"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __esm = (fn, res) => function __init() {
  return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
};
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// ../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/utils.js
var require_utils = __commonJS({
  "../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/utils.js"(exports2) {
    "use strict";
    exports2.removeLeadingAndTrailingHTTPWhitespace = (string3) => {
      return string3.replace(/^[ \t\n\r]+/u, "").replace(/[ \t\n\r]+$/u, "");
    };
    exports2.removeTrailingHTTPWhitespace = (string3) => {
      return string3.replace(/[ \t\n\r]+$/u, "");
    };
    exports2.isHTTPWhitespaceChar = (char) => {
      return char === " " || char === "	" || char === "\n" || char === "\r";
    };
    exports2.solelyContainsHTTPTokenCodePoints = (string3) => {
      return /^[-!#$%&'*+.^_`|~A-Za-z0-9]*$/u.test(string3);
    };
    exports2.soleyContainsHTTPQuotedStringTokenCodePoints = (string3) => {
      return /^[\t\u0020-\u007E\u0080-\u00FF]*$/u.test(string3);
    };
    exports2.asciiLowercase = (string3) => {
      return string3.replace(/[A-Z]/ug, (l) => l.toLowerCase());
    };
    exports2.collectAnHTTPQuotedString = (input, position) => {
      let value = "";
      position++;
      while (true) {
        while (position < input.length && input[position] !== '"' && input[position] !== "\\") {
          value += input[position];
          ++position;
        }
        if (position >= input.length) {
          break;
        }
        const quoteOrBackslash = input[position];
        ++position;
        if (quoteOrBackslash === "\\") {
          if (position >= input.length) {
            value += "\\";
            break;
          }
          value += input[position];
          ++position;
        } else {
          break;
        }
      }
      return [value, position];
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/mime-type-parameters.js
var require_mime_type_parameters = __commonJS({
  "../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/mime-type-parameters.js"(exports2, module2) {
    "use strict";
    var {
      asciiLowercase,
      solelyContainsHTTPTokenCodePoints,
      soleyContainsHTTPQuotedStringTokenCodePoints
    } = require_utils();
    module2.exports = class MIMETypeParameters {
      constructor(map2) {
        this._map = map2;
      }
      get size() {
        return this._map.size;
      }
      get(name) {
        name = asciiLowercase(String(name));
        return this._map.get(name);
      }
      has(name) {
        name = asciiLowercase(String(name));
        return this._map.has(name);
      }
      set(name, value) {
        name = asciiLowercase(String(name));
        value = String(value);
        if (!solelyContainsHTTPTokenCodePoints(name)) {
          throw new Error(`Invalid MIME type parameter name "${name}": only HTTP token code points are valid.`);
        }
        if (!soleyContainsHTTPQuotedStringTokenCodePoints(value)) {
          throw new Error(`Invalid MIME type parameter value "${value}": only HTTP quoted-string token code points are valid.`);
        }
        return this._map.set(name, value);
      }
      clear() {
        this._map.clear();
      }
      delete(name) {
        name = asciiLowercase(String(name));
        return this._map.delete(name);
      }
      forEach(callbackFn, thisArg) {
        this._map.forEach(callbackFn, thisArg);
      }
      keys() {
        return this._map.keys();
      }
      values() {
        return this._map.values();
      }
      entries() {
        return this._map.entries();
      }
      [Symbol.iterator]() {
        return this._map[Symbol.iterator]();
      }
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/parser.js
var require_parser = __commonJS({
  "../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/parser.js"(exports2, module2) {
    "use strict";
    var {
      removeLeadingAndTrailingHTTPWhitespace,
      removeTrailingHTTPWhitespace,
      isHTTPWhitespaceChar,
      solelyContainsHTTPTokenCodePoints,
      soleyContainsHTTPQuotedStringTokenCodePoints,
      asciiLowercase,
      collectAnHTTPQuotedString
    } = require_utils();
    module2.exports = (input) => {
      input = removeLeadingAndTrailingHTTPWhitespace(input);
      let position = 0;
      let type2 = "";
      while (position < input.length && input[position] !== "/") {
        type2 += input[position];
        ++position;
      }
      if (type2.length === 0 || !solelyContainsHTTPTokenCodePoints(type2)) {
        return null;
      }
      if (position >= input.length) {
        return null;
      }
      ++position;
      let subtype = "";
      while (position < input.length && input[position] !== ";") {
        subtype += input[position];
        ++position;
      }
      subtype = removeTrailingHTTPWhitespace(subtype);
      if (subtype.length === 0 || !solelyContainsHTTPTokenCodePoints(subtype)) {
        return null;
      }
      const mimeType = {
        type: asciiLowercase(type2),
        subtype: asciiLowercase(subtype),
        parameters: /* @__PURE__ */ new Map()
      };
      while (position < input.length) {
        ++position;
        while (isHTTPWhitespaceChar(input[position])) {
          ++position;
        }
        let parameterName = "";
        while (position < input.length && input[position] !== ";" && input[position] !== "=") {
          parameterName += input[position];
          ++position;
        }
        parameterName = asciiLowercase(parameterName);
        if (position < input.length) {
          if (input[position] === ";") {
            continue;
          }
          ++position;
        }
        let parameterValue = null;
        if (input[position] === '"') {
          [parameterValue, position] = collectAnHTTPQuotedString(input, position);
          while (position < input.length && input[position] !== ";") {
            ++position;
          }
        } else {
          parameterValue = "";
          while (position < input.length && input[position] !== ";") {
            parameterValue += input[position];
            ++position;
          }
          parameterValue = removeTrailingHTTPWhitespace(parameterValue);
          if (parameterValue === "") {
            continue;
          }
        }
        if (parameterName.length > 0 && solelyContainsHTTPTokenCodePoints(parameterName) && soleyContainsHTTPQuotedStringTokenCodePoints(parameterValue) && !mimeType.parameters.has(parameterName)) {
          mimeType.parameters.set(parameterName, parameterValue);
        }
      }
      return mimeType;
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/serializer.js
var require_serializer = __commonJS({
  "../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/serializer.js"(exports2, module2) {
    "use strict";
    var { solelyContainsHTTPTokenCodePoints } = require_utils();
    module2.exports = (mimeType) => {
      let serialization = `${mimeType.type}/${mimeType.subtype}`;
      if (mimeType.parameters.size === 0) {
        return serialization;
      }
      for (let [name, value] of mimeType.parameters) {
        serialization += ";";
        serialization += name;
        serialization += "=";
        if (!solelyContainsHTTPTokenCodePoints(value) || value.length === 0) {
          value = value.replace(/(["\\])/ug, "\\$1");
          value = `"${value}"`;
        }
        serialization += value;
      }
      return serialization;
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/mime-type.js
var require_mime_type = __commonJS({
  "../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/mime-type.js"(exports2, module2) {
    "use strict";
    var MIMETypeParameters = require_mime_type_parameters();
    var parse2 = require_parser();
    var serialize = require_serializer();
    var {
      asciiLowercase,
      solelyContainsHTTPTokenCodePoints
    } = require_utils();
    module2.exports = class MIMEType {
      constructor(string3) {
        string3 = String(string3);
        const result = parse2(string3);
        if (result === null) {
          throw new Error(`Could not parse MIME type string "${string3}"`);
        }
        this._type = result.type;
        this._subtype = result.subtype;
        this._parameters = new MIMETypeParameters(result.parameters);
      }
      static parse(string3) {
        try {
          return new this(string3);
        } catch (e) {
          return null;
        }
      }
      get essence() {
        return `${this.type}/${this.subtype}`;
      }
      get type() {
        return this._type;
      }
      set type(value) {
        value = asciiLowercase(String(value));
        if (value.length === 0) {
          throw new Error("Invalid type: must be a non-empty string");
        }
        if (!solelyContainsHTTPTokenCodePoints(value)) {
          throw new Error(`Invalid type ${value}: must contain only HTTP token code points`);
        }
        this._type = value;
      }
      get subtype() {
        return this._subtype;
      }
      set subtype(value) {
        value = asciiLowercase(String(value));
        if (value.length === 0) {
          throw new Error("Invalid subtype: must be a non-empty string");
        }
        if (!solelyContainsHTTPTokenCodePoints(value)) {
          throw new Error(`Invalid subtype ${value}: must contain only HTTP token code points`);
        }
        this._subtype = value;
      }
      get parameters() {
        return this._parameters;
      }
      toString() {
        return serialize(this);
      }
      isJavaScript({ prohibitParameters = false } = {}) {
        switch (this._type) {
          case "text": {
            switch (this._subtype) {
              case "ecmascript":
              case "javascript":
              case "javascript1.0":
              case "javascript1.1":
              case "javascript1.2":
              case "javascript1.3":
              case "javascript1.4":
              case "javascript1.5":
              case "jscript":
              case "livescript":
              case "x-ecmascript":
              case "x-javascript": {
                return !prohibitParameters || this._parameters.size === 0;
              }
              default: {
                return false;
              }
            }
          }
          case "application": {
            switch (this._subtype) {
              case "ecmascript":
              case "javascript":
              case "x-ecmascript":
              case "x-javascript": {
                return !prohibitParameters || this._parameters.size === 0;
              }
              default: {
                return false;
              }
            }
          }
          default: {
            return false;
          }
        }
      }
      isXML() {
        return this._subtype === "xml" && (this._type === "text" || this._type === "application") || this._subtype.endsWith("+xml");
      }
      isHTML() {
        return this._subtype === "html" && this._type === "text";
      }
    };
  }
});

// ../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/package.json
var require_package = __commonJS({
  "../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/package.json"(exports2, module2) {
    module2.exports = {
      name: "prettier",
      version: "2.7.1",
      description: "Prettier is an opinionated code formatter",
      bin: "./bin-prettier.js",
      repository: "prettier/prettier",
      funding: "https://github.com/prettier/prettier?sponsor=1",
      homepage: "https://prettier.io",
      author: "James Long",
      license: "MIT",
      main: "./index.js",
      browser: "./standalone.js",
      unpkg: "./standalone.js",
      engines: {
        node: ">=10.13.0"
      },
      files: [
        "*.js",
        "esm/*.mjs"
      ]
    };
  }
});

// ../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/doc.js
var require_doc = __commonJS({
  "../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/doc.js"(exports2, module2) {
    "use strict";
    (function(factory) {
      if (typeof exports2 === "object" && typeof module2 === "object") {
        module2.exports = factory();
      } else if (typeof define === "function" && define.amd) {
        define(factory);
      } else {
        var root2 = typeof globalThis !== "undefined" ? globalThis : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : this || {};
        root2.doc = factory();
      }
    })(function() {
      "use strict";
      var __getOwnPropNames2 = Object.getOwnPropertyNames;
      var __commonJS2 = (cb, mod) => function __require() {
        return mod || (0, cb[__getOwnPropNames2(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
      };
      var require_doc_js_umd = __commonJS2({
        "dist/_doc.js.umd.js"(exports3, module3) {
          var __create2 = Object.create;
          var __defProp2 = Object.defineProperty;
          var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
          var __getOwnPropNames22 = Object.getOwnPropertyNames;
          var __getProtoOf2 = Object.getPrototypeOf;
          var __hasOwnProp2 = Object.prototype.hasOwnProperty;
          var __esm2 = (fn, res) => function __init() {
            return fn && (res = (0, fn[__getOwnPropNames22(fn)[0]])(fn = 0)), res;
          };
          var __commonJS22 = (cb, mod) => function __require() {
            return mod || (0, cb[__getOwnPropNames22(cb)[0]])((mod = {
              exports: {}
            }).exports, mod), mod.exports;
          };
          var __export2 = (target, all) => {
            for (var name in all)
              __defProp2(target, name, {
                get: all[name],
                enumerable: true
              });
          };
          var __copyProps2 = (to, from, except, desc) => {
            if (from && typeof from === "object" || typeof from === "function") {
              for (let key of __getOwnPropNames22(from))
                if (!__hasOwnProp2.call(to, key) && key !== except)
                  __defProp2(to, key, {
                    get: () => from[key],
                    enumerable: !(desc = __getOwnPropDesc2(from, key)) || desc.enumerable
                  });
            }
            return to;
          };
          var __toESM2 = (mod, isNodeMode, target) => (target = mod != null ? __create2(__getProtoOf2(mod)) : {}, __copyProps2(isNodeMode || !mod || !mod.__esModule ? __defProp2(target, "default", {
            value: mod,
            enumerable: true
          }) : target, mod));
          var __toCommonJS2 = (mod) => __copyProps2(__defProp2({}, "__esModule", {
            value: true
          }), mod);
          var init_define_process = __esm2({
            "<define:process>"() {
            }
          });
          var require_doc_builders = __commonJS22({
            "src/document/doc-builders.js"(exports22, module22) {
              "use strict";
              init_define_process();
              function concat(parts) {
                if (false) {
                  for (const part of parts) {
                    assertDoc(part);
                  }
                }
                return {
                  type: "concat",
                  parts
                };
              }
              function indent(contents) {
                if (false) {
                  assertDoc(contents);
                }
                return {
                  type: "indent",
                  contents
                };
              }
              function align(widthOrString, contents) {
                if (false) {
                  assertDoc(contents);
                }
                return {
                  type: "align",
                  contents,
                  n: widthOrString
                };
              }
              function group(contents) {
                let opts = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
                if (false) {
                  assertDoc(contents);
                }
                return {
                  type: "group",
                  id: opts.id,
                  contents,
                  break: Boolean(opts.shouldBreak),
                  expandedStates: opts.expandedStates
                };
              }
              function dedentToRoot(contents) {
                return align(Number.NEGATIVE_INFINITY, contents);
              }
              function markAsRoot(contents) {
                return align({
                  type: "root"
                }, contents);
              }
              function dedent(contents) {
                return align(-1, contents);
              }
              function conditionalGroup(states, opts) {
                return group(states[0], Object.assign(Object.assign({}, opts), {}, {
                  expandedStates: states
                }));
              }
              function fill(parts) {
                if (false) {
                  for (const part of parts) {
                    assertDoc(part);
                  }
                }
                return {
                  type: "fill",
                  parts
                };
              }
              function ifBreak(breakContents, flatContents) {
                let opts = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
                if (false) {
                  if (breakContents) {
                    assertDoc(breakContents);
                  }
                  if (flatContents) {
                    assertDoc(flatContents);
                  }
                }
                return {
                  type: "if-break",
                  breakContents,
                  flatContents,
                  groupId: opts.groupId
                };
              }
              function indentIfBreak(contents, opts) {
                return {
                  type: "indent-if-break",
                  contents,
                  groupId: opts.groupId,
                  negate: opts.negate
                };
              }
              function lineSuffix(contents) {
                if (false) {
                  assertDoc(contents);
                }
                return {
                  type: "line-suffix",
                  contents
                };
              }
              var lineSuffixBoundary = {
                type: "line-suffix-boundary"
              };
              var breakParent = {
                type: "break-parent"
              };
              var trim = {
                type: "trim"
              };
              var hardlineWithoutBreakParent = {
                type: "line",
                hard: true
              };
              var literallineWithoutBreakParent = {
                type: "line",
                hard: true,
                literal: true
              };
              var line = {
                type: "line"
              };
              var softline = {
                type: "line",
                soft: true
              };
              var hardline = concat([hardlineWithoutBreakParent, breakParent]);
              var literalline = concat([literallineWithoutBreakParent, breakParent]);
              var cursor = {
                type: "cursor",
                placeholder: Symbol("cursor")
              };
              function join2(sep2, arr) {
                const res = [];
                for (let i = 0; i < arr.length; i++) {
                  if (i !== 0) {
                    res.push(sep2);
                  }
                  res.push(arr[i]);
                }
                return concat(res);
              }
              function addAlignmentToDoc(doc, size2, tabWidth) {
                let aligned = doc;
                if (size2 > 0) {
                  for (let i = 0; i < Math.floor(size2 / tabWidth); ++i) {
                    aligned = indent(aligned);
                  }
                  aligned = align(size2 % tabWidth, aligned);
                  aligned = align(Number.NEGATIVE_INFINITY, aligned);
                }
                return aligned;
              }
              function label(label2, contents) {
                return {
                  type: "label",
                  label: label2,
                  contents
                };
              }
              module22.exports = {
                concat,
                join: join2,
                line,
                softline,
                hardline,
                literalline,
                group,
                conditionalGroup,
                fill,
                lineSuffix,
                lineSuffixBoundary,
                cursor,
                breakParent,
                ifBreak,
                trim,
                indent,
                indentIfBreak,
                align,
                addAlignmentToDoc,
                markAsRoot,
                dedentToRoot,
                dedent,
                hardlineWithoutBreakParent,
                literallineWithoutBreakParent,
                label
              };
            }
          });
          var require_end_of_line = __commonJS22({
            "src/common/end-of-line.js"(exports22, module22) {
              "use strict";
              init_define_process();
              function guessEndOfLine(text) {
                const index = text.indexOf("\r");
                if (index >= 0) {
                  return text.charAt(index + 1) === "\n" ? "crlf" : "cr";
                }
                return "lf";
              }
              function convertEndOfLineToChars(value) {
                switch (value) {
                  case "cr":
                    return "\r";
                  case "crlf":
                    return "\r\n";
                  default:
                    return "\n";
                }
              }
              function countEndOfLineChars(text, eol) {
                let regex;
                switch (eol) {
                  case "\n":
                    regex = /\n/g;
                    break;
                  case "\r":
                    regex = /\r/g;
                    break;
                  case "\r\n":
                    regex = /\r\n/g;
                    break;
                  default:
                    throw new Error('Unexpected "eol" '.concat(JSON.stringify(eol), "."));
                }
                const endOfLines = text.match(regex);
                return endOfLines ? endOfLines.length : 0;
              }
              function normalizeEndOfLine(text) {
                return text.replace(/\r\n?/g, "\n");
              }
              module22.exports = {
                guessEndOfLine,
                convertEndOfLineToChars,
                countEndOfLineChars,
                normalizeEndOfLine
              };
            }
          });
          var require_get_last = __commonJS22({
            "src/utils/get-last.js"(exports22, module22) {
              "use strict";
              init_define_process();
              var getLast = (arr) => arr[arr.length - 1];
              module22.exports = getLast;
            }
          });
          function ansiRegex() {
            let {
              onlyFirst = false
            } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
            const pattern = ["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)", "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"].join("|");
            return new RegExp(pattern, onlyFirst ? void 0 : "g");
          }
          var init_ansi_regex = __esm2({
            "node_modules/strip-ansi/node_modules/ansi-regex/index.js"() {
              init_define_process();
            }
          });
          function stripAnsi(string3) {
            if (typeof string3 !== "string") {
              throw new TypeError("Expected a `string`, got `".concat(typeof string3, "`"));
            }
            return string3.replace(ansiRegex(), "");
          }
          var init_strip_ansi = __esm2({
            "node_modules/strip-ansi/index.js"() {
              init_define_process();
              init_ansi_regex();
            }
          });
          function isFullwidthCodePoint(codePoint) {
            if (!Number.isInteger(codePoint)) {
              return false;
            }
            return codePoint >= 4352 && (codePoint <= 4447 || codePoint === 9001 || codePoint === 9002 || 11904 <= codePoint && codePoint <= 12871 && codePoint !== 12351 || 12880 <= codePoint && codePoint <= 19903 || 19968 <= codePoint && codePoint <= 42182 || 43360 <= codePoint && codePoint <= 43388 || 44032 <= codePoint && codePoint <= 55203 || 63744 <= codePoint && codePoint <= 64255 || 65040 <= codePoint && codePoint <= 65049 || 65072 <= codePoint && codePoint <= 65131 || 65281 <= codePoint && codePoint <= 65376 || 65504 <= codePoint && codePoint <= 65510 || 110592 <= codePoint && codePoint <= 110593 || 127488 <= codePoint && codePoint <= 127569 || 131072 <= codePoint && codePoint <= 262141);
          }
          var init_is_fullwidth_code_point = __esm2({
            "node_modules/is-fullwidth-code-point/index.js"() {
              init_define_process();
            }
          });
          var require_emoji_regex = __commonJS22({
            "node_modules/emoji-regex/index.js"(exports22, module22) {
              "use strict";
              init_define_process();
              module22.exports = function() {
                return /\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67)\uDB40\uDC7F|(?:\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFE])|(?:\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFC-\uDFFF])|\uD83D\uDC68(?:\uD83C\uDFFB(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFC-\uDFFF])|[\u2695\u2696\u2708]\uFE0F|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))?|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFE])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])\uFE0F|\u200D(?:(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D[\uDC66\uDC67])|\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC)?|(?:\uD83D\uDC69(?:\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69]))|\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1)(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC69(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83E\uDDD1(?:\u200D(?:\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D\uDC69\u200D\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83E\uDDD1(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDC69(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDE36\u200D\uD83C\uDF2B|\uD83C\uDFF3\uFE0F\u200D\u26A7|\uD83D\uDC3B\u200D\u2744|(?:(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF])\u200D[\u2640\u2642]|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\uD83C\uDFF4\u200D\u2620|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])\u200D[\u2640\u2642]|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u2600-\u2604\u260E\u2611\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26B0\u26B1\u26C8\u26CF\u26D1\u26D3\u26E9\u26F0\u26F1\u26F4\u26F7\u26F8\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u3030\u303D\u3297\u3299]|\uD83C[\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]|\uD83D[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3])\uFE0F|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC69\u200D\uD83D\uDC67|\uD83D\uDC69\u200D\uD83D\uDC66|\uD83D\uDE35\u200D\uD83D\uDCAB|\uD83D\uDE2E\u200D\uD83D\uDCA8|\uD83D\uDC15\u200D\uD83E\uDDBA|\uD83E\uDDD1(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83D\uDC69(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDF6\uD83C\uDDE6|\uD83C\uDDF4\uD83C\uDDF2|\uD83D\uDC08\u200D\u2B1B|\u2764\uFE0F\u200D(?:\uD83D\uDD25|\uD83E\uDE79)|\uD83D\uDC41\uFE0F|\uD83C\uDFF3\uFE0F|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|[#\*0-9]\uFE0F\u20E3|\u2764\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|\uD83C\uDFF4|(?:[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u261D\u270C\u270D]|\uD83D[\uDD74\uDD90])(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC08\uDC15\uDC3B\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE2E\uDE35\uDE36\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5]|\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD]|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF]|[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0D\uDD0E\uDD10-\uDD17\uDD1D\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78\uDD7A-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCB\uDDD0\uDDE0-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6]|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26A7\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDED5-\uDED7\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])\uFE0F|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDC8F\uDC91\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1F\uDD26\uDD30-\uDD39\uDD3C-\uDD3E\uDD77\uDDB5\uDDB6\uDDB8\uDDB9\uDDBB\uDDCD-\uDDCF\uDDD1-\uDDDD])/g;
              };
            }
          });
          var string_width_exports = {};
          __export2(string_width_exports, {
            default: () => stringWidth
          });
          function stringWidth(string3) {
            if (typeof string3 !== "string" || string3.length === 0) {
              return 0;
            }
            string3 = stripAnsi(string3);
            if (string3.length === 0) {
              return 0;
            }
            string3 = string3.replace((0, import_emoji_regex.default)(), "  ");
            let width = 0;
            for (let index = 0; index < string3.length; index++) {
              const codePoint = string3.codePointAt(index);
              if (codePoint <= 31 || codePoint >= 127 && codePoint <= 159) {
                continue;
              }
              if (codePoint >= 768 && codePoint <= 879) {
                continue;
              }
              if (codePoint > 65535) {
                index++;
              }
              width += isFullwidthCodePoint(codePoint) ? 2 : 1;
            }
            return width;
          }
          var import_emoji_regex;
          var init_string_width = __esm2({
            "node_modules/string-width/index.js"() {
              init_define_process();
              init_strip_ansi();
              init_is_fullwidth_code_point();
              import_emoji_regex = __toESM2(require_emoji_regex());
            }
          });
          var require_get_string_width = __commonJS22({
            "src/utils/get-string-width.js"(exports22, module22) {
              "use strict";
              init_define_process();
              var stringWidth2 = (init_string_width(), __toCommonJS2(string_width_exports)).default;
              var notAsciiRegex = /[^\x20-\x7F]/;
              function getStringWidth(text) {
                if (!text) {
                  return 0;
                }
                if (!notAsciiRegex.test(text)) {
                  return text.length;
                }
                return stringWidth2(text);
              }
              module22.exports = getStringWidth;
            }
          });
          var require_doc_utils = __commonJS22({
            "src/document/doc-utils.js"(exports22, module22) {
              "use strict";
              init_define_process();
              var getLast = require_get_last();
              var {
                literalline,
                join: join2
              } = require_doc_builders();
              var isConcat = (doc) => Array.isArray(doc) || doc && doc.type === "concat";
              var getDocParts = (doc) => {
                if (Array.isArray(doc)) {
                  return doc;
                }
                if (doc.type !== "concat" && doc.type !== "fill") {
                  throw new Error("Expect doc type to be `concat` or `fill`.");
                }
                return doc.parts;
              };
              var traverseDocOnExitStackMarker = {};
              function traverseDoc(doc, onEnter, onExit, shouldTraverseConditionalGroups) {
                const docsStack = [doc];
                while (docsStack.length > 0) {
                  const doc2 = docsStack.pop();
                  if (doc2 === traverseDocOnExitStackMarker) {
                    onExit(docsStack.pop());
                    continue;
                  }
                  if (onExit) {
                    docsStack.push(doc2, traverseDocOnExitStackMarker);
                  }
                  if (!onEnter || onEnter(doc2) !== false) {
                    if (isConcat(doc2) || doc2.type === "fill") {
                      const parts = getDocParts(doc2);
                      for (let ic = parts.length, i = ic - 1; i >= 0; --i) {
                        docsStack.push(parts[i]);
                      }
                    } else if (doc2.type === "if-break") {
                      if (doc2.flatContents) {
                        docsStack.push(doc2.flatContents);
                      }
                      if (doc2.breakContents) {
                        docsStack.push(doc2.breakContents);
                      }
                    } else if (doc2.type === "group" && doc2.expandedStates) {
                      if (shouldTraverseConditionalGroups) {
                        for (let ic = doc2.expandedStates.length, i = ic - 1; i >= 0; --i) {
                          docsStack.push(doc2.expandedStates[i]);
                        }
                      } else {
                        docsStack.push(doc2.contents);
                      }
                    } else if (doc2.contents) {
                      docsStack.push(doc2.contents);
                    }
                  }
                }
              }
              function mapDoc(doc, cb) {
                const mapped = /* @__PURE__ */ new Map();
                return rec(doc);
                function rec(doc2) {
                  if (mapped.has(doc2)) {
                    return mapped.get(doc2);
                  }
                  const result = process2(doc2);
                  mapped.set(doc2, result);
                  return result;
                }
                function process2(doc2) {
                  if (Array.isArray(doc2)) {
                    return cb(doc2.map(rec));
                  }
                  if (doc2.type === "concat" || doc2.type === "fill") {
                    const parts = doc2.parts.map(rec);
                    return cb(Object.assign(Object.assign({}, doc2), {}, {
                      parts
                    }));
                  }
                  if (doc2.type === "if-break") {
                    const breakContents = doc2.breakContents && rec(doc2.breakContents);
                    const flatContents = doc2.flatContents && rec(doc2.flatContents);
                    return cb(Object.assign(Object.assign({}, doc2), {}, {
                      breakContents,
                      flatContents
                    }));
                  }
                  if (doc2.type === "group" && doc2.expandedStates) {
                    const expandedStates = doc2.expandedStates.map(rec);
                    const contents = expandedStates[0];
                    return cb(Object.assign(Object.assign({}, doc2), {}, {
                      contents,
                      expandedStates
                    }));
                  }
                  if (doc2.contents) {
                    const contents = rec(doc2.contents);
                    return cb(Object.assign(Object.assign({}, doc2), {}, {
                      contents
                    }));
                  }
                  return cb(doc2);
                }
              }
              function findInDoc(doc, fn, defaultValue) {
                let result = defaultValue;
                let hasStopped = false;
                function findInDocOnEnterFn(doc2) {
                  const maybeResult = fn(doc2);
                  if (maybeResult !== void 0) {
                    hasStopped = true;
                    result = maybeResult;
                  }
                  if (hasStopped) {
                    return false;
                  }
                }
                traverseDoc(doc, findInDocOnEnterFn);
                return result;
              }
              function willBreakFn(doc) {
                if (doc.type === "group" && doc.break) {
                  return true;
                }
                if (doc.type === "line" && doc.hard) {
                  return true;
                }
                if (doc.type === "break-parent") {
                  return true;
                }
              }
              function willBreak(doc) {
                return findInDoc(doc, willBreakFn, false);
              }
              function breakParentGroup(groupStack) {
                if (groupStack.length > 0) {
                  const parentGroup = getLast(groupStack);
                  if (!parentGroup.expandedStates && !parentGroup.break) {
                    parentGroup.break = "propagated";
                  }
                }
                return null;
              }
              function propagateBreaks(doc) {
                const alreadyVisitedSet = /* @__PURE__ */ new Set();
                const groupStack = [];
                function propagateBreaksOnEnterFn(doc2) {
                  if (doc2.type === "break-parent") {
                    breakParentGroup(groupStack);
                  }
                  if (doc2.type === "group") {
                    groupStack.push(doc2);
                    if (alreadyVisitedSet.has(doc2)) {
                      return false;
                    }
                    alreadyVisitedSet.add(doc2);
                  }
                }
                function propagateBreaksOnExitFn(doc2) {
                  if (doc2.type === "group") {
                    const group = groupStack.pop();
                    if (group.break) {
                      breakParentGroup(groupStack);
                    }
                  }
                }
                traverseDoc(doc, propagateBreaksOnEnterFn, propagateBreaksOnExitFn, true);
              }
              function removeLinesFn(doc) {
                if (doc.type === "line" && !doc.hard) {
                  return doc.soft ? "" : " ";
                }
                if (doc.type === "if-break") {
                  return doc.flatContents || "";
                }
                return doc;
              }
              function removeLines(doc) {
                return mapDoc(doc, removeLinesFn);
              }
              var isHardline = (doc, nextDoc) => doc && doc.type === "line" && doc.hard && nextDoc && nextDoc.type === "break-parent";
              function stripDocTrailingHardlineFromDoc(doc) {
                if (!doc) {
                  return doc;
                }
                if (isConcat(doc) || doc.type === "fill") {
                  const parts = getDocParts(doc);
                  while (parts.length > 1 && isHardline(...parts.slice(-2))) {
                    parts.length -= 2;
                  }
                  if (parts.length > 0) {
                    const lastPart = stripDocTrailingHardlineFromDoc(getLast(parts));
                    parts[parts.length - 1] = lastPart;
                  }
                  return Array.isArray(doc) ? parts : Object.assign(Object.assign({}, doc), {}, {
                    parts
                  });
                }
                switch (doc.type) {
                  case "align":
                  case "indent":
                  case "indent-if-break":
                  case "group":
                  case "line-suffix":
                  case "label": {
                    const contents = stripDocTrailingHardlineFromDoc(doc.contents);
                    return Object.assign(Object.assign({}, doc), {}, {
                      contents
                    });
                  }
                  case "if-break": {
                    const breakContents = stripDocTrailingHardlineFromDoc(doc.breakContents);
                    const flatContents = stripDocTrailingHardlineFromDoc(doc.flatContents);
                    return Object.assign(Object.assign({}, doc), {}, {
                      breakContents,
                      flatContents
                    });
                  }
                }
                return doc;
              }
              function stripTrailingHardline(doc) {
                return stripDocTrailingHardlineFromDoc(cleanDoc(doc));
              }
              function cleanDocFn(doc) {
                switch (doc.type) {
                  case "fill":
                    if (doc.parts.every((part) => part === "")) {
                      return "";
                    }
                    break;
                  case "group":
                    if (!doc.contents && !doc.id && !doc.break && !doc.expandedStates) {
                      return "";
                    }
                    if (doc.contents.type === "group" && doc.contents.id === doc.id && doc.contents.break === doc.break && doc.contents.expandedStates === doc.expandedStates) {
                      return doc.contents;
                    }
                    break;
                  case "align":
                  case "indent":
                  case "indent-if-break":
                  case "line-suffix":
                    if (!doc.contents) {
                      return "";
                    }
                    break;
                  case "if-break":
                    if (!doc.flatContents && !doc.breakContents) {
                      return "";
                    }
                    break;
                }
                if (!isConcat(doc)) {
                  return doc;
                }
                const parts = [];
                for (const part of getDocParts(doc)) {
                  if (!part) {
                    continue;
                  }
                  const [currentPart, ...restParts] = isConcat(part) ? getDocParts(part) : [part];
                  if (typeof currentPart === "string" && typeof getLast(parts) === "string") {
                    parts[parts.length - 1] += currentPart;
                  } else {
                    parts.push(currentPart);
                  }
                  parts.push(...restParts);
                }
                if (parts.length === 0) {
                  return "";
                }
                if (parts.length === 1) {
                  return parts[0];
                }
                return Array.isArray(doc) ? parts : Object.assign(Object.assign({}, doc), {}, {
                  parts
                });
              }
              function cleanDoc(doc) {
                return mapDoc(doc, (currentDoc) => cleanDocFn(currentDoc));
              }
              function normalizeParts(parts) {
                const newParts = [];
                const restParts = parts.filter(Boolean);
                while (restParts.length > 0) {
                  const part = restParts.shift();
                  if (!part) {
                    continue;
                  }
                  if (isConcat(part)) {
                    restParts.unshift(...getDocParts(part));
                    continue;
                  }
                  if (newParts.length > 0 && typeof getLast(newParts) === "string" && typeof part === "string") {
                    newParts[newParts.length - 1] += part;
                    continue;
                  }
                  newParts.push(part);
                }
                return newParts;
              }
              function normalizeDoc(doc) {
                return mapDoc(doc, (currentDoc) => {
                  if (Array.isArray(currentDoc)) {
                    return normalizeParts(currentDoc);
                  }
                  if (!currentDoc.parts) {
                    return currentDoc;
                  }
                  return Object.assign(Object.assign({}, currentDoc), {}, {
                    parts: normalizeParts(currentDoc.parts)
                  });
                });
              }
              function replaceEndOfLine(doc) {
                return mapDoc(doc, (currentDoc) => typeof currentDoc === "string" && currentDoc.includes("\n") ? replaceTextEndOfLine(currentDoc) : currentDoc);
              }
              function replaceTextEndOfLine(text) {
                let replacement = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : literalline;
                return join2(replacement, text.split("\n")).parts;
              }
              function canBreakFn(doc) {
                if (doc.type === "line") {
                  return true;
                }
              }
              function canBreak(doc) {
                return findInDoc(doc, canBreakFn, false);
              }
              module22.exports = {
                isConcat,
                getDocParts,
                willBreak,
                traverseDoc,
                findInDoc,
                mapDoc,
                propagateBreaks,
                removeLines,
                stripTrailingHardline,
                normalizeParts,
                normalizeDoc,
                cleanDoc,
                replaceTextEndOfLine,
                replaceEndOfLine,
                canBreak
              };
            }
          });
          var require_doc_printer = __commonJS22({
            "src/document/doc-printer.js"(exports22, module22) {
              "use strict";
              init_define_process();
              var {
                convertEndOfLineToChars
              } = require_end_of_line();
              var getLast = require_get_last();
              var getStringWidth = require_get_string_width();
              var {
                fill,
                cursor,
                indent
              } = require_doc_builders();
              var {
                isConcat,
                getDocParts
              } = require_doc_utils();
              var groupModeMap;
              var MODE_BREAK = 1;
              var MODE_FLAT = 2;
              function rootIndent() {
                return {
                  value: "",
                  length: 0,
                  queue: []
                };
              }
              function makeIndent(ind, options) {
                return generateInd(ind, {
                  type: "indent"
                }, options);
              }
              function makeAlign(indent2, widthOrDoc, options) {
                if (widthOrDoc === Number.NEGATIVE_INFINITY) {
                  return indent2.root || rootIndent();
                }
                if (widthOrDoc < 0) {
                  return generateInd(indent2, {
                    type: "dedent"
                  }, options);
                }
                if (!widthOrDoc) {
                  return indent2;
                }
                if (widthOrDoc.type === "root") {
                  return Object.assign(Object.assign({}, indent2), {}, {
                    root: indent2
                  });
                }
                const alignType = typeof widthOrDoc === "string" ? "stringAlign" : "numberAlign";
                return generateInd(indent2, {
                  type: alignType,
                  n: widthOrDoc
                }, options);
              }
              function generateInd(ind, newPart, options) {
                const queue = newPart.type === "dedent" ? ind.queue.slice(0, -1) : [...ind.queue, newPart];
                let value = "";
                let length = 0;
                let lastTabs = 0;
                let lastSpaces = 0;
                for (const part of queue) {
                  switch (part.type) {
                    case "indent":
                      flush();
                      if (options.useTabs) {
                        addTabs(1);
                      } else {
                        addSpaces(options.tabWidth);
                      }
                      break;
                    case "stringAlign":
                      flush();
                      value += part.n;
                      length += part.n.length;
                      break;
                    case "numberAlign":
                      lastTabs += 1;
                      lastSpaces += part.n;
                      break;
                    default:
                      throw new Error("Unexpected type '".concat(part.type, "'"));
                  }
                }
                flushSpaces();
                return Object.assign(Object.assign({}, ind), {}, {
                  value,
                  length,
                  queue
                });
                function addTabs(count) {
                  value += "	".repeat(count);
                  length += options.tabWidth * count;
                }
                function addSpaces(count) {
                  value += " ".repeat(count);
                  length += count;
                }
                function flush() {
                  if (options.useTabs) {
                    flushTabs();
                  } else {
                    flushSpaces();
                  }
                }
                function flushTabs() {
                  if (lastTabs > 0) {
                    addTabs(lastTabs);
                  }
                  resetLast();
                }
                function flushSpaces() {
                  if (lastSpaces > 0) {
                    addSpaces(lastSpaces);
                  }
                  resetLast();
                }
                function resetLast() {
                  lastTabs = 0;
                  lastSpaces = 0;
                }
              }
              function trim(out) {
                if (out.length === 0) {
                  return 0;
                }
                let trimCount = 0;
                while (out.length > 0 && typeof getLast(out) === "string" && /^[\t ]*$/.test(getLast(out))) {
                  trimCount += out.pop().length;
                }
                if (out.length > 0 && typeof getLast(out) === "string") {
                  const trimmed = getLast(out).replace(/[\t ]*$/, "");
                  trimCount += getLast(out).length - trimmed.length;
                  out[out.length - 1] = trimmed;
                }
                return trimCount;
              }
              function fits(next, restCommands, width, options, hasLineSuffix, mustBeFlat) {
                let restIdx = restCommands.length;
                const cmds = [next];
                const out = [];
                while (width >= 0) {
                  if (cmds.length === 0) {
                    if (restIdx === 0) {
                      return true;
                    }
                    cmds.push(restCommands[restIdx - 1]);
                    restIdx--;
                    continue;
                  }
                  const [ind, mode, doc] = cmds.pop();
                  if (typeof doc === "string") {
                    out.push(doc);
                    width -= getStringWidth(doc);
                  } else if (isConcat(doc)) {
                    const parts = getDocParts(doc);
                    for (let i = parts.length - 1; i >= 0; i--) {
                      cmds.push([ind, mode, parts[i]]);
                    }
                  } else {
                    switch (doc.type) {
                      case "indent":
                        cmds.push([makeIndent(ind, options), mode, doc.contents]);
                        break;
                      case "align":
                        cmds.push([makeAlign(ind, doc.n, options), mode, doc.contents]);
                        break;
                      case "trim":
                        width += trim(out);
                        break;
                      case "group": {
                        if (mustBeFlat && doc.break) {
                          return false;
                        }
                        const groupMode = doc.break ? MODE_BREAK : mode;
                        cmds.push([ind, groupMode, doc.expandedStates && groupMode === MODE_BREAK ? getLast(doc.expandedStates) : doc.contents]);
                        if (doc.id) {
                          groupModeMap[doc.id] = groupMode;
                        }
                        break;
                      }
                      case "fill":
                        for (let i = doc.parts.length - 1; i >= 0; i--) {
                          cmds.push([ind, mode, doc.parts[i]]);
                        }
                        break;
                      case "if-break":
                      case "indent-if-break": {
                        const groupMode = doc.groupId ? groupModeMap[doc.groupId] : mode;
                        if (groupMode === MODE_BREAK) {
                          const breakContents = doc.type === "if-break" ? doc.breakContents : doc.negate ? doc.contents : indent(doc.contents);
                          if (breakContents) {
                            cmds.push([ind, mode, breakContents]);
                          }
                        }
                        if (groupMode === MODE_FLAT) {
                          const flatContents = doc.type === "if-break" ? doc.flatContents : doc.negate ? indent(doc.contents) : doc.contents;
                          if (flatContents) {
                            cmds.push([ind, mode, flatContents]);
                          }
                        }
                        break;
                      }
                      case "line":
                        switch (mode) {
                          case MODE_FLAT:
                            if (!doc.hard) {
                              if (!doc.soft) {
                                out.push(" ");
                                width -= 1;
                              }
                              break;
                            }
                            return true;
                          case MODE_BREAK:
                            return true;
                        }
                        break;
                      case "line-suffix":
                        hasLineSuffix = true;
                        break;
                      case "line-suffix-boundary":
                        if (hasLineSuffix) {
                          return false;
                        }
                        break;
                      case "label":
                        cmds.push([ind, mode, doc.contents]);
                        break;
                    }
                  }
                }
                return false;
              }
              function printDocToString(doc, options) {
                groupModeMap = {};
                const width = options.printWidth;
                const newLine = convertEndOfLineToChars(options.endOfLine);
                let pos = 0;
                const cmds = [[rootIndent(), MODE_BREAK, doc]];
                const out = [];
                let shouldRemeasure = false;
                let lineSuffix = [];
                while (cmds.length > 0) {
                  const [ind, mode, doc2] = cmds.pop();
                  if (typeof doc2 === "string") {
                    const formatted = newLine !== "\n" ? doc2.replace(/\n/g, newLine) : doc2;
                    out.push(formatted);
                    pos += getStringWidth(formatted);
                  } else if (isConcat(doc2)) {
                    const parts = getDocParts(doc2);
                    for (let i = parts.length - 1; i >= 0; i--) {
                      cmds.push([ind, mode, parts[i]]);
                    }
                  } else {
                    switch (doc2.type) {
                      case "cursor":
                        out.push(cursor.placeholder);
                        break;
                      case "indent":
                        cmds.push([makeIndent(ind, options), mode, doc2.contents]);
                        break;
                      case "align":
                        cmds.push([makeAlign(ind, doc2.n, options), mode, doc2.contents]);
                        break;
                      case "trim":
                        pos -= trim(out);
                        break;
                      case "group":
                        switch (mode) {
                          case MODE_FLAT:
                            if (!shouldRemeasure) {
                              cmds.push([ind, doc2.break ? MODE_BREAK : MODE_FLAT, doc2.contents]);
                              break;
                            }
                          case MODE_BREAK: {
                            shouldRemeasure = false;
                            const next = [ind, MODE_FLAT, doc2.contents];
                            const rem = width - pos;
                            const hasLineSuffix = lineSuffix.length > 0;
                            if (!doc2.break && fits(next, cmds, rem, options, hasLineSuffix)) {
                              cmds.push(next);
                            } else {
                              if (doc2.expandedStates) {
                                const mostExpanded = getLast(doc2.expandedStates);
                                if (doc2.break) {
                                  cmds.push([ind, MODE_BREAK, mostExpanded]);
                                  break;
                                } else {
                                  for (let i = 1; i < doc2.expandedStates.length + 1; i++) {
                                    if (i >= doc2.expandedStates.length) {
                                      cmds.push([ind, MODE_BREAK, mostExpanded]);
                                      break;
                                    } else {
                                      const state = doc2.expandedStates[i];
                                      const cmd = [ind, MODE_FLAT, state];
                                      if (fits(cmd, cmds, rem, options, hasLineSuffix)) {
                                        cmds.push(cmd);
                                        break;
                                      }
                                    }
                                  }
                                }
                              } else {
                                cmds.push([ind, MODE_BREAK, doc2.contents]);
                              }
                            }
                            break;
                          }
                        }
                        if (doc2.id) {
                          groupModeMap[doc2.id] = getLast(cmds)[1];
                        }
                        break;
                      case "fill": {
                        const rem = width - pos;
                        const {
                          parts
                        } = doc2;
                        if (parts.length === 0) {
                          break;
                        }
                        const [content, whitespace] = parts;
                        const contentFlatCmd = [ind, MODE_FLAT, content];
                        const contentBreakCmd = [ind, MODE_BREAK, content];
                        const contentFits = fits(contentFlatCmd, [], rem, options, lineSuffix.length > 0, true);
                        if (parts.length === 1) {
                          if (contentFits) {
                            cmds.push(contentFlatCmd);
                          } else {
                            cmds.push(contentBreakCmd);
                          }
                          break;
                        }
                        const whitespaceFlatCmd = [ind, MODE_FLAT, whitespace];
                        const whitespaceBreakCmd = [ind, MODE_BREAK, whitespace];
                        if (parts.length === 2) {
                          if (contentFits) {
                            cmds.push(whitespaceFlatCmd, contentFlatCmd);
                          } else {
                            cmds.push(whitespaceBreakCmd, contentBreakCmd);
                          }
                          break;
                        }
                        parts.splice(0, 2);
                        const remainingCmd = [ind, mode, fill(parts)];
                        const secondContent = parts[0];
                        const firstAndSecondContentFlatCmd = [ind, MODE_FLAT, [content, whitespace, secondContent]];
                        const firstAndSecondContentFits = fits(firstAndSecondContentFlatCmd, [], rem, options, lineSuffix.length > 0, true);
                        if (firstAndSecondContentFits) {
                          cmds.push(remainingCmd, whitespaceFlatCmd, contentFlatCmd);
                        } else if (contentFits) {
                          cmds.push(remainingCmd, whitespaceBreakCmd, contentFlatCmd);
                        } else {
                          cmds.push(remainingCmd, whitespaceBreakCmd, contentBreakCmd);
                        }
                        break;
                      }
                      case "if-break":
                      case "indent-if-break": {
                        const groupMode = doc2.groupId ? groupModeMap[doc2.groupId] : mode;
                        if (groupMode === MODE_BREAK) {
                          const breakContents = doc2.type === "if-break" ? doc2.breakContents : doc2.negate ? doc2.contents : indent(doc2.contents);
                          if (breakContents) {
                            cmds.push([ind, mode, breakContents]);
                          }
                        }
                        if (groupMode === MODE_FLAT) {
                          const flatContents = doc2.type === "if-break" ? doc2.flatContents : doc2.negate ? indent(doc2.contents) : doc2.contents;
                          if (flatContents) {
                            cmds.push([ind, mode, flatContents]);
                          }
                        }
                        break;
                      }
                      case "line-suffix":
                        lineSuffix.push([ind, mode, doc2.contents]);
                        break;
                      case "line-suffix-boundary":
                        if (lineSuffix.length > 0) {
                          cmds.push([ind, mode, {
                            type: "line",
                            hard: true
                          }]);
                        }
                        break;
                      case "line":
                        switch (mode) {
                          case MODE_FLAT:
                            if (!doc2.hard) {
                              if (!doc2.soft) {
                                out.push(" ");
                                pos += 1;
                              }
                              break;
                            } else {
                              shouldRemeasure = true;
                            }
                          case MODE_BREAK:
                            if (lineSuffix.length > 0) {
                              cmds.push([ind, mode, doc2], ...lineSuffix.reverse());
                              lineSuffix = [];
                              break;
                            }
                            if (doc2.literal) {
                              if (ind.root) {
                                out.push(newLine, ind.root.value);
                                pos = ind.root.length;
                              } else {
                                out.push(newLine);
                                pos = 0;
                              }
                            } else {
                              pos -= trim(out);
                              out.push(newLine + ind.value);
                              pos = ind.length;
                            }
                            break;
                        }
                        break;
                      case "label":
                        cmds.push([ind, mode, doc2.contents]);
                        break;
                      default:
                    }
                  }
                  if (cmds.length === 0 && lineSuffix.length > 0) {
                    cmds.push(...lineSuffix.reverse());
                    lineSuffix = [];
                  }
                }
                const cursorPlaceholderIndex = out.indexOf(cursor.placeholder);
                if (cursorPlaceholderIndex !== -1) {
                  const otherCursorPlaceholderIndex = out.indexOf(cursor.placeholder, cursorPlaceholderIndex + 1);
                  const beforeCursor = out.slice(0, cursorPlaceholderIndex).join("");
                  const aroundCursor = out.slice(cursorPlaceholderIndex + 1, otherCursorPlaceholderIndex).join("");
                  const afterCursor = out.slice(otherCursorPlaceholderIndex + 1).join("");
                  return {
                    formatted: beforeCursor + aroundCursor + afterCursor,
                    cursorNodeStart: beforeCursor.length,
                    cursorNodeText: aroundCursor
                  };
                }
                return {
                  formatted: out.join("")
                };
              }
              module22.exports = {
                printDocToString
              };
            }
          });
          var require_doc_debug = __commonJS22({
            "src/document/doc-debug.js"(exports22, module22) {
              "use strict";
              init_define_process();
              var {
                isConcat,
                getDocParts
              } = require_doc_utils();
              function flattenDoc(doc) {
                if (!doc) {
                  return "";
                }
                if (isConcat(doc)) {
                  const res = [];
                  for (const part of getDocParts(doc)) {
                    if (isConcat(part)) {
                      res.push(...flattenDoc(part).parts);
                    } else {
                      const flattened = flattenDoc(part);
                      if (flattened !== "") {
                        res.push(flattened);
                      }
                    }
                  }
                  return {
                    type: "concat",
                    parts: res
                  };
                }
                if (doc.type === "if-break") {
                  return Object.assign(Object.assign({}, doc), {}, {
                    breakContents: flattenDoc(doc.breakContents),
                    flatContents: flattenDoc(doc.flatContents)
                  });
                }
                if (doc.type === "group") {
                  return Object.assign(Object.assign({}, doc), {}, {
                    contents: flattenDoc(doc.contents),
                    expandedStates: doc.expandedStates && doc.expandedStates.map(flattenDoc)
                  });
                }
                if (doc.type === "fill") {
                  return {
                    type: "fill",
                    parts: doc.parts.map(flattenDoc)
                  };
                }
                if (doc.contents) {
                  return Object.assign(Object.assign({}, doc), {}, {
                    contents: flattenDoc(doc.contents)
                  });
                }
                return doc;
              }
              function printDocToDebug(doc) {
                const printedSymbols = /* @__PURE__ */ Object.create(null);
                const usedKeysForSymbols = /* @__PURE__ */ new Set();
                return printDoc(flattenDoc(doc));
                function printDoc(doc2, index, parentParts) {
                  if (typeof doc2 === "string") {
                    return JSON.stringify(doc2);
                  }
                  if (isConcat(doc2)) {
                    const printed = getDocParts(doc2).map(printDoc).filter(Boolean);
                    return printed.length === 1 ? printed[0] : "[".concat(printed.join(", "), "]");
                  }
                  if (doc2.type === "line") {
                    const withBreakParent = Array.isArray(parentParts) && parentParts[index + 1] && parentParts[index + 1].type === "break-parent";
                    if (doc2.literal) {
                      return withBreakParent ? "literalline" : "literallineWithoutBreakParent";
                    }
                    if (doc2.hard) {
                      return withBreakParent ? "hardline" : "hardlineWithoutBreakParent";
                    }
                    if (doc2.soft) {
                      return "softline";
                    }
                    return "line";
                  }
                  if (doc2.type === "break-parent") {
                    const afterHardline = Array.isArray(parentParts) && parentParts[index - 1] && parentParts[index - 1].type === "line" && parentParts[index - 1].hard;
                    return afterHardline ? void 0 : "breakParent";
                  }
                  if (doc2.type === "trim") {
                    return "trim";
                  }
                  if (doc2.type === "indent") {
                    return "indent(" + printDoc(doc2.contents) + ")";
                  }
                  if (doc2.type === "align") {
                    return doc2.n === Number.NEGATIVE_INFINITY ? "dedentToRoot(" + printDoc(doc2.contents) + ")" : doc2.n < 0 ? "dedent(" + printDoc(doc2.contents) + ")" : doc2.n.type === "root" ? "markAsRoot(" + printDoc(doc2.contents) + ")" : "align(" + JSON.stringify(doc2.n) + ", " + printDoc(doc2.contents) + ")";
                  }
                  if (doc2.type === "if-break") {
                    return "ifBreak(" + printDoc(doc2.breakContents) + (doc2.flatContents ? ", " + printDoc(doc2.flatContents) : "") + (doc2.groupId ? (!doc2.flatContents ? ', ""' : "") + ", { groupId: ".concat(printGroupId(doc2.groupId), " }") : "") + ")";
                  }
                  if (doc2.type === "indent-if-break") {
                    const optionsParts = [];
                    if (doc2.negate) {
                      optionsParts.push("negate: true");
                    }
                    if (doc2.groupId) {
                      optionsParts.push("groupId: ".concat(printGroupId(doc2.groupId)));
                    }
                    const options = optionsParts.length > 0 ? ", { ".concat(optionsParts.join(", "), " }") : "";
                    return "indentIfBreak(".concat(printDoc(doc2.contents)).concat(options, ")");
                  }
                  if (doc2.type === "group") {
                    const optionsParts = [];
                    if (doc2.break && doc2.break !== "propagated") {
                      optionsParts.push("shouldBreak: true");
                    }
                    if (doc2.id) {
                      optionsParts.push("id: ".concat(printGroupId(doc2.id)));
                    }
                    const options = optionsParts.length > 0 ? ", { ".concat(optionsParts.join(", "), " }") : "";
                    if (doc2.expandedStates) {
                      return "conditionalGroup([".concat(doc2.expandedStates.map((part) => printDoc(part)).join(","), "]").concat(options, ")");
                    }
                    return "group(".concat(printDoc(doc2.contents)).concat(options, ")");
                  }
                  if (doc2.type === "fill") {
                    return "fill([".concat(doc2.parts.map((part) => printDoc(part)).join(", "), "])");
                  }
                  if (doc2.type === "line-suffix") {
                    return "lineSuffix(" + printDoc(doc2.contents) + ")";
                  }
                  if (doc2.type === "line-suffix-boundary") {
                    return "lineSuffixBoundary";
                  }
                  if (doc2.type === "label") {
                    return "label(".concat(JSON.stringify(doc2.label), ", ").concat(printDoc(doc2.contents), ")");
                  }
                  throw new Error("Unknown doc type " + doc2.type);
                }
                function printGroupId(id) {
                  if (typeof id !== "symbol") {
                    return JSON.stringify(String(id));
                  }
                  if (id in printedSymbols) {
                    return printedSymbols[id];
                  }
                  const prefix = String(id).slice(7, -1) || "symbol";
                  for (let counter = 0; ; counter++) {
                    const key = prefix + (counter > 0 ? " #".concat(counter) : "");
                    if (!usedKeysForSymbols.has(key)) {
                      usedKeysForSymbols.add(key);
                      return printedSymbols[id] = "Symbol.for(".concat(JSON.stringify(key), ")");
                    }
                  }
                }
              }
              module22.exports = {
                printDocToDebug
              };
            }
          });
          init_define_process();
          module3.exports = {
            builders: require_doc_builders(),
            printer: require_doc_printer(),
            utils: require_doc_utils(),
            debug: require_doc_debug()
          };
        }
      });
      return require_doc_js_umd();
    });
  }
});

// ../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/third-party.js
var require_third_party = __commonJS({
  "../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/third-party.js"(exports2, module2) {
    "use strict";
    var __getOwnPropNames2 = Object.getOwnPropertyNames;
    var __commonJS2 = (cb, mod) => function __require() {
      return mod || (0, cb[__getOwnPropNames2(cb)[0]])((mod = {
        exports: {}
      }).exports, mod), mod.exports;
    };
    var require_resolve_from = __commonJS2({
      "node_modules/import-fresh/node_modules/resolve-from/index.js"(exports22, module22) {
        "use strict";
        var path5 = require("path");
        var Module = require("module");
        var fs = require("fs");
        var resolveFrom = (fromDir, moduleId, silent) => {
          if (typeof fromDir !== "string") {
            throw new TypeError(`Expected \`fromDir\` to be of type \`string\`, got \`${typeof fromDir}\``);
          }
          if (typeof moduleId !== "string") {
            throw new TypeError(`Expected \`moduleId\` to be of type \`string\`, got \`${typeof moduleId}\``);
          }
          try {
            fromDir = fs.realpathSync(fromDir);
          } catch (err) {
            if (err.code === "ENOENT") {
              fromDir = path5.resolve(fromDir);
            } else if (silent) {
              return null;
            } else {
              throw err;
            }
          }
          const fromFile = path5.join(fromDir, "noop.js");
          const resolveFileName = () => Module._resolveFilename(moduleId, {
            id: fromFile,
            filename: fromFile,
            paths: Module._nodeModulePaths(fromDir)
          });
          if (silent) {
            try {
              return resolveFileName();
            } catch (err) {
              return null;
            }
          }
          return resolveFileName();
        };
        module22.exports = (fromDir, moduleId) => resolveFrom(fromDir, moduleId);
        module22.exports.silent = (fromDir, moduleId) => resolveFrom(fromDir, moduleId, true);
      }
    });
    var require_parent_module = __commonJS2({
      "scripts/build/shims/parent-module.cjs"(exports22, module22) {
        "use strict";
        module22.exports = (file) => file;
      }
    });
    var require_import_fresh = __commonJS2({
      "node_modules/import-fresh/index.js"(exports22, module22) {
        "use strict";
        var path5 = require("path");
        var resolveFrom = require_resolve_from();
        var parentModule = require_parent_module();
        module22.exports = (moduleId) => {
          if (typeof moduleId !== "string") {
            throw new TypeError("Expected a string");
          }
          const parentPath = parentModule(__filename);
          const cwd = parentPath ? path5.dirname(parentPath) : __dirname;
          const filePath = resolveFrom(cwd, moduleId);
          const oldModule = require.cache[filePath];
          if (oldModule && oldModule.parent) {
            let i = oldModule.parent.children.length;
            while (i--) {
              if (oldModule.parent.children[i].id === filePath) {
                oldModule.parent.children.splice(i, 1);
              }
            }
          }
          delete require.cache[filePath];
          const parent = require.cache[parentPath];
          return parent === void 0 ? require(filePath) : parent.require(filePath);
        };
      }
    });
    var require_is_arrayish = __commonJS2({
      "node_modules/is-arrayish/index.js"(exports22, module22) {
        "use strict";
        module22.exports = function isArrayish(obj) {
          if (!obj) {
            return false;
          }
          return obj instanceof Array || Array.isArray(obj) || obj.length >= 0 && obj.splice instanceof Function;
        };
      }
    });
    var require_error_ex = __commonJS2({
      "node_modules/error-ex/index.js"(exports22, module22) {
        "use strict";
        var util2 = require("util");
        var isArrayish = require_is_arrayish();
        var errorEx = function errorEx2(name, properties) {
          if (!name || name.constructor !== String) {
            properties = name || {};
            name = Error.name;
          }
          var errorExError = function ErrorEXError(message) {
            if (!this) {
              return new ErrorEXError(message);
            }
            message = message instanceof Error ? message.message : message || this.message;
            Error.call(this, message);
            Error.captureStackTrace(this, errorExError);
            this.name = name;
            Object.defineProperty(this, "message", {
              configurable: true,
              enumerable: false,
              get: function() {
                var newMessage = message.split(/\r?\n/g);
                for (var key in properties) {
                  if (!properties.hasOwnProperty(key)) {
                    continue;
                  }
                  var modifier = properties[key];
                  if ("message" in modifier) {
                    newMessage = modifier.message(this[key], newMessage) || newMessage;
                    if (!isArrayish(newMessage)) {
                      newMessage = [newMessage];
                    }
                  }
                }
                return newMessage.join("\n");
              },
              set: function(v) {
                message = v;
              }
            });
            var overwrittenStack = null;
            var stackDescriptor = Object.getOwnPropertyDescriptor(this, "stack");
            var stackGetter = stackDescriptor.get;
            var stackValue = stackDescriptor.value;
            delete stackDescriptor.value;
            delete stackDescriptor.writable;
            stackDescriptor.set = function(newstack) {
              overwrittenStack = newstack;
            };
            stackDescriptor.get = function() {
              var stack = (overwrittenStack || (stackGetter ? stackGetter.call(this) : stackValue)).split(/\r?\n+/g);
              if (!overwrittenStack) {
                stack[0] = this.name + ": " + this.message;
              }
              var lineCount = 1;
              for (var key in properties) {
                if (!properties.hasOwnProperty(key)) {
                  continue;
                }
                var modifier = properties[key];
                if ("line" in modifier) {
                  var line = modifier.line(this[key]);
                  if (line) {
                    stack.splice(lineCount++, 0, "    " + line);
                  }
                }
                if ("stack" in modifier) {
                  modifier.stack(this[key], stack);
                }
              }
              return stack.join("\n");
            };
            Object.defineProperty(this, "stack", stackDescriptor);
          };
          if (Object.setPrototypeOf) {
            Object.setPrototypeOf(errorExError.prototype, Error.prototype);
            Object.setPrototypeOf(errorExError, Error);
          } else {
            util2.inherits(errorExError, Error);
          }
          return errorExError;
        };
        errorEx.append = function(str2, def) {
          return {
            message: function(v, message) {
              v = v || def;
              if (v) {
                message[0] += " " + str2.replace("%s", v.toString());
              }
              return message;
            }
          };
        };
        errorEx.line = function(str2, def) {
          return {
            line: function(v) {
              v = v || def;
              if (v) {
                return str2.replace("%s", v.toString());
              }
              return null;
            }
          };
        };
        module22.exports = errorEx;
      }
    });
    var require_json_parse_even_better_errors = __commonJS2({
      "node_modules/json-parse-even-better-errors/index.js"(exports22, module22) {
        "use strict";
        var hexify = (char) => {
          const h = char.charCodeAt(0).toString(16).toUpperCase();
          return "0x" + (h.length % 2 ? "0" : "") + h;
        };
        var parseError = (e, txt, context) => {
          if (!txt) {
            return {
              message: e.message + " while parsing empty string",
              position: 0
            };
          }
          const badToken = e.message.match(/^Unexpected token (.) .*position\s+(\d+)/i);
          const errIdx = badToken ? +badToken[2] : e.message.match(/^Unexpected end of JSON.*/i) ? txt.length - 1 : null;
          const msg = badToken ? e.message.replace(/^Unexpected token ./, `Unexpected token ${JSON.stringify(badToken[1])} (${hexify(badToken[1])})`) : e.message;
          if (errIdx !== null && errIdx !== void 0) {
            const start = errIdx <= context ? 0 : errIdx - context;
            const end = errIdx + context >= txt.length ? txt.length : errIdx + context;
            const slice = (start === 0 ? "" : "...") + txt.slice(start, end) + (end === txt.length ? "" : "...");
            const near = txt === slice ? "" : "near ";
            return {
              message: msg + ` while parsing ${near}${JSON.stringify(slice)}`,
              position: errIdx
            };
          } else {
            return {
              message: msg + ` while parsing '${txt.slice(0, context * 2)}'`,
              position: 0
            };
          }
        };
        var JSONParseError = class extends SyntaxError {
          constructor(er, txt, context, caller) {
            context = context || 20;
            const metadata = parseError(er, txt, context);
            super(metadata.message);
            Object.assign(this, metadata);
            this.code = "EJSONPARSE";
            this.systemError = er;
            Error.captureStackTrace(this, caller || this.constructor);
          }
          get name() {
            return this.constructor.name;
          }
          set name(n) {
          }
          get [Symbol.toStringTag]() {
            return this.constructor.name;
          }
        };
        var kIndent = Symbol.for("indent");
        var kNewline = Symbol.for("newline");
        var formatRE = /^\s*[{\[]((?:\r?\n)+)([\s\t]*)/;
        var emptyRE = /^(?:\{\}|\[\])((?:\r?\n)+)?$/;
        var parseJson = (txt, reviver, context) => {
          const parseText = stripBOM(txt);
          context = context || 20;
          try {
            const [, newline = "\n", indent = "  "] = parseText.match(emptyRE) || parseText.match(formatRE) || [, "", ""];
            const result = JSON.parse(parseText, reviver);
            if (result && typeof result === "object") {
              result[kNewline] = newline;
              result[kIndent] = indent;
            }
            return result;
          } catch (e) {
            if (typeof txt !== "string" && !Buffer.isBuffer(txt)) {
              const isEmptyArray = Array.isArray(txt) && txt.length === 0;
              throw Object.assign(new TypeError(`Cannot parse ${isEmptyArray ? "an empty array" : String(txt)}`), {
                code: "EJSONPARSE",
                systemError: e
              });
            }
            throw new JSONParseError(e, parseText, context, parseJson);
          }
        };
        var stripBOM = (txt) => String(txt).replace(/^\uFEFF/, "");
        module22.exports = parseJson;
        parseJson.JSONParseError = JSONParseError;
        parseJson.noExceptions = (txt, reviver) => {
          try {
            return JSON.parse(stripBOM(txt), reviver);
          } catch (e) {
          }
        };
      }
    });
    var require_build = __commonJS2({
      "node_modules/parse-json/node_modules/lines-and-columns/build/index.js"(exports22) {
        "use strict";
        exports22.__esModule = true;
        exports22.LinesAndColumns = void 0;
        var LF = "\n";
        var CR = "\r";
        var LinesAndColumns = function() {
          function LinesAndColumns2(string3) {
            this.string = string3;
            var offsets = [0];
            for (var offset = 0; offset < string3.length; ) {
              switch (string3[offset]) {
                case LF:
                  offset += LF.length;
                  offsets.push(offset);
                  break;
                case CR:
                  offset += CR.length;
                  if (string3[offset] === LF) {
                    offset += LF.length;
                  }
                  offsets.push(offset);
                  break;
                default:
                  offset++;
                  break;
              }
            }
            this.offsets = offsets;
          }
          LinesAndColumns2.prototype.locationForIndex = function(index) {
            if (index < 0 || index > this.string.length) {
              return null;
            }
            var line = 0;
            var offsets = this.offsets;
            while (offsets[line + 1] <= index) {
              line++;
            }
            var column = index - offsets[line];
            return {
              line,
              column
            };
          };
          LinesAndColumns2.prototype.indexForLocation = function(location) {
            var line = location.line, column = location.column;
            if (line < 0 || line >= this.offsets.length) {
              return null;
            }
            if (column < 0 || column > this.lengthOfLine(line)) {
              return null;
            }
            return this.offsets[line] + column;
          };
          LinesAndColumns2.prototype.lengthOfLine = function(line) {
            var offset = this.offsets[line];
            var nextOffset = line === this.offsets.length - 1 ? this.string.length : this.offsets[line + 1];
            return nextOffset - offset;
          };
          return LinesAndColumns2;
        }();
        exports22.LinesAndColumns = LinesAndColumns;
        exports22["default"] = LinesAndColumns;
      }
    });
    var require_js_tokens = __commonJS2({
      "node_modules/js-tokens/index.js"(exports22) {
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.default = /((['"])(?:(?!\2|\\).|\\(?:\r\n|[\s\S]))*(\2)?|`(?:[^`\\$]|\\[\s\S]|\$(?!\{)|\$\{(?:[^{}]|\{[^}]*\}?)*\}?)*(`)?)|(\/\/.*)|(\/\*(?:[^*]|\*(?!\/))*(\*\/)?)|(\/(?!\*)(?:\[(?:(?![\]\\]).|\\.)*\]|(?![\/\]\\]).|\\.)+\/(?:(?!\s*(?:\b|[\u0080-\uFFFF$\\'"~({]|[+\-!](?!=)|\.?\d))|[gmiyus]{1,6}\b(?![\u0080-\uFFFF$\\]|\s*(?:[+\-*%&|^<>!=?({]|\/(?![\/*])))))|(0[xX][\da-fA-F]+|0[oO][0-7]+|0[bB][01]+|(?:\d*\.\d+|\d+\.?)(?:[eE][+-]?\d+)?)|((?!\d)(?:(?!\s)[$\w\u0080-\uFFFF]|\\u[\da-fA-F]{4}|\\u\{[\da-fA-F]+\})+)|(--|\+\+|&&|\|\||=>|\.{3}|(?:[+\-\/%&|^]|\*{1,2}|<{1,2}|>{1,3}|!=?|={1,2})=?|[?~.,:;[\](){}])|(\s+)|(^$|[\s\S])/g;
        exports22.matchToToken = function(match) {
          var token = {
            type: "invalid",
            value: match[0],
            closed: void 0
          };
          if (match[1])
            token.type = "string", token.closed = !!(match[3] || match[4]);
          else if (match[5])
            token.type = "comment";
          else if (match[6])
            token.type = "comment", token.closed = !!match[7];
          else if (match[8])
            token.type = "regex";
          else if (match[9])
            token.type = "number";
          else if (match[10])
            token.type = "name";
          else if (match[11])
            token.type = "punctuator";
          else if (match[12])
            token.type = "whitespace";
          return token;
        };
      }
    });
    var require_identifier = __commonJS2({
      "node_modules/@babel/helper-validator-identifier/lib/identifier.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.isIdentifierChar = isIdentifierChar;
        exports22.isIdentifierName = isIdentifierName;
        exports22.isIdentifierStart = isIdentifierStart;
        var nonASCIIidentifierStartChars = "\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BF\u31F0-\u31FF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC";
        var nonASCIIidentifierChars = "\u200C\u200D\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u0898-\u089F\u08CA-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B55-\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3C\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D81-\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EBC\u0EC8-\u0ECD\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u180F-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1ABF-\u1ACE\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DFF\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA82C\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F";
        var nonASCIIidentifierStart = new RegExp("[" + nonASCIIidentifierStartChars + "]");
        var nonASCIIidentifier = new RegExp("[" + nonASCIIidentifierStartChars + nonASCIIidentifierChars + "]");
        nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
        var astralIdentifierStartCodes = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 85, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 190, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1070, 4050, 582, 8634, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 46, 2, 18, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 482, 44, 11, 6, 17, 0, 322, 29, 19, 43, 1269, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4152, 8, 221, 3, 5761, 15, 7472, 3104, 541, 1507, 4938];
        var astralIdentifierCodes = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 370, 1, 154, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 161, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 19306, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 262, 6, 10, 9, 357, 0, 62, 13, 1495, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];
        function isInAstralSet(code, set4) {
          let pos = 65536;
          for (let i = 0, length = set4.length; i < length; i += 2) {
            pos += set4[i];
            if (pos > code)
              return false;
            pos += set4[i + 1];
            if (pos >= code)
              return true;
          }
          return false;
        }
        function isIdentifierStart(code) {
          if (code < 65)
            return code === 36;
          if (code <= 90)
            return true;
          if (code < 97)
            return code === 95;
          if (code <= 122)
            return true;
          if (code <= 65535) {
            return code >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code));
          }
          return isInAstralSet(code, astralIdentifierStartCodes);
        }
        function isIdentifierChar(code) {
          if (code < 48)
            return code === 36;
          if (code < 58)
            return true;
          if (code < 65)
            return false;
          if (code <= 90)
            return true;
          if (code < 97)
            return code === 95;
          if (code <= 122)
            return true;
          if (code <= 65535) {
            return code >= 170 && nonASCIIidentifier.test(String.fromCharCode(code));
          }
          return isInAstralSet(code, astralIdentifierStartCodes) || isInAstralSet(code, astralIdentifierCodes);
        }
        function isIdentifierName(name) {
          let isFirst = true;
          for (let i = 0; i < name.length; i++) {
            let cp = name.charCodeAt(i);
            if ((cp & 64512) === 55296 && i + 1 < name.length) {
              const trail = name.charCodeAt(++i);
              if ((trail & 64512) === 56320) {
                cp = 65536 + ((cp & 1023) << 10) + (trail & 1023);
              }
            }
            if (isFirst) {
              isFirst = false;
              if (!isIdentifierStart(cp)) {
                return false;
              }
            } else if (!isIdentifierChar(cp)) {
              return false;
            }
          }
          return !isFirst;
        }
      }
    });
    var require_keyword2 = __commonJS2({
      "node_modules/@babel/helper-validator-identifier/lib/keyword.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.isKeyword = isKeyword;
        exports22.isReservedWord = isReservedWord;
        exports22.isStrictBindOnlyReservedWord = isStrictBindOnlyReservedWord;
        exports22.isStrictBindReservedWord = isStrictBindReservedWord;
        exports22.isStrictReservedWord = isStrictReservedWord;
        var reservedWords = {
          keyword: ["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete"],
          strict: ["implements", "interface", "let", "package", "private", "protected", "public", "static", "yield"],
          strictBind: ["eval", "arguments"]
        };
        var keywords = new Set(reservedWords.keyword);
        var reservedWordsStrictSet = new Set(reservedWords.strict);
        var reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
        function isReservedWord(word, inModule) {
          return inModule && word === "await" || word === "enum";
        }
        function isStrictReservedWord(word, inModule) {
          return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
        }
        function isStrictBindOnlyReservedWord(word) {
          return reservedWordsStrictBindSet.has(word);
        }
        function isStrictBindReservedWord(word, inModule) {
          return isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word);
        }
        function isKeyword(word) {
          return keywords.has(word);
        }
      }
    });
    var require_lib4 = __commonJS2({
      "node_modules/@babel/helper-validator-identifier/lib/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        Object.defineProperty(exports22, "isIdentifierChar", {
          enumerable: true,
          get: function() {
            return _identifier.isIdentifierChar;
          }
        });
        Object.defineProperty(exports22, "isIdentifierName", {
          enumerable: true,
          get: function() {
            return _identifier.isIdentifierName;
          }
        });
        Object.defineProperty(exports22, "isIdentifierStart", {
          enumerable: true,
          get: function() {
            return _identifier.isIdentifierStart;
          }
        });
        Object.defineProperty(exports22, "isKeyword", {
          enumerable: true,
          get: function() {
            return _keyword.isKeyword;
          }
        });
        Object.defineProperty(exports22, "isReservedWord", {
          enumerable: true,
          get: function() {
            return _keyword.isReservedWord;
          }
        });
        Object.defineProperty(exports22, "isStrictBindOnlyReservedWord", {
          enumerable: true,
          get: function() {
            return _keyword.isStrictBindOnlyReservedWord;
          }
        });
        Object.defineProperty(exports22, "isStrictBindReservedWord", {
          enumerable: true,
          get: function() {
            return _keyword.isStrictBindReservedWord;
          }
        });
        Object.defineProperty(exports22, "isStrictReservedWord", {
          enumerable: true,
          get: function() {
            return _keyword.isStrictReservedWord;
          }
        });
        var _identifier = require_identifier();
        var _keyword = require_keyword2();
      }
    });
    var require_escape_string_regexp = __commonJS2({
      "node_modules/@babel/highlight/node_modules/escape-string-regexp/index.js"(exports22, module22) {
        "use strict";
        var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
        module22.exports = function(str2) {
          if (typeof str2 !== "string") {
            throw new TypeError("Expected a string");
          }
          return str2.replace(matchOperatorsRe, "\\$&");
        };
      }
    });
    var require_color_name = __commonJS2({
      "node_modules/color-name/index.js"(exports22, module22) {
        "use strict";
        module22.exports = {
          "aliceblue": [240, 248, 255],
          "antiquewhite": [250, 235, 215],
          "aqua": [0, 255, 255],
          "aquamarine": [127, 255, 212],
          "azure": [240, 255, 255],
          "beige": [245, 245, 220],
          "bisque": [255, 228, 196],
          "black": [0, 0, 0],
          "blanchedalmond": [255, 235, 205],
          "blue": [0, 0, 255],
          "blueviolet": [138, 43, 226],
          "brown": [165, 42, 42],
          "burlywood": [222, 184, 135],
          "cadetblue": [95, 158, 160],
          "chartreuse": [127, 255, 0],
          "chocolate": [210, 105, 30],
          "coral": [255, 127, 80],
          "cornflowerblue": [100, 149, 237],
          "cornsilk": [255, 248, 220],
          "crimson": [220, 20, 60],
          "cyan": [0, 255, 255],
          "darkblue": [0, 0, 139],
          "darkcyan": [0, 139, 139],
          "darkgoldenrod": [184, 134, 11],
          "darkgray": [169, 169, 169],
          "darkgreen": [0, 100, 0],
          "darkgrey": [169, 169, 169],
          "darkkhaki": [189, 183, 107],
          "darkmagenta": [139, 0, 139],
          "darkolivegreen": [85, 107, 47],
          "darkorange": [255, 140, 0],
          "darkorchid": [153, 50, 204],
          "darkred": [139, 0, 0],
          "darksalmon": [233, 150, 122],
          "darkseagreen": [143, 188, 143],
          "darkslateblue": [72, 61, 139],
          "darkslategray": [47, 79, 79],
          "darkslategrey": [47, 79, 79],
          "darkturquoise": [0, 206, 209],
          "darkviolet": [148, 0, 211],
          "deeppink": [255, 20, 147],
          "deepskyblue": [0, 191, 255],
          "dimgray": [105, 105, 105],
          "dimgrey": [105, 105, 105],
          "dodgerblue": [30, 144, 255],
          "firebrick": [178, 34, 34],
          "floralwhite": [255, 250, 240],
          "forestgreen": [34, 139, 34],
          "fuchsia": [255, 0, 255],
          "gainsboro": [220, 220, 220],
          "ghostwhite": [248, 248, 255],
          "gold": [255, 215, 0],
          "goldenrod": [218, 165, 32],
          "gray": [128, 128, 128],
          "green": [0, 128, 0],
          "greenyellow": [173, 255, 47],
          "grey": [128, 128, 128],
          "honeydew": [240, 255, 240],
          "hotpink": [255, 105, 180],
          "indianred": [205, 92, 92],
          "indigo": [75, 0, 130],
          "ivory": [255, 255, 240],
          "khaki": [240, 230, 140],
          "lavender": [230, 230, 250],
          "lavenderblush": [255, 240, 245],
          "lawngreen": [124, 252, 0],
          "lemonchiffon": [255, 250, 205],
          "lightblue": [173, 216, 230],
          "lightcoral": [240, 128, 128],
          "lightcyan": [224, 255, 255],
          "lightgoldenrodyellow": [250, 250, 210],
          "lightgray": [211, 211, 211],
          "lightgreen": [144, 238, 144],
          "lightgrey": [211, 211, 211],
          "lightpink": [255, 182, 193],
          "lightsalmon": [255, 160, 122],
          "lightseagreen": [32, 178, 170],
          "lightskyblue": [135, 206, 250],
          "lightslategray": [119, 136, 153],
          "lightslategrey": [119, 136, 153],
          "lightsteelblue": [176, 196, 222],
          "lightyellow": [255, 255, 224],
          "lime": [0, 255, 0],
          "limegreen": [50, 205, 50],
          "linen": [250, 240, 230],
          "magenta": [255, 0, 255],
          "maroon": [128, 0, 0],
          "mediumaquamarine": [102, 205, 170],
          "mediumblue": [0, 0, 205],
          "mediumorchid": [186, 85, 211],
          "mediumpurple": [147, 112, 219],
          "mediumseagreen": [60, 179, 113],
          "mediumslateblue": [123, 104, 238],
          "mediumspringgreen": [0, 250, 154],
          "mediumturquoise": [72, 209, 204],
          "mediumvioletred": [199, 21, 133],
          "midnightblue": [25, 25, 112],
          "mintcream": [245, 255, 250],
          "mistyrose": [255, 228, 225],
          "moccasin": [255, 228, 181],
          "navajowhite": [255, 222, 173],
          "navy": [0, 0, 128],
          "oldlace": [253, 245, 230],
          "olive": [128, 128, 0],
          "olivedrab": [107, 142, 35],
          "orange": [255, 165, 0],
          "orangered": [255, 69, 0],
          "orchid": [218, 112, 214],
          "palegoldenrod": [238, 232, 170],
          "palegreen": [152, 251, 152],
          "paleturquoise": [175, 238, 238],
          "palevioletred": [219, 112, 147],
          "papayawhip": [255, 239, 213],
          "peachpuff": [255, 218, 185],
          "peru": [205, 133, 63],
          "pink": [255, 192, 203],
          "plum": [221, 160, 221],
          "powderblue": [176, 224, 230],
          "purple": [128, 0, 128],
          "rebeccapurple": [102, 51, 153],
          "red": [255, 0, 0],
          "rosybrown": [188, 143, 143],
          "royalblue": [65, 105, 225],
          "saddlebrown": [139, 69, 19],
          "salmon": [250, 128, 114],
          "sandybrown": [244, 164, 96],
          "seagreen": [46, 139, 87],
          "seashell": [255, 245, 238],
          "sienna": [160, 82, 45],
          "silver": [192, 192, 192],
          "skyblue": [135, 206, 235],
          "slateblue": [106, 90, 205],
          "slategray": [112, 128, 144],
          "slategrey": [112, 128, 144],
          "snow": [255, 250, 250],
          "springgreen": [0, 255, 127],
          "steelblue": [70, 130, 180],
          "tan": [210, 180, 140],
          "teal": [0, 128, 128],
          "thistle": [216, 191, 216],
          "tomato": [255, 99, 71],
          "turquoise": [64, 224, 208],
          "violet": [238, 130, 238],
          "wheat": [245, 222, 179],
          "white": [255, 255, 255],
          "whitesmoke": [245, 245, 245],
          "yellow": [255, 255, 0],
          "yellowgreen": [154, 205, 50]
        };
      }
    });
    var require_conversions = __commonJS2({
      "node_modules/color-convert/conversions.js"(exports22, module22) {
        var cssKeywords = require_color_name();
        var reverseKeywords = {};
        for (key in cssKeywords) {
          if (cssKeywords.hasOwnProperty(key)) {
            reverseKeywords[cssKeywords[key]] = key;
          }
        }
        var key;
        var convert4 = module22.exports = {
          rgb: {
            channels: 3,
            labels: "rgb"
          },
          hsl: {
            channels: 3,
            labels: "hsl"
          },
          hsv: {
            channels: 3,
            labels: "hsv"
          },
          hwb: {
            channels: 3,
            labels: "hwb"
          },
          cmyk: {
            channels: 4,
            labels: "cmyk"
          },
          xyz: {
            channels: 3,
            labels: "xyz"
          },
          lab: {
            channels: 3,
            labels: "lab"
          },
          lch: {
            channels: 3,
            labels: "lch"
          },
          hex: {
            channels: 1,
            labels: ["hex"]
          },
          keyword: {
            channels: 1,
            labels: ["keyword"]
          },
          ansi16: {
            channels: 1,
            labels: ["ansi16"]
          },
          ansi256: {
            channels: 1,
            labels: ["ansi256"]
          },
          hcg: {
            channels: 3,
            labels: ["h", "c", "g"]
          },
          apple: {
            channels: 3,
            labels: ["r16", "g16", "b16"]
          },
          gray: {
            channels: 1,
            labels: ["gray"]
          }
        };
        for (model in convert4) {
          if (convert4.hasOwnProperty(model)) {
            if (!("channels" in convert4[model])) {
              throw new Error("missing channels property: " + model);
            }
            if (!("labels" in convert4[model])) {
              throw new Error("missing channel labels property: " + model);
            }
            if (convert4[model].labels.length !== convert4[model].channels) {
              throw new Error("channel and label counts mismatch: " + model);
            }
            channels = convert4[model].channels;
            labels = convert4[model].labels;
            delete convert4[model].channels;
            delete convert4[model].labels;
            Object.defineProperty(convert4[model], "channels", {
              value: channels
            });
            Object.defineProperty(convert4[model], "labels", {
              value: labels
            });
          }
        }
        var channels;
        var labels;
        var model;
        convert4.rgb.hsl = function(rgb) {
          var r = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          var min = Math.min(r, g, b);
          var max = Math.max(r, g, b);
          var delta = max - min;
          var h;
          var s;
          var l;
          if (max === min) {
            h = 0;
          } else if (r === max) {
            h = (g - b) / delta;
          } else if (g === max) {
            h = 2 + (b - r) / delta;
          } else if (b === max) {
            h = 4 + (r - g) / delta;
          }
          h = Math.min(h * 60, 360);
          if (h < 0) {
            h += 360;
          }
          l = (min + max) / 2;
          if (max === min) {
            s = 0;
          } else if (l <= 0.5) {
            s = delta / (max + min);
          } else {
            s = delta / (2 - max - min);
          }
          return [h, s * 100, l * 100];
        };
        convert4.rgb.hsv = function(rgb) {
          var rdif;
          var gdif;
          var bdif;
          var h;
          var s;
          var r = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          var v = Math.max(r, g, b);
          var diff = v - Math.min(r, g, b);
          var diffc = function(c) {
            return (v - c) / 6 / diff + 1 / 2;
          };
          if (diff === 0) {
            h = s = 0;
          } else {
            s = diff / v;
            rdif = diffc(r);
            gdif = diffc(g);
            bdif = diffc(b);
            if (r === v) {
              h = bdif - gdif;
            } else if (g === v) {
              h = 1 / 3 + rdif - bdif;
            } else if (b === v) {
              h = 2 / 3 + gdif - rdif;
            }
            if (h < 0) {
              h += 1;
            } else if (h > 1) {
              h -= 1;
            }
          }
          return [h * 360, s * 100, v * 100];
        };
        convert4.rgb.hwb = function(rgb) {
          var r = rgb[0];
          var g = rgb[1];
          var b = rgb[2];
          var h = convert4.rgb.hsl(rgb)[0];
          var w = 1 / 255 * Math.min(r, Math.min(g, b));
          b = 1 - 1 / 255 * Math.max(r, Math.max(g, b));
          return [h, w * 100, b * 100];
        };
        convert4.rgb.cmyk = function(rgb) {
          var r = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          var c;
          var m;
          var y;
          var k;
          k = Math.min(1 - r, 1 - g, 1 - b);
          c = (1 - r - k) / (1 - k) || 0;
          m = (1 - g - k) / (1 - k) || 0;
          y = (1 - b - k) / (1 - k) || 0;
          return [c * 100, m * 100, y * 100, k * 100];
        };
        function comparativeDistance(x, y) {
          return Math.pow(x[0] - y[0], 2) + Math.pow(x[1] - y[1], 2) + Math.pow(x[2] - y[2], 2);
        }
        convert4.rgb.keyword = function(rgb) {
          var reversed = reverseKeywords[rgb];
          if (reversed) {
            return reversed;
          }
          var currentClosestDistance = Infinity;
          var currentClosestKeyword;
          for (var keyword in cssKeywords) {
            if (cssKeywords.hasOwnProperty(keyword)) {
              var value = cssKeywords[keyword];
              var distance = comparativeDistance(rgb, value);
              if (distance < currentClosestDistance) {
                currentClosestDistance = distance;
                currentClosestKeyword = keyword;
              }
            }
          }
          return currentClosestKeyword;
        };
        convert4.keyword.rgb = function(keyword) {
          return cssKeywords[keyword];
        };
        convert4.rgb.xyz = function(rgb) {
          var r = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          r = r > 0.04045 ? Math.pow((r + 0.055) / 1.055, 2.4) : r / 12.92;
          g = g > 0.04045 ? Math.pow((g + 0.055) / 1.055, 2.4) : g / 12.92;
          b = b > 0.04045 ? Math.pow((b + 0.055) / 1.055, 2.4) : b / 12.92;
          var x = r * 0.4124 + g * 0.3576 + b * 0.1805;
          var y = r * 0.2126 + g * 0.7152 + b * 0.0722;
          var z2 = r * 0.0193 + g * 0.1192 + b * 0.9505;
          return [x * 100, y * 100, z2 * 100];
        };
        convert4.rgb.lab = function(rgb) {
          var xyz = convert4.rgb.xyz(rgb);
          var x = xyz[0];
          var y = xyz[1];
          var z2 = xyz[2];
          var l;
          var a;
          var b;
          x /= 95.047;
          y /= 100;
          z2 /= 108.883;
          x = x > 8856e-6 ? Math.pow(x, 1 / 3) : 7.787 * x + 16 / 116;
          y = y > 8856e-6 ? Math.pow(y, 1 / 3) : 7.787 * y + 16 / 116;
          z2 = z2 > 8856e-6 ? Math.pow(z2, 1 / 3) : 7.787 * z2 + 16 / 116;
          l = 116 * y - 16;
          a = 500 * (x - y);
          b = 200 * (y - z2);
          return [l, a, b];
        };
        convert4.hsl.rgb = function(hsl) {
          var h = hsl[0] / 360;
          var s = hsl[1] / 100;
          var l = hsl[2] / 100;
          var t1;
          var t2;
          var t3;
          var rgb;
          var val;
          if (s === 0) {
            val = l * 255;
            return [val, val, val];
          }
          if (l < 0.5) {
            t2 = l * (1 + s);
          } else {
            t2 = l + s - l * s;
          }
          t1 = 2 * l - t2;
          rgb = [0, 0, 0];
          for (var i = 0; i < 3; i++) {
            t3 = h + 1 / 3 * -(i - 1);
            if (t3 < 0) {
              t3++;
            }
            if (t3 > 1) {
              t3--;
            }
            if (6 * t3 < 1) {
              val = t1 + (t2 - t1) * 6 * t3;
            } else if (2 * t3 < 1) {
              val = t2;
            } else if (3 * t3 < 2) {
              val = t1 + (t2 - t1) * (2 / 3 - t3) * 6;
            } else {
              val = t1;
            }
            rgb[i] = val * 255;
          }
          return rgb;
        };
        convert4.hsl.hsv = function(hsl) {
          var h = hsl[0];
          var s = hsl[1] / 100;
          var l = hsl[2] / 100;
          var smin = s;
          var lmin = Math.max(l, 0.01);
          var sv;
          var v;
          l *= 2;
          s *= l <= 1 ? l : 2 - l;
          smin *= lmin <= 1 ? lmin : 2 - lmin;
          v = (l + s) / 2;
          sv = l === 0 ? 2 * smin / (lmin + smin) : 2 * s / (l + s);
          return [h, sv * 100, v * 100];
        };
        convert4.hsv.rgb = function(hsv) {
          var h = hsv[0] / 60;
          var s = hsv[1] / 100;
          var v = hsv[2] / 100;
          var hi = Math.floor(h) % 6;
          var f = h - Math.floor(h);
          var p = 255 * v * (1 - s);
          var q = 255 * v * (1 - s * f);
          var t = 255 * v * (1 - s * (1 - f));
          v *= 255;
          switch (hi) {
            case 0:
              return [v, t, p];
            case 1:
              return [q, v, p];
            case 2:
              return [p, v, t];
            case 3:
              return [p, q, v];
            case 4:
              return [t, p, v];
            case 5:
              return [v, p, q];
          }
        };
        convert4.hsv.hsl = function(hsv) {
          var h = hsv[0];
          var s = hsv[1] / 100;
          var v = hsv[2] / 100;
          var vmin = Math.max(v, 0.01);
          var lmin;
          var sl;
          var l;
          l = (2 - s) * v;
          lmin = (2 - s) * vmin;
          sl = s * vmin;
          sl /= lmin <= 1 ? lmin : 2 - lmin;
          sl = sl || 0;
          l /= 2;
          return [h, sl * 100, l * 100];
        };
        convert4.hwb.rgb = function(hwb) {
          var h = hwb[0] / 360;
          var wh = hwb[1] / 100;
          var bl = hwb[2] / 100;
          var ratio = wh + bl;
          var i;
          var v;
          var f;
          var n;
          if (ratio > 1) {
            wh /= ratio;
            bl /= ratio;
          }
          i = Math.floor(6 * h);
          v = 1 - bl;
          f = 6 * h - i;
          if ((i & 1) !== 0) {
            f = 1 - f;
          }
          n = wh + f * (v - wh);
          var r;
          var g;
          var b;
          switch (i) {
            default:
            case 6:
            case 0:
              r = v;
              g = n;
              b = wh;
              break;
            case 1:
              r = n;
              g = v;
              b = wh;
              break;
            case 2:
              r = wh;
              g = v;
              b = n;
              break;
            case 3:
              r = wh;
              g = n;
              b = v;
              break;
            case 4:
              r = n;
              g = wh;
              b = v;
              break;
            case 5:
              r = v;
              g = wh;
              b = n;
              break;
          }
          return [r * 255, g * 255, b * 255];
        };
        convert4.cmyk.rgb = function(cmyk) {
          var c = cmyk[0] / 100;
          var m = cmyk[1] / 100;
          var y = cmyk[2] / 100;
          var k = cmyk[3] / 100;
          var r;
          var g;
          var b;
          r = 1 - Math.min(1, c * (1 - k) + k);
          g = 1 - Math.min(1, m * (1 - k) + k);
          b = 1 - Math.min(1, y * (1 - k) + k);
          return [r * 255, g * 255, b * 255];
        };
        convert4.xyz.rgb = function(xyz) {
          var x = xyz[0] / 100;
          var y = xyz[1] / 100;
          var z2 = xyz[2] / 100;
          var r;
          var g;
          var b;
          r = x * 3.2406 + y * -1.5372 + z2 * -0.4986;
          g = x * -0.9689 + y * 1.8758 + z2 * 0.0415;
          b = x * 0.0557 + y * -0.204 + z2 * 1.057;
          r = r > 31308e-7 ? 1.055 * Math.pow(r, 1 / 2.4) - 0.055 : r * 12.92;
          g = g > 31308e-7 ? 1.055 * Math.pow(g, 1 / 2.4) - 0.055 : g * 12.92;
          b = b > 31308e-7 ? 1.055 * Math.pow(b, 1 / 2.4) - 0.055 : b * 12.92;
          r = Math.min(Math.max(0, r), 1);
          g = Math.min(Math.max(0, g), 1);
          b = Math.min(Math.max(0, b), 1);
          return [r * 255, g * 255, b * 255];
        };
        convert4.xyz.lab = function(xyz) {
          var x = xyz[0];
          var y = xyz[1];
          var z2 = xyz[2];
          var l;
          var a;
          var b;
          x /= 95.047;
          y /= 100;
          z2 /= 108.883;
          x = x > 8856e-6 ? Math.pow(x, 1 / 3) : 7.787 * x + 16 / 116;
          y = y > 8856e-6 ? Math.pow(y, 1 / 3) : 7.787 * y + 16 / 116;
          z2 = z2 > 8856e-6 ? Math.pow(z2, 1 / 3) : 7.787 * z2 + 16 / 116;
          l = 116 * y - 16;
          a = 500 * (x - y);
          b = 200 * (y - z2);
          return [l, a, b];
        };
        convert4.lab.xyz = function(lab) {
          var l = lab[0];
          var a = lab[1];
          var b = lab[2];
          var x;
          var y;
          var z2;
          y = (l + 16) / 116;
          x = a / 500 + y;
          z2 = y - b / 200;
          var y2 = Math.pow(y, 3);
          var x2 = Math.pow(x, 3);
          var z22 = Math.pow(z2, 3);
          y = y2 > 8856e-6 ? y2 : (y - 16 / 116) / 7.787;
          x = x2 > 8856e-6 ? x2 : (x - 16 / 116) / 7.787;
          z2 = z22 > 8856e-6 ? z22 : (z2 - 16 / 116) / 7.787;
          x *= 95.047;
          y *= 100;
          z2 *= 108.883;
          return [x, y, z2];
        };
        convert4.lab.lch = function(lab) {
          var l = lab[0];
          var a = lab[1];
          var b = lab[2];
          var hr;
          var h;
          var c;
          hr = Math.atan2(b, a);
          h = hr * 360 / 2 / Math.PI;
          if (h < 0) {
            h += 360;
          }
          c = Math.sqrt(a * a + b * b);
          return [l, c, h];
        };
        convert4.lch.lab = function(lch) {
          var l = lch[0];
          var c = lch[1];
          var h = lch[2];
          var a;
          var b;
          var hr;
          hr = h / 360 * 2 * Math.PI;
          a = c * Math.cos(hr);
          b = c * Math.sin(hr);
          return [l, a, b];
        };
        convert4.rgb.ansi16 = function(args) {
          var r = args[0];
          var g = args[1];
          var b = args[2];
          var value = 1 in arguments ? arguments[1] : convert4.rgb.hsv(args)[2];
          value = Math.round(value / 50);
          if (value === 0) {
            return 30;
          }
          var ansi = 30 + (Math.round(b / 255) << 2 | Math.round(g / 255) << 1 | Math.round(r / 255));
          if (value === 2) {
            ansi += 60;
          }
          return ansi;
        };
        convert4.hsv.ansi16 = function(args) {
          return convert4.rgb.ansi16(convert4.hsv.rgb(args), args[2]);
        };
        convert4.rgb.ansi256 = function(args) {
          var r = args[0];
          var g = args[1];
          var b = args[2];
          if (r === g && g === b) {
            if (r < 8) {
              return 16;
            }
            if (r > 248) {
              return 231;
            }
            return Math.round((r - 8) / 247 * 24) + 232;
          }
          var ansi = 16 + 36 * Math.round(r / 255 * 5) + 6 * Math.round(g / 255 * 5) + Math.round(b / 255 * 5);
          return ansi;
        };
        convert4.ansi16.rgb = function(args) {
          var color = args % 10;
          if (color === 0 || color === 7) {
            if (args > 50) {
              color += 3.5;
            }
            color = color / 10.5 * 255;
            return [color, color, color];
          }
          var mult = (~~(args > 50) + 1) * 0.5;
          var r = (color & 1) * mult * 255;
          var g = (color >> 1 & 1) * mult * 255;
          var b = (color >> 2 & 1) * mult * 255;
          return [r, g, b];
        };
        convert4.ansi256.rgb = function(args) {
          if (args >= 232) {
            var c = (args - 232) * 10 + 8;
            return [c, c, c];
          }
          args -= 16;
          var rem;
          var r = Math.floor(args / 36) / 5 * 255;
          var g = Math.floor((rem = args % 36) / 6) / 5 * 255;
          var b = rem % 6 / 5 * 255;
          return [r, g, b];
        };
        convert4.rgb.hex = function(args) {
          var integer = ((Math.round(args[0]) & 255) << 16) + ((Math.round(args[1]) & 255) << 8) + (Math.round(args[2]) & 255);
          var string3 = integer.toString(16).toUpperCase();
          return "000000".substring(string3.length) + string3;
        };
        convert4.hex.rgb = function(args) {
          var match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
          if (!match) {
            return [0, 0, 0];
          }
          var colorString = match[0];
          if (match[0].length === 3) {
            colorString = colorString.split("").map(function(char) {
              return char + char;
            }).join("");
          }
          var integer = parseInt(colorString, 16);
          var r = integer >> 16 & 255;
          var g = integer >> 8 & 255;
          var b = integer & 255;
          return [r, g, b];
        };
        convert4.rgb.hcg = function(rgb) {
          var r = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          var max = Math.max(Math.max(r, g), b);
          var min = Math.min(Math.min(r, g), b);
          var chroma = max - min;
          var grayscale;
          var hue;
          if (chroma < 1) {
            grayscale = min / (1 - chroma);
          } else {
            grayscale = 0;
          }
          if (chroma <= 0) {
            hue = 0;
          } else if (max === r) {
            hue = (g - b) / chroma % 6;
          } else if (max === g) {
            hue = 2 + (b - r) / chroma;
          } else {
            hue = 4 + (r - g) / chroma + 4;
          }
          hue /= 6;
          hue %= 1;
          return [hue * 360, chroma * 100, grayscale * 100];
        };
        convert4.hsl.hcg = function(hsl) {
          var s = hsl[1] / 100;
          var l = hsl[2] / 100;
          var c = 1;
          var f = 0;
          if (l < 0.5) {
            c = 2 * s * l;
          } else {
            c = 2 * s * (1 - l);
          }
          if (c < 1) {
            f = (l - 0.5 * c) / (1 - c);
          }
          return [hsl[0], c * 100, f * 100];
        };
        convert4.hsv.hcg = function(hsv) {
          var s = hsv[1] / 100;
          var v = hsv[2] / 100;
          var c = s * v;
          var f = 0;
          if (c < 1) {
            f = (v - c) / (1 - c);
          }
          return [hsv[0], c * 100, f * 100];
        };
        convert4.hcg.rgb = function(hcg) {
          var h = hcg[0] / 360;
          var c = hcg[1] / 100;
          var g = hcg[2] / 100;
          if (c === 0) {
            return [g * 255, g * 255, g * 255];
          }
          var pure = [0, 0, 0];
          var hi = h % 1 * 6;
          var v = hi % 1;
          var w = 1 - v;
          var mg = 0;
          switch (Math.floor(hi)) {
            case 0:
              pure[0] = 1;
              pure[1] = v;
              pure[2] = 0;
              break;
            case 1:
              pure[0] = w;
              pure[1] = 1;
              pure[2] = 0;
              break;
            case 2:
              pure[0] = 0;
              pure[1] = 1;
              pure[2] = v;
              break;
            case 3:
              pure[0] = 0;
              pure[1] = w;
              pure[2] = 1;
              break;
            case 4:
              pure[0] = v;
              pure[1] = 0;
              pure[2] = 1;
              break;
            default:
              pure[0] = 1;
              pure[1] = 0;
              pure[2] = w;
          }
          mg = (1 - c) * g;
          return [(c * pure[0] + mg) * 255, (c * pure[1] + mg) * 255, (c * pure[2] + mg) * 255];
        };
        convert4.hcg.hsv = function(hcg) {
          var c = hcg[1] / 100;
          var g = hcg[2] / 100;
          var v = c + g * (1 - c);
          var f = 0;
          if (v > 0) {
            f = c / v;
          }
          return [hcg[0], f * 100, v * 100];
        };
        convert4.hcg.hsl = function(hcg) {
          var c = hcg[1] / 100;
          var g = hcg[2] / 100;
          var l = g * (1 - c) + 0.5 * c;
          var s = 0;
          if (l > 0 && l < 0.5) {
            s = c / (2 * l);
          } else if (l >= 0.5 && l < 1) {
            s = c / (2 * (1 - l));
          }
          return [hcg[0], s * 100, l * 100];
        };
        convert4.hcg.hwb = function(hcg) {
          var c = hcg[1] / 100;
          var g = hcg[2] / 100;
          var v = c + g * (1 - c);
          return [hcg[0], (v - c) * 100, (1 - v) * 100];
        };
        convert4.hwb.hcg = function(hwb) {
          var w = hwb[1] / 100;
          var b = hwb[2] / 100;
          var v = 1 - b;
          var c = v - w;
          var g = 0;
          if (c < 1) {
            g = (v - c) / (1 - c);
          }
          return [hwb[0], c * 100, g * 100];
        };
        convert4.apple.rgb = function(apple) {
          return [apple[0] / 65535 * 255, apple[1] / 65535 * 255, apple[2] / 65535 * 255];
        };
        convert4.rgb.apple = function(rgb) {
          return [rgb[0] / 255 * 65535, rgb[1] / 255 * 65535, rgb[2] / 255 * 65535];
        };
        convert4.gray.rgb = function(args) {
          return [args[0] / 100 * 255, args[0] / 100 * 255, args[0] / 100 * 255];
        };
        convert4.gray.hsl = convert4.gray.hsv = function(args) {
          return [0, 0, args[0]];
        };
        convert4.gray.hwb = function(gray) {
          return [0, 100, gray[0]];
        };
        convert4.gray.cmyk = function(gray) {
          return [0, 0, 0, gray[0]];
        };
        convert4.gray.lab = function(gray) {
          return [gray[0], 0, 0];
        };
        convert4.gray.hex = function(gray) {
          var val = Math.round(gray[0] / 100 * 255) & 255;
          var integer = (val << 16) + (val << 8) + val;
          var string3 = integer.toString(16).toUpperCase();
          return "000000".substring(string3.length) + string3;
        };
        convert4.rgb.gray = function(rgb) {
          var val = (rgb[0] + rgb[1] + rgb[2]) / 3;
          return [val / 255 * 100];
        };
      }
    });
    var require_route = __commonJS2({
      "node_modules/color-convert/route.js"(exports22, module22) {
        var conversions = require_conversions();
        function buildGraph() {
          var graph = {};
          var models = Object.keys(conversions);
          for (var len = models.length, i = 0; i < len; i++) {
            graph[models[i]] = {
              distance: -1,
              parent: null
            };
          }
          return graph;
        }
        function deriveBFS(fromModel) {
          var graph = buildGraph();
          var queue = [fromModel];
          graph[fromModel].distance = 0;
          while (queue.length) {
            var current = queue.pop();
            var adjacents = Object.keys(conversions[current]);
            for (var len = adjacents.length, i = 0; i < len; i++) {
              var adjacent = adjacents[i];
              var node = graph[adjacent];
              if (node.distance === -1) {
                node.distance = graph[current].distance + 1;
                node.parent = current;
                queue.unshift(adjacent);
              }
            }
          }
          return graph;
        }
        function link(from, to) {
          return function(args) {
            return to(from(args));
          };
        }
        function wrapConversion(toModel, graph) {
          var path5 = [graph[toModel].parent, toModel];
          var fn = conversions[graph[toModel].parent][toModel];
          var cur = graph[toModel].parent;
          while (graph[cur].parent) {
            path5.unshift(graph[cur].parent);
            fn = link(conversions[graph[cur].parent][cur], fn);
            cur = graph[cur].parent;
          }
          fn.conversion = path5;
          return fn;
        }
        module22.exports = function(fromModel) {
          var graph = deriveBFS(fromModel);
          var conversion = {};
          var models = Object.keys(graph);
          for (var len = models.length, i = 0; i < len; i++) {
            var toModel = models[i];
            var node = graph[toModel];
            if (node.parent === null) {
              continue;
            }
            conversion[toModel] = wrapConversion(toModel, graph);
          }
          return conversion;
        };
      }
    });
    var require_color_convert = __commonJS2({
      "node_modules/color-convert/index.js"(exports22, module22) {
        var conversions = require_conversions();
        var route = require_route();
        var convert4 = {};
        var models = Object.keys(conversions);
        function wrapRaw(fn) {
          var wrappedFn = function(args) {
            if (args === void 0 || args === null) {
              return args;
            }
            if (arguments.length > 1) {
              args = Array.prototype.slice.call(arguments);
            }
            return fn(args);
          };
          if ("conversion" in fn) {
            wrappedFn.conversion = fn.conversion;
          }
          return wrappedFn;
        }
        function wrapRounded(fn) {
          var wrappedFn = function(args) {
            if (args === void 0 || args === null) {
              return args;
            }
            if (arguments.length > 1) {
              args = Array.prototype.slice.call(arguments);
            }
            var result = fn(args);
            if (typeof result === "object") {
              for (var len = result.length, i = 0; i < len; i++) {
                result[i] = Math.round(result[i]);
              }
            }
            return result;
          };
          if ("conversion" in fn) {
            wrappedFn.conversion = fn.conversion;
          }
          return wrappedFn;
        }
        models.forEach(function(fromModel) {
          convert4[fromModel] = {};
          Object.defineProperty(convert4[fromModel], "channels", {
            value: conversions[fromModel].channels
          });
          Object.defineProperty(convert4[fromModel], "labels", {
            value: conversions[fromModel].labels
          });
          var routes = route(fromModel);
          var routeModels = Object.keys(routes);
          routeModels.forEach(function(toModel) {
            var fn = routes[toModel];
            convert4[fromModel][toModel] = wrapRounded(fn);
            convert4[fromModel][toModel].raw = wrapRaw(fn);
          });
        });
        module22.exports = convert4;
      }
    });
    var require_ansi_styles = __commonJS2({
      "node_modules/ansi-styles/index.js"(exports22, module22) {
        "use strict";
        var colorConvert = require_color_convert();
        var wrapAnsi16 = (fn, offset) => function() {
          const code = fn.apply(colorConvert, arguments);
          return `\x1B[${code + offset}m`;
        };
        var wrapAnsi256 = (fn, offset) => function() {
          const code = fn.apply(colorConvert, arguments);
          return `\x1B[${38 + offset};5;${code}m`;
        };
        var wrapAnsi16m = (fn, offset) => function() {
          const rgb = fn.apply(colorConvert, arguments);
          return `\x1B[${38 + offset};2;${rgb[0]};${rgb[1]};${rgb[2]}m`;
        };
        function assembleStyles() {
          const codes = /* @__PURE__ */ new Map();
          const styles = {
            modifier: {
              reset: [0, 0],
              bold: [1, 22],
              dim: [2, 22],
              italic: [3, 23],
              underline: [4, 24],
              inverse: [7, 27],
              hidden: [8, 28],
              strikethrough: [9, 29]
            },
            color: {
              black: [30, 39],
              red: [31, 39],
              green: [32, 39],
              yellow: [33, 39],
              blue: [34, 39],
              magenta: [35, 39],
              cyan: [36, 39],
              white: [37, 39],
              gray: [90, 39],
              redBright: [91, 39],
              greenBright: [92, 39],
              yellowBright: [93, 39],
              blueBright: [94, 39],
              magentaBright: [95, 39],
              cyanBright: [96, 39],
              whiteBright: [97, 39]
            },
            bgColor: {
              bgBlack: [40, 49],
              bgRed: [41, 49],
              bgGreen: [42, 49],
              bgYellow: [43, 49],
              bgBlue: [44, 49],
              bgMagenta: [45, 49],
              bgCyan: [46, 49],
              bgWhite: [47, 49],
              bgBlackBright: [100, 49],
              bgRedBright: [101, 49],
              bgGreenBright: [102, 49],
              bgYellowBright: [103, 49],
              bgBlueBright: [104, 49],
              bgMagentaBright: [105, 49],
              bgCyanBright: [106, 49],
              bgWhiteBright: [107, 49]
            }
          };
          styles.color.grey = styles.color.gray;
          for (const groupName of Object.keys(styles)) {
            const group = styles[groupName];
            for (const styleName of Object.keys(group)) {
              const style = group[styleName];
              styles[styleName] = {
                open: `\x1B[${style[0]}m`,
                close: `\x1B[${style[1]}m`
              };
              group[styleName] = styles[styleName];
              codes.set(style[0], style[1]);
            }
            Object.defineProperty(styles, groupName, {
              value: group,
              enumerable: false
            });
            Object.defineProperty(styles, "codes", {
              value: codes,
              enumerable: false
            });
          }
          const ansi2ansi = (n) => n;
          const rgb2rgb = (r, g, b) => [r, g, b];
          styles.color.close = "\x1B[39m";
          styles.bgColor.close = "\x1B[49m";
          styles.color.ansi = {
            ansi: wrapAnsi16(ansi2ansi, 0)
          };
          styles.color.ansi256 = {
            ansi256: wrapAnsi256(ansi2ansi, 0)
          };
          styles.color.ansi16m = {
            rgb: wrapAnsi16m(rgb2rgb, 0)
          };
          styles.bgColor.ansi = {
            ansi: wrapAnsi16(ansi2ansi, 10)
          };
          styles.bgColor.ansi256 = {
            ansi256: wrapAnsi256(ansi2ansi, 10)
          };
          styles.bgColor.ansi16m = {
            rgb: wrapAnsi16m(rgb2rgb, 10)
          };
          for (let key of Object.keys(colorConvert)) {
            if (typeof colorConvert[key] !== "object") {
              continue;
            }
            const suite = colorConvert[key];
            if (key === "ansi16") {
              key = "ansi";
            }
            if ("ansi16" in suite) {
              styles.color.ansi[key] = wrapAnsi16(suite.ansi16, 0);
              styles.bgColor.ansi[key] = wrapAnsi16(suite.ansi16, 10);
            }
            if ("ansi256" in suite) {
              styles.color.ansi256[key] = wrapAnsi256(suite.ansi256, 0);
              styles.bgColor.ansi256[key] = wrapAnsi256(suite.ansi256, 10);
            }
            if ("rgb" in suite) {
              styles.color.ansi16m[key] = wrapAnsi16m(suite.rgb, 0);
              styles.bgColor.ansi16m[key] = wrapAnsi16m(suite.rgb, 10);
            }
          }
          return styles;
        }
        Object.defineProperty(module22, "exports", {
          enumerable: true,
          get: assembleStyles
        });
      }
    });
    var require_has_flag = __commonJS2({
      "node_modules/@babel/highlight/node_modules/has-flag/index.js"(exports22, module22) {
        "use strict";
        module22.exports = (flag, argv) => {
          argv = argv || process.argv;
          const prefix = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
          const pos = argv.indexOf(prefix + flag);
          const terminatorPos = argv.indexOf("--");
          return pos !== -1 && (terminatorPos === -1 ? true : pos < terminatorPos);
        };
      }
    });
    var require_supports_color = __commonJS2({
      "node_modules/@babel/highlight/node_modules/supports-color/index.js"(exports22, module22) {
        "use strict";
        var os = require("os");
        var hasFlag = require_has_flag();
        var env = process.env;
        var forceColor;
        if (hasFlag("no-color") || hasFlag("no-colors") || hasFlag("color=false")) {
          forceColor = false;
        } else if (hasFlag("color") || hasFlag("colors") || hasFlag("color=true") || hasFlag("color=always")) {
          forceColor = true;
        }
        if ("FORCE_COLOR" in env) {
          forceColor = env.FORCE_COLOR.length === 0 || parseInt(env.FORCE_COLOR, 10) !== 0;
        }
        function translateLevel(level) {
          if (level === 0) {
            return false;
          }
          return {
            level,
            hasBasic: true,
            has256: level >= 2,
            has16m: level >= 3
          };
        }
        function supportsColor(stream) {
          if (forceColor === false) {
            return 0;
          }
          if (hasFlag("color=16m") || hasFlag("color=full") || hasFlag("color=truecolor")) {
            return 3;
          }
          if (hasFlag("color=256")) {
            return 2;
          }
          if (stream && !stream.isTTY && forceColor !== true) {
            return 0;
          }
          const min = forceColor ? 1 : 0;
          if (process.platform === "win32") {
            const osRelease = os.release().split(".");
            if (Number(process.versions.node.split(".")[0]) >= 8 && Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
              return Number(osRelease[2]) >= 14931 ? 3 : 2;
            }
            return 1;
          }
          if ("CI" in env) {
            if (["TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI"].some((sign) => sign in env) || env.CI_NAME === "codeship") {
              return 1;
            }
            return min;
          }
          if ("TEAMCITY_VERSION" in env) {
            return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
          }
          if (env.COLORTERM === "truecolor") {
            return 3;
          }
          if ("TERM_PROGRAM" in env) {
            const version = parseInt((env.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
            switch (env.TERM_PROGRAM) {
              case "iTerm.app":
                return version >= 3 ? 3 : 2;
              case "Apple_Terminal":
                return 2;
            }
          }
          if (/-256(color)?$/i.test(env.TERM)) {
            return 2;
          }
          if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
            return 1;
          }
          if ("COLORTERM" in env) {
            return 1;
          }
          if (env.TERM === "dumb") {
            return min;
          }
          return min;
        }
        function getSupportLevel(stream) {
          const level = supportsColor(stream);
          return translateLevel(level);
        }
        module22.exports = {
          supportsColor: getSupportLevel,
          stdout: getSupportLevel(process.stdout),
          stderr: getSupportLevel(process.stderr)
        };
      }
    });
    var require_templates = __commonJS2({
      "node_modules/@babel/highlight/node_modules/chalk/templates.js"(exports22, module22) {
        "use strict";
        var TEMPLATE_REGEX = /(?:\\(u[a-f\d]{4}|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
        var STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
        var STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
        var ESCAPE_REGEX = /\\(u[a-f\d]{4}|x[a-f\d]{2}|.)|([^\\])/gi;
        var ESCAPES = /* @__PURE__ */ new Map([["n", "\n"], ["r", "\r"], ["t", "	"], ["b", "\b"], ["f", "\f"], ["v", "\v"], ["0", "\0"], ["\\", "\\"], ["e", "\x1B"], ["a", "\x07"]]);
        function unescape(c) {
          if (c[0] === "u" && c.length === 5 || c[0] === "x" && c.length === 3) {
            return String.fromCharCode(parseInt(c.slice(1), 16));
          }
          return ESCAPES.get(c) || c;
        }
        function parseArguments(name, args) {
          const results = [];
          const chunks = args.trim().split(/\s*,\s*/g);
          let matches;
          for (const chunk of chunks) {
            if (!isNaN(chunk)) {
              results.push(Number(chunk));
            } else if (matches = chunk.match(STRING_REGEX)) {
              results.push(matches[2].replace(ESCAPE_REGEX, (m, escape, chr) => escape ? unescape(escape) : chr));
            } else {
              throw new Error(`Invalid Chalk template style argument: ${chunk} (in style '${name}')`);
            }
          }
          return results;
        }
        function parseStyle(style) {
          STYLE_REGEX.lastIndex = 0;
          const results = [];
          let matches;
          while ((matches = STYLE_REGEX.exec(style)) !== null) {
            const name = matches[1];
            if (matches[2]) {
              const args = parseArguments(name, matches[2]);
              results.push([name].concat(args));
            } else {
              results.push([name]);
            }
          }
          return results;
        }
        function buildStyle(chalk, styles) {
          const enabled = {};
          for (const layer of styles) {
            for (const style of layer.styles) {
              enabled[style[0]] = layer.inverse ? null : style.slice(1);
            }
          }
          let current = chalk;
          for (const styleName of Object.keys(enabled)) {
            if (Array.isArray(enabled[styleName])) {
              if (!(styleName in current)) {
                throw new Error(`Unknown Chalk style: ${styleName}`);
              }
              if (enabled[styleName].length > 0) {
                current = current[styleName].apply(current, enabled[styleName]);
              } else {
                current = current[styleName];
              }
            }
          }
          return current;
        }
        module22.exports = (chalk, tmp) => {
          const styles = [];
          const chunks = [];
          let chunk = [];
          tmp.replace(TEMPLATE_REGEX, (m, escapeChar, inverse, style, close, chr) => {
            if (escapeChar) {
              chunk.push(unescape(escapeChar));
            } else if (style) {
              const str2 = chunk.join("");
              chunk = [];
              chunks.push(styles.length === 0 ? str2 : buildStyle(chalk, styles)(str2));
              styles.push({
                inverse,
                styles: parseStyle(style)
              });
            } else if (close) {
              if (styles.length === 0) {
                throw new Error("Found extraneous } in Chalk template literal");
              }
              chunks.push(buildStyle(chalk, styles)(chunk.join("")));
              chunk = [];
              styles.pop();
            } else {
              chunk.push(chr);
            }
          });
          chunks.push(chunk.join(""));
          if (styles.length > 0) {
            const errMsg = `Chalk template literal is missing ${styles.length} closing bracket${styles.length === 1 ? "" : "s"} (\`}\`)`;
            throw new Error(errMsg);
          }
          return chunks.join("");
        };
      }
    });
    var require_chalk = __commonJS2({
      "node_modules/@babel/highlight/node_modules/chalk/index.js"(exports22, module22) {
        "use strict";
        var escapeStringRegexp = require_escape_string_regexp();
        var ansiStyles = require_ansi_styles();
        var stdoutColor = require_supports_color().stdout;
        var template = require_templates();
        var isSimpleWindowsTerm = process.platform === "win32" && !(process.env.TERM || "").toLowerCase().startsWith("xterm");
        var levelMapping = ["ansi", "ansi", "ansi256", "ansi16m"];
        var skipModels = /* @__PURE__ */ new Set(["gray"]);
        var styles = /* @__PURE__ */ Object.create(null);
        function applyOptions(obj, options) {
          options = options || {};
          const scLevel = stdoutColor ? stdoutColor.level : 0;
          obj.level = options.level === void 0 ? scLevel : options.level;
          obj.enabled = "enabled" in options ? options.enabled : obj.level > 0;
        }
        function Chalk(options) {
          if (!this || !(this instanceof Chalk) || this.template) {
            const chalk = {};
            applyOptions(chalk, options);
            chalk.template = function() {
              const args = [].slice.call(arguments);
              return chalkTag.apply(null, [chalk.template].concat(args));
            };
            Object.setPrototypeOf(chalk, Chalk.prototype);
            Object.setPrototypeOf(chalk.template, chalk);
            chalk.template.constructor = Chalk;
            return chalk.template;
          }
          applyOptions(this, options);
        }
        if (isSimpleWindowsTerm) {
          ansiStyles.blue.open = "\x1B[94m";
        }
        for (const key of Object.keys(ansiStyles)) {
          ansiStyles[key].closeRe = new RegExp(escapeStringRegexp(ansiStyles[key].close), "g");
          styles[key] = {
            get() {
              const codes = ansiStyles[key];
              return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, key);
            }
          };
        }
        styles.visible = {
          get() {
            return build.call(this, this._styles || [], true, "visible");
          }
        };
        ansiStyles.color.closeRe = new RegExp(escapeStringRegexp(ansiStyles.color.close), "g");
        for (const model of Object.keys(ansiStyles.color.ansi)) {
          if (skipModels.has(model)) {
            continue;
          }
          styles[model] = {
            get() {
              const level = this.level;
              return function() {
                const open = ansiStyles.color[levelMapping[level]][model].apply(null, arguments);
                const codes = {
                  open,
                  close: ansiStyles.color.close,
                  closeRe: ansiStyles.color.closeRe
                };
                return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
              };
            }
          };
        }
        ansiStyles.bgColor.closeRe = new RegExp(escapeStringRegexp(ansiStyles.bgColor.close), "g");
        for (const model of Object.keys(ansiStyles.bgColor.ansi)) {
          if (skipModels.has(model)) {
            continue;
          }
          const bgModel = "bg" + model[0].toUpperCase() + model.slice(1);
          styles[bgModel] = {
            get() {
              const level = this.level;
              return function() {
                const open = ansiStyles.bgColor[levelMapping[level]][model].apply(null, arguments);
                const codes = {
                  open,
                  close: ansiStyles.bgColor.close,
                  closeRe: ansiStyles.bgColor.closeRe
                };
                return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
              };
            }
          };
        }
        var proto = Object.defineProperties(() => {
        }, styles);
        function build(_styles, _empty, key) {
          const builder = function() {
            return applyStyle.apply(builder, arguments);
          };
          builder._styles = _styles;
          builder._empty = _empty;
          const self2 = this;
          Object.defineProperty(builder, "level", {
            enumerable: true,
            get() {
              return self2.level;
            },
            set(level) {
              self2.level = level;
            }
          });
          Object.defineProperty(builder, "enabled", {
            enumerable: true,
            get() {
              return self2.enabled;
            },
            set(enabled) {
              self2.enabled = enabled;
            }
          });
          builder.hasGrey = this.hasGrey || key === "gray" || key === "grey";
          builder.__proto__ = proto;
          return builder;
        }
        function applyStyle() {
          const args = arguments;
          const argsLen = args.length;
          let str2 = String(arguments[0]);
          if (argsLen === 0) {
            return "";
          }
          if (argsLen > 1) {
            for (let a = 1; a < argsLen; a++) {
              str2 += " " + args[a];
            }
          }
          if (!this.enabled || this.level <= 0 || !str2) {
            return this._empty ? "" : str2;
          }
          const originalDim = ansiStyles.dim.open;
          if (isSimpleWindowsTerm && this.hasGrey) {
            ansiStyles.dim.open = "";
          }
          for (const code of this._styles.slice().reverse()) {
            str2 = code.open + str2.replace(code.closeRe, code.open) + code.close;
            str2 = str2.replace(/\r?\n/g, `${code.close}$&${code.open}`);
          }
          ansiStyles.dim.open = originalDim;
          return str2;
        }
        function chalkTag(chalk, strings) {
          if (!Array.isArray(strings)) {
            return [].slice.call(arguments, 1).join(" ");
          }
          const args = [].slice.call(arguments, 2);
          const parts = [strings.raw[0]];
          for (let i = 1; i < strings.length; i++) {
            parts.push(String(args[i - 1]).replace(/[{}\\]/g, "\\$&"));
            parts.push(String(strings.raw[i]));
          }
          return template(chalk, parts.join(""));
        }
        Object.defineProperties(Chalk.prototype, styles);
        module22.exports = Chalk();
        module22.exports.supportsColor = stdoutColor;
        module22.exports.default = module22.exports;
      }
    });
    var require_lib22 = __commonJS2({
      "node_modules/@babel/highlight/lib/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.default = highlight;
        exports22.getChalk = getChalk;
        exports22.shouldHighlight = shouldHighlight;
        var _jsTokens = require_js_tokens();
        var _helperValidatorIdentifier = require_lib4();
        var _chalk = require_chalk();
        var sometimesKeywords = /* @__PURE__ */ new Set(["as", "async", "from", "get", "of", "set"]);
        function getDefs(chalk) {
          return {
            keyword: chalk.cyan,
            capitalized: chalk.yellow,
            jsxIdentifier: chalk.yellow,
            punctuator: chalk.yellow,
            number: chalk.magenta,
            string: chalk.green,
            regex: chalk.magenta,
            comment: chalk.grey,
            invalid: chalk.white.bgRed.bold
          };
        }
        var NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
        var BRACKET = /^[()[\]{}]$/;
        var tokenize;
        {
          const JSX_TAG = /^[a-z][\w-]*$/i;
          const getTokenType = function(token, offset, text) {
            if (token.type === "name") {
              if ((0, _helperValidatorIdentifier.isKeyword)(token.value) || (0, _helperValidatorIdentifier.isStrictReservedWord)(token.value, true) || sometimesKeywords.has(token.value)) {
                return "keyword";
              }
              if (JSX_TAG.test(token.value) && (text[offset - 1] === "<" || text.substr(offset - 2, 2) == "</")) {
                return "jsxIdentifier";
              }
              if (token.value[0] !== token.value[0].toLowerCase()) {
                return "capitalized";
              }
            }
            if (token.type === "punctuator" && BRACKET.test(token.value)) {
              return "bracket";
            }
            if (token.type === "invalid" && (token.value === "@" || token.value === "#")) {
              return "punctuator";
            }
            return token.type;
          };
          tokenize = function* (text) {
            let match;
            while (match = _jsTokens.default.exec(text)) {
              const token = _jsTokens.matchToToken(match);
              yield {
                type: getTokenType(token, match.index, text),
                value: token.value
              };
            }
          };
        }
        function highlightTokens(defs, text) {
          let highlighted = "";
          for (const {
            type: type2,
            value
          } of tokenize(text)) {
            const colorize = defs[type2];
            if (colorize) {
              highlighted += value.split(NEWLINE).map((str2) => colorize(str2)).join("\n");
            } else {
              highlighted += value;
            }
          }
          return highlighted;
        }
        function shouldHighlight(options) {
          return !!_chalk.supportsColor || options.forceColor;
        }
        function getChalk(options) {
          return options.forceColor ? new _chalk.constructor({
            enabled: true,
            level: 1
          }) : _chalk;
        }
        function highlight(code, options = {}) {
          if (code !== "" && shouldHighlight(options)) {
            const chalk = getChalk(options);
            const defs = getDefs(chalk);
            return highlightTokens(defs, code);
          } else {
            return code;
          }
        }
      }
    });
    var require_lib32 = __commonJS2({
      "node_modules/@babel/code-frame/lib/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.codeFrameColumns = codeFrameColumns;
        exports22.default = _default2;
        var _highlight = require_lib22();
        var deprecationWarningShown = false;
        function getDefs(chalk) {
          return {
            gutter: chalk.grey,
            marker: chalk.red.bold,
            message: chalk.red.bold
          };
        }
        var NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
        function getMarkerLines(loc, source, opts) {
          const startLoc = Object.assign({
            column: 0,
            line: -1
          }, loc.start);
          const endLoc = Object.assign({}, startLoc, loc.end);
          const {
            linesAbove = 2,
            linesBelow = 3
          } = opts || {};
          const startLine = startLoc.line;
          const startColumn = startLoc.column;
          const endLine = endLoc.line;
          const endColumn = endLoc.column;
          let start = Math.max(startLine - (linesAbove + 1), 0);
          let end = Math.min(source.length, endLine + linesBelow);
          if (startLine === -1) {
            start = 0;
          }
          if (endLine === -1) {
            end = source.length;
          }
          const lineDiff = endLine - startLine;
          const markerLines = {};
          if (lineDiff) {
            for (let i = 0; i <= lineDiff; i++) {
              const lineNumber = i + startLine;
              if (!startColumn) {
                markerLines[lineNumber] = true;
              } else if (i === 0) {
                const sourceLength = source[lineNumber - 1].length;
                markerLines[lineNumber] = [startColumn, sourceLength - startColumn + 1];
              } else if (i === lineDiff) {
                markerLines[lineNumber] = [0, endColumn];
              } else {
                const sourceLength = source[lineNumber - i].length;
                markerLines[lineNumber] = [0, sourceLength];
              }
            }
          } else {
            if (startColumn === endColumn) {
              if (startColumn) {
                markerLines[startLine] = [startColumn, 0];
              } else {
                markerLines[startLine] = true;
              }
            } else {
              markerLines[startLine] = [startColumn, endColumn - startColumn];
            }
          }
          return {
            start,
            end,
            markerLines
          };
        }
        function codeFrameColumns(rawLines, loc, opts = {}) {
          const highlighted = (opts.highlightCode || opts.forceColor) && (0, _highlight.shouldHighlight)(opts);
          const chalk = (0, _highlight.getChalk)(opts);
          const defs = getDefs(chalk);
          const maybeHighlight = (chalkFn, string3) => {
            return highlighted ? chalkFn(string3) : string3;
          };
          const lines = rawLines.split(NEWLINE);
          const {
            start,
            end,
            markerLines
          } = getMarkerLines(loc, lines, opts);
          const hasColumns = loc.start && typeof loc.start.column === "number";
          const numberMaxWidth = String(end).length;
          const highlightedLines = highlighted ? (0, _highlight.default)(rawLines, opts) : rawLines;
          let frame = highlightedLines.split(NEWLINE, end).slice(start, end).map((line, index) => {
            const number3 = start + 1 + index;
            const paddedNumber = ` ${number3}`.slice(-numberMaxWidth);
            const gutter = ` ${paddedNumber} |`;
            const hasMarker = markerLines[number3];
            const lastMarkerLine = !markerLines[number3 + 1];
            if (hasMarker) {
              let markerLine = "";
              if (Array.isArray(hasMarker)) {
                const markerSpacing = line.slice(0, Math.max(hasMarker[0] - 1, 0)).replace(/[^\t]/g, " ");
                const numberOfMarkers = hasMarker[1] || 1;
                markerLine = ["\n ", maybeHighlight(defs.gutter, gutter.replace(/\d/g, " ")), " ", markerSpacing, maybeHighlight(defs.marker, "^").repeat(numberOfMarkers)].join("");
                if (lastMarkerLine && opts.message) {
                  markerLine += " " + maybeHighlight(defs.message, opts.message);
                }
              }
              return [maybeHighlight(defs.marker, ">"), maybeHighlight(defs.gutter, gutter), line.length > 0 ? ` ${line}` : "", markerLine].join("");
            } else {
              return ` ${maybeHighlight(defs.gutter, gutter)}${line.length > 0 ? ` ${line}` : ""}`;
            }
          }).join("\n");
          if (opts.message && !hasColumns) {
            frame = `${" ".repeat(numberMaxWidth + 1)}${opts.message}
${frame}`;
          }
          if (highlighted) {
            return chalk.reset(frame);
          } else {
            return frame;
          }
        }
        function _default2(rawLines, lineNumber, colNumber, opts = {}) {
          if (!deprecationWarningShown) {
            deprecationWarningShown = true;
            const message = "Passing lineNumber and colNumber is deprecated to @babel/code-frame. Please use `codeFrameColumns`.";
            if (process.emitWarning) {
              process.emitWarning(message, "DeprecationWarning");
            } else {
              const deprecationError = new Error(message);
              deprecationError.name = "DeprecationWarning";
              console.warn(new Error(message));
            }
          }
          colNumber = Math.max(colNumber, 0);
          const location = {
            start: {
              column: colNumber,
              line: lineNumber
            }
          };
          return codeFrameColumns(rawLines, location, opts);
        }
      }
    });
    var require_parse_json = __commonJS2({
      "node_modules/parse-json/index.js"(exports22, module22) {
        "use strict";
        var errorEx = require_error_ex();
        var fallback = require_json_parse_even_better_errors();
        var {
          default: LinesAndColumns
        } = require_build();
        var {
          codeFrameColumns
        } = require_lib32();
        var JSONError = errorEx("JSONError", {
          fileName: errorEx.append("in %s"),
          codeFrame: errorEx.append("\n\n%s\n")
        });
        var parseJson = (string3, reviver, filename) => {
          if (typeof reviver === "string") {
            filename = reviver;
            reviver = null;
          }
          try {
            try {
              return JSON.parse(string3, reviver);
            } catch (error) {
              fallback(string3, reviver);
              throw error;
            }
          } catch (error) {
            error.message = error.message.replace(/\n/g, "");
            const indexMatch = error.message.match(/in JSON at position (\d+) while parsing/);
            const jsonError = new JSONError(error);
            if (filename) {
              jsonError.fileName = filename;
            }
            if (indexMatch && indexMatch.length > 0) {
              const lines = new LinesAndColumns(string3);
              const index = Number(indexMatch[1]);
              const location = lines.locationForIndex(index);
              const codeFrame = codeFrameColumns(string3, {
                start: {
                  line: location.line + 1,
                  column: location.column + 1
                }
              }, {
                highlightCode: true
              });
              jsonError.codeFrame = codeFrame;
            }
            throw jsonError;
          }
        };
        parseJson.JSONError = JSONError;
        module22.exports = parseJson;
      }
    });
    var require_PlainValue_ec8e588e = __commonJS2({
      "node_modules/yaml/dist/PlainValue-ec8e588e.js"(exports22) {
        "use strict";
        var Char = {
          ANCHOR: "&",
          COMMENT: "#",
          TAG: "!",
          DIRECTIVES_END: "-",
          DOCUMENT_END: "."
        };
        var Type3 = {
          ALIAS: "ALIAS",
          BLANK_LINE: "BLANK_LINE",
          BLOCK_FOLDED: "BLOCK_FOLDED",
          BLOCK_LITERAL: "BLOCK_LITERAL",
          COMMENT: "COMMENT",
          DIRECTIVE: "DIRECTIVE",
          DOCUMENT: "DOCUMENT",
          FLOW_MAP: "FLOW_MAP",
          FLOW_SEQ: "FLOW_SEQ",
          MAP: "MAP",
          MAP_KEY: "MAP_KEY",
          MAP_VALUE: "MAP_VALUE",
          PLAIN: "PLAIN",
          QUOTE_DOUBLE: "QUOTE_DOUBLE",
          QUOTE_SINGLE: "QUOTE_SINGLE",
          SEQ: "SEQ",
          SEQ_ITEM: "SEQ_ITEM"
        };
        var defaultTagPrefix = "tag:yaml.org,2002:";
        var defaultTags = {
          MAP: "tag:yaml.org,2002:map",
          SEQ: "tag:yaml.org,2002:seq",
          STR: "tag:yaml.org,2002:str"
        };
        function findLineStarts(src) {
          const ls = [0];
          let offset = src.indexOf("\n");
          while (offset !== -1) {
            offset += 1;
            ls.push(offset);
            offset = src.indexOf("\n", offset);
          }
          return ls;
        }
        function getSrcInfo(cst) {
          let lineStarts, src;
          if (typeof cst === "string") {
            lineStarts = findLineStarts(cst);
            src = cst;
          } else {
            if (Array.isArray(cst))
              cst = cst[0];
            if (cst && cst.context) {
              if (!cst.lineStarts)
                cst.lineStarts = findLineStarts(cst.context.src);
              lineStarts = cst.lineStarts;
              src = cst.context.src;
            }
          }
          return {
            lineStarts,
            src
          };
        }
        function getLinePos(offset, cst) {
          if (typeof offset !== "number" || offset < 0)
            return null;
          const {
            lineStarts,
            src
          } = getSrcInfo(cst);
          if (!lineStarts || !src || offset > src.length)
            return null;
          for (let i = 0; i < lineStarts.length; ++i) {
            const start = lineStarts[i];
            if (offset < start) {
              return {
                line: i,
                col: offset - lineStarts[i - 1] + 1
              };
            }
            if (offset === start)
              return {
                line: i + 1,
                col: 1
              };
          }
          const line = lineStarts.length;
          return {
            line,
            col: offset - lineStarts[line - 1] + 1
          };
        }
        function getLine2(line, cst) {
          const {
            lineStarts,
            src
          } = getSrcInfo(cst);
          if (!lineStarts || !(line >= 1) || line > lineStarts.length)
            return null;
          const start = lineStarts[line - 1];
          let end = lineStarts[line];
          while (end && end > start && src[end - 1] === "\n")
            --end;
          return src.slice(start, end);
        }
        function getPrettyContext({
          start,
          end
        }, cst, maxWidth = 80) {
          let src = getLine2(start.line, cst);
          if (!src)
            return null;
          let {
            col
          } = start;
          if (src.length > maxWidth) {
            if (col <= maxWidth - 10) {
              src = src.substr(0, maxWidth - 1) + "\u2026";
            } else {
              const halfWidth = Math.round(maxWidth / 2);
              if (src.length > col + halfWidth)
                src = src.substr(0, col + halfWidth - 1) + "\u2026";
              col -= src.length - maxWidth;
              src = "\u2026" + src.substr(1 - maxWidth);
            }
          }
          let errLen = 1;
          let errEnd = "";
          if (end) {
            if (end.line === start.line && col + (end.col - start.col) <= maxWidth + 1) {
              errLen = end.col - start.col;
            } else {
              errLen = Math.min(src.length + 1, maxWidth) - col;
              errEnd = "\u2026";
            }
          }
          const offset = col > 1 ? " ".repeat(col - 1) : "";
          const err = "^".repeat(errLen);
          return `${src}
${offset}${err}${errEnd}`;
        }
        var Range = class {
          static copy(orig) {
            return new Range(orig.start, orig.end);
          }
          constructor(start, end) {
            this.start = start;
            this.end = end || start;
          }
          isEmpty() {
            return typeof this.start !== "number" || !this.end || this.end <= this.start;
          }
          setOrigRange(cr, offset) {
            const {
              start,
              end
            } = this;
            if (cr.length === 0 || end <= cr[0]) {
              this.origStart = start;
              this.origEnd = end;
              return offset;
            }
            let i = offset;
            while (i < cr.length) {
              if (cr[i] > start)
                break;
              else
                ++i;
            }
            this.origStart = start + i;
            const nextOffset = i;
            while (i < cr.length) {
              if (cr[i] >= end)
                break;
              else
                ++i;
            }
            this.origEnd = end + i;
            return nextOffset;
          }
        };
        var Node = class {
          static addStringTerminator(src, offset, str2) {
            if (str2[str2.length - 1] === "\n")
              return str2;
            const next = Node.endOfWhiteSpace(src, offset);
            return next >= src.length || src[next] === "\n" ? str2 + "\n" : str2;
          }
          static atDocumentBoundary(src, offset, sep2) {
            const ch0 = src[offset];
            if (!ch0)
              return true;
            const prev = src[offset - 1];
            if (prev && prev !== "\n")
              return false;
            if (sep2) {
              if (ch0 !== sep2)
                return false;
            } else {
              if (ch0 !== Char.DIRECTIVES_END && ch0 !== Char.DOCUMENT_END)
                return false;
            }
            const ch1 = src[offset + 1];
            const ch2 = src[offset + 2];
            if (ch1 !== ch0 || ch2 !== ch0)
              return false;
            const ch3 = src[offset + 3];
            return !ch3 || ch3 === "\n" || ch3 === "	" || ch3 === " ";
          }
          static endOfIdentifier(src, offset) {
            let ch = src[offset];
            const isVerbatim = ch === "<";
            const notOk = isVerbatim ? ["\n", "	", " ", ">"] : ["\n", "	", " ", "[", "]", "{", "}", ","];
            while (ch && notOk.indexOf(ch) === -1)
              ch = src[offset += 1];
            if (isVerbatim && ch === ">")
              offset += 1;
            return offset;
          }
          static endOfIndent(src, offset) {
            let ch = src[offset];
            while (ch === " ")
              ch = src[offset += 1];
            return offset;
          }
          static endOfLine(src, offset) {
            let ch = src[offset];
            while (ch && ch !== "\n")
              ch = src[offset += 1];
            return offset;
          }
          static endOfWhiteSpace(src, offset) {
            let ch = src[offset];
            while (ch === "	" || ch === " ")
              ch = src[offset += 1];
            return offset;
          }
          static startOfLine(src, offset) {
            let ch = src[offset - 1];
            if (ch === "\n")
              return offset;
            while (ch && ch !== "\n")
              ch = src[offset -= 1];
            return offset + 1;
          }
          static endOfBlockIndent(src, indent, lineStart) {
            const inEnd = Node.endOfIndent(src, lineStart);
            if (inEnd > lineStart + indent) {
              return inEnd;
            } else {
              const wsEnd = Node.endOfWhiteSpace(src, inEnd);
              const ch = src[wsEnd];
              if (!ch || ch === "\n")
                return wsEnd;
            }
            return null;
          }
          static atBlank(src, offset, endAsBlank) {
            const ch = src[offset];
            return ch === "\n" || ch === "	" || ch === " " || endAsBlank && !ch;
          }
          static nextNodeIsIndented(ch, indentDiff, indicatorAsIndent) {
            if (!ch || indentDiff < 0)
              return false;
            if (indentDiff > 0)
              return true;
            return indicatorAsIndent && ch === "-";
          }
          static normalizeOffset(src, offset) {
            const ch = src[offset];
            return !ch ? offset : ch !== "\n" && src[offset - 1] === "\n" ? offset - 1 : Node.endOfWhiteSpace(src, offset);
          }
          static foldNewline(src, offset, indent) {
            let inCount = 0;
            let error = false;
            let fold = "";
            let ch = src[offset + 1];
            while (ch === " " || ch === "	" || ch === "\n") {
              switch (ch) {
                case "\n":
                  inCount = 0;
                  offset += 1;
                  fold += "\n";
                  break;
                case "	":
                  if (inCount <= indent)
                    error = true;
                  offset = Node.endOfWhiteSpace(src, offset + 2) - 1;
                  break;
                case " ":
                  inCount += 1;
                  offset += 1;
                  break;
              }
              ch = src[offset + 1];
            }
            if (!fold)
              fold = " ";
            if (ch && inCount <= indent)
              error = true;
            return {
              fold,
              offset,
              error
            };
          }
          constructor(type2, props, context) {
            Object.defineProperty(this, "context", {
              value: context || null,
              writable: true
            });
            this.error = null;
            this.range = null;
            this.valueRange = null;
            this.props = props || [];
            this.type = type2;
            this.value = null;
          }
          getPropValue(idx, key, skipKey) {
            if (!this.context)
              return null;
            const {
              src
            } = this.context;
            const prop = this.props[idx];
            return prop && src[prop.start] === key ? src.slice(prop.start + (skipKey ? 1 : 0), prop.end) : null;
          }
          get anchor() {
            for (let i = 0; i < this.props.length; ++i) {
              const anchor = this.getPropValue(i, Char.ANCHOR, true);
              if (anchor != null)
                return anchor;
            }
            return null;
          }
          get comment() {
            const comments = [];
            for (let i = 0; i < this.props.length; ++i) {
              const comment = this.getPropValue(i, Char.COMMENT, true);
              if (comment != null)
                comments.push(comment);
            }
            return comments.length > 0 ? comments.join("\n") : null;
          }
          commentHasRequiredWhitespace(start) {
            const {
              src
            } = this.context;
            if (this.header && start === this.header.end)
              return false;
            if (!this.valueRange)
              return false;
            const {
              end
            } = this.valueRange;
            return start !== end || Node.atBlank(src, end - 1);
          }
          get hasComment() {
            if (this.context) {
              const {
                src
              } = this.context;
              for (let i = 0; i < this.props.length; ++i) {
                if (src[this.props[i].start] === Char.COMMENT)
                  return true;
              }
            }
            return false;
          }
          get hasProps() {
            if (this.context) {
              const {
                src
              } = this.context;
              for (let i = 0; i < this.props.length; ++i) {
                if (src[this.props[i].start] !== Char.COMMENT)
                  return true;
              }
            }
            return false;
          }
          get includesTrailingLines() {
            return false;
          }
          get jsonLike() {
            const jsonLikeTypes = [Type3.FLOW_MAP, Type3.FLOW_SEQ, Type3.QUOTE_DOUBLE, Type3.QUOTE_SINGLE];
            return jsonLikeTypes.indexOf(this.type) !== -1;
          }
          get rangeAsLinePos() {
            if (!this.range || !this.context)
              return void 0;
            const start = getLinePos(this.range.start, this.context.root);
            if (!start)
              return void 0;
            const end = getLinePos(this.range.end, this.context.root);
            return {
              start,
              end
            };
          }
          get rawValue() {
            if (!this.valueRange || !this.context)
              return null;
            const {
              start,
              end
            } = this.valueRange;
            return this.context.src.slice(start, end);
          }
          get tag() {
            for (let i = 0; i < this.props.length; ++i) {
              const tag = this.getPropValue(i, Char.TAG, false);
              if (tag != null) {
                if (tag[1] === "<") {
                  return {
                    verbatim: tag.slice(2, -1)
                  };
                } else {
                  const [_, handle, suffix] = tag.match(/^(.*!)([^!]*)$/);
                  return {
                    handle,
                    suffix
                  };
                }
              }
            }
            return null;
          }
          get valueRangeContainsNewline() {
            if (!this.valueRange || !this.context)
              return false;
            const {
              start,
              end
            } = this.valueRange;
            const {
              src
            } = this.context;
            for (let i = start; i < end; ++i) {
              if (src[i] === "\n")
                return true;
            }
            return false;
          }
          parseComment(start) {
            const {
              src
            } = this.context;
            if (src[start] === Char.COMMENT) {
              const end = Node.endOfLine(src, start + 1);
              const commentRange = new Range(start, end);
              this.props.push(commentRange);
              return end;
            }
            return start;
          }
          setOrigRanges(cr, offset) {
            if (this.range)
              offset = this.range.setOrigRange(cr, offset);
            if (this.valueRange)
              this.valueRange.setOrigRange(cr, offset);
            this.props.forEach((prop) => prop.setOrigRange(cr, offset));
            return offset;
          }
          toString() {
            const {
              context: {
                src
              },
              range,
              value
            } = this;
            if (value != null)
              return value;
            const str2 = src.slice(range.start, range.end);
            return Node.addStringTerminator(src, range.end, str2);
          }
        };
        var YAMLError = class extends Error {
          constructor(name, source, message) {
            if (!message || !(source instanceof Node))
              throw new Error(`Invalid arguments for new ${name}`);
            super();
            this.name = name;
            this.message = message;
            this.source = source;
          }
          makePretty() {
            if (!this.source)
              return;
            this.nodeType = this.source.type;
            const cst = this.source.context && this.source.context.root;
            if (typeof this.offset === "number") {
              this.range = new Range(this.offset, this.offset + 1);
              const start = cst && getLinePos(this.offset, cst);
              if (start) {
                const end = {
                  line: start.line,
                  col: start.col + 1
                };
                this.linePos = {
                  start,
                  end
                };
              }
              delete this.offset;
            } else {
              this.range = this.source.range;
              this.linePos = this.source.rangeAsLinePos;
            }
            if (this.linePos) {
              const {
                line,
                col
              } = this.linePos.start;
              this.message += ` at line ${line}, column ${col}`;
              const ctx = cst && getPrettyContext(this.linePos, cst);
              if (ctx)
                this.message += `:

${ctx}
`;
            }
            delete this.source;
          }
        };
        var YAMLReferenceError = class extends YAMLError {
          constructor(source, message) {
            super("YAMLReferenceError", source, message);
          }
        };
        var YAMLSemanticError = class extends YAMLError {
          constructor(source, message) {
            super("YAMLSemanticError", source, message);
          }
        };
        var YAMLSyntaxError = class extends YAMLError {
          constructor(source, message) {
            super("YAMLSyntaxError", source, message);
          }
        };
        var YAMLWarning = class extends YAMLError {
          constructor(source, message) {
            super("YAMLWarning", source, message);
          }
        };
        function _defineProperty(obj, key, value) {
          if (key in obj) {
            Object.defineProperty(obj, key, {
              value,
              enumerable: true,
              configurable: true,
              writable: true
            });
          } else {
            obj[key] = value;
          }
          return obj;
        }
        var PlainValue = class extends Node {
          static endOfLine(src, start, inFlow) {
            let ch = src[start];
            let offset = start;
            while (ch && ch !== "\n") {
              if (inFlow && (ch === "[" || ch === "]" || ch === "{" || ch === "}" || ch === ","))
                break;
              const next = src[offset + 1];
              if (ch === ":" && (!next || next === "\n" || next === "	" || next === " " || inFlow && next === ","))
                break;
              if ((ch === " " || ch === "	") && next === "#")
                break;
              offset += 1;
              ch = next;
            }
            return offset;
          }
          get strValue() {
            if (!this.valueRange || !this.context)
              return null;
            let {
              start,
              end
            } = this.valueRange;
            const {
              src
            } = this.context;
            let ch = src[end - 1];
            while (start < end && (ch === "\n" || ch === "	" || ch === " "))
              ch = src[--end - 1];
            let str2 = "";
            for (let i = start; i < end; ++i) {
              const ch2 = src[i];
              if (ch2 === "\n") {
                const {
                  fold,
                  offset
                } = Node.foldNewline(src, i, -1);
                str2 += fold;
                i = offset;
              } else if (ch2 === " " || ch2 === "	") {
                const wsStart = i;
                let next = src[i + 1];
                while (i < end && (next === " " || next === "	")) {
                  i += 1;
                  next = src[i + 1];
                }
                if (next !== "\n")
                  str2 += i > wsStart ? src.slice(wsStart, i + 1) : ch2;
              } else {
                str2 += ch2;
              }
            }
            const ch0 = src[start];
            switch (ch0) {
              case "	": {
                const msg = "Plain value cannot start with a tab character";
                const errors = [new YAMLSemanticError(this, msg)];
                return {
                  errors,
                  str: str2
                };
              }
              case "@":
              case "`": {
                const msg = `Plain value cannot start with reserved character ${ch0}`;
                const errors = [new YAMLSemanticError(this, msg)];
                return {
                  errors,
                  str: str2
                };
              }
              default:
                return str2;
            }
          }
          parseBlockValue(start) {
            const {
              indent,
              inFlow,
              src
            } = this.context;
            let offset = start;
            let valueEnd = start;
            for (let ch = src[offset]; ch === "\n"; ch = src[offset]) {
              if (Node.atDocumentBoundary(src, offset + 1))
                break;
              const end = Node.endOfBlockIndent(src, indent, offset + 1);
              if (end === null || src[end] === "#")
                break;
              if (src[end] === "\n") {
                offset = end;
              } else {
                valueEnd = PlainValue.endOfLine(src, end, inFlow);
                offset = valueEnd;
              }
            }
            if (this.valueRange.isEmpty())
              this.valueRange.start = start;
            this.valueRange.end = valueEnd;
            return valueEnd;
          }
          parse(context, start) {
            this.context = context;
            const {
              inFlow,
              src
            } = context;
            let offset = start;
            const ch = src[offset];
            if (ch && ch !== "#" && ch !== "\n") {
              offset = PlainValue.endOfLine(src, start, inFlow);
            }
            this.valueRange = new Range(start, offset);
            offset = Node.endOfWhiteSpace(src, offset);
            offset = this.parseComment(offset);
            if (!this.hasComment || this.valueRange.isEmpty()) {
              offset = this.parseBlockValue(offset);
            }
            return offset;
          }
        };
        exports22.Char = Char;
        exports22.Node = Node;
        exports22.PlainValue = PlainValue;
        exports22.Range = Range;
        exports22.Type = Type3;
        exports22.YAMLError = YAMLError;
        exports22.YAMLReferenceError = YAMLReferenceError;
        exports22.YAMLSemanticError = YAMLSemanticError;
        exports22.YAMLSyntaxError = YAMLSyntaxError;
        exports22.YAMLWarning = YAMLWarning;
        exports22._defineProperty = _defineProperty;
        exports22.defaultTagPrefix = defaultTagPrefix;
        exports22.defaultTags = defaultTags;
      }
    });
    var require_parse_cst = __commonJS2({
      "node_modules/yaml/dist/parse-cst.js"(exports22) {
        "use strict";
        var PlainValue = require_PlainValue_ec8e588e();
        var BlankLine = class extends PlainValue.Node {
          constructor() {
            super(PlainValue.Type.BLANK_LINE);
          }
          get includesTrailingLines() {
            return true;
          }
          parse(context, start) {
            this.context = context;
            this.range = new PlainValue.Range(start, start + 1);
            return start + 1;
          }
        };
        var CollectionItem = class extends PlainValue.Node {
          constructor(type2, props) {
            super(type2, props);
            this.node = null;
          }
          get includesTrailingLines() {
            return !!this.node && this.node.includesTrailingLines;
          }
          parse(context, start) {
            this.context = context;
            const {
              parseNode,
              src
            } = context;
            let {
              atLineStart,
              lineStart
            } = context;
            if (!atLineStart && this.type === PlainValue.Type.SEQ_ITEM)
              this.error = new PlainValue.YAMLSemanticError(this, "Sequence items must not have preceding content on the same line");
            const indent = atLineStart ? start - lineStart : context.indent;
            let offset = PlainValue.Node.endOfWhiteSpace(src, start + 1);
            let ch = src[offset];
            const inlineComment = ch === "#";
            const comments = [];
            let blankLine = null;
            while (ch === "\n" || ch === "#") {
              if (ch === "#") {
                const end2 = PlainValue.Node.endOfLine(src, offset + 1);
                comments.push(new PlainValue.Range(offset, end2));
                offset = end2;
              } else {
                atLineStart = true;
                lineStart = offset + 1;
                const wsEnd = PlainValue.Node.endOfWhiteSpace(src, lineStart);
                if (src[wsEnd] === "\n" && comments.length === 0) {
                  blankLine = new BlankLine();
                  lineStart = blankLine.parse({
                    src
                  }, lineStart);
                }
                offset = PlainValue.Node.endOfIndent(src, lineStart);
              }
              ch = src[offset];
            }
            if (PlainValue.Node.nextNodeIsIndented(ch, offset - (lineStart + indent), this.type !== PlainValue.Type.SEQ_ITEM)) {
              this.node = parseNode({
                atLineStart,
                inCollection: false,
                indent,
                lineStart,
                parent: this
              }, offset);
            } else if (ch && lineStart > start + 1) {
              offset = lineStart - 1;
            }
            if (this.node) {
              if (blankLine) {
                const items = context.parent.items || context.parent.contents;
                if (items)
                  items.push(blankLine);
              }
              if (comments.length)
                Array.prototype.push.apply(this.props, comments);
              offset = this.node.range.end;
            } else {
              if (inlineComment) {
                const c = comments[0];
                this.props.push(c);
                offset = c.end;
              } else {
                offset = PlainValue.Node.endOfLine(src, start + 1);
              }
            }
            const end = this.node ? this.node.valueRange.end : offset;
            this.valueRange = new PlainValue.Range(start, end);
            return offset;
          }
          setOrigRanges(cr, offset) {
            offset = super.setOrigRanges(cr, offset);
            return this.node ? this.node.setOrigRanges(cr, offset) : offset;
          }
          toString() {
            const {
              context: {
                src
              },
              node,
              range,
              value
            } = this;
            if (value != null)
              return value;
            const str2 = node ? src.slice(range.start, node.range.start) + String(node) : src.slice(range.start, range.end);
            return PlainValue.Node.addStringTerminator(src, range.end, str2);
          }
        };
        var Comment = class extends PlainValue.Node {
          constructor() {
            super(PlainValue.Type.COMMENT);
          }
          parse(context, start) {
            this.context = context;
            const offset = this.parseComment(start);
            this.range = new PlainValue.Range(start, offset);
            return offset;
          }
        };
        function grabCollectionEndComments(node) {
          let cnode = node;
          while (cnode instanceof CollectionItem)
            cnode = cnode.node;
          if (!(cnode instanceof Collection))
            return null;
          const len = cnode.items.length;
          let ci = -1;
          for (let i = len - 1; i >= 0; --i) {
            const n = cnode.items[i];
            if (n.type === PlainValue.Type.COMMENT) {
              const {
                indent,
                lineStart
              } = n.context;
              if (indent > 0 && n.range.start >= lineStart + indent)
                break;
              ci = i;
            } else if (n.type === PlainValue.Type.BLANK_LINE)
              ci = i;
            else
              break;
          }
          if (ci === -1)
            return null;
          const ca = cnode.items.splice(ci, len - ci);
          const prevEnd = ca[0].range.start;
          while (true) {
            cnode.range.end = prevEnd;
            if (cnode.valueRange && cnode.valueRange.end > prevEnd)
              cnode.valueRange.end = prevEnd;
            if (cnode === node)
              break;
            cnode = cnode.context.parent;
          }
          return ca;
        }
        var Collection = class extends PlainValue.Node {
          static nextContentHasIndent(src, offset, indent) {
            const lineStart = PlainValue.Node.endOfLine(src, offset) + 1;
            offset = PlainValue.Node.endOfWhiteSpace(src, lineStart);
            const ch = src[offset];
            if (!ch)
              return false;
            if (offset >= lineStart + indent)
              return true;
            if (ch !== "#" && ch !== "\n")
              return false;
            return Collection.nextContentHasIndent(src, offset, indent);
          }
          constructor(firstItem) {
            super(firstItem.type === PlainValue.Type.SEQ_ITEM ? PlainValue.Type.SEQ : PlainValue.Type.MAP);
            for (let i = firstItem.props.length - 1; i >= 0; --i) {
              if (firstItem.props[i].start < firstItem.context.lineStart) {
                this.props = firstItem.props.slice(0, i + 1);
                firstItem.props = firstItem.props.slice(i + 1);
                const itemRange = firstItem.props[0] || firstItem.valueRange;
                firstItem.range.start = itemRange.start;
                break;
              }
            }
            this.items = [firstItem];
            const ec = grabCollectionEndComments(firstItem);
            if (ec)
              Array.prototype.push.apply(this.items, ec);
          }
          get includesTrailingLines() {
            return this.items.length > 0;
          }
          parse(context, start) {
            this.context = context;
            const {
              parseNode,
              src
            } = context;
            let lineStart = PlainValue.Node.startOfLine(src, start);
            const firstItem = this.items[0];
            firstItem.context.parent = this;
            this.valueRange = PlainValue.Range.copy(firstItem.valueRange);
            const indent = firstItem.range.start - firstItem.context.lineStart;
            let offset = start;
            offset = PlainValue.Node.normalizeOffset(src, offset);
            let ch = src[offset];
            let atLineStart = PlainValue.Node.endOfWhiteSpace(src, lineStart) === offset;
            let prevIncludesTrailingLines = false;
            while (ch) {
              while (ch === "\n" || ch === "#") {
                if (atLineStart && ch === "\n" && !prevIncludesTrailingLines) {
                  const blankLine = new BlankLine();
                  offset = blankLine.parse({
                    src
                  }, offset);
                  this.valueRange.end = offset;
                  if (offset >= src.length) {
                    ch = null;
                    break;
                  }
                  this.items.push(blankLine);
                  offset -= 1;
                } else if (ch === "#") {
                  if (offset < lineStart + indent && !Collection.nextContentHasIndent(src, offset, indent)) {
                    return offset;
                  }
                  const comment = new Comment();
                  offset = comment.parse({
                    indent,
                    lineStart,
                    src
                  }, offset);
                  this.items.push(comment);
                  this.valueRange.end = offset;
                  if (offset >= src.length) {
                    ch = null;
                    break;
                  }
                }
                lineStart = offset + 1;
                offset = PlainValue.Node.endOfIndent(src, lineStart);
                if (PlainValue.Node.atBlank(src, offset)) {
                  const wsEnd = PlainValue.Node.endOfWhiteSpace(src, offset);
                  const next = src[wsEnd];
                  if (!next || next === "\n" || next === "#") {
                    offset = wsEnd;
                  }
                }
                ch = src[offset];
                atLineStart = true;
              }
              if (!ch) {
                break;
              }
              if (offset !== lineStart + indent && (atLineStart || ch !== ":")) {
                if (offset < lineStart + indent) {
                  if (lineStart > start)
                    offset = lineStart;
                  break;
                } else if (!this.error) {
                  const msg = "All collection items must start at the same column";
                  this.error = new PlainValue.YAMLSyntaxError(this, msg);
                }
              }
              if (firstItem.type === PlainValue.Type.SEQ_ITEM) {
                if (ch !== "-") {
                  if (lineStart > start)
                    offset = lineStart;
                  break;
                }
              } else if (ch === "-" && !this.error) {
                const next = src[offset + 1];
                if (!next || next === "\n" || next === "	" || next === " ") {
                  const msg = "A collection cannot be both a mapping and a sequence";
                  this.error = new PlainValue.YAMLSyntaxError(this, msg);
                }
              }
              const node = parseNode({
                atLineStart,
                inCollection: true,
                indent,
                lineStart,
                parent: this
              }, offset);
              if (!node)
                return offset;
              this.items.push(node);
              this.valueRange.end = node.valueRange.end;
              offset = PlainValue.Node.normalizeOffset(src, node.range.end);
              ch = src[offset];
              atLineStart = false;
              prevIncludesTrailingLines = node.includesTrailingLines;
              if (ch) {
                let ls = offset - 1;
                let prev = src[ls];
                while (prev === " " || prev === "	")
                  prev = src[--ls];
                if (prev === "\n") {
                  lineStart = ls + 1;
                  atLineStart = true;
                }
              }
              const ec = grabCollectionEndComments(node);
              if (ec)
                Array.prototype.push.apply(this.items, ec);
            }
            return offset;
          }
          setOrigRanges(cr, offset) {
            offset = super.setOrigRanges(cr, offset);
            this.items.forEach((node) => {
              offset = node.setOrigRanges(cr, offset);
            });
            return offset;
          }
          toString() {
            const {
              context: {
                src
              },
              items,
              range,
              value
            } = this;
            if (value != null)
              return value;
            let str2 = src.slice(range.start, items[0].range.start) + String(items[0]);
            for (let i = 1; i < items.length; ++i) {
              const item = items[i];
              const {
                atLineStart,
                indent
              } = item.context;
              if (atLineStart)
                for (let i2 = 0; i2 < indent; ++i2)
                  str2 += " ";
              str2 += String(item);
            }
            return PlainValue.Node.addStringTerminator(src, range.end, str2);
          }
        };
        var Directive = class extends PlainValue.Node {
          constructor() {
            super(PlainValue.Type.DIRECTIVE);
            this.name = null;
          }
          get parameters() {
            const raw = this.rawValue;
            return raw ? raw.trim().split(/[ \t]+/) : [];
          }
          parseName(start) {
            const {
              src
            } = this.context;
            let offset = start;
            let ch = src[offset];
            while (ch && ch !== "\n" && ch !== "	" && ch !== " ")
              ch = src[offset += 1];
            this.name = src.slice(start, offset);
            return offset;
          }
          parseParameters(start) {
            const {
              src
            } = this.context;
            let offset = start;
            let ch = src[offset];
            while (ch && ch !== "\n" && ch !== "#")
              ch = src[offset += 1];
            this.valueRange = new PlainValue.Range(start, offset);
            return offset;
          }
          parse(context, start) {
            this.context = context;
            let offset = this.parseName(start + 1);
            offset = this.parseParameters(offset);
            offset = this.parseComment(offset);
            this.range = new PlainValue.Range(start, offset);
            return offset;
          }
        };
        var Document = class extends PlainValue.Node {
          static startCommentOrEndBlankLine(src, start) {
            const offset = PlainValue.Node.endOfWhiteSpace(src, start);
            const ch = src[offset];
            return ch === "#" || ch === "\n" ? offset : start;
          }
          constructor() {
            super(PlainValue.Type.DOCUMENT);
            this.directives = null;
            this.contents = null;
            this.directivesEndMarker = null;
            this.documentEndMarker = null;
          }
          parseDirectives(start) {
            const {
              src
            } = this.context;
            this.directives = [];
            let atLineStart = true;
            let hasDirectives = false;
            let offset = start;
            while (!PlainValue.Node.atDocumentBoundary(src, offset, PlainValue.Char.DIRECTIVES_END)) {
              offset = Document.startCommentOrEndBlankLine(src, offset);
              switch (src[offset]) {
                case "\n":
                  if (atLineStart) {
                    const blankLine = new BlankLine();
                    offset = blankLine.parse({
                      src
                    }, offset);
                    if (offset < src.length) {
                      this.directives.push(blankLine);
                    }
                  } else {
                    offset += 1;
                    atLineStart = true;
                  }
                  break;
                case "#":
                  {
                    const comment = new Comment();
                    offset = comment.parse({
                      src
                    }, offset);
                    this.directives.push(comment);
                    atLineStart = false;
                  }
                  break;
                case "%":
                  {
                    const directive = new Directive();
                    offset = directive.parse({
                      parent: this,
                      src
                    }, offset);
                    this.directives.push(directive);
                    hasDirectives = true;
                    atLineStart = false;
                  }
                  break;
                default:
                  if (hasDirectives) {
                    this.error = new PlainValue.YAMLSemanticError(this, "Missing directives-end indicator line");
                  } else if (this.directives.length > 0) {
                    this.contents = this.directives;
                    this.directives = [];
                  }
                  return offset;
              }
            }
            if (src[offset]) {
              this.directivesEndMarker = new PlainValue.Range(offset, offset + 3);
              return offset + 3;
            }
            if (hasDirectives) {
              this.error = new PlainValue.YAMLSemanticError(this, "Missing directives-end indicator line");
            } else if (this.directives.length > 0) {
              this.contents = this.directives;
              this.directives = [];
            }
            return offset;
          }
          parseContents(start) {
            const {
              parseNode,
              src
            } = this.context;
            if (!this.contents)
              this.contents = [];
            let lineStart = start;
            while (src[lineStart - 1] === "-")
              lineStart -= 1;
            let offset = PlainValue.Node.endOfWhiteSpace(src, start);
            let atLineStart = lineStart === start;
            this.valueRange = new PlainValue.Range(offset);
            while (!PlainValue.Node.atDocumentBoundary(src, offset, PlainValue.Char.DOCUMENT_END)) {
              switch (src[offset]) {
                case "\n":
                  if (atLineStart) {
                    const blankLine = new BlankLine();
                    offset = blankLine.parse({
                      src
                    }, offset);
                    if (offset < src.length) {
                      this.contents.push(blankLine);
                    }
                  } else {
                    offset += 1;
                    atLineStart = true;
                  }
                  lineStart = offset;
                  break;
                case "#":
                  {
                    const comment = new Comment();
                    offset = comment.parse({
                      src
                    }, offset);
                    this.contents.push(comment);
                    atLineStart = false;
                  }
                  break;
                default: {
                  const iEnd = PlainValue.Node.endOfIndent(src, offset);
                  const context = {
                    atLineStart,
                    indent: -1,
                    inFlow: false,
                    inCollection: false,
                    lineStart,
                    parent: this
                  };
                  const node = parseNode(context, iEnd);
                  if (!node)
                    return this.valueRange.end = iEnd;
                  this.contents.push(node);
                  offset = node.range.end;
                  atLineStart = false;
                  const ec = grabCollectionEndComments(node);
                  if (ec)
                    Array.prototype.push.apply(this.contents, ec);
                }
              }
              offset = Document.startCommentOrEndBlankLine(src, offset);
            }
            this.valueRange.end = offset;
            if (src[offset]) {
              this.documentEndMarker = new PlainValue.Range(offset, offset + 3);
              offset += 3;
              if (src[offset]) {
                offset = PlainValue.Node.endOfWhiteSpace(src, offset);
                if (src[offset] === "#") {
                  const comment = new Comment();
                  offset = comment.parse({
                    src
                  }, offset);
                  this.contents.push(comment);
                }
                switch (src[offset]) {
                  case "\n":
                    offset += 1;
                    break;
                  case void 0:
                    break;
                  default:
                    this.error = new PlainValue.YAMLSyntaxError(this, "Document end marker line cannot have a non-comment suffix");
                }
              }
            }
            return offset;
          }
          parse(context, start) {
            context.root = this;
            this.context = context;
            const {
              src
            } = context;
            let offset = src.charCodeAt(start) === 65279 ? start + 1 : start;
            offset = this.parseDirectives(offset);
            offset = this.parseContents(offset);
            return offset;
          }
          setOrigRanges(cr, offset) {
            offset = super.setOrigRanges(cr, offset);
            this.directives.forEach((node) => {
              offset = node.setOrigRanges(cr, offset);
            });
            if (this.directivesEndMarker)
              offset = this.directivesEndMarker.setOrigRange(cr, offset);
            this.contents.forEach((node) => {
              offset = node.setOrigRanges(cr, offset);
            });
            if (this.documentEndMarker)
              offset = this.documentEndMarker.setOrigRange(cr, offset);
            return offset;
          }
          toString() {
            const {
              contents,
              directives,
              value
            } = this;
            if (value != null)
              return value;
            let str2 = directives.join("");
            if (contents.length > 0) {
              if (directives.length > 0 || contents[0].type === PlainValue.Type.COMMENT)
                str2 += "---\n";
              str2 += contents.join("");
            }
            if (str2[str2.length - 1] !== "\n")
              str2 += "\n";
            return str2;
          }
        };
        var Alias = class extends PlainValue.Node {
          parse(context, start) {
            this.context = context;
            const {
              src
            } = context;
            let offset = PlainValue.Node.endOfIdentifier(src, start + 1);
            this.valueRange = new PlainValue.Range(start + 1, offset);
            offset = PlainValue.Node.endOfWhiteSpace(src, offset);
            offset = this.parseComment(offset);
            return offset;
          }
        };
        var Chomp = {
          CLIP: "CLIP",
          KEEP: "KEEP",
          STRIP: "STRIP"
        };
        var BlockValue = class extends PlainValue.Node {
          constructor(type2, props) {
            super(type2, props);
            this.blockIndent = null;
            this.chomping = Chomp.CLIP;
            this.header = null;
          }
          get includesTrailingLines() {
            return this.chomping === Chomp.KEEP;
          }
          get strValue() {
            if (!this.valueRange || !this.context)
              return null;
            let {
              start,
              end
            } = this.valueRange;
            const {
              indent,
              src
            } = this.context;
            if (this.valueRange.isEmpty())
              return "";
            let lastNewLine = null;
            let ch = src[end - 1];
            while (ch === "\n" || ch === "	" || ch === " ") {
              end -= 1;
              if (end <= start) {
                if (this.chomping === Chomp.KEEP)
                  break;
                else
                  return "";
              }
              if (ch === "\n")
                lastNewLine = end;
              ch = src[end - 1];
            }
            let keepStart = end + 1;
            if (lastNewLine) {
              if (this.chomping === Chomp.KEEP) {
                keepStart = lastNewLine;
                end = this.valueRange.end;
              } else {
                end = lastNewLine;
              }
            }
            const bi = indent + this.blockIndent;
            const folded = this.type === PlainValue.Type.BLOCK_FOLDED;
            let atStart = true;
            let str2 = "";
            let sep2 = "";
            let prevMoreIndented = false;
            for (let i = start; i < end; ++i) {
              for (let j = 0; j < bi; ++j) {
                if (src[i] !== " ")
                  break;
                i += 1;
              }
              const ch2 = src[i];
              if (ch2 === "\n") {
                if (sep2 === "\n")
                  str2 += "\n";
                else
                  sep2 = "\n";
              } else {
                const lineEnd = PlainValue.Node.endOfLine(src, i);
                const line = src.slice(i, lineEnd);
                i = lineEnd;
                if (folded && (ch2 === " " || ch2 === "	") && i < keepStart) {
                  if (sep2 === " ")
                    sep2 = "\n";
                  else if (!prevMoreIndented && !atStart && sep2 === "\n")
                    sep2 = "\n\n";
                  str2 += sep2 + line;
                  sep2 = lineEnd < end && src[lineEnd] || "";
                  prevMoreIndented = true;
                } else {
                  str2 += sep2 + line;
                  sep2 = folded && i < keepStart ? " " : "\n";
                  prevMoreIndented = false;
                }
                if (atStart && line !== "")
                  atStart = false;
              }
            }
            return this.chomping === Chomp.STRIP ? str2 : str2 + "\n";
          }
          parseBlockHeader(start) {
            const {
              src
            } = this.context;
            let offset = start + 1;
            let bi = "";
            while (true) {
              const ch = src[offset];
              switch (ch) {
                case "-":
                  this.chomping = Chomp.STRIP;
                  break;
                case "+":
                  this.chomping = Chomp.KEEP;
                  break;
                case "0":
                case "1":
                case "2":
                case "3":
                case "4":
                case "5":
                case "6":
                case "7":
                case "8":
                case "9":
                  bi += ch;
                  break;
                default:
                  this.blockIndent = Number(bi) || null;
                  this.header = new PlainValue.Range(start, offset);
                  return offset;
              }
              offset += 1;
            }
          }
          parseBlockValue(start) {
            const {
              indent,
              src
            } = this.context;
            const explicit = !!this.blockIndent;
            let offset = start;
            let valueEnd = start;
            let minBlockIndent = 1;
            for (let ch = src[offset]; ch === "\n"; ch = src[offset]) {
              offset += 1;
              if (PlainValue.Node.atDocumentBoundary(src, offset))
                break;
              const end = PlainValue.Node.endOfBlockIndent(src, indent, offset);
              if (end === null)
                break;
              const ch2 = src[end];
              const lineIndent = end - (offset + indent);
              if (!this.blockIndent) {
                if (src[end] !== "\n") {
                  if (lineIndent < minBlockIndent) {
                    const msg = "Block scalars with more-indented leading empty lines must use an explicit indentation indicator";
                    this.error = new PlainValue.YAMLSemanticError(this, msg);
                  }
                  this.blockIndent = lineIndent;
                } else if (lineIndent > minBlockIndent) {
                  minBlockIndent = lineIndent;
                }
              } else if (ch2 && ch2 !== "\n" && lineIndent < this.blockIndent) {
                if (src[end] === "#")
                  break;
                if (!this.error) {
                  const src2 = explicit ? "explicit indentation indicator" : "first line";
                  const msg = `Block scalars must not be less indented than their ${src2}`;
                  this.error = new PlainValue.YAMLSemanticError(this, msg);
                }
              }
              if (src[end] === "\n") {
                offset = end;
              } else {
                offset = valueEnd = PlainValue.Node.endOfLine(src, end);
              }
            }
            if (this.chomping !== Chomp.KEEP) {
              offset = src[valueEnd] ? valueEnd + 1 : valueEnd;
            }
            this.valueRange = new PlainValue.Range(start + 1, offset);
            return offset;
          }
          parse(context, start) {
            this.context = context;
            const {
              src
            } = context;
            let offset = this.parseBlockHeader(start);
            offset = PlainValue.Node.endOfWhiteSpace(src, offset);
            offset = this.parseComment(offset);
            offset = this.parseBlockValue(offset);
            return offset;
          }
          setOrigRanges(cr, offset) {
            offset = super.setOrigRanges(cr, offset);
            return this.header ? this.header.setOrigRange(cr, offset) : offset;
          }
        };
        var FlowCollection = class extends PlainValue.Node {
          constructor(type2, props) {
            super(type2, props);
            this.items = null;
          }
          prevNodeIsJsonLike(idx = this.items.length) {
            const node = this.items[idx - 1];
            return !!node && (node.jsonLike || node.type === PlainValue.Type.COMMENT && this.prevNodeIsJsonLike(idx - 1));
          }
          parse(context, start) {
            this.context = context;
            const {
              parseNode,
              src
            } = context;
            let {
              indent,
              lineStart
            } = context;
            let char = src[start];
            this.items = [{
              char,
              offset: start
            }];
            let offset = PlainValue.Node.endOfWhiteSpace(src, start + 1);
            char = src[offset];
            while (char && char !== "]" && char !== "}") {
              switch (char) {
                case "\n":
                  {
                    lineStart = offset + 1;
                    const wsEnd = PlainValue.Node.endOfWhiteSpace(src, lineStart);
                    if (src[wsEnd] === "\n") {
                      const blankLine = new BlankLine();
                      lineStart = blankLine.parse({
                        src
                      }, lineStart);
                      this.items.push(blankLine);
                    }
                    offset = PlainValue.Node.endOfIndent(src, lineStart);
                    if (offset <= lineStart + indent) {
                      char = src[offset];
                      if (offset < lineStart + indent || char !== "]" && char !== "}") {
                        const msg = "Insufficient indentation in flow collection";
                        this.error = new PlainValue.YAMLSemanticError(this, msg);
                      }
                    }
                  }
                  break;
                case ",":
                  {
                    this.items.push({
                      char,
                      offset
                    });
                    offset += 1;
                  }
                  break;
                case "#":
                  {
                    const comment = new Comment();
                    offset = comment.parse({
                      src
                    }, offset);
                    this.items.push(comment);
                  }
                  break;
                case "?":
                case ":": {
                  const next = src[offset + 1];
                  if (next === "\n" || next === "	" || next === " " || next === "," || char === ":" && this.prevNodeIsJsonLike()) {
                    this.items.push({
                      char,
                      offset
                    });
                    offset += 1;
                    break;
                  }
                }
                default: {
                  const node = parseNode({
                    atLineStart: false,
                    inCollection: false,
                    inFlow: true,
                    indent: -1,
                    lineStart,
                    parent: this
                  }, offset);
                  if (!node) {
                    this.valueRange = new PlainValue.Range(start, offset);
                    return offset;
                  }
                  this.items.push(node);
                  offset = PlainValue.Node.normalizeOffset(src, node.range.end);
                }
              }
              offset = PlainValue.Node.endOfWhiteSpace(src, offset);
              char = src[offset];
            }
            this.valueRange = new PlainValue.Range(start, offset + 1);
            if (char) {
              this.items.push({
                char,
                offset
              });
              offset = PlainValue.Node.endOfWhiteSpace(src, offset + 1);
              offset = this.parseComment(offset);
            }
            return offset;
          }
          setOrigRanges(cr, offset) {
            offset = super.setOrigRanges(cr, offset);
            this.items.forEach((node) => {
              if (node instanceof PlainValue.Node) {
                offset = node.setOrigRanges(cr, offset);
              } else if (cr.length === 0) {
                node.origOffset = node.offset;
              } else {
                let i = offset;
                while (i < cr.length) {
                  if (cr[i] > node.offset)
                    break;
                  else
                    ++i;
                }
                node.origOffset = node.offset + i;
                offset = i;
              }
            });
            return offset;
          }
          toString() {
            const {
              context: {
                src
              },
              items,
              range,
              value
            } = this;
            if (value != null)
              return value;
            const nodes = items.filter((item) => item instanceof PlainValue.Node);
            let str2 = "";
            let prevEnd = range.start;
            nodes.forEach((node) => {
              const prefix = src.slice(prevEnd, node.range.start);
              prevEnd = node.range.end;
              str2 += prefix + String(node);
              if (str2[str2.length - 1] === "\n" && src[prevEnd - 1] !== "\n" && src[prevEnd] === "\n") {
                prevEnd += 1;
              }
            });
            str2 += src.slice(prevEnd, range.end);
            return PlainValue.Node.addStringTerminator(src, range.end, str2);
          }
        };
        var QuoteDouble = class extends PlainValue.Node {
          static endOfQuote(src, offset) {
            let ch = src[offset];
            while (ch && ch !== '"') {
              offset += ch === "\\" ? 2 : 1;
              ch = src[offset];
            }
            return offset + 1;
          }
          get strValue() {
            if (!this.valueRange || !this.context)
              return null;
            const errors = [];
            const {
              start,
              end
            } = this.valueRange;
            const {
              indent,
              src
            } = this.context;
            if (src[end - 1] !== '"')
              errors.push(new PlainValue.YAMLSyntaxError(this, 'Missing closing "quote'));
            let str2 = "";
            for (let i = start + 1; i < end - 1; ++i) {
              const ch = src[i];
              if (ch === "\n") {
                if (PlainValue.Node.atDocumentBoundary(src, i + 1))
                  errors.push(new PlainValue.YAMLSemanticError(this, "Document boundary indicators are not allowed within string values"));
                const {
                  fold,
                  offset,
                  error
                } = PlainValue.Node.foldNewline(src, i, indent);
                str2 += fold;
                i = offset;
                if (error)
                  errors.push(new PlainValue.YAMLSemanticError(this, "Multi-line double-quoted string needs to be sufficiently indented"));
              } else if (ch === "\\") {
                i += 1;
                switch (src[i]) {
                  case "0":
                    str2 += "\0";
                    break;
                  case "a":
                    str2 += "\x07";
                    break;
                  case "b":
                    str2 += "\b";
                    break;
                  case "e":
                    str2 += "\x1B";
                    break;
                  case "f":
                    str2 += "\f";
                    break;
                  case "n":
                    str2 += "\n";
                    break;
                  case "r":
                    str2 += "\r";
                    break;
                  case "t":
                    str2 += "	";
                    break;
                  case "v":
                    str2 += "\v";
                    break;
                  case "N":
                    str2 += "\x85";
                    break;
                  case "_":
                    str2 += "\xA0";
                    break;
                  case "L":
                    str2 += "\u2028";
                    break;
                  case "P":
                    str2 += "\u2029";
                    break;
                  case " ":
                    str2 += " ";
                    break;
                  case '"':
                    str2 += '"';
                    break;
                  case "/":
                    str2 += "/";
                    break;
                  case "\\":
                    str2 += "\\";
                    break;
                  case "	":
                    str2 += "	";
                    break;
                  case "x":
                    str2 += this.parseCharCode(i + 1, 2, errors);
                    i += 2;
                    break;
                  case "u":
                    str2 += this.parseCharCode(i + 1, 4, errors);
                    i += 4;
                    break;
                  case "U":
                    str2 += this.parseCharCode(i + 1, 8, errors);
                    i += 8;
                    break;
                  case "\n":
                    while (src[i + 1] === " " || src[i + 1] === "	")
                      i += 1;
                    break;
                  default:
                    errors.push(new PlainValue.YAMLSyntaxError(this, `Invalid escape sequence ${src.substr(i - 1, 2)}`));
                    str2 += "\\" + src[i];
                }
              } else if (ch === " " || ch === "	") {
                const wsStart = i;
                let next = src[i + 1];
                while (next === " " || next === "	") {
                  i += 1;
                  next = src[i + 1];
                }
                if (next !== "\n")
                  str2 += i > wsStart ? src.slice(wsStart, i + 1) : ch;
              } else {
                str2 += ch;
              }
            }
            return errors.length > 0 ? {
              errors,
              str: str2
            } : str2;
          }
          parseCharCode(offset, length, errors) {
            const {
              src
            } = this.context;
            const cc = src.substr(offset, length);
            const ok = cc.length === length && /^[0-9a-fA-F]+$/.test(cc);
            const code = ok ? parseInt(cc, 16) : NaN;
            if (isNaN(code)) {
              errors.push(new PlainValue.YAMLSyntaxError(this, `Invalid escape sequence ${src.substr(offset - 2, length + 2)}`));
              return src.substr(offset - 2, length + 2);
            }
            return String.fromCodePoint(code);
          }
          parse(context, start) {
            this.context = context;
            const {
              src
            } = context;
            let offset = QuoteDouble.endOfQuote(src, start + 1);
            this.valueRange = new PlainValue.Range(start, offset);
            offset = PlainValue.Node.endOfWhiteSpace(src, offset);
            offset = this.parseComment(offset);
            return offset;
          }
        };
        var QuoteSingle = class extends PlainValue.Node {
          static endOfQuote(src, offset) {
            let ch = src[offset];
            while (ch) {
              if (ch === "'") {
                if (src[offset + 1] !== "'")
                  break;
                ch = src[offset += 2];
              } else {
                ch = src[offset += 1];
              }
            }
            return offset + 1;
          }
          get strValue() {
            if (!this.valueRange || !this.context)
              return null;
            const errors = [];
            const {
              start,
              end
            } = this.valueRange;
            const {
              indent,
              src
            } = this.context;
            if (src[end - 1] !== "'")
              errors.push(new PlainValue.YAMLSyntaxError(this, "Missing closing 'quote"));
            let str2 = "";
            for (let i = start + 1; i < end - 1; ++i) {
              const ch = src[i];
              if (ch === "\n") {
                if (PlainValue.Node.atDocumentBoundary(src, i + 1))
                  errors.push(new PlainValue.YAMLSemanticError(this, "Document boundary indicators are not allowed within string values"));
                const {
                  fold,
                  offset,
                  error
                } = PlainValue.Node.foldNewline(src, i, indent);
                str2 += fold;
                i = offset;
                if (error)
                  errors.push(new PlainValue.YAMLSemanticError(this, "Multi-line single-quoted string needs to be sufficiently indented"));
              } else if (ch === "'") {
                str2 += ch;
                i += 1;
                if (src[i] !== "'")
                  errors.push(new PlainValue.YAMLSyntaxError(this, "Unescaped single quote? This should not happen."));
              } else if (ch === " " || ch === "	") {
                const wsStart = i;
                let next = src[i + 1];
                while (next === " " || next === "	") {
                  i += 1;
                  next = src[i + 1];
                }
                if (next !== "\n")
                  str2 += i > wsStart ? src.slice(wsStart, i + 1) : ch;
              } else {
                str2 += ch;
              }
            }
            return errors.length > 0 ? {
              errors,
              str: str2
            } : str2;
          }
          parse(context, start) {
            this.context = context;
            const {
              src
            } = context;
            let offset = QuoteSingle.endOfQuote(src, start + 1);
            this.valueRange = new PlainValue.Range(start, offset);
            offset = PlainValue.Node.endOfWhiteSpace(src, offset);
            offset = this.parseComment(offset);
            return offset;
          }
        };
        function createNewNode(type2, props) {
          switch (type2) {
            case PlainValue.Type.ALIAS:
              return new Alias(type2, props);
            case PlainValue.Type.BLOCK_FOLDED:
            case PlainValue.Type.BLOCK_LITERAL:
              return new BlockValue(type2, props);
            case PlainValue.Type.FLOW_MAP:
            case PlainValue.Type.FLOW_SEQ:
              return new FlowCollection(type2, props);
            case PlainValue.Type.MAP_KEY:
            case PlainValue.Type.MAP_VALUE:
            case PlainValue.Type.SEQ_ITEM:
              return new CollectionItem(type2, props);
            case PlainValue.Type.COMMENT:
            case PlainValue.Type.PLAIN:
              return new PlainValue.PlainValue(type2, props);
            case PlainValue.Type.QUOTE_DOUBLE:
              return new QuoteDouble(type2, props);
            case PlainValue.Type.QUOTE_SINGLE:
              return new QuoteSingle(type2, props);
            default:
              return null;
          }
        }
        var ParseContext = class {
          static parseType(src, offset, inFlow) {
            switch (src[offset]) {
              case "*":
                return PlainValue.Type.ALIAS;
              case ">":
                return PlainValue.Type.BLOCK_FOLDED;
              case "|":
                return PlainValue.Type.BLOCK_LITERAL;
              case "{":
                return PlainValue.Type.FLOW_MAP;
              case "[":
                return PlainValue.Type.FLOW_SEQ;
              case "?":
                return !inFlow && PlainValue.Node.atBlank(src, offset + 1, true) ? PlainValue.Type.MAP_KEY : PlainValue.Type.PLAIN;
              case ":":
                return !inFlow && PlainValue.Node.atBlank(src, offset + 1, true) ? PlainValue.Type.MAP_VALUE : PlainValue.Type.PLAIN;
              case "-":
                return !inFlow && PlainValue.Node.atBlank(src, offset + 1, true) ? PlainValue.Type.SEQ_ITEM : PlainValue.Type.PLAIN;
              case '"':
                return PlainValue.Type.QUOTE_DOUBLE;
              case "'":
                return PlainValue.Type.QUOTE_SINGLE;
              default:
                return PlainValue.Type.PLAIN;
            }
          }
          constructor(orig = {}, {
            atLineStart,
            inCollection,
            inFlow,
            indent,
            lineStart,
            parent
          } = {}) {
            PlainValue._defineProperty(this, "parseNode", (overlay, start) => {
              if (PlainValue.Node.atDocumentBoundary(this.src, start))
                return null;
              const context = new ParseContext(this, overlay);
              const {
                props,
                type: type2,
                valueStart
              } = context.parseProps(start);
              const node = createNewNode(type2, props);
              let offset = node.parse(context, valueStart);
              node.range = new PlainValue.Range(start, offset);
              if (offset <= start) {
                node.error = new Error(`Node#parse consumed no characters`);
                node.error.parseEnd = offset;
                node.error.source = node;
                node.range.end = start + 1;
              }
              if (context.nodeStartsCollection(node)) {
                if (!node.error && !context.atLineStart && context.parent.type === PlainValue.Type.DOCUMENT) {
                  node.error = new PlainValue.YAMLSyntaxError(node, "Block collection must not have preceding content here (e.g. directives-end indicator)");
                }
                const collection = new Collection(node);
                offset = collection.parse(new ParseContext(context), offset);
                collection.range = new PlainValue.Range(start, offset);
                return collection;
              }
              return node;
            });
            this.atLineStart = atLineStart != null ? atLineStart : orig.atLineStart || false;
            this.inCollection = inCollection != null ? inCollection : orig.inCollection || false;
            this.inFlow = inFlow != null ? inFlow : orig.inFlow || false;
            this.indent = indent != null ? indent : orig.indent;
            this.lineStart = lineStart != null ? lineStart : orig.lineStart;
            this.parent = parent != null ? parent : orig.parent || {};
            this.root = orig.root;
            this.src = orig.src;
          }
          nodeStartsCollection(node) {
            const {
              inCollection,
              inFlow,
              src
            } = this;
            if (inCollection || inFlow)
              return false;
            if (node instanceof CollectionItem)
              return true;
            let offset = node.range.end;
            if (src[offset] === "\n" || src[offset - 1] === "\n")
              return false;
            offset = PlainValue.Node.endOfWhiteSpace(src, offset);
            return src[offset] === ":";
          }
          parseProps(offset) {
            const {
              inFlow,
              parent,
              src
            } = this;
            const props = [];
            let lineHasProps = false;
            offset = this.atLineStart ? PlainValue.Node.endOfIndent(src, offset) : PlainValue.Node.endOfWhiteSpace(src, offset);
            let ch = src[offset];
            while (ch === PlainValue.Char.ANCHOR || ch === PlainValue.Char.COMMENT || ch === PlainValue.Char.TAG || ch === "\n") {
              if (ch === "\n") {
                let inEnd = offset;
                let lineStart;
                do {
                  lineStart = inEnd + 1;
                  inEnd = PlainValue.Node.endOfIndent(src, lineStart);
                } while (src[inEnd] === "\n");
                const indentDiff = inEnd - (lineStart + this.indent);
                const noIndicatorAsIndent = parent.type === PlainValue.Type.SEQ_ITEM && parent.context.atLineStart;
                if (src[inEnd] !== "#" && !PlainValue.Node.nextNodeIsIndented(src[inEnd], indentDiff, !noIndicatorAsIndent))
                  break;
                this.atLineStart = true;
                this.lineStart = lineStart;
                lineHasProps = false;
                offset = inEnd;
              } else if (ch === PlainValue.Char.COMMENT) {
                const end = PlainValue.Node.endOfLine(src, offset + 1);
                props.push(new PlainValue.Range(offset, end));
                offset = end;
              } else {
                let end = PlainValue.Node.endOfIdentifier(src, offset + 1);
                if (ch === PlainValue.Char.TAG && src[end] === "," && /^[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+,\d\d\d\d(-\d\d){0,2}\/\S/.test(src.slice(offset + 1, end + 13))) {
                  end = PlainValue.Node.endOfIdentifier(src, end + 5);
                }
                props.push(new PlainValue.Range(offset, end));
                lineHasProps = true;
                offset = PlainValue.Node.endOfWhiteSpace(src, end);
              }
              ch = src[offset];
            }
            if (lineHasProps && ch === ":" && PlainValue.Node.atBlank(src, offset + 1, true))
              offset -= 1;
            const type2 = ParseContext.parseType(src, offset, inFlow);
            return {
              props,
              type: type2,
              valueStart: offset
            };
          }
        };
        function parse2(src) {
          const cr = [];
          if (src.indexOf("\r") !== -1) {
            src = src.replace(/\r\n?/g, (match, offset2) => {
              if (match.length > 1)
                cr.push(offset2);
              return "\n";
            });
          }
          const documents = [];
          let offset = 0;
          do {
            const doc = new Document();
            const context = new ParseContext({
              src
            });
            offset = doc.parse(context, offset);
            documents.push(doc);
          } while (offset < src.length);
          documents.setOrigRanges = () => {
            if (cr.length === 0)
              return false;
            for (let i = 1; i < cr.length; ++i)
              cr[i] -= i;
            let crOffset = 0;
            for (let i = 0; i < documents.length; ++i) {
              crOffset = documents[i].setOrigRanges(cr, crOffset);
            }
            cr.splice(0, cr.length);
            return true;
          };
          documents.toString = () => documents.join("...\n");
          return documents;
        }
        exports22.parse = parse2;
      }
    });
    var require_resolveSeq_d03cb037 = __commonJS2({
      "node_modules/yaml/dist/resolveSeq-d03cb037.js"(exports22) {
        "use strict";
        var PlainValue = require_PlainValue_ec8e588e();
        function addCommentBefore(str2, indent, comment) {
          if (!comment)
            return str2;
          const cc = comment.replace(/[\s\S]^/gm, `$&${indent}#`);
          return `#${cc}
${indent}${str2}`;
        }
        function addComment(str2, indent, comment) {
          return !comment ? str2 : comment.indexOf("\n") === -1 ? `${str2} #${comment}` : `${str2}
` + comment.replace(/^/gm, `${indent || ""}#`);
        }
        var Node = class {
        };
        function toJSON(value, arg, ctx) {
          if (Array.isArray(value))
            return value.map((v, i) => toJSON(v, String(i), ctx));
          if (value && typeof value.toJSON === "function") {
            const anchor = ctx && ctx.anchors && ctx.anchors.get(value);
            if (anchor)
              ctx.onCreate = (res2) => {
                anchor.res = res2;
                delete ctx.onCreate;
              };
            const res = value.toJSON(arg, ctx);
            if (anchor && ctx.onCreate)
              ctx.onCreate(res);
            return res;
          }
          if ((!ctx || !ctx.keep) && typeof value === "bigint")
            return Number(value);
          return value;
        }
        var Scalar = class extends Node {
          constructor(value) {
            super();
            this.value = value;
          }
          toJSON(arg, ctx) {
            return ctx && ctx.keep ? this.value : toJSON(this.value, arg, ctx);
          }
          toString() {
            return String(this.value);
          }
        };
        function collectionFromPath(schema2, path5, value) {
          let v = value;
          for (let i = path5.length - 1; i >= 0; --i) {
            const k = path5[i];
            if (Number.isInteger(k) && k >= 0) {
              const a = [];
              a[k] = v;
              v = a;
            } else {
              const o = {};
              Object.defineProperty(o, k, {
                value: v,
                writable: true,
                enumerable: true,
                configurable: true
              });
              v = o;
            }
          }
          return schema2.createNode(v, false);
        }
        var isEmptyPath = (path5) => path5 == null || typeof path5 === "object" && path5[Symbol.iterator]().next().done;
        var Collection = class extends Node {
          constructor(schema2) {
            super();
            PlainValue._defineProperty(this, "items", []);
            this.schema = schema2;
          }
          addIn(path5, value) {
            if (isEmptyPath(path5))
              this.add(value);
            else {
              const [key, ...rest] = path5;
              const node = this.get(key, true);
              if (node instanceof Collection)
                node.addIn(rest, value);
              else if (node === void 0 && this.schema)
                this.set(key, collectionFromPath(this.schema, rest, value));
              else
                throw new Error(`Expected YAML collection at ${key}. Remaining path: ${rest}`);
            }
          }
          deleteIn([key, ...rest]) {
            if (rest.length === 0)
              return this.delete(key);
            const node = this.get(key, true);
            if (node instanceof Collection)
              return node.deleteIn(rest);
            else
              throw new Error(`Expected YAML collection at ${key}. Remaining path: ${rest}`);
          }
          getIn([key, ...rest], keepScalar) {
            const node = this.get(key, true);
            if (rest.length === 0)
              return !keepScalar && node instanceof Scalar ? node.value : node;
            else
              return node instanceof Collection ? node.getIn(rest, keepScalar) : void 0;
          }
          hasAllNullValues() {
            return this.items.every((node) => {
              if (!node || node.type !== "PAIR")
                return false;
              const n = node.value;
              return n == null || n instanceof Scalar && n.value == null && !n.commentBefore && !n.comment && !n.tag;
            });
          }
          hasIn([key, ...rest]) {
            if (rest.length === 0)
              return this.has(key);
            const node = this.get(key, true);
            return node instanceof Collection ? node.hasIn(rest) : false;
          }
          setIn([key, ...rest], value) {
            if (rest.length === 0) {
              this.set(key, value);
            } else {
              const node = this.get(key, true);
              if (node instanceof Collection)
                node.setIn(rest, value);
              else if (node === void 0 && this.schema)
                this.set(key, collectionFromPath(this.schema, rest, value));
              else
                throw new Error(`Expected YAML collection at ${key}. Remaining path: ${rest}`);
            }
          }
          toJSON() {
            return null;
          }
          toString(ctx, {
            blockItem,
            flowChars,
            isMap,
            itemIndent
          }, onComment, onChompKeep) {
            const {
              indent,
              indentStep,
              stringify
            } = ctx;
            const inFlow = this.type === PlainValue.Type.FLOW_MAP || this.type === PlainValue.Type.FLOW_SEQ || ctx.inFlow;
            if (inFlow)
              itemIndent += indentStep;
            const allNullValues = isMap && this.hasAllNullValues();
            ctx = Object.assign({}, ctx, {
              allNullValues,
              indent: itemIndent,
              inFlow,
              type: null
            });
            let chompKeep = false;
            let hasItemWithNewLine = false;
            const nodes = this.items.reduce((nodes2, item, i) => {
              let comment;
              if (item) {
                if (!chompKeep && item.spaceBefore)
                  nodes2.push({
                    type: "comment",
                    str: ""
                  });
                if (item.commentBefore)
                  item.commentBefore.match(/^.*$/gm).forEach((line) => {
                    nodes2.push({
                      type: "comment",
                      str: `#${line}`
                    });
                  });
                if (item.comment)
                  comment = item.comment;
                if (inFlow && (!chompKeep && item.spaceBefore || item.commentBefore || item.comment || item.key && (item.key.commentBefore || item.key.comment) || item.value && (item.value.commentBefore || item.value.comment)))
                  hasItemWithNewLine = true;
              }
              chompKeep = false;
              let str22 = stringify(item, ctx, () => comment = null, () => chompKeep = true);
              if (inFlow && !hasItemWithNewLine && str22.includes("\n"))
                hasItemWithNewLine = true;
              if (inFlow && i < this.items.length - 1)
                str22 += ",";
              str22 = addComment(str22, itemIndent, comment);
              if (chompKeep && (comment || inFlow))
                chompKeep = false;
              nodes2.push({
                type: "item",
                str: str22
              });
              return nodes2;
            }, []);
            let str2;
            if (nodes.length === 0) {
              str2 = flowChars.start + flowChars.end;
            } else if (inFlow) {
              const {
                start,
                end
              } = flowChars;
              const strings = nodes.map((n) => n.str);
              if (hasItemWithNewLine || strings.reduce((sum, str22) => sum + str22.length + 2, 2) > Collection.maxFlowStringSingleLineLength) {
                str2 = start;
                for (const s of strings) {
                  str2 += s ? `
${indentStep}${indent}${s}` : "\n";
                }
                str2 += `
${indent}${end}`;
              } else {
                str2 = `${start} ${strings.join(" ")} ${end}`;
              }
            } else {
              const strings = nodes.map(blockItem);
              str2 = strings.shift();
              for (const s of strings)
                str2 += s ? `
${indent}${s}` : "\n";
            }
            if (this.comment) {
              str2 += "\n" + this.comment.replace(/^/gm, `${indent}#`);
              if (onComment)
                onComment();
            } else if (chompKeep && onChompKeep)
              onChompKeep();
            return str2;
          }
        };
        PlainValue._defineProperty(Collection, "maxFlowStringSingleLineLength", 60);
        function asItemIndex(key) {
          let idx = key instanceof Scalar ? key.value : key;
          if (idx && typeof idx === "string")
            idx = Number(idx);
          return Number.isInteger(idx) && idx >= 0 ? idx : null;
        }
        var YAMLSeq = class extends Collection {
          add(value) {
            this.items.push(value);
          }
          delete(key) {
            const idx = asItemIndex(key);
            if (typeof idx !== "number")
              return false;
            const del = this.items.splice(idx, 1);
            return del.length > 0;
          }
          get(key, keepScalar) {
            const idx = asItemIndex(key);
            if (typeof idx !== "number")
              return void 0;
            const it = this.items[idx];
            return !keepScalar && it instanceof Scalar ? it.value : it;
          }
          has(key) {
            const idx = asItemIndex(key);
            return typeof idx === "number" && idx < this.items.length;
          }
          set(key, value) {
            const idx = asItemIndex(key);
            if (typeof idx !== "number")
              throw new Error(`Expected a valid index, not ${key}.`);
            this.items[idx] = value;
          }
          toJSON(_, ctx) {
            const seq2 = [];
            if (ctx && ctx.onCreate)
              ctx.onCreate(seq2);
            let i = 0;
            for (const item of this.items)
              seq2.push(toJSON(item, String(i++), ctx));
            return seq2;
          }
          toString(ctx, onComment, onChompKeep) {
            if (!ctx)
              return JSON.stringify(this);
            return super.toString(ctx, {
              blockItem: (n) => n.type === "comment" ? n.str : `- ${n.str}`,
              flowChars: {
                start: "[",
                end: "]"
              },
              isMap: false,
              itemIndent: (ctx.indent || "") + "  "
            }, onComment, onChompKeep);
          }
        };
        var stringifyKey = (key, jsKey, ctx) => {
          if (jsKey === null)
            return "";
          if (typeof jsKey !== "object")
            return String(jsKey);
          if (key instanceof Node && ctx && ctx.doc)
            return key.toString({
              anchors: /* @__PURE__ */ Object.create(null),
              doc: ctx.doc,
              indent: "",
              indentStep: ctx.indentStep,
              inFlow: true,
              inStringifyKey: true,
              stringify: ctx.stringify
            });
          return JSON.stringify(jsKey);
        };
        var Pair = class extends Node {
          constructor(key, value = null) {
            super();
            this.key = key;
            this.value = value;
            this.type = Pair.Type.PAIR;
          }
          get commentBefore() {
            return this.key instanceof Node ? this.key.commentBefore : void 0;
          }
          set commentBefore(cb) {
            if (this.key == null)
              this.key = new Scalar(null);
            if (this.key instanceof Node)
              this.key.commentBefore = cb;
            else {
              const msg = "Pair.commentBefore is an alias for Pair.key.commentBefore. To set it, the key must be a Node.";
              throw new Error(msg);
            }
          }
          addToJSMap(ctx, map2) {
            const key = toJSON(this.key, "", ctx);
            if (map2 instanceof Map) {
              const value = toJSON(this.value, key, ctx);
              map2.set(key, value);
            } else if (map2 instanceof Set) {
              map2.add(key);
            } else {
              const stringKey = stringifyKey(this.key, key, ctx);
              const value = toJSON(this.value, stringKey, ctx);
              if (stringKey in map2)
                Object.defineProperty(map2, stringKey, {
                  value,
                  writable: true,
                  enumerable: true,
                  configurable: true
                });
              else
                map2[stringKey] = value;
            }
            return map2;
          }
          toJSON(_, ctx) {
            const pair = ctx && ctx.mapAsMap ? /* @__PURE__ */ new Map() : {};
            return this.addToJSMap(ctx, pair);
          }
          toString(ctx, onComment, onChompKeep) {
            if (!ctx || !ctx.doc)
              return JSON.stringify(this);
            const {
              indent: indentSize,
              indentSeq,
              simpleKeys
            } = ctx.doc.options;
            let {
              key,
              value
            } = this;
            let keyComment = key instanceof Node && key.comment;
            if (simpleKeys) {
              if (keyComment) {
                throw new Error("With simple keys, key nodes cannot have comments");
              }
              if (key instanceof Collection) {
                const msg = "With simple keys, collection cannot be used as a key value";
                throw new Error(msg);
              }
            }
            let explicitKey = !simpleKeys && (!key || keyComment || (key instanceof Node ? key instanceof Collection || key.type === PlainValue.Type.BLOCK_FOLDED || key.type === PlainValue.Type.BLOCK_LITERAL : typeof key === "object"));
            const {
              doc,
              indent,
              indentStep,
              stringify
            } = ctx;
            ctx = Object.assign({}, ctx, {
              implicitKey: !explicitKey,
              indent: indent + indentStep
            });
            let chompKeep = false;
            let str2 = stringify(key, ctx, () => keyComment = null, () => chompKeep = true);
            str2 = addComment(str2, ctx.indent, keyComment);
            if (!explicitKey && str2.length > 1024) {
              if (simpleKeys)
                throw new Error("With simple keys, single line scalar must not span more than 1024 characters");
              explicitKey = true;
            }
            if (ctx.allNullValues && !simpleKeys) {
              if (this.comment) {
                str2 = addComment(str2, ctx.indent, this.comment);
                if (onComment)
                  onComment();
              } else if (chompKeep && !keyComment && onChompKeep)
                onChompKeep();
              return ctx.inFlow && !explicitKey ? str2 : `? ${str2}`;
            }
            str2 = explicitKey ? `? ${str2}
${indent}:` : `${str2}:`;
            if (this.comment) {
              str2 = addComment(str2, ctx.indent, this.comment);
              if (onComment)
                onComment();
            }
            let vcb = "";
            let valueComment = null;
            if (value instanceof Node) {
              if (value.spaceBefore)
                vcb = "\n";
              if (value.commentBefore) {
                const cs = value.commentBefore.replace(/^/gm, `${ctx.indent}#`);
                vcb += `
${cs}`;
              }
              valueComment = value.comment;
            } else if (value && typeof value === "object") {
              value = doc.schema.createNode(value, true);
            }
            ctx.implicitKey = false;
            if (!explicitKey && !this.comment && value instanceof Scalar)
              ctx.indentAtStart = str2.length + 1;
            chompKeep = false;
            if (!indentSeq && indentSize >= 2 && !ctx.inFlow && !explicitKey && value instanceof YAMLSeq && value.type !== PlainValue.Type.FLOW_SEQ && !value.tag && !doc.anchors.getName(value)) {
              ctx.indent = ctx.indent.substr(2);
            }
            const valueStr = stringify(value, ctx, () => valueComment = null, () => chompKeep = true);
            let ws = " ";
            if (vcb || this.comment) {
              ws = `${vcb}
${ctx.indent}`;
            } else if (!explicitKey && value instanceof Collection) {
              const flow = valueStr[0] === "[" || valueStr[0] === "{";
              if (!flow || valueStr.includes("\n"))
                ws = `
${ctx.indent}`;
            } else if (valueStr[0] === "\n")
              ws = "";
            if (chompKeep && !valueComment && onChompKeep)
              onChompKeep();
            return addComment(str2 + ws + valueStr, ctx.indent, valueComment);
          }
        };
        PlainValue._defineProperty(Pair, "Type", {
          PAIR: "PAIR",
          MERGE_PAIR: "MERGE_PAIR"
        });
        var getAliasCount = (node, anchors) => {
          if (node instanceof Alias) {
            const anchor = anchors.get(node.source);
            return anchor.count * anchor.aliasCount;
          } else if (node instanceof Collection) {
            let count = 0;
            for (const item of node.items) {
              const c = getAliasCount(item, anchors);
              if (c > count)
                count = c;
            }
            return count;
          } else if (node instanceof Pair) {
            const kc = getAliasCount(node.key, anchors);
            const vc = getAliasCount(node.value, anchors);
            return Math.max(kc, vc);
          }
          return 1;
        };
        var Alias = class extends Node {
          static stringify({
            range,
            source
          }, {
            anchors,
            doc,
            implicitKey,
            inStringifyKey
          }) {
            let anchor = Object.keys(anchors).find((a) => anchors[a] === source);
            if (!anchor && inStringifyKey)
              anchor = doc.anchors.getName(source) || doc.anchors.newName();
            if (anchor)
              return `*${anchor}${implicitKey ? " " : ""}`;
            const msg = doc.anchors.getName(source) ? "Alias node must be after source node" : "Source node not found for alias node";
            throw new Error(`${msg} [${range}]`);
          }
          constructor(source) {
            super();
            this.source = source;
            this.type = PlainValue.Type.ALIAS;
          }
          set tag(t) {
            throw new Error("Alias nodes cannot have tags");
          }
          toJSON(arg, ctx) {
            if (!ctx)
              return toJSON(this.source, arg, ctx);
            const {
              anchors,
              maxAliasCount
            } = ctx;
            const anchor = anchors.get(this.source);
            if (!anchor || anchor.res === void 0) {
              const msg = "This should not happen: Alias anchor was not resolved?";
              if (this.cstNode)
                throw new PlainValue.YAMLReferenceError(this.cstNode, msg);
              else
                throw new ReferenceError(msg);
            }
            if (maxAliasCount >= 0) {
              anchor.count += 1;
              if (anchor.aliasCount === 0)
                anchor.aliasCount = getAliasCount(this.source, anchors);
              if (anchor.count * anchor.aliasCount > maxAliasCount) {
                const msg = "Excessive alias count indicates a resource exhaustion attack";
                if (this.cstNode)
                  throw new PlainValue.YAMLReferenceError(this.cstNode, msg);
                else
                  throw new ReferenceError(msg);
              }
            }
            return anchor.res;
          }
          toString(ctx) {
            return Alias.stringify(this, ctx);
          }
        };
        PlainValue._defineProperty(Alias, "default", true);
        function findPair(items, key) {
          const k = key instanceof Scalar ? key.value : key;
          for (const it of items) {
            if (it instanceof Pair) {
              if (it.key === key || it.key === k)
                return it;
              if (it.key && it.key.value === k)
                return it;
            }
          }
          return void 0;
        }
        var YAMLMap = class extends Collection {
          add(pair, overwrite) {
            if (!pair)
              pair = new Pair(pair);
            else if (!(pair instanceof Pair))
              pair = new Pair(pair.key || pair, pair.value);
            const prev = findPair(this.items, pair.key);
            const sortEntries = this.schema && this.schema.sortMapEntries;
            if (prev) {
              if (overwrite)
                prev.value = pair.value;
              else
                throw new Error(`Key ${pair.key} already set`);
            } else if (sortEntries) {
              const i = this.items.findIndex((item) => sortEntries(pair, item) < 0);
              if (i === -1)
                this.items.push(pair);
              else
                this.items.splice(i, 0, pair);
            } else {
              this.items.push(pair);
            }
          }
          delete(key) {
            const it = findPair(this.items, key);
            if (!it)
              return false;
            const del = this.items.splice(this.items.indexOf(it), 1);
            return del.length > 0;
          }
          get(key, keepScalar) {
            const it = findPair(this.items, key);
            const node = it && it.value;
            return !keepScalar && node instanceof Scalar ? node.value : node;
          }
          has(key) {
            return !!findPair(this.items, key);
          }
          set(key, value) {
            this.add(new Pair(key, value), true);
          }
          toJSON(_, ctx, Type3) {
            const map2 = Type3 ? new Type3() : ctx && ctx.mapAsMap ? /* @__PURE__ */ new Map() : {};
            if (ctx && ctx.onCreate)
              ctx.onCreate(map2);
            for (const item of this.items)
              item.addToJSMap(ctx, map2);
            return map2;
          }
          toString(ctx, onComment, onChompKeep) {
            if (!ctx)
              return JSON.stringify(this);
            for (const item of this.items) {
              if (!(item instanceof Pair))
                throw new Error(`Map items must all be pairs; found ${JSON.stringify(item)} instead`);
            }
            return super.toString(ctx, {
              blockItem: (n) => n.str,
              flowChars: {
                start: "{",
                end: "}"
              },
              isMap: true,
              itemIndent: ctx.indent || ""
            }, onComment, onChompKeep);
          }
        };
        var MERGE_KEY = "<<";
        var Merge = class extends Pair {
          constructor(pair) {
            if (pair instanceof Pair) {
              let seq2 = pair.value;
              if (!(seq2 instanceof YAMLSeq)) {
                seq2 = new YAMLSeq();
                seq2.items.push(pair.value);
                seq2.range = pair.value.range;
              }
              super(pair.key, seq2);
              this.range = pair.range;
            } else {
              super(new Scalar(MERGE_KEY), new YAMLSeq());
            }
            this.type = Pair.Type.MERGE_PAIR;
          }
          addToJSMap(ctx, map2) {
            for (const {
              source
            } of this.value.items) {
              if (!(source instanceof YAMLMap))
                throw new Error("Merge sources must be maps");
              const srcMap = source.toJSON(null, ctx, Map);
              for (const [key, value] of srcMap) {
                if (map2 instanceof Map) {
                  if (!map2.has(key))
                    map2.set(key, value);
                } else if (map2 instanceof Set) {
                  map2.add(key);
                } else if (!Object.prototype.hasOwnProperty.call(map2, key)) {
                  Object.defineProperty(map2, key, {
                    value,
                    writable: true,
                    enumerable: true,
                    configurable: true
                  });
                }
              }
            }
            return map2;
          }
          toString(ctx, onComment) {
            const seq2 = this.value;
            if (seq2.items.length > 1)
              return super.toString(ctx, onComment);
            this.value = seq2.items[0];
            const str2 = super.toString(ctx, onComment);
            this.value = seq2;
            return str2;
          }
        };
        var binaryOptions = {
          defaultType: PlainValue.Type.BLOCK_LITERAL,
          lineWidth: 76
        };
        var boolOptions = {
          trueStr: "true",
          falseStr: "false"
        };
        var intOptions = {
          asBigInt: false
        };
        var nullOptions = {
          nullStr: "null"
        };
        var strOptions = {
          defaultType: PlainValue.Type.PLAIN,
          doubleQuoted: {
            jsonEncoding: false,
            minMultiLineLength: 40
          },
          fold: {
            lineWidth: 80,
            minContentWidth: 20
          }
        };
        function resolveScalar(str2, tags, scalarFallback) {
          for (const {
            format,
            test,
            resolve
          } of tags) {
            if (test) {
              const match = str2.match(test);
              if (match) {
                let res = resolve.apply(null, match);
                if (!(res instanceof Scalar))
                  res = new Scalar(res);
                if (format)
                  res.format = format;
                return res;
              }
            }
          }
          if (scalarFallback)
            str2 = scalarFallback(str2);
          return new Scalar(str2);
        }
        var FOLD_FLOW = "flow";
        var FOLD_BLOCK = "block";
        var FOLD_QUOTED = "quoted";
        var consumeMoreIndentedLines = (text, i) => {
          let ch = text[i + 1];
          while (ch === " " || ch === "	") {
            do {
              ch = text[i += 1];
            } while (ch && ch !== "\n");
            ch = text[i + 1];
          }
          return i;
        };
        function foldFlowLines(text, indent, mode, {
          indentAtStart,
          lineWidth = 80,
          minContentWidth = 20,
          onFold,
          onOverflow
        }) {
          if (!lineWidth || lineWidth < 0)
            return text;
          const endStep = Math.max(1 + minContentWidth, 1 + lineWidth - indent.length);
          if (text.length <= endStep)
            return text;
          const folds = [];
          const escapedFolds = {};
          let end = lineWidth - indent.length;
          if (typeof indentAtStart === "number") {
            if (indentAtStart > lineWidth - Math.max(2, minContentWidth))
              folds.push(0);
            else
              end = lineWidth - indentAtStart;
          }
          let split = void 0;
          let prev = void 0;
          let overflow = false;
          let i = -1;
          let escStart = -1;
          let escEnd = -1;
          if (mode === FOLD_BLOCK) {
            i = consumeMoreIndentedLines(text, i);
            if (i !== -1)
              end = i + endStep;
          }
          for (let ch; ch = text[i += 1]; ) {
            if (mode === FOLD_QUOTED && ch === "\\") {
              escStart = i;
              switch (text[i + 1]) {
                case "x":
                  i += 3;
                  break;
                case "u":
                  i += 5;
                  break;
                case "U":
                  i += 9;
                  break;
                default:
                  i += 1;
              }
              escEnd = i;
            }
            if (ch === "\n") {
              if (mode === FOLD_BLOCK)
                i = consumeMoreIndentedLines(text, i);
              end = i + endStep;
              split = void 0;
            } else {
              if (ch === " " && prev && prev !== " " && prev !== "\n" && prev !== "	") {
                const next = text[i + 1];
                if (next && next !== " " && next !== "\n" && next !== "	")
                  split = i;
              }
              if (i >= end) {
                if (split) {
                  folds.push(split);
                  end = split + endStep;
                  split = void 0;
                } else if (mode === FOLD_QUOTED) {
                  while (prev === " " || prev === "	") {
                    prev = ch;
                    ch = text[i += 1];
                    overflow = true;
                  }
                  const j = i > escEnd + 1 ? i - 2 : escStart - 1;
                  if (escapedFolds[j])
                    return text;
                  folds.push(j);
                  escapedFolds[j] = true;
                  end = j + endStep;
                  split = void 0;
                } else {
                  overflow = true;
                }
              }
            }
            prev = ch;
          }
          if (overflow && onOverflow)
            onOverflow();
          if (folds.length === 0)
            return text;
          if (onFold)
            onFold();
          let res = text.slice(0, folds[0]);
          for (let i2 = 0; i2 < folds.length; ++i2) {
            const fold = folds[i2];
            const end2 = folds[i2 + 1] || text.length;
            if (fold === 0)
              res = `
${indent}${text.slice(0, end2)}`;
            else {
              if (mode === FOLD_QUOTED && escapedFolds[fold])
                res += `${text[fold]}\\`;
              res += `
${indent}${text.slice(fold + 1, end2)}`;
            }
          }
          return res;
        }
        var getFoldOptions = ({
          indentAtStart
        }) => indentAtStart ? Object.assign({
          indentAtStart
        }, strOptions.fold) : strOptions.fold;
        var containsDocumentMarker = (str2) => /^(%|---|\.\.\.)/m.test(str2);
        function lineLengthOverLimit(str2, lineWidth, indentLength) {
          if (!lineWidth || lineWidth < 0)
            return false;
          const limit = lineWidth - indentLength;
          const strLen = str2.length;
          if (strLen <= limit)
            return false;
          for (let i = 0, start = 0; i < strLen; ++i) {
            if (str2[i] === "\n") {
              if (i - start > limit)
                return true;
              start = i + 1;
              if (strLen - start <= limit)
                return false;
            }
          }
          return true;
        }
        function doubleQuotedString(value, ctx) {
          const {
            implicitKey
          } = ctx;
          const {
            jsonEncoding,
            minMultiLineLength
          } = strOptions.doubleQuoted;
          const json2 = JSON.stringify(value);
          if (jsonEncoding)
            return json2;
          const indent = ctx.indent || (containsDocumentMarker(value) ? "  " : "");
          let str2 = "";
          let start = 0;
          for (let i = 0, ch = json2[i]; ch; ch = json2[++i]) {
            if (ch === " " && json2[i + 1] === "\\" && json2[i + 2] === "n") {
              str2 += json2.slice(start, i) + "\\ ";
              i += 1;
              start = i;
              ch = "\\";
            }
            if (ch === "\\")
              switch (json2[i + 1]) {
                case "u":
                  {
                    str2 += json2.slice(start, i);
                    const code = json2.substr(i + 2, 4);
                    switch (code) {
                      case "0000":
                        str2 += "\\0";
                        break;
                      case "0007":
                        str2 += "\\a";
                        break;
                      case "000b":
                        str2 += "\\v";
                        break;
                      case "001b":
                        str2 += "\\e";
                        break;
                      case "0085":
                        str2 += "\\N";
                        break;
                      case "00a0":
                        str2 += "\\_";
                        break;
                      case "2028":
                        str2 += "\\L";
                        break;
                      case "2029":
                        str2 += "\\P";
                        break;
                      default:
                        if (code.substr(0, 2) === "00")
                          str2 += "\\x" + code.substr(2);
                        else
                          str2 += json2.substr(i, 6);
                    }
                    i += 5;
                    start = i + 1;
                  }
                  break;
                case "n":
                  if (implicitKey || json2[i + 2] === '"' || json2.length < minMultiLineLength) {
                    i += 1;
                  } else {
                    str2 += json2.slice(start, i) + "\n\n";
                    while (json2[i + 2] === "\\" && json2[i + 3] === "n" && json2[i + 4] !== '"') {
                      str2 += "\n";
                      i += 2;
                    }
                    str2 += indent;
                    if (json2[i + 2] === " ")
                      str2 += "\\";
                    i += 1;
                    start = i + 1;
                  }
                  break;
                default:
                  i += 1;
              }
          }
          str2 = start ? str2 + json2.slice(start) : json2;
          return implicitKey ? str2 : foldFlowLines(str2, indent, FOLD_QUOTED, getFoldOptions(ctx));
        }
        function singleQuotedString(value, ctx) {
          if (ctx.implicitKey) {
            if (/\n/.test(value))
              return doubleQuotedString(value, ctx);
          } else {
            if (/[ \t]\n|\n[ \t]/.test(value))
              return doubleQuotedString(value, ctx);
          }
          const indent = ctx.indent || (containsDocumentMarker(value) ? "  " : "");
          const res = "'" + value.replace(/'/g, "''").replace(/\n+/g, `$&
${indent}`) + "'";
          return ctx.implicitKey ? res : foldFlowLines(res, indent, FOLD_FLOW, getFoldOptions(ctx));
        }
        function blockString({
          comment,
          type: type2,
          value
        }, ctx, onComment, onChompKeep) {
          if (/\n[\t ]+$/.test(value) || /^\s*$/.test(value)) {
            return doubleQuotedString(value, ctx);
          }
          const indent = ctx.indent || (ctx.forceBlockIndent || containsDocumentMarker(value) ? "  " : "");
          const indentSize = indent ? "2" : "1";
          const literal = type2 === PlainValue.Type.BLOCK_FOLDED ? false : type2 === PlainValue.Type.BLOCK_LITERAL ? true : !lineLengthOverLimit(value, strOptions.fold.lineWidth, indent.length);
          let header = literal ? "|" : ">";
          if (!value)
            return header + "\n";
          let wsStart = "";
          let wsEnd = "";
          value = value.replace(/[\n\t ]*$/, (ws) => {
            const n = ws.indexOf("\n");
            if (n === -1) {
              header += "-";
            } else if (value === ws || n !== ws.length - 1) {
              header += "+";
              if (onChompKeep)
                onChompKeep();
            }
            wsEnd = ws.replace(/\n$/, "");
            return "";
          }).replace(/^[\n ]*/, (ws) => {
            if (ws.indexOf(" ") !== -1)
              header += indentSize;
            const m = ws.match(/ +$/);
            if (m) {
              wsStart = ws.slice(0, -m[0].length);
              return m[0];
            } else {
              wsStart = ws;
              return "";
            }
          });
          if (wsEnd)
            wsEnd = wsEnd.replace(/\n+(?!\n|$)/g, `$&${indent}`);
          if (wsStart)
            wsStart = wsStart.replace(/\n+/g, `$&${indent}`);
          if (comment) {
            header += " #" + comment.replace(/ ?[\r\n]+/g, " ");
            if (onComment)
              onComment();
          }
          if (!value)
            return `${header}${indentSize}
${indent}${wsEnd}`;
          if (literal) {
            value = value.replace(/\n+/g, `$&${indent}`);
            return `${header}
${indent}${wsStart}${value}${wsEnd}`;
          }
          value = value.replace(/\n+/g, "\n$&").replace(/(?:^|\n)([\t ].*)(?:([\n\t ]*)\n(?![\n\t ]))?/g, "$1$2").replace(/\n+/g, `$&${indent}`);
          const body = foldFlowLines(`${wsStart}${value}${wsEnd}`, indent, FOLD_BLOCK, strOptions.fold);
          return `${header}
${indent}${body}`;
        }
        function plainString(item, ctx, onComment, onChompKeep) {
          const {
            comment,
            type: type2,
            value
          } = item;
          const {
            actualString,
            implicitKey,
            indent,
            inFlow
          } = ctx;
          if (implicitKey && /[\n[\]{},]/.test(value) || inFlow && /[[\]{},]/.test(value)) {
            return doubleQuotedString(value, ctx);
          }
          if (!value || /^[\n\t ,[\]{}#&*!|>'"%@`]|^[?-]$|^[?-][ \t]|[\n:][ \t]|[ \t]\n|[\n\t ]#|[\n\t :]$/.test(value)) {
            return implicitKey || inFlow || value.indexOf("\n") === -1 ? value.indexOf('"') !== -1 && value.indexOf("'") === -1 ? singleQuotedString(value, ctx) : doubleQuotedString(value, ctx) : blockString(item, ctx, onComment, onChompKeep);
          }
          if (!implicitKey && !inFlow && type2 !== PlainValue.Type.PLAIN && value.indexOf("\n") !== -1) {
            return blockString(item, ctx, onComment, onChompKeep);
          }
          if (indent === "" && containsDocumentMarker(value)) {
            ctx.forceBlockIndent = true;
            return blockString(item, ctx, onComment, onChompKeep);
          }
          const str2 = value.replace(/\n+/g, `$&
${indent}`);
          if (actualString) {
            const {
              tags
            } = ctx.doc.schema;
            const resolved = resolveScalar(str2, tags, tags.scalarFallback).value;
            if (typeof resolved !== "string")
              return doubleQuotedString(value, ctx);
          }
          const body = implicitKey ? str2 : foldFlowLines(str2, indent, FOLD_FLOW, getFoldOptions(ctx));
          if (comment && !inFlow && (body.indexOf("\n") !== -1 || comment.indexOf("\n") !== -1)) {
            if (onComment)
              onComment();
            return addCommentBefore(body, indent, comment);
          }
          return body;
        }
        function stringifyString(item, ctx, onComment, onChompKeep) {
          const {
            defaultType
          } = strOptions;
          const {
            implicitKey,
            inFlow
          } = ctx;
          let {
            type: type2,
            value
          } = item;
          if (typeof value !== "string") {
            value = String(value);
            item = Object.assign({}, item, {
              value
            });
          }
          const _stringify = (_type) => {
            switch (_type) {
              case PlainValue.Type.BLOCK_FOLDED:
              case PlainValue.Type.BLOCK_LITERAL:
                return blockString(item, ctx, onComment, onChompKeep);
              case PlainValue.Type.QUOTE_DOUBLE:
                return doubleQuotedString(value, ctx);
              case PlainValue.Type.QUOTE_SINGLE:
                return singleQuotedString(value, ctx);
              case PlainValue.Type.PLAIN:
                return plainString(item, ctx, onComment, onChompKeep);
              default:
                return null;
            }
          };
          if (type2 !== PlainValue.Type.QUOTE_DOUBLE && /[\x00-\x08\x0b-\x1f\x7f-\x9f]/.test(value)) {
            type2 = PlainValue.Type.QUOTE_DOUBLE;
          } else if ((implicitKey || inFlow) && (type2 === PlainValue.Type.BLOCK_FOLDED || type2 === PlainValue.Type.BLOCK_LITERAL)) {
            type2 = PlainValue.Type.QUOTE_DOUBLE;
          }
          let res = _stringify(type2);
          if (res === null) {
            res = _stringify(defaultType);
            if (res === null)
              throw new Error(`Unsupported default string type ${defaultType}`);
          }
          return res;
        }
        function stringifyNumber({
          format,
          minFractionDigits,
          tag,
          value
        }) {
          if (typeof value === "bigint")
            return String(value);
          if (!isFinite(value))
            return isNaN(value) ? ".nan" : value < 0 ? "-.inf" : ".inf";
          let n = JSON.stringify(value);
          if (!format && minFractionDigits && (!tag || tag === "tag:yaml.org,2002:float") && /^\d/.test(n)) {
            let i = n.indexOf(".");
            if (i < 0) {
              i = n.length;
              n += ".";
            }
            let d = minFractionDigits - (n.length - i - 1);
            while (d-- > 0)
              n += "0";
          }
          return n;
        }
        function checkFlowCollectionEnd(errors, cst) {
          let char, name;
          switch (cst.type) {
            case PlainValue.Type.FLOW_MAP:
              char = "}";
              name = "flow map";
              break;
            case PlainValue.Type.FLOW_SEQ:
              char = "]";
              name = "flow sequence";
              break;
            default:
              errors.push(new PlainValue.YAMLSemanticError(cst, "Not a flow collection!?"));
              return;
          }
          let lastItem;
          for (let i = cst.items.length - 1; i >= 0; --i) {
            const item = cst.items[i];
            if (!item || item.type !== PlainValue.Type.COMMENT) {
              lastItem = item;
              break;
            }
          }
          if (lastItem && lastItem.char !== char) {
            const msg = `Expected ${name} to end with ${char}`;
            let err;
            if (typeof lastItem.offset === "number") {
              err = new PlainValue.YAMLSemanticError(cst, msg);
              err.offset = lastItem.offset + 1;
            } else {
              err = new PlainValue.YAMLSemanticError(lastItem, msg);
              if (lastItem.range && lastItem.range.end)
                err.offset = lastItem.range.end - lastItem.range.start;
            }
            errors.push(err);
          }
        }
        function checkFlowCommentSpace(errors, comment) {
          const prev = comment.context.src[comment.range.start - 1];
          if (prev !== "\n" && prev !== "	" && prev !== " ") {
            const msg = "Comments must be separated from other tokens by white space characters";
            errors.push(new PlainValue.YAMLSemanticError(comment, msg));
          }
        }
        function getLongKeyError(source, key) {
          const sk = String(key);
          const k = sk.substr(0, 8) + "..." + sk.substr(-8);
          return new PlainValue.YAMLSemanticError(source, `The "${k}" key is too long`);
        }
        function resolveComments(collection, comments) {
          for (const {
            afterKey,
            before,
            comment
          } of comments) {
            let item = collection.items[before];
            if (!item) {
              if (comment !== void 0) {
                if (collection.comment)
                  collection.comment += "\n" + comment;
                else
                  collection.comment = comment;
              }
            } else {
              if (afterKey && item.value)
                item = item.value;
              if (comment === void 0) {
                if (afterKey || !item.commentBefore)
                  item.spaceBefore = true;
              } else {
                if (item.commentBefore)
                  item.commentBefore += "\n" + comment;
                else
                  item.commentBefore = comment;
              }
            }
          }
        }
        function resolveString(doc, node) {
          const res = node.strValue;
          if (!res)
            return "";
          if (typeof res === "string")
            return res;
          res.errors.forEach((error) => {
            if (!error.source)
              error.source = node;
            doc.errors.push(error);
          });
          return res.str;
        }
        function resolveTagHandle(doc, node) {
          const {
            handle,
            suffix
          } = node.tag;
          let prefix = doc.tagPrefixes.find((p) => p.handle === handle);
          if (!prefix) {
            const dtp = doc.getDefaults().tagPrefixes;
            if (dtp)
              prefix = dtp.find((p) => p.handle === handle);
            if (!prefix)
              throw new PlainValue.YAMLSemanticError(node, `The ${handle} tag handle is non-default and was not declared.`);
          }
          if (!suffix)
            throw new PlainValue.YAMLSemanticError(node, `The ${handle} tag has no suffix.`);
          if (handle === "!" && (doc.version || doc.options.version) === "1.0") {
            if (suffix[0] === "^") {
              doc.warnings.push(new PlainValue.YAMLWarning(node, "YAML 1.0 ^ tag expansion is not supported"));
              return suffix;
            }
            if (/[:/]/.test(suffix)) {
              const vocab = suffix.match(/^([a-z0-9-]+)\/(.*)/i);
              return vocab ? `tag:${vocab[1]}.yaml.org,2002:${vocab[2]}` : `tag:${suffix}`;
            }
          }
          return prefix.prefix + decodeURIComponent(suffix);
        }
        function resolveTagName(doc, node) {
          const {
            tag,
            type: type2
          } = node;
          let nonSpecific = false;
          if (tag) {
            const {
              handle,
              suffix,
              verbatim
            } = tag;
            if (verbatim) {
              if (verbatim !== "!" && verbatim !== "!!")
                return verbatim;
              const msg = `Verbatim tags aren't resolved, so ${verbatim} is invalid.`;
              doc.errors.push(new PlainValue.YAMLSemanticError(node, msg));
            } else if (handle === "!" && !suffix) {
              nonSpecific = true;
            } else {
              try {
                return resolveTagHandle(doc, node);
              } catch (error) {
                doc.errors.push(error);
              }
            }
          }
          switch (type2) {
            case PlainValue.Type.BLOCK_FOLDED:
            case PlainValue.Type.BLOCK_LITERAL:
            case PlainValue.Type.QUOTE_DOUBLE:
            case PlainValue.Type.QUOTE_SINGLE:
              return PlainValue.defaultTags.STR;
            case PlainValue.Type.FLOW_MAP:
            case PlainValue.Type.MAP:
              return PlainValue.defaultTags.MAP;
            case PlainValue.Type.FLOW_SEQ:
            case PlainValue.Type.SEQ:
              return PlainValue.defaultTags.SEQ;
            case PlainValue.Type.PLAIN:
              return nonSpecific ? PlainValue.defaultTags.STR : null;
            default:
              return null;
          }
        }
        function resolveByTagName(doc, node, tagName) {
          const {
            tags
          } = doc.schema;
          const matchWithTest = [];
          for (const tag of tags) {
            if (tag.tag === tagName) {
              if (tag.test)
                matchWithTest.push(tag);
              else {
                const res = tag.resolve(doc, node);
                return res instanceof Collection ? res : new Scalar(res);
              }
            }
          }
          const str2 = resolveString(doc, node);
          if (typeof str2 === "string" && matchWithTest.length > 0)
            return resolveScalar(str2, matchWithTest, tags.scalarFallback);
          return null;
        }
        function getFallbackTagName({
          type: type2
        }) {
          switch (type2) {
            case PlainValue.Type.FLOW_MAP:
            case PlainValue.Type.MAP:
              return PlainValue.defaultTags.MAP;
            case PlainValue.Type.FLOW_SEQ:
            case PlainValue.Type.SEQ:
              return PlainValue.defaultTags.SEQ;
            default:
              return PlainValue.defaultTags.STR;
          }
        }
        function resolveTag(doc, node, tagName) {
          try {
            const res = resolveByTagName(doc, node, tagName);
            if (res) {
              if (tagName && node.tag)
                res.tag = tagName;
              return res;
            }
          } catch (error) {
            if (!error.source)
              error.source = node;
            doc.errors.push(error);
            return null;
          }
          try {
            const fallback = getFallbackTagName(node);
            if (!fallback)
              throw new Error(`The tag ${tagName} is unavailable`);
            const msg = `The tag ${tagName} is unavailable, falling back to ${fallback}`;
            doc.warnings.push(new PlainValue.YAMLWarning(node, msg));
            const res = resolveByTagName(doc, node, fallback);
            res.tag = tagName;
            return res;
          } catch (error) {
            const refError = new PlainValue.YAMLReferenceError(node, error.message);
            refError.stack = error.stack;
            doc.errors.push(refError);
            return null;
          }
        }
        var isCollectionItem = (node) => {
          if (!node)
            return false;
          const {
            type: type2
          } = node;
          return type2 === PlainValue.Type.MAP_KEY || type2 === PlainValue.Type.MAP_VALUE || type2 === PlainValue.Type.SEQ_ITEM;
        };
        function resolveNodeProps(errors, node) {
          const comments = {
            before: [],
            after: []
          };
          let hasAnchor = false;
          let hasTag = false;
          const props = isCollectionItem(node.context.parent) ? node.context.parent.props.concat(node.props) : node.props;
          for (const {
            start,
            end
          } of props) {
            switch (node.context.src[start]) {
              case PlainValue.Char.COMMENT: {
                if (!node.commentHasRequiredWhitespace(start)) {
                  const msg = "Comments must be separated from other tokens by white space characters";
                  errors.push(new PlainValue.YAMLSemanticError(node, msg));
                }
                const {
                  header,
                  valueRange
                } = node;
                const cc = valueRange && (start > valueRange.start || header && start > header.start) ? comments.after : comments.before;
                cc.push(node.context.src.slice(start + 1, end));
                break;
              }
              case PlainValue.Char.ANCHOR:
                if (hasAnchor) {
                  const msg = "A node can have at most one anchor";
                  errors.push(new PlainValue.YAMLSemanticError(node, msg));
                }
                hasAnchor = true;
                break;
              case PlainValue.Char.TAG:
                if (hasTag) {
                  const msg = "A node can have at most one tag";
                  errors.push(new PlainValue.YAMLSemanticError(node, msg));
                }
                hasTag = true;
                break;
            }
          }
          return {
            comments,
            hasAnchor,
            hasTag
          };
        }
        function resolveNodeValue(doc, node) {
          const {
            anchors,
            errors,
            schema: schema2
          } = doc;
          if (node.type === PlainValue.Type.ALIAS) {
            const name = node.rawValue;
            const src = anchors.getNode(name);
            if (!src) {
              const msg = `Aliased anchor not found: ${name}`;
              errors.push(new PlainValue.YAMLReferenceError(node, msg));
              return null;
            }
            const res = new Alias(src);
            anchors._cstAliases.push(res);
            return res;
          }
          const tagName = resolveTagName(doc, node);
          if (tagName)
            return resolveTag(doc, node, tagName);
          if (node.type !== PlainValue.Type.PLAIN) {
            const msg = `Failed to resolve ${node.type} node here`;
            errors.push(new PlainValue.YAMLSyntaxError(node, msg));
            return null;
          }
          try {
            const str2 = resolveString(doc, node);
            return resolveScalar(str2, schema2.tags, schema2.tags.scalarFallback);
          } catch (error) {
            if (!error.source)
              error.source = node;
            errors.push(error);
            return null;
          }
        }
        function resolveNode(doc, node) {
          if (!node)
            return null;
          if (node.error)
            doc.errors.push(node.error);
          const {
            comments,
            hasAnchor,
            hasTag
          } = resolveNodeProps(doc.errors, node);
          if (hasAnchor) {
            const {
              anchors
            } = doc;
            const name = node.anchor;
            const prev = anchors.getNode(name);
            if (prev)
              anchors.map[anchors.newName(name)] = prev;
            anchors.map[name] = node;
          }
          if (node.type === PlainValue.Type.ALIAS && (hasAnchor || hasTag)) {
            const msg = "An alias node must not specify any properties";
            doc.errors.push(new PlainValue.YAMLSemanticError(node, msg));
          }
          const res = resolveNodeValue(doc, node);
          if (res) {
            res.range = [node.range.start, node.range.end];
            if (doc.options.keepCstNodes)
              res.cstNode = node;
            if (doc.options.keepNodeTypes)
              res.type = node.type;
            const cb = comments.before.join("\n");
            if (cb) {
              res.commentBefore = res.commentBefore ? `${res.commentBefore}
${cb}` : cb;
            }
            const ca = comments.after.join("\n");
            if (ca)
              res.comment = res.comment ? `${res.comment}
${ca}` : ca;
          }
          return node.resolved = res;
        }
        function resolveMap(doc, cst) {
          if (cst.type !== PlainValue.Type.MAP && cst.type !== PlainValue.Type.FLOW_MAP) {
            const msg = `A ${cst.type} node cannot be resolved as a mapping`;
            doc.errors.push(new PlainValue.YAMLSyntaxError(cst, msg));
            return null;
          }
          const {
            comments,
            items
          } = cst.type === PlainValue.Type.FLOW_MAP ? resolveFlowMapItems(doc, cst) : resolveBlockMapItems(doc, cst);
          const map2 = new YAMLMap();
          map2.items = items;
          resolveComments(map2, comments);
          let hasCollectionKey = false;
          for (let i = 0; i < items.length; ++i) {
            const {
              key: iKey
            } = items[i];
            if (iKey instanceof Collection)
              hasCollectionKey = true;
            if (doc.schema.merge && iKey && iKey.value === MERGE_KEY) {
              items[i] = new Merge(items[i]);
              const sources = items[i].value.items;
              let error = null;
              sources.some((node) => {
                if (node instanceof Alias) {
                  const {
                    type: type2
                  } = node.source;
                  if (type2 === PlainValue.Type.MAP || type2 === PlainValue.Type.FLOW_MAP)
                    return false;
                  return error = "Merge nodes aliases can only point to maps";
                }
                return error = "Merge nodes can only have Alias nodes as values";
              });
              if (error)
                doc.errors.push(new PlainValue.YAMLSemanticError(cst, error));
            } else {
              for (let j = i + 1; j < items.length; ++j) {
                const {
                  key: jKey
                } = items[j];
                if (iKey === jKey || iKey && jKey && Object.prototype.hasOwnProperty.call(iKey, "value") && iKey.value === jKey.value) {
                  const msg = `Map keys must be unique; "${iKey}" is repeated`;
                  doc.errors.push(new PlainValue.YAMLSemanticError(cst, msg));
                  break;
                }
              }
            }
          }
          if (hasCollectionKey && !doc.options.mapAsMap) {
            const warn = "Keys with collection values will be stringified as YAML due to JS Object restrictions. Use mapAsMap: true to avoid this.";
            doc.warnings.push(new PlainValue.YAMLWarning(cst, warn));
          }
          cst.resolved = map2;
          return map2;
        }
        var valueHasPairComment = ({
          context: {
            lineStart,
            node,
            src
          },
          props
        }) => {
          if (props.length === 0)
            return false;
          const {
            start
          } = props[0];
          if (node && start > node.valueRange.start)
            return false;
          if (src[start] !== PlainValue.Char.COMMENT)
            return false;
          for (let i = lineStart; i < start; ++i)
            if (src[i] === "\n")
              return false;
          return true;
        };
        function resolvePairComment(item, pair) {
          if (!valueHasPairComment(item))
            return;
          const comment = item.getPropValue(0, PlainValue.Char.COMMENT, true);
          let found = false;
          const cb = pair.value.commentBefore;
          if (cb && cb.startsWith(comment)) {
            pair.value.commentBefore = cb.substr(comment.length + 1);
            found = true;
          } else {
            const cc = pair.value.comment;
            if (!item.node && cc && cc.startsWith(comment)) {
              pair.value.comment = cc.substr(comment.length + 1);
              found = true;
            }
          }
          if (found)
            pair.comment = comment;
        }
        function resolveBlockMapItems(doc, cst) {
          const comments = [];
          const items = [];
          let key = void 0;
          let keyStart = null;
          for (let i = 0; i < cst.items.length; ++i) {
            const item = cst.items[i];
            switch (item.type) {
              case PlainValue.Type.BLANK_LINE:
                comments.push({
                  afterKey: !!key,
                  before: items.length
                });
                break;
              case PlainValue.Type.COMMENT:
                comments.push({
                  afterKey: !!key,
                  before: items.length,
                  comment: item.comment
                });
                break;
              case PlainValue.Type.MAP_KEY:
                if (key !== void 0)
                  items.push(new Pair(key));
                if (item.error)
                  doc.errors.push(item.error);
                key = resolveNode(doc, item.node);
                keyStart = null;
                break;
              case PlainValue.Type.MAP_VALUE:
                {
                  if (key === void 0)
                    key = null;
                  if (item.error)
                    doc.errors.push(item.error);
                  if (!item.context.atLineStart && item.node && item.node.type === PlainValue.Type.MAP && !item.node.context.atLineStart) {
                    const msg = "Nested mappings are not allowed in compact mappings";
                    doc.errors.push(new PlainValue.YAMLSemanticError(item.node, msg));
                  }
                  let valueNode = item.node;
                  if (!valueNode && item.props.length > 0) {
                    valueNode = new PlainValue.PlainValue(PlainValue.Type.PLAIN, []);
                    valueNode.context = {
                      parent: item,
                      src: item.context.src
                    };
                    const pos = item.range.start + 1;
                    valueNode.range = {
                      start: pos,
                      end: pos
                    };
                    valueNode.valueRange = {
                      start: pos,
                      end: pos
                    };
                    if (typeof item.range.origStart === "number") {
                      const origPos = item.range.origStart + 1;
                      valueNode.range.origStart = valueNode.range.origEnd = origPos;
                      valueNode.valueRange.origStart = valueNode.valueRange.origEnd = origPos;
                    }
                  }
                  const pair = new Pair(key, resolveNode(doc, valueNode));
                  resolvePairComment(item, pair);
                  items.push(pair);
                  if (key && typeof keyStart === "number") {
                    if (item.range.start > keyStart + 1024)
                      doc.errors.push(getLongKeyError(cst, key));
                  }
                  key = void 0;
                  keyStart = null;
                }
                break;
              default:
                if (key !== void 0)
                  items.push(new Pair(key));
                key = resolveNode(doc, item);
                keyStart = item.range.start;
                if (item.error)
                  doc.errors.push(item.error);
                next:
                  for (let j = i + 1; ; ++j) {
                    const nextItem = cst.items[j];
                    switch (nextItem && nextItem.type) {
                      case PlainValue.Type.BLANK_LINE:
                      case PlainValue.Type.COMMENT:
                        continue next;
                      case PlainValue.Type.MAP_VALUE:
                        break next;
                      default: {
                        const msg = "Implicit map keys need to be followed by map values";
                        doc.errors.push(new PlainValue.YAMLSemanticError(item, msg));
                        break next;
                      }
                    }
                  }
                if (item.valueRangeContainsNewline) {
                  const msg = "Implicit map keys need to be on a single line";
                  doc.errors.push(new PlainValue.YAMLSemanticError(item, msg));
                }
            }
          }
          if (key !== void 0)
            items.push(new Pair(key));
          return {
            comments,
            items
          };
        }
        function resolveFlowMapItems(doc, cst) {
          const comments = [];
          const items = [];
          let key = void 0;
          let explicitKey = false;
          let next = "{";
          for (let i = 0; i < cst.items.length; ++i) {
            const item = cst.items[i];
            if (typeof item.char === "string") {
              const {
                char,
                offset
              } = item;
              if (char === "?" && key === void 0 && !explicitKey) {
                explicitKey = true;
                next = ":";
                continue;
              }
              if (char === ":") {
                if (key === void 0)
                  key = null;
                if (next === ":") {
                  next = ",";
                  continue;
                }
              } else {
                if (explicitKey) {
                  if (key === void 0 && char !== ",")
                    key = null;
                  explicitKey = false;
                }
                if (key !== void 0) {
                  items.push(new Pair(key));
                  key = void 0;
                  if (char === ",") {
                    next = ":";
                    continue;
                  }
                }
              }
              if (char === "}") {
                if (i === cst.items.length - 1)
                  continue;
              } else if (char === next) {
                next = ":";
                continue;
              }
              const msg = `Flow map contains an unexpected ${char}`;
              const err = new PlainValue.YAMLSyntaxError(cst, msg);
              err.offset = offset;
              doc.errors.push(err);
            } else if (item.type === PlainValue.Type.BLANK_LINE) {
              comments.push({
                afterKey: !!key,
                before: items.length
              });
            } else if (item.type === PlainValue.Type.COMMENT) {
              checkFlowCommentSpace(doc.errors, item);
              comments.push({
                afterKey: !!key,
                before: items.length,
                comment: item.comment
              });
            } else if (key === void 0) {
              if (next === ",")
                doc.errors.push(new PlainValue.YAMLSemanticError(item, "Separator , missing in flow map"));
              key = resolveNode(doc, item);
            } else {
              if (next !== ",")
                doc.errors.push(new PlainValue.YAMLSemanticError(item, "Indicator : missing in flow map entry"));
              items.push(new Pair(key, resolveNode(doc, item)));
              key = void 0;
              explicitKey = false;
            }
          }
          checkFlowCollectionEnd(doc.errors, cst);
          if (key !== void 0)
            items.push(new Pair(key));
          return {
            comments,
            items
          };
        }
        function resolveSeq(doc, cst) {
          if (cst.type !== PlainValue.Type.SEQ && cst.type !== PlainValue.Type.FLOW_SEQ) {
            const msg = `A ${cst.type} node cannot be resolved as a sequence`;
            doc.errors.push(new PlainValue.YAMLSyntaxError(cst, msg));
            return null;
          }
          const {
            comments,
            items
          } = cst.type === PlainValue.Type.FLOW_SEQ ? resolveFlowSeqItems(doc, cst) : resolveBlockSeqItems(doc, cst);
          const seq2 = new YAMLSeq();
          seq2.items = items;
          resolveComments(seq2, comments);
          if (!doc.options.mapAsMap && items.some((it) => it instanceof Pair && it.key instanceof Collection)) {
            const warn = "Keys with collection values will be stringified as YAML due to JS Object restrictions. Use mapAsMap: true to avoid this.";
            doc.warnings.push(new PlainValue.YAMLWarning(cst, warn));
          }
          cst.resolved = seq2;
          return seq2;
        }
        function resolveBlockSeqItems(doc, cst) {
          const comments = [];
          const items = [];
          for (let i = 0; i < cst.items.length; ++i) {
            const item = cst.items[i];
            switch (item.type) {
              case PlainValue.Type.BLANK_LINE:
                comments.push({
                  before: items.length
                });
                break;
              case PlainValue.Type.COMMENT:
                comments.push({
                  comment: item.comment,
                  before: items.length
                });
                break;
              case PlainValue.Type.SEQ_ITEM:
                if (item.error)
                  doc.errors.push(item.error);
                items.push(resolveNode(doc, item.node));
                if (item.hasProps) {
                  const msg = "Sequence items cannot have tags or anchors before the - indicator";
                  doc.errors.push(new PlainValue.YAMLSemanticError(item, msg));
                }
                break;
              default:
                if (item.error)
                  doc.errors.push(item.error);
                doc.errors.push(new PlainValue.YAMLSyntaxError(item, `Unexpected ${item.type} node in sequence`));
            }
          }
          return {
            comments,
            items
          };
        }
        function resolveFlowSeqItems(doc, cst) {
          const comments = [];
          const items = [];
          let explicitKey = false;
          let key = void 0;
          let keyStart = null;
          let next = "[";
          let prevItem = null;
          for (let i = 0; i < cst.items.length; ++i) {
            const item = cst.items[i];
            if (typeof item.char === "string") {
              const {
                char,
                offset
              } = item;
              if (char !== ":" && (explicitKey || key !== void 0)) {
                if (explicitKey && key === void 0)
                  key = next ? items.pop() : null;
                items.push(new Pair(key));
                explicitKey = false;
                key = void 0;
                keyStart = null;
              }
              if (char === next) {
                next = null;
              } else if (!next && char === "?") {
                explicitKey = true;
              } else if (next !== "[" && char === ":" && key === void 0) {
                if (next === ",") {
                  key = items.pop();
                  if (key instanceof Pair) {
                    const msg = "Chaining flow sequence pairs is invalid";
                    const err = new PlainValue.YAMLSemanticError(cst, msg);
                    err.offset = offset;
                    doc.errors.push(err);
                  }
                  if (!explicitKey && typeof keyStart === "number") {
                    const keyEnd = item.range ? item.range.start : item.offset;
                    if (keyEnd > keyStart + 1024)
                      doc.errors.push(getLongKeyError(cst, key));
                    const {
                      src
                    } = prevItem.context;
                    for (let i2 = keyStart; i2 < keyEnd; ++i2)
                      if (src[i2] === "\n") {
                        const msg = "Implicit keys of flow sequence pairs need to be on a single line";
                        doc.errors.push(new PlainValue.YAMLSemanticError(prevItem, msg));
                        break;
                      }
                  }
                } else {
                  key = null;
                }
                keyStart = null;
                explicitKey = false;
                next = null;
              } else if (next === "[" || char !== "]" || i < cst.items.length - 1) {
                const msg = `Flow sequence contains an unexpected ${char}`;
                const err = new PlainValue.YAMLSyntaxError(cst, msg);
                err.offset = offset;
                doc.errors.push(err);
              }
            } else if (item.type === PlainValue.Type.BLANK_LINE) {
              comments.push({
                before: items.length
              });
            } else if (item.type === PlainValue.Type.COMMENT) {
              checkFlowCommentSpace(doc.errors, item);
              comments.push({
                comment: item.comment,
                before: items.length
              });
            } else {
              if (next) {
                const msg = `Expected a ${next} in flow sequence`;
                doc.errors.push(new PlainValue.YAMLSemanticError(item, msg));
              }
              const value = resolveNode(doc, item);
              if (key === void 0) {
                items.push(value);
                prevItem = item;
              } else {
                items.push(new Pair(key, value));
                key = void 0;
              }
              keyStart = item.range.start;
              next = ",";
            }
          }
          checkFlowCollectionEnd(doc.errors, cst);
          if (key !== void 0)
            items.push(new Pair(key));
          return {
            comments,
            items
          };
        }
        exports22.Alias = Alias;
        exports22.Collection = Collection;
        exports22.Merge = Merge;
        exports22.Node = Node;
        exports22.Pair = Pair;
        exports22.Scalar = Scalar;
        exports22.YAMLMap = YAMLMap;
        exports22.YAMLSeq = YAMLSeq;
        exports22.addComment = addComment;
        exports22.binaryOptions = binaryOptions;
        exports22.boolOptions = boolOptions;
        exports22.findPair = findPair;
        exports22.intOptions = intOptions;
        exports22.isEmptyPath = isEmptyPath;
        exports22.nullOptions = nullOptions;
        exports22.resolveMap = resolveMap;
        exports22.resolveNode = resolveNode;
        exports22.resolveSeq = resolveSeq;
        exports22.resolveString = resolveString;
        exports22.strOptions = strOptions;
        exports22.stringifyNumber = stringifyNumber;
        exports22.stringifyString = stringifyString;
        exports22.toJSON = toJSON;
      }
    });
    var require_warnings_1000a372 = __commonJS2({
      "node_modules/yaml/dist/warnings-1000a372.js"(exports22) {
        "use strict";
        var PlainValue = require_PlainValue_ec8e588e();
        var resolveSeq = require_resolveSeq_d03cb037();
        var binary2 = {
          identify: (value) => value instanceof Uint8Array,
          default: false,
          tag: "tag:yaml.org,2002:binary",
          resolve: (doc, node) => {
            const src = resolveSeq.resolveString(doc, node);
            if (typeof Buffer === "function") {
              return Buffer.from(src, "base64");
            } else if (typeof atob === "function") {
              const str2 = atob(src.replace(/[\n\r]/g, ""));
              const buffer = new Uint8Array(str2.length);
              for (let i = 0; i < str2.length; ++i)
                buffer[i] = str2.charCodeAt(i);
              return buffer;
            } else {
              const msg = "This environment does not support reading binary tags; either Buffer or atob is required";
              doc.errors.push(new PlainValue.YAMLReferenceError(node, msg));
              return null;
            }
          },
          options: resolveSeq.binaryOptions,
          stringify: ({
            comment,
            type: type2,
            value
          }, ctx, onComment, onChompKeep) => {
            let src;
            if (typeof Buffer === "function") {
              src = value instanceof Buffer ? value.toString("base64") : Buffer.from(value.buffer).toString("base64");
            } else if (typeof btoa === "function") {
              let s = "";
              for (let i = 0; i < value.length; ++i)
                s += String.fromCharCode(value[i]);
              src = btoa(s);
            } else {
              throw new Error("This environment does not support writing binary tags; either Buffer or btoa is required");
            }
            if (!type2)
              type2 = resolveSeq.binaryOptions.defaultType;
            if (type2 === PlainValue.Type.QUOTE_DOUBLE) {
              value = src;
            } else {
              const {
                lineWidth
              } = resolveSeq.binaryOptions;
              const n = Math.ceil(src.length / lineWidth);
              const lines = new Array(n);
              for (let i = 0, o = 0; i < n; ++i, o += lineWidth) {
                lines[i] = src.substr(o, lineWidth);
              }
              value = lines.join(type2 === PlainValue.Type.BLOCK_LITERAL ? "\n" : " ");
            }
            return resolveSeq.stringifyString({
              comment,
              type: type2,
              value
            }, ctx, onComment, onChompKeep);
          }
        };
        function parsePairs(doc, cst) {
          const seq2 = resolveSeq.resolveSeq(doc, cst);
          for (let i = 0; i < seq2.items.length; ++i) {
            let item = seq2.items[i];
            if (item instanceof resolveSeq.Pair)
              continue;
            else if (item instanceof resolveSeq.YAMLMap) {
              if (item.items.length > 1) {
                const msg = "Each pair must have its own sequence indicator";
                throw new PlainValue.YAMLSemanticError(cst, msg);
              }
              const pair = item.items[0] || new resolveSeq.Pair();
              if (item.commentBefore)
                pair.commentBefore = pair.commentBefore ? `${item.commentBefore}
${pair.commentBefore}` : item.commentBefore;
              if (item.comment)
                pair.comment = pair.comment ? `${item.comment}
${pair.comment}` : item.comment;
              item = pair;
            }
            seq2.items[i] = item instanceof resolveSeq.Pair ? item : new resolveSeq.Pair(item);
          }
          return seq2;
        }
        function createPairs(schema2, iterable, ctx) {
          const pairs22 = new resolveSeq.YAMLSeq(schema2);
          pairs22.tag = "tag:yaml.org,2002:pairs";
          for (const it of iterable) {
            let key, value;
            if (Array.isArray(it)) {
              if (it.length === 2) {
                key = it[0];
                value = it[1];
              } else
                throw new TypeError(`Expected [key, value] tuple: ${it}`);
            } else if (it && it instanceof Object) {
              const keys5 = Object.keys(it);
              if (keys5.length === 1) {
                key = keys5[0];
                value = it[key];
              } else
                throw new TypeError(`Expected { key: value } tuple: ${it}`);
            } else {
              key = it;
            }
            const pair = schema2.createPair(key, value, ctx);
            pairs22.items.push(pair);
          }
          return pairs22;
        }
        var pairs2 = {
          default: false,
          tag: "tag:yaml.org,2002:pairs",
          resolve: parsePairs,
          createNode: createPairs
        };
        var YAMLOMap = class extends resolveSeq.YAMLSeq {
          constructor() {
            super();
            PlainValue._defineProperty(this, "add", resolveSeq.YAMLMap.prototype.add.bind(this));
            PlainValue._defineProperty(this, "delete", resolveSeq.YAMLMap.prototype.delete.bind(this));
            PlainValue._defineProperty(this, "get", resolveSeq.YAMLMap.prototype.get.bind(this));
            PlainValue._defineProperty(this, "has", resolveSeq.YAMLMap.prototype.has.bind(this));
            PlainValue._defineProperty(this, "set", resolveSeq.YAMLMap.prototype.set.bind(this));
            this.tag = YAMLOMap.tag;
          }
          toJSON(_, ctx) {
            const map2 = /* @__PURE__ */ new Map();
            if (ctx && ctx.onCreate)
              ctx.onCreate(map2);
            for (const pair of this.items) {
              let key, value;
              if (pair instanceof resolveSeq.Pair) {
                key = resolveSeq.toJSON(pair.key, "", ctx);
                value = resolveSeq.toJSON(pair.value, key, ctx);
              } else {
                key = resolveSeq.toJSON(pair, "", ctx);
              }
              if (map2.has(key))
                throw new Error("Ordered maps must not include duplicate keys");
              map2.set(key, value);
            }
            return map2;
          }
        };
        PlainValue._defineProperty(YAMLOMap, "tag", "tag:yaml.org,2002:omap");
        function parseOMap(doc, cst) {
          const pairs22 = parsePairs(doc, cst);
          const seenKeys = [];
          for (const {
            key
          } of pairs22.items) {
            if (key instanceof resolveSeq.Scalar) {
              if (seenKeys.includes(key.value)) {
                const msg = "Ordered maps must not include duplicate keys";
                throw new PlainValue.YAMLSemanticError(cst, msg);
              } else {
                seenKeys.push(key.value);
              }
            }
          }
          return Object.assign(new YAMLOMap(), pairs22);
        }
        function createOMap(schema2, iterable, ctx) {
          const pairs22 = createPairs(schema2, iterable, ctx);
          const omap22 = new YAMLOMap();
          omap22.items = pairs22.items;
          return omap22;
        }
        var omap2 = {
          identify: (value) => value instanceof Map,
          nodeClass: YAMLOMap,
          default: false,
          tag: "tag:yaml.org,2002:omap",
          resolve: parseOMap,
          createNode: createOMap
        };
        var YAMLSet = class extends resolveSeq.YAMLMap {
          constructor() {
            super();
            this.tag = YAMLSet.tag;
          }
          add(key) {
            const pair = key instanceof resolveSeq.Pair ? key : new resolveSeq.Pair(key);
            const prev = resolveSeq.findPair(this.items, pair.key);
            if (!prev)
              this.items.push(pair);
          }
          get(key, keepPair) {
            const pair = resolveSeq.findPair(this.items, key);
            return !keepPair && pair instanceof resolveSeq.Pair ? pair.key instanceof resolveSeq.Scalar ? pair.key.value : pair.key : pair;
          }
          set(key, value) {
            if (typeof value !== "boolean")
              throw new Error(`Expected boolean value for set(key, value) in a YAML set, not ${typeof value}`);
            const prev = resolveSeq.findPair(this.items, key);
            if (prev && !value) {
              this.items.splice(this.items.indexOf(prev), 1);
            } else if (!prev && value) {
              this.items.push(new resolveSeq.Pair(key));
            }
          }
          toJSON(_, ctx) {
            return super.toJSON(_, ctx, Set);
          }
          toString(ctx, onComment, onChompKeep) {
            if (!ctx)
              return JSON.stringify(this);
            if (this.hasAllNullValues())
              return super.toString(ctx, onComment, onChompKeep);
            else
              throw new Error("Set items must all have null values");
          }
        };
        PlainValue._defineProperty(YAMLSet, "tag", "tag:yaml.org,2002:set");
        function parseSet(doc, cst) {
          const map2 = resolveSeq.resolveMap(doc, cst);
          if (!map2.hasAllNullValues())
            throw new PlainValue.YAMLSemanticError(cst, "Set items must all have null values");
          return Object.assign(new YAMLSet(), map2);
        }
        function createSet(schema2, iterable, ctx) {
          const set22 = new YAMLSet();
          for (const value of iterable)
            set22.items.push(schema2.createPair(value, null, ctx));
          return set22;
        }
        var set4 = {
          identify: (value) => value instanceof Set,
          nodeClass: YAMLSet,
          default: false,
          tag: "tag:yaml.org,2002:set",
          resolve: parseSet,
          createNode: createSet
        };
        var parseSexagesimal = (sign, parts) => {
          const n = parts.split(":").reduce((n2, p) => n2 * 60 + Number(p), 0);
          return sign === "-" ? -n : n;
        };
        var stringifySexagesimal = ({
          value
        }) => {
          if (isNaN(value) || !isFinite(value))
            return resolveSeq.stringifyNumber(value);
          let sign = "";
          if (value < 0) {
            sign = "-";
            value = Math.abs(value);
          }
          const parts = [value % 60];
          if (value < 60) {
            parts.unshift(0);
          } else {
            value = Math.round((value - parts[0]) / 60);
            parts.unshift(value % 60);
            if (value >= 60) {
              value = Math.round((value - parts[0]) / 60);
              parts.unshift(value);
            }
          }
          return sign + parts.map((n) => n < 10 ? "0" + String(n) : String(n)).join(":").replace(/000000\d*$/, "");
        };
        var intTime = {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:int",
          format: "TIME",
          test: /^([-+]?)([0-9][0-9_]*(?::[0-5]?[0-9])+)$/,
          resolve: (str2, sign, parts) => parseSexagesimal(sign, parts.replace(/_/g, "")),
          stringify: stringifySexagesimal
        };
        var floatTime = {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:float",
          format: "TIME",
          test: /^([-+]?)([0-9][0-9_]*(?::[0-5]?[0-9])+\.[0-9_]*)$/,
          resolve: (str2, sign, parts) => parseSexagesimal(sign, parts.replace(/_/g, "")),
          stringify: stringifySexagesimal
        };
        var timestamp2 = {
          identify: (value) => value instanceof Date,
          default: true,
          tag: "tag:yaml.org,2002:timestamp",
          test: RegExp("^(?:([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})(?:(?:t|T|[ \\t]+)([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2}(\\.[0-9]+)?)(?:[ \\t]*(Z|[-+][012]?[0-9](?::[0-9]{2})?))?)?)$"),
          resolve: (str2, year, month, day, hour, minute, second, millisec, tz) => {
            if (millisec)
              millisec = (millisec + "00").substr(1, 3);
            let date3 = Date.UTC(year, month - 1, day, hour || 0, minute || 0, second || 0, millisec || 0);
            if (tz && tz !== "Z") {
              let d = parseSexagesimal(tz[0], tz.slice(1));
              if (Math.abs(d) < 30)
                d *= 60;
              date3 -= 6e4 * d;
            }
            return new Date(date3);
          },
          stringify: ({
            value
          }) => value.toISOString().replace(/((T00:00)?:00)?\.000Z$/, "")
        };
        function shouldWarn(deprecation) {
          const env = typeof process !== "undefined" && process.env || {};
          if (deprecation) {
            if (typeof YAML_SILENCE_DEPRECATION_WARNINGS !== "undefined")
              return !YAML_SILENCE_DEPRECATION_WARNINGS;
            return !env.YAML_SILENCE_DEPRECATION_WARNINGS;
          }
          if (typeof YAML_SILENCE_WARNINGS !== "undefined")
            return !YAML_SILENCE_WARNINGS;
          return !env.YAML_SILENCE_WARNINGS;
        }
        function warn(warning, type2) {
          if (shouldWarn(false)) {
            const emit = typeof process !== "undefined" && process.emitWarning;
            if (emit)
              emit(warning, type2);
            else {
              console.warn(type2 ? `${type2}: ${warning}` : warning);
            }
          }
        }
        function warnFileDeprecation(filename) {
          if (shouldWarn(true)) {
            const path5 = filename.replace(/.*yaml[/\\]/i, "").replace(/\.js$/, "").replace(/\\/g, "/");
            warn(`The endpoint 'yaml/${path5}' will be removed in a future release.`, "DeprecationWarning");
          }
        }
        var warned = {};
        function warnOptionDeprecation(name, alternative) {
          if (!warned[name] && shouldWarn(true)) {
            warned[name] = true;
            let msg = `The option '${name}' will be removed in a future release`;
            msg += alternative ? `, use '${alternative}' instead.` : ".";
            warn(msg, "DeprecationWarning");
          }
        }
        exports22.binary = binary2;
        exports22.floatTime = floatTime;
        exports22.intTime = intTime;
        exports22.omap = omap2;
        exports22.pairs = pairs2;
        exports22.set = set4;
        exports22.timestamp = timestamp2;
        exports22.warn = warn;
        exports22.warnFileDeprecation = warnFileDeprecation;
        exports22.warnOptionDeprecation = warnOptionDeprecation;
      }
    });
    var require_Schema_88e323a7 = __commonJS2({
      "node_modules/yaml/dist/Schema-88e323a7.js"(exports22) {
        "use strict";
        var PlainValue = require_PlainValue_ec8e588e();
        var resolveSeq = require_resolveSeq_d03cb037();
        var warnings = require_warnings_1000a372();
        function createMap(schema2, obj, ctx) {
          const map22 = new resolveSeq.YAMLMap(schema2);
          if (obj instanceof Map) {
            for (const [key, value] of obj)
              map22.items.push(schema2.createPair(key, value, ctx));
          } else if (obj && typeof obj === "object") {
            for (const key of Object.keys(obj))
              map22.items.push(schema2.createPair(key, obj[key], ctx));
          }
          if (typeof schema2.sortMapEntries === "function") {
            map22.items.sort(schema2.sortMapEntries);
          }
          return map22;
        }
        var map2 = {
          createNode: createMap,
          default: true,
          nodeClass: resolveSeq.YAMLMap,
          tag: "tag:yaml.org,2002:map",
          resolve: resolveSeq.resolveMap
        };
        function createSeq(schema2, obj, ctx) {
          const seq22 = new resolveSeq.YAMLSeq(schema2);
          if (obj && obj[Symbol.iterator]) {
            for (const it of obj) {
              const v = schema2.createNode(it, ctx.wrapScalars, null, ctx);
              seq22.items.push(v);
            }
          }
          return seq22;
        }
        var seq2 = {
          createNode: createSeq,
          default: true,
          nodeClass: resolveSeq.YAMLSeq,
          tag: "tag:yaml.org,2002:seq",
          resolve: resolveSeq.resolveSeq
        };
        var string3 = {
          identify: (value) => typeof value === "string",
          default: true,
          tag: "tag:yaml.org,2002:str",
          resolve: resolveSeq.resolveString,
          stringify(item, ctx, onComment, onChompKeep) {
            ctx = Object.assign({
              actualString: true
            }, ctx);
            return resolveSeq.stringifyString(item, ctx, onComment, onChompKeep);
          },
          options: resolveSeq.strOptions
        };
        var failsafe2 = [map2, seq2, string3];
        var intIdentify$2 = (value) => typeof value === "bigint" || Number.isInteger(value);
        var intResolve$1 = (src, part, radix) => resolveSeq.intOptions.asBigInt ? BigInt(src) : parseInt(part, radix);
        function intStringify$1(node, radix, prefix) {
          const {
            value
          } = node;
          if (intIdentify$2(value) && value >= 0)
            return prefix + value.toString(radix);
          return resolveSeq.stringifyNumber(node);
        }
        var nullObj = {
          identify: (value) => value == null,
          createNode: (schema2, value, ctx) => ctx.wrapScalars ? new resolveSeq.Scalar(null) : null,
          default: true,
          tag: "tag:yaml.org,2002:null",
          test: /^(?:~|[Nn]ull|NULL)?$/,
          resolve: () => null,
          options: resolveSeq.nullOptions,
          stringify: () => resolveSeq.nullOptions.nullStr
        };
        var boolObj = {
          identify: (value) => typeof value === "boolean",
          default: true,
          tag: "tag:yaml.org,2002:bool",
          test: /^(?:[Tt]rue|TRUE|[Ff]alse|FALSE)$/,
          resolve: (str2) => str2[0] === "t" || str2[0] === "T",
          options: resolveSeq.boolOptions,
          stringify: ({
            value
          }) => value ? resolveSeq.boolOptions.trueStr : resolveSeq.boolOptions.falseStr
        };
        var octObj = {
          identify: (value) => intIdentify$2(value) && value >= 0,
          default: true,
          tag: "tag:yaml.org,2002:int",
          format: "OCT",
          test: /^0o([0-7]+)$/,
          resolve: (str2, oct) => intResolve$1(str2, oct, 8),
          options: resolveSeq.intOptions,
          stringify: (node) => intStringify$1(node, 8, "0o")
        };
        var intObj = {
          identify: intIdentify$2,
          default: true,
          tag: "tag:yaml.org,2002:int",
          test: /^[-+]?[0-9]+$/,
          resolve: (str2) => intResolve$1(str2, str2, 10),
          options: resolveSeq.intOptions,
          stringify: resolveSeq.stringifyNumber
        };
        var hexObj = {
          identify: (value) => intIdentify$2(value) && value >= 0,
          default: true,
          tag: "tag:yaml.org,2002:int",
          format: "HEX",
          test: /^0x([0-9a-fA-F]+)$/,
          resolve: (str2, hex) => intResolve$1(str2, hex, 16),
          options: resolveSeq.intOptions,
          stringify: (node) => intStringify$1(node, 16, "0x")
        };
        var nanObj = {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:float",
          test: /^(?:[-+]?\.inf|(\.nan))$/i,
          resolve: (str2, nan) => nan ? NaN : str2[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY,
          stringify: resolveSeq.stringifyNumber
        };
        var expObj = {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:float",
          format: "EXP",
          test: /^[-+]?(?:\.[0-9]+|[0-9]+(?:\.[0-9]*)?)[eE][-+]?[0-9]+$/,
          resolve: (str2) => parseFloat(str2),
          stringify: ({
            value
          }) => Number(value).toExponential()
        };
        var floatObj = {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:float",
          test: /^[-+]?(?:\.([0-9]+)|[0-9]+\.([0-9]*))$/,
          resolve(str2, frac1, frac2) {
            const frac = frac1 || frac2;
            const node = new resolveSeq.Scalar(parseFloat(str2));
            if (frac && frac[frac.length - 1] === "0")
              node.minFractionDigits = frac.length;
            return node;
          },
          stringify: resolveSeq.stringifyNumber
        };
        var core2 = failsafe2.concat([nullObj, boolObj, octObj, intObj, hexObj, nanObj, expObj, floatObj]);
        var intIdentify$1 = (value) => typeof value === "bigint" || Number.isInteger(value);
        var stringifyJSON = ({
          value
        }) => JSON.stringify(value);
        var json2 = [map2, seq2, {
          identify: (value) => typeof value === "string",
          default: true,
          tag: "tag:yaml.org,2002:str",
          resolve: resolveSeq.resolveString,
          stringify: stringifyJSON
        }, {
          identify: (value) => value == null,
          createNode: (schema2, value, ctx) => ctx.wrapScalars ? new resolveSeq.Scalar(null) : null,
          default: true,
          tag: "tag:yaml.org,2002:null",
          test: /^null$/,
          resolve: () => null,
          stringify: stringifyJSON
        }, {
          identify: (value) => typeof value === "boolean",
          default: true,
          tag: "tag:yaml.org,2002:bool",
          test: /^true|false$/,
          resolve: (str2) => str2 === "true",
          stringify: stringifyJSON
        }, {
          identify: intIdentify$1,
          default: true,
          tag: "tag:yaml.org,2002:int",
          test: /^-?(?:0|[1-9][0-9]*)$/,
          resolve: (str2) => resolveSeq.intOptions.asBigInt ? BigInt(str2) : parseInt(str2, 10),
          stringify: ({
            value
          }) => intIdentify$1(value) ? value.toString() : JSON.stringify(value)
        }, {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:float",
          test: /^-?(?:0|[1-9][0-9]*)(?:\.[0-9]*)?(?:[eE][-+]?[0-9]+)?$/,
          resolve: (str2) => parseFloat(str2),
          stringify: stringifyJSON
        }];
        json2.scalarFallback = (str2) => {
          throw new SyntaxError(`Unresolved plain scalar ${JSON.stringify(str2)}`);
        };
        var boolStringify = ({
          value
        }) => value ? resolveSeq.boolOptions.trueStr : resolveSeq.boolOptions.falseStr;
        var intIdentify = (value) => typeof value === "bigint" || Number.isInteger(value);
        function intResolve(sign, src, radix) {
          let str2 = src.replace(/_/g, "");
          if (resolveSeq.intOptions.asBigInt) {
            switch (radix) {
              case 2:
                str2 = `0b${str2}`;
                break;
              case 8:
                str2 = `0o${str2}`;
                break;
              case 16:
                str2 = `0x${str2}`;
                break;
            }
            const n2 = BigInt(str2);
            return sign === "-" ? BigInt(-1) * n2 : n2;
          }
          const n = parseInt(str2, radix);
          return sign === "-" ? -1 * n : n;
        }
        function intStringify(node, radix, prefix) {
          const {
            value
          } = node;
          if (intIdentify(value)) {
            const str2 = value.toString(radix);
            return value < 0 ? "-" + prefix + str2.substr(1) : prefix + str2;
          }
          return resolveSeq.stringifyNumber(node);
        }
        var yaml11 = failsafe2.concat([{
          identify: (value) => value == null,
          createNode: (schema2, value, ctx) => ctx.wrapScalars ? new resolveSeq.Scalar(null) : null,
          default: true,
          tag: "tag:yaml.org,2002:null",
          test: /^(?:~|[Nn]ull|NULL)?$/,
          resolve: () => null,
          options: resolveSeq.nullOptions,
          stringify: () => resolveSeq.nullOptions.nullStr
        }, {
          identify: (value) => typeof value === "boolean",
          default: true,
          tag: "tag:yaml.org,2002:bool",
          test: /^(?:Y|y|[Yy]es|YES|[Tt]rue|TRUE|[Oo]n|ON)$/,
          resolve: () => true,
          options: resolveSeq.boolOptions,
          stringify: boolStringify
        }, {
          identify: (value) => typeof value === "boolean",
          default: true,
          tag: "tag:yaml.org,2002:bool",
          test: /^(?:N|n|[Nn]o|NO|[Ff]alse|FALSE|[Oo]ff|OFF)$/i,
          resolve: () => false,
          options: resolveSeq.boolOptions,
          stringify: boolStringify
        }, {
          identify: intIdentify,
          default: true,
          tag: "tag:yaml.org,2002:int",
          format: "BIN",
          test: /^([-+]?)0b([0-1_]+)$/,
          resolve: (str2, sign, bin) => intResolve(sign, bin, 2),
          stringify: (node) => intStringify(node, 2, "0b")
        }, {
          identify: intIdentify,
          default: true,
          tag: "tag:yaml.org,2002:int",
          format: "OCT",
          test: /^([-+]?)0([0-7_]+)$/,
          resolve: (str2, sign, oct) => intResolve(sign, oct, 8),
          stringify: (node) => intStringify(node, 8, "0")
        }, {
          identify: intIdentify,
          default: true,
          tag: "tag:yaml.org,2002:int",
          test: /^([-+]?)([0-9][0-9_]*)$/,
          resolve: (str2, sign, abs) => intResolve(sign, abs, 10),
          stringify: resolveSeq.stringifyNumber
        }, {
          identify: intIdentify,
          default: true,
          tag: "tag:yaml.org,2002:int",
          format: "HEX",
          test: /^([-+]?)0x([0-9a-fA-F_]+)$/,
          resolve: (str2, sign, hex) => intResolve(sign, hex, 16),
          stringify: (node) => intStringify(node, 16, "0x")
        }, {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:float",
          test: /^(?:[-+]?\.inf|(\.nan))$/i,
          resolve: (str2, nan) => nan ? NaN : str2[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY,
          stringify: resolveSeq.stringifyNumber
        }, {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:float",
          format: "EXP",
          test: /^[-+]?([0-9][0-9_]*)?(\.[0-9_]*)?[eE][-+]?[0-9]+$/,
          resolve: (str2) => parseFloat(str2.replace(/_/g, "")),
          stringify: ({
            value
          }) => Number(value).toExponential()
        }, {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:float",
          test: /^[-+]?(?:[0-9][0-9_]*)?\.([0-9_]*)$/,
          resolve(str2, frac) {
            const node = new resolveSeq.Scalar(parseFloat(str2.replace(/_/g, "")));
            if (frac) {
              const f = frac.replace(/_/g, "");
              if (f[f.length - 1] === "0")
                node.minFractionDigits = f.length;
            }
            return node;
          },
          stringify: resolveSeq.stringifyNumber
        }], warnings.binary, warnings.omap, warnings.pairs, warnings.set, warnings.intTime, warnings.floatTime, warnings.timestamp);
        var schemas = {
          core: core2,
          failsafe: failsafe2,
          json: json2,
          yaml11
        };
        var tags = {
          binary: warnings.binary,
          bool: boolObj,
          float: floatObj,
          floatExp: expObj,
          floatNaN: nanObj,
          floatTime: warnings.floatTime,
          int: intObj,
          intHex: hexObj,
          intOct: octObj,
          intTime: warnings.intTime,
          map: map2,
          null: nullObj,
          omap: warnings.omap,
          pairs: warnings.pairs,
          seq: seq2,
          set: warnings.set,
          timestamp: warnings.timestamp
        };
        function findTagObject(value, tagName, tags2) {
          if (tagName) {
            const match = tags2.filter((t) => t.tag === tagName);
            const tagObj = match.find((t) => !t.format) || match[0];
            if (!tagObj)
              throw new Error(`Tag ${tagName} not found`);
            return tagObj;
          }
          return tags2.find((t) => (t.identify && t.identify(value) || t.class && value instanceof t.class) && !t.format);
        }
        function createNode(value, tagName, ctx) {
          if (value instanceof resolveSeq.Node)
            return value;
          const {
            defaultPrefix,
            onTagObj,
            prevObjects,
            schema: schema2,
            wrapScalars
          } = ctx;
          if (tagName && tagName.startsWith("!!"))
            tagName = defaultPrefix + tagName.slice(2);
          let tagObj = findTagObject(value, tagName, schema2.tags);
          if (!tagObj) {
            if (typeof value.toJSON === "function")
              value = value.toJSON();
            if (!value || typeof value !== "object")
              return wrapScalars ? new resolveSeq.Scalar(value) : value;
            tagObj = value instanceof Map ? map2 : value[Symbol.iterator] ? seq2 : map2;
          }
          if (onTagObj) {
            onTagObj(tagObj);
            delete ctx.onTagObj;
          }
          const obj = {
            value: void 0,
            node: void 0
          };
          if (value && typeof value === "object" && prevObjects) {
            const prev = prevObjects.get(value);
            if (prev) {
              const alias = new resolveSeq.Alias(prev);
              ctx.aliasNodes.push(alias);
              return alias;
            }
            obj.value = value;
            prevObjects.set(value, obj);
          }
          obj.node = tagObj.createNode ? tagObj.createNode(ctx.schema, value, ctx) : wrapScalars ? new resolveSeq.Scalar(value) : value;
          if (tagName && obj.node instanceof resolveSeq.Node)
            obj.node.tag = tagName;
          return obj.node;
        }
        function getSchemaTags(schemas2, knownTags, customTags, schemaId) {
          let tags2 = schemas2[schemaId.replace(/\W/g, "")];
          if (!tags2) {
            const keys5 = Object.keys(schemas2).map((key) => JSON.stringify(key)).join(", ");
            throw new Error(`Unknown schema "${schemaId}"; use one of ${keys5}`);
          }
          if (Array.isArray(customTags)) {
            for (const tag of customTags)
              tags2 = tags2.concat(tag);
          } else if (typeof customTags === "function") {
            tags2 = customTags(tags2.slice());
          }
          for (let i = 0; i < tags2.length; ++i) {
            const tag = tags2[i];
            if (typeof tag === "string") {
              const tagObj = knownTags[tag];
              if (!tagObj) {
                const keys5 = Object.keys(knownTags).map((key) => JSON.stringify(key)).join(", ");
                throw new Error(`Unknown custom tag "${tag}"; use one of ${keys5}`);
              }
              tags2[i] = tagObj;
            }
          }
          return tags2;
        }
        var sortMapEntriesByKey = (a, b) => a.key < b.key ? -1 : a.key > b.key ? 1 : 0;
        var Schema3 = class {
          constructor({
            customTags,
            merge: merge3,
            schema: schema2,
            sortMapEntries,
            tags: deprecatedCustomTags
          }) {
            this.merge = !!merge3;
            this.name = schema2;
            this.sortMapEntries = sortMapEntries === true ? sortMapEntriesByKey : sortMapEntries || null;
            if (!customTags && deprecatedCustomTags)
              warnings.warnOptionDeprecation("tags", "customTags");
            this.tags = getSchemaTags(schemas, tags, customTags || deprecatedCustomTags, schema2);
          }
          createNode(value, wrapScalars, tagName, ctx) {
            const baseCtx = {
              defaultPrefix: Schema3.defaultPrefix,
              schema: this,
              wrapScalars
            };
            const createCtx = ctx ? Object.assign(ctx, baseCtx) : baseCtx;
            return createNode(value, tagName, createCtx);
          }
          createPair(key, value, ctx) {
            if (!ctx)
              ctx = {
                wrapScalars: true
              };
            const k = this.createNode(key, ctx.wrapScalars, null, ctx);
            const v = this.createNode(value, ctx.wrapScalars, null, ctx);
            return new resolveSeq.Pair(k, v);
          }
        };
        PlainValue._defineProperty(Schema3, "defaultPrefix", PlainValue.defaultTagPrefix);
        PlainValue._defineProperty(Schema3, "defaultTags", PlainValue.defaultTags);
        exports22.Schema = Schema3;
      }
    });
    var require_Document_9b4560a1 = __commonJS2({
      "node_modules/yaml/dist/Document-9b4560a1.js"(exports22) {
        "use strict";
        var PlainValue = require_PlainValue_ec8e588e();
        var resolveSeq = require_resolveSeq_d03cb037();
        var Schema3 = require_Schema_88e323a7();
        var defaultOptions = {
          anchorPrefix: "a",
          customTags: null,
          indent: 2,
          indentSeq: true,
          keepCstNodes: false,
          keepNodeTypes: true,
          keepBlobsInJSON: true,
          mapAsMap: false,
          maxAliasCount: 100,
          prettyErrors: false,
          simpleKeys: false,
          version: "1.2"
        };
        var scalarOptions = {
          get binary() {
            return resolveSeq.binaryOptions;
          },
          set binary(opt) {
            Object.assign(resolveSeq.binaryOptions, opt);
          },
          get bool() {
            return resolveSeq.boolOptions;
          },
          set bool(opt) {
            Object.assign(resolveSeq.boolOptions, opt);
          },
          get int() {
            return resolveSeq.intOptions;
          },
          set int(opt) {
            Object.assign(resolveSeq.intOptions, opt);
          },
          get null() {
            return resolveSeq.nullOptions;
          },
          set null(opt) {
            Object.assign(resolveSeq.nullOptions, opt);
          },
          get str() {
            return resolveSeq.strOptions;
          },
          set str(opt) {
            Object.assign(resolveSeq.strOptions, opt);
          }
        };
        var documentOptions = {
          "1.0": {
            schema: "yaml-1.1",
            merge: true,
            tagPrefixes: [{
              handle: "!",
              prefix: PlainValue.defaultTagPrefix
            }, {
              handle: "!!",
              prefix: "tag:private.yaml.org,2002:"
            }]
          },
          1.1: {
            schema: "yaml-1.1",
            merge: true,
            tagPrefixes: [{
              handle: "!",
              prefix: "!"
            }, {
              handle: "!!",
              prefix: PlainValue.defaultTagPrefix
            }]
          },
          1.2: {
            schema: "core",
            merge: false,
            tagPrefixes: [{
              handle: "!",
              prefix: "!"
            }, {
              handle: "!!",
              prefix: PlainValue.defaultTagPrefix
            }]
          }
        };
        function stringifyTag(doc, tag) {
          if ((doc.version || doc.options.version) === "1.0") {
            const priv = tag.match(/^tag:private\.yaml\.org,2002:([^:/]+)$/);
            if (priv)
              return "!" + priv[1];
            const vocab = tag.match(/^tag:([a-zA-Z0-9-]+)\.yaml\.org,2002:(.*)/);
            return vocab ? `!${vocab[1]}/${vocab[2]}` : `!${tag.replace(/^tag:/, "")}`;
          }
          let p = doc.tagPrefixes.find((p2) => tag.indexOf(p2.prefix) === 0);
          if (!p) {
            const dtp = doc.getDefaults().tagPrefixes;
            p = dtp && dtp.find((p2) => tag.indexOf(p2.prefix) === 0);
          }
          if (!p)
            return tag[0] === "!" ? tag : `!<${tag}>`;
          const suffix = tag.substr(p.prefix.length).replace(/[!,[\]{}]/g, (ch) => ({
            "!": "%21",
            ",": "%2C",
            "[": "%5B",
            "]": "%5D",
            "{": "%7B",
            "}": "%7D"
          })[ch]);
          return p.handle + suffix;
        }
        function getTagObject(tags, item) {
          if (item instanceof resolveSeq.Alias)
            return resolveSeq.Alias;
          if (item.tag) {
            const match = tags.filter((t) => t.tag === item.tag);
            if (match.length > 0)
              return match.find((t) => t.format === item.format) || match[0];
          }
          let tagObj, obj;
          if (item instanceof resolveSeq.Scalar) {
            obj = item.value;
            const match = tags.filter((t) => t.identify && t.identify(obj) || t.class && obj instanceof t.class);
            tagObj = match.find((t) => t.format === item.format) || match.find((t) => !t.format);
          } else {
            obj = item;
            tagObj = tags.find((t) => t.nodeClass && obj instanceof t.nodeClass);
          }
          if (!tagObj) {
            const name = obj && obj.constructor ? obj.constructor.name : typeof obj;
            throw new Error(`Tag not resolved for ${name} value`);
          }
          return tagObj;
        }
        function stringifyProps(node, tagObj, {
          anchors,
          doc
        }) {
          const props = [];
          const anchor = doc.anchors.getName(node);
          if (anchor) {
            anchors[anchor] = node;
            props.push(`&${anchor}`);
          }
          if (node.tag) {
            props.push(stringifyTag(doc, node.tag));
          } else if (!tagObj.default) {
            props.push(stringifyTag(doc, tagObj.tag));
          }
          return props.join(" ");
        }
        function stringify(item, ctx, onComment, onChompKeep) {
          const {
            anchors,
            schema: schema2
          } = ctx.doc;
          let tagObj;
          if (!(item instanceof resolveSeq.Node)) {
            const createCtx = {
              aliasNodes: [],
              onTagObj: (o) => tagObj = o,
              prevObjects: /* @__PURE__ */ new Map()
            };
            item = schema2.createNode(item, true, null, createCtx);
            for (const alias of createCtx.aliasNodes) {
              alias.source = alias.source.node;
              let name = anchors.getName(alias.source);
              if (!name) {
                name = anchors.newName();
                anchors.map[name] = alias.source;
              }
            }
          }
          if (item instanceof resolveSeq.Pair)
            return item.toString(ctx, onComment, onChompKeep);
          if (!tagObj)
            tagObj = getTagObject(schema2.tags, item);
          const props = stringifyProps(item, tagObj, ctx);
          if (props.length > 0)
            ctx.indentAtStart = (ctx.indentAtStart || 0) + props.length + 1;
          const str2 = typeof tagObj.stringify === "function" ? tagObj.stringify(item, ctx, onComment, onChompKeep) : item instanceof resolveSeq.Scalar ? resolveSeq.stringifyString(item, ctx, onComment, onChompKeep) : item.toString(ctx, onComment, onChompKeep);
          if (!props)
            return str2;
          return item instanceof resolveSeq.Scalar || str2[0] === "{" || str2[0] === "[" ? `${props} ${str2}` : `${props}
${ctx.indent}${str2}`;
        }
        var Anchors = class {
          static validAnchorNode(node) {
            return node instanceof resolveSeq.Scalar || node instanceof resolveSeq.YAMLSeq || node instanceof resolveSeq.YAMLMap;
          }
          constructor(prefix) {
            PlainValue._defineProperty(this, "map", /* @__PURE__ */ Object.create(null));
            this.prefix = prefix;
          }
          createAlias(node, name) {
            this.setAnchor(node, name);
            return new resolveSeq.Alias(node);
          }
          createMergePair(...sources) {
            const merge3 = new resolveSeq.Merge();
            merge3.value.items = sources.map((s) => {
              if (s instanceof resolveSeq.Alias) {
                if (s.source instanceof resolveSeq.YAMLMap)
                  return s;
              } else if (s instanceof resolveSeq.YAMLMap) {
                return this.createAlias(s);
              }
              throw new Error("Merge sources must be Map nodes or their Aliases");
            });
            return merge3;
          }
          getName(node) {
            const {
              map: map2
            } = this;
            return Object.keys(map2).find((a) => map2[a] === node);
          }
          getNames() {
            return Object.keys(this.map);
          }
          getNode(name) {
            return this.map[name];
          }
          newName(prefix) {
            if (!prefix)
              prefix = this.prefix;
            const names = Object.keys(this.map);
            for (let i = 1; true; ++i) {
              const name = `${prefix}${i}`;
              if (!names.includes(name))
                return name;
            }
          }
          resolveNodes() {
            const {
              map: map2,
              _cstAliases
            } = this;
            Object.keys(map2).forEach((a) => {
              map2[a] = map2[a].resolved;
            });
            _cstAliases.forEach((a) => {
              a.source = a.source.resolved;
            });
            delete this._cstAliases;
          }
          setAnchor(node, name) {
            if (node != null && !Anchors.validAnchorNode(node)) {
              throw new Error("Anchors may only be set for Scalar, Seq and Map nodes");
            }
            if (name && /[\x00-\x19\s,[\]{}]/.test(name)) {
              throw new Error("Anchor names must not contain whitespace or control characters");
            }
            const {
              map: map2
            } = this;
            const prev = node && Object.keys(map2).find((a) => map2[a] === node);
            if (prev) {
              if (!name) {
                return prev;
              } else if (prev !== name) {
                delete map2[prev];
                map2[name] = node;
              }
            } else {
              if (!name) {
                if (!node)
                  return null;
                name = this.newName();
              }
              map2[name] = node;
            }
            return name;
          }
        };
        var visit = (node, tags) => {
          if (node && typeof node === "object") {
            const {
              tag
            } = node;
            if (node instanceof resolveSeq.Collection) {
              if (tag)
                tags[tag] = true;
              node.items.forEach((n) => visit(n, tags));
            } else if (node instanceof resolveSeq.Pair) {
              visit(node.key, tags);
              visit(node.value, tags);
            } else if (node instanceof resolveSeq.Scalar) {
              if (tag)
                tags[tag] = true;
            }
          }
          return tags;
        };
        var listTagNames = (node) => Object.keys(visit(node, {}));
        function parseContents(doc, contents) {
          const comments = {
            before: [],
            after: []
          };
          let body = void 0;
          let spaceBefore = false;
          for (const node of contents) {
            if (node.valueRange) {
              if (body !== void 0) {
                const msg = "Document contains trailing content not separated by a ... or --- line";
                doc.errors.push(new PlainValue.YAMLSyntaxError(node, msg));
                break;
              }
              const res = resolveSeq.resolveNode(doc, node);
              if (spaceBefore) {
                res.spaceBefore = true;
                spaceBefore = false;
              }
              body = res;
            } else if (node.comment !== null) {
              const cc = body === void 0 ? comments.before : comments.after;
              cc.push(node.comment);
            } else if (node.type === PlainValue.Type.BLANK_LINE) {
              spaceBefore = true;
              if (body === void 0 && comments.before.length > 0 && !doc.commentBefore) {
                doc.commentBefore = comments.before.join("\n");
                comments.before = [];
              }
            }
          }
          doc.contents = body || null;
          if (!body) {
            doc.comment = comments.before.concat(comments.after).join("\n") || null;
          } else {
            const cb = comments.before.join("\n");
            if (cb) {
              const cbNode = body instanceof resolveSeq.Collection && body.items[0] ? body.items[0] : body;
              cbNode.commentBefore = cbNode.commentBefore ? `${cb}
${cbNode.commentBefore}` : cb;
            }
            doc.comment = comments.after.join("\n") || null;
          }
        }
        function resolveTagDirective({
          tagPrefixes
        }, directive) {
          const [handle, prefix] = directive.parameters;
          if (!handle || !prefix) {
            const msg = "Insufficient parameters given for %TAG directive";
            throw new PlainValue.YAMLSemanticError(directive, msg);
          }
          if (tagPrefixes.some((p) => p.handle === handle)) {
            const msg = "The %TAG directive must only be given at most once per handle in the same document.";
            throw new PlainValue.YAMLSemanticError(directive, msg);
          }
          return {
            handle,
            prefix
          };
        }
        function resolveYamlDirective(doc, directive) {
          let [version] = directive.parameters;
          if (directive.name === "YAML:1.0")
            version = "1.0";
          if (!version) {
            const msg = "Insufficient parameters given for %YAML directive";
            throw new PlainValue.YAMLSemanticError(directive, msg);
          }
          if (!documentOptions[version]) {
            const v0 = doc.version || doc.options.version;
            const msg = `Document will be parsed as YAML ${v0} rather than YAML ${version}`;
            doc.warnings.push(new PlainValue.YAMLWarning(directive, msg));
          }
          return version;
        }
        function parseDirectives(doc, directives, prevDoc) {
          const directiveComments = [];
          let hasDirectives = false;
          for (const directive of directives) {
            const {
              comment,
              name
            } = directive;
            switch (name) {
              case "TAG":
                try {
                  doc.tagPrefixes.push(resolveTagDirective(doc, directive));
                } catch (error) {
                  doc.errors.push(error);
                }
                hasDirectives = true;
                break;
              case "YAML":
              case "YAML:1.0":
                if (doc.version) {
                  const msg = "The %YAML directive must only be given at most once per document.";
                  doc.errors.push(new PlainValue.YAMLSemanticError(directive, msg));
                }
                try {
                  doc.version = resolveYamlDirective(doc, directive);
                } catch (error) {
                  doc.errors.push(error);
                }
                hasDirectives = true;
                break;
              default:
                if (name) {
                  const msg = `YAML only supports %TAG and %YAML directives, and not %${name}`;
                  doc.warnings.push(new PlainValue.YAMLWarning(directive, msg));
                }
            }
            if (comment)
              directiveComments.push(comment);
          }
          if (prevDoc && !hasDirectives && (doc.version || prevDoc.version || doc.options.version) === "1.1") {
            const copyTagPrefix = ({
              handle,
              prefix
            }) => ({
              handle,
              prefix
            });
            doc.tagPrefixes = prevDoc.tagPrefixes.map(copyTagPrefix);
            doc.version = prevDoc.version;
          }
          doc.commentBefore = directiveComments.join("\n") || null;
        }
        function assertCollection(contents) {
          if (contents instanceof resolveSeq.Collection)
            return true;
          throw new Error("Expected a YAML collection as document contents");
        }
        var Document = class {
          constructor(options) {
            this.anchors = new Anchors(options.anchorPrefix);
            this.commentBefore = null;
            this.comment = null;
            this.contents = null;
            this.directivesEndMarker = null;
            this.errors = [];
            this.options = options;
            this.schema = null;
            this.tagPrefixes = [];
            this.version = null;
            this.warnings = [];
          }
          add(value) {
            assertCollection(this.contents);
            return this.contents.add(value);
          }
          addIn(path5, value) {
            assertCollection(this.contents);
            this.contents.addIn(path5, value);
          }
          delete(key) {
            assertCollection(this.contents);
            return this.contents.delete(key);
          }
          deleteIn(path5) {
            if (resolveSeq.isEmptyPath(path5)) {
              if (this.contents == null)
                return false;
              this.contents = null;
              return true;
            }
            assertCollection(this.contents);
            return this.contents.deleteIn(path5);
          }
          getDefaults() {
            return Document.defaults[this.version] || Document.defaults[this.options.version] || {};
          }
          get(key, keepScalar) {
            return this.contents instanceof resolveSeq.Collection ? this.contents.get(key, keepScalar) : void 0;
          }
          getIn(path5, keepScalar) {
            if (resolveSeq.isEmptyPath(path5))
              return !keepScalar && this.contents instanceof resolveSeq.Scalar ? this.contents.value : this.contents;
            return this.contents instanceof resolveSeq.Collection ? this.contents.getIn(path5, keepScalar) : void 0;
          }
          has(key) {
            return this.contents instanceof resolveSeq.Collection ? this.contents.has(key) : false;
          }
          hasIn(path5) {
            if (resolveSeq.isEmptyPath(path5))
              return this.contents !== void 0;
            return this.contents instanceof resolveSeq.Collection ? this.contents.hasIn(path5) : false;
          }
          set(key, value) {
            assertCollection(this.contents);
            this.contents.set(key, value);
          }
          setIn(path5, value) {
            if (resolveSeq.isEmptyPath(path5))
              this.contents = value;
            else {
              assertCollection(this.contents);
              this.contents.setIn(path5, value);
            }
          }
          setSchema(id, customTags) {
            if (!id && !customTags && this.schema)
              return;
            if (typeof id === "number")
              id = id.toFixed(1);
            if (id === "1.0" || id === "1.1" || id === "1.2") {
              if (this.version)
                this.version = id;
              else
                this.options.version = id;
              delete this.options.schema;
            } else if (id && typeof id === "string") {
              this.options.schema = id;
            }
            if (Array.isArray(customTags))
              this.options.customTags = customTags;
            const opt = Object.assign({}, this.getDefaults(), this.options);
            this.schema = new Schema3.Schema(opt);
          }
          parse(node, prevDoc) {
            if (this.options.keepCstNodes)
              this.cstNode = node;
            if (this.options.keepNodeTypes)
              this.type = "DOCUMENT";
            const {
              directives = [],
              contents = [],
              directivesEndMarker,
              error,
              valueRange
            } = node;
            if (error) {
              if (!error.source)
                error.source = this;
              this.errors.push(error);
            }
            parseDirectives(this, directives, prevDoc);
            if (directivesEndMarker)
              this.directivesEndMarker = true;
            this.range = valueRange ? [valueRange.start, valueRange.end] : null;
            this.setSchema();
            this.anchors._cstAliases = [];
            parseContents(this, contents);
            this.anchors.resolveNodes();
            if (this.options.prettyErrors) {
              for (const error2 of this.errors)
                if (error2 instanceof PlainValue.YAMLError)
                  error2.makePretty();
              for (const warn of this.warnings)
                if (warn instanceof PlainValue.YAMLError)
                  warn.makePretty();
            }
            return this;
          }
          listNonDefaultTags() {
            return listTagNames(this.contents).filter((t) => t.indexOf(Schema3.Schema.defaultPrefix) !== 0);
          }
          setTagPrefix(handle, prefix) {
            if (handle[0] !== "!" || handle[handle.length - 1] !== "!")
              throw new Error("Handle must start and end with !");
            if (prefix) {
              const prev = this.tagPrefixes.find((p) => p.handle === handle);
              if (prev)
                prev.prefix = prefix;
              else
                this.tagPrefixes.push({
                  handle,
                  prefix
                });
            } else {
              this.tagPrefixes = this.tagPrefixes.filter((p) => p.handle !== handle);
            }
          }
          toJSON(arg, onAnchor) {
            const {
              keepBlobsInJSON,
              mapAsMap,
              maxAliasCount
            } = this.options;
            const keep = keepBlobsInJSON && (typeof arg !== "string" || !(this.contents instanceof resolveSeq.Scalar));
            const ctx = {
              doc: this,
              indentStep: "  ",
              keep,
              mapAsMap: keep && !!mapAsMap,
              maxAliasCount,
              stringify
            };
            const anchorNames = Object.keys(this.anchors.map);
            if (anchorNames.length > 0)
              ctx.anchors = new Map(anchorNames.map((name) => [this.anchors.map[name], {
                alias: [],
                aliasCount: 0,
                count: 1
              }]));
            const res = resolveSeq.toJSON(this.contents, arg, ctx);
            if (typeof onAnchor === "function" && ctx.anchors)
              for (const {
                count,
                res: res2
              } of ctx.anchors.values())
                onAnchor(res2, count);
            return res;
          }
          toString() {
            if (this.errors.length > 0)
              throw new Error("Document with errors cannot be stringified");
            const indentSize = this.options.indent;
            if (!Number.isInteger(indentSize) || indentSize <= 0) {
              const s = JSON.stringify(indentSize);
              throw new Error(`"indent" option must be a positive integer, not ${s}`);
            }
            this.setSchema();
            const lines = [];
            let hasDirectives = false;
            if (this.version) {
              let vd = "%YAML 1.2";
              if (this.schema.name === "yaml-1.1") {
                if (this.version === "1.0")
                  vd = "%YAML:1.0";
                else if (this.version === "1.1")
                  vd = "%YAML 1.1";
              }
              lines.push(vd);
              hasDirectives = true;
            }
            const tagNames = this.listNonDefaultTags();
            this.tagPrefixes.forEach(({
              handle,
              prefix
            }) => {
              if (tagNames.some((t) => t.indexOf(prefix) === 0)) {
                lines.push(`%TAG ${handle} ${prefix}`);
                hasDirectives = true;
              }
            });
            if (hasDirectives || this.directivesEndMarker)
              lines.push("---");
            if (this.commentBefore) {
              if (hasDirectives || !this.directivesEndMarker)
                lines.unshift("");
              lines.unshift(this.commentBefore.replace(/^/gm, "#"));
            }
            const ctx = {
              anchors: /* @__PURE__ */ Object.create(null),
              doc: this,
              indent: "",
              indentStep: " ".repeat(indentSize),
              stringify
            };
            let chompKeep = false;
            let contentComment = null;
            if (this.contents) {
              if (this.contents instanceof resolveSeq.Node) {
                if (this.contents.spaceBefore && (hasDirectives || this.directivesEndMarker))
                  lines.push("");
                if (this.contents.commentBefore)
                  lines.push(this.contents.commentBefore.replace(/^/gm, "#"));
                ctx.forceBlockIndent = !!this.comment;
                contentComment = this.contents.comment;
              }
              const onChompKeep = contentComment ? null : () => chompKeep = true;
              const body = stringify(this.contents, ctx, () => contentComment = null, onChompKeep);
              lines.push(resolveSeq.addComment(body, "", contentComment));
            } else if (this.contents !== void 0) {
              lines.push(stringify(this.contents, ctx));
            }
            if (this.comment) {
              if ((!chompKeep || contentComment) && lines[lines.length - 1] !== "")
                lines.push("");
              lines.push(this.comment.replace(/^/gm, "#"));
            }
            return lines.join("\n") + "\n";
          }
        };
        PlainValue._defineProperty(Document, "defaults", documentOptions);
        exports22.Document = Document;
        exports22.defaultOptions = defaultOptions;
        exports22.scalarOptions = scalarOptions;
      }
    });
    var require_dist2 = __commonJS2({
      "node_modules/yaml/dist/index.js"(exports22) {
        "use strict";
        var parseCst = require_parse_cst();
        var Document$1 = require_Document_9b4560a1();
        var Schema3 = require_Schema_88e323a7();
        var PlainValue = require_PlainValue_ec8e588e();
        var warnings = require_warnings_1000a372();
        require_resolveSeq_d03cb037();
        function createNode(value, wrapScalars = true, tag) {
          if (tag === void 0 && typeof wrapScalars === "string") {
            tag = wrapScalars;
            wrapScalars = true;
          }
          const options = Object.assign({}, Document$1.Document.defaults[Document$1.defaultOptions.version], Document$1.defaultOptions);
          const schema2 = new Schema3.Schema(options);
          return schema2.createNode(value, wrapScalars, tag);
        }
        var Document = class extends Document$1.Document {
          constructor(options) {
            super(Object.assign({}, Document$1.defaultOptions, options));
          }
        };
        function parseAllDocuments(src, options) {
          const stream = [];
          let prev;
          for (const cstDoc of parseCst.parse(src)) {
            const doc = new Document(options);
            doc.parse(cstDoc, prev);
            stream.push(doc);
            prev = doc;
          }
          return stream;
        }
        function parseDocument(src, options) {
          const cst = parseCst.parse(src);
          const doc = new Document(options).parse(cst[0]);
          if (cst.length > 1) {
            const errMsg = "Source contains multiple documents; please use YAML.parseAllDocuments()";
            doc.errors.unshift(new PlainValue.YAMLSemanticError(cst[1], errMsg));
          }
          return doc;
        }
        function parse2(src, options) {
          const doc = parseDocument(src, options);
          doc.warnings.forEach((warning) => warnings.warn(warning));
          if (doc.errors.length > 0)
            throw doc.errors[0];
          return doc.toJSON();
        }
        function stringify(value, options) {
          const doc = new Document(options);
          doc.contents = value;
          return String(doc);
        }
        var YAML = {
          createNode,
          defaultOptions: Document$1.defaultOptions,
          Document,
          parse: parse2,
          parseAllDocuments,
          parseCST: parseCst.parse,
          parseDocument,
          scalarOptions: Document$1.scalarOptions,
          stringify
        };
        exports22.YAML = YAML;
      }
    });
    var require_yaml = __commonJS2({
      "node_modules/yaml/index.js"(exports22, module22) {
        module22.exports = require_dist2().YAML;
      }
    });
    var require_loaders = __commonJS2({
      "node_modules/cosmiconfig/dist/loaders.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.loaders = void 0;
        var importFresh;
        var loadJs = function loadJs2(filepath) {
          if (importFresh === void 0) {
            importFresh = require_import_fresh();
          }
          const result = importFresh(filepath);
          return result;
        };
        var parseJson;
        var loadJson = function loadJson2(filepath, content) {
          if (parseJson === void 0) {
            parseJson = require_parse_json();
          }
          try {
            const result = parseJson(content);
            return result;
          } catch (error) {
            error.message = `JSON Error in ${filepath}:
${error.message}`;
            throw error;
          }
        };
        var yaml;
        var loadYaml = function loadYaml2(filepath, content) {
          if (yaml === void 0) {
            yaml = require_yaml();
          }
          try {
            const result = yaml.parse(content, {
              prettyErrors: true
            });
            return result;
          } catch (error) {
            error.message = `YAML Error in ${filepath}:
${error.message}`;
            throw error;
          }
        };
        var loaders = {
          loadJs,
          loadJson,
          loadYaml
        };
        exports22.loaders = loaders;
      }
    });
    var require_getPropertyByPath = __commonJS2({
      "node_modules/cosmiconfig/dist/getPropertyByPath.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.getPropertyByPath = getPropertyByPath;
        function getPropertyByPath(source, path5) {
          if (typeof path5 === "string" && Object.prototype.hasOwnProperty.call(source, path5)) {
            return source[path5];
          }
          const parsedPath = typeof path5 === "string" ? path5.split(".") : path5;
          return parsedPath.reduce((previous, key) => {
            if (previous === void 0) {
              return previous;
            }
            return previous[key];
          }, source);
        }
      }
    });
    var require_ExplorerBase = __commonJS2({
      "node_modules/cosmiconfig/dist/ExplorerBase.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.getExtensionDescription = getExtensionDescription;
        exports22.ExplorerBase = void 0;
        var _path = _interopRequireDefault(require("path"));
        var _loaders = require_loaders();
        var _getPropertyByPath = require_getPropertyByPath();
        function _interopRequireDefault(obj) {
          return obj && obj.__esModule ? obj : {
            default: obj
          };
        }
        var ExplorerBase = class {
          constructor(options) {
            if (options.cache === true) {
              this.loadCache = /* @__PURE__ */ new Map();
              this.searchCache = /* @__PURE__ */ new Map();
            }
            this.config = options;
            this.validateConfig();
          }
          clearLoadCache() {
            if (this.loadCache) {
              this.loadCache.clear();
            }
          }
          clearSearchCache() {
            if (this.searchCache) {
              this.searchCache.clear();
            }
          }
          clearCaches() {
            this.clearLoadCache();
            this.clearSearchCache();
          }
          validateConfig() {
            const config = this.config;
            config.searchPlaces.forEach((place) => {
              const loaderKey = _path.default.extname(place) || "noExt";
              const loader2 = config.loaders[loaderKey];
              if (!loader2) {
                throw new Error(`No loader specified for ${getExtensionDescription(place)}, so searchPlaces item "${place}" is invalid`);
              }
              if (typeof loader2 !== "function") {
                throw new Error(`loader for ${getExtensionDescription(place)} is not a function (type provided: "${typeof loader2}"), so searchPlaces item "${place}" is invalid`);
              }
            });
          }
          shouldSearchStopWithResult(result) {
            if (result === null)
              return false;
            if (result.isEmpty && this.config.ignoreEmptySearchPlaces)
              return false;
            return true;
          }
          nextDirectoryToSearch(currentDir, currentResult) {
            if (this.shouldSearchStopWithResult(currentResult)) {
              return null;
            }
            const nextDir = nextDirUp(currentDir);
            if (nextDir === currentDir || currentDir === this.config.stopDir) {
              return null;
            }
            return nextDir;
          }
          loadPackageProp(filepath, content) {
            const parsedContent = _loaders.loaders.loadJson(filepath, content);
            const packagePropValue = (0, _getPropertyByPath.getPropertyByPath)(parsedContent, this.config.packageProp);
            return packagePropValue || null;
          }
          getLoaderEntryForFile(filepath) {
            if (_path.default.basename(filepath) === "package.json") {
              const loader22 = this.loadPackageProp.bind(this);
              return loader22;
            }
            const loaderKey = _path.default.extname(filepath) || "noExt";
            const loader2 = this.config.loaders[loaderKey];
            if (!loader2) {
              throw new Error(`No loader specified for ${getExtensionDescription(filepath)}`);
            }
            return loader2;
          }
          loadedContentToCosmiconfigResult(filepath, loadedContent) {
            if (loadedContent === null) {
              return null;
            }
            if (loadedContent === void 0) {
              return {
                filepath,
                config: void 0,
                isEmpty: true
              };
            }
            return {
              config: loadedContent,
              filepath
            };
          }
          validateFilePath(filepath) {
            if (!filepath) {
              throw new Error("load must pass a non-empty string");
            }
          }
        };
        exports22.ExplorerBase = ExplorerBase;
        function nextDirUp(dir) {
          return _path.default.dirname(dir);
        }
        function getExtensionDescription(filepath) {
          const ext = _path.default.extname(filepath);
          return ext ? `extension "${ext}"` : "files without extensions";
        }
      }
    });
    var require_readFile = __commonJS2({
      "node_modules/cosmiconfig/dist/readFile.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.readFile = readFile;
        exports22.readFileSync = readFileSync;
        var _fs = _interopRequireDefault(require("fs"));
        function _interopRequireDefault(obj) {
          return obj && obj.__esModule ? obj : {
            default: obj
          };
        }
        async function fsReadFileAsync(pathname, encoding) {
          return new Promise((resolve, reject) => {
            _fs.default.readFile(pathname, encoding, (error, contents) => {
              if (error) {
                reject(error);
                return;
              }
              resolve(contents);
            });
          });
        }
        async function readFile(filepath, options = {}) {
          const throwNotFound = options.throwNotFound === true;
          try {
            const content = await fsReadFileAsync(filepath, "utf8");
            return content;
          } catch (error) {
            if (throwNotFound === false && (error.code === "ENOENT" || error.code === "EISDIR")) {
              return null;
            }
            throw error;
          }
        }
        function readFileSync(filepath, options = {}) {
          const throwNotFound = options.throwNotFound === true;
          try {
            const content = _fs.default.readFileSync(filepath, "utf8");
            return content;
          } catch (error) {
            if (throwNotFound === false && (error.code === "ENOENT" || error.code === "EISDIR")) {
              return null;
            }
            throw error;
          }
        }
      }
    });
    var require_cacheWrapper = __commonJS2({
      "node_modules/cosmiconfig/dist/cacheWrapper.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.cacheWrapper = cacheWrapper;
        exports22.cacheWrapperSync = cacheWrapperSync;
        async function cacheWrapper(cache, key, fn) {
          const cached = cache.get(key);
          if (cached !== void 0) {
            return cached;
          }
          const result = await fn();
          cache.set(key, result);
          return result;
        }
        function cacheWrapperSync(cache, key, fn) {
          const cached = cache.get(key);
          if (cached !== void 0) {
            return cached;
          }
          const result = fn();
          cache.set(key, result);
          return result;
        }
      }
    });
    var require_path_type = __commonJS2({
      "node_modules/path-type/index.js"(exports22) {
        "use strict";
        var {
          promisify
        } = require("util");
        var fs = require("fs");
        async function isType(fsStatType, statsMethodName, filePath) {
          if (typeof filePath !== "string") {
            throw new TypeError(`Expected a string, got ${typeof filePath}`);
          }
          try {
            const stats = await promisify(fs[fsStatType])(filePath);
            return stats[statsMethodName]();
          } catch (error) {
            if (error.code === "ENOENT") {
              return false;
            }
            throw error;
          }
        }
        function isTypeSync(fsStatType, statsMethodName, filePath) {
          if (typeof filePath !== "string") {
            throw new TypeError(`Expected a string, got ${typeof filePath}`);
          }
          try {
            return fs[fsStatType](filePath)[statsMethodName]();
          } catch (error) {
            if (error.code === "ENOENT") {
              return false;
            }
            throw error;
          }
        }
        exports22.isFile = isType.bind(null, "stat", "isFile");
        exports22.isDirectory = isType.bind(null, "stat", "isDirectory");
        exports22.isSymlink = isType.bind(null, "lstat", "isSymbolicLink");
        exports22.isFileSync = isTypeSync.bind(null, "statSync", "isFile");
        exports22.isDirectorySync = isTypeSync.bind(null, "statSync", "isDirectory");
        exports22.isSymlinkSync = isTypeSync.bind(null, "lstatSync", "isSymbolicLink");
      }
    });
    var require_getDirectory = __commonJS2({
      "node_modules/cosmiconfig/dist/getDirectory.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.getDirectory = getDirectory;
        exports22.getDirectorySync = getDirectorySync;
        var _path = _interopRequireDefault(require("path"));
        var _pathType = require_path_type();
        function _interopRequireDefault(obj) {
          return obj && obj.__esModule ? obj : {
            default: obj
          };
        }
        async function getDirectory(filepath) {
          const filePathIsDirectory = await (0, _pathType.isDirectory)(filepath);
          if (filePathIsDirectory === true) {
            return filepath;
          }
          const directory = _path.default.dirname(filepath);
          return directory;
        }
        function getDirectorySync(filepath) {
          const filePathIsDirectory = (0, _pathType.isDirectorySync)(filepath);
          if (filePathIsDirectory === true) {
            return filepath;
          }
          const directory = _path.default.dirname(filepath);
          return directory;
        }
      }
    });
    var require_Explorer = __commonJS2({
      "node_modules/cosmiconfig/dist/Explorer.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.Explorer = void 0;
        var _path = _interopRequireDefault(require("path"));
        var _ExplorerBase = require_ExplorerBase();
        var _readFile = require_readFile();
        var _cacheWrapper = require_cacheWrapper();
        var _getDirectory = require_getDirectory();
        function _interopRequireDefault(obj) {
          return obj && obj.__esModule ? obj : {
            default: obj
          };
        }
        var Explorer = class extends _ExplorerBase.ExplorerBase {
          constructor(options) {
            super(options);
          }
          async search(searchFrom = process.cwd()) {
            const startDirectory = await (0, _getDirectory.getDirectory)(searchFrom);
            const result = await this.searchFromDirectory(startDirectory);
            return result;
          }
          async searchFromDirectory(dir) {
            const absoluteDir = _path.default.resolve(process.cwd(), dir);
            const run = async () => {
              const result = await this.searchDirectory(absoluteDir);
              const nextDir = this.nextDirectoryToSearch(absoluteDir, result);
              if (nextDir) {
                return this.searchFromDirectory(nextDir);
              }
              const transformResult = await this.config.transform(result);
              return transformResult;
            };
            if (this.searchCache) {
              return (0, _cacheWrapper.cacheWrapper)(this.searchCache, absoluteDir, run);
            }
            return run();
          }
          async searchDirectory(dir) {
            for await (const place of this.config.searchPlaces) {
              const placeResult = await this.loadSearchPlace(dir, place);
              if (this.shouldSearchStopWithResult(placeResult) === true) {
                return placeResult;
              }
            }
            return null;
          }
          async loadSearchPlace(dir, place) {
            const filepath = _path.default.join(dir, place);
            const fileContents = await (0, _readFile.readFile)(filepath);
            const result = await this.createCosmiconfigResult(filepath, fileContents);
            return result;
          }
          async loadFileContent(filepath, content) {
            if (content === null) {
              return null;
            }
            if (content.trim() === "") {
              return void 0;
            }
            const loader2 = this.getLoaderEntryForFile(filepath);
            const loaderResult = await loader2(filepath, content);
            return loaderResult;
          }
          async createCosmiconfigResult(filepath, content) {
            const fileContent = await this.loadFileContent(filepath, content);
            const result = this.loadedContentToCosmiconfigResult(filepath, fileContent);
            return result;
          }
          async load(filepath) {
            this.validateFilePath(filepath);
            const absoluteFilePath = _path.default.resolve(process.cwd(), filepath);
            const runLoad = async () => {
              const fileContents = await (0, _readFile.readFile)(absoluteFilePath, {
                throwNotFound: true
              });
              const result = await this.createCosmiconfigResult(absoluteFilePath, fileContents);
              const transformResult = await this.config.transform(result);
              return transformResult;
            };
            if (this.loadCache) {
              return (0, _cacheWrapper.cacheWrapper)(this.loadCache, absoluteFilePath, runLoad);
            }
            return runLoad();
          }
        };
        exports22.Explorer = Explorer;
      }
    });
    var require_ExplorerSync = __commonJS2({
      "node_modules/cosmiconfig/dist/ExplorerSync.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.ExplorerSync = void 0;
        var _path = _interopRequireDefault(require("path"));
        var _ExplorerBase = require_ExplorerBase();
        var _readFile = require_readFile();
        var _cacheWrapper = require_cacheWrapper();
        var _getDirectory = require_getDirectory();
        function _interopRequireDefault(obj) {
          return obj && obj.__esModule ? obj : {
            default: obj
          };
        }
        var ExplorerSync = class extends _ExplorerBase.ExplorerBase {
          constructor(options) {
            super(options);
          }
          searchSync(searchFrom = process.cwd()) {
            const startDirectory = (0, _getDirectory.getDirectorySync)(searchFrom);
            const result = this.searchFromDirectorySync(startDirectory);
            return result;
          }
          searchFromDirectorySync(dir) {
            const absoluteDir = _path.default.resolve(process.cwd(), dir);
            const run = () => {
              const result = this.searchDirectorySync(absoluteDir);
              const nextDir = this.nextDirectoryToSearch(absoluteDir, result);
              if (nextDir) {
                return this.searchFromDirectorySync(nextDir);
              }
              const transformResult = this.config.transform(result);
              return transformResult;
            };
            if (this.searchCache) {
              return (0, _cacheWrapper.cacheWrapperSync)(this.searchCache, absoluteDir, run);
            }
            return run();
          }
          searchDirectorySync(dir) {
            for (const place of this.config.searchPlaces) {
              const placeResult = this.loadSearchPlaceSync(dir, place);
              if (this.shouldSearchStopWithResult(placeResult) === true) {
                return placeResult;
              }
            }
            return null;
          }
          loadSearchPlaceSync(dir, place) {
            const filepath = _path.default.join(dir, place);
            const content = (0, _readFile.readFileSync)(filepath);
            const result = this.createCosmiconfigResultSync(filepath, content);
            return result;
          }
          loadFileContentSync(filepath, content) {
            if (content === null) {
              return null;
            }
            if (content.trim() === "") {
              return void 0;
            }
            const loader2 = this.getLoaderEntryForFile(filepath);
            const loaderResult = loader2(filepath, content);
            return loaderResult;
          }
          createCosmiconfigResultSync(filepath, content) {
            const fileContent = this.loadFileContentSync(filepath, content);
            const result = this.loadedContentToCosmiconfigResult(filepath, fileContent);
            return result;
          }
          loadSync(filepath) {
            this.validateFilePath(filepath);
            const absoluteFilePath = _path.default.resolve(process.cwd(), filepath);
            const runLoadSync = () => {
              const content = (0, _readFile.readFileSync)(absoluteFilePath, {
                throwNotFound: true
              });
              const cosmiconfigResult = this.createCosmiconfigResultSync(absoluteFilePath, content);
              const transformResult = this.config.transform(cosmiconfigResult);
              return transformResult;
            };
            if (this.loadCache) {
              return (0, _cacheWrapper.cacheWrapperSync)(this.loadCache, absoluteFilePath, runLoadSync);
            }
            return runLoadSync();
          }
        };
        exports22.ExplorerSync = ExplorerSync;
      }
    });
    var require_types4 = __commonJS2({
      "node_modules/cosmiconfig/dist/types.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
      }
    });
    var require_dist22 = __commonJS2({
      "node_modules/cosmiconfig/dist/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.cosmiconfig = cosmiconfig;
        exports22.cosmiconfigSync = cosmiconfigSync;
        exports22.defaultLoaders = void 0;
        var _os = _interopRequireDefault(require("os"));
        var _Explorer = require_Explorer();
        var _ExplorerSync = require_ExplorerSync();
        var _loaders = require_loaders();
        var _types = require_types4();
        function _interopRequireDefault(obj) {
          return obj && obj.__esModule ? obj : {
            default: obj
          };
        }
        function cosmiconfig(moduleName, options = {}) {
          const normalizedOptions = normalizeOptions(moduleName, options);
          const explorer = new _Explorer.Explorer(normalizedOptions);
          return {
            search: explorer.search.bind(explorer),
            load: explorer.load.bind(explorer),
            clearLoadCache: explorer.clearLoadCache.bind(explorer),
            clearSearchCache: explorer.clearSearchCache.bind(explorer),
            clearCaches: explorer.clearCaches.bind(explorer)
          };
        }
        function cosmiconfigSync(moduleName, options = {}) {
          const normalizedOptions = normalizeOptions(moduleName, options);
          const explorerSync = new _ExplorerSync.ExplorerSync(normalizedOptions);
          return {
            search: explorerSync.searchSync.bind(explorerSync),
            load: explorerSync.loadSync.bind(explorerSync),
            clearLoadCache: explorerSync.clearLoadCache.bind(explorerSync),
            clearSearchCache: explorerSync.clearSearchCache.bind(explorerSync),
            clearCaches: explorerSync.clearCaches.bind(explorerSync)
          };
        }
        var defaultLoaders = Object.freeze({
          ".cjs": _loaders.loaders.loadJs,
          ".js": _loaders.loaders.loadJs,
          ".json": _loaders.loaders.loadJson,
          ".yaml": _loaders.loaders.loadYaml,
          ".yml": _loaders.loaders.loadYaml,
          noExt: _loaders.loaders.loadYaml
        });
        exports22.defaultLoaders = defaultLoaders;
        var identity2 = function identity22(x) {
          return x;
        };
        function normalizeOptions(moduleName, options) {
          const defaults = {
            packageProp: moduleName,
            searchPlaces: ["package.json", `.${moduleName}rc`, `.${moduleName}rc.json`, `.${moduleName}rc.yaml`, `.${moduleName}rc.yml`, `.${moduleName}rc.js`, `.${moduleName}rc.cjs`, `${moduleName}.config.js`, `${moduleName}.config.cjs`],
            ignoreEmptySearchPlaces: true,
            stopDir: _os.default.homedir(),
            cache: true,
            transform: identity2,
            loaders: defaultLoaders
          };
          const normalizedOptions = Object.assign(Object.assign(Object.assign({}, defaults), options), {}, {
            loaders: Object.assign(Object.assign({}, defaults.loaders), options.loaders)
          });
          return normalizedOptions;
        }
      }
    });
    var require_find_parent_dir = __commonJS2({
      "node_modules/find-parent-dir/index.js"(exports22, module22) {
        "use strict";
        var path5 = require("path");
        var fs = require("fs");
        var exists = fs.exists || path5.exists;
        var existsSync = fs.existsSync || path5.existsSync;
        function splitPath(path22) {
          var parts = path22.split(/(\/|\\)/);
          if (!parts.length)
            return parts;
          return !parts[0].length ? parts.slice(1) : parts;
        }
        exports22 = module22.exports = function(currentFullPath, clue, cb) {
          function testDir(parts) {
            if (parts.length === 0)
              return cb(null, null);
            var p = parts.join("");
            exists(path5.join(p, clue), function(itdoes) {
              if (itdoes)
                return cb(null, p);
              testDir(parts.slice(0, -1));
            });
          }
          testDir(splitPath(currentFullPath));
        };
        exports22.sync = function(currentFullPath, clue) {
          function testDir(parts) {
            if (parts.length === 0)
              return null;
            var p = parts.join("");
            var itdoes = existsSync(path5.join(p, clue));
            return itdoes ? p : testDir(parts.slice(0, -1));
          }
          return testDir(splitPath(currentFullPath));
        };
      }
    });
    var require_get_stdin = __commonJS2({
      "node_modules/get-stdin/index.js"(exports22, module22) {
        "use strict";
        var {
          stdin
        } = process;
        module22.exports = async () => {
          let result = "";
          if (stdin.isTTY) {
            return result;
          }
          stdin.setEncoding("utf8");
          for await (const chunk of stdin) {
            result += chunk;
          }
          return result;
        };
        module22.exports.buffer = async () => {
          const result = [];
          let length = 0;
          if (stdin.isTTY) {
            return Buffer.concat([]);
          }
          for await (const chunk of stdin) {
            result.push(chunk);
            length += chunk.length;
          }
          return Buffer.concat(result, length);
        };
      }
    });
    var require_vendors = __commonJS2({
      "node_modules/ci-info/vendors.json"(exports22, module22) {
        module22.exports = [{
          name: "AppVeyor",
          constant: "APPVEYOR",
          env: "APPVEYOR",
          pr: "APPVEYOR_PULL_REQUEST_NUMBER"
        }, {
          name: "Azure Pipelines",
          constant: "AZURE_PIPELINES",
          env: "SYSTEM_TEAMFOUNDATIONCOLLECTIONURI",
          pr: "SYSTEM_PULLREQUEST_PULLREQUESTID"
        }, {
          name: "Appcircle",
          constant: "APPCIRCLE",
          env: "AC_APPCIRCLE"
        }, {
          name: "Bamboo",
          constant: "BAMBOO",
          env: "bamboo_planKey"
        }, {
          name: "Bitbucket Pipelines",
          constant: "BITBUCKET",
          env: "BITBUCKET_COMMIT",
          pr: "BITBUCKET_PR_ID"
        }, {
          name: "Bitrise",
          constant: "BITRISE",
          env: "BITRISE_IO",
          pr: "BITRISE_PULL_REQUEST"
        }, {
          name: "Buddy",
          constant: "BUDDY",
          env: "BUDDY_WORKSPACE_ID",
          pr: "BUDDY_EXECUTION_PULL_REQUEST_ID"
        }, {
          name: "Buildkite",
          constant: "BUILDKITE",
          env: "BUILDKITE",
          pr: {
            env: "BUILDKITE_PULL_REQUEST",
            ne: "false"
          }
        }, {
          name: "CircleCI",
          constant: "CIRCLE",
          env: "CIRCLECI",
          pr: "CIRCLE_PULL_REQUEST"
        }, {
          name: "Cirrus CI",
          constant: "CIRRUS",
          env: "CIRRUS_CI",
          pr: "CIRRUS_PR"
        }, {
          name: "AWS CodeBuild",
          constant: "CODEBUILD",
          env: "CODEBUILD_BUILD_ARN"
        }, {
          name: "Codefresh",
          constant: "CODEFRESH",
          env: "CF_BUILD_ID",
          pr: {
            any: ["CF_PULL_REQUEST_NUMBER", "CF_PULL_REQUEST_ID"]
          }
        }, {
          name: "Codeship",
          constant: "CODESHIP",
          env: {
            CI_NAME: "codeship"
          }
        }, {
          name: "Drone",
          constant: "DRONE",
          env: "DRONE",
          pr: {
            DRONE_BUILD_EVENT: "pull_request"
          }
        }, {
          name: "dsari",
          constant: "DSARI",
          env: "DSARI"
        }, {
          name: "Expo Application Services",
          constant: "EAS",
          env: "EAS_BUILD"
        }, {
          name: "GitHub Actions",
          constant: "GITHUB_ACTIONS",
          env: "GITHUB_ACTIONS",
          pr: {
            GITHUB_EVENT_NAME: "pull_request"
          }
        }, {
          name: "GitLab CI",
          constant: "GITLAB",
          env: "GITLAB_CI",
          pr: "CI_MERGE_REQUEST_ID"
        }, {
          name: "GoCD",
          constant: "GOCD",
          env: "GO_PIPELINE_LABEL"
        }, {
          name: "LayerCI",
          constant: "LAYERCI",
          env: "LAYERCI",
          pr: "LAYERCI_PULL_REQUEST"
        }, {
          name: "Hudson",
          constant: "HUDSON",
          env: "HUDSON_URL"
        }, {
          name: "Jenkins",
          constant: "JENKINS",
          env: ["JENKINS_URL", "BUILD_ID"],
          pr: {
            any: ["ghprbPullId", "CHANGE_ID"]
          }
        }, {
          name: "Magnum CI",
          constant: "MAGNUM",
          env: "MAGNUM"
        }, {
          name: "Netlify CI",
          constant: "NETLIFY",
          env: "NETLIFY",
          pr: {
            env: "PULL_REQUEST",
            ne: "false"
          }
        }, {
          name: "Nevercode",
          constant: "NEVERCODE",
          env: "NEVERCODE",
          pr: {
            env: "NEVERCODE_PULL_REQUEST",
            ne: "false"
          }
        }, {
          name: "Render",
          constant: "RENDER",
          env: "RENDER",
          pr: {
            IS_PULL_REQUEST: "true"
          }
        }, {
          name: "Sail CI",
          constant: "SAIL",
          env: "SAILCI",
          pr: "SAIL_PULL_REQUEST_NUMBER"
        }, {
          name: "Semaphore",
          constant: "SEMAPHORE",
          env: "SEMAPHORE",
          pr: "PULL_REQUEST_NUMBER"
        }, {
          name: "Screwdriver",
          constant: "SCREWDRIVER",
          env: "SCREWDRIVER",
          pr: {
            env: "SD_PULL_REQUEST",
            ne: "false"
          }
        }, {
          name: "Shippable",
          constant: "SHIPPABLE",
          env: "SHIPPABLE",
          pr: {
            IS_PULL_REQUEST: "true"
          }
        }, {
          name: "Solano CI",
          constant: "SOLANO",
          env: "TDDIUM",
          pr: "TDDIUM_PR_ID"
        }, {
          name: "Strider CD",
          constant: "STRIDER",
          env: "STRIDER"
        }, {
          name: "TaskCluster",
          constant: "TASKCLUSTER",
          env: ["TASK_ID", "RUN_ID"]
        }, {
          name: "TeamCity",
          constant: "TEAMCITY",
          env: "TEAMCITY_VERSION"
        }, {
          name: "Travis CI",
          constant: "TRAVIS",
          env: "TRAVIS",
          pr: {
            env: "TRAVIS_PULL_REQUEST",
            ne: "false"
          }
        }, {
          name: "Vercel",
          constant: "VERCEL",
          env: "NOW_BUILDER"
        }, {
          name: "Visual Studio App Center",
          constant: "APPCENTER",
          env: "APPCENTER_BUILD_ID"
        }];
      }
    });
    var require_ci_info = __commonJS2({
      "node_modules/ci-info/index.js"(exports22) {
        "use strict";
        var vendors = require_vendors();
        var env = process.env;
        Object.defineProperty(exports22, "_vendors", {
          value: vendors.map(function(v) {
            return v.constant;
          })
        });
        exports22.name = null;
        exports22.isPR = null;
        vendors.forEach(function(vendor) {
          const envs = Array.isArray(vendor.env) ? vendor.env : [vendor.env];
          const isCI = envs.every(function(obj) {
            return checkEnv(obj);
          });
          exports22[vendor.constant] = isCI;
          if (isCI) {
            exports22.name = vendor.name;
            switch (typeof vendor.pr) {
              case "string":
                exports22.isPR = !!env[vendor.pr];
                break;
              case "object":
                if ("env" in vendor.pr) {
                  exports22.isPR = vendor.pr.env in env && env[vendor.pr.env] !== vendor.pr.ne;
                } else if ("any" in vendor.pr) {
                  exports22.isPR = vendor.pr.any.some(function(key) {
                    return !!env[key];
                  });
                } else {
                  exports22.isPR = checkEnv(vendor.pr);
                }
                break;
              default:
                exports22.isPR = null;
            }
          }
        });
        exports22.isCI = !!(env.CI || env.CONTINUOUS_INTEGRATION || env.BUILD_NUMBER || env.RUN_ID || exports22.name || false);
        function checkEnv(obj) {
          if (typeof obj === "string")
            return !!env[obj];
          return Object.keys(obj).every(function(k) {
            return env[k] === obj[k];
          });
        }
      }
    });
    module2.exports = {
      cosmiconfig: require_dist22().cosmiconfig,
      cosmiconfigSync: require_dist22().cosmiconfigSync,
      findParentDir: require_find_parent_dir().sync,
      getStdin: require_get_stdin(),
      isCI: () => require_ci_info().isCI
    };
  }
});

// ../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-babel.js
var require_parser_babel = __commonJS({
  "../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-babel.js"(exports2, module2) {
    "use strict";
    (function(e) {
      if (typeof exports2 == "object" && typeof module2 == "object") module2.exports = e();
      else if (typeof define == "function" && define.amd) define(e);
      else {
        var i = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i.prettierPlugins = i.prettierPlugins || {}, i.prettierPlugins.babel = e();
      }
    })(function() {
      "use strict";
      var b = (h, l) => () => (l || h((l = { exports: {} }).exports, l), l.exports);
      var G = b((zf, Jr) => {
        var Tt = function(h) {
          return h && h.Math == Math && h;
        };
        Jr.exports = Tt(typeof globalThis == "object" && globalThis) || Tt(typeof window == "object" && window) || Tt(typeof self == "object" && self) || Tt(typeof global == "object" && global) || /* @__PURE__ */ function() {
          return this;
        }() || Function("return this")();
      });
      var Ae = b((Kf, Yr) => {
        Yr.exports = function(h) {
          try {
            return !!h();
          } catch {
            return true;
          }
        };
      });
      var ke = b((Vf, $r) => {
        var hl = Ae();
        $r.exports = !hl(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      });
      var Et = b((Hf, Qr) => {
        var ll = Ae();
        Qr.exports = !ll(function() {
          var h = function() {
          }.bind();
          return typeof h != "function" || h.hasOwnProperty("prototype");
        });
      });
      var bt = b((Wf, Zr) => {
        var ul = Et(), Ct = Function.prototype.call;
        Zr.exports = ul ? Ct.bind(Ct) : function() {
          return Ct.apply(Ct, arguments);
        };
      });
      var ri = b((si) => {
        "use strict";
        var ei = {}.propertyIsEnumerable, ti = Object.getOwnPropertyDescriptor, cl = ti && !ei.call({ 1: 2 }, 1);
        si.f = cl ? function(l) {
          var p = ti(this, l);
          return !!p && p.enumerable;
        } : ei;
      });
      var ms = b((Xf, ii) => {
        ii.exports = function(h, l) {
          return { enumerable: !(h & 1), configurable: !(h & 2), writable: !(h & 4), value: l };
        };
      });
      var ie = b((Jf, oi) => {
        var ai = Et(), ni = Function.prototype, pl = ni.bind, ys = ni.call, fl = ai && pl.bind(ys, ys);
        oi.exports = ai ? function(h) {
          return h && fl(h);
        } : function(h) {
          return h && function() {
            return ys.apply(h, arguments);
          };
        };
      });
      var vt = b((Yf, li) => {
        var hi = ie(), dl = hi({}.toString), ml = hi("".slice);
        li.exports = function(h) {
          return ml(dl(h), 8, -1);
        };
      });
      var ci = b(($f, ui) => {
        var yl = G(), xl = ie(), gl = Ae(), Al = vt(), xs = yl.Object, Pl = xl("".split);
        ui.exports = gl(function() {
          return !xs("z").propertyIsEnumerable(0);
        }) ? function(h) {
          return Al(h) == "String" ? Pl(h, "") : xs(h);
        } : xs;
      });
      var gs = b((Qf, pi) => {
        var Tl = G(), El = Tl.TypeError;
        pi.exports = function(h) {
          if (h == null) throw El("Can't call method on " + h);
          return h;
        };
      });
      var St = b((Zf, fi) => {
        var Cl = ci(), bl = gs();
        fi.exports = function(h) {
          return Cl(bl(h));
        };
      });
      var ae = b((ed, di) => {
        di.exports = function(h) {
          return typeof h == "function";
        };
      });
      var De = b((td, mi) => {
        var vl = ae();
        mi.exports = function(h) {
          return typeof h == "object" ? h !== null : vl(h);
        };
      });
      var Qe = b((sd, yi) => {
        var As = G(), Sl = ae(), wl = function(h) {
          return Sl(h) ? h : void 0;
        };
        yi.exports = function(h, l) {
          return arguments.length < 2 ? wl(As[h]) : As[h] && As[h][l];
        };
      });
      var gi = b((rd, xi) => {
        var Nl = ie();
        xi.exports = Nl({}.isPrototypeOf);
      });
      var Pi = b((id, Ai) => {
        var Il = Qe();
        Ai.exports = Il("navigator", "userAgent") || "";
      });
      var wi = b((ad, Si) => {
        var vi = G(), Ps = Pi(), Ti = vi.process, Ei = vi.Deno, Ci = Ti && Ti.versions || Ei && Ei.version, bi = Ci && Ci.v8, oe, wt;
        bi && (oe = bi.split("."), wt = oe[0] > 0 && oe[0] < 4 ? 1 : +(oe[0] + oe[1]));
        !wt && Ps && (oe = Ps.match(/Edge\/(\d+)/), (!oe || oe[1] >= 74) && (oe = Ps.match(/Chrome\/(\d+)/), oe && (wt = +oe[1])));
        Si.exports = wt;
      });
      var Ts = b((nd, Ii) => {
        var Ni = wi(), kl = Ae();
        Ii.exports = !!Object.getOwnPropertySymbols && !kl(function() {
          var h = Symbol();
          return !String(h) || !(Object(h) instanceof Symbol) || !Symbol.sham && Ni && Ni < 41;
        });
      });
      var Es = b((od, ki) => {
        var Dl = Ts();
        ki.exports = Dl && !Symbol.sham && typeof Symbol.iterator == "symbol";
      });
      var Cs = b((hd, Di) => {
        var Fl = G(), Ll = Qe(), Ol = ae(), Bl = gi(), Ml = Es(), Rl = Fl.Object;
        Di.exports = Ml ? function(h) {
          return typeof h == "symbol";
        } : function(h) {
          var l = Ll("Symbol");
          return Ol(l) && Bl(l.prototype, Rl(h));
        };
      });
      var Li = b((ld, Fi) => {
        var jl = G(), ql = jl.String;
        Fi.exports = function(h) {
          try {
            return ql(h);
          } catch {
            return "Object";
          }
        };
      });
      var Nt = b((ud, Oi) => {
        var Ul = G(), _l = ae(), zl = Li(), Kl = Ul.TypeError;
        Oi.exports = function(h) {
          if (_l(h)) return h;
          throw Kl(zl(h) + " is not a function");
        };
      });
      var Mi = b((cd, Bi) => {
        var Vl = Nt();
        Bi.exports = function(h, l) {
          var p = h[l];
          return p == null ? void 0 : Vl(p);
        };
      });
      var ji = b((pd, Ri) => {
        var Hl = G(), bs = bt(), vs = ae(), Ss = De(), Wl = Hl.TypeError;
        Ri.exports = function(h, l) {
          var p, d;
          if (l === "string" && vs(p = h.toString) && !Ss(d = bs(p, h)) || vs(p = h.valueOf) && !Ss(d = bs(p, h)) || l !== "string" && vs(p = h.toString) && !Ss(d = bs(p, h))) return d;
          throw Wl("Can't convert object to primitive value");
        };
      });
      var Ui = b((fd, qi) => {
        qi.exports = false;
      });
      var It = b((dd, zi) => {
        var _i = G(), Gl = Object.defineProperty;
        zi.exports = function(h, l) {
          try {
            Gl(_i, h, { value: l, configurable: true, writable: true });
          } catch {
            _i[h] = l;
          }
          return l;
        };
      });
      var kt = b((md, Vi) => {
        var Xl = G(), Jl = It(), Ki = "__core-js_shared__", Yl = Xl[Ki] || Jl(Ki, {});
        Vi.exports = Yl;
      });
      var ws = b((yd, Wi) => {
        var $l = Ui(), Hi = kt();
        (Wi.exports = function(h, l) {
          return Hi[h] || (Hi[h] = l !== void 0 ? l : {});
        })("versions", []).push({ version: "3.22.2", mode: $l ? "pure" : "global", copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)", license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE", source: "https://github.com/zloirock/core-js" });
      });
      var Ns = b((xd, Gi) => {
        var Ql = G(), Zl = gs(), eu = Ql.Object;
        Gi.exports = function(h) {
          return eu(Zl(h));
        };
      });
      var be = b((gd, Xi) => {
        var tu = ie(), su = Ns(), ru = tu({}.hasOwnProperty);
        Xi.exports = Object.hasOwn || function(l, p) {
          return ru(su(l), p);
        };
      });
      var Is = b((Ad, Ji) => {
        var iu = ie(), au = 0, nu = Math.random(), ou = iu(1 .toString);
        Ji.exports = function(h) {
          return "Symbol(" + (h === void 0 ? "" : h) + ")_" + ou(++au + nu, 36);
        };
      });
      var Ze = b((Pd, ea) => {
        var hu = G(), lu = ws(), Yi = be(), uu = Is(), $i = Ts(), Zi = Es(), _e = lu("wks"), Fe = hu.Symbol, Qi = Fe && Fe.for, cu = Zi ? Fe : Fe && Fe.withoutSetter || uu;
        ea.exports = function(h) {
          if (!Yi(_e, h) || !($i || typeof _e[h] == "string")) {
            var l = "Symbol." + h;
            $i && Yi(Fe, h) ? _e[h] = Fe[h] : Zi && Qi ? _e[h] = Qi(l) : _e[h] = cu(l);
          }
          return _e[h];
        };
      });
      var ia = b((Td, ra) => {
        var pu = G(), fu = bt(), ta = De(), sa = Cs(), du = Mi(), mu = ji(), yu = Ze(), xu = pu.TypeError, gu = yu("toPrimitive");
        ra.exports = function(h, l) {
          if (!ta(h) || sa(h)) return h;
          var p = du(h, gu), d;
          if (p) {
            if (l === void 0 && (l = "default"), d = fu(p, h, l), !ta(d) || sa(d)) return d;
            throw xu("Can't convert object to primitive value");
          }
          return l === void 0 && (l = "number"), mu(h, l);
        };
      });
      var ks = b((Ed, aa) => {
        var Au = ia(), Pu = Cs();
        aa.exports = function(h) {
          var l = Au(h, "string");
          return Pu(l) ? l : l + "";
        };
      });
      var ha = b((Cd, oa) => {
        var Tu = G(), na = De(), Ds = Tu.document, Eu = na(Ds) && na(Ds.createElement);
        oa.exports = function(h) {
          return Eu ? Ds.createElement(h) : {};
        };
      });
      var Fs = b((bd, la) => {
        var Cu = ke(), bu = Ae(), vu = ha();
        la.exports = !Cu && !bu(function() {
          return Object.defineProperty(vu("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      });
      var Ls = b((ca) => {
        var Su = ke(), wu = bt(), Nu = ri(), Iu = ms(), ku = St(), Du = ks(), Fu = be(), Lu = Fs(), ua = Object.getOwnPropertyDescriptor;
        ca.f = Su ? ua : function(l, p) {
          if (l = ku(l), p = Du(p), Lu) try {
            return ua(l, p);
          } catch {
          }
          if (Fu(l, p)) return Iu(!wu(Nu.f, l, p), l[p]);
        };
      });
      var fa = b((Sd, pa) => {
        var Ou = ke(), Bu = Ae();
        pa.exports = Ou && Bu(function() {
          return Object.defineProperty(function() {
          }, "prototype", { value: 42, writable: false }).prototype != 42;
        });
      });
      var Os = b((wd, ma) => {
        var da = G(), Mu = De(), Ru = da.String, ju = da.TypeError;
        ma.exports = function(h) {
          if (Mu(h)) return h;
          throw ju(Ru(h) + " is not an object");
        };
      });
      var qs = b((xa) => {
        var qu = G(), Uu = ke(), _u = Fs(), zu = fa(), Dt = Os(), ya = ks(), Ku = qu.TypeError, Bs = Object.defineProperty, Vu = Object.getOwnPropertyDescriptor, Ms = "enumerable", Rs = "configurable", js = "writable";
        xa.f = Uu ? zu ? function(l, p, d) {
          if (Dt(l), p = ya(p), Dt(d), typeof l == "function" && p === "prototype" && "value" in d && js in d && !d[js]) {
            var m = Vu(l, p);
            m && m[js] && (l[p] = d.value, d = { configurable: Rs in d ? d[Rs] : m[Rs], enumerable: Ms in d ? d[Ms] : m[Ms], writable: false });
          }
          return Bs(l, p, d);
        } : Bs : function(l, p, d) {
          if (Dt(l), p = ya(p), Dt(d), _u) try {
            return Bs(l, p, d);
          } catch {
          }
          if ("get" in d || "set" in d) throw Ku("Accessors not supported");
          return "value" in d && (l[p] = d.value), l;
        };
      });
      var Ft = b((Id, ga) => {
        var Hu = ke(), Wu = qs(), Gu = ms();
        ga.exports = Hu ? function(h, l, p) {
          return Wu.f(h, l, Gu(1, p));
        } : function(h, l, p) {
          return h[l] = p, h;
        };
      });
      var Lt = b((kd, Aa) => {
        var Xu = ie(), Ju = ae(), Us = kt(), Yu = Xu(Function.toString);
        Ju(Us.inspectSource) || (Us.inspectSource = function(h) {
          return Yu(h);
        });
        Aa.exports = Us.inspectSource;
      });
      var Ea = b((Dd, Ta) => {
        var $u = G(), Qu = ae(), Zu = Lt(), Pa = $u.WeakMap;
        Ta.exports = Qu(Pa) && /native code/.test(Zu(Pa));
      });
      var va = b((Fd, ba) => {
        var ec = ws(), tc = Is(), Ca = ec("keys");
        ba.exports = function(h) {
          return Ca[h] || (Ca[h] = tc(h));
        };
      });
      var _s = b((Ld, Sa) => {
        Sa.exports = {};
      });
      var Fa = b((Od, Da) => {
        var sc = Ea(), ka = G(), zs = ie(), rc = De(), ic = Ft(), Ks = be(), Vs = kt(), ac = va(), nc = _s(), wa = "Object already initialized", Ws = ka.TypeError, oc = ka.WeakMap, Ot, et, Bt, hc = function(h) {
          return Bt(h) ? et(h) : Ot(h, {});
        }, lc = function(h) {
          return function(l) {
            var p;
            if (!rc(l) || (p = et(l)).type !== h) throw Ws("Incompatible receiver, " + h + " required");
            return p;
          };
        };
        sc || Vs.state ? (ve = Vs.state || (Vs.state = new oc()), Na = zs(ve.get), Hs = zs(ve.has), Ia = zs(ve.set), Ot = function(h, l) {
          if (Hs(ve, h)) throw new Ws(wa);
          return l.facade = h, Ia(ve, h, l), l;
        }, et = function(h) {
          return Na(ve, h) || {};
        }, Bt = function(h) {
          return Hs(ve, h);
        }) : (Le = ac("state"), nc[Le] = true, Ot = function(h, l) {
          if (Ks(h, Le)) throw new Ws(wa);
          return l.facade = h, ic(h, Le, l), l;
        }, et = function(h) {
          return Ks(h, Le) ? h[Le] : {};
        }, Bt = function(h) {
          return Ks(h, Le);
        });
        var ve, Na, Hs, Ia, Le;
        Da.exports = { set: Ot, get: et, has: Bt, enforce: hc, getterFor: lc };
      });
      var Ba = b((Bd, Oa) => {
        var Gs = ke(), uc = be(), La = Function.prototype, cc = Gs && Object.getOwnPropertyDescriptor, Xs = uc(La, "name"), pc = Xs && function() {
        }.name === "something", fc = Xs && (!Gs || Gs && cc(La, "name").configurable);
        Oa.exports = { EXISTS: Xs, PROPER: pc, CONFIGURABLE: fc };
      });
      var Ua = b((Md, qa) => {
        var dc = G(), Ma = ae(), mc = be(), Ra = Ft(), yc = It(), xc = Lt(), ja = Fa(), gc = Ba().CONFIGURABLE, Ac = ja.get, Pc = ja.enforce, Tc = String(String).split("String");
        (qa.exports = function(h, l, p, d) {
          var m = d ? !!d.unsafe : false, A = d ? !!d.enumerable : false, g = d ? !!d.noTargetGet : false, x = d && d.name !== void 0 ? d.name : l, T;
          if (Ma(p) && (String(x).slice(0, 7) === "Symbol(" && (x = "[" + String(x).replace(/^Symbol\(([^)]*)\)/, "$1") + "]"), (!mc(p, "name") || gc && p.name !== x) && Ra(p, "name", x), T = Pc(p), T.source || (T.source = Tc.join(typeof x == "string" ? x : ""))), h === dc) {
            A ? h[l] = p : yc(l, p);
            return;
          } else m ? !g && h[l] && (A = true) : delete h[l];
          A ? h[l] = p : Ra(h, l, p);
        })(Function.prototype, "toString", function() {
          return Ma(this) && Ac(this).source || xc(this);
        });
      });
      var Js = b((Rd, _a) => {
        var Ec = Math.ceil, Cc = Math.floor;
        _a.exports = function(h) {
          var l = +h;
          return l !== l || l === 0 ? 0 : (l > 0 ? Cc : Ec)(l);
        };
      });
      var Ka = b((jd, za) => {
        var bc = Js(), vc = Math.max, Sc = Math.min;
        za.exports = function(h, l) {
          var p = bc(h);
          return p < 0 ? vc(p + l, 0) : Sc(p, l);
        };
      });
      var Ha = b((qd, Va) => {
        var wc = Js(), Nc = Math.min;
        Va.exports = function(h) {
          return h > 0 ? Nc(wc(h), 9007199254740991) : 0;
        };
      });
      var Mt = b((Ud, Wa) => {
        var Ic = Ha();
        Wa.exports = function(h) {
          return Ic(h.length);
        };
      });
      var Ja = b((_d, Xa) => {
        var kc = St(), Dc = Ka(), Fc = Mt(), Ga = function(h) {
          return function(l, p, d) {
            var m = kc(l), A = Fc(m), g = Dc(d, A), x;
            if (h && p != p) {
              for (; A > g; ) if (x = m[g++], x != x) return true;
            } else for (; A > g; g++) if ((h || g in m) && m[g] === p) return h || g || 0;
            return !h && -1;
          };
        };
        Xa.exports = { includes: Ga(true), indexOf: Ga(false) };
      });
      var Qa = b((zd, $a) => {
        var Lc = ie(), Ys = be(), Oc = St(), Bc = Ja().indexOf, Mc = _s(), Ya = Lc([].push);
        $a.exports = function(h, l) {
          var p = Oc(h), d = 0, m = [], A;
          for (A in p) !Ys(Mc, A) && Ys(p, A) && Ya(m, A);
          for (; l.length > d; ) Ys(p, A = l[d++]) && (~Bc(m, A) || Ya(m, A));
          return m;
        };
      });
      var en = b((Kd, Za) => {
        Za.exports = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
      });
      var sn = b((tn) => {
        var Rc = Qa(), jc = en(), qc = jc.concat("length", "prototype");
        tn.f = Object.getOwnPropertyNames || function(l) {
          return Rc(l, qc);
        };
      });
      var an = b((rn) => {
        rn.f = Object.getOwnPropertySymbols;
      });
      var on = b((Wd, nn) => {
        var Uc = Qe(), _c = ie(), zc = sn(), Kc = an(), Vc = Os(), Hc = _c([].concat);
        nn.exports = Uc("Reflect", "ownKeys") || function(l) {
          var p = zc.f(Vc(l)), d = Kc.f;
          return d ? Hc(p, d(l)) : p;
        };
      });
      var un = b((Gd, ln) => {
        var hn = be(), Wc = on(), Gc = Ls(), Xc = qs();
        ln.exports = function(h, l, p) {
          for (var d = Wc(l), m = Xc.f, A = Gc.f, g = 0; g < d.length; g++) {
            var x = d[g];
            !hn(h, x) && !(p && hn(p, x)) && m(h, x, A(l, x));
          }
        };
      });
      var pn = b((Xd, cn) => {
        var Jc = Ae(), Yc = ae(), $c = /#|\.prototype\./, tt = function(h, l) {
          var p = Zc[Qc(h)];
          return p == tp ? true : p == ep ? false : Yc(l) ? Jc(l) : !!l;
        }, Qc = tt.normalize = function(h) {
          return String(h).replace($c, ".").toLowerCase();
        }, Zc = tt.data = {}, ep = tt.NATIVE = "N", tp = tt.POLYFILL = "P";
        cn.exports = tt;
      });
      var Qs = b((Jd, fn) => {
        var $s = G(), sp = Ls().f, rp = Ft(), ip = Ua(), ap = It(), np = un(), op = pn();
        fn.exports = function(h, l) {
          var p = h.target, d = h.global, m = h.stat, A, g, x, T, k, D;
          if (d ? g = $s : m ? g = $s[p] || ap(p, {}) : g = ($s[p] || {}).prototype, g) for (x in l) {
            if (k = l[x], h.noTargetGet ? (D = sp(g, x), T = D && D.value) : T = g[x], A = op(d ? x : p + (m ? "." : "#") + x, h.forced), !A && T !== void 0) {
              if (typeof k == typeof T) continue;
              np(k, T);
            }
            (h.sham || T && T.sham) && rp(k, "sham", true), ip(g, x, k, h);
          }
        };
      });
      var dn = b(() => {
        var hp = Qs(), lp = G();
        hp({ global: true }, { globalThis: lp });
      });
      var mn = b(() => {
        dn();
      });
      var Zs = b((em, yn) => {
        var up = vt();
        yn.exports = Array.isArray || function(l) {
          return up(l) == "Array";
        };
      });
      var An = b((tm, gn) => {
        var xn = ie(), cp = Nt(), pp = Et(), fp = xn(xn.bind);
        gn.exports = function(h, l) {
          return cp(h), l === void 0 ? h : pp ? fp(h, l) : function() {
            return h.apply(l, arguments);
          };
        };
      });
      var En = b((sm, Tn) => {
        "use strict";
        var dp = G(), mp = Zs(), yp = Mt(), xp = An(), gp = dp.TypeError, Pn = function(h, l, p, d, m, A, g, x) {
          for (var T = m, k = 0, D = g ? xp(g, x) : false, E, L; k < d; ) {
            if (k in p) {
              if (E = D ? D(p[k], k, l) : p[k], A > 0 && mp(E)) L = yp(E), T = Pn(h, l, E, L, T, A - 1) - 1;
              else {
                if (T >= 9007199254740991) throw gp("Exceed the acceptable array length");
                h[T] = E;
              }
              T++;
            }
            k++;
          }
          return T;
        };
        Tn.exports = Pn;
      });
      var vn = b((rm, bn) => {
        var Ap = Ze(), Pp = Ap("toStringTag"), Cn = {};
        Cn[Pp] = "z";
        bn.exports = String(Cn) === "[object z]";
      });
      var wn = b((im, Sn) => {
        var Tp = G(), Ep = vn(), Cp = ae(), Rt = vt(), bp = Ze(), vp = bp("toStringTag"), Sp = Tp.Object, wp = Rt(/* @__PURE__ */ function() {
          return arguments;
        }()) == "Arguments", Np = function(h, l) {
          try {
            return h[l];
          } catch {
          }
        };
        Sn.exports = Ep ? Rt : function(h) {
          var l, p, d;
          return h === void 0 ? "Undefined" : h === null ? "Null" : typeof (p = Np(l = Sp(h), vp)) == "string" ? p : wp ? Rt(l) : (d = Rt(l)) == "Object" && Cp(l.callee) ? "Arguments" : d;
        };
      });
      var Ln = b((am, Fn) => {
        var Ip = ie(), kp = Ae(), Nn = ae(), Dp = wn(), Fp = Qe(), Lp = Lt(), In = function() {
        }, Op = [], kn = Fp("Reflect", "construct"), er = /^\s*(?:class|function)\b/, Bp = Ip(er.exec), Mp = !er.exec(In), st = function(l) {
          if (!Nn(l)) return false;
          try {
            return kn(In, Op, l), true;
          } catch {
            return false;
          }
        }, Dn = function(l) {
          if (!Nn(l)) return false;
          switch (Dp(l)) {
            case "AsyncFunction":
            case "GeneratorFunction":
            case "AsyncGeneratorFunction":
              return false;
          }
          try {
            return Mp || !!Bp(er, Lp(l));
          } catch {
            return true;
          }
        };
        Dn.sham = true;
        Fn.exports = !kn || kp(function() {
          var h;
          return st(st.call) || !st(Object) || !st(function() {
            h = true;
          }) || h;
        }) ? Dn : st;
      });
      var Rn = b((nm, Mn) => {
        var Rp = G(), On = Zs(), jp = Ln(), qp = De(), Up = Ze(), _p = Up("species"), Bn = Rp.Array;
        Mn.exports = function(h) {
          var l;
          return On(h) && (l = h.constructor, jp(l) && (l === Bn || On(l.prototype)) ? l = void 0 : qp(l) && (l = l[_p], l === null && (l = void 0))), l === void 0 ? Bn : l;
        };
      });
      var qn = b((om, jn) => {
        var zp = Rn();
        jn.exports = function(h, l) {
          return new (zp(h))(l === 0 ? 0 : l);
        };
      });
      var Un = b(() => {
        "use strict";
        var Kp = Qs(), Vp = En(), Hp = Nt(), Wp = Ns(), Gp = Mt(), Xp = qn();
        Kp({ target: "Array", proto: true }, { flatMap: function(l) {
          var p = Wp(this), d = Gp(p), m;
          return Hp(l), m = Xp(p, 0), m.length = Vp(m, p, p, d, 0, 1, l, arguments.length > 1 ? arguments[1] : void 0), m;
        } });
      });
      var qf = b((um, Eo) => {
        var _n, zn, Kn, Vn, Hn;
        function rt(h, l) {
          return l || (l = h.slice(0)), Object.freeze(Object.defineProperties(h, { raw: { value: Object.freeze(l) } }));
        }
        mn();
        Un();
        var ir = Object.defineProperty, Jp = Object.getOwnPropertyDescriptor, ar = Object.getOwnPropertyNames, Yp = Object.prototype.hasOwnProperty, $n = (h, l) => function() {
          return h && (l = (0, h[ar(h)[0]])(h = 0)), l;
        }, H = (h, l) => function() {
          return l || (0, h[ar(h)[0]])((l = { exports: {} }).exports, l), l.exports;
        }, $p = (h, l) => {
          for (var p in l) ir(h, p, { get: l[p], enumerable: true });
        }, Qp = (h, l, p, d) => {
          if (l && typeof l == "object" || typeof l == "function") for (let m of ar(l)) !Yp.call(h, m) && m !== p && ir(h, m, { get: () => l[m], enumerable: !(d = Jp(l, m)) || d.enumerable });
          return h;
        }, Zp = (h) => Qp(ir({}, "__esModule", { value: true }), h), V = $n({ "<define:process>"() {
        } }), ef = H({ "src/utils/try-combinations.js"(h, l) {
          "use strict";
          V();
          function p() {
            let d;
            for (var m = arguments.length, A = new Array(m), g = 0; g < m; g++) A[g] = arguments[g];
            for (let [x, T] of A.entries()) try {
              return { result: T() };
            } catch (k) {
              x === 0 && (d = k);
            }
            return { error: d };
          }
          l.exports = p;
        } }), Qn = H({ "src/language-js/utils/get-shebang.js"(h, l) {
          "use strict";
          V();
          function p(d) {
            if (!d.startsWith("#!")) return "";
            let m = d.indexOf(`
`);
            return m === -1 ? d : d.slice(0, m);
          }
          l.exports = p;
        } }), tf = H({ "src/utils/text/skip-inline-comment.js"(h, l) {
          "use strict";
          V();
          function p(d, m) {
            if (m === false) return false;
            if (d.charAt(m) === "/" && d.charAt(m + 1) === "*") {
              for (let A = m + 2; A < d.length; ++A) if (d.charAt(A) === "*" && d.charAt(A + 1) === "/") return A + 2;
            }
            return m;
          }
          l.exports = p;
        } }), sf = H({ "src/utils/text/skip-newline.js"(h, l) {
          "use strict";
          V();
          function p(d, m, A) {
            let g = A && A.backwards;
            if (m === false) return false;
            let x = d.charAt(m);
            if (g) {
              if (d.charAt(m - 1) === "\r" && x === `
`) return m - 2;
              if (x === `
` || x === "\r" || x === "\u2028" || x === "\u2029") return m - 1;
            } else {
              if (x === "\r" && d.charAt(m + 1) === `
`) return m + 2;
              if (x === `
` || x === "\r" || x === "\u2028" || x === "\u2029") return m + 1;
            }
            return m;
          }
          l.exports = p;
        } }), Zn = H({ "src/utils/text/skip.js"(h, l) {
          "use strict";
          V();
          function p(x) {
            return (T, k, D) => {
              let E = D && D.backwards;
              if (k === false) return false;
              let { length: L } = T, R = k;
              for (; R >= 0 && R < L; ) {
                let F = T.charAt(R);
                if (x instanceof RegExp) {
                  if (!x.test(F)) return R;
                } else if (!x.includes(F)) return R;
                E ? R-- : R++;
              }
              return R === -1 || R === L ? R : false;
            };
          }
          var d = p(/\s/), m = p(" 	"), A = p(",; 	"), g = p(/[^\n\r]/);
          l.exports = { skipWhitespace: d, skipSpaces: m, skipToLineEnd: A, skipEverythingButNewLine: g };
        } }), rf = H({ "src/utils/text/skip-trailing-comment.js"(h, l) {
          "use strict";
          V();
          var { skipEverythingButNewLine: p } = Zn();
          function d(m, A) {
            return A === false ? false : m.charAt(A) === "/" && m.charAt(A + 1) === "/" ? p(m, A) : A;
          }
          l.exports = d;
        } }), af = H({ "src/utils/text/get-next-non-space-non-comment-character-index-with-start-index.js"(h, l) {
          "use strict";
          V();
          var p = tf(), d = sf(), m = rf(), { skipSpaces: A } = Zn();
          function g(x, T) {
            let k = null, D = T;
            for (; D !== k; ) k = D, D = A(x, D), D = p(x, D), D = m(x, D), D = d(x, D);
            return D;
          }
          l.exports = g;
        } }), eo = {};
        $p(eo, { EOL: () => rr, arch: () => nf, cpus: () => oo, default: () => po, endianness: () => to, freemem: () => ao, getNetworkInterfaces: () => co, hostname: () => so, loadavg: () => ro, networkInterfaces: () => uo, platform: () => of, release: () => lo, tmpDir: () => tr, tmpdir: () => sr, totalmem: () => no, type: () => ho, uptime: () => io });
        function to() {
          if (typeof jt > "u") {
            var h = new ArrayBuffer(2), l = new Uint8Array(h), p = new Uint16Array(h);
            if (l[0] = 1, l[1] = 2, p[0] === 258) jt = "BE";
            else if (p[0] === 513) jt = "LE";
            else throw new Error("unable to figure out endianess");
          }
          return jt;
        }
        function so() {
          return typeof globalThis.location < "u" ? globalThis.location.hostname : "";
        }
        function ro() {
          return [];
        }
        function io() {
          return 0;
        }
        function ao() {
          return Number.MAX_VALUE;
        }
        function no() {
          return Number.MAX_VALUE;
        }
        function oo() {
          return [];
        }
        function ho() {
          return "Browser";
        }
        function lo() {
          return typeof globalThis.navigator < "u" ? globalThis.navigator.appVersion : "";
        }
        function uo() {
        }
        function co() {
        }
        function nf() {
          return "javascript";
        }
        function of() {
          return "browser";
        }
        function tr() {
          return "/tmp";
        }
        var jt, sr, rr, po, hf = $n({ "node-modules-polyfills:os"() {
          V(), sr = tr, rr = `
`, po = { EOL: rr, tmpdir: sr, tmpDir: tr, networkInterfaces: uo, getNetworkInterfaces: co, release: lo, type: ho, cpus: oo, totalmem: no, freemem: ao, uptime: io, loadavg: ro, hostname: so, endianness: to };
        } }), lf = H({ "node-modules-polyfills-commonjs:os"(h, l) {
          V();
          var p = (hf(), Zp(eo));
          if (p && p.default) {
            l.exports = p.default;
            for (let d in p) l.exports[d] = p[d];
          } else p && (l.exports = p);
        } }), uf = H({ "node_modules/detect-newline/index.js"(h, l) {
          "use strict";
          V();
          var p = (d) => {
            if (typeof d != "string") throw new TypeError("Expected a string");
            let m = d.match(/(?:\r?\n)/g) || [];
            if (m.length === 0) return;
            let A = m.filter((x) => x === `\r
`).length, g = m.length - A;
            return A > g ? `\r
` : `
`;
          };
          l.exports = p, l.exports.graceful = (d) => typeof d == "string" && p(d) || `
`;
        } }), cf = H({ "node_modules/jest-docblock/build/index.js"(h) {
          "use strict";
          V(), Object.defineProperty(h, "__esModule", { value: true }), h.extract = R, h.parse = W, h.parseWithComments = Y, h.print = M, h.strip = F;
          function l() {
            let u = lf();
            return l = function() {
              return u;
            }, u;
          }
          function p() {
            let u = d(uf());
            return p = function() {
              return u;
            }, u;
          }
          function d(u) {
            return u && u.__esModule ? u : { default: u };
          }
          var m = /\*\/$/, A = /^\/\*\*/, g = /^\s*(\/\*\*?(.|\r?\n)*?\*\/)/, x = /(^|\s+)\/\/([^\r\n]*)/g, T = /^(\r?\n)+/, k = /(?:^|\r?\n) *(@[^\r\n]*?) *\r?\n *(?![^@\r\n]*\/\/[^]*)([^@\r\n\s][^@\r\n]+?) *\r?\n/g, D = /(?:^|\r?\n) *@(\S+) *([^\r\n]*)/g, E = /(\r?\n|^) *\* ?/g, L = [];
          function R(u) {
            let X = u.match(g);
            return X ? X[0].trimLeft() : "";
          }
          function F(u) {
            let X = u.match(g);
            return X && X[0] ? u.substring(X[0].length) : u;
          }
          function W(u) {
            return Y(u).pragmas;
          }
          function Y(u) {
            let X = (0, p().default)(u) || l().EOL;
            u = u.replace(A, "").replace(m, "").replace(E, "$1");
            let se = "";
            for (; se !== u; ) se = u, u = u.replace(k, "".concat(X, "$1 $2").concat(X));
            u = u.replace(T, "").trimRight();
            let J = /* @__PURE__ */ Object.create(null), Oe = u.replace(D, "").replace(T, "").trimRight(), $;
            for (; $ = D.exec(u); ) {
              let z2 = $[2].replace(x, "");
              typeof J[$[1]] == "string" || Array.isArray(J[$[1]]) ? J[$[1]] = L.concat(J[$[1]], z2) : J[$[1]] = z2;
            }
            return { comments: Oe, pragmas: J };
          }
          function M(u) {
            let { comments: X = "", pragmas: se = {} } = u, J = (0, p().default)(X) || l().EOL, Oe = "/**", $ = " *", z2 = " */", O = Object.keys(se), C = O.map((Z) => j(Z, se[Z])).reduce((Z, he) => Z.concat(he), []).map((Z) => $ + " " + Z + J).join("");
            if (!X) {
              if (O.length === 0) return "";
              if (O.length === 1 && !Array.isArray(se[O[0]])) {
                let Z = se[O[0]];
                return "".concat(Oe, " ").concat(j(O[0], Z)[0]).concat(z2);
              }
            }
            let Ve = X.split(J).map((Z) => "".concat($, " ").concat(Z)).join(J) + J;
            return Oe + J + (X ? Ve : "") + (X && O.length ? $ + J : "") + C + z2;
          }
          function j(u, X) {
            return L.concat(X).map((se) => "@".concat(u, " ").concat(se).trim());
          }
        } }), pf = H({ "src/common/end-of-line.js"(h, l) {
          "use strict";
          V();
          function p(g) {
            let x = g.indexOf("\r");
            return x >= 0 ? g.charAt(x + 1) === `
` ? "crlf" : "cr" : "lf";
          }
          function d(g) {
            switch (g) {
              case "cr":
                return "\r";
              case "crlf":
                return `\r
`;
              default:
                return `
`;
            }
          }
          function m(g, x) {
            let T;
            switch (x) {
              case `
`:
                T = /\n/g;
                break;
              case "\r":
                T = /\r/g;
                break;
              case `\r
`:
                T = /\r\n/g;
                break;
              default:
                throw new Error('Unexpected "eol" '.concat(JSON.stringify(x), "."));
            }
            let k = g.match(T);
            return k ? k.length : 0;
          }
          function A(g) {
            return g.replace(/\r\n?/g, `
`);
          }
          l.exports = { guessEndOfLine: p, convertEndOfLineToChars: d, countEndOfLineChars: m, normalizeEndOfLine: A };
        } }), ff = H({ "src/language-js/pragma.js"(h, l) {
          "use strict";
          V();
          var { parseWithComments: p, strip: d, extract: m, print: A } = cf(), { normalizeEndOfLine: g } = pf(), x = Qn();
          function T(E) {
            let L = x(E);
            L && (E = E.slice(L.length + 1));
            let R = m(E), { pragmas: F, comments: W } = p(R);
            return { shebang: L, text: E, pragmas: F, comments: W };
          }
          function k(E) {
            let L = Object.keys(T(E).pragmas);
            return L.includes("prettier") || L.includes("format");
          }
          function D(E) {
            let { shebang: L, text: R, pragmas: F, comments: W } = T(E), Y = d(R), M = A({ pragmas: Object.assign({ format: "" }, F), comments: W.trimStart() });
            return (L ? "".concat(L, `
`) : "") + g(M) + (Y.startsWith(`
`) ? `
` : `

`) + Y;
          }
          l.exports = { hasPragma: k, insertPragma: D };
        } }), fo = H({ "src/utils/is-non-empty-array.js"(h, l) {
          "use strict";
          V();
          function p(d) {
            return Array.isArray(d) && d.length > 0;
          }
          l.exports = p;
        } }), mo = H({ "src/language-js/loc.js"(h, l) {
          "use strict";
          V();
          var p = fo();
          function d(T, k) {
            let { ignoreDecorators: D } = k || {};
            if (!D) {
              let E = T.declaration && T.declaration.decorators || T.decorators;
              if (p(E)) return d(E[0]);
            }
            return T.range ? T.range[0] : T.start;
          }
          function m(T) {
            return T.range ? T.range[1] : T.end;
          }
          function A(T, k) {
            let D = d(T);
            return Number.isInteger(D) && D === d(k);
          }
          function g(T, k) {
            let D = m(T);
            return Number.isInteger(D) && D === m(k);
          }
          function x(T, k) {
            return A(T, k) && g(T, k);
          }
          l.exports = { locStart: d, locEnd: m, hasSameLocStart: A, hasSameLoc: x };
        } }), yo = H({ "src/language-js/parse/utils/create-parser.js"(h, l) {
          "use strict";
          V();
          var { hasPragma: p } = ff(), { locStart: d, locEnd: m } = mo();
          function A(g) {
            return g = typeof g == "function" ? { parse: g } : g, Object.assign({ astFormat: "estree", hasPragma: p, locStart: d, locEnd: m }, g);
          }
          l.exports = A;
        } }), nr = H({ "src/common/parser-create-error.js"(h, l) {
          "use strict";
          V();
          function p(d, m) {
            let A = new SyntaxError(d + " (" + m.start.line + ":" + m.start.column + ")");
            return A.loc = m, A;
          }
          l.exports = p;
        } }), xo = H({ "src/language-js/parse/utils/create-babel-parse-error.js"(h, l) {
          "use strict";
          V();
          var p = nr();
          function d(m) {
            let { message: A, loc: g } = m;
            return p(A.replace(/ \(.*\)/, ""), { start: { line: g ? g.line : 0, column: g ? g.column + 1 : 0 } });
          }
          l.exports = d;
        } }), df = H({ "src/language-js/utils/is-ts-keyword-type.js"(h, l) {
          "use strict";
          V();
          function p(d) {
            let { type: m } = d;
            return m.startsWith("TS") && m.endsWith("Keyword");
          }
          l.exports = p;
        } }), mf = H({ "src/language-js/utils/is-block-comment.js"(h, l) {
          "use strict";
          V();
          var p = /* @__PURE__ */ new Set(["Block", "CommentBlock", "MultiLine"]), d = (m) => p.has(m == null ? void 0 : m.type);
          l.exports = d;
        } }), yf = H({ "src/language-js/utils/is-type-cast-comment.js"(h, l) {
          "use strict";
          V();
          var p = mf();
          function d(m) {
            return p(m) && m.value[0] === "*" && /@type\b/.test(m.value);
          }
          l.exports = d;
        } }), xf = H({ "src/utils/get-last.js"(h, l) {
          "use strict";
          V();
          var p = (d) => d[d.length - 1];
          l.exports = p;
        } }), go = H({ "src/language-js/parse/postprocess/visit-node.js"(h, l) {
          "use strict";
          V();
          function p(d, m) {
            if (Array.isArray(d)) {
              for (let A = 0; A < d.length; A++) d[A] = p(d[A], m);
              return d;
            }
            if (d && typeof d == "object" && typeof d.type == "string") {
              let A = Object.keys(d);
              for (let g = 0; g < A.length; g++) d[A[g]] = p(d[A[g]], m);
              return m(d) || d;
            }
            return d;
          }
          l.exports = p;
        } }), Ao = H({ "src/language-js/parse/postprocess/throw-syntax-error.js"(h, l) {
          "use strict";
          V();
          var p = nr();
          function d(m, A) {
            let { start: g, end: x } = m.loc;
            throw p(A, { start: { line: g.line, column: g.column + 1 }, end: { line: x.line, column: x.column + 1 } });
          }
          l.exports = d;
        } }), gf = H({ "src/language-js/parse/postprocess/typescript.js"(h, l) {
          "use strict";
          V();
          var p = go(), d = Ao();
          function m(x, T, k) {
            let D = x.decorators;
            if (!Array.isArray(D)) return;
            let E = T.decorators;
            (!Array.isArray(E) || E.length !== D.length || D.some((L) => {
              let R = k.get(L);
              return !R || !E.includes(R);
            })) && d(T, "Leading decorators must be attached to a class declaration");
          }
          function A(x, T) {
            x.kind !== 167 || x.modifiers && !x.modifiers.some((E) => E.kind === 126) || x.initializer && T.value === null && d(T, "Abstract property cannot have an initializer");
          }
          function g(x, T) {
            let { esTreeNodeToTSNodeMap: k, tsNodeToESTreeNodeMap: D } = T.tsParseResult;
            p(x, (E) => {
              let L = k.get(E);
              if (!L) return;
              let R = D.get(L);
              R === E && (m(L, R, D), A(L, R));
            });
          }
          l.exports = { throwErrorForInvalidNodes: g };
        } }), Af = H({ "src/language-js/parse/postprocess/index.js"(h, l) {
          "use strict";
          V();
          var { locStart: p, locEnd: d } = mo(), m = df(), A = yf(), g = xf(), x = go(), { throwErrorForInvalidNodes: T } = gf(), k = Ao();
          function D(F, W) {
            if (W.parser === "typescript" && /@|abstract/.test(W.originalText) && T(F, W), W.parser !== "typescript" && W.parser !== "flow" && W.parser !== "acorn" && W.parser !== "espree" && W.parser !== "meriyah") {
              let M = /* @__PURE__ */ new Set();
              F = x(F, (j) => {
                j.leadingComments && j.leadingComments.some(A) && M.add(p(j));
              }), F = x(F, (j) => {
                if (j.type === "ParenthesizedExpression") {
                  let { expression: u } = j;
                  if (u.type === "TypeCastExpression") return u.range = j.range, u;
                  let X = p(j);
                  if (!M.has(X)) return u.extra = Object.assign(Object.assign({}, u.extra), {}, { parenthesized: true }), u;
                }
              });
            }
            return F = x(F, (M) => {
              switch (M.type) {
                case "ChainExpression":
                  return E(M.expression);
                case "LogicalExpression": {
                  if (L(M)) return R(M);
                  break;
                }
                case "VariableDeclaration": {
                  let j = g(M.declarations);
                  j && j.init && Y(M, j);
                  break;
                }
                case "TSParenthesizedType":
                  return m(M.typeAnnotation) || M.typeAnnotation.type === "TSThisType" || (M.typeAnnotation.range = [p(M), d(M)]), M.typeAnnotation;
                case "TSTypeParameter":
                  if (typeof M.name == "string") {
                    let j = p(M);
                    M.name = { type: "Identifier", name: M.name, range: [j, j + M.name.length] };
                  }
                  break;
                case "ObjectExpression":
                  if (W.parser === "typescript") {
                    let j = M.properties.find((u) => u.type === "Property" && u.value.type === "TSEmptyBodyFunctionExpression");
                    j && k(j.value, "Unexpected token.");
                  }
                  break;
                case "SequenceExpression": {
                  let j = g(M.expressions);
                  M.range = [p(M), Math.min(d(j), d(M))];
                  break;
                }
                case "TopicReference":
                  W.__isUsingHackPipeline = true;
                  break;
                case "ExportAllDeclaration": {
                  let { exported: j } = M;
                  if (W.parser === "meriyah" && j && j.type === "Identifier") {
                    let u = W.originalText.slice(p(j), d(j));
                    (u.startsWith('"') || u.startsWith("'")) && (M.exported = Object.assign(Object.assign({}, M.exported), {}, { type: "Literal", value: M.exported.name, raw: u }));
                  }
                  break;
                }
              }
            }), F;
            function Y(M, j) {
              W.originalText[d(j)] !== ";" && (M.range = [p(M), d(j)]);
            }
          }
          function E(F) {
            switch (F.type) {
              case "CallExpression":
                F.type = "OptionalCallExpression", F.callee = E(F.callee);
                break;
              case "MemberExpression":
                F.type = "OptionalMemberExpression", F.object = E(F.object);
                break;
              case "TSNonNullExpression":
                F.expression = E(F.expression);
                break;
            }
            return F;
          }
          function L(F) {
            return F.type === "LogicalExpression" && F.right.type === "LogicalExpression" && F.operator === F.right.operator;
          }
          function R(F) {
            return L(F) ? R({ type: "LogicalExpression", operator: F.operator, left: R({ type: "LogicalExpression", operator: F.operator, left: F.left, right: F.right.left, range: [p(F.left), d(F.right.left)] }), right: F.right.right, range: [p(F), d(F)] }) : F;
          }
          l.exports = D;
        } }), Po = H({ "node_modules/@babel/parser/lib/index.js"(h) {
          "use strict";
          V(), Object.defineProperty(h, "__esModule", { value: true });
          function l(t, e) {
            if (t == null) return {};
            var s = {}, r = Object.keys(t), i, a;
            for (a = 0; a < r.length; a++) i = r[a], !(e.indexOf(i) >= 0) && (s[i] = t[i]);
            return s;
          }
          var p = class {
            constructor(t, e, s) {
              this.line = void 0, this.column = void 0, this.index = void 0, this.line = t, this.column = e, this.index = s;
            }
          }, d = class {
            constructor(t, e) {
              this.start = void 0, this.end = void 0, this.filename = void 0, this.identifierName = void 0, this.start = t, this.end = e;
            }
          };
          function m(t, e) {
            let { line: s, column: r, index: i } = t;
            return new p(s, r + e, i + e);
          }
          var A = Object.freeze({ SyntaxError: "BABEL_PARSER_SYNTAX_ERROR", SourceTypeModuleError: "BABEL_PARSER_SOURCETYPE_MODULE_REQUIRED" }), g = function(t) {
            let e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : t.length - 1;
            return { get() {
              return t.reduce((s, r) => s[r], this);
            }, set(s) {
              t.reduce((r, i, a) => a === e ? r[i] = s : r[i], this);
            } };
          }, x = (t, e, s) => Object.keys(s).map((r) => [r, s[r]]).filter((r) => {
            let [, i] = r;
            return !!i;
          }).map((r) => {
            let [i, a] = r;
            return [i, typeof a == "function" ? { value: a, enumerable: false } : typeof a.reflect == "string" ? Object.assign({}, a, g(a.reflect.split("."))) : a];
          }).reduce((r, i) => {
            let [a, n] = i;
            return Object.defineProperty(r, a, Object.assign({ configurable: true }, n));
          }, Object.assign(new t(), e)), T = (t) => ({ ImportMetaOutsideModule: t(`import.meta may appear only with 'sourceType: "module"'`, { code: A.SourceTypeModuleError }), ImportOutsideModule: t(`'import' and 'export' may appear only with 'sourceType: "module"'`, { code: A.SourceTypeModuleError }) }), k = { ArrayPattern: "array destructuring pattern", AssignmentExpression: "assignment expression", AssignmentPattern: "assignment expression", ArrowFunctionExpression: "arrow function expression", ConditionalExpression: "conditional expression", ForOfStatement: "for-of statement", ForInStatement: "for-in statement", ForStatement: "for-loop", FormalParameters: "function parameter list", Identifier: "identifier", ObjectPattern: "object destructuring pattern", ParenthesizedExpression: "parenthesized expression", RestElement: "rest element", UpdateExpression: { true: "prefix operation", false: "postfix operation" }, VariableDeclarator: "variable declaration", YieldExpression: "yield expression" }, D = (t) => {
            let { type: e, prefix: s } = t;
            return e === "UpdateExpression" ? k.UpdateExpression[String(s)] : k[e];
          }, E = (t) => ({ AccessorIsGenerator: t((e) => {
            let { kind: s } = e;
            return "A ".concat(s, "ter cannot be a generator.");
          }), ArgumentsInClass: t("'arguments' is only allowed in functions and class methods."), AsyncFunctionInSingleStatementContext: t("Async functions can only be declared at the top level or inside a block."), AwaitBindingIdentifier: t("Can not use 'await' as identifier inside an async function."), AwaitBindingIdentifierInStaticBlock: t("Can not use 'await' as identifier inside a static block."), AwaitExpressionFormalParameter: t("'await' is not allowed in async function parameters."), AwaitNotInAsyncContext: t("'await' is only allowed within async functions and at the top levels of modules."), AwaitNotInAsyncFunction: t("'await' is only allowed within async functions."), BadGetterArity: t("A 'get' accesor must not have any formal parameters."), BadSetterArity: t("A 'set' accesor must have exactly one formal parameter."), BadSetterRestParameter: t("A 'set' accesor function argument must not be a rest parameter."), ConstructorClassField: t("Classes may not have a field named 'constructor'."), ConstructorClassPrivateField: t("Classes may not have a private field named '#constructor'."), ConstructorIsAccessor: t("Class constructor may not be an accessor."), ConstructorIsAsync: t("Constructor can't be an async function."), ConstructorIsGenerator: t("Constructor can't be a generator."), DeclarationMissingInitializer: t((e) => {
            let { kind: s } = e;
            return "Missing initializer in ".concat(s, " declaration.");
          }), DecoratorBeforeExport: t("Decorators must be placed *before* the 'export' keyword. You can set the 'decoratorsBeforeExport' option to false to use the 'export @decorator class {}' syntax."), DecoratorConstructor: t("Decorators can't be used with a constructor. Did you mean '@dec class { ... }'?"), DecoratorExportClass: t("Using the export keyword between a decorator and a class is not allowed. Please use `export @dec class` instead."), DecoratorSemicolon: t("Decorators must not be followed by a semicolon."), DecoratorStaticBlock: t("Decorators can't be used with a static block."), DeletePrivateField: t("Deleting a private field is not allowed."), DestructureNamedImport: t("ES2015 named imports do not destructure. Use another statement for destructuring after the import."), DuplicateConstructor: t("Duplicate constructor in the same class."), DuplicateDefaultExport: t("Only one default export allowed per module."), DuplicateExport: t((e) => {
            let { exportName: s } = e;
            return "`".concat(s, "` has already been exported. Exported identifiers must be unique.");
          }), DuplicateProto: t("Redefinition of __proto__ property."), DuplicateRegExpFlags: t("Duplicate regular expression flag."), ElementAfterRest: t("Rest element must be last element."), EscapedCharNotAnIdentifier: t("Invalid Unicode escape."), ExportBindingIsString: t((e) => {
            let { localName: s, exportName: r } = e;
            return "A string literal cannot be used as an exported binding without `from`.\n- Did you mean `export { '".concat(s, "' as '").concat(r, "' } from 'some-module'`?");
          }), ExportDefaultFromAsIdentifier: t("'from' is not allowed as an identifier after 'export default'."), ForInOfLoopInitializer: t((e) => {
            let { type: s } = e;
            return "'".concat(s === "ForInStatement" ? "for-in" : "for-of", "' loop variable declaration may not have an initializer.");
          }), ForOfAsync: t("The left-hand side of a for-of loop may not be 'async'."), ForOfLet: t("The left-hand side of a for-of loop may not start with 'let'."), GeneratorInSingleStatementContext: t("Generators can only be declared at the top level or inside a block."), IllegalBreakContinue: t((e) => {
            let { type: s } = e;
            return "Unsyntactic ".concat(s === "BreakStatement" ? "break" : "continue", ".");
          }), IllegalLanguageModeDirective: t("Illegal 'use strict' directive in function with non-simple parameter list."), IllegalReturn: t("'return' outside of function."), ImportBindingIsString: t((e) => {
            let { importName: s } = e;
            return 'A string literal cannot be used as an imported binding.\n- Did you mean `import { "'.concat(s, '" as foo }`?');
          }), ImportCallArgumentTrailingComma: t("Trailing comma is disallowed inside import(...) arguments."), ImportCallArity: t((e) => {
            let { maxArgumentCount: s } = e;
            return "`import()` requires exactly ".concat(s === 1 ? "one argument" : "one or two arguments", ".");
          }), ImportCallNotNewExpression: t("Cannot use new with import(...)."), ImportCallSpreadArgument: t("`...` is not allowed in `import()`."), IncompatibleRegExpUVFlags: t("The 'u' and 'v' regular expression flags cannot be enabled at the same time."), InvalidBigIntLiteral: t("Invalid BigIntLiteral."), InvalidCodePoint: t("Code point out of bounds."), InvalidCoverInitializedName: t("Invalid shorthand property initializer."), InvalidDecimal: t("Invalid decimal."), InvalidDigit: t((e) => {
            let { radix: s } = e;
            return "Expected number in radix ".concat(s, ".");
          }), InvalidEscapeSequence: t("Bad character escape sequence."), InvalidEscapeSequenceTemplate: t("Invalid escape sequence in template."), InvalidEscapedReservedWord: t((e) => {
            let { reservedWord: s } = e;
            return "Escape sequence in keyword ".concat(s, ".");
          }), InvalidIdentifier: t((e) => {
            let { identifierName: s } = e;
            return "Invalid identifier ".concat(s, ".");
          }), InvalidLhs: t((e) => {
            let { ancestor: s } = e;
            return "Invalid left-hand side in ".concat(D(s), ".");
          }), InvalidLhsBinding: t((e) => {
            let { ancestor: s } = e;
            return "Binding invalid left-hand side in ".concat(D(s), ".");
          }), InvalidNumber: t("Invalid number."), InvalidOrMissingExponent: t("Floating-point numbers require a valid exponent after the 'e'."), InvalidOrUnexpectedToken: t((e) => {
            let { unexpected: s } = e;
            return "Unexpected character '".concat(s, "'.");
          }), InvalidParenthesizedAssignment: t("Invalid parenthesized assignment pattern."), InvalidPrivateFieldResolution: t((e) => {
            let { identifierName: s } = e;
            return "Private name #".concat(s, " is not defined.");
          }), InvalidPropertyBindingPattern: t("Binding member expression."), InvalidRecordProperty: t("Only properties and spread elements are allowed in record definitions."), InvalidRestAssignmentPattern: t("Invalid rest operator's argument."), LabelRedeclaration: t((e) => {
            let { labelName: s } = e;
            return "Label '".concat(s, "' is already declared.");
          }), LetInLexicalBinding: t("'let' is not allowed to be used as a name in 'let' or 'const' declarations."), LineTerminatorBeforeArrow: t("No line break is allowed before '=>'."), MalformedRegExpFlags: t("Invalid regular expression flag."), MissingClassName: t("A class name is required."), MissingEqInAssignment: t("Only '=' operator can be used for specifying default value."), MissingSemicolon: t("Missing semicolon."), MissingPlugin: t((e) => {
            let { missingPlugin: s } = e;
            return "This experimental syntax requires enabling the parser plugin: ".concat(s.map((r) => JSON.stringify(r)).join(", "), ".");
          }), MissingOneOfPlugins: t((e) => {
            let { missingPlugin: s } = e;
            return "This experimental syntax requires enabling one of the following parser plugin(s): ".concat(s.map((r) => JSON.stringify(r)).join(", "), ".");
          }), MissingUnicodeEscape: t("Expecting Unicode escape sequence \\uXXXX."), MixingCoalesceWithLogical: t("Nullish coalescing operator(??) requires parens when mixing with logical operators."), ModuleAttributeDifferentFromType: t("The only accepted module attribute is `type`."), ModuleAttributeInvalidValue: t("Only string literals are allowed as module attribute values."), ModuleAttributesWithDuplicateKeys: t((e) => {
            let { key: s } = e;
            return 'Duplicate key "'.concat(s, '" is not allowed in module attributes.');
          }), ModuleExportNameHasLoneSurrogate: t((e) => {
            let { surrogateCharCode: s } = e;
            return "An export name cannot include a lone surrogate, found '\\u".concat(s.toString(16), "'.");
          }), ModuleExportUndefined: t((e) => {
            let { localName: s } = e;
            return "Export '".concat(s, "' is not defined.");
          }), MultipleDefaultsInSwitch: t("Multiple default clauses."), NewlineAfterThrow: t("Illegal newline after throw."), NoCatchOrFinally: t("Missing catch or finally clause."), NumberIdentifier: t("Identifier directly after number."), NumericSeparatorInEscapeSequence: t("Numeric separators are not allowed inside unicode escape sequences or hex escape sequences."), ObsoleteAwaitStar: t("'await*' has been removed from the async functions proposal. Use Promise.all() instead."), OptionalChainingNoNew: t("Constructors in/after an Optional Chain are not allowed."), OptionalChainingNoTemplate: t("Tagged Template Literals are not allowed in optionalChain."), OverrideOnConstructor: t("'override' modifier cannot appear on a constructor declaration."), ParamDupe: t("Argument name clash."), PatternHasAccessor: t("Object pattern can't contain getter or setter."), PatternHasMethod: t("Object pattern can't contain methods."), PrivateInExpectedIn: t((e) => {
            let { identifierName: s } = e;
            return "Private names are only allowed in property accesses (`obj.#".concat(s, "`) or in `in` expressions (`#").concat(s, " in obj`).");
          }), PrivateNameRedeclaration: t((e) => {
            let { identifierName: s } = e;
            return "Duplicate private name #".concat(s, ".");
          }), RecordExpressionBarIncorrectEndSyntaxType: t("Record expressions ending with '|}' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'."), RecordExpressionBarIncorrectStartSyntaxType: t("Record expressions starting with '{|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'."), RecordExpressionHashIncorrectStartSyntaxType: t("Record expressions starting with '#{' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'."), RecordNoProto: t("'__proto__' is not allowed in Record expressions."), RestTrailingComma: t("Unexpected trailing comma after rest element."), SloppyFunction: t("In non-strict mode code, functions can only be declared at top level, inside a block, or as the body of an if statement."), StaticPrototype: t("Classes may not have static property named prototype."), SuperNotAllowed: t("`super()` is only valid inside a class constructor of a subclass. Maybe a typo in the method name ('constructor') or not extending another class?"), SuperPrivateField: t("Private fields can't be accessed on super."), TrailingDecorator: t("Decorators must be attached to a class element."), TupleExpressionBarIncorrectEndSyntaxType: t("Tuple expressions ending with '|]' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'."), TupleExpressionBarIncorrectStartSyntaxType: t("Tuple expressions starting with '[|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'."), TupleExpressionHashIncorrectStartSyntaxType: t("Tuple expressions starting with '#[' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'."), UnexpectedArgumentPlaceholder: t("Unexpected argument placeholder."), UnexpectedAwaitAfterPipelineBody: t('Unexpected "await" after pipeline body; await must have parentheses in minimal proposal.'), UnexpectedDigitAfterHash: t("Unexpected digit after hash token."), UnexpectedImportExport: t("'import' and 'export' may only appear at the top level."), UnexpectedKeyword: t((e) => {
            let { keyword: s } = e;
            return "Unexpected keyword '".concat(s, "'.");
          }), UnexpectedLeadingDecorator: t("Leading decorators must be attached to a class declaration."), UnexpectedLexicalDeclaration: t("Lexical declaration cannot appear in a single-statement context."), UnexpectedNewTarget: t("`new.target` can only be used in functions or class properties."), UnexpectedNumericSeparator: t("A numeric separator is only allowed between two digits."), UnexpectedPrivateField: t("Unexpected private name."), UnexpectedReservedWord: t((e) => {
            let { reservedWord: s } = e;
            return "Unexpected reserved word '".concat(s, "'.");
          }), UnexpectedSuper: t("'super' is only allowed in object methods and classes."), UnexpectedToken: t((e) => {
            let { expected: s, unexpected: r } = e;
            return "Unexpected token".concat(r ? " '".concat(r, "'.") : "").concat(s ? ', expected "'.concat(s, '"') : "");
          }), UnexpectedTokenUnaryExponentiation: t("Illegal expression. Wrap left hand side or entire exponentiation in parentheses."), UnsupportedBind: t("Binding should be performed on object property."), UnsupportedDecoratorExport: t("A decorated export must export a class declaration."), UnsupportedDefaultExport: t("Only expressions, functions or classes are allowed as the `default` export."), UnsupportedImport: t("`import` can only be used in `import()` or `import.meta`."), UnsupportedMetaProperty: t((e) => {
            let { target: s, onlyValidPropertyName: r } = e;
            return "The only valid meta property for ".concat(s, " is ").concat(s, ".").concat(r, ".");
          }), UnsupportedParameterDecorator: t("Decorators cannot be used to decorate parameters."), UnsupportedPropertyDecorator: t("Decorators cannot be used to decorate object literal properties."), UnsupportedSuper: t("'super' can only be used with function calls (i.e. super()) or in property accesses (i.e. super.prop or super[prop])."), UnterminatedComment: t("Unterminated comment."), UnterminatedRegExp: t("Unterminated regular expression."), UnterminatedString: t("Unterminated string constant."), UnterminatedTemplate: t("Unterminated template."), VarRedeclaration: t((e) => {
            let { identifierName: s } = e;
            return "Identifier '".concat(s, "' has already been declared.");
          }), YieldBindingIdentifier: t("Can not use 'yield' as identifier inside a generator."), YieldInParameter: t("Yield expression is not allowed in formal parameters."), ZeroDigitNumericSeparator: t("Numeric separator can not be used after leading 0.") }), L = (t) => ({ StrictDelete: t("Deleting local variable in strict mode."), StrictEvalArguments: t((e) => {
            let { referenceName: s } = e;
            return "Assigning to '".concat(s, "' in strict mode.");
          }), StrictEvalArgumentsBinding: t((e) => {
            let { bindingName: s } = e;
            return "Binding '".concat(s, "' in strict mode.");
          }), StrictFunction: t("In strict mode code, functions can only be declared at top level or inside a block."), StrictNumericEscape: t("The only valid numeric escape in strict mode is '\\0'."), StrictOctalLiteral: t("Legacy octal literals are not allowed in strict mode."), StrictWith: t("'with' in strict mode.") }), R = /* @__PURE__ */ new Set(["ArrowFunctionExpression", "AssignmentExpression", "ConditionalExpression", "YieldExpression"]), F = (t) => ({ PipeBodyIsTighter: t("Unexpected yield after pipeline body; any yield expression acting as Hack-style pipe body must be parenthesized due to its loose operator precedence."), PipeTopicRequiresHackPipes: t('Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.'), PipeTopicUnbound: t("Topic reference is unbound; it must be inside a pipe body."), PipeTopicUnconfiguredToken: t((e) => {
            let { token: s } = e;
            return "Invalid topic token ".concat(s, ". In order to use ").concat(s, ' as a topic reference, the pipelineOperator plugin must be configured with { "proposal": "hack", "topicToken": "').concat(s, '" }.');
          }), PipeTopicUnused: t("Hack-style pipe body does not contain a topic reference; Hack-style pipes must use topic at least once."), PipeUnparenthesizedBody: t((e) => {
            let { type: s } = e;
            return "Hack-style pipe body cannot be an unparenthesized ".concat(D({ type: s }), "; please wrap it in parentheses.");
          }), PipelineBodyNoArrow: t('Unexpected arrow "=>" after pipeline body; arrow function in pipeline body must be parenthesized.'), PipelineBodySequenceExpression: t("Pipeline body may not be a comma-separated sequence expression."), PipelineHeadSequenceExpression: t("Pipeline head should not be a comma-separated sequence expression."), PipelineTopicUnused: t("Pipeline is in topic style but does not use topic reference."), PrimaryTopicNotAllowed: t("Topic reference was used in a lexical context without topic binding."), PrimaryTopicRequiresSmartPipeline: t('Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.') }), W = ["toMessage"];
          function Y(t) {
            let { toMessage: e } = t, s = l(t, W);
            return function r(i) {
              let { loc: a, details: n } = i;
              return x(SyntaxError, Object.assign({}, s, { loc: a }), { clone() {
                let o = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, c = o.loc || {};
                return r({ loc: new p("line" in c ? c.line : this.loc.line, "column" in c ? c.column : this.loc.column, "index" in c ? c.index : this.loc.index), details: Object.assign({}, this.details, o.details) });
              }, details: { value: n, enumerable: false }, message: { get() {
                return "".concat(e(this.details), " (").concat(this.loc.line, ":").concat(this.loc.column, ")");
              }, set(o) {
                Object.defineProperty(this, "message", { value: o });
              } }, pos: { reflect: "loc.index", enumerable: true }, missingPlugin: "missingPlugin" in n && { reflect: "details.missingPlugin", enumerable: true } });
            };
          }
          function M(t, e) {
            return Object.assign({ toMessage: typeof t == "string" ? () => t : t }, e);
          }
          function j(t, e) {
            if (Array.isArray(t)) return (i) => j(i, t[0]);
            let s = t(M), r = {};
            for (let i of Object.keys(s)) r[i] = Y(Object.assign({ code: A.SyntaxError, reasonCode: i }, e ? { syntaxPlugin: e } : {}, s[i]));
            return r;
          }
          var u = Object.assign({}, j(T), j(E), j(L), j(_n || (_n = rt(["pipelineOperator"])))(F)), { defineProperty: X } = Object, se = (t, e) => X(t, e, { enumerable: false, value: t[e] });
          function J(t) {
            return se(t.loc.start, "index"), se(t.loc.end, "index"), t;
          }
          var Oe = (t) => class extends t {
            parse() {
              let e = J(super.parse());
              return this.options.tokens && (e.tokens = e.tokens.map(J)), e;
            }
            parseRegExpLiteral(e) {
              let { pattern: s, flags: r } = e, i = null;
              try {
                i = new RegExp(s, r);
              } catch {
              }
              let a = this.estreeParseLiteral(i);
              return a.regex = { pattern: s, flags: r }, a;
            }
            parseBigIntLiteral(e) {
              let s;
              try {
                s = BigInt(e);
              } catch {
                s = null;
              }
              let r = this.estreeParseLiteral(s);
              return r.bigint = String(r.value || e), r;
            }
            parseDecimalLiteral(e) {
              let r = this.estreeParseLiteral(null);
              return r.decimal = String(r.value || e), r;
            }
            estreeParseLiteral(e) {
              return this.parseLiteral(e, "Literal");
            }
            parseStringLiteral(e) {
              return this.estreeParseLiteral(e);
            }
            parseNumericLiteral(e) {
              return this.estreeParseLiteral(e);
            }
            parseNullLiteral() {
              return this.estreeParseLiteral(null);
            }
            parseBooleanLiteral(e) {
              return this.estreeParseLiteral(e);
            }
            directiveToStmt(e) {
              let s = e.value, r = this.startNodeAt(e.start, e.loc.start), i = this.startNodeAt(s.start, s.loc.start);
              return i.value = s.extra.expressionValue, i.raw = s.extra.raw, r.expression = this.finishNodeAt(i, "Literal", s.loc.end), r.directive = s.extra.raw.slice(1, -1), this.finishNodeAt(r, "ExpressionStatement", e.loc.end);
            }
            initFunction(e, s) {
              super.initFunction(e, s), e.expression = false;
            }
            checkDeclaration(e) {
              e != null && this.isObjectProperty(e) ? this.checkDeclaration(e.value) : super.checkDeclaration(e);
            }
            getObjectOrClassMethodParams(e) {
              return e.value.params;
            }
            isValidDirective(e) {
              var s;
              return e.type === "ExpressionStatement" && e.expression.type === "Literal" && typeof e.expression.value == "string" && !((s = e.expression.extra) != null && s.parenthesized);
            }
            parseBlockBody(e) {
              for (var s = arguments.length, r = new Array(s > 1 ? s - 1 : 0), i = 1; i < s; i++) r[i - 1] = arguments[i];
              super.parseBlockBody(e, ...r);
              let a = e.directives.map((n) => this.directiveToStmt(n));
              e.body = a.concat(e.body), delete e.directives;
            }
            pushClassMethod(e, s, r, i, a, n) {
              this.parseMethod(s, r, i, a, n, "ClassMethod", true), s.typeParameters && (s.value.typeParameters = s.typeParameters, delete s.typeParameters), e.body.push(s);
            }
            parsePrivateName() {
              let e = super.parsePrivateName();
              return this.getPluginOption("estree", "classFeatures") ? this.convertPrivateNameToPrivateIdentifier(e) : e;
            }
            convertPrivateNameToPrivateIdentifier(e) {
              let s = super.getPrivateNameSV(e);
              return e = e, delete e.id, e.name = s, e.type = "PrivateIdentifier", e;
            }
            isPrivateName(e) {
              return this.getPluginOption("estree", "classFeatures") ? e.type === "PrivateIdentifier" : super.isPrivateName(e);
            }
            getPrivateNameSV(e) {
              return this.getPluginOption("estree", "classFeatures") ? e.name : super.getPrivateNameSV(e);
            }
            parseLiteral(e, s) {
              let r = super.parseLiteral(e, s);
              return r.raw = r.extra.raw, delete r.extra, r;
            }
            parseFunctionBody(e, s) {
              let r = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
              super.parseFunctionBody(e, s, r), e.expression = e.body.type !== "BlockStatement";
            }
            parseMethod(e, s, r, i, a, n) {
              let o = arguments.length > 6 && arguments[6] !== void 0 ? arguments[6] : false, c = this.startNode();
              return c.kind = e.kind, c = super.parseMethod(c, s, r, i, a, n, o), c.type = "FunctionExpression", delete c.kind, e.value = c, n === "ClassPrivateMethod" && (e.computed = false), n = "MethodDefinition", this.finishNode(e, n);
            }
            parseClassProperty() {
              let e = super.parseClassProperty(...arguments);
              return this.getPluginOption("estree", "classFeatures") && (e.type = "PropertyDefinition"), e;
            }
            parseClassPrivateProperty() {
              let e = super.parseClassPrivateProperty(...arguments);
              return this.getPluginOption("estree", "classFeatures") && (e.type = "PropertyDefinition", e.computed = false), e;
            }
            parseObjectMethod(e, s, r, i, a) {
              let n = super.parseObjectMethod(e, s, r, i, a);
              return n && (n.type = "Property", n.kind === "method" && (n.kind = "init"), n.shorthand = false), n;
            }
            parseObjectProperty(e, s, r, i, a) {
              let n = super.parseObjectProperty(e, s, r, i, a);
              return n && (n.kind = "init", n.type = "Property"), n;
            }
            isValidLVal(e) {
              for (var s = arguments.length, r = new Array(s > 1 ? s - 1 : 0), i = 1; i < s; i++) r[i - 1] = arguments[i];
              return e === "Property" ? "value" : super.isValidLVal(e, ...r);
            }
            isAssignable(e, s) {
              return e != null && this.isObjectProperty(e) ? this.isAssignable(e.value, s) : super.isAssignable(e, s);
            }
            toAssignable(e) {
              let s = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              if (e != null && this.isObjectProperty(e)) {
                let { key: r, value: i } = e;
                this.isPrivateName(r) && this.classScope.usePrivateName(this.getPrivateNameSV(r), r.loc.start), this.toAssignable(i, s);
              } else super.toAssignable(e, s);
            }
            toAssignableObjectExpressionProp(e) {
              e.kind === "get" || e.kind === "set" ? this.raise(u.PatternHasAccessor, { at: e.key }) : e.method ? this.raise(u.PatternHasMethod, { at: e.key }) : super.toAssignableObjectExpressionProp(...arguments);
            }
            finishCallExpression(e, s) {
              if (super.finishCallExpression(e, s), e.callee.type === "Import") {
                if (e.type = "ImportExpression", e.source = e.arguments[0], this.hasPlugin("importAssertions")) {
                  var r;
                  e.attributes = (r = e.arguments[1]) != null ? r : null;
                }
                delete e.arguments, delete e.callee;
              }
              return e;
            }
            toReferencedArguments(e) {
              e.type !== "ImportExpression" && super.toReferencedArguments(e);
            }
            parseExport(e) {
              switch (super.parseExport(e), e.type) {
                case "ExportAllDeclaration":
                  e.exported = null;
                  break;
                case "ExportNamedDeclaration":
                  e.specifiers.length === 1 && e.specifiers[0].type === "ExportNamespaceSpecifier" && (e.type = "ExportAllDeclaration", e.exported = e.specifiers[0].exported, delete e.specifiers);
                  break;
              }
              return e;
            }
            parseSubscript(e, s, r, i, a) {
              let n = super.parseSubscript(e, s, r, i, a);
              if (a.optionalChainMember) {
                if ((n.type === "OptionalMemberExpression" || n.type === "OptionalCallExpression") && (n.type = n.type.substring(8)), a.stop) {
                  let o = this.startNodeAtNode(n);
                  return o.expression = n, this.finishNode(o, "ChainExpression");
                }
              } else (n.type === "MemberExpression" || n.type === "CallExpression") && (n.optional = false);
              return n;
            }
            hasPropertyAsPrivateName(e) {
              return e.type === "ChainExpression" && (e = e.expression), super.hasPropertyAsPrivateName(e);
            }
            isOptionalChain(e) {
              return e.type === "ChainExpression";
            }
            isObjectProperty(e) {
              return e.type === "Property" && e.kind === "init" && !e.method;
            }
            isObjectMethod(e) {
              return e.method || e.kind === "get" || e.kind === "set";
            }
            finishNodeAt(e, s, r) {
              return J(super.finishNodeAt(e, s, r));
            }
            resetEndLocation(e) {
              let s = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.state.lastTokEndLoc;
              super.resetEndLocation(e, s), J(e);
            }
          }, $ = class {
            constructor(t, e) {
              this.token = void 0, this.preserveSpace = void 0, this.token = t, this.preserveSpace = !!e;
            }
          }, z2 = { brace: new $("{"), j_oTag: new $("<tag"), j_cTag: new $("</tag"), j_expr: new $("<tag>...</tag>", true) };
          z2.template = new $("`", true);
          var O = true, C = true, Ve = true, Z = true, he = true, Co = true, or = class {
            constructor(t) {
              let e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
              this.label = void 0, this.keyword = void 0, this.beforeExpr = void 0, this.startsExpr = void 0, this.rightAssociative = void 0, this.isLoop = void 0, this.isAssign = void 0, this.prefix = void 0, this.postfix = void 0, this.binop = void 0, this.label = t, this.keyword = e.keyword, this.beforeExpr = !!e.beforeExpr, this.startsExpr = !!e.startsExpr, this.rightAssociative = !!e.rightAssociative, this.isLoop = !!e.isLoop, this.isAssign = !!e.isAssign, this.prefix = !!e.prefix, this.postfix = !!e.postfix, this.binop = e.binop != null ? e.binop : null, this.updateContext = null;
            }
          }, qt = /* @__PURE__ */ new Map();
          function q(t) {
            let e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
            e.keyword = t;
            let s = w(t, e);
            return qt.set(t, s), s;
          }
          function te(t, e) {
            return w(t, { beforeExpr: O, binop: e });
          }
          var He = -1, ce = [], Ut = [], it = [], _t = [], zt = [], Kt = [];
          function w(t) {
            let e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
            var s, r, i, a;
            return ++He, Ut.push(t), it.push((s = e.binop) != null ? s : -1), _t.push((r = e.beforeExpr) != null ? r : false), zt.push((i = e.startsExpr) != null ? i : false), Kt.push((a = e.prefix) != null ? a : false), ce.push(new or(t, e)), He;
          }
          function U(t) {
            let e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
            var s, r, i, a;
            return ++He, qt.set(t, He), Ut.push(t), it.push((s = e.binop) != null ? s : -1), _t.push((r = e.beforeExpr) != null ? r : false), zt.push((i = e.startsExpr) != null ? i : false), Kt.push((a = e.prefix) != null ? a : false), ce.push(new or("name", e)), He;
          }
          var bo = { bracketL: w("[", { beforeExpr: O, startsExpr: C }), bracketHashL: w("#[", { beforeExpr: O, startsExpr: C }), bracketBarL: w("[|", { beforeExpr: O, startsExpr: C }), bracketR: w("]"), bracketBarR: w("|]"), braceL: w("{", { beforeExpr: O, startsExpr: C }), braceBarL: w("{|", { beforeExpr: O, startsExpr: C }), braceHashL: w("#{", { beforeExpr: O, startsExpr: C }), braceR: w("}"), braceBarR: w("|}"), parenL: w("(", { beforeExpr: O, startsExpr: C }), parenR: w(")"), comma: w(",", { beforeExpr: O }), semi: w(";", { beforeExpr: O }), colon: w(":", { beforeExpr: O }), doubleColon: w("::", { beforeExpr: O }), dot: w("."), question: w("?", { beforeExpr: O }), questionDot: w("?."), arrow: w("=>", { beforeExpr: O }), template: w("template"), ellipsis: w("...", { beforeExpr: O }), backQuote: w("`", { startsExpr: C }), dollarBraceL: w("${", { beforeExpr: O, startsExpr: C }), templateTail: w("...`", { startsExpr: C }), templateNonTail: w("...${", { beforeExpr: O, startsExpr: C }), at: w("@"), hash: w("#", { startsExpr: C }), interpreterDirective: w("#!..."), eq: w("=", { beforeExpr: O, isAssign: Z }), assign: w("_=", { beforeExpr: O, isAssign: Z }), slashAssign: w("_=", { beforeExpr: O, isAssign: Z }), xorAssign: w("_=", { beforeExpr: O, isAssign: Z }), moduloAssign: w("_=", { beforeExpr: O, isAssign: Z }), incDec: w("++/--", { prefix: he, postfix: Co, startsExpr: C }), bang: w("!", { beforeExpr: O, prefix: he, startsExpr: C }), tilde: w("~", { beforeExpr: O, prefix: he, startsExpr: C }), doubleCaret: w("^^", { startsExpr: C }), doubleAt: w("@@", { startsExpr: C }), pipeline: te("|>", 0), nullishCoalescing: te("??", 1), logicalOR: te("||", 1), logicalAND: te("&&", 2), bitwiseOR: te("|", 3), bitwiseXOR: te("^", 4), bitwiseAND: te("&", 5), equality: te("==/!=/===/!==", 6), lt: te("</>/<=/>=", 7), gt: te("</>/<=/>=", 7), relational: te("</>/<=/>=", 7), bitShift: te("<</>>/>>>", 8), bitShiftL: te("<</>>/>>>", 8), bitShiftR: te("<</>>/>>>", 8), plusMin: w("+/-", { beforeExpr: O, binop: 9, prefix: he, startsExpr: C }), modulo: w("%", { binop: 10, startsExpr: C }), star: w("*", { binop: 10 }), slash: te("/", 10), exponent: w("**", { beforeExpr: O, binop: 11, rightAssociative: true }), _in: q("in", { beforeExpr: O, binop: 7 }), _instanceof: q("instanceof", { beforeExpr: O, binop: 7 }), _break: q("break"), _case: q("case", { beforeExpr: O }), _catch: q("catch"), _continue: q("continue"), _debugger: q("debugger"), _default: q("default", { beforeExpr: O }), _else: q("else", { beforeExpr: O }), _finally: q("finally"), _function: q("function", { startsExpr: C }), _if: q("if"), _return: q("return", { beforeExpr: O }), _switch: q("switch"), _throw: q("throw", { beforeExpr: O, prefix: he, startsExpr: C }), _try: q("try"), _var: q("var"), _const: q("const"), _with: q("with"), _new: q("new", { beforeExpr: O, startsExpr: C }), _this: q("this", { startsExpr: C }), _super: q("super", { startsExpr: C }), _class: q("class", { startsExpr: C }), _extends: q("extends", { beforeExpr: O }), _export: q("export"), _import: q("import", { startsExpr: C }), _null: q("null", { startsExpr: C }), _true: q("true", { startsExpr: C }), _false: q("false", { startsExpr: C }), _typeof: q("typeof", { beforeExpr: O, prefix: he, startsExpr: C }), _void: q("void", { beforeExpr: O, prefix: he, startsExpr: C }), _delete: q("delete", { beforeExpr: O, prefix: he, startsExpr: C }), _do: q("do", { isLoop: Ve, beforeExpr: O }), _for: q("for", { isLoop: Ve }), _while: q("while", { isLoop: Ve }), _as: U("as", { startsExpr: C }), _assert: U("assert", { startsExpr: C }), _async: U("async", { startsExpr: C }), _await: U("await", { startsExpr: C }), _from: U("from", { startsExpr: C }), _get: U("get", { startsExpr: C }), _let: U("let", { startsExpr: C }), _meta: U("meta", { startsExpr: C }), _of: U("of", { startsExpr: C }), _sent: U("sent", { startsExpr: C }), _set: U("set", { startsExpr: C }), _static: U("static", { startsExpr: C }), _yield: U("yield", { startsExpr: C }), _asserts: U("asserts", { startsExpr: C }), _checks: U("checks", { startsExpr: C }), _exports: U("exports", { startsExpr: C }), _global: U("global", { startsExpr: C }), _implements: U("implements", { startsExpr: C }), _intrinsic: U("intrinsic", { startsExpr: C }), _infer: U("infer", { startsExpr: C }), _is: U("is", { startsExpr: C }), _mixins: U("mixins", { startsExpr: C }), _proto: U("proto", { startsExpr: C }), _require: U("require", { startsExpr: C }), _keyof: U("keyof", { startsExpr: C }), _readonly: U("readonly", { startsExpr: C }), _unique: U("unique", { startsExpr: C }), _abstract: U("abstract", { startsExpr: C }), _declare: U("declare", { startsExpr: C }), _enum: U("enum", { startsExpr: C }), _module: U("module", { startsExpr: C }), _namespace: U("namespace", { startsExpr: C }), _interface: U("interface", { startsExpr: C }), _type: U("type", { startsExpr: C }), _opaque: U("opaque", { startsExpr: C }), name: w("name", { startsExpr: C }), string: w("string", { startsExpr: C }), num: w("num", { startsExpr: C }), bigint: w("bigint", { startsExpr: C }), decimal: w("decimal", { startsExpr: C }), regexp: w("regexp", { startsExpr: C }), privateName: w("#name", { startsExpr: C }), eof: w("eof"), jsxName: w("jsxName"), jsxText: w("jsxText", { beforeExpr: true }), jsxTagStart: w("jsxTagStart", { startsExpr: true }), jsxTagEnd: w("jsxTagEnd"), placeholder: w("%%", { startsExpr: true }) };
          function K(t) {
            return t >= 93 && t <= 128;
          }
          function vo(t) {
            return t <= 92;
          }
          function pe(t) {
            return t >= 58 && t <= 128;
          }
          function hr(t) {
            return t >= 58 && t <= 132;
          }
          function So(t) {
            return _t[t];
          }
          function Vt(t) {
            return zt[t];
          }
          function wo(t) {
            return t >= 29 && t <= 33;
          }
          function lr(t) {
            return t >= 125 && t <= 127;
          }
          function No(t) {
            return t >= 90 && t <= 92;
          }
          function Ht(t) {
            return t >= 58 && t <= 92;
          }
          function Io(t) {
            return t >= 39 && t <= 59;
          }
          function ko(t) {
            return t === 34;
          }
          function Do(t) {
            return Kt[t];
          }
          function Fo(t) {
            return t >= 117 && t <= 119;
          }
          function Lo(t) {
            return t >= 120 && t <= 126;
          }
          function Pe(t) {
            return Ut[t];
          }
          function at(t) {
            return it[t];
          }
          function Oo(t) {
            return it[t] !== -1;
          }
          function Bo(t) {
            return t === 57;
          }
          function nt(t) {
            return t >= 24 && t <= 25;
          }
          function fe(t) {
            return ce[t];
          }
          ce[8].updateContext = (t) => {
            t.pop();
          }, ce[5].updateContext = ce[7].updateContext = ce[23].updateContext = (t) => {
            t.push(z2.brace);
          }, ce[22].updateContext = (t) => {
            t[t.length - 1] === z2.template ? t.pop() : t.push(z2.template);
          }, ce[138].updateContext = (t) => {
            t.push(z2.j_expr, z2.j_oTag);
          };
          var Wt = "\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BF\u31F0-\u31FF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC", ur = "\u200C\u200D\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u0898-\u089F\u08CA-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B55-\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3C\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D81-\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EBC\u0EC8-\u0ECD\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u180F-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1ABF-\u1ACE\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DFF\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA82C\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F", Mo = new RegExp("[" + Wt + "]"), Ro = new RegExp("[" + Wt + ur + "]");
          Wt = ur = null;
          var cr = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 85, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 190, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1070, 4050, 582, 8634, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 46, 2, 18, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 482, 44, 11, 6, 17, 0, 322, 29, 19, 43, 1269, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4152, 8, 221, 3, 5761, 15, 7472, 3104, 541, 1507, 4938], jo = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 370, 1, 154, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 161, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 19306, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 262, 6, 10, 9, 357, 0, 62, 13, 1495, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];
          function Gt(t, e) {
            let s = 65536;
            for (let r = 0, i = e.length; r < i; r += 2) {
              if (s += e[r], s > t) return false;
              if (s += e[r + 1], s >= t) return true;
            }
            return false;
          }
          function de(t) {
            return t < 65 ? t === 36 : t <= 90 ? true : t < 97 ? t === 95 : t <= 122 ? true : t <= 65535 ? t >= 170 && Mo.test(String.fromCharCode(t)) : Gt(t, cr);
          }
          function Be(t) {
            return t < 48 ? t === 36 : t < 58 ? true : t < 65 ? false : t <= 90 ? true : t < 97 ? t === 95 : t <= 122 ? true : t <= 65535 ? t >= 170 && Ro.test(String.fromCharCode(t)) : Gt(t, cr) || Gt(t, jo);
          }
          var Xt = { keyword: ["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete"], strict: ["implements", "interface", "let", "package", "private", "protected", "public", "static", "yield"], strictBind: ["eval", "arguments"] }, qo = new Set(Xt.keyword), Uo = new Set(Xt.strict), _o = new Set(Xt.strictBind);
          function pr(t, e) {
            return e && t === "await" || t === "enum";
          }
          function fr(t, e) {
            return pr(t, e) || Uo.has(t);
          }
          function dr(t) {
            return _o.has(t);
          }
          function mr(t, e) {
            return fr(t, e) || dr(t);
          }
          function zo(t) {
            return qo.has(t);
          }
          function Ko(t, e, s) {
            return t === 64 && e === 64 && de(s);
          }
          var Vo = /* @__PURE__ */ new Set(["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete", "implements", "interface", "let", "package", "private", "protected", "public", "static", "yield", "eval", "arguments", "enum", "await"]);
          function Ho(t) {
            return Vo.has(t);
          }
          var Me = 0, We = 1, me = 2, Jt = 4, yr = 8, ot = 16, xr = 32, Se = 64, Yt = 128, ht = 256, lt = We | me | ht, ye = 1, Re = 2, gr = 4, Te = 8, ut = 16, Ar = 64, ct = 128, $t = 256, Qt = 512, Zt = 1024, es = 2048, Pr = ye | Re | Te | ct, xe = ye | 0 | Te | 0, pt = ye | 0 | gr | 0, Tr = ye | 0 | ut | 0, Wo = 0 | Re | 0 | ct, Go = 0 | Re | 0 | 0, Er = ye | Re | Te | $t, Cr = 0 | Zt, we = 0 | Ar, Xo = ye | 0 | 0 | Ar, Jo = Er | Qt, Yo = 0 | Zt, $o = es, ft = 4, ts = 2, ss = 1, rs = ts | ss, Qo = ts | ft, Zo = ss | ft, eh = ts, th = ss, is = 0, sh = class {
            constructor() {
              this.sawUnambiguousESM = false, this.ambiguousScriptDifferentAst = false;
            }
            hasPlugin(t) {
              if (typeof t == "string") return this.plugins.has(t);
              {
                let [e, s] = t;
                if (!this.hasPlugin(e)) return false;
                let r = this.plugins.get(e);
                for (let i of Object.keys(s)) if ((r == null ? void 0 : r[i]) !== s[i]) return false;
                return true;
              }
            }
            getPluginOption(t, e) {
              var s;
              return (s = this.plugins.get(t)) == null ? void 0 : s[e];
            }
          };
          function br(t, e) {
            t.trailingComments === void 0 ? t.trailingComments = e : t.trailingComments.unshift(...e);
          }
          function rh(t, e) {
            t.leadingComments === void 0 ? t.leadingComments = e : t.leadingComments.unshift(...e);
          }
          function Ge(t, e) {
            t.innerComments === void 0 ? t.innerComments = e : t.innerComments.unshift(...e);
          }
          function Xe(t, e, s) {
            let r = null, i = e.length;
            for (; r === null && i > 0; ) r = e[--i];
            r === null || r.start > s.start ? Ge(t, s.comments) : br(r, s.comments);
          }
          var ih = class extends sh {
            addComment(t) {
              this.filename && (t.loc.filename = this.filename), this.state.comments.push(t);
            }
            processComment(t) {
              let { commentStack: e } = this.state, s = e.length;
              if (s === 0) return;
              let r = s - 1, i = e[r];
              i.start === t.end && (i.leadingNode = t, r--);
              let { start: a } = t;
              for (; r >= 0; r--) {
                let n = e[r], o = n.end;
                if (o > a) n.containingNode = t, this.finalizeComment(n), e.splice(r, 1);
                else {
                  o === a && (n.trailingNode = t);
                  break;
                }
              }
            }
            finalizeComment(t) {
              let { comments: e } = t;
              if (t.leadingNode !== null || t.trailingNode !== null) t.leadingNode !== null && br(t.leadingNode, e), t.trailingNode !== null && rh(t.trailingNode, e);
              else {
                let { containingNode: s, start: r } = t;
                if (this.input.charCodeAt(r - 1) === 44) switch (s.type) {
                  case "ObjectExpression":
                  case "ObjectPattern":
                  case "RecordExpression":
                    Xe(s, s.properties, t);
                    break;
                  case "CallExpression":
                  case "OptionalCallExpression":
                    Xe(s, s.arguments, t);
                    break;
                  case "FunctionDeclaration":
                  case "FunctionExpression":
                  case "ArrowFunctionExpression":
                  case "ObjectMethod":
                  case "ClassMethod":
                  case "ClassPrivateMethod":
                    Xe(s, s.params, t);
                    break;
                  case "ArrayExpression":
                  case "ArrayPattern":
                  case "TupleExpression":
                    Xe(s, s.elements, t);
                    break;
                  case "ExportNamedDeclaration":
                  case "ImportDeclaration":
                    Xe(s, s.specifiers, t);
                    break;
                  default:
                    Ge(s, e);
                }
                else Ge(s, e);
              }
            }
            finalizeRemainingComments() {
              let { commentStack: t } = this.state;
              for (let e = t.length - 1; e >= 0; e--) this.finalizeComment(t[e]);
              this.state.commentStack = [];
            }
            resetPreviousNodeTrailingComments(t) {
              let { commentStack: e } = this.state, { length: s } = e;
              if (s === 0) return;
              let r = e[s - 1];
              r.leadingNode === t && (r.leadingNode = null);
            }
            takeSurroundingComments(t, e, s) {
              let { commentStack: r } = this.state, i = r.length;
              if (i === 0) return;
              let a = i - 1;
              for (; a >= 0; a--) {
                let n = r[a], o = n.end;
                if (n.start === s) n.leadingNode = t;
                else if (o === e) n.trailingNode = t;
                else if (o < e) break;
              }
            }
          }, as = /\r\n?|[\n\u2028\u2029]/, dt = new RegExp(as.source, "g");
          function Ne(t) {
            switch (t) {
              case 10:
              case 13:
              case 8232:
              case 8233:
                return true;
              default:
                return false;
            }
          }
          var ns = /(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g, ah = /(?:[^\S\n\r\u2028\u2029]|\/\/.*|\/\*.*?\*\/)*/y, vr = new RegExp("(?=(" + ah.source + "))\\1" + /(?=[\n\r\u2028\u2029]|\/\*(?!.*?\*\/)|$)/.source, "y");
          function nh(t) {
            switch (t) {
              case 9:
              case 11:
              case 12:
              case 32:
              case 160:
              case 5760:
              case 8192:
              case 8193:
              case 8194:
              case 8195:
              case 8196:
              case 8197:
              case 8198:
              case 8199:
              case 8200:
              case 8201:
              case 8202:
              case 8239:
              case 8287:
              case 12288:
              case 65279:
                return true;
              default:
                return false;
            }
          }
          var Sr = class {
            constructor() {
              this.strict = void 0, this.curLine = void 0, this.lineStart = void 0, this.startLoc = void 0, this.endLoc = void 0, this.errors = [], this.potentialArrowAt = -1, this.noArrowAt = [], this.noArrowParamsConversionAt = [], this.maybeInArrowParameters = false, this.inType = false, this.noAnonFunctionType = false, this.hasFlowComment = false, this.isAmbientContext = false, this.inAbstractClass = false, this.inDisallowConditionalTypesContext = false, this.topicContext = { maxNumOfResolvableTopics: 0, maxTopicIndex: null }, this.soloAwait = false, this.inFSharpPipelineDirectBody = false, this.labels = [], this.decoratorStack = [[]], this.comments = [], this.commentStack = [], this.pos = 0, this.type = 135, this.value = null, this.start = 0, this.end = 0, this.lastTokEndLoc = null, this.lastTokStartLoc = null, this.lastTokStart = 0, this.context = [z2.brace], this.canStartJSXElement = true, this.containsEsc = false, this.strictErrors = /* @__PURE__ */ new Map(), this.tokensLength = 0;
            }
            init(t) {
              let { strictMode: e, sourceType: s, startLine: r, startColumn: i } = t;
              this.strict = e === false ? false : e === true ? true : s === "module", this.curLine = r, this.lineStart = -i, this.startLoc = this.endLoc = new p(r, i, 0);
            }
            curPosition() {
              return new p(this.curLine, this.pos - this.lineStart, this.pos);
            }
            clone(t) {
              let e = new Sr(), s = Object.keys(this);
              for (let r = 0, i = s.length; r < i; r++) {
                let a = s[r], n = this[a];
                !t && Array.isArray(n) && (n = n.slice()), e[a] = n;
              }
              return e;
            }
          }, oh = ["at"], hh = ["at"], lh = function(e) {
            return e >= 48 && e <= 57;
          }, uh = /* @__PURE__ */ new Set([103, 109, 115, 105, 121, 117, 100, 118]), wr = { decBinOct: /* @__PURE__ */ new Set([46, 66, 69, 79, 95, 98, 101, 111]), hex: /* @__PURE__ */ new Set([46, 88, 95, 120]) }, mt = { bin: (t) => t === 48 || t === 49, oct: (t) => t >= 48 && t <= 55, dec: (t) => t >= 48 && t <= 57, hex: (t) => t >= 48 && t <= 57 || t >= 65 && t <= 70 || t >= 97 && t <= 102 }, Ee = class {
            constructor(t) {
              this.type = t.type, this.value = t.value, this.start = t.start, this.end = t.end, this.loc = new d(t.startLoc, t.endLoc);
            }
          }, ch = class extends ih {
            constructor(t, e) {
              super(), this.isLookahead = void 0, this.tokens = [], this.state = new Sr(), this.state.init(t), this.input = e, this.length = e.length, this.isLookahead = false;
            }
            pushToken(t) {
              this.tokens.length = this.state.tokensLength, this.tokens.push(t), ++this.state.tokensLength;
            }
            next() {
              this.checkKeywordEscapes(), this.options.tokens && this.pushToken(new Ee(this.state)), this.state.lastTokStart = this.state.start, this.state.lastTokEndLoc = this.state.endLoc, this.state.lastTokStartLoc = this.state.startLoc, this.nextToken();
            }
            eat(t) {
              return this.match(t) ? (this.next(), true) : false;
            }
            match(t) {
              return this.state.type === t;
            }
            createLookaheadState(t) {
              return { pos: t.pos, value: null, type: t.type, start: t.start, end: t.end, context: [this.curContext()], inType: t.inType, startLoc: t.startLoc, lastTokEndLoc: t.lastTokEndLoc, curLine: t.curLine, lineStart: t.lineStart, curPosition: t.curPosition };
            }
            lookahead() {
              let t = this.state;
              this.state = this.createLookaheadState(t), this.isLookahead = true, this.nextToken(), this.isLookahead = false;
              let e = this.state;
              return this.state = t, e;
            }
            nextTokenStart() {
              return this.nextTokenStartSince(this.state.pos);
            }
            nextTokenStartSince(t) {
              return ns.lastIndex = t, ns.test(this.input) ? ns.lastIndex : t;
            }
            lookaheadCharCode() {
              return this.input.charCodeAt(this.nextTokenStart());
            }
            codePointAtPos(t) {
              let e = this.input.charCodeAt(t);
              if ((e & 64512) === 55296 && ++t < this.input.length) {
                let s = this.input.charCodeAt(t);
                (s & 64512) === 56320 && (e = 65536 + ((e & 1023) << 10) + (s & 1023));
              }
              return e;
            }
            setStrict(t) {
              this.state.strict = t, t && (this.state.strictErrors.forEach((e) => {
                let [s, r] = e;
                return this.raise(s, { at: r });
              }), this.state.strictErrors.clear());
            }
            curContext() {
              return this.state.context[this.state.context.length - 1];
            }
            nextToken() {
              if (this.skipSpace(), this.state.start = this.state.pos, this.isLookahead || (this.state.startLoc = this.state.curPosition()), this.state.pos >= this.length) {
                this.finishToken(135);
                return;
              }
              this.getTokenFromCode(this.codePointAtPos(this.state.pos));
            }
            skipBlockComment() {
              let t;
              this.isLookahead || (t = this.state.curPosition());
              let e = this.state.pos, s = this.input.indexOf("*/", e + 2);
              if (s === -1) throw this.raise(u.UnterminatedComment, { at: this.state.curPosition() });
              for (this.state.pos = s + 2, dt.lastIndex = e + 2; dt.test(this.input) && dt.lastIndex <= s; ) ++this.state.curLine, this.state.lineStart = dt.lastIndex;
              if (this.isLookahead) return;
              let r = { type: "CommentBlock", value: this.input.slice(e + 2, s), start: e, end: s + 2, loc: new d(t, this.state.curPosition()) };
              return this.options.tokens && this.pushToken(r), r;
            }
            skipLineComment(t) {
              let e = this.state.pos, s;
              this.isLookahead || (s = this.state.curPosition());
              let r = this.input.charCodeAt(this.state.pos += t);
              if (this.state.pos < this.length) for (; !Ne(r) && ++this.state.pos < this.length; ) r = this.input.charCodeAt(this.state.pos);
              if (this.isLookahead) return;
              let i = this.state.pos, a = this.input.slice(e + t, i), n = { type: "CommentLine", value: a, start: e, end: i, loc: new d(s, this.state.curPosition()) };
              return this.options.tokens && this.pushToken(n), n;
            }
            skipSpace() {
              let t = this.state.pos, e = [];
              e: for (; this.state.pos < this.length; ) {
                let s = this.input.charCodeAt(this.state.pos);
                switch (s) {
                  case 32:
                  case 160:
                  case 9:
                    ++this.state.pos;
                    break;
                  case 13:
                    this.input.charCodeAt(this.state.pos + 1) === 10 && ++this.state.pos;
                  case 10:
                  case 8232:
                  case 8233:
                    ++this.state.pos, ++this.state.curLine, this.state.lineStart = this.state.pos;
                    break;
                  case 47:
                    switch (this.input.charCodeAt(this.state.pos + 1)) {
                      case 42: {
                        let r = this.skipBlockComment();
                        r !== void 0 && (this.addComment(r), this.options.attachComment && e.push(r));
                        break;
                      }
                      case 47: {
                        let r = this.skipLineComment(2);
                        r !== void 0 && (this.addComment(r), this.options.attachComment && e.push(r));
                        break;
                      }
                      default:
                        break e;
                    }
                    break;
                  default:
                    if (nh(s)) ++this.state.pos;
                    else if (s === 45 && !this.inModule) {
                      let r = this.state.pos;
                      if (this.input.charCodeAt(r + 1) === 45 && this.input.charCodeAt(r + 2) === 62 && (t === 0 || this.state.lineStart > t)) {
                        let i = this.skipLineComment(3);
                        i !== void 0 && (this.addComment(i), this.options.attachComment && e.push(i));
                      } else break e;
                    } else if (s === 60 && !this.inModule) {
                      let r = this.state.pos;
                      if (this.input.charCodeAt(r + 1) === 33 && this.input.charCodeAt(r + 2) === 45 && this.input.charCodeAt(r + 3) === 45) {
                        let i = this.skipLineComment(4);
                        i !== void 0 && (this.addComment(i), this.options.attachComment && e.push(i));
                      } else break e;
                    } else break e;
                }
              }
              if (e.length > 0) {
                let s = this.state.pos, r = { start: t, end: s, comments: e, leadingNode: null, trailingNode: null, containingNode: null };
                this.state.commentStack.push(r);
              }
            }
            finishToken(t, e) {
              this.state.end = this.state.pos, this.state.endLoc = this.state.curPosition();
              let s = this.state.type;
              this.state.type = t, this.state.value = e, this.isLookahead || this.updateContext(s);
            }
            replaceToken(t) {
              this.state.type = t, this.updateContext();
            }
            readToken_numberSign() {
              if (this.state.pos === 0 && this.readToken_interpreter()) return;
              let t = this.state.pos + 1, e = this.codePointAtPos(t);
              if (e >= 48 && e <= 57) throw this.raise(u.UnexpectedDigitAfterHash, { at: this.state.curPosition() });
              if (e === 123 || e === 91 && this.hasPlugin("recordAndTuple")) {
                if (this.expectPlugin("recordAndTuple"), this.getPluginOption("recordAndTuple", "syntaxType") !== "hash") throw this.raise(e === 123 ? u.RecordExpressionHashIncorrectStartSyntaxType : u.TupleExpressionHashIncorrectStartSyntaxType, { at: this.state.curPosition() });
                this.state.pos += 2, e === 123 ? this.finishToken(7) : this.finishToken(1);
              } else de(e) ? (++this.state.pos, this.finishToken(134, this.readWord1(e))) : e === 92 ? (++this.state.pos, this.finishToken(134, this.readWord1())) : this.finishOp(27, 1);
            }
            readToken_dot() {
              let t = this.input.charCodeAt(this.state.pos + 1);
              if (t >= 48 && t <= 57) {
                this.readNumber(true);
                return;
              }
              t === 46 && this.input.charCodeAt(this.state.pos + 2) === 46 ? (this.state.pos += 3, this.finishToken(21)) : (++this.state.pos, this.finishToken(16));
            }
            readToken_slash() {
              this.input.charCodeAt(this.state.pos + 1) === 61 ? this.finishOp(31, 2) : this.finishOp(56, 1);
            }
            readToken_interpreter() {
              if (this.state.pos !== 0 || this.length < 2) return false;
              let t = this.input.charCodeAt(this.state.pos + 1);
              if (t !== 33) return false;
              let e = this.state.pos;
              for (this.state.pos += 1; !Ne(t) && ++this.state.pos < this.length; ) t = this.input.charCodeAt(this.state.pos);
              let s = this.input.slice(e + 2, this.state.pos);
              return this.finishToken(28, s), true;
            }
            readToken_mult_modulo(t) {
              let e = t === 42 ? 55 : 54, s = 1, r = this.input.charCodeAt(this.state.pos + 1);
              t === 42 && r === 42 && (s++, r = this.input.charCodeAt(this.state.pos + 2), e = 57), r === 61 && !this.state.inType && (s++, e = t === 37 ? 33 : 30), this.finishOp(e, s);
            }
            readToken_pipe_amp(t) {
              let e = this.input.charCodeAt(this.state.pos + 1);
              if (e === t) {
                this.input.charCodeAt(this.state.pos + 2) === 61 ? this.finishOp(30, 3) : this.finishOp(t === 124 ? 41 : 42, 2);
                return;
              }
              if (t === 124) {
                if (e === 62) {
                  this.finishOp(39, 2);
                  return;
                }
                if (this.hasPlugin("recordAndTuple") && e === 125) {
                  if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") throw this.raise(u.RecordExpressionBarIncorrectEndSyntaxType, { at: this.state.curPosition() });
                  this.state.pos += 2, this.finishToken(9);
                  return;
                }
                if (this.hasPlugin("recordAndTuple") && e === 93) {
                  if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") throw this.raise(u.TupleExpressionBarIncorrectEndSyntaxType, { at: this.state.curPosition() });
                  this.state.pos += 2, this.finishToken(4);
                  return;
                }
              }
              if (e === 61) {
                this.finishOp(30, 2);
                return;
              }
              this.finishOp(t === 124 ? 43 : 45, 1);
            }
            readToken_caret() {
              let t = this.input.charCodeAt(this.state.pos + 1);
              if (t === 61 && !this.state.inType) this.finishOp(32, 2);
              else if (t === 94 && this.hasPlugin(["pipelineOperator", { proposal: "hack", topicToken: "^^" }])) {
                if (this.finishOp(37, 2), this.input.codePointAt(this.state.pos) === 94) throw this.unexpected();
              } else this.finishOp(44, 1);
            }
            readToken_atSign() {
              this.input.charCodeAt(this.state.pos + 1) === 64 && this.hasPlugin(["pipelineOperator", { proposal: "hack", topicToken: "@@" }]) ? this.finishOp(38, 2) : this.finishOp(26, 1);
            }
            readToken_plus_min(t) {
              let e = this.input.charCodeAt(this.state.pos + 1);
              if (e === t) {
                this.finishOp(34, 2);
                return;
              }
              e === 61 ? this.finishOp(30, 2) : this.finishOp(53, 1);
            }
            readToken_lt() {
              let { pos: t } = this.state, e = this.input.charCodeAt(t + 1);
              if (e === 60) {
                if (this.input.charCodeAt(t + 2) === 61) {
                  this.finishOp(30, 3);
                  return;
                }
                this.finishOp(51, 2);
                return;
              }
              if (e === 61) {
                this.finishOp(49, 2);
                return;
              }
              this.finishOp(47, 1);
            }
            readToken_gt() {
              let { pos: t } = this.state, e = this.input.charCodeAt(t + 1);
              if (e === 62) {
                let s = this.input.charCodeAt(t + 2) === 62 ? 3 : 2;
                if (this.input.charCodeAt(t + s) === 61) {
                  this.finishOp(30, s + 1);
                  return;
                }
                this.finishOp(52, s);
                return;
              }
              if (e === 61) {
                this.finishOp(49, 2);
                return;
              }
              this.finishOp(48, 1);
            }
            readToken_eq_excl(t) {
              let e = this.input.charCodeAt(this.state.pos + 1);
              if (e === 61) {
                this.finishOp(46, this.input.charCodeAt(this.state.pos + 2) === 61 ? 3 : 2);
                return;
              }
              if (t === 61 && e === 62) {
                this.state.pos += 2, this.finishToken(19);
                return;
              }
              this.finishOp(t === 61 ? 29 : 35, 1);
            }
            readToken_question() {
              let t = this.input.charCodeAt(this.state.pos + 1), e = this.input.charCodeAt(this.state.pos + 2);
              t === 63 ? e === 61 ? this.finishOp(30, 3) : this.finishOp(40, 2) : t === 46 && !(e >= 48 && e <= 57) ? (this.state.pos += 2, this.finishToken(18)) : (++this.state.pos, this.finishToken(17));
            }
            getTokenFromCode(t) {
              switch (t) {
                case 46:
                  this.readToken_dot();
                  return;
                case 40:
                  ++this.state.pos, this.finishToken(10);
                  return;
                case 41:
                  ++this.state.pos, this.finishToken(11);
                  return;
                case 59:
                  ++this.state.pos, this.finishToken(13);
                  return;
                case 44:
                  ++this.state.pos, this.finishToken(12);
                  return;
                case 91:
                  if (this.hasPlugin("recordAndTuple") && this.input.charCodeAt(this.state.pos + 1) === 124) {
                    if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") throw this.raise(u.TupleExpressionBarIncorrectStartSyntaxType, { at: this.state.curPosition() });
                    this.state.pos += 2, this.finishToken(2);
                  } else ++this.state.pos, this.finishToken(0);
                  return;
                case 93:
                  ++this.state.pos, this.finishToken(3);
                  return;
                case 123:
                  if (this.hasPlugin("recordAndTuple") && this.input.charCodeAt(this.state.pos + 1) === 124) {
                    if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") throw this.raise(u.RecordExpressionBarIncorrectStartSyntaxType, { at: this.state.curPosition() });
                    this.state.pos += 2, this.finishToken(6);
                  } else ++this.state.pos, this.finishToken(5);
                  return;
                case 125:
                  ++this.state.pos, this.finishToken(8);
                  return;
                case 58:
                  this.hasPlugin("functionBind") && this.input.charCodeAt(this.state.pos + 1) === 58 ? this.finishOp(15, 2) : (++this.state.pos, this.finishToken(14));
                  return;
                case 63:
                  this.readToken_question();
                  return;
                case 96:
                  this.readTemplateToken();
                  return;
                case 48: {
                  let e = this.input.charCodeAt(this.state.pos + 1);
                  if (e === 120 || e === 88) {
                    this.readRadixNumber(16);
                    return;
                  }
                  if (e === 111 || e === 79) {
                    this.readRadixNumber(8);
                    return;
                  }
                  if (e === 98 || e === 66) {
                    this.readRadixNumber(2);
                    return;
                  }
                }
                case 49:
                case 50:
                case 51:
                case 52:
                case 53:
                case 54:
                case 55:
                case 56:
                case 57:
                  this.readNumber(false);
                  return;
                case 34:
                case 39:
                  this.readString(t);
                  return;
                case 47:
                  this.readToken_slash();
                  return;
                case 37:
                case 42:
                  this.readToken_mult_modulo(t);
                  return;
                case 124:
                case 38:
                  this.readToken_pipe_amp(t);
                  return;
                case 94:
                  this.readToken_caret();
                  return;
                case 43:
                case 45:
                  this.readToken_plus_min(t);
                  return;
                case 60:
                  this.readToken_lt();
                  return;
                case 62:
                  this.readToken_gt();
                  return;
                case 61:
                case 33:
                  this.readToken_eq_excl(t);
                  return;
                case 126:
                  this.finishOp(36, 1);
                  return;
                case 64:
                  this.readToken_atSign();
                  return;
                case 35:
                  this.readToken_numberSign();
                  return;
                case 92:
                  this.readWord();
                  return;
                default:
                  if (de(t)) {
                    this.readWord(t);
                    return;
                  }
              }
              throw this.raise(u.InvalidOrUnexpectedToken, { at: this.state.curPosition(), unexpected: String.fromCodePoint(t) });
            }
            finishOp(t, e) {
              let s = this.input.slice(this.state.pos, this.state.pos + e);
              this.state.pos += e, this.finishToken(t, s);
            }
            readRegexp() {
              let t = this.state.startLoc, e = this.state.start + 1, s, r, { pos: i } = this.state;
              for (; ; ++i) {
                if (i >= this.length) throw this.raise(u.UnterminatedRegExp, { at: m(t, 1) });
                let c = this.input.charCodeAt(i);
                if (Ne(c)) throw this.raise(u.UnterminatedRegExp, { at: m(t, 1) });
                if (s) s = false;
                else {
                  if (c === 91) r = true;
                  else if (c === 93 && r) r = false;
                  else if (c === 47 && !r) break;
                  s = c === 92;
                }
              }
              let a = this.input.slice(e, i);
              ++i;
              let n = "", o = () => m(t, i + 2 - e);
              for (; i < this.length; ) {
                let c = this.codePointAtPos(i), f = String.fromCharCode(c);
                if (uh.has(c)) c === 118 ? (this.expectPlugin("regexpUnicodeSets", o()), n.includes("u") && this.raise(u.IncompatibleRegExpUVFlags, { at: o() })) : c === 117 && n.includes("v") && this.raise(u.IncompatibleRegExpUVFlags, { at: o() }), n.includes(f) && this.raise(u.DuplicateRegExpFlags, { at: o() });
                else if (Be(c) || c === 92) this.raise(u.MalformedRegExpFlags, { at: o() });
                else break;
                ++i, n += f;
              }
              this.state.pos = i, this.finishToken(133, { pattern: a, flags: n });
            }
            readInt(t, e, s) {
              let r = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true, i = this.state.pos, a = t === 16 ? wr.hex : wr.decBinOct, n = t === 16 ? mt.hex : t === 10 ? mt.dec : t === 8 ? mt.oct : mt.bin, o = false, c = 0;
              for (let f = 0, y = e == null ? 1 / 0 : e; f < y; ++f) {
                let P = this.input.charCodeAt(this.state.pos), v;
                if (P === 95 && r !== "bail") {
                  let N = this.input.charCodeAt(this.state.pos - 1), B = this.input.charCodeAt(this.state.pos + 1);
                  r ? (Number.isNaN(B) || !n(B) || a.has(N) || a.has(B)) && this.raise(u.UnexpectedNumericSeparator, { at: this.state.curPosition() }) : this.raise(u.NumericSeparatorInEscapeSequence, { at: this.state.curPosition() }), ++this.state.pos;
                  continue;
                }
                if (P >= 97 ? v = P - 97 + 10 : P >= 65 ? v = P - 65 + 10 : lh(P) ? v = P - 48 : v = 1 / 0, v >= t) if (this.options.errorRecovery && v <= 9) v = 0, this.raise(u.InvalidDigit, { at: this.state.curPosition(), radix: t });
                else if (s) v = 0, o = true;
                else break;
                ++this.state.pos, c = c * t + v;
              }
              return this.state.pos === i || e != null && this.state.pos - i !== e || o ? null : c;
            }
            readRadixNumber(t) {
              let e = this.state.curPosition(), s = false;
              this.state.pos += 2;
              let r = this.readInt(t);
              r == null && this.raise(u.InvalidDigit, { at: m(e, 2), radix: t });
              let i = this.input.charCodeAt(this.state.pos);
              if (i === 110) ++this.state.pos, s = true;
              else if (i === 109) throw this.raise(u.InvalidDecimal, { at: e });
              if (de(this.codePointAtPos(this.state.pos))) throw this.raise(u.NumberIdentifier, { at: this.state.curPosition() });
              if (s) {
                let a = this.input.slice(e.index, this.state.pos).replace(/[_n]/g, "");
                this.finishToken(131, a);
                return;
              }
              this.finishToken(130, r);
            }
            readNumber(t) {
              let e = this.state.pos, s = this.state.curPosition(), r = false, i = false, a = false, n = false, o = false;
              !t && this.readInt(10) === null && this.raise(u.InvalidNumber, { at: this.state.curPosition() });
              let c = this.state.pos - e >= 2 && this.input.charCodeAt(e) === 48;
              if (c) {
                let v = this.input.slice(e, this.state.pos);
                if (this.recordStrictModeErrors(u.StrictOctalLiteral, { at: s }), !this.state.strict) {
                  let N = v.indexOf("_");
                  N > 0 && this.raise(u.ZeroDigitNumericSeparator, { at: m(s, N) });
                }
                o = c && !/[89]/.test(v);
              }
              let f = this.input.charCodeAt(this.state.pos);
              if (f === 46 && !o && (++this.state.pos, this.readInt(10), r = true, f = this.input.charCodeAt(this.state.pos)), (f === 69 || f === 101) && !o && (f = this.input.charCodeAt(++this.state.pos), (f === 43 || f === 45) && ++this.state.pos, this.readInt(10) === null && this.raise(u.InvalidOrMissingExponent, { at: s }), r = true, n = true, f = this.input.charCodeAt(this.state.pos)), f === 110 && ((r || c) && this.raise(u.InvalidBigIntLiteral, { at: s }), ++this.state.pos, i = true), f === 109 && (this.expectPlugin("decimal", this.state.curPosition()), (n || c) && this.raise(u.InvalidDecimal, { at: s }), ++this.state.pos, a = true), de(this.codePointAtPos(this.state.pos))) throw this.raise(u.NumberIdentifier, { at: this.state.curPosition() });
              let y = this.input.slice(e, this.state.pos).replace(/[_mn]/g, "");
              if (i) {
                this.finishToken(131, y);
                return;
              }
              if (a) {
                this.finishToken(132, y);
                return;
              }
              let P = o ? parseInt(y, 8) : parseFloat(y);
              this.finishToken(130, P);
            }
            readCodePoint(t) {
              let e = this.input.charCodeAt(this.state.pos), s;
              if (e === 123) {
                if (++this.state.pos, s = this.readHexChar(this.input.indexOf("}", this.state.pos) - this.state.pos, true, t), ++this.state.pos, s !== null && s > 1114111) if (t) this.raise(u.InvalidCodePoint, { at: this.state.curPosition() });
                else return null;
              } else s = this.readHexChar(4, false, t);
              return s;
            }
            readString(t) {
              let e = "", s = ++this.state.pos;
              for (; ; ) {
                if (this.state.pos >= this.length) throw this.raise(u.UnterminatedString, { at: this.state.startLoc });
                let r = this.input.charCodeAt(this.state.pos);
                if (r === t) break;
                if (r === 92) e += this.input.slice(s, this.state.pos), e += this.readEscapedChar(false), s = this.state.pos;
                else if (r === 8232 || r === 8233) ++this.state.pos, ++this.state.curLine, this.state.lineStart = this.state.pos;
                else {
                  if (Ne(r)) throw this.raise(u.UnterminatedString, { at: this.state.startLoc });
                  ++this.state.pos;
                }
              }
              e += this.input.slice(s, this.state.pos++), this.finishToken(129, e);
            }
            readTemplateContinuation() {
              this.match(8) || this.unexpected(null, 8), this.state.pos--, this.readTemplateToken();
            }
            readTemplateToken() {
              let t = "", e = this.state.pos, s = false;
              for (++this.state.pos; ; ) {
                if (this.state.pos >= this.length) throw this.raise(u.UnterminatedTemplate, { at: m(this.state.startLoc, 1) });
                let r = this.input.charCodeAt(this.state.pos);
                if (r === 96) {
                  ++this.state.pos, t += this.input.slice(e, this.state.pos), this.finishToken(24, s ? null : t);
                  return;
                }
                if (r === 36 && this.input.charCodeAt(this.state.pos + 1) === 123) {
                  this.state.pos += 2, t += this.input.slice(e, this.state.pos), this.finishToken(25, s ? null : t);
                  return;
                }
                if (r === 92) {
                  t += this.input.slice(e, this.state.pos);
                  let i = this.readEscapedChar(true);
                  i === null ? s = true : t += i, e = this.state.pos;
                } else if (Ne(r)) {
                  switch (t += this.input.slice(e, this.state.pos), ++this.state.pos, r) {
                    case 13:
                      this.input.charCodeAt(this.state.pos) === 10 && ++this.state.pos;
                    case 10:
                      t += `
`;
                      break;
                    default:
                      t += String.fromCharCode(r);
                      break;
                  }
                  ++this.state.curLine, this.state.lineStart = this.state.pos, e = this.state.pos;
                } else ++this.state.pos;
              }
            }
            recordStrictModeErrors(t, e) {
              let { at: s } = e, r = s.index;
              this.state.strict && !this.state.strictErrors.has(r) ? this.raise(t, { at: s }) : this.state.strictErrors.set(r, [t, s]);
            }
            readEscapedChar(t) {
              let e = !t, s = this.input.charCodeAt(++this.state.pos);
              switch (++this.state.pos, s) {
                case 110:
                  return `
`;
                case 114:
                  return "\r";
                case 120: {
                  let r = this.readHexChar(2, false, e);
                  return r === null ? null : String.fromCharCode(r);
                }
                case 117: {
                  let r = this.readCodePoint(e);
                  return r === null ? null : String.fromCodePoint(r);
                }
                case 116:
                  return "	";
                case 98:
                  return "\b";
                case 118:
                  return "\v";
                case 102:
                  return "\f";
                case 13:
                  this.input.charCodeAt(this.state.pos) === 10 && ++this.state.pos;
                case 10:
                  this.state.lineStart = this.state.pos, ++this.state.curLine;
                case 8232:
                case 8233:
                  return "";
                case 56:
                case 57:
                  if (t) return null;
                  this.recordStrictModeErrors(u.StrictNumericEscape, { at: m(this.state.curPosition(), -1) });
                default:
                  if (s >= 48 && s <= 55) {
                    let r = m(this.state.curPosition(), -1), a = this.input.slice(this.state.pos - 1, this.state.pos + 2).match(/^[0-7]+/)[0], n = parseInt(a, 8);
                    n > 255 && (a = a.slice(0, -1), n = parseInt(a, 8)), this.state.pos += a.length - 1;
                    let o = this.input.charCodeAt(this.state.pos);
                    if (a !== "0" || o === 56 || o === 57) {
                      if (t) return null;
                      this.recordStrictModeErrors(u.StrictNumericEscape, { at: r });
                    }
                    return String.fromCharCode(n);
                  }
                  return String.fromCharCode(s);
              }
            }
            readHexChar(t, e, s) {
              let r = this.state.curPosition(), i = this.readInt(16, t, e, false);
              return i === null && (s ? this.raise(u.InvalidEscapeSequence, { at: r }) : this.state.pos = r.index - 1), i;
            }
            readWord1(t) {
              this.state.containsEsc = false;
              let e = "", s = this.state.pos, r = this.state.pos;
              for (t !== void 0 && (this.state.pos += t <= 65535 ? 1 : 2); this.state.pos < this.length; ) {
                let i = this.codePointAtPos(this.state.pos);
                if (Be(i)) this.state.pos += i <= 65535 ? 1 : 2;
                else if (i === 92) {
                  this.state.containsEsc = true, e += this.input.slice(r, this.state.pos);
                  let a = this.state.curPosition(), n = this.state.pos === s ? de : Be;
                  if (this.input.charCodeAt(++this.state.pos) !== 117) {
                    this.raise(u.MissingUnicodeEscape, { at: this.state.curPosition() }), r = this.state.pos - 1;
                    continue;
                  }
                  ++this.state.pos;
                  let o = this.readCodePoint(true);
                  o !== null && (n(o) || this.raise(u.EscapedCharNotAnIdentifier, { at: a }), e += String.fromCodePoint(o)), r = this.state.pos;
                } else break;
              }
              return e + this.input.slice(r, this.state.pos);
            }
            readWord(t) {
              let e = this.readWord1(t), s = qt.get(e);
              s !== void 0 ? this.finishToken(s, Pe(s)) : this.finishToken(128, e);
            }
            checkKeywordEscapes() {
              let { type: t } = this.state;
              Ht(t) && this.state.containsEsc && this.raise(u.InvalidEscapedReservedWord, { at: this.state.startLoc, reservedWord: Pe(t) });
            }
            raise(t, e) {
              let { at: s } = e, r = l(e, oh), i = s instanceof p ? s : s.loc.start, a = t({ loc: i, details: r });
              if (!this.options.errorRecovery) throw a;
              return this.isLookahead || this.state.errors.push(a), a;
            }
            raiseOverwrite(t, e) {
              let { at: s } = e, r = l(e, hh), i = s instanceof p ? s : s.loc.start, a = i.index, n = this.state.errors;
              for (let o = n.length - 1; o >= 0; o--) {
                let c = n[o];
                if (c.loc.index === a) return n[o] = t({ loc: i, details: r });
                if (c.loc.index < a) break;
              }
              return this.raise(t, e);
            }
            updateContext(t) {
            }
            unexpected(t, e) {
              throw this.raise(u.UnexpectedToken, { expected: e ? Pe(e) : null, at: t != null ? t : this.state.startLoc });
            }
            expectPlugin(t, e) {
              if (this.hasPlugin(t)) return true;
              throw this.raise(u.MissingPlugin, { at: e != null ? e : this.state.startLoc, missingPlugin: [t] });
            }
            expectOnePlugin(t) {
              if (!t.some((e) => this.hasPlugin(e))) throw this.raise(u.MissingOneOfPlugins, { at: this.state.startLoc, missingPlugin: t });
            }
          }, os = class {
            constructor(t) {
              this.var = /* @__PURE__ */ new Set(), this.lexical = /* @__PURE__ */ new Set(), this.functions = /* @__PURE__ */ new Set(), this.flags = t;
            }
          }, hs = class {
            constructor(t, e) {
              this.parser = void 0, this.scopeStack = [], this.inModule = void 0, this.undefinedExports = /* @__PURE__ */ new Map(), this.parser = t, this.inModule = e;
            }
            get inFunction() {
              return (this.currentVarScopeFlags() & me) > 0;
            }
            get allowSuper() {
              return (this.currentThisScopeFlags() & ot) > 0;
            }
            get allowDirectSuper() {
              return (this.currentThisScopeFlags() & xr) > 0;
            }
            get inClass() {
              return (this.currentThisScopeFlags() & Se) > 0;
            }
            get inClassAndNotInNonArrowFunction() {
              let t = this.currentThisScopeFlags();
              return (t & Se) > 0 && (t & me) === 0;
            }
            get inStaticBlock() {
              for (let t = this.scopeStack.length - 1; ; t--) {
                let { flags: e } = this.scopeStack[t];
                if (e & Yt) return true;
                if (e & (lt | Se)) return false;
              }
            }
            get inNonArrowFunction() {
              return (this.currentThisScopeFlags() & me) > 0;
            }
            get treatFunctionsAsVar() {
              return this.treatFunctionsAsVarInScope(this.currentScope());
            }
            createScope(t) {
              return new os(t);
            }
            enter(t) {
              this.scopeStack.push(this.createScope(t));
            }
            exit() {
              this.scopeStack.pop();
            }
            treatFunctionsAsVarInScope(t) {
              return !!(t.flags & (me | Yt) || !this.parser.inModule && t.flags & We);
            }
            declareName(t, e, s) {
              let r = this.currentScope();
              if (e & Te || e & ut) this.checkRedeclarationInScope(r, t, e, s), e & ut ? r.functions.add(t) : r.lexical.add(t), e & Te && this.maybeExportDefined(r, t);
              else if (e & gr) for (let i = this.scopeStack.length - 1; i >= 0 && (r = this.scopeStack[i], this.checkRedeclarationInScope(r, t, e, s), r.var.add(t), this.maybeExportDefined(r, t), !(r.flags & lt)); --i) ;
              this.parser.inModule && r.flags & We && this.undefinedExports.delete(t);
            }
            maybeExportDefined(t, e) {
              this.parser.inModule && t.flags & We && this.undefinedExports.delete(e);
            }
            checkRedeclarationInScope(t, e, s, r) {
              this.isRedeclaredInScope(t, e, s) && this.parser.raise(u.VarRedeclaration, { at: r, identifierName: e });
            }
            isRedeclaredInScope(t, e, s) {
              return s & ye ? s & Te ? t.lexical.has(e) || t.functions.has(e) || t.var.has(e) : s & ut ? t.lexical.has(e) || !this.treatFunctionsAsVarInScope(t) && t.var.has(e) : t.lexical.has(e) && !(t.flags & yr && t.lexical.values().next().value === e) || !this.treatFunctionsAsVarInScope(t) && t.functions.has(e) : false;
            }
            checkLocalExport(t) {
              let { name: e } = t, s = this.scopeStack[0];
              !s.lexical.has(e) && !s.var.has(e) && !s.functions.has(e) && this.undefinedExports.set(e, t.loc.start);
            }
            currentScope() {
              return this.scopeStack[this.scopeStack.length - 1];
            }
            currentVarScopeFlags() {
              for (let t = this.scopeStack.length - 1; ; t--) {
                let { flags: e } = this.scopeStack[t];
                if (e & lt) return e;
              }
            }
            currentThisScopeFlags() {
              for (let t = this.scopeStack.length - 1; ; t--) {
                let { flags: e } = this.scopeStack[t];
                if (e & (lt | Se) && !(e & Jt)) return e;
              }
            }
          }, ph = class extends os {
            constructor() {
              super(...arguments), this.declareFunctions = /* @__PURE__ */ new Set();
            }
          }, fh = class extends hs {
            createScope(t) {
              return new ph(t);
            }
            declareName(t, e, s) {
              let r = this.currentScope();
              if (e & es) {
                this.checkRedeclarationInScope(r, t, e, s), this.maybeExportDefined(r, t), r.declareFunctions.add(t);
                return;
              }
              super.declareName(...arguments);
            }
            isRedeclaredInScope(t, e, s) {
              return super.isRedeclaredInScope(...arguments) ? true : s & es ? !t.declareFunctions.has(e) && (t.lexical.has(e) || t.functions.has(e)) : false;
            }
            checkLocalExport(t) {
              this.scopeStack[0].declareFunctions.has(t.name) || super.checkLocalExport(t);
            }
          }, dh = class {
            constructor() {
              this.privateNames = /* @__PURE__ */ new Set(), this.loneAccessors = /* @__PURE__ */ new Map(), this.undefinedPrivateNames = /* @__PURE__ */ new Map();
            }
          }, mh = class {
            constructor(t) {
              this.parser = void 0, this.stack = [], this.undefinedPrivateNames = /* @__PURE__ */ new Map(), this.parser = t;
            }
            current() {
              return this.stack[this.stack.length - 1];
            }
            enter() {
              this.stack.push(new dh());
            }
            exit() {
              let t = this.stack.pop(), e = this.current();
              for (let [s, r] of Array.from(t.undefinedPrivateNames)) e ? e.undefinedPrivateNames.has(s) || e.undefinedPrivateNames.set(s, r) : this.parser.raise(u.InvalidPrivateFieldResolution, { at: r, identifierName: s });
            }
            declarePrivateName(t, e, s) {
              let { privateNames: r, loneAccessors: i, undefinedPrivateNames: a } = this.current(), n = r.has(t);
              if (e & rs) {
                let o = n && i.get(t);
                if (o) {
                  let c = o & ft, f = e & ft, y = o & rs, P = e & rs;
                  n = y === P || c !== f, n || i.delete(t);
                } else n || i.set(t, e);
              }
              n && this.parser.raise(u.PrivateNameRedeclaration, { at: s, identifierName: t }), r.add(t), a.delete(t);
            }
            usePrivateName(t, e) {
              let s;
              for (s of this.stack) if (s.privateNames.has(t)) return;
              s ? s.undefinedPrivateNames.set(t, e) : this.parser.raise(u.InvalidPrivateFieldResolution, { at: e, identifierName: t });
            }
          }, yh = 0, Nr = 1, ls = 2, Ir = 3, yt = class {
            constructor() {
              let t = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : yh;
              this.type = void 0, this.type = t;
            }
            canBeArrowParameterDeclaration() {
              return this.type === ls || this.type === Nr;
            }
            isCertainlyParameterDeclaration() {
              return this.type === Ir;
            }
          }, kr = class extends yt {
            constructor(t) {
              super(t), this.declarationErrors = /* @__PURE__ */ new Map();
            }
            recordDeclarationError(t, e) {
              let { at: s } = e, r = s.index;
              this.declarationErrors.set(r, [t, s]);
            }
            clearDeclarationError(t) {
              this.declarationErrors.delete(t);
            }
            iterateErrors(t) {
              this.declarationErrors.forEach(t);
            }
          }, xh = class {
            constructor(t) {
              this.parser = void 0, this.stack = [new yt()], this.parser = t;
            }
            enter(t) {
              this.stack.push(t);
            }
            exit() {
              this.stack.pop();
            }
            recordParameterInitializerError(t, e) {
              let { at: s } = e, r = { at: s.loc.start }, { stack: i } = this, a = i.length - 1, n = i[a];
              for (; !n.isCertainlyParameterDeclaration(); ) {
                if (n.canBeArrowParameterDeclaration()) n.recordDeclarationError(t, r);
                else return;
                n = i[--a];
              }
              this.parser.raise(t, r);
            }
            recordArrowParemeterBindingError(t, e) {
              let { at: s } = e, { stack: r } = this, i = r[r.length - 1], a = { at: s.loc.start };
              if (i.isCertainlyParameterDeclaration()) this.parser.raise(t, a);
              else if (i.canBeArrowParameterDeclaration()) i.recordDeclarationError(t, a);
              else return;
            }
            recordAsyncArrowParametersError(t) {
              let { at: e } = t, { stack: s } = this, r = s.length - 1, i = s[r];
              for (; i.canBeArrowParameterDeclaration(); ) i.type === ls && i.recordDeclarationError(u.AwaitBindingIdentifier, { at: e }), i = s[--r];
            }
            validateAsPattern() {
              let { stack: t } = this, e = t[t.length - 1];
              !e.canBeArrowParameterDeclaration() || e.iterateErrors((s) => {
                let [r, i] = s;
                this.parser.raise(r, { at: i });
                let a = t.length - 2, n = t[a];
                for (; n.canBeArrowParameterDeclaration(); ) n.clearDeclarationError(i.index), n = t[--a];
              });
            }
          };
          function gh() {
            return new yt(Ir);
          }
          function Ah() {
            return new kr(Nr);
          }
          function Ph() {
            return new kr(ls);
          }
          function Dr() {
            return new yt();
          }
          var je = 0, Fr = 1, xt = 2, Lr = 4, qe = 8, Th = class {
            constructor() {
              this.stacks = [];
            }
            enter(t) {
              this.stacks.push(t);
            }
            exit() {
              this.stacks.pop();
            }
            currentFlags() {
              return this.stacks[this.stacks.length - 1];
            }
            get hasAwait() {
              return (this.currentFlags() & xt) > 0;
            }
            get hasYield() {
              return (this.currentFlags() & Fr) > 0;
            }
            get hasReturn() {
              return (this.currentFlags() & Lr) > 0;
            }
            get hasIn() {
              return (this.currentFlags() & qe) > 0;
            }
          };
          function gt(t, e) {
            return (t ? xt : 0) | (e ? Fr : 0);
          }
          var Eh = class extends ch {
            addExtra(t, e, s) {
              let r = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true;
              if (!t) return;
              let i = t.extra = t.extra || {};
              r ? i[e] = s : Object.defineProperty(i, e, { enumerable: r, value: s });
            }
            isContextual(t) {
              return this.state.type === t && !this.state.containsEsc;
            }
            isUnparsedContextual(t, e) {
              let s = t + e.length;
              if (this.input.slice(t, s) === e) {
                let r = this.input.charCodeAt(s);
                return !(Be(r) || (r & 64512) === 55296);
              }
              return false;
            }
            isLookaheadContextual(t) {
              let e = this.nextTokenStart();
              return this.isUnparsedContextual(e, t);
            }
            eatContextual(t) {
              return this.isContextual(t) ? (this.next(), true) : false;
            }
            expectContextual(t, e) {
              if (!this.eatContextual(t)) throw e != null ? this.raise(e, { at: this.state.startLoc }) : this.unexpected(null, t);
            }
            canInsertSemicolon() {
              return this.match(135) || this.match(8) || this.hasPrecedingLineBreak();
            }
            hasPrecedingLineBreak() {
              return as.test(this.input.slice(this.state.lastTokEndLoc.index, this.state.start));
            }
            hasFollowingLineBreak() {
              return vr.lastIndex = this.state.end, vr.test(this.input);
            }
            isLineTerminator() {
              return this.eat(13) || this.canInsertSemicolon();
            }
            semicolon() {
              ((arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : true) ? this.isLineTerminator() : this.eat(13)) || this.raise(u.MissingSemicolon, { at: this.state.lastTokEndLoc });
            }
            expect(t, e) {
              this.eat(t) || this.unexpected(e, t);
            }
            tryParse(t) {
              let e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.state.clone(), s = { node: null };
              try {
                let r = t(function() {
                  let i = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null;
                  throw s.node = i, s;
                });
                if (this.state.errors.length > e.errors.length) {
                  let i = this.state;
                  return this.state = e, this.state.tokensLength = i.tokensLength, { node: r, error: i.errors[e.errors.length], thrown: false, aborted: false, failState: i };
                }
                return { node: r, error: null, thrown: false, aborted: false, failState: null };
              } catch (r) {
                let i = this.state;
                if (this.state = e, r instanceof SyntaxError) return { node: null, error: r, thrown: true, aborted: false, failState: i };
                if (r === s) return { node: s.node, error: null, thrown: false, aborted: true, failState: i };
                throw r;
              }
            }
            checkExpressionErrors(t, e) {
              if (!t) return false;
              let { shorthandAssignLoc: s, doubleProtoLoc: r, privateKeyLoc: i, optionalParametersLoc: a } = t, n = !!s || !!r || !!a || !!i;
              if (!e) return n;
              s != null && this.raise(u.InvalidCoverInitializedName, { at: s }), r != null && this.raise(u.DuplicateProto, { at: r }), i != null && this.raise(u.UnexpectedPrivateField, { at: i }), a != null && this.unexpected(a);
            }
            isLiteralPropertyName() {
              return hr(this.state.type);
            }
            isPrivateName(t) {
              return t.type === "PrivateName";
            }
            getPrivateNameSV(t) {
              return t.id.name;
            }
            hasPropertyAsPrivateName(t) {
              return (t.type === "MemberExpression" || t.type === "OptionalMemberExpression") && this.isPrivateName(t.property);
            }
            isOptionalChain(t) {
              return t.type === "OptionalMemberExpression" || t.type === "OptionalCallExpression";
            }
            isObjectProperty(t) {
              return t.type === "ObjectProperty";
            }
            isObjectMethod(t) {
              return t.type === "ObjectMethod";
            }
            initializeScopes() {
              let t = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.options.sourceType === "module", e = this.state.labels;
              this.state.labels = [];
              let s = this.exportedIdentifiers;
              this.exportedIdentifiers = /* @__PURE__ */ new Set();
              let r = this.inModule;
              this.inModule = t;
              let i = this.scope, a = this.getScopeHandler();
              this.scope = new a(this, t);
              let n = this.prodParam;
              this.prodParam = new Th();
              let o = this.classScope;
              this.classScope = new mh(this);
              let c = this.expressionScope;
              return this.expressionScope = new xh(this), () => {
                this.state.labels = e, this.exportedIdentifiers = s, this.inModule = r, this.scope = i, this.prodParam = n, this.classScope = o, this.expressionScope = c;
              };
            }
            enterInitialScopes() {
              let t = je;
              this.inModule && (t |= xt), this.scope.enter(We), this.prodParam.enter(t);
            }
            checkDestructuringPrivate(t) {
              let { privateKeyLoc: e } = t;
              e !== null && this.expectPlugin("destructuringPrivate", e);
            }
          }, At = class {
            constructor() {
              this.shorthandAssignLoc = null, this.doubleProtoLoc = null, this.privateKeyLoc = null, this.optionalParametersLoc = null;
            }
          }, Pt = class {
            constructor(t, e, s) {
              this.type = "", this.start = e, this.end = 0, this.loc = new d(s), t != null && t.options.ranges && (this.range = [e, 0]), t != null && t.filename && (this.loc.filename = t.filename);
            }
          }, us = Pt.prototype;
          us.__clone = function() {
            let t = new Pt(), e = Object.keys(this);
            for (let s = 0, r = e.length; s < r; s++) {
              let i = e[s];
              i !== "leadingComments" && i !== "trailingComments" && i !== "innerComments" && (t[i] = this[i]);
            }
            return t;
          };
          function Ch(t) {
            return ge(t);
          }
          function ge(t) {
            let { type: e, start: s, end: r, loc: i, range: a, extra: n, name: o } = t, c = Object.create(us);
            return c.type = e, c.start = s, c.end = r, c.loc = i, c.range = a, c.extra = n, c.name = o, e === "Placeholder" && (c.expectedNode = t.expectedNode), c;
          }
          function bh(t) {
            let { type: e, start: s, end: r, loc: i, range: a, extra: n } = t;
            if (e === "Placeholder") return Ch(t);
            let o = Object.create(us);
            return o.type = e, o.start = s, o.end = r, o.loc = i, o.range = a, t.raw !== void 0 ? o.raw = t.raw : o.extra = n, o.value = t.value, o;
          }
          var vh = class extends Eh {
            startNode() {
              return new Pt(this, this.state.start, this.state.startLoc);
            }
            startNodeAt(t, e) {
              return new Pt(this, t, e);
            }
            startNodeAtNode(t) {
              return this.startNodeAt(t.start, t.loc.start);
            }
            finishNode(t, e) {
              return this.finishNodeAt(t, e, this.state.lastTokEndLoc);
            }
            finishNodeAt(t, e, s) {
              return t.type = e, t.end = s.index, t.loc.end = s, this.options.ranges && (t.range[1] = s.index), this.options.attachComment && this.processComment(t), t;
            }
            resetStartLocation(t, e, s) {
              t.start = e, t.loc.start = s, this.options.ranges && (t.range[0] = e);
            }
            resetEndLocation(t) {
              let e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.state.lastTokEndLoc;
              t.end = e.index, t.loc.end = e, this.options.ranges && (t.range[1] = e.index);
            }
            resetStartLocationFromNode(t, e) {
              this.resetStartLocation(t, e.start, e.loc.start);
            }
          }, Sh = /* @__PURE__ */ new Set(["_", "any", "bool", "boolean", "empty", "extends", "false", "interface", "mixed", "null", "number", "static", "string", "true", "typeof", "void"]), I = j(zn || (zn = rt(["flow"])))((t) => ({ AmbiguousConditionalArrow: t("Ambiguous expression: wrap the arrow functions in parentheses to disambiguate."), AmbiguousDeclareModuleKind: t("Found both `declare module.exports` and `declare export` in the same module. Modules can only have 1 since they are either an ES module or they are a CommonJS module."), AssignReservedType: t((e) => {
            let { reservedType: s } = e;
            return "Cannot overwrite reserved type ".concat(s, ".");
          }), DeclareClassElement: t("The `declare` modifier can only appear on class fields."), DeclareClassFieldInitializer: t("Initializers are not allowed in fields with the `declare` modifier."), DuplicateDeclareModuleExports: t("Duplicate `declare module.exports` statement."), EnumBooleanMemberNotInitialized: t((e) => {
            let { memberName: s, enumName: r } = e;
            return "Boolean enum members need to be initialized. Use either `".concat(s, " = true,` or `").concat(s, " = false,` in enum `").concat(r, "`.");
          }), EnumDuplicateMemberName: t((e) => {
            let { memberName: s, enumName: r } = e;
            return "Enum member names need to be unique, but the name `".concat(s, "` has already been used before in enum `").concat(r, "`.");
          }), EnumInconsistentMemberValues: t((e) => {
            let { enumName: s } = e;
            return "Enum `".concat(s, "` has inconsistent member initializers. Either use no initializers, or consistently use literals (either booleans, numbers, or strings) for all member initializers.");
          }), EnumInvalidExplicitType: t((e) => {
            let { invalidEnumType: s, enumName: r } = e;
            return "Enum type `".concat(s, "` is not valid. Use one of `boolean`, `number`, `string`, or `symbol` in enum `").concat(r, "`.");
          }), EnumInvalidExplicitTypeUnknownSupplied: t((e) => {
            let { enumName: s } = e;
            return "Supplied enum type is not valid. Use one of `boolean`, `number`, `string`, or `symbol` in enum `".concat(s, "`.");
          }), EnumInvalidMemberInitializerPrimaryType: t((e) => {
            let { enumName: s, memberName: r, explicitType: i } = e;
            return "Enum `".concat(s, "` has type `").concat(i, "`, so the initializer of `").concat(r, "` needs to be a ").concat(i, " literal.");
          }), EnumInvalidMemberInitializerSymbolType: t((e) => {
            let { enumName: s, memberName: r } = e;
            return "Symbol enum members cannot be initialized. Use `".concat(r, ",` in enum `").concat(s, "`.");
          }), EnumInvalidMemberInitializerUnknownType: t((e) => {
            let { enumName: s, memberName: r } = e;
            return "The enum member initializer for `".concat(r, "` needs to be a literal (either a boolean, number, or string) in enum `").concat(s, "`.");
          }), EnumInvalidMemberName: t((e) => {
            let { enumName: s, memberName: r, suggestion: i } = e;
            return "Enum member names cannot start with lowercase 'a' through 'z'. Instead of using `".concat(r, "`, consider using `").concat(i, "`, in enum `").concat(s, "`.");
          }), EnumNumberMemberNotInitialized: t((e) => {
            let { enumName: s, memberName: r } = e;
            return "Number enum members need to be initialized, e.g. `".concat(r, " = 1` in enum `").concat(s, "`.");
          }), EnumStringMemberInconsistentlyInitailized: t((e) => {
            let { enumName: s } = e;
            return "String enum members need to consistently either all use initializers, or use no initializers, in enum `".concat(s, "`.");
          }), GetterMayNotHaveThisParam: t("A getter cannot have a `this` parameter."), ImportTypeShorthandOnlyInPureImport: t("The `type` and `typeof` keywords on named imports can only be used on regular `import` statements. It cannot be used with `import type` or `import typeof` statements."), InexactInsideExact: t("Explicit inexact syntax cannot appear inside an explicit exact object type."), InexactInsideNonObject: t("Explicit inexact syntax cannot appear in class or interface definitions."), InexactVariance: t("Explicit inexact syntax cannot have variance."), InvalidNonTypeImportInDeclareModule: t("Imports within a `declare module` body must always be `import type` or `import typeof`."), MissingTypeParamDefault: t("Type parameter declaration needs a default, since a preceding type parameter declaration has a default."), NestedDeclareModule: t("`declare module` cannot be used inside another `declare module`."), NestedFlowComment: t("Cannot have a flow comment inside another flow comment."), PatternIsOptional: t("A binding pattern parameter cannot be optional in an implementation signature.", { reasonCode: "OptionalBindingPattern" }), SetterMayNotHaveThisParam: t("A setter cannot have a `this` parameter."), SpreadVariance: t("Spread properties cannot have variance."), ThisParamAnnotationRequired: t("A type annotation is required for the `this` parameter."), ThisParamBannedInConstructor: t("Constructors cannot have a `this` parameter; constructors don't bind `this` like other functions."), ThisParamMayNotBeOptional: t("The `this` parameter cannot be optional."), ThisParamMustBeFirst: t("The `this` parameter must be the first function parameter."), ThisParamNoDefault: t("The `this` parameter may not have a default value."), TypeBeforeInitializer: t("Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`."), TypeCastInPattern: t("The type cast expression is expected to be wrapped with parenthesis."), UnexpectedExplicitInexactInObject: t("Explicit inexact syntax must appear at the end of an inexact object."), UnexpectedReservedType: t((e) => {
            let { reservedType: s } = e;
            return "Unexpected reserved type ".concat(s, ".");
          }), UnexpectedReservedUnderscore: t("`_` is only allowed as a type argument to call or new."), UnexpectedSpaceBetweenModuloChecks: t("Spaces between `%` and `checks` are not allowed here."), UnexpectedSpreadType: t("Spread operator cannot appear in class or interface definitions."), UnexpectedSubtractionOperand: t('Unexpected token, expected "number" or "bigint".'), UnexpectedTokenAfterTypeParameter: t("Expected an arrow function after this type parameter declaration."), UnexpectedTypeParameterBeforeAsyncArrowFunction: t("Type parameters must come after the async keyword, e.g. instead of `<T> async () => {}`, use `async <T>() => {}`."), UnsupportedDeclareExportKind: t((e) => {
            let { unsupportedExportKind: s, suggestion: r } = e;
            return "`declare export ".concat(s, "` is not supported. Use `").concat(r, "` instead.");
          }), UnsupportedStatementInDeclareModule: t("Only declares and type imports are allowed inside declare module."), UnterminatedFlowComment: t("Unterminated flow-comment.") }));
          function wh(t) {
            return t.type === "DeclareExportAllDeclaration" || t.type === "DeclareExportDeclaration" && (!t.declaration || t.declaration.type !== "TypeAlias" && t.declaration.type !== "InterfaceDeclaration");
          }
          function cs(t) {
            return t.importKind === "type" || t.importKind === "typeof";
          }
          function Or(t) {
            return pe(t) && t !== 97;
          }
          var Nh = { const: "declare export var", let: "declare export var", type: "export type", interface: "export interface" };
          function Ih(t, e) {
            let s = [], r = [];
            for (let i = 0; i < t.length; i++) (e(t[i], i, t) ? s : r).push(t[i]);
            return [s, r];
          }
          var kh = /\*?\s*@((?:no)?flow)\b/, Dh = (t) => class extends t {
            constructor() {
              super(...arguments), this.flowPragma = void 0;
            }
            getScopeHandler() {
              return fh;
            }
            shouldParseTypes() {
              return this.getPluginOption("flow", "all") || this.flowPragma === "flow";
            }
            shouldParseEnums() {
              return !!this.getPluginOption("flow", "enums");
            }
            finishToken(e, s) {
              return e !== 129 && e !== 13 && e !== 28 && this.flowPragma === void 0 && (this.flowPragma = null), super.finishToken(e, s);
            }
            addComment(e) {
              if (this.flowPragma === void 0) {
                let s = kh.exec(e.value);
                if (s) if (s[1] === "flow") this.flowPragma = "flow";
                else if (s[1] === "noflow") this.flowPragma = "noflow";
                else throw new Error("Unexpected flow pragma");
              }
              return super.addComment(e);
            }
            flowParseTypeInitialiser(e) {
              let s = this.state.inType;
              this.state.inType = true, this.expect(e || 14);
              let r = this.flowParseType();
              return this.state.inType = s, r;
            }
            flowParsePredicate() {
              let e = this.startNode(), s = this.state.startLoc;
              return this.next(), this.expectContextual(107), this.state.lastTokStart > s.index + 1 && this.raise(I.UnexpectedSpaceBetweenModuloChecks, { at: s }), this.eat(10) ? (e.value = this.parseExpression(), this.expect(11), this.finishNode(e, "DeclaredPredicate")) : this.finishNode(e, "InferredPredicate");
            }
            flowParseTypeAndPredicateInitialiser() {
              let e = this.state.inType;
              this.state.inType = true, this.expect(14);
              let s = null, r = null;
              return this.match(54) ? (this.state.inType = e, r = this.flowParsePredicate()) : (s = this.flowParseType(), this.state.inType = e, this.match(54) && (r = this.flowParsePredicate())), [s, r];
            }
            flowParseDeclareClass(e) {
              return this.next(), this.flowParseInterfaceish(e, true), this.finishNode(e, "DeclareClass");
            }
            flowParseDeclareFunction(e) {
              this.next();
              let s = e.id = this.parseIdentifier(), r = this.startNode(), i = this.startNode();
              this.match(47) ? r.typeParameters = this.flowParseTypeParameterDeclaration() : r.typeParameters = null, this.expect(10);
              let a = this.flowParseFunctionTypeParams();
              return r.params = a.params, r.rest = a.rest, r.this = a._this, this.expect(11), [r.returnType, e.predicate] = this.flowParseTypeAndPredicateInitialiser(), i.typeAnnotation = this.finishNode(r, "FunctionTypeAnnotation"), s.typeAnnotation = this.finishNode(i, "TypeAnnotation"), this.resetEndLocation(s), this.semicolon(), this.scope.declareName(e.id.name, $o, e.id.loc.start), this.finishNode(e, "DeclareFunction");
            }
            flowParseDeclare(e, s) {
              if (this.match(80)) return this.flowParseDeclareClass(e);
              if (this.match(68)) return this.flowParseDeclareFunction(e);
              if (this.match(74)) return this.flowParseDeclareVariable(e);
              if (this.eatContextual(123)) return this.match(16) ? this.flowParseDeclareModuleExports(e) : (s && this.raise(I.NestedDeclareModule, { at: this.state.lastTokStartLoc }), this.flowParseDeclareModule(e));
              if (this.isContextual(126)) return this.flowParseDeclareTypeAlias(e);
              if (this.isContextual(127)) return this.flowParseDeclareOpaqueType(e);
              if (this.isContextual(125)) return this.flowParseDeclareInterface(e);
              if (this.match(82)) return this.flowParseDeclareExportDeclaration(e, s);
              throw this.unexpected();
            }
            flowParseDeclareVariable(e) {
              return this.next(), e.id = this.flowParseTypeAnnotatableIdentifier(true), this.scope.declareName(e.id.name, pt, e.id.loc.start), this.semicolon(), this.finishNode(e, "DeclareVariable");
            }
            flowParseDeclareModule(e) {
              this.scope.enter(Me), this.match(129) ? e.id = this.parseExprAtom() : e.id = this.parseIdentifier();
              let s = e.body = this.startNode(), r = s.body = [];
              for (this.expect(5); !this.match(8); ) {
                let n = this.startNode();
                this.match(83) ? (this.next(), !this.isContextual(126) && !this.match(87) && this.raise(I.InvalidNonTypeImportInDeclareModule, { at: this.state.lastTokStartLoc }), this.parseImport(n)) : (this.expectContextual(121, I.UnsupportedStatementInDeclareModule), n = this.flowParseDeclare(n, true)), r.push(n);
              }
              this.scope.exit(), this.expect(8), this.finishNode(s, "BlockStatement");
              let i = null, a = false;
              return r.forEach((n) => {
                wh(n) ? (i === "CommonJS" && this.raise(I.AmbiguousDeclareModuleKind, { at: n }), i = "ES") : n.type === "DeclareModuleExports" && (a && this.raise(I.DuplicateDeclareModuleExports, { at: n }), i === "ES" && this.raise(I.AmbiguousDeclareModuleKind, { at: n }), i = "CommonJS", a = true);
              }), e.kind = i || "CommonJS", this.finishNode(e, "DeclareModule");
            }
            flowParseDeclareExportDeclaration(e, s) {
              if (this.expect(82), this.eat(65)) return this.match(68) || this.match(80) ? e.declaration = this.flowParseDeclare(this.startNode()) : (e.declaration = this.flowParseType(), this.semicolon()), e.default = true, this.finishNode(e, "DeclareExportDeclaration");
              if (this.match(75) || this.isLet() || (this.isContextual(126) || this.isContextual(125)) && !s) {
                let r = this.state.value;
                throw this.raise(I.UnsupportedDeclareExportKind, { at: this.state.startLoc, unsupportedExportKind: r, suggestion: Nh[r] });
              }
              if (this.match(74) || this.match(68) || this.match(80) || this.isContextual(127)) return e.declaration = this.flowParseDeclare(this.startNode()), e.default = false, this.finishNode(e, "DeclareExportDeclaration");
              if (this.match(55) || this.match(5) || this.isContextual(125) || this.isContextual(126) || this.isContextual(127)) return e = this.parseExport(e), e.type === "ExportNamedDeclaration" && (e.type = "ExportDeclaration", e.default = false, delete e.exportKind), e.type = "Declare" + e.type, e;
              throw this.unexpected();
            }
            flowParseDeclareModuleExports(e) {
              return this.next(), this.expectContextual(108), e.typeAnnotation = this.flowParseTypeAnnotation(), this.semicolon(), this.finishNode(e, "DeclareModuleExports");
            }
            flowParseDeclareTypeAlias(e) {
              return this.next(), this.flowParseTypeAlias(e), e.type = "DeclareTypeAlias", e;
            }
            flowParseDeclareOpaqueType(e) {
              return this.next(), this.flowParseOpaqueType(e, true), e.type = "DeclareOpaqueType", e;
            }
            flowParseDeclareInterface(e) {
              return this.next(), this.flowParseInterfaceish(e), this.finishNode(e, "DeclareInterface");
            }
            flowParseInterfaceish(e) {
              let s = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              if (e.id = this.flowParseRestrictedIdentifier(!s, true), this.scope.declareName(e.id.name, s ? Tr : xe, e.id.loc.start), this.match(47) ? e.typeParameters = this.flowParseTypeParameterDeclaration() : e.typeParameters = null, e.extends = [], e.implements = [], e.mixins = [], this.eat(81)) do
                e.extends.push(this.flowParseInterfaceExtends());
              while (!s && this.eat(12));
              if (this.isContextual(114)) {
                this.next();
                do
                  e.mixins.push(this.flowParseInterfaceExtends());
                while (this.eat(12));
              }
              if (this.isContextual(110)) {
                this.next();
                do
                  e.implements.push(this.flowParseInterfaceExtends());
                while (this.eat(12));
              }
              e.body = this.flowParseObjectType({ allowStatic: s, allowExact: false, allowSpread: false, allowProto: s, allowInexact: false });
            }
            flowParseInterfaceExtends() {
              let e = this.startNode();
              return e.id = this.flowParseQualifiedTypeIdentifier(), this.match(47) ? e.typeParameters = this.flowParseTypeParameterInstantiation() : e.typeParameters = null, this.finishNode(e, "InterfaceExtends");
            }
            flowParseInterface(e) {
              return this.flowParseInterfaceish(e), this.finishNode(e, "InterfaceDeclaration");
            }
            checkNotUnderscore(e) {
              e === "_" && this.raise(I.UnexpectedReservedUnderscore, { at: this.state.startLoc });
            }
            checkReservedType(e, s, r) {
              !Sh.has(e) || this.raise(r ? I.AssignReservedType : I.UnexpectedReservedType, { at: s, reservedType: e });
            }
            flowParseRestrictedIdentifier(e, s) {
              return this.checkReservedType(this.state.value, this.state.startLoc, s), this.parseIdentifier(e);
            }
            flowParseTypeAlias(e) {
              return e.id = this.flowParseRestrictedIdentifier(false, true), this.scope.declareName(e.id.name, xe, e.id.loc.start), this.match(47) ? e.typeParameters = this.flowParseTypeParameterDeclaration() : e.typeParameters = null, e.right = this.flowParseTypeInitialiser(29), this.semicolon(), this.finishNode(e, "TypeAlias");
            }
            flowParseOpaqueType(e, s) {
              return this.expectContextual(126), e.id = this.flowParseRestrictedIdentifier(true, true), this.scope.declareName(e.id.name, xe, e.id.loc.start), this.match(47) ? e.typeParameters = this.flowParseTypeParameterDeclaration() : e.typeParameters = null, e.supertype = null, this.match(14) && (e.supertype = this.flowParseTypeInitialiser(14)), e.impltype = null, s || (e.impltype = this.flowParseTypeInitialiser(29)), this.semicolon(), this.finishNode(e, "OpaqueType");
            }
            flowParseTypeParameter() {
              let e = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, s = this.state.startLoc, r = this.startNode(), i = this.flowParseVariance(), a = this.flowParseTypeAnnotatableIdentifier();
              return r.name = a.name, r.variance = i, r.bound = a.typeAnnotation, this.match(29) ? (this.eat(29), r.default = this.flowParseType()) : e && this.raise(I.MissingTypeParamDefault, { at: s }), this.finishNode(r, "TypeParameter");
            }
            flowParseTypeParameterDeclaration() {
              let e = this.state.inType, s = this.startNode();
              s.params = [], this.state.inType = true, this.match(47) || this.match(138) ? this.next() : this.unexpected();
              let r = false;
              do {
                let i = this.flowParseTypeParameter(r);
                s.params.push(i), i.default && (r = true), this.match(48) || this.expect(12);
              } while (!this.match(48));
              return this.expect(48), this.state.inType = e, this.finishNode(s, "TypeParameterDeclaration");
            }
            flowParseTypeParameterInstantiation() {
              let e = this.startNode(), s = this.state.inType;
              e.params = [], this.state.inType = true, this.expect(47);
              let r = this.state.noAnonFunctionType;
              for (this.state.noAnonFunctionType = false; !this.match(48); ) e.params.push(this.flowParseType()), this.match(48) || this.expect(12);
              return this.state.noAnonFunctionType = r, this.expect(48), this.state.inType = s, this.finishNode(e, "TypeParameterInstantiation");
            }
            flowParseTypeParameterInstantiationCallOrNew() {
              let e = this.startNode(), s = this.state.inType;
              for (e.params = [], this.state.inType = true, this.expect(47); !this.match(48); ) e.params.push(this.flowParseTypeOrImplicitInstantiation()), this.match(48) || this.expect(12);
              return this.expect(48), this.state.inType = s, this.finishNode(e, "TypeParameterInstantiation");
            }
            flowParseInterfaceType() {
              let e = this.startNode();
              if (this.expectContextual(125), e.extends = [], this.eat(81)) do
                e.extends.push(this.flowParseInterfaceExtends());
              while (this.eat(12));
              return e.body = this.flowParseObjectType({ allowStatic: false, allowExact: false, allowSpread: false, allowProto: false, allowInexact: false }), this.finishNode(e, "InterfaceTypeAnnotation");
            }
            flowParseObjectPropertyKey() {
              return this.match(130) || this.match(129) ? this.parseExprAtom() : this.parseIdentifier(true);
            }
            flowParseObjectTypeIndexer(e, s, r) {
              return e.static = s, this.lookahead().type === 14 ? (e.id = this.flowParseObjectPropertyKey(), e.key = this.flowParseTypeInitialiser()) : (e.id = null, e.key = this.flowParseType()), this.expect(3), e.value = this.flowParseTypeInitialiser(), e.variance = r, this.finishNode(e, "ObjectTypeIndexer");
            }
            flowParseObjectTypeInternalSlot(e, s) {
              return e.static = s, e.id = this.flowParseObjectPropertyKey(), this.expect(3), this.expect(3), this.match(47) || this.match(10) ? (e.method = true, e.optional = false, e.value = this.flowParseObjectTypeMethodish(this.startNodeAt(e.start, e.loc.start))) : (e.method = false, this.eat(17) && (e.optional = true), e.value = this.flowParseTypeInitialiser()), this.finishNode(e, "ObjectTypeInternalSlot");
            }
            flowParseObjectTypeMethodish(e) {
              for (e.params = [], e.rest = null, e.typeParameters = null, e.this = null, this.match(47) && (e.typeParameters = this.flowParseTypeParameterDeclaration()), this.expect(10), this.match(78) && (e.this = this.flowParseFunctionTypeParam(true), e.this.name = null, this.match(11) || this.expect(12)); !this.match(11) && !this.match(21); ) e.params.push(this.flowParseFunctionTypeParam(false)), this.match(11) || this.expect(12);
              return this.eat(21) && (e.rest = this.flowParseFunctionTypeParam(false)), this.expect(11), e.returnType = this.flowParseTypeInitialiser(), this.finishNode(e, "FunctionTypeAnnotation");
            }
            flowParseObjectTypeCallProperty(e, s) {
              let r = this.startNode();
              return e.static = s, e.value = this.flowParseObjectTypeMethodish(r), this.finishNode(e, "ObjectTypeCallProperty");
            }
            flowParseObjectType(e) {
              let { allowStatic: s, allowExact: r, allowSpread: i, allowProto: a, allowInexact: n } = e, o = this.state.inType;
              this.state.inType = true;
              let c = this.startNode();
              c.callProperties = [], c.properties = [], c.indexers = [], c.internalSlots = [];
              let f, y, P = false;
              for (r && this.match(6) ? (this.expect(6), f = 9, y = true) : (this.expect(5), f = 8, y = false), c.exact = y; !this.match(f); ) {
                let N = false, B = null, _ = null, Q = this.startNode();
                if (a && this.isContextual(115)) {
                  let ne = this.lookahead();
                  ne.type !== 14 && ne.type !== 17 && (this.next(), B = this.state.startLoc, s = false);
                }
                if (s && this.isContextual(104)) {
                  let ne = this.lookahead();
                  ne.type !== 14 && ne.type !== 17 && (this.next(), N = true);
                }
                let re = this.flowParseVariance();
                if (this.eat(0)) B != null && this.unexpected(B), this.eat(0) ? (re && this.unexpected(re.loc.start), c.internalSlots.push(this.flowParseObjectTypeInternalSlot(Q, N))) : c.indexers.push(this.flowParseObjectTypeIndexer(Q, N, re));
                else if (this.match(10) || this.match(47)) B != null && this.unexpected(B), re && this.unexpected(re.loc.start), c.callProperties.push(this.flowParseObjectTypeCallProperty(Q, N));
                else {
                  let ne = "init";
                  if (this.isContextual(98) || this.isContextual(103)) {
                    let le = this.lookahead();
                    hr(le.type) && (ne = this.state.value, this.next());
                  }
                  let $e = this.flowParseObjectTypeProperty(Q, N, B, re, ne, i, n != null ? n : !y);
                  $e === null ? (P = true, _ = this.state.lastTokStartLoc) : c.properties.push($e);
                }
                this.flowObjectTypeSemicolon(), _ && !this.match(8) && !this.match(9) && this.raise(I.UnexpectedExplicitInexactInObject, { at: _ });
              }
              this.expect(f), i && (c.inexact = P);
              let v = this.finishNode(c, "ObjectTypeAnnotation");
              return this.state.inType = o, v;
            }
            flowParseObjectTypeProperty(e, s, r, i, a, n, o) {
              if (this.eat(21)) return this.match(12) || this.match(13) || this.match(8) || this.match(9) ? (n ? o || this.raise(I.InexactInsideExact, { at: this.state.lastTokStartLoc }) : this.raise(I.InexactInsideNonObject, { at: this.state.lastTokStartLoc }), i && this.raise(I.InexactVariance, { at: i }), null) : (n || this.raise(I.UnexpectedSpreadType, { at: this.state.lastTokStartLoc }), r != null && this.unexpected(r), i && this.raise(I.SpreadVariance, { at: i }), e.argument = this.flowParseType(), this.finishNode(e, "ObjectTypeSpreadProperty"));
              {
                e.key = this.flowParseObjectPropertyKey(), e.static = s, e.proto = r != null, e.kind = a;
                let c = false;
                return this.match(47) || this.match(10) ? (e.method = true, r != null && this.unexpected(r), i && this.unexpected(i.loc.start), e.value = this.flowParseObjectTypeMethodish(this.startNodeAt(e.start, e.loc.start)), (a === "get" || a === "set") && this.flowCheckGetterSetterParams(e), !n && e.key.name === "constructor" && e.value.this && this.raise(I.ThisParamBannedInConstructor, { at: e.value.this })) : (a !== "init" && this.unexpected(), e.method = false, this.eat(17) && (c = true), e.value = this.flowParseTypeInitialiser(), e.variance = i), e.optional = c, this.finishNode(e, "ObjectTypeProperty");
              }
            }
            flowCheckGetterSetterParams(e) {
              let s = e.kind === "get" ? 0 : 1, r = e.value.params.length + (e.value.rest ? 1 : 0);
              e.value.this && this.raise(e.kind === "get" ? I.GetterMayNotHaveThisParam : I.SetterMayNotHaveThisParam, { at: e.value.this }), r !== s && this.raise(e.kind === "get" ? u.BadGetterArity : u.BadSetterArity, { at: e }), e.kind === "set" && e.value.rest && this.raise(u.BadSetterRestParameter, { at: e });
            }
            flowObjectTypeSemicolon() {
              !this.eat(13) && !this.eat(12) && !this.match(8) && !this.match(9) && this.unexpected();
            }
            flowParseQualifiedTypeIdentifier(e, s, r) {
              e = e || this.state.start, s = s || this.state.startLoc;
              let i = r || this.flowParseRestrictedIdentifier(true);
              for (; this.eat(16); ) {
                let a = this.startNodeAt(e, s);
                a.qualification = i, a.id = this.flowParseRestrictedIdentifier(true), i = this.finishNode(a, "QualifiedTypeIdentifier");
              }
              return i;
            }
            flowParseGenericType(e, s, r) {
              let i = this.startNodeAt(e, s);
              return i.typeParameters = null, i.id = this.flowParseQualifiedTypeIdentifier(e, s, r), this.match(47) && (i.typeParameters = this.flowParseTypeParameterInstantiation()), this.finishNode(i, "GenericTypeAnnotation");
            }
            flowParseTypeofType() {
              let e = this.startNode();
              return this.expect(87), e.argument = this.flowParsePrimaryType(), this.finishNode(e, "TypeofTypeAnnotation");
            }
            flowParseTupleType() {
              let e = this.startNode();
              for (e.types = [], this.expect(0); this.state.pos < this.length && !this.match(3) && (e.types.push(this.flowParseType()), !this.match(3)); ) this.expect(12);
              return this.expect(3), this.finishNode(e, "TupleTypeAnnotation");
            }
            flowParseFunctionTypeParam(e) {
              let s = null, r = false, i = null, a = this.startNode(), n = this.lookahead(), o = this.state.type === 78;
              return n.type === 14 || n.type === 17 ? (o && !e && this.raise(I.ThisParamMustBeFirst, { at: a }), s = this.parseIdentifier(o), this.eat(17) && (r = true, o && this.raise(I.ThisParamMayNotBeOptional, { at: a })), i = this.flowParseTypeInitialiser()) : i = this.flowParseType(), a.name = s, a.optional = r, a.typeAnnotation = i, this.finishNode(a, "FunctionTypeParam");
            }
            reinterpretTypeAsFunctionTypeParam(e) {
              let s = this.startNodeAt(e.start, e.loc.start);
              return s.name = null, s.optional = false, s.typeAnnotation = e, this.finishNode(s, "FunctionTypeParam");
            }
            flowParseFunctionTypeParams() {
              let e = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : [], s = null, r = null;
              for (this.match(78) && (r = this.flowParseFunctionTypeParam(true), r.name = null, this.match(11) || this.expect(12)); !this.match(11) && !this.match(21); ) e.push(this.flowParseFunctionTypeParam(false)), this.match(11) || this.expect(12);
              return this.eat(21) && (s = this.flowParseFunctionTypeParam(false)), { params: e, rest: s, _this: r };
            }
            flowIdentToTypeAnnotation(e, s, r, i) {
              switch (i.name) {
                case "any":
                  return this.finishNode(r, "AnyTypeAnnotation");
                case "bool":
                case "boolean":
                  return this.finishNode(r, "BooleanTypeAnnotation");
                case "mixed":
                  return this.finishNode(r, "MixedTypeAnnotation");
                case "empty":
                  return this.finishNode(r, "EmptyTypeAnnotation");
                case "number":
                  return this.finishNode(r, "NumberTypeAnnotation");
                case "string":
                  return this.finishNode(r, "StringTypeAnnotation");
                case "symbol":
                  return this.finishNode(r, "SymbolTypeAnnotation");
                default:
                  return this.checkNotUnderscore(i.name), this.flowParseGenericType(e, s, i);
              }
            }
            flowParsePrimaryType() {
              let e = this.state.start, s = this.state.startLoc, r = this.startNode(), i, a, n = false, o = this.state.noAnonFunctionType;
              switch (this.state.type) {
                case 5:
                  return this.flowParseObjectType({ allowStatic: false, allowExact: false, allowSpread: true, allowProto: false, allowInexact: true });
                case 6:
                  return this.flowParseObjectType({ allowStatic: false, allowExact: true, allowSpread: true, allowProto: false, allowInexact: false });
                case 0:
                  return this.state.noAnonFunctionType = false, a = this.flowParseTupleType(), this.state.noAnonFunctionType = o, a;
                case 47:
                  return r.typeParameters = this.flowParseTypeParameterDeclaration(), this.expect(10), i = this.flowParseFunctionTypeParams(), r.params = i.params, r.rest = i.rest, r.this = i._this, this.expect(11), this.expect(19), r.returnType = this.flowParseType(), this.finishNode(r, "FunctionTypeAnnotation");
                case 10:
                  if (this.next(), !this.match(11) && !this.match(21)) if (K(this.state.type) || this.match(78)) {
                    let c = this.lookahead().type;
                    n = c !== 17 && c !== 14;
                  } else n = true;
                  if (n) {
                    if (this.state.noAnonFunctionType = false, a = this.flowParseType(), this.state.noAnonFunctionType = o, this.state.noAnonFunctionType || !(this.match(12) || this.match(11) && this.lookahead().type === 19)) return this.expect(11), a;
                    this.eat(12);
                  }
                  return a ? i = this.flowParseFunctionTypeParams([this.reinterpretTypeAsFunctionTypeParam(a)]) : i = this.flowParseFunctionTypeParams(), r.params = i.params, r.rest = i.rest, r.this = i._this, this.expect(11), this.expect(19), r.returnType = this.flowParseType(), r.typeParameters = null, this.finishNode(r, "FunctionTypeAnnotation");
                case 129:
                  return this.parseLiteral(this.state.value, "StringLiteralTypeAnnotation");
                case 85:
                case 86:
                  return r.value = this.match(85), this.next(), this.finishNode(r, "BooleanLiteralTypeAnnotation");
                case 53:
                  if (this.state.value === "-") {
                    if (this.next(), this.match(130)) return this.parseLiteralAtNode(-this.state.value, "NumberLiteralTypeAnnotation", r);
                    if (this.match(131)) return this.parseLiteralAtNode(-this.state.value, "BigIntLiteralTypeAnnotation", r);
                    throw this.raise(I.UnexpectedSubtractionOperand, { at: this.state.startLoc });
                  }
                  throw this.unexpected();
                case 130:
                  return this.parseLiteral(this.state.value, "NumberLiteralTypeAnnotation");
                case 131:
                  return this.parseLiteral(this.state.value, "BigIntLiteralTypeAnnotation");
                case 88:
                  return this.next(), this.finishNode(r, "VoidTypeAnnotation");
                case 84:
                  return this.next(), this.finishNode(r, "NullLiteralTypeAnnotation");
                case 78:
                  return this.next(), this.finishNode(r, "ThisTypeAnnotation");
                case 55:
                  return this.next(), this.finishNode(r, "ExistsTypeAnnotation");
                case 87:
                  return this.flowParseTypeofType();
                default:
                  if (Ht(this.state.type)) {
                    let c = Pe(this.state.type);
                    return this.next(), super.createIdentifier(r, c);
                  } else if (K(this.state.type)) return this.isContextual(125) ? this.flowParseInterfaceType() : this.flowIdentToTypeAnnotation(e, s, r, this.parseIdentifier());
              }
              throw this.unexpected();
            }
            flowParsePostfixType() {
              let e = this.state.start, s = this.state.startLoc, r = this.flowParsePrimaryType(), i = false;
              for (; (this.match(0) || this.match(18)) && !this.canInsertSemicolon(); ) {
                let a = this.startNodeAt(e, s), n = this.eat(18);
                i = i || n, this.expect(0), !n && this.match(3) ? (a.elementType = r, this.next(), r = this.finishNode(a, "ArrayTypeAnnotation")) : (a.objectType = r, a.indexType = this.flowParseType(), this.expect(3), i ? (a.optional = n, r = this.finishNode(a, "OptionalIndexedAccessType")) : r = this.finishNode(a, "IndexedAccessType"));
              }
              return r;
            }
            flowParsePrefixType() {
              let e = this.startNode();
              return this.eat(17) ? (e.typeAnnotation = this.flowParsePrefixType(), this.finishNode(e, "NullableTypeAnnotation")) : this.flowParsePostfixType();
            }
            flowParseAnonFunctionWithoutParens() {
              let e = this.flowParsePrefixType();
              if (!this.state.noAnonFunctionType && this.eat(19)) {
                let s = this.startNodeAt(e.start, e.loc.start);
                return s.params = [this.reinterpretTypeAsFunctionTypeParam(e)], s.rest = null, s.this = null, s.returnType = this.flowParseType(), s.typeParameters = null, this.finishNode(s, "FunctionTypeAnnotation");
              }
              return e;
            }
            flowParseIntersectionType() {
              let e = this.startNode();
              this.eat(45);
              let s = this.flowParseAnonFunctionWithoutParens();
              for (e.types = [s]; this.eat(45); ) e.types.push(this.flowParseAnonFunctionWithoutParens());
              return e.types.length === 1 ? s : this.finishNode(e, "IntersectionTypeAnnotation");
            }
            flowParseUnionType() {
              let e = this.startNode();
              this.eat(43);
              let s = this.flowParseIntersectionType();
              for (e.types = [s]; this.eat(43); ) e.types.push(this.flowParseIntersectionType());
              return e.types.length === 1 ? s : this.finishNode(e, "UnionTypeAnnotation");
            }
            flowParseType() {
              let e = this.state.inType;
              this.state.inType = true;
              let s = this.flowParseUnionType();
              return this.state.inType = e, s;
            }
            flowParseTypeOrImplicitInstantiation() {
              if (this.state.type === 128 && this.state.value === "_") {
                let e = this.state.start, s = this.state.startLoc, r = this.parseIdentifier();
                return this.flowParseGenericType(e, s, r);
              } else return this.flowParseType();
            }
            flowParseTypeAnnotation() {
              let e = this.startNode();
              return e.typeAnnotation = this.flowParseTypeInitialiser(), this.finishNode(e, "TypeAnnotation");
            }
            flowParseTypeAnnotatableIdentifier(e) {
              let s = e ? this.parseIdentifier() : this.flowParseRestrictedIdentifier();
              return this.match(14) && (s.typeAnnotation = this.flowParseTypeAnnotation(), this.resetEndLocation(s)), s;
            }
            typeCastToParameter(e) {
              return e.expression.typeAnnotation = e.typeAnnotation, this.resetEndLocation(e.expression, e.typeAnnotation.loc.end), e.expression;
            }
            flowParseVariance() {
              let e = null;
              return this.match(53) && (e = this.startNode(), this.state.value === "+" ? e.kind = "plus" : e.kind = "minus", this.next(), this.finishNode(e, "Variance")), e;
            }
            parseFunctionBody(e, s) {
              let r = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
              return s ? this.forwardNoArrowParamsConversionAt(e, () => super.parseFunctionBody(e, true, r)) : super.parseFunctionBody(e, false, r);
            }
            parseFunctionBodyAndFinish(e, s) {
              let r = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
              if (this.match(14)) {
                let i = this.startNode();
                [i.typeAnnotation, e.predicate] = this.flowParseTypeAndPredicateInitialiser(), e.returnType = i.typeAnnotation ? this.finishNode(i, "TypeAnnotation") : null;
              }
              super.parseFunctionBodyAndFinish(e, s, r);
            }
            parseStatement(e, s) {
              if (this.state.strict && this.isContextual(125)) {
                let i = this.lookahead();
                if (pe(i.type)) {
                  let a = this.startNode();
                  return this.next(), this.flowParseInterface(a);
                }
              } else if (this.shouldParseEnums() && this.isContextual(122)) {
                let i = this.startNode();
                return this.next(), this.flowParseEnumDeclaration(i);
              }
              let r = super.parseStatement(e, s);
              return this.flowPragma === void 0 && !this.isValidDirective(r) && (this.flowPragma = null), r;
            }
            parseExpressionStatement(e, s) {
              if (s.type === "Identifier") {
                if (s.name === "declare") {
                  if (this.match(80) || K(this.state.type) || this.match(68) || this.match(74) || this.match(82)) return this.flowParseDeclare(e);
                } else if (K(this.state.type)) {
                  if (s.name === "interface") return this.flowParseInterface(e);
                  if (s.name === "type") return this.flowParseTypeAlias(e);
                  if (s.name === "opaque") return this.flowParseOpaqueType(e, false);
                }
              }
              return super.parseExpressionStatement(e, s);
            }
            shouldParseExportDeclaration() {
              let { type: e } = this.state;
              return lr(e) || this.shouldParseEnums() && e === 122 ? !this.state.containsEsc : super.shouldParseExportDeclaration();
            }
            isExportDefaultSpecifier() {
              let { type: e } = this.state;
              return lr(e) || this.shouldParseEnums() && e === 122 ? this.state.containsEsc : super.isExportDefaultSpecifier();
            }
            parseExportDefaultExpression() {
              if (this.shouldParseEnums() && this.isContextual(122)) {
                let e = this.startNode();
                return this.next(), this.flowParseEnumDeclaration(e);
              }
              return super.parseExportDefaultExpression();
            }
            parseConditional(e, s, r, i) {
              if (!this.match(17)) return e;
              if (this.state.maybeInArrowParameters) {
                let v = this.lookaheadCharCode();
                if (v === 44 || v === 61 || v === 58 || v === 41) return this.setOptionalParametersError(i), e;
              }
              this.expect(17);
              let a = this.state.clone(), n = this.state.noArrowAt, o = this.startNodeAt(s, r), { consequent: c, failed: f } = this.tryParseConditionalConsequent(), [y, P] = this.getArrowLikeExpressions(c);
              if (f || P.length > 0) {
                let v = [...n];
                if (P.length > 0) {
                  this.state = a, this.state.noArrowAt = v;
                  for (let N = 0; N < P.length; N++) v.push(P[N].start);
                  ({ consequent: c, failed: f } = this.tryParseConditionalConsequent()), [y, P] = this.getArrowLikeExpressions(c);
                }
                f && y.length > 1 && this.raise(I.AmbiguousConditionalArrow, { at: a.startLoc }), f && y.length === 1 && (this.state = a, v.push(y[0].start), this.state.noArrowAt = v, { consequent: c, failed: f } = this.tryParseConditionalConsequent());
              }
              return this.getArrowLikeExpressions(c, true), this.state.noArrowAt = n, this.expect(14), o.test = e, o.consequent = c, o.alternate = this.forwardNoArrowParamsConversionAt(o, () => this.parseMaybeAssign(void 0, void 0)), this.finishNode(o, "ConditionalExpression");
            }
            tryParseConditionalConsequent() {
              this.state.noArrowParamsConversionAt.push(this.state.start);
              let e = this.parseMaybeAssignAllowIn(), s = !this.match(14);
              return this.state.noArrowParamsConversionAt.pop(), { consequent: e, failed: s };
            }
            getArrowLikeExpressions(e, s) {
              let r = [e], i = [];
              for (; r.length !== 0; ) {
                let a = r.pop();
                a.type === "ArrowFunctionExpression" ? (a.typeParameters || !a.returnType ? this.finishArrowValidation(a) : i.push(a), r.push(a.body)) : a.type === "ConditionalExpression" && (r.push(a.consequent), r.push(a.alternate));
              }
              return s ? (i.forEach((a) => this.finishArrowValidation(a)), [i, []]) : Ih(i, (a) => a.params.every((n) => this.isAssignable(n, true)));
            }
            finishArrowValidation(e) {
              var s;
              this.toAssignableList(e.params, (s = e.extra) == null ? void 0 : s.trailingCommaLoc, false), this.scope.enter(me | Jt), super.checkParams(e, false, true), this.scope.exit();
            }
            forwardNoArrowParamsConversionAt(e, s) {
              let r;
              return this.state.noArrowParamsConversionAt.indexOf(e.start) !== -1 ? (this.state.noArrowParamsConversionAt.push(this.state.start), r = s(), this.state.noArrowParamsConversionAt.pop()) : r = s(), r;
            }
            parseParenItem(e, s, r) {
              if (e = super.parseParenItem(e, s, r), this.eat(17) && (e.optional = true, this.resetEndLocation(e)), this.match(14)) {
                let i = this.startNodeAt(s, r);
                return i.expression = e, i.typeAnnotation = this.flowParseTypeAnnotation(), this.finishNode(i, "TypeCastExpression");
              }
              return e;
            }
            assertModuleNodeAllowed(e) {
              e.type === "ImportDeclaration" && (e.importKind === "type" || e.importKind === "typeof") || e.type === "ExportNamedDeclaration" && e.exportKind === "type" || e.type === "ExportAllDeclaration" && e.exportKind === "type" || super.assertModuleNodeAllowed(e);
            }
            parseExport(e) {
              let s = super.parseExport(e);
              return (s.type === "ExportNamedDeclaration" || s.type === "ExportAllDeclaration") && (s.exportKind = s.exportKind || "value"), s;
            }
            parseExportDeclaration(e) {
              if (this.isContextual(126)) {
                e.exportKind = "type";
                let s = this.startNode();
                return this.next(), this.match(5) ? (e.specifiers = this.parseExportSpecifiers(true), this.parseExportFrom(e), null) : this.flowParseTypeAlias(s);
              } else if (this.isContextual(127)) {
                e.exportKind = "type";
                let s = this.startNode();
                return this.next(), this.flowParseOpaqueType(s, false);
              } else if (this.isContextual(125)) {
                e.exportKind = "type";
                let s = this.startNode();
                return this.next(), this.flowParseInterface(s);
              } else if (this.shouldParseEnums() && this.isContextual(122)) {
                e.exportKind = "value";
                let s = this.startNode();
                return this.next(), this.flowParseEnumDeclaration(s);
              } else return super.parseExportDeclaration(e);
            }
            eatExportStar(e) {
              return super.eatExportStar(...arguments) ? true : this.isContextual(126) && this.lookahead().type === 55 ? (e.exportKind = "type", this.next(), this.next(), true) : false;
            }
            maybeParseExportNamespaceSpecifier(e) {
              let { startLoc: s } = this.state, r = super.maybeParseExportNamespaceSpecifier(e);
              return r && e.exportKind === "type" && this.unexpected(s), r;
            }
            parseClassId(e, s, r) {
              super.parseClassId(e, s, r), this.match(47) && (e.typeParameters = this.flowParseTypeParameterDeclaration());
            }
            parseClassMember(e, s, r) {
              let { startLoc: i } = this.state;
              if (this.isContextual(121)) {
                if (this.parseClassMemberFromModifier(e, s)) return;
                s.declare = true;
              }
              super.parseClassMember(e, s, r), s.declare && (s.type !== "ClassProperty" && s.type !== "ClassPrivateProperty" && s.type !== "PropertyDefinition" ? this.raise(I.DeclareClassElement, { at: i }) : s.value && this.raise(I.DeclareClassFieldInitializer, { at: s.value }));
            }
            isIterator(e) {
              return e === "iterator" || e === "asyncIterator";
            }
            readIterator() {
              let e = super.readWord1(), s = "@@" + e;
              (!this.isIterator(e) || !this.state.inType) && this.raise(u.InvalidIdentifier, { at: this.state.curPosition(), identifierName: s }), this.finishToken(128, s);
            }
            getTokenFromCode(e) {
              let s = this.input.charCodeAt(this.state.pos + 1);
              return e === 123 && s === 124 ? this.finishOp(6, 2) : this.state.inType && (e === 62 || e === 60) ? this.finishOp(e === 62 ? 48 : 47, 1) : this.state.inType && e === 63 ? s === 46 ? this.finishOp(18, 2) : this.finishOp(17, 1) : Ko(e, s, this.input.charCodeAt(this.state.pos + 2)) ? (this.state.pos += 2, this.readIterator()) : super.getTokenFromCode(e);
            }
            isAssignable(e, s) {
              return e.type === "TypeCastExpression" ? this.isAssignable(e.expression, s) : super.isAssignable(e, s);
            }
            toAssignable(e) {
              !(arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false) && e.type === "AssignmentExpression" && e.left.type === "TypeCastExpression" && (e.left = this.typeCastToParameter(e.left)), super.toAssignable(...arguments);
            }
            toAssignableList(e, s, r) {
              for (let i = 0; i < e.length; i++) {
                let a = e[i];
                (a == null ? void 0 : a.type) === "TypeCastExpression" && (e[i] = this.typeCastToParameter(a));
              }
              super.toAssignableList(e, s, r);
            }
            toReferencedList(e, s) {
              for (let i = 0; i < e.length; i++) {
                var r;
                let a = e[i];
                a && a.type === "TypeCastExpression" && !((r = a.extra) != null && r.parenthesized) && (e.length > 1 || !s) && this.raise(I.TypeCastInPattern, { at: a.typeAnnotation });
              }
              return e;
            }
            parseArrayLike(e, s, r, i) {
              let a = super.parseArrayLike(e, s, r, i);
              return s && !this.state.maybeInArrowParameters && this.toReferencedList(a.elements), a;
            }
            isValidLVal(e) {
              for (var s = arguments.length, r = new Array(s > 1 ? s - 1 : 0), i = 1; i < s; i++) r[i - 1] = arguments[i];
              return e === "TypeCastExpression" || super.isValidLVal(e, ...r);
            }
            parseClassProperty(e) {
              return this.match(14) && (e.typeAnnotation = this.flowParseTypeAnnotation()), super.parseClassProperty(e);
            }
            parseClassPrivateProperty(e) {
              return this.match(14) && (e.typeAnnotation = this.flowParseTypeAnnotation()), super.parseClassPrivateProperty(e);
            }
            isClassMethod() {
              return this.match(47) || super.isClassMethod();
            }
            isClassProperty() {
              return this.match(14) || super.isClassProperty();
            }
            isNonstaticConstructor(e) {
              return !this.match(14) && super.isNonstaticConstructor(e);
            }
            pushClassMethod(e, s, r, i, a, n) {
              if (s.variance && this.unexpected(s.variance.loc.start), delete s.variance, this.match(47) && (s.typeParameters = this.flowParseTypeParameterDeclaration()), super.pushClassMethod(e, s, r, i, a, n), s.params && a) {
                let o = s.params;
                o.length > 0 && this.isThisParam(o[0]) && this.raise(I.ThisParamBannedInConstructor, { at: s });
              } else if (s.type === "MethodDefinition" && a && s.value.params) {
                let o = s.value.params;
                o.length > 0 && this.isThisParam(o[0]) && this.raise(I.ThisParamBannedInConstructor, { at: s });
              }
            }
            pushClassPrivateMethod(e, s, r, i) {
              s.variance && this.unexpected(s.variance.loc.start), delete s.variance, this.match(47) && (s.typeParameters = this.flowParseTypeParameterDeclaration()), super.pushClassPrivateMethod(e, s, r, i);
            }
            parseClassSuper(e) {
              if (super.parseClassSuper(e), e.superClass && this.match(47) && (e.superTypeParameters = this.flowParseTypeParameterInstantiation()), this.isContextual(110)) {
                this.next();
                let s = e.implements = [];
                do {
                  let r = this.startNode();
                  r.id = this.flowParseRestrictedIdentifier(true), this.match(47) ? r.typeParameters = this.flowParseTypeParameterInstantiation() : r.typeParameters = null, s.push(this.finishNode(r, "ClassImplements"));
                } while (this.eat(12));
              }
            }
            checkGetterSetterParams(e) {
              super.checkGetterSetterParams(e);
              let s = this.getObjectOrClassMethodParams(e);
              if (s.length > 0) {
                let r = s[0];
                this.isThisParam(r) && e.kind === "get" ? this.raise(I.GetterMayNotHaveThisParam, { at: r }) : this.isThisParam(r) && this.raise(I.SetterMayNotHaveThisParam, { at: r });
              }
            }
            parsePropertyNamePrefixOperator(e) {
              e.variance = this.flowParseVariance();
            }
            parseObjPropValue(e, s, r, i, a, n, o, c) {
              e.variance && this.unexpected(e.variance.loc.start), delete e.variance;
              let f;
              this.match(47) && !o && (f = this.flowParseTypeParameterDeclaration(), this.match(10) || this.unexpected()), super.parseObjPropValue(e, s, r, i, a, n, o, c), f && ((e.value || e).typeParameters = f);
            }
            parseAssignableListItemTypes(e) {
              return this.eat(17) && (e.type !== "Identifier" && this.raise(I.PatternIsOptional, { at: e }), this.isThisParam(e) && this.raise(I.ThisParamMayNotBeOptional, { at: e }), e.optional = true), this.match(14) ? e.typeAnnotation = this.flowParseTypeAnnotation() : this.isThisParam(e) && this.raise(I.ThisParamAnnotationRequired, { at: e }), this.match(29) && this.isThisParam(e) && this.raise(I.ThisParamNoDefault, { at: e }), this.resetEndLocation(e), e;
            }
            parseMaybeDefault(e, s, r) {
              let i = super.parseMaybeDefault(e, s, r);
              return i.type === "AssignmentPattern" && i.typeAnnotation && i.right.start < i.typeAnnotation.start && this.raise(I.TypeBeforeInitializer, { at: i.typeAnnotation }), i;
            }
            shouldParseDefaultImport(e) {
              return cs(e) ? Or(this.state.type) : super.shouldParseDefaultImport(e);
            }
            parseImportSpecifierLocal(e, s, r) {
              s.local = cs(e) ? this.flowParseRestrictedIdentifier(true, true) : this.parseIdentifier(), e.specifiers.push(this.finishImportSpecifier(s, r));
            }
            maybeParseDefaultImportSpecifier(e) {
              e.importKind = "value";
              let s = null;
              if (this.match(87) ? s = "typeof" : this.isContextual(126) && (s = "type"), s) {
                let r = this.lookahead(), { type: i } = r;
                s === "type" && i === 55 && this.unexpected(null, r.type), (Or(i) || i === 5 || i === 55) && (this.next(), e.importKind = s);
              }
              return super.maybeParseDefaultImportSpecifier(e);
            }
            parseImportSpecifier(e, s, r, i) {
              let a = e.imported, n = null;
              a.type === "Identifier" && (a.name === "type" ? n = "type" : a.name === "typeof" && (n = "typeof"));
              let o = false;
              if (this.isContextual(93) && !this.isLookaheadContextual("as")) {
                let f = this.parseIdentifier(true);
                n !== null && !pe(this.state.type) ? (e.imported = f, e.importKind = n, e.local = ge(f)) : (e.imported = a, e.importKind = null, e.local = this.parseIdentifier());
              } else {
                if (n !== null && pe(this.state.type)) e.imported = this.parseIdentifier(true), e.importKind = n;
                else {
                  if (s) throw this.raise(u.ImportBindingIsString, { at: e, importName: a.value });
                  e.imported = a, e.importKind = null;
                }
                this.eatContextual(93) ? e.local = this.parseIdentifier() : (o = true, e.local = ge(e.imported));
              }
              let c = cs(e);
              return r && c && this.raise(I.ImportTypeShorthandOnlyInPureImport, { at: e }), (r || c) && this.checkReservedType(e.local.name, e.local.loc.start, true), o && !r && !c && this.checkReservedWord(e.local.name, e.loc.start, true, true), this.finishImportSpecifier(e, "ImportSpecifier");
            }
            parseBindingAtom() {
              switch (this.state.type) {
                case 78:
                  return this.parseIdentifier(true);
                default:
                  return super.parseBindingAtom();
              }
            }
            parseFunctionParams(e, s) {
              let r = e.kind;
              r !== "get" && r !== "set" && this.match(47) && (e.typeParameters = this.flowParseTypeParameterDeclaration()), super.parseFunctionParams(e, s);
            }
            parseVarId(e, s) {
              super.parseVarId(e, s), this.match(14) && (e.id.typeAnnotation = this.flowParseTypeAnnotation(), this.resetEndLocation(e.id));
            }
            parseAsyncArrowFromCallExpression(e, s) {
              if (this.match(14)) {
                let r = this.state.noAnonFunctionType;
                this.state.noAnonFunctionType = true, e.returnType = this.flowParseTypeAnnotation(), this.state.noAnonFunctionType = r;
              }
              return super.parseAsyncArrowFromCallExpression(e, s);
            }
            shouldParseAsyncArrow() {
              return this.match(14) || super.shouldParseAsyncArrow();
            }
            parseMaybeAssign(e, s) {
              var r;
              let i = null, a;
              if (this.hasPlugin("jsx") && (this.match(138) || this.match(47))) {
                if (i = this.state.clone(), a = this.tryParse(() => super.parseMaybeAssign(e, s), i), !a.error) return a.node;
                let { context: c } = this.state, f = c[c.length - 1];
                (f === z2.j_oTag || f === z2.j_expr) && c.pop();
              }
              if ((r = a) != null && r.error || this.match(47)) {
                var n, o;
                i = i || this.state.clone();
                let c, f = this.tryParse((P) => {
                  var v;
                  c = this.flowParseTypeParameterDeclaration();
                  let N = this.forwardNoArrowParamsConversionAt(c, () => {
                    let _ = super.parseMaybeAssign(e, s);
                    return this.resetStartLocationFromNode(_, c), _;
                  });
                  (v = N.extra) != null && v.parenthesized && P();
                  let B = this.maybeUnwrapTypeCastExpression(N);
                  return B.type !== "ArrowFunctionExpression" && P(), B.typeParameters = c, this.resetStartLocationFromNode(B, c), N;
                }, i), y = null;
                if (f.node && this.maybeUnwrapTypeCastExpression(f.node).type === "ArrowFunctionExpression") {
                  if (!f.error && !f.aborted) return f.node.async && this.raise(I.UnexpectedTypeParameterBeforeAsyncArrowFunction, { at: c }), f.node;
                  y = f.node;
                }
                if ((n = a) != null && n.node) return this.state = a.failState, a.node;
                if (y) return this.state = f.failState, y;
                throw (o = a) != null && o.thrown ? a.error : f.thrown ? f.error : this.raise(I.UnexpectedTokenAfterTypeParameter, { at: c });
              }
              return super.parseMaybeAssign(e, s);
            }
            parseArrow(e) {
              if (this.match(14)) {
                let s = this.tryParse(() => {
                  let r = this.state.noAnonFunctionType;
                  this.state.noAnonFunctionType = true;
                  let i = this.startNode();
                  return [i.typeAnnotation, e.predicate] = this.flowParseTypeAndPredicateInitialiser(), this.state.noAnonFunctionType = r, this.canInsertSemicolon() && this.unexpected(), this.match(19) || this.unexpected(), i;
                });
                if (s.thrown) return null;
                s.error && (this.state = s.failState), e.returnType = s.node.typeAnnotation ? this.finishNode(s.node, "TypeAnnotation") : null;
              }
              return super.parseArrow(e);
            }
            shouldParseArrow(e) {
              return this.match(14) || super.shouldParseArrow(e);
            }
            setArrowFunctionParameters(e, s) {
              this.state.noArrowParamsConversionAt.indexOf(e.start) !== -1 ? e.params = s : super.setArrowFunctionParameters(e, s);
            }
            checkParams(e, s, r) {
              if (!(r && this.state.noArrowParamsConversionAt.indexOf(e.start) !== -1)) {
                for (let i = 0; i < e.params.length; i++) this.isThisParam(e.params[i]) && i > 0 && this.raise(I.ThisParamMustBeFirst, { at: e.params[i] });
                return super.checkParams(...arguments);
              }
            }
            parseParenAndDistinguishExpression(e) {
              return super.parseParenAndDistinguishExpression(e && this.state.noArrowAt.indexOf(this.state.start) === -1);
            }
            parseSubscripts(e, s, r, i) {
              if (e.type === "Identifier" && e.name === "async" && this.state.noArrowAt.indexOf(s) !== -1) {
                this.next();
                let a = this.startNodeAt(s, r);
                a.callee = e, a.arguments = this.parseCallExpressionArguments(11, false), e = this.finishNode(a, "CallExpression");
              } else if (e.type === "Identifier" && e.name === "async" && this.match(47)) {
                let a = this.state.clone(), n = this.tryParse((c) => this.parseAsyncArrowWithTypeParameters(s, r) || c(), a);
                if (!n.error && !n.aborted) return n.node;
                let o = this.tryParse(() => super.parseSubscripts(e, s, r, i), a);
                if (o.node && !o.error) return o.node;
                if (n.node) return this.state = n.failState, n.node;
                if (o.node) return this.state = o.failState, o.node;
                throw n.error || o.error;
              }
              return super.parseSubscripts(e, s, r, i);
            }
            parseSubscript(e, s, r, i, a) {
              if (this.match(18) && this.isLookaheadToken_lt()) {
                if (a.optionalChainMember = true, i) return a.stop = true, e;
                this.next();
                let n = this.startNodeAt(s, r);
                return n.callee = e, n.typeArguments = this.flowParseTypeParameterInstantiation(), this.expect(10), n.arguments = this.parseCallExpressionArguments(11, false), n.optional = true, this.finishCallExpression(n, true);
              } else if (!i && this.shouldParseTypes() && this.match(47)) {
                let n = this.startNodeAt(s, r);
                n.callee = e;
                let o = this.tryParse(() => (n.typeArguments = this.flowParseTypeParameterInstantiationCallOrNew(), this.expect(10), n.arguments = this.parseCallExpressionArguments(11, false), a.optionalChainMember && (n.optional = false), this.finishCallExpression(n, a.optionalChainMember)));
                if (o.node) return o.error && (this.state = o.failState), o.node;
              }
              return super.parseSubscript(e, s, r, i, a);
            }
            parseNewCallee(e) {
              super.parseNewCallee(e);
              let s = null;
              this.shouldParseTypes() && this.match(47) && (s = this.tryParse(() => this.flowParseTypeParameterInstantiationCallOrNew()).node), e.typeArguments = s;
            }
            parseAsyncArrowWithTypeParameters(e, s) {
              let r = this.startNodeAt(e, s);
              if (this.parseFunctionParams(r), !!this.parseArrow(r)) return this.parseArrowExpression(r, void 0, true);
            }
            readToken_mult_modulo(e) {
              let s = this.input.charCodeAt(this.state.pos + 1);
              if (e === 42 && s === 47 && this.state.hasFlowComment) {
                this.state.hasFlowComment = false, this.state.pos += 2, this.nextToken();
                return;
              }
              super.readToken_mult_modulo(e);
            }
            readToken_pipe_amp(e) {
              let s = this.input.charCodeAt(this.state.pos + 1);
              if (e === 124 && s === 125) {
                this.finishOp(9, 2);
                return;
              }
              super.readToken_pipe_amp(e);
            }
            parseTopLevel(e, s) {
              let r = super.parseTopLevel(e, s);
              return this.state.hasFlowComment && this.raise(I.UnterminatedFlowComment, { at: this.state.curPosition() }), r;
            }
            skipBlockComment() {
              if (this.hasPlugin("flowComments") && this.skipFlowComment()) {
                if (this.state.hasFlowComment) throw this.raise(I.NestedFlowComment, { at: this.state.startLoc });
                this.hasFlowCommentCompletion(), this.state.pos += this.skipFlowComment(), this.state.hasFlowComment = true;
                return;
              }
              if (this.state.hasFlowComment) {
                let e = this.input.indexOf("*-/", this.state.pos + 2);
                if (e === -1) throw this.raise(u.UnterminatedComment, { at: this.state.curPosition() });
                this.state.pos = e + 2 + 3;
                return;
              }
              return super.skipBlockComment();
            }
            skipFlowComment() {
              let { pos: e } = this.state, s = 2;
              for (; [32, 9].includes(this.input.charCodeAt(e + s)); ) s++;
              let r = this.input.charCodeAt(s + e), i = this.input.charCodeAt(s + e + 1);
              return r === 58 && i === 58 ? s + 2 : this.input.slice(s + e, s + e + 12) === "flow-include" ? s + 12 : r === 58 && i !== 58 ? s : false;
            }
            hasFlowCommentCompletion() {
              if (this.input.indexOf("*/", this.state.pos) === -1) throw this.raise(u.UnterminatedComment, { at: this.state.curPosition() });
            }
            flowEnumErrorBooleanMemberNotInitialized(e, s) {
              let { enumName: r, memberName: i } = s;
              this.raise(I.EnumBooleanMemberNotInitialized, { at: e, memberName: i, enumName: r });
            }
            flowEnumErrorInvalidMemberInitializer(e, s) {
              return this.raise(s.explicitType ? s.explicitType === "symbol" ? I.EnumInvalidMemberInitializerSymbolType : I.EnumInvalidMemberInitializerPrimaryType : I.EnumInvalidMemberInitializerUnknownType, Object.assign({ at: e }, s));
            }
            flowEnumErrorNumberMemberNotInitialized(e, s) {
              let { enumName: r, memberName: i } = s;
              this.raise(I.EnumNumberMemberNotInitialized, { at: e, enumName: r, memberName: i });
            }
            flowEnumErrorStringMemberInconsistentlyInitailized(e, s) {
              let { enumName: r } = s;
              this.raise(I.EnumStringMemberInconsistentlyInitailized, { at: e, enumName: r });
            }
            flowEnumMemberInit() {
              let e = this.state.startLoc, s = () => this.match(12) || this.match(8);
              switch (this.state.type) {
                case 130: {
                  let r = this.parseNumericLiteral(this.state.value);
                  return s() ? { type: "number", loc: r.loc.start, value: r } : { type: "invalid", loc: e };
                }
                case 129: {
                  let r = this.parseStringLiteral(this.state.value);
                  return s() ? { type: "string", loc: r.loc.start, value: r } : { type: "invalid", loc: e };
                }
                case 85:
                case 86: {
                  let r = this.parseBooleanLiteral(this.match(85));
                  return s() ? { type: "boolean", loc: r.loc.start, value: r } : { type: "invalid", loc: e };
                }
                default:
                  return { type: "invalid", loc: e };
              }
            }
            flowEnumMemberRaw() {
              let e = this.state.startLoc, s = this.parseIdentifier(true), r = this.eat(29) ? this.flowEnumMemberInit() : { type: "none", loc: e };
              return { id: s, init: r };
            }
            flowEnumCheckExplicitTypeMismatch(e, s, r) {
              let { explicitType: i } = s;
              i !== null && i !== r && this.flowEnumErrorInvalidMemberInitializer(e, s);
            }
            flowEnumMembers(e) {
              let { enumName: s, explicitType: r } = e, i = /* @__PURE__ */ new Set(), a = { booleanMembers: [], numberMembers: [], stringMembers: [], defaultedMembers: [] }, n = false;
              for (; !this.match(8); ) {
                if (this.eat(21)) {
                  n = true;
                  break;
                }
                let o = this.startNode(), { id: c, init: f } = this.flowEnumMemberRaw(), y = c.name;
                if (y === "") continue;
                /^[a-z]/.test(y) && this.raise(I.EnumInvalidMemberName, { at: c, memberName: y, suggestion: y[0].toUpperCase() + y.slice(1), enumName: s }), i.has(y) && this.raise(I.EnumDuplicateMemberName, { at: c, memberName: y, enumName: s }), i.add(y);
                let P = { enumName: s, explicitType: r, memberName: y };
                switch (o.id = c, f.type) {
                  case "boolean": {
                    this.flowEnumCheckExplicitTypeMismatch(f.loc, P, "boolean"), o.init = f.value, a.booleanMembers.push(this.finishNode(o, "EnumBooleanMember"));
                    break;
                  }
                  case "number": {
                    this.flowEnumCheckExplicitTypeMismatch(f.loc, P, "number"), o.init = f.value, a.numberMembers.push(this.finishNode(o, "EnumNumberMember"));
                    break;
                  }
                  case "string": {
                    this.flowEnumCheckExplicitTypeMismatch(f.loc, P, "string"), o.init = f.value, a.stringMembers.push(this.finishNode(o, "EnumStringMember"));
                    break;
                  }
                  case "invalid":
                    throw this.flowEnumErrorInvalidMemberInitializer(f.loc, P);
                  case "none":
                    switch (r) {
                      case "boolean":
                        this.flowEnumErrorBooleanMemberNotInitialized(f.loc, P);
                        break;
                      case "number":
                        this.flowEnumErrorNumberMemberNotInitialized(f.loc, P);
                        break;
                      default:
                        a.defaultedMembers.push(this.finishNode(o, "EnumDefaultedMember"));
                    }
                }
                this.match(8) || this.expect(12);
              }
              return { members: a, hasUnknownMembers: n };
            }
            flowEnumStringMembers(e, s, r) {
              let { enumName: i } = r;
              if (e.length === 0) return s;
              if (s.length === 0) return e;
              if (s.length > e.length) {
                for (let a of e) this.flowEnumErrorStringMemberInconsistentlyInitailized(a, { enumName: i });
                return s;
              } else {
                for (let a of s) this.flowEnumErrorStringMemberInconsistentlyInitailized(a, { enumName: i });
                return e;
              }
            }
            flowEnumParseExplicitType(e) {
              let { enumName: s } = e;
              if (!this.eatContextual(101)) return null;
              if (!K(this.state.type)) throw this.raise(I.EnumInvalidExplicitTypeUnknownSupplied, { at: this.state.startLoc, enumName: s });
              let { value: r } = this.state;
              return this.next(), r !== "boolean" && r !== "number" && r !== "string" && r !== "symbol" && this.raise(I.EnumInvalidExplicitType, { at: this.state.startLoc, enumName: s, invalidEnumType: r }), r;
            }
            flowEnumBody(e, s) {
              let r = s.name, i = s.loc.start, a = this.flowEnumParseExplicitType({ enumName: r });
              this.expect(5);
              let { members: n, hasUnknownMembers: o } = this.flowEnumMembers({ enumName: r, explicitType: a });
              switch (e.hasUnknownMembers = o, a) {
                case "boolean":
                  return e.explicitType = true, e.members = n.booleanMembers, this.expect(8), this.finishNode(e, "EnumBooleanBody");
                case "number":
                  return e.explicitType = true, e.members = n.numberMembers, this.expect(8), this.finishNode(e, "EnumNumberBody");
                case "string":
                  return e.explicitType = true, e.members = this.flowEnumStringMembers(n.stringMembers, n.defaultedMembers, { enumName: r }), this.expect(8), this.finishNode(e, "EnumStringBody");
                case "symbol":
                  return e.members = n.defaultedMembers, this.expect(8), this.finishNode(e, "EnumSymbolBody");
                default: {
                  let c = () => (e.members = [], this.expect(8), this.finishNode(e, "EnumStringBody"));
                  e.explicitType = false;
                  let f = n.booleanMembers.length, y = n.numberMembers.length, P = n.stringMembers.length, v = n.defaultedMembers.length;
                  if (!f && !y && !P && !v) return c();
                  if (!f && !y) return e.members = this.flowEnumStringMembers(n.stringMembers, n.defaultedMembers, { enumName: r }), this.expect(8), this.finishNode(e, "EnumStringBody");
                  if (!y && !P && f >= v) {
                    for (let N of n.defaultedMembers) this.flowEnumErrorBooleanMemberNotInitialized(N.loc.start, { enumName: r, memberName: N.id.name });
                    return e.members = n.booleanMembers, this.expect(8), this.finishNode(e, "EnumBooleanBody");
                  } else if (!f && !P && y >= v) {
                    for (let N of n.defaultedMembers) this.flowEnumErrorNumberMemberNotInitialized(N.loc.start, { enumName: r, memberName: N.id.name });
                    return e.members = n.numberMembers, this.expect(8), this.finishNode(e, "EnumNumberBody");
                  } else return this.raise(I.EnumInconsistentMemberValues, { at: i, enumName: r }), c();
                }
              }
            }
            flowParseEnumDeclaration(e) {
              let s = this.parseIdentifier();
              return e.id = s, e.body = this.flowEnumBody(this.startNode(), s), this.finishNode(e, "EnumDeclaration");
            }
            isLookaheadToken_lt() {
              let e = this.nextTokenStart();
              if (this.input.charCodeAt(e) === 60) {
                let s = this.input.charCodeAt(e + 1);
                return s !== 60 && s !== 61;
              }
              return false;
            }
            maybeUnwrapTypeCastExpression(e) {
              return e.type === "TypeCastExpression" ? e.expression : e;
            }
          }, Fh = { __proto__: null, quot: '"', amp: "&", apos: "'", lt: "<", gt: ">", nbsp: "\xA0", iexcl: "\xA1", cent: "\xA2", pound: "\xA3", curren: "\xA4", yen: "\xA5", brvbar: "\xA6", sect: "\xA7", uml: "\xA8", copy: "\xA9", ordf: "\xAA", laquo: "\xAB", not: "\xAC", shy: "\xAD", reg: "\xAE", macr: "\xAF", deg: "\xB0", plusmn: "\xB1", sup2: "\xB2", sup3: "\xB3", acute: "\xB4", micro: "\xB5", para: "\xB6", middot: "\xB7", cedil: "\xB8", sup1: "\xB9", ordm: "\xBA", raquo: "\xBB", frac14: "\xBC", frac12: "\xBD", frac34: "\xBE", iquest: "\xBF", Agrave: "\xC0", Aacute: "\xC1", Acirc: "\xC2", Atilde: "\xC3", Auml: "\xC4", Aring: "\xC5", AElig: "\xC6", Ccedil: "\xC7", Egrave: "\xC8", Eacute: "\xC9", Ecirc: "\xCA", Euml: "\xCB", Igrave: "\xCC", Iacute: "\xCD", Icirc: "\xCE", Iuml: "\xCF", ETH: "\xD0", Ntilde: "\xD1", Ograve: "\xD2", Oacute: "\xD3", Ocirc: "\xD4", Otilde: "\xD5", Ouml: "\xD6", times: "\xD7", Oslash: "\xD8", Ugrave: "\xD9", Uacute: "\xDA", Ucirc: "\xDB", Uuml: "\xDC", Yacute: "\xDD", THORN: "\xDE", szlig: "\xDF", agrave: "\xE0", aacute: "\xE1", acirc: "\xE2", atilde: "\xE3", auml: "\xE4", aring: "\xE5", aelig: "\xE6", ccedil: "\xE7", egrave: "\xE8", eacute: "\xE9", ecirc: "\xEA", euml: "\xEB", igrave: "\xEC", iacute: "\xED", icirc: "\xEE", iuml: "\xEF", eth: "\xF0", ntilde: "\xF1", ograve: "\xF2", oacute: "\xF3", ocirc: "\xF4", otilde: "\xF5", ouml: "\xF6", divide: "\xF7", oslash: "\xF8", ugrave: "\xF9", uacute: "\xFA", ucirc: "\xFB", uuml: "\xFC", yacute: "\xFD", thorn: "\xFE", yuml: "\xFF", OElig: "\u0152", oelig: "\u0153", Scaron: "\u0160", scaron: "\u0161", Yuml: "\u0178", fnof: "\u0192", circ: "\u02C6", tilde: "\u02DC", Alpha: "\u0391", Beta: "\u0392", Gamma: "\u0393", Delta: "\u0394", Epsilon: "\u0395", Zeta: "\u0396", Eta: "\u0397", Theta: "\u0398", Iota: "\u0399", Kappa: "\u039A", Lambda: "\u039B", Mu: "\u039C", Nu: "\u039D", Xi: "\u039E", Omicron: "\u039F", Pi: "\u03A0", Rho: "\u03A1", Sigma: "\u03A3", Tau: "\u03A4", Upsilon: "\u03A5", Phi: "\u03A6", Chi: "\u03A7", Psi: "\u03A8", Omega: "\u03A9", alpha: "\u03B1", beta: "\u03B2", gamma: "\u03B3", delta: "\u03B4", epsilon: "\u03B5", zeta: "\u03B6", eta: "\u03B7", theta: "\u03B8", iota: "\u03B9", kappa: "\u03BA", lambda: "\u03BB", mu: "\u03BC", nu: "\u03BD", xi: "\u03BE", omicron: "\u03BF", pi: "\u03C0", rho: "\u03C1", sigmaf: "\u03C2", sigma: "\u03C3", tau: "\u03C4", upsilon: "\u03C5", phi: "\u03C6", chi: "\u03C7", psi: "\u03C8", omega: "\u03C9", thetasym: "\u03D1", upsih: "\u03D2", piv: "\u03D6", ensp: "\u2002", emsp: "\u2003", thinsp: "\u2009", zwnj: "\u200C", zwj: "\u200D", lrm: "\u200E", rlm: "\u200F", ndash: "\u2013", mdash: "\u2014", lsquo: "\u2018", rsquo: "\u2019", sbquo: "\u201A", ldquo: "\u201C", rdquo: "\u201D", bdquo: "\u201E", dagger: "\u2020", Dagger: "\u2021", bull: "\u2022", hellip: "\u2026", permil: "\u2030", prime: "\u2032", Prime: "\u2033", lsaquo: "\u2039", rsaquo: "\u203A", oline: "\u203E", frasl: "\u2044", euro: "\u20AC", image: "\u2111", weierp: "\u2118", real: "\u211C", trade: "\u2122", alefsym: "\u2135", larr: "\u2190", uarr: "\u2191", rarr: "\u2192", darr: "\u2193", harr: "\u2194", crarr: "\u21B5", lArr: "\u21D0", uArr: "\u21D1", rArr: "\u21D2", dArr: "\u21D3", hArr: "\u21D4", forall: "\u2200", part: "\u2202", exist: "\u2203", empty: "\u2205", nabla: "\u2207", isin: "\u2208", notin: "\u2209", ni: "\u220B", prod: "\u220F", sum: "\u2211", minus: "\u2212", lowast: "\u2217", radic: "\u221A", prop: "\u221D", infin: "\u221E", ang: "\u2220", and: "\u2227", or: "\u2228", cap: "\u2229", cup: "\u222A", int: "\u222B", there4: "\u2234", sim: "\u223C", cong: "\u2245", asymp: "\u2248", ne: "\u2260", equiv: "\u2261", le: "\u2264", ge: "\u2265", sub: "\u2282", sup: "\u2283", nsub: "\u2284", sube: "\u2286", supe: "\u2287", oplus: "\u2295", otimes: "\u2297", perp: "\u22A5", sdot: "\u22C5", lceil: "\u2308", rceil: "\u2309", lfloor: "\u230A", rfloor: "\u230B", lang: "\u2329", rang: "\u232A", loz: "\u25CA", spades: "\u2660", clubs: "\u2663", hearts: "\u2665", diams: "\u2666" }, Ie = j(Kn || (Kn = rt(["jsx"])))((t) => ({ AttributeIsEmpty: t("JSX attributes must only be assigned a non-empty expression."), MissingClosingTagElement: t((e) => {
            let { openingTagName: s } = e;
            return "Expected corresponding JSX closing tag for <".concat(s, ">.");
          }), MissingClosingTagFragment: t("Expected corresponding JSX closing tag for <>."), UnexpectedSequenceExpression: t("Sequence expressions cannot be directly nested inside JSX. Did you mean to wrap it in parentheses (...)?"), UnexpectedToken: t((e) => {
            let { unexpected: s, HTMLEntity: r } = e;
            return "Unexpected token `".concat(s, "`. Did you mean `").concat(r, "` or `{'").concat(s, "'}`?");
          }), UnsupportedJsxValue: t("JSX value should be either an expression or a quoted JSX text."), UnterminatedJsxContent: t("Unterminated JSX contents."), UnwrappedAdjacentJSXElements: t("Adjacent JSX elements must be wrapped in an enclosing tag. Did you want a JSX fragment <>...</>?") }));
          function Ce(t) {
            return t ? t.type === "JSXOpeningFragment" || t.type === "JSXClosingFragment" : false;
          }
          function Ue(t) {
            if (t.type === "JSXIdentifier") return t.name;
            if (t.type === "JSXNamespacedName") return t.namespace.name + ":" + t.name.name;
            if (t.type === "JSXMemberExpression") return Ue(t.object) + "." + Ue(t.property);
            throw new Error("Node had unexpected type: " + t.type);
          }
          var Lh = (t) => class extends t {
            jsxReadToken() {
              let e = "", s = this.state.pos;
              for (; ; ) {
                if (this.state.pos >= this.length) throw this.raise(Ie.UnterminatedJsxContent, { at: this.state.startLoc });
                let r = this.input.charCodeAt(this.state.pos);
                switch (r) {
                  case 60:
                  case 123:
                    return this.state.pos === this.state.start ? r === 60 && this.state.canStartJSXElement ? (++this.state.pos, this.finishToken(138)) : super.getTokenFromCode(r) : (e += this.input.slice(s, this.state.pos), this.finishToken(137, e));
                  case 38:
                    e += this.input.slice(s, this.state.pos), e += this.jsxReadEntity(), s = this.state.pos;
                    break;
                  case 62:
                  case 125:
                  default:
                    Ne(r) ? (e += this.input.slice(s, this.state.pos), e += this.jsxReadNewLine(true), s = this.state.pos) : ++this.state.pos;
                }
              }
            }
            jsxReadNewLine(e) {
              let s = this.input.charCodeAt(this.state.pos), r;
              return ++this.state.pos, s === 13 && this.input.charCodeAt(this.state.pos) === 10 ? (++this.state.pos, r = e ? `
` : `\r
`) : r = String.fromCharCode(s), ++this.state.curLine, this.state.lineStart = this.state.pos, r;
            }
            jsxReadString(e) {
              let s = "", r = ++this.state.pos;
              for (; ; ) {
                if (this.state.pos >= this.length) throw this.raise(u.UnterminatedString, { at: this.state.startLoc });
                let i = this.input.charCodeAt(this.state.pos);
                if (i === e) break;
                i === 38 ? (s += this.input.slice(r, this.state.pos), s += this.jsxReadEntity(), r = this.state.pos) : Ne(i) ? (s += this.input.slice(r, this.state.pos), s += this.jsxReadNewLine(false), r = this.state.pos) : ++this.state.pos;
              }
              return s += this.input.slice(r, this.state.pos++), this.finishToken(129, s);
            }
            jsxReadEntity() {
              let e = ++this.state.pos;
              if (this.codePointAtPos(this.state.pos) === 35) {
                ++this.state.pos;
                let s = 10;
                this.codePointAtPos(this.state.pos) === 120 && (s = 16, ++this.state.pos);
                let r = this.readInt(s, void 0, false, "bail");
                if (r !== null && this.codePointAtPos(this.state.pos) === 59) return ++this.state.pos, String.fromCodePoint(r);
              } else {
                let s = 0, r = false;
                for (; s++ < 10 && this.state.pos < this.length && !(r = this.codePointAtPos(this.state.pos) == 59); ) ++this.state.pos;
                if (r) {
                  let i = this.input.slice(e, this.state.pos), a = Fh[i];
                  if (++this.state.pos, a) return a;
                }
              }
              return this.state.pos = e, "&";
            }
            jsxReadWord() {
              let e, s = this.state.pos;
              do
                e = this.input.charCodeAt(++this.state.pos);
              while (Be(e) || e === 45);
              return this.finishToken(136, this.input.slice(s, this.state.pos));
            }
            jsxParseIdentifier() {
              let e = this.startNode();
              return this.match(136) ? e.name = this.state.value : Ht(this.state.type) ? e.name = Pe(this.state.type) : this.unexpected(), this.next(), this.finishNode(e, "JSXIdentifier");
            }
            jsxParseNamespacedName() {
              let e = this.state.start, s = this.state.startLoc, r = this.jsxParseIdentifier();
              if (!this.eat(14)) return r;
              let i = this.startNodeAt(e, s);
              return i.namespace = r, i.name = this.jsxParseIdentifier(), this.finishNode(i, "JSXNamespacedName");
            }
            jsxParseElementName() {
              let e = this.state.start, s = this.state.startLoc, r = this.jsxParseNamespacedName();
              if (r.type === "JSXNamespacedName") return r;
              for (; this.eat(16); ) {
                let i = this.startNodeAt(e, s);
                i.object = r, i.property = this.jsxParseIdentifier(), r = this.finishNode(i, "JSXMemberExpression");
              }
              return r;
            }
            jsxParseAttributeValue() {
              let e;
              switch (this.state.type) {
                case 5:
                  return e = this.startNode(), this.setContext(z2.brace), this.next(), e = this.jsxParseExpressionContainer(e, z2.j_oTag), e.expression.type === "JSXEmptyExpression" && this.raise(Ie.AttributeIsEmpty, { at: e }), e;
                case 138:
                case 129:
                  return this.parseExprAtom();
                default:
                  throw this.raise(Ie.UnsupportedJsxValue, { at: this.state.startLoc });
              }
            }
            jsxParseEmptyExpression() {
              let e = this.startNodeAt(this.state.lastTokEndLoc.index, this.state.lastTokEndLoc);
              return this.finishNodeAt(e, "JSXEmptyExpression", this.state.startLoc);
            }
            jsxParseSpreadChild(e) {
              return this.next(), e.expression = this.parseExpression(), this.setContext(z2.j_oTag), this.state.canStartJSXElement = true, this.expect(8), this.finishNode(e, "JSXSpreadChild");
            }
            jsxParseExpressionContainer(e, s) {
              if (this.match(8)) e.expression = this.jsxParseEmptyExpression();
              else {
                let r = this.parseExpression();
                e.expression = r;
              }
              return this.setContext(s), this.state.canStartJSXElement = true, this.expect(8), this.finishNode(e, "JSXExpressionContainer");
            }
            jsxParseAttribute() {
              let e = this.startNode();
              return this.match(5) ? (this.setContext(z2.brace), this.next(), this.expect(21), e.argument = this.parseMaybeAssignAllowIn(), this.setContext(z2.j_oTag), this.state.canStartJSXElement = true, this.expect(8), this.finishNode(e, "JSXSpreadAttribute")) : (e.name = this.jsxParseNamespacedName(), e.value = this.eat(29) ? this.jsxParseAttributeValue() : null, this.finishNode(e, "JSXAttribute"));
            }
            jsxParseOpeningElementAt(e, s) {
              let r = this.startNodeAt(e, s);
              return this.eat(139) ? this.finishNode(r, "JSXOpeningFragment") : (r.name = this.jsxParseElementName(), this.jsxParseOpeningElementAfterName(r));
            }
            jsxParseOpeningElementAfterName(e) {
              let s = [];
              for (; !this.match(56) && !this.match(139); ) s.push(this.jsxParseAttribute());
              return e.attributes = s, e.selfClosing = this.eat(56), this.expect(139), this.finishNode(e, "JSXOpeningElement");
            }
            jsxParseClosingElementAt(e, s) {
              let r = this.startNodeAt(e, s);
              return this.eat(139) ? this.finishNode(r, "JSXClosingFragment") : (r.name = this.jsxParseElementName(), this.expect(139), this.finishNode(r, "JSXClosingElement"));
            }
            jsxParseElementAt(e, s) {
              let r = this.startNodeAt(e, s), i = [], a = this.jsxParseOpeningElementAt(e, s), n = null;
              if (!a.selfClosing) {
                e: for (; ; ) switch (this.state.type) {
                  case 138:
                    if (e = this.state.start, s = this.state.startLoc, this.next(), this.eat(56)) {
                      n = this.jsxParseClosingElementAt(e, s);
                      break e;
                    }
                    i.push(this.jsxParseElementAt(e, s));
                    break;
                  case 137:
                    i.push(this.parseExprAtom());
                    break;
                  case 5: {
                    let o = this.startNode();
                    this.setContext(z2.brace), this.next(), this.match(21) ? i.push(this.jsxParseSpreadChild(o)) : i.push(this.jsxParseExpressionContainer(o, z2.j_expr));
                    break;
                  }
                  default:
                    throw this.unexpected();
                }
                Ce(a) && !Ce(n) && n !== null ? this.raise(Ie.MissingClosingTagFragment, { at: n }) : !Ce(a) && Ce(n) ? this.raise(Ie.MissingClosingTagElement, { at: n, openingTagName: Ue(a.name) }) : !Ce(a) && !Ce(n) && Ue(n.name) !== Ue(a.name) && this.raise(Ie.MissingClosingTagElement, { at: n, openingTagName: Ue(a.name) });
              }
              if (Ce(a) ? (r.openingFragment = a, r.closingFragment = n) : (r.openingElement = a, r.closingElement = n), r.children = i, this.match(47)) throw this.raise(Ie.UnwrappedAdjacentJSXElements, { at: this.state.startLoc });
              return Ce(a) ? this.finishNode(r, "JSXFragment") : this.finishNode(r, "JSXElement");
            }
            jsxParseElement() {
              let e = this.state.start, s = this.state.startLoc;
              return this.next(), this.jsxParseElementAt(e, s);
            }
            setContext(e) {
              let { context: s } = this.state;
              s[s.length - 1] = e;
            }
            parseExprAtom(e) {
              return this.match(137) ? this.parseLiteral(this.state.value, "JSXText") : this.match(138) ? this.jsxParseElement() : this.match(47) && this.input.charCodeAt(this.state.pos) !== 33 ? (this.replaceToken(138), this.jsxParseElement()) : super.parseExprAtom(e);
            }
            skipSpace() {
              this.curContext().preserveSpace || super.skipSpace();
            }
            getTokenFromCode(e) {
              let s = this.curContext();
              if (s === z2.j_expr) return this.jsxReadToken();
              if (s === z2.j_oTag || s === z2.j_cTag) {
                if (de(e)) return this.jsxReadWord();
                if (e === 62) return ++this.state.pos, this.finishToken(139);
                if ((e === 34 || e === 39) && s === z2.j_oTag) return this.jsxReadString(e);
              }
              return e === 60 && this.state.canStartJSXElement && this.input.charCodeAt(this.state.pos + 1) !== 33 ? (++this.state.pos, this.finishToken(138)) : super.getTokenFromCode(e);
            }
            updateContext(e) {
              let { context: s, type: r } = this.state;
              if (r === 56 && e === 138) s.splice(-2, 2, z2.j_cTag), this.state.canStartJSXElement = false;
              else if (r === 138) s.push(z2.j_oTag);
              else if (r === 139) {
                let i = s[s.length - 1];
                i === z2.j_oTag && e === 56 || i === z2.j_cTag ? (s.pop(), this.state.canStartJSXElement = s[s.length - 1] === z2.j_expr) : (this.setContext(z2.j_expr), this.state.canStartJSXElement = true);
              } else this.state.canStartJSXElement = So(r);
            }
          }, Oh = class extends os {
            constructor() {
              super(...arguments), this.types = /* @__PURE__ */ new Set(), this.enums = /* @__PURE__ */ new Set(), this.constEnums = /* @__PURE__ */ new Set(), this.classes = /* @__PURE__ */ new Set(), this.exportOnlyBindings = /* @__PURE__ */ new Set();
            }
          }, Bh = class extends hs {
            createScope(t) {
              return new Oh(t);
            }
            declareName(t, e, s) {
              let r = this.currentScope();
              if (e & Zt) {
                this.maybeExportDefined(r, t), r.exportOnlyBindings.add(t);
                return;
              }
              super.declareName(...arguments), e & Re && (e & ye || (this.checkRedeclarationInScope(r, t, e, s), this.maybeExportDefined(r, t)), r.types.add(t)), e & $t && r.enums.add(t), e & Qt && r.constEnums.add(t), e & ct && r.classes.add(t);
            }
            isRedeclaredInScope(t, e, s) {
              if (t.enums.has(e)) {
                if (s & $t) {
                  let r = !!(s & Qt), i = t.constEnums.has(e);
                  return r !== i;
                }
                return true;
              }
              return s & ct && t.classes.has(e) ? t.lexical.has(e) ? !!(s & ye) : false : s & Re && t.types.has(e) ? true : super.isRedeclaredInScope(...arguments);
            }
            checkLocalExport(t) {
              let e = this.scopeStack[0], { name: s } = t;
              !e.types.has(s) && !e.exportOnlyBindings.has(s) && super.checkLocalExport(t);
            }
          }, Mh = (t, e) => Object.hasOwnProperty.call(t, e) && t[e];
          function Rh(t) {
            if (t == null) throw new Error("Unexpected ".concat(t, " value."));
            return t;
          }
          function Br(t) {
            if (!t) throw new Error("Assert fail");
          }
          function jh(t) {
            return Vt(t) || Oo(t);
          }
          var S = j(Vn || (Vn = rt(["typescript"])))((t) => ({ AbstractMethodHasImplementation: t((e) => {
            let { methodName: s } = e;
            return "Method '".concat(s, "' cannot have an implementation because it is marked abstract.");
          }), AbstractPropertyHasInitializer: t((e) => {
            let { propertyName: s } = e;
            return "Property '".concat(s, "' cannot have an initializer because it is marked abstract.");
          }), AccesorCannotDeclareThisParameter: t("'get' and 'set' accessors cannot declare 'this' parameters."), AccesorCannotHaveTypeParameters: t("An accessor cannot have type parameters."), CannotFindName: t((e) => {
            let { name: s } = e;
            return "Cannot find name '".concat(s, "'.");
          }), ClassMethodHasDeclare: t("Class methods cannot have the 'declare' modifier."), ClassMethodHasReadonly: t("Class methods cannot have the 'readonly' modifier."), ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference: t("A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference."), ConstructorHasTypeParameters: t("Type parameters cannot appear on a constructor declaration."), DeclareAccessor: t((e) => {
            let { kind: s } = e;
            return "'declare' is not allowed in ".concat(s, "ters.");
          }), DeclareClassFieldHasInitializer: t("Initializers are not allowed in ambient contexts."), DeclareFunctionHasImplementation: t("An implementation cannot be declared in ambient contexts."), DuplicateAccessibilityModifier: t((e) => {
            let { modifier: s } = e;
            return "Accessibility modifier already seen.";
          }), DuplicateModifier: t((e) => {
            let { modifier: s } = e;
            return "Duplicate modifier: '".concat(s, "'.");
          }), EmptyHeritageClauseType: t((e) => {
            let { token: s } = e;
            return "'".concat(s, "' list cannot be empty.");
          }), EmptyTypeArguments: t("Type argument list cannot be empty."), EmptyTypeParameters: t("Type parameter list cannot be empty."), ExpectedAmbientAfterExportDeclare: t("'export declare' must be followed by an ambient declaration."), ImportAliasHasImportType: t("An import alias can not use 'import type'."), IncompatibleModifiers: t((e) => {
            let { modifiers: s } = e;
            return "'".concat(s[0], "' modifier cannot be used with '").concat(s[1], "' modifier.");
          }), IndexSignatureHasAbstract: t("Index signatures cannot have the 'abstract' modifier."), IndexSignatureHasAccessibility: t((e) => {
            let { modifier: s } = e;
            return "Index signatures cannot have an accessibility modifier ('".concat(s, "').");
          }), IndexSignatureHasDeclare: t("Index signatures cannot have the 'declare' modifier."), IndexSignatureHasOverride: t("'override' modifier cannot appear on an index signature."), IndexSignatureHasStatic: t("Index signatures cannot have the 'static' modifier."), InitializerNotAllowedInAmbientContext: t("Initializers are not allowed in ambient contexts."), InvalidModifierOnTypeMember: t((e) => {
            let { modifier: s } = e;
            return "'".concat(s, "' modifier cannot appear on a type member.");
          }), InvalidModifierOnTypeParameter: t((e) => {
            let { modifier: s } = e;
            return "'".concat(s, "' modifier cannot appear on a type parameter.");
          }), InvalidModifierOnTypeParameterPositions: t((e) => {
            let { modifier: s } = e;
            return "'".concat(s, "' modifier can only appear on a type parameter of a class, interface or type alias.");
          }), InvalidModifiersOrder: t((e) => {
            let { orderedModifiers: s } = e;
            return "'".concat(s[0], "' modifier must precede '").concat(s[1], "' modifier.");
          }), InvalidTupleMemberLabel: t("Tuple members must be labeled with a simple identifier."), MissingInterfaceName: t("'interface' declarations must be followed by an identifier."), MixedLabeledAndUnlabeledElements: t("Tuple members must all have names or all not have names."), NonAbstractClassHasAbstractMethod: t("Abstract methods can only appear within an abstract class."), NonClassMethodPropertyHasAbstractModifer: t("'abstract' modifier can only appear on a class, method, or property declaration."), OptionalTypeBeforeRequired: t("A required element cannot follow an optional element."), OverrideNotInSubClass: t("This member cannot have an 'override' modifier because its containing class does not extend another class."), PatternIsOptional: t("A binding pattern parameter cannot be optional in an implementation signature."), PrivateElementHasAbstract: t("Private elements cannot have the 'abstract' modifier."), PrivateElementHasAccessibility: t((e) => {
            let { modifier: s } = e;
            return "Private elements cannot have an accessibility modifier ('".concat(s, "').");
          }), ReadonlyForMethodSignature: t("'readonly' modifier can only appear on a property declaration or index signature."), ReservedArrowTypeParam: t("This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma, as in `<T,>() => ...`."), ReservedTypeAssertion: t("This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead."), SetAccesorCannotHaveOptionalParameter: t("A 'set' accessor cannot have an optional parameter."), SetAccesorCannotHaveRestParameter: t("A 'set' accessor cannot have rest parameter."), SetAccesorCannotHaveReturnType: t("A 'set' accessor cannot have a return type annotation."), SingleTypeParameterWithoutTrailingComma: t((e) => {
            let { typeParameterName: s } = e;
            return "Single type parameter ".concat(s, " should have a trailing comma. Example usage: <").concat(s, ",>.");
          }), StaticBlockCannotHaveModifier: t("Static class blocks cannot have any modifier."), TypeAnnotationAfterAssign: t("Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`."), TypeImportCannotSpecifyDefaultAndNamed: t("A type-only import can specify a default import or named bindings, but not both."), TypeModifierIsUsedInTypeExports: t("The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement."), TypeModifierIsUsedInTypeImports: t("The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement."), UnexpectedParameterModifier: t("A parameter property is only allowed in a constructor implementation."), UnexpectedReadonly: t("'readonly' type modifier is only permitted on array and tuple literal types."), UnexpectedTypeAnnotation: t("Did not expect a type annotation here."), UnexpectedTypeCastInParameter: t("Unexpected type cast in parameter position."), UnsupportedImportTypeArgument: t("Argument in a type import must be a string literal."), UnsupportedParameterPropertyKind: t("A parameter property may not be declared using a binding pattern."), UnsupportedSignatureParameterKind: t((e) => {
            let { type: s } = e;
            return "Name in a signature must be an Identifier, ObjectPattern or ArrayPattern, instead got ".concat(s, ".");
          }) }));
          function qh(t) {
            switch (t) {
              case "any":
                return "TSAnyKeyword";
              case "boolean":
                return "TSBooleanKeyword";
              case "bigint":
                return "TSBigIntKeyword";
              case "never":
                return "TSNeverKeyword";
              case "number":
                return "TSNumberKeyword";
              case "object":
                return "TSObjectKeyword";
              case "string":
                return "TSStringKeyword";
              case "symbol":
                return "TSSymbolKeyword";
              case "undefined":
                return "TSUndefinedKeyword";
              case "unknown":
                return "TSUnknownKeyword";
              default:
                return;
            }
          }
          function Mr(t) {
            return t === "private" || t === "public" || t === "protected";
          }
          function Uh(t) {
            return t === "in" || t === "out";
          }
          var _h = (t) => class extends t {
            getScopeHandler() {
              return Bh;
            }
            tsIsIdentifier() {
              return K(this.state.type);
            }
            tsTokenCanFollowModifier() {
              return (this.match(0) || this.match(5) || this.match(55) || this.match(21) || this.match(134) || this.isLiteralPropertyName()) && !this.hasPrecedingLineBreak();
            }
            tsNextTokenCanFollowModifier() {
              return this.next(), this.tsTokenCanFollowModifier();
            }
            tsParseModifier(e, s) {
              if (!K(this.state.type) && this.state.type !== 58) return;
              let r = this.state.value;
              if (e.indexOf(r) !== -1) {
                if (s && this.tsIsStartOfStaticBlocks()) return;
                if (this.tsTryParse(this.tsNextTokenCanFollowModifier.bind(this))) return r;
              }
            }
            tsParseModifiers(e) {
              let { modified: s, allowedModifiers: r, disallowedModifiers: i, stopOnStartOfClassStaticBlock: a, errorTemplate: n = S.InvalidModifierOnTypeMember } = e, o = (f, y, P, v) => {
                y === P && s[v] && this.raise(S.InvalidModifiersOrder, { at: f, orderedModifiers: [P, v] });
              }, c = (f, y, P, v) => {
                (s[P] && y === v || s[v] && y === P) && this.raise(S.IncompatibleModifiers, { at: f, modifiers: [P, v] });
              };
              for (; ; ) {
                let { startLoc: f } = this.state, y = this.tsParseModifier(r.concat(i != null ? i : []), a);
                if (!y) break;
                Mr(y) ? s.accessibility ? this.raise(S.DuplicateAccessibilityModifier, { at: f, modifier: y }) : (o(f, y, y, "override"), o(f, y, y, "static"), o(f, y, y, "readonly"), s.accessibility = y) : Uh(y) ? (s[y] && this.raise(S.DuplicateModifier, { at: f, modifier: y }), s[y] = true, o(f, y, "in", "out")) : (Object.hasOwnProperty.call(s, y) ? this.raise(S.DuplicateModifier, { at: f, modifier: y }) : (o(f, y, "static", "readonly"), o(f, y, "static", "override"), o(f, y, "override", "readonly"), o(f, y, "abstract", "override"), c(f, y, "declare", "override"), c(f, y, "static", "abstract")), s[y] = true), i != null && i.includes(y) && this.raise(n, { at: f, modifier: y });
              }
            }
            tsIsListTerminator(e) {
              switch (e) {
                case "EnumMembers":
                case "TypeMembers":
                  return this.match(8);
                case "HeritageClauseElement":
                  return this.match(5);
                case "TupleElementTypes":
                  return this.match(3);
                case "TypeParametersOrArguments":
                  return this.match(48);
              }
              throw new Error("Unreachable");
            }
            tsParseList(e, s) {
              let r = [];
              for (; !this.tsIsListTerminator(e); ) r.push(s());
              return r;
            }
            tsParseDelimitedList(e, s, r) {
              return Rh(this.tsParseDelimitedListWorker(e, s, true, r));
            }
            tsParseDelimitedListWorker(e, s, r, i) {
              let a = [], n = -1;
              for (; !this.tsIsListTerminator(e); ) {
                n = -1;
                let o = s();
                if (o == null) return;
                if (a.push(o), this.eat(12)) {
                  n = this.state.lastTokStart;
                  continue;
                }
                if (this.tsIsListTerminator(e)) break;
                r && this.expect(12);
                return;
              }
              return i && (i.value = n), a;
            }
            tsParseBracketedList(e, s, r, i, a) {
              i || (r ? this.expect(0) : this.expect(47));
              let n = this.tsParseDelimitedList(e, s, a);
              return r ? this.expect(3) : this.expect(48), n;
            }
            tsParseImportType() {
              let e = this.startNode();
              return this.expect(83), this.expect(10), this.match(129) || this.raise(S.UnsupportedImportTypeArgument, { at: this.state.startLoc }), e.argument = this.parseExprAtom(), this.expect(11), this.eat(16) && (e.qualifier = this.tsParseEntityName()), this.match(47) && (e.typeParameters = this.tsParseTypeArguments()), this.finishNode(e, "TSImportType");
            }
            tsParseEntityName() {
              let e = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : true, s = this.parseIdentifier(e);
              for (; this.eat(16); ) {
                let r = this.startNodeAtNode(s);
                r.left = s, r.right = this.parseIdentifier(e), s = this.finishNode(r, "TSQualifiedName");
              }
              return s;
            }
            tsParseTypeReference() {
              let e = this.startNode();
              return e.typeName = this.tsParseEntityName(), !this.hasPrecedingLineBreak() && this.match(47) && (e.typeParameters = this.tsParseTypeArguments()), this.finishNode(e, "TSTypeReference");
            }
            tsParseThisTypePredicate(e) {
              this.next();
              let s = this.startNodeAtNode(e);
              return s.parameterName = e, s.typeAnnotation = this.tsParseTypeAnnotation(false), s.asserts = false, this.finishNode(s, "TSTypePredicate");
            }
            tsParseThisTypeNode() {
              let e = this.startNode();
              return this.next(), this.finishNode(e, "TSThisType");
            }
            tsParseTypeQuery() {
              let e = this.startNode();
              return this.expect(87), this.match(83) ? e.exprName = this.tsParseImportType() : e.exprName = this.tsParseEntityName(), !this.hasPrecedingLineBreak() && this.match(47) && (e.typeParameters = this.tsParseTypeArguments()), this.finishNode(e, "TSTypeQuery");
            }
            tsParseInOutModifiers(e) {
              this.tsParseModifiers({ modified: e, allowedModifiers: ["in", "out"], disallowedModifiers: ["public", "private", "protected", "readonly", "declare", "abstract", "override"], errorTemplate: S.InvalidModifierOnTypeParameter });
            }
            tsParseNoneModifiers(e) {
              this.tsParseModifiers({ modified: e, allowedModifiers: [], disallowedModifiers: ["in", "out"], errorTemplate: S.InvalidModifierOnTypeParameterPositions });
            }
            tsParseTypeParameter() {
              let e = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.tsParseNoneModifiers.bind(this), s = this.startNode();
              return e(s), s.name = this.tsParseTypeParameterName(), s.constraint = this.tsEatThenParseType(81), s.default = this.tsEatThenParseType(29), this.finishNode(s, "TSTypeParameter");
            }
            tsTryParseTypeParameters(e) {
              if (this.match(47)) return this.tsParseTypeParameters(e);
            }
            tsParseTypeParameters(e) {
              let s = this.startNode();
              this.match(47) || this.match(138) ? this.next() : this.unexpected();
              let r = { value: -1 };
              return s.params = this.tsParseBracketedList("TypeParametersOrArguments", this.tsParseTypeParameter.bind(this, e), false, true, r), s.params.length === 0 && this.raise(S.EmptyTypeParameters, { at: s }), r.value !== -1 && this.addExtra(s, "trailingComma", r.value), this.finishNode(s, "TSTypeParameterDeclaration");
            }
            tsTryNextParseConstantContext() {
              if (this.lookahead().type !== 75) return null;
              this.next();
              let e = this.tsParseTypeReference();
              return e.typeParameters && this.raise(S.CannotFindName, { at: e.typeName, name: "const" }), e;
            }
            tsFillSignature(e, s) {
              let r = e === 19, i = "parameters", a = "typeAnnotation";
              s.typeParameters = this.tsTryParseTypeParameters(), this.expect(10), s[i] = this.tsParseBindingListForSignature(), r ? s[a] = this.tsParseTypeOrTypePredicateAnnotation(e) : this.match(e) && (s[a] = this.tsParseTypeOrTypePredicateAnnotation(e));
            }
            tsParseBindingListForSignature() {
              return this.parseBindingList(11, 41).map((e) => (e.type !== "Identifier" && e.type !== "RestElement" && e.type !== "ObjectPattern" && e.type !== "ArrayPattern" && this.raise(S.UnsupportedSignatureParameterKind, { at: e, type: e.type }), e));
            }
            tsParseTypeMemberSemicolon() {
              !this.eat(12) && !this.isLineTerminator() && this.expect(13);
            }
            tsParseSignatureMember(e, s) {
              return this.tsFillSignature(14, s), this.tsParseTypeMemberSemicolon(), this.finishNode(s, e);
            }
            tsIsUnambiguouslyIndexSignature() {
              return this.next(), K(this.state.type) ? (this.next(), this.match(14)) : false;
            }
            tsTryParseIndexSignature(e) {
              if (!(this.match(0) && this.tsLookAhead(this.tsIsUnambiguouslyIndexSignature.bind(this)))) return;
              this.expect(0);
              let s = this.parseIdentifier();
              s.typeAnnotation = this.tsParseTypeAnnotation(), this.resetEndLocation(s), this.expect(3), e.parameters = [s];
              let r = this.tsTryParseTypeAnnotation();
              return r && (e.typeAnnotation = r), this.tsParseTypeMemberSemicolon(), this.finishNode(e, "TSIndexSignature");
            }
            tsParsePropertyOrMethodSignature(e, s) {
              this.eat(17) && (e.optional = true);
              let r = e;
              if (this.match(10) || this.match(47)) {
                s && this.raise(S.ReadonlyForMethodSignature, { at: e });
                let i = r;
                i.kind && this.match(47) && this.raise(S.AccesorCannotHaveTypeParameters, { at: this.state.curPosition() }), this.tsFillSignature(14, i), this.tsParseTypeMemberSemicolon();
                let a = "parameters", n = "typeAnnotation";
                if (i.kind === "get") i[a].length > 0 && (this.raise(u.BadGetterArity, { at: this.state.curPosition() }), this.isThisParam(i[a][0]) && this.raise(S.AccesorCannotDeclareThisParameter, { at: this.state.curPosition() }));
                else if (i.kind === "set") {
                  if (i[a].length !== 1) this.raise(u.BadSetterArity, { at: this.state.curPosition() });
                  else {
                    let o = i[a][0];
                    this.isThisParam(o) && this.raise(S.AccesorCannotDeclareThisParameter, { at: this.state.curPosition() }), o.type === "Identifier" && o.optional && this.raise(S.SetAccesorCannotHaveOptionalParameter, { at: this.state.curPosition() }), o.type === "RestElement" && this.raise(S.SetAccesorCannotHaveRestParameter, { at: this.state.curPosition() });
                  }
                  i[n] && this.raise(S.SetAccesorCannotHaveReturnType, { at: i[n] });
                } else i.kind = "method";
                return this.finishNode(i, "TSMethodSignature");
              } else {
                let i = r;
                s && (i.readonly = true);
                let a = this.tsTryParseTypeAnnotation();
                return a && (i.typeAnnotation = a), this.tsParseTypeMemberSemicolon(), this.finishNode(i, "TSPropertySignature");
              }
            }
            tsParseTypeMember() {
              let e = this.startNode();
              if (this.match(10) || this.match(47)) return this.tsParseSignatureMember("TSCallSignatureDeclaration", e);
              if (this.match(77)) {
                let r = this.startNode();
                return this.next(), this.match(10) || this.match(47) ? this.tsParseSignatureMember("TSConstructSignatureDeclaration", e) : (e.key = this.createIdentifier(r, "new"), this.tsParsePropertyOrMethodSignature(e, false));
              }
              this.tsParseModifiers({ modified: e, allowedModifiers: ["readonly"], disallowedModifiers: ["declare", "abstract", "private", "protected", "public", "static", "override"] });
              let s = this.tsTryParseIndexSignature(e);
              return s || (this.parsePropertyName(e), !e.computed && e.key.type === "Identifier" && (e.key.name === "get" || e.key.name === "set") && this.tsTokenCanFollowModifier() && (e.kind = e.key.name, this.parsePropertyName(e)), this.tsParsePropertyOrMethodSignature(e, !!e.readonly));
            }
            tsParseTypeLiteral() {
              let e = this.startNode();
              return e.members = this.tsParseObjectTypeMembers(), this.finishNode(e, "TSTypeLiteral");
            }
            tsParseObjectTypeMembers() {
              this.expect(5);
              let e = this.tsParseList("TypeMembers", this.tsParseTypeMember.bind(this));
              return this.expect(8), e;
            }
            tsIsStartOfMappedType() {
              return this.next(), this.eat(53) ? this.isContextual(118) : (this.isContextual(118) && this.next(), !this.match(0) || (this.next(), !this.tsIsIdentifier()) ? false : (this.next(), this.match(58)));
            }
            tsParseMappedTypeParameter() {
              let e = this.startNode();
              return e.name = this.tsParseTypeParameterName(), e.constraint = this.tsExpectThenParseType(58), this.finishNode(e, "TSTypeParameter");
            }
            tsParseMappedType() {
              let e = this.startNode();
              return this.expect(5), this.match(53) ? (e.readonly = this.state.value, this.next(), this.expectContextual(118)) : this.eatContextual(118) && (e.readonly = true), this.expect(0), e.typeParameter = this.tsParseMappedTypeParameter(), e.nameType = this.eatContextual(93) ? this.tsParseType() : null, this.expect(3), this.match(53) ? (e.optional = this.state.value, this.next(), this.expect(17)) : this.eat(17) && (e.optional = true), e.typeAnnotation = this.tsTryParseType(), this.semicolon(), this.expect(8), this.finishNode(e, "TSMappedType");
            }
            tsParseTupleType() {
              let e = this.startNode();
              e.elementTypes = this.tsParseBracketedList("TupleElementTypes", this.tsParseTupleElementType.bind(this), true, false);
              let s = false, r = null;
              return e.elementTypes.forEach((i) => {
                var a;
                let { type: n } = i;
                s && n !== "TSRestType" && n !== "TSOptionalType" && !(n === "TSNamedTupleMember" && i.optional) && this.raise(S.OptionalTypeBeforeRequired, { at: i }), s = s || n === "TSNamedTupleMember" && i.optional || n === "TSOptionalType", n === "TSRestType" && (i = i.typeAnnotation, n = i.type);
                let o = n === "TSNamedTupleMember";
                r = (a = r) != null ? a : o, r !== o && this.raise(S.MixedLabeledAndUnlabeledElements, { at: i });
              }), this.finishNode(e, "TSTupleType");
            }
            tsParseTupleElementType() {
              let { start: e, startLoc: s } = this.state, r = this.eat(21), i = this.tsParseType(), a = this.eat(17);
              if (this.eat(14)) {
                let o = this.startNodeAtNode(i);
                o.optional = a, i.type === "TSTypeReference" && !i.typeParameters && i.typeName.type === "Identifier" ? o.label = i.typeName : (this.raise(S.InvalidTupleMemberLabel, { at: i }), o.label = i), o.elementType = this.tsParseType(), i = this.finishNode(o, "TSNamedTupleMember");
              } else if (a) {
                let o = this.startNodeAtNode(i);
                o.typeAnnotation = i, i = this.finishNode(o, "TSOptionalType");
              }
              if (r) {
                let o = this.startNodeAt(e, s);
                o.typeAnnotation = i, i = this.finishNode(o, "TSRestType");
              }
              return i;
            }
            tsParseParenthesizedType() {
              let e = this.startNode();
              return this.expect(10), e.typeAnnotation = this.tsParseType(), this.expect(11), this.finishNode(e, "TSParenthesizedType");
            }
            tsParseFunctionOrConstructorType(e, s) {
              let r = this.startNode();
              return e === "TSConstructorType" && (r.abstract = !!s, s && this.next(), this.next()), this.tsFillSignature(19, r), this.finishNode(r, e);
            }
            tsParseLiteralTypeNode() {
              let e = this.startNode();
              return e.literal = (() => {
                switch (this.state.type) {
                  case 130:
                  case 131:
                  case 129:
                  case 85:
                  case 86:
                    return this.parseExprAtom();
                  default:
                    throw this.unexpected();
                }
              })(), this.finishNode(e, "TSLiteralType");
            }
            tsParseTemplateLiteralType() {
              let e = this.startNode();
              return e.literal = this.parseTemplate(false), this.finishNode(e, "TSLiteralType");
            }
            parseTemplateSubstitution() {
              return this.state.inType ? this.tsParseType() : super.parseTemplateSubstitution();
            }
            tsParseThisTypeOrThisTypePredicate() {
              let e = this.tsParseThisTypeNode();
              return this.isContextual(113) && !this.hasPrecedingLineBreak() ? this.tsParseThisTypePredicate(e) : e;
            }
            tsParseNonArrayType() {
              switch (this.state.type) {
                case 129:
                case 130:
                case 131:
                case 85:
                case 86:
                  return this.tsParseLiteralTypeNode();
                case 53:
                  if (this.state.value === "-") {
                    let e = this.startNode(), s = this.lookahead();
                    if (s.type !== 130 && s.type !== 131) throw this.unexpected();
                    return e.literal = this.parseMaybeUnary(), this.finishNode(e, "TSLiteralType");
                  }
                  break;
                case 78:
                  return this.tsParseThisTypeOrThisTypePredicate();
                case 87:
                  return this.tsParseTypeQuery();
                case 83:
                  return this.tsParseImportType();
                case 5:
                  return this.tsLookAhead(this.tsIsStartOfMappedType.bind(this)) ? this.tsParseMappedType() : this.tsParseTypeLiteral();
                case 0:
                  return this.tsParseTupleType();
                case 10:
                  return this.tsParseParenthesizedType();
                case 25:
                case 24:
                  return this.tsParseTemplateLiteralType();
                default: {
                  let { type: e } = this.state;
                  if (K(e) || e === 88 || e === 84) {
                    let s = e === 88 ? "TSVoidKeyword" : e === 84 ? "TSNullKeyword" : qh(this.state.value);
                    if (s !== void 0 && this.lookaheadCharCode() !== 46) {
                      let r = this.startNode();
                      return this.next(), this.finishNode(r, s);
                    }
                    return this.tsParseTypeReference();
                  }
                }
              }
              throw this.unexpected();
            }
            tsParseArrayTypeOrHigher() {
              let e = this.tsParseNonArrayType();
              for (; !this.hasPrecedingLineBreak() && this.eat(0); ) if (this.match(3)) {
                let s = this.startNodeAtNode(e);
                s.elementType = e, this.expect(3), e = this.finishNode(s, "TSArrayType");
              } else {
                let s = this.startNodeAtNode(e);
                s.objectType = e, s.indexType = this.tsParseType(), this.expect(3), e = this.finishNode(s, "TSIndexedAccessType");
              }
              return e;
            }
            tsParseTypeOperator() {
              let e = this.startNode(), s = this.state.value;
              return this.next(), e.operator = s, e.typeAnnotation = this.tsParseTypeOperatorOrHigher(), s === "readonly" && this.tsCheckTypeAnnotationForReadOnly(e), this.finishNode(e, "TSTypeOperator");
            }
            tsCheckTypeAnnotationForReadOnly(e) {
              switch (e.typeAnnotation.type) {
                case "TSTupleType":
                case "TSArrayType":
                  return;
                default:
                  this.raise(S.UnexpectedReadonly, { at: e });
              }
            }
            tsParseInferType() {
              let e = this.startNode();
              this.expectContextual(112);
              let s = this.startNode();
              return s.name = this.tsParseTypeParameterName(), s.constraint = this.tsTryParse(() => this.tsParseConstraintForInferType()), e.typeParameter = this.finishNode(s, "TSTypeParameter"), this.finishNode(e, "TSInferType");
            }
            tsParseConstraintForInferType() {
              if (this.eat(81)) {
                let e = this.tsInDisallowConditionalTypesContext(() => this.tsParseType());
                if (this.state.inDisallowConditionalTypesContext || !this.match(17)) return e;
              }
            }
            tsParseTypeOperatorOrHigher() {
              return Fo(this.state.type) && !this.state.containsEsc ? this.tsParseTypeOperator() : this.isContextual(112) ? this.tsParseInferType() : this.tsInAllowConditionalTypesContext(() => this.tsParseArrayTypeOrHigher());
            }
            tsParseUnionOrIntersectionType(e, s, r) {
              let i = this.startNode(), a = this.eat(r), n = [];
              do
                n.push(s());
              while (this.eat(r));
              return n.length === 1 && !a ? n[0] : (i.types = n, this.finishNode(i, e));
            }
            tsParseIntersectionTypeOrHigher() {
              return this.tsParseUnionOrIntersectionType("TSIntersectionType", this.tsParseTypeOperatorOrHigher.bind(this), 45);
            }
            tsParseUnionTypeOrHigher() {
              return this.tsParseUnionOrIntersectionType("TSUnionType", this.tsParseIntersectionTypeOrHigher.bind(this), 43);
            }
            tsIsStartOfFunctionType() {
              return this.match(47) ? true : this.match(10) && this.tsLookAhead(this.tsIsUnambiguouslyStartOfFunctionType.bind(this));
            }
            tsSkipParameterStart() {
              if (K(this.state.type) || this.match(78)) return this.next(), true;
              if (this.match(5)) {
                let { errors: e } = this.state, s = e.length;
                try {
                  return this.parseObjectLike(8, true), e.length === s;
                } catch {
                  return false;
                }
              }
              if (this.match(0)) {
                this.next();
                let { errors: e } = this.state, s = e.length;
                try {
                  return this.parseBindingList(3, 93, true), e.length === s;
                } catch {
                  return false;
                }
              }
              return false;
            }
            tsIsUnambiguouslyStartOfFunctionType() {
              return this.next(), !!(this.match(11) || this.match(21) || this.tsSkipParameterStart() && (this.match(14) || this.match(12) || this.match(17) || this.match(29) || this.match(11) && (this.next(), this.match(19))));
            }
            tsParseTypeOrTypePredicateAnnotation(e) {
              return this.tsInType(() => {
                let s = this.startNode();
                this.expect(e);
                let r = this.startNode(), i = !!this.tsTryParse(this.tsParseTypePredicateAsserts.bind(this));
                if (i && this.match(78)) {
                  let o = this.tsParseThisTypeOrThisTypePredicate();
                  return o.type === "TSThisType" ? (r.parameterName = o, r.asserts = true, r.typeAnnotation = null, o = this.finishNode(r, "TSTypePredicate")) : (this.resetStartLocationFromNode(o, r), o.asserts = true), s.typeAnnotation = o, this.finishNode(s, "TSTypeAnnotation");
                }
                let a = this.tsIsIdentifier() && this.tsTryParse(this.tsParseTypePredicatePrefix.bind(this));
                if (!a) return i ? (r.parameterName = this.parseIdentifier(), r.asserts = i, r.typeAnnotation = null, s.typeAnnotation = this.finishNode(r, "TSTypePredicate"), this.finishNode(s, "TSTypeAnnotation")) : this.tsParseTypeAnnotation(false, s);
                let n = this.tsParseTypeAnnotation(false);
                return r.parameterName = a, r.typeAnnotation = n, r.asserts = i, s.typeAnnotation = this.finishNode(r, "TSTypePredicate"), this.finishNode(s, "TSTypeAnnotation");
              });
            }
            tsTryParseTypeOrTypePredicateAnnotation() {
              return this.match(14) ? this.tsParseTypeOrTypePredicateAnnotation(14) : void 0;
            }
            tsTryParseTypeAnnotation() {
              return this.match(14) ? this.tsParseTypeAnnotation() : void 0;
            }
            tsTryParseType() {
              return this.tsEatThenParseType(14);
            }
            tsParseTypePredicatePrefix() {
              let e = this.parseIdentifier();
              if (this.isContextual(113) && !this.hasPrecedingLineBreak()) return this.next(), e;
            }
            tsParseTypePredicateAsserts() {
              if (this.state.type !== 106) return false;
              let e = this.state.containsEsc;
              return this.next(), !K(this.state.type) && !this.match(78) ? false : (e && this.raise(u.InvalidEscapedReservedWord, { at: this.state.lastTokStartLoc, reservedWord: "asserts" }), true);
            }
            tsParseTypeAnnotation() {
              let e = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : true, s = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.startNode();
              return this.tsInType(() => {
                e && this.expect(14), s.typeAnnotation = this.tsParseType();
              }), this.finishNode(s, "TSTypeAnnotation");
            }
            tsParseType() {
              Br(this.state.inType);
              let e = this.tsParseNonConditionalType();
              if (this.state.inDisallowConditionalTypesContext || this.hasPrecedingLineBreak() || !this.eat(81)) return e;
              let s = this.startNodeAtNode(e);
              return s.checkType = e, s.extendsType = this.tsInDisallowConditionalTypesContext(() => this.tsParseNonConditionalType()), this.expect(17), s.trueType = this.tsInAllowConditionalTypesContext(() => this.tsParseType()), this.expect(14), s.falseType = this.tsInAllowConditionalTypesContext(() => this.tsParseType()), this.finishNode(s, "TSConditionalType");
            }
            isAbstractConstructorSignature() {
              return this.isContextual(120) && this.lookahead().type === 77;
            }
            tsParseNonConditionalType() {
              return this.tsIsStartOfFunctionType() ? this.tsParseFunctionOrConstructorType("TSFunctionType") : this.match(77) ? this.tsParseFunctionOrConstructorType("TSConstructorType") : this.isAbstractConstructorSignature() ? this.tsParseFunctionOrConstructorType("TSConstructorType", true) : this.tsParseUnionTypeOrHigher();
            }
            tsParseTypeAssertion() {
              this.getPluginOption("typescript", "disallowAmbiguousJSXLike") && this.raise(S.ReservedTypeAssertion, { at: this.state.startLoc });
              let e = this.startNode(), s = this.tsTryNextParseConstantContext();
              return e.typeAnnotation = s || this.tsNextThenParseType(), this.expect(48), e.expression = this.parseMaybeUnary(), this.finishNode(e, "TSTypeAssertion");
            }
            tsParseHeritageClause(e) {
              let s = this.state.startLoc, r = this.tsParseDelimitedList("HeritageClauseElement", () => {
                let i = this.startNode();
                return i.expression = this.tsParseEntityName(), this.match(47) && (i.typeParameters = this.tsParseTypeArguments()), this.finishNode(i, "TSExpressionWithTypeArguments");
              });
              return r.length || this.raise(S.EmptyHeritageClauseType, { at: s, token: e }), r;
            }
            tsParseInterfaceDeclaration(e) {
              let s = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
              if (this.hasFollowingLineBreak()) return null;
              this.expectContextual(125), s.declare && (e.declare = true), K(this.state.type) ? (e.id = this.parseIdentifier(), this.checkIdentifier(e.id, Wo)) : (e.id = null, this.raise(S.MissingInterfaceName, { at: this.state.startLoc })), e.typeParameters = this.tsTryParseTypeParameters(this.tsParseInOutModifiers.bind(this)), this.eat(81) && (e.extends = this.tsParseHeritageClause("extends"));
              let r = this.startNode();
              return r.body = this.tsInType(this.tsParseObjectTypeMembers.bind(this)), e.body = this.finishNode(r, "TSInterfaceBody"), this.finishNode(e, "TSInterfaceDeclaration");
            }
            tsParseTypeAliasDeclaration(e) {
              return e.id = this.parseIdentifier(), this.checkIdentifier(e.id, Go), e.typeAnnotation = this.tsInType(() => {
                if (e.typeParameters = this.tsTryParseTypeParameters(this.tsParseInOutModifiers.bind(this)), this.expect(29), this.isContextual(111) && this.lookahead().type !== 16) {
                  let s = this.startNode();
                  return this.next(), this.finishNode(s, "TSIntrinsicKeyword");
                }
                return this.tsParseType();
              }), this.semicolon(), this.finishNode(e, "TSTypeAliasDeclaration");
            }
            tsInNoContext(e) {
              let s = this.state.context;
              this.state.context = [s[0]];
              try {
                return e();
              } finally {
                this.state.context = s;
              }
            }
            tsInType(e) {
              let s = this.state.inType;
              this.state.inType = true;
              try {
                return e();
              } finally {
                this.state.inType = s;
              }
            }
            tsInDisallowConditionalTypesContext(e) {
              let s = this.state.inDisallowConditionalTypesContext;
              this.state.inDisallowConditionalTypesContext = true;
              try {
                return e();
              } finally {
                this.state.inDisallowConditionalTypesContext = s;
              }
            }
            tsInAllowConditionalTypesContext(e) {
              let s = this.state.inDisallowConditionalTypesContext;
              this.state.inDisallowConditionalTypesContext = false;
              try {
                return e();
              } finally {
                this.state.inDisallowConditionalTypesContext = s;
              }
            }
            tsEatThenParseType(e) {
              return this.match(e) ? this.tsNextThenParseType() : void 0;
            }
            tsExpectThenParseType(e) {
              return this.tsDoThenParseType(() => this.expect(e));
            }
            tsNextThenParseType() {
              return this.tsDoThenParseType(() => this.next());
            }
            tsDoThenParseType(e) {
              return this.tsInType(() => (e(), this.tsParseType()));
            }
            tsParseEnumMember() {
              let e = this.startNode();
              return e.id = this.match(129) ? this.parseExprAtom() : this.parseIdentifier(true), this.eat(29) && (e.initializer = this.parseMaybeAssignAllowIn()), this.finishNode(e, "TSEnumMember");
            }
            tsParseEnumDeclaration(e) {
              let s = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
              return s.const && (e.const = true), s.declare && (e.declare = true), this.expectContextual(122), e.id = this.parseIdentifier(), this.checkIdentifier(e.id, e.const ? Jo : Er), this.expect(5), e.members = this.tsParseDelimitedList("EnumMembers", this.tsParseEnumMember.bind(this)), this.expect(8), this.finishNode(e, "TSEnumDeclaration");
            }
            tsParseModuleBlock() {
              let e = this.startNode();
              return this.scope.enter(Me), this.expect(5), this.parseBlockOrModuleBlockBody(e.body = [], void 0, true, 8), this.scope.exit(), this.finishNode(e, "TSModuleBlock");
            }
            tsParseModuleOrNamespaceDeclaration(e) {
              let s = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              if (e.id = this.parseIdentifier(), s || this.checkIdentifier(e.id, Yo), this.eat(16)) {
                let r = this.startNode();
                this.tsParseModuleOrNamespaceDeclaration(r, true), e.body = r;
              } else this.scope.enter(ht), this.prodParam.enter(je), e.body = this.tsParseModuleBlock(), this.prodParam.exit(), this.scope.exit();
              return this.finishNode(e, "TSModuleDeclaration");
            }
            tsParseAmbientExternalModuleDeclaration(e) {
              return this.isContextual(109) ? (e.global = true, e.id = this.parseIdentifier()) : this.match(129) ? e.id = this.parseExprAtom() : this.unexpected(), this.match(5) ? (this.scope.enter(ht), this.prodParam.enter(je), e.body = this.tsParseModuleBlock(), this.prodParam.exit(), this.scope.exit()) : this.semicolon(), this.finishNode(e, "TSModuleDeclaration");
            }
            tsParseImportEqualsDeclaration(e, s) {
              e.isExport = s || false, e.id = this.parseIdentifier(), this.checkIdentifier(e.id, xe), this.expect(29);
              let r = this.tsParseModuleReference();
              return e.importKind === "type" && r.type !== "TSExternalModuleReference" && this.raise(S.ImportAliasHasImportType, { at: r }), e.moduleReference = r, this.semicolon(), this.finishNode(e, "TSImportEqualsDeclaration");
            }
            tsIsExternalModuleReference() {
              return this.isContextual(116) && this.lookaheadCharCode() === 40;
            }
            tsParseModuleReference() {
              return this.tsIsExternalModuleReference() ? this.tsParseExternalModuleReference() : this.tsParseEntityName(false);
            }
            tsParseExternalModuleReference() {
              let e = this.startNode();
              if (this.expectContextual(116), this.expect(10), !this.match(129)) throw this.unexpected();
              return e.expression = this.parseExprAtom(), this.expect(11), this.finishNode(e, "TSExternalModuleReference");
            }
            tsLookAhead(e) {
              let s = this.state.clone(), r = e();
              return this.state = s, r;
            }
            tsTryParseAndCatch(e) {
              let s = this.tryParse((r) => e() || r());
              if (!(s.aborted || !s.node)) return s.error && (this.state = s.failState), s.node;
            }
            tsTryParse(e) {
              let s = this.state.clone(), r = e();
              if (r !== void 0 && r !== false) return r;
              this.state = s;
            }
            tsTryParseDeclare(e) {
              if (this.isLineTerminator()) return;
              let s = this.state.type, r;
              return this.isContextual(99) && (s = 74, r = "let"), this.tsInAmbientContext(() => {
                if (s === 68) return e.declare = true, this.parseFunctionStatement(e, false, true);
                if (s === 80) return e.declare = true, this.parseClass(e, true, false);
                if (s === 122) return this.tsParseEnumDeclaration(e, { declare: true });
                if (s === 109) return this.tsParseAmbientExternalModuleDeclaration(e);
                if (s === 75 || s === 74) return !this.match(75) || !this.isLookaheadContextual("enum") ? (e.declare = true, this.parseVarStatement(e, r || this.state.value, true)) : (this.expect(75), this.tsParseEnumDeclaration(e, { const: true, declare: true }));
                if (s === 125) {
                  let i = this.tsParseInterfaceDeclaration(e, { declare: true });
                  if (i) return i;
                }
                if (K(s)) return this.tsParseDeclaration(e, this.state.value, true);
              });
            }
            tsTryParseExportDeclaration() {
              return this.tsParseDeclaration(this.startNode(), this.state.value, true);
            }
            tsParseExpressionStatement(e, s) {
              switch (s.name) {
                case "declare": {
                  let r = this.tsTryParseDeclare(e);
                  if (r) return r.declare = true, r;
                  break;
                }
                case "global":
                  if (this.match(5)) {
                    this.scope.enter(ht), this.prodParam.enter(je);
                    let r = e;
                    return r.global = true, r.id = s, r.body = this.tsParseModuleBlock(), this.scope.exit(), this.prodParam.exit(), this.finishNode(r, "TSModuleDeclaration");
                  }
                  break;
                default:
                  return this.tsParseDeclaration(e, s.name, false);
              }
            }
            tsParseDeclaration(e, s, r) {
              switch (s) {
                case "abstract":
                  if (this.tsCheckLineTerminator(r) && (this.match(80) || K(this.state.type))) return this.tsParseAbstractDeclaration(e);
                  break;
                case "module":
                  if (this.tsCheckLineTerminator(r)) {
                    if (this.match(129)) return this.tsParseAmbientExternalModuleDeclaration(e);
                    if (K(this.state.type)) return this.tsParseModuleOrNamespaceDeclaration(e);
                  }
                  break;
                case "namespace":
                  if (this.tsCheckLineTerminator(r) && K(this.state.type)) return this.tsParseModuleOrNamespaceDeclaration(e);
                  break;
                case "type":
                  if (this.tsCheckLineTerminator(r) && K(this.state.type)) return this.tsParseTypeAliasDeclaration(e);
                  break;
              }
            }
            tsCheckLineTerminator(e) {
              return e ? this.hasFollowingLineBreak() ? false : (this.next(), true) : !this.isLineTerminator();
            }
            tsTryParseGenericAsyncArrowFunction(e, s) {
              if (!this.match(47)) return;
              let r = this.state.maybeInArrowParameters;
              this.state.maybeInArrowParameters = true;
              let i = this.tsTryParseAndCatch(() => {
                let a = this.startNodeAt(e, s);
                return a.typeParameters = this.tsParseTypeParameters(), super.parseFunctionParams(a), a.returnType = this.tsTryParseTypeOrTypePredicateAnnotation(), this.expect(19), a;
              });
              if (this.state.maybeInArrowParameters = r, !!i) return this.parseArrowExpression(i, null, true);
            }
            tsParseTypeArgumentsInExpression() {
              if (this.reScan_lt() === 47) return this.tsParseTypeArguments();
            }
            tsParseTypeArguments() {
              let e = this.startNode();
              return e.params = this.tsInType(() => this.tsInNoContext(() => (this.expect(47), this.tsParseDelimitedList("TypeParametersOrArguments", this.tsParseType.bind(this))))), e.params.length === 0 && this.raise(S.EmptyTypeArguments, { at: e }), this.expect(48), this.finishNode(e, "TSTypeParameterInstantiation");
            }
            tsIsDeclarationStart() {
              return Lo(this.state.type);
            }
            isExportDefaultSpecifier() {
              return this.tsIsDeclarationStart() ? false : super.isExportDefaultSpecifier();
            }
            parseAssignableListItem(e, s) {
              let r = this.state.start, i = this.state.startLoc, a, n = false, o = false;
              if (e !== void 0) {
                let y = {};
                this.tsParseModifiers({ modified: y, allowedModifiers: ["public", "private", "protected", "override", "readonly"] }), a = y.accessibility, o = y.override, n = y.readonly, e === false && (a || n || o) && this.raise(S.UnexpectedParameterModifier, { at: i });
              }
              let c = this.parseMaybeDefault();
              this.parseAssignableListItemTypes(c);
              let f = this.parseMaybeDefault(c.start, c.loc.start, c);
              if (a || n || o) {
                let y = this.startNodeAt(r, i);
                return s.length && (y.decorators = s), a && (y.accessibility = a), n && (y.readonly = n), o && (y.override = o), f.type !== "Identifier" && f.type !== "AssignmentPattern" && this.raise(S.UnsupportedParameterPropertyKind, { at: y }), y.parameter = f, this.finishNode(y, "TSParameterProperty");
              }
              return s.length && (c.decorators = s), f;
            }
            isSimpleParameter(e) {
              return e.type === "TSParameterProperty" && super.isSimpleParameter(e.parameter) || super.isSimpleParameter(e);
            }
            parseFunctionBodyAndFinish(e, s) {
              let r = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
              this.match(14) && (e.returnType = this.tsParseTypeOrTypePredicateAnnotation(14));
              let i = s === "FunctionDeclaration" ? "TSDeclareFunction" : s === "ClassMethod" || s === "ClassPrivateMethod" ? "TSDeclareMethod" : void 0;
              if (i && !this.match(5) && this.isLineTerminator()) {
                this.finishNode(e, i);
                return;
              }
              if (i === "TSDeclareFunction" && this.state.isAmbientContext && (this.raise(S.DeclareFunctionHasImplementation, { at: e }), e.declare)) {
                super.parseFunctionBodyAndFinish(e, i, r);
                return;
              }
              super.parseFunctionBodyAndFinish(e, s, r);
            }
            registerFunctionStatementId(e) {
              !e.body && e.id ? this.checkIdentifier(e.id, Cr) : super.registerFunctionStatementId(...arguments);
            }
            tsCheckForInvalidTypeCasts(e) {
              e.forEach((s) => {
                (s == null ? void 0 : s.type) === "TSTypeCastExpression" && this.raise(S.UnexpectedTypeAnnotation, { at: s.typeAnnotation });
              });
            }
            toReferencedList(e, s) {
              return this.tsCheckForInvalidTypeCasts(e), e;
            }
            parseArrayLike() {
              let e = super.parseArrayLike(...arguments);
              return e.type === "ArrayExpression" && this.tsCheckForInvalidTypeCasts(e.elements), e;
            }
            parseSubscript(e, s, r, i, a) {
              if (!this.hasPrecedingLineBreak() && this.match(35)) {
                this.state.canStartJSXElement = false, this.next();
                let o = this.startNodeAt(s, r);
                return o.expression = e, this.finishNode(o, "TSNonNullExpression");
              }
              let n = false;
              if (this.match(18) && this.lookaheadCharCode() === 60) {
                if (i) return a.stop = true, e;
                a.optionalChainMember = n = true, this.next();
              }
              if (this.match(47) || this.match(51)) {
                let o, c = this.tsTryParseAndCatch(() => {
                  if (!i && this.atPossibleAsyncArrow(e)) {
                    let P = this.tsTryParseGenericAsyncArrowFunction(s, r);
                    if (P) return P;
                  }
                  let f = this.tsParseTypeArgumentsInExpression();
                  if (!f) throw this.unexpected();
                  if (n && !this.match(10)) throw o = this.state.curPosition(), this.unexpected();
                  if (nt(this.state.type)) {
                    let P = this.parseTaggedTemplateExpression(e, s, r, a);
                    return P.typeParameters = f, P;
                  }
                  if (!i && this.eat(10)) {
                    let P = this.startNodeAt(s, r);
                    return P.callee = e, P.arguments = this.parseCallExpressionArguments(11, false), this.tsCheckForInvalidTypeCasts(P.arguments), P.typeParameters = f, a.optionalChainMember && (P.optional = n), this.finishCallExpression(P, a.optionalChainMember);
                  }
                  if (jh(this.state.type) && this.state.type !== 10) throw this.unexpected();
                  let y = this.startNodeAt(s, r);
                  return y.expression = e, y.typeParameters = f, this.finishNode(y, "TSInstantiationExpression");
                });
                if (o && this.unexpected(o, 10), c) return c;
              }
              return super.parseSubscript(e, s, r, i, a);
            }
            parseNewCallee(e) {
              var s;
              super.parseNewCallee(e);
              let { callee: r } = e;
              r.type === "TSInstantiationExpression" && !((s = r.extra) != null && s.parenthesized) && (e.typeParameters = r.typeParameters, e.callee = r.expression);
            }
            parseExprOp(e, s, r, i) {
              if (at(58) > i && !this.hasPrecedingLineBreak() && this.isContextual(93)) {
                let a = this.startNodeAt(s, r);
                a.expression = e;
                let n = this.tsTryNextParseConstantContext();
                return n ? a.typeAnnotation = n : a.typeAnnotation = this.tsNextThenParseType(), this.finishNode(a, "TSAsExpression"), this.reScan_lt_gt(), this.parseExprOp(a, s, r, i);
              }
              return super.parseExprOp(e, s, r, i);
            }
            checkReservedWord(e, s, r, i) {
              this.state.isAmbientContext || super.checkReservedWord(e, s, r, i);
            }
            checkDuplicateExports() {
            }
            parseImport(e) {
              if (e.importKind = "value", K(this.state.type) || this.match(55) || this.match(5)) {
                let r = this.lookahead();
                if (this.isContextual(126) && r.type !== 12 && r.type !== 97 && r.type !== 29 && (e.importKind = "type", this.next(), r = this.lookahead()), K(this.state.type) && r.type === 29) return this.tsParseImportEqualsDeclaration(e);
              }
              let s = super.parseImport(e);
              return s.importKind === "type" && s.specifiers.length > 1 && s.specifiers[0].type === "ImportDefaultSpecifier" && this.raise(S.TypeImportCannotSpecifyDefaultAndNamed, { at: s }), s;
            }
            parseExport(e) {
              if (this.match(83)) return this.next(), this.isContextual(126) && this.lookaheadCharCode() !== 61 ? (e.importKind = "type", this.next()) : e.importKind = "value", this.tsParseImportEqualsDeclaration(e, true);
              if (this.eat(29)) {
                let s = e;
                return s.expression = this.parseExpression(), this.semicolon(), this.finishNode(s, "TSExportAssignment");
              } else if (this.eatContextual(93)) {
                let s = e;
                return this.expectContextual(124), s.id = this.parseIdentifier(), this.semicolon(), this.finishNode(s, "TSNamespaceExportDeclaration");
              } else return this.isContextual(126) && this.lookahead().type === 5 ? (this.next(), e.exportKind = "type") : e.exportKind = "value", super.parseExport(e);
            }
            isAbstractClass() {
              return this.isContextual(120) && this.lookahead().type === 80;
            }
            parseExportDefaultExpression() {
              if (this.isAbstractClass()) {
                let e = this.startNode();
                return this.next(), e.abstract = true, this.parseClass(e, true, true), e;
              }
              if (this.match(125)) {
                let e = this.tsParseInterfaceDeclaration(this.startNode());
                if (e) return e;
              }
              return super.parseExportDefaultExpression();
            }
            parseVarStatement(e, s) {
              let r = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, { isAmbientContext: i } = this.state, a = super.parseVarStatement(e, s, r || i);
              if (!i) return a;
              for (let { id: n, init: o } of a.declarations) !o || (s !== "const" || !!n.typeAnnotation ? this.raise(S.InitializerNotAllowedInAmbientContext, { at: o }) : o.type !== "StringLiteral" && o.type !== "BooleanLiteral" && o.type !== "NumericLiteral" && o.type !== "BigIntLiteral" && (o.type !== "TemplateLiteral" || o.expressions.length > 0) && !zh(o) && this.raise(S.ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference, { at: o }));
              return a;
            }
            parseStatementContent(e, s) {
              if (this.match(75) && this.isLookaheadContextual("enum")) {
                let r = this.startNode();
                return this.expect(75), this.tsParseEnumDeclaration(r, { const: true });
              }
              if (this.isContextual(122)) return this.tsParseEnumDeclaration(this.startNode());
              if (this.isContextual(125)) {
                let r = this.tsParseInterfaceDeclaration(this.startNode());
                if (r) return r;
              }
              return super.parseStatementContent(e, s);
            }
            parseAccessModifier() {
              return this.tsParseModifier(["public", "protected", "private"]);
            }
            tsHasSomeModifiers(e, s) {
              return s.some((r) => Mr(r) ? e.accessibility === r : !!e[r]);
            }
            tsIsStartOfStaticBlocks() {
              return this.isContextual(104) && this.lookaheadCharCode() === 123;
            }
            parseClassMember(e, s, r) {
              let i = ["declare", "private", "public", "protected", "override", "abstract", "readonly", "static"];
              this.tsParseModifiers({ modified: s, allowedModifiers: i, disallowedModifiers: ["in", "out"], stopOnStartOfClassStaticBlock: true, errorTemplate: S.InvalidModifierOnTypeParameterPositions });
              let a = () => {
                this.tsIsStartOfStaticBlocks() ? (this.next(), this.next(), this.tsHasSomeModifiers(s, i) && this.raise(S.StaticBlockCannotHaveModifier, { at: this.state.curPosition() }), this.parseClassStaticBlock(e, s)) : this.parseClassMemberWithIsStatic(e, s, r, !!s.static);
              };
              s.declare ? this.tsInAmbientContext(a) : a();
            }
            parseClassMemberWithIsStatic(e, s, r, i) {
              let a = this.tsTryParseIndexSignature(s);
              if (a) {
                e.body.push(a), s.abstract && this.raise(S.IndexSignatureHasAbstract, { at: s }), s.accessibility && this.raise(S.IndexSignatureHasAccessibility, { at: s, modifier: s.accessibility }), s.declare && this.raise(S.IndexSignatureHasDeclare, { at: s }), s.override && this.raise(S.IndexSignatureHasOverride, { at: s });
                return;
              }
              !this.state.inAbstractClass && s.abstract && this.raise(S.NonAbstractClassHasAbstractMethod, { at: s }), s.override && (r.hadSuperClass || this.raise(S.OverrideNotInSubClass, { at: s })), super.parseClassMemberWithIsStatic(e, s, r, i);
            }
            parsePostMemberNameModifiers(e) {
              this.eat(17) && (e.optional = true), e.readonly && this.match(10) && this.raise(S.ClassMethodHasReadonly, { at: e }), e.declare && this.match(10) && this.raise(S.ClassMethodHasDeclare, { at: e });
            }
            parseExpressionStatement(e, s) {
              return (s.type === "Identifier" ? this.tsParseExpressionStatement(e, s) : void 0) || super.parseExpressionStatement(e, s);
            }
            shouldParseExportDeclaration() {
              return this.tsIsDeclarationStart() ? true : super.shouldParseExportDeclaration();
            }
            parseConditional(e, s, r, i) {
              if (!this.state.maybeInArrowParameters || !this.match(17)) return super.parseConditional(e, s, r, i);
              let a = this.tryParse(() => super.parseConditional(e, s, r));
              return a.node ? (a.error && (this.state = a.failState), a.node) : (a.error && super.setOptionalParametersError(i, a.error), e);
            }
            parseParenItem(e, s, r) {
              if (e = super.parseParenItem(e, s, r), this.eat(17) && (e.optional = true, this.resetEndLocation(e)), this.match(14)) {
                let i = this.startNodeAt(s, r);
                return i.expression = e, i.typeAnnotation = this.tsParseTypeAnnotation(), this.finishNode(i, "TSTypeCastExpression");
              }
              return e;
            }
            parseExportDeclaration(e) {
              if (!this.state.isAmbientContext && this.isContextual(121)) return this.tsInAmbientContext(() => this.parseExportDeclaration(e));
              let s = this.state.start, r = this.state.startLoc, i = this.eatContextual(121);
              if (i && (this.isContextual(121) || !this.shouldParseExportDeclaration())) throw this.raise(S.ExpectedAmbientAfterExportDeclare, { at: this.state.startLoc });
              let n = K(this.state.type) && this.tsTryParseExportDeclaration() || super.parseExportDeclaration(e);
              return n ? ((n.type === "TSInterfaceDeclaration" || n.type === "TSTypeAliasDeclaration" || i) && (e.exportKind = "type"), i && (this.resetStartLocation(n, s, r), n.declare = true), n) : null;
            }
            parseClassId(e, s, r) {
              if ((!s || r) && this.isContextual(110)) return;
              super.parseClassId(e, s, r, e.declare ? Cr : Pr);
              let i = this.tsTryParseTypeParameters(this.tsParseInOutModifiers.bind(this));
              i && (e.typeParameters = i);
            }
            parseClassPropertyAnnotation(e) {
              !e.optional && this.eat(35) && (e.definite = true);
              let s = this.tsTryParseTypeAnnotation();
              s && (e.typeAnnotation = s);
            }
            parseClassProperty(e) {
              if (this.parseClassPropertyAnnotation(e), this.state.isAmbientContext && this.match(29) && this.raise(S.DeclareClassFieldHasInitializer, { at: this.state.startLoc }), e.abstract && this.match(29)) {
                let { key: s } = e;
                this.raise(S.AbstractPropertyHasInitializer, { at: this.state.startLoc, propertyName: s.type === "Identifier" && !e.computed ? s.name : "[".concat(this.input.slice(s.start, s.end), "]") });
              }
              return super.parseClassProperty(e);
            }
            parseClassPrivateProperty(e) {
              return e.abstract && this.raise(S.PrivateElementHasAbstract, { at: e }), e.accessibility && this.raise(S.PrivateElementHasAccessibility, { at: e, modifier: e.accessibility }), this.parseClassPropertyAnnotation(e), super.parseClassPrivateProperty(e);
            }
            pushClassMethod(e, s, r, i, a, n) {
              let o = this.tsTryParseTypeParameters();
              o && a && this.raise(S.ConstructorHasTypeParameters, { at: o });
              let { declare: c = false, kind: f } = s;
              c && (f === "get" || f === "set") && this.raise(S.DeclareAccessor, { at: s, kind: f }), o && (s.typeParameters = o), super.pushClassMethod(e, s, r, i, a, n);
            }
            pushClassPrivateMethod(e, s, r, i) {
              let a = this.tsTryParseTypeParameters();
              a && (s.typeParameters = a), super.pushClassPrivateMethod(e, s, r, i);
            }
            declareClassPrivateMethodInScope(e, s) {
              e.type !== "TSDeclareMethod" && (e.type === "MethodDefinition" && !e.value.body || super.declareClassPrivateMethodInScope(e, s));
            }
            parseClassSuper(e) {
              super.parseClassSuper(e), e.superClass && (this.match(47) || this.match(51)) && (e.superTypeParameters = this.tsParseTypeArgumentsInExpression()), this.eatContextual(110) && (e.implements = this.tsParseHeritageClause("implements"));
            }
            parseObjPropValue(e) {
              let s = this.tsTryParseTypeParameters();
              s && (e.typeParameters = s);
              for (var r = arguments.length, i = new Array(r > 1 ? r - 1 : 0), a = 1; a < r; a++) i[a - 1] = arguments[a];
              super.parseObjPropValue(e, ...i);
            }
            parseFunctionParams(e, s) {
              let r = this.tsTryParseTypeParameters();
              r && (e.typeParameters = r), super.parseFunctionParams(e, s);
            }
            parseVarId(e, s) {
              super.parseVarId(e, s), e.id.type === "Identifier" && !this.hasPrecedingLineBreak() && this.eat(35) && (e.definite = true);
              let r = this.tsTryParseTypeAnnotation();
              r && (e.id.typeAnnotation = r, this.resetEndLocation(e.id));
            }
            parseAsyncArrowFromCallExpression(e, s) {
              return this.match(14) && (e.returnType = this.tsParseTypeAnnotation()), super.parseAsyncArrowFromCallExpression(e, s);
            }
            parseMaybeAssign() {
              for (var e = arguments.length, s = new Array(e), r = 0; r < e; r++) s[r] = arguments[r];
              var i, a, n, o, c, f, y;
              let P, v, N;
              if (this.hasPlugin("jsx") && (this.match(138) || this.match(47))) {
                if (P = this.state.clone(), v = this.tryParse(() => super.parseMaybeAssign(...s), P), !v.error) return v.node;
                let { context: Q } = this.state, re = Q[Q.length - 1];
                (re === z2.j_oTag || re === z2.j_expr) && Q.pop();
              }
              if (!((i = v) != null && i.error) && !this.match(47)) return super.parseMaybeAssign(...s);
              let B;
              P = P || this.state.clone();
              let _ = this.tryParse((Q) => {
                var re, ne, $e;
                B = this.tsParseTypeParameters();
                let le = super.parseMaybeAssign(...s);
                return (le.type !== "ArrowFunctionExpression" || (re = le.extra) != null && re.parenthesized) && Q(), ((ne = B) == null ? void 0 : ne.params.length) !== 0 && this.resetStartLocationFromNode(le, B), le.typeParameters = B, this.hasPlugin("jsx") && le.typeParameters.params.length === 1 && !(($e = le.typeParameters.extra) != null && $e.trailingComma) && le.typeParameters.params[0].constraint, le;
              }, P);
              if (!_.error && !_.aborted) return B && this.reportReservedArrowTypeParam(B), _.node;
              if (!v && (Br(!this.hasPlugin("jsx")), N = this.tryParse(() => super.parseMaybeAssign(...s), P), !N.error)) return N.node;
              if ((a = v) != null && a.node) return this.state = v.failState, v.node;
              if (_.node) return this.state = _.failState, B && this.reportReservedArrowTypeParam(B), _.node;
              if ((n = N) != null && n.node) return this.state = N.failState, N.node;
              throw (o = v) != null && o.thrown ? v.error : _.thrown ? _.error : (c = N) != null && c.thrown ? N.error : ((f = v) == null ? void 0 : f.error) || _.error || ((y = N) == null ? void 0 : y.error);
            }
            reportReservedArrowTypeParam(e) {
              var s;
              e.params.length === 1 && !((s = e.extra) != null && s.trailingComma) && this.getPluginOption("typescript", "disallowAmbiguousJSXLike") && this.raise(S.ReservedArrowTypeParam, { at: e });
            }
            parseMaybeUnary(e) {
              return !this.hasPlugin("jsx") && this.match(47) ? this.tsParseTypeAssertion() : super.parseMaybeUnary(e);
            }
            parseArrow(e) {
              if (this.match(14)) {
                let s = this.tryParse((r) => {
                  let i = this.tsParseTypeOrTypePredicateAnnotation(14);
                  return (this.canInsertSemicolon() || !this.match(19)) && r(), i;
                });
                if (s.aborted) return;
                s.thrown || (s.error && (this.state = s.failState), e.returnType = s.node);
              }
              return super.parseArrow(e);
            }
            parseAssignableListItemTypes(e) {
              this.eat(17) && (e.type !== "Identifier" && !this.state.isAmbientContext && !this.state.inType && this.raise(S.PatternIsOptional, { at: e }), e.optional = true);
              let s = this.tsTryParseTypeAnnotation();
              return s && (e.typeAnnotation = s), this.resetEndLocation(e), e;
            }
            isAssignable(e, s) {
              switch (e.type) {
                case "TSTypeCastExpression":
                  return this.isAssignable(e.expression, s);
                case "TSParameterProperty":
                  return true;
                default:
                  return super.isAssignable(e, s);
              }
            }
            toAssignable(e) {
              let s = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              switch (e.type) {
                case "ParenthesizedExpression":
                  this.toAssignableParenthesizedExpression(e, s);
                  break;
                case "TSAsExpression":
                case "TSNonNullExpression":
                case "TSTypeAssertion":
                  s ? this.expressionScope.recordArrowParemeterBindingError(S.UnexpectedTypeCastInParameter, { at: e }) : this.raise(S.UnexpectedTypeCastInParameter, { at: e }), this.toAssignable(e.expression, s);
                  break;
                case "AssignmentExpression":
                  !s && e.left.type === "TSTypeCastExpression" && (e.left = this.typeCastToParameter(e.left));
                default:
                  super.toAssignable(e, s);
              }
            }
            toAssignableParenthesizedExpression(e, s) {
              switch (e.expression.type) {
                case "TSAsExpression":
                case "TSNonNullExpression":
                case "TSTypeAssertion":
                case "ParenthesizedExpression":
                  this.toAssignable(e.expression, s);
                  break;
                default:
                  super.toAssignable(e, s);
              }
            }
            checkToRestConversion(e, s) {
              switch (e.type) {
                case "TSAsExpression":
                case "TSTypeAssertion":
                case "TSNonNullExpression":
                  this.checkToRestConversion(e.expression, false);
                  break;
                default:
                  super.checkToRestConversion(e, s);
              }
            }
            isValidLVal(e, s, r) {
              return Mh({ TSTypeCastExpression: true, TSParameterProperty: "parameter", TSNonNullExpression: "expression", TSAsExpression: (r !== we || !s) && ["expression", true], TSTypeAssertion: (r !== we || !s) && ["expression", true] }, e) || super.isValidLVal(e, s, r);
            }
            parseBindingAtom() {
              switch (this.state.type) {
                case 78:
                  return this.parseIdentifier(true);
                default:
                  return super.parseBindingAtom();
              }
            }
            parseMaybeDecoratorArguments(e) {
              if (this.match(47) || this.match(51)) {
                let s = this.tsParseTypeArgumentsInExpression();
                if (this.match(10)) {
                  let r = super.parseMaybeDecoratorArguments(e);
                  return r.typeParameters = s, r;
                }
                this.unexpected(null, 10);
              }
              return super.parseMaybeDecoratorArguments(e);
            }
            checkCommaAfterRest(e) {
              return this.state.isAmbientContext && this.match(12) && this.lookaheadCharCode() === e ? (this.next(), false) : super.checkCommaAfterRest(e);
            }
            isClassMethod() {
              return this.match(47) || super.isClassMethod();
            }
            isClassProperty() {
              return this.match(35) || this.match(14) || super.isClassProperty();
            }
            parseMaybeDefault() {
              let e = super.parseMaybeDefault(...arguments);
              return e.type === "AssignmentPattern" && e.typeAnnotation && e.right.start < e.typeAnnotation.start && this.raise(S.TypeAnnotationAfterAssign, { at: e.typeAnnotation }), e;
            }
            getTokenFromCode(e) {
              if (this.state.inType) {
                if (e === 62) return this.finishOp(48, 1);
                if (e === 60) return this.finishOp(47, 1);
              }
              return super.getTokenFromCode(e);
            }
            reScan_lt_gt() {
              let { type: e } = this.state;
              e === 47 ? (this.state.pos -= 1, this.readToken_lt()) : e === 48 && (this.state.pos -= 1, this.readToken_gt());
            }
            reScan_lt() {
              let { type: e } = this.state;
              return e === 51 ? (this.state.pos -= 2, this.finishOp(47, 1), 47) : e;
            }
            toAssignableList(e) {
              for (let s = 0; s < e.length; s++) {
                let r = e[s];
                (r == null ? void 0 : r.type) === "TSTypeCastExpression" && (e[s] = this.typeCastToParameter(r));
              }
              super.toAssignableList(...arguments);
            }
            typeCastToParameter(e) {
              return e.expression.typeAnnotation = e.typeAnnotation, this.resetEndLocation(e.expression, e.typeAnnotation.loc.end), e.expression;
            }
            shouldParseArrow(e) {
              return this.match(14) ? e.every((s) => this.isAssignable(s, true)) : super.shouldParseArrow(e);
            }
            shouldParseAsyncArrow() {
              return this.match(14) || super.shouldParseAsyncArrow();
            }
            canHaveLeadingDecorator() {
              return super.canHaveLeadingDecorator() || this.isAbstractClass();
            }
            jsxParseOpeningElementAfterName(e) {
              if (this.match(47) || this.match(51)) {
                let s = this.tsTryParseAndCatch(() => this.tsParseTypeArgumentsInExpression());
                s && (e.typeParameters = s);
              }
              return super.jsxParseOpeningElementAfterName(e);
            }
            getGetterSetterExpectedParamCount(e) {
              let s = super.getGetterSetterExpectedParamCount(e), i = this.getObjectOrClassMethodParams(e)[0];
              return i && this.isThisParam(i) ? s + 1 : s;
            }
            parseCatchClauseParam() {
              let e = super.parseCatchClauseParam(), s = this.tsTryParseTypeAnnotation();
              return s && (e.typeAnnotation = s, this.resetEndLocation(e)), e;
            }
            tsInAmbientContext(e) {
              let s = this.state.isAmbientContext;
              this.state.isAmbientContext = true;
              try {
                return e();
              } finally {
                this.state.isAmbientContext = s;
              }
            }
            parseClass(e) {
              let s = this.state.inAbstractClass;
              this.state.inAbstractClass = !!e.abstract;
              try {
                for (var r = arguments.length, i = new Array(r > 1 ? r - 1 : 0), a = 1; a < r; a++) i[a - 1] = arguments[a];
                return super.parseClass(e, ...i);
              } finally {
                this.state.inAbstractClass = s;
              }
            }
            tsParseAbstractDeclaration(e) {
              if (this.match(80)) return e.abstract = true, this.parseClass(e, true, false);
              if (this.isContextual(125)) {
                if (!this.hasFollowingLineBreak()) return e.abstract = true, this.raise(S.NonClassMethodPropertyHasAbstractModifer, { at: e }), this.tsParseInterfaceDeclaration(e);
              } else this.unexpected(null, 80);
            }
            parseMethod() {
              let e = super.parseMethod(...arguments);
              if (e.abstract && (this.hasPlugin("estree") ? !!e.value.body : !!e.body)) {
                let { key: r } = e;
                this.raise(S.AbstractMethodHasImplementation, { at: e, methodName: r.type === "Identifier" && !e.computed ? r.name : "[".concat(this.input.slice(r.start, r.end), "]") });
              }
              return e;
            }
            tsParseTypeParameterName() {
              return this.parseIdentifier().name;
            }
            shouldParseAsAmbientContext() {
              return !!this.getPluginOption("typescript", "dts");
            }
            parse() {
              return this.shouldParseAsAmbientContext() && (this.state.isAmbientContext = true), super.parse();
            }
            getExpression() {
              return this.shouldParseAsAmbientContext() && (this.state.isAmbientContext = true), super.getExpression();
            }
            parseExportSpecifier(e, s, r, i) {
              return !s && i ? (this.parseTypeOnlyImportExportSpecifier(e, false, r), this.finishNode(e, "ExportSpecifier")) : (e.exportKind = "value", super.parseExportSpecifier(e, s, r, i));
            }
            parseImportSpecifier(e, s, r, i) {
              return !s && i ? (this.parseTypeOnlyImportExportSpecifier(e, true, r), this.finishNode(e, "ImportSpecifier")) : (e.importKind = "value", super.parseImportSpecifier(e, s, r, i));
            }
            parseTypeOnlyImportExportSpecifier(e, s, r) {
              let i = s ? "imported" : "local", a = s ? "local" : "exported", n = e[i], o, c = false, f = true, y = n.loc.start;
              if (this.isContextual(93)) {
                let v = this.parseIdentifier();
                if (this.isContextual(93)) {
                  let N = this.parseIdentifier();
                  pe(this.state.type) ? (c = true, n = v, o = s ? this.parseIdentifier() : this.parseModuleExportName(), f = false) : (o = N, f = false);
                } else pe(this.state.type) ? (f = false, o = s ? this.parseIdentifier() : this.parseModuleExportName()) : (c = true, n = v);
              } else pe(this.state.type) && (c = true, s ? (n = this.parseIdentifier(true), this.isContextual(93) || this.checkReservedWord(n.name, n.loc.start, true, true)) : n = this.parseModuleExportName());
              c && r && this.raise(s ? S.TypeModifierIsUsedInTypeImports : S.TypeModifierIsUsedInTypeExports, { at: y }), e[i] = n, e[a] = o;
              let P = s ? "importKind" : "exportKind";
              e[P] = c ? "type" : "value", f && this.eatContextual(93) && (e[a] = s ? this.parseIdentifier() : this.parseModuleExportName()), e[a] || (e[a] = ge(e[i])), s && this.checkIdentifier(e[a], xe);
            }
          };
          function zh(t) {
            if (t.type !== "MemberExpression") return false;
            let { computed: e, property: s } = t;
            return e && s.type !== "StringLiteral" && (s.type !== "TemplateLiteral" || s.expressions.length > 0) ? false : Rr(t.object);
          }
          function Rr(t) {
            return t.type === "Identifier" ? true : t.type !== "MemberExpression" || t.computed ? false : Rr(t.object);
          }
          var jr = j(Hn || (Hn = rt(["placeholders"])))((t) => ({ ClassNameIsRequired: t("A class name is required."), UnexpectedSpace: t("Unexpected space in placeholder.") })), Kh = (t) => class extends t {
            parsePlaceholder(e) {
              if (this.match(140)) {
                let s = this.startNode();
                return this.next(), this.assertNoSpace(), s.name = super.parseIdentifier(true), this.assertNoSpace(), this.expect(140), this.finishPlaceholder(s, e);
              }
            }
            finishPlaceholder(e, s) {
              let r = !!(e.expectedNode && e.type === "Placeholder");
              return e.expectedNode = s, r ? e : this.finishNode(e, "Placeholder");
            }
            getTokenFromCode(e) {
              return e === 37 && this.input.charCodeAt(this.state.pos + 1) === 37 ? this.finishOp(140, 2) : super.getTokenFromCode(...arguments);
            }
            parseExprAtom() {
              return this.parsePlaceholder("Expression") || super.parseExprAtom(...arguments);
            }
            parseIdentifier() {
              return this.parsePlaceholder("Identifier") || super.parseIdentifier(...arguments);
            }
            checkReservedWord(e) {
              e !== void 0 && super.checkReservedWord(...arguments);
            }
            parseBindingAtom() {
              return this.parsePlaceholder("Pattern") || super.parseBindingAtom(...arguments);
            }
            isValidLVal(e) {
              for (var s = arguments.length, r = new Array(s > 1 ? s - 1 : 0), i = 1; i < s; i++) r[i - 1] = arguments[i];
              return e === "Placeholder" || super.isValidLVal(e, ...r);
            }
            toAssignable(e) {
              e && e.type === "Placeholder" && e.expectedNode === "Expression" ? e.expectedNode = "Pattern" : super.toAssignable(...arguments);
            }
            isLet(e) {
              return super.isLet(e) ? true : !this.isContextual(99) || e ? false : this.lookahead().type === 140;
            }
            verifyBreakContinue(e) {
              e.label && e.label.type === "Placeholder" || super.verifyBreakContinue(...arguments);
            }
            parseExpressionStatement(e, s) {
              if (s.type !== "Placeholder" || s.extra && s.extra.parenthesized) return super.parseExpressionStatement(...arguments);
              if (this.match(14)) {
                let r = e;
                return r.label = this.finishPlaceholder(s, "Identifier"), this.next(), r.body = this.parseStatement("label"), this.finishNode(r, "LabeledStatement");
              }
              return this.semicolon(), e.name = s.name, this.finishPlaceholder(e, "Statement");
            }
            parseBlock() {
              return this.parsePlaceholder("BlockStatement") || super.parseBlock(...arguments);
            }
            parseFunctionId() {
              return this.parsePlaceholder("Identifier") || super.parseFunctionId(...arguments);
            }
            parseClass(e, s, r) {
              let i = s ? "ClassDeclaration" : "ClassExpression";
              this.next(), this.takeDecorators(e);
              let a = this.state.strict, n = this.parsePlaceholder("Identifier");
              if (n) if (this.match(81) || this.match(140) || this.match(5)) e.id = n;
              else {
                if (r || !s) return e.id = null, e.body = this.finishPlaceholder(n, "ClassBody"), this.finishNode(e, i);
                throw this.raise(jr.ClassNameIsRequired, { at: this.state.startLoc });
              }
              else this.parseClassId(e, s, r);
              return this.parseClassSuper(e), e.body = this.parsePlaceholder("ClassBody") || this.parseClassBody(!!e.superClass, a), this.finishNode(e, i);
            }
            parseExport(e) {
              let s = this.parsePlaceholder("Identifier");
              if (!s) return super.parseExport(...arguments);
              if (!this.isContextual(97) && !this.match(12)) return e.specifiers = [], e.source = null, e.declaration = this.finishPlaceholder(s, "Declaration"), this.finishNode(e, "ExportNamedDeclaration");
              this.expectPlugin("exportDefaultFrom");
              let r = this.startNode();
              return r.exported = s, e.specifiers = [this.finishNode(r, "ExportDefaultSpecifier")], super.parseExport(e);
            }
            isExportDefaultSpecifier() {
              if (this.match(65)) {
                let e = this.nextTokenStart();
                if (this.isUnparsedContextual(e, "from") && this.input.startsWith(Pe(140), this.nextTokenStartSince(e + 4))) return true;
              }
              return super.isExportDefaultSpecifier();
            }
            maybeParseExportDefaultSpecifier(e) {
              return e.specifiers && e.specifiers.length > 0 ? true : super.maybeParseExportDefaultSpecifier(...arguments);
            }
            checkExport(e) {
              let { specifiers: s } = e;
              s != null && s.length && (e.specifiers = s.filter((r) => r.exported.type === "Placeholder")), super.checkExport(e), e.specifiers = s;
            }
            parseImport(e) {
              let s = this.parsePlaceholder("Identifier");
              if (!s) return super.parseImport(...arguments);
              if (e.specifiers = [], !this.isContextual(97) && !this.match(12)) return e.source = this.finishPlaceholder(s, "StringLiteral"), this.semicolon(), this.finishNode(e, "ImportDeclaration");
              let r = this.startNodeAtNode(s);
              return r.local = s, this.finishNode(r, "ImportDefaultSpecifier"), e.specifiers.push(r), this.eat(12) && (this.maybeParseStarImportSpecifier(e) || this.parseNamedImportSpecifiers(e)), this.expectContextual(97), e.source = this.parseImportSource(), this.semicolon(), this.finishNode(e, "ImportDeclaration");
            }
            parseImportSource() {
              return this.parsePlaceholder("StringLiteral") || super.parseImportSource(...arguments);
            }
            assertNoSpace() {
              this.state.start > this.state.lastTokEndLoc.index && this.raise(jr.UnexpectedSpace, { at: this.state.lastTokEndLoc });
            }
          }, Vh = (t) => class extends t {
            parseV8Intrinsic() {
              if (this.match(54)) {
                let e = this.state.startLoc, s = this.startNode();
                if (this.next(), K(this.state.type)) {
                  let r = this.parseIdentifierName(this.state.start), i = this.createIdentifier(s, r);
                  if (i.type = "V8IntrinsicIdentifier", this.match(10)) return i;
                }
                this.unexpected(e);
              }
            }
            parseExprAtom() {
              return this.parseV8Intrinsic() || super.parseExprAtom(...arguments);
            }
          };
          function ee(t, e) {
            let [s, r] = typeof e == "string" ? [e, {}] : e, i = Object.keys(r), a = i.length === 0;
            return t.some((n) => {
              if (typeof n == "string") return a && n === s;
              {
                let [o, c] = n;
                if (o !== s) return false;
                for (let f of i) if (c[f] !== r[f]) return false;
                return true;
              }
            });
          }
          function Je(t, e, s) {
            let r = t.find((i) => Array.isArray(i) ? i[0] === e : i === e);
            return r && Array.isArray(r) ? r[1][s] : null;
          }
          var qr = ["minimal", "fsharp", "hack", "smart"], Ur = ["^^", "@@", "^", "%", "#"], _r = ["hash", "bar"];
          function Hh(t) {
            if (ee(t, "decorators")) {
              if (ee(t, "decorators-legacy")) throw new Error("Cannot use the decorators and decorators-legacy plugin together");
              let e = Je(t, "decorators", "decoratorsBeforeExport");
              if (e == null) throw new Error("The 'decorators' plugin requires a 'decoratorsBeforeExport' option, whose value must be a boolean. If you are migrating from Babylon/Babel 6 or want to use the old decorators proposal, you should use the 'decorators-legacy' plugin instead of 'decorators'.");
              if (typeof e != "boolean") throw new Error("'decoratorsBeforeExport' must be a boolean.");
            }
            if (ee(t, "flow") && ee(t, "typescript")) throw new Error("Cannot combine flow and typescript plugins.");
            if (ee(t, "placeholders") && ee(t, "v8intrinsic")) throw new Error("Cannot combine placeholders and v8intrinsic plugins.");
            if (ee(t, "pipelineOperator")) {
              let e = Je(t, "pipelineOperator", "proposal");
              if (!qr.includes(e)) {
                let r = qr.map((i) => '"'.concat(i, '"')).join(", ");
                throw new Error('"pipelineOperator" requires "proposal" option whose value must be one of: '.concat(r, "."));
              }
              let s = ee(t, ["recordAndTuple", { syntaxType: "hash" }]);
              if (e === "hack") {
                if (ee(t, "placeholders")) throw new Error("Cannot combine placeholders plugin and Hack-style pipes.");
                if (ee(t, "v8intrinsic")) throw new Error("Cannot combine v8intrinsic plugin and Hack-style pipes.");
                let r = Je(t, "pipelineOperator", "topicToken");
                if (!Ur.includes(r)) {
                  let i = Ur.map((a) => '"'.concat(a, '"')).join(", ");
                  throw new Error('"pipelineOperator" in "proposal": "hack" mode also requires a "topicToken" option whose value must be one of: '.concat(i, "."));
                }
                if (r === "#" && s) throw new Error('Plugin conflict between `["pipelineOperator", { proposal: "hack", topicToken: "#" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.');
              } else if (e === "smart" && s) throw new Error('Plugin conflict between `["pipelineOperator", { proposal: "smart" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.');
            }
            if (ee(t, "moduleAttributes")) {
              if (ee(t, "importAssertions")) throw new Error("Cannot combine importAssertions and moduleAttributes plugins.");
              if (Je(t, "moduleAttributes", "version") !== "may-2020") throw new Error("The 'moduleAttributes' plugin requires a 'version' option, representing the last proposal update. Currently, the only supported value is 'may-2020'.");
            }
            if (ee(t, "recordAndTuple") && !_r.includes(Je(t, "recordAndTuple", "syntaxType"))) throw new Error("'recordAndTuple' requires 'syntaxType' option whose value should be one of: " + _r.map((e) => "'".concat(e, "'")).join(", "));
            if (ee(t, "asyncDoExpressions") && !ee(t, "doExpressions")) {
              let e = new Error("'asyncDoExpressions' requires 'doExpressions', please add 'doExpressions' to parser plugins.");
              throw e.missingPlugins = "doExpressions", e;
            }
          }
          var zr = { estree: Oe, jsx: Lh, flow: Dh, typescript: _h, v8intrinsic: Vh, placeholders: Kh }, Wh = Object.keys(zr), Kr = { sourceType: "script", sourceFilename: void 0, startColumn: 0, startLine: 1, allowAwaitOutsideFunction: false, allowReturnOutsideFunction: false, allowImportExportEverywhere: false, allowSuperOutsideMethod: false, allowUndeclaredExports: false, plugins: [], strictMode: null, ranges: false, tokens: false, createParenthesizedExpressions: false, errorRecovery: false, attachComment: true };
          function Gh(t) {
            let e = {};
            for (let s of Object.keys(Kr)) e[s] = t && t[s] != null ? t[s] : Kr[s];
            return e;
          }
          var Xh = (t, e) => Object.hasOwnProperty.call(t, e) && t[e], Vr = (t) => t.type === "ParenthesizedExpression" ? Vr(t.expression) : t, Jh = class extends vh {
            toAssignable(t) {
              let e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              var s, r;
              let i;
              switch ((t.type === "ParenthesizedExpression" || (s = t.extra) != null && s.parenthesized) && (i = Vr(t), e ? i.type === "Identifier" ? this.expressionScope.recordArrowParemeterBindingError(u.InvalidParenthesizedAssignment, { at: t }) : i.type !== "MemberExpression" && this.raise(u.InvalidParenthesizedAssignment, { at: t }) : this.raise(u.InvalidParenthesizedAssignment, { at: t })), t.type) {
                case "Identifier":
                case "ObjectPattern":
                case "ArrayPattern":
                case "AssignmentPattern":
                case "RestElement":
                  break;
                case "ObjectExpression":
                  t.type = "ObjectPattern";
                  for (let n = 0, o = t.properties.length, c = o - 1; n < o; n++) {
                    var a;
                    let f = t.properties[n], y = n === c;
                    this.toAssignableObjectExpressionProp(f, y, e), y && f.type === "RestElement" && (a = t.extra) != null && a.trailingCommaLoc && this.raise(u.RestTrailingComma, { at: t.extra.trailingCommaLoc });
                  }
                  break;
                case "ObjectProperty": {
                  let { key: n, value: o } = t;
                  this.isPrivateName(n) && this.classScope.usePrivateName(this.getPrivateNameSV(n), n.loc.start), this.toAssignable(o, e);
                  break;
                }
                case "SpreadElement":
                  throw new Error("Internal @babel/parser error (this is a bug, please report it). SpreadElement should be converted by .toAssignable's caller.");
                case "ArrayExpression":
                  t.type = "ArrayPattern", this.toAssignableList(t.elements, (r = t.extra) == null ? void 0 : r.trailingCommaLoc, e);
                  break;
                case "AssignmentExpression":
                  t.operator !== "=" && this.raise(u.MissingEqInAssignment, { at: t.left.loc.end }), t.type = "AssignmentPattern", delete t.operator, this.toAssignable(t.left, e);
                  break;
                case "ParenthesizedExpression":
                  this.toAssignable(i, e);
                  break;
              }
            }
            toAssignableObjectExpressionProp(t, e, s) {
              if (t.type === "ObjectMethod") this.raise(t.kind === "get" || t.kind === "set" ? u.PatternHasAccessor : u.PatternHasMethod, { at: t.key });
              else if (t.type === "SpreadElement") {
                t.type = "RestElement";
                let r = t.argument;
                this.checkToRestConversion(r, false), this.toAssignable(r, s), e || this.raise(u.RestTrailingComma, { at: t });
              } else this.toAssignable(t, s);
            }
            toAssignableList(t, e, s) {
              let r = t.length - 1;
              for (let i = 0; i <= r; i++) {
                let a = t[i];
                if (!!a) {
                  if (a.type === "SpreadElement") {
                    a.type = "RestElement";
                    let n = a.argument;
                    this.checkToRestConversion(n, true), this.toAssignable(n, s);
                  } else this.toAssignable(a, s);
                  a.type === "RestElement" && (i < r ? this.raise(u.RestTrailingComma, { at: a }) : e && this.raise(u.RestTrailingComma, { at: e }));
                }
              }
            }
            isAssignable(t, e) {
              switch (t.type) {
                case "Identifier":
                case "ObjectPattern":
                case "ArrayPattern":
                case "AssignmentPattern":
                case "RestElement":
                  return true;
                case "ObjectExpression": {
                  let s = t.properties.length - 1;
                  return t.properties.every((r, i) => r.type !== "ObjectMethod" && (i === s || r.type !== "SpreadElement") && this.isAssignable(r));
                }
                case "ObjectProperty":
                  return this.isAssignable(t.value);
                case "SpreadElement":
                  return this.isAssignable(t.argument);
                case "ArrayExpression":
                  return t.elements.every((s) => s === null || this.isAssignable(s));
                case "AssignmentExpression":
                  return t.operator === "=";
                case "ParenthesizedExpression":
                  return this.isAssignable(t.expression);
                case "MemberExpression":
                case "OptionalMemberExpression":
                  return !e;
                default:
                  return false;
              }
            }
            toReferencedList(t, e) {
              return t;
            }
            toReferencedListDeep(t, e) {
              this.toReferencedList(t, e);
              for (let s of t) (s == null ? void 0 : s.type) === "ArrayExpression" && this.toReferencedListDeep(s.elements);
            }
            parseSpread(t, e) {
              let s = this.startNode();
              return this.next(), s.argument = this.parseMaybeAssignAllowIn(t, void 0, e), this.finishNode(s, "SpreadElement");
            }
            parseRestBinding() {
              let t = this.startNode();
              return this.next(), t.argument = this.parseBindingAtom(), this.finishNode(t, "RestElement");
            }
            parseBindingAtom() {
              switch (this.state.type) {
                case 0: {
                  let t = this.startNode();
                  return this.next(), t.elements = this.parseBindingList(3, 93, true), this.finishNode(t, "ArrayPattern");
                }
                case 5:
                  return this.parseObjectLike(8, true);
              }
              return this.parseIdentifier();
            }
            parseBindingList(t, e, s, r) {
              let i = [], a = true;
              for (; !this.eat(t); ) if (a ? a = false : this.expect(12), s && this.match(12)) i.push(null);
              else {
                if (this.eat(t)) break;
                if (this.match(21)) {
                  if (i.push(this.parseAssignableListItemTypes(this.parseRestBinding())), !this.checkCommaAfterRest(e)) {
                    this.expect(t);
                    break;
                  }
                } else {
                  let n = [];
                  for (this.match(26) && this.hasPlugin("decorators") && this.raise(u.UnsupportedParameterDecorator, { at: this.state.startLoc }); this.match(26); ) n.push(this.parseDecorator());
                  i.push(this.parseAssignableListItem(r, n));
                }
              }
              return i;
            }
            parseBindingRestProperty(t) {
              return this.next(), t.argument = this.parseIdentifier(), this.checkCommaAfterRest(125), this.finishNode(t, "RestElement");
            }
            parseBindingProperty() {
              let t = this.startNode(), { type: e, start: s, startLoc: r } = this.state;
              return e === 21 ? this.parseBindingRestProperty(t) : (e === 134 ? (this.expectPlugin("destructuringPrivate", r), this.classScope.usePrivateName(this.state.value, r), t.key = this.parsePrivateName()) : this.parsePropertyName(t), t.method = false, this.parseObjPropValue(t, s, r, false, false, true, false), t);
            }
            parseAssignableListItem(t, e) {
              let s = this.parseMaybeDefault();
              this.parseAssignableListItemTypes(s);
              let r = this.parseMaybeDefault(s.start, s.loc.start, s);
              return e.length && (s.decorators = e), r;
            }
            parseAssignableListItemTypes(t) {
              return t;
            }
            parseMaybeDefault(t, e, s) {
              var r, i, a;
              if (e = (r = e) != null ? r : this.state.startLoc, t = (i = t) != null ? i : this.state.start, s = (a = s) != null ? a : this.parseBindingAtom(), !this.eat(29)) return s;
              let n = this.startNodeAt(t, e);
              return n.left = s, n.right = this.parseMaybeAssignAllowIn(), this.finishNode(n, "AssignmentPattern");
            }
            isValidLVal(t, e, s) {
              return Xh({ AssignmentPattern: "left", RestElement: "argument", ObjectProperty: "value", ParenthesizedExpression: "expression", ArrayPattern: "elements", ObjectPattern: "properties" }, t);
            }
            checkLVal(t, e) {
              let { in: s, binding: r = we, checkClashes: i = false, strictModeChanged: a = false, allowingSloppyLetBinding: n = !(r & Te), hasParenthesizedAncestor: o = false } = e;
              var c;
              let f = t.type;
              if (this.isObjectMethod(t)) return;
              if (f === "MemberExpression") {
                r !== we && this.raise(u.InvalidPropertyBindingPattern, { at: t });
                return;
              }
              if (t.type === "Identifier") {
                this.checkIdentifier(t, r, a, n);
                let { name: B } = t;
                i && (i.has(B) ? this.raise(u.ParamDupe, { at: t }) : i.add(B));
                return;
              }
              let y = this.isValidLVal(t.type, !(o || (c = t.extra) != null && c.parenthesized) && s.type === "AssignmentExpression", r);
              if (y === true) return;
              if (y === false) {
                let B = r === we ? u.InvalidLhs : u.InvalidLhsBinding;
                this.raise(B, { at: t, ancestor: s.type === "UpdateExpression" ? { type: "UpdateExpression", prefix: s.prefix } : { type: s.type } });
                return;
              }
              let [P, v] = Array.isArray(y) ? y : [y, f === "ParenthesizedExpression"], N = t.type === "ArrayPattern" || t.type === "ObjectPattern" || t.type === "ParenthesizedExpression" ? t : s;
              for (let B of [].concat(t[P])) B && this.checkLVal(B, { in: N, binding: r, checkClashes: i, allowingSloppyLetBinding: n, strictModeChanged: a, hasParenthesizedAncestor: v });
            }
            checkIdentifier(t, e) {
              let s = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, r = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : !(e & Te);
              this.state.strict && (s ? mr(t.name, this.inModule) : dr(t.name)) && (e === we ? this.raise(u.StrictEvalArguments, { at: t, referenceName: t.name }) : this.raise(u.StrictEvalArgumentsBinding, { at: t, bindingName: t.name })), !r && t.name === "let" && this.raise(u.LetInLexicalBinding, { at: t }), e & we || this.declareNameFromIdentifier(t, e);
            }
            declareNameFromIdentifier(t, e) {
              this.scope.declareName(t.name, e, t.loc.start);
            }
            checkToRestConversion(t, e) {
              switch (t.type) {
                case "ParenthesizedExpression":
                  this.checkToRestConversion(t.expression, e);
                  break;
                case "Identifier":
                case "MemberExpression":
                  break;
                case "ArrayExpression":
                case "ObjectExpression":
                  if (e) break;
                default:
                  this.raise(u.InvalidRestAssignmentPattern, { at: t });
              }
            }
            checkCommaAfterRest(t) {
              return this.match(12) ? (this.raise(this.lookaheadCharCode() === t ? u.RestTrailingComma : u.ElementAfterRest, { at: this.state.startLoc }), true) : false;
            }
          }, Yh = class extends Jh {
            checkProto(t, e, s, r) {
              if (t.type === "SpreadElement" || this.isObjectMethod(t) || t.computed || t.shorthand) return;
              let i = t.key;
              if ((i.type === "Identifier" ? i.name : i.value) === "__proto__") {
                if (e) {
                  this.raise(u.RecordNoProto, { at: i });
                  return;
                }
                s.used && (r ? r.doubleProtoLoc === null && (r.doubleProtoLoc = i.loc.start) : this.raise(u.DuplicateProto, { at: i })), s.used = true;
              }
            }
            shouldExitDescending(t, e) {
              return t.type === "ArrowFunctionExpression" && t.start === e;
            }
            getExpression() {
              this.enterInitialScopes(), this.nextToken();
              let t = this.parseExpression();
              return this.match(135) || this.unexpected(), this.finalizeRemainingComments(), t.comments = this.state.comments, t.errors = this.state.errors, this.options.tokens && (t.tokens = this.tokens), t;
            }
            parseExpression(t, e) {
              return t ? this.disallowInAnd(() => this.parseExpressionBase(e)) : this.allowInAnd(() => this.parseExpressionBase(e));
            }
            parseExpressionBase(t) {
              let e = this.state.start, s = this.state.startLoc, r = this.parseMaybeAssign(t);
              if (this.match(12)) {
                let i = this.startNodeAt(e, s);
                for (i.expressions = [r]; this.eat(12); ) i.expressions.push(this.parseMaybeAssign(t));
                return this.toReferencedList(i.expressions), this.finishNode(i, "SequenceExpression");
              }
              return r;
            }
            parseMaybeAssignDisallowIn(t, e) {
              return this.disallowInAnd(() => this.parseMaybeAssign(t, e));
            }
            parseMaybeAssignAllowIn(t, e) {
              return this.allowInAnd(() => this.parseMaybeAssign(t, e));
            }
            setOptionalParametersError(t, e) {
              var s;
              t.optionalParametersLoc = (s = e == null ? void 0 : e.loc) != null ? s : this.state.startLoc;
            }
            parseMaybeAssign(t, e) {
              let s = this.state.start, r = this.state.startLoc;
              if (this.isContextual(105) && this.prodParam.hasYield) {
                let o = this.parseYield();
                return e && (o = e.call(this, o, s, r)), o;
              }
              let i;
              t ? i = false : (t = new At(), i = true);
              let { type: a } = this.state;
              (a === 10 || K(a)) && (this.state.potentialArrowAt = this.state.start);
              let n = this.parseMaybeConditional(t);
              if (e && (n = e.call(this, n, s, r)), wo(this.state.type)) {
                let o = this.startNodeAt(s, r), c = this.state.value;
                return o.operator = c, this.match(29) ? (this.toAssignable(n, true), o.left = n, t.doubleProtoLoc != null && t.doubleProtoLoc.index >= s && (t.doubleProtoLoc = null), t.shorthandAssignLoc != null && t.shorthandAssignLoc.index >= s && (t.shorthandAssignLoc = null), t.privateKeyLoc != null && t.privateKeyLoc.index >= s && (this.checkDestructuringPrivate(t), t.privateKeyLoc = null)) : o.left = n, this.next(), o.right = this.parseMaybeAssign(), this.checkLVal(n, { in: this.finishNode(o, "AssignmentExpression") }), o;
              } else i && this.checkExpressionErrors(t, true);
              return n;
            }
            parseMaybeConditional(t) {
              let e = this.state.start, s = this.state.startLoc, r = this.state.potentialArrowAt, i = this.parseExprOps(t);
              return this.shouldExitDescending(i, r) ? i : this.parseConditional(i, e, s, t);
            }
            parseConditional(t, e, s, r) {
              if (this.eat(17)) {
                let i = this.startNodeAt(e, s);
                return i.test = t, i.consequent = this.parseMaybeAssignAllowIn(), this.expect(14), i.alternate = this.parseMaybeAssign(), this.finishNode(i, "ConditionalExpression");
              }
              return t;
            }
            parseMaybeUnaryOrPrivate(t) {
              return this.match(134) ? this.parsePrivateName() : this.parseMaybeUnary(t);
            }
            parseExprOps(t) {
              let e = this.state.start, s = this.state.startLoc, r = this.state.potentialArrowAt, i = this.parseMaybeUnaryOrPrivate(t);
              return this.shouldExitDescending(i, r) ? i : this.parseExprOp(i, e, s, -1);
            }
            parseExprOp(t, e, s, r) {
              if (this.isPrivateName(t)) {
                let a = this.getPrivateNameSV(t);
                (r >= at(58) || !this.prodParam.hasIn || !this.match(58)) && this.raise(u.PrivateInExpectedIn, { at: t, identifierName: a }), this.classScope.usePrivateName(a, t.loc.start);
              }
              let i = this.state.type;
              if (Io(i) && (this.prodParam.hasIn || !this.match(58))) {
                let a = at(i);
                if (a > r) {
                  if (i === 39) {
                    if (this.expectPlugin("pipelineOperator"), this.state.inFSharpPipelineDirectBody) return t;
                    this.checkPipelineAtInfixOperator(t, s);
                  }
                  let n = this.startNodeAt(e, s);
                  n.left = t, n.operator = this.state.value;
                  let o = i === 41 || i === 42, c = i === 40;
                  if (c && (a = at(42)), this.next(), i === 39 && this.hasPlugin(["pipelineOperator", { proposal: "minimal" }]) && this.state.type === 96 && this.prodParam.hasAwait) throw this.raise(u.UnexpectedAwaitAfterPipelineBody, { at: this.state.startLoc });
                  n.right = this.parseExprOpRightExpr(i, a), this.finishNode(n, o || c ? "LogicalExpression" : "BinaryExpression");
                  let f = this.state.type;
                  if (c && (f === 41 || f === 42) || o && f === 40) throw this.raise(u.MixingCoalesceWithLogical, { at: this.state.startLoc });
                  return this.parseExprOp(n, e, s, r);
                }
              }
              return t;
            }
            parseExprOpRightExpr(t, e) {
              let s = this.state.start, r = this.state.startLoc;
              switch (t) {
                case 39:
                  switch (this.getPluginOption("pipelineOperator", "proposal")) {
                    case "hack":
                      return this.withTopicBindingContext(() => this.parseHackPipeBody());
                    case "smart":
                      return this.withTopicBindingContext(() => {
                        if (this.prodParam.hasYield && this.isContextual(105)) throw this.raise(u.PipeBodyIsTighter, { at: this.state.startLoc });
                        return this.parseSmartPipelineBodyInStyle(this.parseExprOpBaseRightExpr(t, e), s, r);
                      });
                    case "fsharp":
                      return this.withSoloAwaitPermittingContext(() => this.parseFSharpPipelineBody(e));
                  }
                default:
                  return this.parseExprOpBaseRightExpr(t, e);
              }
            }
            parseExprOpBaseRightExpr(t, e) {
              let s = this.state.start, r = this.state.startLoc;
              return this.parseExprOp(this.parseMaybeUnaryOrPrivate(), s, r, Bo(t) ? e - 1 : e);
            }
            parseHackPipeBody() {
              var t;
              let { startLoc: e } = this.state, s = this.parseMaybeAssign();
              return R.has(s.type) && !((t = s.extra) != null && t.parenthesized) && this.raise(u.PipeUnparenthesizedBody, { at: e, type: s.type }), this.topicReferenceWasUsedInCurrentContext() || this.raise(u.PipeTopicUnused, { at: e }), s;
            }
            checkExponentialAfterUnary(t) {
              this.match(57) && this.raise(u.UnexpectedTokenUnaryExponentiation, { at: t.argument });
            }
            parseMaybeUnary(t, e) {
              let s = this.state.start, r = this.state.startLoc, i = this.isContextual(96);
              if (i && this.isAwaitAllowed()) {
                this.next();
                let c = this.parseAwait(s, r);
                return e || this.checkExponentialAfterUnary(c), c;
              }
              let a = this.match(34), n = this.startNode();
              if (Do(this.state.type)) {
                n.operator = this.state.value, n.prefix = true, this.match(72) && this.expectPlugin("throwExpressions");
                let c = this.match(89);
                if (this.next(), n.argument = this.parseMaybeUnary(null, true), this.checkExpressionErrors(t, true), this.state.strict && c) {
                  let f = n.argument;
                  f.type === "Identifier" ? this.raise(u.StrictDelete, { at: n }) : this.hasPropertyAsPrivateName(f) && this.raise(u.DeletePrivateField, { at: n });
                }
                if (!a) return e || this.checkExponentialAfterUnary(n), this.finishNode(n, "UnaryExpression");
              }
              let o = this.parseUpdate(n, a, t);
              if (i) {
                let { type: c } = this.state;
                if ((this.hasPlugin("v8intrinsic") ? Vt(c) : Vt(c) && !this.match(54)) && !this.isAmbiguousAwait()) return this.raiseOverwrite(u.AwaitNotInAsyncContext, { at: r }), this.parseAwait(s, r);
              }
              return o;
            }
            parseUpdate(t, e, s) {
              if (e) return this.checkLVal(t.argument, { in: this.finishNode(t, "UpdateExpression") }), t;
              let r = this.state.start, i = this.state.startLoc, a = this.parseExprSubscripts(s);
              if (this.checkExpressionErrors(s, false)) return a;
              for (; ko(this.state.type) && !this.canInsertSemicolon(); ) {
                let n = this.startNodeAt(r, i);
                n.operator = this.state.value, n.prefix = false, n.argument = a, this.next(), this.checkLVal(a, { in: a = this.finishNode(n, "UpdateExpression") });
              }
              return a;
            }
            parseExprSubscripts(t) {
              let e = this.state.start, s = this.state.startLoc, r = this.state.potentialArrowAt, i = this.parseExprAtom(t);
              return this.shouldExitDescending(i, r) ? i : this.parseSubscripts(i, e, s);
            }
            parseSubscripts(t, e, s, r) {
              let i = { optionalChainMember: false, maybeAsyncArrow: this.atPossibleAsyncArrow(t), stop: false };
              do
                t = this.parseSubscript(t, e, s, r, i), i.maybeAsyncArrow = false;
              while (!i.stop);
              return t;
            }
            parseSubscript(t, e, s, r, i) {
              let { type: a } = this.state;
              if (!r && a === 15) return this.parseBind(t, e, s, r, i);
              if (nt(a)) return this.parseTaggedTemplateExpression(t, e, s, i);
              let n = false;
              if (a === 18) {
                if (r && this.lookaheadCharCode() === 40) return i.stop = true, t;
                i.optionalChainMember = n = true, this.next();
              }
              if (!r && this.match(10)) return this.parseCoverCallAndAsyncArrowHead(t, e, s, i, n);
              {
                let o = this.eat(0);
                return o || n || this.eat(16) ? this.parseMember(t, e, s, i, o, n) : (i.stop = true, t);
              }
            }
            parseMember(t, e, s, r, i, a) {
              let n = this.startNodeAt(e, s);
              return n.object = t, n.computed = i, i ? (n.property = this.parseExpression(), this.expect(3)) : this.match(134) ? (t.type === "Super" && this.raise(u.SuperPrivateField, { at: s }), this.classScope.usePrivateName(this.state.value, this.state.startLoc), n.property = this.parsePrivateName()) : n.property = this.parseIdentifier(true), r.optionalChainMember ? (n.optional = a, this.finishNode(n, "OptionalMemberExpression")) : this.finishNode(n, "MemberExpression");
            }
            parseBind(t, e, s, r, i) {
              let a = this.startNodeAt(e, s);
              return a.object = t, this.next(), a.callee = this.parseNoCallExpr(), i.stop = true, this.parseSubscripts(this.finishNode(a, "BindExpression"), e, s, r);
            }
            parseCoverCallAndAsyncArrowHead(t, e, s, r, i) {
              let a = this.state.maybeInArrowParameters, n = null;
              this.state.maybeInArrowParameters = true, this.next();
              let o = this.startNodeAt(e, s);
              o.callee = t;
              let { maybeAsyncArrow: c, optionalChainMember: f } = r;
              return c && (this.expressionScope.enter(Ph()), n = new At()), f && (o.optional = i), i ? o.arguments = this.parseCallExpressionArguments(11) : o.arguments = this.parseCallExpressionArguments(11, t.type === "Import", t.type !== "Super", o, n), this.finishCallExpression(o, f), c && this.shouldParseAsyncArrow() && !i ? (r.stop = true, this.checkDestructuringPrivate(n), this.expressionScope.validateAsPattern(), this.expressionScope.exit(), o = this.parseAsyncArrowFromCallExpression(this.startNodeAt(e, s), o)) : (c && (this.checkExpressionErrors(n, true), this.expressionScope.exit()), this.toReferencedArguments(o)), this.state.maybeInArrowParameters = a, o;
            }
            toReferencedArguments(t, e) {
              this.toReferencedListDeep(t.arguments, e);
            }
            parseTaggedTemplateExpression(t, e, s, r) {
              let i = this.startNodeAt(e, s);
              return i.tag = t, i.quasi = this.parseTemplate(true), r.optionalChainMember && this.raise(u.OptionalChainingNoTemplate, { at: s }), this.finishNode(i, "TaggedTemplateExpression");
            }
            atPossibleAsyncArrow(t) {
              return t.type === "Identifier" && t.name === "async" && this.state.lastTokEndLoc.index === t.end && !this.canInsertSemicolon() && t.end - t.start === 5 && t.start === this.state.potentialArrowAt;
            }
            finishCallExpression(t, e) {
              if (t.callee.type === "Import") if (t.arguments.length === 2 && (this.hasPlugin("moduleAttributes") || this.expectPlugin("importAssertions")), t.arguments.length === 0 || t.arguments.length > 2) this.raise(u.ImportCallArity, { at: t, maxArgumentCount: this.hasPlugin("importAssertions") || this.hasPlugin("moduleAttributes") ? 2 : 1 });
              else for (let s of t.arguments) s.type === "SpreadElement" && this.raise(u.ImportCallSpreadArgument, { at: s });
              return this.finishNode(t, e ? "OptionalCallExpression" : "CallExpression");
            }
            parseCallExpressionArguments(t, e, s, r, i) {
              let a = [], n = true, o = this.state.inFSharpPipelineDirectBody;
              for (this.state.inFSharpPipelineDirectBody = false; !this.eat(t); ) {
                if (n) n = false;
                else if (this.expect(12), this.match(t)) {
                  e && !this.hasPlugin("importAssertions") && !this.hasPlugin("moduleAttributes") && this.raise(u.ImportCallArgumentTrailingComma, { at: this.state.lastTokStartLoc }), r && this.addTrailingCommaExtraToNode(r), this.next();
                  break;
                }
                a.push(this.parseExprListItem(false, i, s));
              }
              return this.state.inFSharpPipelineDirectBody = o, a;
            }
            shouldParseAsyncArrow() {
              return this.match(19) && !this.canInsertSemicolon();
            }
            parseAsyncArrowFromCallExpression(t, e) {
              var s;
              return this.resetPreviousNodeTrailingComments(e), this.expect(19), this.parseArrowExpression(t, e.arguments, true, (s = e.extra) == null ? void 0 : s.trailingCommaLoc), e.innerComments && Ge(t, e.innerComments), e.callee.trailingComments && Ge(t, e.callee.trailingComments), t;
            }
            parseNoCallExpr() {
              let t = this.state.start, e = this.state.startLoc;
              return this.parseSubscripts(this.parseExprAtom(), t, e, true);
            }
            parseExprAtom(t) {
              let e, { type: s } = this.state;
              switch (s) {
                case 79:
                  return this.parseSuper();
                case 83:
                  return e = this.startNode(), this.next(), this.match(16) ? this.parseImportMetaProperty(e) : (this.match(10) || this.raise(u.UnsupportedImport, { at: this.state.lastTokStartLoc }), this.finishNode(e, "Import"));
                case 78:
                  return e = this.startNode(), this.next(), this.finishNode(e, "ThisExpression");
                case 90:
                  return this.parseDo(this.startNode(), false);
                case 56:
                case 31:
                  return this.readRegexp(), this.parseRegExpLiteral(this.state.value);
                case 130:
                  return this.parseNumericLiteral(this.state.value);
                case 131:
                  return this.parseBigIntLiteral(this.state.value);
                case 132:
                  return this.parseDecimalLiteral(this.state.value);
                case 129:
                  return this.parseStringLiteral(this.state.value);
                case 84:
                  return this.parseNullLiteral();
                case 85:
                  return this.parseBooleanLiteral(true);
                case 86:
                  return this.parseBooleanLiteral(false);
                case 10: {
                  let r = this.state.potentialArrowAt === this.state.start;
                  return this.parseParenAndDistinguishExpression(r);
                }
                case 2:
                case 1:
                  return this.parseArrayLike(this.state.type === 2 ? 4 : 3, false, true);
                case 0:
                  return this.parseArrayLike(3, true, false, t);
                case 6:
                case 7:
                  return this.parseObjectLike(this.state.type === 6 ? 9 : 8, false, true);
                case 5:
                  return this.parseObjectLike(8, false, false, t);
                case 68:
                  return this.parseFunctionOrFunctionSent();
                case 26:
                  this.parseDecorators();
                case 80:
                  return e = this.startNode(), this.takeDecorators(e), this.parseClass(e, false);
                case 77:
                  return this.parseNewOrNewTarget();
                case 25:
                case 24:
                  return this.parseTemplate(false);
                case 15: {
                  e = this.startNode(), this.next(), e.object = null;
                  let r = e.callee = this.parseNoCallExpr();
                  if (r.type === "MemberExpression") return this.finishNode(e, "BindExpression");
                  throw this.raise(u.UnsupportedBind, { at: r });
                }
                case 134:
                  return this.raise(u.PrivateInExpectedIn, { at: this.state.startLoc, identifierName: this.state.value }), this.parsePrivateName();
                case 33:
                  return this.parseTopicReferenceThenEqualsSign(54, "%");
                case 32:
                  return this.parseTopicReferenceThenEqualsSign(44, "^");
                case 37:
                case 38:
                  return this.parseTopicReference("hack");
                case 44:
                case 54:
                case 27: {
                  let r = this.getPluginOption("pipelineOperator", "proposal");
                  if (r) return this.parseTopicReference(r);
                  throw this.unexpected();
                }
                case 47: {
                  let r = this.input.codePointAt(this.nextTokenStart());
                  if (de(r) || r === 62) {
                    this.expectOnePlugin(["jsx", "flow", "typescript"]);
                    break;
                  } else throw this.unexpected();
                }
                default:
                  if (K(s)) {
                    if (this.isContextual(123) && this.lookaheadCharCode() === 123 && !this.hasFollowingLineBreak()) return this.parseModuleExpression();
                    let r = this.state.potentialArrowAt === this.state.start, i = this.state.containsEsc, a = this.parseIdentifier();
                    if (!i && a.name === "async" && !this.canInsertSemicolon()) {
                      let { type: n } = this.state;
                      if (n === 68) return this.resetPreviousNodeTrailingComments(a), this.next(), this.parseFunction(this.startNodeAtNode(a), void 0, true);
                      if (K(n)) return this.lookaheadCharCode() === 61 ? this.parseAsyncArrowUnaryFunction(this.startNodeAtNode(a)) : a;
                      if (n === 90) return this.resetPreviousNodeTrailingComments(a), this.parseDo(this.startNodeAtNode(a), true);
                    }
                    return r && this.match(19) && !this.canInsertSemicolon() ? (this.next(), this.parseArrowExpression(this.startNodeAtNode(a), [a], false)) : a;
                  } else throw this.unexpected();
              }
            }
            parseTopicReferenceThenEqualsSign(t, e) {
              let s = this.getPluginOption("pipelineOperator", "proposal");
              if (s) return this.state.type = t, this.state.value = e, this.state.pos--, this.state.end--, this.state.endLoc = m(this.state.endLoc, -1), this.parseTopicReference(s);
              throw this.unexpected();
            }
            parseTopicReference(t) {
              let e = this.startNode(), s = this.state.startLoc, r = this.state.type;
              return this.next(), this.finishTopicReference(e, s, t, r);
            }
            finishTopicReference(t, e, s, r) {
              if (this.testTopicReferenceConfiguration(s, e, r)) {
                let i = s === "smart" ? "PipelinePrimaryTopicReference" : "TopicReference";
                return this.topicReferenceIsAllowedInCurrentContext() || this.raise(s === "smart" ? u.PrimaryTopicNotAllowed : u.PipeTopicUnbound, { at: e }), this.registerTopicReference(), this.finishNode(t, i);
              } else throw this.raise(u.PipeTopicUnconfiguredToken, { at: e, token: Pe(r) });
            }
            testTopicReferenceConfiguration(t, e, s) {
              switch (t) {
                case "hack":
                  return this.hasPlugin(["pipelineOperator", { topicToken: Pe(s) }]);
                case "smart":
                  return s === 27;
                default:
                  throw this.raise(u.PipeTopicRequiresHackPipes, { at: e });
              }
            }
            parseAsyncArrowUnaryFunction(t) {
              this.prodParam.enter(gt(true, this.prodParam.hasYield));
              let e = [this.parseIdentifier()];
              return this.prodParam.exit(), this.hasPrecedingLineBreak() && this.raise(u.LineTerminatorBeforeArrow, { at: this.state.curPosition() }), this.expect(19), this.parseArrowExpression(t, e, true), t;
            }
            parseDo(t, e) {
              this.expectPlugin("doExpressions"), e && this.expectPlugin("asyncDoExpressions"), t.async = e, this.next();
              let s = this.state.labels;
              return this.state.labels = [], e ? (this.prodParam.enter(xt), t.body = this.parseBlock(), this.prodParam.exit()) : t.body = this.parseBlock(), this.state.labels = s, this.finishNode(t, "DoExpression");
            }
            parseSuper() {
              let t = this.startNode();
              return this.next(), this.match(10) && !this.scope.allowDirectSuper && !this.options.allowSuperOutsideMethod ? this.raise(u.SuperNotAllowed, { at: t }) : !this.scope.allowSuper && !this.options.allowSuperOutsideMethod && this.raise(u.UnexpectedSuper, { at: t }), !this.match(10) && !this.match(0) && !this.match(16) && this.raise(u.UnsupportedSuper, { at: t }), this.finishNode(t, "Super");
            }
            parsePrivateName() {
              let t = this.startNode(), e = this.startNodeAt(this.state.start + 1, new p(this.state.curLine, this.state.start + 1 - this.state.lineStart, this.state.start + 1)), s = this.state.value;
              return this.next(), t.id = this.createIdentifier(e, s), this.finishNode(t, "PrivateName");
            }
            parseFunctionOrFunctionSent() {
              let t = this.startNode();
              if (this.next(), this.prodParam.hasYield && this.match(16)) {
                let e = this.createIdentifier(this.startNodeAtNode(t), "function");
                return this.next(), this.match(102) ? this.expectPlugin("functionSent") : this.hasPlugin("functionSent") || this.unexpected(), this.parseMetaProperty(t, e, "sent");
              }
              return this.parseFunction(t);
            }
            parseMetaProperty(t, e, s) {
              t.meta = e;
              let r = this.state.containsEsc;
              return t.property = this.parseIdentifier(true), (t.property.name !== s || r) && this.raise(u.UnsupportedMetaProperty, { at: t.property, target: e.name, onlyValidPropertyName: s }), this.finishNode(t, "MetaProperty");
            }
            parseImportMetaProperty(t) {
              let e = this.createIdentifier(this.startNodeAtNode(t), "import");
              return this.next(), this.isContextual(100) && (this.inModule || this.raise(u.ImportMetaOutsideModule, { at: e }), this.sawUnambiguousESM = true), this.parseMetaProperty(t, e, "meta");
            }
            parseLiteralAtNode(t, e, s) {
              return this.addExtra(s, "rawValue", t), this.addExtra(s, "raw", this.input.slice(s.start, this.state.end)), s.value = t, this.next(), this.finishNode(s, e);
            }
            parseLiteral(t, e) {
              let s = this.startNode();
              return this.parseLiteralAtNode(t, e, s);
            }
            parseStringLiteral(t) {
              return this.parseLiteral(t, "StringLiteral");
            }
            parseNumericLiteral(t) {
              return this.parseLiteral(t, "NumericLiteral");
            }
            parseBigIntLiteral(t) {
              return this.parseLiteral(t, "BigIntLiteral");
            }
            parseDecimalLiteral(t) {
              return this.parseLiteral(t, "DecimalLiteral");
            }
            parseRegExpLiteral(t) {
              let e = this.parseLiteral(t.value, "RegExpLiteral");
              return e.pattern = t.pattern, e.flags = t.flags, e;
            }
            parseBooleanLiteral(t) {
              let e = this.startNode();
              return e.value = t, this.next(), this.finishNode(e, "BooleanLiteral");
            }
            parseNullLiteral() {
              let t = this.startNode();
              return this.next(), this.finishNode(t, "NullLiteral");
            }
            parseParenAndDistinguishExpression(t) {
              let e = this.state.start, s = this.state.startLoc, r;
              this.next(), this.expressionScope.enter(Ah());
              let i = this.state.maybeInArrowParameters, a = this.state.inFSharpPipelineDirectBody;
              this.state.maybeInArrowParameters = true, this.state.inFSharpPipelineDirectBody = false;
              let n = this.state.start, o = this.state.startLoc, c = [], f = new At(), y = true, P, v;
              for (; !this.match(11); ) {
                if (y) y = false;
                else if (this.expect(12, f.optionalParametersLoc === null ? null : f.optionalParametersLoc), this.match(11)) {
                  v = this.state.startLoc;
                  break;
                }
                if (this.match(21)) {
                  let _ = this.state.start, Q = this.state.startLoc;
                  if (P = this.state.startLoc, c.push(this.parseParenItem(this.parseRestBinding(), _, Q)), !this.checkCommaAfterRest(41)) break;
                } else c.push(this.parseMaybeAssignAllowIn(f, this.parseParenItem));
              }
              let N = this.state.lastTokEndLoc;
              this.expect(11), this.state.maybeInArrowParameters = i, this.state.inFSharpPipelineDirectBody = a;
              let B = this.startNodeAt(e, s);
              return t && this.shouldParseArrow(c) && (B = this.parseArrow(B)) ? (this.checkDestructuringPrivate(f), this.expressionScope.validateAsPattern(), this.expressionScope.exit(), this.parseArrowExpression(B, c, false), B) : (this.expressionScope.exit(), c.length || this.unexpected(this.state.lastTokStartLoc), v && this.unexpected(v), P && this.unexpected(P), this.checkExpressionErrors(f, true), this.toReferencedListDeep(c, true), c.length > 1 ? (r = this.startNodeAt(n, o), r.expressions = c, this.finishNode(r, "SequenceExpression"), this.resetEndLocation(r, N)) : r = c[0], this.wrapParenthesis(e, s, r));
            }
            wrapParenthesis(t, e, s) {
              if (!this.options.createParenthesizedExpressions) return this.addExtra(s, "parenthesized", true), this.addExtra(s, "parenStart", t), this.takeSurroundingComments(s, t, this.state.lastTokEndLoc.index), s;
              let r = this.startNodeAt(t, e);
              return r.expression = s, this.finishNode(r, "ParenthesizedExpression"), r;
            }
            shouldParseArrow(t) {
              return !this.canInsertSemicolon();
            }
            parseArrow(t) {
              if (this.eat(19)) return t;
            }
            parseParenItem(t, e, s) {
              return t;
            }
            parseNewOrNewTarget() {
              let t = this.startNode();
              if (this.next(), this.match(16)) {
                let e = this.createIdentifier(this.startNodeAtNode(t), "new");
                this.next();
                let s = this.parseMetaProperty(t, e, "target");
                return !this.scope.inNonArrowFunction && !this.scope.inClass && this.raise(u.UnexpectedNewTarget, { at: s }), s;
              }
              return this.parseNew(t);
            }
            parseNew(t) {
              if (this.parseNewCallee(t), this.eat(10)) {
                let e = this.parseExprList(11);
                this.toReferencedList(e), t.arguments = e;
              } else t.arguments = [];
              return this.finishNode(t, "NewExpression");
            }
            parseNewCallee(t) {
              t.callee = this.parseNoCallExpr(), t.callee.type === "Import" ? this.raise(u.ImportCallNotNewExpression, { at: t.callee }) : this.isOptionalChain(t.callee) ? this.raise(u.OptionalChainingNoNew, { at: this.state.lastTokEndLoc }) : this.eat(18) && this.raise(u.OptionalChainingNoNew, { at: this.state.startLoc });
            }
            parseTemplateElement(t) {
              let { start: e, startLoc: s, end: r, value: i } = this.state, a = e + 1, n = this.startNodeAt(a, m(s, 1));
              i === null && (t || this.raise(u.InvalidEscapeSequenceTemplate, { at: m(s, 2) }));
              let o = this.match(24), c = o ? -1 : -2, f = r + c;
              return n.value = { raw: this.input.slice(a, f).replace(/\r\n?/g, `
`), cooked: i === null ? null : i.slice(1, c) }, n.tail = o, this.next(), this.finishNode(n, "TemplateElement"), this.resetEndLocation(n, m(this.state.lastTokEndLoc, c)), n;
            }
            parseTemplate(t) {
              let e = this.startNode();
              e.expressions = [];
              let s = this.parseTemplateElement(t);
              for (e.quasis = [s]; !s.tail; ) e.expressions.push(this.parseTemplateSubstitution()), this.readTemplateContinuation(), e.quasis.push(s = this.parseTemplateElement(t));
              return this.finishNode(e, "TemplateLiteral");
            }
            parseTemplateSubstitution() {
              return this.parseExpression();
            }
            parseObjectLike(t, e, s, r) {
              s && this.expectPlugin("recordAndTuple");
              let i = this.state.inFSharpPipelineDirectBody;
              this.state.inFSharpPipelineDirectBody = false;
              let a = /* @__PURE__ */ Object.create(null), n = true, o = this.startNode();
              for (o.properties = [], this.next(); !this.match(t); ) {
                if (n) n = false;
                else if (this.expect(12), this.match(t)) {
                  this.addTrailingCommaExtraToNode(o);
                  break;
                }
                let f;
                e ? f = this.parseBindingProperty() : (f = this.parsePropertyDefinition(r), this.checkProto(f, s, a, r)), s && !this.isObjectProperty(f) && f.type !== "SpreadElement" && this.raise(u.InvalidRecordProperty, { at: f }), f.shorthand && this.addExtra(f, "shorthand", true), o.properties.push(f);
              }
              this.next(), this.state.inFSharpPipelineDirectBody = i;
              let c = "ObjectExpression";
              return e ? c = "ObjectPattern" : s && (c = "RecordExpression"), this.finishNode(o, c);
            }
            addTrailingCommaExtraToNode(t) {
              this.addExtra(t, "trailingComma", this.state.lastTokStart), this.addExtra(t, "trailingCommaLoc", this.state.lastTokStartLoc, false);
            }
            maybeAsyncOrAccessorProp(t) {
              return !t.computed && t.key.type === "Identifier" && (this.isLiteralPropertyName() || this.match(0) || this.match(55));
            }
            parsePropertyDefinition(t) {
              let e = [];
              if (this.match(26)) for (this.hasPlugin("decorators") && this.raise(u.UnsupportedPropertyDecorator, { at: this.state.startLoc }); this.match(26); ) e.push(this.parseDecorator());
              let s = this.startNode(), r = false, i = false, a, n;
              if (this.match(21)) return e.length && this.unexpected(), this.parseSpread();
              e.length && (s.decorators = e, e = []), s.method = false, t && (a = this.state.start, n = this.state.startLoc);
              let o = this.eat(55);
              this.parsePropertyNamePrefixOperator(s);
              let c = this.state.containsEsc, f = this.parsePropertyName(s, t);
              if (!o && !c && this.maybeAsyncOrAccessorProp(s)) {
                let y = f.name;
                y === "async" && !this.hasPrecedingLineBreak() && (r = true, this.resetPreviousNodeTrailingComments(f), o = this.eat(55), this.parsePropertyName(s)), (y === "get" || y === "set") && (i = true, this.resetPreviousNodeTrailingComments(f), s.kind = y, this.match(55) && (o = true, this.raise(u.AccessorIsGenerator, { at: this.state.curPosition(), kind: y }), this.next()), this.parsePropertyName(s));
              }
              return this.parseObjPropValue(s, a, n, o, r, false, i, t), s;
            }
            getGetterSetterExpectedParamCount(t) {
              return t.kind === "get" ? 0 : 1;
            }
            getObjectOrClassMethodParams(t) {
              return t.params;
            }
            checkGetterSetterParams(t) {
              var e;
              let s = this.getGetterSetterExpectedParamCount(t), r = this.getObjectOrClassMethodParams(t);
              r.length !== s && this.raise(t.kind === "get" ? u.BadGetterArity : u.BadSetterArity, { at: t }), t.kind === "set" && ((e = r[r.length - 1]) == null ? void 0 : e.type) === "RestElement" && this.raise(u.BadSetterRestParameter, { at: t });
            }
            parseObjectMethod(t, e, s, r, i) {
              if (i) return this.parseMethod(t, e, false, false, false, "ObjectMethod"), this.checkGetterSetterParams(t), t;
              if (s || e || this.match(10)) return r && this.unexpected(), t.kind = "method", t.method = true, this.parseMethod(t, e, s, false, false, "ObjectMethod");
            }
            parseObjectProperty(t, e, s, r, i) {
              if (t.shorthand = false, this.eat(14)) return t.value = r ? this.parseMaybeDefault(this.state.start, this.state.startLoc) : this.parseMaybeAssignAllowIn(i), this.finishNode(t, "ObjectProperty");
              if (!t.computed && t.key.type === "Identifier") {
                if (this.checkReservedWord(t.key.name, t.key.loc.start, true, false), r) t.value = this.parseMaybeDefault(e, s, ge(t.key));
                else if (this.match(29)) {
                  let a = this.state.startLoc;
                  i != null ? i.shorthandAssignLoc === null && (i.shorthandAssignLoc = a) : this.raise(u.InvalidCoverInitializedName, { at: a }), t.value = this.parseMaybeDefault(e, s, ge(t.key));
                } else t.value = ge(t.key);
                return t.shorthand = true, this.finishNode(t, "ObjectProperty");
              }
            }
            parseObjPropValue(t, e, s, r, i, a, n, o) {
              let c = this.parseObjectMethod(t, r, i, a, n) || this.parseObjectProperty(t, e, s, a, o);
              return c || this.unexpected(), c;
            }
            parsePropertyName(t, e) {
              if (this.eat(0)) t.computed = true, t.key = this.parseMaybeAssignAllowIn(), this.expect(3);
              else {
                let { type: s, value: r } = this.state, i;
                if (pe(s)) i = this.parseIdentifier(true);
                else switch (s) {
                  case 130:
                    i = this.parseNumericLiteral(r);
                    break;
                  case 129:
                    i = this.parseStringLiteral(r);
                    break;
                  case 131:
                    i = this.parseBigIntLiteral(r);
                    break;
                  case 132:
                    i = this.parseDecimalLiteral(r);
                    break;
                  case 134: {
                    let a = this.state.startLoc;
                    e != null ? e.privateKeyLoc === null && (e.privateKeyLoc = a) : this.raise(u.UnexpectedPrivateField, { at: a }), i = this.parsePrivateName();
                    break;
                  }
                  default:
                    throw this.unexpected();
                }
                t.key = i, s !== 134 && (t.computed = false);
              }
              return t.key;
            }
            initFunction(t, e) {
              t.id = null, t.generator = false, t.async = !!e;
            }
            parseMethod(t, e, s, r, i, a) {
              let n = arguments.length > 6 && arguments[6] !== void 0 ? arguments[6] : false;
              this.initFunction(t, s), t.generator = !!e;
              let o = r;
              return this.scope.enter(me | ot | (n ? Se : 0) | (i ? xr : 0)), this.prodParam.enter(gt(s, t.generator)), this.parseFunctionParams(t, o), this.parseFunctionBodyAndFinish(t, a, true), this.prodParam.exit(), this.scope.exit(), t;
            }
            parseArrayLike(t, e, s, r) {
              s && this.expectPlugin("recordAndTuple");
              let i = this.state.inFSharpPipelineDirectBody;
              this.state.inFSharpPipelineDirectBody = false;
              let a = this.startNode();
              return this.next(), a.elements = this.parseExprList(t, !s, r, a), this.state.inFSharpPipelineDirectBody = i, this.finishNode(a, s ? "TupleExpression" : "ArrayExpression");
            }
            parseArrowExpression(t, e, s, r) {
              this.scope.enter(me | Jt);
              let i = gt(s, false);
              !this.match(5) && this.prodParam.hasIn && (i |= qe), this.prodParam.enter(i), this.initFunction(t, s);
              let a = this.state.maybeInArrowParameters;
              return e && (this.state.maybeInArrowParameters = true, this.setArrowFunctionParameters(t, e, r)), this.state.maybeInArrowParameters = false, this.parseFunctionBody(t, true), this.prodParam.exit(), this.scope.exit(), this.state.maybeInArrowParameters = a, this.finishNode(t, "ArrowFunctionExpression");
            }
            setArrowFunctionParameters(t, e, s) {
              this.toAssignableList(e, s, false), t.params = e;
            }
            parseFunctionBodyAndFinish(t, e) {
              let s = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
              this.parseFunctionBody(t, false, s), this.finishNode(t, e);
            }
            parseFunctionBody(t, e) {
              let s = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, r = e && !this.match(5);
              if (this.expressionScope.enter(Dr()), r) t.body = this.parseMaybeAssign(), this.checkParams(t, false, e, false);
              else {
                let i = this.state.strict, a = this.state.labels;
                this.state.labels = [], this.prodParam.enter(this.prodParam.currentFlags() | Lr), t.body = this.parseBlock(true, false, (n) => {
                  let o = !this.isSimpleParamList(t.params);
                  n && o && this.raise(u.IllegalLanguageModeDirective, { at: (t.kind === "method" || t.kind === "constructor") && !!t.key ? t.key.loc.end : t });
                  let c = !i && this.state.strict;
                  this.checkParams(t, !this.state.strict && !e && !s && !o, e, c), this.state.strict && t.id && this.checkIdentifier(t.id, Xo, c);
                }), this.prodParam.exit(), this.state.labels = a;
              }
              this.expressionScope.exit();
            }
            isSimpleParameter(t) {
              return t.type === "Identifier";
            }
            isSimpleParamList(t) {
              for (let e = 0, s = t.length; e < s; e++) if (!this.isSimpleParameter(t[e])) return false;
              return true;
            }
            checkParams(t, e, s) {
              let r = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true, i = !e && /* @__PURE__ */ new Set(), a = { type: "FormalParameters" };
              for (let n of t.params) this.checkLVal(n, { in: a, binding: pt, checkClashes: i, strictModeChanged: r });
            }
            parseExprList(t, e, s, r) {
              let i = [], a = true;
              for (; !this.eat(t); ) {
                if (a) a = false;
                else if (this.expect(12), this.match(t)) {
                  r && this.addTrailingCommaExtraToNode(r), this.next();
                  break;
                }
                i.push(this.parseExprListItem(e, s));
              }
              return i;
            }
            parseExprListItem(t, e, s) {
              let r;
              if (this.match(12)) t || this.raise(u.UnexpectedToken, { at: this.state.curPosition(), unexpected: "," }), r = null;
              else if (this.match(21)) {
                let i = this.state.start, a = this.state.startLoc;
                r = this.parseParenItem(this.parseSpread(e), i, a);
              } else if (this.match(17)) {
                this.expectPlugin("partialApplication"), s || this.raise(u.UnexpectedArgumentPlaceholder, { at: this.state.startLoc });
                let i = this.startNode();
                this.next(), r = this.finishNode(i, "ArgumentPlaceholder");
              } else r = this.parseMaybeAssignAllowIn(e, this.parseParenItem);
              return r;
            }
            parseIdentifier(t) {
              let e = this.startNode(), s = this.parseIdentifierName(e.start, t);
              return this.createIdentifier(e, s);
            }
            createIdentifier(t, e) {
              return t.name = e, t.loc.identifierName = e, this.finishNode(t, "Identifier");
            }
            parseIdentifierName(t, e) {
              let s, { startLoc: r, type: i } = this.state;
              if (pe(i)) s = this.state.value;
              else throw this.unexpected();
              let a = vo(i);
              return e ? a && this.replaceToken(128) : this.checkReservedWord(s, r, a, false), this.next(), s;
            }
            checkReservedWord(t, e, s, r) {
              if (t.length > 10 || !Ho(t)) return;
              if (t === "yield") {
                if (this.prodParam.hasYield) {
                  this.raise(u.YieldBindingIdentifier, { at: e });
                  return;
                }
              } else if (t === "await") {
                if (this.prodParam.hasAwait) {
                  this.raise(u.AwaitBindingIdentifier, { at: e });
                  return;
                }
                if (this.scope.inStaticBlock) {
                  this.raise(u.AwaitBindingIdentifierInStaticBlock, { at: e });
                  return;
                }
                this.expressionScope.recordAsyncArrowParametersError({ at: e });
              } else if (t === "arguments" && this.scope.inClassAndNotInNonArrowFunction) {
                this.raise(u.ArgumentsInClass, { at: e });
                return;
              }
              if (s && zo(t)) {
                this.raise(u.UnexpectedKeyword, { at: e, keyword: t });
                return;
              }
              (this.state.strict ? r ? mr : fr : pr)(t, this.inModule) && this.raise(u.UnexpectedReservedWord, { at: e, reservedWord: t });
            }
            isAwaitAllowed() {
              return !!(this.prodParam.hasAwait || this.options.allowAwaitOutsideFunction && !this.scope.inFunction);
            }
            parseAwait(t, e) {
              let s = this.startNodeAt(t, e);
              return this.expressionScope.recordParameterInitializerError(u.AwaitExpressionFormalParameter, { at: s }), this.eat(55) && this.raise(u.ObsoleteAwaitStar, { at: s }), !this.scope.inFunction && !this.options.allowAwaitOutsideFunction && (this.isAmbiguousAwait() ? this.ambiguousScriptDifferentAst = true : this.sawUnambiguousESM = true), this.state.soloAwait || (s.argument = this.parseMaybeUnary(null, true)), this.finishNode(s, "AwaitExpression");
            }
            isAmbiguousAwait() {
              if (this.hasPrecedingLineBreak()) return true;
              let { type: t } = this.state;
              return t === 53 || t === 10 || t === 0 || nt(t) || t === 133 || t === 56 || this.hasPlugin("v8intrinsic") && t === 54;
            }
            parseYield() {
              let t = this.startNode();
              this.expressionScope.recordParameterInitializerError(u.YieldInParameter, { at: t }), this.next();
              let e = false, s = null;
              if (!this.hasPrecedingLineBreak()) switch (e = this.eat(55), this.state.type) {
                case 13:
                case 135:
                case 8:
                case 11:
                case 3:
                case 9:
                case 14:
                case 12:
                  if (!e) break;
                default:
                  s = this.parseMaybeAssign();
              }
              return t.delegate = e, t.argument = s, this.finishNode(t, "YieldExpression");
            }
            checkPipelineAtInfixOperator(t, e) {
              this.hasPlugin(["pipelineOperator", { proposal: "smart" }]) && t.type === "SequenceExpression" && this.raise(u.PipelineHeadSequenceExpression, { at: e });
            }
            parseSmartPipelineBodyInStyle(t, e, s) {
              let r = this.startNodeAt(e, s);
              return this.isSimpleReference(t) ? (r.callee = t, this.finishNode(r, "PipelineBareFunction")) : (this.checkSmartPipeTopicBodyEarlyErrors(s), r.expression = t, this.finishNode(r, "PipelineTopicExpression"));
            }
            isSimpleReference(t) {
              switch (t.type) {
                case "MemberExpression":
                  return !t.computed && this.isSimpleReference(t.object);
                case "Identifier":
                  return true;
                default:
                  return false;
              }
            }
            checkSmartPipeTopicBodyEarlyErrors(t) {
              if (this.match(19)) throw this.raise(u.PipelineBodyNoArrow, { at: this.state.startLoc });
              this.topicReferenceWasUsedInCurrentContext() || this.raise(u.PipelineTopicUnused, { at: t });
            }
            withTopicBindingContext(t) {
              let e = this.state.topicContext;
              this.state.topicContext = { maxNumOfResolvableTopics: 1, maxTopicIndex: null };
              try {
                return t();
              } finally {
                this.state.topicContext = e;
              }
            }
            withSmartMixTopicForbiddingContext(t) {
              if (this.hasPlugin(["pipelineOperator", { proposal: "smart" }])) {
                let e = this.state.topicContext;
                this.state.topicContext = { maxNumOfResolvableTopics: 0, maxTopicIndex: null };
                try {
                  return t();
                } finally {
                  this.state.topicContext = e;
                }
              } else return t();
            }
            withSoloAwaitPermittingContext(t) {
              let e = this.state.soloAwait;
              this.state.soloAwait = true;
              try {
                return t();
              } finally {
                this.state.soloAwait = e;
              }
            }
            allowInAnd(t) {
              let e = this.prodParam.currentFlags();
              if (qe & ~e) {
                this.prodParam.enter(e | qe);
                try {
                  return t();
                } finally {
                  this.prodParam.exit();
                }
              }
              return t();
            }
            disallowInAnd(t) {
              let e = this.prodParam.currentFlags();
              if (qe & e) {
                this.prodParam.enter(e & ~qe);
                try {
                  return t();
                } finally {
                  this.prodParam.exit();
                }
              }
              return t();
            }
            registerTopicReference() {
              this.state.topicContext.maxTopicIndex = 0;
            }
            topicReferenceIsAllowedInCurrentContext() {
              return this.state.topicContext.maxNumOfResolvableTopics >= 1;
            }
            topicReferenceWasUsedInCurrentContext() {
              return this.state.topicContext.maxTopicIndex != null && this.state.topicContext.maxTopicIndex >= 0;
            }
            parseFSharpPipelineBody(t) {
              let e = this.state.start, s = this.state.startLoc;
              this.state.potentialArrowAt = this.state.start;
              let r = this.state.inFSharpPipelineDirectBody;
              this.state.inFSharpPipelineDirectBody = true;
              let i = this.parseExprOp(this.parseMaybeUnaryOrPrivate(), e, s, t);
              return this.state.inFSharpPipelineDirectBody = r, i;
            }
            parseModuleExpression() {
              this.expectPlugin("moduleBlocks");
              let t = this.startNode();
              this.next(), this.eat(5);
              let e = this.initializeScopes(true);
              this.enterInitialScopes();
              let s = this.startNode();
              try {
                t.body = this.parseProgram(s, 8, "module");
              } finally {
                e();
              }
              return this.eat(8), this.finishNode(t, "ModuleExpression");
            }
            parsePropertyNamePrefixOperator(t) {
            }
          }, ps = { kind: "loop" }, $h = { kind: "switch" }, Qh = 0, fs = 1, Hr = 2, Wr = 4, Zh = /[\uD800-\uDFFF]/u, ds = /in(?:stanceof)?/y;
          function el(t, e) {
            for (let s = 0; s < t.length; s++) {
              let r = t[s], { type: i } = r;
              if (typeof i == "number") {
                {
                  if (i === 134) {
                    let { loc: a, start: n, value: o, end: c } = r, f = n + 1, y = m(a.start, 1);
                    t.splice(s, 1, new Ee({ type: fe(27), value: "#", start: n, end: f, startLoc: a.start, endLoc: y }), new Ee({ type: fe(128), value: o, start: f, end: c, startLoc: y, endLoc: a.end })), s++;
                    continue;
                  }
                  if (nt(i)) {
                    let { loc: a, start: n, value: o, end: c } = r, f = n + 1, y = m(a.start, 1), P;
                    e.charCodeAt(n) === 96 ? P = new Ee({ type: fe(22), value: "`", start: n, end: f, startLoc: a.start, endLoc: y }) : P = new Ee({ type: fe(8), value: "}", start: n, end: f, startLoc: a.start, endLoc: y });
                    let v, N, B, _;
                    i === 24 ? (N = c - 1, B = m(a.end, -1), v = o === null ? null : o.slice(1, -1), _ = new Ee({ type: fe(22), value: "`", start: N, end: c, startLoc: B, endLoc: a.end })) : (N = c - 2, B = m(a.end, -2), v = o === null ? null : o.slice(1, -2), _ = new Ee({ type: fe(23), value: "${", start: N, end: c, startLoc: B, endLoc: a.end })), t.splice(s, 1, P, new Ee({ type: fe(20), value: v, start: f, end: N, startLoc: y, endLoc: B }), _), s += 2;
                    continue;
                  }
                }
                r.type = fe(i);
              }
            }
            return t;
          }
          var tl = class extends Yh {
            parseTopLevel(t, e) {
              return t.program = this.parseProgram(e), t.comments = this.state.comments, this.options.tokens && (t.tokens = el(this.tokens, this.input)), this.finishNode(t, "File");
            }
            parseProgram(t) {
              let e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 135, s = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : this.options.sourceType;
              if (t.sourceType = s, t.interpreter = this.parseInterpreterDirective(), this.parseBlockBody(t, true, true, e), this.inModule && !this.options.allowUndeclaredExports && this.scope.undefinedExports.size > 0) for (let [r, i] of Array.from(this.scope.undefinedExports)) this.raise(u.ModuleExportUndefined, { at: i, localName: r });
              return this.finishNode(t, "Program");
            }
            stmtToDirective(t) {
              let e = t;
              e.type = "Directive", e.value = e.expression, delete e.expression;
              let s = e.value, r = s.value, i = this.input.slice(s.start, s.end), a = s.value = i.slice(1, -1);
              return this.addExtra(s, "raw", i), this.addExtra(s, "rawValue", a), this.addExtra(s, "expressionValue", r), s.type = "DirectiveLiteral", e;
            }
            parseInterpreterDirective() {
              if (!this.match(28)) return null;
              let t = this.startNode();
              return t.value = this.state.value, this.next(), this.finishNode(t, "InterpreterDirective");
            }
            isLet(t) {
              return this.isContextual(99) ? this.isLetKeyword(t) : false;
            }
            isLetKeyword(t) {
              let e = this.nextTokenStart(), s = this.codePointAtPos(e);
              if (s === 92 || s === 91) return true;
              if (t) return false;
              if (s === 123) return true;
              if (de(s)) {
                if (ds.lastIndex = e, ds.test(this.input)) {
                  let r = this.codePointAtPos(ds.lastIndex);
                  if (!Be(r) && r !== 92) return false;
                }
                return true;
              }
              return false;
            }
            parseStatement(t, e) {
              return this.match(26) && this.parseDecorators(true), this.parseStatementContent(t, e);
            }
            parseStatementContent(t, e) {
              let s = this.state.type, r = this.startNode(), i;
              switch (this.isLet(t) && (s = 74, i = "let"), s) {
                case 60:
                  return this.parseBreakContinueStatement(r, true);
                case 63:
                  return this.parseBreakContinueStatement(r, false);
                case 64:
                  return this.parseDebuggerStatement(r);
                case 90:
                  return this.parseDoStatement(r);
                case 91:
                  return this.parseForStatement(r);
                case 68:
                  if (this.lookaheadCharCode() === 46) break;
                  return t && (this.state.strict ? this.raise(u.StrictFunction, { at: this.state.startLoc }) : t !== "if" && t !== "label" && this.raise(u.SloppyFunction, { at: this.state.startLoc })), this.parseFunctionStatement(r, false, !t);
                case 80:
                  return t && this.unexpected(), this.parseClass(r, true);
                case 69:
                  return this.parseIfStatement(r);
                case 70:
                  return this.parseReturnStatement(r);
                case 71:
                  return this.parseSwitchStatement(r);
                case 72:
                  return this.parseThrowStatement(r);
                case 73:
                  return this.parseTryStatement(r);
                case 75:
                case 74:
                  return i = i || this.state.value, t && i !== "var" && this.raise(u.UnexpectedLexicalDeclaration, { at: this.state.startLoc }), this.parseVarStatement(r, i);
                case 92:
                  return this.parseWhileStatement(r);
                case 76:
                  return this.parseWithStatement(r);
                case 5:
                  return this.parseBlock();
                case 13:
                  return this.parseEmptyStatement(r);
                case 83: {
                  let o = this.lookaheadCharCode();
                  if (o === 40 || o === 46) break;
                }
                case 82: {
                  !this.options.allowImportExportEverywhere && !e && this.raise(u.UnexpectedImportExport, { at: this.state.startLoc }), this.next();
                  let o;
                  return s === 83 ? (o = this.parseImport(r), o.type === "ImportDeclaration" && (!o.importKind || o.importKind === "value") && (this.sawUnambiguousESM = true)) : (o = this.parseExport(r), (o.type === "ExportNamedDeclaration" && (!o.exportKind || o.exportKind === "value") || o.type === "ExportAllDeclaration" && (!o.exportKind || o.exportKind === "value") || o.type === "ExportDefaultDeclaration") && (this.sawUnambiguousESM = true)), this.assertModuleNodeAllowed(r), o;
                }
                default:
                  if (this.isAsyncFunction()) return t && this.raise(u.AsyncFunctionInSingleStatementContext, { at: this.state.startLoc }), this.next(), this.parseFunctionStatement(r, true, !t);
              }
              let a = this.state.value, n = this.parseExpression();
              return K(s) && n.type === "Identifier" && this.eat(14) ? this.parseLabeledStatement(r, a, n, t) : this.parseExpressionStatement(r, n);
            }
            assertModuleNodeAllowed(t) {
              !this.options.allowImportExportEverywhere && !this.inModule && this.raise(u.ImportOutsideModule, { at: t });
            }
            takeDecorators(t) {
              let e = this.state.decoratorStack[this.state.decoratorStack.length - 1];
              e.length && (t.decorators = e, this.resetStartLocationFromNode(t, e[0]), this.state.decoratorStack[this.state.decoratorStack.length - 1] = []);
            }
            canHaveLeadingDecorator() {
              return this.match(80);
            }
            parseDecorators(t) {
              let e = this.state.decoratorStack[this.state.decoratorStack.length - 1];
              for (; this.match(26); ) {
                let s = this.parseDecorator();
                e.push(s);
              }
              if (this.match(82)) t || this.unexpected(), this.hasPlugin("decorators") && !this.getPluginOption("decorators", "decoratorsBeforeExport") && this.raise(u.DecoratorExportClass, { at: this.state.startLoc });
              else if (!this.canHaveLeadingDecorator()) throw this.raise(u.UnexpectedLeadingDecorator, { at: this.state.startLoc });
            }
            parseDecorator() {
              this.expectOnePlugin(["decorators-legacy", "decorators"]);
              let t = this.startNode();
              if (this.next(), this.hasPlugin("decorators")) {
                this.state.decoratorStack.push([]);
                let e = this.state.start, s = this.state.startLoc, r;
                if (this.match(10)) {
                  let i = this.state.start, a = this.state.startLoc;
                  this.next(), r = this.parseExpression(), this.expect(11), r = this.wrapParenthesis(i, a, r);
                } else for (r = this.parseIdentifier(false); this.eat(16); ) {
                  let i = this.startNodeAt(e, s);
                  i.object = r, i.property = this.parseIdentifier(true), i.computed = false, r = this.finishNode(i, "MemberExpression");
                }
                t.expression = this.parseMaybeDecoratorArguments(r), this.state.decoratorStack.pop();
              } else t.expression = this.parseExprSubscripts();
              return this.finishNode(t, "Decorator");
            }
            parseMaybeDecoratorArguments(t) {
              if (this.eat(10)) {
                let e = this.startNodeAtNode(t);
                return e.callee = t, e.arguments = this.parseCallExpressionArguments(11, false), this.toReferencedList(e.arguments), this.finishNode(e, "CallExpression");
              }
              return t;
            }
            parseBreakContinueStatement(t, e) {
              return this.next(), this.isLineTerminator() ? t.label = null : (t.label = this.parseIdentifier(), this.semicolon()), this.verifyBreakContinue(t, e), this.finishNode(t, e ? "BreakStatement" : "ContinueStatement");
            }
            verifyBreakContinue(t, e) {
              let s;
              for (s = 0; s < this.state.labels.length; ++s) {
                let r = this.state.labels[s];
                if ((t.label == null || r.name === t.label.name) && (r.kind != null && (e || r.kind === "loop") || t.label && e)) break;
              }
              if (s === this.state.labels.length) {
                let r = e ? "BreakStatement" : "ContinueStatement";
                this.raise(u.IllegalBreakContinue, { at: t, type: r });
              }
            }
            parseDebuggerStatement(t) {
              return this.next(), this.semicolon(), this.finishNode(t, "DebuggerStatement");
            }
            parseHeaderExpression() {
              this.expect(10);
              let t = this.parseExpression();
              return this.expect(11), t;
            }
            parseDoStatement(t) {
              return this.next(), this.state.labels.push(ps), t.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement("do")), this.state.labels.pop(), this.expect(92), t.test = this.parseHeaderExpression(), this.eat(13), this.finishNode(t, "DoWhileStatement");
            }
            parseForStatement(t) {
              this.next(), this.state.labels.push(ps);
              let e = null;
              if (this.isAwaitAllowed() && this.eatContextual(96) && (e = this.state.lastTokStartLoc), this.scope.enter(Me), this.expect(10), this.match(13)) return e !== null && this.unexpected(e), this.parseFor(t, null);
              let s = this.isContextual(99), r = s && this.isLetKeyword();
              if (this.match(74) || this.match(75) || r) {
                let c = this.startNode(), f = r ? "let" : this.state.value;
                return this.next(), this.parseVar(c, true, f), this.finishNode(c, "VariableDeclaration"), (this.match(58) || this.isContextual(101)) && c.declarations.length === 1 ? this.parseForIn(t, c, e) : (e !== null && this.unexpected(e), this.parseFor(t, c));
              }
              let i = this.isContextual(95), a = new At(), n = this.parseExpression(true, a), o = this.isContextual(101);
              if (o && (s && this.raise(u.ForOfLet, { at: n }), e === null && i && n.type === "Identifier" && this.raise(u.ForOfAsync, { at: n })), o || this.match(58)) {
                this.checkDestructuringPrivate(a), this.toAssignable(n, true);
                let c = o ? "ForOfStatement" : "ForInStatement";
                return this.checkLVal(n, { in: { type: c } }), this.parseForIn(t, n, e);
              } else this.checkExpressionErrors(a, true);
              return e !== null && this.unexpected(e), this.parseFor(t, n);
            }
            parseFunctionStatement(t, e, s) {
              return this.next(), this.parseFunction(t, fs | (s ? 0 : Hr), e);
            }
            parseIfStatement(t) {
              return this.next(), t.test = this.parseHeaderExpression(), t.consequent = this.parseStatement("if"), t.alternate = this.eat(66) ? this.parseStatement("if") : null, this.finishNode(t, "IfStatement");
            }
            parseReturnStatement(t) {
              return !this.prodParam.hasReturn && !this.options.allowReturnOutsideFunction && this.raise(u.IllegalReturn, { at: this.state.startLoc }), this.next(), this.isLineTerminator() ? t.argument = null : (t.argument = this.parseExpression(), this.semicolon()), this.finishNode(t, "ReturnStatement");
            }
            parseSwitchStatement(t) {
              this.next(), t.discriminant = this.parseHeaderExpression();
              let e = t.cases = [];
              this.expect(5), this.state.labels.push($h), this.scope.enter(Me);
              let s;
              for (let r; !this.match(8); ) if (this.match(61) || this.match(65)) {
                let i = this.match(61);
                s && this.finishNode(s, "SwitchCase"), e.push(s = this.startNode()), s.consequent = [], this.next(), i ? s.test = this.parseExpression() : (r && this.raise(u.MultipleDefaultsInSwitch, { at: this.state.lastTokStartLoc }), r = true, s.test = null), this.expect(14);
              } else s ? s.consequent.push(this.parseStatement(null)) : this.unexpected();
              return this.scope.exit(), s && this.finishNode(s, "SwitchCase"), this.next(), this.state.labels.pop(), this.finishNode(t, "SwitchStatement");
            }
            parseThrowStatement(t) {
              return this.next(), this.hasPrecedingLineBreak() && this.raise(u.NewlineAfterThrow, { at: this.state.lastTokEndLoc }), t.argument = this.parseExpression(), this.semicolon(), this.finishNode(t, "ThrowStatement");
            }
            parseCatchClauseParam() {
              let t = this.parseBindingAtom(), e = t.type === "Identifier";
              return this.scope.enter(e ? yr : 0), this.checkLVal(t, { in: { type: "CatchClause" }, binding: xe, allowingSloppyLetBinding: true }), t;
            }
            parseTryStatement(t) {
              if (this.next(), t.block = this.parseBlock(), t.handler = null, this.match(62)) {
                let e = this.startNode();
                this.next(), this.match(10) ? (this.expect(10), e.param = this.parseCatchClauseParam(), this.expect(11)) : (e.param = null, this.scope.enter(Me)), e.body = this.withSmartMixTopicForbiddingContext(() => this.parseBlock(false, false)), this.scope.exit(), t.handler = this.finishNode(e, "CatchClause");
              }
              return t.finalizer = this.eat(67) ? this.parseBlock() : null, !t.handler && !t.finalizer && this.raise(u.NoCatchOrFinally, { at: t }), this.finishNode(t, "TryStatement");
            }
            parseVarStatement(t, e) {
              let s = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
              return this.next(), this.parseVar(t, false, e, s), this.semicolon(), this.finishNode(t, "VariableDeclaration");
            }
            parseWhileStatement(t) {
              return this.next(), t.test = this.parseHeaderExpression(), this.state.labels.push(ps), t.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement("while")), this.state.labels.pop(), this.finishNode(t, "WhileStatement");
            }
            parseWithStatement(t) {
              return this.state.strict && this.raise(u.StrictWith, { at: this.state.startLoc }), this.next(), t.object = this.parseHeaderExpression(), t.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement("with")), this.finishNode(t, "WithStatement");
            }
            parseEmptyStatement(t) {
              return this.next(), this.finishNode(t, "EmptyStatement");
            }
            parseLabeledStatement(t, e, s, r) {
              for (let a of this.state.labels) a.name === e && this.raise(u.LabelRedeclaration, { at: s, labelName: e });
              let i = No(this.state.type) ? "loop" : this.match(71) ? "switch" : null;
              for (let a = this.state.labels.length - 1; a >= 0; a--) {
                let n = this.state.labels[a];
                if (n.statementStart === t.start) n.statementStart = this.state.start, n.kind = i;
                else break;
              }
              return this.state.labels.push({ name: e, kind: i, statementStart: this.state.start }), t.body = this.parseStatement(r ? r.indexOf("label") === -1 ? r + "label" : r : "label"), this.state.labels.pop(), t.label = s, this.finishNode(t, "LabeledStatement");
            }
            parseExpressionStatement(t, e) {
              return t.expression = e, this.semicolon(), this.finishNode(t, "ExpressionStatement");
            }
            parseBlock() {
              let t = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true, s = arguments.length > 2 ? arguments[2] : void 0, r = this.startNode();
              return t && this.state.strictErrors.clear(), this.expect(5), e && this.scope.enter(Me), this.parseBlockBody(r, t, false, 8, s), e && this.scope.exit(), this.finishNode(r, "BlockStatement");
            }
            isValidDirective(t) {
              return t.type === "ExpressionStatement" && t.expression.type === "StringLiteral" && !t.expression.extra.parenthesized;
            }
            parseBlockBody(t, e, s, r, i) {
              let a = t.body = [], n = t.directives = [];
              this.parseBlockOrModuleBlockBody(a, e ? n : void 0, s, r, i);
            }
            parseBlockOrModuleBlockBody(t, e, s, r, i) {
              let a = this.state.strict, n = false, o = false;
              for (; !this.match(r); ) {
                let c = this.parseStatement(null, s);
                if (e && !o) {
                  if (this.isValidDirective(c)) {
                    let f = this.stmtToDirective(c);
                    e.push(f), !n && f.value.value === "use strict" && (n = true, this.setStrict(true));
                    continue;
                  }
                  o = true, this.state.strictErrors.clear();
                }
                t.push(c);
              }
              i && i.call(this, n), a || this.setStrict(false), this.next();
            }
            parseFor(t, e) {
              return t.init = e, this.semicolon(false), t.test = this.match(13) ? null : this.parseExpression(), this.semicolon(false), t.update = this.match(11) ? null : this.parseExpression(), this.expect(11), t.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement("for")), this.scope.exit(), this.state.labels.pop(), this.finishNode(t, "ForStatement");
            }
            parseForIn(t, e, s) {
              let r = this.match(58);
              return this.next(), r ? s !== null && this.unexpected(s) : t.await = s !== null, e.type === "VariableDeclaration" && e.declarations[0].init != null && (!r || this.state.strict || e.kind !== "var" || e.declarations[0].id.type !== "Identifier") && this.raise(u.ForInOfLoopInitializer, { at: e, type: r ? "ForInStatement" : "ForOfStatement" }), e.type === "AssignmentPattern" && this.raise(u.InvalidLhs, { at: e, ancestor: { type: "ForStatement" } }), t.left = e, t.right = r ? this.parseExpression() : this.parseMaybeAssignAllowIn(), this.expect(11), t.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement("for")), this.scope.exit(), this.state.labels.pop(), this.finishNode(t, r ? "ForInStatement" : "ForOfStatement");
            }
            parseVar(t, e, s) {
              let r = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, i = t.declarations = [];
              for (t.kind = s; ; ) {
                let a = this.startNode();
                if (this.parseVarId(a, s), a.init = this.eat(29) ? e ? this.parseMaybeAssignDisallowIn() : this.parseMaybeAssignAllowIn() : null, a.init === null && !r && (a.id.type !== "Identifier" && !(e && (this.match(58) || this.isContextual(101))) ? this.raise(u.DeclarationMissingInitializer, { at: this.state.lastTokEndLoc, kind: "destructuring" }) : s === "const" && !(this.match(58) || this.isContextual(101)) && this.raise(u.DeclarationMissingInitializer, { at: this.state.lastTokEndLoc, kind: "const" })), i.push(this.finishNode(a, "VariableDeclarator")), !this.eat(12)) break;
              }
              return t;
            }
            parseVarId(t, e) {
              t.id = this.parseBindingAtom(), this.checkLVal(t.id, { in: { type: "VariableDeclarator" }, binding: e === "var" ? pt : xe });
            }
            parseFunction(t) {
              let e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : Qh, s = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, r = e & fs, i = e & Hr, a = !!r && !(e & Wr);
              this.initFunction(t, s), this.match(55) && i && this.raise(u.GeneratorInSingleStatementContext, { at: this.state.startLoc }), t.generator = this.eat(55), r && (t.id = this.parseFunctionId(a));
              let n = this.state.maybeInArrowParameters;
              return this.state.maybeInArrowParameters = false, this.scope.enter(me), this.prodParam.enter(gt(s, t.generator)), r || (t.id = this.parseFunctionId()), this.parseFunctionParams(t, false), this.withSmartMixTopicForbiddingContext(() => {
                this.parseFunctionBodyAndFinish(t, r ? "FunctionDeclaration" : "FunctionExpression");
              }), this.prodParam.exit(), this.scope.exit(), r && !i && this.registerFunctionStatementId(t), this.state.maybeInArrowParameters = n, t;
            }
            parseFunctionId(t) {
              return t || K(this.state.type) ? this.parseIdentifier() : null;
            }
            parseFunctionParams(t, e) {
              this.expect(10), this.expressionScope.enter(gh()), t.params = this.parseBindingList(11, 41, false, e), this.expressionScope.exit();
            }
            registerFunctionStatementId(t) {
              !t.id || this.scope.declareName(t.id.name, this.state.strict || t.generator || t.async ? this.scope.treatFunctionsAsVar ? pt : xe : Tr, t.id.loc.start);
            }
            parseClass(t, e, s) {
              this.next(), this.takeDecorators(t);
              let r = this.state.strict;
              return this.state.strict = true, this.parseClassId(t, e, s), this.parseClassSuper(t), t.body = this.parseClassBody(!!t.superClass, r), this.finishNode(t, e ? "ClassDeclaration" : "ClassExpression");
            }
            isClassProperty() {
              return this.match(29) || this.match(13) || this.match(8);
            }
            isClassMethod() {
              return this.match(10);
            }
            isNonstaticConstructor(t) {
              return !t.computed && !t.static && (t.key.name === "constructor" || t.key.value === "constructor");
            }
            parseClassBody(t, e) {
              this.classScope.enter();
              let s = { hadConstructor: false, hadSuperClass: t }, r = [], i = this.startNode();
              if (i.body = [], this.expect(5), this.withSmartMixTopicForbiddingContext(() => {
                for (; !this.match(8); ) {
                  if (this.eat(13)) {
                    if (r.length > 0) throw this.raise(u.DecoratorSemicolon, { at: this.state.lastTokEndLoc });
                    continue;
                  }
                  if (this.match(26)) {
                    r.push(this.parseDecorator());
                    continue;
                  }
                  let a = this.startNode();
                  r.length && (a.decorators = r, this.resetStartLocationFromNode(a, r[0]), r = []), this.parseClassMember(i, a, s), a.kind === "constructor" && a.decorators && a.decorators.length > 0 && this.raise(u.DecoratorConstructor, { at: a });
                }
              }), this.state.strict = e, this.next(), r.length) throw this.raise(u.TrailingDecorator, { at: this.state.startLoc });
              return this.classScope.exit(), this.finishNode(i, "ClassBody");
            }
            parseClassMemberFromModifier(t, e) {
              let s = this.parseIdentifier(true);
              if (this.isClassMethod()) {
                let r = e;
                return r.kind = "method", r.computed = false, r.key = s, r.static = false, this.pushClassMethod(t, r, false, false, false, false), true;
              } else if (this.isClassProperty()) {
                let r = e;
                return r.computed = false, r.key = s, r.static = false, t.body.push(this.parseClassProperty(r)), true;
              }
              return this.resetPreviousNodeTrailingComments(s), false;
            }
            parseClassMember(t, e, s) {
              let r = this.isContextual(104);
              if (r) {
                if (this.parseClassMemberFromModifier(t, e)) return;
                if (this.eat(5)) {
                  this.parseClassStaticBlock(t, e);
                  return;
                }
              }
              this.parseClassMemberWithIsStatic(t, e, s, r);
            }
            parseClassMemberWithIsStatic(t, e, s, r) {
              let i = e, a = e, n = e, o = e, c = e, f = i, y = i;
              if (e.static = r, this.parsePropertyNamePrefixOperator(e), this.eat(55)) {
                f.kind = "method";
                let _ = this.match(134);
                if (this.parseClassElementName(f), _) {
                  this.pushClassPrivateMethod(t, a, true, false);
                  return;
                }
                this.isNonstaticConstructor(i) && this.raise(u.ConstructorIsGenerator, { at: i.key }), this.pushClassMethod(t, i, true, false, false, false);
                return;
              }
              let P = K(this.state.type) && !this.state.containsEsc, v = this.match(134), N = this.parseClassElementName(e), B = this.state.startLoc;
              if (this.parsePostMemberNameModifiers(y), this.isClassMethod()) {
                if (f.kind = "method", v) {
                  this.pushClassPrivateMethod(t, a, false, false);
                  return;
                }
                let _ = this.isNonstaticConstructor(i), Q = false;
                _ && (i.kind = "constructor", s.hadConstructor && !this.hasPlugin("typescript") && this.raise(u.DuplicateConstructor, { at: N }), _ && this.hasPlugin("typescript") && e.override && this.raise(u.OverrideOnConstructor, { at: N }), s.hadConstructor = true, Q = s.hadSuperClass), this.pushClassMethod(t, i, false, false, _, Q);
              } else if (this.isClassProperty()) v ? this.pushClassPrivateProperty(t, o) : this.pushClassProperty(t, n);
              else if (P && N.name === "async" && !this.isLineTerminator()) {
                this.resetPreviousNodeTrailingComments(N);
                let _ = this.eat(55);
                y.optional && this.unexpected(B), f.kind = "method";
                let Q = this.match(134);
                this.parseClassElementName(f), this.parsePostMemberNameModifiers(y), Q ? this.pushClassPrivateMethod(t, a, _, true) : (this.isNonstaticConstructor(i) && this.raise(u.ConstructorIsAsync, { at: i.key }), this.pushClassMethod(t, i, _, true, false, false));
              } else if (P && (N.name === "get" || N.name === "set") && !(this.match(55) && this.isLineTerminator())) {
                this.resetPreviousNodeTrailingComments(N), f.kind = N.name;
                let _ = this.match(134);
                this.parseClassElementName(i), _ ? this.pushClassPrivateMethod(t, a, false, false) : (this.isNonstaticConstructor(i) && this.raise(u.ConstructorIsAccessor, { at: i.key }), this.pushClassMethod(t, i, false, false, false, false)), this.checkGetterSetterParams(i);
              } else if (P && N.name === "accessor" && !this.isLineTerminator()) {
                this.expectPlugin("decoratorAutoAccessors"), this.resetPreviousNodeTrailingComments(N);
                let _ = this.match(134);
                this.parseClassElementName(n), this.pushClassAccessorProperty(t, c, _);
              } else this.isLineTerminator() ? v ? this.pushClassPrivateProperty(t, o) : this.pushClassProperty(t, n) : this.unexpected();
            }
            parseClassElementName(t) {
              let { type: e, value: s } = this.state;
              if ((e === 128 || e === 129) && t.static && s === "prototype" && this.raise(u.StaticPrototype, { at: this.state.startLoc }), e === 134) {
                s === "constructor" && this.raise(u.ConstructorClassPrivateField, { at: this.state.startLoc });
                let r = this.parsePrivateName();
                return t.key = r, r;
              }
              return this.parsePropertyName(t);
            }
            parseClassStaticBlock(t, e) {
              var s;
              this.scope.enter(Se | Yt | ot);
              let r = this.state.labels;
              this.state.labels = [], this.prodParam.enter(je);
              let i = e.body = [];
              this.parseBlockOrModuleBlockBody(i, void 0, false, 8), this.prodParam.exit(), this.scope.exit(), this.state.labels = r, t.body.push(this.finishNode(e, "StaticBlock")), (s = e.decorators) != null && s.length && this.raise(u.DecoratorStaticBlock, { at: e });
            }
            pushClassProperty(t, e) {
              !e.computed && (e.key.name === "constructor" || e.key.value === "constructor") && this.raise(u.ConstructorClassField, { at: e.key }), t.body.push(this.parseClassProperty(e));
            }
            pushClassPrivateProperty(t, e) {
              let s = this.parseClassPrivateProperty(e);
              t.body.push(s), this.classScope.declarePrivateName(this.getPrivateNameSV(s.key), is, s.key.loc.start);
            }
            pushClassAccessorProperty(t, e, s) {
              if (!s && !e.computed) {
                let i = e.key;
                (i.name === "constructor" || i.value === "constructor") && this.raise(u.ConstructorClassField, { at: i });
              }
              let r = this.parseClassAccessorProperty(e);
              t.body.push(r), s && this.classScope.declarePrivateName(this.getPrivateNameSV(r.key), is, r.key.loc.start);
            }
            pushClassMethod(t, e, s, r, i, a) {
              t.body.push(this.parseMethod(e, s, r, i, a, "ClassMethod", true));
            }
            pushClassPrivateMethod(t, e, s, r) {
              let i = this.parseMethod(e, s, r, false, false, "ClassPrivateMethod", true);
              t.body.push(i);
              let a = i.kind === "get" ? i.static ? Qo : eh : i.kind === "set" ? i.static ? Zo : th : is;
              this.declareClassPrivateMethodInScope(i, a);
            }
            declareClassPrivateMethodInScope(t, e) {
              this.classScope.declarePrivateName(this.getPrivateNameSV(t.key), e, t.key.loc.start);
            }
            parsePostMemberNameModifiers(t) {
            }
            parseClassPrivateProperty(t) {
              return this.parseInitializer(t), this.semicolon(), this.finishNode(t, "ClassPrivateProperty");
            }
            parseClassProperty(t) {
              return this.parseInitializer(t), this.semicolon(), this.finishNode(t, "ClassProperty");
            }
            parseClassAccessorProperty(t) {
              return this.parseInitializer(t), this.semicolon(), this.finishNode(t, "ClassAccessorProperty");
            }
            parseInitializer(t) {
              this.scope.enter(Se | ot), this.expressionScope.enter(Dr()), this.prodParam.enter(je), t.value = this.eat(29) ? this.parseMaybeAssignAllowIn() : null, this.expressionScope.exit(), this.prodParam.exit(), this.scope.exit();
            }
            parseClassId(t, e, s) {
              let r = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : Pr;
              if (K(this.state.type)) t.id = this.parseIdentifier(), e && this.declareNameFromIdentifier(t.id, r);
              else if (s || !e) t.id = null;
              else throw this.raise(u.MissingClassName, { at: this.state.startLoc });
            }
            parseClassSuper(t) {
              t.superClass = this.eat(81) ? this.parseExprSubscripts() : null;
            }
            parseExport(t) {
              let e = this.maybeParseExportDefaultSpecifier(t), s = !e || this.eat(12), r = s && this.eatExportStar(t), i = r && this.maybeParseExportNamespaceSpecifier(t), a = s && (!i || this.eat(12)), n = e || r;
              if (r && !i) return e && this.unexpected(), this.parseExportFrom(t, true), this.finishNode(t, "ExportAllDeclaration");
              let o = this.maybeParseExportNamedSpecifiers(t);
              if (e && s && !r && !o || i && a && !o) throw this.unexpected(null, 5);
              let c;
              if (n || o ? (c = false, this.parseExportFrom(t, n)) : c = this.maybeParseExportDeclaration(t), n || o || c) return this.checkExport(t, true, false, !!t.source), this.finishNode(t, "ExportNamedDeclaration");
              if (this.eat(65)) return t.declaration = this.parseExportDefaultExpression(), this.checkExport(t, true, true), this.finishNode(t, "ExportDefaultDeclaration");
              throw this.unexpected(null, 5);
            }
            eatExportStar(t) {
              return this.eat(55);
            }
            maybeParseExportDefaultSpecifier(t) {
              if (this.isExportDefaultSpecifier()) {
                this.expectPlugin("exportDefaultFrom");
                let e = this.startNode();
                return e.exported = this.parseIdentifier(true), t.specifiers = [this.finishNode(e, "ExportDefaultSpecifier")], true;
              }
              return false;
            }
            maybeParseExportNamespaceSpecifier(t) {
              if (this.isContextual(93)) {
                t.specifiers || (t.specifiers = []);
                let e = this.startNodeAt(this.state.lastTokStart, this.state.lastTokStartLoc);
                return this.next(), e.exported = this.parseModuleExportName(), t.specifiers.push(this.finishNode(e, "ExportNamespaceSpecifier")), true;
              }
              return false;
            }
            maybeParseExportNamedSpecifiers(t) {
              if (this.match(5)) {
                t.specifiers || (t.specifiers = []);
                let e = t.exportKind === "type";
                return t.specifiers.push(...this.parseExportSpecifiers(e)), t.source = null, t.declaration = null, this.hasPlugin("importAssertions") && (t.assertions = []), true;
              }
              return false;
            }
            maybeParseExportDeclaration(t) {
              return this.shouldParseExportDeclaration() ? (t.specifiers = [], t.source = null, this.hasPlugin("importAssertions") && (t.assertions = []), t.declaration = this.parseExportDeclaration(t), true) : false;
            }
            isAsyncFunction() {
              if (!this.isContextual(95)) return false;
              let t = this.nextTokenStart();
              return !as.test(this.input.slice(this.state.pos, t)) && this.isUnparsedContextual(t, "function");
            }
            parseExportDefaultExpression() {
              let t = this.startNode(), e = this.isAsyncFunction();
              if (this.match(68) || e) return this.next(), e && this.next(), this.parseFunction(t, fs | Wr, e);
              if (this.match(80)) return this.parseClass(t, true, true);
              if (this.match(26)) return this.hasPlugin("decorators") && this.getPluginOption("decorators", "decoratorsBeforeExport") && this.raise(u.DecoratorBeforeExport, { at: this.state.startLoc }), this.parseDecorators(false), this.parseClass(t, true, true);
              if (this.match(75) || this.match(74) || this.isLet()) throw this.raise(u.UnsupportedDefaultExport, { at: this.state.startLoc });
              let s = this.parseMaybeAssignAllowIn();
              return this.semicolon(), s;
            }
            parseExportDeclaration(t) {
              return this.parseStatement(null);
            }
            isExportDefaultSpecifier() {
              let { type: t } = this.state;
              if (K(t)) {
                if (t === 95 && !this.state.containsEsc || t === 99) return false;
                if ((t === 126 || t === 125) && !this.state.containsEsc) {
                  let { type: r } = this.lookahead();
                  if (K(r) && r !== 97 || r === 5) return this.expectOnePlugin(["flow", "typescript"]), false;
                }
              } else if (!this.match(65)) return false;
              let e = this.nextTokenStart(), s = this.isUnparsedContextual(e, "from");
              if (this.input.charCodeAt(e) === 44 || K(this.state.type) && s) return true;
              if (this.match(65) && s) {
                let r = this.input.charCodeAt(this.nextTokenStartSince(e + 4));
                return r === 34 || r === 39;
              }
              return false;
            }
            parseExportFrom(t, e) {
              if (this.eatContextual(97)) {
                t.source = this.parseImportSource(), this.checkExport(t);
                let s = this.maybeParseImportAssertions();
                s && (t.assertions = s);
              } else e && this.unexpected();
              this.semicolon();
            }
            shouldParseExportDeclaration() {
              let { type: t } = this.state;
              if (t === 26 && (this.expectOnePlugin(["decorators", "decorators-legacy"]), this.hasPlugin("decorators"))) {
                if (this.getPluginOption("decorators", "decoratorsBeforeExport")) throw this.raise(u.DecoratorBeforeExport, { at: this.state.startLoc });
                return true;
              }
              return t === 74 || t === 75 || t === 68 || t === 80 || this.isLet() || this.isAsyncFunction();
            }
            checkExport(t, e, s, r) {
              if (e) {
                if (s) {
                  if (this.checkDuplicateExports(t, "default"), this.hasPlugin("exportDefaultFrom")) {
                    var i;
                    let n = t.declaration;
                    n.type === "Identifier" && n.name === "from" && n.end - n.start === 4 && !((i = n.extra) != null && i.parenthesized) && this.raise(u.ExportDefaultFromAsIdentifier, { at: n });
                  }
                } else if (t.specifiers && t.specifiers.length) for (let n of t.specifiers) {
                  let { exported: o } = n, c = o.type === "Identifier" ? o.name : o.value;
                  if (this.checkDuplicateExports(n, c), !r && n.local) {
                    let { local: f } = n;
                    f.type !== "Identifier" ? this.raise(u.ExportBindingIsString, { at: n, localName: f.value, exportName: c }) : (this.checkReservedWord(f.name, f.loc.start, true, false), this.scope.checkLocalExport(f));
                  }
                }
                else if (t.declaration) {
                  if (t.declaration.type === "FunctionDeclaration" || t.declaration.type === "ClassDeclaration") {
                    let n = t.declaration.id;
                    if (!n) throw new Error("Assertion failure");
                    this.checkDuplicateExports(t, n.name);
                  } else if (t.declaration.type === "VariableDeclaration") for (let n of t.declaration.declarations) this.checkDeclaration(n.id);
                }
              }
              if (this.state.decoratorStack[this.state.decoratorStack.length - 1].length) throw this.raise(u.UnsupportedDecoratorExport, { at: t });
            }
            checkDeclaration(t) {
              if (t.type === "Identifier") this.checkDuplicateExports(t, t.name);
              else if (t.type === "ObjectPattern") for (let e of t.properties) this.checkDeclaration(e);
              else if (t.type === "ArrayPattern") for (let e of t.elements) e && this.checkDeclaration(e);
              else t.type === "ObjectProperty" ? this.checkDeclaration(t.value) : t.type === "RestElement" ? this.checkDeclaration(t.argument) : t.type === "AssignmentPattern" && this.checkDeclaration(t.left);
            }
            checkDuplicateExports(t, e) {
              this.exportedIdentifiers.has(e) && (e === "default" ? this.raise(u.DuplicateDefaultExport, { at: t }) : this.raise(u.DuplicateExport, { at: t, exportName: e })), this.exportedIdentifiers.add(e);
            }
            parseExportSpecifiers(t) {
              let e = [], s = true;
              for (this.expect(5); !this.eat(8); ) {
                if (s) s = false;
                else if (this.expect(12), this.eat(8)) break;
                let r = this.isContextual(126), i = this.match(129), a = this.startNode();
                a.local = this.parseModuleExportName(), e.push(this.parseExportSpecifier(a, i, t, r));
              }
              return e;
            }
            parseExportSpecifier(t, e, s, r) {
              return this.eatContextual(93) ? t.exported = this.parseModuleExportName() : e ? t.exported = bh(t.local) : t.exported || (t.exported = ge(t.local)), this.finishNode(t, "ExportSpecifier");
            }
            parseModuleExportName() {
              if (this.match(129)) {
                let t = this.parseStringLiteral(this.state.value), e = t.value.match(Zh);
                return e && this.raise(u.ModuleExportNameHasLoneSurrogate, { at: t, surrogateCharCode: e[0].charCodeAt(0) }), t;
              }
              return this.parseIdentifier(true);
            }
            parseImport(t) {
              if (t.specifiers = [], !this.match(129)) {
                let r = !this.maybeParseDefaultImportSpecifier(t) || this.eat(12), i = r && this.maybeParseStarImportSpecifier(t);
                r && !i && this.parseNamedImportSpecifiers(t), this.expectContextual(97);
              }
              t.source = this.parseImportSource();
              let e = this.maybeParseImportAssertions();
              if (e) t.assertions = e;
              else {
                let s = this.maybeParseModuleAttributes();
                s && (t.attributes = s);
              }
              return this.semicolon(), this.finishNode(t, "ImportDeclaration");
            }
            parseImportSource() {
              return this.match(129) || this.unexpected(), this.parseExprAtom();
            }
            shouldParseDefaultImport(t) {
              return K(this.state.type);
            }
            parseImportSpecifierLocal(t, e, s) {
              e.local = this.parseIdentifier(), t.specifiers.push(this.finishImportSpecifier(e, s));
            }
            finishImportSpecifier(t, e) {
              return this.checkLVal(t.local, { in: t, binding: xe }), this.finishNode(t, e);
            }
            parseAssertEntries() {
              let t = [], e = /* @__PURE__ */ new Set();
              do {
                if (this.match(8)) break;
                let s = this.startNode(), r = this.state.value;
                if (e.has(r) && this.raise(u.ModuleAttributesWithDuplicateKeys, { at: this.state.startLoc, key: r }), e.add(r), this.match(129) ? s.key = this.parseStringLiteral(r) : s.key = this.parseIdentifier(true), this.expect(14), !this.match(129)) throw this.raise(u.ModuleAttributeInvalidValue, { at: this.state.startLoc });
                s.value = this.parseStringLiteral(this.state.value), this.finishNode(s, "ImportAttribute"), t.push(s);
              } while (this.eat(12));
              return t;
            }
            maybeParseModuleAttributes() {
              if (this.match(76) && !this.hasPrecedingLineBreak()) this.expectPlugin("moduleAttributes"), this.next();
              else return this.hasPlugin("moduleAttributes") ? [] : null;
              let t = [], e = /* @__PURE__ */ new Set();
              do {
                let s = this.startNode();
                if (s.key = this.parseIdentifier(true), s.key.name !== "type" && this.raise(u.ModuleAttributeDifferentFromType, { at: s.key }), e.has(s.key.name) && this.raise(u.ModuleAttributesWithDuplicateKeys, { at: s.key, key: s.key.name }), e.add(s.key.name), this.expect(14), !this.match(129)) throw this.raise(u.ModuleAttributeInvalidValue, { at: this.state.startLoc });
                s.value = this.parseStringLiteral(this.state.value), this.finishNode(s, "ImportAttribute"), t.push(s);
              } while (this.eat(12));
              return t;
            }
            maybeParseImportAssertions() {
              if (this.isContextual(94) && !this.hasPrecedingLineBreak()) this.expectPlugin("importAssertions"), this.next();
              else return this.hasPlugin("importAssertions") ? [] : null;
              this.eat(5);
              let t = this.parseAssertEntries();
              return this.eat(8), t;
            }
            maybeParseDefaultImportSpecifier(t) {
              return this.shouldParseDefaultImport(t) ? (this.parseImportSpecifierLocal(t, this.startNode(), "ImportDefaultSpecifier"), true) : false;
            }
            maybeParseStarImportSpecifier(t) {
              if (this.match(55)) {
                let e = this.startNode();
                return this.next(), this.expectContextual(93), this.parseImportSpecifierLocal(t, e, "ImportNamespaceSpecifier"), true;
              }
              return false;
            }
            parseNamedImportSpecifiers(t) {
              let e = true;
              for (this.expect(5); !this.eat(8); ) {
                if (e) e = false;
                else {
                  if (this.eat(14)) throw this.raise(u.DestructureNamedImport, { at: this.state.startLoc });
                  if (this.expect(12), this.eat(8)) break;
                }
                let s = this.startNode(), r = this.match(129), i = this.isContextual(126);
                s.imported = this.parseModuleExportName();
                let a = this.parseImportSpecifier(s, r, t.importKind === "type" || t.importKind === "typeof", i);
                t.specifiers.push(a);
              }
            }
            parseImportSpecifier(t, e, s, r) {
              if (this.eatContextual(93)) t.local = this.parseIdentifier();
              else {
                let { imported: i } = t;
                if (e) throw this.raise(u.ImportBindingIsString, { at: t, importName: i.value });
                this.checkReservedWord(i.name, t.loc.start, true, true), t.local || (t.local = ge(i));
              }
              return this.finishImportSpecifier(t, "ImportSpecifier");
            }
            isThisParam(t) {
              return t.type === "Identifier" && t.name === "this";
            }
          }, Gr = class extends tl {
            constructor(t, e) {
              t = Gh(t), super(t, e), this.options = t, this.initializeScopes(), this.plugins = sl(this.options.plugins), this.filename = t.sourceFilename;
            }
            getScopeHandler() {
              return hs;
            }
            parse() {
              this.enterInitialScopes();
              let t = this.startNode(), e = this.startNode();
              return this.nextToken(), t.errors = null, this.parseTopLevel(t, e), t.errors = this.state.errors, t;
            }
          };
          function sl(t) {
            let e = /* @__PURE__ */ new Map();
            for (let s of t) {
              let [r, i] = Array.isArray(s) ? s : [s, {}];
              e.has(r) || e.set(r, i || {});
            }
            return e;
          }
          function rl(t, e) {
            var s;
            if (((s = e) == null ? void 0 : s.sourceType) === "unambiguous") {
              e = Object.assign({}, e);
              try {
                e.sourceType = "module";
                let r = Ye(e, t), i = r.parse();
                if (r.sawUnambiguousESM) return i;
                if (r.ambiguousScriptDifferentAst) try {
                  return e.sourceType = "script", Ye(e, t).parse();
                } catch {
                }
                else i.program.sourceType = "script";
                return i;
              } catch (r) {
                try {
                  return e.sourceType = "script", Ye(e, t).parse();
                } catch {
                }
                throw r;
              }
            } else return Ye(e, t).parse();
          }
          function il(t, e) {
            let s = Ye(e, t);
            return s.options.strictMode && (s.state.strict = true), s.getExpression();
          }
          function al(t) {
            let e = {};
            for (let s of Object.keys(t)) e[s] = fe(t[s]);
            return e;
          }
          var nl = al(bo);
          function Ye(t, e) {
            let s = Gr;
            return t != null && t.plugins && (Hh(t.plugins), s = ol(t.plugins)), new s(t, e);
          }
          var Xr = {};
          function ol(t) {
            let e = Wh.filter((i) => ee(t, i)), s = e.join("/"), r = Xr[s];
            if (!r) {
              r = Gr;
              for (let i of e) r = zr[i](r);
              Xr[s] = r;
            }
            return r;
          }
          h.parse = rl, h.parseExpression = il, h.tokTypes = nl;
        } }), Pf = H({ "src/language-js/parse/json.js"(h, l) {
          "use strict";
          V();
          var p = fo(), d = nr(), m = yo(), A = xo();
          function g() {
            let E = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, { allowComments: L = true } = E;
            return function(F) {
              let { parseExpression: W } = Po(), Y;
              try {
                Y = W(F, { tokens: true, ranges: true });
              } catch (M) {
                throw A(M);
              }
              if (!L && p(Y.comments)) throw x(Y.comments[0], "Comment");
              return T(Y), Y;
            };
          }
          function x(E, L) {
            let [R, F] = [E.loc.start, E.loc.end].map((W) => {
              let { line: Y, column: M } = W;
              return { line: Y, column: M + 1 };
            });
            return d("".concat(L, " is not allowed in JSON."), { start: R, end: F });
          }
          function T(E) {
            switch (E.type) {
              case "ArrayExpression":
                for (let L of E.elements) L !== null && T(L);
                return;
              case "ObjectExpression":
                for (let L of E.properties) T(L);
                return;
              case "ObjectProperty":
                if (E.computed) throw x(E.key, "Computed key");
                if (E.shorthand) throw x(E.key, "Shorthand property");
                E.key.type !== "Identifier" && T(E.key), T(E.value);
                return;
              case "UnaryExpression": {
                let { operator: L, argument: R } = E;
                if (L !== "+" && L !== "-") throw x(E, "Operator '".concat(E.operator, "'"));
                if (R.type === "NumericLiteral" || R.type === "Identifier" && (R.name === "Infinity" || R.name === "NaN")) return;
                throw x(R, "Operator '".concat(L, "' before '").concat(R.type, "'"));
              }
              case "Identifier":
                if (E.name !== "Infinity" && E.name !== "NaN" && E.name !== "undefined") throw x(E, "Identifier '".concat(E.name, "'"));
                return;
              case "TemplateLiteral":
                if (p(E.expressions)) throw x(E.expressions[0], "'TemplateLiteral' with expression");
                for (let L of E.quasis) T(L);
                return;
              case "NullLiteral":
              case "BooleanLiteral":
              case "NumericLiteral":
              case "StringLiteral":
              case "TemplateElement":
                return;
              default:
                throw x(E, "'".concat(E.type, "'"));
            }
          }
          var k = g(), D = { json: m({ parse: k, hasPragma() {
            return true;
          } }), json5: m(k), "json-stringify": m({ parse: g({ allowComments: false }), astFormat: "estree-json" }) };
          l.exports = D;
        } });
        V();
        var Tf = ef(), Ef = Qn(), Cf = af(), ze = yo(), bf = xo(), vf = Af(), Sf = Pf(), wf = { sourceType: "module", allowImportExportEverywhere: true, allowReturnOutsideFunction: true, allowSuperOutsideMethod: true, allowUndeclaredExports: true, errorRecovery: true, createParenthesizedExpressions: true, plugins: ["doExpressions", "exportDefaultFrom", "functionBind", "functionSent", "throwExpressions", "partialApplication", ["decorators", { decoratorsBeforeExport: false }], "importAssertions", "decimal", "moduleBlocks", "asyncDoExpressions", "regexpUnicodeSets", "destructuringPrivate", "decoratorAutoAccessors"], tokens: true, ranges: true }, Nf = ["recordAndTuple", { syntaxType: "hash" }], Wn = "v8intrinsic", Gn = [["pipelineOperator", { proposal: "hack", topicToken: "%" }], ["pipelineOperator", { proposal: "minimal" }], ["pipelineOperator", { proposal: "fsharp" }]], ue = function(h) {
          let l = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : wf;
          return Object.assign(Object.assign({}, l), {}, { plugins: [...l.plugins, ...h] });
        }, If = /@(?:no)?flow\b/;
        function kf(h, l) {
          if (l.filepath && l.filepath.endsWith(".js.flow")) return true;
          let p = Ef(h);
          p && (h = h.slice(p.length));
          let d = Cf(h, 0);
          return d !== false && (h = h.slice(0, d)), If.test(h);
        }
        function Df(h, l, p) {
          let m = Po()[h](l, p), A = m.errors.find((g) => !Rf.has(g.reasonCode));
          if (A) throw A;
          return m;
        }
        function Ke(h) {
          for (var l = arguments.length, p = new Array(l > 1 ? l - 1 : 0), d = 1; d < l; d++) p[d - 1] = arguments[d];
          return function(m, A) {
            let g = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
            if ((g.parser === "babel" || g.parser === "__babel_estree") && kf(m, g)) return g.parser = "babel-flow", To(m, A, g);
            let x = p;
            g.__babelSourceType === "script" && (x = x.map((E) => Object.assign(Object.assign({}, E), {}, { sourceType: "script" }))), /#[[{]/.test(m) && (x = x.map((E) => ue([Nf], E)));
            let T = /%[A-Z]/.test(m);
            m.includes("|>") ? x = (T ? [...Gn, Wn] : Gn).flatMap((L) => x.map((R) => ue([L], R))) : T && (x = x.map((E) => ue([Wn], E)));
            let { result: k, error: D } = Tf(...x.map((E) => () => Df(h, m, E)));
            if (!k) throw bf(D);
            return g.originalText = m, vf(k, g);
          };
        }
        var Ff = Ke("parse", ue(["jsx", "flow"])), To = Ke("parse", ue(["jsx", ["flow", { all: true, enums: true }]])), Lf = Ke("parse", ue(["jsx", "typescript"]), ue(["typescript"])), Of = Ke("parse", ue(["jsx", "flow", "estree"])), Bf = Ke("parseExpression", ue(["jsx"])), Mf = Ke("parseExpression", ue(["typescript"])), Rf = /* @__PURE__ */ new Set(["StrictNumericEscape", "StrictWith", "StrictOctalLiteral", "StrictDelete", "StrictEvalArguments", "StrictEvalArgumentsBinding", "StrictFunction", "EmptyTypeArguments", "EmptyTypeParameters", "ConstructorHasTypeParameters", "UnsupportedParameterPropertyKind", "UnexpectedParameterModifier", "MixedLabeledAndUnlabeledElements", "InvalidTupleMemberLabel", "NonClassMethodPropertyHasAbstractModifer", "ReadonlyForMethodSignature", "ClassMethodHasDeclare", "ClassMethodHasReadonly", "InvalidModifierOnTypeMember", "DuplicateAccessibilityModifier", "IndexSignatureHasDeclare", "DecoratorExportClass", "ParamDupe", "InvalidDecimal", "RestTrailingComma", "UnsupportedParameterDecorator", "UnterminatedJsxContent", "UnexpectedReservedWord", "ModuleAttributesWithDuplicateKeys", "LineTerminatorBeforeArrow", "InvalidEscapeSequenceTemplate", "NonAbstractClassHasAbstractMethod", "UnsupportedPropertyDecorator", "OptionalTypeBeforeRequired", "PatternIsOptional", "OptionalBindingPattern", "DeclareClassFieldHasInitializer", "TypeImportCannotSpecifyDefaultAndNamed", "DeclareFunctionHasImplementation", "ConstructorClassField", "VarRedeclaration", "InvalidPrivateFieldResolution", "DuplicateExport"]), Xn = ze(Ff), Jn = ze(Lf), Yn = ze(Bf), jf = ze(Mf);
        Eo.exports = { parsers: Object.assign(Object.assign({ babel: Xn, "babel-flow": ze(To), "babel-ts": Jn }, Sf), {}, { __js_expression: Yn, __vue_expression: Yn, __vue_ts_expression: jf, __vue_event_binding: Xn, __vue_ts_event_binding: Jn, __babel_estree: ze(Of) }) };
      });
      return qf();
    });
  }
});

// ../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-flow.js
var require_parser_flow = __commonJS({
  "../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-flow.js"(exports2, module2) {
    "use strict";
    (function(e) {
      if (typeof exports2 == "object" && typeof module2 == "object") module2.exports = e();
      else if (typeof define == "function" && define.amd) define(e);
      else {
        var i = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i.prettierPlugins = i.prettierPlugins || {}, i.prettierPlugins.flow = e();
      }
    })(function() {
      "use strict";
      var Be = (H0, z0) => () => (z0 || H0((z0 = { exports: {} }).exports, z0), z0.exports);
      var ru = Be((_oe, rn0) => {
        var h_ = function(H0) {
          return H0 && H0.Math == Math && H0;
        };
        rn0.exports = h_(typeof globalThis == "object" && globalThis) || h_(typeof window == "object" && window) || h_(typeof self == "object" && self) || h_(typeof global == "object" && global) || /* @__PURE__ */ function() {
          return this;
        }() || Function("return this")();
      });
      var Qs = Be((yoe, en0) => {
        en0.exports = function(H0) {
          try {
            return !!H0();
          } catch {
            return true;
          }
        };
      });
      var fv = Be((hoe, nn0) => {
        var N7e = Qs();
        nn0.exports = !N7e(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      });
      var jR = Be((doe, tn0) => {
        var C7e = Qs();
        tn0.exports = !C7e(function() {
          var H0 = function() {
          }.bind();
          return typeof H0 != "function" || H0.hasOwnProperty("prototype");
        });
      });
      var k_ = Be((koe, un0) => {
        var P7e = jR(), d_ = Function.prototype.call;
        un0.exports = P7e ? d_.bind(d_) : function() {
          return d_.apply(d_, arguments);
        };
      });
      var on0 = Be((xn0) => {
        "use strict";
        var in0 = {}.propertyIsEnumerable, fn0 = Object.getOwnPropertyDescriptor, D7e = fn0 && !in0.call({ 1: 2 }, 1);
        xn0.f = D7e ? function(z0) {
          var xr = fn0(this, z0);
          return !!xr && xr.enumerable;
        } : in0;
      });
      var GR = Be((Eoe, an0) => {
        an0.exports = function(H0, z0) {
          return { enumerable: !(H0 & 1), configurable: !(H0 & 2), writable: !(H0 & 4), value: z0 };
        };
      });
      var zc = Be((Soe, vn0) => {
        var cn0 = jR(), sn0 = Function.prototype, L7e = sn0.bind, MR = sn0.call, R7e = cn0 && L7e.bind(MR, MR);
        vn0.exports = cn0 ? function(H0) {
          return H0 && R7e(H0);
        } : function(H0) {
          return H0 && function() {
            return MR.apply(H0, arguments);
          };
        };
      });
      var pn0 = Be((goe, bn0) => {
        var ln0 = zc(), j7e = ln0({}.toString), G7e = ln0("".slice);
        bn0.exports = function(H0) {
          return G7e(j7e(H0), 8, -1);
        };
      });
      var _n0 = Be((Foe, mn0) => {
        var M7e = ru(), B7e = zc(), q7e = Qs(), U7e = pn0(), BR = M7e.Object, H7e = B7e("".split);
        mn0.exports = q7e(function() {
          return !BR("z").propertyIsEnumerable(0);
        }) ? function(H0) {
          return U7e(H0) == "String" ? H7e(H0, "") : BR(H0);
        } : BR;
      });
      var qR = Be((Toe, yn0) => {
        var X7e = ru(), Y7e = X7e.TypeError;
        yn0.exports = function(H0) {
          if (H0 == null) throw Y7e("Can't call method on " + H0);
          return H0;
        };
      });
      var w_ = Be((Ooe, hn0) => {
        var V7e = _n0(), z7e = qR();
        hn0.exports = function(H0) {
          return V7e(z7e(H0));
        };
      });
      var Kc = Be((Ioe, dn0) => {
        dn0.exports = function(H0) {
          return typeof H0 == "function";
        };
      });
      var S2 = Be((Aoe, kn0) => {
        var K7e = Kc();
        kn0.exports = function(H0) {
          return typeof H0 == "object" ? H0 !== null : K7e(H0);
        };
      });
      var E_ = Be((Noe, wn0) => {
        var UR = ru(), W7e = Kc(), J7e = function(H0) {
          return W7e(H0) ? H0 : void 0;
        };
        wn0.exports = function(H0, z0) {
          return arguments.length < 2 ? J7e(UR[H0]) : UR[H0] && UR[H0][z0];
        };
      });
      var Sn0 = Be((Coe, En0) => {
        var $7e = zc();
        En0.exports = $7e({}.isPrototypeOf);
      });
      var Fn0 = Be((Poe, gn0) => {
        var Z7e = E_();
        gn0.exports = Z7e("navigator", "userAgent") || "";
      });
      var Pn0 = Be((Doe, Cn0) => {
        var Nn0 = ru(), HR = Fn0(), Tn0 = Nn0.process, On0 = Nn0.Deno, In0 = Tn0 && Tn0.versions || On0 && On0.version, An0 = In0 && In0.v8, $i, S_;
        An0 && ($i = An0.split("."), S_ = $i[0] > 0 && $i[0] < 4 ? 1 : +($i[0] + $i[1]));
        !S_ && HR && ($i = HR.match(/Edge\/(\d+)/), (!$i || $i[1] >= 74) && ($i = HR.match(/Chrome\/(\d+)/), $i && (S_ = +$i[1])));
        Cn0.exports = S_;
      });
      var XR = Be((Loe, Ln0) => {
        var Dn0 = Pn0(), Q7e = Qs();
        Ln0.exports = !!Object.getOwnPropertySymbols && !Q7e(function() {
          var H0 = Symbol();
          return !String(H0) || !(Object(H0) instanceof Symbol) || !Symbol.sham && Dn0 && Dn0 < 41;
        });
      });
      var YR = Be((Roe, Rn0) => {
        var rie = XR();
        Rn0.exports = rie && !Symbol.sham && typeof Symbol.iterator == "symbol";
      });
      var VR = Be((joe, jn0) => {
        var eie = ru(), nie = E_(), tie = Kc(), uie = Sn0(), iie = YR(), fie = eie.Object;
        jn0.exports = iie ? function(H0) {
          return typeof H0 == "symbol";
        } : function(H0) {
          var z0 = nie("Symbol");
          return tie(z0) && uie(z0.prototype, fie(H0));
        };
      });
      var Mn0 = Be((Goe, Gn0) => {
        var xie = ru(), oie = xie.String;
        Gn0.exports = function(H0) {
          try {
            return oie(H0);
          } catch {
            return "Object";
          }
        };
      });
      var qn0 = Be((Moe, Bn0) => {
        var aie = ru(), cie = Kc(), sie = Mn0(), vie = aie.TypeError;
        Bn0.exports = function(H0) {
          if (cie(H0)) return H0;
          throw vie(sie(H0) + " is not a function");
        };
      });
      var Hn0 = Be((Boe, Un0) => {
        var lie = qn0();
        Un0.exports = function(H0, z0) {
          var xr = H0[z0];
          return xr == null ? void 0 : lie(xr);
        };
      });
      var Yn0 = Be((qoe, Xn0) => {
        var bie = ru(), zR = k_(), KR = Kc(), WR = S2(), pie = bie.TypeError;
        Xn0.exports = function(H0, z0) {
          var xr, gr;
          if (z0 === "string" && KR(xr = H0.toString) && !WR(gr = zR(xr, H0)) || KR(xr = H0.valueOf) && !WR(gr = zR(xr, H0)) || z0 !== "string" && KR(xr = H0.toString) && !WR(gr = zR(xr, H0))) return gr;
          throw pie("Can't convert object to primitive value");
        };
      });
      var zn0 = Be((Uoe, Vn0) => {
        Vn0.exports = false;
      });
      var g_ = Be((Hoe, Wn0) => {
        var Kn0 = ru(), mie = Object.defineProperty;
        Wn0.exports = function(H0, z0) {
          try {
            mie(Kn0, H0, { value: z0, configurable: true, writable: true });
          } catch {
            Kn0[H0] = z0;
          }
          return z0;
        };
      });
      var F_ = Be((Xoe, $n0) => {
        var _ie = ru(), yie = g_(), Jn0 = "__core-js_shared__", hie = _ie[Jn0] || yie(Jn0, {});
        $n0.exports = hie;
      });
      var JR = Be((Yoe, Qn0) => {
        var die = zn0(), Zn0 = F_();
        (Qn0.exports = function(H0, z0) {
          return Zn0[H0] || (Zn0[H0] = z0 !== void 0 ? z0 : {});
        })("versions", []).push({ version: "3.22.2", mode: die ? "pure" : "global", copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)", license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE", source: "https://github.com/zloirock/core-js" });
      });
      var et0 = Be((Voe, rt0) => {
        var kie = ru(), wie = qR(), Eie = kie.Object;
        rt0.exports = function(H0) {
          return Eie(wie(H0));
        };
      });
      var r1 = Be((zoe, nt0) => {
        var Sie = zc(), gie = et0(), Fie = Sie({}.hasOwnProperty);
        nt0.exports = Object.hasOwn || function(z0, xr) {
          return Fie(gie(z0), xr);
        };
      });
      var $R = Be((Koe, tt0) => {
        var Tie = zc(), Oie = 0, Iie = Math.random(), Aie = Tie(1 .toString);
        tt0.exports = function(H0) {
          return "Symbol(" + (H0 === void 0 ? "" : H0) + ")_" + Aie(++Oie + Iie, 36);
        };
      });
      var at0 = Be((Woe, ot0) => {
        var Nie = ru(), Cie = JR(), ut0 = r1(), Pie = $R(), it0 = XR(), xt0 = YR(), g2 = Cie("wks"), xv = Nie.Symbol, ft0 = xv && xv.for, Die = xt0 ? xv : xv && xv.withoutSetter || Pie;
        ot0.exports = function(H0) {
          if (!ut0(g2, H0) || !(it0 || typeof g2[H0] == "string")) {
            var z0 = "Symbol." + H0;
            it0 && ut0(xv, H0) ? g2[H0] = xv[H0] : xt0 && ft0 ? g2[H0] = ft0(z0) : g2[H0] = Die(z0);
          }
          return g2[H0];
        };
      });
      var lt0 = Be((Joe, vt0) => {
        var Lie = ru(), Rie = k_(), ct0 = S2(), st0 = VR(), jie = Hn0(), Gie = Yn0(), Mie = at0(), Bie = Lie.TypeError, qie = Mie("toPrimitive");
        vt0.exports = function(H0, z0) {
          if (!ct0(H0) || st0(H0)) return H0;
          var xr = jie(H0, qie), gr;
          if (xr) {
            if (z0 === void 0 && (z0 = "default"), gr = Rie(xr, H0, z0), !ct0(gr) || st0(gr)) return gr;
            throw Bie("Can't convert object to primitive value");
          }
          return z0 === void 0 && (z0 = "number"), Gie(H0, z0);
        };
      });
      var ZR = Be(($oe, bt0) => {
        var Uie = lt0(), Hie = VR();
        bt0.exports = function(H0) {
          var z0 = Uie(H0, "string");
          return Hie(z0) ? z0 : z0 + "";
        };
      });
      var _t0 = Be((Zoe, mt0) => {
        var Xie = ru(), pt0 = S2(), QR = Xie.document, Yie = pt0(QR) && pt0(QR.createElement);
        mt0.exports = function(H0) {
          return Yie ? QR.createElement(H0) : {};
        };
      });
      var rj = Be((Qoe, yt0) => {
        var Vie = fv(), zie = Qs(), Kie = _t0();
        yt0.exports = !Vie && !zie(function() {
          return Object.defineProperty(Kie("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      });
      var ej = Be((dt0) => {
        var Wie = fv(), Jie = k_(), $ie = on0(), Zie = GR(), Qie = w_(), rfe = ZR(), efe = r1(), nfe = rj(), ht0 = Object.getOwnPropertyDescriptor;
        dt0.f = Wie ? ht0 : function(z0, xr) {
          if (z0 = Qie(z0), xr = rfe(xr), nfe) try {
            return ht0(z0, xr);
          } catch {
          }
          if (efe(z0, xr)) return Zie(!Jie($ie.f, z0, xr), z0[xr]);
        };
      });
      var wt0 = Be((eae, kt0) => {
        var tfe = fv(), ufe = Qs();
        kt0.exports = tfe && ufe(function() {
          return Object.defineProperty(function() {
          }, "prototype", { value: 42, writable: false }).prototype != 42;
        });
      });
      var nj = Be((nae, St0) => {
        var Et0 = ru(), ife = S2(), ffe = Et0.String, xfe = Et0.TypeError;
        St0.exports = function(H0) {
          if (ife(H0)) return H0;
          throw xfe(ffe(H0) + " is not an object");
        };
      });
      var xj = Be((Ft0) => {
        var ofe = ru(), afe = fv(), cfe = rj(), sfe = wt0(), T_ = nj(), gt0 = ZR(), vfe = ofe.TypeError, tj = Object.defineProperty, lfe = Object.getOwnPropertyDescriptor, uj = "enumerable", ij = "configurable", fj = "writable";
        Ft0.f = afe ? sfe ? function(z0, xr, gr) {
          if (T_(z0), xr = gt0(xr), T_(gr), typeof z0 == "function" && xr === "prototype" && "value" in gr && fj in gr && !gr[fj]) {
            var de = lfe(z0, xr);
            de && de[fj] && (z0[xr] = gr.value, gr = { configurable: ij in gr ? gr[ij] : de[ij], enumerable: uj in gr ? gr[uj] : de[uj], writable: false });
          }
          return tj(z0, xr, gr);
        } : tj : function(z0, xr, gr) {
          if (T_(z0), xr = gt0(xr), T_(gr), cfe) try {
            return tj(z0, xr, gr);
          } catch {
          }
          if ("get" in gr || "set" in gr) throw vfe("Accessors not supported");
          return "value" in gr && (z0[xr] = gr.value), z0;
        };
      });
      var O_ = Be((uae, Tt0) => {
        var bfe = fv(), pfe = xj(), mfe = GR();
        Tt0.exports = bfe ? function(H0, z0, xr) {
          return pfe.f(H0, z0, mfe(1, xr));
        } : function(H0, z0, xr) {
          return H0[z0] = xr, H0;
        };
      });
      var aj = Be((iae, Ot0) => {
        var _fe = zc(), yfe = Kc(), oj = F_(), hfe = _fe(Function.toString);
        yfe(oj.inspectSource) || (oj.inspectSource = function(H0) {
          return hfe(H0);
        });
        Ot0.exports = oj.inspectSource;
      });
      var Nt0 = Be((fae, At0) => {
        var dfe = ru(), kfe = Kc(), wfe = aj(), It0 = dfe.WeakMap;
        At0.exports = kfe(It0) && /native code/.test(wfe(It0));
      });
      var Dt0 = Be((xae, Pt0) => {
        var Efe = JR(), Sfe = $R(), Ct0 = Efe("keys");
        Pt0.exports = function(H0) {
          return Ct0[H0] || (Ct0[H0] = Sfe(H0));
        };
      });
      var cj = Be((oae, Lt0) => {
        Lt0.exports = {};
      });
      var qt0 = Be((aae, Bt0) => {
        var gfe = Nt0(), Mt0 = ru(), sj = zc(), Ffe = S2(), Tfe = O_(), vj = r1(), lj = F_(), Ofe = Dt0(), Ife = cj(), Rt0 = "Object already initialized", pj = Mt0.TypeError, Afe = Mt0.WeakMap, I_, a4, A_, Nfe = function(H0) {
          return A_(H0) ? a4(H0) : I_(H0, {});
        }, Cfe = function(H0) {
          return function(z0) {
            var xr;
            if (!Ffe(z0) || (xr = a4(z0)).type !== H0) throw pj("Incompatible receiver, " + H0 + " required");
            return xr;
          };
        };
        gfe || lj.state ? (e1 = lj.state || (lj.state = new Afe()), jt0 = sj(e1.get), bj = sj(e1.has), Gt0 = sj(e1.set), I_ = function(H0, z0) {
          if (bj(e1, H0)) throw new pj(Rt0);
          return z0.facade = H0, Gt0(e1, H0, z0), z0;
        }, a4 = function(H0) {
          return jt0(e1, H0) || {};
        }, A_ = function(H0) {
          return bj(e1, H0);
        }) : (ov = Ofe("state"), Ife[ov] = true, I_ = function(H0, z0) {
          if (vj(H0, ov)) throw new pj(Rt0);
          return z0.facade = H0, Tfe(H0, ov, z0), z0;
        }, a4 = function(H0) {
          return vj(H0, ov) ? H0[ov] : {};
        }, A_ = function(H0) {
          return vj(H0, ov);
        });
        var e1, jt0, bj, Gt0, ov;
        Bt0.exports = { set: I_, get: a4, has: A_, enforce: Nfe, getterFor: Cfe };
      });
      var Xt0 = Be((cae, Ht0) => {
        var mj = fv(), Pfe = r1(), Ut0 = Function.prototype, Dfe = mj && Object.getOwnPropertyDescriptor, _j = Pfe(Ut0, "name"), Lfe = _j && function() {
        }.name === "something", Rfe = _j && (!mj || mj && Dfe(Ut0, "name").configurable);
        Ht0.exports = { EXISTS: _j, PROPER: Lfe, CONFIGURABLE: Rfe };
      });
      var Wt0 = Be((sae, Kt0) => {
        var jfe = ru(), Yt0 = Kc(), Gfe = r1(), Vt0 = O_(), Mfe = g_(), Bfe = aj(), zt0 = qt0(), qfe = Xt0().CONFIGURABLE, Ufe = zt0.get, Hfe = zt0.enforce, Xfe = String(String).split("String");
        (Kt0.exports = function(H0, z0, xr, gr) {
          var de = gr ? !!gr.unsafe : false, Ve = gr ? !!gr.enumerable : false, De = gr ? !!gr.noTargetGet : false, Ke = gr && gr.name !== void 0 ? gr.name : z0, tn;
          if (Yt0(xr) && (String(Ke).slice(0, 7) === "Symbol(" && (Ke = "[" + String(Ke).replace(/^Symbol\(([^)]*)\)/, "$1") + "]"), (!Gfe(xr, "name") || qfe && xr.name !== Ke) && Vt0(xr, "name", Ke), tn = Hfe(xr), tn.source || (tn.source = Xfe.join(typeof Ke == "string" ? Ke : ""))), H0 === jfe) {
            Ve ? H0[z0] = xr : Mfe(z0, xr);
            return;
          } else de ? !De && H0[z0] && (Ve = true) : delete H0[z0];
          Ve ? H0[z0] = xr : Vt0(H0, z0, xr);
        })(Function.prototype, "toString", function() {
          return Yt0(this) && Ufe(this).source || Bfe(this);
        });
      });
      var yj = Be((vae, Jt0) => {
        var Yfe = Math.ceil, Vfe = Math.floor;
        Jt0.exports = function(H0) {
          var z0 = +H0;
          return z0 !== z0 || z0 === 0 ? 0 : (z0 > 0 ? Vfe : Yfe)(z0);
        };
      });
      var Zt0 = Be((lae, $t0) => {
        var zfe = yj(), Kfe = Math.max, Wfe = Math.min;
        $t0.exports = function(H0, z0) {
          var xr = zfe(H0);
          return xr < 0 ? Kfe(xr + z0, 0) : Wfe(xr, z0);
        };
      });
      var ru0 = Be((bae, Qt0) => {
        var Jfe = yj(), $fe = Math.min;
        Qt0.exports = function(H0) {
          return H0 > 0 ? $fe(Jfe(H0), 9007199254740991) : 0;
        };
      });
      var nu0 = Be((pae, eu0) => {
        var Zfe = ru0();
        eu0.exports = function(H0) {
          return Zfe(H0.length);
        };
      });
      var iu0 = Be((mae, uu0) => {
        var Qfe = w_(), rxe = Zt0(), exe = nu0(), tu0 = function(H0) {
          return function(z0, xr, gr) {
            var de = Qfe(z0), Ve = exe(de), De = rxe(gr, Ve), Ke;
            if (H0 && xr != xr) {
              for (; Ve > De; ) if (Ke = de[De++], Ke != Ke) return true;
            } else for (; Ve > De; De++) if ((H0 || De in de) && de[De] === xr) return H0 || De || 0;
            return !H0 && -1;
          };
        };
        uu0.exports = { includes: tu0(true), indexOf: tu0(false) };
      });
      var ou0 = Be((_ae, xu0) => {
        var nxe = zc(), hj = r1(), txe = w_(), uxe = iu0().indexOf, ixe = cj(), fu0 = nxe([].push);
        xu0.exports = function(H0, z0) {
          var xr = txe(H0), gr = 0, de = [], Ve;
          for (Ve in xr) !hj(ixe, Ve) && hj(xr, Ve) && fu0(de, Ve);
          for (; z0.length > gr; ) hj(xr, Ve = z0[gr++]) && (~uxe(de, Ve) || fu0(de, Ve));
          return de;
        };
      });
      var cu0 = Be((yae, au0) => {
        au0.exports = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
      });
      var vu0 = Be((su0) => {
        var fxe = ou0(), xxe = cu0(), oxe = xxe.concat("length", "prototype");
        su0.f = Object.getOwnPropertyNames || function(z0) {
          return fxe(z0, oxe);
        };
      });
      var bu0 = Be((lu0) => {
        lu0.f = Object.getOwnPropertySymbols;
      });
      var mu0 = Be((kae, pu0) => {
        var axe = E_(), cxe = zc(), sxe = vu0(), vxe = bu0(), lxe = nj(), bxe = cxe([].concat);
        pu0.exports = axe("Reflect", "ownKeys") || function(z0) {
          var xr = sxe.f(lxe(z0)), gr = vxe.f;
          return gr ? bxe(xr, gr(z0)) : xr;
        };
      });
      var hu0 = Be((wae, yu0) => {
        var _u0 = r1(), pxe = mu0(), mxe = ej(), _xe = xj();
        yu0.exports = function(H0, z0, xr) {
          for (var gr = pxe(z0), de = _xe.f, Ve = mxe.f, De = 0; De < gr.length; De++) {
            var Ke = gr[De];
            !_u0(H0, Ke) && !(xr && _u0(xr, Ke)) && de(H0, Ke, Ve(z0, Ke));
          }
        };
      });
      var ku0 = Be((Eae, du0) => {
        var yxe = Qs(), hxe = Kc(), dxe = /#|\.prototype\./, c4 = function(H0, z0) {
          var xr = wxe[kxe(H0)];
          return xr == Sxe ? true : xr == Exe ? false : hxe(z0) ? yxe(z0) : !!z0;
        }, kxe = c4.normalize = function(H0) {
          return String(H0).replace(dxe, ".").toLowerCase();
        }, wxe = c4.data = {}, Exe = c4.NATIVE = "N", Sxe = c4.POLYFILL = "P";
        du0.exports = c4;
      });
      var Eu0 = Be((Sae, wu0) => {
        var dj = ru(), gxe = ej().f, Fxe = O_(), Txe = Wt0(), Oxe = g_(), Ixe = hu0(), Axe = ku0();
        wu0.exports = function(H0, z0) {
          var xr = H0.target, gr = H0.global, de = H0.stat, Ve, De, Ke, tn, Qn, rt;
          if (gr ? De = dj : de ? De = dj[xr] || Oxe(xr, {}) : De = (dj[xr] || {}).prototype, De) for (Ke in z0) {
            if (Qn = z0[Ke], H0.noTargetGet ? (rt = gxe(De, Ke), tn = rt && rt.value) : tn = De[Ke], Ve = Axe(gr ? Ke : xr + (de ? "." : "#") + Ke, H0.forced), !Ve && tn !== void 0) {
              if (typeof Qn == typeof tn) continue;
              Ixe(Qn, tn);
            }
            (H0.sham || tn && tn.sham) && Fxe(Qn, "sham", true), Txe(De, Ke, Qn, H0);
          }
        };
      });
      var Su0 = Be(() => {
        var Nxe = Eu0(), Cxe = ru();
        Nxe({ global: true }, { globalThis: Cxe });
      });
      var gu0 = Be(() => {
        Su0();
      });
      var soe = Be((Iae, zu0) => {
        gu0();
        var Zq = Object.defineProperty, Pxe = Object.getOwnPropertyDescriptor, Qq = Object.getOwnPropertyNames, Dxe = Object.prototype.hasOwnProperty, C_ = (H0, z0) => function() {
          return H0 && (z0 = (0, H0[Qq(H0)[0]])(H0 = 0)), z0;
        }, eu = (H0, z0) => function() {
          return z0 || (0, H0[Qq(H0)[0]])((z0 = { exports: {} }).exports, z0), z0.exports;
        }, rU = (H0, z0) => {
          for (var xr in z0) Zq(H0, xr, { get: z0[xr], enumerable: true });
        }, Lxe = (H0, z0, xr, gr) => {
          if (z0 && typeof z0 == "object" || typeof z0 == "function") for (let de of Qq(z0)) !Dxe.call(H0, de) && de !== xr && Zq(H0, de, { get: () => z0[de], enumerable: !(gr = Pxe(z0, de)) || gr.enumerable });
          return H0;
        }, eU = (H0) => Lxe(Zq({}, "__esModule", { value: true }), H0), Pt = C_({ "<define:process>"() {
        } }), Fu0 = eu({ "src/common/parser-create-error.js"(H0, z0) {
          "use strict";
          Pt();
          function xr(gr, de) {
            let Ve = new SyntaxError(gr + " (" + de.start.line + ":" + de.start.column + ")");
            return Ve.loc = de, Ve;
          }
          z0.exports = xr;
        } }), Tu0 = {};
        rU(Tu0, { EOL: () => Sj, arch: () => Rxe, cpus: () => Du0, default: () => Mu0, endianness: () => Ou0, freemem: () => Cu0, getNetworkInterfaces: () => Gu0, hostname: () => Iu0, loadavg: () => Au0, networkInterfaces: () => ju0, platform: () => jxe, release: () => Ru0, tmpDir: () => wj, tmpdir: () => Ej, totalmem: () => Pu0, type: () => Lu0, uptime: () => Nu0 });
        function Ou0() {
          if (typeof N_ > "u") {
            var H0 = new ArrayBuffer(2), z0 = new Uint8Array(H0), xr = new Uint16Array(H0);
            if (z0[0] = 1, z0[1] = 2, xr[0] === 258) N_ = "BE";
            else if (xr[0] === 513) N_ = "LE";
            else throw new Error("unable to figure out endianess");
          }
          return N_;
        }
        function Iu0() {
          return typeof globalThis.location < "u" ? globalThis.location.hostname : "";
        }
        function Au0() {
          return [];
        }
        function Nu0() {
          return 0;
        }
        function Cu0() {
          return Number.MAX_VALUE;
        }
        function Pu0() {
          return Number.MAX_VALUE;
        }
        function Du0() {
          return [];
        }
        function Lu0() {
          return "Browser";
        }
        function Ru0() {
          return typeof globalThis.navigator < "u" ? globalThis.navigator.appVersion : "";
        }
        function ju0() {
        }
        function Gu0() {
        }
        function Rxe() {
          return "javascript";
        }
        function jxe() {
          return "browser";
        }
        function wj() {
          return "/tmp";
        }
        var N_, Ej, Sj, Mu0, Gxe = C_({ "node-modules-polyfills:os"() {
          Pt(), Ej = wj, Sj = `
`, Mu0 = { EOL: Sj, tmpdir: Ej, tmpDir: wj, networkInterfaces: ju0, getNetworkInterfaces: Gu0, release: Ru0, type: Lu0, cpus: Du0, totalmem: Pu0, freemem: Cu0, uptime: Nu0, loadavg: Au0, hostname: Iu0, endianness: Ou0 };
        } }), Mxe = eu({ "node-modules-polyfills-commonjs:os"(H0, z0) {
          Pt();
          var xr = (Gxe(), eU(Tu0));
          if (xr && xr.default) {
            z0.exports = xr.default;
            for (let gr in xr) z0.exports[gr] = xr[gr];
          } else xr && (z0.exports = xr);
        } }), Bxe = eu({ "node_modules/detect-newline/index.js"(H0, z0) {
          "use strict";
          Pt();
          var xr = (gr) => {
            if (typeof gr != "string") throw new TypeError("Expected a string");
            let de = gr.match(/(?:\r?\n)/g) || [];
            if (de.length === 0) return;
            let Ve = de.filter((Ke) => Ke === `\r
`).length, De = de.length - Ve;
            return Ve > De ? `\r
` : `
`;
          };
          z0.exports = xr, z0.exports.graceful = (gr) => typeof gr == "string" && xr(gr) || `
`;
        } }), qxe = eu({ "node_modules/jest-docblock/build/index.js"(H0) {
          "use strict";
          Pt(), Object.defineProperty(H0, "__esModule", { value: true }), H0.extract = au, H0.parse = Kt, H0.parseWithComments = Zi, H0.print = Ln, H0.strip = En;
          function z0() {
            let fn = Mxe();
            return z0 = function() {
              return fn;
            }, fn;
          }
          function xr() {
            let fn = gr(Bxe());
            return xr = function() {
              return fn;
            }, fn;
          }
          function gr(fn) {
            return fn && fn.__esModule ? fn : { default: fn };
          }
          var de = /\*\/$/, Ve = /^\/\*\*/, De = /^\s*(\/\*\*?(.|\r?\n)*?\*\/)/, Ke = /(^|\s+)\/\/([^\r\n]*)/g, tn = /^(\r?\n)+/, Qn = /(?:^|\r?\n) *(@[^\r\n]*?) *\r?\n *(?![^@\r\n]*\/\/[^]*)([^@\r\n\s][^@\r\n]+?) *\r?\n/g, rt = /(?:^|\r?\n) *@(\S+) *([^\r\n]*)/g, tt = /(\r?\n|^) *\* ?/g, Ot = [];
          function au(fn) {
            let Ht = fn.match(De);
            return Ht ? Ht[0].trimLeft() : "";
          }
          function En(fn) {
            let Ht = fn.match(De);
            return Ht && Ht[0] ? fn.substring(Ht[0].length) : fn;
          }
          function Kt(fn) {
            return Zi(fn).pragmas;
          }
          function Zi(fn) {
            let Ht = (0, xr().default)(fn) || z0().EOL;
            fn = fn.replace(Ve, "").replace(de, "").replace(tt, "$1");
            let S7 = "";
            for (; S7 !== fn; ) S7 = fn, fn = fn.replace(Qn, "".concat(Ht, "$1 $2").concat(Ht));
            fn = fn.replace(tn, "").trimRight();
            let Dt = /* @__PURE__ */ Object.create(null), ks = fn.replace(rt, "").replace(tn, "").trimRight(), In;
            for (; In = rt.exec(fn); ) {
              let Wc = In[2].replace(Ke, "");
              typeof Dt[In[1]] == "string" || Array.isArray(Dt[In[1]]) ? Dt[In[1]] = Ot.concat(Dt[In[1]], Wc) : Dt[In[1]] = Wc;
            }
            return { comments: ks, pragmas: Dt };
          }
          function Ln(fn) {
            let { comments: Ht = "", pragmas: S7 = {} } = fn, Dt = (0, xr().default)(Ht) || z0().EOL, ks = "/**", In = " *", Wc = " */", Ai = Object.keys(S7), li = Ai.map((g7) => Tn(g7, S7[g7])).reduce((g7, av) => g7.concat(av), []).map((g7) => In + " " + g7 + Dt).join("");
            if (!Ht) {
              if (Ai.length === 0) return "";
              if (Ai.length === 1 && !Array.isArray(S7[Ai[0]])) {
                let g7 = S7[Ai[0]];
                return "".concat(ks, " ").concat(Tn(Ai[0], g7)[0]).concat(Wc);
              }
            }
            let jt = Ht.split(Dt).map((g7) => "".concat(In, " ").concat(g7)).join(Dt) + Dt;
            return ks + Dt + (Ht ? jt : "") + (Ht && Ai.length ? In + Dt : "") + li + Wc;
          }
          function Tn(fn, Ht) {
            return Ot.concat(Ht).map((S7) => "@".concat(fn, " ").concat(S7).trim());
          }
        } }), Uxe = eu({ "src/common/end-of-line.js"(H0, z0) {
          "use strict";
          Pt();
          function xr(De) {
            let Ke = De.indexOf("\r");
            return Ke >= 0 ? De.charAt(Ke + 1) === `
` ? "crlf" : "cr" : "lf";
          }
          function gr(De) {
            switch (De) {
              case "cr":
                return "\r";
              case "crlf":
                return `\r
`;
              default:
                return `
`;
            }
          }
          function de(De, Ke) {
            let tn;
            switch (Ke) {
              case `
`:
                tn = /\n/g;
                break;
              case "\r":
                tn = /\r/g;
                break;
              case `\r
`:
                tn = /\r\n/g;
                break;
              default:
                throw new Error('Unexpected "eol" '.concat(JSON.stringify(Ke), "."));
            }
            let Qn = De.match(tn);
            return Qn ? Qn.length : 0;
          }
          function Ve(De) {
            return De.replace(/\r\n?/g, `
`);
          }
          z0.exports = { guessEndOfLine: xr, convertEndOfLineToChars: gr, countEndOfLineChars: de, normalizeEndOfLine: Ve };
        } }), Hxe = eu({ "src/language-js/utils/get-shebang.js"(H0, z0) {
          "use strict";
          Pt();
          function xr(gr) {
            if (!gr.startsWith("#!")) return "";
            let de = gr.indexOf(`
`);
            return de === -1 ? gr : gr.slice(0, de);
          }
          z0.exports = xr;
        } }), Xxe = eu({ "src/language-js/pragma.js"(H0, z0) {
          "use strict";
          Pt();
          var { parseWithComments: xr, strip: gr, extract: de, print: Ve } = qxe(), { normalizeEndOfLine: De } = Uxe(), Ke = Hxe();
          function tn(tt) {
            let Ot = Ke(tt);
            Ot && (tt = tt.slice(Ot.length + 1));
            let au = de(tt), { pragmas: En, comments: Kt } = xr(au);
            return { shebang: Ot, text: tt, pragmas: En, comments: Kt };
          }
          function Qn(tt) {
            let Ot = Object.keys(tn(tt).pragmas);
            return Ot.includes("prettier") || Ot.includes("format");
          }
          function rt(tt) {
            let { shebang: Ot, text: au, pragmas: En, comments: Kt } = tn(tt), Zi = gr(au), Ln = Ve({ pragmas: Object.assign({ format: "" }, En), comments: Kt.trimStart() });
            return (Ot ? "".concat(Ot, `
`) : "") + De(Ln) + (Zi.startsWith(`
`) ? `
` : `

`) + Zi;
          }
          z0.exports = { hasPragma: Qn, insertPragma: rt };
        } }), Yxe = eu({ "src/utils/is-non-empty-array.js"(H0, z0) {
          "use strict";
          Pt();
          function xr(gr) {
            return Array.isArray(gr) && gr.length > 0;
          }
          z0.exports = xr;
        } }), Bu0 = eu({ "src/language-js/loc.js"(H0, z0) {
          "use strict";
          Pt();
          var xr = Yxe();
          function gr(tn, Qn) {
            let { ignoreDecorators: rt } = Qn || {};
            if (!rt) {
              let tt = tn.declaration && tn.declaration.decorators || tn.decorators;
              if (xr(tt)) return gr(tt[0]);
            }
            return tn.range ? tn.range[0] : tn.start;
          }
          function de(tn) {
            return tn.range ? tn.range[1] : tn.end;
          }
          function Ve(tn, Qn) {
            let rt = gr(tn);
            return Number.isInteger(rt) && rt === gr(Qn);
          }
          function De(tn, Qn) {
            let rt = de(tn);
            return Number.isInteger(rt) && rt === de(Qn);
          }
          function Ke(tn, Qn) {
            return Ve(tn, Qn) && De(tn, Qn);
          }
          z0.exports = { locStart: gr, locEnd: de, hasSameLocStart: Ve, hasSameLoc: Ke };
        } }), Vxe = eu({ "src/language-js/parse/utils/create-parser.js"(H0, z0) {
          "use strict";
          Pt();
          var { hasPragma: xr } = Xxe(), { locStart: gr, locEnd: de } = Bu0();
          function Ve(De) {
            return De = typeof De == "function" ? { parse: De } : De, Object.assign({ astFormat: "estree", hasPragma: xr, locStart: gr, locEnd: de }, De);
          }
          z0.exports = Ve;
        } }), zxe = eu({ "src/language-js/parse/utils/replace-hashbang.js"(H0, z0) {
          "use strict";
          Pt();
          function xr(gr) {
            return gr.charAt(0) === "#" && gr.charAt(1) === "!" ? "//" + gr.slice(2) : gr;
          }
          z0.exports = xr;
        } }), Kxe = eu({ "src/language-js/utils/is-ts-keyword-type.js"(H0, z0) {
          "use strict";
          Pt();
          function xr(gr) {
            let { type: de } = gr;
            return de.startsWith("TS") && de.endsWith("Keyword");
          }
          z0.exports = xr;
        } }), Wxe = eu({ "src/language-js/utils/is-block-comment.js"(H0, z0) {
          "use strict";
          Pt();
          var xr = /* @__PURE__ */ new Set(["Block", "CommentBlock", "MultiLine"]), gr = (de) => xr.has(de == null ? void 0 : de.type);
          z0.exports = gr;
        } }), Jxe = eu({ "src/language-js/utils/is-type-cast-comment.js"(H0, z0) {
          "use strict";
          Pt();
          var xr = Wxe();
          function gr(de) {
            return xr(de) && de.value[0] === "*" && /@type\b/.test(de.value);
          }
          z0.exports = gr;
        } }), $xe = eu({ "src/utils/get-last.js"(H0, z0) {
          "use strict";
          Pt();
          var xr = (gr) => gr[gr.length - 1];
          z0.exports = xr;
        } }), qu0 = eu({ "src/language-js/parse/postprocess/visit-node.js"(H0, z0) {
          "use strict";
          Pt();
          function xr(gr, de) {
            if (Array.isArray(gr)) {
              for (let Ve = 0; Ve < gr.length; Ve++) gr[Ve] = xr(gr[Ve], de);
              return gr;
            }
            if (gr && typeof gr == "object" && typeof gr.type == "string") {
              let Ve = Object.keys(gr);
              for (let De = 0; De < Ve.length; De++) gr[Ve[De]] = xr(gr[Ve[De]], de);
              return de(gr) || gr;
            }
            return gr;
          }
          z0.exports = xr;
        } }), Uu0 = eu({ "src/language-js/parse/postprocess/throw-syntax-error.js"(H0, z0) {
          "use strict";
          Pt();
          var xr = Fu0();
          function gr(de, Ve) {
            let { start: De, end: Ke } = de.loc;
            throw xr(Ve, { start: { line: De.line, column: De.column + 1 }, end: { line: Ke.line, column: Ke.column + 1 } });
          }
          z0.exports = gr;
        } }), Zxe = eu({ "src/language-js/parse/postprocess/typescript.js"(H0, z0) {
          "use strict";
          Pt();
          var xr = qu0(), gr = Uu0();
          function de(Ke, tn, Qn) {
            let rt = Ke.decorators;
            if (!Array.isArray(rt)) return;
            let tt = tn.decorators;
            (!Array.isArray(tt) || tt.length !== rt.length || rt.some((Ot) => {
              let au = Qn.get(Ot);
              return !au || !tt.includes(au);
            })) && gr(tn, "Leading decorators must be attached to a class declaration");
          }
          function Ve(Ke, tn) {
            Ke.kind !== 167 || Ke.modifiers && !Ke.modifiers.some((tt) => tt.kind === 126) || Ke.initializer && tn.value === null && gr(tn, "Abstract property cannot have an initializer");
          }
          function De(Ke, tn) {
            let { esTreeNodeToTSNodeMap: Qn, tsNodeToESTreeNodeMap: rt } = tn.tsParseResult;
            xr(Ke, (tt) => {
              let Ot = Qn.get(tt);
              if (!Ot) return;
              let au = rt.get(Ot);
              au === tt && (de(Ot, au, rt), Ve(Ot, au));
            });
          }
          z0.exports = { throwErrorForInvalidNodes: De };
        } }), Qxe = eu({ "src/language-js/parse/postprocess/index.js"(H0, z0) {
          "use strict";
          Pt();
          var { locStart: xr, locEnd: gr } = Bu0(), de = Kxe(), Ve = Jxe(), De = $xe(), Ke = qu0(), { throwErrorForInvalidNodes: tn } = Zxe(), Qn = Uu0();
          function rt(En, Kt) {
            if (Kt.parser === "typescript" && /@|abstract/.test(Kt.originalText) && tn(En, Kt), Kt.parser !== "typescript" && Kt.parser !== "flow" && Kt.parser !== "acorn" && Kt.parser !== "espree" && Kt.parser !== "meriyah") {
              let Ln = /* @__PURE__ */ new Set();
              En = Ke(En, (Tn) => {
                Tn.leadingComments && Tn.leadingComments.some(Ve) && Ln.add(xr(Tn));
              }), En = Ke(En, (Tn) => {
                if (Tn.type === "ParenthesizedExpression") {
                  let { expression: fn } = Tn;
                  if (fn.type === "TypeCastExpression") return fn.range = Tn.range, fn;
                  let Ht = xr(Tn);
                  if (!Ln.has(Ht)) return fn.extra = Object.assign(Object.assign({}, fn.extra), {}, { parenthesized: true }), fn;
                }
              });
            }
            return En = Ke(En, (Ln) => {
              switch (Ln.type) {
                case "ChainExpression":
                  return tt(Ln.expression);
                case "LogicalExpression": {
                  if (Ot(Ln)) return au(Ln);
                  break;
                }
                case "VariableDeclaration": {
                  let Tn = De(Ln.declarations);
                  Tn && Tn.init && Zi(Ln, Tn);
                  break;
                }
                case "TSParenthesizedType":
                  return de(Ln.typeAnnotation) || Ln.typeAnnotation.type === "TSThisType" || (Ln.typeAnnotation.range = [xr(Ln), gr(Ln)]), Ln.typeAnnotation;
                case "TSTypeParameter":
                  if (typeof Ln.name == "string") {
                    let Tn = xr(Ln);
                    Ln.name = { type: "Identifier", name: Ln.name, range: [Tn, Tn + Ln.name.length] };
                  }
                  break;
                case "ObjectExpression":
                  if (Kt.parser === "typescript") {
                    let Tn = Ln.properties.find((fn) => fn.type === "Property" && fn.value.type === "TSEmptyBodyFunctionExpression");
                    Tn && Qn(Tn.value, "Unexpected token.");
                  }
                  break;
                case "SequenceExpression": {
                  let Tn = De(Ln.expressions);
                  Ln.range = [xr(Ln), Math.min(gr(Tn), gr(Ln))];
                  break;
                }
                case "TopicReference":
                  Kt.__isUsingHackPipeline = true;
                  break;
                case "ExportAllDeclaration": {
                  let { exported: Tn } = Ln;
                  if (Kt.parser === "meriyah" && Tn && Tn.type === "Identifier") {
                    let fn = Kt.originalText.slice(xr(Tn), gr(Tn));
                    (fn.startsWith('"') || fn.startsWith("'")) && (Ln.exported = Object.assign(Object.assign({}, Ln.exported), {}, { type: "Literal", value: Ln.exported.name, raw: fn }));
                  }
                  break;
                }
              }
            }), En;
            function Zi(Ln, Tn) {
              Kt.originalText[gr(Tn)] !== ";" && (Ln.range = [xr(Ln), gr(Tn)]);
            }
          }
          function tt(En) {
            switch (En.type) {
              case "CallExpression":
                En.type = "OptionalCallExpression", En.callee = tt(En.callee);
                break;
              case "MemberExpression":
                En.type = "OptionalMemberExpression", En.object = tt(En.object);
                break;
              case "TSNonNullExpression":
                En.expression = tt(En.expression);
                break;
            }
            return En;
          }
          function Ot(En) {
            return En.type === "LogicalExpression" && En.right.type === "LogicalExpression" && En.operator === En.right.operator;
          }
          function au(En) {
            return Ot(En) ? au({ type: "LogicalExpression", operator: En.operator, left: au({ type: "LogicalExpression", operator: En.operator, left: En.left, right: En.right.left, range: [xr(En.left), gr(En.right.left)] }), right: En.right.right, range: [xr(En), gr(En)] }) : En;
          }
          z0.exports = rt;
        } }), Hu0 = {};
        rU(Hu0, { default: () => Xu0 });
        var Xu0, roe = C_({ "node-modules-polyfills:fs"() {
          Pt(), Xu0 = {};
        } }), kj = eu({ "node-modules-polyfills-commonjs:fs"(H0, z0) {
          Pt();
          var xr = (roe(), eU(Hu0));
          if (xr && xr.default) {
            z0.exports = xr.default;
            for (let gr in xr) z0.exports[gr] = xr[gr];
          } else xr && (z0.exports = xr);
        } }), Yu0 = {};
        rU(Yu0, { ALPN_ENABLED: () => Pq, COPYFILE_EXCL: () => CB, COPYFILE_FICLONE: () => DB, COPYFILE_FICLONE_FORCE: () => RB, DH_CHECK_P_NOT_PRIME: () => Aq, DH_CHECK_P_NOT_SAFE_PRIME: () => Iq, DH_NOT_SUITABLE_GENERATOR: () => Cq, DH_UNABLE_TO_CHECK_GENERATOR: () => Nq, E2BIG: () => Ij, EACCES: () => Aj, EADDRINUSE: () => Nj, EADDRNOTAVAIL: () => Cj, EAFNOSUPPORT: () => Pj, EAGAIN: () => Dj, EALREADY: () => Lj, EBADF: () => Rj, EBADMSG: () => jj, EBUSY: () => Gj, ECANCELED: () => Mj, ECHILD: () => Bj, ECONNABORTED: () => qj, ECONNREFUSED: () => Uj, ECONNRESET: () => Hj, EDEADLK: () => Xj, EDESTADDRREQ: () => Yj, EDOM: () => Vj, EDQUOT: () => zj, EEXIST: () => Kj, EFAULT: () => Wj, EFBIG: () => Jj, EHOSTUNREACH: () => $j, EIDRM: () => Zj, EILSEQ: () => Qj, EINPROGRESS: () => rG, EINTR: () => eG, EINVAL: () => nG, EIO: () => tG, EISCONN: () => uG, EISDIR: () => iG, ELOOP: () => fG, EMFILE: () => xG, EMLINK: () => oG, EMSGSIZE: () => aG, EMULTIHOP: () => cG, ENAMETOOLONG: () => sG, ENETDOWN: () => vG, ENETRESET: () => lG, ENETUNREACH: () => bG, ENFILE: () => pG, ENGINE_METHOD_ALL: () => Tq, ENGINE_METHOD_CIPHERS: () => Eq, ENGINE_METHOD_DH: () => dq, ENGINE_METHOD_DIGESTS: () => Sq, ENGINE_METHOD_DSA: () => hq, ENGINE_METHOD_EC: () => wq, ENGINE_METHOD_NONE: () => Oq, ENGINE_METHOD_PKEY_ASN1_METHS: () => Fq, ENGINE_METHOD_PKEY_METHS: () => gq, ENGINE_METHOD_RAND: () => kq, ENGINE_METHOD_RSA: () => yq, ENOBUFS: () => mG, ENODATA: () => _G, ENODEV: () => yG, ENOENT: () => hG, ENOEXEC: () => dG, ENOLCK: () => kG, ENOLINK: () => wG, ENOMEM: () => EG, ENOMSG: () => SG, ENOPROTOOPT: () => gG, ENOSPC: () => FG, ENOSR: () => TG, ENOSTR: () => OG, ENOSYS: () => IG, ENOTCONN: () => AG, ENOTDIR: () => NG, ENOTEMPTY: () => CG, ENOTSOCK: () => PG, ENOTSUP: () => DG, ENOTTY: () => LG, ENXIO: () => RG, EOPNOTSUPP: () => jG, EOVERFLOW: () => GG, EPERM: () => MG, EPIPE: () => BG, EPROTO: () => qG, EPROTONOSUPPORT: () => UG, EPROTOTYPE: () => HG, ERANGE: () => XG, EROFS: () => YG, ESPIPE: () => VG, ESRCH: () => zG, ESTALE: () => KG, ETIME: () => WG, ETIMEDOUT: () => JG, ETXTBSY: () => $G, EWOULDBLOCK: () => ZG, EXDEV: () => QG, F_OK: () => TB, OPENSSL_VERSION_NUMBER: () => jB, O_APPEND: () => oB, O_CREAT: () => uB, O_DIRECTORY: () => aB, O_DSYNC: () => vB, O_EXCL: () => iB, O_NOCTTY: () => fB, O_NOFOLLOW: () => cB, O_NONBLOCK: () => bB, O_RDONLY: () => MM, O_RDWR: () => qM, O_SYMLINK: () => lB, O_SYNC: () => sB, O_TRUNC: () => xB, O_WRONLY: () => BM, POINT_CONVERSION_COMPRESSED: () => Kq, POINT_CONVERSION_HYBRID: () => Jq, POINT_CONVERSION_UNCOMPRESSED: () => Wq, PRIORITY_ABOVE_NORMAL: () => tM, PRIORITY_BELOW_NORMAL: () => eM, PRIORITY_HIGH: () => uM, PRIORITY_HIGHEST: () => iM, PRIORITY_LOW: () => rM, PRIORITY_NORMAL: () => nM, RSA_NO_PADDING: () => Rq, RSA_PKCS1_OAEP_PADDING: () => jq, RSA_PKCS1_PADDING: () => Dq, RSA_PKCS1_PSS_PADDING: () => Mq, RSA_PSS_SALTLEN_AUTO: () => Uq, RSA_PSS_SALTLEN_DIGEST: () => Bq, RSA_PSS_SALTLEN_MAX_SIGN: () => qq, RSA_SSLV23_PADDING: () => Lq, RSA_X931_PADDING: () => Gq, RTLD_GLOBAL: () => Tj, RTLD_LAZY: () => gj, RTLD_LOCAL: () => Oj, RTLD_NOW: () => Fj, R_OK: () => OB, SIGABRT: () => sM, SIGALRM: () => dM, SIGBUS: () => lM, SIGCHLD: () => wM, SIGCONT: () => EM, SIGFPE: () => bM, SIGHUP: () => fM, SIGILL: () => aM, SIGINFO: () => LM, SIGINT: () => xM, SIGIO: () => DM, SIGIOT: () => vM, SIGKILL: () => pM, SIGPIPE: () => hM, SIGPROF: () => CM, SIGQUIT: () => oM, SIGSEGV: () => _M, SIGSTOP: () => SM, SIGSYS: () => RM, SIGTERM: () => kM, SIGTRAP: () => cM, SIGTSTP: () => gM, SIGTTIN: () => FM, SIGTTOU: () => TM, SIGURG: () => OM, SIGUSR1: () => mM, SIGUSR2: () => yM, SIGVTALRM: () => NM, SIGWINCH: () => PM, SIGXCPU: () => IM, SIGXFSZ: () => AM, SSL_OP_ALL: () => GB, SSL_OP_ALLOW_UNSAFE_LEGACY_RENEGOTIATION: () => MB, SSL_OP_CIPHER_SERVER_PREFERENCE: () => BB, SSL_OP_CISCO_ANYCONNECT: () => qB, SSL_OP_COOKIE_EXCHANGE: () => UB, SSL_OP_CRYPTOPRO_TLSEXT_BUG: () => HB, SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS: () => XB, SSL_OP_EPHEMERAL_RSA: () => YB, SSL_OP_LEGACY_SERVER_CONNECT: () => VB, SSL_OP_MICROSOFT_BIG_SSLV3_BUFFER: () => zB, SSL_OP_MICROSOFT_SESS_ID_BUG: () => KB, SSL_OP_MSIE_SSLV2_RSA_PADDING: () => WB, SSL_OP_NETSCAPE_CA_DN_BUG: () => JB, SSL_OP_NETSCAPE_CHALLENGE_BUG: () => $B, SSL_OP_NETSCAPE_DEMO_CIPHER_CHANGE_BUG: () => ZB, SSL_OP_NETSCAPE_REUSE_CIPHER_CHANGE_BUG: () => QB, SSL_OP_NO_COMPRESSION: () => rq, SSL_OP_NO_QUERY_MTU: () => eq2, SSL_OP_NO_SESSION_RESUMPTION_ON_RENEGOTIATION: () => nq, SSL_OP_NO_SSLv2: () => tq, SSL_OP_NO_SSLv3: () => uq, SSL_OP_NO_TICKET: () => iq, SSL_OP_NO_TLSv1: () => fq, SSL_OP_NO_TLSv1_1: () => xq, SSL_OP_NO_TLSv1_2: () => oq, SSL_OP_PKCS1_CHECK_1: () => aq, SSL_OP_PKCS1_CHECK_2: () => cq, SSL_OP_SINGLE_DH_USE: () => sq, SSL_OP_SINGLE_ECDH_USE: () => vq, SSL_OP_SSLEAY_080_CLIENT_DH_BUG: () => lq, SSL_OP_SSLREF2_REUSE_CERT_TYPE_BUG: () => bq, SSL_OP_TLS_BLOCK_PADDING_BUG: () => pq, SSL_OP_TLS_D5_BUG: () => mq, SSL_OP_TLS_ROLLBACK_BUG: () => _q, S_IFBLK: () => rB, S_IFCHR: () => QM, S_IFDIR: () => ZM, S_IFIFO: () => eB, S_IFLNK: () => nB, S_IFMT: () => JM, S_IFREG: () => $M, S_IFSOCK: () => tB, S_IRGRP: () => dB, S_IROTH: () => SB, S_IRUSR: () => mB, S_IRWXG: () => hB, S_IRWXO: () => EB, S_IRWXU: () => pB, S_IWGRP: () => kB, S_IWOTH: () => gB, S_IWUSR: () => _B, S_IXGRP: () => wB, S_IXOTH: () => FB, S_IXUSR: () => yB, TLS1_1_VERSION: () => Yq, TLS1_2_VERSION: () => Vq, TLS1_3_VERSION: () => zq, TLS1_VERSION: () => Xq, UV_DIRENT_BLOCK: () => WM, UV_DIRENT_CHAR: () => KM, UV_DIRENT_DIR: () => XM, UV_DIRENT_FIFO: () => VM, UV_DIRENT_FILE: () => HM, UV_DIRENT_LINK: () => YM, UV_DIRENT_SOCKET: () => zM, UV_DIRENT_UNKNOWN: () => UM, UV_FS_COPYFILE_EXCL: () => NB, UV_FS_COPYFILE_FICLONE: () => PB, UV_FS_COPYFILE_FICLONE_FORCE: () => LB, UV_FS_SYMLINK_DIR: () => jM, UV_FS_SYMLINK_JUNCTION: () => GM, W_OK: () => IB, X_OK: () => AB, default: () => Vu0, defaultCipherList: () => $q, defaultCoreCipherList: () => Hq });
        var gj, Fj, Tj, Oj, Ij, Aj, Nj, Cj, Pj, Dj, Lj, Rj, jj, Gj, Mj, Bj, qj, Uj, Hj, Xj, Yj, Vj, zj, Kj, Wj, Jj, $j, Zj, Qj, rG, eG, nG, tG, uG, iG, fG, xG, oG, aG, cG, sG, vG, lG, bG, pG, mG, _G, yG, hG, dG, kG, wG, EG, SG, gG, FG, TG, OG, IG, AG, NG, CG, PG, DG, LG, RG, jG, GG, MG, BG, qG, UG, HG, XG, YG, VG, zG, KG, WG, JG, $G, ZG, QG, rM, eM, nM, tM, uM, iM, fM, xM, oM, aM, cM, sM, vM, lM, bM, pM, mM, _M, yM, hM, dM, kM, wM, EM, SM, gM, FM, TM, OM, IM, AM, NM, CM, PM, DM, LM, RM, jM, GM, MM, BM, qM, UM, HM, XM, YM, VM, zM, KM, WM, JM, $M, ZM, QM, rB, eB, nB, tB, uB, iB, fB, xB, oB, aB, cB, sB, vB, lB, bB, pB, mB, _B, yB, hB, dB, kB, wB, EB, SB, gB, FB, TB, OB, IB, AB, NB, CB, PB, DB, LB, RB, jB, GB, MB, BB, qB, UB, HB, XB, YB, VB, zB, KB, WB, JB, $B, ZB, QB, rq, eq2, nq, tq, uq, iq, fq, xq, oq, aq, cq, sq, vq, lq, bq, pq, mq, _q, yq, hq, dq, kq, wq, Eq, Sq, gq, Fq, Tq, Oq, Iq, Aq, Nq, Cq, Pq, Dq, Lq, Rq, jq, Gq, Mq, Bq, qq, Uq, Hq, Xq, Yq, Vq, zq, Kq, Wq, Jq, $q, Vu0, eoe = C_({ "node-modules-polyfills:constants"() {
          Pt(), gj = 1, Fj = 2, Tj = 8, Oj = 4, Ij = 7, Aj = 13, Nj = 48, Cj = 49, Pj = 47, Dj = 35, Lj = 37, Rj = 9, jj = 94, Gj = 16, Mj = 89, Bj = 10, qj = 53, Uj = 61, Hj = 54, Xj = 11, Yj = 39, Vj = 33, zj = 69, Kj = 17, Wj = 14, Jj = 27, $j = 65, Zj = 90, Qj = 92, rG = 36, eG = 4, nG = 22, tG = 5, uG = 56, iG = 21, fG = 62, xG = 24, oG = 31, aG = 40, cG = 95, sG = 63, vG = 50, lG = 52, bG = 51, pG = 23, mG = 55, _G = 96, yG = 19, hG = 2, dG = 8, kG = 77, wG = 97, EG = 12, SG = 91, gG = 42, FG = 28, TG = 98, OG = 99, IG = 78, AG = 57, NG = 20, CG = 66, PG = 38, DG = 45, LG = 25, RG = 6, jG = 102, GG = 84, MG = 1, BG = 32, qG = 100, UG = 43, HG = 41, XG = 34, YG = 30, VG = 29, zG = 3, KG = 70, WG = 101, JG = 60, $G = 26, ZG = 35, QG = 18, rM = 19, eM = 10, nM = 0, tM = -7, uM = -14, iM = -20, fM = 1, xM = 2, oM = 3, aM = 4, cM = 5, sM = 6, vM = 6, lM = 10, bM = 8, pM = 9, mM = 30, _M = 11, yM = 31, hM = 13, dM = 14, kM = 15, wM = 20, EM = 19, SM = 17, gM = 18, FM = 21, TM = 22, OM = 16, IM = 24, AM = 25, NM = 26, CM = 27, PM = 28, DM = 23, LM = 29, RM = 12, jM = 1, GM = 2, MM = 0, BM = 1, qM = 2, UM = 0, HM = 1, XM = 2, YM = 3, VM = 4, zM = 5, KM = 6, WM = 7, JM = 61440, $M = 32768, ZM = 16384, QM = 8192, rB = 24576, eB = 4096, nB = 40960, tB = 49152, uB = 512, iB = 2048, fB = 131072, xB = 1024, oB = 8, aB = 1048576, cB = 256, sB = 128, vB = 4194304, lB = 2097152, bB = 4, pB = 448, mB = 256, _B = 128, yB = 64, hB = 56, dB = 32, kB = 16, wB = 8, EB = 7, SB = 4, gB = 2, FB = 1, TB = 0, OB = 4, IB = 2, AB = 1, NB = 1, CB = 1, PB = 2, DB = 2, LB = 4, RB = 4, jB = 269488175, GB = 2147485780, MB = 262144, BB = 4194304, qB = 32768, UB = 8192, HB = 2147483648, XB = 2048, YB = 0, VB = 4, zB = 0, KB = 0, WB = 0, JB = 0, $B = 0, ZB = 0, QB = 0, rq = 131072, eq2 = 4096, nq = 65536, tq = 0, uq = 33554432, iq = 16384, fq = 67108864, xq = 268435456, oq = 134217728, aq = 0, cq = 0, sq = 0, vq = 0, lq = 0, bq = 0, pq = 0, mq = 0, _q = 8388608, yq = 1, hq = 2, dq = 4, kq = 8, wq = 2048, Eq = 64, Sq = 128, gq = 512, Fq = 1024, Tq = 65535, Oq = 0, Iq = 2, Aq = 1, Nq = 4, Cq = 8, Pq = 1, Dq = 1, Lq = 2, Rq = 3, jq = 4, Gq = 5, Mq = 6, Bq = -1, qq = -2, Uq = -2, Hq = "TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256:TLS_AES_128_GCM_SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-AES256-GCM-SHA384:DHE-RSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-SHA256:DHE-RSA-AES128-SHA256:ECDHE-RSA-AES256-SHA384:DHE-RSA-AES256-SHA384:ECDHE-RSA-AES256-SHA256:DHE-RSA-AES256-SHA256:HIGH:!aNULL:!eNULL:!EXPORT:!DES:!RC4:!MD5:!PSK:!SRP:!CAMELLIA", Xq = 769, Yq = 770, Vq = 771, zq = 772, Kq = 2, Wq = 4, Jq = 6, $q = "TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256:TLS_AES_128_GCM_SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-AES256-GCM-SHA384:DHE-RSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-SHA256:DHE-RSA-AES128-SHA256:ECDHE-RSA-AES256-SHA384:DHE-RSA-AES256-SHA384:ECDHE-RSA-AES256-SHA256:DHE-RSA-AES256-SHA256:HIGH:!aNULL:!eNULL:!EXPORT:!DES:!RC4:!MD5:!PSK:!SRP:!CAMELLIA", Vu0 = { RTLD_LAZY: gj, RTLD_NOW: Fj, RTLD_GLOBAL: Tj, RTLD_LOCAL: Oj, E2BIG: Ij, EACCES: Aj, EADDRINUSE: Nj, EADDRNOTAVAIL: Cj, EAFNOSUPPORT: Pj, EAGAIN: Dj, EALREADY: Lj, EBADF: Rj, EBADMSG: jj, EBUSY: Gj, ECANCELED: Mj, ECHILD: Bj, ECONNABORTED: qj, ECONNREFUSED: Uj, ECONNRESET: Hj, EDEADLK: Xj, EDESTADDRREQ: Yj, EDOM: Vj, EDQUOT: zj, EEXIST: Kj, EFAULT: Wj, EFBIG: Jj, EHOSTUNREACH: $j, EIDRM: Zj, EILSEQ: Qj, EINPROGRESS: rG, EINTR: eG, EINVAL: nG, EIO: tG, EISCONN: uG, EISDIR: iG, ELOOP: fG, EMFILE: xG, EMLINK: oG, EMSGSIZE: aG, EMULTIHOP: cG, ENAMETOOLONG: sG, ENETDOWN: vG, ENETRESET: lG, ENETUNREACH: bG, ENFILE: pG, ENOBUFS: mG, ENODATA: _G, ENODEV: yG, ENOENT: hG, ENOEXEC: dG, ENOLCK: kG, ENOLINK: wG, ENOMEM: EG, ENOMSG: SG, ENOPROTOOPT: gG, ENOSPC: FG, ENOSR: TG, ENOSTR: OG, ENOSYS: IG, ENOTCONN: AG, ENOTDIR: NG, ENOTEMPTY: CG, ENOTSOCK: PG, ENOTSUP: DG, ENOTTY: LG, ENXIO: RG, EOPNOTSUPP: jG, EOVERFLOW: GG, EPERM: MG, EPIPE: BG, EPROTO: qG, EPROTONOSUPPORT: UG, EPROTOTYPE: HG, ERANGE: XG, EROFS: YG, ESPIPE: VG, ESRCH: zG, ESTALE: KG, ETIME: WG, ETIMEDOUT: JG, ETXTBSY: $G, EWOULDBLOCK: ZG, EXDEV: QG, PRIORITY_LOW: rM, PRIORITY_BELOW_NORMAL: eM, PRIORITY_NORMAL: nM, PRIORITY_ABOVE_NORMAL: tM, PRIORITY_HIGH: uM, PRIORITY_HIGHEST: iM, SIGHUP: fM, SIGINT: xM, SIGQUIT: oM, SIGILL: aM, SIGTRAP: cM, SIGABRT: sM, SIGIOT: vM, SIGBUS: lM, SIGFPE: bM, SIGKILL: pM, SIGUSR1: mM, SIGSEGV: _M, SIGUSR2: yM, SIGPIPE: hM, SIGALRM: dM, SIGTERM: kM, SIGCHLD: wM, SIGCONT: EM, SIGSTOP: SM, SIGTSTP: gM, SIGTTIN: FM, SIGTTOU: TM, SIGURG: OM, SIGXCPU: IM, SIGXFSZ: AM, SIGVTALRM: NM, SIGPROF: CM, SIGWINCH: PM, SIGIO: DM, SIGINFO: LM, SIGSYS: RM, UV_FS_SYMLINK_DIR: jM, UV_FS_SYMLINK_JUNCTION: GM, O_RDONLY: MM, O_WRONLY: BM, O_RDWR: qM, UV_DIRENT_UNKNOWN: UM, UV_DIRENT_FILE: HM, UV_DIRENT_DIR: XM, UV_DIRENT_LINK: YM, UV_DIRENT_FIFO: VM, UV_DIRENT_SOCKET: zM, UV_DIRENT_CHAR: KM, UV_DIRENT_BLOCK: WM, S_IFMT: JM, S_IFREG: $M, S_IFDIR: ZM, S_IFCHR: QM, S_IFBLK: rB, S_IFIFO: eB, S_IFLNK: nB, S_IFSOCK: tB, O_CREAT: uB, O_EXCL: iB, O_NOCTTY: fB, O_TRUNC: xB, O_APPEND: oB, O_DIRECTORY: aB, O_NOFOLLOW: cB, O_SYNC: sB, O_DSYNC: vB, O_SYMLINK: lB, O_NONBLOCK: bB, S_IRWXU: pB, S_IRUSR: mB, S_IWUSR: _B, S_IXUSR: yB, S_IRWXG: hB, S_IRGRP: dB, S_IWGRP: kB, S_IXGRP: wB, S_IRWXO: EB, S_IROTH: SB, S_IWOTH: gB, S_IXOTH: FB, F_OK: TB, R_OK: OB, W_OK: IB, X_OK: AB, UV_FS_COPYFILE_EXCL: NB, COPYFILE_EXCL: CB, UV_FS_COPYFILE_FICLONE: PB, COPYFILE_FICLONE: DB, UV_FS_COPYFILE_FICLONE_FORCE: LB, COPYFILE_FICLONE_FORCE: RB, OPENSSL_VERSION_NUMBER: jB, SSL_OP_ALL: GB, SSL_OP_ALLOW_UNSAFE_LEGACY_RENEGOTIATION: MB, SSL_OP_CIPHER_SERVER_PREFERENCE: BB, SSL_OP_CISCO_ANYCONNECT: qB, SSL_OP_COOKIE_EXCHANGE: UB, SSL_OP_CRYPTOPRO_TLSEXT_BUG: HB, SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS: XB, SSL_OP_EPHEMERAL_RSA: YB, SSL_OP_LEGACY_SERVER_CONNECT: VB, SSL_OP_MICROSOFT_BIG_SSLV3_BUFFER: zB, SSL_OP_MICROSOFT_SESS_ID_BUG: KB, SSL_OP_MSIE_SSLV2_RSA_PADDING: WB, SSL_OP_NETSCAPE_CA_DN_BUG: JB, SSL_OP_NETSCAPE_CHALLENGE_BUG: $B, SSL_OP_NETSCAPE_DEMO_CIPHER_CHANGE_BUG: ZB, SSL_OP_NETSCAPE_REUSE_CIPHER_CHANGE_BUG: QB, SSL_OP_NO_COMPRESSION: rq, SSL_OP_NO_QUERY_MTU: eq2, SSL_OP_NO_SESSION_RESUMPTION_ON_RENEGOTIATION: nq, SSL_OP_NO_SSLv2: tq, SSL_OP_NO_SSLv3: uq, SSL_OP_NO_TICKET: iq, SSL_OP_NO_TLSv1: fq, SSL_OP_NO_TLSv1_1: xq, SSL_OP_NO_TLSv1_2: oq, SSL_OP_PKCS1_CHECK_1: aq, SSL_OP_PKCS1_CHECK_2: cq, SSL_OP_SINGLE_DH_USE: sq, SSL_OP_SINGLE_ECDH_USE: vq, SSL_OP_SSLEAY_080_CLIENT_DH_BUG: lq, SSL_OP_SSLREF2_REUSE_CERT_TYPE_BUG: bq, SSL_OP_TLS_BLOCK_PADDING_BUG: pq, SSL_OP_TLS_D5_BUG: mq, SSL_OP_TLS_ROLLBACK_BUG: _q, ENGINE_METHOD_RSA: yq, ENGINE_METHOD_DSA: hq, ENGINE_METHOD_DH: dq, ENGINE_METHOD_RAND: kq, ENGINE_METHOD_EC: wq, ENGINE_METHOD_CIPHERS: Eq, ENGINE_METHOD_DIGESTS: Sq, ENGINE_METHOD_PKEY_METHS: gq, ENGINE_METHOD_PKEY_ASN1_METHS: Fq, ENGINE_METHOD_ALL: Tq, ENGINE_METHOD_NONE: Oq, DH_CHECK_P_NOT_SAFE_PRIME: Iq, DH_CHECK_P_NOT_PRIME: Aq, DH_UNABLE_TO_CHECK_GENERATOR: Nq, DH_NOT_SUITABLE_GENERATOR: Cq, ALPN_ENABLED: Pq, RSA_PKCS1_PADDING: Dq, RSA_SSLV23_PADDING: Lq, RSA_NO_PADDING: Rq, RSA_PKCS1_OAEP_PADDING: jq, RSA_X931_PADDING: Gq, RSA_PKCS1_PSS_PADDING: Mq, RSA_PSS_SALTLEN_DIGEST: Bq, RSA_PSS_SALTLEN_MAX_SIGN: qq, RSA_PSS_SALTLEN_AUTO: Uq, defaultCoreCipherList: Hq, TLS1_VERSION: Xq, TLS1_1_VERSION: Yq, TLS1_2_VERSION: Vq, TLS1_3_VERSION: zq, POINT_CONVERSION_COMPRESSED: Kq, POINT_CONVERSION_UNCOMPRESSED: Wq, POINT_CONVERSION_HYBRID: Jq, defaultCipherList: $q };
        } }), noe = eu({ "node-modules-polyfills-commonjs:constants"(H0, z0) {
          Pt();
          var xr = (eoe(), eU(Yu0));
          if (xr && xr.default) {
            z0.exports = xr.default;
            for (let gr in xr) z0.exports[gr] = xr[gr];
          } else xr && (z0.exports = xr);
        } }), toe = eu({ "node_modules/flow-parser/flow_parser.js"(H0) {
          Pt(), function(z0) {
            "use strict";
            var xr = "member_property_expression", gr = 8483, de = 12538, Ve = "children", De = "predicate_expression", Ke = "??", tn = "Identifier", Qn = 64311, rt = 192, tt = 11710, Ot = 122654, au = 110947, En = 67591, Kt = "!", Zi = "directive", Ln = 163, Tn = "block", fn = 126553, Ht = 12735, S7 = 68096, Dt = "params", ks = 93071, In = 122, Wc = 72767, Ai = 181, li = "for_statement", jt = 128, g7 = "start", av = 43867, nU = "_method", P_ = 70414, cv = ">", Qi = "catch_body", D_ = 120121, tU = "the end of an expression statement (`;`)", L_ = 124907, uU = 1027, s4 = 126558, rf = "jsx_fragment", R_ = 42527, j_ = "decorators", G_ = 82943, M_ = 71039, B_ = 110882, q_ = 67514, iU = 8472, fU = "update", U_ = 12783, H_ = 12438, X_ = 12352, Y_ = 8511, V_ = 42961, F2 = "method", v4 = 120713, ef = 8191, nf = "function_param", z_ = 67871, F7 = "throw", K_ = 11507, tf = "class_extends", W_ = 43470, uf = "object_key_literal", J_ = 71903, $_ = 65437, ff = "jsx_child", Z_ = 43311, l4 = 119995, Q_ = 67637, b4 = 68116, ry = 66204, ey = 65470, xU = "<<=", ny = "e", ty = 67391, p4 = 11631, m4 = 69956, sv = "tparams", uy = 66735, iy = 64217, fy = 43697, oU = "Invalid binary/octal ", xy = -43, oy = 43255, _4 = "do", ay = 43301, xf = "binding_pattern", cy = 120487, of = "jsx_attribute_value_literal", y4 = "package", af = "interface_declaration", sy = 72750, vy = 119892, aU = "tail", cU = -53, cf = 111, sU = 180, ly = 119807, by = 71959, vU = 8206, py = 65613, Jc = "type", my = 55215, _y = -42, sf = "export_default_declaration_decl", h4 = 72970, lU = "filtered_out", yy = 70416, bU = 229, vf = "function_this_param", pU = "module", d4 = "try", hy = 70143, dy = 125183, ky = 70412, d0 = "@])", lf = "binary", mU = "infinity", k4 = "private", wy = 65500, w4 = "has_unknown_members", bf = "pattern_array_rest_element", _U = "Property", ws = "implements", Ey = 12548, yU = 211, pf = "if_alternate_statement", Sy = 124903, gy = 43395, vv = "src/parser/type_parser.ml", Fy = 66915, E4 = 126552, Ty = 120712, S4 = 126555, Oy = 120596, c7 = "raw", T7 = 112, mf = "class_declaration", _f = "statement", Iy = 126624, Ay = 71235, yf = "meta_property", Ny = 44002, Cy = 8467, hf = "class_property_value", Py = 8318, df = "optional_call", Dy = 43761, $c = "kind", kf = "class_identifier", Ly = 69955, Ry = 66378, jy = 120512, Gy = 68220, Xt = 110, My = 123583, T2 = "declare", wf = "typeof_member_identifier", Ef = "catch_clause", By = 11742, qy = 70831, g4 = 8468, Sf = "for_in_assignment_pattern", hU = -32, gf = "object_", Uy = 43262, Hy = "mixins", Ff = "type_param", dU = "visit_trailing_comment", Xy = 71839, O2 = "boolean", Tf = "call", kU = "expected *", Yy = 43010, Vy = 241, Nu = "expression", I2 = "column", zy = 43595, Ky = 43258, Wy = 191456, Of = "member_type_identifier", A2 = 117, Jy = 43754, F4 = 126544, wU = "Assert_failure", $y = 66517, Zy = 42964, If = "enum_number_member", EU = "a string", Qy = 65855, rh = 119993, eh = "opaque", SU = 870530776, nh = 67711, th = 66994, Af = "enum_symbol_body", gU = 185, FU = 219, T4 = "filter", uh = 43615, O4 = 126560, ih = 19903, n1 = "get", fh = 64316, TU = `Fatal error: exception %s
`, I4 = "exported", OU = ">=", Ju = "return", A4 = "members", N4 = 256, xh = 66962, oh = 64279, ah = 67829, IU = "Enum `", AU = "&&=", Nf = "object_property", ch = 67589, Cf = "pattern_object_property", Pf = "template_literal_element", sh = 69551, Ni = 127343600, C4 = 70452, Df = "class_element", vh = "ENOENT", lh = 71131, NU = 200, bh = 120137, ph = 94098, P4 = 72349, CU = 1328, Lf = "function_identifier", mh = 126543, Rf = "jsx_attribute_name", _h = 43487, dr = "@[<2>{ ", PU = "ENOTEMPTY", yh = 65908, hh = 72191, D4 = 120513, dh = 92909, DU = "bound", kh = 162, LU = 172, L4 = 120070, jf = "enum_number_body", Gf = "update_expression", Mf = "spread_element", Bf = "for_in_left_declaration", R4 = 64319, N2 = "%d", wh = 12703, j4 = 11687, RU = "@,))@]", Eh = 42239, qf = "type_cast", Sh = 42508, Uf = "class_implements_interface", gh = 67640, Fh = 605857695, jU = "Cygwin", GU = "buffer.ml", Th = 124908, MU = "handler", Oh = 66207, Ih = 66963, G4 = 11558, BU = "-=", Pn = 113, Ah = 113775, qU = "collect_comments", M4 = 126540, lv = "set", Hf = "assignment_pattern", Cu = "right", Xf = "object_key_identifier", B4 = 120133, Nh = "Invalid number ", Ch = 42963, q4 = 12539, Ph = 68023, Dh = 43798, ti = 100, Yf = "pattern_literal", Vf = "generic_type", UU = "*", Lh = 42783, Rh = 42890, jh = 230, U4 = "else", Gh = 70851, Mh = 69289, HU = "the start of a statement", H4 = "properties", Bh = 43696, qh = 110959, zf = "declare_function", X4 = 120597, Kf = "object_indexer_property_type", Uh = 70492, Hh = 2048, C2 = "arguments", Xr = "comments", Xh = 43042, Zc = 107, Yh = 110575, XU = 161, Vh = 67431, Y4 = "line", P2 = "declaration", nu = "static", Wf = "pattern_identifier", zh = 69958, YU = "the", Kh = "Unix.Unix_error", Wh = 43814, Qc = "annot", Jh = 65786, $h = 66303, Zh = 64967, Qh = 64255, rd = 8584, V4 = 120655, VU = "Stack_overflow", ed = 43700, Jf = "syntax_opt", zU = "/static/", $f = "comprehension", nd = 253, KU = "Not_found", WU = "+=", JU = 235, td = 68680, ud = 66954, id = 64324, fd = 72966, $U = 174, ZU = -1053382366, xd = "rest", Zf = "pattern_array_element", Qf = "jsx_attribute_value_expression", z4 = 65595, rx = "pattern_array_e", QU = 243, od = 43711, ad = "rmdir", K4 = "symbol", cd = 69926, W4 = "*dummy method*", sd = 43741, O7 = "typeParameters", D2 = "const", rH = 1026, eH = 149, vd = 12341, ld = 72847, bd = 66993, nH = 202, Ci = "false", Yt = 106, pd = 120076, md = 186, Pi = 128, _d = 125124, yd = "Fatal error: exception ", J4 = 67593, hd = 69297, dd = 44031, tH = 234, kd = 92927, wd = 68095, $u = 8231, ex = "object_key_computed", nx = "labeled_statement", tx = "function_param_pattern", $4 = 126590, Ed = 65481, Sd = 43442, uH = "collect_comments_opt", ux = "variable_declarator", bv = "_", gd = "compare: functional value", Fd = 67967, pv = "computed", ix = "object_property_type", mt = "id", Td = 126562, t1 = 114, iH = "comment_bounds", Od = 70853, Id = 69247, fx = "class_private_field", Ad = 42237, Nd = 72329, fH = "Invalid_argument", Cd = 113770, Z4 = 94031, Pd = 120092, xx = "declare_class", Dd = 67839, Ld = 72250, xH = "%ni", Rd = 92879, oH = "prototype", Es = "`.", ox = 8287, Q4 = 65344, jd = "&", I7 = "debugger", ax = "type_identifier_reference", aH = "Internal Error: Found private field in object props", cx = "sequence", sx = "call_type_args", cH = 238, Gd = 12348, sH = "++", Md = 68863, Bd = 72001, qd = 70084, Ud = "label", mv = -45, vx = "jsx_opening_attribute", Hd = 43583, r8 = "%F", Xd = 43784, Yd = 113791, lx = "call_arguments", e8 = 126503, Vd = 43743, Zu = "0", zd = 119967, n8 = 126538, bx = "new_", _v = 449540197, Kd = 64109, Wd = 68466, Jd = 177983, wt = 248, px = "program", Xe = "@,]@]", $d = 68031, mx = "function_type", _x = "type_", t8 = 8484, Zd = 67382, Qd = 42537, rk = 226, ek = 66559, nk = 42993, tk = 64274, u8 = 71236, uk = 120069, ik = 72105, fk = 126570, xk = "object", ok = 42959, A7 = "break", yx = "for_of_statement", ak = 43695, i8 = 126551, ck = 66955, f8 = 126520, sk = 66499, L2 = 1024, vk = 67455, lk = 43018, vH = 198, x8 = 126522, hx = "function_declaration", bk = 73064, dx = "await", pk = 92728, mk = 70418, _k = 68119, kx = "function_rest_param", yk = 42653, o8 = 11703, bi = "left", a8 = 70449, hk = 184, wx = "declare_type_alias", Ex = 16777215, c8 = 70302, lH = "/=", bH = "|=", dk = 55242, kk = 126583, wk = 124927, Ek = 124895, Sk = 72959, gk = 65497, pH = "Invalid legacy octal ", rs = "typeof", Fk = "explicit_type", Sx = "statement_list", Tk = 65495, gx = "class_method", s8 = 8526, v8 = 244, Ok = 67861, l8 = 119994, b8 = "enum", mH = 2147483647, Ik = 69762, _H = 208, R2 = "in", Ak = 11702, p8 = 67638, yH = ", characters ", Nk = 70753, yv = "super", Ck = 92783, Pk = 8304, m8 = 126504, Fx = "import_specifier", Dk = 68324, Lk = 101589, Rk = 67646, Tx = "expression_or_spread", jk = 74879, Gk = 43792, _8 = 43260, Mk = 93052, hH = "{", Bk = 65574, qk = 125258, hv = 224, Ox = "jsx_element_name_member_expression", j2 = "instanceof", Uk = 69599, Hk = 43560, Ix = "function_expression", y8 = 223, Xk = 72242, Yk = 11498, Vk = 126467, zk = 73112, dH = 140, h8 = 70107, Kk = 13311, Ax = "jsx_children", d8 = 126548, Wk = 63743, k8 = 43471, Nx = "jsx_expression", Jk = 69864, $k = 71998, Zk = 72e3, w8 = 126591, E8 = 12592, Cx = "type_params", Qk = 126578, S8 = 126537, kr = "{ ", rw = 123627, Px = "jsx_spread_attribute", Ce = "@,", ew = 70161, nw = 187, g8 = 126500, Dx = "label_identifier", tw = 42606, Lx = "number_literal_type", F8 = 42999, uw = 64310, kH = -594953737, iw = 122623, T8 = "hasUnknownMembers", Rx = "array", wH = "^=", jx = "enum_string_member", fw = 65536, xw = 65615, es = "void", ow = 65135, Z0 = ")", EH = 138, aw = 70002, G2 = "let", cw = 70271, sw = "nan", W = "@[%s =@ ", vw = 194559, lw = 110579, Gx = "binding_type_identifier", bw = 42735, SH = 57343, Qu = "/", Mx = "for_in_statement_lhs", pw = 43503, mw = 8516, _w = 66938, yw = "ENOTDIR", gH = "TypeParameterInstantiation", hw = 69749, dw = 65381, kw = 83526, dv = "number", ww = 12447, FH = 154, O8 = 70286, Ew = 72160, Sw = 43493, TH = 206, Bx = "enum_member_identifier", I8 = 70280, M2 = "function", A8 = 70162, gw = 255, Fw = 67702, Tw = 66771, Ow = 70312, OH = "|", Iw = 93759, IH = "End_of_file", Aw = 43709, u1 = "new", AH = "Failure", B2 = "local", Nw = 101631, N8 = 8489, C8 = "with", qx = "enum_declaration", Cw = 218, Pw = 70457, P8 = 8488, Ux = "member", D8 = 64325, Dw = 247, Lw = 70448, Rw = 69967, L8 = 126535, jw = 71934, Hx = "import_named_specifier", Gw = 65312, Mw = 126619, Xx = "type_annotation", NH = 56320, Bw = 131071, qw = 120770, Uw = 67002, Yx = "with_", Vx = "statement_fork_point", CH = "finalizer", Hw = 12320, PH = "elements", zx = "literal", Xw = 68607, Yw = 8507, R8 = "each", DH = "Sys_error", Vw = 123535, zw = 130, Kx = "bigint_literal_type", Kw = 64829, j8 = 11727, Ww = 120538, Wx = "member_private_name", Jx = "type_alias", LH = "Printexc.handle_uncaught_exception", G8 = 126556, $x = "tagged_template", Zx = "pattern_object_property_literal_key", Jw = 43881, M8 = 72192, $w = 67826, Zw = 124910, Qw = 66511, ns = "int_of_string", rE = 43249, nr = "None", RH = "FunctionTypeParam", ui = "name", eE = 70285, s7 = 103, nE = 120744, Qx = 12288, ro = "intersection_type", tE = 11679, B8 = 11559, jH = "callee", uE = 71295, iE = 70018, fE = 11567, xE = 42954, GH = "*-/", r7 = "predicate", eo = "expression_statement", MH = "regexp", oE = 65479, BH = 132, aE = 11389, qu = "optional", qH = -602162310, z2 = "@]", cE = 120003, sE = 72249, UH = "Unexpected ", vE = 73008, q8 = "finally", no = "toplevel_statement_list", HH = "end", lE = 178207, XH = "&=", bE = 70301, YH = "%Li", pE = 72161, mE = 69746, _E = 70460, yE = 12799, U8 = 65535, hE = "loc", dE = 69375, kE = 43518, VH = 205, wE = 65487, to = "while_", EE = 183983, uo = "typeof_expression", SE = -673950933, gE = 42559, zH = "||", FE = 124926, TE = 55291, io = "jsx_element_name_identifier", fo = 8239, H8 = "mixed", KH = 136, OE = -253313196, IE = 11734, X8 = 67827, AE = 68287, NE = 119976, WH = "**", J = " =", Y8 = 888960333, CE = 124902, xo = "tuple_type", JH = 227, PE = 70726, DE = 73111, V8 = 126602, LE = 126529, oo = "object_property_value_type", N0 = "%a", $H = ", ", ZH = "<=", RE = 69423, QH = 199, z8 = 11695, jE = 12294, K8 = 11711, GE = 67583, rX = 710, W8 = 126584, ME = 68295, BE = 72703, qE = "prefix", eX = -80, J8 = 69415, UE = 11492, q2 = "class", $8 = 65575, N7 = "continue", HE = 65663, nX = 2047, Z8 = 68120, XE = 71086, YE = 19967, Di = 782176664, VE = 120779, Q8 = 8486, pi = " ", tX = "||=", uX = "Undefined_recursive_module", zE = 66863, iX = "RestElement", r3 = 126634, KE = 66377, WE = 74751, ao = "jsx_element_name_namespaced", JE = 43334, $E = 66815, C7 = "typeAnnotation", ZE = 120126, co = "array_element", e3 = 64285, fX = 189, xX = "**=", Yr = "()", QE = 8543, so = "declare_module", vo = "export_batch_specifier", oX = "%i", aX = ">>>=", rS = 68029, cX = "importKind", P7 = "extends", eS = 64296, n3 = 43259, nS = 71679, tS = 64913, uS = 119969, iS = 94175, fS = 72440, t3 = 65141, lo = "function_", xS = 43071, oS = 42888, aS = 69807, cu = "variance", ts = 123, bo = "import_default_specifier", sX = ">>>", cS = 43764, mi = "pattern", sS = 71947, vS = 70655, kv = "consequent", vX = 4096, lS = 183, bS = 68447, pS = 65473, us = 255, mS = 73648, po = "call_type_arg", mo = 8238, _S = 68899, yS = 93026, Ye = "@[<2>[", hS = 110588, _o = "comment", lX = 191, yo = "switch_case", bX = 175, dS = 71942, ho = "do_while", wv = "constructor", kS = 43587, wS = 43586, Eu = "yield", ES = 67462, pX = "fd ", SS = -61, gS = "target", u3 = 72272, U2 = "var", mX = "impltype", i3 = 70108, H2 = "0o", FS = 119972, TS = 92991, f3 = 70441, x3 = 8450, OS = 120074, IS = 66717, ko = "interface_type", o3 = 43880, An = "%B", AS = 111355, Ev = 5760, NS = 11630, a3 = 126499, CS = "of", _X = ">>", yX = "Popping lex mode from empty stack", c3 = 120629, is = 108, PS = 43002, hX = "%=", s3 = 126539, DS = 126502, wo = "template_literal", LS = "src/parser/statement_parser.ml", RS = ": Not a directory", dX = "b", jS = 67461, GS = 11519, kX = "src/parser/flow_lexer.ml", wX = "Out_of_memory", MS = 120570, Eo = 12287, BS = 126534, qS = "index out of bounds", US = 73029, v3 = "_bigarr02", l3 = 126571, EX = "))", So = "for_statement_init", SX = "supertype", go = "class_property", b3 = "}", i1 = "this", Fo = "declare_module_exports", gX = "@", To = "union_type", Li = 65535, Oo = "variance_opt", HS = 94032, FX = 222, XS = 42124, Io = "this_expression", Ao = "jsx_element", TX = "typeArguments", YS = 65019, VS = 125251, zS = 64111, KS = 8471, No = "typeof_qualified_identifier", WS = 70497, OX = "EnumDefaultedMember", Co = 8202, JS = 66927, D7 = "switch", $S = 69634, Po = "unary_expression", ZS = 71215, IX = 126, QS = 67679, rg = 65597, AX = 207, eg = 120686, p3 = 72163, ng = 67001, tg = 42962, ug = 64262, X2 = 124, Do = 65279, ig = 126495, NX = 169, fg = 71944, CX = -10, m3 = "alternate", xg = 92975, og = 65489, Y2 = 252, ag = 67807, cg = 43187, sg = 68850, _3 = "export", vg = 66383, PX = "===", Lo = ".", Ro = "type_args", DX = 147, lg = 92159, LX = 240, jo = "jsx_element_name", bg = 72283, pg = 171, f1 = 116, mg = 110587, y3 = 70279, _g = 75075, yg = 65338, Go = "function_params", hg = 126627, RX = 213, h3 = 73065, dg = 71352, d3 = 119970, kg = 70005, wg = 12295, k3 = 120771, Eg = 71494, Sg = 11557, gg = 42191, jX = "flags", Fg = 68437, Tg = 70730, Mo = "optional_indexed_access", Bo = "pattern_object_p", Og = 42785, qo = "nullable_type", Bn = "value", Ig = 12343, Ag = 68415, Ng = 11694, GX = 221, Cg = 11726, Uo = "syntax", Pg = 119964, MX = "&&", Dg = 68497, Lg = 73097, fs = "null", w3 = 126523, Rg = 120084, jg = 126601, Gg = 8454, Mg = "expressions", Bg = 72144, V2 = '"', Zr = "(@[", BX = 1022, qX = 231, qg = 170, E3 = 12448, Ug = 68786, S3 = "<", UX = 931, HX = "(", XX = 196, YX = 2048, g3 = "an identifier", F3 = 69959, Hg = 68799, VX = "leadingComments", Xg = 72969, Yg = 182, Vg = 100351, Ho = "enum_defaulted_member", zg = 69839, Kg = 94026, Wg = 209, zX = ">>=", Jg = 131, T3 = 12336, v7 = "empty", KX = 331416730, WX = 204, $g = 70479, Zg = 69487, Qg = 101640, rF = 43123, JX = "([^/]+)", O3 = 8319, $X = 165, Xo = "object_type_property_setter", ZX = 909, eF = 15, nF = 12591, br = 125, tF = 92735, QX = "cases", uF = 183969, x1 = "bigint", rY = "Division_by_zero", iF = 67071, fF = 12329, I3 = 120004, xF = 69414, A3 = "if", oF = 126519, aF = "immediately within another function.", cF = 55238, sF = 126498, eY = "qualification", vF = 66256, wr = "@ }@]", z22 = 118, N3 = 11565, C3 = 120122, Yo = "pattern_object_rest_property", lF = 74862, P3 = "'", bF = -26065557, pF = 124911, Sv = 119, L7 = 104, Vo = "assignment", mF = 8457, K2 = "from", _F = 64321, yF = 113817, hF = 65629, dF = 42655, Ri = 102, kF = 43137, wF = 11502, a0 = ";@ ", R7 = 101, zo = "pattern_array_element_pattern", Wn = "body", Ko = "jsx_member_expression", EF = 65547, Wo = "jsx_attribute_value", Jo = "jsx_namespaced_name", D3 = 72967, SF = 126550, gv = 254, gF = 43807, FF = 43738, L3 = 126589, R3 = 8455, j3 = 126628, TF = 11670, nY = "*=", G3 = 120134, $o = "conditional", tY = " : flags Open_text and Open_binary are not compatible", M3 = 119965, OF = 69890, IF = 72817, AF = 164, NF = 43822, B3 = 69744, uY = "\\\\", CF = 43638, PF = 93047, DF = "AssignmentPattern", q3 = 64322, LF = 123190, iY = 188, Zo = "object_spread_property_type", RF = 70783, jF = 113663, fY = 160, U3 = 42622, H3 = 43823, ji = "init", Fv = 109, GF = 66503, X3 = "proto", MF = 74649, Qo = "optional_member", BF = 40981, qF = 120654, v = "@ ", ra = "enum_boolean_body", ea = "export_named_specifier", na = "declare_interface", UF = 70451, ta = "pattern_object_property_computed_key", Y3 = -97, V3 = 120539, z3 = 64317, HF = 12543, ua = "export_named_declaration_specifier", XF = 43359, K3 = 126530, W3 = 72713, YF = 113800, xY = 195, VF = 72367, zF = 72103, KF = 70278, ia = "if_consequent_statement", W2 = -85, J3 = 126496, fa = "try_catch", xa = "computed_key", oa = "class_", WF = 173823, aa = "pattern_object_property_identifier_key", oY = "f", ca = "arrow_function", $3 = 8485, JF = 126546, sa = "enum_boolean_member", $F = 94177, J2 = "delete", ZF = 232, aY = "blocks", va = "pattern_array_rest_element_pattern", QF = 78894, Z3 = 66512, rT = 94111, Tv = "string", Ss = "test", eT = 69572, nT = 66463, tT = 66335, uT = 72348, iT = 73061, o1 = ":", la = "enum_body", fT = 110590, ba = "function_this_param_type", xT = 215, oT = 77823, cY = "minus", sY = 201, aT = 119980, pa = "private_name", ma = "object_key", _a = "function_param_type", vY = "<<", cT = 11718, a1 = "as", lY = "delegate", Gi = "true", sT = 67413, Q3 = 70854, vT = 73439, lT = 43776, bT = 71723, pT = 11505, mT = 214, _T = 120628, yT = 43513, ya = "jsx_attribute_name_namespaced", r6 = 120127, e6 = "Map.bal", n6 = "any", bY = "@[", pY = "camlinternalMod.ml", t6 = 126559, Uu = "import", u6 = 70404, ha = "jsx_spread_child", hT = 233, dT = 67897, kT = 119974, Hu = 8233, wT = 68405, i6 = 239, mY = "attributes", _Y = 173, da = "object_internal_slot_property_type", ET = 71351, ST = 242, gT = 67643, f6 = "shorthand", ka = "for_in_statement", FT = 126463, TT = 71338, OT = 69445, IT = 65370, AT = 73055, NT = 167, CT = 64911, wa = "pattern_object_property_pattern", yY = 212, hY = 197, x6 = 126579, PT = 64286, DT = "explicitType", LT = 67669, RT = 43866, dY = "Sys_blocked_io", o6 = "catch", jT = 123197, GT = 64466, MT = 65140, BT = 73030, qT = 69404, a6 = "protected", kY = 8204, UT = 67504, HT = 193, $2 = 246, XT = 43713, c6 = 120571, Ea = "array_type", wY = "%u", Sa = "export_default_declaration", ga = "class_expression", EY = "quasi", Vt = "%S", YT = 8525, s6 = 126515, VT = 120485, v6 = 43519, l6 = 120745, b6 = 94178, zT = 126588, zn = 127, KT = 66855, SY = "@{", gY = "visit_leading_comment", WT = 67742, FY = " : flags Open_rdonly and Open_wronly are not compatible", JT = 120144, p6 = "returnType", c1 = -744106340, s1 = 240, Fa = "-", m6 = 8469, gs = "async", _6 = 126521, $T = 72095, y6 = 216, TY = " : file already exists", ZT = 178205, QT = 8449, h6 = 94179, rO = 42774, d6 = "case", eO = 66965, nO = 66431, OY = 190, Ta = "declare_export_declaration", Z2 = "targs", Oa = "type_identifier", tO = 64284, uO = 43013, k6 = 43815, Ia = "function_body_any", iO = 66966, w6 = 120687, fO = 66939, xO = 66978, IY = 168, E6 = "public", oO = 68115, aO = 43712, S6 = 65598, g6 = 126547, cO = 110591, Aa = "indexed_access", AY = 12520, e7 = "interface", NY = `(Program not linked with -g, cannot print stack backtrace)
`, v1 = -46, Na = "string_literal_type", Ca = "import_namespace_specifier", sO = 120132, F6 = 11735, vO = 67505, T6 = 119893, O6 = "bool", Q2 = 1e3, _i = "default", lO = 236, C = "", bO = "exportKind", CY = "trailingComments", I6 = "^", pO = 71983, mO = 8348, _O = 66977, yO = 65594, Pa = "logical", Da = "jsx_member_expression_identifier", A6 = 210, PY = "cooked", La = "for_of_left_declaration", Ov = 63, hO = 72202, l7 = "argument", dO = 12442, kO = 43645, N6 = 120085, wO = 42539, C6 = 126468, DY = 166, LY = "Match_failure", EO = 68191, Su = "src/parser/flow_ast.ml", P6 = 11647, Ra = "declare_variable", xs = "+", SO = 71127, D6 = 120145, ja = "declare_export_declaration_decl", L6 = 64318, RY = 179, Ga = "class_implements", jY = "!=", GY = "inexact", MY = "%li", BY = 237, rl = "a", R6 = 73062, gO = 178, Ma = 65278, Ba = "function_rest_param_type", FO = 77711, TO = 70066, OO = 43714, qY = -696510241, j6 = 70480, IO = 69748, AO = 113788, NO = 94207, UY = `\r
`, qa = "class_body", CO = 126651, PO = 68735, DO = 43273, G6 = 119996, M6 = 67644, HY = 224, Ua = "catch_clause_pattern", Ha = "boolean_literal_type", B6 = 126554, q6 = 126557, LO = 113807, U6 = 126536, XY = "%", Iv = "property", RO = 71956, YY = "#", jO = 123213, el = "meta", Xa = "for_of_assignment_pattern", Ya = "if_statement", GO = 66421, MO = 8505, BO = 225, nl = 250, qO = 100343, H6 = "Literal", UO = 42887, Av = 115, VY = ";", HO = 1255, XO = "=", YO = 126566, VO = 93823, Va = "opaque_type", zY = "!==", za = "jsx_attribute", Ka = "type_annotation_hint", Mi = 32768, zO = 73727, KY = "range", WY = 245, KO = "jsError", X6 = 70006, WO = 43492, Y6 = "@]}", tr = "(Some ", JO = 8477, JY = 129, $O = 71487, V6 = 126564, $Y = `
`, ZO = 126514, QO = 70080, Wa = "generic_identifier_type", rI = 66811, Ja = "typeof_identifier", ZY = "~", eI = 65007, $a = "pattern_object_rest_property_pattern", nI = 194, QY = 1039100673, tI = 66461, uI = 70319, z6 = 11719, iI = 72271, Wt = -48, Za = "enum_string_body", fI = 70461, Qa = "export_named_declaration", xI = 110930, oI = 92862, rV = "??=", aI = 70440, K6 = "while", su = "camlinternalFormat.ml", cI = 43782, eV = 203, sI = 173791, vI = 11263, lI = 1114111, bI = 42969, W6 = 70750, rc = "jsx_identifier", pI = 70105, mI = 43014, _I = 11564, ec = "typeof_type", nV = "EEXIST", yI = 64847, hI = 71167, dI = 42511, kI = 72712, wI = 92995, EI = 43704, tl = 121, nc = "object_call_property_type", SI = 64433, ul = "operator", J6 = 68296, tc = "class_decorator", uc = 120, ic = "for_of_statement_lhs", gI = 11623, FI = 67004, TI = 71999, OI = 70708, II = 512, AI = 110927, NI = 71423, tV = 32752, CI = 93951, PI = 12292, fc = "object_type", $6 = "types", DI = 110580, uV = 177, LI = 126633, RI = 12686, xc = 8286, iV = 144, jI = 73647, fV = 228, Z6 = 70855, l1 = "0x", GI = 70366, MI = `
`, oc = "variable_declaration", BI = 65276, Q6 = 119981, qI = 71945, UI = 43887, j7 = 105, HI = 8335, XI = 123565, YI = 69505, VI = 70187, ac = "jsx_attribute_name_identifier", cc = "source", sc = "pattern_object_property_key", rp = 65548, zI = 66175, KI = 92766, vc = "pattern_assignment_pattern", lc = "object_type_property_getter", ep = 8305, G7 = "generator", np = "for", xV = "PropertyDefinition", oV = "--", vu = -36, WI = "mkdir", JI = 68223, bc = "generic_qualified_identifier_type", $I = 11686, pc = "jsx_closing_element", ZI = 43790, tp = ": No such file or directory", QI = 69687, rA = 66348, up = 72162, eA = 43388, nA = 72768, tA = 68351, h = "<2>", ip = 64297, uA = 125259, iA = 220, zr = ",@ ", aV = "win32", fp = 70281, mc = "member_property_identifier", fA = 68149, xA = 68111, oA = 71450, aA = 43009, _c = "member_property", cA = 73458, yi = "identifier", sA = 67423, vA = 66775, lA = 110951, cV = "Internal Error: Found object private prop", yc = "super_expression", hc = "jsx_opening_element", bA = 177976, dc = "variable_declarator_pattern", kc = "pattern_expression", wc = "jsx_member_expression_object", pA = 68252, mA = 77808, Nv = -835925911, Ec = "import_declaration", _A = 55203, sV = "Pervasives.do_at_exit", vV = "utf8", ii = "key", yA = 43702, Sc = "spread_property", xp = 126563, hA = 863850040, dA = 70106, op = 67592, gc = "function_expression_or_method", kA = 71958, Fc = "for_init_declaration", wA = 71955, ap = 123214, EA = 68479, lV = "==", SA = 43019, gA = 123180, cp = 217, Cv = "specifiers", Tc = "function_body", FA = 69622, sp = 8487, TA = 43641, bV = "Unexpected token `", pV = "v", OA = 123135, IA = 69295, vp = 120093, AA = 8521, lp = 43642, mV = 176;
            function Ku0(t, n, e, i, x) {
              if (i <= n) for (var c = 1; c <= x; c++) e[i + c] = t[n + c];
              else for (var c = x; c >= 1; c--) e[i + c] = t[n + c];
              return 0;
            }
            function Wu0(t) {
              for (var n = [0]; t !== 0; ) {
                for (var e = t[1], i = 1; i < e.length; i++) n.push(e[i]);
                t = t[2];
              }
              return n;
            }
            function Ju0(t, n, e) {
              var i = new Array(e + 1);
              i[0] = 0;
              for (var x = 1, c = n + 1; x <= e; x++, c++) i[x] = t[c];
              return i;
            }
            function NA(t, n, e) {
              var i = String.fromCharCode;
              if (n == 0 && e <= vX && e == t.length) return i.apply(null, t);
              for (var x = C; 0 < e; n += L2, e -= L2) x += i.apply(null, t.slice(n, n + Math.min(e, L2)));
              return x;
            }
            function bp(t) {
              if (z0.Uint8Array) var n = new z0.Uint8Array(t.l);
              else var n = new Array(t.l);
              for (var e = t.c, i = e.length, x = 0; x < i; x++) n[x] = e.charCodeAt(x);
              for (i = t.l; x < i; x++) n[x] = 0;
              return t.c = n, t.t = 4, n;
            }
            function Fs(t, n, e, i, x) {
              if (x == 0) return 0;
              if (i == 0 && (x >= e.l || e.t == 2 && x >= e.c.length)) e.c = t.t == 4 ? NA(t.c, n, x) : n == 0 && t.c.length == x ? t.c : t.c.substr(n, x), e.t = e.c.length == e.l ? 0 : 2;
              else if (e.t == 2 && i == e.c.length) e.c += t.t == 4 ? NA(t.c, n, x) : n == 0 && t.c.length == x ? t.c : t.c.substr(n, x), e.t = e.c.length == e.l ? 0 : 2;
              else {
                e.t != 4 && bp(e);
                var c = t.c, s = e.c;
                if (t.t == 4) if (i <= n) for (var p = 0; p < x; p++) s[i + p] = c[n + p];
                else for (var p = x - 1; p >= 0; p--) s[i + p] = c[n + p];
                else {
                  for (var y = Math.min(x, c.length - n), p = 0; p < y; p++) s[i + p] = c.charCodeAt(n + p);
                  for (; p < x; p++) s[i + p] = 0;
                }
              }
              return 0;
            }
            function voe(t) {
              return t;
            }
            function Ts(t, n, e, i, x) {
              return Fs(t, n, e, i, x), 0;
            }
            function $u0(t, n) {
              throw [0, t, n];
            }
            function Pv(t, n) {
              if (t == 0) return C;
              if (n.repeat) return n.repeat(t);
              for (var e = C, i = 0; ; ) {
                if (t & 1 && (e += n), t >>= 1, t == 0) return e;
                n += n, i++, i == 9 && n.slice(0, 1);
              }
            }
            function Dv(t) {
              t.t == 2 ? t.c += Pv(t.l - t.c.length, "\0") : t.c = NA(t.c, 0, t.c.length), t.t = 0;
            }
            function _V(t) {
              if (t.length < 24) {
                for (var n = 0; n < t.length; n++) if (t.charCodeAt(n) > zn) return false;
                return true;
              } else return !/[^\x00-\x7f]/.test(t);
            }
            function CA(t) {
              for (var n = C, e = C, i, x, c, s, p = 0, y = t.length; p < y; p++) {
                if (x = t.charCodeAt(p), x < Pi) {
                  for (var T = p + 1; T < y && (x = t.charCodeAt(T)) < Pi; T++) ;
                  if (T - p > II ? (e.substr(0, 1), n += e, e = C, n += t.slice(p, T)) : e += t.slice(p, T), T == y) break;
                  p = T;
                }
                s = 1, ++p < y && ((c = t.charCodeAt(p)) & -64) == jt && (i = c + (x << 6), x < HY ? (s = i - 12416, s < Pi && (s = 1)) : (s = 2, ++p < y && ((c = t.charCodeAt(p)) & -64) == jt && (i = c + (i << 6), x < LX ? (s = i - 925824, (s < YX || s >= 55295 && s < 57344) && (s = 2)) : (s = 3, ++p < y && ((c = t.charCodeAt(p)) & -64) == jt && x < 245 && (s = c - 63447168 + (i << 6), (s < 65536 || s > 1114111) && (s = 3)))))), s < 4 ? (p -= s, e += "\uFFFD") : s > Li ? e += String.fromCharCode(55232 + (s >> 10), NH + (s & 1023)) : e += String.fromCharCode(s), e.length > L2 && (e.substr(0, 1), n += e, e = C);
              }
              return n + e;
            }
            function Oc(t, n, e) {
              this.t = t, this.c = n, this.l = e;
            }
            Oc.prototype.toString = function() {
              switch (this.t) {
                case 9:
                  return this.c;
                default:
                  Dv(this);
                case 0:
                  if (_V(this.c)) return this.t = 9, this.c;
                  this.t = 8;
                case 8:
                  return this.c;
              }
            }, Oc.prototype.toUtf16 = function() {
              var t = this.toString();
              return this.t == 9 ? t : CA(t);
            }, Oc.prototype.slice = function() {
              var t = this.t == 4 ? this.c.slice() : this.c;
              return new Oc(this.t, t, this.l);
            };
            function yV(t) {
              return new Oc(0, t, t.length);
            }
            function r(t) {
              return yV(t);
            }
            function PA(t, n) {
              $u0(t, r(n));
            }
            var zt = [0];
            function lu(t) {
              PA(zt.Invalid_argument, t);
            }
            function hV() {
              lu(qS);
            }
            function Jn(t, n, e) {
              if (e &= us, t.t != 4) {
                if (n == t.c.length) return t.c += String.fromCharCode(e), n + 1 == t.l && (t.t = 0), 0;
                bp(t);
              }
              return t.c[n] = e, 0;
            }
            function b1(t, n, e) {
              return n >>> 0 >= t.l && hV(), Jn(t, n, e);
            }
            function Xu(t, n) {
              switch (t.t & 6) {
                default:
                  if (n >= t.c.length) return 0;
                case 0:
                  return t.c.charCodeAt(n);
                case 4:
                  return t.c[n];
              }
            }
            function os(t, n) {
              if (t.fun) return os(t.fun, n);
              if (typeof t != "function") return t;
              var e = t.length | 0;
              if (e === 0) return t.apply(null, n);
              var i = n.length | 0, x = e - i | 0;
              return x == 0 ? t.apply(null, n) : x < 0 ? os(t.apply(null, n.slice(0, e)), n.slice(e)) : function() {
                for (var c = arguments.length == 0 ? 1 : arguments.length, s = new Array(n.length + c), p = 0; p < n.length; p++) s[p] = n[p];
                for (var p = 0; p < arguments.length; p++) s[n.length + p] = arguments[p];
                return os(t, s);
              };
            }
            function il() {
              lu(qS);
            }
            function tu(t, n) {
              return n >>> 0 >= t.length - 1 && il(), t;
            }
            function Zu0(t) {
              return isFinite(t) ? Math.abs(t) >= 22250738585072014e-324 ? 0 : t != 0 ? 1 : 2 : isNaN(t) ? 4 : 3;
            }
            function Ic(t) {
              return (t.t & 6) != 0 && Dv(t), t.c;
            }
            var Qu0 = Math.log2 && Math.log2(11235582092889474e291) == 1020;
            function r70(t) {
              if (Qu0) return Math.floor(Math.log2(t));
              var n = 0;
              if (t == 0) return -1 / 0;
              if (t >= 1) for (; t >= 2; ) t /= 2, n++;
              else for (; t < 1; ) t *= 2, n--;
              return n;
            }
            function DA(t) {
              var n = new z0.Float32Array(1);
              n[0] = t;
              var e = new z0.Int32Array(n.buffer);
              return e[0] | 0;
            }
            var dV = Math.pow(2, -24);
            function kV(t) {
              throw t;
            }
            function wV() {
              kV(zt.Division_by_zero);
            }
            function sn(t, n, e) {
              this.lo = t & Ex, this.mi = n & Ex, this.hi = e & Li;
            }
            sn.prototype.caml_custom = "_j", sn.prototype.copy = function() {
              return new sn(this.lo, this.mi, this.hi);
            }, sn.prototype.ucompare = function(t) {
              return this.hi > t.hi ? 1 : this.hi < t.hi ? -1 : this.mi > t.mi ? 1 : this.mi < t.mi ? -1 : this.lo > t.lo ? 1 : this.lo < t.lo ? -1 : 0;
            }, sn.prototype.compare = function(t) {
              var n = this.hi << 16, e = t.hi << 16;
              return n > e ? 1 : n < e ? -1 : this.mi > t.mi ? 1 : this.mi < t.mi ? -1 : this.lo > t.lo ? 1 : this.lo < t.lo ? -1 : 0;
            }, sn.prototype.neg = function() {
              var t = -this.lo, n = -this.mi + (t >> 24), e = -this.hi + (n >> 24);
              return new sn(t, n, e);
            }, sn.prototype.add = function(t) {
              var n = this.lo + t.lo, e = this.mi + t.mi + (n >> 24), i = this.hi + t.hi + (e >> 24);
              return new sn(n, e, i);
            }, sn.prototype.sub = function(t) {
              var n = this.lo - t.lo, e = this.mi - t.mi + (n >> 24), i = this.hi - t.hi + (e >> 24);
              return new sn(n, e, i);
            }, sn.prototype.mul = function(t) {
              var n = this.lo * t.lo, e = (n * dV | 0) + this.mi * t.lo + this.lo * t.mi, i = (e * dV | 0) + this.hi * t.lo + this.mi * t.mi + this.lo * t.hi;
              return new sn(n, e, i);
            }, sn.prototype.isZero = function() {
              return (this.lo | this.mi | this.hi) == 0;
            }, sn.prototype.isNeg = function() {
              return this.hi << 16 < 0;
            }, sn.prototype.and = function(t) {
              return new sn(this.lo & t.lo, this.mi & t.mi, this.hi & t.hi);
            }, sn.prototype.or = function(t) {
              return new sn(this.lo | t.lo, this.mi | t.mi, this.hi | t.hi);
            }, sn.prototype.xor = function(t) {
              return new sn(this.lo ^ t.lo, this.mi ^ t.mi, this.hi ^ t.hi);
            }, sn.prototype.shift_left = function(t) {
              return t = t & 63, t == 0 ? this : t < 24 ? new sn(this.lo << t, this.mi << t | this.lo >> 24 - t, this.hi << t | this.mi >> 24 - t) : t < 48 ? new sn(0, this.lo << t - 24, this.mi << t - 24 | this.lo >> 48 - t) : new sn(0, 0, this.lo << t - 48);
            }, sn.prototype.shift_right_unsigned = function(t) {
              return t = t & 63, t == 0 ? this : t < 24 ? new sn(this.lo >> t | this.mi << 24 - t, this.mi >> t | this.hi << 24 - t, this.hi >> t) : t < 48 ? new sn(this.mi >> t - 24 | this.hi << 48 - t, this.hi >> t - 24, 0) : new sn(this.hi >> t - 48, 0, 0);
            }, sn.prototype.shift_right = function(t) {
              if (t = t & 63, t == 0) return this;
              var n = this.hi << 16 >> 16;
              if (t < 24) return new sn(this.lo >> t | this.mi << 24 - t, this.mi >> t | n << 24 - t, this.hi << 16 >> t >>> 16);
              var e = this.hi << 16 >> 31;
              return t < 48 ? new sn(this.mi >> t - 24 | this.hi << 48 - t, this.hi << 16 >> t - 24 >> 16, e & Li) : new sn(this.hi << 16 >> t - 32, e, e);
            }, sn.prototype.lsl1 = function() {
              this.hi = this.hi << 1 | this.mi >> 23, this.mi = (this.mi << 1 | this.lo >> 23) & Ex, this.lo = this.lo << 1 & Ex;
            }, sn.prototype.lsr1 = function() {
              this.lo = (this.lo >>> 1 | this.mi << 23) & Ex, this.mi = (this.mi >>> 1 | this.hi << 23) & Ex, this.hi = this.hi >>> 1;
            }, sn.prototype.udivmod = function(t) {
              for (var n = 0, e = this.copy(), i = t.copy(), x = new sn(0, 0, 0); e.ucompare(i) > 0; ) n++, i.lsl1();
              for (; n >= 0; ) n--, x.lsl1(), e.ucompare(i) >= 0 && (x.lo++, e = e.sub(i)), i.lsr1();
              return { quotient: x, modulus: e };
            }, sn.prototype.div = function(t) {
              var n = this;
              t.isZero() && wV();
              var e = n.hi ^ t.hi;
              n.hi & Mi && (n = n.neg()), t.hi & Mi && (t = t.neg());
              var i = n.udivmod(t).quotient;
              return e & Mi && (i = i.neg()), i;
            }, sn.prototype.mod = function(t) {
              var n = this;
              t.isZero() && wV();
              var e = n.hi;
              n.hi & Mi && (n = n.neg()), t.hi & Mi && (t = t.neg());
              var i = n.udivmod(t).modulus;
              return e & Mi && (i = i.neg()), i;
            }, sn.prototype.toInt = function() {
              return this.lo | this.mi << 24;
            }, sn.prototype.toFloat = function() {
              return (this.hi << 16) * Math.pow(2, 32) + this.mi * Math.pow(2, 24) + this.lo;
            }, sn.prototype.toArray = function() {
              return [this.hi >> 8, this.hi & us, this.mi >> 16, this.mi >> 8 & us, this.mi & us, this.lo >> 16, this.lo >> 8 & us, this.lo & us];
            }, sn.prototype.lo32 = function() {
              return this.lo | (this.mi & us) << 24;
            }, sn.prototype.hi32 = function() {
              return this.mi >>> 8 & Li | this.hi << 16;
            };
            function pp(t, n, e) {
              return new sn(t, n, e);
            }
            function mp(t) {
              if (!isFinite(t)) return isNaN(t) ? pp(1, 0, tV) : t > 0 ? pp(0, 0, tV) : pp(0, 0, 65520);
              var n = t == 0 && 1 / t == -1 / 0 ? Mi : t >= 0 ? 0 : Mi;
              n && (t = -t);
              var e = r70(t) + 1023;
              e <= 0 ? (e = 0, t /= Math.pow(2, -rH)) : (t /= Math.pow(2, e - uU), t < 16 && (t *= 2, e -= 1), e == 0 && (t /= 2));
              var i = Math.pow(2, 24), x = t | 0;
              t = (t - x) * i;
              var c = t | 0;
              t = (t - c) * i;
              var s = t | 0;
              return x = x & eF | n | e << 4, pp(s, c, x);
            }
            function fl(t) {
              return t.toArray();
            }
            function EV(t, n, e) {
              if (t.write(32, n.dims.length), t.write(32, n.kind | n.layout << 8), n.caml_custom == v3) for (var i = 0; i < n.dims.length; i++) n.dims[i] < Li ? t.write(16, n.dims[i]) : (t.write(16, Li), t.write(32, 0), t.write(32, n.dims[i]));
              else for (var i = 0; i < n.dims.length; i++) t.write(32, n.dims[i]);
              switch (n.kind) {
                case 2:
                case 3:
                case 12:
                  for (var i = 0; i < n.data.length; i++) t.write(8, n.data[i]);
                  break;
                case 4:
                case 5:
                  for (var i = 0; i < n.data.length; i++) t.write(16, n.data[i]);
                  break;
                case 6:
                  for (var i = 0; i < n.data.length; i++) t.write(32, n.data[i]);
                  break;
                case 8:
                case 9:
                  t.write(8, 0);
                  for (var i = 0; i < n.data.length; i++) t.write(32, n.data[i]);
                  break;
                case 7:
                  for (var i = 0; i < n.data.length / 2; i++) for (var x = fl(n.get(i)), c = 0; c < 8; c++) t.write(8, x[c]);
                  break;
                case 1:
                  for (var i = 0; i < n.data.length; i++) for (var x = fl(mp(n.get(i))), c = 0; c < 8; c++) t.write(8, x[c]);
                  break;
                case 0:
                  for (var i = 0; i < n.data.length; i++) {
                    var x = DA(n.get(i));
                    t.write(32, x);
                  }
                  break;
                case 10:
                  for (var i = 0; i < n.data.length / 2; i++) {
                    var c = n.get(i);
                    t.write(32, DA(c[1])), t.write(32, DA(c[2]));
                  }
                  break;
                case 11:
                  for (var i = 0; i < n.data.length / 2; i++) {
                    for (var s = n.get(i), x = fl(mp(s[1])), c = 0; c < 8; c++) t.write(8, x[c]);
                    for (var x = fl(mp(s[2])), c = 0; c < 8; c++) t.write(8, x[c]);
                  }
                  break;
              }
              e[0] = (4 + n.dims.length) * 4, e[1] = (4 + n.dims.length) * 8;
            }
            function SV(t) {
              switch (t) {
                case 7:
                case 10:
                case 11:
                  return 2;
                default:
                  return 1;
              }
            }
            function e70(t, n) {
              var e = z0, i;
              switch (t) {
                case 0:
                  i = e.Float32Array;
                  break;
                case 1:
                  i = e.Float64Array;
                  break;
                case 2:
                  i = e.Int8Array;
                  break;
                case 3:
                  i = e.Uint8Array;
                  break;
                case 4:
                  i = e.Int16Array;
                  break;
                case 5:
                  i = e.Uint16Array;
                  break;
                case 6:
                  i = e.Int32Array;
                  break;
                case 7:
                  i = e.Int32Array;
                  break;
                case 8:
                  i = e.Int32Array;
                  break;
                case 9:
                  i = e.Int32Array;
                  break;
                case 10:
                  i = e.Float32Array;
                  break;
                case 11:
                  i = e.Float64Array;
                  break;
                case 12:
                  i = e.Uint8Array;
                  break;
              }
              i || lu("Bigarray.create: unsupported kind");
              var x = new i(n * SV(t));
              return x;
            }
            function LA(t) {
              var n = new z0.Int32Array(1);
              n[0] = t;
              var e = new z0.Float32Array(n.buffer);
              return e[0];
            }
            function xl(t) {
              return new sn(t[7] << 0 | t[6] << 8 | t[5] << 16, t[4] << 0 | t[3] << 8 | t[2] << 16, t[1] << 0 | t[0] << 8);
            }
            function RA(t) {
              var n = t.lo, e = t.mi, i = t.hi, x = (i & 32767) >> 4;
              if (x == nX) return (n | e | i & eF) == 0 ? i & Mi ? -1 / 0 : 1 / 0 : NaN;
              var c = Math.pow(2, -24), s = (n * c + e) * c + (i & eF);
              return x > 0 ? (s += 16, s *= Math.pow(2, x - uU)) : s *= Math.pow(2, -rH), i & Mi && (s = -s), s;
            }
            function jA(t) {
              for (var n = t.length, e = 1, i = 0; i < n; i++) t[i] < 0 && lu("Bigarray.create: negative dimension"), e = e * t[i];
              return e;
            }
            function n70(t, n) {
              return new sn(t & Ex, t >>> 24 & us | (n & Li) << 8, n >>> 16 & Li);
            }
            function GA(t) {
              return t.hi32();
            }
            function MA(t) {
              return t.lo32();
            }
            var t70 = v3;
            function Os(t, n, e, i) {
              this.kind = t, this.layout = n, this.dims = e, this.data = i;
            }
            Os.prototype.caml_custom = t70, Os.prototype.offset = function(t) {
              var n = 0;
              if (typeof t == "number" && (t = [t]), t instanceof Array || lu("bigarray.js: invalid offset"), this.dims.length != t.length && lu("Bigarray.get/set: bad number of dimensions"), this.layout == 0) for (var e = 0; e < this.dims.length; e++) (t[e] < 0 || t[e] >= this.dims[e]) && il(), n = n * this.dims[e] + t[e];
              else for (var e = this.dims.length - 1; e >= 0; e--) (t[e] < 1 || t[e] > this.dims[e]) && il(), n = n * this.dims[e] + (t[e] - 1);
              return n;
            }, Os.prototype.get = function(t) {
              switch (this.kind) {
                case 7:
                  var n = this.data[t * 2 + 0], e = this.data[t * 2 + 1];
                  return n70(n, e);
                case 10:
                case 11:
                  var i = this.data[t * 2 + 0], x = this.data[t * 2 + 1];
                  return [gv, i, x];
                default:
                  return this.data[t];
              }
            }, Os.prototype.set = function(t, n) {
              switch (this.kind) {
                case 7:
                  this.data[t * 2 + 0] = MA(n), this.data[t * 2 + 1] = GA(n);
                  break;
                case 10:
                case 11:
                  this.data[t * 2 + 0] = n[1], this.data[t * 2 + 1] = n[2];
                  break;
                default:
                  this.data[t] = n;
                  break;
              }
              return 0;
            }, Os.prototype.fill = function(t) {
              switch (this.kind) {
                case 7:
                  var n = MA(t), e = GA(t);
                  if (n == e) this.data.fill(n);
                  else for (var i = 0; i < this.data.length; i++) this.data[i] = i % 2 == 0 ? n : e;
                  break;
                case 10:
                case 11:
                  var x = t[1], c = t[2];
                  if (x == c) this.data.fill(x);
                  else for (var i = 0; i < this.data.length; i++) this.data[i] = i % 2 == 0 ? x : c;
                  break;
                default:
                  this.data.fill(t);
                  break;
              }
            }, Os.prototype.compare = function(t, n) {
              if (this.layout != t.layout || this.kind != t.kind) {
                var e = this.kind | this.layout << 8, i = t.kind | t.layout << 8;
                return i - e;
              }
              if (this.dims.length != t.dims.length) return t.dims.length - this.dims.length;
              for (var x = 0; x < this.dims.length; x++) if (this.dims[x] != t.dims[x]) return this.dims[x] < t.dims[x] ? -1 : 1;
              switch (this.kind) {
                case 0:
                case 1:
                case 10:
                case 11:
                  for (var c, s, x = 0; x < this.data.length; x++) {
                    if (c = this.data[x], s = t.data[x], c < s) return -1;
                    if (c > s) return 1;
                    if (c != s) {
                      if (!n) return NaN;
                      if (c == c) return 1;
                      if (s == s) return -1;
                    }
                  }
                  break;
                case 7:
                  for (var x = 0; x < this.data.length; x += 2) {
                    if (this.data[x + 1] < t.data[x + 1]) return -1;
                    if (this.data[x + 1] > t.data[x + 1]) return 1;
                    if (this.data[x] >>> 0 < t.data[x] >>> 0) return -1;
                    if (this.data[x] >>> 0 > t.data[x] >>> 0) return 1;
                  }
                  break;
                case 2:
                case 3:
                case 4:
                case 5:
                case 6:
                case 8:
                case 9:
                case 12:
                  for (var x = 0; x < this.data.length; x++) {
                    if (this.data[x] < t.data[x]) return -1;
                    if (this.data[x] > t.data[x]) return 1;
                  }
                  break;
              }
              return 0;
            };
            function Lv(t, n, e, i) {
              this.kind = t, this.layout = n, this.dims = e, this.data = i;
            }
            Lv.prototype = new Os(), Lv.prototype.offset = function(t) {
              return typeof t != "number" && (t instanceof Array && t.length == 1 ? t = t[0] : lu("Ml_Bigarray_c_1_1.offset")), (t < 0 || t >= this.dims[0]) && il(), t;
            }, Lv.prototype.get = function(t) {
              return this.data[t];
            }, Lv.prototype.set = function(t, n) {
              return this.data[t] = n, 0;
            }, Lv.prototype.fill = function(t) {
              return this.data.fill(t), 0;
            };
            function gV(t, n, e, i) {
              var x = SV(t);
              return jA(e) * x != i.length && lu("length doesn't match dims"), n == 0 && e.length == 1 && x == 1 ? new Lv(t, n, e, i) : new Os(t, n, e, i);
            }
            function n7(t) {
              PA(zt.Failure, t);
            }
            function FV(t, n, e) {
              var i = t.read32s();
              (i < 0 || i > 16) && n7("input_value: wrong number of bigarray dimensions");
              var x = t.read32s(), c = x & us, s = x >> 8 & 1, p = [];
              if (e == v3) for (var y = 0; y < i; y++) {
                var T = t.read16u();
                if (T == Li) {
                  var E = t.read32u(), d = t.read32u();
                  E != 0 && n7("input_value: bigarray dimension overflow in 32bit"), T = d;
                }
                p.push(T);
              }
              else for (var y = 0; y < i; y++) p.push(t.read32u());
              var w = jA(p), G = e70(c, w), A = gV(c, s, p, G);
              switch (c) {
                case 2:
                  for (var y = 0; y < w; y++) G[y] = t.read8s();
                  break;
                case 3:
                case 12:
                  for (var y = 0; y < w; y++) G[y] = t.read8u();
                  break;
                case 4:
                  for (var y = 0; y < w; y++) G[y] = t.read16s();
                  break;
                case 5:
                  for (var y = 0; y < w; y++) G[y] = t.read16u();
                  break;
                case 6:
                  for (var y = 0; y < w; y++) G[y] = t.read32s();
                  break;
                case 8:
                case 9:
                  var S = t.read8u();
                  S && n7("input_value: cannot read bigarray with 64-bit OCaml ints");
                  for (var y = 0; y < w; y++) G[y] = t.read32s();
                  break;
                case 7:
                  for (var k0 = new Array(8), y = 0; y < w; y++) {
                    for (var M = 0; M < 8; M++) k0[M] = t.read8u();
                    var K = xl(k0);
                    A.set(y, K);
                  }
                  break;
                case 1:
                  for (var k0 = new Array(8), y = 0; y < w; y++) {
                    for (var M = 0; M < 8; M++) k0[M] = t.read8u();
                    var V = RA(xl(k0));
                    A.set(y, V);
                  }
                  break;
                case 0:
                  for (var y = 0; y < w; y++) {
                    var V = LA(t.read32s());
                    A.set(y, V);
                  }
                  break;
                case 10:
                  for (var y = 0; y < w; y++) {
                    var f0 = LA(t.read32s()), m0 = LA(t.read32s());
                    A.set(y, [gv, f0, m0]);
                  }
                  break;
                case 11:
                  for (var k0 = new Array(8), y = 0; y < w; y++) {
                    for (var M = 0; M < 8; M++) k0[M] = t.read8u();
                    for (var f0 = RA(xl(k0)), M = 0; M < 8; M++) k0[M] = t.read8u();
                    var m0 = RA(xl(k0));
                    A.set(y, [gv, f0, m0]);
                  }
                  break;
              }
              return n[0] = (4 + i) * 4, gV(c, s, p, G);
            }
            function TV(t, n, e) {
              return t.compare(n, e);
            }
            function OV(t, n) {
              return Math.imul(t, n);
            }
            function as(t, n) {
              return n = OV(n, -862048943), n = n << 15 | n >>> 32 - 15, n = OV(n, 461845907), t ^= n, t = t << 13 | t >>> 32 - 13, (t + (t << 2) | 0) + -430675100 | 0;
            }
            function u70(t, n) {
              return t = as(t, MA(n)), t = as(t, GA(n)), t;
            }
            function IV(t, n) {
              return u70(t, mp(n));
            }
            function AV(t) {
              var n = jA(t.dims), e = 0;
              switch (t.kind) {
                case 2:
                case 3:
                case 12:
                  n > N4 && (n = N4);
                  var i = 0, x = 0;
                  for (x = 0; x + 4 <= t.data.length; x += 4) i = t.data[x + 0] | t.data[x + 1] << 8 | t.data[x + 2] << 16 | t.data[x + 3] << 24, e = as(e, i);
                  switch (i = 0, n & 3) {
                    case 3:
                      i = t.data[x + 2] << 16;
                    case 2:
                      i |= t.data[x + 1] << 8;
                    case 1:
                      i |= t.data[x + 0], e = as(e, i);
                  }
                  break;
                case 4:
                case 5:
                  n > jt && (n = jt);
                  var i = 0, x = 0;
                  for (x = 0; x + 2 <= t.data.length; x += 2) i = t.data[x + 0] | t.data[x + 1] << 16, e = as(e, i);
                  (n & 1) != 0 && (e = as(e, t.data[x]));
                  break;
                case 6:
                  n > 64 && (n = 64);
                  for (var x = 0; x < n; x++) e = as(e, t.data[x]);
                  break;
                case 8:
                case 9:
                  n > 64 && (n = 64);
                  for (var x = 0; x < n; x++) e = as(e, t.data[x]);
                  break;
                case 7:
                  n > 32 && (n = 32), n *= 2;
                  for (var x = 0; x < n; x++) e = as(e, t.data[x]);
                  break;
                case 10:
                  n *= 2;
                case 0:
                  n > 64 && (n = 64);
                  for (var x = 0; x < n; x++) e = IV(e, t.data[x]);
                  break;
                case 11:
                  n *= 2;
                case 1:
                  n > 32 && (n = 32);
                  for (var x = 0; x < n; x++) e = IV(e, t.data[x]);
                  break;
              }
              return e;
            }
            function i70(t, n) {
              return n[0] = 4, t.read32s();
            }
            function f70(t, n) {
              switch (t.read8u()) {
                case 1:
                  return n[0] = 4, t.read32s();
                case 2:
                  n7("input_value: native integer value too large");
                default:
                  n7("input_value: ill-formed native integer");
              }
            }
            function x70(t, n) {
              for (var e = new Array(8), i = 0; i < 8; i++) e[i] = t.read8u();
              return n[0] = 8, xl(e);
            }
            function o70(t, n, e) {
              for (var i = fl(n), x = 0; x < 8; x++) t.write(8, i[x]);
              e[0] = 8, e[1] = 8;
            }
            function a70(t, n, e) {
              return t.compare(n);
            }
            function c70(t) {
              return t.lo32() ^ t.hi32();
            }
            var NV = { _j: { deserialize: x70, serialize: o70, fixed_length: 8, compare: a70, hash: c70 }, _i: { deserialize: i70, fixed_length: 4 }, _n: { deserialize: f70, fixed_length: 4 }, _bigarray: { deserialize: function(t, n) {
              return FV(t, n, "_bigarray");
            }, serialize: EV, compare: TV, hash: AV }, _bigarr02: { deserialize: function(t, n) {
              return FV(t, n, v3);
            }, serialize: EV, compare: TV, hash: AV } };
            function BA(t) {
              return NV[t.caml_custom] && NV[t.caml_custom].compare;
            }
            function CV(t, n, e, i) {
              var x = BA(n);
              if (x) {
                var c = e > 0 ? x(n, t, i) : x(t, n, i);
                if (i && c != c) return e;
                if (+c != +c) return +c;
                if ((c | 0) != 0) return c | 0;
              }
              return e;
            }
            function _p(t) {
              return t instanceof Oc;
            }
            function qA(t) {
              return _p(t);
            }
            function PV(t) {
              if (typeof t == "number") return Q2;
              if (_p(t)) return Y2;
              if (qA(t)) return 1252;
              if (t instanceof Array && t[0] === t[0] >>> 0 && t[0] <= gw) {
                var n = t[0] | 0;
                return n == gv ? 0 : n;
              } else {
                if (t instanceof String) return AY;
                if (typeof t == "string") return AY;
                if (t instanceof Number) return Q2;
                if (t && t.caml_custom) return HO;
                if (t && t.compare) return 1256;
                if (typeof t == "function") return 1247;
                if (typeof t == "symbol") return 1251;
              }
              return 1001;
            }
            function Ac(t, n) {
              return t < n ? -1 : t == n ? 0 : 1;
            }
            function DV(t, n) {
              return t.t & 6 && Dv(t), n.t & 6 && Dv(n), t.c < n.c ? -1 : t.c > n.c ? 1 : 0;
            }
            function Ee(t, n) {
              return DV(t, n);
            }
            function yp(t, n, e) {
              for (var i = []; ; ) {
                if (!(e && t === n)) {
                  var x = PV(t);
                  if (x == nl) {
                    t = t[1];
                    continue;
                  }
                  var c = PV(n);
                  if (c == nl) {
                    n = n[1];
                    continue;
                  }
                  if (x !== c) return x == Q2 ? c == HO ? CV(t, n, -1, e) : -1 : c == Q2 ? x == HO ? CV(n, t, 1, e) : 1 : x < c ? -1 : 1;
                  switch (x) {
                    case 247:
                      lu(gd);
                      break;
                    case 248:
                      var p = Ac(t[2], n[2]);
                      if (p != 0) return p | 0;
                      break;
                    case 249:
                      lu(gd);
                      break;
                    case 250:
                      lu("equal: got Forward_tag, should not happen");
                      break;
                    case 251:
                      lu("equal: abstract value");
                      break;
                    case 252:
                      if (t !== n) {
                        var p = DV(t, n);
                        if (p != 0) return p | 0;
                      }
                      break;
                    case 253:
                      lu("equal: got Double_tag, should not happen");
                      break;
                    case 254:
                      lu("equal: got Double_array_tag, should not happen");
                      break;
                    case 255:
                      lu("equal: got Custom_tag, should not happen");
                      break;
                    case 1247:
                      lu(gd);
                      break;
                    case 1255:
                      var s = BA(t);
                      if (s != BA(n)) return t.caml_custom < n.caml_custom ? -1 : 1;
                      s || lu("compare: abstract value");
                      var p = s(t, n, e);
                      if (p != p) return e ? -1 : p;
                      if (p !== (p | 0)) return -1;
                      if (p != 0) return p | 0;
                      break;
                    case 1256:
                      var p = t.compare(n, e);
                      if (p != p) return e ? -1 : p;
                      if (p !== (p | 0)) return -1;
                      if (p != 0) return p | 0;
                      break;
                    case 1e3:
                      if (t = +t, n = +n, t < n) return -1;
                      if (t > n) return 1;
                      if (t != n) {
                        if (!e) return NaN;
                        if (t == t) return 1;
                        if (n == n) return -1;
                      }
                      break;
                    case 1001:
                      if (t < n) return -1;
                      if (t > n) return 1;
                      if (t != n) {
                        if (!e) return NaN;
                        if (t == t) return 1;
                        if (n == n) return -1;
                      }
                      break;
                    case 1251:
                      if (t !== n) return e ? 1 : NaN;
                      break;
                    case 1252:
                      var t = Ic(t), n = Ic(n);
                      if (t !== n) {
                        if (t < n) return -1;
                        if (t > n) return 1;
                      }
                      break;
                    case 12520:
                      var t = t.toString(), n = n.toString();
                      if (t !== n) {
                        if (t < n) return -1;
                        if (t > n) return 1;
                      }
                      break;
                    case 246:
                    case 254:
                    default:
                      if (t.length != n.length) return t.length < n.length ? -1 : 1;
                      t.length > 1 && i.push(t, n, 1);
                      break;
                  }
                }
                if (i.length == 0) return 0;
                var y = i.pop();
                n = i.pop(), t = i.pop(), y + 1 < t.length && i.push(t, n, y + 1), t = t[y], n = n[y];
              }
            }
            function LV(t, n) {
              return yp(t, n, true);
            }
            function s70() {
              return [0];
            }
            function Lt(t) {
              return t < 0 && lu("Bytes.create"), new Oc(t ? 2 : 9, C, t);
            }
            function RV(t, n) {
              return +(yp(t, n, false) == 0);
            }
            function v70(t, n, e, i) {
              if (e > 0) if (n == 0 && (e >= t.l || t.t == 2 && e >= t.c.length)) i == 0 ? (t.c = C, t.t = 2) : (t.c = Pv(e, String.fromCharCode(i)), t.t = e == t.l ? 0 : 2);
              else for (t.t != 4 && bp(t), e += n; n < e; n++) t.c[n] = i;
              return 0;
            }
            function ol(t) {
              var n;
              if (t = Ic(t), n = +t, t.length > 0 && n === n || (t = t.replace(/_/g, C), n = +t, t.length > 0 && n === n || /^[+-]?nan$/i.test(t))) return n;
              var e = /^ *([+-]?)0x([0-9a-f]+)\.?([0-9a-f]*)p([+-]?[0-9]+)/i.exec(t);
              if (e) {
                var i = e[3].replace(/0+$/, C), x = parseInt(e[1] + e[2] + i, 16), c = (e[4] | 0) - 4 * i.length;
                return n = x * Math.pow(2, c), n;
              }
              if (/^\+?inf(inity)?$/i.test(t)) return 1 / 0;
              if (/^-inf(inity)?$/i.test(t)) return -1 / 0;
              n7("float_of_string");
            }
            function UA(t) {
              t = Ic(t);
              var n = t.length;
              n > 31 && lu("format_int: format too long");
              for (var e = { justify: xs, signstyle: Fa, filler: pi, alternate: false, base: 0, signedconv: false, width: 0, uppercase: false, sign: 1, prec: -1, conv: oY }, i = 0; i < n; i++) {
                var x = t.charAt(i);
                switch (x) {
                  case "-":
                    e.justify = Fa;
                    break;
                  case "+":
                  case " ":
                    e.signstyle = x;
                    break;
                  case "0":
                    e.filler = Zu;
                    break;
                  case "#":
                    e.alternate = true;
                    break;
                  case "1":
                  case "2":
                  case "3":
                  case "4":
                  case "5":
                  case "6":
                  case "7":
                  case "8":
                  case "9":
                    for (e.width = 0; x = t.charCodeAt(i) - 48, x >= 0 && x <= 9; ) e.width = e.width * 10 + x, i++;
                    i--;
                    break;
                  case ".":
                    for (e.prec = 0, i++; x = t.charCodeAt(i) - 48, x >= 0 && x <= 9; ) e.prec = e.prec * 10 + x, i++;
                    i--;
                  case "d":
                  case "i":
                    e.signedconv = true;
                  case "u":
                    e.base = 10;
                    break;
                  case "x":
                    e.base = 16;
                    break;
                  case "X":
                    e.base = 16, e.uppercase = true;
                    break;
                  case "o":
                    e.base = 8;
                    break;
                  case "e":
                  case "f":
                  case "g":
                    e.signedconv = true, e.conv = x;
                    break;
                  case "E":
                  case "F":
                  case "G":
                    e.signedconv = true, e.uppercase = true, e.conv = x.toLowerCase();
                    break;
                }
              }
              return e;
            }
            function HA(t, n) {
              t.uppercase && (n = n.toUpperCase());
              var e = n.length;
              t.signedconv && (t.sign < 0 || t.signstyle != Fa) && e++, t.alternate && (t.base == 8 && (e += 1), t.base == 16 && (e += 2));
              var i = C;
              if (t.justify == xs && t.filler == pi) for (var x = e; x < t.width; x++) i += pi;
              if (t.signedconv && (t.sign < 0 ? i += Fa : t.signstyle != Fa && (i += t.signstyle)), t.alternate && t.base == 8 && (i += Zu), t.alternate && t.base == 16 && (i += l1), t.justify == xs && t.filler == Zu) for (var x = e; x < t.width; x++) i += Zu;
              if (i += n, t.justify == Fa) for (var x = e; x < t.width; x++) i += pi;
              return r(i);
            }
            function XA(t, n) {
              function e(E, d) {
                if (Math.abs(E) < 1) return E.toFixed(d);
                var w = parseInt(E.toString().split(xs)[1]);
                return w > 20 ? (w -= 20, E /= Math.pow(10, w), E += new Array(w + 1).join(Zu), d > 0 && (E = E + Lo + new Array(d + 1).join(Zu)), E) : E.toFixed(d);
              }
              var i, x = UA(t), c = x.prec < 0 ? 6 : x.prec;
              if ((n < 0 || n == 0 && 1 / n == -1 / 0) && (x.sign = -1, n = -n), isNaN(n)) i = sw, x.filler = pi;
              else if (!isFinite(n)) i = "inf", x.filler = pi;
              else switch (x.conv) {
                case "e":
                  var i = n.toExponential(c), s = i.length;
                  i.charAt(s - 3) == ny && (i = i.slice(0, s - 1) + Zu + i.slice(s - 1));
                  break;
                case "f":
                  i = e(n, c);
                  break;
                case "g":
                  c = c || 1, i = n.toExponential(c - 1);
                  var p = i.indexOf(ny), y = +i.slice(p + 1);
                  if (y < -4 || n >= 1e21 || n.toFixed(0).length > c) {
                    for (var s = p - 1; i.charAt(s) == Zu; ) s--;
                    i.charAt(s) == Lo && s--, i = i.slice(0, s + 1) + i.slice(p), s = i.length, i.charAt(s - 3) == ny && (i = i.slice(0, s - 1) + Zu + i.slice(s - 1));
                    break;
                  } else {
                    var T = c;
                    if (y < 0) T -= y + 1, i = n.toFixed(T);
                    else for (; i = n.toFixed(T), i.length > c + 1; ) T--;
                    if (T) {
                      for (var s = i.length - 1; i.charAt(s) == Zu; ) s--;
                      i.charAt(s) == Lo && s--, i = i.slice(0, s + 1);
                    }
                  }
                  break;
              }
              return HA(x, i);
            }
            function hp(t, n) {
              if (Ic(t) == N2) return r(C + n);
              var e = UA(t);
              n < 0 && (e.signedconv ? (e.sign = -1, n = -n) : n >>>= 0);
              var i = n.toString(e.base);
              if (e.prec >= 0) {
                e.filler = pi;
                var x = e.prec - i.length;
                x > 0 && (i = Pv(x, Zu) + i);
              }
              return HA(e, i);
            }
            var jV = 0;
            function M7() {
              return jV++;
            }
            function l70() {
              return 0;
            }
            function GV() {
              return [0];
            }
            var dp = [];
            function Qe(t, n, e) {
              var i = t[1], x = dp[e];
              if (x === void 0) for (var c = dp.length; c < e; c++) dp[c] = 0;
              else if (i[x] === n) return i[x - 1];
              for (var s = 3, p = i[1] * 2 + 1, y; s < p; ) y = s + p >> 1 | 1, n < i[y + 1] ? p = y - 2 : s = y;
              return dp[e] = s + 1, n == i[s + 1] ? i[s] : 0;
            }
            function b70(t) {
              for (var n = C, e = n, i, x, c = 0, s = t.length; c < s; c++) {
                if (i = t.charCodeAt(c), i < Pi) {
                  for (var p = c + 1; p < s && (i = t.charCodeAt(p)) < Pi; p++) ;
                  if (p - c > II ? (e.substr(0, 1), n += e, e = C, n += t.slice(c, p)) : e += t.slice(c, p), p == s) break;
                  c = p;
                }
                i < YX ? (e += String.fromCharCode(192 | i >> 6), e += String.fromCharCode(Pi | i & Ov)) : i < 55296 || i >= SH ? e += String.fromCharCode(HY | i >> 12, Pi | i >> 6 & Ov, Pi | i & Ov) : i >= 56319 || c + 1 == s || (x = t.charCodeAt(c + 1)) < NH || x > SH ? e += "\xEF\xBF\xBD" : (c++, i = (i << 10) + x - 56613888, e += String.fromCharCode(LX | i >> 18, Pi | i >> 12 & Ov, Pi | i >> 6 & Ov, Pi | i & Ov)), e.length > L2 && (e.substr(0, 1), n += e, e = C);
              }
              return n + e;
            }
            function p70(t) {
              var n = 9;
              return _V(t) || (n = 8, t = b70(t)), new Oc(n, t, t.length);
            }
            function B7(t) {
              return p70(t);
            }
            function m70(t, n, e) {
              if (!isFinite(t)) return isNaN(t) ? B7(sw) : B7(t > 0 ? mU : "-infinity");
              var i = t == 0 && 1 / t == -1 / 0 ? 1 : t >= 0 ? 0 : 1;
              i && (t = -t);
              var x = 0;
              if (t != 0) if (t < 1) for (; t < 1 && x > -BX; ) t *= 2, x--;
              else for (; t >= 2; ) t /= 2, x++;
              var c = x < 0 ? C : xs, s = C;
              if (i) s = Fa;
              else switch (e) {
                case 43:
                  s = xs;
                  break;
                case 32:
                  s = pi;
                  break;
                default:
                  break;
              }
              if (n >= 0 && n < 13) {
                var p = Math.pow(2, n * 4);
                t = Math.round(t * p) / p;
              }
              var y = t.toString(16);
              if (n >= 0) {
                var T = y.indexOf(Lo);
                if (T < 0) y += Lo + Pv(n, Zu);
                else {
                  var E = T + 1 + n;
                  y.length < E ? y += Pv(E - y.length, Zu) : y = y.substr(0, E);
                }
              }
              return B7(s + l1 + y + "p" + c + x.toString(10));
            }
            function _70(t) {
              return +t.isZero();
            }
            function kp(t) {
              return new sn(t & Ex, t >> 24 & Ex, t >> 31 & Li);
            }
            function y70(t) {
              return t.toInt();
            }
            function h70(t) {
              return +t.isNeg();
            }
            function MV(t) {
              return t.neg();
            }
            function d70(t, n) {
              var e = UA(t);
              e.signedconv && h70(n) && (e.sign = -1, n = MV(n));
              var i = C, x = kp(e.base), c = "0123456789abcdef";
              do {
                var s = n.udivmod(x);
                n = s.quotient, i = c.charAt(y70(s.modulus)) + i;
              } while (!_70(n));
              if (e.prec >= 0) {
                e.filler = pi;
                var p = e.prec - i.length;
                p > 0 && (i = Pv(p, Zu) + i);
              }
              return HA(e, i);
            }
            function b7(t) {
              return t.l;
            }
            function un(t) {
              return b7(t);
            }
            function Vr(t, n) {
              return Xu(t, n);
            }
            function k70(t, n) {
              return t.add(n);
            }
            function w70(t, n) {
              return t.mul(n);
            }
            function YA(t, n) {
              return t.ucompare(n) < 0;
            }
            function BV(t) {
              var n = 0, e = un(t), i = 10, x = 1;
              if (e > 0) switch (Vr(t, n)) {
                case 45:
                  n++, x = -1;
                  break;
                case 43:
                  n++, x = 1;
                  break;
              }
              if (n + 1 < e && Vr(t, n) == 48) switch (Vr(t, n + 1)) {
                case 120:
                case 88:
                  i = 16, n += 2;
                  break;
                case 111:
                case 79:
                  i = 8, n += 2;
                  break;
                case 98:
                case 66:
                  i = 2, n += 2;
                  break;
                case 117:
                case 85:
                  n += 2;
                  break;
              }
              return [n, x, i];
            }
            function wp(t) {
              return t >= 48 && t <= 57 ? t - 48 : t >= 65 && t <= 90 ? t - 55 : t >= 97 && t <= In ? t - 87 : -1;
            }
            function Rv(t) {
              var n = BV(t), e = n[0], i = n[1], x = n[2], c = kp(x), s = new sn(Ex, 268435455, Li).udivmod(c).quotient, p = Vr(t, e), y = wp(p);
              (y < 0 || y >= x) && n7(ns);
              for (var T = kp(y); ; ) if (e++, p = Vr(t, e), p != 95) {
                if (y = wp(p), y < 0 || y >= x) break;
                YA(s, T) && n7(ns), y = kp(y), T = k70(w70(c, T), y), YA(T, y) && n7(ns);
              }
              return e != un(t) && n7(ns), x == 10 && YA(new sn(0, 0, Mi), T) && n7(ns), i < 0 && (T = MV(T)), T;
            }
            function jv(t) {
              return t.toFloat();
            }
            function Bi(t) {
              var n = BV(t), e = n[0], i = n[1], x = n[2], c = un(t), s = -1 >>> 0, p = e < c ? Vr(t, e) : 0, y = wp(p);
              (y < 0 || y >= x) && n7(ns);
              var T = y;
              for (e++; e < c; e++) if (p = Vr(t, e), p != 95) {
                if (y = wp(p), y < 0 || y >= x) break;
                T = x * T + y, T > s && n7(ns);
              }
              return e != c && n7(ns), T = i * T, x == 10 && (T | 0) != T && n7(ns), T | 0;
            }
            function E70(t) {
              return t.slice(1);
            }
            function S70(t) {
              return !!t;
            }
            function bn(t) {
              return t.toUtf16();
            }
            function g70(t) {
              for (var n = {}, e = 1; e < t.length; e++) {
                var i = t[e];
                n[bn(i[1])] = i[2];
              }
              return n;
            }
            function F70(t, n) {
              return +(yp(t, n, false) < 0);
            }
            function Gv(e, n) {
              e < 0 && il();
              var e = e + 1 | 0, i = new Array(e);
              i[0] = 0;
              for (var x = 1; x < e; x++) i[x] = n;
              return i;
            }
            function T70() {
              return 0;
            }
            function at(t) {
              PA(zt.Sys_error, t);
            }
            var Nc = new Array();
            function p1(t) {
              var n = Nc[t];
              if (n.opened || at("Cannot flush a closed channel"), !n.buffer || n.buffer == C) return 0;
              if (n.fd && zt.fds[n.fd] && zt.fds[n.fd].output) {
                var e = zt.fds[n.fd].output;
                switch (e.length) {
                  case 2:
                    e(t, n.buffer);
                    break;
                  default:
                    e(n.buffer);
                }
              }
              return n.buffer = C, 0;
            }
            function qV() {
              return typeof z0.process < "u" && typeof z0.process.versions < "u" && typeof z0.process.versions.node < "u" && z0.process.platform !== "browser";
            }
            function O70() {
              function t(e) {
                if (e.charAt(0) === Qu) return [C, e.substring(1)];
              }
              function n(e) {
                var i = /^([a-zA-Z]:|[\\/]{2}[^\\/]+[\\/]+[^\\/]+)?([\\/])?([\s\S]*?)$/, x = i.exec(e), c = x[1] || C, s = Boolean(c && c.charAt(1) !== o1);
                if (Boolean(x[2] || s)) {
                  var p = x[1] || C, y = x[2] || C;
                  return [p, e.substring(p.length + y.length)];
                }
              }
              return z0.process && z0.process.platform && z0.process.platform === aV ? n : t;
            }
            var VA = O70();
            function UV(t) {
              return t.slice(-1) !== Qu ? t + Qu : t;
            }
            if (z0.process && z0.process.cwd) var al = z0.process.cwd().replace(/\\/g, Qu);
            else var al = "/static";
            al = UV(al);
            function I70(t) {
              t = bn(t), VA(t) || (t = al + t);
              for (var n = VA(t), e = n[1].split(Qu), i = [], x = 0; x < e.length; x++) switch (e[x]) {
                case "..":
                  i.length > 1 && i.pop();
                  break;
                case ".":
                  break;
                default:
                  i.push(e[x]);
                  break;
              }
              return i.unshift(n[0]), i.orig = t, i;
            }
            var A70 = ["E2BIG", "EACCES", "EAGAIN", "EBADF", "EBUSY", "ECHILD", "EDEADLK", "EDOM", nV, "EFAULT", "EFBIG", "EINTR", "EINVAL", "EIO", "EISDIR", "EMFILE", "EMLINK", "ENAMETOOLONG", "ENFILE", "ENODEV", vh, "ENOEXEC", "ENOLCK", "ENOMEM", "ENOSPC", "ENOSYS", yw, PU, "ENOTTY", "ENXIO", "EPERM", "EPIPE", "ERANGE", "EROFS", "ESPIPE", "ESRCH", "EXDEV", "EWOULDBLOCK", "EINPROGRESS", "EALREADY", "ENOTSOCK", "EDESTADDRREQ", "EMSGSIZE", "EPROTOTYPE", "ENOPROTOOPT", "EPROTONOSUPPORT", "ESOCKTNOSUPPORT", "EOPNOTSUPP", "EPFNOSUPPORT", "EAFNOSUPPORT", "EADDRINUSE", "EADDRNOTAVAIL", "ENETDOWN", "ENETUNREACH", "ENETRESET", "ECONNABORTED", "ECONNRESET", "ENOBUFS", "EISCONN", "ENOTCONN", "ESHUTDOWN", "ETOOMANYREFS", "ETIMEDOUT", "ECONNREFUSED", "EHOSTDOWN", "EHOSTUNREACH", "ELOOP", "EOVERFLOW"];
            function m1(t, n, e, i) {
              var x = A70.indexOf(t);
              x < 0 && (i == null && (i = -9999), x = [0, i]);
              var c = [x, B7(n || C), B7(e || C)];
              return c;
            }
            var HV = {};
            function _1(t) {
              return HV[t];
            }
            function y1(t, n) {
              throw [0, t].concat(n);
            }
            function N70(t) {
              return new Oc(4, t, t.length);
            }
            function C70(t) {
              t = Ic(t), at(t + tp);
            }
            function P70(t, n) {
              return n >>> 0 >= t.l && hV(), Xu(t, n);
            }
            function XV() {
            }
            function gu(t) {
              this.data = t;
            }
            gu.prototype = new XV(), gu.prototype.truncate = function(t) {
              var n = this.data;
              this.data = Lt(t | 0), Fs(n, 0, this.data, 0, t);
            }, gu.prototype.length = function() {
              return b7(this.data);
            }, gu.prototype.write = function(t, n, e, i) {
              var x = this.length();
              if (t + i >= x) {
                var c = Lt(t + i), s = this.data;
                this.data = c, Fs(s, 0, this.data, 0, x);
              }
              return Ts(n, e, this.data, t, i), 0;
            }, gu.prototype.read = function(t, n, e, i) {
              var x = this.length();
              return Fs(this.data, t, n, e, i), 0;
            }, gu.prototype.read_one = function(t) {
              return P70(this.data, t);
            }, gu.prototype.close = function() {
            }, gu.prototype.constructor = gu;
            function t7(t, n) {
              this.content = {}, this.root = t, this.lookupFun = n;
            }
            t7.prototype.nm = function(t) {
              return this.root + t;
            }, t7.prototype.create_dir_if_needed = function(t) {
              for (var n = t.split(Qu), e = C, i = 0; i < n.length - 1; i++) e += n[i] + Qu, !this.content[e] && (this.content[e] = Symbol("directory"));
            }, t7.prototype.slash = function(t) {
              return /\/$/.test(t) ? t : t + Qu;
            }, t7.prototype.lookup = function(t) {
              if (!this.content[t] && this.lookupFun) {
                var n = this.lookupFun(r(this.root), r(t));
                n !== 0 && (this.create_dir_if_needed(t), this.content[t] = new gu(n[1]));
              }
            }, t7.prototype.exists = function(t) {
              if (t == C) return 1;
              var n = this.slash(t);
              return this.content[n] ? 1 : (this.lookup(t), this.content[t] ? 1 : 0);
            }, t7.prototype.mkdir = function(t, n, e) {
              var i = e && _1(Kh);
              this.exists(t) && (i ? y1(i, m1(nV, WI, this.nm(t))) : at(t + ": File exists"));
              var x = /^(.*)\/[^/]+/.exec(t);
              x = x && x[1] || C, this.exists(x) || (i ? y1(i, m1(vh, WI, this.nm(x))) : at(x + tp)), this.is_dir(x) || (i ? y1(i, m1(yw, WI, this.nm(x))) : at(x + RS)), this.create_dir_if_needed(this.slash(t));
            }, t7.prototype.rmdir = function(t, n) {
              var e = n && _1(Kh), i = t == C ? C : this.slash(t), x = new RegExp(I6 + i + JX);
              this.exists(t) || (e ? y1(e, m1(vh, ad, this.nm(t))) : at(t + tp)), this.is_dir(t) || (e ? y1(e, m1(yw, ad, this.nm(t))) : at(t + RS));
              for (var c in this.content) c.match(x) && (e ? y1(e, m1(PU, ad, this.nm(t))) : at(this.nm(t) + ": Directory not empty"));
              delete this.content[i];
            }, t7.prototype.readdir = function(t) {
              var n = t == C ? C : this.slash(t);
              this.exists(t) || at(t + tp), this.is_dir(t) || at(t + RS);
              var e = new RegExp(I6 + n + JX), i = {}, x = [];
              for (var c in this.content) {
                var s = c.match(e);
                s && !i[s[1]] && (i[s[1]] = true, x.push(s[1]));
              }
              return x;
            }, t7.prototype.is_dir = function(t) {
              if (t == C) return true;
              var n = this.slash(t);
              return this.content[n] ? 1 : 0;
            }, t7.prototype.unlink = function(t) {
              var n = !!this.content[t];
              return delete this.content[t], n;
            }, t7.prototype.open = function(t, n) {
              if (n.rdonly && n.wronly && at(this.nm(t) + FY), n.text && n.binary && at(this.nm(t) + tY), this.lookup(t), this.content[t]) {
                this.is_dir(t) && at(this.nm(t) + " : is a directory"), n.create && n.excl && at(this.nm(t) + TY);
                var e = this.content[t];
                return n.truncate && e.truncate(), e;
              } else {
                if (n.create) return this.create_dir_if_needed(t), this.content[t] = new gu(Lt(0)), this.content[t];
                C70(this.nm(t));
              }
            }, t7.prototype.register = function(t, n) {
              var e;
              if (this.content[t] && at(this.nm(t) + TY), _p(n) && (e = new gu(n)), qA(n)) e = new gu(n);
              else if (n instanceof Array) e = new gu(N70(n));
              else if (typeof n == "string") e = new gu(yV(n));
              else if (n.toString) {
                var i = B7(n.toString());
                e = new gu(i);
              }
              e ? (this.create_dir_if_needed(t), this.content[t] = e) : at(this.nm(t) + " : registering file with invalid content type");
            }, t7.prototype.constructor = t7;
            function D70(t) {
              for (var n = un(t), e = new Array(n), i = 0; i < n; i++) e[i] = Vr(t, i);
              return e;
            }
            function L70(t) {
              return t.t != 4 && bp(t), t.c;
            }
            function Cc(t) {
              this.fs = kj(), this.fd = t;
            }
            Cc.prototype = new XV(), Cc.prototype.truncate = function(t) {
              try {
                this.fs.ftruncateSync(this.fd, t | 0);
              } catch (n) {
                at(n.toString());
              }
            }, Cc.prototype.length = function() {
              try {
                return this.fs.fstatSync(this.fd).size;
              } catch (t) {
                at(t.toString());
              }
            }, Cc.prototype.write = function(t, n, e, i) {
              var x = D70(n);
              x instanceof z0.Uint8Array || (x = new z0.Uint8Array(x));
              var c = z0.Buffer.from(x);
              try {
                this.fs.writeSync(this.fd, c, e, i, t);
              } catch (s) {
                at(s.toString());
              }
              return 0;
            }, Cc.prototype.read = function(t, n, e, i) {
              var x = L70(n);
              x instanceof z0.Uint8Array || (x = new z0.Uint8Array(x));
              var c = z0.Buffer.from(x);
              try {
                this.fs.readSync(this.fd, c, e, i, t);
              } catch (p) {
                at(p.toString());
              }
              for (var s = 0; s < i; s++) b1(n, e + s, c[e + s]);
              return 0;
            }, Cc.prototype.read_one = function(t) {
              var n = new z0.Uint8Array(1), e = z0.Buffer.from(n);
              try {
                this.fs.readSync(this.fd, e, 0, 1, t);
              } catch (i) {
                at(i.toString());
              }
              return e[0];
            }, Cc.prototype.close = function() {
              try {
                this.fs.closeSync(this.fd);
              } catch (t) {
                at(t.toString());
              }
            }, Cc.prototype.constructor = Cc;
            function Fu(t) {
              this.fs = kj(), this.root = t;
            }
            Fu.prototype.nm = function(t) {
              return this.root + t;
            }, Fu.prototype.exists = function(t) {
              try {
                return this.fs.existsSync(this.nm(t)) ? 1 : 0;
              } catch {
                return 0;
              }
            }, Fu.prototype.mkdir = function(t, n, e) {
              try {
                return this.fs.mkdirSync(this.nm(t), { mode: n }), 0;
              } catch (i) {
                this.raise_nodejs_error(i, e);
              }
            }, Fu.prototype.rmdir = function(t, n) {
              try {
                return this.fs.rmdirSync(this.nm(t)), 0;
              } catch (e) {
                this.raise_nodejs_error(e, n);
              }
            }, Fu.prototype.readdir = function(t, n) {
              try {
                return this.fs.readdirSync(this.nm(t));
              } catch (e) {
                this.raise_nodejs_error(e, n);
              }
            }, Fu.prototype.is_dir = function(t) {
              try {
                return this.fs.statSync(this.nm(t)).isDirectory() ? 1 : 0;
              } catch (n) {
                at(n.toString());
              }
            }, Fu.prototype.unlink = function(t, n) {
              try {
                var e = this.fs.existsSync(this.nm(t)) ? 1 : 0;
                return this.fs.unlinkSync(this.nm(t)), e;
              } catch (i) {
                this.raise_nodejs_error(i, n);
              }
            }, Fu.prototype.open = function(t, n, e) {
              var i = noe(), x = 0;
              for (var c in n) switch (c) {
                case "rdonly":
                  x |= i.O_RDONLY;
                  break;
                case "wronly":
                  x |= i.O_WRONLY;
                  break;
                case "append":
                  x |= i.O_WRONLY | i.O_APPEND;
                  break;
                case "create":
                  x |= i.O_CREAT;
                  break;
                case "truncate":
                  x |= i.O_TRUNC;
                  break;
                case "excl":
                  x |= i.O_EXCL;
                  break;
                case "binary":
                  x |= i.O_BINARY;
                  break;
                case "text":
                  x |= i.O_TEXT;
                  break;
                case "nonblock":
                  x |= i.O_NONBLOCK;
                  break;
              }
              try {
                var s = this.fs.openSync(this.nm(t), x);
                return new Cc(s);
              } catch (p) {
                this.raise_nodejs_error(p, e);
              }
            }, Fu.prototype.rename = function(t, n, e) {
              try {
                this.fs.renameSync(this.nm(t), this.nm(n));
              } catch (i) {
                this.raise_nodejs_error(i, e);
              }
            }, Fu.prototype.stat = function(t, n) {
              try {
                var e = this.fs.statSync(this.nm(t));
                return this.stats_from_js(e);
              } catch (i) {
                this.raise_nodejs_error(i, n);
              }
            }, Fu.prototype.lstat = function(t, n) {
              try {
                var e = this.fs.lstatSync(this.nm(t));
                return this.stats_from_js(e);
              } catch (i) {
                this.raise_nodejs_error(i, n);
              }
            }, Fu.prototype.symlink = function(t, n, e, i) {
              try {
                return this.fs.symlinkSync(this.nm(n), this.nm(e), t ? "dir" : "file"), 0;
              } catch (x) {
                this.raise_nodejs_error(x, i);
              }
            }, Fu.prototype.readlink = function(t, n) {
              try {
                var e = this.fs.readlinkSync(this.nm(t), vV);
                return B7(e);
              } catch (i) {
                this.raise_nodejs_error(i, n);
              }
            }, Fu.prototype.raise_nodejs_error = function(t, n) {
              var e = _1(Kh);
              if (n && e) {
                var i = m1(t.code, t.syscall, t.path, t.errno);
                y1(e, i);
              } else at(t.toString());
            }, Fu.prototype.stats_from_js = function(t) {
              var n;
              return t.isFile() ? n = 0 : t.isDirectory() ? n = 1 : t.isCharacterDevice() ? n = 2 : t.isBlockDevice() ? n = 3 : t.isSymbolicLink() ? n = 4 : t.isFIFO() ? n = 5 : t.isSocket() && (n = 6), [0, t.dev, t.ino, n, t.mode, t.nlink, t.uid, t.gid, t.rdev, t.size, t.atimeMs, t.mtimeMs, t.ctimeMs];
            }, Fu.prototype.constructor = Fu;
            function YV(t) {
              var n = VA(t);
              if (!!n) return n[0] + Qu;
            }
            var Ep = YV(al) || n7("unable to compute caml_root"), Mv = [];
            qV() ? Mv.push({ path: Ep, device: new Fu(Ep) }) : Mv.push({ path: Ep, device: new t7(Ep) }), Mv.push({ path: zU, device: new t7(zU) });
            function R70(e) {
              for (var n = I70(e), e = n.join(Qu), i = UV(e), x, c = 0; c < Mv.length; c++) {
                var s = Mv[c];
                i.search(s.path) == 0 && (!x || x.path.length < s.path.length) && (x = { path: s.path, device: s.device, rest: e.substring(s.path.length, e.length) });
              }
              if (!x) {
                var p = YV(e);
                if (p && p.match(/^[a-zA-Z]:\/$/)) {
                  var s = { path: p, device: new Fu(p) };
                  Mv.push(s), x = { path: s.path, device: s.device, rest: e.substring(s.path.length, e.length) };
                }
              }
              if (x) return x;
              at("no device found for " + i);
            }
            function VV(t, n) {
              var e = Nc[t], i = r(n), x = un(i);
              return e.file.write(e.offset, i, 0, x), e.offset += x, 0;
            }
            function j70(n) {
              var n = CA(n), e = z0;
              if (e.process && e.process.stdout && e.process.stdout.write) e.process.stderr.write(n);
              else {
                n.charCodeAt(n.length - 1) == 10 && (n = n.substr(0, n.length - 1));
                var i = e.console;
                i && i.error && i.error(n);
              }
            }
            function G70(n) {
              var n = CA(n), e = z0;
              if (e.process && e.process.stdout && e.process.stdout.write) e.process.stdout.write(n);
              else {
                n.charCodeAt(n.length - 1) == 10 && (n = n.substr(0, n.length - 1));
                var i = e.console;
                i && i.log && i.log(n);
              }
            }
            function Sp(t, n, e, i) {
              zt.fds === void 0 && (zt.fds = new Array()), i = i || {};
              var x = {};
              return x.file = e, x.offset = i.append ? e.length() : 0, x.flags = i, x.output = n, zt.fds[t] = x, (!zt.fd_last_idx || t > zt.fd_last_idx) && (zt.fd_last_idx = t), t;
            }
            function loe(t, n, e) {
              for (var i = {}; n; ) {
                switch (n[1]) {
                  case 0:
                    i.rdonly = 1;
                    break;
                  case 1:
                    i.wronly = 1;
                    break;
                  case 2:
                    i.append = 1;
                    break;
                  case 3:
                    i.create = 1;
                    break;
                  case 4:
                    i.truncate = 1;
                    break;
                  case 5:
                    i.excl = 1;
                    break;
                  case 6:
                    i.binary = 1;
                    break;
                  case 7:
                    i.text = 1;
                    break;
                  case 8:
                    i.nonblock = 1;
                    break;
                }
                n = n[2];
              }
              i.rdonly && i.wronly && at(Ic(t) + FY), i.text && i.binary && at(Ic(t) + tY);
              var x = R70(t), c = x.device.open(x.rest, i), s = zt.fd_last_idx ? zt.fd_last_idx : 0;
              return Sp(s + 1, VV, c, i);
            }
            Sp(0, VV, new gu(Lt(0))), Sp(1, G70, new gu(Lt(0))), Sp(2, j70, new gu(Lt(0)));
            function M70(t) {
              var n = zt.fds[t];
              n.flags.wronly && at(pX + t + " is writeonly");
              var e = null;
              if (t == 0 && qV()) {
                var i = kj();
                e = function() {
                  return B7(i.readFileSync(0, vV));
                };
              }
              var x = { file: n.file, offset: n.offset, fd: t, opened: true, out: false, refill: e };
              return Nc[x.fd] = x, x.fd;
            }
            function zV(t) {
              var n = zt.fds[t];
              n.flags.rdonly && at(pX + t + " is readonly");
              var e = { file: n.file, offset: n.offset, fd: t, opened: true, out: true, buffer: C };
              return Nc[e.fd] = e, e.fd;
            }
            function B70() {
              for (var t = 0, n = 0; n < Nc.length; n++) Nc[n] && Nc[n].opened && Nc[n].out && (t = [0, Nc[n].fd, t]);
              return t;
            }
            function boe(t) {
              return t;
            }
            function q70(t, n, e, i) {
              var x = Nc[t];
              x.opened || at("Cannot output to a closed channel");
              var c;
              e == 0 && b7(n) == i ? c = n : (c = Lt(i), Fs(n, e, c, 0, i));
              var s = c, p = Ic(s), y = p.lastIndexOf($Y);
              return y < 0 ? x.buffer += p : (x.buffer += p.substr(0, y + 1), p1(t), x.buffer += p.substr(y + 1)), 0;
            }
            function zA(t, n, e, i) {
              return q70(t, n, e, i);
            }
            function KV(t, n) {
              var e = r(String.fromCharCode(n));
              return zA(t, e, 0, 1), 0;
            }
            function cl(t, n) {
              return +(yp(t, n, false) != 0);
            }
            function KA(t, n) {
              var e = new Array(n + 1);
              e[0] = t;
              for (var i = 1; i <= n; i++) e[i] = 0;
              return e;
            }
            function U70(t, n) {
              return t[0] = nl, t[1] = n, 0;
            }
            function h1(t) {
              return t instanceof Array && t[0] == t[0] >>> 0 ? t[0] : _p(t) || qA(t) ? Y2 : t instanceof Function || typeof t == "function" ? Dw : t && t.caml_custom ? gw : Q2;
            }
            function hi(t, n, e) {
              e && z0.toplevelReloc && (t = z0.toplevelReloc(e)), zt[t + 1] = n, e && (zt[e] = n);
            }
            function WA(t, n) {
              return HV[Ic(t)] = n, 0;
            }
            function H70(t) {
              return t[2] = jV++, t;
            }
            function X70(t, n) {
              return t === n ? 1 : (t.t & 6 && Dv(t), n.t & 6 && Dv(n), t.c == n.c ? 1 : 0);
            }
            function qn(t, n) {
              return X70(t, n);
            }
            function Y70() {
              lu(qS);
            }
            function It(t, n) {
              return n >>> 0 >= un(t) && Y70(), Vr(t, n);
            }
            function n0(t, n) {
              return 1 - qn(t, n);
            }
            function V70() {
              return [0, r("js_of_ocaml")];
            }
            function z70() {
              return 2147483647 / 4 | 0;
            }
            function K70(t) {
              return 0;
            }
            var W70 = z0.process && z0.process.platform && z0.process.platform == aV ? jU : "Unix";
            function J70() {
              return [0, r(W70), 32, 0];
            }
            function $70() {
              kV(zt.Not_found);
            }
            function WV(t) {
              var n = z0, e = bn(t);
              if (n.process && n.process.env && n.process.env[e] != null) return B7(n.process.env[e]);
              if (z0.jsoo_static_env && z0.jsoo_static_env[e]) return B7(z0.jsoo_static_env[e]);
              $70();
            }
            function JA(t) {
              for (var n = 1; t && t.joo_tramp; ) t = t.joo_tramp.apply(null, t.joo_args), n++;
              return t;
            }
            function Tu(t, n) {
              return { joo_tramp: t, joo_args: n };
            }
            function N(t, n) {
              if (typeof n == "function") return t.fun = n, 0;
              if (n.fun) return t.fun = n.fun, 0;
              for (var e = n.length; e--; ) t[e] = n[e];
              return 0;
            }
            function poe(t) {
              return t;
            }
            function Et(t) {
              return t instanceof Array ? t : z0.RangeError && t instanceof z0.RangeError && t.message && t.message.match(/maximum call stack/i) || z0.InternalError && t instanceof z0.InternalError && t.message && t.message.match(/too much recursion/i) ? zt.Stack_overflow : t instanceof z0.Error && _1(KO) ? [0, _1(KO), t] : [0, zt.Failure, B7(String(t))];
            }
            function Z70(t) {
              switch (t[2]) {
                case -8:
                case -11:
                case -12:
                  return 1;
                default:
                  return 0;
              }
            }
            function Q70(t) {
              var n = C;
              if (t[0] == 0) {
                if (n += t[1][1], t.length == 3 && t[2][0] == 0 && Z70(t[1])) var i = t[2], e = 1;
                else var e = 2, i = t;
                n += HX;
                for (var x = e; x < i.length; x++) {
                  x > e && (n += $H);
                  var c = i[x];
                  typeof c == "number" ? n += c.toString() : c instanceof Oc || typeof c == "string" ? n += V2 + c.toString() + V2 : n += bv;
                }
                n += Z0;
              } else t[0] == wt && (n += t[1]);
              return n;
            }
            function JV(t) {
              if (t instanceof Array && (t[0] == 0 || t[0] == wt)) {
                var n = _1(LH);
                if (n) n(t, false);
                else {
                  var e = Q70(t), i = _1(sV);
                  i && i(0), z0.console.error(yd + e + $Y);
                }
              } else throw t;
            }
            function ri0() {
              var t = z0;
              t.process && t.process.on ? t.process.on("uncaughtException", function(n, e) {
                JV(n), t.process.exit(2);
              }) : t.addEventListener && t.addEventListener("error", function(n) {
                n.error && JV(n.error);
              });
            }
            ri0();
            function u(t, n) {
              return t.length == 1 ? t(n) : os(t, [n]);
            }
            function o(t, n, e) {
              return t.length == 2 ? t(n, e) : os(t, [n, e]);
            }
            function ur(t, n, e, i) {
              return t.length == 3 ? t(n, e, i) : os(t, [n, e, i]);
            }
            function R(t, n, e, i, x) {
              return t.length == 4 ? t(n, e, i, x) : os(t, [n, e, i, x]);
            }
            function p7(t, n, e, i, x, c) {
              return t.length == 5 ? t(n, e, i, x, c) : os(t, [n, e, i, x, c]);
            }
            function ei0(t, n, e, i, x, c, s, p) {
              return t.length == 7 ? t(n, e, i, x, c, s, p) : os(t, [n, e, i, x, c, s, p]);
            }
            var $A = [wt, r(wX), -1], $V = [wt, r(DH), -2], q7 = [wt, r(AH), -3], ZA = [wt, r(fH), -4], Jt = [wt, r(KU), -7], ZV = [wt, r(LY), -8], QV = [wt, r(VU), -9], Sn = [wt, r(wU), -11], sl = [wt, r(uX), -12], rz = [0, s7], ni0 = [4, 0, 0, 0, [12, 45, [4, 0, 0, 0, 0]]], QA = [0, [11, r('File "'), [2, 0, [11, r('", line '), [4, 0, 0, 0, [11, r(yH), [4, 0, 0, 0, [12, 45, [4, 0, 0, 0, [11, r(": "), [2, 0, 0]]]]]]]]]], r('File "%s", line %d, characters %d-%d: %s')], ez = [0, 0, [0, 0, 0], [0, 0, 0]], rN = r(""), eN = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), Bv = [0, 0, 0, 0, 1, 0], nz = [0, r(Rx), r(co), r(Ea), r(ca), r(Vo), r(Hf), r(Kx), r(lf), r(xf), r(Gx), r(Tn), r(Ha), r(A7), r(Tf), r(lx), r(po), r(sx), r(Qi), r(Ef), r(Ua), r(oa), r(qa), r(mf), r(tc), r(Df), r(ga), r(tf), r(kf), r(Ga), r(Uf), r(gx), r(fx), r(go), r(hf), r(_o), r($f), r(xa), r($o), r(N7), r(I7), r(xx), r(Ta), r(ja), r(zf), r(na), r(so), r(Fo), r(wx), r(Ra), r(ho), r(v7), r(la), r(ra), r(sa), r(qx), r(Ho), r(Bx), r(jf), r(If), r(Za), r(jx), r(Af), r(vo), r(Sa), r(sf), r(Qa), r(ua), r(ea), r(Nu), r(Tx), r(eo), r(Sf), r(Bf), r(ka), r(Mx), r(Fc), r(Xa), r(La), r(yx), r(ic), r(li), r(So), r(lo), r(Tc), r(Ia), r(hx), r(Ix), r(gc), r(Lf), r(nf), r(tx), r(_a), r(Go), r(kx), r(Ba), r(vf), r(ba), r(mx), r(G7), r(Wa), r(bc), r(Vf), r(yi), r(pf), r(ia), r(Ya), r(Uu), r(Ec), r(bo), r(Hx), r(Ca), r(Fx), r(Aa), r(e7), r(af), r(ko), r(ro), r(za), r(Rf), r(ac), r(ya), r(Wo), r(Qf), r(of), r(ff), r(Ax), r(pc), r(Ao), r(jo), r(io), r(Ox), r(ao), r(Nx), r(rf), r(rc), r(Ko), r(Da), r(wc), r(Jo), r(vx), r(hc), r(Px), r(ha), r(Dx), r(nx), r(zx), r(Pa), r(Ux), r(Wx), r(_c), r(xr), r(mc), r(Of), r(yf), r(bx), r(qo), r(Lx), r(gf), r(nc), r(Kf), r(da), r(ma), r(ex), r(Xf), r(uf), r(Nf), r(ix), r(oo), r(Zo), r(fc), r(lc), r(Xo), r(Va), r(df), r(Mo), r(Qo), r(mi), r(rx), r(Zf), r(zo), r(bf), r(va), r(vc), r(kc), r(Wf), r(Yf), r(Bo), r(Cf), r(ta), r(aa), r(sc), r(Zx), r(wa), r(Yo), r($a), r(r7), r(De), r(pa), r(px), r(Ju), r(cx), r(Mf), r(Sc), r(_f), r(Vx), r(Sx), r(Na), r(yc), r(D7), r(yo), r(Uo), r(Jf), r($x), r(wo), r(Pf), r(Io), r(F7), r(no), r(fa), r(xo), r(_x), r(Jx), r(Xx), r(Ka), r(Ro), r(qf), r(Oa), r(ax), r(Ff), r(Cx), r(uo), r(Ja), r(wf), r(No), r(ec), r(Po), r(To), r(Gf), r(oc), r(ux), r(dc), r(cu), r(Oo), r(to), r(Yx), r(Eu)], tz = [0, r("first_leading"), r("last_trailing")], uz = [0, 0];
            hi(11, sl, uX), hi(10, Sn, wU), hi(9, [wt, r(dY), CX], dY), hi(8, QV, VU), hi(7, ZV, LY), hi(6, Jt, KU), hi(5, [wt, r(rY), -6], rY), hi(4, [wt, r(IH), -5], IH), hi(3, ZA, fH), hi(2, q7, AH), hi(1, $V, DH), hi(0, $A, wX);
            var ti0 = r("output_substring"), ui0 = r("%.12g"), ii0 = r(Lo), fi0 = r(Gi), xi0 = r(Ci), oi0 = r(uY), ai0 = r("\\'"), ci0 = r("\\b"), si0 = r("\\t"), vi0 = r("\\n"), li0 = r("\\r"), bi0 = r("List.iter2"), pi0 = r("tl"), mi0 = r("hd"), _i0 = r("String.blit / Bytes.blit_string"), yi0 = r("Bytes.blit"), hi0 = r("String.sub / Bytes.sub"), di0 = r("Array.blit"), ki0 = r("Array.sub"), wi0 = r("Map.remove_min_elt"), Ei0 = [0, 0, 0, 0], Si0 = [0, r("map.ml"), 400, 10], gi0 = [0, 0, 0], Fi0 = r(e6), Ti0 = r(e6), Oi0 = r(e6), Ii0 = r(e6), Ai0 = r("Stdlib.Queue.Empty"), Ni0 = r("CamlinternalLazy.Undefined"), Ci0 = r("Buffer.add_substring/add_subbytes"), Pi0 = r("Buffer.add: cannot grow buffer"), Di0 = [0, r(GU), 93, 2], Li0 = [0, r(GU), 94, 2], Ri0 = r("Buffer.sub"), ji0 = r("%c"), Gi0 = r("%s"), Mi0 = r(oX), Bi0 = r(MY), qi0 = r(xH), Ui0 = r(YH), Hi0 = r("%f"), Xi0 = r(An), Yi0 = r("%{"), Vi0 = r("%}"), zi0 = r("%("), Ki0 = r("%)"), Wi0 = r(N0), Ji0 = r("%t"), $i0 = r("%?"), Zi0 = r("%r"), Qi0 = r("%_r"), rf0 = [0, r(su), 850, 23], ef0 = [0, r(su), 814, 21], nf0 = [0, r(su), 815, 21], tf0 = [0, r(su), 818, 21], uf0 = [0, r(su), 819, 21], if0 = [0, r(su), 822, 19], ff0 = [0, r(su), 823, 19], xf0 = [0, r(su), 826, 22], of0 = [0, r(su), 827, 22], af0 = [0, r(su), 831, 30], cf0 = [0, r(su), 832, 30], sf0 = [0, r(su), 836, 26], vf0 = [0, r(su), 837, 26], lf0 = [0, r(su), 846, 28], bf0 = [0, r(su), 847, 28], pf0 = [0, r(su), 851, 23], mf0 = r(wY), _f0 = [0, r(su), 1558, 4], yf0 = r("Printf: bad conversion %["), hf0 = [0, r(su), 1626, 39], df0 = [0, r(su), 1649, 31], kf0 = [0, r(su), 1650, 31], wf0 = r("Printf: bad conversion %_"), Ef0 = r(SY), Sf0 = r(bY), gf0 = r(SY), Ff0 = r(bY), Tf0 = [0, [11, r("invalid box description "), [3, 0, 0]], r("invalid box description %S")], Of0 = r(C), If0 = [0, 0, 4], Af0 = r(C), Nf0 = r(dX), Cf0 = r("h"), Pf0 = r("hov"), Df0 = r("hv"), Lf0 = r(pV), Rf0 = r(sw), jf0 = r("neg_infinity"), Gf0 = r(mU), Mf0 = r(Lo), Bf0 = r("%+nd"), qf0 = r("% nd"), Uf0 = r("%+ni"), Hf0 = r("% ni"), Xf0 = r("%nx"), Yf0 = r("%#nx"), Vf0 = r("%nX"), zf0 = r("%#nX"), Kf0 = r("%no"), Wf0 = r("%#no"), Jf0 = r("%nd"), $f0 = r(xH), Zf0 = r("%nu"), Qf0 = r("%+ld"), rx0 = r("% ld"), ex0 = r("%+li"), nx0 = r("% li"), tx0 = r("%lx"), ux0 = r("%#lx"), ix0 = r("%lX"), fx0 = r("%#lX"), xx0 = r("%lo"), ox0 = r("%#lo"), ax0 = r("%ld"), cx0 = r(MY), sx0 = r("%lu"), vx0 = r("%+Ld"), lx0 = r("% Ld"), bx0 = r("%+Li"), px0 = r("% Li"), mx0 = r("%Lx"), _x0 = r("%#Lx"), yx0 = r("%LX"), hx0 = r("%#LX"), dx0 = r("%Lo"), kx0 = r("%#Lo"), wx0 = r("%Ld"), Ex0 = r(YH), Sx0 = r("%Lu"), gx0 = r("%+d"), Fx0 = r("% d"), Tx0 = r("%+i"), Ox0 = r("% i"), Ix0 = r("%x"), Ax0 = r("%#x"), Nx0 = r("%X"), Cx0 = r("%#X"), Px0 = r("%o"), Dx0 = r("%#o"), Lx0 = r(N2), Rx0 = r(oX), jx0 = r(wY), Gx0 = r(z2), Mx0 = r("@}"), Bx0 = r("@?"), qx0 = r(`@
`), Ux0 = r("@."), Hx0 = r("@@"), Xx0 = r("@%"), Yx0 = r(gX), Vx0 = r("CamlinternalFormat.Type_mismatch"), zx0 = r(C), Kx0 = [0, [11, r($H), [2, 0, [2, 0, 0]]], r(", %s%s")], Wx0 = [0, [11, r(yd), [2, 0, [12, 10, 0]]], r(TU)], Jx0 = [0, [11, r("Fatal error in uncaught exception handler: exception "), [2, 0, [12, 10, 0]]], r(`Fatal error in uncaught exception handler: exception %s
`)], $x0 = r("Fatal error: out of memory in uncaught exception handler"), Zx0 = [0, [11, r(yd), [2, 0, [12, 10, 0]]], r(TU)], Qx0 = [0, [2, 0, [12, 10, 0]], r(`%s
`)], ro0 = [0, [11, r(NY), 0], r(NY)], eo0 = r("Raised at"), no0 = r("Re-raised at"), to0 = r("Raised by primitive operation at"), uo0 = r("Called from"), io0 = r(" (inlined)"), fo0 = r(C), xo0 = [0, [2, 0, [12, 32, [2, 0, [11, r(' in file "'), [2, 0, [12, 34, [2, 0, [11, r(", line "), [4, 0, 0, 0, [11, r(yH), ni0]]]]]]]]]], r('%s %s in file "%s"%s, line %d, characters %d-%d')], oo0 = [0, [2, 0, [11, r(" unknown location"), 0]], r("%s unknown location")], ao0 = r("Out of memory"), co0 = r("Stack overflow"), so0 = r("Pattern matching failed"), vo0 = r("Assertion failed"), lo0 = r("Undefined recursive module"), bo0 = [0, [12, 40, [2, 0, [2, 0, [12, 41, 0]]]], r("(%s%s)")], po0 = r(C), mo0 = r(C), _o0 = [0, [12, 40, [2, 0, [12, 41, 0]]], r("(%s)")], yo0 = [0, [4, 0, 0, 0, 0], r(N2)], ho0 = [0, [3, 0, 0], r(Vt)], do0 = r(bv), ko0 = [0, r(C), r(`(Cannot print locations:
 bytecode executable program file not found)`), r(`(Cannot print locations:
 bytecode executable program file appears to be corrupt)`), r(`(Cannot print locations:
 bytecode executable program file has wrong magic number)`), r(`(Cannot print locations:
 bytecode executable program file cannot be opened;
 -- too many open files. Try running with OCAMLRUNPARAM=b=2)`)], wo0 = [3, 0, 3], Eo0 = r(Lo), So0 = r(cv), go0 = r("</"), Fo0 = r(C), To0 = r(cv), Oo0 = r(S3), Io0 = r(C), Ao0 = r(MI), No0 = r(C), Co0 = r(C), Po0 = r(C), Do0 = r(C), Lo0 = [0, r(C)], Ro0 = r(C), jo0 = r(C), Go0 = r(C), Mo0 = r(C), Bo0 = [0, r(C), 0, r(C)], qo0 = r(C), Uo0 = r("Stdlib.Format.String_tag"), Ho0 = [0, r("camlinternalOO.ml"), 281, 50], Xo0 = r(C), Yo0 = [0, r(pY), 72, 5], Vo0 = [0, r(pY), 81, 2], zo0 = r("CamlinternalMod.update_mod: not a module"), Ko0 = r("CamlinternalMod.init_mod: not a module"), Wo0 = r("TMPDIR"), Jo0 = r("TEMP"), $o0 = r(jU), Zo0 = r("Win32"), Qo0 = [0, r("src/wtf8.ml"), 65, 9], ra0 = r("Js_of_ocaml__Js.Error"), ea0 = r(KO), na0 = [0, [15, 0], r(N0)], ta0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], ua0 = r(Yr), ia0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], fa0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], xa0 = r("Flow_ast.Program.statements"), oa0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], aa0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], ca0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], sa0 = [0, [17, 0, 0], r(z2)], va0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], la0 = r(Xr), ba0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], pa0 = r(tr), ma0 = r(Z0), _a0 = r(nr), ya0 = [0, [17, 0, 0], r(z2)], ha0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], da0 = r("all_comments"), ka0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], wa0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], Ea0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], Sa0 = [0, [17, 0, 0], r(z2)], ga0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Fa0 = [0, [15, 0], r(N0)], Ta0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Oa0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Ia0 = [0, [17, 0, [12, 41, 0]], r(d0)], Aa0 = [0, [15, 0], r(N0)], Na0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Function.BodyBlock"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Function.BodyBlock@ ")], Ca0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Pa0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Da0 = [0, [17, 0, [12, 41, 0]], r(d0)], La0 = [0, [17, 0, [12, 41, 0]], r(d0)], Ra0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Function.BodyExpression"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Function.BodyExpression@ ")], ja0 = [0, [17, 0, [12, 41, 0]], r(d0)], Ga0 = [0, [15, 0], r(N0)], Ma0 = r(Yr), Ba0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], qa0 = r("Flow_ast.Function.id"), Ua0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Ha0 = r(tr), Xa0 = r(Z0), Ya0 = r(nr), Va0 = [0, [17, 0, 0], r(z2)], za0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Ka0 = r(Dt), Wa0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Ja0 = [0, [17, 0, 0], r(z2)], $a0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Za0 = r(Wn), Qa0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], rc0 = [0, [17, 0, 0], r(z2)], ec0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], nc0 = r(gs), tc0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], uc0 = [0, [9, 0, 0], r(An)], ic0 = [0, [17, 0, 0], r(z2)], fc0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], xc0 = r(G7), oc0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ac0 = [0, [9, 0, 0], r(An)], cc0 = [0, [17, 0, 0], r(z2)], sc0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], vc0 = r(r7), lc0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], bc0 = r(tr), pc0 = r(Z0), mc0 = r(nr), _c0 = [0, [17, 0, 0], r(z2)], yc0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], hc0 = r(Ju), dc0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], kc0 = [0, [17, 0, 0], r(z2)], wc0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Ec0 = r(sv), Sc0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], gc0 = r(tr), Fc0 = r(Z0), Tc0 = r(nr), Oc0 = [0, [17, 0, 0], r(z2)], Ic0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Ac0 = r(Xr), Nc0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Cc0 = r(tr), Pc0 = r(Z0), Dc0 = r(nr), Lc0 = [0, [17, 0, 0], r(z2)], Rc0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], jc0 = r("sig_loc"), Gc0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Mc0 = [0, [17, 0, 0], r(z2)], Bc0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], qc0 = [0, [15, 0], r(N0)], Uc0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Hc0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], Xc0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], Yc0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Vc0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], zc0 = r("Flow_ast.Function.Params.this_"), Kc0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Wc0 = r(tr), Jc0 = r(Z0), $c0 = r(nr), Zc0 = [0, [17, 0, 0], r(z2)], Qc0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], rs0 = r(Dt), es0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ns0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], ts0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], us0 = [0, [17, 0, 0], r(z2)], is0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], fs0 = r(xd), xs0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], os0 = r(tr), as0 = r(Z0), cs0 = r(nr), ss0 = [0, [17, 0, 0], r(z2)], vs0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], ls0 = r(Xr), bs0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ps0 = r(tr), ms0 = r(Z0), _s0 = r(nr), ys0 = [0, [17, 0, 0], r(z2)], hs0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], ds0 = [0, [15, 0], r(N0)], ks0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], ws0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Es0 = [0, [17, 0, [12, 41, 0]], r(d0)], Ss0 = [0, [15, 0], r(N0)], gs0 = r(Yr), Fs0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Ts0 = r("Flow_ast.Function.ThisParam.annot"), Os0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Is0 = [0, [17, 0, 0], r(z2)], As0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Ns0 = r(Xr), Cs0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Ps0 = r(tr), Ds0 = r(Z0), Ls0 = r(nr), Rs0 = [0, [17, 0, 0], r(z2)], js0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Gs0 = [0, [15, 0], r(N0)], Ms0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Bs0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], qs0 = [0, [17, 0, [12, 41, 0]], r(d0)], Us0 = [0, [15, 0], r(N0)], Hs0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Xs0 = r("Flow_ast.Function.Param.argument"), Ys0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Vs0 = [0, [17, 0, 0], r(z2)], zs0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Ks0 = r(_i), Ws0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Js0 = r(tr), $s0 = r(Z0), Zs0 = r(nr), Qs0 = [0, [17, 0, 0], r(z2)], r10 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], e10 = [0, [15, 0], r(N0)], n10 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], t10 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], u10 = [0, [17, 0, [12, 41, 0]], r(d0)], i10 = [0, [15, 0], r(N0)], f10 = r(Yr), x10 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], o10 = r("Flow_ast.Function.RestParam.argument"), a10 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], c10 = [0, [17, 0, 0], r(z2)], s10 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], v10 = r(Xr), l10 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], b10 = r(tr), p10 = r(Z0), m10 = r(nr), _10 = [0, [17, 0, 0], r(z2)], y10 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], h10 = [0, [15, 0], r(N0)], d10 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], k10 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], w10 = [0, [17, 0, [12, 41, 0]], r(d0)], E10 = [0, [15, 0], r(N0)], S10 = r(Yr), g10 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], F10 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], T10 = r("Flow_ast.Class.id"), O10 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], I10 = r(tr), A10 = r(Z0), N10 = r(nr), C10 = [0, [17, 0, 0], r(z2)], P10 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], D10 = r(Wn), L10 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], R10 = [0, [17, 0, 0], r(z2)], j10 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], G10 = r(sv), M10 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], B10 = r(tr), q10 = r(Z0), U10 = r(nr), H10 = [0, [17, 0, 0], r(z2)], X10 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Y10 = r(P7), V10 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], z10 = r(tr), K10 = r(Z0), W10 = r(nr), J10 = [0, [17, 0, 0], r(z2)], $10 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Z10 = r(ws), Q10 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], rv0 = r(tr), ev0 = r(Z0), nv0 = r(nr), tv0 = [0, [17, 0, 0], r(z2)], uv0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], iv0 = r("class_decorators"), fv0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], xv0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], ov0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], av0 = [0, [17, 0, 0], r(z2)], cv0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], sv0 = r(Xr), vv0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], lv0 = r(tr), bv0 = r(Z0), pv0 = r(nr), mv0 = [0, [17, 0, 0], r(z2)], _v0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], yv0 = [0, [15, 0], r(N0)], hv0 = r(Yr), dv0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], kv0 = r("Flow_ast.Class.Decorator.expression"), wv0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Ev0 = [0, [17, 0, 0], r(z2)], Sv0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], gv0 = r(Xr), Fv0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Tv0 = r(tr), Ov0 = r(Z0), Iv0 = r(nr), Av0 = [0, [17, 0, 0], r(z2)], Nv0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Cv0 = [0, [15, 0], r(N0)], Pv0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Dv0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Lv0 = [0, [17, 0, [12, 41, 0]], r(d0)], Rv0 = [0, [15, 0], r(N0)], jv0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Class.Body.Method"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Class.Body.Method@ ")], Gv0 = [0, [17, 0, [12, 41, 0]], r(d0)], Mv0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Class.Body.Property"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Class.Body.Property@ ")], Bv0 = [0, [17, 0, [12, 41, 0]], r(d0)], qv0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Class.Body.PrivateField"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Class.Body.PrivateField@ ")], Uv0 = [0, [17, 0, [12, 41, 0]], r(d0)], Hv0 = [0, [15, 0], r(N0)], Xv0 = r(Yr), Yv0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Vv0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], zv0 = r("Flow_ast.Class.Body.body"), Kv0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Wv0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], Jv0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], $v0 = [0, [17, 0, 0], r(z2)], Zv0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Qv0 = r(Xr), r20 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], e20 = r(tr), n20 = r(Z0), t20 = r(nr), u20 = [0, [17, 0, 0], r(z2)], i20 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], f20 = [0, [15, 0], r(N0)], x20 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], o20 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], a20 = [0, [17, 0, [12, 41, 0]], r(d0)], c20 = [0, [15, 0], r(N0)], s20 = r(Yr), v20 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], l20 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], b20 = r("Flow_ast.Class.Implements.interfaces"), p20 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], m20 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], _20 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], y20 = [0, [17, 0, 0], r(z2)], h20 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], d20 = r(Xr), k20 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], w20 = r(tr), E20 = r(Z0), S20 = r(nr), g20 = [0, [17, 0, 0], r(z2)], F20 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], T20 = [0, [15, 0], r(N0)], O20 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], I20 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], A20 = [0, [17, 0, [12, 41, 0]], r(d0)], N20 = [0, [15, 0], r(N0)], C20 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], P20 = r("Flow_ast.Class.Implements.Interface.id"), D20 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], L20 = [0, [17, 0, 0], r(z2)], R20 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], j20 = r(Z2), G20 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], M20 = r(tr), B20 = r(Z0), q20 = r(nr), U20 = [0, [17, 0, 0], r(z2)], H20 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], X20 = [0, [15, 0], r(N0)], Y20 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], V20 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], z20 = [0, [17, 0, [12, 41, 0]], r(d0)], K20 = [0, [15, 0], r(N0)], W20 = r(Yr), J20 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], $20 = r("Flow_ast.Class.Extends.expr"), Z20 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Q20 = [0, [17, 0, 0], r(z2)], rl0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], el0 = r(Z2), nl0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], tl0 = r(tr), ul0 = r(Z0), il0 = r(nr), fl0 = [0, [17, 0, 0], r(z2)], xl0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], ol0 = r(Xr), al0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], cl0 = r(tr), sl0 = r(Z0), vl0 = r(nr), ll0 = [0, [17, 0, 0], r(z2)], bl0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], pl0 = [0, [15, 0], r(N0)], ml0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], _l0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], yl0 = [0, [17, 0, [12, 41, 0]], r(d0)], hl0 = [0, [15, 0], r(N0)], dl0 = r(Yr), kl0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], wl0 = r("Flow_ast.Class.PrivateField.key"), El0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Sl0 = [0, [17, 0, 0], r(z2)], gl0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Fl0 = r(Bn), Tl0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Ol0 = [0, [17, 0, 0], r(z2)], Il0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Al0 = r(Qc), Nl0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Cl0 = [0, [17, 0, 0], r(z2)], Pl0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Dl0 = r(nu), Ll0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Rl0 = [0, [9, 0, 0], r(An)], jl0 = [0, [17, 0, 0], r(z2)], Gl0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Ml0 = r(cu), Bl0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ql0 = r(tr), Ul0 = r(Z0), Hl0 = r(nr), Xl0 = [0, [17, 0, 0], r(z2)], Yl0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Vl0 = r(Xr), zl0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Kl0 = r(tr), Wl0 = r(Z0), Jl0 = r(nr), $l0 = [0, [17, 0, 0], r(z2)], Zl0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Ql0 = [0, [15, 0], r(N0)], rb0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], eb0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], nb0 = [0, [17, 0, [12, 41, 0]], r(d0)], tb0 = [0, [15, 0], r(N0)], ub0 = r("Flow_ast.Class.Property.Uninitialized"), ib0 = r("Flow_ast.Class.Property.Declared"), fb0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Class.Property.Initialized"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Class.Property.Initialized@ ")], xb0 = [0, [17, 0, [12, 41, 0]], r(d0)], ob0 = [0, [15, 0], r(N0)], ab0 = r(Yr), cb0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], sb0 = r("Flow_ast.Class.Property.key"), vb0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], lb0 = [0, [17, 0, 0], r(z2)], bb0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], pb0 = r(Bn), mb0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], _b0 = [0, [17, 0, 0], r(z2)], yb0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], hb0 = r(Qc), db0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], kb0 = [0, [17, 0, 0], r(z2)], wb0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Eb0 = r(nu), Sb0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], gb0 = [0, [9, 0, 0], r(An)], Fb0 = [0, [17, 0, 0], r(z2)], Tb0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Ob0 = r(cu), Ib0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Ab0 = r(tr), Nb0 = r(Z0), Cb0 = r(nr), Pb0 = [0, [17, 0, 0], r(z2)], Db0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Lb0 = r(Xr), Rb0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], jb0 = r(tr), Gb0 = r(Z0), Mb0 = r(nr), Bb0 = [0, [17, 0, 0], r(z2)], qb0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Ub0 = [0, [15, 0], r(N0)], Hb0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Xb0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Yb0 = [0, [17, 0, [12, 41, 0]], r(d0)], Vb0 = [0, [15, 0], r(N0)], zb0 = r(Yr), Kb0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Wb0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Jb0 = r("Flow_ast.Class.Method.kind"), $b0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Zb0 = [0, [17, 0, 0], r(z2)], Qb0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], r40 = r(ii), e40 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], n40 = [0, [17, 0, 0], r(z2)], t40 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], u40 = r(Bn), i40 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], f40 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], x40 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], o40 = [0, [17, 0, [12, 41, 0]], r(d0)], a40 = [0, [17, 0, 0], r(z2)], c40 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], s40 = r(nu), v40 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], l40 = [0, [9, 0, 0], r(An)], b40 = [0, [17, 0, 0], r(z2)], p40 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], m40 = r(j_), _40 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], y40 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], h40 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], d40 = [0, [17, 0, 0], r(z2)], k40 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], w40 = r(Xr), E40 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], S40 = r(tr), g40 = r(Z0), F40 = r(nr), T40 = [0, [17, 0, 0], r(z2)], O40 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], I40 = [0, [15, 0], r(N0)], A40 = r("Flow_ast.Class.Method.Constructor"), N40 = r("Flow_ast.Class.Method.Method"), C40 = r("Flow_ast.Class.Method.Get"), P40 = r("Flow_ast.Class.Method.Set"), D40 = [0, [15, 0], r(N0)], L40 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], R40 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], j40 = [0, [17, 0, [12, 41, 0]], r(d0)], G40 = [0, [15, 0], r(N0)], M40 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], B40 = r("Flow_ast.Comment.kind"), q40 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], U40 = [0, [17, 0, 0], r(z2)], H40 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], X40 = r("text"), Y40 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], V40 = [0, [3, 0, 0], r(Vt)], z40 = [0, [17, 0, 0], r(z2)], K40 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], W40 = r("on_newline"), J40 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], $40 = [0, [9, 0, 0], r(An)], Z40 = [0, [17, 0, 0], r(z2)], Q40 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], r80 = [0, [15, 0], r(N0)], e80 = r("Flow_ast.Comment.Line"), n80 = r("Flow_ast.Comment.Block"), t80 = [0, [15, 0], r(N0)], u80 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], i80 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], f80 = [0, [17, 0, [12, 41, 0]], r(d0)], x80 = [0, [15, 0], r(N0)], o80 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Pattern.Object"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Pattern.Object@ ")], a80 = [0, [17, 0, [12, 41, 0]], r(d0)], c80 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Pattern.Array"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Pattern.Array@ ")], s80 = [0, [17, 0, [12, 41, 0]], r(d0)], v80 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Pattern.Identifier"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Pattern.Identifier@ ")], l80 = [0, [17, 0, [12, 41, 0]], r(d0)], b80 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Pattern.Expression"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Pattern.Expression@ ")], p80 = [0, [17, 0, [12, 41, 0]], r(d0)], m80 = [0, [15, 0], r(N0)], _80 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], y80 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], h80 = [0, [17, 0, [12, 41, 0]], r(d0)], d80 = [0, [15, 0], r(N0)], k80 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], w80 = r("Flow_ast.Pattern.Identifier.name"), E80 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], S80 = [0, [17, 0, 0], r(z2)], g80 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], F80 = r(Qc), T80 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], O80 = [0, [17, 0, 0], r(z2)], I80 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], A80 = r(qu), N80 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], C80 = [0, [9, 0, 0], r(An)], P80 = [0, [17, 0, 0], r(z2)], D80 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], L80 = [0, [15, 0], r(N0)], R80 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], j80 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], G80 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], M80 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], B80 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], q80 = r("Flow_ast.Pattern.Array.elements"), U80 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], H80 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], X80 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], Y80 = [0, [17, 0, 0], r(z2)], V80 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], z80 = r(Qc), K80 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], W80 = [0, [17, 0, 0], r(z2)], J80 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], $80 = r(Xr), Z80 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Q80 = r(tr), r30 = r(Z0), e30 = r(nr), n30 = [0, [17, 0, 0], r(z2)], t30 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], u30 = [0, [15, 0], r(N0)], i30 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Pattern.Array.Element"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Pattern.Array.Element@ ")], f30 = [0, [17, 0, [12, 41, 0]], r(d0)], x30 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Pattern.Array.RestElement"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Pattern.Array.RestElement@ ")], o30 = [0, [17, 0, [12, 41, 0]], r(d0)], a30 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Pattern.Array.Hole"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Pattern.Array.Hole@ ")], c30 = [0, [17, 0, [12, 41, 0]], r(d0)], s30 = [0, [15, 0], r(N0)], v30 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], l30 = r("Flow_ast.Pattern.Array.Element.argument"), b30 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], p30 = [0, [17, 0, 0], r(z2)], m30 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], _30 = r(_i), y30 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], h30 = r(tr), d30 = r(Z0), k30 = r(nr), w30 = [0, [17, 0, 0], r(z2)], E30 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], S30 = [0, [15, 0], r(N0)], g30 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], F30 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], T30 = [0, [17, 0, [12, 41, 0]], r(d0)], O30 = [0, [15, 0], r(N0)], I30 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], A30 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], N30 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], C30 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], P30 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], D30 = r("Flow_ast.Pattern.Object.properties"), L30 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], R30 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], j30 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], G30 = [0, [17, 0, 0], r(z2)], M30 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], B30 = r(Qc), q30 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], U30 = [0, [17, 0, 0], r(z2)], H30 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], X30 = r(Xr), Y30 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], V30 = r(tr), z30 = r(Z0), K30 = r(nr), W30 = [0, [17, 0, 0], r(z2)], J30 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], $30 = [0, [15, 0], r(N0)], Z30 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Pattern.Object.Property"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Pattern.Object.Property@ ")], Q30 = [0, [17, 0, [12, 41, 0]], r(d0)], r60 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Pattern.Object.RestElement"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Pattern.Object.RestElement@ ")], e60 = [0, [17, 0, [12, 41, 0]], r(d0)], n60 = [0, [15, 0], r(N0)], t60 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], u60 = r("Flow_ast.Pattern.Object.Property.key"), i60 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], f60 = [0, [17, 0, 0], r(z2)], x60 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], o60 = r(mi), a60 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], c60 = [0, [17, 0, 0], r(z2)], s60 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], v60 = r(_i), l60 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], b60 = r(tr), p60 = r(Z0), m60 = r(nr), _60 = [0, [17, 0, 0], r(z2)], y60 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], h60 = r(f6), d60 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], k60 = [0, [9, 0, 0], r(An)], w60 = [0, [17, 0, 0], r(z2)], E60 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], S60 = [0, [15, 0], r(N0)], g60 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], F60 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], T60 = [0, [17, 0, [12, 41, 0]], r(d0)], O60 = [0, [15, 0], r(N0)], I60 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Pattern.Object.Property.Literal"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Pattern.Object.Property.Literal@ ")], A60 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], N60 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], C60 = [0, [17, 0, [12, 41, 0]], r(d0)], P60 = [0, [17, 0, [12, 41, 0]], r(d0)], D60 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Pattern.Object.Property.Identifier"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Pattern.Object.Property.Identifier@ ")], L60 = [0, [17, 0, [12, 41, 0]], r(d0)], R60 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Pattern.Object.Property.Computed"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Pattern.Object.Property.Computed@ ")], j60 = [0, [17, 0, [12, 41, 0]], r(d0)], G60 = [0, [15, 0], r(N0)], M60 = r(Yr), B60 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], q60 = r("Flow_ast.Pattern.RestElement.argument"), U60 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], H60 = [0, [17, 0, 0], r(z2)], X60 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Y60 = r(Xr), V60 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], z60 = r(tr), K60 = r(Z0), W60 = r(nr), J60 = [0, [17, 0, 0], r(z2)], $60 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Z60 = [0, [15, 0], r(N0)], Q60 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], rp0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], ep0 = [0, [17, 0, [12, 41, 0]], r(d0)], np0 = [0, [15, 0], r(N0)], tp0 = r(Yr), up0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], ip0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], fp0 = r("Flow_ast.JSX.frag_opening_element"), xp0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], op0 = [0, [17, 0, 0], r(z2)], ap0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], cp0 = r("frag_closing_element"), sp0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], vp0 = [0, [17, 0, 0], r(z2)], lp0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], bp0 = r("frag_children"), pp0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], mp0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], _p0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], yp0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], hp0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], dp0 = [0, [17, 0, [12, 41, 0]], r(d0)], kp0 = [0, [17, 0, 0], r(z2)], wp0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Ep0 = r("frag_comments"), Sp0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], gp0 = r(tr), Fp0 = r(Z0), Tp0 = r(nr), Op0 = [0, [17, 0, 0], r(z2)], Ip0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Ap0 = [0, [15, 0], r(N0)], Np0 = r(Yr), Cp0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Pp0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Dp0 = r("Flow_ast.JSX.opening_element"), Lp0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Rp0 = [0, [17, 0, 0], r(z2)], jp0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Gp0 = r("closing_element"), Mp0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Bp0 = r(tr), qp0 = r(Z0), Up0 = r(nr), Hp0 = [0, [17, 0, 0], r(z2)], Xp0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Yp0 = r(Ve), Vp0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], zp0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Kp0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Wp0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], Jp0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], $p0 = [0, [17, 0, [12, 41, 0]], r(d0)], Zp0 = [0, [17, 0, 0], r(z2)], Qp0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], r50 = r(Xr), e50 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], n50 = r(tr), t50 = r(Z0), u50 = r(nr), i50 = [0, [17, 0, 0], r(z2)], f50 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], x50 = [0, [15, 0], r(N0)], o50 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.JSX.Element"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.JSX.Element@ ")], a50 = [0, [17, 0, [12, 41, 0]], r(d0)], c50 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.JSX.Fragment"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.JSX.Fragment@ ")], s50 = [0, [17, 0, [12, 41, 0]], r(d0)], v50 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.JSX.ExpressionContainer"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.JSX.ExpressionContainer@ ")], l50 = [0, [17, 0, [12, 41, 0]], r(d0)], b50 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.JSX.SpreadChild"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.JSX.SpreadChild@ ")], p50 = [0, [17, 0, [12, 41, 0]], r(d0)], m50 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.JSX.Text"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.JSX.Text@ ")], _50 = [0, [17, 0, [12, 41, 0]], r(d0)], y50 = [0, [15, 0], r(N0)], h50 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], d50 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], k50 = [0, [17, 0, [12, 41, 0]], r(d0)], w50 = [0, [15, 0], r(N0)], E50 = r(Yr), S50 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], g50 = r("Flow_ast.JSX.SpreadChild.expression"), F50 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], T50 = [0, [17, 0, 0], r(z2)], O50 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], I50 = r(Xr), A50 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], N50 = r(tr), C50 = r(Z0), P50 = r(nr), D50 = [0, [17, 0, 0], r(z2)], L50 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], R50 = [0, [15, 0], r(N0)], j50 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], G50 = r("Flow_ast.JSX.Closing.name"), M50 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], B50 = [0, [17, 0, 0], r(z2)], q50 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], U50 = [0, [15, 0], r(N0)], H50 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], X50 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Y50 = [0, [17, 0, [12, 41, 0]], r(d0)], V50 = [0, [15, 0], r(N0)], z50 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], K50 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], W50 = r("Flow_ast.JSX.Opening.name"), J50 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], $50 = [0, [17, 0, 0], r(z2)], Z50 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Q50 = r("self_closing"), rm0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], em0 = [0, [9, 0, 0], r(An)], nm0 = [0, [17, 0, 0], r(z2)], tm0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], um0 = r(mY), im0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], fm0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], xm0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], om0 = [0, [17, 0, 0], r(z2)], am0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], cm0 = [0, [15, 0], r(N0)], sm0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.JSX.Opening.Attribute"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.JSX.Opening.Attribute@ ")], vm0 = [0, [17, 0, [12, 41, 0]], r(d0)], lm0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.JSX.Opening.SpreadAttribute"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.JSX.Opening.SpreadAttribute@ ")], bm0 = [0, [17, 0, [12, 41, 0]], r(d0)], pm0 = [0, [15, 0], r(N0)], mm0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], _m0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], ym0 = [0, [17, 0, [12, 41, 0]], r(d0)], hm0 = [0, [15, 0], r(N0)], dm0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.JSX.Identifier"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.JSX.Identifier@ ")], km0 = [0, [17, 0, [12, 41, 0]], r(d0)], wm0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.JSX.NamespacedName"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.JSX.NamespacedName@ ")], Em0 = [0, [17, 0, [12, 41, 0]], r(d0)], Sm0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.JSX.MemberExpression"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.JSX.MemberExpression@ ")], gm0 = [0, [17, 0, [12, 41, 0]], r(d0)], Fm0 = [0, [15, 0], r(N0)], Tm0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Om0 = r("Flow_ast.JSX.MemberExpression._object"), Im0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Am0 = [0, [17, 0, 0], r(z2)], Nm0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Cm0 = r(Iv), Pm0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Dm0 = [0, [17, 0, 0], r(z2)], Lm0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Rm0 = [0, [15, 0], r(N0)], jm0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.JSX.MemberExpression.Identifier"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.JSX.MemberExpression.Identifier@ ")], Gm0 = [0, [17, 0, [12, 41, 0]], r(d0)], Mm0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.JSX.MemberExpression.MemberExpression"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.JSX.MemberExpression.MemberExpression@ ")], Bm0 = [0, [17, 0, [12, 41, 0]], r(d0)], qm0 = [0, [15, 0], r(N0)], Um0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Hm0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Xm0 = [0, [17, 0, [12, 41, 0]], r(d0)], Ym0 = [0, [15, 0], r(N0)], Vm0 = r(Yr), zm0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Km0 = r("Flow_ast.JSX.SpreadAttribute.argument"), Wm0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Jm0 = [0, [17, 0, 0], r(z2)], $m0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Zm0 = r(Xr), Qm0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], r90 = r(tr), e90 = r(Z0), n90 = r(nr), t90 = [0, [17, 0, 0], r(z2)], u90 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], i90 = [0, [15, 0], r(N0)], f90 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], x90 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], o90 = [0, [17, 0, [12, 41, 0]], r(d0)], a90 = [0, [15, 0], r(N0)], c90 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], s90 = r("Flow_ast.JSX.Attribute.name"), v90 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], l90 = [0, [17, 0, 0], r(z2)], b90 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], p90 = r(Bn), m90 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], _90 = r(tr), y90 = r(Z0), h90 = r(nr), d90 = [0, [17, 0, 0], r(z2)], k90 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], w90 = [0, [15, 0], r(N0)], E90 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.JSX.Attribute.Literal ("), [17, [0, r(Ce), 0, 0], 0]]]], r("(@[<2>Flow_ast.JSX.Attribute.Literal (@,")], S90 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], g90 = [0, [17, [0, r(Ce), 0, 0], [11, r(EX), [17, 0, 0]]], r(RU)], F90 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.JSX.Attribute.ExpressionContainer ("), [17, [0, r(Ce), 0, 0], 0]]]], r("(@[<2>Flow_ast.JSX.Attribute.ExpressionContainer (@,")], T90 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], O90 = [0, [17, [0, r(Ce), 0, 0], [11, r(EX), [17, 0, 0]]], r(RU)], I90 = [0, [15, 0], r(N0)], A90 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.JSX.Attribute.Identifier"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.JSX.Attribute.Identifier@ ")], N90 = [0, [17, 0, [12, 41, 0]], r(d0)], C90 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.JSX.Attribute.NamespacedName"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.JSX.Attribute.NamespacedName@ ")], P90 = [0, [17, 0, [12, 41, 0]], r(d0)], D90 = [0, [15, 0], r(N0)], L90 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], R90 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], j90 = [0, [17, 0, [12, 41, 0]], r(d0)], G90 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], M90 = r("Flow_ast.JSX.Text.value"), B90 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], q90 = [0, [3, 0, 0], r(Vt)], U90 = [0, [17, 0, 0], r(z2)], H90 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], X90 = r(c7), Y90 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], V90 = [0, [3, 0, 0], r(Vt)], z90 = [0, [17, 0, 0], r(z2)], K90 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], W90 = [0, [15, 0], r(N0)], J90 = [0, [15, 0], r(N0)], $90 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.JSX.ExpressionContainer.Expression"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.JSX.ExpressionContainer.Expression@ ")], Z90 = [0, [17, 0, [12, 41, 0]], r(d0)], Q90 = r("Flow_ast.JSX.ExpressionContainer.EmptyExpression"), r_0 = [0, [15, 0], r(N0)], e_0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], n_0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], t_0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], u_0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], i_0 = r("Flow_ast.JSX.ExpressionContainer.expression"), f_0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], x_0 = [0, [17, 0, 0], r(z2)], o_0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], a_0 = r(Xr), c_0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], s_0 = r(tr), v_0 = r(Z0), l_0 = r(nr), b_0 = [0, [17, 0, 0], r(z2)], p_0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], m_0 = [0, [15, 0], r(N0)], __0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], y_0 = r("Flow_ast.JSX.NamespacedName.namespace"), h_0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], d_0 = [0, [17, 0, 0], r(z2)], k_0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], w_0 = r(ui), E_0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], S_0 = [0, [17, 0, 0], r(z2)], g_0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], F_0 = [0, [15, 0], r(N0)], T_0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], O_0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], I_0 = [0, [17, 0, [12, 41, 0]], r(d0)], A_0 = [0, [15, 0], r(N0)], N_0 = r(Yr), C_0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], P_0 = r("Flow_ast.JSX.Identifier.name"), D_0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], L_0 = [0, [3, 0, 0], r(Vt)], R_0 = [0, [17, 0, 0], r(z2)], j_0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], G_0 = r(Xr), M_0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], B_0 = r(tr), q_0 = r(Z0), U_0 = r(nr), H_0 = [0, [17, 0, 0], r(z2)], X_0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Y_0 = [0, [15, 0], r(N0)], V_0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], z_0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], K_0 = [0, [17, 0, [12, 41, 0]], r(d0)], W_0 = [0, [15, 0], r(N0)], J_0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Array"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Array@ ")], $_0 = [0, [17, 0, [12, 41, 0]], r(d0)], Z_0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.ArrowFunction"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.ArrowFunction@ ")], Q_0 = [0, [17, 0, [12, 41, 0]], r(d0)], ry0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Assignment"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Assignment@ ")], ey0 = [0, [17, 0, [12, 41, 0]], r(d0)], ny0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Binary"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Binary@ ")], ty0 = [0, [17, 0, [12, 41, 0]], r(d0)], uy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Call"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Call@ ")], iy0 = [0, [17, 0, [12, 41, 0]], r(d0)], fy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Class"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Class@ ")], xy0 = [0, [17, 0, [12, 41, 0]], r(d0)], oy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Comprehension"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Comprehension@ ")], ay0 = [0, [17, 0, [12, 41, 0]], r(d0)], cy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Conditional"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Conditional@ ")], sy0 = [0, [17, 0, [12, 41, 0]], r(d0)], vy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Function"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Function@ ")], ly0 = [0, [17, 0, [12, 41, 0]], r(d0)], by0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Generator"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Generator@ ")], py0 = [0, [17, 0, [12, 41, 0]], r(d0)], my0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Identifier"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Identifier@ ")], _y0 = [0, [17, 0, [12, 41, 0]], r(d0)], yy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Import"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Import@ ")], hy0 = [0, [17, 0, [12, 41, 0]], r(d0)], dy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.JSXElement"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.JSXElement@ ")], ky0 = [0, [17, 0, [12, 41, 0]], r(d0)], wy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.JSXFragment"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.JSXFragment@ ")], Ey0 = [0, [17, 0, [12, 41, 0]], r(d0)], Sy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Literal"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Literal@ ")], gy0 = [0, [17, 0, [12, 41, 0]], r(d0)], Fy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Logical"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Logical@ ")], Ty0 = [0, [17, 0, [12, 41, 0]], r(d0)], Oy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Member"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Member@ ")], Iy0 = [0, [17, 0, [12, 41, 0]], r(d0)], Ay0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.MetaProperty"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.MetaProperty@ ")], Ny0 = [0, [17, 0, [12, 41, 0]], r(d0)], Cy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.New"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.New@ ")], Py0 = [0, [17, 0, [12, 41, 0]], r(d0)], Dy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Object"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Object@ ")], Ly0 = [0, [17, 0, [12, 41, 0]], r(d0)], Ry0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.OptionalCall"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.OptionalCall@ ")], jy0 = [0, [17, 0, [12, 41, 0]], r(d0)], Gy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.OptionalMember"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.OptionalMember@ ")], My0 = [0, [17, 0, [12, 41, 0]], r(d0)], By0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Sequence"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Sequence@ ")], qy0 = [0, [17, 0, [12, 41, 0]], r(d0)], Uy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Super"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Super@ ")], Hy0 = [0, [17, 0, [12, 41, 0]], r(d0)], Xy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.TaggedTemplate"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.TaggedTemplate@ ")], Yy0 = [0, [17, 0, [12, 41, 0]], r(d0)], Vy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.TemplateLiteral"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.TemplateLiteral@ ")], zy0 = [0, [17, 0, [12, 41, 0]], r(d0)], Ky0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.This"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.This@ ")], Wy0 = [0, [17, 0, [12, 41, 0]], r(d0)], Jy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.TypeCast"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.TypeCast@ ")], $y0 = [0, [17, 0, [12, 41, 0]], r(d0)], Zy0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Unary"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Unary@ ")], Qy0 = [0, [17, 0, [12, 41, 0]], r(d0)], rh0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Update"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Update@ ")], eh0 = [0, [17, 0, [12, 41, 0]], r(d0)], nh0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Yield"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Yield@ ")], th0 = [0, [17, 0, [12, 41, 0]], r(d0)], uh0 = [0, [15, 0], r(N0)], ih0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], fh0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], xh0 = [0, [17, 0, [12, 41, 0]], r(d0)], oh0 = [0, [15, 0], r(N0)], ah0 = r(Yr), ch0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], sh0 = r("Flow_ast.Expression.Import.argument"), vh0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], lh0 = [0, [17, 0, 0], r(z2)], bh0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], ph0 = r(Xr), mh0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], _h0 = r(tr), yh0 = r(Z0), hh0 = r(nr), dh0 = [0, [17, 0, 0], r(z2)], kh0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], wh0 = [0, [15, 0], r(N0)], Eh0 = r(Yr), Sh0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], gh0 = r("Flow_ast.Expression.Super.comments"), Fh0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Th0 = r(tr), Oh0 = r(Z0), Ih0 = r(nr), Ah0 = [0, [17, 0, 0], r(z2)], Nh0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Ch0 = [0, [15, 0], r(N0)], Ph0 = r(Yr), Dh0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Lh0 = r("Flow_ast.Expression.This.comments"), Rh0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], jh0 = r(tr), Gh0 = r(Z0), Mh0 = r(nr), Bh0 = [0, [17, 0, 0], r(z2)], qh0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Uh0 = [0, [15, 0], r(N0)], Hh0 = r(Yr), Xh0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Yh0 = r("Flow_ast.Expression.MetaProperty.meta"), Vh0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], zh0 = [0, [17, 0, 0], r(z2)], Kh0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Wh0 = r(Iv), Jh0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], $h0 = [0, [17, 0, 0], r(z2)], Zh0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Qh0 = r(Xr), rd0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ed0 = r(tr), nd0 = r(Z0), td0 = r(nr), ud0 = [0, [17, 0, 0], r(z2)], id0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], fd0 = [0, [15, 0], r(N0)], xd0 = r(Yr), od0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], ad0 = r("Flow_ast.Expression.TypeCast.expression"), cd0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], sd0 = [0, [17, 0, 0], r(z2)], vd0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], ld0 = r(Qc), bd0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], pd0 = [0, [17, 0, 0], r(z2)], md0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], _d0 = r(Xr), yd0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], hd0 = r(tr), dd0 = r(Z0), kd0 = r(nr), wd0 = [0, [17, 0, 0], r(z2)], Ed0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Sd0 = [0, [15, 0], r(N0)], gd0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Fd0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Td0 = r("Flow_ast.Expression.Generator.blocks"), Od0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Id0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], Ad0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], Nd0 = [0, [17, 0, 0], r(z2)], Cd0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Pd0 = r(T4), Dd0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Ld0 = r(tr), Rd0 = r(Z0), jd0 = r(nr), Gd0 = [0, [17, 0, 0], r(z2)], Md0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Bd0 = [0, [15, 0], r(N0)], qd0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Ud0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Hd0 = r("Flow_ast.Expression.Comprehension.blocks"), Xd0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Yd0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], Vd0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], zd0 = [0, [17, 0, 0], r(z2)], Kd0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Wd0 = r(T4), Jd0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], $d0 = r(tr), Zd0 = r(Z0), Qd0 = r(nr), rk0 = [0, [17, 0, 0], r(z2)], ek0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], nk0 = [0, [15, 0], r(N0)], tk0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], uk0 = r("Flow_ast.Expression.Comprehension.Block.left"), ik0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], fk0 = [0, [17, 0, 0], r(z2)], xk0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], ok0 = r(Cu), ak0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ck0 = [0, [17, 0, 0], r(z2)], sk0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], vk0 = r(R8), lk0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], bk0 = [0, [9, 0, 0], r(An)], pk0 = [0, [17, 0, 0], r(z2)], mk0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], _k0 = [0, [15, 0], r(N0)], yk0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], hk0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], dk0 = [0, [17, 0, [12, 41, 0]], r(d0)], kk0 = [0, [15, 0], r(N0)], wk0 = r(Yr), Ek0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Sk0 = r("Flow_ast.Expression.Yield.argument"), gk0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Fk0 = r(tr), Tk0 = r(Z0), Ok0 = r(nr), Ik0 = [0, [17, 0, 0], r(z2)], Ak0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Nk0 = r(Xr), Ck0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Pk0 = r(tr), Dk0 = r(Z0), Lk0 = r(nr), Rk0 = [0, [17, 0, 0], r(z2)], jk0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Gk0 = r(lY), Mk0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Bk0 = [0, [9, 0, 0], r(An)], qk0 = [0, [17, 0, 0], r(z2)], Uk0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Hk0 = r("result_out"), Xk0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Yk0 = [0, [17, 0, 0], r(z2)], Vk0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], zk0 = [0, [15, 0], r(N0)], Kk0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Wk0 = r("Flow_ast.Expression.OptionalMember.member"), Jk0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], $k0 = [0, [17, 0, 0], r(z2)], Zk0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Qk0 = r(lU), rw0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ew0 = [0, [17, 0, 0], r(z2)], nw0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], tw0 = r(qu), uw0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], iw0 = [0, [9, 0, 0], r(An)], fw0 = [0, [17, 0, 0], r(z2)], xw0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], ow0 = [0, [15, 0], r(N0)], aw0 = r(Yr), cw0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], sw0 = r("Flow_ast.Expression.Member._object"), vw0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], lw0 = [0, [17, 0, 0], r(z2)], bw0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], pw0 = r(Iv), mw0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], _w0 = [0, [17, 0, 0], r(z2)], yw0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], hw0 = r(Xr), dw0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], kw0 = r(tr), ww0 = r(Z0), Ew0 = r(nr), Sw0 = [0, [17, 0, 0], r(z2)], gw0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Fw0 = [0, [15, 0], r(N0)], Tw0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Member.PropertyIdentifier"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Member.PropertyIdentifier@ ")], Ow0 = [0, [17, 0, [12, 41, 0]], r(d0)], Iw0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Member.PropertyPrivateName"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Member.PropertyPrivateName@ ")], Aw0 = [0, [17, 0, [12, 41, 0]], r(d0)], Nw0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Member.PropertyExpression"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Member.PropertyExpression@ ")], Cw0 = [0, [17, 0, [12, 41, 0]], r(d0)], Pw0 = [0, [15, 0], r(N0)], Dw0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Lw0 = r("Flow_ast.Expression.OptionalCall.call"), Rw0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], jw0 = [0, [17, 0, 0], r(z2)], Gw0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Mw0 = r(lU), Bw0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], qw0 = [0, [17, 0, 0], r(z2)], Uw0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Hw0 = r(qu), Xw0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Yw0 = [0, [9, 0, 0], r(An)], Vw0 = [0, [17, 0, 0], r(z2)], zw0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Kw0 = [0, [15, 0], r(N0)], Ww0 = r(Yr), Jw0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], $w0 = r("Flow_ast.Expression.Call.callee"), Zw0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Qw0 = [0, [17, 0, 0], r(z2)], rE0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], eE0 = r(Z2), nE0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], tE0 = r(tr), uE0 = r(Z0), iE0 = r(nr), fE0 = [0, [17, 0, 0], r(z2)], xE0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], oE0 = r(C2), aE0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], cE0 = [0, [17, 0, 0], r(z2)], sE0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], vE0 = r(Xr), lE0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], bE0 = r(tr), pE0 = r(Z0), mE0 = r(nr), _E0 = [0, [17, 0, 0], r(z2)], yE0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], hE0 = [0, [15, 0], r(N0)], dE0 = r(Yr), kE0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], wE0 = r("Flow_ast.Expression.New.callee"), EE0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], SE0 = [0, [17, 0, 0], r(z2)], gE0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], FE0 = r(Z2), TE0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], OE0 = r(tr), IE0 = r(Z0), AE0 = r(nr), NE0 = [0, [17, 0, 0], r(z2)], CE0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], PE0 = r(C2), DE0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], LE0 = r(tr), RE0 = r(Z0), jE0 = r(nr), GE0 = [0, [17, 0, 0], r(z2)], ME0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], BE0 = r(Xr), qE0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], UE0 = r(tr), HE0 = r(Z0), XE0 = r(nr), YE0 = [0, [17, 0, 0], r(z2)], VE0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], zE0 = [0, [15, 0], r(N0)], KE0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], WE0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], JE0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], $E0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], ZE0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], QE0 = r("Flow_ast.Expression.ArgList.arguments"), rS0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], eS0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], nS0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], tS0 = [0, [17, 0, 0], r(z2)], uS0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], iS0 = r(Xr), fS0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], xS0 = r(tr), oS0 = r(Z0), aS0 = r(nr), cS0 = [0, [17, 0, 0], r(z2)], sS0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], vS0 = [0, [15, 0], r(N0)], lS0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], bS0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], pS0 = [0, [17, 0, [12, 41, 0]], r(d0)], mS0 = [0, [15, 0], r(N0)], _S0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Expression"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Expression@ ")], yS0 = [0, [17, 0, [12, 41, 0]], r(d0)], hS0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Spread"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Spread@ ")], dS0 = [0, [17, 0, [12, 41, 0]], r(d0)], kS0 = [0, [15, 0], r(N0)], wS0 = r(Yr), ES0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], SS0 = r("Flow_ast.Expression.Conditional.test"), gS0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], FS0 = [0, [17, 0, 0], r(z2)], TS0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], OS0 = r(kv), IS0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], AS0 = [0, [17, 0, 0], r(z2)], NS0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], CS0 = r(m3), PS0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], DS0 = [0, [17, 0, 0], r(z2)], LS0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], RS0 = r(Xr), jS0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], GS0 = r(tr), MS0 = r(Z0), BS0 = r(nr), qS0 = [0, [17, 0, 0], r(z2)], US0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], HS0 = [0, [15, 0], r(N0)], XS0 = r(Yr), YS0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], VS0 = r("Flow_ast.Expression.Logical.operator"), zS0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], KS0 = [0, [17, 0, 0], r(z2)], WS0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], JS0 = r(bi), $S0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ZS0 = [0, [17, 0, 0], r(z2)], QS0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], rg0 = r(Cu), eg0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ng0 = [0, [17, 0, 0], r(z2)], tg0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], ug0 = r(Xr), ig0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], fg0 = r(tr), xg0 = r(Z0), og0 = r(nr), ag0 = [0, [17, 0, 0], r(z2)], cg0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], sg0 = [0, [15, 0], r(N0)], vg0 = r("Flow_ast.Expression.Logical.Or"), lg0 = r("Flow_ast.Expression.Logical.And"), bg0 = r("Flow_ast.Expression.Logical.NullishCoalesce"), pg0 = [0, [15, 0], r(N0)], mg0 = r(Yr), _g0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], yg0 = r("Flow_ast.Expression.Update.operator"), hg0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], dg0 = [0, [17, 0, 0], r(z2)], kg0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], wg0 = r(l7), Eg0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Sg0 = [0, [17, 0, 0], r(z2)], gg0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Fg0 = r(qE), Tg0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Og0 = [0, [9, 0, 0], r(An)], Ig0 = [0, [17, 0, 0], r(z2)], Ag0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Ng0 = r(Xr), Cg0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Pg0 = r(tr), Dg0 = r(Z0), Lg0 = r(nr), Rg0 = [0, [17, 0, 0], r(z2)], jg0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Gg0 = [0, [15, 0], r(N0)], Mg0 = r("Flow_ast.Expression.Update.Decrement"), Bg0 = r("Flow_ast.Expression.Update.Increment"), qg0 = [0, [15, 0], r(N0)], Ug0 = r(Yr), Hg0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Xg0 = r("Flow_ast.Expression.Assignment.operator"), Yg0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Vg0 = r(tr), zg0 = r(Z0), Kg0 = r(nr), Wg0 = [0, [17, 0, 0], r(z2)], Jg0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], $g0 = r(bi), Zg0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Qg0 = [0, [17, 0, 0], r(z2)], rF0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], eF0 = r(Cu), nF0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], tF0 = [0, [17, 0, 0], r(z2)], uF0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], iF0 = r(Xr), fF0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], xF0 = r(tr), oF0 = r(Z0), aF0 = r(nr), cF0 = [0, [17, 0, 0], r(z2)], sF0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], vF0 = [0, [15, 0], r(N0)], lF0 = r("Flow_ast.Expression.Assignment.PlusAssign"), bF0 = r("Flow_ast.Expression.Assignment.MinusAssign"), pF0 = r("Flow_ast.Expression.Assignment.MultAssign"), mF0 = r("Flow_ast.Expression.Assignment.ExpAssign"), _F0 = r("Flow_ast.Expression.Assignment.DivAssign"), yF0 = r("Flow_ast.Expression.Assignment.ModAssign"), hF0 = r("Flow_ast.Expression.Assignment.LShiftAssign"), dF0 = r("Flow_ast.Expression.Assignment.RShiftAssign"), kF0 = r("Flow_ast.Expression.Assignment.RShift3Assign"), wF0 = r("Flow_ast.Expression.Assignment.BitOrAssign"), EF0 = r("Flow_ast.Expression.Assignment.BitXorAssign"), SF0 = r("Flow_ast.Expression.Assignment.BitAndAssign"), gF0 = r("Flow_ast.Expression.Assignment.NullishAssign"), FF0 = r("Flow_ast.Expression.Assignment.AndAssign"), TF0 = r("Flow_ast.Expression.Assignment.OrAssign"), OF0 = [0, [15, 0], r(N0)], IF0 = r(Yr), AF0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], NF0 = r("Flow_ast.Expression.Binary.operator"), CF0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], PF0 = [0, [17, 0, 0], r(z2)], DF0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], LF0 = r(bi), RF0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], jF0 = [0, [17, 0, 0], r(z2)], GF0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], MF0 = r(Cu), BF0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], qF0 = [0, [17, 0, 0], r(z2)], UF0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], HF0 = r(Xr), XF0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], YF0 = r(tr), VF0 = r(Z0), zF0 = r(nr), KF0 = [0, [17, 0, 0], r(z2)], WF0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], JF0 = [0, [15, 0], r(N0)], $F0 = r("Flow_ast.Expression.Binary.Equal"), ZF0 = r("Flow_ast.Expression.Binary.NotEqual"), QF0 = r("Flow_ast.Expression.Binary.StrictEqual"), rT0 = r("Flow_ast.Expression.Binary.StrictNotEqual"), eT0 = r("Flow_ast.Expression.Binary.LessThan"), nT0 = r("Flow_ast.Expression.Binary.LessThanEqual"), tT0 = r("Flow_ast.Expression.Binary.GreaterThan"), uT0 = r("Flow_ast.Expression.Binary.GreaterThanEqual"), iT0 = r("Flow_ast.Expression.Binary.LShift"), fT0 = r("Flow_ast.Expression.Binary.RShift"), xT0 = r("Flow_ast.Expression.Binary.RShift3"), oT0 = r("Flow_ast.Expression.Binary.Plus"), aT0 = r("Flow_ast.Expression.Binary.Minus"), cT0 = r("Flow_ast.Expression.Binary.Mult"), sT0 = r("Flow_ast.Expression.Binary.Exp"), vT0 = r("Flow_ast.Expression.Binary.Div"), lT0 = r("Flow_ast.Expression.Binary.Mod"), bT0 = r("Flow_ast.Expression.Binary.BitOr"), pT0 = r("Flow_ast.Expression.Binary.Xor"), mT0 = r("Flow_ast.Expression.Binary.BitAnd"), _T0 = r("Flow_ast.Expression.Binary.In"), yT0 = r("Flow_ast.Expression.Binary.Instanceof"), hT0 = [0, [15, 0], r(N0)], dT0 = r(Yr), kT0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], wT0 = r("Flow_ast.Expression.Unary.operator"), ET0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ST0 = [0, [17, 0, 0], r(z2)], gT0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], FT0 = r(l7), TT0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], OT0 = [0, [17, 0, 0], r(z2)], IT0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], AT0 = r(Xr), NT0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], CT0 = r(tr), PT0 = r(Z0), DT0 = r(nr), LT0 = [0, [17, 0, 0], r(z2)], RT0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], jT0 = [0, [15, 0], r(N0)], GT0 = r("Flow_ast.Expression.Unary.Minus"), MT0 = r("Flow_ast.Expression.Unary.Plus"), BT0 = r("Flow_ast.Expression.Unary.Not"), qT0 = r("Flow_ast.Expression.Unary.BitNot"), UT0 = r("Flow_ast.Expression.Unary.Typeof"), HT0 = r("Flow_ast.Expression.Unary.Void"), XT0 = r("Flow_ast.Expression.Unary.Delete"), YT0 = r("Flow_ast.Expression.Unary.Await"), VT0 = [0, [15, 0], r(N0)], zT0 = r(Yr), KT0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], WT0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], JT0 = r("Flow_ast.Expression.Sequence.expressions"), $T0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ZT0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], QT0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], rO0 = [0, [17, 0, 0], r(z2)], eO0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], nO0 = r(Xr), tO0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], uO0 = r(tr), iO0 = r(Z0), fO0 = r(nr), xO0 = [0, [17, 0, 0], r(z2)], oO0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], aO0 = [0, [15, 0], r(N0)], cO0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], sO0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], vO0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], lO0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], bO0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], pO0 = r("Flow_ast.Expression.Object.properties"), mO0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], _O0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], yO0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], hO0 = [0, [17, 0, 0], r(z2)], dO0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], kO0 = r(Xr), wO0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], EO0 = r(tr), SO0 = r(Z0), gO0 = r(nr), FO0 = [0, [17, 0, 0], r(z2)], TO0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], OO0 = [0, [15, 0], r(N0)], IO0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Object.Property"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Object.Property@ ")], AO0 = [0, [17, 0, [12, 41, 0]], r(d0)], NO0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Object.SpreadProperty"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Object.SpreadProperty@ ")], CO0 = [0, [17, 0, [12, 41, 0]], r(d0)], PO0 = [0, [15, 0], r(N0)], DO0 = r(Yr), LO0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], RO0 = r("Flow_ast.Expression.Object.SpreadProperty.argument"), jO0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], GO0 = [0, [17, 0, 0], r(z2)], MO0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], BO0 = r(Xr), qO0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], UO0 = r(tr), HO0 = r(Z0), XO0 = r(nr), YO0 = [0, [17, 0, 0], r(z2)], VO0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], zO0 = [0, [15, 0], r(N0)], KO0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], WO0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], JO0 = [0, [17, 0, [12, 41, 0]], r(d0)], $O0 = [0, [15, 0], r(N0)], ZO0 = r(Yr), QO0 = r(Yr), rI0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Object.Property.Init {"), [17, [0, r(Ce), 0, 0], 0]]], r("@[<2>Flow_ast.Expression.Object.Property.Init {@,")], eI0 = r(ii), nI0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], tI0 = [0, [17, 0, 0], r(z2)], uI0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], iI0 = r(Bn), fI0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], xI0 = [0, [17, 0, 0], r(z2)], oI0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], aI0 = r(f6), cI0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], sI0 = [0, [9, 0, 0], r(An)], vI0 = [0, [17, 0, 0], r(z2)], lI0 = [0, [17, 0, [12, br, 0]], r(Y6)], bI0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Object.Property.Method {"), [17, [0, r(Ce), 0, 0], 0]]], r("@[<2>Flow_ast.Expression.Object.Property.Method {@,")], pI0 = r(ii), mI0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], _I0 = [0, [17, 0, 0], r(z2)], yI0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], hI0 = r(Bn), dI0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], kI0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], wI0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], EI0 = [0, [17, 0, [12, 41, 0]], r(d0)], SI0 = [0, [17, 0, 0], r(z2)], gI0 = [0, [17, 0, [12, br, 0]], r(Y6)], FI0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Object.Property.Get {"), [17, [0, r(Ce), 0, 0], 0]]], r("@[<2>Flow_ast.Expression.Object.Property.Get {@,")], TI0 = r(ii), OI0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], II0 = [0, [17, 0, 0], r(z2)], AI0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], NI0 = r(Bn), CI0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], PI0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], DI0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], LI0 = [0, [17, 0, [12, 41, 0]], r(d0)], RI0 = [0, [17, 0, 0], r(z2)], jI0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], GI0 = r(Xr), MI0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], BI0 = r(tr), qI0 = r(Z0), UI0 = r(nr), HI0 = [0, [17, 0, 0], r(z2)], XI0 = [0, [17, 0, [12, br, 0]], r(Y6)], YI0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Object.Property.Set {"), [17, [0, r(Ce), 0, 0], 0]]], r("@[<2>Flow_ast.Expression.Object.Property.Set {@,")], VI0 = r(ii), zI0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], KI0 = [0, [17, 0, 0], r(z2)], WI0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], JI0 = r(Bn), $I0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ZI0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], QI0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], rA0 = [0, [17, 0, [12, 41, 0]], r(d0)], eA0 = [0, [17, 0, 0], r(z2)], nA0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], tA0 = r(Xr), uA0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], iA0 = r(tr), fA0 = r(Z0), xA0 = r(nr), oA0 = [0, [17, 0, 0], r(z2)], aA0 = [0, [17, 0, [12, br, 0]], r(Y6)], cA0 = [0, [15, 0], r(N0)], sA0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], vA0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], lA0 = [0, [17, 0, [12, 41, 0]], r(d0)], bA0 = [0, [15, 0], r(N0)], pA0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Object.Property.Literal"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Object.Property.Literal@ ")], mA0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], _A0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], yA0 = [0, [17, 0, [12, 41, 0]], r(d0)], hA0 = [0, [17, 0, [12, 41, 0]], r(d0)], dA0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Object.Property.Identifier"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Object.Property.Identifier@ ")], kA0 = [0, [17, 0, [12, 41, 0]], r(d0)], wA0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Object.Property.PrivateName"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Object.Property.PrivateName@ ")], EA0 = [0, [17, 0, [12, 41, 0]], r(d0)], SA0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Object.Property.Computed"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Object.Property.Computed@ ")], gA0 = [0, [17, 0, [12, 41, 0]], r(d0)], FA0 = [0, [15, 0], r(N0)], TA0 = r(Yr), OA0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], IA0 = r("Flow_ast.Expression.TaggedTemplate.tag"), AA0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], NA0 = [0, [17, 0, 0], r(z2)], CA0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], PA0 = r(EY), DA0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], LA0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], RA0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], jA0 = [0, [17, 0, [12, 41, 0]], r(d0)], GA0 = [0, [17, 0, 0], r(z2)], MA0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], BA0 = r(Xr), qA0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], UA0 = r(tr), HA0 = r(Z0), XA0 = r(nr), YA0 = [0, [17, 0, 0], r(z2)], VA0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], zA0 = [0, [15, 0], r(N0)], KA0 = r(Yr), WA0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], JA0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], $A0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], ZA0 = r("Flow_ast.Expression.TemplateLiteral.quasis"), QA0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], rN0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], eN0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], nN0 = [0, [17, 0, 0], r(z2)], tN0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], uN0 = r(Mg), iN0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], fN0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], xN0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], oN0 = [0, [17, 0, 0], r(z2)], aN0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], cN0 = r(Xr), sN0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], vN0 = r(tr), lN0 = r(Z0), bN0 = r(nr), pN0 = [0, [17, 0, 0], r(z2)], mN0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], _N0 = [0, [15, 0], r(N0)], yN0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], hN0 = r("Flow_ast.Expression.TemplateLiteral.Element.value"), dN0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], kN0 = [0, [17, 0, 0], r(z2)], wN0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], EN0 = r(aU), SN0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], gN0 = [0, [9, 0, 0], r(An)], FN0 = [0, [17, 0, 0], r(z2)], TN0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], ON0 = [0, [15, 0], r(N0)], IN0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], AN0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], NN0 = [0, [17, 0, [12, 41, 0]], r(d0)], CN0 = [0, [15, 0], r(N0)], PN0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], DN0 = r("Flow_ast.Expression.TemplateLiteral.Element.raw"), LN0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], RN0 = [0, [3, 0, 0], r(Vt)], jN0 = [0, [17, 0, 0], r(z2)], GN0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], MN0 = r(PY), BN0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], qN0 = [0, [3, 0, 0], r(Vt)], UN0 = [0, [17, 0, 0], r(z2)], HN0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], XN0 = [0, [15, 0], r(N0)], YN0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], VN0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], zN0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], KN0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], WN0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], JN0 = r("Flow_ast.Expression.Array.elements"), $N0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ZN0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], QN0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], rC0 = [0, [17, 0, 0], r(z2)], eC0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], nC0 = r(Xr), tC0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], uC0 = r(tr), iC0 = r(Z0), fC0 = r(nr), xC0 = [0, [17, 0, 0], r(z2)], oC0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], aC0 = [0, [15, 0], r(N0)], cC0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Array.Expression"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Array.Expression@ ")], sC0 = [0, [17, 0, [12, 41, 0]], r(d0)], vC0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Array.Spread"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Array.Spread@ ")], lC0 = [0, [17, 0, [12, 41, 0]], r(d0)], bC0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.Array.Hole"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.Array.Hole@ ")], pC0 = [0, [17, 0, [12, 41, 0]], r(d0)], mC0 = [0, [15, 0], r(N0)], _C0 = r(Yr), yC0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], hC0 = r("Flow_ast.Expression.SpreadElement.argument"), dC0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], kC0 = [0, [17, 0, 0], r(z2)], wC0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], EC0 = r(Xr), SC0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], gC0 = r(tr), FC0 = r(Z0), TC0 = r(nr), OC0 = [0, [17, 0, 0], r(z2)], IC0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], AC0 = [0, [15, 0], r(N0)], NC0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], CC0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], PC0 = [0, [17, 0, [12, 41, 0]], r(d0)], DC0 = [0, [15, 0], r(N0)], LC0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], RC0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], jC0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], GC0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], MC0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], BC0 = r("Flow_ast.Expression.CallTypeArgs.arguments"), qC0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], UC0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], HC0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], XC0 = [0, [17, 0, 0], r(z2)], YC0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], VC0 = r(Xr), zC0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], KC0 = r(tr), WC0 = r(Z0), JC0 = r(nr), $C0 = [0, [17, 0, 0], r(z2)], ZC0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], QC0 = [0, [15, 0], r(N0)], rP0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], eP0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], nP0 = [0, [17, 0, [12, 41, 0]], r(d0)], tP0 = [0, [15, 0], r(N0)], uP0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.CallTypeArg.Explicit"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.CallTypeArg.Explicit@ ")], iP0 = [0, [17, 0, [12, 41, 0]], r(d0)], fP0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Expression.CallTypeArg.Implicit"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Expression.CallTypeArg.Implicit@ ")], xP0 = [0, [17, 0, [12, 41, 0]], r(d0)], oP0 = [0, [15, 0], r(N0)], aP0 = r(Yr), cP0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], sP0 = r("Flow_ast.Expression.CallTypeArg.Implicit.comments"), vP0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], lP0 = r(tr), bP0 = r(Z0), pP0 = r(nr), mP0 = [0, [17, 0, 0], r(z2)], _P0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], yP0 = [0, [15, 0], r(N0)], hP0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], dP0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], kP0 = [0, [17, 0, [12, 41, 0]], r(d0)], wP0 = [0, [15, 0], r(N0)], EP0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.Block"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.Block@ ")], SP0 = [0, [17, 0, [12, 41, 0]], r(d0)], gP0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.Break"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.Break@ ")], FP0 = [0, [17, 0, [12, 41, 0]], r(d0)], TP0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.ClassDeclaration"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.ClassDeclaration@ ")], OP0 = [0, [17, 0, [12, 41, 0]], r(d0)], IP0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.Continue"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.Continue@ ")], AP0 = [0, [17, 0, [12, 41, 0]], r(d0)], NP0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.Debugger"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.Debugger@ ")], CP0 = [0, [17, 0, [12, 41, 0]], r(d0)], PP0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareClass"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareClass@ ")], DP0 = [0, [17, 0, [12, 41, 0]], r(d0)], LP0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareExportDeclaration"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareExportDeclaration@ ")], RP0 = [0, [17, 0, [12, 41, 0]], r(d0)], jP0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareFunction"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareFunction@ ")], GP0 = [0, [17, 0, [12, 41, 0]], r(d0)], MP0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareInterface"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareInterface@ ")], BP0 = [0, [17, 0, [12, 41, 0]], r(d0)], qP0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareModule"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareModule@ ")], UP0 = [0, [17, 0, [12, 41, 0]], r(d0)], HP0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareModuleExports"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareModuleExports@ ")], XP0 = [0, [17, 0, [12, 41, 0]], r(d0)], YP0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareTypeAlias"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareTypeAlias@ ")], VP0 = [0, [17, 0, [12, 41, 0]], r(d0)], zP0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareOpaqueType"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareOpaqueType@ ")], KP0 = [0, [17, 0, [12, 41, 0]], r(d0)], WP0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareVariable"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareVariable@ ")], JP0 = [0, [17, 0, [12, 41, 0]], r(d0)], $P0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DoWhile"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DoWhile@ ")], ZP0 = [0, [17, 0, [12, 41, 0]], r(d0)], QP0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.Empty"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.Empty@ ")], rD0 = [0, [17, 0, [12, 41, 0]], r(d0)], eD0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.EnumDeclaration"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.EnumDeclaration@ ")], nD0 = [0, [17, 0, [12, 41, 0]], r(d0)], tD0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.ExportDefaultDeclaration"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.ExportDefaultDeclaration@ ")], uD0 = [0, [17, 0, [12, 41, 0]], r(d0)], iD0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.ExportNamedDeclaration"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.ExportNamedDeclaration@ ")], fD0 = [0, [17, 0, [12, 41, 0]], r(d0)], xD0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.Expression"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.Expression@ ")], oD0 = [0, [17, 0, [12, 41, 0]], r(d0)], aD0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.For"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.For@ ")], cD0 = [0, [17, 0, [12, 41, 0]], r(d0)], sD0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.ForIn"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.ForIn@ ")], vD0 = [0, [17, 0, [12, 41, 0]], r(d0)], lD0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.ForOf"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.ForOf@ ")], bD0 = [0, [17, 0, [12, 41, 0]], r(d0)], pD0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.FunctionDeclaration"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.FunctionDeclaration@ ")], mD0 = [0, [17, 0, [12, 41, 0]], r(d0)], _D0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.If"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.If@ ")], yD0 = [0, [17, 0, [12, 41, 0]], r(d0)], hD0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.ImportDeclaration"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.ImportDeclaration@ ")], dD0 = [0, [17, 0, [12, 41, 0]], r(d0)], kD0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.InterfaceDeclaration"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.InterfaceDeclaration@ ")], wD0 = [0, [17, 0, [12, 41, 0]], r(d0)], ED0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.Labeled"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.Labeled@ ")], SD0 = [0, [17, 0, [12, 41, 0]], r(d0)], gD0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.Return"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.Return@ ")], FD0 = [0, [17, 0, [12, 41, 0]], r(d0)], TD0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.Switch"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.Switch@ ")], OD0 = [0, [17, 0, [12, 41, 0]], r(d0)], ID0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.Throw"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.Throw@ ")], AD0 = [0, [17, 0, [12, 41, 0]], r(d0)], ND0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.Try"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.Try@ ")], CD0 = [0, [17, 0, [12, 41, 0]], r(d0)], PD0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.TypeAlias"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.TypeAlias@ ")], DD0 = [0, [17, 0, [12, 41, 0]], r(d0)], LD0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.OpaqueType"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.OpaqueType@ ")], RD0 = [0, [17, 0, [12, 41, 0]], r(d0)], jD0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.VariableDeclaration"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.VariableDeclaration@ ")], GD0 = [0, [17, 0, [12, 41, 0]], r(d0)], MD0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.While"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.While@ ")], BD0 = [0, [17, 0, [12, 41, 0]], r(d0)], qD0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.With"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.With@ ")], UD0 = [0, [17, 0, [12, 41, 0]], r(d0)], HD0 = [0, [15, 0], r(N0)], XD0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], YD0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], VD0 = [0, [17, 0, [12, 41, 0]], r(d0)], zD0 = [0, [15, 0], r(N0)], KD0 = r("Flow_ast.Statement.ExportValue"), WD0 = r("Flow_ast.Statement.ExportType"), JD0 = [0, [15, 0], r(N0)], $D0 = r(Yr), ZD0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], QD0 = r("Flow_ast.Statement.Empty.comments"), rL0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], eL0 = r(tr), nL0 = r(Z0), tL0 = r(nr), uL0 = [0, [17, 0, 0], r(z2)], iL0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], fL0 = [0, [15, 0], r(N0)], xL0 = r(Yr), oL0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], aL0 = r("Flow_ast.Statement.Expression.expression"), cL0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], sL0 = [0, [17, 0, 0], r(z2)], vL0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], lL0 = r(Zi), bL0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], pL0 = r(tr), mL0 = [0, [3, 0, 0], r(Vt)], _L0 = r(Z0), yL0 = r(nr), hL0 = [0, [17, 0, 0], r(z2)], dL0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], kL0 = r(Xr), wL0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], EL0 = r(tr), SL0 = r(Z0), gL0 = r(nr), FL0 = [0, [17, 0, 0], r(z2)], TL0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], OL0 = [0, [15, 0], r(N0)], IL0 = r(Yr), AL0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], NL0 = r("Flow_ast.Statement.ImportDeclaration.import_kind"), CL0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], PL0 = [0, [17, 0, 0], r(z2)], DL0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], LL0 = r(cc), RL0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], jL0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], GL0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], ML0 = [0, [17, 0, [12, 41, 0]], r(d0)], BL0 = [0, [17, 0, 0], r(z2)], qL0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], UL0 = r(_i), HL0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], XL0 = r(tr), YL0 = r(Z0), VL0 = r(nr), zL0 = [0, [17, 0, 0], r(z2)], KL0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], WL0 = r(Cv), JL0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], $L0 = r(tr), ZL0 = r(Z0), QL0 = r(nr), rR0 = [0, [17, 0, 0], r(z2)], eR0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], nR0 = r(Xr), tR0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], uR0 = r(tr), iR0 = r(Z0), fR0 = r(nr), xR0 = [0, [17, 0, 0], r(z2)], oR0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], aR0 = [0, [15, 0], r(N0)], cR0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], sR0 = r("Flow_ast.Statement.ImportDeclaration.kind"), vR0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], lR0 = r(tr), bR0 = r(Z0), pR0 = r(nr), mR0 = [0, [17, 0, 0], r(z2)], _R0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], yR0 = r(B2), hR0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], dR0 = r(tr), kR0 = r(Z0), wR0 = r(nr), ER0 = [0, [17, 0, 0], r(z2)], SR0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], gR0 = r("remote"), FR0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], TR0 = [0, [17, 0, 0], r(z2)], OR0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], IR0 = [0, [15, 0], r(N0)], AR0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], NR0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.ImportDeclaration.ImportNamedSpecifiers"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.ImportDeclaration.ImportNamedSpecifiers@ ")], CR0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], PR0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], DR0 = [0, [17, 0, [12, 41, 0]], r(d0)], LR0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.ImportDeclaration.ImportNamespaceSpecifier"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.ImportDeclaration.ImportNamespaceSpecifier@ ")], RR0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], jR0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], GR0 = [0, [17, 0, [12, 41, 0]], r(d0)], MR0 = [0, [17, 0, [12, 41, 0]], r(d0)], BR0 = [0, [15, 0], r(N0)], qR0 = r("Flow_ast.Statement.ImportDeclaration.ImportType"), UR0 = r("Flow_ast.Statement.ImportDeclaration.ImportTypeof"), HR0 = r("Flow_ast.Statement.ImportDeclaration.ImportValue"), XR0 = [0, [15, 0], r(N0)], YR0 = r(Yr), VR0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], zR0 = r("Flow_ast.Statement.DeclareExportDeclaration.default"), KR0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], WR0 = r(tr), JR0 = r(Z0), $R0 = r(nr), ZR0 = [0, [17, 0, 0], r(z2)], QR0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], rj0 = r(P2), ej0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], nj0 = r(tr), tj0 = r(Z0), uj0 = r(nr), ij0 = [0, [17, 0, 0], r(z2)], fj0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], xj0 = r(Cv), oj0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], aj0 = r(tr), cj0 = r(Z0), sj0 = r(nr), vj0 = [0, [17, 0, 0], r(z2)], lj0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], bj0 = r(cc), pj0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], mj0 = r(tr), _j0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], yj0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], hj0 = [0, [17, 0, [12, 41, 0]], r(d0)], dj0 = r(Z0), kj0 = r(nr), wj0 = [0, [17, 0, 0], r(z2)], Ej0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Sj0 = r(Xr), gj0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Fj0 = r(tr), Tj0 = r(Z0), Oj0 = r(nr), Ij0 = [0, [17, 0, 0], r(z2)], Aj0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Nj0 = [0, [15, 0], r(N0)], Cj0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareExportDeclaration.Variable"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareExportDeclaration.Variable@ ")], Pj0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Dj0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Lj0 = [0, [17, 0, [12, 41, 0]], r(d0)], Rj0 = [0, [17, 0, [12, 41, 0]], r(d0)], jj0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareExportDeclaration.Function"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareExportDeclaration.Function@ ")], Gj0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Mj0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Bj0 = [0, [17, 0, [12, 41, 0]], r(d0)], qj0 = [0, [17, 0, [12, 41, 0]], r(d0)], Uj0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareExportDeclaration.Class"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareExportDeclaration.Class@ ")], Hj0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Xj0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Yj0 = [0, [17, 0, [12, 41, 0]], r(d0)], Vj0 = [0, [17, 0, [12, 41, 0]], r(d0)], zj0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareExportDeclaration.DefaultType"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareExportDeclaration.DefaultType@ ")], Kj0 = [0, [17, 0, [12, 41, 0]], r(d0)], Wj0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareExportDeclaration.NamedType"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareExportDeclaration.NamedType@ ")], Jj0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], $j0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Zj0 = [0, [17, 0, [12, 41, 0]], r(d0)], Qj0 = [0, [17, 0, [12, 41, 0]], r(d0)], rG0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareExportDeclaration.NamedOpaqueType"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareExportDeclaration.NamedOpaqueType@ ")], eG0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], nG0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], tG0 = [0, [17, 0, [12, 41, 0]], r(d0)], uG0 = [0, [17, 0, [12, 41, 0]], r(d0)], iG0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareExportDeclaration.Interface"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareExportDeclaration.Interface@ ")], fG0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], xG0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], oG0 = [0, [17, 0, [12, 41, 0]], r(d0)], aG0 = [0, [17, 0, [12, 41, 0]], r(d0)], cG0 = [0, [15, 0], r(N0)], sG0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.ExportDefaultDeclaration.Declaration"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.ExportDefaultDeclaration.Declaration@ ")], vG0 = [0, [17, 0, [12, 41, 0]], r(d0)], lG0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.ExportDefaultDeclaration.Expression"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.ExportDefaultDeclaration.Expression@ ")], bG0 = [0, [17, 0, [12, 41, 0]], r(d0)], pG0 = [0, [15, 0], r(N0)], mG0 = r(Yr), _G0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], yG0 = r("Flow_ast.Statement.ExportDefaultDeclaration.default"), hG0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], dG0 = [0, [17, 0, 0], r(z2)], kG0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], wG0 = r(P2), EG0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], SG0 = [0, [17, 0, 0], r(z2)], gG0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], FG0 = r(Xr), TG0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], OG0 = r(tr), IG0 = r(Z0), AG0 = r(nr), NG0 = [0, [17, 0, 0], r(z2)], CG0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], PG0 = [0, [15, 0], r(N0)], DG0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], LG0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.ExportNamedDeclaration.ExportSpecifiers"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.ExportNamedDeclaration.ExportSpecifiers@ ")], RG0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], jG0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], GG0 = [0, [17, 0, [12, 41, 0]], r(d0)], MG0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.ExportNamedDeclaration.ExportBatchSpecifier"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.ExportNamedDeclaration.ExportBatchSpecifier@ ")], BG0 = [0, [17, 0, [12, 41, 0]], r(d0)], qG0 = [0, [15, 0], r(N0)], UG0 = r(Yr), HG0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], XG0 = r("Flow_ast.Statement.ExportNamedDeclaration.declaration"), YG0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], VG0 = r(tr), zG0 = r(Z0), KG0 = r(nr), WG0 = [0, [17, 0, 0], r(z2)], JG0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], $G0 = r(Cv), ZG0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], QG0 = r(tr), rM0 = r(Z0), eM0 = r(nr), nM0 = [0, [17, 0, 0], r(z2)], tM0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], uM0 = r(cc), iM0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], fM0 = r(tr), xM0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], oM0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], aM0 = [0, [17, 0, [12, 41, 0]], r(d0)], cM0 = r(Z0), sM0 = r(nr), vM0 = [0, [17, 0, 0], r(z2)], lM0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], bM0 = r("export_kind"), pM0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], mM0 = [0, [17, 0, 0], r(z2)], _M0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], yM0 = r(Xr), hM0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], dM0 = r(tr), kM0 = r(Z0), wM0 = r(nr), EM0 = [0, [17, 0, 0], r(z2)], SM0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], gM0 = [0, [15, 0], r(N0)], FM0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], TM0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], OM0 = r(tr), IM0 = r(Z0), AM0 = r(nr), NM0 = [0, [17, 0, [12, 41, 0]], r(d0)], CM0 = [0, [15, 0], r(N0)], PM0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], DM0 = r("Flow_ast.Statement.ExportNamedDeclaration.ExportSpecifier.local"), LM0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], RM0 = [0, [17, 0, 0], r(z2)], jM0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], GM0 = r(I4), MM0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], BM0 = r(tr), qM0 = r(Z0), UM0 = r(nr), HM0 = [0, [17, 0, 0], r(z2)], XM0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], YM0 = [0, [15, 0], r(N0)], VM0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], zM0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], KM0 = [0, [17, 0, [12, 41, 0]], r(d0)], WM0 = [0, [15, 0], r(N0)], JM0 = r(Yr), $M0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], ZM0 = r("Flow_ast.Statement.DeclareModuleExports.annot"), QM0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], rB0 = [0, [17, 0, 0], r(z2)], eB0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], nB0 = r(Xr), tB0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], uB0 = r(tr), iB0 = r(Z0), fB0 = r(nr), xB0 = [0, [17, 0, 0], r(z2)], oB0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], aB0 = [0, [15, 0], r(N0)], cB0 = r(Yr), sB0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], vB0 = r("Flow_ast.Statement.DeclareModule.id"), lB0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], bB0 = [0, [17, 0, 0], r(z2)], pB0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], mB0 = r(Wn), _B0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], yB0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], hB0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], dB0 = [0, [17, 0, [12, 41, 0]], r(d0)], kB0 = [0, [17, 0, 0], r(z2)], wB0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], EB0 = r($c), SB0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], gB0 = [0, [17, 0, 0], r(z2)], FB0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], TB0 = r(Xr), OB0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], IB0 = r(tr), AB0 = r(Z0), NB0 = r(nr), CB0 = [0, [17, 0, 0], r(z2)], PB0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], DB0 = [0, [15, 0], r(N0)], LB0 = r("Flow_ast.Statement.DeclareModule.ES"), RB0 = r("Flow_ast.Statement.DeclareModule.CommonJS"), jB0 = [0, [15, 0], r(N0)], GB0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareModule.Identifier"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareModule.Identifier@ ")], MB0 = [0, [17, 0, [12, 41, 0]], r(d0)], BB0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.DeclareModule.Literal"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.DeclareModule.Literal@ ")], qB0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], UB0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], HB0 = [0, [17, 0, [12, 41, 0]], r(d0)], XB0 = [0, [17, 0, [12, 41, 0]], r(d0)], YB0 = [0, [15, 0], r(N0)], VB0 = r(Yr), zB0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], KB0 = r("Flow_ast.Statement.DeclareFunction.id"), WB0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], JB0 = [0, [17, 0, 0], r(z2)], $B0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], ZB0 = r(Qc), QB0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], rq0 = [0, [17, 0, 0], r(z2)], eq0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], nq0 = r(r7), tq0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], uq0 = r(tr), iq0 = r(Z0), fq0 = r(nr), xq0 = [0, [17, 0, 0], r(z2)], oq0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], aq0 = r(Xr), cq0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], sq0 = r(tr), vq0 = r(Z0), lq0 = r(nr), bq0 = [0, [17, 0, 0], r(z2)], pq0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], mq0 = [0, [15, 0], r(N0)], _q0 = r(Yr), yq0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], hq0 = r("Flow_ast.Statement.DeclareVariable.id"), dq0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], kq0 = [0, [17, 0, 0], r(z2)], wq0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Eq0 = r(Qc), Sq0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], gq0 = [0, [17, 0, 0], r(z2)], Fq0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Tq0 = r(Xr), Oq0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Iq0 = r(tr), Aq0 = r(Z0), Nq0 = r(nr), Cq0 = [0, [17, 0, 0], r(z2)], Pq0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Dq0 = [0, [15, 0], r(N0)], Lq0 = r(Yr), Rq0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], jq0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Gq0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Mq0 = [0, [17, 0, [12, 41, 0]], r(d0)], Bq0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], qq0 = r("Flow_ast.Statement.DeclareClass.id"), Uq0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Hq0 = [0, [17, 0, 0], r(z2)], Xq0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Yq0 = r(sv), Vq0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], zq0 = r(tr), Kq0 = r(Z0), Wq0 = r(nr), Jq0 = [0, [17, 0, 0], r(z2)], $q0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Zq0 = r(Wn), Qq0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], rU0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], eU0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], nU0 = [0, [17, 0, [12, 41, 0]], r(d0)], tU0 = [0, [17, 0, 0], r(z2)], uU0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], iU0 = r(P7), fU0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], xU0 = r(tr), oU0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], aU0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], cU0 = [0, [17, 0, [12, 41, 0]], r(d0)], sU0 = r(Z0), vU0 = r(nr), lU0 = [0, [17, 0, 0], r(z2)], bU0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], pU0 = r(Hy), mU0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], _U0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], yU0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], hU0 = [0, [17, 0, 0], r(z2)], dU0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], kU0 = r(ws), wU0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], EU0 = r(tr), SU0 = r(Z0), gU0 = r(nr), FU0 = [0, [17, 0, 0], r(z2)], TU0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], OU0 = r(Xr), IU0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], AU0 = r(tr), NU0 = r(Z0), CU0 = r(nr), PU0 = [0, [17, 0, 0], r(z2)], DU0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], LU0 = [0, [15, 0], r(N0)], RU0 = r(Yr), jU0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], GU0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], MU0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], BU0 = [0, [17, 0, [12, 41, 0]], r(d0)], qU0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], UU0 = r("Flow_ast.Statement.Interface.id"), HU0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], XU0 = [0, [17, 0, 0], r(z2)], YU0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], VU0 = r(sv), zU0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], KU0 = r(tr), WU0 = r(Z0), JU0 = r(nr), $U0 = [0, [17, 0, 0], r(z2)], ZU0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], QU0 = r(P7), rH0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], eH0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], nH0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], tH0 = [0, [17, 0, 0], r(z2)], uH0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], iH0 = r(Wn), fH0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], xH0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], oH0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], aH0 = [0, [17, 0, [12, 41, 0]], r(d0)], cH0 = [0, [17, 0, 0], r(z2)], sH0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], vH0 = r(Xr), lH0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], bH0 = r(tr), pH0 = r(Z0), mH0 = r(nr), _H0 = [0, [17, 0, 0], r(z2)], yH0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], hH0 = [0, [15, 0], r(N0)], dH0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.EnumDeclaration.BooleanBody"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.EnumDeclaration.BooleanBody@ ")], kH0 = [0, [17, 0, [12, 41, 0]], r(d0)], wH0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.EnumDeclaration.NumberBody"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.EnumDeclaration.NumberBody@ ")], EH0 = [0, [17, 0, [12, 41, 0]], r(d0)], SH0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.EnumDeclaration.StringBody"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.EnumDeclaration.StringBody@ ")], gH0 = [0, [17, 0, [12, 41, 0]], r(d0)], FH0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.EnumDeclaration.SymbolBody"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.EnumDeclaration.SymbolBody@ ")], TH0 = [0, [17, 0, [12, 41, 0]], r(d0)], OH0 = [0, [15, 0], r(N0)], IH0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], AH0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], NH0 = [0, [17, 0, [12, 41, 0]], r(d0)], CH0 = [0, [15, 0], r(N0)], PH0 = r(Yr), DH0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], LH0 = r("Flow_ast.Statement.EnumDeclaration.id"), RH0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], jH0 = [0, [17, 0, 0], r(z2)], GH0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], MH0 = r(Wn), BH0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], qH0 = [0, [17, 0, 0], r(z2)], UH0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], HH0 = r(Xr), XH0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], YH0 = r(tr), VH0 = r(Z0), zH0 = r(nr), KH0 = [0, [17, 0, 0], r(z2)], WH0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], JH0 = [0, [15, 0], r(N0)], $H0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], ZH0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], QH0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], rX0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], eX0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], nX0 = r("Flow_ast.Statement.EnumDeclaration.SymbolBody.members"), tX0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], uX0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], iX0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], fX0 = [0, [17, 0, 0], r(z2)], xX0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], oX0 = r(w4), aX0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], cX0 = [0, [9, 0, 0], r(An)], sX0 = [0, [17, 0, 0], r(z2)], vX0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], lX0 = r(Xr), bX0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], pX0 = r(tr), mX0 = r(Z0), _X0 = r(nr), yX0 = [0, [17, 0, 0], r(z2)], hX0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], dX0 = [0, [15, 0], r(N0)], kX0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], wX0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], EX0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.EnumDeclaration.StringBody.Defaulted"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.EnumDeclaration.StringBody.Defaulted@ ")], SX0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], gX0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], FX0 = [0, [17, 0, [12, 41, 0]], r(d0)], TX0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.EnumDeclaration.StringBody.Initialized"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.EnumDeclaration.StringBody.Initialized@ ")], OX0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], IX0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], AX0 = [0, [17, 0, [12, 41, 0]], r(d0)], NX0 = [0, [15, 0], r(N0)], CX0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], PX0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], DX0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], LX0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], RX0 = r("Flow_ast.Statement.EnumDeclaration.StringBody.members"), jX0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], GX0 = [0, [17, 0, 0], r(z2)], MX0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], BX0 = r(Fk), qX0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], UX0 = [0, [9, 0, 0], r(An)], HX0 = [0, [17, 0, 0], r(z2)], XX0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], YX0 = r(w4), VX0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], zX0 = [0, [9, 0, 0], r(An)], KX0 = [0, [17, 0, 0], r(z2)], WX0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], JX0 = r(Xr), $X0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ZX0 = r(tr), QX0 = r(Z0), rY0 = r(nr), eY0 = [0, [17, 0, 0], r(z2)], nY0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], tY0 = [0, [15, 0], r(N0)], uY0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], iY0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], fY0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], xY0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], oY0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], aY0 = r("Flow_ast.Statement.EnumDeclaration.NumberBody.members"), cY0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], sY0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], vY0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], lY0 = [0, [17, 0, 0], r(z2)], bY0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], pY0 = r(Fk), mY0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], _Y0 = [0, [9, 0, 0], r(An)], yY0 = [0, [17, 0, 0], r(z2)], hY0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], dY0 = r(w4), kY0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], wY0 = [0, [9, 0, 0], r(An)], EY0 = [0, [17, 0, 0], r(z2)], SY0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], gY0 = r(Xr), FY0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], TY0 = r(tr), OY0 = r(Z0), IY0 = r(nr), AY0 = [0, [17, 0, 0], r(z2)], NY0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], CY0 = [0, [15, 0], r(N0)], PY0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], DY0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], LY0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], RY0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], jY0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], GY0 = r("Flow_ast.Statement.EnumDeclaration.BooleanBody.members"), MY0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], BY0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], qY0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], UY0 = [0, [17, 0, 0], r(z2)], HY0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], XY0 = r(Fk), YY0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], VY0 = [0, [9, 0, 0], r(An)], zY0 = [0, [17, 0, 0], r(z2)], KY0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], WY0 = r(w4), JY0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], $Y0 = [0, [9, 0, 0], r(An)], ZY0 = [0, [17, 0, 0], r(z2)], QY0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], rV0 = r(Xr), eV0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], nV0 = r(tr), tV0 = r(Z0), uV0 = r(nr), iV0 = [0, [17, 0, 0], r(z2)], fV0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], xV0 = [0, [15, 0], r(N0)], oV0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], aV0 = r("Flow_ast.Statement.EnumDeclaration.InitializedMember.id"), cV0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], sV0 = [0, [17, 0, 0], r(z2)], vV0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], lV0 = r(ji), bV0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], pV0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], mV0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], _V0 = [0, [17, 0, [12, 41, 0]], r(d0)], yV0 = [0, [17, 0, 0], r(z2)], hV0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], dV0 = [0, [15, 0], r(N0)], kV0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], wV0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], EV0 = [0, [17, 0, [12, 41, 0]], r(d0)], SV0 = [0, [15, 0], r(N0)], gV0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], FV0 = r("Flow_ast.Statement.EnumDeclaration.DefaultedMember.id"), TV0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], OV0 = [0, [17, 0, 0], r(z2)], IV0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], AV0 = [0, [15, 0], r(N0)], NV0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], CV0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], PV0 = [0, [17, 0, [12, 41, 0]], r(d0)], DV0 = [0, [15, 0], r(N0)], LV0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.ForOf.LeftDeclaration"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.ForOf.LeftDeclaration@ ")], RV0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], jV0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], GV0 = [0, [17, 0, [12, 41, 0]], r(d0)], MV0 = [0, [17, 0, [12, 41, 0]], r(d0)], BV0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.ForOf.LeftPattern"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.ForOf.LeftPattern@ ")], qV0 = [0, [17, 0, [12, 41, 0]], r(d0)], UV0 = [0, [15, 0], r(N0)], HV0 = r(Yr), XV0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], YV0 = r("Flow_ast.Statement.ForOf.left"), VV0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], zV0 = [0, [17, 0, 0], r(z2)], KV0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], WV0 = r(Cu), JV0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], $V0 = [0, [17, 0, 0], r(z2)], ZV0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], QV0 = r(Wn), rz0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ez0 = [0, [17, 0, 0], r(z2)], nz0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], tz0 = r(dx), uz0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], iz0 = [0, [9, 0, 0], r(An)], fz0 = [0, [17, 0, 0], r(z2)], xz0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], oz0 = r(Xr), az0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], cz0 = r(tr), sz0 = r(Z0), vz0 = r(nr), lz0 = [0, [17, 0, 0], r(z2)], bz0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], pz0 = [0, [15, 0], r(N0)], mz0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.ForIn.LeftDeclaration"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.ForIn.LeftDeclaration@ ")], _z0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], yz0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], hz0 = [0, [17, 0, [12, 41, 0]], r(d0)], dz0 = [0, [17, 0, [12, 41, 0]], r(d0)], kz0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.ForIn.LeftPattern"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.ForIn.LeftPattern@ ")], wz0 = [0, [17, 0, [12, 41, 0]], r(d0)], Ez0 = [0, [15, 0], r(N0)], Sz0 = r(Yr), gz0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Fz0 = r("Flow_ast.Statement.ForIn.left"), Tz0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Oz0 = [0, [17, 0, 0], r(z2)], Iz0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Az0 = r(Cu), Nz0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Cz0 = [0, [17, 0, 0], r(z2)], Pz0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Dz0 = r(Wn), Lz0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Rz0 = [0, [17, 0, 0], r(z2)], jz0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Gz0 = r(R8), Mz0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Bz0 = [0, [9, 0, 0], r(An)], qz0 = [0, [17, 0, 0], r(z2)], Uz0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Hz0 = r(Xr), Xz0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Yz0 = r(tr), Vz0 = r(Z0), zz0 = r(nr), Kz0 = [0, [17, 0, 0], r(z2)], Wz0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Jz0 = [0, [15, 0], r(N0)], $z0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.For.InitDeclaration"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.For.InitDeclaration@ ")], Zz0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Qz0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], rK0 = [0, [17, 0, [12, 41, 0]], r(d0)], eK0 = [0, [17, 0, [12, 41, 0]], r(d0)], nK0 = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Statement.For.InitExpression"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Statement.For.InitExpression@ ")], tK0 = [0, [17, 0, [12, 41, 0]], r(d0)], uK0 = [0, [15, 0], r(N0)], iK0 = r(Yr), fK0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], xK0 = r("Flow_ast.Statement.For.init"), oK0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], aK0 = r(tr), cK0 = r(Z0), sK0 = r(nr), vK0 = [0, [17, 0, 0], r(z2)], lK0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], bK0 = r(Ss), pK0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], mK0 = r(tr), _K0 = r(Z0), yK0 = r(nr), hK0 = [0, [17, 0, 0], r(z2)], dK0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], kK0 = r(fU), wK0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], EK0 = r(tr), SK0 = r(Z0), gK0 = r(nr), FK0 = [0, [17, 0, 0], r(z2)], TK0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], OK0 = r(Wn), IK0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], AK0 = [0, [17, 0, 0], r(z2)], NK0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], CK0 = r(Xr), PK0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], DK0 = r(tr), LK0 = r(Z0), RK0 = r(nr), jK0 = [0, [17, 0, 0], r(z2)], GK0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], MK0 = [0, [15, 0], r(N0)], BK0 = r(Yr), qK0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], UK0 = r("Flow_ast.Statement.DoWhile.body"), HK0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], XK0 = [0, [17, 0, 0], r(z2)], YK0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], VK0 = r(Ss), zK0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], KK0 = [0, [17, 0, 0], r(z2)], WK0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], JK0 = r(Xr), $K0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ZK0 = r(tr), QK0 = r(Z0), rW0 = r(nr), eW0 = [0, [17, 0, 0], r(z2)], nW0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], tW0 = [0, [15, 0], r(N0)], uW0 = r(Yr), iW0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], fW0 = r("Flow_ast.Statement.While.test"), xW0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], oW0 = [0, [17, 0, 0], r(z2)], aW0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], cW0 = r(Wn), sW0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], vW0 = [0, [17, 0, 0], r(z2)], lW0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], bW0 = r(Xr), pW0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], mW0 = r(tr), _W0 = r(Z0), yW0 = r(nr), hW0 = [0, [17, 0, 0], r(z2)], dW0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], kW0 = [0, [15, 0], r(N0)], wW0 = r("Flow_ast.Statement.VariableDeclaration.Var"), EW0 = r("Flow_ast.Statement.VariableDeclaration.Let"), SW0 = r("Flow_ast.Statement.VariableDeclaration.Const"), gW0 = [0, [15, 0], r(N0)], FW0 = r(Yr), TW0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], OW0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], IW0 = r("Flow_ast.Statement.VariableDeclaration.declarations"), AW0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], NW0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], CW0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], PW0 = [0, [17, 0, 0], r(z2)], DW0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], LW0 = r($c), RW0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], jW0 = [0, [17, 0, 0], r(z2)], GW0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], MW0 = r(Xr), BW0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], qW0 = r(tr), UW0 = r(Z0), HW0 = r(nr), XW0 = [0, [17, 0, 0], r(z2)], YW0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], VW0 = [0, [15, 0], r(N0)], zW0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], KW0 = r("Flow_ast.Statement.VariableDeclaration.Declarator.id"), WW0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], JW0 = [0, [17, 0, 0], r(z2)], $W0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], ZW0 = r(ji), QW0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], rJ0 = r(tr), eJ0 = r(Z0), nJ0 = r(nr), tJ0 = [0, [17, 0, 0], r(z2)], uJ0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], iJ0 = [0, [15, 0], r(N0)], fJ0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], xJ0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], oJ0 = [0, [17, 0, [12, 41, 0]], r(d0)], aJ0 = [0, [15, 0], r(N0)], cJ0 = r(Yr), sJ0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], vJ0 = r("Flow_ast.Statement.Try.block"), lJ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], bJ0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], pJ0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], mJ0 = [0, [17, 0, [12, 41, 0]], r(d0)], _J0 = [0, [17, 0, 0], r(z2)], yJ0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], hJ0 = r(MU), dJ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], kJ0 = r(tr), wJ0 = r(Z0), EJ0 = r(nr), SJ0 = [0, [17, 0, 0], r(z2)], gJ0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], FJ0 = r(CH), TJ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], OJ0 = r(tr), IJ0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], AJ0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], NJ0 = [0, [17, 0, [12, 41, 0]], r(d0)], CJ0 = r(Z0), PJ0 = r(nr), DJ0 = [0, [17, 0, 0], r(z2)], LJ0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], RJ0 = r(Xr), jJ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], GJ0 = r(tr), MJ0 = r(Z0), BJ0 = r(nr), qJ0 = [0, [17, 0, 0], r(z2)], UJ0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], HJ0 = [0, [15, 0], r(N0)], XJ0 = r(Yr), YJ0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], VJ0 = r("Flow_ast.Statement.Try.CatchClause.param"), zJ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], KJ0 = r(tr), WJ0 = r(Z0), JJ0 = r(nr), $J0 = [0, [17, 0, 0], r(z2)], ZJ0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], QJ0 = r(Wn), r$0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], e$0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], n$0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], t$0 = [0, [17, 0, [12, 41, 0]], r(d0)], u$0 = [0, [17, 0, 0], r(z2)], i$0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], f$0 = r(Xr), x$0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], o$0 = r(tr), a$0 = r(Z0), c$0 = r(nr), s$0 = [0, [17, 0, 0], r(z2)], v$0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], l$0 = [0, [15, 0], r(N0)], b$0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], p$0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], m$0 = [0, [17, 0, [12, 41, 0]], r(d0)], _$0 = [0, [15, 0], r(N0)], y$0 = r(Yr), h$0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], d$0 = r("Flow_ast.Statement.Throw.argument"), k$0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], w$0 = [0, [17, 0, 0], r(z2)], E$0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], S$0 = r(Xr), g$0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], F$0 = r(tr), T$0 = r(Z0), O$0 = r(nr), I$0 = [0, [17, 0, 0], r(z2)], A$0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], N$0 = [0, [15, 0], r(N0)], C$0 = r(Yr), P$0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], D$0 = r("Flow_ast.Statement.Return.argument"), L$0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], R$0 = r(tr), j$0 = r(Z0), G$0 = r(nr), M$0 = [0, [17, 0, 0], r(z2)], B$0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], q$0 = r(Xr), U$0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], H$0 = r(tr), X$0 = r(Z0), Y$0 = r(nr), V$0 = [0, [17, 0, 0], r(z2)], z$0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], K$0 = r("return_out"), W$0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], J$0 = [0, [17, 0, 0], r(z2)], $$0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Z$0 = [0, [15, 0], r(N0)], Q$0 = r(Yr), rZ0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], eZ0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], nZ0 = r("Flow_ast.Statement.Switch.discriminant"), tZ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], uZ0 = [0, [17, 0, 0], r(z2)], iZ0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], fZ0 = r(QX), xZ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], oZ0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], aZ0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], cZ0 = [0, [17, 0, 0], r(z2)], sZ0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], vZ0 = r(Xr), lZ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], bZ0 = r(tr), pZ0 = r(Z0), mZ0 = r(nr), _Z0 = [0, [17, 0, 0], r(z2)], yZ0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], hZ0 = r("exhaustive_out"), dZ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], kZ0 = [0, [17, 0, 0], r(z2)], wZ0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], EZ0 = [0, [15, 0], r(N0)], SZ0 = r(Yr), gZ0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], FZ0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], TZ0 = r("Flow_ast.Statement.Switch.Case.test"), OZ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], IZ0 = r(tr), AZ0 = r(Z0), NZ0 = r(nr), CZ0 = [0, [17, 0, 0], r(z2)], PZ0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], DZ0 = r(kv), LZ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], RZ0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], jZ0 = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], GZ0 = [0, [17, 0, 0], r(z2)], MZ0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], BZ0 = r(Xr), qZ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], UZ0 = r(tr), HZ0 = r(Z0), XZ0 = r(nr), YZ0 = [0, [17, 0, 0], r(z2)], VZ0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], zZ0 = [0, [15, 0], r(N0)], KZ0 = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], WZ0 = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], JZ0 = [0, [17, 0, [12, 41, 0]], r(d0)], $Z0 = [0, [15, 0], r(N0)], ZZ0 = r(Yr), QZ0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], rQ0 = r("Flow_ast.Statement.OpaqueType.id"), eQ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], nQ0 = [0, [17, 0, 0], r(z2)], tQ0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], uQ0 = r(sv), iQ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], fQ0 = r(tr), xQ0 = r(Z0), oQ0 = r(nr), aQ0 = [0, [17, 0, 0], r(z2)], cQ0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], sQ0 = r(mX), vQ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], lQ0 = r(tr), bQ0 = r(Z0), pQ0 = r(nr), mQ0 = [0, [17, 0, 0], r(z2)], _Q0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], yQ0 = r(SX), hQ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], dQ0 = r(tr), kQ0 = r(Z0), wQ0 = r(nr), EQ0 = [0, [17, 0, 0], r(z2)], SQ0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], gQ0 = r(Xr), FQ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], TQ0 = r(tr), OQ0 = r(Z0), IQ0 = r(nr), AQ0 = [0, [17, 0, 0], r(z2)], NQ0 = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], CQ0 = [0, [15, 0], r(N0)], PQ0 = r(Yr), DQ0 = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], LQ0 = r("Flow_ast.Statement.TypeAlias.id"), RQ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], jQ0 = [0, [17, 0, 0], r(z2)], GQ0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], MQ0 = r(sv), BQ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], qQ0 = r(tr), UQ0 = r(Z0), HQ0 = r(nr), XQ0 = [0, [17, 0, 0], r(z2)], YQ0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], VQ0 = r(Cu), zQ0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], KQ0 = [0, [17, 0, 0], r(z2)], WQ0 = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], JQ0 = r(Xr), $Q0 = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ZQ0 = r(tr), QQ0 = r(Z0), r0r = r(nr), e0r = [0, [17, 0, 0], r(z2)], n0r = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], t0r = [0, [15, 0], r(N0)], u0r = r(Yr), i0r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], f0r = r("Flow_ast.Statement.With._object"), x0r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], o0r = [0, [17, 0, 0], r(z2)], a0r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], c0r = r(Wn), s0r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], v0r = [0, [17, 0, 0], r(z2)], l0r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], b0r = r(Xr), p0r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], m0r = r(tr), _0r = r(Z0), y0r = r(nr), h0r = [0, [17, 0, 0], r(z2)], d0r = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], k0r = [0, [15, 0], r(N0)], w0r = r(Yr), E0r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], S0r = r("Flow_ast.Statement.Debugger.comments"), g0r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], F0r = r(tr), T0r = r(Z0), O0r = r(nr), I0r = [0, [17, 0, 0], r(z2)], A0r = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], N0r = [0, [15, 0], r(N0)], C0r = r(Yr), P0r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], D0r = r("Flow_ast.Statement.Continue.label"), L0r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], R0r = r(tr), j0r = r(Z0), G0r = r(nr), M0r = [0, [17, 0, 0], r(z2)], B0r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], q0r = r(Xr), U0r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], H0r = r(tr), X0r = r(Z0), Y0r = r(nr), V0r = [0, [17, 0, 0], r(z2)], z0r = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], K0r = [0, [15, 0], r(N0)], W0r = r(Yr), J0r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], $0r = r("Flow_ast.Statement.Break.label"), Z0r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Q0r = r(tr), rrr = r(Z0), err = r(nr), nrr = [0, [17, 0, 0], r(z2)], trr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], urr = r(Xr), irr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], frr = r(tr), xrr = r(Z0), orr = r(nr), arr = [0, [17, 0, 0], r(z2)], crr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], srr = [0, [15, 0], r(N0)], vrr = r(Yr), lrr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], brr = r("Flow_ast.Statement.Labeled.label"), prr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], mrr = [0, [17, 0, 0], r(z2)], _rr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], yrr = r(Wn), hrr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], drr = [0, [17, 0, 0], r(z2)], krr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], wrr = r(Xr), Err = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Srr = r(tr), grr = r(Z0), Frr = r(nr), Trr = [0, [17, 0, 0], r(z2)], Orr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Irr = [0, [15, 0], r(N0)], Arr = r(Yr), Nrr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Crr = r("Flow_ast.Statement.If.test"), Prr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Drr = [0, [17, 0, 0], r(z2)], Lrr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Rrr = r(kv), jrr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Grr = [0, [17, 0, 0], r(z2)], Mrr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Brr = r(m3), qrr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Urr = r(tr), Hrr = r(Z0), Xrr = r(nr), Yrr = [0, [17, 0, 0], r(z2)], Vrr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], zrr = r(Xr), Krr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Wrr = r(tr), Jrr = r(Z0), $rr = r(nr), Zrr = [0, [17, 0, 0], r(z2)], Qrr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], rer = [0, [15, 0], r(N0)], eer = r(Yr), ner = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], ter = r("Flow_ast.Statement.If.Alternate.body"), uer = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ier = [0, [17, 0, 0], r(z2)], fer = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], xer = r(Xr), oer = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], aer = r(tr), cer = r(Z0), ser = r(nr), ver = [0, [17, 0, 0], r(z2)], ler = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], ber = [0, [15, 0], r(N0)], per = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], mer = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], _er = [0, [17, 0, [12, 41, 0]], r(d0)], yer = [0, [15, 0], r(N0)], her = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], der = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], ker = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], wer = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Eer = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Ser = r("Flow_ast.Statement.Block.body"), ger = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Fer = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], Ter = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], Oer = [0, [17, 0, 0], r(z2)], Ier = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Aer = r(Xr), Ner = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Cer = r(tr), Per = r(Z0), Der = r(nr), Ler = [0, [17, 0, 0], r(z2)], Rer = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], jer = [0, [15, 0], r(N0)], Ger = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Predicate.Declared"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Predicate.Declared@ ")], Mer = [0, [17, 0, [12, 41, 0]], r(d0)], Ber = r("Flow_ast.Type.Predicate.Inferred"), qer = [0, [15, 0], r(N0)], Uer = r(Yr), Her = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Xer = r("Flow_ast.Type.Predicate.kind"), Yer = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Ver = [0, [17, 0, 0], r(z2)], zer = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Ker = r(Xr), Wer = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Jer = r(tr), $er = r(Z0), Zer = r(nr), Qer = [0, [17, 0, 0], r(z2)], rnr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], enr = [0, [15, 0], r(N0)], nnr = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], tnr = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], unr = [0, [17, 0, [12, 41, 0]], r(d0)], inr = [0, [15, 0], r(N0)], fnr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], xnr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], onr = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], anr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], cnr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], snr = r("Flow_ast.Type.TypeArgs.arguments"), vnr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], lnr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], bnr = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], pnr = [0, [17, 0, 0], r(z2)], mnr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], _nr = r(Xr), ynr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], hnr = r(tr), dnr = r(Z0), knr = r(nr), wnr = [0, [17, 0, 0], r(z2)], Enr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Snr = [0, [15, 0], r(N0)], gnr = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Fnr = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Tnr = [0, [17, 0, [12, 41, 0]], r(d0)], Onr = [0, [15, 0], r(N0)], Inr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Anr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], Nnr = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], Cnr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Pnr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Dnr = r("Flow_ast.Type.TypeParams.params"), Lnr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Rnr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], jnr = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], Gnr = [0, [17, 0, 0], r(z2)], Mnr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Bnr = r(Xr), qnr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Unr = r(tr), Hnr = r(Z0), Xnr = r(nr), Ynr = [0, [17, 0, 0], r(z2)], Vnr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], znr = [0, [15, 0], r(N0)], Knr = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Wnr = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Jnr = [0, [17, 0, [12, 41, 0]], r(d0)], $nr = [0, [15, 0], r(N0)], Znr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Qnr = r("Flow_ast.Type.TypeParam.name"), rtr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], etr = [0, [17, 0, 0], r(z2)], ntr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], ttr = r(DU), utr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], itr = [0, [17, 0, 0], r(z2)], ftr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], xtr = r(cu), otr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], atr = r(tr), ctr = r(Z0), str2 = r(nr), vtr = [0, [17, 0, 0], r(z2)], ltr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], btr = r(_i), ptr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], mtr = r(tr), _tr = r(Z0), ytr = r(nr), htr = [0, [17, 0, 0], r(z2)], dtr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], ktr = [0, [15, 0], r(N0)], wtr = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Etr = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Str = [0, [17, 0, [12, 41, 0]], r(d0)], gtr = [0, [15, 0], r(N0)], Ftr = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Missing"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Missing@ ")], Ttr = [0, [17, 0, [12, 41, 0]], r(d0)], Otr = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Available"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Available@ ")], Itr = [0, [17, 0, [12, 41, 0]], r(d0)], Atr = [0, [15, 0], r(N0)], Ntr = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Ctr = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Ptr = [0, [17, 0, [12, 41, 0]], r(d0)], Dtr = [0, [15, 0], r(N0)], Ltr = r(Yr), Rtr = r(Yr), jtr = r(Yr), Gtr = r(Yr), Mtr = r(Yr), Btr = r(Yr), qtr = r(Yr), Utr = r(Yr), Htr = r(Yr), Xtr = r(Yr), Ytr = r(Yr), Vtr = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Any"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Any@ ")], ztr = r(tr), Ktr = r(Z0), Wtr = r(nr), Jtr = [0, [17, 0, [12, 41, 0]], r(d0)], $tr = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Mixed"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Mixed@ ")], Ztr = r(tr), Qtr = r(Z0), rur = r(nr), eur = [0, [17, 0, [12, 41, 0]], r(d0)], nur = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Empty"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Empty@ ")], tur = r(tr), uur = r(Z0), iur = r(nr), fur = [0, [17, 0, [12, 41, 0]], r(d0)], xur = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Void"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Void@ ")], our = r(tr), aur = r(Z0), cur = r(nr), sur = [0, [17, 0, [12, 41, 0]], r(d0)], vur = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Null"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Null@ ")], lur = r(tr), bur = r(Z0), pur = r(nr), mur = [0, [17, 0, [12, 41, 0]], r(d0)], _ur = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Number"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Number@ ")], yur = r(tr), hur = r(Z0), dur = r(nr), kur = [0, [17, 0, [12, 41, 0]], r(d0)], wur = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.BigInt"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.BigInt@ ")], Eur = r(tr), Sur = r(Z0), gur = r(nr), Fur = [0, [17, 0, [12, 41, 0]], r(d0)], Tur = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.String"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.String@ ")], Our = r(tr), Iur = r(Z0), Aur = r(nr), Nur = [0, [17, 0, [12, 41, 0]], r(d0)], Cur = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Boolean"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Boolean@ ")], Pur = r(tr), Dur = r(Z0), Lur = r(nr), Rur = [0, [17, 0, [12, 41, 0]], r(d0)], jur = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Symbol"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Symbol@ ")], Gur = r(tr), Mur = r(Z0), Bur = r(nr), qur = [0, [17, 0, [12, 41, 0]], r(d0)], Uur = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Exists"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Exists@ ")], Hur = r(tr), Xur = r(Z0), Yur = r(nr), Vur = [0, [17, 0, [12, 41, 0]], r(d0)], zur = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Nullable"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Nullable@ ")], Kur = [0, [17, 0, [12, 41, 0]], r(d0)], Wur = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Function"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Function@ ")], Jur = [0, [17, 0, [12, 41, 0]], r(d0)], $ur = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Object"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Object@ ")], Zur = [0, [17, 0, [12, 41, 0]], r(d0)], Qur = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Interface"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Interface@ ")], r7r = [0, [17, 0, [12, 41, 0]], r(d0)], e7r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Array"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Array@ ")], n7r = [0, [17, 0, [12, 41, 0]], r(d0)], t7r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Generic"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Generic@ ")], u7r = [0, [17, 0, [12, 41, 0]], r(d0)], i7r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.IndexedAccess"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.IndexedAccess@ ")], f7r = [0, [17, 0, [12, 41, 0]], r(d0)], x7r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.OptionalIndexedAccess"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.OptionalIndexedAccess@ ")], o7r = [0, [17, 0, [12, 41, 0]], r(d0)], a7r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Union"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Union@ ")], c7r = [0, [17, 0, [12, 41, 0]], r(d0)], s7r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Intersection"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Intersection@ ")], v7r = [0, [17, 0, [12, 41, 0]], r(d0)], l7r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Typeof"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Typeof@ ")], b7r = [0, [17, 0, [12, 41, 0]], r(d0)], p7r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Tuple"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Tuple@ ")], m7r = [0, [17, 0, [12, 41, 0]], r(d0)], _7r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.StringLiteral"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.StringLiteral@ ")], y7r = [0, [17, 0, [12, 41, 0]], r(d0)], h7r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.NumberLiteral"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.NumberLiteral@ ")], d7r = [0, [17, 0, [12, 41, 0]], r(d0)], k7r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.BigIntLiteral"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.BigIntLiteral@ ")], w7r = [0, [17, 0, [12, 41, 0]], r(d0)], E7r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.BooleanLiteral"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.BooleanLiteral@ ")], S7r = [0, [17, 0, [12, 41, 0]], r(d0)], g7r = [0, [15, 0], r(N0)], F7r = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], T7r = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], O7r = [0, [17, 0, [12, 41, 0]], r(d0)], I7r = [0, [15, 0], r(N0)], A7r = r(Yr), N7r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], C7r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], P7r = r("Flow_ast.Type.Intersection.types"), D7r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], L7r = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], R7r = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], j7r = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], G7r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], M7r = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], B7r = [0, [17, 0, [12, 41, 0]], r(d0)], q7r = [0, [17, 0, 0], r(z2)], U7r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], H7r = r(Xr), X7r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Y7r = r(tr), V7r = r(Z0), z7r = r(nr), K7r = [0, [17, 0, 0], r(z2)], W7r = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], J7r = [0, [15, 0], r(N0)], $7r = r(Yr), Z7r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Q7r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], rir = r("Flow_ast.Type.Union.types"), eir = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], nir = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], tir = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], uir = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], iir = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], fir = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], xir = [0, [17, 0, [12, 41, 0]], r(d0)], oir = [0, [17, 0, 0], r(z2)], air = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], cir = r(Xr), sir = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], vir = r(tr), lir = r(Z0), bir = r(nr), pir = [0, [17, 0, 0], r(z2)], mir = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], _ir = [0, [15, 0], r(N0)], yir = r(Yr), hir = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], dir = r("Flow_ast.Type.Array.argument"), kir = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], wir = [0, [17, 0, 0], r(z2)], Eir = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Sir = r(Xr), gir = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Fir = r(tr), Tir = r(Z0), Oir = r(nr), Iir = [0, [17, 0, 0], r(z2)], Air = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Nir = [0, [15, 0], r(N0)], Cir = r(Yr), Pir = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Dir = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Lir = r("Flow_ast.Type.Tuple.types"), Rir = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], jir = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], Gir = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], Mir = [0, [17, 0, 0], r(z2)], Bir = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], qir = r(Xr), Uir = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Hir = r(tr), Xir = r(Z0), Yir = r(nr), Vir = [0, [17, 0, 0], r(z2)], zir = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Kir = [0, [15, 0], r(N0)], Wir = r(Yr), Jir = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], $ir = r("Flow_ast.Type.Typeof.argument"), Zir = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Qir = [0, [17, 0, 0], r(z2)], rfr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], efr = r(Xr), nfr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], tfr = r(tr), ufr = r(Z0), ifr = r(nr), ffr = [0, [17, 0, 0], r(z2)], xfr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], ofr = [0, [15, 0], r(N0)], afr = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], cfr = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], sfr = [0, [17, 0, [12, 41, 0]], r(d0)], vfr = [0, [15, 0], r(N0)], lfr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], bfr = r("Flow_ast.Type.Typeof.Target.qualification"), pfr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], mfr = [0, [17, 0, 0], r(z2)], _fr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], yfr = r(mt), hfr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], dfr = [0, [17, 0, 0], r(z2)], kfr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], wfr = [0, [15, 0], r(N0)], Efr = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Typeof.Target.Unqualified"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Typeof.Target.Unqualified@ ")], Sfr = [0, [17, 0, [12, 41, 0]], r(d0)], gfr = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Typeof.Target.Qualified"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Typeof.Target.Qualified@ ")], Ffr = [0, [17, 0, [12, 41, 0]], r(d0)], Tfr = [0, [15, 0], r(N0)], Ofr = r(Yr), Ifr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Afr = r("Flow_ast.Type.Nullable.argument"), Nfr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Cfr = [0, [17, 0, 0], r(z2)], Pfr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Dfr = r(Xr), Lfr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Rfr = r(tr), jfr = r(Z0), Gfr = r(nr), Mfr = [0, [17, 0, 0], r(z2)], Bfr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], qfr = [0, [15, 0], r(N0)], Ufr = r(Yr), Hfr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Xfr = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Yfr = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Vfr = [0, [17, 0, [12, 41, 0]], r(d0)], zfr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Kfr = r("Flow_ast.Type.Interface.body"), Wfr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Jfr = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], $fr = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Zfr = [0, [17, 0, [12, 41, 0]], r(d0)], Qfr = [0, [17, 0, 0], r(z2)], rxr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], exr = r(P7), nxr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], txr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], uxr = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], ixr = [0, [17, 0, 0], r(z2)], fxr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], xxr = r(Xr), oxr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], axr = r(tr), cxr = r(Z0), sxr = r(nr), vxr = [0, [17, 0, 0], r(z2)], lxr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], bxr = [0, [15, 0], r(N0)], pxr = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Object.Property"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Object.Property@ ")], mxr = [0, [17, 0, [12, 41, 0]], r(d0)], _xr = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Object.SpreadProperty"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Object.SpreadProperty@ ")], yxr = [0, [17, 0, [12, 41, 0]], r(d0)], hxr = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Object.Indexer"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Object.Indexer@ ")], dxr = [0, [17, 0, [12, 41, 0]], r(d0)], kxr = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Object.CallProperty"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Object.CallProperty@ ")], wxr = [0, [17, 0, [12, 41, 0]], r(d0)], Exr = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Object.InternalSlot"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Object.InternalSlot@ ")], Sxr = [0, [17, 0, [12, 41, 0]], r(d0)], gxr = [0, [15, 0], r(N0)], Fxr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Txr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], Oxr = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], Ixr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Axr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Nxr = r("Flow_ast.Type.Object.exact"), Cxr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Pxr = [0, [9, 0, 0], r(An)], Dxr = [0, [17, 0, 0], r(z2)], Lxr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Rxr = r(GY), jxr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Gxr = [0, [9, 0, 0], r(An)], Mxr = [0, [17, 0, 0], r(z2)], Bxr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], qxr = r(H4), Uxr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Hxr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], Xxr = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], Yxr = [0, [17, 0, 0], r(z2)], Vxr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], zxr = r(Xr), Kxr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Wxr = r(tr), Jxr = r(Z0), $xr = r(nr), Zxr = [0, [17, 0, 0], r(z2)], Qxr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], ror = [0, [15, 0], r(N0)], eor = r(Yr), nor = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], tor = r("Flow_ast.Type.Object.InternalSlot.id"), uor = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ior = [0, [17, 0, 0], r(z2)], xor = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], oor = r(Bn), aor = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], cor = [0, [17, 0, 0], r(z2)], sor = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], vor = r(qu), lor = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], bor = [0, [9, 0, 0], r(An)], por = [0, [17, 0, 0], r(z2)], mor = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], _or = r(nu), yor = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], hor = [0, [9, 0, 0], r(An)], dor = [0, [17, 0, 0], r(z2)], kor = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], wor = r(nU), Eor = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Sor = [0, [9, 0, 0], r(An)], gor = [0, [17, 0, 0], r(z2)], For = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Tor = r(Xr), Oor = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Ior = r(tr), Aor = r(Z0), Nor = r(nr), Cor = [0, [17, 0, 0], r(z2)], Por = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Dor = [0, [15, 0], r(N0)], Lor = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Ror = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], jor = [0, [17, 0, [12, 41, 0]], r(d0)], Gor = [0, [15, 0], r(N0)], Mor = r(Yr), Bor = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], qor = r("Flow_ast.Type.Object.CallProperty.value"), Uor = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Hor = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Xor = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Yor = [0, [17, 0, [12, 41, 0]], r(d0)], Vor = [0, [17, 0, 0], r(z2)], zor = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Kor = r(nu), Wor = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Jor = [0, [9, 0, 0], r(An)], $or = [0, [17, 0, 0], r(z2)], Zor = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Qor = r(Xr), rar = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ear = r(tr), nar = r(Z0), tar = r(nr), uar = [0, [17, 0, 0], r(z2)], iar = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], far = [0, [15, 0], r(N0)], xar = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], oar = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], aar = [0, [17, 0, [12, 41, 0]], r(d0)], car = [0, [15, 0], r(N0)], sar = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], lar = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], bar = [0, [17, 0, [12, 41, 0]], r(d0)], par = [0, [15, 0], r(N0)], mar = r(Yr), _ar = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], yar = r("Flow_ast.Type.Object.Indexer.id"), har = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], dar = r(tr), kar = r(Z0), war = r(nr), Ear = [0, [17, 0, 0], r(z2)], Sar = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], gar = r(ii), Far = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Tar = [0, [17, 0, 0], r(z2)], Oar = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Iar = r(Bn), Aar = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Nar = [0, [17, 0, 0], r(z2)], Car = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Par = r(nu), Dar = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Lar = [0, [9, 0, 0], r(An)], Rar = [0, [17, 0, 0], r(z2)], jar = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Gar = r(cu), Mar = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Bar = r(tr), qar = r(Z0), Uar = r(nr), Har = [0, [17, 0, 0], r(z2)], Xar = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Yar = r(Xr), Var = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], zar = r(tr), Kar = r(Z0), War = r(nr), Jar = [0, [17, 0, 0], r(z2)], $ar = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Zar = [0, [15, 0], r(N0)], Qar = r(Yr), rcr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], ecr = r("Flow_ast.Type.Object.SpreadProperty.argument"), ncr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], tcr = [0, [17, 0, 0], r(z2)], ucr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], icr = r(Xr), fcr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], xcr = r(tr), ocr = r(Z0), acr = r(nr), ccr = [0, [17, 0, 0], r(z2)], scr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], vcr = [0, [15, 0], r(N0)], lcr = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], bcr = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], pcr = [0, [17, 0, [12, 41, 0]], r(d0)], mcr = [0, [15, 0], r(N0)], _cr = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Object.Property.Init"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Object.Property.Init@ ")], ycr = [0, [17, 0, [12, 41, 0]], r(d0)], hcr = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Object.Property.Get"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Object.Property.Get@ ")], dcr = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], kcr = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], wcr = [0, [17, 0, [12, 41, 0]], r(d0)], Ecr = [0, [17, 0, [12, 41, 0]], r(d0)], Scr = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Object.Property.Set"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Object.Property.Set@ ")], gcr = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Fcr = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Tcr = [0, [17, 0, [12, 41, 0]], r(d0)], Ocr = [0, [17, 0, [12, 41, 0]], r(d0)], Icr = [0, [15, 0], r(N0)], Acr = r(Yr), Ncr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Ccr = r("Flow_ast.Type.Object.Property.key"), Pcr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Dcr = [0, [17, 0, 0], r(z2)], Lcr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Rcr = r(Bn), jcr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Gcr = [0, [17, 0, 0], r(z2)], Mcr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Bcr = r(qu), qcr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Ucr = [0, [9, 0, 0], r(An)], Hcr = [0, [17, 0, 0], r(z2)], Xcr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Ycr = r(nu), Vcr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], zcr = [0, [9, 0, 0], r(An)], Kcr = [0, [17, 0, 0], r(z2)], Wcr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Jcr = r(X3), $cr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Zcr = [0, [9, 0, 0], r(An)], Qcr = [0, [17, 0, 0], r(z2)], rsr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], esr = r(nU), nsr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], tsr = [0, [9, 0, 0], r(An)], usr = [0, [17, 0, 0], r(z2)], isr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], fsr = r(cu), xsr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], osr = r(tr), asr = r(Z0), csr = r(nr), ssr = [0, [17, 0, 0], r(z2)], vsr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], lsr = r(Xr), bsr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], psr = r(tr), msr = r(Z0), _sr = r(nr), ysr = [0, [17, 0, 0], r(z2)], hsr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], dsr = [0, [15, 0], r(N0)], ksr = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], wsr = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Esr = [0, [17, 0, [12, 41, 0]], r(d0)], Ssr = [0, [15, 0], r(N0)], gsr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Fsr = r("Flow_ast.Type.OptionalIndexedAccess.indexed_access"), Tsr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Osr = [0, [17, 0, 0], r(z2)], Isr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Asr = r(qu), Nsr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Csr = [0, [9, 0, 0], r(An)], Psr = [0, [17, 0, 0], r(z2)], Dsr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Lsr = [0, [15, 0], r(N0)], Rsr = r(Yr), jsr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Gsr = r("Flow_ast.Type.IndexedAccess._object"), Msr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Bsr = [0, [17, 0, 0], r(z2)], qsr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Usr = r("index"), Hsr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Xsr = [0, [17, 0, 0], r(z2)], Ysr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Vsr = r(Xr), zsr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Ksr = r(tr), Wsr = r(Z0), Jsr = r(nr), $sr = [0, [17, 0, 0], r(z2)], Zsr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Qsr = [0, [15, 0], r(N0)], r1r = r(Yr), e1r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], n1r = r("Flow_ast.Type.Generic.id"), t1r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], u1r = [0, [17, 0, 0], r(z2)], i1r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], f1r = r(Z2), x1r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], o1r = r(tr), a1r = r(Z0), c1r = r(nr), s1r = [0, [17, 0, 0], r(z2)], v1r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], l1r = r(Xr), b1r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], p1r = r(tr), m1r = r(Z0), _1r = r(nr), y1r = [0, [17, 0, 0], r(z2)], h1r = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], d1r = [0, [15, 0], r(N0)], k1r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], w1r = r("Flow_ast.Type.Generic.Identifier.qualification"), E1r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], S1r = [0, [17, 0, 0], r(z2)], g1r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], F1r = r(mt), T1r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], O1r = [0, [17, 0, 0], r(z2)], I1r = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], A1r = [0, [15, 0], r(N0)], N1r = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], C1r = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], P1r = [0, [17, 0, [12, 41, 0]], r(d0)], D1r = [0, [15, 0], r(N0)], L1r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Generic.Identifier.Unqualified"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Generic.Identifier.Unqualified@ ")], R1r = [0, [17, 0, [12, 41, 0]], r(d0)], j1r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Type.Generic.Identifier.Qualified"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Type.Generic.Identifier.Qualified@ ")], G1r = [0, [17, 0, [12, 41, 0]], r(d0)], M1r = [0, [15, 0], r(N0)], B1r = r(Yr), q1r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], U1r = r("Flow_ast.Type.Function.tparams"), H1r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], X1r = r(tr), Y1r = r(Z0), V1r = r(nr), z1r = [0, [17, 0, 0], r(z2)], K1r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], W1r = r(Dt), J1r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], $1r = [0, [17, 0, 0], r(z2)], Z1r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Q1r = r(Ju), rvr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], evr = [0, [17, 0, 0], r(z2)], nvr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], tvr = r(Xr), uvr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], ivr = r(tr), fvr = r(Z0), xvr = r(nr), ovr = [0, [17, 0, 0], r(z2)], avr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], cvr = [0, [15, 0], r(N0)], svr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], vvr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], lvr = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], bvr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], pvr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], mvr = r("Flow_ast.Type.Function.Params.this_"), _vr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], yvr = r(tr), hvr = r(Z0), dvr = r(nr), kvr = [0, [17, 0, 0], r(z2)], wvr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Evr = r(Dt), Svr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], gvr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], Fvr = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], Tvr = [0, [17, 0, 0], r(z2)], Ovr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Ivr = r(xd), Avr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Nvr = r(tr), Cvr = r(Z0), Pvr = r(nr), Dvr = [0, [17, 0, 0], r(z2)], Lvr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Rvr = r(Xr), jvr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Gvr = r(tr), Mvr = r(Z0), Bvr = r(nr), qvr = [0, [17, 0, 0], r(z2)], Uvr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Hvr = [0, [15, 0], r(N0)], Xvr = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Yvr = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Vvr = [0, [17, 0, [12, 41, 0]], r(d0)], zvr = [0, [15, 0], r(N0)], Kvr = r(Yr), Wvr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Jvr = r("Flow_ast.Type.Function.ThisParam.annot"), $vr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Zvr = [0, [17, 0, 0], r(z2)], Qvr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], r2r = r(Xr), e2r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], n2r = r(tr), t2r = r(Z0), u2r = r(nr), i2r = [0, [17, 0, 0], r(z2)], f2r = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], x2r = [0, [15, 0], r(N0)], o2r = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], a2r = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], c2r = [0, [17, 0, [12, 41, 0]], r(d0)], s2r = [0, [15, 0], r(N0)], v2r = r(Yr), l2r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], b2r = r("Flow_ast.Type.Function.RestParam.argument"), p2r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], m2r = [0, [17, 0, 0], r(z2)], _2r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], y2r = r(Xr), h2r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], d2r = r(tr), k2r = r(Z0), w2r = r(nr), E2r = [0, [17, 0, 0], r(z2)], S2r = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], g2r = [0, [15, 0], r(N0)], F2r = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], T2r = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], O2r = [0, [17, 0, [12, 41, 0]], r(d0)], I2r = [0, [15, 0], r(N0)], A2r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], N2r = r("Flow_ast.Type.Function.Param.name"), C2r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], P2r = r(tr), D2r = r(Z0), L2r = r(nr), R2r = [0, [17, 0, 0], r(z2)], j2r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], G2r = r(Qc), M2r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], B2r = [0, [17, 0, 0], r(z2)], q2r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], U2r = r(qu), H2r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], X2r = [0, [9, 0, 0], r(An)], Y2r = [0, [17, 0, 0], r(z2)], V2r = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], z2r = [0, [15, 0], r(N0)], K2r = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], W2r = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], J2r = [0, [17, 0, [12, 41, 0]], r(d0)], $2r = [0, [15, 0], r(N0)], Z2r = r(Yr), Q2r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], rlr = r("Flow_ast.ComputedKey.expression"), elr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], nlr = [0, [17, 0, 0], r(z2)], tlr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], ulr = r(Xr), ilr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], flr = r(tr), xlr = r(Z0), olr = r(nr), alr = [0, [17, 0, 0], r(z2)], clr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], slr = [0, [15, 0], r(N0)], vlr = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], llr = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], blr = [0, [17, 0, [12, 41, 0]], r(d0)], plr = [0, [15, 0], r(N0)], mlr = r(Yr), _lr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], ylr = r("Flow_ast.Variance.kind"), hlr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], dlr = [0, [17, 0, 0], r(z2)], klr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], wlr = r(Xr), Elr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Slr = r(tr), glr = r(Z0), Flr = r(nr), Tlr = [0, [17, 0, 0], r(z2)], Olr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], Ilr = [0, [15, 0], r(N0)], Alr = r("Flow_ast.Variance.Minus"), Nlr = r("Flow_ast.Variance.Plus"), Clr = [0, [15, 0], r(N0)], Plr = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], Dlr = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], Llr = [0, [17, 0, [12, 41, 0]], r(d0)], Rlr = [0, [15, 0], r(N0)], jlr = r(Yr), Glr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Mlr = r("Flow_ast.BooleanLiteral.value"), Blr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], qlr = [0, [9, 0, 0], r(An)], Ulr = [0, [17, 0, 0], r(z2)], Hlr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Xlr = r(Xr), Ylr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Vlr = r(tr), zlr = r(Z0), Klr = r(nr), Wlr = [0, [17, 0, 0], r(z2)], Jlr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], $lr = [0, [15, 0], r(N0)], Zlr = r(Yr), Qlr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], rbr = r("Flow_ast.BigIntLiteral.approx_value"), ebr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], nbr = [0, [8, [0, 0, 5], 0, 0, 0], r(r8)], tbr = [0, [17, 0, 0], r(z2)], ubr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], ibr = r(x1), fbr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], xbr = [0, [3, 0, 0], r(Vt)], obr = [0, [17, 0, 0], r(z2)], abr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], cbr = r(Xr), sbr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], vbr = r(tr), lbr = r(Z0), bbr = r(nr), pbr = [0, [17, 0, 0], r(z2)], mbr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], _br = [0, [15, 0], r(N0)], ybr = r(Yr), hbr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], dbr = r("Flow_ast.NumberLiteral.value"), kbr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], wbr = [0, [8, [0, 0, 5], 0, 0, 0], r(r8)], Ebr = [0, [17, 0, 0], r(z2)], Sbr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], gbr = r(c7), Fbr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Tbr = [0, [3, 0, 0], r(Vt)], Obr = [0, [17, 0, 0], r(z2)], Ibr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Abr = r(Xr), Nbr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Cbr = r(tr), Pbr = r(Z0), Dbr = r(nr), Lbr = [0, [17, 0, 0], r(z2)], Rbr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], jbr = [0, [15, 0], r(N0)], Gbr = r(Yr), Mbr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Bbr = r("Flow_ast.StringLiteral.value"), qbr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Ubr = [0, [3, 0, 0], r(Vt)], Hbr = [0, [17, 0, 0], r(z2)], Xbr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Ybr = r(c7), Vbr = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], zbr = [0, [3, 0, 0], r(Vt)], Kbr = [0, [17, 0, 0], r(z2)], Wbr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Jbr = r(Xr), $br = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Zbr = r(tr), Qbr = r(Z0), r4r = r(nr), e4r = [0, [17, 0, 0], r(z2)], n4r = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], t4r = [0, [15, 0], r(N0)], u4r = r("Flow_ast.Literal.Null"), i4r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Literal.String"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Literal.String@ ")], f4r = [0, [3, 0, 0], r(Vt)], x4r = [0, [17, 0, [12, 41, 0]], r(d0)], o4r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Literal.Boolean"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Literal.Boolean@ ")], a4r = [0, [9, 0, 0], r(An)], c4r = [0, [17, 0, [12, 41, 0]], r(d0)], s4r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Literal.Number"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Literal.Number@ ")], v4r = [0, [8, [0, 0, 5], 0, 0, 0], r(r8)], l4r = [0, [17, 0, [12, 41, 0]], r(d0)], b4r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Literal.BigInt"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Literal.BigInt@ ")], p4r = [0, [8, [0, 0, 5], 0, 0, 0], r(r8)], m4r = [0, [17, 0, [12, 41, 0]], r(d0)], _4r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("Flow_ast.Literal.RegExp"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>Flow_ast.Literal.RegExp@ ")], y4r = [0, [17, 0, [12, 41, 0]], r(d0)], h4r = [0, [15, 0], r(N0)], d4r = r(Yr), k4r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], w4r = r("Flow_ast.Literal.value"), E4r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], S4r = [0, [17, 0, 0], r(z2)], g4r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], F4r = r(c7), T4r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], O4r = [0, [3, 0, 0], r(Vt)], I4r = [0, [17, 0, 0], r(z2)], A4r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], N4r = r(Xr), C4r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], P4r = r(tr), D4r = r(Z0), L4r = r(nr), R4r = [0, [17, 0, 0], r(z2)], j4r = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], G4r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], M4r = r("Flow_ast.Literal.RegExp.pattern"), B4r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], q4r = [0, [3, 0, 0], r(Vt)], U4r = [0, [17, 0, 0], r(z2)], H4r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], X4r = r(jX), Y4r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], V4r = [0, [3, 0, 0], r(Vt)], z4r = [0, [17, 0, 0], r(z2)], K4r = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], W4r = [0, [15, 0], r(N0)], J4r = [0, [15, 0], r(N0)], $4r = r(Yr), Z4r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], Q4r = r("Flow_ast.PrivateName.name"), r8r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], e8r = [0, [3, 0, 0], r(Vt)], n8r = [0, [17, 0, 0], r(z2)], t8r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], u8r = r(Xr), i8r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], f8r = r(tr), x8r = r(Z0), o8r = r(nr), a8r = [0, [17, 0, 0], r(z2)], c8r = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], s8r = [0, [15, 0], r(N0)], v8r = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], l8r = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], b8r = [0, [17, 0, [12, 41, 0]], r(d0)], p8r = [0, [15, 0], r(N0)], m8r = r(Yr), _8r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], y8r = r("Flow_ast.Identifier.name"), h8r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], d8r = [0, [3, 0, 0], r(Vt)], k8r = [0, [17, 0, 0], r(z2)], w8r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], E8r = r(Xr), S8r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], g8r = r(tr), F8r = r(Z0), T8r = r(nr), O8r = [0, [17, 0, 0], r(z2)], I8r = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], A8r = [0, [15, 0], r(N0)], N8r = [0, [12, 40, [18, [1, [0, 0, r(C)]], 0]], r(Zr)], C8r = [0, [12, 44, [17, [0, r(v), 1, 0], 0]], r(zr)], P8r = [0, [17, 0, [12, 41, 0]], r(d0)], D8r = [0, [15, 0], r(N0)], L8r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], R8r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], j8r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], G8r = r("Flow_ast.Syntax.leading"), M8r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], B8r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], q8r = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], U8r = [0, [17, 0, 0], r(z2)], H8r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], X8r = r("trailing"), Y8r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], V8r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, 91, 0]], r(Ye)], z8r = [0, [17, [0, r(Ce), 0, 0], [12, 93, [17, 0, 0]]], r(Xe)], K8r = [0, [17, 0, 0], r(z2)], W8r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], J8r = r("internal"), $8r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], Z8r = [0, [17, 0, 0], r(z2)], Q8r = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], r3r = [0, [0, 0, 0]], e3r = [0, r(Su), 21, 2], n3r = [0, [0, 0, 0, 0, 0]], t3r = [0, r(Su), 32, 2], u3r = [0, [0, 0, 0, 0, 0]], i3r = [0, r(Su), 43, 2], f3r = [0, [0, [0, [0, 0, 0]], 0, 0, 0, 0]], x3r = [0, r(Su), 70, 2], o3r = [0, [0, 0, 0]], a3r = [0, r(Su), 80, 2], c3r = [0, [0, 0, 0]], s3r = [0, r(Su), 90, 2], v3r = [0, [0, 0, 0]], l3r = [0, r(Su), R7, 2], b3r = [0, [0, 0, 0]], p3r = [0, r(Su), Xt, 2], m3r = [0, [0, 0, 0, 0, 0, 0, 0]], _3r = [0, r(Su), br, 2], y3r = [0, [0, 0, 0, 0, 0]], h3r = [0, r(Su), KH, 2], d3r = [0, [0, [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0, 0, 0, 0, 0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]]]], k3r = [0, r(Su), 485, 2], w3r = [0, [0, [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0, 0, 0]], E3r = [0, r(Su), BX, 2], S3r = [0, [0, [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0]], g3r = [0, r(Su), 1460, 2], F3r = [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0, [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0, 0, 0, 0, 0]], T3r = [0, r(Su), 1604, 2], O3r = [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0]], I3r = [0, r(Su), 1689, 2], A3r = [0, [0, 0, 0, 0, 0, 0, 0]], N3r = [0, r(Su), 1705, 2], C3r = [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0]], P3r = [0, r(Su), 1828, 2], D3r = [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], L3r = [0, r(Su), 1895, 2], R3r = [0, [0, 0, 0, 0, 0]], j3r = [0, r(Su), 1907, 2], G3r = [0, [0, 0, 0]], M3r = [0, [0, 0, 0, 0, 0]], B3r = [0, [0, 0, 0, 0, 0]], q3r = [0, [0, [0, [0, 0, 0]], 0, 0, 0, 0]], U3r = [0, [0, 0, 0]], H3r = [0, [0, 0, 0]], X3r = [0, [0, 0, 0]], Y3r = [0, [0, 0, 0]], V3r = [0, [0, 0, 0, 0, 0, 0, 0]], z3r = [0, [0, 0, 0, 0, 0]], K3r = [0, [0, [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0, 0, 0, 0, 0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]]]], W3r = [0, [0, [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0, 0, 0]], J3r = [0, [0, [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0]], $3r = [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0, [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0, 0, 0, 0, 0]], Z3r = [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0]], Q3r = [0, [0, 0, 0, 0, 0, 0, 0]], r6r = [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0]], e6r = [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], n6r = [0, [0, 0, 0, 0, 0]], t6r = [0, 1], u6r = [0, 0], i6r = [0, 2], f6r = [0, 0], x6r = [0, 1], o6r = [0, 1], a6r = [0, 1], c6r = [0, 1], s6r = [0, 1], v6r = [0, 0, 0], l6r = [0, 0, 0], b6r = [0, r(Eu), r(Yx), r(to), r(Oo), r(cu), r(dc), r(ux), r(oc), r(Gf), r(To), r(Po), r(ec), r(No), r(wf), r(Ja), r(uo), r(Cx), r(Ff), r(ax), r(Oa), r(qf), r(Ro), r(Ka), r(Xx), r(Jx), r(_x), r(xo), r(fa), r(no), r(F7), r(Io), r(Pf), r(wo), r($x), r(Jf), r(Uo), r(yo), r(D7), r(yc), r(Na), r(Sx), r(Vx), r(_f), r(Sc), r(Mf), r(cx), r(Ju), r(px), r(pa), r(De), r(r7), r($a), r(Yo), r(wa), r(Zx), r(sc), r(aa), r(ta), r(Cf), r(Bo), r(Yf), r(Wf), r(kc), r(vc), r(va), r(bf), r(zo), r(Zf), r(rx), r(mi), r(Qo), r(Mo), r(df), r(Va), r(Xo), r(lc), r(fc), r(Zo), r(oo), r(ix), r(Nf), r(uf), r(Xf), r(ex), r(ma), r(da), r(Kf), r(nc), r(gf), r(Lx), r(qo), r(bx), r(yf), r(Of), r(mc), r(xr), r(_c), r(Wx), r(Ux), r(Pa), r(zx), r(nx), r(Dx), r(ha), r(Px), r(hc), r(vx), r(Jo), r(wc), r(Da), r(Ko), r(rc), r(rf), r(Nx), r(ao), r(Ox), r(io), r(jo), r(Ao), r(pc), r(Ax), r(ff), r(of), r(Qf), r(Wo), r(ya), r(ac), r(Rf), r(za), r(ro), r(ko), r(af), r(e7), r(Aa), r(Fx), r(Ca), r(Hx), r(bo), r(Ec), r(Uu), r(Ya), r(ia), r(pf), r(yi), r(Vf), r(bc), r(Wa), r(G7), r(mx), r(ba), r(vf), r(Ba), r(kx), r(Go), r(_a), r(tx), r(nf), r(Lf), r(gc), r(Ix), r(hx), r(Ia), r(Tc), r(lo), r(So), r(li), r(ic), r(yx), r(La), r(Xa), r(Fc), r(Mx), r(ka), r(Bf), r(Sf), r(eo), r(Tx), r(Nu), r(ea), r(ua), r(Qa), r(sf), r(Sa), r(vo), r(Af), r(jx), r(Za), r(If), r(jf), r(Bx), r(Ho), r(qx), r(sa), r(ra), r(la), r(v7), r(ho), r(Ra), r(wx), r(Fo), r(so), r(na), r(zf), r(ja), r(Ta), r(xx), r(I7), r(N7), r($o), r(xa), r($f), r(_o), r(hf), r(go), r(fx), r(gx), r(Uf), r(Ga), r(kf), r(tf), r(ga), r(Df), r(tc), r(mf), r(qa), r(oa), r(Ua), r(Ef), r(Qi), r(sx), r(po), r(lx), r(Tf), r(A7), r(Ha), r(Tn), r(Gx), r(xf), r(lf), r(Kx), r(Hf), r(Vo), r(ca), r(Ea), r(co), r(Rx), r(W4)], p6r = [0, r(_f), r(Qf), r(_a), r(Vf), r(Tf), r(Yf), r(qo), r(ex), r(Nx), r(ko), r(Ka), r(D7), r(Xo), r(ea), r(tc), r(pc), r(bx), r(ff), r(ra), r(Bx), r(Yx), r(li), r(hc), r(Lx), r(Wa), r(sa), r(Of), r(yi), r(Oo), r(Mx), r(ta), r(zf), r(sx), r(tx), r(Qi), r(jo), r(Af), r(ba), r(vc), r(ic), r(yo), r(Kx), r(ma), r(ia), r(Sx), r(la), r(Px), r(yf), r(tf), r(go), r(Qo), r(wa), r(Xf), r(Yo), r(Ko), r(Uf), r(fc), r(r7), r(Nf), r(Ba), r(mc), r(ao), r(Ao), r(bc), r(nx), r($o), r(Jx), r(If), r(uf), r(rc), r($f), r(Dx), r(Go), r(aa), r(Ea), r(so), r(Sa), r(Wx), r(rx), r(co), r(po), r(cx), r(cu), r($a), r(uo), r(Ya), r(lf), r(So), r(no), r(ac), r(Df), r(nc), r(Uo), r(v7), r(Xa), r(Xx), r(Eu), r(fa), r(Ta), r(ec), r(zo), r(px), r(Po), r(hf), r(ja), r(oc), r(Ax), r(Zx), r(ro), r(Ho), r(Sf), r(lc), r(ua), r(ha), r(bf), r(ka), r(Ff), r(xo), r(dc), r(Sc), r(Cx), r(To), r(Ga), r(yx), r(fx), r(Pa), r(kx), r(Gf), r(_o), r(gf), r(Jo), r(Hf), r(Ux), r(oa), r(ga), r(Aa), r(va), r(Mo), r(wc), r(_c), r(Uu), r(Ju), r(Ha), r(Ja), r(ax), r(yc), r(kc), r(F7), r(I7), r(pf), r(Va), r(Tx), r(of), r(mi), r(Ix), r(qx), r(Fx), r(gx), r(nf), r(zx), r(Wo), r(G7), r(vf), r(wf), r(jf), r(De), r(Tc), r(bo), r(Za), r(sf), r(Kf), r(Mf), r(Ca), r(oo), r(Cf), r(_x), r(ix), r(Oa), r(lx), r(Fo), r(Ua), r(na), r(Gx), r(Rf), r(Jf), r(mx), r(pa), r(Ec), r(qa), r(da), r(io), r(kf), r(af), r(ho), r(Ro), r(Rx), r(ux), r(Ef), r(qf), r(Ra), r(Ox), r(ya), r(xa), r(vx), r(Bo), r(za), r(Bf), r(Da), r(wo), r(Vo), r(Wf), r(xf), r(Nu), r(Zf), r(eo), r(hx), r(Ia), r(Vx), r(N7), r(Lf), r(sc), r(vo), r(wx), r(Pf), r($x), r(Na), r(lo), r(Qa), r(No), r(La), r(df), r(Tn), r(Hx), r(mf), r(rf), r(Zo), r(gc), r(xx), r(jx), r(A7), r(ca), r(e7), r(to), r(Fc), r(Io), r(xr)], m6r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("File_key.LibFile"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>File_key.LibFile@ ")], _6r = [0, [3, 0, 0], r(Vt)], y6r = [0, [17, 0, [12, 41, 0]], r(d0)], h6r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("File_key.SourceFile"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>File_key.SourceFile@ ")], d6r = [0, [3, 0, 0], r(Vt)], k6r = [0, [17, 0, [12, 41, 0]], r(d0)], w6r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("File_key.JsonFile"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>File_key.JsonFile@ ")], E6r = [0, [3, 0, 0], r(Vt)], S6r = [0, [17, 0, [12, 41, 0]], r(d0)], g6r = [0, [12, 40, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r("File_key.ResourceFile"), [17, [0, r(v), 1, 0], 0]]]], r("(@[<2>File_key.ResourceFile@ ")], F6r = [0, [3, 0, 0], r(Vt)], T6r = [0, [17, 0, [12, 41, 0]], r(d0)], O6r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], I6r = r("Loc.line"), A6r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], N6r = [0, [4, 0, 0, 0, 0], r(N2)], C6r = [0, [17, 0, 0], r(z2)], P6r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], D6r = r(I2), L6r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], R6r = [0, [4, 0, 0, 0, 0], r(N2)], j6r = [0, [17, 0, 0], r(z2)], G6r = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], M6r = [0, [15, 0], r(N0)], B6r = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [11, r(kr), 0]], r(dr)], q6r = r("Loc.source"), U6r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], H6r = r(tr), X6r = r(Z0), Y6r = r(nr), V6r = [0, [17, 0, 0], r(z2)], z6r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], K6r = r(g7), W6r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], J6r = [0, [17, 0, 0], r(z2)], $6r = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Z6r = r("_end"), Q6r = [0, [18, [1, [0, 0, r(C)]], [2, 0, [11, r(J), [17, [0, r(v), 1, 0], 0]]]], r(W)], rpr = [0, [17, 0, 0], r(z2)], epr = [0, [17, [0, r(v), 1, 0], [12, br, [17, 0, 0]]], r(wr)], npr = [0, r(Rx), r(co), r(Ea), r(ca), r(Vo), r(Hf), r(Kx), r(lf), r(xf), r(Gx), r(Tn), r(Ha), r(A7), r(Tf), r(lx), r(po), r(sx), r(Qi), r(Ef), r(Ua), r(oa), r(qa), r(mf), r(tc), r(Df), r(ga), r(tf), r(kf), r(Ga), r(Uf), r(gx), r(fx), r(go), r(hf), r(_o), r($f), r(xa), r($o), r(N7), r(I7), r(xx), r(Ta), r(ja), r(zf), r(na), r(so), r(Fo), r(wx), r(Ra), r(ho), r(v7), r(la), r(ra), r(sa), r(qx), r(Ho), r(Bx), r(jf), r(If), r(Za), r(jx), r(Af), r(vo), r(Sa), r(sf), r(Qa), r(ua), r(ea), r(Nu), r(Tx), r(eo), r(Sf), r(Bf), r(ka), r(Mx), r(Fc), r(Xa), r(La), r(yx), r(ic), r(li), r(So), r(lo), r(Tc), r(Ia), r(hx), r(Ix), r(gc), r(Lf), r(nf), r(tx), r(_a), r(Go), r(kx), r(Ba), r(vf), r(ba), r(mx), r(G7), r(Wa), r(bc), r(Vf), r(yi), r(pf), r(ia), r(Ya), r(Uu), r(Ec), r(bo), r(Hx), r(Ca), r(Fx), r(Aa), r(e7), r(af), r(ko), r(ro), r(za), r(Rf), r(ac), r(ya), r(Wo), r(Qf), r(of), r(ff), r(Ax), r(pc), r(Ao), r(jo), r(io), r(Ox), r(ao), r(Nx), r(rf), r(rc), r(Ko), r(Da), r(wc), r(Jo), r(vx), r(hc), r(Px), r(ha), r(Dx), r(nx), r(zx), r(Pa), r(Ux), r(Wx), r(_c), r(xr), r(mc), r(Of), r(yf), r(bx), r(qo), r(Lx), r(gf), r(nc), r(Kf), r(da), r(ma), r(ex), r(Xf), r(uf), r(Nf), r(ix), r(oo), r(Zo), r(fc), r(lc), r(Xo), r(Va), r(df), r(Mo), r(Qo), r(mi), r(rx), r(Zf), r(zo), r(bf), r(va), r(vc), r(kc), r(Wf), r(Yf), r(Bo), r(Cf), r(ta), r(aa), r(sc), r(Zx), r(wa), r(Yo), r($a), r(r7), r(De), r(pa), r(px), r(Ju), r(cx), r(Mf), r(Sc), r(_f), r(Vx), r(Sx), r(Na), r(yc), r(D7), r(yo), r(Uo), r(Jf), r($x), r(wo), r(Pf), r(Io), r(F7), r(no), r(fa), r(xo), r(_x), r(Jx), r(Xx), r(Ka), r(Ro), r(qf), r(Oa), r(ax), r(Ff), r(Cx), r(uo), r(Ja), r(wf), r(No), r(ec), r(Po), r(To), r(Gf), r(oc), r(ux), r(dc), r(cu), r(Oo), r(to), r(Yx), r(Eu)], tpr = [0, r(Eu), r(Yx), r(to), r(Oo), r(cu), r(dc), r(ux), r(oc), r(Gf), r(To), r(Po), r(ec), r(No), r(wf), r(Ja), r(uo), r(Cx), r(Ff), r(ax), r(Oa), r(qf), r(Ro), r(Ka), r(Xx), r(Jx), r(_x), r(xo), r(fa), r(no), r(F7), r(Io), r(Pf), r(wo), r($x), r(Jf), r(Uo), r(yo), r(D7), r(yc), r(Na), r(Sx), r(Vx), r(_f), r(Sc), r(Mf), r(cx), r(Ju), r(px), r(pa), r(De), r(r7), r($a), r(Yo), r(wa), r(Zx), r(sc), r(aa), r(ta), r(Cf), r(Bo), r(Yf), r(Wf), r(kc), r(vc), r(va), r(bf), r(zo), r(Zf), r(rx), r(mi), r(Qo), r(Mo), r(df), r(Va), r(Xo), r(lc), r(fc), r(Zo), r(oo), r(ix), r(Nf), r(uf), r(Xf), r(ex), r(ma), r(da), r(Kf), r(nc), r(gf), r(Lx), r(qo), r(bx), r(yf), r(Of), r(mc), r(xr), r(_c), r(Wx), r(Ux), r(Pa), r(zx), r(nx), r(Dx), r(ha), r(Px), r(hc), r(vx), r(Jo), r(wc), r(Da), r(Ko), r(rc), r(rf), r(Nx), r(ao), r(Ox), r(io), r(jo), r(Ao), r(pc), r(Ax), r(ff), r(of), r(Qf), r(Wo), r(ya), r(ac), r(Rf), r(za), r(ro), r(ko), r(af), r(e7), r(Aa), r(Fx), r(Ca), r(Hx), r(bo), r(Ec), r(Uu), r(Ya), r(ia), r(pf), r(yi), r(Vf), r(bc), r(Wa), r(G7), r(mx), r(ba), r(vf), r(Ba), r(kx), r(Go), r(_a), r(tx), r(nf), r(Lf), r(gc), r(Ix), r(hx), r(Ia), r(Tc), r(lo), r(So), r(li), r(ic), r(yx), r(La), r(Xa), r(Fc), r(Mx), r(ka), r(Bf), r(Sf), r(eo), r(Tx), r(Nu), r(ea), r(ua), r(Qa), r(sf), r(Sa), r(vo), r(Af), r(jx), r(Za), r(If), r(jf), r(Bx), r(Ho), r(qx), r(sa), r(ra), r(la), r(v7), r(ho), r(Ra), r(wx), r(Fo), r(so), r(na), r(zf), r(ja), r(Ta), r(xx), r(I7), r(N7), r($o), r(xa), r($f), r(_o), r(hf), r(go), r(fx), r(gx), r(Uf), r(Ga), r(kf), r(tf), r(ga), r(Df), r(tc), r(mf), r(qa), r(oa), r(Ua), r(Ef), r(Qi), r(sx), r(po), r(lx), r(Tf), r(A7), r(Ha), r(Tn), r(Gx), r(xf), r(lf), r(Kx), r(Hf), r(Vo), r(ca), r(Ea), r(co), r(Rx), r(W4)], upr = [0, r(_f), r(Qf), r(_a), r(Vf), r(Tf), r(Yf), r(qo), r(ex), r(Nx), r(ko), r(Ka), r(D7), r(Xo), r(ea), r(tc), r(pc), r(bx), r(ff), r(ra), r(Bx), r(Yx), r(li), r(hc), r(Lx), r(Wa), r(sa), r(Of), r(yi), r(Oo), r(Mx), r(ta), r(zf), r(sx), r(tx), r(Qi), r(jo), r(Af), r(ba), r(vc), r(ic), r(yo), r(Kx), r(ma), r(ia), r(Sx), r(la), r(Px), r(yf), r(tf), r(go), r(Qo), r(wa), r(Xf), r(Yo), r(Ko), r(Uf), r(fc), r(r7), r(Nf), r(Ba), r(mc), r(ao), r(Ao), r(bc), r(nx), r($o), r(Jx), r(If), r(uf), r(rc), r($f), r(Dx), r(Go), r(aa), r(Ea), r(so), r(Sa), r(Wx), r(rx), r(co), r(po), r(cx), r(cu), r($a), r(uo), r(Ya), r(lf), r(So), r(no), r(ac), r(Df), r(nc), r(Uo), r(v7), r(Xa), r(Xx), r(Eu), r(fa), r(Ta), r(ec), r(zo), r(px), r(Po), r(hf), r(ja), r(oc), r(Ax), r(Zx), r(ro), r(Ho), r(Sf), r(lc), r(ua), r(ha), r(bf), r(ka), r(Ff), r(xo), r(dc), r(Sc), r(Cx), r(To), r(Ga), r(yx), r(fx), r(Pa), r(kx), r(Gf), r(_o), r(gf), r(Jo), r(Hf), r(Ux), r(oa), r(ga), r(Aa), r(va), r(Mo), r(wc), r(_c), r(Uu), r(Ju), r(Ha), r(Ja), r(ax), r(yc), r(kc), r(F7), r(I7), r(pf), r(Va), r(Tx), r(of), r(mi), r(Ix), r(qx), r(Fx), r(gx), r(nf), r(zx), r(Wo), r(G7), r(vf), r(wf), r(jf), r(De), r(Tc), r(bo), r(Za), r(sf), r(Kf), r(Mf), r(Ca), r(oo), r(Cf), r(_x), r(ix), r(Oa), r(lx), r(Fo), r(Ua), r(na), r(Gx), r(Rf), r(Jf), r(mx), r(pa), r(Ec), r(qa), r(da), r(io), r(kf), r(af), r(ho), r(Ro), r(Rx), r(ux), r(Ef), r(qf), r(Ra), r(Ox), r(ya), r(xa), r(vx), r(Bo), r(za), r(Bf), r(Da), r(wo), r(Vo), r(Wf), r(xf), r(Nu), r(Zf), r(eo), r(hx), r(Ia), r(Vx), r(N7), r(Lf), r(sc), r(vo), r(wx), r(Pf), r($x), r(Na), r(lo), r(Qa), r(No), r(La), r(df), r(Tn), r(Hx), r(mf), r(rf), r(Zo), r(gc), r(xx), r(jx), r(A7), r(ca), r(e7), r(to), r(Fc), r(Io), r(xr)], ipr = r(lV), fpr = r(jY), xpr = r(PX), opr = r(zY), apr = r(S3), cpr = r(ZH), spr = r(cv), vpr = r(OU), lpr = r(vY), bpr = r(_X), ppr = r(sX), mpr = r(xs), _pr = r(Fa), ypr = r(UU), hpr = r(WH), dpr = r(Qu), kpr = r(XY), wpr = r(OH), Epr = r(I6), Spr = r(jd), gpr = r(R2), Fpr = r(j2), Tpr = r(WU), Opr = r(BU), Ipr = r(nY), Apr = r(xX), Npr = r(lH), Cpr = r(hX), Ppr = r(xU), Dpr = r(zX), Lpr = r(aX), Rpr = r(bH), jpr = r(wH), Gpr = r(XH), Mpr = r(rV), Bpr = r(AU), qpr = r(tX), Upr = r("Set.remove_min_elt"), Hpr = [0, [12, 59, [17, [0, r(v), 1, 0], 0]], r(a0)], Xpr = [0, [18, [1, [0, [11, r(h), 0], r(h)]], [12, ts, 0]], r("@[<2>{")], Ypr = [0, [12, 32, 0], r(pi)], Vpr = [0, [12, 32, 0], r(pi)], zpr = [0, [17, [0, r(Ce), 0, 0], [12, br, [17, 0, 0]]], r("@,}@]")], Kpr = [0, r("src/hack_forked/utils/collections/flow_set.ml"), 363, 14], Wpr = [0, [0, 36, 37], [0, 48, 58], [0, 65, 91], [0, 95, 96], [0, 97, ts], [0, qg, pg], [0, Ai, Yg], [0, lS, hk], [0, md, nw], [0, rt, xT], [0, y6, Dw], [0, wt, 706], [0, rX, 722], [0, 736, 741], [0, 748, 749], [0, 750, 751], [0, 768, 885], [0, 886, 888], [0, 890, 894], [0, 895, 896], [0, 902, 907], [0, 908, ZX], [0, 910, 930], [0, UX, 1014], [0, 1015, 1154], [0, 1155, 1160], [0, 1162, CU], [0, 1329, 1367], [0, 1369, 1370], [0, 1376, 1417], [0, 1425, 1470], [0, 1471, 1472], [0, 1473, 1475], [0, 1476, 1478], [0, 1479, 1480], [0, 1488, 1515], [0, 1519, 1523], [0, 1552, 1563], [0, 1568, 1642], [0, 1646, 1748], [0, 1749, 1757], [0, 1759, 1769], [0, 1770, 1789], [0, 1791, 1792], [0, 1808, 1867], [0, 1869, 1970], [0, 1984, 2038], [0, 2042, 2043], [0, 2045, 2046], [0, Hh, 2094], [0, 2112, 2140], [0, 2144, 2155], [0, 2208, 2229], [0, 2230, 2238], [0, 2259, 2274], [0, 2275, 2404], [0, 2406, 2416], [0, 2417, 2436], [0, 2437, 2445], [0, 2447, 2449], [0, 2451, 2473], [0, 2474, 2481], [0, 2482, 2483], [0, 2486, 2490], [0, 2492, 2501], [0, 2503, 2505], [0, 2507, 2511], [0, 2519, 2520], [0, 2524, 2526], [0, 2527, 2532], [0, 2534, 2546], [0, 2556, 2557], [0, 2558, 2559], [0, 2561, 2564], [0, 2565, 2571], [0, 2575, 2577], [0, 2579, 2601], [0, 2602, 2609], [0, 2610, 2612], [0, 2613, 2615], [0, 2616, 2618], [0, 2620, 2621], [0, 2622, 2627], [0, 2631, 2633], [0, 2635, 2638], [0, 2641, 2642], [0, 2649, 2653], [0, 2654, 2655], [0, 2662, 2678], [0, 2689, 2692], [0, 2693, 2702], [0, 2703, 2706], [0, 2707, 2729], [0, 2730, 2737], [0, 2738, 2740], [0, 2741, 2746], [0, 2748, 2758], [0, 2759, 2762], [0, 2763, 2766], [0, 2768, 2769], [0, 2784, 2788], [0, 2790, 2800], [0, 2809, 2816], [0, 2817, 2820], [0, 2821, 2829], [0, 2831, 2833], [0, 2835, 2857], [0, 2858, 2865], [0, 2866, 2868], [0, 2869, 2874], [0, 2876, 2885], [0, 2887, 2889], [0, 2891, 2894], [0, 2902, 2904], [0, 2908, 2910], [0, 2911, 2916], [0, 2918, 2928], [0, 2929, 2930], [0, 2946, 2948], [0, 2949, 2955], [0, 2958, 2961], [0, 2962, 2966], [0, 2969, 2971], [0, 2972, 2973], [0, 2974, 2976], [0, 2979, 2981], [0, 2984, 2987], [0, 2990, 3002], [0, 3006, 3011], [0, 3014, 3017], [0, 3018, 3022], [0, 3024, 3025], [0, 3031, 3032], [0, 3046, 3056], [0, 3072, 3085], [0, 3086, 3089], [0, 3090, 3113], [0, 3114, 3130], [0, 3133, 3141], [0, 3142, 3145], [0, 3146, 3150], [0, 3157, 3159], [0, 3160, 3163], [0, 3168, 3172], [0, 3174, 3184], [0, 3200, 3204], [0, 3205, 3213], [0, 3214, 3217], [0, 3218, 3241], [0, 3242, 3252], [0, 3253, 3258], [0, 3260, 3269], [0, 3270, 3273], [0, 3274, 3278], [0, 3285, 3287], [0, 3294, 3295], [0, 3296, 3300], [0, 3302, 3312], [0, 3313, 3315], [0, 3328, 3332], [0, 3333, 3341], [0, 3342, 3345], [0, 3346, 3397], [0, 3398, 3401], [0, 3402, 3407], [0, 3412, 3416], [0, 3423, 3428], [0, 3430, 3440], [0, 3450, 3456], [0, 3458, 3460], [0, 3461, 3479], [0, 3482, 3506], [0, 3507, 3516], [0, 3517, 3518], [0, 3520, 3527], [0, 3530, 3531], [0, 3535, 3541], [0, 3542, 3543], [0, 3544, 3552], [0, 3558, 3568], [0, 3570, 3572], [0, 3585, 3643], [0, 3648, 3663], [0, 3664, 3674], [0, 3713, 3715], [0, 3716, 3717], [0, 3718, 3723], [0, 3724, 3748], [0, 3749, 3750], [0, 3751, 3774], [0, 3776, 3781], [0, 3782, 3783], [0, 3784, 3790], [0, 3792, 3802], [0, 3804, 3808], [0, 3840, 3841], [0, 3864, 3866], [0, 3872, 3882], [0, 3893, 3894], [0, 3895, 3896], [0, 3897, 3898], [0, 3902, 3912], [0, 3913, 3949], [0, 3953, 3973], [0, 3974, 3992], [0, 3993, 4029], [0, 4038, 4039], [0, vX, 4170], [0, 4176, 4254], [0, 4256, 4294], [0, 4295, 4296], [0, 4301, 4302], [0, 4304, 4347], [0, 4348, 4681], [0, 4682, 4686], [0, 4688, 4695], [0, 4696, 4697], [0, 4698, 4702], [0, 4704, 4745], [0, 4746, 4750], [0, 4752, 4785], [0, 4786, 4790], [0, 4792, 4799], [0, 4800, 4801], [0, 4802, 4806], [0, 4808, 4823], [0, 4824, 4881], [0, 4882, 4886], [0, 4888, 4955], [0, 4957, 4960], [0, 4969, 4978], [0, 4992, 5008], [0, 5024, 5110], [0, 5112, 5118], [0, 5121, 5741], [0, 5743, Ev], [0, 5761, 5787], [0, 5792, 5867], [0, 5870, 5881], [0, 5888, 5901], [0, 5902, 5909], [0, 5920, 5941], [0, 5952, 5972], [0, 5984, 5997], [0, 5998, 6001], [0, 6002, 6004], [0, 6016, 6100], [0, 6103, 6104], [0, 6108, 6110], [0, 6112, 6122], [0, 6155, 6158], [0, 6160, 6170], [0, 6176, 6265], [0, 6272, 6315], [0, 6320, 6390], [0, 6400, 6431], [0, 6432, 6444], [0, 6448, 6460], [0, 6470, 6510], [0, 6512, 6517], [0, 6528, 6572], [0, 6576, 6602], [0, 6608, 6619], [0, 6656, 6684], [0, 6688, 6751], [0, 6752, 6781], [0, 6783, 6794], [0, 6800, 6810], [0, 6823, 6824], [0, 6832, 6846], [0, 6912, 6988], [0, 6992, 7002], [0, 7019, 7028], [0, 7040, 7156], [0, 7168, 7224], [0, 7232, 7242], [0, 7245, 7294], [0, 7296, 7305], [0, 7312, 7355], [0, 7357, 7360], [0, 7376, 7379], [0, 7380, 7419], [0, 7424, 7674], [0, 7675, 7958], [0, 7960, 7966], [0, 7968, 8006], [0, 8008, 8014], [0, 8016, 8024], [0, 8025, 8026], [0, 8027, 8028], [0, 8029, 8030], [0, 8031, 8062], [0, 8064, 8117], [0, 8118, 8125], [0, 8126, 8127], [0, 8130, 8133], [0, 8134, 8141], [0, 8144, 8148], [0, 8150, 8156], [0, 8160, 8173], [0, 8178, 8181], [0, 8182, 8189], [0, kY, vU], [0, 8255, 8257], [0, 8276, 8277], [0, ep, 8306], [0, O3, 8320], [0, 8336, 8349], [0, 8400, 8413], [0, 8417, 8418], [0, 8421, 8433], [0, x3, 8451], [0, R3, 8456], [0, 8458, g4], [0, m6, 8470], [0, iU, 8478], [0, t8, $3], [0, Q8, sp], [0, P8, N8], [0, 8490, 8506], [0, 8508, 8512], [0, 8517, 8522], [0, s8, 8527], [0, 8544, 8585], [0, 11264, 11311], [0, 11312, 11359], [0, 11360, 11493], [0, 11499, 11508], [0, 11520, G4], [0, B8, 11560], [0, N3, 11566], [0, 11568, 11624], [0, p4, 11632], [0, P6, 11671], [0, 11680, j4], [0, 11688, z8], [0, 11696, o8], [0, 11704, K8], [0, 11712, z6], [0, 11720, j8], [0, 11728, F6], [0, 11736, 11743], [0, 11744, 11776], [0, 12293, 12296], [0, 12321, T3], [0, 12337, 12342], [0, 12344, 12349], [0, 12353, 12439], [0, 12441, E3], [0, 12449, q4], [0, 12540, 12544], [0, 12549, E8], [0, 12593, 12687], [0, 12704, 12731], [0, 12784, 12800], [0, 13312, 19894], [0, 19968, 40944], [0, 40960, 42125], [0, 42192, 42238], [0, 42240, 42509], [0, 42512, 42540], [0, 42560, 42608], [0, 42612, U3], [0, 42623, 42738], [0, 42775, 42784], [0, 42786, 42889], [0, 42891, 42944], [0, 42946, 42951], [0, F8, 43048], [0, 43072, 43124], [0, 43136, 43206], [0, 43216, 43226], [0, 43232, 43256], [0, n3, _8], [0, 43261, 43310], [0, 43312, 43348], [0, 43360, 43389], [0, 43392, 43457], [0, k8, 43482], [0, 43488, v6], [0, 43520, 43575], [0, 43584, 43598], [0, 43600, 43610], [0, 43616, 43639], [0, lp, 43715], [0, 43739, 43742], [0, 43744, 43760], [0, 43762, 43767], [0, 43777, 43783], [0, 43785, 43791], [0, 43793, 43799], [0, 43808, k6], [0, 43816, H3], [0, 43824, av], [0, 43868, o3], [0, 43888, 44011], [0, 44012, 44014], [0, 44016, 44026], [0, 44032, 55204], [0, 55216, 55239], [0, 55243, 55292], [0, 63744, 64110], [0, 64112, 64218], [0, 64256, 64263], [0, 64275, 64280], [0, e3, ip], [0, 64298, Qn], [0, 64312, z3], [0, L6, R4], [0, 64320, q3], [0, 64323, D8], [0, 64326, 64434], [0, 64467, 64830], [0, 64848, 64912], [0, 64914, 64968], [0, 65008, 65020], [0, 65024, 65040], [0, 65056, 65072], [0, 65075, 65077], [0, 65101, 65104], [0, 65136, t3], [0, 65142, 65277], [0, 65296, 65306], [0, 65313, 65339], [0, 65343, Q4], [0, 65345, 65371], [0, 65382, 65471], [0, 65474, 65480], [0, 65482, 65488], [0, 65490, 65496], [0, 65498, 65501], [0, fw, rp], [0, 65549, $8], [0, 65576, z4], [0, 65596, S6], [0, 65599, 65614], [0, 65616, 65630], [0, 65664, 65787], [0, 65856, 65909], [0, 66045, 66046], [0, 66176, 66205], [0, 66208, 66257], [0, 66272, 66273], [0, 66304, 66336], [0, 66349, 66379], [0, 66384, 66427], [0, 66432, 66462], [0, 66464, 66500], [0, 66504, Z3], [0, 66513, 66518], [0, 66560, 66718], [0, 66720, 66730], [0, 66736, 66772], [0, 66776, 66812], [0, 66816, 66856], [0, 66864, 66916], [0, 67072, 67383], [0, 67392, 67414], [0, 67424, 67432], [0, 67584, 67590], [0, op, J4], [0, 67594, p8], [0, 67639, 67641], [0, M6, 67645], [0, 67647, 67670], [0, 67680, 67703], [0, 67712, 67743], [0, 67808, X8], [0, 67828, 67830], [0, 67840, 67862], [0, 67872, 67898], [0, 67968, 68024], [0, 68030, 68032], [0, S7, 68100], [0, 68101, 68103], [0, 68108, b4], [0, 68117, Z8], [0, 68121, 68150], [0, 68152, 68155], [0, 68159, 68160], [0, 68192, 68221], [0, 68224, 68253], [0, 68288, J6], [0, 68297, 68327], [0, 68352, 68406], [0, 68416, 68438], [0, 68448, 68467], [0, 68480, 68498], [0, 68608, 68681], [0, 68736, 68787], [0, 68800, 68851], [0, 68864, 68904], [0, 68912, 68922], [0, 69376, 69405], [0, J8, 69416], [0, 69424, 69457], [0, 69600, 69623], [0, 69632, 69703], [0, 69734, B3], [0, 69759, 69819], [0, 69840, 69865], [0, 69872, 69882], [0, 69888, 69941], [0, 69942, 69952], [0, m4, F3], [0, 69968, 70004], [0, X6, 70007], [0, 70016, 70085], [0, 70089, 70093], [0, 70096, h8], [0, i3, 70109], [0, 70144, A8], [0, 70163, 70200], [0, 70206, 70207], [0, 70272, y3], [0, I8, fp], [0, 70282, O8], [0, 70287, c8], [0, 70303, 70313], [0, 70320, 70379], [0, 70384, 70394], [0, 70400, u6], [0, 70405, 70413], [0, 70415, 70417], [0, 70419, f3], [0, 70442, a8], [0, 70450, C4], [0, 70453, 70458], [0, 70459, 70469], [0, 70471, 70473], [0, 70475, 70478], [0, j6, 70481], [0, 70487, 70488], [0, 70493, 70500], [0, 70502, 70509], [0, 70512, 70517], [0, 70656, 70731], [0, 70736, 70746], [0, W6, 70752], [0, 70784, Q3], [0, Z6, 70856], [0, 70864, 70874], [0, 71040, 71094], [0, 71096, 71105], [0, 71128, 71134], [0, 71168, 71233], [0, u8, 71237], [0, 71248, 71258], [0, 71296, 71353], [0, 71360, 71370], [0, 71424, 71451], [0, 71453, 71468], [0, 71472, 71482], [0, 71680, 71739], [0, 71840, 71914], [0, 71935, 71936], [0, 72096, 72104], [0, 72106, 72152], [0, 72154, up], [0, p3, 72165], [0, M8, 72255], [0, 72263, 72264], [0, u3, 72346], [0, P4, 72350], [0, 72384, 72441], [0, 72704, W3], [0, 72714, 72759], [0, 72760, 72769], [0, 72784, 72794], [0, 72818, 72848], [0, 72850, 72872], [0, 72873, 72887], [0, 72960, D3], [0, 72968, h4], [0, 72971, 73015], [0, 73018, 73019], [0, 73020, 73022], [0, 73023, 73032], [0, 73040, 73050], [0, 73056, R6], [0, 73063, h3], [0, 73066, 73103], [0, 73104, 73106], [0, 73107, 73113], [0, 73120, 73130], [0, 73440, 73463], [0, 73728, 74650], [0, 74752, 74863], [0, 74880, 75076], [0, 77824, 78895], [0, 82944, 83527], [0, 92160, 92729], [0, 92736, 92767], [0, 92768, 92778], [0, 92880, 92910], [0, 92912, 92917], [0, 92928, 92983], [0, 92992, 92996], [0, 93008, 93018], [0, 93027, 93048], [0, 93053, 93072], [0, 93760, 93824], [0, 93952, 94027], [0, Z4, 94088], [0, 94095, 94112], [0, 94176, b6], [0, h6, 94180], [0, 94208, 100344], [0, 100352, 101107], [0, 110592, 110879], [0, 110928, 110931], [0, 110948, 110952], [0, 110960, 111356], [0, 113664, 113771], [0, 113776, 113789], [0, 113792, 113801], [0, 113808, 113818], [0, 113821, 113823], [0, 119141, 119146], [0, 119149, 119155], [0, 119163, 119171], [0, 119173, 119180], [0, 119210, 119214], [0, 119362, 119365], [0, 119808, T6], [0, 119894, M3], [0, 119966, 119968], [0, d3, 119971], [0, 119973, 119975], [0, 119977, Q6], [0, 119982, l8], [0, l4, G6], [0, 119997, I3], [0, 120005, L4], [0, 120071, 120075], [0, 120077, N6], [0, 120086, vp], [0, 120094, C3], [0, 120123, r6], [0, 120128, B4], [0, G3, 120135], [0, 120138, D6], [0, 120146, 120486], [0, 120488, D4], [0, 120514, V3], [0, 120540, c6], [0, 120572, X4], [0, 120598, c3], [0, 120630, V4], [0, 120656, w6], [0, 120688, v4], [0, 120714, l6], [0, 120746, k3], [0, 120772, 120780], [0, 120782, 120832], [0, 121344, 121399], [0, 121403, 121453], [0, 121461, 121462], [0, 121476, 121477], [0, 121499, 121504], [0, 121505, 121520], [0, 122880, 122887], [0, 122888, 122905], [0, 122907, 122914], [0, 122915, 122917], [0, 122918, 122923], [0, 123136, 123181], [0, 123184, 123198], [0, 123200, 123210], [0, ap, 123215], [0, 123584, 123642], [0, 124928, 125125], [0, 125136, 125143], [0, 125184, 125260], [0, 125264, 125274], [0, 126464, C6], [0, 126469, J3], [0, 126497, a3], [0, g8, 126501], [0, e8, m8], [0, 126505, s6], [0, 126516, f8], [0, _6, x8], [0, w3, 126524], [0, K3, 126531], [0, L8, U6], [0, S8, n8], [0, s3, M4], [0, 126541, F4], [0, 126545, g6], [0, d8, 126549], [0, i8, E4], [0, fn, B6], [0, S4, G8], [0, q6, s4], [0, t6, O4], [0, 126561, xp], [0, V6, 126565], [0, 126567, l3], [0, 126572, x6], [0, 126580, W8], [0, 126585, L3], [0, $4, w8], [0, 126592, V8], [0, 126603, 126620], [0, 126625, j3], [0, 126629, r3], [0, 126635, 126652], [0, 131072, 173783], [0, 173824, 177973], [0, 177984, 178206], [0, 178208, 183970], [0, 183984, 191457], [0, 194560, 195102], [0, 917760, 918e3]], Jpr = r(O2), $pr = r(dv), Zpr = r(Tv), Qpr = r(K4), r5r = r("Cannot export an enum with `export type`, try `export enum E {}` or `module.exports = E;` instead."), e5r = r("Enum members are separated with `,`. Replace `;` with `,`."), n5r = r("Unexpected reserved word"), t5r = r("Unexpected reserved type"), u5r = r("Unexpected `super` outside of a class method"), i5r = r("`super()` is only valid in a class constructor"), f5r = r("Unexpected end of input"), x5r = r("Unexpected variance sigil"), o5r = r("Unexpected static modifier"), a5r = r("Unexpected proto modifier"), c5r = r("Type aliases are not allowed in untyped mode"), s5r = r("Opaque type aliases are not allowed in untyped mode"), v5r = r("Type annotations are not allowed in untyped mode"), l5r = r("Type declarations are not allowed in untyped mode"), b5r = r("Type imports are not allowed in untyped mode"), p5r = r("Type exports are not allowed in untyped mode"), m5r = r("Interfaces are not allowed in untyped mode"), _5r = r("Spreading a type is only allowed inside an object type"), y5r = r("Explicit inexact syntax must come at the end of an object type"), h5r = r("Explicit inexact syntax cannot appear inside an explicit exact object type"), d5r = r("Explicit inexact syntax can only appear inside an object type"), k5r = r("Illegal newline after throw"), w5r = r("A bigint literal must be an integer"), E5r = r("A bigint literal cannot use exponential notation"), S5r = r("Invalid regular expression"), g5r = r("Invalid regular expression: missing /"), F5r = r("Invalid left-hand side in assignment"), T5r = r("Invalid left-hand side in exponentiation expression"), O5r = r("Invalid left-hand side in for-in"), I5r = r("Invalid left-hand side in for-of"), A5r = r("Invalid optional indexed access. Indexed access uses bracket notation. Use the format `T?.[K]`."), N5r = r("found an expression instead"), C5r = r("Expected an object pattern, array pattern, or an identifier but "), P5r = r("More than one default clause in switch statement"), D5r = r("Missing catch or finally after try"), L5r = r("Illegal continue statement"), R5r = r("Illegal break statement"), j5r = r("Illegal return statement"), G5r = r("Illegal Unicode escape"), M5r = r("Strict mode code may not include a with statement"), B5r = r("Catch variable may not be eval or arguments in strict mode"), q5r = r("Variable name may not be eval or arguments in strict mode"), U5r = r("Parameter name eval or arguments is not allowed in strict mode"), H5r = r("Strict mode function may not have duplicate parameter names"), X5r = r('Illegal "use strict" directive in function with non-simple parameter list'), Y5r = r("Function name may not be eval or arguments in strict mode"), V5r = r("Octal literals are not allowed in strict mode."), z5r = r("Number literals with leading zeros are not allowed in strict mode."), K5r = r("Delete of an unqualified identifier in strict mode."), W5r = r("Duplicate data property in object literal not allowed in strict mode"), J5r = r("Object literal may not have data and accessor property with the same name"), $5r = r("Object literal may not have multiple get/set accessors with the same name"), Z5r = r("`typeof` can only be used to get the type of variables."), Q5r = r("Assignment to eval or arguments is not allowed in strict mode"), rmr = r("Postfix increment/decrement may not have eval or arguments operand in strict mode"), emr = r("Prefix increment/decrement may not have eval or arguments operand in strict mode"), nmr = r("Use of future reserved word in strict mode"), tmr = r("JSX attributes must only be assigned a non-empty expression"), umr = r("JSX value should be either an expression or a quoted JSX text"), imr = r("Const must be initialized"), fmr = r("Destructuring assignment must be initialized"), xmr = r("Illegal newline before arrow"), omr = r(aF), amr = r("Async functions can only be declared at top level or "), cmr = r(aF), smr = r("Generators can only be declared at top level or "), vmr = r("elements must be wrapped in an enclosing parent tag"), lmr = r("Unexpected token <. Remember, adjacent JSX "), bmr = r("Rest parameter must be final parameter of an argument list"), pmr = r("Rest element must be final element of an array pattern"), mmr = r("Rest property must be final property of an object pattern"), _mr = r("async is an implementation detail and isn't necessary for your declare function statement. It is sufficient for your declare function to just have a Promise return type."), ymr = r("`declare` modifier can only appear on class fields."), hmr = r("Unexpected token `=`. Initializers are not allowed in a `declare`."), dmr = r("Unexpected token `=`. Initializers are not allowed in a `declare opaque type`."), kmr = r("`declare export let` is not supported. Use `declare export var` instead."), wmr = r("`declare export const` is not supported. Use `declare export var` instead."), Emr = r("`declare export type` is not supported. Use `export type` instead."), Smr = r("`declare export interface` is not supported. Use `export interface` instead."), gmr = r("`export * as` is an early-stage proposal and is not enabled by default. To enable support in the parser, use the `esproposal_export_star_as` option"), Fmr = r("Found a decorator in an unsupported position."), Tmr = r("Type parameter declaration needs a default, since a preceding type parameter declaration has a default."), Omr = r("Duplicate `declare module.exports` statement!"), Imr = r("Found both `declare module.exports` and `declare export` in the same module. Modules can only have 1 since they are either an ES module xor they are a CommonJS module."), Amr = r("Getter should have zero parameters"), Nmr = r("Setter should have exactly one parameter"), Cmr = r("`import type` or `import typeof`!"), Pmr = r("Imports within a `declare module` body must always be "), Dmr = r("The `type` and `typeof` keywords on named imports can only be used on regular `import` statements. It cannot be used with `import type` or `import typeof` statements"), Lmr = r("Missing comma between import specifiers"), Rmr = r("Missing comma between export specifiers"), jmr = r("Malformed unicode"), Gmr = r("Classes may only have one constructor"), Mmr = r("Private fields may not be deleted."), Bmr = r("Private fields can only be referenced from within a class."), qmr = r("You may not access a private field through the `super` keyword."), Umr = r("Yield expression not allowed in formal parameter"), Hmr = r("`await` is an invalid identifier in async functions"), Xmr = r("`yield` is an invalid identifier in generators"), Ymr = r("either a `let` binding pattern, or a member expression."), Vmr = r("`let [` is ambiguous in this position because it is "), zmr = r("Literals cannot be used as shorthand properties."), Kmr = r("Computed properties must have a value."), Wmr = r("Object pattern can't contain methods"), Jmr = r("A trailing comma is not permitted after the rest element"), $mr = r("An optional chain may not be used in a `new` expression."), Zmr = r("Template literals may not be used in an optional chain."), Qmr = r("Unexpected whitespace between `#` and identifier"), r9r = r("A type annotation is required for the `this` parameter."), e9r = r("The `this` parameter must be the first function parameter."), n9r = r("The `this` parameter cannot be optional."), t9r = r("A getter cannot have a `this` parameter."), u9r = r("A setter cannot have a `this` parameter."), i9r = r("Arrow functions cannot have a `this` parameter; arrow functions automatically bind `this` when declared."), f9r = r("Constructors cannot have a `this` parameter; constructors don't bind `this` like other functions."), x9r = [0, [11, r("Boolean enum members need to be initialized. Use either `"), [2, 0, [11, r(" = true,` or `"), [2, 0, [11, r(" = false,` in enum `"), [2, 0, [11, r(Es), 0]]]]]]], r("Boolean enum members need to be initialized. Use either `%s = true,` or `%s = false,` in enum `%s`.")], o9r = [0, [11, r("Enum member names need to be unique, but the name `"), [2, 0, [11, r("` has already been used before in enum `"), [2, 0, [11, r(Es), 0]]]]], r("Enum member names need to be unique, but the name `%s` has already been used before in enum `%s`.")], a9r = [0, [11, r(IU), [2, 0, [11, r("` has inconsistent member initializers. Either use no initializers, or consistently use literals (either booleans, numbers, or strings) for all member initializers."), 0]]], r("Enum `%s` has inconsistent member initializers. Either use no initializers, or consistently use literals (either booleans, numbers, or strings) for all member initializers.")], c9r = [0, [11, r("Use one of `boolean`, `number`, `string`, or `symbol` in enum `"), [2, 0, [11, r(Es), 0]]], r("Use one of `boolean`, `number`, `string`, or `symbol` in enum `%s`.")], s9r = [0, [11, r("Enum type `"), [2, 0, [11, r("` is not valid. "), [2, 0, 0]]]], r("Enum type `%s` is not valid. %s")], v9r = [0, [11, r("Supplied enum type is not valid. "), [2, 0, 0]], r("Supplied enum type is not valid. %s")], l9r = [0, [11, r("Enum member names and initializers are separated with `=`. Replace `"), [2, 0, [11, r(":` with `"), [2, 0, [11, r(" =`."), 0]]]]], r("Enum member names and initializers are separated with `=`. Replace `%s:` with `%s =`.")], b9r = [0, [11, r("Symbol enum members cannot be initialized. Use `"), [2, 0, [11, r(",` in enum `"), [2, 0, [11, r(Es), 0]]]]], r("Symbol enum members cannot be initialized. Use `%s,` in enum `%s`.")], p9r = [0, [11, r(IU), [2, 0, [11, r("` has type `"), [2, 0, [11, r("`, so the initializer of `"), [2, 0, [11, r("` needs to be a "), [2, 0, [11, r(" literal."), 0]]]]]]]]], r("Enum `%s` has type `%s`, so the initializer of `%s` needs to be a %s literal.")], m9r = [0, [11, r("The enum member initializer for `"), [2, 0, [11, r("` needs to be a literal (either a boolean, number, or string) in enum `"), [2, 0, [11, r(Es), 0]]]]], r("The enum member initializer for `%s` needs to be a literal (either a boolean, number, or string) in enum `%s`.")], _9r = [0, [11, r("Enum member names cannot start with lowercase 'a' through 'z'. Instead of using `"), [2, 0, [11, r("`, consider using `"), [2, 0, [11, r("`, in enum `"), [2, 0, [11, r(Es), 0]]]]]]], r("Enum member names cannot start with lowercase 'a' through 'z'. Instead of using `%s`, consider using `%s`, in enum `%s`.")], y9r = r("The `...` must come at the end of the enum body. Remove the trailing comma."), h9r = r("The `...` must come after all enum members. Move it to the end of the enum body."), d9r = [0, [11, r("Number enum members need to be initialized, e.g. `"), [2, 0, [11, r(" = 1,` in enum `"), [2, 0, [11, r(Es), 0]]]]], r("Number enum members need to be initialized, e.g. `%s = 1,` in enum `%s`.")], k9r = [0, [11, r("String enum members need to consistently either all use initializers, or use no initializers, in enum "), [2, 0, [12, 46, 0]]], r("String enum members need to consistently either all use initializers, or use no initializers, in enum %s.")], w9r = [0, [11, r(UH), [2, 0, 0]], r("Unexpected %s")], E9r = [0, [11, r(UH), [2, 0, [11, r(", expected "), [2, 0, 0]]]], r("Unexpected %s, expected %s")], S9r = [0, [11, r(bV), [2, 0, [11, r("`. Did you mean `"), [2, 0, [11, r("`?"), 0]]]]], r("Unexpected token `%s`. Did you mean `%s`?")], g9r = r(P3), F9r = r("Invalid flags supplied to RegExp constructor '"), T9r = r("Remove the period."), O9r = r("Indexed access uses bracket notation."), I9r = [0, [11, r("Invalid indexed access. "), [2, 0, [11, r(" Use the format `T[K]`."), 0]]], r("Invalid indexed access. %s Use the format `T[K]`.")], A9r = r(P3), N9r = r("Undefined label '"), C9r = r("' has already been declared"), P9r = r(" '"), D9r = r("Expected corresponding JSX closing tag for "), L9r = r(aF), R9r = r("In strict mode code, functions can only be declared at top level or "), j9r = r("inside a block, or as the body of an if statement."), G9r = r("In non-strict mode code, functions can only be declared at top level, "), M9r = [0, [11, r("Duplicate export for `"), [2, 0, [12, 96, 0]]], r("Duplicate export for `%s`")], B9r = r("` is declared more than once."), q9r = r("Private fields may only be declared once. `#"), U9r = r("static "), H9r = r(C), X9r = r(YY), Y9r = r("methods"), V9r = r("fields"), z9r = r(Es), K9r = r(" named `"), W9r = r("Classes may not have "), J9r = r("` has not been declared."), $9r = r("Private fields must be declared before they can be referenced. `#"), Z9r = [0, [11, r(bV), [2, 0, [11, r("`. Parentheses are required to combine `??` with `&&` or `||` expressions."), 0]]], r("Unexpected token `%s`. Parentheses are required to combine `??` with `&&` or `||` expressions.")], Q9r = r("Parse_error.Error"), r_r = [0, r("src/third-party/sedlex/flow_sedlexing.ml"), s1, 4], e_r = r("Flow_sedlexing.MalFormed"), n_r = [0, 1, 0], t_r = [0, 0, [0, 1, 0], [0, 1, 0]], u_r = r(YU), i_r = r("end of input"), f_r = r(rl), x_r = r("template literal part"), o_r = r(rl), a_r = r(MH), c_r = r(YU), s_r = r(rl), v_r = r(dv), l_r = r(rl), b_r = r(x1), p_r = r(rl), m_r = r(Tv), __r = r("an"), y_r = r(yi), h_r = r(pi), d_r = [0, [11, r("token `"), [2, 0, [12, 96, 0]]], r("token `%s`")], k_r = r(hH), w_r = r(b3), E_r = r("{|"), S_r = r("|}"), g_r = r(HX), F_r = r(Z0), T_r = r("["), O_r = r("]"), I_r = r(VY), A_r = r(","), N_r = r(Lo), C_r = r("=>"), P_r = r("..."), D_r = r(gX), L_r = r(YY), R_r = r(M2), j_r = r(A3), G_r = r(R2), M_r = r(j2), B_r = r(Ju), q_r = r(D7), U_r = r(i1), H_r = r(F7), X_r = r(d4), Y_r = r(U2), V_r = r(K6), z_r = r(C8), K_r = r(D2), W_r = r(G2), J_r = r(fs), $_r = r(Ci), Z_r = r(Gi), Q_r = r(A7), ryr = r(d6), eyr = r(o6), nyr = r(N7), tyr = r(_i), uyr = r(_4), iyr = r(q8), fyr = r(np), xyr = r(q2), oyr = r(P7), ayr = r(nu), cyr = r(U4), syr = r(u1), vyr = r(J2), lyr = r(rs), byr = r(es), pyr = r(b8), myr = r(_3), _yr = r(Uu), yyr = r(yv), hyr = r(ws), dyr = r(e7), kyr = r(y4), wyr = r(k4), Eyr = r(a6), Syr = r(E6), gyr = r(Eu), Fyr = r(I7), Tyr = r(T2), Oyr = r(Jc), Iyr = r(eh), Ayr = r(CS), Nyr = r(gs), Cyr = r(dx), Pyr = r("%checks"), Dyr = r(aX), Lyr = r(zX), Ryr = r(xU), jyr = r(wH), Gyr = r(bH), Myr = r(XH), Byr = r(hX), qyr = r(lH), Uyr = r(nY), Hyr = r(xX), Xyr = r(BU), Yyr = r(WU), Vyr = r(rV), zyr = r(AU), Kyr = r(tX), Wyr = r(XO), Jyr = r("?."), $yr = r(Ke), Zyr = r("?"), Qyr = r(o1), rhr = r(zH), ehr = r(MX), nhr = r(OH), thr = r(I6), uhr = r(jd), ihr = r(lV), fhr = r(jY), xhr = r(PX), ohr = r(zY), ahr = r(ZH), chr = r(OU), shr = r(S3), vhr = r(cv), lhr = r(vY), bhr = r(_X), phr = r(sX), mhr = r(xs), _hr = r(Fa), yhr = r(Qu), hhr = r(UU), dhr = r(WH), khr = r(XY), whr = r(Kt), Ehr = r(ZY), Shr = r(sH), ghr = r(oV), Fhr = r(C), Thr = r(n6), Ohr = r(H8), Ihr = r(v7), Ahr = r(dv), Nhr = r(x1), Chr = r(Tv), Phr = r(es), Dhr = r(K4), Lhr = r(Qu), Rhr = r(Qu), jhr = r(O2), Ghr = r(O6), Mhr = r("T_LCURLY"), Bhr = r("T_RCURLY"), qhr = r("T_LCURLYBAR"), Uhr = r("T_RCURLYBAR"), Hhr = r("T_LPAREN"), Xhr = r("T_RPAREN"), Yhr = r("T_LBRACKET"), Vhr = r("T_RBRACKET"), zhr = r("T_SEMICOLON"), Khr = r("T_COMMA"), Whr = r("T_PERIOD"), Jhr = r("T_ARROW"), $hr = r("T_ELLIPSIS"), Zhr = r("T_AT"), Qhr = r("T_POUND"), rdr = r("T_FUNCTION"), edr = r("T_IF"), ndr = r("T_IN"), tdr = r("T_INSTANCEOF"), udr = r("T_RETURN"), idr = r("T_SWITCH"), fdr = r("T_THIS"), xdr = r("T_THROW"), odr = r("T_TRY"), adr = r("T_VAR"), cdr = r("T_WHILE"), sdr = r("T_WITH"), vdr = r("T_CONST"), ldr = r("T_LET"), bdr = r("T_NULL"), pdr = r("T_FALSE"), mdr = r("T_TRUE"), _dr = r("T_BREAK"), ydr = r("T_CASE"), hdr = r("T_CATCH"), ddr = r("T_CONTINUE"), kdr = r("T_DEFAULT"), wdr = r("T_DO"), Edr = r("T_FINALLY"), Sdr = r("T_FOR"), gdr = r("T_CLASS"), Fdr = r("T_EXTENDS"), Tdr = r("T_STATIC"), Odr = r("T_ELSE"), Idr = r("T_NEW"), Adr = r("T_DELETE"), Ndr = r("T_TYPEOF"), Cdr = r("T_VOID"), Pdr = r("T_ENUM"), Ddr = r("T_EXPORT"), Ldr = r("T_IMPORT"), Rdr = r("T_SUPER"), jdr = r("T_IMPLEMENTS"), Gdr = r("T_INTERFACE"), Mdr = r("T_PACKAGE"), Bdr = r("T_PRIVATE"), qdr = r("T_PROTECTED"), Udr = r("T_PUBLIC"), Hdr = r("T_YIELD"), Xdr = r("T_DEBUGGER"), Ydr = r("T_DECLARE"), Vdr = r("T_TYPE"), zdr = r("T_OPAQUE"), Kdr = r("T_OF"), Wdr = r("T_ASYNC"), Jdr = r("T_AWAIT"), $dr = r("T_CHECKS"), Zdr = r("T_RSHIFT3_ASSIGN"), Qdr = r("T_RSHIFT_ASSIGN"), rkr = r("T_LSHIFT_ASSIGN"), ekr = r("T_BIT_XOR_ASSIGN"), nkr = r("T_BIT_OR_ASSIGN"), tkr = r("T_BIT_AND_ASSIGN"), ukr = r("T_MOD_ASSIGN"), ikr = r("T_DIV_ASSIGN"), fkr = r("T_MULT_ASSIGN"), xkr = r("T_EXP_ASSIGN"), okr = r("T_MINUS_ASSIGN"), akr = r("T_PLUS_ASSIGN"), ckr = r("T_NULLISH_ASSIGN"), skr = r("T_AND_ASSIGN"), vkr = r("T_OR_ASSIGN"), lkr = r("T_ASSIGN"), bkr = r("T_PLING_PERIOD"), pkr = r("T_PLING_PLING"), mkr = r("T_PLING"), _kr = r("T_COLON"), ykr = r("T_OR"), hkr = r("T_AND"), dkr = r("T_BIT_OR"), kkr = r("T_BIT_XOR"), wkr = r("T_BIT_AND"), Ekr = r("T_EQUAL"), Skr = r("T_NOT_EQUAL"), gkr = r("T_STRICT_EQUAL"), Fkr = r("T_STRICT_NOT_EQUAL"), Tkr = r("T_LESS_THAN_EQUAL"), Okr = r("T_GREATER_THAN_EQUAL"), Ikr = r("T_LESS_THAN"), Akr = r("T_GREATER_THAN"), Nkr = r("T_LSHIFT"), Ckr = r("T_RSHIFT"), Pkr = r("T_RSHIFT3"), Dkr = r("T_PLUS"), Lkr = r("T_MINUS"), Rkr = r("T_DIV"), jkr = r("T_MULT"), Gkr = r("T_EXP"), Mkr = r("T_MOD"), Bkr = r("T_NOT"), qkr = r("T_BIT_NOT"), Ukr = r("T_INCR"), Hkr = r("T_DECR"), Xkr = r("T_EOF"), Ykr = r("T_ANY_TYPE"), Vkr = r("T_MIXED_TYPE"), zkr = r("T_EMPTY_TYPE"), Kkr = r("T_NUMBER_TYPE"), Wkr = r("T_BIGINT_TYPE"), Jkr = r("T_STRING_TYPE"), $kr = r("T_VOID_TYPE"), Zkr = r("T_SYMBOL_TYPE"), Qkr = r("T_NUMBER"), rwr = r("T_BIGINT"), ewr = r("T_STRING"), nwr = r("T_TEMPLATE_PART"), twr = r("T_IDENTIFIER"), uwr = r("T_REGEXP"), iwr = r("T_ERROR"), fwr = r("T_JSX_IDENTIFIER"), xwr = r("T_JSX_TEXT"), owr = r("T_BOOLEAN_TYPE"), awr = r("T_NUMBER_SINGLETON_TYPE"), cwr = r("T_BIGINT_SINGLETON_TYPE"), swr = [0, r(kX), HT, 9], vwr = [0, r(kX), A6, 9], lwr = r(GH), bwr = r("*/"), pwr = r(GH), mwr = r("unreachable line_comment"), _wr = r("unreachable string_quote"), ywr = r("\\"), hwr = r("unreachable template_part"), dwr = r("${"), kwr = r(UY), wwr = r(UY), Ewr = r(MI), Swr = r("unreachable regexp_class"), gwr = r(uY), Fwr = r("unreachable regexp_body"), Twr = r(C), Owr = r(C), Iwr = r(C), Awr = r(C), Nwr = r("unreachable jsxtext"), Cwr = r(P3), Pwr = r(V2), Dwr = r(S3), Lwr = r(cv), Rwr = r(hH), jwr = r(b3), Gwr = r("{'}'}"), Mwr = r(b3), Bwr = r("{'>'}"), qwr = r(cv), Uwr = r(l1), Hwr = r("iexcl"), Xwr = r("aelig"), Ywr = r("Nu"), Vwr = r("Eacute"), zwr = r("Atilde"), Kwr = r("'int'"), Wwr = r("AElig"), Jwr = r("Aacute"), $wr = r("Acirc"), Zwr = r("Agrave"), Qwr = r("Alpha"), rEr = r("Aring"), eEr = [0, hY], nEr = [0, 913], tEr = [0, rt], uEr = [0, nI], iEr = [0, HT], fEr = [0, vH], xEr = [0, 8747], oEr = r("Auml"), aEr = r("Beta"), cEr = r("Ccedil"), sEr = r("Chi"), vEr = r("Dagger"), lEr = r("Delta"), bEr = r("ETH"), pEr = [0, _H], mEr = [0, 916], _Er = [0, 8225], yEr = [0, 935], hEr = [0, QH], dEr = [0, 914], kEr = [0, XX], wEr = [0, xY], EEr = r("Icirc"), SEr = r("Ecirc"), gEr = r("Egrave"), FEr = r("Epsilon"), TEr = r("Eta"), OEr = r("Euml"), IEr = r("Gamma"), AEr = r("Iacute"), NEr = [0, VH], CEr = [0, 915], PEr = [0, eV], DEr = [0, 919], LEr = [0, 917], REr = [0, NU], jEr = [0, nH], GEr = r("Igrave"), MEr = r("Iota"), BEr = r("Iuml"), qEr = r("Kappa"), UEr = r("Lambda"), HEr = r("Mu"), XEr = r("Ntilde"), YEr = [0, Wg], VEr = [0, 924], zEr = [0, 923], KEr = [0, 922], WEr = [0, AX], JEr = [0, 921], $Er = [0, WX], ZEr = [0, TH], QEr = [0, sY], rSr = r("Sigma"), eSr = r("Otilde"), nSr = r("OElig"), tSr = r("Oacute"), uSr = r("Ocirc"), iSr = r("Ograve"), fSr = r("Omega"), xSr = r("Omicron"), oSr = r("Oslash"), aSr = [0, y6], cSr = [0, 927], sSr = [0, 937], vSr = [0, A6], lSr = [0, yY], bSr = [0, yU], pSr = [0, 338], mSr = r("Ouml"), _Sr = r("Phi"), ySr = r("Pi"), hSr = r("Prime"), dSr = r("Psi"), kSr = r("Rho"), wSr = r("Scaron"), ESr = [0, 352], SSr = [0, 929], gSr = [0, 936], FSr = [0, 8243], TSr = [0, 928], OSr = [0, 934], ISr = [0, mT], ASr = [0, RX], NSr = r("Uuml"), CSr = r("THORN"), PSr = r("Tau"), DSr = r("Theta"), LSr = r("Uacute"), RSr = r("Ucirc"), jSr = r("Ugrave"), GSr = r("Upsilon"), MSr = [0, 933], BSr = [0, cp], qSr = [0, FU], USr = [0, Cw], HSr = [0, 920], XSr = [0, 932], YSr = [0, FX], VSr = r("Xi"), zSr = r("Yacute"), KSr = r("Yuml"), WSr = r("Zeta"), JSr = r("aacute"), $Sr = r("acirc"), ZSr = r("acute"), QSr = [0, sU], rgr = [0, rk], egr = [0, BO], ngr = [0, 918], tgr = [0, 376], ugr = [0, GX], igr = [0, 926], fgr = [0, iA], xgr = [0, UX], ogr = [0, 925], agr = r("delta"), cgr = r("cap"), sgr = r("aring"), vgr = r("agrave"), lgr = r("alefsym"), bgr = r("alpha"), pgr = r("amp"), mgr = r("and"), _gr = r("ang"), ygr = r("apos"), hgr = [0, 39], dgr = [0, 8736], kgr = [0, 8743], wgr = [0, 38], Egr = [0, 945], Sgr = [0, 8501], ggr = [0, hv], Fgr = r("asymp"), Tgr = r("atilde"), Ogr = r("auml"), Igr = r("bdquo"), Agr = r("beta"), Ngr = r("brvbar"), Cgr = r("bull"), Pgr = [0, 8226], Dgr = [0, DY], Lgr = [0, 946], Rgr = [0, 8222], jgr = [0, fV], Ggr = [0, JH], Mgr = [0, 8776], Bgr = [0, bU], qgr = r("copy"), Ugr = r("ccedil"), Hgr = r("cedil"), Xgr = r("cent"), Ygr = r("chi"), Vgr = r("circ"), zgr = r("clubs"), Kgr = r("cong"), Wgr = [0, 8773], Jgr = [0, 9827], $gr = [0, rX], Zgr = [0, 967], Qgr = [0, kh], rFr = [0, hk], eFr = [0, qX], nFr = r("crarr"), tFr = r("cup"), uFr = r("curren"), iFr = r("dArr"), fFr = r("dagger"), xFr = r("darr"), oFr = r("deg"), aFr = [0, mV], cFr = [0, 8595], sFr = [0, 8224], vFr = [0, 8659], lFr = [0, AF], bFr = [0, 8746], pFr = [0, 8629], mFr = [0, NX], _Fr = [0, 8745], yFr = r("fnof"), hFr = r("ensp"), dFr = r("diams"), kFr = r("divide"), wFr = r("eacute"), EFr = r("ecirc"), SFr = r("egrave"), gFr = r(v7), FFr = r("emsp"), TFr = [0, 8195], OFr = [0, 8709], IFr = [0, ZF], AFr = [0, tH], NFr = [0, hT], CFr = [0, Dw], PFr = [0, 9830], DFr = r("epsilon"), LFr = r("equiv"), RFr = r("eta"), jFr = r("eth"), GFr = r("euml"), MFr = r("euro"), BFr = r("exist"), qFr = [0, 8707], UFr = [0, 8364], HFr = [0, JU], XFr = [0, s1], YFr = [0, 951], VFr = [0, 8801], zFr = [0, 949], KFr = [0, 8194], WFr = r("gt"), JFr = r("forall"), $Fr = r("frac12"), ZFr = r("frac14"), QFr = r("frac34"), rTr = r("frasl"), eTr = r("gamma"), nTr = r("ge"), tTr = [0, 8805], uTr = [0, 947], iTr = [0, 8260], fTr = [0, OY], xTr = [0, iY], oTr = [0, fX], aTr = [0, 8704], cTr = r("hArr"), sTr = r("harr"), vTr = r("hearts"), lTr = r("hellip"), bTr = r("iacute"), pTr = r("icirc"), mTr = [0, cH], _Tr = [0, BY], yTr = [0, 8230], hTr = [0, 9829], dTr = [0, 8596], kTr = [0, 8660], wTr = [0, 62], ETr = [0, 402], STr = [0, 948], gTr = [0, jh], FTr = r("prime"), TTr = r("ndash"), OTr = r("le"), ITr = r("kappa"), ATr = r("igrave"), NTr = r("image"), CTr = r("infin"), PTr = r("iota"), DTr = r("iquest"), LTr = r("isin"), RTr = r("iuml"), jTr = [0, i6], GTr = [0, 8712], MTr = [0, lX], BTr = [0, 953], qTr = [0, 8734], UTr = [0, 8465], HTr = [0, lO], XTr = r("lArr"), YTr = r("lambda"), VTr = r("lang"), zTr = r("laquo"), KTr = r("larr"), WTr = r("lceil"), JTr = r("ldquo"), $Tr = [0, 8220], ZTr = [0, 8968], QTr = [0, 8592], rOr = [0, pg], eOr = [0, 10216], nOr = [0, 955], tOr = [0, 8656], uOr = [0, 954], iOr = r("macr"), fOr = r("lfloor"), xOr = r("lowast"), oOr = r("loz"), aOr = r("lrm"), cOr = r("lsaquo"), sOr = r("lsquo"), vOr = r("lt"), lOr = [0, 60], bOr = [0, 8216], pOr = [0, 8249], mOr = [0, vU], _Or = [0, 9674], yOr = [0, 8727], hOr = [0, 8970], dOr = r("mdash"), kOr = r("micro"), wOr = r("middot"), EOr = r(cY), SOr = r("mu"), gOr = r("nabla"), FOr = r("nbsp"), TOr = [0, fY], OOr = [0, 8711], IOr = [0, 956], AOr = [0, 8722], NOr = [0, lS], COr = [0, Ai], POr = [0, 8212], DOr = [0, bX], LOr = [0, 8804], ROr = r("or"), jOr = r("oacute"), GOr = r("ne"), MOr = r("ni"), BOr = r("not"), qOr = r("notin"), UOr = r("nsub"), HOr = r("ntilde"), XOr = r("nu"), YOr = [0, 957], VOr = [0, Vy], zOr = [0, 8836], KOr = [0, 8713], WOr = [0, LU], JOr = [0, 8715], $Or = [0, 8800], ZOr = r("ocirc"), QOr = r("oelig"), rIr = r("ograve"), eIr = r("oline"), nIr = r("omega"), tIr = r("omicron"), uIr = r("oplus"), iIr = [0, 8853], fIr = [0, 959], xIr = [0, 969], oIr = [0, 8254], aIr = [0, ST], cIr = [0, 339], sIr = [0, v8], vIr = [0, QU], lIr = r("part"), bIr = r("ordf"), pIr = r("ordm"), mIr = r("oslash"), _Ir = r("otilde"), yIr = r("otimes"), hIr = r("ouml"), dIr = r("para"), kIr = [0, Yg], wIr = [0, $2], EIr = [0, 8855], SIr = [0, WY], gIr = [0, wt], FIr = [0, md], TIr = [0, qg], OIr = r("permil"), IIr = r("perp"), AIr = r("phi"), NIr = r("pi"), CIr = r("piv"), PIr = r("plusmn"), DIr = r("pound"), LIr = [0, Ln], RIr = [0, uV], jIr = [0, 982], GIr = [0, 960], MIr = [0, 966], BIr = [0, 8869], qIr = [0, 8240], UIr = [0, 8706], HIr = [0, 8744], XIr = [0, 8211], YIr = r("sup1"), VIr = r("rlm"), zIr = r("raquo"), KIr = r("prod"), WIr = r("prop"), JIr = r("psi"), $Ir = r("quot"), ZIr = r("rArr"), QIr = r("radic"), rAr = r("rang"), eAr = [0, 10217], nAr = [0, 8730], tAr = [0, 8658], uAr = [0, 34], iAr = [0, 968], fAr = [0, 8733], xAr = [0, 8719], oAr = r("rarr"), aAr = r("rceil"), cAr = r("rdquo"), sAr = r("real"), vAr = r("reg"), lAr = r("rfloor"), bAr = r("rho"), pAr = [0, 961], mAr = [0, 8971], _Ar = [0, $U], yAr = [0, 8476], hAr = [0, 8221], dAr = [0, 8969], kAr = [0, 8594], wAr = [0, nw], EAr = r("sigma"), SAr = r("rsaquo"), gAr = r("rsquo"), FAr = r("sbquo"), TAr = r("scaron"), OAr = r("sdot"), IAr = r("sect"), AAr = r("shy"), NAr = [0, _Y], CAr = [0, NT], PAr = [0, 8901], DAr = [0, 353], LAr = [0, 8218], RAr = [0, 8217], jAr = [0, 8250], GAr = r("sigmaf"), MAr = r("sim"), BAr = r("spades"), qAr = r("sub"), UAr = r("sube"), HAr = r("sum"), XAr = r("sup"), YAr = [0, 8835], VAr = [0, 8721], zAr = [0, 8838], KAr = [0, 8834], WAr = [0, 9824], JAr = [0, 8764], $Ar = [0, 962], ZAr = [0, 963], QAr = [0, 8207], rNr = r("uarr"), eNr = r("thetasym"), nNr = r("sup2"), tNr = r("sup3"), uNr = r("supe"), iNr = r("szlig"), fNr = r("tau"), xNr = r("there4"), oNr = r("theta"), aNr = [0, 952], cNr = [0, 8756], sNr = [0, 964], vNr = [0, y8], lNr = [0, 8839], bNr = [0, RY], pNr = [0, gO], mNr = r("thinsp"), _Nr = r("thorn"), yNr = r("tilde"), hNr = r("times"), dNr = r("trade"), kNr = r("uArr"), wNr = r("uacute"), ENr = [0, nl], SNr = [0, 8657], gNr = [0, 8482], FNr = [0, xT], TNr = [0, 732], ONr = [0, gv], INr = [0, 8201], ANr = [0, 977], NNr = r("xi"), CNr = r("ucirc"), PNr = r("ugrave"), DNr = r("uml"), LNr = r("upsih"), RNr = r("upsilon"), jNr = r("uuml"), GNr = r("weierp"), MNr = [0, iU], BNr = [0, Y2], qNr = [0, 965], UNr = [0, 978], HNr = [0, IY], XNr = [0, 249], YNr = [0, 251], VNr = r("yacute"), zNr = r("yen"), KNr = r("yuml"), WNr = r("zeta"), JNr = r("zwj"), $Nr = r("zwnj"), ZNr = [0, kY], QNr = [0, 8205], rCr = [0, 950], eCr = [0, gw], nCr = [0, $X], tCr = [0, nd], uCr = [0, 958], iCr = [0, 8593], fCr = [0, gU], xCr = [0, 8242], oCr = [0, XU], aCr = r(VY), cCr = r(jd), sCr = r("unreachable jsx_child"), vCr = r("unreachable type_token wholenumber"), lCr = r("unreachable type_token wholebigint"), bCr = r("unreachable type_token floatbigint"), pCr = r("unreachable type_token scinumber"), mCr = r("unreachable type_token scibigint"), _Cr = r("unreachable type_token hexnumber"), yCr = r("unreachable type_token hexbigint"), hCr = r("unreachable type_token legacyoctnumber"), dCr = r("unreachable type_token octnumber"), kCr = r("unreachable type_token octbigint"), wCr = r("unreachable type_token binnumber"), ECr = r("unreachable type_token bigbigint"), SCr = r("unreachable type_token"), gCr = r(o1), FCr = r(o1), TCr = r(kU), OCr = r(H8), ICr = r(n6), ACr = r(x1), NCr = r(O6), CCr = r(O2), PCr = r(v7), DCr = r(P7), LCr = r(Ci), RCr = r(e7), jCr = [9, 1], GCr = [9, 0], MCr = r(fs), BCr = r(dv), qCr = r(nu), UCr = r(Tv), HCr = r(K4), XCr = r(Gi), YCr = r(rs), VCr = r(es), zCr = r("unreachable template_tail"), KCr = r(b3), WCr = [0, r(C), r(C), r(C)], JCr = r("unreachable jsx_tag"), $Cr = r(P3), ZCr = r("unreachable regexp"), QCr = r("unreachable token wholenumber"), rPr = r("unreachable token wholebigint"), ePr = r("unreachable token floatbigint"), nPr = r("unreachable token scinumber"), tPr = r("unreachable token scibigint"), uPr = r("unreachable token hexnumber"), iPr = r("unreachable token hexbigint"), fPr = r("unreachable token legacyoctnumber"), xPr = r("unreachable token legacynonoctnumber"), oPr = r("unreachable token octnumber"), aPr = r("unreachable token octbigint"), cPr = r("unreachable token bignumber"), sPr = r("unreachable token bigint"), vPr = r("unreachable token"), lPr = r(o1), bPr = r(o1), pPr = r(kU), mPr = [6, r("#!")], _Pr = r("expected ?"), yPr = r(j2), hPr = r(_4), dPr = r(D2), kPr = r(gs), wPr = r(dx), EPr = r(A7), SPr = r(d6), gPr = r(o6), FPr = r(q2), TPr = r(N7), OPr = r(I7), IPr = r(T2), APr = r(_i), NPr = r(J2), CPr = r(np), PPr = r(U4), DPr = r(b8), LPr = r(_3), RPr = r(P7), jPr = r(Ci), GPr = r(q8), MPr = r(M2), BPr = r(A3), qPr = r(ws), UPr = r(Uu), HPr = r(R2), XPr = r(yv), YPr = r(y4), VPr = r(e7), zPr = r(G2), KPr = r(u1), WPr = r(fs), JPr = r(CS), $Pr = r(eh), ZPr = r(k4), QPr = r(a6), rDr = r(E6), eDr = r(Ju), nDr = r(nu), tDr = r(rs), uDr = r(D7), iDr = r(i1), fDr = r(F7), xDr = r(Gi), oDr = r(d4), aDr = r(Jc), cDr = r(U2), sDr = r(es), vDr = r(K6), lDr = r(C8), bDr = r(Eu), pDr = r("unreachable string_escape"), mDr = r(Zu), _Dr = r(H2), yDr = r(H2), hDr = r(Zu), dDr = r(dX), kDr = r(oY), wDr = r("n"), EDr = r("r"), SDr = r("t"), gDr = r(pV), FDr = r(H2), TDr = r(l1), ODr = r(l1), IDr = r("unreachable id_char"), ADr = r(l1), NDr = r(l1), CDr = r("Invalid (lexer) bigint "), PDr = r("Invalid (lexer) bigint binary/octal "), DDr = r(H2), LDr = r(pH), RDr = r(oU), jDr = r(Nh), GDr = [10, r("token ILLEGAL")], MDr = r("\0"), BDr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), qDr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), UDr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), HDr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), XDr = r("\0\0"), YDr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), VDr = r(""), zDr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), KDr = r("\0"), WDr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), JDr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), $Dr = r("\0\0\0\0"), ZDr = r("\0\0\0"), QDr = r("\x07\x07"), rLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), eLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), nLr = r(`\x07\b	
\v\f\r`), tLr = r(""), uLr = r("\0\0\0"), iLr = r("\0"), fLr = r("\0\0\0\0\0\0"), xLr = r(""), oLr = r(""), aLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), cLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), sLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), vLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), lLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), bLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), pLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), mLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), _Lr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), yLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), hLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), dLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x07\b\0\0\0\0\0\0	\x07\b"), kLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), wLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), ELr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), SLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), gLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), FLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), TLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), OLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), ILr = r(`\x07\b	
\v\x07\f\r\x1B																										 	!																										"#$%																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																													`), ALr = r(""), NLr = r(""), CLr = r("\0\0\0\0"), PLr = r(`\x07\b	
\v\f\r\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x1B\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07`), DLr = r(`\x07\b	
\v\f\r\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07`), LLr = r("\0\0"), RLr = r(""), jLr = r(""), GLr = r("\x07"), MLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), BLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), qLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), ULr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), HLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), XLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), YLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), VLr = r("\0\0\0\0\0\0\0"), zLr = r("\x07"), KLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), WLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), JLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), $Lr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), ZLr = r("\0"), QLr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), rRr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), eRr = r("\0\0"), nRr = r("\0"), tRr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), uRr = r(""), iRr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), fRr = r(""), xRr = r(""), oRr = r(""), aRr = r("\0"), cRr = r("\0\0\0"), sRr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), vRr = r(""), lRr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), bRr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), pRr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), mRr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), _Rr = r("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), yRr = [0, [11, r("the identifier `"), [2, 0, [12, 96, 0]]], r("the identifier `%s`")], hRr = [0, 1], dRr = [0, 1], kRr = r("@flow"), wRr = r(yX), ERr = r(yX), SRr = [0, [11, r("an identifier. When exporting a "), [2, 0, [11, r(" as a named export, you must specify a "), [2, 0, [11, r(" name. Did you mean `export default "), [2, 0, [11, r(" ...`?"), 0]]]]]]], r("an identifier. When exporting a %s as a named export, you must specify a %s name. Did you mean `export default %s ...`?")], gRr = r(g3), FRr = r("Peeking current location when not available"), TRr = r(e7), ORr = r(bv), IRr = r(n6), ARr = r(x1), NRr = r(O6), CRr = r(O2), PRr = r(v7), DRr = r(P7), LRr = r(Ci), RRr = r(H8), jRr = r(fs), GRr = r(dv), MRr = r(nu), BRr = r(Tv), qRr = r(Gi), URr = r(rs), HRr = r(es), XRr = r(Ci), YRr = r(fs), VRr = r(Gi), zRr = r(Ci), KRr = r(fs), WRr = r(Gi), JRr = r(C2), $Rr = r("eval"), ZRr = r(ws), QRr = r(e7), rjr = r(y4), ejr = r(k4), njr = r(a6), tjr = r(E6), ujr = r(nu), ijr = r(Eu), fjr = r(b8), xjr = r(A3), ojr = r(_i), ajr = r(dx), cjr = r(A7), sjr = r(d6), vjr = r(o6), ljr = r(q2), bjr = r(D2), pjr = r(N7), mjr = r(I7), _jr = r(J2), yjr = r(_4), hjr = r(U4), djr = r(_3), kjr = r(P7), wjr = r(q8), Ejr = r(np), Sjr = r(M2), gjr = r(F7), Fjr = r(Uu), Tjr = r(R2), Ojr = r(j2), Ijr = r(u1), Ajr = r(Ju), Njr = r(yv), Cjr = r(D7), Pjr = r(i1), Djr = r(d4), Ljr = r(rs), Rjr = r(U2), jjr = r(es), Gjr = r(K6), Mjr = r(C8), Bjr = r(Eu), qjr = [0, r("src/parser/parser_env.ml"), 343, 9], Ujr = r("Internal Error: Tried to add_declared_private with outside of class scope."), Hjr = r("Internal Error: `exit_class` called before a matching `enter_class`"), Xjr = r(C), Yjr = [0, 0, 0], Vjr = [0, 0, 0], zjr = r("Parser_env.Try.Rollback"), Kjr = r(C), Wjr = r(C), Jjr = [0, r(Eu), r(Yx), r(to), r(dU), r(gY), r(Oo), r(cu), r(dc), r(ux), r(oc), r(Gf), r(To), r(Po), r(ec), r(No), r(wf), r(Ja), r(uo), r(Cx), r(Ff), r(ax), r(Oa), r(qf), r(Ro), r(Ka), r(Xx), r(Jx), r(_x), r(xo), r(fa), r(no), r(F7), r(Io), r(Pf), r(wo), r($x), r(Jf), r(Uo), r(yo), r(D7), r(yc), r(Na), r(Sx), r(Vx), r(_f), r(Sc), r(Mf), r(cx), r(Ju), r(px), r(pa), r(De), r(r7), r($a), r(Yo), r(wa), r(Zx), r(sc), r(aa), r(ta), r(Cf), r(Bo), r(Yf), r(Wf), r(kc), r(vc), r(va), r(bf), r(zo), r(Zf), r(rx), r(mi), r(Qo), r(Mo), r(df), r(Va), r(Xo), r(lc), r(fc), r(Zo), r(oo), r(ix), r(Nf), r(uf), r(Xf), r(ex), r(ma), r(da), r(Kf), r(nc), r(gf), r(Lx), r(qo), r(bx), r(yf), r(Of), r(mc), r(xr), r(_c), r(Wx), r(Ux), r(Pa), r(zx), r(nx), r(Dx), r(ha), r(Px), r(hc), r(vx), r(Jo), r(wc), r(Da), r(Ko), r(rc), r(rf), r(Nx), r(ao), r(Ox), r(io), r(jo), r(Ao), r(pc), r(Ax), r(ff), r(of), r(Qf), r(Wo), r(ya), r(ac), r(Rf), r(za), r(ro), r(ko), r(af), r(e7), r(Aa), r(Fx), r(Ca), r(Hx), r(bo), r(Ec), r(Uu), r(Ya), r(ia), r(pf), r(yi), r(Vf), r(bc), r(Wa), r(G7), r(mx), r(ba), r(vf), r(Ba), r(kx), r(Go), r(_a), r(tx), r(nf), r(Lf), r(gc), r(Ix), r(hx), r(Ia), r(Tc), r(lo), r(So), r(li), r(ic), r(yx), r(La), r(Xa), r(Fc), r(Mx), r(ka), r(Bf), r(Sf), r(eo), r(Tx), r(Nu), r(ea), r(ua), r(Qa), r(sf), r(Sa), r(vo), r(Af), r(jx), r(Za), r(If), r(jf), r(Bx), r(Ho), r(qx), r(sa), r(ra), r(la), r(v7), r(ho), r(Ra), r(wx), r(Fo), r(so), r(na), r(zf), r(ja), r(Ta), r(xx), r(I7), r(N7), r($o), r(xa), r($f), r(iH), r(_o), r(uH), r(qU), r(hf), r(go), r(fx), r(gx), r(Uf), r(Ga), r(kf), r(tf), r(ga), r(Df), r(tc), r(mf), r(qa), r(oa), r(Ua), r(Ef), r(Qi), r(sx), r(po), r(lx), r(Tf), r(A7), r(Ha), r(Tn), r(Gx), r(xf), r(lf), r(Kx), r(Hf), r(Vo), r(ca), r(Ea), r(co), r(Rx), r(W4)], $jr = [0, r(Eu), r(Yx), r(to), r(Oo), r(cu), r(dc), r(ux), r(oc), r(Gf), r(To), r(Po), r(ec), r(No), r(wf), r(Ja), r(uo), r(Cx), r(Ff), r(ax), r(Oa), r(qf), r(Ro), r(Ka), r(Xx), r(Jx), r(_x), r(xo), r(fa), r(no), r(F7), r(Io), r(Pf), r(wo), r($x), r(Jf), r(Uo), r(yo), r(D7), r(yc), r(Na), r(Sx), r(Vx), r(_f), r(Sc), r(Mf), r(cx), r(Ju), r(px), r(pa), r(De), r(r7), r($a), r(Yo), r(wa), r(Zx), r(sc), r(aa), r(ta), r(Cf), r(Bo), r(Yf), r(Wf), r(kc), r(vc), r(va), r(bf), r(zo), r(Zf), r(rx), r(mi), r(Qo), r(Mo), r(df), r(Va), r(Xo), r(lc), r(fc), r(Zo), r(oo), r(ix), r(Nf), r(uf), r(Xf), r(ex), r(ma), r(da), r(Kf), r(nc), r(gf), r(Lx), r(qo), r(bx), r(yf), r(Of), r(mc), r(xr), r(_c), r(Wx), r(Ux), r(Pa), r(zx), r(nx), r(Dx), r(ha), r(Px), r(hc), r(vx), r(Jo), r(wc), r(Da), r(Ko), r(rc), r(rf), r(Nx), r(ao), r(Ox), r(io), r(jo), r(Ao), r(pc), r(Ax), r(ff), r(of), r(Qf), r(Wo), r(ya), r(ac), r(Rf), r(za), r(ro), r(ko), r(af), r(e7), r(Aa), r(Fx), r(Ca), r(Hx), r(bo), r(Ec), r(Uu), r(Ya), r(ia), r(pf), r(yi), r(Vf), r(bc), r(Wa), r(G7), r(mx), r(ba), r(vf), r(Ba), r(kx), r(Go), r(_a), r(tx), r(nf), r(Lf), r(gc), r(Ix), r(hx), r(Ia), r(Tc), r(lo), r(So), r(li), r(ic), r(yx), r(La), r(Xa), r(Fc), r(Mx), r(ka), r(Bf), r(Sf), r(eo), r(Tx), r(Nu), r(ea), r(ua), r(Qa), r(sf), r(Sa), r(vo), r(Af), r(jx), r(Za), r(If), r(jf), r(Bx), r(Ho), r(qx), r(sa), r(ra), r(la), r(v7), r(ho), r(Ra), r(wx), r(Fo), r(so), r(na), r(zf), r(ja), r(Ta), r(xx), r(I7), r(N7), r($o), r(xa), r($f), r(_o), r(hf), r(go), r(fx), r(gx), r(Uf), r(Ga), r(kf), r(tf), r(ga), r(Df), r(tc), r(mf), r(qa), r(oa), r(Ua), r(Ef), r(Qi), r(sx), r(po), r(lx), r(Tf), r(A7), r(Ha), r(Tn), r(Gx), r(xf), r(lf), r(Kx), r(Hf), r(Vo), r(ca), r(Ea), r(co), r(Rx), r(W4)], Zjr = [0, r(_f), r(Qf), r(_a), r(Vf), r(Tf), r(Yf), r(qo), r(ex), r(Nx), r(ko), r(Ka), r(D7), r(Xo), r(ea), r(tc), r(pc), r(bx), r(ff), r(ra), r(Bx), r(Yx), r(li), r(hc), r(Lx), r(Wa), r(sa), r(Of), r(yi), r(Oo), r(Mx), r(ta), r(zf), r(sx), r(tx), r(Qi), r(jo), r(Af), r(ba), r(vc), r(ic), r(yo), r(Kx), r(ma), r(ia), r(Sx), r(la), r(Px), r(yf), r(tf), r(go), r(Qo), r(wa), r(Xf), r(Yo), r(Ko), r(Uf), r(fc), r(r7), r(Nf), r(Ba), r(mc), r(ao), r(Ao), r(bc), r(nx), r($o), r(Jx), r(If), r(uf), r(rc), r($f), r(Dx), r(Go), r(aa), r(Ea), r(so), r(Sa), r(Wx), r(rx), r(co), r(po), r(cx), r(cu), r($a), r(uo), r(Ya), r(lf), r(So), r(no), r(ac), r(Df), r(nc), r(Uo), r(v7), r(Xa), r(Xx), r(Eu), r(fa), r(Ta), r(ec), r(zo), r(px), r(Po), r(hf), r(ja), r(oc), r(Ax), r(Zx), r(ro), r(Ho), r(Sf), r(lc), r(ua), r(ha), r(bf), r(ka), r(Ff), r(xo), r(dc), r(Sc), r(Cx), r(To), r(Ga), r(yx), r(fx), r(Pa), r(kx), r(Gf), r(_o), r(gf), r(Jo), r(Hf), r(Ux), r(oa), r(ga), r(Aa), r(va), r(Mo), r(wc), r(_c), r(Uu), r(Ju), r(Ha), r(Ja), r(ax), r(yc), r(kc), r(F7), r(I7), r(pf), r(Va), r(Tx), r(of), r(mi), r(Ix), r(qx), r(Fx), r(gx), r(nf), r(zx), r(Wo), r(G7), r(vf), r(wf), r(jf), r(De), r(Tc), r(bo), r(Za), r(sf), r(Kf), r(Mf), r(Ca), r(oo), r(Cf), r(_x), r(ix), r(Oa), r(lx), r(Fo), r(Ua), r(na), r(Gx), r(Rf), r(Jf), r(mx), r(pa), r(Ec), r(qa), r(da), r(io), r(kf), r(af), r(ho), r(Ro), r(Rx), r(ux), r(Ef), r(qf), r(Ra), r(Ox), r(ya), r(xa), r(vx), r(Bo), r(za), r(Bf), r(Da), r(wo), r(Vo), r(Wf), r(xf), r(Nu), r(Zf), r(eo), r(hx), r(Ia), r(Vx), r(N7), r(Lf), r(sc), r(vo), r(wx), r(Pf), r($x), r(Na), r(lo), r(Qa), r(No), r(La), r(df), r(Tn), r(Hx), r(mf), r(rf), r(Zo), r(gc), r(xx), r(jx), r(A7), r(ca), r(e7), r(to), r(Fc), r(Io), r(xr)], Qjr = [0, r(_f), r(Qf), r(_a), r(Vf), r(Tf), r(Yf), r(qo), r(ex), r(Nx), r(ko), r(Ka), r(D7), r(Xo), r(ea), r(tc), r(pc), r(bx), r(ff), r(ra), r(Bx), r(Yx), r(li), r(hc), r(Lx), r(Wa), r(sa), r(Of), r(yi), r(Oo), r(gY), r(Mx), r(ta), r(zf), r(sx), r(tx), r(Qi), r(jo), r(Af), r(ba), r(vc), r(ic), r(yo), r(Kx), r(ma), r(ia), r(Sx), r(la), r(Px), r(yf), r(tf), r(go), r(Qo), r(wa), r(uH), r(Xf), r(Yo), r(Ko), r(Uf), r(fc), r(r7), r(Nf), r(Ba), r(mc), r(ao), r(Ao), r(bc), r(nx), r($o), r(Jx), r(If), r(uf), r(rc), r($f), r(Dx), r(Go), r(aa), r(Ea), r(so), r(Sa), r(Wx), r(rx), r(co), r(po), r(cx), r(cu), r($a), r(uo), r(Ya), r(lf), r(So), r(no), r(ac), r(Df), r(nc), r(Uo), r(v7), r(Xa), r(Xx), r(Eu), r(fa), r(Ta), r(ec), r(zo), r(px), r(Po), r(hf), r(ja), r(oc), r(Ax), r(Zx), r(ro), r(Ho), r(Sf), r(lc), r(ua), r(ha), r(bf), r(ka), r(Ff), r(xo), r(dc), r(Sc), r(Cx), r(To), r(Ga), r(yx), r(fx), r(Pa), r(kx), r(Gf), r(_o), r(gf), r(Jo), r(Hf), r(Ux), r(oa), r(ga), r(Aa), r(va), r(Mo), r(wc), r(_c), r(Uu), r(Ju), r(Ha), r(Ja), r(ax), r(yc), r(kc), r(F7), r(I7), r(pf), r(Va), r(Tx), r(of), r(mi), r(Ix), r(qx), r(Fx), r(gx), r(nf), r(zx), r(Wo), r(G7), r(vf), r(wf), r(jf), r(De), r(Tc), r(bo), r(Za), r(sf), r(Kf), r(Mf), r(Ca), r(oo), r(Cf), r(_x), r(ix), r(Oa), r(lx), r(Fo), r(Ua), r(na), r(Gx), r(Rf), r(qU), r(Jf), r(mx), r(pa), r(Ec), r(qa), r(da), r(io), r(kf), r(af), r(ho), r(Ro), r(iH), r(Rx), r(ux), r(Ef), r(qf), r(dU), r(Ra), r(Ox), r(ya), r(xa), r(vx), r(Bo), r(za), r(Bf), r(Da), r(wo), r(Vo), r(Wf), r(xf), r(Nu), r(Zf), r(eo), r(hx), r(Ia), r(Vx), r(N7), r(Lf), r(sc), r(vo), r(wx), r(Pf), r($x), r(Na), r(lo), r(Qa), r(No), r(La), r(df), r(Tn), r(Hx), r(mf), r(rf), r(Zo), r(gc), r(xx), r(jx), r(A7), r(ca), r(e7), r(to), r(Fc), r(Io), r(xr)], rGr = r(Y4), eGr = r(I2), nGr = [0, [11, r("Failure while looking up "), [2, 0, [11, r(". Index: "), [4, 0, 0, 0, [11, r(". Length: "), [4, 0, 0, 0, [12, 46, 0]]]]]]], r("Failure while looking up %s. Index: %d. Length: %d.")], tGr = [0, 0, 0, 0], uGr = r("Offset_utils.Offset_lookup_failed"), iGr = r(KY), fGr = r(hE), xGr = r(CY), oGr = r(VX), aGr = r(VX), cGr = r(CY), sGr = r(Jc), vGr = r(Xr), lGr = r(Wn), bGr = r("Program"), pGr = r(Ud), mGr = r("BreakStatement"), _Gr = r(Ud), yGr = r("ContinueStatement"), hGr = r("DebuggerStatement"), dGr = r(cc), kGr = r("DeclareExportAllDeclaration"), wGr = r(cc), EGr = r(Cv), SGr = r(P2), gGr = r(_i), FGr = r("DeclareExportDeclaration"), TGr = r($c), OGr = r(Wn), IGr = r(mt), AGr = r("DeclareModule"), NGr = r(C7), CGr = r("DeclareModuleExports"), PGr = r(Ss), DGr = r(Wn), LGr = r("DoWhileStatement"), RGr = r("EmptyStatement"), jGr = r(bO), GGr = r(P2), MGr = r("ExportDefaultDeclaration"), BGr = r(bO), qGr = r(I4), UGr = r(cc), HGr = r("ExportAllDeclaration"), XGr = r(bO), YGr = r(cc), VGr = r(Cv), zGr = r(P2), KGr = r("ExportNamedDeclaration"), WGr = r(Zi), JGr = r(Nu), $Gr = r("ExpressionStatement"), ZGr = r(Wn), QGr = r(fU), rMr = r(Ss), eMr = r(ji), nMr = r("ForStatement"), tMr = r(R8), uMr = r(Wn), iMr = r(Cu), fMr = r(bi), xMr = r("ForInStatement"), oMr = r(dx), aMr = r(Wn), cMr = r(Cu), sMr = r(bi), vMr = r("ForOfStatement"), lMr = r(m3), bMr = r(kv), pMr = r(Ss), mMr = r("IfStatement"), _Mr = r(Jc), yMr = r(rs), hMr = r(Bn), dMr = r(cX), kMr = r(cc), wMr = r(Cv), EMr = r("ImportDeclaration"), SMr = r(Wn), gMr = r(Ud), FMr = r("LabeledStatement"), TMr = r(l7), OMr = r("ReturnStatement"), IMr = r(QX), AMr = r("discriminant"), NMr = r("SwitchStatement"), CMr = r(l7), PMr = r("ThrowStatement"), DMr = r(CH), LMr = r(MU), RMr = r(Tn), jMr = r("TryStatement"), GMr = r(Wn), MMr = r(Ss), BMr = r("WhileStatement"), qMr = r(Wn), UMr = r(xk), HMr = r("WithStatement"), XMr = r(PH), YMr = r("ArrayExpression"), VMr = r(O7), zMr = r(p6), KMr = r(Nu), WMr = r(r7), JMr = r(G7), $Mr = r(gs), ZMr = r(Wn), QMr = r(Dt), rBr = r(mt), eBr = r("ArrowFunctionExpression"), nBr = r(XO), tBr = r(Cu), uBr = r(bi), iBr = r(ul), fBr = r("AssignmentExpression"), xBr = r(Cu), oBr = r(bi), aBr = r(ul), cBr = r("BinaryExpression"), sBr = r("CallExpression"), vBr = r(T4), lBr = r(aY), bBr = r("ComprehensionExpression"), pBr = r(m3), mBr = r(kv), _Br = r(Ss), yBr = r("ConditionalExpression"), hBr = r(T4), dBr = r(aY), kBr = r("GeneratorExpression"), wBr = r(cc), EBr = r("ImportExpression"), SBr = r(zH), gBr = r(MX), FBr = r(Ke), TBr = r(Cu), OBr = r(bi), IBr = r(ul), ABr = r("LogicalExpression"), NBr = r("MemberExpression"), CBr = r(Iv), PBr = r(el), DBr = r("MetaProperty"), LBr = r(C2), RBr = r(TX), jBr = r(jH), GBr = r("NewExpression"), MBr = r(H4), BBr = r("ObjectExpression"), qBr = r(qu), UBr = r("OptionalCallExpression"), HBr = r(qu), XBr = r("OptionalMemberExpression"), YBr = r(Mg), VBr = r("SequenceExpression"), zBr = r("Super"), KBr = r("ThisExpression"), WBr = r(C7), JBr = r(Nu), $Br = r("TypeCastExpression"), ZBr = r(l7), QBr = r("AwaitExpression"), rqr = r(Fa), eqr = r(xs), nqr = r(Kt), tqr = r(ZY), uqr = r(rs), iqr = r(es), fqr = r(J2), xqr = r("matched above"), oqr = r(l7), aqr = r(qE), cqr = r(ul), sqr = r("UnaryExpression"), vqr = r(oV), lqr = r(sH), bqr = r(qE), pqr = r(l7), mqr = r(ul), _qr = r("UpdateExpression"), yqr = r(lY), hqr = r(l7), dqr = r("YieldExpression"), kqr = r("Unexpected FunctionDeclaration with BodyExpression"), wqr = r(O7), Eqr = r(p6), Sqr = r(Nu), gqr = r(r7), Fqr = r(G7), Tqr = r(gs), Oqr = r(Wn), Iqr = r(Dt), Aqr = r(mt), Nqr = r("FunctionDeclaration"), Cqr = r("Unexpected FunctionExpression with BodyExpression"), Pqr = r(O7), Dqr = r(p6), Lqr = r(Nu), Rqr = r(r7), jqr = r(G7), Gqr = r(gs), Mqr = r(Wn), Bqr = r(Dt), qqr = r(mt), Uqr = r("FunctionExpression"), Hqr = r(qu), Xqr = r(C7), Yqr = r(ui), Vqr = r(tn), zqr = r(qu), Kqr = r(C7), Wqr = r(ui), Jqr = r("PrivateIdentifier"), $qr = r(qu), Zqr = r(C7), Qqr = r(ui), rUr = r(tn), eUr = r(kv), nUr = r(Ss), tUr = r("SwitchCase"), uUr = r(Wn), iUr = r("param"), fUr = r("CatchClause"), xUr = r(Wn), oUr = r("BlockStatement"), aUr = r(mt), cUr = r("DeclareVariable"), sUr = r(r7), vUr = r(mt), lUr = r("DeclareFunction"), bUr = r(Hy), pUr = r(ws), mUr = r(P7), _Ur = r(Wn), yUr = r(O7), hUr = r(mt), dUr = r("DeclareClass"), kUr = r(P7), wUr = r(Wn), EUr = r(O7), SUr = r(mt), gUr = r("DeclareInterface"), FUr = r(Bn), TUr = r(Jc), OUr = r(I4), IUr = r("ExportNamespaceSpecifier"), AUr = r(Cu), NUr = r(O7), CUr = r(mt), PUr = r("DeclareTypeAlias"), DUr = r(Cu), LUr = r(O7), RUr = r(mt), jUr = r("TypeAlias"), GUr = r("DeclareOpaqueType"), MUr = r("OpaqueType"), BUr = r(SX), qUr = r(mX), UUr = r(O7), HUr = r(mt), XUr = r("ClassDeclaration"), YUr = r("ClassExpression"), VUr = r(j_), zUr = r(ws), KUr = r("superTypeParameters"), WUr = r("superClass"), JUr = r(O7), $Ur = r(Wn), ZUr = r(mt), QUr = r(Nu), rHr = r("Decorator"), eHr = r(O7), nHr = r(mt), tHr = r("ClassImplements"), uHr = r(Wn), iHr = r("ClassBody"), fHr = r(wv), xHr = r(F2), oHr = r(n1), aHr = r(lv), cHr = r(j_), sHr = r(pv), vHr = r(nu), lHr = r($c), bHr = r(Bn), pHr = r(ii), mHr = r("MethodDefinition"), _Hr = r(T2), yHr = r(cu), hHr = r(nu), dHr = r(pv), kHr = r(C7), wHr = r(Bn), EHr = r(ii), SHr = r(xV), gHr = r("Internal Error: Private name found in class prop"), FHr = r(T2), THr = r(cu), OHr = r(nu), IHr = r(pv), AHr = r(C7), NHr = r(Bn), CHr = r(ii), PHr = r(xV), DHr = r(mt), LHr = r(OX), RHr = r(ji), jHr = r(mt), GHr = r("EnumStringMember"), MHr = r(mt), BHr = r(OX), qHr = r(ji), UHr = r(mt), HHr = r("EnumNumberMember"), XHr = r(ji), YHr = r(mt), VHr = r("EnumBooleanMember"), zHr = r(T8), KHr = r(DT), WHr = r(A4), JHr = r("EnumBooleanBody"), $Hr = r(T8), ZHr = r(DT), QHr = r(A4), rXr = r("EnumNumberBody"), eXr = r(T8), nXr = r(DT), tXr = r(A4), uXr = r("EnumStringBody"), iXr = r(T8), fXr = r(A4), xXr = r("EnumSymbolBody"), oXr = r(Wn), aXr = r(mt), cXr = r("EnumDeclaration"), sXr = r(P7), vXr = r(Wn), lXr = r(O7), bXr = r(mt), pXr = r("InterfaceDeclaration"), mXr = r(O7), _Xr = r(mt), yXr = r("InterfaceExtends"), hXr = r(C7), dXr = r(H4), kXr = r("ObjectPattern"), wXr = r(C7), EXr = r(PH), SXr = r("ArrayPattern"), gXr = r(Cu), FXr = r(bi), TXr = r(DF), OXr = r(C7), IXr = r(ui), AXr = r(tn), NXr = r(l7), CXr = r(iX), PXr = r(l7), DXr = r(iX), LXr = r(Cu), RXr = r(bi), jXr = r(DF), GXr = r(ji), MXr = r(ji), BXr = r(n1), qXr = r(lv), UXr = r(aH), HXr = r(pv), XXr = r(f6), YXr = r(F2), VXr = r($c), zXr = r(Bn), KXr = r(ii), WXr = r(_U), JXr = r(l7), $Xr = r("SpreadProperty"), ZXr = r(Cu), QXr = r(bi), rYr = r(DF), eYr = r(pv), nYr = r(f6), tYr = r(F2), uYr = r($c), iYr = r(Bn), fYr = r(ii), xYr = r(_U), oYr = r(l7), aYr = r("SpreadElement"), cYr = r(R8), sYr = r(Cu), vYr = r(bi), lYr = r("ComprehensionBlock"), bYr = r("We should not create Literal nodes for bigints"), pYr = r(jX), mYr = r(mi), _Yr = r("regex"), yYr = r(c7), hYr = r(Bn), dYr = r(c7), kYr = r(Bn), wYr = r(H6), EYr = r(c7), SYr = r(Bn), gYr = r(H6), FYr = r(x1), TYr = r(Bn), OYr = r("BigIntLiteral"), IYr = r(c7), AYr = r(Bn), NYr = r(H6), CYr = r(Gi), PYr = r(Ci), DYr = r(c7), LYr = r(Bn), RYr = r(H6), jYr = r(Mg), GYr = r("quasis"), MYr = r("TemplateLiteral"), BYr = r(PY), qYr = r(c7), UYr = r(aU), HYr = r(Bn), XYr = r("TemplateElement"), YYr = r(EY), VYr = r("tag"), zYr = r("TaggedTemplateExpression"), KYr = r(U2), WYr = r(G2), JYr = r(D2), $Yr = r($c), ZYr = r("declarations"), QYr = r("VariableDeclaration"), rVr = r(ji), eVr = r(mt), nVr = r("VariableDeclarator"), tVr = r($c), uVr = r("Variance"), iVr = r("AnyTypeAnnotation"), fVr = r("MixedTypeAnnotation"), xVr = r("EmptyTypeAnnotation"), oVr = r("VoidTypeAnnotation"), aVr = r("NullLiteralTypeAnnotation"), cVr = r("SymbolTypeAnnotation"), sVr = r("NumberTypeAnnotation"), vVr = r("BigIntTypeAnnotation"), lVr = r("StringTypeAnnotation"), bVr = r("BooleanTypeAnnotation"), pVr = r(C7), mVr = r("NullableTypeAnnotation"), _Vr = r(O7), yVr = r(xd), hVr = r(p6), dVr = r(i1), kVr = r(Dt), wVr = r("FunctionTypeAnnotation"), EVr = r(qu), SVr = r(C7), gVr = r(ui), FVr = r(RH), TVr = r(qu), OVr = r(C7), IVr = r(ui), AVr = r(RH), NVr = [0, 0, 0, 0, 0], CVr = r("internalSlots"), PVr = r("callProperties"), DVr = r("indexers"), LVr = r(H4), RVr = r("exact"), jVr = r(GY), GVr = r("ObjectTypeAnnotation"), MVr = r(aH), BVr = r("There should not be computed object type property keys"), qVr = r(ji), UVr = r(n1), HVr = r(lv), XVr = r($c), YVr = r(cu), VVr = r(X3), zVr = r(nu), KVr = r(qu), WVr = r(F2), JVr = r(Bn), $Vr = r(ii), ZVr = r("ObjectTypeProperty"), QVr = r(l7), rzr = r("ObjectTypeSpreadProperty"), ezr = r(cu), nzr = r(nu), tzr = r(Bn), uzr = r(ii), izr = r(mt), fzr = r("ObjectTypeIndexer"), xzr = r(nu), ozr = r(Bn), azr = r("ObjectTypeCallProperty"), czr = r(Bn), szr = r(F2), vzr = r(nu), lzr = r(qu), bzr = r(mt), pzr = r("ObjectTypeInternalSlot"), mzr = r(Wn), _zr = r(P7), yzr = r("InterfaceTypeAnnotation"), hzr = r("elementType"), dzr = r("ArrayTypeAnnotation"), kzr = r(mt), wzr = r(eY), Ezr = r("QualifiedTypeIdentifier"), Szr = r(O7), gzr = r(mt), Fzr = r("GenericTypeAnnotation"), Tzr = r("indexType"), Ozr = r("objectType"), Izr = r("IndexedAccessType"), Azr = r(qu), Nzr = r("OptionalIndexedAccessType"), Czr = r($6), Pzr = r("UnionTypeAnnotation"), Dzr = r($6), Lzr = r("IntersectionTypeAnnotation"), Rzr = r(l7), jzr = r("TypeofTypeAnnotation"), Gzr = r(mt), Mzr = r(eY), Bzr = r("QualifiedTypeofIdentifier"), qzr = r($6), Uzr = r("TupleTypeAnnotation"), Hzr = r(c7), Xzr = r(Bn), Yzr = r("StringLiteralTypeAnnotation"), Vzr = r(c7), zzr = r(Bn), Kzr = r("NumberLiteralTypeAnnotation"), Wzr = r(c7), Jzr = r(Bn), $zr = r("BigIntLiteralTypeAnnotation"), Zzr = r(Gi), Qzr = r(Ci), rKr = r(c7), eKr = r(Bn), nKr = r("BooleanLiteralTypeAnnotation"), tKr = r("ExistsTypeAnnotation"), uKr = r(C7), iKr = r("TypeAnnotation"), fKr = r(Dt), xKr = r("TypeParameterDeclaration"), oKr = r(_i), aKr = r(cu), cKr = r(DU), sKr = r(ui), vKr = r("TypeParameter"), lKr = r(Dt), bKr = r(gH), pKr = r(Dt), mKr = r(gH), _Kr = r(bv), yKr = r(Ve), hKr = r("closingElement"), dKr = r("openingElement"), kKr = r("JSXElement"), wKr = r("closingFragment"), EKr = r(Ve), SKr = r("openingFragment"), gKr = r("JSXFragment"), FKr = r("selfClosing"), TKr = r(mY), OKr = r(ui), IKr = r("JSXOpeningElement"), AKr = r("JSXOpeningFragment"), NKr = r(ui), CKr = r("JSXClosingElement"), PKr = r("JSXClosingFragment"), DKr = r(Bn), LKr = r(ui), RKr = r("JSXAttribute"), jKr = r(l7), GKr = r("JSXSpreadAttribute"), MKr = r("JSXEmptyExpression"), BKr = r(Nu), qKr = r("JSXExpressionContainer"), UKr = r(Nu), HKr = r("JSXSpreadChild"), XKr = r(c7), YKr = r(Bn), VKr = r("JSXText"), zKr = r(Iv), KKr = r(xk), WKr = r("JSXMemberExpression"), JKr = r(ui), $Kr = r("namespace"), ZKr = r("JSXNamespacedName"), QKr = r(ui), rWr = r("JSXIdentifier"), eWr = r(I4), nWr = r(B2), tWr = r("ExportSpecifier"), uWr = r(B2), iWr = r("ImportDefaultSpecifier"), fWr = r(B2), xWr = r("ImportNamespaceSpecifier"), oWr = r(cX), aWr = r(B2), cWr = r("imported"), sWr = r("ImportSpecifier"), vWr = r("Line"), lWr = r("Block"), bWr = r(Bn), pWr = r(Bn), mWr = r("DeclaredPredicate"), _Wr = r("InferredPredicate"), yWr = r(C2), hWr = r(TX), dWr = r(jH), kWr = r(pv), wWr = r(Iv), EWr = r(xk), SWr = r("message"), gWr = r(hE), FWr = r(HH), TWr = r(g7), OWr = r(cc), IWr = r(I2), AWr = r(Y4), NWr = [0, [3, 0, 0], r(Vt)], CWr = r(M2), PWr = r(A3), DWr = r(R2), LWr = r(j2), RWr = r(Ju), jWr = r(D7), GWr = r(i1), MWr = r(F7), BWr = r(d4), qWr = r(U2), UWr = r(K6), HWr = r(C8), XWr = r(D2), YWr = r(G2), VWr = r(fs), zWr = r(Ci), KWr = r(Gi), WWr = r(A7), JWr = r(d6), $Wr = r(o6), ZWr = r(N7), QWr = r(_i), rJr = r(_4), eJr = r(q8), nJr = r(np), tJr = r(q2), uJr = r(P7), iJr = r(nu), fJr = r(U4), xJr = r(u1), oJr = r(J2), aJr = r(rs), cJr = r(es), sJr = r(b8), vJr = r(_3), lJr = r(Uu), bJr = r(yv), pJr = r(ws), mJr = r(e7), _Jr = r(y4), yJr = r(k4), hJr = r(a6), dJr = r(E6), kJr = r(Eu), wJr = r(I7), EJr = r(T2), SJr = r(Jc), gJr = r(eh), FJr = r(CS), TJr = r(gs), OJr = r(dx), IJr = r(n6), AJr = r(H8), NJr = r(v7), CJr = r(dv), PJr = r(x1), DJr = r(Tv), LJr = r(es), RJr = r(K4), jJr = r(O2), GJr = r(O6), MJr = [0, r(g3)], BJr = r(C), qJr = [7, 0], UJr = r(C), HJr = [0, 1], XJr = [0, 2], YJr = [0, 3], VJr = [0, 0], zJr = [0, 0], KJr = [0, 0, 0, 0, 0], WJr = [0, r(vv), 906, 6], JJr = [0, r(vv), ZX, 6], $Jr = [0, 0], ZJr = [0, r(vv), 1012, 8], QJr = r(X3), r$r = [0, r(vv), 1029, 8], e$r = r("Can not have both `static` and `proto`"), n$r = r(nu), t$r = r(X3), u$r = r(n1), i$r = r(lv), f$r = r(n1), x$r = r(wv), o$r = r(oH), a$r = [0, 0, 0, 0], c$r = [0, [0, 0, 0, 0, 0]], s$r = r(i1), v$r = [0, r("a type")], l$r = [0, 0], b$r = [0, 0], p$r = [14, 1], m$r = [14, 0], _$r = [0, r(vv), EH, 15], y$r = [0, r(vv), L7, 15], h$r = [0, 44], d$r = [0, 44], k$r = r(M2), w$r = [0, r(C), 0], E$r = [0, 0, 0], S$r = [0, 0, 0], g$r = [0, 0, 0], F$r = [0, 41], T$r = r(Qu), O$r = r(Qu), I$r = [0, r("a regular expression")], A$r = r(C), N$r = r(C), C$r = r(C), P$r = [0, r("src/parser/expression_parser.ml"), CU, 17], D$r = [0, r("a template literal part")], L$r = [0, [0, r(C), r(C)], 1], R$r = r(fs), j$r = r(fs), G$r = r(Gi), M$r = r(Ci), B$r = r("Invalid bigint "), q$r = r("Invalid bigint binary/octal "), U$r = r(H2), H$r = r(pH), X$r = r(Nh), Y$r = r(Nh), V$r = r(oU), z$r = [0, 44], K$r = [0, 1], W$r = [0, 1], J$r = [0, 1], $$r = [0, 1], Z$r = [0, 0], Q$r = r(bv), rZr = r(bv), eZr = r(u1), nZr = r(gS), tZr = [0, r("the identifier `target`")], uZr = [0, 0], iZr = r(Uu), fZr = r(el), xZr = r(el), oZr = r(yv), aZr = [0, 0], cZr = [0, r("either a call or access of `super`")], sZr = r(yv), vZr = [0, 0], lZr = [0, 1], bZr = [0, 0], pZr = [0, 1], mZr = [0, 0], _Zr = [0, 1], yZr = [0, 0], hZr = [0, 2], dZr = [0, 3], kZr = [0, 7], wZr = [0, 6], EZr = [0, 4], SZr = [0, 5], gZr = [0, [0, 17, [0, 2]]], FZr = [0, [0, 18, [0, 3]]], TZr = [0, [0, 19, [0, 4]]], OZr = [0, [0, 0, [0, 5]]], IZr = [0, [0, 1, [0, 5]]], AZr = [0, [0, 2, [0, 5]]], NZr = [0, [0, 3, [0, 5]]], CZr = [0, [0, 5, [0, 6]]], PZr = [0, [0, 7, [0, 6]]], DZr = [0, [0, 4, [0, 6]]], LZr = [0, [0, 6, [0, 6]]], RZr = [0, [0, 8, [0, 7]]], jZr = [0, [0, 9, [0, 7]]], GZr = [0, [0, 10, [0, 7]]], MZr = [0, [0, 11, [0, 8]]], BZr = [0, [0, 12, [0, 8]]], qZr = [0, [0, 15, [0, 9]]], UZr = [0, [0, 13, [0, 9]]], HZr = [0, [0, 14, [1, 10]]], XZr = [0, [0, 16, [0, 9]]], YZr = [0, [0, 21, [0, 6]]], VZr = [0, [0, 20, [0, 6]]], zZr = [23, r(Ke)], KZr = [0, [0, 8]], WZr = [0, [0, 7]], JZr = [0, [0, 6]], $Zr = [0, [0, 10]], ZZr = [0, [0, 9]], QZr = [0, [0, 11]], rQr = [0, [0, 5]], eQr = [0, [0, 4]], nQr = [0, [0, 2]], tQr = [0, [0, 3]], uQr = [0, [0, 1]], iQr = [0, [0, 0]], fQr = [0, [0, 12]], xQr = [0, [0, 13]], oQr = [0, [0, 14]], aQr = [0, 0], cQr = r(Uu), sQr = r(u1), vQr = r(gS), lQr = r(el), bQr = r(gs), pQr = r(Uu), mQr = r(u1), _Qr = r(gS), yQr = r(el), hQr = r(o1), dQr = r(Lo), kQr = [17, r("JSX fragment")], wQr = [0, Ni], EQr = [1, Ni], SQr = r(C), gQr = [0, r(C)], FQr = [0, r(g3)], TQr = r(C), OQr = [0, 0, 0, 0], IQr = [0, r("src/hack_forked/utils/collections/flow_map.ml"), 717, 36], AQr = [0, 0, 0], NQr = r(q2), CQr = [0, r(C), 0], PQr = r("unexpected PrivateName in Property, expected a PrivateField"), DQr = r(wv), LQr = r(oH), RQr = [0, 0, 0], jQr = r(wv), GQr = r(wv), MQr = r(n1), BQr = r(lv), qQr = [0, 1], UQr = [0, 1], HQr = [0, 1], XQr = r(wv), YQr = r(n1), VQr = r(lv), zQr = r(XO), KQr = r(Eu), WQr = r(dx), JQr = r("Internal Error: private name found in object props"), $Qr = r(cV), ZQr = [0, r(g3)], QQr = r(Eu), r0e = r(dx), e0e = r(Eu), n0e = r(dx), t0e = r(cV), u0e = [10, r(yi)], i0e = [0, 1], f0e = r(a1), x0e = r(K2), o0e = [0, r(LS), 1763, 21], a0e = r(K2), c0e = r(a1), s0e = [0, r("a declaration, statement or export specifiers")], v0e = [0, 40], l0e = r(a1), b0e = r(K2), p0e = [0, r(C), r(C), 0], m0e = [0, r(EU)], _0e = r(pU), y0e = r("exports"), h0e = [0, 1], d0e = [0, 1], k0e = [0, 0], w0e = r(pU), E0e = [0, 40], S0e = r(Hy), g0e = [0, 0], F0e = [0, 1], T0e = [0, 83], O0e = [0, 0], I0e = [0, 1], A0e = r(a1), N0e = r(a1), C0e = r(K2), P0e = r(a1), D0e = [0, r("the keyword `as`")], L0e = r(a1), R0e = r(K2), j0e = [0, r(EU)], G0e = [0, r("the keyword `from`")], M0e = [0, r(C), r(C), 0], B0e = [0, r(tU)], q0e = r("Label"), U0e = [0, r(tU)], H0e = [0, 0, 0], X0e = [0, 29], Y0e = [0, r(LS), 431, 22], V0e = [0, 28], z0e = [0, r(LS), 450, 22], K0e = [0, 0], W0e = r("the token `;`"), J0e = [0, 0], $0e = [0, 0], Z0e = r(dx), Q0e = r(G2), rre = r(Eu), ere = [0, r(HU)], nre = [15, [0, 0]], tre = [0, r(HU)], ure = r("use strict"), ire = [0, 0, 0, 0], fre = r(MI), xre = r("Nooo: "), ore = r(_i), are = r("Parser error: No such thing as an expression pattern!"), cre = r(C), sre = [0, [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]], vre = [0, r("src/parser/parser_flow.ml"), NT, 28], lre = [0, [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]], bre = r(Bn), pre = r(KY), mre = r(I2), _re = r(Y4), yre = r(HH), hre = r(I2), dre = r(Y4), kre = r(g7), wre = r(hE), Ere = r("normal"), Sre = r(Jc), gre = r("jsxTag"), Fre = r("jsxChild"), Tre = r("template"), Ore = r(MH), Ire = r("context"), Are = r(Jc), Nre = r("use_strict"), Cre = r($6), Pre = r("esproposal_export_star_as"), Dre = r("esproposal_decorators"), Lre = r("enums"), Rre = r("Internal error: ");
            function Gt(t) {
              if (typeof t == "number") return 0;
              switch (t[0]) {
                case 0:
                  return [0, Gt(t[1])];
                case 1:
                  return [1, Gt(t[1])];
                case 2:
                  return [2, Gt(t[1])];
                case 3:
                  return [3, Gt(t[1])];
                case 4:
                  return [4, Gt(t[1])];
                case 5:
                  return [5, Gt(t[1])];
                case 6:
                  return [6, Gt(t[1])];
                case 7:
                  return [7, Gt(t[1])];
                case 8:
                  var n = t[1];
                  return [8, n, Gt(t[2])];
                case 9:
                  var e = t[1];
                  return [9, e, e, Gt(t[3])];
                case 10:
                  return [10, Gt(t[1])];
                case 11:
                  return [11, Gt(t[1])];
                case 12:
                  return [12, Gt(t[1])];
                case 13:
                  return [13, Gt(t[1])];
                default:
                  return [14, Gt(t[1])];
              }
            }
            function u7(t, n) {
              if (typeof t == "number") return n;
              switch (t[0]) {
                case 0:
                  return [0, u7(t[1], n)];
                case 1:
                  return [1, u7(t[1], n)];
                case 2:
                  return [2, u7(t[1], n)];
                case 3:
                  return [3, u7(t[1], n)];
                case 4:
                  return [4, u7(t[1], n)];
                case 5:
                  return [5, u7(t[1], n)];
                case 6:
                  return [6, u7(t[1], n)];
                case 7:
                  return [7, u7(t[1], n)];
                case 8:
                  var e = t[1];
                  return [8, e, u7(t[2], n)];
                case 9:
                  var i = t[2], x = t[1];
                  return [9, x, i, u7(t[3], n)];
                case 10:
                  return [10, u7(t[1], n)];
                case 11:
                  return [11, u7(t[1], n)];
                case 12:
                  return [12, u7(t[1], n)];
                case 13:
                  return [13, u7(t[1], n)];
                default:
                  return [14, u7(t[1], n)];
              }
            }
            function At(t, n) {
              if (typeof t == "number") return n;
              switch (t[0]) {
                case 0:
                  return [0, At(t[1], n)];
                case 1:
                  return [1, At(t[1], n)];
                case 2:
                  var e = t[1];
                  return [2, e, At(t[2], n)];
                case 3:
                  var i = t[1];
                  return [3, i, At(t[2], n)];
                case 4:
                  var x = t[3], c = t[2], s = t[1];
                  return [4, s, c, x, At(t[4], n)];
                case 5:
                  var p = t[3], y = t[2], T = t[1];
                  return [5, T, y, p, At(t[4], n)];
                case 6:
                  var E = t[3], d = t[2], w = t[1];
                  return [6, w, d, E, At(t[4], n)];
                case 7:
                  var G = t[3], A = t[2], S = t[1];
                  return [7, S, A, G, At(t[4], n)];
                case 8:
                  var M = t[3], K = t[2], V = t[1];
                  return [8, V, K, M, At(t[4], n)];
                case 9:
                  var f0 = t[1];
                  return [9, f0, At(t[2], n)];
                case 10:
                  return [10, At(t[1], n)];
                case 11:
                  var m0 = t[1];
                  return [11, m0, At(t[2], n)];
                case 12:
                  var k0 = t[1];
                  return [12, k0, At(t[2], n)];
                case 13:
                  var g0 = t[2], e0 = t[1];
                  return [13, e0, g0, At(t[3], n)];
                case 14:
                  var x0 = t[2], l = t[1];
                  return [14, l, x0, At(t[3], n)];
                case 15:
                  return [15, At(t[1], n)];
                case 16:
                  return [16, At(t[1], n)];
                case 17:
                  var c0 = t[1];
                  return [17, c0, At(t[2], n)];
                case 18:
                  var t0 = t[1];
                  return [18, t0, At(t[2], n)];
                case 19:
                  return [19, At(t[1], n)];
                case 20:
                  var o0 = t[2], w0 = t[1];
                  return [20, w0, o0, At(t[3], n)];
                case 21:
                  var _0 = t[1];
                  return [21, _0, At(t[2], n)];
                case 22:
                  return [22, At(t[1], n)];
                case 23:
                  var E0 = t[1];
                  return [23, E0, At(t[2], n)];
                default:
                  var U0 = t[2], b = t[1];
                  return [24, b, U0, At(t[3], n)];
              }
            }
            function nN(t, n, e) {
              return t[1] === n ? (t[1] = e, 1) : 0;
            }
            function ke(t) {
              throw [0, q7, t];
            }
            function Pu(t) {
              throw [0, ZA, t];
            }
            M7(0);
            function gp(t) {
              return 0 <= t ? t : -t | 0;
            }
            var jre = mH;
            function Te(t, n) {
              var e = un(t), i = un(n), x = Lt(e + i | 0);
              return Ts(t, 0, x, 0, e), Ts(n, 0, x, e, i), x;
            }
            function Gre(t) {
              return t ? fi0 : xi0;
            }
            function on(t, n) {
              if (t) {
                var e = t[1];
                return [0, e, on(t[2], n)];
              }
              return n;
            }
            M70(0);
            var Mre = zV(1), Pc = zV(2);
            function Bre(t) {
              function n(e) {
                for (var i = e; ; ) {
                  if (i) {
                    var x = i[2], c = i[1];
                    try {
                      p1(c);
                    } catch (y) {
                      if (y = Et(y), y[1] !== $V) throw y;
                      var s = y;
                    }
                    var i = x;
                    continue;
                  }
                  return 0;
                }
              }
              return n(B70(0));
            }
            function vl(t, n) {
              return zA(t, n, 0, un(n));
            }
            function iz(t) {
              return vl(Pc, t), KV(Pc, 10), p1(Pc);
            }
            var tN = [0, Bre];
            function fz(t) {
              for (; ; ) {
                var n = tN[1], e = [0, 1], i = 1 - nN(tN, n, /* @__PURE__ */ function(x, c) {
                  return function(s) {
                    return nN(x, 1, 0) && u(t, 0), u(c, 0);
                  };
                }(e, n));
                if (!i) return i;
              }
            }
            function uN(t) {
              return u(tN[1], 0);
            }
            WA(r(sV), uN), K70(0) && fz(function(t) {
              return l70(t);
            });
            function xz(t) {
              return 25 < (t + Y3 | 0) >>> 0 ? t : t + hU | 0;
            }
            var oz = J70(0)[1], ll = (4 * z70(0) | 0) - 1 | 0;
            M7(0);
            var qre = V70(0);
            function Dc(t) {
              for (var n = 0, e = t; ; ) {
                if (e) {
                  var n = n + 1 | 0, e = e[2];
                  continue;
                }
                return n;
              }
            }
            function bl(t) {
              return t ? t[1] : ke(mi0);
            }
            function az(t) {
              return t ? t[2] : ke(pi0);
            }
            function Lc(t, n) {
              for (var e = t, i = n; ; ) {
                if (e) {
                  var x = [0, e[1], i], e = e[2], i = x;
                  continue;
                }
                return i;
              }
            }
            function ye(t) {
              return Lc(t, 0);
            }
            function pl(t) {
              if (t) {
                var n = t[1];
                return on(n, pl(t[2]));
              }
              return 0;
            }
            function d1(t, n) {
              if (n) {
                var e = n[2], i = u(t, n[1]);
                return [0, i, d1(t, e)];
              }
              return 0;
            }
            function Fp(t, n) {
              for (var e = 0, i = n; ; ) {
                if (i) {
                  var x = i[2], e = [0, u(t, i[1]), e], i = x;
                  continue;
                }
                return e;
              }
            }
            function Du(t, n) {
              for (var e = n; ; ) {
                if (e) {
                  var i = e[2];
                  u(t, e[1]);
                  var e = i;
                  continue;
                }
                return 0;
              }
            }
            function le(t, n, e) {
              for (var i = n, x = e; ; ) {
                if (x) {
                  var c = x[2], i = o(t, i, x[1]), x = c;
                  continue;
                }
                return i;
              }
            }
            function iN(t, n, e) {
              if (n) {
                var i = n[1];
                return o(t, i, iN(t, n[2], e));
              }
              return e;
            }
            function cz(t, n, e) {
              for (var i = n, x = e; ; ) {
                if (i) {
                  if (x) {
                    var c = x[2], s = i[2];
                    o(t, i[1], x[1]);
                    var i = s, x = c;
                    continue;
                  }
                } else if (!x) return 0;
                return Pu(bi0);
              }
            }
            function fN(t, n) {
              for (var e = n; ; ) {
                if (e) {
                  var i = e[2], x = LV(e[1], t) === 0 ? 1 : 0;
                  if (x) return x;
                  var e = i;
                  continue;
                }
                return 0;
              }
            }
            function Ure(t, n) {
              for (var e = n; ; ) {
                if (e) {
                  var i = e[1], x = e[2], c = i[2];
                  if (LV(i[1], t) === 0) return c;
                  var e = x;
                  continue;
                }
                throw Jt;
              }
            }
            function ml(t) {
              var n = 0;
              return function(e) {
                for (var i = n, x = e; ; ) {
                  if (x) {
                    var c = x[2], s = x[1];
                    if (u(t, s)) {
                      var i = [0, s, i], x = c;
                      continue;
                    }
                    var x = c;
                    continue;
                  }
                  return ye(i);
                }
              };
            }
            function k1(t, n) {
              var e = Lt(t);
              return v70(e, 0, t, n), e;
            }
            function sz(t) {
              var n = b7(t), e = Lt(n);
              return Fs(t, 0, e, 0, n), e;
            }
            function vz(t, n, e) {
              if (0 <= n && 0 <= e && !((b7(t) - e | 0) < n)) {
                var i = Lt(e);
                return Fs(t, n, i, 0, e), i;
              }
              return Pu(hi0);
            }
            function qv(t, n, e) {
              return vz(t, n, e);
            }
            function lz(t, n, e, i, x) {
              return 0 <= x && 0 <= n && !((b7(t) - x | 0) < n) && 0 <= i && !((b7(e) - x | 0) < i) ? Fs(t, n, e, i, x) : Pu(yi0);
            }
            function cs(t, n, e, i, x) {
              return 0 <= x && 0 <= n && !((un(t) - x | 0) < n) && 0 <= i && !((b7(e) - x | 0) < i) ? Ts(t, n, e, i, x) : Pu(_i0);
            }
            function Tp(t, n) {
              return k1(t, n);
            }
            function m7(t, n, e) {
              return vz(t, n, e);
            }
            var bz = Ee;
            function pz(t, n) {
              var e = n.length - 1 - 1 | 0, i = 0;
              if (!(e < 0)) for (var x = i; ; ) {
                u(t, n[1 + x]);
                var c = x + 1 | 0;
                if (e !== x) {
                  var x = c;
                  continue;
                }
                break;
              }
              return 0;
            }
            function Op(t, n) {
              var e = n.length - 1;
              if (e === 0) return [0];
              var i = Gv(e, u(t, n[1])), x = e - 1 | 0, c = 1;
              if (!(x < 1)) for (var s = c; ; ) {
                i[1 + s] = u(t, n[1 + s]);
                var p = s + 1 | 0;
                if (x !== s) {
                  var s = p;
                  continue;
                }
                break;
              }
              return i;
            }
            function _l(t) {
              if (t) for (var n = 0, e = t, i = t[2], x = t[1]; ; ) {
                if (e) {
                  var n = n + 1 | 0, e = e[2];
                  continue;
                }
                for (var c = Gv(n, x), s = 1, p = i; ; ) {
                  if (p) {
                    var y = p[2];
                    c[1 + s] = p[1];
                    var s = s + 1 | 0, p = y;
                    continue;
                  }
                  return c;
                }
              }
              return [0];
            }
            M7(0);
            function xN(t) {
              function n(v0) {
                return v0 ? v0[5] : 0;
              }
              function e(v0, P, L, Q) {
                var i0 = n(v0), l0 = n(Q), S0 = l0 <= i0 ? i0 + 1 | 0 : l0 + 1 | 0;
                return [0, v0, P, L, Q, S0];
              }
              function i(v0, P) {
                return [0, 0, v0, P, 0, 1];
              }
              function x(v0, P, L, Q) {
                var i0 = v0 ? v0[5] : 0, l0 = Q ? Q[5] : 0;
                if ((l0 + 2 | 0) < i0) {
                  if (v0) {
                    var S0 = v0[4], T0 = v0[3], rr = v0[2], L0 = v0[1], B = n(S0);
                    if (B <= n(L0)) return e(L0, rr, T0, e(S0, P, L, Q));
                    if (S0) {
                      var Z = S0[3], p0 = S0[2], b0 = S0[1], O0 = e(S0[4], P, L, Q);
                      return e(e(L0, rr, T0, b0), p0, Z, O0);
                    }
                    return Pu(Fi0);
                  }
                  return Pu(Ti0);
                }
                if ((i0 + 2 | 0) < l0) {
                  if (Q) {
                    var M0 = Q[4], er = Q[3], yr = Q[2], vr = Q[1], $0 = n(vr);
                    if ($0 <= n(M0)) return e(e(v0, P, L, vr), yr, er, M0);
                    if (vr) {
                      var Er = vr[3], Mr = vr[2], Br = vr[1], qr = e(vr[4], yr, er, M0);
                      return e(e(v0, P, L, Br), Mr, Er, qr);
                    }
                    return Pu(Oi0);
                  }
                  return Pu(Ii0);
                }
                var jr = l0 <= i0 ? i0 + 1 | 0 : l0 + 1 | 0;
                return [0, v0, P, L, Q, jr];
              }
              var c = 0;
              function s(v0) {
                return v0 ? 0 : 1;
              }
              function p(v0, P, L) {
                if (L) {
                  var Q = L[4], i0 = L[3], l0 = L[2], S0 = L[1], T0 = L[5], rr = o(t[1], v0, l0);
                  if (rr === 0) return i0 === P ? L : [0, S0, v0, P, Q, T0];
                  if (0 <= rr) {
                    var L0 = p(v0, P, Q);
                    return Q === L0 ? L : x(S0, l0, i0, L0);
                  }
                  var B = p(v0, P, S0);
                  return S0 === B ? L : x(B, l0, i0, Q);
                }
                return [0, 0, v0, P, 0, 1];
              }
              function y(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[4], i0 = L[3], l0 = L[1], S0 = o(t[1], v0, L[2]);
                    if (S0 === 0) return i0;
                    var T0 = 0 <= S0 ? Q : l0, L = T0;
                    continue;
                  }
                  throw Jt;
                }
              }
              function T(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[2], i0 = L[4], l0 = L[3], S0 = L[1];
                    if (u(v0, Q)) for (var T0 = Q, rr = l0, L0 = S0; ; ) {
                      if (L0) {
                        var B = L0[2], Z = L0[4], p0 = L0[3], b0 = L0[1];
                        if (u(v0, B)) {
                          var T0 = B, rr = p0, L0 = b0;
                          continue;
                        }
                        var L0 = Z;
                        continue;
                      }
                      return [0, T0, rr];
                    }
                    var L = i0;
                    continue;
                  }
                  throw Jt;
                }
              }
              function E(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[2], i0 = L[4], l0 = L[3], S0 = L[1];
                    if (u(v0, Q)) for (var T0 = Q, rr = l0, L0 = S0; ; ) {
                      if (L0) {
                        var B = L0[2], Z = L0[4], p0 = L0[3], b0 = L0[1];
                        if (u(v0, B)) {
                          var T0 = B, rr = p0, L0 = b0;
                          continue;
                        }
                        var L0 = Z;
                        continue;
                      }
                      return [0, [0, T0, rr]];
                    }
                    var L = i0;
                    continue;
                  }
                  return 0;
                }
              }
              function d(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[2], i0 = L[4], l0 = L[3], S0 = L[1];
                    if (u(v0, Q)) for (var T0 = Q, rr = l0, L0 = i0; ; ) {
                      if (L0) {
                        var B = L0[2], Z = L0[4], p0 = L0[3], b0 = L0[1];
                        if (u(v0, B)) {
                          var T0 = B, rr = p0, L0 = Z;
                          continue;
                        }
                        var L0 = b0;
                        continue;
                      }
                      return [0, T0, rr];
                    }
                    var L = S0;
                    continue;
                  }
                  throw Jt;
                }
              }
              function w(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[2], i0 = L[4], l0 = L[3], S0 = L[1];
                    if (u(v0, Q)) for (var T0 = Q, rr = l0, L0 = i0; ; ) {
                      if (L0) {
                        var B = L0[2], Z = L0[4], p0 = L0[3], b0 = L0[1];
                        if (u(v0, B)) {
                          var T0 = B, rr = p0, L0 = Z;
                          continue;
                        }
                        var L0 = b0;
                        continue;
                      }
                      return [0, [0, T0, rr]];
                    }
                    var L = S0;
                    continue;
                  }
                  return 0;
                }
              }
              function G(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[4], i0 = L[3], l0 = L[1], S0 = o(t[1], v0, L[2]);
                    if (S0 === 0) return [0, i0];
                    var T0 = 0 <= S0 ? Q : l0, L = T0;
                    continue;
                  }
                  return 0;
                }
              }
              function A(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[4], i0 = L[1], l0 = o(t[1], v0, L[2]), S0 = l0 === 0 ? 1 : 0;
                    if (S0) return S0;
                    var T0 = 0 <= l0 ? Q : i0, L = T0;
                    continue;
                  }
                  return 0;
                }
              }
              function S(v0) {
                for (var P = v0; ; ) {
                  if (P) {
                    var L = P[1];
                    if (L) {
                      var P = L;
                      continue;
                    }
                    return [0, P[2], P[3]];
                  }
                  throw Jt;
                }
              }
              function M(v0) {
                for (var P = v0; ; ) {
                  if (P) {
                    var L = P[1];
                    if (L) {
                      var P = L;
                      continue;
                    }
                    return [0, [0, P[2], P[3]]];
                  }
                  return 0;
                }
              }
              function K(v0) {
                for (var P = v0; ; ) {
                  if (P) {
                    if (P[4]) {
                      var P = P[4];
                      continue;
                    }
                    return [0, P[2], P[3]];
                  }
                  throw Jt;
                }
              }
              function V(v0) {
                for (var P = v0; ; ) {
                  if (P) {
                    if (P[4]) {
                      var P = P[4];
                      continue;
                    }
                    return [0, [0, P[2], P[3]]];
                  }
                  return 0;
                }
              }
              function f0(v0) {
                if (v0) {
                  var P = v0[1];
                  if (P) {
                    var L = v0[4], Q = v0[3], i0 = v0[2];
                    return x(f0(P), i0, Q, L);
                  }
                  return v0[4];
                }
                return Pu(wi0);
              }
              function m0(v0, P) {
                if (v0) {
                  if (P) {
                    var L = S(P), Q = L[2], i0 = L[1];
                    return x(v0, i0, Q, f0(P));
                  }
                  return v0;
                }
                return P;
              }
              function k0(v0, P) {
                if (P) {
                  var L = P[4], Q = P[3], i0 = P[2], l0 = P[1], S0 = o(t[1], v0, i0);
                  if (S0 === 0) return m0(l0, L);
                  if (0 <= S0) {
                    var T0 = k0(v0, L);
                    return L === T0 ? P : x(l0, i0, Q, T0);
                  }
                  var rr = k0(v0, l0);
                  return l0 === rr ? P : x(rr, i0, Q, L);
                }
                return 0;
              }
              function g0(v0, P, L) {
                if (L) {
                  var Q = L[4], i0 = L[3], l0 = L[2], S0 = L[1], T0 = L[5], rr = o(t[1], v0, l0);
                  if (rr === 0) {
                    var L0 = u(P, [0, i0]);
                    if (L0) {
                      var B = L0[1];
                      return i0 === B ? L : [0, S0, v0, B, Q, T0];
                    }
                    return m0(S0, Q);
                  }
                  if (0 <= rr) {
                    var Z = g0(v0, P, Q);
                    return Q === Z ? L : x(S0, l0, i0, Z);
                  }
                  var p0 = g0(v0, P, S0);
                  return S0 === p0 ? L : x(p0, l0, i0, Q);
                }
                var b0 = u(P, 0);
                return b0 ? [0, 0, v0, b0[1], 0, 1] : 0;
              }
              function e0(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[4], i0 = L[3], l0 = L[2];
                    e0(v0, L[1]), o(v0, l0, i0);
                    var L = Q;
                    continue;
                  }
                  return 0;
                }
              }
              function x0(v0, P) {
                if (P) {
                  var L = P[5], Q = P[4], i0 = P[3], l0 = P[2], S0 = x0(v0, P[1]), T0 = u(v0, i0);
                  return [0, S0, l0, T0, x0(v0, Q), L];
                }
                return 0;
              }
              function l(v0, P) {
                if (P) {
                  var L = P[2], Q = P[5], i0 = P[4], l0 = P[3], S0 = l(v0, P[1]), T0 = o(v0, L, l0);
                  return [0, S0, L, T0, l(v0, i0), Q];
                }
                return 0;
              }
              function c0(v0, P, L) {
                for (var Q = P, i0 = L; ; ) {
                  if (Q) {
                    var l0 = Q[4], S0 = Q[3], T0 = Q[2], rr = ur(v0, T0, S0, c0(v0, Q[1], i0)), Q = l0, i0 = rr;
                    continue;
                  }
                  return i0;
                }
              }
              function t0(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[4], i0 = L[1], l0 = o(v0, L[2], L[3]);
                    if (l0) {
                      var S0 = t0(v0, i0);
                      if (S0) {
                        var L = Q;
                        continue;
                      }
                      var T0 = S0;
                    } else var T0 = l0;
                    return T0;
                  }
                  return 1;
                }
              }
              function o0(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[4], i0 = L[1], l0 = o(v0, L[2], L[3]);
                    if (l0) var S0 = l0;
                    else {
                      var T0 = o0(v0, i0);
                      if (!T0) {
                        var L = Q;
                        continue;
                      }
                      var S0 = T0;
                    }
                    return S0;
                  }
                  return 0;
                }
              }
              function w0(v0, P, L) {
                if (L) {
                  var Q = L[4], i0 = L[3], l0 = L[2];
                  return x(w0(v0, P, L[1]), l0, i0, Q);
                }
                return i(v0, P);
              }
              function _0(v0, P, L) {
                if (L) {
                  var Q = L[3], i0 = L[2], l0 = L[1];
                  return x(l0, i0, Q, _0(v0, P, L[4]));
                }
                return i(v0, P);
              }
              function E0(v0, P, L, Q) {
                if (v0) {
                  if (Q) {
                    var i0 = Q[5], l0 = v0[5], S0 = Q[4], T0 = Q[3], rr = Q[2], L0 = Q[1], B = v0[4], Z = v0[3], p0 = v0[2], b0 = v0[1];
                    return (i0 + 2 | 0) < l0 ? x(b0, p0, Z, E0(B, P, L, Q)) : (l0 + 2 | 0) < i0 ? x(E0(v0, P, L, L0), rr, T0, S0) : e(v0, P, L, Q);
                  }
                  return _0(P, L, v0);
                }
                return w0(P, L, Q);
              }
              function U0(v0, P) {
                if (v0) {
                  if (P) {
                    var L = S(P), Q = L[2], i0 = L[1];
                    return E0(v0, i0, Q, f0(P));
                  }
                  return v0;
                }
                return P;
              }
              function b(v0, P, L, Q) {
                return L ? E0(v0, P, L[1], Q) : U0(v0, Q);
              }
              function R0(v0, P) {
                if (P) {
                  var L = P[4], Q = P[3], i0 = P[2], l0 = P[1], S0 = o(t[1], v0, i0);
                  if (S0 === 0) return [0, l0, [0, Q], L];
                  if (0 <= S0) {
                    var T0 = R0(v0, L), rr = T0[3], L0 = T0[2];
                    return [0, E0(l0, i0, Q, T0[1]), L0, rr];
                  }
                  var B = R0(v0, l0), Z = B[2], p0 = B[1];
                  return [0, p0, Z, E0(B[3], i0, Q, L)];
                }
                return Ei0;
              }
              function X(v0, P, L) {
                if (P) {
                  var Q = P[2], i0 = P[5], l0 = P[4], S0 = P[3], T0 = P[1];
                  if (n(L) <= i0) {
                    var rr = R0(Q, L), L0 = rr[2], B = rr[1], Z = X(v0, l0, rr[3]), p0 = ur(v0, Q, [0, S0], L0);
                    return b(X(v0, T0, B), Q, p0, Z);
                  }
                } else if (!L) return 0;
                if (L) {
                  var b0 = L[2], O0 = L[4], M0 = L[3], er = L[1], yr = R0(b0, P), vr = yr[2], $0 = yr[1], Er = X(v0, yr[3], O0), Mr = ur(v0, b0, vr, [0, M0]);
                  return b(X(v0, $0, er), b0, Mr, Er);
                }
                throw [0, Sn, Si0];
              }
              function s0(v0, P, L) {
                if (P) {
                  if (L) {
                    var Q = L[3], i0 = L[2], l0 = P[3], S0 = P[2], T0 = L[4], rr = L[1], L0 = P[4], B = P[1];
                    if (L[5] <= P[5]) {
                      var Z = R0(S0, L), p0 = Z[2], b0 = Z[3], O0 = s0(v0, B, Z[1]), M0 = s0(v0, L0, b0);
                      return p0 ? b(O0, S0, ur(v0, S0, l0, p0[1]), M0) : E0(O0, S0, l0, M0);
                    }
                    var er = R0(i0, P), yr = er[2], vr = er[3], $0 = s0(v0, er[1], rr), Er = s0(v0, vr, T0);
                    return yr ? b($0, i0, ur(v0, i0, yr[1], Q), Er) : E0($0, i0, Q, Er);
                  }
                  var Mr = P;
                } else var Mr = L;
                return Mr;
              }
              function hr(v0, P) {
                if (P) {
                  var L = P[4], Q = P[3], i0 = P[2], l0 = P[1], S0 = hr(v0, l0), T0 = o(v0, i0, Q), rr = hr(v0, L);
                  return T0 ? l0 === S0 && L === rr ? P : E0(S0, i0, Q, rr) : U0(S0, rr);
                }
                return 0;
              }
              function Ar(v0, P) {
                if (P) {
                  var L = P[2], Q = P[4], i0 = P[3], l0 = Ar(v0, P[1]), S0 = o(v0, L, i0), T0 = Ar(v0, Q);
                  return S0 ? E0(l0, L, S0[1], T0) : U0(l0, T0);
                }
                return 0;
              }
              function or(v0, P) {
                if (P) {
                  var L = P[3], Q = P[2], i0 = P[4], l0 = or(v0, P[1]), S0 = l0[2], T0 = l0[1], rr = o(v0, Q, L), L0 = or(v0, i0), B = L0[2], Z = L0[1];
                  if (rr) {
                    var p0 = U0(S0, B);
                    return [0, E0(T0, Q, L, Z), p0];
                  }
                  var b0 = E0(S0, Q, L, B);
                  return [0, U0(T0, Z), b0];
                }
                return gi0;
              }
              function W0(v0, P) {
                for (var L = v0, Q = P; ; ) {
                  if (L) {
                    var i0 = [0, L[2], L[3], L[4], Q], L = L[1], Q = i0;
                    continue;
                  }
                  return Q;
                }
              }
              function Lr(v0, P, L) {
                for (var Q = W0(L, 0), i0 = W0(P, 0), l0 = Q; ; ) {
                  if (i0) {
                    if (l0) {
                      var S0 = l0[4], T0 = l0[3], rr = l0[2], L0 = i0[4], B = i0[3], Z = i0[2], p0 = o(t[1], i0[1], l0[1]);
                      if (p0 === 0) {
                        var b0 = o(v0, Z, rr);
                        if (b0 === 0) {
                          var O0 = W0(T0, S0), i0 = W0(B, L0), l0 = O0;
                          continue;
                        }
                        return b0;
                      }
                      return p0;
                    }
                    return 1;
                  }
                  return l0 ? -1 : 0;
                }
              }
              function Tr(v0, P, L) {
                for (var Q = W0(L, 0), i0 = W0(P, 0), l0 = Q; ; ) {
                  if (i0) {
                    if (l0) {
                      var S0 = l0[4], T0 = l0[3], rr = l0[2], L0 = i0[4], B = i0[3], Z = i0[2], p0 = o(t[1], i0[1], l0[1]) === 0 ? 1 : 0;
                      if (p0) {
                        var b0 = o(v0, Z, rr);
                        if (b0) {
                          var O0 = W0(T0, S0), i0 = W0(B, L0), l0 = O0;
                          continue;
                        }
                        var M0 = b0;
                      } else var M0 = p0;
                      return M0;
                    }
                    return 0;
                  }
                  return l0 ? 0 : 1;
                }
              }
              function Hr(v0) {
                if (v0) {
                  var P = v0[1], L = Hr(v0[4]);
                  return (Hr(P) + 1 | 0) + L | 0;
                }
                return 0;
              }
              function Or(v0, P) {
                for (var L = v0, Q = P; ; ) {
                  if (Q) {
                    var i0 = Q[3], l0 = Q[2], S0 = Q[1], L = [0, [0, l0, i0], Or(L, Q[4])], Q = S0;
                    continue;
                  }
                  return L;
                }
              }
              function fr(v0) {
                return Or(0, v0);
              }
              function Rr(v0, P) {
                for (var L = P, Q = v0; ; ) {
                  var i0 = u(Q, 0);
                  if (i0) {
                    var l0 = i0[1], S0 = i0[2], L = p(l0[1], l0[2], L), Q = S0;
                    continue;
                  }
                  return L;
                }
              }
              function Wr(v0) {
                return Rr(v0, c);
              }
              function Jr(v0, P) {
                if (v0) {
                  var L = v0[2], Q = v0[1], i0 = W0(v0[3], v0[4]);
                  return [0, [0, Q, L], function(l0) {
                    return Jr(i0, l0);
                  }];
                }
                return 0;
              }
              function ar(v0) {
                var P = W0(v0, 0);
                return function(L) {
                  return Jr(P, L);
                };
              }
              function _r(v0, P) {
                for (var L = v0, Q = P; ; ) {
                  if (L) {
                    var i0 = [0, L[2], L[3], L[1], Q], L = L[4], Q = i0;
                    continue;
                  }
                  return Q;
                }
              }
              function Ir(v0, P) {
                if (v0) {
                  var L = v0[2], Q = v0[1], i0 = _r(v0[3], v0[4]);
                  return [0, [0, Q, L], function(l0) {
                    return Ir(i0, l0);
                  }];
                }
                return 0;
              }
              function fe(v0) {
                var P = _r(v0, 0);
                return function(L) {
                  return Ir(P, L);
                };
              }
              return [0, c, s, A, p, g0, i, k0, X, s0, Lr, Tr, e0, c0, t0, o0, hr, Ar, or, Hr, fr, S, M, K, V, S, M, R0, y, G, T, E, d, w, x0, l, ar, fe, function(v0, P) {
                for (var L = P, Q = 0; ; ) {
                  if (L) {
                    var i0 = L[4], l0 = L[3], S0 = L[2], T0 = L[1], rr = o(t[1], S0, v0);
                    if (rr !== 0) {
                      if (0 <= rr) {
                        var L = T0, Q = [0, S0, l0, i0, Q];
                        continue;
                      }
                      var L = i0;
                      continue;
                    }
                    var L0 = [0, S0, l0, i0, Q];
                  } else var L0 = Q;
                  return function(B) {
                    return Jr(L0, B);
                  };
                }
              }, Rr, Wr];
            }
            M7(0);
            function yl(t) {
              return [0, 0, 0];
            }
            function hl(t) {
              return t[1] = 0, t[2] = 0, 0;
            }
            function w1(t, n) {
              return n[1] = [0, t, n[1]], n[2] = n[2] + 1 | 0, 0;
            }
            function Uv(t) {
              var n = t[1];
              if (n) {
                var e = n[1];
                return t[1] = n[2], t[2] = t[2] - 1 | 0, [0, e];
              }
              return 0;
            }
            function Hv(t) {
              var n = t[1];
              return n ? [0, n[1]] : 0;
            }
            var Hre = [wt, Ai0, M7(0)];
            function mz(t) {
              return [0, 0, 0, 0];
            }
            function oN(t) {
              return t[1] = 0, t[2] = 0, t[3] = 0, 0;
            }
            function aN(t, n) {
              var e = [0, t, 0], i = n[3];
              return i ? (n[1] = n[1] + 1 | 0, i[2] = e, n[3] = e, 0) : (n[1] = 1, n[2] = e, n[3] = e, 0);
            }
            var Xre = [wt, Ni0, M7(0)];
            function Yre(t) {
              throw Xre;
            }
            function Vre(t) {
              var n = t[1];
              t[1] = Yre;
              try {
                var e = u(n, 0);
                return U70(t, e), e;
              } catch (i) {
                throw i = Et(i), t[1] = function(x) {
                  throw i;
                }, i;
              }
            }
            function $n(t) {
              var n = 1 <= t ? t : 1, e = ll < n ? ll : n, i = Lt(e);
              return [0, i, 0, e, i];
            }
            function Mt(t) {
              return qv(t[1], 0, t[2]);
            }
            function cN(t, n) {
              for (var e = t[2], i = [0, t[3]]; ; ) {
                if (i[1] < (e + n | 0)) {
                  i[1] = 2 * i[1] | 0;
                  continue;
                }
                ll < i[1] && ((e + n | 0) <= ll ? i[1] = ll : ke(Pi0));
                var x = Lt(i[1]);
                if (lz(t[1], 0, x, 0, t[2]), t[1] = x, t[3] = i[1], (t[2] + n | 0) <= t[3]) {
                  if ((e + n | 0) <= t[3]) return 0;
                  throw [0, Sn, Li0];
                }
                throw [0, Sn, Di0];
              }
            }
            function qi(t, n) {
              var e = t[2];
              return t[3] <= e && cN(t, 1), Jn(t[1], e, n), t[2] = e + 1 | 0, 0;
            }
            function _z(t, n, e, i) {
              var x = e < 0 ? 1 : 0;
              if (x) var s = x;
              else var c = i < 0 ? 1 : 0, s = c || ((un(n) - i | 0) < e ? 1 : 0);
              s && Pu(Ci0);
              var p = t[2] + i | 0;
              return t[3] < p && cN(t, i), Ts(n, e, t[1], t[2], i), t[2] = p, 0;
            }
            function sN(t, n, e, i) {
              return _z(t, n, e, i);
            }
            function hn(t, n) {
              var e = un(n), i = t[2] + e | 0;
              return t[3] < i && cN(t, e), Ts(n, 0, t[1], t[2], e), t[2] = i, 0;
            }
            function vN(t) {
              return t[2] === 5 ? 12 : -6;
            }
            function yz(t) {
              return [0, 0, Lt(t)];
            }
            function hz(t, n) {
              var e = b7(t[2]), i = t[1] + n | 0, x = e < i ? 1 : 0;
              if (x) {
                var c = e * 2 | 0, s = i <= c ? c : i, p = Lt(s);
                lz(t[2], 0, p, 0, e), t[2] = p;
                var y = 0;
              } else var y = x;
              return y;
            }
            function Xv(t, n) {
              return hz(t, 1), b1(t[2], t[1], n), t[1] = t[1] + 1 | 0, 0;
            }
            function Lu(t, n) {
              var e = un(n);
              return hz(t, e), cs(n, 0, t[2], t[1], e), t[1] = t[1] + e | 0, 0;
            }
            function dz(t) {
              return qv(t[2], 0, t[1]);
            }
            function kz(t) {
              if (typeof t == "number") switch (t) {
                case 0:
                  return Gx0;
                case 1:
                  return Mx0;
                case 2:
                  return Bx0;
                case 3:
                  return qx0;
                case 4:
                  return Ux0;
                case 5:
                  return Hx0;
                default:
                  return Xx0;
              }
              else switch (t[0]) {
                case 0:
                  return t[1];
                case 1:
                  return t[1];
                default:
                  return Te(Yx0, Tp(1, t[1]));
              }
            }
            function lN(t, n) {
              for (var e = n; ; ) {
                if (typeof e == "number") return 0;
                switch (e[0]) {
                  case 0:
                    var i = e[1];
                    Lu(t, ji0);
                    var e = i;
                    continue;
                  case 1:
                    var x = e[1];
                    Lu(t, Gi0);
                    var e = x;
                    continue;
                  case 2:
                    var c = e[1];
                    Lu(t, Mi0);
                    var e = c;
                    continue;
                  case 3:
                    var s = e[1];
                    Lu(t, Bi0);
                    var e = s;
                    continue;
                  case 4:
                    var p = e[1];
                    Lu(t, qi0);
                    var e = p;
                    continue;
                  case 5:
                    var y = e[1];
                    Lu(t, Ui0);
                    var e = y;
                    continue;
                  case 6:
                    var T = e[1];
                    Lu(t, Hi0);
                    var e = T;
                    continue;
                  case 7:
                    var E = e[1];
                    Lu(t, Xi0);
                    var e = E;
                    continue;
                  case 8:
                    var d = e[2], w = e[1];
                    Lu(t, Yi0), lN(t, w), Lu(t, Vi0);
                    var e = d;
                    continue;
                  case 9:
                    var G = e[3], A = e[1];
                    Lu(t, zi0), lN(t, A), Lu(t, Ki0);
                    var e = G;
                    continue;
                  case 10:
                    var S = e[1];
                    Lu(t, Wi0);
                    var e = S;
                    continue;
                  case 11:
                    var M = e[1];
                    Lu(t, Ji0);
                    var e = M;
                    continue;
                  case 12:
                    var K = e[1];
                    Lu(t, $i0);
                    var e = K;
                    continue;
                  case 13:
                    var V = e[1];
                    Lu(t, Zi0);
                    var e = V;
                    continue;
                  default:
                    var f0 = e[1];
                    Lu(t, Qi0);
                    var e = f0;
                    continue;
                }
              }
            }
            function uu(t) {
              if (typeof t == "number") return 0;
              switch (t[0]) {
                case 0:
                  return [0, uu(t[1])];
                case 1:
                  return [1, uu(t[1])];
                case 2:
                  return [2, uu(t[1])];
                case 3:
                  return [3, uu(t[1])];
                case 4:
                  return [4, uu(t[1])];
                case 5:
                  return [5, uu(t[1])];
                case 6:
                  return [6, uu(t[1])];
                case 7:
                  return [7, uu(t[1])];
                case 8:
                  var n = t[1];
                  return [8, n, uu(t[2])];
                case 9:
                  var e = t[2], i = t[1];
                  return [9, e, i, uu(t[3])];
                case 10:
                  return [10, uu(t[1])];
                case 11:
                  return [11, uu(t[1])];
                case 12:
                  return [12, uu(t[1])];
                case 13:
                  return [13, uu(t[1])];
                default:
                  return [14, uu(t[1])];
              }
            }
            function Ru(t) {
              if (typeof t == "number") {
                var n = function(sr) {
                  return 0;
                }, e = function(sr) {
                  return 0;
                }, i = function(sr) {
                  return 0;
                };
                return [0, function(sr) {
                  return 0;
                }, i, e, n];
              } else switch (t[0]) {
                case 0:
                  var x = Ru(t[1]), c = x[4], s = x[3], p = x[2], y = x[1], T = function(sr) {
                    return u(p, 0), 0;
                  };
                  return [0, function(sr) {
                    return u(y, 0), 0;
                  }, T, s, c];
                case 1:
                  var E = Ru(t[1]), d = E[4], w = E[3], G = E[2], A = E[1], S = function(sr) {
                    return u(G, 0), 0;
                  };
                  return [0, function(sr) {
                    return u(A, 0), 0;
                  }, S, w, d];
                case 2:
                  var M = Ru(t[1]), K = M[4], V = M[3], f0 = M[2], m0 = M[1], k0 = function(sr) {
                    return u(f0, 0), 0;
                  };
                  return [0, function(sr) {
                    return u(m0, 0), 0;
                  }, k0, V, K];
                case 3:
                  var g0 = Ru(t[1]), e0 = g0[4], x0 = g0[3], l = g0[2], c0 = g0[1], t0 = function(sr) {
                    return u(l, 0), 0;
                  };
                  return [0, function(sr) {
                    return u(c0, 0), 0;
                  }, t0, x0, e0];
                case 4:
                  var o0 = Ru(t[1]), w0 = o0[4], _0 = o0[3], E0 = o0[2], U0 = o0[1], b = function(sr) {
                    return u(E0, 0), 0;
                  };
                  return [0, function(sr) {
                    return u(U0, 0), 0;
                  }, b, _0, w0];
                case 5:
                  var R0 = Ru(t[1]), X = R0[4], s0 = R0[3], hr = R0[2], Ar = R0[1], or = function(sr) {
                    return u(hr, 0), 0;
                  };
                  return [0, function(sr) {
                    return u(Ar, 0), 0;
                  }, or, s0, X];
                case 6:
                  var W0 = Ru(t[1]), Lr = W0[4], Tr = W0[3], Hr = W0[2], Or = W0[1], fr = function(sr) {
                    return u(Hr, 0), 0;
                  };
                  return [0, function(sr) {
                    return u(Or, 0), 0;
                  }, fr, Tr, Lr];
                case 7:
                  var Rr = Ru(t[1]), Wr = Rr[4], Jr = Rr[3], ar = Rr[2], _r = Rr[1], Ir = function(sr) {
                    return u(ar, 0), 0;
                  };
                  return [0, function(sr) {
                    return u(_r, 0), 0;
                  }, Ir, Jr, Wr];
                case 8:
                  var fe = Ru(t[2]), v0 = fe[4], P = fe[3], L = fe[2], Q = fe[1], i0 = function(sr) {
                    return u(L, 0), 0;
                  };
                  return [0, function(sr) {
                    return u(Q, 0), 0;
                  }, i0, P, v0];
                case 9:
                  var l0 = t[2], S0 = t[1], T0 = Ru(t[3]), rr = T0[4], L0 = T0[3], B = T0[2], Z = T0[1], p0 = Ru(bu(uu(S0), l0)), b0 = p0[4], O0 = p0[3], M0 = p0[2], er = p0[1], yr = function(sr) {
                    return u(b0, 0), u(rr, 0), 0;
                  }, vr = function(sr) {
                    return u(L0, 0), u(O0, 0), 0;
                  }, $0 = function(sr) {
                    return u(M0, 0), u(B, 0), 0;
                  };
                  return [0, function(sr) {
                    return u(Z, 0), u(er, 0), 0;
                  }, $0, vr, yr];
                case 10:
                  var Er = Ru(t[1]), Mr = Er[4], Br = Er[3], qr = Er[2], jr = Er[1], $r = function(sr) {
                    return u(qr, 0), 0;
                  };
                  return [0, function(sr) {
                    return u(jr, 0), 0;
                  }, $r, Br, Mr];
                case 11:
                  var ne = Ru(t[1]), Qr = ne[4], be = ne[3], ae = ne[2], pe = ne[1], oe = function(sr) {
                    return u(ae, 0), 0;
                  };
                  return [0, function(sr) {
                    return u(pe, 0), 0;
                  }, oe, be, Qr];
                case 12:
                  var ce = Ru(t[1]), ge = ce[4], q0 = ce[3], Fr = ce[2], _ = ce[1], k = function(sr) {
                    return u(Fr, 0), 0;
                  };
                  return [0, function(sr) {
                    return u(_, 0), 0;
                  }, k, q0, ge];
                case 13:
                  var I = Ru(t[1]), U = I[4], Y = I[3], y0 = I[2], P0 = I[1], I0 = function(sr) {
                    return u(U, 0), 0;
                  }, D = function(sr) {
                    return u(Y, 0), 0;
                  }, u0 = function(sr) {
                    return u(y0, 0), 0;
                  };
                  return [0, function(sr) {
                    return u(P0, 0), 0;
                  }, u0, D, I0];
                default:
                  var X0 = Ru(t[1]), J0 = X0[4], ir = X0[3], Q0 = X0[2], F0 = X0[1], Sr = function(sr) {
                    return u(J0, 0), 0;
                  }, mr = function(sr) {
                    return u(ir, 0), 0;
                  }, Cr = function(sr) {
                    return u(Q0, 0), 0;
                  };
                  return [0, function(sr) {
                    return u(F0, 0), 0;
                  }, Cr, mr, Sr];
              }
            }
            function bu(t, n) {
              var e = 0;
              if (typeof t == "number") {
                if (typeof n == "number") return 0;
                switch (n[0]) {
                  case 10:
                    break;
                  case 11:
                    e = 1;
                    break;
                  case 12:
                    e = 2;
                    break;
                  case 13:
                    e = 3;
                    break;
                  case 14:
                    e = 4;
                    break;
                  case 8:
                    e = 5;
                    break;
                  case 9:
                    e = 6;
                    break;
                  default:
                    throw [0, Sn, rf0];
                }
              } else switch (t[0]) {
                case 0:
                  var i = 0, x = t[1];
                  if (typeof n != "number") switch (n[0]) {
                    case 0:
                      return [0, bu(x, n[1])];
                    case 8:
                      e = 5, i = 1;
                      break;
                    case 9:
                      e = 6, i = 1;
                      break;
                    case 10:
                      i = 1;
                      break;
                    case 11:
                      e = 1, i = 1;
                      break;
                    case 12:
                      e = 2, i = 1;
                      break;
                    case 13:
                      e = 3, i = 1;
                      break;
                    case 14:
                      e = 4, i = 1;
                      break;
                  }
                  i || (e = 7);
                  break;
                case 1:
                  var c = 0, s = t[1];
                  if (typeof n != "number") switch (n[0]) {
                    case 1:
                      return [1, bu(s, n[1])];
                    case 8:
                      e = 5, c = 1;
                      break;
                    case 9:
                      e = 6, c = 1;
                      break;
                    case 10:
                      c = 1;
                      break;
                    case 11:
                      e = 1, c = 1;
                      break;
                    case 12:
                      e = 2, c = 1;
                      break;
                    case 13:
                      e = 3, c = 1;
                      break;
                    case 14:
                      e = 4, c = 1;
                      break;
                  }
                  c || (e = 7);
                  break;
                case 2:
                  var p = 0, y = t[1];
                  if (typeof n == "number") p = 1;
                  else switch (n[0]) {
                    case 2:
                      return [2, bu(y, n[1])];
                    case 8:
                      e = 5;
                      break;
                    case 9:
                      e = 6;
                      break;
                    case 10:
                      break;
                    case 11:
                      e = 1;
                      break;
                    case 12:
                      e = 2;
                      break;
                    case 13:
                      e = 3;
                      break;
                    case 14:
                      e = 4;
                      break;
                    default:
                      p = 1;
                  }
                  p && (e = 7);
                  break;
                case 3:
                  var T = 0, E = t[1];
                  if (typeof n == "number") T = 1;
                  else switch (n[0]) {
                    case 3:
                      return [3, bu(E, n[1])];
                    case 8:
                      e = 5;
                      break;
                    case 9:
                      e = 6;
                      break;
                    case 10:
                      break;
                    case 11:
                      e = 1;
                      break;
                    case 12:
                      e = 2;
                      break;
                    case 13:
                      e = 3;
                      break;
                    case 14:
                      e = 4;
                      break;
                    default:
                      T = 1;
                  }
                  T && (e = 7);
                  break;
                case 4:
                  var d = 0, w = t[1];
                  if (typeof n == "number") d = 1;
                  else switch (n[0]) {
                    case 4:
                      return [4, bu(w, n[1])];
                    case 8:
                      e = 5;
                      break;
                    case 9:
                      e = 6;
                      break;
                    case 10:
                      break;
                    case 11:
                      e = 1;
                      break;
                    case 12:
                      e = 2;
                      break;
                    case 13:
                      e = 3;
                      break;
                    case 14:
                      e = 4;
                      break;
                    default:
                      d = 1;
                  }
                  d && (e = 7);
                  break;
                case 5:
                  var G = 0, A = t[1];
                  if (typeof n == "number") G = 1;
                  else switch (n[0]) {
                    case 5:
                      return [5, bu(A, n[1])];
                    case 8:
                      e = 5;
                      break;
                    case 9:
                      e = 6;
                      break;
                    case 10:
                      break;
                    case 11:
                      e = 1;
                      break;
                    case 12:
                      e = 2;
                      break;
                    case 13:
                      e = 3;
                      break;
                    case 14:
                      e = 4;
                      break;
                    default:
                      G = 1;
                  }
                  G && (e = 7);
                  break;
                case 6:
                  var S = 0, M = t[1];
                  if (typeof n == "number") S = 1;
                  else switch (n[0]) {
                    case 6:
                      return [6, bu(M, n[1])];
                    case 8:
                      e = 5;
                      break;
                    case 9:
                      e = 6;
                      break;
                    case 10:
                      break;
                    case 11:
                      e = 1;
                      break;
                    case 12:
                      e = 2;
                      break;
                    case 13:
                      e = 3;
                      break;
                    case 14:
                      e = 4;
                      break;
                    default:
                      S = 1;
                  }
                  S && (e = 7);
                  break;
                case 7:
                  var K = 0, V = t[1];
                  if (typeof n == "number") K = 1;
                  else switch (n[0]) {
                    case 7:
                      return [7, bu(V, n[1])];
                    case 8:
                      e = 5;
                      break;
                    case 9:
                      e = 6;
                      break;
                    case 10:
                      break;
                    case 11:
                      e = 1;
                      break;
                    case 12:
                      e = 2;
                      break;
                    case 13:
                      e = 3;
                      break;
                    case 14:
                      e = 4;
                      break;
                    default:
                      K = 1;
                  }
                  K && (e = 7);
                  break;
                case 8:
                  var f0 = 0, m0 = t[2], k0 = t[1];
                  if (typeof n == "number") f0 = 1;
                  else switch (n[0]) {
                    case 8:
                      var g0 = n[1], e0 = bu(m0, n[2]);
                      return [8, bu(k0, g0), e0];
                    case 10:
                      break;
                    case 11:
                      e = 1;
                      break;
                    case 12:
                      e = 2;
                      break;
                    case 13:
                      e = 3;
                      break;
                    case 14:
                      e = 4;
                      break;
                    default:
                      f0 = 1;
                  }
                  if (f0) throw [0, Sn, sf0];
                  break;
                case 9:
                  var x0 = 0, l = t[3], c0 = t[2], t0 = t[1];
                  if (typeof n == "number") x0 = 1;
                  else switch (n[0]) {
                    case 8:
                      e = 5;
                      break;
                    case 9:
                      var o0 = n[3], w0 = n[2], _0 = n[1], E0 = Ru(bu(uu(c0), _0)), U0 = E0[4];
                      return u(E0[2], 0), u(U0, 0), [9, t0, w0, bu(l, o0)];
                    case 10:
                      break;
                    case 11:
                      e = 1;
                      break;
                    case 12:
                      e = 2;
                      break;
                    case 13:
                      e = 3;
                      break;
                    case 14:
                      e = 4;
                      break;
                    default:
                      x0 = 1;
                  }
                  if (x0) throw [0, Sn, lf0];
                  break;
                case 10:
                  var b = t[1];
                  if (typeof n != "number" && n[0] === 10) return [10, bu(b, n[1])];
                  throw [0, Sn, ef0];
                case 11:
                  var R0 = 0, X = t[1];
                  if (typeof n == "number") R0 = 1;
                  else switch (n[0]) {
                    case 10:
                      break;
                    case 11:
                      return [11, bu(X, n[1])];
                    default:
                      R0 = 1;
                  }
                  if (R0) throw [0, Sn, tf0];
                  break;
                case 12:
                  var s0 = 0, hr = t[1];
                  if (typeof n == "number") s0 = 1;
                  else switch (n[0]) {
                    case 10:
                      break;
                    case 11:
                      e = 1;
                      break;
                    case 12:
                      return [12, bu(hr, n[1])];
                    default:
                      s0 = 1;
                  }
                  if (s0) throw [0, Sn, if0];
                  break;
                case 13:
                  var Ar = 0, or = t[1];
                  if (typeof n == "number") Ar = 1;
                  else switch (n[0]) {
                    case 10:
                      break;
                    case 11:
                      e = 1;
                      break;
                    case 12:
                      e = 2;
                      break;
                    case 13:
                      return [13, bu(or, n[1])];
                    default:
                      Ar = 1;
                  }
                  if (Ar) throw [0, Sn, xf0];
                  break;
                default:
                  var W0 = 0, Lr = t[1];
                  if (typeof n == "number") W0 = 1;
                  else switch (n[0]) {
                    case 10:
                      break;
                    case 11:
                      e = 1;
                      break;
                    case 12:
                      e = 2;
                      break;
                    case 13:
                      e = 3;
                      break;
                    case 14:
                      return [14, bu(Lr, n[1])];
                    default:
                      W0 = 1;
                  }
                  if (W0) throw [0, Sn, af0];
              }
              switch (e) {
                case 0:
                  throw [0, Sn, nf0];
                case 1:
                  throw [0, Sn, uf0];
                case 2:
                  throw [0, Sn, ff0];
                case 3:
                  throw [0, Sn, of0];
                case 4:
                  throw [0, Sn, cf0];
                case 5:
                  throw [0, Sn, vf0];
                case 6:
                  throw [0, Sn, bf0];
                default:
                  throw [0, Sn, pf0];
              }
            }
            var Ou = [wt, Vx0, M7(0)];
            function Ip(t, n) {
              if (typeof t == "number") return [0, 0, n];
              if (t[0] === 0) return [0, [0, t[1], t[2]], n];
              if (typeof n != "number" && n[0] === 2) return [0, [1, t[1]], n[1]];
              throw Ou;
            }
            function dl(t, n, e) {
              var i = Ip(t, e);
              if (typeof n == "number") {
                if (n) {
                  var x = i[2];
                  if (typeof x != "number" && x[0] === 2) return [0, i[1], 1, x[1]];
                  throw Ou;
                }
                return [0, i[1], 0, i[2]];
              }
              return [0, i[1], [0, n[1]], i[2]];
            }
            function _7(t, n, e) {
              if (typeof t == "number") return [0, 0, _t(n, e)];
              switch (t[0]) {
                case 0:
                  if (typeof e != "number" && e[0] === 0) {
                    var i = _7(t[1], n, e[1]);
                    return [0, [0, i[1]], i[2]];
                  }
                  break;
                case 1:
                  if (typeof e != "number" && e[0] === 1) {
                    var x = _7(t[1], n, e[1]);
                    return [0, [1, x[1]], x[2]];
                  }
                  break;
                case 2:
                  if (typeof e != "number" && e[0] === 2) {
                    var c = _7(t[1], n, e[1]);
                    return [0, [2, c[1]], c[2]];
                  }
                  break;
                case 3:
                  if (typeof e != "number" && e[0] === 3) {
                    var s = _7(t[1], n, e[1]);
                    return [0, [3, s[1]], s[2]];
                  }
                  break;
                case 4:
                  if (typeof e != "number" && e[0] === 4) {
                    var p = _7(t[1], n, e[1]);
                    return [0, [4, p[1]], p[2]];
                  }
                  break;
                case 5:
                  if (typeof e != "number" && e[0] === 5) {
                    var y = _7(t[1], n, e[1]);
                    return [0, [5, y[1]], y[2]];
                  }
                  break;
                case 6:
                  if (typeof e != "number" && e[0] === 6) {
                    var T = _7(t[1], n, e[1]);
                    return [0, [6, T[1]], T[2]];
                  }
                  break;
                case 7:
                  if (typeof e != "number" && e[0] === 7) {
                    var E = _7(t[1], n, e[1]);
                    return [0, [7, E[1]], E[2]];
                  }
                  break;
                case 8:
                  if (typeof e != "number" && e[0] === 8) {
                    var d = e[1], w = e[2], G = t[2];
                    if (cl([0, t[1]], [0, d])) throw Ou;
                    var A = _7(G, n, w);
                    return [0, [8, d, A[1]], A[2]];
                  }
                  break;
                case 9:
                  if (typeof e != "number" && e[0] === 9) {
                    var S = e[2], M = e[1], K = e[3], V = t[3], f0 = t[2], m0 = t[1], k0 = [0, Gt(M)];
                    if (cl([0, Gt(m0)], k0)) throw Ou;
                    var g0 = [0, Gt(S)];
                    if (cl([0, Gt(f0)], g0)) throw Ou;
                    var e0 = Ru(bu(uu(M), S)), x0 = e0[4];
                    u(e0[2], 0), u(x0, 0);
                    var l = _7(Gt(V), n, K), c0 = l[2];
                    return [0, [9, M, S, uu(l[1])], c0];
                  }
                  break;
                case 10:
                  if (typeof e != "number" && e[0] === 10) {
                    var t0 = _7(t[1], n, e[1]);
                    return [0, [10, t0[1]], t0[2]];
                  }
                  break;
                case 11:
                  if (typeof e != "number" && e[0] === 11) {
                    var o0 = _7(t[1], n, e[1]);
                    return [0, [11, o0[1]], o0[2]];
                  }
                  break;
                case 13:
                  if (typeof e != "number" && e[0] === 13) {
                    var w0 = _7(t[1], n, e[1]);
                    return [0, [13, w0[1]], w0[2]];
                  }
                  break;
                case 14:
                  if (typeof e != "number" && e[0] === 14) {
                    var _0 = _7(t[1], n, e[1]);
                    return [0, [14, _0[1]], _0[2]];
                  }
                  break;
              }
              throw Ou;
            }
            function _t(t, n) {
              if (typeof t == "number") return [0, 0, n];
              switch (t[0]) {
                case 0:
                  if (typeof n != "number" && n[0] === 0) {
                    var e = _t(t[1], n[1]);
                    return [0, [0, e[1]], e[2]];
                  }
                  break;
                case 1:
                  if (typeof n != "number" && n[0] === 0) {
                    var i = _t(t[1], n[1]);
                    return [0, [1, i[1]], i[2]];
                  }
                  break;
                case 2:
                  var x = t[2], c = Ip(t[1], n), s = c[2], p = c[1];
                  if (typeof s != "number" && s[0] === 1) {
                    var y = _t(x, s[1]);
                    return [0, [2, p, y[1]], y[2]];
                  }
                  throw Ou;
                case 3:
                  var T = t[2], E = Ip(t[1], n), d = E[2], w = E[1];
                  if (typeof d != "number" && d[0] === 1) {
                    var G = _t(T, d[1]);
                    return [0, [3, w, G[1]], G[2]];
                  }
                  throw Ou;
                case 4:
                  var A = t[4], S = t[1], M = dl(t[2], t[3], n), K = M[3], V = M[1];
                  if (typeof K != "number" && K[0] === 2) {
                    var f0 = M[2], m0 = _t(A, K[1]);
                    return [0, [4, S, V, f0, m0[1]], m0[2]];
                  }
                  throw Ou;
                case 5:
                  var k0 = t[4], g0 = t[1], e0 = dl(t[2], t[3], n), x0 = e0[3], l = e0[1];
                  if (typeof x0 != "number" && x0[0] === 3) {
                    var c0 = e0[2], t0 = _t(k0, x0[1]);
                    return [0, [5, g0, l, c0, t0[1]], t0[2]];
                  }
                  throw Ou;
                case 6:
                  var o0 = t[4], w0 = t[1], _0 = dl(t[2], t[3], n), E0 = _0[3], U0 = _0[1];
                  if (typeof E0 != "number" && E0[0] === 4) {
                    var b = _0[2], R0 = _t(o0, E0[1]);
                    return [0, [6, w0, U0, b, R0[1]], R0[2]];
                  }
                  throw Ou;
                case 7:
                  var X = t[4], s0 = t[1], hr = dl(t[2], t[3], n), Ar = hr[3], or = hr[1];
                  if (typeof Ar != "number" && Ar[0] === 5) {
                    var W0 = hr[2], Lr = _t(X, Ar[1]);
                    return [0, [7, s0, or, W0, Lr[1]], Lr[2]];
                  }
                  throw Ou;
                case 8:
                  var Tr = t[4], Hr = t[1], Or = dl(t[2], t[3], n), fr = Or[3], Rr = Or[1];
                  if (typeof fr != "number" && fr[0] === 6) {
                    var Wr = Or[2], Jr = _t(Tr, fr[1]);
                    return [0, [8, Hr, Rr, Wr, Jr[1]], Jr[2]];
                  }
                  throw Ou;
                case 9:
                  var ar = t[2], _r = Ip(t[1], n), Ir = _r[2], fe = _r[1];
                  if (typeof Ir != "number" && Ir[0] === 7) {
                    var v0 = _t(ar, Ir[1]);
                    return [0, [9, fe, v0[1]], v0[2]];
                  }
                  throw Ou;
                case 10:
                  var P = _t(t[1], n);
                  return [0, [10, P[1]], P[2]];
                case 11:
                  var L = t[1], Q = _t(t[2], n);
                  return [0, [11, L, Q[1]], Q[2]];
                case 12:
                  var i0 = t[1], l0 = _t(t[2], n);
                  return [0, [12, i0, l0[1]], l0[2]];
                case 13:
                  if (typeof n != "number" && n[0] === 8) {
                    var S0 = n[1], T0 = n[2], rr = t[3], L0 = t[1];
                    if (cl([0, t[2]], [0, S0])) throw Ou;
                    var B = _t(rr, T0);
                    return [0, [13, L0, S0, B[1]], B[2]];
                  }
                  break;
                case 14:
                  if (typeof n != "number" && n[0] === 9) {
                    var Z = n[1], p0 = n[3], b0 = t[3], O0 = t[2], M0 = t[1], er = [0, Gt(Z)];
                    if (cl([0, Gt(O0)], er)) throw Ou;
                    var yr = _t(b0, Gt(p0));
                    return [0, [14, M0, Z, yr[1]], yr[2]];
                  }
                  break;
                case 15:
                  if (typeof n != "number" && n[0] === 10) {
                    var vr = _t(t[1], n[1]);
                    return [0, [15, vr[1]], vr[2]];
                  }
                  break;
                case 16:
                  if (typeof n != "number" && n[0] === 11) {
                    var $0 = _t(t[1], n[1]);
                    return [0, [16, $0[1]], $0[2]];
                  }
                  break;
                case 17:
                  var Er = t[1], Mr = _t(t[2], n);
                  return [0, [17, Er, Mr[1]], Mr[2]];
                case 18:
                  var Br = t[2], qr = t[1];
                  if (qr[0] === 0) {
                    var jr = qr[1], $r = jr[2], ne = _t(jr[1], n), Qr = ne[1], be = _t(Br, ne[2]);
                    return [0, [18, [0, [0, Qr, $r]], be[1]], be[2]];
                  }
                  var ae = qr[1], pe = ae[2], oe = _t(ae[1], n), ce = oe[1], ge = _t(Br, oe[2]);
                  return [0, [18, [1, [0, ce, pe]], ge[1]], ge[2]];
                case 19:
                  if (typeof n != "number" && n[0] === 13) {
                    var q0 = _t(t[1], n[1]);
                    return [0, [19, q0[1]], q0[2]];
                  }
                  break;
                case 20:
                  if (typeof n != "number" && n[0] === 1) {
                    var Fr = t[2], _ = t[1], k = _t(t[3], n[1]);
                    return [0, [20, _, Fr, k[1]], k[2]];
                  }
                  break;
                case 21:
                  if (typeof n != "number" && n[0] === 2) {
                    var I = t[1], U = _t(t[2], n[1]);
                    return [0, [21, I, U[1]], U[2]];
                  }
                  break;
                case 23:
                  var Y = t[2], y0 = t[1];
                  if (typeof y0 == "number") switch (y0) {
                    case 0:
                      return U7(y0, Y, n);
                    case 1:
                      return U7(y0, Y, n);
                    case 2:
                      if (typeof n != "number" && n[0] === 14) {
                        var P0 = _t(Y, n[1]);
                        return [0, [23, 2, P0[1]], P0[2]];
                      }
                      throw Ou;
                    default:
                      return U7(y0, Y, n);
                  }
                  else switch (y0[0]) {
                    case 0:
                      return U7(y0, Y, n);
                    case 1:
                      return U7(y0, Y, n);
                    case 2:
                      return U7(y0, Y, n);
                    case 3:
                      return U7(y0, Y, n);
                    case 4:
                      return U7(y0, Y, n);
                    case 5:
                      return U7(y0, Y, n);
                    case 6:
                      return U7(y0, Y, n);
                    case 7:
                      return U7(y0, Y, n);
                    case 8:
                      return U7([8, y0[1], y0[2]], Y, n);
                    case 9:
                      var I0 = y0[1], D = _7(y0[2], Y, n), u0 = D[2];
                      return [0, [23, [9, I0, D[1]], u0[1]], u0[2]];
                    case 10:
                      return U7(y0, Y, n);
                    default:
                      return U7(y0, Y, n);
                  }
              }
              throw Ou;
            }
            function U7(t, n, e) {
              var i = _t(n, e);
              return [0, [23, t, i[1]], i[2]];
            }
            function H7(t, n, e) {
              var i = un(e), x = 0 <= n ? t : 0, c = gp(n);
              if (c <= i) return e;
              var s = x === 2 ? 48 : 32, p = k1(c, s);
              switch (x) {
                case 0:
                  cs(e, 0, p, 0, i);
                  break;
                case 1:
                  cs(e, 0, p, c - i | 0, i);
                  break;
                default:
                  var y = 0;
                  if (0 < i) {
                    var T = 0;
                    It(e, 0) !== 43 && It(e, 0) !== 45 && It(e, 0) !== 32 && (y = 1, T = 1), T || (b1(p, 0, It(e, 0)), cs(e, 1, p, (c - i | 0) + 1 | 0, i - 1 | 0));
                  } else y = 1;
                  if (y) {
                    var E = 0;
                    if (1 < i && It(e, 0) === 48) {
                      var d = 0;
                      uc !== It(e, 1) && It(e, 1) !== 88 && (E = 1, d = 1), d || (b1(p, 1, It(e, 1)), cs(e, 2, p, (c - i | 0) + 2 | 0, i - 2 | 0));
                    } else E = 1;
                    E && cs(e, 0, p, c - i | 0, i);
                  }
              }
              return p;
            }
            function Yv(t, n) {
              var e = gp(t), i = un(n), x = It(n, 0), c = 0;
              if (58 <= x) 71 <= x ? 5 < (x + Y3 | 0) >>> 0 || (c = 1) : 65 <= x && (c = 1);
              else {
                var s = 0;
                if (x !== 32) if (43 <= x) switch (x + xy | 0) {
                  case 5:
                    if (i < (e + 2 | 0) && 1 < i) {
                      var p = 0;
                      if ((uc === It(n, 1) || It(n, 1) === 88) && (p = 1), p) {
                        var y = k1(e + 2 | 0, 48);
                        return b1(y, 1, It(n, 1)), cs(n, 2, y, (e - i | 0) + 4 | 0, i - 2 | 0), y;
                      }
                    }
                    c = 1, s = 1;
                    break;
                  case 0:
                  case 2:
                    break;
                  case 1:
                  case 3:
                  case 4:
                    s = 1;
                    break;
                  default:
                    c = 1, s = 1;
                }
                else s = 1;
                if (!s && i < (e + 1 | 0)) {
                  var T = k1(e + 1 | 0, 48);
                  return b1(T, 0, x), cs(n, 1, T, (e - i | 0) + 2 | 0, i - 1 | 0), T;
                }
              }
              if (c && i < e) {
                var E = k1(e, 48);
                return cs(n, 0, E, e - i | 0, i), E;
              }
              return n;
            }
            function zre(t) {
              for (var n = 0, e = un(t); ; ) {
                if (e <= n) var i = t;
                else {
                  var x = Vr(t, n) + hU | 0, c = 0;
                  if (59 < x >>> 0 ? 33 < (x + SS | 0) >>> 0 && (c = 1) : x === 2 && (c = 1), !c) {
                    var n = n + 1 | 0;
                    continue;
                  }
                  var s = t, p = [0, 0], y = b7(s) - 1 | 0, T = 0;
                  if (!(y < 0)) for (var E = T; ; ) {
                    var d = Xu(s, E), w = 0;
                    if (32 <= d) {
                      var G = d - 34 | 0, A = 0;
                      if (58 < G >>> 0 ? 93 <= G && (A = 1) : 56 < (G - 1 | 0) >>> 0 && (w = 1, A = 1), !A) {
                        var S = 1;
                        w = 2;
                      }
                    } else 11 <= d ? d === 13 && (w = 1) : 8 <= d && (w = 1);
                    switch (w) {
                      case 0:
                        var S = 4;
                        break;
                      case 1:
                        var S = 2;
                        break;
                    }
                    p[1] = p[1] + S | 0;
                    var M = E + 1 | 0;
                    if (y !== E) {
                      var E = M;
                      continue;
                    }
                    break;
                  }
                  if (p[1] === b7(s)) var K = sz(s);
                  else {
                    var V = Lt(p[1]);
                    p[1] = 0;
                    var f0 = b7(s) - 1 | 0, m0 = 0;
                    if (!(f0 < 0)) for (var k0 = m0; ; ) {
                      var g0 = Xu(s, k0), e0 = 0;
                      if (35 <= g0) g0 === 92 ? e0 = 2 : zn <= g0 ? e0 = 1 : e0 = 3;
                      else if (32 <= g0) 34 <= g0 ? e0 = 2 : e0 = 3;
                      else if (14 <= g0) e0 = 1;
                      else switch (g0) {
                        case 8:
                          Jn(V, p[1], 92), p[1]++, Jn(V, p[1], 98);
                          break;
                        case 9:
                          Jn(V, p[1], 92), p[1]++, Jn(V, p[1], f1);
                          break;
                        case 10:
                          Jn(V, p[1], 92), p[1]++, Jn(V, p[1], Xt);
                          break;
                        case 13:
                          Jn(V, p[1], 92), p[1]++, Jn(V, p[1], t1);
                          break;
                        default:
                          e0 = 1;
                      }
                      switch (e0) {
                        case 1:
                          Jn(V, p[1], 92), p[1]++, Jn(V, p[1], 48 + (g0 / ti | 0) | 0), p[1]++, Jn(V, p[1], 48 + ((g0 / 10 | 0) % 10 | 0) | 0), p[1]++, Jn(V, p[1], 48 + (g0 % 10 | 0) | 0);
                          break;
                        case 2:
                          Jn(V, p[1], 92), p[1]++, Jn(V, p[1], g0);
                          break;
                        case 3:
                          Jn(V, p[1], g0);
                          break;
                      }
                      p[1]++;
                      var x0 = k0 + 1 | 0;
                      if (f0 !== k0) {
                        var k0 = x0;
                        continue;
                      }
                      break;
                    }
                    var K = V;
                  }
                  var i = K;
                }
                var l = un(i), c0 = k1(l + 2 | 0, 34);
                return Ts(i, 0, c0, 1, l), c0;
              }
            }
            function wz(t, n) {
              var e = gp(n), i = rz ? rz[1] : 70;
              switch (t[2]) {
                case 0:
                  var x = Ri;
                  break;
                case 1:
                  var x = R7;
                  break;
                case 2:
                  var x = 69;
                  break;
                case 3:
                  var x = s7;
                  break;
                case 4:
                  var x = 71;
                  break;
                case 5:
                  var x = i;
                  break;
                case 6:
                  var x = L7;
                  break;
                case 7:
                  var x = 72;
                  break;
                default:
                  var x = 70;
              }
              var c = yz(16);
              switch (Xv(c, 37), t[1]) {
                case 0:
                  break;
                case 1:
                  Xv(c, 43);
                  break;
                default:
                  Xv(c, 32);
              }
              return 8 <= t[2] && Xv(c, 35), Xv(c, 46), Lu(c, r(C + e)), Xv(c, x), dz(c);
            }
            function Ap(t, n) {
              if (13 <= t) {
                var e = [0, 0], i = un(n) - 1 | 0, x = 0;
                if (!(i < 0)) for (var c = x; ; ) {
                  9 < (Vr(n, c) + Wt | 0) >>> 0 || e[1]++;
                  var s = c + 1 | 0;
                  if (i !== c) {
                    var c = s;
                    continue;
                  }
                  break;
                }
                var p = e[1], y = Lt(un(n) + ((p - 1 | 0) / 3 | 0) | 0), T = [0, 0], E = function(K) {
                  return b1(y, T[1], K), T[1]++, 0;
                }, d = [0, ((p - 1 | 0) % 3 | 0) + 1 | 0], w = un(n) - 1 | 0, G = 0;
                if (!(w < 0)) for (var A = G; ; ) {
                  var S = Vr(n, A);
                  9 < (S + Wt | 0) >>> 0 || (d[1] === 0 && (E(95), d[1] = 3), d[1] += -1), E(S);
                  var M = A + 1 | 0;
                  if (w !== A) {
                    var A = M;
                    continue;
                  }
                  break;
                }
                return y;
              }
              return n;
            }
            function Kre(t, n) {
              switch (t) {
                case 1:
                  var e = gx0;
                  break;
                case 2:
                  var e = Fx0;
                  break;
                case 4:
                  var e = Tx0;
                  break;
                case 5:
                  var e = Ox0;
                  break;
                case 6:
                  var e = Ix0;
                  break;
                case 7:
                  var e = Ax0;
                  break;
                case 8:
                  var e = Nx0;
                  break;
                case 9:
                  var e = Cx0;
                  break;
                case 10:
                  var e = Px0;
                  break;
                case 11:
                  var e = Dx0;
                  break;
                case 0:
                case 13:
                  var e = Lx0;
                  break;
                case 3:
                case 14:
                  var e = Rx0;
                  break;
                default:
                  var e = jx0;
              }
              return Ap(t, hp(e, n));
            }
            function Wre(t, n) {
              switch (t) {
                case 1:
                  var e = Qf0;
                  break;
                case 2:
                  var e = rx0;
                  break;
                case 4:
                  var e = ex0;
                  break;
                case 5:
                  var e = nx0;
                  break;
                case 6:
                  var e = tx0;
                  break;
                case 7:
                  var e = ux0;
                  break;
                case 8:
                  var e = ix0;
                  break;
                case 9:
                  var e = fx0;
                  break;
                case 10:
                  var e = xx0;
                  break;
                case 11:
                  var e = ox0;
                  break;
                case 0:
                case 13:
                  var e = ax0;
                  break;
                case 3:
                case 14:
                  var e = cx0;
                  break;
                default:
                  var e = sx0;
              }
              return Ap(t, hp(e, n));
            }
            function Jre(t, n) {
              switch (t) {
                case 1:
                  var e = Bf0;
                  break;
                case 2:
                  var e = qf0;
                  break;
                case 4:
                  var e = Uf0;
                  break;
                case 5:
                  var e = Hf0;
                  break;
                case 6:
                  var e = Xf0;
                  break;
                case 7:
                  var e = Yf0;
                  break;
                case 8:
                  var e = Vf0;
                  break;
                case 9:
                  var e = zf0;
                  break;
                case 10:
                  var e = Kf0;
                  break;
                case 11:
                  var e = Wf0;
                  break;
                case 0:
                case 13:
                  var e = Jf0;
                  break;
                case 3:
                case 14:
                  var e = $f0;
                  break;
                default:
                  var e = Zf0;
              }
              return Ap(t, hp(e, n));
            }
            function $re(t, n) {
              switch (t) {
                case 1:
                  var e = vx0;
                  break;
                case 2:
                  var e = lx0;
                  break;
                case 4:
                  var e = bx0;
                  break;
                case 5:
                  var e = px0;
                  break;
                case 6:
                  var e = mx0;
                  break;
                case 7:
                  var e = _x0;
                  break;
                case 8:
                  var e = yx0;
                  break;
                case 9:
                  var e = hx0;
                  break;
                case 10:
                  var e = dx0;
                  break;
                case 11:
                  var e = kx0;
                  break;
                case 0:
                case 13:
                  var e = wx0;
                  break;
                case 3:
                case 14:
                  var e = Ex0;
                  break;
                default:
                  var e = Sx0;
              }
              return Ap(t, d70(e, n));
            }
            function ss(t, n, e) {
              function i(m0) {
                switch (t[1]) {
                  case 0:
                    var k0 = 45;
                    break;
                  case 1:
                    var k0 = 43;
                    break;
                  default:
                    var k0 = 32;
                }
                return m70(e, n, k0);
              }
              function x(m0) {
                var k0 = Zu0(e);
                return k0 === 3 ? e < 0 ? jf0 : Gf0 : 4 <= k0 ? Rf0 : m0;
              }
              switch (t[2]) {
                case 5:
                  for (var c = XA(wz(t, n), e), s = 0, p = un(c); ; ) {
                    if (s === p) var y = 0;
                    else {
                      var T = It(c, s) + v1 | 0, E = 0;
                      if (23 < T >>> 0 ? T === 55 && (E = 1) : 21 < (T - 1 | 0) >>> 0 && (E = 1), !E) {
                        var s = s + 1 | 0;
                        continue;
                      }
                      var y = 1;
                    }
                    var d = y ? c : Te(c, Mf0);
                    return x(d);
                  }
                case 6:
                  return i(0);
                case 7:
                  var w = i(0), G = b7(w);
                  if (G === 0) var A = w;
                  else {
                    var S = Lt(G), M = G - 1 | 0, K = 0;
                    if (!(M < 0)) for (var V = K; ; ) {
                      Jn(S, V, xz(Xu(w, V)));
                      var f0 = V + 1 | 0;
                      if (M !== V) {
                        var V = f0;
                        continue;
                      }
                      break;
                    }
                    var A = S;
                  }
                  return A;
                case 8:
                  return x(i(0));
                default:
                  return XA(wz(t, n), e);
              }
            }
            function kl(t, n, e, i) {
              for (var x = n, c = e, s = i; ; ) {
                if (typeof s == "number") return u(x, c);
                switch (s[0]) {
                  case 0:
                    var p = s[1];
                    return function(ar) {
                      return Xn(x, [5, c, ar], p);
                    };
                  case 1:
                    var y = s[1];
                    return function(ar) {
                      var _r = 0;
                      if (40 <= ar) if (ar === 92) var Ir = oi0;
                      else zn <= ar ? _r = 1 : _r = 2;
                      else if (32 <= ar) if (39 <= ar) var Ir = ai0;
                      else _r = 2;
                      else if (14 <= ar) _r = 1;
                      else switch (ar) {
                        case 8:
                          var Ir = ci0;
                          break;
                        case 9:
                          var Ir = si0;
                          break;
                        case 10:
                          var Ir = vi0;
                          break;
                        case 13:
                          var Ir = li0;
                          break;
                        default:
                          _r = 1;
                      }
                      switch (_r) {
                        case 1:
                          var fe = Lt(4);
                          Jn(fe, 0, 92), Jn(fe, 1, 48 + (ar / ti | 0) | 0), Jn(fe, 2, 48 + ((ar / 10 | 0) % 10 | 0) | 0), Jn(fe, 3, 48 + (ar % 10 | 0) | 0);
                          var Ir = fe;
                          break;
                        case 2:
                          var v0 = Lt(1);
                          Jn(v0, 0, ar);
                          var Ir = v0;
                          break;
                      }
                      var P = un(Ir), L = k1(P + 2 | 0, 39);
                      return Ts(Ir, 0, L, 1, P), Xn(x, [4, c, L], y);
                    };
                  case 2:
                    var T = s[2], E = s[1];
                    return mN(x, c, T, E, function(ar) {
                      return ar;
                    });
                  case 3:
                    return mN(x, c, s[2], s[1], zre);
                  case 4:
                    return Np(x, c, s[4], s[2], s[3], Kre, s[1]);
                  case 5:
                    return Np(x, c, s[4], s[2], s[3], Wre, s[1]);
                  case 6:
                    return Np(x, c, s[4], s[2], s[3], Jre, s[1]);
                  case 7:
                    return Np(x, c, s[4], s[2], s[3], $re, s[1]);
                  case 8:
                    var d = s[4], w = s[3], G = s[2], A = s[1];
                    if (typeof G == "number") {
                      if (typeof w == "number") return w ? function(ar, _r) {
                        return Xn(x, [4, c, ss(A, ar, _r)], d);
                      } : function(ar) {
                        return Xn(x, [4, c, ss(A, vN(A), ar)], d);
                      };
                      var S = w[1];
                      return function(ar) {
                        return Xn(x, [4, c, ss(A, S, ar)], d);
                      };
                    } else {
                      if (G[0] === 0) {
                        var M = G[2], K = G[1];
                        if (typeof w == "number") return w ? function(ar, _r) {
                          return Xn(x, [4, c, H7(K, M, ss(A, ar, _r))], d);
                        } : function(ar) {
                          return Xn(x, [4, c, H7(K, M, ss(A, vN(A), ar))], d);
                        };
                        var V = w[1];
                        return function(ar) {
                          return Xn(x, [4, c, H7(K, M, ss(A, V, ar))], d);
                        };
                      }
                      var f0 = G[1];
                      if (typeof w == "number") return w ? function(ar, _r, Ir) {
                        return Xn(x, [4, c, H7(f0, ar, ss(A, _r, Ir))], d);
                      } : function(ar, _r) {
                        return Xn(x, [4, c, H7(f0, ar, ss(A, vN(A), _r))], d);
                      };
                      var m0 = w[1];
                      return function(ar, _r) {
                        return Xn(x, [4, c, H7(f0, ar, ss(A, m0, _r))], d);
                      };
                    }
                  case 9:
                    return mN(x, c, s[2], s[1], Gre);
                  case 10:
                    var c = [7, c], s = s[1];
                    continue;
                  case 11:
                    var c = [2, c, s[1]], s = s[2];
                    continue;
                  case 12:
                    var c = [3, c, s[1]], s = s[2];
                    continue;
                  case 13:
                    var k0 = s[3], g0 = s[2], e0 = yz(16);
                    lN(e0, g0);
                    var x0 = dz(e0);
                    return function(ar) {
                      return Xn(x, [4, c, x0], k0);
                    };
                  case 14:
                    var l = s[3], c0 = s[2];
                    return function(ar) {
                      var _r = ar[1], Ir = _t(_r, Gt(uu(c0)));
                      if (typeof Ir[2] == "number") return Xn(x, c, At(Ir[1], l));
                      throw Ou;
                    };
                  case 15:
                    var t0 = s[1];
                    return function(ar, _r) {
                      return Xn(x, [6, c, function(Ir) {
                        return o(ar, Ir, _r);
                      }], t0);
                    };
                  case 16:
                    var o0 = s[1];
                    return function(ar) {
                      return Xn(x, [6, c, ar], o0);
                    };
                  case 17:
                    var c = [0, c, s[1]], s = s[2];
                    continue;
                  case 18:
                    var w0 = s[1];
                    if (w0[0] === 0) {
                      var _0 = s[2], E0 = w0[1][1], U0 = 0, x = /* @__PURE__ */ function(fe, v0, P) {
                        return function(L) {
                          return Xn(v0, [1, fe, [0, L]], P);
                        };
                      }(c, x, _0), c = U0, s = E0;
                      continue;
                    }
                    var b = s[2], R0 = w0[1][1], X = 0, x = /* @__PURE__ */ function(ar, _r, Ir) {
                      return function(fe) {
                        return Xn(_r, [1, ar, [1, fe]], Ir);
                      };
                    }(c, x, b), c = X, s = R0;
                    continue;
                  case 19:
                    throw [0, Sn, _f0];
                  case 20:
                    var s0 = s[3], hr = [8, c, yf0];
                    return function(ar) {
                      return Xn(x, hr, s0);
                    };
                  case 21:
                    var Ar = s[2];
                    return function(ar) {
                      return Xn(x, [4, c, hp(mf0, ar)], Ar);
                    };
                  case 22:
                    var or = s[1];
                    return function(ar) {
                      return Xn(x, [5, c, ar], or);
                    };
                  case 23:
                    var W0 = s[2], Lr = s[1];
                    if (typeof Lr == "number") switch (Lr) {
                      case 0:
                        return t < 50 ? ct(t + 1 | 0, x, c, W0) : Tu(ct, [0, x, c, W0]);
                      case 1:
                        return t < 50 ? ct(t + 1 | 0, x, c, W0) : Tu(ct, [0, x, c, W0]);
                      case 2:
                        throw [0, Sn, hf0];
                      default:
                        return t < 50 ? ct(t + 1 | 0, x, c, W0) : Tu(ct, [0, x, c, W0]);
                    }
                    else switch (Lr[0]) {
                      case 0:
                        return t < 50 ? ct(t + 1 | 0, x, c, W0) : Tu(ct, [0, x, c, W0]);
                      case 1:
                        return t < 50 ? ct(t + 1 | 0, x, c, W0) : Tu(ct, [0, x, c, W0]);
                      case 2:
                        return t < 50 ? ct(t + 1 | 0, x, c, W0) : Tu(ct, [0, x, c, W0]);
                      case 3:
                        return t < 50 ? ct(t + 1 | 0, x, c, W0) : Tu(ct, [0, x, c, W0]);
                      case 4:
                        return t < 50 ? ct(t + 1 | 0, x, c, W0) : Tu(ct, [0, x, c, W0]);
                      case 5:
                        return t < 50 ? ct(t + 1 | 0, x, c, W0) : Tu(ct, [0, x, c, W0]);
                      case 6:
                        return t < 50 ? ct(t + 1 | 0, x, c, W0) : Tu(ct, [0, x, c, W0]);
                      case 7:
                        return t < 50 ? ct(t + 1 | 0, x, c, W0) : Tu(ct, [0, x, c, W0]);
                      case 8:
                        return t < 50 ? ct(t + 1 | 0, x, c, W0) : Tu(ct, [0, x, c, W0]);
                      case 9:
                        var Tr = Lr[2];
                        return t < 50 ? bN(t + 1 | 0, x, c, Tr, W0) : Tu(bN, [0, x, c, Tr, W0]);
                      case 10:
                        return t < 50 ? ct(t + 1 | 0, x, c, W0) : Tu(ct, [0, x, c, W0]);
                      default:
                        return t < 50 ? ct(t + 1 | 0, x, c, W0) : Tu(ct, [0, x, c, W0]);
                    }
                  default:
                    var Hr = s[3], Or = s[1], fr = u(s[2], 0);
                    return t < 50 ? pN(t + 1 | 0, x, c, Hr, Or, fr) : Tu(pN, [0, x, c, Hr, Or, fr]);
                }
              }
            }
            function bN(t, n, e, i, x) {
              if (typeof i == "number") return t < 50 ? ct(t + 1 | 0, n, e, x) : Tu(ct, [0, n, e, x]);
              switch (i[0]) {
                case 0:
                  var c = i[1];
                  return function(m0) {
                    return fi(n, e, c, x);
                  };
                case 1:
                  var s = i[1];
                  return function(m0) {
                    return fi(n, e, s, x);
                  };
                case 2:
                  var p = i[1];
                  return function(m0) {
                    return fi(n, e, p, x);
                  };
                case 3:
                  var y = i[1];
                  return function(m0) {
                    return fi(n, e, y, x);
                  };
                case 4:
                  var T = i[1];
                  return function(m0) {
                    return fi(n, e, T, x);
                  };
                case 5:
                  var E = i[1];
                  return function(m0) {
                    return fi(n, e, E, x);
                  };
                case 6:
                  var d = i[1];
                  return function(m0) {
                    return fi(n, e, d, x);
                  };
                case 7:
                  var w = i[1];
                  return function(m0) {
                    return fi(n, e, w, x);
                  };
                case 8:
                  var G = i[2];
                  return function(m0) {
                    return fi(n, e, G, x);
                  };
                case 9:
                  var A = i[3], S = i[2], M = bu(uu(i[1]), S);
                  return function(m0) {
                    return fi(n, e, u7(M, A), x);
                  };
                case 10:
                  var K = i[1];
                  return function(m0, k0) {
                    return fi(n, e, K, x);
                  };
                case 11:
                  var V = i[1];
                  return function(m0) {
                    return fi(n, e, V, x);
                  };
                case 12:
                  var f0 = i[1];
                  return function(m0) {
                    return fi(n, e, f0, x);
                  };
                case 13:
                  throw [0, Sn, df0];
                default:
                  throw [0, Sn, kf0];
              }
            }
            function ct(t, n, e, i) {
              var x = [8, e, wf0];
              return t < 50 ? kl(t + 1 | 0, n, x, i) : Tu(kl, [0, n, x, i]);
            }
            function pN(t, n, e, i, x, c) {
              if (x) {
                var s = x[1];
                return function(y) {
                  return Zre(n, e, i, s, u(c, y));
                };
              }
              var p = [4, e, c];
              return t < 50 ? kl(t + 1 | 0, n, p, i) : Tu(kl, [0, n, p, i]);
            }
            function Xn(t, n, e) {
              return JA(kl(0, t, n, e));
            }
            function fi(t, n, e, i) {
              return JA(bN(0, t, n, e, i));
            }
            function Zre(t, n, e, i, x) {
              return JA(pN(0, t, n, e, i, x));
            }
            function mN(t, n, e, i, x) {
              if (typeof i == "number") return function(y) {
                return Xn(t, [4, n, u(x, y)], e);
              };
              if (i[0] === 0) {
                var c = i[2], s = i[1];
                return function(y) {
                  return Xn(t, [4, n, H7(s, c, u(x, y))], e);
                };
              }
              var p = i[1];
              return function(y, T) {
                return Xn(t, [4, n, H7(p, y, u(x, T))], e);
              };
            }
            function Np(t, n, e, i, x, c, s) {
              if (typeof i == "number") {
                if (typeof x == "number") return x ? function(G, A) {
                  return Xn(t, [4, n, Yv(G, o(c, s, A))], e);
                } : function(G) {
                  return Xn(t, [4, n, o(c, s, G)], e);
                };
                var p = x[1];
                return function(G) {
                  return Xn(t, [4, n, Yv(p, o(c, s, G))], e);
                };
              } else {
                if (i[0] === 0) {
                  var y = i[2], T = i[1];
                  if (typeof x == "number") return x ? function(G, A) {
                    return Xn(t, [4, n, H7(T, y, Yv(G, o(c, s, A)))], e);
                  } : function(G) {
                    return Xn(t, [4, n, H7(T, y, o(c, s, G))], e);
                  };
                  var E = x[1];
                  return function(G) {
                    return Xn(t, [4, n, H7(T, y, Yv(E, o(c, s, G)))], e);
                  };
                }
                var d = i[1];
                if (typeof x == "number") return x ? function(G, A, S) {
                  return Xn(t, [4, n, H7(d, G, Yv(A, o(c, s, S)))], e);
                } : function(G, A) {
                  return Xn(t, [4, n, H7(d, G, o(c, s, A))], e);
                };
                var w = x[1];
                return function(G, A) {
                  return Xn(t, [4, n, H7(d, G, Yv(w, o(c, s, A)))], e);
                };
              }
            }
            function vs(t, n) {
              for (var e = n; ; ) {
                if (typeof e == "number") return 0;
                switch (e[0]) {
                  case 0:
                    var i = e[1], x = kz(e[2]);
                    return vs(t, i), vl(t, x);
                  case 1:
                    var c = e[2], s = e[1];
                    if (c[0] === 0) {
                      var p = c[1];
                      vs(t, s), vl(t, Ef0);
                      var e = p;
                      continue;
                    }
                    var y = c[1];
                    vs(t, s), vl(t, Sf0);
                    var e = y;
                    continue;
                  case 6:
                    var T = e[2];
                    return vs(t, e[1]), u(T, t);
                  case 7:
                    return vs(t, e[1]), p1(t);
                  case 8:
                    var E = e[2];
                    return vs(t, e[1]), Pu(E);
                  case 2:
                  case 4:
                    var d = e[2];
                    return vs(t, e[1]), vl(t, d);
                  default:
                    var w = e[2];
                    return vs(t, e[1]), KV(t, w);
                }
              }
            }
            function ls(t, n) {
              for (var e = n; ; ) {
                if (typeof e == "number") return 0;
                switch (e[0]) {
                  case 0:
                    var i = e[1], x = kz(e[2]);
                    return ls(t, i), hn(t, x);
                  case 1:
                    var c = e[2], s = e[1];
                    if (c[0] === 0) {
                      var p = c[1];
                      ls(t, s), hn(t, gf0);
                      var e = p;
                      continue;
                    }
                    var y = c[1];
                    ls(t, s), hn(t, Ff0);
                    var e = y;
                    continue;
                  case 6:
                    var T = e[2];
                    return ls(t, e[1]), hn(t, u(T, 0));
                  case 7:
                    var e = e[1];
                    continue;
                  case 8:
                    var E = e[2];
                    return ls(t, e[1]), Pu(E);
                  case 2:
                  case 4:
                    var d = e[2];
                    return ls(t, e[1]), hn(t, d);
                  default:
                    var w = e[2];
                    return ls(t, e[1]), qi(t, w);
                }
              }
            }
            function Qre(t) {
              if (qn(t, Of0)) return If0;
              var n = un(t);
              function e(S) {
                var M = Tf0[1], K = $n(N4);
                return u(Xn(function(V) {
                  return ls(K, V), ke(Mt(K));
                }, 0, M), t);
              }
              function i(S) {
                for (var M = S; ; ) {
                  if (M === n) return M;
                  var K = It(t, M);
                  if (K !== 9 && K !== 32) return M;
                  var M = M + 1 | 0;
                }
              }
              function x(S, M) {
                for (var K = M; ; ) {
                  if (K === n || 25 < (It(t, K) + Y3 | 0) >>> 0) return K;
                  var K = K + 1 | 0;
                }
              }
              function c(S, M) {
                for (var K = M; ; ) {
                  if (K === n) return K;
                  var V = It(t, K), f0 = 0;
                  if (48 <= V ? 58 <= V || (f0 = 1) : V === 45 && (f0 = 1), f0) {
                    var K = K + 1 | 0;
                    continue;
                  }
                  return K;
                }
              }
              var s = i(0), p = x(s, s), y = m7(t, s, p - s | 0), T = i(p), E = c(T, T);
              if (T === E) var d = 0;
              else try {
                var w = Bi(m7(t, T, E - T | 0)), d = w;
              } catch (S) {
                if (S = Et(S), S[1] !== q7) throw S;
                var d = e(0);
              }
              i(E) !== n && e(0);
              var G = 0;
              if (n0(y, Af0) && n0(y, Nf0)) var A = n0(y, Cf0) ? n0(y, Pf0) ? n0(y, Df0) ? n0(y, Lf0) ? e(0) : 1 : 2 : 3 : 0;
              else G = 1;
              if (G) var A = 4;
              return [0, d, A];
            }
            function _N(t, n) {
              var e = n[1], i = 0;
              return Xn(function(x) {
                return vs(t, x), 0;
              }, i, e);
            }
            function yN(t) {
              return _N(Pc, t);
            }
            function et(t) {
              var n = t[1];
              return Xn(function(e) {
                var i = $n(64);
                return ls(i, e), Mt(i);
              }, 0, n);
            }
            var hN = [0, 0];
            function dN(t, n) {
              var e = t[1 + n];
              if (1 - (typeof e == "number" ? 1 : 0)) {
                if (h1(e) === Y2) return u(et(ho0), e);
                if (h1(e) === nd) for (var i = XA(ui0, e), x = 0, c = un(i); ; ) {
                  if (c <= x) return Te(i, ii0);
                  var s = It(i, x), p = 0;
                  if (48 <= s ? 58 <= s || (p = 1) : s === 45 && (p = 1), p) {
                    var x = x + 1 | 0;
                    continue;
                  }
                  return i;
                }
                return do0;
              }
              return u(et(yo0), e);
            }
            function Ez(t, n) {
              if (t.length - 1 <= n) return zx0;
              var e = Ez(t, n + 1 | 0), i = dN(t, n);
              return o(et(Kx0), i, e);
            }
            function Cp(t) {
              function n(k0) {
                for (var g0 = k0; ; ) {
                  if (g0) {
                    var e0 = g0[2], x0 = g0[1];
                    try {
                      var l = 0, c0 = u(x0, t);
                      l = 1;
                    } catch {
                    }
                    if (l && c0) return [0, c0[1]];
                    var g0 = e0;
                    continue;
                  }
                  return 0;
                }
              }
              var e = n(hN[1]);
              if (e) return e[1];
              if (t === $A) return ao0;
              if (t === QV) return co0;
              if (t[1] === ZV) {
                var i = t[2], x = i[3], c = i[2], s = i[1];
                return p7(et(QA), s, c, x, x + 5 | 0, so0);
              }
              if (t[1] === Sn) {
                var p = t[2], y = p[3], T = p[2], E = p[1];
                return p7(et(QA), E, T, y, y + 6 | 0, vo0);
              }
              if (t[1] === sl) {
                var d = t[2], w = d[3], G = d[2], A = d[1];
                return p7(et(QA), A, G, w, w + 6 | 0, lo0);
              }
              if (h1(t) === 0) {
                var S = t.length - 1, M = t[1][1];
                if (2 < S >>> 0) var K = Ez(t, 2), V = dN(t, 1), f0 = o(et(bo0), V, K);
                else switch (S) {
                  case 0:
                    var f0 = po0;
                    break;
                  case 1:
                    var f0 = mo0;
                    break;
                  default:
                    var m0 = dN(t, 1), f0 = u(et(_o0), m0);
                }
                return Te(M, f0);
              }
              return t[1];
            }
            function kN(t, n) {
              var e = s70(n), i = e.length - 1 - 1 | 0, x = 0;
              if (!(i < 0)) for (var c = x; ; ) {
                var s = tu(e, c)[1 + c], p = /* @__PURE__ */ function(f0) {
                  return function(m0) {
                    return m0 ? f0 === 0 ? eo0 : no0 : f0 === 0 ? to0 : uo0;
                  };
                }(c);
                if (s[0] === 0) var y = s[5], T = s[4], E = s[3], d = s[6] ? io0 : fo0, w = s[2], G = s[7], A = p(s[1]), M = [0, ei0(et(xo0), A, G, w, d, E, T, y)];
                else if (s[1]) var M = 0;
                else var S = p(0), M = [0, u(et(oo0), S)];
                if (M) {
                  var K = M[1];
                  u(_N(t, Qx0), K);
                }
                var V = c + 1 | 0;
                if (i !== c) {
                  var c = V;
                  continue;
                }
                break;
              }
              return 0;
            }
            function Sz(t) {
              for (; ; ) {
                var n = hN[1], e = 1 - nN(hN, n, [0, t, n]);
                if (!e) return e;
              }
            }
            var ree = ko0.slice();
            function eee(t, n) {
              var e = Cp(t);
              u(yN(Zx0), e), kN(Pc, n);
              var i = T70(0);
              if (i < 0) {
                var x = gp(i);
                iz(tu(ree, x)[1 + x]);
              }
              return p1(Pc);
            }
            var nee = [0];
            WA(r(LH), function(t, n) {
              try {
                try {
                  var e = n ? nee : GV(0);
                  try {
                    uN(0);
                  } catch {
                  }
                  try {
                    var i = eee(t, e), x = i;
                  } catch (y) {
                    y = Et(y);
                    var c = Cp(t);
                    u(yN(Wx0), c), kN(Pc, e);
                    var s = Cp(y);
                    u(yN(Jx0), s), kN(Pc, GV(0));
                    var x = p1(Pc);
                  }
                  var p = x;
                } catch (y) {
                  if (y = Et(y), y !== $A) throw y;
                  var p = iz($x0);
                }
                return p;
              } catch {
                return 0;
              }
            });
            var wN = [wt, Uo0, M7(0)], Pp = 0, gz = -1;
            function wl(t, n) {
              return t[13] = t[13] + n[3] | 0, aN(n, t[28]);
            }
            var Fz = 1000000010;
            function EN(t, n) {
              return ur(t[17], n, 0, un(n));
            }
            function Dp(t) {
              return u(t[19], 0);
            }
            function Tz(t, n, e) {
              return t[9] = t[9] - n | 0, EN(t, e), t[11] = 0, 0;
            }
            function Lp(t, n) {
              var e = n0(n, qo0);
              return e && Tz(t, un(n), n);
            }
            function Vv(t, n, e) {
              var i = n[3], x = n[2];
              Lp(t, n[1]), Dp(t), t[11] = 1;
              var c = (t[6] - e | 0) + x | 0, s = t[8], p = s <= c ? s : c;
              return t[10] = p, t[9] = t[6] - t[10] | 0, u(t[21], t[10]), Lp(t, i);
            }
            function Oz(t, n) {
              return Vv(t, Bo0, n);
            }
            function El(t, n) {
              var e = n[2], i = n[3];
              return Lp(t, n[1]), t[9] = t[9] - e | 0, u(t[20], e), Lp(t, i);
            }
            function Iz(t) {
              for (; ; ) {
                var n = t[28][2], e = n ? [0, n[1]] : 0;
                if (e) {
                  var i = e[1], x = i[1], c = i[2], s = 0 <= x ? 1 : 0, p = i[3], y = t[13] - t[12] | 0, T = s || (t[9] <= y ? 1 : 0);
                  if (T) {
                    var E = t[28], d = E[2];
                    if (d) {
                      if (d[2]) {
                        var w = d[2];
                        E[1] = E[1] - 1 | 0, E[2] = w;
                      } else oN(E);
                      var G = 0 <= x ? x : Fz;
                      if (typeof c == "number") switch (c) {
                        case 0:
                          var A = Hv(t[3]);
                          if (A) {
                            var S = A[1][1], M = function(L, Q) {
                              if (Q) {
                                var i0 = Q[1], l0 = Q[2];
                                return F70(L, i0) ? [0, L, Q] : [0, i0, M(L, l0)];
                              }
                              return [0, L, 0];
                            };
                            S[1] = M(t[6] - t[9] | 0, S[1]);
                          }
                          break;
                        case 1:
                          Uv(t[2]);
                          break;
                        case 2:
                          Uv(t[3]);
                          break;
                        case 3:
                          var K = Hv(t[2]);
                          K ? Oz(t, K[1][2]) : Dp(t);
                          break;
                        case 4:
                          if (t[10] !== (t[6] - t[9] | 0)) {
                            var V = t[28], f0 = V[2];
                            if (f0) {
                              var m0 = f0[1];
                              if (f0[2]) {
                                var k0 = f0[2];
                                V[1] = V[1] - 1 | 0, V[2] = k0;
                                var g0 = [0, m0];
                              } else {
                                oN(V);
                                var g0 = [0, m0];
                              }
                            } else var g0 = 0;
                            if (g0) {
                              var e0 = g0[1], x0 = e0[1];
                              t[12] = t[12] - e0[3] | 0, t[9] = t[9] + x0 | 0;
                            }
                          }
                          break;
                        default:
                          var l = Uv(t[5]);
                          l && EN(t, u(t[25], l[1]));
                      }
                      else switch (c[0]) {
                        case 0:
                          Tz(t, G, c[1]);
                          break;
                        case 1:
                          var c0 = c[2], t0 = c[1], o0 = c0[1], w0 = c0[2], _0 = Hv(t[2]);
                          if (_0) {
                            var E0 = _0[1], U0 = E0[2];
                            switch (E0[1]) {
                              case 0:
                                El(t, t0);
                                break;
                              case 1:
                                Vv(t, c0, U0);
                                break;
                              case 2:
                                Vv(t, c0, U0);
                                break;
                              case 3:
                                t[9] < (G + un(o0) | 0) ? Vv(t, c0, U0) : El(t, t0);
                                break;
                              case 4:
                                t[11] || !(t[9] < (G + un(o0) | 0) || ((t[6] - U0 | 0) + w0 | 0) < t[10]) ? El(t, t0) : Vv(t, c0, U0);
                                break;
                              default:
                                El(t, t0);
                            }
                          }
                          break;
                        case 2:
                          var b = t[6] - t[9] | 0, R0 = c[2], X = c[1], s0 = Hv(t[3]);
                          if (s0) {
                            var hr = s0[1][1], Ar = hr[1];
                            if (Ar) for (var or = hr[1], W0 = Ar[1]; ; ) {
                              if (or) {
                                var Lr = or[1], Tr = or[2];
                                if (!(b <= Lr)) {
                                  var or = Tr;
                                  continue;
                                }
                                var Hr = Lr;
                              } else var Hr = W0;
                              var Or = Hr;
                              break;
                            }
                            else var Or = b;
                            var fr = Or - b | 0;
                            0 <= fr ? El(t, [0, jo0, fr + X | 0, Ro0]) : Vv(t, [0, Mo0, Or + R0 | 0, Go0], t[6]);
                          }
                          break;
                        case 3:
                          var Rr = c[2], Wr = c[1];
                          if (t[8] < (t[6] - t[9] | 0)) {
                            var Jr = Hv(t[2]);
                            if (Jr) {
                              var ar = Jr[1], _r = ar[2], Ir = ar[1];
                              t[9] < _r && !(3 < (Ir - 1 | 0) >>> 0) && Oz(t, _r);
                            } else Dp(t);
                          }
                          var fe = t[9] - Wr | 0, v0 = Rr === 1 ? 1 : t[9] < G ? Rr : 5;
                          w1([0, v0, fe], t[2]);
                          break;
                        case 4:
                          w1(c[1], t[3]);
                          break;
                        default:
                          var P = c[1];
                          EN(t, u(t[24], P)), w1(P, t[5]);
                      }
                      t[12] = p + t[12] | 0;
                      continue;
                    }
                    throw Hre;
                  }
                  return T;
                }
                return 0;
              }
            }
            function Az(t, n) {
              return wl(t, n), Iz(t);
            }
            function Nz(t, n, e) {
              return Az(t, [0, n, [0, e], n]);
            }
            function SN(t) {
              return hl(t), w1([0, -1, [0, gz, Lo0, 0]], t);
            }
            function gN(t, n) {
              var e = Hv(t[1]);
              if (e) {
                var i = e[1], x = i[2], c = x[1];
                if (i[1] < t[12]) return SN(t[1]);
                var s = x[2];
                if (typeof s != "number") switch (s[0]) {
                  case 3:
                    var p = 1 - n, y = p && (x[1] = t[13] + c | 0, Uv(t[1]), 0);
                    return y;
                  case 1:
                  case 2:
                    var T = n && (x[1] = t[13] + c | 0, Uv(t[1]), 0);
                    return T;
                }
                return 0;
              }
              return 0;
            }
            function Cz(t, n, e) {
              return wl(t, e), n && gN(t, 1), w1([0, t[13], e], t[1]);
            }
            function Pz(t, n, e) {
              if (t[14] = t[14] + 1 | 0, t[14] < t[15]) return Cz(t, 0, [0, -t[13] | 0, [3, n, e], 0]);
              var i = t[14] === t[15] ? 1 : 0;
              if (i) {
                var x = t[16];
                return Nz(t, un(x), x);
              }
              return i;
            }
            function Dz(t, n) {
              var e = 1 < t[14] ? 1 : 0;
              if (e) {
                t[14] < t[15] && (wl(t, [0, Pp, 1, 0]), gN(t, 1), gN(t, 0)), t[14] = t[14] - 1 | 0;
                var i = 0;
              } else var i = e;
              return i;
            }
            function Lz(t, n) {
              t[23] && wl(t, [0, Pp, 5, 0]);
              var e = t[22];
              if (e) {
                var i = Uv(t[4]);
                if (i) return u(t[27], i[1]);
                var x = 0;
              } else var x = e;
              return x;
            }
            function FN(t, n) {
              var e = t[4];
              function i(x) {
                return Lz(t, 0);
              }
              for (Du(i, e[1]); ; ) {
                if (1 < t[14]) {
                  Dz(t, 0);
                  continue;
                }
                return t[13] = Fz, Iz(t), n && Dp(t), t[12] = 1, t[13] = 1, oN(t[28]), SN(t[1]), hl(t[2]), hl(t[3]), hl(t[4]), hl(t[5]), t[10] = 0, t[14] = 0, t[9] = t[6], Pz(t, 0, 3);
              }
            }
            function TN(t, n, e) {
              var i = t[14] < t[15] ? 1 : 0;
              return i && Nz(t, n, e);
            }
            function Rz(t, n, e) {
              return TN(t, n, e);
            }
            function g(t, n) {
              return Rz(t, un(n), n);
            }
            function Sl(t, n) {
              return Rz(t, 1, Tp(1, n));
            }
            function gl(t, n) {
              return FN(t, 0), u(t[18], 0);
            }
            var jz = Tp(80, 32);
            function Gz(t, n) {
              for (var e = n; ; ) {
                var i = 0 < e ? 1 : 0;
                if (i) {
                  if (80 < e) {
                    ur(t[17], jz, 0, 80);
                    var e = e + eX | 0;
                    continue;
                  }
                  return ur(t[17], jz, 0, e);
                }
                return i;
              }
            }
            function tee(t) {
              return t[1] === wN ? Te(Oo0, Te(t[2], To0)) : Io0;
            }
            function uee(t) {
              return t[1] === wN ? Te(go0, Te(t[2], So0)) : Fo0;
            }
            function iee(t) {
              return 0;
            }
            function fee(t) {
              return 0;
            }
            function Mz(t, n) {
              function e(w) {
                return 0;
              }
              function i(w) {
                return 0;
              }
              function x(w) {
                return 0;
              }
              var c = mz(0), s = [0, gz, wo0, 0];
              aN(s, c);
              var p = yl(0);
              SN(p), w1([0, 1, s], p);
              var y = yl(0), T = yl(0), E = yl(0), d = [0, p, yl(0), E, T, y, 78, 10, 68, 78, 0, 1, 1, 1, 1, jre, Eo0, t, n, x, i, e, 0, 0, tee, uee, iee, fee, c];
              return d[19] = function(w) {
                return ur(d[17], Ao0, 0, 1);
              }, d[20] = function(w) {
                return Gz(d, w);
              }, d[21] = function(w) {
                return Gz(d, w);
              }, d;
            }
            function Bz(t) {
              function n(e) {
                return p1(t);
              }
              return Mz(function(e, i, x) {
                return 0 <= i && 0 <= x && !((un(e) - x | 0) < i) ? zA(t, e, i, x) : Pu(ti0);
              }, n);
            }
            function ON(t) {
              function n(e) {
                return 0;
              }
              return Mz(function(e, i, x) {
                return _z(t, e, i, x);
              }, n);
            }
            var xee = II;
            function qz(t) {
              return $n(xee);
            }
            var oee = qz(0), aee = Bz(Mre), cee = Bz(Pc);
            ON(oee);
            function Uz(t, n) {
              var e = $n(16), i = ON(e);
              o(t, i, n), gl(i, 0);
              var x = e[2];
              if (2 <= x) {
                var c = x - 2 | 0, s = 1;
                return 0 <= c && !((e[2] - c | 0) < 1) ? qv(e[1], s, c) : Pu(Ri0);
              }
              return Mt(e);
            }
            function X7(t, n) {
              var e = 0;
              if (typeof n == "number") return 0;
              switch (n[0]) {
                case 0:
                  var i = n[2];
                  if (X7(t, n[1]), typeof i == "number") switch (i) {
                    case 0:
                      return Dz(t, 0);
                    case 1:
                      return Lz(t, 0);
                    case 2:
                      return gl(t, 0);
                    case 3:
                      var x = t[14] < t[15] ? 1 : 0;
                      return x && Az(t, [0, Pp, 3, 0]);
                    case 4:
                      return FN(t, 1), u(t[18], 0);
                    case 5:
                      return Sl(t, 64);
                    default:
                      return Sl(t, 37);
                  }
                  else switch (i[0]) {
                    case 0:
                      var c = [0, Do0, i[2], Po0], s = t[14] < t[15] ? 1 : 0, p = [0, Co0, i[3], No0], y = c[3], T = c[2], E = c[1];
                      return s && Cz(t, 1, [0, -t[13] | 0, [1, c, p], (un(E) + T | 0) + un(y) | 0]);
                    case 1:
                      return 0;
                    default:
                      var d = i[1];
                      return Sl(t, 64), Sl(t, d);
                  }
                case 1:
                  var w = n[2], G = n[1];
                  if (w[0] === 0) {
                    var A = w[1];
                    X7(t, G);
                    var S = [0, wN, Uz(X7, A)];
                    t[22] && (w1(S, t[4]), u(t[26], S));
                    var M = t[23];
                    return M && wl(t, [0, Pp, [5, S], 0]);
                  }
                  var K = w[1];
                  X7(t, G);
                  var V = Qre(Uz(X7, K));
                  return Pz(t, V[1], V[2]);
                case 2:
                  var f0 = n[1], m0 = 0;
                  if (typeof f0 != "number" && f0[0] === 0) {
                    var k0 = f0[2], g0 = 0;
                    if (typeof k0 != "number" && k0[0] === 1) {
                      var e0 = n[2], x0 = k0[2], l = f0[1];
                      m0 = 1, g0 = 1;
                    }
                  }
                  if (!m0) {
                    var c0 = n[2], t0 = f0;
                    e = 2;
                  }
                  break;
                case 3:
                  var o0 = n[1], w0 = 0;
                  if (typeof o0 != "number" && o0[0] === 0) {
                    var _0 = o0[2], E0 = 0;
                    if (typeof _0 != "number" && _0[0] === 1) {
                      var U0 = n[2], b = _0[2], R0 = o0[1];
                      e = 1, w0 = 1, E0 = 1;
                    }
                  }
                  if (!w0) {
                    var X = n[2], s0 = o0;
                    e = 3;
                  }
                  break;
                case 4:
                  var hr = n[1], Ar = 0;
                  if (typeof hr != "number" && hr[0] === 0) {
                    var or = hr[2], W0 = 0;
                    if (typeof or != "number" && or[0] === 1) {
                      var e0 = n[2], x0 = or[2], l = hr[1];
                      Ar = 1, W0 = 1;
                    }
                  }
                  if (!Ar) {
                    var c0 = n[2], t0 = hr;
                    e = 2;
                  }
                  break;
                case 5:
                  var Lr = n[1], Tr = 0;
                  if (typeof Lr == "number" || Lr[0] !== 0) Tr = 1;
                  else {
                    var Hr = Lr[2], Or = 0;
                    if (typeof Hr != "number" && Hr[0] === 1) {
                      var U0 = n[2], b = Hr[2], R0 = Lr[1];
                      e = 1, Or = 1;
                    }
                    Or || (Tr = 1);
                  }
                  if (Tr) {
                    var X = n[2], s0 = Lr;
                    e = 3;
                  }
                  break;
                case 6:
                  var fr = n[2];
                  return X7(t, n[1]), u(fr, t);
                case 7:
                  return X7(t, n[1]), gl(t, 0);
                default:
                  var Rr = n[2];
                  return X7(t, n[1]), Pu(Rr);
              }
              switch (e) {
                case 0:
                  return X7(t, l), TN(t, x0, e0);
                case 1:
                  return X7(t, R0), TN(t, b, Tp(1, U0));
                case 2:
                  return X7(t, t0), g(t, c0);
                default:
                  return X7(t, s0), Sl(t, X);
              }
            }
            function f(t) {
              return function(n) {
                var e = n[1], i = 0;
                return Xn(function(x) {
                  return X7(t, x), 0;
                }, i, e);
              };
            }
            function C0(t) {
              var n = t[1], e = qz(0), i = ON(e);
              return Xn(function(x) {
                X7(i, x), FN(i, 0);
                var c = Mt(e);
                return e[2] = 0, e[1] = e[4], e[3] = b7(e[1]), c;
              }, 0, n);
            }
            fz(function(t) {
              return gl(aee, 0), gl(cee, 0);
            });
            function see(t, n) {
              var e = h1(n) === wt ? n : n[1];
              return WA(t, e);
            }
            var vee = 2;
            function lee(t) {
              var n = [0, 0], e = un(t) - 1 | 0, i = 0;
              if (!(e < 0)) for (var x = i; ; ) {
                var c = It(t, x);
                n[1] = (y8 * n[1] | 0) + c | 0;
                var s = x + 1 | 0;
                if (e !== x) {
                  var x = s;
                  continue;
                }
                break;
              }
              n[1] = n[1] & mH;
              var p = 1073741823 < n[1] ? n[1] + 2147483648 | 0 : n[1];
              return p;
            }
            var bs = xN([0, Ee]), E1 = xN([0, Ee]), Is = xN([0, Ac]), Hz = KA(0, 0), bee = [0, 0];
            function Xz(t) {
              return 2 < t ? Xz((t + 1 | 0) / 2 | 0) * 2 | 0 : t;
            }
            function Yz(t) {
              bee[1]++;
              var n = t.length - 1, e = Gv((n * 2 | 0) + 2 | 0, Hz);
              tu(e, 0)[1] = n;
              var i = ((Xz(n) * 32 | 0) / 8 | 0) - 1 | 0;
              tu(e, 1)[2] = i;
              var x = n - 1 | 0, c = 0;
              if (!(x < 0)) for (var s = c; ; ) {
                var p = (s * 2 | 0) + 3 | 0, y = tu(t, s)[1 + s];
                tu(e, p)[1 + p] = y;
                var T = s + 1 | 0;
                if (x !== s) {
                  var s = T;
                  continue;
                }
                break;
              }
              return [0, vee, e, E1[1], Is[1], 0, 0, bs[1], 0];
            }
            function IN(t, n) {
              var e = t[2].length - 1, i = e < n ? 1 : 0;
              if (i) {
                var x = Gv(n, Hz), c = t[2], s = 0;
                0 <= e && !((c.length - 1 - e | 0) < 0) && !((x.length - 1 - e | 0) < 0) && (Ku0(c, 0, x, 0, e), s = 1), s || Pu(di0), t[2] = x;
                var p = 0;
              } else var p = i;
              return p;
            }
            var Vz = [0, 0], pee = [0, 0];
            function AN(t) {
              var n = t[2].length - 1;
              return IN(t, n + 1 | 0), n;
            }
            function Fl(t, n) {
              try {
                var e = o(E1[28], n, t[3]);
                return e;
              } catch (x) {
                if (x = Et(x), x === Jt) {
                  var i = AN(t);
                  return t[3] = ur(E1[4], n, i, t[3]), t[4] = ur(Is[4], i, 1, t[4]), i;
                }
                throw x;
              }
            }
            function NN(t, n) {
              return Op(function(e) {
                return Fl(t, e);
              }, n);
            }
            function zz(t, n, e) {
              return pee[1]++, o(Is[28], n, t[4]) ? (IN(t, n + 1 | 0), tu(t[2], n)[1 + n] = e, 0) : (t[6] = [0, [0, n, e], t[6]], 0);
            }
            function mee(t, n) {
              try {
                var e = Ure(n, t[6]);
                return e;
              } catch (i) {
                if (i = Et(i), i === Jt) return tu(t[2], n)[1 + n];
                throw i;
              }
            }
            function CN(t) {
              if (t === 0) return 0;
              for (var n = t.length - 1 - 1 | 0, e = 0; ; ) {
                if (0 <= n) {
                  var i = [0, t[1 + n], e], n = n - 1 | 0, e = i;
                  continue;
                }
                return e;
              }
            }
            function _ee(t) {
              var n = t[1];
              return t[1] = n + 1 | 0, n;
            }
            function PN(t, n) {
              try {
                var e = o(bs[28], n, t[7]);
                return e;
              } catch (x) {
                if (x = Et(x), x === Jt) {
                  var i = _ee(t);
                  return n0(n, Xo0) && (t[7] = ur(bs[4], n, i, t[7])), i;
                }
                throw x;
              }
            }
            function DN(t) {
              return RV(t, 0) ? [0] : t;
            }
            function yee(t, n) {
              try {
                var e = o(bs[28], n, t[7]);
                return e;
              } catch (i) {
                throw i = Et(i), i === Jt ? [0, Sn, Ho0] : i;
              }
            }
            function LN(t, n, e, i, x, c) {
              var s = x[2], p = x[4], y = CN(n), T = CN(e), E = CN(i), d = d1(function(b) {
                return Fl(t, b);
              }, T), w = d1(function(b) {
                return Fl(t, b);
              }, E);
              t[5] = [0, [0, t[3], t[4], t[6], t[7], d, y], t[5]];
              var G = bs[1], A = t[7];
              function S(b, R0, X) {
                return fN(b, y) ? ur(bs[4], b, R0, X) : X;
              }
              t[7] = ur(bs[13], S, A, G);
              var M = [0, E1[1]], K = [0, Is[1]];
              cz(function(b, R0) {
                M[1] = ur(E1[4], b, R0, M[1]);
                var X = K[1];
                try {
                  var s0 = o(Is[28], R0, t[4]), hr = s0;
                } catch (Ar) {
                  if (Ar = Et(Ar), Ar !== Jt) throw Ar;
                  var hr = 1;
                }
                return K[1] = ur(Is[4], R0, hr, X), 0;
              }, E, w), cz(function(b, R0) {
                return M[1] = ur(E1[4], b, R0, M[1]), K[1] = ur(Is[4], R0, 0, K[1]), 0;
              }, T, d), t[3] = M[1], t[4] = K[1];
              var V = 0, f0 = t[6];
              t[6] = iN(function(b, R0) {
                return fN(b[1], d) ? R0 : [0, b, R0];
              }, f0, V);
              var m0 = c ? o(s, t, p) : u(s, t), k0 = bl(t[5]), g0 = k0[6], e0 = k0[5], x0 = k0[4], l = k0[3], c0 = k0[2], t0 = k0[1];
              t[5] = az(t[5]), t[7] = le(function(b, R0) {
                var X = o(bs[28], R0, t[7]);
                return ur(bs[4], R0, X, b);
              }, x0, g0), t[3] = t0, t[4] = c0;
              var o0 = t[6];
              t[6] = iN(function(b, R0) {
                return fN(b[1], e0) ? R0 : [0, b, R0];
              }, o0, l);
              var w0 = 0, _0 = DN(i), E0 = [0, Op(function(b) {
                return mee(t, Fl(t, b));
              }, _0), w0], U0 = DN(n);
              return Wu0([0, [0, m0], [0, Op(function(b) {
                return yee(t, b);
              }, U0), E0]]);
            }
            function Rp(t, n) {
              if (t === 0) var e = Yz([0]);
              else {
                var i = Yz(Op(lee, t)), x = t.length - 1 - 1 | 0, c = 0;
                if (!(x < 0)) for (var s = c; ; ) {
                  var p = (s * 2 | 0) + 2 | 0;
                  i[3] = ur(E1[4], t[1 + s], p, i[3]), i[4] = ur(Is[4], p, 1, i[4]);
                  var y = s + 1 | 0;
                  if (x !== s) {
                    var s = y;
                    continue;
                  }
                  break;
                }
                var e = i;
              }
              var T = u(n, e);
              return Vz[1] = (Vz[1] + e[1] | 0) - 1 | 0, e[8] = ye(e[8]), IN(e, 3 + ((tu(e[2], 1)[2] * 16 | 0) / 32 | 0) | 0), [0, u(T, 0), n, T, 0];
            }
            function jp(t, n) {
              if (t) return t;
              var e = KA(wt, n[1]);
              return e[1] = n[2], H70(e);
            }
            function RN(t, n, e) {
              if (t) return n;
              var i = e[8];
              if (i !== 0) for (var x = i; ; ) {
                if (x) {
                  var c = x[2];
                  u(x[1], n);
                  var x = c;
                  continue;
                }
                break;
              }
              return n;
            }
            function Gp(t) {
              var n = AN(t), e = 0;
              if ((n % 2 | 0) !== 0 && !((2 + ((tu(t[2], 1)[2] * 16 | 0) / 32 | 0) | 0) < n)) {
                var i = AN(t);
                e = 1;
              }
              if (!e) var i = n;
              return tu(t[2], i)[1 + i] = 0, i;
            }
            function jN(t, n) {
              for (var e = [0, 0], i = n.length - 1; ; ) {
                if (e[1] < i) {
                  var x = e[1], c = tu(n, x)[1 + x], s = function(p0) {
                    e[1]++;
                    var b0 = e[1];
                    return tu(n, b0)[1 + b0];
                  }, p = s(0);
                  if (typeof p == "number") switch (p) {
                    case 0:
                      var y = s(0), Z = /* @__PURE__ */ function(b0) {
                        return function(O0) {
                          return b0;
                        };
                      }(y);
                      break;
                    case 1:
                      var T = s(0), Z = /* @__PURE__ */ function(b0) {
                        return function(O0) {
                          return O0[1 + b0];
                        };
                      }(T);
                      break;
                    case 2:
                      var E = s(0), d = s(0), Z = /* @__PURE__ */ function(b0, O0) {
                        return function(M0) {
                          return M0[1 + b0][1 + O0];
                        };
                      }(E, d);
                      break;
                    case 3:
                      var w = s(0), Z = /* @__PURE__ */ function(b0) {
                        return function(O0) {
                          return u(O0[1][1 + b0], O0);
                        };
                      }(w);
                      break;
                    case 4:
                      var G = s(0), Z = /* @__PURE__ */ function(b0) {
                        return function(O0, M0) {
                          return O0[1 + b0] = M0, 0;
                        };
                      }(G);
                      break;
                    case 5:
                      var A = s(0), S = s(0), Z = /* @__PURE__ */ function(b0, O0) {
                        return function(M0) {
                          return u(b0, O0);
                        };
                      }(A, S);
                      break;
                    case 6:
                      var M = s(0), K = s(0), Z = /* @__PURE__ */ function(b0, O0) {
                        return function(M0) {
                          return u(b0, M0[1 + O0]);
                        };
                      }(M, K);
                      break;
                    case 7:
                      var V = s(0), f0 = s(0), m0 = s(0), Z = /* @__PURE__ */ function(b0, O0, M0) {
                        return function(er) {
                          return u(b0, er[1 + O0][1 + M0]);
                        };
                      }(V, f0, m0);
                      break;
                    case 8:
                      var k0 = s(0), g0 = s(0), Z = /* @__PURE__ */ function(b0, O0) {
                        return function(M0) {
                          return u(b0, u(M0[1][1 + O0], M0));
                        };
                      }(k0, g0);
                      break;
                    case 9:
                      var e0 = s(0), x0 = s(0), l = s(0), Z = /* @__PURE__ */ function(b0, O0, M0) {
                        return function(er) {
                          return o(b0, O0, M0);
                        };
                      }(e0, x0, l);
                      break;
                    case 10:
                      var c0 = s(0), t0 = s(0), o0 = s(0), Z = /* @__PURE__ */ function(b0, O0, M0) {
                        return function(er) {
                          return o(b0, O0, er[1 + M0]);
                        };
                      }(c0, t0, o0);
                      break;
                    case 11:
                      var w0 = s(0), _0 = s(0), E0 = s(0), U0 = s(0), Z = /* @__PURE__ */ function(b0, O0, M0, er) {
                        return function(yr) {
                          return o(b0, O0, yr[1 + M0][1 + er]);
                        };
                      }(w0, _0, E0, U0);
                      break;
                    case 12:
                      var b = s(0), R0 = s(0), X = s(0), Z = /* @__PURE__ */ function(b0, O0, M0) {
                        return function(er) {
                          return o(b0, O0, u(er[1][1 + M0], er));
                        };
                      }(b, R0, X);
                      break;
                    case 13:
                      var s0 = s(0), hr = s(0), Ar = s(0), Z = /* @__PURE__ */ function(b0, O0, M0) {
                        return function(er) {
                          return o(b0, er[1 + O0], M0);
                        };
                      }(s0, hr, Ar);
                      break;
                    case 14:
                      var or = s(0), W0 = s(0), Lr = s(0), Tr = s(0), Z = /* @__PURE__ */ function(b0, O0, M0, er) {
                        return function(yr) {
                          return o(b0, yr[1 + O0][1 + M0], er);
                        };
                      }(or, W0, Lr, Tr);
                      break;
                    case 15:
                      var Hr = s(0), Or = s(0), fr = s(0), Z = /* @__PURE__ */ function(b0, O0, M0) {
                        return function(er) {
                          return o(b0, u(er[1][1 + O0], er), M0);
                        };
                      }(Hr, Or, fr);
                      break;
                    case 16:
                      var Rr = s(0), Wr = s(0), Z = /* @__PURE__ */ function(b0, O0) {
                        return function(M0) {
                          return o(M0[1][1 + b0], M0, O0);
                        };
                      }(Rr, Wr);
                      break;
                    case 17:
                      var Jr = s(0), ar = s(0), Z = /* @__PURE__ */ function(b0, O0) {
                        return function(M0) {
                          return o(M0[1][1 + b0], M0, M0[1 + O0]);
                        };
                      }(Jr, ar);
                      break;
                    case 18:
                      var _r = s(0), Ir = s(0), fe = s(0), Z = /* @__PURE__ */ function(b0, O0, M0) {
                        return function(er) {
                          return o(er[1][1 + b0], er, er[1 + O0][1 + M0]);
                        };
                      }(_r, Ir, fe);
                      break;
                    case 19:
                      var v0 = s(0), P = s(0), Z = /* @__PURE__ */ function(b0, O0) {
                        return function(M0) {
                          var er = u(M0[1][1 + O0], M0);
                          return o(M0[1][1 + b0], M0, er);
                        };
                      }(v0, P);
                      break;
                    case 20:
                      var L = s(0), Q = s(0);
                      Gp(t);
                      var Z = /* @__PURE__ */ function(b0, O0) {
                        return function(M0) {
                          return u(Qe(O0, b0, 0), O0);
                        };
                      }(L, Q);
                      break;
                    case 21:
                      var i0 = s(0), l0 = s(0);
                      Gp(t);
                      var Z = /* @__PURE__ */ function(b0, O0) {
                        return function(M0) {
                          var er = M0[1 + O0];
                          return u(Qe(er, b0, 0), er);
                        };
                      }(i0, l0);
                      break;
                    case 22:
                      var S0 = s(0), T0 = s(0), rr = s(0);
                      Gp(t);
                      var Z = /* @__PURE__ */ function(b0, O0, M0) {
                        return function(er) {
                          var yr = er[1 + O0][1 + M0];
                          return u(Qe(yr, b0, 0), yr);
                        };
                      }(S0, T0, rr);
                      break;
                    default:
                      var L0 = s(0), B = s(0);
                      Gp(t);
                      var Z = /* @__PURE__ */ function(b0, O0) {
                        return function(M0) {
                          var er = u(M0[1][1 + O0], M0);
                          return u(Qe(er, b0, 0), er);
                        };
                      }(L0, B);
                  }
                  else var Z = p;
                  zz(t, c, Z), e[1]++;
                  continue;
                }
                return 0;
              }
            }
            function Kz(t, n) {
              var e = n.length - 1, i = KA(0, e), x = e - 1 | 0, c = 0;
              if (!(x < 0)) for (var s = c; ; ) {
                var p = tu(n, s)[1 + s];
                if (typeof p == "number") switch (p) {
                  case 0:
                    var E = /* @__PURE__ */ function(G) {
                      function A(S) {
                        var M = i[1 + G];
                        if (A === M) throw [0, sl, t];
                        return u(M, S);
                      }
                      return A;
                    }(s);
                    break;
                  case 1:
                    var y = [];
                    N(y, [$2, /* @__PURE__ */ function(G, A) {
                      return function(S) {
                        var M = i[1 + A];
                        if (G === M) throw [0, sl, t];
                        var K = h1(M);
                        return nl === K ? M[1] : $2 === K ? Vre(M) : M;
                      };
                    }(y, s)]);
                    var E = y;
                    break;
                  default:
                    var T = function(G) {
                      throw [0, sl, t];
                    }, E = [0, T, T, T, 0];
                }
                else var E = p[0] === 0 ? Kz(t, p[1]) : p[1];
                i[1 + s] = E;
                var d = s + 1 | 0;
                if (x !== s) {
                  var s = d;
                  continue;
                }
                break;
              }
              return i;
            }
            function pu(t, n) {
              return typeof n != "number" && n[0] === 0 ? Kz(t, n[1]) : ke(Ko0);
            }
            function Wz(t, n, e) {
              if (h1(e) === 0 && t.length - 1 <= e.length - 1) {
                var i = t.length - 1 - 1 | 0, x = 0;
                if (!(i < 0)) for (var c = x; ; ) {
                  var s = e[1 + c], p = tu(t, c)[1 + c];
                  if (typeof p == "number") if (p === 2) {
                    var y = 0;
                    if (h1(s) === 0 && s.length - 1 === 4) for (var T = 0, E = n[1 + c]; ; ) {
                      E[1 + T] = s[1 + T];
                      var d = T + 1 | 0;
                      if (T !== 3) {
                        var T = d;
                        continue;
                      }
                      break;
                    }
                    else y = 1;
                    if (y) throw [0, Sn, Yo0];
                  } else n[1 + c] = s;
                  else p[0] === 0 && Wz(p[1], n[1 + c], s);
                  var w = c + 1 | 0;
                  if (i !== c) {
                    var c = w;
                    continue;
                  }
                  break;
                }
                return 0;
              }
              throw [0, Sn, Vo0];
            }
            function mu(t, n, e) {
              return typeof t != "number" && t[0] === 0 ? Wz(t[1], n, e) : ke(zo0);
            }
            try {
              WV(Wo0);
            } catch (t) {
              if (t = Et(t), t !== Jt) throw t;
            }
            try {
              WV(Jo0);
            } catch (t) {
              if (t = Et(t), t !== Jt) throw t;
            }
            n0(oz, $o0) && n0(oz, Zo0);
            function S1(t, n) {
              function e(i) {
                return qi(t, i);
              }
              return fw <= n ? (e(s1 | n >>> 18 | 0), e(jt | (n >>> 12 | 0) & 63), e(jt | (n >>> 6 | 0) & 63), e(jt | n & 63)) : Hh <= n ? (e(hv | n >>> 12 | 0), e(jt | (n >>> 6 | 0) & 63), e(jt | n & 63)) : jt <= n ? (e(rt | n >>> 6 | 0), e(jt | n & 63)) : e(n);
            }
            var GN = z0, i7 = null, Jz = void 0;
            function Mp(t) {
              return t !== Jz ? 1 : 0;
            }
            var hee = GN.Array, MN = [wt, ra0, M7(0)], dee = GN.Error;
            see(ea0, [0, MN, {}]);
            function $z(t) {
              throw t;
            }
            Sz(function(t) {
              return t[1] === MN ? [0, B7(t[2].toString())] : 0;
            }), Sz(function(t) {
              return t instanceof hee ? 0 : [0, B7(t.toString())];
            });
            var Dr = pu(e3r, r3r), Rn = pu(t3r, n3r), Bp = pu(i3r, u3r), Tl = pu(x3r, f3r), g1 = pu(a3r, o3r), BN = pu(s3r, c3r), Zz = pu(l3r, v3r), qN = pu(p3r, b3r), zv = pu(_3r, m3r), qp = pu(h3r, y3r), $e = pu(k3r, d3r), Yu = pu(E3r, w3r), qe = pu(g3r, S3r), UN = pu(T3r, F3r), di = pu(I3r, O3r), iu = pu(N3r, A3r), F1 = pu(P3r, C3r), As = pu(L3r, D3r), HN = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, Qz = function t(n, e, i) {
              return t.fun(n, e, i);
            }, kee = pu(j3r, R3r);
            N(HN, function(t, n, e, i) {
              u(f(e), j8r), o(f(e), M8r, G8r);
              var x = i[1];
              u(f(e), B8r);
              var c = 0;
              le(function(y, T) {
                y && u(f(e), R8r);
                function E(d) {
                  return u(t, d);
                }
                return ur(iu[1], E, e, T), 1;
              }, c, x), u(f(e), q8r), u(f(e), U8r), u(f(e), H8r), o(f(e), Y8r, X8r);
              var s = i[2];
              u(f(e), V8r);
              var p = 0;
              return le(function(y, T) {
                y && u(f(e), L8r);
                function E(d) {
                  return u(t, d);
                }
                return ur(iu[1], E, e, T), 1;
              }, p, s), u(f(e), z8r), u(f(e), K8r), u(f(e), W8r), o(f(e), $8r, J8r), o(n, e, i[3]), u(f(e), Z8r), u(f(e), Q8r);
            }), N(Qz, function(t, n, e) {
              var i = o(HN, t, n);
              return o(C0(D8r), i, e);
            }), mu(G3r, Dr, [0, HN, Qz]);
            var XN = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, rK = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Up = function t(n, e, i) {
              return t.fun(n, e, i);
            }, eK = function t(n, e) {
              return t.fun(n, e);
            };
            N(XN, function(t, n, e, i) {
              u(f(e), N8r), o(n, e, i[1]), u(f(e), C8r);
              var x = i[2];
              return ur(Up, function(c) {
                return u(t, c);
              }, e, x), u(f(e), P8r);
            }), N(rK, function(t, n, e) {
              var i = o(XN, t, n);
              return o(C0(A8r), i, e);
            }), N(Up, function(t, n, e) {
              u(f(n), _8r), o(f(n), h8r, y8r);
              var i = e[1];
              o(f(n), d8r, i), u(f(n), k8r), u(f(n), w8r), o(f(n), S8r, E8r);
              var x = e[2];
              if (x) {
                g(n, g8r);
                var c = x[1], s = function(y, T) {
                  return g(y, m8r);
                }, p = function(y) {
                  return u(t, y);
                };
                R(Dr[1], p, s, n, c), g(n, F8r);
              } else g(n, T8r);
              return u(f(n), O8r), u(f(n), I8r);
            }), N(eK, function(t, n) {
              var e = u(Up, t);
              return o(C0(p8r), e, n);
            }), mu(M3r, Rn, [0, XN, rK, Up, eK]);
            var YN = function t(n, e, i) {
              return t.fun(n, e, i);
            }, nK = function t(n, e) {
              return t.fun(n, e);
            }, Hp = function t(n, e, i) {
              return t.fun(n, e, i);
            }, tK = function t(n, e) {
              return t.fun(n, e);
            };
            N(YN, function(t, n, e) {
              u(f(n), v8r), o(t, n, e[1]), u(f(n), l8r);
              var i = e[2];
              return ur(Hp, function(x) {
                return u(t, x);
              }, n, i), u(f(n), b8r);
            }), N(nK, function(t, n) {
              var e = u(YN, t);
              return o(C0(s8r), e, n);
            }), N(Hp, function(t, n, e) {
              u(f(n), Z4r), o(f(n), r8r, Q4r);
              var i = e[1];
              o(f(n), e8r, i), u(f(n), n8r), u(f(n), t8r), o(f(n), i8r, u8r);
              var x = e[2];
              if (x) {
                g(n, f8r);
                var c = x[1], s = function(y, T) {
                  return g(y, $4r);
                }, p = function(y) {
                  return u(t, y);
                };
                R(Dr[1], p, s, n, c), g(n, x8r);
              } else g(n, o8r);
              return u(f(n), a8r), u(f(n), c8r);
            }), N(tK, function(t, n) {
              var e = u(Hp, t);
              return o(C0(J4r), e, n);
            }), mu(B3r, Bp, [0, YN, nK, Hp, tK]);
            function uK(t, n) {
              u(f(t), G4r), o(f(t), B4r, M4r);
              var e = n[1];
              o(f(t), q4r, e), u(f(t), U4r), u(f(t), H4r), o(f(t), Y4r, X4r);
              var i = n[2];
              return o(f(t), V4r, i), u(f(t), z4r), u(f(t), K4r);
            }
            var iK = [0, uK, function(t) {
              return o(C0(W4r), uK, t);
            }], VN = function t(n, e, i) {
              return t.fun(n, e, i);
            }, fK = function t(n, e) {
              return t.fun(n, e);
            }, Xp = function t(n, e) {
              return t.fun(n, e);
            }, xK = function t(n) {
              return t.fun(n);
            };
            N(VN, function(t, n, e) {
              u(f(n), k4r), o(f(n), E4r, w4r), o(Xp, n, e[1]), u(f(n), S4r), u(f(n), g4r), o(f(n), T4r, F4r);
              var i = e[2];
              o(f(n), O4r, i), u(f(n), I4r), u(f(n), A4r), o(f(n), C4r, N4r);
              var x = e[3];
              if (x) {
                g(n, P4r);
                var c = x[1], s = function(y, T) {
                  return g(y, d4r);
                }, p = function(y) {
                  return u(t, y);
                };
                R(Dr[1], p, s, n, c), g(n, D4r);
              } else g(n, L4r);
              return u(f(n), R4r), u(f(n), j4r);
            }), N(fK, function(t, n) {
              var e = u(VN, t);
              return o(C0(h4r), e, n);
            }), N(Xp, function(t, n) {
              if (typeof n == "number") return g(t, u4r);
              switch (n[0]) {
                case 0:
                  u(f(t), i4r);
                  var e = n[1];
                  return o(f(t), f4r, e), u(f(t), x4r);
                case 1:
                  u(f(t), o4r);
                  var i = n[1];
                  return o(f(t), a4r, i), u(f(t), c4r);
                case 2:
                  u(f(t), s4r);
                  var x = n[1];
                  return o(f(t), v4r, x), u(f(t), l4r);
                case 3:
                  u(f(t), b4r);
                  var c = n[1];
                  return o(f(t), p4r, c), u(f(t), m4r);
                default:
                  return u(f(t), _4r), o(iK[1], t, n[1]), u(f(t), y4r);
              }
            }), N(xK, function(t) {
              return o(C0(t4r), Xp, t);
            }), mu(q3r, Tl, [0, iK, VN, fK, Xp, xK]);
            var zN = function t(n, e, i) {
              return t.fun(n, e, i);
            }, oK = function t(n, e) {
              return t.fun(n, e);
            };
            N(zN, function(t, n, e) {
              u(f(n), Mbr), o(f(n), qbr, Bbr);
              var i = e[1];
              o(f(n), Ubr, i), u(f(n), Hbr), u(f(n), Xbr), o(f(n), Vbr, Ybr);
              var x = e[2];
              o(f(n), zbr, x), u(f(n), Kbr), u(f(n), Wbr), o(f(n), $br, Jbr);
              var c = e[3];
              if (c) {
                g(n, Zbr);
                var s = c[1], p = function(T, E) {
                  return g(T, Gbr);
                }, y = function(T) {
                  return u(t, T);
                };
                R(Dr[1], y, p, n, s), g(n, Qbr);
              } else g(n, r4r);
              return u(f(n), e4r), u(f(n), n4r);
            }), N(oK, function(t, n) {
              var e = u(zN, t);
              return o(C0(jbr), e, n);
            }), mu(U3r, g1, [0, zN, oK]);
            var KN = function t(n, e, i) {
              return t.fun(n, e, i);
            }, aK = function t(n, e) {
              return t.fun(n, e);
            };
            N(KN, function(t, n, e) {
              u(f(n), hbr), o(f(n), kbr, dbr);
              var i = e[1];
              o(f(n), wbr, i), u(f(n), Ebr), u(f(n), Sbr), o(f(n), Fbr, gbr);
              var x = e[2];
              o(f(n), Tbr, x), u(f(n), Obr), u(f(n), Ibr), o(f(n), Nbr, Abr);
              var c = e[3];
              if (c) {
                g(n, Cbr);
                var s = c[1], p = function(T, E) {
                  return g(T, ybr);
                }, y = function(T) {
                  return u(t, T);
                };
                R(Dr[1], y, p, n, s), g(n, Pbr);
              } else g(n, Dbr);
              return u(f(n), Lbr), u(f(n), Rbr);
            }), N(aK, function(t, n) {
              var e = u(KN, t);
              return o(C0(_br), e, n);
            }), mu(H3r, BN, [0, KN, aK]);
            var WN = function t(n, e, i) {
              return t.fun(n, e, i);
            }, cK = function t(n, e) {
              return t.fun(n, e);
            };
            N(WN, function(t, n, e) {
              u(f(n), Qlr), o(f(n), ebr, rbr);
              var i = e[1];
              o(f(n), nbr, i), u(f(n), tbr), u(f(n), ubr), o(f(n), fbr, ibr);
              var x = e[2];
              o(f(n), xbr, x), u(f(n), obr), u(f(n), abr), o(f(n), sbr, cbr);
              var c = e[3];
              if (c) {
                g(n, vbr);
                var s = c[1], p = function(T, E) {
                  return g(T, Zlr);
                }, y = function(T) {
                  return u(t, T);
                };
                R(Dr[1], y, p, n, s), g(n, lbr);
              } else g(n, bbr);
              return u(f(n), pbr), u(f(n), mbr);
            }), N(cK, function(t, n) {
              var e = u(WN, t);
              return o(C0($lr), e, n);
            }), mu(X3r, Zz, [0, WN, cK]);
            var JN = function t(n, e, i) {
              return t.fun(n, e, i);
            }, sK = function t(n, e) {
              return t.fun(n, e);
            };
            N(JN, function(t, n, e) {
              u(f(n), Glr), o(f(n), Blr, Mlr);
              var i = e[1];
              o(f(n), qlr, i), u(f(n), Ulr), u(f(n), Hlr), o(f(n), Ylr, Xlr);
              var x = e[2];
              if (x) {
                g(n, Vlr);
                var c = x[1], s = function(y, T) {
                  return g(y, jlr);
                }, p = function(y) {
                  return u(t, y);
                };
                R(Dr[1], p, s, n, c), g(n, zlr);
              } else g(n, Klr);
              return u(f(n), Wlr), u(f(n), Jlr);
            }), N(sK, function(t, n) {
              var e = u(JN, t);
              return o(C0(Rlr), e, n);
            }), mu(Y3r, qN, [0, JN, sK]);
            var $N = function t(n, e, i) {
              return t.fun(n, e, i);
            }, vK = function t(n, e) {
              return t.fun(n, e);
            }, Yp = function t(n, e) {
              return t.fun(n, e);
            }, lK = function t(n) {
              return t.fun(n);
            }, Vp = function t(n, e, i) {
              return t.fun(n, e, i);
            }, bK = function t(n, e) {
              return t.fun(n, e);
            };
            N($N, function(t, n, e) {
              u(f(n), Plr), o(t, n, e[1]), u(f(n), Dlr);
              var i = e[2];
              return ur(Vp, function(x) {
                return u(t, x);
              }, n, i), u(f(n), Llr);
            }), N(vK, function(t, n) {
              var e = u($N, t);
              return o(C0(Clr), e, n);
            }), N(Yp, function(t, n) {
              return n ? g(t, Alr) : g(t, Nlr);
            }), N(lK, function(t) {
              return o(C0(Ilr), Yp, t);
            }), N(Vp, function(t, n, e) {
              u(f(n), _lr), o(f(n), hlr, ylr), o(Yp, n, e[1]), u(f(n), dlr), u(f(n), klr), o(f(n), Elr, wlr);
              var i = e[2];
              if (i) {
                g(n, Slr);
                var x = i[1], c = function(p, y) {
                  return g(p, mlr);
                }, s = function(p) {
                  return u(t, p);
                };
                R(Dr[1], s, c, n, x), g(n, glr);
              } else g(n, Flr);
              return u(f(n), Tlr), u(f(n), Olr);
            }), N(bK, function(t, n) {
              var e = u(Vp, t);
              return o(C0(plr), e, n);
            }), mu(V3r, zv, [0, $N, vK, Yp, lK, Vp, bK]);
            var ZN = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, pK = function t(n, e, i) {
              return t.fun(n, e, i);
            }, QN = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, mK = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(ZN, function(t, n, e, i) {
              u(f(e), vlr), o(t, e, i[1]), u(f(e), llr);
              var x = i[2];
              function c(p) {
                return u(n, p);
              }
              function s(p) {
                return u(t, p);
              }
              return R(qp[3], s, c, e, x), u(f(e), blr);
            }), N(pK, function(t, n, e) {
              var i = o(ZN, t, n);
              return o(C0(slr), i, e);
            }), N(QN, function(t, n, e, i) {
              u(f(e), Q2r), o(f(e), elr, rlr);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(qe[31], s, c, e, x), u(f(e), nlr), u(f(e), tlr), o(f(e), ilr, ulr);
              var p = i[2];
              if (p) {
                g(e, flr);
                var y = p[1], T = function(d, w) {
                  return g(d, Z2r);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, xlr);
              } else g(e, olr);
              return u(f(e), alr), u(f(e), clr);
            }), N(mK, function(t, n, e) {
              var i = o(QN, t, n);
              return o(C0($2r), i, e);
            }), mu(z3r, qp, [0, ZN, pK, QN, mK]);
            var rC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, _K = function t(n, e, i) {
              return t.fun(n, e, i);
            }, zp = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, yK = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(rC, function(t, n, e, i) {
              u(f(e), K2r), o(t, e, i[1]), u(f(e), W2r);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(zp, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), J2r);
            }), N(_K, function(t, n, e) {
              var i = o(rC, t, n);
              return o(C0(z2r), i, e);
            }), N(zp, function(t, n, e, i) {
              u(f(e), A2r), o(f(e), C2r, N2r);
              var x = i[1];
              if (x) {
                g(e, P2r);
                var c = x[1], s = function(w) {
                  return u(n, w);
                }, p = function(w) {
                  return u(t, w);
                };
                R(Rn[1], p, s, e, c), g(e, D2r);
              } else g(e, L2r);
              u(f(e), R2r), u(f(e), j2r), o(f(e), M2r, G2r);
              var y = i[2];
              function T(w) {
                return u(n, w);
              }
              function E(w) {
                return u(t, w);
              }
              R($e[13], E, T, e, y), u(f(e), B2r), u(f(e), q2r), o(f(e), H2r, U2r);
              var d = i[3];
              return o(f(e), X2r, d), u(f(e), Y2r), u(f(e), V2r);
            }), N(yK, function(t, n, e) {
              var i = o(zp, t, n);
              return o(C0(I2r), i, e);
            });
            var eC = [0, rC, _K, zp, yK], nC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, hK = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Kp = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, dK = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(nC, function(t, n, e, i) {
              u(f(e), F2r), o(t, e, i[1]), u(f(e), T2r);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Kp, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), O2r);
            }), N(hK, function(t, n, e) {
              var i = o(nC, t, n);
              return o(C0(g2r), i, e);
            }), N(Kp, function(t, n, e, i) {
              u(f(e), l2r), o(f(e), p2r, b2r);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(eC[1], s, c, e, x), u(f(e), m2r), u(f(e), _2r), o(f(e), h2r, y2r);
              var p = i[2];
              if (p) {
                g(e, d2r);
                var y = p[1], T = function(d, w) {
                  return g(d, v2r);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, k2r);
              } else g(e, w2r);
              return u(f(e), E2r), u(f(e), S2r);
            }), N(dK, function(t, n, e) {
              var i = o(Kp, t, n);
              return o(C0(s2r), i, e);
            });
            var kK = [0, nC, hK, Kp, dK], tC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, wK = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Wp = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, EK = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(tC, function(t, n, e, i) {
              u(f(e), o2r), o(t, e, i[1]), u(f(e), a2r);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Wp, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), c2r);
            }), N(wK, function(t, n, e) {
              var i = o(tC, t, n);
              return o(C0(x2r), i, e);
            }), N(Wp, function(t, n, e, i) {
              u(f(e), Wvr), o(f(e), $vr, Jvr);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R($e[17], s, c, e, x), u(f(e), Zvr), u(f(e), Qvr), o(f(e), e2r, r2r);
              var p = i[2];
              if (p) {
                g(e, n2r);
                var y = p[1], T = function(d, w) {
                  return g(d, Kvr);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, t2r);
              } else g(e, u2r);
              return u(f(e), i2r), u(f(e), f2r);
            }), N(EK, function(t, n, e) {
              var i = o(Wp, t, n);
              return o(C0(zvr), i, e);
            });
            var SK = [0, tC, wK, Wp, EK], uC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, gK = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Jp = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, FK = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(uC, function(t, n, e, i) {
              u(f(e), Xvr), o(t, e, i[1]), u(f(e), Yvr);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Jp, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), Vvr);
            }), N(gK, function(t, n, e) {
              var i = o(uC, t, n);
              return o(C0(Hvr), i, e);
            }), N(Jp, function(t, n, e, i) {
              u(f(e), pvr), o(f(e), _vr, mvr);
              var x = i[1];
              if (x) {
                g(e, yvr);
                var c = x[1], s = function(V) {
                  return u(n, V);
                }, p = function(V) {
                  return u(t, V);
                };
                R(SK[1], p, s, e, c), g(e, hvr);
              } else g(e, dvr);
              u(f(e), kvr), u(f(e), wvr), o(f(e), Svr, Evr);
              var y = i[2];
              u(f(e), gvr);
              var T = 0;
              le(function(V, f0) {
                V && u(f(e), bvr);
                function m0(g0) {
                  return u(n, g0);
                }
                function k0(g0) {
                  return u(t, g0);
                }
                return R(eC[1], k0, m0, e, f0), 1;
              }, T, y), u(f(e), Fvr), u(f(e), Tvr), u(f(e), Ovr), o(f(e), Avr, Ivr);
              var E = i[3];
              if (E) {
                g(e, Nvr);
                var d = E[1], w = function(V) {
                  return u(n, V);
                }, G = function(V) {
                  return u(t, V);
                };
                R(kK[1], G, w, e, d), g(e, Cvr);
              } else g(e, Pvr);
              u(f(e), Dvr), u(f(e), Lvr), o(f(e), jvr, Rvr);
              var A = i[4];
              if (A) {
                g(e, Gvr);
                var S = A[1], M = function(V, f0) {
                  u(f(V), vvr);
                  var m0 = 0;
                  return le(function(k0, g0) {
                    k0 && u(f(V), svr);
                    function e0(x0) {
                      return u(t, x0);
                    }
                    return ur(iu[1], e0, V, g0), 1;
                  }, m0, f0), u(f(V), lvr);
                }, K = function(V) {
                  return u(t, V);
                };
                R(Dr[1], K, M, e, S), g(e, Mvr);
              } else g(e, Bvr);
              return u(f(e), qvr), u(f(e), Uvr);
            }), N(FK, function(t, n, e) {
              var i = o(Jp, t, n);
              return o(C0(cvr), i, e);
            });
            var TK = [0, uC, gK, Jp, FK], iC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, OK2 = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(iC, function(t, n, e, i) {
              u(f(e), q1r), o(f(e), H1r, U1r);
              var x = i[1];
              if (x) {
                g(e, X1r);
                var c = x[1], s = function(V) {
                  return u(n, V);
                }, p = function(V) {
                  return u(t, V);
                };
                R($e[22][1], p, s, e, c), g(e, Y1r);
              } else g(e, V1r);
              u(f(e), z1r), u(f(e), K1r), o(f(e), J1r, W1r);
              var y = i[2];
              function T(V) {
                return u(n, V);
              }
              function E(V) {
                return u(t, V);
              }
              R(TK[1], E, T, e, y), u(f(e), $1r), u(f(e), Z1r), o(f(e), rvr, Q1r);
              var d = i[3];
              function w(V) {
                return u(n, V);
              }
              function G(V) {
                return u(t, V);
              }
              R($e[13], G, w, e, d), u(f(e), evr), u(f(e), nvr), o(f(e), uvr, tvr);
              var A = i[4];
              if (A) {
                g(e, ivr);
                var S = A[1], M = function(V, f0) {
                  return g(V, B1r);
                }, K = function(V) {
                  return u(t, V);
                };
                R(Dr[1], K, M, e, S), g(e, fvr);
              } else g(e, xvr);
              return u(f(e), ovr), u(f(e), avr);
            }), N(OK2, function(t, n, e) {
              var i = o(iC, t, n);
              return o(C0(M1r), i, e);
            });
            var Ol = [0, eC, kK, SK, TK, iC, OK2], $p = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, IK = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Zp = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, AK = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Qp = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, NK = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N($p, function(t, n, e, i) {
              if (i[0] === 0) {
                u(f(e), L1r);
                var x = i[1], c = function(T) {
                  return u(n, T);
                }, s = function(T) {
                  return u(t, T);
                };
                return R(Rn[1], s, c, e, x), u(f(e), R1r);
              }
              u(f(e), j1r);
              var p = i[1];
              function y(T) {
                return u(n, T);
              }
              return R(Zp, function(T) {
                return u(t, T);
              }, y, e, p), u(f(e), G1r);
            }), N(IK, function(t, n, e) {
              var i = o($p, t, n);
              return o(C0(D1r), i, e);
            }), N(Zp, function(t, n, e, i) {
              u(f(e), N1r), o(t, e, i[1]), u(f(e), C1r);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Qp, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), P1r);
            }), N(AK, function(t, n, e) {
              var i = o(Zp, t, n);
              return o(C0(A1r), i, e);
            }), N(Qp, function(t, n, e, i) {
              u(f(e), k1r), o(f(e), E1r, w1r);
              var x = i[1];
              function c(T) {
                return u(n, T);
              }
              R($p, function(T) {
                return u(t, T);
              }, c, e, x), u(f(e), S1r), u(f(e), g1r), o(f(e), T1r, F1r);
              var s = i[2];
              function p(T) {
                return u(n, T);
              }
              function y(T) {
                return u(t, T);
              }
              return R(Rn[1], y, p, e, s), u(f(e), O1r), u(f(e), I1r);
            }), N(NK, function(t, n, e) {
              var i = o(Qp, t, n);
              return o(C0(d1r), i, e);
            });
            var CK = [0, $p, IK, Zp, AK, Qp, NK], fC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, PK = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(fC, function(t, n, e, i) {
              u(f(e), e1r), o(f(e), t1r, n1r);
              var x = i[1];
              function c(S) {
                return u(n, S);
              }
              function s(S) {
                return u(t, S);
              }
              R(CK[1], s, c, e, x), u(f(e), u1r), u(f(e), i1r), o(f(e), x1r, f1r);
              var p = i[2];
              if (p) {
                g(e, o1r);
                var y = p[1], T = function(S) {
                  return u(n, S);
                }, E = function(S) {
                  return u(t, S);
                };
                R($e[23][1], E, T, e, y), g(e, a1r);
              } else g(e, c1r);
              u(f(e), s1r), u(f(e), v1r), o(f(e), b1r, l1r);
              var d = i[3];
              if (d) {
                g(e, p1r);
                var w = d[1], G = function(S, M) {
                  return g(S, r1r);
                }, A = function(S) {
                  return u(t, S);
                };
                R(Dr[1], A, G, e, w), g(e, m1r);
              } else g(e, _1r);
              return u(f(e), y1r), u(f(e), h1r);
            }), N(PK, function(t, n, e) {
              var i = o(fC, t, n);
              return o(C0(Qsr), i, e);
            });
            var xC = [0, CK, fC, PK], oC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, DK = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(oC, function(t, n, e, i) {
              u(f(e), jsr), o(f(e), Msr, Gsr);
              var x = i[1];
              function c(A) {
                return u(n, A);
              }
              function s(A) {
                return u(t, A);
              }
              R($e[13], s, c, e, x), u(f(e), Bsr), u(f(e), qsr), o(f(e), Hsr, Usr);
              var p = i[2];
              function y(A) {
                return u(n, A);
              }
              function T(A) {
                return u(t, A);
              }
              R($e[13], T, y, e, p), u(f(e), Xsr), u(f(e), Ysr), o(f(e), zsr, Vsr);
              var E = i[3];
              if (E) {
                g(e, Ksr);
                var d = E[1], w = function(A, S) {
                  return g(A, Rsr);
                }, G = function(A) {
                  return u(t, A);
                };
                R(Dr[1], G, w, e, d), g(e, Wsr);
              } else g(e, Jsr);
              return u(f(e), $sr), u(f(e), Zsr);
            }), N(DK, function(t, n, e) {
              var i = o(oC, t, n);
              return o(C0(Lsr), i, e);
            });
            var aC = [0, oC, DK], cC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, LK = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(cC, function(t, n, e, i) {
              u(f(e), gsr), o(f(e), Tsr, Fsr);
              var x = i[1];
              function c(y) {
                return u(n, y);
              }
              function s(y) {
                return u(t, y);
              }
              R(aC[1], s, c, e, x), u(f(e), Osr), u(f(e), Isr), o(f(e), Nsr, Asr);
              var p = i[2];
              return o(f(e), Csr, p), u(f(e), Psr), u(f(e), Dsr);
            }), N(LK, function(t, n, e) {
              var i = o(cC, t, n);
              return o(C0(Ssr), i, e);
            });
            var RK = [0, cC, LK], sC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, jK = function t(n, e, i) {
              return t.fun(n, e, i);
            }, r5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, GK = function t(n, e, i) {
              return t.fun(n, e, i);
            }, e5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, MK = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(sC, function(t, n, e, i) {
              u(f(e), ksr), o(t, e, i[1]), u(f(e), wsr);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(r5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), Esr);
            }), N(jK, function(t, n, e) {
              var i = o(sC, t, n);
              return o(C0(dsr), i, e);
            }), N(r5, function(t, n, e, i) {
              u(f(e), Ncr), o(f(e), Pcr, Ccr);
              var x = i[1];
              function c(m0) {
                return u(n, m0);
              }
              function s(m0) {
                return u(t, m0);
              }
              R(qe[7][1][1], s, c, e, x), u(f(e), Dcr), u(f(e), Lcr), o(f(e), jcr, Rcr);
              var p = i[2];
              function y(m0) {
                return u(n, m0);
              }
              R(e5, function(m0) {
                return u(t, m0);
              }, y, e, p), u(f(e), Gcr), u(f(e), Mcr), o(f(e), qcr, Bcr);
              var T = i[3];
              o(f(e), Ucr, T), u(f(e), Hcr), u(f(e), Xcr), o(f(e), Vcr, Ycr);
              var E = i[4];
              o(f(e), zcr, E), u(f(e), Kcr), u(f(e), Wcr), o(f(e), $cr, Jcr);
              var d = i[5];
              o(f(e), Zcr, d), u(f(e), Qcr), u(f(e), rsr), o(f(e), nsr, esr);
              var w = i[6];
              o(f(e), tsr, w), u(f(e), usr), u(f(e), isr), o(f(e), xsr, fsr);
              var G = i[7];
              if (G) {
                g(e, osr);
                var A = G[1], S = function(m0) {
                  return u(t, m0);
                };
                ur(zv[1], S, e, A), g(e, asr);
              } else g(e, csr);
              u(f(e), ssr), u(f(e), vsr), o(f(e), bsr, lsr);
              var M = i[8];
              if (M) {
                g(e, psr);
                var K = M[1], V = function(m0, k0) {
                  return g(m0, Acr);
                }, f0 = function(m0) {
                  return u(t, m0);
                };
                R(Dr[1], f0, V, e, K), g(e, msr);
              } else g(e, _sr);
              return u(f(e), ysr), u(f(e), hsr);
            }), N(GK, function(t, n, e) {
              var i = o(r5, t, n);
              return o(C0(Icr), i, e);
            }), N(e5, function(t, n, e, i) {
              switch (i[0]) {
                case 0:
                  u(f(e), _cr);
                  var x = i[1], c = function(S) {
                    return u(n, S);
                  }, s = function(S) {
                    return u(t, S);
                  };
                  return R($e[13], s, c, e, x), u(f(e), ycr);
                case 1:
                  var p = i[1];
                  u(f(e), hcr), u(f(e), dcr), o(t, e, p[1]), u(f(e), kcr);
                  var y = p[2], T = function(S) {
                    return u(n, S);
                  }, E = function(S) {
                    return u(t, S);
                  };
                  return R(Ol[5], E, T, e, y), u(f(e), wcr), u(f(e), Ecr);
                default:
                  var d = i[1];
                  u(f(e), Scr), u(f(e), gcr), o(t, e, d[1]), u(f(e), Fcr);
                  var w = d[2], G = function(S) {
                    return u(n, S);
                  }, A = function(S) {
                    return u(t, S);
                  };
                  return R(Ol[5], A, G, e, w), u(f(e), Tcr), u(f(e), Ocr);
              }
            }), N(MK, function(t, n, e) {
              var i = o(e5, t, n);
              return o(C0(mcr), i, e);
            });
            var BK = [0, sC, jK, r5, GK, e5, MK], vC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, qK = function t(n, e, i) {
              return t.fun(n, e, i);
            }, n5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, UK = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(vC, function(t, n, e, i) {
              u(f(e), lcr), o(t, e, i[1]), u(f(e), bcr);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(n5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), pcr);
            }), N(qK, function(t, n, e) {
              var i = o(vC, t, n);
              return o(C0(vcr), i, e);
            }), N(n5, function(t, n, e, i) {
              u(f(e), rcr), o(f(e), ncr, ecr);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R($e[13], s, c, e, x), u(f(e), tcr), u(f(e), ucr), o(f(e), fcr, icr);
              var p = i[2];
              if (p) {
                g(e, xcr);
                var y = p[1], T = function(d, w) {
                  return g(d, Qar);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, ocr);
              } else g(e, acr);
              return u(f(e), ccr), u(f(e), scr);
            }), N(UK, function(t, n, e) {
              var i = o(n5, t, n);
              return o(C0(Zar), i, e);
            });
            var HK = [0, vC, qK, n5, UK], t5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, XK = function t(n, e, i) {
              return t.fun(n, e, i);
            }, lC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, YK = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(t5, function(t, n, e, i) {
              u(f(e), _ar), o(f(e), har, yar);
              var x = i[1];
              if (x) {
                g(e, dar);
                var c = x[1], s = function(g0) {
                  return u(t, g0);
                }, p = function(g0) {
                  return u(t, g0);
                };
                R(Rn[1], p, s, e, c), g(e, kar);
              } else g(e, war);
              u(f(e), Ear), u(f(e), Sar), o(f(e), Far, gar);
              var y = i[2];
              function T(g0) {
                return u(n, g0);
              }
              function E(g0) {
                return u(t, g0);
              }
              R($e[13], E, T, e, y), u(f(e), Tar), u(f(e), Oar), o(f(e), Aar, Iar);
              var d = i[3];
              function w(g0) {
                return u(n, g0);
              }
              function G(g0) {
                return u(t, g0);
              }
              R($e[13], G, w, e, d), u(f(e), Nar), u(f(e), Car), o(f(e), Dar, Par);
              var A = i[4];
              o(f(e), Lar, A), u(f(e), Rar), u(f(e), jar), o(f(e), Mar, Gar);
              var S = i[5];
              if (S) {
                g(e, Bar);
                var M = S[1], K = function(g0) {
                  return u(t, g0);
                };
                ur(zv[1], K, e, M), g(e, qar);
              } else g(e, Uar);
              u(f(e), Har), u(f(e), Xar), o(f(e), Var, Yar);
              var V = i[6];
              if (V) {
                g(e, zar);
                var f0 = V[1], m0 = function(g0, e0) {
                  return g(g0, mar);
                }, k0 = function(g0) {
                  return u(t, g0);
                };
                R(Dr[1], k0, m0, e, f0), g(e, Kar);
              } else g(e, War);
              return u(f(e), Jar), u(f(e), $ar);
            }), N(XK, function(t, n, e) {
              var i = o(t5, t, n);
              return o(C0(par), i, e);
            }), N(lC, function(t, n, e, i) {
              u(f(e), sar), o(t, e, i[1]), u(f(e), lar);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(t5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), bar);
            }), N(YK, function(t, n, e) {
              var i = o(lC, t, n);
              return o(C0(car), i, e);
            });
            var VK = [0, t5, XK, lC, YK], bC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, zK = function t(n, e, i) {
              return t.fun(n, e, i);
            }, u5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, KK = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(bC, function(t, n, e, i) {
              u(f(e), xar), o(t, e, i[1]), u(f(e), oar);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(u5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), aar);
            }), N(zK, function(t, n, e) {
              var i = o(bC, t, n);
              return o(C0(far), i, e);
            }), N(u5, function(t, n, e, i) {
              u(f(e), Bor), o(f(e), Uor, qor);
              var x = i[1];
              u(f(e), Hor), o(t, e, x[1]), u(f(e), Xor);
              var c = x[2];
              function s(G) {
                return u(n, G);
              }
              function p(G) {
                return u(t, G);
              }
              R(Ol[5], p, s, e, c), u(f(e), Yor), u(f(e), Vor), u(f(e), zor), o(f(e), Wor, Kor);
              var y = i[2];
              o(f(e), Jor, y), u(f(e), $or), u(f(e), Zor), o(f(e), rar, Qor);
              var T = i[3];
              if (T) {
                g(e, ear);
                var E = T[1], d = function(G, A) {
                  return g(G, Mor);
                }, w = function(G) {
                  return u(t, G);
                };
                R(Dr[1], w, d, e, E), g(e, nar);
              } else g(e, tar);
              return u(f(e), uar), u(f(e), iar);
            }), N(KK, function(t, n, e) {
              var i = o(u5, t, n);
              return o(C0(Gor), i, e);
            });
            var WK = [0, bC, zK, u5, KK], pC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, JK = function t(n, e, i) {
              return t.fun(n, e, i);
            }, i5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, $K = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(pC, function(t, n, e, i) {
              u(f(e), Lor), o(t, e, i[1]), u(f(e), Ror);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(i5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), jor);
            }), N(JK, function(t, n, e) {
              var i = o(pC, t, n);
              return o(C0(Dor), i, e);
            }), N(i5, function(t, n, e, i) {
              u(f(e), nor), o(f(e), uor, tor);
              var x = i[1];
              function c(K) {
                return u(t, K);
              }
              function s(K) {
                return u(t, K);
              }
              R(Rn[1], s, c, e, x), u(f(e), ior), u(f(e), xor), o(f(e), aor, oor);
              var p = i[2];
              function y(K) {
                return u(n, K);
              }
              function T(K) {
                return u(t, K);
              }
              R($e[13], T, y, e, p), u(f(e), cor), u(f(e), sor), o(f(e), lor, vor);
              var E = i[3];
              o(f(e), bor, E), u(f(e), por), u(f(e), mor), o(f(e), yor, _or);
              var d = i[4];
              o(f(e), hor, d), u(f(e), dor), u(f(e), kor), o(f(e), Eor, wor);
              var w = i[5];
              o(f(e), Sor, w), u(f(e), gor), u(f(e), For), o(f(e), Oor, Tor);
              var G = i[6];
              if (G) {
                g(e, Ior);
                var A = G[1], S = function(K, V) {
                  return g(K, eor);
                }, M = function(K) {
                  return u(t, K);
                };
                R(Dr[1], M, S, e, A), g(e, Aor);
              } else g(e, Nor);
              return u(f(e), Cor), u(f(e), Por);
            }), N($K, function(t, n, e) {
              var i = o(i5, t, n);
              return o(C0(ror), i, e);
            });
            var ZK = [0, pC, JK, i5, $K], mC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, QK = function t(n, e, i) {
              return t.fun(n, e, i);
            }, f5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, rW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(mC, function(t, n, e, i) {
              u(f(e), Axr), o(f(e), Cxr, Nxr);
              var x = i[1];
              o(f(e), Pxr, x), u(f(e), Dxr), u(f(e), Lxr), o(f(e), jxr, Rxr);
              var c = i[2];
              o(f(e), Gxr, c), u(f(e), Mxr), u(f(e), Bxr), o(f(e), Uxr, qxr);
              var s = i[3];
              u(f(e), Hxr);
              var p = 0;
              le(function(w, G) {
                w && u(f(e), Ixr);
                function A(S) {
                  return u(n, S);
                }
                return R(f5, function(S) {
                  return u(t, S);
                }, A, e, G), 1;
              }, p, s), u(f(e), Xxr), u(f(e), Yxr), u(f(e), Vxr), o(f(e), Kxr, zxr);
              var y = i[4];
              if (y) {
                g(e, Wxr);
                var T = y[1], E = function(w, G) {
                  u(f(w), Txr);
                  var A = 0;
                  return le(function(S, M) {
                    S && u(f(w), Fxr);
                    function K(V) {
                      return u(t, V);
                    }
                    return ur(iu[1], K, w, M), 1;
                  }, A, G), u(f(w), Oxr);
                }, d = function(w) {
                  return u(t, w);
                };
                R(Dr[1], d, E, e, T), g(e, Jxr);
              } else g(e, $xr);
              return u(f(e), Zxr), u(f(e), Qxr);
            }), N(QK, function(t, n, e) {
              var i = o(mC, t, n);
              return o(C0(gxr), i, e);
            }), N(f5, function(t, n, e, i) {
              switch (i[0]) {
                case 0:
                  u(f(e), pxr);
                  var x = i[1], c = function(f0) {
                    return u(n, f0);
                  }, s = function(f0) {
                    return u(t, f0);
                  };
                  return R(BK[1], s, c, e, x), u(f(e), mxr);
                case 1:
                  u(f(e), _xr);
                  var p = i[1], y = function(f0) {
                    return u(n, f0);
                  }, T = function(f0) {
                    return u(t, f0);
                  };
                  return R(HK[1], T, y, e, p), u(f(e), yxr);
                case 2:
                  u(f(e), hxr);
                  var E = i[1], d = function(f0) {
                    return u(n, f0);
                  }, w = function(f0) {
                    return u(t, f0);
                  };
                  return R(VK[3], w, d, e, E), u(f(e), dxr);
                case 3:
                  u(f(e), kxr);
                  var G = i[1], A = function(f0) {
                    return u(n, f0);
                  }, S = function(f0) {
                    return u(t, f0);
                  };
                  return R(WK[1], S, A, e, G), u(f(e), wxr);
                default:
                  u(f(e), Exr);
                  var M = i[1], K = function(f0) {
                    return u(n, f0);
                  }, V = function(f0) {
                    return u(t, f0);
                  };
                  return R(ZK[1], V, K, e, M), u(f(e), Sxr);
              }
            }), N(rW, function(t, n, e) {
              var i = o(f5, t, n);
              return o(C0(bxr), i, e);
            });
            var _C = [0, BK, HK, VK, WK, ZK, mC, QK, f5, rW], yC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, eW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(yC, function(t, n, e, i) {
              u(f(e), zfr), o(f(e), Wfr, Kfr);
              var x = i[1];
              u(f(e), Jfr), o(t, e, x[1]), u(f(e), $fr);
              var c = x[2];
              function s(A) {
                return u(n, A);
              }
              function p(A) {
                return u(t, A);
              }
              R(_C[6], p, s, e, c), u(f(e), Zfr), u(f(e), Qfr), u(f(e), rxr), o(f(e), nxr, exr);
              var y = i[2];
              u(f(e), txr);
              var T = 0;
              le(function(A, S) {
                A && u(f(e), Hfr), u(f(e), Xfr), o(t, e, S[1]), u(f(e), Yfr);
                var M = S[2];
                function K(f0) {
                  return u(n, f0);
                }
                function V(f0) {
                  return u(t, f0);
                }
                return R(xC[2], V, K, e, M), u(f(e), Vfr), 1;
              }, T, y), u(f(e), uxr), u(f(e), ixr), u(f(e), fxr), o(f(e), oxr, xxr);
              var E = i[3];
              if (E) {
                g(e, axr);
                var d = E[1], w = function(A, S) {
                  return g(A, Ufr);
                }, G = function(A) {
                  return u(t, A);
                };
                R(Dr[1], G, w, e, d), g(e, cxr);
              } else g(e, sxr);
              return u(f(e), vxr), u(f(e), lxr);
            }), N(eW, function(t, n, e) {
              var i = o(yC, t, n);
              return o(C0(qfr), i, e);
            });
            var nW = [0, yC, eW], hC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, tW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(hC, function(t, n, e, i) {
              u(f(e), Ifr), o(f(e), Nfr, Afr);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R($e[13], s, c, e, x), u(f(e), Cfr), u(f(e), Pfr), o(f(e), Lfr, Dfr);
              var p = i[2];
              if (p) {
                g(e, Rfr);
                var y = p[1], T = function(d, w) {
                  return g(d, Ofr);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, jfr);
              } else g(e, Gfr);
              return u(f(e), Mfr), u(f(e), Bfr);
            }), N(tW, function(t, n, e) {
              var i = o(hC, t, n);
              return o(C0(Tfr), i, e);
            });
            var uW = [0, hC, tW], x5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, iW = function t(n, e, i) {
              return t.fun(n, e, i);
            }, o5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, fW = function t(n, e, i) {
              return t.fun(n, e, i);
            }, a5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, xW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(x5, function(t, n, e, i) {
              if (i[0] === 0) {
                u(f(e), Efr);
                var x = i[1], c = function(T) {
                  return u(n, T);
                }, s = function(T) {
                  return u(t, T);
                };
                return R(Rn[1], s, c, e, x), u(f(e), Sfr);
              }
              u(f(e), gfr);
              var p = i[1];
              function y(T) {
                return u(n, T);
              }
              return R(a5, function(T) {
                return u(t, T);
              }, y, e, p), u(f(e), Ffr);
            }), N(iW, function(t, n, e) {
              var i = o(x5, t, n);
              return o(C0(wfr), i, e);
            }), N(o5, function(t, n, e, i) {
              u(f(e), lfr), o(f(e), pfr, bfr);
              var x = i[1];
              function c(T) {
                return u(n, T);
              }
              R(x5, function(T) {
                return u(t, T);
              }, c, e, x), u(f(e), mfr), u(f(e), _fr), o(f(e), hfr, yfr);
              var s = i[2];
              function p(T) {
                return u(n, T);
              }
              function y(T) {
                return u(t, T);
              }
              return R(Rn[1], y, p, e, s), u(f(e), dfr), u(f(e), kfr);
            }), N(fW, function(t, n, e) {
              var i = o(o5, t, n);
              return o(C0(vfr), i, e);
            }), N(a5, function(t, n, e, i) {
              u(f(e), afr), o(n, e, i[1]), u(f(e), cfr);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(o5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), sfr);
            }), N(xW, function(t, n, e) {
              var i = o(a5, t, n);
              return o(C0(ofr), i, e);
            });
            var oW = [0, x5, iW, o5, fW, a5, xW], dC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, aW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(dC, function(t, n, e, i) {
              u(f(e), Jir), o(f(e), Zir, $ir);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(oW[1], s, c, e, x), u(f(e), Qir), u(f(e), rfr), o(f(e), nfr, efr);
              var p = i[2];
              if (p) {
                g(e, tfr);
                var y = p[1], T = function(d, w) {
                  return g(d, Wir);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, ufr);
              } else g(e, ifr);
              return u(f(e), ffr), u(f(e), xfr);
            }), N(aW, function(t, n, e) {
              var i = o(dC, t, n);
              return o(C0(Kir), i, e);
            });
            var cW = [0, oW, dC, aW], kC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, sW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(kC, function(t, n, e, i) {
              u(f(e), Dir), o(f(e), Rir, Lir);
              var x = i[1];
              u(f(e), jir);
              var c = 0;
              le(function(E, d) {
                E && u(f(e), Pir);
                function w(A) {
                  return u(n, A);
                }
                function G(A) {
                  return u(t, A);
                }
                return R($e[13], G, w, e, d), 1;
              }, c, x), u(f(e), Gir), u(f(e), Mir), u(f(e), Bir), o(f(e), Uir, qir);
              var s = i[2];
              if (s) {
                g(e, Hir);
                var p = s[1], y = function(E, d) {
                  return g(E, Cir);
                }, T = function(E) {
                  return u(t, E);
                };
                R(Dr[1], T, y, e, p), g(e, Xir);
              } else g(e, Yir);
              return u(f(e), Vir), u(f(e), zir);
            }), N(sW, function(t, n, e) {
              var i = o(kC, t, n);
              return o(C0(Nir), i, e);
            });
            var vW = [0, kC, sW], wC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, lW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(wC, function(t, n, e, i) {
              u(f(e), hir), o(f(e), kir, dir);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R($e[13], s, c, e, x), u(f(e), wir), u(f(e), Eir), o(f(e), gir, Sir);
              var p = i[2];
              if (p) {
                g(e, Fir);
                var y = p[1], T = function(d, w) {
                  return g(d, yir);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, Tir);
              } else g(e, Oir);
              return u(f(e), Iir), u(f(e), Air);
            }), N(lW, function(t, n, e) {
              var i = o(wC, t, n);
              return o(C0(_ir), i, e);
            });
            var bW = [0, wC, lW], EC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, pW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(EC, function(t, n, e, i) {
              u(f(e), Q7r), o(f(e), eir, rir);
              var x = i[1];
              u(f(e), nir);
              var c = x[1];
              function s(K) {
                return u(n, K);
              }
              function p(K) {
                return u(t, K);
              }
              R($e[13], p, s, e, c), u(f(e), tir);
              var y = x[2];
              function T(K) {
                return u(n, K);
              }
              function E(K) {
                return u(t, K);
              }
              R($e[13], E, T, e, y), u(f(e), uir), u(f(e), iir);
              var d = x[3], w = 0;
              le(function(K, V) {
                K && u(f(e), Z7r);
                function f0(k0) {
                  return u(n, k0);
                }
                function m0(k0) {
                  return u(t, k0);
                }
                return R($e[13], m0, f0, e, V), 1;
              }, w, d), u(f(e), fir), u(f(e), xir), u(f(e), oir), u(f(e), air), o(f(e), sir, cir);
              var G = i[2];
              if (G) {
                g(e, vir);
                var A = G[1], S = function(K, V) {
                  return g(K, $7r);
                }, M = function(K) {
                  return u(t, K);
                };
                R(Dr[1], M, S, e, A), g(e, lir);
              } else g(e, bir);
              return u(f(e), pir), u(f(e), mir);
            }), N(pW, function(t, n, e) {
              var i = o(EC, t, n);
              return o(C0(J7r), i, e);
            });
            var mW = [0, EC, pW], SC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, _W = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(SC, function(t, n, e, i) {
              u(f(e), C7r), o(f(e), D7r, P7r);
              var x = i[1];
              u(f(e), L7r);
              var c = x[1];
              function s(K) {
                return u(n, K);
              }
              function p(K) {
                return u(t, K);
              }
              R($e[13], p, s, e, c), u(f(e), R7r);
              var y = x[2];
              function T(K) {
                return u(n, K);
              }
              function E(K) {
                return u(t, K);
              }
              R($e[13], E, T, e, y), u(f(e), j7r), u(f(e), G7r);
              var d = x[3], w = 0;
              le(function(K, V) {
                K && u(f(e), N7r);
                function f0(k0) {
                  return u(n, k0);
                }
                function m0(k0) {
                  return u(t, k0);
                }
                return R($e[13], m0, f0, e, V), 1;
              }, w, d), u(f(e), M7r), u(f(e), B7r), u(f(e), q7r), u(f(e), U7r), o(f(e), X7r, H7r);
              var G = i[2];
              if (G) {
                g(e, Y7r);
                var A = G[1], S = function(K, V) {
                  return g(K, A7r);
                }, M = function(K) {
                  return u(t, K);
                };
                R(Dr[1], M, S, e, A), g(e, V7r);
              } else g(e, z7r);
              return u(f(e), K7r), u(f(e), W7r);
            }), N(_W, function(t, n, e) {
              var i = o(SC, t, n);
              return o(C0(I7r), i, e);
            });
            var yW = [0, SC, _W], c5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, hW = function t(n, e, i) {
              return t.fun(n, e, i);
            }, s5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, dW = function t(n, e, i) {
              return t.fun(n, e, i);
            }, gC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, kW = function t(n, e, i) {
              return t.fun(n, e, i);
            }, FC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, wW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(c5, function(t, n, e, i) {
              u(f(e), F7r), o(n, e, i[1]), u(f(e), T7r);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(s5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), O7r);
            }), N(hW, function(t, n, e) {
              var i = o(c5, t, n);
              return o(C0(g7r), i, e);
            }), N(s5, function(t, n, e, i) {
              switch (i[0]) {
                case 0:
                  var x = i[1];
                  if (u(f(e), Vtr), x) {
                    g(e, ztr);
                    var c = x[1], s = function(U, Y) {
                      return g(U, Ytr);
                    }, p = function(U) {
                      return u(t, U);
                    };
                    R(Dr[1], p, s, e, c), g(e, Ktr);
                  } else g(e, Wtr);
                  return u(f(e), Jtr);
                case 1:
                  var y = i[1];
                  if (u(f(e), $tr), y) {
                    g(e, Ztr);
                    var T = y[1], E = function(U, Y) {
                      return g(U, Xtr);
                    }, d = function(U) {
                      return u(t, U);
                    };
                    R(Dr[1], d, E, e, T), g(e, Qtr);
                  } else g(e, rur);
                  return u(f(e), eur);
                case 2:
                  var w = i[1];
                  if (u(f(e), nur), w) {
                    g(e, tur);
                    var G = w[1], A = function(U, Y) {
                      return g(U, Htr);
                    }, S = function(U) {
                      return u(t, U);
                    };
                    R(Dr[1], S, A, e, G), g(e, uur);
                  } else g(e, iur);
                  return u(f(e), fur);
                case 3:
                  var M = i[1];
                  if (u(f(e), xur), M) {
                    g(e, our);
                    var K = M[1], V = function(U, Y) {
                      return g(U, Utr);
                    }, f0 = function(U) {
                      return u(t, U);
                    };
                    R(Dr[1], f0, V, e, K), g(e, aur);
                  } else g(e, cur);
                  return u(f(e), sur);
                case 4:
                  var m0 = i[1];
                  if (u(f(e), vur), m0) {
                    g(e, lur);
                    var k0 = m0[1], g0 = function(U, Y) {
                      return g(U, qtr);
                    }, e0 = function(U) {
                      return u(t, U);
                    };
                    R(Dr[1], e0, g0, e, k0), g(e, bur);
                  } else g(e, pur);
                  return u(f(e), mur);
                case 5:
                  var x0 = i[1];
                  if (u(f(e), _ur), x0) {
                    g(e, yur);
                    var l = x0[1], c0 = function(U, Y) {
                      return g(U, Btr);
                    }, t0 = function(U) {
                      return u(t, U);
                    };
                    R(Dr[1], t0, c0, e, l), g(e, hur);
                  } else g(e, dur);
                  return u(f(e), kur);
                case 6:
                  var o0 = i[1];
                  if (u(f(e), wur), o0) {
                    g(e, Eur);
                    var w0 = o0[1], _0 = function(U, Y) {
                      return g(U, Mtr);
                    }, E0 = function(U) {
                      return u(t, U);
                    };
                    R(Dr[1], E0, _0, e, w0), g(e, Sur);
                  } else g(e, gur);
                  return u(f(e), Fur);
                case 7:
                  var U0 = i[1];
                  if (u(f(e), Tur), U0) {
                    g(e, Our);
                    var b = U0[1], R0 = function(U, Y) {
                      return g(U, Gtr);
                    }, X = function(U) {
                      return u(t, U);
                    };
                    R(Dr[1], X, R0, e, b), g(e, Iur);
                  } else g(e, Aur);
                  return u(f(e), Nur);
                case 8:
                  var s0 = i[1];
                  if (u(f(e), Cur), s0) {
                    g(e, Pur);
                    var hr = s0[1], Ar = function(U, Y) {
                      return g(U, jtr);
                    }, or = function(U) {
                      return u(t, U);
                    };
                    R(Dr[1], or, Ar, e, hr), g(e, Dur);
                  } else g(e, Lur);
                  return u(f(e), Rur);
                case 9:
                  var W0 = i[1];
                  if (u(f(e), jur), W0) {
                    g(e, Gur);
                    var Lr = W0[1], Tr = function(U, Y) {
                      return g(U, Rtr);
                    }, Hr = function(U) {
                      return u(t, U);
                    };
                    R(Dr[1], Hr, Tr, e, Lr), g(e, Mur);
                  } else g(e, Bur);
                  return u(f(e), qur);
                case 10:
                  var Or = i[1];
                  if (u(f(e), Uur), Or) {
                    g(e, Hur);
                    var fr = Or[1], Rr = function(U, Y) {
                      return g(U, Ltr);
                    }, Wr = function(U) {
                      return u(t, U);
                    };
                    R(Dr[1], Wr, Rr, e, fr), g(e, Xur);
                  } else g(e, Yur);
                  return u(f(e), Vur);
                case 11:
                  u(f(e), zur);
                  var Jr = i[1], ar = function(U) {
                    return u(n, U);
                  }, _r = function(U) {
                    return u(t, U);
                  };
                  return R(uW[1], _r, ar, e, Jr), u(f(e), Kur);
                case 12:
                  u(f(e), Wur);
                  var Ir = i[1], fe = function(U) {
                    return u(n, U);
                  }, v0 = function(U) {
                    return u(t, U);
                  };
                  return R(Ol[5], v0, fe, e, Ir), u(f(e), Jur);
                case 13:
                  u(f(e), $ur);
                  var P = i[1], L = function(U) {
                    return u(n, U);
                  }, Q = function(U) {
                    return u(t, U);
                  };
                  return R(_C[6], Q, L, e, P), u(f(e), Zur);
                case 14:
                  u(f(e), Qur);
                  var i0 = i[1], l0 = function(U) {
                    return u(n, U);
                  }, S0 = function(U) {
                    return u(t, U);
                  };
                  return R(nW[1], S0, l0, e, i0), u(f(e), r7r);
                case 15:
                  u(f(e), e7r);
                  var T0 = i[1], rr = function(U) {
                    return u(n, U);
                  }, L0 = function(U) {
                    return u(t, U);
                  };
                  return R(bW[1], L0, rr, e, T0), u(f(e), n7r);
                case 16:
                  u(f(e), t7r);
                  var B = i[1], Z = function(U) {
                    return u(n, U);
                  }, p0 = function(U) {
                    return u(t, U);
                  };
                  return R(xC[2], p0, Z, e, B), u(f(e), u7r);
                case 17:
                  u(f(e), i7r);
                  var b0 = i[1], O0 = function(U) {
                    return u(n, U);
                  }, M0 = function(U) {
                    return u(t, U);
                  };
                  return R(aC[1], M0, O0, e, b0), u(f(e), f7r);
                case 18:
                  u(f(e), x7r);
                  var er = i[1], yr = function(U) {
                    return u(n, U);
                  }, vr = function(U) {
                    return u(t, U);
                  };
                  return R(RK[1], vr, yr, e, er), u(f(e), o7r);
                case 19:
                  u(f(e), a7r);
                  var $0 = i[1], Er = function(U) {
                    return u(n, U);
                  }, Mr = function(U) {
                    return u(t, U);
                  };
                  return R(mW[1], Mr, Er, e, $0), u(f(e), c7r);
                case 20:
                  u(f(e), s7r);
                  var Br = i[1], qr = function(U) {
                    return u(n, U);
                  }, jr = function(U) {
                    return u(t, U);
                  };
                  return R(yW[1], jr, qr, e, Br), u(f(e), v7r);
                case 21:
                  u(f(e), l7r);
                  var $r = i[1], ne = function(U) {
                    return u(n, U);
                  }, Qr = function(U) {
                    return u(t, U);
                  };
                  return R(cW[2], Qr, ne, e, $r), u(f(e), b7r);
                case 22:
                  u(f(e), p7r);
                  var be = i[1], ae = function(U) {
                    return u(n, U);
                  }, pe = function(U) {
                    return u(t, U);
                  };
                  return R(vW[1], pe, ae, e, be), u(f(e), m7r);
                case 23:
                  u(f(e), _7r);
                  var oe = i[1], ce = function(U) {
                    return u(t, U);
                  };
                  return ur(g1[1], ce, e, oe), u(f(e), y7r);
                case 24:
                  u(f(e), h7r);
                  var ge = i[1], q0 = function(U) {
                    return u(t, U);
                  };
                  return ur(BN[1], q0, e, ge), u(f(e), d7r);
                case 25:
                  u(f(e), k7r);
                  var Fr = i[1], _ = function(U) {
                    return u(t, U);
                  };
                  return ur(Zz[1], _, e, Fr), u(f(e), w7r);
                default:
                  u(f(e), E7r);
                  var k = i[1], I = function(U) {
                    return u(t, U);
                  };
                  return ur(qN[1], I, e, k), u(f(e), S7r);
              }
            }), N(dW, function(t, n, e) {
              var i = o(s5, t, n);
              return o(C0(Dtr), i, e);
            }), N(gC, function(t, n, e, i) {
              u(f(e), Ntr), o(t, e, i[1]), u(f(e), Ctr);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(c5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), Ptr);
            }), N(kW, function(t, n, e) {
              var i = o(gC, t, n);
              return o(C0(Atr), i, e);
            }), N(FC, function(t, n, e, i) {
              if (i[0] === 0) return u(f(e), Ftr), o(n, e, i[1]), u(f(e), Ttr);
              u(f(e), Otr);
              var x = i[1];
              function c(p) {
                return u(n, p);
              }
              function s(p) {
                return u(t, p);
              }
              return R($e[17], s, c, e, x), u(f(e), Itr);
            }), N(wW, function(t, n, e) {
              var i = o(FC, t, n);
              return o(C0(gtr), i, e);
            });
            var TC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, EW = function t(n, e, i) {
              return t.fun(n, e, i);
            }, v5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, SW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(TC, function(t, n, e, i) {
              u(f(e), wtr), o(t, e, i[1]), u(f(e), Etr);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(v5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), Str);
            }), N(EW, function(t, n, e) {
              var i = o(TC, t, n);
              return o(C0(ktr), i, e);
            }), N(v5, function(t, n, e, i) {
              u(f(e), Znr), o(f(e), rtr, Qnr);
              var x = i[1];
              function c(K) {
                return u(t, K);
              }
              function s(K) {
                return u(t, K);
              }
              R(Rn[1], s, c, e, x), u(f(e), etr), u(f(e), ntr), o(f(e), utr, ttr);
              var p = i[2];
              function y(K) {
                return u(n, K);
              }
              function T(K) {
                return u(t, K);
              }
              R($e[19], T, y, e, p), u(f(e), itr), u(f(e), ftr), o(f(e), otr, xtr);
              var E = i[3];
              if (E) {
                g(e, atr);
                var d = E[1], w = function(K) {
                  return u(t, K);
                };
                ur(zv[1], w, e, d), g(e, ctr);
              } else g(e, str2);
              u(f(e), vtr), u(f(e), ltr), o(f(e), ptr, btr);
              var G = i[4];
              if (G) {
                g(e, mtr);
                var A = G[1], S = function(K) {
                  return u(n, K);
                }, M = function(K) {
                  return u(t, K);
                };
                R($e[13], M, S, e, A), g(e, _tr);
              } else g(e, ytr);
              return u(f(e), htr), u(f(e), dtr);
            }), N(SW, function(t, n, e) {
              var i = o(v5, t, n);
              return o(C0($nr), i, e);
            });
            var gW = [0, TC, EW, v5, SW], OC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, FW = function t(n, e, i) {
              return t.fun(n, e, i);
            }, l5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, TW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(OC, function(t, n, e, i) {
              u(f(e), Knr), o(t, e, i[1]), u(f(e), Wnr);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(l5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), Jnr);
            }), N(FW, function(t, n, e) {
              var i = o(OC, t, n);
              return o(C0(znr), i, e);
            }), N(l5, function(t, n, e, i) {
              u(f(e), Pnr), o(f(e), Lnr, Dnr);
              var x = i[1];
              u(f(e), Rnr);
              var c = 0;
              le(function(E, d) {
                E && u(f(e), Cnr);
                function w(A) {
                  return u(n, A);
                }
                function G(A) {
                  return u(t, A);
                }
                return R(gW[1], G, w, e, d), 1;
              }, c, x), u(f(e), jnr), u(f(e), Gnr), u(f(e), Mnr), o(f(e), qnr, Bnr);
              var s = i[2];
              if (s) {
                g(e, Unr);
                var p = s[1], y = function(E, d) {
                  u(f(E), Anr);
                  var w = 0;
                  return le(function(G, A) {
                    G && u(f(E), Inr);
                    function S(M) {
                      return u(t, M);
                    }
                    return ur(iu[1], S, E, A), 1;
                  }, w, d), u(f(E), Nnr);
                }, T = function(E) {
                  return u(t, E);
                };
                R(Dr[1], T, y, e, p), g(e, Hnr);
              } else g(e, Xnr);
              return u(f(e), Ynr), u(f(e), Vnr);
            }), N(TW, function(t, n, e) {
              var i = o(l5, t, n);
              return o(C0(Onr), i, e);
            });
            var IC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, OW = function t(n, e, i) {
              return t.fun(n, e, i);
            }, b5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, IW = function t(n, e, i) {
              return t.fun(n, e, i);
            }, wee = [0, OC, FW, l5, TW];
            N(IC, function(t, n, e, i) {
              u(f(e), gnr), o(t, e, i[1]), u(f(e), Fnr);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(b5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), Tnr);
            }), N(OW, function(t, n, e) {
              var i = o(IC, t, n);
              return o(C0(Snr), i, e);
            }), N(b5, function(t, n, e, i) {
              u(f(e), cnr), o(f(e), vnr, snr);
              var x = i[1];
              u(f(e), lnr);
              var c = 0;
              le(function(E, d) {
                E && u(f(e), anr);
                function w(A) {
                  return u(n, A);
                }
                function G(A) {
                  return u(t, A);
                }
                return R($e[13], G, w, e, d), 1;
              }, c, x), u(f(e), bnr), u(f(e), pnr), u(f(e), mnr), o(f(e), ynr, _nr);
              var s = i[2];
              if (s) {
                g(e, hnr);
                var p = s[1], y = function(E, d) {
                  u(f(E), xnr);
                  var w = 0;
                  return le(function(G, A) {
                    G && u(f(E), fnr);
                    function S(M) {
                      return u(t, M);
                    }
                    return ur(iu[1], S, E, A), 1;
                  }, w, d), u(f(E), onr);
                }, T = function(E) {
                  return u(t, E);
                };
                R(Dr[1], T, y, e, p), g(e, dnr);
              } else g(e, knr);
              return u(f(e), wnr), u(f(e), Enr);
            }), N(IW, function(t, n, e) {
              var i = o(b5, t, n);
              return o(C0(inr), i, e);
            });
            var AC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, AW = function t(n, e, i) {
              return t.fun(n, e, i);
            }, p5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, NW = function t(n, e, i) {
              return t.fun(n, e, i);
            }, m5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, CW = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Eee = [0, IC, OW, b5, IW];
            N(AC, function(t, n, e, i) {
              u(f(e), nnr), o(t, e, i[1]), u(f(e), tnr);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(p5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), unr);
            }), N(AW, function(t, n, e) {
              var i = o(AC, t, n);
              return o(C0(enr), i, e);
            }), N(p5, function(t, n, e, i) {
              u(f(e), Her), o(f(e), Yer, Xer);
              var x = i[1];
              function c(E) {
                return u(n, E);
              }
              R(m5, function(E) {
                return u(t, E);
              }, c, e, x), u(f(e), Ver), u(f(e), zer), o(f(e), Wer, Ker);
              var s = i[2];
              if (s) {
                g(e, Jer);
                var p = s[1], y = function(E, d) {
                  return g(E, Uer);
                }, T = function(E) {
                  return u(t, E);
                };
                R(Dr[1], T, y, e, p), g(e, $er);
              } else g(e, Zer);
              return u(f(e), Qer), u(f(e), rnr);
            }), N(NW, function(t, n, e) {
              var i = o(p5, t, n);
              return o(C0(qer), i, e);
            }), N(m5, function(t, n, e, i) {
              if (i) {
                u(f(e), Ger);
                var x = i[1], c = function(p) {
                  return u(n, p);
                }, s = function(p) {
                  return u(t, p);
                };
                return R(qe[31], s, c, e, x), u(f(e), Mer);
              }
              return g(e, Ber);
            }), N(CW, function(t, n, e) {
              var i = o(m5, t, n);
              return o(C0(jer), i, e);
            }), mu(K3r, $e, [0, Ol, xC, aC, RK, _C, nW, uW, cW, vW, bW, mW, yW, c5, hW, s5, dW, gC, kW, FC, wW, gW, wee, Eee, [0, AC, AW, p5, NW, m5, CW]]);
            var NC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, PW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(NC, function(t, n, e, i) {
              u(f(e), Eer), o(f(e), ger, Ser);
              var x = i[1];
              u(f(e), Fer);
              var c = 0;
              le(function(E, d) {
                E && u(f(e), wer);
                function w(A) {
                  return u(n, A);
                }
                function G(A) {
                  return u(t, A);
                }
                return R(Yu[35], G, w, e, d), 1;
              }, c, x), u(f(e), Ter), u(f(e), Oer), u(f(e), Ier), o(f(e), Ner, Aer);
              var s = i[2];
              if (s) {
                g(e, Cer);
                var p = s[1], y = function(E, d) {
                  u(f(E), der);
                  var w = 0;
                  return le(function(G, A) {
                    G && u(f(E), her);
                    function S(M) {
                      return u(t, M);
                    }
                    return ur(iu[1], S, E, A), 1;
                  }, w, d), u(f(E), ker);
                }, T = function(E) {
                  return u(t, E);
                };
                R(Dr[1], T, y, e, p), g(e, Per);
              } else g(e, Der);
              return u(f(e), Ler), u(f(e), Rer);
            }), N(PW, function(t, n, e) {
              var i = o(NC, t, n);
              return o(C0(yer), i, e);
            });
            var Kv = [0, NC, PW], CC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, DW = function t(n, e, i) {
              return t.fun(n, e, i);
            }, _5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, LW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(CC, function(t, n, e, i) {
              u(f(e), per), o(t, e, i[1]), u(f(e), mer);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(_5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), _er);
            }), N(DW, function(t, n, e) {
              var i = o(CC, t, n);
              return o(C0(ber), i, e);
            }), N(_5, function(t, n, e, i) {
              u(f(e), ner), o(f(e), uer, ter);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(Yu[35], s, c, e, x), u(f(e), ier), u(f(e), fer), o(f(e), oer, xer);
              var p = i[2];
              if (p) {
                g(e, aer);
                var y = p[1], T = function(d, w) {
                  return g(d, eer);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, cer);
              } else g(e, ser);
              return u(f(e), ver), u(f(e), ler);
            }), N(LW, function(t, n, e) {
              var i = o(_5, t, n);
              return o(C0(rer), i, e);
            });
            var RW = [0, CC, DW, _5, LW], PC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, jW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(PC, function(t, n, e, i) {
              u(f(e), Nrr), o(f(e), Prr, Crr);
              var x = i[1];
              function c(V) {
                return u(n, V);
              }
              function s(V) {
                return u(t, V);
              }
              R(qe[31], s, c, e, x), u(f(e), Drr), u(f(e), Lrr), o(f(e), jrr, Rrr);
              var p = i[2];
              function y(V) {
                return u(n, V);
              }
              function T(V) {
                return u(t, V);
              }
              R(Yu[35], T, y, e, p), u(f(e), Grr), u(f(e), Mrr), o(f(e), qrr, Brr);
              var E = i[3];
              if (E) {
                g(e, Urr);
                var d = E[1], w = function(V) {
                  return u(n, V);
                }, G = function(V) {
                  return u(t, V);
                };
                R(RW[1], G, w, e, d), g(e, Hrr);
              } else g(e, Xrr);
              u(f(e), Yrr), u(f(e), Vrr), o(f(e), Krr, zrr);
              var A = i[4];
              if (A) {
                g(e, Wrr);
                var S = A[1], M = function(V, f0) {
                  return g(V, Arr);
                }, K = function(V) {
                  return u(t, V);
                };
                R(Dr[1], K, M, e, S), g(e, Jrr);
              } else g(e, $rr);
              return u(f(e), Zrr), u(f(e), Qrr);
            }), N(jW, function(t, n, e) {
              var i = o(PC, t, n);
              return o(C0(Irr), i, e);
            });
            var GW = [0, RW, PC, jW], DC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, MW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(DC, function(t, n, e, i) {
              u(f(e), lrr), o(f(e), prr, brr);
              var x = i[1];
              function c(A) {
                return u(t, A);
              }
              function s(A) {
                return u(t, A);
              }
              R(Rn[1], s, c, e, x), u(f(e), mrr), u(f(e), _rr), o(f(e), hrr, yrr);
              var p = i[2];
              function y(A) {
                return u(n, A);
              }
              function T(A) {
                return u(t, A);
              }
              R(Yu[35], T, y, e, p), u(f(e), drr), u(f(e), krr), o(f(e), Err, wrr);
              var E = i[3];
              if (E) {
                g(e, Srr);
                var d = E[1], w = function(A, S) {
                  return g(A, vrr);
                }, G = function(A) {
                  return u(t, A);
                };
                R(Dr[1], G, w, e, d), g(e, grr);
              } else g(e, Frr);
              return u(f(e), Trr), u(f(e), Orr);
            }), N(MW, function(t, n, e) {
              var i = o(DC, t, n);
              return o(C0(srr), i, e);
            });
            var BW = [0, DC, MW], LC = function t(n, e, i) {
              return t.fun(n, e, i);
            }, qW = function t(n, e) {
              return t.fun(n, e);
            };
            N(LC, function(t, n, e) {
              u(f(n), J0r), o(f(n), Z0r, $0r);
              var i = e[1];
              if (i) {
                g(n, Q0r);
                var x = i[1], c = function(d) {
                  return u(t, d);
                }, s = function(d) {
                  return u(t, d);
                };
                R(Rn[1], s, c, n, x), g(n, rrr);
              } else g(n, err);
              u(f(n), nrr), u(f(n), trr), o(f(n), irr, urr);
              var p = e[2];
              if (p) {
                g(n, frr);
                var y = p[1], T = function(d, w) {
                  return g(d, W0r);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, n, y), g(n, xrr);
              } else g(n, orr);
              return u(f(n), arr), u(f(n), crr);
            }), N(qW, function(t, n) {
              var e = u(LC, t);
              return o(C0(K0r), e, n);
            });
            var UW = [0, LC, qW], RC = function t(n, e, i) {
              return t.fun(n, e, i);
            }, HW = function t(n, e) {
              return t.fun(n, e);
            };
            N(RC, function(t, n, e) {
              u(f(n), P0r), o(f(n), L0r, D0r);
              var i = e[1];
              if (i) {
                g(n, R0r);
                var x = i[1], c = function(d) {
                  return u(t, d);
                }, s = function(d) {
                  return u(t, d);
                };
                R(Rn[1], s, c, n, x), g(n, j0r);
              } else g(n, G0r);
              u(f(n), M0r), u(f(n), B0r), o(f(n), U0r, q0r);
              var p = e[2];
              if (p) {
                g(n, H0r);
                var y = p[1], T = function(d, w) {
                  return g(d, C0r);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, n, y), g(n, X0r);
              } else g(n, Y0r);
              return u(f(n), V0r), u(f(n), z0r);
            }), N(HW, function(t, n) {
              var e = u(RC, t);
              return o(C0(N0r), e, n);
            });
            var XW = [0, RC, HW], jC = function t(n, e, i) {
              return t.fun(n, e, i);
            }, YW = function t(n, e) {
              return t.fun(n, e);
            };
            N(jC, function(t, n, e) {
              u(f(n), E0r), o(f(n), g0r, S0r);
              var i = e[1];
              if (i) {
                g(n, F0r);
                var x = i[1], c = function(p, y) {
                  return g(p, w0r);
                }, s = function(p) {
                  return u(t, p);
                };
                R(Dr[1], s, c, n, x), g(n, T0r);
              } else g(n, O0r);
              return u(f(n), I0r), u(f(n), A0r);
            }), N(YW, function(t, n) {
              var e = u(jC, t);
              return o(C0(k0r), e, n);
            });
            var VW = [0, jC, YW], GC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, zW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(GC, function(t, n, e, i) {
              u(f(e), i0r), o(f(e), x0r, f0r);
              var x = i[1];
              function c(A) {
                return u(n, A);
              }
              function s(A) {
                return u(t, A);
              }
              R(qe[31], s, c, e, x), u(f(e), o0r), u(f(e), a0r), o(f(e), s0r, c0r);
              var p = i[2];
              function y(A) {
                return u(n, A);
              }
              function T(A) {
                return u(t, A);
              }
              R(Yu[35], T, y, e, p), u(f(e), v0r), u(f(e), l0r), o(f(e), p0r, b0r);
              var E = i[3];
              if (E) {
                g(e, m0r);
                var d = E[1], w = function(A, S) {
                  return g(A, u0r);
                }, G = function(A) {
                  return u(t, A);
                };
                R(Dr[1], G, w, e, d), g(e, _0r);
              } else g(e, y0r);
              return u(f(e), h0r), u(f(e), d0r);
            }), N(zW, function(t, n, e) {
              var i = o(GC, t, n);
              return o(C0(t0r), i, e);
            });
            var KW = [0, GC, zW], MC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, WW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(MC, function(t, n, e, i) {
              u(f(e), DQ0), o(f(e), RQ0, LQ0);
              var x = i[1];
              function c(V) {
                return u(n, V);
              }
              function s(V) {
                return u(t, V);
              }
              R(Rn[1], s, c, e, x), u(f(e), jQ0), u(f(e), GQ0), o(f(e), BQ0, MQ0);
              var p = i[2];
              if (p) {
                g(e, qQ0);
                var y = p[1], T = function(V) {
                  return u(n, V);
                }, E = function(V) {
                  return u(t, V);
                };
                R($e[22][1], E, T, e, y), g(e, UQ0);
              } else g(e, HQ0);
              u(f(e), XQ0), u(f(e), YQ0), o(f(e), zQ0, VQ0);
              var d = i[3];
              function w(V) {
                return u(n, V);
              }
              function G(V) {
                return u(t, V);
              }
              R($e[13], G, w, e, d), u(f(e), KQ0), u(f(e), WQ0), o(f(e), $Q0, JQ0);
              var A = i[4];
              if (A) {
                g(e, ZQ0);
                var S = A[1], M = function(V, f0) {
                  return g(V, PQ0);
                }, K = function(V) {
                  return u(t, V);
                };
                R(Dr[1], K, M, e, S), g(e, QQ0);
              } else g(e, r0r);
              return u(f(e), e0r), u(f(e), n0r);
            }), N(WW, function(t, n, e) {
              var i = o(MC, t, n);
              return o(C0(CQ0), i, e);
            });
            var y5 = [0, MC, WW], BC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, JW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(BC, function(t, n, e, i) {
              u(f(e), QZ0), o(f(e), eQ0, rQ0);
              var x = i[1];
              function c(e0) {
                return u(n, e0);
              }
              function s(e0) {
                return u(t, e0);
              }
              R(Rn[1], s, c, e, x), u(f(e), nQ0), u(f(e), tQ0), o(f(e), iQ0, uQ0);
              var p = i[2];
              if (p) {
                g(e, fQ0);
                var y = p[1], T = function(e0) {
                  return u(n, e0);
                }, E = function(e0) {
                  return u(t, e0);
                };
                R($e[22][1], E, T, e, y), g(e, xQ0);
              } else g(e, oQ0);
              u(f(e), aQ0), u(f(e), cQ0), o(f(e), vQ0, sQ0);
              var d = i[3];
              if (d) {
                g(e, lQ0);
                var w = d[1], G = function(e0) {
                  return u(n, e0);
                }, A = function(e0) {
                  return u(t, e0);
                };
                R($e[13], A, G, e, w), g(e, bQ0);
              } else g(e, pQ0);
              u(f(e), mQ0), u(f(e), _Q0), o(f(e), hQ0, yQ0);
              var S = i[4];
              if (S) {
                g(e, dQ0);
                var M = S[1], K = function(e0) {
                  return u(n, e0);
                }, V = function(e0) {
                  return u(t, e0);
                };
                R($e[13], V, K, e, M), g(e, kQ0);
              } else g(e, wQ0);
              u(f(e), EQ0), u(f(e), SQ0), o(f(e), FQ0, gQ0);
              var f0 = i[5];
              if (f0) {
                g(e, TQ0);
                var m0 = f0[1], k0 = function(e0, x0) {
                  return g(e0, ZZ0);
                }, g0 = function(e0) {
                  return u(t, e0);
                };
                R(Dr[1], g0, k0, e, m0), g(e, OQ0);
              } else g(e, IQ0);
              return u(f(e), AQ0), u(f(e), NQ0);
            }), N(JW, function(t, n, e) {
              var i = o(BC, t, n);
              return o(C0($Z0), i, e);
            });
            var h5 = [0, BC, JW], qC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, $W = function t(n, e, i) {
              return t.fun(n, e, i);
            }, d5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, ZW = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(qC, function(t, n, e, i) {
              u(f(e), KZ0), o(t, e, i[1]), u(f(e), WZ0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(d5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), JZ0);
            }), N($W, function(t, n, e) {
              var i = o(qC, t, n);
              return o(C0(zZ0), i, e);
            }), N(d5, function(t, n, e, i) {
              u(f(e), FZ0), o(f(e), OZ0, TZ0);
              var x = i[1];
              if (x) {
                g(e, IZ0);
                var c = x[1], s = function(A) {
                  return u(n, A);
                }, p = function(A) {
                  return u(t, A);
                };
                R(qe[31], p, s, e, c), g(e, AZ0);
              } else g(e, NZ0);
              u(f(e), CZ0), u(f(e), PZ0), o(f(e), LZ0, DZ0);
              var y = i[2];
              u(f(e), RZ0);
              var T = 0;
              le(function(A, S) {
                A && u(f(e), gZ0);
                function M(V) {
                  return u(n, V);
                }
                function K(V) {
                  return u(t, V);
                }
                return R(Yu[35], K, M, e, S), 1;
              }, T, y), u(f(e), jZ0), u(f(e), GZ0), u(f(e), MZ0), o(f(e), qZ0, BZ0);
              var E = i[3];
              if (E) {
                g(e, UZ0);
                var d = E[1], w = function(A, S) {
                  return g(A, SZ0);
                }, G = function(A) {
                  return u(t, A);
                };
                R(Dr[1], G, w, e, d), g(e, HZ0);
              } else g(e, XZ0);
              return u(f(e), YZ0), u(f(e), VZ0);
            }), N(ZW, function(t, n, e) {
              var i = o(d5, t, n);
              return o(C0(EZ0), i, e);
            });
            var QW = [0, qC, $W, d5, ZW], UC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, rJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(UC, function(t, n, e, i) {
              u(f(e), eZ0), o(f(e), tZ0, nZ0);
              var x = i[1];
              function c(G) {
                return u(n, G);
              }
              function s(G) {
                return u(t, G);
              }
              R(qe[31], s, c, e, x), u(f(e), uZ0), u(f(e), iZ0), o(f(e), xZ0, fZ0);
              var p = i[2];
              u(f(e), oZ0);
              var y = 0;
              le(function(G, A) {
                G && u(f(e), rZ0);
                function S(K) {
                  return u(n, K);
                }
                function M(K) {
                  return u(t, K);
                }
                return R(QW[1], M, S, e, A), 1;
              }, y, p), u(f(e), aZ0), u(f(e), cZ0), u(f(e), sZ0), o(f(e), lZ0, vZ0);
              var T = i[3];
              if (T) {
                g(e, bZ0);
                var E = T[1], d = function(G, A) {
                  return g(G, Q$0);
                }, w = function(G) {
                  return u(t, G);
                };
                R(Dr[1], w, d, e, E), g(e, pZ0);
              } else g(e, mZ0);
              return u(f(e), _Z0), u(f(e), yZ0), o(f(e), dZ0, hZ0), o(n, e, i[4]), u(f(e), kZ0), u(f(e), wZ0);
            }), N(rJ, function(t, n, e) {
              var i = o(UC, t, n);
              return o(C0(Z$0), i, e);
            });
            var eJ = [0, QW, UC, rJ], HC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, nJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(HC, function(t, n, e, i) {
              u(f(e), P$0), o(f(e), L$0, D$0);
              var x = i[1];
              if (x) {
                g(e, R$0);
                var c = x[1], s = function(w) {
                  return u(n, w);
                }, p = function(w) {
                  return u(t, w);
                };
                R(qe[31], p, s, e, c), g(e, j$0);
              } else g(e, G$0);
              u(f(e), M$0), u(f(e), B$0), o(f(e), U$0, q$0);
              var y = i[2];
              if (y) {
                g(e, H$0);
                var T = y[1], E = function(w, G) {
                  return g(w, C$0);
                }, d = function(w) {
                  return u(t, w);
                };
                R(Dr[1], d, E, e, T), g(e, X$0);
              } else g(e, Y$0);
              return u(f(e), V$0), u(f(e), z$0), o(f(e), W$0, K$0), o(n, e, i[3]), u(f(e), J$0), u(f(e), $$0);
            }), N(nJ, function(t, n, e) {
              var i = o(HC, t, n);
              return o(C0(N$0), i, e);
            });
            var tJ = [0, HC, nJ], XC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, uJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(XC, function(t, n, e, i) {
              u(f(e), h$0), o(f(e), k$0, d$0);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(qe[31], s, c, e, x), u(f(e), w$0), u(f(e), E$0), o(f(e), g$0, S$0);
              var p = i[2];
              if (p) {
                g(e, F$0);
                var y = p[1], T = function(d, w) {
                  return g(d, y$0);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, T$0);
              } else g(e, O$0);
              return u(f(e), I$0), u(f(e), A$0);
            }), N(uJ, function(t, n, e) {
              var i = o(XC, t, n);
              return o(C0(_$0), i, e);
            });
            var iJ = [0, XC, uJ], YC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, fJ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, k5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, xJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(YC, function(t, n, e, i) {
              u(f(e), b$0), o(t, e, i[1]), u(f(e), p$0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(k5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), m$0);
            }), N(fJ, function(t, n, e) {
              var i = o(YC, t, n);
              return o(C0(l$0), i, e);
            }), N(k5, function(t, n, e, i) {
              u(f(e), YJ0), o(f(e), zJ0, VJ0);
              var x = i[1];
              if (x) {
                g(e, KJ0);
                var c = x[1], s = function(M) {
                  return u(n, M);
                }, p = function(M) {
                  return u(t, M);
                };
                R(di[5], p, s, e, c), g(e, WJ0);
              } else g(e, JJ0);
              u(f(e), $J0), u(f(e), ZJ0), o(f(e), r$0, QJ0);
              var y = i[2];
              u(f(e), e$0), o(t, e, y[1]), u(f(e), n$0);
              var T = y[2];
              function E(M) {
                return u(n, M);
              }
              function d(M) {
                return u(t, M);
              }
              R(Kv[1], d, E, e, T), u(f(e), t$0), u(f(e), u$0), u(f(e), i$0), o(f(e), x$0, f$0);
              var w = i[3];
              if (w) {
                g(e, o$0);
                var G = w[1], A = function(M, K) {
                  return g(M, XJ0);
                }, S = function(M) {
                  return u(t, M);
                };
                R(Dr[1], S, A, e, G), g(e, a$0);
              } else g(e, c$0);
              return u(f(e), s$0), u(f(e), v$0);
            }), N(xJ, function(t, n, e) {
              var i = o(k5, t, n);
              return o(C0(HJ0), i, e);
            });
            var oJ = [0, YC, fJ, k5, xJ], VC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, aJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(VC, function(t, n, e, i) {
              u(f(e), sJ0), o(f(e), lJ0, vJ0);
              var x = i[1];
              u(f(e), bJ0), o(t, e, x[1]), u(f(e), pJ0);
              var c = x[2];
              function s(k0) {
                return u(n, k0);
              }
              function p(k0) {
                return u(t, k0);
              }
              R(Kv[1], p, s, e, c), u(f(e), mJ0), u(f(e), _J0), u(f(e), yJ0), o(f(e), dJ0, hJ0);
              var y = i[2];
              if (y) {
                g(e, kJ0);
                var T = y[1], E = function(k0) {
                  return u(n, k0);
                }, d = function(k0) {
                  return u(t, k0);
                };
                R(oJ[1], d, E, e, T), g(e, wJ0);
              } else g(e, EJ0);
              u(f(e), SJ0), u(f(e), gJ0), o(f(e), TJ0, FJ0);
              var w = i[3];
              if (w) {
                var G = w[1];
                g(e, OJ0), u(f(e), IJ0), o(t, e, G[1]), u(f(e), AJ0);
                var A = G[2], S = function(k0) {
                  return u(n, k0);
                }, M = function(k0) {
                  return u(t, k0);
                };
                R(Kv[1], M, S, e, A), u(f(e), NJ0), g(e, CJ0);
              } else g(e, PJ0);
              u(f(e), DJ0), u(f(e), LJ0), o(f(e), jJ0, RJ0);
              var K = i[4];
              if (K) {
                g(e, GJ0);
                var V = K[1], f0 = function(k0, g0) {
                  return g(k0, cJ0);
                }, m0 = function(k0) {
                  return u(t, k0);
                };
                R(Dr[1], m0, f0, e, V), g(e, MJ0);
              } else g(e, BJ0);
              return u(f(e), qJ0), u(f(e), UJ0);
            }), N(aJ, function(t, n, e) {
              var i = o(VC, t, n);
              return o(C0(aJ0), i, e);
            });
            var cJ = [0, oJ, VC, aJ], zC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, sJ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, w5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, vJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(zC, function(t, n, e, i) {
              u(f(e), fJ0), o(t, e, i[1]), u(f(e), xJ0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(w5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), oJ0);
            }), N(sJ, function(t, n, e) {
              var i = o(zC, t, n);
              return o(C0(iJ0), i, e);
            }), N(w5, function(t, n, e, i) {
              u(f(e), zW0), o(f(e), WW0, KW0);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(di[5], s, c, e, x), u(f(e), JW0), u(f(e), $W0), o(f(e), QW0, ZW0);
              var p = i[2];
              if (p) {
                g(e, rJ0);
                var y = p[1], T = function(d) {
                  return u(n, d);
                }, E = function(d) {
                  return u(t, d);
                };
                R(qe[31], E, T, e, y), g(e, eJ0);
              } else g(e, nJ0);
              return u(f(e), tJ0), u(f(e), uJ0);
            }), N(vJ, function(t, n, e) {
              var i = o(w5, t, n);
              return o(C0(VW0), i, e);
            });
            var lJ = [0, zC, sJ, w5, vJ], KC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, bJ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, E5 = function t(n, e) {
              return t.fun(n, e);
            }, pJ = function t(n) {
              return t.fun(n);
            };
            N(KC, function(t, n, e, i) {
              u(f(e), OW0), o(f(e), AW0, IW0);
              var x = i[1];
              u(f(e), NW0);
              var c = 0;
              le(function(E, d) {
                E && u(f(e), TW0);
                function w(A) {
                  return u(n, A);
                }
                function G(A) {
                  return u(t, A);
                }
                return R(lJ[1], G, w, e, d), 1;
              }, c, x), u(f(e), CW0), u(f(e), PW0), u(f(e), DW0), o(f(e), RW0, LW0), o(E5, e, i[2]), u(f(e), jW0), u(f(e), GW0), o(f(e), BW0, MW0);
              var s = i[3];
              if (s) {
                g(e, qW0);
                var p = s[1], y = function(E, d) {
                  return g(E, FW0);
                }, T = function(E) {
                  return u(t, E);
                };
                R(Dr[1], T, y, e, p), g(e, UW0);
              } else g(e, HW0);
              return u(f(e), XW0), u(f(e), YW0);
            }), N(bJ, function(t, n, e) {
              var i = o(KC, t, n);
              return o(C0(gW0), i, e);
            }), N(E5, function(t, n) {
              switch (n) {
                case 0:
                  return g(t, wW0);
                case 1:
                  return g(t, EW0);
                default:
                  return g(t, SW0);
              }
            }), N(pJ, function(t) {
              return o(C0(kW0), E5, t);
            });
            var Il = [0, lJ, KC, bJ, E5, pJ], WC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, mJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(WC, function(t, n, e, i) {
              u(f(e), iW0), o(f(e), xW0, fW0);
              var x = i[1];
              function c(A) {
                return u(n, A);
              }
              function s(A) {
                return u(t, A);
              }
              R(qe[31], s, c, e, x), u(f(e), oW0), u(f(e), aW0), o(f(e), sW0, cW0);
              var p = i[2];
              function y(A) {
                return u(n, A);
              }
              function T(A) {
                return u(t, A);
              }
              R(Yu[35], T, y, e, p), u(f(e), vW0), u(f(e), lW0), o(f(e), pW0, bW0);
              var E = i[3];
              if (E) {
                g(e, mW0);
                var d = E[1], w = function(A, S) {
                  return g(A, uW0);
                }, G = function(A) {
                  return u(t, A);
                };
                R(Dr[1], G, w, e, d), g(e, _W0);
              } else g(e, yW0);
              return u(f(e), hW0), u(f(e), dW0);
            }), N(mJ, function(t, n, e) {
              var i = o(WC, t, n);
              return o(C0(tW0), i, e);
            });
            var _J = [0, WC, mJ], JC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, yJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(JC, function(t, n, e, i) {
              u(f(e), qK0), o(f(e), HK0, UK0);
              var x = i[1];
              function c(A) {
                return u(n, A);
              }
              function s(A) {
                return u(t, A);
              }
              R(Yu[35], s, c, e, x), u(f(e), XK0), u(f(e), YK0), o(f(e), zK0, VK0);
              var p = i[2];
              function y(A) {
                return u(n, A);
              }
              function T(A) {
                return u(t, A);
              }
              R(qe[31], T, y, e, p), u(f(e), KK0), u(f(e), WK0), o(f(e), $K0, JK0);
              var E = i[3];
              if (E) {
                g(e, ZK0);
                var d = E[1], w = function(A, S) {
                  return g(A, BK0);
                }, G = function(A) {
                  return u(t, A);
                };
                R(Dr[1], G, w, e, d), g(e, QK0);
              } else g(e, rW0);
              return u(f(e), eW0), u(f(e), nW0);
            }), N(yJ, function(t, n, e) {
              var i = o(JC, t, n);
              return o(C0(MK0), i, e);
            });
            var hJ = [0, JC, yJ], $C = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, dJ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, S5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, kJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N($C, function(t, n, e, i) {
              u(f(e), fK0), o(f(e), oK0, xK0);
              var x = i[1];
              if (x) {
                g(e, aK0);
                var c = x[1], s = function(g0) {
                  return u(n, g0);
                };
                R(S5, function(g0) {
                  return u(t, g0);
                }, s, e, c), g(e, cK0);
              } else g(e, sK0);
              u(f(e), vK0), u(f(e), lK0), o(f(e), pK0, bK0);
              var p = i[2];
              if (p) {
                g(e, mK0);
                var y = p[1], T = function(g0) {
                  return u(n, g0);
                }, E = function(g0) {
                  return u(t, g0);
                };
                R(qe[31], E, T, e, y), g(e, _K0);
              } else g(e, yK0);
              u(f(e), hK0), u(f(e), dK0), o(f(e), wK0, kK0);
              var d = i[3];
              if (d) {
                g(e, EK0);
                var w = d[1], G = function(g0) {
                  return u(n, g0);
                }, A = function(g0) {
                  return u(t, g0);
                };
                R(qe[31], A, G, e, w), g(e, SK0);
              } else g(e, gK0);
              u(f(e), FK0), u(f(e), TK0), o(f(e), IK0, OK0);
              var S = i[4];
              function M(g0) {
                return u(n, g0);
              }
              function K(g0) {
                return u(t, g0);
              }
              R(Yu[35], K, M, e, S), u(f(e), AK0), u(f(e), NK0), o(f(e), PK0, CK0);
              var V = i[5];
              if (V) {
                g(e, DK0);
                var f0 = V[1], m0 = function(g0, e0) {
                  return g(g0, iK0);
                }, k0 = function(g0) {
                  return u(t, g0);
                };
                R(Dr[1], k0, m0, e, f0), g(e, LK0);
              } else g(e, RK0);
              return u(f(e), jK0), u(f(e), GK0);
            }), N(dJ, function(t, n, e) {
              var i = o($C, t, n);
              return o(C0(uK0), i, e);
            }), N(S5, function(t, n, e, i) {
              if (i[0] === 0) {
                var x = i[1];
                u(f(e), $z0), u(f(e), Zz0), o(t, e, x[1]), u(f(e), Qz0);
                var c = x[2], s = function(d) {
                  return u(n, d);
                }, p = function(d) {
                  return u(t, d);
                };
                return R(Il[2], p, s, e, c), u(f(e), rK0), u(f(e), eK0);
              }
              u(f(e), nK0);
              var y = i[1];
              function T(d) {
                return u(n, d);
              }
              function E(d) {
                return u(t, d);
              }
              return R(qe[31], E, T, e, y), u(f(e), tK0);
            }), N(kJ, function(t, n, e) {
              var i = o(S5, t, n);
              return o(C0(Jz0), i, e);
            });
            var wJ = [0, $C, dJ, S5, kJ], ZC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, EJ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, g5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, SJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(ZC, function(t, n, e, i) {
              u(f(e), gz0), o(f(e), Tz0, Fz0);
              var x = i[1];
              function c(K) {
                return u(n, K);
              }
              R(g5, function(K) {
                return u(t, K);
              }, c, e, x), u(f(e), Oz0), u(f(e), Iz0), o(f(e), Nz0, Az0);
              var s = i[2];
              function p(K) {
                return u(n, K);
              }
              function y(K) {
                return u(t, K);
              }
              R(qe[31], y, p, e, s), u(f(e), Cz0), u(f(e), Pz0), o(f(e), Lz0, Dz0);
              var T = i[3];
              function E(K) {
                return u(n, K);
              }
              function d(K) {
                return u(t, K);
              }
              R(Yu[35], d, E, e, T), u(f(e), Rz0), u(f(e), jz0), o(f(e), Mz0, Gz0);
              var w = i[4];
              o(f(e), Bz0, w), u(f(e), qz0), u(f(e), Uz0), o(f(e), Xz0, Hz0);
              var G = i[5];
              if (G) {
                g(e, Yz0);
                var A = G[1], S = function(K, V) {
                  return g(K, Sz0);
                }, M = function(K) {
                  return u(t, K);
                };
                R(Dr[1], M, S, e, A), g(e, Vz0);
              } else g(e, zz0);
              return u(f(e), Kz0), u(f(e), Wz0);
            }), N(EJ, function(t, n, e) {
              var i = o(ZC, t, n);
              return o(C0(Ez0), i, e);
            }), N(g5, function(t, n, e, i) {
              if (i[0] === 0) {
                var x = i[1];
                u(f(e), mz0), u(f(e), _z0), o(t, e, x[1]), u(f(e), yz0);
                var c = x[2], s = function(d) {
                  return u(n, d);
                }, p = function(d) {
                  return u(t, d);
                };
                return R(Il[2], p, s, e, c), u(f(e), hz0), u(f(e), dz0);
              }
              u(f(e), kz0);
              var y = i[1];
              function T(d) {
                return u(n, d);
              }
              function E(d) {
                return u(t, d);
              }
              return R(di[5], E, T, e, y), u(f(e), wz0);
            }), N(SJ, function(t, n, e) {
              var i = o(g5, t, n);
              return o(C0(pz0), i, e);
            });
            var gJ = [0, ZC, EJ, g5, SJ], QC = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, FJ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, F5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, TJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(QC, function(t, n, e, i) {
              u(f(e), XV0), o(f(e), VV0, YV0);
              var x = i[1];
              function c(K) {
                return u(n, K);
              }
              R(F5, function(K) {
                return u(t, K);
              }, c, e, x), u(f(e), zV0), u(f(e), KV0), o(f(e), JV0, WV0);
              var s = i[2];
              function p(K) {
                return u(n, K);
              }
              function y(K) {
                return u(t, K);
              }
              R(qe[31], y, p, e, s), u(f(e), $V0), u(f(e), ZV0), o(f(e), rz0, QV0);
              var T = i[3];
              function E(K) {
                return u(n, K);
              }
              function d(K) {
                return u(t, K);
              }
              R(Yu[35], d, E, e, T), u(f(e), ez0), u(f(e), nz0), o(f(e), uz0, tz0);
              var w = i[4];
              o(f(e), iz0, w), u(f(e), fz0), u(f(e), xz0), o(f(e), az0, oz0);
              var G = i[5];
              if (G) {
                g(e, cz0);
                var A = G[1], S = function(K, V) {
                  return g(K, HV0);
                }, M = function(K) {
                  return u(t, K);
                };
                R(Dr[1], M, S, e, A), g(e, sz0);
              } else g(e, vz0);
              return u(f(e), lz0), u(f(e), bz0);
            }), N(FJ, function(t, n, e) {
              var i = o(QC, t, n);
              return o(C0(UV0), i, e);
            }), N(F5, function(t, n, e, i) {
              if (i[0] === 0) {
                var x = i[1];
                u(f(e), LV0), u(f(e), RV0), o(t, e, x[1]), u(f(e), jV0);
                var c = x[2], s = function(d) {
                  return u(n, d);
                }, p = function(d) {
                  return u(t, d);
                };
                return R(Il[2], p, s, e, c), u(f(e), GV0), u(f(e), MV0);
              }
              u(f(e), BV0);
              var y = i[1];
              function T(d) {
                return u(n, d);
              }
              function E(d) {
                return u(t, d);
              }
              return R(di[5], E, T, e, y), u(f(e), qV0);
            }), N(TJ, function(t, n, e) {
              var i = o(F5, t, n);
              return o(C0(DV0), i, e);
            });
            var OJ = [0, QC, FJ, F5, TJ], rP = function t(n, e, i) {
              return t.fun(n, e, i);
            }, IJ = function t(n, e) {
              return t.fun(n, e);
            }, T5 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, AJ = function t(n, e) {
              return t.fun(n, e);
            };
            N(rP, function(t, n, e) {
              u(f(n), NV0), o(t, n, e[1]), u(f(n), CV0);
              var i = e[2];
              return ur(T5, function(x) {
                return u(t, x);
              }, n, i), u(f(n), PV0);
            }), N(IJ, function(t, n) {
              var e = u(rP, t);
              return o(C0(AV0), e, n);
            }), N(T5, function(t, n, e) {
              u(f(n), gV0), o(f(n), TV0, FV0);
              var i = e[1];
              function x(s) {
                return u(t, s);
              }
              function c(s) {
                return u(t, s);
              }
              return R(Rn[1], c, x, n, i), u(f(n), OV0), u(f(n), IV0);
            }), N(AJ, function(t, n) {
              var e = u(T5, t);
              return o(C0(SV0), e, n);
            });
            var eP = [0, rP, IJ, T5, AJ], nP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, NJ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, O5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, CJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(nP, function(t, n, e, i) {
              u(f(e), kV0), o(n, e, i[1]), u(f(e), wV0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(O5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), EV0);
            }), N(NJ, function(t, n, e) {
              var i = o(nP, t, n);
              return o(C0(dV0), i, e);
            }), N(O5, function(t, n, e, i) {
              u(f(e), oV0), o(f(e), cV0, aV0);
              var x = i[1];
              function c(y) {
                return u(n, y);
              }
              function s(y) {
                return u(n, y);
              }
              R(Rn[1], s, c, e, x), u(f(e), sV0), u(f(e), vV0), o(f(e), bV0, lV0);
              var p = i[2];
              return u(f(e), pV0), o(n, e, p[1]), u(f(e), mV0), o(t, e, p[2]), u(f(e), _V0), u(f(e), yV0), u(f(e), hV0);
            }), N(CJ, function(t, n, e) {
              var i = o(O5, t, n);
              return o(C0(xV0), i, e);
            });
            var I5 = [0, nP, NJ, O5, CJ], tP = function t(n, e, i) {
              return t.fun(n, e, i);
            }, PJ = function t(n, e) {
              return t.fun(n, e);
            };
            N(tP, function(t, n, e) {
              u(f(n), jY0), o(f(n), MY0, GY0);
              var i = e[1];
              u(f(n), BY0);
              var x = 0;
              le(function(d, w) {
                d && u(f(n), RY0);
                function G(S) {
                  return u(t, S);
                }
                function A(S) {
                  function M(K) {
                    return u(t, K);
                  }
                  return o(qN[1], M, S);
                }
                return R(I5[1], A, G, n, w), 1;
              }, x, i), u(f(n), qY0), u(f(n), UY0), u(f(n), HY0), o(f(n), YY0, XY0);
              var c = e[2];
              o(f(n), VY0, c), u(f(n), zY0), u(f(n), KY0), o(f(n), JY0, WY0);
              var s = e[3];
              o(f(n), $Y0, s), u(f(n), ZY0), u(f(n), QY0), o(f(n), eV0, rV0);
              var p = e[4];
              if (p) {
                g(n, nV0);
                var y = p[1], T = function(d, w) {
                  u(f(d), DY0);
                  var G = 0;
                  return le(function(A, S) {
                    A && u(f(d), PY0);
                    function M(K) {
                      return u(t, K);
                    }
                    return ur(iu[1], M, d, S), 1;
                  }, G, w), u(f(d), LY0);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, n, y), g(n, tV0);
              } else g(n, uV0);
              return u(f(n), iV0), u(f(n), fV0);
            }), N(PJ, function(t, n) {
              var e = u(tP, t);
              return o(C0(CY0), e, n);
            });
            var DJ = [0, tP, PJ], uP = function t(n, e, i) {
              return t.fun(n, e, i);
            }, LJ = function t(n, e) {
              return t.fun(n, e);
            };
            N(uP, function(t, n, e) {
              u(f(n), oY0), o(f(n), cY0, aY0);
              var i = e[1];
              u(f(n), sY0);
              var x = 0;
              le(function(d, w) {
                d && u(f(n), xY0);
                function G(S) {
                  return u(t, S);
                }
                function A(S) {
                  function M(K) {
                    return u(t, K);
                  }
                  return o(BN[1], M, S);
                }
                return R(I5[1], A, G, n, w), 1;
              }, x, i), u(f(n), vY0), u(f(n), lY0), u(f(n), bY0), o(f(n), mY0, pY0);
              var c = e[2];
              o(f(n), _Y0, c), u(f(n), yY0), u(f(n), hY0), o(f(n), kY0, dY0);
              var s = e[3];
              o(f(n), wY0, s), u(f(n), EY0), u(f(n), SY0), o(f(n), FY0, gY0);
              var p = e[4];
              if (p) {
                g(n, TY0);
                var y = p[1], T = function(d, w) {
                  u(f(d), iY0);
                  var G = 0;
                  return le(function(A, S) {
                    A && u(f(d), uY0);
                    function M(K) {
                      return u(t, K);
                    }
                    return ur(iu[1], M, d, S), 1;
                  }, G, w), u(f(d), fY0);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, n, y), g(n, OY0);
              } else g(n, IY0);
              return u(f(n), AY0), u(f(n), NY0);
            }), N(LJ, function(t, n) {
              var e = u(uP, t);
              return o(C0(tY0), e, n);
            });
            var RJ = [0, uP, LJ], iP = function t(n, e, i) {
              return t.fun(n, e, i);
            }, jJ = function t(n, e) {
              return t.fun(n, e);
            }, A5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, GJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(iP, function(t, n, e) {
              u(f(n), LX0), o(f(n), jX0, RX0);
              var i = e[1];
              function x(d) {
                return u(t, d);
              }
              R(A5, function(d) {
                function w(G) {
                  return u(t, G);
                }
                return o(g1[1], w, d);
              }, x, n, i), u(f(n), GX0), u(f(n), MX0), o(f(n), qX0, BX0);
              var c = e[2];
              o(f(n), UX0, c), u(f(n), HX0), u(f(n), XX0), o(f(n), VX0, YX0);
              var s = e[3];
              o(f(n), zX0, s), u(f(n), KX0), u(f(n), WX0), o(f(n), $X0, JX0);
              var p = e[4];
              if (p) {
                g(n, ZX0);
                var y = p[1], T = function(d, w) {
                  u(f(d), PX0);
                  var G = 0;
                  return le(function(A, S) {
                    A && u(f(d), CX0);
                    function M(K) {
                      return u(t, K);
                    }
                    return ur(iu[1], M, d, S), 1;
                  }, G, w), u(f(d), DX0);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, n, y), g(n, QX0);
              } else g(n, rY0);
              return u(f(n), eY0), u(f(n), nY0);
            }), N(jJ, function(t, n) {
              var e = u(iP, t);
              return o(C0(NX0), e, n);
            }), N(A5, function(t, n, e, i) {
              if (i[0] === 0) {
                u(f(e), EX0), u(f(e), SX0);
                var x = i[1], c = 0;
                return le(function(y, T) {
                  y && u(f(e), wX0);
                  function E(d) {
                    return u(n, d);
                  }
                  return ur(eP[1], E, e, T), 1;
                }, c, x), u(f(e), gX0), u(f(e), FX0);
              }
              u(f(e), TX0), u(f(e), OX0);
              var s = i[1], p = 0;
              return le(function(y, T) {
                y && u(f(e), kX0);
                function E(w) {
                  return u(n, w);
                }
                function d(w) {
                  return u(t, w);
                }
                return R(I5[1], d, E, e, T), 1;
              }, p, s), u(f(e), IX0), u(f(e), AX0);
            }), N(GJ, function(t, n, e) {
              var i = o(A5, t, n);
              return o(C0(dX0), i, e);
            });
            var MJ = [0, iP, jJ, A5, GJ], fP = function t(n, e, i) {
              return t.fun(n, e, i);
            }, BJ = function t(n, e) {
              return t.fun(n, e);
            };
            N(fP, function(t, n, e) {
              u(f(n), eX0), o(f(n), tX0, nX0);
              var i = e[1];
              u(f(n), uX0);
              var x = 0;
              le(function(E, d) {
                E && u(f(n), rX0);
                function w(G) {
                  return u(t, G);
                }
                return ur(eP[1], w, n, d), 1;
              }, x, i), u(f(n), iX0), u(f(n), fX0), u(f(n), xX0), o(f(n), aX0, oX0);
              var c = e[2];
              o(f(n), cX0, c), u(f(n), sX0), u(f(n), vX0), o(f(n), bX0, lX0);
              var s = e[3];
              if (s) {
                g(n, pX0);
                var p = s[1], y = function(E, d) {
                  u(f(E), ZH0);
                  var w = 0;
                  return le(function(G, A) {
                    G && u(f(E), $H0);
                    function S(M) {
                      return u(t, M);
                    }
                    return ur(iu[1], S, E, A), 1;
                  }, w, d), u(f(E), QH0);
                }, T = function(E) {
                  return u(t, E);
                };
                R(Dr[1], T, y, n, p), g(n, mX0);
              } else g(n, _X0);
              return u(f(n), yX0), u(f(n), hX0);
            }), N(BJ, function(t, n) {
              var e = u(fP, t);
              return o(C0(JH0), e, n);
            });
            var qJ = [0, fP, BJ], xP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, UJ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, N5 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, HJ = function t(n, e) {
              return t.fun(n, e);
            }, C5 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, XJ = function t(n, e) {
              return t.fun(n, e);
            };
            N(xP, function(t, n, e, i) {
              u(f(e), DH0), o(f(e), RH0, LH0);
              var x = i[1];
              function c(w) {
                return u(n, w);
              }
              function s(w) {
                return u(t, w);
              }
              R(Rn[1], s, c, e, x), u(f(e), jH0), u(f(e), GH0), o(f(e), BH0, MH0);
              var p = i[2];
              ur(N5, function(w) {
                return u(t, w);
              }, e, p), u(f(e), qH0), u(f(e), UH0), o(f(e), XH0, HH0);
              var y = i[3];
              if (y) {
                g(e, YH0);
                var T = y[1], E = function(w, G) {
                  return g(w, PH0);
                }, d = function(w) {
                  return u(t, w);
                };
                R(Dr[1], d, E, e, T), g(e, VH0);
              } else g(e, zH0);
              return u(f(e), KH0), u(f(e), WH0);
            }), N(UJ, function(t, n, e) {
              var i = o(xP, t, n);
              return o(C0(CH0), i, e);
            }), N(N5, function(t, n, e) {
              u(f(n), IH0), o(t, n, e[1]), u(f(n), AH0);
              var i = e[2];
              return ur(C5, function(x) {
                return u(t, x);
              }, n, i), u(f(n), NH0);
            }), N(HJ, function(t, n) {
              var e = u(N5, t);
              return o(C0(OH0), e, n);
            }), N(C5, function(t, n, e) {
              switch (e[0]) {
                case 0:
                  u(f(n), dH0);
                  var i = e[1], x = function(d) {
                    return u(t, d);
                  };
                  return ur(DJ[1], x, n, i), u(f(n), kH0);
                case 1:
                  u(f(n), wH0);
                  var c = e[1], s = function(d) {
                    return u(t, d);
                  };
                  return ur(RJ[1], s, n, c), u(f(n), EH0);
                case 2:
                  u(f(n), SH0);
                  var p = e[1], y = function(d) {
                    return u(t, d);
                  };
                  return ur(MJ[1], y, n, p), u(f(n), gH0);
                default:
                  u(f(n), FH0);
                  var T = e[1], E = function(d) {
                    return u(t, d);
                  };
                  return ur(qJ[1], E, n, T), u(f(n), TH0);
              }
            }), N(XJ, function(t, n) {
              var e = u(C5, t);
              return o(C0(hH0), e, n);
            });
            var YJ = [0, eP, I5, DJ, RJ, MJ, qJ, xP, UJ, N5, HJ, C5, XJ], oP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, VJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(oP, function(t, n, e, i) {
              u(f(e), qU0), o(f(e), HU0, UU0);
              var x = i[1];
              function c(k0) {
                return u(n, k0);
              }
              function s(k0) {
                return u(t, k0);
              }
              R(Rn[1], s, c, e, x), u(f(e), XU0), u(f(e), YU0), o(f(e), zU0, VU0);
              var p = i[2];
              if (p) {
                g(e, KU0);
                var y = p[1], T = function(k0) {
                  return u(n, k0);
                }, E = function(k0) {
                  return u(t, k0);
                };
                R($e[22][1], E, T, e, y), g(e, WU0);
              } else g(e, JU0);
              u(f(e), $U0), u(f(e), ZU0), o(f(e), rH0, QU0);
              var d = i[3];
              u(f(e), eH0);
              var w = 0;
              le(function(k0, g0) {
                k0 && u(f(e), jU0), u(f(e), GU0), o(t, e, g0[1]), u(f(e), MU0);
                var e0 = g0[2];
                function x0(c0) {
                  return u(n, c0);
                }
                function l(c0) {
                  return u(t, c0);
                }
                return R($e[2][2], l, x0, e, e0), u(f(e), BU0), 1;
              }, w, d), u(f(e), nH0), u(f(e), tH0), u(f(e), uH0), o(f(e), fH0, iH0);
              var G = i[4];
              u(f(e), xH0), o(t, e, G[1]), u(f(e), oH0);
              var A = G[2];
              function S(k0) {
                return u(n, k0);
              }
              function M(k0) {
                return u(t, k0);
              }
              R($e[5][6], M, S, e, A), u(f(e), aH0), u(f(e), cH0), u(f(e), sH0), o(f(e), lH0, vH0);
              var K = i[5];
              if (K) {
                g(e, bH0);
                var V = K[1], f0 = function(k0, g0) {
                  return g(k0, RU0);
                }, m0 = function(k0) {
                  return u(t, k0);
                };
                R(Dr[1], m0, f0, e, V), g(e, pH0);
              } else g(e, mH0);
              return u(f(e), _H0), u(f(e), yH0);
            }), N(VJ, function(t, n, e) {
              var i = o(oP, t, n);
              return o(C0(LU0), i, e);
            });
            var P5 = [0, oP, VJ], aP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, zJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(aP, function(t, n, e, i) {
              u(f(e), Bq0), o(f(e), Uq0, qq0);
              var x = i[1];
              function c(_0) {
                return u(n, _0);
              }
              function s(_0) {
                return u(t, _0);
              }
              R(Rn[1], s, c, e, x), u(f(e), Hq0), u(f(e), Xq0), o(f(e), Vq0, Yq0);
              var p = i[2];
              if (p) {
                g(e, zq0);
                var y = p[1], T = function(_0) {
                  return u(n, _0);
                }, E = function(_0) {
                  return u(t, _0);
                };
                R($e[22][1], E, T, e, y), g(e, Kq0);
              } else g(e, Wq0);
              u(f(e), Jq0), u(f(e), $q0), o(f(e), Qq0, Zq0);
              var d = i[3];
              u(f(e), rU0), o(t, e, d[1]), u(f(e), eU0);
              var w = d[2];
              function G(_0) {
                return u(n, _0);
              }
              function A(_0) {
                return u(t, _0);
              }
              R($e[5][6], A, G, e, w), u(f(e), nU0), u(f(e), tU0), u(f(e), uU0), o(f(e), fU0, iU0);
              var S = i[4];
              if (S) {
                var M = S[1];
                g(e, xU0), u(f(e), oU0), o(t, e, M[1]), u(f(e), aU0);
                var K = M[2], V = function(_0) {
                  return u(n, _0);
                }, f0 = function(_0) {
                  return u(t, _0);
                };
                R($e[2][2], f0, V, e, K), u(f(e), cU0), g(e, sU0);
              } else g(e, vU0);
              u(f(e), lU0), u(f(e), bU0), o(f(e), mU0, pU0);
              var m0 = i[5];
              u(f(e), _U0);
              var k0 = 0;
              le(function(_0, E0) {
                _0 && u(f(e), Rq0), u(f(e), jq0), o(t, e, E0[1]), u(f(e), Gq0);
                var U0 = E0[2];
                function b(X) {
                  return u(n, X);
                }
                function R0(X) {
                  return u(t, X);
                }
                return R($e[2][2], R0, b, e, U0), u(f(e), Mq0), 1;
              }, k0, m0), u(f(e), yU0), u(f(e), hU0), u(f(e), dU0), o(f(e), wU0, kU0);
              var g0 = i[6];
              if (g0) {
                g(e, EU0);
                var e0 = g0[1], x0 = function(_0) {
                  return u(n, _0);
                }, l = function(_0) {
                  return u(t, _0);
                };
                R(F1[5][2], l, x0, e, e0), g(e, SU0);
              } else g(e, gU0);
              u(f(e), FU0), u(f(e), TU0), o(f(e), IU0, OU0);
              var c0 = i[7];
              if (c0) {
                g(e, AU0);
                var t0 = c0[1], o0 = function(_0, E0) {
                  return g(_0, Lq0);
                }, w0 = function(_0) {
                  return u(t, _0);
                };
                R(Dr[1], w0, o0, e, t0), g(e, NU0);
              } else g(e, CU0);
              return u(f(e), PU0), u(f(e), DU0);
            }), N(zJ, function(t, n, e) {
              var i = o(aP, t, n);
              return o(C0(Dq0), i, e);
            });
            var cP = [0, aP, zJ], sP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, KJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(sP, function(t, n, e, i) {
              u(f(e), yq0), o(f(e), dq0, hq0);
              var x = i[1];
              function c(A) {
                return u(n, A);
              }
              function s(A) {
                return u(t, A);
              }
              R(Rn[1], s, c, e, x), u(f(e), kq0), u(f(e), wq0), o(f(e), Sq0, Eq0);
              var p = i[2];
              function y(A) {
                return u(n, A);
              }
              function T(A) {
                return u(t, A);
              }
              R($e[17], T, y, e, p), u(f(e), gq0), u(f(e), Fq0), o(f(e), Oq0, Tq0);
              var E = i[3];
              if (E) {
                g(e, Iq0);
                var d = E[1], w = function(A, S) {
                  return g(A, _q0);
                }, G = function(A) {
                  return u(t, A);
                };
                R(Dr[1], G, w, e, d), g(e, Aq0);
              } else g(e, Nq0);
              return u(f(e), Cq0), u(f(e), Pq0);
            }), N(KJ, function(t, n, e) {
              var i = o(sP, t, n);
              return o(C0(mq0), i, e);
            });
            var vP = [0, sP, KJ], lP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, WJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(lP, function(t, n, e, i) {
              u(f(e), zB0), o(f(e), WB0, KB0);
              var x = i[1];
              function c(V) {
                return u(n, V);
              }
              function s(V) {
                return u(t, V);
              }
              R(Rn[1], s, c, e, x), u(f(e), JB0), u(f(e), $B0), o(f(e), QB0, ZB0);
              var p = i[2];
              function y(V) {
                return u(n, V);
              }
              function T(V) {
                return u(t, V);
              }
              R($e[17], T, y, e, p), u(f(e), rq0), u(f(e), eq0), o(f(e), tq0, nq0);
              var E = i[3];
              if (E) {
                g(e, uq0);
                var d = E[1], w = function(V) {
                  return u(n, V);
                }, G = function(V) {
                  return u(t, V);
                };
                R($e[24][1], G, w, e, d), g(e, iq0);
              } else g(e, fq0);
              u(f(e), xq0), u(f(e), oq0), o(f(e), cq0, aq0);
              var A = i[4];
              if (A) {
                g(e, sq0);
                var S = A[1], M = function(V, f0) {
                  return g(V, VB0);
                }, K = function(V) {
                  return u(t, V);
                };
                R(Dr[1], K, M, e, S), g(e, vq0);
              } else g(e, lq0);
              return u(f(e), bq0), u(f(e), pq0);
            }), N(WJ, function(t, n, e) {
              var i = o(lP, t, n);
              return o(C0(YB0), i, e);
            });
            var bP = [0, lP, WJ], D5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, JJ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, L5 = function t(n, e) {
              return t.fun(n, e);
            }, $J = function t(n) {
              return t.fun(n);
            }, pP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, ZJ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(D5, function(t, n, e, i) {
              if (i[0] === 0) {
                u(f(e), GB0);
                var x = i[1], c = function(E) {
                  return u(n, E);
                }, s = function(E) {
                  return u(t, E);
                };
                return R(Rn[1], s, c, e, x), u(f(e), MB0);
              }
              var p = i[1];
              u(f(e), BB0), u(f(e), qB0), o(n, e, p[1]), u(f(e), UB0);
              var y = p[2];
              function T(E) {
                return u(t, E);
              }
              return ur(g1[1], T, e, y), u(f(e), HB0), u(f(e), XB0);
            }), N(JJ, function(t, n, e) {
              var i = o(D5, t, n);
              return o(C0(jB0), i, e);
            }), N(L5, function(t, n) {
              return n ? g(t, LB0) : g(t, RB0);
            }), N($J, function(t) {
              return o(C0(DB0), L5, t);
            }), N(pP, function(t, n, e, i) {
              u(f(e), sB0), o(f(e), lB0, vB0);
              var x = i[1];
              function c(A) {
                return u(n, A);
              }
              R(D5, function(A) {
                return u(t, A);
              }, c, e, x), u(f(e), bB0), u(f(e), pB0), o(f(e), _B0, mB0);
              var s = i[2];
              u(f(e), yB0), o(t, e, s[1]), u(f(e), hB0);
              var p = s[2];
              function y(A) {
                return u(n, A);
              }
              function T(A) {
                return u(t, A);
              }
              R(Kv[1], T, y, e, p), u(f(e), dB0), u(f(e), kB0), u(f(e), wB0), o(f(e), SB0, EB0), o(L5, e, i[3]), u(f(e), gB0), u(f(e), FB0), o(f(e), OB0, TB0);
              var E = i[4];
              if (E) {
                g(e, IB0);
                var d = E[1], w = function(A, S) {
                  return g(A, cB0);
                }, G = function(A) {
                  return u(t, A);
                };
                R(Dr[1], G, w, e, d), g(e, AB0);
              } else g(e, NB0);
              return u(f(e), CB0), u(f(e), PB0);
            }), N(ZJ, function(t, n, e) {
              var i = o(pP, t, n);
              return o(C0(aB0), i, e);
            });
            var QJ = [0, D5, JJ, L5, $J, pP, ZJ], mP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, r$ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(mP, function(t, n, e, i) {
              u(f(e), $M0), o(f(e), QM0, ZM0);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R($e[17], s, c, e, x), u(f(e), rB0), u(f(e), eB0), o(f(e), tB0, nB0);
              var p = i[2];
              if (p) {
                g(e, uB0);
                var y = p[1], T = function(d, w) {
                  return g(d, JM0);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, iB0);
              } else g(e, fB0);
              return u(f(e), xB0), u(f(e), oB0);
            }), N(r$, function(t, n, e) {
              var i = o(mP, t, n);
              return o(C0(WM0), i, e);
            });
            var e$ = [0, mP, r$], _P = function t(n, e, i) {
              return t.fun(n, e, i);
            }, n$ = function t(n, e) {
              return t.fun(n, e);
            }, R5 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, t$ = function t(n, e) {
              return t.fun(n, e);
            };
            N(_P, function(t, n, e) {
              u(f(n), VM0), o(t, n, e[1]), u(f(n), zM0);
              var i = e[2];
              return ur(R5, function(x) {
                return u(t, x);
              }, n, i), u(f(n), KM0);
            }), N(n$, function(t, n) {
              var e = u(_P, t);
              return o(C0(YM0), e, n);
            }), N(R5, function(t, n, e) {
              u(f(n), PM0), o(f(n), LM0, DM0);
              var i = e[1];
              function x(E) {
                return u(t, E);
              }
              function c(E) {
                return u(t, E);
              }
              R(Rn[1], c, x, n, i), u(f(n), RM0), u(f(n), jM0), o(f(n), MM0, GM0);
              var s = e[2];
              if (s) {
                g(n, BM0);
                var p = s[1], y = function(E) {
                  return u(t, E);
                }, T = function(E) {
                  return u(t, E);
                };
                R(Rn[1], T, y, n, p), g(n, qM0);
              } else g(n, UM0);
              return u(f(n), HM0), u(f(n), XM0);
            }), N(t$, function(t, n) {
              var e = u(R5, t);
              return o(C0(CM0), e, n);
            });
            var u$ = [0, _P, n$, R5, t$], yP = function t(n, e, i) {
              return t.fun(n, e, i);
            }, i$ = function t(n, e) {
              return t.fun(n, e);
            };
            N(yP, function(t, n, e) {
              var i = e[2];
              if (u(f(n), FM0), o(t, n, e[1]), u(f(n), TM0), i) {
                g(n, OM0);
                var x = i[1], c = function(p) {
                  return u(t, p);
                }, s = function(p) {
                  return u(t, p);
                };
                R(Rn[1], s, c, n, x), g(n, IM0);
              } else g(n, AM0);
              return u(f(n), NM0);
            }), N(i$, function(t, n) {
              var e = u(yP, t);
              return o(C0(gM0), e, n);
            });
            var f$ = [0, yP, i$], hP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, x$ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, j5 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, o$ = function t(n, e) {
              return t.fun(n, e);
            };
            N(hP, function(t, n, e, i) {
              u(f(e), HG0), o(f(e), YG0, XG0);
              var x = i[1];
              if (x) {
                g(e, VG0);
                var c = x[1], s = function(V) {
                  return u(n, V);
                }, p = function(V) {
                  return u(t, V);
                };
                R(Yu[35], p, s, e, c), g(e, zG0);
              } else g(e, KG0);
              u(f(e), WG0), u(f(e), JG0), o(f(e), ZG0, $G0);
              var y = i[2];
              if (y) {
                g(e, QG0);
                var T = y[1];
                ur(j5, function(V) {
                  return u(t, V);
                }, e, T), g(e, rM0);
              } else g(e, eM0);
              u(f(e), nM0), u(f(e), tM0), o(f(e), iM0, uM0);
              var E = i[3];
              if (E) {
                var d = E[1];
                g(e, fM0), u(f(e), xM0), o(t, e, d[1]), u(f(e), oM0);
                var w = d[2], G = function(V) {
                  return u(t, V);
                };
                ur(g1[1], G, e, w), u(f(e), aM0), g(e, cM0);
              } else g(e, sM0);
              u(f(e), vM0), u(f(e), lM0), o(f(e), pM0, bM0), o(Yu[33], e, i[4]), u(f(e), mM0), u(f(e), _M0), o(f(e), hM0, yM0);
              var A = i[5];
              if (A) {
                g(e, dM0);
                var S = A[1], M = function(V, f0) {
                  return g(V, UG0);
                }, K = function(V) {
                  return u(t, V);
                };
                R(Dr[1], K, M, e, S), g(e, kM0);
              } else g(e, wM0);
              return u(f(e), EM0), u(f(e), SM0);
            }), N(x$, function(t, n, e) {
              var i = o(hP, t, n);
              return o(C0(qG0), i, e);
            }), N(j5, function(t, n, e) {
              if (e[0] === 0) {
                u(f(n), LG0), u(f(n), RG0);
                var i = e[1], x = 0;
                return le(function(p, y) {
                  p && u(f(n), DG0);
                  function T(E) {
                    return u(t, E);
                  }
                  return ur(u$[1], T, n, y), 1;
                }, x, i), u(f(n), jG0), u(f(n), GG0);
              }
              u(f(n), MG0);
              var c = e[1];
              function s(p) {
                return u(t, p);
              }
              return ur(f$[1], s, n, c), u(f(n), BG0);
            }), N(o$, function(t, n) {
              var e = u(j5, t);
              return o(C0(PG0), e, n);
            });
            var dP = [0, u$, f$, hP, x$, j5, o$], kP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, a$ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, G5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, c$ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(kP, function(t, n, e, i) {
              u(f(e), _G0), o(f(e), hG0, yG0), o(t, e, i[1]), u(f(e), dG0), u(f(e), kG0), o(f(e), EG0, wG0);
              var x = i[2];
              function c(E) {
                return u(n, E);
              }
              R(G5, function(E) {
                return u(t, E);
              }, c, e, x), u(f(e), SG0), u(f(e), gG0), o(f(e), TG0, FG0);
              var s = i[3];
              if (s) {
                g(e, OG0);
                var p = s[1], y = function(E, d) {
                  return g(E, mG0);
                }, T = function(E) {
                  return u(t, E);
                };
                R(Dr[1], T, y, e, p), g(e, IG0);
              } else g(e, AG0);
              return u(f(e), NG0), u(f(e), CG0);
            }), N(a$, function(t, n, e) {
              var i = o(kP, t, n);
              return o(C0(pG0), i, e);
            }), N(G5, function(t, n, e, i) {
              if (i[0] === 0) {
                u(f(e), sG0);
                var x = i[1], c = function(E) {
                  return u(n, E);
                }, s = function(E) {
                  return u(t, E);
                };
                return R(Yu[35], s, c, e, x), u(f(e), vG0);
              }
              u(f(e), lG0);
              var p = i[1];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t, E);
              }
              return R(qe[31], T, y, e, p), u(f(e), bG0);
            }), N(c$, function(t, n, e) {
              var i = o(G5, t, n);
              return o(C0(cG0), i, e);
            });
            var s$ = [0, kP, a$, G5, c$], M5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, v$ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, wP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, l$ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(M5, function(t, n, e, i) {
              switch (i[0]) {
                case 0:
                  var x = i[1];
                  u(f(e), Cj0), u(f(e), Pj0), o(t, e, x[1]), u(f(e), Dj0);
                  var c = x[2], s = function(E0) {
                    return u(n, E0);
                  }, p = function(E0) {
                    return u(t, E0);
                  };
                  return R(vP[1], p, s, e, c), u(f(e), Lj0), u(f(e), Rj0);
                case 1:
                  var y = i[1];
                  u(f(e), jj0), u(f(e), Gj0), o(t, e, y[1]), u(f(e), Mj0);
                  var T = y[2], E = function(E0) {
                    return u(n, E0);
                  }, d = function(E0) {
                    return u(t, E0);
                  };
                  return R(bP[1], d, E, e, T), u(f(e), Bj0), u(f(e), qj0);
                case 2:
                  var w = i[1];
                  u(f(e), Uj0), u(f(e), Hj0), o(t, e, w[1]), u(f(e), Xj0);
                  var G = w[2], A = function(E0) {
                    return u(n, E0);
                  }, S = function(E0) {
                    return u(t, E0);
                  };
                  return R(cP[1], S, A, e, G), u(f(e), Yj0), u(f(e), Vj0);
                case 3:
                  u(f(e), zj0);
                  var M = i[1], K = function(E0) {
                    return u(n, E0);
                  }, V = function(E0) {
                    return u(t, E0);
                  };
                  return R($e[13], V, K, e, M), u(f(e), Kj0);
                case 4:
                  var f0 = i[1];
                  u(f(e), Wj0), u(f(e), Jj0), o(t, e, f0[1]), u(f(e), $j0);
                  var m0 = f0[2], k0 = function(E0) {
                    return u(n, E0);
                  }, g0 = function(E0) {
                    return u(t, E0);
                  };
                  return R(y5[1], g0, k0, e, m0), u(f(e), Zj0), u(f(e), Qj0);
                case 5:
                  var e0 = i[1];
                  u(f(e), rG0), u(f(e), eG0), o(t, e, e0[1]), u(f(e), nG0);
                  var x0 = e0[2], l = function(E0) {
                    return u(n, E0);
                  }, c0 = function(E0) {
                    return u(t, E0);
                  };
                  return R(h5[1], c0, l, e, x0), u(f(e), tG0), u(f(e), uG0);
                default:
                  var t0 = i[1];
                  u(f(e), iG0), u(f(e), fG0), o(t, e, t0[1]), u(f(e), xG0);
                  var o0 = t0[2], w0 = function(E0) {
                    return u(n, E0);
                  }, _0 = function(E0) {
                    return u(t, E0);
                  };
                  return R(P5[1], _0, w0, e, o0), u(f(e), oG0), u(f(e), aG0);
              }
            }), N(v$, function(t, n, e) {
              var i = o(M5, t, n);
              return o(C0(Nj0), i, e);
            }), N(wP, function(t, n, e, i) {
              u(f(e), VR0), o(f(e), KR0, zR0);
              var x = i[1];
              x ? (g(e, WR0), o(t, e, x[1]), g(e, JR0)) : g(e, $R0), u(f(e), ZR0), u(f(e), QR0), o(f(e), ej0, rj0);
              var c = i[2];
              if (c) {
                g(e, nj0);
                var s = c[1], p = function(f0) {
                  return u(n, f0);
                };
                R(M5, function(f0) {
                  return u(t, f0);
                }, p, e, s), g(e, tj0);
              } else g(e, uj0);
              u(f(e), ij0), u(f(e), fj0), o(f(e), oj0, xj0);
              var y = i[3];
              if (y) {
                g(e, aj0);
                var T = y[1], E = function(f0) {
                  return u(t, f0);
                };
                ur(dP[5], E, e, T), g(e, cj0);
              } else g(e, sj0);
              u(f(e), vj0), u(f(e), lj0), o(f(e), pj0, bj0);
              var d = i[4];
              if (d) {
                var w = d[1];
                g(e, mj0), u(f(e), _j0), o(t, e, w[1]), u(f(e), yj0);
                var G = w[2], A = function(f0) {
                  return u(t, f0);
                };
                ur(g1[1], A, e, G), u(f(e), hj0), g(e, dj0);
              } else g(e, kj0);
              u(f(e), wj0), u(f(e), Ej0), o(f(e), gj0, Sj0);
              var S = i[5];
              if (S) {
                g(e, Fj0);
                var M = S[1], K = function(f0, m0) {
                  return g(f0, YR0);
                }, V = function(f0) {
                  return u(t, f0);
                };
                R(Dr[1], V, K, e, M), g(e, Tj0);
              } else g(e, Oj0);
              return u(f(e), Ij0), u(f(e), Aj0);
            }), N(l$, function(t, n, e) {
              var i = o(wP, t, n);
              return o(C0(XR0), i, e);
            });
            var b$ = [0, M5, v$, wP, l$], Al = function t(n, e) {
              return t.fun(n, e);
            }, p$ = function t(n) {
              return t.fun(n);
            }, B5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, m$ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, q5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, _$ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, EP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, y$ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(Al, function(t, n) {
              switch (n) {
                case 0:
                  return g(t, qR0);
                case 1:
                  return g(t, UR0);
                default:
                  return g(t, HR0);
              }
            }), N(p$, function(t) {
              return o(C0(BR0), Al, t);
            }), N(B5, function(t, n, e, i) {
              if (i[0] === 0) {
                u(f(e), NR0), u(f(e), CR0);
                var x = i[1], c = 0;
                return le(function(E, d) {
                  E && u(f(e), AR0);
                  function w(G) {
                    return u(n, G);
                  }
                  return R(q5, function(G) {
                    return u(t, G);
                  }, w, e, d), 1;
                }, c, x), u(f(e), PR0), u(f(e), DR0);
              }
              var s = i[1];
              u(f(e), LR0), u(f(e), RR0), o(t, e, s[1]), u(f(e), jR0);
              var p = s[2];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t, E);
              }
              return R(Rn[1], T, y, e, p), u(f(e), GR0), u(f(e), MR0);
            }), N(m$, function(t, n, e) {
              var i = o(B5, t, n);
              return o(C0(IR0), i, e);
            }), N(q5, function(t, n, e, i) {
              u(f(e), cR0), o(f(e), vR0, sR0);
              var x = i[1];
              x ? (g(e, lR0), o(Al, e, x[1]), g(e, bR0)) : g(e, pR0), u(f(e), mR0), u(f(e), _R0), o(f(e), hR0, yR0);
              var c = i[2];
              if (c) {
                g(e, dR0);
                var s = c[1], p = function(w) {
                  return u(n, w);
                }, y = function(w) {
                  return u(t, w);
                };
                R(Rn[1], y, p, e, s), g(e, kR0);
              } else g(e, wR0);
              u(f(e), ER0), u(f(e), SR0), o(f(e), FR0, gR0);
              var T = i[3];
              function E(w) {
                return u(n, w);
              }
              function d(w) {
                return u(t, w);
              }
              return R(Rn[1], d, E, e, T), u(f(e), TR0), u(f(e), OR0);
            }), N(_$, function(t, n, e) {
              var i = o(q5, t, n);
              return o(C0(aR0), i, e);
            }), N(EP, function(t, n, e, i) {
              u(f(e), AL0), o(f(e), CL0, NL0), o(Al, e, i[1]), u(f(e), PL0), u(f(e), DL0), o(f(e), RL0, LL0);
              var x = i[2];
              u(f(e), jL0), o(t, e, x[1]), u(f(e), GL0);
              var c = x[2];
              function s(V) {
                return u(t, V);
              }
              ur(g1[1], s, e, c), u(f(e), ML0), u(f(e), BL0), u(f(e), qL0), o(f(e), HL0, UL0);
              var p = i[3];
              if (p) {
                g(e, XL0);
                var y = p[1], T = function(V) {
                  return u(n, V);
                }, E = function(V) {
                  return u(t, V);
                };
                R(Rn[1], E, T, e, y), g(e, YL0);
              } else g(e, VL0);
              u(f(e), zL0), u(f(e), KL0), o(f(e), JL0, WL0);
              var d = i[4];
              if (d) {
                g(e, $L0);
                var w = d[1], G = function(V) {
                  return u(n, V);
                };
                R(B5, function(V) {
                  return u(t, V);
                }, G, e, w), g(e, ZL0);
              } else g(e, QL0);
              u(f(e), rR0), u(f(e), eR0), o(f(e), tR0, nR0);
              var A = i[5];
              if (A) {
                g(e, uR0);
                var S = A[1], M = function(V, f0) {
                  return g(V, IL0);
                }, K = function(V) {
                  return u(t, V);
                };
                R(Dr[1], K, M, e, S), g(e, iR0);
              } else g(e, fR0);
              return u(f(e), xR0), u(f(e), oR0);
            }), N(y$, function(t, n, e) {
              var i = o(EP, t, n);
              return o(C0(OL0), i, e);
            });
            var h$ = [0, Al, p$, B5, m$, q5, _$, EP, y$], SP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, d$ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(SP, function(t, n, e, i) {
              u(f(e), oL0), o(f(e), cL0, aL0);
              var x = i[1];
              function c(G) {
                return u(n, G);
              }
              function s(G) {
                return u(t, G);
              }
              R(qe[31], s, c, e, x), u(f(e), sL0), u(f(e), vL0), o(f(e), bL0, lL0);
              var p = i[2];
              if (p) {
                g(e, pL0);
                var y = p[1];
                o(f(e), mL0, y), g(e, _L0);
              } else g(e, yL0);
              u(f(e), hL0), u(f(e), dL0), o(f(e), wL0, kL0);
              var T = i[3];
              if (T) {
                g(e, EL0);
                var E = T[1], d = function(G, A) {
                  return g(G, xL0);
                }, w = function(G) {
                  return u(t, G);
                };
                R(Dr[1], w, d, e, E), g(e, SL0);
              } else g(e, gL0);
              return u(f(e), FL0), u(f(e), TL0);
            }), N(d$, function(t, n, e) {
              var i = o(SP, t, n);
              return o(C0(fL0), i, e);
            });
            var k$ = [0, SP, d$], gP = function t(n, e, i) {
              return t.fun(n, e, i);
            }, w$ = function t(n, e) {
              return t.fun(n, e);
            };
            N(gP, function(t, n, e) {
              u(f(n), ZD0), o(f(n), rL0, QD0);
              var i = e[1];
              if (i) {
                g(n, eL0);
                var x = i[1], c = function(p, y) {
                  return g(p, $D0);
                }, s = function(p) {
                  return u(t, p);
                };
                R(Dr[1], s, c, n, x), g(n, nL0);
              } else g(n, tL0);
              return u(f(n), uL0), u(f(n), iL0);
            }), N(w$, function(t, n) {
              var e = u(gP, t);
              return o(C0(JD0), e, n);
            });
            var E$ = [0, gP, w$], FP = function t(n, e) {
              return t.fun(n, e);
            }, S$ = function t(n) {
              return t.fun(n);
            }, TP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, g$ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, U5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, F$ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(FP, function(t, n) {
              return n ? g(t, KD0) : g(t, WD0);
            }), N(S$, function(t) {
              return o(C0(zD0), FP, t);
            }), N(TP, function(t, n, e, i) {
              u(f(e), XD0), o(t, e, i[1]), u(f(e), YD0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(U5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), VD0);
            }), N(g$, function(t, n, e) {
              var i = o(TP, t, n);
              return o(C0(HD0), i, e);
            }), N(U5, function(t, n, e, i) {
              switch (i[0]) {
                case 0:
                  u(f(e), EP0);
                  var x = i[1], c = function(h0) {
                    return u(n, h0);
                  }, s = function(h0) {
                    return u(t, h0);
                  };
                  return R(Kv[1], s, c, e, x), u(f(e), SP0);
                case 1:
                  u(f(e), gP0);
                  var p = i[1], y = function(h0) {
                    return u(t, h0);
                  };
                  return ur(UW[1], y, e, p), u(f(e), FP0);
                case 2:
                  u(f(e), TP0);
                  var T = i[1], E = function(h0) {
                    return u(n, h0);
                  }, d = function(h0) {
                    return u(t, h0);
                  };
                  return R(F1[8], d, E, e, T), u(f(e), OP0);
                case 3:
                  u(f(e), IP0);
                  var w = i[1], G = function(h0) {
                    return u(t, h0);
                  };
                  return ur(XW[1], G, e, w), u(f(e), AP0);
                case 4:
                  u(f(e), NP0);
                  var A = i[1], S = function(h0) {
                    return u(t, h0);
                  };
                  return ur(VW[1], S, e, A), u(f(e), CP0);
                case 5:
                  u(f(e), PP0);
                  var M = i[1], K = function(h0) {
                    return u(n, h0);
                  }, V = function(h0) {
                    return u(t, h0);
                  };
                  return R(cP[1], V, K, e, M), u(f(e), DP0);
                case 6:
                  u(f(e), LP0);
                  var f0 = i[1], m0 = function(h0) {
                    return u(n, h0);
                  }, k0 = function(h0) {
                    return u(t, h0);
                  };
                  return R(b$[3], k0, m0, e, f0), u(f(e), RP0);
                case 7:
                  u(f(e), jP0);
                  var g0 = i[1], e0 = function(h0) {
                    return u(n, h0);
                  }, x0 = function(h0) {
                    return u(t, h0);
                  };
                  return R(bP[1], x0, e0, e, g0), u(f(e), GP0);
                case 8:
                  u(f(e), MP0);
                  var l = i[1], c0 = function(h0) {
                    return u(n, h0);
                  }, t0 = function(h0) {
                    return u(t, h0);
                  };
                  return R(P5[1], t0, c0, e, l), u(f(e), BP0);
                case 9:
                  u(f(e), qP0);
                  var o0 = i[1], w0 = function(h0) {
                    return u(n, h0);
                  }, _0 = function(h0) {
                    return u(t, h0);
                  };
                  return R(QJ[5], _0, w0, e, o0), u(f(e), UP0);
                case 10:
                  u(f(e), HP0);
                  var E0 = i[1], U0 = function(h0) {
                    return u(n, h0);
                  }, b = function(h0) {
                    return u(t, h0);
                  };
                  return R(e$[1], b, U0, e, E0), u(f(e), XP0);
                case 11:
                  u(f(e), YP0);
                  var R0 = i[1], X = function(h0) {
                    return u(n, h0);
                  }, s0 = function(h0) {
                    return u(t, h0);
                  };
                  return R(y5[1], s0, X, e, R0), u(f(e), VP0);
                case 12:
                  u(f(e), zP0);
                  var hr = i[1], Ar = function(h0) {
                    return u(n, h0);
                  }, or = function(h0) {
                    return u(t, h0);
                  };
                  return R(h5[1], or, Ar, e, hr), u(f(e), KP0);
                case 13:
                  u(f(e), WP0);
                  var W0 = i[1], Lr = function(h0) {
                    return u(n, h0);
                  }, Tr = function(h0) {
                    return u(t, h0);
                  };
                  return R(vP[1], Tr, Lr, e, W0), u(f(e), JP0);
                case 14:
                  u(f(e), $P0);
                  var Hr = i[1], Or = function(h0) {
                    return u(n, h0);
                  }, fr = function(h0) {
                    return u(t, h0);
                  };
                  return R(hJ[1], fr, Or, e, Hr), u(f(e), ZP0);
                case 15:
                  u(f(e), QP0);
                  var Rr = i[1], Wr = function(h0) {
                    return u(t, h0);
                  };
                  return ur(E$[1], Wr, e, Rr), u(f(e), rD0);
                case 16:
                  u(f(e), eD0);
                  var Jr = i[1], ar = function(h0) {
                    return u(n, h0);
                  }, _r = function(h0) {
                    return u(t, h0);
                  };
                  return R(YJ[7], _r, ar, e, Jr), u(f(e), nD0);
                case 17:
                  u(f(e), tD0);
                  var Ir = i[1], fe = function(h0) {
                    return u(n, h0);
                  }, v0 = function(h0) {
                    return u(t, h0);
                  };
                  return R(s$[1], v0, fe, e, Ir), u(f(e), uD0);
                case 18:
                  u(f(e), iD0);
                  var P = i[1], L = function(h0) {
                    return u(n, h0);
                  }, Q = function(h0) {
                    return u(t, h0);
                  };
                  return R(dP[3], Q, L, e, P), u(f(e), fD0);
                case 19:
                  u(f(e), xD0);
                  var i0 = i[1], l0 = function(h0) {
                    return u(n, h0);
                  }, S0 = function(h0) {
                    return u(t, h0);
                  };
                  return R(k$[1], S0, l0, e, i0), u(f(e), oD0);
                case 20:
                  u(f(e), aD0);
                  var T0 = i[1], rr = function(h0) {
                    return u(n, h0);
                  }, L0 = function(h0) {
                    return u(t, h0);
                  };
                  return R(wJ[1], L0, rr, e, T0), u(f(e), cD0);
                case 21:
                  u(f(e), sD0);
                  var B = i[1], Z = function(h0) {
                    return u(n, h0);
                  }, p0 = function(h0) {
                    return u(t, h0);
                  };
                  return R(gJ[1], p0, Z, e, B), u(f(e), vD0);
                case 22:
                  u(f(e), lD0);
                  var b0 = i[1], O0 = function(h0) {
                    return u(n, h0);
                  }, M0 = function(h0) {
                    return u(t, h0);
                  };
                  return R(OJ[1], M0, O0, e, b0), u(f(e), bD0);
                case 23:
                  u(f(e), pD0);
                  var er = i[1], yr = function(h0) {
                    return u(n, h0);
                  }, vr = function(h0) {
                    return u(t, h0);
                  };
                  return R(As[5], vr, yr, e, er), u(f(e), mD0);
                case 24:
                  u(f(e), _D0);
                  var $0 = i[1], Er = function(h0) {
                    return u(n, h0);
                  }, Mr = function(h0) {
                    return u(t, h0);
                  };
                  return R(GW[2], Mr, Er, e, $0), u(f(e), yD0);
                case 25:
                  u(f(e), hD0);
                  var Br = i[1], qr = function(h0) {
                    return u(n, h0);
                  }, jr = function(h0) {
                    return u(t, h0);
                  };
                  return R(h$[7], jr, qr, e, Br), u(f(e), dD0);
                case 26:
                  u(f(e), kD0);
                  var $r = i[1], ne = function(h0) {
                    return u(n, h0);
                  }, Qr = function(h0) {
                    return u(t, h0);
                  };
                  return R(P5[1], Qr, ne, e, $r), u(f(e), wD0);
                case 27:
                  u(f(e), ED0);
                  var be = i[1], ae = function(h0) {
                    return u(n, h0);
                  }, pe = function(h0) {
                    return u(t, h0);
                  };
                  return R(BW[1], pe, ae, e, be), u(f(e), SD0);
                case 28:
                  u(f(e), gD0);
                  var oe = i[1], ce = function(h0) {
                    return u(n, h0);
                  }, ge = function(h0) {
                    return u(t, h0);
                  };
                  return R(tJ[1], ge, ce, e, oe), u(f(e), FD0);
                case 29:
                  u(f(e), TD0);
                  var q0 = i[1], Fr = function(h0) {
                    return u(n, h0);
                  }, _ = function(h0) {
                    return u(t, h0);
                  };
                  return R(eJ[2], _, Fr, e, q0), u(f(e), OD0);
                case 30:
                  u(f(e), ID0);
                  var k = i[1], I = function(h0) {
                    return u(n, h0);
                  }, U = function(h0) {
                    return u(t, h0);
                  };
                  return R(iJ[1], U, I, e, k), u(f(e), AD0);
                case 31:
                  u(f(e), ND0);
                  var Y = i[1], y0 = function(h0) {
                    return u(n, h0);
                  }, P0 = function(h0) {
                    return u(t, h0);
                  };
                  return R(cJ[2], P0, y0, e, Y), u(f(e), CD0);
                case 32:
                  u(f(e), PD0);
                  var I0 = i[1], D = function(h0) {
                    return u(n, h0);
                  }, u0 = function(h0) {
                    return u(t, h0);
                  };
                  return R(y5[1], u0, D, e, I0), u(f(e), DD0);
                case 33:
                  u(f(e), LD0);
                  var X0 = i[1], J0 = function(h0) {
                    return u(n, h0);
                  }, ir = function(h0) {
                    return u(t, h0);
                  };
                  return R(h5[1], ir, J0, e, X0), u(f(e), RD0);
                case 34:
                  u(f(e), jD0);
                  var Q0 = i[1], F0 = function(h0) {
                    return u(n, h0);
                  }, Sr = function(h0) {
                    return u(t, h0);
                  };
                  return R(Il[2], Sr, F0, e, Q0), u(f(e), GD0);
                case 35:
                  u(f(e), MD0);
                  var mr = i[1], Cr = function(h0) {
                    return u(n, h0);
                  }, sr = function(h0) {
                    return u(t, h0);
                  };
                  return R(_J[1], sr, Cr, e, mr), u(f(e), BD0);
                default:
                  u(f(e), qD0);
                  var Pr = i[1], K0 = function(h0) {
                    return u(n, h0);
                  }, Ur = function(h0) {
                    return u(t, h0);
                  };
                  return R(KW[1], Ur, K0, e, Pr), u(f(e), UD0);
              }
            }), N(F$, function(t, n, e) {
              var i = o(U5, t, n);
              return o(C0(wP0), i, e);
            }), mu(W3r, Yu, [0, Kv, GW, BW, UW, XW, VW, KW, y5, h5, eJ, tJ, iJ, cJ, Il, _J, hJ, wJ, gJ, OJ, YJ, P5, cP, vP, bP, QJ, e$, dP, s$, b$, h$, k$, E$, FP, S$, TP, g$, U5, F$]);
            var OP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, T$ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, H5 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, O$ = function t(n, e) {
              return t.fun(n, e);
            };
            N(OP, function(t, n, e, i) {
              u(f(e), hP0), o(n, e, i[1]), u(f(e), dP0);
              var x = i[2];
              return ur(H5, function(c) {
                return u(t, c);
              }, e, x), u(f(e), kP0);
            }), N(T$, function(t, n, e) {
              var i = o(OP, t, n);
              return o(C0(yP0), i, e);
            }), N(H5, function(t, n, e) {
              u(f(n), cP0), o(f(n), vP0, sP0);
              var i = e[1];
              if (i) {
                g(n, lP0);
                var x = i[1], c = function(p, y) {
                  return g(p, aP0);
                }, s = function(p) {
                  return u(t, p);
                };
                R(Dr[1], s, c, n, x), g(n, bP0);
              } else g(n, pP0);
              return u(f(n), mP0), u(f(n), _P0);
            }), N(O$, function(t, n) {
              var e = u(H5, t);
              return o(C0(oP0), e, n);
            });
            var I$ = [0, OP, T$, H5, O$], IP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, A$ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(IP, function(t, n, e, i) {
              if (i[0] === 0) {
                u(f(e), uP0);
                var x = i[1], c = function(E) {
                  return u(n, E);
                }, s = function(E) {
                  return u(t, E);
                };
                return R($e[13], s, c, e, x), u(f(e), iP0);
              }
              u(f(e), fP0);
              var p = i[1];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t, E);
              }
              return R(I$[1], T, y, e, p), u(f(e), xP0);
            }), N(A$, function(t, n, e) {
              var i = o(IP, t, n);
              return o(C0(tP0), i, e);
            });
            var N$ = [0, I$, IP, A$], AP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, C$ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, X5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, P$ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(AP, function(t, n, e, i) {
              u(f(e), rP0), o(t, e, i[1]), u(f(e), eP0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(X5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), nP0);
            }), N(C$, function(t, n, e) {
              var i = o(AP, t, n);
              return o(C0(QC0), i, e);
            }), N(X5, function(t, n, e, i) {
              u(f(e), MC0), o(f(e), qC0, BC0);
              var x = i[1];
              u(f(e), UC0);
              var c = 0;
              le(function(E, d) {
                E && u(f(e), GC0);
                function w(A) {
                  return u(n, A);
                }
                function G(A) {
                  return u(t, A);
                }
                return R(N$[2], G, w, e, d), 1;
              }, c, x), u(f(e), HC0), u(f(e), XC0), u(f(e), YC0), o(f(e), zC0, VC0);
              var s = i[2];
              if (s) {
                g(e, KC0);
                var p = s[1], y = function(E, d) {
                  u(f(E), RC0);
                  var w = 0;
                  return le(function(G, A) {
                    G && u(f(E), LC0);
                    function S(M) {
                      return u(t, M);
                    }
                    return ur(iu[1], S, E, A), 1;
                  }, w, d), u(f(E), jC0);
                }, T = function(E) {
                  return u(t, E);
                };
                R(Dr[1], T, y, e, p), g(e, WC0);
              } else g(e, JC0);
              return u(f(e), $C0), u(f(e), ZC0);
            }), N(P$, function(t, n, e) {
              var i = o(X5, t, n);
              return o(C0(DC0), i, e);
            });
            var NP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, D$ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Y5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, L$ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, See = [0, AP, C$, X5, P$];
            N(NP, function(t, n, e, i) {
              u(f(e), NC0), o(t, e, i[1]), u(f(e), CC0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Y5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), PC0);
            }), N(D$, function(t, n, e) {
              var i = o(NP, t, n);
              return o(C0(AC0), i, e);
            }), N(Y5, function(t, n, e, i) {
              u(f(e), yC0), o(f(e), dC0, hC0);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(qe[31], s, c, e, x), u(f(e), kC0), u(f(e), wC0), o(f(e), SC0, EC0);
              var p = i[2];
              if (p) {
                g(e, gC0);
                var y = p[1], T = function(d, w) {
                  return g(d, _C0);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, FC0);
              } else g(e, TC0);
              return u(f(e), OC0), u(f(e), IC0);
            }), N(L$, function(t, n, e) {
              var i = o(Y5, t, n);
              return o(C0(mC0), i, e);
            });
            var CP = [0, NP, D$, Y5, L$], V5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, R$ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(V5, function(t, n, e, i) {
              switch (i[0]) {
                case 0:
                  u(f(e), cC0);
                  var x = i[1], c = function(E) {
                    return u(n, E);
                  }, s = function(E) {
                    return u(t, E);
                  };
                  return R(qe[31], s, c, e, x), u(f(e), sC0);
                case 1:
                  u(f(e), vC0);
                  var p = i[1], y = function(E) {
                    return u(n, E);
                  }, T = function(E) {
                    return u(t, E);
                  };
                  return R(CP[1], T, y, e, p), u(f(e), lC0);
                default:
                  return u(f(e), bC0), o(t, e, i[1]), u(f(e), pC0);
              }
            }), N(R$, function(t, n, e) {
              var i = o(V5, t, n);
              return o(C0(aC0), i, e);
            });
            var PP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, j$ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(PP, function(t, n, e, i) {
              u(f(e), WN0), o(f(e), $N0, JN0);
              var x = i[1];
              u(f(e), ZN0);
              var c = 0;
              le(function(E, d) {
                E && u(f(e), KN0);
                function w(G) {
                  return u(n, G);
                }
                return R(V5, function(G) {
                  return u(t, G);
                }, w, e, d), 1;
              }, c, x), u(f(e), QN0), u(f(e), rC0), u(f(e), eC0), o(f(e), tC0, nC0);
              var s = i[2];
              if (s) {
                g(e, uC0);
                var p = s[1], y = function(E, d) {
                  u(f(E), VN0);
                  var w = 0;
                  return le(function(G, A) {
                    G && u(f(E), YN0);
                    function S(M) {
                      return u(t, M);
                    }
                    return ur(iu[1], S, E, A), 1;
                  }, w, d), u(f(E), zN0);
                }, T = function(E) {
                  return u(t, E);
                };
                R(Dr[1], T, y, e, p), g(e, iC0);
              } else g(e, fC0);
              return u(f(e), xC0), u(f(e), oC0);
            }), N(j$, function(t, n, e) {
              var i = o(PP, t, n);
              return o(C0(XN0), i, e);
            });
            var G$ = [0, V5, R$, PP, j$], z5 = function t(n, e) {
              return t.fun(n, e);
            }, M$ = function t(n) {
              return t.fun(n);
            }, DP = function t(n, e, i) {
              return t.fun(n, e, i);
            }, B$ = function t(n, e) {
              return t.fun(n, e);
            }, K5 = function t(n, e) {
              return t.fun(n, e);
            }, q$ = function t(n) {
              return t.fun(n);
            };
            N(z5, function(t, n) {
              u(f(t), PN0), o(f(t), LN0, DN0);
              var e = n[1];
              o(f(t), RN0, e), u(f(t), jN0), u(f(t), GN0), o(f(t), BN0, MN0);
              var i = n[2];
              return o(f(t), qN0, i), u(f(t), UN0), u(f(t), HN0);
            }), N(M$, function(t) {
              return o(C0(CN0), z5, t);
            }), N(DP, function(t, n, e) {
              return u(f(n), IN0), o(t, n, e[1]), u(f(n), AN0), o(K5, n, e[2]), u(f(n), NN0);
            }), N(B$, function(t, n) {
              var e = u(DP, t);
              return o(C0(ON0), e, n);
            }), N(K5, function(t, n) {
              u(f(t), yN0), o(f(t), dN0, hN0), o(z5, t, n[1]), u(f(t), kN0), u(f(t), wN0), o(f(t), SN0, EN0);
              var e = n[2];
              return o(f(t), gN0, e), u(f(t), FN0), u(f(t), TN0);
            }), N(q$, function(t) {
              return o(C0(_N0), K5, t);
            });
            var U$ = [0, z5, M$, DP, B$, K5, q$], LP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, H$ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(LP, function(t, n, e, i) {
              u(f(e), $A0), o(f(e), QA0, ZA0);
              var x = i[1];
              u(f(e), rN0);
              var c = 0;
              le(function(w, G) {
                w && u(f(e), JA0);
                function A(S) {
                  return u(t, S);
                }
                return ur(U$[3], A, e, G), 1;
              }, c, x), u(f(e), eN0), u(f(e), nN0), u(f(e), tN0), o(f(e), iN0, uN0);
              var s = i[2];
              u(f(e), fN0);
              var p = 0;
              le(function(w, G) {
                w && u(f(e), WA0);
                function A(M) {
                  return u(n, M);
                }
                function S(M) {
                  return u(t, M);
                }
                return R(qe[31], S, A, e, G), 1;
              }, p, s), u(f(e), xN0), u(f(e), oN0), u(f(e), aN0), o(f(e), sN0, cN0);
              var y = i[3];
              if (y) {
                g(e, vN0);
                var T = y[1], E = function(w, G) {
                  return g(w, KA0);
                }, d = function(w) {
                  return u(t, w);
                };
                R(Dr[1], d, E, e, T), g(e, lN0);
              } else g(e, bN0);
              return u(f(e), pN0), u(f(e), mN0);
            }), N(H$, function(t, n, e) {
              var i = o(LP, t, n);
              return o(C0(zA0), i, e);
            });
            var RP = [0, U$, LP, H$], jP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, X$ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(jP, function(t, n, e, i) {
              u(f(e), OA0), o(f(e), AA0, IA0);
              var x = i[1];
              function c(S) {
                return u(n, S);
              }
              function s(S) {
                return u(t, S);
              }
              R(qe[31], s, c, e, x), u(f(e), NA0), u(f(e), CA0), o(f(e), DA0, PA0);
              var p = i[2];
              u(f(e), LA0), o(t, e, p[1]), u(f(e), RA0);
              var y = p[2];
              function T(S) {
                return u(n, S);
              }
              function E(S) {
                return u(t, S);
              }
              R(RP[2], E, T, e, y), u(f(e), jA0), u(f(e), GA0), u(f(e), MA0), o(f(e), qA0, BA0);
              var d = i[3];
              if (d) {
                g(e, UA0);
                var w = d[1], G = function(S, M) {
                  return g(S, TA0);
                }, A = function(S) {
                  return u(t, S);
                };
                R(Dr[1], A, G, e, w), g(e, HA0);
              } else g(e, XA0);
              return u(f(e), YA0), u(f(e), VA0);
            }), N(X$, function(t, n, e) {
              var i = o(jP, t, n);
              return o(C0(FA0), i, e);
            });
            var Y$ = [0, jP, X$], T1 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, V$ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, GP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, z$ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, W5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, K$ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(T1, function(t, n, e, i) {
              switch (i[0]) {
                case 0:
                  var x = i[1];
                  u(f(e), pA0), u(f(e), mA0), o(n, e, x[1]), u(f(e), _A0);
                  var c = x[2], s = function(S) {
                    return u(t, S);
                  };
                  return ur(Tl[2], s, e, c), u(f(e), yA0), u(f(e), hA0);
                case 1:
                  u(f(e), dA0);
                  var p = i[1], y = function(S) {
                    return u(n, S);
                  }, T = function(S) {
                    return u(t, S);
                  };
                  return R(Rn[1], T, y, e, p), u(f(e), kA0);
                case 2:
                  u(f(e), wA0);
                  var E = i[1], d = function(S) {
                    return u(t, S);
                  };
                  return ur(Bp[1], d, e, E), u(f(e), EA0);
                default:
                  u(f(e), SA0);
                  var w = i[1], G = function(S) {
                    return u(n, S);
                  }, A = function(S) {
                    return u(t, S);
                  };
                  return R(qp[1], A, G, e, w), u(f(e), gA0);
              }
            }), N(V$, function(t, n, e) {
              var i = o(T1, t, n);
              return o(C0(bA0), i, e);
            }), N(GP, function(t, n, e, i) {
              u(f(e), sA0), o(t, e, i[1]), u(f(e), vA0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(W5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), lA0);
            }), N(z$, function(t, n, e) {
              var i = o(GP, t, n);
              return o(C0(cA0), i, e);
            }), N(W5, function(t, n, e, i) {
              switch (i[0]) {
                case 0:
                  u(f(e), rI0), o(f(e), nI0, eI0);
                  var x = i[1], c = function(s0) {
                    return u(n, s0);
                  };
                  R(T1, function(s0) {
                    return u(t, s0);
                  }, c, e, x), u(f(e), tI0), u(f(e), uI0), o(f(e), fI0, iI0);
                  var s = i[2], p = function(s0) {
                    return u(n, s0);
                  }, y = function(s0) {
                    return u(t, s0);
                  };
                  R(qe[31], y, p, e, s), u(f(e), xI0), u(f(e), oI0), o(f(e), cI0, aI0);
                  var T = i[3];
                  return o(f(e), sI0, T), u(f(e), vI0), u(f(e), lI0);
                case 1:
                  var E = i[2];
                  u(f(e), bI0), o(f(e), mI0, pI0);
                  var d = i[1], w = function(s0) {
                    return u(n, s0);
                  };
                  R(T1, function(s0) {
                    return u(t, s0);
                  }, w, e, d), u(f(e), _I0), u(f(e), yI0), o(f(e), dI0, hI0), u(f(e), kI0), o(t, e, E[1]), u(f(e), wI0);
                  var G = E[2], A = function(s0) {
                    return u(n, s0);
                  }, S = function(s0) {
                    return u(t, s0);
                  };
                  return R(As[5], S, A, e, G), u(f(e), EI0), u(f(e), SI0), u(f(e), gI0);
                case 2:
                  var M = i[3], K = i[2];
                  u(f(e), FI0), o(f(e), OI0, TI0);
                  var V = i[1], f0 = function(s0) {
                    return u(n, s0);
                  };
                  R(T1, function(s0) {
                    return u(t, s0);
                  }, f0, e, V), u(f(e), II0), u(f(e), AI0), o(f(e), CI0, NI0), u(f(e), PI0), o(t, e, K[1]), u(f(e), DI0);
                  var m0 = K[2], k0 = function(s0) {
                    return u(n, s0);
                  }, g0 = function(s0) {
                    return u(t, s0);
                  };
                  if (R(As[5], g0, k0, e, m0), u(f(e), LI0), u(f(e), RI0), u(f(e), jI0), o(f(e), MI0, GI0), M) {
                    g(e, BI0);
                    var e0 = M[1], x0 = function(s0, hr) {
                      return g(s0, QO0);
                    }, l = function(s0) {
                      return u(t, s0);
                    };
                    R(Dr[1], l, x0, e, e0), g(e, qI0);
                  } else g(e, UI0);
                  return u(f(e), HI0), u(f(e), XI0);
                default:
                  var c0 = i[3], t0 = i[2];
                  u(f(e), YI0), o(f(e), zI0, VI0);
                  var o0 = i[1], w0 = function(s0) {
                    return u(n, s0);
                  };
                  R(T1, function(s0) {
                    return u(t, s0);
                  }, w0, e, o0), u(f(e), KI0), u(f(e), WI0), o(f(e), $I0, JI0), u(f(e), ZI0), o(t, e, t0[1]), u(f(e), QI0);
                  var _0 = t0[2], E0 = function(s0) {
                    return u(n, s0);
                  }, U0 = function(s0) {
                    return u(t, s0);
                  };
                  if (R(As[5], U0, E0, e, _0), u(f(e), rA0), u(f(e), eA0), u(f(e), nA0), o(f(e), uA0, tA0), c0) {
                    g(e, iA0);
                    var b = c0[1], R0 = function(s0, hr) {
                      return g(s0, ZO0);
                    }, X = function(s0) {
                      return u(t, s0);
                    };
                    R(Dr[1], X, R0, e, b), g(e, fA0);
                  } else g(e, xA0);
                  return u(f(e), oA0), u(f(e), aA0);
              }
            }), N(K$, function(t, n, e) {
              var i = o(W5, t, n);
              return o(C0($O0), i, e);
            });
            var W$ = [0, T1, V$, GP, z$, W5, K$], MP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, J$ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, J5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, $$ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(MP, function(t, n, e, i) {
              u(f(e), KO0), o(t, e, i[1]), u(f(e), WO0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(J5, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), JO0);
            }), N(J$, function(t, n, e) {
              var i = o(MP, t, n);
              return o(C0(zO0), i, e);
            }), N(J5, function(t, n, e, i) {
              u(f(e), LO0), o(f(e), jO0, RO0);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(qe[31], s, c, e, x), u(f(e), GO0), u(f(e), MO0), o(f(e), qO0, BO0);
              var p = i[2];
              if (p) {
                g(e, UO0);
                var y = p[1], T = function(d, w) {
                  return g(d, DO0);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, HO0);
              } else g(e, XO0);
              return u(f(e), YO0), u(f(e), VO0);
            }), N($$, function(t, n, e) {
              var i = o(J5, t, n);
              return o(C0(PO0), i, e);
            });
            var Z$ = [0, MP, J$, J5, $$], $5 = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, Q$ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, BP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, rZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N($5, function(t, n, e, i) {
              if (i[0] === 0) {
                u(f(e), IO0);
                var x = i[1], c = function(E) {
                  return u(n, E);
                }, s = function(E) {
                  return u(t, E);
                };
                return R(W$[3], s, c, e, x), u(f(e), AO0);
              }
              u(f(e), NO0);
              var p = i[1];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t, E);
              }
              return R(Z$[1], T, y, e, p), u(f(e), CO0);
            }), N(Q$, function(t, n, e) {
              var i = o($5, t, n);
              return o(C0(OO0), i, e);
            }), N(BP, function(t, n, e, i) {
              u(f(e), bO0), o(f(e), mO0, pO0);
              var x = i[1];
              u(f(e), _O0);
              var c = 0;
              le(function(E, d) {
                E && u(f(e), lO0);
                function w(G) {
                  return u(n, G);
                }
                return R($5, function(G) {
                  return u(t, G);
                }, w, e, d), 1;
              }, c, x), u(f(e), yO0), u(f(e), hO0), u(f(e), dO0), o(f(e), wO0, kO0);
              var s = i[2];
              if (s) {
                g(e, EO0);
                var p = s[1], y = function(E, d) {
                  u(f(E), sO0);
                  var w = 0;
                  return le(function(G, A) {
                    G && u(f(E), cO0);
                    function S(M) {
                      return u(t, M);
                    }
                    return ur(iu[1], S, E, A), 1;
                  }, w, d), u(f(E), vO0);
                }, T = function(E) {
                  return u(t, E);
                };
                R(Dr[1], T, y, e, p), g(e, SO0);
              } else g(e, gO0);
              return u(f(e), FO0), u(f(e), TO0);
            }), N(rZ, function(t, n, e) {
              var i = o(BP, t, n);
              return o(C0(aO0), i, e);
            });
            var eZ = [0, W$, Z$, $5, Q$, BP, rZ], qP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, nZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(qP, function(t, n, e, i) {
              u(f(e), WT0), o(f(e), $T0, JT0);
              var x = i[1];
              u(f(e), ZT0);
              var c = 0;
              le(function(E, d) {
                E && u(f(e), KT0);
                function w(A) {
                  return u(n, A);
                }
                function G(A) {
                  return u(t, A);
                }
                return R(qe[31], G, w, e, d), 1;
              }, c, x), u(f(e), QT0), u(f(e), rO0), u(f(e), eO0), o(f(e), tO0, nO0);
              var s = i[2];
              if (s) {
                g(e, uO0);
                var p = s[1], y = function(E, d) {
                  return g(E, zT0);
                }, T = function(E) {
                  return u(t, E);
                };
                R(Dr[1], T, y, e, p), g(e, iO0);
              } else g(e, fO0);
              return u(f(e), xO0), u(f(e), oO0);
            }), N(nZ, function(t, n, e) {
              var i = o(qP, t, n);
              return o(C0(VT0), i, e);
            });
            var tZ = [0, qP, nZ], Z5 = function t(n, e) {
              return t.fun(n, e);
            }, uZ = function t(n) {
              return t.fun(n);
            }, UP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, iZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(Z5, function(t, n) {
              switch (n) {
                case 0:
                  return g(t, GT0);
                case 1:
                  return g(t, MT0);
                case 2:
                  return g(t, BT0);
                case 3:
                  return g(t, qT0);
                case 4:
                  return g(t, UT0);
                case 5:
                  return g(t, HT0);
                case 6:
                  return g(t, XT0);
                default:
                  return g(t, YT0);
              }
            }), N(uZ, function(t) {
              return o(C0(jT0), Z5, t);
            }), N(UP, function(t, n, e, i) {
              u(f(e), kT0), o(f(e), ET0, wT0), o(Z5, e, i[1]), u(f(e), ST0), u(f(e), gT0), o(f(e), TT0, FT0);
              var x = i[2];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(qe[31], s, c, e, x), u(f(e), OT0), u(f(e), IT0), o(f(e), NT0, AT0);
              var p = i[3];
              if (p) {
                g(e, CT0);
                var y = p[1], T = function(d, w) {
                  return g(d, dT0);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, PT0);
              } else g(e, DT0);
              return u(f(e), LT0), u(f(e), RT0);
            }), N(iZ, function(t, n, e) {
              var i = o(UP, t, n);
              return o(C0(hT0), i, e);
            });
            var fZ = [0, Z5, uZ, UP, iZ], Q5 = function t(n, e) {
              return t.fun(n, e);
            }, xZ = function t(n) {
              return t.fun(n);
            }, HP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, oZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(Q5, function(t, n) {
              switch (n) {
                case 0:
                  return g(t, $F0);
                case 1:
                  return g(t, ZF0);
                case 2:
                  return g(t, QF0);
                case 3:
                  return g(t, rT0);
                case 4:
                  return g(t, eT0);
                case 5:
                  return g(t, nT0);
                case 6:
                  return g(t, tT0);
                case 7:
                  return g(t, uT0);
                case 8:
                  return g(t, iT0);
                case 9:
                  return g(t, fT0);
                case 10:
                  return g(t, xT0);
                case 11:
                  return g(t, oT0);
                case 12:
                  return g(t, aT0);
                case 13:
                  return g(t, cT0);
                case 14:
                  return g(t, sT0);
                case 15:
                  return g(t, vT0);
                case 16:
                  return g(t, lT0);
                case 17:
                  return g(t, bT0);
                case 18:
                  return g(t, pT0);
                case 19:
                  return g(t, mT0);
                case 20:
                  return g(t, _T0);
                default:
                  return g(t, yT0);
              }
            }), N(xZ, function(t) {
              return o(C0(JF0), Q5, t);
            }), N(HP, function(t, n, e, i) {
              u(f(e), AF0), o(f(e), CF0, NF0), o(Q5, e, i[1]), u(f(e), PF0), u(f(e), DF0), o(f(e), RF0, LF0);
              var x = i[2];
              function c(A) {
                return u(n, A);
              }
              function s(A) {
                return u(t, A);
              }
              R(qe[31], s, c, e, x), u(f(e), jF0), u(f(e), GF0), o(f(e), BF0, MF0);
              var p = i[3];
              function y(A) {
                return u(n, A);
              }
              function T(A) {
                return u(t, A);
              }
              R(qe[31], T, y, e, p), u(f(e), qF0), u(f(e), UF0), o(f(e), XF0, HF0);
              var E = i[4];
              if (E) {
                g(e, YF0);
                var d = E[1], w = function(A, S) {
                  return g(A, IF0);
                }, G = function(A) {
                  return u(t, A);
                };
                R(Dr[1], G, w, e, d), g(e, VF0);
              } else g(e, zF0);
              return u(f(e), KF0), u(f(e), WF0);
            }), N(oZ, function(t, n, e) {
              var i = o(HP, t, n);
              return o(C0(OF0), i, e);
            });
            var aZ = [0, Q5, xZ, HP, oZ], rm = function t(n, e) {
              return t.fun(n, e);
            }, cZ = function t(n) {
              return t.fun(n);
            }, XP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, sZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(rm, function(t, n) {
              switch (n) {
                case 0:
                  return g(t, lF0);
                case 1:
                  return g(t, bF0);
                case 2:
                  return g(t, pF0);
                case 3:
                  return g(t, mF0);
                case 4:
                  return g(t, _F0);
                case 5:
                  return g(t, yF0);
                case 6:
                  return g(t, hF0);
                case 7:
                  return g(t, dF0);
                case 8:
                  return g(t, kF0);
                case 9:
                  return g(t, wF0);
                case 10:
                  return g(t, EF0);
                case 11:
                  return g(t, SF0);
                case 12:
                  return g(t, gF0);
                case 13:
                  return g(t, FF0);
                default:
                  return g(t, TF0);
              }
            }), N(cZ, function(t) {
              return o(C0(vF0), rm, t);
            }), N(XP, function(t, n, e, i) {
              u(f(e), Hg0), o(f(e), Yg0, Xg0);
              var x = i[1];
              x ? (g(e, Vg0), o(rm, e, x[1]), g(e, zg0)) : g(e, Kg0), u(f(e), Wg0), u(f(e), Jg0), o(f(e), Zg0, $g0);
              var c = i[2];
              function s(S) {
                return u(n, S);
              }
              function p(S) {
                return u(t, S);
              }
              R(di[5], p, s, e, c), u(f(e), Qg0), u(f(e), rF0), o(f(e), nF0, eF0);
              var y = i[3];
              function T(S) {
                return u(n, S);
              }
              function E(S) {
                return u(t, S);
              }
              R(qe[31], E, T, e, y), u(f(e), tF0), u(f(e), uF0), o(f(e), fF0, iF0);
              var d = i[4];
              if (d) {
                g(e, xF0);
                var w = d[1], G = function(S, M) {
                  return g(S, Ug0);
                }, A = function(S) {
                  return u(t, S);
                };
                R(Dr[1], A, G, e, w), g(e, oF0);
              } else g(e, aF0);
              return u(f(e), cF0), u(f(e), sF0);
            }), N(sZ, function(t, n, e) {
              var i = o(XP, t, n);
              return o(C0(qg0), i, e);
            });
            var vZ = [0, rm, cZ, XP, sZ], em = function t(n, e) {
              return t.fun(n, e);
            }, lZ = function t(n) {
              return t.fun(n);
            }, YP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, bZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(em, function(t, n) {
              return n ? g(t, Mg0) : g(t, Bg0);
            }), N(lZ, function(t) {
              return o(C0(Gg0), em, t);
            }), N(YP, function(t, n, e, i) {
              u(f(e), _g0), o(f(e), hg0, yg0), o(em, e, i[1]), u(f(e), dg0), u(f(e), kg0), o(f(e), Eg0, wg0);
              var x = i[2];
              function c(w) {
                return u(n, w);
              }
              function s(w) {
                return u(t, w);
              }
              R(qe[31], s, c, e, x), u(f(e), Sg0), u(f(e), gg0), o(f(e), Tg0, Fg0);
              var p = i[3];
              o(f(e), Og0, p), u(f(e), Ig0), u(f(e), Ag0), o(f(e), Cg0, Ng0);
              var y = i[4];
              if (y) {
                g(e, Pg0);
                var T = y[1], E = function(w, G) {
                  return g(w, mg0);
                }, d = function(w) {
                  return u(t, w);
                };
                R(Dr[1], d, E, e, T), g(e, Dg0);
              } else g(e, Lg0);
              return u(f(e), Rg0), u(f(e), jg0);
            }), N(bZ, function(t, n, e) {
              var i = o(YP, t, n);
              return o(C0(pg0), i, e);
            });
            var pZ = [0, em, lZ, YP, bZ], nm = function t(n, e) {
              return t.fun(n, e);
            }, mZ = function t(n) {
              return t.fun(n);
            }, VP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, _Z = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(nm, function(t, n) {
              switch (n) {
                case 0:
                  return g(t, vg0);
                case 1:
                  return g(t, lg0);
                default:
                  return g(t, bg0);
              }
            }), N(mZ, function(t) {
              return o(C0(sg0), nm, t);
            }), N(VP, function(t, n, e, i) {
              u(f(e), YS0), o(f(e), zS0, VS0), o(nm, e, i[1]), u(f(e), KS0), u(f(e), WS0), o(f(e), $S0, JS0);
              var x = i[2];
              function c(A) {
                return u(n, A);
              }
              function s(A) {
                return u(t, A);
              }
              R(qe[31], s, c, e, x), u(f(e), ZS0), u(f(e), QS0), o(f(e), eg0, rg0);
              var p = i[3];
              function y(A) {
                return u(n, A);
              }
              function T(A) {
                return u(t, A);
              }
              R(qe[31], T, y, e, p), u(f(e), ng0), u(f(e), tg0), o(f(e), ig0, ug0);
              var E = i[4];
              if (E) {
                g(e, fg0);
                var d = E[1], w = function(A, S) {
                  return g(A, XS0);
                }, G = function(A) {
                  return u(t, A);
                };
                R(Dr[1], G, w, e, d), g(e, xg0);
              } else g(e, og0);
              return u(f(e), ag0), u(f(e), cg0);
            }), N(_Z, function(t, n, e) {
              var i = o(VP, t, n);
              return o(C0(HS0), i, e);
            });
            var yZ = [0, nm, mZ, VP, _Z], zP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, hZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(zP, function(t, n, e, i) {
              u(f(e), ES0), o(f(e), gS0, SS0);
              var x = i[1];
              function c(K) {
                return u(n, K);
              }
              function s(K) {
                return u(t, K);
              }
              R(qe[31], s, c, e, x), u(f(e), FS0), u(f(e), TS0), o(f(e), IS0, OS0);
              var p = i[2];
              function y(K) {
                return u(n, K);
              }
              function T(K) {
                return u(t, K);
              }
              R(qe[31], T, y, e, p), u(f(e), AS0), u(f(e), NS0), o(f(e), PS0, CS0);
              var E = i[3];
              function d(K) {
                return u(n, K);
              }
              function w(K) {
                return u(t, K);
              }
              R(qe[31], w, d, e, E), u(f(e), DS0), u(f(e), LS0), o(f(e), jS0, RS0);
              var G = i[4];
              if (G) {
                g(e, GS0);
                var A = G[1], S = function(K, V) {
                  return g(K, wS0);
                }, M = function(K) {
                  return u(t, K);
                };
                R(Dr[1], M, S, e, A), g(e, MS0);
              } else g(e, BS0);
              return u(f(e), qS0), u(f(e), US0);
            }), N(hZ, function(t, n, e) {
              var i = o(zP, t, n);
              return o(C0(kS0), i, e);
            });
            var dZ = [0, zP, hZ], tm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, kZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(tm, function(t, n, e, i) {
              if (i[0] === 0) {
                u(f(e), _S0);
                var x = i[1], c = function(E) {
                  return u(n, E);
                }, s = function(E) {
                  return u(t, E);
                };
                return R(qe[31], s, c, e, x), u(f(e), yS0);
              }
              u(f(e), hS0);
              var p = i[1];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t, E);
              }
              return R(CP[1], T, y, e, p), u(f(e), dS0);
            }), N(kZ, function(t, n, e) {
              var i = o(tm, t, n);
              return o(C0(mS0), i, e);
            });
            var KP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, wZ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, um = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, EZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(KP, function(t, n, e, i) {
              u(f(e), lS0), o(t, e, i[1]), u(f(e), bS0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(um, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), pS0);
            }), N(wZ, function(t, n, e) {
              var i = o(KP, t, n);
              return o(C0(vS0), i, e);
            }), N(um, function(t, n, e, i) {
              u(f(e), ZE0), o(f(e), rS0, QE0);
              var x = i[1];
              u(f(e), eS0);
              var c = 0;
              le(function(E, d) {
                E && u(f(e), $E0);
                function w(G) {
                  return u(n, G);
                }
                return R(tm, function(G) {
                  return u(t, G);
                }, w, e, d), 1;
              }, c, x), u(f(e), nS0), u(f(e), tS0), u(f(e), uS0), o(f(e), fS0, iS0);
              var s = i[2];
              if (s) {
                g(e, xS0);
                var p = s[1], y = function(E, d) {
                  u(f(E), WE0);
                  var w = 0;
                  return le(function(G, A) {
                    G && u(f(E), KE0);
                    function S(M) {
                      return u(t, M);
                    }
                    return ur(iu[1], S, E, A), 1;
                  }, w, d), u(f(E), JE0);
                }, T = function(E) {
                  return u(t, E);
                };
                R(Dr[1], T, y, e, p), g(e, oS0);
              } else g(e, aS0);
              return u(f(e), cS0), u(f(e), sS0);
            }), N(EZ, function(t, n, e) {
              var i = o(um, t, n);
              return o(C0(zE0), i, e);
            });
            var WP = [0, KP, wZ, um, EZ], JP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, SZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(JP, function(t, n, e, i) {
              u(f(e), kE0), o(f(e), EE0, wE0);
              var x = i[1];
              function c(f0) {
                return u(n, f0);
              }
              function s(f0) {
                return u(t, f0);
              }
              R(qe[31], s, c, e, x), u(f(e), SE0), u(f(e), gE0), o(f(e), TE0, FE0);
              var p = i[2];
              if (p) {
                g(e, OE0);
                var y = p[1], T = function(f0) {
                  return u(n, f0);
                }, E = function(f0) {
                  return u(t, f0);
                };
                R(qe[2][1], E, T, e, y), g(e, IE0);
              } else g(e, AE0);
              u(f(e), NE0), u(f(e), CE0), o(f(e), DE0, PE0);
              var d = i[3];
              if (d) {
                g(e, LE0);
                var w = d[1], G = function(f0) {
                  return u(n, f0);
                }, A = function(f0) {
                  return u(t, f0);
                };
                R(WP[1], A, G, e, w), g(e, RE0);
              } else g(e, jE0);
              u(f(e), GE0), u(f(e), ME0), o(f(e), qE0, BE0);
              var S = i[4];
              if (S) {
                g(e, UE0);
                var M = S[1], K = function(f0, m0) {
                  return g(f0, dE0);
                }, V = function(f0) {
                  return u(t, f0);
                };
                R(Dr[1], V, K, e, M), g(e, HE0);
              } else g(e, XE0);
              return u(f(e), YE0), u(f(e), VE0);
            }), N(SZ, function(t, n, e) {
              var i = o(JP, t, n);
              return o(C0(hE0), i, e);
            });
            var gZ = [0, JP, SZ], $P = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, FZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N($P, function(t, n, e, i) {
              u(f(e), Jw0), o(f(e), Zw0, $w0);
              var x = i[1];
              function c(V) {
                return u(n, V);
              }
              function s(V) {
                return u(t, V);
              }
              R(qe[31], s, c, e, x), u(f(e), Qw0), u(f(e), rE0), o(f(e), nE0, eE0);
              var p = i[2];
              if (p) {
                g(e, tE0);
                var y = p[1], T = function(V) {
                  return u(n, V);
                }, E = function(V) {
                  return u(t, V);
                };
                R(qe[2][1], E, T, e, y), g(e, uE0);
              } else g(e, iE0);
              u(f(e), fE0), u(f(e), xE0), o(f(e), aE0, oE0);
              var d = i[3];
              function w(V) {
                return u(n, V);
              }
              function G(V) {
                return u(t, V);
              }
              R(WP[1], G, w, e, d), u(f(e), cE0), u(f(e), sE0), o(f(e), lE0, vE0);
              var A = i[4];
              if (A) {
                g(e, bE0);
                var S = A[1], M = function(V, f0) {
                  return g(V, Ww0);
                }, K = function(V) {
                  return u(t, V);
                };
                R(Dr[1], K, M, e, S), g(e, pE0);
              } else g(e, mE0);
              return u(f(e), _E0), u(f(e), yE0);
            }), N(FZ, function(t, n, e) {
              var i = o($P, t, n);
              return o(C0(Kw0), i, e);
            });
            var ZP = [0, $P, FZ], QP = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, TZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(QP, function(t, n, e, i) {
              u(f(e), Dw0), o(f(e), Rw0, Lw0);
              var x = i[1];
              function c(y) {
                return u(n, y);
              }
              function s(y) {
                return u(t, y);
              }
              R(ZP[1], s, c, e, x), u(f(e), jw0), u(f(e), Gw0), o(f(e), Bw0, Mw0), o(n, e, i[2]), u(f(e), qw0), u(f(e), Uw0), o(f(e), Xw0, Hw0);
              var p = i[3];
              return o(f(e), Yw0, p), u(f(e), Vw0), u(f(e), zw0);
            }), N(TZ, function(t, n, e) {
              var i = o(QP, t, n);
              return o(C0(Pw0), i, e);
            });
            var OZ = [0, QP, TZ], im = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, IZ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, rD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, AZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(im, function(t, n, e, i) {
              switch (i[0]) {
                case 0:
                  u(f(e), Tw0);
                  var x = i[1], c = function(w) {
                    return u(n, w);
                  }, s = function(w) {
                    return u(t, w);
                  };
                  return R(Rn[1], s, c, e, x), u(f(e), Ow0);
                case 1:
                  u(f(e), Iw0);
                  var p = i[1], y = function(w) {
                    return u(t, w);
                  };
                  return ur(Bp[1], y, e, p), u(f(e), Aw0);
                default:
                  u(f(e), Nw0);
                  var T = i[1], E = function(w) {
                    return u(n, w);
                  }, d = function(w) {
                    return u(t, w);
                  };
                  return R(qe[31], d, E, e, T), u(f(e), Cw0);
              }
            }), N(IZ, function(t, n, e) {
              var i = o(im, t, n);
              return o(C0(Fw0), i, e);
            }), N(rD, function(t, n, e, i) {
              u(f(e), cw0), o(f(e), vw0, sw0);
              var x = i[1];
              function c(G) {
                return u(n, G);
              }
              function s(G) {
                return u(t, G);
              }
              R(qe[31], s, c, e, x), u(f(e), lw0), u(f(e), bw0), o(f(e), mw0, pw0);
              var p = i[2];
              function y(G) {
                return u(n, G);
              }
              R(im, function(G) {
                return u(t, G);
              }, y, e, p), u(f(e), _w0), u(f(e), yw0), o(f(e), dw0, hw0);
              var T = i[3];
              if (T) {
                g(e, kw0);
                var E = T[1], d = function(G, A) {
                  return g(G, aw0);
                }, w = function(G) {
                  return u(t, G);
                };
                R(Dr[1], w, d, e, E), g(e, ww0);
              } else g(e, Ew0);
              return u(f(e), Sw0), u(f(e), gw0);
            }), N(AZ, function(t, n, e) {
              var i = o(rD, t, n);
              return o(C0(ow0), i, e);
            });
            var eD = [0, im, IZ, rD, AZ], nD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, NZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(nD, function(t, n, e, i) {
              u(f(e), Kk0), o(f(e), Jk0, Wk0);
              var x = i[1];
              function c(y) {
                return u(n, y);
              }
              function s(y) {
                return u(t, y);
              }
              R(eD[3], s, c, e, x), u(f(e), $k0), u(f(e), Zk0), o(f(e), rw0, Qk0), o(n, e, i[2]), u(f(e), ew0), u(f(e), nw0), o(f(e), uw0, tw0);
              var p = i[3];
              return o(f(e), iw0, p), u(f(e), fw0), u(f(e), xw0);
            }), N(NZ, function(t, n, e) {
              var i = o(nD, t, n);
              return o(C0(zk0), i, e);
            });
            var CZ = [0, nD, NZ], tD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, PZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(tD, function(t, n, e, i) {
              u(f(e), Ek0), o(f(e), gk0, Sk0);
              var x = i[1];
              if (x) {
                g(e, Fk0);
                var c = x[1], s = function(G) {
                  return u(n, G);
                }, p = function(G) {
                  return u(t, G);
                };
                R(qe[31], p, s, e, c), g(e, Tk0);
              } else g(e, Ok0);
              u(f(e), Ik0), u(f(e), Ak0), o(f(e), Ck0, Nk0);
              var y = i[2];
              if (y) {
                g(e, Pk0);
                var T = y[1], E = function(G, A) {
                  return g(G, wk0);
                }, d = function(G) {
                  return u(t, G);
                };
                R(Dr[1], d, E, e, T), g(e, Dk0);
              } else g(e, Lk0);
              u(f(e), Rk0), u(f(e), jk0), o(f(e), Mk0, Gk0);
              var w = i[3];
              return o(f(e), Bk0, w), u(f(e), qk0), u(f(e), Uk0), o(f(e), Xk0, Hk0), o(n, e, i[4]), u(f(e), Yk0), u(f(e), Vk0);
            }), N(PZ, function(t, n, e) {
              var i = o(tD, t, n);
              return o(C0(kk0), i, e);
            });
            var DZ = [0, tD, PZ], uD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, LZ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, fm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, RZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(uD, function(t, n, e, i) {
              u(f(e), yk0), o(t, e, i[1]), u(f(e), hk0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(fm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), dk0);
            }), N(LZ, function(t, n, e) {
              var i = o(uD, t, n);
              return o(C0(_k0), i, e);
            }), N(fm, function(t, n, e, i) {
              u(f(e), tk0), o(f(e), ik0, uk0);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(di[5], s, c, e, x), u(f(e), fk0), u(f(e), xk0), o(f(e), ak0, ok0);
              var p = i[2];
              function y(d) {
                return u(n, d);
              }
              function T(d) {
                return u(t, d);
              }
              R(qe[31], T, y, e, p), u(f(e), ck0), u(f(e), sk0), o(f(e), lk0, vk0);
              var E = i[3];
              return o(f(e), bk0, E), u(f(e), pk0), u(f(e), mk0);
            }), N(RZ, function(t, n, e) {
              var i = o(fm, t, n);
              return o(C0(nk0), i, e);
            });
            var jZ = [0, uD, LZ, fm, RZ], iD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, GZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(iD, function(t, n, e, i) {
              u(f(e), Ud0), o(f(e), Xd0, Hd0);
              var x = i[1];
              u(f(e), Yd0);
              var c = 0;
              le(function(E, d) {
                E && u(f(e), qd0);
                function w(A) {
                  return u(n, A);
                }
                function G(A) {
                  return u(t, A);
                }
                return R(jZ[1], G, w, e, d), 1;
              }, c, x), u(f(e), Vd0), u(f(e), zd0), u(f(e), Kd0), o(f(e), Jd0, Wd0);
              var s = i[2];
              if (s) {
                g(e, $d0);
                var p = s[1], y = function(E) {
                  return u(n, E);
                }, T = function(E) {
                  return u(t, E);
                };
                R(qe[31], T, y, e, p), g(e, Zd0);
              } else g(e, Qd0);
              return u(f(e), rk0), u(f(e), ek0);
            }), N(GZ, function(t, n, e) {
              var i = o(iD, t, n);
              return o(C0(Bd0), i, e);
            });
            var fD = [0, jZ, iD, GZ], xD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, MZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(xD, function(t, n, e, i) {
              u(f(e), Fd0), o(f(e), Od0, Td0);
              var x = i[1];
              u(f(e), Id0);
              var c = 0;
              le(function(E, d) {
                E && u(f(e), gd0);
                function w(A) {
                  return u(n, A);
                }
                function G(A) {
                  return u(t, A);
                }
                return R(fD[1][1], G, w, e, d), 1;
              }, c, x), u(f(e), Ad0), u(f(e), Nd0), u(f(e), Cd0), o(f(e), Dd0, Pd0);
              var s = i[2];
              if (s) {
                g(e, Ld0);
                var p = s[1], y = function(E) {
                  return u(n, E);
                }, T = function(E) {
                  return u(t, E);
                };
                R(qe[31], T, y, e, p), g(e, Rd0);
              } else g(e, jd0);
              return u(f(e), Gd0), u(f(e), Md0);
            }), N(MZ, function(t, n, e) {
              var i = o(xD, t, n);
              return o(C0(Sd0), i, e);
            });
            var BZ = [0, xD, MZ], oD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, qZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(oD, function(t, n, e, i) {
              u(f(e), od0), o(f(e), cd0, ad0);
              var x = i[1];
              function c(A) {
                return u(n, A);
              }
              function s(A) {
                return u(t, A);
              }
              R(qe[31], s, c, e, x), u(f(e), sd0), u(f(e), vd0), o(f(e), bd0, ld0);
              var p = i[2];
              function y(A) {
                return u(n, A);
              }
              function T(A) {
                return u(t, A);
              }
              R($e[17], T, y, e, p), u(f(e), pd0), u(f(e), md0), o(f(e), yd0, _d0);
              var E = i[3];
              if (E) {
                g(e, hd0);
                var d = E[1], w = function(A, S) {
                  return g(A, xd0);
                }, G = function(A) {
                  return u(t, A);
                };
                R(Dr[1], G, w, e, d), g(e, dd0);
              } else g(e, kd0);
              return u(f(e), wd0), u(f(e), Ed0);
            }), N(qZ, function(t, n, e) {
              var i = o(oD, t, n);
              return o(C0(fd0), i, e);
            });
            var UZ = [0, oD, qZ], aD = function t(n, e, i) {
              return t.fun(n, e, i);
            }, HZ = function t(n, e) {
              return t.fun(n, e);
            };
            N(aD, function(t, n, e) {
              u(f(n), Xh0), o(f(n), Vh0, Yh0);
              var i = e[1];
              function x(G) {
                return u(t, G);
              }
              function c(G) {
                return u(t, G);
              }
              R(Rn[1], c, x, n, i), u(f(n), zh0), u(f(n), Kh0), o(f(n), Jh0, Wh0);
              var s = e[2];
              function p(G) {
                return u(t, G);
              }
              function y(G) {
                return u(t, G);
              }
              R(Rn[1], y, p, n, s), u(f(n), $h0), u(f(n), Zh0), o(f(n), rd0, Qh0);
              var T = e[3];
              if (T) {
                g(n, ed0);
                var E = T[1], d = function(G, A) {
                  return g(G, Hh0);
                }, w = function(G) {
                  return u(t, G);
                };
                R(Dr[1], w, d, n, E), g(n, nd0);
              } else g(n, td0);
              return u(f(n), ud0), u(f(n), id0);
            }), N(HZ, function(t, n) {
              var e = u(aD, t);
              return o(C0(Uh0), e, n);
            });
            var XZ = [0, aD, HZ], cD = function t(n, e, i) {
              return t.fun(n, e, i);
            }, YZ = function t(n, e) {
              return t.fun(n, e);
            };
            N(cD, function(t, n, e) {
              u(f(n), Dh0), o(f(n), Rh0, Lh0);
              var i = e[1];
              if (i) {
                g(n, jh0);
                var x = i[1], c = function(p, y) {
                  return g(p, Ph0);
                }, s = function(p) {
                  return u(t, p);
                };
                R(Dr[1], s, c, n, x), g(n, Gh0);
              } else g(n, Mh0);
              return u(f(n), Bh0), u(f(n), qh0);
            }), N(YZ, function(t, n) {
              var e = u(cD, t);
              return o(C0(Ch0), e, n);
            });
            var VZ = [0, cD, YZ], sD = function t(n, e, i) {
              return t.fun(n, e, i);
            }, zZ = function t(n, e) {
              return t.fun(n, e);
            };
            N(sD, function(t, n, e) {
              u(f(n), Sh0), o(f(n), Fh0, gh0);
              var i = e[1];
              if (i) {
                g(n, Th0);
                var x = i[1], c = function(p, y) {
                  return g(p, Eh0);
                }, s = function(p) {
                  return u(t, p);
                };
                R(Dr[1], s, c, n, x), g(n, Oh0);
              } else g(n, Ih0);
              return u(f(n), Ah0), u(f(n), Nh0);
            }), N(zZ, function(t, n) {
              var e = u(sD, t);
              return o(C0(wh0), e, n);
            });
            var KZ = [0, sD, zZ], vD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, WZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(vD, function(t, n, e, i) {
              u(f(e), ch0), o(f(e), vh0, sh0);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(qe[31], s, c, e, x), u(f(e), lh0), u(f(e), bh0), o(f(e), mh0, ph0);
              var p = i[2];
              if (p) {
                g(e, _h0);
                var y = p[1], T = function(d, w) {
                  return g(d, ah0);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, yh0);
              } else g(e, hh0);
              return u(f(e), dh0), u(f(e), kh0);
            }), N(WZ, function(t, n, e) {
              var i = o(vD, t, n);
              return o(C0(oh0), i, e);
            });
            var JZ = [0, vD, WZ], lD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, $Z = function t(n, e, i) {
              return t.fun(n, e, i);
            }, xm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, ZZ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(lD, function(t, n, e, i) {
              u(f(e), ih0), o(n, e, i[1]), u(f(e), fh0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(xm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), xh0);
            }), N($Z, function(t, n, e) {
              var i = o(lD, t, n);
              return o(C0(uh0), i, e);
            }), N(xm, function(t, n, e, i) {
              switch (i[0]) {
                case 0:
                  u(f(e), J_0);
                  var x = i[1], c = function(Y) {
                    return u(n, Y);
                  }, s = function(Y) {
                    return u(t, Y);
                  };
                  return R(G$[3], s, c, e, x), u(f(e), $_0);
                case 1:
                  u(f(e), Z_0);
                  var p = i[1], y = function(Y) {
                    return u(n, Y);
                  }, T = function(Y) {
                    return u(t, Y);
                  };
                  return R(As[5], T, y, e, p), u(f(e), Q_0);
                case 2:
                  u(f(e), ry0);
                  var E = i[1], d = function(Y) {
                    return u(n, Y);
                  }, w = function(Y) {
                    return u(t, Y);
                  };
                  return R(vZ[3], w, d, e, E), u(f(e), ey0);
                case 3:
                  u(f(e), ny0);
                  var G = i[1], A = function(Y) {
                    return u(n, Y);
                  }, S = function(Y) {
                    return u(t, Y);
                  };
                  return R(aZ[3], S, A, e, G), u(f(e), ty0);
                case 4:
                  u(f(e), uy0);
                  var M = i[1], K = function(Y) {
                    return u(n, Y);
                  }, V = function(Y) {
                    return u(t, Y);
                  };
                  return R(ZP[1], V, K, e, M), u(f(e), iy0);
                case 5:
                  u(f(e), fy0);
                  var f0 = i[1], m0 = function(Y) {
                    return u(n, Y);
                  }, k0 = function(Y) {
                    return u(t, Y);
                  };
                  return R(F1[8], k0, m0, e, f0), u(f(e), xy0);
                case 6:
                  u(f(e), oy0);
                  var g0 = i[1], e0 = function(Y) {
                    return u(n, Y);
                  }, x0 = function(Y) {
                    return u(t, Y);
                  };
                  return R(fD[2], x0, e0, e, g0), u(f(e), ay0);
                case 7:
                  u(f(e), cy0);
                  var l = i[1], c0 = function(Y) {
                    return u(n, Y);
                  }, t0 = function(Y) {
                    return u(t, Y);
                  };
                  return R(dZ[1], t0, c0, e, l), u(f(e), sy0);
                case 8:
                  u(f(e), vy0);
                  var o0 = i[1], w0 = function(Y) {
                    return u(n, Y);
                  }, _0 = function(Y) {
                    return u(t, Y);
                  };
                  return R(As[5], _0, w0, e, o0), u(f(e), ly0);
                case 9:
                  u(f(e), by0);
                  var E0 = i[1], U0 = function(Y) {
                    return u(n, Y);
                  }, b = function(Y) {
                    return u(t, Y);
                  };
                  return R(BZ[1], b, U0, e, E0), u(f(e), py0);
                case 10:
                  u(f(e), my0);
                  var R0 = i[1], X = function(Y) {
                    return u(n, Y);
                  }, s0 = function(Y) {
                    return u(t, Y);
                  };
                  return R(Rn[1], s0, X, e, R0), u(f(e), _y0);
                case 11:
                  u(f(e), yy0);
                  var hr = i[1], Ar = function(Y) {
                    return u(n, Y);
                  }, or = function(Y) {
                    return u(t, Y);
                  };
                  return R(JZ[1], or, Ar, e, hr), u(f(e), hy0);
                case 12:
                  u(f(e), dy0);
                  var W0 = i[1], Lr = function(Y) {
                    return u(n, Y);
                  }, Tr = function(Y) {
                    return u(t, Y);
                  };
                  return R(UN[17], Tr, Lr, e, W0), u(f(e), ky0);
                case 13:
                  u(f(e), wy0);
                  var Hr = i[1], Or = function(Y) {
                    return u(n, Y);
                  }, fr = function(Y) {
                    return u(t, Y);
                  };
                  return R(UN[19], fr, Or, e, Hr), u(f(e), Ey0);
                case 14:
                  u(f(e), Sy0);
                  var Rr = i[1], Wr = function(Y) {
                    return u(t, Y);
                  };
                  return ur(Tl[2], Wr, e, Rr), u(f(e), gy0);
                case 15:
                  u(f(e), Fy0);
                  var Jr = i[1], ar = function(Y) {
                    return u(n, Y);
                  }, _r = function(Y) {
                    return u(t, Y);
                  };
                  return R(yZ[3], _r, ar, e, Jr), u(f(e), Ty0);
                case 16:
                  u(f(e), Oy0);
                  var Ir = i[1], fe = function(Y) {
                    return u(n, Y);
                  }, v0 = function(Y) {
                    return u(t, Y);
                  };
                  return R(eD[3], v0, fe, e, Ir), u(f(e), Iy0);
                case 17:
                  u(f(e), Ay0);
                  var P = i[1], L = function(Y) {
                    return u(t, Y);
                  };
                  return ur(XZ[1], L, e, P), u(f(e), Ny0);
                case 18:
                  u(f(e), Cy0);
                  var Q = i[1], i0 = function(Y) {
                    return u(n, Y);
                  }, l0 = function(Y) {
                    return u(t, Y);
                  };
                  return R(gZ[1], l0, i0, e, Q), u(f(e), Py0);
                case 19:
                  u(f(e), Dy0);
                  var S0 = i[1], T0 = function(Y) {
                    return u(n, Y);
                  }, rr = function(Y) {
                    return u(t, Y);
                  };
                  return R(eZ[5], rr, T0, e, S0), u(f(e), Ly0);
                case 20:
                  u(f(e), Ry0);
                  var L0 = i[1], B = function(Y) {
                    return u(n, Y);
                  }, Z = function(Y) {
                    return u(t, Y);
                  };
                  return R(OZ[1], Z, B, e, L0), u(f(e), jy0);
                case 21:
                  u(f(e), Gy0);
                  var p0 = i[1], b0 = function(Y) {
                    return u(n, Y);
                  }, O0 = function(Y) {
                    return u(t, Y);
                  };
                  return R(CZ[1], O0, b0, e, p0), u(f(e), My0);
                case 22:
                  u(f(e), By0);
                  var M0 = i[1], er = function(Y) {
                    return u(n, Y);
                  }, yr = function(Y) {
                    return u(t, Y);
                  };
                  return R(tZ[1], yr, er, e, M0), u(f(e), qy0);
                case 23:
                  u(f(e), Uy0);
                  var vr = i[1], $0 = function(Y) {
                    return u(t, Y);
                  };
                  return ur(KZ[1], $0, e, vr), u(f(e), Hy0);
                case 24:
                  u(f(e), Xy0);
                  var Er = i[1], Mr = function(Y) {
                    return u(n, Y);
                  }, Br = function(Y) {
                    return u(t, Y);
                  };
                  return R(Y$[1], Br, Mr, e, Er), u(f(e), Yy0);
                case 25:
                  u(f(e), Vy0);
                  var qr = i[1], jr = function(Y) {
                    return u(n, Y);
                  }, $r = function(Y) {
                    return u(t, Y);
                  };
                  return R(RP[2], $r, jr, e, qr), u(f(e), zy0);
                case 26:
                  u(f(e), Ky0);
                  var ne = i[1], Qr = function(Y) {
                    return u(t, Y);
                  };
                  return ur(VZ[1], Qr, e, ne), u(f(e), Wy0);
                case 27:
                  u(f(e), Jy0);
                  var be = i[1], ae = function(Y) {
                    return u(n, Y);
                  }, pe = function(Y) {
                    return u(t, Y);
                  };
                  return R(UZ[1], pe, ae, e, be), u(f(e), $y0);
                case 28:
                  u(f(e), Zy0);
                  var oe = i[1], ce = function(Y) {
                    return u(n, Y);
                  }, ge = function(Y) {
                    return u(t, Y);
                  };
                  return R(fZ[3], ge, ce, e, oe), u(f(e), Qy0);
                case 29:
                  u(f(e), rh0);
                  var q0 = i[1], Fr = function(Y) {
                    return u(n, Y);
                  }, _ = function(Y) {
                    return u(t, Y);
                  };
                  return R(pZ[3], _, Fr, e, q0), u(f(e), eh0);
                default:
                  u(f(e), nh0);
                  var k = i[1], I = function(Y) {
                    return u(n, Y);
                  }, U = function(Y) {
                    return u(t, Y);
                  };
                  return R(DZ[1], U, I, e, k), u(f(e), th0);
              }
            }), N(ZZ, function(t, n, e) {
              var i = o(xm, t, n);
              return o(C0(W_0), i, e);
            }), mu(J3r, qe, [0, N$, See, CP, G$, RP, Y$, eZ, tZ, fZ, aZ, vZ, pZ, yZ, dZ, tm, kZ, WP, gZ, ZP, OZ, eD, CZ, DZ, fD, BZ, UZ, XZ, VZ, KZ, JZ, lD, $Z, xm, ZZ]);
            var bD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, QZ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, om = function t(n, e, i) {
              return t.fun(n, e, i);
            }, rQ = function t(n, e) {
              return t.fun(n, e);
            };
            N(bD, function(t, n, e, i) {
              u(f(e), V_0), o(n, e, i[1]), u(f(e), z_0);
              var x = i[2];
              return ur(om, function(c) {
                return u(t, c);
              }, e, x), u(f(e), K_0);
            }), N(QZ, function(t, n, e) {
              var i = o(bD, t, n);
              return o(C0(Y_0), i, e);
            }), N(om, function(t, n, e) {
              u(f(n), C_0), o(f(n), D_0, P_0);
              var i = e[1];
              o(f(n), L_0, i), u(f(n), R_0), u(f(n), j_0), o(f(n), M_0, G_0);
              var x = e[2];
              if (x) {
                g(n, B_0);
                var c = x[1], s = function(y, T) {
                  return g(y, N_0);
                }, p = function(y) {
                  return u(t, y);
                };
                R(Dr[1], p, s, n, c), g(n, q_0);
              } else g(n, U_0);
              return u(f(n), H_0), u(f(n), X_0);
            }), N(rQ, function(t, n) {
              var e = u(om, t);
              return o(C0(A_0), e, n);
            });
            var O1 = [0, bD, QZ, om, rQ], pD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, eQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, am = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, nQ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(pD, function(t, n, e, i) {
              u(f(e), T_0), o(t, e, i[1]), u(f(e), O_0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(am, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), I_0);
            }), N(eQ, function(t, n, e) {
              var i = o(pD, t, n);
              return o(C0(F_0), i, e);
            }), N(am, function(t, n, e, i) {
              u(f(e), __0), o(f(e), h_0, y_0);
              var x = i[1];
              function c(E) {
                return u(n, E);
              }
              function s(E) {
                return u(t, E);
              }
              R(O1[1], s, c, e, x), u(f(e), d_0), u(f(e), k_0), o(f(e), E_0, w_0);
              var p = i[2];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t, E);
              }
              return R(O1[1], T, y, e, p), u(f(e), S_0), u(f(e), g_0);
            }), N(nQ, function(t, n, e) {
              var i = o(am, t, n);
              return o(C0(m_0), i, e);
            });
            var mD = [0, pD, eQ, am, nQ], _D = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, tQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, cm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, uQ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(_D, function(t, n, e, i) {
              u(f(e), u_0), o(f(e), f_0, i_0);
              var x = i[1];
              function c(E) {
                return u(n, E);
              }
              R(cm, function(E) {
                return u(t, E);
              }, c, e, x), u(f(e), x_0), u(f(e), o_0), o(f(e), c_0, a_0);
              var s = i[2];
              if (s) {
                g(e, s_0);
                var p = s[1], y = function(E, d) {
                  u(f(E), n_0);
                  var w = 0;
                  return le(function(G, A) {
                    G && u(f(E), e_0);
                    function S(M) {
                      return u(t, M);
                    }
                    return ur(iu[1], S, E, A), 1;
                  }, w, d), u(f(E), t_0);
                }, T = function(E) {
                  return u(t, E);
                };
                R(Dr[1], T, y, e, p), g(e, v_0);
              } else g(e, l_0);
              return u(f(e), b_0), u(f(e), p_0);
            }), N(tQ, function(t, n, e) {
              var i = o(_D, t, n);
              return o(C0(r_0), i, e);
            }), N(cm, function(t, n, e, i) {
              if (i) {
                u(f(e), $90);
                var x = i[1], c = function(p) {
                  return u(n, p);
                }, s = function(p) {
                  return u(t, p);
                };
                return R(qe[31], s, c, e, x), u(f(e), Z90);
              }
              return g(e, Q90);
            }), N(uQ, function(t, n, e) {
              var i = o(cm, t, n);
              return o(C0(J90), i, e);
            });
            var yD = [0, _D, tQ, cm, uQ];
            function iQ(t, n) {
              u(f(t), G90), o(f(t), B90, M90);
              var e = n[1];
              o(f(t), q90, e), u(f(t), U90), u(f(t), H90), o(f(t), Y90, X90);
              var i = n[2];
              return o(f(t), V90, i), u(f(t), z90), u(f(t), K90);
            }
            var fQ = [0, iQ, function(t) {
              return o(C0(W90), iQ, t);
            }], hD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, xQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, sm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, oQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, vm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, aQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, lm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, cQ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(hD, function(t, n, e, i) {
              u(f(e), L90), o(t, e, i[1]), u(f(e), R90);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(lm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), j90);
            }), N(xQ, function(t, n, e) {
              var i = o(hD, t, n);
              return o(C0(D90), i, e);
            }), N(sm, function(t, n, e, i) {
              if (i[0] === 0) {
                u(f(e), A90);
                var x = i[1], c = function(E) {
                  return u(n, E);
                }, s = function(E) {
                  return u(t, E);
                };
                return R(O1[1], s, c, e, x), u(f(e), N90);
              }
              u(f(e), C90);
              var p = i[1];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t, E);
              }
              return R(mD[1], T, y, e, p), u(f(e), P90);
            }), N(oQ, function(t, n, e) {
              var i = o(sm, t, n);
              return o(C0(I90), i, e);
            }), N(vm, function(t, n, e, i) {
              if (i[0] === 0) {
                u(f(e), E90), o(n, e, i[1]), u(f(e), S90);
                var x = i[2], c = function(T) {
                  return u(t, T);
                };
                return ur(Tl[2], c, e, x), u(f(e), g90);
              }
              u(f(e), F90), o(n, e, i[1]), u(f(e), T90);
              var s = i[2];
              function p(T) {
                return u(n, T);
              }
              function y(T) {
                return u(t, T);
              }
              return R(yD[1], y, p, e, s), u(f(e), O90);
            }), N(aQ, function(t, n, e) {
              var i = o(vm, t, n);
              return o(C0(w90), i, e);
            }), N(lm, function(t, n, e, i) {
              u(f(e), c90), o(f(e), v90, s90);
              var x = i[1];
              function c(T) {
                return u(n, T);
              }
              R(sm, function(T) {
                return u(t, T);
              }, c, e, x), u(f(e), l90), u(f(e), b90), o(f(e), m90, p90);
              var s = i[2];
              if (s) {
                g(e, _90);
                var p = s[1], y = function(T) {
                  return u(n, T);
                };
                R(vm, function(T) {
                  return u(t, T);
                }, y, e, p), g(e, y90);
              } else g(e, h90);
              return u(f(e), d90), u(f(e), k90);
            }), N(cQ, function(t, n, e) {
              var i = o(lm, t, n);
              return o(C0(a90), i, e);
            });
            var sQ = [0, hD, xQ, sm, oQ, vm, aQ, lm, cQ], dD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, vQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, bm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, lQ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(dD, function(t, n, e, i) {
              u(f(e), f90), o(t, e, i[1]), u(f(e), x90);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(bm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), o90);
            }), N(vQ, function(t, n, e) {
              var i = o(dD, t, n);
              return o(C0(i90), i, e);
            }), N(bm, function(t, n, e, i) {
              u(f(e), zm0), o(f(e), Wm0, Km0);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(qe[31], s, c, e, x), u(f(e), Jm0), u(f(e), $m0), o(f(e), Qm0, Zm0);
              var p = i[2];
              if (p) {
                g(e, r90);
                var y = p[1], T = function(d, w) {
                  return g(d, Vm0);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, e90);
              } else g(e, n90);
              return u(f(e), t90), u(f(e), u90);
            }), N(lQ, function(t, n, e) {
              var i = o(bm, t, n);
              return o(C0(Ym0), i, e);
            });
            var bQ = [0, dD, vQ, bm, lQ], pm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, pQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, mm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, mQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, _m = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, _Q = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(pm, function(t, n, e, i) {
              u(f(e), Um0), o(t, e, i[1]), u(f(e), Hm0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(_m, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), Xm0);
            }), N(pQ, function(t, n, e) {
              var i = o(pm, t, n);
              return o(C0(qm0), i, e);
            }), N(mm, function(t, n, e, i) {
              if (i[0] === 0) {
                u(f(e), jm0);
                var x = i[1], c = function(T) {
                  return u(n, T);
                }, s = function(T) {
                  return u(t, T);
                };
                return R(O1[1], s, c, e, x), u(f(e), Gm0);
              }
              u(f(e), Mm0);
              var p = i[1];
              function y(T) {
                return u(n, T);
              }
              return R(pm, function(T) {
                return u(t, T);
              }, y, e, p), u(f(e), Bm0);
            }), N(mQ, function(t, n, e) {
              var i = o(mm, t, n);
              return o(C0(Rm0), i, e);
            }), N(_m, function(t, n, e, i) {
              u(f(e), Tm0), o(f(e), Im0, Om0);
              var x = i[1];
              function c(T) {
                return u(n, T);
              }
              R(mm, function(T) {
                return u(t, T);
              }, c, e, x), u(f(e), Am0), u(f(e), Nm0), o(f(e), Pm0, Cm0);
              var s = i[2];
              function p(T) {
                return u(n, T);
              }
              function y(T) {
                return u(t, T);
              }
              return R(O1[1], y, p, e, s), u(f(e), Dm0), u(f(e), Lm0);
            }), N(_Q, function(t, n, e) {
              var i = o(_m, t, n);
              return o(C0(Fm0), i, e);
            });
            var yQ = [0, pm, pQ, mm, mQ, _m, _Q], Nl = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, hQ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(Nl, function(t, n, e, i) {
              switch (i[0]) {
                case 0:
                  u(f(e), dm0);
                  var x = i[1], c = function(G) {
                    return u(n, G);
                  }, s = function(G) {
                    return u(t, G);
                  };
                  return R(O1[1], s, c, e, x), u(f(e), km0);
                case 1:
                  u(f(e), wm0);
                  var p = i[1], y = function(G) {
                    return u(n, G);
                  }, T = function(G) {
                    return u(t, G);
                  };
                  return R(mD[1], T, y, e, p), u(f(e), Em0);
                default:
                  u(f(e), Sm0);
                  var E = i[1], d = function(G) {
                    return u(n, G);
                  }, w = function(G) {
                    return u(t, G);
                  };
                  return R(yQ[1], w, d, e, E), u(f(e), gm0);
              }
            }), N(hQ, function(t, n, e) {
              var i = o(Nl, t, n);
              return o(C0(hm0), i, e);
            });
            var kD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, dQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, ym = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, kQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, hm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, wQ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(kD, function(t, n, e, i) {
              u(f(e), mm0), o(t, e, i[1]), u(f(e), _m0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(hm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), ym0);
            }), N(dQ, function(t, n, e) {
              var i = o(kD, t, n);
              return o(C0(pm0), i, e);
            }), N(ym, function(t, n, e, i) {
              if (i[0] === 0) {
                u(f(e), sm0);
                var x = i[1], c = function(E) {
                  return u(n, E);
                }, s = function(E) {
                  return u(t, E);
                };
                return R(sQ[1], s, c, e, x), u(f(e), vm0);
              }
              u(f(e), lm0);
              var p = i[1];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t, E);
              }
              return R(bQ[1], T, y, e, p), u(f(e), bm0);
            }), N(kQ, function(t, n, e) {
              var i = o(ym, t, n);
              return o(C0(cm0), i, e);
            }), N(hm, function(t, n, e, i) {
              u(f(e), K50), o(f(e), J50, W50);
              var x = i[1];
              function c(T) {
                return u(n, T);
              }
              R(Nl, function(T) {
                return u(t, T);
              }, c, e, x), u(f(e), $50), u(f(e), Z50), o(f(e), rm0, Q50);
              var s = i[2];
              o(f(e), em0, s), u(f(e), nm0), u(f(e), tm0), o(f(e), im0, um0);
              var p = i[3];
              u(f(e), fm0);
              var y = 0;
              return le(function(T, E) {
                T && u(f(e), z50);
                function d(w) {
                  return u(n, w);
                }
                return R(ym, function(w) {
                  return u(t, w);
                }, d, e, E), 1;
              }, y, p), u(f(e), xm0), u(f(e), om0), u(f(e), am0);
            }), N(wQ, function(t, n, e) {
              var i = o(hm, t, n);
              return o(C0(V50), i, e);
            });
            var EQ = [0, kD, dQ, ym, kQ, hm, wQ], wD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, SQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, dm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, gQ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(wD, function(t, n, e, i) {
              u(f(e), H50), o(t, e, i[1]), u(f(e), X50);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(dm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), Y50);
            }), N(SQ, function(t, n, e) {
              var i = o(wD, t, n);
              return o(C0(U50), i, e);
            }), N(dm, function(t, n, e, i) {
              u(f(e), j50), o(f(e), M50, G50);
              var x = i[1];
              function c(s) {
                return u(n, s);
              }
              return R(Nl, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), B50), u(f(e), q50);
            }), N(gQ, function(t, n, e) {
              var i = o(dm, t, n);
              return o(C0(R50), i, e);
            });
            var FQ = [0, wD, SQ, dm, gQ], ED = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, TQ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(ED, function(t, n, e, i) {
              u(f(e), S50), o(f(e), F50, g50);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(qe[31], s, c, e, x), u(f(e), T50), u(f(e), O50), o(f(e), A50, I50);
              var p = i[2];
              if (p) {
                g(e, N50);
                var y = p[1], T = function(d, w) {
                  return g(d, E50);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, C50);
              } else g(e, P50);
              return u(f(e), D50), u(f(e), L50);
            }), N(TQ, function(t, n, e) {
              var i = o(ED, t, n);
              return o(C0(w50), i, e);
            });
            var OQ = [0, ED, TQ], Cl = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, IQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, km = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, AQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, wm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, NQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Em = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, CQ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(Cl, function(t, n, e, i) {
              u(f(e), h50), o(t, e, i[1]), u(f(e), d50);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(km, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), k50);
            }), N(IQ, function(t, n, e) {
              var i = o(Cl, t, n);
              return o(C0(y50), i, e);
            }), N(km, function(t, n, e, i) {
              switch (i[0]) {
                case 0:
                  u(f(e), o50);
                  var x = i[1], c = function(A) {
                    return u(n, A);
                  };
                  return R(wm, function(A) {
                    return u(t, A);
                  }, c, e, x), u(f(e), a50);
                case 1:
                  u(f(e), c50);
                  var s = i[1], p = function(A) {
                    return u(n, A);
                  };
                  return R(Em, function(A) {
                    return u(t, A);
                  }, p, e, s), u(f(e), s50);
                case 2:
                  u(f(e), v50);
                  var y = i[1], T = function(A) {
                    return u(n, A);
                  }, E = function(A) {
                    return u(t, A);
                  };
                  return R(yD[1], E, T, e, y), u(f(e), l50);
                case 3:
                  u(f(e), b50);
                  var d = i[1], w = function(A) {
                    return u(n, A);
                  }, G = function(A) {
                    return u(t, A);
                  };
                  return R(OQ[1], G, w, e, d), u(f(e), p50);
                default:
                  return u(f(e), m50), o(fQ[1], e, i[1]), u(f(e), _50);
              }
            }), N(AQ, function(t, n, e) {
              var i = o(km, t, n);
              return o(C0(x50), i, e);
            }), N(wm, function(t, n, e, i) {
              u(f(e), Pp0), o(f(e), Lp0, Dp0);
              var x = i[1];
              function c(V) {
                return u(n, V);
              }
              function s(V) {
                return u(t, V);
              }
              R(EQ[1], s, c, e, x), u(f(e), Rp0), u(f(e), jp0), o(f(e), Mp0, Gp0);
              var p = i[2];
              if (p) {
                g(e, Bp0);
                var y = p[1], T = function(V) {
                  return u(n, V);
                }, E = function(V) {
                  return u(t, V);
                };
                R(FQ[1], E, T, e, y), g(e, qp0);
              } else g(e, Up0);
              u(f(e), Hp0), u(f(e), Xp0), o(f(e), Vp0, Yp0);
              var d = i[3];
              u(f(e), zp0), o(t, e, d[1]), u(f(e), Kp0), u(f(e), Wp0);
              var w = d[2], G = 0;
              le(function(V, f0) {
                V && u(f(e), Cp0);
                function m0(k0) {
                  return u(n, k0);
                }
                return R(Cl, function(k0) {
                  return u(t, k0);
                }, m0, e, f0), 1;
              }, G, w), u(f(e), Jp0), u(f(e), $p0), u(f(e), Zp0), u(f(e), Qp0), o(f(e), e50, r50);
              var A = i[4];
              if (A) {
                g(e, n50);
                var S = A[1], M = function(V, f0) {
                  return g(V, Np0);
                }, K = function(V) {
                  return u(t, V);
                };
                R(Dr[1], K, M, e, S), g(e, t50);
              } else g(e, u50);
              return u(f(e), i50), u(f(e), f50);
            }), N(NQ, function(t, n, e) {
              var i = o(wm, t, n);
              return o(C0(Ap0), i, e);
            }), N(Em, function(t, n, e, i) {
              u(f(e), ip0), o(f(e), xp0, fp0), o(t, e, i[1]), u(f(e), op0), u(f(e), ap0), o(f(e), sp0, cp0), o(t, e, i[2]), u(f(e), vp0), u(f(e), lp0), o(f(e), pp0, bp0);
              var x = i[3];
              u(f(e), mp0), o(t, e, x[1]), u(f(e), _p0), u(f(e), yp0);
              var c = x[2], s = 0;
              le(function(d, w) {
                d && u(f(e), up0);
                function G(A) {
                  return u(n, A);
                }
                return R(Cl, function(A) {
                  return u(t, A);
                }, G, e, w), 1;
              }, s, c), u(f(e), hp0), u(f(e), dp0), u(f(e), kp0), u(f(e), wp0), o(f(e), Sp0, Ep0);
              var p = i[4];
              if (p) {
                g(e, gp0);
                var y = p[1], T = function(d, w) {
                  return g(d, tp0);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, Fp0);
              } else g(e, Tp0);
              return u(f(e), Op0), u(f(e), Ip0);
            }), N(CQ, function(t, n, e) {
              var i = o(Em, t, n);
              return o(C0(np0), i, e);
            }), mu($3r, UN, [0, O1, mD, yD, fQ, sQ, bQ, yQ, Nl, hQ, EQ, FQ, OQ, Cl, IQ, km, AQ, wm, NQ, Em, CQ]);
            var SD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, PQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Sm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, DQ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(SD, function(t, n, e, i) {
              u(f(e), Q60), o(t, e, i[1]), u(f(e), rp0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Sm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), ep0);
            }), N(PQ, function(t, n, e) {
              var i = o(SD, t, n);
              return o(C0(Z60), i, e);
            }), N(Sm, function(t, n, e, i) {
              u(f(e), B60), o(f(e), U60, q60);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(di[5], s, c, e, x), u(f(e), H60), u(f(e), X60), o(f(e), V60, Y60);
              var p = i[2];
              if (p) {
                g(e, z60);
                var y = p[1], T = function(d, w) {
                  return g(d, M60);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, K60);
              } else g(e, W60);
              return u(f(e), J60), u(f(e), $60);
            }), N(DQ, function(t, n, e) {
              var i = o(Sm, t, n);
              return o(C0(G60), i, e);
            });
            var gD = [0, SD, PQ, Sm, DQ], gm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, LQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, FD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, RQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Fm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, jQ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(gm, function(t, n, e, i) {
              switch (i[0]) {
                case 0:
                  var x = i[1];
                  u(f(e), I60), u(f(e), A60), o(t, e, x[1]), u(f(e), N60);
                  var c = x[2], s = function(G) {
                    return u(t, G);
                  };
                  return ur(Tl[2], s, e, c), u(f(e), C60), u(f(e), P60);
                case 1:
                  u(f(e), D60);
                  var p = i[1], y = function(G) {
                    return u(n, G);
                  }, T = function(G) {
                    return u(t, G);
                  };
                  return R(Rn[1], T, y, e, p), u(f(e), L60);
                default:
                  u(f(e), R60);
                  var E = i[1], d = function(G) {
                    return u(n, G);
                  }, w = function(G) {
                    return u(t, G);
                  };
                  return R(qp[1], w, d, e, E), u(f(e), j60);
              }
            }), N(LQ, function(t, n, e) {
              var i = o(gm, t, n);
              return o(C0(O60), i, e);
            }), N(FD, function(t, n, e, i) {
              u(f(e), g60), o(t, e, i[1]), u(f(e), F60);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Fm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), T60);
            }), N(RQ, function(t, n, e) {
              var i = o(FD, t, n);
              return o(C0(S60), i, e);
            }), N(Fm, function(t, n, e, i) {
              u(f(e), t60), o(f(e), i60, u60);
              var x = i[1];
              function c(A) {
                return u(n, A);
              }
              R(gm, function(A) {
                return u(t, A);
              }, c, e, x), u(f(e), f60), u(f(e), x60), o(f(e), a60, o60);
              var s = i[2];
              function p(A) {
                return u(n, A);
              }
              function y(A) {
                return u(t, A);
              }
              R(di[5], y, p, e, s), u(f(e), c60), u(f(e), s60), o(f(e), l60, v60);
              var T = i[3];
              if (T) {
                g(e, b60);
                var E = T[1], d = function(A) {
                  return u(n, A);
                }, w = function(A) {
                  return u(t, A);
                };
                R(qe[31], w, d, e, E), g(e, p60);
              } else g(e, m60);
              u(f(e), _60), u(f(e), y60), o(f(e), d60, h60);
              var G = i[4];
              return o(f(e), k60, G), u(f(e), w60), u(f(e), E60);
            }), N(jQ, function(t, n, e) {
              var i = o(Fm, t, n);
              return o(C0(n60), i, e);
            });
            var GQ = [0, gm, LQ, FD, RQ, Fm, jQ], Tm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, MQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, TD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, BQ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(Tm, function(t, n, e, i) {
              if (i[0] === 0) {
                u(f(e), Z30);
                var x = i[1], c = function(E) {
                  return u(n, E);
                }, s = function(E) {
                  return u(t, E);
                };
                return R(GQ[3], s, c, e, x), u(f(e), Q30);
              }
              u(f(e), r60);
              var p = i[1];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t, E);
              }
              return R(gD[1], T, y, e, p), u(f(e), e60);
            }), N(MQ, function(t, n, e) {
              var i = o(Tm, t, n);
              return o(C0($30), i, e);
            }), N(TD, function(t, n, e, i) {
              u(f(e), P30), o(f(e), L30, D30);
              var x = i[1];
              u(f(e), R30);
              var c = 0;
              le(function(G, A) {
                G && u(f(e), C30);
                function S(M) {
                  return u(n, M);
                }
                return R(Tm, function(M) {
                  return u(t, M);
                }, S, e, A), 1;
              }, c, x), u(f(e), j30), u(f(e), G30), u(f(e), M30), o(f(e), q30, B30);
              var s = i[2];
              function p(G) {
                return u(n, G);
              }
              function y(G) {
                return u(t, G);
              }
              R($e[19], y, p, e, s), u(f(e), U30), u(f(e), H30), o(f(e), Y30, X30);
              var T = i[3];
              if (T) {
                g(e, V30);
                var E = T[1], d = function(G, A) {
                  u(f(G), A30);
                  var S = 0;
                  return le(function(M, K) {
                    M && u(f(G), I30);
                    function V(f0) {
                      return u(t, f0);
                    }
                    return ur(iu[1], V, G, K), 1;
                  }, S, A), u(f(G), N30);
                }, w = function(G) {
                  return u(t, G);
                };
                R(Dr[1], w, d, e, E), g(e, z30);
              } else g(e, K30);
              return u(f(e), W30), u(f(e), J30);
            }), N(BQ, function(t, n, e) {
              var i = o(TD, t, n);
              return o(C0(O30), i, e);
            });
            var qQ = [0, GQ, Tm, MQ, TD, BQ], OD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, UQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Om = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, HQ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(OD, function(t, n, e, i) {
              u(f(e), g30), o(t, e, i[1]), u(f(e), F30);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Om, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), T30);
            }), N(UQ, function(t, n, e) {
              var i = o(OD, t, n);
              return o(C0(S30), i, e);
            }), N(Om, function(t, n, e, i) {
              u(f(e), v30), o(f(e), b30, l30);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(di[5], s, c, e, x), u(f(e), p30), u(f(e), m30), o(f(e), y30, _30);
              var p = i[2];
              if (p) {
                g(e, h30);
                var y = p[1], T = function(d) {
                  return u(n, d);
                }, E = function(d) {
                  return u(t, d);
                };
                R(qe[31], E, T, e, y), g(e, d30);
              } else g(e, k30);
              return u(f(e), w30), u(f(e), E30);
            }), N(HQ, function(t, n, e) {
              var i = o(Om, t, n);
              return o(C0(s30), i, e);
            });
            var XQ = [0, OD, UQ, Om, HQ], Im = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, YQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, ID = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, VQ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(Im, function(t, n, e, i) {
              switch (i[0]) {
                case 0:
                  u(f(e), i30);
                  var x = i[1], c = function(E) {
                    return u(n, E);
                  }, s = function(E) {
                    return u(t, E);
                  };
                  return R(XQ[1], s, c, e, x), u(f(e), f30);
                case 1:
                  u(f(e), x30);
                  var p = i[1], y = function(E) {
                    return u(n, E);
                  }, T = function(E) {
                    return u(t, E);
                  };
                  return R(gD[1], T, y, e, p), u(f(e), o30);
                default:
                  return u(f(e), a30), o(t, e, i[1]), u(f(e), c30);
              }
            }), N(YQ, function(t, n, e) {
              var i = o(Im, t, n);
              return o(C0(u30), i, e);
            }), N(ID, function(t, n, e, i) {
              u(f(e), B80), o(f(e), U80, q80);
              var x = i[1];
              u(f(e), H80);
              var c = 0;
              le(function(G, A) {
                G && u(f(e), M80);
                function S(M) {
                  return u(n, M);
                }
                return R(Im, function(M) {
                  return u(t, M);
                }, S, e, A), 1;
              }, c, x), u(f(e), X80), u(f(e), Y80), u(f(e), V80), o(f(e), K80, z80);
              var s = i[2];
              function p(G) {
                return u(n, G);
              }
              function y(G) {
                return u(t, G);
              }
              R($e[19], y, p, e, s), u(f(e), W80), u(f(e), J80), o(f(e), Z80, $80);
              var T = i[3];
              if (T) {
                g(e, Q80);
                var E = T[1], d = function(G, A) {
                  u(f(G), j80);
                  var S = 0;
                  return le(function(M, K) {
                    M && u(f(G), R80);
                    function V(f0) {
                      return u(t, f0);
                    }
                    return ur(iu[1], V, G, K), 1;
                  }, S, A), u(f(G), G80);
                }, w = function(G) {
                  return u(t, G);
                };
                R(Dr[1], w, d, e, E), g(e, r30);
              } else g(e, e30);
              return u(f(e), n30), u(f(e), t30);
            }), N(VQ, function(t, n, e) {
              var i = o(ID, t, n);
              return o(C0(L80), i, e);
            });
            var zQ = [0, XQ, Im, YQ, ID, VQ], AD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, KQ = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(AD, function(t, n, e, i) {
              u(f(e), k80), o(f(e), E80, w80);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(Rn[1], s, c, e, x), u(f(e), S80), u(f(e), g80), o(f(e), T80, F80);
              var p = i[2];
              function y(d) {
                return u(n, d);
              }
              function T(d) {
                return u(t, d);
              }
              R($e[19], T, y, e, p), u(f(e), O80), u(f(e), I80), o(f(e), N80, A80);
              var E = i[3];
              return o(f(e), C80, E), u(f(e), P80), u(f(e), D80);
            }), N(KQ, function(t, n, e) {
              var i = o(AD, t, n);
              return o(C0(d80), i, e);
            });
            var WQ = [0, AD, KQ], ND = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, JQ = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Am = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, $Q = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(ND, function(t, n, e, i) {
              u(f(e), _80), o(n, e, i[1]), u(f(e), y80);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Am, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), h80);
            }), N(JQ, function(t, n, e) {
              var i = o(ND, t, n);
              return o(C0(m80), i, e);
            }), N(Am, function(t, n, e, i) {
              switch (i[0]) {
                case 0:
                  u(f(e), o80);
                  var x = i[1], c = function(M) {
                    return u(n, M);
                  }, s = function(M) {
                    return u(t, M);
                  };
                  return R(qQ[4], s, c, e, x), u(f(e), a80);
                case 1:
                  u(f(e), c80);
                  var p = i[1], y = function(M) {
                    return u(n, M);
                  }, T = function(M) {
                    return u(t, M);
                  };
                  return R(zQ[4], T, y, e, p), u(f(e), s80);
                case 2:
                  u(f(e), v80);
                  var E = i[1], d = function(M) {
                    return u(n, M);
                  }, w = function(M) {
                    return u(t, M);
                  };
                  return R(WQ[1], w, d, e, E), u(f(e), l80);
                default:
                  u(f(e), b80);
                  var G = i[1], A = function(M) {
                    return u(n, M);
                  }, S = function(M) {
                    return u(t, M);
                  };
                  return R(qe[31], S, A, e, G), u(f(e), p80);
              }
            }), N($Q, function(t, n, e) {
              var i = o(Am, t, n);
              return o(C0(x80), i, e);
            }), mu(Z3r, di, [0, gD, qQ, zQ, WQ, ND, JQ, Am, $Q]);
            var CD = function t(n, e, i) {
              return t.fun(n, e, i);
            }, ZQ = function t(n, e) {
              return t.fun(n, e);
            }, Nm = function t(n, e) {
              return t.fun(n, e);
            }, QQ = function t(n) {
              return t.fun(n);
            }, Cm = function t(n, e) {
              return t.fun(n, e);
            }, r00 = function t(n) {
              return t.fun(n);
            };
            N(CD, function(t, n, e) {
              return u(f(n), u80), o(t, n, e[1]), u(f(n), i80), o(Cm, n, e[2]), u(f(n), f80);
            }), N(ZQ, function(t, n) {
              var e = u(CD, t);
              return o(C0(t80), e, n);
            }), N(Nm, function(t, n) {
              return n ? g(t, e80) : g(t, n80);
            }), N(QQ, function(t) {
              return o(C0(r80), Nm, t);
            }), N(Cm, function(t, n) {
              u(f(t), M40), o(f(t), q40, B40), o(Nm, t, n[1]), u(f(t), U40), u(f(t), H40), o(f(t), Y40, X40);
              var e = n[2];
              o(f(t), V40, e), u(f(t), z40), u(f(t), K40), o(f(t), J40, W40);
              var i = n[3];
              return o(f(t), $40, i), u(f(t), Z40), u(f(t), Q40);
            }), N(r00, function(t) {
              return o(C0(G40), Cm, t);
            }), mu(Q3r, iu, [0, CD, ZQ, Nm, QQ, Cm, r00]);
            var PD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, e00 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Pm = function t(n, e) {
              return t.fun(n, e);
            }, n00 = function t(n) {
              return t.fun(n);
            }, Dm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, t00 = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(PD, function(t, n, e, i) {
              u(f(e), L40), o(n, e, i[1]), u(f(e), R40);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Dm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), j40);
            }), N(e00, function(t, n, e) {
              var i = o(PD, t, n);
              return o(C0(D40), i, e);
            }), N(Pm, function(t, n) {
              switch (n) {
                case 0:
                  return g(t, A40);
                case 1:
                  return g(t, N40);
                case 2:
                  return g(t, C40);
                default:
                  return g(t, P40);
              }
            }), N(n00, function(t) {
              return o(C0(I40), Pm, t);
            }), N(Dm, function(t, n, e, i) {
              u(f(e), Wb0), o(f(e), $b0, Jb0), o(Pm, e, i[1]), u(f(e), Zb0), u(f(e), Qb0), o(f(e), e40, r40);
              var x = i[2];
              function c(V) {
                return u(n, V);
              }
              function s(V) {
                return u(t, V);
              }
              R(qe[7][1][1], s, c, e, x), u(f(e), n40), u(f(e), t40), o(f(e), i40, u40);
              var p = i[3];
              u(f(e), f40), o(t, e, p[1]), u(f(e), x40);
              var y = p[2];
              function T(V) {
                return u(n, V);
              }
              function E(V) {
                return u(t, V);
              }
              R(As[5], E, T, e, y), u(f(e), o40), u(f(e), a40), u(f(e), c40), o(f(e), v40, s40);
              var d = i[4];
              o(f(e), l40, d), u(f(e), b40), u(f(e), p40), o(f(e), _40, m40);
              var w = i[5];
              u(f(e), y40);
              var G = 0;
              le(function(V, f0) {
                V && u(f(e), Kb0);
                function m0(g0) {
                  return u(n, g0);
                }
                function k0(g0) {
                  return u(t, g0);
                }
                return R(F1[7][1], k0, m0, e, f0), 1;
              }, G, w), u(f(e), h40), u(f(e), d40), u(f(e), k40), o(f(e), E40, w40);
              var A = i[6];
              if (A) {
                g(e, S40);
                var S = A[1], M = function(V, f0) {
                  return g(V, zb0);
                }, K = function(V) {
                  return u(t, V);
                };
                R(Dr[1], K, M, e, S), g(e, g40);
              } else g(e, F40);
              return u(f(e), T40), u(f(e), O40);
            }), N(t00, function(t, n, e) {
              var i = o(Dm, t, n);
              return o(C0(Vb0), i, e);
            });
            var u00 = [0, PD, e00, Pm, n00, Dm, t00], DD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, i00 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Lm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, f00 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Rm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, x00 = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(DD, function(t, n, e, i) {
              u(f(e), Hb0), o(n, e, i[1]), u(f(e), Xb0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Lm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), Yb0);
            }), N(i00, function(t, n, e) {
              var i = o(DD, t, n);
              return o(C0(Ub0), i, e);
            }), N(Lm, function(t, n, e, i) {
              u(f(e), cb0), o(f(e), vb0, sb0);
              var x = i[1];
              function c(m0) {
                return u(n, m0);
              }
              function s(m0) {
                return u(t, m0);
              }
              R(qe[7][1][1], s, c, e, x), u(f(e), lb0), u(f(e), bb0), o(f(e), mb0, pb0);
              var p = i[2];
              function y(m0) {
                return u(n, m0);
              }
              R(Rm, function(m0) {
                return u(t, m0);
              }, y, e, p), u(f(e), _b0), u(f(e), yb0), o(f(e), db0, hb0);
              var T = i[3];
              function E(m0) {
                return u(n, m0);
              }
              function d(m0) {
                return u(t, m0);
              }
              R($e[19], d, E, e, T), u(f(e), kb0), u(f(e), wb0), o(f(e), Sb0, Eb0);
              var w = i[4];
              o(f(e), gb0, w), u(f(e), Fb0), u(f(e), Tb0), o(f(e), Ib0, Ob0);
              var G = i[5];
              if (G) {
                g(e, Ab0);
                var A = G[1], S = function(m0) {
                  return u(t, m0);
                };
                ur(zv[1], S, e, A), g(e, Nb0);
              } else g(e, Cb0);
              u(f(e), Pb0), u(f(e), Db0), o(f(e), Rb0, Lb0);
              var M = i[6];
              if (M) {
                g(e, jb0);
                var K = M[1], V = function(m0, k0) {
                  return g(m0, ab0);
                }, f0 = function(m0) {
                  return u(t, m0);
                };
                R(Dr[1], f0, V, e, K), g(e, Gb0);
              } else g(e, Mb0);
              return u(f(e), Bb0), u(f(e), qb0);
            }), N(f00, function(t, n, e) {
              var i = o(Lm, t, n);
              return o(C0(ob0), i, e);
            }), N(Rm, function(t, n, e, i) {
              if (typeof i == "number") return i ? g(e, ub0) : g(e, ib0);
              u(f(e), fb0);
              var x = i[1];
              function c(p) {
                return u(n, p);
              }
              function s(p) {
                return u(t, p);
              }
              return R(qe[31], s, c, e, x), u(f(e), xb0);
            }), N(x00, function(t, n, e) {
              var i = o(Rm, t, n);
              return o(C0(tb0), i, e);
            });
            var o00 = [0, DD, i00, Lm, f00, Rm, x00], LD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, a00 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, jm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, c00 = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(LD, function(t, n, e, i) {
              u(f(e), rb0), o(n, e, i[1]), u(f(e), eb0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(jm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), nb0);
            }), N(a00, function(t, n, e) {
              var i = o(LD, t, n);
              return o(C0(Ql0), i, e);
            }), N(jm, function(t, n, e, i) {
              u(f(e), kl0), o(f(e), El0, wl0);
              var x = i[1];
              function c(m0) {
                return u(t, m0);
              }
              ur(Bp[1], c, e, x), u(f(e), Sl0), u(f(e), gl0), o(f(e), Tl0, Fl0);
              var s = i[2];
              function p(m0) {
                return u(n, m0);
              }
              function y(m0) {
                return u(t, m0);
              }
              R(F1[2][5], y, p, e, s), u(f(e), Ol0), u(f(e), Il0), o(f(e), Nl0, Al0);
              var T = i[3];
              function E(m0) {
                return u(n, m0);
              }
              function d(m0) {
                return u(t, m0);
              }
              R($e[19], d, E, e, T), u(f(e), Cl0), u(f(e), Pl0), o(f(e), Ll0, Dl0);
              var w = i[4];
              o(f(e), Rl0, w), u(f(e), jl0), u(f(e), Gl0), o(f(e), Bl0, Ml0);
              var G = i[5];
              if (G) {
                g(e, ql0);
                var A = G[1], S = function(m0) {
                  return u(t, m0);
                };
                ur(zv[1], S, e, A), g(e, Ul0);
              } else g(e, Hl0);
              u(f(e), Xl0), u(f(e), Yl0), o(f(e), zl0, Vl0);
              var M = i[6];
              if (M) {
                g(e, Kl0);
                var K = M[1], V = function(m0, k0) {
                  return g(m0, dl0);
                }, f0 = function(m0) {
                  return u(t, m0);
                };
                R(Dr[1], f0, V, e, K), g(e, Wl0);
              } else g(e, Jl0);
              return u(f(e), $l0), u(f(e), Zl0);
            }), N(c00, function(t, n, e) {
              var i = o(jm, t, n);
              return o(C0(hl0), i, e);
            });
            var s00 = [0, LD, a00, jm, c00], RD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, v00 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Gm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, l00 = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(RD, function(t, n, e, i) {
              u(f(e), ml0), o(t, e, i[1]), u(f(e), _l0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Gm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), yl0);
            }), N(v00, function(t, n, e) {
              var i = o(RD, t, n);
              return o(C0(pl0), i, e);
            }), N(Gm, function(t, n, e, i) {
              u(f(e), J20), o(f(e), Z20, $20);
              var x = i[1];
              function c(S) {
                return u(n, S);
              }
              function s(S) {
                return u(t, S);
              }
              R(qe[31], s, c, e, x), u(f(e), Q20), u(f(e), rl0), o(f(e), nl0, el0);
              var p = i[2];
              if (p) {
                g(e, tl0);
                var y = p[1], T = function(S) {
                  return u(n, S);
                }, E = function(S) {
                  return u(t, S);
                };
                R($e[23][1], E, T, e, y), g(e, ul0);
              } else g(e, il0);
              u(f(e), fl0), u(f(e), xl0), o(f(e), al0, ol0);
              var d = i[3];
              if (d) {
                g(e, cl0);
                var w = d[1], G = function(S, M) {
                  return g(S, W20);
                }, A = function(S) {
                  return u(t, S);
                };
                R(Dr[1], A, G, e, w), g(e, sl0);
              } else g(e, vl0);
              return u(f(e), ll0), u(f(e), bl0);
            }), N(l00, function(t, n, e) {
              var i = o(Gm, t, n);
              return o(C0(K20), i, e);
            });
            var b00 = [0, RD, v00, Gm, l00], jD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, p00 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Mm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, m00 = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(jD, function(t, n, e, i) {
              u(f(e), Y20), o(t, e, i[1]), u(f(e), V20);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Mm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), z20);
            }), N(p00, function(t, n, e) {
              var i = o(jD, t, n);
              return o(C0(X20), i, e);
            }), N(Mm, function(t, n, e, i) {
              u(f(e), C20), o(f(e), D20, P20);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(Rn[1], s, c, e, x), u(f(e), L20), u(f(e), R20), o(f(e), G20, j20);
              var p = i[2];
              if (p) {
                g(e, M20);
                var y = p[1], T = function(d) {
                  return u(n, d);
                }, E = function(d) {
                  return u(t, d);
                };
                R($e[23][1], E, T, e, y), g(e, B20);
              } else g(e, q20);
              return u(f(e), U20), u(f(e), H20);
            }), N(m00, function(t, n, e) {
              var i = o(Mm, t, n);
              return o(C0(N20), i, e);
            });
            var _00 = [0, jD, p00, Mm, m00], GD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, y00 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Bm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, h00 = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(GD, function(t, n, e, i) {
              u(f(e), O20), o(t, e, i[1]), u(f(e), I20);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Bm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), A20);
            }), N(y00, function(t, n, e) {
              var i = o(GD, t, n);
              return o(C0(T20), i, e);
            }), N(Bm, function(t, n, e, i) {
              u(f(e), l20), o(f(e), p20, b20);
              var x = i[1];
              u(f(e), m20);
              var c = 0;
              le(function(E, d) {
                E && u(f(e), v20);
                function w(A) {
                  return u(n, A);
                }
                function G(A) {
                  return u(t, A);
                }
                return R(_00[1], G, w, e, d), 1;
              }, c, x), u(f(e), _20), u(f(e), y20), u(f(e), h20), o(f(e), k20, d20);
              var s = i[2];
              if (s) {
                g(e, w20);
                var p = s[1], y = function(E, d) {
                  return g(E, s20);
                }, T = function(E) {
                  return u(t, E);
                };
                R(Dr[1], T, y, e, p), g(e, E20);
              } else g(e, S20);
              return u(f(e), g20), u(f(e), F20);
            }), N(h00, function(t, n, e) {
              var i = o(Bm, t, n);
              return o(C0(c20), i, e);
            });
            var d00 = [0, _00, GD, y00, Bm, h00], MD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, k00 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, qm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, w00 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Um = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, E00 = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(MD, function(t, n, e, i) {
              u(f(e), x20), o(t, e, i[1]), u(f(e), o20);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(qm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), a20);
            }), N(k00, function(t, n, e) {
              var i = o(MD, t, n);
              return o(C0(f20), i, e);
            }), N(qm, function(t, n, e, i) {
              u(f(e), Vv0), o(f(e), Kv0, zv0);
              var x = i[1];
              u(f(e), Wv0);
              var c = 0;
              le(function(E, d) {
                E && u(f(e), Yv0);
                function w(G) {
                  return u(n, G);
                }
                return R(Um, function(G) {
                  return u(t, G);
                }, w, e, d), 1;
              }, c, x), u(f(e), Jv0), u(f(e), $v0), u(f(e), Zv0), o(f(e), r20, Qv0);
              var s = i[2];
              if (s) {
                g(e, e20);
                var p = s[1], y = function(E, d) {
                  return g(E, Xv0);
                }, T = function(E) {
                  return u(t, E);
                };
                R(Dr[1], T, y, e, p), g(e, n20);
              } else g(e, t20);
              return u(f(e), u20), u(f(e), i20);
            }), N(w00, function(t, n, e) {
              var i = o(qm, t, n);
              return o(C0(Hv0), i, e);
            }), N(Um, function(t, n, e, i) {
              switch (i[0]) {
                case 0:
                  u(f(e), jv0);
                  var x = i[1], c = function(G) {
                    return u(n, G);
                  }, s = function(G) {
                    return u(t, G);
                  };
                  return R(u00[1], s, c, e, x), u(f(e), Gv0);
                case 1:
                  u(f(e), Mv0);
                  var p = i[1], y = function(G) {
                    return u(n, G);
                  }, T = function(G) {
                    return u(t, G);
                  };
                  return R(o00[1], T, y, e, p), u(f(e), Bv0);
                default:
                  u(f(e), qv0);
                  var E = i[1], d = function(G) {
                    return u(n, G);
                  }, w = function(G) {
                    return u(t, G);
                  };
                  return R(s00[1], w, d, e, E), u(f(e), Uv0);
              }
            }), N(E00, function(t, n, e) {
              var i = o(Um, t, n);
              return o(C0(Rv0), i, e);
            });
            var BD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, S00 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Hm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, g00 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, gee = [0, MD, k00, qm, w00, Um, E00];
            N(BD, function(t, n, e, i) {
              u(f(e), Pv0), o(t, e, i[1]), u(f(e), Dv0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Hm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), Lv0);
            }), N(S00, function(t, n, e) {
              var i = o(BD, t, n);
              return o(C0(Cv0), i, e);
            }), N(Hm, function(t, n, e, i) {
              u(f(e), dv0), o(f(e), wv0, kv0);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(qe[31], s, c, e, x), u(f(e), Ev0), u(f(e), Sv0), o(f(e), Fv0, gv0);
              var p = i[2];
              if (p) {
                g(e, Tv0);
                var y = p[1], T = function(d, w) {
                  return g(d, hv0);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, Ov0);
              } else g(e, Iv0);
              return u(f(e), Av0), u(f(e), Nv0);
            }), N(g00, function(t, n, e) {
              var i = o(Hm, t, n);
              return o(C0(yv0), i, e);
            });
            var F00 = [0, BD, S00, Hm, g00], qD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, T00 = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(qD, function(t, n, e, i) {
              u(f(e), F10), o(f(e), O10, T10);
              var x = i[1];
              if (x) {
                g(e, I10);
                var c = x[1], s = function(w0) {
                  return u(n, w0);
                }, p = function(w0) {
                  return u(t, w0);
                };
                R(Rn[1], p, s, e, c), g(e, A10);
              } else g(e, N10);
              u(f(e), C10), u(f(e), P10), o(f(e), L10, D10);
              var y = i[2];
              function T(w0) {
                return u(n, w0);
              }
              function E(w0) {
                return u(t, w0);
              }
              R(F1[6][1], E, T, e, y), u(f(e), R10), u(f(e), j10), o(f(e), M10, G10);
              var d = i[3];
              if (d) {
                g(e, B10);
                var w = d[1], G = function(w0) {
                  return u(n, w0);
                }, A = function(w0) {
                  return u(t, w0);
                };
                R($e[22][1], A, G, e, w), g(e, q10);
              } else g(e, U10);
              u(f(e), H10), u(f(e), X10), o(f(e), V10, Y10);
              var S = i[4];
              if (S) {
                g(e, z10);
                var M = S[1], K = function(w0) {
                  return u(n, w0);
                }, V = function(w0) {
                  return u(t, w0);
                };
                R(b00[1], V, K, e, M), g(e, K10);
              } else g(e, W10);
              u(f(e), J10), u(f(e), $10), o(f(e), Q10, Z10);
              var f0 = i[5];
              if (f0) {
                g(e, rv0);
                var m0 = f0[1], k0 = function(w0) {
                  return u(n, w0);
                }, g0 = function(w0) {
                  return u(t, w0);
                };
                R(d00[2], g0, k0, e, m0), g(e, ev0);
              } else g(e, nv0);
              u(f(e), tv0), u(f(e), uv0), o(f(e), fv0, iv0);
              var e0 = i[6];
              u(f(e), xv0);
              var x0 = 0;
              le(function(w0, _0) {
                w0 && u(f(e), g10);
                function E0(b) {
                  return u(n, b);
                }
                function U0(b) {
                  return u(t, b);
                }
                return R(F00[1], U0, E0, e, _0), 1;
              }, x0, e0), u(f(e), ov0), u(f(e), av0), u(f(e), cv0), o(f(e), vv0, sv0);
              var l = i[7];
              if (l) {
                g(e, lv0);
                var c0 = l[1], t0 = function(w0, _0) {
                  return g(w0, S10);
                }, o0 = function(w0) {
                  return u(t, w0);
                };
                R(Dr[1], o0, t0, e, c0), g(e, bv0);
              } else g(e, pv0);
              return u(f(e), mv0), u(f(e), _v0);
            }), N(T00, function(t, n, e) {
              var i = o(qD, t, n);
              return o(C0(E10), i, e);
            }), mu(r6r, F1, [0, u00, o00, s00, b00, d00, gee, F00, qD, T00]);
            var UD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, O00 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Xm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, I00 = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(UD, function(t, n, e, i) {
              u(f(e), d10), o(t, e, i[1]), u(f(e), k10);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Xm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), w10);
            }), N(O00, function(t, n, e) {
              var i = o(UD, t, n);
              return o(C0(h10), i, e);
            }), N(Xm, function(t, n, e, i) {
              u(f(e), x10), o(f(e), a10, o10);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(di[5], s, c, e, x), u(f(e), c10), u(f(e), s10), o(f(e), l10, v10);
              var p = i[2];
              if (p) {
                g(e, b10);
                var y = p[1], T = function(d, w) {
                  return g(d, f10);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, p10);
              } else g(e, m10);
              return u(f(e), _10), u(f(e), y10);
            }), N(I00, function(t, n, e) {
              var i = o(Xm, t, n);
              return o(C0(i10), i, e);
            });
            var A00 = [0, UD, O00, Xm, I00], HD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, N00 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Ym = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, C00 = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(HD, function(t, n, e, i) {
              u(f(e), n10), o(t, e, i[1]), u(f(e), t10);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Ym, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), u10);
            }), N(N00, function(t, n, e) {
              var i = o(HD, t, n);
              return o(C0(e10), i, e);
            }), N(Ym, function(t, n, e, i) {
              u(f(e), Hs0), o(f(e), Ys0, Xs0);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R(di[5], s, c, e, x), u(f(e), Vs0), u(f(e), zs0), o(f(e), Ws0, Ks0);
              var p = i[2];
              if (p) {
                g(e, Js0);
                var y = p[1], T = function(d) {
                  return u(n, d);
                }, E = function(d) {
                  return u(t, d);
                };
                R(qe[31], E, T, e, y), g(e, $s0);
              } else g(e, Zs0);
              return u(f(e), Qs0), u(f(e), r10);
            }), N(C00, function(t, n, e) {
              var i = o(Ym, t, n);
              return o(C0(Us0), i, e);
            });
            var P00 = [0, HD, N00, Ym, C00], XD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, D00 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Vm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, L00 = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(XD, function(t, n, e, i) {
              u(f(e), Ms0), o(t, e, i[1]), u(f(e), Bs0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Vm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), qs0);
            }), N(D00, function(t, n, e) {
              var i = o(XD, t, n);
              return o(C0(Gs0), i, e);
            }), N(Vm, function(t, n, e, i) {
              u(f(e), Fs0), o(f(e), Os0, Ts0);
              var x = i[1];
              function c(d) {
                return u(n, d);
              }
              function s(d) {
                return u(t, d);
              }
              R($e[17], s, c, e, x), u(f(e), Is0), u(f(e), As0), o(f(e), Cs0, Ns0);
              var p = i[2];
              if (p) {
                g(e, Ps0);
                var y = p[1], T = function(d, w) {
                  return g(d, gs0);
                }, E = function(d) {
                  return u(t, d);
                };
                R(Dr[1], E, T, e, y), g(e, Ds0);
              } else g(e, Ls0);
              return u(f(e), Rs0), u(f(e), js0);
            }), N(L00, function(t, n, e) {
              var i = o(Vm, t, n);
              return o(C0(Ss0), i, e);
            });
            var R00 = [0, XD, D00, Vm, L00], YD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, j00 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, zm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, G00 = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(YD, function(t, n, e, i) {
              u(f(e), ks0), o(t, e, i[1]), u(f(e), ws0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(zm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), Es0);
            }), N(j00, function(t, n, e) {
              var i = o(YD, t, n);
              return o(C0(ds0), i, e);
            }), N(zm, function(t, n, e, i) {
              u(f(e), Vc0), o(f(e), Kc0, zc0);
              var x = i[1];
              if (x) {
                g(e, Wc0);
                var c = x[1], s = function(V) {
                  return u(n, V);
                }, p = function(V) {
                  return u(t, V);
                };
                R(R00[1], p, s, e, c), g(e, Jc0);
              } else g(e, $c0);
              u(f(e), Zc0), u(f(e), Qc0), o(f(e), es0, rs0);
              var y = i[2];
              u(f(e), ns0);
              var T = 0;
              le(function(V, f0) {
                V && u(f(e), Yc0);
                function m0(g0) {
                  return u(n, g0);
                }
                function k0(g0) {
                  return u(t, g0);
                }
                return R(P00[1], k0, m0, e, f0), 1;
              }, T, y), u(f(e), ts0), u(f(e), us0), u(f(e), is0), o(f(e), xs0, fs0);
              var E = i[3];
              if (E) {
                g(e, os0);
                var d = E[1], w = function(V) {
                  return u(n, V);
                }, G = function(V) {
                  return u(t, V);
                };
                R(A00[1], G, w, e, d), g(e, as0);
              } else g(e, cs0);
              u(f(e), ss0), u(f(e), vs0), o(f(e), bs0, ls0);
              var A = i[4];
              if (A) {
                g(e, ps0);
                var S = A[1], M = function(V, f0) {
                  u(f(V), Hc0);
                  var m0 = 0;
                  return le(function(k0, g0) {
                    k0 && u(f(V), Uc0);
                    function e0(x0) {
                      return u(t, x0);
                    }
                    return ur(iu[1], e0, V, g0), 1;
                  }, m0, f0), u(f(V), Xc0);
                }, K = function(V) {
                  return u(t, V);
                };
                R(Dr[1], K, M, e, S), g(e, ms0);
              } else g(e, _s0);
              return u(f(e), ys0), u(f(e), hs0);
            }), N(G00, function(t, n, e) {
              var i = o(zm, t, n);
              return o(C0(qc0), i, e);
            });
            var M00 = [0, YD, j00, zm, G00], VD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, B00 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Km = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, q00 = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(VD, function(t, n, e, i) {
              u(f(e), Ba0), o(f(e), Ua0, qa0);
              var x = i[1];
              if (x) {
                g(e, Ha0);
                var c = x[1], s = function(_0) {
                  return u(n, _0);
                }, p = function(_0) {
                  return u(t, _0);
                };
                R(Rn[1], p, s, e, c), g(e, Xa0);
              } else g(e, Ya0);
              u(f(e), Va0), u(f(e), za0), o(f(e), Wa0, Ka0);
              var y = i[2];
              function T(_0) {
                return u(n, _0);
              }
              function E(_0) {
                return u(t, _0);
              }
              R(M00[1], E, T, e, y), u(f(e), Ja0), u(f(e), $a0), o(f(e), Qa0, Za0);
              var d = i[3];
              function w(_0) {
                return u(n, _0);
              }
              R(Km, function(_0) {
                return u(t, _0);
              }, w, e, d), u(f(e), rc0), u(f(e), ec0), o(f(e), tc0, nc0);
              var G = i[4];
              o(f(e), uc0, G), u(f(e), ic0), u(f(e), fc0), o(f(e), oc0, xc0);
              var A = i[5];
              o(f(e), ac0, A), u(f(e), cc0), u(f(e), sc0), o(f(e), lc0, vc0);
              var S = i[6];
              if (S) {
                g(e, bc0);
                var M = S[1], K = function(_0) {
                  return u(n, _0);
                }, V = function(_0) {
                  return u(t, _0);
                };
                R($e[24][1], V, K, e, M), g(e, pc0);
              } else g(e, mc0);
              u(f(e), _c0), u(f(e), yc0), o(f(e), dc0, hc0);
              var f0 = i[7];
              function m0(_0) {
                return u(n, _0);
              }
              function k0(_0) {
                return u(t, _0);
              }
              R($e[19], k0, m0, e, f0), u(f(e), kc0), u(f(e), wc0), o(f(e), Sc0, Ec0);
              var g0 = i[8];
              if (g0) {
                g(e, gc0);
                var e0 = g0[1], x0 = function(_0) {
                  return u(n, _0);
                }, l = function(_0) {
                  return u(t, _0);
                };
                R($e[22][1], l, x0, e, e0), g(e, Fc0);
              } else g(e, Tc0);
              u(f(e), Oc0), u(f(e), Ic0), o(f(e), Nc0, Ac0);
              var c0 = i[9];
              if (c0) {
                g(e, Cc0);
                var t0 = c0[1], o0 = function(_0, E0) {
                  return g(_0, Ma0);
                }, w0 = function(_0) {
                  return u(t, _0);
                };
                R(Dr[1], w0, o0, e, t0), g(e, Pc0);
              } else g(e, Dc0);
              return u(f(e), Lc0), u(f(e), Rc0), o(f(e), Gc0, jc0), o(t, e, i[10]), u(f(e), Mc0), u(f(e), Bc0);
            }), N(B00, function(t, n, e) {
              var i = o(VD, t, n);
              return o(C0(Ga0), i, e);
            }), N(Km, function(t, n, e, i) {
              if (i[0] === 0) {
                var x = i[1];
                u(f(e), Na0), u(f(e), Ca0), o(t, e, x[1]), u(f(e), Pa0);
                var c = x[2], s = function(d) {
                  return u(n, d);
                }, p = function(d) {
                  return u(t, d);
                };
                return R(Yu[1][1], p, s, e, c), u(f(e), Da0), u(f(e), La0);
              }
              u(f(e), Ra0);
              var y = i[1];
              function T(d) {
                return u(n, d);
              }
              function E(d) {
                return u(t, d);
              }
              return R(qe[31], E, T, e, y), u(f(e), ja0);
            }), N(q00, function(t, n, e) {
              var i = o(Km, t, n);
              return o(C0(Aa0), i, e);
            }), mu(e6r, As, [0, A00, P00, R00, M00, VD, B00, Km, q00]);
            var zD = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, U00 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Wm = function t(n, e, i, x) {
              return t.fun(n, e, i, x);
            }, H00 = function t(n, e, i) {
              return t.fun(n, e, i);
            };
            N(zD, function(t, n, e, i) {
              u(f(e), Ta0), o(t, e, i[1]), u(f(e), Oa0);
              var x = i[2];
              function c(s) {
                return u(n, s);
              }
              return R(Wm, function(s) {
                return u(t, s);
              }, c, e, x), u(f(e), Ia0);
            }), N(U00, function(t, n, e) {
              var i = o(zD, t, n);
              return o(C0(Fa0), i, e);
            }), N(Wm, function(t, n, e, i) {
              u(f(e), fa0), o(f(e), oa0, xa0);
              var x = i[1];
              u(f(e), aa0);
              var c = 0;
              le(function(w, G) {
                w && u(f(e), ia0);
                function A(M) {
                  return u(n, M);
                }
                function S(M) {
                  return u(t, M);
                }
                return R(Yu[35], S, A, e, G), 1;
              }, c, x), u(f(e), ca0), u(f(e), sa0), u(f(e), va0), o(f(e), ba0, la0);
              var s = i[2];
              if (s) {
                g(e, pa0);
                var p = s[1], y = function(w, G) {
                  return g(w, ua0);
                }, T = function(w) {
                  return u(t, w);
                };
                R(Dr[1], T, y, e, p), g(e, ma0);
              } else g(e, _a0);
              u(f(e), ya0), u(f(e), ha0), o(f(e), ka0, da0);
              var E = i[3];
              u(f(e), wa0);
              var d = 0;
              return le(function(w, G) {
                w && u(f(e), ta0);
                function A(S) {
                  return u(t, S);
                }
                return ur(iu[1], A, e, G), 1;
              }, d, E), u(f(e), Ea0), u(f(e), Sa0), u(f(e), ga0);
            }), N(H00, function(t, n, e) {
              var i = o(Wm, t, n);
              return o(C0(na0), i, e);
            }), mu(n6r, kee, [0, zD, U00, Wm, H00]);
            function ze(t, n) {
              if (n) {
                var e = n[1], i = u(t, e);
                return e === i ? n : [0, i];
              }
              return n;
            }
            function te(t, n, e, i, x) {
              var c = o(t, n, e);
              return e === c ? i : u(x, c);
            }
            function ee(t, n, e, i) {
              var x = u(t, n);
              return n === x ? e : u(i, x);
            }
            function _u(t, n) {
              var e = n[1];
              function i(x) {
                return [0, e, x];
              }
              return te(t, e, n[2], n, i);
            }
            function Un(t, n) {
              var e = le(function(i, x) {
                var c = u(t, x), s = i[2], p = s || (c !== x ? 1 : 0);
                return [0, [0, c, i[1]], p];
              }, l6r, n);
              return e[2] ? ye(e[1]) : n;
            }
            var KD = Rp(p6r, function(t) {
              var n = NN(t, b6r), e = n[1], i = n[2], x = n[3], c = n[4], s = n[5], p = n[6], y = n[7], T = n[8], E = n[9], d = n[10], w = n[11], G = n[12], A = n[13], S = n[14], M = n[15], K = n[16], V = n[17], f0 = n[18], m0 = n[19], k0 = n[20], g0 = n[21], e0 = n[22], x0 = n[23], l = n[24], c0 = n[25], t0 = n[26], o0 = n[27], w0 = n[28], _0 = n[29], E0 = n[30], U0 = n[31], b = n[32], R0 = n[33], X = n[34], s0 = n[35], hr = n[36], Ar = n[37], or = n[38], W0 = n[39], Lr = n[40], Tr = n[41], Hr = n[42], Or = n[43], fr = n[44], Rr = n[45], Wr = n[46], Jr = n[47], ar = n[49], _r = n[50], Ir = n[51], fe = n[52], v0 = n[53], P = n[54], L = n[55], Q = n[56], i0 = n[57], l0 = n[58], S0 = n[59], T0 = n[60], rr = n[61], L0 = n[62], B = n[63], Z = n[65], p0 = n[66], b0 = n[67], O0 = n[68], M0 = n[69], er = n[70], yr = n[71], vr = n[72], $0 = n[73], Er = n[74], Mr = n[75], Br = n[76], qr = n[77], jr = n[78], $r = n[79], ne = n[80], Qr = n[81], be = n[82], ae = n[83], pe = n[84], oe = n[85], ce = n[86], ge = n[87], q0 = n[88], Fr = n[89], _ = n[90], k = n[91], I = n[92], U = n[93], Y = n[94], y0 = n[95], P0 = n[96], I0 = n[97], D = n[98], u0 = n[99], X0 = n[ti], J0 = n[R7], ir = n[Ri], Q0 = n[s7], F0 = n[L7], Sr = n[j7], mr = n[Yt], Cr = n[Zc], sr = n[is], Pr = n[Fv], K0 = n[Xt], Ur = n[cf], h0 = n[T7], Kr = n[Pn], re = n[t1], xe = n[Av], Re = n[f1], ve = n[A2], Ie = n[z22], Ge = n[Sv], Me = n[uc], an = n[tl], We = n[In], Ae = n[ts], cn = n[X2], rn = n[br], kn = n[IX], vn = n[zn], Ne = n[jt], Je = n[JY], en = n[zw], _n = n[Jg], Cn = n[BH], Hn = n[133], Fn = n[134], vt = n[135], Nt = n[KH], gt = n[137], Zt = n[EH], qt = n[139], Ft = n[dH], Ct = n[141], du = n[142], Wu = n[143], lt = n[iV], ou = n[145], Bu = n[146], K7 = n[DX], Yi = n[148], a7 = n[eH], Hc = n[150], W7 = n[151], Ut = n[152], bt = n[153], B0 = n[FH], D0 = n[155], Le = n[156], He = n[157], he = n[158], me = n[159], Zn = n[fY], wn = n[XU], ft = n[kh], xt = n[Ln], jn = n[AF], ut = n[$X], dt = n[DY], xn = n[NT], ln = n[IY], it = n[NX], Tt = n[qg], Ti = n[pg], hs = n[LU], Au = n[_Y], Hs = n[$U], Vi = n[bX], Xs = n[mV], Ys = n[uV], nn = n[gO], si = n[RY], Vs = n[sU], c2 = n[Ai], M9 = n[Yg], B9 = n[lS], q9 = n[hk], zs = n[gU], s2 = n[md], U9 = n[nw], H9 = n[iY], X9 = n[fX], H1 = n[OY], vi = n[lX], ab = n[rt], cb = n[HT], sb = n[nI], Y9 = n[xY], V9 = n[XX], z9 = n[hY], vb = n[vH], K9 = n[QH], W9 = n[NU], J9 = n[sY], $9 = n[nH], lb = n[eV], Z9 = n[WX], X1 = n[VH], v2 = n[TH], bb = n[AX], pb = n[_H], mb = n[Wg], On = n[A6], Gn = n[yU], Y1 = n[yY], _b = n[RX], yb = n[mT], Q9 = n[xT], Xc = n[y6], r_ = n[cp], l2 = n[Cw], hb = n[FU], Yc = n[iA], e_ = n[GX], Ks = n[FX], db = n[y8], V1 = n[hv], n_ = n[BO], ds = n[rk], t_ = n[JH], z1 = n[fV], u_ = n[bU], b2 = n[jh], i_ = n[qX], Ws = n[ZF], kb = n[hT], Js = n[tH], f_ = n[JU], zi = n[lO], Vc = n[BY], $s = n[cH], x_ = n[i6], p2 = n[s1], m2 = n[Vy], _2 = n[ST], o_ = n[QU], Zs = n[v8], a_ = n[WY], y2 = n[$2], qL = n[48], K1 = n[64];
              function UL(a, F, m) {
                var O = m[2], H = m[1], $ = ze(u(a[1][1 + nn], a), H), r0 = o(a[1][1 + s0], a, O);
                return O === r0 && H === $ ? m : [0, $, r0, m[3], m[4]];
              }
              function W1(a, F, m) {
                var O = m[4], H = m[3], $ = m[2], r0 = m[1], j0 = o(a[1][1 + Vc], a, r0), V0 = ze(u(a[1][1 + V], a), $), Nr = o(a[1][1 + t0], a, H), Gr = o(a[1][1 + s0], a, O);
                return r0 === j0 && H === Nr && $ === V0 && O === Gr ? m : [0, j0, V0, Nr, Gr];
              }
              function HL(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = o(a[1][1 + nn], a, $), j0 = o(a[1][1 + Or], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m : [0, r0, j0, V0];
              }
              function J1(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = o(a[1][1 + _r], a, $), j0 = o(a[1][1 + Or], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m : [0, r0, j0, V0];
              }
              function XL(a, F, m) {
                var O = m[2], H = O[2], $ = O[1], r0 = ur(a[1][1 + p], a, F, $), j0 = ze(u(a[1][1 + nn], a), H);
                return $ === r0 && H === j0 ? m : [0, m[1], [0, r0, j0]];
              }
              function Oi(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = Un(o(a[1][1 + y], a, H), $), j0 = o(a[1][1 + s0], a, O);
                return $ === r0 && O === j0 ? m : [0, r0, H, j0];
              }
              function YL(a, F, m) {
                var O = m[4], H = m[2], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m : [0, m[1], $, m[3], r0];
              }
              function VL(a, F, m) {
                var O = m[3], H = m[2], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m : [0, m[1], $, r0];
              }
              function h22(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = o(a[1][1 + nn], a, $), j0 = o(a[1][1 + l], a, H), V0 = o(a[1][1 + s0], a, O);
                return r0 === $ && j0 === H && V0 === O ? m : [0, r0, j0, V0];
              }
              function zL(a, F, m) {
                var O = m[4], H = m[3], $ = m[2], r0 = m[1], j0 = _u(u(a[1][1 + zi], a), r0);
                if ($) var V0 = $[1], Nr = V0[1], Gr = function(Qt) {
                  return [0, [0, Nr, Qt]];
                }, Fe = V0[2], _e = te(u(a[1][1 + z1], a), Nr, Fe, $, Gr);
                else var _e = $;
                if (H) var Dn = H[1], yn = Dn[1], ot = function(Qt) {
                  return [0, [0, yn, Qt]];
                }, pt = Dn[2], kt = te(u(a[1][1 + zi], a), yn, pt, H, ot);
                else var kt = H;
                var Kn = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === _e && H === kt && O === Kn ? m : [0, j0, _e, kt, Kn];
              }
              function $1(a, F, m) {
                var O = m[2], H = m[1], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m : [0, $, r0];
              }
              function KL(a, F, m) {
                var O = m[1], H = o(a[1][1 + s0], a, O);
                return O === H ? m : [0, H];
              }
              function Z1(a, F) {
                return F;
              }
              function WL(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = Un(u(a[1][1 + b], a), $), j0 = Un(u(a[1][1 + nn], a), H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m : [0, r0, j0, V0];
              }
              function wb(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = o(a[1][1 + nn], a, $), j0 = _u(u(a[1][1 + R0], a), H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m : [0, r0, j0, V0];
              }
              function JL(a, F) {
                var m = F[2], O = m[3], H = m[2], $ = m[1], r0 = ze(u(a[1][1 + nn], a), $), j0 = o(a[1][1 + Tr], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? F : [0, F[1], [0, r0, j0, V0]];
              }
              function Eb(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = o(a[1][1 + nn], a, $), j0 = Un(u(a[1][1 + Ar], a), H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m : [0, r0, j0, V0, m[4]];
              }
              function $L(a, F, m) {
                var O = m[1], H = o(a[1][1 + s0], a, O);
                return O === H ? m : [0, H];
              }
              function ZL(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F : [0, F[1], [0, $, r0]];
              }
              function d2(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F : [0, F[1], [0, $, r0]];
              }
              function QL(a, F) {
                return [0, o(a[1][1 + Or], a, F), 0];
              }
              function rR(a, F) {
                var m = u(a[1][1 + Hr], a), O = le(function(H, $) {
                  var r0 = H[1], j0 = u(m, $);
                  if (j0) {
                    if (j0[2]) return [0, Lc(j0, r0), 1];
                    var V0 = j0[1], Nr = H[2], Gr = Nr || ($ !== V0 ? 1 : 0);
                    return [0, [0, V0, r0], Gr];
                  }
                  return [0, r0, 1];
                }, v6r, F);
                return O[2] ? ye(O[1]) : F;
              }
              function c_(a, F) {
                return o(a[1][1 + Tr], a, F);
              }
              function eR(a, F, m) {
                var O = m[2], H = m[1], $ = Un(u(a[1][1 + nn], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m : [0, $, r0];
              }
              function k2(a, F, m) {
                var O = m[2], H = m[1], $ = ze(u(a[1][1 + nn], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m : [0, $, r0, m[3]];
              }
              function nR(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + Le], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F : [0, F[1], [0, $, r0]];
              }
              function w2(a, F) {
                return o(a[1][1 + nn], a, F);
              }
              function tR(a, F) {
                var m = F[2], O = m[2], H = m[1];
                if (H) var $ = function(Nr) {
                  return [0, Nr];
                }, r0 = H[1], j0 = ee(u(a[1][1 + nn], a), r0, H, $);
                else var j0 = H;
                var V0 = o(a[1][1 + s0], a, O);
                return H === j0 && O === V0 ? F : [0, F[1], [0, j0, V0]];
              }
              function Q1(a, F) {
                return o(a[1][1 + nn], a, F);
              }
              function uR(a, F, m) {
                return ur(a[1][1 + er], a, F, m);
              }
              function Sb(a, F, m) {
                return ur(a[1][1 + er], a, F, m);
              }
              function iR(a, F, m) {
                var O = m[2], H = O[2], $ = O[1], r0 = ur(a[1][1 + Z], a, F, $), j0 = o(a[1][1 + s0], a, H);
                return r0 === $ && H === j0 ? m : [0, m[1], [0, r0, j0]];
              }
              function gb(a, F, m) {
                return ur(a[1][1 + er], a, F, m);
              }
              function fR(a, F, m) {
                var O = m[2], H = O[2], $ = O[1], r0 = ur(a[1][1 + b0], a, F, $), j0 = ze(u(a[1][1 + nn], a), H);
                return $ === r0 && H === j0 ? m : [0, m[1], [0, r0, j0]];
              }
              function Fb(a, F, m) {
                switch (m[0]) {
                  case 0:
                    var O = function(j0) {
                      return [0, j0];
                    }, H = m[1];
                    return ee(o(a[1][1 + O0], a, F), H, m, O);
                  case 1:
                    var $ = function(j0) {
                      return [1, j0];
                    }, r0 = m[1];
                    return ee(o(a[1][1 + p0], a, F), r0, m, $);
                  default:
                    return m;
                }
              }
              function xR(a, F, m) {
                return ur(a[1][1 + er], a, F, m);
              }
              function Mn(a, F, m) {
                return ur(a[1][1 + er], a, F, m);
              }
              function s_(a, F, m) {
                var O = m[2], H = O[2], $ = O[1], r0 = ur(a[1][1 + fe], a, F, $), j0 = o(a[1][1 + s0], a, H);
                return r0 === $ && H === j0 ? m : [0, m[1], [0, r0, j0]];
              }
              function oR(a, F, m) {
                return o(a[1][1 + On], a, m);
              }
              function aR(a, F, m) {
                return ur(a[1][1 + L0], a, F, m);
              }
              function rv(a, F, m) {
                var O = m[1];
                function H(r0) {
                  return [0, O, r0];
                }
                var $ = m[2];
                return te(o(a[1][1 + rr], a, F), O, $, m, H);
              }
              function Tb(a, F, m) {
                switch (m[0]) {
                  case 0:
                    var O = function(Nr) {
                      return [0, Nr];
                    }, H = m[1];
                    return ee(o(a[1][1 + L], a, F), H, m, O);
                  case 1:
                    var $ = function(Nr) {
                      return [1, Nr];
                    }, r0 = m[1];
                    return ee(o(a[1][1 + i0], a, F), r0, m, $);
                  default:
                    var j0 = function(Nr) {
                      return [2, Nr];
                    }, V0 = m[1];
                    return ee(o(a[1][1 + l0], a, F), V0, m, j0);
                }
              }
              function v_(a, F, m) {
                var O = m[2], H = O[4], $ = O[3], r0 = O[2], j0 = O[1], V0 = ur(a[1][1 + Q], a, F, j0), Nr = ur(a[1][1 + P], a, F, r0), Gr = ze(u(a[1][1 + nn], a), $);
                if (H) {
                  var Fe = 0;
                  if (V0[0] === 1) {
                    var _e = Nr[2];
                    if (_e[0] === 2) var yn = qn(V0[1][2][1], _e[1][1][2][1]);
                    else Fe = 1;
                  } else Fe = 1;
                  if (Fe) var Dn = j0 === V0 ? 1 : 0, yn = Dn && (r0 === Nr ? 1 : 0);
                } else var yn = H;
                return V0 === j0 && Nr === r0 && Gr === $ && H === yn ? m : [0, m[1], [0, V0, Nr, Gr, yn]];
              }
              function Ob(a, F, m) {
                if (m[0] === 0) {
                  var O = function(j0) {
                    return [0, j0];
                  }, H = m[1];
                  return ee(o(a[1][1 + S0], a, F), H, m, O);
                }
                function $(j0) {
                  return [1, j0];
                }
                var r0 = m[1];
                return ee(o(a[1][1 + v0], a, F), r0, m, $);
              }
              function cR(a, F, m, O) {
                return ur(a[1][1 + J0], a, m, O);
              }
              function l_(a, F, m) {
                return o(a[1][1 + lt], a, m);
              }
              function sR(a, F, m) {
                var O = m[2];
                switch (O[0]) {
                  case 0:
                    var H = O[1], $ = H[3], r0 = H[2], j0 = H[1], V0 = Un(o(a[1][1 + T0], a, F), j0), Nr = o(a[1][1 + x0], a, r0), Gr = o(a[1][1 + s0], a, $), Fe = 0;
                    if (V0 === j0 && Nr === r0 && Gr === $) {
                      var _e = O;
                      Fe = 1;
                    }
                    if (!Fe) var _e = [0, [0, V0, Nr, Gr]];
                    var Ji = _e;
                    break;
                  case 1:
                    var Dn = O[1], yn = Dn[3], ot = Dn[2], pt = Dn[1], kt = Un(o(a[1][1 + M0], a, F), pt), Kn = o(a[1][1 + x0], a, ot), Qt = o(a[1][1 + s0], a, yn), J7 = 0;
                    if (yn === Qt && kt === pt && Kn === ot) {
                      var $7 = O;
                      J7 = 1;
                    }
                    if (!J7) var $7 = [1, [0, kt, Kn, Qt]];
                    var Ji = $7;
                    break;
                  case 2:
                    var E7 = O[1], Z7 = E7[2], Q7 = E7[1], ri = ur(a[1][1 + L0], a, F, Q7), ei = o(a[1][1 + x0], a, Z7), ni = 0;
                    if (Q7 === ri && Z7 === ei) {
                      var Wi = O;
                      ni = 1;
                    }
                    if (!ni) var Wi = [2, [0, ri, ei, E7[3]]];
                    var Ji = Wi;
                    break;
                  default:
                    var tv = function(iv) {
                      return [3, iv];
                    }, uv = O[1], Ji = ee(u(a[1][1 + B], a), uv, O, tv);
                }
                return O === Ji ? m : [0, m[1], Ji];
              }
              function b_(a, F) {
                return ur(a[1][1 + er], a, 0, F);
              }
              function Ib(a, F, m) {
                var O = F && F[1];
                return ur(a[1][1 + er], a, [0, O], m);
              }
              function p_(a, F) {
                return o(a[1][1 + m2], a, F);
              }
              function vR(a, F) {
                return o(a[1][1 + m2], a, F);
              }
              function m_(a, F) {
                return ur(a[1][1 + $s], a, s6r, F);
              }
              function Ab(a, F, m) {
                return ur(a[1][1 + $s], a, [0, F], m);
              }
              function lR(a, F) {
                return ur(a[1][1 + $s], a, c6r, F);
              }
              function bR(a, F, m) {
                var O = m[5], H = m[4], $ = m[3], r0 = m[2], j0 = m[1], V0 = o(a[1][1 + Vc], a, j0), Nr = ze(u(a[1][1 + V], a), r0), Gr = ze(u(a[1][1 + t0], a), $), Fe = ze(u(a[1][1 + t0], a), H), _e = o(a[1][1 + s0], a, O);
                return j0 === V0 && $ === Gr && r0 === Nr && $ === Gr && H === Fe && O === _e ? m : [0, V0, Nr, Gr, Fe, _e];
              }
              function pR(a, F) {
                return o(a[1][1 + On], a, F);
              }
              function Nb(a, F) {
                return o(a[1][1 + lt], a, F);
              }
              function mR(a, F) {
                var m = F[1];
                function O($) {
                  return [0, m, $];
                }
                var H = F[2];
                return te(u(a[1][1 + J0], a), m, H, F, O);
              }
              function _R(a, F) {
                switch (F[0]) {
                  case 0:
                    var m = function(Gr) {
                      return [0, Gr];
                    }, O = F[1];
                    return ee(u(a[1][1 + be], a), O, F, m);
                  case 1:
                    var H = function(Gr) {
                      return [1, Gr];
                    }, $ = F[1];
                    return ee(u(a[1][1 + ae], a), $, F, H);
                  case 2:
                    var r0 = function(Gr) {
                      return [2, Gr];
                    }, j0 = F[1];
                    return ee(u(a[1][1 + ar], a), j0, F, r0);
                  default:
                    var V0 = function(Gr) {
                      return [3, Gr];
                    }, Nr = F[1];
                    return ee(u(a[1][1 + pe], a), Nr, F, V0);
                }
              }
              function __(a, F) {
                var m = F[2], O = F[1];
                switch (m[0]) {
                  case 0:
                    var H = m[3], $ = m[2], r0 = m[1], j0 = o(a[1][1 + oe], a, r0), V0 = o(a[1][1 + nn], a, $);
                    if (H) {
                      var Nr = 0;
                      if (j0[0] === 1) {
                        var Gr = V0[2];
                        if (Gr[0] === 10) var _e = qn(j0[1][2][1], Gr[1][2][1]);
                        else Nr = 1;
                      } else Nr = 1;
                      if (Nr) var Fe = r0 === j0 ? 1 : 0, _e = Fe && ($ === V0 ? 1 : 0);
                    } else var _e = H;
                    return r0 === j0 && $ === V0 && H === _e ? F : [0, O, [0, j0, V0, _e]];
                  case 1:
                    var Dn = m[2], yn = m[1], ot = o(a[1][1 + oe], a, yn), pt = _u(u(a[1][1 + me], a), Dn);
                    return yn === ot && Dn === pt ? F : [0, O, [1, ot, pt]];
                  case 2:
                    var kt = m[3], Kn = m[2], Qt = m[1], J7 = o(a[1][1 + oe], a, Qt), $7 = _u(u(a[1][1 + me], a), Kn), E7 = o(a[1][1 + s0], a, kt);
                    return Qt === J7 && Kn === $7 && kt === E7 ? F : [0, O, [2, J7, $7, E7]];
                  default:
                    var Z7 = m[3], Q7 = m[2], ri = m[1], ei = o(a[1][1 + oe], a, ri), ni = _u(u(a[1][1 + me], a), Q7), Wi = o(a[1][1 + s0], a, Z7);
                    return ri === ei && Q7 === ni && Z7 === Wi ? F : [0, O, [3, ei, ni, Wi]];
                }
              }
              function yR(a, F, m) {
                var O = m[2], H = m[1], $ = Un(function(j0) {
                  if (j0[0] === 0) {
                    var V0 = j0[1], Nr = o(a[1][1 + Qr], a, V0);
                    return V0 === Nr ? j0 : [0, Nr];
                  }
                  var Gr = j0[1], Fe = o(a[1][1 + fr], a, Gr);
                  return Gr === Fe ? j0 : [1, Fe];
                }, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m : [0, $, r0];
              }
              function Cb(a, F, m) {
                var O = m[4], H = m[3], $ = m[2], r0 = m[1], j0 = o(a[1][1 + nn], a, r0), V0 = ze(u(a[1][1 + b2], a), $), Nr = ze(u(a[1][1 + Ws], a), H), Gr = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === V0 && H === Nr && O === Gr ? m : [0, j0, V0, Nr, Gr];
              }
              function hR(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = o(a[1][1 + lt], a, $), j0 = o(a[1][1 + lt], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m : [0, r0, j0, V0];
              }
              function dR(a, F) {
                return o(a[1][1 + nn], a, F);
              }
              function y_(a, F) {
                return o(a[1][1 + ar], a, F);
              }
              function kR(a, F) {
                return o(a[1][1 + lt], a, F);
              }
              function E2(a, F) {
                switch (F[0]) {
                  case 0:
                    var m = function(V0) {
                      return [0, V0];
                    }, O = F[1];
                    return ee(u(a[1][1 + y0], a), O, F, m);
                  case 1:
                    var H = function(V0) {
                      return [1, V0];
                    }, $ = F[1];
                    return ee(u(a[1][1 + D], a), $, F, H);
                  default:
                    var r0 = function(V0) {
                      return [2, V0];
                    }, j0 = F[1];
                    return ee(u(a[1][1 + P0], a), j0, F, r0);
                }
              }
              function wR(a, F, m) {
                var O = m[1], H = ur(a[1][1 + u0], a, F, O);
                return O === H ? m : [0, H, m[2], m[3]];
              }
              function ER(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = o(a[1][1 + nn], a, $), j0 = o(a[1][1 + I0], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m : [0, r0, j0, V0];
              }
              function SR(a, F, m) {
                var O = m[4], H = m[3], $ = m[2], r0 = o(a[1][1 + nn], a, $), j0 = o(a[1][1 + nn], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m : [0, m[1], r0, j0, V0];
              }
              function Pb(a, F, m) {
                var O = m[3], H = o(a[1][1 + s0], a, O);
                return O === H ? m : [0, m[1], m[2], H];
              }
              function gR(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = o(a[1][1 + Q0], a, $), j0 = o(a[1][1 + Or], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m : [0, r0, j0, V0];
              }
              function FR(a, F) {
                var m = F[2], O = m[2], H = o(a[1][1 + s0], a, O);
                return O === H ? F : [0, F[1], [0, m[1], H]];
              }
              function Db(a, F) {
                return o(a[1][1 + ve], a, F);
              }
              function TR(a, F) {
                if (F[0] === 0) {
                  var m = function(r0) {
                    return [0, r0];
                  }, O = F[1];
                  return ee(u(a[1][1 + K0], a), O, F, m);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F[1];
                return ee(u(a[1][1 + Ur], a), $, F, H);
              }
              function OR(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + Pr], a, H), r0 = o(a[1][1 + h0], a, O);
                return H === $ && O === r0 ? F : [0, F[1], [0, $, r0]];
              }
              function ku(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + h0], a, H), r0 = o(a[1][1 + h0], a, O);
                return H === $ && O === r0 ? F : [0, F[1], [0, $, r0]];
              }
              function wu(a, F) {
                return o(a[1][1 + Ur], a, F);
              }
              function Ii(a, F) {
                return o(a[1][1 + sr], a, F);
              }
              function w7(a, F) {
                return o(a[1][1 + h0], a, F);
              }
              function Ki(a, F) {
                switch (F[0]) {
                  case 0:
                    var m = function(V0) {
                      return [0, V0];
                    }, O = F[1];
                    return ee(u(a[1][1 + ve], a), O, F, m);
                  case 1:
                    var H = function(V0) {
                      return [1, V0];
                    }, $ = F[1];
                    return ee(u(a[1][1 + xe], a), $, F, H);
                  default:
                    var r0 = function(V0) {
                      return [2, V0];
                    }, j0 = F[1];
                    return ee(u(a[1][1 + Re], a), j0, F, r0);
                }
              }
              function ev(a, F) {
                var m = F[2], O = F[1], H = o(a[1][1 + nn], a, O), $ = o(a[1][1 + s0], a, m);
                return O === H && m === $ ? F : [0, H, $];
              }
              function Lb(a, F, m) {
                var O = m[2], H = m[1], $ = o(a[1][1 + s0], a, O);
                if (H) {
                  var r0 = H[1], j0 = o(a[1][1 + nn], a, r0);
                  return r0 === j0 && O === $ ? m : [0, [0, j0], $];
                }
                return O === $ ? m : [0, 0, $];
              }
              function nv(a, F) {
                var m = F[2], O = F[1];
                switch (m[0]) {
                  case 0:
                    var H = function(_e) {
                      return [0, O, [0, _e]];
                    }, $ = m[1];
                    return te(u(a[1][1 + Ge], a), O, $, F, H);
                  case 1:
                    var r0 = function(_e) {
                      return [0, O, [1, _e]];
                    }, j0 = m[1];
                    return te(u(a[1][1 + Kr], a), O, j0, F, r0);
                  case 2:
                    var V0 = function(_e) {
                      return [0, O, [2, _e]];
                    }, Nr = m[1];
                    return te(u(a[1][1 + re], a), O, Nr, F, V0);
                  case 3:
                    var Gr = function(_e) {
                      return [0, O, [3, _e]];
                    }, Fe = m[1];
                    return ee(u(a[1][1 + F0], a), Fe, F, Gr);
                  default:
                    return F;
                }
              }
              function Rb(a, F) {
                var m = F[2], O = Un(u(a[1][1 + We], a), m);
                return m === O ? F : [0, F[1], O];
              }
              function jb(a, F, m) {
                return ur(a[1][1 + J0], a, F, m);
              }
              function IR(a, F, m) {
                return ur(a[1][1 + re], a, F, m);
              }
              function Sne(a, F) {
                if (F[0] === 0) {
                  var m = F[1], O = function(V0) {
                    return [0, m, V0];
                  }, H = F[2];
                  return te(u(a[1][1 + Ae], a), m, H, F, O);
                }
                var $ = F[1];
                function r0(V0) {
                  return [1, $, V0];
                }
                var j0 = F[2];
                return te(u(a[1][1 + cn], a), $, j0, F, r0);
              }
              function gne(a, F) {
                return o(a[1][1 + sr], a, F);
              }
              function Fne(a, F) {
                return o(a[1][1 + h0], a, F);
              }
              function Tne(a, F) {
                if (F[0] === 0) {
                  var m = function(r0) {
                    return [0, r0];
                  }, O = F[1];
                  return ee(u(a[1][1 + vn], a), O, F, m);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F[1];
                return ee(u(a[1][1 + kn], a), $, F, H);
              }
              function One(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + Ne], a, H), r0 = ze(u(a[1][1 + rn], a), O);
                return H === $ && O === r0 ? F : [0, F[1], [0, $, r0]];
              }
              function Ine(a, F, m) {
                var O = m[2], H = m[1], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m : [0, $, r0];
              }
              function Ane(a, F) {
                if (F[0] === 0) {
                  var m = function(V0) {
                    return [0, V0];
                  }, O = F[1];
                  return ee(u(a[1][1 + Je], a), O, F, m);
                }
                var H = F[1], $ = H[1];
                function r0(V0) {
                  return [1, [0, $, V0]];
                }
                var j0 = H[2];
                return te(u(a[1][1 + Sr], a), $, j0, F, r0);
              }
              function Nne(a, F) {
                var m = F[2][1], O = o(a[1][1 + Ie], a, m);
                return m === O ? F : [0, F[1], [0, O]];
              }
              function Cne(a, F) {
                var m = F[2], O = m[3], H = m[1], $ = o(a[1][1 + Ie], a, H), r0 = Un(u(a[1][1 + Cr], a), O);
                return H === $ && O === r0 ? F : [0, F[1], [0, $, m[2], r0]];
              }
              function Pne(a, F, m) {
                var O = m[4], H = m[3], $ = o(a[1][1 + an], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m : [0, m[1], m[2], $, r0];
              }
              function Dne(a, F, m) {
                var O = m[4], H = m[3], $ = m[2], r0 = m[1], j0 = o(a[1][1 + mr], a, r0), V0 = ze(u(a[1][1 + Me], a), $), Nr = o(a[1][1 + an], a, H), Gr = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === V0 && H === Nr && O === Gr ? m : [0, j0, V0, Nr, Gr];
              }
              function Lne(a, F, m, O) {
                var H = 2 <= F ? o(a[1][1 + L0], a, a6r) : u(a[1][1 + Vc], a);
                return u(H, O);
              }
              function Rne(a, F, m) {
                var O = 2 <= F ? o(a[1][1 + L0], a, o6r) : u(a[1][1 + Vc], a);
                return u(O, m);
              }
              function jne(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = 0;
                if (F) {
                  var j0 = 0;
                  if ($) switch ($[1]) {
                    case 2:
                      break;
                    case 0:
                      r0 = 1, j0 = 2;
                      break;
                    default:
                      j0 = 1;
                  }
                  var V0 = 0;
                  switch (j0) {
                    case 2:
                      V0 = 1;
                      break;
                    case 0:
                      if (2 <= F) {
                        var Nr = 0, Gr = 0;
                        V0 = 1;
                      }
                      break;
                  }
                  if (!V0) var Nr = 1, Gr = 0;
                } else r0 = 1;
                if (r0) var Nr = 1, Gr = 1;
                var Fe = o(Gr ? a[1][1 + m0] : a[1][1 + lt], a, O);
                if (H) var _e = Nr ? u(a[1][1 + Vc], a) : o(a[1][1 + L0], a, x6r), Dn = function(ot) {
                  return [0, ot];
                }, yn = ee(_e, H[1], H, Dn);
                else var yn = H;
                return H === yn && O === Fe ? m : [0, $, yn, Fe];
              }
              function Gne(a, F, m) {
                if (m[0] === 0) {
                  var O = m[1], H = Un(o(a[1][1 + gt], a, F), O);
                  return O === H ? m : [0, H];
                }
                var $ = m[1], r0 = $[1];
                function j0(Nr) {
                  return [1, [0, r0, Nr]];
                }
                var V0 = $[2];
                return te(o(a[1][1 + Nt], a, F), r0, V0, m, j0);
              }
              function Mne(a, F, m) {
                var O = m[5], H = m[4], $ = m[3], r0 = m[1], j0 = ze(o(a[1][1 + vt], a, r0), H), V0 = ze(o(a[1][1 + Zt], a, r0), $), Nr = o(a[1][1 + s0], a, O);
                return H === j0 && $ === V0 && O === Nr ? m : [0, r0, m[2], V0, j0, Nr];
              }
              function Bne(a, F, m) {
                var O = m[4], H = m[3], $ = m[2], r0 = m[1], j0 = o(a[1][1 + _r], a, r0), V0 = ur(a[1][1 + du], a, H !== 0 ? 1 : 0, $), Nr = u(a[1][1 + Wu], a), Gr = ze(function(_e) {
                  return _u(Nr, _e);
                }, H), Fe = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === V0 && H === Gr && O === Fe ? m : [0, j0, V0, Gr, Fe];
              }
              function qne(a, F, m) {
                var O = m[2], H = m[1], $ = o(a[1][1 + Or], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m : [0, $, r0];
              }
              function Une(a, F, m) {
                return o(a[1][1 + Or], a, m);
              }
              function Hne(a, F, m) {
                var O = m[2], H = m[1], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m : [0, $, r0];
              }
              function Xne(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F : [0, F[1], [0, $, r0]];
              }
              function Yne(a, F) {
                var m = F[2], O = m[2], H = o(a[1][1 + s0], a, O);
                return O === H ? F : [0, F[1], [0, m[1], H]];
              }
              function Vne(a, F, m) {
                return ur(a[1][1 + Hn], a, F, m);
              }
              function zne(a, F, m) {
                var O = m[5], H = m[4], $ = m[3], r0 = m[2], j0 = m[1], V0 = o(a[1][1 + Vc], a, j0), Nr = ze(u(a[1][1 + V], a), r0), Gr = u(a[1][1 + ou], a), Fe = Un(function(yn) {
                  return _u(Gr, yn);
                }, $), _e = _u(u(a[1][1 + qr], a), H), Dn = o(a[1][1 + s0], a, O);
                return V0 === j0 && Nr === r0 && Fe === $ && _e === H && Dn === O ? m : [0, V0, Nr, Fe, _e, Dn];
              }
              function Kne(a, F) {
                return o(a[1][1 + k0], a, F);
              }
              function Wne(a, F) {
                return o(a[1][1 + k0], a, F);
              }
              function Jne(a, F) {
                return o(a[1][1 + lt], a, F);
              }
              function $ne(a, F) {
                var m = F[2], O = m[2], H = o(a[1][1 + s0], a, O);
                return O === H ? F : [0, F[1], [0, m[1], H]];
              }
              function Zne(a, F, m) {
                return m;
              }
              function Qne(a, F) {
                return ur(a[1][1 + L0], a, f6r, F);
              }
              function rte(a, F) {
                var m = F[1];
                function O($) {
                  return [0, m, $];
                }
                var H = F[2];
                return te(u(a[1][1 + zi], a), m, H, F, O);
              }
              function ete(a, F) {
                if (F[0] === 0) {
                  var m = function(r0) {
                    return [0, r0];
                  }, O = F[1];
                  return ee(u(a[1][1 + xt], a), O, F, m);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F[1];
                return ee(u(a[1][1 + nn], a), $, F, H);
              }
              function nte(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + Le], a, H), r0 = ze(u(a[1][1 + nn], a), O);
                return H === $ && O === r0 ? F : [0, F[1], [0, $, r0]];
              }
              function tte(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + l], a, H), r0 = o(a[1][1 + s0], a, O);
                return $ === H && r0 === O ? F : [0, F[1], [0, $, r0]];
              }
              function ute(a, F) {
                var m = F[2], O = m[4], H = m[3], $ = m[2], r0 = m[1], j0 = Un(u(a[1][1 + He], a), $), V0 = ze(u(a[1][1 + bt], a), H), Nr = ze(u(a[1][1 + W7], a), r0), Gr = o(a[1][1 + s0], a, O);
                return $ === j0 && H === V0 && O === Gr && r0 === Nr ? F : [0, F[1], [0, Nr, j0, V0, Gr]];
              }
              function ite(a, F, m) {
                var O = m[9], H = m[8], $ = m[7], r0 = m[6], j0 = m[3], V0 = m[2], Nr = m[1], Gr = ze(u(a[1][1 + he], a), Nr), Fe = o(a[1][1 + B0], a, V0), _e = o(a[1][1 + x0], a, $), Dn = o(a[1][1 + ft], a, j0), yn = ze(u(a[1][1 + Ir], a), r0), ot = ze(u(a[1][1 + V], a), H), pt = o(a[1][1 + s0], a, O);
                return Nr === Gr && V0 === Fe && j0 === Dn && r0 === yn && $ === _e && H === ot && O === pt ? m : [0, Gr, Fe, Dn, m[4], m[5], yn, _e, ot, pt, m[10]];
              }
              function fte(a, F, m) {
                return ur(a[1][1 + jn], a, F, m);
              }
              function xte(a, F, m) {
                return ur(a[1][1 + me], a, F, m);
              }
              function ote(a, F, m) {
                return ur(a[1][1 + jn], a, F, m);
              }
              function ate(a, F) {
                if (F[0] === 0) return F;
                var m = F[1], O = o(a[1][1 + l], a, m);
                return O === m ? F : [1, O];
              }
              function cte(a, F) {
                var m = F[1];
                function O($) {
                  return [0, m, $];
                }
                var H = F[2];
                return ee(u(a[1][1 + t0], a), H, F, O);
              }
              function ste(a, F) {
                var m = F[2], O = F[1];
                switch (m[0]) {
                  case 0:
                    var H = function(Ze) {
                      return [0, O, [0, Ze]];
                    }, $ = m[1];
                    return ee(u(a[1][1 + s0], a), $, F, H);
                  case 1:
                    var r0 = function(Ze) {
                      return [0, O, [1, Ze]];
                    }, j0 = m[1];
                    return ee(u(a[1][1 + s0], a), j0, F, r0);
                  case 2:
                    var V0 = function(Ze) {
                      return [0, O, [2, Ze]];
                    }, Nr = m[1];
                    return ee(u(a[1][1 + s0], a), Nr, F, V0);
                  case 3:
                    var Gr = function(Ze) {
                      return [0, O, [3, Ze]];
                    }, Fe = m[1];
                    return ee(u(a[1][1 + s0], a), Fe, F, Gr);
                  case 4:
                    var _e = function(Ze) {
                      return [0, O, [4, Ze]];
                    }, Dn = m[1];
                    return ee(u(a[1][1 + s0], a), Dn, F, _e);
                  case 5:
                    var yn = function(Ze) {
                      return [0, O, [5, Ze]];
                    }, ot = m[1];
                    return ee(u(a[1][1 + s0], a), ot, F, yn);
                  case 6:
                    var pt = function(Ze) {
                      return [0, O, [6, Ze]];
                    }, kt = m[1];
                    return ee(u(a[1][1 + s0], a), kt, F, pt);
                  case 7:
                    var Kn = function(Ze) {
                      return [0, O, [7, Ze]];
                    }, Qt = m[1];
                    return ee(u(a[1][1 + s0], a), Qt, F, Kn);
                  case 8:
                    var J7 = function(Ze) {
                      return [0, O, [8, Ze]];
                    }, $7 = m[1];
                    return ee(u(a[1][1 + s0], a), $7, F, J7);
                  case 9:
                    var E7 = function(Ze) {
                      return [0, O, [9, Ze]];
                    }, Z7 = m[1];
                    return ee(u(a[1][1 + s0], a), Z7, F, E7);
                  case 10:
                    var Q7 = function(Ze) {
                      return [0, O, [10, Ze]];
                    }, ri = m[1];
                    return ee(u(a[1][1 + s0], a), ri, F, Q7);
                  case 11:
                    var ei = function(Ze) {
                      return [0, O, [11, Ze]];
                    }, ni = m[1];
                    return ee(u(a[1][1 + k], a), ni, F, ei);
                  case 12:
                    var Wi = function(Ze) {
                      return [0, O, [12, Ze]];
                    }, tv = m[1];
                    return te(u(a[1][1 + a7], a), O, tv, F, Wi);
                  case 13:
                    var uv = function(Ze) {
                      return [0, O, [13, Ze]];
                    }, Ji = m[1];
                    return te(u(a[1][1 + qr], a), O, Ji, F, uv);
                  case 14:
                    var iv = function(Ze) {
                      return [0, O, [14, Ze]];
                    }, Gb = m[1];
                    return te(u(a[1][1 + _n], a), O, Gb, F, iv);
                  case 15:
                    var Mb = function(Ze) {
                      return [0, O, [15, Ze]];
                    }, Bb = m[1];
                    return ee(u(a[1][1 + Zs], a), Bb, F, Mb);
                  case 16:
                    var qb = function(Ze) {
                      return [0, O, [16, Ze]];
                    }, Ub = m[1];
                    return te(u(a[1][1 + ou], a), O, Ub, F, qb);
                  case 17:
                    var Hb = function(Ze) {
                      return [0, O, [17, Ze]];
                    }, Xb = m[1];
                    return te(u(a[1][1 + Fn], a), O, Xb, F, Hb);
                  case 18:
                    var Yb = function(Ze) {
                      return [0, O, [18, Ze]];
                    }, Vb = m[1];
                    return te(u(a[1][1 + vr], a), O, Vb, F, Yb);
                  case 19:
                    var zb = function(Ze) {
                      return [0, O, [19, Ze]];
                    }, Kb = m[1];
                    return te(u(a[1][1 + d], a), O, Kb, F, zb);
                  case 20:
                    var Wb = function(Ze) {
                      return [0, O, [20, Ze]];
                    }, Jb = m[1];
                    return te(u(a[1][1 + en], a), O, Jb, F, Wb);
                  case 21:
                    var $b = function(Ze) {
                      return [0, O, [21, Ze]];
                    }, Zb = m[1];
                    return ee(u(a[1][1 + G], a), Zb, F, $b);
                  case 22:
                    var Qb = function(Ze) {
                      return [0, O, [22, Ze]];
                    }, r4 = m[1];
                    return ee(u(a[1][1 + o0], a), r4, F, Qb);
                  case 23:
                    var e4 = function(Ze) {
                      return [0, O, [23, Ze]];
                    }, n4 = m[1];
                    return te(u(a[1][1 + Lr], a), O, n4, F, e4);
                  case 24:
                    var t4 = function(Ze) {
                      return [0, O, [24, Ze]];
                    }, u4 = m[1];
                    return te(u(a[1][1 + _], a), O, u4, F, t4);
                  case 25:
                    var i4 = function(Ze) {
                      return [0, O, [25, Ze]];
                    }, f4 = m[1];
                    return te(u(a[1][1 + p2], a), O, f4, F, i4);
                  default:
                    var x4 = function(Ze) {
                      return [0, O, [26, Ze]];
                    }, o4 = m[1];
                    return te(u(a[1][1 + f_], a), O, o4, F, x4);
                }
              }
              function vte(a, F, m) {
                var O = m[2], H = m[1], $ = H[3], r0 = H[2], j0 = H[1], V0 = o(a[1][1 + t0], a, j0), Nr = o(a[1][1 + t0], a, r0), Gr = Un(u(a[1][1 + t0], a), $), Fe = o(a[1][1 + s0], a, O);
                return V0 === j0 && Nr === r0 && Gr === $ && Fe === O ? m : [0, [0, V0, Nr, Gr], Fe];
              }
              function lte(a, F, m) {
                var O = m[2], H = m[1], $ = H[3], r0 = H[2], j0 = H[1], V0 = o(a[1][1 + t0], a, j0), Nr = o(a[1][1 + t0], a, r0), Gr = Un(u(a[1][1 + t0], a), $), Fe = o(a[1][1 + s0], a, O);
                return V0 === j0 && Nr === r0 && Gr === $ && Fe === O ? m : [0, [0, V0, Nr, Gr], Fe];
              }
              function bte(a, F) {
                var m = F[2], O = F[1], H = o(a[1][1 + t0], a, O), $ = o(a[1][1 + s0], a, m);
                return O === H && m === $ ? F : [0, H, $];
              }
              function pte(a, F) {
                var m = F[2], O = F[1], H = Un(u(a[1][1 + t0], a), O), $ = o(a[1][1 + s0], a, m);
                return O === H && m === $ ? F : [0, H, $];
              }
              function mte(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + K], a, H), r0 = o(a[1][1 + S], a, O);
                return $ === H && r0 === O ? F : [0, F[1], [0, $, r0]];
              }
              function _te(a, F) {
                return o(a[1][1 + lt], a, F);
              }
              function yte(a, F) {
                return o(a[1][1 + lt], a, F);
              }
              function hte(a, F) {
                if (F[0] === 0) {
                  var m = function(r0) {
                    return [0, r0];
                  }, O = F[1];
                  return ee(u(a[1][1 + M], a), O, F, m);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F[1];
                return ee(u(a[1][1 + A], a), $, F, H);
              }
              function dte(a, F) {
                var m = F[2], O = F[1], H = o(a[1][1 + K], a, O), $ = o(a[1][1 + s0], a, m);
                return O === H && m === $ ? F : [0, H, $];
              }
              function kte(a, F) {
                var m = F[2], O = F[1], H = o(a[1][1 + t0], a, O), $ = o(a[1][1 + s0], a, m);
                return O === H && m === $ ? F : [0, H, $];
              }
              function wte(a, F, m) {
                var O = m[2], H = o(a[1][1 + s0], a, O);
                return O === H ? m : [0, m[1], H];
              }
              function Ete(a, F, m) {
                var O = m[3], H = o(a[1][1 + s0], a, O);
                return O === H ? m : [0, m[1], m[2], H];
              }
              function Ste(a, F, m) {
                var O = m[3], H = o(a[1][1 + s0], a, O);
                return O === H ? m : [0, m[1], m[2], H];
              }
              function gte(a, F, m) {
                var O = m[3], H = o(a[1][1 + s0], a, O);
                return O === H ? m : [0, m[1], m[2], H];
              }
              function Fte(a, F, m) {
                var O = m[1], H = ur(a[1][1 + Fn], a, F, O);
                return H === O ? m : [0, H, m[2]];
              }
              function Tte(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = o(a[1][1 + t0], a, $), j0 = o(a[1][1 + t0], a, H), V0 = o(a[1][1 + s0], a, O);
                return r0 === $ && j0 === H && V0 === O ? m : [0, r0, j0, V0];
              }
              function Ote(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = o(a[1][1 + K7], a, $), j0 = ze(u(a[1][1 + e0], a), H), V0 = o(a[1][1 + s0], a, O);
                return r0 === $ && j0 === H && V0 === O ? m : [0, r0, j0, V0];
              }
              function Ite(a, F) {
                var m = F[2], O = m[4], H = m[3], $ = m[2], r0 = m[1], j0 = o(a[1][1 + x0], a, $), V0 = o(a[1][1 + c], a, H), Nr = ze(u(a[1][1 + t0], a), O), Gr = o(a[1][1 + Vc], a, r0);
                return Gr === r0 && j0 === $ && V0 === H && Nr === O ? F : [0, F[1], [0, Gr, j0, V0, Nr]];
              }
              function Ate(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = Un(u(a[1][1 + f0], a), H), r0 = o(a[1][1 + s0], a, O);
                return $ === H && r0 === O ? F : [0, F[1], [0, $, r0]];
              }
              function Nte(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = Un(u(a[1][1 + t0], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F : [0, F[1], [0, $, r0]];
              }
              function Cte(a, F) {
                return ze(u(a[1][1 + s], a), F);
              }
              function Pte(a, F) {
                var m = F[2], O = m[2], H = o(a[1][1 + s0], a, O);
                return O === H ? F : [0, F[1], [0, m[1], H]];
              }
              function Dte(a, F) {
                return o(a[1][1 + lt], a, F);
              }
              function Lte(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + K7], a, H), r0 = o(a[1][1 + Y], a, O);
                return $ === H && r0 === O ? F : [0, F[1], [0, $, r0]];
              }
              function Rte(a, F) {
                if (F[0] === 0) {
                  var m = function(r0) {
                    return [0, r0];
                  }, O = F[1];
                  return ee(u(a[1][1 + m0], a), O, F, m);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F[1];
                return ee(u(a[1][1 + Bu], a), $, F, H);
              }
              function jte(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = u(a[1][1 + ou], a), j0 = Un(function(Gr) {
                  return _u(r0, Gr);
                }, H), V0 = _u(u(a[1][1 + qr], a), $), Nr = o(a[1][1 + s0], a, O);
                return j0 === H && V0 === $ && O === Nr ? m : [0, V0, j0, Nr];
              }
              function Gte(a, F, m) {
                var O = m[4], H = m[3], $ = Un(function(j0) {
                  switch (j0[0]) {
                    case 0:
                      var V0 = function(Kn) {
                        return [0, Kn];
                      }, Nr = j0[1];
                      return ee(u(a[1][1 + ne], a), Nr, j0, V0);
                    case 1:
                      var Gr = function(Kn) {
                        return [1, Kn];
                      }, Fe = j0[1];
                      return ee(u(a[1][1 + jr], a), Fe, j0, Gr);
                    case 2:
                      var _e = function(Kn) {
                        return [2, Kn];
                      }, Dn = j0[1];
                      return ee(u(a[1][1 + ge], a), Dn, j0, _e);
                    case 3:
                      var yn = function(Kn) {
                        return [3, Kn];
                      }, ot = j0[1];
                      return ee(u(a[1][1 + q0], a), ot, j0, yn);
                    default:
                      var pt = function(Kn) {
                        return [4, Kn];
                      }, kt = j0[1];
                      return ee(u(a[1][1 + ce], a), kt, j0, pt);
                  }
                }, H), r0 = o(a[1][1 + s0], a, O);
                return $ === H && O === r0 ? m : [0, m[1], m[2], $, r0];
              }
              function Mte(a, F) {
                var m = F[2], O = m[3], H = m[1], $ = H[2], r0 = H[1], j0 = ur(a[1][1 + a7], a, r0, $), V0 = o(a[1][1 + s0], a, O);
                return $ === j0 && O === V0 ? F : [0, F[1], [0, [0, r0, j0], m[2], V0]];
              }
              function Bte(a, F) {
                var m = F[2], O = m[6], H = m[2], $ = m[1], r0 = o(a[1][1 + lt], a, $), j0 = o(a[1][1 + t0], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? F : [0, F[1], [0, r0, j0, m[3], m[4], m[5], V0]];
              }
              function qte(a, F) {
                var m = F[2], O = m[6], H = m[5], $ = m[3], r0 = m[2], j0 = o(a[1][1 + t0], a, r0), V0 = o(a[1][1 + t0], a, $), Nr = o(a[1][1 + c], a, H), Gr = o(a[1][1 + s0], a, O);
                return j0 === r0 && V0 === $ && Nr === H && Gr === O ? F : [0, F[1], [0, m[1], j0, V0, m[4], Nr, Gr]];
              }
              function Ute(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + t0], a, H), r0 = o(a[1][1 + s0], a, O);
                return $ === H && O === r0 ? F : [0, F[1], [0, $, r0]];
              }
              function Hte(a, F) {
                var m = F[2], O = m[8], H = m[7], $ = m[2], r0 = m[1], j0 = o(a[1][1 + oe], a, r0), V0 = o(a[1][1 + $r], a, $), Nr = o(a[1][1 + c], a, H), Gr = o(a[1][1 + s0], a, O);
                return j0 === r0 && V0 === $ && Nr === H && Gr === O ? F : [0, F[1], [0, j0, V0, m[3], m[4], m[5], m[6], Nr, Gr]];
              }
              function Xte(a, F) {
                var m = F[1];
                function O($) {
                  return [0, m, $];
                }
                var H = F[2];
                return te(u(a[1][1 + a7], a), m, H, F, O);
              }
              function Yte(a, F) {
                var m = F[1];
                function O($) {
                  return [0, m, $];
                }
                var H = F[2];
                return te(u(a[1][1 + a7], a), m, H, F, O);
              }
              function Vte(a, F) {
                switch (F[0]) {
                  case 0:
                    var m = function(V0) {
                      return [0, V0];
                    }, O = F[1];
                    return ee(u(a[1][1 + t0], a), O, F, m);
                  case 1:
                    var H = function(V0) {
                      return [1, V0];
                    }, $ = F[1];
                    return ee(u(a[1][1 + Br], a), $, F, H);
                  default:
                    var r0 = function(V0) {
                      return [2, V0];
                    }, j0 = F[1];
                    return ee(u(a[1][1 + Mr], a), j0, F, r0);
                }
              }
              function zte(a, F) {
                return o(a[1][1 + lt], a, F);
              }
              function Kte(a, F, m) {
                var O = m[4], H = m[3], $ = m[2], r0 = $[2], j0 = r0[4], V0 = r0[3], Nr = r0[2], Gr = r0[1], Fe = m[1], _e = ze(u(a[1][1 + Hc], a), Gr), Dn = Un(u(a[1][1 + D0], a), Nr), yn = ze(u(a[1][1 + Ut], a), V0), ot = o(a[1][1 + t0], a, H), pt = ze(u(a[1][1 + V], a), Fe), kt = o(a[1][1 + s0], a, O), Kn = o(a[1][1 + s0], a, j0);
                return Dn === Nr && yn === V0 && ot === H && pt === Fe && kt === O && Kn === j0 && _e === Gr ? m : [0, pt, [0, $[1], [0, _e, Dn, yn, Kn]], ot, kt];
              }
              function Wte(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + l], a, H), r0 = o(a[1][1 + s0], a, O);
                return $ === H && r0 === O ? F : [0, F[1], [0, $, r0]];
              }
              function Jte(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + D0], a, H), r0 = o(a[1][1 + s0], a, O);
                return $ === H && r0 === O ? F : [0, F[1], [0, $, r0]];
              }
              function $te(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + t0], a, O), r0 = ze(u(a[1][1 + lt], a), H);
                return $ === O && r0 === H ? F : [0, F[1], [0, r0, $, m[3]]];
              }
              function Zte(a, F) {
                var m = F[1];
                function O($) {
                  return [0, m, $];
                }
                var H = F[2];
                return te(u(a[1][1 + T], a), m, H, F, O);
              }
              function Qte(a, F) {
                if (F[0] === 0) {
                  var m = function(r0) {
                    return [0, r0];
                  }, O = F[1];
                  return ee(u(a[1][1 + Ti], a), O, F, m);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F[1];
                return ee(u(a[1][1 + nn], a), $, F, H);
              }
              function rue(a, F, m) {
                var O = m[5], H = m[4], $ = m[3], r0 = m[2], j0 = m[1], V0 = ze(u(a[1][1 + ut], a), j0), Nr = ze(u(a[1][1 + _r], a), r0), Gr = ze(u(a[1][1 + nn], a), $), Fe = o(a[1][1 + Or], a, H), _e = o(a[1][1 + s0], a, O);
                return j0 === V0 && r0 === Nr && $ === Gr && H === Fe && O === _e ? m : [0, V0, Nr, Gr, Fe, _e];
              }
              function eue(a, F) {
                var m = F[1];
                function O($) {
                  return [0, m, $];
                }
                var H = F[2];
                return te(u(a[1][1 + T], a), m, H, F, O);
              }
              function nue(a, F) {
                if (F[0] === 0) {
                  var m = function(r0) {
                    return [0, r0];
                  }, O = F[1];
                  return ee(u(a[1][1 + it], a), O, F, m);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F[1];
                return ee(u(a[1][1 + Tt], a), $, F, H);
              }
              function tue(a, F, m) {
                var O = m[5], H = m[3], $ = m[2], r0 = m[1], j0 = o(a[1][1 + xn], a, r0), V0 = o(a[1][1 + nn], a, $), Nr = o(a[1][1 + Or], a, H), Gr = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === V0 && H === Nr && O === Gr ? m : [0, j0, V0, Nr, m[4], Gr];
              }
              function uue(a, F) {
                var m = F[1];
                function O($) {
                  return [0, m, $];
                }
                var H = F[2];
                return te(u(a[1][1 + T], a), m, H, F, O);
              }
              function iue(a, F) {
                if (F[0] === 0) {
                  var m = function(r0) {
                    return [0, r0];
                  }, O = F[1];
                  return ee(u(a[1][1 + Hs], a), O, F, m);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F[1];
                return ee(u(a[1][1 + Vi], a), $, F, H);
              }
              function fue(a, F, m) {
                var O = m[5], H = m[3], $ = m[2], r0 = m[1], j0 = o(a[1][1 + hs], a, r0), V0 = o(a[1][1 + nn], a, $), Nr = o(a[1][1 + Or], a, H), Gr = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === V0 && H === Nr && O === Gr ? m : [0, j0, V0, Nr, m[4], Gr];
              }
              function xue(a, F) {
                if (F[0] === 0) {
                  var m = function(r0) {
                    return [0, r0];
                  }, O = F[1];
                  return ee(u(a[1][1 + nn], a), O, F, m);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F[1];
                return ee(u(a[1][1 + Rr], a), $, F, H);
              }
              function oue(a, F, m) {
                var O = m[3], H = m[1], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m : [0, $, m[2], r0];
              }
              function aue(a, F) {
                if (F[0] === 0) {
                  var m = F[1], O = Un(u(a[1][1 + Vs], a), m);
                  return m === O ? F : [0, O];
                }
                var H = F[1], $ = o(a[1][1 + q9], a, H);
                return H === $ ? F : [1, $];
              }
              function cue(a, F) {
                var m = F[2], O = ze(u(a[1][1 + lt], a), m);
                return m === O ? F : [0, F[1], O];
              }
              function sue(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + lt], a, H), r0 = ze(u(a[1][1 + lt], a), O);
                return H === $ && O === r0 ? F : [0, F[1], [0, $, r0]];
              }
              function vue(a, F, m) {
                var O = m[5], H = m[2], $ = m[1], r0 = ze(u(a[1][1 + si], a), H), j0 = ze(u(a[1][1 + Or], a), $), V0 = o(a[1][1 + s0], a, O);
                return H === r0 && $ === j0 && O === V0 ? m : [0, j0, r0, m[3], m[4], V0];
              }
              function lue(a, F) {
                if (F[0] === 0) {
                  var m = function(r0) {
                    return [0, r0];
                  }, O = F[1];
                  return ee(u(a[1][1 + Or], a), O, F, m);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F[1];
                return ee(u(a[1][1 + nn], a), $, F, H);
              }
              function bue(a, F, m) {
                var O = m[3], H = m[2], $ = o(a[1][1 + M9], a, H), r0 = o(a[1][1 + s0], a, O);
                return $ === H && r0 === O ? m : [0, m[1], $, r0];
              }
              function pue(a, F) {
                return o(a[1][1 + lt], a, F);
              }
              function mue(a, F) {
                var m = F[2], O = m[1], H = o(a[1][1 + H1], a, O);
                return O === H ? F : [0, F[1], [0, H, m[2]]];
              }
              function _ue(a, F) {
                var m = F[2], O = m[1], H = o(a[1][1 + H1], a, O);
                return O === H ? F : [0, F[1], [0, H, m[2]]];
              }
              function yue(a, F) {
                var m = F[2], O = m[1], H = o(a[1][1 + H1], a, O);
                return O === H ? F : [0, F[1], [0, H, m[2]]];
              }
              function hue(a, F) {
                var m = F[2][1], O = o(a[1][1 + H1], a, m);
                return m === O ? F : [0, F[1], [0, O]];
              }
              function due(a, F) {
                var m = F[3], O = F[1], H = Un(u(a[1][1 + vi], a), O), $ = o(a[1][1 + s0], a, m);
                return O === H && m === $ ? F : [0, H, F[2], $];
              }
              function kue(a, F) {
                var m = F[4], O = F[1];
                if (O[0] === 0) var H = function(_e) {
                  return [0, _e];
                }, $ = O[1], r0 = u(a[1][1 + vi], a), Gr = ee(function(_e) {
                  return Un(r0, _e);
                }, $, O, H);
                else var j0 = function(_e) {
                  return [1, _e];
                }, V0 = O[1], Nr = u(a[1][1 + s2], a), Gr = ee(function(_e) {
                  return Un(Nr, _e);
                }, V0, O, j0);
                var Fe = o(a[1][1 + s0], a, m);
                return O === Gr && m === Fe ? F : [0, Gr, F[2], F[3], Fe];
              }
              function wue(a, F) {
                var m = F[4], O = F[1], H = Un(u(a[1][1 + H9], a), O), $ = o(a[1][1 + s0], a, m);
                return O === H && m === $ ? F : [0, H, F[2], F[3], $];
              }
              function Eue(a, F) {
                var m = F[4], O = F[1], H = Un(u(a[1][1 + cb], a), O), $ = o(a[1][1 + s0], a, m);
                return O === H && m === $ ? F : [0, H, F[2], F[3], $];
              }
              function Sue(a, F) {
                var m = F[2], O = F[1];
                switch (m[0]) {
                  case 0:
                    var H = function(_e) {
                      return [0, O, [0, _e]];
                    }, $ = m[1];
                    return ee(u(a[1][1 + sb], a), $, F, H);
                  case 1:
                    var r0 = function(_e) {
                      return [0, O, [1, _e]];
                    }, j0 = m[1];
                    return ee(u(a[1][1 + X9], a), j0, F, r0);
                  case 2:
                    var V0 = function(_e) {
                      return [0, O, [2, _e]];
                    }, Nr = m[1];
                    return ee(u(a[1][1 + U9], a), Nr, F, V0);
                  default:
                    var Gr = function(_e) {
                      return [0, O, [3, _e]];
                    }, Fe = m[1];
                    return ee(u(a[1][1 + zs], a), Fe, F, Gr);
                }
              }
              function gue(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = ur(a[1][1 + L0], a, i6r, $), j0 = o(a[1][1 + Y9], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m : [0, r0, j0, V0];
              }
              function Fue(a, F, m) {
                var O = m[1], H = o(a[1][1 + s0], a, O);
                return O === H ? m : [0, H];
              }
              function Tue(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = o(a[1][1 + Or], a, $), j0 = o(a[1][1 + _r], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m : [0, r0, j0, V0];
              }
              function Oue(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = ur(a[1][1 + L0], a, u6r, $), j0 = o(a[1][1 + l], a, H), V0 = o(a[1][1 + s0], a, O);
                return r0 === $ && j0 === H && V0 === O ? m : [0, r0, j0, V0];
              }
              function Iue(a, F, m) {
                return ur(a[1][1 + c0], a, F, m);
              }
              function Aue(a, F, m) {
                var O = m[2], H = m[1], $ = o(a[1][1 + l], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m : [0, $, r0];
              }
              function Nue(a, F, m) {
                var O = m[4], H = m[2], $ = _u(u(a[1][1 + zi], a), H), r0 = o(a[1][1 + s0], a, O);
                return $ === H && O === r0 ? m : [0, m[1], $, m[3], r0];
              }
              function Cue(a, F, m) {
                return ur(a[1][1 + Hn], a, F, m);
              }
              function Pue(a, F, m) {
                var O = m[4], H = m[3], $ = m[2], r0 = m[1], j0 = o(a[1][1 + he], a, r0), V0 = o(a[1][1 + l], a, $), Nr = ze(u(a[1][1 + Ir], a), H), Gr = o(a[1][1 + s0], a, O);
                return j0 === r0 && V0 === $ && Nr === H && Gr === O ? m : [0, j0, V0, Nr, Gr];
              }
              function Due(a, F) {
                switch (F[0]) {
                  case 0:
                    var m = F[1], O = m[2], H = m[1], $ = ur(a[1][1 + vb], a, H, O);
                    return $ === O ? F : [0, [0, H, $]];
                  case 1:
                    var r0 = F[1], j0 = r0[2], V0 = r0[1], Nr = ur(a[1][1 + lb], a, V0, j0);
                    return Nr === j0 ? F : [1, [0, V0, Nr]];
                  case 2:
                    var Gr = F[1], Fe = Gr[2], _e = Gr[1], Dn = ur(a[1][1 + v2], a, _e, Fe);
                    return Dn === Fe ? F : [2, [0, _e, Dn]];
                  case 3:
                    var yn = F[1], ot = o(a[1][1 + t0], a, yn);
                    return ot === yn ? F : [3, ot];
                  case 4:
                    var pt = F[1], kt = pt[2], Kn = pt[1], Qt = ur(a[1][1 + c0], a, Kn, kt);
                    return Qt === kt ? F : [4, [0, Kn, Qt]];
                  case 5:
                    var J7 = F[1], $7 = J7[2], E7 = J7[1], Z7 = ur(a[1][1 + Er], a, E7, $7);
                    return Z7 === $7 ? F : [5, [0, E7, Z7]];
                  default:
                    var Q7 = F[1], ri = Q7[2], ei = Q7[1], ni = ur(a[1][1 + Hn], a, ei, ri);
                    return ni === ri ? F : [6, [0, ei, ni]];
                }
              }
              function Lue(a, F, m) {
                var O = m[5], H = m[3], $ = m[2], r0 = ze(u(a[1][1 + si], a), H), j0 = ze(u(a[1][1 + Z9], a), $), V0 = o(a[1][1 + s0], a, O);
                return H === r0 && $ === j0 && O === V0 ? m : [0, m[1], j0, r0, m[4], V0];
              }
              function Rue(a, F, m) {
                var O = m[7], H = m[6], $ = m[5], r0 = m[4], j0 = m[3], V0 = m[2], Nr = m[1], Gr = o(a[1][1 + hb], a, Nr), Fe = ze(u(a[1][1 + V], a), V0), _e = _u(u(a[1][1 + qr], a), j0), Dn = u(a[1][1 + ou], a), yn = ze(function(Qt) {
                  return _u(Dn, Qt);
                }, r0), ot = u(a[1][1 + ou], a), pt = Un(function(Qt) {
                  return _u(ot, Qt);
                }, $), kt = ze(u(a[1][1 + l2], a), H), Kn = o(a[1][1 + s0], a, O);
                return Gr === Nr && Fe === V0 && _e === j0 && yn === r0 && pt === $ && kt === H && Kn === O ? m : [0, Gr, Fe, _e, yn, pt, kt, Kn];
              }
              function jue(a, F, m) {
                var O = m[1], H = o(a[1][1 + s0], a, O);
                return O === H ? m : [0, H];
              }
              function Gue(a, F, m) {
                var O = m[2], H = m[1], $ = ze(u(a[1][1 + Q0], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m : [0, $, r0];
              }
              function Mue(a, F, m) {
                var O = m[4], H = m[3], $ = m[2], r0 = m[1], j0 = o(a[1][1 + _r], a, r0), V0 = o(a[1][1 + nn], a, $), Nr = o(a[1][1 + nn], a, H), Gr = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === V0 && H === Nr && O === Gr ? m : [0, j0, V0, Nr, Gr];
              }
              function Bue(a, F, m) {
                return m;
              }
              function que(a, F, m) {
                var O = m[6], H = m[5], $ = m[3], r0 = m[2], j0 = m[1], V0 = o(a[1][1 + ar], a, j0), Nr = o(a[1][1 + _b], a, r0), Gr = o(a[1][1 + x0], a, $), Fe = o(a[1][1 + c], a, H), _e = o(a[1][1 + s0], a, O);
                return j0 === V0 && r0 === Nr && Gr === $ && Fe === H && _e === O ? m : [0, V0, Nr, Gr, m[4], Fe, _e];
              }
              function Uue(a, F) {
                if (typeof F == "number") return F;
                var m = F[1], O = o(a[1][1 + nn], a, m);
                return m === O ? F : [0, O];
              }
              function Hue(a, F, m) {
                var O = m[6], H = m[5], $ = m[3], r0 = m[2], j0 = m[1], V0 = o(a[1][1 + oe], a, j0), Nr = o(a[1][1 + _b], a, r0), Gr = o(a[1][1 + x0], a, $), Fe = o(a[1][1 + c], a, H), _e = o(a[1][1 + s0], a, O);
                return j0 === V0 && r0 === Nr && Gr === $ && Fe === H && _e === O ? m : [0, V0, Nr, Gr, m[4], Fe, _e];
              }
              function Xue(a, F, m) {
                var O = m[6], H = m[5], $ = m[3], r0 = m[2], j0 = o(a[1][1 + oe], a, r0), V0 = _u(u(a[1][1 + me], a), $), Nr = Un(u(a[1][1 + db], a), H), Gr = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === V0 && H === Nr && O === Gr ? m : [0, m[1], j0, V0, m[4], Nr, Gr];
              }
              function Yue(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + m0], a, H), r0 = ze(u(a[1][1 + e0], a), O);
                return H === $ && O === r0 ? F : [0, F[1], [0, $, r0]];
              }
              function Vue(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = Un(u(a[1][1 + r_], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F : [0, F[1], [0, $, r0]];
              }
              function zue(a, F) {
                switch (F[0]) {
                  case 0:
                    var m = F[1], O = m[1], H = function(yn) {
                      return [0, [0, O, yn]];
                    }, $ = m[2];
                    return te(u(a[1][1 + Xc], a), O, $, F, H);
                  case 1:
                    var r0 = F[1], j0 = r0[1], V0 = function(yn) {
                      return [1, [0, j0, yn]];
                    }, Nr = r0[2];
                    return te(u(a[1][1 + yb], a), j0, Nr, F, V0);
                  default:
                    var Gr = F[1], Fe = Gr[1], _e = function(yn) {
                      return [2, [0, Fe, yn]];
                    }, Dn = Gr[2];
                    return te(u(a[1][1 + Q9], a), Fe, Dn, F, _e);
                }
              }
              function Kue(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F : [0, F[1], [0, $, r0]];
              }
              function Wue(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = Un(u(a[1][1 + Ks], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F : [0, F[1], [0, $, r0]];
              }
              function Jue(a, F) {
                return ur(a[1][1 + L0], a, t6r, F);
              }
              function $ue(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = o(a[1][1 + nn], a, $), j0 = ze(u(a[1][1 + e0], a), H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m : [0, r0, j0, V0];
              }
              function Zue(a, F, m) {
                var O = m[7], H = m[6], $ = m[5], r0 = m[4], j0 = m[3], V0 = m[2], Nr = m[1], Gr = ze(u(a[1][1 + hb], a), Nr), Fe = o(a[1][1 + n_], a, V0), _e = ze(u(a[1][1 + V], a), j0), Dn = u(a[1][1 + Yc], a), yn = ze(function(Kn) {
                  return _u(Dn, Kn);
                }, r0), ot = ze(u(a[1][1 + l2], a), $), pt = Un(u(a[1][1 + db], a), H), kt = o(a[1][1 + s0], a, O);
                return Nr === Gr && V0 === Fe && r0 === yn && $ === ot && H === pt && O === kt && j0 === _e ? m : [0, Gr, Fe, _e, yn, ot, pt, kt];
              }
              function Que(a, F, m) {
                return ur(a[1][1 + ds], a, F, m);
              }
              function r7e(a, F, m) {
                return ur(a[1][1 + ds], a, F, m);
              }
              function e7e(a, F, m) {
                var O = m[3], H = m[2], $ = m[1], r0 = ze(u(a[1][1 + t_], a), $), j0 = o(a[1][1 + u_], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m : [0, r0, j0, V0];
              }
              function n7e(a, F) {
                return _u(u(a[1][1 + zi], a), F);
              }
              function t7e(a, F) {
                if (F[0] === 0) {
                  var m = F[1], O = o(a[1][1 + t0], a, m);
                  return O === m ? F : [0, O];
                }
                var H = F[1], $ = H[2][1], r0 = o(a[1][1 + s0], a, $);
                return $ === r0 ? F : [1, [0, H[1], [0, r0]]];
              }
              function u7e(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = Un(u(a[1][1 + i_], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F : [0, F[1], [0, $, r0]];
              }
              function i7e(a, F, m) {
                var O = m[1], H = ur(a[1][1 + kb], a, F, O);
                return O === H ? m : [0, H, m[2], m[3]];
              }
              function f7e(a, F) {
                var m = F[2], O = m[2], H = m[1], $ = Un(u(a[1][1 + Ys], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F : [0, F[1], [0, $, r0]];
              }
              function x7e(a, F, m) {
                var O = m[4], H = m[3], $ = m[2], r0 = m[1], j0 = o(a[1][1 + nn], a, r0), V0 = ze(u(a[1][1 + b2], a), $), Nr = o(a[1][1 + Ws], a, H), Gr = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === V0 && H === Nr && O === Gr ? m : [0, j0, V0, Nr, Gr];
              }
              function o7e(a, F, m) {
                var O = m[2], H = m[1], $ = ze(u(a[1][1 + Q0], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m : [0, $, r0];
              }
              function a7e(a, F, m) {
                var O = m[2], H = m[1], $ = o(a[1][1 + Tr], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m : [0, $, r0];
              }
              function c7e(a, F, m) {
                var O = m[4], H = m[3], $ = m[2], r0 = o(a[1][1 + nn], a, $), j0 = o(a[1][1 + nn], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m : [0, m[1], r0, j0, V0];
              }
              function s7e(a, F, m) {
                var O = m[4], H = m[3], $ = m[2], r0 = o(a[1][1 + m2], a, $), j0 = o(a[1][1 + nn], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m : [0, m[1], r0, j0, V0];
              }
              function v7e(a, F, m) {
                return ur(a[1][1 + jn], a, F, m);
              }
              function l7e(a, F) {
                switch (F[0]) {
                  case 0:
                    var m = function(r0) {
                      return [0, r0];
                    }, O = F[1];
                    return ee(u(a[1][1 + nn], a), O, F, m);
                  case 1:
                    var H = function(r0) {
                      return [1, r0];
                    }, $ = F[1];
                    return ee(u(a[1][1 + Rr], a), $, F, H);
                  default:
                    return F;
                }
              }
              function b7e(a, F, m) {
                var O = m[2], H = m[1], $ = Un(u(a[1][1 + a_], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m : [0, $, r0];
              }
              function p7e(a, F) {
                var m = F[2], O = F[1];
                switch (m[0]) {
                  case 0:
                    var H = function(Ue) {
                      return [0, O, [0, Ue]];
                    }, $ = m[1];
                    return te(u(a[1][1 + y2], a), O, $, F, H);
                  case 1:
                    var r0 = function(Ue) {
                      return [0, O, [1, Ue]];
                    }, j0 = m[1];
                    return te(u(a[1][1 + o_], a), O, j0, F, r0);
                  case 2:
                    var V0 = function(Ue) {
                      return [0, O, [2, Ue]];
                    }, Nr = m[1];
                    return te(u(a[1][1 + _2], a), O, Nr, F, V0);
                  case 3:
                    var Gr = function(Ue) {
                      return [0, O, [3, Ue]];
                    }, Fe = m[1];
                    return te(u(a[1][1 + x_], a), O, Fe, F, Gr);
                  case 4:
                    var _e = function(Ue) {
                      return [0, O, [4, Ue]];
                    }, Dn = m[1];
                    return te(u(a[1][1 + kb], a), O, Dn, F, _e);
                  case 5:
                    var yn = function(Ue) {
                      return [0, O, [5, Ue]];
                    }, ot = m[1];
                    return te(u(a[1][1 + e_], a), O, ot, F, yn);
                  case 6:
                    var pt = function(Ue) {
                      return [0, O, [6, Ue]];
                    }, kt = m[1];
                    return te(u(a[1][1 + Gn], a), O, kt, F, pt);
                  case 7:
                    var Kn = function(Ue) {
                      return [0, O, [7, Ue]];
                    }, Qt = m[1];
                    return te(u(a[1][1 + mb], a), O, Qt, F, Kn);
                  case 8:
                    var J7 = function(Ue) {
                      return [0, O, [8, Ue]];
                    }, $7 = m[1];
                    return te(u(a[1][1 + Zn], a), O, $7, F, J7);
                  case 9:
                    var E7 = function(Ue) {
                      return [0, O, [9, Ue]];
                    }, Z7 = m[1];
                    return te(u(a[1][1 + Yi], a), O, Z7, F, E7);
                  case 10:
                    var Q7 = function(Ue) {
                      return [0, O, [10, Ue]];
                    }, ri = m[1];
                    return ee(u(a[1][1 + lt], a), ri, F, Q7);
                  case 11:
                    var ei = function(Ue) {
                      return [0, O, [11, Ue]];
                    }, ni = m[1];
                    return ee(o(a[1][1 + Ft], a, O), ni, F, ei);
                  case 12:
                    var Wi = function(Ue) {
                      return [0, O, [12, Ue]];
                    }, tv = m[1];
                    return te(u(a[1][1 + Ge], a), O, tv, F, Wi);
                  case 13:
                    var uv = function(Ue) {
                      return [0, O, [13, Ue]];
                    }, Ji = m[1];
                    return te(u(a[1][1 + Kr], a), O, Ji, F, uv);
                  case 14:
                    var iv = function(Ue) {
                      return [0, O, [14, Ue]];
                    }, Gb = m[1];
                    return te(u(a[1][1 + J0], a), O, Gb, F, iv);
                  case 15:
                    var Mb = function(Ue) {
                      return [0, O, [15, Ue]];
                    }, Bb = m[1];
                    return te(u(a[1][1 + X0], a), O, Bb, F, Mb);
                  case 16:
                    var qb = function(Ue) {
                      return [0, O, [16, Ue]];
                    }, Ub = m[1];
                    return te(u(a[1][1 + u0], a), O, Ub, F, qb);
                  case 17:
                    var Hb = function(Ue) {
                      return [0, O, [17, Ue]];
                    }, Xb = m[1];
                    return te(u(a[1][1 + U], a), O, Xb, F, Hb);
                  case 18:
                    var Yb = function(Ue) {
                      return [0, O, [18, Ue]];
                    }, Vb = m[1];
                    return te(u(a[1][1 + I], a), O, Vb, F, Yb);
                  case 19:
                    var zb = function(Ue) {
                      return [0, O, [19, Ue]];
                    }, Kb = m[1];
                    return te(u(a[1][1 + Fr], a), O, Kb, F, zb);
                  case 20:
                    var Wb = function(Ue) {
                      return [0, O, [20, Ue]];
                    }, Jb = m[1];
                    return ee(o(a[1][1 + $0], a, O), Jb, F, Wb);
                  case 21:
                    var $b = function(Ue) {
                      return [0, O, [21, Ue]];
                    }, Zb = m[1];
                    return te(u(a[1][1 + yr], a), O, Zb, F, $b);
                  case 22:
                    var Qb = function(Ue) {
                      return [0, O, [22, Ue]];
                    }, r4 = m[1];
                    return te(u(a[1][1 + Wr], a), O, r4, F, Qb);
                  case 23:
                    var e4 = function(Ue) {
                      return [0, O, [23, Ue]];
                    }, n4 = m[1];
                    return te(u(a[1][1 + W0], a), O, n4, F, e4);
                  case 24:
                    var t4 = function(Ue) {
                      return [0, O, [24, Ue]];
                    }, u4 = m[1];
                    return te(u(a[1][1 + X], a), O, u4, F, t4);
                  case 25:
                    var i4 = function(Ue) {
                      return [0, O, [25, Ue]];
                    }, f4 = m[1];
                    return te(u(a[1][1 + R0], a), O, f4, F, i4);
                  case 26:
                    var x4 = function(Ue) {
                      return [0, O, [26, Ue]];
                    }, o4 = m[1];
                    return te(u(a[1][1 + U0], a), O, o4, F, x4);
                  case 27:
                    var Ze = function(Ue) {
                      return [0, O, [27, Ue]];
                    }, AR = m[1];
                    return te(u(a[1][1 + g0], a), O, AR, F, Ze);
                  case 28:
                    var NR = function(Ue) {
                      return [0, O, [28, Ue]];
                    }, CR = m[1];
                    return te(u(a[1][1 + w], a), O, CR, F, NR);
                  case 29:
                    var PR = function(Ue) {
                      return [0, O, [29, Ue]];
                    }, DR = m[1];
                    return te(u(a[1][1 + E], a), O, DR, F, PR);
                  default:
                    var LR = function(Ue) {
                      return [0, O, [30, Ue]];
                    }, RR = m[1];
                    return te(u(a[1][1 + e], a), O, RR, F, LR);
                }
              }
              function m7e(a, F) {
                var m = F[2], O = F[1], H = Un(u(a[1][1 + Y1], a), O), $ = Un(u(a[1][1 + Y1], a), m);
                return O === H && m === $ ? F : [0, H, $, F[3]];
              }
              var _7e = 8;
              function y7e(a, F) {
                return F;
              }
              function h7e(a, F) {
                var m = F[2], O = F[1];
                switch (m[0]) {
                  case 0:
                    var H = function(Oe) {
                      return [0, O, [0, Oe]];
                    }, $ = m[1];
                    return te(u(a[1][1 + zi], a), O, $, F, H);
                  case 1:
                    var r0 = function(Oe) {
                      return [0, O, [1, Oe]];
                    }, j0 = m[1];
                    return te(u(a[1][1 + Js], a), O, j0, F, r0);
                  case 2:
                    var V0 = function(Oe) {
                      return [0, O, [2, Oe]];
                    }, Nr = m[1];
                    return te(u(a[1][1 + V1], a), O, Nr, F, V0);
                  case 3:
                    var Gr = function(Oe) {
                      return [0, O, [3, Oe]];
                    }, Fe = m[1];
                    return te(u(a[1][1 + pb], a), O, Fe, F, Gr);
                  case 4:
                    var _e = function(Oe) {
                      return [0, O, [4, Oe]];
                    }, Dn = m[1];
                    return te(u(a[1][1 + bb], a), O, Dn, F, _e);
                  case 5:
                    var yn = function(Oe) {
                      return [0, O, [5, Oe]];
                    }, ot = m[1];
                    return te(u(a[1][1 + v2], a), O, ot, F, yn);
                  case 6:
                    var pt = function(Oe) {
                      return [0, O, [6, Oe]];
                    }, kt = m[1];
                    return te(u(a[1][1 + X1], a), O, kt, F, pt);
                  case 7:
                    var Kn = function(Oe) {
                      return [0, O, [7, Oe]];
                    }, Qt = m[1];
                    return te(u(a[1][1 + lb], a), O, Qt, F, Kn);
                  case 8:
                    var J7 = function(Oe) {
                      return [0, O, [8, Oe]];
                    }, $7 = m[1];
                    return te(u(a[1][1 + $9], a), O, $7, F, J7);
                  case 9:
                    var E7 = function(Oe) {
                      return [0, O, [9, Oe]];
                    }, Z7 = m[1];
                    return te(u(a[1][1 + J9], a), O, Z7, F, E7);
                  case 10:
                    var Q7 = function(Oe) {
                      return [0, O, [10, Oe]];
                    }, ri = m[1];
                    return te(u(a[1][1 + W9], a), O, ri, F, Q7);
                  case 11:
                    var ei = function(Oe) {
                      return [0, O, [11, Oe]];
                    }, ni = m[1];
                    return te(u(a[1][1 + K9], a), O, ni, F, ei);
                  case 12:
                    var Wi = function(Oe) {
                      return [0, O, [33, Oe]];
                    }, tv = m[1];
                    return te(u(a[1][1 + Er], a), O, tv, F, Wi);
                  case 13:
                    var uv = function(Oe) {
                      return [0, O, [13, Oe]];
                    }, Ji = m[1];
                    return te(u(a[1][1 + vb], a), O, Ji, F, uv);
                  case 14:
                    var iv = function(Oe) {
                      return [0, O, [14, Oe]];
                    }, Gb = m[1];
                    return te(u(a[1][1 + z9], a), O, Gb, F, iv);
                  case 15:
                    var Mb = function(Oe) {
                      return [0, O, [15, Oe]];
                    }, Bb = m[1];
                    return te(u(a[1][1 + V9], a), O, Bb, F, Mb);
                  case 16:
                    var qb = function(Oe) {
                      return [0, O, [16, Oe]];
                    }, Ub = m[1];
                    return te(u(a[1][1 + ab], a), O, Ub, F, qb);
                  case 17:
                    var Hb = function(Oe) {
                      return [0, O, [17, Oe]];
                    }, Xb = m[1];
                    return te(u(a[1][1 + B9], a), O, Xb, F, Hb);
                  case 18:
                    var Yb = function(Oe) {
                      return [0, O, [18, Oe]];
                    }, Vb = m[1];
                    return te(u(a[1][1 + c2], a), O, Vb, F, Yb);
                  case 19:
                    var zb = function(Oe) {
                      return [0, O, [19, Oe]];
                    }, Kb = m[1];
                    return te(u(a[1][1 + Xs], a), O, Kb, F, zb);
                  case 20:
                    var Wb = function(Oe) {
                      return [0, O, [20, Oe]];
                    }, Jb = m[1];
                    return te(u(a[1][1 + dt], a), O, Jb, F, Wb);
                  case 21:
                    var $b = function(Oe) {
                      return [0, O, [21, Oe]];
                    }, Zb = m[1];
                    return te(u(a[1][1 + Au], a), O, Zb, F, $b);
                  case 22:
                    var Qb = function(Oe) {
                      return [0, O, [22, Oe]];
                    }, r4 = m[1];
                    return te(u(a[1][1 + ln], a), O, r4, F, Qb);
                  case 23:
                    var e4 = function(Oe) {
                      return [0, O, [23, Oe]];
                    }, n4 = m[1];
                    return te(u(a[1][1 + wn], a), O, n4, F, e4);
                  case 24:
                    var t4 = function(Oe) {
                      return [0, O, [24, Oe]];
                    }, u4 = m[1];
                    return te(u(a[1][1 + Ct], a), O, u4, F, t4);
                  case 25:
                    var i4 = function(Oe) {
                      return [0, O, [25, Oe]];
                    }, f4 = m[1];
                    return te(u(a[1][1 + qt], a), O, f4, F, i4);
                  case 26:
                    var x4 = function(Oe) {
                      return [0, O, [26, Oe]];
                    }, o4 = m[1];
                    return te(u(a[1][1 + Cn], a), O, o4, F, x4);
                  case 27:
                    var Ze = function(Oe) {
                      return [0, O, [27, Oe]];
                    }, AR = m[1];
                    return te(u(a[1][1 + ir], a), O, AR, F, Ze);
                  case 28:
                    var NR = function(Oe) {
                      return [0, O, [28, Oe]];
                    }, CR = m[1];
                    return te(u(a[1][1 + Jr], a), O, CR, F, NR);
                  case 29:
                    var PR = function(Oe) {
                      return [0, O, [29, Oe]];
                    }, DR = m[1];
                    return te(u(a[1][1 + or], a), O, DR, F, PR);
                  case 30:
                    var LR = function(Oe) {
                      return [0, O, [30, Oe]];
                    }, RR = m[1];
                    return te(u(a[1][1 + E0], a), O, RR, F, LR);
                  case 31:
                    var Ue = function(Oe) {
                      return [0, O, [31, Oe]];
                    }, d7e = m[1];
                    return te(u(a[1][1 + w0], a), O, d7e, F, Ue);
                  case 32:
                    var k7e = function(Oe) {
                      return [0, O, [32, Oe]];
                    }, w7e = m[1];
                    return te(u(a[1][1 + c0], a), O, w7e, F, k7e);
                  case 33:
                    var E7e = function(Oe) {
                      return [0, O, [33, Oe]];
                    }, S7e = m[1];
                    return te(u(a[1][1 + Er], a), O, S7e, F, E7e);
                  case 34:
                    var g7e = function(Oe) {
                      return [0, O, [34, Oe]];
                    }, F7e = m[1];
                    return te(u(a[1][1 + T], a), O, F7e, F, g7e);
                  case 35:
                    var T7e = function(Oe) {
                      return [0, O, [35, Oe]];
                    }, O7e = m[1];
                    return te(u(a[1][1 + x], a), O, O7e, F, T7e);
                  default:
                    var I7e = function(Oe) {
                      return [0, O, [36, Oe]];
                    }, A7e = m[1];
                    return te(u(a[1][1 + i], a), O, A7e, F, I7e);
                }
              }
              return jN(t, [0, qL, function(a, F) {
                var m = F[2], O = m[3], H = m[2], $ = m[1], r0 = o(a[1][1 + _0], a, $), j0 = o(a[1][1 + s0], a, H), V0 = Un(u(a[1][1 + Y1], a), O);
                return $ === r0 && H === j0 && O === V0 ? F : [0, F[1], [0, r0, j0, V0]];
              }, Or, h7e, Y1, y7e, s0, _7e, ze, hr, hr, m7e, nn, p7e, y2, b7e, a_, l7e, o_, v7e, _2, s7e, x_, c7e, zi, a7e, Js, o7e, kb, x7e, Ws, f7e, $0, i7e, b2, u7e, i_, t7e, u_, n7e, z1, e7e, V1, r7e, e_, Que, ds, Zue, Yc, $ue, hb, Jue, n_, Wue, db, Kue, Ks, zue, l2, Vue, r_, Yue, Xc, Xue, yb, Hue, _b, Uue, Q9, que, Gn, Bue, mb, Mue, pb, Gue, bb, jue, v2, Rue, X1, Lue, Z9, Due, lb, Pue, $9, Cue, J9, Nue, W9, Aue, K9, Iue, vb, Oue, z9, Tue, V9, Fue, ab, gue, Y9, Sue, sb, Eue, X9, wue, U9, kue, zs, due, vi, hue, cb, yue, H9, _ue, s2, mue, H1, pue, B9, bue, M9, lue, c2, vue, Vs, sue, q9, cue, si, aue, Xs, oue, Ys, xue, Au, fue, hs, iue, Hs, uue, ln, tue, xn, nue, it, eue, dt, rue, ut, Qte, Ti, Zte, D0, $te, Ut, Jte, Hc, Wte, a7, Kte, Q0, zte, $r, Vte, Br, Yte, Mr, Xte, ne, Hte, jr, Ute, ge, qte, ce, Bte, q0, Mte, qr, Gte, _n, jte, K7, Rte, Bu, Lte, Y, Dte, s, Pte, c, Cte, e0, Nte, V, Ate, f0, Ite, ou, Ote, Fn, Tte, vr, Fte, Lr, gte, _, Ste, p2, Ete, f_, wte, k, kte, G, dte, K, hte, M, yte, S, _te, A, mte, o0, pte, Zs, bte, d, lte, en, vte, t0, ste, l, cte, x0, ate, wn, ote, Zn, xte, me, fte, jn, ite, B0, ute, W7, tte, He, nte, ft, ete, xt, rte, he, Qne, Yi, Zne, lt, $ne, k0, Jne, m0, Wne, Vc, Kne, Hn, zne, Cn, Vne, ar, Yne, On, Xne, Ft, Hne, du, Une, Wu, qne, Ct, Bne, qt, Mne, vt, Gne, gt, jne, Zt, Rne, Nt, Lne, Ge, Dne, Kr, Pne, mr, Cne, Me, Nne, Cr, Ane, Sr, Ine, Je, One, Ne, Tne, vn, Fne, kn, gne, rn, Sne, cn, IR, Ae, jb, an, Rb, We, nv, re, Lb, F0, ev, Ie, Ki, ve, w7, xe, Ii, Re, wu, sr, ku, Ur, OR, Pr, TR, K0, Db, h0, FR, ir, gR, J0, Pb, X0, SR, u0, ER, yr, wR, I0, E2, y0, kR, D, y_, P0, dR, U, hR, I, Cb, Fr, yR, Qr, __, oe, _R, be, mR, ae, Nb, pe, pR, Er, bR, Le, lR, p, Ab, t_, m_, Vi, vR, Tt, p_, $s, Ib, m2, b_, er, sR, L0, l_, rr, cR, T0, Ob, S0, v_, Q, Tb, L, rv, i0, aR, l0, oR, v0, s_, P, Mn, fe, xR, M0, Fb, O0, fR, b0, gb, p0, iR, Z, Sb, K1, uR, B, Q1, Ir, tR, _r, w2, bt, nR, Jr, k2, Wr, eR, _0, c_, Tr, rR, Hr, QL, Rr, d2, fr, ZL, W0, $L, or, Eb, Ar, JL, X, wb, R0, WL, b, Z1, U0, KL, E0, $1, w0, zL, g0, h22, w, VL, E, YL, T, Oi, y, XL, x, J1, i, HL, c0, W1, e, UL]), function(a, F) {
                return jp(F, t);
              };
            });
            function X00(t) {
              switch (t[0]) {
                case 0:
                  return 1;
                case 3:
                  return 3;
                default:
                  return 2;
              }
            }
            function Y00(t, n) {
              u(f(t), O6r), o(f(t), A6r, I6r);
              var e = n[1];
              o(f(t), N6r, e), u(f(t), C6r), u(f(t), P6r), o(f(t), L6r, D6r);
              var i = n[2];
              return o(f(t), R6r, i), u(f(t), j6r), u(f(t), G6r);
            }
            var V00 = function t(n, e) {
              return t.fun(n, e);
            }, Fee = function t(n) {
              return t.fun(n);
            };
            N(V00, function(t, n) {
              u(f(t), B6r), o(f(t), U6r, q6r);
              var e = n[1];
              if (e) {
                g(t, H6r);
                var i = e[1];
                switch (i[0]) {
                  case 0:
                    u(f(t), m6r);
                    var x = i[1];
                    o(f(t), _6r, x), u(f(t), y6r);
                    break;
                  case 1:
                    u(f(t), h6r);
                    var c = i[1];
                    o(f(t), d6r, c), u(f(t), k6r);
                    break;
                  case 2:
                    u(f(t), w6r);
                    var s = i[1];
                    o(f(t), E6r, s), u(f(t), S6r);
                    break;
                  default:
                    u(f(t), g6r);
                    var p = i[1];
                    o(f(t), F6r, p), u(f(t), T6r);
                }
                g(t, X6r);
              } else g(t, Y6r);
              return u(f(t), V6r), u(f(t), z6r), o(f(t), W6r, K6r), Y00(t, n[2]), u(f(t), J6r), u(f(t), $6r), o(f(t), Q6r, Z6r), Y00(t, n[3]), u(f(t), rpr), u(f(t), epr);
            }), N(Fee, function(t) {
              return o(C0(M6r), V00, t);
            });
            function yt(t, n) {
              return [0, t[1], t[2], n[3]];
            }
            function ps(t, n) {
              var e = t[1] - n[1] | 0;
              return e === 0 ? t[2] - n[2] | 0 : e;
            }
            function z00(t, n) {
              var e = n[1], i = t[1];
              if (i) if (e) var x = e[1], c = i[1], s = X00(x), p = X00(c) - s | 0, T = p === 0 ? Ee(c[1], x[1]) : p;
              else var T = -1;
              else var y = e && 1, T = y;
              if (T === 0) {
                var E = ps(t[2], n[2]);
                return E === 0 ? ps(t[3], n[3]) : E;
              }
              return T;
            }
            function Wv(t, n) {
              return z00(t, n) === 0 ? 1 : 0;
            }
            var WD = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Tee = Rp(upr, function(t) {
              var n = NN(t, tpr)[35], e = LN(t, 0, 0, npr, KD, 1)[1];
              return zz(t, n, function(i, x) {
                return 0;
              }), function(i, x) {
                var c = jp(x, t);
                return u(e, c), RN(x, c, t);
              };
            });
            N(WD, function(t, n, e) {
              var i = e[2];
              switch (i[0]) {
                case 0:
                  var x = i[1][1];
                  return le(function(s, p) {
                    var y = p[0] === 0 ? p[1][2][2] : p[1][2][1];
                    return ur(WD, t, s, y);
                  }, n, x);
                case 1:
                  var c = i[1][1];
                  return le(function(s, p) {
                    return p[0] === 2 ? s : ur(WD, t, s, p[1][2][1]);
                  }, n, c);
                case 2:
                  return o(t, n, i[1][1]);
                default:
                  return n;
              }
            });
            function Rc(t, n) {
              return [0, n[1], [0, n[2], t]];
            }
            function K00(t, n, e) {
              var i = t && t[1], x = n && n[1];
              return [0, i, x, e];
            }
            function lr(t, n, e) {
              var i = t && t[1], x = n && n[1];
              return !i && !x ? x : [0, K00([0, i], [0, x], 0)];
            }
            function yu(t, n, e, i) {
              var x = t && t[1], c = n && n[1];
              return !x && !c && !e ? e : [0, K00([0, x], [0, c], e)];
            }
            function y7(t, n) {
              if (t) {
                if (n) {
                  var e = n[1], i = t[1], x = [0, on(i[2], e[2])];
                  return lr([0, on(e[1], i[1])], x, 0);
                }
                var c = t;
              } else var c = n;
              return c;
            }
            function JD(t, n) {
              if (n) {
                if (t) {
                  var e = n[1], i = t[1], x = i[3], c = [0, on(i[2], e[2])];
                  return yu([0, on(e[1], i[1])], c, x, 0);
                }
                var s = n[1];
                return yu([0, s[1]], [0, s[2]], 0, 0);
              }
              return t;
            }
            function Jv(t, n) {
              for (var e = t, i = n; ; ) {
                if (typeof e == "number") return i;
                if (e[0] === 0) return [0, e[1], 0, i];
                var x = [0, e[2], e[4], i], e = e[3], i = x;
              }
            }
            function W00(t, n) {
              if (t) var e = Jv(t[2], t[3]), i = function(c) {
                return W00(e, c);
              }, x = [0, t[1], i];
              else var x = t;
              return x;
            }
            function Oee(t) {
              var n = Jv(t, 0);
              return function(e) {
                return W00(n, e);
              };
            }
            function ms(t) {
              return typeof t == "number" ? 0 : t[0] === 0 ? 1 : t[1];
            }
            function Iee(t) {
              return [0, t];
            }
            function Y7(t, n, e) {
              var i = 0;
              if (typeof t == "number") {
                if (typeof e == "number") return [0, n];
                e[0] === 1 && (i = 1);
              } else if (t[0] === 0) typeof e != "number" && e[0] === 1 && (i = 1);
              else {
                var x = t[1];
                if (typeof e != "number" && e[0] === 1) {
                  var c = e[1], s = c <= x ? x + 1 | 0 : c + 1 | 0;
                  return [1, s, n, t, e];
                }
                var p = x;
                i = 2;
              }
              switch (i) {
                case 1:
                  var p = e[1];
                  break;
                case 0:
                  return [1, 2, n, t, e];
              }
              return [1, p + 1 | 0, n, t, e];
            }
            function Ns(t, n, e) {
              var i = ms(t), x = ms(e), c = x <= i ? i + 1 | 0 : x + 1 | 0;
              return [1, c, n, t, e];
            }
            function $D(t, n) {
              var e = n !== 0 ? 1 : 0;
              if (e) {
                if (n !== 1) {
                  var i = n >>> 1 | 0, x = $D(t, i), c = u(t, 0), s = $D(t, (n - i | 0) - 1 | 0);
                  return [1, ms(x) + 1 | 0, c, x, s];
                }
                var p = [0, u(t, 0)];
              } else var p = e;
              return p;
            }
            function ki(t, n, e) {
              var i = ms(t), x = ms(e);
              if ((x + 2 | 0) < i) {
                var c = t[4], s = t[3], p = t[2], y = ms(c);
                if (y <= ms(s)) return Ns(s, p, Y7(c, n, e));
                var T = Y7(c[4], n, e), E = c[2];
                return Ns(Y7(s, p, c[3]), E, T);
              }
              if ((i + 2 | 0) < x) {
                var d = e[4], w = e[3], G = e[2], A = ms(w);
                if (A <= ms(d)) return Ns(Y7(t, n, w), G, d);
                var S = Y7(w[4], G, d), M = w[2];
                return Ns(Y7(t, n, w[3]), M, S);
              }
              return Y7(t, n, e);
            }
            function J00(t, n) {
              if (typeof n == "number") return [0, t];
              if (n[0] === 0) return Y7([0, t], n[1], 0);
              var e = n[4], i = n[2];
              return ki(J00(t, n[3]), i, e);
            }
            function $00(t, n) {
              if (typeof n == "number") return [0, t];
              if (n[0] === 0) return Y7(0, n[1], [0, t]);
              var e = $00(t, n[4]);
              return ki(n[3], n[2], e);
            }
            function Vu(t, n, e) {
              if (typeof t == "number") return J00(n, e);
              if (t[0] === 0) {
                if (typeof e != "number") {
                  if (e[0] === 0) return Y7(t, n, e);
                  if (3 < e[1]) {
                    var i = e[4], x = e[2];
                    return ki(Vu(t, n, e[3]), x, i);
                  }
                  return Ns(t, n, e);
                }
              } else {
                var c = t[4], s = t[3], p = t[2], y = t[1];
                if (typeof e != "number") {
                  if (e[0] === 0) return 3 < y ? ki(s, p, Vu(c, n, e)) : Ns(t, n, e);
                  var T = e[1];
                  if ((T + 2 | 0) < y) return ki(s, p, Vu(c, n, e));
                  if ((y + 2 | 0) < T) {
                    var E = e[4], d = e[2];
                    return ki(Vu(t, n, e[3]), d, E);
                  }
                  return Ns(t, n, e);
                }
              }
              return $00(n, t);
            }
            function Pl(t) {
              for (var n = t; ; ) {
                if (typeof n == "number") throw Jt;
                if (n[0] === 0) return n[1];
                if (typeof n[3] == "number") return n[2];
                var n = n[3];
              }
            }
            function Z00(t) {
              for (var n = t; ; ) {
                if (typeof n == "number") return 0;
                if (n[0] === 0) return [0, n[1]];
                if (typeof n[3] == "number") return [0, n[2]];
                var n = n[3];
              }
            }
            function Q00(t) {
              for (var n = t; ; ) {
                if (typeof n == "number") throw Jt;
                if (n[0] === 0) return n[1];
                if (typeof n[4] == "number") return n[2];
                var n = n[4];
              }
            }
            function Aee(t) {
              for (var n = t; ; ) {
                if (typeof n == "number") return 0;
                if (n[0] === 0) return [0, n[1]];
                if (typeof n[4] == "number") return [0, n[2]];
                var n = n[4];
              }
            }
            function ZD(t) {
              if (typeof t == "number") return Pu(Upr);
              if (t[0] === 0) return 0;
              if (typeof t[3] == "number") return t[4];
              var n = t[4], e = t[2];
              return ki(ZD(t[3]), e, n);
            }
            function Dl(t, n) {
              if (typeof t == "number") return n;
              if (typeof n == "number") return t;
              var e = ZD(n);
              return Vu(t, Pl(n), e);
            }
            function QD(t) {
              if (typeof t == "number") return 0;
              if (t[0] === 0) return 1;
              var n = QD(t[4]);
              return (QD(t[3]) + 1 | 0) + n | 0;
            }
            function rr0(t, n) {
              for (var e = t, i = n; ; ) {
                if (typeof i == "number") return e;
                if (i[0] === 0) return [0, i[1], e];
                var x = i[3], c = rr0(e, i[4]), e = [0, i[2], c], i = x;
              }
            }
            function er0(t) {
              return rr0(0, t);
            }
            var st = 0;
            function rL(t) {
              var n = typeof t == "number" ? 1 : 0, e = n && 1;
              return e;
            }
            function eL(t) {
              function n(e0, x0) {
                if (typeof x0 == "number") return [0, e0];
                if (x0[0] === 0) {
                  var l = x0[1], c0 = o(t[1], e0, l);
                  return c0 === 0 ? x0 : 0 <= c0 ? Y7(x0, e0, st) : Y7([0, e0], l, st);
                }
                var t0 = x0[4], o0 = x0[3], w0 = x0[2], _0 = o(t[1], e0, w0);
                if (_0 === 0) return x0;
                if (0 <= _0) {
                  var E0 = n(e0, t0);
                  return t0 === E0 ? x0 : ki(o0, w0, E0);
                }
                var U0 = n(e0, o0);
                return o0 === U0 ? x0 : ki(U0, w0, t0);
              }
              function e(e0, x0) {
                if (typeof x0 == "number") return [0, st, 0, st];
                if (x0[0] === 0) {
                  var l = o(t[1], e0, x0[1]);
                  return l === 0 ? [0, st, 1, st] : 0 <= l ? [0, x0, 0, st] : [0, st, 0, x0];
                }
                var c0 = x0[4], t0 = x0[3], o0 = x0[2], w0 = o(t[1], e0, o0);
                if (w0 === 0) return [0, t0, 1, c0];
                if (0 <= w0) {
                  var _0 = e(e0, c0), E0 = _0[3], U0 = _0[2];
                  return [0, Vu(t0, o0, _0[1]), U0, E0];
                }
                var b = e(e0, t0), R0 = Vu(b[3], o0, c0);
                return [0, b[1], b[2], R0];
              }
              function i(e0, x0) {
                for (var l = x0; ; ) {
                  if (typeof l == "number") return 0;
                  if (l[0] === 0) return o(t[1], e0, l[1]) === 0 ? 1 : 0;
                  var c0 = o(t[1], e0, l[2]), t0 = c0 === 0 ? 1 : 0;
                  if (t0) return t0;
                  var o0 = 0 <= c0 ? l[4] : l[3], l = o0;
                }
              }
              function x(e0, x0) {
                if (typeof x0 == "number") return st;
                if (x0[0] === 0) return o(t[1], e0, x0[1]) === 0 ? st : x0;
                var l = x0[4], c0 = x0[3], t0 = x0[2], o0 = o(t[1], e0, t0);
                if (o0 === 0) {
                  if (typeof c0 == "number") return l;
                  if (typeof l == "number") return c0;
                  var w0 = ZD(l);
                  return ki(c0, Pl(l), w0);
                }
                if (0 <= o0) {
                  var _0 = x(e0, l);
                  return l === _0 ? x0 : ki(c0, t0, _0);
                }
                var E0 = x(e0, c0);
                return c0 === E0 ? x0 : ki(E0, t0, l);
              }
              function c(e0, x0) {
                if (typeof e0 == "number") return x0;
                if (e0[0] === 1) {
                  var l = e0[2], c0 = e0[1];
                  if (typeof x0 != "number") {
                    if (x0[0] === 0) return n(x0[1], e0);
                    var t0 = x0[2], o0 = x0[1];
                    if (o0 <= c0) {
                      if (o0 === 1) return n(t0, e0);
                      var w0 = e(l, x0), _0 = c(e0[4], w0[3]);
                      return Vu(c(e0[3], w0[1]), l, _0);
                    }
                    if (c0 === 1) return n(l, x0);
                    var E0 = e(t0, e0), U0 = c(E0[3], x0[4]);
                    return Vu(c(E0[1], x0[3]), t0, U0);
                  }
                }
                return typeof x0 == "number" ? e0 : n(e0[1], x0);
              }
              function s(e0, x0) {
                if (typeof e0 == "number" || typeof x0 == "number") return st;
                if (typeof e0 != "number" && e0[0] !== 0) {
                  var l = e0[4], c0 = e0[3], t0 = e0[2], o0 = e(t0, x0), w0 = o0[1];
                  if (o0[2]) {
                    var _0 = s(l, o0[3]);
                    return Vu(s(c0, w0), t0, _0);
                  }
                  var E0 = s(l, o0[3]);
                  return Dl(s(c0, w0), E0);
                }
                return i(e0[1], x0) ? e0 : st;
              }
              function p(e0, x0) {
                if (typeof x0 == "number") return [0, st, function(s0) {
                  return st;
                }];
                if (x0[0] === 0) return o(t[1], e0, x0[1]) === 0 ? 0 : [0, st, function(s0) {
                  return st;
                }];
                var l = x0[4], c0 = x0[3], t0 = x0[2], o0 = o(t[1], e0, t0);
                if (o0 === 0) return 0;
                if (0 <= o0) {
                  var w0 = p(e0, l);
                  if (w0) var _0 = w0[2], E0 = [0, Vu(c0, t0, w0[1]), _0];
                  else var E0 = w0;
                  return E0;
                }
                var U0 = p(e0, c0);
                if (U0) var b = U0[2], R0 = function(s0) {
                  return Vu(u(b, 0), t0, l);
                }, X = [0, U0[1], R0];
                else var X = U0;
                return X;
              }
              function y(e0, x0) {
                for (var l = e0, c0 = x0; ; ) {
                  if (typeof l != "number" && typeof c0 != "number") {
                    var t0 = 0;
                    if (typeof l != "number" && l[0] !== 0) {
                      if (typeof c0 != "number" && c0[0] !== 0) {
                        if (l === c0) return 0;
                        var o0 = p(l[2], c0);
                        if (o0) {
                          var w0 = y(l[3], o0[1]);
                          if (w0) {
                            var _0 = u(o0[2], 0), l = l[4], c0 = _0;
                            continue;
                          }
                          var E0 = w0;
                        } else var E0 = o0;
                        return E0;
                      }
                      var U0 = l, b = c0[1];
                      t0 = 1;
                    }
                    if (!t0) var U0 = c0, b = l[1];
                    return 1 - i(b, U0);
                  }
                  return 1;
                }
              }
              function T(e0, x0) {
                if (typeof e0 == "number") return st;
                if (typeof x0 == "number") return e0;
                if (typeof e0 != "number" && e0[0] !== 0) {
                  var l = e0[4], c0 = e0[3], t0 = e0[2], o0 = e(t0, x0), w0 = o0[1];
                  if (o0[2]) {
                    var _0 = T(l, o0[3]);
                    return Dl(T(c0, w0), _0);
                  }
                  var E0 = T(l, o0[3]);
                  return Vu(T(c0, w0), t0, E0);
                }
                return i(e0[1], x0) ? st : e0;
              }
              function E(e0, x0) {
                for (var l = Jv(x0, 0), c0 = Jv(e0, 0), t0 = l; ; ) {
                  if (c0) {
                    if (t0) {
                      var o0 = o(t[1], c0[1], t0[1]);
                      if (o0 === 0) {
                        var w0 = Jv(t0[2], t0[3]), c0 = Jv(c0[2], c0[3]), t0 = w0;
                        continue;
                      }
                      return o0;
                    }
                    return 1;
                  }
                  var _0 = t0 && -1;
                  return _0;
                }
              }
              function d(e0, x0) {
                return E(e0, x0) === 0 ? 1 : 0;
              }
              function w(e0, x0) {
                for (var l = e0, c0 = x0; ; ) {
                  if (typeof l == "number") return 1;
                  if (l[0] === 0) {
                    var t0 = l[1];
                    if (typeof c0 != "number") {
                      if (c0[0] === 0) {
                        var o0 = o(t[1], t0, c0[1]) === 0 ? 1 : 0, w0 = o0 && 1;
                        return w0;
                      }
                      var _0 = o(t[1], t0, c0[2]);
                      if (_0 === 0) return 1;
                      if (0 <= _0) {
                        var c0 = c0[4];
                        continue;
                      }
                      var c0 = c0[3];
                      continue;
                    }
                  } else {
                    var E0 = l[4], U0 = l[3], b = l[2];
                    if (typeof c0 != "number") {
                      if (c0[0] === 0) {
                        var R0 = l[1] === 1 ? 1 : 0, X = R0 && (o(t[1], b, c0[1]) === 0 ? 1 : 0);
                        return X;
                      }
                      var s0 = c0[4], hr = c0[3], Ar = o(t[1], b, c0[2]);
                      if (Ar === 0) {
                        var or = w(U0, hr);
                        if (or) {
                          var l = E0, c0 = s0;
                          continue;
                        }
                        return or;
                      }
                      if (0 <= Ar) {
                        var W0 = w(Y7(st, b, E0), s0);
                        if (W0) {
                          var l = U0;
                          continue;
                        }
                        return W0;
                      }
                      var Lr = w(Y7(U0, b, st), hr);
                      if (Lr) {
                        var l = E0;
                        continue;
                      }
                      return Lr;
                    }
                  }
                  return 0;
                }
              }
              function G(e0, x0) {
                for (var l = x0; ; ) {
                  if (typeof l == "number") return 0;
                  if (l[0] === 0) return u(e0, l[1]);
                  G(e0, l[3]), u(e0, l[2]);
                  var l = l[4];
                }
              }
              function A(e0, x0, l) {
                for (var c0 = x0, t0 = l; ; ) {
                  if (typeof c0 == "number") return t0;
                  if (c0[0] === 0) return o(e0, c0[1], t0);
                  var o0 = A(e0, c0[3], t0), w0 = o(e0, c0[2], o0), c0 = c0[4], t0 = w0;
                }
              }
              function S(e0, x0) {
                for (var l = x0; ; ) {
                  if (typeof l == "number") return 1;
                  if (l[0] === 0) return u(e0, l[1]);
                  var c0 = u(e0, l[2]);
                  if (c0) {
                    var t0 = S(e0, l[3]);
                    if (t0) {
                      var l = l[4];
                      continue;
                    }
                    var o0 = t0;
                  } else var o0 = c0;
                  return o0;
                }
              }
              function M(e0, x0) {
                for (var l = x0; ; ) {
                  if (typeof l == "number") return 0;
                  if (l[0] === 0) return u(e0, l[1]);
                  var c0 = u(e0, l[2]);
                  if (c0) var t0 = c0;
                  else {
                    var o0 = M(e0, l[3]);
                    if (!o0) {
                      var l = l[4];
                      continue;
                    }
                    var t0 = o0;
                  }
                  return t0;
                }
              }
              function K(e0, x0) {
                if (typeof x0 == "number") return st;
                if (x0[0] === 0) return u(e0, x0[1]) ? x0 : st;
                var l = x0[4], c0 = x0[3], t0 = x0[2], o0 = K(e0, c0), w0 = u(e0, t0), _0 = K(e0, l);
                return w0 ? c0 === o0 && l === _0 ? x0 : Vu(o0, t0, _0) : Dl(o0, _0);
              }
              function V(e0, x0) {
                if (typeof x0 == "number") return [0, st, st];
                if (x0[0] === 0) return u(e0, x0[1]) ? [0, x0, st] : [0, st, x0];
                var l = x0[2], c0 = V(e0, x0[3]), t0 = c0[2], o0 = c0[1], w0 = u(e0, l), _0 = V(e0, x0[4]), E0 = _0[2], U0 = _0[1];
                if (w0) {
                  var b = Dl(t0, E0);
                  return [0, Vu(o0, l, U0), b];
                }
                var R0 = Vu(t0, l, E0);
                return [0, Dl(o0, U0), R0];
              }
              function f0(e0, x0) {
                for (var l = x0; ; ) {
                  if (typeof l == "number") throw Jt;
                  if (l[0] === 0) {
                    var c0 = l[1];
                    if (o(t[1], e0, c0) === 0) return c0;
                    throw Jt;
                  }
                  var t0 = l[2], o0 = o(t[1], e0, t0);
                  if (o0 === 0) return t0;
                  var w0 = 0 <= o0 ? l[4] : l[3], l = w0;
                }
              }
              function m0(e0, x0) {
                for (var l = x0; ; ) {
                  if (typeof l == "number") return 0;
                  if (l[0] === 0) {
                    var c0 = l[1], t0 = o(t[1], e0, c0) === 0 ? 1 : 0, o0 = t0 && [0, c0];
                    return o0;
                  }
                  var w0 = l[2], _0 = o(t[1], e0, w0);
                  if (_0 === 0) return [0, w0];
                  var E0 = 0 <= _0 ? l[4] : l[3], l = E0;
                }
              }
              function k0(e0, x0) {
                if (typeof x0 == "number") return st;
                if (x0[0] === 0) {
                  var l = x0[1], c0 = u(e0, l);
                  return l === c0 ? x0 : [0, c0];
                }
                var t0 = x0[4], o0 = x0[3], w0 = x0[2], _0 = k0(e0, o0), E0 = u(e0, w0), U0 = k0(e0, t0);
                if (o0 === _0 && w0 === E0 && t0 === U0) return x0;
                var b = 0;
                if (!rL(_0)) {
                  var R0 = Q00(_0);
                  0 <= o(t[1], R0, E0) && (b = 1);
                }
                if (!b) {
                  var X = 0;
                  if (!rL(U0)) {
                    var s0 = Pl(U0);
                    0 <= o(t[1], E0, s0) && (X = 1);
                  }
                  if (!X) return Vu(_0, E0, U0);
                }
                return c(_0, n(E0, U0));
              }
              function g0(e0) {
                if (e0) {
                  var x0 = e0[2], l = e0[1];
                  if (x0) {
                    var c0 = x0[2], t0 = x0[1];
                    if (c0) {
                      var o0 = c0[2], w0 = c0[1];
                      if (o0) {
                        var _0 = o0[2], E0 = o0[1];
                        if (_0) {
                          if (_0[2]) {
                            var U0 = t[1], b = function(or, W0) {
                              if (or === 2) {
                                if (W0) {
                                  var Lr = W0[2];
                                  if (Lr) {
                                    var Tr = Lr[1], Hr = W0[1], Or = Lr[2], fr = o(U0, Hr, Tr), Rr = fr === 0 ? [0, Hr, 0] : 0 < fr ? [0, Hr, [0, Tr, 0]] : [0, Tr, [0, Hr, 0]];
                                    return [0, Rr, Or];
                                  }
                                }
                              } else if (or === 3 && W0) {
                                var Wr = W0[2];
                                if (Wr) {
                                  var Jr = Wr[2];
                                  if (Jr) {
                                    var ar = Jr[1], _r = Wr[1], Ir = W0[1], fe = Jr[2], v0 = o(U0, Ir, _r);
                                    if (v0 === 0) var P = o(U0, _r, ar), L = P === 0 ? [0, _r, 0] : 0 < P ? [0, _r, [0, ar, 0]] : [0, ar, [0, _r, 0]], Q = L;
                                    else if (0 < v0) {
                                      var i0 = o(U0, _r, ar);
                                      if (i0 === 0) var T0 = [0, Ir, [0, _r, 0]];
                                      else if (0 < i0) var T0 = [0, Ir, [0, _r, [0, ar, 0]]];
                                      else var l0 = o(U0, Ir, ar), S0 = l0 === 0 ? [0, Ir, [0, _r, 0]] : 0 < l0 ? [0, Ir, [0, ar, [0, _r, 0]]] : [0, ar, [0, Ir, [0, _r, 0]]], T0 = S0;
                                      var Q = T0;
                                    } else {
                                      var rr = o(U0, Ir, ar);
                                      if (rr === 0) var Z = [0, _r, [0, Ir, 0]];
                                      else if (0 < rr) var Z = [0, _r, [0, Ir, [0, ar, 0]]];
                                      else var L0 = o(U0, _r, ar), B = L0 === 0 ? [0, _r, [0, Ir, 0]] : 0 < L0 ? [0, _r, [0, ar, [0, Ir, 0]]] : [0, ar, [0, _r, [0, Ir, 0]]], Z = B;
                                      var Q = Z;
                                    }
                                    return [0, Q, fe];
                                  }
                                }
                              }
                              for (var p0 = or >> 1, b0 = R0(p0, W0), O0 = b0[1], M0 = R0(or - p0 | 0, b0[2]), er = O0, yr = M0[1], vr = 0, $0 = M0[2]; ; ) {
                                if (er) {
                                  if (yr) {
                                    var Er = yr[2], Mr = yr[1], Br = er[2], qr = er[1], jr = o(U0, qr, Mr);
                                    if (jr === 0) {
                                      var er = Br, yr = Er, vr = [0, qr, vr];
                                      continue;
                                    }
                                    if (0 <= jr) {
                                      var yr = Er, vr = [0, Mr, vr];
                                      continue;
                                    }
                                    var er = Br, vr = [0, qr, vr];
                                    continue;
                                  }
                                  var $r = Lc(er, vr);
                                } else var $r = Lc(yr, vr);
                                return [0, $r, $0];
                              }
                            }, R0 = function(or, W0) {
                              if (or === 2) {
                                if (W0) {
                                  var Lr = W0[2];
                                  if (Lr) {
                                    var Tr = Lr[1], Hr = W0[1], Or = Lr[2], fr = o(U0, Hr, Tr), Rr = fr === 0 ? [0, Hr, 0] : 0 <= fr ? [0, Tr, [0, Hr, 0]] : [0, Hr, [0, Tr, 0]];
                                    return [0, Rr, Or];
                                  }
                                }
                              } else if (or === 3 && W0) {
                                var Wr = W0[2];
                                if (Wr) {
                                  var Jr = Wr[2];
                                  if (Jr) {
                                    var ar = Jr[1], _r = Wr[1], Ir = W0[1], fe = Jr[2], v0 = o(U0, Ir, _r);
                                    if (v0 === 0) var P = o(U0, _r, ar), L = P === 0 ? [0, _r, 0] : 0 <= P ? [0, ar, [0, _r, 0]] : [0, _r, [0, ar, 0]], Q = L;
                                    else if (0 <= v0) {
                                      var i0 = o(U0, Ir, ar);
                                      if (i0 === 0) var T0 = [0, _r, [0, Ir, 0]];
                                      else if (0 <= i0) var l0 = o(U0, _r, ar), S0 = l0 === 0 ? [0, _r, [0, Ir, 0]] : 0 <= l0 ? [0, ar, [0, _r, [0, Ir, 0]]] : [0, _r, [0, ar, [0, Ir, 0]]], T0 = S0;
                                      else var T0 = [0, _r, [0, Ir, [0, ar, 0]]];
                                      var Q = T0;
                                    } else {
                                      var rr = o(U0, _r, ar);
                                      if (rr === 0) var Z = [0, Ir, [0, _r, 0]];
                                      else if (0 <= rr) var L0 = o(U0, Ir, ar), B = L0 === 0 ? [0, Ir, [0, _r, 0]] : 0 <= L0 ? [0, ar, [0, Ir, [0, _r, 0]]] : [0, Ir, [0, ar, [0, _r, 0]]], Z = B;
                                      else var Z = [0, Ir, [0, _r, [0, ar, 0]]];
                                      var Q = Z;
                                    }
                                    return [0, Q, fe];
                                  }
                                }
                              }
                              for (var p0 = or >> 1, b0 = b(p0, W0), O0 = b0[1], M0 = b(or - p0 | 0, b0[2]), er = O0, yr = M0[1], vr = 0, $0 = M0[2]; ; ) {
                                if (er) {
                                  if (yr) {
                                    var Er = yr[2], Mr = yr[1], Br = er[2], qr = er[1], jr = o(U0, qr, Mr);
                                    if (jr === 0) {
                                      var er = Br, yr = Er, vr = [0, qr, vr];
                                      continue;
                                    }
                                    if (0 < jr) {
                                      var er = Br, vr = [0, qr, vr];
                                      continue;
                                    }
                                    var yr = Er, vr = [0, Mr, vr];
                                    continue;
                                  }
                                  var $r = Lc(er, vr);
                                } else var $r = Lc(yr, vr);
                                return [0, $r, $0];
                              }
                            }, X = Dc(e0), s0 = 2 <= X ? R0(X, e0)[1] : e0, hr = function(or, W0) {
                              if (!(3 < or >>> 0)) switch (or) {
                                case 0:
                                  return [0, 0, W0];
                                case 1:
                                  if (W0) return [0, [0, W0[1]], W0[2]];
                                  break;
                                case 2:
                                  if (W0) {
                                    var Lr = W0[2];
                                    if (Lr) return [0, [1, 2, Lr[1], [0, W0[1]], 0], Lr[2]];
                                  }
                                  break;
                                default:
                                  if (W0) {
                                    var Tr = W0[2];
                                    if (Tr) {
                                      var Hr = Tr[2];
                                      if (Hr) return [0, [1, 2, Tr[1], [0, W0[1]], [0, Hr[1]]], Hr[2]];
                                    }
                                  }
                              }
                              var Or = or / 2 | 0, fr = hr(Or, W0), Rr = fr[2];
                              if (Rr) {
                                var Wr = hr((or - Or | 0) - 1 | 0, Rr[2]), Jr = Wr[2];
                                return [0, Ns(fr[1], Rr[1], Wr[1]), Jr];
                              }
                              throw [0, Sn, Kpr];
                            };
                            return hr(Dc(s0), s0)[1];
                          }
                          var Ar = n(E0, n(w0, n(t0, [0, l])));
                          return n(_0[1], Ar);
                        }
                        return n(E0, n(w0, n(t0, [0, l])));
                      }
                      return n(w0, n(t0, [0, l]));
                    }
                    return n(t0, [0, l]);
                  }
                  return [0, l];
                }
                return st;
              }
              return [0, st, rL, i, n, Iee, x, c, s, y, T, E, d, w, G, k0, A, S, M, K, V, QD, er0, Pl, Z00, Q00, Aee, Pl, Z00, f0, m0, Oee, g0, function(e0, x0, l) {
                u(f(x0), Xpr);
                var c0 = er0(l);
                c0 && u(f(x0), Ypr);
                var t0 = 0;
                return le(function(o0, w0) {
                  return o0 && u(f(x0), Hpr), o(e0, x0, w0), 1;
                }, t0, c0), c0 && u(f(x0), Vpr), u(f(x0), zpr);
              }, $D];
            }
            var nr0 = Wpr.slice();
            function nL(t) {
              for (var n = 0, e = nr0.length - 1 - 1 | 0; ; ) {
                if (e < n) return 0;
                var i = n + ((e - n | 0) / 2 | 0) | 0, x = nr0[1 + i];
                if (t < x[1]) {
                  var e = i - 1 | 0;
                  continue;
                }
                if (x[2] <= t) {
                  var n = i + 1 | 0;
                  continue;
                }
                return 1;
              }
            }
            var tr0 = function t(n, e) {
              return t.fun(n, e);
            };
            N(tr0, function(t, n) {
              if (typeof t == "number") {
                var e = t;
                if (55 <= e) switch (e) {
                  case 55:
                    if (typeof n == "number") {
                      var i = n !== 55 ? 1 : 0;
                      if (!i) return i;
                    }
                    break;
                  case 56:
                    if (typeof n == "number") {
                      var x = n !== 56 ? 1 : 0;
                      if (!x) return x;
                    }
                    break;
                  case 57:
                    if (typeof n == "number") {
                      var c = n !== 57 ? 1 : 0;
                      if (!c) return c;
                    }
                    break;
                  case 58:
                    if (typeof n == "number") {
                      var s = n !== 58 ? 1 : 0;
                      if (!s) return s;
                    }
                    break;
                  case 59:
                    if (typeof n == "number") {
                      var p = n !== 59 ? 1 : 0;
                      if (!p) return p;
                    }
                    break;
                  case 60:
                    if (typeof n == "number") {
                      var y = n !== 60 ? 1 : 0;
                      if (!y) return y;
                    }
                    break;
                  case 61:
                    if (typeof n == "number") {
                      var T = n !== 61 ? 1 : 0;
                      if (!T) return T;
                    }
                    break;
                  case 62:
                    if (typeof n == "number") {
                      var E = n !== 62 ? 1 : 0;
                      if (!E) return E;
                    }
                    break;
                  case 63:
                    if (typeof n == "number") {
                      var d = n !== 63 ? 1 : 0;
                      if (!d) return d;
                    }
                    break;
                  case 64:
                    if (typeof n == "number") {
                      var w = n !== 64 ? 1 : 0;
                      if (!w) return w;
                    }
                    break;
                  case 65:
                    if (typeof n == "number") {
                      var G = n !== 65 ? 1 : 0;
                      if (!G) return G;
                    }
                    break;
                  case 66:
                    if (typeof n == "number") {
                      var A = n !== 66 ? 1 : 0;
                      if (!A) return A;
                    }
                    break;
                  case 67:
                    if (typeof n == "number") {
                      var S = n !== 67 ? 1 : 0;
                      if (!S) return S;
                    }
                    break;
                  case 68:
                    if (typeof n == "number") {
                      var M = n !== 68 ? 1 : 0;
                      if (!M) return M;
                    }
                    break;
                  case 69:
                    if (typeof n == "number") {
                      var K = n !== 69 ? 1 : 0;
                      if (!K) return K;
                    }
                    break;
                  case 70:
                    if (typeof n == "number") {
                      var V = n !== 70 ? 1 : 0;
                      if (!V) return V;
                    }
                    break;
                  case 71:
                    if (typeof n == "number") {
                      var f0 = n !== 71 ? 1 : 0;
                      if (!f0) return f0;
                    }
                    break;
                  case 72:
                    if (typeof n == "number") {
                      var m0 = n !== 72 ? 1 : 0;
                      if (!m0) return m0;
                    }
                    break;
                  case 73:
                    if (typeof n == "number") {
                      var k0 = n !== 73 ? 1 : 0;
                      if (!k0) return k0;
                    }
                    break;
                  case 74:
                    if (typeof n == "number") {
                      var g0 = n !== 74 ? 1 : 0;
                      if (!g0) return g0;
                    }
                    break;
                  case 75:
                    if (typeof n == "number") {
                      var e0 = n !== 75 ? 1 : 0;
                      if (!e0) return e0;
                    }
                    break;
                  case 76:
                    if (typeof n == "number") {
                      var x0 = n !== 76 ? 1 : 0;
                      if (!x0) return x0;
                    }
                    break;
                  case 77:
                    if (typeof n == "number") {
                      var l = n !== 77 ? 1 : 0;
                      if (!l) return l;
                    }
                    break;
                  case 78:
                    if (typeof n == "number") {
                      var c0 = n !== 78 ? 1 : 0;
                      if (!c0) return c0;
                    }
                    break;
                  case 79:
                    if (typeof n == "number") {
                      var t0 = n !== 79 ? 1 : 0;
                      if (!t0) return t0;
                    }
                    break;
                  case 80:
                    if (typeof n == "number") {
                      var o0 = n !== 80 ? 1 : 0;
                      if (!o0) return o0;
                    }
                    break;
                  case 81:
                    if (typeof n == "number") {
                      var w0 = n !== 81 ? 1 : 0;
                      if (!w0) return w0;
                    }
                    break;
                  case 82:
                    if (typeof n == "number") {
                      var _0 = n !== 82 ? 1 : 0;
                      if (!_0) return _0;
                    }
                    break;
                  case 83:
                    if (typeof n == "number") {
                      var E0 = n !== 83 ? 1 : 0;
                      if (!E0) return E0;
                    }
                    break;
                  case 84:
                    if (typeof n == "number") {
                      var U0 = n !== 84 ? 1 : 0;
                      if (!U0) return U0;
                    }
                    break;
                  case 85:
                    if (typeof n == "number") {
                      var b = n !== 85 ? 1 : 0;
                      if (!b) return b;
                    }
                    break;
                  case 86:
                    if (typeof n == "number") {
                      var R0 = n !== 86 ? 1 : 0;
                      if (!R0) return R0;
                    }
                    break;
                  case 87:
                    if (typeof n == "number") {
                      var X = n !== 87 ? 1 : 0;
                      if (!X) return X;
                    }
                    break;
                  case 88:
                    if (typeof n == "number") {
                      var s0 = n !== 88 ? 1 : 0;
                      if (!s0) return s0;
                    }
                    break;
                  case 89:
                    if (typeof n == "number") {
                      var hr = n !== 89 ? 1 : 0;
                      if (!hr) return hr;
                    }
                    break;
                  case 90:
                    if (typeof n == "number") {
                      var Ar = n !== 90 ? 1 : 0;
                      if (!Ar) return Ar;
                    }
                    break;
                  case 91:
                    if (typeof n == "number") {
                      var or = n !== 91 ? 1 : 0;
                      if (!or) return or;
                    }
                    break;
                  case 92:
                    if (typeof n == "number") {
                      var W0 = n !== 92 ? 1 : 0;
                      if (!W0) return W0;
                    }
                    break;
                  case 93:
                    if (typeof n == "number") {
                      var Lr = n !== 93 ? 1 : 0;
                      if (!Lr) return Lr;
                    }
                    break;
                  case 94:
                    if (typeof n == "number") {
                      var Tr = n !== 94 ? 1 : 0;
                      if (!Tr) return Tr;
                    }
                    break;
                  case 95:
                    if (typeof n == "number") {
                      var Hr = n !== 95 ? 1 : 0;
                      if (!Hr) return Hr;
                    }
                    break;
                  case 96:
                    if (typeof n == "number") {
                      var Or = n !== 96 ? 1 : 0;
                      if (!Or) return Or;
                    }
                    break;
                  case 97:
                    if (typeof n == "number") {
                      var fr = n !== 97 ? 1 : 0;
                      if (!fr) return fr;
                    }
                    break;
                  case 98:
                    if (typeof n == "number") {
                      var Rr = n !== 98 ? 1 : 0;
                      if (!Rr) return Rr;
                    }
                    break;
                  case 99:
                    if (typeof n == "number") {
                      var Wr = n !== 99 ? 1 : 0;
                      if (!Wr) return Wr;
                    }
                    break;
                  case 100:
                    if (typeof n == "number") {
                      var Jr = ti !== n ? 1 : 0;
                      if (!Jr) return Jr;
                    }
                    break;
                  case 101:
                    if (typeof n == "number") {
                      var ar = R7 !== n ? 1 : 0;
                      if (!ar) return ar;
                    }
                    break;
                  case 102:
                    if (typeof n == "number") {
                      var _r = Ri !== n ? 1 : 0;
                      if (!_r) return _r;
                    }
                    break;
                  case 103:
                    if (typeof n == "number") {
                      var Ir = s7 !== n ? 1 : 0;
                      if (!Ir) return Ir;
                    }
                    break;
                  case 104:
                    if (typeof n == "number") {
                      var fe = L7 !== n ? 1 : 0;
                      if (!fe) return fe;
                    }
                    break;
                  case 105:
                    if (typeof n == "number") {
                      var v0 = j7 !== n ? 1 : 0;
                      if (!v0) return v0;
                    }
                    break;
                  case 106:
                    if (typeof n == "number") {
                      var P = Yt !== n ? 1 : 0;
                      if (!P) return P;
                    }
                    break;
                  case 107:
                    if (typeof n == "number") {
                      var L = Zc !== n ? 1 : 0;
                      if (!L) return L;
                    }
                    break;
                  default:
                    if (typeof n == "number" && is <= n) return 0;
                }
                else switch (e) {
                  case 0:
                    if (typeof n == "number" && !n) return n;
                    break;
                  case 1:
                    if (typeof n == "number") {
                      var Q = n !== 1 ? 1 : 0;
                      if (!Q) return Q;
                    }
                    break;
                  case 2:
                    if (typeof n == "number") {
                      var i0 = n !== 2 ? 1 : 0;
                      if (!i0) return i0;
                    }
                    break;
                  case 3:
                    if (typeof n == "number") {
                      var l0 = n !== 3 ? 1 : 0;
                      if (!l0) return l0;
                    }
                    break;
                  case 4:
                    if (typeof n == "number") {
                      var S0 = n !== 4 ? 1 : 0;
                      if (!S0) return S0;
                    }
                    break;
                  case 5:
                    if (typeof n == "number") {
                      var T0 = n !== 5 ? 1 : 0;
                      if (!T0) return T0;
                    }
                    break;
                  case 6:
                    if (typeof n == "number") {
                      var rr = n !== 6 ? 1 : 0;
                      if (!rr) return rr;
                    }
                    break;
                  case 7:
                    if (typeof n == "number") {
                      var L0 = n !== 7 ? 1 : 0;
                      if (!L0) return L0;
                    }
                    break;
                  case 8:
                    if (typeof n == "number") {
                      var B = n !== 8 ? 1 : 0;
                      if (!B) return B;
                    }
                    break;
                  case 9:
                    if (typeof n == "number") {
                      var Z = n !== 9 ? 1 : 0;
                      if (!Z) return Z;
                    }
                    break;
                  case 10:
                    if (typeof n == "number") {
                      var p0 = n !== 10 ? 1 : 0;
                      if (!p0) return p0;
                    }
                    break;
                  case 11:
                    if (typeof n == "number") {
                      var b0 = n !== 11 ? 1 : 0;
                      if (!b0) return b0;
                    }
                    break;
                  case 12:
                    if (typeof n == "number") {
                      var O0 = n !== 12 ? 1 : 0;
                      if (!O0) return O0;
                    }
                    break;
                  case 13:
                    if (typeof n == "number") {
                      var M0 = n !== 13 ? 1 : 0;
                      if (!M0) return M0;
                    }
                    break;
                  case 14:
                    if (typeof n == "number") {
                      var er = n !== 14 ? 1 : 0;
                      if (!er) return er;
                    }
                    break;
                  case 15:
                    if (typeof n == "number") {
                      var yr = n !== 15 ? 1 : 0;
                      if (!yr) return yr;
                    }
                    break;
                  case 16:
                    if (typeof n == "number") {
                      var vr = n !== 16 ? 1 : 0;
                      if (!vr) return vr;
                    }
                    break;
                  case 17:
                    if (typeof n == "number") {
                      var $0 = n !== 17 ? 1 : 0;
                      if (!$0) return $0;
                    }
                    break;
                  case 18:
                    if (typeof n == "number") {
                      var Er = n !== 18 ? 1 : 0;
                      if (!Er) return Er;
                    }
                    break;
                  case 19:
                    if (typeof n == "number") {
                      var Mr = n !== 19 ? 1 : 0;
                      if (!Mr) return Mr;
                    }
                    break;
                  case 20:
                    if (typeof n == "number") {
                      var Br = n !== 20 ? 1 : 0;
                      if (!Br) return Br;
                    }
                    break;
                  case 21:
                    if (typeof n == "number") {
                      var qr = n !== 21 ? 1 : 0;
                      if (!qr) return qr;
                    }
                    break;
                  case 22:
                    if (typeof n == "number") {
                      var jr = n !== 22 ? 1 : 0;
                      if (!jr) return jr;
                    }
                    break;
                  case 23:
                    if (typeof n == "number") {
                      var $r = n !== 23 ? 1 : 0;
                      if (!$r) return $r;
                    }
                    break;
                  case 24:
                    if (typeof n == "number") {
                      var ne = n !== 24 ? 1 : 0;
                      if (!ne) return ne;
                    }
                    break;
                  case 25:
                    if (typeof n == "number") {
                      var Qr = n !== 25 ? 1 : 0;
                      if (!Qr) return Qr;
                    }
                    break;
                  case 26:
                    if (typeof n == "number") {
                      var be = n !== 26 ? 1 : 0;
                      if (!be) return be;
                    }
                    break;
                  case 27:
                    if (typeof n == "number") {
                      var ae = n !== 27 ? 1 : 0;
                      if (!ae) return ae;
                    }
                    break;
                  case 28:
                    if (typeof n == "number") {
                      var pe = n !== 28 ? 1 : 0;
                      if (!pe) return pe;
                    }
                    break;
                  case 29:
                    if (typeof n == "number") {
                      var oe = n !== 29 ? 1 : 0;
                      if (!oe) return oe;
                    }
                    break;
                  case 30:
                    if (typeof n == "number") {
                      var ce = n !== 30 ? 1 : 0;
                      if (!ce) return ce;
                    }
                    break;
                  case 31:
                    if (typeof n == "number") {
                      var ge = n !== 31 ? 1 : 0;
                      if (!ge) return ge;
                    }
                    break;
                  case 32:
                    if (typeof n == "number") {
                      var q0 = n !== 32 ? 1 : 0;
                      if (!q0) return q0;
                    }
                    break;
                  case 33:
                    if (typeof n == "number") {
                      var Fr = n !== 33 ? 1 : 0;
                      if (!Fr) return Fr;
                    }
                    break;
                  case 34:
                    if (typeof n == "number") {
                      var _ = n !== 34 ? 1 : 0;
                      if (!_) return _;
                    }
                    break;
                  case 35:
                    if (typeof n == "number") {
                      var k = n !== 35 ? 1 : 0;
                      if (!k) return k;
                    }
                    break;
                  case 36:
                    if (typeof n == "number") {
                      var I = n !== 36 ? 1 : 0;
                      if (!I) return I;
                    }
                    break;
                  case 37:
                    if (typeof n == "number") {
                      var U = n !== 37 ? 1 : 0;
                      if (!U) return U;
                    }
                    break;
                  case 38:
                    if (typeof n == "number") {
                      var Y = n !== 38 ? 1 : 0;
                      if (!Y) return Y;
                    }
                    break;
                  case 39:
                    if (typeof n == "number") {
                      var y0 = n !== 39 ? 1 : 0;
                      if (!y0) return y0;
                    }
                    break;
                  case 40:
                    if (typeof n == "number") {
                      var P0 = n !== 40 ? 1 : 0;
                      if (!P0) return P0;
                    }
                    break;
                  case 41:
                    if (typeof n == "number") {
                      var I0 = n !== 41 ? 1 : 0;
                      if (!I0) return I0;
                    }
                    break;
                  case 42:
                    if (typeof n == "number") {
                      var D = n !== 42 ? 1 : 0;
                      if (!D) return D;
                    }
                    break;
                  case 43:
                    if (typeof n == "number") {
                      var u0 = n !== 43 ? 1 : 0;
                      if (!u0) return u0;
                    }
                    break;
                  case 44:
                    if (typeof n == "number") {
                      var X0 = n !== 44 ? 1 : 0;
                      if (!X0) return X0;
                    }
                    break;
                  case 45:
                    if (typeof n == "number") {
                      var J0 = n !== 45 ? 1 : 0;
                      if (!J0) return J0;
                    }
                    break;
                  case 46:
                    if (typeof n == "number") {
                      var ir = n !== 46 ? 1 : 0;
                      if (!ir) return ir;
                    }
                    break;
                  case 47:
                    if (typeof n == "number") {
                      var Q0 = n !== 47 ? 1 : 0;
                      if (!Q0) return Q0;
                    }
                    break;
                  case 48:
                    if (typeof n == "number") {
                      var F0 = n !== 48 ? 1 : 0;
                      if (!F0) return F0;
                    }
                    break;
                  case 49:
                    if (typeof n == "number") {
                      var Sr = n !== 49 ? 1 : 0;
                      if (!Sr) return Sr;
                    }
                    break;
                  case 50:
                    if (typeof n == "number") {
                      var mr = n !== 50 ? 1 : 0;
                      if (!mr) return mr;
                    }
                    break;
                  case 51:
                    if (typeof n == "number") {
                      var Cr = n !== 51 ? 1 : 0;
                      if (!Cr) return Cr;
                    }
                    break;
                  case 52:
                    if (typeof n == "number") {
                      var sr = n !== 52 ? 1 : 0;
                      if (!sr) return sr;
                    }
                    break;
                  case 53:
                    if (typeof n == "number") {
                      var Pr = n !== 53 ? 1 : 0;
                      if (!Pr) return Pr;
                    }
                    break;
                  default:
                    if (typeof n == "number") {
                      var K0 = n !== 54 ? 1 : 0;
                      if (!K0) return K0;
                    }
                }
              } else switch (t[0]) {
                case 0:
                  if (typeof n != "number" && n[0] === 0) {
                    var Ur = Ee(t[1], n[1]);
                    return Ur === 0 ? Ee(t[2], n[2]) : Ur;
                  }
                  break;
                case 1:
                  if (typeof n != "number" && n[0] === 1) {
                    var h0 = Ee(t[1], n[1]);
                    return h0 === 0 ? Ee(t[2], n[2]) : h0;
                  }
                  break;
                case 2:
                  if (typeof n != "number" && n[0] === 2) return Ee(t[1], n[1]);
                  break;
                case 3:
                  if (typeof n != "number" && n[0] === 3) {
                    var Kr = n[2], re = t[2], xe = Ee(t[1], n[1]);
                    if (xe === 0) {
                      if (re) return Kr ? Ee(re[1], Kr[1]) : 1;
                      var Re = Kr && -1;
                      return Re;
                    }
                    return xe;
                  }
                  break;
                case 4:
                  if (typeof n != "number" && n[0] === 4) return Ee(t[1], n[1]);
                  break;
                case 5:
                  if (typeof n != "number" && n[0] === 5) {
                    var ve = n[2], Ie = t[2], Ge = Ee(t[1], n[1]);
                    if (Ge === 0) {
                      if (Ie) if (ve) {
                        var Me = ve[1], an = Ie[1], We = 0;
                        switch (an) {
                          case 0:
                            if (Me) We = 1;
                            else var vn = Me;
                            break;
                          case 1:
                            var Ae = Me !== 1 ? 1 : 0;
                            if (Ae) We = 1;
                            else var vn = Ae;
                            break;
                          case 2:
                            var cn = Me !== 2 ? 1 : 0;
                            if (cn) We = 1;
                            else var vn = cn;
                            break;
                          default:
                            if (3 <= Me) var vn = 0;
                            else We = 1;
                        }
                        if (We) var rn = function(Ct) {
                          switch (Ct) {
                            case 0:
                              return 0;
                            case 1:
                              return 1;
                            case 2:
                              return 2;
                            default:
                              return 3;
                          }
                        }, kn = rn(Me), vn = Ac(rn(an), kn);
                        var Ne = vn;
                      } else var Ne = 1;
                      else var Ne = ve && -1;
                      return Ne === 0 ? Ee(t[3], n[3]) : Ne;
                    }
                    return Ge;
                  }
                  break;
                case 6:
                  if (typeof n != "number" && n[0] === 6) {
                    var Je = Ee(t[1], n[1]);
                    return Je === 0 ? Ee(t[2], n[2]) : Je;
                  }
                  break;
                case 7:
                  if (typeof n != "number" && n[0] === 7) return Ac(t[1], n[1]);
                  break;
                case 8:
                  if (typeof n != "number" && n[0] === 8) {
                    var en = Ee(t[1], n[1]);
                    return en === 0 ? Ee(t[2], n[2]) : en;
                  }
                  break;
                case 9:
                  if (typeof n != "number" && n[0] === 9) return Ee(t[1], n[1]);
                  break;
                case 10:
                  if (typeof n != "number" && n[0] === 10) return Ee(t[1], n[1]);
                  break;
                case 11:
                  if (typeof n != "number" && n[0] === 11) {
                    var _n = Ee(t[1], n[1]);
                    return _n === 0 ? Ee(t[2], n[2]) : _n;
                  }
                  break;
                case 12:
                  if (typeof n != "number" && n[0] === 12) {
                    var Cn = Ee(t[1], n[1]);
                    return Cn === 0 ? Ee(t[2], n[2]) : Cn;
                  }
                  break;
                case 13:
                  if (typeof n != "number" && n[0] === 13) return Ee(t[1], n[1]);
                  break;
                case 14:
                  if (typeof n != "number" && n[0] === 14) return Ac(t[1], n[1]);
                  break;
                case 15:
                  if (typeof n != "number" && n[0] === 15) return Ee(t[1], n[1]);
                  break;
                case 16:
                  if (typeof n != "number" && n[0] === 16) {
                    var Hn = Ee(t[1], n[1]);
                    return Hn === 0 ? Ee(t[2], n[2]) : Hn;
                  }
                  break;
                case 17:
                  if (typeof n != "number" && n[0] === 17) return Ee(t[1], n[1]);
                  break;
                case 18:
                  if (typeof n != "number" && n[0] === 18) return Ac(t[1], n[1]);
                  break;
                case 19:
                  if (typeof n != "number" && n[0] === 19) return Ee(t[1], n[1]);
                  break;
                case 20:
                  if (typeof n != "number" && n[0] === 20) return Ee(t[1], n[1]);
                  break;
                case 21:
                  if (typeof n != "number" && n[0] === 21) {
                    var Fn = Ee(t[1], n[1]);
                    if (Fn === 0) {
                      var vt = Ac(t[2], n[2]);
                      if (vt === 0) {
                        var Nt = Ac(t[3], n[3]);
                        return Nt === 0 ? Ac(t[4], n[4]) : Nt;
                      }
                      return vt;
                    }
                    return Fn;
                  }
                  break;
                case 22:
                  if (typeof n != "number" && n[0] === 22) return Ee(t[1], n[1]);
                  break;
                default:
                  if (typeof n != "number" && n[0] === 23) return Ee(t[1], n[1]);
              }
              function gt(qt) {
                if (typeof qt == "number") {
                  var Ft = qt;
                  if (55 <= Ft) switch (Ft) {
                    case 55:
                      return 72;
                    case 56:
                      return 73;
                    case 57:
                      return 74;
                    case 58:
                      return 76;
                    case 59:
                      return 77;
                    case 60:
                      return 78;
                    case 61:
                      return 80;
                    case 62:
                      return 81;
                    case 63:
                      return 82;
                    case 64:
                      return 83;
                    case 65:
                      return 84;
                    case 66:
                      return 85;
                    case 67:
                      return 86;
                    case 68:
                      return 87;
                    case 69:
                      return 88;
                    case 70:
                      return 89;
                    case 71:
                      return 90;
                    case 72:
                      return 91;
                    case 73:
                      return 92;
                    case 74:
                      return 93;
                    case 75:
                      return 94;
                    case 76:
                      return 96;
                    case 77:
                      return 97;
                    case 78:
                      return 98;
                    case 79:
                      return 99;
                    case 80:
                      return ti;
                    case 81:
                      return R7;
                    case 82:
                      return Ri;
                    case 83:
                      return s7;
                    case 84:
                      return L7;
                    case 85:
                      return j7;
                    case 86:
                      return Yt;
                    case 87:
                      return Zc;
                    case 88:
                      return Xt;
                    case 89:
                      return T7;
                    case 90:
                      return Pn;
                    case 91:
                      return t1;
                    case 92:
                      return Av;
                    case 93:
                      return f1;
                    case 94:
                      return A2;
                    case 95:
                      return z22;
                    case 96:
                      return Sv;
                    case 97:
                      return uc;
                    case 98:
                      return tl;
                    case 99:
                      return In;
                    case 100:
                      return ts;
                    case 101:
                      return br;
                    case 102:
                      return IX;
                    case 103:
                      return zn;
                    case 104:
                      return jt;
                    case 105:
                      return JY;
                    case 106:
                      return zw;
                    case 107:
                      return Jg;
                    default:
                      return BH;
                  }
                  switch (Ft) {
                    case 0:
                      return 4;
                    case 1:
                      return 8;
                    case 2:
                      return 15;
                    case 3:
                      return 16;
                    case 4:
                      return 17;
                    case 5:
                      return 18;
                    case 6:
                      return 19;
                    case 7:
                      return 20;
                    case 8:
                      return 21;
                    case 9:
                      return 22;
                    case 10:
                      return 23;
                    case 11:
                      return 24;
                    case 12:
                      return 25;
                    case 13:
                      return 26;
                    case 14:
                      return 27;
                    case 15:
                      return 28;
                    case 16:
                      return 29;
                    case 17:
                      return 30;
                    case 18:
                      return 31;
                    case 19:
                      return 32;
                    case 20:
                      return 33;
                    case 21:
                      return 34;
                    case 22:
                      return 35;
                    case 23:
                      return 36;
                    case 24:
                      return 37;
                    case 25:
                      return 39;
                    case 26:
                      return 40;
                    case 27:
                      return 41;
                    case 28:
                      return 42;
                    case 29:
                      return 43;
                    case 30:
                      return 45;
                    case 31:
                      return 46;
                    case 32:
                      return 47;
                    case 33:
                      return 48;
                    case 34:
                      return 51;
                    case 35:
                      return 52;
                    case 36:
                      return 53;
                    case 37:
                      return 54;
                    case 38:
                      return 55;
                    case 39:
                      return 56;
                    case 40:
                      return 57;
                    case 41:
                      return 58;
                    case 42:
                      return 59;
                    case 43:
                      return 60;
                    case 44:
                      return 61;
                    case 45:
                      return 62;
                    case 46:
                      return 63;
                    case 47:
                      return 64;
                    case 48:
                      return 65;
                    case 49:
                      return 66;
                    case 50:
                      return 67;
                    case 51:
                      return 68;
                    case 52:
                      return 69;
                    case 53:
                      return 70;
                    default:
                      return 71;
                  }
                } else switch (qt[0]) {
                  case 0:
                    return 0;
                  case 1:
                    return 1;
                  case 2:
                    return 2;
                  case 3:
                    return 3;
                  case 4:
                    return 5;
                  case 5:
                    return 6;
                  case 6:
                    return 7;
                  case 7:
                    return 9;
                  case 8:
                    return 10;
                  case 9:
                    return 11;
                  case 10:
                    return 12;
                  case 11:
                    return 13;
                  case 12:
                    return 14;
                  case 13:
                    return 38;
                  case 14:
                    return 44;
                  case 15:
                    return 49;
                  case 16:
                    return 50;
                  case 17:
                    return 75;
                  case 18:
                    return 79;
                  case 19:
                    return 95;
                  case 20:
                    return is;
                  case 21:
                    return Fv;
                  case 22:
                    return cf;
                  default:
                    return X2;
                }
              }
              var Zt = gt(n);
              return Ac(gt(t), Zt);
            });
            var Nee = [wt, Q9r, M7(0)];
            M7(0);
            var I1 = [wt, e_r, M7(0)], ur0 = 0, ir0 = 0, fr0 = 0, xr0 = 0, or0 = 0, ar0 = 0, cr0 = 0, sr0 = 0, vr0 = 0, lr0 = 0;
            function j(t) {
              if (t[3] === t[2]) return -1;
              var n = t[1][1 + t[3]];
              return t[3] = t[3] + 1 | 0, n === 10 && (t[5] !== 0 && (t[5] = t[5] + 1 | 0), t[4] = t[3]), n;
            }
            function G0(t, n) {
              return t[9] = t[3], t[10] = t[4], t[11] = t[5], t[12] = n, 0;
            }
            function gn(t) {
              return t[6] = t[3], t[7] = t[4], t[8] = t[5], G0(t, -1);
            }
            function q(t) {
              return t[3] = t[9], t[4] = t[10], t[5] = t[11], t[12];
            }
            function $v(t) {
              return t[3] = t[6], t[4] = t[7], t[5] = t[8], 0;
            }
            function tL(t, n) {
              return t[6] = n, 0;
            }
            function Jm(t) {
              return t[3] - t[6] | 0;
            }
            function Ll(t) {
              var n = t[3] - t[6] | 0, e = t[6], i = t[1];
              return 0 <= e && 0 <= n && !((i.length - 1 - n | 0) < e) ? Ju0(i, e, n) : Pu(ki0);
            }
            function br0(t) {
              var n = t[6];
              return tu(t[1], n)[1 + n];
            }
            function Rl(t, n, e, i) {
              for (var x = 0, c = e, s = n; ; ) {
                if (0 < c) {
                  var p = t[1 + s];
                  if (0 <= p) {
                    if (zn < p) if (nX < p) if (U8 < p) {
                      if (lI < p) throw I1;
                      Jn(i, x, s1 | p >>> 18 | 0), Jn(i, x + 1 | 0, jt | (p >>> 12 | 0) & 63), Jn(i, x + 2 | 0, jt | (p >>> 6 | 0) & 63), Jn(i, x + 3 | 0, jt | p & 63);
                      var y = x + 4 | 0;
                    } else {
                      Jn(i, x, hv | p >>> 12 | 0), Jn(i, x + 1 | 0, jt | (p >>> 6 | 0) & 63), Jn(i, x + 2 | 0, jt | p & 63);
                      var y = x + 3 | 0;
                    }
                    else {
                      Jn(i, x, rt | p >>> 6 | 0), Jn(i, x + 1 | 0, jt | p & 63);
                      var y = x + 2 | 0;
                    }
                    else {
                      Jn(i, x, p);
                      var y = x + 1 | 0;
                    }
                    var x = y, c = c - 1 | 0, s = s + 1 | 0;
                    continue;
                  }
                  throw I1;
                }
                return x;
              }
            }
            function pr0(t) {
              for (var n = un(t), e = Gv(n, 0), i = 0, x = 0; ; ) {
                if (x < n) {
                  var c = Vr(t, x), s = 0;
                  if (rt <= c) if (s1 <= c) if (wt <= c) s = 1;
                  else {
                    var p = Vr(t, x + 1 | 0), y = Vr(t, x + 2 | 0), T = Vr(t, x + 3 | 0), E = (p >>> 6 | 0) !== 2 ? 1 : 0;
                    if (E) var w = E;
                    else var d = (y >>> 6 | 0) !== 2 ? 1 : 0, w = d || ((T >>> 6 | 0) !== 2 ? 1 : 0);
                    if (w) throw I1;
                    e[1 + i] = (c & 7) << 18 | (p & 63) << 12 | (y & 63) << 6 | T & 63;
                    var G = x + 4 | 0;
                  }
                  else if (hv <= c) {
                    var A = Vr(t, x + 1 | 0), S = Vr(t, x + 2 | 0), M = (c & 15) << 12 | (A & 63) << 6 | S & 63, K = (A >>> 6 | 0) !== 2 ? 1 : 0, V = K || ((S >>> 6 | 0) !== 2 ? 1 : 0);
                    if (V) var m0 = V;
                    else var f0 = 55296 <= M ? 1 : 0, m0 = f0 && (M <= 57088 ? 1 : 0);
                    if (m0) throw I1;
                    e[1 + i] = M;
                    var G = x + 3 | 0;
                  } else {
                    var k0 = Vr(t, x + 1 | 0);
                    if ((k0 >>> 6 | 0) !== 2) throw I1;
                    e[1 + i] = (c & 31) << 6 | k0 & 63;
                    var G = x + 2 | 0;
                  }
                  else if (jt <= c) s = 1;
                  else {
                    e[1 + i] = c;
                    var G = x + 1 | 0;
                  }
                  if (s) throw I1;
                  var i = i + 1 | 0, x = G;
                  continue;
                }
                return [0, e, i, lr0, vr0, sr0, cr0, ar0, or0, xr0, fr0, ir0, ur0];
              }
            }
            function jl(t, n, e) {
              var i = t[6] + n | 0, x = Lt(e * 4 | 0), c = t[1];
              if ((i + e | 0) <= c.length - 1) return qv(x, 0, Rl(c, i, e, x));
              throw [0, Sn, r_r];
            }
            function Se(t) {
              var n = t[6], e = t[3] - n | 0, i = Lt(e * 4 | 0);
              return qv(i, 0, Rl(t[1], n, e, i));
            }
            function Gl(t, n) {
              var e = t[6], i = t[3] - e | 0, x = Lt(i * 4 | 0);
              return sN(n, x, 0, Rl(t[1], e, i, x));
            }
            function uL(t) {
              var n = t.length - 1, e = Lt(n * 4 | 0);
              return qv(e, 0, Rl(t, 0, n, e));
            }
            function mr0(t, n) {
              return t[3] = t[3] - n | 0, 0;
            }
            var _r0 = 0;
            function Cee(t, n, e) {
              return [0, t, n, n_r, 0, e, _r0, t_r];
            }
            function yr0(t) {
              var n = t[2];
              return [0, t[1], [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12]], t[3], t[4], t[5], t[6], t[7]];
            }
            function hr0(t) {
              return t[3][1];
            }
            function $m(t, n) {
              return t !== n[4] ? [0, n[1], n[2], n[3], t, n[5], n[6], n[7]] : n;
            }
            var iL = function t(n, e) {
              return t.fun(n, e);
            }, dr0 = function t(n, e) {
              return t.fun(n, e);
            }, fL = function t(n, e) {
              return t.fun(n, e);
            }, xL = function t(n, e) {
              return t.fun(n, e);
            }, kr0 = function t(n, e) {
              return t.fun(n, e);
            };
            N(iL, function(t, n) {
              if (typeof t == "number") {
                var e = t;
                if (61 <= e) if (92 <= e) switch (e) {
                  case 92:
                    if (typeof n == "number" && n === 92) return 1;
                    break;
                  case 93:
                    if (typeof n == "number" && n === 93) return 1;
                    break;
                  case 94:
                    if (typeof n == "number" && n === 94) return 1;
                    break;
                  case 95:
                    if (typeof n == "number" && n === 95) return 1;
                    break;
                  case 96:
                    if (typeof n == "number" && n === 96) return 1;
                    break;
                  case 97:
                    if (typeof n == "number" && n === 97) return 1;
                    break;
                  case 98:
                    if (typeof n == "number" && n === 98) return 1;
                    break;
                  case 99:
                    if (typeof n == "number" && n === 99) return 1;
                    break;
                  case 100:
                    if (typeof n == "number" && ti === n) return 1;
                    break;
                  case 101:
                    if (typeof n == "number" && R7 === n) return 1;
                    break;
                  case 102:
                    if (typeof n == "number" && Ri === n) return 1;
                    break;
                  case 103:
                    if (typeof n == "number" && s7 === n) return 1;
                    break;
                  case 104:
                    if (typeof n == "number" && L7 === n) return 1;
                    break;
                  case 105:
                    if (typeof n == "number" && j7 === n) return 1;
                    break;
                  case 106:
                    if (typeof n == "number" && Yt === n) return 1;
                    break;
                  case 107:
                    if (typeof n == "number" && Zc === n) return 1;
                    break;
                  case 108:
                    if (typeof n == "number" && is === n) return 1;
                    break;
                  case 109:
                    if (typeof n == "number" && Fv === n) return 1;
                    break;
                  case 110:
                    if (typeof n == "number" && Xt === n) return 1;
                    break;
                  case 111:
                    if (typeof n == "number" && cf === n) return 1;
                    break;
                  case 112:
                    if (typeof n == "number" && T7 === n) return 1;
                    break;
                  case 113:
                    if (typeof n == "number" && Pn === n) return 1;
                    break;
                  case 114:
                    if (typeof n == "number" && t1 === n) return 1;
                    break;
                  case 115:
                    if (typeof n == "number" && Av === n) return 1;
                    break;
                  case 116:
                    if (typeof n == "number" && f1 === n) return 1;
                    break;
                  case 117:
                    if (typeof n == "number" && A2 === n) return 1;
                    break;
                  case 118:
                    if (typeof n == "number" && z22 === n) return 1;
                    break;
                  case 119:
                    if (typeof n == "number" && Sv === n) return 1;
                    break;
                  case 120:
                    if (typeof n == "number" && uc === n) return 1;
                    break;
                  default:
                    if (typeof n == "number" && tl <= n) return 1;
                }
                else switch (e) {
                  case 61:
                    if (typeof n == "number" && n === 61) return 1;
                    break;
                  case 62:
                    if (typeof n == "number" && n === 62) return 1;
                    break;
                  case 63:
                    if (typeof n == "number" && n === 63) return 1;
                    break;
                  case 64:
                    if (typeof n == "number" && n === 64) return 1;
                    break;
                  case 65:
                    if (typeof n == "number" && n === 65) return 1;
                    break;
                  case 66:
                    if (typeof n == "number" && n === 66) return 1;
                    break;
                  case 67:
                    if (typeof n == "number" && n === 67) return 1;
                    break;
                  case 68:
                    if (typeof n == "number" && n === 68) return 1;
                    break;
                  case 69:
                    if (typeof n == "number" && n === 69) return 1;
                    break;
                  case 70:
                    if (typeof n == "number" && n === 70) return 1;
                    break;
                  case 71:
                    if (typeof n == "number" && n === 71) return 1;
                    break;
                  case 72:
                    if (typeof n == "number" && n === 72) return 1;
                    break;
                  case 73:
                    if (typeof n == "number" && n === 73) return 1;
                    break;
                  case 74:
                    if (typeof n == "number" && n === 74) return 1;
                    break;
                  case 75:
                    if (typeof n == "number" && n === 75) return 1;
                    break;
                  case 76:
                    if (typeof n == "number" && n === 76) return 1;
                    break;
                  case 77:
                    if (typeof n == "number" && n === 77) return 1;
                    break;
                  case 78:
                    if (typeof n == "number" && n === 78) return 1;
                    break;
                  case 79:
                    if (typeof n == "number" && n === 79) return 1;
                    break;
                  case 80:
                    if (typeof n == "number" && n === 80) return 1;
                    break;
                  case 81:
                    if (typeof n == "number" && n === 81) return 1;
                    break;
                  case 82:
                    if (typeof n == "number" && n === 82) return 1;
                    break;
                  case 83:
                    if (typeof n == "number" && n === 83) return 1;
                    break;
                  case 84:
                    if (typeof n == "number" && n === 84) return 1;
                    break;
                  case 85:
                    if (typeof n == "number" && n === 85) return 1;
                    break;
                  case 86:
                    if (typeof n == "number" && n === 86) return 1;
                    break;
                  case 87:
                    if (typeof n == "number" && n === 87) return 1;
                    break;
                  case 88:
                    if (typeof n == "number" && n === 88) return 1;
                    break;
                  case 89:
                    if (typeof n == "number" && n === 89) return 1;
                    break;
                  case 90:
                    if (typeof n == "number" && n === 90) return 1;
                    break;
                  default:
                    if (typeof n == "number" && n === 91) return 1;
                }
                else if (31 <= e) switch (e) {
                  case 31:
                    if (typeof n == "number" && n === 31) return 1;
                    break;
                  case 32:
                    if (typeof n == "number" && n === 32) return 1;
                    break;
                  case 33:
                    if (typeof n == "number" && n === 33) return 1;
                    break;
                  case 34:
                    if (typeof n == "number" && n === 34) return 1;
                    break;
                  case 35:
                    if (typeof n == "number" && n === 35) return 1;
                    break;
                  case 36:
                    if (typeof n == "number" && n === 36) return 1;
                    break;
                  case 37:
                    if (typeof n == "number" && n === 37) return 1;
                    break;
                  case 38:
                    if (typeof n == "number" && n === 38) return 1;
                    break;
                  case 39:
                    if (typeof n == "number" && n === 39) return 1;
                    break;
                  case 40:
                    if (typeof n == "number" && n === 40) return 1;
                    break;
                  case 41:
                    if (typeof n == "number" && n === 41) return 1;
                    break;
                  case 42:
                    if (typeof n == "number" && n === 42) return 1;
                    break;
                  case 43:
                    if (typeof n == "number" && n === 43) return 1;
                    break;
                  case 44:
                    if (typeof n == "number" && n === 44) return 1;
                    break;
                  case 45:
                    if (typeof n == "number" && n === 45) return 1;
                    break;
                  case 46:
                    if (typeof n == "number" && n === 46) return 1;
                    break;
                  case 47:
                    if (typeof n == "number" && n === 47) return 1;
                    break;
                  case 48:
                    if (typeof n == "number" && n === 48) return 1;
                    break;
                  case 49:
                    if (typeof n == "number" && n === 49) return 1;
                    break;
                  case 50:
                    if (typeof n == "number" && n === 50) return 1;
                    break;
                  case 51:
                    if (typeof n == "number" && n === 51) return 1;
                    break;
                  case 52:
                    if (typeof n == "number" && n === 52) return 1;
                    break;
                  case 53:
                    if (typeof n == "number" && n === 53) return 1;
                    break;
                  case 54:
                    if (typeof n == "number" && n === 54) return 1;
                    break;
                  case 55:
                    if (typeof n == "number" && n === 55) return 1;
                    break;
                  case 56:
                    if (typeof n == "number" && n === 56) return 1;
                    break;
                  case 57:
                    if (typeof n == "number" && n === 57) return 1;
                    break;
                  case 58:
                    if (typeof n == "number" && n === 58) return 1;
                    break;
                  case 59:
                    if (typeof n == "number" && n === 59) return 1;
                    break;
                  default:
                    if (typeof n == "number" && n === 60) return 1;
                }
                else switch (e) {
                  case 0:
                    if (typeof n == "number" && !n) return 1;
                    break;
                  case 1:
                    if (typeof n == "number" && n === 1) return 1;
                    break;
                  case 2:
                    if (typeof n == "number" && n === 2) return 1;
                    break;
                  case 3:
                    if (typeof n == "number" && n === 3) return 1;
                    break;
                  case 4:
                    if (typeof n == "number" && n === 4) return 1;
                    break;
                  case 5:
                    if (typeof n == "number" && n === 5) return 1;
                    break;
                  case 6:
                    if (typeof n == "number" && n === 6) return 1;
                    break;
                  case 7:
                    if (typeof n == "number" && n === 7) return 1;
                    break;
                  case 8:
                    if (typeof n == "number" && n === 8) return 1;
                    break;
                  case 9:
                    if (typeof n == "number" && n === 9) return 1;
                    break;
                  case 10:
                    if (typeof n == "number" && n === 10) return 1;
                    break;
                  case 11:
                    if (typeof n == "number" && n === 11) return 1;
                    break;
                  case 12:
                    if (typeof n == "number" && n === 12) return 1;
                    break;
                  case 13:
                    if (typeof n == "number" && n === 13) return 1;
                    break;
                  case 14:
                    if (typeof n == "number" && n === 14) return 1;
                    break;
                  case 15:
                    if (typeof n == "number" && n === 15) return 1;
                    break;
                  case 16:
                    if (typeof n == "number" && n === 16) return 1;
                    break;
                  case 17:
                    if (typeof n == "number" && n === 17) return 1;
                    break;
                  case 18:
                    if (typeof n == "number" && n === 18) return 1;
                    break;
                  case 19:
                    if (typeof n == "number" && n === 19) return 1;
                    break;
                  case 20:
                    if (typeof n == "number" && n === 20) return 1;
                    break;
                  case 21:
                    if (typeof n == "number" && n === 21) return 1;
                    break;
                  case 22:
                    if (typeof n == "number" && n === 22) return 1;
                    break;
                  case 23:
                    if (typeof n == "number" && n === 23) return 1;
                    break;
                  case 24:
                    if (typeof n == "number" && n === 24) return 1;
                    break;
                  case 25:
                    if (typeof n == "number" && n === 25) return 1;
                    break;
                  case 26:
                    if (typeof n == "number" && n === 26) return 1;
                    break;
                  case 27:
                    if (typeof n == "number" && n === 27) return 1;
                    break;
                  case 28:
                    if (typeof n == "number" && n === 28) return 1;
                    break;
                  case 29:
                    if (typeof n == "number" && n === 29) return 1;
                    break;
                  default:
                    if (typeof n == "number" && n === 30) return 1;
                }
              } else switch (t[0]) {
                case 0:
                  if (typeof n != "number" && n[0] === 0) {
                    var i = n[1], x = u(u(fL, t[1]), i), c = x && qn(t[2], n[2]);
                    return c;
                  }
                  break;
                case 1:
                  if (typeof n != "number" && n[0] === 1) {
                    var s = n[1], p = u(u(xL, t[1]), s), y = p && qn(t[2], n[2]);
                    return y;
                  }
                  break;
                case 2:
                  if (typeof n != "number" && n[0] === 2) {
                    var T = n[1], E = t[1], d = Wv(E[1], T[1]), w = d && qn(E[2], T[2]), G = w && qn(E[3], T[3]), A = G && (E[4] === T[4] ? 1 : 0);
                    return A;
                  }
                  break;
                case 3:
                  if (typeof n != "number" && n[0] === 3) {
                    var S = n[1], M = t[1], K = Wv(M[1], S[1]);
                    if (K) var V = S[2], f0 = u(u(kr0, M[2]), V);
                    else var f0 = K;
                    var m0 = f0 && (M[3] === S[3] ? 1 : 0);
                    return m0;
                  }
                  break;
                case 4:
                  if (typeof n != "number" && n[0] === 4) {
                    var k0 = Wv(t[1], n[1]), g0 = k0 && qn(t[2], n[2]), e0 = g0 && qn(t[3], n[3]);
                    return e0;
                  }
                  break;
                case 5:
                  if (typeof n != "number" && n[0] === 5) {
                    var x0 = Wv(t[1], n[1]), l = x0 && qn(t[2], n[2]), c0 = l && qn(t[3], n[3]);
                    return c0;
                  }
                  break;
                case 6:
                  if (typeof n != "number" && n[0] === 6) return qn(t[1], n[1]);
                  break;
                case 7:
                  if (typeof n != "number" && n[0] === 7) {
                    var t0 = qn(t[1], n[1]);
                    return t0 && Wv(t[2], n[2]);
                  }
                  break;
                case 8:
                  if (typeof n != "number" && n[0] === 8) {
                    var o0 = Wv(t[1], n[1]), w0 = o0 && qn(t[2], n[2]), _0 = w0 && qn(t[3], n[3]);
                    return _0;
                  }
                  break;
                case 9:
                  if (typeof n != "number" && n[0] === 9) {
                    var E0 = n[1];
                    return u(u(dr0, t[1]), E0);
                  }
                  break;
                case 10:
                  if (typeof n != "number" && n[0] === 10) {
                    var U0 = n[1], b = u(u(fL, t[1]), U0), R0 = b && (t[2] == n[2] ? 1 : 0), X = R0 && qn(t[3], n[3]);
                    return X;
                  }
                  break;
                default:
                  if (typeof n != "number" && n[0] === 11) {
                    var s0 = n[1], hr = u(u(xL, t[1]), s0), Ar = hr && (t[2] == n[2] ? 1 : 0), or = Ar && qn(t[3], n[3]);
                    return or;
                  }
              }
              return 0;
            }), N(dr0, function(t, n) {
              if (t) {
                if (n) return 1;
              } else if (!n) return 1;
              return 0;
            }), N(fL, function(t, n) {
              switch (t) {
                case 0:
                  if (!n) return 1;
                  break;
                case 1:
                  if (n === 1) return 1;
                  break;
                case 2:
                  if (n === 2) return 1;
                  break;
                case 3:
                  if (n === 3) return 1;
                  break;
                default:
                  if (4 <= n) return 1;
              }
              return 0;
            }), N(xL, function(t, n) {
              switch (t) {
                case 0:
                  if (!n) return 1;
                  break;
                case 1:
                  if (n === 1) return 1;
                  break;
                default:
                  if (2 <= n) return 1;
              }
              return 0;
            }), N(kr0, function(t, n) {
              var e = qn(t[1], n[1]), i = e && qn(t[2], n[2]), x = i && qn(t[3], n[3]);
              return x;
            });
            function wr0(t) {
              if (typeof t == "number") {
                var n = t;
                if (61 <= n) {
                  if (92 <= n) switch (n) {
                    case 92:
                      return Ekr;
                    case 93:
                      return Skr;
                    case 94:
                      return gkr;
                    case 95:
                      return Fkr;
                    case 96:
                      return Tkr;
                    case 97:
                      return Okr;
                    case 98:
                      return Ikr;
                    case 99:
                      return Akr;
                    case 100:
                      return Nkr;
                    case 101:
                      return Ckr;
                    case 102:
                      return Pkr;
                    case 103:
                      return Dkr;
                    case 104:
                      return Lkr;
                    case 105:
                      return Rkr;
                    case 106:
                      return jkr;
                    case 107:
                      return Gkr;
                    case 108:
                      return Mkr;
                    case 109:
                      return Bkr;
                    case 110:
                      return qkr;
                    case 111:
                      return Ukr;
                    case 112:
                      return Hkr;
                    case 113:
                      return Xkr;
                    case 114:
                      return Ykr;
                    case 115:
                      return Vkr;
                    case 116:
                      return zkr;
                    case 117:
                      return Kkr;
                    case 118:
                      return Wkr;
                    case 119:
                      return Jkr;
                    case 120:
                      return $kr;
                    default:
                      return Zkr;
                  }
                  switch (n) {
                    case 61:
                      return Vdr;
                    case 62:
                      return zdr;
                    case 63:
                      return Kdr;
                    case 64:
                      return Wdr;
                    case 65:
                      return Jdr;
                    case 66:
                      return $dr;
                    case 67:
                      return Zdr;
                    case 68:
                      return Qdr;
                    case 69:
                      return rkr;
                    case 70:
                      return ekr;
                    case 71:
                      return nkr;
                    case 72:
                      return tkr;
                    case 73:
                      return ukr;
                    case 74:
                      return ikr;
                    case 75:
                      return fkr;
                    case 76:
                      return xkr;
                    case 77:
                      return okr;
                    case 78:
                      return akr;
                    case 79:
                      return ckr;
                    case 80:
                      return skr;
                    case 81:
                      return vkr;
                    case 82:
                      return lkr;
                    case 83:
                      return bkr;
                    case 84:
                      return pkr;
                    case 85:
                      return mkr;
                    case 86:
                      return _kr;
                    case 87:
                      return ykr;
                    case 88:
                      return hkr;
                    case 89:
                      return dkr;
                    case 90:
                      return kkr;
                    default:
                      return wkr;
                  }
                }
                if (31 <= n) switch (n) {
                  case 31:
                    return mdr;
                  case 32:
                    return _dr;
                  case 33:
                    return ydr;
                  case 34:
                    return hdr;
                  case 35:
                    return ddr;
                  case 36:
                    return kdr;
                  case 37:
                    return wdr;
                  case 38:
                    return Edr;
                  case 39:
                    return Sdr;
                  case 40:
                    return gdr;
                  case 41:
                    return Fdr;
                  case 42:
                    return Tdr;
                  case 43:
                    return Odr;
                  case 44:
                    return Idr;
                  case 45:
                    return Adr;
                  case 46:
                    return Ndr;
                  case 47:
                    return Cdr;
                  case 48:
                    return Pdr;
                  case 49:
                    return Ddr;
                  case 50:
                    return Ldr;
                  case 51:
                    return Rdr;
                  case 52:
                    return jdr;
                  case 53:
                    return Gdr;
                  case 54:
                    return Mdr;
                  case 55:
                    return Bdr;
                  case 56:
                    return qdr;
                  case 57:
                    return Udr;
                  case 58:
                    return Hdr;
                  case 59:
                    return Xdr;
                  default:
                    return Ydr;
                }
                switch (n) {
                  case 0:
                    return Mhr;
                  case 1:
                    return Bhr;
                  case 2:
                    return qhr;
                  case 3:
                    return Uhr;
                  case 4:
                    return Hhr;
                  case 5:
                    return Xhr;
                  case 6:
                    return Yhr;
                  case 7:
                    return Vhr;
                  case 8:
                    return zhr;
                  case 9:
                    return Khr;
                  case 10:
                    return Whr;
                  case 11:
                    return Jhr;
                  case 12:
                    return $hr;
                  case 13:
                    return Zhr;
                  case 14:
                    return Qhr;
                  case 15:
                    return rdr;
                  case 16:
                    return edr;
                  case 17:
                    return ndr;
                  case 18:
                    return tdr;
                  case 19:
                    return udr;
                  case 20:
                    return idr;
                  case 21:
                    return fdr;
                  case 22:
                    return xdr;
                  case 23:
                    return odr;
                  case 24:
                    return adr;
                  case 25:
                    return cdr;
                  case 26:
                    return sdr;
                  case 27:
                    return vdr;
                  case 28:
                    return ldr;
                  case 29:
                    return bdr;
                  default:
                    return pdr;
                }
              } else switch (t[0]) {
                case 0:
                  return Qkr;
                case 1:
                  return rwr;
                case 2:
                  return ewr;
                case 3:
                  return nwr;
                case 4:
                  return twr;
                case 5:
                  return uwr;
                case 6:
                  return iwr;
                case 7:
                  return fwr;
                case 8:
                  return xwr;
                case 9:
                  return owr;
                case 10:
                  return awr;
                default:
                  return cwr;
              }
            }
            function oL(t) {
              if (typeof t == "number") {
                var n = t;
                if (61 <= n) {
                  if (92 <= n) switch (n) {
                    case 92:
                      return ihr;
                    case 93:
                      return fhr;
                    case 94:
                      return xhr;
                    case 95:
                      return ohr;
                    case 96:
                      return ahr;
                    case 97:
                      return chr;
                    case 98:
                      return shr;
                    case 99:
                      return vhr;
                    case 100:
                      return lhr;
                    case 101:
                      return bhr;
                    case 102:
                      return phr;
                    case 103:
                      return mhr;
                    case 104:
                      return _hr;
                    case 105:
                      return yhr;
                    case 106:
                      return hhr;
                    case 107:
                      return dhr;
                    case 108:
                      return khr;
                    case 109:
                      return whr;
                    case 110:
                      return Ehr;
                    case 111:
                      return Shr;
                    case 112:
                      return ghr;
                    case 113:
                      return Fhr;
                    case 114:
                      return Thr;
                    case 115:
                      return Ohr;
                    case 116:
                      return Ihr;
                    case 117:
                      return Ahr;
                    case 118:
                      return Nhr;
                    case 119:
                      return Chr;
                    case 120:
                      return Phr;
                    default:
                      return Dhr;
                  }
                  switch (n) {
                    case 61:
                      return Oyr;
                    case 62:
                      return Iyr;
                    case 63:
                      return Ayr;
                    case 64:
                      return Nyr;
                    case 65:
                      return Cyr;
                    case 66:
                      return Pyr;
                    case 67:
                      return Dyr;
                    case 68:
                      return Lyr;
                    case 69:
                      return Ryr;
                    case 70:
                      return jyr;
                    case 71:
                      return Gyr;
                    case 72:
                      return Myr;
                    case 73:
                      return Byr;
                    case 74:
                      return qyr;
                    case 75:
                      return Uyr;
                    case 76:
                      return Hyr;
                    case 77:
                      return Xyr;
                    case 78:
                      return Yyr;
                    case 79:
                      return Vyr;
                    case 80:
                      return zyr;
                    case 81:
                      return Kyr;
                    case 82:
                      return Wyr;
                    case 83:
                      return Jyr;
                    case 84:
                      return $yr;
                    case 85:
                      return Zyr;
                    case 86:
                      return Qyr;
                    case 87:
                      return rhr;
                    case 88:
                      return ehr;
                    case 89:
                      return nhr;
                    case 90:
                      return thr;
                    default:
                      return uhr;
                  }
                }
                if (31 <= n) switch (n) {
                  case 31:
                    return Z_r;
                  case 32:
                    return Q_r;
                  case 33:
                    return ryr;
                  case 34:
                    return eyr;
                  case 35:
                    return nyr;
                  case 36:
                    return tyr;
                  case 37:
                    return uyr;
                  case 38:
                    return iyr;
                  case 39:
                    return fyr;
                  case 40:
                    return xyr;
                  case 41:
                    return oyr;
                  case 42:
                    return ayr;
                  case 43:
                    return cyr;
                  case 44:
                    return syr;
                  case 45:
                    return vyr;
                  case 46:
                    return lyr;
                  case 47:
                    return byr;
                  case 48:
                    return pyr;
                  case 49:
                    return myr;
                  case 50:
                    return _yr;
                  case 51:
                    return yyr;
                  case 52:
                    return hyr;
                  case 53:
                    return dyr;
                  case 54:
                    return kyr;
                  case 55:
                    return wyr;
                  case 56:
                    return Eyr;
                  case 57:
                    return Syr;
                  case 58:
                    return gyr;
                  case 59:
                    return Fyr;
                  default:
                    return Tyr;
                }
                switch (n) {
                  case 0:
                    return k_r;
                  case 1:
                    return w_r;
                  case 2:
                    return E_r;
                  case 3:
                    return S_r;
                  case 4:
                    return g_r;
                  case 5:
                    return F_r;
                  case 6:
                    return T_r;
                  case 7:
                    return O_r;
                  case 8:
                    return I_r;
                  case 9:
                    return A_r;
                  case 10:
                    return N_r;
                  case 11:
                    return C_r;
                  case 12:
                    return P_r;
                  case 13:
                    return D_r;
                  case 14:
                    return L_r;
                  case 15:
                    return R_r;
                  case 16:
                    return j_r;
                  case 17:
                    return G_r;
                  case 18:
                    return M_r;
                  case 19:
                    return B_r;
                  case 20:
                    return q_r;
                  case 21:
                    return U_r;
                  case 22:
                    return H_r;
                  case 23:
                    return X_r;
                  case 24:
                    return Y_r;
                  case 25:
                    return V_r;
                  case 26:
                    return z_r;
                  case 27:
                    return K_r;
                  case 28:
                    return W_r;
                  case 29:
                    return J_r;
                  default:
                    return $_r;
                }
              } else switch (t[0]) {
                case 2:
                  return t[1][3];
                case 3:
                  return t[1][2][3];
                case 5:
                  var e = Te(Lhr, t[3]);
                  return Te(Rhr, Te(t[2], e));
                case 9:
                  return t[1] ? jhr : Ghr;
                case 0:
                case 1:
                  return t[2];
                case 6:
                case 7:
                  return t[1];
                default:
                  return t[3];
              }
            }
            function Ml(t) {
              return u(et(d_r), t);
            }
            function aL(t, n) {
              var e = t && t[1], i = 0;
              if (typeof n == "number") if (Pn === n) var x = u_r, c = i_r;
              else i = 1;
              else switch (n[0]) {
                case 3:
                  var x = f_r, c = x_r;
                  break;
                case 5:
                  var x = o_r, c = a_r;
                  break;
                case 6:
                case 9:
                  i = 1;
                  break;
                case 0:
                case 10:
                  var x = s_r, c = v_r;
                  break;
                case 1:
                case 11:
                  var x = l_r, c = b_r;
                  break;
                case 2:
                case 8:
                  var x = p_r, c = m_r;
                  break;
                default:
                  var x = __r, c = y_r;
              }
              if (i) var x = c_r, c = Ml(oL(n));
              return e ? Te(x, Te(h_r, c)) : c;
            }
            function cL(t) {
              return 45 < t ? 46 < t ? -1 : 0 : -1;
            }
            function jc(t) {
              if (8 < t) {
                if (Ev < t) {
                  if (ef < t) {
                    if (Do < t) return -1;
                    if (Qx < t) {
                      var n = t <= Ma ? 1 : 0, e = n && -1;
                      return e;
                    }
                    if (fo < t) {
                      if (xc < t) {
                        if (ox < t) {
                          var i = t <= Eo ? 1 : 0, x = i && -1;
                          return x;
                        }
                        return 0;
                      }
                      return -1;
                    }
                    if (Co < t) {
                      var c = t <= mo ? 1 : 0, s = c && -1;
                      return s;
                    }
                    return 0;
                  }
                  return -1;
                }
                return Vr(BDr, t - 9 | 0) - 1 | 0;
              }
              return -1;
            }
            function pn(t) {
              return 47 < t ? 57 < t ? -1 : 0 : -1;
            }
            function Nn(t) {
              return 47 < t ? Ri < t ? -1 : Vr($Lr, t + Wt | 0) - 1 | 0 : -1;
            }
            function wi(t) {
              return 47 < t ? Xt < t ? -1 : Vr(ULr, t + Wt | 0) - 1 | 0 : -1;
            }
            function Zv(t) {
              return 35 < t ? In < t ? -1 : Vr(cLr, t + vu | 0) - 1 | 0 : -1;
            }
            function Zm(t) {
              return 87 < t ? uc < t ? -1 : Vr(eN, t - 88 | 0) - 1 | 0 : -1;
            }
            function Qm(t) {
              return 45 < t ? 57 < t ? -1 : Vr(ZLr, t + v1 | 0) - 1 | 0 : -1;
            }
            function Er0(t) {
              return 35 < t ? In < t ? -1 : Vr(sLr, t + vu | 0) - 1 | 0 : -1;
            }
            function A1(t) {
              return 47 < t ? br < t ? -1 : Vr(MLr, t + Wt | 0) - 1 | 0 : -1;
            }
            function Qv(t) {
              return 35 < t ? In < t ? -1 : Vr(vLr, t + vu | 0) - 1 | 0 : -1;
            }
            function N1(t) {
              if (8 < t) {
                if (Ev < t) {
                  if (ef < t) {
                    if (Do < t) return -1;
                    if (Qx < t) {
                      var n = t <= Ma ? 1 : 0, e = n && -1;
                      return e;
                    }
                    if (fo < t) {
                      if (xc < t) {
                        if (ox < t) {
                          var i = t <= Eo ? 1 : 0, x = i && -1;
                          return x;
                        }
                        return 0;
                      }
                      return -1;
                    }
                    if (Co < t) {
                      var c = t <= mo ? 1 : 0, s = c && -1;
                      return s;
                    }
                    return 0;
                  }
                  return -1;
                }
                return Vr(qDr, t - 9 | 0) - 1 | 0;
              }
              return -1;
            }
            function r9(t) {
              return 45 < t ? R7 < t ? -1 : Vr(rLr, t + v1 | 0) - 1 | 0 : -1;
            }
            function Sr0(t) {
              return 35 < t ? In < t ? -1 : Vr(lLr, t + vu | 0) - 1 | 0 : -1;
            }
            function e9(t) {
              return 47 < t ? 95 < t ? -1 : Vr(sRr, t + Wt | 0) - 1 | 0 : -1;
            }
            function n9(t) {
              return 47 < t ? Xt < t ? -1 : Vr(lRr, t + Wt | 0) - 1 | 0 : -1;
            }
            function t9(t) {
              return 47 < t ? Xt < t ? -1 : Vr(HLr, t + Wt | 0) - 1 | 0 : -1;
            }
            function u9(t) {
              return 35 < t ? In < t ? -1 : Vr(bLr, t + vu | 0) - 1 | 0 : -1;
            }
            function i9(t) {
              if (8 < t) {
                if (Ev < t) {
                  if (ef < t) {
                    if (Do < t) return -1;
                    if (Qx < t) {
                      var n = t <= Ma ? 1 : 0, e = n && -1;
                      return e;
                    }
                    if (fo < t) {
                      if (xc < t) {
                        if (ox < t) {
                          var i = t <= Eo ? 1 : 0, x = i && -1;
                          return x;
                        }
                        return 0;
                      }
                      return -1;
                    }
                    if (Co < t) {
                      var c = t <= mo ? 1 : 0, s = c && -1;
                      return s;
                    }
                    return 0;
                  }
                  return -1;
                }
                return Vr(UDr, t - 9 | 0) - 1 | 0;
              }
              return -1;
            }
            function f9(t) {
              return 44 < t ? 57 < t ? -1 : Vr(KDr, t + mv | 0) - 1 | 0 : -1;
            }
            function Gc(t) {
              return 47 < t ? 49 < t ? -1 : 0 : -1;
            }
            function x9(t) {
              return 47 < t ? 95 < t ? -1 : Vr(WDr, t + Wt | 0) - 1 | 0 : -1;
            }
            function C1(t) {
              return 47 < t ? 57 < t ? -1 : Vr(vRr, t + Wt | 0) - 1 | 0 : -1;
            }
            function o9(t) {
              return 35 < t ? In < t ? -1 : Vr(pLr, t + vu | 0) - 1 | 0 : -1;
            }
            function gr0(t) {
              return t1 < t ? Av < t ? -1 : 0 : -1;
            }
            function Ui(t) {
              return 60 < t ? 61 < t ? -1 : 0 : -1;
            }
            function Fr0(t) {
              if (-1 < t) {
                if (In < t) {
                  if (ts < t) {
                    if ($u < t) {
                      var n = t <= Hu ? 1 : 0, e = n && -1;
                      return e;
                    }
                    return 0;
                  }
                  return -1;
                }
                return Vr(fLr, t) - 1 | 0;
              }
              return -1;
            }
            function r2(t) {
              return 47 < t ? Xt < t ? -1 : Vr(XLr, t + Wt | 0) - 1 | 0 : -1;
            }
            function a9(t) {
              return 47 < t ? Xt < t ? -1 : Vr(JLr, t + Wt | 0) - 1 | 0 : -1;
            }
            function sL(t) {
              return 60 < t ? 62 < t ? -1 : Vr(rN, t + SS | 0) - 1 | 0 : -1;
            }
            function c9(t) {
              return 65 < t ? 98 < t ? -1 : Vr(eN, t - 66 | 0) - 1 | 0 : -1;
            }
            function Bt(t) {
              return 35 < t ? In < t ? -1 : Vr(mLr, t + vu | 0) - 1 | 0 : -1;
            }
            function s9(t) {
              return Av < t ? f1 < t ? -1 : 0 : -1;
            }
            function zu(t) {
              return 47 < t ? 55 < t ? -1 : 0 : -1;
            }
            function vL(t) {
              return Fv < t ? Xt < t ? -1 : 0 : -1;
            }
            function v9(t) {
              return Xt < t ? cf < t ? -1 : 0 : -1;
            }
            function Bl(t) {
              return 98 < t ? 99 < t ? -1 : 0 : -1;
            }
            function Cs(t) {
              return 47 < t ? 48 < t ? -1 : 0 : -1;
            }
            function ql(t) {
              if (8 < t) {
                if (Ev < t) {
                  if (ef < t) {
                    if (Do < t) return -1;
                    if (Qx < t) {
                      var n = t <= Ma ? 1 : 0, e = n && -1;
                      return e;
                    }
                    if (fo < t) {
                      if (xc < t) {
                        if (ox < t) {
                          var i = t <= Eo ? 1 : 0, x = i && -1;
                          return x;
                        }
                        return 0;
                      }
                      return -1;
                    }
                    if (Co < t) {
                      var c = t <= mo ? 1 : 0, s = c && -1;
                      return s;
                    }
                    return 0;
                  }
                  return -1;
                }
                return Vr(HDr, t - 9 | 0) - 1 | 0;
              }
              return -1;
            }
            function l9(t) {
              return 45 < t ? R7 < t ? -1 : Vr(JDr, t + v1 | 0) - 1 | 0 : -1;
            }
            function b9(t) {
              return 78 < t ? cf < t ? -1 : Vr(eN, t - 79 | 0) - 1 | 0 : -1;
            }
            function Tr0(t) {
              return 41 < t ? 42 < t ? -1 : 0 : -1;
            }
            function Or0(t) {
              return 35 < t ? In < t ? -1 : Vr(_Lr, t + vu | 0) - 1 | 0 : -1;
            }
            function p9(t) {
              return 47 < t ? R7 < t ? -1 : Vr(BLr, t + Wt | 0) - 1 | 0 : -1;
            }
            function Ps(t) {
              return 35 < t ? In < t ? -1 : Vr(yLr, t + vu | 0) - 1 | 0 : -1;
            }
            function Ir0(t) {
              return 41 < t ? 61 < t ? -1 : Vr(KLr, t + _y | 0) - 1 | 0 : -1;
            }
            function P1(t) {
              return 44 < t ? 48 < t ? -1 : Vr(LLr, t + mv | 0) - 1 | 0 : -1;
            }
            function Ar0(t) {
              return 44 < t ? 45 < t ? -1 : 0 : -1;
            }
            function Nr0(t) {
              return L7 < t ? j7 < t ? -1 : 0 : -1;
            }
            function m9(t) {
              return Zc < t ? is < t ? -1 : 0 : -1;
            }
            function Cr0(t) {
              return 99 < t ? ti < t ? -1 : 0 : -1;
            }
            function _9(t) {
              return 47 < t ? Ri < t ? -1 : Vr(QLr, t + Wt | 0) - 1 | 0 : -1;
            }
            function y9(t) {
              return Pn < t ? t1 < t ? -1 : 0 : -1;
            }
            function D1(t) {
              return 45 < t ? 57 < t ? -1 : Vr(nRr, t + v1 | 0) - 1 | 0 : -1;
            }
            function Pr0(t) {
              return 35 < t ? In < t ? -1 : Vr(hLr, t + vu | 0) - 1 | 0 : -1;
            }
            function L1(t) {
              return 47 < t ? ts < t ? -1 : Vr(bRr, t + Wt | 0) - 1 | 0 : -1;
            }
            function lL(t) {
              return 35 < t ? In < t ? -1 : Vr(dLr, t + vu | 0) - 1 | 0 : -1;
            }
            function xi(t) {
              return 9 < t ? 10 < t ? -1 : 0 : -1;
            }
            function Dr0(t) {
              return 35 < t ? In < t ? -1 : Vr(kLr, t + vu | 0) - 1 | 0 : -1;
            }
            function Lr0(t) {
              return 96 < t ? 97 < t ? -1 : 0 : -1;
            }
            function Mc(t) {
              return 35 < t ? In < t ? -1 : Vr(wLr, t + vu | 0) - 1 | 0 : -1;
            }
            function h9(t) {
              return 35 < t ? In < t ? -1 : Vr(ELr, t + vu | 0) - 1 | 0 : -1;
            }
            function Ds(t) {
              return 47 < t ? 95 < t ? -1 : Vr(YLr, t + Wt | 0) - 1 | 0 : -1;
            }
            function Rr0(t) {
              return 35 < t ? In < t ? -1 : Vr(SLr, t + vu | 0) - 1 | 0 : -1;
            }
            function Ul(t) {
              return ti < t ? R7 < t ? -1 : 0 : -1;
            }
            function jr0(t) {
              if (8 < t) {
                if (Ev < t) {
                  if (ef < t) {
                    if (Do < t) return -1;
                    if (Qx < t) {
                      var n = t <= Ma ? 1 : 0, e = n && -1;
                      return e;
                    }
                    if (fo < t) {
                      if (xc < t) {
                        if (ox < t) {
                          var i = t <= Eo ? 1 : 0, x = i && -1;
                          return x;
                        }
                        return 0;
                      }
                      return -1;
                    }
                    if (Co < t) {
                      var c = t <= mo ? 1 : 0, s = c && -1;
                      return s;
                    }
                    return 0;
                  }
                  return -1;
                }
                return Vr(YDr, t - 9 | 0) - 1 | 0;
              }
              return -1;
            }
            function Gr0(t) {
              return 35 < t ? In < t ? -1 : Vr(tRr, t + vu | 0) - 1 | 0 : -1;
            }
            function d9(t) {
              return 41 < t ? 47 < t ? -1 : Vr(CLr, t + _y | 0) - 1 | 0 : -1;
            }
            function k9(t) {
              return 35 < t ? In < t ? -1 : Vr(gLr, t + vu | 0) - 1 | 0 : -1;
            }
            function Mr0(t) {
              return 35 < t ? In < t ? -1 : Vr(FLr, t + vu | 0) - 1 | 0 : -1;
            }
            function Br0(t) {
              return z22 < t ? Sv < t ? -1 : 0 : -1;
            }
            function w9(t) {
              return 35 < t ? In < t ? -1 : Vr(TLr, t + vu | 0) - 1 | 0 : -1;
            }
            function f7(t) {
              return 47 < t ? R7 < t ? -1 : Vr(qLr, t + Wt | 0) - 1 | 0 : -1;
            }
            function E9(t) {
              return 42 < t ? 57 < t ? -1 : Vr(uLr, t + xy | 0) - 1 | 0 : -1;
            }
            function Bc(t) {
              return 45 < t ? 95 < t ? -1 : Vr(aLr, t + v1 | 0) - 1 | 0 : -1;
            }
            function Ls(t) {
              return f1 < t ? A2 < t ? -1 : 0 : -1;
            }
            function qr0(t) {
              return 46 < t ? 47 < t ? -1 : 0 : -1;
            }
            function Ur0(t) {
              return 57 < t ? 58 < t ? -1 : 0 : -1;
            }
            function dn(t) {
              return 35 < t ? In < t ? -1 : Vr(OLr, t + vu | 0) - 1 | 0 : -1;
            }
            function Hr0(t) {
              for (; ; ) {
                gn(t);
                var n = j(t), e = In < n ? 1 : Vr(xRr, n + 1 | 0) - 1 | 0;
                if (3 < e >>> 0) var i = q(t);
                else switch (e) {
                  case 0:
                    var i = 1;
                    break;
                  case 1:
                    var i = 2;
                    break;
                  case 2:
                    var i = 0;
                    break;
                  default:
                    if (G0(t, 2), Ls(j(t)) === 0) {
                      var x = L1(j(t));
                      if (x === 0) if (Nn(j(t)) === 0 && Nn(j(t)) === 0) var c = Nn(j(t)) !== 0 ? 1 : 0, i = c && q(t);
                      else var i = q(t);
                      else if (x === 1 && Nn(j(t)) === 0) for (; ; ) {
                        var s = A1(j(t));
                        if (s !== 0) {
                          var p = s !== 1 ? 1 : 0, i = p && q(t);
                          break;
                        }
                      }
                      else var i = q(t);
                    } else var i = q(t);
                }
                if (2 < i >>> 0) throw [0, Sn, swr];
                switch (i) {
                  case 0:
                    continue;
                  case 1:
                    return 1;
                  default:
                    if (nL(br0(t))) continue;
                    return mr0(t, 1), 0;
                }
              }
            }
            function S9(t, n) {
              var e = n - t[3][2] | 0;
              return [0, hr0(t), e];
            }
            function Hl(t, n, e) {
              var i = S9(t, e), x = S9(t, n);
              return [0, t[1], x, i];
            }
            function ju(t, n) {
              return S9(t, n[6]);
            }
            function h7(t, n) {
              return S9(t, n[3]);
            }
            function nt(t, n) {
              return Hl(t, n[6], n[3]);
            }
            function Xr0(t, n) {
              var e = 0;
              if (typeof n == "number") e = 1;
              else switch (n[0]) {
                case 2:
                  var i = n[1][1];
                  break;
                case 3:
                  return n[1][1];
                case 4:
                  var i = n[1];
                  break;
                case 7:
                  var i = n[2];
                  break;
                case 5:
                case 8:
                  return n[1];
                default:
                  e = 1;
              }
              return e ? nt(t, t[2]) : i;
            }
            function Gu(t, n, e) {
              return [0, t[1], t[2], t[3], t[4], t[5], [0, [0, n, e], t[6]], t[7]];
            }
            function Yr0(t, n, e) {
              return Gu(t, n, [10, Ml(e)]);
            }
            function bL(t, n, e, i) {
              return Gu(t, n, [12, e, i]);
            }
            function Ei(t, n) {
              return Gu(t, n, GDr);
            }
            function d7(t, n) {
              var e = n[3], i = [0, hr0(t) + 1 | 0, e];
              return [0, t[1], t[2], i, t[4], t[5], t[6], t[7]];
            }
            function Vr0(t) {
              var n = un(t);
              return n !== 0 && Xt === It(t, n - 1 | 0) ? m7(t, 0, n - 1 | 0) : t;
            }
            function Si(t, n, e, i, x) {
              var c = [0, t[1], n, e], s = Mt(i), p = x ? 0 : 1;
              return [0, c, [0, p, s, t[7][3][1] < c[2][1] ? 1 : 0]];
            }
            function qc(t, n) {
              if (It(n, 0) === 45) var e = m7(n, 1, un(n) - 1 | 0), i = 1;
              else var e = n, i = 0;
              switch (t) {
                case 1:
                  try {
                    var x = jv(Rv(Te(DDr, e))), c = x;
                  } catch (T) {
                    if (T = Et(T), T[1] !== q7) throw T;
                    var c = ke(Te(LDr, e));
                  }
                  break;
                case 0:
                case 3:
                  try {
                    var s = jv(Rv(e)), c = s;
                  } catch (T) {
                    if (T = Et(T), T[1] !== q7) throw T;
                    var c = ke(Te(RDr, e));
                  }
                  break;
                default:
                  try {
                    var p = ol(e), c = p;
                  } catch (T) {
                    if (T = Et(T), T[1] !== q7) throw T;
                    var c = ke(Te(jDr, e));
                  }
              }
              var y = i ? -c : c;
              return [10, t, y, n];
            }
            function Hi(t, n) {
              if (It(n, 0) === 45) var e = m7(n, 1, un(n) - 1 | 0), i = 1;
              else var e = n, i = 0;
              if (2 <= t) {
                var x = Vr0(e);
                try {
                  var c = ol(x), s = c;
                } catch (w) {
                  if (w = Et(w), w[1] !== q7) throw w;
                  var s = ke(Te(CDr, x));
                }
                var p = s;
              } else {
                var y = Vr0(e);
                try {
                  var T = jv(Rv(y)), E = T;
                } catch (G) {
                  if (G = Et(G), G[1] !== q7) throw G;
                  var E = ke(Te(PDr, y));
                }
                var p = E;
              }
              var d = i ? -p : p;
              return [11, t, d, n];
            }
            function zr0(t, n, e) {
              return nL(e) ? t : Gu(t, n, 37);
            }
            function Kr0(t, n, e, i, x) {
              var c = Hl(t, n + e[6] | 0, n + e[3] | 0);
              return [0, c, jl(e, i, (Jm(e) - i | 0) - x | 0)];
            }
            function Wr0(t, n) {
              for (var e = t[2][6], i = [0, n, n.length - 1, lr0, vr0, sr0, cr0, ar0, or0, xr0, fr0, ir0, ur0], x = $n(n.length - 1), c = t; ; ) {
                gn(i);
                var s = j(i), p = 92 < s ? 1 : Vr(jLr, s + 1 | 0) - 1 | 0;
                if (2 < p >>> 0) var y = q(i);
                else switch (p) {
                  case 0:
                    var y = 2;
                    break;
                  case 1:
                    for (; ; ) {
                      G0(i, 3);
                      var T = j(i);
                      if (-1 < T) if (91 < T) var E = T <= 92 ? 1 : 0, d = E && -1;
                      else var d = 0;
                      else var d = -1;
                      if (d !== 0) {
                        var y = q(i);
                        break;
                      }
                    }
                    break;
                  default:
                    if (G0(i, 3), Ls(j(i)) === 0) {
                      var w = L1(j(i));
                      if (w === 0) if (Nn(j(i)) === 0 && Nn(j(i)) === 0) var G = Nn(j(i)) !== 0 ? 1 : 0, y = G && q(i);
                      else var y = q(i);
                      else if (w === 1 && Nn(j(i)) === 0) for (; ; ) {
                        var A = A1(j(i));
                        if (A !== 0) {
                          var y = A === 1 ? 1 : q(i);
                          break;
                        }
                      }
                      else var y = q(i);
                    } else var y = q(i);
                }
                if (3 < y >>> 0) return ke(IDr);
                switch (y) {
                  case 0:
                    var S = Kr0(c, e, i, 2, 0), M = S[1], K = Bi(Te(ADr, S[2])), V = 0 <= K ? 1 : 0, f0 = V && (K <= 55295 ? 1 : 0);
                    if (f0) var k0 = f0;
                    else var m0 = 57344 <= K ? 1 : 0, k0 = m0 && (K <= lI ? 1 : 0);
                    var g0 = k0 ? zr0(c, M, K) : Gu(c, M, 37);
                    S1(x, K);
                    var c = g0;
                    continue;
                  case 1:
                    var e0 = Kr0(c, e, i, 3, 1), x0 = Bi(Te(NDr, e0[2])), l = zr0(c, e0[1], x0);
                    S1(x, x0);
                    var c = l;
                    continue;
                  case 2:
                    return [0, c, Mt(x)];
                  default:
                    Gl(i, x);
                    continue;
                }
              }
            }
            function Rt(t, n, e) {
              var i = Ei(t, nt(t, n));
              return $v(n), o(e, i, n);
            }
            function R1(t, n, e) {
              for (var i = t; ; ) {
                gn(e);
                var x = j(e);
                if (-1 < x) if (42 < x) var c = x <= Hu ? 1 : 0, s = c && ($u < x ? 1 : 0);
                else var s = Vr(VDr, x) - 1 | 0;
                else var s = -1;
                if (3 < s >>> 0) var p = q(e);
                else switch (s) {
                  case 0:
                    for (; ; ) {
                      G0(e, 3);
                      var y = j(e);
                      if (-1 < y) if (41 < y) if (42 < y) if ($u < y) var T = y <= Hu ? 1 : 0, E = T && -1;
                      else var E = 0;
                      else var E = -1;
                      else var E = Vr(eRr, y) - 1 | 0;
                      else var E = -1;
                      if (E !== 0) {
                        var p = q(e);
                        break;
                      }
                    }
                    break;
                  case 1:
                    var p = 0;
                    break;
                  case 2:
                    G0(e, 0);
                    var d = xi(j(e)) !== 0 ? 1 : 0, p = d && q(e);
                    break;
                  default:
                    G0(e, 3);
                    var w = j(e), G = 44 < w ? 47 < w ? -1 : Vr(aRr, w + mv | 0) - 1 | 0 : -1, p = G === 0 ? qr0(j(e)) === 0 ? 2 : q(e) : G === 1 ? 1 : q(e);
                }
                if (3 < p >>> 0) {
                  var A = Ei(i, nt(i, e));
                  return [0, A, h7(A, e)];
                }
                switch (p) {
                  case 0:
                    var S = d7(i, e);
                    Gl(e, n);
                    var i = S;
                    continue;
                  case 1:
                    var M = i[4] ? bL(i, nt(i, e), bwr, lwr) : i;
                    return [0, M, h7(M, e)];
                  case 2:
                    if (i[4]) return [0, i, h7(i, e)];
                    hn(n, pwr);
                    continue;
                  default:
                    Gl(e, n);
                    continue;
                }
              }
            }
            function e2(t, n, e) {
              for (; ; ) {
                gn(e);
                var i = j(e), x = 13 < i ? Hu < i ? 1 : $u < i ? 2 : 1 : Vr(NLr, i + 1 | 0) - 1 | 0;
                if (3 < x >>> 0) var c = q(e);
                else switch (x) {
                  case 0:
                    var c = 0;
                    break;
                  case 1:
                    for (; ; ) {
                      G0(e, 2);
                      var s = j(e);
                      if (-1 < s) if (12 < s) if (13 < s) if ($u < s) var p = s <= Hu ? 1 : 0, y = p && -1;
                      else var y = 0;
                      else var y = -1;
                      else var y = Vr(MDr, s) - 1 | 0;
                      else var y = -1;
                      if (y !== 0) {
                        var c = q(e);
                        break;
                      }
                    }
                    break;
                  case 2:
                    var c = 1;
                    break;
                  default:
                    G0(e, 1);
                    var c = xi(j(e)) === 0 ? 1 : q(e);
                }
                if (2 < c >>> 0) return ke(mwr);
                switch (c) {
                  case 0:
                    return [0, t, h7(t, e)];
                  case 1:
                    var T = h7(t, e), E = d7(t, e), d = Jm(e);
                    return [0, E, [0, T[1], T[2] - d | 0]];
                  default:
                    Gl(e, n);
                    continue;
                }
              }
            }
            function Jr0(t, n) {
              function e(k0) {
                return G0(k0, 3), zu(j(k0)) === 0 ? 2 : q(k0);
              }
              gn(n);
              var i = j(n), x = uc < i ? Hu < i ? 1 : $u < i ? 2 : 1 : Vr(nLr, i + 1 | 0) - 1 | 0;
              if (14 < x >>> 0) var c = q(n);
              else switch (x) {
                case 1:
                  var c = 16;
                  break;
                case 2:
                  var c = 15;
                  break;
                case 3:
                  G0(n, 15);
                  var c = xi(j(n)) === 0 ? 15 : q(n);
                  break;
                case 4:
                  G0(n, 4);
                  var c = zu(j(n)) === 0 ? e(n) : q(n);
                  break;
                case 5:
                  G0(n, 11);
                  var c = zu(j(n)) === 0 ? e(n) : q(n);
                  break;
                case 7:
                  var c = 5;
                  break;
                case 8:
                  var c = 6;
                  break;
                case 9:
                  var c = 7;
                  break;
                case 10:
                  var c = 8;
                  break;
                case 11:
                  var c = 9;
                  break;
                case 12:
                  G0(n, 14);
                  var s = L1(j(n));
                  if (s === 0) var c = Nn(j(n)) === 0 && Nn(j(n)) === 0 && Nn(j(n)) === 0 ? 12 : q(n);
                  else if (s === 1 && Nn(j(n)) === 0) for (; ; ) {
                    var p = A1(j(n));
                    if (p !== 0) {
                      var c = p === 1 ? 13 : q(n);
                      break;
                    }
                  }
                  else var c = q(n);
                  break;
                case 13:
                  var c = 10;
                  break;
                case 14:
                  G0(n, 14);
                  var c = Nn(j(n)) === 0 && Nn(j(n)) === 0 ? 1 : q(n);
                  break;
                default:
                  var c = 0;
              }
              if (16 < c >>> 0) return ke(pDr);
              switch (c) {
                case 1:
                  var y = Se(n);
                  return [0, t, y, [0, Bi(Te(mDr, y))], 0];
                case 2:
                  var T = Se(n), E = Bi(Te(_Dr, T));
                  return N4 <= E ? [0, t, T, [0, E >>> 3 | 0, 48 + (E & 7) | 0], 1] : [0, t, T, [0, E], 1];
                case 3:
                  var d = Se(n);
                  return [0, t, d, [0, Bi(Te(yDr, d))], 1];
                case 4:
                  return [0, t, hDr, [0, 0], 0];
                case 5:
                  return [0, t, dDr, [0, 8], 0];
                case 6:
                  return [0, t, kDr, [0, 12], 0];
                case 7:
                  return [0, t, wDr, [0, 10], 0];
                case 8:
                  return [0, t, EDr, [0, 13], 0];
                case 9:
                  return [0, t, SDr, [0, 9], 0];
                case 10:
                  return [0, t, gDr, [0, 11], 0];
                case 11:
                  var w = Se(n);
                  return [0, t, w, [0, Bi(Te(FDr, w))], 1];
                case 12:
                  var G = Se(n);
                  return [0, t, G, [0, Bi(Te(TDr, m7(G, 1, un(G) - 1 | 0)))], 0];
                case 13:
                  var A = Se(n), S = Bi(Te(ODr, m7(A, 2, un(A) - 3 | 0))), M = lI < S ? Ei(t, nt(t, n)) : t;
                  return [0, M, A, [0, S], 0];
                case 14:
                  var K = Se(n), V = Ll(n);
                  return [0, Ei(t, nt(t, n)), K, V, 0];
                case 15:
                  var f0 = Se(n);
                  return [0, d7(t, n), f0, [0], 0];
                default:
                  var m0 = Se(n);
                  return [0, t, m0, Ll(n), 0];
              }
            }
            function $r0(t, n, e, i, x, c) {
              for (var s = t, p = x; ; ) {
                gn(c);
                var y = j(c), T = 92 < y ? 1 : Vr(RLr, y + 1 | 0) - 1 | 0;
                if (4 < T >>> 0) var E = q(c);
                else switch (T) {
                  case 0:
                    var E = 3;
                    break;
                  case 1:
                    for (; ; ) {
                      G0(c, 4);
                      var d = j(c);
                      if (-1 < d) if (91 < d) var w = d <= 92 ? 1 : 0, G = w && -1;
                      else var G = Vr(ZDr, d) - 1 | 0;
                      else var G = -1;
                      if (G !== 0) {
                        var E = q(c);
                        break;
                      }
                    }
                    break;
                  case 2:
                    var E = 2;
                    break;
                  case 3:
                    var E = 0;
                    break;
                  default:
                    var E = 1;
                }
                if (4 < E >>> 0) return ke(_wr);
                switch (E) {
                  case 0:
                    var A = Se(c);
                    if (hn(i, A), qn(n, A)) return [0, s, h7(s, c), p];
                    hn(e, A);
                    continue;
                  case 1:
                    hn(i, ywr);
                    var S = Jr0(s, c), M = S[4], K = M || p;
                    hn(i, S[2]);
                    var V = S[3];
                    pz(function(w0) {
                      return S1(e, w0);
                    }, V);
                    var s = S[1], p = K;
                    continue;
                  case 2:
                    var f0 = Se(c);
                    hn(i, f0);
                    var m0 = d7(Ei(s, nt(s, c)), c);
                    return hn(e, f0), [0, m0, h7(m0, c), p];
                  case 3:
                    var k0 = Se(c);
                    hn(i, k0);
                    var g0 = Ei(s, nt(s, c));
                    return hn(e, k0), [0, g0, h7(g0, c), p];
                  default:
                    var e0 = c[6], x0 = c[3] - e0 | 0, l = Lt(x0 * 4 | 0), c0 = Rl(c[1], e0, x0, l);
                    sN(i, l, 0, c0), sN(e, l, 0, c0);
                    continue;
                }
              }
            }
            function Zr0(t, n, e, i, x) {
              for (var c = t; ; ) {
                gn(x);
                var s = j(x), p = 96 < s ? 1 : Vr(zLr, s + 1 | 0) - 1 | 0;
                if (6 < p >>> 0) var y = q(x);
                else switch (p) {
                  case 0:
                    var y = 0;
                    break;
                  case 1:
                    for (; ; ) {
                      G0(x, 6);
                      var T = j(x);
                      if (-1 < T) if (95 < T) var E = T <= 96 ? 1 : 0, d = E && -1;
                      else var d = Vr($Dr, T) - 1 | 0;
                      else var d = -1;
                      if (d !== 0) {
                        var y = q(x);
                        break;
                      }
                    }
                    break;
                  case 2:
                    var y = 5;
                    break;
                  case 3:
                    G0(x, 5);
                    var y = xi(j(x)) === 0 ? 4 : q(x);
                    break;
                  case 4:
                    G0(x, 6);
                    var w = j(x), G = In < w ? ts < w ? -1 : 0 : -1, y = G === 0 ? 2 : q(x);
                    break;
                  case 5:
                    var y = 3;
                    break;
                  default:
                    var y = 1;
                }
                if (6 < y >>> 0) return ke(hwr);
                switch (y) {
                  case 0:
                    return [0, Ei(c, nt(c, x)), 1];
                  case 1:
                    return qi(i, 96), [0, c, 1];
                  case 2:
                    return hn(i, dwr), [0, c, 0];
                  case 3:
                    qi(e, 92), qi(i, 92);
                    var A = Jr0(c, x), S = A[2];
                    hn(e, S), hn(i, S);
                    var M = A[3];
                    pz(function(m0) {
                      return S1(n, m0);
                    }, M);
                    var c = A[1];
                    continue;
                  case 4:
                    hn(e, kwr), hn(i, wwr), hn(n, Ewr);
                    var c = d7(c, x);
                    continue;
                  case 5:
                    var K = Se(x);
                    hn(e, K), hn(i, K), qi(n, 10);
                    var c = d7(c, x);
                    continue;
                  default:
                    var V = Se(x);
                    hn(e, V), hn(i, V), hn(n, V);
                    continue;
                }
              }
            }
            function Pee(t, n) {
              function e(B0) {
                for (; ; ) if (G0(B0, 33), dn(j(B0)) !== 0) return q(B0);
              }
              function i(B0) {
                for (; ; ) if (G0(B0, 27), dn(j(B0)) !== 0) return q(B0);
              }
              function x(B0) {
                G0(B0, 26);
                var D0 = Bt(j(B0));
                if (D0 === 0) {
                  for (; ; ) if (G0(B0, 25), dn(j(B0)) !== 0) return q(B0);
                }
                return D0 === 1 ? i(B0) : q(B0);
              }
              function c(B0) {
                for (; ; ) if (G0(B0, 27), dn(j(B0)) !== 0) return q(B0);
              }
              function s(B0) {
                G0(B0, 26);
                var D0 = Bt(j(B0));
                if (D0 === 0) {
                  for (; ; ) if (G0(B0, 25), dn(j(B0)) !== 0) return q(B0);
                }
                return D0 === 1 ? c(B0) : q(B0);
              }
              function p(B0) {
                r: for (; ; ) {
                  if (pn(j(B0)) === 0) for (; ; ) {
                    G0(B0, 28);
                    var D0 = Mc(j(B0));
                    if (3 < D0 >>> 0) return q(B0);
                    switch (D0) {
                      case 0:
                        return c(B0);
                      case 1:
                        continue;
                      case 2:
                        continue r;
                      default:
                        return s(B0);
                    }
                  }
                  return q(B0);
                }
              }
              function y(B0) {
                G0(B0, 33);
                var D0 = Gr0(j(B0));
                if (3 < D0 >>> 0) return q(B0);
                switch (D0) {
                  case 0:
                    return e(B0);
                  case 1:
                    var Le = C1(j(B0));
                    if (Le === 0) for (; ; ) {
                      G0(B0, 28);
                      var He = Qv(j(B0));
                      if (2 < He >>> 0) return q(B0);
                      switch (He) {
                        case 0:
                          return c(B0);
                        case 1:
                          continue;
                        default:
                          return s(B0);
                      }
                    }
                    if (Le === 1) for (; ; ) {
                      G0(B0, 28);
                      var he = Mc(j(B0));
                      if (3 < he >>> 0) return q(B0);
                      switch (he) {
                        case 0:
                          return c(B0);
                        case 1:
                          continue;
                        case 2:
                          return p(B0);
                        default:
                          return s(B0);
                      }
                    }
                    return q(B0);
                  case 2:
                    for (; ; ) {
                      G0(B0, 28);
                      var me = Qv(j(B0));
                      if (2 < me >>> 0) return q(B0);
                      switch (me) {
                        case 0:
                          return i(B0);
                        case 1:
                          continue;
                        default:
                          return x(B0);
                      }
                    }
                  default:
                    for (; ; ) {
                      G0(B0, 28);
                      var Zn = Mc(j(B0));
                      if (3 < Zn >>> 0) return q(B0);
                      switch (Zn) {
                        case 0:
                          return i(B0);
                        case 1:
                          continue;
                        case 2:
                          return p(B0);
                        default:
                          return x(B0);
                      }
                    }
                }
              }
              function T(B0) {
                G0(B0, 31);
                var D0 = Bt(j(B0));
                if (D0 === 0) {
                  for (; ; ) if (G0(B0, 29), dn(j(B0)) !== 0) return q(B0);
                }
                return D0 === 1 ? e(B0) : q(B0);
              }
              function E(B0) {
                return G0(B0, 3), Ur0(j(B0)) === 0 ? 3 : q(B0);
              }
              function d(B0) {
                return m9(j(B0)) === 0 && v9(j(B0)) === 0 && Br0(j(B0)) === 0 && Ar0(j(B0)) === 0 && Nr0(j(B0)) === 0 && vL(j(B0)) === 0 && Bl(j(B0)) === 0 && m9(j(B0)) === 0 && Ls(j(B0)) === 0 && Cr0(j(B0)) === 0 && Ul(j(B0)) === 0 ? 3 : q(B0);
              }
              function w(B0) {
                G0(B0, 34);
                var D0 = Or0(j(B0));
                if (3 < D0 >>> 0) return q(B0);
                switch (D0) {
                  case 0:
                    return e(B0);
                  case 1:
                    for (; ; ) {
                      G0(B0, 34);
                      var Le = Ps(j(B0));
                      if (4 < Le >>> 0) return q(B0);
                      switch (Le) {
                        case 0:
                          return e(B0);
                        case 1:
                          continue;
                        case 2:
                          return y(B0);
                        case 3:
                          r: for (; ; ) {
                            if (pn(j(B0)) === 0) for (; ; ) {
                              G0(B0, 34);
                              var He = Ps(j(B0));
                              if (4 < He >>> 0) return q(B0);
                              switch (He) {
                                case 0:
                                  return e(B0);
                                case 1:
                                  continue;
                                case 2:
                                  return y(B0);
                                case 3:
                                  continue r;
                                default:
                                  return T(B0);
                              }
                            }
                            return q(B0);
                          }
                        default:
                          return T(B0);
                      }
                    }
                  case 2:
                    return y(B0);
                  default:
                    return T(B0);
                }
              }
              function G(B0) {
                for (; ; ) if (G0(B0, 19), dn(j(B0)) !== 0) return q(B0);
              }
              function A(B0) {
                G0(B0, 34);
                var D0 = Qv(j(B0));
                if (2 < D0 >>> 0) return q(B0);
                switch (D0) {
                  case 0:
                    return e(B0);
                  case 1:
                    for (; ; ) {
                      G0(B0, 34);
                      var Le = Mc(j(B0));
                      if (3 < Le >>> 0) return q(B0);
                      switch (Le) {
                        case 0:
                          return e(B0);
                        case 1:
                          continue;
                        case 2:
                          r: for (; ; ) {
                            if (pn(j(B0)) === 0) for (; ; ) {
                              G0(B0, 34);
                              var He = Mc(j(B0));
                              if (3 < He >>> 0) return q(B0);
                              switch (He) {
                                case 0:
                                  return e(B0);
                                case 1:
                                  continue;
                                case 2:
                                  continue r;
                                default:
                                  return T(B0);
                              }
                            }
                            return q(B0);
                          }
                        default:
                          return T(B0);
                      }
                    }
                  default:
                    return T(B0);
                }
              }
              function S(B0) {
                for (; ; ) if (G0(B0, 17), dn(j(B0)) !== 0) return q(B0);
              }
              function M(B0) {
                for (; ; ) if (G0(B0, 17), dn(j(B0)) !== 0) return q(B0);
              }
              function K(B0) {
                for (; ; ) if (G0(B0, 11), dn(j(B0)) !== 0) return q(B0);
              }
              function V(B0) {
                for (; ; ) if (G0(B0, 11), dn(j(B0)) !== 0) return q(B0);
              }
              function f0(B0) {
                for (; ; ) if (G0(B0, 15), dn(j(B0)) !== 0) return q(B0);
              }
              function m0(B0) {
                for (; ; ) if (G0(B0, 15), dn(j(B0)) !== 0) return q(B0);
              }
              function k0(B0) {
                for (; ; ) if (G0(B0, 23), dn(j(B0)) !== 0) return q(B0);
              }
              function g0(B0) {
                for (; ; ) if (G0(B0, 23), dn(j(B0)) !== 0) return q(B0);
              }
              function e0(B0) {
                G0(B0, 32);
                var D0 = Bt(j(B0));
                if (D0 === 0) {
                  for (; ; ) if (G0(B0, 30), dn(j(B0)) !== 0) return q(B0);
                }
                return D0 === 1 ? e(B0) : q(B0);
              }
              function x0(B0) {
                r: for (; ; ) {
                  if (pn(j(B0)) === 0) for (; ; ) {
                    G0(B0, 34);
                    var D0 = Rr0(j(B0));
                    if (4 < D0 >>> 0) return q(B0);
                    switch (D0) {
                      case 0:
                        return e(B0);
                      case 1:
                        return A(B0);
                      case 2:
                        continue;
                      case 3:
                        continue r;
                      default:
                        return e0(B0);
                    }
                  }
                  return q(B0);
                }
              }
              gn(n);
              var l = j(n), c0 = ef < l ? vw < l ? -1 : Uk < l ? C3 < l ? Bw < l ? EE < l ? Wy < l ? 1 : 8 : Jd < l ? lE < l ? uF < l ? 1 : 8 : ZT < l ? 1 : 8 : WF < l ? bA < l ? 1 : 8 : sI < l ? 1 : 8 : C6 < l ? E4 < l ? x6 < l ? V8 < l ? j3 < l ? r3 < l ? CO < l ? 1 : 8 : LI < l ? 1 : 8 : Iy < l ? hg < l ? 1 : 8 : Mw < l ? 1 : 8 : L3 < l ? w8 < l ? jg < l ? 1 : 8 : $4 < l ? 1 : 8 : W8 < l ? zT < l ? 1 : 8 : kk < l ? 1 : 8 : O4 < l ? YO < l ? l3 < l ? Qk < l ? 1 : 8 : fk < l ? 1 : 8 : xp < l ? V6 < l ? 1 : 8 : Td < l ? 1 : 8 : G8 < l ? s4 < l ? t6 < l ? 1 : 8 : q6 < l ? 1 : 8 : B6 < l ? S4 < l ? 1 : 8 : fn < l ? 1 : 8 : LE < l ? M4 < l ? g6 < l ? SF < l ? i8 < l ? 1 : 8 : d8 < l ? 1 : 8 : F4 < l ? JF < l ? 1 : 8 : mh < l ? 1 : 8 : U6 < l ? n8 < l ? s3 < l ? 1 : 8 : S8 < l ? 1 : 8 : BS < l ? L8 < l ? 1 : 8 : K3 < l ? 1 : 8 : m8 < l ? f8 < l ? x8 < l ? w3 < l ? 1 : 8 : _6 < l ? 1 : 8 : s6 < l ? oF < l ? 1 : 8 : ZO < l ? 1 : 8 : a3 < l ? DS < l ? e8 < l ? 1 : 8 : g8 < l ? 1 : 8 : J3 < l ? sF < l ? 1 : 8 : ig < l ? 1 : 8 : iw < l ? Ek < l ? wk < l ? qk < l ? FT < l ? Vk < l ? 1 : 8 : uA < l ? 1 : 8 : dy < l ? VS < l ? 1 : 8 : _d < l ? 1 : 8 : Th < l ? pF < l ? FE < l ? 1 : 8 : Zw < l ? 1 : 8 : Sy < l ? L_ < l ? 1 : 8 : CE < l ? 1 : 8 : LF < l ? Vw < l ? My < l ? rw < l ? 1 : 8 : XI < l ? 1 : 8 : jO < l ? ap < l ? 1 : 8 : jT < l ? 1 : 8 : Ot < l ? OA < l ? gA < l ? 1 : 8 : 1 : 8 : c6 < l ? w6 < l ? l6 < l ? k3 < l ? VE < l ? 1 : 8 : qw < l ? 1 : 8 : v4 < l ? nE < l ? 1 : 8 : Ty < l ? 1 : 8 : c3 < l ? V4 < l ? eg < l ? 1 : 8 : qF < l ? 1 : 8 : X4 < l ? _T < l ? 1 : 8 : Oy < l ? 1 : 8 : D6 < l ? D4 < l ? V3 < l ? MS < l ? 1 : 8 : Ww < l ? 1 : 8 : cy < l ? jy < l ? 1 : 8 : VT < l ? 1 : 8 : B4 < l ? bh < l ? JT < l ? 1 : 8 : G3 < l ? 1 : 8 : r6 < l ? sO < l ? 1 : 8 : ZE < l ? 1 : 8 : uT < l ? Z4 < l ? Yd < l ? Q6 < l ? L4 < l ? N6 < l ? vp < l ? D_ < l ? 1 : 8 : Pd < l ? 1 : 8 : pd < l ? Rg < l ? 1 : 8 : OS < l ? 1 : 8 : G6 < l ? I3 < l ? uk < l ? 1 : 8 : cE < l ? 1 : 8 : l8 < l ? l4 < l ? 1 : 8 : rh < l ? 1 : 8 : M3 < l ? FS < l ? NE < l ? aT < l ? 1 : 8 : kT < l ? 1 : 8 : uS < l ? d3 < l ? 1 : 8 : zd < l ? 1 : 8 : ly < l ? T6 < l ? Pg < l ? 1 : 8 : vy < l ? 1 : 8 : LO < l ? yF < l ? 1 : 8 : YF < l ? 1 : 8 : DI < l ? au < l ? jF < l ? Ah < l ? AO < l ? 1 : 8 : Cd < l ? 1 : 8 : qh < l ? AS < l ? 1 : 8 : lA < l ? 1 : 8 : cO < l ? AI < l ? xI < l ? 1 : 8 : B_ < l ? 1 : 8 : hS < l ? fT < l ? 1 : 8 : mg < l ? 1 : 8 : NO < l ? Nw < l ? Yh < l ? lw < l ? 1 : 8 : Qg < l ? 1 : 8 : Vg < l ? Lk < l ? 1 : 8 : qO < l ? 1 : 8 : iS < l ? b6 < l ? h6 < l ? 1 : 8 : $F < l ? 1 : 8 : ph < l ? rT < l ? 1 : 8 : HS < l ? 1 : 8 : zO < l ? Ck < l ? yS < l ? Iw < l ? CI < l ? Kg < l ? 1 : 8 : VO < l ? 1 : 8 : Mk < l ? ks < l ? 1 : 8 : PF < l ? 1 : 8 : kd < l ? TS < l ? wI < l ? 1 : 8 : xg < l ? 1 : 8 : Rd < l ? dh < l ? 1 : 8 : oI < l ? 1 : 8 : oT < l ? lg < l ? tF < l ? KI < l ? 1 : 8 : pk < l ? 1 : 8 : G_ < l ? kw < l ? 1 : 8 : QF < l ? 1 : 8 : jk < l ? FO < l ? mA < l ? 1 : 8 : _g < l ? 1 : 8 : WE < l ? lF < l ? 1 : 8 : MF < l ? 1 : 8 : h4 < l ? h3 < l ? vT < l ? jI < l ? mS < l ? 1 : 8 : cA < l ? 1 : 8 : DE < l ? zk < l ? 1 : 8 : Lg < l ? 1 : 8 : AT < l ? R6 < l ? bk < l ? 1 : 8 : iT < l ? 1 : 8 : US < l ? BT < l ? 1 : 8 : vE < l ? 1 : 8 : Wc < l ? Sk < l ? D3 < l ? Xg < l ? 1 : 8 : fd < l ? 1 : 8 : IF < l ? ld < l ? 1 : 8 : nA < l ? 1 : 8 : BE < l ? W3 < l ? sy < l ? 1 : 8 : kI < l ? 1 : 8 : VF < l ? fS < l ? 1 : 8 : P4 < l ? 1 : 8 : vS < l ? jw < l ? ik < l ? hO < l ? iI < l ? bg < l ? Nd < l ? 1 : 8 : u3 < l ? 1 : 8 : sE < l ? Ld < l ? 1 : 8 : Xk < l ? 1 : 8 : up < l ? hh < l ? M8 < l ? 1 : 8 : p3 < l ? 1 : 8 : Ew < l ? pE < l ? 1 : 8 : Bg < l ? 1 : 8 : by < l ? Zk < l ? $T < l ? zF < l ? 1 : 8 : Bd < l ? 1 : 8 : $k < l ? TI < l ? 1 : 8 : pO < l ? 1 : 8 : sS < l ? RO < l ? kA < l ? 1 : 8 : wA < l ? 1 : 8 : fg < l ? qI < l ? 1 : 8 : dS < l ? 1 : 8 : hI < l ? NI < l ? nS < l ? Xy < l ? J_ < l ? 1 : 8 : bT < l ? 1 : 8 : $O < l ? Eg < l ? 1 : 8 : oA < l ? 1 : 8 : uE < l ? ET < l ? dg < l ? 1 : 8 : TT < l ? 1 : 8 : Ay < l ? u8 < l ? 1 : 8 : ZS < l ? 1 : 8 : Gh < l ? M_ < l ? SO < l ? lh < l ? 1 : 8 : XE < l ? 1 : 8 : Q3 < l ? Z6 < l ? 1 : 8 : Od < l ? 1 : 8 : W6 < l ? RF < l ? qy < l ? 1 : 8 : Nk < l ? 1 : 8 : PE < l ? Tg < l ? 1 : 8 : OI < l ? 1 : 8 : A8 < l ? P_ < l ? C4 < l ? $g < l ? Uh < l ? WS < l ? 1 : 8 : j6 < l ? 1 : 8 : _E < l ? fI < l ? 1 : 8 : Pw < l ? 1 : 8 : f3 < l ? a8 < l ? UF < l ? 1 : 8 : Lw < l ? 1 : 8 : mk < l ? aI < l ? 1 : 8 : yy < l ? 1 : 8 : O8 < l ? uI < l ? u6 < l ? ky < l ? 1 : 8 : GI < l ? 1 : 8 : c8 < l ? Ow < l ? 1 : 8 : bE < l ? 1 : 8 : y3 < l ? fp < l ? eE < l ? 1 : 8 : I8 < l ? 1 : 8 : cw < l ? KF < l ? 1 : 8 : VI < l ? 1 : 8 : zh < l ? QO < l ? h8 < l ? hy < l ? ew < l ? 1 : 8 : i3 < l ? 1 : 8 : pI < l ? dA < l ? 1 : 8 : qd < l ? 1 : 8 : kg < l ? iE < l ? TO < l ? 1 : 8 : X6 < l ? 1 : 8 : Rw < l ? aw < l ? 1 : 8 : F3 < l ? 1 : 8 : Ik < l ? OF < l ? Ly < l ? m4 < l ? 1 : 8 : cd < l ? 1 : 8 : zg < l ? Jk < l ? 1 : 8 : aS < l ? 1 : 8 : B3 < l ? IO < l ? hw < l ? 1 : 8 : mE < l ? 1 : 8 : $S < l ? QI < l ? 1 : 8 : FA < l ? 1 : 8 : od < l ? KE < l ? Rk < l ? J6 < l ? Md < l ? xF < l ? Zg < l ? sh < l ? eT < l ? 1 : 8 : YI < l ? 1 : 8 : RE < l ? OT < l ? 1 : 8 : J8 < l ? 1 : 8 : IA < l ? dE < l ? qT < l ? 1 : 8 : hd < l ? 1 : 8 : Id < l ? Mh < l ? 1 : 8 : _S < l ? 1 : 8 : EA < l ? PO < l ? Hg < l ? sg < l ? 1 : 8 : Ug < l ? 1 : 8 : Xw < l ? td < l ? 1 : 8 : Dg < l ? 1 : 8 : Ag < l ? bS < l ? Wd < l ? 1 : 8 : Fg < l ? 1 : 8 : tA < l ? wT < l ? 1 : 8 : Dk < l ? 1 : 8 : rS < l ? Z8 < l ? JI < l ? AE < l ? ME < l ? 1 : 8 : pA < l ? 1 : 8 : EO < l ? Gy < l ? 1 : 8 : fA < l ? 1 : 8 : xA < l ? b4 < l ? _k < l ? 1 : 8 : oO < l ? 1 : 8 : wd < l ? S7 < l ? 1 : 8 : $d < l ? 1 : 8 : X8 < l ? z_ < l ? Fd < l ? Ph < l ? 1 : 8 : dT < l ? 1 : 8 : Dd < l ? Ok < l ? 1 : 8 : ah < l ? 1 : 8 : nh < l ? ag < l ? $w < l ? 1 : 8 : WT < l ? 1 : 8 : QS < l ? Fw < l ? 1 : 8 : LT < l ? 1 : 8 : Ih < l ? vk < l ? En < l ? p8 < l ? gT < l ? M6 < l ? 1 : 8 : gh < l ? 1 : 8 : J4 < l ? Q_ < l ? 1 : 8 : op < l ? 1 : 8 : vO < l ? GE < l ? ch < l ? 1 : 8 : q_ < l ? 1 : 8 : ES < l ? UT < l ? 1 : 8 : jS < l ? 1 : 8 : Uw < l ? ty < l ? sA < l ? Vh < l ? 1 : 8 : sT < l ? 1 : 8 : iF < l ? Zd < l ? 1 : 8 : FI < l ? 1 : 8 : xO < l ? th < l ? ng < l ? 1 : 8 : bd < l ? 1 : 8 : iO < l ? _O < l ? 1 : 8 : eO < l ? 1 : 8 : IS < l ? zE < l ? fO < l ? ck < l ? xh < l ? 1 : 8 : ud < l ? 1 : 8 : JS < l ? _w < l ? 1 : 8 : Fy < l ? 1 : 8 : vA < l ? $E < l ? KT < l ? 1 : 8 : rI < l ? 1 : 8 : uy < l ? Tw < l ? 1 : 8 : 1 : nT < l ? Z3 < l ? ek < l ? 8 : $y < l ? 1 : 8 : GF < l ? Qw < l ? 1 : 8 : sk < l ? 1 : 8 : vg < l ? nO < l ? tI < l ? 1 : 8 : GO < l ? 1 : 8 : Ry < l ? 1 : 8 : D8 < l ? Ed < l ? xw < l ? Oh < l ? rA < l ? 8 : $h < l ? tT < l ? 1 : 8 : vF < l ? 1 : 8 : Qy < l ? zI < l ? ry < l ? 1 : 8 : yh < l ? 1 : 8 : HE < l ? Jh < l ? 1 : 8 : hF < l ? 1 : 8 : rp < l ? z4 < l ? S6 < l ? py < l ? 1 : 8 : rg < l ? 1 : 8 : $8 < l ? yO < l ? 1 : 8 : Bk < l ? 1 : 8 : gk < l ? U8 < l ? EF < l ? 1 : 8 : wy < l ? 1 : 8 : og < l ? Tk < l ? 1 : 8 : wE < l ? 1 : 8 : Gw < l ? $_ < l ? ey < l ? pS < l ? oE < l ? 1 : 8 : 1 : 8 : dw < l ? 8 : Q4 < l ? IT < l ? 1 : 8 : yg < l ? 1 : 8 : eI < l ? t3 < l ? Ma < l ? Do < l ? 1 : 2 : BI < l ? 1 : 8 : ow < l ? MT < l ? 1 : 8 : YS < l ? 1 : 8 : yI < l ? tS < l ? Zh < l ? 1 : 8 : CT < l ? 1 : 8 : GT < l ? Kw < l ? 1 : 8 : SI < l ? 1 : 8 : UI < l ? tk < l ? Qn < l ? R4 < l ? q3 < l ? id < l ? 1 : 8 : _F < l ? 1 : 8 : z3 < l ? L6 < l ? 1 : 8 : fh < l ? 1 : 8 : PT < l ? ip < l ? uw < l ? 1 : 8 : eS < l ? 1 : 8 : tO < l ? e3 < l ? 1 : 8 : oh < l ? 1 : 8 : dk < l ? zS < l ? Qh < l ? ug < l ? 1 : 8 : iy < l ? 1 : 8 : Wk < l ? Kd < l ? 1 : 8 : TE < l ? 1 : 8 : dd < l ? my < l ? cF < l ? 1 : 8 : _A < l ? 1 : 8 : Ny < l ? 1 : 8 : Xd < l ? H3 < l ? o3 < l ? Jw < l ? 1 : 8 : av < l ? 8 : RT < l ? 1 : 8 : gF < l ? k6 < l ? NF < l ? 1 : 8 : Wh < l ? 1 : 8 : Gk < l ? Dh < l ? 1 : 8 : ZI < l ? 1 : 8 : Vd < l ? cS < l ? lT < l ? cI < l ? 1 : 8 : 1 : Dy < l ? 8 : Jy < l ? 1 : 8 : FF < l ? sd < l ? 1 : 8 : XT < l ? OO < l ? 1 : 8 : aO < l ? 1 : 8 : wh < l ? F8 < l ? W_ < l ? uh < l ? kO < l ? ed < l ? EI < l ? Aw < l ? 1 : 8 : yA < l ? 1 : 8 : Bh < l ? fy < l ? 1 : 8 : ak < l ? 1 : 8 : CF < l ? TA < l ? lp < l ? 1 : 8 : 1 : 8 : yT < l ? Hd < l ? kS < l ? zy < l ? 1 : 8 : wS < l ? 1 : 8 : v6 < l ? Hk < l ? 1 : 8 : kE < l ? 1 : 8 : Sw < l ? pw < l ? 1 : 8 : _h < l ? WO < l ? 1 : 8 : k8 < l ? 1 : 8 : kF < l ? DO < l ? XF < l ? gy < l ? Sd < l ? 1 : 8 : eA < l ? 1 : 8 : Z_ < l ? JE < l ? 1 : 8 : ay < l ? 1 : 8 : Ky < l ? _8 < l ? Uy < l ? 1 : 8 : n3 < l ? 1 : 8 : rE < l ? oy < l ? 1 : 8 : cg < l ? 1 : 8 : Yy < l ? SA < l ? xS < l ? rF < l ? 1 : 8 : Xh < l ? 1 : 8 : mI < l ? lk < l ? 1 : 8 : uO < l ? 1 : 8 : PS < l && aA < l ? 1 : 8 : yk < l ? Rh < l ? tg < l ? nk < l ? 8 : Zy < l ? bI < l ? 1 : 8 : Ch < l ? 1 : 8 : xE < l ? ok < l ? V_ < l ? 1 : 8 : 1 : 8 : Og < l ? UO < l && oS < l ? 1 : 8 : bw < l ? rO < l ? Lh < l ? 1 : 8 : 1 : dF < l ? 8 : 1 : Eh < l ? gE < l ? U3 < l ? 8 : tw < l ? 1 : 8 : dI < l ? Qd < l ? wO < l ? 1 : 8 : R_ < l ? 1 : 8 : Sh < l ? 1 : 8 : BF < l ? gg < l ? Ad < l ? 1 : 8 : XS < l ? 1 : 8 : Kk < l ? YE < l ? 8 : ih < l ? 1 : 8 : U_ < l ? yE < l ? 1 : 8 : Ht < l ? 1 : 8 : GS < l ? jE < l ? dO < l ? q4 < l ? Ey < l ? E8 < l ? RI < l ? 1 : 8 : nF < l ? 1 : 8 : HF < l ? 1 : 8 : ww < l ? E3 < l ? de < l ? 1 : 8 : 1 : 8 : Ig < l ? Gd < l ? X_ < l ? H_ < l ? 1 : 8 : 1 : 8 : Hw < l ? T3 < l ? vd < l ? 1 : 8 : fF < l ? 1 : 8 : wg < l ? 1 : 8 : z8 < l ? j8 < l ? Eo < l ? PI < l ? 8 : Qx < l ? 1 : 2 : F6 < l ? By < l ? 1 : 8 : IE < l ? 1 : 8 : K8 < l ? z6 < l ? Cg < l ? 1 : 8 : cT < l ? 1 : 8 : o8 < l ? tt < l ? 1 : 8 : Ak < l ? 1 : 8 : NS < l ? tE < l ? j4 < l ? Ng < l ? 1 : 8 : $I < l ? 1 : 8 : P6 < l ? TF < l ? 1 : 8 : p4 < l ? 1 : 8 : _I < l ? fE < l ? gI < l ? 1 : 8 : N3 < l ? 1 : 8 : G4 < l ? B8 < l ? 1 : 8 : Sg < l ? 1 : 8 : N8 < l ? QE < l ? aE < l ? Yk < l ? pT < l ? K_ < l ? 1 : 8 : wF < l ? 1 : 8 : UE < l ? 1 : 8 : rd < l ? vI < l ? 8 : 1 : 8 : MO < l ? mw < l ? YT < l ? s8 < l ? 1 : 8 : AA < l ? 1 : 8 : Yw < l ? Y_ < l ? 1 : 8 : 1 : 8 : Gg < l ? JO < l ? $3 < l ? sp < l ? P8 < l ? 1 : 8 : Q8 < l ? 1 : 8 : gr < l ? t8 < l ? 1 : 8 : 1 : g4 < l ? KS < l ? 8 : m6 < l ? 1 : 8 : mF < l ? Cy < l ? 1 : 8 : R3 < l ? 1 : 8 : Pk < l ? HI < l ? QT < l ? x3 < l ? 1 : 8 : mO < l ? 1 : 8 : Py < l ? O3 < l ? 1 : 8 : ep < l ? 1 : 8 : mo < l ? xc < l ? ox < l ? 1 : 2 : fo < l ? 1 : 2 : $u < l ? Hu < l ? 1 : 3 : Co < l ? 1 : 2 : Vr(ILr, l + 1 | 0) - 1 | 0;
              if (36 < c0 >>> 0) var t0 = q(n);
              else switch (c0) {
                case 0:
                  var t0 = 98;
                  break;
                case 1:
                  var t0 = 99;
                  break;
                case 2:
                  if (G0(n, 1), jc(j(n)) === 0) {
                    for (; ; ) if (G0(n, 1), jc(j(n)) !== 0) {
                      var t0 = q(n);
                      break;
                    }
                  } else var t0 = q(n);
                  break;
                case 3:
                  var t0 = 0;
                  break;
                case 4:
                  G0(n, 0);
                  var o0 = xi(j(n)) !== 0 ? 1 : 0, t0 = o0 && q(n);
                  break;
                case 5:
                  G0(n, 88);
                  var t0 = Ui(j(n)) === 0 ? (G0(n, 58), Ui(j(n)) === 0 ? 54 : q(n)) : q(n);
                  break;
                case 6:
                  var t0 = 7;
                  break;
                case 7:
                  G0(n, 95);
                  var w0 = j(n), _0 = 32 < w0 ? 33 < w0 ? -1 : 0 : -1, t0 = _0 === 0 ? 6 : q(n);
                  break;
                case 8:
                  var t0 = 97;
                  break;
                case 9:
                  G0(n, 84);
                  var t0 = Ui(j(n)) === 0 ? 71 : q(n);
                  break;
                case 10:
                  G0(n, 86);
                  var E0 = j(n), U0 = 37 < E0 ? 61 < E0 ? -1 : Vr(pRr, E0 - 38 | 0) - 1 | 0 : -1, t0 = U0 === 0 ? (G0(n, 51), Ui(j(n)) === 0 ? 76 : q(n)) : U0 === 1 ? 72 : q(n);
                  break;
                case 11:
                  var t0 = 38;
                  break;
                case 12:
                  var t0 = 39;
                  break;
                case 13:
                  G0(n, 82);
                  var b = Ir0(j(n));
                  if (2 < b >>> 0) var t0 = q(n);
                  else switch (b) {
                    case 0:
                      G0(n, 83);
                      var t0 = Ui(j(n)) === 0 ? 70 : q(n);
                      break;
                    case 1:
                      var t0 = 4;
                      break;
                    default:
                      var t0 = 69;
                  }
                  break;
                case 14:
                  G0(n, 80);
                  var R0 = j(n), X = 42 < R0 ? 61 < R0 ? -1 : Vr(mRr, R0 + xy | 0) - 1 | 0 : -1, t0 = X === 0 ? 59 : X === 1 ? 67 : q(n);
                  break;
                case 15:
                  var t0 = 45;
                  break;
                case 16:
                  G0(n, 81);
                  var s0 = j(n), hr = 44 < s0 ? 61 < s0 ? -1 : Vr(eLr, s0 + mv | 0) - 1 | 0 : -1, t0 = hr === 0 ? 60 : hr === 1 ? 68 : q(n);
                  break;
                case 17:
                  G0(n, 43);
                  var Ar = D1(j(n));
                  if (Ar === 0) var t0 = cL(j(n)) === 0 ? 42 : q(n);
                  else if (Ar === 1) for (; ; ) {
                    G0(n, 34);
                    var or = Ps(j(n));
                    if (4 < or >>> 0) var t0 = q(n);
                    else switch (or) {
                      case 0:
                        var t0 = e(n);
                        break;
                      case 1:
                        continue;
                      case 2:
                        var t0 = y(n);
                        break;
                      case 3:
                        r: for (; ; ) {
                          if (pn(j(n)) === 0) for (; ; ) {
                            G0(n, 34);
                            var W0 = Ps(j(n));
                            if (4 < W0 >>> 0) var Lr = q(n);
                            else switch (W0) {
                              case 0:
                                var Lr = e(n);
                                break;
                              case 1:
                                continue;
                              case 2:
                                var Lr = y(n);
                                break;
                              case 3:
                                continue r;
                              default:
                                var Lr = T(n);
                            }
                            break;
                          }
                          else var Lr = q(n);
                          var t0 = Lr;
                          break;
                        }
                        break;
                      default:
                        var t0 = T(n);
                    }
                    break;
                  }
                  else var t0 = q(n);
                  break;
                case 18:
                  G0(n, 93);
                  var Tr = Ir0(j(n));
                  if (2 < Tr >>> 0) var t0 = q(n);
                  else switch (Tr) {
                    case 0:
                      G0(n, 2);
                      var Hr = i9(j(n));
                      if (2 < Hr >>> 0) var t0 = q(n);
                      else switch (Hr) {
                        case 0:
                          for (; ; ) {
                            var Or = i9(j(n));
                            if (2 < Or >>> 0) var t0 = q(n);
                            else switch (Or) {
                              case 0:
                                continue;
                              case 1:
                                var t0 = E(n);
                                break;
                              default:
                                var t0 = d(n);
                            }
                            break;
                          }
                          break;
                        case 1:
                          var t0 = E(n);
                          break;
                        default:
                          var t0 = d(n);
                      }
                      break;
                    case 1:
                      var t0 = 5;
                      break;
                    default:
                      var t0 = 92;
                  }
                  break;
                case 19:
                  G0(n, 34);
                  var fr = lL(j(n));
                  if (8 < fr >>> 0) var t0 = q(n);
                  else switch (fr) {
                    case 0:
                      var t0 = e(n);
                      break;
                    case 1:
                      var t0 = w(n);
                      break;
                    case 2:
                      for (; ; ) {
                        G0(n, 20);
                        var Rr = Mr0(j(n));
                        if (4 < Rr >>> 0) var t0 = q(n);
                        else switch (Rr) {
                          case 0:
                            var t0 = G(n);
                            break;
                          case 1:
                            var t0 = A(n);
                            break;
                          case 2:
                            continue;
                          case 3:
                            for (; ; ) {
                              G0(n, 18);
                              var Wr = u9(j(n));
                              if (3 < Wr >>> 0) var t0 = q(n);
                              else switch (Wr) {
                                case 0:
                                  var t0 = S(n);
                                  break;
                                case 1:
                                  var t0 = A(n);
                                  break;
                                case 2:
                                  continue;
                                default:
                                  G0(n, 17);
                                  var Jr = Bt(j(n));
                                  if (Jr === 0) {
                                    for (; ; ) if (G0(n, 17), dn(j(n)) !== 0) {
                                      var t0 = q(n);
                                      break;
                                    }
                                  } else var t0 = Jr === 1 ? S(n) : q(n);
                              }
                              break;
                            }
                            break;
                          default:
                            G0(n, 19);
                            var ar = Bt(j(n));
                            if (ar === 0) {
                              for (; ; ) if (G0(n, 19), dn(j(n)) !== 0) {
                                var t0 = q(n);
                                break;
                              }
                            } else var t0 = ar === 1 ? G(n) : q(n);
                        }
                        break;
                      }
                      break;
                    case 3:
                      for (; ; ) {
                        G0(n, 18);
                        var _r = u9(j(n));
                        if (3 < _r >>> 0) var t0 = q(n);
                        else switch (_r) {
                          case 0:
                            var t0 = M(n);
                            break;
                          case 1:
                            var t0 = A(n);
                            break;
                          case 2:
                            continue;
                          default:
                            G0(n, 17);
                            var Ir = Bt(j(n));
                            if (Ir === 0) {
                              for (; ; ) if (G0(n, 17), dn(j(n)) !== 0) {
                                var t0 = q(n);
                                break;
                              }
                            } else var t0 = Ir === 1 ? M(n) : q(n);
                        }
                        break;
                      }
                      break;
                    case 4:
                      G0(n, 33);
                      var fe = Pr0(j(n));
                      if (fe === 0) var t0 = e(n);
                      else if (fe === 1) for (; ; ) {
                        G0(n, 12);
                        var v0 = k9(j(n));
                        if (3 < v0 >>> 0) var t0 = q(n);
                        else switch (v0) {
                          case 0:
                            var t0 = K(n);
                            break;
                          case 1:
                            continue;
                          case 2:
                            r: for (; ; ) {
                              if (Gc(j(n)) === 0) for (; ; ) {
                                G0(n, 12);
                                var P = k9(j(n));
                                if (3 < P >>> 0) var Q = q(n);
                                else switch (P) {
                                  case 0:
                                    var Q = V(n);
                                    break;
                                  case 1:
                                    continue;
                                  case 2:
                                    continue r;
                                  default:
                                    G0(n, 10);
                                    var L = Bt(j(n));
                                    if (L === 0) {
                                      for (; ; ) if (G0(n, 9), dn(j(n)) !== 0) {
                                        var Q = q(n);
                                        break;
                                      }
                                    } else var Q = L === 1 ? V(n) : q(n);
                                }
                                break;
                              }
                              else var Q = q(n);
                              var t0 = Q;
                              break;
                            }
                            break;
                          default:
                            G0(n, 10);
                            var i0 = Bt(j(n));
                            if (i0 === 0) {
                              for (; ; ) if (G0(n, 9), dn(j(n)) !== 0) {
                                var t0 = q(n);
                                break;
                              }
                            } else var t0 = i0 === 1 ? K(n) : q(n);
                        }
                        break;
                      }
                      else var t0 = q(n);
                      break;
                    case 5:
                      var t0 = y(n);
                      break;
                    case 6:
                      G0(n, 33);
                      var l0 = Dr0(j(n));
                      if (l0 === 0) var t0 = e(n);
                      else if (l0 === 1) for (; ; ) {
                        G0(n, 16);
                        var S0 = h9(j(n));
                        if (3 < S0 >>> 0) var t0 = q(n);
                        else switch (S0) {
                          case 0:
                            var t0 = f0(n);
                            break;
                          case 1:
                            continue;
                          case 2:
                            r: for (; ; ) {
                              if (zu(j(n)) === 0) for (; ; ) {
                                G0(n, 16);
                                var T0 = h9(j(n));
                                if (3 < T0 >>> 0) var L0 = q(n);
                                else switch (T0) {
                                  case 0:
                                    var L0 = m0(n);
                                    break;
                                  case 1:
                                    continue;
                                  case 2:
                                    continue r;
                                  default:
                                    G0(n, 14);
                                    var rr = Bt(j(n));
                                    if (rr === 0) {
                                      for (; ; ) if (G0(n, 13), dn(j(n)) !== 0) {
                                        var L0 = q(n);
                                        break;
                                      }
                                    } else var L0 = rr === 1 ? m0(n) : q(n);
                                }
                                break;
                              }
                              else var L0 = q(n);
                              var t0 = L0;
                              break;
                            }
                            break;
                          default:
                            G0(n, 14);
                            var B = Bt(j(n));
                            if (B === 0) {
                              for (; ; ) if (G0(n, 13), dn(j(n)) !== 0) {
                                var t0 = q(n);
                                break;
                              }
                            } else var t0 = B === 1 ? f0(n) : q(n);
                        }
                        break;
                      }
                      else var t0 = q(n);
                      break;
                    case 7:
                      G0(n, 33);
                      var Z = Er0(j(n));
                      if (Z === 0) var t0 = e(n);
                      else if (Z === 1) for (; ; ) {
                        G0(n, 24);
                        var p0 = w9(j(n));
                        if (3 < p0 >>> 0) var t0 = q(n);
                        else switch (p0) {
                          case 0:
                            var t0 = k0(n);
                            break;
                          case 1:
                            continue;
                          case 2:
                            r: for (; ; ) {
                              if (Nn(j(n)) === 0) for (; ; ) {
                                G0(n, 24);
                                var b0 = w9(j(n));
                                if (3 < b0 >>> 0) var M0 = q(n);
                                else switch (b0) {
                                  case 0:
                                    var M0 = g0(n);
                                    break;
                                  case 1:
                                    continue;
                                  case 2:
                                    continue r;
                                  default:
                                    G0(n, 22);
                                    var O0 = Bt(j(n));
                                    if (O0 === 0) {
                                      for (; ; ) if (G0(n, 21), dn(j(n)) !== 0) {
                                        var M0 = q(n);
                                        break;
                                      }
                                    } else var M0 = O0 === 1 ? g0(n) : q(n);
                                }
                                break;
                              }
                              else var M0 = q(n);
                              var t0 = M0;
                              break;
                            }
                            break;
                          default:
                            G0(n, 22);
                            var er = Bt(j(n));
                            if (er === 0) {
                              for (; ; ) if (G0(n, 21), dn(j(n)) !== 0) {
                                var t0 = q(n);
                                break;
                              }
                            } else var t0 = er === 1 ? k0(n) : q(n);
                        }
                        break;
                      }
                      else var t0 = q(n);
                      break;
                    default:
                      var t0 = e0(n);
                  }
                  break;
                case 20:
                  G0(n, 34);
                  var yr = o9(j(n));
                  if (5 < yr >>> 0) var t0 = q(n);
                  else switch (yr) {
                    case 0:
                      var t0 = e(n);
                      break;
                    case 1:
                      var t0 = w(n);
                      break;
                    case 2:
                      for (; ; ) {
                        G0(n, 34);
                        var vr = o9(j(n));
                        if (5 < vr >>> 0) var t0 = q(n);
                        else switch (vr) {
                          case 0:
                            var t0 = e(n);
                            break;
                          case 1:
                            var t0 = w(n);
                            break;
                          case 2:
                            continue;
                          case 3:
                            var t0 = y(n);
                            break;
                          case 4:
                            var t0 = x0(n);
                            break;
                          default:
                            var t0 = e0(n);
                        }
                        break;
                      }
                      break;
                    case 3:
                      var t0 = y(n);
                      break;
                    case 4:
                      var t0 = x0(n);
                      break;
                    default:
                      var t0 = e0(n);
                  }
                  break;
                case 21:
                  var t0 = 46;
                  break;
                case 22:
                  var t0 = 44;
                  break;
                case 23:
                  G0(n, 78);
                  var $0 = j(n), Er = 59 < $0 ? 61 < $0 ? -1 : Vr(rN, $0 - 60 | 0) - 1 | 0 : -1, t0 = Er === 0 ? (G0(n, 62), Ui(j(n)) === 0 ? 61 : q(n)) : Er === 1 ? 55 : q(n);
                  break;
                case 24:
                  G0(n, 90);
                  var Mr = sL(j(n)), t0 = Mr === 0 ? (G0(n, 57), Ui(j(n)) === 0 ? 53 : q(n)) : Mr === 1 ? 91 : q(n);
                  break;
                case 25:
                  G0(n, 79);
                  var Br = sL(j(n));
                  if (Br === 0) var t0 = 56;
                  else if (Br === 1) {
                    G0(n, 66);
                    var qr = sL(j(n)), t0 = qr === 0 ? 63 : qr === 1 ? (G0(n, 65), Ui(j(n)) === 0 ? 64 : q(n)) : q(n);
                  } else var t0 = q(n);
                  break;
                case 26:
                  G0(n, 50);
                  var jr = j(n), $r = 45 < jr ? 63 < jr ? -1 : Vr(zDr, jr + v1 | 0) - 1 | 0 : -1, t0 = $r === 0 ? (G0(n, 48), pn(j(n)) === 0 ? 47 : q(n)) : $r === 1 ? (G0(n, 49), Ui(j(n)) === 0 ? 75 : q(n)) : q(n);
                  break;
                case 27:
                  G0(n, 94);
                  var ne = j(n), Qr = 63 < ne ? 64 < ne ? -1 : 0 : -1;
                  if (Qr === 0) {
                    var be = j(n), ae = 96 < be ? j7 < be ? -1 : Vr(VLr, be + Y3 | 0) - 1 | 0 : -1;
                    if (ae === 0) if (gr0(j(n)) === 0) {
                      var pe = j(n), oe = uc < pe ? tl < pe ? -1 : 0 : -1;
                      if (oe === 0 && vL(j(n)) === 0 && Bl(j(n)) === 0) var ce = j(n), ge = 72 < ce ? 73 < ce ? -1 : 0 : -1, t0 = ge === 0 && s9(j(n)) === 0 && Ul(j(n)) === 0 && y9(j(n)) === 0 && Lr0(j(n)) === 0 && s9(j(n)) === 0 && v9(j(n)) === 0 && y9(j(n)) === 0 ? 35 : q(n);
                      else var t0 = q(n);
                    } else var t0 = q(n);
                    else var t0 = ae === 1 && s9(j(n)) === 0 && Ul(j(n)) === 0 && y9(j(n)) === 0 && Lr0(j(n)) === 0 && s9(j(n)) === 0 && v9(j(n)) === 0 && y9(j(n)) === 0 ? 35 : q(n);
                  } else var t0 = q(n);
                  break;
                case 28:
                  var t0 = 40;
                  break;
                case 29:
                  if (G0(n, 96), Ls(j(n)) === 0) {
                    var q0 = L1(j(n));
                    if (q0 === 0) var t0 = Nn(j(n)) === 0 && Nn(j(n)) === 0 && Nn(j(n)) === 0 ? 97 : q(n);
                    else if (q0 === 1 && Nn(j(n)) === 0) for (; ; ) {
                      var Fr = A1(j(n));
                      if (Fr !== 0) {
                        var t0 = Fr === 1 ? 97 : q(n);
                        break;
                      }
                    }
                    else var t0 = q(n);
                  } else var t0 = q(n);
                  break;
                case 30:
                  var t0 = 41;
                  break;
                case 31:
                  G0(n, 87);
                  var t0 = Ui(j(n)) === 0 ? 74 : q(n);
                  break;
                case 32:
                  var t0 = 8;
                  break;
                case 33:
                  var t0 = 36;
                  break;
                case 34:
                  G0(n, 85);
                  var _ = j(n), k = 60 < _ ? X2 < _ ? -1 : Vr(_Rr, _ + SS | 0) - 1 | 0 : -1, t0 = k === 0 ? 73 : k === 1 ? (G0(n, 52), Ui(j(n)) === 0 ? 77 : q(n)) : q(n);
                  break;
                case 35:
                  var t0 = 37;
                  break;
                default:
                  var t0 = 89;
              }
              if (99 < t0 >>> 0) return ke(vPr);
              var I = t0;
              if (50 <= I) switch (I) {
                case 50:
                  return [0, t, 85];
                case 51:
                  return [0, t, 88];
                case 52:
                  return [0, t, 87];
                case 53:
                  return [0, t, 94];
                case 54:
                  return [0, t, 95];
                case 55:
                  return [0, t, 96];
                case 56:
                  return [0, t, 97];
                case 57:
                  return [0, t, 92];
                case 58:
                  return [0, t, 93];
                case 59:
                  return [0, t, cf];
                case 60:
                  return [0, t, T7];
                case 61:
                  return [0, t, 69];
                case 62:
                  return [0, t, ti];
                case 63:
                  return [0, t, 68];
                case 64:
                  return [0, t, 67];
                case 65:
                  return [0, t, Ri];
                case 66:
                  return [0, t, R7];
                case 67:
                  return [0, t, 78];
                case 68:
                  return [0, t, 77];
                case 69:
                  return [0, t, 75];
                case 70:
                  return [0, t, 76];
                case 71:
                  return [0, t, 73];
                case 72:
                  return [0, t, 72];
                case 73:
                  return [0, t, 71];
                case 74:
                  return [0, t, 70];
                case 75:
                  return [0, t, 79];
                case 76:
                  return [0, t, 80];
                case 77:
                  return [0, t, 81];
                case 78:
                  return [0, t, 98];
                case 79:
                  return [0, t, 99];
                case 80:
                  return [0, t, s7];
                case 81:
                  return [0, t, L7];
                case 82:
                  return [0, t, Yt];
                case 83:
                  return [0, t, Zc];
                case 84:
                  return [0, t, is];
                case 85:
                  return [0, t, 89];
                case 86:
                  return [0, t, 91];
                case 87:
                  return [0, t, 90];
                case 88:
                  return [0, t, Fv];
                case 89:
                  return [0, t, Xt];
                case 90:
                  return [0, t, 82];
                case 91:
                  return [0, t, 11];
                case 92:
                  return [0, t, 74];
                case 93:
                  return [0, t, j7];
                case 94:
                  return [0, t, 13];
                case 95:
                  return [0, t, 14];
                case 96:
                  return [2, Ei(t, nt(t, n))];
                case 97:
                  var U = n[6];
                  Hr0(n);
                  var Y = Hl(t, U, n[3]);
                  tL(n, U);
                  var y0 = Ll(n), P0 = Wr0(t, y0), I0 = P0[2], D = Ee(I0, yPr);
                  if (0 <= D) {
                    if (!(0 < D)) return [0, t, 18];
                    var u0 = Ee(I0, XPr);
                    if (0 <= u0) {
                      if (!(0 < u0)) return [0, t, 51];
                      var X0 = Ee(I0, tDr);
                      if (0 <= X0) {
                        if (!(0 < X0)) return [0, t, 46];
                        if (!n0(I0, cDr)) return [0, t, 24];
                        if (!n0(I0, sDr)) return [0, t, 47];
                        if (!n0(I0, vDr)) return [0, t, 25];
                        if (!n0(I0, lDr)) return [0, t, 26];
                        if (!n0(I0, bDr)) return [0, t, 58];
                      } else {
                        if (!n0(I0, uDr)) return [0, t, 20];
                        if (!n0(I0, iDr)) return [0, t, 21];
                        if (!n0(I0, fDr)) return [0, t, 22];
                        if (!n0(I0, xDr)) return [0, t, 31];
                        if (!n0(I0, oDr)) return [0, t, 23];
                        if (!n0(I0, aDr)) return [0, t, 61];
                      }
                    } else {
                      var J0 = Ee(I0, YPr);
                      if (0 <= J0) {
                        if (!(0 < J0)) return [0, t, 54];
                        if (!n0(I0, ZPr)) return [0, t, 55];
                        if (!n0(I0, QPr)) return [0, t, 56];
                        if (!n0(I0, rDr)) return [0, t, 57];
                        if (!n0(I0, eDr)) return [0, t, 19];
                        if (!n0(I0, nDr)) return [0, t, 42];
                      } else {
                        if (!n0(I0, VPr)) return [0, t, 53];
                        if (!n0(I0, zPr)) return [0, t, 28];
                        if (!n0(I0, KPr)) return [0, t, 44];
                        if (!n0(I0, WPr)) return [0, t, 29];
                        if (!n0(I0, JPr)) return [0, t, 63];
                        if (!n0(I0, $Pr)) return [0, t, 62];
                      }
                    }
                  } else {
                    var ir = Ee(I0, hPr);
                    if (0 <= ir) {
                      if (!(0 < ir)) return [0, t, 37];
                      var Q0 = Ee(I0, CPr);
                      if (0 <= Q0) {
                        if (!(0 < Q0)) return [0, t, 39];
                        if (!n0(I0, MPr)) return [0, t, 15];
                        if (!n0(I0, BPr)) return [0, t, 16];
                        if (!n0(I0, qPr)) return [0, t, 52];
                        if (!n0(I0, UPr)) return [0, t, 50];
                        if (!n0(I0, HPr)) return [0, t, 17];
                      } else {
                        if (!n0(I0, PPr)) return [0, t, 43];
                        if (!n0(I0, DPr)) return [0, t, 48];
                        if (!n0(I0, LPr)) return [0, t, 49];
                        if (!n0(I0, RPr)) return [0, t, 41];
                        if (!n0(I0, jPr)) return [0, t, 30];
                        if (!n0(I0, GPr)) return [0, t, 38];
                      }
                    } else {
                      var F0 = Ee(I0, dPr);
                      if (0 <= F0) {
                        if (!(0 < F0)) return [0, t, 27];
                        if (!n0(I0, TPr)) return [0, t, 35];
                        if (!n0(I0, OPr)) return [0, t, 59];
                        if (!n0(I0, IPr)) return [0, t, 60];
                        if (!n0(I0, APr)) return [0, t, 36];
                        if (!n0(I0, NPr)) return [0, t, 45];
                      } else {
                        if (!n0(I0, kPr)) return [0, t, 64];
                        if (!n0(I0, wPr)) return [0, t, 65];
                        if (!n0(I0, EPr)) return [0, t, 32];
                        if (!n0(I0, SPr)) return [0, t, 33];
                        if (!n0(I0, gPr)) return [0, t, 34];
                        if (!n0(I0, FPr)) return [0, t, 40];
                      }
                    }
                  }
                  var Sr = [4, Y, I0, uL(y0)];
                  return [0, P0[1], Sr];
                case 98:
                  var mr = t[4] ? Gu(t, nt(t, n), 6) : t;
                  return [0, mr, Pn];
                default:
                  var Cr = Ei(t, nt(t, n));
                  return [0, Cr, [6, Se(n)]];
              }
              switch (I) {
                case 0:
                  return [2, d7(t, n)];
                case 1:
                  return [2, t];
                case 2:
                  var sr = ju(t, n), Pr = $n(zn), K0 = R1(t, Pr, n), Ur = K0[1];
                  return [1, Ur, Si(Ur, sr, K0[2], Pr, 1)];
                case 3:
                  var h0 = Se(n);
                  if (t[5]) {
                    var Kr = t[4] ? Yr0(t, nt(t, n), h0) : t, re = $m(1, Kr), xe = Jm(n);
                    return qn(jl(n, xe - 1 | 0, 1), lPr) && n0(jl(n, xe - 2 | 0, 1), bPr) ? [0, re, 86] : [2, re];
                  }
                  var Re = ju(t, n), ve = $n(zn);
                  hn(ve, m7(h0, 2, un(h0) - 2 | 0));
                  var Ie = R1(t, ve, n), Ge = Ie[1];
                  return [1, Ge, Si(Ge, Re, Ie[2], ve, 1)];
                case 4:
                  if (t[4]) return [2, $m(0, t)];
                  $v(n), gn(n);
                  var Me = Tr0(j(n)) !== 0 ? 1 : 0, an = Me && q(n);
                  return an === 0 ? [0, t, Yt] : ke(pPr);
                case 5:
                  var We = ju(t, n), Ae = $n(zn), cn = e2(t, Ae, n), rn = cn[1];
                  return [1, rn, Si(rn, We, cn[2], Ae, 0)];
                case 6:
                  return n[6] === 0 ? [2, e2(t, $n(zn), n)[1]] : [0, t, mPr];
                case 7:
                  var kn = Se(n), vn = ju(t, n), Ne = $n(zn), Je = $n(zn);
                  hn(Je, kn);
                  var en = $r0(t, kn, Ne, Je, 0, n), _n = en[1], Cn = [0, _n[1], vn, en[2]], Hn = en[3], Fn = Mt(Je);
                  return [0, _n, [2, [0, Cn, Mt(Ne), Fn, Hn]]];
                case 8:
                  var vt = $n(zn), Nt = $n(zn), gt = $n(zn);
                  Gl(n, gt);
                  var Zt = ju(t, n), qt = Zr0(t, vt, Nt, gt, n), Ft = qt[1], Ct = h7(Ft, n), du = [0, Ft[1], Zt, Ct], Wu = qt[2], lt = Mt(gt), ou = Mt(Nt);
                  return [0, Ft, [3, [0, du, [0, Mt(vt), ou, lt], Wu]]];
                case 9:
                  return Rt(t, n, function(B0, D0) {
                    if (gn(D0), Cs(j(D0)) === 0 && c9(j(D0)) === 0 && Gc(j(D0)) === 0) for (; ; ) {
                      var Le = n9(j(D0));
                      if (2 < Le >>> 0) var me = q(D0);
                      else switch (Le) {
                        case 0:
                          continue;
                        case 1:
                          r: for (; ; ) {
                            if (Gc(j(D0)) === 0) for (; ; ) {
                              var He = n9(j(D0));
                              if (2 < He >>> 0) var he = q(D0);
                              else switch (He) {
                                case 0:
                                  continue;
                                case 1:
                                  continue r;
                                default:
                                  var he = 0;
                              }
                              break;
                            }
                            else var he = q(D0);
                            var me = he;
                            break;
                          }
                          break;
                        default:
                          var me = 0;
                      }
                      break;
                    }
                    else var me = q(D0);
                    return me === 0 ? [0, B0, [1, 0, Se(D0)]] : ke(sPr);
                  });
                case 10:
                  return [0, t, [1, 0, Se(n)]];
                case 11:
                  return Rt(t, n, function(B0, D0) {
                    if (gn(D0), Cs(j(D0)) === 0 && c9(j(D0)) === 0 && Gc(j(D0)) === 0) for (; ; ) {
                      G0(D0, 0);
                      var Le = e9(j(D0));
                      if (Le !== 0) {
                        if (Le === 1) r: for (; ; ) {
                          if (Gc(j(D0)) === 0) for (; ; ) {
                            G0(D0, 0);
                            var He = e9(j(D0));
                            if (He !== 0) {
                              if (He === 1) continue r;
                              var he = q(D0);
                              break;
                            }
                          }
                          else var he = q(D0);
                          var me = he;
                          break;
                        }
                        else var me = q(D0);
                        break;
                      }
                    }
                    else var me = q(D0);
                    return me === 0 ? [0, B0, [0, 0, Se(D0)]] : ke(cPr);
                  });
                case 12:
                  return [0, t, [0, 0, Se(n)]];
                case 13:
                  return Rt(t, n, function(B0, D0) {
                    if (gn(D0), Cs(j(D0)) === 0 && b9(j(D0)) === 0 && zu(j(D0)) === 0) for (; ; ) {
                      var Le = a9(j(D0));
                      if (2 < Le >>> 0) var me = q(D0);
                      else switch (Le) {
                        case 0:
                          continue;
                        case 1:
                          r: for (; ; ) {
                            if (zu(j(D0)) === 0) for (; ; ) {
                              var He = a9(j(D0));
                              if (2 < He >>> 0) var he = q(D0);
                              else switch (He) {
                                case 0:
                                  continue;
                                case 1:
                                  continue r;
                                default:
                                  var he = 0;
                              }
                              break;
                            }
                            else var he = q(D0);
                            var me = he;
                            break;
                          }
                          break;
                        default:
                          var me = 0;
                      }
                      break;
                    }
                    else var me = q(D0);
                    return me === 0 ? [0, B0, [1, 1, Se(D0)]] : ke(aPr);
                  });
                case 14:
                  return [0, t, [1, 1, Se(n)]];
                case 15:
                  return Rt(t, n, function(B0, D0) {
                    if (gn(D0), Cs(j(D0)) === 0 && b9(j(D0)) === 0 && zu(j(D0)) === 0) for (; ; ) {
                      G0(D0, 0);
                      var Le = x9(j(D0));
                      if (Le !== 0) {
                        if (Le === 1) r: for (; ; ) {
                          if (zu(j(D0)) === 0) for (; ; ) {
                            G0(D0, 0);
                            var He = x9(j(D0));
                            if (He !== 0) {
                              if (He === 1) continue r;
                              var he = q(D0);
                              break;
                            }
                          }
                          else var he = q(D0);
                          var me = he;
                          break;
                        }
                        else var me = q(D0);
                        break;
                      }
                    }
                    else var me = q(D0);
                    return me === 0 ? [0, B0, [0, 3, Se(D0)]] : ke(oPr);
                  });
                case 16:
                  return [0, t, [0, 3, Se(n)]];
                case 17:
                  return Rt(t, n, function(B0, D0) {
                    if (gn(D0), Cs(j(D0)) === 0) for (; ; ) {
                      var Le = j(D0), He = 47 < Le ? 57 < Le ? -1 : Vr(uRr, Le + Wt | 0) - 1 | 0 : -1;
                      if (He !== 0) {
                        if (He === 1) {
                          for (; ; ) if (G0(D0, 0), pn(j(D0)) !== 0) {
                            var he = q(D0);
                            break;
                          }
                        } else var he = q(D0);
                        break;
                      }
                    }
                    else var he = q(D0);
                    return he === 0 ? [0, B0, [0, 2, Se(D0)]] : ke(xPr);
                  });
                case 18:
                  return [0, t, [0, 2, Se(n)]];
                case 19:
                  return Rt(t, n, function(B0, D0) {
                    if (gn(D0), Cs(j(D0)) === 0 && zu(j(D0)) === 0) {
                      for (; ; ) if (G0(D0, 0), zu(j(D0)) !== 0) {
                        var Le = q(D0);
                        break;
                      }
                    } else var Le = q(D0);
                    return Le === 0 ? [0, B0, [0, 1, Se(D0)]] : ke(fPr);
                  });
                case 20:
                  return [0, t, [0, 1, Se(n)]];
                case 21:
                  return Rt(t, n, function(B0, D0) {
                    if (gn(D0), Cs(j(D0)) === 0 && Zm(j(D0)) === 0 && Nn(j(D0)) === 0) for (; ; ) {
                      var Le = t9(j(D0));
                      if (2 < Le >>> 0) var me = q(D0);
                      else switch (Le) {
                        case 0:
                          continue;
                        case 1:
                          r: for (; ; ) {
                            if (Nn(j(D0)) === 0) for (; ; ) {
                              var He = t9(j(D0));
                              if (2 < He >>> 0) var he = q(D0);
                              else switch (He) {
                                case 0:
                                  continue;
                                case 1:
                                  continue r;
                                default:
                                  var he = 0;
                              }
                              break;
                            }
                            else var he = q(D0);
                            var me = he;
                            break;
                          }
                          break;
                        default:
                          var me = 0;
                      }
                      break;
                    }
                    else var me = q(D0);
                    return me === 0 ? [0, B0, [1, 2, Se(D0)]] : ke(iPr);
                  });
                case 23:
                  return Rt(t, n, function(B0, D0) {
                    if (gn(D0), Cs(j(D0)) === 0 && Zm(j(D0)) === 0 && Nn(j(D0)) === 0) for (; ; ) {
                      G0(D0, 0);
                      var Le = _9(j(D0));
                      if (Le !== 0) {
                        if (Le === 1) r: for (; ; ) {
                          if (Nn(j(D0)) === 0) for (; ; ) {
                            G0(D0, 0);
                            var He = _9(j(D0));
                            if (He !== 0) {
                              if (He === 1) continue r;
                              var he = q(D0);
                              break;
                            }
                          }
                          else var he = q(D0);
                          var me = he;
                          break;
                        }
                        else var me = q(D0);
                        break;
                      }
                    }
                    else var me = q(D0);
                    return me === 0 ? [0, B0, [0, 4, Se(D0)]] : ke(uPr);
                  });
                case 25:
                  return Rt(t, n, function(B0, D0) {
                    function Le(ln) {
                      for (; ; ) {
                        var it = wi(j(ln));
                        if (2 < it >>> 0) return q(ln);
                        switch (it) {
                          case 0:
                            continue;
                          case 1:
                            r: for (; ; ) {
                              if (pn(j(ln)) === 0) for (; ; ) {
                                var Tt = wi(j(ln));
                                if (2 < Tt >>> 0) return q(ln);
                                switch (Tt) {
                                  case 0:
                                    continue;
                                  case 1:
                                    continue r;
                                  default:
                                    return 0;
                                }
                              }
                              return q(ln);
                            }
                          default:
                            return 0;
                        }
                      }
                    }
                    function He(ln) {
                      for (; ; ) {
                        var it = r2(j(ln));
                        if (it !== 0) {
                          var Tt = it !== 1 ? 1 : 0;
                          return Tt && q(ln);
                        }
                      }
                    }
                    function he(ln) {
                      var it = E9(j(ln));
                      if (2 < it >>> 0) return q(ln);
                      switch (it) {
                        case 0:
                          var Tt = C1(j(ln));
                          return Tt === 0 ? He(ln) : Tt === 1 ? Le(ln) : q(ln);
                        case 1:
                          return He(ln);
                        default:
                          return Le(ln);
                      }
                    }
                    function me(ln) {
                      var it = p9(j(ln));
                      if (it === 0) for (; ; ) {
                        var Tt = f7(j(ln));
                        if (2 < Tt >>> 0) return q(ln);
                        switch (Tt) {
                          case 0:
                            continue;
                          case 1:
                            return he(ln);
                          default:
                            r: for (; ; ) {
                              if (pn(j(ln)) === 0) for (; ; ) {
                                var Ti = f7(j(ln));
                                if (2 < Ti >>> 0) return q(ln);
                                switch (Ti) {
                                  case 0:
                                    continue;
                                  case 1:
                                    return he(ln);
                                  default:
                                    continue r;
                                }
                              }
                              return q(ln);
                            }
                        }
                      }
                      return it === 1 ? he(ln) : q(ln);
                    }
                    gn(D0);
                    var Zn = Qm(j(D0));
                    if (2 < Zn >>> 0) var wn = q(D0);
                    else switch (Zn) {
                      case 0:
                        if (pn(j(D0)) === 0) for (; ; ) {
                          var ft = f7(j(D0));
                          if (2 < ft >>> 0) var wn = q(D0);
                          else switch (ft) {
                            case 0:
                              continue;
                            case 1:
                              var wn = he(D0);
                              break;
                            default:
                              r: for (; ; ) {
                                if (pn(j(D0)) === 0) for (; ; ) {
                                  var xt = f7(j(D0));
                                  if (2 < xt >>> 0) var jn = q(D0);
                                  else switch (xt) {
                                    case 0:
                                      continue;
                                    case 1:
                                      var jn = he(D0);
                                      break;
                                    default:
                                      continue r;
                                  }
                                  break;
                                }
                                else var jn = q(D0);
                                var wn = jn;
                                break;
                              }
                          }
                          break;
                        }
                        else var wn = q(D0);
                        break;
                      case 1:
                        var ut = r9(j(D0)), wn = ut === 0 ? me(D0) : ut === 1 ? he(D0) : q(D0);
                        break;
                      default:
                        for (; ; ) {
                          var dt = l9(j(D0));
                          if (2 < dt >>> 0) var wn = q(D0);
                          else switch (dt) {
                            case 0:
                              var wn = me(D0);
                              break;
                            case 1:
                              continue;
                            default:
                              var wn = he(D0);
                          }
                          break;
                        }
                    }
                    if (wn === 0) {
                      var xn = Gu(B0, nt(B0, D0), 23);
                      return [0, xn, [1, 2, Se(D0)]];
                    }
                    return ke(tPr);
                  });
                case 26:
                  var Bu = Gu(t, nt(t, n), 23);
                  return [0, Bu, [1, 2, Se(n)]];
                case 27:
                  return Rt(t, n, function(B0, D0) {
                    function Le(xn) {
                      for (; ; ) {
                        G0(xn, 0);
                        var ln = Ds(j(xn));
                        if (ln !== 0) {
                          if (ln === 1) r: for (; ; ) {
                            if (pn(j(xn)) === 0) for (; ; ) {
                              G0(xn, 0);
                              var it = Ds(j(xn));
                              if (it !== 0) {
                                if (it === 1) continue r;
                                return q(xn);
                              }
                            }
                            return q(xn);
                          }
                          return q(xn);
                        }
                      }
                    }
                    function He(xn) {
                      for (; ; ) if (G0(xn, 0), pn(j(xn)) !== 0) return q(xn);
                    }
                    function he(xn) {
                      var ln = E9(j(xn));
                      if (2 < ln >>> 0) return q(xn);
                      switch (ln) {
                        case 0:
                          var it = C1(j(xn));
                          return it === 0 ? He(xn) : it === 1 ? Le(xn) : q(xn);
                        case 1:
                          return He(xn);
                        default:
                          return Le(xn);
                      }
                    }
                    function me(xn) {
                      var ln = p9(j(xn));
                      if (ln === 0) for (; ; ) {
                        var it = f7(j(xn));
                        if (2 < it >>> 0) return q(xn);
                        switch (it) {
                          case 0:
                            continue;
                          case 1:
                            return he(xn);
                          default:
                            r: for (; ; ) {
                              if (pn(j(xn)) === 0) for (; ; ) {
                                var Tt = f7(j(xn));
                                if (2 < Tt >>> 0) return q(xn);
                                switch (Tt) {
                                  case 0:
                                    continue;
                                  case 1:
                                    return he(xn);
                                  default:
                                    continue r;
                                }
                              }
                              return q(xn);
                            }
                        }
                      }
                      return ln === 1 ? he(xn) : q(xn);
                    }
                    gn(D0);
                    var Zn = Qm(j(D0));
                    if (2 < Zn >>> 0) var wn = q(D0);
                    else switch (Zn) {
                      case 0:
                        if (pn(j(D0)) === 0) for (; ; ) {
                          var ft = f7(j(D0));
                          if (2 < ft >>> 0) var wn = q(D0);
                          else switch (ft) {
                            case 0:
                              continue;
                            case 1:
                              var wn = he(D0);
                              break;
                            default:
                              r: for (; ; ) {
                                if (pn(j(D0)) === 0) for (; ; ) {
                                  var xt = f7(j(D0));
                                  if (2 < xt >>> 0) var jn = q(D0);
                                  else switch (xt) {
                                    case 0:
                                      continue;
                                    case 1:
                                      var jn = he(D0);
                                      break;
                                    default:
                                      continue r;
                                  }
                                  break;
                                }
                                else var jn = q(D0);
                                var wn = jn;
                                break;
                              }
                          }
                          break;
                        }
                        else var wn = q(D0);
                        break;
                      case 1:
                        var ut = r9(j(D0)), wn = ut === 0 ? me(D0) : ut === 1 ? he(D0) : q(D0);
                        break;
                      default:
                        for (; ; ) {
                          var dt = l9(j(D0));
                          if (2 < dt >>> 0) var wn = q(D0);
                          else switch (dt) {
                            case 0:
                              var wn = me(D0);
                              break;
                            case 1:
                              continue;
                            default:
                              var wn = he(D0);
                          }
                          break;
                        }
                    }
                    return wn === 0 ? [0, B0, [0, 4, Se(D0)]] : ke(nPr);
                  });
                case 29:
                  return Rt(t, n, function(B0, D0) {
                    function Le(ut) {
                      for (; ; ) {
                        var dt = wi(j(ut));
                        if (2 < dt >>> 0) return q(ut);
                        switch (dt) {
                          case 0:
                            continue;
                          case 1:
                            r: for (; ; ) {
                              if (pn(j(ut)) === 0) for (; ; ) {
                                var xn = wi(j(ut));
                                if (2 < xn >>> 0) return q(ut);
                                switch (xn) {
                                  case 0:
                                    continue;
                                  case 1:
                                    continue r;
                                  default:
                                    return 0;
                                }
                              }
                              return q(ut);
                            }
                          default:
                            return 0;
                        }
                      }
                    }
                    function He(ut) {
                      var dt = r2(j(ut));
                      if (dt === 0) return Le(ut);
                      var xn = dt !== 1 ? 1 : 0;
                      return xn && q(ut);
                    }
                    gn(D0);
                    var he = Qm(j(D0));
                    if (2 < he >>> 0) var me = q(D0);
                    else switch (he) {
                      case 0:
                        var me = pn(j(D0)) === 0 ? Le(D0) : q(D0);
                        break;
                      case 1:
                        for (; ; ) {
                          var Zn = D1(j(D0));
                          if (Zn === 0) var me = He(D0);
                          else {
                            if (Zn === 1) continue;
                            var me = q(D0);
                          }
                          break;
                        }
                        break;
                      default:
                        for (; ; ) {
                          var wn = Bc(j(D0));
                          if (2 < wn >>> 0) var me = q(D0);
                          else switch (wn) {
                            case 0:
                              var me = He(D0);
                              break;
                            case 1:
                              continue;
                            default:
                              r: for (; ; ) {
                                if (pn(j(D0)) === 0) for (; ; ) {
                                  var ft = Bc(j(D0));
                                  if (2 < ft >>> 0) var xt = q(D0);
                                  else switch (ft) {
                                    case 0:
                                      var xt = He(D0);
                                      break;
                                    case 1:
                                      continue;
                                    default:
                                      continue r;
                                  }
                                  break;
                                }
                                else var xt = q(D0);
                                var me = xt;
                                break;
                              }
                          }
                          break;
                        }
                    }
                    if (me === 0) {
                      var jn = Gu(B0, nt(B0, D0), 22);
                      return [0, jn, [1, 2, Se(D0)]];
                    }
                    return ke(ePr);
                  });
                case 30:
                  return Rt(t, n, function(B0, D0) {
                    gn(D0);
                    var Le = C1(j(D0));
                    if (Le === 0) for (; ; ) {
                      var He = r2(j(D0));
                      if (He !== 0) {
                        var he = He !== 1 ? 1 : 0, ft = he && q(D0);
                        break;
                      }
                    }
                    else if (Le === 1) for (; ; ) {
                      var me = wi(j(D0));
                      if (2 < me >>> 0) var ft = q(D0);
                      else switch (me) {
                        case 0:
                          continue;
                        case 1:
                          r: for (; ; ) {
                            if (pn(j(D0)) === 0) for (; ; ) {
                              var Zn = wi(j(D0));
                              if (2 < Zn >>> 0) var wn = q(D0);
                              else switch (Zn) {
                                case 0:
                                  continue;
                                case 1:
                                  continue r;
                                default:
                                  var wn = 0;
                              }
                              break;
                            }
                            else var wn = q(D0);
                            var ft = wn;
                            break;
                          }
                          break;
                        default:
                          var ft = 0;
                      }
                      break;
                    }
                    else var ft = q(D0);
                    return ft === 0 ? [0, B0, [1, 2, Se(D0)]] : ke(rPr);
                  });
                case 31:
                  var K7 = Gu(t, nt(t, n), 22);
                  return [0, K7, [1, 2, Se(n)]];
                case 33:
                  return Rt(t, n, function(B0, D0) {
                    function Le(jn) {
                      for (; ; ) {
                        G0(jn, 0);
                        var ut = Ds(j(jn));
                        if (ut !== 0) {
                          if (ut === 1) r: for (; ; ) {
                            if (pn(j(jn)) === 0) for (; ; ) {
                              G0(jn, 0);
                              var dt = Ds(j(jn));
                              if (dt !== 0) {
                                if (dt === 1) continue r;
                                return q(jn);
                              }
                            }
                            return q(jn);
                          }
                          return q(jn);
                        }
                      }
                    }
                    function He(jn) {
                      return G0(jn, 0), pn(j(jn)) === 0 ? Le(jn) : q(jn);
                    }
                    gn(D0);
                    var he = Qm(j(D0));
                    if (2 < he >>> 0) var me = q(D0);
                    else switch (he) {
                      case 0:
                        var me = pn(j(D0)) === 0 ? Le(D0) : q(D0);
                        break;
                      case 1:
                        for (; ; ) {
                          G0(D0, 0);
                          var Zn = D1(j(D0));
                          if (Zn === 0) var me = He(D0);
                          else {
                            if (Zn === 1) continue;
                            var me = q(D0);
                          }
                          break;
                        }
                        break;
                      default:
                        for (; ; ) {
                          G0(D0, 0);
                          var wn = Bc(j(D0));
                          if (2 < wn >>> 0) var me = q(D0);
                          else switch (wn) {
                            case 0:
                              var me = He(D0);
                              break;
                            case 1:
                              continue;
                            default:
                              r: for (; ; ) {
                                if (pn(j(D0)) === 0) for (; ; ) {
                                  G0(D0, 0);
                                  var ft = Bc(j(D0));
                                  if (2 < ft >>> 0) var xt = q(D0);
                                  else switch (ft) {
                                    case 0:
                                      var xt = He(D0);
                                      break;
                                    case 1:
                                      continue;
                                    default:
                                      continue r;
                                  }
                                  break;
                                }
                                else var xt = q(D0);
                                var me = xt;
                                break;
                              }
                          }
                          break;
                        }
                    }
                    return me === 0 ? [0, B0, [0, 4, Se(D0)]] : ke(QCr);
                  });
                case 35:
                  var Yi = nt(t, n), a7 = Se(n);
                  return [0, t, [4, Yi, a7, a7]];
                case 36:
                  return [0, t, 0];
                case 37:
                  return [0, t, 1];
                case 38:
                  return [0, t, 4];
                case 39:
                  return [0, t, 5];
                case 40:
                  return [0, t, 6];
                case 41:
                  return [0, t, 7];
                case 42:
                  return [0, t, 12];
                case 43:
                  return [0, t, 10];
                case 44:
                  return [0, t, 8];
                case 45:
                  return [0, t, 9];
                case 46:
                  return [0, t, 86];
                case 47:
                  $v(n), gn(n);
                  var Hc = j(n), W7 = 62 < Hc ? 63 < Hc ? -1 : 0 : -1, Ut = W7 !== 0 ? 1 : 0, bt = Ut && q(n);
                  return bt === 0 ? [0, t, 85] : ke(_Pr);
                case 48:
                  return [0, t, 83];
                case 49:
                  return [0, t, 84];
                case 22:
                case 32:
                  return [0, t, [1, 2, Se(n)]];
                default:
                  return [0, t, [0, 4, Se(n)]];
              }
            }
            function Dee(t, n) {
              gn(n);
              var e = j(n), i = ef < e ? Eo < e ? Ma < e ? Do < e ? 1 : 2 : Qx < e ? 1 : 2 : mo < e ? xc < e ? ox < e ? 1 : 2 : fo < e ? 1 : 2 : $u < e ? Hu < e ? 1 : 3 : Co < e ? 1 : 2 : Vr(ALr, e + 1 | 0) - 1 | 0;
              if (5 < i >>> 0) var x = q(n);
              else switch (i) {
                case 0:
                  var x = 0;
                  break;
                case 1:
                  var x = 6;
                  break;
                case 2:
                  if (G0(n, 2), jc(j(n)) === 0) {
                    for (; ; ) if (G0(n, 2), jc(j(n)) !== 0) {
                      var x = q(n);
                      break;
                    }
                  } else var x = q(n);
                  break;
                case 3:
                  var x = 1;
                  break;
                case 4:
                  G0(n, 1);
                  var x = xi(j(n)) === 0 ? 1 : q(n);
                  break;
                default:
                  G0(n, 5);
                  var c = d9(j(n)), x = c === 0 ? 4 : c === 1 ? 3 : q(n);
              }
              if (6 < x >>> 0) return ke(ZCr);
              switch (x) {
                case 0:
                  return [0, t, Pn];
                case 1:
                  return [2, d7(t, n)];
                case 2:
                  return [2, t];
                case 3:
                  var s = ju(t, n), p = $n(zn), y = e2(t, p, n), T = y[1];
                  return [1, T, Si(T, s, y[2], p, 0)];
                case 4:
                  var E = ju(t, n), d = $n(zn), w = R1(t, d, n), G = w[1];
                  return [1, G, Si(G, E, w[2], d, 1)];
                case 5:
                  var A = ju(t, n), S = $n(zn), M = t;
                  r: for (; ; ) {
                    gn(n);
                    var K = j(n), V = 92 < K ? Hu < K ? 1 : $u < K ? 2 : 1 : Vr(GLr, K + 1 | 0) - 1 | 0;
                    if (6 < V >>> 0) var f0 = q(n);
                    else switch (V) {
                      case 0:
                        var f0 = 0;
                        break;
                      case 1:
                        for (; ; ) {
                          G0(n, 7);
                          var m0 = j(n);
                          if (-1 < m0) if (90 < m0) if (92 < m0) if ($u < m0) var k0 = m0 <= Hu ? 1 : 0, g0 = k0 && -1;
                          else var g0 = 0;
                          else var g0 = -1;
                          else var g0 = Vr(cRr, m0) - 1 | 0;
                          else var g0 = -1;
                          if (g0 !== 0) {
                            var f0 = q(n);
                            break;
                          }
                        }
                        break;
                      case 2:
                        var f0 = 6;
                        break;
                      case 3:
                        G0(n, 6);
                        var f0 = xi(j(n)) === 0 ? 6 : q(n);
                        break;
                      case 4:
                        if (G0(n, 4), Sr0(j(n)) === 0) {
                          for (; ; ) if (G0(n, 3), Sr0(j(n)) !== 0) {
                            var f0 = q(n);
                            break;
                          }
                        } else var f0 = q(n);
                        break;
                      case 5:
                        var f0 = 5;
                        break;
                      default:
                        G0(n, 7);
                        var e0 = j(n);
                        if (-1 < e0) if (13 < e0) var x0 = e0 <= Hu ? 1 : 0, l = x0 && ($u < e0 ? 1 : 0);
                        else var l = Vr(xLr, e0) - 1 | 0;
                        else var l = -1;
                        if (2 < l >>> 0) var f0 = q(n);
                        else switch (l) {
                          case 0:
                            var f0 = 2;
                            break;
                          case 1:
                            var f0 = 1;
                            break;
                          default:
                            G0(n, 1);
                            var f0 = xi(j(n)) === 0 ? 1 : q(n);
                        }
                    }
                    if (7 < f0 >>> 0) var c0 = ke(Fwr);
                    else switch (f0) {
                      case 0:
                        var c0 = [0, Gu(M, nt(M, n), 25), Twr];
                        break;
                      case 1:
                        var c0 = [0, d7(Gu(M, nt(M, n), 25), n), Owr];
                        break;
                      case 3:
                        var t0 = Se(n), c0 = [0, M, m7(t0, 1, un(t0) - 1 | 0)];
                        break;
                      case 4:
                        var c0 = [0, M, Iwr];
                        break;
                      case 5:
                        for (qi(S, 91); ; ) {
                          gn(n);
                          var o0 = j(n), w0 = 93 < o0 ? 1 : Vr(oLr, o0 + 1 | 0) - 1 | 0;
                          if (3 < w0 >>> 0) var _0 = q(n);
                          else switch (w0) {
                            case 0:
                              var _0 = 0;
                              break;
                            case 1:
                              for (; ; ) {
                                G0(n, 4);
                                var E0 = j(n);
                                if (-1 < E0) if (91 < E0) var U0 = E0 <= 93 ? 1 : 0, b = U0 && -1;
                                else var b = 0;
                                else var b = -1;
                                if (b !== 0) {
                                  var _0 = q(n);
                                  break;
                                }
                              }
                              break;
                            case 2:
                              G0(n, 4);
                              var R0 = j(n), X = 91 < R0 ? 93 < R0 ? -1 : Vr(rN, R0 - 92 | 0) - 1 | 0 : -1, _0 = X === 0 ? 1 : X === 1 ? 2 : q(n);
                              break;
                            default:
                              var _0 = 3;
                          }
                          if (4 < _0 >>> 0) var s0 = ke(Swr);
                          else switch (_0) {
                            case 0:
                              var s0 = M;
                              break;
                            case 1:
                              hn(S, gwr);
                              continue;
                            case 2:
                              qi(S, 92), qi(S, 93);
                              continue;
                            case 3:
                              qi(S, 93);
                              var s0 = M;
                              break;
                            default:
                              hn(S, Se(n));
                              continue;
                          }
                          var M = s0;
                          continue r;
                        }
                      case 6:
                        var c0 = [0, d7(Gu(M, nt(M, n), 25), n), Awr];
                        break;
                      default:
                        hn(S, Se(n));
                        continue;
                    }
                    var hr = c0[1], Ar = h7(hr, n), or = [0, hr[1], A, Ar], W0 = c0[2];
                    return [0, hr, [5, or, Mt(S), W0]];
                  }
                default:
                  var Lr = Ei(t, nt(t, n));
                  return [0, Lr, [6, Se(n)]];
              }
            }
            function pL(t, n, e, i, x) {
              for (var c = t; ; ) {
                var s = function(Cn) {
                  for (; ; ) if (G0(Cn, 6), Fr0(j(Cn)) !== 0) return q(Cn);
                };
                gn(x);
                var p = j(x), y = br < p ? Hu < p ? 1 : $u < p ? 2 : 1 : Vr(QDr, p + 1 | 0) - 1 | 0;
                if (6 < y >>> 0) var T = q(x);
                else switch (y) {
                  case 0:
                    var T = 1;
                    break;
                  case 1:
                    var T = s(x);
                    break;
                  case 2:
                    var T = 2;
                    break;
                  case 3:
                    G0(x, 2);
                    var T = xi(j(x)) === 0 ? 2 : q(x);
                    break;
                  case 4:
                    var T = 0;
                    break;
                  case 5:
                    G0(x, 6);
                    var E = j(x), d = 34 < E ? In < E ? -1 : Vr(WLr, E - 35 | 0) - 1 | 0 : -1;
                    if (d === 0) {
                      var w = j(x), G = 47 < w ? uc < w ? -1 : Vr(iRr, w + Wt | 0) - 1 | 0 : -1;
                      if (G === 0) for (; ; ) {
                        var A = j(x), S = 47 < A ? 59 < A ? -1 : Vr(iLr, A + Wt | 0) - 1 | 0 : -1;
                        if (S !== 0) {
                          var T = S === 1 ? 4 : q(x);
                          break;
                        }
                      }
                      else if (G === 1 && Nn(j(x)) === 0) for (; ; ) {
                        var M = j(x), K = 47 < M ? Ri < M ? -1 : Vr(rRr, M + Wt | 0) - 1 | 0 : -1;
                        if (K !== 0) {
                          var T = K === 1 ? 3 : q(x);
                          break;
                        }
                      }
                      else var T = q(x);
                    } else if (d === 1 && dn(j(x)) === 0) {
                      var V = Zv(j(x));
                      if (V === 0) {
                        var f0 = Zv(j(x));
                        if (f0 === 0) {
                          var m0 = Zv(j(x));
                          if (m0 === 0) {
                            var k0 = Zv(j(x));
                            if (k0 === 0) {
                              var g0 = Zv(j(x));
                              if (g0 === 0) {
                                var e0 = Zv(j(x));
                                if (e0 === 0) var x0 = j(x), l = 58 < x0 ? 59 < x0 ? -1 : 0 : -1, T = l === 0 ? 5 : q(x);
                                else var T = e0 === 1 ? 5 : q(x);
                              } else var T = g0 === 1 ? 5 : q(x);
                            } else var T = k0 === 1 ? 5 : q(x);
                          } else var T = m0 === 1 ? 5 : q(x);
                        } else var T = f0 === 1 ? 5 : q(x);
                      } else var T = V === 1 ? 5 : q(x);
                    } else var T = q(x);
                    break;
                  default:
                    G0(x, 0);
                    var T = Fr0(j(x)) === 0 ? s(x) : q(x);
                }
                if (6 < T >>> 0) return ke(Nwr);
                switch (T) {
                  case 0:
                    var c0 = Se(x), t0 = 0;
                    switch (n) {
                      case 0:
                        n0(c0, Cwr) || (t0 = 1);
                        break;
                      case 1:
                        n0(c0, Pwr) || (t0 = 1);
                        break;
                      default:
                        var o0 = 0;
                        if (n0(c0, Dwr)) {
                          if (!n0(c0, Lwr)) return bL(c, nt(c, x), qwr, Bwr);
                          if (n0(c0, Rwr)) {
                            if (!n0(c0, jwr)) return bL(c, nt(c, x), Mwr, Gwr);
                            o0 = 1;
                          }
                        }
                        if (!o0) return $v(x), c;
                    }
                    if (t0) return c;
                    hn(i, c0), hn(e, c0);
                    continue;
                  case 1:
                    return Ei(c, nt(c, x));
                  case 2:
                    var w0 = Se(x);
                    hn(i, w0), hn(e, w0);
                    var c = d7(c, x);
                    continue;
                  case 3:
                    var _0 = Se(x), E0 = m7(_0, 3, un(_0) - 4 | 0);
                    hn(i, _0), S1(e, Bi(Te(Uwr, E0)));
                    continue;
                  case 4:
                    var U0 = Se(x), b = m7(U0, 2, un(U0) - 3 | 0);
                    hn(i, U0), S1(e, Bi(b));
                    continue;
                  case 5:
                    var R0 = Se(x), X = m7(R0, 1, un(R0) - 2 | 0);
                    hn(i, R0);
                    var s0 = Ee(X, Hwr), hr = 0;
                    if (0 <= s0) if (0 < s0) {
                      var Ar = Ee(X, FTr), or = 0;
                      if (0 <= Ar) if (0 < Ar) {
                        var W0 = Ee(X, YIr), Lr = 0;
                        if (0 <= W0) if (0 < W0) {
                          var Tr = Ee(X, rNr), Hr = 0;
                          if (0 <= Tr) if (0 < Tr) {
                            var Or = Ee(X, NNr), fr = 0;
                            if (0 <= Or) if (0 < Or) if (n0(X, VNr)) if (n0(X, zNr)) if (n0(X, KNr)) if (n0(X, WNr)) if (n0(X, JNr)) if (n0(X, $Nr)) or = 1, Lr = 1, Hr = 1, fr = 1;
                            else var Rr = ZNr;
                            else var Rr = QNr;
                            else var Rr = rCr;
                            else var Rr = eCr;
                            else var Rr = nCr;
                            else var Rr = tCr;
                            else var Rr = uCr;
                            else if (n0(X, CNr)) if (n0(X, PNr)) if (n0(X, DNr)) if (n0(X, LNr)) if (n0(X, RNr)) if (n0(X, jNr)) if (n0(X, GNr)) or = 1, Lr = 1, Hr = 1, fr = 1;
                            else var Rr = MNr;
                            else var Rr = BNr;
                            else var Rr = qNr;
                            else var Rr = UNr;
                            else var Rr = HNr;
                            else var Rr = XNr;
                            else var Rr = YNr;
                            if (!fr) var Wr = Rr;
                          } else var Wr = iCr;
                          else {
                            var Jr = Ee(X, eNr), ar = 0;
                            if (0 <= Jr) if (0 < Jr) if (n0(X, mNr)) if (n0(X, _Nr)) if (n0(X, yNr)) if (n0(X, hNr)) if (n0(X, dNr)) if (n0(X, kNr)) if (n0(X, wNr)) or = 1, Lr = 1, Hr = 1, ar = 1;
                            else var _r = ENr;
                            else var _r = SNr;
                            else var _r = gNr;
                            else var _r = FNr;
                            else var _r = TNr;
                            else var _r = ONr;
                            else var _r = INr;
                            else var _r = ANr;
                            else if (n0(X, nNr)) if (n0(X, tNr)) if (n0(X, uNr)) if (n0(X, iNr)) if (n0(X, fNr)) if (n0(X, xNr)) if (n0(X, oNr)) or = 1, Lr = 1, Hr = 1, ar = 1;
                            else var _r = aNr;
                            else var _r = cNr;
                            else var _r = sNr;
                            else var _r = vNr;
                            else var _r = lNr;
                            else var _r = bNr;
                            else var _r = pNr;
                            if (!ar) var Wr = _r;
                          }
                          if (!Hr) var Ir = Wr;
                        } else var Ir = fCr;
                        else {
                          var fe = Ee(X, VIr), v0 = 0;
                          if (0 <= fe) if (0 < fe) {
                            var P = Ee(X, EAr), L = 0;
                            if (0 <= P) if (0 < P) if (n0(X, GAr)) if (n0(X, MAr)) if (n0(X, BAr)) if (n0(X, qAr)) if (n0(X, UAr)) if (n0(X, HAr)) if (n0(X, XAr)) or = 1, Lr = 1, v0 = 1, L = 1;
                            else var Q = YAr;
                            else var Q = VAr;
                            else var Q = zAr;
                            else var Q = KAr;
                            else var Q = WAr;
                            else var Q = JAr;
                            else var Q = $Ar;
                            else var Q = ZAr;
                            else if (n0(X, SAr)) if (n0(X, gAr)) if (n0(X, FAr)) if (n0(X, TAr)) if (n0(X, OAr)) if (n0(X, IAr)) if (n0(X, AAr)) or = 1, Lr = 1, v0 = 1, L = 1;
                            else var Q = NAr;
                            else var Q = CAr;
                            else var Q = PAr;
                            else var Q = DAr;
                            else var Q = LAr;
                            else var Q = RAr;
                            else var Q = jAr;
                            if (!L) var i0 = Q;
                          } else var i0 = QAr;
                          else {
                            var l0 = Ee(X, zIr), S0 = 0;
                            if (0 <= l0) if (0 < l0) if (n0(X, oAr)) if (n0(X, aAr)) if (n0(X, cAr)) if (n0(X, sAr)) if (n0(X, vAr)) if (n0(X, lAr)) if (n0(X, bAr)) or = 1, Lr = 1, v0 = 1, S0 = 1;
                            else var T0 = pAr;
                            else var T0 = mAr;
                            else var T0 = _Ar;
                            else var T0 = yAr;
                            else var T0 = hAr;
                            else var T0 = dAr;
                            else var T0 = kAr;
                            else var T0 = wAr;
                            else if (n0(X, KIr)) if (n0(X, WIr)) if (n0(X, JIr)) if (n0(X, $Ir)) if (n0(X, ZIr)) if (n0(X, QIr)) if (n0(X, rAr)) or = 1, Lr = 1, v0 = 1, S0 = 1;
                            else var T0 = eAr;
                            else var T0 = nAr;
                            else var T0 = tAr;
                            else var T0 = uAr;
                            else var T0 = iAr;
                            else var T0 = fAr;
                            else var T0 = xAr;
                            if (!S0) var i0 = T0;
                          }
                          if (!v0) var Ir = i0;
                        }
                        if (!Lr) var rr = Ir;
                      } else var rr = xCr;
                      else {
                        var L0 = Ee(X, TTr), B = 0;
                        if (0 <= L0) if (0 < L0) {
                          var Z = Ee(X, ROr), p0 = 0;
                          if (0 <= Z) if (0 < Z) {
                            var b0 = Ee(X, lIr), O0 = 0;
                            if (0 <= b0) if (0 < b0) if (n0(X, OIr)) if (n0(X, IIr)) if (n0(X, AIr)) if (n0(X, NIr)) if (n0(X, CIr)) if (n0(X, PIr)) if (n0(X, DIr)) or = 1, B = 1, p0 = 1, O0 = 1;
                            else var M0 = LIr;
                            else var M0 = RIr;
                            else var M0 = jIr;
                            else var M0 = GIr;
                            else var M0 = MIr;
                            else var M0 = BIr;
                            else var M0 = qIr;
                            else var M0 = UIr;
                            else if (n0(X, bIr)) if (n0(X, pIr)) if (n0(X, mIr)) if (n0(X, _Ir)) if (n0(X, yIr)) if (n0(X, hIr)) if (n0(X, dIr)) or = 1, B = 1, p0 = 1, O0 = 1;
                            else var M0 = kIr;
                            else var M0 = wIr;
                            else var M0 = EIr;
                            else var M0 = SIr;
                            else var M0 = gIr;
                            else var M0 = FIr;
                            else var M0 = TIr;
                            if (!O0) var er = M0;
                          } else var er = HIr;
                          else {
                            var yr = Ee(X, jOr), vr = 0;
                            if (0 <= yr) if (0 < yr) if (n0(X, ZOr)) if (n0(X, QOr)) if (n0(X, rIr)) if (n0(X, eIr)) if (n0(X, nIr)) if (n0(X, tIr)) if (n0(X, uIr)) or = 1, B = 1, p0 = 1, vr = 1;
                            else var $0 = iIr;
                            else var $0 = fIr;
                            else var $0 = xIr;
                            else var $0 = oIr;
                            else var $0 = aIr;
                            else var $0 = cIr;
                            else var $0 = sIr;
                            else var $0 = vIr;
                            else if (n0(X, GOr)) if (n0(X, MOr)) if (n0(X, BOr)) if (n0(X, qOr)) if (n0(X, UOr)) if (n0(X, HOr)) if (n0(X, XOr)) or = 1, B = 1, p0 = 1, vr = 1;
                            else var $0 = YOr;
                            else var $0 = VOr;
                            else var $0 = zOr;
                            else var $0 = KOr;
                            else var $0 = WOr;
                            else var $0 = JOr;
                            else var $0 = $Or;
                            if (!vr) var er = $0;
                          }
                          if (!p0) var Er = er;
                        } else var Er = XIr;
                        else {
                          var Mr = Ee(X, OTr), Br = 0;
                          if (0 <= Mr) if (0 < Mr) {
                            var qr = Ee(X, iOr), jr = 0;
                            if (0 <= qr) if (0 < qr) if (n0(X, dOr)) if (n0(X, kOr)) if (n0(X, wOr)) if (n0(X, EOr)) if (n0(X, SOr)) if (n0(X, gOr)) if (n0(X, FOr)) or = 1, B = 1, Br = 1, jr = 1;
                            else var $r = TOr;
                            else var $r = OOr;
                            else var $r = IOr;
                            else var $r = AOr;
                            else var $r = NOr;
                            else var $r = COr;
                            else var $r = POr;
                            else var $r = DOr;
                            else if (n0(X, fOr)) if (n0(X, xOr)) if (n0(X, oOr)) if (n0(X, aOr)) if (n0(X, cOr)) if (n0(X, sOr)) if (n0(X, vOr)) or = 1, B = 1, Br = 1, jr = 1;
                            else var $r = lOr;
                            else var $r = bOr;
                            else var $r = pOr;
                            else var $r = mOr;
                            else var $r = _Or;
                            else var $r = yOr;
                            else var $r = hOr;
                            if (!jr) var ne = $r;
                          } else var ne = LOr;
                          else {
                            var Qr = Ee(X, ITr), be = 0;
                            if (0 <= Qr) if (0 < Qr) if (n0(X, XTr)) if (n0(X, YTr)) if (n0(X, VTr)) if (n0(X, zTr)) if (n0(X, KTr)) if (n0(X, WTr)) if (n0(X, JTr)) or = 1, B = 1, Br = 1, be = 1;
                            else var ae = $Tr;
                            else var ae = ZTr;
                            else var ae = QTr;
                            else var ae = rOr;
                            else var ae = eOr;
                            else var ae = nOr;
                            else var ae = tOr;
                            else var ae = uOr;
                            else if (n0(X, ATr)) if (n0(X, NTr)) if (n0(X, CTr)) if (n0(X, PTr)) if (n0(X, DTr)) if (n0(X, LTr)) if (n0(X, RTr)) or = 1, B = 1, Br = 1, be = 1;
                            else var ae = jTr;
                            else var ae = GTr;
                            else var ae = MTr;
                            else var ae = BTr;
                            else var ae = qTr;
                            else var ae = UTr;
                            else var ae = HTr;
                            if (!be) var ne = ae;
                          }
                          if (!Br) var Er = ne;
                        }
                        if (!B) var rr = Er;
                      }
                      if (!or) {
                        var pe = rr;
                        hr = 1;
                      }
                    } else {
                      var pe = oCr;
                      hr = 1;
                    }
                    else {
                      var oe = Ee(X, Xwr), ce = 0;
                      if (0 <= oe) if (0 < oe) {
                        var ge = Ee(X, agr), q0 = 0;
                        if (0 <= ge) if (0 < ge) {
                          var Fr = Ee(X, yFr), _ = 0;
                          if (0 <= Fr) if (0 < Fr) {
                            var k = Ee(X, WFr), I = 0;
                            if (0 <= k) if (0 < k) if (n0(X, cTr)) if (n0(X, sTr)) if (n0(X, vTr)) if (n0(X, lTr)) if (n0(X, bTr)) if (n0(X, pTr)) ce = 1, q0 = 1, _ = 1, I = 1;
                            else var U = mTr;
                            else var U = _Tr;
                            else var U = yTr;
                            else var U = hTr;
                            else var U = dTr;
                            else var U = kTr;
                            else var U = wTr;
                            else if (n0(X, JFr)) if (n0(X, $Fr)) if (n0(X, ZFr)) if (n0(X, QFr)) if (n0(X, rTr)) if (n0(X, eTr)) if (n0(X, nTr)) ce = 1, q0 = 1, _ = 1, I = 1;
                            else var U = tTr;
                            else var U = uTr;
                            else var U = iTr;
                            else var U = fTr;
                            else var U = xTr;
                            else var U = oTr;
                            else var U = aTr;
                            if (!I) var Y = U;
                          } else var Y = ETr;
                          else {
                            var y0 = Ee(X, hFr), P0 = 0;
                            if (0 <= y0) if (0 < y0) if (n0(X, DFr)) if (n0(X, LFr)) if (n0(X, RFr)) if (n0(X, jFr)) if (n0(X, GFr)) if (n0(X, MFr)) if (n0(X, BFr)) ce = 1, q0 = 1, _ = 1, P0 = 1;
                            else var I0 = qFr;
                            else var I0 = UFr;
                            else var I0 = HFr;
                            else var I0 = XFr;
                            else var I0 = YFr;
                            else var I0 = VFr;
                            else var I0 = zFr;
                            else var I0 = KFr;
                            else if (n0(X, dFr)) if (n0(X, kFr)) if (n0(X, wFr)) if (n0(X, EFr)) if (n0(X, SFr)) if (n0(X, gFr)) if (n0(X, FFr)) ce = 1, q0 = 1, _ = 1, P0 = 1;
                            else var I0 = TFr;
                            else var I0 = OFr;
                            else var I0 = IFr;
                            else var I0 = AFr;
                            else var I0 = NFr;
                            else var I0 = CFr;
                            else var I0 = PFr;
                            if (!P0) var Y = I0;
                          }
                          if (!_) var D = Y;
                        } else var D = STr;
                        else {
                          var u0 = Ee(X, cgr), X0 = 0;
                          if (0 <= u0) if (0 < u0) {
                            var J0 = Ee(X, qgr), ir = 0;
                            if (0 <= J0) if (0 < J0) if (n0(X, nFr)) if (n0(X, tFr)) if (n0(X, uFr)) if (n0(X, iFr)) if (n0(X, fFr)) if (n0(X, xFr)) if (n0(X, oFr)) ce = 1, q0 = 1, X0 = 1, ir = 1;
                            else var Q0 = aFr;
                            else var Q0 = cFr;
                            else var Q0 = sFr;
                            else var Q0 = vFr;
                            else var Q0 = lFr;
                            else var Q0 = bFr;
                            else var Q0 = pFr;
                            else var Q0 = mFr;
                            else if (n0(X, Ugr)) if (n0(X, Hgr)) if (n0(X, Xgr)) if (n0(X, Ygr)) if (n0(X, Vgr)) if (n0(X, zgr)) if (n0(X, Kgr)) ce = 1, q0 = 1, X0 = 1, ir = 1;
                            else var Q0 = Wgr;
                            else var Q0 = Jgr;
                            else var Q0 = $gr;
                            else var Q0 = Zgr;
                            else var Q0 = Qgr;
                            else var Q0 = rFr;
                            else var Q0 = eFr;
                            if (!ir) var F0 = Q0;
                          } else var F0 = _Fr;
                          else {
                            var Sr = Ee(X, sgr), mr = 0;
                            if (0 <= Sr) if (0 < Sr) if (n0(X, Fgr)) if (n0(X, Tgr)) if (n0(X, Ogr)) if (n0(X, Igr)) if (n0(X, Agr)) if (n0(X, Ngr)) if (n0(X, Cgr)) ce = 1, q0 = 1, X0 = 1, mr = 1;
                            else var Cr = Pgr;
                            else var Cr = Dgr;
                            else var Cr = Lgr;
                            else var Cr = Rgr;
                            else var Cr = jgr;
                            else var Cr = Ggr;
                            else var Cr = Mgr;
                            else var Cr = Bgr;
                            else if (n0(X, vgr)) if (n0(X, lgr)) if (n0(X, bgr)) if (n0(X, pgr)) if (n0(X, mgr)) if (n0(X, _gr)) if (n0(X, ygr)) ce = 1, q0 = 1, X0 = 1, mr = 1;
                            else var Cr = hgr;
                            else var Cr = dgr;
                            else var Cr = kgr;
                            else var Cr = wgr;
                            else var Cr = Egr;
                            else var Cr = Sgr;
                            else var Cr = ggr;
                            if (!mr) var F0 = Cr;
                          }
                          if (!X0) var D = F0;
                        }
                        if (!q0) var sr = D;
                      } else var sr = gTr;
                      else {
                        var Pr = Ee(X, Ywr), K0 = 0;
                        if (0 <= Pr) if (0 < Pr) {
                          var Ur = Ee(X, rSr), h0 = 0;
                          if (0 <= Ur) if (0 < Ur) {
                            var Kr = Ee(X, NSr), re = 0;
                            if (0 <= Kr) if (0 < Kr) if (n0(X, VSr)) if (n0(X, zSr)) if (n0(X, KSr)) if (n0(X, WSr)) if (n0(X, JSr)) if (n0(X, $Sr)) if (n0(X, ZSr)) ce = 1, K0 = 1, h0 = 1, re = 1;
                            else var xe = QSr;
                            else var xe = rgr;
                            else var xe = egr;
                            else var xe = ngr;
                            else var xe = tgr;
                            else var xe = ugr;
                            else var xe = igr;
                            else var xe = fgr;
                            else if (n0(X, CSr)) if (n0(X, PSr)) if (n0(X, DSr)) if (n0(X, LSr)) if (n0(X, RSr)) if (n0(X, jSr)) if (n0(X, GSr)) ce = 1, K0 = 1, h0 = 1, re = 1;
                            else var xe = MSr;
                            else var xe = BSr;
                            else var xe = qSr;
                            else var xe = USr;
                            else var xe = HSr;
                            else var xe = XSr;
                            else var xe = YSr;
                            if (!re) var Re = xe;
                          } else var Re = xgr;
                          else {
                            var ve = Ee(X, eSr), Ie = 0;
                            if (0 <= ve) if (0 < ve) if (n0(X, mSr)) if (n0(X, _Sr)) if (n0(X, ySr)) if (n0(X, hSr)) if (n0(X, dSr)) if (n0(X, kSr)) if (n0(X, wSr)) ce = 1, K0 = 1, h0 = 1, Ie = 1;
                            else var Ge = ESr;
                            else var Ge = SSr;
                            else var Ge = gSr;
                            else var Ge = FSr;
                            else var Ge = TSr;
                            else var Ge = OSr;
                            else var Ge = ISr;
                            else var Ge = ASr;
                            else if (n0(X, nSr)) if (n0(X, tSr)) if (n0(X, uSr)) if (n0(X, iSr)) if (n0(X, fSr)) if (n0(X, xSr)) if (n0(X, oSr)) ce = 1, K0 = 1, h0 = 1, Ie = 1;
                            else var Ge = aSr;
                            else var Ge = cSr;
                            else var Ge = sSr;
                            else var Ge = vSr;
                            else var Ge = lSr;
                            else var Ge = bSr;
                            else var Ge = pSr;
                            if (!Ie) var Re = Ge;
                          }
                          if (!h0) var Me = Re;
                        } else var Me = ogr;
                        else {
                          var an = Ee(X, Vwr), We = 0;
                          if (0 <= an) if (0 < an) {
                            var Ae = Ee(X, EEr), cn = 0;
                            if (0 <= Ae) if (0 < Ae) if (n0(X, GEr)) if (n0(X, MEr)) if (n0(X, BEr)) if (n0(X, qEr)) if (n0(X, UEr)) if (n0(X, HEr)) if (n0(X, XEr)) ce = 1, K0 = 1, We = 1, cn = 1;
                            else var rn = YEr;
                            else var rn = VEr;
                            else var rn = zEr;
                            else var rn = KEr;
                            else var rn = WEr;
                            else var rn = JEr;
                            else var rn = $Er;
                            else var rn = ZEr;
                            else if (n0(X, SEr)) if (n0(X, gEr)) if (n0(X, FEr)) if (n0(X, TEr)) if (n0(X, OEr)) if (n0(X, IEr)) if (n0(X, AEr)) ce = 1, K0 = 1, We = 1, cn = 1;
                            else var rn = NEr;
                            else var rn = CEr;
                            else var rn = PEr;
                            else var rn = DEr;
                            else var rn = LEr;
                            else var rn = REr;
                            else var rn = jEr;
                            if (!cn) var kn = rn;
                          } else var kn = QEr;
                          else {
                            var vn = Ee(X, zwr), Ne = 0;
                            if (0 <= vn) if (0 < vn) if (n0(X, oEr)) if (n0(X, aEr)) if (n0(X, cEr)) if (n0(X, sEr)) if (n0(X, vEr)) if (n0(X, lEr)) if (n0(X, bEr)) ce = 1, K0 = 1, We = 1, Ne = 1;
                            else var Je = pEr;
                            else var Je = mEr;
                            else var Je = _Er;
                            else var Je = yEr;
                            else var Je = hEr;
                            else var Je = dEr;
                            else var Je = kEr;
                            else var Je = wEr;
                            else if (n0(X, Kwr)) if (n0(X, Wwr)) if (n0(X, Jwr)) if (n0(X, $wr)) if (n0(X, Zwr)) if (n0(X, Qwr)) if (n0(X, rEr)) ce = 1, K0 = 1, We = 1, Ne = 1;
                            else var Je = eEr;
                            else var Je = nEr;
                            else var Je = tEr;
                            else var Je = uEr;
                            else var Je = iEr;
                            else var Je = fEr;
                            else var Je = xEr;
                            if (!Ne) var kn = Je;
                          }
                          if (!We) var Me = kn;
                        }
                        if (!K0) var sr = Me;
                      }
                      if (!ce) {
                        var pe = sr;
                        hr = 1;
                      }
                    }
                    var en = hr ? pe : 0;
                    en ? S1(e, en[1]) : hn(e, Te(cCr, Te(X, aCr)));
                    continue;
                  default:
                    var _n = Se(x);
                    hn(i, _n), hn(e, _n);
                    continue;
                }
              }
            }
            function Lee(t, n) {
              gn(n);
              var e = j(n), i = ef < e ? vw < e ? -1 : Uk < e ? C3 < e ? Bw < e ? EE < e ? Wy < e ? 1 : 6 : Jd < e ? lE < e ? uF < e ? 1 : 6 : ZT < e ? 1 : 6 : WF < e ? bA < e ? 1 : 6 : sI < e ? 1 : 6 : C6 < e ? E4 < e ? x6 < e ? V8 < e ? j3 < e ? r3 < e ? CO < e ? 1 : 6 : LI < e ? 1 : 6 : Iy < e ? hg < e ? 1 : 6 : Mw < e ? 1 : 6 : L3 < e ? w8 < e ? jg < e ? 1 : 6 : $4 < e ? 1 : 6 : W8 < e ? zT < e ? 1 : 6 : kk < e ? 1 : 6 : O4 < e ? YO < e ? l3 < e ? Qk < e ? 1 : 6 : fk < e ? 1 : 6 : xp < e ? V6 < e ? 1 : 6 : Td < e ? 1 : 6 : G8 < e ? s4 < e ? t6 < e ? 1 : 6 : q6 < e ? 1 : 6 : B6 < e ? S4 < e ? 1 : 6 : fn < e ? 1 : 6 : LE < e ? M4 < e ? g6 < e ? SF < e ? i8 < e ? 1 : 6 : d8 < e ? 1 : 6 : F4 < e ? JF < e ? 1 : 6 : mh < e ? 1 : 6 : U6 < e ? n8 < e ? s3 < e ? 1 : 6 : S8 < e ? 1 : 6 : BS < e ? L8 < e ? 1 : 6 : K3 < e ? 1 : 6 : m8 < e ? f8 < e ? x8 < e ? w3 < e ? 1 : 6 : _6 < e ? 1 : 6 : s6 < e ? oF < e ? 1 : 6 : ZO < e ? 1 : 6 : a3 < e ? DS < e ? e8 < e ? 1 : 6 : g8 < e ? 1 : 6 : J3 < e ? sF < e ? 1 : 6 : ig < e ? 1 : 6 : iw < e ? Ek < e ? wk < e ? qk < e ? FT < e ? Vk < e ? 1 : 6 : uA < e ? 1 : 6 : dy < e ? VS < e ? 1 : 6 : _d < e ? 1 : 6 : Th < e ? pF < e ? FE < e ? 1 : 6 : Zw < e ? 1 : 6 : Sy < e ? L_ < e ? 1 : 6 : CE < e ? 1 : 6 : LF < e ? Vw < e ? My < e ? rw < e ? 1 : 6 : XI < e ? 1 : 6 : jO < e ? ap < e ? 1 : 6 : jT < e ? 1 : 6 : Ot < e ? OA < e ? gA < e ? 1 : 6 : 1 : 6 : c6 < e ? w6 < e ? l6 < e ? k3 < e ? VE < e ? 1 : 6 : qw < e ? 1 : 6 : v4 < e ? nE < e ? 1 : 6 : Ty < e ? 1 : 6 : c3 < e ? V4 < e ? eg < e ? 1 : 6 : qF < e ? 1 : 6 : X4 < e ? _T < e ? 1 : 6 : Oy < e ? 1 : 6 : D6 < e ? D4 < e ? V3 < e ? MS < e ? 1 : 6 : Ww < e ? 1 : 6 : cy < e ? jy < e ? 1 : 6 : VT < e ? 1 : 6 : B4 < e ? bh < e ? JT < e ? 1 : 6 : G3 < e ? 1 : 6 : r6 < e ? sO < e ? 1 : 6 : ZE < e ? 1 : 6 : uT < e ? Z4 < e ? Yd < e ? Q6 < e ? L4 < e ? N6 < e ? vp < e ? D_ < e ? 1 : 6 : Pd < e ? 1 : 6 : pd < e ? Rg < e ? 1 : 6 : OS < e ? 1 : 6 : G6 < e ? I3 < e ? uk < e ? 1 : 6 : cE < e ? 1 : 6 : l8 < e ? l4 < e ? 1 : 6 : rh < e ? 1 : 6 : M3 < e ? FS < e ? NE < e ? aT < e ? 1 : 6 : kT < e ? 1 : 6 : uS < e ? d3 < e ? 1 : 6 : zd < e ? 1 : 6 : ly < e ? T6 < e ? Pg < e ? 1 : 6 : vy < e ? 1 : 6 : LO < e ? yF < e ? 1 : 6 : YF < e ? 1 : 6 : DI < e ? au < e ? jF < e ? Ah < e ? AO < e ? 1 : 6 : Cd < e ? 1 : 6 : qh < e ? AS < e ? 1 : 6 : lA < e ? 1 : 6 : cO < e ? AI < e ? xI < e ? 1 : 6 : B_ < e ? 1 : 6 : hS < e ? fT < e ? 1 : 6 : mg < e ? 1 : 6 : NO < e ? Nw < e ? Yh < e ? lw < e ? 1 : 6 : Qg < e ? 1 : 6 : Vg < e ? Lk < e ? 1 : 6 : qO < e ? 1 : 6 : iS < e ? b6 < e ? h6 < e ? 1 : 6 : $F < e ? 1 : 6 : ph < e ? rT < e ? 1 : 6 : HS < e ? 1 : 6 : zO < e ? Ck < e ? yS < e ? Iw < e ? CI < e ? Kg < e ? 1 : 6 : VO < e ? 1 : 6 : Mk < e ? ks < e ? 1 : 6 : PF < e ? 1 : 6 : kd < e ? TS < e ? wI < e ? 1 : 6 : xg < e ? 1 : 6 : Rd < e ? dh < e ? 1 : 6 : oI < e ? 1 : 6 : oT < e ? lg < e ? tF < e ? KI < e ? 1 : 6 : pk < e ? 1 : 6 : G_ < e ? kw < e ? 1 : 6 : QF < e ? 1 : 6 : jk < e ? FO < e ? mA < e ? 1 : 6 : _g < e ? 1 : 6 : WE < e ? lF < e ? 1 : 6 : MF < e ? 1 : 6 : h4 < e ? h3 < e ? vT < e ? jI < e ? mS < e ? 1 : 6 : cA < e ? 1 : 6 : DE < e ? zk < e ? 1 : 6 : Lg < e ? 1 : 6 : AT < e ? R6 < e ? bk < e ? 1 : 6 : iT < e ? 1 : 6 : US < e ? BT < e ? 1 : 6 : vE < e ? 1 : 6 : Wc < e ? Sk < e ? D3 < e ? Xg < e ? 1 : 6 : fd < e ? 1 : 6 : IF < e ? ld < e ? 1 : 6 : nA < e ? 1 : 6 : BE < e ? W3 < e ? sy < e ? 1 : 6 : kI < e ? 1 : 6 : VF < e ? fS < e ? 1 : 6 : P4 < e ? 1 : 6 : vS < e ? jw < e ? ik < e ? hO < e ? iI < e ? bg < e ? Nd < e ? 1 : 6 : u3 < e ? 1 : 6 : sE < e ? Ld < e ? 1 : 6 : Xk < e ? 1 : 6 : up < e ? hh < e ? M8 < e ? 1 : 6 : p3 < e ? 1 : 6 : Ew < e ? pE < e ? 1 : 6 : Bg < e ? 1 : 6 : by < e ? Zk < e ? $T < e ? zF < e ? 1 : 6 : Bd < e ? 1 : 6 : $k < e ? TI < e ? 1 : 6 : pO < e ? 1 : 6 : sS < e ? RO < e ? kA < e ? 1 : 6 : wA < e ? 1 : 6 : fg < e ? qI < e ? 1 : 6 : dS < e ? 1 : 6 : hI < e ? NI < e ? nS < e ? Xy < e ? J_ < e ? 1 : 6 : bT < e ? 1 : 6 : $O < e ? Eg < e ? 1 : 6 : oA < e ? 1 : 6 : uE < e ? ET < e ? dg < e ? 1 : 6 : TT < e ? 1 : 6 : Ay < e ? u8 < e ? 1 : 6 : ZS < e ? 1 : 6 : Gh < e ? M_ < e ? SO < e ? lh < e ? 1 : 6 : XE < e ? 1 : 6 : Q3 < e ? Z6 < e ? 1 : 6 : Od < e ? 1 : 6 : W6 < e ? RF < e ? qy < e ? 1 : 6 : Nk < e ? 1 : 6 : PE < e ? Tg < e ? 1 : 6 : OI < e ? 1 : 6 : A8 < e ? P_ < e ? C4 < e ? $g < e ? Uh < e ? WS < e ? 1 : 6 : j6 < e ? 1 : 6 : _E < e ? fI < e ? 1 : 6 : Pw < e ? 1 : 6 : f3 < e ? a8 < e ? UF < e ? 1 : 6 : Lw < e ? 1 : 6 : mk < e ? aI < e ? 1 : 6 : yy < e ? 1 : 6 : O8 < e ? uI < e ? u6 < e ? ky < e ? 1 : 6 : GI < e ? 1 : 6 : c8 < e ? Ow < e ? 1 : 6 : bE < e ? 1 : 6 : y3 < e ? fp < e ? eE < e ? 1 : 6 : I8 < e ? 1 : 6 : cw < e ? KF < e ? 1 : 6 : VI < e ? 1 : 6 : zh < e ? QO < e ? h8 < e ? hy < e ? ew < e ? 1 : 6 : i3 < e ? 1 : 6 : pI < e ? dA < e ? 1 : 6 : qd < e ? 1 : 6 : kg < e ? iE < e ? TO < e ? 1 : 6 : X6 < e ? 1 : 6 : Rw < e ? aw < e ? 1 : 6 : F3 < e ? 1 : 6 : Ik < e ? OF < e ? Ly < e ? m4 < e ? 1 : 6 : cd < e ? 1 : 6 : zg < e ? Jk < e ? 1 : 6 : aS < e ? 1 : 6 : B3 < e ? IO < e ? hw < e ? 1 : 6 : mE < e ? 1 : 6 : $S < e ? QI < e ? 1 : 6 : FA < e ? 1 : 6 : od < e ? KE < e ? Rk < e ? J6 < e ? Md < e ? xF < e ? Zg < e ? sh < e ? eT < e ? 1 : 6 : YI < e ? 1 : 6 : RE < e ? OT < e ? 1 : 6 : J8 < e ? 1 : 6 : IA < e ? dE < e ? qT < e ? 1 : 6 : hd < e ? 1 : 6 : Id < e ? Mh < e ? 1 : 6 : _S < e ? 1 : 6 : EA < e ? PO < e ? Hg < e ? sg < e ? 1 : 6 : Ug < e ? 1 : 6 : Xw < e ? td < e ? 1 : 6 : Dg < e ? 1 : 6 : Ag < e ? bS < e ? Wd < e ? 1 : 6 : Fg < e ? 1 : 6 : tA < e ? wT < e ? 1 : 6 : Dk < e ? 1 : 6 : rS < e ? Z8 < e ? JI < e ? AE < e ? ME < e ? 1 : 6 : pA < e ? 1 : 6 : EO < e ? Gy < e ? 1 : 6 : fA < e ? 1 : 6 : xA < e ? b4 < e ? _k < e ? 1 : 6 : oO < e ? 1 : 6 : wd < e ? S7 < e ? 1 : 6 : $d < e ? 1 : 6 : X8 < e ? z_ < e ? Fd < e ? Ph < e ? 1 : 6 : dT < e ? 1 : 6 : Dd < e ? Ok < e ? 1 : 6 : ah < e ? 1 : 6 : nh < e ? ag < e ? $w < e ? 1 : 6 : WT < e ? 1 : 6 : QS < e ? Fw < e ? 1 : 6 : LT < e ? 1 : 6 : Ih < e ? vk < e ? En < e ? p8 < e ? gT < e ? M6 < e ? 1 : 6 : gh < e ? 1 : 6 : J4 < e ? Q_ < e ? 1 : 6 : op < e ? 1 : 6 : vO < e ? GE < e ? ch < e ? 1 : 6 : q_ < e ? 1 : 6 : ES < e ? UT < e ? 1 : 6 : jS < e ? 1 : 6 : Uw < e ? ty < e ? sA < e ? Vh < e ? 1 : 6 : sT < e ? 1 : 6 : iF < e ? Zd < e ? 1 : 6 : FI < e ? 1 : 6 : xO < e ? th < e ? ng < e ? 1 : 6 : bd < e ? 1 : 6 : iO < e ? _O < e ? 1 : 6 : eO < e ? 1 : 6 : IS < e ? zE < e ? fO < e ? ck < e ? xh < e ? 1 : 6 : ud < e ? 1 : 6 : JS < e ? _w < e ? 1 : 6 : Fy < e ? 1 : 6 : vA < e ? $E < e ? KT < e ? 1 : 6 : rI < e ? 1 : 6 : uy < e ? Tw < e ? 1 : 6 : 1 : nT < e ? Z3 < e ? ek < e ? 6 : $y < e ? 1 : 6 : GF < e ? Qw < e ? 1 : 6 : sk < e ? 1 : 6 : vg < e ? nO < e ? tI < e ? 1 : 6 : GO < e ? 1 : 6 : Ry < e ? 1 : 6 : D8 < e ? Ed < e ? xw < e ? Oh < e ? rA < e ? 6 : $h < e ? tT < e ? 1 : 6 : vF < e ? 1 : 6 : Qy < e ? zI < e ? ry < e ? 1 : 6 : yh < e ? 1 : 6 : HE < e ? Jh < e ? 1 : 6 : hF < e ? 1 : 6 : rp < e ? z4 < e ? S6 < e ? py < e ? 1 : 6 : rg < e ? 1 : 6 : $8 < e ? yO < e ? 1 : 6 : Bk < e ? 1 : 6 : gk < e ? U8 < e ? EF < e ? 1 : 6 : wy < e ? 1 : 6 : og < e ? Tk < e ? 1 : 6 : wE < e ? 1 : 6 : Gw < e ? $_ < e ? ey < e ? pS < e ? oE < e ? 1 : 6 : 1 : 6 : dw < e ? 6 : Q4 < e ? IT < e ? 1 : 6 : yg < e ? 1 : 6 : eI < e ? t3 < e ? Ma < e ? Do < e ? 1 : 2 : BI < e ? 1 : 6 : ow < e ? MT < e ? 1 : 6 : YS < e ? 1 : 6 : yI < e ? tS < e ? Zh < e ? 1 : 6 : CT < e ? 1 : 6 : GT < e ? Kw < e ? 1 : 6 : SI < e ? 1 : 6 : UI < e ? tk < e ? Qn < e ? R4 < e ? q3 < e ? id < e ? 1 : 6 : _F < e ? 1 : 6 : z3 < e ? L6 < e ? 1 : 6 : fh < e ? 1 : 6 : PT < e ? ip < e ? uw < e ? 1 : 6 : eS < e ? 1 : 6 : tO < e ? e3 < e ? 1 : 6 : oh < e ? 1 : 6 : dk < e ? zS < e ? Qh < e ? ug < e ? 1 : 6 : iy < e ? 1 : 6 : Wk < e ? Kd < e ? 1 : 6 : TE < e ? 1 : 6 : dd < e ? my < e ? cF < e ? 1 : 6 : _A < e ? 1 : 6 : Ny < e ? 1 : 6 : Xd < e ? H3 < e ? o3 < e ? Jw < e ? 1 : 6 : av < e ? 6 : RT < e ? 1 : 6 : gF < e ? k6 < e ? NF < e ? 1 : 6 : Wh < e ? 1 : 6 : Gk < e ? Dh < e ? 1 : 6 : ZI < e ? 1 : 6 : Vd < e ? cS < e ? lT < e ? cI < e ? 1 : 6 : 1 : Dy < e ? 6 : Jy < e ? 1 : 6 : FF < e ? sd < e ? 1 : 6 : XT < e ? OO < e ? 1 : 6 : aO < e ? 1 : 6 : wh < e ? F8 < e ? W_ < e ? uh < e ? kO < e ? ed < e ? EI < e ? Aw < e ? 1 : 6 : yA < e ? 1 : 6 : Bh < e ? fy < e ? 1 : 6 : ak < e ? 1 : 6 : CF < e ? TA < e ? lp < e ? 1 : 6 : 1 : 6 : yT < e ? Hd < e ? kS < e ? zy < e ? 1 : 6 : wS < e ? 1 : 6 : v6 < e ? Hk < e ? 1 : 6 : kE < e ? 1 : 6 : Sw < e ? pw < e ? 1 : 6 : _h < e ? WO < e ? 1 : 6 : k8 < e ? 1 : 6 : kF < e ? DO < e ? XF < e ? gy < e ? Sd < e ? 1 : 6 : eA < e ? 1 : 6 : Z_ < e ? JE < e ? 1 : 6 : ay < e ? 1 : 6 : Ky < e ? _8 < e ? Uy < e ? 1 : 6 : n3 < e ? 1 : 6 : rE < e ? oy < e ? 1 : 6 : cg < e ? 1 : 6 : Yy < e ? SA < e ? xS < e ? rF < e ? 1 : 6 : Xh < e ? 1 : 6 : mI < e ? lk < e ? 1 : 6 : uO < e ? 1 : 6 : PS < e && aA < e ? 1 : 6 : yk < e ? Rh < e ? tg < e ? nk < e ? 6 : Zy < e ? bI < e ? 1 : 6 : Ch < e ? 1 : 6 : xE < e ? ok < e ? V_ < e ? 1 : 6 : 1 : 6 : Og < e ? UO < e && oS < e ? 1 : 6 : bw < e ? rO < e ? Lh < e ? 1 : 6 : 1 : dF < e ? 6 : 1 : Eh < e ? gE < e ? U3 < e ? 6 : tw < e ? 1 : 6 : dI < e ? Qd < e ? wO < e ? 1 : 6 : R_ < e ? 1 : 6 : Sh < e ? 1 : 6 : BF < e ? gg < e ? Ad < e ? 1 : 6 : XS < e ? 1 : 6 : Kk < e ? YE < e ? 6 : ih < e ? 1 : 6 : U_ < e ? yE < e ? 1 : 6 : Ht < e ? 1 : 6 : GS < e ? jE < e ? dO < e ? q4 < e ? Ey < e ? E8 < e ? RI < e ? 1 : 6 : nF < e ? 1 : 6 : HF < e ? 1 : 6 : ww < e ? E3 < e ? de < e ? 1 : 6 : 1 : 6 : Ig < e ? Gd < e ? X_ < e ? H_ < e ? 1 : 6 : 1 : 6 : Hw < e ? T3 < e ? vd < e ? 1 : 6 : fF < e ? 1 : 6 : wg < e ? 1 : 6 : z8 < e ? j8 < e ? Eo < e ? PI < e ? 6 : Qx < e ? 1 : 2 : F6 < e ? By < e ? 1 : 6 : IE < e ? 1 : 6 : K8 < e ? z6 < e ? Cg < e ? 1 : 6 : cT < e ? 1 : 6 : o8 < e ? tt < e ? 1 : 6 : Ak < e ? 1 : 6 : NS < e ? tE < e ? j4 < e ? Ng < e ? 1 : 6 : $I < e ? 1 : 6 : P6 < e ? TF < e ? 1 : 6 : p4 < e ? 1 : 6 : _I < e ? fE < e ? gI < e ? 1 : 6 : N3 < e ? 1 : 6 : G4 < e ? B8 < e ? 1 : 6 : Sg < e ? 1 : 6 : N8 < e ? QE < e ? aE < e ? Yk < e ? pT < e ? K_ < e ? 1 : 6 : wF < e ? 1 : 6 : UE < e ? 1 : 6 : rd < e ? vI < e ? 6 : 1 : 6 : MO < e ? mw < e ? YT < e ? s8 < e ? 1 : 6 : AA < e ? 1 : 6 : Yw < e ? Y_ < e ? 1 : 6 : 1 : 6 : Gg < e ? JO < e ? $3 < e ? sp < e ? P8 < e ? 1 : 6 : Q8 < e ? 1 : 6 : gr < e ? t8 < e ? 1 : 6 : 1 : g4 < e ? KS < e ? 6 : m6 < e ? 1 : 6 : mF < e ? Cy < e ? 1 : 6 : R3 < e ? 1 : 6 : Pk < e ? HI < e ? QT < e ? x3 < e ? 1 : 6 : mO < e ? 1 : 6 : Py < e ? O3 < e ? 1 : 6 : ep < e ? 1 : 6 : mo < e ? xc < e ? ox < e ? 1 : 2 : fo < e ? 1 : 2 : $u < e ? Hu < e ? 1 : 3 : Co < e ? 1 : 2 : Vr(DLr, e + 1 | 0) - 1 | 0;
              if (14 < i >>> 0) var x = q(n);
              else switch (i) {
                case 0:
                  var x = 0;
                  break;
                case 1:
                  var x = 14;
                  break;
                case 2:
                  if (G0(n, 2), jc(j(n)) === 0) {
                    for (; ; ) if (G0(n, 2), jc(j(n)) !== 0) {
                      var x = q(n);
                      break;
                    }
                  } else var x = q(n);
                  break;
                case 3:
                  var x = 1;
                  break;
                case 4:
                  G0(n, 1);
                  var x = xi(j(n)) === 0 ? 1 : q(n);
                  break;
                case 5:
                  var x = 12;
                  break;
                case 6:
                  var x = 13;
                  break;
                case 7:
                  var x = 10;
                  break;
                case 8:
                  G0(n, 6);
                  var c = d9(j(n)), x = c === 0 ? 4 : c === 1 ? 3 : q(n);
                  break;
                case 9:
                  var x = 9;
                  break;
                case 10:
                  var x = 5;
                  break;
                case 11:
                  var x = 11;
                  break;
                case 12:
                  var x = 7;
                  break;
                case 13:
                  if (G0(n, 14), Ls(j(n)) === 0) {
                    var s = L1(j(n));
                    if (s === 0) var x = Nn(j(n)) === 0 && Nn(j(n)) === 0 && Nn(j(n)) === 0 ? 13 : q(n);
                    else if (s === 1 && Nn(j(n)) === 0) for (; ; ) {
                      var p = A1(j(n));
                      if (p !== 0) {
                        var x = p === 1 ? 13 : q(n);
                        break;
                      }
                    }
                    else var x = q(n);
                  } else var x = q(n);
                  break;
                default:
                  var x = 8;
              }
              if (14 < x >>> 0) return ke(JCr);
              switch (x) {
                case 0:
                  return [0, t, Pn];
                case 1:
                  return [2, d7(t, n)];
                case 2:
                  return [2, t];
                case 3:
                  var y = ju(t, n), T = $n(zn), E = e2(t, T, n), d = E[1];
                  return [1, d, Si(d, y, E[2], T, 0)];
                case 4:
                  var w = ju(t, n), G = $n(zn), A = R1(t, G, n), S = A[1];
                  return [1, S, Si(S, w, A[2], G, 1)];
                case 5:
                  return [0, t, 98];
                case 6:
                  return [0, t, j7];
                case 7:
                  return [0, t, 99];
                case 8:
                  return [0, t, 0];
                case 9:
                  return [0, t, 86];
                case 10:
                  return [0, t, 10];
                case 11:
                  return [0, t, 82];
                case 12:
                  var M = Se(n), K = ju(t, n), V = $n(zn), f0 = $n(zn);
                  hn(f0, M);
                  var m0 = qn(M, $Cr) ? 0 : 1, k0 = pL(t, m0, V, f0, n), g0 = h7(k0, n);
                  hn(f0, M);
                  var e0 = Mt(V), x0 = Mt(f0);
                  return [0, k0, [8, [0, k0[1], K, g0], e0, x0]];
                case 13:
                  for (var l = n[6]; ; ) {
                    gn(n);
                    var c0 = j(n), t0 = In < c0 ? 1 : Vr(oRr, c0 + 1 | 0) - 1 | 0;
                    if (3 < t0 >>> 0) var o0 = q(n);
                    else switch (t0) {
                      case 0:
                        var o0 = 1;
                        break;
                      case 1:
                        var o0 = 2;
                        break;
                      case 2:
                        var o0 = 0;
                        break;
                      default:
                        if (G0(n, 2), Ls(j(n)) === 0) {
                          var w0 = L1(j(n));
                          if (w0 === 0) if (Nn(j(n)) === 0 && Nn(j(n)) === 0) var _0 = Nn(j(n)) !== 0 ? 1 : 0, o0 = _0 && q(n);
                          else var o0 = q(n);
                          else if (w0 === 1 && Nn(j(n)) === 0) for (; ; ) {
                            var E0 = A1(j(n));
                            if (E0 !== 0) {
                              var U0 = E0 !== 1 ? 1 : 0, o0 = U0 && q(n);
                              break;
                            }
                          }
                          else var o0 = q(n);
                        } else var o0 = q(n);
                    }
                    if (2 < o0 >>> 0) throw [0, Sn, vwr];
                    switch (o0) {
                      case 0:
                        continue;
                      case 1:
                        break;
                      default:
                        if (nL(br0(n))) continue;
                        mr0(n, 1);
                    }
                    var b = n[3];
                    tL(n, l);
                    var R0 = Ll(n), X = Hl(t, l, b);
                    return [0, t, [7, uL(R0), X]];
                  }
                default:
                  return [0, t, [6, Se(n)]];
              }
            }
            function Ree(t, n) {
              gn(n);
              var e = j(n);
              if (-1 < e) if (ef < e) if (Eo < e) if (Ma < e) var i = e <= Do ? 1 : 0, T = i && 1;
              else var x = e <= Qx ? 1 : 0, T = x && 1;
              else if (mo < e) if (xc < e) var c = e <= ox ? 1 : 0, T = c && 1;
              else var s = e <= fo ? 1 : 0, T = s && 1;
              else if ($u < e) var p = e <= Hu ? 1 : 0, T = p && 2;
              else var y = e <= Co ? 1 : 0, T = y && 1;
              else var T = Vr(tLr, e) - 1 | 0;
              else var T = -1;
              if (5 < T >>> 0) var E = q(n);
              else switch (T) {
                case 0:
                  var E = 5;
                  break;
                case 1:
                  if (G0(n, 1), jc(j(n)) === 0) {
                    for (; ; ) if (G0(n, 1), jc(j(n)) !== 0) {
                      var E = q(n);
                      break;
                    }
                  } else var E = q(n);
                  break;
                case 2:
                  var E = 0;
                  break;
                case 3:
                  G0(n, 0);
                  var d = xi(j(n)) !== 0 ? 1 : 0, E = d && q(n);
                  break;
                case 4:
                  G0(n, 5);
                  var w = d9(j(n)), E = w === 0 ? 3 : w === 1 ? 2 : q(n);
                  break;
                default:
                  var E = 4;
              }
              if (5 < E >>> 0) return ke(zCr);
              switch (E) {
                case 0:
                  return [2, d7(t, n)];
                case 1:
                  return [2, t];
                case 2:
                  var G = ju(t, n), A = $n(zn), S = e2(t, A, n), M = S[1];
                  return [1, M, Si(M, G, S[2], A, 0)];
                case 3:
                  var K = ju(t, n), V = $n(zn), f0 = R1(t, V, n), m0 = f0[1];
                  return [1, m0, Si(m0, K, f0[2], V, 1)];
                case 4:
                  var k0 = ju(t, n), g0 = $n(zn), e0 = $n(zn), x0 = $n(zn);
                  hn(x0, KCr);
                  var l = Zr0(t, g0, e0, x0, n), c0 = l[1], t0 = h7(c0, n), o0 = [0, c0[1], k0, t0], w0 = l[2], _0 = Mt(x0), E0 = Mt(e0);
                  return [0, c0, [3, [0, o0, [0, Mt(g0), E0, _0], w0]]];
                default:
                  var U0 = Ei(t, nt(t, n));
                  return [0, U0, [3, [0, nt(U0, n), WCr, 1]]];
              }
            }
            function jee(t, n) {
              function e(D) {
                for (; ; ) if (G0(D, 29), dn(j(D)) !== 0) return q(D);
              }
              function i(D) {
                G0(D, 27);
                var u0 = Bt(j(D));
                if (u0 === 0) {
                  for (; ; ) if (G0(D, 25), dn(j(D)) !== 0) return q(D);
                }
                return u0 === 1 ? e(D) : q(D);
              }
              function x(D) {
                for (; ; ) if (G0(D, 23), dn(j(D)) !== 0) return q(D);
              }
              function c(D) {
                G0(D, 22);
                var u0 = Bt(j(D));
                if (u0 === 0) {
                  for (; ; ) if (G0(D, 21), dn(j(D)) !== 0) return q(D);
                }
                return u0 === 1 ? x(D) : q(D);
              }
              function s(D) {
                for (; ; ) if (G0(D, 23), dn(j(D)) !== 0) return q(D);
              }
              function p(D) {
                G0(D, 22);
                var u0 = Bt(j(D));
                if (u0 === 0) {
                  for (; ; ) if (G0(D, 21), dn(j(D)) !== 0) return q(D);
                }
                return u0 === 1 ? s(D) : q(D);
              }
              function y(D) {
                r: for (; ; ) {
                  if (pn(j(D)) === 0) for (; ; ) {
                    G0(D, 24);
                    var u0 = Mc(j(D));
                    if (3 < u0 >>> 0) return q(D);
                    switch (u0) {
                      case 0:
                        return s(D);
                      case 1:
                        continue;
                      case 2:
                        continue r;
                      default:
                        return p(D);
                    }
                  }
                  return q(D);
                }
              }
              function T(D) {
                G0(D, 29);
                var u0 = Gr0(j(D));
                if (3 < u0 >>> 0) return q(D);
                switch (u0) {
                  case 0:
                    return e(D);
                  case 1:
                    var X0 = C1(j(D));
                    if (X0 === 0) for (; ; ) {
                      G0(D, 24);
                      var J0 = Qv(j(D));
                      if (2 < J0 >>> 0) return q(D);
                      switch (J0) {
                        case 0:
                          return s(D);
                        case 1:
                          continue;
                        default:
                          return p(D);
                      }
                    }
                    if (X0 === 1) for (; ; ) {
                      G0(D, 24);
                      var ir = Mc(j(D));
                      if (3 < ir >>> 0) return q(D);
                      switch (ir) {
                        case 0:
                          return s(D);
                        case 1:
                          continue;
                        case 2:
                          return y(D);
                        default:
                          return p(D);
                      }
                    }
                    return q(D);
                  case 2:
                    for (; ; ) {
                      G0(D, 24);
                      var Q0 = Qv(j(D));
                      if (2 < Q0 >>> 0) return q(D);
                      switch (Q0) {
                        case 0:
                          return x(D);
                        case 1:
                          continue;
                        default:
                          return c(D);
                      }
                    }
                  default:
                    for (; ; ) {
                      G0(D, 24);
                      var F0 = Mc(j(D));
                      if (3 < F0 >>> 0) return q(D);
                      switch (F0) {
                        case 0:
                          return x(D);
                        case 1:
                          continue;
                        case 2:
                          return y(D);
                        default:
                          return c(D);
                      }
                    }
                }
              }
              function E(D) {
                for (; ; ) {
                  G0(D, 30);
                  var u0 = Ps(j(D));
                  if (4 < u0 >>> 0) return q(D);
                  switch (u0) {
                    case 0:
                      return e(D);
                    case 1:
                      continue;
                    case 2:
                      return T(D);
                    case 3:
                      r: for (; ; ) {
                        if (pn(j(D)) === 0) for (; ; ) {
                          G0(D, 30);
                          var X0 = Ps(j(D));
                          if (4 < X0 >>> 0) return q(D);
                          switch (X0) {
                            case 0:
                              return e(D);
                            case 1:
                              continue;
                            case 2:
                              return T(D);
                            case 3:
                              continue r;
                            default:
                              return i(D);
                          }
                        }
                        return q(D);
                      }
                    default:
                      return i(D);
                  }
                }
              }
              function d(D) {
                return pn(j(D)) === 0 ? E(D) : q(D);
              }
              function w(D) {
                for (; ; ) if (G0(D, 19), dn(j(D)) !== 0) return q(D);
              }
              function G(D) {
                for (; ; ) if (G0(D, 19), dn(j(D)) !== 0) return q(D);
              }
              function A(D) {
                G0(D, 29);
                var u0 = Er0(j(D));
                if (u0 === 0) return e(D);
                if (u0 === 1) for (; ; ) {
                  G0(D, 20);
                  var X0 = w9(j(D));
                  if (3 < X0 >>> 0) return q(D);
                  switch (X0) {
                    case 0:
                      return G(D);
                    case 1:
                      continue;
                    case 2:
                      r: for (; ; ) {
                        if (Nn(j(D)) === 0) for (; ; ) {
                          G0(D, 20);
                          var J0 = w9(j(D));
                          if (3 < J0 >>> 0) return q(D);
                          switch (J0) {
                            case 0:
                              return w(D);
                            case 1:
                              continue;
                            case 2:
                              continue r;
                            default:
                              G0(D, 18);
                              var ir = Bt(j(D));
                              if (ir === 0) {
                                for (; ; ) if (G0(D, 17), dn(j(D)) !== 0) return q(D);
                              }
                              return ir === 1 ? w(D) : q(D);
                          }
                        }
                        return q(D);
                      }
                    default:
                      G0(D, 18);
                      var Q0 = Bt(j(D));
                      if (Q0 === 0) {
                        for (; ; ) if (G0(D, 17), dn(j(D)) !== 0) return q(D);
                      }
                      return Q0 === 1 ? G(D) : q(D);
                  }
                }
                return q(D);
              }
              function S(D) {
                for (; ; ) if (G0(D, 13), dn(j(D)) !== 0) return q(D);
              }
              function M(D) {
                for (; ; ) if (G0(D, 13), dn(j(D)) !== 0) return q(D);
              }
              function K(D) {
                G0(D, 29);
                var u0 = Dr0(j(D));
                if (u0 === 0) return e(D);
                if (u0 === 1) for (; ; ) {
                  G0(D, 14);
                  var X0 = h9(j(D));
                  if (3 < X0 >>> 0) return q(D);
                  switch (X0) {
                    case 0:
                      return M(D);
                    case 1:
                      continue;
                    case 2:
                      r: for (; ; ) {
                        if (zu(j(D)) === 0) for (; ; ) {
                          G0(D, 14);
                          var J0 = h9(j(D));
                          if (3 < J0 >>> 0) return q(D);
                          switch (J0) {
                            case 0:
                              return S(D);
                            case 1:
                              continue;
                            case 2:
                              continue r;
                            default:
                              G0(D, 12);
                              var ir = Bt(j(D));
                              if (ir === 0) {
                                for (; ; ) if (G0(D, 11), dn(j(D)) !== 0) return q(D);
                              }
                              return ir === 1 ? S(D) : q(D);
                          }
                        }
                        return q(D);
                      }
                    default:
                      G0(D, 12);
                      var Q0 = Bt(j(D));
                      if (Q0 === 0) {
                        for (; ; ) if (G0(D, 11), dn(j(D)) !== 0) return q(D);
                      }
                      return Q0 === 1 ? M(D) : q(D);
                  }
                }
                return q(D);
              }
              function V(D) {
                for (; ; ) if (G0(D, 9), dn(j(D)) !== 0) return q(D);
              }
              function f0(D) {
                for (; ; ) if (G0(D, 9), dn(j(D)) !== 0) return q(D);
              }
              function m0(D) {
                G0(D, 29);
                var u0 = Pr0(j(D));
                if (u0 === 0) return e(D);
                if (u0 === 1) for (; ; ) {
                  G0(D, 10);
                  var X0 = k9(j(D));
                  if (3 < X0 >>> 0) return q(D);
                  switch (X0) {
                    case 0:
                      return f0(D);
                    case 1:
                      continue;
                    case 2:
                      r: for (; ; ) {
                        if (Gc(j(D)) === 0) for (; ; ) {
                          G0(D, 10);
                          var J0 = k9(j(D));
                          if (3 < J0 >>> 0) return q(D);
                          switch (J0) {
                            case 0:
                              return V(D);
                            case 1:
                              continue;
                            case 2:
                              continue r;
                            default:
                              G0(D, 8);
                              var ir = Bt(j(D));
                              if (ir === 0) {
                                for (; ; ) if (G0(D, 7), dn(j(D)) !== 0) return q(D);
                              }
                              return ir === 1 ? V(D) : q(D);
                          }
                        }
                        return q(D);
                      }
                    default:
                      G0(D, 8);
                      var Q0 = Bt(j(D));
                      if (Q0 === 0) {
                        for (; ; ) if (G0(D, 7), dn(j(D)) !== 0) return q(D);
                      }
                      return Q0 === 1 ? f0(D) : q(D);
                  }
                }
                return q(D);
              }
              function k0(D) {
                G0(D, 28);
                var u0 = Bt(j(D));
                if (u0 === 0) {
                  for (; ; ) if (G0(D, 26), dn(j(D)) !== 0) return q(D);
                }
                return u0 === 1 ? e(D) : q(D);
              }
              function g0(D) {
                G0(D, 30);
                var u0 = Qv(j(D));
                if (2 < u0 >>> 0) return q(D);
                switch (u0) {
                  case 0:
                    return e(D);
                  case 1:
                    for (; ; ) {
                      G0(D, 30);
                      var X0 = Mc(j(D));
                      if (3 < X0 >>> 0) return q(D);
                      switch (X0) {
                        case 0:
                          return e(D);
                        case 1:
                          continue;
                        case 2:
                          r: for (; ; ) {
                            if (pn(j(D)) === 0) for (; ; ) {
                              G0(D, 30);
                              var J0 = Mc(j(D));
                              if (3 < J0 >>> 0) return q(D);
                              switch (J0) {
                                case 0:
                                  return e(D);
                                case 1:
                                  continue;
                                case 2:
                                  continue r;
                                default:
                                  return i(D);
                              }
                            }
                            return q(D);
                          }
                        default:
                          return i(D);
                      }
                    }
                  default:
                    return i(D);
                }
              }
              function e0(D) {
                for (; ; ) {
                  G0(D, 30);
                  var u0 = u9(j(D));
                  if (3 < u0 >>> 0) return q(D);
                  switch (u0) {
                    case 0:
                      return e(D);
                    case 1:
                      return g0(D);
                    case 2:
                      continue;
                    default:
                      return k0(D);
                  }
                }
              }
              function x0(D) {
                for (; ; ) if (G0(D, 15), dn(j(D)) !== 0) return q(D);
              }
              function l(D) {
                G0(D, 15);
                var u0 = Bt(j(D));
                if (u0 === 0) {
                  for (; ; ) if (G0(D, 15), dn(j(D)) !== 0) return q(D);
                }
                return u0 === 1 ? x0(D) : q(D);
              }
              function c0(D) {
                for (; ; ) {
                  G0(D, 16);
                  var u0 = Mr0(j(D));
                  if (4 < u0 >>> 0) return q(D);
                  switch (u0) {
                    case 0:
                      return x0(D);
                    case 1:
                      return g0(D);
                    case 2:
                      continue;
                    case 3:
                      for (; ; ) {
                        G0(D, 15);
                        var X0 = u9(j(D));
                        if (3 < X0 >>> 0) return q(D);
                        switch (X0) {
                          case 0:
                            return x0(D);
                          case 1:
                            return g0(D);
                          case 2:
                            continue;
                          default:
                            return l(D);
                        }
                      }
                    default:
                      return l(D);
                  }
                }
              }
              function t0(D) {
                G0(D, 30);
                var u0 = Or0(j(D));
                if (3 < u0 >>> 0) return q(D);
                switch (u0) {
                  case 0:
                    return e(D);
                  case 1:
                    for (; ; ) {
                      G0(D, 30);
                      var X0 = Ps(j(D));
                      if (4 < X0 >>> 0) return q(D);
                      switch (X0) {
                        case 0:
                          return e(D);
                        case 1:
                          continue;
                        case 2:
                          return T(D);
                        case 3:
                          r: for (; ; ) {
                            if (pn(j(D)) === 0) for (; ; ) {
                              G0(D, 30);
                              var J0 = Ps(j(D));
                              if (4 < J0 >>> 0) return q(D);
                              switch (J0) {
                                case 0:
                                  return e(D);
                                case 1:
                                  continue;
                                case 2:
                                  return T(D);
                                case 3:
                                  continue r;
                                default:
                                  return i(D);
                              }
                            }
                            return q(D);
                          }
                        default:
                          return i(D);
                      }
                    }
                  case 2:
                    return T(D);
                  default:
                    return i(D);
                }
              }
              function o0(D) {
                G0(D, 30);
                var u0 = lL(j(D));
                if (8 < u0 >>> 0) return q(D);
                switch (u0) {
                  case 0:
                    return e(D);
                  case 1:
                    return t0(D);
                  case 2:
                    return c0(D);
                  case 3:
                    return e0(D);
                  case 4:
                    return m0(D);
                  case 5:
                    return T(D);
                  case 6:
                    return K(D);
                  case 7:
                    return A(D);
                  default:
                    return k0(D);
                }
              }
              function w0(D) {
                r: for (; ; ) {
                  if (pn(j(D)) === 0) for (; ; ) {
                    G0(D, 30);
                    var u0 = Rr0(j(D));
                    if (4 < u0 >>> 0) return q(D);
                    switch (u0) {
                      case 0:
                        return e(D);
                      case 1:
                        return g0(D);
                      case 2:
                        continue;
                      case 3:
                        continue r;
                      default:
                        return k0(D);
                    }
                  }
                  return q(D);
                }
              }
              function _0(D) {
                for (; ; ) {
                  G0(D, 30);
                  var u0 = o9(j(D));
                  if (5 < u0 >>> 0) return q(D);
                  switch (u0) {
                    case 0:
                      return e(D);
                    case 1:
                      return t0(D);
                    case 2:
                      continue;
                    case 3:
                      return T(D);
                    case 4:
                      return w0(D);
                    default:
                      return k0(D);
                  }
                }
              }
              function E0(D) {
                return G0(D, 3), Ur0(j(D)) === 0 ? 3 : q(D);
              }
              function U0(D) {
                return m9(j(D)) === 0 && v9(j(D)) === 0 && Br0(j(D)) === 0 && Ar0(j(D)) === 0 && Nr0(j(D)) === 0 && vL(j(D)) === 0 && Bl(j(D)) === 0 && m9(j(D)) === 0 && Ls(j(D)) === 0 && Cr0(j(D)) === 0 && Ul(j(D)) === 0 ? 3 : q(D);
              }
              gn(n);
              var b = j(n), R0 = ef < b ? vw < b ? -1 : Uk < b ? C3 < b ? Bw < b ? EE < b ? Wy < b ? 1 : 6 : Jd < b ? lE < b ? uF < b ? 1 : 6 : ZT < b ? 1 : 6 : WF < b ? bA < b ? 1 : 6 : sI < b ? 1 : 6 : C6 < b ? E4 < b ? x6 < b ? V8 < b ? j3 < b ? r3 < b ? CO < b ? 1 : 6 : LI < b ? 1 : 6 : Iy < b ? hg < b ? 1 : 6 : Mw < b ? 1 : 6 : L3 < b ? w8 < b ? jg < b ? 1 : 6 : $4 < b ? 1 : 6 : W8 < b ? zT < b ? 1 : 6 : kk < b ? 1 : 6 : O4 < b ? YO < b ? l3 < b ? Qk < b ? 1 : 6 : fk < b ? 1 : 6 : xp < b ? V6 < b ? 1 : 6 : Td < b ? 1 : 6 : G8 < b ? s4 < b ? t6 < b ? 1 : 6 : q6 < b ? 1 : 6 : B6 < b ? S4 < b ? 1 : 6 : fn < b ? 1 : 6 : LE < b ? M4 < b ? g6 < b ? SF < b ? i8 < b ? 1 : 6 : d8 < b ? 1 : 6 : F4 < b ? JF < b ? 1 : 6 : mh < b ? 1 : 6 : U6 < b ? n8 < b ? s3 < b ? 1 : 6 : S8 < b ? 1 : 6 : BS < b ? L8 < b ? 1 : 6 : K3 < b ? 1 : 6 : m8 < b ? f8 < b ? x8 < b ? w3 < b ? 1 : 6 : _6 < b ? 1 : 6 : s6 < b ? oF < b ? 1 : 6 : ZO < b ? 1 : 6 : a3 < b ? DS < b ? e8 < b ? 1 : 6 : g8 < b ? 1 : 6 : J3 < b ? sF < b ? 1 : 6 : ig < b ? 1 : 6 : iw < b ? Ek < b ? wk < b ? qk < b ? FT < b ? Vk < b ? 1 : 6 : uA < b ? 1 : 6 : dy < b ? VS < b ? 1 : 6 : _d < b ? 1 : 6 : Th < b ? pF < b ? FE < b ? 1 : 6 : Zw < b ? 1 : 6 : Sy < b ? L_ < b ? 1 : 6 : CE < b ? 1 : 6 : LF < b ? Vw < b ? My < b ? rw < b ? 1 : 6 : XI < b ? 1 : 6 : jO < b ? ap < b ? 1 : 6 : jT < b ? 1 : 6 : Ot < b ? OA < b ? gA < b ? 1 : 6 : 1 : 6 : c6 < b ? w6 < b ? l6 < b ? k3 < b ? VE < b ? 1 : 6 : qw < b ? 1 : 6 : v4 < b ? nE < b ? 1 : 6 : Ty < b ? 1 : 6 : c3 < b ? V4 < b ? eg < b ? 1 : 6 : qF < b ? 1 : 6 : X4 < b ? _T < b ? 1 : 6 : Oy < b ? 1 : 6 : D6 < b ? D4 < b ? V3 < b ? MS < b ? 1 : 6 : Ww < b ? 1 : 6 : cy < b ? jy < b ? 1 : 6 : VT < b ? 1 : 6 : B4 < b ? bh < b ? JT < b ? 1 : 6 : G3 < b ? 1 : 6 : r6 < b ? sO < b ? 1 : 6 : ZE < b ? 1 : 6 : uT < b ? Z4 < b ? Yd < b ? Q6 < b ? L4 < b ? N6 < b ? vp < b ? D_ < b ? 1 : 6 : Pd < b ? 1 : 6 : pd < b ? Rg < b ? 1 : 6 : OS < b ? 1 : 6 : G6 < b ? I3 < b ? uk < b ? 1 : 6 : cE < b ? 1 : 6 : l8 < b ? l4 < b ? 1 : 6 : rh < b ? 1 : 6 : M3 < b ? FS < b ? NE < b ? aT < b ? 1 : 6 : kT < b ? 1 : 6 : uS < b ? d3 < b ? 1 : 6 : zd < b ? 1 : 6 : ly < b ? T6 < b ? Pg < b ? 1 : 6 : vy < b ? 1 : 6 : LO < b ? yF < b ? 1 : 6 : YF < b ? 1 : 6 : DI < b ? au < b ? jF < b ? Ah < b ? AO < b ? 1 : 6 : Cd < b ? 1 : 6 : qh < b ? AS < b ? 1 : 6 : lA < b ? 1 : 6 : cO < b ? AI < b ? xI < b ? 1 : 6 : B_ < b ? 1 : 6 : hS < b ? fT < b ? 1 : 6 : mg < b ? 1 : 6 : NO < b ? Nw < b ? Yh < b ? lw < b ? 1 : 6 : Qg < b ? 1 : 6 : Vg < b ? Lk < b ? 1 : 6 : qO < b ? 1 : 6 : iS < b ? b6 < b ? h6 < b ? 1 : 6 : $F < b ? 1 : 6 : ph < b ? rT < b ? 1 : 6 : HS < b ? 1 : 6 : zO < b ? Ck < b ? yS < b ? Iw < b ? CI < b ? Kg < b ? 1 : 6 : VO < b ? 1 : 6 : Mk < b ? ks < b ? 1 : 6 : PF < b ? 1 : 6 : kd < b ? TS < b ? wI < b ? 1 : 6 : xg < b ? 1 : 6 : Rd < b ? dh < b ? 1 : 6 : oI < b ? 1 : 6 : oT < b ? lg < b ? tF < b ? KI < b ? 1 : 6 : pk < b ? 1 : 6 : G_ < b ? kw < b ? 1 : 6 : QF < b ? 1 : 6 : jk < b ? FO < b ? mA < b ? 1 : 6 : _g < b ? 1 : 6 : WE < b ? lF < b ? 1 : 6 : MF < b ? 1 : 6 : h4 < b ? h3 < b ? vT < b ? jI < b ? mS < b ? 1 : 6 : cA < b ? 1 : 6 : DE < b ? zk < b ? 1 : 6 : Lg < b ? 1 : 6 : AT < b ? R6 < b ? bk < b ? 1 : 6 : iT < b ? 1 : 6 : US < b ? BT < b ? 1 : 6 : vE < b ? 1 : 6 : Wc < b ? Sk < b ? D3 < b ? Xg < b ? 1 : 6 : fd < b ? 1 : 6 : IF < b ? ld < b ? 1 : 6 : nA < b ? 1 : 6 : BE < b ? W3 < b ? sy < b ? 1 : 6 : kI < b ? 1 : 6 : VF < b ? fS < b ? 1 : 6 : P4 < b ? 1 : 6 : vS < b ? jw < b ? ik < b ? hO < b ? iI < b ? bg < b ? Nd < b ? 1 : 6 : u3 < b ? 1 : 6 : sE < b ? Ld < b ? 1 : 6 : Xk < b ? 1 : 6 : up < b ? hh < b ? M8 < b ? 1 : 6 : p3 < b ? 1 : 6 : Ew < b ? pE < b ? 1 : 6 : Bg < b ? 1 : 6 : by < b ? Zk < b ? $T < b ? zF < b ? 1 : 6 : Bd < b ? 1 : 6 : $k < b ? TI < b ? 1 : 6 : pO < b ? 1 : 6 : sS < b ? RO < b ? kA < b ? 1 : 6 : wA < b ? 1 : 6 : fg < b ? qI < b ? 1 : 6 : dS < b ? 1 : 6 : hI < b ? NI < b ? nS < b ? Xy < b ? J_ < b ? 1 : 6 : bT < b ? 1 : 6 : $O < b ? Eg < b ? 1 : 6 : oA < b ? 1 : 6 : uE < b ? ET < b ? dg < b ? 1 : 6 : TT < b ? 1 : 6 : Ay < b ? u8 < b ? 1 : 6 : ZS < b ? 1 : 6 : Gh < b ? M_ < b ? SO < b ? lh < b ? 1 : 6 : XE < b ? 1 : 6 : Q3 < b ? Z6 < b ? 1 : 6 : Od < b ? 1 : 6 : W6 < b ? RF < b ? qy < b ? 1 : 6 : Nk < b ? 1 : 6 : PE < b ? Tg < b ? 1 : 6 : OI < b ? 1 : 6 : A8 < b ? P_ < b ? C4 < b ? $g < b ? Uh < b ? WS < b ? 1 : 6 : j6 < b ? 1 : 6 : _E < b ? fI < b ? 1 : 6 : Pw < b ? 1 : 6 : f3 < b ? a8 < b ? UF < b ? 1 : 6 : Lw < b ? 1 : 6 : mk < b ? aI < b ? 1 : 6 : yy < b ? 1 : 6 : O8 < b ? uI < b ? u6 < b ? ky < b ? 1 : 6 : GI < b ? 1 : 6 : c8 < b ? Ow < b ? 1 : 6 : bE < b ? 1 : 6 : y3 < b ? fp < b ? eE < b ? 1 : 6 : I8 < b ? 1 : 6 : cw < b ? KF < b ? 1 : 6 : VI < b ? 1 : 6 : zh < b ? QO < b ? h8 < b ? hy < b ? ew < b ? 1 : 6 : i3 < b ? 1 : 6 : pI < b ? dA < b ? 1 : 6 : qd < b ? 1 : 6 : kg < b ? iE < b ? TO < b ? 1 : 6 : X6 < b ? 1 : 6 : Rw < b ? aw < b ? 1 : 6 : F3 < b ? 1 : 6 : Ik < b ? OF < b ? Ly < b ? m4 < b ? 1 : 6 : cd < b ? 1 : 6 : zg < b ? Jk < b ? 1 : 6 : aS < b ? 1 : 6 : B3 < b ? IO < b ? hw < b ? 1 : 6 : mE < b ? 1 : 6 : $S < b ? QI < b ? 1 : 6 : FA < b ? 1 : 6 : od < b ? KE < b ? Rk < b ? J6 < b ? Md < b ? xF < b ? Zg < b ? sh < b ? eT < b ? 1 : 6 : YI < b ? 1 : 6 : RE < b ? OT < b ? 1 : 6 : J8 < b ? 1 : 6 : IA < b ? dE < b ? qT < b ? 1 : 6 : hd < b ? 1 : 6 : Id < b ? Mh < b ? 1 : 6 : _S < b ? 1 : 6 : EA < b ? PO < b ? Hg < b ? sg < b ? 1 : 6 : Ug < b ? 1 : 6 : Xw < b ? td < b ? 1 : 6 : Dg < b ? 1 : 6 : Ag < b ? bS < b ? Wd < b ? 1 : 6 : Fg < b ? 1 : 6 : tA < b ? wT < b ? 1 : 6 : Dk < b ? 1 : 6 : rS < b ? Z8 < b ? JI < b ? AE < b ? ME < b ? 1 : 6 : pA < b ? 1 : 6 : EO < b ? Gy < b ? 1 : 6 : fA < b ? 1 : 6 : xA < b ? b4 < b ? _k < b ? 1 : 6 : oO < b ? 1 : 6 : wd < b ? S7 < b ? 1 : 6 : $d < b ? 1 : 6 : X8 < b ? z_ < b ? Fd < b ? Ph < b ? 1 : 6 : dT < b ? 1 : 6 : Dd < b ? Ok < b ? 1 : 6 : ah < b ? 1 : 6 : nh < b ? ag < b ? $w < b ? 1 : 6 : WT < b ? 1 : 6 : QS < b ? Fw < b ? 1 : 6 : LT < b ? 1 : 6 : Ih < b ? vk < b ? En < b ? p8 < b ? gT < b ? M6 < b ? 1 : 6 : gh < b ? 1 : 6 : J4 < b ? Q_ < b ? 1 : 6 : op < b ? 1 : 6 : vO < b ? GE < b ? ch < b ? 1 : 6 : q_ < b ? 1 : 6 : ES < b ? UT < b ? 1 : 6 : jS < b ? 1 : 6 : Uw < b ? ty < b ? sA < b ? Vh < b ? 1 : 6 : sT < b ? 1 : 6 : iF < b ? Zd < b ? 1 : 6 : FI < b ? 1 : 6 : xO < b ? th < b ? ng < b ? 1 : 6 : bd < b ? 1 : 6 : iO < b ? _O < b ? 1 : 6 : eO < b ? 1 : 6 : IS < b ? zE < b ? fO < b ? ck < b ? xh < b ? 1 : 6 : ud < b ? 1 : 6 : JS < b ? _w < b ? 1 : 6 : Fy < b ? 1 : 6 : vA < b ? $E < b ? KT < b ? 1 : 6 : rI < b ? 1 : 6 : uy < b ? Tw < b ? 1 : 6 : 1 : nT < b ? Z3 < b ? ek < b ? 6 : $y < b ? 1 : 6 : GF < b ? Qw < b ? 1 : 6 : sk < b ? 1 : 6 : vg < b ? nO < b ? tI < b ? 1 : 6 : GO < b ? 1 : 6 : Ry < b ? 1 : 6 : D8 < b ? Ed < b ? xw < b ? Oh < b ? rA < b ? 6 : $h < b ? tT < b ? 1 : 6 : vF < b ? 1 : 6 : Qy < b ? zI < b ? ry < b ? 1 : 6 : yh < b ? 1 : 6 : HE < b ? Jh < b ? 1 : 6 : hF < b ? 1 : 6 : rp < b ? z4 < b ? S6 < b ? py < b ? 1 : 6 : rg < b ? 1 : 6 : $8 < b ? yO < b ? 1 : 6 : Bk < b ? 1 : 6 : gk < b ? U8 < b ? EF < b ? 1 : 6 : wy < b ? 1 : 6 : og < b ? Tk < b ? 1 : 6 : wE < b ? 1 : 6 : Gw < b ? $_ < b ? ey < b ? pS < b ? oE < b ? 1 : 6 : 1 : 6 : dw < b ? 6 : Q4 < b ? IT < b ? 1 : 6 : yg < b ? 1 : 6 : eI < b ? t3 < b ? Ma < b ? Do < b ? 1 : 2 : BI < b ? 1 : 6 : ow < b ? MT < b ? 1 : 6 : YS < b ? 1 : 6 : yI < b ? tS < b ? Zh < b ? 1 : 6 : CT < b ? 1 : 6 : GT < b ? Kw < b ? 1 : 6 : SI < b ? 1 : 6 : UI < b ? tk < b ? Qn < b ? R4 < b ? q3 < b ? id < b ? 1 : 6 : _F < b ? 1 : 6 : z3 < b ? L6 < b ? 1 : 6 : fh < b ? 1 : 6 : PT < b ? ip < b ? uw < b ? 1 : 6 : eS < b ? 1 : 6 : tO < b ? e3 < b ? 1 : 6 : oh < b ? 1 : 6 : dk < b ? zS < b ? Qh < b ? ug < b ? 1 : 6 : iy < b ? 1 : 6 : Wk < b ? Kd < b ? 1 : 6 : TE < b ? 1 : 6 : dd < b ? my < b ? cF < b ? 1 : 6 : _A < b ? 1 : 6 : Ny < b ? 1 : 6 : Xd < b ? H3 < b ? o3 < b ? Jw < b ? 1 : 6 : av < b ? 6 : RT < b ? 1 : 6 : gF < b ? k6 < b ? NF < b ? 1 : 6 : Wh < b ? 1 : 6 : Gk < b ? Dh < b ? 1 : 6 : ZI < b ? 1 : 6 : Vd < b ? cS < b ? lT < b ? cI < b ? 1 : 6 : 1 : Dy < b ? 6 : Jy < b ? 1 : 6 : FF < b ? sd < b ? 1 : 6 : XT < b ? OO < b ? 1 : 6 : aO < b ? 1 : 6 : wh < b ? F8 < b ? W_ < b ? uh < b ? kO < b ? ed < b ? EI < b ? Aw < b ? 1 : 6 : yA < b ? 1 : 6 : Bh < b ? fy < b ? 1 : 6 : ak < b ? 1 : 6 : CF < b ? TA < b ? lp < b ? 1 : 6 : 1 : 6 : yT < b ? Hd < b ? kS < b ? zy < b ? 1 : 6 : wS < b ? 1 : 6 : v6 < b ? Hk < b ? 1 : 6 : kE < b ? 1 : 6 : Sw < b ? pw < b ? 1 : 6 : _h < b ? WO < b ? 1 : 6 : k8 < b ? 1 : 6 : kF < b ? DO < b ? XF < b ? gy < b ? Sd < b ? 1 : 6 : eA < b ? 1 : 6 : Z_ < b ? JE < b ? 1 : 6 : ay < b ? 1 : 6 : Ky < b ? _8 < b ? Uy < b ? 1 : 6 : n3 < b ? 1 : 6 : rE < b ? oy < b ? 1 : 6 : cg < b ? 1 : 6 : Yy < b ? SA < b ? xS < b ? rF < b ? 1 : 6 : Xh < b ? 1 : 6 : mI < b ? lk < b ? 1 : 6 : uO < b ? 1 : 6 : PS < b && aA < b ? 1 : 6 : yk < b ? Rh < b ? tg < b ? nk < b ? 6 : Zy < b ? bI < b ? 1 : 6 : Ch < b ? 1 : 6 : xE < b ? ok < b ? V_ < b ? 1 : 6 : 1 : 6 : Og < b ? UO < b && oS < b ? 1 : 6 : bw < b ? rO < b ? Lh < b ? 1 : 6 : 1 : dF < b ? 6 : 1 : Eh < b ? gE < b ? U3 < b ? 6 : tw < b ? 1 : 6 : dI < b ? Qd < b ? wO < b ? 1 : 6 : R_ < b ? 1 : 6 : Sh < b ? 1 : 6 : BF < b ? gg < b ? Ad < b ? 1 : 6 : XS < b ? 1 : 6 : Kk < b ? YE < b ? 6 : ih < b ? 1 : 6 : U_ < b ? yE < b ? 1 : 6 : Ht < b ? 1 : 6 : GS < b ? jE < b ? dO < b ? q4 < b ? Ey < b ? E8 < b ? RI < b ? 1 : 6 : nF < b ? 1 : 6 : HF < b ? 1 : 6 : ww < b ? E3 < b ? de < b ? 1 : 6 : 1 : 6 : Ig < b ? Gd < b ? X_ < b ? H_ < b ? 1 : 6 : 1 : 6 : Hw < b ? T3 < b ? vd < b ? 1 : 6 : fF < b ? 1 : 6 : wg < b ? 1 : 6 : z8 < b ? j8 < b ? Eo < b ? PI < b ? 6 : Qx < b ? 1 : 2 : F6 < b ? By < b ? 1 : 6 : IE < b ? 1 : 6 : K8 < b ? z6 < b ? Cg < b ? 1 : 6 : cT < b ? 1 : 6 : o8 < b ? tt < b ? 1 : 6 : Ak < b ? 1 : 6 : NS < b ? tE < b ? j4 < b ? Ng < b ? 1 : 6 : $I < b ? 1 : 6 : P6 < b ? TF < b ? 1 : 6 : p4 < b ? 1 : 6 : _I < b ? fE < b ? gI < b ? 1 : 6 : N3 < b ? 1 : 6 : G4 < b ? B8 < b ? 1 : 6 : Sg < b ? 1 : 6 : N8 < b ? QE < b ? aE < b ? Yk < b ? pT < b ? K_ < b ? 1 : 6 : wF < b ? 1 : 6 : UE < b ? 1 : 6 : rd < b ? vI < b ? 6 : 1 : 6 : MO < b ? mw < b ? YT < b ? s8 < b ? 1 : 6 : AA < b ? 1 : 6 : Yw < b ? Y_ < b ? 1 : 6 : 1 : 6 : Gg < b ? JO < b ? $3 < b ? sp < b ? P8 < b ? 1 : 6 : Q8 < b ? 1 : 6 : gr < b ? t8 < b ? 1 : 6 : 1 : g4 < b ? KS < b ? 6 : m6 < b ? 1 : 6 : mF < b ? Cy < b ? 1 : 6 : R3 < b ? 1 : 6 : Pk < b ? HI < b ? QT < b ? x3 < b ? 1 : 6 : mO < b ? 1 : 6 : Py < b ? O3 < b ? 1 : 6 : ep < b ? 1 : 6 : mo < b ? xc < b ? ox < b ? 1 : 2 : fo < b ? 1 : 2 : $u < b ? Hu < b ? 1 : 3 : Co < b ? 1 : 2 : Vr(PLr, b + 1 | 0) - 1 | 0;
              if (30 < R0 >>> 0) var X = q(n);
              else switch (R0) {
                case 0:
                  var X = 62;
                  break;
                case 1:
                  var X = 63;
                  break;
                case 2:
                  if (G0(n, 1), jc(j(n)) === 0) {
                    for (; ; ) if (G0(n, 1), jc(j(n)) !== 0) {
                      var X = q(n);
                      break;
                    }
                  } else var X = q(n);
                  break;
                case 3:
                  var X = 0;
                  break;
                case 4:
                  G0(n, 0);
                  var s0 = xi(j(n)) !== 0 ? 1 : 0, X = s0 && q(n);
                  break;
                case 5:
                  var X = 6;
                  break;
                case 6:
                  var X = 61;
                  break;
                case 7:
                  if (G0(n, 63), Bl(j(n)) === 0) {
                    var hr = j(n), Ar = s7 < hr ? L7 < hr ? -1 : 0 : -1;
                    if (Ar === 0 && Ul(j(n)) === 0 && Bl(j(n)) === 0) var or = j(n), W0 = Yt < or ? Zc < or ? -1 : 0 : -1, X = W0 === 0 && gr0(j(n)) === 0 ? 31 : q(n);
                    else var X = q(n);
                  } else var X = q(n);
                  break;
                case 8:
                  var X = 56;
                  break;
                case 9:
                  var X = 38;
                  break;
                case 10:
                  var X = 39;
                  break;
                case 11:
                  G0(n, 53);
                  var X = qr0(j(n)) === 0 ? 4 : q(n);
                  break;
                case 12:
                  var X = 59;
                  break;
                case 13:
                  var X = 43;
                  break;
                case 14:
                  G0(n, 60);
                  var Lr = ql(j(n));
                  if (3 < Lr >>> 0) var X = q(n);
                  else switch (Lr) {
                    case 0:
                      for (; ; ) {
                        var Tr = ql(j(n));
                        if (3 < Tr >>> 0) var X = q(n);
                        else switch (Tr) {
                          case 0:
                            continue;
                          case 1:
                            var X = d(n);
                            break;
                          case 2:
                            var X = o0(n);
                            break;
                          default:
                            var X = _0(n);
                        }
                        break;
                      }
                      break;
                    case 1:
                      var X = d(n);
                      break;
                    case 2:
                      var X = o0(n);
                      break;
                    default:
                      var X = _0(n);
                  }
                  break;
                case 15:
                  G0(n, 41);
                  var Hr = D1(j(n)), X = Hr === 0 ? cL(j(n)) === 0 ? 40 : q(n) : Hr === 1 ? E(n) : q(n);
                  break;
                case 16:
                  G0(n, 63);
                  var Or = d9(j(n));
                  if (Or === 0) {
                    G0(n, 2);
                    var fr = i9(j(n));
                    if (2 < fr >>> 0) var X = q(n);
                    else switch (fr) {
                      case 0:
                        for (; ; ) {
                          var Rr = i9(j(n));
                          if (2 < Rr >>> 0) var X = q(n);
                          else switch (Rr) {
                            case 0:
                              continue;
                            case 1:
                              var X = E0(n);
                              break;
                            default:
                              var X = U0(n);
                          }
                          break;
                        }
                        break;
                      case 1:
                        var X = E0(n);
                        break;
                      default:
                        var X = U0(n);
                    }
                  } else var X = Or === 1 ? 5 : q(n);
                  break;
                case 17:
                  G0(n, 30);
                  var Wr = lL(j(n));
                  if (8 < Wr >>> 0) var X = q(n);
                  else switch (Wr) {
                    case 0:
                      var X = e(n);
                      break;
                    case 1:
                      var X = t0(n);
                      break;
                    case 2:
                      var X = c0(n);
                      break;
                    case 3:
                      var X = e0(n);
                      break;
                    case 4:
                      var X = m0(n);
                      break;
                    case 5:
                      var X = T(n);
                      break;
                    case 6:
                      var X = K(n);
                      break;
                    case 7:
                      var X = A(n);
                      break;
                    default:
                      var X = k0(n);
                  }
                  break;
                case 18:
                  G0(n, 30);
                  var Jr = o9(j(n));
                  if (5 < Jr >>> 0) var X = q(n);
                  else switch (Jr) {
                    case 0:
                      var X = e(n);
                      break;
                    case 1:
                      var X = t0(n);
                      break;
                    case 2:
                      var X = _0(n);
                      break;
                    case 3:
                      var X = T(n);
                      break;
                    case 4:
                      var X = w0(n);
                      break;
                    default:
                      var X = k0(n);
                  }
                  break;
                case 19:
                  var X = 44;
                  break;
                case 20:
                  var X = 42;
                  break;
                case 21:
                  var X = 49;
                  break;
                case 22:
                  G0(n, 51);
                  var ar = j(n), _r = 61 < ar ? 62 < ar ? -1 : 0 : -1, X = _r === 0 ? 57 : q(n);
                  break;
                case 23:
                  var X = 50;
                  break;
                case 24:
                  G0(n, 46);
                  var X = cL(j(n)) === 0 ? 45 : q(n);
                  break;
                case 25:
                  var X = 32;
                  break;
                case 26:
                  if (G0(n, 63), Ls(j(n)) === 0) {
                    var Ir = L1(j(n));
                    if (Ir === 0) var X = Nn(j(n)) === 0 && Nn(j(n)) === 0 && Nn(j(n)) === 0 ? 61 : q(n);
                    else if (Ir === 1 && Nn(j(n)) === 0) for (; ; ) {
                      var fe = A1(j(n));
                      if (fe !== 0) {
                        var X = fe === 1 ? 61 : q(n);
                        break;
                      }
                    }
                    else var X = q(n);
                  } else var X = q(n);
                  break;
                case 27:
                  var X = 33;
                  break;
                case 28:
                  G0(n, 34);
                  var v0 = j(n), P = ts < v0 ? X2 < v0 ? -1 : 0 : -1, X = P === 0 ? 36 : q(n);
                  break;
                case 29:
                  G0(n, 55);
                  var L = j(n), Q = X2 < L ? br < L ? -1 : 0 : -1, X = Q === 0 ? 37 : q(n);
                  break;
                default:
                  var X = 35;
              }
              if (63 < X >>> 0) return ke(SCr);
              var i0 = X;
              if (32 <= i0) switch (i0) {
                case 34:
                  return [0, t, 0];
                case 35:
                  return [0, t, 1];
                case 36:
                  return [0, t, 2];
                case 37:
                  return [0, t, 3];
                case 38:
                  return [0, t, 4];
                case 39:
                  return [0, t, 5];
                case 40:
                  return [0, t, 12];
                case 41:
                  return [0, t, 10];
                case 42:
                  return [0, t, 8];
                case 43:
                  return [0, t, 9];
                case 45:
                  return [0, t, 83];
                case 49:
                  return [0, t, 98];
                case 50:
                  return [0, t, 99];
                case 53:
                  return [0, t, Yt];
                case 55:
                  return [0, t, 89];
                case 56:
                  return [0, t, 91];
                case 57:
                  return [0, t, 11];
                case 59:
                  return [0, t, s7];
                case 60:
                  return [0, t, L7];
                case 61:
                  var l0 = n[6];
                  Hr0(n);
                  var S0 = Hl(t, l0, n[3]);
                  tL(n, l0);
                  var T0 = Ll(n), rr = Wr0(t, T0), L0 = rr[2], B = rr[1], Z = Ee(L0, OCr);
                  if (0 <= Z) {
                    if (!(0 < Z)) return [0, B, Av];
                    if (!n0(L0, MCr)) return [0, B, 29];
                    if (!n0(L0, BCr)) return [0, B, A2];
                    if (!n0(L0, qCr)) return [0, B, 42];
                    if (!n0(L0, UCr)) return [0, B, Sv];
                    if (!n0(L0, HCr)) return [0, B, tl];
                    if (!n0(L0, XCr)) return [0, B, 31];
                    if (!n0(L0, YCr)) return [0, B, 46];
                    if (!n0(L0, VCr)) return [0, B, uc];
                  } else {
                    if (!n0(L0, ICr)) return [0, B, t1];
                    if (!n0(L0, ACr)) return [0, B, z22];
                    if (!n0(L0, NCr)) return [0, B, GCr];
                    if (!n0(L0, CCr)) return [0, B, jCr];
                    if (!n0(L0, PCr)) return [0, B, f1];
                    if (!n0(L0, DCr)) return [0, B, 41];
                    if (!n0(L0, LCr)) return [0, B, 30];
                    if (!n0(L0, RCr)) return [0, B, 53];
                  }
                  return [0, B, [4, S0, L0, uL(T0)]];
                case 62:
                  var p0 = t[4] ? Gu(t, nt(t, n), 6) : t;
                  return [0, p0, Pn];
                case 63:
                  return [0, t, [6, Se(n)]];
                case 32:
                case 47:
                  return [0, t, 6];
                case 33:
                case 48:
                  return [0, t, 7];
                case 44:
                case 54:
                  return [0, t, 86];
                case 46:
                case 52:
                  return [0, t, 85];
                default:
                  return [0, t, 82];
              }
              switch (i0) {
                case 0:
                  return [2, d7(t, n)];
                case 1:
                  return [2, t];
                case 2:
                  var b0 = ju(t, n), O0 = $n(zn), M0 = R1(t, O0, n), er = M0[1];
                  return [1, er, Si(er, b0, M0[2], O0, 1)];
                case 3:
                  var yr = Se(n);
                  if (t[5]) {
                    var vr = t[4] ? Yr0(t, nt(t, n), yr) : t, $0 = $m(1, vr), Er = Jm(n);
                    return qn(jl(n, Er - 1 | 0, 1), gCr) && n0(jl(n, Er - 2 | 0, 1), FCr) ? [0, $0, 86] : [2, $0];
                  }
                  var Mr = ju(t, n), Br = $n(zn);
                  hn(Br, yr);
                  var qr = R1(t, Br, n), jr = qr[1];
                  return [1, jr, Si(jr, Mr, qr[2], Br, 1)];
                case 4:
                  if (t[4]) return [2, $m(0, t)];
                  $v(n), gn(n);
                  var $r = Tr0(j(n)) !== 0 ? 1 : 0, ne = $r && q(n);
                  return ne === 0 ? [0, t, Yt] : ke(TCr);
                case 5:
                  var Qr = ju(t, n), be = $n(zn), ae = e2(t, be, n), pe = ae[1];
                  return [1, pe, Si(pe, Qr, ae[2], be, 0)];
                case 6:
                  var oe = Se(n), ce = ju(t, n), ge = $n(zn), q0 = $n(zn);
                  hn(q0, oe);
                  var Fr = $r0(t, oe, ge, q0, 0, n), _ = Fr[1], k = [0, _[1], ce, Fr[2]], I = Fr[3], U = Mt(q0);
                  return [0, _, [2, [0, k, Mt(ge), U, I]]];
                case 7:
                  return Rt(t, n, function(D, u0) {
                    function X0(F0) {
                      if (c9(j(F0)) === 0) {
                        if (Gc(j(F0)) === 0) for (; ; ) {
                          var Sr = n9(j(F0));
                          if (2 < Sr >>> 0) return q(F0);
                          switch (Sr) {
                            case 0:
                              continue;
                            case 1:
                              r: for (; ; ) {
                                if (Gc(j(F0)) === 0) for (; ; ) {
                                  var mr = n9(j(F0));
                                  if (2 < mr >>> 0) return q(F0);
                                  switch (mr) {
                                    case 0:
                                      continue;
                                    case 1:
                                      continue r;
                                    default:
                                      return 0;
                                  }
                                }
                                return q(F0);
                              }
                            default:
                              return 0;
                          }
                        }
                        return q(F0);
                      }
                      return q(F0);
                    }
                    gn(u0);
                    var J0 = P1(j(u0));
                    if (J0 === 0) for (; ; ) {
                      var ir = N1(j(u0));
                      if (ir !== 0) {
                        var Q0 = ir === 1 ? X0(u0) : q(u0);
                        break;
                      }
                    }
                    else var Q0 = J0 === 1 ? X0(u0) : q(u0);
                    return Q0 === 0 ? [0, D, Hi(0, Se(u0))] : ke(ECr);
                  });
                case 8:
                  return [0, t, Hi(0, Se(n))];
                case 9:
                  return Rt(t, n, function(D, u0) {
                    function X0(F0) {
                      if (c9(j(F0)) === 0) {
                        if (Gc(j(F0)) === 0) for (; ; ) {
                          G0(F0, 0);
                          var Sr = e9(j(F0));
                          if (Sr !== 0) {
                            if (Sr === 1) r: for (; ; ) {
                              if (Gc(j(F0)) === 0) for (; ; ) {
                                G0(F0, 0);
                                var mr = e9(j(F0));
                                if (mr !== 0) {
                                  if (mr === 1) continue r;
                                  return q(F0);
                                }
                              }
                              return q(F0);
                            }
                            return q(F0);
                          }
                        }
                        return q(F0);
                      }
                      return q(F0);
                    }
                    gn(u0);
                    var J0 = P1(j(u0));
                    if (J0 === 0) for (; ; ) {
                      var ir = N1(j(u0));
                      if (ir !== 0) {
                        var Q0 = ir === 1 ? X0(u0) : q(u0);
                        break;
                      }
                    }
                    else var Q0 = J0 === 1 ? X0(u0) : q(u0);
                    return Q0 === 0 ? [0, D, qc(0, Se(u0))] : ke(wCr);
                  });
                case 10:
                  return [0, t, qc(0, Se(n))];
                case 11:
                  return Rt(t, n, function(D, u0) {
                    function X0(F0) {
                      if (b9(j(F0)) === 0) {
                        if (zu(j(F0)) === 0) for (; ; ) {
                          var Sr = a9(j(F0));
                          if (2 < Sr >>> 0) return q(F0);
                          switch (Sr) {
                            case 0:
                              continue;
                            case 1:
                              r: for (; ; ) {
                                if (zu(j(F0)) === 0) for (; ; ) {
                                  var mr = a9(j(F0));
                                  if (2 < mr >>> 0) return q(F0);
                                  switch (mr) {
                                    case 0:
                                      continue;
                                    case 1:
                                      continue r;
                                    default:
                                      return 0;
                                  }
                                }
                                return q(F0);
                              }
                            default:
                              return 0;
                          }
                        }
                        return q(F0);
                      }
                      return q(F0);
                    }
                    gn(u0);
                    var J0 = P1(j(u0));
                    if (J0 === 0) for (; ; ) {
                      var ir = N1(j(u0));
                      if (ir !== 0) {
                        var Q0 = ir === 1 ? X0(u0) : q(u0);
                        break;
                      }
                    }
                    else var Q0 = J0 === 1 ? X0(u0) : q(u0);
                    return Q0 === 0 ? [0, D, Hi(1, Se(u0))] : ke(kCr);
                  });
                case 12:
                  return [0, t, Hi(1, Se(n))];
                case 13:
                  return Rt(t, n, function(D, u0) {
                    function X0(F0) {
                      if (b9(j(F0)) === 0) {
                        if (zu(j(F0)) === 0) for (; ; ) {
                          G0(F0, 0);
                          var Sr = x9(j(F0));
                          if (Sr !== 0) {
                            if (Sr === 1) r: for (; ; ) {
                              if (zu(j(F0)) === 0) for (; ; ) {
                                G0(F0, 0);
                                var mr = x9(j(F0));
                                if (mr !== 0) {
                                  if (mr === 1) continue r;
                                  return q(F0);
                                }
                              }
                              return q(F0);
                            }
                            return q(F0);
                          }
                        }
                        return q(F0);
                      }
                      return q(F0);
                    }
                    gn(u0);
                    var J0 = P1(j(u0));
                    if (J0 === 0) for (; ; ) {
                      var ir = N1(j(u0));
                      if (ir !== 0) {
                        var Q0 = ir === 1 ? X0(u0) : q(u0);
                        break;
                      }
                    }
                    else var Q0 = J0 === 1 ? X0(u0) : q(u0);
                    return Q0 === 0 ? [0, D, qc(3, Se(u0))] : ke(dCr);
                  });
                case 14:
                  return [0, t, qc(3, Se(n))];
                case 15:
                  return Rt(t, n, function(D, u0) {
                    function X0(F0) {
                      if (zu(j(F0)) === 0) {
                        for (; ; ) if (G0(F0, 0), zu(j(F0)) !== 0) return q(F0);
                      }
                      return q(F0);
                    }
                    gn(u0);
                    var J0 = P1(j(u0));
                    if (J0 === 0) for (; ; ) {
                      var ir = N1(j(u0));
                      if (ir !== 0) {
                        var Q0 = ir === 1 ? X0(u0) : q(u0);
                        break;
                      }
                    }
                    else var Q0 = J0 === 1 ? X0(u0) : q(u0);
                    return Q0 === 0 ? [0, D, qc(1, Se(u0))] : ke(hCr);
                  });
                case 16:
                  return [0, t, qc(1, Se(n))];
                case 17:
                  return Rt(t, n, function(D, u0) {
                    function X0(F0) {
                      if (Zm(j(F0)) === 0) {
                        if (Nn(j(F0)) === 0) for (; ; ) {
                          var Sr = t9(j(F0));
                          if (2 < Sr >>> 0) return q(F0);
                          switch (Sr) {
                            case 0:
                              continue;
                            case 1:
                              r: for (; ; ) {
                                if (Nn(j(F0)) === 0) for (; ; ) {
                                  var mr = t9(j(F0));
                                  if (2 < mr >>> 0) return q(F0);
                                  switch (mr) {
                                    case 0:
                                      continue;
                                    case 1:
                                      continue r;
                                    default:
                                      return 0;
                                  }
                                }
                                return q(F0);
                              }
                            default:
                              return 0;
                          }
                        }
                        return q(F0);
                      }
                      return q(F0);
                    }
                    gn(u0);
                    var J0 = P1(j(u0));
                    if (J0 === 0) for (; ; ) {
                      var ir = N1(j(u0));
                      if (ir !== 0) {
                        var Q0 = ir === 1 ? X0(u0) : q(u0);
                        break;
                      }
                    }
                    else var Q0 = J0 === 1 ? X0(u0) : q(u0);
                    return Q0 === 0 ? [0, D, Hi(2, Se(u0))] : ke(yCr);
                  });
                case 19:
                  return Rt(t, n, function(D, u0) {
                    function X0(F0) {
                      if (Zm(j(F0)) === 0) {
                        if (Nn(j(F0)) === 0) for (; ; ) {
                          G0(F0, 0);
                          var Sr = _9(j(F0));
                          if (Sr !== 0) {
                            if (Sr === 1) r: for (; ; ) {
                              if (Nn(j(F0)) === 0) for (; ; ) {
                                G0(F0, 0);
                                var mr = _9(j(F0));
                                if (mr !== 0) {
                                  if (mr === 1) continue r;
                                  return q(F0);
                                }
                              }
                              return q(F0);
                            }
                            return q(F0);
                          }
                        }
                        return q(F0);
                      }
                      return q(F0);
                    }
                    gn(u0);
                    var J0 = P1(j(u0));
                    if (J0 === 0) for (; ; ) {
                      var ir = N1(j(u0));
                      if (ir !== 0) {
                        var Q0 = ir === 1 ? X0(u0) : q(u0);
                        break;
                      }
                    }
                    else var Q0 = J0 === 1 ? X0(u0) : q(u0);
                    return Q0 === 0 ? [0, D, qc(4, Se(u0))] : ke(_Cr);
                  });
                case 21:
                  return Rt(t, n, function(D, u0) {
                    function X0(h0) {
                      for (; ; ) {
                        var Kr = wi(j(h0));
                        if (2 < Kr >>> 0) return q(h0);
                        switch (Kr) {
                          case 0:
                            continue;
                          case 1:
                            r: for (; ; ) {
                              if (pn(j(h0)) === 0) for (; ; ) {
                                var re = wi(j(h0));
                                if (2 < re >>> 0) return q(h0);
                                switch (re) {
                                  case 0:
                                    continue;
                                  case 1:
                                    continue r;
                                  default:
                                    return 0;
                                }
                              }
                              return q(h0);
                            }
                          default:
                            return 0;
                        }
                      }
                    }
                    function J0(h0) {
                      for (; ; ) {
                        var Kr = r2(j(h0));
                        if (Kr !== 0) {
                          var re = Kr !== 1 ? 1 : 0;
                          return re && q(h0);
                        }
                      }
                    }
                    function ir(h0) {
                      var Kr = E9(j(h0));
                      if (2 < Kr >>> 0) return q(h0);
                      switch (Kr) {
                        case 0:
                          var re = C1(j(h0));
                          return re === 0 ? J0(h0) : re === 1 ? X0(h0) : q(h0);
                        case 1:
                          return J0(h0);
                        default:
                          return X0(h0);
                      }
                    }
                    function Q0(h0) {
                      if (pn(j(h0)) === 0) for (; ; ) {
                        var Kr = f7(j(h0));
                        if (2 < Kr >>> 0) return q(h0);
                        switch (Kr) {
                          case 0:
                            continue;
                          case 1:
                            return ir(h0);
                          default:
                            r: for (; ; ) {
                              if (pn(j(h0)) === 0) for (; ; ) {
                                var re = f7(j(h0));
                                if (2 < re >>> 0) return q(h0);
                                switch (re) {
                                  case 0:
                                    continue;
                                  case 1:
                                    return ir(h0);
                                  default:
                                    continue r;
                                }
                              }
                              return q(h0);
                            }
                        }
                      }
                      return q(h0);
                    }
                    function F0(h0) {
                      var Kr = p9(j(h0));
                      if (Kr === 0) for (; ; ) {
                        var re = f7(j(h0));
                        if (2 < re >>> 0) return q(h0);
                        switch (re) {
                          case 0:
                            continue;
                          case 1:
                            return ir(h0);
                          default:
                            r: for (; ; ) {
                              if (pn(j(h0)) === 0) for (; ; ) {
                                var xe = f7(j(h0));
                                if (2 < xe >>> 0) return q(h0);
                                switch (xe) {
                                  case 0:
                                    continue;
                                  case 1:
                                    return ir(h0);
                                  default:
                                    continue r;
                                }
                              }
                              return q(h0);
                            }
                        }
                      }
                      return Kr === 1 ? ir(h0) : q(h0);
                    }
                    function Sr(h0) {
                      var Kr = r9(j(h0));
                      return Kr === 0 ? F0(h0) : Kr === 1 ? ir(h0) : q(h0);
                    }
                    function mr(h0) {
                      for (; ; ) {
                        var Kr = l9(j(h0));
                        if (2 < Kr >>> 0) return q(h0);
                        switch (Kr) {
                          case 0:
                            return F0(h0);
                          case 1:
                            continue;
                          default:
                            return ir(h0);
                        }
                      }
                    }
                    gn(u0);
                    var Cr = f9(j(u0));
                    if (3 < Cr >>> 0) var sr = q(u0);
                    else switch (Cr) {
                      case 0:
                        for (; ; ) {
                          var Pr = ql(j(u0));
                          if (3 < Pr >>> 0) var sr = q(u0);
                          else switch (Pr) {
                            case 0:
                              continue;
                            case 1:
                              var sr = Q0(u0);
                              break;
                            case 2:
                              var sr = Sr(u0);
                              break;
                            default:
                              var sr = mr(u0);
                          }
                          break;
                        }
                        break;
                      case 1:
                        var sr = Q0(u0);
                        break;
                      case 2:
                        var sr = Sr(u0);
                        break;
                      default:
                        var sr = mr(u0);
                    }
                    if (sr === 0) {
                      var K0 = Se(u0), Ur = Gu(D, nt(D, u0), 23);
                      return [0, Ur, Hi(2, K0)];
                    }
                    return ke(mCr);
                  });
                case 22:
                  var Y = Se(n), y0 = Gu(t, nt(t, n), 23);
                  return [0, y0, Hi(2, Y)];
                case 23:
                  return Rt(t, n, function(D, u0) {
                    function X0(K0) {
                      for (; ; ) {
                        G0(K0, 0);
                        var Ur = Ds(j(K0));
                        if (Ur !== 0) {
                          if (Ur === 1) r: for (; ; ) {
                            if (pn(j(K0)) === 0) for (; ; ) {
                              G0(K0, 0);
                              var h0 = Ds(j(K0));
                              if (h0 !== 0) {
                                if (h0 === 1) continue r;
                                return q(K0);
                              }
                            }
                            return q(K0);
                          }
                          return q(K0);
                        }
                      }
                    }
                    function J0(K0) {
                      for (; ; ) if (G0(K0, 0), pn(j(K0)) !== 0) return q(K0);
                    }
                    function ir(K0) {
                      var Ur = E9(j(K0));
                      if (2 < Ur >>> 0) return q(K0);
                      switch (Ur) {
                        case 0:
                          var h0 = C1(j(K0));
                          return h0 === 0 ? J0(K0) : h0 === 1 ? X0(K0) : q(K0);
                        case 1:
                          return J0(K0);
                        default:
                          return X0(K0);
                      }
                    }
                    function Q0(K0) {
                      if (pn(j(K0)) === 0) for (; ; ) {
                        var Ur = f7(j(K0));
                        if (2 < Ur >>> 0) return q(K0);
                        switch (Ur) {
                          case 0:
                            continue;
                          case 1:
                            return ir(K0);
                          default:
                            r: for (; ; ) {
                              if (pn(j(K0)) === 0) for (; ; ) {
                                var h0 = f7(j(K0));
                                if (2 < h0 >>> 0) return q(K0);
                                switch (h0) {
                                  case 0:
                                    continue;
                                  case 1:
                                    return ir(K0);
                                  default:
                                    continue r;
                                }
                              }
                              return q(K0);
                            }
                        }
                      }
                      return q(K0);
                    }
                    function F0(K0) {
                      var Ur = p9(j(K0));
                      if (Ur === 0) for (; ; ) {
                        var h0 = f7(j(K0));
                        if (2 < h0 >>> 0) return q(K0);
                        switch (h0) {
                          case 0:
                            continue;
                          case 1:
                            return ir(K0);
                          default:
                            r: for (; ; ) {
                              if (pn(j(K0)) === 0) for (; ; ) {
                                var Kr = f7(j(K0));
                                if (2 < Kr >>> 0) return q(K0);
                                switch (Kr) {
                                  case 0:
                                    continue;
                                  case 1:
                                    return ir(K0);
                                  default:
                                    continue r;
                                }
                              }
                              return q(K0);
                            }
                        }
                      }
                      return Ur === 1 ? ir(K0) : q(K0);
                    }
                    function Sr(K0) {
                      var Ur = r9(j(K0));
                      return Ur === 0 ? F0(K0) : Ur === 1 ? ir(K0) : q(K0);
                    }
                    function mr(K0) {
                      for (; ; ) {
                        var Ur = l9(j(K0));
                        if (2 < Ur >>> 0) return q(K0);
                        switch (Ur) {
                          case 0:
                            return F0(K0);
                          case 1:
                            continue;
                          default:
                            return ir(K0);
                        }
                      }
                    }
                    gn(u0);
                    var Cr = f9(j(u0));
                    if (3 < Cr >>> 0) var sr = q(u0);
                    else switch (Cr) {
                      case 0:
                        for (; ; ) {
                          var Pr = ql(j(u0));
                          if (3 < Pr >>> 0) var sr = q(u0);
                          else switch (Pr) {
                            case 0:
                              continue;
                            case 1:
                              var sr = Q0(u0);
                              break;
                            case 2:
                              var sr = Sr(u0);
                              break;
                            default:
                              var sr = mr(u0);
                          }
                          break;
                        }
                        break;
                      case 1:
                        var sr = Q0(u0);
                        break;
                      case 2:
                        var sr = Sr(u0);
                        break;
                      default:
                        var sr = mr(u0);
                    }
                    return sr === 0 ? [0, D, qc(4, Se(u0))] : ke(pCr);
                  });
                case 25:
                  return Rt(t, n, function(D, u0) {
                    function X0(K0) {
                      for (; ; ) {
                        var Ur = wi(j(K0));
                        if (2 < Ur >>> 0) return q(K0);
                        switch (Ur) {
                          case 0:
                            continue;
                          case 1:
                            r: for (; ; ) {
                              if (pn(j(K0)) === 0) for (; ; ) {
                                var h0 = wi(j(K0));
                                if (2 < h0 >>> 0) return q(K0);
                                switch (h0) {
                                  case 0:
                                    continue;
                                  case 1:
                                    continue r;
                                  default:
                                    return 0;
                                }
                              }
                              return q(K0);
                            }
                          default:
                            return 0;
                        }
                      }
                    }
                    function J0(K0) {
                      return pn(j(K0)) === 0 ? X0(K0) : q(K0);
                    }
                    function ir(K0) {
                      var Ur = r2(j(K0));
                      if (Ur === 0) return X0(K0);
                      var h0 = Ur !== 1 ? 1 : 0;
                      return h0 && q(K0);
                    }
                    function Q0(K0) {
                      for (; ; ) {
                        var Ur = D1(j(K0));
                        if (Ur === 0) return ir(K0);
                        if (Ur !== 1) return q(K0);
                      }
                    }
                    function F0(K0) {
                      for (; ; ) {
                        var Ur = Bc(j(K0));
                        if (2 < Ur >>> 0) return q(K0);
                        switch (Ur) {
                          case 0:
                            return ir(K0);
                          case 1:
                            continue;
                          default:
                            r: for (; ; ) {
                              if (pn(j(K0)) === 0) for (; ; ) {
                                var h0 = Bc(j(K0));
                                if (2 < h0 >>> 0) return q(K0);
                                switch (h0) {
                                  case 0:
                                    return ir(K0);
                                  case 1:
                                    continue;
                                  default:
                                    continue r;
                                }
                              }
                              return q(K0);
                            }
                        }
                      }
                    }
                    gn(u0);
                    var Sr = f9(j(u0));
                    if (3 < Sr >>> 0) var mr = q(u0);
                    else switch (Sr) {
                      case 0:
                        for (; ; ) {
                          var Cr = ql(j(u0));
                          if (3 < Cr >>> 0) var mr = q(u0);
                          else switch (Cr) {
                            case 0:
                              continue;
                            case 1:
                              var mr = J0(u0);
                              break;
                            case 2:
                              var mr = Q0(u0);
                              break;
                            default:
                              var mr = F0(u0);
                          }
                          break;
                        }
                        break;
                      case 1:
                        var mr = J0(u0);
                        break;
                      case 2:
                        var mr = Q0(u0);
                        break;
                      default:
                        var mr = F0(u0);
                    }
                    if (mr === 0) {
                      var sr = Se(u0), Pr = Gu(D, nt(D, u0), 22);
                      return [0, Pr, Hi(2, sr)];
                    }
                    return ke(bCr);
                  });
                case 26:
                  return Rt(t, n, function(D, u0) {
                    function X0(mr) {
                      for (; ; ) {
                        var Cr = r2(j(mr));
                        if (Cr !== 0) {
                          var sr = Cr !== 1 ? 1 : 0;
                          return sr && q(mr);
                        }
                      }
                    }
                    function J0(mr) {
                      for (; ; ) {
                        var Cr = wi(j(mr));
                        if (2 < Cr >>> 0) return q(mr);
                        switch (Cr) {
                          case 0:
                            continue;
                          case 1:
                            r: for (; ; ) {
                              if (pn(j(mr)) === 0) for (; ; ) {
                                var sr = wi(j(mr));
                                if (2 < sr >>> 0) return q(mr);
                                switch (sr) {
                                  case 0:
                                    continue;
                                  case 1:
                                    continue r;
                                  default:
                                    return 0;
                                }
                              }
                              return q(mr);
                            }
                          default:
                            return 0;
                        }
                      }
                    }
                    gn(u0);
                    var ir = j(u0), Q0 = 44 < ir ? 57 < ir ? -1 : Vr(XDr, ir + mv | 0) - 1 | 0 : -1;
                    if (2 < Q0 >>> 0) var F0 = q(u0);
                    else switch (Q0) {
                      case 0:
                        for (; ; ) {
                          var Sr = jr0(j(u0));
                          if (2 < Sr >>> 0) var F0 = q(u0);
                          else switch (Sr) {
                            case 0:
                              continue;
                            case 1:
                              var F0 = X0(u0);
                              break;
                            default:
                              var F0 = J0(u0);
                          }
                          break;
                        }
                        break;
                      case 1:
                        var F0 = X0(u0);
                        break;
                      default:
                        var F0 = J0(u0);
                    }
                    return F0 === 0 ? [0, D, Hi(2, Se(u0))] : ke(lCr);
                  });
                case 27:
                  var P0 = Se(n), I0 = Gu(t, nt(t, n), 22);
                  return [0, I0, Hi(2, P0)];
                case 29:
                  return Rt(t, n, function(D, u0) {
                    function X0(re) {
                      for (; ; ) {
                        G0(re, 0);
                        var xe = Ds(j(re));
                        if (xe !== 0) {
                          if (xe === 1) r: for (; ; ) {
                            if (pn(j(re)) === 0) for (; ; ) {
                              G0(re, 0);
                              var Re = Ds(j(re));
                              if (Re !== 0) {
                                if (Re === 1) continue r;
                                return q(re);
                              }
                            }
                            return q(re);
                          }
                          return q(re);
                        }
                      }
                    }
                    function J0(re) {
                      return G0(re, 0), pn(j(re)) === 0 ? X0(re) : q(re);
                    }
                    gn(u0);
                    var ir = f9(j(u0));
                    if (3 < ir >>> 0) var Q0 = q(u0);
                    else switch (ir) {
                      case 0:
                        for (; ; ) {
                          var F0 = jr0(j(u0));
                          if (2 < F0 >>> 0) var Q0 = q(u0);
                          else switch (F0) {
                            case 0:
                              continue;
                            case 1:
                              for (; ; ) {
                                G0(u0, 0);
                                var Sr = D1(j(u0)), mr = Sr !== 0 ? 1 : 0;
                                if (mr) {
                                  if (Sr === 1) continue;
                                  var Q0 = q(u0);
                                } else var Q0 = mr;
                                break;
                              }
                              break;
                            default:
                              for (; ; ) {
                                G0(u0, 0);
                                var Cr = Bc(j(u0));
                                if (2 < Cr >>> 0) var Q0 = q(u0);
                                else switch (Cr) {
                                  case 0:
                                    var Q0 = 0;
                                    break;
                                  case 1:
                                    continue;
                                  default:
                                    r: for (; ; ) {
                                      if (pn(j(u0)) === 0) for (; ; ) {
                                        G0(u0, 0);
                                        var sr = Bc(j(u0));
                                        if (2 < sr >>> 0) var Pr = q(u0);
                                        else switch (sr) {
                                          case 0:
                                            var Pr = 0;
                                            break;
                                          case 1:
                                            continue;
                                          default:
                                            continue r;
                                        }
                                        break;
                                      }
                                      else var Pr = q(u0);
                                      var Q0 = Pr;
                                      break;
                                    }
                                }
                                break;
                              }
                          }
                          break;
                        }
                        break;
                      case 1:
                        var Q0 = pn(j(u0)) === 0 ? X0(u0) : q(u0);
                        break;
                      case 2:
                        for (; ; ) {
                          G0(u0, 0);
                          var K0 = D1(j(u0));
                          if (K0 === 0) var Q0 = J0(u0);
                          else {
                            if (K0 === 1) continue;
                            var Q0 = q(u0);
                          }
                          break;
                        }
                        break;
                      default:
                        for (; ; ) {
                          G0(u0, 0);
                          var Ur = Bc(j(u0));
                          if (2 < Ur >>> 0) var Q0 = q(u0);
                          else switch (Ur) {
                            case 0:
                              var Q0 = J0(u0);
                              break;
                            case 1:
                              continue;
                            default:
                              r: for (; ; ) {
                                if (pn(j(u0)) === 0) for (; ; ) {
                                  G0(u0, 0);
                                  var h0 = Bc(j(u0));
                                  if (2 < h0 >>> 0) var Kr = q(u0);
                                  else switch (h0) {
                                    case 0:
                                      var Kr = J0(u0);
                                      break;
                                    case 1:
                                      continue;
                                    default:
                                      continue r;
                                  }
                                  break;
                                }
                                else var Kr = q(u0);
                                var Q0 = Kr;
                                break;
                              }
                          }
                          break;
                        }
                    }
                    return Q0 === 0 ? [0, D, qc(4, Se(u0))] : ke(vCr);
                  });
                case 31:
                  return [0, t, 66];
                case 18:
                case 28:
                  return [0, t, Hi(2, Se(n))];
                default:
                  return [0, t, qc(4, Se(n))];
              }
            }
            function Xl(t) {
              return function(n) {
                for (var e = 0, i = n; ; ) {
                  var x = o(t, i, i[2]);
                  switch (x[0]) {
                    case 0:
                      var c = x[2], s = x[1], p = Xr0(s, c), y = e === 0 ? 0 : ye(e), T = s[6];
                      if (T === 0) return [0, [0, s[1], s[2], s[3], s[4], s[5], s[6], p], [0, c, p, 0, y]];
                      var E = [0, c, p, ye(T), y];
                      return [0, [0, s[1], s[2], s[3], s[4], s[5], _r0, p], E];
                    case 1:
                      var d = x[2], w = x[1], e = [0, d, e], i = [0, w[1], w[2], w[3], w[4], w[5], w[6], d[1]];
                      continue;
                    default:
                      var i = x[1];
                      continue;
                  }
                }
              };
            }
            var Gee = Xl(Dee), Mee = Xl(Lee), Bee = Xl(Ree), qee = Xl(jee), Uee = Xl(Pee), Mu = eL([0, bz]);
            function Yl(t, n) {
              return [0, 0, 0, n, yr0(t)];
            }
            function g9(t) {
              var n = t[4];
              switch (t[3]) {
                case 0:
                  var c0 = u(Uee, n);
                  break;
                case 1:
                  var c0 = u(qee, n);
                  break;
                case 2:
                  var c0 = u(Mee, n);
                  break;
                case 3:
                  var e = h7(n, n[2]), i = $n(zn), x = $n(zn), c = n[2];
                  gn(c);
                  var s = j(c), p = ts < s ? Hu < s ? 1 : $u < s ? 2 : 1 : Vr(fRr, s + 1 | 0) - 1 | 0;
                  if (5 < p >>> 0) var y = q(c);
                  else switch (p) {
                    case 0:
                      var y = 1;
                      break;
                    case 1:
                      var y = 4;
                      break;
                    case 2:
                      var y = 0;
                      break;
                    case 3:
                      G0(c, 0);
                      var T = xi(j(c)) !== 0 ? 1 : 0, y = T && q(c);
                      break;
                    case 4:
                      var y = 2;
                      break;
                    default:
                      var y = 3;
                  }
                  if (4 < y >>> 0) var E = ke(sCr);
                  else switch (y) {
                    case 0:
                      var d = Se(c);
                      hn(x, d), hn(i, d);
                      var w = pL(d7(n, c), 2, i, x, c), G = h7(w, c), A = Mt(i), S = Mt(x), E = [0, w, [8, [0, w[1], e, G], A, S]];
                      break;
                    case 1:
                      var E = [0, n, Pn];
                      break;
                    case 2:
                      var E = [0, n, 98];
                      break;
                    case 3:
                      var E = [0, n, 0];
                      break;
                    default:
                      $v(c);
                      var M = pL(n, 2, i, x, c), K = h7(M, c), V = Mt(i), f0 = Mt(x), E = [0, M, [8, [0, M[1], e, K], V, f0]];
                  }
                  var m0 = E[2], k0 = E[1], g0 = Xr0(k0, m0), e0 = k0[6];
                  if (e0 === 0) var l = [0, k0, [0, m0, g0, 0, 0]];
                  else var x0 = [0, m0, g0, ye(e0), 0], l = [0, [0, k0[1], k0[2], k0[3], k0[4], k0[5], 0, k0[7]], x0];
                  var c0 = l;
                  break;
                case 4:
                  var c0 = u(Bee, n);
                  break;
                default:
                  var c0 = u(Gee, n);
              }
              var t0 = c0[1], o0 = yr0(t0), w0 = [0, o0, c0[2]];
              return t[4] = t0, t[1] ? t[2] = [0, w0] : t[1] = [0, w0], w0;
            }
            function Qr0(t) {
              var n = t[1];
              return n ? n[1][2] : g9(t)[2];
            }
            function Hee(t, n, e, i) {
              var x = t && t[1], c = n && n[1];
              try {
                var s = 0, p = pr0(i), y = s, T = p;
              } catch (A) {
                if (A = Et(A), A !== I1) throw A;
                var E = [0, [0, [0, e, ez[2], ez[3]], 86], 0], y = E, T = pr0(Xjr);
              }
              var d = c ? c[1] : Bv, w = Cee(e, T, d[4]), G = [0, Yl(w, 0)];
              return [0, [0, y], [0, 0], Mu[1], [0, 0], d[5], 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, [0, Vjr], [0, w], G, [0, x], d, e, [0, 0], [0, Yjr]];
            }
            function n2(t) {
              return bl(t[23][1]);
            }
            function fu(t) {
              return t[27][4];
            }
            function ue(t, n) {
              var e = n[2];
              t[1][1] = [0, [0, n[1], e], t[1][1]];
              var i = t[22];
              return i && o(i[1], t, e);
            }
            function Vl(t, n) {
              return t[30][1] = n, 0;
            }
            function Rs(t, n) {
              if (t === 0) return Qr0(n[25][1]);
              if (t === 1) {
                var e = n[25][1];
                e[1] || g9(e);
                var i = e[2];
                return i ? i[1][2] : g9(e)[2];
              }
              throw [0, Sn, qjr];
            }
            function _s(t, n) {
              return t === n[5] ? n : [0, n[1], n[2], n[3], n[4], t, n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], n[17], n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function mL(t, n) {
              return t === n[17] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], t, n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function re0(t, n) {
              return t === n[18] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], n[17], t, n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function ee0(t, n) {
              return t === n[19] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], n[17], n[18], t, n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function t2(t, n) {
              return t === n[21] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], n[17], n[18], n[19], n[20], t, n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function F9(t, n) {
              return t === n[14] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], t, n[15], n[16], n[17], n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function zl(t, n) {
              return t === n[8] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], t, n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], n[17], n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function Kl(t, n) {
              return t === n[12] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], t, n[13], n[14], n[15], n[16], n[17], n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function u2(t, n) {
              return t === n[15] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14], t, n[16], n[17], n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function ne0(t, n) {
              return t === n[6] ? n : [0, n[1], n[2], n[3], n[4], n[5], t, n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], n[17], n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function te0(t, n) {
              return t === n[7] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], t, n[8], n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], n[17], n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function _L(t, n) {
              return t === n[13] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], t, n[14], n[15], n[16], n[17], n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function T9(t, n) {
              return [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], n[17], n[18], n[19], n[20], n[21], [0, t], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function yL(t) {
              function n(e) {
                return ue(t, e);
              }
              return function(e) {
                return Du(n, e);
              };
            }
            function i2(t) {
              var n = t[4][1], e = n && [0, n[1][2]];
              return e;
            }
            function ue0(t) {
              var n = t[4][1], e = n && [0, n[1][1]];
              return e;
            }
            function ie0(t) {
              return [0, t[1], t[2], t[3], t[4], t[5], t[6], t[7], t[8], t[9], t[10], t[11], t[12], t[13], t[14], t[15], t[16], t[17], t[18], t[19], t[20], t[21], 0, t[23], t[24], t[25], t[26], t[27], t[28], t[29], t[30]];
            }
            function fe0(t, n, e, i) {
              return [0, t[1], t[2], Mu[1], t[4], t[5], 0, 0, 0, 0, 0, 1, t[12], t[13], t[14], t[15], t[16], e, n, t[19], i, t[21], t[22], t[23], t[24], t[25], t[26], t[27], t[28], t[29], t[30]];
            }
            function xe0(t) {
              var n = Ee(t, xjr), e = 0;
              if (0 <= n) {
                if (0 < n) {
                  var i = Ee(t, gjr);
                  0 <= i ? 0 < i && n0(t, Djr) && n0(t, Ljr) && n0(t, Rjr) && n0(t, jjr) && n0(t, Gjr) && n0(t, Mjr) && n0(t, Bjr) && (e = 1) : n0(t, Fjr) && n0(t, Tjr) && n0(t, Ojr) && n0(t, Ijr) && n0(t, Ajr) && n0(t, Njr) && n0(t, Cjr) && n0(t, Pjr) && (e = 1);
                }
              } else {
                var x = Ee(t, ojr);
                0 <= x ? 0 < x && n0(t, _jr) && n0(t, yjr) && n0(t, hjr) && n0(t, djr) && n0(t, kjr) && n0(t, wjr) && n0(t, Ejr) && n0(t, Sjr) && (e = 1) : n0(t, ajr) && n0(t, cjr) && n0(t, sjr) && n0(t, vjr) && n0(t, ljr) && n0(t, bjr) && n0(t, pjr) && n0(t, mjr) && (e = 1);
              }
              return e ? 0 : 1;
            }
            function O9(t) {
              return n0(t, fjr) ? 0 : 1;
            }
            function hL(t) {
              if (typeof t == "number") {
                if (t === 48) return 1;
              } else if (t[0] === 4 && O9(t[3])) return 1;
              return 0;
            }
            function f2(t) {
              return n0(t, ZRr) && n0(t, QRr) && n0(t, rjr) && n0(t, ejr) && n0(t, njr) && n0(t, tjr) && n0(t, ujr) && n0(t, ijr) ? 0 : 1;
            }
            function dL(t) {
              if (typeof t == "number") switch (t) {
                case 42:
                case 52:
                case 53:
                case 54:
                case 55:
                case 56:
                case 57:
                case 58:
                  return 1;
              }
              else if (t[0] === 4 && f2(t[3])) return 1;
              return 0;
            }
            function js(t) {
              return n0(t, JRr) && n0(t, $Rr) ? 0 : 1;
            }
            function oe0(t) {
              return typeof t != "number" && t[0] === 4 && js(t[3]) ? 1 : 0;
            }
            function kL(t) {
              var n = xe0(t);
              if (n) var e = n;
              else {
                var i = O9(t);
                if (i) var e = i;
                else {
                  if (n0(t, zRr) && n0(t, KRr) && n0(t, WRr)) return 0;
                  var e = 1;
                }
              }
              return e;
            }
            function ae0(t) {
              var n = Ee(t, TRr), e = 0;
              return 0 <= n ? 0 < n && n0(t, RRr) && n0(t, jRr) && n0(t, GRr) && n0(t, MRr) && n0(t, BRr) && n0(t, qRr) && n0(t, URr) && n0(t, HRr) && (e = 1) : n0(t, ORr) && n0(t, IRr) && n0(t, ARr) && n0(t, NRr) && n0(t, CRr) && n0(t, PRr) && n0(t, DRr) && n0(t, LRr) && (e = 1), e ? 0 : 1;
            }
            function Yn(t, n) {
              return Rs(t, n)[1];
            }
            function Wl(t, n) {
              return Rs(t, n)[2];
            }
            function A0(t) {
              return Yn(0, t);
            }
            function Pe(t) {
              return Wl(0, t);
            }
            function j1(t) {
              var n = i2(t), e = n ? n[1] : ke(FRr);
              return [0, e[1], e[3], e[3]];
            }
            function wL(t) {
              return Rs(0, t)[3];
            }
            function pr(t) {
              var n = Rs(0, t)[4];
              return n && u(ml(function(e) {
                return ps(t[30][1], e[1][2]) <= 0 ? 1 : 0;
              }), n);
            }
            function ce0(t) {
              for (var n = Rs(0, t)[4]; ; ) {
                if (n) {
                  var e = n[2], i = ps(n[1][1][2], t[30][1]) < 0 ? 1 : 0;
                  if (i) return i;
                  var n = e;
                  continue;
                }
                return 0;
              }
            }
            function Jl(t, n) {
              var e = 0 < t ? [0, Wl(t - 1 | 0, n)] : i2(n);
              if (e) var i = e[1][2][1], x = i < Wl(t, n)[2][1] ? 1 : 0;
              else var x = e;
              return x;
            }
            function x7(t) {
              return Jl(0, t);
            }
            function se0(t, n) {
              var e = Yn(t, n);
              if (typeof e == "number") {
                var i = e - 2 | 0;
                if (Xt < i >>> 0) {
                  if (!(T7 < (i + 1 | 0) >>> 0)) return 1;
                } else {
                  var x = i !== 6 ? 1 : 0;
                  if (!x) return x;
                }
              }
              return Jl(t, n);
            }
            function x2(t) {
              return se0(0, t);
            }
            function I9(t, n) {
              var e = Yn(t, n);
              if (dL(e) || hL(e) || oe0(e)) return 1;
              var i = 0;
              if (typeof e == "number") switch (e) {
                case 14:
                case 28:
                case 60:
                case 61:
                case 62:
                case 63:
                case 64:
                case 65:
                  i = 1;
                  break;
              }
              else e[0] === 4 && (i = 1);
              return i ? 1 : 0;
            }
            function ve0(t, n) {
              var e = n2(n);
              if (e === 1) {
                var i = Yn(t, n);
                return typeof i != "number" && i[0] === 4 ? 1 : 0;
              }
              if (e) return 0;
              var x = Yn(t, n);
              if (typeof x == "number") switch (x) {
                case 42:
                case 46:
                case 47:
                  return 0;
                case 15:
                case 16:
                case 17:
                case 18:
                case 19:
                case 20:
                case 21:
                case 22:
                case 23:
                case 24:
                case 25:
                case 26:
                case 27:
                case 28:
                case 29:
                case 30:
                case 31:
                case 32:
                case 33:
                case 34:
                case 35:
                case 36:
                case 37:
                case 38:
                case 39:
                case 40:
                case 41:
                case 43:
                case 44:
                case 45:
                case 48:
                case 49:
                case 50:
                case 51:
                case 52:
                case 53:
                case 54:
                case 55:
                case 56:
                case 57:
                case 58:
                case 59:
                case 60:
                case 61:
                case 62:
                case 63:
                case 64:
                case 65:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                  break;
                default:
                  return 0;
              }
              else switch (x[0]) {
                case 4:
                  if (ae0(x[3])) return 0;
                  break;
                case 9:
                case 10:
                case 11:
                  break;
                default:
                  return 0;
              }
              return 1;
            }
            function G1(t) {
              return I9(0, t);
            }
            function Gs(t) {
              var n = A0(t) === 15 ? 1 : 0;
              if (n) var e = n;
              else {
                var i = A0(t) === 64 ? 1 : 0;
                if (i) {
                  var x = Yn(1, t) === 15 ? 1 : 0;
                  if (x) var c = Wl(1, t)[2][1], e = Pe(t)[3][1] === c ? 1 : 0;
                  else var e = x;
                } else var e = i;
              }
              return e;
            }
            function $l(t) {
              var n = A0(t);
              if (typeof n == "number") {
                var e = 0;
                if ((n === 13 || n === 40) && (e = 1), e) return 1;
              }
              return 0;
            }
            function je(t, n) {
              return ue(t, [0, Pe(t), n]);
            }
            function le0(t, n) {
              if (hL(n)) return 2;
              if (dL(n)) return 55;
              var e = aL(0, n);
              return t ? [11, e, t[1]] : [10, e];
            }
            function St(t, n) {
              var e = wL(n);
              return u(yL(n), e), je(n, le0(t, A0(n)));
            }
            function A9(t) {
              function n(e) {
                return ue(t, [0, e[1], 76]);
              }
              return function(e) {
                return Du(n, e);
              };
            }
            function be0(t, n) {
              var e = t[6] ? ur(et(SRr), n, n, n) : gRr;
              return St([0, e], t);
            }
            function gi(t, n) {
              var e = t[5];
              return e && je(t, n);
            }
            function V7(t, n) {
              var e = t[5];
              return e && ue(t, [0, n[1], n[2]]);
            }
            function M1(t, n) {
              return ue(t, [0, n, [18, t[5]]]);
            }
            function ie(t) {
              var n = t[26][1];
              if (n) {
                var e = n2(t), i = A0(t), x = [0, Pe(t), i, e];
                u(n[1], x);
              }
              var c = t[25][1], s = c[1], p = s ? s[1][1] : g9(c)[1];
              t[24][1] = p;
              var y = wL(t);
              u(yL(t), y);
              var T = t[2][1], E = Lc(Rs(0, t)[4], T);
              t[2][1] = E;
              var d = [0, Rs(0, t)];
              t[4][1] = d;
              var w = t[25][1];
              return w[2] ? (w[1] = w[2], w[2] = 0, 0) : (Qr0(w), w[1] = 0, 0);
            }
            function xu(t, n) {
              var e = o(iL, A0(t), n);
              return e && ie(t), e;
            }
            function Ku(t, n) {
              t[23][1] = [0, n, t[23][1]];
              var e = n2(t), i = Yl(t[24][1], e);
              return t[25][1] = i, 0;
            }
            function k7(t) {
              var n = t[23][1], e = n ? n[2] : ke(ERr);
              t[23][1] = e;
              var i = n2(t), x = Yl(t[24][1], i);
              return t[25][1] = x, 0;
            }
            function we(t) {
              var n = Pe(t);
              if (A0(t) === 9 && Jl(1, t)) {
                var e = pr(t), i = Rs(1, t)[4], x = on(e, u(ml(function(s) {
                  return s[1][2][1] <= n[3][1] ? 1 : 0;
                }), i));
                return Vl(t, [0, n[3][1] + 1 | 0, 0]), x;
              }
              var c = pr(t);
              return Vl(t, n[3]), c;
            }
            function Ms(t) {
              var n = t[4][1];
              if (n) {
                var e = n[1][2], i = pr(t), x = u(ml(function(p) {
                  return p[1][2][1] <= e[3][1] ? 1 : 0;
                }), i);
                Vl(t, [0, e[3][1] + 1 | 0, 0]);
                var c = x;
              } else var c = n;
              return c;
            }
            function B1(t, n) {
              return St([0, aL(hRr, n)], t);
            }
            function Y0(t, n) {
              return 1 - o(iL, A0(t), n) && B1(t, n), ie(t);
            }
            function pe0(t, n) {
              var e = xu(t, n);
              return 1 - e && B1(t, n), e;
            }
            function Zl(t, n) {
              var e = A0(t), i = 0;
              return typeof e != "number" && e[0] === 4 && qn(e[3], n) && (i = 1), i || St([0, u(et(yRr), n)], t), ie(t);
            }
            var Bs = [wt, zjr, M7(0)];
            function Xee(t) {
              var n = t[26][1];
              if (n) {
                var e = mz(0), i = [0, function(s) {
                  return aN(s, e);
                }];
                t[26][1] = i;
                var x = [0, [0, n[1], e]];
              } else var x = n;
              return [0, t[1][1], t[2][1], t[4][1], t[23][1], t[24][1], t[30][1], x];
            }
            function me0(t, n, e) {
              if (e) {
                var i = e[1], x = i[1];
                if (n[26][1] = [0, x], t) for (var c = i[2][2]; ; ) {
                  if (c) {
                    var s = c[2];
                    u(x, c[1]);
                    var c = s;
                    continue;
                  }
                  return 0;
                }
                var p = t;
              } else var p = e;
              return p;
            }
            function Yee(t, n) {
              me0(0, t, n[7]), t[1][1] = n[1], t[2][1] = n[2], t[4][1] = n[3], t[23][1] = n[4], t[24][1] = n[5], t[30][1] = n[6];
              var e = n2(t), i = Yl(t[24][1], e);
              return t[25][1] = i, 0;
            }
            function Vee(t, n, e) {
              return me0(1, t, n[7]), [0, e];
            }
            function EL(t, n) {
              var e = Xee(t);
              try {
                var i = Vee(t, e, u(n, t));
                return i;
              } catch (x) {
                if (x = Et(x), x === Bs) return Yee(t, e);
                throw x;
              }
            }
            function _e0(t, n, e) {
              var i = EL(t, e);
              return i ? i[1] : n;
            }
            function Ql(t, n) {
              var e = ye(n);
              if (e) {
                var i = e[1], x = u(t, i);
                return i === x ? n : ye([0, x, e[2]]);
              }
              return n;
            }
            var ye0 = Rp(Zjr, function(t) {
              var n = PN(t, Wjr), e = NN(t, $jr), i = e[22], x = e[26], c = e[35], s = e[77], p = e[iV], y = e[gO], T = e[cp], E = e[BO], d = e[jh], w = e[ZF], G = e[6], A = e[7], S = e[10], M = e[17], K = e[21], V = e[27], f0 = e[33], m0 = e[36], k0 = e[46], g0 = e[51], e0 = e[89], x0 = e[92], l = e[97], c0 = e[99], t0 = e[ti], o0 = e[Pn], w0 = e[Sv], _0 = e[zw], E0 = e[Jg], U0 = e[dH], b = e[DX], R0 = e[eH], X = e[FH], s0 = e[kh], hr = e[AF], Ar = e[Wg], or = e[A6], W0 = e[Cw], Lr = e[iA], Tr = e[rk], Hr = e[hT], Or = e[lO], fr = e[i6], Rr = e[ST], Wr = e[v8], Jr = e[$2], ar = LN(t, 0, 0, nz, KD, 1)[1];
              function _r(q0, Fr, _) {
                var k = _[2], I = k[2], U = k[1], Y = _[1];
                if (I) {
                  var y0 = function(D) {
                    return [0, Y, [0, U, [0, D]]];
                  }, P0 = I[1];
                  return ee(u(q0[1][1 + y], q0), P0, _, y0);
                }
                function I0(D) {
                  return [0, Y, [0, D, I]];
                }
                return ee(o(q0[1][1 + G], q0, Fr), U, _, I0);
              }
              function Ir(q0, Fr, _) {
                var k = _[2], I = _[1], U = I[3], Y = I[2];
                if (U) var y0 = Ql(u(q0[1][1 + x], q0), U), P0 = Y;
                else var y0 = 0, P0 = o(q0[1][1 + x], q0, Y);
                var I0 = o(q0[1][1 + c], q0, k);
                return Y === P0 && U === y0 && k === I0 ? _ : [0, [0, I[1], P0, y0], I0];
              }
              function fe(q0, Fr) {
                var _ = Fr[2], k = _[1], I = Fr[1];
                function U(y0) {
                  return [0, I, [0, k, y0]];
                }
                var Y = _[2];
                return ee(u(q0[1][1 + c], q0), Y, Fr, U);
              }
              function v0(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], _[2], U];
                }
                var I = _[3];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              function P(q0, Fr) {
                function _(I) {
                  return [0, Fr[1], I];
                }
                var k = Fr[2];
                return ee(u(q0[1][1 + c], q0), k, Fr, _);
              }
              function L(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], _[2], U];
                }
                var I = _[3];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              function Q(q0, Fr, _) {
                var k = _[2], I = _[1], U = Ql(u(q0[1][1 + y], q0), I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, U, Y];
              }
              function i0(q0, Fr) {
                var _ = Fr[2], k = _[1], I = Fr[1];
                function U(y0) {
                  return [0, I, [0, k, y0]];
                }
                var Y = _[2];
                return ee(u(q0[1][1 + c], q0), Y, Fr, U);
              }
              function l0(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], _[2], _[3], U];
                }
                var I = _[4];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              function S0(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], U];
                }
                var I = _[2];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              function T0(q0, Fr, _) {
                var k = _[3], I = _[2], U = o(q0[1][1 + l], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], U, Y];
              }
              function rr(q0, Fr, _) {
                var k = _[4], I = _[3], U = _[2], Y = _[1], y0 = o(q0[1][1 + c], q0, k);
                if (I) {
                  var P0 = ze(u(q0[1][1 + w], q0), I);
                  return I === P0 && k === y0 ? _ : [0, _[1], _[2], P0, y0];
                }
                if (U) {
                  var I0 = ze(u(q0[1][1 + d], q0), U);
                  return U === I0 && k === y0 ? _ : [0, _[1], I0, _[3], y0];
                }
                var D = o(q0[1][1 + y], q0, Y);
                return Y === D && k === y0 ? _ : [0, D, _[2], _[3], y0];
              }
              function L0(q0, Fr, _) {
                var k = _[4], I = _[3], U = o(q0[1][1 + y], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], _[2], U, Y];
              }
              function B(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], _[2], _[3], U];
                }
                var I = _[4];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              function Z(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], _[2], _[3], U];
                }
                var I = _[4];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              function p0(q0, Fr, _) {
                var k = _[2], I = _[1], U = I[3], Y = I[2];
                if (U) var y0 = Ql(u(q0[1][1 + x], q0), U), P0 = Y;
                else var y0 = 0, P0 = o(q0[1][1 + x], q0, Y);
                var I0 = o(q0[1][1 + c], q0, k);
                return Y === P0 && U === y0 && k === I0 ? _ : [0, [0, I[1], P0, y0], I0];
              }
              function b0(q0, Fr, _) {
                var k = _[3], I = _[1], U = _u(u(q0[1][1 + s], q0), I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, U, _[2], Y];
              }
              function O0(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], U];
                }
                var I = _[2];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              function M0(q0, Fr) {
                if (Fr[0] === 0) {
                  var _ = function(P0) {
                    return [0, P0];
                  }, k = Fr[1];
                  return ee(u(q0[1][1 + p], q0), k, Fr, _);
                }
                var I = Fr[1], U = I[2], Y = U[2], y0 = o(q0[1][1 + p], q0, Y);
                return Y === y0 ? Fr : [1, [0, I[1], [0, U[1], y0]]];
              }
              function er(q0, Fr, _) {
                var k = _[4], I = _[3], U = o(q0[1][1 + x], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], _[2], U, Y];
              }
              function yr(q0, Fr) {
                var _ = Fr[2], k = Fr[1];
                function I(Y) {
                  return [0, k, [0, _[1], _[2], _[3], Y]];
                }
                var U = _[4];
                return ee(u(q0[1][1 + c], q0), U, [0, k, _], I);
              }
              function vr(q0, Fr, _) {
                var k = _[9], I = _[3], U = o(q0[1][1 + s0], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], _[2], U, _[4], _[5], _[6], _[7], _[8], Y, _[10]];
              }
              function $0(q0, Fr, _) {
                var k = _[4], I = _[3], U = o(q0[1][1 + y], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], _[2], U, Y];
              }
              function Er(q0, Fr) {
                var _ = Fr[2], k = _[1], I = Fr[1];
                function U(y0) {
                  return [0, I, [0, k, y0]];
                }
                var Y = _[2];
                return ee(u(q0[1][1 + c], q0), Y, Fr, U);
              }
              function Mr(q0, Fr) {
                var _ = Fr[2], k = _[2], I = _[1], U = Fr[1];
                if (k === 0) {
                  var Y = function(I0) {
                    return [0, U, [0, I0, k]];
                  };
                  return ee(u(q0[1][1 + p], q0), I, Fr, Y);
                }
                function y0(I0) {
                  return [0, U, [0, I, I0]];
                }
                var P0 = u(q0[1][1 + i], q0);
                return ee(function(I0) {
                  return ze(P0, I0);
                }, k, Fr, y0);
              }
              function Br(q0, Fr) {
                var _ = Fr[2], k = _[2], I = Fr[1];
                function U(P0) {
                  return [0, I, [0, P0, k]];
                }
                var Y = _[1], y0 = u(q0[1][1 + T], q0);
                return ee(function(P0) {
                  return Ql(y0, P0);
                }, Y, Fr, U);
              }
              function qr(q0, Fr, _) {
                var k = _[2];
                if (k === 0) {
                  var I = function(P0) {
                    return [0, P0, _[2], _[3]];
                  }, U = _[1];
                  return ee(u(q0[1][1 + y], q0), U, _, I);
                }
                function Y(P0) {
                  return [0, _[1], P0, _[3]];
                }
                var y0 = u(q0[1][1 + i], q0);
                return ee(function(P0) {
                  return ze(y0, P0);
                }, k, _, Y);
              }
              function jr(q0, Fr) {
                var _ = Fr[2], k = _[1], I = Fr[1];
                function U(y0) {
                  return [0, I, [0, k, y0]];
                }
                var Y = _[2];
                return ee(u(q0[1][1 + c], q0), Y, Fr, U);
              }
              function $r(q0, Fr, _) {
                var k = _[7], I = _[2], U = o(q0[1][1 + E], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], U, _[3], _[4], _[5], _[6], Y];
              }
              function ne(q0, Fr) {
                var _ = Fr[2], k = _[1], I = Fr[1];
                function U(y0) {
                  return [0, I, [0, k, y0]];
                }
                var Y = _[2];
                return ee(u(q0[1][1 + c], q0), Y, Fr, U);
              }
              function Qr(q0, Fr) {
                var _ = Fr[2], k = _[1], I = Fr[1];
                function U(y0) {
                  return [0, I, [0, k, y0]];
                }
                var Y = _[2];
                return ee(u(q0[1][1 + c], q0), Y, Fr, U);
              }
              function be(q0, Fr, _) {
                var k = _[4], I = _[3], U = o(q0[1][1 + w], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], _[2], U, Y];
              }
              function ae(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], U];
                }
                var I = _[2];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              function pe(q0, Fr, _) {
                var k = _[4], I = _[3], U = o(q0[1][1 + y], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], _[2], U, Y];
              }
              function oe(q0, Fr, _) {
                var k = _[4], I = _[3], U = o(q0[1][1 + y], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], _[2], U, Y];
              }
              function ce(q0, Fr) {
                function _(I) {
                  return [0, Fr[1], I];
                }
                var k = Fr[2];
                return ee(u(q0[1][1 + c], q0), k, Fr, _);
              }
              function ge(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], U];
                }
                var I = _[2];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              return jN(t, [0, m0, function(q0, Fr) {
                var _ = Fr[2], k = u(ml(function(U) {
                  return ps(U[1][2], q0[1 + n]) < 0 ? 1 : 0;
                }), _), I = Dc(k);
                return Dc(_) === I ? Fr : [0, Fr[1], k, Fr[3]];
              }, Jr, ge, Wr, ce, Rr, oe, fr, pe, Or, ae, Hr, be, w, Qr, d, ne, Tr, $r, E, jr, Lr, qr, W0, Br, T, Mr, or, Er, Ar, $0, hr, vr, X, yr, R0, er, b, M0, U0, O0, E0, b0, _0, p0, w0, Z, o0, B, t0, L0, x0, rr, c0, T0, e0, S0, s, l0, g0, i0, k0, Q, f0, L, V, P, K, v0, M, fe, S, Ir, A, _r]), function(q0, Fr, _) {
                var k = jp(Fr, t);
                return k[1 + n] = _, u(ar, k), RN(Fr, k, t);
              };
            });
            function N9(t) {
              var n = i2(t);
              if (n) var e = n[1], i = ce0(t) ? (Vl(t, e[3]), [0, o(ye0[1], 0, e[3])]) : 0, x = i;
              else var x = n;
              return [0, 0, function(c, s) {
                return x ? o(s, x[1], c) : c;
              }];
            }
            function rb(t) {
              var n = i2(t);
              if (n) {
                var e = n[1];
                if (ce0(t)) {
                  Vl(t, e[3]);
                  var i = Ms(t), x = [0, o(ye0[1], 0, [0, e[3][1] + 1 | 0, 0])], c = i;
                } else var x = 0, c = Ms(t);
              } else var x = 0, c = 0;
              return [0, c, function(s, p) {
                return x ? o(p, x[1], s) : s;
              }];
            }
            function $t(t) {
              return x7(t) ? rb(t) : N9(t);
            }
            function ys(t, n) {
              var e = $t(t);
              function i(x, c) {
                return o(Qe(x, Nv, 27), x, c);
              }
              return o(e[2], n, i);
            }
            function oi(t, n) {
              if (n) var e = $t(t), i = function(c, s) {
                return o(Qe(c, bF, 30), c, s);
              }, x = [0, o(e[2], n[1], i)];
              else var x = n;
              return x;
            }
            function o2(t, n) {
              var e = $t(t);
              function i(x, c) {
                return o(Qe(x, -983660142, 32), x, c);
              }
              return o(e[2], n, i);
            }
            function eb(t, n) {
              var e = $t(t);
              function i(x, c) {
                return o(Qe(x, -455772979, 33), x, c);
              }
              return o(e[2], n, i);
            }
            function he0(t, n) {
              if (n) var e = $t(t), i = function(c, s) {
                return o(Qe(c, kH, 34), c, s);
              }, x = [0, o(e[2], n[1], i)];
              else var x = n;
              return x;
            }
            function Xi(t, n) {
              var e = $t(t);
              function i(x, c) {
                return o(Qe(x, qY, 35), x, c);
              }
              return o(e[2], n, i);
            }
            function de0(t, n) {
              var e = $t(t);
              function i(x, c) {
                var s = u(Qe(x, ZU, 37), x);
                return Ql(function(p) {
                  return _u(s, p);
                }, c);
              }
              return o(e[2], n, i);
            }
            function ke0(t, n) {
              var e = $t(t);
              function i(x, c) {
                return o(Qe(x, -21476009, 38), x, c);
              }
              return o(e[2], n, i);
            }
            Rp(Qjr, function(t) {
              var n = PN(t, Kjr), e = DN(Jjr), i = e.length - 1, x = tz.length - 1, c = Gv(i + x | 0, 0), s = i - 1 | 0, p = 0;
              if (!(s < 0)) for (var y = p; ; ) {
                var T = Fl(t, tu(e, y)[1 + y]);
                tu(c, y)[1 + y] = T;
                var E = y + 1 | 0;
                if (s !== y) {
                  var y = E;
                  continue;
                }
                break;
              }
              var d = x - 1 | 0, w = 0;
              if (!(d < 0)) for (var G = w; ; ) {
                var A = G + i | 0, S = PN(t, tu(tz, G)[1 + G]);
                tu(c, A)[1 + A] = S;
                var M = G + 1 | 0;
                if (d !== G) {
                  var G = M;
                  continue;
                }
                break;
              }
              var K = c[4], V = c[5], f0 = c[y6], m0 = c[cp], k0 = c[nd], g0 = c[gv], e0 = c[38], x0 = c[mT], l = c[Vy], c0 = LN(t, 0, 0, nz, KD, 1)[1];
              function t0(b, R0, X) {
                return o(b[1][1 + f0], b, X[2]), X;
              }
              function o0(b, R0) {
                return o(b[1][1 + m0], b, R0), R0;
              }
              function w0(b, R0) {
                var X = R0[1], s0 = b[1 + g0];
                if (s0) {
                  var hr = ps(s0[1][1][2], X[2]) < 0 ? 1 : 0, Ar = hr && (b[1 + g0] = [0, R0], 0);
                  return Ar;
                }
                var or = 0 <= ps(X[2], b[1 + n][3]) ? 1 : 0, W0 = or && (b[1 + g0] = [0, R0], 0);
                return W0;
              }
              function _0(b, R0) {
                var X = R0[1], s0 = b[1 + k0];
                if (s0) {
                  var hr = ps(X[2], s0[1][1][2]) < 0 ? 1 : 0, Ar = hr && (b[1 + k0] = [0, R0], 0);
                  return Ar;
                }
                var or = ps(X[2], b[1 + n][2]) < 0 ? 1 : 0, W0 = or && (b[1 + k0] = [0, R0], 0);
                return W0;
              }
              function E0(b, R0) {
                return R0 && o(b[1][1 + m0], b, R0[1]);
              }
              function U0(b, R0) {
                var X = R0[1];
                Du(u(b[1][1 + V], b), X);
                var s0 = R0[2];
                return Du(u(b[1][1 + K], b), s0);
              }
              return jN(t, [0, x0, function(b) {
                return [0, b[1 + k0], b[1 + g0]];
              }, m0, U0, f0, E0, V, _0, K, w0, e0, o0, l, t0]), function(b, R0, X) {
                var s0 = jp(R0, t);
                return s0[1 + n] = X, u(c0, s0), s0[1 + k0] = 0, s0[1 + g0] = 0, RN(R0, s0, t);
              };
            });
            function we0(t) {
              return t === 3 ? 2 : (4 <= t, 1);
            }
            function SL(t, n, e) {
              if (e) {
                var i = e[1], x = 0;
                if (i === 8232 || Hu === i) x = 1;
                else if (i === 10) var s = 6;
                else if (i === 13) var s = 5;
                else if (fw <= i) var s = 3;
                else if (Hh <= i) var s = 2;
                else var c = jt <= i ? 1 : 0, s = c && 1;
                if (x) var s = 7;
                var p = s;
              } else var p = 4;
              return [0, p, t];
            }
            var zee = [wt, uGr, M7(0)];
            function Ee0(t, n, e, i) {
              try {
                var x = tu(t, n)[1 + n];
                return x;
              } catch (c) {
                throw c = Et(c), c[1] === ZA ? [0, zee, e, ur(et(nGr), i, n, t.length - 1)] : c;
              }
            }
            function C9(t, n) {
              if (n[1] === 0 && n[2] === 0) return 0;
              var e = Ee0(t, n[1] - 1 | 0, n, rGr);
              return Ee0(e, n[2], n, eGr);
            }
            var Kee = Ee;
            function Wee(t, n) {
              return o(f(t), NWr, n);
            }
            u(eL([0, Kee])[33], Wee);
            function Se0(t) {
              var n = A0(t), e = 0;
              if (typeof n == "number") switch (n) {
                case 15:
                  var i = CWr;
                  break;
                case 16:
                  var i = PWr;
                  break;
                case 17:
                  var i = DWr;
                  break;
                case 18:
                  var i = LWr;
                  break;
                case 19:
                  var i = RWr;
                  break;
                case 20:
                  var i = jWr;
                  break;
                case 21:
                  var i = GWr;
                  break;
                case 22:
                  var i = MWr;
                  break;
                case 23:
                  var i = BWr;
                  break;
                case 24:
                  var i = qWr;
                  break;
                case 25:
                  var i = UWr;
                  break;
                case 26:
                  var i = HWr;
                  break;
                case 27:
                  var i = XWr;
                  break;
                case 28:
                  var i = YWr;
                  break;
                case 29:
                  var i = VWr;
                  break;
                case 30:
                  var i = zWr;
                  break;
                case 31:
                  var i = KWr;
                  break;
                case 32:
                  var i = WWr;
                  break;
                case 33:
                  var i = JWr;
                  break;
                case 34:
                  var i = $Wr;
                  break;
                case 35:
                  var i = ZWr;
                  break;
                case 36:
                  var i = QWr;
                  break;
                case 37:
                  var i = rJr;
                  break;
                case 38:
                  var i = eJr;
                  break;
                case 39:
                  var i = nJr;
                  break;
                case 40:
                  var i = tJr;
                  break;
                case 41:
                  var i = uJr;
                  break;
                case 42:
                  var i = iJr;
                  break;
                case 43:
                  var i = fJr;
                  break;
                case 44:
                  var i = xJr;
                  break;
                case 45:
                  var i = oJr;
                  break;
                case 46:
                  var i = aJr;
                  break;
                case 47:
                  var i = cJr;
                  break;
                case 48:
                  var i = sJr;
                  break;
                case 49:
                  var i = vJr;
                  break;
                case 50:
                  var i = lJr;
                  break;
                case 51:
                  var i = bJr;
                  break;
                case 52:
                  var i = pJr;
                  break;
                case 53:
                  var i = mJr;
                  break;
                case 54:
                  var i = _Jr;
                  break;
                case 55:
                  var i = yJr;
                  break;
                case 56:
                  var i = hJr;
                  break;
                case 57:
                  var i = dJr;
                  break;
                case 58:
                  var i = kJr;
                  break;
                case 59:
                  var i = wJr;
                  break;
                case 60:
                  var i = EJr;
                  break;
                case 61:
                  var i = SJr;
                  break;
                case 62:
                  var i = gJr;
                  break;
                case 63:
                  var i = FJr;
                  break;
                case 64:
                  var i = TJr;
                  break;
                case 65:
                  var i = OJr;
                  break;
                case 114:
                  var i = IJr;
                  break;
                case 115:
                  var i = AJr;
                  break;
                case 116:
                  var i = NJr;
                  break;
                case 117:
                  var i = CJr;
                  break;
                case 118:
                  var i = PJr;
                  break;
                case 119:
                  var i = DJr;
                  break;
                case 120:
                  var i = LJr;
                  break;
                case 121:
                  var i = RJr;
                  break;
                default:
                  e = 1;
              }
              else switch (n[0]) {
                case 4:
                  var i = n[2];
                  break;
                case 9:
                  var i = n[1] ? jJr : GJr;
                  break;
                default:
                  e = 1;
              }
              if (e) {
                St(MJr, t);
                var i = BJr;
              }
              return ie(t), i;
            }
            function z7(t) {
              var n = Pe(t), e = pr(t), i = Se0(t);
              return [0, n, [0, i, lr([0, e], [0, we(t)], 0)]];
            }
            function ge0(t) {
              var n = Pe(t), e = pr(t);
              Y0(t, 14);
              var i = Pe(t), x = Se0(t), c = lr([0, e], [0, we(t)], 0), s = yt(n, i), p = i[2], y = n[3], T = y[1] === p[1] ? 1 : 0, E = T && (y[2] === p[2] ? 1 : 0);
              return 1 - E && ue(t, [0, s, R7]), [0, s, [0, x, c]];
            }
            function q1(t) {
              var n = t[2], e = n[3] === 0 ? 1 : 0;
              if (e) for (var i = n[2]; ; ) {
                if (i) {
                  var x = i[1][2], c = 0, s = i[2];
                  if (x[1][2][0] === 2 && !x[2]) {
                    var p = 1;
                    c = 1;
                  }
                  if (!c) var p = 0;
                  if (p) {
                    var i = s;
                    continue;
                  }
                  return p;
                }
                return 1;
              }
              return e;
            }
            function nb(t) {
              for (var n = t; ; ) {
                var e = n[2];
                if (e[0] === 27) {
                  var i = e[1][2];
                  if (i[2][0] === 23) return 1;
                  var n = i;
                  continue;
                }
                return 0;
              }
            }
            function cr(t, n, e) {
              var i = t ? t[1] : Pe(e), x = u(n, e), c = i2(e), s = c ? yt(i, c[1]) : i;
              return [0, s, x];
            }
            function gL(t, n, e) {
              var i = cr(t, n, e), x = i[2];
              return [0, [0, i[1], x[1]], x[2]];
            }
            function Jee(t) {
              function n(B) {
                var Z = Pe(B), p0 = A0(B);
                if (typeof p0 == "number") {
                  if (s7 === p0) {
                    var b0 = pr(B);
                    return ie(B), [0, [0, Z, [0, 0, lr([0, b0], 0, 0)]]];
                  }
                  if (L7 === p0) {
                    var O0 = pr(B);
                    return ie(B), [0, [0, Z, [0, 1, lr([0, O0], 0, 0)]]];
                  }
                }
                return 0;
              }
              var e = function B(Z) {
                return B.fun(Z);
              }, i = function B(Z) {
                return B.fun(Z);
              }, x = function B(Z) {
                return B.fun(Z);
              }, c = function B(Z, p0, b0) {
                return B.fun(Z, p0, b0);
              }, s = function B(Z) {
                return B.fun(Z);
              }, p = function B(Z, p0, b0) {
                return B.fun(Z, p0, b0);
              }, y = function B(Z) {
                return B.fun(Z);
              }, T = function B(Z, p0) {
                return B.fun(Z, p0);
              }, E = function B(Z) {
                return B.fun(Z);
              }, d = function B(Z) {
                return B.fun(Z);
              }, w = function B(Z, p0, b0) {
                return B.fun(Z, p0, b0);
              }, G = function B(Z, p0, b0, O0) {
                return B.fun(Z, p0, b0, O0);
              }, A = function B(Z) {
                return B.fun(Z);
              }, S = function B(Z, p0) {
                return B.fun(Z, p0);
              }, M = function B(Z) {
                return B.fun(Z);
              }, K = function B(Z) {
                return B.fun(Z);
              }, V = function B(Z) {
                return B.fun(Z);
              }, f0 = function B(Z) {
                return B.fun(Z);
              }, m0 = function B(Z) {
                return B.fun(Z);
              }, k0 = function B(Z) {
                return B.fun(Z);
              }, g0 = function B(Z, p0) {
                return B.fun(Z, p0);
              }, e0 = function B(Z) {
                return B.fun(Z);
              }, x0 = function B(Z) {
                return B.fun(Z);
              }, l = function B(Z) {
                return B.fun(Z);
              }, c0 = function B(Z) {
                return B.fun(Z);
              }, t0 = function B(Z) {
                return B.fun(Z);
              }, o0 = function B(Z) {
                return B.fun(Z);
              }, w0 = function B(Z) {
                return B.fun(Z);
              }, _0 = function B(Z, p0, b0, O0) {
                return B.fun(Z, p0, b0, O0);
              }, E0 = function B(Z, p0, b0, O0) {
                return B.fun(Z, p0, b0, O0);
              }, U0 = function B(Z) {
                return B.fun(Z);
              }, b = function B(Z) {
                return B.fun(Z);
              }, R0 = function B(Z) {
                return B.fun(Z);
              }, X = function B(Z) {
                return B.fun(Z);
              }, s0 = function B(Z) {
                return B.fun(Z);
              }, hr = function B(Z) {
                return B.fun(Z);
              }, Ar = function B(Z, p0) {
                return B.fun(Z, p0);
              }, or = function B(Z, p0) {
                return B.fun(Z, p0);
              }, W0 = function B(Z) {
                return B.fun(Z);
              }, Lr = function B(Z, p0, b0) {
                return B.fun(Z, p0, b0);
              };
              N(e, function(B) {
                return u(x, B);
              }), N(i, function(B) {
                return 1 - fu(B) && je(B, 12), cr(0, function(Z) {
                  return Y0(Z, 86), u(e, Z);
                }, B);
              }), N(x, function(B) {
                var Z = A0(B) === 89 ? 1 : 0;
                if (Z) {
                  var p0 = pr(B);
                  ie(B);
                  var b0 = p0;
                } else var b0 = Z;
                return ur(c, B, [0, b0], u(s, B));
              }), N(c, function(B, Z, p0) {
                var b0 = Z && Z[1];
                if (A0(B) === 89) {
                  var O0 = [0, p0, 0], M0 = function(er) {
                    for (var yr = O0; ; ) {
                      var vr = A0(er);
                      if (typeof vr == "number" && vr === 89) {
                        Y0(er, 89);
                        var yr = [0, u(s, er), yr];
                        continue;
                      }
                      var $0 = ye(yr);
                      if ($0) {
                        var Er = $0[2];
                        if (Er) {
                          var Mr = lr([0, b0], 0, 0);
                          return [19, [0, [0, $0[1], Er[1], Er[2]], Mr]];
                        }
                      }
                      throw [0, Sn, y$r];
                    }
                  };
                  return cr([0, p0[1]], M0, B);
                }
                return p0;
              }), N(s, function(B) {
                var Z = A0(B) === 91 ? 1 : 0;
                if (Z) {
                  var p0 = pr(B);
                  ie(B);
                  var b0 = p0;
                } else var b0 = Z;
                return ur(p, B, [0, b0], u(y, B));
              }), N(p, function(B, Z, p0) {
                var b0 = Z && Z[1];
                if (A0(B) === 91) {
                  var O0 = [0, p0, 0], M0 = function(er) {
                    for (var yr = O0; ; ) {
                      var vr = A0(er);
                      if (typeof vr == "number" && vr === 91) {
                        Y0(er, 91);
                        var yr = [0, u(y, er), yr];
                        continue;
                      }
                      var $0 = ye(yr);
                      if ($0) {
                        var Er = $0[2];
                        if (Er) {
                          var Mr = lr([0, b0], 0, 0);
                          return [20, [0, [0, $0[1], Er[1], Er[2]], Mr]];
                        }
                      }
                      throw [0, Sn, _$r];
                    }
                  };
                  return cr([0, p0[1]], M0, B);
                }
                return p0;
              }), N(y, function(B) {
                return o(T, B, u(E, B));
              }), N(T, function(B, Z) {
                var p0 = A0(B);
                if (typeof p0 == "number" && p0 === 11 && !B[15]) {
                  var b0 = o(g0, B, Z);
                  return R(_0, B, b0[1], 0, [0, b0[1], [0, 0, [0, b0, 0], 0, 0]]);
                }
                return Z;
              }), N(E, function(B) {
                var Z = A0(B);
                return typeof Z == "number" && Z === 85 ? cr(0, function(p0) {
                  var b0 = pr(p0);
                  Y0(p0, 85);
                  var O0 = lr([0, b0], 0, 0);
                  return [11, [0, u(E, p0), O0]];
                }, B) : u(d, B);
              }), N(d, function(B) {
                return ur(w, 0, B, u(V, B));
              }), N(w, function(B, Z, p0) {
                var b0 = B && B[1];
                if (x7(Z)) return p0;
                var O0 = A0(Z);
                if (typeof O0 == "number") {
                  if (O0 === 6) return ie(Z), R(G, b0, 0, Z, p0);
                  if (O0 === 10) {
                    var M0 = Yn(1, Z);
                    return typeof M0 == "number" && M0 === 6 ? (je(Z, p$r), Y0(Z, 10), Y0(Z, 6), R(G, b0, 0, Z, p0)) : (je(Z, m$r), p0);
                  }
                  if (O0 === 83) return ie(Z), A0(Z) !== 6 && je(Z, 30), Y0(Z, 6), R(G, 1, 1, Z, p0);
                }
                return p0;
              }), N(G, function(B, Z, p0, b0) {
                function O0(M0) {
                  if (!Z && xu(M0, 7)) return [15, [0, b0, lr(0, [0, we(M0)], 0)]];
                  var er = u(e, M0);
                  Y0(M0, 7);
                  var yr = [0, b0, er, lr(0, [0, we(M0)], 0)];
                  return B ? [18, [0, yr, Z]] : [17, yr];
                }
                return ur(w, [0, B], p0, cr([0, b0[1]], O0, p0));
              }), N(A, function(B) {
                return o(S, B, o(t[13], 0, B));
              }), N(S, function(B, Z) {
                for (var p0 = [0, Z[1], [0, Z]]; ; ) {
                  var b0 = p0[2];
                  if (A0(B) === 10 && I9(1, B)) {
                    var O0 = /* @__PURE__ */ function(vr) {
                      return function($0) {
                        return Y0($0, 10), [0, vr, z7($0)];
                      };
                    }(b0), M0 = cr([0, p0[1]], O0, B), er = M0[1], p0 = [0, er, [1, [0, er, M0[2]]]];
                    continue;
                  }
                  return b0;
                }
              }), N(M, function(B) {
                var Z = A0(B);
                if (typeof Z == "number") {
                  if (Z === 4) {
                    ie(B);
                    var p0 = u(M, B);
                    return Y0(B, 5), p0;
                  }
                } else if (Z[0] === 4) return [0, u(A, B)];
                return je(B, 51), 0;
              }), N(K, function(B) {
                return cr(0, function(Z) {
                  var p0 = pr(Z);
                  Y0(Z, 46);
                  var b0 = u(M, Z);
                  if (b0) {
                    var O0 = lr([0, p0], 0, 0);
                    return [21, [0, b0[1], O0]];
                  }
                  return b$r;
                }, B);
              }), N(V, function(B) {
                var Z = Pe(B), p0 = A0(B), b0 = 0;
                if (typeof p0 == "number") switch (p0) {
                  case 4:
                    return u(o0, B);
                  case 6:
                    return u(k0, B);
                  case 46:
                    return u(K, B);
                  case 53:
                    return cr(0, function(ge) {
                      var q0 = pr(ge);
                      Y0(ge, 53);
                      var Fr = u(U0, ge), _ = lr([0, q0], 0, 0);
                      return [14, [0, Fr[2], Fr[1], _]];
                    }, B);
                  case 98:
                    return u(w0, B);
                  case 106:
                    var O0 = pr(B);
                    return Y0(B, Yt), [0, Z, [10, lr([0, O0], [0, we(B)], 0)]];
                  case 42:
                    b0 = 1;
                    break;
                  case 0:
                  case 2:
                    var M0 = R(E0, 0, 1, 1, B);
                    return [0, M0[1], [13, M0[2]]];
                  case 30:
                  case 31:
                    var er = pr(B);
                    return Y0(B, p0), [0, Z, [26, [0, p0 === 31 ? 1 : 0, lr([0, er], [0, we(B)], 0)]]];
                }
                else switch (p0[0]) {
                  case 2:
                    var yr = p0[1], vr = yr[4], $0 = yr[3], Er = yr[2], Mr = yr[1];
                    vr && gi(B, 45);
                    var Br = pr(B);
                    return Y0(B, [2, [0, Mr, Er, $0, vr]]), [0, Mr, [23, [0, Er, $0, lr([0, Br], [0, we(B)], 0)]]];
                  case 10:
                    var qr = p0[3], jr = p0[2], $r = p0[1], ne = pr(B);
                    Y0(B, [10, $r, jr, qr]);
                    var Qr = we(B);
                    return $r === 1 && gi(B, 45), [0, Z, [24, [0, jr, qr, lr([0, ne], [0, Qr], 0)]]];
                  case 11:
                    var be = p0[3], ae = p0[2], pe = pr(B);
                    return Y0(B, [11, p0[1], ae, be]), [0, Z, [25, [0, ae, be, lr([0, pe], [0, we(B)], 0)]]];
                  case 4:
                    b0 = 1;
                    break;
                }
                if (b0) {
                  var oe = u(hr, B);
                  return [0, oe[1], [16, oe[2]]];
                }
                var ce = u(m0, B);
                return ce ? [0, Z, ce[1]] : (St(v$r, B), [0, Z, l$r]);
              }), N(f0, function(B) {
                var Z = 0;
                if (typeof B == "number") switch (B) {
                  case 29:
                  case 114:
                  case 115:
                  case 116:
                  case 117:
                  case 118:
                  case 119:
                  case 120:
                  case 121:
                    Z = 1;
                    break;
                }
                else B[0] === 9 && (Z = 1);
                return Z ? 1 : 0;
              }), N(m0, function(B) {
                var Z = pr(B), p0 = A0(B);
                if (typeof p0 == "number") switch (p0) {
                  case 29:
                    return ie(B), [0, [4, lr([0, Z], [0, we(B)], 0)]];
                  case 114:
                    return ie(B), [0, [0, lr([0, Z], [0, we(B)], 0)]];
                  case 115:
                    return ie(B), [0, [1, lr([0, Z], [0, we(B)], 0)]];
                  case 116:
                    return ie(B), [0, [2, lr([0, Z], [0, we(B)], 0)]];
                  case 117:
                    return ie(B), [0, [5, lr([0, Z], [0, we(B)], 0)]];
                  case 118:
                    return ie(B), [0, [6, lr([0, Z], [0, we(B)], 0)]];
                  case 119:
                    return ie(B), [0, [7, lr([0, Z], [0, we(B)], 0)]];
                  case 120:
                    return ie(B), [0, [3, lr([0, Z], [0, we(B)], 0)]];
                  case 121:
                    return ie(B), [0, [9, lr([0, Z], [0, we(B)], 0)]];
                }
                else if (p0[0] === 9) return ie(B), [0, [8, lr([0, Z], [0, we(B)], 0)]];
                return 0;
              }), N(k0, function(B) {
                return cr(0, function(Z) {
                  var p0 = pr(Z);
                  Y0(Z, 6);
                  for (var b0 = u2(0, Z), O0 = 0; ; ) {
                    var M0 = A0(b0);
                    if (typeof M0 == "number") {
                      var er = 0;
                      if ((M0 === 7 || Pn === M0) && (er = 1), er) {
                        var yr = ye(O0);
                        return Y0(Z, 7), [22, [0, yr, lr([0, p0], [0, we(Z)], 0)]];
                      }
                    }
                    var vr = [0, u(e, b0), O0];
                    A0(b0) !== 7 && Y0(b0, 9);
                    var O0 = vr;
                  }
                }, B);
              }), N(g0, function(B, Z) {
                return [0, Z[1], [0, 0, Z, 0]];
              }), N(e0, function(B) {
                return cr(0, function(Z) {
                  Ku(Z, 0);
                  var p0 = o(t[13], 0, Z);
                  k7(Z), 1 - fu(Z) && je(Z, 12);
                  var b0 = xu(Z, 85);
                  return Y0(Z, 86), [0, [0, p0], u(e, Z), b0];
                }, B);
              });
              function Tr(B) {
                var Z = Yn(1, B);
                return typeof Z == "number" && !(1 < (Z + W2 | 0) >>> 0) ? u(e0, B) : o(g0, B, u(e, B));
              }
              N(x0, function(B) {
                var Z = 0;
                return function(p0) {
                  for (var b0 = Z, O0 = p0; ; ) {
                    var M0 = A0(B);
                    if (typeof M0 == "number") switch (M0) {
                      case 5:
                      case 12:
                      case 113:
                        var er = M0 === 12 ? 1 : 0, yr = er && [0, cr(0, function(jr) {
                          var $r = pr(jr);
                          Y0(jr, 12);
                          var ne = lr([0, $r], 0, 0);
                          return [0, Tr(jr), ne];
                        }, B)];
                        return [0, b0, ye(O0), yr, 0];
                    }
                    else if (M0[0] === 4 && !n0(M0[3], s$r)) {
                      var vr = 0;
                      if ((Yn(1, B) === 86 || Yn(1, B) === 85) && (vr = 1), vr) {
                        var $0 = b0 !== 0 ? 1 : 0, Er = $0 || (O0 !== 0 ? 1 : 0);
                        Er && je(B, s7);
                        var Mr = cr(0, function($r) {
                          var ne = pr($r);
                          ie($r), A0($r) === 85 && je($r, L7);
                          var Qr = lr([0, ne], 0, 0);
                          return [0, u(i, $r), Qr];
                        }, B);
                        A0(B) !== 5 && Y0(B, 9);
                        var b0 = [0, Mr];
                        continue;
                      }
                    }
                    var Br = [0, Tr(B), O0];
                    A0(B) !== 5 && Y0(B, 9);
                    var O0 = Br;
                  }
                };
              }), N(l, function(B) {
                return cr(0, function(Z) {
                  var p0 = pr(Z);
                  Y0(Z, 4);
                  var b0 = o(x0, Z, 0), O0 = pr(Z);
                  Y0(Z, 5);
                  var M0 = yu([0, p0], [0, we(Z)], O0, 0);
                  return [0, b0[1], b0[2], b0[3], M0];
                }, B);
              }), N(c0, function(B) {
                var Z = pr(B);
                Y0(B, 4);
                var p0 = u2(0, B), b0 = A0(p0), O0 = 0;
                if (typeof b0 == "number") switch (b0) {
                  case 5:
                    var M0 = c$r;
                    break;
                  case 42:
                    O0 = 2;
                    break;
                  case 12:
                  case 113:
                    var M0 = [0, o(x0, p0, 0)];
                    break;
                  default:
                    O0 = 1;
                }
                else b0[0] === 4 ? O0 = 2 : O0 = 1;
                switch (O0) {
                  case 1:
                    if (u(f0, b0)) {
                      var er = Yn(1, p0), yr = 0;
                      if (typeof er == "number" && !(1 < (er + W2 | 0) >>> 0)) {
                        var vr = [0, o(x0, p0, 0)];
                        yr = 1;
                      }
                      if (!yr) var vr = [1, u(e, p0)];
                      var M0 = vr;
                    } else var M0 = [1, u(e, p0)];
                    break;
                  case 2:
                    var M0 = u(t0, p0);
                    break;
                }
                if (M0[0] === 0) var $0 = M0;
                else {
                  var Er = M0[1];
                  if (B[15]) var Mr = M0;
                  else {
                    var Br = A0(B), qr = 0;
                    if (typeof Br == "number") if (Br === 5) var jr = Yn(1, B) === 11 ? [0, o(x0, B, [0, o(g0, B, Er), 0])] : [1, Er];
                    else if (Br === 9) {
                      Y0(B, 9);
                      var jr = [0, o(x0, B, [0, o(g0, B, Er), 0])];
                    } else qr = 1;
                    else qr = 1;
                    if (qr) var jr = M0;
                    var Mr = jr;
                  }
                  var $0 = Mr;
                }
                var $r = pr(B);
                Y0(B, 5);
                var ne = we(B);
                if ($0[0] === 0) {
                  var Qr = $0[1], be = yu([0, Z], [0, ne], $r, 0);
                  return [0, [0, Qr[1], Qr[2], Qr[3], be]];
                }
                return [1, ur(Lr, $0[1], Z, ne)];
              }), N(t0, function(B) {
                var Z = Yn(1, B);
                return typeof Z == "number" && !(1 < (Z + W2 | 0) >>> 0) ? [0, o(x0, B, 0)] : [1, ur(c, B, 0, ur(p, B, 0, o(T, B, ur(w, 0, B, o(or, B, u(b, B))))))];
              }), N(o0, function(B) {
                var Z = Pe(B), p0 = cr(0, c0, B), b0 = p0[2];
                return b0[0] === 0 ? R(_0, B, Z, 0, [0, p0[1], b0[1]]) : b0[1];
              }), N(w0, function(B) {
                var Z = Pe(B), p0 = oi(B, u(X, B));
                return R(_0, B, Z, p0, u(l, B));
              }), N(_0, function(B, Z, p0, b0) {
                return cr([0, Z], function(O0) {
                  return Y0(O0, 11), [12, [0, p0, b0, u(e, O0), 0]];
                }, B);
              });
              function Hr(B, Z, p0) {
                return cr([0, Z], function(b0) {
                  var O0 = u(l, b0);
                  return Y0(b0, 86), [0, p0, O0, u(e, b0), 0];
                }, B);
              }
              function Or(B, Z) {
                var p0 = A0(Z);
                if (typeof p0 == "number" && !(10 <= p0)) switch (p0) {
                  case 1:
                    if (!B) return 0;
                    break;
                  case 3:
                    if (B) return 0;
                    break;
                  case 8:
                  case 9:
                    return ie(Z);
                }
                return B1(Z, 9);
              }
              function fr(B, Z) {
                return Z && ue(B, [0, Z[1][1], 7]);
              }
              function Rr(B, Z) {
                return Z && ue(B, [0, Z[1], 9]);
              }
              N(E0, function(B, Z, p0, b0) {
                var O0 = Z && (A0(b0) === 2 ? 1 : 0), M0 = Z && 1 - O0;
                return cr(0, function(er) {
                  var yr = pr(er), vr = O0 && 2;
                  Y0(er, vr);
                  var $0 = u2(0, er), Er = a$r;
                  r: for (; ; ) {
                    var Mr = Er[3], Br = Er[2], qr = Er[1];
                    if (B && p0) throw [0, Sn, WJr];
                    if (M0 && !p0) throw [0, Sn, JJr];
                    var jr = Pe($0), $r = A0($0);
                    if (typeof $r == "number") {
                      var ne = 0;
                      if (13 <= $r) {
                        if (Pn === $r) {
                          var Qr = [0, ye(qr), Br, Mr];
                          ne = 1;
                        }
                      } else if ($r) switch ($r - 1 | 0) {
                        case 0:
                          if (!O0) {
                            var Qr = [0, ye(qr), Br, Mr];
                            ne = 1;
                          }
                          break;
                        case 2:
                          if (O0) {
                            var Qr = [0, ye(qr), Br, Mr];
                            ne = 1;
                          }
                          break;
                        case 11:
                          if (!p0) {
                            ie($0);
                            var be = A0($0);
                            if (typeof be == "number" && !(10 <= be)) switch (be) {
                              case 1:
                              case 3:
                              case 8:
                              case 9:
                                ue($0, [0, jr, 20]), Or(O0, $0);
                                continue;
                            }
                            var ae = wL($0);
                            u(yL($0), ae), ue($0, [0, jr, 17]), ie($0), Or(O0, $0);
                            continue;
                          }
                          var pe = pr($0);
                          ie($0);
                          var oe = A0($0), ce = 0;
                          if (typeof oe == "number" && !(10 <= oe)) switch (oe) {
                            case 1:
                            case 3:
                            case 8:
                            case 9:
                              Or(O0, $0);
                              var ge = A0($0), q0 = 0;
                              if (typeof ge == "number") {
                                var Fr = ge - 1 | 0;
                                if (!(2 < Fr >>> 0)) switch (Fr) {
                                  case 0:
                                    if (M0) {
                                      var Qr = [0, ye(qr), 1, pe];
                                      ne = 1, ce = 1, q0 = 1;
                                    }
                                    break;
                                  case 1:
                                    break;
                                  default:
                                    ue($0, [0, jr, 19]);
                                    var Qr = [0, ye(qr), Br, Mr];
                                    ne = 1, ce = 1, q0 = 1;
                                }
                              }
                              if (!q0) {
                                ue($0, [0, jr, 18]);
                                continue;
                              }
                              break;
                          }
                          if (!ce) {
                            var _ = [1, cr([0, jr], /* @__PURE__ */ function(W7) {
                              return function(Ut) {
                                var bt = lr([0, W7], 0, 0);
                                return [0, u(e, Ut), bt];
                              };
                            }(pe), $0)];
                            Or(O0, $0);
                            var Er = [0, [0, _, qr], Br, Mr];
                            continue;
                          }
                          break;
                      }
                      if (ne) {
                        var k = pr(er), I = on(Qr[3], k), U = O0 ? 3 : 1;
                        Y0(er, U);
                        var Y = yu([0, yr], [0, we(er)], I, 0);
                        return [0, O0, Qr[2], Qr[1], Y];
                      }
                    }
                    for (var y0 = B, P0 = B, I0 = 0, D = 0, u0 = 0, X0 = 0; ; ) {
                      var J0 = A0($0), ir = 0;
                      if (typeof J0 == "number") switch (J0) {
                        case 6:
                          Rr($0, u0);
                          var Q0 = Yn(1, $0), F0 = 0;
                          if (typeof Q0 == "number" && Q0 === 6) {
                            fr($0, I0);
                            var Cr = [4, cr([0, jr], /* @__PURE__ */ function(Ut, bt, B0) {
                              return function(D0) {
                                var Le = on(bt, pr(D0));
                                Y0(D0, 6), Y0(D0, 6);
                                var He = z7(D0);
                                Y0(D0, 7), Y0(D0, 7);
                                var he = A0(D0), me = 0;
                                if (typeof he == "number") {
                                  var Zn = 0;
                                  if (he !== 4 && he !== 98 && (Zn = 1), !Zn) {
                                    var wn = Hr(D0, Ut, oi(D0, u(X, D0))), ft = 0, xt = [0, wn[1], [12, wn[2]]], jn = 1, ut = 0;
                                    me = 1;
                                  }
                                }
                                if (!me) {
                                  var dt = xu(D0, 85), xn = we(D0);
                                  Y0(D0, 86);
                                  var ft = xn, xt = u(e, D0), jn = 0, ut = dt;
                                }
                                return [0, He, xt, ut, B0 !== 0 ? 1 : 0, jn, lr([0, Le], [0, ft], 0)];
                              };
                            }(jr, X0, D), $0)];
                            F0 = 1;
                          }
                          if (!F0) var Cr = [2, cr([0, jr], /* @__PURE__ */ function(W7, Ut, bt) {
                            return function(B0) {
                              var D0 = on(W7, pr(B0));
                              Y0(B0, 6);
                              var Le = Yn(1, B0) === 86 ? 1 : 0;
                              if (Le) {
                                var He = z7(B0);
                                Y0(B0, 86);
                                var he = [0, He];
                              } else var he = Le;
                              var me = u(e, B0);
                              Y0(B0, 7);
                              var Zn = we(B0);
                              Y0(B0, 86);
                              var wn = u(e, B0);
                              return [0, he, me, wn, Ut !== 0 ? 1 : 0, bt, lr([0, D0], [0, Zn], 0)];
                            };
                          }(X0, D, I0), $0)];
                          break;
                        case 42:
                          if (y0) {
                            if (I0 === 0) {
                              var Sr = [0, Pe($0)], mr = on(X0, pr($0));
                              ie($0);
                              var y0 = 0, P0 = 0, D = Sr, X0 = mr;
                              continue;
                            }
                            throw [0, Sn, ZJr];
                          }
                          ir = 1;
                          break;
                        case 103:
                        case 104:
                          if (I0 === 0) {
                            var y0 = 0, P0 = 0, I0 = n($0);
                            continue;
                          }
                          ir = 1;
                          break;
                        case 4:
                        case 98:
                          Rr($0, u0), fr($0, I0);
                          var Cr = [3, cr([0, jr], /* @__PURE__ */ function(W7, Ut) {
                            return function(bt) {
                              var B0 = Pe(bt), D0 = Hr(bt, B0, oi(bt, u(X, bt)));
                              return [0, D0, Ut !== 0 ? 1 : 0, lr([0, W7], 0, 0)];
                            };
                          }(X0, D), $0)];
                          break;
                        default:
                          ir = 1;
                      }
                      else if (J0[0] === 4 && !n0(J0[3], QJr)) {
                        if (P0) {
                          if (I0 === 0) {
                            var sr = [0, Pe($0)], Pr = on(X0, pr($0));
                            ie($0);
                            var y0 = 0, P0 = 0, u0 = sr, X0 = Pr;
                            continue;
                          }
                          throw [0, Sn, r$r];
                        }
                        ir = 1;
                      } else ir = 1;
                      if (ir) {
                        var K0 = 0;
                        if (D) {
                          var Ur = D[1];
                          if (u0) {
                            var Cr = ke(e$r);
                            K0 = 1;
                          } else if (typeof J0 == "number" && !(1 < (J0 + W2 | 0) >>> 0)) {
                            var h0 = [0, Ur, [1, Rc(lr([0, X0], 0, 0), [0, Ur, n$r])]], Kr = 0, re = u0, xe = 0;
                            K0 = 2;
                          }
                        } else if (u0) {
                          var Re = u0[1];
                          if (typeof J0 == "number" && !(1 < (J0 + W2 | 0) >>> 0)) {
                            var h0 = [0, Re, [1, Rc(lr([0, X0], 0, 0), [0, Re, t$r])]], Kr = 0, re = 0, xe = D;
                            K0 = 2;
                          }
                        }
                        var ve = 0;
                        switch (K0) {
                          case 0:
                            var Ie = function(Ut) {
                              Ku(Ut, 0);
                              var bt = o(t[20], 0, Ut);
                              return k7(Ut), bt;
                            }, Ge = pr($0), Me = Ie($0), an = Me[1], We = Me[2], Ae = 0;
                            if (We[0] === 1) {
                              var cn = We[1][2][1], rn = 0;
                              if (n0(cn, u$r) && n0(cn, i$r) && (rn = 1), !rn) {
                                var kn = A0($0), vn = 0;
                                if (typeof kn == "number") {
                                  var Ne = kn - 5 | 0;
                                  if (92 < Ne >>> 0) {
                                    if (!(94 < (Ne + 1 | 0) >>> 0)) {
                                      Rr($0, u0), fr($0, I0);
                                      var Je = We;
                                      Ae = 1, vn = 1;
                                    }
                                  } else if (!(1 < (Ne + eX | 0) >>> 0)) {
                                    var h0 = [0, an, We], Kr = X0, re = u0, xe = D;
                                    ve = 1, Ae = 2, vn = 1;
                                  }
                                }
                                if (!vn) {
                                  Xi($0, We);
                                  var en = Ie($0), _n = qn(cn, f$r), Cn = on(X0, Ge);
                                  Rr($0, u0), fr($0, I0);
                                  var Cr = [0, cr([0, jr], /* @__PURE__ */ function(bt, B0, D0, Le, He) {
                                    return function(he) {
                                      var me = D0[1], Zn = Xi(he, D0[2]), wn = Hr(he, bt, 0), ft = wn[2][2];
                                      if (Le) {
                                        var xt = ft[2], jn = 0;
                                        if (xt[1]) ue(he, [0, me, j7]), jn = 1;
                                        else {
                                          var ut = 0;
                                          !xt[2] && !xt[3] && (jn = 1, ut = 1), ut || ue(he, [0, me, 80]);
                                        }
                                      } else {
                                        var dt = ft[2], xn = 0;
                                        if (dt[1]) ue(he, [0, me, Yt]), xn = 1;
                                        else {
                                          var ln = dt[2], it = 0;
                                          if (dt[3]) ue(he, [0, me, 81]);
                                          else {
                                            var Tt = 0;
                                            ln && !ln[2] && (Tt = 1), Tt || (ue(he, [0, me, 81]), it = 1);
                                          }
                                          it || (xn = 1);
                                        }
                                      }
                                      var Ti = lr([0, He], 0, 0), hs = 0, Au = 0, Hs = 0, Vi = B0 !== 0 ? 1 : 0, Xs = 0, Ys = Le ? [1, wn] : [2, wn];
                                      return [0, Zn, Ys, Xs, Vi, Hs, Au, hs, Ti];
                                    };
                                  }(jr, D, en, _n, Cn), $0)];
                                  Ae = 2;
                                }
                              }
                            }
                            var Hn = 0;
                            switch (Ae) {
                              case 2:
                                Hn = 1;
                                break;
                              case 0:
                                var Fn = Me[2], vt = A0($0), Nt = 0;
                                if (typeof vt == "number") {
                                  var gt = 0;
                                  if (vt !== 4 && vt !== 98 && (gt = 1), !gt) {
                                    Rr($0, u0), fr($0, I0);
                                    var Je = Fn;
                                    Nt = 1;
                                  }
                                }
                                if (!Nt) {
                                  var Zt = D !== 0 ? 1 : 0, qt = 0;
                                  if (Fn[0] === 1) {
                                    var Ft = Fn[1], Ct = Ft[2][1], du = 0;
                                    if (B) {
                                      var Wu = 0;
                                      !qn(x$r, Ct) && (!Zt || !qn(o$r, Ct)) && (Wu = 1), Wu || (ue($0, [0, Ft[1], [21, Ct, Zt, 0, 0]]), qt = 1, du = 1);
                                    }
                                  }
                                  var h0 = [0, an, Fn], Kr = X0, re = u0, xe = D;
                                  ve = 1, Hn = 1;
                                }
                                break;
                            }
                            if (!Hn) var lt = Xi($0, Je), ou = Hr($0, jr, oi($0, u(X, $0))), Bu = [0, ou[1], [12, ou[2]]], K7 = [0, lt, [0, Bu], 0, D !== 0 ? 1 : 0, 0, 1, 0, lr([0, X0], 0, 0)], Cr = [0, [0, Bu[1], K7]];
                            break;
                          case 2:
                            ve = 1;
                            break;
                        }
                        if (ve) {
                          var Yi = h0[2], a7 = h0[1];
                          1 - fu($0) && je($0, 12);
                          var Cr = [0, cr([0, jr], /* @__PURE__ */ function(Ut, bt, B0, D0, Le, He) {
                            return function(he) {
                              var me = xu(he, 85), Zn = pe0(he, 86) ? u(e, he) : [0, He, $Jr];
                              return [0, Le, [0, Zn], me, bt !== 0 ? 1 : 0, B0 !== 0 ? 1 : 0, 0, Ut, lr([0, D0], 0, 0)];
                            };
                          }(I0, xe, re, Kr, Yi, a7), $0)];
                        }
                      }
                      Or(O0, $0);
                      var Er = [0, [0, Cr, qr], Br, Mr];
                      continue r;
                    }
                  }
                }, b0);
              }), N(U0, function(B) {
                var Z = A0(B) === 41 ? 1 : 0;
                if (Z) {
                  Y0(B, 41);
                  for (var p0 = 0; ; ) {
                    var b0 = [0, u(hr, B), p0], O0 = A0(B);
                    if (typeof O0 == "number" && O0 === 9) {
                      Y0(B, 9);
                      var p0 = b0;
                      continue;
                    }
                    var M0 = de0(B, ye(b0));
                    break;
                  }
                } else var M0 = Z;
                return [0, M0, R(E0, 0, 0, 0, B)];
              }), N(b, function(B) {
                var Z = z7(B), p0 = Z[2], b0 = p0[1], O0 = Z[1];
                return ae0(b0) && ue(B, [0, O0, 3]), [0, O0, [0, b0, p0[2]]];
              }), N(R0, function(B) {
                return cr(0, function(Z) {
                  var p0 = u(b, Z), b0 = A0(Z) === 86 ? [1, u(i, Z)] : [0, j1(Z)];
                  return [0, p0, b0];
                }, B);
              }), N(X, function(B) {
                var Z = A0(B) === 98 ? 1 : 0;
                if (Z) {
                  1 - fu(B) && je(B, 12);
                  var p0 = [0, cr(0, function(O0) {
                    var M0 = pr(O0);
                    Y0(O0, 98);
                    for (var er = 0, yr = 0; ; ) {
                      var vr = cr(0, /* @__PURE__ */ function(ne) {
                        return function(Qr) {
                          var be = n(Qr), ae = u(R0, Qr), pe = ae[2], oe = A0(Qr), ce = 0;
                          if (typeof oe == "number" && oe === 82) {
                            ie(Qr);
                            var ge = 1, q0 = [0, u(e, Qr)];
                            ce = 1;
                          }
                          if (!ce) {
                            ne && ue(Qr, [0, ae[1], 77]);
                            var ge = ne, q0 = 0;
                          }
                          return [0, be, pe[1], pe[2], q0, ge];
                        };
                      }(er), O0), $0 = vr[2], Er = [0, [0, vr[1], [0, $0[2], $0[3], $0[1], $0[4]]], yr], Mr = A0(O0), Br = 0;
                      if (typeof Mr == "number") {
                        var qr = 0;
                        if (Mr !== 99 && Pn !== Mr && (qr = 1), !qr) {
                          var jr = ye(Er);
                          Br = 1;
                        }
                      }
                      if (!Br) {
                        if (Y0(O0, 9), A0(O0) !== 99) {
                          var er = $0[5], yr = Er;
                          continue;
                        }
                        var jr = ye(Er);
                      }
                      var $r = pr(O0);
                      return Y0(O0, 99), [0, jr, yu([0, M0], [0, we(O0)], $r, 0)];
                    }
                  }, B)];
                } else var p0 = Z;
                return p0;
              }), N(s0, function(B) {
                var Z = A0(B) === 98 ? 1 : 0, p0 = Z && [0, cr(0, function(b0) {
                  var O0 = pr(b0);
                  Y0(b0, 98);
                  for (var M0 = u2(0, b0), er = 0; ; ) {
                    var yr = A0(M0);
                    if (typeof yr == "number") {
                      var vr = 0;
                      if ((yr === 99 || Pn === yr) && (vr = 1), vr) {
                        var $0 = ye(er), Er = pr(M0);
                        return Y0(M0, 99), [0, $0, yu([0, O0], [0, we(M0)], Er, 0)];
                      }
                    }
                    var Mr = [0, u(e, M0), er];
                    A0(M0) !== 99 && Y0(M0, 9);
                    var er = Mr;
                  }
                }, B)];
                return p0;
              }), N(hr, function(B) {
                return o(Ar, B, u(b, B));
              }), N(Ar, function(B, Z) {
                function p0(b0) {
                  for (var O0 = [0, Z[1], [0, Z]]; ; ) {
                    var M0 = O0[2], er = O0[1];
                    if (A0(b0) === 10 && ve0(1, b0)) {
                      var yr = cr([0, er], /* @__PURE__ */ function(qr) {
                        return function(jr) {
                          return Y0(jr, 10), [0, qr, u(b, jr)];
                        };
                      }(M0), b0), vr = yr[1], O0 = [0, vr, [1, [0, vr, yr[2]]]];
                      continue;
                    }
                    if (A0(b0) === 98) var $0 = $t(b0), Er = function(Br, qr) {
                      return o(Qe(Br, -860373976, 77), Br, qr);
                    }, Mr = o($0[2], M0, Er);
                    else var Mr = M0;
                    return [0, Mr, u(s0, b0), 0];
                  }
                }
                return cr([0, Z[1]], p0, B);
              }), N(or, function(B, Z) {
                var p0 = o(Ar, B, Z);
                return [0, p0[1], [16, p0[2]]];
              }), N(W0, function(B) {
                var Z = A0(B);
                return typeof Z == "number" && Z === 86 ? [1, u(i, B)] : [0, j1(B)];
              }), N(Lr, function(B, Z, p0) {
                var b0 = B[2];
                function O0(Sr) {
                  return y7(Sr, lr([0, Z], [0, p0], 0));
                }
                switch (b0[0]) {
                  case 0:
                    var F0 = [0, O0(b0[1])];
                    break;
                  case 1:
                    var F0 = [1, O0(b0[1])];
                    break;
                  case 2:
                    var F0 = [2, O0(b0[1])];
                    break;
                  case 3:
                    var F0 = [3, O0(b0[1])];
                    break;
                  case 4:
                    var F0 = [4, O0(b0[1])];
                    break;
                  case 5:
                    var F0 = [5, O0(b0[1])];
                    break;
                  case 6:
                    var F0 = [6, O0(b0[1])];
                    break;
                  case 7:
                    var F0 = [7, O0(b0[1])];
                    break;
                  case 8:
                    var F0 = [8, O0(b0[1])];
                    break;
                  case 9:
                    var F0 = [9, O0(b0[1])];
                    break;
                  case 10:
                    var F0 = [10, O0(b0[1])];
                    break;
                  case 11:
                    var M0 = b0[1], er = O0(M0[2]), F0 = [11, [0, M0[1], er]];
                    break;
                  case 12:
                    var yr = b0[1], vr = O0(yr[4]), F0 = [12, [0, yr[1], yr[2], yr[3], vr]];
                    break;
                  case 13:
                    var $0 = b0[1], Er = lr([0, Z], [0, p0], 0), Mr = JD($0[4], Er), F0 = [13, [0, $0[1], $0[2], $0[3], Mr]];
                    break;
                  case 14:
                    var Br = b0[1], qr = O0(Br[3]), F0 = [14, [0, Br[1], Br[2], qr]];
                    break;
                  case 15:
                    var jr = b0[1], $r = O0(jr[2]), F0 = [15, [0, jr[1], $r]];
                    break;
                  case 16:
                    var ne = b0[1], Qr = O0(ne[3]), F0 = [16, [0, ne[1], ne[2], Qr]];
                    break;
                  case 17:
                    var be = b0[1], ae = O0(be[3]), F0 = [17, [0, be[1], be[2], ae]];
                    break;
                  case 18:
                    var pe = b0[1], oe = pe[1], ce = pe[2], ge = O0(oe[3]), F0 = [18, [0, [0, oe[1], oe[2], ge], ce]];
                    break;
                  case 19:
                    var q0 = b0[1], Fr = O0(q0[2]), F0 = [19, [0, q0[1], Fr]];
                    break;
                  case 20:
                    var _ = b0[1], k = O0(_[2]), F0 = [20, [0, _[1], k]];
                    break;
                  case 21:
                    var I = b0[1], U = O0(I[2]), F0 = [21, [0, I[1], U]];
                    break;
                  case 22:
                    var Y = b0[1], y0 = O0(Y[2]), F0 = [22, [0, Y[1], y0]];
                    break;
                  case 23:
                    var P0 = b0[1], I0 = O0(P0[3]), F0 = [23, [0, P0[1], P0[2], I0]];
                    break;
                  case 24:
                    var D = b0[1], u0 = O0(D[3]), F0 = [24, [0, D[1], D[2], u0]];
                    break;
                  case 25:
                    var X0 = b0[1], J0 = O0(X0[3]), F0 = [25, [0, X0[1], X0[2], J0]];
                    break;
                  default:
                    var ir = b0[1], Q0 = O0(ir[2]), F0 = [26, [0, ir[1], Q0]];
                }
                return [0, B[1], F0];
              });
              function Wr(B) {
                var Z = pr(B);
                if (Y0(B, 66), A0(B) === 4) {
                  var p0 = on(Z, pr(B));
                  Y0(B, 4), Ku(B, 0);
                  var b0 = u(t[9], B);
                  return k7(B), Y0(B, 5), [0, [0, b0], lr([0, p0], [0, we(B)], 0)];
                }
                return [0, 0, lr([0, Z], [0, we(B)], 0)];
              }
              var Jr = 0;
              function ar(B) {
                var Z = u2(0, B), p0 = A0(Z);
                return typeof p0 == "number" && p0 === 66 ? [0, cr(Jr, Wr, Z)] : 0;
              }
              function _r(B) {
                var Z = A0(B), p0 = Yn(1, B);
                if (typeof Z == "number" && Z === 86) {
                  if (typeof p0 == "number" && p0 === 66) {
                    Y0(B, 86);
                    var b0 = ar(B);
                    return [0, [0, j1(B)], b0];
                  }
                  var O0 = u(W0, B), M0 = A0(B) === 66 ? o2(B, O0) : O0;
                  return [0, M0, ar(B)];
                }
                return [0, [0, j1(B)], 0];
              }
              function Ir(B, Z) {
                var p0 = _s(1, Z);
                Ku(p0, 1);
                var b0 = u(B, p0);
                return k7(p0), b0;
              }
              function fe(B) {
                return Ir(e, B);
              }
              function v0(B) {
                return Ir(b, B);
              }
              function P(B) {
                return Ir(X, B);
              }
              function L(B) {
                return Ir(s0, B);
              }
              function Q(B, Z) {
                return Ir(ur(E0, B, 0, 0), Z);
              }
              function i0(B) {
                return Ir(U0, B);
              }
              function l0(B) {
                return Ir(l, B);
              }
              function S0(B) {
                return Ir(i, B);
              }
              function T0(B) {
                return Ir(W0, B);
              }
              function rr(B) {
                return Ir(ar, B);
              }
              function L0(B) {
                return Ir(_r, B);
              }
              return [0, fe, v0, P, L, function(B) {
                return Ir(hr, B);
              }, Q, i0, l0, S0, T0, rr, L0];
            }
            function $ee(t) {
              function n(c, s) {
                if (s[0] === 0) return s[1];
                var p = s[2][1];
                return Du(function(y) {
                  return ue(c, y);
                }, p), s[1];
              }
              function e(c, s, p) {
                var y = c ? c[1] : 26;
                if (p[0] === 0) var T = p[1];
                else {
                  var E = p[2][2];
                  Du(function(A) {
                    return ue(s, A);
                  }, E);
                  var T = p[1];
                }
                1 - u(t[23], T) && ue(s, [0, T[1], y]);
                var d = T[2], w = 0;
                return d[0] === 10 && js(d[1][2][1]) && (V7(s, [0, T[1], 52]), w = 1), o(t[19], s, T);
              }
              function i(c, s) {
                return [0, [0, c, s[1]], [0, c, s[2]]];
              }
              function x(c, s) {
                var p = Lc(c[2], s[2]);
                return [0, Lc(c[1], s[1]), p];
              }
              return [0, n, e, g$r, i, x, function(c) {
                var s = ye(c[2]);
                return [0, ye(c[1]), s];
              }];
            }
            function Zee(t) {
              function n(S) {
                var M = A0(S);
                if (typeof M == "number") {
                  var K = M - 99 | 0, V = 0;
                  if (6 < K >>> 0 ? K === 14 && (V = 1) : 4 < (K - 1 | 0) >>> 0 && (V = 1), V) return we(S);
                }
                var f0 = x7(S);
                return f0 && Ms(S);
              }
              function e(S) {
                var M = pr(S);
                Ku(S, 0);
                var K = cr(0, function(f0) {
                  Y0(f0, 0), Y0(f0, 12);
                  var m0 = u(t[10], f0);
                  return Y0(f0, 1), m0;
                }, S);
                k7(S);
                var V = lr([0, M], [0, n(S)], 0);
                return [0, K[1], [0, K[2], V]];
              }
              function i(S) {
                return A0(S) === 1 ? 0 : [0, u(t[7], S)];
              }
              function x(S) {
                var M = pr(S);
                Ku(S, 0);
                var K = cr(0, function(f0) {
                  Y0(f0, 0);
                  var m0 = i(f0);
                  return Y0(f0, 1), m0;
                }, S);
                k7(S);
                var V = yu([0, M], [0, n(S)], 0, 0);
                return [0, K[1], [0, K[2], V]];
              }
              function c(S) {
                Ku(S, 0);
                var M = cr(0, function(K) {
                  Y0(K, 0);
                  var V = A0(K), f0 = 0;
                  if (typeof V == "number" && V === 12) {
                    var m0 = pr(K);
                    Y0(K, 12);
                    var k0 = u(t[10], K), x0 = [3, [0, k0, lr([0, m0], 0, 0)]];
                    f0 = 1;
                  }
                  if (!f0) var g0 = i(K), e0 = g0 ? 0 : pr(K), x0 = [2, [0, g0, yu(0, 0, e0, 0)]];
                  return Y0(K, 1), x0;
                }, S);
                return k7(S), [0, M[1], M[2]];
              }
              function s(S) {
                var M = Pe(S), K = A0(S), V = 0;
                if (typeof K != "number" && K[0] === 7) {
                  var f0 = K[1];
                  V = 1;
                }
                if (!V) {
                  St(FQr, S);
                  var f0 = TQr;
                }
                var m0 = pr(S);
                ie(S);
                var k0 = A0(S), g0 = 0;
                if (typeof k0 == "number") {
                  var e0 = k0 + CX | 0, x0 = 0;
                  if (72 < e0 >>> 0 ? e0 !== 76 && (x0 = 1) : 70 < (e0 - 1 | 0) >>> 0 || (x0 = 1), !x0) {
                    var l = we(S);
                    g0 = 1;
                  }
                }
                if (!g0) var l = n(S);
                return [0, M, [0, f0, lr([0, m0], [0, l], 0)]];
              }
              function p(S) {
                var M = Yn(1, S);
                if (typeof M == "number") {
                  if (M === 10) for (var K = cr(0, function(m0) {
                    var k0 = [0, s(m0)];
                    return Y0(m0, 10), [0, k0, s(m0)];
                  }, S); ; ) {
                    var V = A0(S);
                    if (typeof V == "number" && V === 10) {
                      var f0 = /* @__PURE__ */ function(k0) {
                        return function(g0) {
                          return Y0(g0, 10), [0, [1, k0], s(g0)];
                        };
                      }(K), K = cr([0, K[1]], f0, S);
                      continue;
                    }
                    return [2, K];
                  }
                  if (M === 86) return [1, cr(0, function(m0) {
                    var k0 = s(m0);
                    return Y0(m0, 86), [0, k0, s(m0)];
                  }, S)];
                }
                return [0, s(S)];
              }
              function y(S) {
                return cr(0, function(M) {
                  var K = Yn(1, M), V = 0;
                  if (typeof K == "number" && K === 86) {
                    var f0 = [1, cr(0, function(b) {
                      var R0 = s(b);
                      return Y0(b, 86), [0, R0, s(b)];
                    }, M)];
                    V = 1;
                  }
                  if (!V) var f0 = [0, s(M)];
                  var m0 = A0(M), k0 = 0;
                  if (typeof m0 == "number" && m0 === 82) {
                    Y0(M, 82);
                    var g0 = pr(M), e0 = A0(M), x0 = 0;
                    if (typeof e0 == "number") if (e0 === 0) {
                      var l = x(M), c0 = l[2], t0 = l[1];
                      c0[1] || ue(M, [0, t0, 56]);
                      var o0 = [0, [1, t0, c0]];
                    } else x0 = 1;
                    else if (e0[0] === 8) {
                      Y0(M, e0);
                      var w0 = [0, e0[2]], _0 = lr([0, g0], [0, n(M)], 0), o0 = [0, [0, e0[1], [0, w0, e0[3], _0]]];
                    } else x0 = 1;
                    if (x0) {
                      je(M, 57);
                      var o0 = [0, [0, Pe(M), [0, gQr, SQr, 0]]];
                    }
                    var E0 = o0;
                    k0 = 1;
                  }
                  if (!k0) var E0 = 0;
                  return [0, f0, E0];
                }, S);
              }
              function T(S) {
                return cr(0, function(M) {
                  Y0(M, 98);
                  var K = A0(M);
                  if (typeof K == "number") {
                    if (K === 99) return ie(M), wQr;
                  } else if (K[0] === 7) for (var V = 0, f0 = p(M); ; ) {
                    var m0 = A0(M);
                    if (typeof m0 == "number") {
                      if (m0 === 0) {
                        var V = [0, [1, e(M)], V];
                        continue;
                      }
                    } else if (m0[0] === 7) {
                      var V = [0, [0, y(M)], V];
                      continue;
                    }
                    var k0 = ye(V), g0 = [0, c1, [0, f0, xu(M, j7), k0]];
                    return xu(M, 99) ? [0, g0] : (B1(M, 99), [1, g0]);
                  }
                  return B1(M, 99), EQr;
                }, S);
              }
              function E(S) {
                return cr(0, function(M) {
                  Y0(M, 98), Y0(M, j7);
                  var K = A0(M);
                  if (typeof K == "number") {
                    if (K === 99) return ie(M), Ni;
                  } else if (K[0] === 7) {
                    var V = p(M);
                    return pe0(M, 99), [0, c1, [0, V]];
                  }
                  return B1(M, 99), Ni;
                }, S);
              }
              var d = function S(M) {
                return S.fun(M);
              }, w = function S(M) {
                return S.fun(M);
              }, G = function S(M) {
                return S.fun(M);
              };
              N(d, function(S) {
                var M = A0(S);
                if (typeof M == "number") {
                  if (M === 0) return c(S);
                } else if (M[0] === 8) return Y0(S, M), [0, M[1], [4, [0, M[2], M[3]]]];
                var K = u(G, S), V = K[2], f0 = K[1];
                return Ni <= V[1] ? [0, f0, [1, V[2]]] : [0, f0, [0, V[2]]];
              });
              function A(S) {
                switch (S[0]) {
                  case 0:
                    return S[1][2][1];
                  case 1:
                    var M = S[1][2], K = Te(hQr, M[2][2][1]);
                    return Te(M[1][2][1], K);
                  default:
                    var V = S[1][2], f0 = V[1], m0 = f0[0] === 0 ? f0[1][2][1] : A([2, f0[1]]);
                    return Te(m0, Te(dQr, V[2][2][1]));
                }
              }
              return N(w, function(S) {
                var M = pr(S), K = T(S);
                k7(S);
                var V = K[2];
                if (V[0] === 0) var f0 = V[1], m0 = typeof f0 == "number" ? 0 : f0[2][2], k0 = m0;
                else var k0 = 1;
                if (k0) var g0 = SU, e0 = g0, x0 = cr(0, function(qr) {
                  return 0;
                }, S);
                else {
                  Ku(S, 3);
                  for (var l = Pe(S), c0 = 0; ; ) {
                    var t0 = i2(S), o0 = A0(S), w0 = 0;
                    if (typeof o0 == "number") {
                      var _0 = 0;
                      if (o0 === 98) {
                        Ku(S, 2);
                        var E0 = A0(S), U0 = Yn(1, S), b = 0;
                        if (typeof E0 == "number" && E0 === 98 && typeof U0 == "number") {
                          var R0 = 0;
                          if (j7 !== U0 && Pn !== U0 && (R0 = 1), !R0) {
                            var X = E(S), s0 = X[2], hr = X[1], Ar = typeof s0 == "number" ? [0, Ni, hr] : [0, c1, [0, hr, s0[2]]], or = S[23][1], W0 = 0;
                            if (or) {
                              var Lr = or[2];
                              if (Lr) {
                                var Tr = Lr[2];
                                W0 = 1;
                              }
                            }
                            if (!W0) var Tr = ke(wRr);
                            S[23][1] = Tr;
                            var Hr = n2(S), Or = Yl(S[24][1], Hr);
                            S[25][1] = Or;
                            var fr = [0, ye(c0), t0, Ar];
                            b = 1;
                          }
                        }
                        if (!b) {
                          var Rr = u(w, S), Wr = Rr[2], Jr = Rr[1], ar = Ni <= Wr[1] ? [0, Jr, [1, Wr[2]]] : [0, Jr, [0, Wr[2]]], c0 = [0, ar, c0];
                          continue;
                        }
                      } else if (Pn === o0) {
                        St(0, S);
                        var fr = [0, ye(c0), t0, SU];
                      } else w0 = 1, _0 = 1;
                      if (!_0) var _r = t0 ? t0[1] : l, Ir = yt(l, _r), e0 = fr[3], x0 = [0, Ir, fr[1]];
                    } else w0 = 1;
                    if (w0) {
                      var c0 = [0, u(d, S), c0];
                      continue;
                    }
                    break;
                  }
                }
                var fe = we(S), v0 = 0;
                if (typeof e0 != "number") {
                  var P = e0[1], L = 0;
                  if (c1 === P) {
                    var Q = e0[2], i0 = K[2];
                    if (i0[0] === 0) {
                      var l0 = i0[1];
                      if (typeof l0 == "number") je(S, kQr);
                      else {
                        var S0 = A(l0[2][1]);
                        n0(A(Q[2][1]), S0) && je(S, [17, S0]);
                      }
                    }
                    var T0 = Q[1];
                  } else if (Ni === P) {
                    var rr = K[2];
                    if (rr[0] === 0) {
                      var L0 = rr[1];
                      typeof L0 != "number" && je(S, [17, A(L0[2][1])]);
                    }
                    var T0 = e0[2];
                  } else L = 1;
                  if (!L) {
                    var B = T0;
                    v0 = 1;
                  }
                }
                if (!v0) var B = K[1];
                var Z = K[2][1], p0 = K[1];
                if (typeof Z == "number") {
                  var b0 = 0, O0 = lr([0, M], [0, fe], 0);
                  if (typeof e0 != "number") {
                    var M0 = e0[1], er = 0;
                    if (c1 === M0) var yr = e0[2][1];
                    else if (Ni === M0) var yr = e0[2];
                    else er = 1;
                    if (!er) {
                      var vr = yr;
                      b0 = 1;
                    }
                  }
                  if (!b0) var vr = B;
                  var $0 = [0, Ni, [0, p0, vr, x0, O0]];
                } else {
                  var Er = 0, Mr = lr([0, M], [0, fe], 0);
                  if (typeof e0 != "number" && c1 === e0[1]) {
                    var Br = [0, e0[2]];
                    Er = 1;
                  }
                  if (!Er) var Br = 0;
                  var $0 = [0, c1, [0, [0, p0, Z[2]], Br, x0, Mr]];
                }
                return [0, yt(K[1], B), $0];
              }), N(G, function(S) {
                return Ku(S, 2), u(w, S);
              }), [0, n, e, i, x, c, s, p, y, T, E, d, w, G];
            }
            function Fi(t) {
              return typeof t == "number" ? 0 : t[0] === 0 ? 1 : t[1];
            }
            function Qee(t, n) {
              return [0, t, n];
            }
            function tb(t, n, e) {
              return [1, 2, n, e, t, 0];
            }
            function ub(t, n, e) {
              return [1, 2, t, n, 0, e];
            }
            function Uc(t, n, e, i) {
              var x = Fi(t), c = Fi(i), s = c <= x ? x + 1 | 0 : c + 1 | 0;
              return s === 1 ? [0, n, e] : [1, s, n, e, t, i];
            }
            function FL(t, n) {
              var e = n !== 0 ? 1 : 0;
              if (e) {
                if (n !== 1) {
                  var i = n >>> 1 | 0, x = FL(t, i), c = u(t, 0), s = FL(t, (n - i | 0) - 1 | 0), p = c[2], y = c[1];
                  return [1, Fi(x) + 1 | 0, y, p, x, s];
                }
                var T = u(t, 0), E = [0, T[1], T[2]];
              } else var E = e;
              return E;
            }
            function P9(t, n, e, i) {
              var x = Fi(t), c = Fi(i), s = c <= x ? x + 1 | 0 : c + 1 | 0;
              return [1, s, n, e, t, i];
            }
            function Iu(t, n, e, i) {
              var x = Fi(t), c = Fi(i);
              if ((c + 2 | 0) < x) {
                var s = t[5], p = t[4], y = t[3], T = t[2], E = Fi(s);
                if (E <= Fi(p)) return P9(p, T, y, Uc(s, n, e, i));
                var d = Uc(s[5], n, e, i), w = s[3], G = s[2];
                return P9(Uc(p, T, y, s[4]), G, w, d);
              }
              if ((x + 2 | 0) < c) {
                var A = i[5], S = i[4], M = i[3], K = i[2], V = Fi(S);
                if (V <= Fi(A)) return P9(Uc(t, n, e, S), K, M, A);
                var f0 = Uc(S[5], K, M, A), m0 = S[3], k0 = S[2];
                return P9(Uc(t, n, e, S[4]), k0, m0, f0);
              }
              return Uc(t, n, e, i);
            }
            var o7 = 0;
            function rne(t) {
              var n = typeof t == "number" ? 1 : 0, e = n && 1;
              return e;
            }
            function qs(t, n) {
              for (var e = t, i = n; ; ) {
                if (typeof e == "number") return i;
                if (e[0] === 0) return [0, e[1], e[2], o7, i];
                var x = [0, e[2], e[3], e[5], i], e = e[4], i = x;
              }
            }
            function Fe0(t) {
              for (var n = t; ; ) {
                if (typeof n == "number") throw Jt;
                if (n[0] === 0) return n;
                if (typeof n[4] == "number") return [0, n[2], n[3]];
                var n = n[4];
              }
            }
            function Te0(t) {
              for (var n = t; ; ) {
                var e = n[4];
                if (typeof e == "number") return [0, n[2], n[3]];
                if (e[0] === 0) return e;
                var n = e;
              }
            }
            function Oe0(t) {
              for (var n = t; ; ) {
                if (typeof n == "number") return 0;
                if (n[0] === 0) return [0, [0, n[1], n[2]]];
                if (typeof n[4] == "number") return [0, [0, n[2], n[3]]];
                var n = n[4];
              }
            }
            function ene(t) {
              for (var n = t; ; ) {
                if (typeof n == "number") throw Jt;
                if (n[0] === 0) return n;
                if (typeof n[5] == "number") return [0, n[2], n[3]];
                var n = n[5];
              }
            }
            function nne(t) {
              for (var n = t; ; ) {
                if (typeof n == "number") return 0;
                if (n[0] === 0) return [0, [0, n[1], n[2]]];
                if (typeof n[5] == "number") return [0, [0, n[2], n[3]]];
                var n = n[5];
              }
            }
            function TL(t) {
              var n = t[5], e = t[4], i = t[3], x = t[2];
              return typeof e == "number" ? n : e[0] === 0 ? Iu(0, x, i, n) : Iu(TL(e), x, i, n);
            }
            function OL(t, n) {
              if (typeof n == "number") return t;
              if (n[0] === 0) return tb(t, n[1], n[2]);
              var e = n[5], i = n[3], x = n[2];
              return Iu(OL(t, n[4]), x, i, e);
            }
            function Ie0(t, n, e) {
              if (typeof e == "number") return [0, t, n];
              if (e[0] === 0) return ub(t, n, e);
              var i = e[5], x = e[3], c = e[2];
              return Iu(Ie0(t, n, e[4]), c, x, i);
            }
            function IL(t, n) {
              if (typeof n == "number") return t;
              if (n[0] === 0) return ub(n[1], n[2], t);
              var e = IL(t, n[5]);
              return Iu(n[4], n[2], n[3], e);
            }
            function Ae0(t, n, e) {
              if (typeof e == "number") return [0, t, n];
              if (e[0] === 0) return tb(e, t, n);
              var i = Ae0(t, n, e[5]);
              return Iu(e[4], e[2], e[3], i);
            }
            function Ne0(t, n) {
              if (typeof t == "number") return n;
              if (t[0] === 1 && typeof n != "number") {
                if (n[0] === 0) return IL(n, t);
                var e = Te0(n), i = TL(n);
                return Iu(t, e[1], e[2], i);
              }
              return typeof n == "number" ? t : OL(t, n);
            }
            function ai(t, n, e, i) {
              if (typeof t == "number") return Ie0(n, e, i);
              if (t[0] === 0) {
                if (typeof i != "number") {
                  if (i[0] === 0) return [1, 2, n, e, t, i];
                  if (3 < i[1]) {
                    var x = i[5], c = i[3], s = i[2];
                    return Iu(ai(t, n, e, i[4]), s, c, x);
                  }
                  return Uc(t, n, e, i);
                }
              } else {
                var p = t[5], y = t[4], T = t[3], E = t[2], d = t[1];
                if (typeof i != "number") {
                  if (i[0] === 0) return 3 < d ? Iu(y, E, T, ai(p, n, e, i)) : Uc(t, n, e, i);
                  var w = i[1];
                  if ((w + 2 | 0) < d) return Iu(y, E, T, ai(p, n, e, i));
                  if ((d + 2 | 0) < w) {
                    var G = i[5], A = i[3], S = i[2];
                    return Iu(ai(t, n, e, i[4]), S, A, G);
                  }
                  return Uc(t, n, e, i);
                }
              }
              return Ae0(n, e, t);
            }
            function D9(t, n) {
              if (typeof t == "number") return n;
              if (t[0] === 1 && typeof n != "number") {
                if (n[0] === 0) return IL(n, t);
                var e = Te0(n), i = TL(n);
                return ai(t, e[1], e[2], i);
              }
              return typeof n == "number" ? t : OL(t, n);
            }
            function ib(t, n, e, i) {
              return e ? ai(t, n, e[1], i) : D9(t, i);
            }
            function Ce0(t, n) {
              for (var e = n; ; ) {
                if (typeof e == "number") return 0;
                if (e[0] === 0) return o(t, e[1], e[2]);
                Ce0(t, e[4]), o(t, e[2], e[3]);
                var e = e[5];
              }
            }
            function AL(t, n) {
              if (typeof n == "number") return 0;
              if (n[0] === 0) {
                var e = u(t, n[2]);
                return [0, n[1], e];
              }
              var i = AL(t, n[4]), x = u(t, n[3]), c = AL(t, n[5]);
              return [1, n[1], n[2], x, i, c];
            }
            function NL(t, n) {
              if (typeof n == "number") return 0;
              if (n[0] === 0) {
                var e = n[1];
                return [0, e, o(t, e, n[2])];
              }
              var i = n[2], x = NL(t, n[4]), c = o(t, i, n[3]), s = NL(t, n[5]);
              return [1, n[1], i, c, x, s];
            }
            function CL(t, n, e) {
              for (var i = n, x = e; ; ) {
                if (typeof i == "number") return x;
                if (i[0] === 0) return ur(t, i[1], i[2], x);
                var c = CL(t, i[4], x), s = ur(t, i[2], i[3], c), i = i[5], x = s;
              }
            }
            function Pe0(t, n) {
              for (var e = t, i = n; ; ) {
                if (typeof i == "number") return e;
                if (i[0] === 0) return [0, i[1], e];
                var x = i[4], c = Pe0(e, i[5]), e = [0, i[2], c], i = x;
              }
            }
            function De0(t) {
              return Pe0(0, t);
            }
            function Le0(t, n) {
              for (var e = n; ; ) {
                if (typeof e == "number") return 1;
                if (e[0] === 0) return o(t, e[1], e[2]);
                var i = o(t, e[2], e[3]);
                if (i) {
                  var x = Le0(t, e[4]);
                  if (x) {
                    var e = e[5];
                    continue;
                  }
                  var c = x;
                } else var c = i;
                return c;
              }
            }
            function Re0(t, n) {
              for (var e = n; ; ) {
                if (typeof e == "number") return 0;
                if (e[0] === 0) return o(t, e[1], e[2]);
                var i = o(t, e[2], e[3]);
                if (i) var x = i;
                else {
                  var c = Re0(t, e[4]);
                  if (!c) {
                    var e = e[5];
                    continue;
                  }
                  var x = c;
                }
                return x;
              }
            }
            function PL(t, n) {
              if (typeof n == "number") return 0;
              if (n[0] === 0) return o(t, n[1], n[2]) ? n : o7;
              var e = n[5], i = n[4], x = n[3], c = n[2], s = PL(t, i), p = o(t, c, x), y = PL(t, e);
              return p ? i === s && e === y ? n : ai(s, c, x, y) : D9(s, y);
            }
            function DL(t) {
              if (typeof t == "number") return 0;
              if (t[0] === 0) return 1;
              var n = DL(t[5]);
              return (DL(t[4]) + 1 | 0) + n | 0;
            }
            function je0(t, n) {
              for (var e = t, i = n; ; ) {
                if (typeof i == "number") return e;
                if (i[0] === 0) return [0, i, e];
                var x = i[4], c = je0(e, i[5]), e = [0, [0, i[2], i[3]], c], i = x;
              }
            }
            function tne(t) {
              return je0(0, t);
            }
            var L9 = /* @__PURE__ */ function(t) {
              function n(A, S, M) {
                if (typeof M == "number") return [0, A, S];
                if (M[0] === 0) {
                  var K = M[1], V = o(t[1], A, K);
                  return V === 0 ? M[2] === S ? M : [0, K, S] : 0 <= V ? tb(M, A, S) : ub(A, S, M);
                }
                var f0 = M[5], m0 = M[4], k0 = M[3], g0 = M[2], e0 = o(t[1], A, g0);
                if (e0 === 0) return k0 === S ? M : [1, M[1], A, S, m0, f0];
                if (0 <= e0) {
                  var x0 = n(A, S, f0);
                  return f0 === x0 ? M : Iu(m0, g0, k0, x0);
                }
                var l = n(A, S, m0);
                return m0 === l ? M : Iu(l, g0, k0, f0);
              }
              function e(A, S) {
                for (var M = S; ; ) {
                  if (typeof M == "number") throw Jt;
                  if (M[0] === 0) {
                    if (o(t[1], A, M[1]) === 0) return M[2];
                    throw Jt;
                  }
                  var K = o(t[1], A, M[2]);
                  if (K === 0) return M[3];
                  var V = 0 <= K ? M[5] : M[4], M = V;
                }
              }
              function i(A, S) {
                for (var M = S; ; ) {
                  if (typeof M == "number") return 0;
                  if (M[0] === 0) {
                    var K = o(t[1], A, M[1]) === 0 ? 1 : 0, V = K && [0, M[2]];
                    return V;
                  }
                  var f0 = o(t[1], A, M[2]);
                  if (f0 === 0) return [0, M[3]];
                  var m0 = 0 <= f0 ? M[5] : M[4], M = m0;
                }
              }
              function x(A, S) {
                for (var M = S; ; ) {
                  if (typeof M == "number") return 0;
                  if (M[0] === 0) return o(t[1], A, M[1]) === 0 ? 1 : 0;
                  var K = o(t[1], A, M[2]), V = K === 0 ? 1 : 0;
                  if (V) return V;
                  var f0 = 0 <= K ? M[5] : M[4], M = f0;
                }
              }
              function c(A, S) {
                if (typeof S == "number") return S;
                if (S[0] === 0) return o(t[1], A, S[1]) === 0 ? o7 : S;
                var M = S[5], K = S[4], V = S[3], f0 = S[2], m0 = o(t[1], A, f0);
                if (m0 === 0) return Ne0(K, M);
                if (0 <= m0) {
                  var k0 = c(A, M);
                  return M === k0 ? S : Iu(K, f0, V, k0);
                }
                var g0 = c(A, K);
                return K === g0 ? S : Iu(g0, f0, V, M);
              }
              function s(A, S, M) {
                if (typeof M == "number") return [0, A, u(S, 0)];
                if (M[0] === 0) {
                  var K = M[2], V = M[1], f0 = o(t[1], A, V);
                  if (f0 === 0) {
                    var m0 = u(S, [0, K]);
                    return K === m0 ? M : [0, V, m0];
                  }
                  var k0 = u(S, 0);
                  return 0 <= f0 ? tb(M, A, k0) : ub(A, k0, M);
                }
                var g0 = M[5], e0 = M[4], x0 = M[3], l = M[2], c0 = o(t[1], A, l);
                if (c0 === 0) {
                  var t0 = u(S, [0, x0]);
                  return x0 === t0 ? M : [1, M[1], A, t0, e0, g0];
                }
                if (0 <= c0) {
                  var o0 = s(A, S, g0);
                  return g0 === o0 ? M : Iu(e0, l, x0, o0);
                }
                var w0 = s(A, S, e0);
                return e0 === w0 ? M : Iu(w0, l, x0, g0);
              }
              function p(A, S, M) {
                if (typeof M == "number") {
                  var K = u(S, 0);
                  return K && [0, A, K[1]];
                } else {
                  if (M[0] === 0) {
                    var V = M[2], f0 = M[1], m0 = o(t[1], A, f0);
                    if (m0 === 0) {
                      var k0 = u(S, [0, V]);
                      if (k0) {
                        var g0 = k0[1];
                        return V === g0 ? M : [0, f0, g0];
                      }
                      return o7;
                    }
                    var e0 = u(S, 0);
                    if (e0) {
                      var x0 = e0[1];
                      return 0 <= m0 ? tb(M, A, x0) : ub(A, x0, M);
                    }
                    return M;
                  }
                  var l = M[5], c0 = M[4], t0 = M[3], o0 = M[2], w0 = o(t[1], A, o0);
                  if (w0 === 0) {
                    var _0 = u(S, [0, t0]);
                    if (_0) {
                      var E0 = _0[1];
                      return t0 === E0 ? M : [1, M[1], A, E0, c0, l];
                    }
                    return Ne0(c0, l);
                  }
                  if (0 <= w0) {
                    var U0 = p(A, S, l);
                    return l === U0 ? M : Iu(c0, o0, t0, U0);
                  }
                  var b = p(A, S, c0);
                  return c0 === b ? M : Iu(b, o0, t0, l);
                }
              }
              function y(A, S) {
                if (typeof S == "number") return OQr;
                if (S[0] === 0) {
                  var M = o(t[1], A, S[1]);
                  return M === 0 ? [0, o7, [0, S[2]], o7] : 0 <= M ? [0, S, 0, o7] : [0, o7, 0, S];
                }
                var K = S[5], V = S[4], f0 = S[3], m0 = S[2], k0 = o(t[1], A, m0);
                if (k0 === 0) return [0, V, [0, f0], K];
                if (0 <= k0) {
                  var g0 = y(A, K), e0 = g0[3], x0 = g0[2];
                  return [0, ai(V, m0, f0, g0[1]), x0, e0];
                }
                var l = y(A, V), c0 = ai(l[3], m0, f0, K);
                return [0, l[1], l[2], c0];
              }
              function T(A, S, M) {
                if (typeof S == "number") {
                  if (typeof M == "number") return 0;
                  if (M[0] === 0) {
                    var K = M[1], V = ur(A, K, 0, [0, M[2]]);
                    return V ? [0, K, V[1]] : o7;
                  }
                } else if (S[0] === 0) {
                  var f0 = S[2], m0 = S[1];
                  if (typeof M == "number") {
                    var k0 = ur(A, m0, [0, f0], 0);
                    return k0 ? [0, m0, k0[1]] : o7;
                  } else if (M[0] === 0) {
                    var g0 = y(m0, M), e0 = T(A, o7, g0[3]), x0 = ur(A, m0, [0, f0], g0[2]);
                    return ib(T(A, o7, g0[1]), m0, x0, e0);
                  }
                } else {
                  var l = S[2], c0 = Fi(M);
                  if (c0 <= S[1]) {
                    var t0 = y(l, M), o0 = T(A, S[5], t0[3]), w0 = ur(A, l, [0, S[3]], t0[2]);
                    return ib(T(A, S[4], t0[1]), l, w0, o0);
                  }
                  var _0 = 0;
                  if ((typeof M == "number" || M[0] !== 1) && (_0 = 1), _0) throw [0, Sn, IQr];
                }
                var E0 = M[2], U0 = y(E0, S), b = T(A, U0[3], M[5]), R0 = ur(A, E0, U0[2], [0, M[3]]);
                return ib(T(A, U0[1], M[4]), E0, R0, b);
              }
              function E(A, S, M) {
                var K = 0;
                if (typeof S == "number") {
                  var _0 = M;
                  K = 1;
                } else if (S[0] === 1) {
                  var V = S[3], f0 = S[2];
                  if (typeof M != "number" && M[0] !== 0) {
                    var m0 = M[3], k0 = M[2];
                    if (M[1] <= S[1]) {
                      var g0 = y(f0, M), e0 = g0[2], x0 = E(A, S[4], g0[1]), l = E(A, S[5], g0[3]);
                      return e0 ? ib(x0, f0, ur(A, f0, V, e0[1]), l) : ai(x0, f0, V, l);
                    }
                    var c0 = y(k0, S), t0 = c0[2], o0 = E(A, c0[1], M[4]), w0 = E(A, c0[3], M[5]);
                    return t0 ? ib(o0, k0, ur(A, k0, t0[1], m0), w0) : ai(o0, k0, m0, w0);
                  }
                }
                if (!K) if (typeof M == "number") var _0 = S;
                else {
                  if (M[0] === 0) {
                    var E0 = M[2], U0 = M[1];
                    return p(U0, function(X) {
                      return X ? ur(A, U0, X[1], E0) : [0, E0];
                    }, S);
                  }
                  var b = S[2], R0 = S[1];
                  return p(R0, function(X) {
                    return X ? ur(A, R0, b, X[1]) : [0, b];
                  }, M);
                }
                return _0;
              }
              function d(A, S) {
                if (typeof S == "number") return AQr;
                if (S[0] === 0) return o(A, S[1], S[2]) ? [0, S, o7] : [0, o7, S];
                var M = S[3], K = S[2], V = d(A, S[4]), f0 = V[2], m0 = V[1], k0 = o(A, K, M), g0 = d(A, S[5]), e0 = g0[2], x0 = g0[1];
                if (k0) {
                  var l = D9(f0, e0);
                  return [0, ai(m0, K, M, x0), l];
                }
                var c0 = ai(f0, K, M, e0);
                return [0, D9(m0, x0), c0];
              }
              function w(A, S, M) {
                for (var K = qs(M, 0), V = qs(S, 0), f0 = K; ; ) {
                  if (V) {
                    if (f0) {
                      var m0 = o(t[1], V[1], f0[1]);
                      if (m0 === 0) {
                        var k0 = o(A, V[2], f0[2]);
                        if (k0 === 0) {
                          var g0 = qs(f0[3], f0[4]), V = qs(V[3], V[4]), f0 = g0;
                          continue;
                        }
                        return k0;
                      }
                      return m0;
                    }
                    return 1;
                  }
                  var e0 = f0 && -1;
                  return e0;
                }
              }
              function G(A, S, M) {
                for (var K = qs(M, 0), V = qs(S, 0), f0 = K; ; ) {
                  if (V) {
                    if (f0) {
                      var m0 = o(t[1], V[1], f0[1]) === 0 ? 1 : 0;
                      if (m0) {
                        var k0 = o(A, V[2], f0[2]);
                        if (k0) {
                          var g0 = qs(f0[3], f0[4]), V = qs(V[3], V[4]), f0 = g0;
                          continue;
                        }
                        var e0 = k0;
                      } else var e0 = m0;
                    } else var e0 = f0;
                    return e0;
                  }
                  return f0 ? 0 : 1;
                }
              }
              return [0, o7, rne, x, n, p, s, Qee, c, T, E, w, G, Ce0, CL, Le0, Re0, PL, d, DL, tne, Fe0, Oe0, ene, nne, De0, De0, function(A, S, M) {
                var K = [0, o7, 0], V = CL(function(f0, m0, k0) {
                  var g0 = k0[1], e0 = u(S, f0), x0 = k0[2], l = x0 || (e0 !== f0 ? 1 : 0);
                  if (A) var c0 = A[1], t0 = s(e0, function(o0) {
                    return o0 ? o(c0, o0[1], m0) : m0;
                  }, g0);
                  else var t0 = n(e0, m0, g0);
                  return [0, t0, l];
                }, M, K);
                return V[2] ? V[1] : M;
              }, Fe0, Oe0, y, e, i, AL, NL, FL];
            }([0, bz]);
            function a2(t) {
              return [0, j1(t)];
            }
            var LL = eL([0, function(t, n) {
              var e = z00(t[1], n[1]);
              return e === 0 ? o(tr0, t[2], n[2]) : e;
            }]);
            function fb(t, n, e) {
              var i = e[2][1];
              return qn(i, cre) ? n : o(Mu[3], i, n) ? (ue(t, [0, e[1], [19, i]]), n) : o(Mu[4], i, n);
            }
            function RL(t, n) {
              var e = n[2];
              switch (e[0]) {
                case 0:
                  var i = e[1][1];
                  return le(function(c, s) {
                    var p = s[0] === 0 ? s[1][2][2] : s[1][2][1];
                    return RL(c, p);
                  }, t, i);
                case 1:
                  var x = e[1][1];
                  return le(function(c, s) {
                    return s[0] === 2 ? c : RL(c, s[1][2][1]);
                  }, t, x);
                case 2:
                  return [0, e[1][1], t];
                default:
                  return ke(are);
              }
            }
            var se = pu(vre, sre), mn = Jee(se), Vn = function(t) {
              var n = [0, KJr, Mu[1], 0, 0];
              function e(o0) {
                var w0 = A0(o0);
                if (typeof w0 == "number") {
                  var _0 = 0;
                  if (8 <= w0 ? 10 <= w0 || (_0 = 1) : w0 === 1 && (_0 = 1), _0) return 1;
                }
                return 0;
              }
              function i(o0) {
                var w0 = z7(o0), _0 = A0(o0), E0 = 0;
                if (typeof _0 == "number") {
                  var U0 = 0;
                  if (_0 === 82 ? Y0(o0, 82) : _0 === 86 ? (je(o0, [4, w0[2][1]]), Y0(o0, 86)) : U0 = 1, !U0) {
                    var b = Pe(o0), R0 = pr(o0), X = A0(o0), s0 = 0;
                    if (typeof X == "number") switch (X) {
                      case 30:
                      case 31:
                        ie(o0);
                        var hr = we(o0), Ar = e(o0) ? [1, b, [0, X === 31 ? 1 : 0, lr([0, R0], [0, hr], 0)]] : [0, b], or = Ar;
                        break;
                      default:
                        s0 = 1;
                    }
                    else switch (X[0]) {
                      case 0:
                        var W0 = X[2], Lr = ur(se[24], o0, X[1], W0), Tr = we(o0), Hr = e(o0) ? [2, b, [0, Lr, W0, lr([0, R0], [0, Tr], 0)]] : [0, b], or = Hr;
                        break;
                      case 2:
                        var Or = X[1], fr = Or[1];
                        Or[4] && gi(o0, 45), ie(o0);
                        var Rr = we(o0);
                        if (e(o0)) var Wr = lr([0, R0], [0, Rr], 0), Jr = [3, fr, [0, Or[2], Or[3], Wr]];
                        else var Jr = [0, fr];
                        var or = Jr;
                        break;
                      default:
                        s0 = 1;
                    }
                    if (s0) {
                      ie(o0);
                      var or = [0, b];
                    }
                    var ar = or;
                    E0 = 1;
                  }
                }
                if (!E0) var ar = 0;
                return [0, w0, ar];
              }
              var x = 0;
              function c(o0) {
                var w0 = pr(o0);
                Y0(o0, 48);
                var _0 = o(se[13], 0, o0), E0 = _0[2][1], U0 = _0[1], b = cr(0, function(R0) {
                  var X = xu(R0, 63);
                  if (X) {
                    Ku(R0, 1);
                    var s0 = A0(R0), hr = 0;
                    if (typeof s0 == "number") switch (s0) {
                      case 117:
                        var Ar = HJr;
                        break;
                      case 119:
                        var Ar = XJr;
                        break;
                      case 121:
                        var Ar = YJr;
                        break;
                      default:
                        hr = 1;
                    }
                    else switch (s0[0]) {
                      case 4:
                        je(R0, [3, E0, [0, s0[2]]]);
                        var Ar = 0;
                        break;
                      case 9:
                        if (s0[1]) var Ar = VJr;
                        else hr = 1;
                        break;
                      default:
                        hr = 1;
                    }
                    if (hr) {
                      je(R0, [3, E0, 0]);
                      var Ar = 0;
                    }
                    ie(R0), k7(R0);
                    var or = Ar;
                  } else var or = X;
                  var W0 = or !== 0 ? 1 : 0, Lr = W0 && pr(R0);
                  Y0(R0, 0);
                  for (var Tr = n; ; ) {
                    var Hr = A0(R0);
                    if (typeof Hr == "number") {
                      var Or = Hr - 2 | 0;
                      if (Xt < Or >>> 0) {
                        if (!(T7 < (Or + 1 | 0) >>> 0)) {
                          var fr = Tr[3], Rr = Tr[4], Wr = ye(Tr[1][4]), Jr = ye(Tr[1][3]), ar = ye(Tr[1][2]), _r = ye(Tr[1][1]), Ir = on(Rr, pr(R0));
                          Y0(R0, 1);
                          var fe = A0(R0), v0 = 0;
                          if (typeof fe == "number") {
                            var P = 0;
                            if (fe !== 1 && Pn !== fe && (v0 = 1, P = 1), !P) var Q = we(R0);
                          } else v0 = 1;
                          if (v0) var L = x7(R0), Q = L && Ms(R0);
                          var i0 = yu([0, Lr], [0, Q], Ir, 0);
                          if (or) switch (or[1]) {
                            case 0:
                              return [0, [0, _r, 1, fr, i0]];
                            case 1:
                              return [1, [0, ar, 1, fr, i0]];
                            case 2:
                              var l0 = 1;
                              break;
                            default:
                              return [3, [0, Wr, fr, i0]];
                          }
                          else {
                            var S0 = Dc(_r), T0 = Dc(ar), rr = Dc(Jr), L0 = Dc(Wr), B = 0;
                            if (S0 === 0 && T0 === 0) {
                              var Z = 0;
                              if (rr === 0 && L0 === 0 && (B = 1, Z = 1), !Z) {
                                var l0 = 0;
                                B = 2;
                              }
                            }
                            var p0 = 0;
                            switch (B) {
                              case 0:
                                if (T0 === 0 && rr === 0 && L0 <= S0) return Du(function(K0) {
                                  return ue(R0, [0, K0[1], [0, E0, K0[2][1][2][1]]]);
                                }, Wr), [0, [0, _r, 0, fr, i0]];
                                if (S0 === 0 && rr === 0 && L0 <= T0) return Du(function(K0) {
                                  return ue(R0, [0, K0[1], [8, E0, K0[2][1][2][1]]]);
                                }, Wr), [1, [0, ar, 0, fr, i0]];
                                ue(R0, [0, U0, [2, E0]]);
                                break;
                              case 1:
                                break;
                              default:
                                p0 = 1;
                            }
                            if (!p0) return [2, [0, zJr, 0, fr, i0]];
                          }
                          var b0 = Dc(Jr), O0 = Dc(Wr);
                          if (b0 !== 0) {
                            var M0 = 0;
                            if (O0 !== 0 && (b0 < O0 ? (Du(function(K0) {
                              return ue(R0, [0, K0[1], [9, E0]]);
                            }, Jr), M0 = 1) : Du(function(K0) {
                              return ue(R0, [0, K0[1], [9, E0]]);
                            }, Wr)), !M0) return [2, [0, [1, Jr], l0, fr, i0]];
                          }
                          return [2, [0, [0, Wr], l0, fr, i0]];
                        }
                      } else if (Or === 10) {
                        var er = Pe(R0), yr = pr(R0);
                        ie(R0);
                        var vr = A0(R0), $0 = 0;
                        if (typeof vr == "number") {
                          var Er = vr - 2 | 0, Mr = 0;
                          if (Xt < Er >>> 0) T7 < (Er + 1 | 0) >>> 0 && (Mr = 1);
                          else if (Er === 7) {
                            Y0(R0, 9);
                            var Br = A0(R0), qr = 0;
                            if (typeof Br == "number") {
                              var jr = 0;
                              if (Br !== 1 && Pn !== Br && (jr = 1), !jr) {
                                var $r = 1;
                                qr = 1;
                              }
                            }
                            if (!qr) var $r = 0;
                            ue(R0, [0, er, [7, $r]]);
                          } else Mr = 1;
                          Mr || ($0 = 1);
                        }
                        $0 || ue(R0, [0, er, qJr]);
                        var Tr = [0, Tr[1], Tr[2], 1, yr];
                        continue;
                      }
                    }
                    var ne = Tr[2], Qr = Tr[1], be = cr(x, i, R0), ae = be[2], pe = ae[1], oe = pe[2][1];
                    if (qn(oe, UJr)) var ce = Tr;
                    else {
                      var ge = pe[1], q0 = ae[2], Fr = be[1], _ = It(oe, 0), k = 97 <= _ ? 1 : 0, I = k && (_ <= In ? 1 : 0);
                      I && ue(R0, [0, ge, [6, E0, oe]]), o(Mu[3], oe, ne) && ue(R0, [0, ge, [1, E0, oe]]);
                      var U = Tr[4], Y = Tr[3], y0 = o(Mu[4], oe, ne), P0 = [0, Tr[1], y0, Y, U], I0 = /* @__PURE__ */ function(Ur) {
                        return function(h0, Kr) {
                          return or && or[1] !== h0 ? ue(R0, [0, Kr, [5, E0, or, Ur]]) : 0;
                        };
                      }(oe);
                      if (typeof q0 == "number") {
                        var D = 0;
                        if (or) {
                          var u0 = or[1], X0 = 0;
                          if (u0 === 1 ? ue(R0, [0, Fr, [8, E0, oe]]) : u0 ? (D = 1, X0 = 1) : ue(R0, [0, Fr, [0, E0, oe]]), !X0) var J0 = P0;
                        } else D = 1;
                        if (D) var J0 = [0, [0, Qr[1], Qr[2], Qr[3], [0, [0, Fr, [0, pe]], Qr[4]]], y0, Y, U];
                      } else switch (q0[0]) {
                        case 0:
                          ue(R0, [0, q0[1], [5, E0, or, oe]]);
                          var J0 = P0;
                          break;
                        case 1:
                          var ir = q0[1];
                          I0(0, ir);
                          var J0 = [0, [0, [0, [0, Fr, [0, pe, [0, ir, q0[2]]]], Qr[1]], Qr[2], Qr[3], Qr[4]], y0, Y, U];
                          break;
                        case 2:
                          var Q0 = q0[1];
                          I0(1, Q0);
                          var J0 = [0, [0, Qr[1], [0, [0, Fr, [0, pe, [0, Q0, q0[2]]]], Qr[2]], Qr[3], Qr[4]], y0, Y, U];
                          break;
                        default:
                          var F0 = q0[1];
                          I0(2, F0);
                          var J0 = [0, [0, Qr[1], Qr[2], [0, [0, Fr, [0, pe, [0, F0, q0[2]]]], Qr[3]], Qr[4]], y0, Y, U];
                      }
                      var ce = J0;
                    }
                    var Sr = A0(R0), mr = 0;
                    if (typeof Sr == "number") {
                      var Cr = Sr - 2 | 0, sr = 0;
                      Xt < Cr >>> 0 ? T7 < (Cr + 1 | 0) >>> 0 && (sr = 1) : Cr === 6 ? (je(R0, 1), Y0(R0, 8)) : sr = 1, sr || (mr = 1);
                    }
                    mr || Y0(R0, 9);
                    var Tr = ce;
                  }
                }, o0);
                return [16, [0, _0, b, lr([0, w0], 0, 0)]];
              }
              var s = 0;
              function p(o0) {
                return cr(s, c, o0);
              }
              function y(o0, w0) {
                var _0 = w0[2][1], E0 = w0[1], U0 = o0[1];
                js(_0) && V7(U0, [0, E0, 41]);
                var b = O9(_0), R0 = b || f2(_0);
                return R0 && V7(U0, [0, E0, 55]), [0, U0, o0[2]];
              }
              function T(o0, w0) {
                var _0 = w0[2];
                switch (_0[0]) {
                  case 0:
                    return le(E, o0, _0[1][1]);
                  case 1:
                    return le(d, o0, _0[1][1]);
                  case 2:
                    var E0 = _0[1][1], U0 = E0[2][1], b = o0[2], R0 = o0[1];
                    o(Mu[3], U0, b) && ue(R0, [0, E0[1], 42]);
                    var X = y([0, R0, b], E0), s0 = o(Mu[4], U0, X[2]);
                    return [0, X[1], s0];
                  default:
                    return ue(o0[1], [0, w0[1], 31]), o0;
                }
              }
              function E(o0, w0) {
                if (w0[0] === 0) {
                  var _0 = w0[1][2], E0 = _0[1], U0 = E0[0] === 1 ? y(o0, E0[1]) : o0;
                  return T(U0, _0[2]);
                }
                return T(o0, w0[1][2][1]);
              }
              function d(o0, w0) {
                return w0[0] === 2 ? o0 : T(o0, w0[1][2][1]);
              }
              function w(o0, w0, _0, E0) {
                var U0 = o0[5], b = q1(E0), R0 = E0[2], X = R0[3], s0 = _s(U0 ? 0 : w0, o0), hr = w0 || U0 || 1 - b;
                if (hr) {
                  if (_0) {
                    var Ar = _0[1], or = Ar[2][1], W0 = Ar[1];
                    js(or) && V7(s0, [0, W0, 44]);
                    var Lr = O9(or), Tr = Lr || f2(or);
                    Tr && V7(s0, [0, W0, 55]);
                  }
                  var Hr = R0[2], Or = [0, s0, Mu[1]], fr = le(function(ar, _r) {
                    return T(ar, _r[2][1]);
                  }, Or, Hr), Rr = X && (T(fr, X[1][2][1]), 0), Wr = Rr;
                } else var Wr = hr;
                return Wr;
              }
              var G = function o0(w0, _0) {
                return o0.fun(w0, _0);
              };
              function A(o0) {
                A0(o0) === 21 && je(o0, s7);
                var w0 = o(se[18], o0, 41), _0 = A0(o0) === 82 ? 1 : 0, E0 = _0 && (Y0(o0, 82), [0, u(se[10], o0)]);
                return [0, w0, E0];
              }
              var S = 0;
              N(G, function(o0, w0) {
                var _0 = A0(o0);
                if (typeof _0 == "number") {
                  var E0 = _0 - 5 | 0, U0 = 0;
                  if (7 < E0 >>> 0 ? is === E0 && (U0 = 1) : 5 < (E0 - 1 | 0) >>> 0 && (U0 = 1), U0) {
                    var b = _0 === 12 ? 1 : 0;
                    if (b) var R0 = pr(o0), X = cr(0, function(or) {
                      return Y0(or, 12), o(se[18], or, 41);
                    }, o0), s0 = lr([0, R0], 0, 0), hr = [0, [0, X[1], [0, X[2], s0]]];
                    else var hr = b;
                    return A0(o0) !== 5 && je(o0, 64), [0, ye(w0), hr];
                  }
                }
                var Ar = cr(S, A, o0);
                return A0(o0) !== 5 && Y0(o0, 9), o(G, o0, [0, Ar, w0]);
              });
              function M(o0, w0) {
                function _0(U0) {
                  var b = mL(w0, re0(o0, U0)), R0 = 1, X = b[10] === 1 ? b : [0, b[1], b[2], b[3], b[4], b[5], b[6], b[7], b[8], b[9], R0, b[11], b[12], b[13], b[14], b[15], b[16], b[17], b[18], b[19], b[20], b[21], b[22], b[23], b[24], b[25], b[26], b[27], b[28], b[29], b[30]], s0 = pr(X);
                  Y0(X, 4);
                  var hr = fu(X), Ar = hr && (A0(X) === 21 ? 1 : 0);
                  if (Ar) {
                    var or = pr(X), W0 = cr(0, function(ar) {
                      return Y0(ar, 21), A0(ar) === 86 ? [0, u(t[9], ar)] : (je(ar, Ri), 0);
                    }, X), Lr = W0[2];
                    if (Lr) {
                      A0(X) === 9 && ie(X);
                      var Tr = lr([0, or], 0, 0), Hr = [0, [0, W0[1], [0, Lr[1], Tr]]];
                    } else var Hr = Lr;
                    var Or = Hr;
                  } else var Or = Ar;
                  var fr = o(G, X, 0), Rr = pr(X);
                  Y0(X, 5);
                  var Wr = yu([0, s0], [0, we(X)], Rr, 0);
                  return [0, Or, fr[1], fr[2], Wr];
                }
                var E0 = 0;
                return function(U0) {
                  return cr(E0, _0, U0);
                };
              }
              function K(o0, w0, _0, E0, U0) {
                var b = fe0(o0, w0, _0, U0), R0 = o(se[16], E0, b);
                return [0, [0, R0[1]], R0[2]];
              }
              function V(o0, w0, _0) {
                var E0 = Pe(o0), U0 = A0(o0), b = 0;
                if (typeof U0 == "number") if (s7 === U0) {
                  var R0 = pr(o0);
                  ie(o0);
                  var s0 = [0, [0, E0, [0, 0, lr([0, R0], 0, 0)]]];
                } else if (L7 === U0) {
                  var X = pr(o0);
                  ie(o0);
                  var s0 = [0, [0, E0, [0, 1, lr([0, X], 0, 0)]]];
                } else b = 1;
                else b = 1;
                if (b) var s0 = 0;
                if (s0) {
                  var hr = 0;
                  if (!w0 && !_0 && (hr = 1), !hr) return ue(o0, [0, s0[1][1], 7]), 0;
                }
                return s0;
              }
              function f0(o0) {
                if (Yt === A0(o0)) {
                  var w0 = pr(o0);
                  return ie(o0), [0, 1, w0];
                }
                return S$r;
              }
              function m0(o0) {
                if (A0(o0) === 64 && !Jl(1, o0)) {
                  var w0 = pr(o0);
                  return ie(o0), [0, 1, w0];
                }
                return E$r;
              }
              function k0(o0) {
                var w0 = m0(o0), _0 = w0[1], E0 = w0[2], U0 = cr(0, function(W0) {
                  var Lr = pr(W0);
                  Y0(W0, 15);
                  var Tr = f0(W0), Hr = Tr[1], Or = pl([0, E0, [0, Lr, [0, Tr[2], 0]]]), fr = W0[7], Rr = A0(W0), Wr = 0;
                  if (fr && typeof Rr == "number") {
                    if (Rr === 4) {
                      var Ir = 0, fe = 0;
                      Wr = 1;
                    } else if (Rr === 98) {
                      var Jr = oi(W0, u(t[3], W0)), ar = A0(W0) === 4 ? 0 : [0, ys(W0, o(se[13], h$r, W0))], Ir = ar, fe = Jr;
                      Wr = 1;
                    }
                  }
                  if (!Wr) var _r = G1(W0) ? ys(W0, o(se[13], d$r, W0)) : (be0(W0, k$r), [0, Pe(W0), w$r]), Ir = [0, _r], fe = oi(W0, u(t[3], W0));
                  var v0 = u(M(_0, Hr), W0), P = A0(W0) === 86 ? v0 : eb(W0, v0), L = u(t[12], W0), Q = L[2], i0 = L[1];
                  if (Q) var l0 = he0(W0, Q), S0 = i0;
                  else var l0 = Q, S0 = o2(W0, i0);
                  return [0, Hr, fe, Ir, P, S0, l0, Or];
                }, o0), b = U0[2], R0 = b[4], X = b[3], s0 = b[1], hr = K(o0, _0, s0, 0, q1(R0));
                w(o0, hr[2], X, R0);
                var Ar = U0[1], or = lr([0, b[7]], 0, 0);
                return [23, [0, X, R0, hr[1], _0, s0, b[6], b[5], b[2], or, Ar]];
              }
              var g0 = 0;
              function e0(o0) {
                return cr(g0, k0, o0);
              }
              function x0(o0, w0) {
                var _0 = pr(w0);
                Y0(w0, o0);
                for (var E0 = 0, U0 = 0; ; ) {
                  var b = cr(0, function(or) {
                    var W0 = o(se[18], or, 40);
                    if (xu(or, 82)) var Lr = 0, Tr = [0, u(se[10], or)];
                    else if (W0[2][0] === 2) var Lr = 0, Tr = 0;
                    else var Lr = [0, [0, W0[1], 59]], Tr = 0;
                    return [0, [0, W0, Tr], Lr];
                  }, w0), R0 = b[2], X = R0[2], s0 = [0, [0, b[1], R0[1]], E0], hr = X ? [0, X[1], U0] : U0;
                  if (xu(w0, 9)) {
                    var E0 = s0, U0 = hr;
                    continue;
                  }
                  var Ar = ye(hr);
                  return [0, ye(s0), _0, Ar];
                }
              }
              var l = 24;
              function c0(o0) {
                return x0(l, o0);
              }
              function t0(o0) {
                var w0 = x0(27, F9(1, o0)), _0 = w0[1], E0 = w0[3], U0 = ye(le(function(b, R0) {
                  return R0[2][2] ? b : [0, [0, R0[1], 58], b];
                }, E0, _0));
                return [0, _0, w0[2], U0];
              }
              return [0, m0, f0, V, M, K, w, function(o0) {
                return x0(28, F9(1, o0));
              }, t0, c0, e0, p];
            }(mn), R9 = $ee(se), ci = function(t) {
              function n(P) {
                var L = P[2];
                switch (L[0]) {
                  case 17:
                    var Q = L[1], i0 = Q[1][2][1];
                    if (n0(i0, pQr)) {
                      if (!n0(i0, mQr)) {
                        var l0 = n0(Q[2][2][1], _Qr);
                        if (!l0) return l0;
                      }
                    } else {
                      var S0 = n0(Q[2][2][1], yQr);
                      if (!S0) return S0;
                    }
                    break;
                  case 0:
                  case 10:
                  case 16:
                  case 19:
                    break;
                  default:
                    return 0;
                }
                return 1;
              }
              var e = t[1], i = function P(L) {
                return P.fun(L);
              }, x = function P(L) {
                return P.fun(L);
              }, c = function P(L) {
                return P.fun(L);
              }, s = function P(L) {
                return P.fun(L);
              }, p = function P(L) {
                return P.fun(L);
              }, y = function P(L) {
                return P.fun(L);
              }, T = function P(L) {
                return P.fun(L);
              }, E = function P(L) {
                return P.fun(L);
              }, d = function P(L) {
                return P.fun(L);
              }, w = function P(L) {
                return P.fun(L);
              }, G = function P(L) {
                return P.fun(L);
              }, A = function P(L) {
                return P.fun(L);
              }, S = function P(L) {
                return P.fun(L);
              }, M = function P(L) {
                return P.fun(L);
              }, K = function P(L) {
                return P.fun(L);
              }, V = function P(L) {
                return P.fun(L);
              }, f0 = function P(L) {
                return P.fun(L);
              }, m0 = function P(L, Q, i0, l0, S0) {
                return P.fun(L, Q, i0, l0, S0);
              }, k0 = function P(L, Q, i0, l0) {
                return P.fun(L, Q, i0, l0);
              }, g0 = function P(L) {
                return P.fun(L);
              }, e0 = function P(L) {
                return P.fun(L);
              }, x0 = function P(L) {
                return P.fun(L);
              }, l = function P(L, Q, i0, l0, S0) {
                return P.fun(L, Q, i0, l0, S0);
              }, c0 = function P(L, Q, i0, l0) {
                return P.fun(L, Q, i0, l0);
              }, t0 = function P(L) {
                return P.fun(L);
              }, o0 = function P(L, Q, i0) {
                return P.fun(L, Q, i0);
              }, w0 = function P(L) {
                return P.fun(L);
              }, _0 = function P(L, Q, i0) {
                return P.fun(L, Q, i0);
              }, E0 = function P(L) {
                return P.fun(L);
              }, U0 = function P(L) {
                return P.fun(L);
              }, b = function P(L, Q) {
                return P.fun(L, Q);
              }, R0 = function P(L, Q, i0, l0) {
                return P.fun(L, Q, i0, l0);
              }, X = function P(L) {
                return P.fun(L);
              }, s0 = function P(L, Q, i0) {
                return P.fun(L, Q, i0);
              }, hr = function P(L) {
                return P.fun(L);
              }, Ar = function P(L) {
                return P.fun(L);
              }, or = function P(L) {
                return P.fun(L);
              }, W0 = function P(L, Q, i0) {
                return P.fun(L, Q, i0);
              }, Lr = t[2];
              function Tr(P) {
                var L = Pe(P), Q = u(y, P), i0 = u(p, P);
                if (i0) {
                  var l0 = i0[1];
                  return [0, cr([0, L], function(S0) {
                    var T0 = ur(Lr, 0, S0, Q);
                    return [2, [0, l0, T0, u(x, S0), 0]];
                  }, P)];
                }
                return Q;
              }
              function Hr(P, L) {
                if (typeof L == "number") {
                  var Q = L !== 55 ? 1 : 0;
                  if (!Q) return Q;
                }
                throw Bs;
              }
              function Or(P) {
                var L = T9(Hr, P), Q = Tr(L), i0 = A0(L);
                if (typeof i0 == "number") {
                  if (i0 === 11) throw Bs;
                  if (i0 === 86) {
                    var l0 = ue0(L), S0 = 0;
                    if (l0) {
                      var T0 = l0[1];
                      if (typeof T0 == "number" && T0 === 5) {
                        var rr = 1;
                        S0 = 1;
                      }
                    }
                    if (!S0) var rr = 0;
                    if (rr) throw Bs;
                  }
                }
                if (G1(L)) {
                  if (Q[0] === 0) {
                    var L0 = Q[1][2];
                    if (L0[0] === 10 && !n0(L0[1][2][1], bQr) && !x7(L)) throw Bs;
                  }
                  return Q;
                }
                return Q;
              }
              N(i, function(P) {
                var L = A0(P), Q = 0, i0 = G1(P);
                if (typeof L == "number") {
                  var l0 = 0;
                  if (22 <= L) if (L === 58) {
                    if (P[17]) return [0, u(c, P)];
                    l0 = 1;
                  } else L !== 98 && (l0 = 1);
                  else L !== 4 && !(21 <= L) && (l0 = 1);
                  l0 || (Q = 1);
                }
                if (!Q && !i0) return Tr(P);
                var S0 = 0;
                if (L === 64 && fu(P) && Yn(1, P) === 98) {
                  var T0 = Or, rr = or;
                  S0 = 1;
                }
                if (!S0) var T0 = or, rr = Or;
                var L0 = EL(P, rr);
                if (L0) return L0[1];
                var B = EL(P, T0);
                return B ? B[1] : Tr(P);
              }), N(x, function(P) {
                return o(e, P, u(i, P));
              }), N(c, function(P) {
                return cr(0, function(L) {
                  L[10] && je(L, 91);
                  var Q = pr(L), i0 = Pe(L);
                  Y0(L, 58);
                  var l0 = Pe(L);
                  if (x2(L)) var S0 = 0, T0 = 0;
                  else {
                    var rr = xu(L, Yt), L0 = A0(L), B = 0;
                    if (typeof L0 == "number") {
                      var Z = 0;
                      if (L0 !== 86) if (10 <= L0) Z = 1;
                      else switch (L0) {
                        case 0:
                        case 2:
                        case 3:
                        case 4:
                        case 6:
                          Z = 1;
                          break;
                      }
                      if (!Z) {
                        var p0 = 0;
                        B = 1;
                      }
                    }
                    if (!B) var p0 = 1;
                    var b0 = rr || p0, O0 = b0 && [0, u(x, L)], S0 = rr, T0 = O0;
                  }
                  var M0 = T0 ? 0 : we(L), er = yt(i0, l0);
                  return [30, [0, T0, lr([0, Q], [0, M0], 0), S0, er]];
                }, P);
              }), N(s, function(P) {
                var L = P[2];
                switch (L[0]) {
                  case 17:
                    var Q = L[1], i0 = Q[1][2][1];
                    if (n0(i0, cQr)) {
                      if (!n0(i0, sQr)) {
                        var l0 = n0(Q[2][2][1], vQr);
                        if (!l0) return l0;
                      }
                    } else {
                      var S0 = n0(Q[2][2][1], lQr);
                      if (!S0) return S0;
                    }
                    break;
                  case 10:
                  case 16:
                    break;
                  default:
                    return 0;
                }
                return 1;
              }), N(p, function(P) {
                var L = A0(P), Q = 0;
                if (typeof L == "number") {
                  var i0 = L - 67 | 0;
                  if (!(15 < i0 >>> 0)) {
                    switch (i0) {
                      case 0:
                        var l0 = KZr;
                        break;
                      case 1:
                        var l0 = WZr;
                        break;
                      case 2:
                        var l0 = JZr;
                        break;
                      case 3:
                        var l0 = $Zr;
                        break;
                      case 4:
                        var l0 = ZZr;
                        break;
                      case 5:
                        var l0 = QZr;
                        break;
                      case 6:
                        var l0 = rQr;
                        break;
                      case 7:
                        var l0 = eQr;
                        break;
                      case 8:
                        var l0 = nQr;
                        break;
                      case 9:
                        var l0 = tQr;
                        break;
                      case 10:
                        var l0 = uQr;
                        break;
                      case 11:
                        var l0 = iQr;
                        break;
                      case 12:
                        var l0 = fQr;
                        break;
                      case 13:
                        var l0 = xQr;
                        break;
                      case 14:
                        var l0 = oQr;
                        break;
                      default:
                        var l0 = aQr;
                    }
                    var S0 = l0;
                    Q = 1;
                  }
                }
                if (!Q) var S0 = 0;
                return S0 !== 0 && ie(P), S0;
              }), N(y, function(P) {
                var L = Pe(P), Q = u(E, P);
                if (A0(P) === 85) {
                  ie(P);
                  var i0 = u(x, Kl(0, P));
                  Y0(P, 86);
                  var l0 = cr(0, x, P), S0 = yt(L, l0[1]), T0 = l0[2];
                  return [0, [0, S0, [7, [0, o(e, P, Q), i0, T0, 0]]]];
                }
                return Q;
              }), N(T, function(P) {
                return o(e, P, u(y, P));
              });
              function fr(P, L, Q, i0, l0) {
                var S0 = o(e, P, L);
                return [0, [0, l0, [15, [0, i0, S0, o(e, P, Q), 0]]]];
              }
              function Rr(P, L, Q, i0) {
                for (var l0 = P, S0 = Q, T0 = i0; ; ) {
                  var rr = A0(L);
                  if (typeof rr == "number" && rr === 84) {
                    1 - l0 && je(L, zZr), Y0(L, 84);
                    var L0 = cr(0, d, L), B = L0[2], Z = L0[1], p0 = A0(L), b0 = 0;
                    if (typeof p0 == "number" && !(1 < (p0 - 87 | 0) >>> 0)) {
                      je(L, [23, oL(p0)]);
                      var O0 = Jr(L, B, Z), M0 = Wr(L, O0[2], O0[1]), er = M0[2], yr = M0[1];
                      b0 = 1;
                    }
                    if (!b0) var er = B, yr = Z;
                    var vr = yt(T0, yr), l0 = 1, S0 = fr(L, S0, er, 2, vr), T0 = vr;
                    continue;
                  }
                  return [0, T0, S0];
                }
              }
              function Wr(P, L, Q) {
                for (var i0 = L, l0 = Q; ; ) {
                  var S0 = A0(P);
                  if (typeof S0 == "number" && S0 === 87) {
                    ie(P);
                    var T0 = cr(0, d, P), rr = Jr(P, T0[2], T0[1]), L0 = yt(l0, rr[1]), B = Rr(0, P, fr(P, i0, rr[2], 0, L0), L0), i0 = B[2], l0 = B[1];
                    continue;
                  }
                  return [0, l0, i0];
                }
              }
              function Jr(P, L, Q) {
                for (var i0 = L, l0 = Q; ; ) {
                  var S0 = A0(P);
                  if (typeof S0 == "number" && S0 === 88) {
                    ie(P);
                    var T0 = cr(0, d, P), rr = yt(l0, T0[1]), L0 = Rr(0, P, fr(P, i0, T0[2], 1, rr), rr), i0 = L0[2], l0 = L0[1];
                    continue;
                  }
                  return [0, l0, i0];
                }
              }
              N(E, function(P) {
                var L = cr(0, d, P), Q = L[2], i0 = L[1], l0 = A0(P), S0 = 0;
                if (typeof l0 == "number" && l0 === 84) {
                  var rr = Rr(1, P, Q, i0);
                  S0 = 1;
                }
                if (!S0) var T0 = Jr(P, Q, i0), rr = Wr(P, T0[2], T0[1]);
                return rr[2];
              });
              function ar(P, L, Q, i0) {
                return [0, i0, [3, [0, Q, P, L, 0]]];
              }
              N(d, function(P) {
                var L = 0;
                r: for (; ; ) {
                  var Q = cr(0, function(k) {
                    var I = u(w, k) !== 0 ? 1 : 0;
                    return [0, I, u(G, Kl(0, k))];
                  }, P), i0 = Q[2], l0 = i0[2], S0 = Q[1];
                  if (A0(P) === 98) {
                    var T0 = 0;
                    l0[0] === 0 && l0[1][2][0] === 12 ? je(P, 63) : T0 = 1;
                  }
                  var rr = A0(P), L0 = 0;
                  if (typeof rr == "number") {
                    var B = rr - 17 | 0, Z = 0;
                    if (1 < B >>> 0) if (72 <= B) switch (B - 72 | 0) {
                      case 0:
                        var p0 = gZr;
                        break;
                      case 1:
                        var p0 = FZr;
                        break;
                      case 2:
                        var p0 = TZr;
                        break;
                      case 3:
                        var p0 = OZr;
                        break;
                      case 4:
                        var p0 = IZr;
                        break;
                      case 5:
                        var p0 = AZr;
                        break;
                      case 6:
                        var p0 = NZr;
                        break;
                      case 7:
                        var p0 = CZr;
                        break;
                      case 8:
                        var p0 = PZr;
                        break;
                      case 9:
                        var p0 = DZr;
                        break;
                      case 10:
                        var p0 = LZr;
                        break;
                      case 11:
                        var p0 = RZr;
                        break;
                      case 12:
                        var p0 = jZr;
                        break;
                      case 13:
                        var p0 = GZr;
                        break;
                      case 14:
                        var p0 = MZr;
                        break;
                      case 15:
                        var p0 = BZr;
                        break;
                      case 16:
                        var p0 = qZr;
                        break;
                      case 17:
                        var p0 = UZr;
                        break;
                      case 18:
                        var p0 = HZr;
                        break;
                      case 19:
                        var p0 = XZr;
                        break;
                      default:
                        Z = 1;
                    }
                    else Z = 1;
                    else var p0 = B ? YZr : P[12] ? 0 : VZr;
                    if (!Z) {
                      var b0 = p0;
                      L0 = 1;
                    }
                  }
                  if (!L0) var b0 = 0;
                  if (b0 !== 0 && ie(P), !L && !b0) return l0;
                  if (b0) {
                    var O0 = b0[1], M0 = O0[1], er = i0[1], yr = er && (M0 === 14 ? 1 : 0);
                    yr && ue(P, [0, S0, 27]);
                    for (var vr = o(e, P, l0), $0 = vr, Er = [0, M0, O0[2]], Mr = S0, Br = L; ; ) {
                      var qr = Er[2], jr = Er[1];
                      if (Br) {
                        var $r = Br[1], ne = $r[2], Qr = ne[2], be = Qr[0] === 0 ? Qr[1] : Qr[1] - 1 | 0;
                        if (qr[1] <= be) {
                          var ae = yt($r[3], Mr), pe = ar($r[1], $0, ne[1], ae), $0 = pe, Er = [0, jr, qr], Mr = ae, Br = Br[2];
                          continue;
                        }
                      }
                      var L = [0, [0, $0, [0, jr, qr], Mr], Br];
                      continue r;
                    }
                  }
                  for (var oe = o(e, P, l0), ce = S0, ge = L; ; ) {
                    if (ge) {
                      var q0 = ge[1], Fr = yt(q0[3], ce), _ = ge[2], oe = ar(q0[1], oe, q0[2][1], Fr), ce = Fr, ge = _;
                      continue;
                    }
                    return [0, oe];
                  }
                }
              }), N(w, function(P) {
                var L = A0(P);
                if (typeof L == "number") {
                  if (48 <= L) {
                    if (s7 <= L) {
                      if (!(cf <= L)) switch (L - 103 | 0) {
                        case 0:
                          return _Zr;
                        case 1:
                          return yZr;
                        case 6:
                          return hZr;
                        case 7:
                          return dZr;
                      }
                    } else if (L === 65 && P[18]) return kZr;
                  } else if (45 <= L) switch (L + mv | 0) {
                    case 0:
                      return wZr;
                    case 1:
                      return EZr;
                    default:
                      return SZr;
                  }
                }
                return 0;
              }), N(G, function(P) {
                var L = Pe(P), Q = pr(P), i0 = u(w, P);
                if (i0) {
                  var l0 = i0[1];
                  ie(P);
                  var S0 = cr(0, A, P), T0 = S0[2], rr = yt(L, S0[1]), L0 = 0;
                  if (l0 === 6) {
                    var B = T0[2], Z = 0;
                    switch (B[0]) {
                      case 10:
                        V7(P, [0, rr, 47]);
                        break;
                      case 16:
                        B[1][2][0] === 1 && ue(P, [0, rr, 88]);
                        break;
                      default:
                        Z = 1;
                    }
                    Z || (L0 = 1);
                  }
                  return [0, [0, rr, [28, [0, l0, T0, lr([0, Q], 0, 0)]]]];
                }
                var p0 = A0(P), b0 = 0;
                if (typeof p0 == "number") if (cf === p0) var O0 = mZr;
                else if (T7 === p0) var O0 = pZr;
                else b0 = 1;
                else b0 = 1;
                if (b0) var O0 = 0;
                if (O0) {
                  ie(P);
                  var M0 = cr(0, A, P), er = M0[2];
                  1 - u(s, er) && ue(P, [0, er[1], 26]);
                  var yr = er[2], vr = 0;
                  yr[0] === 10 && js(yr[1][2][1]) && (gi(P, 54), vr = 1);
                  var $0 = yt(L, M0[1]), Er = lr([0, Q], 0, 0);
                  return [0, [0, $0, [29, [0, O0[1], er, 1, Er]]]];
                }
                return u(S, P);
              }), N(A, function(P) {
                return o(e, P, u(G, P));
              }), N(S, function(P) {
                var L = u(M, P);
                if (x7(P)) return L;
                var Q = A0(P), i0 = 0;
                if (typeof Q == "number") if (cf === Q) var l0 = bZr;
                else if (T7 === Q) var l0 = lZr;
                else i0 = 1;
                else i0 = 1;
                if (i0) var l0 = 0;
                if (l0) {
                  var S0 = o(e, P, L);
                  1 - u(s, S0) && ue(P, [0, S0[1], 26]);
                  var T0 = S0[2], rr = 0;
                  T0[0] === 10 && js(T0[1][2][1]) && (gi(P, 53), rr = 1);
                  var L0 = Pe(P);
                  ie(P);
                  var B = we(P), Z = yt(S0[1], L0), p0 = lr(0, [0, B], 0);
                  return [0, [0, Z, [29, [0, l0[1], S0, 0, p0]]]];
                }
                return L;
              }), N(M, function(P) {
                var L = Pe(P), Q = 1 - P[16], i0 = 0, l0 = P[16] === 0 ? P : [0, P[1], P[2], P[3], P[4], P[5], P[6], P[7], P[8], P[9], P[10], P[11], P[12], P[13], P[14], P[15], i0, P[17], P[18], P[19], P[20], P[21], P[22], P[23], P[24], P[25], P[26], P[27], P[28], P[29], P[30]], S0 = A0(l0), T0 = 0;
                if (typeof S0 == "number") {
                  var rr = S0 - 44 | 0;
                  if (!(7 < rr >>> 0)) {
                    var L0 = 0;
                    switch (rr) {
                      case 0:
                        if (Q) var B = [0, u(g0, l0)];
                        else L0 = 1;
                        break;
                      case 6:
                        var B = [0, u(f0, l0)];
                        break;
                      case 7:
                        var B = [0, u(V, l0)];
                        break;
                      default:
                        L0 = 1;
                    }
                    if (!L0) {
                      var Z = B;
                      T0 = 1;
                    }
                  }
                }
                if (!T0) var Z = Gs(l0) ? [0, u(t0, l0)] : u(E0, l0);
                return p7(m0, 0, 0, l0, L, Z);
              }), N(K, function(P) {
                return o(e, P, u(M, P));
              }), N(V, function(P) {
                switch (P[21]) {
                  case 0:
                    var L = 0, Q = 0;
                    break;
                  case 1:
                    var L = 0, Q = 1;
                    break;
                  default:
                    var L = 1, Q = 1;
                }
                var i0 = Pe(P), l0 = pr(P);
                Y0(P, 51);
                var S0 = [0, i0, [23, [0, lr([0, l0], [0, we(P)], 0)]]], T0 = A0(P);
                if (typeof T0 == "number" && !(11 <= T0)) switch (T0) {
                  case 4:
                    var rr = L ? S0 : (ue(P, [0, i0, 5]), [0, i0, [10, Rc(0, [0, i0, oZr])]]);
                    return R(k0, aZr, P, i0, rr);
                  case 6:
                  case 10:
                    var L0 = Q ? S0 : (ue(P, [0, i0, 4]), [0, i0, [10, Rc(0, [0, i0, sZr])]]);
                    return R(k0, vZr, P, i0, L0);
                }
                return Q ? St(cZr, P) : ue(P, [0, i0, 4]), S0;
              }), N(f0, function(P) {
                return cr(0, function(L) {
                  var Q = pr(L), i0 = Pe(L);
                  if (Y0(L, 50), xu(L, 10)) {
                    var l0 = Rc(0, [0, i0, iZr]), S0 = Pe(L);
                    Zl(L, fZr);
                    var T0 = Rc(0, [0, S0, xZr]);
                    return [17, [0, l0, T0, lr([0, Q], [0, we(L)], 0)]];
                  }
                  var rr = pr(L);
                  Y0(L, 4);
                  var L0 = ur(s0, [0, rr], 0, u(x, Kl(0, L)));
                  return Y0(L, 5), [11, [0, L0, lr([0, Q], [0, we(L)], 0)]];
                }, P);
              }), N(m0, function(P, L, Q, i0, l0) {
                var S0 = P ? P[1] : 1, T0 = L && L[1], rr = p7(l, [0, S0], [0, T0], Q, i0, l0), L0 = ue0(Q), B = 0;
                if (L0) {
                  var Z = L0[1];
                  if (typeof Z == "number" && Z === 83) {
                    var p0 = 1;
                    B = 1;
                  }
                }
                if (!B) var p0 = 0;
                function b0(vr) {
                  var $0 = $t(vr);
                  function Er(Br, qr) {
                    return o(Qe(Br, Di, 78), Br, qr);
                  }
                  var Mr = o(e, vr, rr);
                  return o($0[2], Mr, Er);
                }
                function O0(vr, $0, Er) {
                  var Mr = u(x0, $0), Br = Mr[1], qr = yt(i0, Br), jr = [0, Er, vr, [0, Br, Mr[2]], 0], $r = 0;
                  if (!p0 && !T0) {
                    var ne = [4, jr];
                    $r = 1;
                  }
                  if (!$r) var ne = [20, [0, jr, qr, p0]];
                  var Qr = T0 || p0;
                  return p7(m0, [0, S0], [0, Qr], $0, i0, [0, [0, qr, ne]]);
                }
                if (Q[13]) return rr;
                var M0 = A0(Q);
                if (typeof M0 == "number") {
                  var er = M0 - 98 | 0;
                  if (2 < er >>> 0) {
                    if (er === -94) return O0(0, Q, b0(Q));
                  } else if (er !== 1 && fu(Q)) {
                    var yr = T9(function(vr, $0) {
                      throw Bs;
                    }, Q);
                    return _e0(yr, rr, function(vr) {
                      var $0 = b0(vr);
                      return O0(u(e0, vr), vr, $0);
                    });
                  }
                }
                return rr;
              }), N(k0, function(P, L, Q, i0) {
                var l0 = P ? P[1] : 1;
                return o(e, L, p7(m0, [0, l0], 0, L, Q, [0, i0]));
              }), N(g0, function(P) {
                return cr(0, function(L) {
                  var Q = Pe(L), i0 = pr(L);
                  if (Y0(L, 44), L[11] && A0(L) === 10) {
                    var l0 = we(L);
                    ie(L);
                    var S0 = Rc(lr([0, i0], [0, l0], 0), [0, Q, eZr]), T0 = A0(L);
                    return typeof T0 != "number" && T0[0] === 4 && !n0(T0[3], nZr) ? [17, [0, S0, o(se[13], 0, L), 0]] : (St(tZr, L), ie(L), [10, S0]);
                  }
                  var rr = Pe(L), L0 = A0(L), B = 0;
                  if (typeof L0 == "number") if (L0 === 44) var Z = u(g0, L);
                  else if (L0 === 51) var Z = u(V, _L(1, L));
                  else B = 1;
                  else B = 1;
                  if (B) var Z = Gs(L) ? u(t0, L) : u(U0, L);
                  var p0 = R(c0, uZr, _L(1, L), rr, Z), b0 = A0(L), O0 = 0;
                  if (typeof b0 != "number" && b0[0] === 3) {
                    var M0 = R(R0, L, rr, p0, b0[1]);
                    O0 = 1;
                  }
                  if (!O0) var M0 = p0;
                  var er = 0;
                  if (A0(L) !== 4) {
                    var yr = 0;
                    if (fu(L) && A0(L) === 98 && (yr = 1), !yr) {
                      var Er = M0;
                      er = 1;
                    }
                  }
                  if (!er) var vr = $t(L), $0 = function(ne, Qr) {
                    return o(Qe(ne, Di, 79), ne, Qr);
                  }, Er = o(vr[2], M0, $0);
                  var Mr = fu(L), Br = Mr && _e0(T9(function(ne, Qr) {
                    throw Bs;
                  }, L), 0, e0), qr = A0(L), jr = 0;
                  if (typeof qr == "number" && qr === 4) {
                    var $r = [0, u(x0, L)];
                    jr = 1;
                  }
                  if (!jr) var $r = 0;
                  return [18, [0, Er, Br, $r, lr([0, i0], 0, 0)]];
                }, P);
              });
              function _r(P) {
                var L = pr(P);
                Y0(P, 98);
                for (var Q = 0; ; ) {
                  var i0 = A0(P);
                  if (typeof i0 == "number") {
                    var l0 = 0;
                    if ((i0 === 99 || Pn === i0) && (l0 = 1), l0) {
                      var S0 = ye(Q), T0 = pr(P);
                      Y0(P, 99);
                      var rr = A0(P) === 4 ? $t(P)[1] : we(P);
                      return [0, S0, yu([0, L], [0, rr], T0, 0)];
                    }
                  }
                  var L0 = A0(P), B = 0;
                  if (typeof L0 != "number" && L0[0] === 4 && !n0(L0[2], Q$r)) {
                    var Z = Pe(P), p0 = pr(P);
                    Zl(P, rZr);
                    var b0 = [1, [0, Z, [0, lr([0, p0], [0, we(P)], 0)]]];
                    B = 1;
                  }
                  if (!B) var b0 = [0, u(mn[1], P)];
                  var O0 = [0, b0, Q];
                  A0(P) !== 99 && Y0(P, 9);
                  var Q = O0;
                }
              }
              N(e0, function(P) {
                Ku(P, 1);
                var L = A0(P) === 98 ? 1 : 0, Q = L && [0, cr(0, _r, P)];
                return k7(P), Q;
              });
              function Ir(P) {
                var L = pr(P);
                Y0(P, 12);
                var Q = u(x, P);
                return [0, Q, lr([0, L], 0, 0)];
              }
              N(x0, function(P) {
                return cr(0, function(L) {
                  var Q = pr(L);
                  Y0(L, 4);
                  for (var i0 = 0; ; ) {
                    var l0 = A0(L);
                    if (typeof l0 == "number") {
                      var S0 = 0;
                      if ((l0 === 5 || Pn === l0) && (S0 = 1), S0) {
                        var T0 = ye(i0), rr = pr(L);
                        return Y0(L, 5), [0, T0, yu([0, Q], [0, we(L)], rr, 0)];
                      }
                    }
                    var L0 = A0(L), B = 0;
                    if (typeof L0 == "number" && L0 === 12) {
                      var Z = [1, cr(0, Ir, L)];
                      B = 1;
                    }
                    if (!B) var Z = [0, u(x, L)];
                    var p0 = [0, Z, i0];
                    A0(L) !== 5 && Y0(L, 9);
                    var i0 = p0;
                  }
                }, P);
              }), N(l, function(P, L, Q, i0, l0) {
                var S0 = P ? P[1] : 1, T0 = L && L[1], rr = A0(Q), L0 = 0;
                if (typeof rr == "number") switch (rr) {
                  case 6:
                    ie(Q);
                    var B = 0, Z = [0, T0], p0 = [0, S0];
                    L0 = 2;
                    break;
                  case 10:
                    ie(Q);
                    var b0 = 0, O0 = [0, T0], M0 = [0, S0];
                    L0 = 1;
                    break;
                  case 83:
                    1 - S0 && je(Q, 99), Y0(Q, 83);
                    var er = 0, yr = A0(Q);
                    if (typeof yr == "number") switch (yr) {
                      case 4:
                        return l0;
                      case 6:
                        ie(Q);
                        var B = K$r, Z = W$r, p0 = [0, S0];
                        L0 = 2, er = 1;
                        break;
                      case 98:
                        if (fu(Q)) return l0;
                        break;
                    }
                    else if (yr[0] === 3) return je(Q, ti), l0;
                    if (!er) {
                      var b0 = J$r, O0 = $$r, M0 = [0, S0];
                      L0 = 1;
                    }
                    break;
                }
                else if (rr[0] === 3) {
                  T0 && je(Q, ti);
                  var vr = rr[1];
                  return p7(m0, Z$r, 0, Q, i0, [0, R(R0, Q, i0, o(e, Q, l0), vr)]);
                }
                switch (L0) {
                  case 0:
                    return l0;
                  case 1:
                    var $0 = M0 ? S0 : 1, Er = O0 && O0[1], Mr = b0 && b0[1], Br = A0(Q), qr = 0;
                    if (typeof Br == "number" && Br === 14) {
                      var jr = ge0(Q), $r = jr[1], ne = Q[29][1], Qr = jr[2][1];
                      if (ne) {
                        var be = ne[1];
                        Q[29][1] = [0, [0, be[1], [0, [0, Qr, $r], be[2]]], ne[2]];
                      } else ue(Q, [0, $r, 89]);
                      var pe = [1, jr], oe = $r;
                      qr = 1;
                    }
                    if (!qr) var ae = z7(Q), pe = [0, ae], oe = ae[1];
                    var ce = yt(i0, oe), ge = 0;
                    l0[0] === 0 && l0[1][2][0] === 23 && pe[0] === 1 && (ue(Q, [0, ce, 90]), ge = 1);
                    var q0 = [0, o(e, Q, l0), pe, 0], Fr = Er ? [21, [0, q0, ce, Mr]] : [16, q0];
                    return p7(m0, [0, $0], [0, Er], Q, i0, [0, [0, ce, Fr]]);
                  default:
                    var _ = p0 ? S0 : 1, k = Z && Z[1], I = B && B[1], U = _L(0, Q), Y = u(se[7], U), y0 = Pe(Q);
                    Y0(Q, 7);
                    var P0 = we(Q), I0 = yt(i0, y0), D = lr(0, [0, P0], 0), u0 = [0, o(e, Q, l0), [2, Y], D], X0 = k ? [21, [0, u0, I0, I]] : [16, u0];
                    return p7(m0, [0, _], [0, k], Q, i0, [0, [0, I0, X0]]);
                }
              }), N(c0, function(P, L, Q, i0) {
                var l0 = P ? P[1] : 1;
                return o(e, L, p7(l, [0, l0], 0, L, Q, [0, i0]));
              }), N(t0, function(P) {
                return cr(0, function(L) {
                  var Q = u(Vn[1], L), i0 = Q[1], l0 = Q[2], S0 = cr(0, function(M0) {
                    var er = pr(M0);
                    Y0(M0, 15);
                    var yr = u(Vn[2], M0), vr = yr[1], $0 = pl([0, l0, [0, er, [0, yr[2], 0]]]);
                    if (A0(M0) === 4) var Er = 0, Mr = 0;
                    else {
                      var Br = A0(M0), qr = 0;
                      if (typeof Br == "number") {
                        var jr = Br !== 98 ? 1 : 0;
                        if (!jr) {
                          var ne = jr;
                          qr = 1;
                        }
                      }
                      if (!qr) var $r = mL(vr, re0(i0, M0)), ne = [0, ys($r, o(se[13], z$r, $r))];
                      var Er = oi(M0, u(mn[3], M0)), Mr = ne;
                    }
                    var Qr = t2(0, M0), be = ur(Vn[4], i0, vr, Qr), ae = A0(Qr) === 86 ? be : eb(Qr, be), pe = u(mn[12], Qr), oe = pe[2], ce = pe[1];
                    if (oe) var ge = he0(Qr, oe), q0 = ce;
                    else var ge = oe, q0 = o2(Qr, ce);
                    return [0, Mr, ae, vr, ge, q0, Er, $0];
                  }, L), T0 = S0[2], rr = T0[3], L0 = T0[2], B = T0[1], Z = q1(L0), p0 = p7(Vn[5], L, i0, rr, 1, Z);
                  R(Vn[6], L, p0[2], B, L0);
                  var b0 = S0[1], O0 = lr([0, T0[7]], 0, 0);
                  return [8, [0, B, L0, p0[1], i0, rr, T0[4], T0[5], T0[6], O0, b0]];
                }, P);
              }), N(o0, function(P, L, Q) {
                switch (L) {
                  case 1:
                    gi(P, 45);
                    try {
                      var i0 = jv(Rv(Te(U$r, Q))), l0 = i0;
                    } catch (L0) {
                      if (L0 = Et(L0), L0[1] !== q7) throw L0;
                      var l0 = ke(Te(H$r, Q));
                    }
                    break;
                  case 2:
                    gi(P, 46);
                    try {
                      var S0 = ol(Q), l0 = S0;
                    } catch (L0) {
                      if (L0 = Et(L0), L0[1] !== q7) throw L0;
                      var l0 = ke(Te(X$r, Q));
                    }
                    break;
                  case 4:
                    try {
                      var T0 = ol(Q), l0 = T0;
                    } catch (L0) {
                      if (L0 = Et(L0), L0[1] !== q7) throw L0;
                      var l0 = ke(Te(Y$r, Q));
                    }
                    break;
                  default:
                    try {
                      var rr = jv(Rv(Q)), l0 = rr;
                    } catch (L0) {
                      if (L0 = Et(L0), L0[1] !== q7) throw L0;
                      var l0 = ke(Te(V$r, Q));
                    }
                }
                return Y0(P, [0, L, Q]), l0;
              }), N(w0, function(P) {
                var L = un(P);
                return L !== 0 && Xt === It(P, L - 1 | 0) ? m7(P, 0, L - 1 | 0) : P;
              }), N(_0, function(P, L, Q) {
                if (2 <= L) {
                  var i0 = u(w0, Q);
                  try {
                    var l0 = ol(i0), S0 = l0;
                  } catch (Z) {
                    if (Z = Et(Z), Z[1] !== q7) throw Z;
                    var S0 = ke(Te(B$r, i0));
                  }
                  var T0 = S0;
                } else {
                  var rr = u(w0, Q);
                  try {
                    var L0 = jv(Rv(rr)), B = L0;
                  } catch (p0) {
                    if (p0 = Et(p0), p0[1] !== q7) throw p0;
                    var B = ke(Te(q$r, rr));
                  }
                  var T0 = B;
                }
                return Y0(P, [1, L, Q]), T0;
              }), N(E0, function(P) {
                var L = Pe(P), Q = pr(P), i0 = A0(P);
                if (typeof i0 == "number") switch (i0) {
                  case 0:
                    var l0 = u(se[12], P);
                    return [1, [0, l0[1], [19, l0[2]]], l0[3]];
                  case 4:
                    return [0, u(X, P)];
                  case 6:
                    var S0 = cr(0, hr, P), T0 = S0[2];
                    return [1, [0, S0[1], [0, T0[1]]], T0[2]];
                  case 21:
                    return ie(P), [0, [0, L, [26, [0, lr([0, Q], [0, we(P)], 0)]]]];
                  case 29:
                    return ie(P), [0, [0, L, [14, [0, 0, R$r, lr([0, Q], [0, we(P)], 0)]]]];
                  case 40:
                    return [0, u(se[22], P)];
                  case 98:
                    var rr = u(se[17], P), L0 = rr[2], B = rr[1], Z = Ni <= L0[1] ? [13, L0[2]] : [12, L0[2]];
                    return [0, [0, B, Z]];
                  case 30:
                  case 31:
                    ie(P);
                    var p0 = i0 === 31 ? 1 : 0, b0 = p0 ? G$r : M$r;
                    return [0, [0, L, [14, [0, [1, p0], b0, lr([0, Q], [0, we(P)], 0)]]]];
                  case 74:
                  case 105:
                    return [0, u(Ar, P)];
                }
                else switch (i0[0]) {
                  case 0:
                    var O0 = i0[2], M0 = [2, ur(o0, P, i0[1], O0)];
                    return [0, [0, L, [14, [0, M0, O0, lr([0, Q], [0, we(P)], 0)]]]];
                  case 1:
                    var er = i0[2], yr = [3, ur(_0, P, i0[1], er)];
                    return [0, [0, L, [14, [0, yr, er, lr([0, Q], [0, we(P)], 0)]]]];
                  case 2:
                    var vr = i0[1];
                    vr[4] && gi(P, 45), ie(P);
                    var $0 = [0, vr[2]], Er = lr([0, Q], [0, we(P)], 0);
                    return [0, [0, vr[1], [14, [0, $0, vr[3], Er]]]];
                  case 3:
                    var Mr = o(b, P, i0[1]);
                    return [0, [0, Mr[1], [25, Mr[2]]]];
                }
                if (G1(P)) {
                  var Br = o(se[13], 0, P);
                  return [0, [0, Br[1], [10, Br]]];
                }
                St(0, P);
                var qr = 0;
                return typeof i0 != "number" && i0[0] === 6 && (ie(P), qr = 1), [0, [0, L, [14, [0, 0, j$r, lr([0, Q], [0, 0], 0)]]]];
              }), N(U0, function(P) {
                return o(e, P, u(E0, P));
              }), N(b, function(P, L) {
                var Q = L[3], i0 = L[2], l0 = L[1], S0 = pr(P);
                Y0(P, [3, L]);
                var T0 = [0, l0, [0, [0, i0[2], i0[1]], Q]];
                if (Q) var rr = 0, L0 = [0, T0, 0], B = l0;
                else for (var Z = [0, T0, 0], p0 = 0; ; ) {
                  var b0 = u(se[7], P), O0 = [0, b0, p0], M0 = A0(P), er = 0;
                  if (typeof M0 == "number" && M0 === 1) {
                    Ku(P, 4);
                    var yr = A0(P), vr = 0;
                    if (typeof yr != "number" && yr[0] === 3) {
                      var $0 = yr[1], Er = $0[3], Mr = $0[2], Br = $0[1];
                      ie(P);
                      var qr = [0, [0, Mr[2], Mr[1]], Er];
                      k7(P);
                      var jr = [0, [0, Br, qr], Z];
                      if (!Er) {
                        var Z = jr, p0 = O0;
                        continue;
                      }
                      var $r = ye(O0), ne = [0, Br, ye(jr), $r];
                      er = 1, vr = 1;
                    }
                    if (!vr) throw [0, Sn, P$r];
                  }
                  if (!er) {
                    St(D$r, P);
                    var Qr = [0, b0[1], L$r], be = ye(O0), ae = ye([0, Qr, Z]), ne = [0, b0[1], ae, be];
                  }
                  var rr = ne[3], L0 = ne[2], B = ne[1];
                  break;
                }
                var pe = we(P), oe = yt(l0, B);
                return [0, oe, [0, L0, rr, lr([0, S0], [0, pe], 0)]];
              }), N(R0, function(P, L, Q, i0) {
                var l0 = $t(P);
                function S0(L0, B) {
                  return o(Qe(L0, Di, 28), L0, B);
                }
                var T0 = o(l0[2], Q, S0), rr = o(b, P, i0);
                return [0, yt(L, rr[1]), [24, [0, T0, rr, 0]]];
              }), N(X, function(P) {
                var L = pr(P), Q = cr(0, function(T0) {
                  Y0(T0, 4);
                  var rr = Pe(T0), L0 = u(x, T0), B = A0(T0), Z = 0;
                  if (typeof B == "number") if (B === 9) var p0 = [0, ur(W0, T0, rr, [0, L0, 0])];
                  else if (B === 86) var p0 = [1, [0, L0, u(mn[9], T0), 0]];
                  else Z = 1;
                  else Z = 1;
                  if (Z) var p0 = [0, L0];
                  return Y0(T0, 5), p0;
                }, P), i0 = Q[2], l0 = we(P), S0 = i0[0] === 0 ? i0[1] : [0, Q[1], [27, i0[1]]];
                return ur(s0, [0, L], [0, l0], S0);
              }), N(s0, function(P, L, Q) {
                var i0 = Q[2], l0 = P && P[1], S0 = L && L[1];
                function T0(Je) {
                  return y7(Je, lr([0, l0], [0, S0], 0));
                }
                function rr(Je) {
                  return JD(Je, lr([0, l0], [0, S0], 0));
                }
                switch (i0[0]) {
                  case 0:
                    var L0 = i0[1], B = rr(L0[2]), Ne = [0, [0, L0[1], B]];
                    break;
                  case 1:
                    var Z = i0[1], p0 = Z[10], b0 = T0(Z[9]), Ne = [1, [0, Z[1], Z[2], Z[3], Z[4], Z[5], Z[6], Z[7], Z[8], b0, p0]];
                    break;
                  case 2:
                    var O0 = i0[1], M0 = T0(O0[4]), Ne = [2, [0, O0[1], O0[2], O0[3], M0]];
                    break;
                  case 3:
                    var er = i0[1], yr = T0(er[4]), Ne = [3, [0, er[1], er[2], er[3], yr]];
                    break;
                  case 4:
                    var vr = i0[1], $0 = T0(vr[4]), Ne = [4, [0, vr[1], vr[2], vr[3], $0]];
                    break;
                  case 5:
                    var Er = i0[1], Mr = T0(Er[7]), Ne = [5, [0, Er[1], Er[2], Er[3], Er[4], Er[5], Er[6], Mr]];
                    break;
                  case 7:
                    var Br = i0[1], qr = T0(Br[4]), Ne = [7, [0, Br[1], Br[2], Br[3], qr]];
                    break;
                  case 8:
                    var jr = i0[1], $r = jr[10], ne = T0(jr[9]), Ne = [8, [0, jr[1], jr[2], jr[3], jr[4], jr[5], jr[6], jr[7], jr[8], ne, $r]];
                    break;
                  case 10:
                    var Qr = i0[1], be = Qr[2], ae = T0(be[2]), Ne = [10, [0, Qr[1], [0, be[1], ae]]];
                    break;
                  case 11:
                    var pe = i0[1], oe = T0(pe[2]), Ne = [11, [0, pe[1], oe]];
                    break;
                  case 12:
                    var ce = i0[1], ge = T0(ce[4]), Ne = [12, [0, ce[1], ce[2], ce[3], ge]];
                    break;
                  case 13:
                    var q0 = i0[1], Fr = T0(q0[4]), Ne = [13, [0, q0[1], q0[2], q0[3], Fr]];
                    break;
                  case 14:
                    var _ = i0[1], k = T0(_[3]), Ne = [14, [0, _[1], _[2], k]];
                    break;
                  case 15:
                    var I = i0[1], U = T0(I[4]), Ne = [15, [0, I[1], I[2], I[3], U]];
                    break;
                  case 16:
                    var Y = i0[1], y0 = T0(Y[3]), Ne = [16, [0, Y[1], Y[2], y0]];
                    break;
                  case 17:
                    var P0 = i0[1], I0 = T0(P0[3]), Ne = [17, [0, P0[1], P0[2], I0]];
                    break;
                  case 18:
                    var D = i0[1], u0 = T0(D[4]), Ne = [18, [0, D[1], D[2], D[3], u0]];
                    break;
                  case 19:
                    var X0 = i0[1], J0 = rr(X0[2]), Ne = [19, [0, X0[1], J0]];
                    break;
                  case 20:
                    var ir = i0[1], Q0 = ir[1], F0 = ir[3], Sr = ir[2], mr = T0(Q0[4]), Ne = [20, [0, [0, Q0[1], Q0[2], Q0[3], mr], Sr, F0]];
                    break;
                  case 21:
                    var Cr = i0[1], sr = Cr[1], Pr = Cr[3], K0 = Cr[2], Ur = T0(sr[3]), Ne = [21, [0, [0, sr[1], sr[2], Ur], K0, Pr]];
                    break;
                  case 22:
                    var h0 = i0[1], Kr = T0(h0[2]), Ne = [22, [0, h0[1], Kr]];
                    break;
                  case 23:
                    var Ne = [23, [0, T0(i0[1][1])]];
                    break;
                  case 24:
                    var re = i0[1], xe = T0(re[3]), Ne = [24, [0, re[1], re[2], xe]];
                    break;
                  case 25:
                    var Re = i0[1], ve = T0(Re[3]), Ne = [25, [0, Re[1], Re[2], ve]];
                    break;
                  case 26:
                    var Ne = [26, [0, T0(i0[1][1])]];
                    break;
                  case 27:
                    var Ie = i0[1], Ge = T0(Ie[3]), Ne = [27, [0, Ie[1], Ie[2], Ge]];
                    break;
                  case 28:
                    var Me = i0[1], an = T0(Me[3]), Ne = [28, [0, Me[1], Me[2], an]];
                    break;
                  case 29:
                    var We = i0[1], Ae = T0(We[4]), Ne = [29, [0, We[1], We[2], We[3], Ae]];
                    break;
                  case 30:
                    var cn = i0[1], rn = cn[4], kn = cn[3], vn = T0(cn[2]), Ne = [30, [0, cn[1], vn, kn, rn]];
                    break;
                  default:
                    var Ne = i0;
                }
                return [0, Q[1], Ne];
              }), N(hr, function(P) {
                var L = pr(P);
                Y0(P, 6);
                for (var Q = [0, 0, t[3]]; ; ) {
                  var i0 = Q[2], l0 = Q[1], S0 = A0(P);
                  if (typeof S0 == "number") {
                    var T0 = 0;
                    if (13 <= S0) Pn === S0 && (T0 = 1);
                    else if (7 <= S0) switch (S0 - 7 | 0) {
                      case 2:
                        var rr = Pe(P);
                        ie(P);
                        var Q = [0, [0, [2, rr], l0], i0];
                        continue;
                      case 5:
                        var L0 = pr(P), B = cr(0, function(Qr) {
                          ie(Qr);
                          var be = u(i, Qr);
                          return be[0] === 0 ? [0, be[1], t[3]] : [0, be[1], be[2]];
                        }, P), Z = B[2], p0 = Z[2], b0 = B[1], O0 = lr([0, L0], 0, 0), M0 = [1, [0, b0, [0, Z[1], O0]]], er = A0(P) === 7 ? 1 : 0, yr = 0;
                        if (!er && Yn(1, P) === 7) {
                          var vr = [0, p0[1], [0, [0, b0, 65], p0[2]]];
                          yr = 1;
                        }
                        if (!yr) var vr = p0;
                        1 - er && Y0(P, 9);
                        var Q = [0, [0, M0, l0], o(t[5], vr, i0)];
                        continue;
                      case 0:
                        T0 = 1;
                        break;
                    }
                    if (T0) {
                      var $0 = u(t[6], i0), Er = ye(l0), Mr = pr(P);
                      return Y0(P, 7), [0, [0, Er, yu([0, L], [0, we(P)], Mr, 0)], $0];
                    }
                  }
                  var Br = u(i, P);
                  if (Br[0] === 0) var qr = t[3], jr = Br[1];
                  else var qr = Br[2], jr = Br[1];
                  A0(P) !== 7 && Y0(P, 9);
                  var Q = [0, [0, [0, jr], l0], o(t[5], qr, i0)];
                }
              }), N(Ar, function(P) {
                Ku(P, 5);
                var L = Pe(P), Q = pr(P), i0 = A0(P), l0 = 0;
                if (typeof i0 != "number" && i0[0] === 5) {
                  var S0 = i0[3], T0 = i0[2];
                  ie(P);
                  var rr = we(P), L0 = rr, B = S0, Z = T0, p0 = Te(O$r, Te(T0, Te(T$r, S0)));
                  l0 = 1;
                }
                if (!l0) {
                  St(I$r, P);
                  var L0 = 0, B = A$r, Z = N$r, p0 = C$r;
                }
                k7(P);
                var b0 = $n(un(B)), O0 = un(B) - 1 | 0, M0 = 0;
                if (!(O0 < 0)) for (var er = M0; ; ) {
                  var yr = Vr(B, er), vr = yr - 100 | 0, $0 = 0;
                  if (!(21 < vr >>> 0)) switch (vr) {
                    case 0:
                    case 3:
                    case 5:
                    case 9:
                    case 15:
                    case 17:
                    case 21:
                      qi(b0, yr), $0 = 1;
                      break;
                  }
                  var Er = er + 1 | 0;
                  if (O0 !== er) {
                    var er = Er;
                    continue;
                  }
                  break;
                }
                var Mr = Mt(b0);
                return n0(Mr, B) && je(P, [13, B]), [0, L, [14, [0, [4, [0, Z, Mr]], p0, lr([0, Q], [0, L0], 0)]]];
              });
              function fe(P, L) {
                if (typeof L == "number") {
                  var Q = 0;
                  if (61 <= L) {
                    var i0 = L - 64 | 0;
                    27 < i0 >>> 0 ? i0 === 43 && (Q = 1) : 25 < (i0 - 1 | 0) >>> 0 && (Q = 1);
                  } else {
                    var l0 = L + _y | 0;
                    17 < l0 >>> 0 ? -1 <= l0 && (Q = 1) : l0 === 13 && (Q = 1);
                  }
                  if (Q) return 0;
                }
                throw Bs;
              }
              function v0(P) {
                var L = A0(P);
                if (typeof L == "number" && !L) {
                  var Q = o(se[16], 1, P);
                  return [0, [0, Q[1]], Q[2]];
                }
                return [0, [1, u(se[10], P)], 0];
              }
              return N(or, function(P) {
                var L = T9(fe, P), Q = Pe(L);
                if (Yn(1, L) === 11) var l0 = 0, S0 = 0;
                else var i0 = u(Vn[1], L), l0 = i0[2], S0 = i0[1];
                var T0 = cr(0, function(ne) {
                  var Qr = oi(ne, u(mn[3], ne));
                  if (G1(ne) && Qr === 0) {
                    var be = o(se[13], F$r, ne), ae = be[1], pe = [0, ae, [0, [0, ae, [2, [0, be, [0, j1(ne)], 0]]], 0]];
                    return [0, Qr, [0, ae, [0, 0, [0, pe, 0], 0, 0]], [0, [0, ae[1], ae[3], ae[3]]], 0];
                  }
                  var oe = ur(Vn[4], ne[18], ne[17], ne), ce = u2(1, ne), ge = u(mn[12], ce);
                  return [0, Qr, oe, ge[1], ge[2]];
                }, L), rr = T0[2], L0 = rr[2], B = L0[2], Z = 0;
                if (!B[1]) {
                  var p0 = 0;
                  if (!B[3] && B[2] && (p0 = 1), !p0) {
                    var b0 = ie0(L);
                    Z = 1;
                  }
                }
                if (!Z) var b0 = L;
                var O0 = L0[2], M0 = O0[1], er = M0 ? (ue(b0, [0, M0[1][1], Zc]), [0, L0[1], [0, 0, O0[2], O0[3], O0[4]]]) : L0, yr = q1(er), vr = x7(b0), $0 = vr && (A0(b0) === 11 ? 1 : 0);
                $0 && je(b0, 60), Y0(b0, 11);
                var Er = fe0(ie0(b0), S0, 0, yr), Mr = cr(0, v0, Er), Br = Mr[2];
                R(Vn[6], Er, Br[2], 0, er);
                var qr = yt(Q, Mr[1]), jr = T0[1], $r = lr([0, l0], 0, 0);
                return [0, [0, qr, [1, [0, 0, er, Br[1], S0, 0, rr[4], rr[3], rr[1], $r, jr]]]];
              }), N(W0, function(P, L, Q) {
                return cr([0, L], function(i0) {
                  for (var l0 = Q; ; ) {
                    var S0 = A0(i0);
                    if (typeof S0 == "number" && S0 === 9) {
                      ie(i0);
                      var l0 = [0, u(x, i0), l0];
                      continue;
                    }
                    return [22, [0, ye(l0), 0]];
                  }
                }, P);
              }), [0, x, i, T, n, K, o0, W0];
            }(R9), Us = /* @__PURE__ */ function(t) {
              function n(e0) {
                var x0 = pr(e0);
                ie(e0);
                var l = lr([0, x0], 0, 0), c0 = u(ci[5], e0), t0 = x7(e0) ? rb(e0) : N9(e0);
                function o0(w0, _0) {
                  return o(Qe(w0, Di, 80), w0, _0);
                }
                return [0, o(t0[2], c0, o0), l];
              }
              function e(e0) {
                var x0 = e0[27][2];
                if (x0) for (var l = 0; ; ) {
                  var c0 = A0(e0);
                  if (typeof c0 == "number" && c0 === 13) {
                    var l = [0, cr(0, n, e0), l];
                    continue;
                  }
                  return ye(l);
                }
                return x0;
              }
              function i(e0, x0) {
                var l = e0 && e0[1], c0 = pr(x0), t0 = A0(x0);
                if (typeof t0 == "number") switch (t0) {
                  case 6:
                    var o0 = cr(0, function(Jr) {
                      var ar = pr(Jr);
                      Y0(Jr, 6);
                      var _r = Kl(0, Jr), Ir = u(se[10], _r);
                      return Y0(Jr, 7), [0, Ir, lr([0, ar], [0, we(Jr)], 0)];
                    }, x0), w0 = o0[1];
                    return [0, w0, [3, [0, w0, o0[2]]]];
                  case 14:
                    if (l) {
                      var _0 = ge0(x0), E0 = x0[29][1], U0 = _0[2][1];
                      if (E0) {
                        var b = E0[1], R0 = E0[2], X = b[2], s0 = [0, [0, o(Mu[4], U0, b[1]), X], R0];
                        x0[29][1] = s0;
                      } else ke(Ujr);
                      return [0, _0[1], [2, _0]];
                    }
                    var hr = cr(0, function(Jr) {
                      return ie(Jr), [1, z7(Jr)];
                    }, x0), Ar = hr[1];
                    return ue(x0, [0, Ar, 89]), [0, Ar, hr[2]];
                }
                else switch (t0[0]) {
                  case 0:
                    var or = t0[2], W0 = Pe(x0), Lr = [2, ur(ci[6], x0, t0[1], or)];
                    return [0, W0, [0, [0, W0, [0, Lr, or, lr([0, c0], [0, we(x0)], 0)]]]];
                  case 2:
                    var Tr = t0[1], Hr = Tr[4], Or = Tr[3], fr = Tr[2], Rr = Tr[1];
                    return Hr && gi(x0, 45), Y0(x0, [2, [0, Rr, fr, Or, Hr]]), [0, Rr, [0, [0, Rr, [0, [0, fr], Or, lr([0, c0], [0, we(x0)], 0)]]]];
                }
                var Wr = z7(x0);
                return [0, Wr[1], [1, Wr]];
              }
              function x(e0, x0, l) {
                var c0 = u(Vn[2], e0), t0 = c0[1], o0 = c0[2], w0 = i([0, x0], e0), _0 = w0[1], E0 = 0, U0 = Xi(e0, w0[2]);
                return [0, U0, cr(0, function(b) {
                  var R0 = t2(1, b), X = cr(0, function(Tr) {
                    var Hr = ur(Vn[4], 0, 0, Tr), Or = 0, fr = A0(Tr) === 86 ? Hr : eb(Tr, Hr);
                    if (l) {
                      var Rr = fr[2], Wr = 0;
                      if (Rr[1]) ue(Tr, [0, _0, j7]), Wr = 1;
                      else {
                        var Jr = 0;
                        !Rr[2] && !Rr[3] && (Wr = 1, Jr = 1), Jr || ue(Tr, [0, _0, 80]);
                      }
                    } else {
                      var ar = fr[2];
                      if (ar[1]) ue(Tr, [0, _0, Yt]);
                      else {
                        var _r = ar[2], Ir = 0;
                        (!_r || _r[2] || ar[3]) && (Ir = 1), Ir && (ar[3] ? ue(Tr, [0, _0, 81]) : ue(Tr, [0, _0, 81]));
                      }
                    }
                    return [0, Or, fr, o2(Tr, u(mn[10], Tr))];
                  }, R0), s0 = X[2], hr = s0[2], Ar = q1(hr), or = p7(Vn[5], R0, E0, t0, 0, Ar);
                  R(Vn[6], R0, or[2], 0, hr);
                  var W0 = X[1], Lr = lr([0, o0], 0, 0);
                  return [0, 0, hr, or[1], E0, t0, 0, s0[3], s0[1], Lr, W0];
                }, e0)];
              }
              function c(e0) {
                var x0 = u(ci[2], e0);
                return x0[0] === 0 ? [0, x0[1], t[3]] : [0, x0[1], x0[2]];
              }
              function s(e0, x0) {
                switch (x0[0]) {
                  case 0:
                    var l = x0[1], c0 = l[1];
                    return ue(e0, [0, c0, 95]), [0, c0, [14, l[2]]];
                  case 1:
                    var t0 = x0[1], o0 = t0[2][1], w0 = t0[1], _0 = 0;
                    return kL(o0) && n0(o0, KQr) && n0(o0, WQr) && (ue(e0, [0, w0, 2]), _0 = 1), !_0 && f2(o0) && V7(e0, [0, w0, 55]), [0, w0, [10, t0]];
                  case 2:
                    return ke(JQr);
                  default:
                    var E0 = x0[1][2][1];
                    return ue(e0, [0, E0[1], 96]), E0;
                }
              }
              function p(e0, x0, l) {
                function c0(o0) {
                  var w0 = t2(1, o0), _0 = cr(0, function(hr) {
                    var Ar = oi(hr, u(mn[3], hr));
                    if (e0) if (x0) var or = 1, W0 = 1;
                    else var or = hr[18], W0 = 0;
                    else if (x0) var or = 0, W0 = 1;
                    else var or = 0, W0 = 0;
                    var Lr = ur(Vn[4], or, W0, hr), Tr = A0(hr) === 86 ? Lr : eb(hr, Lr);
                    return [0, Ar, Tr, o2(hr, u(mn[10], hr))];
                  }, w0), E0 = _0[2], U0 = E0[2], b = q1(U0), R0 = p7(Vn[5], w0, e0, x0, 0, b);
                  R(Vn[6], w0, R0[2], 0, U0);
                  var X = _0[1], s0 = lr([0, l], 0, 0);
                  return [0, 0, U0, R0[1], e0, x0, 0, E0[3], E0[1], s0, X];
                }
                var t0 = 0;
                return function(o0) {
                  return cr(t0, c0, o0);
                };
              }
              function y(e0) {
                return Y0(e0, 86), c(e0);
              }
              function T(e0, x0, l, c0, t0, o0) {
                var w0 = cr([0, x0], function(E0) {
                  if (!c0 && !t0) {
                    var U0 = A0(E0);
                    if (typeof U0 == "number") {
                      var b = 0;
                      if (86 <= U0) {
                        if (U0 === 98) b = 1;
                        else if (!(87 <= U0)) {
                          var R0 = y(E0);
                          return [0, [0, l, R0[1], 0], R0[2]];
                        }
                      } else {
                        if (U0 === 82) {
                          if (l[0] === 1) var X = l[1], s0 = Pe(E0), hr = function(Rr) {
                            var Wr = pr(Rr);
                            Y0(Rr, 82);
                            var Jr = we(Rr), ar = o(se[19], Rr, [0, X[1], [10, X]]), _r = u(se[10], Rr);
                            return [2, [0, 0, ar, _r, lr([0, Wr], [0, Jr], 0)]];
                          }, Ar = cr([0, X[1]], hr, E0), or = [0, Ar, [0, [0, [0, s0, [10, Ml(zQr)]], 0], 0]];
                          else var or = y(E0);
                          return [0, [0, l, or[1], 1], or[2]];
                        }
                        if (!(10 <= U0)) switch (U0) {
                          case 4:
                            b = 1;
                            break;
                          case 1:
                          case 9:
                            var W0 = [0, l, s(E0, l), 1];
                            return [0, W0, t[3]];
                        }
                      }
                      if (b) {
                        var Lr = Xi(E0, l), Tr = [1, Lr, u(p(c0, t0, o0), E0)];
                        return [0, Tr, t[3]];
                      }
                    }
                    var Hr = [0, l, s(E0, l), 1];
                    return [0, Hr, t[3]];
                  }
                  var Or = Xi(E0, l), fr = [1, Or, u(p(c0, t0, o0), E0)];
                  return [0, fr, t[3]];
                }, e0), _0 = w0[2];
                return [0, [0, [0, w0[1], _0[1]]], _0[2]];
              }
              function E(e0) {
                var x0 = cr(0, function(c0) {
                  var t0 = pr(c0);
                  Y0(c0, 0);
                  for (var o0 = 0, w0 = [0, 0, t[3]]; ; ) {
                    var _0 = w0[2], E0 = w0[1], U0 = A0(c0);
                    if (typeof U0 == "number") {
                      var b = 0;
                      if ((U0 === 1 || Pn === U0) && (b = 1), b) {
                        var R0 = o0 ? [0, _0[1], [0, [0, o0[1], 98], _0[2]]] : _0, X = u(t[6], R0), s0 = ye(E0), hr = pr(c0);
                        return Y0(c0, 1), [0, [0, s0, yu([0, t0], [0, we(c0)], hr, 0)], X];
                      }
                    }
                    if (A0(c0) === 12) var Ar = pr(c0), or = cr(0, function(y0) {
                      return Y0(y0, 12), c(y0);
                    }, c0), W0 = or[2], Lr = W0[2], Tr = lr([0, Ar], 0, 0), Hr = [0, [1, [0, or[1], [0, W0[1], Tr]]], Lr];
                    else {
                      var Or = Pe(c0), fr = Yn(1, c0), Rr = 0;
                      if (typeof fr == "number") {
                        var Wr = 0;
                        if (86 <= fr) fr !== 98 && 87 <= fr && (Wr = 1);
                        else if (fr !== 82) if (10 <= fr) Wr = 1;
                        else switch (fr) {
                          case 1:
                          case 4:
                          case 9:
                            break;
                          default:
                            Wr = 1;
                        }
                        if (!Wr) {
                          var ar = 0, _r = 0;
                          Rr = 1;
                        }
                      }
                      if (!Rr) var Jr = u(Vn[1], c0), ar = Jr[2], _r = Jr[1];
                      var Ir = u(Vn[2], c0), fe = Ir[1], v0 = on(ar, Ir[2]), P = A0(c0), L = 0;
                      if (!_r && !fe && typeof P != "number" && P[0] === 4) {
                        var Q = P[3], i0 = 0;
                        if (n0(Q, YQr)) if (n0(Q, VQr)) i0 = 1;
                        else {
                          var l0 = pr(c0), S0 = i(0, c0)[2], T0 = A0(c0), rr = 0;
                          if (typeof T0 == "number") {
                            var L0 = 0;
                            if (86 <= T0) T0 !== 98 && 87 <= T0 && (L0 = 1);
                            else if (T0 !== 82) if (10 <= T0) L0 = 1;
                            else switch (T0) {
                              case 1:
                              case 4:
                              case 9:
                                break;
                              default:
                                L0 = 1;
                            }
                            if (!L0) {
                              var B = T(c0, Or, S0, 0, 0, 0);
                              rr = 1;
                            }
                          }
                          if (!rr) {
                            Xi(c0, S0);
                            var Z = t[3], p0 = cr([0, Or], function(I0) {
                              return x(I0, 0, 0);
                            }, c0), b0 = p0[2], O0 = lr([0, l0], 0, 0), B = [0, [0, [0, p0[1], [3, b0[1], b0[2], O0]]], Z];
                          }
                          var M0 = B;
                        }
                        else {
                          var er = pr(c0), yr = i(0, c0)[2], vr = A0(c0), $0 = 0;
                          if (typeof vr == "number") {
                            var Er = 0;
                            if (86 <= vr) vr !== 98 && 87 <= vr && (Er = 1);
                            else if (vr !== 82) if (10 <= vr) Er = 1;
                            else switch (vr) {
                              case 1:
                              case 4:
                              case 9:
                                break;
                              default:
                                Er = 1;
                            }
                            if (!Er) {
                              var Mr = T(c0, Or, yr, 0, 0, 0);
                              $0 = 1;
                            }
                          }
                          if (!$0) {
                            Xi(c0, yr);
                            var Br = t[3], qr = cr([0, Or], function(D) {
                              return x(D, 0, 1);
                            }, c0), jr = qr[2], $r = lr([0, er], 0, 0), Mr = [0, [0, [0, qr[1], [2, jr[1], jr[2], $r]]], Br];
                          }
                          var M0 = Mr;
                        }
                        if (!i0) {
                          var ne = M0;
                          L = 1;
                        }
                      }
                      if (!L) var ne = T(c0, Or, i(0, c0)[2], _r, fe, v0);
                      var Hr = ne;
                    }
                    var Qr = Hr[1], be = 0;
                    if (Qr[0] === 1 && A0(c0) === 9) {
                      var ae = [0, Pe(c0)];
                      be = 1;
                    }
                    if (!be) var ae = 0;
                    var pe = o(t[5], Hr[2], _0), oe = A0(c0), ce = 0;
                    if (typeof oe == "number") {
                      var ge = oe - 2 | 0, q0 = 0;
                      if (Xt < ge >>> 0 ? T7 < (ge + 1 | 0) >>> 0 && (q0 = 1) : ge === 7 ? ie(c0) : q0 = 1, !q0) {
                        var Fr = pe;
                        ce = 1;
                      }
                    }
                    if (!ce) {
                      var _ = aL(dRr, 9), k = le0([0, _], A0(c0)), I = [0, Pe(c0), k];
                      xu(c0, 8);
                      var Fr = o(t[4], I, pe);
                    }
                    var o0 = ae, w0 = [0, [0, Qr, E0], Fr];
                  }
                }, e0), l = x0[2];
                return [0, x0[1], l[1], l[2]];
              }
              function d(e0, x0, l, c0) {
                var t0 = l[2][1], o0 = l[1];
                if (qn(t0, XQr)) return ue(e0, [0, o0, [21, t0, 0, QY === c0 ? 1 : 0, 1]]), x0;
                var w0 = o(L9[32], t0, x0);
                if (w0) {
                  var _0 = w0[1], E0 = 0;
                  return SE === c0 ? Fh === _0 && (E0 = 1) : Fh === c0 && SE === _0 && (E0 = 1), E0 || ue(e0, [0, o0, [20, t0]]), ur(L9[4], t0, KX, x0);
                }
                return ur(L9[4], t0, c0, x0);
              }
              function w(e0, x0) {
                return cr(0, function(l) {
                  var c0 = x0 && pr(l);
                  Y0(l, 52);
                  for (var t0 = 0; ; ) {
                    var o0 = [0, cr(0, function(E0) {
                      var U0 = u(mn[2], E0);
                      if (A0(E0) === 98) var b = $t(E0), R0 = function(s0, hr) {
                        return o(Qe(s0, Nv, 81), s0, hr);
                      }, X = o(b[2], U0, R0);
                      else var X = U0;
                      return [0, X, u(mn[4], E0)];
                    }, l), t0], w0 = A0(l);
                    if (typeof w0 == "number" && w0 === 9) {
                      Y0(l, 9);
                      var t0 = o0;
                      continue;
                    }
                    var _0 = ye(o0);
                    return [0, _0, lr([0, c0], 0, 0)];
                  }
                }, e0);
              }
              function G(e0, x0) {
                return x0 && ue(e0, [0, x0[1][1], 7]);
              }
              function A(e0, x0) {
                return x0 && ue(e0, [0, x0[1], 68]);
              }
              function S(e0, x0, l, c0, t0, o0, w0, _0, E0, U0) {
                for (; ; ) {
                  var b = A0(e0), R0 = 0;
                  if (typeof b == "number") {
                    var X = b - 1 | 0, s0 = 0;
                    if (7 < X >>> 0) {
                      var hr = X - 81 | 0;
                      if (4 < hr >>> 0) s0 = 1;
                      else switch (hr) {
                        case 3:
                          St(0, e0), ie(e0);
                          continue;
                        case 0:
                        case 4:
                          break;
                        default:
                          s0 = 1;
                      }
                    } else 5 < (X - 1 | 0) >>> 0 || (s0 = 1);
                    !s0 && !t0 && !o0 && (R0 = 1);
                  }
                  if (!R0) {
                    var Ar = A0(e0), or = 0;
                    if (typeof Ar == "number") {
                      var W0 = 0;
                      if (Ar !== 4 && Ar !== 98 && (or = 1, W0 = 1), !W0) var Tr = 0;
                    } else or = 1;
                    if (or) var Lr = x2(e0), Tr = Lr && 1;
                    if (!Tr) {
                      A(e0, _0), G(e0, E0);
                      var Hr = 0;
                      if (!w0) {
                        var Or = 0;
                        switch (c0[0]) {
                          case 0:
                            var fr = c0[1][2][1], Rr = 0;
                            typeof fr != "number" && fr[0] === 0 && (n0(fr[1], jQr) && (Or = 1), Rr = 1), Rr || (Or = 1);
                            break;
                          case 1:
                            n0(c0[1][2][1], GQr) && (Or = 1);
                            break;
                          default:
                            Or = 1;
                        }
                        if (!Or) {
                          var Wr = t2(2, e0), Jr = 0;
                          Hr = 1;
                        }
                      }
                      if (!Hr) var Wr = t2(1, e0), Jr = 1;
                      var ar = Xi(Wr, c0), _r = cr(0, function(S0) {
                        var T0 = cr(0, function(p0) {
                          var b0 = oi(p0, u(mn[3], p0));
                          if (t0) if (o0) var O0 = 1, M0 = 1;
                          else var O0 = p0[18], M0 = 0;
                          else if (o0) var O0 = 0, M0 = 1;
                          else var O0 = 0, M0 = 0;
                          var er = ur(Vn[4], O0, M0, p0), yr = A0(p0) === 86 ? er : eb(p0, er), vr = yr[2], $0 = vr[1], Er = 0;
                          if ($0 && Jr === 0) {
                            ue(p0, [0, $0[1][1], is]);
                            var Mr = [0, yr[1], [0, 0, vr[2], vr[3], vr[4]]];
                            Er = 1;
                          }
                          if (!Er) var Mr = yr;
                          return [0, b0, Mr, o2(p0, u(mn[10], p0))];
                        }, S0), rr = T0[2], L0 = rr[2], B = q1(L0), Z = p7(Vn[5], S0, t0, o0, 0, B);
                        return R(Vn[6], S0, Z[2], 0, L0), [0, 0, L0, Z[1], t0, o0, 0, rr[3], rr[1], 0, T0[1]];
                      }, Wr), Ir = [0, Jr, ar, _r, w0, l, lr([0, U0], 0, 0)];
                      return [0, [0, yt(x0, _r[1]), Ir]];
                    }
                  }
                  var fe = cr([0, x0], function(S0) {
                    var T0 = u(mn[10], S0), rr = A0(S0);
                    if (_0) {
                      var L0 = 0;
                      if (typeof rr == "number" && rr === 82) {
                        je(S0, 69), ie(S0);
                        var B = 0;
                      } else L0 = 1;
                      if (L0) var B = 0;
                    } else {
                      var Z = 0;
                      if (typeof rr == "number" && rr === 82) {
                        ie(S0);
                        var p0 = t2(1, S0), B = [0, u(se[7], p0)];
                      } else Z = 1;
                      if (Z) var B = 1;
                    }
                    var b0 = A0(S0), O0 = 0;
                    if (typeof b0 == "number" && !(9 <= b0)) switch (b0) {
                      case 8:
                        ie(S0);
                        var M0 = A0(S0), er = 0;
                        if (typeof M0 == "number") {
                          var yr = 0;
                          if (M0 !== 1 && Pn !== M0 && (er = 1, yr = 1), !yr) var $0 = we(S0);
                        } else er = 1;
                        if (er) var vr = x7(S0), $0 = vr && Ms(S0);
                        var Er = [0, c0, T0, B, $0];
                        O0 = 1;
                        break;
                      case 4:
                      case 6:
                        St(0, S0);
                        var Er = [0, c0, T0, B, 0];
                        O0 = 1;
                        break;
                    }
                    if (!O0) {
                      var Mr = A0(S0), Br = 0;
                      if (typeof Mr == "number") {
                        var qr = 0;
                        if (Mr !== 1 && Pn !== Mr && (Br = 1, qr = 1), !qr) var jr = [0, 0, function(q0, Fr) {
                          return q0;
                        }];
                      } else Br = 1;
                      if (Br) var jr = x7(S0) ? rb(S0) : N9(S0);
                      if (typeof B == "number") if (T0[0] === 0) var $r = function(_, k) {
                        return o(Qe(_, qY, 83), _, k);
                      }, be = B, ae = T0, pe = o(jr[2], c0, $r);
                      else var ne = function(_, k) {
                        return o(Qe(_, OE, 84), _, k);
                      }, be = B, ae = [1, o(jr[2], T0[1], ne)], pe = c0;
                      else var Qr = function(ge, q0) {
                        return o(Qe(ge, Di, 85), ge, q0);
                      }, be = [0, o(jr[2], B[1], Qr)], ae = T0, pe = c0;
                      var Er = [0, pe, ae, be, 0];
                    }
                    var oe = lr([0, U0], [0, Er[4]], 0);
                    return [0, Er[1], Er[2], Er[3], oe];
                  }, e0), v0 = fe[2], P = v0[4], L = v0[3], Q = v0[2], i0 = v0[1], l0 = fe[1];
                  return i0[0] === 2 ? [2, [0, l0, [0, i0[1], L, Q, w0, E0, P]]] : [1, [0, l0, [0, i0, L, Q, w0, E0, P]]];
                }
              }
              function M(e0, x0) {
                var l = Yn(e0, x0);
                if (typeof l == "number") {
                  var c0 = 0;
                  if (86 <= l) (l === 98 || !(87 <= l)) && (c0 = 1);
                  else if (l === 82) c0 = 1;
                  else if (!(9 <= l)) switch (l) {
                    case 1:
                    case 4:
                    case 8:
                      c0 = 1;
                      break;
                  }
                  if (c0) return 1;
                }
                return 0;
              }
              var K = 0;
              function V(e0) {
                return M(K, e0);
              }
              function f0(e0, x0, l, c0) {
                var t0 = e0 && e0[1], o0 = _s(1, x0), w0 = on(t0, e(o0)), _0 = pr(o0);
                Y0(o0, 40);
                var E0 = F9(1, o0), U0 = A0(E0), b = 0;
                if (l && typeof U0 == "number") {
                  var R0 = 0;
                  if (52 <= U0 ? U0 !== 98 && 53 <= U0 && (R0 = 1) : U0 !== 41 && U0 && (R0 = 1), !R0) {
                    var Ar = 0;
                    b = 1;
                  }
                }
                if (!b) if (G1(o0)) var X = o(se[13], 0, E0), s0 = $t(o0), hr = function(v0, P) {
                  return o(Qe(v0, Nv, 88), v0, P);
                }, Ar = [0, o(s0[2], X, hr)];
                else {
                  be0(o0, NQr);
                  var Ar = [0, [0, Pe(o0), CQr]];
                }
                var or = u(mn[3], o0);
                if (or) var W0 = $t(o0), Lr = function(v0, P) {
                  return o(Qe(v0, bF, 86), v0, P);
                }, Tr = [0, o(W0[2], or[1], Lr)];
                else var Tr = or;
                var Hr = pr(o0), Or = xu(o0, 41);
                if (Or) var fr = cr(0, function(v0) {
                  var P = mL(0, v0), L = u(ci[5], P);
                  if (A0(v0) === 98) var Q = $t(v0), i0 = function(T0, rr) {
                    return o(Qe(T0, Di, 82), T0, rr);
                  }, l0 = o(Q[2], L, i0);
                  else var l0 = L;
                  var S0 = u(mn[4], v0);
                  return [0, l0, S0, lr([0, Hr], 0, 0)];
                }, o0), Rr = fr[1], Wr = $t(o0), Jr = function(v0, P) {
                  return ur(Qe(v0, -663447790, 87), v0, Rr, P);
                }, ar = [0, [0, Rr, o(Wr[2], fr[2], Jr)]];
                else var ar = Or;
                var _r = A0(o0) === 52 ? 1 : 0;
                if (_r) {
                  1 - fu(o0) && je(o0, 16);
                  var Ir = [0, ke0(o0, w(o0, 1))];
                } else var Ir = _r;
                var fe = cr(0, function(v0) {
                  var P = pr(v0);
                  if (xu(v0, 0)) {
                    v0[29][1] = [0, [0, Mu[1], 0], v0[29][1]];
                    for (var L = 0, Q = L9[1], i0 = 0; ; ) {
                      var l0 = A0(v0);
                      if (typeof l0 == "number") {
                        var S0 = l0 - 2 | 0;
                        if (Xt < S0 >>> 0) {
                          if (!(T7 < (S0 + 1 | 0) >>> 0)) {
                            var T0 = ye(i0), rr = function(ou, Bu) {
                              return u(ml(function(K7) {
                                return 1 - o(Mu[3], K7[1], ou);
                              }), Bu);
                            }, L0 = v0[29][1];
                            if (L0) {
                              var B = L0[1], Z = B[1];
                              if (L0[2]) {
                                var p0 = L0[2], b0 = rr(Z, B[2]), O0 = bl(p0), M0 = az(p0), er = on(O0[2], b0);
                                v0[29][1] = [0, [0, O0[1], er], M0];
                              } else {
                                var yr = rr(Z, B[2]);
                                Du(function(ou) {
                                  return ue(v0, [0, ou[2], [22, ou[1]]]);
                                }, yr), v0[29][1] = 0;
                              }
                            } else ke(Hjr);
                            Y0(v0, 1);
                            var vr = A0(v0), $0 = 0;
                            if (!c0) {
                              var Er = 0;
                              if (typeof vr == "number" && (vr === 1 || Pn === vr) && (Er = 1), !Er) {
                                var Mr = x7(v0);
                                if (Mr) {
                                  var Br = Ms(v0);
                                  $0 = 1;
                                } else {
                                  var Br = Mr;
                                  $0 = 1;
                                }
                              }
                            }
                            if (!$0) var Br = we(v0);
                            return [0, T0, lr([0, P], [0, Br], 0)];
                          }
                        } else if (S0 === 6) {
                          Y0(v0, 8);
                          continue;
                        }
                      }
                      var qr = Pe(v0), jr = e(v0), $r = A0(v0), ne = 0;
                      if (typeof $r == "number" && $r === 60 && !M(1, v0)) {
                        var Qr = [0, Pe(v0)], be = pr(v0);
                        ie(v0);
                        var ae = be, pe = Qr;
                        ne = 1;
                      }
                      if (!ne) var ae = 0, pe = 0;
                      var oe = Yn(1, v0) !== 4 ? 1 : 0;
                      if (oe) var ce = Yn(1, v0) !== 98 ? 1 : 0, ge = ce && (A0(v0) === 42 ? 1 : 0);
                      else var ge = oe;
                      if (ge) {
                        var q0 = pr(v0);
                        ie(v0);
                        var Fr = q0;
                      } else var Fr = ge;
                      var _ = A0(v0) === 64 ? 1 : 0;
                      if (_) var k = 1 - M(1, v0), I = k && 1 - Jl(1, v0);
                      else var I = _;
                      if (I) {
                        var U = pr(v0);
                        ie(v0);
                        var Y = U;
                      } else var Y = I;
                      var y0 = u(Vn[2], v0), P0 = y0[1], I0 = ur(Vn[3], v0, I, P0), D = 0;
                      if (!P0 && I0) {
                        var u0 = u(Vn[2], v0), X0 = u0[2], J0 = u0[1];
                        D = 1;
                      }
                      if (!D) var X0 = y0[2], J0 = P0;
                      var ir = pl([0, ae, [0, Fr, [0, Y, [0, X0, 0]]]]), Q0 = A0(v0), F0 = 0;
                      if (!I && !J0 && typeof Q0 != "number" && Q0[0] === 4) {
                        var Sr = Q0[3];
                        if (n0(Sr, MQr)) {
                          if (!n0(Sr, BQr)) {
                            var mr = pr(v0), Cr = i(qQr, v0)[2];
                            if (V(v0)) {
                              var Ie = S(v0, qr, jr, Cr, I, J0, ge, pe, I0, ir);
                              F0 = 1;
                            } else {
                              A(v0, pe), G(v0, I0), Xi(v0, Cr);
                              var sr = on(ir, mr), Pr = cr([0, qr], function(Bu) {
                                return x(Bu, 1, 0);
                              }, v0), K0 = Pr[2], Ur = lr([0, sr], 0, 0), Ie = [0, [0, Pr[1], [0, 3, K0[1], K0[2], ge, jr, Ur]]];
                              F0 = 1;
                            }
                          }
                        } else {
                          var h0 = pr(v0), Kr = i(UQr, v0)[2];
                          if (V(v0)) {
                            var Ie = S(v0, qr, jr, Kr, I, J0, ge, pe, I0, ir);
                            F0 = 1;
                          } else {
                            A(v0, pe), G(v0, I0), Xi(v0, Kr);
                            var re = on(ir, h0), xe = cr([0, qr], function(Bu) {
                              return x(Bu, 1, 1);
                            }, v0), Re = xe[2], ve = lr([0, re], 0, 0), Ie = [0, [0, xe[1], [0, 2, Re[1], Re[2], ge, jr, ve]]];
                            F0 = 1;
                          }
                        }
                      }
                      if (!F0) var Ie = S(v0, qr, jr, i(HQr, v0)[2], I, J0, ge, pe, I0, ir);
                      switch (Ie[0]) {
                        case 0:
                          var Ge = Ie[1], Me = Ge[2];
                          switch (Me[1]) {
                            case 0:
                              if (Me[4]) var Ft = Q, Ct = L;
                              else {
                                L && ue(v0, [0, Ge[1], 87]);
                                var Ft = Q, Ct = 1;
                              }
                              break;
                            case 1:
                              var an = Me[2], We = an[0] === 2 ? d(v0, Q, an[1], QY) : Q, Ft = We, Ct = L;
                              break;
                            case 2:
                              var Ae = Me[2], cn = Ae[0] === 2 ? d(v0, Q, Ae[1], SE) : Q, Ft = cn, Ct = L;
                              break;
                            default:
                              var rn = Me[2], kn = rn[0] === 2 ? d(v0, Q, rn[1], Fh) : Q, Ft = kn, Ct = L;
                          }
                          break;
                        case 1:
                          var vn = Ie[1][2], Ne = vn[4], Je = vn[1], en = 0;
                          switch (Je[0]) {
                            case 0:
                              var _n = Je[1], Cn = _n[2][1], Hn = 0;
                              if (typeof Cn != "number" && Cn[0] === 0) {
                                var vt = Cn[1], Nt = _n[1];
                                en = 1, Hn = 1;
                              }
                              Hn || (en = 2);
                              break;
                            case 1:
                              var Fn = Je[1], vt = Fn[2][1], Nt = Fn[1];
                              en = 1;
                              break;
                            case 2:
                              ke(PQr);
                              break;
                            default:
                              en = 2;
                          }
                          switch (en) {
                            case 1:
                              var gt = qn(vt, DQr);
                              if (gt) var qt = gt;
                              else var Zt = qn(vt, LQr), qt = Zt && Ne;
                              qt && ue(v0, [0, Nt, [21, vt, Ne, 0, 0]]);
                              break;
                            case 2:
                              break;
                          }
                          var Ft = Q, Ct = L;
                          break;
                        default:
                          var Ft = d(v0, Q, Ie[1][2][1], KX), Ct = L;
                      }
                      var L = Ct, Q = Ft, i0 = [0, Ie, i0];
                    }
                  }
                  return B1(v0, 0), RQr;
                }, o0);
                return [0, Ar, fe, Tr, ar, Ir, w0, lr([0, _0], 0, 0)];
              }
              function m0(e0, x0) {
                return cr(0, function(l) {
                  return [2, f0([0, x0], l, l[7], 0)];
                }, e0);
              }
              function k0(e0) {
                return [5, f0(0, e0, 1, 1)];
              }
              var g0 = 0;
              return [0, i, E, m0, function(e0) {
                return cr(g0, k0, e0);
              }, w, e];
            }(R9), ht = function(t) {
              function n(_) {
                var k = u(Vn[10], _);
                if (_[5]) M1(_, k[1]);
                else {
                  var I = k[2], U = 0;
                  if (I[0] === 23) {
                    var Y = I[1], y0 = k[1], P0 = 0;
                    Y[4] ? ue(_, [0, y0, 61]) : Y[5] ? ue(_, [0, y0, 62]) : (U = 1, P0 = 1);
                  } else U = 1;
                }
                return k;
              }
              function e(_, k, I) {
                var U = I[2][1], Y = I[1];
                if (n0(U, Z0e)) {
                  if (n0(U, Q0e)) return n0(U, rre) ? f2(U) ? V7(k, [0, Y, 55]) : kL(U) ? ue(k, [0, Y, [10, Ml(U)]]) : _ && js(U) ? V7(k, [0, Y, _[1]]) : 0 : k[17] ? ue(k, [0, Y, 2]) : V7(k, [0, Y, 55]);
                  if (k[5]) return V7(k, [0, Y, 55]);
                  var y0 = k[14];
                  return y0 && ue(k, [0, Y, [10, Ml(U)]]);
                }
                var P0 = k[18];
                return P0 && ue(k, [0, Y, 2]);
              }
              function i(_, k) {
                var I = k[4], U = k[3], Y = k[2], y0 = k[1];
                I && gi(_, 45);
                var P0 = pr(_);
                return Y0(_, [2, [0, y0, Y, U, I]]), [0, y0, [0, Y, U, lr([0, P0], [0, we(_)], 0)]];
              }
              function x(_, k, I) {
                var U = _ ? _[1] : W0e, Y = k ? k[1] : 1, y0 = A0(I);
                if (typeof y0 == "number") {
                  var P0 = y0 - 2 | 0;
                  if (Xt < P0 >>> 0) {
                    if (!(T7 < (P0 + 1 | 0) >>> 0)) {
                      var I0 = function(X0, J0) {
                        return X0;
                      };
                      return [1, [0, we(I), I0]];
                    }
                  } else if (P0 === 6) {
                    ie(I);
                    var D = A0(I);
                    if (typeof D == "number") {
                      var u0 = 0;
                      if ((D === 1 || Pn === D) && (u0 = 1), u0) return [0, we(I)];
                    }
                    return x7(I) ? [0, Ms(I)] : J0e;
                  }
                }
                return x7(I) ? [1, rb(I)] : (Y && St([0, U], I), $0e);
              }
              function c(_) {
                var k = A0(_);
                if (typeof k == "number") {
                  var I = 0;
                  if ((k === 1 || Pn === k) && (I = 1), I) {
                    var U = function(Y, y0) {
                      return Y;
                    };
                    return [0, we(_), U];
                  }
                }
                return x7(_) ? rb(_) : N9(_);
              }
              function s(_, k, I) {
                var U = x(0, 0, k);
                if (U[0] === 0) return [0, U[1], I];
                var Y = ye(I);
                if (Y) var y0 = function(D, u0) {
                  return ur(Qe(D, 634872468, 89), D, _, u0);
                }, P0 = o(U[1][2], Y[1], y0), I0 = ye([0, P0, Y[2]]);
                else var I0 = Y;
                return [0, 0, I0];
              }
              var p = function _(k) {
                return _.fun(k);
              }, y = function _(k) {
                return _.fun(k);
              }, T = function _(k) {
                return _.fun(k);
              }, E = function _(k) {
                return _.fun(k);
              }, d = function _(k) {
                return _.fun(k);
              }, w = function _(k, I) {
                return _.fun(k, I);
              }, G = function _(k) {
                return _.fun(k);
              }, A = function _(k) {
                return _.fun(k);
              }, S = function _(k, I, U) {
                return _.fun(k, I, U);
              }, M = function _(k) {
                return _.fun(k);
              }, K = function _(k) {
                return _.fun(k);
              }, V = function _(k, I) {
                return _.fun(k, I);
              }, f0 = function _(k) {
                return _.fun(k);
              }, m0 = function _(k) {
                return _.fun(k);
              }, k0 = function _(k, I) {
                return _.fun(k, I);
              }, g0 = function _(k) {
                return _.fun(k);
              }, e0 = function _(k, I) {
                return _.fun(k, I);
              }, x0 = function _(k) {
                return _.fun(k);
              }, l = function _(k, I) {
                return _.fun(k, I);
              }, c0 = function _(k) {
                return _.fun(k);
              }, t0 = function _(k, I) {
                return _.fun(k, I);
              }, o0 = function _(k, I) {
                return _.fun(k, I);
              }, w0 = function _(k, I) {
                return _.fun(k, I);
              }, _0 = function _(k) {
                return _.fun(k);
              }, E0 = function _(k) {
                return _.fun(k);
              }, U0 = function _(k, I, U) {
                return _.fun(k, I, U);
              }, b = function _(k, I) {
                return _.fun(k, I);
              }, R0 = function _(k, I) {
                return _.fun(k, I);
              }, X = function _(k) {
                return _.fun(k);
              };
              function s0(_) {
                var k = pr(_);
                Y0(_, 59);
                var I = A0(_) === 8 ? 1 : 0, U = I && we(_), Y = x(0, 0, _), y0 = Y[0] === 0 ? Y[1] : Y[1][1];
                return [4, [0, lr([0, k], [0, on(U, y0)], 0)]];
              }
              var hr = 0;
              function Ar(_) {
                return cr(hr, s0, _);
              }
              function or(_) {
                var k = pr(_);
                Y0(_, 37);
                var I = zl(1, _), U = u(se[2], I), Y = 1 - _[5], y0 = Y && nb(U);
                y0 && M1(_, U[1]);
                var P0 = we(_);
                Y0(_, 25);
                var I0 = we(_);
                Y0(_, 4);
                var D = u(se[7], _);
                Y0(_, 5);
                var u0 = A0(_) === 8 ? 1 : 0, X0 = u0 && we(_), J0 = x(0, K0e, _), ir = J0[0] === 0 ? on(X0, J0[1]) : J0[1][1];
                return [14, [0, U, D, lr([0, k], [0, on(P0, on(I0, ir))], 0)]];
              }
              var W0 = 0;
              function Lr(_) {
                return cr(W0, or, _);
              }
              function Tr(_, k, I) {
                var U = I[2][1];
                if (U && !U[1][2][2]) {
                  var Y = U[2];
                  if (!Y) return Y;
                }
                return ue(_, [0, I[1], k]);
              }
              function Hr(_, k) {
                var I = 1 - _[5], U = I && nb(k);
                return U && M1(_, k[1]);
              }
              function Or(_) {
                var k = pr(_);
                Y0(_, 39);
                var I = _[18], U = I && xu(_, 65), Y = on(k, pr(_));
                Y0(_, 4);
                var y0 = lr([0, Y], 0, 0), P0 = Kl(1, _), I0 = A0(P0), D = 0;
                if (typeof I0 == "number") if (24 <= I0) if (29 <= I0) D = 1;
                else switch (I0 - 24 | 0) {
                  case 0:
                    var u0 = cr(0, Vn[9], P0), X0 = u0[2], J0 = lr([0, X0[2]], 0, 0), Pr = X0[3], K0 = [0, [1, [0, u0[1], [0, X0[1], 0, J0]]]];
                    break;
                  case 3:
                    var ir = cr(0, Vn[8], P0), Q0 = ir[2], F0 = lr([0, Q0[2]], 0, 0), Pr = Q0[3], K0 = [0, [1, [0, ir[1], [0, Q0[1], 2, F0]]]];
                    break;
                  case 4:
                    var Sr = cr(0, Vn[7], P0), mr = Sr[2], Cr = lr([0, mr[2]], 0, 0), Pr = mr[3], K0 = [0, [1, [0, Sr[1], [0, mr[1], 1, Cr]]]];
                    break;
                  default:
                    D = 1;
                }
                else if (I0 === 8) var Pr = 0, K0 = 0;
                else D = 1;
                else D = 1;
                if (D) var sr = F9(1, P0), Pr = 0, K0 = [0, [0, u(se[8], sr)]];
                var Ur = A0(_);
                if (typeof Ur == "number") {
                  if (Ur === 17) {
                    if (K0) {
                      var h0 = K0[1];
                      if (h0[0] === 0) var Kr = [1, ur(t[2], V0e, _, h0[1])];
                      else {
                        var re = h0[1];
                        Tr(_, 28, re);
                        var Kr = [0, re];
                      }
                      U ? Y0(_, 63) : Y0(_, 17);
                      var xe = u(se[7], _);
                      Y0(_, 5);
                      var Re = zl(1, _), ve = u(se[2], Re);
                      return Hr(_, ve), [21, [0, Kr, xe, ve, 0, y0]];
                    }
                    throw [0, Sn, z0e];
                  }
                  if (Ur === 63) {
                    if (K0) {
                      var Ie = K0[1];
                      if (Ie[0] === 0) var Ge = [1, ur(t[2], X0e, _, Ie[1])];
                      else {
                        var Me = Ie[1];
                        Tr(_, 29, Me);
                        var Ge = [0, Me];
                      }
                      Y0(_, 63);
                      var an = u(se[10], _);
                      Y0(_, 5);
                      var We = zl(1, _), Ae = u(se[2], We);
                      return Hr(_, Ae), [22, [0, Ge, an, Ae, U, y0]];
                    }
                    throw [0, Sn, Y0e];
                  }
                }
                if (Du(function(gt) {
                  return ue(_, gt);
                }, Pr), U ? Y0(_, 63) : Y0(_, 8), K0) var cn = K0[1], rn = cn[0] === 0 ? [0, [1, o(t[1], _, cn[1])]] : [0, [0, cn[1]]], kn = rn;
                else var kn = K0;
                var vn = A0(_), Ne = 0;
                if (typeof vn == "number") {
                  var Je = vn !== 8 ? 1 : 0;
                  if (!Je) {
                    var en = Je;
                    Ne = 1;
                  }
                }
                if (!Ne) var en = [0, u(se[7], _)];
                Y0(_, 8);
                var _n = A0(_), Cn = 0;
                if (typeof _n == "number") {
                  var Hn = _n !== 5 ? 1 : 0;
                  if (!Hn) {
                    var Fn = Hn;
                    Cn = 1;
                  }
                }
                if (!Cn) var Fn = [0, u(se[7], _)];
                Y0(_, 5);
                var vt = zl(1, _), Nt = u(se[2], vt);
                return Hr(_, Nt), [20, [0, kn, en, Fn, Nt, y0]];
              }
              var fr = 0;
              function Rr(_) {
                return cr(fr, Or, _);
              }
              function Wr(_) {
                var k = Gs(_) ? n(_) : u(se[2], _), I = 1 - _[5], U = I && nb(k);
                return U && M1(_, k[1]), k;
              }
              function Jr(_) {
                var k = pr(_);
                Y0(_, 43);
                var I = Wr(_);
                return [0, I, lr([0, k], 0, 0)];
              }
              function ar(_) {
                var k = pr(_);
                Y0(_, 16);
                var I = on(k, pr(_));
                Y0(_, 4);
                var U = u(se[7], _);
                Y0(_, 5);
                var Y = Wr(_), y0 = A0(_) === 43 ? 1 : 0, P0 = y0 && [0, cr(0, Jr, _)];
                return [24, [0, U, Y, P0, lr([0, I], 0, 0)]];
              }
              var _r = 0;
              function Ir(_) {
                return cr(_r, ar, _);
              }
              function fe(_) {
                1 - _[11] && je(_, 36);
                var k = pr(_), I = Pe(_);
                Y0(_, 19);
                var U = A0(_) === 8 ? 1 : 0, Y = U && we(_), y0 = 0;
                if (A0(_) !== 8 && !x2(_)) {
                  var P0 = [0, u(se[7], _)];
                  y0 = 1;
                }
                if (!y0) var P0 = 0;
                var I0 = yt(I, Pe(_)), D = x(0, 0, _), u0 = 0;
                if (D[0] === 0) var X0 = D[1];
                else {
                  var J0 = D[1];
                  if (P0) {
                    var ir = function(sr, Pr) {
                      return o(Qe(sr, Di, 90), sr, Pr);
                    }, Q0 = [0, o(J0[2], P0[1], ir)], F0 = Y;
                    u0 = 1;
                  } else var X0 = J0[1];
                }
                if (!u0) var Q0 = P0, F0 = on(Y, X0);
                return [28, [0, Q0, lr([0, k], [0, F0], 0), I0]];
              }
              var v0 = 0;
              function P(_) {
                return cr(v0, fe, _);
              }
              function L(_) {
                var k = pr(_);
                Y0(_, 20), Y0(_, 4);
                var I = u(se[7], _);
                Y0(_, 5), Y0(_, 0);
                for (var U = H0e; ; ) {
                  var Y = U[2], y0 = A0(_);
                  if (typeof y0 == "number") {
                    var P0 = 0;
                    if ((y0 === 1 || Pn === y0) && (P0 = 1), P0) {
                      var I0 = ye(Y);
                      Y0(_, 1);
                      var D = c(_), u0 = I[1];
                      return [29, [0, I, I0, lr([0, k], [0, D[1]], 0), u0]];
                    }
                  }
                  var X0 = U[1], J0 = gL(0, /* @__PURE__ */ function(Q0) {
                    return function(F0) {
                      var Sr = pr(F0), mr = A0(F0), Cr = 0;
                      if (typeof mr == "number" && mr === 36) {
                        Q0 && je(F0, 32), Y0(F0, 36);
                        var sr = we(F0), Pr = 0;
                        Cr = 1;
                      }
                      if (!Cr) {
                        Y0(F0, 33);
                        var sr = 0, Pr = [0, u(se[7], F0)];
                      }
                      var K0 = Q0 || (Pr === 0 ? 1 : 0);
                      Y0(F0, 86);
                      var Ur = on(sr, c(F0)[1]);
                      function h0(Re) {
                        if (typeof Re == "number") {
                          var ve = Re - 1 | 0, Ie = 0;
                          if (32 < ve >>> 0 ? ve === 35 && (Ie = 1) : 30 < (ve - 1 | 0) >>> 0 && (Ie = 1), Ie) return 1;
                        }
                        return 0;
                      }
                      var Kr = 1, re = F0[9] === 1 ? F0 : [0, F0[1], F0[2], F0[3], F0[4], F0[5], F0[6], F0[7], F0[8], Kr, F0[10], F0[11], F0[12], F0[13], F0[14], F0[15], F0[16], F0[17], F0[18], F0[19], F0[20], F0[21], F0[22], F0[23], F0[24], F0[25], F0[26], F0[27], F0[28], F0[29], F0[30]], xe = o(se[4], h0, re);
                      return [0, [0, Pr, xe, lr([0, Sr], [0, Ur], 0)], K0];
                    };
                  }(X0), _), U = [0, J0[2], [0, J0[1], Y]];
                }
              }
              var Q = 0;
              function i0(_) {
                return cr(Q, L, _);
              }
              function l0(_) {
                var k = pr(_), I = Pe(_);
                Y0(_, 22), x7(_) && ue(_, [0, I, 21]);
                var U = u(se[7], _), Y = x(0, 0, _);
                if (Y[0] === 0) var P0 = U, I0 = Y[1];
                else var y0 = function(D, u0) {
                  return o(Qe(D, Di, 91), D, u0);
                }, P0 = o(Y[1][2], U, y0), I0 = 0;
                return [30, [0, P0, lr([0, k], [0, I0], 0)]];
              }
              var S0 = 0;
              function T0(_) {
                return cr(S0, l0, _);
              }
              function rr(_) {
                var k = pr(_);
                Y0(_, 23);
                var I = u(se[15], _);
                if (A0(_) === 34) var U = $t(_), Y = function(sr, Pr) {
                  var K0 = Pr[1];
                  return [0, K0, ur(Qe(sr, Y8, 29), sr, K0, Pr[2])];
                }, y0 = o(U[2], I, Y);
                else var y0 = I;
                var P0 = A0(_), I0 = 0;
                if (typeof P0 == "number" && P0 === 34) {
                  var D = [0, cr(0, function(Pr) {
                    var K0 = pr(Pr);
                    Y0(Pr, 34);
                    var Ur = we(Pr), h0 = A0(Pr) === 4 ? 1 : 0;
                    if (h0) {
                      Y0(Pr, 4);
                      var Kr = [0, o(se[18], Pr, 39)];
                      Y0(Pr, 5);
                      var re = Kr;
                    } else var re = h0;
                    var xe = u(se[15], Pr);
                    if (A0(Pr) === 38) var Ie = xe;
                    else var Re = c(Pr), ve = function(Ge, Me) {
                      var an = Me[1];
                      return [0, an, ur(Qe(Ge, Y8, 92), Ge, an, Me[2])];
                    }, Ie = o(Re[2], xe, ve);
                    return [0, re, Ie, lr([0, K0], [0, Ur], 0)];
                  }, _)];
                  I0 = 1;
                }
                if (!I0) var D = 0;
                var u0 = A0(_), X0 = 0;
                if (typeof u0 == "number" && u0 === 38) {
                  Y0(_, 38);
                  var J0 = u(se[15], _), ir = J0[1], Q0 = c(_), F0 = function(Pr, K0) {
                    return ur(Qe(Pr, Y8, 93), Pr, ir, K0);
                  }, Sr = [0, [0, ir, o(Q0[2], J0[2], F0)]];
                  X0 = 1;
                }
                if (!X0) var Sr = 0;
                var mr = D === 0 ? 1 : 0, Cr = mr && (Sr === 0 ? 1 : 0);
                return Cr && ue(_, [0, y0[1], 33]), [31, [0, y0, D, Sr, lr([0, k], 0, 0)]];
              }
              var L0 = 0;
              function B(_) {
                return cr(L0, rr, _);
              }
              function Z(_) {
                var k = u(Vn[9], _), I = s(0, _, k[1]), U = 0, Y = k[3];
                Du(function(P0) {
                  return ue(_, P0);
                }, Y);
                var y0 = lr([0, k[2]], [0, I[1]], 0);
                return [34, [0, I[2], U, y0]];
              }
              var p0 = 0;
              function b0(_) {
                return cr(p0, Z, _);
              }
              function O0(_) {
                var k = u(Vn[8], _), I = s(2, _, k[1]), U = 2, Y = k[3];
                Du(function(P0) {
                  return ue(_, P0);
                }, Y);
                var y0 = lr([0, k[2]], [0, I[1]], 0);
                return [34, [0, I[2], U, y0]];
              }
              var M0 = 0;
              function er(_) {
                return cr(M0, O0, _);
              }
              function yr(_) {
                var k = u(Vn[7], _), I = s(1, _, k[1]), U = 1, Y = k[3];
                Du(function(P0) {
                  return ue(_, P0);
                }, Y);
                var y0 = lr([0, k[2]], [0, I[1]], 0);
                return [34, [0, I[2], U, y0]];
              }
              var vr = 0;
              function $0(_) {
                return cr(vr, yr, _);
              }
              function Er(_) {
                var k = pr(_);
                Y0(_, 25);
                var I = on(k, pr(_));
                Y0(_, 4);
                var U = u(se[7], _);
                Y0(_, 5);
                var Y = zl(1, _), y0 = u(se[2], Y), P0 = 1 - _[5], I0 = P0 && nb(y0);
                return I0 && M1(_, y0[1]), [35, [0, U, y0, lr([0, I], 0, 0)]];
              }
              var Mr = 0;
              function Br(_) {
                return cr(Mr, Er, _);
              }
              function qr(_) {
                var k = pr(_), I = u(se[7], _), U = A0(_), Y = I[2];
                if (Y[0] === 10 && typeof U == "number" && U === 86) {
                  var y0 = Y[1], P0 = y0[2][1];
                  Y0(_, 86), o(Mu[3], P0, _[3]) && ue(_, [0, I[1], [16, q0e, P0]]);
                  var I0 = _[30], D = _[29], u0 = _[28], X0 = _[27], J0 = _[26], ir = _[25], Q0 = _[24], F0 = _[23], Sr = _[22], mr = _[21], Cr = _[20], sr = _[19], Pr = _[18], K0 = _[17], Ur = _[16], h0 = _[15], Kr = _[14], re = _[13], xe = _[12], Re = _[11], ve = _[10], Ie = _[9], Ge = _[8], Me = _[7], an = _[6], We = _[5], Ae = _[4], cn = o(Mu[4], P0, _[3]), rn = [0, _[1], _[2], cn, Ae, We, an, Me, Ge, Ie, ve, Re, xe, re, Kr, h0, Ur, K0, Pr, sr, Cr, mr, Sr, F0, Q0, ir, J0, X0, u0, D, I0], kn = Gs(rn) ? n(rn) : u(se[2], rn);
                  return [27, [0, y0, kn, lr([0, k], 0, 0)]];
                }
                var vn = x(U0e, 0, _);
                if (vn[0] === 0) var Je = I, en = vn[1];
                else var Ne = function(_n, Cn) {
                  return o(Qe(_n, Di, 94), _n, Cn);
                }, Je = o(vn[1][2], I, Ne), en = 0;
                return [19, [0, Je, 0, lr(0, [0, en], 0)]];
              }
              var jr = 0;
              function $r(_) {
                return cr(jr, qr, _);
              }
              function ne(_) {
                var k = u(se[7], _), I = x(B0e, 0, _);
                if (I[0] === 0) var Y = k, y0 = I[1];
                else var U = function(sr, Pr) {
                  return o(Qe(sr, Di, 95), sr, Pr);
                }, Y = o(I[1][2], k, U), y0 = 0;
                var P0 = _[19];
                if (P0) {
                  var I0 = Y[2], D = 0;
                  if (I0[0] === 14) {
                    var u0 = I0[1], X0 = 0, J0 = u0[1];
                    if (typeof J0 != "number" && J0[0] === 0) {
                      var ir = u0[2], Q0 = 1 < un(ir) ? 1 : 0;
                      if (Q0) var F0 = It(ir, un(ir) - 1 | 0), Sr = It(ir, 0) === F0 ? 1 : 0;
                      else var Sr = Q0;
                      var mr = Sr && [0, m7(ir, 1, un(ir) - 2 | 0)], Cr = mr;
                      X0 = 1;
                    }
                    X0 || (D = 1);
                  } else D = 1;
                  if (D) var Cr = 0;
                } else var Cr = P0;
                return [19, [0, Y, Cr, lr(0, [0, y0], 0)]];
              }
              var Qr = 0;
              function be(_) {
                return cr(Qr, ne, _);
              }
              function ae(_) {
                var k = A0(_), I = 0;
                if (typeof k != "number" && k[0] === 4 && !n0(k[3], R0e)) {
                  ie(_);
                  var U = A0(_);
                  if (typeof U != "number" && U[0] === 2) return i(_, U[1]);
                  St(j0e, _), I = 1;
                }
                return I || St(G0e, _), [0, j1(_), M0e];
              }
              function pe(_, k, I) {
                function U(D) {
                  return _ ? u(mn[2], D) : o(se[13], 0, D);
                }
                var Y = Yn(1, I);
                if (typeof Y == "number") switch (Y) {
                  case 1:
                  case 9:
                  case 113:
                    return [0, U(I), 0];
                }
                else if (Y[0] === 4 && !n0(Y[3], L0e)) {
                  var y0 = z7(I);
                  return ie(I), [0, y0, [0, U(I)]];
                }
                var P0 = A0(I);
                if (k && typeof P0 == "number") {
                  var I0 = 0;
                  if ((P0 === 46 || P0 === 61) && (I0 = 1), I0) return je(I, k[1]), ie(I), [0, u(mn[2], I), 0];
                }
                return [0, U(I), 0];
              }
              function oe(_, k) {
                var I = A0(_);
                if (typeof I == "number" && Yt === I) {
                  var U = cr(0, function(Ae) {
                    ie(Ae);
                    var cn = A0(Ae);
                    return typeof cn != "number" && cn[0] === 4 && !n0(cn[3], P0e) ? (ie(Ae), 2 <= k ? [0, o(se[13], 0, Ae)] : [0, u(mn[2], Ae)]) : (St(D0e, Ae), 0);
                  }, _), Y = U[2], y0 = Y && [0, [0, U[1], Y[1]]], P0 = y0 && [0, [1, y0[1]]];
                  return P0;
                }
                Y0(_, 0);
                for (var I0 = 0, D = 0; ; ) {
                  var u0 = I0 ? I0[1] : 1, X0 = A0(_);
                  if (typeof X0 == "number") {
                    var J0 = 0;
                    if ((X0 === 1 || Pn === X0) && (J0 = 1), J0) {
                      var ir = ye(D);
                      return Y0(_, 1), [0, [0, ir]];
                    }
                  }
                  if (1 - u0 && je(_, 84), k === 2) {
                    var Q0 = A0(_), F0 = 0;
                    if (typeof Q0 == "number") if (Q0 === 46) var Sr = I0e;
                    else if (Q0 === 61) var Sr = O0e;
                    else F0 = 1;
                    else F0 = 1;
                    if (F0) var Sr = 0;
                    var mr = A0(_), Cr = 0;
                    if (typeof mr == "number") {
                      var sr = 0;
                      if (mr !== 46 && mr !== 61 && (sr = 1), !sr) {
                        var Pr = 1;
                        Cr = 1;
                      }
                    }
                    if (!Cr) var Pr = 0;
                    if (Pr) {
                      var K0 = z7(_), Ur = A0(_), h0 = 0;
                      if (typeof Ur == "number") switch (Ur) {
                        case 1:
                        case 9:
                        case 113:
                          e(0, _, K0);
                          var Ie = [0, 0, 0, K0];
                          h0 = 1;
                          break;
                      }
                      else if (Ur[0] === 4 && !n0(Ur[3], A0e)) {
                        var Kr = Yn(1, _), re = 0;
                        if (typeof Kr == "number") switch (Kr) {
                          case 1:
                          case 9:
                          case 113:
                            var xe = [0, Sr, 0, u(mn[2], _)];
                            re = 1;
                            break;
                        }
                        else if (Kr[0] === 4 && !n0(Kr[3], N0e)) {
                          var Re = z7(_);
                          ie(_);
                          var xe = [0, Sr, [0, u(mn[2], _)], Re];
                          re = 1;
                        }
                        if (!re) {
                          e(0, _, K0), ie(_);
                          var xe = [0, 0, [0, o(se[13], 0, _)], K0];
                        }
                        var Ie = xe;
                        h0 = 1;
                      }
                      if (!h0) var ve = pe(1, 0, _), Ie = [0, Sr, ve[2], ve[1]];
                      var Me = Ie;
                    } else var Ge = pe(0, 0, _), Me = [0, 0, Ge[2], Ge[1]];
                    var We = Me;
                  } else var an = pe(1, T0e, _), We = [0, 0, an[2], an[1]];
                  var I0 = [0, xu(_, 9)], D = [0, We, D];
                }
              }
              function ce(_, k) {
                var I = x(0, 0, _);
                if (I[0] === 0) return [0, I[1], k];
                function U(Y, y0) {
                  var P0 = y0[1];
                  return [0, P0, ur(Qe(Y, hA, 96), Y, P0, y0[2])];
                }
                return [0, 0, o(I[1][2], k, U)];
              }
              function ge(_) {
                var k = _s(1, _), I = pr(k);
                Y0(k, 50);
                var U = A0(k), Y = 0;
                if (typeof U == "number") switch (U) {
                  case 46:
                    if (fu(k)) {
                      Y0(k, 46);
                      var y0 = A0(k), P0 = 0;
                      if (typeof y0 == "number") {
                        var I0 = 0;
                        if (Yt !== y0 && y0 && (I0 = 1), !I0) {
                          var J0 = 1;
                          Y = 2, P0 = 1;
                        }
                      }
                      if (!P0) {
                        var D = 1;
                        Y = 1;
                      }
                    }
                    break;
                  case 61:
                    if (fu(k)) {
                      var u0 = Yn(1, k), X0 = 0;
                      if (typeof u0 == "number") switch (u0) {
                        case 0:
                          ie(k);
                          var J0 = 0;
                          Y = 2, X0 = 2;
                          break;
                        case 106:
                          ie(k), St(0, k);
                          var J0 = 0;
                          Y = 2, X0 = 2;
                          break;
                        case 9:
                          X0 = 1;
                          break;
                      }
                      else u0[0] === 4 && !n0(u0[3], C0e) && (X0 = 1);
                      switch (X0) {
                        case 2:
                          break;
                        case 0:
                          ie(k);
                          var D = 0;
                          Y = 1;
                          break;
                        default:
                          var D = 2;
                          Y = 1;
                      }
                    }
                    break;
                  case 0:
                  case 106:
                    var J0 = 2;
                    Y = 2;
                    break;
                }
                else if (U[0] === 2) {
                  var ir = ce(k, i(k, U[1])), Q0 = lr([0, I], [0, ir[1]], 0);
                  return [25, [0, 2, ir[2], 0, 0, Q0]];
                }
                switch (Y) {
                  case 0:
                    var D = 2;
                    break;
                  case 1:
                    break;
                  default:
                    var F0 = oe(k, J0), Sr = ce(k, ae(k)), mr = lr([0, I], [0, Sr[1]], 0);
                    return [25, [0, J0, Sr[2], 0, F0, mr]];
                }
                var Cr = 2 <= D ? o(se[13], 0, k) : u(mn[2], k), sr = A0(k), Pr = 0;
                if (typeof sr == "number" && sr === 9) {
                  Y0(k, 9);
                  var K0 = oe(k, D);
                  Pr = 1;
                }
                if (!Pr) var K0 = 0;
                var Ur = ce(k, ae(k)), h0 = lr([0, I], [0, Ur[1]], 0);
                return [25, [0, D, Ur[2], [0, Cr], K0, h0]];
              }
              var q0 = 0;
              function Fr(_) {
                return cr(q0, ge, _);
              }
              return N(p, function(_) {
                var k = Pe(_), I = pr(_);
                return Y0(_, 8), [0, k, [15, [0, lr([0, I], [0, c(_)[1]], 0)]]];
              }), N(y, function(_) {
                var k = pr(_), I = cr(0, function(X0) {
                  Y0(X0, 32);
                  var J0 = 0;
                  if (A0(X0) !== 8 && !x2(X0)) {
                    var ir = o(se[13], 0, X0), Q0 = ir[2][1];
                    1 - o(Mu[3], Q0, X0[3]) && je(X0, [15, Q0]);
                    var F0 = [0, ir];
                    J0 = 1;
                  }
                  if (!J0) var F0 = 0;
                  var Sr = x(0, 0, X0), mr = 0;
                  if (Sr[0] === 0) var Cr = Sr[1];
                  else {
                    var sr = Sr[1];
                    if (F0) {
                      var Pr = function(xe, Re) {
                        return o(Qe(xe, Nv, 97), xe, Re);
                      }, K0 = [0, o(sr[2], F0[1], Pr)], Ur = 0;
                      mr = 1;
                    } else var Cr = sr[1];
                  }
                  if (!mr) var K0 = F0, Ur = Cr;
                  return [0, K0, Ur];
                }, _), U = I[2], Y = U[1], y0 = I[1], P0 = Y === 0 ? 1 : 0;
                if (P0) var I0 = _[8], D = I0 || _[9], u0 = 1 - D;
                else var u0 = P0;
                return u0 && ue(_, [0, y0, 35]), [0, y0, [1, [0, Y, lr([0, k], [0, U[2]], 0)]]];
              }), N(T, function(_) {
                var k = pr(_), I = cr(0, function(P0) {
                  Y0(P0, 35);
                  var I0 = 0;
                  if (A0(P0) !== 8 && !x2(P0)) {
                    var D = o(se[13], 0, P0), u0 = D[2][1];
                    1 - o(Mu[3], u0, P0[3]) && je(P0, [15, u0]);
                    var X0 = [0, D];
                    I0 = 1;
                  }
                  if (!I0) var X0 = 0;
                  var J0 = x(0, 0, P0), ir = 0;
                  if (J0[0] === 0) var Q0 = J0[1];
                  else {
                    var F0 = J0[1];
                    if (X0) {
                      var Sr = function(Ur, h0) {
                        return o(Qe(Ur, Nv, 98), Ur, h0);
                      }, mr = [0, o(F0[2], X0[1], Sr)], Cr = 0;
                      ir = 1;
                    } else var Q0 = F0[1];
                  }
                  if (!ir) var mr = X0, Cr = Q0;
                  return [0, mr, Cr];
                }, _), U = I[2], Y = I[1];
                1 - _[8] && ue(_, [0, Y, 34]);
                var y0 = lr([0, k], [0, U[2]], 0);
                return [0, Y, [3, [0, U[1], y0]]];
              }), N(E, function(_) {
                var k = cr(0, function(U) {
                  var Y = pr(U);
                  Y0(U, 26);
                  var y0 = on(Y, pr(U));
                  Y0(U, 4);
                  var P0 = u(se[7], U);
                  Y0(U, 5);
                  var I0 = u(se[2], U), D = 1 - U[5], u0 = D && nb(I0);
                  return u0 && M1(U, I0[1]), [36, [0, P0, I0, lr([0, y0], 0, 0)]];
                }, _), I = k[1];
                return V7(_, [0, I, 38]), [0, I, k[2]];
              }), N(d, function(_) {
                var k = u(se[15], _), I = k[1], U = c(_);
                function Y(y0, P0) {
                  return ur(Qe(y0, Y8, 99), y0, I, P0);
                }
                return [0, I, [0, o(U[2], k[2], Y)]];
              }), N(w, function(_, k) {
                1 - fu(k) && je(k, 10);
                var I = on(_, pr(k));
                Y0(k, 61), Ku(k, 1);
                var U = u(mn[2], k), Y = A0(k) === 98 ? ys(k, U) : U, y0 = u(mn[3], k);
                Y0(k, 82);
                var P0 = u(mn[1], k);
                k7(k);
                var I0 = x(0, 0, k);
                if (I0[0] === 0) var u0 = P0, X0 = I0[1];
                else var D = function(J0, ir) {
                  return o(Qe(J0, _v, ti), J0, ir);
                }, u0 = o(I0[1][2], P0, D), X0 = 0;
                return [0, Y, y0, u0, lr([0, I], [0, X0], 0)];
              }), N(G, function(_) {
                return cr(0, function(k) {
                  var I = pr(k);
                  return Y0(k, 60), [11, o(w, I, k)];
                }, _);
              }), N(A, function(_) {
                if (I9(1, _) && !se0(1, _)) {
                  var k = cr(0, u(w, 0), _);
                  return [0, k[1], [32, k[2]]];
                }
                return u(se[2], _);
              }), N(S, function(_, k, I) {
                var U = _ && _[1];
                1 - fu(I) && je(I, 11);
                var Y = on(k, pr(I));
                Y0(I, 62);
                var y0 = pr(I);
                Y0(I, 61);
                var P0 = on(Y, y0);
                Ku(I, 1);
                var I0 = u(mn[2], I), D = A0(I) === 98 ? ys(I, I0) : I0, u0 = u(mn[3], I), X0 = A0(I), J0 = 0;
                if (typeof X0 == "number" && X0 === 86) {
                  Y0(I, 86);
                  var ir = [0, u(mn[1], I)];
                  J0 = 1;
                }
                if (!J0) var ir = 0;
                if (U) {
                  var Q0 = A0(I), F0 = 0;
                  if (typeof Q0 == "number" && Q0 === 82) {
                    je(I, 70), ie(I);
                    var Sr = 0;
                    if (A0(I) !== 8 && !x2(I)) {
                      var mr = [0, u(mn[1], I)];
                      Sr = 1;
                    }
                    if (!Sr) var mr = 0;
                  } else F0 = 1;
                  if (F0) var mr = 0;
                  var Cr = mr;
                } else {
                  Y0(I, 82);
                  var Cr = [0, u(mn[1], I)];
                }
                k7(I);
                var sr = x(0, 0, I);
                if (sr[0] === 0) var Pr = Cr, K0 = ir, Ur = u0, h0 = D, Kr = sr[1];
                else {
                  var re = sr[1][2];
                  if (Cr) var xe = function(en, _n) {
                    return o(Qe(en, _v, R7), en, _n);
                  }, Pr = [0, o(re, Cr[1], xe)], K0 = ir, Ur = u0, h0 = D, Kr = 0;
                  else if (ir) var Re = 0, ve = function(en, _n) {
                    return o(Qe(en, _v, Ri), en, _n);
                  }, Pr = Re, K0 = [0, o(re, ir[1], ve)], Ur = u0, h0 = D, Kr = 0;
                  else if (u0) var Ie = 0, Ge = 0, Me = function(en, _n) {
                    return o(Qe(en, bF, s7), en, _n);
                  }, Pr = Ie, K0 = Ge, Ur = [0, o(re, u0[1], Me)], h0 = D, Kr = 0;
                  else var an = 0, We = 0, Ae = 0, Pr = an, K0 = We, Ur = Ae, cn = 0, h0 = o(re, D, function(en, _n) {
                    return o(Qe(en, Nv, L7), en, _n);
                  }), Kr = cn;
                }
                return [0, h0, Ur, Pr, K0, lr([0, P0], [0, Kr], 0)];
              }), N(M, function(_) {
                return cr(0, function(k) {
                  var I = pr(k);
                  return Y0(k, 60), [12, ur(S, F0e, I, k)];
                }, _);
              }), N(K, function(_) {
                var k = Yn(1, _);
                if (typeof k == "number" && k === 61) {
                  var I = cr(0, o(S, g0e, 0), _);
                  return [0, I[1], [33, I[2]]];
                }
                return u(se[2], _);
              }), N(V, function(_, k) {
                1 - fu(k) && je(k, 16);
                var I = on(_, pr(k));
                Y0(k, 53);
                var U = u(mn[2], k), Y = A0(k) === 41 ? U : ys(k, U), y0 = u(mn[3], k), P0 = A0(k) === 41 ? y0 : oi(k, y0), I0 = u(mn[7], k), D = c(k);
                function u0(ir, Q0) {
                  var F0 = Q0[1];
                  return [0, F0, ur(Qe(ir, qH, j7), ir, F0, Q0[2])];
                }
                var X0 = o(D[2], I0[2], u0), J0 = lr([0, I], 0, 0);
                return [0, Y, P0, I0[1], X0, J0];
              }), N(f0, function(_) {
                return cr(0, function(k) {
                  var I = pr(k);
                  return Y0(k, 60), [8, o(V, I, k)];
                }, _);
              }), N(m0, function(_) {
                var k = I9(1, _), I = 1, U = k || ve0(I, _);
                if (U) {
                  var Y = cr(0, u(V, 0), _);
                  return [0, Y[1], [26, Y[2]]];
                }
                return be(_);
              }), N(k0, function(_, k) {
                var I = _s(1, k), U = on(_, pr(I));
                Y0(I, 40);
                var Y = o(se[13], 0, I), y0 = A0(I), P0 = 0;
                if (typeof y0 == "number") {
                  var I0 = 0;
                  if (y0 !== 98 && y0 && (I0 = 1), !I0) {
                    var D = ys(I, Y);
                    P0 = 1;
                  }
                }
                if (!P0) var D = Y;
                var u0 = u(mn[3], I), X0 = A0(I), J0 = 0;
                if (typeof X0 == "number" && !X0) {
                  var ir = oi(I, u0);
                  J0 = 1;
                }
                if (!J0) var ir = u0;
                var Q0 = xu(I, 41);
                if (Q0) {
                  var F0 = u(mn[5], I), Sr = A0(I), mr = 0;
                  if (typeof Sr == "number" && !Sr) {
                    var Cr = $t(I), sr = function(Fn, vt) {
                      return _u(u(Qe(Fn, ZU, 36), Fn), vt);
                    }, Pr = [0, o(Cr[2], F0, sr)];
                    mr = 1;
                  }
                  if (!mr) var Pr = [0, F0];
                  var K0 = Pr;
                } else var K0 = Q0;
                var Ur = A0(I), h0 = 0;
                if (typeof Ur != "number" && Ur[0] === 4 && !n0(Ur[3], S0e)) {
                  ie(I);
                  for (var Kr = 0; ; ) {
                    var re = [0, u(mn[5], I), Kr], xe = A0(I);
                    if (typeof xe == "number" && xe === 9) {
                      Y0(I, 9);
                      var Kr = re;
                      continue;
                    }
                    var Re = ye(re), ve = A0(I), Ie = 0;
                    if (typeof ve == "number" && !ve) {
                      var Ge = de0(I, Re);
                      Ie = 1;
                    }
                    if (!Ie) var Ge = Re;
                    var Me = Ge;
                    h0 = 1;
                    break;
                  }
                }
                if (!h0) var Me = 0;
                var an = A0(I), We = 0;
                if (typeof an == "number" && an === 52) {
                  var Ae = o(Us[5], I, 0), cn = A0(I), rn = 0;
                  if (typeof cn == "number" && !cn) {
                    var kn = [0, ke0(I, Ae)];
                    rn = 1;
                  }
                  if (!rn) var kn = [0, Ae];
                  var vn = kn;
                  We = 1;
                }
                if (!We) var vn = 0;
                var Ne = o(mn[6], 1, I), Je = c(I);
                function en(Cn, Hn) {
                  var Fn = Hn[1];
                  return [0, Fn, ur(Qe(Cn, qH, Yt), Cn, Fn, Hn[2])];
                }
                var _n = o(Je[2], Ne, en);
                return [0, D, ir, _n, K0, Me, vn, lr([0, U], 0, 0)];
              }), N(g0, function(_) {
                return cr(0, function(k) {
                  var I = pr(k);
                  return Y0(k, 60), [5, o(k0, I, k)];
                }, _);
              }), N(e0, function(_, k) {
                var I = _ && _[1], U = on(I, pr(k));
                Y0(k, 15);
                var Y = ys(k, o(se[13], 0, k)), y0 = cr(0, function(mr) {
                  var Cr = oi(mr, u(mn[3], mr)), sr = u(mn[8], mr);
                  Y0(mr, 86);
                  var Pr = u(mn[1], mr);
                  Ku(mr, 1);
                  var K0 = A0(mr);
                  if (k7(mr), K0 === 66) var Ur = $t(mr), h0 = function(re, xe) {
                    return o(Qe(re, _v, 31), re, xe);
                  }, Kr = o(Ur[2], Pr, h0);
                  else var Kr = Pr;
                  return [12, [0, Cr, sr, Kr, 0]];
                }, k), P0 = u(mn[11], k), I0 = x(0, 0, k);
                if (I0[0] === 0) var D = P0, u0 = y0, X0 = I0[1];
                else {
                  var J0 = I0[1][2];
                  if (P0) var ir = function(Pr, K0) {
                    return o(Qe(Pr, kH, Zc), Pr, K0);
                  }, D = [0, o(J0, P0[1], ir)], u0 = y0, X0 = 0;
                  else var Q0 = 0, D = Q0, F0 = 0, u0 = o(J0, y0, function(Pr, K0) {
                    return o(Qe(Pr, _v, is), Pr, K0);
                  }), X0 = F0;
                }
                var Sr = [0, u0[1], u0];
                return [0, Y, Sr, D, lr([0, U], [0, X0], 0)];
              }), N(x0, function(_) {
                return cr(0, function(k) {
                  var I = pr(k);
                  Y0(k, 60);
                  var U = A0(k), Y = 0;
                  return typeof U == "number" && U === 64 && (je(k, 67), Y0(k, 64), Y = 1), [7, o(e0, [0, I], k)];
                }, _);
              }), N(l, function(_, k) {
                var I = on(k, pr(_));
                Y0(_, 24);
                var U = o(se[13], E0e, _), Y = u(mn[9], _), y0 = x(0, 0, _);
                if (y0[0] === 0) var I0 = Y, D = y0[1];
                else var P0 = function(u0, X0) {
                  return o(Qe(u0, OE, Fv), u0, X0);
                }, I0 = o(y0[1][2], Y, P0), D = 0;
                return [0, U, I0, lr([0, I], [0, D], 0)];
              }), N(c0, function(_) {
                return cr(0, function(k) {
                  var I = pr(k);
                  return Y0(k, 60), [13, o(l, k, I)];
                }, _);
              }), N(t0, function(_, k) {
                var I = Pe(k), U = pr(k);
                Y0(k, 60);
                var Y = on(U, pr(k));
                return Zl(k, w0e), !_ && A0(k) !== 10 ? cr([0, I], function(y0) {
                  var P0 = A0(y0), I0 = 0;
                  if (typeof P0 != "number" && P0[0] === 2) {
                    var D = i(y0, P0[1]), u0 = $t(y0), X0 = function(Cr, sr) {
                      var Pr = sr[1];
                      return [0, Pr, ur(Qe(Cr, hA, 39), Cr, Pr, sr[2])];
                    }, J0 = [1, o(u0[2], D, X0)];
                    I0 = 1;
                  }
                  if (!I0) var J0 = [0, ys(y0, o(se[13], 0, y0))];
                  var ir = gL(0, function(mr) {
                    var Cr = pr(mr);
                    Y0(mr, 0);
                    for (var sr = 0, Pr = 0; ; ) {
                      var K0 = A0(mr);
                      if (typeof K0 == "number") {
                        var Ur = 0;
                        if ((K0 === 1 || Pn === K0) && (Ur = 1), Ur) {
                          var h0 = ye(Pr), Kr = h0 === 0 ? 1 : 0, re = Kr && pr(mr);
                          return Y0(mr, 1), [0, [0, h0, yu([0, Cr], [0, c(mr)[1]], re, 0)], sr];
                        }
                      }
                      var xe = o(w0, h0e, mr), Re = xe[2], ve = 0;
                      if (sr) if (sr[1]) if (Re[0] === 10) {
                        je(mr, 79);
                        var Ae = sr;
                      } else ve = 1;
                      else switch (Re[0]) {
                        case 6:
                          var Ie = Re[1][2], Ge = 0;
                          if (Ie) switch (Ie[1][0]) {
                            case 4:
                            case 6:
                              Ge = 1;
                              break;
                          }
                          Ge || je(mr, 79);
                          var Ae = sr;
                          break;
                        case 10:
                          je(mr, 78);
                          var Ae = sr;
                          break;
                        default:
                          ve = 1;
                      }
                      else switch (Re[0]) {
                        case 6:
                          var Me = Re[1][2], an = 0;
                          if (Me) switch (Me[1][0]) {
                            case 4:
                            case 6:
                              var We = sr;
                              an = 1;
                              break;
                          }
                          if (!an) var We = d0e;
                          var Ae = We;
                          break;
                        case 10:
                          var Ae = k0e;
                          break;
                        default:
                          ve = 1;
                      }
                      if (ve) var Ae = sr;
                      var sr = Ae, Pr = [0, xe, Pr];
                    }
                  }, y0), Q0 = ir[2], F0 = Q0 && Q0[1], Sr = lr([0, Y], 0, 0);
                  return [9, [0, J0, ir[1], F0, Sr]];
                }, k) : cr([0, I], u(o0, Y), k);
              }), N(o0, function(_, k) {
                var I = pr(k);
                Y0(k, 10);
                var U = pr(k);
                Zl(k, y0e);
                var Y = pl([0, _, [0, I, [0, U, [0, pr(k), 0]]]]), y0 = u(mn[9], k), P0 = x(0, 0, k);
                if (P0[0] === 0) var u0 = P0[1], X0 = y0;
                else var I0 = 0, D = function(J0, ir) {
                  return o(Qe(J0, OE, Xt), J0, ir);
                }, u0 = I0, X0 = o(P0[1][2], y0, D);
                return [10, [0, X0, lr([0, Y], [0, u0], 0)]];
              }), N(w0, function(_, k) {
                var I = _ && _[1];
                1 - fu(k) && je(k, 13);
                var U = Yn(1, k);
                if (typeof U == "number") switch (U) {
                  case 24:
                    return u(c0, k);
                  case 40:
                    return u(g0, k);
                  case 46:
                    if (A0(k) === 50) return Fr(k);
                    break;
                  case 49:
                    if (I) return o(X, [0, I], k);
                    break;
                  case 53:
                    return u(f0, k);
                  case 61:
                    var Y = A0(k);
                    return typeof Y == "number" && Y === 50 && I ? Fr(k) : u(G, k);
                  case 62:
                    return u(M, k);
                  case 15:
                  case 64:
                    return u(x0, k);
                }
                else if (U[0] === 4 && !n0(U[3], _0e)) return o(t0, I, k);
                if (I) {
                  var y0 = A0(k);
                  return typeof y0 == "number" && y0 === 50 ? (je(k, 82), u(se[2], k)) : u(c0, k);
                }
                return u(se[2], k);
              }), N(_0, function(_) {
                Zl(_, b0e);
                var k = A0(_);
                if (typeof k != "number" && k[0] === 2) return i(_, k[1]);
                var I = [0, Pe(_), p0e];
                return St(m0e, _), I;
              }), N(E0, function(_) {
                var k = u(_0, _), I = k[2], U = k[1], Y = x(0, 0, _);
                if (Y[0] === 0) return [0, [0, U, I], Y[1]];
                var y0 = 0;
                function P0(I0, D) {
                  return ur(Qe(I0, hA, cf), I0, U, D);
                }
                return [0, [0, U, o(Y[1][2], I, P0)], y0];
              }), N(U0, function(_, k, I) {
                var U = _ ? _[1] : 1, Y = A0(k);
                if (typeof Y == "number") {
                  var y0 = 0;
                  if ((Y === 1 || Pn === Y) && (y0 = 1), y0) return ye(I);
                }
                1 - U && je(k, 85);
                var P0 = cr(0, function(I0) {
                  var D = z7(I0), u0 = A0(I0), X0 = 0;
                  if (typeof u0 != "number" && u0[0] === 4 && !n0(u0[3], l0e)) {
                    ie(I0);
                    var J0 = [0, z7(I0)];
                    X0 = 1;
                  }
                  if (!X0) var J0 = 0;
                  return [0, D, J0];
                }, k);
                return ur(U0, [0, xu(k, 9)], k, [0, P0, I]);
              }), N(b, function(_, k) {
                return Du(function(I) {
                  var U = I[2];
                  return U[2] ? 0 : e(v0e, _, U[1]);
                }, k);
              }), N(R0, function(_, k) {
                var I = ne0(1, _s(1, k)), U = pr(I), Y = Pe(I);
                Y0(I, 49);
                var y0 = A0(I);
                if (typeof y0 == "number") {
                  if (53 <= y0) {
                    if (!(63 <= y0)) switch (y0 + cU | 0) {
                      case 0:
                        return cr([0, Y], function(D) {
                          1 - fu(D) && je(D, 15);
                          var u0 = cr(0, u(V, 0), D), X0 = [0, u0[1], [26, u0[2]]];
                          return [18, [0, [0, X0], 0, 0, 0, lr([0, U], 0, 0)]];
                        }, I);
                      case 8:
                        if (Yn(1, I) !== 0) return cr([0, Y], function(D) {
                          1 - fu(D) && je(D, 15);
                          var u0 = Yn(1, D);
                          if (typeof u0 == "number") {
                            if (u0 === 48) return je(D, 0), Y0(D, 61), [18, [0, 0, 0, 0, 0, lr([0, U], 0, 0)]];
                            if (Yt === u0) {
                              Y0(D, 61);
                              var X0 = Pe(D);
                              Y0(D, Yt);
                              var J0 = u(E0, D), ir = lr([0, U], [0, J0[2]], 0);
                              return [18, [0, 0, [0, [1, [0, X0, 0]]], [0, J0[1]], 0, ir]];
                            }
                          }
                          var Q0 = cr(0, u(w, 0), D), F0 = [0, Q0[1], [32, Q0[2]]];
                          return [18, [0, [0, F0], 0, 0, 0, lr([0, U], 0, 0)]];
                        }, I);
                        break;
                      case 9:
                        return cr([0, Y], function(D) {
                          var u0 = cr(0, function(J0) {
                            return u(o(S, 0, 0), J0);
                          }, D), X0 = [0, u0[1], [33, u0[2]]];
                          return [18, [0, [0, X0], 0, 0, 0, lr([0, U], 0, 0)]];
                        }, I);
                    }
                  } else if (y0 === 36) return cr([0, Y], function(D) {
                    var u0 = on(U, pr(D)), X0 = cr(0, function(Ur) {
                      return Y0(Ur, 36);
                    }, D), J0 = te0(1, D);
                    if (Gs(J0)) var ir = 0, Q0 = [0, u(Vn[10], J0)];
                    else if ($l(J0)) var ir = 0, Q0 = [0, o(Us[3], J0, _)];
                    else if (A0(J0) === 48) var ir = 0, Q0 = [0, u(Vn[11], J0)];
                    else {
                      var F0 = u(se[10], J0), Sr = x(0, 0, J0);
                      if (Sr[0] === 0) var sr = Sr[1], Pr = F0;
                      else var mr = 0, Cr = function(Kr, re) {
                        return o(Qe(Kr, Di, T7), Kr, re);
                      }, sr = mr, Pr = o(Sr[1][2], F0, Cr);
                      var ir = sr, Q0 = [1, Pr];
                    }
                    var K0 = lr([0, u0], [0, ir], 0);
                    return [17, [0, X0[1], Q0, K0]];
                  }, I);
                }
                if ($l(I)) return cr([0, Y], function(D) {
                  var u0 = o(Us[3], D, _);
                  return [18, [0, [0, u0], 0, 0, 1, lr([0, U], 0, 0)]];
                }, I);
                if (Gs(I)) return cr([0, Y], function(D) {
                  u(A9(D), _);
                  var u0 = u(Vn[10], D);
                  return [18, [0, [0, u0], 0, 0, 1, lr([0, U], 0, 0)]];
                }, I);
                if (typeof y0 == "number") if (29 <= y0) {
                  if (y0 === 48) {
                    if (I[27][1]) return cr([0, Y], function(D) {
                      var u0 = o(se[3], [0, _], D);
                      return [18, [0, [0, u0], 0, 0, 1, lr([0, U], 0, 0)]];
                    }, I);
                  } else if (Yt === y0) return cr([0, Y], function(D) {
                    var u0 = Pe(D);
                    Y0(D, Yt);
                    var X0 = D[27][3], J0 = A0(D), ir = 0;
                    if (typeof J0 != "number" && J0[0] === 4 && !n0(J0[3], c0e)) {
                      ie(D);
                      var Q0 = X0 ? [0, o(se[13], 0, D)] : (je(D, 13), 0), F0 = Q0;
                      ir = 1;
                    }
                    if (!ir) var F0 = 0;
                    var Sr = u(E0, D), mr = lr([0, U], [0, Sr[2]], 0);
                    return [18, [0, 0, [0, [1, [0, u0, F0]]], [0, Sr[1]], 1, mr]];
                  }, I);
                } else {
                  var P0 = 0;
                  if ((y0 === 24 || 27 <= y0) && (P0 = 1), P0) return cr([0, Y], function(D) {
                    var u0 = o(se[3], [0, _], D);
                    return [18, [0, [0, u0], 0, 0, 1, lr([0, U], 0, 0)]];
                  }, I);
                }
                var I0 = xu(I, 61) ? 0 : 1;
                return xu(I, 0) ? cr([0, Y], function(D) {
                  var u0 = ur(U0, 0, D, 0);
                  Y0(D, 1);
                  var X0 = A0(D), J0 = 0;
                  if (typeof X0 != "number" && X0[0] === 4 && !n0(X0[3], a0e)) {
                    var ir = u(E0, D), Q0 = ir[2], F0 = [0, ir[1]];
                    J0 = 1;
                  }
                  if (!J0) {
                    o(b, D, u0);
                    var Sr = x(0, 0, D), mr = Sr[0] === 0 ? Sr[1] : Sr[1][1], Q0 = mr, F0 = 0;
                  }
                  return [18, [0, 0, [0, [0, u0]], F0, I0, lr([0, U], [0, Q0], 0)]];
                }, I) : (St(s0e, I), o(se[3], [0, _], I));
              }), N(X, function(_) {
                var k = _ && _[1];
                function I(Y) {
                  1 - fu(Y) && je(Y, 13);
                  var y0 = pr(Y);
                  Y0(Y, 60);
                  var P0 = ne0(1, _s(1, Y)), I0 = on(y0, pr(P0));
                  Y0(P0, 49);
                  var D = A0(P0);
                  if (typeof D == "number") if (53 <= D) {
                    if (Yt === D) {
                      var u0 = Pe(P0);
                      Y0(P0, Yt);
                      var X0 = P0[27][3], J0 = A0(P0), ir = 0;
                      if (typeof J0 != "number" && J0[0] === 4 && !n0(J0[3], f0e)) {
                        ie(P0);
                        var Q0 = X0 ? [0, o(se[13], 0, P0)] : (je(P0, 13), 0), F0 = Q0;
                        ir = 1;
                      }
                      if (!ir) var F0 = 0;
                      var Sr = u(E0, P0), mr = lr([0, I0], [0, Sr[2]], 0);
                      return [6, [0, 0, 0, [0, [1, [0, u0, F0]]], [0, Sr[1]], mr]];
                    }
                    if (!(63 <= D)) switch (D + cU | 0) {
                      case 0:
                        if (k) {
                          var Cr = cr(0, u(V, 0), P0);
                          return [6, [0, 0, [0, [6, Cr]], 0, 0, lr([0, I0], 0, 0)]];
                        }
                        break;
                      case 8:
                        if (k) {
                          var sr = cr(0, u(w, 0), P0);
                          return [6, [0, 0, [0, [4, sr]], 0, 0, lr([0, I0], 0, 0)]];
                        }
                        break;
                      case 9:
                        var Pr = cr(0, o(S, i0e, 0), P0);
                        return [6, [0, 0, [0, [5, Pr]], 0, 0, lr([0, I0], 0, 0)]];
                    }
                  } else {
                    var K0 = D - 15 | 0;
                    if (!(25 < K0 >>> 0)) switch (K0) {
                      case 21:
                        var Ur = on(I0, pr(P0)), h0 = cr(0, function(Ct) {
                          return Y0(Ct, 36);
                        }, P0), Kr = te0(1, P0), re = A0(Kr), xe = 0;
                        if (typeof re == "number") if (re === 15) var Re = 0, ve = Re, Ie = [0, [1, cr(0, function(Ct) {
                          return o(e0, 0, Ct);
                        }, Kr)]];
                        else if (re === 40) var ve = 0, Ie = [0, [2, cr(0, u(k0, 0), Kr)]];
                        else xe = 1;
                        else xe = 1;
                        if (xe) {
                          var Ge = u(mn[1], Kr), Me = x(0, 0, Kr);
                          if (Me[0] === 0) var Ae = Me[1], cn = Ge;
                          else var an = 0, We = function(Wu, lt) {
                            return o(Qe(Wu, _v, Pn), Wu, lt);
                          }, Ae = an, cn = o(Me[1][2], Ge, We);
                          var ve = Ae, Ie = [0, [3, cn]];
                        }
                        var rn = lr([0, Ur], [0, ve], 0);
                        return [6, [0, [0, h0[1]], Ie, 0, 0, rn]];
                      case 0:
                      case 9:
                      case 12:
                      case 13:
                      case 25:
                        var kn = A0(P0);
                        if (typeof kn == "number") {
                          var vn = 0;
                          if (25 <= kn) if (29 <= kn) {
                            if (kn === 40) {
                              var Ne = [0, [2, cr(0, u(k0, 0), P0)]];
                              vn = 1;
                            }
                          } else 27 <= kn && (vn = 2);
                          else if (kn === 15) {
                            var Ne = [0, [1, cr(0, function(du) {
                              return o(e0, 0, du);
                            }, P0)]];
                            vn = 1;
                          } else 24 <= kn && (vn = 2);
                          var Je = 0;
                          switch (vn) {
                            case 0:
                              break;
                            case 2:
                              var en = 0;
                              typeof kn == "number" ? kn === 27 ? je(P0, 72) : kn === 28 ? je(P0, 71) : en = 1 : en = 1;
                              var Ne = [0, [0, cr(0, function(du) {
                                return o(l, du, 0);
                              }, P0)]];
                              Je = 1;
                              break;
                            default:
                              Je = 1;
                          }
                          if (Je) return [6, [0, 0, Ne, 0, 0, lr([0, I0], 0, 0)]];
                        }
                        throw [0, Sn, o0e];
                    }
                  }
                  var _n = A0(P0), Cn = 0;
                  typeof _n == "number" ? _n === 53 ? je(P0, 74) : _n === 61 ? je(P0, 73) : Cn = 1 : Cn = 1, Y0(P0, 0);
                  var Hn = ur(U0, 0, P0, 0);
                  Y0(P0, 1);
                  var Fn = A0(P0), vt = 0;
                  if (typeof Fn != "number" && Fn[0] === 4 && !n0(Fn[3], x0e)) {
                    var Nt = u(E0, P0), gt = Nt[2], Zt = [0, Nt[1]];
                    vt = 1;
                  }
                  if (!vt) {
                    o(b, P0, Hn);
                    var qt = x(0, 0, P0), Ft = qt[0] === 0 ? qt[1] : qt[1][1], gt = Ft, Zt = 0;
                  }
                  return [6, [0, 0, 0, [0, [0, Hn]], Zt, lr([0, I0], [0, gt], 0)]];
                }
                var U = 0;
                return function(Y) {
                  return cr(U, I, Y);
                };
              }), [0, Rr, Ir, $0, B, Br, E, d, y, T, Ar, w0, X, M, Lr, p, R0, be, Fr, m0, $r, K, P, i0, T0, A, b0, er];
            }(R9), Ge0 = function(t) {
              var n = function y(T, E) {
                return y.fun(T, E);
              }, e = function y(T, E) {
                return y.fun(T, E);
              }, i = function y(T, E) {
                return y.fun(T, E);
              };
              N(n, function(y, T) {
                for (var E = T[2], d = E[2], w = a2(y), G = 0, A = E[1]; ; ) {
                  if (A) {
                    var S = A[1];
                    if (S[0] === 0) {
                      var M = S[1], K = M[2];
                      switch (K[0]) {
                        case 0:
                          var V = K[2], f0 = K[1];
                          switch (f0[0]) {
                            case 0:
                              var m0 = [0, f0[1]];
                              break;
                            case 1:
                              var m0 = [1, f0[1]];
                              break;
                            case 2:
                              var m0 = ke(t0e);
                              break;
                            default:
                              var m0 = [2, f0[1]];
                          }
                          var k0 = V[2], g0 = 0;
                          if (k0[0] === 2) {
                            var e0 = k0[1];
                            if (!e0[1]) {
                              var x0 = [0, e0[3]], l = e0[2];
                              g0 = 1;
                            }
                          }
                          if (!g0) var x0 = 0, l = o(i, y, V);
                          var c0 = [0, [0, [0, M[1], [0, m0, l, x0, K[3]]]], G];
                          break;
                        case 1:
                          ue(y, [0, K[2][1], 97]);
                          var c0 = G;
                          break;
                        default:
                          ue(y, [0, K[2][1], u0e]);
                          var c0 = G;
                      }
                      var G = c0, A = A[2];
                      continue;
                    }
                    var t0 = S[1], o0 = t0[1];
                    if (A[2]) {
                      ue(y, [0, o0, 66]);
                      var A = A[2];
                      continue;
                    }
                    var w0 = t0[2], _0 = w0[2], G = [0, [1, [0, o0, [0, o(i, y, w0[1]), _0]]], G], A = 0;
                    continue;
                  }
                  var E0 = [0, [0, ye(G), w, d]];
                  return [0, T[1], E0];
                }
              });
              function x(y, T) {
                return u(se[23], T) ? [0, o(i, y, T)] : (ue(y, [0, T[1], 26]), 0);
              }
              N(e, function(y, T) {
                for (var E = T[2], d = E[2], w = a2(y), G = 0, A = E[1]; ; ) {
                  if (A) {
                    var S = A[1];
                    switch (S[0]) {
                      case 0:
                        var M = S[1], K = M[2];
                        if (K[0] === 2) {
                          var V = K[1];
                          if (!V[1]) {
                            var G = [0, [0, [0, M[1], [0, V[2], [0, V[3]]]]], G], A = A[2];
                            continue;
                          }
                        }
                        var f0 = x(y, M);
                        if (f0) var m0 = f0[1], k0 = [0, [0, [0, m0[1], [0, m0, 0]]], G];
                        else var k0 = G;
                        var G = k0, A = A[2];
                        continue;
                      case 1:
                        var g0 = S[1], e0 = g0[1];
                        if (A[2]) {
                          ue(y, [0, e0, 65]);
                          var A = A[2];
                          continue;
                        }
                        var x0 = g0[2], l = x(y, x0[1]), c0 = l ? [0, [1, [0, e0, [0, l[1], x0[2]]]], G] : G, G = c0, A = 0;
                        continue;
                      default:
                        var G = [0, [2, S[1]], G], A = A[2];
                        continue;
                    }
                  }
                  var t0 = [1, [0, ye(G), w, d]];
                  return [0, T[1], t0];
                }
              }), N(i, function(y, T) {
                var E = T[2], d = T[1];
                switch (E[0]) {
                  case 0:
                    return o(e, y, [0, d, E[1]]);
                  case 10:
                    var w = E[1], G = w[2][1], A = w[1], S = 0;
                    if (y[5] && js(G) ? ue(y, [0, A, 52]) : S = 1, S && 1 - y[5]) {
                      var M = 0;
                      if (y[17] && qn(G, e0e) ? ue(y, [0, A, 93]) : M = 1, M) {
                        var K = y[18], V = K && qn(G, n0e);
                        V && ue(y, [0, A, 92]);
                      }
                    }
                    return [0, d, [2, [0, w, a2(y), 0]]];
                  case 19:
                    return o(n, y, [0, d, E[1]]);
                  default:
                    return [0, d, [3, [0, d, E]]];
                }
              });
              function c(y) {
                function T(w) {
                  var G = A0(w);
                  return typeof G == "number" && G === 82 ? (Y0(w, 82), [0, u(se[10], w)]) : 0;
                }
                function E(w) {
                  var G = pr(w);
                  Y0(w, 0);
                  for (var A = 0, S = 0, M = 0; ; ) {
                    var K = A0(w);
                    if (typeof K == "number") {
                      var V = 0;
                      if ((K === 1 || Pn === K) && (V = 1), V) {
                        S && ue(w, [0, S[1], 98]);
                        var f0 = ye(M), m0 = pr(w);
                        Y0(w, 1);
                        var k0 = we(w), g0 = A0(w) === 86 ? [1, u(t[9], w)] : a2(w);
                        return [0, [0, f0, g0, yu([0, G], [0, k0], m0, 0)]];
                      }
                    }
                    if (A0(w) === 12) var e0 = pr(w), x0 = cr(0, function(Jr) {
                      return Y0(Jr, 12), p(Jr, y);
                    }, w), l = lr([0, e0], 0, 0), c0 = [0, [1, [0, x0[1], [0, x0[2], l]]]];
                    else {
                      var t0 = Pe(w), o0 = o(se[20], 0, w), w0 = A0(w), _0 = 0;
                      if (typeof w0 == "number" && w0 === 86) {
                        Y0(w, 86);
                        var E0 = cr([0, t0], function(ar) {
                          var _r = p(ar, y);
                          return [0, _r, T(ar)];
                        }, w), U0 = E0[2], b = o0[2];
                        switch (b[0]) {
                          case 0:
                            var R0 = [0, b[1]];
                            break;
                          case 1:
                            var R0 = [1, b[1]];
                            break;
                          case 2:
                            var R0 = ke($Qr);
                            break;
                          default:
                            var R0 = [2, b[1]];
                        }
                        var c0 = [0, [0, [0, E0[1], [0, R0, U0[1], U0[2], 0]]]];
                      } else _0 = 1;
                      if (_0) {
                        var X = o0[2];
                        if (X[0] === 1) {
                          var s0 = X[1], hr = s0[2][1], Ar = s0[1], or = 0;
                          kL(hr) && n0(hr, QQr) && n0(hr, r0e) && (ue(w, [0, Ar, 2]), or = 1), !or && f2(hr) && V7(w, [0, Ar, 55]);
                          var W0 = cr([0, t0], /* @__PURE__ */ function(ar, _r) {
                            return function(Ir) {
                              var fe = [0, _r, [2, [0, ar, a2(Ir), 0]]];
                              return [0, fe, T(Ir)];
                            };
                          }(s0, Ar), w), Lr = W0[2], c0 = [0, [0, [0, W0[1], [0, [1, s0], Lr[1], Lr[2], 1]]]];
                        } else {
                          St(ZQr, w);
                          var c0 = 0;
                        }
                      }
                    }
                    if (c0) {
                      var Tr = c0[1], Hr = A ? (ue(w, [0, Tr[1][1], 66]), 0) : S;
                      if (Tr[0] === 0) var Rr = Hr, Wr = A;
                      else var Or = A0(w) === 9 ? 1 : 0, fr = Or && [0, Pe(w)], Rr = fr, Wr = 1;
                      A0(w) !== 1 && Y0(w, 9);
                      var A = Wr, S = Rr, M = [0, Tr, M];
                      continue;
                    }
                  }
                }
                var d = 0;
                return function(w) {
                  return cr(d, E, w);
                };
              }
              function s(y) {
                function T(d) {
                  var w = pr(d);
                  Y0(d, 6);
                  for (var G = 0; ; ) {
                    var A = A0(d);
                    if (typeof A == "number") {
                      var S = 0;
                      if (13 <= A) Pn === A && (S = 1);
                      else if (7 <= A) switch (A - 7 | 0) {
                        case 2:
                          var M = Pe(d);
                          Y0(d, 9);
                          var G = [0, [2, M], G];
                          continue;
                        case 5:
                          var K = pr(d), V = cr(0, function(_0) {
                            return Y0(_0, 12), p(_0, y);
                          }, d), f0 = V[1], m0 = lr([0, K], 0, 0), k0 = [1, [0, f0, [0, V[2], m0]]];
                          A0(d) !== 7 && (ue(d, [0, f0, 65]), A0(d) === 9 && ie(d));
                          var G = [0, k0, G];
                          continue;
                        case 0:
                          S = 1;
                          break;
                      }
                      if (S) {
                        var g0 = ye(G), e0 = pr(d);
                        Y0(d, 7);
                        var x0 = A0(d) === 86 ? [1, u(t[9], d)] : a2(d);
                        return [1, [0, g0, x0, yu([0, w], [0, we(d)], e0, 0)]];
                      }
                    }
                    var l = cr(0, function(w0) {
                      var _0 = p(w0, y), E0 = A0(w0), U0 = 0;
                      if (typeof E0 == "number" && E0 === 82) {
                        Y0(w0, 82);
                        var b = [0, u(se[10], w0)];
                        U0 = 1;
                      }
                      if (!U0) var b = 0;
                      return [0, _0, b];
                    }, d), c0 = l[2], t0 = [0, [0, l[1], [0, c0[1], c0[2]]]];
                    A0(d) !== 7 && Y0(d, 9);
                    var G = [0, t0, G];
                  }
                }
                var E = 0;
                return function(d) {
                  return cr(E, T, d);
                };
              }
              function p(y, T) {
                var E = A0(y);
                if (typeof E == "number") {
                  if (E === 6) return u(s(T), y);
                  if (!E) return u(c(T), y);
                }
                var d = ur(se[14], y, 0, T);
                return [0, d[1], [2, d[2]]];
              }
              return [0, n, e, i, c, s, p];
            }(mn), une = Zee(se), ine = mn[9];
            function Me0(t, n) {
              var e = A0(n), i = 0;
              if (typeof e == "number" ? e === 28 ? n[5] ? je(n, 55) : n[14] && St(0, n) : e === 58 ? n[17] ? je(n, 2) : n[5] && je(n, 55) : e === 65 ? n[18] && je(n, 2) : i = 1 : i = 1, i) if (dL(e)) gi(n, 55);
              else {
                var x = 0;
                if (typeof e == "number") switch (e) {
                  case 15:
                  case 16:
                  case 17:
                  case 18:
                  case 19:
                  case 20:
                  case 21:
                  case 22:
                  case 23:
                  case 24:
                  case 25:
                  case 26:
                  case 27:
                  case 32:
                  case 33:
                  case 34:
                  case 35:
                  case 36:
                  case 37:
                  case 38:
                  case 39:
                  case 40:
                  case 41:
                  case 43:
                  case 44:
                  case 45:
                  case 46:
                  case 47:
                  case 49:
                  case 50:
                  case 51:
                  case 58:
                  case 59:
                  case 65:
                    var c = 1;
                    x = 1;
                    break;
                }
                else if (e[0] === 4 && xe0(e[3])) {
                  var c = 1;
                  x = 1;
                }
                if (!x) var c = 0;
                var s = 0;
                if (c) var p = c;
                else {
                  var y = hL(e);
                  if (y) var p = y;
                  else {
                    var T = 0;
                    if (typeof e == "number") switch (e) {
                      case 29:
                      case 30:
                      case 31:
                        break;
                      default:
                        T = 1;
                    }
                    else if (e[0] === 4) {
                      var E = e[3];
                      n0(E, XRr) && n0(E, YRr) && n0(E, VRr) && (T = 1);
                    } else T = 1;
                    if (T) {
                      var d = 0;
                      s = 1;
                    } else var p = 1;
                  }
                }
                if (!s) var d = p;
                if (d) St(0, n);
                else {
                  var w = 0;
                  t && oe0(e) ? gi(n, t[1]) : w = 1;
                }
              }
              return z7(n);
            }
            var Be0 = function t(n) {
              return t.fun(n);
            }, jL = function t(n, e, i) {
              return t.fun(n, e, i);
            }, GL = function t(n) {
              return t.fun(n);
            }, qe0 = function t(n, e) {
              return t.fun(n, e);
            }, ML = function t(n, e) {
              return t.fun(n, e);
            }, BL = function t(n, e) {
              return t.fun(n, e);
            }, j9 = function t(n, e) {
              return t.fun(n, e);
            }, xb = function t(n, e) {
              return t.fun(n, e);
            }, G9 = function t(n) {
              return t.fun(n);
            }, Ue0 = function t(n) {
              return t.fun(n);
            }, He0 = function t(n) {
              return t.fun(n);
            }, Xe0 = function t(n, e, i) {
              return t.fun(n, e, i);
            }, Ye0 = function t(n) {
              return t.fun(n);
            }, Ve0 = function t(n) {
              return t.fun(n);
            }, ze0 = Us[3], fne = ci[3], xne = ci[1], one = ci[5], ane = Us[2], cne = Us[1], sne = Us[4], vne = ci[4], lne = ci[6], bne = une[13], pne = Ge0[6], mne = Ge0[3];
            N(Be0, function(t) {
              var n = pr(t), e = ye(n), i = 5;
              r: for (; ; ) {
                if (e) for (var x = e[2], c = e[1], s = c[2], p = c[1], y = s[2], T = 0, E = un(y); ; ) {
                  if (E < (T + 5 | 0)) var d = 0;
                  else {
                    var w = qn(m7(y, T, i), kRr);
                    if (!w) {
                      var T = T + 1 | 0;
                      continue;
                    }
                    var d = w;
                  }
                  if (!d) {
                    var e = x;
                    continue r;
                  }
                  t[30][1] = p[3];
                  var G = ye([0, [0, p, s], x]);
                  break;
                }
                else var G = e;
                if (G === 0) {
                  var A = 0;
                  if (n) {
                    var S = n[1], M = S[2];
                    if (!M[1]) {
                      var K = M[2], V = 0;
                      if (1 <= un(K) && It(K, 0) === 42) {
                        t[30][1] = S[1][3];
                        var f0 = [0, S, 0];
                        A = 1, V = 1;
                      }
                    }
                  }
                  if (!A) var f0 = 0;
                } else var f0 = G;
                var m0 = o(qe0, t, function(c0) {
                  return 0;
                }), k0 = Pe(t);
                Y0(t, Pn);
                var g0 = Mu[1];
                if (le(function(c0, t0) {
                  var o0 = t0[2];
                  switch (o0[0]) {
                    case 17:
                      return fb(t, c0, Rc(0, [0, o0[1][1], ore]));
                    case 18:
                      var w0 = o0[1], _0 = w0[1];
                      if (_0) {
                        if (!w0[2]) {
                          var E0 = _0[1], U0 = E0[2], b = 0;
                          switch (U0[0]) {
                            case 34:
                              var R0 = U0[1][1], X = 0, s0 = le(function(Tr, Hr) {
                                return le(RL, Tr, [0, Hr[2][1], 0]);
                              }, X, R0);
                              return le(function(Tr, Hr) {
                                return fb(t, Tr, Hr);
                              }, c0, s0);
                            case 2:
                            case 23:
                              var hr = U0[1][1];
                              if (hr) var Ar = hr[1];
                              else b = 1;
                              break;
                            case 16:
                            case 26:
                            case 32:
                            case 33:
                              var Ar = U0[1][1];
                              break;
                            default:
                              b = 1;
                          }
                          return b ? c0 : fb(t, c0, Rc(0, [0, E0[1], Ar[2][1]]));
                        }
                      } else {
                        var or = w0[2];
                        if (or) {
                          var W0 = or[1];
                          if (W0[0] === 0) {
                            var Lr = W0[1];
                            return le(function(Tr, Hr) {
                              var Or = Hr[2], fr = Or[2];
                              return fr ? fb(t, Tr, fr[1]) : fb(t, Tr, Or[1]);
                            }, c0, Lr);
                          }
                          return c0;
                        }
                      }
                      return c0;
                    default:
                      return c0;
                  }
                }, g0, m0), m0) var e0 = bl(ye(m0))[1], x0 = yt(bl(m0)[1], e0);
                else var x0 = k0;
                var l = ye(t[2][1]);
                return [0, x0, [0, m0, lr([0, f0], 0, 0), l]];
              }
            }), N(jL, function(t, n, e) {
              for (var i = ee0(1, t), x = ire; ; ) {
                var c = x[3], s = x[2], p = x[1], y = A0(i), T = 0;
                if (typeof y == "number" && Pn === y) var E = [0, i, p, s, c];
                else T = 1;
                if (T) if (u(n, y)) var E = [0, i, p, s, c];
                else {
                  var d = 0;
                  if (typeof y == "number" || y[0] !== 2) d = 1;
                  else {
                    var w = u(e, i), G = [0, w, s], A = w[2];
                    if (A[0] === 19) {
                      var S = A[1][2];
                      if (S) {
                        var M = qn(S[1], ure), K = M && 1 - i[20];
                        K && ue(i, [0, w[1], 43]);
                        var V = M ? _s(1, i) : i, f0 = [0, y, p], m0 = c || M, i = V, x = [0, f0, G, m0];
                        continue;
                      }
                    }
                    var E = [0, i, p, G, c];
                  }
                  if (d) var E = [0, i, p, s, c];
                }
                var k0 = ee0(0, i), g0 = ye(p);
                return Du(function(e0) {
                  if (typeof e0 != "number" && e0[0] === 2) {
                    var x0 = e0[1], l = x0[4];
                    return l && V7(k0, [0, x0[1], 45]);
                  }
                  return ke(Te(xre, Te(wr0(e0), fre)));
                }, g0), [0, k0, E[3], c];
              }
            }), N(GL, function(t) {
              var n = u(Us[6], t), e = A0(t);
              if (typeof e == "number") {
                var i = e - 49 | 0;
                if (!(11 < i >>> 0)) switch (i) {
                  case 0:
                    return o(ht[16], n, t);
                  case 1:
                    u(A9(t), n);
                    var x = Yn(1, t);
                    if (typeof x == "number") {
                      var c = 0;
                      if ((x === 4 || x === 10) && (c = 1), c) return u(ht[17], t);
                    }
                    return u(ht[18], t);
                  case 11:
                    if (Yn(1, t) === 49) return u(A9(t), n), o(ht[12], 0, t);
                    break;
                }
              }
              return o(xb, [0, n], t);
            }), N(qe0, function(t, n) {
              var e = ur(jL, t, n, GL), i = o(ML, n, e[1]), x = e[2];
              return le(function(c, s) {
                return [0, s, c];
              }, i, x);
            }), N(ML, function(t, n) {
              for (var e = 0; ; ) {
                var i = A0(n);
                if (typeof i == "number" && Pn === i || u(t, i)) return ye(e);
                var e = [0, u(GL, n), e];
              }
            }), N(BL, function(t, n) {
              var e = ur(jL, n, t, function(s) {
                return o(xb, 0, s);
              }), i = o(j9, t, e[1]), x = e[2], c = le(function(s, p) {
                return [0, p, s];
              }, i, x);
              return [0, c, e[3]];
            }), N(j9, function(t, n) {
              for (var e = 0; ; ) {
                var i = A0(n);
                if (typeof i == "number" && Pn === i || u(t, i)) return ye(e);
                var e = [0, o(xb, 0, n), e];
              }
            }), N(xb, function(t, n) {
              var e = t && t[1];
              1 - $l(n) && u(A9(n), e);
              var i = A0(n);
              if (typeof i == "number") {
                if (i === 27) return u(ht[27], n);
                if (i === 28) return u(ht[3], n);
              }
              if (Gs(n)) return u(Vn[10], n);
              if ($l(n)) return o(ze0, n, e);
              if (typeof i == "number") {
                var x = i + Wt | 0;
                if (!(14 < x >>> 0)) switch (x) {
                  case 0:
                    if (n[27][1]) return u(Vn[11], n);
                    break;
                  case 5:
                    return u(ht[19], n);
                  case 12:
                    return o(ht[11], 0, n);
                  case 13:
                    return u(ht[25], n);
                  case 14:
                    return u(ht[21], n);
                }
              }
              return u(G9, n);
            }), N(G9, function(t) {
              var n = A0(t);
              if (typeof n == "number") switch (n) {
                case 0:
                  return u(ht[7], t);
                case 8:
                  return u(ht[15], t);
                case 19:
                  return u(ht[22], t);
                case 20:
                  return u(ht[23], t);
                case 22:
                  return u(ht[24], t);
                case 23:
                  return u(ht[4], t);
                case 24:
                  return u(ht[26], t);
                case 25:
                  return u(ht[5], t);
                case 26:
                  return u(ht[6], t);
                case 32:
                  return u(ht[8], t);
                case 35:
                  return u(ht[9], t);
                case 37:
                  return u(ht[14], t);
                case 39:
                  return u(ht[1], t);
                case 59:
                  return u(ht[10], t);
                case 113:
                  return St(ere, t), [0, Pe(t), nre];
                case 16:
                case 43:
                  return u(ht[2], t);
                case 1:
                case 5:
                case 7:
                case 9:
                case 10:
                case 11:
                case 12:
                case 17:
                case 18:
                case 33:
                case 34:
                case 36:
                case 38:
                case 41:
                case 42:
                case 49:
                case 83:
                case 86:
                  return St(tre, t), ie(t), u(G9, t);
              }
              if (Gs(t)) {
                var e = u(Vn[10], t);
                return M1(t, e[1]), e;
              }
              if (typeof n == "number" && n === 28 && Yn(1, t) === 6) {
                var i = Wl(1, t);
                return ue(t, [0, yt(Pe(t), i), 94]), u(ht[17], t);
              }
              return G1(t) ? u(ht[20], t) : ($l(t) && (St(0, t), ie(t)), u(ht[17], t));
            }), N(Ue0, function(t) {
              var n = Pe(t), e = u(ci[1], t), i = A0(t);
              return typeof i == "number" && i === 9 ? ur(ci[7], t, n, [0, e, 0]) : e;
            }), N(He0, function(t) {
              var n = Pe(t), e = u(ci[2], t), i = A0(t);
              if (typeof i == "number" && i === 9) {
                var x = [0, o(R9[1], t, e), 0];
                return [0, ur(ci[7], t, n, x)];
              }
              return e;
            }), N(Xe0, function(t, n, e) {
              var i = n && n[1];
              return cr(0, function(x) {
                var c = 1 - i, s = Me0([0, e], x), p = c && (A0(x) === 85 ? 1 : 0);
                return p && (1 - fu(x) && je(x, 12), Y0(x, 85)), [0, s, u(mn[10], x), p];
              }, t);
            }), N(Ye0, function(t) {
              var n = Pe(t), e = pr(t);
              Y0(t, 0);
              var i = o(j9, function(y) {
                return y === 1 ? 1 : 0;
              }, t), x = i === 0 ? 1 : 0, c = Pe(t), s = x && pr(t);
              Y0(t, 1);
              var p = [0, i, yu([0, e], [0, we(t)], s, 0)];
              return [0, yt(n, c), p];
            }), N(Ve0, function(t) {
              function n(i) {
                var x = pr(i);
                Y0(i, 0);
                var c = o(BL, function(S) {
                  return S === 1 ? 1 : 0;
                }, i), s = c[1], p = s === 0 ? 1 : 0, y = p && pr(i);
                Y0(i, 1);
                var T = A0(i), E = 0;
                if (!t) {
                  var d = 0;
                  if (typeof T == "number" && (T === 1 || Pn === T) && (d = 1), !d) {
                    var w = x7(i);
                    if (w) {
                      var G = Ms(i);
                      E = 1;
                    } else {
                      var G = w;
                      E = 1;
                    }
                  }
                }
                if (!E) var G = we(i);
                var A = yu([0, x], [0, G], y, 0);
                return [0, [0, s, A], c[2]];
              }
              var e = 0;
              return function(i) {
                return gL(e, n, i);
              };
            }), mu(lre, se, [0, Be0, G9, xb, j9, BL, ML, Ue0, He0, fne, xne, one, ane, Me0, Xe0, Ye0, Ve0, bne, pne, mne, cne, ze0, sne, vne, lne, ine]);
            var Ke0 = [0, 0], We0 = bn;
            function _ne(t) {
              function n(e, i) {
                var x = i[2], c = i[1], s = oL(x), p = [0, [0, bre, u(t[1], s)], 0], y = C9(e, c[3]), T = [0, u(t[5], y), 0], E = C9(e, c[2]), d = [0, u(t[5], E), T], w = [0, [0, pre, u(t[4], d)], p], G = [0, [0, mre, u(t[5], c[3][2])], 0], A = [0, [0, _re, u(t[5], c[3][1])], G], S = [0, [0, yre, u(t[3], A)], 0], M = [0, [0, hre, u(t[5], c[2][2])], 0], K = [0, [0, dre, u(t[5], c[2][1])], M], V = [0, [0, kre, u(t[3], K)], S], f0 = [0, [0, wre, u(t[3], V)], w];
                switch (i[3]) {
                  case 0:
                    var m0 = Ere;
                    break;
                  case 1:
                    var m0 = Sre;
                    break;
                  case 2:
                    var m0 = gre;
                    break;
                  case 3:
                    var m0 = Fre;
                    break;
                  case 4:
                    var m0 = Tre;
                    break;
                  default:
                    var m0 = Ore;
                }
                var k0 = [0, [0, Ire, u(t[1], m0)], f0], g0 = wr0(x), e0 = [0, [0, Are, u(t[1], g0)], k0];
                return u(t[3], e0);
              }
              return [0, n, function(e, i) {
                var x = ye(Fp(function(c) {
                  return n(e, c);
                }, i));
                return u(t[4], x);
              }];
            }
            var yne = S70;
            function U1(t) {
              return g70(_l(t));
            }
            function hu(t) {
              return E70(_l(t));
            }
            function hne(t) {
              return t;
            }
            function dne(t) {
              return t;
            }
            function Je0(t, n, e) {
              try {
                var i = new RegExp(bn(n), bn(e));
                return i;
              } catch {
                return i7;
              }
            }
            var kne = _ne([0, We0, yne, U1, hu, hne, dne, i7, Je0]), wne = [0, 1], $e0 = /* @__PURE__ */ function(t) {
              function n(E, d) {
                return hu(ye(Fp(E, d)));
              }
              function e(E, d) {
                return d ? u(E, d[1]) : i7;
              }
              function i(E, d) {
                return d[0] === 0 ? i7 : u(E, d[1]);
              }
              function x(E) {
                return U1([0, [0, AWr, E[1]], [0, [0, IWr, E[2]], 0]]);
              }
              function c(E) {
                var d = E[1], w = d ? bn(d[1][1]) : i7, G = [0, [0, FWr, x(E[3])], 0];
                return U1([0, [0, OWr, w], [0, [0, TWr, x(E[2])], G]]);
              }
              function s(E) {
                return n(function(d) {
                  var w = d[2], G = 0;
                  if (typeof w == "number") {
                    var A = w;
                    if (55 <= A) switch (A) {
                      case 55:
                        var S = nmr;
                        break;
                      case 56:
                        var S = tmr;
                        break;
                      case 57:
                        var S = umr;
                        break;
                      case 58:
                        var S = imr;
                        break;
                      case 59:
                        var S = fmr;
                        break;
                      case 60:
                        var S = xmr;
                        break;
                      case 61:
                        var S = Te(amr, omr);
                        break;
                      case 62:
                        var S = Te(smr, cmr);
                        break;
                      case 63:
                        var S = Te(lmr, vmr);
                        break;
                      case 64:
                        var S = bmr;
                        break;
                      case 65:
                        var S = pmr;
                        break;
                      case 66:
                        var S = mmr;
                        break;
                      case 67:
                        var S = _mr;
                        break;
                      case 68:
                        var S = ymr;
                        break;
                      case 69:
                        var S = hmr;
                        break;
                      case 70:
                        var S = dmr;
                        break;
                      case 71:
                        var S = kmr;
                        break;
                      case 72:
                        var S = wmr;
                        break;
                      case 73:
                        var S = Emr;
                        break;
                      case 74:
                        var S = Smr;
                        break;
                      case 75:
                        var S = gmr;
                        break;
                      case 76:
                        var S = Fmr;
                        break;
                      case 77:
                        var S = Tmr;
                        break;
                      case 78:
                        var S = Omr;
                        break;
                      case 79:
                        var S = Imr;
                        break;
                      case 80:
                        var S = Amr;
                        break;
                      case 81:
                        var S = Nmr;
                        break;
                      case 82:
                        var S = Te(Pmr, Cmr);
                        break;
                      case 83:
                        var S = Dmr;
                        break;
                      case 84:
                        var S = Lmr;
                        break;
                      case 85:
                        var S = Rmr;
                        break;
                      case 86:
                        var S = jmr;
                        break;
                      case 87:
                        var S = Gmr;
                        break;
                      case 88:
                        var S = Mmr;
                        break;
                      case 89:
                        var S = Bmr;
                        break;
                      case 90:
                        var S = qmr;
                        break;
                      case 91:
                        var S = Umr;
                        break;
                      case 92:
                        var S = Hmr;
                        break;
                      case 93:
                        var S = Xmr;
                        break;
                      case 94:
                        var S = Te(Vmr, Ymr);
                        break;
                      case 95:
                        var S = zmr;
                        break;
                      case 96:
                        var S = Kmr;
                        break;
                      case 97:
                        var S = Wmr;
                        break;
                      case 98:
                        var S = Jmr;
                        break;
                      case 99:
                        var S = $mr;
                        break;
                      case 100:
                        var S = Zmr;
                        break;
                      case 101:
                        var S = Qmr;
                        break;
                      case 102:
                        var S = r9r;
                        break;
                      case 103:
                        var S = e9r;
                        break;
                      case 104:
                        var S = n9r;
                        break;
                      case 105:
                        var S = t9r;
                        break;
                      case 106:
                        var S = u9r;
                        break;
                      case 107:
                        var S = i9r;
                        break;
                      default:
                        var S = f9r;
                    }
                    else switch (A) {
                      case 0:
                        var S = r5r;
                        break;
                      case 1:
                        var S = e5r;
                        break;
                      case 2:
                        var S = n5r;
                        break;
                      case 3:
                        var S = t5r;
                        break;
                      case 4:
                        var S = u5r;
                        break;
                      case 5:
                        var S = i5r;
                        break;
                      case 6:
                        var S = f5r;
                        break;
                      case 7:
                        var S = x5r;
                        break;
                      case 8:
                        var S = o5r;
                        break;
                      case 9:
                        var S = a5r;
                        break;
                      case 10:
                        var S = c5r;
                        break;
                      case 11:
                        var S = s5r;
                        break;
                      case 12:
                        var S = v5r;
                        break;
                      case 13:
                        var S = l5r;
                        break;
                      case 14:
                        var S = b5r;
                        break;
                      case 15:
                        var S = p5r;
                        break;
                      case 16:
                        var S = m5r;
                        break;
                      case 17:
                        var S = _5r;
                        break;
                      case 18:
                        var S = y5r;
                        break;
                      case 19:
                        var S = h5r;
                        break;
                      case 20:
                        var S = d5r;
                        break;
                      case 21:
                        var S = k5r;
                        break;
                      case 22:
                        var S = w5r;
                        break;
                      case 23:
                        var S = E5r;
                        break;
                      case 24:
                        var S = S5r;
                        break;
                      case 25:
                        var S = g5r;
                        break;
                      case 26:
                        var S = F5r;
                        break;
                      case 27:
                        var S = T5r;
                        break;
                      case 28:
                        var S = O5r;
                        break;
                      case 29:
                        var S = I5r;
                        break;
                      case 30:
                        var S = A5r;
                        break;
                      case 31:
                        var S = Te(C5r, N5r);
                        break;
                      case 32:
                        var S = P5r;
                        break;
                      case 33:
                        var S = D5r;
                        break;
                      case 34:
                        var S = L5r;
                        break;
                      case 35:
                        var S = R5r;
                        break;
                      case 36:
                        var S = j5r;
                        break;
                      case 37:
                        var S = G5r;
                        break;
                      case 38:
                        var S = M5r;
                        break;
                      case 39:
                        var S = B5r;
                        break;
                      case 40:
                        var S = q5r;
                        break;
                      case 41:
                        var S = U5r;
                        break;
                      case 42:
                        var S = H5r;
                        break;
                      case 43:
                        var S = X5r;
                        break;
                      case 44:
                        var S = Y5r;
                        break;
                      case 45:
                        var S = V5r;
                        break;
                      case 46:
                        var S = z5r;
                        break;
                      case 47:
                        var S = K5r;
                        break;
                      case 48:
                        var S = W5r;
                        break;
                      case 49:
                        var S = J5r;
                        break;
                      case 50:
                        var S = $5r;
                        break;
                      case 51:
                        var S = Z5r;
                        break;
                      case 52:
                        var S = Q5r;
                        break;
                      case 53:
                        var S = rmr;
                        break;
                      default:
                        var S = emr;
                    }
                  } else switch (w[0]) {
                    case 0:
                      var M = w[2], K = w[1], S = ur(et(x9r), M, M, K);
                      break;
                    case 1:
                      var V = w[1], f0 = w[2], S = o(et(o9r), f0, V);
                      break;
                    case 2:
                      var m0 = w[1], S = u(et(a9r), m0);
                      break;
                    case 3:
                      var k0 = w[2], g0 = w[1], e0 = u(et(c9r), g0);
                      if (k0) var x0 = k0[1], S = o(et(s9r), x0, e0);
                      else var S = u(et(v9r), e0);
                      break;
                    case 4:
                      var l = w[1], S = o(et(l9r), l, l);
                      break;
                    case 5:
                      var c0 = w[3], t0 = w[2], o0 = w[1];
                      if (t0) {
                        var w0 = t0[1];
                        if (3 <= w0) var S = o(et(b9r), c0, o0);
                        else {
                          switch (w0) {
                            case 0:
                              var _0 = Jpr;
                              break;
                            case 1:
                              var _0 = $pr;
                              break;
                            case 2:
                              var _0 = Zpr;
                              break;
                            default:
                              var _0 = Qpr;
                          }
                          var S = R(et(p9r), o0, _0, c0, _0);
                        }
                      } else var S = o(et(m9r), c0, o0);
                      break;
                    case 6:
                      var E0 = w[2], U0 = E0;
                      if (b7(U0) === 0) var b = U0;
                      else {
                        var R0 = sz(U0);
                        Jn(R0, 0, xz(Xu(U0, 0)));
                        var b = R0;
                      }
                      var X = b, s0 = w[1], S = ur(et(_9r), E0, X, s0);
                      break;
                    case 7:
                      var S = w[1] ? y9r : h9r;
                      break;
                    case 8:
                      var hr = w[1], Ar = w[2], S = o(et(d9r), Ar, hr);
                      break;
                    case 9:
                      var or = w[1], S = u(et(k9r), or);
                      break;
                    case 10:
                      var W0 = w[1], S = u(et(w9r), W0);
                      break;
                    case 11:
                      var Lr = w[2], Tr = w[1], S = o(et(E9r), Tr, Lr);
                      break;
                    case 12:
                      var Hr = w[2], Or = w[1], S = o(et(S9r), Or, Hr);
                      break;
                    case 13:
                      var S = Te(F9r, Te(w[1], g9r));
                      break;
                    case 14:
                      var fr = w[1] ? T9r : O9r, S = u(et(I9r), fr);
                      break;
                    case 15:
                      var S = Te(N9r, Te(w[1], A9r));
                      break;
                    case 16:
                      var Rr = Te(P9r, Te(w[2], C9r)), S = Te(w[1], Rr);
                      break;
                    case 17:
                      var S = Te(D9r, w[1]);
                      break;
                    case 18:
                      var S = w[1] ? Te(R9r, L9r) : Te(G9r, j9r);
                      break;
                    case 19:
                      var Wr = w[1], S = u(et(M9r), Wr);
                      break;
                    case 20:
                      var S = Te(q9r, Te(w[1], B9r));
                      break;
                    case 21:
                      var Jr = w[1], ar = w[2] ? U9r : H9r, _r = w[4] ? Te(X9r, Jr) : Jr, Ir = w[3] ? Y9r : V9r, S = Te(W9r, Te(ar, Te(Ir, Te(K9r, Te(_r, z9r)))));
                      break;
                    case 22:
                      var S = Te($9r, Te(w[1], J9r));
                      break;
                    default:
                      var fe = w[1], S = u(et(Z9r), fe);
                  }
                  var v0 = [0, [0, SWr, bn(S)], G];
                  return U1([0, [0, gWr, c(d[1])], v0]);
                }, E);
              }
              function p(E) {
                if (E) {
                  var d = E[1], w = [0, on(d[3], d[2])];
                  return lr([0, d[1]], w, 0);
                }
                return E;
              }
              function y(E) {
                function d(_) {
                  return n(q0, _);
                }
                function w(_, k, I, U) {
                  var Y = t[1];
                  if (Y) {
                    if (E) var y0 = E[1], P0 = [0, C9(y0, k[3]), 0], I0 = [0, [0, iGr, hu([0, C9(y0, k[2]), P0])], 0];
                    else var I0 = E;
                    var D = on(I0, [0, [0, fGr, c(k)], 0]);
                  } else var D = Y;
                  if (I) {
                    var u0 = I[1], X0 = u0[1];
                    if (X0) {
                      var J0 = u0[2];
                      if (J0) var ir = [0, [0, xGr, d(J0)], 0], Q0 = [0, [0, oGr, d(X0)], ir];
                      else var Q0 = [0, [0, aGr, d(X0)], 0];
                      var mr = Q0;
                    } else var F0 = u0[2], Sr = F0 && [0, [0, cGr, d(F0)], 0], mr = Sr;
                    var Cr = mr;
                  } else var Cr = I;
                  return U1(Lc(on(D, on(Cr, [0, [0, sGr, bn(_)], 0])), U));
                }
                function G(_) {
                  return n(Q, _);
                }
                function A(_) {
                  var k = _[2], I = G(k[1]), U = [0, [0, lGr, I], [0, [0, vGr, d(k[3])], 0]];
                  return w(bGr, _[1], k[2], U);
                }
                function S(_) {
                  var k = _[2];
                  return w(Vqr, _[1], k[2], [0, [0, Yqr, bn(k[1])], [0, [0, Xqr, i7], [0, [0, Hqr, false], 0]]]);
                }
                function M(_) {
                  if (_[0] === 0) return S(_[1]);
                  var k = _[1], I = k[2], U = M(I[1]), Y = [0, [0, Mzr, U], [0, [0, Gzr, S(I[2])], 0]];
                  return w(Bzr, k[1], 0, Y);
                }
                function K(_) {
                  var k = _[2], I = k[1], U = I[0] === 0 ? S(I[1]) : K(I[1]), Y = [0, [0, wzr, U], [0, [0, kzr, S(k[2])], 0]];
                  return w(Ezr, _[1], 0, Y);
                }
                function V(_) {
                  var k = _[2], I = k[1], U = I[0] === 0 ? S(I[1]) : K(I[1]), Y = [0, [0, gzr, U], [0, [0, Szr, e($r, k[2])], 0]];
                  return w(Fzr, _[1], k[3], Y);
                }
                function f0(_) {
                  var k = _[2], I = k[2], U = k[1], Y = _[1];
                  if (typeof U == "number") var y0 = i7;
                  else switch (U[0]) {
                    case 0:
                      var y0 = bn(U[1]);
                      break;
                    case 1:
                      var y0 = !!U[1];
                      break;
                    case 2:
                      var y0 = U[1];
                      break;
                    case 3:
                      var y0 = ke(bYr);
                      break;
                    default:
                      var P0 = U[1], y0 = Je0(Y, P0[1], P0[2]);
                  }
                  var I0 = 0;
                  if (typeof U != "number" && U[0] === 4) {
                    var D = U[1], u0 = [0, [0, _Yr, U1([0, [0, mYr, bn(D[1])], [0, [0, pYr, bn(D[2])], 0]])], 0], X0 = [0, [0, hYr, y0], [0, [0, yYr, bn(I)], u0]];
                    I0 = 1;
                  }
                  if (!I0) var X0 = [0, [0, kYr, y0], [0, [0, dYr, bn(I)], 0]];
                  return w(wYr, Y, k[3], X0);
                }
                function m0(_) {
                  var k = [0, [0, Tzr, g0(_[2])], 0];
                  return [0, [0, Ozr, g0(_[1])], k];
                }
                function k0(_, k) {
                  var I = k[2], U = [0, [0, EVr, !!I[3]], 0], Y = [0, [0, SVr, g0(I[2])], U], y0 = [0, [0, gVr, e(S, I[1])], Y];
                  return w(FVr, k[1], _, y0);
                }
                function g0(_) {
                  var k = _[2], I = _[1];
                  switch (k[0]) {
                    case 0:
                      return w(iVr, I, k[1], 0);
                    case 1:
                      return w(fVr, I, k[1], 0);
                    case 2:
                      return w(xVr, I, k[1], 0);
                    case 3:
                      return w(oVr, I, k[1], 0);
                    case 4:
                      return w(aVr, I, k[1], 0);
                    case 5:
                      return w(sVr, I, k[1], 0);
                    case 6:
                      return w(vVr, I, k[1], 0);
                    case 7:
                      return w(lVr, I, k[1], 0);
                    case 8:
                      return w(bVr, I, k[1], 0);
                    case 9:
                      return w(cVr, I, k[1], 0);
                    case 10:
                      return w(tKr, I, k[1], 0);
                    case 11:
                      var U = k[1], Y = [0, [0, pVr, g0(U[1])], 0];
                      return w(mVr, I, U[2], Y);
                    case 12:
                      return e0([0, I, k[1]]);
                    case 13:
                      return x0(1, [0, I, k[1]]);
                    case 14:
                      var y0 = k[1], P0 = [0, [0, mzr, x0(0, y0[1])], 0], I0 = [0, [0, _zr, n(fe, y0[2])], P0];
                      return w(yzr, I, y0[3], I0);
                    case 15:
                      var D = k[1], u0 = [0, [0, hzr, g0(D[1])], 0];
                      return w(dzr, I, D[2], u0);
                    case 16:
                      return V([0, I, k[1]]);
                    case 17:
                      var X0 = k[1], J0 = m0(X0);
                      return w(Izr, I, X0[3], J0);
                    case 18:
                      var ir = k[1], Q0 = ir[1], F0 = [0, [0, Azr, !!ir[2]], 0], Sr = on(m0(Q0), F0);
                      return w(Nzr, I, Q0[3], Sr);
                    case 19:
                      var mr = k[1], Cr = mr[1], sr = [0, [0, Czr, n(g0, [0, Cr[1], [0, Cr[2], Cr[3]]])], 0];
                      return w(Pzr, I, mr[2], sr);
                    case 20:
                      var Pr = k[1], K0 = Pr[1], Ur = [0, [0, Dzr, n(g0, [0, K0[1], [0, K0[2], K0[3]]])], 0];
                      return w(Lzr, I, Pr[2], Ur);
                    case 21:
                      var h0 = k[1], Kr = [0, [0, Rzr, M(h0[1])], 0];
                      return w(jzr, I, h0[2], Kr);
                    case 22:
                      var re = k[1], xe = [0, [0, qzr, n(g0, re[1])], 0];
                      return w(Uzr, I, re[2], xe);
                    case 23:
                      var Re = k[1];
                      return w(Yzr, I, Re[3], [0, [0, Xzr, bn(Re[1])], [0, [0, Hzr, bn(Re[2])], 0]]);
                    case 24:
                      var ve = k[1];
                      return w(Kzr, I, ve[3], [0, [0, zzr, ve[1]], [0, [0, Vzr, bn(ve[2])], 0]]);
                    case 25:
                      var Ie = k[1];
                      return w($zr, I, Ie[3], [0, [0, Jzr, i7], [0, [0, Wzr, bn(Ie[2])], 0]]);
                    default:
                      var Ge = k[1], Me = Ge[1], an = 0, We = Me ? Zzr : Qzr;
                      return w(nKr, I, Ge[2], [0, [0, eKr, !!Me], [0, [0, rKr, bn(We)], an]]);
                  }
                }
                function e0(_) {
                  var k = _[2], I = k[2][2], U = k[4], Y = y7(p(I[4]), U), y0 = [0, [0, _Vr, e(qr, k[1])], 0], P0 = [0, [0, yVr, e(Mr, I[3])], y0], I0 = [0, [0, hVr, g0(k[3])], P0], D = [0, [0, dVr, e(Br, I[1])], I0], u0 = I[2], X0 = [0, [0, kVr, n(function(J0) {
                    return k0(0, J0);
                  }, u0)], D];
                  return w(wVr, _[1], Y, X0);
                }
                function x0(_, k) {
                  var I = k[2], U = I[3], Y = le(function(ir, Q0) {
                    var F0 = ir[4], Sr = ir[3], mr = ir[2], Cr = ir[1];
                    switch (Q0[0]) {
                      case 0:
                        var sr = Q0[1], Pr = sr[2], K0 = Pr[2], Ur = Pr[1];
                        switch (Ur[0]) {
                          case 0:
                            var h0 = f0(Ur[1]);
                            break;
                          case 1:
                            var h0 = S(Ur[1]);
                            break;
                          case 2:
                            var h0 = ke(MVr);
                            break;
                          default:
                            var h0 = ke(BVr);
                        }
                        switch (K0[0]) {
                          case 0:
                            var xe = qVr, Re = g0(K0[1]);
                            break;
                          case 1:
                            var Kr = K0[1], xe = UVr, Re = e0([0, Kr[1], Kr[2]]);
                            break;
                          default:
                            var re = K0[1], xe = HVr, Re = e0([0, re[1], re[2]]);
                        }
                        var ve = [0, [0, XVr, bn(xe)], 0], Ie = [0, [0, YVr, e(Er, Pr[7])], ve];
                        return [0, [0, w(ZVr, sr[1], Pr[8], [0, [0, $Vr, h0], [0, [0, JVr, Re], [0, [0, WVr, !!Pr[6]], [0, [0, KVr, !!Pr[3]], [0, [0, zVr, !!Pr[4]], [0, [0, VVr, !!Pr[5]], Ie]]]]]]), Cr], mr, Sr, F0];
                      case 1:
                        var Ge = Q0[1], Me = Ge[2], an = [0, [0, QVr, g0(Me[1])], 0];
                        return [0, [0, w(rzr, Ge[1], Me[2], an), Cr], mr, Sr, F0];
                      case 2:
                        var We = Q0[1], Ae = We[2], cn = [0, [0, ezr, e(Er, Ae[5])], 0], rn = [0, [0, nzr, !!Ae[4]], cn], kn = [0, [0, tzr, g0(Ae[3])], rn], vn = [0, [0, uzr, g0(Ae[2])], kn], Ne = [0, [0, izr, e(S, Ae[1])], vn];
                        return [0, Cr, [0, w(fzr, We[1], Ae[6], Ne), mr], Sr, F0];
                      case 3:
                        var Je = Q0[1], en = Je[2], _n = [0, [0, xzr, !!en[2]], 0], Cn = [0, [0, ozr, e0(en[1])], _n];
                        return [0, Cr, mr, [0, w(azr, Je[1], en[3], Cn), Sr], F0];
                      default:
                        var Hn = Q0[1], Fn = Hn[2], vt = [0, [0, czr, g0(Fn[2])], 0], Nt = [0, [0, lzr, !!Fn[3]], [0, [0, vzr, !!Fn[4]], [0, [0, szr, !!Fn[5]], vt]]], gt = [0, [0, bzr, S(Fn[1])], Nt];
                        return [0, Cr, mr, Sr, [0, w(pzr, Hn[1], Fn[6], gt), F0]];
                    }
                  }, NVr, U), y0 = [0, [0, CVr, hu(ye(Y[4]))], 0], P0 = [0, [0, PVr, hu(ye(Y[3]))], y0], I0 = [0, [0, DVr, hu(ye(Y[2]))], P0], D = [0, [0, LVr, hu(ye(Y[1]))], I0], u0 = [0, [0, RVr, !!I[1]], D], X0 = _ ? [0, [0, jVr, !!I[2]], u0] : u0, J0 = p(I[4]);
                  return w(GVr, k[1], J0, X0);
                }
                function l(_) {
                  var k = [0, [0, uKr, g0(_[2])], 0];
                  return w(iKr, _[1], 0, k);
                }
                function c0(_) {
                  var k = _[2];
                  switch (k[2]) {
                    case 0:
                      var I = KYr;
                      break;
                    case 1:
                      var I = WYr;
                      break;
                    default:
                      var I = JYr;
                  }
                  var U = [0, [0, $Yr, bn(I)], 0], Y = [0, [0, ZYr, n($0, k[1])], U];
                  return w(QYr, _[1], k[3], Y);
                }
                function t0(_) {
                  var k = _[2];
                  return w(NYr, _[1], k[3], [0, [0, AYr, bn(k[1])], [0, [0, IYr, bn(k[2])], 0]]);
                }
                function o0(_) {
                  var k = _[2], I = [0, [0, IXr, i1], [0, [0, OXr, l(k[1])], 0]];
                  return w(AXr, _[1], k[2], I);
                }
                function w0(_, k) {
                  var I = k[1][2], U = [0, [0, $qr, !!k[3]], 0], Y = [0, [0, Zqr, i(l, k[2])], U];
                  return w(rUr, _, I[2], [0, [0, Qqr, bn(I[1])], Y]);
                }
                function _0(_) {
                  var k = _[2];
                  return w(Jqr, _[1], k[2], [0, [0, Wqr, bn(k[1])], [0, [0, Kqr, i7], [0, [0, zqr, false], 0]]]);
                }
                function E0(_) {
                  return n(M0, _[2][1]);
                }
                function U0(_) {
                  var k = _[2], I = [0, [0, wKr, w(PKr, k[2], 0, 0)], 0], U = [0, [0, EKr, n(oe, k[3][2])], I], Y = [0, [0, SKr, w(AKr, k[1], 0, 0)], U];
                  return w(gKr, _[1], k[4], Y);
                }
                function b(_) {
                  var k = _[2];
                  return w(rWr, _[1], k[2], [0, [0, QKr, bn(k[1])], 0]);
                }
                function R0(_) {
                  var k = _[2], I = [0, [0, JKr, b(k[2])], 0], U = [0, [0, $Kr, b(k[1])], I];
                  return w(ZKr, _[1], 0, U);
                }
                function X(_) {
                  var k = _[2], I = k[1], U = I[0] === 0 ? b(I[1]) : X(I[1]), Y = [0, [0, KKr, U], [0, [0, zKr, b(k[2])], 0]];
                  return w(WKr, _[1], 0, Y);
                }
                function s0(_) {
                  switch (_[0]) {
                    case 0:
                      return b(_[1]);
                    case 1:
                      return R0(_[1]);
                    default:
                      return X(_[1]);
                  }
                }
                function hr(_) {
                  var k = _[2], I = [0, [0, yKr, n(oe, k[3][2])], 0], U = [0, [0, hKr, e(ae, k[2])], I], Y = k[1], y0 = Y[2], P0 = [0, [0, FKr, !!y0[2]], 0], I0 = [0, [0, TKr, n(be, y0[3])], P0], D = [0, [0, OKr, s0(y0[1])], I0], u0 = [0, [0, dKr, w(IKr, Y[1], 0, D)], U];
                  return w(kKr, _[1], k[4], u0);
                }
                function Ar(_) {
                  var k = _[2], I = [0, [0, jYr, n(fr, k[2])], 0], U = [0, [0, GYr, n(vr, k[1])], I];
                  return w(MYr, _[1], k[3], U);
                }
                function or(_, k) {
                  var I = k[2], U = I[7], Y = I[5], y0 = I[4];
                  if (y0) var P0 = y0[1][2], I0 = y7(P0[3], U), D = I0, u0 = P0[2], X0 = [0, P0[1]];
                  else var D = U, u0 = 0, X0 = 0;
                  if (Y) var J0 = Y[1][2], ir = y7(J0[2], D), Q0 = ir, F0 = n(T0, J0[1]);
                  else var Q0 = D, F0 = hu(0);
                  var Sr = [0, [0, zUr, F0], [0, [0, VUr, n(S0, I[6])], 0]], mr = [0, [0, KUr, e($r, u0)], Sr], Cr = [0, [0, WUr, e(fr, X0)], mr], sr = [0, [0, JUr, e(qr, I[3])], Cr], Pr = I[2], K0 = Pr[2], Ur = [0, [0, uHr, n(rr, K0[1])], 0], h0 = [0, [0, $Ur, w(iHr, Pr[1], K0[2], Ur)], sr], Kr = [0, [0, ZUr, e(S, I[1])], h0];
                  return w(_, k[1], Q0, Kr);
                }
                function W0(_) {
                  var k = _[2], I = [0, [0, xUr, G(k[1])], 0], U = p(k[2]);
                  return w(oUr, _[1], U, I);
                }
                function Lr(_) {
                  var k = _[2];
                  switch (k[0]) {
                    case 0:
                      var I = 0, U = S(k[1]);
                      break;
                    case 1:
                      var I = 0, U = _0(k[1]);
                      break;
                    default:
                      var I = 1, U = fr(k[1]);
                  }
                  return [0, [0, EWr, fr(_[1])], [0, [0, wWr, U], [0, [0, kWr, !!I], 0]]];
                }
                function Tr(_) {
                  var k = [0, [0, yWr, E0(_[3])], 0], I = [0, [0, hWr, e(ne, _[2])], k];
                  return [0, [0, dWr, fr(_[1])], I];
                }
                function Hr(_) {
                  var k = _[2], I = k[3], U = k[2], Y = k[1];
                  if (I) {
                    var y0 = I[1], P0 = y0[2], I0 = [0, [0, NXr, Or(P0[1])], 0], D = w(CXr, y0[1], P0[2], I0), u0 = ye([0, D, Fp(L0, U)]), X0 = Y ? [0, o0(Y[1]), u0] : u0;
                    return hu(X0);
                  }
                  var J0 = d1(L0, U), ir = Y ? [0, o0(Y[1]), J0] : J0;
                  return hu(ir);
                }
                function Or(_) {
                  var k = _[2], I = _[1];
                  switch (k[0]) {
                    case 0:
                      var U = k[1], Y = [0, [0, hXr, i(l, U[2])], 0], y0 = [0, [0, dXr, n(b0, U[1])], Y];
                      return w(kXr, I, p(U[3]), y0);
                    case 1:
                      var P0 = k[1], I0 = [0, [0, wXr, i(l, P0[2])], 0], D = [0, [0, EXr, n(Z, P0[1])], I0];
                      return w(SXr, I, p(P0[3]), D);
                    case 2:
                      return w0(I, k[1]);
                    default:
                      return fr(k[1]);
                  }
                }
                function fr(_) {
                  var k = _[2], I = _[1];
                  switch (k[0]) {
                    case 0:
                      var U = k[1], Y = [0, [0, XMr, n(er, U[1])], 0];
                      return w(YMr, I, p(U[2]), Y);
                    case 1:
                      var y0 = k[1], P0 = y0[7], I0 = y0[3], D = y0[2];
                      if (I0[0] === 0) var u0 = 0, X0 = W0(I0[1]);
                      else var u0 = 1, X0 = fr(I0[1]);
                      var J0 = P0[0] === 0 ? 0 : [0, P0[1]], ir = y0[9], Q0 = y7(p(D[2][4]), ir), F0 = [0, [0, VMr, e(qr, y0[8])], 0], Sr = [0, [0, KMr, !!u0], [0, [0, zMr, e(l, J0)], F0]], mr = [0, [0, JMr, false], [0, [0, WMr, e(Fr, y0[6])], Sr]], Cr = [0, [0, ZMr, X0], [0, [0, $Mr, !!y0[4]], mr]];
                      return w(eBr, I, Q0, [0, [0, rBr, i7], [0, [0, QMr, Hr(D)], Cr]]);
                    case 2:
                      var sr = k[1], Pr = sr[1];
                      if (Pr) {
                        switch (Pr[1]) {
                          case 0:
                            var K0 = Tpr;
                            break;
                          case 1:
                            var K0 = Opr;
                            break;
                          case 2:
                            var K0 = Ipr;
                            break;
                          case 3:
                            var K0 = Apr;
                            break;
                          case 4:
                            var K0 = Npr;
                            break;
                          case 5:
                            var K0 = Cpr;
                            break;
                          case 6:
                            var K0 = Ppr;
                            break;
                          case 7:
                            var K0 = Dpr;
                            break;
                          case 8:
                            var K0 = Lpr;
                            break;
                          case 9:
                            var K0 = Rpr;
                            break;
                          case 10:
                            var K0 = jpr;
                            break;
                          case 11:
                            var K0 = Gpr;
                            break;
                          case 12:
                            var K0 = Mpr;
                            break;
                          case 13:
                            var K0 = Bpr;
                            break;
                          default:
                            var K0 = qpr;
                        }
                        var Ur = K0;
                      } else var Ur = nBr;
                      var h0 = [0, [0, tBr, fr(sr[3])], 0], Kr = [0, [0, uBr, Or(sr[2])], h0];
                      return w(fBr, I, sr[4], [0, [0, iBr, bn(Ur)], Kr]);
                    case 3:
                      var re = k[1], xe = [0, [0, xBr, fr(re[3])], 0], Re = [0, [0, oBr, fr(re[2])], xe];
                      switch (re[1]) {
                        case 0:
                          var ve = ipr;
                          break;
                        case 1:
                          var ve = fpr;
                          break;
                        case 2:
                          var ve = xpr;
                          break;
                        case 3:
                          var ve = opr;
                          break;
                        case 4:
                          var ve = apr;
                          break;
                        case 5:
                          var ve = cpr;
                          break;
                        case 6:
                          var ve = spr;
                          break;
                        case 7:
                          var ve = vpr;
                          break;
                        case 8:
                          var ve = lpr;
                          break;
                        case 9:
                          var ve = bpr;
                          break;
                        case 10:
                          var ve = ppr;
                          break;
                        case 11:
                          var ve = mpr;
                          break;
                        case 12:
                          var ve = _pr;
                          break;
                        case 13:
                          var ve = ypr;
                          break;
                        case 14:
                          var ve = hpr;
                          break;
                        case 15:
                          var ve = dpr;
                          break;
                        case 16:
                          var ve = kpr;
                          break;
                        case 17:
                          var ve = wpr;
                          break;
                        case 18:
                          var ve = Epr;
                          break;
                        case 19:
                          var ve = Spr;
                          break;
                        case 20:
                          var ve = gpr;
                          break;
                        default:
                          var ve = Fpr;
                      }
                      return w(cBr, I, re[4], [0, [0, aBr, bn(ve)], Re]);
                    case 4:
                      var Ie = k[1], Ge = Ie[4], Me = y7(p(Ie[3][2][2]), Ge);
                      return w(sBr, I, Me, Tr(Ie));
                    case 5:
                      return or(YUr, [0, I, k[1]]);
                    case 6:
                      var an = k[1], We = [0, [0, vBr, e(fr, an[2])], 0];
                      return w(bBr, I, 0, [0, [0, lBr, n(yr, an[1])], We]);
                    case 7:
                      var Ae = k[1], cn = [0, [0, pBr, fr(Ae[3])], 0], rn = [0, [0, mBr, fr(Ae[2])], cn], kn = [0, [0, _Br, fr(Ae[1])], rn];
                      return w(yBr, I, Ae[4], kn);
                    case 8:
                      return Rr([0, I, k[1]]);
                    case 9:
                      var vn = k[1], Ne = [0, [0, hBr, e(fr, vn[2])], 0];
                      return w(kBr, I, 0, [0, [0, dBr, n(yr, vn[1])], Ne]);
                    case 10:
                      return S(k[1]);
                    case 11:
                      var Je = k[1], en = [0, [0, wBr, fr(Je[1])], 0];
                      return w(EBr, I, Je[2], en);
                    case 12:
                      return hr([0, I, k[1]]);
                    case 13:
                      return U0([0, I, k[1]]);
                    case 14:
                      var _n = k[1], Cn = _n[1];
                      return typeof Cn != "number" && Cn[0] === 3 ? w(OYr, I, _n[3], [0, [0, TYr, i7], [0, [0, FYr, bn(_n[2])], 0]]) : f0([0, I, _n]);
                    case 15:
                      var Hn = k[1];
                      switch (Hn[1]) {
                        case 0:
                          var Fn = SBr;
                          break;
                        case 1:
                          var Fn = gBr;
                          break;
                        default:
                          var Fn = FBr;
                      }
                      var vt = [0, [0, TBr, fr(Hn[3])], 0], Nt = [0, [0, OBr, fr(Hn[2])], vt];
                      return w(ABr, I, Hn[4], [0, [0, IBr, bn(Fn)], Nt]);
                    case 16:
                      var gt = k[1], Zt = Lr(gt);
                      return w(NBr, I, gt[3], Zt);
                    case 17:
                      var qt = k[1], Ft = [0, [0, CBr, S(qt[2])], 0], Ct = [0, [0, PBr, S(qt[1])], Ft];
                      return w(DBr, I, qt[3], Ct);
                    case 18:
                      var du = k[1], Wu = du[4], lt = du[3];
                      if (lt) var ou = lt[1], Bu = y7(p(ou[2][2]), Wu), K7 = Bu, Yi = E0(ou);
                      else var K7 = Wu, Yi = hu(0);
                      var a7 = [0, [0, RBr, e(ne, du[2])], [0, [0, LBr, Yi], 0]];
                      return w(GBr, I, K7, [0, [0, jBr, fr(du[1])], a7]);
                    case 19:
                      var Hc = k[1], W7 = [0, [0, MBr, n(p0, Hc[1])], 0];
                      return w(BBr, I, p(Hc[2]), W7);
                    case 20:
                      var Ut = k[1], bt = Ut[1], B0 = bt[4], D0 = y7(p(bt[3][2][2]), B0), Le = [0, [0, qBr, !!Ut[3]], 0];
                      return w(UBr, I, D0, on(Tr(bt), Le));
                    case 21:
                      var He = k[1], he = He[1], me = [0, [0, HBr, !!He[3]], 0], Zn = on(Lr(he), me);
                      return w(XBr, I, he[3], Zn);
                    case 22:
                      var wn = k[1], ft = [0, [0, YBr, n(fr, wn[1])], 0];
                      return w(VBr, I, wn[2], ft);
                    case 23:
                      return w(zBr, I, k[1][1], 0);
                    case 24:
                      var xt = k[1], jn = [0, [0, YYr, Ar(xt[2])], 0], ut = [0, [0, VYr, fr(xt[1])], jn];
                      return w(zYr, I, xt[3], ut);
                    case 25:
                      return Ar([0, I, k[1]]);
                    case 26:
                      return w(KBr, I, k[1][1], 0);
                    case 27:
                      var dt = k[1], xn = [0, [0, WBr, l(dt[2])], 0], ln = [0, [0, JBr, fr(dt[1])], xn];
                      return w($Br, I, dt[3], ln);
                    case 28:
                      var it = k[1], Tt = it[3], Ti = it[2], hs = it[1];
                      if (7 <= hs) return w(QBr, I, Tt, [0, [0, ZBr, fr(Ti)], 0]);
                      switch (hs) {
                        case 0:
                          var Au = rqr;
                          break;
                        case 1:
                          var Au = eqr;
                          break;
                        case 2:
                          var Au = nqr;
                          break;
                        case 3:
                          var Au = tqr;
                          break;
                        case 4:
                          var Au = uqr;
                          break;
                        case 5:
                          var Au = iqr;
                          break;
                        case 6:
                          var Au = fqr;
                          break;
                        default:
                          var Au = ke(xqr);
                      }
                      var Hs = [0, [0, aqr, true], [0, [0, oqr, fr(Ti)], 0]];
                      return w(sqr, I, Tt, [0, [0, cqr, bn(Au)], Hs]);
                    case 29:
                      var Vi = k[1], Xs = Vi[1] ? vqr : lqr, Ys = [0, [0, bqr, !!Vi[3]], 0], nn = [0, [0, pqr, fr(Vi[2])], Ys];
                      return w(_qr, I, Vi[4], [0, [0, mqr, bn(Xs)], nn]);
                    default:
                      var si = k[1], Vs = [0, [0, yqr, !!si[3]], 0], c2 = [0, [0, hqr, e(fr, si[1])], Vs];
                      return w(dqr, I, si[2], c2);
                  }
                }
                function Rr(_) {
                  var k = _[2], I = k[7], U = k[3], Y = k[2], y0 = U[0] === 0 ? U[1] : ke(Cqr), P0 = I[0] === 0 ? 0 : [0, I[1]], I0 = k[9], D = y7(p(Y[2][4]), I0), u0 = [0, [0, Pqr, e(qr, k[8])], 0], X0 = [0, [0, Lqr, false], [0, [0, Dqr, e(l, P0)], u0]], J0 = [0, [0, Rqr, e(Fr, k[6])], X0], ir = [0, [0, Gqr, !!k[4]], [0, [0, jqr, !!k[5]], J0]], Q0 = [0, [0, Mqr, W0(y0)], ir], F0 = [0, [0, Bqr, Hr(Y)], Q0], Sr = [0, [0, qqr, e(S, k[1])], F0];
                  return w(Uqr, _[1], D, Sr);
                }
                function Wr(_) {
                  var k = _[2], I = [0, [0, sXr, n(fe, k[3])], 0], U = [0, [0, vXr, x0(0, k[4])], I], Y = [0, [0, lXr, e(qr, k[2])], U], y0 = [0, [0, bXr, S(k[1])], Y];
                  return w(pXr, _[1], k[5], y0);
                }
                function Jr(_, k) {
                  var I = k[2], U = _ ? GUr : MUr, Y = [0, [0, BUr, e(g0, I[4])], 0], y0 = [0, [0, qUr, e(g0, I[3])], Y], P0 = [0, [0, UUr, e(qr, I[2])], y0], I0 = [0, [0, HUr, S(I[1])], P0];
                  return w(U, k[1], I[5], I0);
                }
                function ar(_) {
                  var k = _[2], I = [0, [0, DUr, g0(k[3])], 0], U = [0, [0, LUr, e(qr, k[2])], I], Y = [0, [0, RUr, S(k[1])], U];
                  return w(jUr, _[1], k[4], Y);
                }
                function _r(_) {
                  if (_) {
                    var k = _[1];
                    if (k[0] === 0) return n(ge, k[1]);
                    var I = k[1], U = I[2];
                    if (U) {
                      var Y = [0, [0, OUr, S(U[1])], 0];
                      return hu([0, w(IUr, I[1], 0, Y), 0]);
                    }
                    return hu(0);
                  }
                  return hu(0);
                }
                function Ir(_) {
                  return _ ? FUr : TUr;
                }
                function fe(_) {
                  var k = _[2], I = k[1], U = I[0] === 0 ? S(I[1]) : K(I[1]), Y = [0, [0, _Xr, U], [0, [0, mXr, e($r, k[2])], 0]];
                  return w(yXr, _[1], k[3], Y);
                }
                function v0(_) {
                  var k = _[2], I = k[6], U = k[4], Y = hu(U ? [0, fe(U[1]), 0] : 0), y0 = I ? n(T0, I[1][2][1]) : hu(0), P0 = [0, [0, mUr, Y], [0, [0, pUr, y0], [0, [0, bUr, n(fe, k[5])], 0]]], I0 = [0, [0, _Ur, x0(0, k[3])], P0], D = [0, [0, yUr, e(qr, k[2])], I0], u0 = [0, [0, hUr, S(k[1])], D];
                  return w(dUr, _[1], k[7], u0);
                }
                function P(_) {
                  var k = _[2], I = k[2], U = k[1], Y = yt(U[1], I[1]), y0 = [0, [0, sUr, e(Fr, k[3])], 0], P0 = [0, [0, vUr, w0(Y, [0, U, [1, I], 0])], y0];
                  return w(lUr, _[1], k[4], P0);
                }
                function L(_) {
                  var k = _[2], I = k[2], U = k[1], Y = [0, [0, aUr, w0(yt(U[1], I[1]), [0, U, [1, I], 0])], 0];
                  return w(cUr, _[1], k[3], Y);
                }
                function Q(_) {
                  var k = _[2], I = _[1];
                  switch (k[0]) {
                    case 0:
                      return W0([0, I, k[1]]);
                    case 1:
                      var U = k[1], Y = [0, [0, pGr, e(S, U[1])], 0];
                      return w(mGr, I, U[2], Y);
                    case 2:
                      return or(XUr, [0, I, k[1]]);
                    case 3:
                      var y0 = k[1], P0 = [0, [0, _Gr, e(S, y0[1])], 0];
                      return w(yGr, I, y0[2], P0);
                    case 4:
                      return w(hGr, I, k[1][1], 0);
                    case 5:
                      return v0([0, I, k[1]]);
                    case 6:
                      var I0 = k[1], D = I0[5], u0 = I0[4], X0 = I0[3], J0 = I0[2];
                      if (X0) {
                        var ir = X0[1];
                        if (ir[0] !== 0 && !ir[1][2]) return w(kGr, I, D, [0, [0, dGr, e(t0, u0)], 0]);
                      }
                      if (J0) {
                        var Q0 = J0[1];
                        switch (Q0[0]) {
                          case 0:
                            var F0 = L(Q0[1]);
                            break;
                          case 1:
                            var F0 = P(Q0[1]);
                            break;
                          case 2:
                            var F0 = v0(Q0[1]);
                            break;
                          case 3:
                            var F0 = g0(Q0[1]);
                            break;
                          case 4:
                            var F0 = ar(Q0[1]);
                            break;
                          case 5:
                            var F0 = Jr(1, Q0[1]);
                            break;
                          default:
                            var F0 = Wr(Q0[1]);
                        }
                        var Sr = F0;
                      } else var Sr = i7;
                      var mr = [0, [0, wGr, e(t0, u0)], 0], Cr = [0, [0, SGr, Sr], [0, [0, EGr, _r(X0)], mr]], sr = I0[1], Pr = sr && 1;
                      return w(FGr, I, D, [0, [0, gGr, !!Pr], Cr]);
                    case 7:
                      return P([0, I, k[1]]);
                    case 8:
                      var K0 = k[1], Ur = [0, [0, kUr, n(fe, K0[3])], 0], h0 = [0, [0, wUr, x0(0, K0[4])], Ur], Kr = [0, [0, EUr, e(qr, K0[2])], h0], re = [0, [0, SUr, S(K0[1])], Kr];
                      return w(gUr, I, K0[5], re);
                    case 9:
                      var xe = k[1], Re = xe[1], ve = Re[0] === 0 ? S(Re[1]) : t0(Re[1]), Ie = 0, Ge = xe[3] ? "ES" : "CommonJS", Me = [0, [0, IGr, ve], [0, [0, OGr, W0(xe[2])], [0, [0, TGr, Ge], Ie]]];
                      return w(AGr, I, xe[4], Me);
                    case 10:
                      var an = k[1], We = [0, [0, NGr, l(an[1])], 0];
                      return w(CGr, I, an[2], We);
                    case 11:
                      var Ae = k[1], cn = [0, [0, AUr, g0(Ae[3])], 0], rn = [0, [0, NUr, e(qr, Ae[2])], cn], kn = [0, [0, CUr, S(Ae[1])], rn];
                      return w(PUr, I, Ae[4], kn);
                    case 12:
                      return Jr(1, [0, I, k[1]]);
                    case 13:
                      return L([0, I, k[1]]);
                    case 14:
                      var vn = k[1], Ne = [0, [0, PGr, fr(vn[2])], 0], Je = [0, [0, DGr, Q(vn[1])], Ne];
                      return w(LGr, I, vn[3], Je);
                    case 15:
                      return w(RGr, I, k[1][1], 0);
                    case 16:
                      var en = k[1], _n = en[2], Cn = _n[2], Hn = _n[1];
                      switch (Cn[0]) {
                        case 0:
                          var Fn = Cn[1], vt = [0, [0, KHr, !!Fn[2]], [0, [0, zHr, !!Fn[3]], 0]], Nt = Fn[1], gt = [0, [0, WHr, n(function(ku) {
                            var wu = ku[2], Ii = wu[2], w7 = Ii[2], Ki = w7[1], ev = 0, Lb = Ki ? CYr : PYr, nv = [0, [0, XHr, w(RYr, Ii[1], w7[2], [0, [0, LYr, !!Ki], [0, [0, DYr, bn(Lb)], 0]])], ev], Rb = [0, [0, YHr, S(wu[1])], nv];
                            return w(VHr, ku[1], 0, Rb);
                          }, Nt)], vt], bt = w(JHr, Hn, p(Fn[4]), gt);
                          break;
                        case 1:
                          var Zt = Cn[1], qt = [0, [0, ZHr, !!Zt[2]], [0, [0, $Hr, !!Zt[3]], 0]], Ft = Zt[1], Ct = [0, [0, QHr, n(function(ku) {
                            var wu = ku[2], Ii = wu[2], w7 = Ii[2], Ki = [0, [0, qHr, w(gYr, Ii[1], w7[3], [0, [0, SYr, w7[1]], [0, [0, EYr, bn(w7[2])], 0]])], 0], ev = [0, [0, UHr, S(wu[1])], Ki];
                            return w(HHr, ku[1], 0, ev);
                          }, Ft)], qt], bt = w(rXr, Hn, p(Zt[4]), Ct);
                          break;
                        case 2:
                          var du = Cn[1], Wu = du[1];
                          if (Wu[0] === 0) var lt = Wu[1], Bu = d1(function(ku) {
                            var wu = [0, [0, MHr, S(ku[2][1])], 0];
                            return w(BHr, ku[1], 0, wu);
                          }, lt);
                          else var ou = Wu[1], Bu = d1(function(ku) {
                            var wu = ku[2], Ii = [0, [0, RHr, t0(wu[2])], 0], w7 = [0, [0, jHr, S(wu[1])], Ii];
                            return w(GHr, ku[1], 0, w7);
                          }, ou);
                          var K7 = [0, [0, nXr, !!du[2]], [0, [0, eXr, !!du[3]], 0]], Yi = [0, [0, tXr, hu(Bu)], K7], bt = w(uXr, Hn, p(du[4]), Yi);
                          break;
                        default:
                          var a7 = Cn[1], Hc = [0, [0, iXr, !!a7[2]], 0], W7 = a7[1], Ut = [0, [0, fXr, n(function(ku) {
                            var wu = [0, [0, DHr, S(ku[2][1])], 0];
                            return w(LHr, ku[1], 0, wu);
                          }, W7)], Hc], bt = w(xXr, Hn, p(a7[3]), Ut);
                      }
                      var B0 = [0, [0, aXr, S(en[1])], [0, [0, oXr, bt], 0]];
                      return w(cXr, I, en[3], B0);
                    case 17:
                      var D0 = k[1], Le = D0[2], He = Le[0] === 0 ? Q(Le[1]) : fr(Le[1]), he = [0, [0, GGr, He], [0, [0, jGr, bn(Ir(1))], 0]];
                      return w(MGr, I, D0[3], he);
                    case 18:
                      var me = k[1], Zn = me[5], wn = me[4], ft = me[3], xt = me[2];
                      if (xt) {
                        var jn = xt[1];
                        if (jn[0] !== 0) {
                          var ut = [0, [0, BGr, bn(Ir(wn))], 0], dt = [0, [0, qGr, e(S, jn[1][2])], ut];
                          return w(HGr, I, Zn, [0, [0, UGr, e(t0, ft)], dt]);
                        }
                      }
                      var xn = [0, [0, XGr, bn(Ir(wn))], 0], ln = [0, [0, YGr, e(t0, ft)], xn], it = [0, [0, VGr, _r(xt)], ln];
                      return w(KGr, I, Zn, [0, [0, zGr, e(Q, me[1])], it]);
                    case 19:
                      var Tt = k[1], Ti = [0, [0, WGr, e(We0, Tt[2])], 0], hs = [0, [0, JGr, fr(Tt[1])], Ti];
                      return w($Gr, I, Tt[3], hs);
                    case 20:
                      var Au = k[1], Hs = function(ku) {
                        return ku[0] === 0 ? c0(ku[1]) : fr(ku[1]);
                      }, Vi = [0, [0, ZGr, Q(Au[4])], 0], Xs = [0, [0, QGr, e(fr, Au[3])], Vi], Ys = [0, [0, rMr, e(fr, Au[2])], Xs], nn = [0, [0, eMr, e(Hs, Au[1])], Ys];
                      return w(nMr, I, Au[5], nn);
                    case 21:
                      var si = k[1], Vs = si[1], c2 = Vs[0] === 0 ? c0(Vs[1]) : Or(Vs[1]), M9 = [0, [0, tMr, !!si[4]], 0], B9 = [0, [0, uMr, Q(si[3])], M9], q9 = [0, [0, fMr, c2], [0, [0, iMr, fr(si[2])], B9]];
                      return w(xMr, I, si[5], q9);
                    case 22:
                      var zs = k[1], s2 = zs[1], U9 = s2[0] === 0 ? c0(s2[1]) : Or(s2[1]), H9 = [0, [0, oMr, !!zs[4]], 0], X9 = [0, [0, aMr, Q(zs[3])], H9], H1 = [0, [0, sMr, U9], [0, [0, cMr, fr(zs[2])], X9]];
                      return w(vMr, I, zs[5], H1);
                    case 23:
                      var vi = k[1], ab = vi[7], cb = vi[3], sb = vi[2], Y9 = cb[0] === 0 ? cb[1] : ke(kqr), V9 = ab[0] === 0 ? 0 : [0, ab[1]], z9 = vi[9], vb = y7(p(sb[2][4]), z9), K9 = [0, [0, wqr, e(qr, vi[8])], 0], W9 = [0, [0, Sqr, false], [0, [0, Eqr, e(l, V9)], K9]], J9 = [0, [0, gqr, e(Fr, vi[6])], W9], $9 = [0, [0, Tqr, !!vi[4]], [0, [0, Fqr, !!vi[5]], J9]], lb = [0, [0, Oqr, W0(Y9)], $9], Z9 = [0, [0, Iqr, Hr(sb)], lb];
                      return w(Nqr, I, vb, [0, [0, Aqr, e(S, vi[1])], Z9]);
                    case 24:
                      var X1 = k[1], v2 = X1[3];
                      if (v2) {
                        var bb = v2[1][2], pb = bb[2], mb = bb[1], On = mb[2], Gn = function(wu) {
                          return y7(wu, pb);
                        };
                        switch (On[0]) {
                          case 0:
                            var Y1 = On[1], _b = JD(Y1[2], pb), Mn = [0, [0, Y1[1], _b]];
                            break;
                          case 1:
                            var yb = On[1], Q9 = Gn(yb[2]), Mn = [1, [0, yb[1], Q9]];
                            break;
                          case 2:
                            var Xc = On[1], r_ = Gn(Xc[7]), Mn = [2, [0, Xc[1], Xc[2], Xc[3], Xc[4], Xc[5], Xc[6], r_]];
                            break;
                          case 3:
                            var l2 = On[1], hb = Gn(l2[2]), Mn = [3, [0, l2[1], hb]];
                            break;
                          case 4:
                            var Mn = [4, [0, Gn(On[1][1])]];
                            break;
                          case 5:
                            var Yc = On[1], e_ = Gn(Yc[7]), Mn = [5, [0, Yc[1], Yc[2], Yc[3], Yc[4], Yc[5], Yc[6], e_]];
                            break;
                          case 6:
                            var Ks = On[1], db = Gn(Ks[5]), Mn = [6, [0, Ks[1], Ks[2], Ks[3], Ks[4], db]];
                            break;
                          case 7:
                            var V1 = On[1], n_ = Gn(V1[4]), Mn = [7, [0, V1[1], V1[2], V1[3], n_]];
                            break;
                          case 8:
                            var ds = On[1], t_ = Gn(ds[5]), Mn = [8, [0, ds[1], ds[2], ds[3], ds[4], t_]];
                            break;
                          case 9:
                            var z1 = On[1], u_ = Gn(z1[4]), Mn = [9, [0, z1[1], z1[2], z1[3], u_]];
                            break;
                          case 10:
                            var b2 = On[1], i_ = Gn(b2[2]), Mn = [10, [0, b2[1], i_]];
                            break;
                          case 11:
                            var Ws = On[1], kb = Gn(Ws[4]), Mn = [11, [0, Ws[1], Ws[2], Ws[3], kb]];
                            break;
                          case 12:
                            var Js = On[1], f_ = Gn(Js[5]), Mn = [12, [0, Js[1], Js[2], Js[3], Js[4], f_]];
                            break;
                          case 13:
                            var zi = On[1], Vc = Gn(zi[3]), Mn = [13, [0, zi[1], zi[2], Vc]];
                            break;
                          case 14:
                            var $s = On[1], x_ = Gn($s[3]), Mn = [14, [0, $s[1], $s[2], x_]];
                            break;
                          case 15:
                            var Mn = [15, [0, Gn(On[1][1])]];
                            break;
                          case 16:
                            var p2 = On[1], m2 = Gn(p2[3]), Mn = [16, [0, p2[1], p2[2], m2]];
                            break;
                          case 17:
                            var _2 = On[1], o_ = Gn(_2[3]), Mn = [17, [0, _2[1], _2[2], o_]];
                            break;
                          case 18:
                            var Zs = On[1], a_ = Gn(Zs[5]), Mn = [18, [0, Zs[1], Zs[2], Zs[3], Zs[4], a_]];
                            break;
                          case 19:
                            var y2 = On[1], qL = Gn(y2[3]), Mn = [19, [0, y2[1], y2[2], qL]];
                            break;
                          case 20:
                            var K1 = On[1], UL = Gn(K1[5]), Mn = [20, [0, K1[1], K1[2], K1[3], K1[4], UL]];
                            break;
                          case 21:
                            var W1 = On[1], HL = Gn(W1[5]), Mn = [21, [0, W1[1], W1[2], W1[3], W1[4], HL]];
                            break;
                          case 22:
                            var J1 = On[1], XL = Gn(J1[5]), Mn = [22, [0, J1[1], J1[2], J1[3], J1[4], XL]];
                            break;
                          case 23:
                            var Oi = On[1], YL = Oi[10], VL = Gn(Oi[9]), Mn = [23, [0, Oi[1], Oi[2], Oi[3], Oi[4], Oi[5], Oi[6], Oi[7], Oi[8], VL, YL]];
                            break;
                          case 24:
                            var h22 = On[1], zL = Gn(h22[4]), Mn = [24, [0, h22[1], h22[2], h22[3], zL]];
                            break;
                          case 25:
                            var $1 = On[1], KL = Gn($1[5]), Mn = [25, [0, $1[1], $1[2], $1[3], $1[4], KL]];
                            break;
                          case 26:
                            var Z1 = On[1], WL = Gn(Z1[5]), Mn = [26, [0, Z1[1], Z1[2], Z1[3], Z1[4], WL]];
                            break;
                          case 27:
                            var wb = On[1], JL = Gn(wb[3]), Mn = [27, [0, wb[1], wb[2], JL]];
                            break;
                          case 28:
                            var Eb = On[1], $L = Eb[3], ZL = Gn(Eb[2]), Mn = [28, [0, Eb[1], ZL, $L]];
                            break;
                          case 29:
                            var d2 = On[1], QL = d2[4], rR = Gn(d2[3]), Mn = [29, [0, d2[1], d2[2], rR, QL]];
                            break;
                          case 30:
                            var c_ = On[1], eR = Gn(c_[2]), Mn = [30, [0, c_[1], eR]];
                            break;
                          case 31:
                            var k2 = On[1], nR = Gn(k2[4]), Mn = [31, [0, k2[1], k2[2], k2[3], nR]];
                            break;
                          case 32:
                            var w2 = On[1], tR = Gn(w2[4]), Mn = [32, [0, w2[1], w2[2], w2[3], tR]];
                            break;
                          case 33:
                            var Q1 = On[1], uR = Gn(Q1[5]), Mn = [33, [0, Q1[1], Q1[2], Q1[3], Q1[4], uR]];
                            break;
                          case 34:
                            var Sb = On[1], iR = Gn(Sb[3]), Mn = [34, [0, Sb[1], Sb[2], iR]];
                            break;
                          case 35:
                            var gb = On[1], fR = Gn(gb[3]), Mn = [35, [0, gb[1], gb[2], fR]];
                            break;
                          default:
                            var Fb = On[1], xR = Gn(Fb[3]), Mn = [36, [0, Fb[1], Fb[2], xR]];
                        }
                        var s_ = Q([0, mb[1], Mn]);
                      } else var s_ = i7;
                      var oR = [0, [0, bMr, Q(X1[2])], [0, [0, lMr, s_], 0]], aR = [0, [0, pMr, fr(X1[1])], oR];
                      return w(mMr, I, X1[4], aR);
                    case 25:
                      var rv = k[1], Tb = rv[4], v_ = rv[3];
                      if (Tb) {
                        var Ob = Tb[1];
                        if (Ob[0] === 0) var cR = Ob[1], b_ = d1(function(wu) {
                          var Ii = wu[1], w7 = wu[3], Ki = wu[2], ev = Ki ? yt(w7[1], Ki[1][1]) : w7[1], Lb = Ki ? Ki[1] : w7, nv = 0, Rb = 0;
                          if (Ii) switch (Ii[1]) {
                            case 0:
                              var jb = Jc;
                              break;
                            case 1:
                              var jb = rs;
                              break;
                            default:
                              nv = 1;
                          }
                          else nv = 1;
                          if (nv) var jb = i7;
                          var IR = [0, [0, aWr, S(Lb)], [0, [0, oWr, jb], Rb]];
                          return w(sWr, ev, 0, [0, [0, cWr, S(w7)], IR]);
                        }, cR);
                        else var l_ = Ob[1], sR = [0, [0, fWr, S(l_[2])], 0], b_ = [0, w(xWr, l_[1], 0, sR), 0];
                        var Ib = b_;
                      } else var Ib = Tb;
                      if (v_) var p_ = v_[1], vR = [0, [0, uWr, S(p_)], 0], m_ = [0, w(iWr, p_[1], 0, vR), Ib];
                      else var m_ = Ib;
                      switch (rv[1]) {
                        case 0:
                          var Ab = _Mr;
                          break;
                        case 1:
                          var Ab = yMr;
                          break;
                        default:
                          var Ab = hMr;
                      }
                      var lR = [0, [0, dMr, bn(Ab)], 0], bR = [0, [0, kMr, t0(rv[2])], lR], pR = [0, [0, wMr, hu(m_)], bR];
                      return w(EMr, I, rv[5], pR);
                    case 26:
                      return Wr([0, I, k[1]]);
                    case 27:
                      var Nb = k[1], mR = [0, [0, SMr, Q(Nb[2])], 0], _R = [0, [0, gMr, S(Nb[1])], mR];
                      return w(FMr, I, Nb[3], _R);
                    case 28:
                      var __ = k[1], yR = [0, [0, TMr, e(fr, __[1])], 0];
                      return w(OMr, I, __[2], yR);
                    case 29:
                      var Cb = k[1], hR = [0, [0, IMr, n(i0, Cb[2])], 0], dR = [0, [0, AMr, fr(Cb[1])], hR];
                      return w(NMr, I, Cb[3], dR);
                    case 30:
                      var y_ = k[1], kR = [0, [0, CMr, fr(y_[1])], 0];
                      return w(PMr, I, y_[2], kR);
                    case 31:
                      var E2 = k[1], wR = [0, [0, DMr, e(W0, E2[3])], 0], ER = [0, [0, LMr, e(l0, E2[2])], wR], SR = [0, [0, RMr, W0(E2[1])], ER];
                      return w(jMr, I, E2[4], SR);
                    case 32:
                      return ar([0, I, k[1]]);
                    case 33:
                      return Jr(0, [0, I, k[1]]);
                    case 34:
                      return c0([0, I, k[1]]);
                    case 35:
                      var Pb = k[1], gR = [0, [0, GMr, Q(Pb[2])], 0], FR = [0, [0, MMr, fr(Pb[1])], gR];
                      return w(BMr, I, Pb[3], FR);
                    default:
                      var Db = k[1], TR = [0, [0, qMr, Q(Db[2])], 0], OR = [0, [0, UMr, fr(Db[1])], TR];
                      return w(HMr, I, Db[3], OR);
                  }
                }
                function i0(_) {
                  var k = _[2], I = [0, [0, eUr, n(Q, k[2])], 0], U = [0, [0, nUr, e(fr, k[1])], I];
                  return w(tUr, _[1], k[3], U);
                }
                function l0(_) {
                  var k = _[2], I = [0, [0, uUr, W0(k[2])], 0], U = [0, [0, iUr, e(Or, k[1])], I];
                  return w(fUr, _[1], k[3], U);
                }
                function S0(_) {
                  var k = _[2], I = [0, [0, QUr, fr(k[1])], 0];
                  return w(rHr, _[1], k[2], I);
                }
                function T0(_) {
                  var k = _[2], I = [0, [0, eHr, e($r, k[2])], 0], U = [0, [0, nHr, S(k[1])], I];
                  return w(tHr, _[1], 0, U);
                }
                function rr(_) {
                  switch (_[0]) {
                    case 0:
                      var k = _[1], I = k[2], U = I[6], Y = I[2];
                      switch (Y[0]) {
                        case 0:
                          var I0 = U, D = 0, u0 = f0(Y[1]);
                          break;
                        case 1:
                          var I0 = U, D = 0, u0 = S(Y[1]);
                          break;
                        case 2:
                          var I0 = U, D = 0, u0 = _0(Y[1]);
                          break;
                        default:
                          var y0 = Y[1][2], P0 = y7(y0[2], U), I0 = P0, D = 1, u0 = fr(y0[1]);
                      }
                      switch (I[1]) {
                        case 0:
                          var X0 = fHr;
                          break;
                        case 1:
                          var X0 = xHr;
                          break;
                        case 2:
                          var X0 = oHr;
                          break;
                        default:
                          var X0 = aHr;
                      }
                      var J0 = [0, [0, sHr, !!D], [0, [0, cHr, n(S0, I[5])], 0]], ir = [0, [0, lHr, bn(X0)], [0, [0, vHr, !!I[4]], J0]], Q0 = [0, [0, pHr, u0], [0, [0, bHr, Rr(I[3])], ir]];
                      return w(mHr, k[1], I0, Q0);
                    case 1:
                      var F0 = _[1], Sr = F0[2], mr = Sr[6], Cr = Sr[2], sr = Sr[1];
                      switch (sr[0]) {
                        case 0:
                          var h0 = mr, Kr = 0, re = f0(sr[1]);
                          break;
                        case 1:
                          var h0 = mr, Kr = 0, re = S(sr[1]);
                          break;
                        case 2:
                          var Pr = ke(gHr), h0 = Pr[3], Kr = Pr[2], re = Pr[1];
                          break;
                        default:
                          var K0 = sr[1][2], Ur = y7(K0[2], mr), h0 = Ur, Kr = 1, re = fr(K0[1]);
                      }
                      if (typeof Cr == "number") if (Cr) var xe = 0, Re = 0;
                      else var xe = 1, Re = 0;
                      else var xe = 0, Re = [0, Cr[1]];
                      var ve = xe && [0, [0, FHr, !!xe], 0], Ie = [0, [0, THr, e(Er, Sr[5])], 0], Ge = [0, [0, IHr, !!Kr], [0, [0, OHr, !!Sr[4]], Ie]], Me = [0, [0, AHr, i(l, Sr[3])], Ge], an = on([0, [0, CHr, re], [0, [0, NHr, e(fr, Re)], Me]], ve);
                      return w(PHr, F0[1], h0, an);
                    default:
                      var We = _[1], Ae = We[2], cn = Ae[2];
                      if (typeof cn == "number") if (cn) var rn = 0, kn = 0;
                      else var rn = 1, kn = 0;
                      else var rn = 0, kn = [0, cn[1]];
                      var vn = rn && [0, [0, _Hr, !!rn], 0], Ne = [0, [0, yHr, e(Er, Ae[5])], 0], Je = [0, [0, dHr, false], [0, [0, hHr, !!Ae[4]], Ne]], en = [0, [0, kHr, i(l, Ae[3])], Je], _n = [0, [0, wHr, e(fr, kn)], en], Cn = on([0, [0, EHr, _0(Ae[1])], _n], vn);
                      return w(SHr, We[1], Ae[6], Cn);
                  }
                }
                function L0(_) {
                  var k = _[2], I = k[2], U = k[1];
                  if (I) {
                    var Y = [0, [0, gXr, fr(I[1])], 0], y0 = [0, [0, FXr, Or(U)], Y];
                    return w(TXr, _[1], 0, y0);
                  }
                  return Or(U);
                }
                function B(_, k) {
                  var I = [0, [0, PXr, Or(k[1])], 0];
                  return w(DXr, _, k[2], I);
                }
                function Z(_) {
                  switch (_[0]) {
                    case 0:
                      var k = _[1], I = k[2], U = I[2], Y = I[1];
                      if (U) {
                        var y0 = [0, [0, LXr, fr(U[1])], 0], P0 = [0, [0, RXr, Or(Y)], y0];
                        return w(jXr, k[1], 0, P0);
                      }
                      return Or(Y);
                    case 1:
                      var I0 = _[1];
                      return B(I0[1], I0[2]);
                    default:
                      return i7;
                  }
                }
                function p0(_) {
                  if (_[0] === 0) {
                    var k = _[1], I = k[2];
                    switch (I[0]) {
                      case 0:
                        var U = fr(I[2]), X0 = 0, J0 = I[3], ir = 0, Q0 = GXr, F0 = U, Sr = I[1];
                        break;
                      case 1:
                        var Y = I[2], y0 = Rr([0, Y[1], Y[2]]), X0 = 0, J0 = 0, ir = 1, Q0 = MXr, F0 = y0, Sr = I[1];
                        break;
                      case 2:
                        var P0 = I[2], I0 = Rr([0, P0[1], P0[2]]), X0 = I[3], J0 = 0, ir = 0, Q0 = BXr, F0 = I0, Sr = I[1];
                        break;
                      default:
                        var D = I[2], u0 = Rr([0, D[1], D[2]]), X0 = I[3], J0 = 0, ir = 0, Q0 = qXr, F0 = u0, Sr = I[1];
                    }
                    switch (Sr[0]) {
                      case 0:
                        var Pr = X0, K0 = 0, Ur = f0(Sr[1]);
                        break;
                      case 1:
                        var Pr = X0, K0 = 0, Ur = S(Sr[1]);
                        break;
                      case 2:
                        var mr = ke(UXr), Pr = mr[3], K0 = mr[2], Ur = mr[1];
                        break;
                      default:
                        var Cr = Sr[1][2], sr = y7(Cr[2], X0), Pr = sr, K0 = 1, Ur = fr(Cr[1]);
                    }
                    return w(WXr, k[1], Pr, [0, [0, KXr, Ur], [0, [0, zXr, F0], [0, [0, VXr, bn(Q0)], [0, [0, YXr, !!ir], [0, [0, XXr, !!J0], [0, [0, HXr, !!K0], 0]]]]]]);
                  }
                  var h0 = _[1], Kr = h0[2], re = [0, [0, JXr, fr(Kr[1])], 0];
                  return w($Xr, h0[1], Kr[2], re);
                }
                function b0(_) {
                  if (_[0] === 0) {
                    var k = _[1], I = k[2], U = I[3], Y = I[2], y0 = I[1];
                    switch (y0[0]) {
                      case 0:
                        var D = 0, u0 = 0, X0 = f0(y0[1]);
                        break;
                      case 1:
                        var D = 0, u0 = 0, X0 = S(y0[1]);
                        break;
                      default:
                        var P0 = y0[1][2], I0 = fr(P0[1]), D = P0[2], u0 = 1, X0 = I0;
                    }
                    if (U) var J0 = U[1], ir = yt(Y[1], J0[1]), Q0 = [0, [0, ZXr, fr(J0)], 0], F0 = w(rYr, ir, 0, [0, [0, QXr, Or(Y)], Q0]);
                    else var F0 = Or(Y);
                    return w(xYr, k[1], D, [0, [0, fYr, X0], [0, [0, iYr, F0], [0, [0, uYr, ji], [0, [0, tYr, false], [0, [0, nYr, !!I[4]], [0, [0, eYr, !!u0], 0]]]]]]);
                  }
                  var Sr = _[1];
                  return B(Sr[1], Sr[2]);
                }
                function O0(_) {
                  var k = _[2], I = [0, [0, oYr, fr(k[1])], 0];
                  return w(aYr, _[1], k[2], I);
                }
                function M0(_) {
                  return _[0] === 0 ? fr(_[1]) : O0(_[1]);
                }
                function er(_) {
                  switch (_[0]) {
                    case 0:
                      return fr(_[1]);
                    case 1:
                      return O0(_[1]);
                    default:
                      return i7;
                  }
                }
                function yr(_) {
                  var k = _[2], I = [0, [0, cYr, !!k[3]], 0], U = [0, [0, sYr, fr(k[2])], I], Y = [0, [0, vYr, Or(k[1])], U];
                  return w(lYr, _[1], 0, Y);
                }
                function vr(_) {
                  var k = _[2], I = k[1], U = U1([0, [0, qYr, bn(I[1])], [0, [0, BYr, bn(I[2])], 0]]);
                  return w(XYr, _[1], 0, [0, [0, HYr, U], [0, [0, UYr, !!k[2]], 0]]);
                }
                function $0(_) {
                  var k = _[2], I = [0, [0, rVr, e(fr, k[2])], 0], U = [0, [0, eVr, Or(k[1])], I];
                  return w(nVr, _[1], 0, U);
                }
                function Er(_) {
                  var k = _[2], I = k[1] ? cY : "plus";
                  return w(uVr, _[1], k[2], [0, [0, tVr, I], 0]);
                }
                function Mr(_) {
                  var k = _[2];
                  return k0(k[2], k[1]);
                }
                function Br(_) {
                  var k = _[2], I = [0, [0, OVr, g0(k[1][2])], [0, [0, TVr, false], 0]], U = [0, [0, IVr, e(S, 0)], I];
                  return w(AVr, _[1], k[2], U);
                }
                function qr(_) {
                  var k = _[2], I = [0, [0, fKr, n(jr, k[1])], 0], U = p(k[2]);
                  return w(xKr, _[1], U, I);
                }
                function jr(_) {
                  var k = _[2], I = k[1][2], U = [0, [0, oKr, e(g0, k[4])], 0], Y = [0, [0, aKr, e(Er, k[3])], U], y0 = [0, [0, cKr, i(l, k[2])], Y];
                  return w(vKr, _[1], I[2], [0, [0, sKr, bn(I[1])], y0]);
                }
                function $r(_) {
                  var k = _[2], I = [0, [0, lKr, n(g0, k[1])], 0], U = p(k[2]);
                  return w(bKr, _[1], U, I);
                }
                function ne(_) {
                  var k = _[2], I = [0, [0, pKr, n(Qr, k[1])], 0], U = p(k[2]);
                  return w(mKr, _[1], U, I);
                }
                function Qr(_) {
                  if (_[0] === 0) return g0(_[1]);
                  var k = _[1], I = k[1], U = k[2][1];
                  return V([0, I, [0, [0, Rc(0, [0, I, _Kr])], 0, U]]);
                }
                function be(_) {
                  if (_[0] === 0) {
                    var k = _[1], I = k[2], U = I[1], Y = U[0] === 0 ? b(U[1]) : R0(U[1]), y0 = [0, [0, LKr, Y], [0, [0, DKr, e(ce, I[2])], 0]];
                    return w(RKr, k[1], 0, y0);
                  }
                  var P0 = _[1], I0 = P0[2], D = [0, [0, jKr, fr(I0[1])], 0];
                  return w(GKr, P0[1], I0[2], D);
                }
                function ae(_) {
                  var k = [0, [0, NKr, s0(_[2][1])], 0];
                  return w(CKr, _[1], 0, k);
                }
                function pe(_) {
                  var k = _[2], I = k[1], U = _[1], Y = I ? fr(I[1]) : w(MKr, [0, U[1], [0, U[2][1], U[2][2] + 1 | 0], [0, U[3][1], U[3][2] - 1 | 0]], 0, 0);
                  return w(qKr, U, p(k[2]), [0, [0, BKr, Y], 0]);
                }
                function oe(_) {
                  var k = _[2], I = _[1];
                  switch (k[0]) {
                    case 0:
                      return hr([0, I, k[1]]);
                    case 1:
                      return U0([0, I, k[1]]);
                    case 2:
                      return pe([0, I, k[1]]);
                    case 3:
                      var U = k[1], Y = [0, [0, UKr, fr(U[1])], 0];
                      return w(HKr, I, U[2], Y);
                    default:
                      var y0 = k[1];
                      return w(VKr, I, 0, [0, [0, YKr, bn(y0[1])], [0, [0, XKr, bn(y0[2])], 0]]);
                  }
                }
                function ce(_) {
                  return _[0] === 0 ? f0([0, _[1], _[2]]) : pe([0, _[1], _[2]]);
                }
                function ge(_) {
                  var k = _[2], I = k[2], U = k[1], Y = S(I ? I[1] : U), y0 = [0, [0, nWr, S(U)], [0, [0, eWr, Y], 0]];
                  return w(tWr, _[1], 0, y0);
                }
                function q0(_) {
                  var k = _[2];
                  if (k[1]) var I = k[2], U = vWr;
                  else var I = k[2], U = lWr;
                  return w(U, _[1], 0, [0, [0, bWr, bn(I)], 0]);
                }
                function Fr(_) {
                  var k = _[2], I = k[1];
                  if (I) var U = [0, [0, pWr, fr(I[1])], 0], Y = mWr;
                  else var U = 0, Y = _Wr;
                  return w(Y, _[1], k[2], U);
                }
                return [0, A, fr];
              }
              function T(E) {
                return y(E)[1];
              }
              return [0, T, function(E) {
                return y(E)[2];
              }, s];
            }(wne);
            function ob(t, n, e) {
              var i = n[e];
              return Mp(i) ? i | 0 : t;
            }
            function Ene(t, n) {
              var e = RV(n, Jz) ? {} : n, i = B7(t), x = ob(Bv[5], e, Nre), c = ob(Bv[4], e, Cre), s = ob(Bv[3], e, Pre), p = ob(Bv[2], e, Dre), y = [0, [0, ob(Bv[1], e, Lre), p, s, c, x]], T = e.tokens, E = Mp(T), d = E && T | 0, w = e.comments, G = Mp(w) ? w | 0 : 1, A = e.all_comments, S = Mp(A) ? A | 0 : 1, M = [0, 0], K = d && [0, function(b0) {
                return M[1] = [0, b0, M[1]], 0;
              }], V = [0, y], f0 = [0, K], m0 = uz ? uz[1] : 1, k0 = f0 && f0[1], g0 = V && V[1], e0 = [0, g0], x0 = [0, k0], l = 0, c0 = x0 && x0[1], t0 = e0 && e0[1], o0 = Hee([0, c0], [0, t0], l, i), w0 = u(se[1], o0), _0 = ye(o0[1][1]), E0 = [0, LL[1], 0], U0 = ye(le(function(b0, O0) {
                var M0 = b0[2], er = b0[1];
                return o(LL[3], O0, er) ? [0, er, M0] : [0, o(LL[4], O0, er), [0, O0, M0]];
              }, E0, _0)[2]);
              if (U0 && m0) throw [0, Nee, U0[1], U0[2]];
              Ke0[1] = 0;
              for (var b = un(i) - 0 | 0, R0 = i, X = 0, s0 = 0; ; ) {
                if (s0 === b) var hr = X;
                else {
                  var Ar = Xu(R0, s0), or = 0;
                  if (0 <= Ar && !(zn < Ar)) var W0 = 1;
                  else or = 1;
                  if (or) {
                    var Lr = 0;
                    if (nI <= Ar && !(y8 < Ar)) var W0 = 2;
                    else Lr = 1;
                    if (Lr) {
                      var Tr = 0;
                      if (hv <= Ar && !(i6 < Ar)) var W0 = 3;
                      else Tr = 1;
                      if (Tr) {
                        var Hr = 0;
                        if (s1 <= Ar && !(v8 < Ar)) var W0 = 4;
                        else Hr = 1;
                        if (Hr) var W0 = 0;
                      }
                    }
                  }
                  if (W0 === 0) {
                    var X = SL(X, s0, 0), s0 = s0 + 1 | 0;
                    continue;
                  }
                  if (!((b - s0 | 0) < W0)) {
                    var Or = W0 - 1 | 0, fr = s0 + W0 | 0;
                    if (3 < Or >>> 0) throw [0, Sn, Qo0];
                    switch (Or) {
                      case 0:
                        var Rr = Xu(R0, s0);
                        break;
                      case 1:
                        var Rr = (Xu(R0, s0) & 31) << 6 | Xu(R0, s0 + 1 | 0) & 63;
                        break;
                      case 2:
                        var Rr = (Xu(R0, s0) & 15) << 12 | (Xu(R0, s0 + 1 | 0) & 63) << 6 | Xu(R0, s0 + 2 | 0) & 63;
                        break;
                      default:
                        var Rr = (Xu(R0, s0) & 7) << 18 | (Xu(R0, s0 + 1 | 0) & 63) << 12 | (Xu(R0, s0 + 2 | 0) & 63) << 6 | Xu(R0, s0 + 3 | 0) & 63;
                    }
                    var X = SL(X, s0, [0, Rr]), s0 = fr;
                    continue;
                  }
                  var hr = SL(X, s0, 0);
                }
                for (var Wr = tGr, Jr = ye([0, 6, hr]); ; ) {
                  var ar = Wr[3], _r = Wr[2], Ir = Wr[1];
                  if (Jr) {
                    var fe = Jr[1];
                    if (fe === 5) {
                      var v0 = Jr[2];
                      if (v0 && v0[1] === 6) {
                        var P = _l(ye([0, Ir, _r])), Wr = [0, Ir + 2 | 0, 0, [0, P, ar]], Jr = v0[2];
                        continue;
                      }
                    } else if (!(6 <= fe)) {
                      var L = Jr[2], Wr = [0, Ir + we0(fe) | 0, [0, Ir, _r], ar], Jr = L;
                      continue;
                    }
                    var Q = _l(ye([0, Ir, _r])), i0 = Jr[2], Wr = [0, Ir + we0(fe) | 0, 0, [0, Q, ar]], Jr = i0;
                    continue;
                  }
                  var l0 = _l(ye(ar));
                  if (G) var T0 = w0;
                  else var S0 = u(Tee[1], 0), T0 = o(Qe(S0, -201766268, 25), S0, w0);
                  if (S) var L0 = T0;
                  else var rr = T0[2], L0 = [0, T0[1], [0, rr[1], rr[2], 0]];
                  var B = o($e0[1], [0, l0], L0), Z = on(U0, Ke0[1]);
                  if (B.errors = u($e0[3], Z), d) {
                    var p0 = M[1];
                    B.tokens = hu(Fp(u(kne[1], l0), p0));
                  }
                  return B;
                }
              }
            }
            if (typeof H0 < "u") var Ze0 = H0;
            else {
              var Qe0 = {};
              GN.flow = Qe0;
              var Ze0 = Qe0;
            }
            Ze0.parse = function(t, n) {
              try {
                var e = Ene(t, n);
                return e;
              } catch (i) {
                return i = Et(i), i[1] === MN ? u($z, i[2]) : u($z, new dee(bn(Te(Rre, Cp(i)))));
              }
            }, uN(0);
          }(globalThis);
        } });
        Pt();
        var uoe = Fu0(), ioe = Vxe(), foe = zxe(), xoe = Qxe(), ooe = { comments: false, enums: true, esproposal_decorators: true, esproposal_export_star_as: true, tokens: true };
        function aoe(H0) {
          let { message: z0, loc: { start: xr, end: gr } } = H0;
          return uoe(z0, { start: { line: xr.line, column: xr.column + 1 }, end: { line: gr.line, column: gr.column + 1 } });
        }
        function coe(H0, z0) {
          let xr = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, { parse: gr } = toe(), de = gr(foe(H0), ooe), [Ve] = de.errors;
          if (Ve) throw aoe(Ve);
          return xr.originalText = H0, xoe(de, xr);
        }
        zu0.exports = { parsers: { flow: ioe(coe) } };
      });
      return soe();
    });
  }
});

// ../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-typescript.js
var require_parser_typescript = __commonJS({
  "../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-typescript.js"(exports2, module2) {
    "use strict";
    (function(e) {
      if (typeof exports2 == "object" && typeof module2 == "object") module2.exports = e();
      else if (typeof define == "function" && define.amd) define(e);
      else {
        var i = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i.prettierPlugins = i.prettierPlugins || {}, i.prettierPlugins.typescript = e();
      }
    })(function() {
      "use strict";
      var Bn = (M, re) => () => (re || M((re = { exports: {} }).exports, re), re.exports);
      var qc = Bn((Sz, CA) => {
        var $0 = function(M) {
          return M && M.Math == Math && M;
        };
        CA.exports = $0(typeof globalThis == "object" && globalThis) || $0(typeof window == "object" && window) || $0(typeof self == "object" && self) || $0(typeof global == "object" && global) || /* @__PURE__ */ function() {
          return this;
        }() || Function("return this")();
      });
      var cg = Bn((Tz, kA) => {
        kA.exports = function(M) {
          try {
            return !!M();
          } catch {
            return true;
          }
        };
      });
      var Am = Bn((xz, AA) => {
        var OL = cg();
        AA.exports = !OL(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      });
      var Z0 = Bn((Ez, NA) => {
        var FL = cg();
        NA.exports = !FL(function() {
          var M = function() {
          }.bind();
          return typeof M != "function" || M.hasOwnProperty("prototype");
        });
      });
      var r1 = Bn((Cz, PA) => {
        var ML = Z0(), e1 = Function.prototype.call;
        PA.exports = ML ? e1.bind(e1) : function() {
          return e1.apply(e1, arguments);
        };
      });
      var FA = Bn((OA) => {
        "use strict";
        var IA = {}.propertyIsEnumerable, wA = Object.getOwnPropertyDescriptor, LL = wA && !IA.call({ 1: 2 }, 1);
        OA.f = LL ? function(re) {
          var Ve = wA(this, re);
          return !!Ve && Ve.enumerable;
        } : IA;
      });
      var XS = Bn((Az, MA) => {
        MA.exports = function(M, re) {
          return { enumerable: !(M & 1), configurable: !(M & 2), writable: !(M & 4), value: re };
        };
      });
      var dp = Bn((Nz, BA) => {
        var LA = Z0(), RA = Function.prototype, RL = RA.bind, QS = RA.call, BL = LA && RL.bind(QS, QS);
        BA.exports = LA ? function(M) {
          return M && BL(M);
        } : function(M) {
          return M && function() {
            return QS.apply(M, arguments);
          };
        };
      });
      var i1 = Bn((Pz, jA) => {
        var JA = dp(), JL = JA({}.toString), jL = JA("".slice);
        jA.exports = function(M) {
          return jL(JL(M), 8, -1);
        };
      });
      var zA = Bn((Iz, UA) => {
        var UL = qc(), zL = dp(), WL = cg(), qL = i1(), YS = UL.Object, VL = zL("".split);
        UA.exports = WL(function() {
          return !YS("z").propertyIsEnumerable(0);
        }) ? function(M) {
          return qL(M) == "String" ? VL(M, "") : YS(M);
        } : YS;
      });
      var $S = Bn((wz, WA) => {
        var KL = qc(), GL = KL.TypeError;
        WA.exports = function(M) {
          if (M == null) throw GL("Can't call method on " + M);
          return M;
        };
      });
      var t1 = Bn((Oz, qA) => {
        var HL = zA(), XL = $S();
        qA.exports = function(M) {
          return HL(XL(M));
        };
      });
      var gp = Bn((Fz, VA) => {
        VA.exports = function(M) {
          return typeof M == "function";
        };
      });
      var Nm = Bn((Mz, KA) => {
        var QL = gp();
        KA.exports = function(M) {
          return typeof M == "object" ? M !== null : QL(M);
        };
      });
      var qy = Bn((Lz, GA) => {
        var ZS = qc(), YL = gp(), $L = function(M) {
          return YL(M) ? M : void 0;
        };
        GA.exports = function(M, re) {
          return arguments.length < 2 ? $L(ZS[M]) : ZS[M] && ZS[M][re];
        };
      });
      var XA = Bn((Rz, HA) => {
        var ZL = dp();
        HA.exports = ZL({}.isPrototypeOf);
      });
      var YA = Bn((Bz, QA) => {
        var eR = qy();
        QA.exports = eR("navigator", "userAgent") || "";
      });
      var aN = Bn((Jz, tN) => {
        var iN = qc(), eT = YA(), $A = iN.process, ZA = iN.Deno, eN = $A && $A.versions || ZA && ZA.version, rN = eN && eN.v8, ad, a1;
        rN && (ad = rN.split("."), a1 = ad[0] > 0 && ad[0] < 4 ? 1 : +(ad[0] + ad[1]));
        !a1 && eT && (ad = eT.match(/Edge\/(\d+)/), (!ad || ad[1] >= 74) && (ad = eT.match(/Chrome\/(\d+)/), ad && (a1 = +ad[1])));
        tN.exports = a1;
      });
      var rT = Bn((jz, oN) => {
        var nN = aN(), rR = cg();
        oN.exports = !!Object.getOwnPropertySymbols && !rR(function() {
          var M = Symbol();
          return !String(M) || !(Object(M) instanceof Symbol) || !Symbol.sham && nN && nN < 41;
        });
      });
      var iT = Bn((Uz, sN) => {
        var iR = rT();
        sN.exports = iR && !Symbol.sham && typeof Symbol.iterator == "symbol";
      });
      var tT = Bn((zz, cN) => {
        var tR = qc(), aR = qy(), nR = gp(), oR = XA(), sR = iT(), cR = tR.Object;
        cN.exports = sR ? function(M) {
          return typeof M == "symbol";
        } : function(M) {
          var re = aR("Symbol");
          return nR(re) && oR(re.prototype, cR(M));
        };
      });
      var lN = Bn((Wz, uN) => {
        var uR = qc(), lR = uR.String;
        uN.exports = function(M) {
          try {
            return lR(M);
          } catch {
            return "Object";
          }
        };
      });
      var n1 = Bn((qz, fN) => {
        var fR = qc(), _R = gp(), pR = lN(), dR = fR.TypeError;
        fN.exports = function(M) {
          if (_R(M)) return M;
          throw dR(pR(M) + " is not a function");
        };
      });
      var pN = Bn((Vz, _N) => {
        var gR = n1();
        _N.exports = function(M, re) {
          var Ve = M[re];
          return Ve == null ? void 0 : gR(Ve);
        };
      });
      var gN = Bn((Kz, dN) => {
        var mR = qc(), aT = r1(), nT = gp(), oT = Nm(), vR = mR.TypeError;
        dN.exports = function(M, re) {
          var Ve, Ke;
          if (re === "string" && nT(Ve = M.toString) && !oT(Ke = aT(Ve, M)) || nT(Ve = M.valueOf) && !oT(Ke = aT(Ve, M)) || re !== "string" && nT(Ve = M.toString) && !oT(Ke = aT(Ve, M))) return Ke;
          throw vR("Can't convert object to primitive value");
        };
      });
      var vN = Bn((Gz, mN) => {
        mN.exports = false;
      });
      var o1 = Bn((Hz, hN) => {
        var yN = qc(), yR = Object.defineProperty;
        hN.exports = function(M, re) {
          try {
            yR(yN, M, { value: re, configurable: true, writable: true });
          } catch {
            yN[M] = re;
          }
          return re;
        };
      });
      var s1 = Bn((Xz, bN) => {
        var hR = qc(), DR = o1(), DN = "__core-js_shared__", bR = hR[DN] || DR(DN, {});
        bN.exports = bR;
      });
      var sT = Bn((Qz, TN) => {
        var SR = vN(), SN = s1();
        (TN.exports = function(M, re) {
          return SN[M] || (SN[M] = re !== void 0 ? re : {});
        })("versions", []).push({ version: "3.22.2", mode: SR ? "pure" : "global", copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)", license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE", source: "https://github.com/zloirock/core-js" });
      });
      var cT = Bn((Yz, xN) => {
        var TR = qc(), xR = $S(), ER = TR.Object;
        xN.exports = function(M) {
          return ER(xR(M));
        };
      });
      var Wg = Bn(($z, EN) => {
        var CR = dp(), kR = cT(), AR = CR({}.hasOwnProperty);
        EN.exports = Object.hasOwn || function(re, Ve) {
          return AR(kR(re), Ve);
        };
      });
      var uT = Bn((Zz, CN) => {
        var NR = dp(), PR = 0, IR = Math.random(), wR = NR(1 .toString);
        CN.exports = function(M) {
          return "Symbol(" + (M === void 0 ? "" : M) + ")_" + wR(++PR + IR, 36);
        };
      });
      var Vy = Bn((eW, IN) => {
        var OR = qc(), FR = sT(), kN = Wg(), MR = uT(), AN = rT(), PN = iT(), Iv = FR("wks"), Pm = OR.Symbol, NN = Pm && Pm.for, LR = PN ? Pm : Pm && Pm.withoutSetter || MR;
        IN.exports = function(M) {
          if (!kN(Iv, M) || !(AN || typeof Iv[M] == "string")) {
            var re = "Symbol." + M;
            AN && kN(Pm, M) ? Iv[M] = Pm[M] : PN && NN ? Iv[M] = NN(re) : Iv[M] = LR(re);
          }
          return Iv[M];
        };
      });
      var MN = Bn((rW, FN) => {
        var RR = qc(), BR = r1(), wN = Nm(), ON = tT(), JR = pN(), jR = gN(), UR = Vy(), zR = RR.TypeError, WR = UR("toPrimitive");
        FN.exports = function(M, re) {
          if (!wN(M) || ON(M)) return M;
          var Ve = JR(M, WR), Ke;
          if (Ve) {
            if (re === void 0 && (re = "default"), Ke = BR(Ve, M, re), !wN(Ke) || ON(Ke)) return Ke;
            throw zR("Can't convert object to primitive value");
          }
          return re === void 0 && (re = "number"), jR(M, re);
        };
      });
      var lT = Bn((iW, LN) => {
        var qR = MN(), VR = tT();
        LN.exports = function(M) {
          var re = qR(M, "string");
          return VR(re) ? re : re + "";
        };
      });
      var JN = Bn((tW, BN) => {
        var KR = qc(), RN = Nm(), fT = KR.document, GR = RN(fT) && RN(fT.createElement);
        BN.exports = function(M) {
          return GR ? fT.createElement(M) : {};
        };
      });
      var _T = Bn((aW, jN) => {
        var HR = Am(), XR = cg(), QR = JN();
        jN.exports = !HR && !XR(function() {
          return Object.defineProperty(QR("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      });
      var pT = Bn((zN) => {
        var YR = Am(), $R = r1(), ZR = FA(), eB = XS(), rB = t1(), iB = lT(), tB = Wg(), aB = _T(), UN = Object.getOwnPropertyDescriptor;
        zN.f = YR ? UN : function(re, Ve) {
          if (re = rB(re), Ve = iB(Ve), aB) try {
            return UN(re, Ve);
          } catch {
          }
          if (tB(re, Ve)) return eB(!$R(ZR.f, re, Ve), re[Ve]);
        };
      });
      var qN = Bn((oW, WN) => {
        var nB = Am(), oB = cg();
        WN.exports = nB && oB(function() {
          return Object.defineProperty(function() {
          }, "prototype", { value: 42, writable: false }).prototype != 42;
        });
      });
      var dT = Bn((sW, KN) => {
        var VN = qc(), sB = Nm(), cB = VN.String, uB = VN.TypeError;
        KN.exports = function(M) {
          if (sB(M)) return M;
          throw uB(cB(M) + " is not an object");
        };
      });
      var hT = Bn((HN) => {
        var lB = qc(), fB = Am(), _B = _T(), pB = qN(), c1 = dT(), GN = lT(), dB = lB.TypeError, gT = Object.defineProperty, gB = Object.getOwnPropertyDescriptor, mT = "enumerable", vT = "configurable", yT = "writable";
        HN.f = fB ? pB ? function(re, Ve, Ke) {
          if (c1(re), Ve = GN(Ve), c1(Ke), typeof re == "function" && Ve === "prototype" && "value" in Ke && yT in Ke && !Ke[yT]) {
            var oi = gB(re, Ve);
            oi && oi[yT] && (re[Ve] = Ke.value, Ke = { configurable: vT in Ke ? Ke[vT] : oi[vT], enumerable: mT in Ke ? Ke[mT] : oi[mT], writable: false });
          }
          return gT(re, Ve, Ke);
        } : gT : function(re, Ve, Ke) {
          if (c1(re), Ve = GN(Ve), c1(Ke), _B) try {
            return gT(re, Ve, Ke);
          } catch {
          }
          if ("get" in Ke || "set" in Ke) throw dB("Accessors not supported");
          return "value" in Ke && (re[Ve] = Ke.value), re;
        };
      });
      var u1 = Bn((uW, XN) => {
        var mB = Am(), vB = hT(), yB = XS();
        XN.exports = mB ? function(M, re, Ve) {
          return vB.f(M, re, yB(1, Ve));
        } : function(M, re, Ve) {
          return M[re] = Ve, M;
        };
      });
      var l1 = Bn((lW, QN) => {
        var hB = dp(), DB = gp(), DT = s1(), bB = hB(Function.toString);
        DB(DT.inspectSource) || (DT.inspectSource = function(M) {
          return bB(M);
        });
        QN.exports = DT.inspectSource;
      });
      var ZN = Bn((fW, $N) => {
        var SB = qc(), TB = gp(), xB = l1(), YN = SB.WeakMap;
        $N.exports = TB(YN) && /native code/.test(xB(YN));
      });
      var iP = Bn((_W, rP) => {
        var EB = sT(), CB = uT(), eP = EB("keys");
        rP.exports = function(M) {
          return eP[M] || (eP[M] = CB(M));
        };
      });
      var bT = Bn((pW, tP) => {
        tP.exports = {};
      });
      var uP = Bn((dW, cP) => {
        var kB = ZN(), sP = qc(), ST = dp(), AB = Nm(), NB = u1(), TT = Wg(), xT = s1(), PB = iP(), IB = bT(), aP = "Object already initialized", CT = sP.TypeError, wB = sP.WeakMap, f1, Ky, _1, OB = function(M) {
          return _1(M) ? Ky(M) : f1(M, {});
        }, FB = function(M) {
          return function(re) {
            var Ve;
            if (!AB(re) || (Ve = Ky(re)).type !== M) throw CT("Incompatible receiver, " + M + " required");
            return Ve;
          };
        };
        kB || xT.state ? (qg = xT.state || (xT.state = new wB()), nP = ST(qg.get), ET = ST(qg.has), oP = ST(qg.set), f1 = function(M, re) {
          if (ET(qg, M)) throw new CT(aP);
          return re.facade = M, oP(qg, M, re), re;
        }, Ky = function(M) {
          return nP(qg, M) || {};
        }, _1 = function(M) {
          return ET(qg, M);
        }) : (Im = PB("state"), IB[Im] = true, f1 = function(M, re) {
          if (TT(M, Im)) throw new CT(aP);
          return re.facade = M, NB(M, Im, re), re;
        }, Ky = function(M) {
          return TT(M, Im) ? M[Im] : {};
        }, _1 = function(M) {
          return TT(M, Im);
        });
        var qg, nP, ET, oP, Im;
        cP.exports = { set: f1, get: Ky, has: _1, enforce: OB, getterFor: FB };
      });
      var _P = Bn((gW, fP) => {
        var kT = Am(), MB = Wg(), lP = Function.prototype, LB = kT && Object.getOwnPropertyDescriptor, AT = MB(lP, "name"), RB = AT && function() {
        }.name === "something", BB = AT && (!kT || kT && LB(lP, "name").configurable);
        fP.exports = { EXISTS: AT, PROPER: RB, CONFIGURABLE: BB };
      });
      var vP = Bn((mW, mP) => {
        var JB = qc(), pP = gp(), jB = Wg(), dP = u1(), UB = o1(), zB = l1(), gP = uP(), WB = _P().CONFIGURABLE, qB = gP.get, VB = gP.enforce, KB = String(String).split("String");
        (mP.exports = function(M, re, Ve, Ke) {
          var oi = Ke ? !!Ke.unsafe : false, kr = Ke ? !!Ke.enumerable : false, pr = Ke ? !!Ke.noTargetGet : false, Lr = Ke && Ke.name !== void 0 ? Ke.name : re, ar;
          if (pP(Ve) && (String(Lr).slice(0, 7) === "Symbol(" && (Lr = "[" + String(Lr).replace(/^Symbol\(([^)]*)\)/, "$1") + "]"), (!jB(Ve, "name") || WB && Ve.name !== Lr) && dP(Ve, "name", Lr), ar = VB(Ve), ar.source || (ar.source = KB.join(typeof Lr == "string" ? Lr : ""))), M === JB) {
            kr ? M[re] = Ve : UB(re, Ve);
            return;
          } else oi ? !pr && M[re] && (kr = true) : delete M[re];
          kr ? M[re] = Ve : dP(M, re, Ve);
        })(Function.prototype, "toString", function() {
          return pP(this) && qB(this).source || zB(this);
        });
      });
      var NT = Bn((vW, yP) => {
        var GB = Math.ceil, HB = Math.floor;
        yP.exports = function(M) {
          var re = +M;
          return re !== re || re === 0 ? 0 : (re > 0 ? HB : GB)(re);
        };
      });
      var DP = Bn((yW, hP) => {
        var XB = NT(), QB = Math.max, YB = Math.min;
        hP.exports = function(M, re) {
          var Ve = XB(M);
          return Ve < 0 ? QB(Ve + re, 0) : YB(Ve, re);
        };
      });
      var SP = Bn((hW, bP) => {
        var $B = NT(), ZB = Math.min;
        bP.exports = function(M) {
          return M > 0 ? ZB($B(M), 9007199254740991) : 0;
        };
      });
      var p1 = Bn((DW, TP) => {
        var eJ = SP();
        TP.exports = function(M) {
          return eJ(M.length);
        };
      });
      var CP = Bn((bW, EP) => {
        var rJ = t1(), iJ = DP(), tJ = p1(), xP = function(M) {
          return function(re, Ve, Ke) {
            var oi = rJ(re), kr = tJ(oi), pr = iJ(Ke, kr), Lr;
            if (M && Ve != Ve) {
              for (; kr > pr; ) if (Lr = oi[pr++], Lr != Lr) return true;
            } else for (; kr > pr; pr++) if ((M || pr in oi) && oi[pr] === Ve) return M || pr || 0;
            return !M && -1;
          };
        };
        EP.exports = { includes: xP(true), indexOf: xP(false) };
      });
      var NP = Bn((SW, AP) => {
        var aJ = dp(), PT = Wg(), nJ = t1(), oJ = CP().indexOf, sJ = bT(), kP = aJ([].push);
        AP.exports = function(M, re) {
          var Ve = nJ(M), Ke = 0, oi = [], kr;
          for (kr in Ve) !PT(sJ, kr) && PT(Ve, kr) && kP(oi, kr);
          for (; re.length > Ke; ) PT(Ve, kr = re[Ke++]) && (~oJ(oi, kr) || kP(oi, kr));
          return oi;
        };
      });
      var IP = Bn((TW, PP) => {
        PP.exports = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
      });
      var OP = Bn((wP) => {
        var cJ = NP(), uJ = IP(), lJ = uJ.concat("length", "prototype");
        wP.f = Object.getOwnPropertyNames || function(re) {
          return cJ(re, lJ);
        };
      });
      var MP = Bn((FP) => {
        FP.f = Object.getOwnPropertySymbols;
      });
      var RP = Bn((CW, LP) => {
        var fJ = qy(), _J = dp(), pJ = OP(), dJ = MP(), gJ = dT(), mJ = _J([].concat);
        LP.exports = fJ("Reflect", "ownKeys") || function(re) {
          var Ve = pJ.f(gJ(re)), Ke = dJ.f;
          return Ke ? mJ(Ve, Ke(re)) : Ve;
        };
      });
      var jP = Bn((kW, JP) => {
        var BP = Wg(), vJ = RP(), yJ = pT(), hJ = hT();
        JP.exports = function(M, re, Ve) {
          for (var Ke = vJ(re), oi = hJ.f, kr = yJ.f, pr = 0; pr < Ke.length; pr++) {
            var Lr = Ke[pr];
            !BP(M, Lr) && !(Ve && BP(Ve, Lr)) && oi(M, Lr, kr(re, Lr));
          }
        };
      });
      var zP = Bn((AW, UP) => {
        var DJ = cg(), bJ = gp(), SJ = /#|\.prototype\./, Gy = function(M, re) {
          var Ve = xJ[TJ(M)];
          return Ve == CJ ? true : Ve == EJ ? false : bJ(re) ? DJ(re) : !!re;
        }, TJ = Gy.normalize = function(M) {
          return String(M).replace(SJ, ".").toLowerCase();
        }, xJ = Gy.data = {}, EJ = Gy.NATIVE = "N", CJ = Gy.POLYFILL = "P";
        UP.exports = Gy;
      });
      var wT = Bn((NW, WP) => {
        var IT = qc(), kJ = pT().f, AJ = u1(), NJ = vP(), PJ = o1(), IJ = jP(), wJ = zP();
        WP.exports = function(M, re) {
          var Ve = M.target, Ke = M.global, oi = M.stat, kr, pr, Lr, ar, ke, e;
          if (Ke ? pr = IT : oi ? pr = IT[Ve] || PJ(Ve, {}) : pr = (IT[Ve] || {}).prototype, pr) for (Lr in re) {
            if (ke = re[Lr], M.noTargetGet ? (e = kJ(pr, Lr), ar = e && e.value) : ar = pr[Lr], kr = wJ(Ke ? Lr : Ve + (oi ? "." : "#") + Lr, M.forced), !kr && ar !== void 0) {
              if (typeof ke == typeof ar) continue;
              IJ(ke, ar);
            }
            (M.sham || ar && ar.sham) && AJ(ke, "sham", true), NJ(pr, Lr, ke, M);
          }
        };
      });
      var qP = Bn(() => {
        var OJ = wT(), FJ = qc();
        OJ({ global: true }, { globalThis: FJ });
      });
      var VP = Bn(() => {
        qP();
      });
      var OT = Bn((FW, KP) => {
        var MJ = i1();
        KP.exports = Array.isArray || function(re) {
          return MJ(re) == "Array";
        };
      });
      var XP = Bn((MW, HP) => {
        var GP = dp(), LJ = n1(), RJ = Z0(), BJ = GP(GP.bind);
        HP.exports = function(M, re) {
          return LJ(M), re === void 0 ? M : RJ ? BJ(M, re) : function() {
            return M.apply(re, arguments);
          };
        };
      });
      var $P = Bn((LW, YP) => {
        "use strict";
        var JJ = qc(), jJ = OT(), UJ = p1(), zJ = XP(), WJ = JJ.TypeError, QP = function(M, re, Ve, Ke, oi, kr, pr, Lr) {
          for (var ar = oi, ke = 0, e = pr ? zJ(pr, Lr) : false, a, C; ke < Ke; ) {
            if (ke in Ve) {
              if (a = e ? e(Ve[ke], ke, re) : Ve[ke], kr > 0 && jJ(a)) C = UJ(a), ar = QP(M, re, a, C, ar, kr - 1) - 1;
              else {
                if (ar >= 9007199254740991) throw WJ("Exceed the acceptable array length");
                M[ar] = a;
              }
              ar++;
            }
            ke++;
          }
          return ar;
        };
        YP.exports = QP;
      });
      var r4 = Bn((RW, e4) => {
        var qJ = Vy(), VJ = qJ("toStringTag"), ZP = {};
        ZP[VJ] = "z";
        e4.exports = String(ZP) === "[object z]";
      });
      var t4 = Bn((BW, i4) => {
        var KJ = qc(), GJ = r4(), HJ = gp(), d1 = i1(), XJ = Vy(), QJ = XJ("toStringTag"), YJ = KJ.Object, $J = d1(/* @__PURE__ */ function() {
          return arguments;
        }()) == "Arguments", ZJ = function(M, re) {
          try {
            return M[re];
          } catch {
          }
        };
        i4.exports = GJ ? d1 : function(M) {
          var re, Ve, Ke;
          return M === void 0 ? "Undefined" : M === null ? "Null" : typeof (Ve = ZJ(re = YJ(M), QJ)) == "string" ? Ve : $J ? d1(re) : (Ke = d1(re)) == "Object" && HJ(re.callee) ? "Arguments" : Ke;
        };
      });
      var u4 = Bn((JW, c4) => {
        var ej = dp(), rj = cg(), a4 = gp(), ij = t4(), tj = qy(), aj = l1(), n4 = function() {
        }, nj = [], o4 = tj("Reflect", "construct"), FT = /^\s*(?:class|function)\b/, oj = ej(FT.exec), sj = !FT.exec(n4), Hy = function(re) {
          if (!a4(re)) return false;
          try {
            return o4(n4, nj, re), true;
          } catch {
            return false;
          }
        }, s4 = function(re) {
          if (!a4(re)) return false;
          switch (ij(re)) {
            case "AsyncFunction":
            case "GeneratorFunction":
            case "AsyncGeneratorFunction":
              return false;
          }
          try {
            return sj || !!oj(FT, aj(re));
          } catch {
            return true;
          }
        };
        s4.sham = true;
        c4.exports = !o4 || rj(function() {
          var M;
          return Hy(Hy.call) || !Hy(Object) || !Hy(function() {
            M = true;
          }) || M;
        }) ? s4 : Hy;
      });
      var p4 = Bn((jW, _4) => {
        var cj = qc(), l4 = OT(), uj = u4(), lj = Nm(), fj = Vy(), _j = fj("species"), f4 = cj.Array;
        _4.exports = function(M) {
          var re;
          return l4(M) && (re = M.constructor, uj(re) && (re === f4 || l4(re.prototype)) ? re = void 0 : lj(re) && (re = re[_j], re === null && (re = void 0))), re === void 0 ? f4 : re;
        };
      });
      var g4 = Bn((UW, d4) => {
        var pj = p4();
        d4.exports = function(M, re) {
          return new (pj(M))(re === 0 ? 0 : re);
        };
      });
      var m4 = Bn(() => {
        "use strict";
        var dj = wT(), gj = $P(), mj = n1(), vj = cT(), yj = p1(), hj = g4();
        dj({ target: "Array", proto: true }, { flatMap: function(re) {
          var Ve = vj(this), Ke = yj(Ve), oi;
          return mj(re), oi = hj(Ve, 0), oi.length = gj(oi, Ve, Ve, Ke, 0, 1, re, arguments.length > 1 ? arguments[1] : void 0), oi;
        } });
      });
      var Dz = Bn((qW, f3) => {
        VP();
        m4();
        var zT = Object.defineProperty, Dj = Object.getOwnPropertyDescriptor, WT = Object.getOwnPropertyNames, bj = Object.prototype.hasOwnProperty, Qy = (M, re) => function() {
          return M && (re = (0, M[WT(M)[0]])(M = 0)), re;
        }, Oa = (M, re) => function() {
          return re || (0, M[WT(M)[0]])((re = { exports: {} }).exports, re), re.exports;
        }, h1 = (M, re) => {
          for (var Ve in re) zT(M, Ve, { get: re[Ve], enumerable: true });
        }, Sj = (M, re, Ve, Ke) => {
          if (re && typeof re == "object" || typeof re == "function") for (let oi of WT(re)) !bj.call(M, oi) && oi !== Ve && zT(M, oi, { get: () => re[oi], enumerable: !(Ke = Dj(re, oi)) || Ke.enumerable });
          return M;
        }, mp = (M) => Sj(zT({}, "__esModule", { value: true }), M), v4, y4, Eu, Ea = Qy({ "<define:process>"() {
          v4 = {}, y4 = [], Eu = { env: v4, argv: y4 };
        } }), S4 = Oa({ "src/common/parser-create-error.js"(M, re) {
          "use strict";
          Ea();
          function Ve(Ke, oi) {
            let kr = new SyntaxError(Ke + " (" + oi.start.line + ":" + oi.start.column + ")");
            return kr.loc = oi, kr;
          }
          re.exports = Ve;
        } }), Tj = Oa({ "src/utils/try-combinations.js"(M, re) {
          "use strict";
          Ea();
          function Ve() {
            let Ke;
            for (var oi = arguments.length, kr = new Array(oi), pr = 0; pr < oi; pr++) kr[pr] = arguments[pr];
            for (let [Lr, ar] of kr.entries()) try {
              return { result: ar() };
            } catch (ke) {
              Lr === 0 && (Ke = ke);
            }
            return { error: Ke };
          }
          re.exports = Ve;
        } }), T4 = {};
        h1(T4, { EOL: () => RT, arch: () => xj, cpus: () => P4, default: () => M4, endianness: () => x4, freemem: () => A4, getNetworkInterfaces: () => F4, hostname: () => E4, loadavg: () => C4, networkInterfaces: () => O4, platform: () => Ej, release: () => w4, tmpDir: () => MT, tmpdir: () => LT, totalmem: () => N4, type: () => I4, uptime: () => k4 });
        function x4() {
          if (typeof g1 > "u") {
            var M = new ArrayBuffer(2), re = new Uint8Array(M), Ve = new Uint16Array(M);
            if (re[0] = 1, re[1] = 2, Ve[0] === 258) g1 = "BE";
            else if (Ve[0] === 513) g1 = "LE";
            else throw new Error("unable to figure out endianess");
          }
          return g1;
        }
        function E4() {
          return typeof globalThis.location < "u" ? globalThis.location.hostname : "";
        }
        function C4() {
          return [];
        }
        function k4() {
          return 0;
        }
        function A4() {
          return Number.MAX_VALUE;
        }
        function N4() {
          return Number.MAX_VALUE;
        }
        function P4() {
          return [];
        }
        function I4() {
          return "Browser";
        }
        function w4() {
          return typeof globalThis.navigator < "u" ? globalThis.navigator.appVersion : "";
        }
        function O4() {
        }
        function F4() {
        }
        function xj() {
          return "javascript";
        }
        function Ej() {
          return "browser";
        }
        function MT() {
          return "/tmp";
        }
        var g1, LT, RT, M4, Cj = Qy({ "node-modules-polyfills:os"() {
          Ea(), LT = MT, RT = `
`, M4 = { EOL: RT, tmpdir: LT, tmpDir: MT, networkInterfaces: O4, getNetworkInterfaces: F4, release: w4, type: I4, cpus: P4, totalmem: N4, freemem: A4, uptime: k4, loadavg: C4, hostname: E4, endianness: x4 };
        } }), kj = Oa({ "node-modules-polyfills-commonjs:os"(M, re) {
          Ea();
          var Ve = (Cj(), mp(T4));
          if (Ve && Ve.default) {
            re.exports = Ve.default;
            for (let Ke in Ve) re.exports[Ke] = Ve[Ke];
          } else Ve && (re.exports = Ve);
        } }), Aj = Oa({ "node_modules/detect-newline/index.js"(M, re) {
          "use strict";
          Ea();
          var Ve = (Ke) => {
            if (typeof Ke != "string") throw new TypeError("Expected a string");
            let oi = Ke.match(/(?:\r?\n)/g) || [];
            if (oi.length === 0) return;
            let kr = oi.filter((Lr) => Lr === `\r
`).length, pr = oi.length - kr;
            return kr > pr ? `\r
` : `
`;
          };
          re.exports = Ve, re.exports.graceful = (Ke) => typeof Ke == "string" && Ve(Ke) || `
`;
        } }), Nj = Oa({ "node_modules/jest-docblock/build/index.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.extract = w, M.parse = E, M.parseWithComments = Q, M.print = le, M.strip = B;
          function re() {
            let p = kj();
            return re = function() {
              return p;
            }, p;
          }
          function Ve() {
            let p = Ke(Aj());
            return Ve = function() {
              return p;
            }, p;
          }
          function Ke(p) {
            return p && p.__esModule ? p : { default: p };
          }
          var oi = /\*\/$/, kr = /^\/\*\*/, pr = /^\s*(\/\*\*?(.|\r?\n)*?\*\/)/, Lr = /(^|\s+)\/\/([^\r\n]*)/g, ar = /^(\r?\n)+/, ke = /(?:^|\r?\n) *(@[^\r\n]*?) *\r?\n *(?![^@\r\n]*\/\/[^]*)([^@\r\n\s][^@\r\n]+?) *\r?\n/g, e = /(?:^|\r?\n) *@(\S+) *([^\r\n]*)/g, a = /(\r?\n|^) *\* ?/g, C = [];
          function w(p) {
            let m = p.match(pr);
            return m ? m[0].trimLeft() : "";
          }
          function B(p) {
            let m = p.match(pr);
            return m && m[0] ? p.substring(m[0].length) : p;
          }
          function E(p) {
            return Q(p).pragmas;
          }
          function Q(p) {
            let m = (0, Ve().default)(p) || re().EOL;
            p = p.replace(kr, "").replace(oi, "").replace(a, "$1");
            let G = "";
            for (; G !== p; ) G = p, p = p.replace(ke, "".concat(m, "$1 $2").concat(m));
            p = p.replace(ar, "").trimRight();
            let oe = /* @__PURE__ */ Object.create(null), f = p.replace(e, "").replace(ar, "").trimRight(), T;
            for (; T = e.exec(p); ) {
              let K = T[2].replace(Lr, "");
              typeof oe[T[1]] == "string" || Array.isArray(oe[T[1]]) ? oe[T[1]] = C.concat(oe[T[1]], K) : oe[T[1]] = K;
            }
            return { comments: f, pragmas: oe };
          }
          function le(p) {
            let { comments: m = "", pragmas: G = {} } = p, oe = (0, Ve().default)(m) || re().EOL, f = "/**", T = " *", K = " */", b = Object.keys(G), se = b.map((ie) => N(ie, G[ie])).reduce((ie, R) => ie.concat(R), []).map((ie) => T + " " + ie + oe).join("");
            if (!m) {
              if (b.length === 0) return "";
              if (b.length === 1 && !Array.isArray(G[b[0]])) {
                let ie = G[b[0]];
                return "".concat(f, " ").concat(N(b[0], ie)[0]).concat(K);
              }
            }
            let J = m.split(oe).map((ie) => "".concat(T, " ").concat(ie)).join(oe) + oe;
            return f + oe + (m ? J : "") + (m && b.length ? T + oe : "") + se + K;
          }
          function N(p, m) {
            return C.concat(m).map((G) => "@".concat(p, " ").concat(G).trim());
          }
        } }), Pj = Oa({ "src/common/end-of-line.js"(M, re) {
          "use strict";
          Ea();
          function Ve(pr) {
            let Lr = pr.indexOf("\r");
            return Lr >= 0 ? pr.charAt(Lr + 1) === `
` ? "crlf" : "cr" : "lf";
          }
          function Ke(pr) {
            switch (pr) {
              case "cr":
                return "\r";
              case "crlf":
                return `\r
`;
              default:
                return `
`;
            }
          }
          function oi(pr, Lr) {
            let ar;
            switch (Lr) {
              case `
`:
                ar = /\n/g;
                break;
              case "\r":
                ar = /\r/g;
                break;
              case `\r
`:
                ar = /\r\n/g;
                break;
              default:
                throw new Error('Unexpected "eol" '.concat(JSON.stringify(Lr), "."));
            }
            let ke = pr.match(ar);
            return ke ? ke.length : 0;
          }
          function kr(pr) {
            return pr.replace(/\r\n?/g, `
`);
          }
          re.exports = { guessEndOfLine: Ve, convertEndOfLineToChars: Ke, countEndOfLineChars: oi, normalizeEndOfLine: kr };
        } }), Ij = Oa({ "src/language-js/utils/get-shebang.js"(M, re) {
          "use strict";
          Ea();
          function Ve(Ke) {
            if (!Ke.startsWith("#!")) return "";
            let oi = Ke.indexOf(`
`);
            return oi === -1 ? Ke : Ke.slice(0, oi);
          }
          re.exports = Ve;
        } }), wj = Oa({ "src/language-js/pragma.js"(M, re) {
          "use strict";
          Ea();
          var { parseWithComments: Ve, strip: Ke, extract: oi, print: kr } = Nj(), { normalizeEndOfLine: pr } = Pj(), Lr = Ij();
          function ar(a) {
            let C = Lr(a);
            C && (a = a.slice(C.length + 1));
            let w = oi(a), { pragmas: B, comments: E } = Ve(w);
            return { shebang: C, text: a, pragmas: B, comments: E };
          }
          function ke(a) {
            let C = Object.keys(ar(a).pragmas);
            return C.includes("prettier") || C.includes("format");
          }
          function e(a) {
            let { shebang: C, text: w, pragmas: B, comments: E } = ar(a), Q = Ke(w), le = kr({ pragmas: Object.assign({ format: "" }, B), comments: E.trimStart() });
            return (C ? "".concat(C, `
`) : "") + pr(le) + (Q.startsWith(`
`) ? `
` : `

`) + Q;
          }
          re.exports = { hasPragma: ke, insertPragma: e };
        } }), Oj = Oa({ "src/utils/is-non-empty-array.js"(M, re) {
          "use strict";
          Ea();
          function Ve(Ke) {
            return Array.isArray(Ke) && Ke.length > 0;
          }
          re.exports = Ve;
        } }), L4 = Oa({ "src/language-js/loc.js"(M, re) {
          "use strict";
          Ea();
          var Ve = Oj();
          function Ke(ar, ke) {
            let { ignoreDecorators: e } = ke || {};
            if (!e) {
              let a = ar.declaration && ar.declaration.decorators || ar.decorators;
              if (Ve(a)) return Ke(a[0]);
            }
            return ar.range ? ar.range[0] : ar.start;
          }
          function oi(ar) {
            return ar.range ? ar.range[1] : ar.end;
          }
          function kr(ar, ke) {
            let e = Ke(ar);
            return Number.isInteger(e) && e === Ke(ke);
          }
          function pr(ar, ke) {
            let e = oi(ar);
            return Number.isInteger(e) && e === oi(ke);
          }
          function Lr(ar, ke) {
            return kr(ar, ke) && pr(ar, ke);
          }
          re.exports = { locStart: Ke, locEnd: oi, hasSameLocStart: kr, hasSameLoc: Lr };
        } }), Fj = Oa({ "src/language-js/parse/utils/create-parser.js"(M, re) {
          "use strict";
          Ea();
          var { hasPragma: Ve } = wj(), { locStart: Ke, locEnd: oi } = L4();
          function kr(pr) {
            return pr = typeof pr == "function" ? { parse: pr } : pr, Object.assign({ astFormat: "estree", hasPragma: Ve, locStart: Ke, locEnd: oi }, pr);
          }
          re.exports = kr;
        } }), Mj = Oa({ "src/language-js/parse/utils/replace-hashbang.js"(M, re) {
          "use strict";
          Ea();
          function Ve(Ke) {
            return Ke.charAt(0) === "#" && Ke.charAt(1) === "!" ? "//" + Ke.slice(2) : Ke;
          }
          re.exports = Ve;
        } }), Lj = Oa({ "src/language-js/utils/is-ts-keyword-type.js"(M, re) {
          "use strict";
          Ea();
          function Ve(Ke) {
            let { type: oi } = Ke;
            return oi.startsWith("TS") && oi.endsWith("Keyword");
          }
          re.exports = Ve;
        } }), Rj = Oa({ "src/language-js/utils/is-block-comment.js"(M, re) {
          "use strict";
          Ea();
          var Ve = /* @__PURE__ */ new Set(["Block", "CommentBlock", "MultiLine"]), Ke = (oi) => Ve.has(oi == null ? void 0 : oi.type);
          re.exports = Ke;
        } }), Bj = Oa({ "src/language-js/utils/is-type-cast-comment.js"(M, re) {
          "use strict";
          Ea();
          var Ve = Rj();
          function Ke(oi) {
            return Ve(oi) && oi.value[0] === "*" && /@type\b/.test(oi.value);
          }
          re.exports = Ke;
        } }), Jj = Oa({ "src/utils/get-last.js"(M, re) {
          "use strict";
          Ea();
          var Ve = (Ke) => Ke[Ke.length - 1];
          re.exports = Ve;
        } }), R4 = Oa({ "src/language-js/parse/postprocess/visit-node.js"(M, re) {
          "use strict";
          Ea();
          function Ve(Ke, oi) {
            if (Array.isArray(Ke)) {
              for (let kr = 0; kr < Ke.length; kr++) Ke[kr] = Ve(Ke[kr], oi);
              return Ke;
            }
            if (Ke && typeof Ke == "object" && typeof Ke.type == "string") {
              let kr = Object.keys(Ke);
              for (let pr = 0; pr < kr.length; pr++) Ke[kr[pr]] = Ve(Ke[kr[pr]], oi);
              return oi(Ke) || Ke;
            }
            return Ke;
          }
          re.exports = Ve;
        } }), B4 = Oa({ "src/language-js/parse/postprocess/throw-syntax-error.js"(M, re) {
          "use strict";
          Ea();
          var Ve = S4();
          function Ke(oi, kr) {
            let { start: pr, end: Lr } = oi.loc;
            throw Ve(kr, { start: { line: pr.line, column: pr.column + 1 }, end: { line: Lr.line, column: Lr.column + 1 } });
          }
          re.exports = Ke;
        } }), jj = Oa({ "src/language-js/parse/postprocess/typescript.js"(M, re) {
          "use strict";
          Ea();
          var Ve = R4(), Ke = B4();
          function oi(Lr, ar, ke) {
            let e = Lr.decorators;
            if (!Array.isArray(e)) return;
            let a = ar.decorators;
            (!Array.isArray(a) || a.length !== e.length || e.some((C) => {
              let w = ke.get(C);
              return !w || !a.includes(w);
            })) && Ke(ar, "Leading decorators must be attached to a class declaration");
          }
          function kr(Lr, ar) {
            Lr.kind !== 167 || Lr.modifiers && !Lr.modifiers.some((a) => a.kind === 126) || Lr.initializer && ar.value === null && Ke(ar, "Abstract property cannot have an initializer");
          }
          function pr(Lr, ar) {
            let { esTreeNodeToTSNodeMap: ke, tsNodeToESTreeNodeMap: e } = ar.tsParseResult;
            Ve(Lr, (a) => {
              let C = ke.get(a);
              if (!C) return;
              let w = e.get(C);
              w === a && (oi(C, w, e), kr(C, w));
            });
          }
          re.exports = { throwErrorForInvalidNodes: pr };
        } }), Uj = Oa({ "src/language-js/parse/postprocess/index.js"(M, re) {
          "use strict";
          Ea();
          var { locStart: Ve, locEnd: Ke } = L4(), oi = Lj(), kr = Bj(), pr = Jj(), Lr = R4(), { throwErrorForInvalidNodes: ar } = jj(), ke = B4();
          function e(B, E) {
            if (E.parser === "typescript" && /@|abstract/.test(E.originalText) && ar(B, E), E.parser !== "typescript" && E.parser !== "flow" && E.parser !== "acorn" && E.parser !== "espree" && E.parser !== "meriyah") {
              let le = /* @__PURE__ */ new Set();
              B = Lr(B, (N) => {
                N.leadingComments && N.leadingComments.some(kr) && le.add(Ve(N));
              }), B = Lr(B, (N) => {
                if (N.type === "ParenthesizedExpression") {
                  let { expression: p } = N;
                  if (p.type === "TypeCastExpression") return p.range = N.range, p;
                  let m = Ve(N);
                  if (!le.has(m)) return p.extra = Object.assign(Object.assign({}, p.extra), {}, { parenthesized: true }), p;
                }
              });
            }
            return B = Lr(B, (le) => {
              switch (le.type) {
                case "ChainExpression":
                  return a(le.expression);
                case "LogicalExpression": {
                  if (C(le)) return w(le);
                  break;
                }
                case "VariableDeclaration": {
                  let N = pr(le.declarations);
                  N && N.init && Q(le, N);
                  break;
                }
                case "TSParenthesizedType":
                  return oi(le.typeAnnotation) || le.typeAnnotation.type === "TSThisType" || (le.typeAnnotation.range = [Ve(le), Ke(le)]), le.typeAnnotation;
                case "TSTypeParameter":
                  if (typeof le.name == "string") {
                    let N = Ve(le);
                    le.name = { type: "Identifier", name: le.name, range: [N, N + le.name.length] };
                  }
                  break;
                case "ObjectExpression":
                  if (E.parser === "typescript") {
                    let N = le.properties.find((p) => p.type === "Property" && p.value.type === "TSEmptyBodyFunctionExpression");
                    N && ke(N.value, "Unexpected token.");
                  }
                  break;
                case "SequenceExpression": {
                  let N = pr(le.expressions);
                  le.range = [Ve(le), Math.min(Ke(N), Ke(le))];
                  break;
                }
                case "TopicReference":
                  E.__isUsingHackPipeline = true;
                  break;
                case "ExportAllDeclaration": {
                  let { exported: N } = le;
                  if (E.parser === "meriyah" && N && N.type === "Identifier") {
                    let p = E.originalText.slice(Ve(N), Ke(N));
                    (p.startsWith('"') || p.startsWith("'")) && (le.exported = Object.assign(Object.assign({}, le.exported), {}, { type: "Literal", value: le.exported.name, raw: p }));
                  }
                  break;
                }
              }
            }), B;
            function Q(le, N) {
              E.originalText[Ke(N)] !== ";" && (le.range = [Ve(le), Ke(N)]);
            }
          }
          function a(B) {
            switch (B.type) {
              case "CallExpression":
                B.type = "OptionalCallExpression", B.callee = a(B.callee);
                break;
              case "MemberExpression":
                B.type = "OptionalMemberExpression", B.object = a(B.object);
                break;
              case "TSNonNullExpression":
                B.expression = a(B.expression);
                break;
            }
            return B;
          }
          function C(B) {
            return B.type === "LogicalExpression" && B.right.type === "LogicalExpression" && B.operator === B.right.operator;
          }
          function w(B) {
            return C(B) ? w({ type: "LogicalExpression", operator: B.operator, left: w({ type: "LogicalExpression", operator: B.operator, left: B.left, right: B.right.left, range: [Ve(B.left), Ke(B.right.left)] }), right: B.right.right, range: [Ve(B), Ke(B)] }) : B;
          }
          re.exports = e;
        } }), zj = Oa({ "node_modules/ms/index.js"(M, re) {
          Ea();
          var Ve = 1e3, Ke = Ve * 60, oi = Ke * 60, kr = oi * 24, pr = kr * 7, Lr = kr * 365.25;
          re.exports = function(C, w) {
            w = w || {};
            var B = typeof C;
            if (B === "string" && C.length > 0) return ar(C);
            if (B === "number" && isFinite(C)) return w.long ? e(C) : ke(C);
            throw new Error("val is not a non-empty string or a valid number. val=" + JSON.stringify(C));
          };
          function ar(C) {
            if (C = String(C), !(C.length > 100)) {
              var w = /^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(C);
              if (!!w) {
                var B = parseFloat(w[1]), E = (w[2] || "ms").toLowerCase();
                switch (E) {
                  case "years":
                  case "year":
                  case "yrs":
                  case "yr":
                  case "y":
                    return B * Lr;
                  case "weeks":
                  case "week":
                  case "w":
                    return B * pr;
                  case "days":
                  case "day":
                  case "d":
                    return B * kr;
                  case "hours":
                  case "hour":
                  case "hrs":
                  case "hr":
                  case "h":
                    return B * oi;
                  case "minutes":
                  case "minute":
                  case "mins":
                  case "min":
                  case "m":
                    return B * Ke;
                  case "seconds":
                  case "second":
                  case "secs":
                  case "sec":
                  case "s":
                    return B * Ve;
                  case "milliseconds":
                  case "millisecond":
                  case "msecs":
                  case "msec":
                  case "ms":
                    return B;
                  default:
                    return;
                }
              }
            }
          }
          function ke(C) {
            var w = Math.abs(C);
            return w >= kr ? Math.round(C / kr) + "d" : w >= oi ? Math.round(C / oi) + "h" : w >= Ke ? Math.round(C / Ke) + "m" : w >= Ve ? Math.round(C / Ve) + "s" : C + "ms";
          }
          function e(C) {
            var w = Math.abs(C);
            return w >= kr ? a(C, w, kr, "day") : w >= oi ? a(C, w, oi, "hour") : w >= Ke ? a(C, w, Ke, "minute") : w >= Ve ? a(C, w, Ve, "second") : C + " ms";
          }
          function a(C, w, B, E) {
            var Q = w >= B * 1.5;
            return Math.round(C / B) + " " + E + (Q ? "s" : "");
          }
        } }), Wj = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/debug/src/common.js"(M, re) {
          Ea();
          function Ve(Ke) {
            kr.debug = kr, kr.default = kr, kr.coerce = a, kr.disable = ar, kr.enable = Lr, kr.enabled = ke, kr.humanize = zj(), kr.destroy = C, Object.keys(Ke).forEach((w) => {
              kr[w] = Ke[w];
            }), kr.names = [], kr.skips = [], kr.formatters = {};
            function oi(w) {
              let B = 0;
              for (let E = 0; E < w.length; E++) B = (B << 5) - B + w.charCodeAt(E), B |= 0;
              return kr.colors[Math.abs(B) % kr.colors.length];
            }
            kr.selectColor = oi;
            function kr(w) {
              let B, E = null, Q, le;
              function N() {
                for (var p = arguments.length, m = new Array(p), G = 0; G < p; G++) m[G] = arguments[G];
                if (!N.enabled) return;
                let oe = N, f = Number(/* @__PURE__ */ new Date()), T = f - (B || f);
                oe.diff = T, oe.prev = B, oe.curr = f, B = f, m[0] = kr.coerce(m[0]), typeof m[0] != "string" && m.unshift("%O");
                let K = 0;
                m[0] = m[0].replace(/%([a-zA-Z%])/g, (se, J) => {
                  if (se === "%%") return "%";
                  K++;
                  let ie = kr.formatters[J];
                  if (typeof ie == "function") {
                    let R = m[K];
                    se = ie.call(oe, R), m.splice(K, 1), K--;
                  }
                  return se;
                }), kr.formatArgs.call(oe, m), (oe.log || kr.log).apply(oe, m);
              }
              return N.namespace = w, N.useColors = kr.useColors(), N.color = kr.selectColor(w), N.extend = pr, N.destroy = kr.destroy, Object.defineProperty(N, "enabled", { enumerable: true, configurable: false, get: () => E !== null ? E : (Q !== kr.namespaces && (Q = kr.namespaces, le = kr.enabled(w)), le), set: (p) => {
                E = p;
              } }), typeof kr.init == "function" && kr.init(N), N;
            }
            function pr(w, B) {
              let E = kr(this.namespace + (typeof B > "u" ? ":" : B) + w);
              return E.log = this.log, E;
            }
            function Lr(w) {
              kr.save(w), kr.namespaces = w, kr.names = [], kr.skips = [];
              let B, E = (typeof w == "string" ? w : "").split(/[\s,]+/), Q = E.length;
              for (B = 0; B < Q; B++) !E[B] || (w = E[B].replace(/\*/g, ".*?"), w[0] === "-" ? kr.skips.push(new RegExp("^" + w.slice(1) + "$")) : kr.names.push(new RegExp("^" + w + "$")));
            }
            function ar() {
              let w = [...kr.names.map(e), ...kr.skips.map(e).map((B) => "-" + B)].join(",");
              return kr.enable(""), w;
            }
            function ke(w) {
              if (w[w.length - 1] === "*") return true;
              let B, E;
              for (B = 0, E = kr.skips.length; B < E; B++) if (kr.skips[B].test(w)) return false;
              for (B = 0, E = kr.names.length; B < E; B++) if (kr.names[B].test(w)) return true;
              return false;
            }
            function e(w) {
              return w.toString().substring(2, w.toString().length - 2).replace(/\.\*\?$/, "*");
            }
            function a(w) {
              return w instanceof Error ? w.stack || w.message : w;
            }
            function C() {
              console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.");
            }
            return kr.enable(kr.load()), kr;
          }
          re.exports = Ve;
        } }), wm = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/debug/src/browser.js"(M, re) {
          Ea(), M.formatArgs = Ke, M.save = oi, M.load = kr, M.useColors = Ve, M.storage = pr(), M.destroy = /* @__PURE__ */ (() => {
            let ar = false;
            return () => {
              ar || (ar = true, console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`."));
            };
          })(), M.colors = ["#0000CC", "#0000FF", "#0033CC", "#0033FF", "#0066CC", "#0066FF", "#0099CC", "#0099FF", "#00CC00", "#00CC33", "#00CC66", "#00CC99", "#00CCCC", "#00CCFF", "#3300CC", "#3300FF", "#3333CC", "#3333FF", "#3366CC", "#3366FF", "#3399CC", "#3399FF", "#33CC00", "#33CC33", "#33CC66", "#33CC99", "#33CCCC", "#33CCFF", "#6600CC", "#6600FF", "#6633CC", "#6633FF", "#66CC00", "#66CC33", "#9900CC", "#9900FF", "#9933CC", "#9933FF", "#99CC00", "#99CC33", "#CC0000", "#CC0033", "#CC0066", "#CC0099", "#CC00CC", "#CC00FF", "#CC3300", "#CC3333", "#CC3366", "#CC3399", "#CC33CC", "#CC33FF", "#CC6600", "#CC6633", "#CC9900", "#CC9933", "#CCCC00", "#CCCC33", "#FF0000", "#FF0033", "#FF0066", "#FF0099", "#FF00CC", "#FF00FF", "#FF3300", "#FF3333", "#FF3366", "#FF3399", "#FF33CC", "#FF33FF", "#FF6600", "#FF6633", "#FF9900", "#FF9933", "#FFCC00", "#FFCC33"];
          function Ve() {
            return typeof window < "u" && window.process && (window.process.type === "renderer" || window.process.__nwjs) ? true : typeof navigator < "u" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/) ? false : typeof document < "u" && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || typeof window < "u" && window.console && (window.console.firebug || window.console.exception && window.console.table) || typeof navigator < "u" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || typeof navigator < "u" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
          }
          function Ke(ar) {
            if (ar[0] = (this.useColors ? "%c" : "") + this.namespace + (this.useColors ? " %c" : " ") + ar[0] + (this.useColors ? "%c " : " ") + "+" + re.exports.humanize(this.diff), !this.useColors) return;
            let ke = "color: " + this.color;
            ar.splice(1, 0, ke, "color: inherit");
            let e = 0, a = 0;
            ar[0].replace(/%[a-zA-Z%]/g, (C) => {
              C !== "%%" && (e++, C === "%c" && (a = e));
            }), ar.splice(a, 0, ke);
          }
          M.log = console.debug || console.log || (() => {
          });
          function oi(ar) {
            try {
              ar ? M.storage.setItem("debug", ar) : M.storage.removeItem("debug");
            } catch {
            }
          }
          function kr() {
            let ar;
            try {
              ar = M.storage.getItem("debug");
            } catch {
            }
            return !ar && typeof Eu < "u" && "env" in Eu && (ar = Eu.env.DEBUG), ar;
          }
          function pr() {
            try {
              return localStorage;
            } catch {
            }
          }
          re.exports = Wj()(M);
          var { formatters: Lr } = re.exports;
          Lr.j = function(ar) {
            try {
              return JSON.stringify(ar);
            } catch (ke) {
              return "[UnexpectedJSONParseError]: " + ke.message;
            }
          };
        } }), qj = Oa({ "node_modules/is-extglob/index.js"(M, re) {
          Ea(), re.exports = function(Ke) {
            if (typeof Ke != "string" || Ke === "") return false;
            for (var oi; oi = /(\\).|([@?!+*]\(.*\))/g.exec(Ke); ) {
              if (oi[2]) return true;
              Ke = Ke.slice(oi.index + oi[0].length);
            }
            return false;
          };
        } }), Vj = Oa({ "node_modules/is-glob/index.js"(M, re) {
          Ea();
          var Ve = qj(), Ke = { "{": "}", "(": ")", "[": "]" }, oi = function(pr) {
            if (pr[0] === "!") return true;
            for (var Lr = 0, ar = -2, ke = -2, e = -2, a = -2, C = -2; Lr < pr.length; ) {
              if (pr[Lr] === "*" || pr[Lr + 1] === "?" && /[\].+)]/.test(pr[Lr]) || ke !== -1 && pr[Lr] === "[" && pr[Lr + 1] !== "]" && (ke < Lr && (ke = pr.indexOf("]", Lr)), ke > Lr && (C === -1 || C > ke || (C = pr.indexOf("\\", Lr), C === -1 || C > ke))) || e !== -1 && pr[Lr] === "{" && pr[Lr + 1] !== "}" && (e = pr.indexOf("}", Lr), e > Lr && (C = pr.indexOf("\\", Lr), C === -1 || C > e)) || a !== -1 && pr[Lr] === "(" && pr[Lr + 1] === "?" && /[:!=]/.test(pr[Lr + 2]) && pr[Lr + 3] !== ")" && (a = pr.indexOf(")", Lr), a > Lr && (C = pr.indexOf("\\", Lr), C === -1 || C > a)) || ar !== -1 && pr[Lr] === "(" && pr[Lr + 1] !== "|" && (ar < Lr && (ar = pr.indexOf("|", Lr)), ar !== -1 && pr[ar + 1] !== ")" && (a = pr.indexOf(")", ar), a > ar && (C = pr.indexOf("\\", ar), C === -1 || C > a)))) return true;
              if (pr[Lr] === "\\") {
                var w = pr[Lr + 1];
                Lr += 2;
                var B = Ke[w];
                if (B) {
                  var E = pr.indexOf(B, Lr);
                  E !== -1 && (Lr = E + 1);
                }
                if (pr[Lr] === "!") return true;
              } else Lr++;
            }
            return false;
          }, kr = function(pr) {
            if (pr[0] === "!") return true;
            for (var Lr = 0; Lr < pr.length; ) {
              if (/[*?{}()[\]]/.test(pr[Lr])) return true;
              if (pr[Lr] === "\\") {
                var ar = pr[Lr + 1];
                Lr += 2;
                var ke = Ke[ar];
                if (ke) {
                  var e = pr.indexOf(ke, Lr);
                  e !== -1 && (Lr = e + 1);
                }
                if (pr[Lr] === "!") return true;
              } else Lr++;
            }
            return false;
          };
          re.exports = function(Lr, ar) {
            if (typeof Lr != "string" || Lr === "") return false;
            if (Ve(Lr)) return true;
            var ke = oi;
            return ar && ar.strict === false && (ke = kr), ke(Lr);
          };
        } }), D1 = Oa({ "node_modules/semver/internal/constants.js"(M, re) {
          Ea();
          var Ve = "2.0.0", Ke = 256, oi = Number.MAX_SAFE_INTEGER || 9007199254740991, kr = 16;
          re.exports = { SEMVER_SPEC_VERSION: Ve, MAX_LENGTH: Ke, MAX_SAFE_INTEGER: oi, MAX_SAFE_COMPONENT_LENGTH: kr };
        } }), b1 = Oa({ "node_modules/semver/internal/debug.js"(M, re) {
          Ea();
          var Ve = typeof Eu == "object" && Eu.env && Eu.env.NODE_DEBUG && /\bsemver\b/i.test(Eu.env.NODE_DEBUG) ? function() {
            for (var Ke = arguments.length, oi = new Array(Ke), kr = 0; kr < Ke; kr++) oi[kr] = arguments[kr];
            return console.error("SEMVER", ...oi);
          } : () => {
          };
          re.exports = Ve;
        } }), wv = Oa({ "node_modules/semver/internal/re.js"(M, re) {
          Ea();
          var { MAX_SAFE_COMPONENT_LENGTH: Ve } = D1(), Ke = b1();
          M = re.exports = {};
          var oi = M.re = [], kr = M.src = [], pr = M.t = {}, Lr = 0, ar = (ke, e, a) => {
            let C = Lr++;
            Ke(ke, C, e), pr[ke] = C, kr[C] = e, oi[C] = new RegExp(e, a ? "g" : void 0);
          };
          ar("NUMERICIDENTIFIER", "0|[1-9]\\d*"), ar("NUMERICIDENTIFIERLOOSE", "[0-9]+"), ar("NONNUMERICIDENTIFIER", "\\d*[a-zA-Z-][a-zA-Z0-9-]*"), ar("MAINVERSION", "(".concat(kr[pr.NUMERICIDENTIFIER], ")\\.(").concat(kr[pr.NUMERICIDENTIFIER], ")\\.(").concat(kr[pr.NUMERICIDENTIFIER], ")")), ar("MAINVERSIONLOOSE", "(".concat(kr[pr.NUMERICIDENTIFIERLOOSE], ")\\.(").concat(kr[pr.NUMERICIDENTIFIERLOOSE], ")\\.(").concat(kr[pr.NUMERICIDENTIFIERLOOSE], ")")), ar("PRERELEASEIDENTIFIER", "(?:".concat(kr[pr.NUMERICIDENTIFIER], "|").concat(kr[pr.NONNUMERICIDENTIFIER], ")")), ar("PRERELEASEIDENTIFIERLOOSE", "(?:".concat(kr[pr.NUMERICIDENTIFIERLOOSE], "|").concat(kr[pr.NONNUMERICIDENTIFIER], ")")), ar("PRERELEASE", "(?:-(".concat(kr[pr.PRERELEASEIDENTIFIER], "(?:\\.").concat(kr[pr.PRERELEASEIDENTIFIER], ")*))")), ar("PRERELEASELOOSE", "(?:-?(".concat(kr[pr.PRERELEASEIDENTIFIERLOOSE], "(?:\\.").concat(kr[pr.PRERELEASEIDENTIFIERLOOSE], ")*))")), ar("BUILDIDENTIFIER", "[0-9A-Za-z-]+"), ar("BUILD", "(?:\\+(".concat(kr[pr.BUILDIDENTIFIER], "(?:\\.").concat(kr[pr.BUILDIDENTIFIER], ")*))")), ar("FULLPLAIN", "v?".concat(kr[pr.MAINVERSION]).concat(kr[pr.PRERELEASE], "?").concat(kr[pr.BUILD], "?")), ar("FULL", "^".concat(kr[pr.FULLPLAIN], "$")), ar("LOOSEPLAIN", "[v=\\s]*".concat(kr[pr.MAINVERSIONLOOSE]).concat(kr[pr.PRERELEASELOOSE], "?").concat(kr[pr.BUILD], "?")), ar("LOOSE", "^".concat(kr[pr.LOOSEPLAIN], "$")), ar("GTLT", "((?:<|>)?=?)"), ar("XRANGEIDENTIFIERLOOSE", "".concat(kr[pr.NUMERICIDENTIFIERLOOSE], "|x|X|\\*")), ar("XRANGEIDENTIFIER", "".concat(kr[pr.NUMERICIDENTIFIER], "|x|X|\\*")), ar("XRANGEPLAIN", "[v=\\s]*(".concat(kr[pr.XRANGEIDENTIFIER], ")(?:\\.(").concat(kr[pr.XRANGEIDENTIFIER], ")(?:\\.(").concat(kr[pr.XRANGEIDENTIFIER], ")(?:").concat(kr[pr.PRERELEASE], ")?").concat(kr[pr.BUILD], "?)?)?")), ar("XRANGEPLAINLOOSE", "[v=\\s]*(".concat(kr[pr.XRANGEIDENTIFIERLOOSE], ")(?:\\.(").concat(kr[pr.XRANGEIDENTIFIERLOOSE], ")(?:\\.(").concat(kr[pr.XRANGEIDENTIFIERLOOSE], ")(?:").concat(kr[pr.PRERELEASELOOSE], ")?").concat(kr[pr.BUILD], "?)?)?")), ar("XRANGE", "^".concat(kr[pr.GTLT], "\\s*").concat(kr[pr.XRANGEPLAIN], "$")), ar("XRANGELOOSE", "^".concat(kr[pr.GTLT], "\\s*").concat(kr[pr.XRANGEPLAINLOOSE], "$")), ar("COERCE", "(^|[^\\d])(\\d{1,".concat(Ve, "})(?:\\.(\\d{1,").concat(Ve, "}))?(?:\\.(\\d{1,").concat(Ve, "}))?(?:$|[^\\d])")), ar("COERCERTL", kr[pr.COERCE], true), ar("LONETILDE", "(?:~>?)"), ar("TILDETRIM", "(\\s*)".concat(kr[pr.LONETILDE], "\\s+"), true), M.tildeTrimReplace = "$1~", ar("TILDE", "^".concat(kr[pr.LONETILDE]).concat(kr[pr.XRANGEPLAIN], "$")), ar("TILDELOOSE", "^".concat(kr[pr.LONETILDE]).concat(kr[pr.XRANGEPLAINLOOSE], "$")), ar("LONECARET", "(?:\\^)"), ar("CARETTRIM", "(\\s*)".concat(kr[pr.LONECARET], "\\s+"), true), M.caretTrimReplace = "$1^", ar("CARET", "^".concat(kr[pr.LONECARET]).concat(kr[pr.XRANGEPLAIN], "$")), ar("CARETLOOSE", "^".concat(kr[pr.LONECARET]).concat(kr[pr.XRANGEPLAINLOOSE], "$")), ar("COMPARATORLOOSE", "^".concat(kr[pr.GTLT], "\\s*(").concat(kr[pr.LOOSEPLAIN], ")$|^$")), ar("COMPARATOR", "^".concat(kr[pr.GTLT], "\\s*(").concat(kr[pr.FULLPLAIN], ")$|^$")), ar("COMPARATORTRIM", "(\\s*)".concat(kr[pr.GTLT], "\\s*(").concat(kr[pr.LOOSEPLAIN], "|").concat(kr[pr.XRANGEPLAIN], ")"), true), M.comparatorTrimReplace = "$1$2$3", ar("HYPHENRANGE", "^\\s*(".concat(kr[pr.XRANGEPLAIN], ")\\s+-\\s+(").concat(kr[pr.XRANGEPLAIN], ")\\s*$")), ar("HYPHENRANGELOOSE", "^\\s*(".concat(kr[pr.XRANGEPLAINLOOSE], ")\\s+-\\s+(").concat(kr[pr.XRANGEPLAINLOOSE], ")\\s*$")), ar("STAR", "(<|>)?=?\\s*\\*"), ar("GTE0", "^\\s*>=\\s*0\\.0\\.0\\s*$"), ar("GTE0PRE", "^\\s*>=\\s*0\\.0\\.0-0\\s*$");
        } }), S1 = Oa({ "node_modules/semver/internal/parse-options.js"(M, re) {
          Ea();
          var Ve = ["includePrerelease", "loose", "rtl"], Ke = (oi) => oi ? typeof oi != "object" ? { loose: true } : Ve.filter((kr) => oi[kr]).reduce((kr, pr) => (kr[pr] = true, kr), {}) : {};
          re.exports = Ke;
        } }), BT = Oa({ "node_modules/semver/internal/identifiers.js"(M, re) {
          Ea();
          var Ve = /^[0-9]+$/, Ke = (kr, pr) => {
            let Lr = Ve.test(kr), ar = Ve.test(pr);
            return Lr && ar && (kr = +kr, pr = +pr), kr === pr ? 0 : Lr && !ar ? -1 : ar && !Lr ? 1 : kr < pr ? -1 : 1;
          }, oi = (kr, pr) => Ke(pr, kr);
          re.exports = { compareIdentifiers: Ke, rcompareIdentifiers: oi };
        } }), Lf = Oa({ "node_modules/semver/classes/semver.js"(M, re) {
          Ea();
          var Ve = b1(), { MAX_LENGTH: Ke, MAX_SAFE_INTEGER: oi } = D1(), { re: kr, t: pr } = wv(), Lr = S1(), { compareIdentifiers: ar } = BT(), ke = class {
            constructor(e, a) {
              if (a = Lr(a), e instanceof ke) {
                if (e.loose === !!a.loose && e.includePrerelease === !!a.includePrerelease) return e;
                e = e.version;
              } else if (typeof e != "string") throw new TypeError("Invalid Version: ".concat(e));
              if (e.length > Ke) throw new TypeError("version is longer than ".concat(Ke, " characters"));
              Ve("SemVer", e, a), this.options = a, this.loose = !!a.loose, this.includePrerelease = !!a.includePrerelease;
              let C = e.trim().match(a.loose ? kr[pr.LOOSE] : kr[pr.FULL]);
              if (!C) throw new TypeError("Invalid Version: ".concat(e));
              if (this.raw = e, this.major = +C[1], this.minor = +C[2], this.patch = +C[3], this.major > oi || this.major < 0) throw new TypeError("Invalid major version");
              if (this.minor > oi || this.minor < 0) throw new TypeError("Invalid minor version");
              if (this.patch > oi || this.patch < 0) throw new TypeError("Invalid patch version");
              C[4] ? this.prerelease = C[4].split(".").map((w) => {
                if (/^[0-9]+$/.test(w)) {
                  let B = +w;
                  if (B >= 0 && B < oi) return B;
                }
                return w;
              }) : this.prerelease = [], this.build = C[5] ? C[5].split(".") : [], this.format();
            }
            format() {
              return this.version = "".concat(this.major, ".").concat(this.minor, ".").concat(this.patch), this.prerelease.length && (this.version += "-".concat(this.prerelease.join("."))), this.version;
            }
            toString() {
              return this.version;
            }
            compare(e) {
              if (Ve("SemVer.compare", this.version, this.options, e), !(e instanceof ke)) {
                if (typeof e == "string" && e === this.version) return 0;
                e = new ke(e, this.options);
              }
              return e.version === this.version ? 0 : this.compareMain(e) || this.comparePre(e);
            }
            compareMain(e) {
              return e instanceof ke || (e = new ke(e, this.options)), ar(this.major, e.major) || ar(this.minor, e.minor) || ar(this.patch, e.patch);
            }
            comparePre(e) {
              if (e instanceof ke || (e = new ke(e, this.options)), this.prerelease.length && !e.prerelease.length) return -1;
              if (!this.prerelease.length && e.prerelease.length) return 1;
              if (!this.prerelease.length && !e.prerelease.length) return 0;
              let a = 0;
              do {
                let C = this.prerelease[a], w = e.prerelease[a];
                if (Ve("prerelease compare", a, C, w), C === void 0 && w === void 0) return 0;
                if (w === void 0) return 1;
                if (C === void 0) return -1;
                if (C === w) continue;
                return ar(C, w);
              } while (++a);
            }
            compareBuild(e) {
              e instanceof ke || (e = new ke(e, this.options));
              let a = 0;
              do {
                let C = this.build[a], w = e.build[a];
                if (Ve("prerelease compare", a, C, w), C === void 0 && w === void 0) return 0;
                if (w === void 0) return 1;
                if (C === void 0) return -1;
                if (C === w) continue;
                return ar(C, w);
              } while (++a);
            }
            inc(e, a) {
              switch (e) {
                case "premajor":
                  this.prerelease.length = 0, this.patch = 0, this.minor = 0, this.major++, this.inc("pre", a);
                  break;
                case "preminor":
                  this.prerelease.length = 0, this.patch = 0, this.minor++, this.inc("pre", a);
                  break;
                case "prepatch":
                  this.prerelease.length = 0, this.inc("patch", a), this.inc("pre", a);
                  break;
                case "prerelease":
                  this.prerelease.length === 0 && this.inc("patch", a), this.inc("pre", a);
                  break;
                case "major":
                  (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) && this.major++, this.minor = 0, this.patch = 0, this.prerelease = [];
                  break;
                case "minor":
                  (this.patch !== 0 || this.prerelease.length === 0) && this.minor++, this.patch = 0, this.prerelease = [];
                  break;
                case "patch":
                  this.prerelease.length === 0 && this.patch++, this.prerelease = [];
                  break;
                case "pre":
                  if (this.prerelease.length === 0) this.prerelease = [0];
                  else {
                    let C = this.prerelease.length;
                    for (; --C >= 0; ) typeof this.prerelease[C] == "number" && (this.prerelease[C]++, C = -2);
                    C === -1 && this.prerelease.push(0);
                  }
                  a && (ar(this.prerelease[0], a) === 0 ? isNaN(this.prerelease[1]) && (this.prerelease = [a, 0]) : this.prerelease = [a, 0]);
                  break;
                default:
                  throw new Error("invalid increment argument: ".concat(e));
              }
              return this.format(), this.raw = this.version, this;
            }
          };
          re.exports = ke;
        } }), Ov = Oa({ "node_modules/semver/functions/parse.js"(M, re) {
          Ea();
          var { MAX_LENGTH: Ve } = D1(), { re: Ke, t: oi } = wv(), kr = Lf(), pr = S1(), Lr = (ar, ke) => {
            if (ke = pr(ke), ar instanceof kr) return ar;
            if (typeof ar != "string" || ar.length > Ve || !(ke.loose ? Ke[oi.LOOSE] : Ke[oi.FULL]).test(ar)) return null;
            try {
              return new kr(ar, ke);
            } catch {
              return null;
            }
          };
          re.exports = Lr;
        } }), Kj = Oa({ "node_modules/semver/functions/valid.js"(M, re) {
          Ea();
          var Ve = Ov(), Ke = (oi, kr) => {
            let pr = Ve(oi, kr);
            return pr ? pr.version : null;
          };
          re.exports = Ke;
        } }), Gj = Oa({ "node_modules/semver/functions/clean.js"(M, re) {
          Ea();
          var Ve = Ov(), Ke = (oi, kr) => {
            let pr = Ve(oi.trim().replace(/^[=v]+/, ""), kr);
            return pr ? pr.version : null;
          };
          re.exports = Ke;
        } }), Hj = Oa({ "node_modules/semver/functions/inc.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = (oi, kr, pr, Lr) => {
            typeof pr == "string" && (Lr = pr, pr = void 0);
            try {
              return new Ve(oi instanceof Ve ? oi.version : oi, pr).inc(kr, Lr).version;
            } catch {
              return null;
            }
          };
          re.exports = Ke;
        } }), nd = Oa({ "node_modules/semver/functions/compare.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = (oi, kr, pr) => new Ve(oi, pr).compare(new Ve(kr, pr));
          re.exports = Ke;
        } }), qT = Oa({ "node_modules/semver/functions/eq.js"(M, re) {
          Ea();
          var Ve = nd(), Ke = (oi, kr, pr) => Ve(oi, kr, pr) === 0;
          re.exports = Ke;
        } }), Xj = Oa({ "node_modules/semver/functions/diff.js"(M, re) {
          Ea();
          var Ve = Ov(), Ke = qT(), oi = (kr, pr) => {
            if (Ke(kr, pr)) return null;
            {
              let Lr = Ve(kr), ar = Ve(pr), ke = Lr.prerelease.length || ar.prerelease.length, e = ke ? "pre" : "", a = ke ? "prerelease" : "";
              for (let C in Lr) if ((C === "major" || C === "minor" || C === "patch") && Lr[C] !== ar[C]) return e + C;
              return a;
            }
          };
          re.exports = oi;
        } }), Qj = Oa({ "node_modules/semver/functions/major.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = (oi, kr) => new Ve(oi, kr).major;
          re.exports = Ke;
        } }), Yj = Oa({ "node_modules/semver/functions/minor.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = (oi, kr) => new Ve(oi, kr).minor;
          re.exports = Ke;
        } }), $j = Oa({ "node_modules/semver/functions/patch.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = (oi, kr) => new Ve(oi, kr).patch;
          re.exports = Ke;
        } }), Zj = Oa({ "node_modules/semver/functions/prerelease.js"(M, re) {
          Ea();
          var Ve = Ov(), Ke = (oi, kr) => {
            let pr = Ve(oi, kr);
            return pr && pr.prerelease.length ? pr.prerelease : null;
          };
          re.exports = Ke;
        } }), eU = Oa({ "node_modules/semver/functions/rcompare.js"(M, re) {
          Ea();
          var Ve = nd(), Ke = (oi, kr, pr) => Ve(kr, oi, pr);
          re.exports = Ke;
        } }), rU = Oa({ "node_modules/semver/functions/compare-loose.js"(M, re) {
          Ea();
          var Ve = nd(), Ke = (oi, kr) => Ve(oi, kr, true);
          re.exports = Ke;
        } }), VT = Oa({ "node_modules/semver/functions/compare-build.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = (oi, kr, pr) => {
            let Lr = new Ve(oi, pr), ar = new Ve(kr, pr);
            return Lr.compare(ar) || Lr.compareBuild(ar);
          };
          re.exports = Ke;
        } }), iU = Oa({ "node_modules/semver/functions/sort.js"(M, re) {
          Ea();
          var Ve = VT(), Ke = (oi, kr) => oi.sort((pr, Lr) => Ve(pr, Lr, kr));
          re.exports = Ke;
        } }), tU = Oa({ "node_modules/semver/functions/rsort.js"(M, re) {
          Ea();
          var Ve = VT(), Ke = (oi, kr) => oi.sort((pr, Lr) => Ve(Lr, pr, kr));
          re.exports = Ke;
        } }), T1 = Oa({ "node_modules/semver/functions/gt.js"(M, re) {
          Ea();
          var Ve = nd(), Ke = (oi, kr, pr) => Ve(oi, kr, pr) > 0;
          re.exports = Ke;
        } }), KT = Oa({ "node_modules/semver/functions/lt.js"(M, re) {
          Ea();
          var Ve = nd(), Ke = (oi, kr, pr) => Ve(oi, kr, pr) < 0;
          re.exports = Ke;
        } }), J4 = Oa({ "node_modules/semver/functions/neq.js"(M, re) {
          Ea();
          var Ve = nd(), Ke = (oi, kr, pr) => Ve(oi, kr, pr) !== 0;
          re.exports = Ke;
        } }), GT = Oa({ "node_modules/semver/functions/gte.js"(M, re) {
          Ea();
          var Ve = nd(), Ke = (oi, kr, pr) => Ve(oi, kr, pr) >= 0;
          re.exports = Ke;
        } }), HT = Oa({ "node_modules/semver/functions/lte.js"(M, re) {
          Ea();
          var Ve = nd(), Ke = (oi, kr, pr) => Ve(oi, kr, pr) <= 0;
          re.exports = Ke;
        } }), j4 = Oa({ "node_modules/semver/functions/cmp.js"(M, re) {
          Ea();
          var Ve = qT(), Ke = J4(), oi = T1(), kr = GT(), pr = KT(), Lr = HT(), ar = (ke, e, a, C) => {
            switch (e) {
              case "===":
                return typeof ke == "object" && (ke = ke.version), typeof a == "object" && (a = a.version), ke === a;
              case "!==":
                return typeof ke == "object" && (ke = ke.version), typeof a == "object" && (a = a.version), ke !== a;
              case "":
              case "=":
              case "==":
                return Ve(ke, a, C);
              case "!=":
                return Ke(ke, a, C);
              case ">":
                return oi(ke, a, C);
              case ">=":
                return kr(ke, a, C);
              case "<":
                return pr(ke, a, C);
              case "<=":
                return Lr(ke, a, C);
              default:
                throw new TypeError("Invalid operator: ".concat(e));
            }
          };
          re.exports = ar;
        } }), aU = Oa({ "node_modules/semver/functions/coerce.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = Ov(), { re: oi, t: kr } = wv(), pr = (Lr, ar) => {
            if (Lr instanceof Ve) return Lr;
            if (typeof Lr == "number" && (Lr = String(Lr)), typeof Lr != "string") return null;
            ar = ar || {};
            let ke = null;
            if (!ar.rtl) ke = Lr.match(oi[kr.COERCE]);
            else {
              let e;
              for (; (e = oi[kr.COERCERTL].exec(Lr)) && (!ke || ke.index + ke[0].length !== Lr.length); ) (!ke || e.index + e[0].length !== ke.index + ke[0].length) && (ke = e), oi[kr.COERCERTL].lastIndex = e.index + e[1].length + e[2].length;
              oi[kr.COERCERTL].lastIndex = -1;
            }
            return ke === null ? null : Ke("".concat(ke[2], ".").concat(ke[3] || "0", ".").concat(ke[4] || "0"), ar);
          };
          re.exports = pr;
        } }), nU = Oa({ "node_modules/yallist/iterator.js"(M, re) {
          "use strict";
          Ea(), re.exports = function(Ve) {
            Ve.prototype[Symbol.iterator] = function* () {
              for (let Ke = this.head; Ke; Ke = Ke.next) yield Ke.value;
            };
          };
        } }), oU = Oa({ "node_modules/yallist/yallist.js"(M, re) {
          "use strict";
          Ea(), re.exports = Ve, Ve.Node = pr, Ve.create = Ve;
          function Ve(Lr) {
            var ar = this;
            if (ar instanceof Ve || (ar = new Ve()), ar.tail = null, ar.head = null, ar.length = 0, Lr && typeof Lr.forEach == "function") Lr.forEach(function(a) {
              ar.push(a);
            });
            else if (arguments.length > 0) for (var ke = 0, e = arguments.length; ke < e; ke++) ar.push(arguments[ke]);
            return ar;
          }
          Ve.prototype.removeNode = function(Lr) {
            if (Lr.list !== this) throw new Error("removing node which does not belong to this list");
            var ar = Lr.next, ke = Lr.prev;
            return ar && (ar.prev = ke), ke && (ke.next = ar), Lr === this.head && (this.head = ar), Lr === this.tail && (this.tail = ke), Lr.list.length--, Lr.next = null, Lr.prev = null, Lr.list = null, ar;
          }, Ve.prototype.unshiftNode = function(Lr) {
            if (Lr !== this.head) {
              Lr.list && Lr.list.removeNode(Lr);
              var ar = this.head;
              Lr.list = this, Lr.next = ar, ar && (ar.prev = Lr), this.head = Lr, this.tail || (this.tail = Lr), this.length++;
            }
          }, Ve.prototype.pushNode = function(Lr) {
            if (Lr !== this.tail) {
              Lr.list && Lr.list.removeNode(Lr);
              var ar = this.tail;
              Lr.list = this, Lr.prev = ar, ar && (ar.next = Lr), this.tail = Lr, this.head || (this.head = Lr), this.length++;
            }
          }, Ve.prototype.push = function() {
            for (var Lr = 0, ar = arguments.length; Lr < ar; Lr++) oi(this, arguments[Lr]);
            return this.length;
          }, Ve.prototype.unshift = function() {
            for (var Lr = 0, ar = arguments.length; Lr < ar; Lr++) kr(this, arguments[Lr]);
            return this.length;
          }, Ve.prototype.pop = function() {
            if (!!this.tail) {
              var Lr = this.tail.value;
              return this.tail = this.tail.prev, this.tail ? this.tail.next = null : this.head = null, this.length--, Lr;
            }
          }, Ve.prototype.shift = function() {
            if (!!this.head) {
              var Lr = this.head.value;
              return this.head = this.head.next, this.head ? this.head.prev = null : this.tail = null, this.length--, Lr;
            }
          }, Ve.prototype.forEach = function(Lr, ar) {
            ar = ar || this;
            for (var ke = this.head, e = 0; ke !== null; e++) Lr.call(ar, ke.value, e, this), ke = ke.next;
          }, Ve.prototype.forEachReverse = function(Lr, ar) {
            ar = ar || this;
            for (var ke = this.tail, e = this.length - 1; ke !== null; e--) Lr.call(ar, ke.value, e, this), ke = ke.prev;
          }, Ve.prototype.get = function(Lr) {
            for (var ar = 0, ke = this.head; ke !== null && ar < Lr; ar++) ke = ke.next;
            if (ar === Lr && ke !== null) return ke.value;
          }, Ve.prototype.getReverse = function(Lr) {
            for (var ar = 0, ke = this.tail; ke !== null && ar < Lr; ar++) ke = ke.prev;
            if (ar === Lr && ke !== null) return ke.value;
          }, Ve.prototype.map = function(Lr, ar) {
            ar = ar || this;
            for (var ke = new Ve(), e = this.head; e !== null; ) ke.push(Lr.call(ar, e.value, this)), e = e.next;
            return ke;
          }, Ve.prototype.mapReverse = function(Lr, ar) {
            ar = ar || this;
            for (var ke = new Ve(), e = this.tail; e !== null; ) ke.push(Lr.call(ar, e.value, this)), e = e.prev;
            return ke;
          }, Ve.prototype.reduce = function(Lr, ar) {
            var ke, e = this.head;
            if (arguments.length > 1) ke = ar;
            else if (this.head) e = this.head.next, ke = this.head.value;
            else throw new TypeError("Reduce of empty list with no initial value");
            for (var a = 0; e !== null; a++) ke = Lr(ke, e.value, a), e = e.next;
            return ke;
          }, Ve.prototype.reduceReverse = function(Lr, ar) {
            var ke, e = this.tail;
            if (arguments.length > 1) ke = ar;
            else if (this.tail) e = this.tail.prev, ke = this.tail.value;
            else throw new TypeError("Reduce of empty list with no initial value");
            for (var a = this.length - 1; e !== null; a--) ke = Lr(ke, e.value, a), e = e.prev;
            return ke;
          }, Ve.prototype.toArray = function() {
            for (var Lr = new Array(this.length), ar = 0, ke = this.head; ke !== null; ar++) Lr[ar] = ke.value, ke = ke.next;
            return Lr;
          }, Ve.prototype.toArrayReverse = function() {
            for (var Lr = new Array(this.length), ar = 0, ke = this.tail; ke !== null; ar++) Lr[ar] = ke.value, ke = ke.prev;
            return Lr;
          }, Ve.prototype.slice = function(Lr, ar) {
            ar = ar || this.length, ar < 0 && (ar += this.length), Lr = Lr || 0, Lr < 0 && (Lr += this.length);
            var ke = new Ve();
            if (ar < Lr || ar < 0) return ke;
            Lr < 0 && (Lr = 0), ar > this.length && (ar = this.length);
            for (var e = 0, a = this.head; a !== null && e < Lr; e++) a = a.next;
            for (; a !== null && e < ar; e++, a = a.next) ke.push(a.value);
            return ke;
          }, Ve.prototype.sliceReverse = function(Lr, ar) {
            ar = ar || this.length, ar < 0 && (ar += this.length), Lr = Lr || 0, Lr < 0 && (Lr += this.length);
            var ke = new Ve();
            if (ar < Lr || ar < 0) return ke;
            Lr < 0 && (Lr = 0), ar > this.length && (ar = this.length);
            for (var e = this.length, a = this.tail; a !== null && e > ar; e--) a = a.prev;
            for (; a !== null && e > Lr; e--, a = a.prev) ke.push(a.value);
            return ke;
          }, Ve.prototype.splice = function(Lr, ar) {
            Lr > this.length && (Lr = this.length - 1), Lr < 0 && (Lr = this.length + Lr);
            for (var ke = 0, e = this.head; e !== null && ke < Lr; ke++) e = e.next;
            for (var a = [], ke = 0; e && ke < ar; ke++) a.push(e.value), e = this.removeNode(e);
            e === null && (e = this.tail), e !== this.head && e !== this.tail && (e = e.prev);
            for (var ke = 0; ke < (arguments.length <= 2 ? 0 : arguments.length - 2); ke++) e = Ke(this, e, ke + 2 < 2 || arguments.length <= ke + 2 ? void 0 : arguments[ke + 2]);
            return a;
          }, Ve.prototype.reverse = function() {
            for (var Lr = this.head, ar = this.tail, ke = Lr; ke !== null; ke = ke.prev) {
              var e = ke.prev;
              ke.prev = ke.next, ke.next = e;
            }
            return this.head = ar, this.tail = Lr, this;
          };
          function Ke(Lr, ar, ke) {
            var e = ar === Lr.head ? new pr(ke, null, ar, Lr) : new pr(ke, ar, ar.next, Lr);
            return e.next === null && (Lr.tail = e), e.prev === null && (Lr.head = e), Lr.length++, e;
          }
          function oi(Lr, ar) {
            Lr.tail = new pr(ar, Lr.tail, null, Lr), Lr.head || (Lr.head = Lr.tail), Lr.length++;
          }
          function kr(Lr, ar) {
            Lr.head = new pr(ar, null, Lr.head, Lr), Lr.tail || (Lr.tail = Lr.head), Lr.length++;
          }
          function pr(Lr, ar, ke, e) {
            if (!(this instanceof pr)) return new pr(Lr, ar, ke, e);
            this.list = e, this.value = Lr, ar ? (ar.next = this, this.prev = ar) : this.prev = null, ke ? (ke.prev = this, this.next = ke) : this.next = null;
          }
          try {
            nU()(Ve);
          } catch {
          }
        } }), sU = Oa({ "node_modules/lru-cache/index.js"(M, re) {
          "use strict";
          Ea();
          var Ve = oU(), Ke = Symbol("max"), oi = Symbol("length"), kr = Symbol("lengthCalculator"), pr = Symbol("allowStale"), Lr = Symbol("maxAge"), ar = Symbol("dispose"), ke = Symbol("noDisposeOnSet"), e = Symbol("lruList"), a = Symbol("cache"), C = Symbol("updateAgeOnGet"), w = () => 1, B = class {
            constructor(G) {
              if (typeof G == "number" && (G = { max: G }), G || (G = {}), G.max && (typeof G.max != "number" || G.max < 0)) throw new TypeError("max must be a non-negative number");
              let oe = this[Ke] = G.max || 1 / 0, f = G.length || w;
              if (this[kr] = typeof f != "function" ? w : f, this[pr] = G.stale || false, G.maxAge && typeof G.maxAge != "number") throw new TypeError("maxAge must be a number");
              this[Lr] = G.maxAge || 0, this[ar] = G.dispose, this[ke] = G.noDisposeOnSet || false, this[C] = G.updateAgeOnGet || false, this.reset();
            }
            set max(G) {
              if (typeof G != "number" || G < 0) throw new TypeError("max must be a non-negative number");
              this[Ke] = G || 1 / 0, le(this);
            }
            get max() {
              return this[Ke];
            }
            set allowStale(G) {
              this[pr] = !!G;
            }
            get allowStale() {
              return this[pr];
            }
            set maxAge(G) {
              if (typeof G != "number") throw new TypeError("maxAge must be a non-negative number");
              this[Lr] = G, le(this);
            }
            get maxAge() {
              return this[Lr];
            }
            set lengthCalculator(G) {
              typeof G != "function" && (G = w), G !== this[kr] && (this[kr] = G, this[oi] = 0, this[e].forEach((oe) => {
                oe.length = this[kr](oe.value, oe.key), this[oi] += oe.length;
              })), le(this);
            }
            get lengthCalculator() {
              return this[kr];
            }
            get length() {
              return this[oi];
            }
            get itemCount() {
              return this[e].length;
            }
            rforEach(G, oe) {
              oe = oe || this;
              for (let f = this[e].tail; f !== null; ) {
                let T = f.prev;
                m(this, G, f, oe), f = T;
              }
            }
            forEach(G, oe) {
              oe = oe || this;
              for (let f = this[e].head; f !== null; ) {
                let T = f.next;
                m(this, G, f, oe), f = T;
              }
            }
            keys() {
              return this[e].toArray().map((G) => G.key);
            }
            values() {
              return this[e].toArray().map((G) => G.value);
            }
            reset() {
              this[ar] && this[e] && this[e].length && this[e].forEach((G) => this[ar](G.key, G.value)), this[a] = /* @__PURE__ */ new Map(), this[e] = new Ve(), this[oi] = 0;
            }
            dump() {
              return this[e].map((G) => Q(this, G) ? false : { k: G.key, v: G.value, e: G.now + (G.maxAge || 0) }).toArray().filter((G) => G);
            }
            dumpLru() {
              return this[e];
            }
            set(G, oe, f) {
              if (f = f || this[Lr], f && typeof f != "number") throw new TypeError("maxAge must be a number");
              let T = f ? Date.now() : 0, K = this[kr](oe, G);
              if (this[a].has(G)) {
                if (K > this[Ke]) return N(this, this[a].get(G)), false;
                let J = this[a].get(G).value;
                return this[ar] && (this[ke] || this[ar](G, J.value)), J.now = T, J.maxAge = f, J.value = oe, this[oi] += K - J.length, J.length = K, this.get(G), le(this), true;
              }
              let b = new p(G, oe, K, T, f);
              return b.length > this[Ke] ? (this[ar] && this[ar](G, oe), false) : (this[oi] += b.length, this[e].unshift(b), this[a].set(G, this[e].head), le(this), true);
            }
            has(G) {
              if (!this[a].has(G)) return false;
              let oe = this[a].get(G).value;
              return !Q(this, oe);
            }
            get(G) {
              return E(this, G, true);
            }
            peek(G) {
              return E(this, G, false);
            }
            pop() {
              let G = this[e].tail;
              return G ? (N(this, G), G.value) : null;
            }
            del(G) {
              N(this, this[a].get(G));
            }
            load(G) {
              this.reset();
              let oe = Date.now();
              for (let f = G.length - 1; f >= 0; f--) {
                let T = G[f], K = T.e || 0;
                if (K === 0) this.set(T.k, T.v);
                else {
                  let b = K - oe;
                  b > 0 && this.set(T.k, T.v, b);
                }
              }
            }
            prune() {
              this[a].forEach((G, oe) => E(this, oe, false));
            }
          }, E = (G, oe, f) => {
            let T = G[a].get(oe);
            if (T) {
              let K = T.value;
              if (Q(G, K)) {
                if (N(G, T), !G[pr]) return;
              } else f && (G[C] && (T.value.now = Date.now()), G[e].unshiftNode(T));
              return K.value;
            }
          }, Q = (G, oe) => {
            if (!oe || !oe.maxAge && !G[Lr]) return false;
            let f = Date.now() - oe.now;
            return oe.maxAge ? f > oe.maxAge : G[Lr] && f > G[Lr];
          }, le = (G) => {
            if (G[oi] > G[Ke]) for (let oe = G[e].tail; G[oi] > G[Ke] && oe !== null; ) {
              let f = oe.prev;
              N(G, oe), oe = f;
            }
          }, N = (G, oe) => {
            if (oe) {
              let f = oe.value;
              G[ar] && G[ar](f.key, f.value), G[oi] -= f.length, G[a].delete(f.key), G[e].removeNode(oe);
            }
          }, p = class {
            constructor(G, oe, f, T, K) {
              this.key = G, this.value = oe, this.length = f, this.now = T, this.maxAge = K || 0;
            }
          }, m = (G, oe, f, T) => {
            let K = f.value;
            Q(G, K) && (N(G, f), G[pr] || (K = void 0)), K && oe.call(T, K.value, K.key, G);
          };
          re.exports = B;
        } }), od = Oa({ "node_modules/semver/classes/range.js"(M, re) {
          Ea();
          var Ve = class {
            constructor(ie, R) {
              if (R = kr(R), ie instanceof Ve) return ie.loose === !!R.loose && ie.includePrerelease === !!R.includePrerelease ? ie : new Ve(ie.raw, R);
              if (ie instanceof pr) return this.raw = ie.value, this.set = [[ie]], this.format(), this;
              if (this.options = R, this.loose = !!R.loose, this.includePrerelease = !!R.includePrerelease, this.raw = ie, this.set = ie.split("||").map((q) => this.parseRange(q.trim())).filter((q) => q.length), !this.set.length) throw new TypeError("Invalid SemVer Range: ".concat(ie));
              if (this.set.length > 1) {
                let q = this.set[0];
                if (this.set = this.set.filter((O) => !B(O[0])), this.set.length === 0) this.set = [q];
                else if (this.set.length > 1) {
                  for (let O of this.set) if (O.length === 1 && E(O[0])) {
                    this.set = [O];
                    break;
                  }
                }
              }
              this.format();
            }
            format() {
              return this.range = this.set.map((ie) => ie.join(" ").trim()).join("||").trim(), this.range;
            }
            toString() {
              return this.range;
            }
            parseRange(ie) {
              ie = ie.trim();
              let R = Object.keys(this.options).join(","), q = "parseRange:".concat(R, ":").concat(ie), O = oi.get(q);
              if (O) return O;
              let ve = this.options.loose, ee = ve ? ke[e.HYPHENRANGELOOSE] : ke[e.HYPHENRANGE];
              ie = ie.replace(ee, se(this.options.includePrerelease)), Lr("hyphen replace", ie), ie = ie.replace(ke[e.COMPARATORTRIM], a), Lr("comparator trim", ie), ie = ie.replace(ke[e.TILDETRIM], C), ie = ie.replace(ke[e.CARETTRIM], w), ie = ie.split(/\s+/).join(" ");
              let he = ie.split(" ").map(($) => le($, this.options)).join(" ").split(/\s+/).map(($) => b($, this.options));
              ve && (he = he.filter(($) => (Lr("loose invalid filter", $, this.options), !!$.match(ke[e.COMPARATORLOOSE])))), Lr("range list", he);
              let F = /* @__PURE__ */ new Map(), x = he.map(($) => new pr($, this.options));
              for (let $ of x) {
                if (B($)) return [$];
                F.set($.value, $);
              }
              F.size > 1 && F.has("") && F.delete("");
              let X = [...F.values()];
              return oi.set(q, X), X;
            }
            intersects(ie, R) {
              if (!(ie instanceof Ve)) throw new TypeError("a Range is required");
              return this.set.some((q) => Q(q, R) && ie.set.some((O) => Q(O, R) && q.every((ve) => O.every((ee) => ve.intersects(ee, R)))));
            }
            test(ie) {
              if (!ie) return false;
              if (typeof ie == "string") try {
                ie = new ar(ie, this.options);
              } catch {
                return false;
              }
              for (let R = 0; R < this.set.length; R++) if (J(this.set[R], ie, this.options)) return true;
              return false;
            }
          };
          re.exports = Ve;
          var Ke = sU(), oi = new Ke({ max: 1e3 }), kr = S1(), pr = x1(), Lr = b1(), ar = Lf(), { re: ke, t: e, comparatorTrimReplace: a, tildeTrimReplace: C, caretTrimReplace: w } = wv(), B = (ie) => ie.value === "<0.0.0-0", E = (ie) => ie.value === "", Q = (ie, R) => {
            let q = true, O = ie.slice(), ve = O.pop();
            for (; q && O.length; ) q = O.every((ee) => ve.intersects(ee, R)), ve = O.pop();
            return q;
          }, le = (ie, R) => (Lr("comp", ie, R), ie = G(ie, R), Lr("caret", ie), ie = p(ie, R), Lr("tildes", ie), ie = f(ie, R), Lr("xrange", ie), ie = K(ie, R), Lr("stars", ie), ie), N = (ie) => !ie || ie.toLowerCase() === "x" || ie === "*", p = (ie, R) => ie.trim().split(/\s+/).map((q) => m(q, R)).join(" "), m = (ie, R) => {
            let q = R.loose ? ke[e.TILDELOOSE] : ke[e.TILDE];
            return ie.replace(q, (O, ve, ee, he, F) => {
              Lr("tilde", ie, O, ve, ee, he, F);
              let x;
              return N(ve) ? x = "" : N(ee) ? x = ">=".concat(ve, ".0.0 <").concat(+ve + 1, ".0.0-0") : N(he) ? x = ">=".concat(ve, ".").concat(ee, ".0 <").concat(ve, ".").concat(+ee + 1, ".0-0") : F ? (Lr("replaceTilde pr", F), x = ">=".concat(ve, ".").concat(ee, ".").concat(he, "-").concat(F, " <").concat(ve, ".").concat(+ee + 1, ".0-0")) : x = ">=".concat(ve, ".").concat(ee, ".").concat(he, " <").concat(ve, ".").concat(+ee + 1, ".0-0"), Lr("tilde return", x), x;
            });
          }, G = (ie, R) => ie.trim().split(/\s+/).map((q) => oe(q, R)).join(" "), oe = (ie, R) => {
            Lr("caret", ie, R);
            let q = R.loose ? ke[e.CARETLOOSE] : ke[e.CARET], O = R.includePrerelease ? "-0" : "";
            return ie.replace(q, (ve, ee, he, F, x) => {
              Lr("caret", ie, ve, ee, he, F, x);
              let X;
              return N(ee) ? X = "" : N(he) ? X = ">=".concat(ee, ".0.0").concat(O, " <").concat(+ee + 1, ".0.0-0") : N(F) ? ee === "0" ? X = ">=".concat(ee, ".").concat(he, ".0").concat(O, " <").concat(ee, ".").concat(+he + 1, ".0-0") : X = ">=".concat(ee, ".").concat(he, ".0").concat(O, " <").concat(+ee + 1, ".0.0-0") : x ? (Lr("replaceCaret pr", x), ee === "0" ? he === "0" ? X = ">=".concat(ee, ".").concat(he, ".").concat(F, "-").concat(x, " <").concat(ee, ".").concat(he, ".").concat(+F + 1, "-0") : X = ">=".concat(ee, ".").concat(he, ".").concat(F, "-").concat(x, " <").concat(ee, ".").concat(+he + 1, ".0-0") : X = ">=".concat(ee, ".").concat(he, ".").concat(F, "-").concat(x, " <").concat(+ee + 1, ".0.0-0")) : (Lr("no pr"), ee === "0" ? he === "0" ? X = ">=".concat(ee, ".").concat(he, ".").concat(F).concat(O, " <").concat(ee, ".").concat(he, ".").concat(+F + 1, "-0") : X = ">=".concat(ee, ".").concat(he, ".").concat(F).concat(O, " <").concat(ee, ".").concat(+he + 1, ".0-0") : X = ">=".concat(ee, ".").concat(he, ".").concat(F, " <").concat(+ee + 1, ".0.0-0")), Lr("caret return", X), X;
            });
          }, f = (ie, R) => (Lr("replaceXRanges", ie, R), ie.split(/\s+/).map((q) => T(q, R)).join(" ")), T = (ie, R) => {
            ie = ie.trim();
            let q = R.loose ? ke[e.XRANGELOOSE] : ke[e.XRANGE];
            return ie.replace(q, (O, ve, ee, he, F, x) => {
              Lr("xRange", ie, O, ve, ee, he, F, x);
              let X = N(ee), $ = X || N(he), A = $ || N(F), y = A;
              return ve === "=" && y && (ve = ""), x = R.includePrerelease ? "-0" : "", X ? ve === ">" || ve === "<" ? O = "<0.0.0-0" : O = "*" : ve && y ? ($ && (he = 0), F = 0, ve === ">" ? (ve = ">=", $ ? (ee = +ee + 1, he = 0, F = 0) : (he = +he + 1, F = 0)) : ve === "<=" && (ve = "<", $ ? ee = +ee + 1 : he = +he + 1), ve === "<" && (x = "-0"), O = "".concat(ve + ee, ".").concat(he, ".").concat(F).concat(x)) : $ ? O = ">=".concat(ee, ".0.0").concat(x, " <").concat(+ee + 1, ".0.0-0") : A && (O = ">=".concat(ee, ".").concat(he, ".0").concat(x, " <").concat(ee, ".").concat(+he + 1, ".0-0")), Lr("xRange return", O), O;
            });
          }, K = (ie, R) => (Lr("replaceStars", ie, R), ie.trim().replace(ke[e.STAR], "")), b = (ie, R) => (Lr("replaceGTE0", ie, R), ie.trim().replace(ke[R.includePrerelease ? e.GTE0PRE : e.GTE0], "")), se = (ie) => (R, q, O, ve, ee, he, F, x, X, $, A, y, V) => (N(O) ? q = "" : N(ve) ? q = ">=".concat(O, ".0.0").concat(ie ? "-0" : "") : N(ee) ? q = ">=".concat(O, ".").concat(ve, ".0").concat(ie ? "-0" : "") : he ? q = ">=".concat(q) : q = ">=".concat(q).concat(ie ? "-0" : ""), N(X) ? x = "" : N($) ? x = "<".concat(+X + 1, ".0.0-0") : N(A) ? x = "<".concat(X, ".").concat(+$ + 1, ".0-0") : y ? x = "<=".concat(X, ".").concat($, ".").concat(A, "-").concat(y) : ie ? x = "<".concat(X, ".").concat($, ".").concat(+A + 1, "-0") : x = "<=".concat(x), "".concat(q, " ").concat(x).trim()), J = (ie, R, q) => {
            for (let O = 0; O < ie.length; O++) if (!ie[O].test(R)) return false;
            if (R.prerelease.length && !q.includePrerelease) {
              for (let O = 0; O < ie.length; O++) if (Lr(ie[O].semver), ie[O].semver !== pr.ANY && ie[O].semver.prerelease.length > 0) {
                let ve = ie[O].semver;
                if (ve.major === R.major && ve.minor === R.minor && ve.patch === R.patch) return true;
              }
              return false;
            }
            return true;
          };
        } }), x1 = Oa({ "node_modules/semver/classes/comparator.js"(M, re) {
          Ea();
          var Ve = Symbol("SemVer ANY"), Ke = class {
            static get ANY() {
              return Ve;
            }
            constructor(a, C) {
              if (C = oi(C), a instanceof Ke) {
                if (a.loose === !!C.loose) return a;
                a = a.value;
              }
              ar("comparator", a, C), this.options = C, this.loose = !!C.loose, this.parse(a), this.semver === Ve ? this.value = "" : this.value = this.operator + this.semver.version, ar("comp", this);
            }
            parse(a) {
              let C = this.options.loose ? kr[pr.COMPARATORLOOSE] : kr[pr.COMPARATOR], w = a.match(C);
              if (!w) throw new TypeError("Invalid comparator: ".concat(a));
              this.operator = w[1] !== void 0 ? w[1] : "", this.operator === "=" && (this.operator = ""), w[2] ? this.semver = new ke(w[2], this.options.loose) : this.semver = Ve;
            }
            toString() {
              return this.value;
            }
            test(a) {
              if (ar("Comparator.test", a, this.options.loose), this.semver === Ve || a === Ve) return true;
              if (typeof a == "string") try {
                a = new ke(a, this.options);
              } catch {
                return false;
              }
              return Lr(a, this.operator, this.semver, this.options);
            }
            intersects(a, C) {
              if (!(a instanceof Ke)) throw new TypeError("a Comparator is required");
              if ((!C || typeof C != "object") && (C = { loose: !!C, includePrerelease: false }), this.operator === "") return this.value === "" ? true : new e(a.value, C).test(this.value);
              if (a.operator === "") return a.value === "" ? true : new e(this.value, C).test(a.semver);
              let w = (this.operator === ">=" || this.operator === ">") && (a.operator === ">=" || a.operator === ">"), B = (this.operator === "<=" || this.operator === "<") && (a.operator === "<=" || a.operator === "<"), E = this.semver.version === a.semver.version, Q = (this.operator === ">=" || this.operator === "<=") && (a.operator === ">=" || a.operator === "<="), le = Lr(this.semver, "<", a.semver, C) && (this.operator === ">=" || this.operator === ">") && (a.operator === "<=" || a.operator === "<"), N = Lr(this.semver, ">", a.semver, C) && (this.operator === "<=" || this.operator === "<") && (a.operator === ">=" || a.operator === ">");
              return w || B || E && Q || le || N;
            }
          };
          re.exports = Ke;
          var oi = S1(), { re: kr, t: pr } = wv(), Lr = j4(), ar = b1(), ke = Lf(), e = od();
        } }), E1 = Oa({ "node_modules/semver/functions/satisfies.js"(M, re) {
          Ea();
          var Ve = od(), Ke = (oi, kr, pr) => {
            try {
              kr = new Ve(kr, pr);
            } catch {
              return false;
            }
            return kr.test(oi);
          };
          re.exports = Ke;
        } }), cU = Oa({ "node_modules/semver/ranges/to-comparators.js"(M, re) {
          Ea();
          var Ve = od(), Ke = (oi, kr) => new Ve(oi, kr).set.map((pr) => pr.map((Lr) => Lr.value).join(" ").trim().split(" "));
          re.exports = Ke;
        } }), uU = Oa({ "node_modules/semver/ranges/max-satisfying.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = od(), oi = (kr, pr, Lr) => {
            let ar = null, ke = null, e = null;
            try {
              e = new Ke(pr, Lr);
            } catch {
              return null;
            }
            return kr.forEach((a) => {
              e.test(a) && (!ar || ke.compare(a) === -1) && (ar = a, ke = new Ve(ar, Lr));
            }), ar;
          };
          re.exports = oi;
        } }), lU = Oa({ "node_modules/semver/ranges/min-satisfying.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = od(), oi = (kr, pr, Lr) => {
            let ar = null, ke = null, e = null;
            try {
              e = new Ke(pr, Lr);
            } catch {
              return null;
            }
            return kr.forEach((a) => {
              e.test(a) && (!ar || ke.compare(a) === 1) && (ar = a, ke = new Ve(ar, Lr));
            }), ar;
          };
          re.exports = oi;
        } }), fU = Oa({ "node_modules/semver/ranges/min-version.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = od(), oi = T1(), kr = (pr, Lr) => {
            pr = new Ke(pr, Lr);
            let ar = new Ve("0.0.0");
            if (pr.test(ar) || (ar = new Ve("0.0.0-0"), pr.test(ar))) return ar;
            ar = null;
            for (let ke = 0; ke < pr.set.length; ++ke) {
              let e = pr.set[ke], a = null;
              e.forEach((C) => {
                let w = new Ve(C.semver.version);
                switch (C.operator) {
                  case ">":
                    w.prerelease.length === 0 ? w.patch++ : w.prerelease.push(0), w.raw = w.format();
                  case "":
                  case ">=":
                    (!a || oi(w, a)) && (a = w);
                    break;
                  case "<":
                  case "<=":
                    break;
                  default:
                    throw new Error("Unexpected operation: ".concat(C.operator));
                }
              }), a && (!ar || oi(ar, a)) && (ar = a);
            }
            return ar && pr.test(ar) ? ar : null;
          };
          re.exports = kr;
        } }), _U = Oa({ "node_modules/semver/ranges/valid.js"(M, re) {
          Ea();
          var Ve = od(), Ke = (oi, kr) => {
            try {
              return new Ve(oi, kr).range || "*";
            } catch {
              return null;
            }
          };
          re.exports = Ke;
        } }), XT = Oa({ "node_modules/semver/ranges/outside.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = x1(), { ANY: oi } = Ke, kr = od(), pr = E1(), Lr = T1(), ar = KT(), ke = HT(), e = GT(), a = (C, w, B, E) => {
            C = new Ve(C, E), w = new kr(w, E);
            let Q, le, N, p, m;
            switch (B) {
              case ">":
                Q = Lr, le = ke, N = ar, p = ">", m = ">=";
                break;
              case "<":
                Q = ar, le = e, N = Lr, p = "<", m = "<=";
                break;
              default:
                throw new TypeError('Must provide a hilo val of "<" or ">"');
            }
            if (pr(C, w, E)) return false;
            for (let G = 0; G < w.set.length; ++G) {
              let oe = w.set[G], f = null, T = null;
              if (oe.forEach((K) => {
                K.semver === oi && (K = new Ke(">=0.0.0")), f = f || K, T = T || K, Q(K.semver, f.semver, E) ? f = K : N(K.semver, T.semver, E) && (T = K);
              }), f.operator === p || f.operator === m || (!T.operator || T.operator === p) && le(C, T.semver)) return false;
              if (T.operator === m && N(C, T.semver)) return false;
            }
            return true;
          };
          re.exports = a;
        } }), pU = Oa({ "node_modules/semver/ranges/gtr.js"(M, re) {
          Ea();
          var Ve = XT(), Ke = (oi, kr, pr) => Ve(oi, kr, ">", pr);
          re.exports = Ke;
        } }), dU = Oa({ "node_modules/semver/ranges/ltr.js"(M, re) {
          Ea();
          var Ve = XT(), Ke = (oi, kr, pr) => Ve(oi, kr, "<", pr);
          re.exports = Ke;
        } }), gU = Oa({ "node_modules/semver/ranges/intersects.js"(M, re) {
          Ea();
          var Ve = od(), Ke = (oi, kr, pr) => (oi = new Ve(oi, pr), kr = new Ve(kr, pr), oi.intersects(kr));
          re.exports = Ke;
        } }), mU = Oa({ "node_modules/semver/ranges/simplify.js"(M, re) {
          Ea();
          var Ve = E1(), Ke = nd();
          re.exports = (oi, kr, pr) => {
            let Lr = [], ar = null, ke = null, e = oi.sort((B, E) => Ke(B, E, pr));
            for (let B of e) Ve(B, kr, pr) ? (ke = B, ar || (ar = B)) : (ke && Lr.push([ar, ke]), ke = null, ar = null);
            ar && Lr.push([ar, null]);
            let a = [];
            for (let [B, E] of Lr) B === E ? a.push(B) : !E && B === e[0] ? a.push("*") : E ? B === e[0] ? a.push("<=".concat(E)) : a.push("".concat(B, " - ").concat(E)) : a.push(">=".concat(B));
            let C = a.join(" || "), w = typeof kr.raw == "string" ? kr.raw : String(kr);
            return C.length < w.length ? C : kr;
          };
        } }), vU = Oa({ "node_modules/semver/ranges/subset.js"(M, re) {
          Ea();
          var Ve = od(), Ke = x1(), { ANY: oi } = Ke, kr = E1(), pr = nd(), Lr = function(a, C) {
            let w = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
            if (a === C) return true;
            a = new Ve(a, w), C = new Ve(C, w);
            let B = false;
            e: for (let E of a.set) {
              for (let Q of C.set) {
                let le = ar(E, Q, w);
                if (B = B || le !== null, le) continue e;
              }
              if (B) return false;
            }
            return true;
          }, ar = (a, C, w) => {
            if (a === C) return true;
            if (a.length === 1 && a[0].semver === oi) {
              if (C.length === 1 && C[0].semver === oi) return true;
              w.includePrerelease ? a = [new Ke(">=0.0.0-0")] : a = [new Ke(">=0.0.0")];
            }
            if (C.length === 1 && C[0].semver === oi) {
              if (w.includePrerelease) return true;
              C = [new Ke(">=0.0.0")];
            }
            let B = /* @__PURE__ */ new Set(), E, Q;
            for (let T of a) T.operator === ">" || T.operator === ">=" ? E = ke(E, T, w) : T.operator === "<" || T.operator === "<=" ? Q = e(Q, T, w) : B.add(T.semver);
            if (B.size > 1) return null;
            let le;
            if (E && Q) {
              if (le = pr(E.semver, Q.semver, w), le > 0) return null;
              if (le === 0 && (E.operator !== ">=" || Q.operator !== "<=")) return null;
            }
            for (let T of B) {
              if (E && !kr(T, String(E), w) || Q && !kr(T, String(Q), w)) return null;
              for (let K of C) if (!kr(T, String(K), w)) return false;
              return true;
            }
            let N, p, m, G, oe = Q && !w.includePrerelease && Q.semver.prerelease.length ? Q.semver : false, f = E && !w.includePrerelease && E.semver.prerelease.length ? E.semver : false;
            oe && oe.prerelease.length === 1 && Q.operator === "<" && oe.prerelease[0] === 0 && (oe = false);
            for (let T of C) {
              if (G = G || T.operator === ">" || T.operator === ">=", m = m || T.operator === "<" || T.operator === "<=", E) {
                if (f && T.semver.prerelease && T.semver.prerelease.length && T.semver.major === f.major && T.semver.minor === f.minor && T.semver.patch === f.patch && (f = false), T.operator === ">" || T.operator === ">=") {
                  if (N = ke(E, T, w), N === T && N !== E) return false;
                } else if (E.operator === ">=" && !kr(E.semver, String(T), w)) return false;
              }
              if (Q) {
                if (oe && T.semver.prerelease && T.semver.prerelease.length && T.semver.major === oe.major && T.semver.minor === oe.minor && T.semver.patch === oe.patch && (oe = false), T.operator === "<" || T.operator === "<=") {
                  if (p = e(Q, T, w), p === T && p !== Q) return false;
                } else if (Q.operator === "<=" && !kr(Q.semver, String(T), w)) return false;
              }
              if (!T.operator && (Q || E) && le !== 0) return false;
            }
            return !(E && m && !Q && le !== 0 || Q && G && !E && le !== 0 || f || oe);
          }, ke = (a, C, w) => {
            if (!a) return C;
            let B = pr(a.semver, C.semver, w);
            return B > 0 ? a : B < 0 || C.operator === ">" && a.operator === ">=" ? C : a;
          }, e = (a, C, w) => {
            if (!a) return C;
            let B = pr(a.semver, C.semver, w);
            return B < 0 ? a : B > 0 || C.operator === "<" && a.operator === "<=" ? C : a;
          };
          re.exports = Lr;
        } }), QT = Oa({ "node_modules/semver/index.js"(M, re) {
          Ea();
          var Ve = wv();
          re.exports = { re: Ve.re, src: Ve.src, tokens: Ve.t, SEMVER_SPEC_VERSION: D1().SEMVER_SPEC_VERSION, SemVer: Lf(), compareIdentifiers: BT().compareIdentifiers, rcompareIdentifiers: BT().rcompareIdentifiers, parse: Ov(), valid: Kj(), clean: Gj(), inc: Hj(), diff: Xj(), major: Qj(), minor: Yj(), patch: $j(), prerelease: Zj(), compare: nd(), rcompare: eU(), compareLoose: rU(), compareBuild: VT(), sort: iU(), rsort: tU(), gt: T1(), lt: KT(), eq: qT(), neq: J4(), gte: GT(), lte: HT(), cmp: j4(), coerce: aU(), Comparator: x1(), Range: od(), satisfies: E1(), toComparators: cU(), maxSatisfying: uU(), minSatisfying: lU(), minVersion: fU(), validRange: _U(), outside: XT(), gtr: pU(), ltr: dU(), intersects: gU(), simplifyRange: mU(), subset: vU() };
        } }), U4 = {};
        h1(U4, { basename: () => K4, default: () => H4, delimiter: () => jT, dirname: () => V4, extname: () => G4, isAbsolute: () => $T, join: () => W4, normalize: () => YT, relative: () => q4, resolve: () => y1, sep: () => JT });
        function z4(M, re) {
          for (var Ve = 0, Ke = M.length - 1; Ke >= 0; Ke--) {
            var oi = M[Ke];
            oi === "." ? M.splice(Ke, 1) : oi === ".." ? (M.splice(Ke, 1), Ve++) : Ve && (M.splice(Ke, 1), Ve--);
          }
          if (re) for (; Ve--; Ve) M.unshift("..");
          return M;
        }
        function y1() {
          for (var M = "", re = false, Ve = arguments.length - 1; Ve >= -1 && !re; Ve--) {
            var Ke = Ve >= 0 ? arguments[Ve] : "/";
            if (typeof Ke != "string") throw new TypeError("Arguments to path.resolve must be strings");
            if (!Ke) continue;
            M = Ke + "/" + M, re = Ke.charAt(0) === "/";
          }
          return M = z4(ZT(M.split("/"), function(oi) {
            return !!oi;
          }), !re).join("/"), (re ? "/" : "") + M || ".";
        }
        function YT(M) {
          var re = $T(M), Ve = X4(M, -1) === "/";
          return M = z4(ZT(M.split("/"), function(Ke) {
            return !!Ke;
          }), !re).join("/"), !M && !re && (M = "."), M && Ve && (M += "/"), (re ? "/" : "") + M;
        }
        function $T(M) {
          return M.charAt(0) === "/";
        }
        function W4() {
          var M = Array.prototype.slice.call(arguments, 0);
          return YT(ZT(M, function(re, Ve) {
            if (typeof re != "string") throw new TypeError("Arguments to path.join must be strings");
            return re;
          }).join("/"));
        }
        function q4(M, re) {
          M = y1(M).substr(1), re = y1(re).substr(1);
          function Ve(ke) {
            for (var e = 0; e < ke.length && ke[e] === ""; e++) ;
            for (var a = ke.length - 1; a >= 0 && ke[a] === ""; a--) ;
            return e > a ? [] : ke.slice(e, a - e + 1);
          }
          for (var Ke = Ve(M.split("/")), oi = Ve(re.split("/")), kr = Math.min(Ke.length, oi.length), pr = kr, Lr = 0; Lr < kr; Lr++) if (Ke[Lr] !== oi[Lr]) {
            pr = Lr;
            break;
          }
          for (var ar = [], Lr = pr; Lr < Ke.length; Lr++) ar.push("..");
          return ar = ar.concat(oi.slice(pr)), ar.join("/");
        }
        function V4(M) {
          var re = C1(M), Ve = re[0], Ke = re[1];
          return !Ve && !Ke ? "." : (Ke && (Ke = Ke.substr(0, Ke.length - 1)), Ve + Ke);
        }
        function K4(M, re) {
          var Ve = C1(M)[2];
          return re && Ve.substr(-1 * re.length) === re && (Ve = Ve.substr(0, Ve.length - re.length)), Ve;
        }
        function G4(M) {
          return C1(M)[3];
        }
        function ZT(M, re) {
          if (M.filter) return M.filter(re);
          for (var Ve = [], Ke = 0; Ke < M.length; Ke++) re(M[Ke], Ke, M) && Ve.push(M[Ke]);
          return Ve;
        }
        var h4, C1, JT, jT, H4, X4, yU = Qy({ "node-modules-polyfills:path"() {
          Ea(), h4 = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/, C1 = function(M) {
            return h4.exec(M).slice(1);
          }, JT = "/", jT = ":", H4 = { extname: G4, basename: K4, dirname: V4, sep: JT, delimiter: jT, relative: q4, join: W4, isAbsolute: $T, normalize: YT, resolve: y1 }, X4 = "ab".substr(-1) === "b" ? function(M, re, Ve) {
            return M.substr(re, Ve);
          } : function(M, re, Ve) {
            return re < 0 && (re = M.length + re), M.substr(re, Ve);
          };
        } }), Fv = Oa({ "node-modules-polyfills-commonjs:path"(M, re) {
          Ea();
          var Ve = (yU(), mp(U4));
          if (Ve && Ve.default) {
            re.exports = Ve.default;
            for (let Ke in Ve) re.exports[Ke] = Ve[Ke];
          } else Ve && (re.exports = Ve);
        } }), Q4 = {};
        h1(Q4, { default: () => Y4 });
        var Y4, hU = Qy({ "node-modules-polyfills:fs"() {
          Ea(), Y4 = {};
        } }), ex = Oa({ "node-modules-polyfills-commonjs:fs"(M, re) {
          Ea();
          var Ve = (hU(), mp(Q4));
          if (Ve && Ve.default) {
            re.exports = Ve.default;
            for (let Ke in Ve) re.exports[Ke] = Ve[Ke];
          } else Ve && (re.exports = Ve);
        } }), _u = Oa({ "node_modules/typescript/lib/typescript.js"(M, re) {
          "use strict";
          Ea();
          var Ve = M && M.__spreadArray || function(e, a, C) {
            if (C || arguments.length === 2) for (var w = 0, B = a.length, E; w < B; w++) (E || !(w in a)) && (E || (E = Array.prototype.slice.call(a, 0, w)), E[w] = a[w]);
            return e.concat(E || Array.prototype.slice.call(a));
          }, Ke = M && M.__assign || function() {
            return Ke = Object.assign || function(e) {
              for (var a, C = 1, w = arguments.length; C < w; C++) {
                a = arguments[C];
                for (var B in a) Object.prototype.hasOwnProperty.call(a, B) && (e[B] = a[B]);
              }
              return e;
            }, Ke.apply(this, arguments);
          }, oi = M && M.__makeTemplateObject || function(e, a) {
            return Object.defineProperty ? Object.defineProperty(e, "raw", { value: a }) : e.raw = a, e;
          }, kr = M && M.__generator || function(e, a) {
            var C = { label: 0, sent: function() {
              if (E[0] & 1) throw E[1];
              return E[1];
            }, trys: [], ops: [] }, w, B, E, Q;
            return Q = { next: le(0), throw: le(1), return: le(2) }, typeof Symbol == "function" && (Q[Symbol.iterator] = function() {
              return this;
            }), Q;
            function le(p) {
              return function(m) {
                return N([p, m]);
              };
            }
            function N(p) {
              if (w) throw new TypeError("Generator is already executing.");
              for (; C; ) try {
                if (w = 1, B && (E = p[0] & 2 ? B.return : p[0] ? B.throw || ((E = B.return) && E.call(B), 0) : B.next) && !(E = E.call(B, p[1])).done) return E;
                switch (B = 0, E && (p = [p[0] & 2, E.value]), p[0]) {
                  case 0:
                  case 1:
                    E = p;
                    break;
                  case 4:
                    return C.label++, { value: p[1], done: false };
                  case 5:
                    C.label++, B = p[1], p = [0];
                    continue;
                  case 7:
                    p = C.ops.pop(), C.trys.pop();
                    continue;
                  default:
                    if (E = C.trys, !(E = E.length > 0 && E[E.length - 1]) && (p[0] === 6 || p[0] === 2)) {
                      C = 0;
                      continue;
                    }
                    if (p[0] === 3 && (!E || p[1] > E[0] && p[1] < E[3])) {
                      C.label = p[1];
                      break;
                    }
                    if (p[0] === 6 && C.label < E[1]) {
                      C.label = E[1], E = p;
                      break;
                    }
                    if (E && C.label < E[2]) {
                      C.label = E[2], C.ops.push(p);
                      break;
                    }
                    E[2] && C.ops.pop(), C.trys.pop();
                    continue;
                }
                p = a.call(e, C);
              } catch (m) {
                p = [6, m], B = 0;
              } finally {
                w = E = 0;
              }
              if (p[0] & 5) throw p[1];
              return { value: p[0] ? p[1] : void 0, done: true };
            }
          }, pr = M && M.__rest || function(e, a) {
            var C = {};
            for (var w in e) Object.prototype.hasOwnProperty.call(e, w) && a.indexOf(w) < 0 && (C[w] = e[w]);
            if (e != null && typeof Object.getOwnPropertySymbols == "function") for (var B = 0, w = Object.getOwnPropertySymbols(e); B < w.length; B++) a.indexOf(w[B]) < 0 && Object.prototype.propertyIsEnumerable.call(e, w[B]) && (C[w[B]] = e[w[B]]);
            return C;
          }, Lr = M && M.__extends || /* @__PURE__ */ function() {
            var e = function(a, C) {
              return e = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(w, B) {
                w.__proto__ = B;
              } || function(w, B) {
                for (var E in B) Object.prototype.hasOwnProperty.call(B, E) && (w[E] = B[E]);
              }, e(a, C);
            };
            return function(a, C) {
              if (typeof C != "function" && C !== null) throw new TypeError("Class extends value " + String(C) + " is not a constructor or null");
              e(a, C);
              function w() {
                this.constructor = a;
              }
              a.prototype = C === null ? Object.create(C) : (w.prototype = C.prototype, new w());
            };
          }(), ke;
          (function(e) {
            function a() {
              var K = {};
              return K.prev = K, { head: K, tail: K, size: 0 };
            }
            function C(K, b) {
              return { key: K, value: b, next: void 0, prev: void 0 };
            }
            function w(K, b) {
              return K === b || K !== K && b !== b;
            }
            function B(K) {
              var b = K.prev;
              if (!b || b === K) throw new Error("Illegal state");
              return b;
            }
            function E(K) {
              for (; K; ) {
                var b = !K.prev;
                if (K = K.next, !b) return K;
              }
            }
            function Q(K, b) {
              for (var se = K.tail; se !== K.head; se = B(se)) if (w(se.key, b)) return se;
            }
            function le(K, b, se) {
              var J = Q(K, b);
              if (J) {
                J.value = se;
                return;
              }
              var ie = C(b, se);
              return ie.prev = K.tail, K.tail.next = ie, K.tail = ie, K.size++, ie;
            }
            function N(K, b) {
              for (var se = K.tail; se !== K.head; se = B(se)) {
                if (se.prev === void 0) throw new Error("Illegal state");
                if (w(se.key, b)) {
                  if (se.next) se.next.prev = se.prev;
                  else {
                    if (K.tail !== se) throw new Error("Illegal state");
                    K.tail = se.prev;
                  }
                  return se.prev.next = se.next, se.next = se.prev, se.prev = void 0, K.size--, se;
                }
              }
            }
            function p(K) {
              for (var b = K.tail; b !== K.head; ) {
                var se = B(b);
                b.next = K.head, b.prev = void 0, b = se;
              }
              K.head.next = void 0, K.tail = K.head, K.size = 0;
            }
            function m(K, b) {
              for (var se = K.head; se; ) se = E(se), se && b(se.value, se.key);
            }
            function G(K, b) {
              if (K) for (var se = K.next(); !se.done; se = K.next()) b(se.value);
            }
            function oe(K, b) {
              return { current: K.head, selector: b };
            }
            function f(K) {
              return K.current = E(K.current), K.current ? { value: K.selector(K.current.key, K.current.value), done: false } : { value: void 0, done: true };
            }
            var T;
            (function(K) {
              function b(J) {
                var ie = function() {
                  function R(q, O) {
                    this._data = oe(q, O);
                  }
                  return R.prototype.next = function() {
                    return f(this._data);
                  }, R;
                }();
                return function() {
                  function R(q) {
                    var O = this;
                    this._mapData = a(), G(J(q), function(ve) {
                      var ee = ve[0], he = ve[1];
                      return O.set(ee, he);
                    });
                  }
                  return Object.defineProperty(R.prototype, "size", { get: function() {
                    return this._mapData.size;
                  }, enumerable: false, configurable: true }), R.prototype.get = function(q) {
                    var O;
                    return (O = Q(this._mapData, q)) === null || O === void 0 ? void 0 : O.value;
                  }, R.prototype.set = function(q, O) {
                    return le(this._mapData, q, O), this;
                  }, R.prototype.has = function(q) {
                    return !!Q(this._mapData, q);
                  }, R.prototype.delete = function(q) {
                    return !!N(this._mapData, q);
                  }, R.prototype.clear = function() {
                    p(this._mapData);
                  }, R.prototype.keys = function() {
                    return new ie(this._mapData, function(q, O) {
                      return q;
                    });
                  }, R.prototype.values = function() {
                    return new ie(this._mapData, function(q, O) {
                      return O;
                    });
                  }, R.prototype.entries = function() {
                    return new ie(this._mapData, function(q, O) {
                      return [q, O];
                    });
                  }, R.prototype.forEach = function(q) {
                    m(this._mapData, q);
                  }, R;
                }();
              }
              K.createMapShim = b;
              function se(J) {
                var ie = function() {
                  function R(q, O) {
                    this._data = oe(q, O);
                  }
                  return R.prototype.next = function() {
                    return f(this._data);
                  }, R;
                }();
                return function() {
                  function R(q) {
                    var O = this;
                    this._mapData = a(), G(J(q), function(ve) {
                      return O.add(ve);
                    });
                  }
                  return Object.defineProperty(R.prototype, "size", { get: function() {
                    return this._mapData.size;
                  }, enumerable: false, configurable: true }), R.prototype.add = function(q) {
                    return le(this._mapData, q, q), this;
                  }, R.prototype.has = function(q) {
                    return !!Q(this._mapData, q);
                  }, R.prototype.delete = function(q) {
                    return !!N(this._mapData, q);
                  }, R.prototype.clear = function() {
                    p(this._mapData);
                  }, R.prototype.keys = function() {
                    return new ie(this._mapData, function(q, O) {
                      return q;
                    });
                  }, R.prototype.values = function() {
                    return new ie(this._mapData, function(q, O) {
                      return O;
                    });
                  }, R.prototype.entries = function() {
                    return new ie(this._mapData, function(q, O) {
                      return [q, O];
                    });
                  }, R.prototype.forEach = function(q) {
                    m(this._mapData, q);
                  }, R;
                }();
              }
              K.createSetShim = se;
            })(T = e.ShimCollections || (e.ShimCollections = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            e.versionMajorMinor = "4.7", e.version = "4.7.2";
            var a;
            (function(B) {
              B[B.LessThan = -1] = "LessThan", B[B.EqualTo = 0] = "EqualTo", B[B.GreaterThan = 1] = "GreaterThan";
            })(a = e.Comparison || (e.Comparison = {}));
            var C;
            (function(B) {
              var E = typeof globalThis < "u" || typeof globalThis < "u" ? globalThis : typeof self < "u" ? self : void 0;
              function Q() {
                var N = E == null ? void 0 : E.Map;
                return typeof N < "u" && "entries" in N.prototype && new N([[0, 0]]).size === 1 ? N : void 0;
              }
              B.tryGetNativeMap = Q;
              function le() {
                var N = E == null ? void 0 : E.Set;
                return typeof N < "u" && "entries" in N.prototype && new N([0]).size === 1 ? N : void 0;
              }
              B.tryGetNativeSet = le;
            })(C || (C = {})), e.Map = w("Map", "tryGetNativeMap", "createMapShim"), e.Set = w("Set", "tryGetNativeSet", "createSetShim");
            function w(B, E, Q) {
              var le, N = (le = C[E]()) !== null && le !== void 0 ? le : e.ShimCollections === null || e.ShimCollections === void 0 ? void 0 : e.ShimCollections[Q](e.getIterator);
              if (N) return N;
              throw new Error("TypeScript requires an environment that provides a compatible native ".concat(B, " implementation."));
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(S) {
              if (S) {
                if (Oe(S)) return Br(S);
                if (S instanceof e.Map) return S.entries();
                if (S instanceof e.Set) return S.values();
                throw new Error("Iteration not supported.");
              }
            }
            e.getIterator = a, e.emptyArray = [], e.emptyMap = new e.Map(), e.emptySet = new e.Set();
            function C(S) {
              return S ? S.length : 0;
            }
            e.length = C;
            function w(S, Ce) {
              if (S) for (var qe = 0; qe < S.length; qe++) {
                var br = Ce(S[qe], qe);
                if (br) return br;
              }
            }
            e.forEach = w;
            function B(S, Ce) {
              if (S) for (var qe = S.length - 1; qe >= 0; qe--) {
                var br = Ce(S[qe], qe);
                if (br) return br;
              }
            }
            e.forEachRight = B;
            function E(S, Ce) {
              if (S !== void 0) for (var qe = 0; qe < S.length; qe++) {
                var br = Ce(S[qe], qe);
                if (br !== void 0) return br;
              }
            }
            e.firstDefined = E;
            function Q(S, Ce) {
              for (; ; ) {
                var qe = S.next();
                if (qe.done) return;
                var br = Ce(qe.value);
                if (br !== void 0) return br;
              }
            }
            e.firstDefinedIterator = Q;
            function le(S, Ce, qe) {
              var br = qe;
              if (S) for (var Zr = S.next(), Si = 0; !Zr.done; Zr = S.next(), Si++) br = Ce(br, Zr.value, Si);
              return br;
            }
            e.reduceLeftIterator = le;
            function N(S, Ce, qe) {
              var br = [];
              e.Debug.assertEqual(S.length, Ce.length);
              for (var Zr = 0; Zr < S.length; Zr++) br.push(qe(S[Zr], Ce[Zr], Zr));
              return br;
            }
            e.zipWith = N;
            function p(S, Ce) {
              e.Debug.assertEqual(S.length, Ce.length);
              var qe = 0;
              return { next: function() {
                return qe === S.length ? { value: void 0, done: true } : (qe++, { value: [S[qe - 1], Ce[qe - 1]], done: false });
              } };
            }
            e.zipToIterator = p;
            function m(S, Ce) {
              e.Debug.assert(S.length === Ce.length);
              for (var qe = new e.Map(), br = 0; br < S.length; ++br) qe.set(S[br], Ce[br]);
              return qe;
            }
            e.zipToMap = m;
            function G(S, Ce) {
              if (S.length <= 1) return S;
              for (var qe = [], br = 0, Zr = S.length; br < Zr; br++) br && qe.push(Ce), qe.push(S[br]);
              return qe;
            }
            e.intersperse = G;
            function oe(S, Ce) {
              if (S) {
                for (var qe = 0; qe < S.length; qe++) if (!Ce(S[qe], qe)) return false;
              }
              return true;
            }
            e.every = oe;
            function f(S, Ce) {
              for (var qe = 0; qe < S.length; qe++) {
                var br = S[qe];
                if (Ce(br, qe)) return br;
              }
            }
            e.find = f;
            function T(S, Ce) {
              for (var qe = S.length - 1; qe >= 0; qe--) {
                var br = S[qe];
                if (Ce(br, qe)) return br;
              }
            }
            e.findLast = T;
            function K(S, Ce, qe) {
              for (var br = qe || 0; br < S.length; br++) if (Ce(S[br], br)) return br;
              return -1;
            }
            e.findIndex = K;
            function b(S, Ce, qe) {
              for (var br = qe === void 0 ? S.length - 1 : qe; br >= 0; br--) if (Ce(S[br], br)) return br;
              return -1;
            }
            e.findLastIndex = b;
            function se(S, Ce) {
              for (var qe = 0; qe < S.length; qe++) {
                var br = Ce(S[qe], qe);
                if (br) return br;
              }
              return e.Debug.fail();
            }
            e.findMap = se;
            function J(S, Ce, qe) {
              if (qe === void 0 && (qe = ut), S) for (var br = 0, Zr = S; br < Zr.length; br++) {
                var Si = Zr[br];
                if (qe(Si, Ce)) return true;
              }
              return false;
            }
            e.contains = J;
            function ie(S, Ce, qe) {
              return qe === void 0 && (qe = ut), S.length === Ce.length && S.every(function(br, Zr) {
                return qe(br, Ce[Zr]);
              });
            }
            e.arraysEqual = ie;
            function R(S, Ce, qe) {
              for (var br = qe || 0; br < S.length; br++) if (J(Ce, S.charCodeAt(br))) return br;
              return -1;
            }
            e.indexOfAnyCharCode = R;
            function q(S, Ce) {
              var qe = 0;
              if (S) for (var br = 0; br < S.length; br++) {
                var Zr = S[br];
                Ce(Zr, br) && qe++;
              }
              return qe;
            }
            e.countWhere = q;
            function O(S, Ce) {
              if (S) {
                for (var qe = S.length, br = 0; br < qe && Ce(S[br]); ) br++;
                if (br < qe) {
                  var Zr = S.slice(0, br);
                  for (br++; br < qe; ) {
                    var Si = S[br];
                    Ce(Si) && Zr.push(Si), br++;
                  }
                  return Zr;
                }
              }
              return S;
            }
            e.filter = O;
            function ve(S, Ce) {
              for (var qe = 0, br = 0; br < S.length; br++) Ce(S[br], br, S) && (S[qe] = S[br], qe++);
              S.length = qe;
            }
            e.filterMutate = ve;
            function ee(S) {
              S.length = 0;
            }
            e.clear = ee;
            function he(S, Ce) {
              var qe;
              if (S) {
                qe = [];
                for (var br = 0; br < S.length; br++) qe.push(Ce(S[br], br));
              }
              return qe;
            }
            e.map = he;
            function F(S, Ce) {
              return { next: function() {
                var qe = S.next();
                return qe.done ? qe : { value: Ce(qe.value), done: false };
              } };
            }
            e.mapIterator = F;
            function x(S, Ce) {
              if (S) for (var qe = 0; qe < S.length; qe++) {
                var br = S[qe], Zr = Ce(br, qe);
                if (br !== Zr) {
                  var Si = S.slice(0, qe);
                  for (Si.push(Zr), qe++; qe < S.length; qe++) Si.push(Ce(S[qe], qe));
                  return Si;
                }
              }
              return S;
            }
            e.sameMap = x;
            function X(S) {
              for (var Ce = [], qe = 0, br = S; qe < br.length; qe++) {
                var Zr = br[qe];
                Zr && (Oe(Zr) ? Ae(Ce, Zr) : Ce.push(Zr));
              }
              return Ce;
            }
            e.flatten = X;
            function $(S, Ce) {
              var qe;
              if (S) for (var br = 0; br < S.length; br++) {
                var Zr = Ce(S[br], br);
                Zr && (Oe(Zr) ? qe = Ae(qe, Zr) : qe = we(qe, Zr));
              }
              return qe || e.emptyArray;
            }
            e.flatMap = $;
            function A(S, Ce) {
              var qe = [];
              if (S) for (var br = 0; br < S.length; br++) {
                var Zr = Ce(S[br], br);
                Zr && (Oe(Zr) ? Ae(qe, Zr) : qe.push(Zr));
              }
              return qe;
            }
            e.flatMapToMutable = A;
            function y(S, Ce) {
              var qe = S.next();
              if (qe.done) return e.emptyIterator;
              var br = Zr(qe.value);
              return { next: function() {
                for (; ; ) {
                  var Si = br.next();
                  if (!Si.done) return Si;
                  var Pi = S.next();
                  if (Pi.done) return Pi;
                  br = Zr(Pi.value);
                }
              } };
              function Zr(Si) {
                var Pi = Ce(Si);
                return Pi === void 0 ? e.emptyIterator : Oe(Pi) ? Br(Pi) : Pi;
              }
            }
            e.flatMapIterator = y;
            function V(S, Ce) {
              var qe;
              if (S) for (var br = 0; br < S.length; br++) {
                var Zr = S[br], Si = Ce(Zr, br);
                (qe || Zr !== Si || Oe(Si)) && (qe || (qe = S.slice(0, br)), Oe(Si) ? Ae(qe, Si) : qe.push(Si));
              }
              return qe || S;
            }
            e.sameFlatMap = V;
            function L(S, Ce) {
              for (var qe = [], br = 0; br < S.length; br++) {
                var Zr = Ce(S[br], br);
                if (Zr === void 0) return;
                qe.push(Zr);
              }
              return qe;
            }
            e.mapAllOrFail = L;
            function P(S, Ce) {
              var qe = [];
              if (S) for (var br = 0; br < S.length; br++) {
                var Zr = Ce(S[br], br);
                Zr !== void 0 && qe.push(Zr);
              }
              return qe;
            }
            e.mapDefined = P;
            function k(S, Ce) {
              return { next: function() {
                for (; ; ) {
                  var qe = S.next();
                  if (qe.done) return qe;
                  var br = Ce(qe.value);
                  if (br !== void 0) return { value: br, done: false };
                }
              } };
            }
            e.mapDefinedIterator = k;
            function Y(S, Ce) {
              if (!!S) {
                var qe = new e.Map();
                return S.forEach(function(br, Zr) {
                  var Si = Ce(Zr, br);
                  if (Si !== void 0) {
                    var Pi = Si[0], Qi = Si[1];
                    Pi !== void 0 && Qi !== void 0 && qe.set(Pi, Qi);
                  }
                }), qe;
              }
            }
            e.mapDefinedEntries = Y;
            function U(S, Ce) {
              if (S) {
                var qe = new e.Set();
                return S.forEach(function(br) {
                  var Zr = Ce(br);
                  Zr !== void 0 && qe.add(Zr);
                }), qe;
              }
            }
            e.mapDefinedValues = U;
            function j(S, Ce, qe) {
              if (S.has(Ce)) return S.get(Ce);
              var br = qe();
              return S.set(Ce, br), br;
            }
            e.getOrUpdate = j;
            function H(S, Ce) {
              return S.has(Ce) ? false : (S.add(Ce), true);
            }
            e.tryAddToSet = H, e.emptyIterator = { next: function() {
              return { value: void 0, done: true };
            } };
            function I(S) {
              var Ce = false;
              return { next: function() {
                var qe = Ce;
                return Ce = true, qe ? { value: void 0, done: true } : { value: S, done: false };
              } };
            }
            e.singleIterator = I;
            function l(S, Ce, qe) {
              var br;
              if (S) {
                br = [];
                for (var Zr = S.length, Si = void 0, Pi = void 0, Qi = 0, Ct = 0; Qi < Zr; ) {
                  for (; Ct < Zr; ) {
                    var sa = S[Ct];
                    if (Pi = Ce(sa, Ct), Ct === 0) Si = Pi;
                    else if (Pi !== Si) break;
                    Ct++;
                  }
                  if (Qi < Ct) {
                    var en = qe(S.slice(Qi, Ct), Si, Qi, Ct);
                    en && br.push(en), Qi = Ct;
                  }
                  Si = Pi, Ct++;
                }
              }
              return br;
            }
            e.spanMap = l;
            function d(S, Ce) {
              if (!!S) {
                var qe = new e.Map();
                return S.forEach(function(br, Zr) {
                  var Si = Ce(Zr, br), Pi = Si[0], Qi = Si[1];
                  qe.set(Pi, Qi);
                }), qe;
              }
            }
            e.mapEntries = d;
            function D(S, Ce) {
              if (S) if (Ce) for (var qe = 0, br = S; qe < br.length; qe++) {
                var Zr = br[qe];
                if (Ce(Zr)) return true;
              }
              else return S.length > 0;
              return false;
            }
            e.some = D;
            function fe(S, Ce, qe) {
              for (var br, Zr = 0; Zr < S.length; Zr++) Ce(S[Zr]) ? br = br === void 0 ? Zr : br : br !== void 0 && (qe(br, Zr), br = void 0);
              br !== void 0 && qe(br, S.length);
            }
            e.getRangesWhere = fe;
            function g(S, Ce) {
              return D(Ce) ? D(S) ? Ve(Ve([], S, true), Ce, true) : Ce : S;
            }
            e.concatenate = g;
            function ne(S, Ce) {
              return Ce;
            }
            function ue(S) {
              return S.map(ne);
            }
            e.indicesOf = ue;
            function We(S, Ce, qe) {
              var br = ue(S);
              Cr(S, br, qe);
              for (var Zr = S[br[0]], Si = [br[0]], Pi = 1; Pi < br.length; Pi++) {
                var Qi = br[Pi], Ct = S[Qi];
                Ce(Zr, Ct) || (Si.push(Qi), Zr = Ct);
              }
              return Si.sort(), Si.map(function(sa) {
                return S[sa];
              });
            }
            function Fe(S, Ce) {
              for (var qe = [], br = 0, Zr = S; br < Zr.length; br++) {
                var Si = Zr[br];
                er(qe, Si, Ce);
              }
              return qe;
            }
            function Z(S, Ce, qe) {
              return S.length === 0 ? [] : S.length === 1 ? S.slice() : qe ? We(S, Ce, qe) : Fe(S, Ce);
            }
            e.deduplicate = Z;
            function Be(S, Ce) {
              if (S.length === 0) return e.emptyArray;
              for (var qe = S[0], br = [qe], Zr = 1; Zr < S.length; Zr++) {
                var Si = S[Zr];
                switch (Ce(Si, qe)) {
                  case true:
                  case 0:
                    continue;
                  case -1:
                    return e.Debug.fail("Array is unsorted.");
                }
                br.push(qe = Si);
              }
              return br;
            }
            function ge() {
              return [];
            }
            e.createSortedArray = ge;
            function Re(S, Ce, qe, br) {
              if (S.length === 0) {
                S.push(Ce);
                return;
              }
              var Zr = ii(S, Ce, vi, qe);
              Zr < 0 ? S.splice(~Zr, 0, Ce) : br && S.splice(Zr, 0, Ce);
            }
            e.insertSorted = Re;
            function ze(S, Ce, qe) {
              return Be(Ye(S, Ce), qe || Ce || wt);
            }
            e.sortAndDeduplicate = ze;
            function Ee(S, Ce) {
              if (S.length < 2) return true;
              for (var qe = S[0], br = 0, Zr = S.slice(1); br < Zr.length; br++) {
                var Si = Zr[br];
                if (Ce(qe, Si) === 1) return false;
                qe = Si;
              }
              return true;
            }
            e.arrayIsSorted = Ee;
            function He(S, Ce, qe) {
              if (qe === void 0 && (qe = ut), !S || !Ce) return S === Ce;
              if (S.length !== Ce.length) return false;
              for (var br = 0; br < S.length; br++) if (!qe(S[br], Ce[br], br)) return false;
              return true;
            }
            e.arrayIsEqualTo = He;
            function rr(S) {
              var Ce;
              if (S) for (var qe = 0; qe < S.length; qe++) {
                var br = S[qe];
                (Ce || !br) && (Ce || (Ce = S.slice(0, qe)), br && Ce.push(br));
              }
              return Ce || S;
            }
            e.compact = rr;
            function Ie(S, Ce, qe) {
              if (!Ce || !S || Ce.length === 0 || S.length === 0) return Ce;
              var br = [];
              e: for (var Zr = 0, Si = 0; Si < Ce.length; Si++) {
                Si > 0 && e.Debug.assertGreaterThanOrEqual(qe(Ce[Si], Ce[Si - 1]), 0);
                r: for (var Pi = Zr; Zr < S.length; Zr++) switch (Zr > Pi && e.Debug.assertGreaterThanOrEqual(qe(S[Zr], S[Zr - 1]), 0), qe(Ce[Si], S[Zr])) {
                  case -1:
                    br.push(Ce[Si]);
                    continue e;
                  case 0:
                    continue e;
                  case 1:
                    continue r;
                }
              }
              return br;
            }
            e.relativeComplement = Ie;
            function _e(S, Ce) {
              for (var qe = 0, br = 0, Zr = S; br < Zr.length; br++) {
                var Si = Zr[br];
                qe += Si[Ce];
              }
              return qe;
            }
            e.sum = _e;
            function we(S, Ce) {
              return Ce === void 0 ? S : S === void 0 ? [Ce] : (S.push(Ce), S);
            }
            e.append = we;
            function de(S, Ce) {
              return S === void 0 ? Ce : Ce === void 0 ? S : Oe(S) ? Oe(Ce) ? g(S, Ce) : we(S, Ce) : Oe(Ce) ? we(Ce, S) : [S, Ce];
            }
            e.combine = de;
            function ye(S, Ce) {
              return Ce < 0 ? S.length + Ce : Ce;
            }
            function Ae(S, Ce, qe, br) {
              if (Ce === void 0 || Ce.length === 0) return S;
              if (S === void 0) return Ce.slice(qe, br);
              qe = qe === void 0 ? 0 : ye(Ce, qe), br = br === void 0 ? Ce.length : ye(Ce, br);
              for (var Zr = qe; Zr < br && Zr < Ce.length; Zr++) Ce[Zr] !== void 0 && S.push(Ce[Zr]);
              return S;
            }
            e.addRange = Ae;
            function er(S, Ce, qe) {
              return J(S, Ce, qe) ? false : (S.push(Ce), true);
            }
            e.pushIfUnique = er;
            function ir(S, Ce, qe) {
              return S ? (er(S, Ce, qe), S) : [Ce];
            }
            e.appendIfUnique = ir;
            function Cr(S, Ce, qe) {
              Ce.sort(function(br, Zr) {
                return qe(S[br], S[Zr]) || Ki(br, Zr);
              });
            }
            function Ye(S, Ce) {
              return S.length === 0 ? S : S.slice().sort(Ce);
            }
            e.sort = Ye;
            function Br(S) {
              var Ce = 0;
              return { next: function() {
                return Ce === S.length ? { value: void 0, done: true } : (Ce++, { value: S[Ce - 1], done: false });
              } };
            }
            e.arrayIterator = Br;
            function Er(S) {
              var Ce = S.length;
              return { next: function() {
                return Ce === 0 ? { value: void 0, done: true } : (Ce--, { value: S[Ce], done: false });
              } };
            }
            e.arrayReverseIterator = Er;
            function Ne(S, Ce) {
              var qe = ue(S);
              return Cr(S, qe, Ce), qe.map(function(br) {
                return S[br];
              });
            }
            e.stableSort = Ne;
            function n(S, Ce, qe, br) {
              for (; qe < br; ) {
                if (S[qe] !== Ce[qe]) return false;
                qe++;
              }
              return true;
            }
            e.rangeEquals = n;
            function lr(S, Ce) {
              if (S && (Ce = ye(S, Ce), Ce < S.length)) return S[Ce];
            }
            e.elementAt = lr;
            function be(S) {
              return S.length === 0 ? void 0 : S[0];
            }
            e.firstOrUndefined = be;
            function Ge(S) {
              return e.Debug.assert(S.length !== 0), S[0];
            }
            e.first = Ge;
            function ur(S) {
              return S.length === 0 ? void 0 : S[S.length - 1];
            }
            e.lastOrUndefined = ur;
            function yr(S) {
              return e.Debug.assert(S.length !== 0), S[S.length - 1];
            }
            e.last = yr;
            function Ir(S) {
              return S && S.length === 1 ? S[0] : void 0;
            }
            e.singleOrUndefined = Ir;
            function wr(S) {
              return S && S.length === 1 ? S[0] : S;
            }
            e.singleOrMany = wr;
            function Ur(S, Ce, qe) {
              var br = S.slice(0);
              return br[Ce] = qe, br;
            }
            e.replaceElement = Ur;
            function ii(S, Ce, qe, br, Zr) {
              return mi(S, qe(Ce), qe, br, Zr);
            }
            e.binarySearch = ii;
            function mi(S, Ce, qe, br, Zr) {
              if (!D(S)) return -1;
              for (var Si = Zr || 0, Pi = S.length - 1; Si <= Pi; ) {
                var Qi = Si + (Pi - Si >> 1), Ct = qe(S[Qi], Qi);
                switch (br(Ct, Ce)) {
                  case -1:
                    Si = Qi + 1;
                    break;
                  case 0:
                    return Qi;
                  case 1:
                    Pi = Qi - 1;
                    break;
                }
              }
              return ~Si;
            }
            e.binarySearchKey = mi;
            function pe(S, Ce, qe, br, Zr) {
              if (S && S.length > 0) {
                var Si = S.length;
                if (Si > 0) {
                  var Pi = br === void 0 || br < 0 ? 0 : br, Qi = Zr === void 0 || Pi + Zr > Si - 1 ? Si - 1 : Pi + Zr, Ct = void 0;
                  for (arguments.length <= 2 ? (Ct = S[Pi], Pi++) : Ct = qe; Pi <= Qi; ) Ct = Ce(Ct, S[Pi], Pi), Pi++;
                  return Ct;
                }
              }
              return qe;
            }
            e.reduceLeft = pe;
            var or = Object.prototype.hasOwnProperty;
            function qr(S, Ce) {
              return or.call(S, Ce);
            }
            e.hasProperty = qr;
            function si(S, Ce) {
              return or.call(S, Ce) ? S[Ce] : void 0;
            }
            e.getProperty = si;
            function Di(S) {
              var Ce = [];
              for (var qe in S) or.call(S, qe) && Ce.push(qe);
              return Ce;
            }
            e.getOwnKeys = Di;
            function wi(S) {
              var Ce = [];
              do
                for (var qe = Object.getOwnPropertyNames(S), br = 0, Zr = qe; br < Zr.length; br++) {
                  var Si = Zr[br];
                  er(Ce, Si);
                }
              while (S = Object.getPrototypeOf(S));
              return Ce;
            }
            e.getAllKeys = wi;
            function Xi(S) {
              var Ce = [];
              for (var qe in S) or.call(S, qe) && Ce.push(S[qe]);
              return Ce;
            }
            e.getOwnValues = Xi;
            var et = Object.entries || function(S) {
              for (var Ce = Di(S), qe = Array(Ce.length), br = 0; br < Ce.length; br++) qe[br] = [Ce[br], S[Ce[br]]];
              return qe;
            };
            function Gi(S) {
              return S ? et(S) : [];
            }
            e.getEntries = Gi;
            function Wt(S, Ce) {
              for (var qe = new Array(S), br = 0; br < S; br++) qe[br] = Ce(br);
              return qe;
            }
            e.arrayOf = Wt;
            function Zt(S, Ce) {
              for (var qe = [], br = S.next(); !br.done; br = S.next()) qe.push(Ce ? Ce(br.value) : br.value);
              return qe;
            }
            e.arrayFrom = Zt;
            function _r(S) {
              for (var Ce = [], qe = 1; qe < arguments.length; qe++) Ce[qe - 1] = arguments[qe];
              for (var br = 0, Zr = Ce; br < Zr.length; br++) {
                var Si = Zr[br];
                if (Si !== void 0) for (var Pi in Si) qr(Si, Pi) && (S[Pi] = Si[Pi]);
              }
              return S;
            }
            e.assign = _r;
            function pi(S, Ce, qe) {
              if (qe === void 0 && (qe = ut), S === Ce) return true;
              if (!S || !Ce) return false;
              for (var br in S) if (or.call(S, br) && (!or.call(Ce, br) || !qe(S[br], Ce[br]))) return false;
              for (var br in Ce) if (or.call(Ce, br) && !or.call(S, br)) return false;
              return true;
            }
            e.equalOwnProperties = pi;
            function ae(S, Ce, qe) {
              qe === void 0 && (qe = vi);
              for (var br = new e.Map(), Zr = 0, Si = S; Zr < Si.length; Zr++) {
                var Pi = Si[Zr], Qi = Ce(Pi);
                Qi !== void 0 && br.set(Qi, qe(Pi));
              }
              return br;
            }
            e.arrayToMap = ae;
            function Xe(S, Ce, qe) {
              qe === void 0 && (qe = vi);
              for (var br = [], Zr = 0, Si = S; Zr < Si.length; Zr++) {
                var Pi = Si[Zr];
                br[Ce(Pi)] = qe(Pi);
              }
              return br;
            }
            e.arrayToNumericMap = Xe;
            function Jr(S, Ce, qe) {
              qe === void 0 && (qe = vi);
              for (var br = Je(), Zr = 0, Si = S; Zr < Si.length; Zr++) {
                var Pi = Si[Zr];
                br.add(Ce(Pi), qe(Pi));
              }
              return br;
            }
            e.arrayToMultiMap = Jr;
            function ti(S, Ce, qe) {
              return qe === void 0 && (qe = vi), Zt(Jr(S, Ce).values(), qe);
            }
            e.group = ti;
            function Ze(S) {
              var Ce = {};
              for (var qe in S) or.call(S, qe) && (Ce[qe] = S[qe]);
              return Ce;
            }
            e.clone = Ze;
            function Sr(S, Ce) {
              var qe = {};
              for (var br in Ce) or.call(Ce, br) && (qe[br] = Ce[br]);
              for (var br in S) or.call(S, br) && (qe[br] = S[br]);
              return qe;
            }
            e.extend = Sr;
            function zr(S, Ce) {
              for (var qe in Ce) or.call(Ce, qe) && (S[qe] = Ce[qe]);
            }
            e.copyProperties = zr;
            function Wr(S, Ce) {
              return Ce ? Ce.bind(S) : void 0;
            }
            e.maybeBind = Wr;
            function Je() {
              var S = new e.Map();
              return S.add = xe, S.remove = vr, S;
            }
            e.createMultiMap = Je;
            function xe(S, Ce) {
              var qe = this.get(S);
              return qe ? qe.push(Ce) : this.set(S, qe = [Ce]), qe;
            }
            function vr(S, Ce) {
              var qe = this.get(S);
              qe && (Kn(qe, Ce), qe.length || this.delete(S));
            }
            function mr() {
              return Je();
            }
            e.createUnderscoreEscapedMultiMap = mr;
            function Ar(S, Ce) {
              var qe = new e.Map(), br = 0;
              function Zr() {
                var Pi = qe.values(), Qi;
                return { next: function() {
                  for (; ; ) if (Qi) {
                    var Ct = Qi.next();
                    if (!Ct.done) return { value: Ct.value };
                    Qi = void 0;
                  } else {
                    var Ct = Pi.next();
                    if (Ct.done) return { value: void 0, done: true };
                    if (!Oe(Ct.value)) return { value: Ct.value };
                    Qi = Br(Ct.value);
                  }
                } };
              }
              var Si = { has: function(Pi) {
                var Qi = S(Pi);
                if (!qe.has(Qi)) return false;
                var Ct = qe.get(Qi);
                if (!Oe(Ct)) return Ce(Ct, Pi);
                for (var sa = 0, en = Ct; sa < en.length; sa++) {
                  var Wa = en[sa];
                  if (Ce(Wa, Pi)) return true;
                }
                return false;
              }, add: function(Pi) {
                var Qi = S(Pi);
                if (qe.has(Qi)) {
                  var Ct = qe.get(Qi);
                  if (Oe(Ct)) J(Ct, Pi, Ce) || (Ct.push(Pi), br++);
                  else {
                    var sa = Ct;
                    Ce(sa, Pi) || (qe.set(Qi, [sa, Pi]), br++);
                  }
                } else qe.set(Qi, Pi), br++;
                return this;
              }, delete: function(Pi) {
                var Qi = S(Pi);
                if (!qe.has(Qi)) return false;
                var Ct = qe.get(Qi);
                if (Oe(Ct)) {
                  for (var sa = 0; sa < Ct.length; sa++) if (Ce(Ct[sa], Pi)) return Ct.length === 1 ? qe.delete(Qi) : Ct.length === 2 ? qe.set(Qi, Ct[1 - sa]) : xn(Ct, sa), br--, true;
                } else {
                  var en = Ct;
                  if (Ce(en, Pi)) return qe.delete(Qi), br--, true;
                }
                return false;
              }, clear: function() {
                qe.clear(), br = 0;
              }, get size() {
                return br;
              }, forEach: function(Pi) {
                for (var Qi = 0, Ct = Zt(qe.values()); Qi < Ct.length; Qi++) {
                  var sa = Ct[Qi];
                  if (Oe(sa)) for (var en = 0, Wa = sa; en < Wa.length; en++) {
                    var qn = Wa[en];
                    Pi(qn, qn);
                  }
                  else {
                    var qn = sa;
                    Pi(qn, qn);
                  }
                }
              }, keys: function() {
                return Zr();
              }, values: function() {
                return Zr();
              }, entries: function() {
                var Pi = Zr();
                return { next: function() {
                  var Qi = Pi.next();
                  return Qi.done ? Qi : { value: [Qi.value, Qi.value] };
                } };
              } };
              return Si;
            }
            e.createSet = Ar;
            function Oe(S) {
              return Array.isArray ? Array.isArray(S) : S instanceof Array;
            }
            e.isArray = Oe;
            function nr(S) {
              return Oe(S) ? S : [S];
            }
            e.toArray = nr;
            function Mr(S) {
              return typeof S == "string";
            }
            e.isString = Mr;
            function Pe(S) {
              return typeof S == "number";
            }
            e.isNumber = Pe;
            function Ue(S, Ce) {
              return S !== void 0 && Ce(S) ? S : void 0;
            }
            e.tryCast = Ue;
            function fr(S, Ce) {
              return S !== void 0 && Ce(S) ? S : e.Debug.fail("Invalid cast. The supplied value ".concat(S, " did not pass the test '").concat(e.Debug.getFunctionName(Ce), "'."));
            }
            e.cast = fr;
            function De(S) {
            }
            e.noop = De;
            function gr() {
              return false;
            }
            e.returnFalse = gr;
            function Vr() {
              return true;
            }
            e.returnTrue = Vr;
            function Tr() {
            }
            e.returnUndefined = Tr;
            function vi(S) {
              return S;
            }
            e.identity = vi;
            function Ui(S) {
              return S.toLowerCase();
            }
            e.toLowerCase = Ui;
            var Yi = /[^\u0130\u0131\u00DFa-z0-9\\/:\-_\. ]+/g;
            function Wi(S) {
              return Yi.test(S) ? S.replace(Yi, Ui) : S;
            }
            e.toFileNameLowerCase = Wi;
            function ct() {
              throw new Error("Not implemented");
            }
            e.notImplemented = ct;
            function Li(S) {
              var Ce;
              return function() {
                return S && (Ce = S(), S = void 0), Ce;
              };
            }
            e.memoize = Li;
            function nt(S) {
              var Ce = new e.Map();
              return function(qe) {
                var br = "".concat(typeof qe, ":").concat(qe), Zr = Ce.get(br);
                return Zr === void 0 && !Ce.has(br) && (Zr = S(qe), Ce.set(br, Zr)), Zr;
              };
            }
            e.memoizeOne = nt;
            function Mt(S, Ce, qe, br, Zr) {
              if (Zr) {
                for (var Si = [], Pi = 0; Pi < arguments.length; Pi++) Si[Pi] = arguments[Pi];
                return function(Qi) {
                  return pe(Si, function(Ct, sa) {
                    return sa(Ct);
                  }, Qi);
                };
              } else return br ? function(Qi) {
                return br(qe(Ce(S(Qi))));
              } : qe ? function(Qi) {
                return qe(Ce(S(Qi)));
              } : Ce ? function(Qi) {
                return Ce(S(Qi));
              } : S ? function(Qi) {
                return S(Qi);
              } : function(Qi) {
                return Qi;
              };
            }
            e.compose = Mt;
            var xt;
            (function(S) {
              S[S.None = 0] = "None", S[S.Normal = 1] = "Normal", S[S.Aggressive = 2] = "Aggressive", S[S.VeryAggressive = 3] = "VeryAggressive";
            })(xt = e.AssertionLevel || (e.AssertionLevel = {}));
            function ut(S, Ce) {
              return S === Ce;
            }
            e.equateValues = ut;
            function Dt(S, Ce) {
              return S === Ce || S !== void 0 && Ce !== void 0 && S.toUpperCase() === Ce.toUpperCase();
            }
            e.equateStringsCaseInsensitive = Dt;
            function Rt(S, Ce) {
              return ut(S, Ce);
            }
            e.equateStringsCaseSensitive = Rt;
            function Ii(S, Ce) {
              return S === Ce ? 0 : S === void 0 ? -1 : Ce === void 0 ? 1 : S < Ce ? -1 : 1;
            }
            function Ki(S, Ce) {
              return Ii(S, Ce);
            }
            e.compareValues = Ki;
            function Fi(S, Ce) {
              return Ki(S == null ? void 0 : S.start, Ce == null ? void 0 : Ce.start) || Ki(S == null ? void 0 : S.length, Ce == null ? void 0 : Ce.length);
            }
            e.compareTextSpans = Fi;
            function ui(S, Ce, qe) {
              return qe(S, Ce) === -1 ? S : Ce;
            }
            e.min = ui;
            function Bt(S, Ce) {
              return S === Ce ? 0 : S === void 0 ? -1 : Ce === void 0 ? 1 : (S = S.toUpperCase(), Ce = Ce.toUpperCase(), S < Ce ? -1 : S > Ce ? 1 : 0);
            }
            e.compareStringsCaseInsensitive = Bt;
            function wt(S, Ce) {
              return Ii(S, Ce);
            }
            e.compareStringsCaseSensitive = wt;
            function na(S) {
              return S ? Bt : wt;
            }
            e.getStringComparer = na;
            var Ai = function() {
              var S, Ce, qe = Qi();
              return Ct;
              function br(sa, en, Wa) {
                if (sa === en) return 0;
                if (sa === void 0) return -1;
                if (en === void 0) return 1;
                var qn = Wa(sa, en);
                return qn < 0 ? -1 : qn > 0 ? 1 : 0;
              }
              function Zr(sa) {
                var en = new Intl.Collator(sa, { usage: "sort", sensitivity: "variant" }).compare;
                return function(Wa, qn) {
                  return br(Wa, qn, en);
                };
              }
              function Si(sa) {
                if (sa !== void 0) return Pi();
                return function(Wa, qn) {
                  return br(Wa, qn, en);
                };
                function en(Wa, qn) {
                  return Wa.localeCompare(qn);
                }
              }
              function Pi() {
                return function(Wa, qn) {
                  return br(Wa, qn, sa);
                };
                function sa(Wa, qn) {
                  return en(Wa.toUpperCase(), qn.toUpperCase()) || en(Wa, qn);
                }
                function en(Wa, qn) {
                  return Wa < qn ? -1 : Wa > qn ? 1 : 0;
                }
              }
              function Qi() {
                return typeof Intl == "object" && typeof Intl.Collator == "function" ? Zr : typeof String.prototype.localeCompare == "function" && typeof String.prototype.toLocaleUpperCase == "function" && "a".localeCompare("B") < 0 ? Si : Pi;
              }
              function Ct(sa) {
                return sa === void 0 ? S || (S = qe(sa)) : sa === "en-US" ? Ce || (Ce = qe(sa)) : qe(sa);
              }
            }(), Oi, ji;
            function Vi() {
              return ji;
            }
            e.getUILocale = Vi;
            function at(S) {
              ji !== S && (ji = S, Oi = void 0);
            }
            e.setUILocale = at;
            function At(S, Ce) {
              var qe = Oi || (Oi = Ai(ji));
              return qe(S, Ce);
            }
            e.compareStringsCaseSensitiveUI = At;
            function ba(S, Ce, qe, br) {
              return S === Ce ? 0 : S === void 0 ? -1 : Ce === void 0 ? 1 : br(S[qe], Ce[qe]);
            }
            e.compareProperties = ba;
            function $a(S, Ce) {
              return Ki(S ? 1 : 0, Ce ? 1 : 0);
            }
            e.compareBooleans = $a;
            function Qa(S, Ce, qe) {
              for (var br = Math.min(2, Math.floor(S.length * 0.34)), Zr = Math.floor(S.length * 0.4) + 1, Si, Pi = 0, Qi = Ce; Pi < Qi.length; Pi++) {
                var Ct = Qi[Pi], sa = qe(Ct);
                if (sa !== void 0 && Math.abs(sa.length - S.length) <= br) {
                  if (sa === S || sa.length < 3 && sa.toLowerCase() !== S.toLowerCase()) continue;
                  var en = ai(S, sa, Zr - 0.1);
                  if (en === void 0) continue;
                  e.Debug.assert(en < Zr), Zr = en, Si = Ct;
                }
              }
              return Si;
            }
            e.getSpellingSuggestion = Qa;
            function ai(S, Ce, qe) {
              for (var br = new Array(Ce.length + 1), Zr = new Array(Ce.length + 1), Si = qe + 0.01, Pi = 0; Pi <= Ce.length; Pi++) br[Pi] = Pi;
              for (var Pi = 1; Pi <= S.length; Pi++) {
                var Qi = S.charCodeAt(Pi - 1), Ct = Math.ceil(Pi > qe ? Pi - qe : 1), sa = Math.floor(Ce.length > qe + Pi ? qe + Pi : Ce.length);
                Zr[0] = Pi;
                for (var en = Pi, Wa = 1; Wa < Ct; Wa++) Zr[Wa] = Si;
                for (var Wa = Ct; Wa <= sa; Wa++) {
                  var qn = S[Pi - 1].toLowerCase() === Ce[Wa - 1].toLowerCase() ? br[Wa - 1] + 0.1 : br[Wa - 1] + 2, mo = Qi === Ce.charCodeAt(Wa - 1) ? br[Wa - 1] : Math.min(br[Wa] + 1, Zr[Wa - 1] + 1, qn);
                  Zr[Wa] = mo, en = Math.min(en, mo);
                }
                for (var Wa = sa + 1; Wa <= Ce.length; Wa++) Zr[Wa] = Si;
                if (en > qe) return;
                var So = br;
                br = Zr, Zr = So;
              }
              var Go = br[Ce.length];
              return Go > qe ? void 0 : Go;
            }
            function Dn(S, Ce) {
              var qe = S.length - Ce.length;
              return qe >= 0 && S.indexOf(Ce, qe) === qe;
            }
            e.endsWith = Dn;
            function ka(S, Ce) {
              return Dn(S, Ce) ? S.slice(0, S.length - Ce.length) : S;
            }
            e.removeSuffix = ka;
            function Ba(S, Ce) {
              return Dn(S, Ce) ? S.slice(0, S.length - Ce.length) : void 0;
            }
            e.tryRemoveSuffix = Ba;
            function pn(S, Ce) {
              return S.indexOf(Ce) !== -1;
            }
            e.stringContains = pn;
            function Cn(S) {
              for (var Ce = S.length, qe = Ce - 1; qe > 0; qe--) {
                var br = S.charCodeAt(qe);
                if (br >= 48 && br <= 57) do
                  --qe, br = S.charCodeAt(qe);
                while (qe > 0 && br >= 48 && br <= 57);
                else if (qe > 4 && (br === 110 || br === 78)) {
                  if (--qe, br = S.charCodeAt(qe), br !== 105 && br !== 73 || (--qe, br = S.charCodeAt(qe), br !== 109 && br !== 77)) break;
                  --qe, br = S.charCodeAt(qe);
                } else break;
                if (br !== 45 && br !== 46) break;
                Ce = qe;
              }
              return Ce === S.length ? S : S.slice(0, Ce);
            }
            e.removeMinAndVersionNumbers = Cn;
            function Bi(S, Ce) {
              for (var qe = 0; qe < S.length; qe++) if (S[qe] === Ce) return kn(S, qe), true;
              return false;
            }
            e.orderedRemoveItem = Bi;
            function kn(S, Ce) {
              for (var qe = Ce; qe < S.length - 1; qe++) S[qe] = S[qe + 1];
              S.pop();
            }
            e.orderedRemoveItemAt = kn;
            function xn(S, Ce) {
              S[Ce] = S[S.length - 1], S.pop();
            }
            e.unorderedRemoveItemAt = xn;
            function Kn(S, Ce) {
              return Pn(S, function(qe) {
                return qe === Ce;
              });
            }
            e.unorderedRemoveItem = Kn;
            function Pn(S, Ce) {
              for (var qe = 0; qe < S.length; qe++) if (Ce(S[qe])) return xn(S, qe), true;
              return false;
            }
            function eo(S) {
              return S ? vi : Wi;
            }
            e.createGetCanonicalFileName = eo;
            function Rn(S) {
              var Ce = S.prefix, qe = S.suffix;
              return "".concat(Ce, "*").concat(qe);
            }
            e.patternText = Rn;
            function Da(S, Ce) {
              return e.Debug.assert(to(S, Ce)), Ce.substring(S.prefix.length, Ce.length - S.suffix.length);
            }
            e.matchedText = Da;
            function bo(S, Ce, qe) {
              for (var br, Zr = -1, Si = 0, Pi = S; Si < Pi.length; Si++) {
                var Qi = Pi[Si], Ct = Ce(Qi);
                to(Ct, qe) && Ct.prefix.length > Zr && (Zr = Ct.prefix.length, br = Qi);
              }
              return br;
            }
            e.findBestPatternMatch = bo;
            function Ro(S, Ce) {
              return S.lastIndexOf(Ce, 0) === 0;
            }
            e.startsWith = Ro;
            function En(S, Ce) {
              return Ro(S, Ce) ? S.substr(Ce.length) : S;
            }
            e.removePrefix = En;
            function Wn(S, Ce, qe) {
              return qe === void 0 && (qe = vi), Ro(qe(S), qe(Ce)) ? S.substring(Ce.length) : void 0;
            }
            e.tryRemovePrefix = Wn;
            function to(S, Ce) {
              var qe = S.prefix, br = S.suffix;
              return Ce.length >= qe.length + br.length && Ro(Ce, qe) && Dn(Ce, br);
            }
            function Co(S, Ce) {
              return function(qe) {
                return S(qe) && Ce(qe);
              };
            }
            e.and = Co;
            function Ko() {
              for (var S = [], Ce = 0; Ce < arguments.length; Ce++) S[Ce] = arguments[Ce];
              return function() {
                for (var qe = [], br = 0; br < arguments.length; br++) qe[br] = arguments[br];
                for (var Zr, Si = 0, Pi = S; Si < Pi.length; Si++) {
                  var Qi = Pi[Si];
                  if (Zr = Qi.apply(void 0, qe), Zr) return Zr;
                }
                return Zr;
              };
            }
            e.or = Ko;
            function Oo(S) {
              return function() {
                for (var Ce = [], qe = 0; qe < arguments.length; qe++) Ce[qe] = arguments[qe];
                return !S.apply(void 0, Ce);
              };
            }
            e.not = Oo;
            function no(S) {
            }
            e.assertType = no;
            function $o(S) {
              return S === void 0 ? void 0 : [S];
            }
            e.singleElementArray = $o;
            function Pr(S, Ce, qe, br, Zr, Si) {
              Si = Si || De;
              for (var Pi = 0, Qi = 0, Ct = S.length, sa = Ce.length, en = false; Pi < Ct && Qi < sa; ) {
                var Wa = S[Pi], qn = Ce[Qi], mo = qe(Wa, qn);
                mo === -1 ? (br(Wa), Pi++, en = true) : mo === 1 ? (Zr(qn), Qi++, en = true) : (Si(qn, Wa), Pi++, Qi++);
              }
              for (; Pi < Ct; ) br(S[Pi++]), en = true;
              for (; Qi < sa; ) Zr(Ce[Qi++]), en = true;
              return en;
            }
            e.enumerateInsertsAndDeletes = Pr;
            function xi(S, Ce) {
              for (var qe = Array(S), br = 0; br < S; br++) qe[br] = Ce(br);
              return qe;
            }
            e.fill = xi;
            function St(S) {
              var Ce = [];
              return pa(S, Ce, void 0, 0), Ce;
            }
            e.cartesianProduct = St;
            function pa(S, Ce, qe, br) {
              for (var Zr = 0, Si = S[br]; Zr < Si.length; Zr++) {
                var Pi = Si[Zr], Qi = void 0;
                qe ? (Qi = qe.slice(), Qi.push(Pi)) : Qi = [Pi], br === S.length - 1 ? Ce.push(Qi) : pa(S, Ce, Qi, br + 1);
              }
            }
            function dn(S, Ce, qe) {
              return qe === void 0 && (qe = " "), Ce <= S.length ? S : qe.repeat(Ce - S.length) + S;
            }
            e.padLeft = dn;
            function Jn(S, Ce, qe) {
              return qe === void 0 && (qe = " "), Ce <= S.length ? S : S + qe.repeat(Ce - S.length);
            }
            e.padRight = Jn;
            function Qe(S, Ce) {
              for (var qe = S.length, br = 0; br < qe && Ce(S[br]); ) br++;
              return S.slice(0, br);
            }
            e.takeWhile = Qe, e.trimString = String.prototype.trim ? function(S) {
              return S.trim();
            } : function(S) {
              return e.trimStringEnd(e.trimStringStart(S));
            }, e.trimStringEnd = String.prototype.trimEnd ? function(S) {
              return S.trimEnd();
            } : Gr, e.trimStringStart = String.prototype.trimStart ? function(S) {
              return S.trimStart();
            } : function(S) {
              return S.replace(/^\s+/g, "");
            };
            function Gr(S) {
              for (var Ce = S.length - 1; Ce >= 0 && e.isWhiteSpaceLike(S.charCodeAt(Ce)); ) Ce--;
              return S.slice(0, Ce + 1);
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(w) {
              w[w.Off = 0] = "Off", w[w.Error = 1] = "Error", w[w.Warning = 2] = "Warning", w[w.Info = 3] = "Info", w[w.Verbose = 4] = "Verbose";
            })(a = e.LogLevel || (e.LogLevel = {}));
            var C;
            (function(w) {
              var B, E = 0;
              w.currentLogLevel = a.Warning, w.isDebugging = false;
              function Q() {
                return B != null ? B : B = new e.Version(e.version);
              }
              w.getTypeScriptVersion = Q;
              function le(Ye) {
                return w.currentLogLevel <= Ye;
              }
              w.shouldLog = le;
              function N(Ye, Br) {
                w.loggingHost && le(Ye) && w.loggingHost.log(Ye, Br);
              }
              function p(Ye) {
                N(a.Info, Ye);
              }
              w.log = p, function(Ye) {
                function Br(lr) {
                  N(a.Error, lr);
                }
                Ye.error = Br;
                function Er(lr) {
                  N(a.Warning, lr);
                }
                Ye.warn = Er;
                function Ne(lr) {
                  N(a.Info, lr);
                }
                Ye.log = Ne;
                function n(lr) {
                  N(a.Verbose, lr);
                }
                Ye.trace = n;
              }(p = w.log || (w.log = {}));
              var m = {};
              function G() {
                return E;
              }
              w.getAssertionLevel = G;
              function oe(Ye) {
                var Br = E;
                if (E = Ye, Ye > Br) for (var Er = 0, Ne = e.getOwnKeys(m); Er < Ne.length; Er++) {
                  var n = Ne[Er], lr = m[n];
                  lr !== void 0 && w[n] !== lr.assertion && Ye >= lr.level && (w[n] = lr, m[n] = void 0);
                }
              }
              w.setAssertionLevel = oe;
              function f(Ye) {
                return E >= Ye;
              }
              w.shouldAssert = f;
              function T(Ye, Br) {
                return f(Ye) ? true : (m[Br] = { level: Ye, assertion: w[Br] }, w[Br] = e.noop, false);
              }
              function K(Ye, Br) {
                debugger;
                var Er = new Error(Ye ? "Debug Failure. ".concat(Ye) : "Debug Failure.");
                throw Error.captureStackTrace && Error.captureStackTrace(Er, Br || K), Er;
              }
              w.fail = K;
              function b(Ye, Br, Er) {
                return K("".concat(Br || "Unexpected node.", `\r
Node `).concat(j(Ye.kind), " was unexpected."), Er || b);
              }
              w.failBadSyntaxKind = b;
              function se(Ye, Br, Er, Ne) {
                Ye || (Br = Br ? "False expression: ".concat(Br) : "False expression.", Er && (Br += `\r
Verbose Debug Information: ` + (typeof Er == "string" ? Er : Er())), K(Br, Ne || se));
              }
              w.assert = se;
              function J(Ye, Br, Er, Ne, n) {
                if (Ye !== Br) {
                  var lr = Er ? Ne ? "".concat(Er, " ").concat(Ne) : Er : "";
                  K("Expected ".concat(Ye, " === ").concat(Br, ". ").concat(lr), n || J);
                }
              }
              w.assertEqual = J;
              function ie(Ye, Br, Er, Ne) {
                Ye >= Br && K("Expected ".concat(Ye, " < ").concat(Br, ". ").concat(Er || ""), Ne || ie);
              }
              w.assertLessThan = ie;
              function R(Ye, Br, Er) {
                Ye > Br && K("Expected ".concat(Ye, " <= ").concat(Br), Er || R);
              }
              w.assertLessThanOrEqual = R;
              function q(Ye, Br, Er) {
                Ye < Br && K("Expected ".concat(Ye, " >= ").concat(Br), Er || q);
              }
              w.assertGreaterThanOrEqual = q;
              function O(Ye, Br, Er) {
                Ye == null && K(Br, Er || O);
              }
              w.assertIsDefined = O;
              function ve(Ye, Br, Er) {
                return O(Ye, Br, Er || ve), Ye;
              }
              w.checkDefined = ve;
              function ee(Ye, Br, Er) {
                for (var Ne = 0, n = Ye; Ne < n.length; Ne++) {
                  var lr = n[Ne];
                  O(lr, Br, Er || ee);
                }
              }
              w.assertEachIsDefined = ee;
              function he(Ye, Br, Er) {
                return ee(Ye, Br, Er || he), Ye;
              }
              w.checkEachDefined = he;
              function F(Ye, Br, Er) {
                Br === void 0 && (Br = "Illegal value:");
                var Ne = typeof Ye == "object" && e.hasProperty(Ye, "kind") && e.hasProperty(Ye, "pos") ? "SyntaxKind: " + j(Ye.kind) : JSON.stringify(Ye);
                return K("".concat(Br, " ").concat(Ne), Er || F);
              }
              w.assertNever = F;
              function x(Ye, Br, Er, Ne) {
                T(1, "assertEachNode") && se(Br === void 0 || e.every(Ye, Br), Er || "Unexpected node.", function() {
                  return "Node array did not pass test '".concat(P(Br), "'.");
                }, Ne || x);
              }
              w.assertEachNode = x;
              function X(Ye, Br, Er, Ne) {
                T(1, "assertNode") && se(Ye !== void 0 && (Br === void 0 || Br(Ye)), Er || "Unexpected node.", function() {
                  return "Node ".concat(j(Ye == null ? void 0 : Ye.kind), " did not pass test '").concat(P(Br), "'.");
                }, Ne || X);
              }
              w.assertNode = X;
              function $(Ye, Br, Er, Ne) {
                T(1, "assertNotNode") && se(Ye === void 0 || Br === void 0 || !Br(Ye), Er || "Unexpected node.", function() {
                  return "Node ".concat(j(Ye.kind), " should not have passed test '").concat(P(Br), "'.");
                }, Ne || $);
              }
              w.assertNotNode = $;
              function A(Ye, Br, Er, Ne) {
                T(1, "assertOptionalNode") && se(Br === void 0 || Ye === void 0 || Br(Ye), Er || "Unexpected node.", function() {
                  return "Node ".concat(j(Ye == null ? void 0 : Ye.kind), " did not pass test '").concat(P(Br), "'.");
                }, Ne || A);
              }
              w.assertOptionalNode = A;
              function y(Ye, Br, Er, Ne) {
                T(1, "assertOptionalToken") && se(Br === void 0 || Ye === void 0 || Ye.kind === Br, Er || "Unexpected node.", function() {
                  return "Node ".concat(j(Ye == null ? void 0 : Ye.kind), " was not a '").concat(j(Br), "' token.");
                }, Ne || y);
              }
              w.assertOptionalToken = y;
              function V(Ye, Br, Er) {
                T(1, "assertMissingNode") && se(Ye === void 0, Br || "Unexpected node.", function() {
                  return "Node ".concat(j(Ye.kind), " was unexpected'.");
                }, Er || V);
              }
              w.assertMissingNode = V;
              function L(Ye) {
              }
              w.type = L;
              function P(Ye) {
                if (typeof Ye != "function") return "";
                if (Ye.hasOwnProperty("name")) return Ye.name;
                var Br = Function.prototype.toString.call(Ye), Er = /^function\s+([\w\$]+)\s*\(/.exec(Br);
                return Er ? Er[1] : "";
              }
              w.getFunctionName = P;
              function k(Ye) {
                return "{ name: ".concat(e.unescapeLeadingUnderscores(Ye.escapedName), "; flags: ").concat(fe(Ye.flags), "; declarations: ").concat(e.map(Ye.declarations, function(Br) {
                  return j(Br.kind);
                }), " }");
              }
              w.formatSymbol = k;
              function Y(Ye, Br, Er) {
                Ye === void 0 && (Ye = 0);
                var Ne = U(Br);
                if (Ye === 0) return Ne.length > 0 && Ne[0][0] === 0 ? Ne[0][1] : "0";
                if (Er) {
                  for (var n = "", lr = Ye, be = 0, Ge = Ne; be < Ge.length; be++) {
                    var ur = Ge[be], yr = ur[0], Ir = ur[1];
                    if (yr > Ye) break;
                    yr !== 0 && yr & Ye && (n = "".concat(n).concat(n ? "|" : "").concat(Ir), lr &= ~yr);
                  }
                  if (lr === 0) return n;
                } else for (var wr = 0, Ur = Ne; wr < Ur.length; wr++) {
                  var ii = Ur[wr], yr = ii[0], Ir = ii[1];
                  if (yr === Ye) return Ir;
                }
                return Ye.toString();
              }
              w.formatEnum = Y;
              function U(Ye) {
                var Br = [];
                for (var Er in Ye) {
                  var Ne = Ye[Er];
                  typeof Ne == "number" && Br.push([Ne, Er]);
                }
                return e.stableSort(Br, function(n, lr) {
                  return e.compareValues(n[0], lr[0]);
                });
              }
              function j(Ye) {
                return Y(Ye, e.SyntaxKind, false);
              }
              w.formatSyntaxKind = j;
              function H(Ye) {
                return Y(Ye, e.SnippetKind, false);
              }
              w.formatSnippetKind = H;
              function I(Ye) {
                return Y(Ye, e.NodeFlags, true);
              }
              w.formatNodeFlags = I;
              function l(Ye) {
                return Y(Ye, e.ModifierFlags, true);
              }
              w.formatModifierFlags = l;
              function d(Ye) {
                return Y(Ye, e.TransformFlags, true);
              }
              w.formatTransformFlags = d;
              function D(Ye) {
                return Y(Ye, e.EmitFlags, true);
              }
              w.formatEmitFlags = D;
              function fe(Ye) {
                return Y(Ye, e.SymbolFlags, true);
              }
              w.formatSymbolFlags = fe;
              function g(Ye) {
                return Y(Ye, e.TypeFlags, true);
              }
              w.formatTypeFlags = g;
              function ne(Ye) {
                return Y(Ye, e.SignatureFlags, true);
              }
              w.formatSignatureFlags = ne;
              function ue(Ye) {
                return Y(Ye, e.ObjectFlags, true);
              }
              w.formatObjectFlags = ue;
              function We(Ye) {
                return Y(Ye, e.FlowFlags, true);
              }
              w.formatFlowFlags = We;
              var Fe = false, Z;
              function Be() {
                if (we(), !Z) throw new Error("Debugging helpers could not be loaded.");
                return Z;
              }
              function ge(Ye) {
                return console.log(Re(Ye));
              }
              w.printControlFlowGraph = ge;
              function Re(Ye) {
                return Be().formatControlFlowGraph(Ye);
              }
              w.formatControlFlowGraph = Re;
              var ze;
              function Ee(Ye) {
                "__debugFlowFlags" in Ye || Object.defineProperties(Ye, { __tsDebuggerDisplay: { value: function() {
                  var Br = this.flags & 2 ? "FlowStart" : this.flags & 4 ? "FlowBranchLabel" : this.flags & 8 ? "FlowLoopLabel" : this.flags & 16 ? "FlowAssignment" : this.flags & 32 ? "FlowTrueCondition" : this.flags & 64 ? "FlowFalseCondition" : this.flags & 128 ? "FlowSwitchClause" : this.flags & 256 ? "FlowArrayMutation" : this.flags & 512 ? "FlowCall" : this.flags & 1024 ? "FlowReduceLabel" : this.flags & 1 ? "FlowUnreachable" : "UnknownFlow", Er = this.flags & ~(2048 - 1);
                  return "".concat(Br).concat(Er ? " (".concat(We(Er), ")") : "");
                } }, __debugFlowFlags: { get: function() {
                  return Y(this.flags, e.FlowFlags, true);
                } }, __debugToString: { value: function() {
                  return Re(this);
                } } });
              }
              function He(Ye) {
                Fe && (typeof Object.setPrototypeOf == "function" ? (ze || (ze = Object.create(Object.prototype), Ee(ze)), Object.setPrototypeOf(Ye, ze)) : Ee(Ye));
              }
              w.attachFlowNodeDebugInfo = He;
              var rr;
              function Ie(Ye) {
                "__tsDebuggerDisplay" in Ye || Object.defineProperties(Ye, { __tsDebuggerDisplay: { value: function(Br) {
                  return Br = String(Br).replace(/(?:,[\s\w\d_]+:[^,]+)+\]$/, "]"), "NodeArray ".concat(Br);
                } } });
              }
              function _e(Ye) {
                Fe && (typeof Object.setPrototypeOf == "function" ? (rr || (rr = Object.create(Array.prototype), Ie(rr)), Object.setPrototypeOf(Ye, rr)) : Ie(Ye));
              }
              w.attachNodeArrayDebugInfo = _e;
              function we() {
                if (Fe) return;
                var Ye, Br;
                function Er() {
                  return Ye === void 0 && typeof WeakMap == "function" && (Ye = /* @__PURE__ */ new WeakMap()), Ye;
                }
                function Ne() {
                  return Br === void 0 && typeof WeakMap == "function" && (Br = /* @__PURE__ */ new WeakMap()), Br;
                }
                Object.defineProperties(e.objectAllocator.getSymbolConstructor().prototype, { __tsDebuggerDisplay: { value: function() {
                  var Ir = this.flags & 33554432 ? "TransientSymbol" : "Symbol", wr = this.flags & -33554433;
                  return "".concat(Ir, " '").concat(e.symbolName(this), "'").concat(wr ? " (".concat(fe(wr), ")") : "");
                } }, __debugFlags: { get: function() {
                  return fe(this.flags);
                } } }), Object.defineProperties(e.objectAllocator.getTypeConstructor().prototype, { __tsDebuggerDisplay: { value: function() {
                  var Ir = this.flags & 98304 ? "NullableType" : this.flags & 384 ? "LiteralType ".concat(JSON.stringify(this.value)) : this.flags & 2048 ? "LiteralType ".concat(this.value.negative ? "-" : "").concat(this.value.base10Value, "n") : this.flags & 8192 ? "UniqueESSymbolType" : this.flags & 32 ? "EnumType" : this.flags & 67359327 ? "IntrinsicType ".concat(this.intrinsicName) : this.flags & 1048576 ? "UnionType" : this.flags & 2097152 ? "IntersectionType" : this.flags & 4194304 ? "IndexType" : this.flags & 8388608 ? "IndexedAccessType" : this.flags & 16777216 ? "ConditionalType" : this.flags & 33554432 ? "SubstitutionType" : this.flags & 262144 ? "TypeParameter" : this.flags & 524288 ? this.objectFlags & 3 ? "InterfaceType" : this.objectFlags & 4 ? "TypeReference" : this.objectFlags & 8 ? "TupleType" : this.objectFlags & 16 ? "AnonymousType" : this.objectFlags & 32 ? "MappedType" : this.objectFlags & 1024 ? "ReverseMappedType" : this.objectFlags & 256 ? "EvolvingArrayType" : "ObjectType" : "Type", wr = this.flags & 524288 ? this.objectFlags & -1344 : 0;
                  return "".concat(Ir).concat(this.symbol ? " '".concat(e.symbolName(this.symbol), "'") : "").concat(wr ? " (".concat(ue(wr), ")") : "");
                } }, __debugFlags: { get: function() {
                  return g(this.flags);
                } }, __debugObjectFlags: { get: function() {
                  return this.flags & 524288 ? ue(this.objectFlags) : "";
                } }, __debugTypeToString: { value: function() {
                  var Ir = Er(), wr = Ir == null ? void 0 : Ir.get(this);
                  return wr === void 0 && (wr = this.checker.typeToString(this), Ir == null || Ir.set(this, wr)), wr;
                } } }), Object.defineProperties(e.objectAllocator.getSignatureConstructor().prototype, { __debugFlags: { get: function() {
                  return ne(this.flags);
                } }, __debugSignatureToString: { value: function() {
                  var Ir;
                  return (Ir = this.checker) === null || Ir === void 0 ? void 0 : Ir.signatureToString(this);
                } } });
                for (var n = [e.objectAllocator.getNodeConstructor(), e.objectAllocator.getIdentifierConstructor(), e.objectAllocator.getTokenConstructor(), e.objectAllocator.getSourceFileConstructor()], lr = 0, be = n; lr < be.length; lr++) {
                  var Ge = be[lr];
                  Ge.prototype.hasOwnProperty("__debugKind") || Object.defineProperties(Ge.prototype, { __tsDebuggerDisplay: { value: function() {
                    var Ir = e.isGeneratedIdentifier(this) ? "GeneratedIdentifier" : e.isIdentifier(this) ? "Identifier '".concat(e.idText(this), "'") : e.isPrivateIdentifier(this) ? "PrivateIdentifier '".concat(e.idText(this), "'") : e.isStringLiteral(this) ? "StringLiteral ".concat(JSON.stringify(this.text.length < 10 ? this.text : this.text.slice(10) + "...")) : e.isNumericLiteral(this) ? "NumericLiteral ".concat(this.text) : e.isBigIntLiteral(this) ? "BigIntLiteral ".concat(this.text, "n") : e.isTypeParameterDeclaration(this) ? "TypeParameterDeclaration" : e.isParameter(this) ? "ParameterDeclaration" : e.isConstructorDeclaration(this) ? "ConstructorDeclaration" : e.isGetAccessorDeclaration(this) ? "GetAccessorDeclaration" : e.isSetAccessorDeclaration(this) ? "SetAccessorDeclaration" : e.isCallSignatureDeclaration(this) ? "CallSignatureDeclaration" : e.isConstructSignatureDeclaration(this) ? "ConstructSignatureDeclaration" : e.isIndexSignatureDeclaration(this) ? "IndexSignatureDeclaration" : e.isTypePredicateNode(this) ? "TypePredicateNode" : e.isTypeReferenceNode(this) ? "TypeReferenceNode" : e.isFunctionTypeNode(this) ? "FunctionTypeNode" : e.isConstructorTypeNode(this) ? "ConstructorTypeNode" : e.isTypeQueryNode(this) ? "TypeQueryNode" : e.isTypeLiteralNode(this) ? "TypeLiteralNode" : e.isArrayTypeNode(this) ? "ArrayTypeNode" : e.isTupleTypeNode(this) ? "TupleTypeNode" : e.isOptionalTypeNode(this) ? "OptionalTypeNode" : e.isRestTypeNode(this) ? "RestTypeNode" : e.isUnionTypeNode(this) ? "UnionTypeNode" : e.isIntersectionTypeNode(this) ? "IntersectionTypeNode" : e.isConditionalTypeNode(this) ? "ConditionalTypeNode" : e.isInferTypeNode(this) ? "InferTypeNode" : e.isParenthesizedTypeNode(this) ? "ParenthesizedTypeNode" : e.isThisTypeNode(this) ? "ThisTypeNode" : e.isTypeOperatorNode(this) ? "TypeOperatorNode" : e.isIndexedAccessTypeNode(this) ? "IndexedAccessTypeNode" : e.isMappedTypeNode(this) ? "MappedTypeNode" : e.isLiteralTypeNode(this) ? "LiteralTypeNode" : e.isNamedTupleMember(this) ? "NamedTupleMember" : e.isImportTypeNode(this) ? "ImportTypeNode" : j(this.kind);
                    return "".concat(Ir).concat(this.flags ? " (".concat(I(this.flags), ")") : "");
                  } }, __debugKind: { get: function() {
                    return j(this.kind);
                  } }, __debugNodeFlags: { get: function() {
                    return I(this.flags);
                  } }, __debugModifierFlags: { get: function() {
                    return l(e.getEffectiveModifierFlagsNoCache(this));
                  } }, __debugTransformFlags: { get: function() {
                    return d(this.transformFlags);
                  } }, __debugIsParseTreeNode: { get: function() {
                    return e.isParseTreeNode(this);
                  } }, __debugEmitFlags: { get: function() {
                    return D(e.getEmitFlags(this));
                  } }, __debugGetText: { value: function(Ir) {
                    if (e.nodeIsSynthesized(this)) return "";
                    var wr = Ne(), Ur = wr == null ? void 0 : wr.get(this);
                    if (Ur === void 0) {
                      var ii = e.getParseTreeNode(this), mi = ii && e.getSourceFileOfNode(ii);
                      Ur = mi ? e.getSourceTextOfNodeFromSourceFile(mi, ii, Ir) : "", wr == null || wr.set(this, Ur);
                    }
                    return Ur;
                  } } });
                }
                try {
                  if (false) var ur, yr;
                } catch {
                }
                Fe = true;
              }
              w.enableDebugInfo = we;
              function de(Ye, Br, Er, Ne, n) {
                var lr = Br ? "DeprecationError: " : "DeprecationWarning: ";
                return lr += "'".concat(Ye, "' "), lr += Ne ? "has been deprecated since v".concat(Ne) : "is deprecated", lr += Br ? " and can no longer be used." : Er ? " and will no longer be usable after v".concat(Er, ".") : ".", lr += n ? " ".concat(e.formatStringFromArgs(n, [Ye], 0)) : "", lr;
              }
              function ye(Ye, Br, Er, Ne) {
                var n = de(Ye, true, Br, Er, Ne);
                return function() {
                  throw new TypeError(n);
                };
              }
              function Ae(Ye, Br, Er, Ne) {
                var n = false;
                return function() {
                  n || (p.warn(de(Ye, false, Br, Er, Ne)), n = true);
                };
              }
              function er(Ye, Br) {
                var Er, Ne;
                Br === void 0 && (Br = {});
                var n = typeof Br.typeScriptVersion == "string" ? new e.Version(Br.typeScriptVersion) : (Er = Br.typeScriptVersion) !== null && Er !== void 0 ? Er : Q(), lr = typeof Br.errorAfter == "string" ? new e.Version(Br.errorAfter) : Br.errorAfter, be = typeof Br.warnAfter == "string" ? new e.Version(Br.warnAfter) : Br.warnAfter, Ge = typeof Br.since == "string" ? new e.Version(Br.since) : (Ne = Br.since) !== null && Ne !== void 0 ? Ne : be, ur = Br.error || lr && n.compareTo(lr) <= 0, yr = !be || n.compareTo(be) >= 0;
                return ur ? ye(Ye, lr, Ge, Br.message) : yr ? Ae(Ye, lr, Ge, Br.message) : e.noop;
              }
              function ir(Ye, Br) {
                return function() {
                  return Ye(), Br.apply(this, arguments);
                };
              }
              function Cr(Ye, Br) {
                var Er = er(P(Ye), Br);
                return ir(Er, Ye);
              }
              w.deprecate = Cr;
            })(C = e.Debug || (e.Debug = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a = /^(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:\-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i, C = /^(?:0|[1-9]\d*|[a-z-][a-z0-9-]*)(?:\.(?:0|[1-9]\d*|[a-z-][a-z0-9-]*))*$/i, w = /^[a-z0-9-]+(?:\.[a-z0-9-]+)*$/i, B = /^(0|[1-9]\d*)$/, E = function() {
              function F(x, X, $, A, y) {
                if (X === void 0 && (X = 0), $ === void 0 && ($ = 0), A === void 0 && (A = ""), y === void 0 && (y = ""), typeof x == "string") {
                  var V = e.Debug.checkDefined(Q(x), "Invalid version");
                  x = V.major, X = V.minor, $ = V.patch, A = V.prerelease, y = V.build;
                }
                e.Debug.assert(x >= 0, "Invalid argument: major"), e.Debug.assert(X >= 0, "Invalid argument: minor"), e.Debug.assert($ >= 0, "Invalid argument: patch"), e.Debug.assert(!A || C.test(A), "Invalid argument: prerelease"), e.Debug.assert(!y || w.test(y), "Invalid argument: build"), this.major = x, this.minor = X, this.patch = $, this.prerelease = A ? A.split(".") : e.emptyArray, this.build = y ? y.split(".") : e.emptyArray;
              }
              return F.tryParse = function(x) {
                var X = Q(x);
                if (!!X) {
                  var $ = X.major, A = X.minor, y = X.patch, V = X.prerelease, L = X.build;
                  return new F($, A, y, V, L);
                }
              }, F.prototype.compareTo = function(x) {
                return this === x ? 0 : x === void 0 ? 1 : e.compareValues(this.major, x.major) || e.compareValues(this.minor, x.minor) || e.compareValues(this.patch, x.patch) || le(this.prerelease, x.prerelease);
              }, F.prototype.increment = function(x) {
                switch (x) {
                  case "major":
                    return new F(this.major + 1, 0, 0);
                  case "minor":
                    return new F(this.major, this.minor + 1, 0);
                  case "patch":
                    return new F(this.major, this.minor, this.patch + 1);
                  default:
                    return e.Debug.assertNever(x);
                }
              }, F.prototype.toString = function() {
                var x = "".concat(this.major, ".").concat(this.minor, ".").concat(this.patch);
                return e.some(this.prerelease) && (x += "-".concat(this.prerelease.join("."))), e.some(this.build) && (x += "+".concat(this.build.join("."))), x;
              }, F.zero = new F(0, 0, 0), F;
            }();
            e.Version = E;
            function Q(F) {
              var x = a.exec(F);
              if (!!x) {
                var X = x[1], $ = x[2], A = $ === void 0 ? "0" : $, y = x[3], V = y === void 0 ? "0" : y, L = x[4], P = L === void 0 ? "" : L, k = x[5], Y = k === void 0 ? "" : k;
                if (!(P && !C.test(P)) && !(Y && !w.test(Y))) return { major: parseInt(X, 10), minor: parseInt(A, 10), patch: parseInt(V, 10), prerelease: P, build: Y };
              }
            }
            function le(F, x) {
              if (F === x) return 0;
              if (F.length === 0) return x.length === 0 ? 0 : 1;
              if (x.length === 0) return -1;
              for (var X = Math.min(F.length, x.length), $ = 0; $ < X; $++) {
                var A = F[$], y = x[$];
                if (A !== y) {
                  var V = B.test(A), L = B.test(y);
                  if (V || L) {
                    if (V !== L) return V ? -1 : 1;
                    var P = e.compareValues(+A, +y);
                    if (P) return P;
                  } else {
                    var P = e.compareStringsCaseSensitive(A, y);
                    if (P) return P;
                  }
                }
              }
              return e.compareValues(F.length, x.length);
            }
            var N = function() {
              function F(x) {
                this._alternatives = x ? e.Debug.checkDefined(T(x), "Invalid range spec.") : e.emptyArray;
              }
              return F.tryParse = function(x) {
                var X = T(x);
                if (X) {
                  var $ = new F("");
                  return $._alternatives = X, $;
                }
              }, F.prototype.test = function(x) {
                return typeof x == "string" && (x = new E(x)), R(x, this._alternatives);
              }, F.prototype.toString = function() {
                return ve(this._alternatives);
              }, F;
            }();
            e.VersionRange = N;
            var p = /\|\|/g, m = /\s+/g, G = /^([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i, oe = /^\s*([a-z0-9-+.*]+)\s+-\s+([a-z0-9-+.*]+)\s*$/i, f = /^(~|\^|<|<=|>|>=|=)?\s*([a-z0-9-+.*]+)$/i;
            function T(F) {
              for (var x = [], X = 0, $ = e.trimString(F).split(p); X < $.length; X++) {
                var A = $[X];
                if (!!A) {
                  var y = [];
                  A = e.trimString(A);
                  var V = oe.exec(A);
                  if (V) {
                    if (!b(V[1], V[2], y)) return;
                  } else for (var L = 0, P = A.split(m); L < P.length; L++) {
                    var k = P[L], Y = f.exec(e.trimString(k));
                    if (!Y || !se(Y[1], Y[2], y)) return;
                  }
                  x.push(y);
                }
              }
              return x;
            }
            function K(F) {
              var x = G.exec(F);
              if (!!x) {
                var X = x[1], $ = x[2], A = $ === void 0 ? "*" : $, y = x[3], V = y === void 0 ? "*" : y, L = x[4], P = x[5], k = new E(J(X) ? 0 : parseInt(X, 10), J(X) || J(A) ? 0 : parseInt(A, 10), J(X) || J(A) || J(V) ? 0 : parseInt(V, 10), L, P);
                return { version: k, major: X, minor: A, patch: V };
              }
            }
            function b(F, x, X) {
              var $ = K(F);
              if (!$) return false;
              var A = K(x);
              return A ? (J($.major) || X.push(ie(">=", $.version)), J(A.major) || X.push(J(A.minor) ? ie("<", A.version.increment("major")) : J(A.patch) ? ie("<", A.version.increment("minor")) : ie("<=", A.version)), true) : false;
            }
            function se(F, x, X) {
              var $ = K(x);
              if (!$) return false;
              var A = $.version, y = $.major, V = $.minor, L = $.patch;
              if (J(y)) (F === "<" || F === ">") && X.push(ie("<", E.zero));
              else switch (F) {
                case "~":
                  X.push(ie(">=", A)), X.push(ie("<", A.increment(J(V) ? "major" : "minor")));
                  break;
                case "^":
                  X.push(ie(">=", A)), X.push(ie("<", A.increment(A.major > 0 || J(V) ? "major" : A.minor > 0 || J(L) ? "minor" : "patch")));
                  break;
                case "<":
                case ">=":
                  X.push(ie(F, A));
                  break;
                case "<=":
                case ">":
                  X.push(J(V) ? ie(F === "<=" ? "<" : ">=", A.increment("major")) : J(L) ? ie(F === "<=" ? "<" : ">=", A.increment("minor")) : ie(F, A));
                  break;
                case "=":
                case void 0:
                  J(V) || J(L) ? (X.push(ie(">=", A)), X.push(ie("<", A.increment(J(V) ? "major" : "minor")))) : X.push(ie("=", A));
                  break;
                default:
                  return false;
              }
              return true;
            }
            function J(F) {
              return F === "*" || F === "x" || F === "X";
            }
            function ie(F, x) {
              return { operator: F, operand: x };
            }
            function R(F, x) {
              if (x.length === 0) return true;
              for (var X = 0, $ = x; X < $.length; X++) {
                var A = $[X];
                if (q(F, A)) return true;
              }
              return false;
            }
            function q(F, x) {
              for (var X = 0, $ = x; X < $.length; X++) {
                var A = $[X];
                if (!O(F, A.operator, A.operand)) return false;
              }
              return true;
            }
            function O(F, x, X) {
              var $ = F.compareTo(X);
              switch (x) {
                case "<":
                  return $ < 0;
                case "<=":
                  return $ <= 0;
                case ">":
                  return $ > 0;
                case ">=":
                  return $ >= 0;
                case "=":
                  return $ === 0;
                default:
                  return e.Debug.assertNever(x);
              }
            }
            function ve(F) {
              return e.map(F, ee).join(" || ") || "*";
            }
            function ee(F) {
              return e.map(F, he).join(" ");
            }
            function he(F) {
              return "".concat(F.operator).concat(F.operand);
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(le, N) {
              return typeof le == "object" && typeof le.timeOrigin == "number" && typeof le.mark == "function" && typeof le.measure == "function" && typeof le.now == "function" && typeof N == "function";
            }
            function C() {
              if (typeof performance == "object" && typeof PerformanceObserver == "function" && a(performance, PerformanceObserver)) return { shouldWriteNativeEvents: true, performance, PerformanceObserver };
            }
            function w() {
            }
            var B = C() || void 0, E = B == null ? void 0 : B.performance;
            function Q() {
              return B;
            }
            e.tryGetNativePerformanceHooks = Q, e.timestamp = E ? function() {
              return E.now();
            } : Date.now ? Date.now : function() {
              return +/* @__PURE__ */ new Date();
            };
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w, B;
              function E(R, q, O, ve) {
                return R ? Q(q, O, ve) : C.nullTimer;
              }
              C.createTimerIf = E;
              function Q(R, q, O) {
                var ve = 0;
                return { enter: ee, exit: he };
                function ee() {
                  ++ve === 1 && oe(q);
                }
                function he() {
                  --ve === 0 ? (oe(O), f(R, q, O)) : ve < 0 && e.Debug.fail("enter/exit count does not match.");
                }
              }
              C.createTimer = Q, C.nullTimer = { enter: e.noop, exit: e.noop };
              var le = false, N = e.timestamp(), p = new e.Map(), m = new e.Map(), G = new e.Map();
              function oe(R) {
                var q;
                if (le) {
                  var O = (q = m.get(R)) !== null && q !== void 0 ? q : 0;
                  m.set(R, O + 1), p.set(R, e.timestamp()), B == null || B.mark(R);
                }
              }
              C.mark = oe;
              function f(R, q, O) {
                var ve, ee;
                if (le) {
                  var he = (ve = O !== void 0 ? p.get(O) : void 0) !== null && ve !== void 0 ? ve : e.timestamp(), F = (ee = q !== void 0 ? p.get(q) : void 0) !== null && ee !== void 0 ? ee : N, x = G.get(R) || 0;
                  G.set(R, x + (he - F)), B == null || B.measure(R, q, O);
                }
              }
              C.measure = f;
              function T(R) {
                return m.get(R) || 0;
              }
              C.getCount = T;
              function K(R) {
                return G.get(R) || 0;
              }
              C.getDuration = K;
              function b(R) {
                G.forEach(function(q, O) {
                  return R(O, q);
                });
              }
              C.forEachMeasure = b;
              function se() {
                return le;
              }
              C.isEnabled = se;
              function J(R) {
                var q;
                return R === void 0 && (R = e.sys), le || (le = true, w || (w = e.tryGetNativePerformanceHooks()), w && (N = w.performance.timeOrigin, (w.shouldWriteNativeEvents || ((q = R == null ? void 0 : R.cpuProfilingEnabled) === null || q === void 0 ? void 0 : q.call(R)) || (R == null ? void 0 : R.debugMode)) && (B = w.performance))), true;
              }
              C.enable = J;
              function ie() {
                le && (p.clear(), m.clear(), G.clear(), B = void 0, le = false);
              }
              C.disable = ie;
            })(a = e.performance || (e.performance = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a, C = { logEvent: e.noop, logErrEvent: e.noop, logPerfEvent: e.noop, logInfoEvent: e.noop, logStartCommand: e.noop, logStopCommand: e.noop, logStartUpdateProgram: e.noop, logStopUpdateProgram: e.noop, logStartUpdateGraph: e.noop, logStopUpdateGraph: e.noop, logStartResolveModule: e.noop, logStopResolveModule: e.noop, logStartParseSourceFile: e.noop, logStopParseSourceFile: e.noop, logStartReadFile: e.noop, logStopReadFile: e.noop, logStartBindFile: e.noop, logStopBindFile: e.noop, logStartScheduledOperation: e.noop, logStopScheduledOperation: e.noop }, w;
            try {
              var B = (a = Eu.env.TS_ETW_MODULE_PATH) !== null && a !== void 0 ? a : "./node_modules/@microsoft/typescript-etw";
              w = void 0;
            } catch {
              w = void 0;
            }
            e.perfLogger = w && w.logEvent ? w : C;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w, B = 0, E = 0, Q, le = [], N, p = [];
              function m(he, F, x) {
                if (e.Debug.assert(!e.tracing, "Tracing already started"), w === void 0) try {
                  w = ex();
                } catch (V) {
                  throw new Error(`tracing requires having fs
(original error: `.concat(V.message || V, ")"));
                }
                Q = he, le.length = 0, N === void 0 && (N = e.combinePaths(F, "legend.json")), w.existsSync(F) || w.mkdirSync(F, { recursive: true });
                var X = Q === "build" ? ".".concat(Eu.pid, "-").concat(++B) : Q === "server" ? ".".concat(Eu.pid) : "", $ = e.combinePaths(F, "trace".concat(X, ".json")), A = e.combinePaths(F, "types".concat(X, ".json"));
                p.push({ configFilePath: x, tracePath: $, typesPath: A }), E = w.openSync($, "w"), e.tracing = C;
                var y = { cat: "__metadata", ph: "M", ts: 1e3 * e.timestamp(), pid: 1, tid: 1 };
                w.writeSync(E, `[
` + [Ke({ name: "process_name", args: { name: "tsc" } }, y), Ke({ name: "thread_name", args: { name: "Main" } }, y), Ke(Ke({ name: "TracingStartedInBrowser" }, y), { cat: "disabled-by-default-devtools.timeline" })].map(function(V) {
                  return JSON.stringify(V);
                }).join(`,
`));
              }
              C.startTracing = m;
              function G() {
                e.Debug.assert(e.tracing, "Tracing is not in progress"), e.Debug.assert(!!le.length == (Q !== "server")), w.writeSync(E, `
]
`), w.closeSync(E), e.tracing = void 0, le.length ? ve(le) : p[p.length - 1].typesPath = void 0;
              }
              C.stopTracing = G;
              function oe(he) {
                Q !== "server" && le.push(he);
              }
              C.recordType = oe;
              var f;
              (function(he) {
                he.Parse = "parse", he.Program = "program", he.Bind = "bind", he.Check = "check", he.CheckTypes = "checkTypes", he.Emit = "emit", he.Session = "session";
              })(f = C.Phase || (C.Phase = {}));
              function T(he, F, x) {
                q("I", he, F, x, '"s":"g"');
              }
              C.instant = T;
              var K = [];
              function b(he, F, x, X) {
                X === void 0 && (X = false), X && q("B", he, F, x), K.push({ phase: he, name: F, args: x, time: 1e3 * e.timestamp(), separateBeginAndEnd: X });
              }
              C.push = b;
              function se() {
                e.Debug.assert(K.length > 0), R(K.length - 1, 1e3 * e.timestamp()), K.length--;
              }
              C.pop = se;
              function J() {
                for (var he = 1e3 * e.timestamp(), F = K.length - 1; F >= 0; F--) R(F, he);
                K.length = 0;
              }
              C.popAll = J;
              var ie = 1e3 * 10;
              function R(he, F) {
                var x = K[he], X = x.phase, $ = x.name, A = x.args, y = x.time, V = x.separateBeginAndEnd;
                V ? q("E", X, $, A, void 0, F) : ie - y % ie <= F - y && q("X", X, $, A, '"dur":'.concat(F - y), y);
              }
              function q(he, F, x, X, $, A) {
                A === void 0 && (A = 1e3 * e.timestamp()), !(Q === "server" && F === "checkTypes") && (e.performance.mark("beginTracing"), w.writeSync(E, `,
{"pid":1,"tid":1,"ph":"`.concat(he, '","cat":"').concat(F, '","ts":').concat(A, ',"name":"').concat(x, '"')), $ && w.writeSync(E, ",".concat($)), X && w.writeSync(E, ',"args":'.concat(JSON.stringify(X))), w.writeSync(E, "}"), e.performance.mark("endTracing"), e.performance.measure("Tracing", "beginTracing", "endTracing"));
              }
              function O(he) {
                var F = e.getSourceFileOfNode(he);
                return F ? { path: F.path, start: x(e.getLineAndCharacterOfPosition(F, he.pos)), end: x(e.getLineAndCharacterOfPosition(F, he.end)) } : void 0;
                function x(X) {
                  return { line: X.line + 1, character: X.character + 1 };
                }
              }
              function ve(he) {
                var F, x, X, $, A, y, V, L, P, k, Y, U, j, H, I, l, d, D, fe, g, ne, ue;
                e.performance.mark("beginDumpTypes");
                var We = p[p.length - 1].typesPath, Fe = w.openSync(We, "w"), Z = new e.Map();
                w.writeSync(Fe, "[");
                for (var Be = he.length, ge = 0; ge < Be; ge++) {
                  var Re = he[ge], ze = Re.objectFlags, Ee = (F = Re.aliasSymbol) !== null && F !== void 0 ? F : Re.symbol, He = void 0;
                  if (ze & 16 | Re.flags & 2944) try {
                    He = (x = Re.checker) === null || x === void 0 ? void 0 : x.typeToString(Re);
                  } catch {
                    He = void 0;
                  }
                  var rr = {};
                  if (Re.flags & 8388608) {
                    var Ie = Re;
                    rr = { indexedAccessObjectType: (X = Ie.objectType) === null || X === void 0 ? void 0 : X.id, indexedAccessIndexType: ($ = Ie.indexType) === null || $ === void 0 ? void 0 : $.id };
                  }
                  var _e = {};
                  if (ze & 4) {
                    var we = Re;
                    _e = { instantiatedType: (A = we.target) === null || A === void 0 ? void 0 : A.id, typeArguments: (y = we.resolvedTypeArguments) === null || y === void 0 ? void 0 : y.map(function(lr) {
                      return lr.id;
                    }), referenceLocation: O(we.node) };
                  }
                  var de = {};
                  if (Re.flags & 16777216) {
                    var ye = Re;
                    de = { conditionalCheckType: (V = ye.checkType) === null || V === void 0 ? void 0 : V.id, conditionalExtendsType: (L = ye.extendsType) === null || L === void 0 ? void 0 : L.id, conditionalTrueType: (k = (P = ye.resolvedTrueType) === null || P === void 0 ? void 0 : P.id) !== null && k !== void 0 ? k : -1, conditionalFalseType: (U = (Y = ye.resolvedFalseType) === null || Y === void 0 ? void 0 : Y.id) !== null && U !== void 0 ? U : -1 };
                  }
                  var Ae = {};
                  if (Re.flags & 33554432) {
                    var er = Re;
                    Ae = { substitutionBaseType: (j = er.baseType) === null || j === void 0 ? void 0 : j.id, substituteType: (H = er.substitute) === null || H === void 0 ? void 0 : H.id };
                  }
                  var ir = {};
                  if (ze & 1024) {
                    var Cr = Re;
                    ir = { reverseMappedSourceType: (I = Cr.source) === null || I === void 0 ? void 0 : I.id, reverseMappedMappedType: (l = Cr.mappedType) === null || l === void 0 ? void 0 : l.id, reverseMappedConstraintType: (d = Cr.constraintType) === null || d === void 0 ? void 0 : d.id };
                  }
                  var Ye = {};
                  if (ze & 256) {
                    var Br = Re;
                    Ye = { evolvingArrayElementType: Br.elementType.id, evolvingArrayFinalType: (D = Br.finalArrayType) === null || D === void 0 ? void 0 : D.id };
                  }
                  var Er = void 0, Ne = Re.checker.getRecursionIdentity(Re);
                  Ne && (Er = Z.get(Ne), Er || (Er = Z.size, Z.set(Ne, Er)));
                  var n = Ke(Ke(Ke(Ke(Ke(Ke(Ke({ id: Re.id, intrinsicName: Re.intrinsicName, symbolName: (Ee == null ? void 0 : Ee.escapedName) && e.unescapeLeadingUnderscores(Ee.escapedName), recursionId: Er, isTuple: ze & 8 ? true : void 0, unionTypes: Re.flags & 1048576 ? (fe = Re.types) === null || fe === void 0 ? void 0 : fe.map(function(lr) {
                    return lr.id;
                  }) : void 0, intersectionTypes: Re.flags & 2097152 ? Re.types.map(function(lr) {
                    return lr.id;
                  }) : void 0, aliasTypeArguments: (g = Re.aliasTypeArguments) === null || g === void 0 ? void 0 : g.map(function(lr) {
                    return lr.id;
                  }), keyofType: Re.flags & 4194304 ? (ne = Re.type) === null || ne === void 0 ? void 0 : ne.id : void 0 }, rr), _e), de), Ae), ir), Ye), { destructuringPattern: O(Re.pattern), firstDeclaration: O((ue = Ee == null ? void 0 : Ee.declarations) === null || ue === void 0 ? void 0 : ue[0]), flags: e.Debug.formatTypeFlags(Re.flags).split("|"), display: He });
                  w.writeSync(Fe, JSON.stringify(n)), ge < Be - 1 && w.writeSync(Fe, `,
`);
                }
                w.writeSync(Fe, `]
`), w.closeSync(Fe), e.performance.mark("endDumpTypes"), e.performance.measure("Dump types", "beginDumpTypes", "endDumpTypes");
              }
              function ee() {
                !N || w.writeFileSync(N, JSON.stringify(p));
              }
              C.dumpLegend = ee;
            })(a || (a = {})), e.startTracing = a.startTracing, e.dumpTracingLegend = a.dumpLegend;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(n) {
              n[n.Unknown = 0] = "Unknown", n[n.EndOfFileToken = 1] = "EndOfFileToken", n[n.SingleLineCommentTrivia = 2] = "SingleLineCommentTrivia", n[n.MultiLineCommentTrivia = 3] = "MultiLineCommentTrivia", n[n.NewLineTrivia = 4] = "NewLineTrivia", n[n.WhitespaceTrivia = 5] = "WhitespaceTrivia", n[n.ShebangTrivia = 6] = "ShebangTrivia", n[n.ConflictMarkerTrivia = 7] = "ConflictMarkerTrivia", n[n.NumericLiteral = 8] = "NumericLiteral", n[n.BigIntLiteral = 9] = "BigIntLiteral", n[n.StringLiteral = 10] = "StringLiteral", n[n.JsxText = 11] = "JsxText", n[n.JsxTextAllWhiteSpaces = 12] = "JsxTextAllWhiteSpaces", n[n.RegularExpressionLiteral = 13] = "RegularExpressionLiteral", n[n.NoSubstitutionTemplateLiteral = 14] = "NoSubstitutionTemplateLiteral", n[n.TemplateHead = 15] = "TemplateHead", n[n.TemplateMiddle = 16] = "TemplateMiddle", n[n.TemplateTail = 17] = "TemplateTail", n[n.OpenBraceToken = 18] = "OpenBraceToken", n[n.CloseBraceToken = 19] = "CloseBraceToken", n[n.OpenParenToken = 20] = "OpenParenToken", n[n.CloseParenToken = 21] = "CloseParenToken", n[n.OpenBracketToken = 22] = "OpenBracketToken", n[n.CloseBracketToken = 23] = "CloseBracketToken", n[n.DotToken = 24] = "DotToken", n[n.DotDotDotToken = 25] = "DotDotDotToken", n[n.SemicolonToken = 26] = "SemicolonToken", n[n.CommaToken = 27] = "CommaToken", n[n.QuestionDotToken = 28] = "QuestionDotToken", n[n.LessThanToken = 29] = "LessThanToken", n[n.LessThanSlashToken = 30] = "LessThanSlashToken", n[n.GreaterThanToken = 31] = "GreaterThanToken", n[n.LessThanEqualsToken = 32] = "LessThanEqualsToken", n[n.GreaterThanEqualsToken = 33] = "GreaterThanEqualsToken", n[n.EqualsEqualsToken = 34] = "EqualsEqualsToken", n[n.ExclamationEqualsToken = 35] = "ExclamationEqualsToken", n[n.EqualsEqualsEqualsToken = 36] = "EqualsEqualsEqualsToken", n[n.ExclamationEqualsEqualsToken = 37] = "ExclamationEqualsEqualsToken", n[n.EqualsGreaterThanToken = 38] = "EqualsGreaterThanToken", n[n.PlusToken = 39] = "PlusToken", n[n.MinusToken = 40] = "MinusToken", n[n.AsteriskToken = 41] = "AsteriskToken", n[n.AsteriskAsteriskToken = 42] = "AsteriskAsteriskToken", n[n.SlashToken = 43] = "SlashToken", n[n.PercentToken = 44] = "PercentToken", n[n.PlusPlusToken = 45] = "PlusPlusToken", n[n.MinusMinusToken = 46] = "MinusMinusToken", n[n.LessThanLessThanToken = 47] = "LessThanLessThanToken", n[n.GreaterThanGreaterThanToken = 48] = "GreaterThanGreaterThanToken", n[n.GreaterThanGreaterThanGreaterThanToken = 49] = "GreaterThanGreaterThanGreaterThanToken", n[n.AmpersandToken = 50] = "AmpersandToken", n[n.BarToken = 51] = "BarToken", n[n.CaretToken = 52] = "CaretToken", n[n.ExclamationToken = 53] = "ExclamationToken", n[n.TildeToken = 54] = "TildeToken", n[n.AmpersandAmpersandToken = 55] = "AmpersandAmpersandToken", n[n.BarBarToken = 56] = "BarBarToken", n[n.QuestionToken = 57] = "QuestionToken", n[n.ColonToken = 58] = "ColonToken", n[n.AtToken = 59] = "AtToken", n[n.QuestionQuestionToken = 60] = "QuestionQuestionToken", n[n.BacktickToken = 61] = "BacktickToken", n[n.HashToken = 62] = "HashToken", n[n.EqualsToken = 63] = "EqualsToken", n[n.PlusEqualsToken = 64] = "PlusEqualsToken", n[n.MinusEqualsToken = 65] = "MinusEqualsToken", n[n.AsteriskEqualsToken = 66] = "AsteriskEqualsToken", n[n.AsteriskAsteriskEqualsToken = 67] = "AsteriskAsteriskEqualsToken", n[n.SlashEqualsToken = 68] = "SlashEqualsToken", n[n.PercentEqualsToken = 69] = "PercentEqualsToken", n[n.LessThanLessThanEqualsToken = 70] = "LessThanLessThanEqualsToken", n[n.GreaterThanGreaterThanEqualsToken = 71] = "GreaterThanGreaterThanEqualsToken", n[n.GreaterThanGreaterThanGreaterThanEqualsToken = 72] = "GreaterThanGreaterThanGreaterThanEqualsToken", n[n.AmpersandEqualsToken = 73] = "AmpersandEqualsToken", n[n.BarEqualsToken = 74] = "BarEqualsToken", n[n.BarBarEqualsToken = 75] = "BarBarEqualsToken", n[n.AmpersandAmpersandEqualsToken = 76] = "AmpersandAmpersandEqualsToken", n[n.QuestionQuestionEqualsToken = 77] = "QuestionQuestionEqualsToken", n[n.CaretEqualsToken = 78] = "CaretEqualsToken", n[n.Identifier = 79] = "Identifier", n[n.PrivateIdentifier = 80] = "PrivateIdentifier", n[n.BreakKeyword = 81] = "BreakKeyword", n[n.CaseKeyword = 82] = "CaseKeyword", n[n.CatchKeyword = 83] = "CatchKeyword", n[n.ClassKeyword = 84] = "ClassKeyword", n[n.ConstKeyword = 85] = "ConstKeyword", n[n.ContinueKeyword = 86] = "ContinueKeyword", n[n.DebuggerKeyword = 87] = "DebuggerKeyword", n[n.DefaultKeyword = 88] = "DefaultKeyword", n[n.DeleteKeyword = 89] = "DeleteKeyword", n[n.DoKeyword = 90] = "DoKeyword", n[n.ElseKeyword = 91] = "ElseKeyword", n[n.EnumKeyword = 92] = "EnumKeyword", n[n.ExportKeyword = 93] = "ExportKeyword", n[n.ExtendsKeyword = 94] = "ExtendsKeyword", n[n.FalseKeyword = 95] = "FalseKeyword", n[n.FinallyKeyword = 96] = "FinallyKeyword", n[n.ForKeyword = 97] = "ForKeyword", n[n.FunctionKeyword = 98] = "FunctionKeyword", n[n.IfKeyword = 99] = "IfKeyword", n[n.ImportKeyword = 100] = "ImportKeyword", n[n.InKeyword = 101] = "InKeyword", n[n.InstanceOfKeyword = 102] = "InstanceOfKeyword", n[n.NewKeyword = 103] = "NewKeyword", n[n.NullKeyword = 104] = "NullKeyword", n[n.ReturnKeyword = 105] = "ReturnKeyword", n[n.SuperKeyword = 106] = "SuperKeyword", n[n.SwitchKeyword = 107] = "SwitchKeyword", n[n.ThisKeyword = 108] = "ThisKeyword", n[n.ThrowKeyword = 109] = "ThrowKeyword", n[n.TrueKeyword = 110] = "TrueKeyword", n[n.TryKeyword = 111] = "TryKeyword", n[n.TypeOfKeyword = 112] = "TypeOfKeyword", n[n.VarKeyword = 113] = "VarKeyword", n[n.VoidKeyword = 114] = "VoidKeyword", n[n.WhileKeyword = 115] = "WhileKeyword", n[n.WithKeyword = 116] = "WithKeyword", n[n.ImplementsKeyword = 117] = "ImplementsKeyword", n[n.InterfaceKeyword = 118] = "InterfaceKeyword", n[n.LetKeyword = 119] = "LetKeyword", n[n.PackageKeyword = 120] = "PackageKeyword", n[n.PrivateKeyword = 121] = "PrivateKeyword", n[n.ProtectedKeyword = 122] = "ProtectedKeyword", n[n.PublicKeyword = 123] = "PublicKeyword", n[n.StaticKeyword = 124] = "StaticKeyword", n[n.YieldKeyword = 125] = "YieldKeyword", n[n.AbstractKeyword = 126] = "AbstractKeyword", n[n.AsKeyword = 127] = "AsKeyword", n[n.AssertsKeyword = 128] = "AssertsKeyword", n[n.AssertKeyword = 129] = "AssertKeyword", n[n.AnyKeyword = 130] = "AnyKeyword", n[n.AsyncKeyword = 131] = "AsyncKeyword", n[n.AwaitKeyword = 132] = "AwaitKeyword", n[n.BooleanKeyword = 133] = "BooleanKeyword", n[n.ConstructorKeyword = 134] = "ConstructorKeyword", n[n.DeclareKeyword = 135] = "DeclareKeyword", n[n.GetKeyword = 136] = "GetKeyword", n[n.InferKeyword = 137] = "InferKeyword", n[n.IntrinsicKeyword = 138] = "IntrinsicKeyword", n[n.IsKeyword = 139] = "IsKeyword", n[n.KeyOfKeyword = 140] = "KeyOfKeyword", n[n.ModuleKeyword = 141] = "ModuleKeyword", n[n.NamespaceKeyword = 142] = "NamespaceKeyword", n[n.NeverKeyword = 143] = "NeverKeyword", n[n.OutKeyword = 144] = "OutKeyword", n[n.ReadonlyKeyword = 145] = "ReadonlyKeyword", n[n.RequireKeyword = 146] = "RequireKeyword", n[n.NumberKeyword = 147] = "NumberKeyword", n[n.ObjectKeyword = 148] = "ObjectKeyword", n[n.SetKeyword = 149] = "SetKeyword", n[n.StringKeyword = 150] = "StringKeyword", n[n.SymbolKeyword = 151] = "SymbolKeyword", n[n.TypeKeyword = 152] = "TypeKeyword", n[n.UndefinedKeyword = 153] = "UndefinedKeyword", n[n.UniqueKeyword = 154] = "UniqueKeyword", n[n.UnknownKeyword = 155] = "UnknownKeyword", n[n.FromKeyword = 156] = "FromKeyword", n[n.GlobalKeyword = 157] = "GlobalKeyword", n[n.BigIntKeyword = 158] = "BigIntKeyword", n[n.OverrideKeyword = 159] = "OverrideKeyword", n[n.OfKeyword = 160] = "OfKeyword", n[n.QualifiedName = 161] = "QualifiedName", n[n.ComputedPropertyName = 162] = "ComputedPropertyName", n[n.TypeParameter = 163] = "TypeParameter", n[n.Parameter = 164] = "Parameter", n[n.Decorator = 165] = "Decorator", n[n.PropertySignature = 166] = "PropertySignature", n[n.PropertyDeclaration = 167] = "PropertyDeclaration", n[n.MethodSignature = 168] = "MethodSignature", n[n.MethodDeclaration = 169] = "MethodDeclaration", n[n.ClassStaticBlockDeclaration = 170] = "ClassStaticBlockDeclaration", n[n.Constructor = 171] = "Constructor", n[n.GetAccessor = 172] = "GetAccessor", n[n.SetAccessor = 173] = "SetAccessor", n[n.CallSignature = 174] = "CallSignature", n[n.ConstructSignature = 175] = "ConstructSignature", n[n.IndexSignature = 176] = "IndexSignature", n[n.TypePredicate = 177] = "TypePredicate", n[n.TypeReference = 178] = "TypeReference", n[n.FunctionType = 179] = "FunctionType", n[n.ConstructorType = 180] = "ConstructorType", n[n.TypeQuery = 181] = "TypeQuery", n[n.TypeLiteral = 182] = "TypeLiteral", n[n.ArrayType = 183] = "ArrayType", n[n.TupleType = 184] = "TupleType", n[n.OptionalType = 185] = "OptionalType", n[n.RestType = 186] = "RestType", n[n.UnionType = 187] = "UnionType", n[n.IntersectionType = 188] = "IntersectionType", n[n.ConditionalType = 189] = "ConditionalType", n[n.InferType = 190] = "InferType", n[n.ParenthesizedType = 191] = "ParenthesizedType", n[n.ThisType = 192] = "ThisType", n[n.TypeOperator = 193] = "TypeOperator", n[n.IndexedAccessType = 194] = "IndexedAccessType", n[n.MappedType = 195] = "MappedType", n[n.LiteralType = 196] = "LiteralType", n[n.NamedTupleMember = 197] = "NamedTupleMember", n[n.TemplateLiteralType = 198] = "TemplateLiteralType", n[n.TemplateLiteralTypeSpan = 199] = "TemplateLiteralTypeSpan", n[n.ImportType = 200] = "ImportType", n[n.ObjectBindingPattern = 201] = "ObjectBindingPattern", n[n.ArrayBindingPattern = 202] = "ArrayBindingPattern", n[n.BindingElement = 203] = "BindingElement", n[n.ArrayLiteralExpression = 204] = "ArrayLiteralExpression", n[n.ObjectLiteralExpression = 205] = "ObjectLiteralExpression", n[n.PropertyAccessExpression = 206] = "PropertyAccessExpression", n[n.ElementAccessExpression = 207] = "ElementAccessExpression", n[n.CallExpression = 208] = "CallExpression", n[n.NewExpression = 209] = "NewExpression", n[n.TaggedTemplateExpression = 210] = "TaggedTemplateExpression", n[n.TypeAssertionExpression = 211] = "TypeAssertionExpression", n[n.ParenthesizedExpression = 212] = "ParenthesizedExpression", n[n.FunctionExpression = 213] = "FunctionExpression", n[n.ArrowFunction = 214] = "ArrowFunction", n[n.DeleteExpression = 215] = "DeleteExpression", n[n.TypeOfExpression = 216] = "TypeOfExpression", n[n.VoidExpression = 217] = "VoidExpression", n[n.AwaitExpression = 218] = "AwaitExpression", n[n.PrefixUnaryExpression = 219] = "PrefixUnaryExpression", n[n.PostfixUnaryExpression = 220] = "PostfixUnaryExpression", n[n.BinaryExpression = 221] = "BinaryExpression", n[n.ConditionalExpression = 222] = "ConditionalExpression", n[n.TemplateExpression = 223] = "TemplateExpression", n[n.YieldExpression = 224] = "YieldExpression", n[n.SpreadElement = 225] = "SpreadElement", n[n.ClassExpression = 226] = "ClassExpression", n[n.OmittedExpression = 227] = "OmittedExpression", n[n.ExpressionWithTypeArguments = 228] = "ExpressionWithTypeArguments", n[n.AsExpression = 229] = "AsExpression", n[n.NonNullExpression = 230] = "NonNullExpression", n[n.MetaProperty = 231] = "MetaProperty", n[n.SyntheticExpression = 232] = "SyntheticExpression", n[n.TemplateSpan = 233] = "TemplateSpan", n[n.SemicolonClassElement = 234] = "SemicolonClassElement", n[n.Block = 235] = "Block", n[n.EmptyStatement = 236] = "EmptyStatement", n[n.VariableStatement = 237] = "VariableStatement", n[n.ExpressionStatement = 238] = "ExpressionStatement", n[n.IfStatement = 239] = "IfStatement", n[n.DoStatement = 240] = "DoStatement", n[n.WhileStatement = 241] = "WhileStatement", n[n.ForStatement = 242] = "ForStatement", n[n.ForInStatement = 243] = "ForInStatement", n[n.ForOfStatement = 244] = "ForOfStatement", n[n.ContinueStatement = 245] = "ContinueStatement", n[n.BreakStatement = 246] = "BreakStatement", n[n.ReturnStatement = 247] = "ReturnStatement", n[n.WithStatement = 248] = "WithStatement", n[n.SwitchStatement = 249] = "SwitchStatement", n[n.LabeledStatement = 250] = "LabeledStatement", n[n.ThrowStatement = 251] = "ThrowStatement", n[n.TryStatement = 252] = "TryStatement", n[n.DebuggerStatement = 253] = "DebuggerStatement", n[n.VariableDeclaration = 254] = "VariableDeclaration", n[n.VariableDeclarationList = 255] = "VariableDeclarationList", n[n.FunctionDeclaration = 256] = "FunctionDeclaration", n[n.ClassDeclaration = 257] = "ClassDeclaration", n[n.InterfaceDeclaration = 258] = "InterfaceDeclaration", n[n.TypeAliasDeclaration = 259] = "TypeAliasDeclaration", n[n.EnumDeclaration = 260] = "EnumDeclaration", n[n.ModuleDeclaration = 261] = "ModuleDeclaration", n[n.ModuleBlock = 262] = "ModuleBlock", n[n.CaseBlock = 263] = "CaseBlock", n[n.NamespaceExportDeclaration = 264] = "NamespaceExportDeclaration", n[n.ImportEqualsDeclaration = 265] = "ImportEqualsDeclaration", n[n.ImportDeclaration = 266] = "ImportDeclaration", n[n.ImportClause = 267] = "ImportClause", n[n.NamespaceImport = 268] = "NamespaceImport", n[n.NamedImports = 269] = "NamedImports", n[n.ImportSpecifier = 270] = "ImportSpecifier", n[n.ExportAssignment = 271] = "ExportAssignment", n[n.ExportDeclaration = 272] = "ExportDeclaration", n[n.NamedExports = 273] = "NamedExports", n[n.NamespaceExport = 274] = "NamespaceExport", n[n.ExportSpecifier = 275] = "ExportSpecifier", n[n.MissingDeclaration = 276] = "MissingDeclaration", n[n.ExternalModuleReference = 277] = "ExternalModuleReference", n[n.JsxElement = 278] = "JsxElement", n[n.JsxSelfClosingElement = 279] = "JsxSelfClosingElement", n[n.JsxOpeningElement = 280] = "JsxOpeningElement", n[n.JsxClosingElement = 281] = "JsxClosingElement", n[n.JsxFragment = 282] = "JsxFragment", n[n.JsxOpeningFragment = 283] = "JsxOpeningFragment", n[n.JsxClosingFragment = 284] = "JsxClosingFragment", n[n.JsxAttribute = 285] = "JsxAttribute", n[n.JsxAttributes = 286] = "JsxAttributes", n[n.JsxSpreadAttribute = 287] = "JsxSpreadAttribute", n[n.JsxExpression = 288] = "JsxExpression", n[n.CaseClause = 289] = "CaseClause", n[n.DefaultClause = 290] = "DefaultClause", n[n.HeritageClause = 291] = "HeritageClause", n[n.CatchClause = 292] = "CatchClause", n[n.AssertClause = 293] = "AssertClause", n[n.AssertEntry = 294] = "AssertEntry", n[n.ImportTypeAssertionContainer = 295] = "ImportTypeAssertionContainer", n[n.PropertyAssignment = 296] = "PropertyAssignment", n[n.ShorthandPropertyAssignment = 297] = "ShorthandPropertyAssignment", n[n.SpreadAssignment = 298] = "SpreadAssignment", n[n.EnumMember = 299] = "EnumMember", n[n.UnparsedPrologue = 300] = "UnparsedPrologue", n[n.UnparsedPrepend = 301] = "UnparsedPrepend", n[n.UnparsedText = 302] = "UnparsedText", n[n.UnparsedInternalText = 303] = "UnparsedInternalText", n[n.UnparsedSyntheticReference = 304] = "UnparsedSyntheticReference", n[n.SourceFile = 305] = "SourceFile", n[n.Bundle = 306] = "Bundle", n[n.UnparsedSource = 307] = "UnparsedSource", n[n.InputFiles = 308] = "InputFiles", n[n.JSDocTypeExpression = 309] = "JSDocTypeExpression", n[n.JSDocNameReference = 310] = "JSDocNameReference", n[n.JSDocMemberName = 311] = "JSDocMemberName", n[n.JSDocAllType = 312] = "JSDocAllType", n[n.JSDocUnknownType = 313] = "JSDocUnknownType", n[n.JSDocNullableType = 314] = "JSDocNullableType", n[n.JSDocNonNullableType = 315] = "JSDocNonNullableType", n[n.JSDocOptionalType = 316] = "JSDocOptionalType", n[n.JSDocFunctionType = 317] = "JSDocFunctionType", n[n.JSDocVariadicType = 318] = "JSDocVariadicType", n[n.JSDocNamepathType = 319] = "JSDocNamepathType", n[n.JSDocComment = 320] = "JSDocComment", n[n.JSDocText = 321] = "JSDocText", n[n.JSDocTypeLiteral = 322] = "JSDocTypeLiteral", n[n.JSDocSignature = 323] = "JSDocSignature", n[n.JSDocLink = 324] = "JSDocLink", n[n.JSDocLinkCode = 325] = "JSDocLinkCode", n[n.JSDocLinkPlain = 326] = "JSDocLinkPlain", n[n.JSDocTag = 327] = "JSDocTag", n[n.JSDocAugmentsTag = 328] = "JSDocAugmentsTag", n[n.JSDocImplementsTag = 329] = "JSDocImplementsTag", n[n.JSDocAuthorTag = 330] = "JSDocAuthorTag", n[n.JSDocDeprecatedTag = 331] = "JSDocDeprecatedTag", n[n.JSDocClassTag = 332] = "JSDocClassTag", n[n.JSDocPublicTag = 333] = "JSDocPublicTag", n[n.JSDocPrivateTag = 334] = "JSDocPrivateTag", n[n.JSDocProtectedTag = 335] = "JSDocProtectedTag", n[n.JSDocReadonlyTag = 336] = "JSDocReadonlyTag", n[n.JSDocOverrideTag = 337] = "JSDocOverrideTag", n[n.JSDocCallbackTag = 338] = "JSDocCallbackTag", n[n.JSDocEnumTag = 339] = "JSDocEnumTag", n[n.JSDocParameterTag = 340] = "JSDocParameterTag", n[n.JSDocReturnTag = 341] = "JSDocReturnTag", n[n.JSDocThisTag = 342] = "JSDocThisTag", n[n.JSDocTypeTag = 343] = "JSDocTypeTag", n[n.JSDocTemplateTag = 344] = "JSDocTemplateTag", n[n.JSDocTypedefTag = 345] = "JSDocTypedefTag", n[n.JSDocSeeTag = 346] = "JSDocSeeTag", n[n.JSDocPropertyTag = 347] = "JSDocPropertyTag", n[n.SyntaxList = 348] = "SyntaxList", n[n.NotEmittedStatement = 349] = "NotEmittedStatement", n[n.PartiallyEmittedExpression = 350] = "PartiallyEmittedExpression", n[n.CommaListExpression = 351] = "CommaListExpression", n[n.MergeDeclarationMarker = 352] = "MergeDeclarationMarker", n[n.EndOfDeclarationMarker = 353] = "EndOfDeclarationMarker", n[n.SyntheticReferenceExpression = 354] = "SyntheticReferenceExpression", n[n.Count = 355] = "Count", n[n.FirstAssignment = 63] = "FirstAssignment", n[n.LastAssignment = 78] = "LastAssignment", n[n.FirstCompoundAssignment = 64] = "FirstCompoundAssignment", n[n.LastCompoundAssignment = 78] = "LastCompoundAssignment", n[n.FirstReservedWord = 81] = "FirstReservedWord", n[n.LastReservedWord = 116] = "LastReservedWord", n[n.FirstKeyword = 81] = "FirstKeyword", n[n.LastKeyword = 160] = "LastKeyword", n[n.FirstFutureReservedWord = 117] = "FirstFutureReservedWord", n[n.LastFutureReservedWord = 125] = "LastFutureReservedWord", n[n.FirstTypeNode = 177] = "FirstTypeNode", n[n.LastTypeNode = 200] = "LastTypeNode", n[n.FirstPunctuation = 18] = "FirstPunctuation", n[n.LastPunctuation = 78] = "LastPunctuation", n[n.FirstToken = 0] = "FirstToken", n[n.LastToken = 160] = "LastToken", n[n.FirstTriviaToken = 2] = "FirstTriviaToken", n[n.LastTriviaToken = 7] = "LastTriviaToken", n[n.FirstLiteralToken = 8] = "FirstLiteralToken", n[n.LastLiteralToken = 14] = "LastLiteralToken", n[n.FirstTemplateToken = 14] = "FirstTemplateToken", n[n.LastTemplateToken = 17] = "LastTemplateToken", n[n.FirstBinaryOperator = 29] = "FirstBinaryOperator", n[n.LastBinaryOperator = 78] = "LastBinaryOperator", n[n.FirstStatement = 237] = "FirstStatement", n[n.LastStatement = 253] = "LastStatement", n[n.FirstNode = 161] = "FirstNode", n[n.FirstJSDocNode = 309] = "FirstJSDocNode", n[n.LastJSDocNode = 347] = "LastJSDocNode", n[n.FirstJSDocTagNode = 327] = "FirstJSDocTagNode", n[n.LastJSDocTagNode = 347] = "LastJSDocTagNode", n[n.FirstContextualKeyword = 126] = "FirstContextualKeyword", n[n.LastContextualKeyword = 160] = "LastContextualKeyword", n[n.JSDoc = 320] = "JSDoc";
            })(a = e.SyntaxKind || (e.SyntaxKind = {}));
            var C;
            (function(n) {
              n[n.None = 0] = "None", n[n.Let = 1] = "Let", n[n.Const = 2] = "Const", n[n.NestedNamespace = 4] = "NestedNamespace", n[n.Synthesized = 8] = "Synthesized", n[n.Namespace = 16] = "Namespace", n[n.OptionalChain = 32] = "OptionalChain", n[n.ExportContext = 64] = "ExportContext", n[n.ContainsThis = 128] = "ContainsThis", n[n.HasImplicitReturn = 256] = "HasImplicitReturn", n[n.HasExplicitReturn = 512] = "HasExplicitReturn", n[n.GlobalAugmentation = 1024] = "GlobalAugmentation", n[n.HasAsyncFunctions = 2048] = "HasAsyncFunctions", n[n.DisallowInContext = 4096] = "DisallowInContext", n[n.YieldContext = 8192] = "YieldContext", n[n.DecoratorContext = 16384] = "DecoratorContext", n[n.AwaitContext = 32768] = "AwaitContext", n[n.DisallowConditionalTypesContext = 65536] = "DisallowConditionalTypesContext", n[n.ThisNodeHasError = 131072] = "ThisNodeHasError", n[n.JavaScriptFile = 262144] = "JavaScriptFile", n[n.ThisNodeOrAnySubNodesHasError = 524288] = "ThisNodeOrAnySubNodesHasError", n[n.HasAggregatedChildData = 1048576] = "HasAggregatedChildData", n[n.PossiblyContainsDynamicImport = 2097152] = "PossiblyContainsDynamicImport", n[n.PossiblyContainsImportMeta = 4194304] = "PossiblyContainsImportMeta", n[n.JSDoc = 8388608] = "JSDoc", n[n.Ambient = 16777216] = "Ambient", n[n.InWithStatement = 33554432] = "InWithStatement", n[n.JsonFile = 67108864] = "JsonFile", n[n.TypeCached = 134217728] = "TypeCached", n[n.Deprecated = 268435456] = "Deprecated", n[n.BlockScoped = 3] = "BlockScoped", n[n.ReachabilityCheckFlags = 768] = "ReachabilityCheckFlags", n[n.ReachabilityAndEmitFlags = 2816] = "ReachabilityAndEmitFlags", n[n.ContextFlags = 50720768] = "ContextFlags", n[n.TypeExcludesFlags = 40960] = "TypeExcludesFlags", n[n.PermanentlySetIncrementalFlags = 6291456] = "PermanentlySetIncrementalFlags";
            })(C = e.NodeFlags || (e.NodeFlags = {}));
            var w;
            (function(n) {
              n[n.None = 0] = "None", n[n.Export = 1] = "Export", n[n.Ambient = 2] = "Ambient", n[n.Public = 4] = "Public", n[n.Private = 8] = "Private", n[n.Protected = 16] = "Protected", n[n.Static = 32] = "Static", n[n.Readonly = 64] = "Readonly", n[n.Abstract = 128] = "Abstract", n[n.Async = 256] = "Async", n[n.Default = 512] = "Default", n[n.Const = 2048] = "Const", n[n.HasComputedJSDocModifiers = 4096] = "HasComputedJSDocModifiers", n[n.Deprecated = 8192] = "Deprecated", n[n.Override = 16384] = "Override", n[n.In = 32768] = "In", n[n.Out = 65536] = "Out", n[n.HasComputedFlags = 536870912] = "HasComputedFlags", n[n.AccessibilityModifier = 28] = "AccessibilityModifier", n[n.ParameterPropertyModifier = 16476] = "ParameterPropertyModifier", n[n.NonPublicAccessibilityModifier = 24] = "NonPublicAccessibilityModifier", n[n.TypeScriptModifier = 116958] = "TypeScriptModifier", n[n.ExportDefault = 513] = "ExportDefault", n[n.All = 125951] = "All";
            })(w = e.ModifierFlags || (e.ModifierFlags = {}));
            var B;
            (function(n) {
              n[n.None = 0] = "None", n[n.IntrinsicNamedElement = 1] = "IntrinsicNamedElement", n[n.IntrinsicIndexedElement = 2] = "IntrinsicIndexedElement", n[n.IntrinsicElement = 3] = "IntrinsicElement";
            })(B = e.JsxFlags || (e.JsxFlags = {}));
            var E;
            (function(n) {
              n[n.Succeeded = 1] = "Succeeded", n[n.Failed = 2] = "Failed", n[n.Reported = 4] = "Reported", n[n.ReportsUnmeasurable = 8] = "ReportsUnmeasurable", n[n.ReportsUnreliable = 16] = "ReportsUnreliable", n[n.ReportsMask = 24] = "ReportsMask";
            })(E = e.RelationComparisonResult || (e.RelationComparisonResult = {}));
            var Q;
            (function(n) {
              n[n.None = 0] = "None", n[n.Auto = 1] = "Auto", n[n.Loop = 2] = "Loop", n[n.Unique = 3] = "Unique", n[n.Node = 4] = "Node", n[n.KindMask = 7] = "KindMask", n[n.ReservedInNestedScopes = 8] = "ReservedInNestedScopes", n[n.Optimistic = 16] = "Optimistic", n[n.FileLevel = 32] = "FileLevel", n[n.AllowNameSubstitution = 64] = "AllowNameSubstitution";
            })(Q = e.GeneratedIdentifierFlags || (e.GeneratedIdentifierFlags = {}));
            var le;
            (function(n) {
              n[n.None = 0] = "None", n[n.PrecedingLineBreak = 1] = "PrecedingLineBreak", n[n.PrecedingJSDocComment = 2] = "PrecedingJSDocComment", n[n.Unterminated = 4] = "Unterminated", n[n.ExtendedUnicodeEscape = 8] = "ExtendedUnicodeEscape", n[n.Scientific = 16] = "Scientific", n[n.Octal = 32] = "Octal", n[n.HexSpecifier = 64] = "HexSpecifier", n[n.BinarySpecifier = 128] = "BinarySpecifier", n[n.OctalSpecifier = 256] = "OctalSpecifier", n[n.ContainsSeparator = 512] = "ContainsSeparator", n[n.UnicodeEscape = 1024] = "UnicodeEscape", n[n.ContainsInvalidEscape = 2048] = "ContainsInvalidEscape", n[n.BinaryOrOctalSpecifier = 384] = "BinaryOrOctalSpecifier", n[n.NumericLiteralFlags = 1008] = "NumericLiteralFlags", n[n.TemplateLiteralLikeFlags = 2048] = "TemplateLiteralLikeFlags";
            })(le = e.TokenFlags || (e.TokenFlags = {}));
            var N;
            (function(n) {
              n[n.Unreachable = 1] = "Unreachable", n[n.Start = 2] = "Start", n[n.BranchLabel = 4] = "BranchLabel", n[n.LoopLabel = 8] = "LoopLabel", n[n.Assignment = 16] = "Assignment", n[n.TrueCondition = 32] = "TrueCondition", n[n.FalseCondition = 64] = "FalseCondition", n[n.SwitchClause = 128] = "SwitchClause", n[n.ArrayMutation = 256] = "ArrayMutation", n[n.Call = 512] = "Call", n[n.ReduceLabel = 1024] = "ReduceLabel", n[n.Referenced = 2048] = "Referenced", n[n.Shared = 4096] = "Shared", n[n.Label = 12] = "Label", n[n.Condition = 96] = "Condition";
            })(N = e.FlowFlags || (e.FlowFlags = {}));
            var p;
            (function(n) {
              n[n.ExpectError = 0] = "ExpectError", n[n.Ignore = 1] = "Ignore";
            })(p = e.CommentDirectiveType || (e.CommentDirectiveType = {}));
            var m = /* @__PURE__ */ function() {
              function n() {
              }
              return n;
            }();
            e.OperationCanceledException = m;
            var G;
            (function(n) {
              n[n.RootFile = 0] = "RootFile", n[n.SourceFromProjectReference = 1] = "SourceFromProjectReference", n[n.OutputFromProjectReference = 2] = "OutputFromProjectReference", n[n.Import = 3] = "Import", n[n.ReferenceFile = 4] = "ReferenceFile", n[n.TypeReferenceDirective = 5] = "TypeReferenceDirective", n[n.LibFile = 6] = "LibFile", n[n.LibReferenceDirective = 7] = "LibReferenceDirective", n[n.AutomaticTypeDirectiveFile = 8] = "AutomaticTypeDirectiveFile";
            })(G = e.FileIncludeKind || (e.FileIncludeKind = {}));
            var oe;
            (function(n) {
              n[n.FilePreprocessingReferencedDiagnostic = 0] = "FilePreprocessingReferencedDiagnostic", n[n.FilePreprocessingFileExplainingDiagnostic = 1] = "FilePreprocessingFileExplainingDiagnostic";
            })(oe = e.FilePreprocessingDiagnosticsKind || (e.FilePreprocessingDiagnosticsKind = {}));
            var f;
            (function(n) {
              n[n.Not = 0] = "Not", n[n.SafeModules = 1] = "SafeModules", n[n.Completely = 2] = "Completely";
            })(f = e.StructureIsReused || (e.StructureIsReused = {}));
            var T;
            (function(n) {
              n[n.Success = 0] = "Success", n[n.DiagnosticsPresent_OutputsSkipped = 1] = "DiagnosticsPresent_OutputsSkipped", n[n.DiagnosticsPresent_OutputsGenerated = 2] = "DiagnosticsPresent_OutputsGenerated", n[n.InvalidProject_OutputsSkipped = 3] = "InvalidProject_OutputsSkipped", n[n.ProjectReferenceCycle_OutputsSkipped = 4] = "ProjectReferenceCycle_OutputsSkipped", n[n.ProjectReferenceCycle_OutputsSkupped = 4] = "ProjectReferenceCycle_OutputsSkupped";
            })(T = e.ExitStatus || (e.ExitStatus = {}));
            var K;
            (function(n) {
              n[n.Ok = 0] = "Ok", n[n.NeedsOverride = 1] = "NeedsOverride", n[n.HasInvalidOverride = 2] = "HasInvalidOverride";
            })(K = e.MemberOverrideStatus || (e.MemberOverrideStatus = {}));
            var b;
            (function(n) {
              n[n.None = 0] = "None", n[n.Literal = 1] = "Literal", n[n.Subtype = 2] = "Subtype";
            })(b = e.UnionReduction || (e.UnionReduction = {}));
            var se;
            (function(n) {
              n[n.None = 0] = "None", n[n.Signature = 1] = "Signature", n[n.NoConstraints = 2] = "NoConstraints", n[n.Completions = 4] = "Completions", n[n.SkipBindingPatterns = 8] = "SkipBindingPatterns";
            })(se = e.ContextFlags || (e.ContextFlags = {}));
            var J;
            (function(n) {
              n[n.None = 0] = "None", n[n.NoTruncation = 1] = "NoTruncation", n[n.WriteArrayAsGenericType = 2] = "WriteArrayAsGenericType", n[n.GenerateNamesForShadowedTypeParams = 4] = "GenerateNamesForShadowedTypeParams", n[n.UseStructuralFallback = 8] = "UseStructuralFallback", n[n.ForbidIndexedAccessSymbolReferences = 16] = "ForbidIndexedAccessSymbolReferences", n[n.WriteTypeArgumentsOfSignature = 32] = "WriteTypeArgumentsOfSignature", n[n.UseFullyQualifiedType = 64] = "UseFullyQualifiedType", n[n.UseOnlyExternalAliasing = 128] = "UseOnlyExternalAliasing", n[n.SuppressAnyReturnType = 256] = "SuppressAnyReturnType", n[n.WriteTypeParametersInQualifiedName = 512] = "WriteTypeParametersInQualifiedName", n[n.MultilineObjectLiterals = 1024] = "MultilineObjectLiterals", n[n.WriteClassExpressionAsTypeLiteral = 2048] = "WriteClassExpressionAsTypeLiteral", n[n.UseTypeOfFunction = 4096] = "UseTypeOfFunction", n[n.OmitParameterModifiers = 8192] = "OmitParameterModifiers", n[n.UseAliasDefinedOutsideCurrentScope = 16384] = "UseAliasDefinedOutsideCurrentScope", n[n.UseSingleQuotesForStringLiteralType = 268435456] = "UseSingleQuotesForStringLiteralType", n[n.NoTypeReduction = 536870912] = "NoTypeReduction", n[n.AllowThisInObjectLiteral = 32768] = "AllowThisInObjectLiteral", n[n.AllowQualifiedNameInPlaceOfIdentifier = 65536] = "AllowQualifiedNameInPlaceOfIdentifier", n[n.AllowQualifedNameInPlaceOfIdentifier = 65536] = "AllowQualifedNameInPlaceOfIdentifier", n[n.AllowAnonymousIdentifier = 131072] = "AllowAnonymousIdentifier", n[n.AllowEmptyUnionOrIntersection = 262144] = "AllowEmptyUnionOrIntersection", n[n.AllowEmptyTuple = 524288] = "AllowEmptyTuple", n[n.AllowUniqueESSymbolType = 1048576] = "AllowUniqueESSymbolType", n[n.AllowEmptyIndexInfoType = 2097152] = "AllowEmptyIndexInfoType", n[n.AllowNodeModulesRelativePaths = 67108864] = "AllowNodeModulesRelativePaths", n[n.DoNotIncludeSymbolChain = 134217728] = "DoNotIncludeSymbolChain", n[n.IgnoreErrors = 70221824] = "IgnoreErrors", n[n.InObjectTypeLiteral = 4194304] = "InObjectTypeLiteral", n[n.InTypeAlias = 8388608] = "InTypeAlias", n[n.InInitialEntityName = 16777216] = "InInitialEntityName";
            })(J = e.NodeBuilderFlags || (e.NodeBuilderFlags = {}));
            var ie;
            (function(n) {
              n[n.None = 0] = "None", n[n.NoTruncation = 1] = "NoTruncation", n[n.WriteArrayAsGenericType = 2] = "WriteArrayAsGenericType", n[n.UseStructuralFallback = 8] = "UseStructuralFallback", n[n.WriteTypeArgumentsOfSignature = 32] = "WriteTypeArgumentsOfSignature", n[n.UseFullyQualifiedType = 64] = "UseFullyQualifiedType", n[n.SuppressAnyReturnType = 256] = "SuppressAnyReturnType", n[n.MultilineObjectLiterals = 1024] = "MultilineObjectLiterals", n[n.WriteClassExpressionAsTypeLiteral = 2048] = "WriteClassExpressionAsTypeLiteral", n[n.UseTypeOfFunction = 4096] = "UseTypeOfFunction", n[n.OmitParameterModifiers = 8192] = "OmitParameterModifiers", n[n.UseAliasDefinedOutsideCurrentScope = 16384] = "UseAliasDefinedOutsideCurrentScope", n[n.UseSingleQuotesForStringLiteralType = 268435456] = "UseSingleQuotesForStringLiteralType", n[n.NoTypeReduction = 536870912] = "NoTypeReduction", n[n.AllowUniqueESSymbolType = 1048576] = "AllowUniqueESSymbolType", n[n.AddUndefined = 131072] = "AddUndefined", n[n.WriteArrowStyleSignature = 262144] = "WriteArrowStyleSignature", n[n.InArrayType = 524288] = "InArrayType", n[n.InElementType = 2097152] = "InElementType", n[n.InFirstTypeArgument = 4194304] = "InFirstTypeArgument", n[n.InTypeAlias = 8388608] = "InTypeAlias", n[n.WriteOwnNameForAnyLike = 0] = "WriteOwnNameForAnyLike", n[n.NodeBuilderFlagsMask = 814775659] = "NodeBuilderFlagsMask";
            })(ie = e.TypeFormatFlags || (e.TypeFormatFlags = {}));
            var R;
            (function(n) {
              n[n.None = 0] = "None", n[n.WriteTypeParametersOrArguments = 1] = "WriteTypeParametersOrArguments", n[n.UseOnlyExternalAliasing = 2] = "UseOnlyExternalAliasing", n[n.AllowAnyNodeKind = 4] = "AllowAnyNodeKind", n[n.UseAliasDefinedOutsideCurrentScope = 8] = "UseAliasDefinedOutsideCurrentScope", n[n.DoNotIncludeSymbolChain = 16] = "DoNotIncludeSymbolChain";
            })(R = e.SymbolFormatFlags || (e.SymbolFormatFlags = {}));
            var q;
            (function(n) {
              n[n.Accessible = 0] = "Accessible", n[n.NotAccessible = 1] = "NotAccessible", n[n.CannotBeNamed = 2] = "CannotBeNamed";
            })(q = e.SymbolAccessibility || (e.SymbolAccessibility = {}));
            var O;
            (function(n) {
              n[n.UnionOrIntersection = 0] = "UnionOrIntersection", n[n.Spread = 1] = "Spread";
            })(O = e.SyntheticSymbolKind || (e.SyntheticSymbolKind = {}));
            var ve;
            (function(n) {
              n[n.This = 0] = "This", n[n.Identifier = 1] = "Identifier", n[n.AssertsThis = 2] = "AssertsThis", n[n.AssertsIdentifier = 3] = "AssertsIdentifier";
            })(ve = e.TypePredicateKind || (e.TypePredicateKind = {}));
            var ee;
            (function(n) {
              n[n.Unknown = 0] = "Unknown", n[n.TypeWithConstructSignatureAndValue = 1] = "TypeWithConstructSignatureAndValue", n[n.VoidNullableOrNeverType = 2] = "VoidNullableOrNeverType", n[n.NumberLikeType = 3] = "NumberLikeType", n[n.BigIntLikeType = 4] = "BigIntLikeType", n[n.StringLikeType = 5] = "StringLikeType", n[n.BooleanType = 6] = "BooleanType", n[n.ArrayLikeType = 7] = "ArrayLikeType", n[n.ESSymbolType = 8] = "ESSymbolType", n[n.Promise = 9] = "Promise", n[n.TypeWithCallSignature = 10] = "TypeWithCallSignature", n[n.ObjectType = 11] = "ObjectType";
            })(ee = e.TypeReferenceSerializationKind || (e.TypeReferenceSerializationKind = {}));
            var he;
            (function(n) {
              n[n.None = 0] = "None", n[n.FunctionScopedVariable = 1] = "FunctionScopedVariable", n[n.BlockScopedVariable = 2] = "BlockScopedVariable", n[n.Property = 4] = "Property", n[n.EnumMember = 8] = "EnumMember", n[n.Function = 16] = "Function", n[n.Class = 32] = "Class", n[n.Interface = 64] = "Interface", n[n.ConstEnum = 128] = "ConstEnum", n[n.RegularEnum = 256] = "RegularEnum", n[n.ValueModule = 512] = "ValueModule", n[n.NamespaceModule = 1024] = "NamespaceModule", n[n.TypeLiteral = 2048] = "TypeLiteral", n[n.ObjectLiteral = 4096] = "ObjectLiteral", n[n.Method = 8192] = "Method", n[n.Constructor = 16384] = "Constructor", n[n.GetAccessor = 32768] = "GetAccessor", n[n.SetAccessor = 65536] = "SetAccessor", n[n.Signature = 131072] = "Signature", n[n.TypeParameter = 262144] = "TypeParameter", n[n.TypeAlias = 524288] = "TypeAlias", n[n.ExportValue = 1048576] = "ExportValue", n[n.Alias = 2097152] = "Alias", n[n.Prototype = 4194304] = "Prototype", n[n.ExportStar = 8388608] = "ExportStar", n[n.Optional = 16777216] = "Optional", n[n.Transient = 33554432] = "Transient", n[n.Assignment = 67108864] = "Assignment", n[n.ModuleExports = 134217728] = "ModuleExports", n[n.All = 67108863] = "All", n[n.Enum = 384] = "Enum", n[n.Variable = 3] = "Variable", n[n.Value = 111551] = "Value", n[n.Type = 788968] = "Type", n[n.Namespace = 1920] = "Namespace", n[n.Module = 1536] = "Module", n[n.Accessor = 98304] = "Accessor", n[n.FunctionScopedVariableExcludes = 111550] = "FunctionScopedVariableExcludes", n[n.BlockScopedVariableExcludes = 111551] = "BlockScopedVariableExcludes", n[n.ParameterExcludes = 111551] = "ParameterExcludes", n[n.PropertyExcludes = 0] = "PropertyExcludes", n[n.EnumMemberExcludes = 900095] = "EnumMemberExcludes", n[n.FunctionExcludes = 110991] = "FunctionExcludes", n[n.ClassExcludes = 899503] = "ClassExcludes", n[n.InterfaceExcludes = 788872] = "InterfaceExcludes", n[n.RegularEnumExcludes = 899327] = "RegularEnumExcludes", n[n.ConstEnumExcludes = 899967] = "ConstEnumExcludes", n[n.ValueModuleExcludes = 110735] = "ValueModuleExcludes", n[n.NamespaceModuleExcludes = 0] = "NamespaceModuleExcludes", n[n.MethodExcludes = 103359] = "MethodExcludes", n[n.GetAccessorExcludes = 46015] = "GetAccessorExcludes", n[n.SetAccessorExcludes = 78783] = "SetAccessorExcludes", n[n.TypeParameterExcludes = 526824] = "TypeParameterExcludes", n[n.TypeAliasExcludes = 788968] = "TypeAliasExcludes", n[n.AliasExcludes = 2097152] = "AliasExcludes", n[n.ModuleMember = 2623475] = "ModuleMember", n[n.ExportHasLocal = 944] = "ExportHasLocal", n[n.BlockScoped = 418] = "BlockScoped", n[n.PropertyOrAccessor = 98308] = "PropertyOrAccessor", n[n.ClassMember = 106500] = "ClassMember", n[n.ExportSupportsDefaultModifier = 112] = "ExportSupportsDefaultModifier", n[n.ExportDoesNotSupportDefaultModifier = -113] = "ExportDoesNotSupportDefaultModifier", n[n.Classifiable = 2885600] = "Classifiable", n[n.LateBindingContainer = 6256] = "LateBindingContainer";
            })(he = e.SymbolFlags || (e.SymbolFlags = {}));
            var F;
            (function(n) {
              n[n.Numeric = 0] = "Numeric", n[n.Literal = 1] = "Literal";
            })(F = e.EnumKind || (e.EnumKind = {}));
            var x;
            (function(n) {
              n[n.Instantiated = 1] = "Instantiated", n[n.SyntheticProperty = 2] = "SyntheticProperty", n[n.SyntheticMethod = 4] = "SyntheticMethod", n[n.Readonly = 8] = "Readonly", n[n.ReadPartial = 16] = "ReadPartial", n[n.WritePartial = 32] = "WritePartial", n[n.HasNonUniformType = 64] = "HasNonUniformType", n[n.HasLiteralType = 128] = "HasLiteralType", n[n.ContainsPublic = 256] = "ContainsPublic", n[n.ContainsProtected = 512] = "ContainsProtected", n[n.ContainsPrivate = 1024] = "ContainsPrivate", n[n.ContainsStatic = 2048] = "ContainsStatic", n[n.Late = 4096] = "Late", n[n.ReverseMapped = 8192] = "ReverseMapped", n[n.OptionalParameter = 16384] = "OptionalParameter", n[n.RestParameter = 32768] = "RestParameter", n[n.DeferredType = 65536] = "DeferredType", n[n.HasNeverType = 131072] = "HasNeverType", n[n.Mapped = 262144] = "Mapped", n[n.StripOptional = 524288] = "StripOptional", n[n.Unresolved = 1048576] = "Unresolved", n[n.Synthetic = 6] = "Synthetic", n[n.Discriminant = 192] = "Discriminant", n[n.Partial = 48] = "Partial";
            })(x = e.CheckFlags || (e.CheckFlags = {}));
            var X;
            (function(n) {
              n.Call = "__call", n.Constructor = "__constructor", n.New = "__new", n.Index = "__index", n.ExportStar = "__export", n.Global = "__global", n.Missing = "__missing", n.Type = "__type", n.Object = "__object", n.JSXAttributes = "__jsxAttributes", n.Class = "__class", n.Function = "__function", n.Computed = "__computed", n.Resolving = "__resolving__", n.ExportEquals = "export=", n.Default = "default", n.This = "this";
            })(X = e.InternalSymbolName || (e.InternalSymbolName = {}));
            var $;
            (function(n) {
              n[n.TypeChecked = 1] = "TypeChecked", n[n.LexicalThis = 2] = "LexicalThis", n[n.CaptureThis = 4] = "CaptureThis", n[n.CaptureNewTarget = 8] = "CaptureNewTarget", n[n.SuperInstance = 256] = "SuperInstance", n[n.SuperStatic = 512] = "SuperStatic", n[n.ContextChecked = 1024] = "ContextChecked", n[n.AsyncMethodWithSuper = 2048] = "AsyncMethodWithSuper", n[n.AsyncMethodWithSuperBinding = 4096] = "AsyncMethodWithSuperBinding", n[n.CaptureArguments = 8192] = "CaptureArguments", n[n.EnumValuesComputed = 16384] = "EnumValuesComputed", n[n.LexicalModuleMergesWithClass = 32768] = "LexicalModuleMergesWithClass", n[n.LoopWithCapturedBlockScopedBinding = 65536] = "LoopWithCapturedBlockScopedBinding", n[n.ContainsCapturedBlockScopeBinding = 131072] = "ContainsCapturedBlockScopeBinding", n[n.CapturedBlockScopedBinding = 262144] = "CapturedBlockScopedBinding", n[n.BlockScopedBindingInLoop = 524288] = "BlockScopedBindingInLoop", n[n.ClassWithBodyScopedClassBinding = 1048576] = "ClassWithBodyScopedClassBinding", n[n.BodyScopedClassBinding = 2097152] = "BodyScopedClassBinding", n[n.NeedsLoopOutParameter = 4194304] = "NeedsLoopOutParameter", n[n.AssignmentsMarked = 8388608] = "AssignmentsMarked", n[n.ClassWithConstructorReference = 16777216] = "ClassWithConstructorReference", n[n.ConstructorReferenceInClass = 33554432] = "ConstructorReferenceInClass", n[n.ContainsClassWithPrivateIdentifiers = 67108864] = "ContainsClassWithPrivateIdentifiers", n[n.ContainsSuperPropertyInStaticInitializer = 134217728] = "ContainsSuperPropertyInStaticInitializer", n[n.InCheckIdentifier = 268435456] = "InCheckIdentifier";
            })($ = e.NodeCheckFlags || (e.NodeCheckFlags = {}));
            var A;
            (function(n) {
              n[n.Any = 1] = "Any", n[n.Unknown = 2] = "Unknown", n[n.String = 4] = "String", n[n.Number = 8] = "Number", n[n.Boolean = 16] = "Boolean", n[n.Enum = 32] = "Enum", n[n.BigInt = 64] = "BigInt", n[n.StringLiteral = 128] = "StringLiteral", n[n.NumberLiteral = 256] = "NumberLiteral", n[n.BooleanLiteral = 512] = "BooleanLiteral", n[n.EnumLiteral = 1024] = "EnumLiteral", n[n.BigIntLiteral = 2048] = "BigIntLiteral", n[n.ESSymbol = 4096] = "ESSymbol", n[n.UniqueESSymbol = 8192] = "UniqueESSymbol", n[n.Void = 16384] = "Void", n[n.Undefined = 32768] = "Undefined", n[n.Null = 65536] = "Null", n[n.Never = 131072] = "Never", n[n.TypeParameter = 262144] = "TypeParameter", n[n.Object = 524288] = "Object", n[n.Union = 1048576] = "Union", n[n.Intersection = 2097152] = "Intersection", n[n.Index = 4194304] = "Index", n[n.IndexedAccess = 8388608] = "IndexedAccess", n[n.Conditional = 16777216] = "Conditional", n[n.Substitution = 33554432] = "Substitution", n[n.NonPrimitive = 67108864] = "NonPrimitive", n[n.TemplateLiteral = 134217728] = "TemplateLiteral", n[n.StringMapping = 268435456] = "StringMapping", n[n.AnyOrUnknown = 3] = "AnyOrUnknown", n[n.Nullable = 98304] = "Nullable", n[n.Literal = 2944] = "Literal", n[n.Unit = 109440] = "Unit", n[n.StringOrNumberLiteral = 384] = "StringOrNumberLiteral", n[n.StringOrNumberLiteralOrUnique = 8576] = "StringOrNumberLiteralOrUnique", n[n.DefinitelyFalsy = 117632] = "DefinitelyFalsy", n[n.PossiblyFalsy = 117724] = "PossiblyFalsy", n[n.Intrinsic = 67359327] = "Intrinsic", n[n.Primitive = 131068] = "Primitive", n[n.StringLike = 402653316] = "StringLike", n[n.NumberLike = 296] = "NumberLike", n[n.BigIntLike = 2112] = "BigIntLike", n[n.BooleanLike = 528] = "BooleanLike", n[n.EnumLike = 1056] = "EnumLike", n[n.ESSymbolLike = 12288] = "ESSymbolLike", n[n.VoidLike = 49152] = "VoidLike", n[n.DefinitelyNonNullable = 470302716] = "DefinitelyNonNullable", n[n.DisjointDomains = 469892092] = "DisjointDomains", n[n.UnionOrIntersection = 3145728] = "UnionOrIntersection", n[n.StructuredType = 3670016] = "StructuredType", n[n.TypeVariable = 8650752] = "TypeVariable", n[n.InstantiableNonPrimitive = 58982400] = "InstantiableNonPrimitive", n[n.InstantiablePrimitive = 406847488] = "InstantiablePrimitive", n[n.Instantiable = 465829888] = "Instantiable", n[n.StructuredOrInstantiable = 469499904] = "StructuredOrInstantiable", n[n.ObjectFlagsType = 3899393] = "ObjectFlagsType", n[n.Simplifiable = 25165824] = "Simplifiable", n[n.Singleton = 67358815] = "Singleton", n[n.Narrowable = 536624127] = "Narrowable", n[n.IncludesMask = 205258751] = "IncludesMask", n[n.IncludesMissingType = 262144] = "IncludesMissingType", n[n.IncludesNonWideningType = 4194304] = "IncludesNonWideningType", n[n.IncludesWildcard = 8388608] = "IncludesWildcard", n[n.IncludesEmptyObject = 16777216] = "IncludesEmptyObject", n[n.IncludesInstantiable = 33554432] = "IncludesInstantiable", n[n.NotPrimitiveUnion = 36323363] = "NotPrimitiveUnion";
            })(A = e.TypeFlags || (e.TypeFlags = {}));
            var y;
            (function(n) {
              n[n.Class = 1] = "Class", n[n.Interface = 2] = "Interface", n[n.Reference = 4] = "Reference", n[n.Tuple = 8] = "Tuple", n[n.Anonymous = 16] = "Anonymous", n[n.Mapped = 32] = "Mapped", n[n.Instantiated = 64] = "Instantiated", n[n.ObjectLiteral = 128] = "ObjectLiteral", n[n.EvolvingArray = 256] = "EvolvingArray", n[n.ObjectLiteralPatternWithComputedProperties = 512] = "ObjectLiteralPatternWithComputedProperties", n[n.ReverseMapped = 1024] = "ReverseMapped", n[n.JsxAttributes = 2048] = "JsxAttributes", n[n.JSLiteral = 4096] = "JSLiteral", n[n.FreshLiteral = 8192] = "FreshLiteral", n[n.ArrayLiteral = 16384] = "ArrayLiteral", n[n.PrimitiveUnion = 32768] = "PrimitiveUnion", n[n.ContainsWideningType = 65536] = "ContainsWideningType", n[n.ContainsObjectOrArrayLiteral = 131072] = "ContainsObjectOrArrayLiteral", n[n.NonInferrableType = 262144] = "NonInferrableType", n[n.CouldContainTypeVariablesComputed = 524288] = "CouldContainTypeVariablesComputed", n[n.CouldContainTypeVariables = 1048576] = "CouldContainTypeVariables", n[n.ClassOrInterface = 3] = "ClassOrInterface", n[n.RequiresWidening = 196608] = "RequiresWidening", n[n.PropagatingFlags = 458752] = "PropagatingFlags", n[n.ObjectTypeKindMask = 1343] = "ObjectTypeKindMask", n[n.ContainsSpread = 2097152] = "ContainsSpread", n[n.ObjectRestType = 4194304] = "ObjectRestType", n[n.InstantiationExpressionType = 8388608] = "InstantiationExpressionType", n[n.IsClassInstanceClone = 16777216] = "IsClassInstanceClone", n[n.IdenticalBaseTypeCalculated = 33554432] = "IdenticalBaseTypeCalculated", n[n.IdenticalBaseTypeExists = 67108864] = "IdenticalBaseTypeExists", n[n.IsGenericTypeComputed = 2097152] = "IsGenericTypeComputed", n[n.IsGenericObjectType = 4194304] = "IsGenericObjectType", n[n.IsGenericIndexType = 8388608] = "IsGenericIndexType", n[n.IsGenericType = 12582912] = "IsGenericType", n[n.ContainsIntersections = 16777216] = "ContainsIntersections", n[n.IsNeverIntersectionComputed = 16777216] = "IsNeverIntersectionComputed", n[n.IsNeverIntersection = 33554432] = "IsNeverIntersection";
            })(y = e.ObjectFlags || (e.ObjectFlags = {}));
            var V;
            (function(n) {
              n[n.Invariant = 0] = "Invariant", n[n.Covariant = 1] = "Covariant", n[n.Contravariant = 2] = "Contravariant", n[n.Bivariant = 3] = "Bivariant", n[n.Independent = 4] = "Independent", n[n.VarianceMask = 7] = "VarianceMask", n[n.Unmeasurable = 8] = "Unmeasurable", n[n.Unreliable = 16] = "Unreliable", n[n.AllowsStructuralFallback = 24] = "AllowsStructuralFallback";
            })(V = e.VarianceFlags || (e.VarianceFlags = {}));
            var L;
            (function(n) {
              n[n.Required = 1] = "Required", n[n.Optional = 2] = "Optional", n[n.Rest = 4] = "Rest", n[n.Variadic = 8] = "Variadic", n[n.Fixed = 3] = "Fixed", n[n.Variable = 12] = "Variable", n[n.NonRequired = 14] = "NonRequired", n[n.NonRest = 11] = "NonRest";
            })(L = e.ElementFlags || (e.ElementFlags = {}));
            var P;
            (function(n) {
              n[n.None = 0] = "None", n[n.IncludeUndefined = 1] = "IncludeUndefined", n[n.NoIndexSignatures = 2] = "NoIndexSignatures", n[n.Writing = 4] = "Writing", n[n.CacheSymbol = 8] = "CacheSymbol", n[n.NoTupleBoundsCheck = 16] = "NoTupleBoundsCheck", n[n.ExpressionPosition = 32] = "ExpressionPosition", n[n.ReportDeprecated = 64] = "ReportDeprecated", n[n.SuppressNoImplicitAnyError = 128] = "SuppressNoImplicitAnyError", n[n.Contextual = 256] = "Contextual", n[n.Persistent = 1] = "Persistent";
            })(P = e.AccessFlags || (e.AccessFlags = {}));
            var k;
            (function(n) {
              n[n.Component = 0] = "Component", n[n.Function = 1] = "Function", n[n.Mixed = 2] = "Mixed";
            })(k = e.JsxReferenceKind || (e.JsxReferenceKind = {}));
            var Y;
            (function(n) {
              n[n.Call = 0] = "Call", n[n.Construct = 1] = "Construct";
            })(Y = e.SignatureKind || (e.SignatureKind = {}));
            var U;
            (function(n) {
              n[n.None = 0] = "None", n[n.HasRestParameter = 1] = "HasRestParameter", n[n.HasLiteralTypes = 2] = "HasLiteralTypes", n[n.Abstract = 4] = "Abstract", n[n.IsInnerCallChain = 8] = "IsInnerCallChain", n[n.IsOuterCallChain = 16] = "IsOuterCallChain", n[n.IsUntypedSignatureInJSFile = 32] = "IsUntypedSignatureInJSFile", n[n.PropagatingFlags = 39] = "PropagatingFlags", n[n.CallChainFlags = 24] = "CallChainFlags";
            })(U = e.SignatureFlags || (e.SignatureFlags = {}));
            var j;
            (function(n) {
              n[n.String = 0] = "String", n[n.Number = 1] = "Number";
            })(j = e.IndexKind || (e.IndexKind = {}));
            var H;
            (function(n) {
              n[n.Simple = 0] = "Simple", n[n.Array = 1] = "Array", n[n.Function = 2] = "Function", n[n.Composite = 3] = "Composite", n[n.Merged = 4] = "Merged";
            })(H = e.TypeMapKind || (e.TypeMapKind = {}));
            var I;
            (function(n) {
              n[n.NakedTypeVariable = 1] = "NakedTypeVariable", n[n.SpeculativeTuple = 2] = "SpeculativeTuple", n[n.SubstituteSource = 4] = "SubstituteSource", n[n.HomomorphicMappedType = 8] = "HomomorphicMappedType", n[n.PartialHomomorphicMappedType = 16] = "PartialHomomorphicMappedType", n[n.MappedTypeConstraint = 32] = "MappedTypeConstraint", n[n.ContravariantConditional = 64] = "ContravariantConditional", n[n.ReturnType = 128] = "ReturnType", n[n.LiteralKeyof = 256] = "LiteralKeyof", n[n.NoConstraints = 512] = "NoConstraints", n[n.AlwaysStrict = 1024] = "AlwaysStrict", n[n.MaxValue = 2048] = "MaxValue", n[n.PriorityImpliesCombination = 416] = "PriorityImpliesCombination", n[n.Circularity = -1] = "Circularity";
            })(I = e.InferencePriority || (e.InferencePriority = {}));
            var l;
            (function(n) {
              n[n.None = 0] = "None", n[n.NoDefault = 1] = "NoDefault", n[n.AnyDefault = 2] = "AnyDefault", n[n.SkippedGenericFunction = 4] = "SkippedGenericFunction";
            })(l = e.InferenceFlags || (e.InferenceFlags = {}));
            var d;
            (function(n) {
              n[n.False = 0] = "False", n[n.Unknown = 1] = "Unknown", n[n.Maybe = 3] = "Maybe", n[n.True = -1] = "True";
            })(d = e.Ternary || (e.Ternary = {}));
            var D;
            (function(n) {
              n[n.None = 0] = "None", n[n.ExportsProperty = 1] = "ExportsProperty", n[n.ModuleExports = 2] = "ModuleExports", n[n.PrototypeProperty = 3] = "PrototypeProperty", n[n.ThisProperty = 4] = "ThisProperty", n[n.Property = 5] = "Property", n[n.Prototype = 6] = "Prototype", n[n.ObjectDefinePropertyValue = 7] = "ObjectDefinePropertyValue", n[n.ObjectDefinePropertyExports = 8] = "ObjectDefinePropertyExports", n[n.ObjectDefinePrototypeProperty = 9] = "ObjectDefinePrototypeProperty";
            })(D = e.AssignmentDeclarationKind || (e.AssignmentDeclarationKind = {}));
            var fe;
            (function(n) {
              n[n.Warning = 0] = "Warning", n[n.Error = 1] = "Error", n[n.Suggestion = 2] = "Suggestion", n[n.Message = 3] = "Message";
            })(fe = e.DiagnosticCategory || (e.DiagnosticCategory = {}));
            function g(n, lr) {
              lr === void 0 && (lr = true);
              var be = fe[n.category];
              return lr ? be.toLowerCase() : be;
            }
            e.diagnosticCategoryName = g;
            var ne;
            (function(n) {
              n[n.Classic = 1] = "Classic", n[n.NodeJs = 2] = "NodeJs", n[n.Node16 = 3] = "Node16", n[n.NodeNext = 99] = "NodeNext";
            })(ne = e.ModuleResolutionKind || (e.ModuleResolutionKind = {}));
            var ue;
            (function(n) {
              n[n.Legacy = 1] = "Legacy", n[n.Auto = 2] = "Auto", n[n.Force = 3] = "Force";
            })(ue = e.ModuleDetectionKind || (e.ModuleDetectionKind = {}));
            var We;
            (function(n) {
              n[n.FixedPollingInterval = 0] = "FixedPollingInterval", n[n.PriorityPollingInterval = 1] = "PriorityPollingInterval", n[n.DynamicPriorityPolling = 2] = "DynamicPriorityPolling", n[n.FixedChunkSizePolling = 3] = "FixedChunkSizePolling", n[n.UseFsEvents = 4] = "UseFsEvents", n[n.UseFsEventsOnParentDirectory = 5] = "UseFsEventsOnParentDirectory";
            })(We = e.WatchFileKind || (e.WatchFileKind = {}));
            var Fe;
            (function(n) {
              n[n.UseFsEvents = 0] = "UseFsEvents", n[n.FixedPollingInterval = 1] = "FixedPollingInterval", n[n.DynamicPriorityPolling = 2] = "DynamicPriorityPolling", n[n.FixedChunkSizePolling = 3] = "FixedChunkSizePolling";
            })(Fe = e.WatchDirectoryKind || (e.WatchDirectoryKind = {}));
            var Z;
            (function(n) {
              n[n.FixedInterval = 0] = "FixedInterval", n[n.PriorityInterval = 1] = "PriorityInterval", n[n.DynamicPriority = 2] = "DynamicPriority", n[n.FixedChunkSize = 3] = "FixedChunkSize";
            })(Z = e.PollingWatchKind || (e.PollingWatchKind = {}));
            var Be;
            (function(n) {
              n[n.None = 0] = "None", n[n.CommonJS = 1] = "CommonJS", n[n.AMD = 2] = "AMD", n[n.UMD = 3] = "UMD", n[n.System = 4] = "System", n[n.ES2015 = 5] = "ES2015", n[n.ES2020 = 6] = "ES2020", n[n.ES2022 = 7] = "ES2022", n[n.ESNext = 99] = "ESNext", n[n.Node16 = 100] = "Node16", n[n.NodeNext = 199] = "NodeNext";
            })(Be = e.ModuleKind || (e.ModuleKind = {}));
            var ge;
            (function(n) {
              n[n.None = 0] = "None", n[n.Preserve = 1] = "Preserve", n[n.React = 2] = "React", n[n.ReactNative = 3] = "ReactNative", n[n.ReactJSX = 4] = "ReactJSX", n[n.ReactJSXDev = 5] = "ReactJSXDev";
            })(ge = e.JsxEmit || (e.JsxEmit = {}));
            var Re;
            (function(n) {
              n[n.Remove = 0] = "Remove", n[n.Preserve = 1] = "Preserve", n[n.Error = 2] = "Error";
            })(Re = e.ImportsNotUsedAsValues || (e.ImportsNotUsedAsValues = {}));
            var ze;
            (function(n) {
              n[n.CarriageReturnLineFeed = 0] = "CarriageReturnLineFeed", n[n.LineFeed = 1] = "LineFeed";
            })(ze = e.NewLineKind || (e.NewLineKind = {}));
            var Ee;
            (function(n) {
              n[n.Unknown = 0] = "Unknown", n[n.JS = 1] = "JS", n[n.JSX = 2] = "JSX", n[n.TS = 3] = "TS", n[n.TSX = 4] = "TSX", n[n.External = 5] = "External", n[n.JSON = 6] = "JSON", n[n.Deferred = 7] = "Deferred";
            })(Ee = e.ScriptKind || (e.ScriptKind = {}));
            var He;
            (function(n) {
              n[n.ES3 = 0] = "ES3", n[n.ES5 = 1] = "ES5", n[n.ES2015 = 2] = "ES2015", n[n.ES2016 = 3] = "ES2016", n[n.ES2017 = 4] = "ES2017", n[n.ES2018 = 5] = "ES2018", n[n.ES2019 = 6] = "ES2019", n[n.ES2020 = 7] = "ES2020", n[n.ES2021 = 8] = "ES2021", n[n.ES2022 = 9] = "ES2022", n[n.ESNext = 99] = "ESNext", n[n.JSON = 100] = "JSON", n[n.Latest = 99] = "Latest";
            })(He = e.ScriptTarget || (e.ScriptTarget = {}));
            var rr;
            (function(n) {
              n[n.Standard = 0] = "Standard", n[n.JSX = 1] = "JSX";
            })(rr = e.LanguageVariant || (e.LanguageVariant = {}));
            var Ie;
            (function(n) {
              n[n.None = 0] = "None", n[n.Recursive = 1] = "Recursive";
            })(Ie = e.WatchDirectoryFlags || (e.WatchDirectoryFlags = {}));
            var _e;
            (function(n) {
              n[n.nullCharacter = 0] = "nullCharacter", n[n.maxAsciiCharacter = 127] = "maxAsciiCharacter", n[n.lineFeed = 10] = "lineFeed", n[n.carriageReturn = 13] = "carriageReturn", n[n.lineSeparator = 8232] = "lineSeparator", n[n.paragraphSeparator = 8233] = "paragraphSeparator", n[n.nextLine = 133] = "nextLine", n[n.space = 32] = "space", n[n.nonBreakingSpace = 160] = "nonBreakingSpace", n[n.enQuad = 8192] = "enQuad", n[n.emQuad = 8193] = "emQuad", n[n.enSpace = 8194] = "enSpace", n[n.emSpace = 8195] = "emSpace", n[n.threePerEmSpace = 8196] = "threePerEmSpace", n[n.fourPerEmSpace = 8197] = "fourPerEmSpace", n[n.sixPerEmSpace = 8198] = "sixPerEmSpace", n[n.figureSpace = 8199] = "figureSpace", n[n.punctuationSpace = 8200] = "punctuationSpace", n[n.thinSpace = 8201] = "thinSpace", n[n.hairSpace = 8202] = "hairSpace", n[n.zeroWidthSpace = 8203] = "zeroWidthSpace", n[n.narrowNoBreakSpace = 8239] = "narrowNoBreakSpace", n[n.ideographicSpace = 12288] = "ideographicSpace", n[n.mathematicalSpace = 8287] = "mathematicalSpace", n[n.ogham = 5760] = "ogham", n[n._ = 95] = "_", n[n.$ = 36] = "$", n[n._0 = 48] = "_0", n[n._1 = 49] = "_1", n[n._2 = 50] = "_2", n[n._3 = 51] = "_3", n[n._4 = 52] = "_4", n[n._5 = 53] = "_5", n[n._6 = 54] = "_6", n[n._7 = 55] = "_7", n[n._8 = 56] = "_8", n[n._9 = 57] = "_9", n[n.a = 97] = "a", n[n.b = 98] = "b", n[n.c = 99] = "c", n[n.d = 100] = "d", n[n.e = 101] = "e", n[n.f = 102] = "f", n[n.g = 103] = "g", n[n.h = 104] = "h", n[n.i = 105] = "i", n[n.j = 106] = "j", n[n.k = 107] = "k", n[n.l = 108] = "l", n[n.m = 109] = "m", n[n.n = 110] = "n", n[n.o = 111] = "o", n[n.p = 112] = "p", n[n.q = 113] = "q", n[n.r = 114] = "r", n[n.s = 115] = "s", n[n.t = 116] = "t", n[n.u = 117] = "u", n[n.v = 118] = "v", n[n.w = 119] = "w", n[n.x = 120] = "x", n[n.y = 121] = "y", n[n.z = 122] = "z", n[n.A = 65] = "A", n[n.B = 66] = "B", n[n.C = 67] = "C", n[n.D = 68] = "D", n[n.E = 69] = "E", n[n.F = 70] = "F", n[n.G = 71] = "G", n[n.H = 72] = "H", n[n.I = 73] = "I", n[n.J = 74] = "J", n[n.K = 75] = "K", n[n.L = 76] = "L", n[n.M = 77] = "M", n[n.N = 78] = "N", n[n.O = 79] = "O", n[n.P = 80] = "P", n[n.Q = 81] = "Q", n[n.R = 82] = "R", n[n.S = 83] = "S", n[n.T = 84] = "T", n[n.U = 85] = "U", n[n.V = 86] = "V", n[n.W = 87] = "W", n[n.X = 88] = "X", n[n.Y = 89] = "Y", n[n.Z = 90] = "Z", n[n.ampersand = 38] = "ampersand", n[n.asterisk = 42] = "asterisk", n[n.at = 64] = "at", n[n.backslash = 92] = "backslash", n[n.backtick = 96] = "backtick", n[n.bar = 124] = "bar", n[n.caret = 94] = "caret", n[n.closeBrace = 125] = "closeBrace", n[n.closeBracket = 93] = "closeBracket", n[n.closeParen = 41] = "closeParen", n[n.colon = 58] = "colon", n[n.comma = 44] = "comma", n[n.dot = 46] = "dot", n[n.doubleQuote = 34] = "doubleQuote", n[n.equals = 61] = "equals", n[n.exclamation = 33] = "exclamation", n[n.greaterThan = 62] = "greaterThan", n[n.hash = 35] = "hash", n[n.lessThan = 60] = "lessThan", n[n.minus = 45] = "minus", n[n.openBrace = 123] = "openBrace", n[n.openBracket = 91] = "openBracket", n[n.openParen = 40] = "openParen", n[n.percent = 37] = "percent", n[n.plus = 43] = "plus", n[n.question = 63] = "question", n[n.semicolon = 59] = "semicolon", n[n.singleQuote = 39] = "singleQuote", n[n.slash = 47] = "slash", n[n.tilde = 126] = "tilde", n[n.backspace = 8] = "backspace", n[n.formFeed = 12] = "formFeed", n[n.byteOrderMark = 65279] = "byteOrderMark", n[n.tab = 9] = "tab", n[n.verticalTab = 11] = "verticalTab";
            })(_e = e.CharacterCodes || (e.CharacterCodes = {}));
            var we;
            (function(n) {
              n.Ts = ".ts", n.Tsx = ".tsx", n.Dts = ".d.ts", n.Js = ".js", n.Jsx = ".jsx", n.Json = ".json", n.TsBuildInfo = ".tsbuildinfo", n.Mjs = ".mjs", n.Mts = ".mts", n.Dmts = ".d.mts", n.Cjs = ".cjs", n.Cts = ".cts", n.Dcts = ".d.cts";
            })(we = e.Extension || (e.Extension = {}));
            var de;
            (function(n) {
              n[n.None = 0] = "None", n[n.ContainsTypeScript = 1] = "ContainsTypeScript", n[n.ContainsJsx = 2] = "ContainsJsx", n[n.ContainsESNext = 4] = "ContainsESNext", n[n.ContainsES2022 = 8] = "ContainsES2022", n[n.ContainsES2021 = 16] = "ContainsES2021", n[n.ContainsES2020 = 32] = "ContainsES2020", n[n.ContainsES2019 = 64] = "ContainsES2019", n[n.ContainsES2018 = 128] = "ContainsES2018", n[n.ContainsES2017 = 256] = "ContainsES2017", n[n.ContainsES2016 = 512] = "ContainsES2016", n[n.ContainsES2015 = 1024] = "ContainsES2015", n[n.ContainsGenerator = 2048] = "ContainsGenerator", n[n.ContainsDestructuringAssignment = 4096] = "ContainsDestructuringAssignment", n[n.ContainsTypeScriptClassSyntax = 4096] = "ContainsTypeScriptClassSyntax", n[n.ContainsLexicalThis = 8192] = "ContainsLexicalThis", n[n.ContainsRestOrSpread = 16384] = "ContainsRestOrSpread", n[n.ContainsObjectRestOrSpread = 32768] = "ContainsObjectRestOrSpread", n[n.ContainsComputedPropertyName = 65536] = "ContainsComputedPropertyName", n[n.ContainsBlockScopedBinding = 131072] = "ContainsBlockScopedBinding", n[n.ContainsBindingPattern = 262144] = "ContainsBindingPattern", n[n.ContainsYield = 524288] = "ContainsYield", n[n.ContainsAwait = 1048576] = "ContainsAwait", n[n.ContainsHoistedDeclarationOrCompletion = 2097152] = "ContainsHoistedDeclarationOrCompletion", n[n.ContainsDynamicImport = 4194304] = "ContainsDynamicImport", n[n.ContainsClassFields = 8388608] = "ContainsClassFields", n[n.ContainsPossibleTopLevelAwait = 16777216] = "ContainsPossibleTopLevelAwait", n[n.ContainsLexicalSuper = 33554432] = "ContainsLexicalSuper", n[n.ContainsUpdateExpressionForIdentifier = 67108864] = "ContainsUpdateExpressionForIdentifier", n[n.HasComputedFlags = 536870912] = "HasComputedFlags", n[n.AssertTypeScript = 1] = "AssertTypeScript", n[n.AssertJsx = 2] = "AssertJsx", n[n.AssertESNext = 4] = "AssertESNext", n[n.AssertES2022 = 8] = "AssertES2022", n[n.AssertES2021 = 16] = "AssertES2021", n[n.AssertES2020 = 32] = "AssertES2020", n[n.AssertES2019 = 64] = "AssertES2019", n[n.AssertES2018 = 128] = "AssertES2018", n[n.AssertES2017 = 256] = "AssertES2017", n[n.AssertES2016 = 512] = "AssertES2016", n[n.AssertES2015 = 1024] = "AssertES2015", n[n.AssertGenerator = 2048] = "AssertGenerator", n[n.AssertDestructuringAssignment = 4096] = "AssertDestructuringAssignment", n[n.OuterExpressionExcludes = 536870912] = "OuterExpressionExcludes", n[n.PropertyAccessExcludes = 536870912] = "PropertyAccessExcludes", n[n.NodeExcludes = 536870912] = "NodeExcludes", n[n.ArrowFunctionExcludes = 557748224] = "ArrowFunctionExcludes", n[n.FunctionExcludes = 591310848] = "FunctionExcludes", n[n.ConstructorExcludes = 591306752] = "ConstructorExcludes", n[n.MethodOrAccessorExcludes = 574529536] = "MethodOrAccessorExcludes", n[n.PropertyExcludes = 570433536] = "PropertyExcludes", n[n.ClassExcludes = 536940544] = "ClassExcludes", n[n.ModuleExcludes = 589443072] = "ModuleExcludes", n[n.TypeExcludes = -2] = "TypeExcludes", n[n.ObjectLiteralExcludes = 536973312] = "ObjectLiteralExcludes", n[n.ArrayLiteralOrCallOrNewExcludes = 536887296] = "ArrayLiteralOrCallOrNewExcludes", n[n.VariableDeclarationListExcludes = 537165824] = "VariableDeclarationListExcludes", n[n.ParameterExcludes = 536870912] = "ParameterExcludes", n[n.CatchClauseExcludes = 536903680] = "CatchClauseExcludes", n[n.BindingPatternExcludes = 536887296] = "BindingPatternExcludes", n[n.ContainsLexicalThisOrSuper = 33562624] = "ContainsLexicalThisOrSuper", n[n.PropertyNamePropagatingFlags = 33562624] = "PropertyNamePropagatingFlags";
            })(de = e.TransformFlags || (e.TransformFlags = {}));
            var ye;
            (function(n) {
              n[n.TabStop = 0] = "TabStop", n[n.Placeholder = 1] = "Placeholder", n[n.Choice = 2] = "Choice", n[n.Variable = 3] = "Variable";
            })(ye = e.SnippetKind || (e.SnippetKind = {}));
            var Ae;
            (function(n) {
              n[n.None = 0] = "None", n[n.SingleLine = 1] = "SingleLine", n[n.AdviseOnEmitNode = 2] = "AdviseOnEmitNode", n[n.NoSubstitution = 4] = "NoSubstitution", n[n.CapturesThis = 8] = "CapturesThis", n[n.NoLeadingSourceMap = 16] = "NoLeadingSourceMap", n[n.NoTrailingSourceMap = 32] = "NoTrailingSourceMap", n[n.NoSourceMap = 48] = "NoSourceMap", n[n.NoNestedSourceMaps = 64] = "NoNestedSourceMaps", n[n.NoTokenLeadingSourceMaps = 128] = "NoTokenLeadingSourceMaps", n[n.NoTokenTrailingSourceMaps = 256] = "NoTokenTrailingSourceMaps", n[n.NoTokenSourceMaps = 384] = "NoTokenSourceMaps", n[n.NoLeadingComments = 512] = "NoLeadingComments", n[n.NoTrailingComments = 1024] = "NoTrailingComments", n[n.NoComments = 1536] = "NoComments", n[n.NoNestedComments = 2048] = "NoNestedComments", n[n.HelperName = 4096] = "HelperName", n[n.ExportName = 8192] = "ExportName", n[n.LocalName = 16384] = "LocalName", n[n.InternalName = 32768] = "InternalName", n[n.Indented = 65536] = "Indented", n[n.NoIndentation = 131072] = "NoIndentation", n[n.AsyncFunctionBody = 262144] = "AsyncFunctionBody", n[n.ReuseTempVariableScope = 524288] = "ReuseTempVariableScope", n[n.CustomPrologue = 1048576] = "CustomPrologue", n[n.NoHoisting = 2097152] = "NoHoisting", n[n.HasEndOfDeclarationMarker = 4194304] = "HasEndOfDeclarationMarker", n[n.Iterator = 8388608] = "Iterator", n[n.NoAsciiEscaping = 16777216] = "NoAsciiEscaping", n[n.TypeScriptClassWrapper = 33554432] = "TypeScriptClassWrapper", n[n.NeverApplyImportHelper = 67108864] = "NeverApplyImportHelper", n[n.IgnoreSourceNewlines = 134217728] = "IgnoreSourceNewlines", n[n.Immutable = 268435456] = "Immutable", n[n.IndirectCall = 536870912] = "IndirectCall";
            })(Ae = e.EmitFlags || (e.EmitFlags = {}));
            var er;
            (function(n) {
              n[n.Extends = 1] = "Extends", n[n.Assign = 2] = "Assign", n[n.Rest = 4] = "Rest", n[n.Decorate = 8] = "Decorate", n[n.Metadata = 16] = "Metadata", n[n.Param = 32] = "Param", n[n.Awaiter = 64] = "Awaiter", n[n.Generator = 128] = "Generator", n[n.Values = 256] = "Values", n[n.Read = 512] = "Read", n[n.SpreadArray = 1024] = "SpreadArray", n[n.Await = 2048] = "Await", n[n.AsyncGenerator = 4096] = "AsyncGenerator", n[n.AsyncDelegator = 8192] = "AsyncDelegator", n[n.AsyncValues = 16384] = "AsyncValues", n[n.ExportStar = 32768] = "ExportStar", n[n.ImportStar = 65536] = "ImportStar", n[n.ImportDefault = 131072] = "ImportDefault", n[n.MakeTemplateObject = 262144] = "MakeTemplateObject", n[n.ClassPrivateFieldGet = 524288] = "ClassPrivateFieldGet", n[n.ClassPrivateFieldSet = 1048576] = "ClassPrivateFieldSet", n[n.ClassPrivateFieldIn = 2097152] = "ClassPrivateFieldIn", n[n.CreateBinding = 4194304] = "CreateBinding", n[n.FirstEmitHelper = 1] = "FirstEmitHelper", n[n.LastEmitHelper = 4194304] = "LastEmitHelper", n[n.ForOfIncludes = 256] = "ForOfIncludes", n[n.ForAwaitOfIncludes = 16384] = "ForAwaitOfIncludes", n[n.AsyncGeneratorIncludes = 6144] = "AsyncGeneratorIncludes", n[n.AsyncDelegatorIncludes = 26624] = "AsyncDelegatorIncludes", n[n.SpreadIncludes = 1536] = "SpreadIncludes";
            })(er = e.ExternalEmitHelpers || (e.ExternalEmitHelpers = {}));
            var ir;
            (function(n) {
              n[n.SourceFile = 0] = "SourceFile", n[n.Expression = 1] = "Expression", n[n.IdentifierName = 2] = "IdentifierName", n[n.MappedTypeParameter = 3] = "MappedTypeParameter", n[n.Unspecified = 4] = "Unspecified", n[n.EmbeddedStatement = 5] = "EmbeddedStatement", n[n.JsxAttributeValue = 6] = "JsxAttributeValue";
            })(ir = e.EmitHint || (e.EmitHint = {}));
            var Cr;
            (function(n) {
              n[n.Parentheses = 1] = "Parentheses", n[n.TypeAssertions = 2] = "TypeAssertions", n[n.NonNullAssertions = 4] = "NonNullAssertions", n[n.PartiallyEmittedExpressions = 8] = "PartiallyEmittedExpressions", n[n.Assertions = 6] = "Assertions", n[n.All = 15] = "All", n[n.ExcludeJSDocTypeAssertion = 16] = "ExcludeJSDocTypeAssertion";
            })(Cr = e.OuterExpressionKinds || (e.OuterExpressionKinds = {}));
            var Ye;
            (function(n) {
              n[n.None = 0] = "None", n[n.InParameters = 1] = "InParameters", n[n.VariablesHoistedInParameters = 2] = "VariablesHoistedInParameters";
            })(Ye = e.LexicalEnvironmentFlags || (e.LexicalEnvironmentFlags = {}));
            var Br;
            (function(n) {
              n.Prologue = "prologue", n.EmitHelpers = "emitHelpers", n.NoDefaultLib = "no-default-lib", n.Reference = "reference", n.Type = "type", n.TypeResolutionModeRequire = "type-require", n.TypeResolutionModeImport = "type-import", n.Lib = "lib", n.Prepend = "prepend", n.Text = "text", n.Internal = "internal";
            })(Br = e.BundleFileSectionKind || (e.BundleFileSectionKind = {}));
            var Er;
            (function(n) {
              n[n.None = 0] = "None", n[n.SingleLine = 0] = "SingleLine", n[n.MultiLine = 1] = "MultiLine", n[n.PreserveLines = 2] = "PreserveLines", n[n.LinesMask = 3] = "LinesMask", n[n.NotDelimited = 0] = "NotDelimited", n[n.BarDelimited = 4] = "BarDelimited", n[n.AmpersandDelimited = 8] = "AmpersandDelimited", n[n.CommaDelimited = 16] = "CommaDelimited", n[n.AsteriskDelimited = 32] = "AsteriskDelimited", n[n.DelimitersMask = 60] = "DelimitersMask", n[n.AllowTrailingComma = 64] = "AllowTrailingComma", n[n.Indented = 128] = "Indented", n[n.SpaceBetweenBraces = 256] = "SpaceBetweenBraces", n[n.SpaceBetweenSiblings = 512] = "SpaceBetweenSiblings", n[n.Braces = 1024] = "Braces", n[n.Parenthesis = 2048] = "Parenthesis", n[n.AngleBrackets = 4096] = "AngleBrackets", n[n.SquareBrackets = 8192] = "SquareBrackets", n[n.BracketsMask = 15360] = "BracketsMask", n[n.OptionalIfUndefined = 16384] = "OptionalIfUndefined", n[n.OptionalIfEmpty = 32768] = "OptionalIfEmpty", n[n.Optional = 49152] = "Optional", n[n.PreferNewLine = 65536] = "PreferNewLine", n[n.NoTrailingNewLine = 131072] = "NoTrailingNewLine", n[n.NoInterveningComments = 262144] = "NoInterveningComments", n[n.NoSpaceIfEmpty = 524288] = "NoSpaceIfEmpty", n[n.SingleElement = 1048576] = "SingleElement", n[n.SpaceAfterList = 2097152] = "SpaceAfterList", n[n.Modifiers = 262656] = "Modifiers", n[n.HeritageClauses = 512] = "HeritageClauses", n[n.SingleLineTypeLiteralMembers = 768] = "SingleLineTypeLiteralMembers", n[n.MultiLineTypeLiteralMembers = 32897] = "MultiLineTypeLiteralMembers", n[n.SingleLineTupleTypeElements = 528] = "SingleLineTupleTypeElements", n[n.MultiLineTupleTypeElements = 657] = "MultiLineTupleTypeElements", n[n.UnionTypeConstituents = 516] = "UnionTypeConstituents", n[n.IntersectionTypeConstituents = 520] = "IntersectionTypeConstituents", n[n.ObjectBindingPatternElements = 525136] = "ObjectBindingPatternElements", n[n.ArrayBindingPatternElements = 524880] = "ArrayBindingPatternElements", n[n.ObjectLiteralExpressionProperties = 526226] = "ObjectLiteralExpressionProperties", n[n.ImportClauseEntries = 526226] = "ImportClauseEntries", n[n.ArrayLiteralExpressionElements = 8914] = "ArrayLiteralExpressionElements", n[n.CommaListElements = 528] = "CommaListElements", n[n.CallExpressionArguments = 2576] = "CallExpressionArguments", n[n.NewExpressionArguments = 18960] = "NewExpressionArguments", n[n.TemplateExpressionSpans = 262144] = "TemplateExpressionSpans", n[n.SingleLineBlockStatements = 768] = "SingleLineBlockStatements", n[n.MultiLineBlockStatements = 129] = "MultiLineBlockStatements", n[n.VariableDeclarationList = 528] = "VariableDeclarationList", n[n.SingleLineFunctionBodyStatements = 768] = "SingleLineFunctionBodyStatements", n[n.MultiLineFunctionBodyStatements = 1] = "MultiLineFunctionBodyStatements", n[n.ClassHeritageClauses = 0] = "ClassHeritageClauses", n[n.ClassMembers = 129] = "ClassMembers", n[n.InterfaceMembers = 129] = "InterfaceMembers", n[n.EnumMembers = 145] = "EnumMembers", n[n.CaseBlockClauses = 129] = "CaseBlockClauses", n[n.NamedImportsOrExportsElements = 525136] = "NamedImportsOrExportsElements", n[n.JsxElementOrFragmentChildren = 262144] = "JsxElementOrFragmentChildren", n[n.JsxElementAttributes = 262656] = "JsxElementAttributes", n[n.CaseOrDefaultClauseStatements = 163969] = "CaseOrDefaultClauseStatements", n[n.HeritageClauseTypes = 528] = "HeritageClauseTypes", n[n.SourceFileStatements = 131073] = "SourceFileStatements", n[n.Decorators = 2146305] = "Decorators", n[n.TypeArguments = 53776] = "TypeArguments", n[n.TypeParameters = 53776] = "TypeParameters", n[n.Parameters = 2576] = "Parameters", n[n.IndexSignatureParameters = 8848] = "IndexSignatureParameters", n[n.JSDocComment = 33] = "JSDocComment";
            })(Er = e.ListFormat || (e.ListFormat = {}));
            var Ne;
            (function(n) {
              n[n.None = 0] = "None", n[n.TripleSlashXML = 1] = "TripleSlashXML", n[n.SingleLine = 2] = "SingleLine", n[n.MultiLine = 4] = "MultiLine", n[n.All = 7] = "All", n[n.Default = 7] = "Default";
            })(Ne = e.PragmaKindFlags || (e.PragmaKindFlags = {})), e.commentPragmas = { reference: { args: [{ name: "types", optional: true, captureSpan: true }, { name: "lib", optional: true, captureSpan: true }, { name: "path", optional: true, captureSpan: true }, { name: "no-default-lib", optional: true }, { name: "resolution-mode", optional: true }], kind: 1 }, "amd-dependency": { args: [{ name: "path" }, { name: "name", optional: true }], kind: 1 }, "amd-module": { args: [{ name: "name" }], kind: 1 }, "ts-check": { kind: 2 }, "ts-nocheck": { kind: 2 }, jsx: { args: [{ name: "factory" }], kind: 4 }, jsxfrag: { args: [{ name: "factory" }], kind: 4 }, jsximportsource: { args: [{ name: "factory" }], kind: 4 }, jsxruntime: { args: [{ name: "factory" }], kind: 4 } };
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(A) {
              for (var y = 5381, V = 0; V < A.length; V++) y = (y << 5) + y + A.charCodeAt(V);
              return y.toString();
            }
            e.generateDjb2Hash = a;
            function C() {
              Error.stackTraceLimit < 100 && (Error.stackTraceLimit = 100);
            }
            e.setStackTraceLimit = C;
            var w;
            (function(A) {
              A[A.Created = 0] = "Created", A[A.Changed = 1] = "Changed", A[A.Deleted = 2] = "Deleted";
            })(w = e.FileWatcherEventKind || (e.FileWatcherEventKind = {}));
            var B;
            (function(A) {
              A[A.High = 2e3] = "High", A[A.Medium = 500] = "Medium", A[A.Low = 250] = "Low";
            })(B = e.PollingInterval || (e.PollingInterval = {})), e.missingFileModifiedTime = /* @__PURE__ */ new Date(0);
            function E(A, y) {
              return A.getModifiedTime(y) || e.missingFileModifiedTime;
            }
            e.getModifiedTime = E;
            function Q(A) {
              var y;
              return y = {}, y[B.Low] = A.Low, y[B.Medium] = A.Medium, y[B.High] = A.High, y;
            }
            var le = { Low: 32, Medium: 64, High: 256 }, N = Q(le);
            e.unchangedPollThresholds = Q(le);
            function p(A) {
              if (!A.getEnvironmentVariable) return;
              var y = P("TSC_WATCH_POLLINGINTERVAL", B);
              N = k("TSC_WATCH_POLLINGCHUNKSIZE", le) || N, e.unchangedPollThresholds = k("TSC_WATCH_UNCHANGEDPOLLTHRESHOLDS", le) || e.unchangedPollThresholds;
              function V(Y, U) {
                return A.getEnvironmentVariable("".concat(Y, "_").concat(U.toUpperCase()));
              }
              function L(Y) {
                var U;
                return j("Low"), j("Medium"), j("High"), U;
                function j(H) {
                  var I = V(Y, H);
                  I && ((U || (U = {}))[H] = Number(I));
                }
              }
              function P(Y, U) {
                var j = L(Y);
                if (j) return H("Low"), H("Medium"), H("High"), true;
                return false;
                function H(I) {
                  U[I] = j[I] || U[I];
                }
              }
              function k(Y, U) {
                var j = L(Y);
                return (y || j) && Q(j ? Ke(Ke({}, U), j) : U);
              }
            }
            e.setCustomPollingValues = p;
            function m(A, y, V, L, P) {
              for (var k = V, Y = y.length; L && Y; H(), Y--) {
                var U = y[V];
                if (U) {
                  if (U.isClosed) {
                    y[V] = void 0;
                    continue;
                  }
                } else continue;
                L--;
                var j = K(U, E(A, U.fileName));
                if (U.isClosed) {
                  y[V] = void 0;
                  continue;
                }
                P == null || P(U, V, j), y[V] && (k < V && (y[k] = U, y[V] = void 0), k++);
              }
              return V;
              function H() {
                V++, V === y.length && (k < V && (y.length = k), V = 0, k = 0);
              }
            }
            function G(A) {
              var y = [], V = [], L = U(B.Low), P = U(B.Medium), k = U(B.High);
              return Y;
              function Y(ne, ue, We) {
                var Fe = { fileName: ne, callback: ue, unchangedPolls: 0, mtime: E(A, ne) };
                return y.push(Fe), d(Fe, We), { close: function() {
                  Fe.isClosed = true, e.unorderedRemoveItem(y, Fe);
                } };
              }
              function U(ne) {
                var ue = [];
                return ue.pollingInterval = ne, ue.pollIndex = 0, ue.pollScheduled = false, ue;
              }
              function j(ne) {
                ne.pollIndex = I(ne, ne.pollingInterval, ne.pollIndex, N[ne.pollingInterval]), ne.length ? g(ne.pollingInterval) : (e.Debug.assert(ne.pollIndex === 0), ne.pollScheduled = false);
              }
              function H(ne) {
                I(V, B.Low, 0, V.length), j(ne), !ne.pollScheduled && V.length && g(B.Low);
              }
              function I(ne, ue, We, Fe) {
                return m(A, ne, We, Fe, Z);
                function Z(Be, ge, Re) {
                  Re ? (Be.unchangedPolls = 0, ne !== V && (ne[ge] = void 0, D(Be))) : Be.unchangedPolls !== e.unchangedPollThresholds[ue] ? Be.unchangedPolls++ : ne === V ? (Be.unchangedPolls = 1, ne[ge] = void 0, d(Be, B.Low)) : ue !== B.High && (Be.unchangedPolls++, ne[ge] = void 0, d(Be, ue === B.Low ? B.Medium : B.High));
                }
              }
              function l(ne) {
                switch (ne) {
                  case B.Low:
                    return L;
                  case B.Medium:
                    return P;
                  case B.High:
                    return k;
                }
              }
              function d(ne, ue) {
                l(ue).push(ne), fe(ue);
              }
              function D(ne) {
                V.push(ne), fe(B.Low);
              }
              function fe(ne) {
                l(ne).pollScheduled || g(ne);
              }
              function g(ne) {
                l(ne).pollScheduled = A.setTimeout(ne === B.Low ? H : j, ne, l(ne));
              }
            }
            e.createDynamicPriorityPollingWatchFile = G;
            function oe(A, y) {
              var V = e.createMultiMap(), L = new e.Map(), P = e.createGetCanonicalFileName(y);
              return k;
              function k(U, j, H, I) {
                var l = P(U);
                V.add(l, j);
                var d = e.getDirectoryPath(l) || ".", D = L.get(d) || Y(e.getDirectoryPath(U) || ".", d, I);
                return D.referenceCount++, { close: function() {
                  D.referenceCount === 1 ? (D.close(), L.delete(d)) : D.referenceCount--, V.remove(l, j);
                } };
              }
              function Y(U, j, H) {
                var I = A(U, 1, function(l, d) {
                  if (!!e.isString(d)) {
                    var D = e.getNormalizedAbsolutePath(d, U), fe = D && V.get(P(D));
                    if (fe) for (var g = 0, ne = fe; g < ne.length; g++) {
                      var ue = ne[g];
                      ue(D, w.Changed);
                    }
                  }
                }, false, B.Medium, H);
                return I.referenceCount = 0, L.set(j, I), I;
              }
            }
            function f(A) {
              var y = [], V = 0, L;
              return P;
              function P(U, j) {
                var H = { fileName: U, callback: j, mtime: E(A, U) };
                return y.push(H), Y(), { close: function() {
                  H.isClosed = true, e.unorderedRemoveItem(y, H);
                } };
              }
              function k() {
                L = void 0, V = m(A, y, V, N[B.Low]), Y();
              }
              function Y() {
                !y.length || L || (L = A.setTimeout(k, B.High));
              }
            }
            function T(A, y) {
              var V = new e.Map(), L = e.createMultiMap(), P = e.createGetCanonicalFileName(y);
              return function(k, Y, U, j) {
                var H = P(k), I = V.get(H);
                return I ? I.refCount++ : V.set(H, { watcher: A(k, function(l, d) {
                  return e.forEach(L.get(H), function(D) {
                    return D(l, d);
                  });
                }, U, j), refCount: 1 }), L.add(H, Y), { close: function() {
                  var l = e.Debug.checkDefined(V.get(H));
                  L.remove(H, Y), l.refCount--, !l.refCount && (V.delete(H), e.closeFileWatcherOf(l));
                } };
              };
            }
            e.createSingleFileWatcherPerName = T;
            function K(A, y) {
              var V = A.mtime.getTime(), L = y.getTime();
              return V !== L ? (A.mtime = y, A.callback(A.fileName, b(V, L)), true) : false;
            }
            e.onWatchedFileStat = K;
            function b(A, y) {
              return A === 0 ? w.Created : y === 0 ? w.Deleted : w.Changed;
            }
            e.getFileWatcherEventKind = b, e.ignoredPaths = ["/node_modules/.", "/.git", "/.#"];
            var se = e.noop;
            function J(A) {
              return se(A);
            }
            e.sysLog = J;
            function ie(A) {
              se = A;
            }
            e.setSysLog = ie;
            function R(A) {
              var y = A.watchDirectory, V = A.useCaseSensitiveFileNames, L = A.getCurrentDirectory, P = A.getAccessibleSortedChildDirectories, k = A.directoryExists, Y = A.realpath, U = A.setTimeout, j = A.clearTimeout, H = new e.Map(), I = e.createMultiMap(), l = new e.Map(), d, D = e.getStringComparer(!V), fe = e.createGetCanonicalFileName(V);
              return function(ze, Ee, He, rr) {
                return He ? g(ze, rr, Ee) : y(ze, Ee, He, rr);
              };
              function g(ze, Ee, He) {
                var rr = fe(ze), Ie = H.get(rr);
                Ie ? Ie.refCount++ : (Ie = { watcher: y(ze, function(we) {
                  ge(we, Ee) || (Ee != null && Ee.synchronousWatchDirectory ? (ne(rr, we), Be(ze, rr, Ee)) : ue(ze, rr, we, Ee));
                }, false, Ee), refCount: 1, childWatches: e.emptyArray }, H.set(rr, Ie), Be(ze, rr, Ee));
                var _e = He && { dirName: ze, callback: He };
                return _e && I.add(rr, _e), { dirName: ze, close: function() {
                  var we = e.Debug.checkDefined(H.get(rr));
                  _e && I.remove(rr, _e), we.refCount--, !we.refCount && (H.delete(rr), e.closeFileWatcherOf(we), we.childWatches.forEach(e.closeFileWatcher));
                } };
              }
              function ne(ze, Ee, He) {
                var rr, Ie;
                e.isString(Ee) ? rr = Ee : Ie = Ee, I.forEach(function(_e, we) {
                  var de;
                  if (!(Ie && Ie.get(we) === true) && (we === ze || e.startsWith(ze, we) && ze[we.length] === e.directorySeparator)) if (Ie) if (He) {
                    var ye = Ie.get(we);
                    ye ? (de = ye).push.apply(de, He) : Ie.set(we, He.slice());
                  } else Ie.set(we, true);
                  else _e.forEach(function(Ae) {
                    var er = Ae.callback;
                    return er(rr);
                  });
                });
              }
              function ue(ze, Ee, He, rr) {
                var Ie = H.get(Ee);
                if (Ie && k(ze)) {
                  We(ze, Ee, He, rr);
                  return;
                }
                ne(Ee, He), Z(Ie);
              }
              function We(ze, Ee, He, rr) {
                var Ie = l.get(Ee);
                Ie ? Ie.fileNames.push(He) : l.set(Ee, { dirName: ze, options: rr, fileNames: [He] }), d && (j(d), d = void 0), d = U(Fe, 1e3);
              }
              function Fe() {
                d = void 0, J("sysLog:: onTimerToUpdateChildWatches:: ".concat(l.size));
                for (var ze = e.timestamp(), Ee = new e.Map(); !d && l.size; ) {
                  var He = l.entries().next();
                  e.Debug.assert(!He.done);
                  var rr = He.value, Ie = rr[0], _e = rr[1], we = _e.dirName, de = _e.options, ye = _e.fileNames;
                  l.delete(Ie);
                  var Ae = Be(we, Ie, de);
                  ne(Ie, Ee, Ae ? void 0 : ye);
                }
                J("sysLog:: invokingWatchers:: Elapsed:: ".concat(e.timestamp() - ze, "ms:: ").concat(l.size)), I.forEach(function(ir, Cr) {
                  var Ye = Ee.get(Cr);
                  Ye && ir.forEach(function(Br) {
                    var Er = Br.callback, Ne = Br.dirName;
                    e.isArray(Ye) ? Ye.forEach(Er) : Er(Ne);
                  });
                });
                var er = e.timestamp() - ze;
                J("sysLog:: Elapsed:: ".concat(er, "ms:: onTimerToUpdateChildWatches:: ").concat(l.size, " ").concat(d));
              }
              function Z(ze) {
                if (!!ze) {
                  var Ee = ze.childWatches;
                  ze.childWatches = e.emptyArray;
                  for (var He = 0, rr = Ee; He < rr.length; He++) {
                    var Ie = rr[He];
                    Ie.close(), Z(H.get(fe(Ie.dirName)));
                  }
                }
              }
              function Be(ze, Ee, He) {
                var rr = H.get(Ee);
                if (!rr) return false;
                var Ie, _e = e.enumerateInsertsAndDeletes(k(ze) ? e.mapDefined(P(ze), function(ye) {
                  var Ae = e.getNormalizedAbsolutePath(ye, ze);
                  return !ge(Ae, He) && D(Ae, e.normalizePath(Y(Ae))) === 0 ? Ae : void 0;
                }) : e.emptyArray, rr.childWatches, function(ye, Ae) {
                  return D(ye, Ae.dirName);
                }, we, e.closeFileWatcher, de);
                return rr.childWatches = Ie || e.emptyArray, _e;
                function we(ye) {
                  var Ae = g(ye, He);
                  de(Ae);
                }
                function de(ye) {
                  (Ie || (Ie = [])).push(ye);
                }
              }
              function ge(ze, Ee) {
                return e.some(e.ignoredPaths, function(He) {
                  return Re(ze, He);
                }) || ee(ze, Ee, V, L);
              }
              function Re(ze, Ee) {
                return e.stringContains(ze, Ee) ? true : V ? false : e.stringContains(fe(ze), Ee);
              }
            }
            e.createDirectoryWatcherSupportingRecursive = R;
            var q;
            (function(A) {
              A[A.File = 0] = "File", A[A.Directory = 1] = "Directory";
            })(q = e.FileSystemEntryKind || (e.FileSystemEntryKind = {}));
            function O(A) {
              return function(y, V) {
                return A(V === w.Changed ? "change" : "rename", "");
              };
            }
            e.createFileWatcherCallback = O;
            function ve(A, y, V) {
              return function(L) {
                L === "rename" ? y(A, V(A) ? w.Created : w.Deleted) : y(A, w.Changed);
              };
            }
            function ee(A, y, V, L) {
              return ((y == null ? void 0 : y.excludeDirectories) || (y == null ? void 0 : y.excludeFiles)) && (e.matchesExclude(A, y == null ? void 0 : y.excludeFiles, V, L()) || e.matchesExclude(A, y == null ? void 0 : y.excludeDirectories, V, L()));
            }
            function he(A, y, V, L, P) {
              return function(k, Y) {
                if (k === "rename") {
                  var U = Y ? e.normalizePath(e.combinePaths(A, Y)) : A;
                  (!Y || !ee(U, V, L, P)) && y(U);
                }
              };
            }
            function F(A) {
              var y = A.pollingWatchFile, V = A.getModifiedTime, L = A.setTimeout, P = A.clearTimeout, k = A.fsWatch, Y = A.fileExists, U = A.useCaseSensitiveFileNames, j = A.getCurrentDirectory, H = A.fsSupportsRecursiveFsWatch, I = A.directoryExists, l = A.getAccessibleSortedChildDirectories, d = A.realpath, D = A.tscWatchFile, fe = A.useNonPollingWatchers, g = A.tscWatchDirectory, ne = A.defaultWatchFileKind, ue, We, Fe, Z;
              return { watchFile: Be, watchDirectory: He };
              function Be(_e, we, de, ye) {
                ye = ze(ye, fe);
                var Ae = e.Debug.checkDefined(ye.watchFile);
                switch (Ae) {
                  case e.WatchFileKind.FixedPollingInterval:
                    return y(_e, we, B.Low, void 0);
                  case e.WatchFileKind.PriorityPollingInterval:
                    return y(_e, we, de, void 0);
                  case e.WatchFileKind.DynamicPriorityPolling:
                    return ge()(_e, we, de, void 0);
                  case e.WatchFileKind.FixedChunkSizePolling:
                    return Re()(_e, we, void 0, void 0);
                  case e.WatchFileKind.UseFsEvents:
                    return k(_e, 0, ve(_e, we, Y), false, de, e.getFallbackOptions(ye));
                  case e.WatchFileKind.UseFsEventsOnParentDirectory:
                    return Fe || (Fe = oe(k, U)), Fe(_e, we, de, e.getFallbackOptions(ye));
                  default:
                    e.Debug.assertNever(Ae);
                }
              }
              function ge() {
                return ue || (ue = G({ getModifiedTime: V, setTimeout: L }));
              }
              function Re() {
                return We || (We = f({ getModifiedTime: V, setTimeout: L }));
              }
              function ze(_e, we) {
                if (_e && _e.watchFile !== void 0) return _e;
                switch (D) {
                  case "PriorityPollingInterval":
                    return { watchFile: e.WatchFileKind.PriorityPollingInterval };
                  case "DynamicPriorityPolling":
                    return { watchFile: e.WatchFileKind.DynamicPriorityPolling };
                  case "UseFsEvents":
                    return Ee(e.WatchFileKind.UseFsEvents, e.PollingWatchKind.PriorityInterval, _e);
                  case "UseFsEventsWithFallbackDynamicPolling":
                    return Ee(e.WatchFileKind.UseFsEvents, e.PollingWatchKind.DynamicPriority, _e);
                  case "UseFsEventsOnParentDirectory":
                    we = true;
                  default:
                    return we ? Ee(e.WatchFileKind.UseFsEventsOnParentDirectory, e.PollingWatchKind.PriorityInterval, _e) : { watchFile: (ne == null ? void 0 : ne()) || e.WatchFileKind.FixedPollingInterval };
                }
              }
              function Ee(_e, we, de) {
                var ye = de == null ? void 0 : de.fallbackPolling;
                return { watchFile: _e, fallbackPolling: ye === void 0 ? we : ye };
              }
              function He(_e, we, de, ye) {
                return H ? k(_e, 1, he(_e, we, ye, U, j), de, B.Medium, e.getFallbackOptions(ye)) : (Z || (Z = R({ useCaseSensitiveFileNames: U, getCurrentDirectory: j, directoryExists: I, getAccessibleSortedChildDirectories: l, watchDirectory: rr, realpath: d, setTimeout: L, clearTimeout: P })), Z(_e, we, de, ye));
              }
              function rr(_e, we, de, ye) {
                e.Debug.assert(!de);
                var Ae = Ie(ye), er = e.Debug.checkDefined(Ae.watchDirectory);
                switch (er) {
                  case e.WatchDirectoryKind.FixedPollingInterval:
                    return y(_e, function() {
                      return we(_e);
                    }, B.Medium, void 0);
                  case e.WatchDirectoryKind.DynamicPriorityPolling:
                    return ge()(_e, function() {
                      return we(_e);
                    }, B.Medium, void 0);
                  case e.WatchDirectoryKind.FixedChunkSizePolling:
                    return Re()(_e, function() {
                      return we(_e);
                    }, void 0, void 0);
                  case e.WatchDirectoryKind.UseFsEvents:
                    return k(_e, 1, he(_e, we, ye, U, j), de, B.Medium, e.getFallbackOptions(Ae));
                  default:
                    e.Debug.assertNever(er);
                }
              }
              function Ie(_e) {
                if (_e && _e.watchDirectory !== void 0) return _e;
                switch (g) {
                  case "RecursiveDirectoryUsingFsWatchFile":
                    return { watchDirectory: e.WatchDirectoryKind.FixedPollingInterval };
                  case "RecursiveDirectoryUsingDynamicPriorityPolling":
                    return { watchDirectory: e.WatchDirectoryKind.DynamicPriorityPolling };
                  default:
                    var we = _e == null ? void 0 : _e.fallbackPolling;
                    return { watchDirectory: e.WatchDirectoryKind.UseFsEvents, fallbackPolling: we !== void 0 ? we : void 0 };
                }
              }
            }
            e.createSystemWatchFunctions = F;
            function x(A) {
              var y = A.writeFile;
              A.writeFile = function(V, L, P) {
                return e.writeFileEnsuringDirectories(V, L, !!P, function(k, Y, U) {
                  return y.call(A, k, Y, U);
                }, function(k) {
                  return A.createDirectory(k);
                }, function(k) {
                  return A.directoryExists(k);
                });
              };
            }
            e.patchWriteFileEnsuringDirectory = x;
            function X() {
              if (!(typeof Eu > "u")) {
                var A = Eu.version;
                if (!!A) {
                  var y = A.indexOf(".");
                  if (y !== -1) return parseInt(A.substring(1, y));
                }
              }
            }
            e.getNodeMajorVersion = X, e.sys = void 0;
            function $(A) {
              e.sys = void 0;
            }
            e.setSys = $, e.sys && e.sys.getEnvironmentVariable && (p(e.sys), e.Debug.setAssertionLevel(/^development$/i.test(e.sys.getEnvironmentVariable("NODE_ENV")) ? 1 : 0)), e.sys && e.sys.debugMode && (e.Debug.isDebugging = true);
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            e.directorySeparator = "/", e.altDirectorySeparator = "\\";
            var a = "://", C = /\\/g;
            function w(ze) {
              return ze === 47 || ze === 92;
            }
            e.isAnyDirectorySeparator = w;
            function B(ze) {
              return b(ze) < 0;
            }
            e.isUrl = B;
            function E(ze) {
              return b(ze) > 0;
            }
            e.isRootedDiskPath = E;
            function Q(ze) {
              var Ee = b(ze);
              return Ee > 0 && Ee === ze.length;
            }
            e.isDiskPathRoot = Q;
            function le(ze) {
              return b(ze) !== 0;
            }
            e.pathIsAbsolute = le;
            function N(ze) {
              return /^\.\.?($|[\\/])/.test(ze);
            }
            e.pathIsRelative = N;
            function p(ze) {
              return !le(ze) && !N(ze);
            }
            e.pathIsBareSpecifier = p;
            function m(ze) {
              return e.stringContains(ie(ze), ".");
            }
            e.hasExtension = m;
            function G(ze, Ee) {
              return ze.length > Ee.length && e.endsWith(ze, Ee);
            }
            e.fileExtensionIs = G;
            function oe(ze, Ee) {
              for (var He = 0, rr = Ee; He < rr.length; He++) {
                var Ie = rr[He];
                if (G(ze, Ie)) return true;
              }
              return false;
            }
            e.fileExtensionIsOneOf = oe;
            function f(ze) {
              return ze.length > 0 && w(ze.charCodeAt(ze.length - 1));
            }
            e.hasTrailingDirectorySeparator = f;
            function T(ze) {
              return ze >= 97 && ze <= 122 || ze >= 65 && ze <= 90;
            }
            function K(ze, Ee) {
              var He = ze.charCodeAt(Ee);
              if (He === 58) return Ee + 1;
              if (He === 37 && ze.charCodeAt(Ee + 1) === 51) {
                var rr = ze.charCodeAt(Ee + 2);
                if (rr === 97 || rr === 65) return Ee + 3;
              }
              return -1;
            }
            function b(ze) {
              if (!ze) return 0;
              var Ee = ze.charCodeAt(0);
              if (Ee === 47 || Ee === 92) {
                if (ze.charCodeAt(1) !== Ee) return 1;
                var He = ze.indexOf(Ee === 47 ? e.directorySeparator : e.altDirectorySeparator, 2);
                return He < 0 ? ze.length : He + 1;
              }
              if (T(Ee) && ze.charCodeAt(1) === 58) {
                var rr = ze.charCodeAt(2);
                if (rr === 47 || rr === 92) return 3;
                if (ze.length === 2) return 2;
              }
              var Ie = ze.indexOf(a);
              if (Ie !== -1) {
                var _e = Ie + a.length, we = ze.indexOf(e.directorySeparator, _e);
                if (we !== -1) {
                  var de = ze.slice(0, Ie), ye = ze.slice(_e, we);
                  if (de === "file" && (ye === "" || ye === "localhost") && T(ze.charCodeAt(we + 1))) {
                    var Ae = K(ze, we + 2);
                    if (Ae !== -1) {
                      if (ze.charCodeAt(Ae) === 47) return ~(Ae + 1);
                      if (Ae === ze.length) return ~Ae;
                    }
                  }
                  return ~(we + 1);
                }
                return ~ze.length;
              }
              return 0;
            }
            function se(ze) {
              var Ee = b(ze);
              return Ee < 0 ? ~Ee : Ee;
            }
            e.getRootLength = se;
            function J(ze) {
              ze = F(ze);
              var Ee = se(ze);
              return Ee === ze.length ? ze : (ze = Y(ze), ze.slice(0, Math.max(Ee, ze.lastIndexOf(e.directorySeparator))));
            }
            e.getDirectoryPath = J;
            function ie(ze, Ee, He) {
              ze = F(ze);
              var rr = se(ze);
              if (rr === ze.length) return "";
              ze = Y(ze);
              var Ie = ze.slice(Math.max(se(ze), ze.lastIndexOf(e.directorySeparator) + 1)), _e = Ee !== void 0 && He !== void 0 ? O(Ie, Ee, He) : void 0;
              return _e ? Ie.slice(0, Ie.length - _e.length) : Ie;
            }
            e.getBaseFileName = ie;
            function R(ze, Ee, He) {
              if (e.startsWith(Ee, ".") || (Ee = "." + Ee), ze.length >= Ee.length && ze.charCodeAt(ze.length - Ee.length) === 46) {
                var rr = ze.slice(ze.length - Ee.length);
                if (He(rr, Ee)) return rr;
              }
            }
            function q(ze, Ee, He) {
              if (typeof Ee == "string") return R(ze, Ee, He) || "";
              for (var rr = 0, Ie = Ee; rr < Ie.length; rr++) {
                var _e = Ie[rr], we = R(ze, _e, He);
                if (we) return we;
              }
              return "";
            }
            function O(ze, Ee, He) {
              if (Ee) return q(Y(ze), Ee, He ? e.equateStringsCaseInsensitive : e.equateStringsCaseSensitive);
              var rr = ie(ze), Ie = rr.lastIndexOf(".");
              return Ie >= 0 ? rr.substring(Ie) : "";
            }
            e.getAnyExtensionFromPath = O;
            function ve(ze, Ee) {
              var He = ze.substring(0, Ee), rr = ze.substring(Ee).split(e.directorySeparator);
              return rr.length && !e.lastOrUndefined(rr) && rr.pop(), Ve([He], rr, true);
            }
            function ee(ze, Ee) {
              return Ee === void 0 && (Ee = ""), ze = X(Ee, ze), ve(ze, se(ze));
            }
            e.getPathComponents = ee;
            function he(ze) {
              if (ze.length === 0) return "";
              var Ee = ze[0] && U(ze[0]);
              return Ee + ze.slice(1).join(e.directorySeparator);
            }
            e.getPathFromPathComponents = he;
            function F(ze) {
              var Ee = ze.indexOf("\\");
              return Ee === -1 ? ze : (C.lastIndex = Ee, ze.replace(C, e.directorySeparator));
            }
            e.normalizeSlashes = F;
            function x(ze) {
              if (!e.some(ze)) return [];
              for (var Ee = [ze[0]], He = 1; He < ze.length; He++) {
                var rr = ze[He];
                if (!!rr && rr !== ".") {
                  if (rr === "..") {
                    if (Ee.length > 1) {
                      if (Ee[Ee.length - 1] !== "..") {
                        Ee.pop();
                        continue;
                      }
                    } else if (Ee[0]) continue;
                  }
                  Ee.push(rr);
                }
              }
              return Ee;
            }
            e.reducePathComponents = x;
            function X(ze) {
              for (var Ee = [], He = 1; He < arguments.length; He++) Ee[He - 1] = arguments[He];
              ze && (ze = F(ze));
              for (var rr = 0, Ie = Ee; rr < Ie.length; rr++) {
                var _e = Ie[rr];
                !_e || (_e = F(_e), !ze || se(_e) !== 0 ? ze = _e : ze = U(ze) + _e);
              }
              return ze;
            }
            e.combinePaths = X;
            function $(ze) {
              for (var Ee = [], He = 1; He < arguments.length; He++) Ee[He - 1] = arguments[He];
              return V(e.some(Ee) ? X.apply(void 0, Ve([ze], Ee, false)) : F(ze));
            }
            e.resolvePath = $;
            function A(ze, Ee) {
              return x(ee(ze, Ee));
            }
            e.getNormalizedPathComponents = A;
            function y(ze, Ee) {
              return he(A(ze, Ee));
            }
            e.getNormalizedAbsolutePath = y;
            function V(ze) {
              if (ze = F(ze), !I.test(ze)) return ze;
              var Ee = ze.replace(/\/\.\//g, "/").replace(/^\.\//, "");
              if (Ee !== ze && (ze = Ee, !I.test(ze))) return ze;
              var He = he(x(ee(ze)));
              return He && f(ze) ? U(He) : He;
            }
            e.normalizePath = V;
            function L(ze) {
              return ze.length === 0 ? "" : ze.slice(1).join(e.directorySeparator);
            }
            function P(ze, Ee) {
              return L(A(ze, Ee));
            }
            e.getNormalizedAbsolutePathWithoutRoot = P;
            function k(ze, Ee, He) {
              var rr = E(ze) ? V(ze) : y(ze, Ee);
              return He(rr);
            }
            e.toPath = k;
            function Y(ze) {
              return f(ze) ? ze.substr(0, ze.length - 1) : ze;
            }
            e.removeTrailingDirectorySeparator = Y;
            function U(ze) {
              return f(ze) ? ze : ze + e.directorySeparator;
            }
            e.ensureTrailingDirectorySeparator = U;
            function j(ze) {
              return !le(ze) && !N(ze) ? "./" + ze : ze;
            }
            e.ensurePathIsNonModuleName = j;
            function H(ze, Ee, He, rr) {
              var Ie = He !== void 0 && rr !== void 0 ? O(ze, He, rr) : O(ze);
              return Ie ? ze.slice(0, ze.length - Ie.length) + (e.startsWith(Ee, ".") ? Ee : "." + Ee) : ze;
            }
            e.changeAnyExtension = H;
            var I = /(?:\/\/)|(?:^|\/)\.\.?(?:$|\/)/;
            function l(ze, Ee, He) {
              if (ze === Ee) return 0;
              if (ze === void 0) return -1;
              if (Ee === void 0) return 1;
              var rr = ze.substring(0, se(ze)), Ie = Ee.substring(0, se(Ee)), _e = e.compareStringsCaseInsensitive(rr, Ie);
              if (_e !== 0) return _e;
              var we = ze.substring(rr.length), de = Ee.substring(Ie.length);
              if (!I.test(we) && !I.test(de)) return He(we, de);
              for (var ye = x(ee(ze)), Ae = x(ee(Ee)), er = Math.min(ye.length, Ae.length), ir = 1; ir < er; ir++) {
                var Cr = He(ye[ir], Ae[ir]);
                if (Cr !== 0) return Cr;
              }
              return e.compareValues(ye.length, Ae.length);
            }
            function d(ze, Ee) {
              return l(ze, Ee, e.compareStringsCaseSensitive);
            }
            e.comparePathsCaseSensitive = d;
            function D(ze, Ee) {
              return l(ze, Ee, e.compareStringsCaseInsensitive);
            }
            e.comparePathsCaseInsensitive = D;
            function fe(ze, Ee, He, rr) {
              return typeof He == "string" ? (ze = X(He, ze), Ee = X(He, Ee)) : typeof He == "boolean" && (rr = He), l(ze, Ee, e.getStringComparer(rr));
            }
            e.comparePaths = fe;
            function g(ze, Ee, He, rr) {
              if (typeof He == "string" ? (ze = X(He, ze), Ee = X(He, Ee)) : typeof He == "boolean" && (rr = He), ze === void 0 || Ee === void 0) return false;
              if (ze === Ee) return true;
              var Ie = x(ee(ze)), _e = x(ee(Ee));
              if (_e.length < Ie.length) return false;
              for (var we = rr ? e.equateStringsCaseInsensitive : e.equateStringsCaseSensitive, de = 0; de < Ie.length; de++) {
                var ye = de === 0 ? e.equateStringsCaseInsensitive : we;
                if (!ye(Ie[de], _e[de])) return false;
              }
              return true;
            }
            e.containsPath = g;
            function ne(ze, Ee, He) {
              var rr = He(ze), Ie = He(Ee);
              return e.startsWith(rr, Ie + "/") || e.startsWith(rr, Ie + "\\");
            }
            e.startsWithDirectory = ne;
            function ue(ze, Ee, He, rr) {
              var Ie = x(ee(ze)), _e = x(ee(Ee)), we;
              for (we = 0; we < Ie.length && we < _e.length; we++) {
                var de = rr(Ie[we]), ye = rr(_e[we]), Ae = we === 0 ? e.equateStringsCaseInsensitive : He;
                if (!Ae(de, ye)) break;
              }
              if (we === 0) return _e;
              for (var er = _e.slice(we), ir = []; we < Ie.length; we++) ir.push("..");
              return Ve(Ve([""], ir, true), er, true);
            }
            e.getPathComponentsRelativeTo = ue;
            function We(ze, Ee, He) {
              e.Debug.assert(se(ze) > 0 == se(Ee) > 0, "Paths must either both be absolute or both be relative");
              var rr = typeof He == "function" ? He : e.identity, Ie = typeof He == "boolean" ? He : false, _e = ue(ze, Ee, Ie ? e.equateStringsCaseInsensitive : e.equateStringsCaseSensitive, rr);
              return he(_e);
            }
            e.getRelativePathFromDirectory = We;
            function Fe(ze, Ee, He) {
              return E(ze) ? Be(Ee, ze, Ee, He, false) : ze;
            }
            e.convertToRelativePath = Fe;
            function Z(ze, Ee, He) {
              return j(We(J(ze), Ee, He));
            }
            e.getRelativePathFromFile = Z;
            function Be(ze, Ee, He, rr, Ie) {
              var _e = ue($(He, ze), $(He, Ee), e.equateStringsCaseSensitive, rr), we = _e[0];
              if (Ie && E(we)) {
                var de = we.charAt(0) === e.directorySeparator ? "file://" : "file:///";
                _e[0] = de + we;
              }
              return he(_e);
            }
            e.getRelativePathToDirectoryOrUrl = Be;
            function ge(ze, Ee) {
              for (; ; ) {
                var He = Ee(ze);
                if (He !== void 0) return He;
                var rr = J(ze);
                if (rr === ze) return;
                ze = rr;
              }
            }
            e.forEachAncestorDirectory = ge;
            function Re(ze) {
              return e.endsWith(ze, "/node_modules");
            }
            e.isNodeModulesDirectory = Re;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(C, w, B, E, Q, le, N) {
              return { code: C, category: w, key: B, message: E, reportsUnnecessary: Q, elidedInCompatabilityPyramid: le, reportsDeprecated: N };
            }
            e.Diagnostics = { Unterminated_string_literal: a(1002, e.DiagnosticCategory.Error, "Unterminated_string_literal_1002", "Unterminated string literal."), Identifier_expected: a(1003, e.DiagnosticCategory.Error, "Identifier_expected_1003", "Identifier expected."), _0_expected: a(1005, e.DiagnosticCategory.Error, "_0_expected_1005", "'{0}' expected."), A_file_cannot_have_a_reference_to_itself: a(1006, e.DiagnosticCategory.Error, "A_file_cannot_have_a_reference_to_itself_1006", "A file cannot have a reference to itself."), The_parser_expected_to_find_a_1_to_match_the_0_token_here: a(1007, e.DiagnosticCategory.Error, "The_parser_expected_to_find_a_1_to_match_the_0_token_here_1007", "The parser expected to find a '{1}' to match the '{0}' token here."), Trailing_comma_not_allowed: a(1009, e.DiagnosticCategory.Error, "Trailing_comma_not_allowed_1009", "Trailing comma not allowed."), Asterisk_Slash_expected: a(1010, e.DiagnosticCategory.Error, "Asterisk_Slash_expected_1010", "'*/' expected."), An_element_access_expression_should_take_an_argument: a(1011, e.DiagnosticCategory.Error, "An_element_access_expression_should_take_an_argument_1011", "An element access expression should take an argument."), Unexpected_token: a(1012, e.DiagnosticCategory.Error, "Unexpected_token_1012", "Unexpected token."), A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma: a(1013, e.DiagnosticCategory.Error, "A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma_1013", "A rest parameter or binding pattern may not have a trailing comma."), A_rest_parameter_must_be_last_in_a_parameter_list: a(1014, e.DiagnosticCategory.Error, "A_rest_parameter_must_be_last_in_a_parameter_list_1014", "A rest parameter must be last in a parameter list."), Parameter_cannot_have_question_mark_and_initializer: a(1015, e.DiagnosticCategory.Error, "Parameter_cannot_have_question_mark_and_initializer_1015", "Parameter cannot have question mark and initializer."), A_required_parameter_cannot_follow_an_optional_parameter: a(1016, e.DiagnosticCategory.Error, "A_required_parameter_cannot_follow_an_optional_parameter_1016", "A required parameter cannot follow an optional parameter."), An_index_signature_cannot_have_a_rest_parameter: a(1017, e.DiagnosticCategory.Error, "An_index_signature_cannot_have_a_rest_parameter_1017", "An index signature cannot have a rest parameter."), An_index_signature_parameter_cannot_have_an_accessibility_modifier: a(1018, e.DiagnosticCategory.Error, "An_index_signature_parameter_cannot_have_an_accessibility_modifier_1018", "An index signature parameter cannot have an accessibility modifier."), An_index_signature_parameter_cannot_have_a_question_mark: a(1019, e.DiagnosticCategory.Error, "An_index_signature_parameter_cannot_have_a_question_mark_1019", "An index signature parameter cannot have a question mark."), An_index_signature_parameter_cannot_have_an_initializer: a(1020, e.DiagnosticCategory.Error, "An_index_signature_parameter_cannot_have_an_initializer_1020", "An index signature parameter cannot have an initializer."), An_index_signature_must_have_a_type_annotation: a(1021, e.DiagnosticCategory.Error, "An_index_signature_must_have_a_type_annotation_1021", "An index signature must have a type annotation."), An_index_signature_parameter_must_have_a_type_annotation: a(1022, e.DiagnosticCategory.Error, "An_index_signature_parameter_must_have_a_type_annotation_1022", "An index signature parameter must have a type annotation."), readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature: a(1024, e.DiagnosticCategory.Error, "readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature_1024", "'readonly' modifier can only appear on a property declaration or index signature."), An_index_signature_cannot_have_a_trailing_comma: a(1025, e.DiagnosticCategory.Error, "An_index_signature_cannot_have_a_trailing_comma_1025", "An index signature cannot have a trailing comma."), Accessibility_modifier_already_seen: a(1028, e.DiagnosticCategory.Error, "Accessibility_modifier_already_seen_1028", "Accessibility modifier already seen."), _0_modifier_must_precede_1_modifier: a(1029, e.DiagnosticCategory.Error, "_0_modifier_must_precede_1_modifier_1029", "'{0}' modifier must precede '{1}' modifier."), _0_modifier_already_seen: a(1030, e.DiagnosticCategory.Error, "_0_modifier_already_seen_1030", "'{0}' modifier already seen."), _0_modifier_cannot_appear_on_class_elements_of_this_kind: a(1031, e.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_class_elements_of_this_kind_1031", "'{0}' modifier cannot appear on class elements of this kind."), super_must_be_followed_by_an_argument_list_or_member_access: a(1034, e.DiagnosticCategory.Error, "super_must_be_followed_by_an_argument_list_or_member_access_1034", "'super' must be followed by an argument list or member access."), Only_ambient_modules_can_use_quoted_names: a(1035, e.DiagnosticCategory.Error, "Only_ambient_modules_can_use_quoted_names_1035", "Only ambient modules can use quoted names."), Statements_are_not_allowed_in_ambient_contexts: a(1036, e.DiagnosticCategory.Error, "Statements_are_not_allowed_in_ambient_contexts_1036", "Statements are not allowed in ambient contexts."), A_declare_modifier_cannot_be_used_in_an_already_ambient_context: a(1038, e.DiagnosticCategory.Error, "A_declare_modifier_cannot_be_used_in_an_already_ambient_context_1038", "A 'declare' modifier cannot be used in an already ambient context."), Initializers_are_not_allowed_in_ambient_contexts: a(1039, e.DiagnosticCategory.Error, "Initializers_are_not_allowed_in_ambient_contexts_1039", "Initializers are not allowed in ambient contexts."), _0_modifier_cannot_be_used_in_an_ambient_context: a(1040, e.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_in_an_ambient_context_1040", "'{0}' modifier cannot be used in an ambient context."), _0_modifier_cannot_be_used_here: a(1042, e.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_here_1042", "'{0}' modifier cannot be used here."), _0_modifier_cannot_appear_on_a_module_or_namespace_element: a(1044, e.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_module_or_namespace_element_1044", "'{0}' modifier cannot appear on a module or namespace element."), Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier: a(1046, e.DiagnosticCategory.Error, "Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier_1046", "Top-level declarations in .d.ts files must start with either a 'declare' or 'export' modifier."), A_rest_parameter_cannot_be_optional: a(1047, e.DiagnosticCategory.Error, "A_rest_parameter_cannot_be_optional_1047", "A rest parameter cannot be optional."), A_rest_parameter_cannot_have_an_initializer: a(1048, e.DiagnosticCategory.Error, "A_rest_parameter_cannot_have_an_initializer_1048", "A rest parameter cannot have an initializer."), A_set_accessor_must_have_exactly_one_parameter: a(1049, e.DiagnosticCategory.Error, "A_set_accessor_must_have_exactly_one_parameter_1049", "A 'set' accessor must have exactly one parameter."), A_set_accessor_cannot_have_an_optional_parameter: a(1051, e.DiagnosticCategory.Error, "A_set_accessor_cannot_have_an_optional_parameter_1051", "A 'set' accessor cannot have an optional parameter."), A_set_accessor_parameter_cannot_have_an_initializer: a(1052, e.DiagnosticCategory.Error, "A_set_accessor_parameter_cannot_have_an_initializer_1052", "A 'set' accessor parameter cannot have an initializer."), A_set_accessor_cannot_have_rest_parameter: a(1053, e.DiagnosticCategory.Error, "A_set_accessor_cannot_have_rest_parameter_1053", "A 'set' accessor cannot have rest parameter."), A_get_accessor_cannot_have_parameters: a(1054, e.DiagnosticCategory.Error, "A_get_accessor_cannot_have_parameters_1054", "A 'get' accessor cannot have parameters."), Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value: a(1055, e.DiagnosticCategory.Error, "Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Prom_1055", "Type '{0}' is not a valid async function return type in ES5/ES3 because it does not refer to a Promise-compatible constructor value."), Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher: a(1056, e.DiagnosticCategory.Error, "Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher_1056", "Accessors are only available when targeting ECMAScript 5 and higher."), The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: a(1058, e.DiagnosticCategory.Error, "The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_t_1058", "The return type of an async function must either be a valid promise or must not contain a callable 'then' member."), A_promise_must_have_a_then_method: a(1059, e.DiagnosticCategory.Error, "A_promise_must_have_a_then_method_1059", "A promise must have a 'then' method."), The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback: a(1060, e.DiagnosticCategory.Error, "The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback_1060", "The first parameter of the 'then' method of a promise must be a callback."), Enum_member_must_have_initializer: a(1061, e.DiagnosticCategory.Error, "Enum_member_must_have_initializer_1061", "Enum member must have initializer."), Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method: a(1062, e.DiagnosticCategory.Error, "Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method_1062", "Type is referenced directly or indirectly in the fulfillment callback of its own 'then' method."), An_export_assignment_cannot_be_used_in_a_namespace: a(1063, e.DiagnosticCategory.Error, "An_export_assignment_cannot_be_used_in_a_namespace_1063", "An export assignment cannot be used in a namespace."), The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0: a(1064, e.DiagnosticCategory.Error, "The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_wri_1064", "The return type of an async function or method must be the global Promise<T> type. Did you mean to write 'Promise<{0}>'?"), In_ambient_enum_declarations_member_initializer_must_be_constant_expression: a(1066, e.DiagnosticCategory.Error, "In_ambient_enum_declarations_member_initializer_must_be_constant_expression_1066", "In ambient enum declarations member initializer must be constant expression."), Unexpected_token_A_constructor_method_accessor_or_property_was_expected: a(1068, e.DiagnosticCategory.Error, "Unexpected_token_A_constructor_method_accessor_or_property_was_expected_1068", "Unexpected token. A constructor, method, accessor, or property was expected."), Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces: a(1069, e.DiagnosticCategory.Error, "Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces_1069", "Unexpected token. A type parameter name was expected without curly braces."), _0_modifier_cannot_appear_on_a_type_member: a(1070, e.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_type_member_1070", "'{0}' modifier cannot appear on a type member."), _0_modifier_cannot_appear_on_an_index_signature: a(1071, e.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_an_index_signature_1071", "'{0}' modifier cannot appear on an index signature."), A_0_modifier_cannot_be_used_with_an_import_declaration: a(1079, e.DiagnosticCategory.Error, "A_0_modifier_cannot_be_used_with_an_import_declaration_1079", "A '{0}' modifier cannot be used with an import declaration."), Invalid_reference_directive_syntax: a(1084, e.DiagnosticCategory.Error, "Invalid_reference_directive_syntax_1084", "Invalid 'reference' directive syntax."), Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0: a(1085, e.DiagnosticCategory.Error, "Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0_1085", "Octal literals are not available when targeting ECMAScript 5 and higher. Use the syntax '{0}'."), _0_modifier_cannot_appear_on_a_constructor_declaration: a(1089, e.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_constructor_declaration_1089", "'{0}' modifier cannot appear on a constructor declaration."), _0_modifier_cannot_appear_on_a_parameter: a(1090, e.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_parameter_1090", "'{0}' modifier cannot appear on a parameter."), Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement: a(1091, e.DiagnosticCategory.Error, "Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement_1091", "Only a single variable declaration is allowed in a 'for...in' statement."), Type_parameters_cannot_appear_on_a_constructor_declaration: a(1092, e.DiagnosticCategory.Error, "Type_parameters_cannot_appear_on_a_constructor_declaration_1092", "Type parameters cannot appear on a constructor declaration."), Type_annotation_cannot_appear_on_a_constructor_declaration: a(1093, e.DiagnosticCategory.Error, "Type_annotation_cannot_appear_on_a_constructor_declaration_1093", "Type annotation cannot appear on a constructor declaration."), An_accessor_cannot_have_type_parameters: a(1094, e.DiagnosticCategory.Error, "An_accessor_cannot_have_type_parameters_1094", "An accessor cannot have type parameters."), A_set_accessor_cannot_have_a_return_type_annotation: a(1095, e.DiagnosticCategory.Error, "A_set_accessor_cannot_have_a_return_type_annotation_1095", "A 'set' accessor cannot have a return type annotation."), An_index_signature_must_have_exactly_one_parameter: a(1096, e.DiagnosticCategory.Error, "An_index_signature_must_have_exactly_one_parameter_1096", "An index signature must have exactly one parameter."), _0_list_cannot_be_empty: a(1097, e.DiagnosticCategory.Error, "_0_list_cannot_be_empty_1097", "'{0}' list cannot be empty."), Type_parameter_list_cannot_be_empty: a(1098, e.DiagnosticCategory.Error, "Type_parameter_list_cannot_be_empty_1098", "Type parameter list cannot be empty."), Type_argument_list_cannot_be_empty: a(1099, e.DiagnosticCategory.Error, "Type_argument_list_cannot_be_empty_1099", "Type argument list cannot be empty."), Invalid_use_of_0_in_strict_mode: a(1100, e.DiagnosticCategory.Error, "Invalid_use_of_0_in_strict_mode_1100", "Invalid use of '{0}' in strict mode."), with_statements_are_not_allowed_in_strict_mode: a(1101, e.DiagnosticCategory.Error, "with_statements_are_not_allowed_in_strict_mode_1101", "'with' statements are not allowed in strict mode."), delete_cannot_be_called_on_an_identifier_in_strict_mode: a(1102, e.DiagnosticCategory.Error, "delete_cannot_be_called_on_an_identifier_in_strict_mode_1102", "'delete' cannot be called on an identifier in strict mode."), for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules: a(1103, e.DiagnosticCategory.Error, "for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_1103", "'for await' loops are only allowed within async functions and at the top levels of modules."), A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement: a(1104, e.DiagnosticCategory.Error, "A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement_1104", "A 'continue' statement can only be used within an enclosing iteration statement."), A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement: a(1105, e.DiagnosticCategory.Error, "A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement_1105", "A 'break' statement can only be used within an enclosing iteration or switch statement."), The_left_hand_side_of_a_for_of_statement_may_not_be_async: a(1106, e.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_may_not_be_async_1106", "The left-hand side of a 'for...of' statement may not be 'async'."), Jump_target_cannot_cross_function_boundary: a(1107, e.DiagnosticCategory.Error, "Jump_target_cannot_cross_function_boundary_1107", "Jump target cannot cross function boundary."), A_return_statement_can_only_be_used_within_a_function_body: a(1108, e.DiagnosticCategory.Error, "A_return_statement_can_only_be_used_within_a_function_body_1108", "A 'return' statement can only be used within a function body."), Expression_expected: a(1109, e.DiagnosticCategory.Error, "Expression_expected_1109", "Expression expected."), Type_expected: a(1110, e.DiagnosticCategory.Error, "Type_expected_1110", "Type expected."), A_default_clause_cannot_appear_more_than_once_in_a_switch_statement: a(1113, e.DiagnosticCategory.Error, "A_default_clause_cannot_appear_more_than_once_in_a_switch_statement_1113", "A 'default' clause cannot appear more than once in a 'switch' statement."), Duplicate_label_0: a(1114, e.DiagnosticCategory.Error, "Duplicate_label_0_1114", "Duplicate label '{0}'."), A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement: a(1115, e.DiagnosticCategory.Error, "A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement_1115", "A 'continue' statement can only jump to a label of an enclosing iteration statement."), A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement: a(1116, e.DiagnosticCategory.Error, "A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement_1116", "A 'break' statement can only jump to a label of an enclosing statement."), An_object_literal_cannot_have_multiple_properties_with_the_same_name: a(1117, e.DiagnosticCategory.Error, "An_object_literal_cannot_have_multiple_properties_with_the_same_name_1117", "An object literal cannot have multiple properties with the same name."), An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name: a(1118, e.DiagnosticCategory.Error, "An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name_1118", "An object literal cannot have multiple get/set accessors with the same name."), An_object_literal_cannot_have_property_and_accessor_with_the_same_name: a(1119, e.DiagnosticCategory.Error, "An_object_literal_cannot_have_property_and_accessor_with_the_same_name_1119", "An object literal cannot have property and accessor with the same name."), An_export_assignment_cannot_have_modifiers: a(1120, e.DiagnosticCategory.Error, "An_export_assignment_cannot_have_modifiers_1120", "An export assignment cannot have modifiers."), Octal_literals_are_not_allowed_in_strict_mode: a(1121, e.DiagnosticCategory.Error, "Octal_literals_are_not_allowed_in_strict_mode_1121", "Octal literals are not allowed in strict mode."), Variable_declaration_list_cannot_be_empty: a(1123, e.DiagnosticCategory.Error, "Variable_declaration_list_cannot_be_empty_1123", "Variable declaration list cannot be empty."), Digit_expected: a(1124, e.DiagnosticCategory.Error, "Digit_expected_1124", "Digit expected."), Hexadecimal_digit_expected: a(1125, e.DiagnosticCategory.Error, "Hexadecimal_digit_expected_1125", "Hexadecimal digit expected."), Unexpected_end_of_text: a(1126, e.DiagnosticCategory.Error, "Unexpected_end_of_text_1126", "Unexpected end of text."), Invalid_character: a(1127, e.DiagnosticCategory.Error, "Invalid_character_1127", "Invalid character."), Declaration_or_statement_expected: a(1128, e.DiagnosticCategory.Error, "Declaration_or_statement_expected_1128", "Declaration or statement expected."), Statement_expected: a(1129, e.DiagnosticCategory.Error, "Statement_expected_1129", "Statement expected."), case_or_default_expected: a(1130, e.DiagnosticCategory.Error, "case_or_default_expected_1130", "'case' or 'default' expected."), Property_or_signature_expected: a(1131, e.DiagnosticCategory.Error, "Property_or_signature_expected_1131", "Property or signature expected."), Enum_member_expected: a(1132, e.DiagnosticCategory.Error, "Enum_member_expected_1132", "Enum member expected."), Variable_declaration_expected: a(1134, e.DiagnosticCategory.Error, "Variable_declaration_expected_1134", "Variable declaration expected."), Argument_expression_expected: a(1135, e.DiagnosticCategory.Error, "Argument_expression_expected_1135", "Argument expression expected."), Property_assignment_expected: a(1136, e.DiagnosticCategory.Error, "Property_assignment_expected_1136", "Property assignment expected."), Expression_or_comma_expected: a(1137, e.DiagnosticCategory.Error, "Expression_or_comma_expected_1137", "Expression or comma expected."), Parameter_declaration_expected: a(1138, e.DiagnosticCategory.Error, "Parameter_declaration_expected_1138", "Parameter declaration expected."), Type_parameter_declaration_expected: a(1139, e.DiagnosticCategory.Error, "Type_parameter_declaration_expected_1139", "Type parameter declaration expected."), Type_argument_expected: a(1140, e.DiagnosticCategory.Error, "Type_argument_expected_1140", "Type argument expected."), String_literal_expected: a(1141, e.DiagnosticCategory.Error, "String_literal_expected_1141", "String literal expected."), Line_break_not_permitted_here: a(1142, e.DiagnosticCategory.Error, "Line_break_not_permitted_here_1142", "Line break not permitted here."), or_expected: a(1144, e.DiagnosticCategory.Error, "or_expected_1144", "'{' or ';' expected."), Declaration_expected: a(1146, e.DiagnosticCategory.Error, "Declaration_expected_1146", "Declaration expected."), Import_declarations_in_a_namespace_cannot_reference_a_module: a(1147, e.DiagnosticCategory.Error, "Import_declarations_in_a_namespace_cannot_reference_a_module_1147", "Import declarations in a namespace cannot reference a module."), Cannot_use_imports_exports_or_module_augmentations_when_module_is_none: a(1148, e.DiagnosticCategory.Error, "Cannot_use_imports_exports_or_module_augmentations_when_module_is_none_1148", "Cannot use imports, exports, or module augmentations when '--module' is 'none'."), File_name_0_differs_from_already_included_file_name_1_only_in_casing: a(1149, e.DiagnosticCategory.Error, "File_name_0_differs_from_already_included_file_name_1_only_in_casing_1149", "File name '{0}' differs from already included file name '{1}' only in casing."), const_declarations_must_be_initialized: a(1155, e.DiagnosticCategory.Error, "const_declarations_must_be_initialized_1155", "'const' declarations must be initialized."), const_declarations_can_only_be_declared_inside_a_block: a(1156, e.DiagnosticCategory.Error, "const_declarations_can_only_be_declared_inside_a_block_1156", "'const' declarations can only be declared inside a block."), let_declarations_can_only_be_declared_inside_a_block: a(1157, e.DiagnosticCategory.Error, "let_declarations_can_only_be_declared_inside_a_block_1157", "'let' declarations can only be declared inside a block."), Unterminated_template_literal: a(1160, e.DiagnosticCategory.Error, "Unterminated_template_literal_1160", "Unterminated template literal."), Unterminated_regular_expression_literal: a(1161, e.DiagnosticCategory.Error, "Unterminated_regular_expression_literal_1161", "Unterminated regular expression literal."), An_object_member_cannot_be_declared_optional: a(1162, e.DiagnosticCategory.Error, "An_object_member_cannot_be_declared_optional_1162", "An object member cannot be declared optional."), A_yield_expression_is_only_allowed_in_a_generator_body: a(1163, e.DiagnosticCategory.Error, "A_yield_expression_is_only_allowed_in_a_generator_body_1163", "A 'yield' expression is only allowed in a generator body."), Computed_property_names_are_not_allowed_in_enums: a(1164, e.DiagnosticCategory.Error, "Computed_property_names_are_not_allowed_in_enums_1164", "Computed property names are not allowed in enums."), A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: a(1165, e.DiagnosticCategory.Error, "A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_t_1165", "A computed property name in an ambient context must refer to an expression whose type is a literal type or a 'unique symbol' type."), A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_symbol_type: a(1166, e.DiagnosticCategory.Error, "A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_1166", "A computed property name in a class property declaration must have a simple literal type or a 'unique symbol' type."), A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: a(1168, e.DiagnosticCategory.Error, "A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_ty_1168", "A computed property name in a method overload must refer to an expression whose type is a literal type or a 'unique symbol' type."), A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: a(1169, e.DiagnosticCategory.Error, "A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_1169", "A computed property name in an interface must refer to an expression whose type is a literal type or a 'unique symbol' type."), A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: a(1170, e.DiagnosticCategory.Error, "A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type__1170", "A computed property name in a type literal must refer to an expression whose type is a literal type or a 'unique symbol' type."), A_comma_expression_is_not_allowed_in_a_computed_property_name: a(1171, e.DiagnosticCategory.Error, "A_comma_expression_is_not_allowed_in_a_computed_property_name_1171", "A comma expression is not allowed in a computed property name."), extends_clause_already_seen: a(1172, e.DiagnosticCategory.Error, "extends_clause_already_seen_1172", "'extends' clause already seen."), extends_clause_must_precede_implements_clause: a(1173, e.DiagnosticCategory.Error, "extends_clause_must_precede_implements_clause_1173", "'extends' clause must precede 'implements' clause."), Classes_can_only_extend_a_single_class: a(1174, e.DiagnosticCategory.Error, "Classes_can_only_extend_a_single_class_1174", "Classes can only extend a single class."), implements_clause_already_seen: a(1175, e.DiagnosticCategory.Error, "implements_clause_already_seen_1175", "'implements' clause already seen."), Interface_declaration_cannot_have_implements_clause: a(1176, e.DiagnosticCategory.Error, "Interface_declaration_cannot_have_implements_clause_1176", "Interface declaration cannot have 'implements' clause."), Binary_digit_expected: a(1177, e.DiagnosticCategory.Error, "Binary_digit_expected_1177", "Binary digit expected."), Octal_digit_expected: a(1178, e.DiagnosticCategory.Error, "Octal_digit_expected_1178", "Octal digit expected."), Unexpected_token_expected: a(1179, e.DiagnosticCategory.Error, "Unexpected_token_expected_1179", "Unexpected token. '{' expected."), Property_destructuring_pattern_expected: a(1180, e.DiagnosticCategory.Error, "Property_destructuring_pattern_expected_1180", "Property destructuring pattern expected."), Array_element_destructuring_pattern_expected: a(1181, e.DiagnosticCategory.Error, "Array_element_destructuring_pattern_expected_1181", "Array element destructuring pattern expected."), A_destructuring_declaration_must_have_an_initializer: a(1182, e.DiagnosticCategory.Error, "A_destructuring_declaration_must_have_an_initializer_1182", "A destructuring declaration must have an initializer."), An_implementation_cannot_be_declared_in_ambient_contexts: a(1183, e.DiagnosticCategory.Error, "An_implementation_cannot_be_declared_in_ambient_contexts_1183", "An implementation cannot be declared in ambient contexts."), Modifiers_cannot_appear_here: a(1184, e.DiagnosticCategory.Error, "Modifiers_cannot_appear_here_1184", "Modifiers cannot appear here."), Merge_conflict_marker_encountered: a(1185, e.DiagnosticCategory.Error, "Merge_conflict_marker_encountered_1185", "Merge conflict marker encountered."), A_rest_element_cannot_have_an_initializer: a(1186, e.DiagnosticCategory.Error, "A_rest_element_cannot_have_an_initializer_1186", "A rest element cannot have an initializer."), A_parameter_property_may_not_be_declared_using_a_binding_pattern: a(1187, e.DiagnosticCategory.Error, "A_parameter_property_may_not_be_declared_using_a_binding_pattern_1187", "A parameter property may not be declared using a binding pattern."), Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement: a(1188, e.DiagnosticCategory.Error, "Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement_1188", "Only a single variable declaration is allowed in a 'for...of' statement."), The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer: a(1189, e.DiagnosticCategory.Error, "The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer_1189", "The variable declaration of a 'for...in' statement cannot have an initializer."), The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer: a(1190, e.DiagnosticCategory.Error, "The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer_1190", "The variable declaration of a 'for...of' statement cannot have an initializer."), An_import_declaration_cannot_have_modifiers: a(1191, e.DiagnosticCategory.Error, "An_import_declaration_cannot_have_modifiers_1191", "An import declaration cannot have modifiers."), Module_0_has_no_default_export: a(1192, e.DiagnosticCategory.Error, "Module_0_has_no_default_export_1192", "Module '{0}' has no default export."), An_export_declaration_cannot_have_modifiers: a(1193, e.DiagnosticCategory.Error, "An_export_declaration_cannot_have_modifiers_1193", "An export declaration cannot have modifiers."), Export_declarations_are_not_permitted_in_a_namespace: a(1194, e.DiagnosticCategory.Error, "Export_declarations_are_not_permitted_in_a_namespace_1194", "Export declarations are not permitted in a namespace."), export_Asterisk_does_not_re_export_a_default: a(1195, e.DiagnosticCategory.Error, "export_Asterisk_does_not_re_export_a_default_1195", "'export *' does not re-export a default."), Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified: a(1196, e.DiagnosticCategory.Error, "Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified_1196", "Catch clause variable type annotation must be 'any' or 'unknown' if specified."), Catch_clause_variable_cannot_have_an_initializer: a(1197, e.DiagnosticCategory.Error, "Catch_clause_variable_cannot_have_an_initializer_1197", "Catch clause variable cannot have an initializer."), An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive: a(1198, e.DiagnosticCategory.Error, "An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive_1198", "An extended Unicode escape value must be between 0x0 and 0x10FFFF inclusive."), Unterminated_Unicode_escape_sequence: a(1199, e.DiagnosticCategory.Error, "Unterminated_Unicode_escape_sequence_1199", "Unterminated Unicode escape sequence."), Line_terminator_not_permitted_before_arrow: a(1200, e.DiagnosticCategory.Error, "Line_terminator_not_permitted_before_arrow_1200", "Line terminator not permitted before arrow."), Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead: a(1202, e.DiagnosticCategory.Error, "Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_1202", `Import assignment cannot be used when targeting ECMAScript modules. Consider using 'import * as ns from "mod"', 'import {a} from "mod"', 'import d from "mod"', or another module format instead.`), Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead: a(1203, e.DiagnosticCategory.Error, "Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or__1203", "Export assignment cannot be used when targeting ECMAScript modules. Consider using 'export default' or another module format instead."), Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type: a(1205, e.DiagnosticCategory.Error, "Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type_1205", "Re-exporting a type when the '--isolatedModules' flag is provided requires using 'export type'."), Decorators_are_not_valid_here: a(1206, e.DiagnosticCategory.Error, "Decorators_are_not_valid_here_1206", "Decorators are not valid here."), Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name: a(1207, e.DiagnosticCategory.Error, "Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name_1207", "Decorators cannot be applied to multiple get/set accessors of the same name."), _0_cannot_be_compiled_under_isolatedModules_because_it_is_considered_a_global_script_file_Add_an_import_export_or_an_empty_export_statement_to_make_it_a_module: a(1208, e.DiagnosticCategory.Error, "_0_cannot_be_compiled_under_isolatedModules_because_it_is_considered_a_global_script_file_Add_an_imp_1208", "'{0}' cannot be compiled under '--isolatedModules' because it is considered a global script file. Add an import, export, or an empty 'export {}' statement to make it a module."), Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode: a(1210, e.DiagnosticCategory.Error, "Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of__1210", "Code contained in a class is evaluated in JavaScript's strict mode which does not allow this use of '{0}'. For more information, see https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Strict_mode."), A_class_declaration_without_the_default_modifier_must_have_a_name: a(1211, e.DiagnosticCategory.Error, "A_class_declaration_without_the_default_modifier_must_have_a_name_1211", "A class declaration without the 'default' modifier must have a name."), Identifier_expected_0_is_a_reserved_word_in_strict_mode: a(1212, e.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_1212", "Identifier expected. '{0}' is a reserved word in strict mode."), Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode: a(1213, e.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_stric_1213", "Identifier expected. '{0}' is a reserved word in strict mode. Class definitions are automatically in strict mode."), Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode: a(1214, e.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode_1214", "Identifier expected. '{0}' is a reserved word in strict mode. Modules are automatically in strict mode."), Invalid_use_of_0_Modules_are_automatically_in_strict_mode: a(1215, e.DiagnosticCategory.Error, "Invalid_use_of_0_Modules_are_automatically_in_strict_mode_1215", "Invalid use of '{0}'. Modules are automatically in strict mode."), Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules: a(1216, e.DiagnosticCategory.Error, "Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules_1216", "Identifier expected. '__esModule' is reserved as an exported marker when transforming ECMAScript modules."), Export_assignment_is_not_supported_when_module_flag_is_system: a(1218, e.DiagnosticCategory.Error, "Export_assignment_is_not_supported_when_module_flag_is_system_1218", "Export assignment is not supported when '--module' flag is 'system'."), Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning: a(1219, e.DiagnosticCategory.Error, "Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_t_1219", "Experimental support for decorators is a feature that is subject to change in a future release. Set the 'experimentalDecorators' option in your 'tsconfig' or 'jsconfig' to remove this warning."), Generators_are_not_allowed_in_an_ambient_context: a(1221, e.DiagnosticCategory.Error, "Generators_are_not_allowed_in_an_ambient_context_1221", "Generators are not allowed in an ambient context."), An_overload_signature_cannot_be_declared_as_a_generator: a(1222, e.DiagnosticCategory.Error, "An_overload_signature_cannot_be_declared_as_a_generator_1222", "An overload signature cannot be declared as a generator."), _0_tag_already_specified: a(1223, e.DiagnosticCategory.Error, "_0_tag_already_specified_1223", "'{0}' tag already specified."), Signature_0_must_be_a_type_predicate: a(1224, e.DiagnosticCategory.Error, "Signature_0_must_be_a_type_predicate_1224", "Signature '{0}' must be a type predicate."), Cannot_find_parameter_0: a(1225, e.DiagnosticCategory.Error, "Cannot_find_parameter_0_1225", "Cannot find parameter '{0}'."), Type_predicate_0_is_not_assignable_to_1: a(1226, e.DiagnosticCategory.Error, "Type_predicate_0_is_not_assignable_to_1_1226", "Type predicate '{0}' is not assignable to '{1}'."), Parameter_0_is_not_in_the_same_position_as_parameter_1: a(1227, e.DiagnosticCategory.Error, "Parameter_0_is_not_in_the_same_position_as_parameter_1_1227", "Parameter '{0}' is not in the same position as parameter '{1}'."), A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods: a(1228, e.DiagnosticCategory.Error, "A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods_1228", "A type predicate is only allowed in return type position for functions and methods."), A_type_predicate_cannot_reference_a_rest_parameter: a(1229, e.DiagnosticCategory.Error, "A_type_predicate_cannot_reference_a_rest_parameter_1229", "A type predicate cannot reference a rest parameter."), A_type_predicate_cannot_reference_element_0_in_a_binding_pattern: a(1230, e.DiagnosticCategory.Error, "A_type_predicate_cannot_reference_element_0_in_a_binding_pattern_1230", "A type predicate cannot reference element '{0}' in a binding pattern."), An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration: a(1231, e.DiagnosticCategory.Error, "An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration_1231", "An export assignment must be at the top level of a file or module declaration."), An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module: a(1232, e.DiagnosticCategory.Error, "An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module_1232", "An import declaration can only be used at the top level of a namespace or module."), An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module: a(1233, e.DiagnosticCategory.Error, "An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module_1233", "An export declaration can only be used at the top level of a namespace or module."), An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file: a(1234, e.DiagnosticCategory.Error, "An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file_1234", "An ambient module declaration is only allowed at the top level in a file."), A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module: a(1235, e.DiagnosticCategory.Error, "A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module_1235", "A namespace declaration is only allowed at the top level of a namespace or module."), The_return_type_of_a_property_decorator_function_must_be_either_void_or_any: a(1236, e.DiagnosticCategory.Error, "The_return_type_of_a_property_decorator_function_must_be_either_void_or_any_1236", "The return type of a property decorator function must be either 'void' or 'any'."), The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any: a(1237, e.DiagnosticCategory.Error, "The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any_1237", "The return type of a parameter decorator function must be either 'void' or 'any'."), Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression: a(1238, e.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression_1238", "Unable to resolve signature of class decorator when called as an expression."), Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression: a(1239, e.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression_1239", "Unable to resolve signature of parameter decorator when called as an expression."), Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression: a(1240, e.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression_1240", "Unable to resolve signature of property decorator when called as an expression."), Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression: a(1241, e.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression_1241", "Unable to resolve signature of method decorator when called as an expression."), abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration: a(1242, e.DiagnosticCategory.Error, "abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration_1242", "'abstract' modifier can only appear on a class, method, or property declaration."), _0_modifier_cannot_be_used_with_1_modifier: a(1243, e.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_with_1_modifier_1243", "'{0}' modifier cannot be used with '{1}' modifier."), Abstract_methods_can_only_appear_within_an_abstract_class: a(1244, e.DiagnosticCategory.Error, "Abstract_methods_can_only_appear_within_an_abstract_class_1244", "Abstract methods can only appear within an abstract class."), Method_0_cannot_have_an_implementation_because_it_is_marked_abstract: a(1245, e.DiagnosticCategory.Error, "Method_0_cannot_have_an_implementation_because_it_is_marked_abstract_1245", "Method '{0}' cannot have an implementation because it is marked abstract."), An_interface_property_cannot_have_an_initializer: a(1246, e.DiagnosticCategory.Error, "An_interface_property_cannot_have_an_initializer_1246", "An interface property cannot have an initializer."), A_type_literal_property_cannot_have_an_initializer: a(1247, e.DiagnosticCategory.Error, "A_type_literal_property_cannot_have_an_initializer_1247", "A type literal property cannot have an initializer."), A_class_member_cannot_have_the_0_keyword: a(1248, e.DiagnosticCategory.Error, "A_class_member_cannot_have_the_0_keyword_1248", "A class member cannot have the '{0}' keyword."), A_decorator_can_only_decorate_a_method_implementation_not_an_overload: a(1249, e.DiagnosticCategory.Error, "A_decorator_can_only_decorate_a_method_implementation_not_an_overload_1249", "A decorator can only decorate a method implementation, not an overload."), Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5: a(1250, e.DiagnosticCategory.Error, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_1250", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'."), Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode: a(1251, e.DiagnosticCategory.Error, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_d_1251", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Class definitions are automatically in strict mode."), Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode: a(1252, e.DiagnosticCategory.Error, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_1252", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Modules are automatically in strict mode."), A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference: a(1254, e.DiagnosticCategory.Error, "A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_refere_1254", "A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference."), A_definite_assignment_assertion_is_not_permitted_in_this_context: a(1255, e.DiagnosticCategory.Error, "A_definite_assignment_assertion_is_not_permitted_in_this_context_1255", "A definite assignment assertion '!' is not permitted in this context."), A_required_element_cannot_follow_an_optional_element: a(1257, e.DiagnosticCategory.Error, "A_required_element_cannot_follow_an_optional_element_1257", "A required element cannot follow an optional element."), A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration: a(1258, e.DiagnosticCategory.Error, "A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration_1258", "A default export must be at the top level of a file or module declaration."), Module_0_can_only_be_default_imported_using_the_1_flag: a(1259, e.DiagnosticCategory.Error, "Module_0_can_only_be_default_imported_using_the_1_flag_1259", "Module '{0}' can only be default-imported using the '{1}' flag"), Keywords_cannot_contain_escape_characters: a(1260, e.DiagnosticCategory.Error, "Keywords_cannot_contain_escape_characters_1260", "Keywords cannot contain escape characters."), Already_included_file_name_0_differs_from_file_name_1_only_in_casing: a(1261, e.DiagnosticCategory.Error, "Already_included_file_name_0_differs_from_file_name_1_only_in_casing_1261", "Already included file name '{0}' differs from file name '{1}' only in casing."), Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module: a(1262, e.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module_1262", "Identifier expected. '{0}' is a reserved word at the top-level of a module."), Declarations_with_initializers_cannot_also_have_definite_assignment_assertions: a(1263, e.DiagnosticCategory.Error, "Declarations_with_initializers_cannot_also_have_definite_assignment_assertions_1263", "Declarations with initializers cannot also have definite assignment assertions."), Declarations_with_definite_assignment_assertions_must_also_have_type_annotations: a(1264, e.DiagnosticCategory.Error, "Declarations_with_definite_assignment_assertions_must_also_have_type_annotations_1264", "Declarations with definite assignment assertions must also have type annotations."), A_rest_element_cannot_follow_another_rest_element: a(1265, e.DiagnosticCategory.Error, "A_rest_element_cannot_follow_another_rest_element_1265", "A rest element cannot follow another rest element."), An_optional_element_cannot_follow_a_rest_element: a(1266, e.DiagnosticCategory.Error, "An_optional_element_cannot_follow_a_rest_element_1266", "An optional element cannot follow a rest element."), Property_0_cannot_have_an_initializer_because_it_is_marked_abstract: a(1267, e.DiagnosticCategory.Error, "Property_0_cannot_have_an_initializer_because_it_is_marked_abstract_1267", "Property '{0}' cannot have an initializer because it is marked abstract."), An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type: a(1268, e.DiagnosticCategory.Error, "An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type_1268", "An index signature parameter type must be 'string', 'number', 'symbol', or a template literal type."), Cannot_use_export_import_on_a_type_or_type_only_namespace_when_the_isolatedModules_flag_is_provided: a(1269, e.DiagnosticCategory.Error, "Cannot_use_export_import_on_a_type_or_type_only_namespace_when_the_isolatedModules_flag_is_provided_1269", "Cannot use 'export import' on a type or type-only namespace when the '--isolatedModules' flag is provided."), Decorator_function_return_type_0_is_not_assignable_to_type_1: a(1270, e.DiagnosticCategory.Error, "Decorator_function_return_type_0_is_not_assignable_to_type_1_1270", "Decorator function return type '{0}' is not assignable to type '{1}'."), Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any: a(1271, e.DiagnosticCategory.Error, "Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any_1271", "Decorator function return type is '{0}' but is expected to be 'void' or 'any'."), A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled: a(1272, e.DiagnosticCategory.Error, "A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_w_1272", "A type referenced in a decorated signature must be imported with 'import type' or a namespace import when 'isolatedModules' and 'emitDecoratorMetadata' are enabled."), _0_modifier_cannot_appear_on_a_type_parameter: a(1273, e.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_type_parameter_1273", "'{0}' modifier cannot appear on a type parameter"), _0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias: a(1274, e.DiagnosticCategory.Error, "_0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias_1274", "'{0}' modifier can only appear on a type parameter of a class, interface or type alias"), with_statements_are_not_allowed_in_an_async_function_block: a(1300, e.DiagnosticCategory.Error, "with_statements_are_not_allowed_in_an_async_function_block_1300", "'with' statements are not allowed in an async function block."), await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules: a(1308, e.DiagnosticCategory.Error, "await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_1308", "'await' expressions are only allowed within async functions and at the top levels of modules."), The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level: a(1309, e.DiagnosticCategory.Error, "The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level_1309", "The current file is a CommonJS module and cannot use 'await' at the top level."), Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern: a(1312, e.DiagnosticCategory.Error, "Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_1312", "Did you mean to use a ':'? An '=' can only follow a property name when the containing object literal is part of a destructuring pattern."), The_body_of_an_if_statement_cannot_be_the_empty_statement: a(1313, e.DiagnosticCategory.Error, "The_body_of_an_if_statement_cannot_be_the_empty_statement_1313", "The body of an 'if' statement cannot be the empty statement."), Global_module_exports_may_only_appear_in_module_files: a(1314, e.DiagnosticCategory.Error, "Global_module_exports_may_only_appear_in_module_files_1314", "Global module exports may only appear in module files."), Global_module_exports_may_only_appear_in_declaration_files: a(1315, e.DiagnosticCategory.Error, "Global_module_exports_may_only_appear_in_declaration_files_1315", "Global module exports may only appear in declaration files."), Global_module_exports_may_only_appear_at_top_level: a(1316, e.DiagnosticCategory.Error, "Global_module_exports_may_only_appear_at_top_level_1316", "Global module exports may only appear at top level."), A_parameter_property_cannot_be_declared_using_a_rest_parameter: a(1317, e.DiagnosticCategory.Error, "A_parameter_property_cannot_be_declared_using_a_rest_parameter_1317", "A parameter property cannot be declared using a rest parameter."), An_abstract_accessor_cannot_have_an_implementation: a(1318, e.DiagnosticCategory.Error, "An_abstract_accessor_cannot_have_an_implementation_1318", "An abstract accessor cannot have an implementation."), A_default_export_can_only_be_used_in_an_ECMAScript_style_module: a(1319, e.DiagnosticCategory.Error, "A_default_export_can_only_be_used_in_an_ECMAScript_style_module_1319", "A default export can only be used in an ECMAScript-style module."), Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: a(1320, e.DiagnosticCategory.Error, "Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member_1320", "Type of 'await' operand must either be a valid promise or must not contain a callable 'then' member."), Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: a(1321, e.DiagnosticCategory.Error, "Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_cal_1321", "Type of 'yield' operand in an async generator must either be a valid promise or must not contain a callable 'then' member."), Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: a(1322, e.DiagnosticCategory.Error, "Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_con_1322", "Type of iterated elements of a 'yield*' operand must either be a valid promise or must not contain a callable 'then' member."), Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd_system_umd_node16_or_nodenext: a(1323, e.DiagnosticCategory.Error, "Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd__1323", "Dynamic imports are only supported when the '--module' flag is set to 'es2020', 'es2022', 'esnext', 'commonjs', 'amd', 'system', 'umd', 'node16', or 'nodenext'."), Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nodenext: a(1324, e.DiagnosticCategory.Error, "Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nod_1324", "Dynamic imports only support a second argument when the '--module' option is set to 'esnext', 'node16', or 'nodenext'."), Argument_of_dynamic_import_cannot_be_spread_element: a(1325, e.DiagnosticCategory.Error, "Argument_of_dynamic_import_cannot_be_spread_element_1325", "Argument of dynamic import cannot be spread element."), This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments: a(1326, e.DiagnosticCategory.Error, "This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot__1326", "This use of 'import' is invalid. 'import()' calls can be written, but they must have parentheses and cannot have type arguments."), String_literal_with_double_quotes_expected: a(1327, e.DiagnosticCategory.Error, "String_literal_with_double_quotes_expected_1327", "String literal with double quotes expected."), Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal: a(1328, e.DiagnosticCategory.Error, "Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_li_1328", "Property value can only be string literal, numeric literal, 'true', 'false', 'null', object literal or array literal."), _0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0: a(1329, e.DiagnosticCategory.Error, "_0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write__1329", "'{0}' accepts too few arguments to be used as a decorator here. Did you mean to call it first and write '@{0}()'?"), A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly: a(1330, e.DiagnosticCategory.Error, "A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly_1330", "A property of an interface or type literal whose type is a 'unique symbol' type must be 'readonly'."), A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly: a(1331, e.DiagnosticCategory.Error, "A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly_1331", "A property of a class whose type is a 'unique symbol' type must be both 'static' and 'readonly'."), A_variable_whose_type_is_a_unique_symbol_type_must_be_const: a(1332, e.DiagnosticCategory.Error, "A_variable_whose_type_is_a_unique_symbol_type_must_be_const_1332", "A variable whose type is a 'unique symbol' type must be 'const'."), unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name: a(1333, e.DiagnosticCategory.Error, "unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name_1333", "'unique symbol' types may not be used on a variable declaration with a binding name."), unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement: a(1334, e.DiagnosticCategory.Error, "unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement_1334", "'unique symbol' types are only allowed on variables in a variable statement."), unique_symbol_types_are_not_allowed_here: a(1335, e.DiagnosticCategory.Error, "unique_symbol_types_are_not_allowed_here_1335", "'unique symbol' types are not allowed here."), An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead: a(1337, e.DiagnosticCategory.Error, "An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_o_1337", "An index signature parameter type cannot be a literal type or generic type. Consider using a mapped object type instead."), infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type: a(1338, e.DiagnosticCategory.Error, "infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type_1338", "'infer' declarations are only permitted in the 'extends' clause of a conditional type."), Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here: a(1339, e.DiagnosticCategory.Error, "Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here_1339", "Module '{0}' does not refer to a value, but is used as a value here."), Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0: a(1340, e.DiagnosticCategory.Error, "Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0_1340", "Module '{0}' does not refer to a type, but is used as a type here. Did you mean 'typeof import('{0}')'?"), Type_arguments_cannot_be_used_here: a(1342, e.DiagnosticCategory.Error, "Type_arguments_cannot_be_used_here_1342", "Type arguments cannot be used here."), The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system_node16_or_nodenext: a(1343, e.DiagnosticCategory.Error, "The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system__1343", "The 'import.meta' meta-property is only allowed when the '--module' option is 'es2020', 'es2022', 'esnext', 'system', 'node16', or 'nodenext'."), A_label_is_not_allowed_here: a(1344, e.DiagnosticCategory.Error, "A_label_is_not_allowed_here_1344", "'A label is not allowed here."), An_expression_of_type_void_cannot_be_tested_for_truthiness: a(1345, e.DiagnosticCategory.Error, "An_expression_of_type_void_cannot_be_tested_for_truthiness_1345", "An expression of type 'void' cannot be tested for truthiness."), This_parameter_is_not_allowed_with_use_strict_directive: a(1346, e.DiagnosticCategory.Error, "This_parameter_is_not_allowed_with_use_strict_directive_1346", "This parameter is not allowed with 'use strict' directive."), use_strict_directive_cannot_be_used_with_non_simple_parameter_list: a(1347, e.DiagnosticCategory.Error, "use_strict_directive_cannot_be_used_with_non_simple_parameter_list_1347", "'use strict' directive cannot be used with non-simple parameter list."), Non_simple_parameter_declared_here: a(1348, e.DiagnosticCategory.Error, "Non_simple_parameter_declared_here_1348", "Non-simple parameter declared here."), use_strict_directive_used_here: a(1349, e.DiagnosticCategory.Error, "use_strict_directive_used_here_1349", "'use strict' directive used here."), Print_the_final_configuration_instead_of_building: a(1350, e.DiagnosticCategory.Message, "Print_the_final_configuration_instead_of_building_1350", "Print the final configuration instead of building."), An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal: a(1351, e.DiagnosticCategory.Error, "An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal_1351", "An identifier or keyword cannot immediately follow a numeric literal."), A_bigint_literal_cannot_use_exponential_notation: a(1352, e.DiagnosticCategory.Error, "A_bigint_literal_cannot_use_exponential_notation_1352", "A bigint literal cannot use exponential notation."), A_bigint_literal_must_be_an_integer: a(1353, e.DiagnosticCategory.Error, "A_bigint_literal_must_be_an_integer_1353", "A bigint literal must be an integer."), readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types: a(1354, e.DiagnosticCategory.Error, "readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types_1354", "'readonly' type modifier is only permitted on array and tuple literal types."), A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals: a(1355, e.DiagnosticCategory.Error, "A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array__1355", "A 'const' assertions can only be applied to references to enum members, or string, number, boolean, array, or object literals."), Did_you_mean_to_mark_this_function_as_async: a(1356, e.DiagnosticCategory.Error, "Did_you_mean_to_mark_this_function_as_async_1356", "Did you mean to mark this function as 'async'?"), An_enum_member_name_must_be_followed_by_a_or: a(1357, e.DiagnosticCategory.Error, "An_enum_member_name_must_be_followed_by_a_or_1357", "An enum member name must be followed by a ',', '=', or '}'."), Tagged_template_expressions_are_not_permitted_in_an_optional_chain: a(1358, e.DiagnosticCategory.Error, "Tagged_template_expressions_are_not_permitted_in_an_optional_chain_1358", "Tagged template expressions are not permitted in an optional chain."), Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here: a(1359, e.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here_1359", "Identifier expected. '{0}' is a reserved word that cannot be used here."), _0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type: a(1361, e.DiagnosticCategory.Error, "_0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type_1361", "'{0}' cannot be used as a value because it was imported using 'import type'."), _0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type: a(1362, e.DiagnosticCategory.Error, "_0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type_1362", "'{0}' cannot be used as a value because it was exported using 'export type'."), A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both: a(1363, e.DiagnosticCategory.Error, "A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both_1363", "A type-only import can specify a default import or named bindings, but not both."), Convert_to_type_only_export: a(1364, e.DiagnosticCategory.Message, "Convert_to_type_only_export_1364", "Convert to type-only export"), Convert_all_re_exported_types_to_type_only_exports: a(1365, e.DiagnosticCategory.Message, "Convert_all_re_exported_types_to_type_only_exports_1365", "Convert all re-exported types to type-only exports"), Split_into_two_separate_import_declarations: a(1366, e.DiagnosticCategory.Message, "Split_into_two_separate_import_declarations_1366", "Split into two separate import declarations"), Split_all_invalid_type_only_imports: a(1367, e.DiagnosticCategory.Message, "Split_all_invalid_type_only_imports_1367", "Split all invalid type-only imports"), Did_you_mean_0: a(1369, e.DiagnosticCategory.Message, "Did_you_mean_0_1369", "Did you mean '{0}'?"), This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error: a(1371, e.DiagnosticCategory.Error, "This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set__1371", "This import is never used as a value and must use 'import type' because 'importsNotUsedAsValues' is set to 'error'."), Convert_to_type_only_import: a(1373, e.DiagnosticCategory.Message, "Convert_to_type_only_import_1373", "Convert to type-only import"), Convert_all_imports_not_used_as_a_value_to_type_only_imports: a(1374, e.DiagnosticCategory.Message, "Convert_all_imports_not_used_as_a_value_to_type_only_imports_1374", "Convert all imports not used as a value to type-only imports"), await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module: a(1375, e.DiagnosticCategory.Error, "await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_fi_1375", "'await' expressions are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."), _0_was_imported_here: a(1376, e.DiagnosticCategory.Message, "_0_was_imported_here_1376", "'{0}' was imported here."), _0_was_exported_here: a(1377, e.DiagnosticCategory.Message, "_0_was_exported_here_1377", "'{0}' was exported here."), Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher: a(1378, e.DiagnosticCategory.Error, "Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_n_1378", "Top-level 'await' expressions are only allowed when the 'module' option is set to 'es2022', 'esnext', 'system', 'node16', or 'nodenext', and the 'target' option is set to 'es2017' or higher."), An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type: a(1379, e.DiagnosticCategory.Error, "An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type_1379", "An import alias cannot reference a declaration that was exported using 'export type'."), An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type: a(1380, e.DiagnosticCategory.Error, "An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type_1380", "An import alias cannot reference a declaration that was imported using 'import type'."), Unexpected_token_Did_you_mean_or_rbrace: a(1381, e.DiagnosticCategory.Error, "Unexpected_token_Did_you_mean_or_rbrace_1381", "Unexpected token. Did you mean `{'}'}` or `&rbrace;`?"), Unexpected_token_Did_you_mean_or_gt: a(1382, e.DiagnosticCategory.Error, "Unexpected_token_Did_you_mean_or_gt_1382", "Unexpected token. Did you mean `{'>'}` or `&gt;`?"), Only_named_exports_may_use_export_type: a(1383, e.DiagnosticCategory.Error, "Only_named_exports_may_use_export_type_1383", "Only named exports may use 'export type'."), Function_type_notation_must_be_parenthesized_when_used_in_a_union_type: a(1385, e.DiagnosticCategory.Error, "Function_type_notation_must_be_parenthesized_when_used_in_a_union_type_1385", "Function type notation must be parenthesized when used in a union type."), Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type: a(1386, e.DiagnosticCategory.Error, "Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type_1386", "Constructor type notation must be parenthesized when used in a union type."), Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type: a(1387, e.DiagnosticCategory.Error, "Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type_1387", "Function type notation must be parenthesized when used in an intersection type."), Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type: a(1388, e.DiagnosticCategory.Error, "Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type_1388", "Constructor type notation must be parenthesized when used in an intersection type."), _0_is_not_allowed_as_a_variable_declaration_name: a(1389, e.DiagnosticCategory.Error, "_0_is_not_allowed_as_a_variable_declaration_name_1389", "'{0}' is not allowed as a variable declaration name."), _0_is_not_allowed_as_a_parameter_name: a(1390, e.DiagnosticCategory.Error, "_0_is_not_allowed_as_a_parameter_name_1390", "'{0}' is not allowed as a parameter name."), An_import_alias_cannot_use_import_type: a(1392, e.DiagnosticCategory.Error, "An_import_alias_cannot_use_import_type_1392", "An import alias cannot use 'import type'"), Imported_via_0_from_file_1: a(1393, e.DiagnosticCategory.Message, "Imported_via_0_from_file_1_1393", "Imported via {0} from file '{1}'"), Imported_via_0_from_file_1_with_packageId_2: a(1394, e.DiagnosticCategory.Message, "Imported_via_0_from_file_1_with_packageId_2_1394", "Imported via {0} from file '{1}' with packageId '{2}'"), Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions: a(1395, e.DiagnosticCategory.Message, "Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions_1395", "Imported via {0} from file '{1}' to import 'importHelpers' as specified in compilerOptions"), Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions: a(1396, e.DiagnosticCategory.Message, "Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions_1396", "Imported via {0} from file '{1}' with packageId '{2}' to import 'importHelpers' as specified in compilerOptions"), Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions: a(1397, e.DiagnosticCategory.Message, "Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions_1397", "Imported via {0} from file '{1}' to import 'jsx' and 'jsxs' factory functions"), Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions: a(1398, e.DiagnosticCategory.Message, "Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions_1398", "Imported via {0} from file '{1}' with packageId '{2}' to import 'jsx' and 'jsxs' factory functions"), File_is_included_via_import_here: a(1399, e.DiagnosticCategory.Message, "File_is_included_via_import_here_1399", "File is included via import here."), Referenced_via_0_from_file_1: a(1400, e.DiagnosticCategory.Message, "Referenced_via_0_from_file_1_1400", "Referenced via '{0}' from file '{1}'"), File_is_included_via_reference_here: a(1401, e.DiagnosticCategory.Message, "File_is_included_via_reference_here_1401", "File is included via reference here."), Type_library_referenced_via_0_from_file_1: a(1402, e.DiagnosticCategory.Message, "Type_library_referenced_via_0_from_file_1_1402", "Type library referenced via '{0}' from file '{1}'"), Type_library_referenced_via_0_from_file_1_with_packageId_2: a(1403, e.DiagnosticCategory.Message, "Type_library_referenced_via_0_from_file_1_with_packageId_2_1403", "Type library referenced via '{0}' from file '{1}' with packageId '{2}'"), File_is_included_via_type_library_reference_here: a(1404, e.DiagnosticCategory.Message, "File_is_included_via_type_library_reference_here_1404", "File is included via type library reference here."), Library_referenced_via_0_from_file_1: a(1405, e.DiagnosticCategory.Message, "Library_referenced_via_0_from_file_1_1405", "Library referenced via '{0}' from file '{1}'"), File_is_included_via_library_reference_here: a(1406, e.DiagnosticCategory.Message, "File_is_included_via_library_reference_here_1406", "File is included via library reference here."), Matched_by_include_pattern_0_in_1: a(1407, e.DiagnosticCategory.Message, "Matched_by_include_pattern_0_in_1_1407", "Matched by include pattern '{0}' in '{1}'"), File_is_matched_by_include_pattern_specified_here: a(1408, e.DiagnosticCategory.Message, "File_is_matched_by_include_pattern_specified_here_1408", "File is matched by include pattern specified here."), Part_of_files_list_in_tsconfig_json: a(1409, e.DiagnosticCategory.Message, "Part_of_files_list_in_tsconfig_json_1409", "Part of 'files' list in tsconfig.json"), File_is_matched_by_files_list_specified_here: a(1410, e.DiagnosticCategory.Message, "File_is_matched_by_files_list_specified_here_1410", "File is matched by 'files' list specified here."), Output_from_referenced_project_0_included_because_1_specified: a(1411, e.DiagnosticCategory.Message, "Output_from_referenced_project_0_included_because_1_specified_1411", "Output from referenced project '{0}' included because '{1}' specified"), Output_from_referenced_project_0_included_because_module_is_specified_as_none: a(1412, e.DiagnosticCategory.Message, "Output_from_referenced_project_0_included_because_module_is_specified_as_none_1412", "Output from referenced project '{0}' included because '--module' is specified as 'none'"), File_is_output_from_referenced_project_specified_here: a(1413, e.DiagnosticCategory.Message, "File_is_output_from_referenced_project_specified_here_1413", "File is output from referenced project specified here."), Source_from_referenced_project_0_included_because_1_specified: a(1414, e.DiagnosticCategory.Message, "Source_from_referenced_project_0_included_because_1_specified_1414", "Source from referenced project '{0}' included because '{1}' specified"), Source_from_referenced_project_0_included_because_module_is_specified_as_none: a(1415, e.DiagnosticCategory.Message, "Source_from_referenced_project_0_included_because_module_is_specified_as_none_1415", "Source from referenced project '{0}' included because '--module' is specified as 'none'"), File_is_source_from_referenced_project_specified_here: a(1416, e.DiagnosticCategory.Message, "File_is_source_from_referenced_project_specified_here_1416", "File is source from referenced project specified here."), Entry_point_of_type_library_0_specified_in_compilerOptions: a(1417, e.DiagnosticCategory.Message, "Entry_point_of_type_library_0_specified_in_compilerOptions_1417", "Entry point of type library '{0}' specified in compilerOptions"), Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1: a(1418, e.DiagnosticCategory.Message, "Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1_1418", "Entry point of type library '{0}' specified in compilerOptions with packageId '{1}'"), File_is_entry_point_of_type_library_specified_here: a(1419, e.DiagnosticCategory.Message, "File_is_entry_point_of_type_library_specified_here_1419", "File is entry point of type library specified here."), Entry_point_for_implicit_type_library_0: a(1420, e.DiagnosticCategory.Message, "Entry_point_for_implicit_type_library_0_1420", "Entry point for implicit type library '{0}'"), Entry_point_for_implicit_type_library_0_with_packageId_1: a(1421, e.DiagnosticCategory.Message, "Entry_point_for_implicit_type_library_0_with_packageId_1_1421", "Entry point for implicit type library '{0}' with packageId '{1}'"), Library_0_specified_in_compilerOptions: a(1422, e.DiagnosticCategory.Message, "Library_0_specified_in_compilerOptions_1422", "Library '{0}' specified in compilerOptions"), File_is_library_specified_here: a(1423, e.DiagnosticCategory.Message, "File_is_library_specified_here_1423", "File is library specified here."), Default_library: a(1424, e.DiagnosticCategory.Message, "Default_library_1424", "Default library"), Default_library_for_target_0: a(1425, e.DiagnosticCategory.Message, "Default_library_for_target_0_1425", "Default library for target '{0}'"), File_is_default_library_for_target_specified_here: a(1426, e.DiagnosticCategory.Message, "File_is_default_library_for_target_specified_here_1426", "File is default library for target specified here."), Root_file_specified_for_compilation: a(1427, e.DiagnosticCategory.Message, "Root_file_specified_for_compilation_1427", "Root file specified for compilation"), File_is_output_of_project_reference_source_0: a(1428, e.DiagnosticCategory.Message, "File_is_output_of_project_reference_source_0_1428", "File is output of project reference source '{0}'"), File_redirects_to_file_0: a(1429, e.DiagnosticCategory.Message, "File_redirects_to_file_0_1429", "File redirects to file '{0}'"), The_file_is_in_the_program_because_Colon: a(1430, e.DiagnosticCategory.Message, "The_file_is_in_the_program_because_Colon_1430", "The file is in the program because:"), for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module: a(1431, e.DiagnosticCategory.Error, "for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_1431", "'for await' loops are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."), Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher: a(1432, e.DiagnosticCategory.Error, "Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_nod_1432", "Top-level 'for await' loops are only allowed when the 'module' option is set to 'es2022', 'esnext', 'system', 'node16', or 'nodenext', and the 'target' option is set to 'es2017' or higher."), Decorators_may_not_be_applied_to_this_parameters: a(1433, e.DiagnosticCategory.Error, "Decorators_may_not_be_applied_to_this_parameters_1433", "Decorators may not be applied to 'this' parameters."), Unexpected_keyword_or_identifier: a(1434, e.DiagnosticCategory.Error, "Unexpected_keyword_or_identifier_1434", "Unexpected keyword or identifier."), Unknown_keyword_or_identifier_Did_you_mean_0: a(1435, e.DiagnosticCategory.Error, "Unknown_keyword_or_identifier_Did_you_mean_0_1435", "Unknown keyword or identifier. Did you mean '{0}'?"), Decorators_must_precede_the_name_and_all_keywords_of_property_declarations: a(1436, e.DiagnosticCategory.Error, "Decorators_must_precede_the_name_and_all_keywords_of_property_declarations_1436", "Decorators must precede the name and all keywords of property declarations."), Namespace_must_be_given_a_name: a(1437, e.DiagnosticCategory.Error, "Namespace_must_be_given_a_name_1437", "Namespace must be given a name."), Interface_must_be_given_a_name: a(1438, e.DiagnosticCategory.Error, "Interface_must_be_given_a_name_1438", "Interface must be given a name."), Type_alias_must_be_given_a_name: a(1439, e.DiagnosticCategory.Error, "Type_alias_must_be_given_a_name_1439", "Type alias must be given a name."), Variable_declaration_not_allowed_at_this_location: a(1440, e.DiagnosticCategory.Error, "Variable_declaration_not_allowed_at_this_location_1440", "Variable declaration not allowed at this location."), Cannot_start_a_function_call_in_a_type_annotation: a(1441, e.DiagnosticCategory.Error, "Cannot_start_a_function_call_in_a_type_annotation_1441", "Cannot start a function call in a type annotation."), Expected_for_property_initializer: a(1442, e.DiagnosticCategory.Error, "Expected_for_property_initializer_1442", "Expected '=' for property initializer."), Module_declaration_names_may_only_use_or_quoted_strings: a(1443, e.DiagnosticCategory.Error, "Module_declaration_names_may_only_use_or_quoted_strings_1443", `Module declaration names may only use ' or " quoted strings.`), _0_is_a_type_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled: a(1444, e.DiagnosticCategory.Error, "_0_is_a_type_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedMod_1444", "'{0}' is a type and must be imported using a type-only import when 'preserveValueImports' and 'isolatedModules' are both enabled."), _0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled: a(1446, e.DiagnosticCategory.Error, "_0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_preserveVa_1446", "'{0}' resolves to a type-only declaration and must be imported using a type-only import when 'preserveValueImports' and 'isolatedModules' are both enabled."), _0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_isolatedModules_is_enabled: a(1448, e.DiagnosticCategory.Error, "_0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_isol_1448", "'{0}' resolves to a type-only declaration and must be re-exported using a type-only re-export when 'isolatedModules' is enabled."), Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed: a(1449, e.DiagnosticCategory.Message, "Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed_1449", "Preserve unused imported values in the JavaScript output that would otherwise be removed."), Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_assertion_as_arguments: a(1450, e.DiagnosticCategory.Message, "Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_assertion_as_arguments_1450", "Dynamic imports can only accept a module specifier and an optional assertion as arguments"), Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression: a(1451, e.DiagnosticCategory.Error, "Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member__1451", "Private identifiers are only allowed in class bodies and may only be used as part of a class member declaration, property access, or on the left-hand-side of an 'in' expression"), Resolution_modes_are_only_supported_when_moduleResolution_is_node16_or_nodenext: a(1452, e.DiagnosticCategory.Error, "Resolution_modes_are_only_supported_when_moduleResolution_is_node16_or_nodenext_1452", "Resolution modes are only supported when `moduleResolution` is `node16` or `nodenext`."), resolution_mode_should_be_either_require_or_import: a(1453, e.DiagnosticCategory.Error, "resolution_mode_should_be_either_require_or_import_1453", "`resolution-mode` should be either `require` or `import`."), resolution_mode_can_only_be_set_for_type_only_imports: a(1454, e.DiagnosticCategory.Error, "resolution_mode_can_only_be_set_for_type_only_imports_1454", "`resolution-mode` can only be set for type-only imports."), resolution_mode_is_the_only_valid_key_for_type_import_assertions: a(1455, e.DiagnosticCategory.Error, "resolution_mode_is_the_only_valid_key_for_type_import_assertions_1455", "`resolution-mode` is the only valid key for type import assertions."), Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require: a(1456, e.DiagnosticCategory.Error, "Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require_1456", "Type import assertions should have exactly one key - `resolution-mode` - with value `import` or `require`."), The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output: a(1470, e.DiagnosticCategory.Error, "The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output_1470", "The 'import.meta' meta-property is not allowed in files which will build into CommonJS output."), Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_cannot_be_imported_synchronously_Use_dynamic_import_instead: a(1471, e.DiagnosticCategory.Error, "Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_c_1471", "Module '{0}' cannot be imported using this construct. The specifier only resolves to an ES module, which cannot be imported synchronously. Use dynamic import instead."), catch_or_finally_expected: a(1472, e.DiagnosticCategory.Error, "catch_or_finally_expected_1472", "'catch' or 'finally' expected."), An_import_declaration_can_only_be_used_at_the_top_level_of_a_module: a(1473, e.DiagnosticCategory.Error, "An_import_declaration_can_only_be_used_at_the_top_level_of_a_module_1473", "An import declaration can only be used at the top level of a module."), An_export_declaration_can_only_be_used_at_the_top_level_of_a_module: a(1474, e.DiagnosticCategory.Error, "An_export_declaration_can_only_be_used_at_the_top_level_of_a_module_1474", "An export declaration can only be used at the top level of a module."), Control_what_method_is_used_to_detect_module_format_JS_files: a(1475, e.DiagnosticCategory.Message, "Control_what_method_is_used_to_detect_module_format_JS_files_1475", "Control what method is used to detect module-format JS files."), auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_with_module_Colon_node16_as_modules: a(1476, e.DiagnosticCategory.Message, "auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_w_1476", '"auto": Treat files with imports, exports, import.meta, jsx (with jsx: react-jsx), or esm format (with module: node16+) as modules.'), The_types_of_0_are_incompatible_between_these_types: a(2200, e.DiagnosticCategory.Error, "The_types_of_0_are_incompatible_between_these_types_2200", "The types of '{0}' are incompatible between these types."), The_types_returned_by_0_are_incompatible_between_these_types: a(2201, e.DiagnosticCategory.Error, "The_types_returned_by_0_are_incompatible_between_these_types_2201", "The types returned by '{0}' are incompatible between these types."), Call_signature_return_types_0_and_1_are_incompatible: a(2202, e.DiagnosticCategory.Error, "Call_signature_return_types_0_and_1_are_incompatible_2202", "Call signature return types '{0}' and '{1}' are incompatible.", void 0, true), Construct_signature_return_types_0_and_1_are_incompatible: a(2203, e.DiagnosticCategory.Error, "Construct_signature_return_types_0_and_1_are_incompatible_2203", "Construct signature return types '{0}' and '{1}' are incompatible.", void 0, true), Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1: a(2204, e.DiagnosticCategory.Error, "Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1_2204", "Call signatures with no arguments have incompatible return types '{0}' and '{1}'.", void 0, true), Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1: a(2205, e.DiagnosticCategory.Error, "Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1_2205", "Construct signatures with no arguments have incompatible return types '{0}' and '{1}'.", void 0, true), The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement: a(2206, e.DiagnosticCategory.Error, "The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement_2206", "The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement."), The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement: a(2207, e.DiagnosticCategory.Error, "The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement_2207", "The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement."), The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate: a(2209, e.DiagnosticCategory.Error, "The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_roo_2209", "The project root is ambiguous, but is required to resolve export map entry '{0}' in file '{1}'. Supply the `rootDir` compiler option to disambiguate."), The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate: a(2210, e.DiagnosticCategory.Error, "The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_roo_2210", "The project root is ambiguous, but is required to resolve import map entry '{0}' in file '{1}'. Supply the `rootDir` compiler option to disambiguate."), Duplicate_identifier_0: a(2300, e.DiagnosticCategory.Error, "Duplicate_identifier_0_2300", "Duplicate identifier '{0}'."), Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor: a(2301, e.DiagnosticCategory.Error, "Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor_2301", "Initializer of instance member variable '{0}' cannot reference identifier '{1}' declared in the constructor."), Static_members_cannot_reference_class_type_parameters: a(2302, e.DiagnosticCategory.Error, "Static_members_cannot_reference_class_type_parameters_2302", "Static members cannot reference class type parameters."), Circular_definition_of_import_alias_0: a(2303, e.DiagnosticCategory.Error, "Circular_definition_of_import_alias_0_2303", "Circular definition of import alias '{0}'."), Cannot_find_name_0: a(2304, e.DiagnosticCategory.Error, "Cannot_find_name_0_2304", "Cannot find name '{0}'."), Module_0_has_no_exported_member_1: a(2305, e.DiagnosticCategory.Error, "Module_0_has_no_exported_member_1_2305", "Module '{0}' has no exported member '{1}'."), File_0_is_not_a_module: a(2306, e.DiagnosticCategory.Error, "File_0_is_not_a_module_2306", "File '{0}' is not a module."), Cannot_find_module_0_or_its_corresponding_type_declarations: a(2307, e.DiagnosticCategory.Error, "Cannot_find_module_0_or_its_corresponding_type_declarations_2307", "Cannot find module '{0}' or its corresponding type declarations."), Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity: a(2308, e.DiagnosticCategory.Error, "Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambig_2308", "Module {0} has already exported a member named '{1}'. Consider explicitly re-exporting to resolve the ambiguity."), An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements: a(2309, e.DiagnosticCategory.Error, "An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements_2309", "An export assignment cannot be used in a module with other exported elements."), Type_0_recursively_references_itself_as_a_base_type: a(2310, e.DiagnosticCategory.Error, "Type_0_recursively_references_itself_as_a_base_type_2310", "Type '{0}' recursively references itself as a base type."), Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function: a(2311, e.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function_2311", "Cannot find name '{0}'. Did you mean to write this in an async function?"), An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members: a(2312, e.DiagnosticCategory.Error, "An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_me_2312", "An interface can only extend an object type or intersection of object types with statically known members."), Type_parameter_0_has_a_circular_constraint: a(2313, e.DiagnosticCategory.Error, "Type_parameter_0_has_a_circular_constraint_2313", "Type parameter '{0}' has a circular constraint."), Generic_type_0_requires_1_type_argument_s: a(2314, e.DiagnosticCategory.Error, "Generic_type_0_requires_1_type_argument_s_2314", "Generic type '{0}' requires {1} type argument(s)."), Type_0_is_not_generic: a(2315, e.DiagnosticCategory.Error, "Type_0_is_not_generic_2315", "Type '{0}' is not generic."), Global_type_0_must_be_a_class_or_interface_type: a(2316, e.DiagnosticCategory.Error, "Global_type_0_must_be_a_class_or_interface_type_2316", "Global type '{0}' must be a class or interface type."), Global_type_0_must_have_1_type_parameter_s: a(2317, e.DiagnosticCategory.Error, "Global_type_0_must_have_1_type_parameter_s_2317", "Global type '{0}' must have {1} type parameter(s)."), Cannot_find_global_type_0: a(2318, e.DiagnosticCategory.Error, "Cannot_find_global_type_0_2318", "Cannot find global type '{0}'."), Named_property_0_of_types_1_and_2_are_not_identical: a(2319, e.DiagnosticCategory.Error, "Named_property_0_of_types_1_and_2_are_not_identical_2319", "Named property '{0}' of types '{1}' and '{2}' are not identical."), Interface_0_cannot_simultaneously_extend_types_1_and_2: a(2320, e.DiagnosticCategory.Error, "Interface_0_cannot_simultaneously_extend_types_1_and_2_2320", "Interface '{0}' cannot simultaneously extend types '{1}' and '{2}'."), Excessive_stack_depth_comparing_types_0_and_1: a(2321, e.DiagnosticCategory.Error, "Excessive_stack_depth_comparing_types_0_and_1_2321", "Excessive stack depth comparing types '{0}' and '{1}'."), Type_0_is_not_assignable_to_type_1: a(2322, e.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_2322", "Type '{0}' is not assignable to type '{1}'."), Cannot_redeclare_exported_variable_0: a(2323, e.DiagnosticCategory.Error, "Cannot_redeclare_exported_variable_0_2323", "Cannot redeclare exported variable '{0}'."), Property_0_is_missing_in_type_1: a(2324, e.DiagnosticCategory.Error, "Property_0_is_missing_in_type_1_2324", "Property '{0}' is missing in type '{1}'."), Property_0_is_private_in_type_1_but_not_in_type_2: a(2325, e.DiagnosticCategory.Error, "Property_0_is_private_in_type_1_but_not_in_type_2_2325", "Property '{0}' is private in type '{1}' but not in type '{2}'."), Types_of_property_0_are_incompatible: a(2326, e.DiagnosticCategory.Error, "Types_of_property_0_are_incompatible_2326", "Types of property '{0}' are incompatible."), Property_0_is_optional_in_type_1_but_required_in_type_2: a(2327, e.DiagnosticCategory.Error, "Property_0_is_optional_in_type_1_but_required_in_type_2_2327", "Property '{0}' is optional in type '{1}' but required in type '{2}'."), Types_of_parameters_0_and_1_are_incompatible: a(2328, e.DiagnosticCategory.Error, "Types_of_parameters_0_and_1_are_incompatible_2328", "Types of parameters '{0}' and '{1}' are incompatible."), Index_signature_for_type_0_is_missing_in_type_1: a(2329, e.DiagnosticCategory.Error, "Index_signature_for_type_0_is_missing_in_type_1_2329", "Index signature for type '{0}' is missing in type '{1}'."), _0_and_1_index_signatures_are_incompatible: a(2330, e.DiagnosticCategory.Error, "_0_and_1_index_signatures_are_incompatible_2330", "'{0}' and '{1}' index signatures are incompatible."), this_cannot_be_referenced_in_a_module_or_namespace_body: a(2331, e.DiagnosticCategory.Error, "this_cannot_be_referenced_in_a_module_or_namespace_body_2331", "'this' cannot be referenced in a module or namespace body."), this_cannot_be_referenced_in_current_location: a(2332, e.DiagnosticCategory.Error, "this_cannot_be_referenced_in_current_location_2332", "'this' cannot be referenced in current location."), this_cannot_be_referenced_in_constructor_arguments: a(2333, e.DiagnosticCategory.Error, "this_cannot_be_referenced_in_constructor_arguments_2333", "'this' cannot be referenced in constructor arguments."), this_cannot_be_referenced_in_a_static_property_initializer: a(2334, e.DiagnosticCategory.Error, "this_cannot_be_referenced_in_a_static_property_initializer_2334", "'this' cannot be referenced in a static property initializer."), super_can_only_be_referenced_in_a_derived_class: a(2335, e.DiagnosticCategory.Error, "super_can_only_be_referenced_in_a_derived_class_2335", "'super' can only be referenced in a derived class."), super_cannot_be_referenced_in_constructor_arguments: a(2336, e.DiagnosticCategory.Error, "super_cannot_be_referenced_in_constructor_arguments_2336", "'super' cannot be referenced in constructor arguments."), Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors: a(2337, e.DiagnosticCategory.Error, "Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors_2337", "Super calls are not permitted outside constructors or in nested functions inside constructors."), super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class: a(2338, e.DiagnosticCategory.Error, "super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_der_2338", "'super' property access is permitted only in a constructor, member function, or member accessor of a derived class."), Property_0_does_not_exist_on_type_1: a(2339, e.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_2339", "Property '{0}' does not exist on type '{1}'."), Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword: a(2340, e.DiagnosticCategory.Error, "Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword_2340", "Only public and protected methods of the base class are accessible via the 'super' keyword."), Property_0_is_private_and_only_accessible_within_class_1: a(2341, e.DiagnosticCategory.Error, "Property_0_is_private_and_only_accessible_within_class_1_2341", "Property '{0}' is private and only accessible within class '{1}'."), This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_version_of_0: a(2343, e.DiagnosticCategory.Error, "This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_ve_2343", "This syntax requires an imported helper named '{1}' which does not exist in '{0}'. Consider upgrading your version of '{0}'."), Type_0_does_not_satisfy_the_constraint_1: a(2344, e.DiagnosticCategory.Error, "Type_0_does_not_satisfy_the_constraint_1_2344", "Type '{0}' does not satisfy the constraint '{1}'."), Argument_of_type_0_is_not_assignable_to_parameter_of_type_1: a(2345, e.DiagnosticCategory.Error, "Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_2345", "Argument of type '{0}' is not assignable to parameter of type '{1}'."), Call_target_does_not_contain_any_signatures: a(2346, e.DiagnosticCategory.Error, "Call_target_does_not_contain_any_signatures_2346", "Call target does not contain any signatures."), Untyped_function_calls_may_not_accept_type_arguments: a(2347, e.DiagnosticCategory.Error, "Untyped_function_calls_may_not_accept_type_arguments_2347", "Untyped function calls may not accept type arguments."), Value_of_type_0_is_not_callable_Did_you_mean_to_include_new: a(2348, e.DiagnosticCategory.Error, "Value_of_type_0_is_not_callable_Did_you_mean_to_include_new_2348", "Value of type '{0}' is not callable. Did you mean to include 'new'?"), This_expression_is_not_callable: a(2349, e.DiagnosticCategory.Error, "This_expression_is_not_callable_2349", "This expression is not callable."), Only_a_void_function_can_be_called_with_the_new_keyword: a(2350, e.DiagnosticCategory.Error, "Only_a_void_function_can_be_called_with_the_new_keyword_2350", "Only a void function can be called with the 'new' keyword."), This_expression_is_not_constructable: a(2351, e.DiagnosticCategory.Error, "This_expression_is_not_constructable_2351", "This expression is not constructable."), Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first: a(2352, e.DiagnosticCategory.Error, "Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the__2352", "Conversion of type '{0}' to type '{1}' may be a mistake because neither type sufficiently overlaps with the other. If this was intentional, convert the expression to 'unknown' first."), Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1: a(2353, e.DiagnosticCategory.Error, "Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1_2353", "Object literal may only specify known properties, and '{0}' does not exist in type '{1}'."), This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found: a(2354, e.DiagnosticCategory.Error, "This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found_2354", "This syntax requires an imported helper but module '{0}' cannot be found."), A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value: a(2355, e.DiagnosticCategory.Error, "A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value_2355", "A function whose declared type is neither 'void' nor 'any' must return a value."), An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type: a(2356, e.DiagnosticCategory.Error, "An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type_2356", "An arithmetic operand must be of type 'any', 'number', 'bigint' or an enum type."), The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access: a(2357, e.DiagnosticCategory.Error, "The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access_2357", "The operand of an increment or decrement operator must be a variable or a property access."), The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter: a(2358, e.DiagnosticCategory.Error, "The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_paramete_2358", "The left-hand side of an 'instanceof' expression must be of type 'any', an object type or a type parameter."), The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_Function_interface_type: a(2359, e.DiagnosticCategory.Error, "The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_F_2359", "The right-hand side of an 'instanceof' expression must be of type 'any' or of a type assignable to the 'Function' interface type."), The_left_hand_side_of_an_in_expression_must_be_a_private_identifier_or_of_type_any_string_number_or_symbol: a(2360, e.DiagnosticCategory.Error, "The_left_hand_side_of_an_in_expression_must_be_a_private_identifier_or_of_type_any_string_number_or__2360", "The left-hand side of an 'in' expression must be a private identifier or of type 'any', 'string', 'number', or 'symbol'."), The_right_hand_side_of_an_in_expression_must_not_be_a_primitive: a(2361, e.DiagnosticCategory.Error, "The_right_hand_side_of_an_in_expression_must_not_be_a_primitive_2361", "The right-hand side of an 'in' expression must not be a primitive."), The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type: a(2362, e.DiagnosticCategory.Error, "The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2362", "The left-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."), The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type: a(2363, e.DiagnosticCategory.Error, "The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2363", "The right-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."), The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access: a(2364, e.DiagnosticCategory.Error, "The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access_2364", "The left-hand side of an assignment expression must be a variable or a property access."), Operator_0_cannot_be_applied_to_types_1_and_2: a(2365, e.DiagnosticCategory.Error, "Operator_0_cannot_be_applied_to_types_1_and_2_2365", "Operator '{0}' cannot be applied to types '{1}' and '{2}'."), Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined: a(2366, e.DiagnosticCategory.Error, "Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined_2366", "Function lacks ending return statement and return type does not include 'undefined'."), This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap: a(2367, e.DiagnosticCategory.Error, "This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap_2367", "This condition will always return '{0}' since the types '{1}' and '{2}' have no overlap."), Type_parameter_name_cannot_be_0: a(2368, e.DiagnosticCategory.Error, "Type_parameter_name_cannot_be_0_2368", "Type parameter name cannot be '{0}'."), A_parameter_property_is_only_allowed_in_a_constructor_implementation: a(2369, e.DiagnosticCategory.Error, "A_parameter_property_is_only_allowed_in_a_constructor_implementation_2369", "A parameter property is only allowed in a constructor implementation."), A_rest_parameter_must_be_of_an_array_type: a(2370, e.DiagnosticCategory.Error, "A_rest_parameter_must_be_of_an_array_type_2370", "A rest parameter must be of an array type."), A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation: a(2371, e.DiagnosticCategory.Error, "A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation_2371", "A parameter initializer is only allowed in a function or constructor implementation."), Parameter_0_cannot_reference_itself: a(2372, e.DiagnosticCategory.Error, "Parameter_0_cannot_reference_itself_2372", "Parameter '{0}' cannot reference itself."), Parameter_0_cannot_reference_identifier_1_declared_after_it: a(2373, e.DiagnosticCategory.Error, "Parameter_0_cannot_reference_identifier_1_declared_after_it_2373", "Parameter '{0}' cannot reference identifier '{1}' declared after it."), Duplicate_index_signature_for_type_0: a(2374, e.DiagnosticCategory.Error, "Duplicate_index_signature_for_type_0_2374", "Duplicate index signature for type '{0}'."), Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties: a(2375, e.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefi_2375", "Type '{0}' is not assignable to type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the types of the target's properties."), A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_class_contains_initialized_properties_parameter_properties_or_private_identifiers: a(2376, e.DiagnosticCategory.Error, "A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_2376", "A 'super' call must be the first statement in the constructor to refer to 'super' or 'this' when a derived class contains initialized properties, parameter properties, or private identifiers."), Constructors_for_derived_classes_must_contain_a_super_call: a(2377, e.DiagnosticCategory.Error, "Constructors_for_derived_classes_must_contain_a_super_call_2377", "Constructors for derived classes must contain a 'super' call."), A_get_accessor_must_return_a_value: a(2378, e.DiagnosticCategory.Error, "A_get_accessor_must_return_a_value_2378", "A 'get' accessor must return a value."), Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties: a(2379, e.DiagnosticCategory.Error, "Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_tr_2379", "Argument of type '{0}' is not assignable to parameter of type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the types of the target's properties."), The_return_type_of_a_get_accessor_must_be_assignable_to_its_set_accessor_type: a(2380, e.DiagnosticCategory.Error, "The_return_type_of_a_get_accessor_must_be_assignable_to_its_set_accessor_type_2380", "The return type of a 'get' accessor must be assignable to its 'set' accessor type"), Overload_signatures_must_all_be_exported_or_non_exported: a(2383, e.DiagnosticCategory.Error, "Overload_signatures_must_all_be_exported_or_non_exported_2383", "Overload signatures must all be exported or non-exported."), Overload_signatures_must_all_be_ambient_or_non_ambient: a(2384, e.DiagnosticCategory.Error, "Overload_signatures_must_all_be_ambient_or_non_ambient_2384", "Overload signatures must all be ambient or non-ambient."), Overload_signatures_must_all_be_public_private_or_protected: a(2385, e.DiagnosticCategory.Error, "Overload_signatures_must_all_be_public_private_or_protected_2385", "Overload signatures must all be public, private or protected."), Overload_signatures_must_all_be_optional_or_required: a(2386, e.DiagnosticCategory.Error, "Overload_signatures_must_all_be_optional_or_required_2386", "Overload signatures must all be optional or required."), Function_overload_must_be_static: a(2387, e.DiagnosticCategory.Error, "Function_overload_must_be_static_2387", "Function overload must be static."), Function_overload_must_not_be_static: a(2388, e.DiagnosticCategory.Error, "Function_overload_must_not_be_static_2388", "Function overload must not be static."), Function_implementation_name_must_be_0: a(2389, e.DiagnosticCategory.Error, "Function_implementation_name_must_be_0_2389", "Function implementation name must be '{0}'."), Constructor_implementation_is_missing: a(2390, e.DiagnosticCategory.Error, "Constructor_implementation_is_missing_2390", "Constructor implementation is missing."), Function_implementation_is_missing_or_not_immediately_following_the_declaration: a(2391, e.DiagnosticCategory.Error, "Function_implementation_is_missing_or_not_immediately_following_the_declaration_2391", "Function implementation is missing or not immediately following the declaration."), Multiple_constructor_implementations_are_not_allowed: a(2392, e.DiagnosticCategory.Error, "Multiple_constructor_implementations_are_not_allowed_2392", "Multiple constructor implementations are not allowed."), Duplicate_function_implementation: a(2393, e.DiagnosticCategory.Error, "Duplicate_function_implementation_2393", "Duplicate function implementation."), This_overload_signature_is_not_compatible_with_its_implementation_signature: a(2394, e.DiagnosticCategory.Error, "This_overload_signature_is_not_compatible_with_its_implementation_signature_2394", "This overload signature is not compatible with its implementation signature."), Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local: a(2395, e.DiagnosticCategory.Error, "Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local_2395", "Individual declarations in merged declaration '{0}' must be all exported or all local."), Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters: a(2396, e.DiagnosticCategory.Error, "Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters_2396", "Duplicate identifier 'arguments'. Compiler uses 'arguments' to initialize rest parameters."), Declaration_name_conflicts_with_built_in_global_identifier_0: a(2397, e.DiagnosticCategory.Error, "Declaration_name_conflicts_with_built_in_global_identifier_0_2397", "Declaration name conflicts with built-in global identifier '{0}'."), constructor_cannot_be_used_as_a_parameter_property_name: a(2398, e.DiagnosticCategory.Error, "constructor_cannot_be_used_as_a_parameter_property_name_2398", "'constructor' cannot be used as a parameter property name."), Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference: a(2399, e.DiagnosticCategory.Error, "Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference_2399", "Duplicate identifier '_this'. Compiler uses variable declaration '_this' to capture 'this' reference."), Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference: a(2400, e.DiagnosticCategory.Error, "Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference_2400", "Expression resolves to variable declaration '_this' that compiler uses to capture 'this' reference."), A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_initialized_properties_parameter_properties_or_private_identifiers: a(2401, e.DiagnosticCategory.Error, "A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_in_2401", "A 'super' call must be a root-level statement within a constructor of a derived class that contains initialized properties, parameter properties, or private identifiers."), Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference: a(2402, e.DiagnosticCategory.Error, "Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference_2402", "Expression resolves to '_super' that compiler uses to capture base class reference."), Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2: a(2403, e.DiagnosticCategory.Error, "Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_t_2403", "Subsequent variable declarations must have the same type.  Variable '{0}' must be of type '{1}', but here has type '{2}'."), The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation: a(2404, e.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation_2404", "The left-hand side of a 'for...in' statement cannot use a type annotation."), The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any: a(2405, e.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any_2405", "The left-hand side of a 'for...in' statement must be of type 'string' or 'any'."), The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access: a(2406, e.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access_2406", "The left-hand side of a 'for...in' statement must be a variable or a property access."), The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0: a(2407, e.DiagnosticCategory.Error, "The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_2407", "The right-hand side of a 'for...in' statement must be of type 'any', an object type or a type parameter, but here has type '{0}'."), Setters_cannot_return_a_value: a(2408, e.DiagnosticCategory.Error, "Setters_cannot_return_a_value_2408", "Setters cannot return a value."), Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class: a(2409, e.DiagnosticCategory.Error, "Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class_2409", "Return type of constructor signature must be assignable to the instance type of the class."), The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any: a(2410, e.DiagnosticCategory.Error, "The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any_2410", "The 'with' statement is not supported. All symbols in a 'with' block will have type 'any'."), Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target: a(2412, e.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefi_2412", "Type '{0}' is not assignable to type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the type of the target."), Property_0_of_type_1_is_not_assignable_to_2_index_type_3: a(2411, e.DiagnosticCategory.Error, "Property_0_of_type_1_is_not_assignable_to_2_index_type_3_2411", "Property '{0}' of type '{1}' is not assignable to '{2}' index type '{3}'."), _0_index_type_1_is_not_assignable_to_2_index_type_3: a(2413, e.DiagnosticCategory.Error, "_0_index_type_1_is_not_assignable_to_2_index_type_3_2413", "'{0}' index type '{1}' is not assignable to '{2}' index type '{3}'."), Class_name_cannot_be_0: a(2414, e.DiagnosticCategory.Error, "Class_name_cannot_be_0_2414", "Class name cannot be '{0}'."), Class_0_incorrectly_extends_base_class_1: a(2415, e.DiagnosticCategory.Error, "Class_0_incorrectly_extends_base_class_1_2415", "Class '{0}' incorrectly extends base class '{1}'."), Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2: a(2416, e.DiagnosticCategory.Error, "Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2_2416", "Property '{0}' in type '{1}' is not assignable to the same property in base type '{2}'."), Class_static_side_0_incorrectly_extends_base_class_static_side_1: a(2417, e.DiagnosticCategory.Error, "Class_static_side_0_incorrectly_extends_base_class_static_side_1_2417", "Class static side '{0}' incorrectly extends base class static side '{1}'."), Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1: a(2418, e.DiagnosticCategory.Error, "Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1_2418", "Type of computed property's value is '{0}', which is not assignable to type '{1}'."), Types_of_construct_signatures_are_incompatible: a(2419, e.DiagnosticCategory.Error, "Types_of_construct_signatures_are_incompatible_2419", "Types of construct signatures are incompatible."), Class_0_incorrectly_implements_interface_1: a(2420, e.DiagnosticCategory.Error, "Class_0_incorrectly_implements_interface_1_2420", "Class '{0}' incorrectly implements interface '{1}'."), A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members: a(2422, e.DiagnosticCategory.Error, "A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_memb_2422", "A class can only implement an object type or intersection of object types with statically known members."), Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor: a(2423, e.DiagnosticCategory.Error, "Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_access_2423", "Class '{0}' defines instance member function '{1}', but extended class '{2}' defines it as instance member accessor."), Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function: a(2425, e.DiagnosticCategory.Error, "Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_functi_2425", "Class '{0}' defines instance member property '{1}', but extended class '{2}' defines it as instance member function."), Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function: a(2426, e.DiagnosticCategory.Error, "Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_functi_2426", "Class '{0}' defines instance member accessor '{1}', but extended class '{2}' defines it as instance member function."), Interface_name_cannot_be_0: a(2427, e.DiagnosticCategory.Error, "Interface_name_cannot_be_0_2427", "Interface name cannot be '{0}'."), All_declarations_of_0_must_have_identical_type_parameters: a(2428, e.DiagnosticCategory.Error, "All_declarations_of_0_must_have_identical_type_parameters_2428", "All declarations of '{0}' must have identical type parameters."), Interface_0_incorrectly_extends_interface_1: a(2430, e.DiagnosticCategory.Error, "Interface_0_incorrectly_extends_interface_1_2430", "Interface '{0}' incorrectly extends interface '{1}'."), Enum_name_cannot_be_0: a(2431, e.DiagnosticCategory.Error, "Enum_name_cannot_be_0_2431", "Enum name cannot be '{0}'."), In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element: a(2432, e.DiagnosticCategory.Error, "In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enu_2432", "In an enum with multiple declarations, only one declaration can omit an initializer for its first enum element."), A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged: a(2433, e.DiagnosticCategory.Error, "A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merg_2433", "A namespace declaration cannot be in a different file from a class or function with which it is merged."), A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged: a(2434, e.DiagnosticCategory.Error, "A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged_2434", "A namespace declaration cannot be located prior to a class or function with which it is merged."), Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces: a(2435, e.DiagnosticCategory.Error, "Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces_2435", "Ambient modules cannot be nested in other modules or namespaces."), Ambient_module_declaration_cannot_specify_relative_module_name: a(2436, e.DiagnosticCategory.Error, "Ambient_module_declaration_cannot_specify_relative_module_name_2436", "Ambient module declaration cannot specify relative module name."), Module_0_is_hidden_by_a_local_declaration_with_the_same_name: a(2437, e.DiagnosticCategory.Error, "Module_0_is_hidden_by_a_local_declaration_with_the_same_name_2437", "Module '{0}' is hidden by a local declaration with the same name."), Import_name_cannot_be_0: a(2438, e.DiagnosticCategory.Error, "Import_name_cannot_be_0_2438", "Import name cannot be '{0}'."), Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name: a(2439, e.DiagnosticCategory.Error, "Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relati_2439", "Import or export declaration in an ambient module declaration cannot reference module through relative module name."), Import_declaration_conflicts_with_local_declaration_of_0: a(2440, e.DiagnosticCategory.Error, "Import_declaration_conflicts_with_local_declaration_of_0_2440", "Import declaration conflicts with local declaration of '{0}'."), Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module: a(2441, e.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_2441", "Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module."), Types_have_separate_declarations_of_a_private_property_0: a(2442, e.DiagnosticCategory.Error, "Types_have_separate_declarations_of_a_private_property_0_2442", "Types have separate declarations of a private property '{0}'."), Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2: a(2443, e.DiagnosticCategory.Error, "Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2_2443", "Property '{0}' is protected but type '{1}' is not a class derived from '{2}'."), Property_0_is_protected_in_type_1_but_public_in_type_2: a(2444, e.DiagnosticCategory.Error, "Property_0_is_protected_in_type_1_but_public_in_type_2_2444", "Property '{0}' is protected in type '{1}' but public in type '{2}'."), Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses: a(2445, e.DiagnosticCategory.Error, "Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses_2445", "Property '{0}' is protected and only accessible within class '{1}' and its subclasses."), Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_class_2: a(2446, e.DiagnosticCategory.Error, "Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_cl_2446", "Property '{0}' is protected and only accessible through an instance of class '{1}'. This is an instance of class '{2}'."), The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead: a(2447, e.DiagnosticCategory.Error, "The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead_2447", "The '{0}' operator is not allowed for boolean types. Consider using '{1}' instead."), Block_scoped_variable_0_used_before_its_declaration: a(2448, e.DiagnosticCategory.Error, "Block_scoped_variable_0_used_before_its_declaration_2448", "Block-scoped variable '{0}' used before its declaration."), Class_0_used_before_its_declaration: a(2449, e.DiagnosticCategory.Error, "Class_0_used_before_its_declaration_2449", "Class '{0}' used before its declaration."), Enum_0_used_before_its_declaration: a(2450, e.DiagnosticCategory.Error, "Enum_0_used_before_its_declaration_2450", "Enum '{0}' used before its declaration."), Cannot_redeclare_block_scoped_variable_0: a(2451, e.DiagnosticCategory.Error, "Cannot_redeclare_block_scoped_variable_0_2451", "Cannot redeclare block-scoped variable '{0}'."), An_enum_member_cannot_have_a_numeric_name: a(2452, e.DiagnosticCategory.Error, "An_enum_member_cannot_have_a_numeric_name_2452", "An enum member cannot have a numeric name."), Variable_0_is_used_before_being_assigned: a(2454, e.DiagnosticCategory.Error, "Variable_0_is_used_before_being_assigned_2454", "Variable '{0}' is used before being assigned."), Type_alias_0_circularly_references_itself: a(2456, e.DiagnosticCategory.Error, "Type_alias_0_circularly_references_itself_2456", "Type alias '{0}' circularly references itself."), Type_alias_name_cannot_be_0: a(2457, e.DiagnosticCategory.Error, "Type_alias_name_cannot_be_0_2457", "Type alias name cannot be '{0}'."), An_AMD_module_cannot_have_multiple_name_assignments: a(2458, e.DiagnosticCategory.Error, "An_AMD_module_cannot_have_multiple_name_assignments_2458", "An AMD module cannot have multiple name assignments."), Module_0_declares_1_locally_but_it_is_not_exported: a(2459, e.DiagnosticCategory.Error, "Module_0_declares_1_locally_but_it_is_not_exported_2459", "Module '{0}' declares '{1}' locally, but it is not exported."), Module_0_declares_1_locally_but_it_is_exported_as_2: a(2460, e.DiagnosticCategory.Error, "Module_0_declares_1_locally_but_it_is_exported_as_2_2460", "Module '{0}' declares '{1}' locally, but it is exported as '{2}'."), Type_0_is_not_an_array_type: a(2461, e.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_2461", "Type '{0}' is not an array type."), A_rest_element_must_be_last_in_a_destructuring_pattern: a(2462, e.DiagnosticCategory.Error, "A_rest_element_must_be_last_in_a_destructuring_pattern_2462", "A rest element must be last in a destructuring pattern."), A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature: a(2463, e.DiagnosticCategory.Error, "A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature_2463", "A binding pattern parameter cannot be optional in an implementation signature."), A_computed_property_name_must_be_of_type_string_number_symbol_or_any: a(2464, e.DiagnosticCategory.Error, "A_computed_property_name_must_be_of_type_string_number_symbol_or_any_2464", "A computed property name must be of type 'string', 'number', 'symbol', or 'any'."), this_cannot_be_referenced_in_a_computed_property_name: a(2465, e.DiagnosticCategory.Error, "this_cannot_be_referenced_in_a_computed_property_name_2465", "'this' cannot be referenced in a computed property name."), super_cannot_be_referenced_in_a_computed_property_name: a(2466, e.DiagnosticCategory.Error, "super_cannot_be_referenced_in_a_computed_property_name_2466", "'super' cannot be referenced in a computed property name."), A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type: a(2467, e.DiagnosticCategory.Error, "A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type_2467", "A computed property name cannot reference a type parameter from its containing type."), Cannot_find_global_value_0: a(2468, e.DiagnosticCategory.Error, "Cannot_find_global_value_0_2468", "Cannot find global value '{0}'."), The_0_operator_cannot_be_applied_to_type_symbol: a(2469, e.DiagnosticCategory.Error, "The_0_operator_cannot_be_applied_to_type_symbol_2469", "The '{0}' operator cannot be applied to type 'symbol'."), Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher: a(2472, e.DiagnosticCategory.Error, "Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher_2472", "Spread operator in 'new' expressions is only available when targeting ECMAScript 5 and higher."), Enum_declarations_must_all_be_const_or_non_const: a(2473, e.DiagnosticCategory.Error, "Enum_declarations_must_all_be_const_or_non_const_2473", "Enum declarations must all be const or non-const."), const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values: a(2474, e.DiagnosticCategory.Error, "const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values_2474", "const enum member initializers can only contain literal values and other computed enum values."), const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query: a(2475, e.DiagnosticCategory.Error, "const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_im_2475", "'const' enums can only be used in property or index access expressions or the right hand side of an import declaration or export assignment or type query."), A_const_enum_member_can_only_be_accessed_using_a_string_literal: a(2476, e.DiagnosticCategory.Error, "A_const_enum_member_can_only_be_accessed_using_a_string_literal_2476", "A const enum member can only be accessed using a string literal."), const_enum_member_initializer_was_evaluated_to_a_non_finite_value: a(2477, e.DiagnosticCategory.Error, "const_enum_member_initializer_was_evaluated_to_a_non_finite_value_2477", "'const' enum member initializer was evaluated to a non-finite value."), const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN: a(2478, e.DiagnosticCategory.Error, "const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN_2478", "'const' enum member initializer was evaluated to disallowed value 'NaN'."), let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations: a(2480, e.DiagnosticCategory.Error, "let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations_2480", "'let' is not allowed to be used as a name in 'let' or 'const' declarations."), Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1: a(2481, e.DiagnosticCategory.Error, "Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1_2481", "Cannot initialize outer scoped variable '{0}' in the same scope as block scoped declaration '{1}'."), The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation: a(2483, e.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation_2483", "The left-hand side of a 'for...of' statement cannot use a type annotation."), Export_declaration_conflicts_with_exported_declaration_of_0: a(2484, e.DiagnosticCategory.Error, "Export_declaration_conflicts_with_exported_declaration_of_0_2484", "Export declaration conflicts with exported declaration of '{0}'."), The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access: a(2487, e.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access_2487", "The left-hand side of a 'for...of' statement must be a variable or a property access."), Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator: a(2488, e.DiagnosticCategory.Error, "Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator_2488", "Type '{0}' must have a '[Symbol.iterator]()' method that returns an iterator."), An_iterator_must_have_a_next_method: a(2489, e.DiagnosticCategory.Error, "An_iterator_must_have_a_next_method_2489", "An iterator must have a 'next()' method."), The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property: a(2490, e.DiagnosticCategory.Error, "The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property_2490", "The type returned by the '{0}()' method of an iterator must have a 'value' property."), The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern: a(2491, e.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern_2491", "The left-hand side of a 'for...in' statement cannot be a destructuring pattern."), Cannot_redeclare_identifier_0_in_catch_clause: a(2492, e.DiagnosticCategory.Error, "Cannot_redeclare_identifier_0_in_catch_clause_2492", "Cannot redeclare identifier '{0}' in catch clause."), Tuple_type_0_of_length_1_has_no_element_at_index_2: a(2493, e.DiagnosticCategory.Error, "Tuple_type_0_of_length_1_has_no_element_at_index_2_2493", "Tuple type '{0}' of length '{1}' has no element at index '{2}'."), Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher: a(2494, e.DiagnosticCategory.Error, "Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher_2494", "Using a string in a 'for...of' statement is only supported in ECMAScript 5 and higher."), Type_0_is_not_an_array_type_or_a_string_type: a(2495, e.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_or_a_string_type_2495", "Type '{0}' is not an array type or a string type."), The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression: a(2496, e.DiagnosticCategory.Error, "The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_stand_2496", "The 'arguments' object cannot be referenced in an arrow function in ES3 and ES5. Consider using a standard function expression."), This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export: a(2497, e.DiagnosticCategory.Error, "This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_2497", "This module can only be referenced with ECMAScript imports/exports by turning on the '{0}' flag and referencing its default export."), Module_0_uses_export_and_cannot_be_used_with_export_Asterisk: a(2498, e.DiagnosticCategory.Error, "Module_0_uses_export_and_cannot_be_used_with_export_Asterisk_2498", "Module '{0}' uses 'export =' and cannot be used with 'export *'."), An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments: a(2499, e.DiagnosticCategory.Error, "An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments_2499", "An interface can only extend an identifier/qualified-name with optional type arguments."), A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments: a(2500, e.DiagnosticCategory.Error, "A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments_2500", "A class can only implement an identifier/qualified-name with optional type arguments."), A_rest_element_cannot_contain_a_binding_pattern: a(2501, e.DiagnosticCategory.Error, "A_rest_element_cannot_contain_a_binding_pattern_2501", "A rest element cannot contain a binding pattern."), _0_is_referenced_directly_or_indirectly_in_its_own_type_annotation: a(2502, e.DiagnosticCategory.Error, "_0_is_referenced_directly_or_indirectly_in_its_own_type_annotation_2502", "'{0}' is referenced directly or indirectly in its own type annotation."), Cannot_find_namespace_0: a(2503, e.DiagnosticCategory.Error, "Cannot_find_namespace_0_2503", "Cannot find namespace '{0}'."), Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator: a(2504, e.DiagnosticCategory.Error, "Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator_2504", "Type '{0}' must have a '[Symbol.asyncIterator]()' method that returns an async iterator."), A_generator_cannot_have_a_void_type_annotation: a(2505, e.DiagnosticCategory.Error, "A_generator_cannot_have_a_void_type_annotation_2505", "A generator cannot have a 'void' type annotation."), _0_is_referenced_directly_or_indirectly_in_its_own_base_expression: a(2506, e.DiagnosticCategory.Error, "_0_is_referenced_directly_or_indirectly_in_its_own_base_expression_2506", "'{0}' is referenced directly or indirectly in its own base expression."), Type_0_is_not_a_constructor_function_type: a(2507, e.DiagnosticCategory.Error, "Type_0_is_not_a_constructor_function_type_2507", "Type '{0}' is not a constructor function type."), No_base_constructor_has_the_specified_number_of_type_arguments: a(2508, e.DiagnosticCategory.Error, "No_base_constructor_has_the_specified_number_of_type_arguments_2508", "No base constructor has the specified number of type arguments."), Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members: a(2509, e.DiagnosticCategory.Error, "Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_2509", "Base constructor return type '{0}' is not an object type or intersection of object types with statically known members."), Base_constructors_must_all_have_the_same_return_type: a(2510, e.DiagnosticCategory.Error, "Base_constructors_must_all_have_the_same_return_type_2510", "Base constructors must all have the same return type."), Cannot_create_an_instance_of_an_abstract_class: a(2511, e.DiagnosticCategory.Error, "Cannot_create_an_instance_of_an_abstract_class_2511", "Cannot create an instance of an abstract class."), Overload_signatures_must_all_be_abstract_or_non_abstract: a(2512, e.DiagnosticCategory.Error, "Overload_signatures_must_all_be_abstract_or_non_abstract_2512", "Overload signatures must all be abstract or non-abstract."), Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression: a(2513, e.DiagnosticCategory.Error, "Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression_2513", "Abstract method '{0}' in class '{1}' cannot be accessed via super expression."), Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2: a(2515, e.DiagnosticCategory.Error, "Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2_2515", "Non-abstract class '{0}' does not implement inherited abstract member '{1}' from class '{2}'."), All_declarations_of_an_abstract_method_must_be_consecutive: a(2516, e.DiagnosticCategory.Error, "All_declarations_of_an_abstract_method_must_be_consecutive_2516", "All declarations of an abstract method must be consecutive."), Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type: a(2517, e.DiagnosticCategory.Error, "Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type_2517", "Cannot assign an abstract constructor type to a non-abstract constructor type."), A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard: a(2518, e.DiagnosticCategory.Error, "A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard_2518", "A 'this'-based type guard is not compatible with a parameter-based type guard."), An_async_iterator_must_have_a_next_method: a(2519, e.DiagnosticCategory.Error, "An_async_iterator_must_have_a_next_method_2519", "An async iterator must have a 'next()' method."), Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions: a(2520, e.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions_2520", "Duplicate identifier '{0}'. Compiler uses declaration '{1}' to support async functions."), The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method: a(2522, e.DiagnosticCategory.Error, "The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_usi_2522", "The 'arguments' object cannot be referenced in an async function or method in ES3 and ES5. Consider using a standard function or method."), yield_expressions_cannot_be_used_in_a_parameter_initializer: a(2523, e.DiagnosticCategory.Error, "yield_expressions_cannot_be_used_in_a_parameter_initializer_2523", "'yield' expressions cannot be used in a parameter initializer."), await_expressions_cannot_be_used_in_a_parameter_initializer: a(2524, e.DiagnosticCategory.Error, "await_expressions_cannot_be_used_in_a_parameter_initializer_2524", "'await' expressions cannot be used in a parameter initializer."), Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value: a(2525, e.DiagnosticCategory.Error, "Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value_2525", "Initializer provides no value for this binding element and the binding element has no default value."), A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface: a(2526, e.DiagnosticCategory.Error, "A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface_2526", "A 'this' type is available only in a non-static member of a class or interface."), The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary: a(2527, e.DiagnosticCategory.Error, "The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary_2527", "The inferred type of '{0}' references an inaccessible '{1}' type. A type annotation is necessary."), A_module_cannot_have_multiple_default_exports: a(2528, e.DiagnosticCategory.Error, "A_module_cannot_have_multiple_default_exports_2528", "A module cannot have multiple default exports."), Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions: a(2529, e.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_func_2529", "Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module containing async functions."), Property_0_is_incompatible_with_index_signature: a(2530, e.DiagnosticCategory.Error, "Property_0_is_incompatible_with_index_signature_2530", "Property '{0}' is incompatible with index signature."), Object_is_possibly_null: a(2531, e.DiagnosticCategory.Error, "Object_is_possibly_null_2531", "Object is possibly 'null'."), Object_is_possibly_undefined: a(2532, e.DiagnosticCategory.Error, "Object_is_possibly_undefined_2532", "Object is possibly 'undefined'."), Object_is_possibly_null_or_undefined: a(2533, e.DiagnosticCategory.Error, "Object_is_possibly_null_or_undefined_2533", "Object is possibly 'null' or 'undefined'."), A_function_returning_never_cannot_have_a_reachable_end_point: a(2534, e.DiagnosticCategory.Error, "A_function_returning_never_cannot_have_a_reachable_end_point_2534", "A function returning 'never' cannot have a reachable end point."), Enum_type_0_has_members_with_initializers_that_are_not_literals: a(2535, e.DiagnosticCategory.Error, "Enum_type_0_has_members_with_initializers_that_are_not_literals_2535", "Enum type '{0}' has members with initializers that are not literals."), Type_0_cannot_be_used_to_index_type_1: a(2536, e.DiagnosticCategory.Error, "Type_0_cannot_be_used_to_index_type_1_2536", "Type '{0}' cannot be used to index type '{1}'."), Type_0_has_no_matching_index_signature_for_type_1: a(2537, e.DiagnosticCategory.Error, "Type_0_has_no_matching_index_signature_for_type_1_2537", "Type '{0}' has no matching index signature for type '{1}'."), Type_0_cannot_be_used_as_an_index_type: a(2538, e.DiagnosticCategory.Error, "Type_0_cannot_be_used_as_an_index_type_2538", "Type '{0}' cannot be used as an index type."), Cannot_assign_to_0_because_it_is_not_a_variable: a(2539, e.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_not_a_variable_2539", "Cannot assign to '{0}' because it is not a variable."), Cannot_assign_to_0_because_it_is_a_read_only_property: a(2540, e.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_read_only_property_2540", "Cannot assign to '{0}' because it is a read-only property."), Index_signature_in_type_0_only_permits_reading: a(2542, e.DiagnosticCategory.Error, "Index_signature_in_type_0_only_permits_reading_2542", "Index signature in type '{0}' only permits reading."), Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference: a(2543, e.DiagnosticCategory.Error, "Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_me_2543", "Duplicate identifier '_newTarget'. Compiler uses variable declaration '_newTarget' to capture 'new.target' meta-property reference."), Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference: a(2544, e.DiagnosticCategory.Error, "Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta__2544", "Expression resolves to variable declaration '_newTarget' that compiler uses to capture 'new.target' meta-property reference."), A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any: a(2545, e.DiagnosticCategory.Error, "A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any_2545", "A mixin class must have a constructor with a single rest parameter of type 'any[]'."), The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property: a(2547, e.DiagnosticCategory.Error, "The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_pro_2547", "The type returned by the '{0}()' method of an async iterator must be a promise for a type with a 'value' property."), Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator: a(2548, e.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator_2548", "Type '{0}' is not an array type or does not have a '[Symbol.iterator]()' method that returns an iterator."), Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator: a(2549, e.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns__2549", "Type '{0}' is not an array type or a string type or does not have a '[Symbol.iterator]()' method that returns an iterator."), Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2_or_later: a(2550, e.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_c_2550", "Property '{0}' does not exist on type '{1}'. Do you need to change your target library? Try changing the 'lib' compiler option to '{2}' or later."), Property_0_does_not_exist_on_type_1_Did_you_mean_2: a(2551, e.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_Did_you_mean_2_2551", "Property '{0}' does not exist on type '{1}'. Did you mean '{2}'?"), Cannot_find_name_0_Did_you_mean_1: a(2552, e.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_1_2552", "Cannot find name '{0}'. Did you mean '{1}'?"), Computed_values_are_not_permitted_in_an_enum_with_string_valued_members: a(2553, e.DiagnosticCategory.Error, "Computed_values_are_not_permitted_in_an_enum_with_string_valued_members_2553", "Computed values are not permitted in an enum with string valued members."), Expected_0_arguments_but_got_1: a(2554, e.DiagnosticCategory.Error, "Expected_0_arguments_but_got_1_2554", "Expected {0} arguments, but got {1}."), Expected_at_least_0_arguments_but_got_1: a(2555, e.DiagnosticCategory.Error, "Expected_at_least_0_arguments_but_got_1_2555", "Expected at least {0} arguments, but got {1}."), A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter: a(2556, e.DiagnosticCategory.Error, "A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter_2556", "A spread argument must either have a tuple type or be passed to a rest parameter."), Expected_0_type_arguments_but_got_1: a(2558, e.DiagnosticCategory.Error, "Expected_0_type_arguments_but_got_1_2558", "Expected {0} type arguments, but got {1}."), Type_0_has_no_properties_in_common_with_type_1: a(2559, e.DiagnosticCategory.Error, "Type_0_has_no_properties_in_common_with_type_1_2559", "Type '{0}' has no properties in common with type '{1}'."), Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it: a(2560, e.DiagnosticCategory.Error, "Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it_2560", "Value of type '{0}' has no properties in common with type '{1}'. Did you mean to call it?"), Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2: a(2561, e.DiagnosticCategory.Error, "Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_writ_2561", "Object literal may only specify known properties, but '{0}' does not exist in type '{1}'. Did you mean to write '{2}'?"), Base_class_expressions_cannot_reference_class_type_parameters: a(2562, e.DiagnosticCategory.Error, "Base_class_expressions_cannot_reference_class_type_parameters_2562", "Base class expressions cannot reference class type parameters."), The_containing_function_or_module_body_is_too_large_for_control_flow_analysis: a(2563, e.DiagnosticCategory.Error, "The_containing_function_or_module_body_is_too_large_for_control_flow_analysis_2563", "The containing function or module body is too large for control flow analysis."), Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor: a(2564, e.DiagnosticCategory.Error, "Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor_2564", "Property '{0}' has no initializer and is not definitely assigned in the constructor."), Property_0_is_used_before_being_assigned: a(2565, e.DiagnosticCategory.Error, "Property_0_is_used_before_being_assigned_2565", "Property '{0}' is used before being assigned."), A_rest_element_cannot_have_a_property_name: a(2566, e.DiagnosticCategory.Error, "A_rest_element_cannot_have_a_property_name_2566", "A rest element cannot have a property name."), Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations: a(2567, e.DiagnosticCategory.Error, "Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations_2567", "Enum declarations can only merge with namespace or other enum declarations."), Property_0_may_not_exist_on_type_1_Did_you_mean_2: a(2568, e.DiagnosticCategory.Error, "Property_0_may_not_exist_on_type_1_Did_you_mean_2_2568", "Property '{0}' may not exist on type '{1}'. Did you mean '{2}'?"), Could_not_find_name_0_Did_you_mean_1: a(2570, e.DiagnosticCategory.Error, "Could_not_find_name_0_Did_you_mean_1_2570", "Could not find name '{0}'. Did you mean '{1}'?"), Object_is_of_type_unknown: a(2571, e.DiagnosticCategory.Error, "Object_is_of_type_unknown_2571", "Object is of type 'unknown'."), A_rest_element_type_must_be_an_array_type: a(2574, e.DiagnosticCategory.Error, "A_rest_element_type_must_be_an_array_type_2574", "A rest element type must be an array type."), No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments: a(2575, e.DiagnosticCategory.Error, "No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments_2575", "No overload expects {0} arguments, but overloads do exist that expect either {1} or {2} arguments."), Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead: a(2576, e.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead_2576", "Property '{0}' does not exist on type '{1}'. Did you mean to access the static member '{2}' instead?"), Return_type_annotation_circularly_references_itself: a(2577, e.DiagnosticCategory.Error, "Return_type_annotation_circularly_references_itself_2577", "Return type annotation circularly references itself."), Unused_ts_expect_error_directive: a(2578, e.DiagnosticCategory.Error, "Unused_ts_expect_error_directive_2578", "Unused '@ts-expect-error' directive."), Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode: a(2580, e.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashno_2580", "Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i --save-dev @types/node`."), Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery: a(2581, e.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slash_2581", "Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i --save-dev @types/jquery`."), Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha: a(2582, e.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_type_2582", "Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i --save-dev @types/jest` or `npm i --save-dev @types/mocha`."), Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_1_or_later: a(2583, e.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2583", "Cannot find name '{0}'. Do you need to change your target library? Try changing the 'lib' compiler option to '{1}' or later."), Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom: a(2584, e.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2584", "Cannot find name '{0}'. Do you need to change your target library? Try changing the 'lib' compiler option to include 'dom'."), _0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later: a(2585, e.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_2585", "'{0}' only refers to a type, but is being used as a value here. Do you need to change your target library? Try changing the 'lib' compiler option to es2015 or later."), Cannot_assign_to_0_because_it_is_a_constant: a(2588, e.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_constant_2588", "Cannot assign to '{0}' because it is a constant."), Type_instantiation_is_excessively_deep_and_possibly_infinite: a(2589, e.DiagnosticCategory.Error, "Type_instantiation_is_excessively_deep_and_possibly_infinite_2589", "Type instantiation is excessively deep and possibly infinite."), Expression_produces_a_union_type_that_is_too_complex_to_represent: a(2590, e.DiagnosticCategory.Error, "Expression_produces_a_union_type_that_is_too_complex_to_represent_2590", "Expression produces a union type that is too complex to represent."), Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig: a(2591, e.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashno_2591", "Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i --save-dev @types/node` and then add 'node' to the types field in your tsconfig."), Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig: a(2592, e.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slash_2592", "Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i --save-dev @types/jquery` and then add 'jquery' to the types field in your tsconfig."), Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig: a(2593, e.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_type_2593", "Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i --save-dev @types/jest` or `npm i --save-dev @types/mocha` and then add 'jest' or 'mocha' to the types field in your tsconfig."), This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag: a(2594, e.DiagnosticCategory.Error, "This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the__2594", "This module is declared with using 'export =', and can only be used with a default import when using the '{0}' flag."), _0_can_only_be_imported_by_using_a_default_import: a(2595, e.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_a_default_import_2595", "'{0}' can only be imported by using a default import."), _0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: a(2596, e.DiagnosticCategory.Error, "_0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import_2596", "'{0}' can only be imported by turning on the 'esModuleInterop' flag and using a default import."), _0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import: a(2597, e.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import_2597", "'{0}' can only be imported by using a 'require' call or by using a default import."), _0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: a(2598, e.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using__2598", "'{0}' can only be imported by using a 'require' call or by turning on the 'esModuleInterop' flag and using a default import."), JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist: a(2602, e.DiagnosticCategory.Error, "JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist_2602", "JSX element implicitly has type 'any' because the global type 'JSX.Element' does not exist."), Property_0_in_type_1_is_not_assignable_to_type_2: a(2603, e.DiagnosticCategory.Error, "Property_0_in_type_1_is_not_assignable_to_type_2_2603", "Property '{0}' in type '{1}' is not assignable to type '{2}'."), JSX_element_type_0_does_not_have_any_construct_or_call_signatures: a(2604, e.DiagnosticCategory.Error, "JSX_element_type_0_does_not_have_any_construct_or_call_signatures_2604", "JSX element type '{0}' does not have any construct or call signatures."), Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property: a(2606, e.DiagnosticCategory.Error, "Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property_2606", "Property '{0}' of JSX spread attribute is not assignable to target property."), JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property: a(2607, e.DiagnosticCategory.Error, "JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property_2607", "JSX element class does not support attributes because it does not have a '{0}' property."), The_global_type_JSX_0_may_not_have_more_than_one_property: a(2608, e.DiagnosticCategory.Error, "The_global_type_JSX_0_may_not_have_more_than_one_property_2608", "The global type 'JSX.{0}' may not have more than one property."), JSX_spread_child_must_be_an_array_type: a(2609, e.DiagnosticCategory.Error, "JSX_spread_child_must_be_an_array_type_2609", "JSX spread child must be an array type."), _0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property: a(2610, e.DiagnosticCategory.Error, "_0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property_2610", "'{0}' is defined as an accessor in class '{1}', but is overridden here in '{2}' as an instance property."), _0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor: a(2611, e.DiagnosticCategory.Error, "_0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor_2611", "'{0}' is defined as a property in class '{1}', but is overridden here in '{2}' as an accessor."), Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration: a(2612, e.DiagnosticCategory.Error, "Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_2612", "Property '{0}' will overwrite the base property in '{1}'. If this is intentional, add an initializer. Otherwise, add a 'declare' modifier or remove the redundant declaration."), Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead: a(2613, e.DiagnosticCategory.Error, "Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead_2613", "Module '{0}' has no default export. Did you mean to use 'import { {1} } from {0}' instead?"), Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead: a(2614, e.DiagnosticCategory.Error, "Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead_2614", "Module '{0}' has no exported member '{1}'. Did you mean to use 'import {1} from {0}' instead?"), Type_of_property_0_circularly_references_itself_in_mapped_type_1: a(2615, e.DiagnosticCategory.Error, "Type_of_property_0_circularly_references_itself_in_mapped_type_1_2615", "Type of property '{0}' circularly references itself in mapped type '{1}'."), _0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import: a(2616, e.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import_2616", "'{0}' can only be imported by using 'import {1} = require({2})' or a default import."), _0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: a(2617, e.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_us_2617", "'{0}' can only be imported by using 'import {1} = require({2})' or by turning on the 'esModuleInterop' flag and using a default import."), Source_has_0_element_s_but_target_requires_1: a(2618, e.DiagnosticCategory.Error, "Source_has_0_element_s_but_target_requires_1_2618", "Source has {0} element(s) but target requires {1}."), Source_has_0_element_s_but_target_allows_only_1: a(2619, e.DiagnosticCategory.Error, "Source_has_0_element_s_but_target_allows_only_1_2619", "Source has {0} element(s) but target allows only {1}."), Target_requires_0_element_s_but_source_may_have_fewer: a(2620, e.DiagnosticCategory.Error, "Target_requires_0_element_s_but_source_may_have_fewer_2620", "Target requires {0} element(s) but source may have fewer."), Target_allows_only_0_element_s_but_source_may_have_more: a(2621, e.DiagnosticCategory.Error, "Target_allows_only_0_element_s_but_source_may_have_more_2621", "Target allows only {0} element(s) but source may have more."), Source_provides_no_match_for_required_element_at_position_0_in_target: a(2623, e.DiagnosticCategory.Error, "Source_provides_no_match_for_required_element_at_position_0_in_target_2623", "Source provides no match for required element at position {0} in target."), Source_provides_no_match_for_variadic_element_at_position_0_in_target: a(2624, e.DiagnosticCategory.Error, "Source_provides_no_match_for_variadic_element_at_position_0_in_target_2624", "Source provides no match for variadic element at position {0} in target."), Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target: a(2625, e.DiagnosticCategory.Error, "Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target_2625", "Variadic element at position {0} in source does not match element at position {1} in target."), Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target: a(2626, e.DiagnosticCategory.Error, "Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target_2626", "Type at position {0} in source is not compatible with type at position {1} in target."), Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target: a(2627, e.DiagnosticCategory.Error, "Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target_2627", "Type at positions {0} through {1} in source is not compatible with type at position {2} in target."), Cannot_assign_to_0_because_it_is_an_enum: a(2628, e.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_an_enum_2628", "Cannot assign to '{0}' because it is an enum."), Cannot_assign_to_0_because_it_is_a_class: a(2629, e.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_class_2629", "Cannot assign to '{0}' because it is a class."), Cannot_assign_to_0_because_it_is_a_function: a(2630, e.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_function_2630", "Cannot assign to '{0}' because it is a function."), Cannot_assign_to_0_because_it_is_a_namespace: a(2631, e.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_namespace_2631", "Cannot assign to '{0}' because it is a namespace."), Cannot_assign_to_0_because_it_is_an_import: a(2632, e.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_an_import_2632", "Cannot assign to '{0}' because it is an import."), JSX_property_access_expressions_cannot_include_JSX_namespace_names: a(2633, e.DiagnosticCategory.Error, "JSX_property_access_expressions_cannot_include_JSX_namespace_names_2633", "JSX property access expressions cannot include JSX namespace names"), _0_index_signatures_are_incompatible: a(2634, e.DiagnosticCategory.Error, "_0_index_signatures_are_incompatible_2634", "'{0}' index signatures are incompatible."), Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable: a(2635, e.DiagnosticCategory.Error, "Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable_2635", "Type '{0}' has no signatures for which the type argument list is applicable."), Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation: a(2636, e.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation_2636", "Type '{0}' is not assignable to type '{1}' as implied by variance annotation."), Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_types: a(2637, e.DiagnosticCategory.Error, "Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_t_2637", "Variance annotations are only supported in type aliases for object, function, constructor, and mapped types."), Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity: a(2649, e.DiagnosticCategory.Error, "Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity_2649", "Cannot augment module '{0}' with value exports because it resolves to a non-module entity."), A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums: a(2651, e.DiagnosticCategory.Error, "A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_memb_2651", "A member initializer in a enum declaration cannot reference members declared after it, including members defined in other enums."), Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead: a(2652, e.DiagnosticCategory.Error, "Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_d_2652", "Merged declaration '{0}' cannot include a default export declaration. Consider adding a separate 'export default {0}' declaration instead."), Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1: a(2653, e.DiagnosticCategory.Error, "Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1_2653", "Non-abstract class expression does not implement inherited abstract member '{0}' from class '{1}'."), JSX_expressions_must_have_one_parent_element: a(2657, e.DiagnosticCategory.Error, "JSX_expressions_must_have_one_parent_element_2657", "JSX expressions must have one parent element."), Type_0_provides_no_match_for_the_signature_1: a(2658, e.DiagnosticCategory.Error, "Type_0_provides_no_match_for_the_signature_1_2658", "Type '{0}' provides no match for the signature '{1}'."), super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher: a(2659, e.DiagnosticCategory.Error, "super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_highe_2659", "'super' is only allowed in members of object literal expressions when option 'target' is 'ES2015' or higher."), super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions: a(2660, e.DiagnosticCategory.Error, "super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions_2660", "'super' can only be referenced in members of derived classes or object literal expressions."), Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module: a(2661, e.DiagnosticCategory.Error, "Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module_2661", "Cannot export '{0}'. Only local declarations can be exported from a module."), Cannot_find_name_0_Did_you_mean_the_static_member_1_0: a(2662, e.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_the_static_member_1_0_2662", "Cannot find name '{0}'. Did you mean the static member '{1}.{0}'?"), Cannot_find_name_0_Did_you_mean_the_instance_member_this_0: a(2663, e.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_the_instance_member_this_0_2663", "Cannot find name '{0}'. Did you mean the instance member 'this.{0}'?"), Invalid_module_name_in_augmentation_module_0_cannot_be_found: a(2664, e.DiagnosticCategory.Error, "Invalid_module_name_in_augmentation_module_0_cannot_be_found_2664", "Invalid module name in augmentation, module '{0}' cannot be found."), Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented: a(2665, e.DiagnosticCategory.Error, "Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augm_2665", "Invalid module name in augmentation. Module '{0}' resolves to an untyped module at '{1}', which cannot be augmented."), Exports_and_export_assignments_are_not_permitted_in_module_augmentations: a(2666, e.DiagnosticCategory.Error, "Exports_and_export_assignments_are_not_permitted_in_module_augmentations_2666", "Exports and export assignments are not permitted in module augmentations."), Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module: a(2667, e.DiagnosticCategory.Error, "Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_mod_2667", "Imports are not permitted in module augmentations. Consider moving them to the enclosing external module."), export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible: a(2668, e.DiagnosticCategory.Error, "export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always__2668", "'export' modifier cannot be applied to ambient modules and module augmentations since they are always visible."), Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations: a(2669, e.DiagnosticCategory.Error, "Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_2669", "Augmentations for the global scope can only be directly nested in external modules or ambient module declarations."), Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context: a(2670, e.DiagnosticCategory.Error, "Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambien_2670", "Augmentations for the global scope should have 'declare' modifier unless they appear in already ambient context."), Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity: a(2671, e.DiagnosticCategory.Error, "Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity_2671", "Cannot augment module '{0}' because it resolves to a non-module entity."), Cannot_assign_a_0_constructor_type_to_a_1_constructor_type: a(2672, e.DiagnosticCategory.Error, "Cannot_assign_a_0_constructor_type_to_a_1_constructor_type_2672", "Cannot assign a '{0}' constructor type to a '{1}' constructor type."), Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration: a(2673, e.DiagnosticCategory.Error, "Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration_2673", "Constructor of class '{0}' is private and only accessible within the class declaration."), Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration: a(2674, e.DiagnosticCategory.Error, "Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration_2674", "Constructor of class '{0}' is protected and only accessible within the class declaration."), Cannot_extend_a_class_0_Class_constructor_is_marked_as_private: a(2675, e.DiagnosticCategory.Error, "Cannot_extend_a_class_0_Class_constructor_is_marked_as_private_2675", "Cannot extend a class '{0}'. Class constructor is marked as private."), Accessors_must_both_be_abstract_or_non_abstract: a(2676, e.DiagnosticCategory.Error, "Accessors_must_both_be_abstract_or_non_abstract_2676", "Accessors must both be abstract or non-abstract."), A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type: a(2677, e.DiagnosticCategory.Error, "A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type_2677", "A type predicate's type must be assignable to its parameter's type."), Type_0_is_not_comparable_to_type_1: a(2678, e.DiagnosticCategory.Error, "Type_0_is_not_comparable_to_type_1_2678", "Type '{0}' is not comparable to type '{1}'."), A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void: a(2679, e.DiagnosticCategory.Error, "A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void_2679", "A function that is called with the 'new' keyword cannot have a 'this' type that is 'void'."), A_0_parameter_must_be_the_first_parameter: a(2680, e.DiagnosticCategory.Error, "A_0_parameter_must_be_the_first_parameter_2680", "A '{0}' parameter must be the first parameter."), A_constructor_cannot_have_a_this_parameter: a(2681, e.DiagnosticCategory.Error, "A_constructor_cannot_have_a_this_parameter_2681", "A constructor cannot have a 'this' parameter."), this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation: a(2683, e.DiagnosticCategory.Error, "this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_2683", "'this' implicitly has type 'any' because it does not have a type annotation."), The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1: a(2684, e.DiagnosticCategory.Error, "The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1_2684", "The 'this' context of type '{0}' is not assignable to method's 'this' of type '{1}'."), The_this_types_of_each_signature_are_incompatible: a(2685, e.DiagnosticCategory.Error, "The_this_types_of_each_signature_are_incompatible_2685", "The 'this' types of each signature are incompatible."), _0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead: a(2686, e.DiagnosticCategory.Error, "_0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead_2686", "'{0}' refers to a UMD global, but the current file is a module. Consider adding an import instead."), All_declarations_of_0_must_have_identical_modifiers: a(2687, e.DiagnosticCategory.Error, "All_declarations_of_0_must_have_identical_modifiers_2687", "All declarations of '{0}' must have identical modifiers."), Cannot_find_type_definition_file_for_0: a(2688, e.DiagnosticCategory.Error, "Cannot_find_type_definition_file_for_0_2688", "Cannot find type definition file for '{0}'."), Cannot_extend_an_interface_0_Did_you_mean_implements: a(2689, e.DiagnosticCategory.Error, "Cannot_extend_an_interface_0_Did_you_mean_implements_2689", "Cannot extend an interface '{0}'. Did you mean 'implements'?"), _0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0: a(2690, e.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0_2690", "'{0}' only refers to a type, but is being used as a value here. Did you mean to use '{1} in {0}'?"), An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead: a(2691, e.DiagnosticCategory.Error, "An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead_2691", "An import path cannot end with a '{0}' extension. Consider importing '{1}' instead."), _0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible: a(2692, e.DiagnosticCategory.Error, "_0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible_2692", "'{0}' is a primitive, but '{1}' is a wrapper object. Prefer using '{0}' when possible."), _0_only_refers_to_a_type_but_is_being_used_as_a_value_here: a(2693, e.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_2693", "'{0}' only refers to a type, but is being used as a value here."), Namespace_0_has_no_exported_member_1: a(2694, e.DiagnosticCategory.Error, "Namespace_0_has_no_exported_member_1_2694", "Namespace '{0}' has no exported member '{1}'."), Left_side_of_comma_operator_is_unused_and_has_no_side_effects: a(2695, e.DiagnosticCategory.Error, "Left_side_of_comma_operator_is_unused_and_has_no_side_effects_2695", "Left side of comma operator is unused and has no side effects.", true), The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead: a(2696, e.DiagnosticCategory.Error, "The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead_2696", "The 'Object' type is assignable to very few other types. Did you mean to use the 'any' type instead?"), An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option: a(2697, e.DiagnosticCategory.Error, "An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_in_2697", "An async function or method must return a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your '--lib' option."), Spread_types_may_only_be_created_from_object_types: a(2698, e.DiagnosticCategory.Error, "Spread_types_may_only_be_created_from_object_types_2698", "Spread types may only be created from object types."), Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1: a(2699, e.DiagnosticCategory.Error, "Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1_2699", "Static property '{0}' conflicts with built-in property 'Function.{0}' of constructor function '{1}'."), Rest_types_may_only_be_created_from_object_types: a(2700, e.DiagnosticCategory.Error, "Rest_types_may_only_be_created_from_object_types_2700", "Rest types may only be created from object types."), The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access: a(2701, e.DiagnosticCategory.Error, "The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access_2701", "The target of an object rest assignment must be a variable or a property access."), _0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here: a(2702, e.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here_2702", "'{0}' only refers to a type, but is being used as a namespace here."), The_operand_of_a_delete_operator_must_be_a_property_reference: a(2703, e.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_must_be_a_property_reference_2703", "The operand of a 'delete' operator must be a property reference."), The_operand_of_a_delete_operator_cannot_be_a_read_only_property: a(2704, e.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_cannot_be_a_read_only_property_2704", "The operand of a 'delete' operator cannot be a read-only property."), An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option: a(2705, e.DiagnosticCategory.Error, "An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_de_2705", "An async function or method in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your '--lib' option."), Required_type_parameters_may_not_follow_optional_type_parameters: a(2706, e.DiagnosticCategory.Error, "Required_type_parameters_may_not_follow_optional_type_parameters_2706", "Required type parameters may not follow optional type parameters."), Generic_type_0_requires_between_1_and_2_type_arguments: a(2707, e.DiagnosticCategory.Error, "Generic_type_0_requires_between_1_and_2_type_arguments_2707", "Generic type '{0}' requires between {1} and {2} type arguments."), Cannot_use_namespace_0_as_a_value: a(2708, e.DiagnosticCategory.Error, "Cannot_use_namespace_0_as_a_value_2708", "Cannot use namespace '{0}' as a value."), Cannot_use_namespace_0_as_a_type: a(2709, e.DiagnosticCategory.Error, "Cannot_use_namespace_0_as_a_type_2709", "Cannot use namespace '{0}' as a type."), _0_are_specified_twice_The_attribute_named_0_will_be_overwritten: a(2710, e.DiagnosticCategory.Error, "_0_are_specified_twice_The_attribute_named_0_will_be_overwritten_2710", "'{0}' are specified twice. The attribute named '{0}' will be overwritten."), A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option: a(2711, e.DiagnosticCategory.Error, "A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES20_2711", "A dynamic import call returns a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your '--lib' option."), A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option: a(2712, e.DiagnosticCategory.Error, "A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declarat_2712", "A dynamic import call in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your '--lib' option."), Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1: a(2713, e.DiagnosticCategory.Error, "Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_p_2713", `Cannot access '{0}.{1}' because '{0}' is a type, but not a namespace. Did you mean to retrieve the type of the property '{1}' in '{0}' with '{0}["{1}"]'?`), The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context: a(2714, e.DiagnosticCategory.Error, "The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context_2714", "The expression of an export assignment must be an identifier or qualified name in an ambient context."), Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor: a(2715, e.DiagnosticCategory.Error, "Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor_2715", "Abstract property '{0}' in class '{1}' cannot be accessed in the constructor."), Type_parameter_0_has_a_circular_default: a(2716, e.DiagnosticCategory.Error, "Type_parameter_0_has_a_circular_default_2716", "Type parameter '{0}' has a circular default."), Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2: a(2717, e.DiagnosticCategory.Error, "Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_t_2717", "Subsequent property declarations must have the same type.  Property '{0}' must be of type '{1}', but here has type '{2}'."), Duplicate_property_0: a(2718, e.DiagnosticCategory.Error, "Duplicate_property_0_2718", "Duplicate property '{0}'."), Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated: a(2719, e.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated_2719", "Type '{0}' is not assignable to type '{1}'. Two different types with this name exist, but they are unrelated."), Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass: a(2720, e.DiagnosticCategory.Error, "Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclas_2720", "Class '{0}' incorrectly implements class '{1}'. Did you mean to extend '{1}' and inherit its members as a subclass?"), Cannot_invoke_an_object_which_is_possibly_null: a(2721, e.DiagnosticCategory.Error, "Cannot_invoke_an_object_which_is_possibly_null_2721", "Cannot invoke an object which is possibly 'null'."), Cannot_invoke_an_object_which_is_possibly_undefined: a(2722, e.DiagnosticCategory.Error, "Cannot_invoke_an_object_which_is_possibly_undefined_2722", "Cannot invoke an object which is possibly 'undefined'."), Cannot_invoke_an_object_which_is_possibly_null_or_undefined: a(2723, e.DiagnosticCategory.Error, "Cannot_invoke_an_object_which_is_possibly_null_or_undefined_2723", "Cannot invoke an object which is possibly 'null' or 'undefined'."), _0_has_no_exported_member_named_1_Did_you_mean_2: a(2724, e.DiagnosticCategory.Error, "_0_has_no_exported_member_named_1_Did_you_mean_2_2724", "'{0}' has no exported member named '{1}'. Did you mean '{2}'?"), Class_name_cannot_be_Object_when_targeting_ES5_with_module_0: a(2725, e.DiagnosticCategory.Error, "Class_name_cannot_be_Object_when_targeting_ES5_with_module_0_2725", "Class name cannot be 'Object' when targeting ES5 with module {0}."), Cannot_find_lib_definition_for_0: a(2726, e.DiagnosticCategory.Error, "Cannot_find_lib_definition_for_0_2726", "Cannot find lib definition for '{0}'."), Cannot_find_lib_definition_for_0_Did_you_mean_1: a(2727, e.DiagnosticCategory.Error, "Cannot_find_lib_definition_for_0_Did_you_mean_1_2727", "Cannot find lib definition for '{0}'. Did you mean '{1}'?"), _0_is_declared_here: a(2728, e.DiagnosticCategory.Message, "_0_is_declared_here_2728", "'{0}' is declared here."), Property_0_is_used_before_its_initialization: a(2729, e.DiagnosticCategory.Error, "Property_0_is_used_before_its_initialization_2729", "Property '{0}' is used before its initialization."), An_arrow_function_cannot_have_a_this_parameter: a(2730, e.DiagnosticCategory.Error, "An_arrow_function_cannot_have_a_this_parameter_2730", "An arrow function cannot have a 'this' parameter."), Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String: a(2731, e.DiagnosticCategory.Error, "Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_i_2731", "Implicit conversion of a 'symbol' to a 'string' will fail at runtime. Consider wrapping this expression in 'String(...)'."), Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension: a(2732, e.DiagnosticCategory.Error, "Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension_2732", "Cannot find module '{0}'. Consider using '--resolveJsonModule' to import module with '.json' extension."), Property_0_was_also_declared_here: a(2733, e.DiagnosticCategory.Error, "Property_0_was_also_declared_here_2733", "Property '{0}' was also declared here."), Are_you_missing_a_semicolon: a(2734, e.DiagnosticCategory.Error, "Are_you_missing_a_semicolon_2734", "Are you missing a semicolon?"), Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1: a(2735, e.DiagnosticCategory.Error, "Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1_2735", "Did you mean for '{0}' to be constrained to type 'new (...args: any[]) => {1}'?"), Operator_0_cannot_be_applied_to_type_1: a(2736, e.DiagnosticCategory.Error, "Operator_0_cannot_be_applied_to_type_1_2736", "Operator '{0}' cannot be applied to type '{1}'."), BigInt_literals_are_not_available_when_targeting_lower_than_ES2020: a(2737, e.DiagnosticCategory.Error, "BigInt_literals_are_not_available_when_targeting_lower_than_ES2020_2737", "BigInt literals are not available when targeting lower than ES2020."), An_outer_value_of_this_is_shadowed_by_this_container: a(2738, e.DiagnosticCategory.Message, "An_outer_value_of_this_is_shadowed_by_this_container_2738", "An outer value of 'this' is shadowed by this container."), Type_0_is_missing_the_following_properties_from_type_1_Colon_2: a(2739, e.DiagnosticCategory.Error, "Type_0_is_missing_the_following_properties_from_type_1_Colon_2_2739", "Type '{0}' is missing the following properties from type '{1}': {2}"), Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more: a(2740, e.DiagnosticCategory.Error, "Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more_2740", "Type '{0}' is missing the following properties from type '{1}': {2}, and {3} more."), Property_0_is_missing_in_type_1_but_required_in_type_2: a(2741, e.DiagnosticCategory.Error, "Property_0_is_missing_in_type_1_but_required_in_type_2_2741", "Property '{0}' is missing in type '{1}' but required in type '{2}'."), The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary: a(2742, e.DiagnosticCategory.Error, "The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_a_2742", "The inferred type of '{0}' cannot be named without a reference to '{1}'. This is likely not portable. A type annotation is necessary."), No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments: a(2743, e.DiagnosticCategory.Error, "No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments_2743", "No overload expects {0} type arguments, but overloads do exist that expect either {1} or {2} type arguments."), Type_parameter_defaults_can_only_reference_previously_declared_type_parameters: a(2744, e.DiagnosticCategory.Error, "Type_parameter_defaults_can_only_reference_previously_declared_type_parameters_2744", "Type parameter defaults can only reference previously declared type parameters."), This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided: a(2745, e.DiagnosticCategory.Error, "This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_pr_2745", "This JSX tag's '{0}' prop expects type '{1}' which requires multiple children, but only a single child was provided."), This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided: a(2746, e.DiagnosticCategory.Error, "This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided_2746", "This JSX tag's '{0}' prop expects a single child of type '{1}', but multiple children were provided."), _0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2: a(2747, e.DiagnosticCategory.Error, "_0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_t_2747", "'{0}' components don't accept text as child elements. Text in JSX has the type 'string', but the expected type of '{1}' is '{2}'."), Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided: a(2748, e.DiagnosticCategory.Error, "Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided_2748", "Cannot access ambient const enums when the '--isolatedModules' flag is provided."), _0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0: a(2749, e.DiagnosticCategory.Error, "_0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0_2749", "'{0}' refers to a value, but is being used as a type here. Did you mean 'typeof {0}'?"), The_implementation_signature_is_declared_here: a(2750, e.DiagnosticCategory.Error, "The_implementation_signature_is_declared_here_2750", "The implementation signature is declared here."), Circularity_originates_in_type_at_this_location: a(2751, e.DiagnosticCategory.Error, "Circularity_originates_in_type_at_this_location_2751", "Circularity originates in type at this location."), The_first_export_default_is_here: a(2752, e.DiagnosticCategory.Error, "The_first_export_default_is_here_2752", "The first export default is here."), Another_export_default_is_here: a(2753, e.DiagnosticCategory.Error, "Another_export_default_is_here_2753", "Another export default is here."), super_may_not_use_type_arguments: a(2754, e.DiagnosticCategory.Error, "super_may_not_use_type_arguments_2754", "'super' may not use type arguments."), No_constituent_of_type_0_is_callable: a(2755, e.DiagnosticCategory.Error, "No_constituent_of_type_0_is_callable_2755", "No constituent of type '{0}' is callable."), Not_all_constituents_of_type_0_are_callable: a(2756, e.DiagnosticCategory.Error, "Not_all_constituents_of_type_0_are_callable_2756", "Not all constituents of type '{0}' are callable."), Type_0_has_no_call_signatures: a(2757, e.DiagnosticCategory.Error, "Type_0_has_no_call_signatures_2757", "Type '{0}' has no call signatures."), Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_other: a(2758, e.DiagnosticCategory.Error, "Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_2758", "Each member of the union type '{0}' has signatures, but none of those signatures are compatible with each other."), No_constituent_of_type_0_is_constructable: a(2759, e.DiagnosticCategory.Error, "No_constituent_of_type_0_is_constructable_2759", "No constituent of type '{0}' is constructable."), Not_all_constituents_of_type_0_are_constructable: a(2760, e.DiagnosticCategory.Error, "Not_all_constituents_of_type_0_are_constructable_2760", "Not all constituents of type '{0}' are constructable."), Type_0_has_no_construct_signatures: a(2761, e.DiagnosticCategory.Error, "Type_0_has_no_construct_signatures_2761", "Type '{0}' has no construct signatures."), Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_with_each_other: a(2762, e.DiagnosticCategory.Error, "Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_2762", "Each member of the union type '{0}' has construct signatures, but none of those signatures are compatible with each other."), Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_send_0: a(2763, e.DiagnosticCategory.Error, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_s_2763", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but for-of will always send '{0}'."), Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_always_send_0: a(2764, e.DiagnosticCategory.Error, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_al_2764", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but array spread will always send '{0}'."), Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring_will_always_send_0: a(2765, e.DiagnosticCategory.Error, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring__2765", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but array destructuring will always send '{0}'."), Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_containing_generator_will_always_send_0: a(2766, e.DiagnosticCategory.Error, "Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_co_2766", "Cannot delegate iteration to value because the 'next' method of its iterator expects type '{1}', but the containing generator will always send '{0}'."), The_0_property_of_an_iterator_must_be_a_method: a(2767, e.DiagnosticCategory.Error, "The_0_property_of_an_iterator_must_be_a_method_2767", "The '{0}' property of an iterator must be a method."), The_0_property_of_an_async_iterator_must_be_a_method: a(2768, e.DiagnosticCategory.Error, "The_0_property_of_an_async_iterator_must_be_a_method_2768", "The '{0}' property of an async iterator must be a method."), No_overload_matches_this_call: a(2769, e.DiagnosticCategory.Error, "No_overload_matches_this_call_2769", "No overload matches this call."), The_last_overload_gave_the_following_error: a(2770, e.DiagnosticCategory.Error, "The_last_overload_gave_the_following_error_2770", "The last overload gave the following error."), The_last_overload_is_declared_here: a(2771, e.DiagnosticCategory.Error, "The_last_overload_is_declared_here_2771", "The last overload is declared here."), Overload_0_of_1_2_gave_the_following_error: a(2772, e.DiagnosticCategory.Error, "Overload_0_of_1_2_gave_the_following_error_2772", "Overload {0} of {1}, '{2}', gave the following error."), Did_you_forget_to_use_await: a(2773, e.DiagnosticCategory.Error, "Did_you_forget_to_use_await_2773", "Did you forget to use 'await'?"), This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead: a(2774, e.DiagnosticCategory.Error, "This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_2774", "This condition will always return true since this function is always defined. Did you mean to call it instead?"), Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation: a(2775, e.DiagnosticCategory.Error, "Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation_2775", "Assertions require every name in the call target to be declared with an explicit type annotation."), Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name: a(2776, e.DiagnosticCategory.Error, "Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name_2776", "Assertions require the call target to be an identifier or qualified name."), The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access: a(2777, e.DiagnosticCategory.Error, "The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access_2777", "The operand of an increment or decrement operator may not be an optional property access."), The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access: a(2778, e.DiagnosticCategory.Error, "The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access_2778", "The target of an object rest assignment may not be an optional property access."), The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access: a(2779, e.DiagnosticCategory.Error, "The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access_2779", "The left-hand side of an assignment expression may not be an optional property access."), The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access: a(2780, e.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access_2780", "The left-hand side of a 'for...in' statement may not be an optional property access."), The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access: a(2781, e.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access_2781", "The left-hand side of a 'for...of' statement may not be an optional property access."), _0_needs_an_explicit_type_annotation: a(2782, e.DiagnosticCategory.Message, "_0_needs_an_explicit_type_annotation_2782", "'{0}' needs an explicit type annotation."), _0_is_specified_more_than_once_so_this_usage_will_be_overwritten: a(2783, e.DiagnosticCategory.Error, "_0_is_specified_more_than_once_so_this_usage_will_be_overwritten_2783", "'{0}' is specified more than once, so this usage will be overwritten."), get_and_set_accessors_cannot_declare_this_parameters: a(2784, e.DiagnosticCategory.Error, "get_and_set_accessors_cannot_declare_this_parameters_2784", "'get' and 'set' accessors cannot declare 'this' parameters."), This_spread_always_overwrites_this_property: a(2785, e.DiagnosticCategory.Error, "This_spread_always_overwrites_this_property_2785", "This spread always overwrites this property."), _0_cannot_be_used_as_a_JSX_component: a(2786, e.DiagnosticCategory.Error, "_0_cannot_be_used_as_a_JSX_component_2786", "'{0}' cannot be used as a JSX component."), Its_return_type_0_is_not_a_valid_JSX_element: a(2787, e.DiagnosticCategory.Error, "Its_return_type_0_is_not_a_valid_JSX_element_2787", "Its return type '{0}' is not a valid JSX element."), Its_instance_type_0_is_not_a_valid_JSX_element: a(2788, e.DiagnosticCategory.Error, "Its_instance_type_0_is_not_a_valid_JSX_element_2788", "Its instance type '{0}' is not a valid JSX element."), Its_element_type_0_is_not_a_valid_JSX_element: a(2789, e.DiagnosticCategory.Error, "Its_element_type_0_is_not_a_valid_JSX_element_2789", "Its element type '{0}' is not a valid JSX element."), The_operand_of_a_delete_operator_must_be_optional: a(2790, e.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_must_be_optional_2790", "The operand of a 'delete' operator must be optional."), Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_later: a(2791, e.DiagnosticCategory.Error, "Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_lat_2791", "Exponentiation cannot be performed on 'bigint' values unless the 'target' option is set to 'es2016' or later."), Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_node_or_to_add_aliases_to_the_paths_option: a(2792, e.DiagnosticCategory.Error, "Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_node_or_to_add_aliases_to_th_2792", "Cannot find module '{0}'. Did you mean to set the 'moduleResolution' option to 'node', or to add aliases to the 'paths' option?"), The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_are_not_externally_visible: a(2793, e.DiagnosticCategory.Error, "The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_2793", "The call would have succeeded against this implementation, but implementation signatures of overloads are not externally visible."), Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise: a(2794, e.DiagnosticCategory.Error, "Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise_2794", "Expected {0} arguments, but got {1}. Did you forget to include 'void' in your type argument to 'Promise'?"), The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types: a(2795, e.DiagnosticCategory.Error, "The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types_2795", "The 'intrinsic' keyword can only be used to declare compiler provided intrinsic types."), It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tagged_template_expression_which_cannot_be_invoked: a(2796, e.DiagnosticCategory.Error, "It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tag_2796", "It is likely that you are missing a comma to separate these two template expressions. They form a tagged template expression which cannot be invoked."), A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_be_declared_abstract: a(2797, e.DiagnosticCategory.Error, "A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_2797", "A mixin class that extends from a type variable containing an abstract construct signature must also be declared 'abstract'."), The_declaration_was_marked_as_deprecated_here: a(2798, e.DiagnosticCategory.Error, "The_declaration_was_marked_as_deprecated_here_2798", "The declaration was marked as deprecated here."), Type_produces_a_tuple_type_that_is_too_large_to_represent: a(2799, e.DiagnosticCategory.Error, "Type_produces_a_tuple_type_that_is_too_large_to_represent_2799", "Type produces a tuple type that is too large to represent."), Expression_produces_a_tuple_type_that_is_too_large_to_represent: a(2800, e.DiagnosticCategory.Error, "Expression_produces_a_tuple_type_that_is_too_large_to_represent_2800", "Expression produces a tuple type that is too large to represent."), This_condition_will_always_return_true_since_this_0_is_always_defined: a(2801, e.DiagnosticCategory.Error, "This_condition_will_always_return_true_since_this_0_is_always_defined_2801", "This condition will always return true since this '{0}' is always defined."), Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher: a(2802, e.DiagnosticCategory.Error, "Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es201_2802", "Type '{0}' can only be iterated through when using the '--downlevelIteration' flag or with a '--target' of 'es2015' or higher."), Cannot_assign_to_private_method_0_Private_methods_are_not_writable: a(2803, e.DiagnosticCategory.Error, "Cannot_assign_to_private_method_0_Private_methods_are_not_writable_2803", "Cannot assign to private method '{0}'. Private methods are not writable."), Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name: a(2804, e.DiagnosticCategory.Error, "Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name_2804", "Duplicate identifier '{0}'. Static and instance elements cannot share the same private name."), Private_accessor_was_defined_without_a_getter: a(2806, e.DiagnosticCategory.Error, "Private_accessor_was_defined_without_a_getter_2806", "Private accessor was defined without a getter."), This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0: a(2807, e.DiagnosticCategory.Error, "This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_o_2807", "This syntax requires an imported helper named '{1}' with {2} parameters, which is not compatible with the one in '{0}'. Consider upgrading your version of '{0}'."), A_get_accessor_must_be_at_least_as_accessible_as_the_setter: a(2808, e.DiagnosticCategory.Error, "A_get_accessor_must_be_at_least_as_accessible_as_the_setter_2808", "A get accessor must be at least as accessible as the setter"), Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_destructuring_assignment_you_might_need_to_wrap_the_the_whole_assignment_in_parentheses: a(2809, e.DiagnosticCategory.Error, "Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_d_2809", "Declaration or statement expected. This '=' follows a block of statements, so if you intended to write a destructuring assignment, you might need to wrap the the whole assignment in parentheses."), Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments: a(2810, e.DiagnosticCategory.Error, "Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_2810", "Expected 1 argument, but got 0. 'new Promise()' needs a JSDoc hint to produce a 'resolve' that can be called without arguments."), Initializer_for_property_0: a(2811, e.DiagnosticCategory.Error, "Initializer_for_property_0_2811", "Initializer for property '{0}'"), Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom: a(2812, e.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom_2812", "Property '{0}' does not exist on type '{1}'. Try changing the 'lib' compiler option to include 'dom'."), Class_declaration_cannot_implement_overload_list_for_0: a(2813, e.DiagnosticCategory.Error, "Class_declaration_cannot_implement_overload_list_for_0_2813", "Class declaration cannot implement overload list for '{0}'."), Function_with_bodies_can_only_merge_with_classes_that_are_ambient: a(2814, e.DiagnosticCategory.Error, "Function_with_bodies_can_only_merge_with_classes_that_are_ambient_2814", "Function with bodies can only merge with classes that are ambient."), arguments_cannot_be_referenced_in_property_initializers: a(2815, e.DiagnosticCategory.Error, "arguments_cannot_be_referenced_in_property_initializers_2815", "'arguments' cannot be referenced in property initializers."), Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class: a(2816, e.DiagnosticCategory.Error, "Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class_2816", "Cannot use 'this' in a static property initializer of a decorated class."), Property_0_has_no_initializer_and_is_not_definitely_assigned_in_a_class_static_block: a(2817, e.DiagnosticCategory.Error, "Property_0_has_no_initializer_and_is_not_definitely_assigned_in_a_class_static_block_2817", "Property '{0}' has no initializer and is not definitely assigned in a class static block."), Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializers: a(2818, e.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializer_2818", "Duplicate identifier '{0}'. Compiler reserves name '{1}' when emitting 'super' references in static initializers."), Namespace_name_cannot_be_0: a(2819, e.DiagnosticCategory.Error, "Namespace_name_cannot_be_0_2819", "Namespace name cannot be '{0}'."), Type_0_is_not_assignable_to_type_1_Did_you_mean_2: a(2820, e.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_Did_you_mean_2_2820", "Type '{0}' is not assignable to type '{1}'. Did you mean '{2}'?"), Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_or_nodenext: a(2821, e.DiagnosticCategory.Error, "Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_or_nodenext_2821", "Import assertions are only supported when the '--module' option is set to 'esnext' or 'nodenext'."), Import_assertions_cannot_be_used_with_type_only_imports_or_exports: a(2822, e.DiagnosticCategory.Error, "Import_assertions_cannot_be_used_with_type_only_imports_or_exports_2822", "Import assertions cannot be used with type-only imports or exports."), Cannot_find_namespace_0_Did_you_mean_1: a(2833, e.DiagnosticCategory.Error, "Cannot_find_namespace_0_Did_you_mean_1_2833", "Cannot find namespace '{0}'. Did you mean '{1}'?"), Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_node16_or_nodenext_Consider_adding_an_extension_to_the_import_path: a(2834, e.DiagnosticCategory.Error, "Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_n_2834", "Relative import paths need explicit file extensions in EcmaScript imports when '--moduleResolution' is 'node16' or 'nodenext'. Consider adding an extension to the import path."), Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_node16_or_nodenext_Did_you_mean_0: a(2835, e.DiagnosticCategory.Error, "Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_n_2835", "Relative import paths need explicit file extensions in EcmaScript imports when '--moduleResolution' is 'node16' or 'nodenext'. Did you mean '{0}'?"), Import_assertions_are_not_allowed_on_statements_that_transpile_to_commonjs_require_calls: a(2836, e.DiagnosticCategory.Error, "Import_assertions_are_not_allowed_on_statements_that_transpile_to_commonjs_require_calls_2836", "Import assertions are not allowed on statements that transpile to commonjs 'require' calls."), Import_assertion_values_must_be_string_literal_expressions: a(2837, e.DiagnosticCategory.Error, "Import_assertion_values_must_be_string_literal_expressions_2837", "Import assertion values must be string literal expressions."), All_declarations_of_0_must_have_identical_constraints: a(2838, e.DiagnosticCategory.Error, "All_declarations_of_0_must_have_identical_constraints_2838", "All declarations of '{0}' must have identical constraints."), Import_declaration_0_is_using_private_name_1: a(4e3, e.DiagnosticCategory.Error, "Import_declaration_0_is_using_private_name_1_4000", "Import declaration '{0}' is using private name '{1}'."), Type_parameter_0_of_exported_class_has_or_is_using_private_name_1: a(4002, e.DiagnosticCategory.Error, "Type_parameter_0_of_exported_class_has_or_is_using_private_name_1_4002", "Type parameter '{0}' of exported class has or is using private name '{1}'."), Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1: a(4004, e.DiagnosticCategory.Error, "Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1_4004", "Type parameter '{0}' of exported interface has or is using private name '{1}'."), Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1: a(4006, e.DiagnosticCategory.Error, "Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4006", "Type parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."), Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1: a(4008, e.DiagnosticCategory.Error, "Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4008", "Type parameter '{0}' of call signature from exported interface has or is using private name '{1}'."), Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1: a(4010, e.DiagnosticCategory.Error, "Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4010", "Type parameter '{0}' of public static method from exported class has or is using private name '{1}'."), Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1: a(4012, e.DiagnosticCategory.Error, "Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4012", "Type parameter '{0}' of public method from exported class has or is using private name '{1}'."), Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1: a(4014, e.DiagnosticCategory.Error, "Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4014", "Type parameter '{0}' of method from exported interface has or is using private name '{1}'."), Type_parameter_0_of_exported_function_has_or_is_using_private_name_1: a(4016, e.DiagnosticCategory.Error, "Type_parameter_0_of_exported_function_has_or_is_using_private_name_1_4016", "Type parameter '{0}' of exported function has or is using private name '{1}'."), Implements_clause_of_exported_class_0_has_or_is_using_private_name_1: a(4019, e.DiagnosticCategory.Error, "Implements_clause_of_exported_class_0_has_or_is_using_private_name_1_4019", "Implements clause of exported class '{0}' has or is using private name '{1}'."), extends_clause_of_exported_class_0_has_or_is_using_private_name_1: a(4020, e.DiagnosticCategory.Error, "extends_clause_of_exported_class_0_has_or_is_using_private_name_1_4020", "'extends' clause of exported class '{0}' has or is using private name '{1}'."), extends_clause_of_exported_class_has_or_is_using_private_name_0: a(4021, e.DiagnosticCategory.Error, "extends_clause_of_exported_class_has_or_is_using_private_name_0_4021", "'extends' clause of exported class has or is using private name '{0}'."), extends_clause_of_exported_interface_0_has_or_is_using_private_name_1: a(4022, e.DiagnosticCategory.Error, "extends_clause_of_exported_interface_0_has_or_is_using_private_name_1_4022", "'extends' clause of exported interface '{0}' has or is using private name '{1}'."), Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4023, e.DiagnosticCategory.Error, "Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4023", "Exported variable '{0}' has or is using name '{1}' from external module {2} but cannot be named."), Exported_variable_0_has_or_is_using_name_1_from_private_module_2: a(4024, e.DiagnosticCategory.Error, "Exported_variable_0_has_or_is_using_name_1_from_private_module_2_4024", "Exported variable '{0}' has or is using name '{1}' from private module '{2}'."), Exported_variable_0_has_or_is_using_private_name_1: a(4025, e.DiagnosticCategory.Error, "Exported_variable_0_has_or_is_using_private_name_1_4025", "Exported variable '{0}' has or is using private name '{1}'."), Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4026, e.DiagnosticCategory.Error, "Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot__4026", "Public static property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."), Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: a(4027, e.DiagnosticCategory.Error, "Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4027", "Public static property '{0}' of exported class has or is using name '{1}' from private module '{2}'."), Public_static_property_0_of_exported_class_has_or_is_using_private_name_1: a(4028, e.DiagnosticCategory.Error, "Public_static_property_0_of_exported_class_has_or_is_using_private_name_1_4028", "Public static property '{0}' of exported class has or is using private name '{1}'."), Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4029, e.DiagnosticCategory.Error, "Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_name_4029", "Public property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."), Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: a(4030, e.DiagnosticCategory.Error, "Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4030", "Public property '{0}' of exported class has or is using name '{1}' from private module '{2}'."), Public_property_0_of_exported_class_has_or_is_using_private_name_1: a(4031, e.DiagnosticCategory.Error, "Public_property_0_of_exported_class_has_or_is_using_private_name_1_4031", "Public property '{0}' of exported class has or is using private name '{1}'."), Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2: a(4032, e.DiagnosticCategory.Error, "Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4032", "Property '{0}' of exported interface has or is using name '{1}' from private module '{2}'."), Property_0_of_exported_interface_has_or_is_using_private_name_1: a(4033, e.DiagnosticCategory.Error, "Property_0_of_exported_interface_has_or_is_using_private_name_1_4033", "Property '{0}' of exported interface has or is using private name '{1}'."), Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: a(4034, e.DiagnosticCategory.Error, "Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_mod_4034", "Parameter type of public static setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."), Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1: a(4035, e.DiagnosticCategory.Error, "Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1_4035", "Parameter type of public static setter '{0}' from exported class has or is using private name '{1}'."), Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: a(4036, e.DiagnosticCategory.Error, "Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4036", "Parameter type of public setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."), Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1: a(4037, e.DiagnosticCategory.Error, "Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1_4037", "Parameter type of public setter '{0}' from exported class has or is using private name '{1}'."), Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4038, e.DiagnosticCategory.Error, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_modul_4038", "Return type of public static getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."), Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: a(4039, e.DiagnosticCategory.Error, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_4039", "Return type of public static getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."), Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1: a(4040, e.DiagnosticCategory.Error, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1_4040", "Return type of public static getter '{0}' from exported class has or is using private name '{1}'."), Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4041, e.DiagnosticCategory.Error, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_4041", "Return type of public getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."), Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: a(4042, e.DiagnosticCategory.Error, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4042", "Return type of public getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."), Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1: a(4043, e.DiagnosticCategory.Error, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1_4043", "Return type of public getter '{0}' from exported class has or is using private name '{1}'."), Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: a(4044, e.DiagnosticCategory.Error, "Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_mod_4044", "Return type of constructor signature from exported interface has or is using name '{0}' from private module '{1}'."), Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0: a(4045, e.DiagnosticCategory.Error, "Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0_4045", "Return type of constructor signature from exported interface has or is using private name '{0}'."), Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: a(4046, e.DiagnosticCategory.Error, "Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4046", "Return type of call signature from exported interface has or is using name '{0}' from private module '{1}'."), Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0: a(4047, e.DiagnosticCategory.Error, "Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0_4047", "Return type of call signature from exported interface has or is using private name '{0}'."), Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: a(4048, e.DiagnosticCategory.Error, "Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4048", "Return type of index signature from exported interface has or is using name '{0}' from private module '{1}'."), Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0: a(4049, e.DiagnosticCategory.Error, "Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0_4049", "Return type of index signature from exported interface has or is using private name '{0}'."), Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: a(4050, e.DiagnosticCategory.Error, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module__4050", "Return type of public static method from exported class has or is using name '{0}' from external module {1} but cannot be named."), Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1: a(4051, e.DiagnosticCategory.Error, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4051", "Return type of public static method from exported class has or is using name '{0}' from private module '{1}'."), Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0: a(4052, e.DiagnosticCategory.Error, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0_4052", "Return type of public static method from exported class has or is using private name '{0}'."), Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: a(4053, e.DiagnosticCategory.Error, "Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_c_4053", "Return type of public method from exported class has or is using name '{0}' from external module {1} but cannot be named."), Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1: a(4054, e.DiagnosticCategory.Error, "Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4054", "Return type of public method from exported class has or is using name '{0}' from private module '{1}'."), Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0: a(4055, e.DiagnosticCategory.Error, "Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0_4055", "Return type of public method from exported class has or is using private name '{0}'."), Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1: a(4056, e.DiagnosticCategory.Error, "Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4056", "Return type of method from exported interface has or is using name '{0}' from private module '{1}'."), Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0: a(4057, e.DiagnosticCategory.Error, "Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0_4057", "Return type of method from exported interface has or is using private name '{0}'."), Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: a(4058, e.DiagnosticCategory.Error, "Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named_4058", "Return type of exported function has or is using name '{0}' from external module {1} but cannot be named."), Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1: a(4059, e.DiagnosticCategory.Error, "Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1_4059", "Return type of exported function has or is using name '{0}' from private module '{1}'."), Return_type_of_exported_function_has_or_is_using_private_name_0: a(4060, e.DiagnosticCategory.Error, "Return_type_of_exported_function_has_or_is_using_private_name_0_4060", "Return type of exported function has or is using private name '{0}'."), Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4061, e.DiagnosticCategory.Error, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_can_4061", "Parameter '{0}' of constructor from exported class has or is using name '{1}' from external module {2} but cannot be named."), Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2: a(4062, e.DiagnosticCategory.Error, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2_4062", "Parameter '{0}' of constructor from exported class has or is using name '{1}' from private module '{2}'."), Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1: a(4063, e.DiagnosticCategory.Error, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1_4063", "Parameter '{0}' of constructor from exported class has or is using private name '{1}'."), Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: a(4064, e.DiagnosticCategory.Error, "Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_mod_4064", "Parameter '{0}' of constructor signature from exported interface has or is using name '{1}' from private module '{2}'."), Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1: a(4065, e.DiagnosticCategory.Error, "Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4065", "Parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."), Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: a(4066, e.DiagnosticCategory.Error, "Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4066", "Parameter '{0}' of call signature from exported interface has or is using name '{1}' from private module '{2}'."), Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1: a(4067, e.DiagnosticCategory.Error, "Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4067", "Parameter '{0}' of call signature from exported interface has or is using private name '{1}'."), Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4068, e.DiagnosticCategory.Error, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module__4068", "Parameter '{0}' of public static method from exported class has or is using name '{1}' from external module {2} but cannot be named."), Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2: a(4069, e.DiagnosticCategory.Error, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4069", "Parameter '{0}' of public static method from exported class has or is using name '{1}' from private module '{2}'."), Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1: a(4070, e.DiagnosticCategory.Error, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4070", "Parameter '{0}' of public static method from exported class has or is using private name '{1}'."), Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4071, e.DiagnosticCategory.Error, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_c_4071", "Parameter '{0}' of public method from exported class has or is using name '{1}' from external module {2} but cannot be named."), Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2: a(4072, e.DiagnosticCategory.Error, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4072", "Parameter '{0}' of public method from exported class has or is using name '{1}' from private module '{2}'."), Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1: a(4073, e.DiagnosticCategory.Error, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4073", "Parameter '{0}' of public method from exported class has or is using private name '{1}'."), Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2: a(4074, e.DiagnosticCategory.Error, "Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4074", "Parameter '{0}' of method from exported interface has or is using name '{1}' from private module '{2}'."), Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1: a(4075, e.DiagnosticCategory.Error, "Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4075", "Parameter '{0}' of method from exported interface has or is using private name '{1}'."), Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4076, e.DiagnosticCategory.Error, "Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4076", "Parameter '{0}' of exported function has or is using name '{1}' from external module {2} but cannot be named."), Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2: a(4077, e.DiagnosticCategory.Error, "Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2_4077", "Parameter '{0}' of exported function has or is using name '{1}' from private module '{2}'."), Parameter_0_of_exported_function_has_or_is_using_private_name_1: a(4078, e.DiagnosticCategory.Error, "Parameter_0_of_exported_function_has_or_is_using_private_name_1_4078", "Parameter '{0}' of exported function has or is using private name '{1}'."), Exported_type_alias_0_has_or_is_using_private_name_1: a(4081, e.DiagnosticCategory.Error, "Exported_type_alias_0_has_or_is_using_private_name_1_4081", "Exported type alias '{0}' has or is using private name '{1}'."), Default_export_of_the_module_has_or_is_using_private_name_0: a(4082, e.DiagnosticCategory.Error, "Default_export_of_the_module_has_or_is_using_private_name_0_4082", "Default export of the module has or is using private name '{0}'."), Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1: a(4083, e.DiagnosticCategory.Error, "Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1_4083", "Type parameter '{0}' of exported type alias has or is using private name '{1}'."), Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2: a(4084, e.DiagnosticCategory.Error, "Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2_4084", "Exported type alias '{0}' has or is using private name '{1}' from module {2}."), Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict: a(4090, e.DiagnosticCategory.Error, "Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_librar_4090", "Conflicting definitions for '{0}' found at '{1}' and '{2}'. Consider installing a specific version of this library to resolve the conflict."), Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: a(4091, e.DiagnosticCategory.Error, "Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4091", "Parameter '{0}' of index signature from exported interface has or is using name '{1}' from private module '{2}'."), Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1: a(4092, e.DiagnosticCategory.Error, "Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1_4092", "Parameter '{0}' of index signature from exported interface has or is using private name '{1}'."), Property_0_of_exported_class_expression_may_not_be_private_or_protected: a(4094, e.DiagnosticCategory.Error, "Property_0_of_exported_class_expression_may_not_be_private_or_protected_4094", "Property '{0}' of exported class expression may not be private or protected."), Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4095, e.DiagnosticCategory.Error, "Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_4095", "Public static method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."), Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: a(4096, e.DiagnosticCategory.Error, "Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4096", "Public static method '{0}' of exported class has or is using name '{1}' from private module '{2}'."), Public_static_method_0_of_exported_class_has_or_is_using_private_name_1: a(4097, e.DiagnosticCategory.Error, "Public_static_method_0_of_exported_class_has_or_is_using_private_name_1_4097", "Public static method '{0}' of exported class has or is using private name '{1}'."), Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4098, e.DiagnosticCategory.Error, "Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4098", "Public method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."), Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: a(4099, e.DiagnosticCategory.Error, "Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4099", "Public method '{0}' of exported class has or is using name '{1}' from private module '{2}'."), Public_method_0_of_exported_class_has_or_is_using_private_name_1: a(4100, e.DiagnosticCategory.Error, "Public_method_0_of_exported_class_has_or_is_using_private_name_1_4100", "Public method '{0}' of exported class has or is using private name '{1}'."), Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2: a(4101, e.DiagnosticCategory.Error, "Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4101", "Method '{0}' of exported interface has or is using name '{1}' from private module '{2}'."), Method_0_of_exported_interface_has_or_is_using_private_name_1: a(4102, e.DiagnosticCategory.Error, "Method_0_of_exported_interface_has_or_is_using_private_name_1_4102", "Method '{0}' of exported interface has or is using private name '{1}'."), Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1: a(4103, e.DiagnosticCategory.Error, "Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1_4103", "Type parameter '{0}' of exported mapped object type is using private name '{1}'."), The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1: a(4104, e.DiagnosticCategory.Error, "The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1_4104", "The type '{0}' is 'readonly' and cannot be assigned to the mutable type '{1}'."), Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter: a(4105, e.DiagnosticCategory.Error, "Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter_4105", "Private or protected member '{0}' cannot be accessed on a type parameter."), Parameter_0_of_accessor_has_or_is_using_private_name_1: a(4106, e.DiagnosticCategory.Error, "Parameter_0_of_accessor_has_or_is_using_private_name_1_4106", "Parameter '{0}' of accessor has or is using private name '{1}'."), Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2: a(4107, e.DiagnosticCategory.Error, "Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2_4107", "Parameter '{0}' of accessor has or is using name '{1}' from private module '{2}'."), Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4108, e.DiagnosticCategory.Error, "Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4108", "Parameter '{0}' of accessor has or is using name '{1}' from external module '{2}' but cannot be named."), Type_arguments_for_0_circularly_reference_themselves: a(4109, e.DiagnosticCategory.Error, "Type_arguments_for_0_circularly_reference_themselves_4109", "Type arguments for '{0}' circularly reference themselves."), Tuple_type_arguments_circularly_reference_themselves: a(4110, e.DiagnosticCategory.Error, "Tuple_type_arguments_circularly_reference_themselves_4110", "Tuple type arguments circularly reference themselves."), Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0: a(4111, e.DiagnosticCategory.Error, "Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0_4111", "Property '{0}' comes from an index signature, so it must be accessed with ['{0}']."), This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class: a(4112, e.DiagnosticCategory.Error, "This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another__4112", "This member cannot have an 'override' modifier because its containing class '{0}' does not extend another class."), This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0: a(4113, e.DiagnosticCategory.Error, "This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_4113", "This member cannot have an 'override' modifier because it is not declared in the base class '{0}'."), This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0: a(4114, e.DiagnosticCategory.Error, "This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0_4114", "This member must have an 'override' modifier because it overrides a member in the base class '{0}'."), This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0: a(4115, e.DiagnosticCategory.Error, "This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0_4115", "This parameter property must have an 'override' modifier because it overrides a member in base class '{0}'."), This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0: a(4116, e.DiagnosticCategory.Error, "This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared__4116", "This member must have an 'override' modifier because it overrides an abstract method that is declared in the base class '{0}'."), This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1: a(4117, e.DiagnosticCategory.Error, "This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you__4117", "This member cannot have an 'override' modifier because it is not declared in the base class '{0}'. Did you mean '{1}'?"), The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized: a(4118, e.DiagnosticCategory.Error, "The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized_4118", "The type of this node cannot be serialized because its property '{0}' cannot be serialized."), This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0: a(4119, e.DiagnosticCategory.Error, "This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_4119", "This member must have a JSDoc comment with an '@override' tag because it overrides a member in the base class '{0}'."), This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0: a(4120, e.DiagnosticCategory.Error, "This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_4120", "This parameter property must have a JSDoc comment with an '@override' tag because it overrides a member in the base class '{0}'."), This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class: a(4121, e.DiagnosticCategory.Error, "This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_4121", "This member cannot have a JSDoc comment with an '@override' tag because its containing class '{0}' does not extend another class."), This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0: a(4122, e.DiagnosticCategory.Error, "This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base__4122", "This member cannot have a JSDoc comment with an '@override' tag because it is not declared in the base class '{0}'."), This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1: a(4123, e.DiagnosticCategory.Error, "This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base__4123", "This member cannot have a JSDoc comment with an 'override' tag because it is not declared in the base class '{0}'. Did you mean '{1}'?"), Compiler_option_0_of_value_1_is_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next: a(4124, e.DiagnosticCategory.Error, "Compiler_option_0_of_value_1_is_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_w_4124", "Compiler option '{0}' of value '{1}' is unstable. Use nightly TypeScript to silence this error. Try updating with 'npm install -D typescript@next'."), Resolution_mode_assertions_are_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next: a(4125, e.DiagnosticCategory.Error, "Resolution_mode_assertions_are_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_wi_4125", "Resolution mode assertions are unstable. Use nightly TypeScript to silence this error. Try updating with 'npm install -D typescript@next'."), The_current_host_does_not_support_the_0_option: a(5001, e.DiagnosticCategory.Error, "The_current_host_does_not_support_the_0_option_5001", "The current host does not support the '{0}' option."), Cannot_find_the_common_subdirectory_path_for_the_input_files: a(5009, e.DiagnosticCategory.Error, "Cannot_find_the_common_subdirectory_path_for_the_input_files_5009", "Cannot find the common subdirectory path for the input files."), File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0: a(5010, e.DiagnosticCategory.Error, "File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0_5010", "File specification cannot end in a recursive directory wildcard ('**'): '{0}'."), Cannot_read_file_0_Colon_1: a(5012, e.DiagnosticCategory.Error, "Cannot_read_file_0_Colon_1_5012", "Cannot read file '{0}': {1}."), Failed_to_parse_file_0_Colon_1: a(5014, e.DiagnosticCategory.Error, "Failed_to_parse_file_0_Colon_1_5014", "Failed to parse file '{0}': {1}."), Unknown_compiler_option_0: a(5023, e.DiagnosticCategory.Error, "Unknown_compiler_option_0_5023", "Unknown compiler option '{0}'."), Compiler_option_0_requires_a_value_of_type_1: a(5024, e.DiagnosticCategory.Error, "Compiler_option_0_requires_a_value_of_type_1_5024", "Compiler option '{0}' requires a value of type {1}."), Unknown_compiler_option_0_Did_you_mean_1: a(5025, e.DiagnosticCategory.Error, "Unknown_compiler_option_0_Did_you_mean_1_5025", "Unknown compiler option '{0}'. Did you mean '{1}'?"), Could_not_write_file_0_Colon_1: a(5033, e.DiagnosticCategory.Error, "Could_not_write_file_0_Colon_1_5033", "Could not write file '{0}': {1}."), Option_project_cannot_be_mixed_with_source_files_on_a_command_line: a(5042, e.DiagnosticCategory.Error, "Option_project_cannot_be_mixed_with_source_files_on_a_command_line_5042", "Option 'project' cannot be mixed with source files on a command line."), Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher: a(5047, e.DiagnosticCategory.Error, "Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES_5047", "Option 'isolatedModules' can only be used when either option '--module' is provided or option 'target' is 'ES2015' or higher."), Option_0_cannot_be_specified_when_option_target_is_ES3: a(5048, e.DiagnosticCategory.Error, "Option_0_cannot_be_specified_when_option_target_is_ES3_5048", "Option '{0}' cannot be specified when option 'target' is 'ES3'."), Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided: a(5051, e.DiagnosticCategory.Error, "Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided_5051", "Option '{0} can only be used when either option '--inlineSourceMap' or option '--sourceMap' is provided."), Option_0_cannot_be_specified_without_specifying_option_1: a(5052, e.DiagnosticCategory.Error, "Option_0_cannot_be_specified_without_specifying_option_1_5052", "Option '{0}' cannot be specified without specifying option '{1}'."), Option_0_cannot_be_specified_with_option_1: a(5053, e.DiagnosticCategory.Error, "Option_0_cannot_be_specified_with_option_1_5053", "Option '{0}' cannot be specified with option '{1}'."), A_tsconfig_json_file_is_already_defined_at_Colon_0: a(5054, e.DiagnosticCategory.Error, "A_tsconfig_json_file_is_already_defined_at_Colon_0_5054", "A 'tsconfig.json' file is already defined at: '{0}'."), Cannot_write_file_0_because_it_would_overwrite_input_file: a(5055, e.DiagnosticCategory.Error, "Cannot_write_file_0_because_it_would_overwrite_input_file_5055", "Cannot write file '{0}' because it would overwrite input file."), Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files: a(5056, e.DiagnosticCategory.Error, "Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files_5056", "Cannot write file '{0}' because it would be overwritten by multiple input files."), Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0: a(5057, e.DiagnosticCategory.Error, "Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0_5057", "Cannot find a tsconfig.json file at the specified directory: '{0}'."), The_specified_path_does_not_exist_Colon_0: a(5058, e.DiagnosticCategory.Error, "The_specified_path_does_not_exist_Colon_0_5058", "The specified path does not exist: '{0}'."), Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier: a(5059, e.DiagnosticCategory.Error, "Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier_5059", "Invalid value for '--reactNamespace'. '{0}' is not a valid identifier."), Pattern_0_can_have_at_most_one_Asterisk_character: a(5061, e.DiagnosticCategory.Error, "Pattern_0_can_have_at_most_one_Asterisk_character_5061", "Pattern '{0}' can have at most one '*' character."), Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character: a(5062, e.DiagnosticCategory.Error, "Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character_5062", "Substitution '{0}' in pattern '{1}' can have at most one '*' character."), Substitutions_for_pattern_0_should_be_an_array: a(5063, e.DiagnosticCategory.Error, "Substitutions_for_pattern_0_should_be_an_array_5063", "Substitutions for pattern '{0}' should be an array."), Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2: a(5064, e.DiagnosticCategory.Error, "Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2_5064", "Substitution '{0}' for pattern '{1}' has incorrect type, expected 'string', got '{2}'."), File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0: a(5065, e.DiagnosticCategory.Error, "File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildca_5065", "File specification cannot contain a parent directory ('..') that appears after a recursive directory wildcard ('**'): '{0}'."), Substitutions_for_pattern_0_shouldn_t_be_an_empty_array: a(5066, e.DiagnosticCategory.Error, "Substitutions_for_pattern_0_shouldn_t_be_an_empty_array_5066", "Substitutions for pattern '{0}' shouldn't be an empty array."), Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name: a(5067, e.DiagnosticCategory.Error, "Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name_5067", "Invalid value for 'jsxFactory'. '{0}' is not a valid identifier or qualified-name."), Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig: a(5068, e.DiagnosticCategory.Error, "Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript__5068", "Adding a tsconfig.json file will help organize projects that contain both TypeScript and JavaScript files. Learn more at https://aka.ms/tsconfig."), Option_0_cannot_be_specified_without_specifying_option_1_or_option_2: a(5069, e.DiagnosticCategory.Error, "Option_0_cannot_be_specified_without_specifying_option_1_or_option_2_5069", "Option '{0}' cannot be specified without specifying option '{1}' or option '{2}'."), Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy: a(5070, e.DiagnosticCategory.Error, "Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy_5070", "Option '--resolveJsonModule' cannot be specified without 'node' module resolution strategy."), Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_esNext: a(5071, e.DiagnosticCategory.Error, "Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_5071", "Option '--resolveJsonModule' can only be specified when module code generation is 'commonjs', 'amd', 'es2015' or 'esNext'."), Unknown_build_option_0: a(5072, e.DiagnosticCategory.Error, "Unknown_build_option_0_5072", "Unknown build option '{0}'."), Build_option_0_requires_a_value_of_type_1: a(5073, e.DiagnosticCategory.Error, "Build_option_0_requires_a_value_of_type_1_5073", "Build option '{0}' requires a value of type {1}."), Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified: a(5074, e.DiagnosticCategory.Error, "Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBui_5074", "Option '--incremental' can only be specified using tsconfig, emitting to single file or when option '--tsBuildInfoFile' is specified."), _0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2: a(5075, e.DiagnosticCategory.Error, "_0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_5075", "'{0}' is assignable to the constraint of type '{1}', but '{1}' could be instantiated with a different subtype of constraint '{2}'."), _0_and_1_operations_cannot_be_mixed_without_parentheses: a(5076, e.DiagnosticCategory.Error, "_0_and_1_operations_cannot_be_mixed_without_parentheses_5076", "'{0}' and '{1}' operations cannot be mixed without parentheses."), Unknown_build_option_0_Did_you_mean_1: a(5077, e.DiagnosticCategory.Error, "Unknown_build_option_0_Did_you_mean_1_5077", "Unknown build option '{0}'. Did you mean '{1}'?"), Unknown_watch_option_0: a(5078, e.DiagnosticCategory.Error, "Unknown_watch_option_0_5078", "Unknown watch option '{0}'."), Unknown_watch_option_0_Did_you_mean_1: a(5079, e.DiagnosticCategory.Error, "Unknown_watch_option_0_Did_you_mean_1_5079", "Unknown watch option '{0}'. Did you mean '{1}'?"), Watch_option_0_requires_a_value_of_type_1: a(5080, e.DiagnosticCategory.Error, "Watch_option_0_requires_a_value_of_type_1_5080", "Watch option '{0}' requires a value of type {1}."), Cannot_find_a_tsconfig_json_file_at_the_current_directory_Colon_0: a(5081, e.DiagnosticCategory.Error, "Cannot_find_a_tsconfig_json_file_at_the_current_directory_Colon_0_5081", "Cannot find a tsconfig.json file at the current directory: {0}."), _0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1: a(5082, e.DiagnosticCategory.Error, "_0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1_5082", "'{0}' could be instantiated with an arbitrary type which could be unrelated to '{1}'."), Cannot_read_file_0: a(5083, e.DiagnosticCategory.Error, "Cannot_read_file_0_5083", "Cannot read file '{0}'."), Tuple_members_must_all_have_names_or_all_not_have_names: a(5084, e.DiagnosticCategory.Error, "Tuple_members_must_all_have_names_or_all_not_have_names_5084", "Tuple members must all have names or all not have names."), A_tuple_member_cannot_be_both_optional_and_rest: a(5085, e.DiagnosticCategory.Error, "A_tuple_member_cannot_be_both_optional_and_rest_5085", "A tuple member cannot be both optional and rest."), A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type: a(5086, e.DiagnosticCategory.Error, "A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_c_5086", "A labeled tuple element is declared as optional with a question mark after the name and before the colon, rather than after the type."), A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type: a(5087, e.DiagnosticCategory.Error, "A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type_5087", "A labeled tuple element is declared as rest with a '...' before the name, rather than before the type."), The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialized_A_type_annotation_is_necessary: a(5088, e.DiagnosticCategory.Error, "The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialize_5088", "The inferred type of '{0}' references a type with a cyclic structure which cannot be trivially serialized. A type annotation is necessary."), Option_0_cannot_be_specified_when_option_jsx_is_1: a(5089, e.DiagnosticCategory.Error, "Option_0_cannot_be_specified_when_option_jsx_is_1_5089", "Option '{0}' cannot be specified when option 'jsx' is '{1}'."), Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash: a(5090, e.DiagnosticCategory.Error, "Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash_5090", "Non-relative paths are not allowed when 'baseUrl' is not set. Did you forget a leading './'?"), Option_preserveConstEnums_cannot_be_disabled_when_isolatedModules_is_enabled: a(5091, e.DiagnosticCategory.Error, "Option_preserveConstEnums_cannot_be_disabled_when_isolatedModules_is_enabled_5091", "Option 'preserveConstEnums' cannot be disabled when 'isolatedModules' is enabled."), The_root_value_of_a_0_file_must_be_an_object: a(5092, e.DiagnosticCategory.Error, "The_root_value_of_a_0_file_must_be_an_object_5092", "The root value of a '{0}' file must be an object."), Compiler_option_0_may_only_be_used_with_build: a(5093, e.DiagnosticCategory.Error, "Compiler_option_0_may_only_be_used_with_build_5093", "Compiler option '--{0}' may only be used with '--build'."), Compiler_option_0_may_not_be_used_with_build: a(5094, e.DiagnosticCategory.Error, "Compiler_option_0_may_not_be_used_with_build_5094", "Compiler option '--{0}' may not be used with '--build'."), Option_preserveValueImports_can_only_be_used_when_module_is_set_to_es2015_or_later: a(5095, e.DiagnosticCategory.Error, "Option_preserveValueImports_can_only_be_used_when_module_is_set_to_es2015_or_later_5095", "Option 'preserveValueImports' can only be used when 'module' is set to 'es2015' or later."), Generates_a_sourcemap_for_each_corresponding_d_ts_file: a(6e3, e.DiagnosticCategory.Message, "Generates_a_sourcemap_for_each_corresponding_d_ts_file_6000", "Generates a sourcemap for each corresponding '.d.ts' file."), Concatenate_and_emit_output_to_single_file: a(6001, e.DiagnosticCategory.Message, "Concatenate_and_emit_output_to_single_file_6001", "Concatenate and emit output to single file."), Generates_corresponding_d_ts_file: a(6002, e.DiagnosticCategory.Message, "Generates_corresponding_d_ts_file_6002", "Generates corresponding '.d.ts' file."), Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations: a(6004, e.DiagnosticCategory.Message, "Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations_6004", "Specify the location where debugger should locate TypeScript files instead of source locations."), Watch_input_files: a(6005, e.DiagnosticCategory.Message, "Watch_input_files_6005", "Watch input files."), Redirect_output_structure_to_the_directory: a(6006, e.DiagnosticCategory.Message, "Redirect_output_structure_to_the_directory_6006", "Redirect output structure to the directory."), Do_not_erase_const_enum_declarations_in_generated_code: a(6007, e.DiagnosticCategory.Message, "Do_not_erase_const_enum_declarations_in_generated_code_6007", "Do not erase const enum declarations in generated code."), Do_not_emit_outputs_if_any_errors_were_reported: a(6008, e.DiagnosticCategory.Message, "Do_not_emit_outputs_if_any_errors_were_reported_6008", "Do not emit outputs if any errors were reported."), Do_not_emit_comments_to_output: a(6009, e.DiagnosticCategory.Message, "Do_not_emit_comments_to_output_6009", "Do not emit comments to output."), Do_not_emit_outputs: a(6010, e.DiagnosticCategory.Message, "Do_not_emit_outputs_6010", "Do not emit outputs."), Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typechecking: a(6011, e.DiagnosticCategory.Message, "Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typech_6011", "Allow default imports from modules with no default export. This does not affect code emit, just typechecking."), Skip_type_checking_of_declaration_files: a(6012, e.DiagnosticCategory.Message, "Skip_type_checking_of_declaration_files_6012", "Skip type checking of declaration files."), Do_not_resolve_the_real_path_of_symlinks: a(6013, e.DiagnosticCategory.Message, "Do_not_resolve_the_real_path_of_symlinks_6013", "Do not resolve the real path of symlinks."), Only_emit_d_ts_declaration_files: a(6014, e.DiagnosticCategory.Message, "Only_emit_d_ts_declaration_files_6014", "Only emit '.d.ts' declaration files."), Specify_ECMAScript_target_version: a(6015, e.DiagnosticCategory.Message, "Specify_ECMAScript_target_version_6015", "Specify ECMAScript target version."), Specify_module_code_generation: a(6016, e.DiagnosticCategory.Message, "Specify_module_code_generation_6016", "Specify module code generation."), Print_this_message: a(6017, e.DiagnosticCategory.Message, "Print_this_message_6017", "Print this message."), Print_the_compiler_s_version: a(6019, e.DiagnosticCategory.Message, "Print_the_compiler_s_version_6019", "Print the compiler's version."), Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json: a(6020, e.DiagnosticCategory.Message, "Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json_6020", "Compile the project given the path to its configuration file, or to a folder with a 'tsconfig.json'."), Syntax_Colon_0: a(6023, e.DiagnosticCategory.Message, "Syntax_Colon_0_6023", "Syntax: {0}"), options: a(6024, e.DiagnosticCategory.Message, "options_6024", "options"), file: a(6025, e.DiagnosticCategory.Message, "file_6025", "file"), Examples_Colon_0: a(6026, e.DiagnosticCategory.Message, "Examples_Colon_0_6026", "Examples: {0}"), Options_Colon: a(6027, e.DiagnosticCategory.Message, "Options_Colon_6027", "Options:"), Version_0: a(6029, e.DiagnosticCategory.Message, "Version_0_6029", "Version {0}"), Insert_command_line_options_and_files_from_a_file: a(6030, e.DiagnosticCategory.Message, "Insert_command_line_options_and_files_from_a_file_6030", "Insert command line options and files from a file."), Starting_compilation_in_watch_mode: a(6031, e.DiagnosticCategory.Message, "Starting_compilation_in_watch_mode_6031", "Starting compilation in watch mode..."), File_change_detected_Starting_incremental_compilation: a(6032, e.DiagnosticCategory.Message, "File_change_detected_Starting_incremental_compilation_6032", "File change detected. Starting incremental compilation..."), KIND: a(6034, e.DiagnosticCategory.Message, "KIND_6034", "KIND"), FILE: a(6035, e.DiagnosticCategory.Message, "FILE_6035", "FILE"), VERSION: a(6036, e.DiagnosticCategory.Message, "VERSION_6036", "VERSION"), LOCATION: a(6037, e.DiagnosticCategory.Message, "LOCATION_6037", "LOCATION"), DIRECTORY: a(6038, e.DiagnosticCategory.Message, "DIRECTORY_6038", "DIRECTORY"), STRATEGY: a(6039, e.DiagnosticCategory.Message, "STRATEGY_6039", "STRATEGY"), FILE_OR_DIRECTORY: a(6040, e.DiagnosticCategory.Message, "FILE_OR_DIRECTORY_6040", "FILE OR DIRECTORY"), Errors_Files: a(6041, e.DiagnosticCategory.Message, "Errors_Files_6041", "Errors  Files"), Generates_corresponding_map_file: a(6043, e.DiagnosticCategory.Message, "Generates_corresponding_map_file_6043", "Generates corresponding '.map' file."), Compiler_option_0_expects_an_argument: a(6044, e.DiagnosticCategory.Error, "Compiler_option_0_expects_an_argument_6044", "Compiler option '{0}' expects an argument."), Unterminated_quoted_string_in_response_file_0: a(6045, e.DiagnosticCategory.Error, "Unterminated_quoted_string_in_response_file_0_6045", "Unterminated quoted string in response file '{0}'."), Argument_for_0_option_must_be_Colon_1: a(6046, e.DiagnosticCategory.Error, "Argument_for_0_option_must_be_Colon_1_6046", "Argument for '{0}' option must be: {1}."), Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1: a(6048, e.DiagnosticCategory.Error, "Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1_6048", "Locale must be of the form <language> or <language>-<territory>. For example '{0}' or '{1}'."), Unable_to_open_file_0: a(6050, e.DiagnosticCategory.Error, "Unable_to_open_file_0_6050", "Unable to open file '{0}'."), Corrupted_locale_file_0: a(6051, e.DiagnosticCategory.Error, "Corrupted_locale_file_0_6051", "Corrupted locale file {0}."), Raise_error_on_expressions_and_declarations_with_an_implied_any_type: a(6052, e.DiagnosticCategory.Message, "Raise_error_on_expressions_and_declarations_with_an_implied_any_type_6052", "Raise error on expressions and declarations with an implied 'any' type."), File_0_not_found: a(6053, e.DiagnosticCategory.Error, "File_0_not_found_6053", "File '{0}' not found."), File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1: a(6054, e.DiagnosticCategory.Error, "File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1_6054", "File '{0}' has an unsupported extension. The only supported extensions are {1}."), Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures: a(6055, e.DiagnosticCategory.Message, "Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures_6055", "Suppress noImplicitAny errors for indexing objects lacking index signatures."), Do_not_emit_declarations_for_code_that_has_an_internal_annotation: a(6056, e.DiagnosticCategory.Message, "Do_not_emit_declarations_for_code_that_has_an_internal_annotation_6056", "Do not emit declarations for code that has an '@internal' annotation."), Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir: a(6058, e.DiagnosticCategory.Message, "Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir_6058", "Specify the root directory of input files. Use to control the output directory structure with --outDir."), File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files: a(6059, e.DiagnosticCategory.Error, "File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files_6059", "File '{0}' is not under 'rootDir' '{1}'. 'rootDir' is expected to contain all source files."), Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix: a(6060, e.DiagnosticCategory.Message, "Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix_6060", "Specify the end of line sequence to be used when emitting files: 'CRLF' (dos) or 'LF' (unix)."), NEWLINE: a(6061, e.DiagnosticCategory.Message, "NEWLINE_6061", "NEWLINE"), Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line: a(6064, e.DiagnosticCategory.Error, "Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line_6064", "Option '{0}' can only be specified in 'tsconfig.json' file or set to 'null' on command line."), Enables_experimental_support_for_ES7_decorators: a(6065, e.DiagnosticCategory.Message, "Enables_experimental_support_for_ES7_decorators_6065", "Enables experimental support for ES7 decorators."), Enables_experimental_support_for_emitting_type_metadata_for_decorators: a(6066, e.DiagnosticCategory.Message, "Enables_experimental_support_for_emitting_type_metadata_for_decorators_6066", "Enables experimental support for emitting type metadata for decorators."), Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6: a(6069, e.DiagnosticCategory.Message, "Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6_6069", "Specify module resolution strategy: 'node' (Node.js) or 'classic' (TypeScript pre-1.6)."), Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file: a(6070, e.DiagnosticCategory.Message, "Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file_6070", "Initializes a TypeScript project and creates a tsconfig.json file."), Successfully_created_a_tsconfig_json_file: a(6071, e.DiagnosticCategory.Message, "Successfully_created_a_tsconfig_json_file_6071", "Successfully created a tsconfig.json file."), Suppress_excess_property_checks_for_object_literals: a(6072, e.DiagnosticCategory.Message, "Suppress_excess_property_checks_for_object_literals_6072", "Suppress excess property checks for object literals."), Stylize_errors_and_messages_using_color_and_context_experimental: a(6073, e.DiagnosticCategory.Message, "Stylize_errors_and_messages_using_color_and_context_experimental_6073", "Stylize errors and messages using color and context (experimental)."), Do_not_report_errors_on_unused_labels: a(6074, e.DiagnosticCategory.Message, "Do_not_report_errors_on_unused_labels_6074", "Do not report errors on unused labels."), Report_error_when_not_all_code_paths_in_function_return_a_value: a(6075, e.DiagnosticCategory.Message, "Report_error_when_not_all_code_paths_in_function_return_a_value_6075", "Report error when not all code paths in function return a value."), Report_errors_for_fallthrough_cases_in_switch_statement: a(6076, e.DiagnosticCategory.Message, "Report_errors_for_fallthrough_cases_in_switch_statement_6076", "Report errors for fallthrough cases in switch statement."), Do_not_report_errors_on_unreachable_code: a(6077, e.DiagnosticCategory.Message, "Do_not_report_errors_on_unreachable_code_6077", "Do not report errors on unreachable code."), Disallow_inconsistently_cased_references_to_the_same_file: a(6078, e.DiagnosticCategory.Message, "Disallow_inconsistently_cased_references_to_the_same_file_6078", "Disallow inconsistently-cased references to the same file."), Specify_library_files_to_be_included_in_the_compilation: a(6079, e.DiagnosticCategory.Message, "Specify_library_files_to_be_included_in_the_compilation_6079", "Specify library files to be included in the compilation."), Specify_JSX_code_generation: a(6080, e.DiagnosticCategory.Message, "Specify_JSX_code_generation_6080", "Specify JSX code generation."), File_0_has_an_unsupported_extension_so_skipping_it: a(6081, e.DiagnosticCategory.Message, "File_0_has_an_unsupported_extension_so_skipping_it_6081", "File '{0}' has an unsupported extension, so skipping it."), Only_amd_and_system_modules_are_supported_alongside_0: a(6082, e.DiagnosticCategory.Error, "Only_amd_and_system_modules_are_supported_alongside_0_6082", "Only 'amd' and 'system' modules are supported alongside --{0}."), Base_directory_to_resolve_non_absolute_module_names: a(6083, e.DiagnosticCategory.Message, "Base_directory_to_resolve_non_absolute_module_names_6083", "Base directory to resolve non-absolute module names."), Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react_JSX_emit: a(6084, e.DiagnosticCategory.Message, "Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react__6084", "[Deprecated] Use '--jsxFactory' instead. Specify the object invoked for createElement when targeting 'react' JSX emit"), Enable_tracing_of_the_name_resolution_process: a(6085, e.DiagnosticCategory.Message, "Enable_tracing_of_the_name_resolution_process_6085", "Enable tracing of the name resolution process."), Resolving_module_0_from_1: a(6086, e.DiagnosticCategory.Message, "Resolving_module_0_from_1_6086", "======== Resolving module '{0}' from '{1}'. ========"), Explicitly_specified_module_resolution_kind_Colon_0: a(6087, e.DiagnosticCategory.Message, "Explicitly_specified_module_resolution_kind_Colon_0_6087", "Explicitly specified module resolution kind: '{0}'."), Module_resolution_kind_is_not_specified_using_0: a(6088, e.DiagnosticCategory.Message, "Module_resolution_kind_is_not_specified_using_0_6088", "Module resolution kind is not specified, using '{0}'."), Module_name_0_was_successfully_resolved_to_1: a(6089, e.DiagnosticCategory.Message, "Module_name_0_was_successfully_resolved_to_1_6089", "======== Module name '{0}' was successfully resolved to '{1}'. ========"), Module_name_0_was_not_resolved: a(6090, e.DiagnosticCategory.Message, "Module_name_0_was_not_resolved_6090", "======== Module name '{0}' was not resolved. ========"), paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0: a(6091, e.DiagnosticCategory.Message, "paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0_6091", "'paths' option is specified, looking for a pattern to match module name '{0}'."), Module_name_0_matched_pattern_1: a(6092, e.DiagnosticCategory.Message, "Module_name_0_matched_pattern_1_6092", "Module name '{0}', matched pattern '{1}'."), Trying_substitution_0_candidate_module_location_Colon_1: a(6093, e.DiagnosticCategory.Message, "Trying_substitution_0_candidate_module_location_Colon_1_6093", "Trying substitution '{0}', candidate module location: '{1}'."), Resolving_module_name_0_relative_to_base_url_1_2: a(6094, e.DiagnosticCategory.Message, "Resolving_module_name_0_relative_to_base_url_1_2_6094", "Resolving module name '{0}' relative to base url '{1}' - '{2}'."), Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1: a(6095, e.DiagnosticCategory.Message, "Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1_6095", "Loading module as file / folder, candidate module location '{0}', target file type '{1}'."), File_0_does_not_exist: a(6096, e.DiagnosticCategory.Message, "File_0_does_not_exist_6096", "File '{0}' does not exist."), File_0_exist_use_it_as_a_name_resolution_result: a(6097, e.DiagnosticCategory.Message, "File_0_exist_use_it_as_a_name_resolution_result_6097", "File '{0}' exist - use it as a name resolution result."), Loading_module_0_from_node_modules_folder_target_file_type_1: a(6098, e.DiagnosticCategory.Message, "Loading_module_0_from_node_modules_folder_target_file_type_1_6098", "Loading module '{0}' from 'node_modules' folder, target file type '{1}'."), Found_package_json_at_0: a(6099, e.DiagnosticCategory.Message, "Found_package_json_at_0_6099", "Found 'package.json' at '{0}'."), package_json_does_not_have_a_0_field: a(6100, e.DiagnosticCategory.Message, "package_json_does_not_have_a_0_field_6100", "'package.json' does not have a '{0}' field."), package_json_has_0_field_1_that_references_2: a(6101, e.DiagnosticCategory.Message, "package_json_has_0_field_1_that_references_2_6101", "'package.json' has '{0}' field '{1}' that references '{2}'."), Allow_javascript_files_to_be_compiled: a(6102, e.DiagnosticCategory.Message, "Allow_javascript_files_to_be_compiled_6102", "Allow javascript files to be compiled."), Checking_if_0_is_the_longest_matching_prefix_for_1_2: a(6104, e.DiagnosticCategory.Message, "Checking_if_0_is_the_longest_matching_prefix_for_1_2_6104", "Checking if '{0}' is the longest matching prefix for '{1}' - '{2}'."), Expected_type_of_0_field_in_package_json_to_be_1_got_2: a(6105, e.DiagnosticCategory.Message, "Expected_type_of_0_field_in_package_json_to_be_1_got_2_6105", "Expected type of '{0}' field in 'package.json' to be '{1}', got '{2}'."), baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1: a(6106, e.DiagnosticCategory.Message, "baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1_6106", "'baseUrl' option is set to '{0}', using this value to resolve non-relative module name '{1}'."), rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0: a(6107, e.DiagnosticCategory.Message, "rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0_6107", "'rootDirs' option is set, using it to resolve relative module name '{0}'."), Longest_matching_prefix_for_0_is_1: a(6108, e.DiagnosticCategory.Message, "Longest_matching_prefix_for_0_is_1_6108", "Longest matching prefix for '{0}' is '{1}'."), Loading_0_from_the_root_dir_1_candidate_location_2: a(6109, e.DiagnosticCategory.Message, "Loading_0_from_the_root_dir_1_candidate_location_2_6109", "Loading '{0}' from the root dir '{1}', candidate location '{2}'."), Trying_other_entries_in_rootDirs: a(6110, e.DiagnosticCategory.Message, "Trying_other_entries_in_rootDirs_6110", "Trying other entries in 'rootDirs'."), Module_resolution_using_rootDirs_has_failed: a(6111, e.DiagnosticCategory.Message, "Module_resolution_using_rootDirs_has_failed_6111", "Module resolution using 'rootDirs' has failed."), Do_not_emit_use_strict_directives_in_module_output: a(6112, e.DiagnosticCategory.Message, "Do_not_emit_use_strict_directives_in_module_output_6112", "Do not emit 'use strict' directives in module output."), Enable_strict_null_checks: a(6113, e.DiagnosticCategory.Message, "Enable_strict_null_checks_6113", "Enable strict null checks."), Unknown_option_excludes_Did_you_mean_exclude: a(6114, e.DiagnosticCategory.Error, "Unknown_option_excludes_Did_you_mean_exclude_6114", "Unknown option 'excludes'. Did you mean 'exclude'?"), Raise_error_on_this_expressions_with_an_implied_any_type: a(6115, e.DiagnosticCategory.Message, "Raise_error_on_this_expressions_with_an_implied_any_type_6115", "Raise error on 'this' expressions with an implied 'any' type."), Resolving_type_reference_directive_0_containing_file_1_root_directory_2: a(6116, e.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_1_root_directory_2_6116", "======== Resolving type reference directive '{0}', containing file '{1}', root directory '{2}'. ========"), Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2: a(6119, e.DiagnosticCategory.Message, "Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2_6119", "======== Type reference directive '{0}' was successfully resolved to '{1}', primary: {2}. ========"), Type_reference_directive_0_was_not_resolved: a(6120, e.DiagnosticCategory.Message, "Type_reference_directive_0_was_not_resolved_6120", "======== Type reference directive '{0}' was not resolved. ========"), Resolving_with_primary_search_path_0: a(6121, e.DiagnosticCategory.Message, "Resolving_with_primary_search_path_0_6121", "Resolving with primary search path '{0}'."), Root_directory_cannot_be_determined_skipping_primary_search_paths: a(6122, e.DiagnosticCategory.Message, "Root_directory_cannot_be_determined_skipping_primary_search_paths_6122", "Root directory cannot be determined, skipping primary search paths."), Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set: a(6123, e.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set_6123", "======== Resolving type reference directive '{0}', containing file '{1}', root directory not set. ========"), Type_declaration_files_to_be_included_in_compilation: a(6124, e.DiagnosticCategory.Message, "Type_declaration_files_to_be_included_in_compilation_6124", "Type declaration files to be included in compilation."), Looking_up_in_node_modules_folder_initial_location_0: a(6125, e.DiagnosticCategory.Message, "Looking_up_in_node_modules_folder_initial_location_0_6125", "Looking up in 'node_modules' folder, initial location '{0}'."), Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder: a(6126, e.DiagnosticCategory.Message, "Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_mod_6126", "Containing file is not specified and root directory cannot be determined, skipping lookup in 'node_modules' folder."), Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1: a(6127, e.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1_6127", "======== Resolving type reference directive '{0}', containing file not set, root directory '{1}'. ========"), Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set: a(6128, e.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set_6128", "======== Resolving type reference directive '{0}', containing file not set, root directory not set. ========"), Resolving_real_path_for_0_result_1: a(6130, e.DiagnosticCategory.Message, "Resolving_real_path_for_0_result_1_6130", "Resolving real path for '{0}', result '{1}'."), Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system: a(6131, e.DiagnosticCategory.Error, "Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system_6131", "Cannot compile modules using option '{0}' unless the '--module' flag is 'amd' or 'system'."), File_name_0_has_a_1_extension_stripping_it: a(6132, e.DiagnosticCategory.Message, "File_name_0_has_a_1_extension_stripping_it_6132", "File name '{0}' has a '{1}' extension - stripping it."), _0_is_declared_but_its_value_is_never_read: a(6133, e.DiagnosticCategory.Error, "_0_is_declared_but_its_value_is_never_read_6133", "'{0}' is declared but its value is never read.", true), Report_errors_on_unused_locals: a(6134, e.DiagnosticCategory.Message, "Report_errors_on_unused_locals_6134", "Report errors on unused locals."), Report_errors_on_unused_parameters: a(6135, e.DiagnosticCategory.Message, "Report_errors_on_unused_parameters_6135", "Report errors on unused parameters."), The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files: a(6136, e.DiagnosticCategory.Message, "The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files_6136", "The maximum dependency depth to search under node_modules and load JavaScript files."), Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1: a(6137, e.DiagnosticCategory.Error, "Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1_6137", "Cannot import type declaration files. Consider importing '{0}' instead of '{1}'."), Property_0_is_declared_but_its_value_is_never_read: a(6138, e.DiagnosticCategory.Error, "Property_0_is_declared_but_its_value_is_never_read_6138", "Property '{0}' is declared but its value is never read.", true), Import_emit_helpers_from_tslib: a(6139, e.DiagnosticCategory.Message, "Import_emit_helpers_from_tslib_6139", "Import emit helpers from 'tslib'."), Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2: a(6140, e.DiagnosticCategory.Error, "Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using__6140", "Auto discovery for typings is enabled in project '{0}'. Running extra resolution pass for module '{1}' using cache location '{2}'."), Parse_in_strict_mode_and_emit_use_strict_for_each_source_file: a(6141, e.DiagnosticCategory.Message, "Parse_in_strict_mode_and_emit_use_strict_for_each_source_file_6141", 'Parse in strict mode and emit "use strict" for each source file.'), Module_0_was_resolved_to_1_but_jsx_is_not_set: a(6142, e.DiagnosticCategory.Error, "Module_0_was_resolved_to_1_but_jsx_is_not_set_6142", "Module '{0}' was resolved to '{1}', but '--jsx' is not set."), Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1: a(6144, e.DiagnosticCategory.Message, "Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1_6144", "Module '{0}' was resolved as locally declared ambient module in file '{1}'."), Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified: a(6145, e.DiagnosticCategory.Message, "Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified_6145", "Module '{0}' was resolved as ambient module declared in '{1}' since this file was not modified."), Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h: a(6146, e.DiagnosticCategory.Message, "Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h_6146", "Specify the JSX factory function to use when targeting 'react' JSX emit, e.g. 'React.createElement' or 'h'."), Resolution_for_module_0_was_found_in_cache_from_location_1: a(6147, e.DiagnosticCategory.Message, "Resolution_for_module_0_was_found_in_cache_from_location_1_6147", "Resolution for module '{0}' was found in cache from location '{1}'."), Directory_0_does_not_exist_skipping_all_lookups_in_it: a(6148, e.DiagnosticCategory.Message, "Directory_0_does_not_exist_skipping_all_lookups_in_it_6148", "Directory '{0}' does not exist, skipping all lookups in it."), Show_diagnostic_information: a(6149, e.DiagnosticCategory.Message, "Show_diagnostic_information_6149", "Show diagnostic information."), Show_verbose_diagnostic_information: a(6150, e.DiagnosticCategory.Message, "Show_verbose_diagnostic_information_6150", "Show verbose diagnostic information."), Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file: a(6151, e.DiagnosticCategory.Message, "Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file_6151", "Emit a single file with source maps instead of having a separate file."), Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap_to_be_set: a(6152, e.DiagnosticCategory.Message, "Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap__6152", "Emit the source alongside the sourcemaps within a single file; requires '--inlineSourceMap' or '--sourceMap' to be set."), Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule: a(6153, e.DiagnosticCategory.Message, "Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule_6153", "Transpile each file as a separate module (similar to 'ts.transpileModule')."), Print_names_of_generated_files_part_of_the_compilation: a(6154, e.DiagnosticCategory.Message, "Print_names_of_generated_files_part_of_the_compilation_6154", "Print names of generated files part of the compilation."), Print_names_of_files_part_of_the_compilation: a(6155, e.DiagnosticCategory.Message, "Print_names_of_files_part_of_the_compilation_6155", "Print names of files part of the compilation."), The_locale_used_when_displaying_messages_to_the_user_e_g_en_us: a(6156, e.DiagnosticCategory.Message, "The_locale_used_when_displaying_messages_to_the_user_e_g_en_us_6156", "The locale used when displaying messages to the user (e.g. 'en-us')"), Do_not_generate_custom_helper_functions_like_extends_in_compiled_output: a(6157, e.DiagnosticCategory.Message, "Do_not_generate_custom_helper_functions_like_extends_in_compiled_output_6157", "Do not generate custom helper functions like '__extends' in compiled output."), Do_not_include_the_default_library_file_lib_d_ts: a(6158, e.DiagnosticCategory.Message, "Do_not_include_the_default_library_file_lib_d_ts_6158", "Do not include the default library file (lib.d.ts)."), Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files: a(6159, e.DiagnosticCategory.Message, "Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files_6159", "Do not add triple-slash references or imported modules to the list of compiled files."), Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files: a(6160, e.DiagnosticCategory.Message, "Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files_6160", "[Deprecated] Use '--skipLibCheck' instead. Skip type checking of default library declaration files."), List_of_folders_to_include_type_definitions_from: a(6161, e.DiagnosticCategory.Message, "List_of_folders_to_include_type_definitions_from_6161", "List of folders to include type definitions from."), Disable_size_limitations_on_JavaScript_projects: a(6162, e.DiagnosticCategory.Message, "Disable_size_limitations_on_JavaScript_projects_6162", "Disable size limitations on JavaScript projects."), The_character_set_of_the_input_files: a(6163, e.DiagnosticCategory.Message, "The_character_set_of_the_input_files_6163", "The character set of the input files."), Do_not_truncate_error_messages: a(6165, e.DiagnosticCategory.Message, "Do_not_truncate_error_messages_6165", "Do not truncate error messages."), Output_directory_for_generated_declaration_files: a(6166, e.DiagnosticCategory.Message, "Output_directory_for_generated_declaration_files_6166", "Output directory for generated declaration files."), A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl: a(6167, e.DiagnosticCategory.Message, "A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl_6167", "A series of entries which re-map imports to lookup locations relative to the 'baseUrl'."), List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime: a(6168, e.DiagnosticCategory.Message, "List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime_6168", "List of root folders whose combined content represents the structure of the project at runtime."), Show_all_compiler_options: a(6169, e.DiagnosticCategory.Message, "Show_all_compiler_options_6169", "Show all compiler options."), Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file: a(6170, e.DiagnosticCategory.Message, "Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file_6170", "[Deprecated] Use '--outFile' instead. Concatenate and emit output to single file"), Command_line_Options: a(6171, e.DiagnosticCategory.Message, "Command_line_Options_6171", "Command-line Options"), Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3: a(6179, e.DiagnosticCategory.Message, "Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3_6179", "Provide full support for iterables in 'for-of', spread, and destructuring when targeting 'ES5' or 'ES3'."), Enable_all_strict_type_checking_options: a(6180, e.DiagnosticCategory.Message, "Enable_all_strict_type_checking_options_6180", "Enable all strict type-checking options."), Scoped_package_detected_looking_in_0: a(6182, e.DiagnosticCategory.Message, "Scoped_package_detected_looking_in_0_6182", "Scoped package detected, looking in '{0}'"), Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2: a(6183, e.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_6183", "Reusing resolution of module '{0}' from '{1}' of old program, it was successfully resolved to '{2}'."), Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3: a(6184, e.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package__6184", "Reusing resolution of module '{0}' from '{1}' of old program, it was successfully resolved to '{2}' with Package ID '{3}'."), Enable_strict_checking_of_function_types: a(6186, e.DiagnosticCategory.Message, "Enable_strict_checking_of_function_types_6186", "Enable strict checking of function types."), Enable_strict_checking_of_property_initialization_in_classes: a(6187, e.DiagnosticCategory.Message, "Enable_strict_checking_of_property_initialization_in_classes_6187", "Enable strict checking of property initialization in classes."), Numeric_separators_are_not_allowed_here: a(6188, e.DiagnosticCategory.Error, "Numeric_separators_are_not_allowed_here_6188", "Numeric separators are not allowed here."), Multiple_consecutive_numeric_separators_are_not_permitted: a(6189, e.DiagnosticCategory.Error, "Multiple_consecutive_numeric_separators_are_not_permitted_6189", "Multiple consecutive numeric separators are not permitted."), Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen: a(6191, e.DiagnosticCategory.Message, "Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen_6191", "Whether to keep outdated console output in watch mode instead of clearing the screen."), All_imports_in_import_declaration_are_unused: a(6192, e.DiagnosticCategory.Error, "All_imports_in_import_declaration_are_unused_6192", "All imports in import declaration are unused.", true), Found_1_error_Watching_for_file_changes: a(6193, e.DiagnosticCategory.Message, "Found_1_error_Watching_for_file_changes_6193", "Found 1 error. Watching for file changes."), Found_0_errors_Watching_for_file_changes: a(6194, e.DiagnosticCategory.Message, "Found_0_errors_Watching_for_file_changes_6194", "Found {0} errors. Watching for file changes."), Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols: a(6195, e.DiagnosticCategory.Message, "Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols_6195", "Resolve 'keyof' to string valued property names only (no numbers or symbols)."), _0_is_declared_but_never_used: a(6196, e.DiagnosticCategory.Error, "_0_is_declared_but_never_used_6196", "'{0}' is declared but never used.", true), Include_modules_imported_with_json_extension: a(6197, e.DiagnosticCategory.Message, "Include_modules_imported_with_json_extension_6197", "Include modules imported with '.json' extension"), All_destructured_elements_are_unused: a(6198, e.DiagnosticCategory.Error, "All_destructured_elements_are_unused_6198", "All destructured elements are unused.", true), All_variables_are_unused: a(6199, e.DiagnosticCategory.Error, "All_variables_are_unused_6199", "All variables are unused.", true), Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0: a(6200, e.DiagnosticCategory.Error, "Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0_6200", "Definitions of the following identifiers conflict with those in another file: {0}"), Conflicts_are_in_this_file: a(6201, e.DiagnosticCategory.Message, "Conflicts_are_in_this_file_6201", "Conflicts are in this file."), Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0: a(6202, e.DiagnosticCategory.Error, "Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0_6202", "Project references may not form a circular graph. Cycle detected: {0}"), _0_was_also_declared_here: a(6203, e.DiagnosticCategory.Message, "_0_was_also_declared_here_6203", "'{0}' was also declared here."), and_here: a(6204, e.DiagnosticCategory.Message, "and_here_6204", "and here."), All_type_parameters_are_unused: a(6205, e.DiagnosticCategory.Error, "All_type_parameters_are_unused_6205", "All type parameters are unused."), package_json_has_a_typesVersions_field_with_version_specific_path_mappings: a(6206, e.DiagnosticCategory.Message, "package_json_has_a_typesVersions_field_with_version_specific_path_mappings_6206", "'package.json' has a 'typesVersions' field with version-specific path mappings."), package_json_does_not_have_a_typesVersions_entry_that_matches_version_0: a(6207, e.DiagnosticCategory.Message, "package_json_does_not_have_a_typesVersions_entry_that_matches_version_0_6207", "'package.json' does not have a 'typesVersions' entry that matches version '{0}'."), package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2: a(6208, e.DiagnosticCategory.Message, "package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_ma_6208", "'package.json' has a 'typesVersions' entry '{0}' that matches compiler version '{1}', looking for a pattern to match module name '{2}'."), package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range: a(6209, e.DiagnosticCategory.Message, "package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range_6209", "'package.json' has a 'typesVersions' entry '{0}' that is not a valid semver range."), An_argument_for_0_was_not_provided: a(6210, e.DiagnosticCategory.Message, "An_argument_for_0_was_not_provided_6210", "An argument for '{0}' was not provided."), An_argument_matching_this_binding_pattern_was_not_provided: a(6211, e.DiagnosticCategory.Message, "An_argument_matching_this_binding_pattern_was_not_provided_6211", "An argument matching this binding pattern was not provided."), Did_you_mean_to_call_this_expression: a(6212, e.DiagnosticCategory.Message, "Did_you_mean_to_call_this_expression_6212", "Did you mean to call this expression?"), Did_you_mean_to_use_new_with_this_expression: a(6213, e.DiagnosticCategory.Message, "Did_you_mean_to_use_new_with_this_expression_6213", "Did you mean to use 'new' with this expression?"), Enable_strict_bind_call_and_apply_methods_on_functions: a(6214, e.DiagnosticCategory.Message, "Enable_strict_bind_call_and_apply_methods_on_functions_6214", "Enable strict 'bind', 'call', and 'apply' methods on functions."), Using_compiler_options_of_project_reference_redirect_0: a(6215, e.DiagnosticCategory.Message, "Using_compiler_options_of_project_reference_redirect_0_6215", "Using compiler options of project reference redirect '{0}'."), Found_1_error: a(6216, e.DiagnosticCategory.Message, "Found_1_error_6216", "Found 1 error."), Found_0_errors: a(6217, e.DiagnosticCategory.Message, "Found_0_errors_6217", "Found {0} errors."), Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2: a(6218, e.DiagnosticCategory.Message, "Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2_6218", "======== Module name '{0}' was successfully resolved to '{1}' with Package ID '{2}'. ========"), Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3: a(6219, e.DiagnosticCategory.Message, "Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3_6219", "======== Type reference directive '{0}' was successfully resolved to '{1}' with Package ID '{2}', primary: {3}. ========"), package_json_had_a_falsy_0_field: a(6220, e.DiagnosticCategory.Message, "package_json_had_a_falsy_0_field_6220", "'package.json' had a falsy '{0}' field."), Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects: a(6221, e.DiagnosticCategory.Message, "Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects_6221", "Disable use of source files instead of declaration files from referenced projects."), Emit_class_fields_with_Define_instead_of_Set: a(6222, e.DiagnosticCategory.Message, "Emit_class_fields_with_Define_instead_of_Set_6222", "Emit class fields with Define instead of Set."), Generates_a_CPU_profile: a(6223, e.DiagnosticCategory.Message, "Generates_a_CPU_profile_6223", "Generates a CPU profile."), Disable_solution_searching_for_this_project: a(6224, e.DiagnosticCategory.Message, "Disable_solution_searching_for_this_project_6224", "Disable solution searching for this project."), Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_DynamicPriorityPolling_FixedChunkSizePolling_UseFsEvents_UseFsEventsOnParentDirectory: a(6225, e.DiagnosticCategory.Message, "Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_Dynami_6225", "Specify strategy for watching file: 'FixedPollingInterval' (default), 'PriorityPollingInterval', 'DynamicPriorityPolling', 'FixedChunkSizePolling', 'UseFsEvents', 'UseFsEventsOnParentDirectory'."), Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively_Colon_UseFsEvents_default_FixedPollingInterval_DynamicPriorityPolling_FixedChunkSizePolling: a(6226, e.DiagnosticCategory.Message, "Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively__6226", "Specify strategy for watching directory on platforms that don't support recursive watching natively: 'UseFsEvents' (default), 'FixedPollingInterval', 'DynamicPriorityPolling', 'FixedChunkSizePolling'."), Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_FixedInterval_default_PriorityInterval_DynamicPriority_FixedChunkSize: a(6227, e.DiagnosticCategory.Message, "Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_6227", "Specify strategy for creating a polling watch when it fails to create using file system events: 'FixedInterval' (default), 'PriorityInterval', 'DynamicPriority', 'FixedChunkSize'."), Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3: a(6229, e.DiagnosticCategory.Error, "Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3_6229", "Tag '{0}' expects at least '{1}' arguments, but the JSX factory '{2}' provides at most '{3}'."), Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line: a(6230, e.DiagnosticCategory.Error, "Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line_6230", "Option '{0}' can only be specified in 'tsconfig.json' file or set to 'false' or 'null' on command line."), Could_not_resolve_the_path_0_with_the_extensions_Colon_1: a(6231, e.DiagnosticCategory.Error, "Could_not_resolve_the_path_0_with_the_extensions_Colon_1_6231", "Could not resolve the path '{0}' with the extensions: {1}."), Declaration_augments_declaration_in_another_file_This_cannot_be_serialized: a(6232, e.DiagnosticCategory.Error, "Declaration_augments_declaration_in_another_file_This_cannot_be_serialized_6232", "Declaration augments declaration in another file. This cannot be serialized."), This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_file: a(6233, e.DiagnosticCategory.Error, "This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_fil_6233", "This is the declaration being augmented. Consider moving the augmenting declaration into the same file."), This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without: a(6234, e.DiagnosticCategory.Error, "This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without_6234", "This expression is not callable because it is a 'get' accessor. Did you mean to use it without '()'?"), Disable_loading_referenced_projects: a(6235, e.DiagnosticCategory.Message, "Disable_loading_referenced_projects_6235", "Disable loading referenced projects."), Arguments_for_the_rest_parameter_0_were_not_provided: a(6236, e.DiagnosticCategory.Error, "Arguments_for_the_rest_parameter_0_were_not_provided_6236", "Arguments for the rest parameter '{0}' were not provided."), Generates_an_event_trace_and_a_list_of_types: a(6237, e.DiagnosticCategory.Message, "Generates_an_event_trace_and_a_list_of_types_6237", "Generates an event trace and a list of types."), Specify_the_module_specifier_to_be_used_to_import_the_jsx_and_jsxs_factory_functions_from_eg_react: a(6238, e.DiagnosticCategory.Error, "Specify_the_module_specifier_to_be_used_to_import_the_jsx_and_jsxs_factory_functions_from_eg_react_6238", "Specify the module specifier to be used to import the 'jsx' and 'jsxs' factory functions from. eg, react"), File_0_exists_according_to_earlier_cached_lookups: a(6239, e.DiagnosticCategory.Message, "File_0_exists_according_to_earlier_cached_lookups_6239", "File '{0}' exists according to earlier cached lookups."), File_0_does_not_exist_according_to_earlier_cached_lookups: a(6240, e.DiagnosticCategory.Message, "File_0_does_not_exist_according_to_earlier_cached_lookups_6240", "File '{0}' does not exist according to earlier cached lookups."), Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1: a(6241, e.DiagnosticCategory.Message, "Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1_6241", "Resolution for type reference directive '{0}' was found in cache from location '{1}'."), Resolving_type_reference_directive_0_containing_file_1: a(6242, e.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_1_6242", "======== Resolving type reference directive '{0}', containing file '{1}'. ========"), Interpret_optional_property_types_as_written_rather_than_adding_undefined: a(6243, e.DiagnosticCategory.Message, "Interpret_optional_property_types_as_written_rather_than_adding_undefined_6243", "Interpret optional property types as written, rather than adding 'undefined'."), Modules: a(6244, e.DiagnosticCategory.Message, "Modules_6244", "Modules"), File_Management: a(6245, e.DiagnosticCategory.Message, "File_Management_6245", "File Management"), Emit: a(6246, e.DiagnosticCategory.Message, "Emit_6246", "Emit"), JavaScript_Support: a(6247, e.DiagnosticCategory.Message, "JavaScript_Support_6247", "JavaScript Support"), Type_Checking: a(6248, e.DiagnosticCategory.Message, "Type_Checking_6248", "Type Checking"), Editor_Support: a(6249, e.DiagnosticCategory.Message, "Editor_Support_6249", "Editor Support"), Watch_and_Build_Modes: a(6250, e.DiagnosticCategory.Message, "Watch_and_Build_Modes_6250", "Watch and Build Modes"), Compiler_Diagnostics: a(6251, e.DiagnosticCategory.Message, "Compiler_Diagnostics_6251", "Compiler Diagnostics"), Interop_Constraints: a(6252, e.DiagnosticCategory.Message, "Interop_Constraints_6252", "Interop Constraints"), Backwards_Compatibility: a(6253, e.DiagnosticCategory.Message, "Backwards_Compatibility_6253", "Backwards Compatibility"), Language_and_Environment: a(6254, e.DiagnosticCategory.Message, "Language_and_Environment_6254", "Language and Environment"), Projects: a(6255, e.DiagnosticCategory.Message, "Projects_6255", "Projects"), Output_Formatting: a(6256, e.DiagnosticCategory.Message, "Output_Formatting_6256", "Output Formatting"), Completeness: a(6257, e.DiagnosticCategory.Message, "Completeness_6257", "Completeness"), _0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file: a(6258, e.DiagnosticCategory.Error, "_0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file_6258", "'{0}' should be set inside the 'compilerOptions' object of the config json file"), Found_1_error_in_1: a(6259, e.DiagnosticCategory.Message, "Found_1_error_in_1_6259", "Found 1 error in {1}"), Found_0_errors_in_the_same_file_starting_at_Colon_1: a(6260, e.DiagnosticCategory.Message, "Found_0_errors_in_the_same_file_starting_at_Colon_1_6260", "Found {0} errors in the same file, starting at: {1}"), Found_0_errors_in_1_files: a(6261, e.DiagnosticCategory.Message, "Found_0_errors_in_1_files_6261", "Found {0} errors in {1} files."), Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve: a(6270, e.DiagnosticCategory.Message, "Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve_6270", "Directory '{0}' has no containing package.json scope. Imports will not resolve."), Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1: a(6271, e.DiagnosticCategory.Message, "Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1_6271", "Import specifier '{0}' does not exist in package.json scope at path '{1}'."), Invalid_import_specifier_0_has_no_possible_resolutions: a(6272, e.DiagnosticCategory.Message, "Invalid_import_specifier_0_has_no_possible_resolutions_6272", "Invalid import specifier '{0}' has no possible resolutions."), package_json_scope_0_has_no_imports_defined: a(6273, e.DiagnosticCategory.Message, "package_json_scope_0_has_no_imports_defined_6273", "package.json scope '{0}' has no imports defined."), package_json_scope_0_explicitly_maps_specifier_1_to_null: a(6274, e.DiagnosticCategory.Message, "package_json_scope_0_explicitly_maps_specifier_1_to_null_6274", "package.json scope '{0}' explicitly maps specifier '{1}' to null."), package_json_scope_0_has_invalid_type_for_target_of_specifier_1: a(6275, e.DiagnosticCategory.Message, "package_json_scope_0_has_invalid_type_for_target_of_specifier_1_6275", "package.json scope '{0}' has invalid type for target of specifier '{1}'"), Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1: a(6276, e.DiagnosticCategory.Message, "Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1_6276", "Export specifier '{0}' does not exist in package.json scope at path '{1}'."), Enable_project_compilation: a(6302, e.DiagnosticCategory.Message, "Enable_project_compilation_6302", "Enable project compilation"), Composite_projects_may_not_disable_declaration_emit: a(6304, e.DiagnosticCategory.Error, "Composite_projects_may_not_disable_declaration_emit_6304", "Composite projects may not disable declaration emit."), Output_file_0_has_not_been_built_from_source_file_1: a(6305, e.DiagnosticCategory.Error, "Output_file_0_has_not_been_built_from_source_file_1_6305", "Output file '{0}' has not been built from source file '{1}'."), Referenced_project_0_must_have_setting_composite_Colon_true: a(6306, e.DiagnosticCategory.Error, "Referenced_project_0_must_have_setting_composite_Colon_true_6306", `Referenced project '{0}' must have setting "composite": true.`), File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_include_pattern: a(6307, e.DiagnosticCategory.Error, "File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_includ_6307", "File '{0}' is not listed within the file list of project '{1}'. Projects must list all files or use an 'include' pattern."), Cannot_prepend_project_0_because_it_does_not_have_outFile_set: a(6308, e.DiagnosticCategory.Error, "Cannot_prepend_project_0_because_it_does_not_have_outFile_set_6308", "Cannot prepend project '{0}' because it does not have 'outFile' set"), Output_file_0_from_project_1_does_not_exist: a(6309, e.DiagnosticCategory.Error, "Output_file_0_from_project_1_does_not_exist_6309", "Output file '{0}' from project '{1}' does not exist"), Referenced_project_0_may_not_disable_emit: a(6310, e.DiagnosticCategory.Error, "Referenced_project_0_may_not_disable_emit_6310", "Referenced project '{0}' may not disable emit."), Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2: a(6350, e.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2_6350", "Project '{0}' is out of date because oldest output '{1}' is older than newest input '{2}'"), Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2: a(6351, e.DiagnosticCategory.Message, "Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2_6351", "Project '{0}' is up to date because newest input '{1}' is older than oldest output '{2}'"), Project_0_is_out_of_date_because_output_file_1_does_not_exist: a(6352, e.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_output_file_1_does_not_exist_6352", "Project '{0}' is out of date because output file '{1}' does not exist"), Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date: a(6353, e.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date_6353", "Project '{0}' is out of date because its dependency '{1}' is out of date"), Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies: a(6354, e.DiagnosticCategory.Message, "Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies_6354", "Project '{0}' is up to date with .d.ts files from its dependencies"), Projects_in_this_build_Colon_0: a(6355, e.DiagnosticCategory.Message, "Projects_in_this_build_Colon_0_6355", "Projects in this build: {0}"), A_non_dry_build_would_delete_the_following_files_Colon_0: a(6356, e.DiagnosticCategory.Message, "A_non_dry_build_would_delete_the_following_files_Colon_0_6356", "A non-dry build would delete the following files: {0}"), A_non_dry_build_would_build_project_0: a(6357, e.DiagnosticCategory.Message, "A_non_dry_build_would_build_project_0_6357", "A non-dry build would build project '{0}'"), Building_project_0: a(6358, e.DiagnosticCategory.Message, "Building_project_0_6358", "Building project '{0}'..."), Updating_output_timestamps_of_project_0: a(6359, e.DiagnosticCategory.Message, "Updating_output_timestamps_of_project_0_6359", "Updating output timestamps of project '{0}'..."), Project_0_is_up_to_date: a(6361, e.DiagnosticCategory.Message, "Project_0_is_up_to_date_6361", "Project '{0}' is up to date"), Skipping_build_of_project_0_because_its_dependency_1_has_errors: a(6362, e.DiagnosticCategory.Message, "Skipping_build_of_project_0_because_its_dependency_1_has_errors_6362", "Skipping build of project '{0}' because its dependency '{1}' has errors"), Project_0_can_t_be_built_because_its_dependency_1_has_errors: a(6363, e.DiagnosticCategory.Message, "Project_0_can_t_be_built_because_its_dependency_1_has_errors_6363", "Project '{0}' can't be built because its dependency '{1}' has errors"), Build_one_or_more_projects_and_their_dependencies_if_out_of_date: a(6364, e.DiagnosticCategory.Message, "Build_one_or_more_projects_and_their_dependencies_if_out_of_date_6364", "Build one or more projects and their dependencies, if out of date"), Delete_the_outputs_of_all_projects: a(6365, e.DiagnosticCategory.Message, "Delete_the_outputs_of_all_projects_6365", "Delete the outputs of all projects."), Show_what_would_be_built_or_deleted_if_specified_with_clean: a(6367, e.DiagnosticCategory.Message, "Show_what_would_be_built_or_deleted_if_specified_with_clean_6367", "Show what would be built (or deleted, if specified with '--clean')"), Option_build_must_be_the_first_command_line_argument: a(6369, e.DiagnosticCategory.Error, "Option_build_must_be_the_first_command_line_argument_6369", "Option '--build' must be the first command line argument."), Options_0_and_1_cannot_be_combined: a(6370, e.DiagnosticCategory.Error, "Options_0_and_1_cannot_be_combined_6370", "Options '{0}' and '{1}' cannot be combined."), Updating_unchanged_output_timestamps_of_project_0: a(6371, e.DiagnosticCategory.Message, "Updating_unchanged_output_timestamps_of_project_0_6371", "Updating unchanged output timestamps of project '{0}'..."), Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed: a(6372, e.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed_6372", "Project '{0}' is out of date because output of its dependency '{1}' has changed"), Updating_output_of_project_0: a(6373, e.DiagnosticCategory.Message, "Updating_output_of_project_0_6373", "Updating output of project '{0}'..."), A_non_dry_build_would_update_timestamps_for_output_of_project_0: a(6374, e.DiagnosticCategory.Message, "A_non_dry_build_would_update_timestamps_for_output_of_project_0_6374", "A non-dry build would update timestamps for output of project '{0}'"), A_non_dry_build_would_update_output_of_project_0: a(6375, e.DiagnosticCategory.Message, "A_non_dry_build_would_update_output_of_project_0_6375", "A non-dry build would update output of project '{0}'"), Cannot_update_output_of_project_0_because_there_was_error_reading_file_1: a(6376, e.DiagnosticCategory.Message, "Cannot_update_output_of_project_0_because_there_was_error_reading_file_1_6376", "Cannot update output of project '{0}' because there was error reading file '{1}'"), Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1: a(6377, e.DiagnosticCategory.Error, "Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1_6377", "Cannot write file '{0}' because it will overwrite '.tsbuildinfo' file generated by referenced project '{1}'"), Composite_projects_may_not_disable_incremental_compilation: a(6379, e.DiagnosticCategory.Error, "Composite_projects_may_not_disable_incremental_compilation_6379", "Composite projects may not disable incremental compilation."), Specify_file_to_store_incremental_compilation_information: a(6380, e.DiagnosticCategory.Message, "Specify_file_to_store_incremental_compilation_information_6380", "Specify file to store incremental compilation information"), Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2: a(6381, e.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_curren_6381", "Project '{0}' is out of date because output for it was generated with version '{1}' that differs with current version '{2}'"), Skipping_build_of_project_0_because_its_dependency_1_was_not_built: a(6382, e.DiagnosticCategory.Message, "Skipping_build_of_project_0_because_its_dependency_1_was_not_built_6382", "Skipping build of project '{0}' because its dependency '{1}' was not built"), Project_0_can_t_be_built_because_its_dependency_1_was_not_built: a(6383, e.DiagnosticCategory.Message, "Project_0_can_t_be_built_because_its_dependency_1_was_not_built_6383", "Project '{0}' can't be built because its dependency '{1}' was not built"), Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it: a(6384, e.DiagnosticCategory.Message, "Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_di_6384", "Have recompiles in '--incremental' and '--watch' assume that changes within a file will only affect files directly depending on it."), _0_is_deprecated: a(6385, e.DiagnosticCategory.Suggestion, "_0_is_deprecated_6385", "'{0}' is deprecated.", void 0, void 0, true), Performance_timings_for_diagnostics_or_extendedDiagnostics_are_not_available_in_this_session_A_native_implementation_of_the_Web_Performance_API_could_not_be_found: a(6386, e.DiagnosticCategory.Message, "Performance_timings_for_diagnostics_or_extendedDiagnostics_are_not_available_in_this_session_A_nativ_6386", "Performance timings for '--diagnostics' or '--extendedDiagnostics' are not available in this session. A native implementation of the Web Performance API could not be found."), The_signature_0_of_1_is_deprecated: a(6387, e.DiagnosticCategory.Suggestion, "The_signature_0_of_1_is_deprecated_6387", "The signature '{0}' of '{1}' is deprecated.", void 0, void 0, true), Project_0_is_being_forcibly_rebuilt: a(6388, e.DiagnosticCategory.Message, "Project_0_is_being_forcibly_rebuilt_6388", "Project '{0}' is being forcibly rebuilt"), Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved: a(6389, e.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved_6389", "Reusing resolution of module '{0}' from '{1}' of old program, it was not resolved."), Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2: a(6390, e.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved__6390", "Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was successfully resolved to '{2}'."), Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3: a(6391, e.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved__6391", "Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was successfully resolved to '{2}' with Package ID '{3}'."), Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved: a(6392, e.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved_6392", "Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was not resolved."), Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3: a(6393, e.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_6393", "Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}'."), Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4: a(6394, e.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_6394", "Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}' with Package ID '{4}'."), Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_not_resolved: a(6395, e.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_not_resolved_6395", "Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was not resolved."), Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3: a(6396, e.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_succes_6396", "Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}'."), Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4: a(6397, e.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_succes_6397", "Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}' with Package ID '{4}'."), Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_not_resolved: a(6398, e.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_not_re_6398", "Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was not resolved."), The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1: a(6500, e.DiagnosticCategory.Message, "The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1_6500", "The expected type comes from property '{0}' which is declared here on type '{1}'"), The_expected_type_comes_from_this_index_signature: a(6501, e.DiagnosticCategory.Message, "The_expected_type_comes_from_this_index_signature_6501", "The expected type comes from this index signature."), The_expected_type_comes_from_the_return_type_of_this_signature: a(6502, e.DiagnosticCategory.Message, "The_expected_type_comes_from_the_return_type_of_this_signature_6502", "The expected type comes from the return type of this signature."), Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing: a(6503, e.DiagnosticCategory.Message, "Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing_6503", "Print names of files that are part of the compilation and then stop processing."), File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option: a(6504, e.DiagnosticCategory.Error, "File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option_6504", "File '{0}' is a JavaScript file. Did you mean to enable the 'allowJs' option?"), Print_names_of_files_and_the_reason_they_are_part_of_the_compilation: a(6505, e.DiagnosticCategory.Message, "Print_names_of_files_and_the_reason_they_are_part_of_the_compilation_6505", "Print names of files and the reason they are part of the compilation."), Consider_adding_a_declare_modifier_to_this_class: a(6506, e.DiagnosticCategory.Message, "Consider_adding_a_declare_modifier_to_this_class_6506", "Consider adding a 'declare' modifier to this class."), Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these_files: a(6600, e.DiagnosticCategory.Message, "Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these__6600", "Allow JavaScript files to be a part of your program. Use the 'checkJS' option to get errors from these files."), Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export: a(6601, e.DiagnosticCategory.Message, "Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export_6601", "Allow 'import x from y' when a module doesn't have a default export."), Allow_accessing_UMD_globals_from_modules: a(6602, e.DiagnosticCategory.Message, "Allow_accessing_UMD_globals_from_modules_6602", "Allow accessing UMD globals from modules."), Disable_error_reporting_for_unreachable_code: a(6603, e.DiagnosticCategory.Message, "Disable_error_reporting_for_unreachable_code_6603", "Disable error reporting for unreachable code."), Disable_error_reporting_for_unused_labels: a(6604, e.DiagnosticCategory.Message, "Disable_error_reporting_for_unused_labels_6604", "Disable error reporting for unused labels."), Ensure_use_strict_is_always_emitted: a(6605, e.DiagnosticCategory.Message, "Ensure_use_strict_is_always_emitted_6605", "Ensure 'use strict' is always emitted."), Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it: a(6606, e.DiagnosticCategory.Message, "Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_wi_6606", "Have recompiles in projects that use 'incremental' and 'watch' mode assume that changes within a file will only affect files directly depending on it."), Specify_the_base_directory_to_resolve_non_relative_module_names: a(6607, e.DiagnosticCategory.Message, "Specify_the_base_directory_to_resolve_non_relative_module_names_6607", "Specify the base directory to resolve non-relative module names."), No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files: a(6608, e.DiagnosticCategory.Message, "No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files_6608", "No longer supported. In early versions, manually set the text encoding for reading files."), Enable_error_reporting_in_type_checked_JavaScript_files: a(6609, e.DiagnosticCategory.Message, "Enable_error_reporting_in_type_checked_JavaScript_files_6609", "Enable error reporting in type-checked JavaScript files."), Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references: a(6611, e.DiagnosticCategory.Message, "Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references_6611", "Enable constraints that allow a TypeScript project to be used with project references."), Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project: a(6612, e.DiagnosticCategory.Message, "Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project_6612", "Generate .d.ts files from TypeScript and JavaScript files in your project."), Specify_the_output_directory_for_generated_declaration_files: a(6613, e.DiagnosticCategory.Message, "Specify_the_output_directory_for_generated_declaration_files_6613", "Specify the output directory for generated declaration files."), Create_sourcemaps_for_d_ts_files: a(6614, e.DiagnosticCategory.Message, "Create_sourcemaps_for_d_ts_files_6614", "Create sourcemaps for d.ts files."), Output_compiler_performance_information_after_building: a(6615, e.DiagnosticCategory.Message, "Output_compiler_performance_information_after_building_6615", "Output compiler performance information after building."), Disables_inference_for_type_acquisition_by_looking_at_filenames_in_a_project: a(6616, e.DiagnosticCategory.Message, "Disables_inference_for_type_acquisition_by_looking_at_filenames_in_a_project_6616", "Disables inference for type acquisition by looking at filenames in a project."), Reduce_the_number_of_projects_loaded_automatically_by_TypeScript: a(6617, e.DiagnosticCategory.Message, "Reduce_the_number_of_projects_loaded_automatically_by_TypeScript_6617", "Reduce the number of projects loaded automatically by TypeScript."), Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server: a(6618, e.DiagnosticCategory.Message, "Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server_6618", "Remove the 20mb cap on total source code size for JavaScript files in the TypeScript language server."), Opt_a_project_out_of_multi_project_reference_checking_when_editing: a(6619, e.DiagnosticCategory.Message, "Opt_a_project_out_of_multi_project_reference_checking_when_editing_6619", "Opt a project out of multi-project reference checking when editing."), Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects: a(6620, e.DiagnosticCategory.Message, "Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects_6620", "Disable preferring source files instead of declaration files when referencing composite projects."), Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration: a(6621, e.DiagnosticCategory.Message, "Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration_6621", "Emit more compliant, but verbose and less performant JavaScript for iteration."), Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files: a(6622, e.DiagnosticCategory.Message, "Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files_6622", "Emit a UTF-8 Byte Order Mark (BOM) in the beginning of output files."), Only_output_d_ts_files_and_not_JavaScript_files: a(6623, e.DiagnosticCategory.Message, "Only_output_d_ts_files_and_not_JavaScript_files_6623", "Only output d.ts files and not JavaScript files."), Emit_design_type_metadata_for_decorated_declarations_in_source_files: a(6624, e.DiagnosticCategory.Message, "Emit_design_type_metadata_for_decorated_declarations_in_source_files_6624", "Emit design-type metadata for decorated declarations in source files."), Disable_the_type_acquisition_for_JavaScript_projects: a(6625, e.DiagnosticCategory.Message, "Disable_the_type_acquisition_for_JavaScript_projects_6625", "Disable the type acquisition for JavaScript projects"), Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheticDefaultImports_for_type_compatibility: a(6626, e.DiagnosticCategory.Message, "Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheti_6626", "Emit additional JavaScript to ease support for importing CommonJS modules. This enables 'allowSyntheticDefaultImports' for type compatibility."), Filters_results_from_the_include_option: a(6627, e.DiagnosticCategory.Message, "Filters_results_from_the_include_option_6627", "Filters results from the `include` option."), Remove_a_list_of_directories_from_the_watch_process: a(6628, e.DiagnosticCategory.Message, "Remove_a_list_of_directories_from_the_watch_process_6628", "Remove a list of directories from the watch process."), Remove_a_list_of_files_from_the_watch_mode_s_processing: a(6629, e.DiagnosticCategory.Message, "Remove_a_list_of_files_from_the_watch_mode_s_processing_6629", "Remove a list of files from the watch mode's processing."), Enable_experimental_support_for_TC39_stage_2_draft_decorators: a(6630, e.DiagnosticCategory.Message, "Enable_experimental_support_for_TC39_stage_2_draft_decorators_6630", "Enable experimental support for TC39 stage 2 draft decorators."), Print_files_read_during_the_compilation_including_why_it_was_included: a(6631, e.DiagnosticCategory.Message, "Print_files_read_during_the_compilation_including_why_it_was_included_6631", "Print files read during the compilation including why it was included."), Output_more_detailed_compiler_performance_information_after_building: a(6632, e.DiagnosticCategory.Message, "Output_more_detailed_compiler_performance_information_after_building_6632", "Output more detailed compiler performance information after building."), Specify_one_or_more_path_or_node_module_references_to_base_configuration_files_from_which_settings_are_inherited: a(6633, e.DiagnosticCategory.Message, "Specify_one_or_more_path_or_node_module_references_to_base_configuration_files_from_which_settings_a_6633", "Specify one or more path or node module references to base configuration files from which settings are inherited."), Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers: a(6634, e.DiagnosticCategory.Message, "Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers_6634", "Specify what approach the watcher should use if the system runs out of native file watchers."), Include_a_list_of_files_This_does_not_support_glob_patterns_as_opposed_to_include: a(6635, e.DiagnosticCategory.Message, "Include_a_list_of_files_This_does_not_support_glob_patterns_as_opposed_to_include_6635", "Include a list of files. This does not support glob patterns, as opposed to `include`."), Build_all_projects_including_those_that_appear_to_be_up_to_date: a(6636, e.DiagnosticCategory.Message, "Build_all_projects_including_those_that_appear_to_be_up_to_date_6636", "Build all projects, including those that appear to be up to date."), Ensure_that_casing_is_correct_in_imports: a(6637, e.DiagnosticCategory.Message, "Ensure_that_casing_is_correct_in_imports_6637", "Ensure that casing is correct in imports."), Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging: a(6638, e.DiagnosticCategory.Message, "Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging_6638", "Emit a v8 CPU profile of the compiler run for debugging."), Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file: a(6639, e.DiagnosticCategory.Message, "Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file_6639", "Allow importing helper functions from tslib once per project, instead of including them per-file."), Specify_a_list_of_glob_patterns_that_match_files_to_be_included_in_compilation: a(6641, e.DiagnosticCategory.Message, "Specify_a_list_of_glob_patterns_that_match_files_to_be_included_in_compilation_6641", "Specify a list of glob patterns that match files to be included in compilation."), Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects: a(6642, e.DiagnosticCategory.Message, "Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects_6642", "Save .tsbuildinfo files to allow for incremental compilation of projects."), Include_sourcemap_files_inside_the_emitted_JavaScript: a(6643, e.DiagnosticCategory.Message, "Include_sourcemap_files_inside_the_emitted_JavaScript_6643", "Include sourcemap files inside the emitted JavaScript."), Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript: a(6644, e.DiagnosticCategory.Message, "Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript_6644", "Include source code in the sourcemaps inside the emitted JavaScript."), Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports: a(6645, e.DiagnosticCategory.Message, "Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports_6645", "Ensure that each file can be safely transpiled without relying on other imports."), Specify_what_JSX_code_is_generated: a(6646, e.DiagnosticCategory.Message, "Specify_what_JSX_code_is_generated_6646", "Specify what JSX code is generated."), Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h: a(6647, e.DiagnosticCategory.Message, "Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h_6647", "Specify the JSX factory function used when targeting React JSX emit, e.g. 'React.createElement' or 'h'."), Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragment_or_Fragment: a(6648, e.DiagnosticCategory.Message, "Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragme_6648", "Specify the JSX Fragment reference used for fragments when targeting React JSX emit e.g. 'React.Fragment' or 'Fragment'."), Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Asterisk: a(6649, e.DiagnosticCategory.Message, "Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Ast_6649", "Specify module specifier used to import the JSX factory functions when using 'jsx: react-jsx*'."), Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option: a(6650, e.DiagnosticCategory.Message, "Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option_6650", "Make keyof only return strings instead of string, numbers or symbols. Legacy option."), Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment: a(6651, e.DiagnosticCategory.Message, "Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment_6651", "Specify a set of bundled library declaration files that describe the target runtime environment."), Print_the_names_of_emitted_files_after_a_compilation: a(6652, e.DiagnosticCategory.Message, "Print_the_names_of_emitted_files_after_a_compilation_6652", "Print the names of emitted files after a compilation."), Print_all_of_the_files_read_during_the_compilation: a(6653, e.DiagnosticCategory.Message, "Print_all_of_the_files_read_during_the_compilation_6653", "Print all of the files read during the compilation."), Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit: a(6654, e.DiagnosticCategory.Message, "Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit_6654", "Set the language of the messaging from TypeScript. This does not affect emit."), Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations: a(6655, e.DiagnosticCategory.Message, "Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations_6655", "Specify the location where debugger should locate map files instead of generated locations."), Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicable_with_allowJs: a(6656, e.DiagnosticCategory.Message, "Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicabl_6656", "Specify the maximum folder depth used for checking JavaScript files from 'node_modules'. Only applicable with 'allowJs'."), Specify_what_module_code_is_generated: a(6657, e.DiagnosticCategory.Message, "Specify_what_module_code_is_generated_6657", "Specify what module code is generated."), Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier: a(6658, e.DiagnosticCategory.Message, "Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier_6658", "Specify how TypeScript looks up a file from a given module specifier."), Set_the_newline_character_for_emitting_files: a(6659, e.DiagnosticCategory.Message, "Set_the_newline_character_for_emitting_files_6659", "Set the newline character for emitting files."), Disable_emitting_files_from_a_compilation: a(6660, e.DiagnosticCategory.Message, "Disable_emitting_files_from_a_compilation_6660", "Disable emitting files from a compilation."), Disable_generating_custom_helper_functions_like_extends_in_compiled_output: a(6661, e.DiagnosticCategory.Message, "Disable_generating_custom_helper_functions_like_extends_in_compiled_output_6661", "Disable generating custom helper functions like '__extends' in compiled output."), Disable_emitting_files_if_any_type_checking_errors_are_reported: a(6662, e.DiagnosticCategory.Message, "Disable_emitting_files_if_any_type_checking_errors_are_reported_6662", "Disable emitting files if any type checking errors are reported."), Disable_truncating_types_in_error_messages: a(6663, e.DiagnosticCategory.Message, "Disable_truncating_types_in_error_messages_6663", "Disable truncating types in error messages."), Enable_error_reporting_for_fallthrough_cases_in_switch_statements: a(6664, e.DiagnosticCategory.Message, "Enable_error_reporting_for_fallthrough_cases_in_switch_statements_6664", "Enable error reporting for fallthrough cases in switch statements."), Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type: a(6665, e.DiagnosticCategory.Message, "Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type_6665", "Enable error reporting for expressions and declarations with an implied 'any' type."), Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier: a(6666, e.DiagnosticCategory.Message, "Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier_6666", "Ensure overriding members in derived classes are marked with an override modifier."), Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function: a(6667, e.DiagnosticCategory.Message, "Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function_6667", "Enable error reporting for codepaths that do not explicitly return in a function."), Enable_error_reporting_when_this_is_given_the_type_any: a(6668, e.DiagnosticCategory.Message, "Enable_error_reporting_when_this_is_given_the_type_any_6668", "Enable error reporting when 'this' is given the type 'any'."), Disable_adding_use_strict_directives_in_emitted_JavaScript_files: a(6669, e.DiagnosticCategory.Message, "Disable_adding_use_strict_directives_in_emitted_JavaScript_files_6669", "Disable adding 'use strict' directives in emitted JavaScript files."), Disable_including_any_library_files_including_the_default_lib_d_ts: a(6670, e.DiagnosticCategory.Message, "Disable_including_any_library_files_including_the_default_lib_d_ts_6670", "Disable including any library files, including the default lib.d.ts."), Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type: a(6671, e.DiagnosticCategory.Message, "Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type_6671", "Enforces using indexed accessors for keys declared using an indexed type."), Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add_to_a_project: a(6672, e.DiagnosticCategory.Message, "Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add__6672", "Disallow 'import's, 'require's or '<reference>'s from expanding the number of files TypeScript should add to a project."), Disable_strict_checking_of_generic_signatures_in_function_types: a(6673, e.DiagnosticCategory.Message, "Disable_strict_checking_of_generic_signatures_in_function_types_6673", "Disable strict checking of generic signatures in function types."), Add_undefined_to_a_type_when_accessed_using_an_index: a(6674, e.DiagnosticCategory.Message, "Add_undefined_to_a_type_when_accessed_using_an_index_6674", "Add 'undefined' to a type when accessed using an index."), Enable_error_reporting_when_local_variables_aren_t_read: a(6675, e.DiagnosticCategory.Message, "Enable_error_reporting_when_local_variables_aren_t_read_6675", "Enable error reporting when local variables aren't read."), Raise_an_error_when_a_function_parameter_isn_t_read: a(6676, e.DiagnosticCategory.Message, "Raise_an_error_when_a_function_parameter_isn_t_read_6676", "Raise an error when a function parameter isn't read."), Deprecated_setting_Use_outFile_instead: a(6677, e.DiagnosticCategory.Message, "Deprecated_setting_Use_outFile_instead_6677", "Deprecated setting. Use 'outFile' instead."), Specify_an_output_folder_for_all_emitted_files: a(6678, e.DiagnosticCategory.Message, "Specify_an_output_folder_for_all_emitted_files_6678", "Specify an output folder for all emitted files."), Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designates_a_file_that_bundles_all_d_ts_output: a(6679, e.DiagnosticCategory.Message, "Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designa_6679", "Specify a file that bundles all outputs into one JavaScript file. If 'declaration' is true, also designates a file that bundles all .d.ts output."), Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations: a(6680, e.DiagnosticCategory.Message, "Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations_6680", "Specify a set of entries that re-map imports to additional lookup locations."), Specify_a_list_of_language_service_plugins_to_include: a(6681, e.DiagnosticCategory.Message, "Specify_a_list_of_language_service_plugins_to_include_6681", "Specify a list of language service plugins to include."), Disable_erasing_const_enum_declarations_in_generated_code: a(6682, e.DiagnosticCategory.Message, "Disable_erasing_const_enum_declarations_in_generated_code_6682", "Disable erasing 'const enum' declarations in generated code."), Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node: a(6683, e.DiagnosticCategory.Message, "Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node_6683", "Disable resolving symlinks to their realpath. This correlates to the same flag in node."), Disable_wiping_the_console_in_watch_mode: a(6684, e.DiagnosticCategory.Message, "Disable_wiping_the_console_in_watch_mode_6684", "Disable wiping the console in watch mode."), Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read: a(6685, e.DiagnosticCategory.Message, "Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read_6685", "Enable color and formatting in TypeScript's output to make compiler errors easier to read."), Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit: a(6686, e.DiagnosticCategory.Message, "Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit_6686", "Specify the object invoked for 'createElement'. This only applies when targeting 'react' JSX emit."), Specify_an_array_of_objects_that_specify_paths_for_projects_Used_in_project_references: a(6687, e.DiagnosticCategory.Message, "Specify_an_array_of_objects_that_specify_paths_for_projects_Used_in_project_references_6687", "Specify an array of objects that specify paths for projects. Used in project references."), Disable_emitting_comments: a(6688, e.DiagnosticCategory.Message, "Disable_emitting_comments_6688", "Disable emitting comments."), Enable_importing_json_files: a(6689, e.DiagnosticCategory.Message, "Enable_importing_json_files_6689", "Enable importing .json files."), Specify_the_root_folder_within_your_source_files: a(6690, e.DiagnosticCategory.Message, "Specify_the_root_folder_within_your_source_files_6690", "Specify the root folder within your source files."), Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules: a(6691, e.DiagnosticCategory.Message, "Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules_6691", "Allow multiple folders to be treated as one when resolving modules."), Skip_type_checking_d_ts_files_that_are_included_with_TypeScript: a(6692, e.DiagnosticCategory.Message, "Skip_type_checking_d_ts_files_that_are_included_with_TypeScript_6692", "Skip type checking .d.ts files that are included with TypeScript."), Skip_type_checking_all_d_ts_files: a(6693, e.DiagnosticCategory.Message, "Skip_type_checking_all_d_ts_files_6693", "Skip type checking all .d.ts files."), Create_source_map_files_for_emitted_JavaScript_files: a(6694, e.DiagnosticCategory.Message, "Create_source_map_files_for_emitted_JavaScript_files_6694", "Create source map files for emitted JavaScript files."), Specify_the_root_path_for_debuggers_to_find_the_reference_source_code: a(6695, e.DiagnosticCategory.Message, "Specify_the_root_path_for_debuggers_to_find_the_reference_source_code_6695", "Specify the root path for debuggers to find the reference source code."), Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function: a(6697, e.DiagnosticCategory.Message, "Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function_6697", "Check that the arguments for 'bind', 'call', and 'apply' methods match the original function."), When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible: a(6698, e.DiagnosticCategory.Message, "When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible_6698", "When assigning functions, check to ensure parameters and the return values are subtype-compatible."), When_type_checking_take_into_account_null_and_undefined: a(6699, e.DiagnosticCategory.Message, "When_type_checking_take_into_account_null_and_undefined_6699", "When type checking, take into account 'null' and 'undefined'."), Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor: a(6700, e.DiagnosticCategory.Message, "Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor_6700", "Check for class properties that are declared but not set in the constructor."), Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments: a(6701, e.DiagnosticCategory.Message, "Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments_6701", "Disable emitting declarations that have '@internal' in their JSDoc comments."), Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals: a(6702, e.DiagnosticCategory.Message, "Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals_6702", "Disable reporting of excess property errors during the creation of object literals."), Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures: a(6703, e.DiagnosticCategory.Message, "Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures_6703", "Suppress 'noImplicitAny' errors when indexing objects that lack index signatures."), Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively: a(6704, e.DiagnosticCategory.Message, "Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_supp_6704", "Synchronously call callbacks and update the state of directory watchers on platforms that don`t support recursive watching natively."), Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declarations: a(6705, e.DiagnosticCategory.Message, "Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declaratio_6705", "Set the JavaScript language version for emitted JavaScript and include compatible library declarations."), Log_paths_used_during_the_moduleResolution_process: a(6706, e.DiagnosticCategory.Message, "Log_paths_used_during_the_moduleResolution_process_6706", "Log paths used during the 'moduleResolution' process."), Specify_the_path_to_tsbuildinfo_incremental_compilation_file: a(6707, e.DiagnosticCategory.Message, "Specify_the_path_to_tsbuildinfo_incremental_compilation_file_6707", "Specify the path to .tsbuildinfo incremental compilation file."), Specify_options_for_automatic_acquisition_of_declaration_files: a(6709, e.DiagnosticCategory.Message, "Specify_options_for_automatic_acquisition_of_declaration_files_6709", "Specify options for automatic acquisition of declaration files."), Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types: a(6710, e.DiagnosticCategory.Message, "Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types_6710", "Specify multiple folders that act like './node_modules/@types'."), Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file: a(6711, e.DiagnosticCategory.Message, "Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file_6711", "Specify type package names to be included without being referenced in a source file."), Emit_ECMAScript_standard_compliant_class_fields: a(6712, e.DiagnosticCategory.Message, "Emit_ECMAScript_standard_compliant_class_fields_6712", "Emit ECMAScript-standard-compliant class fields."), Enable_verbose_logging: a(6713, e.DiagnosticCategory.Message, "Enable_verbose_logging_6713", "Enable verbose logging."), Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality: a(6714, e.DiagnosticCategory.Message, "Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality_6714", "Specify how directories are watched on systems that lack recursive file-watching functionality."), Specify_how_the_TypeScript_watch_mode_works: a(6715, e.DiagnosticCategory.Message, "Specify_how_the_TypeScript_watch_mode_works_6715", "Specify how the TypeScript watch mode works."), Require_undeclared_properties_from_index_signatures_to_use_element_accesses: a(6717, e.DiagnosticCategory.Message, "Require_undeclared_properties_from_index_signatures_to_use_element_accesses_6717", "Require undeclared properties from index signatures to use element accesses."), Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types: a(6718, e.DiagnosticCategory.Message, "Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types_6718", "Specify emit/checking behavior for imports that are only used for types."), Default_catch_clause_variables_as_unknown_instead_of_any: a(6803, e.DiagnosticCategory.Message, "Default_catch_clause_variables_as_unknown_instead_of_any_6803", "Default catch clause variables as 'unknown' instead of 'any'."), one_of_Colon: a(6900, e.DiagnosticCategory.Message, "one_of_Colon_6900", "one of:"), one_or_more_Colon: a(6901, e.DiagnosticCategory.Message, "one_or_more_Colon_6901", "one or more:"), type_Colon: a(6902, e.DiagnosticCategory.Message, "type_Colon_6902", "type:"), default_Colon: a(6903, e.DiagnosticCategory.Message, "default_Colon_6903", "default:"), module_system_or_esModuleInterop: a(6904, e.DiagnosticCategory.Message, "module_system_or_esModuleInterop_6904", 'module === "system" or esModuleInterop'), false_unless_strict_is_set: a(6905, e.DiagnosticCategory.Message, "false_unless_strict_is_set_6905", "`false`, unless `strict` is set"), false_unless_composite_is_set: a(6906, e.DiagnosticCategory.Message, "false_unless_composite_is_set_6906", "`false`, unless `composite` is set"), node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified: a(6907, e.DiagnosticCategory.Message, "node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified_6907", '`["node_modules", "bower_components", "jspm_packages"]`, plus the value of `outDir` if one is specified.'), if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk: a(6908, e.DiagnosticCategory.Message, "if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk_6908", '`[]` if `files` is specified, otherwise `["**/*"]`'), true_if_composite_false_otherwise: a(6909, e.DiagnosticCategory.Message, "true_if_composite_false_otherwise_6909", "`true` if `composite`, `false` otherwise"), module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node: a(69010, e.DiagnosticCategory.Message, "module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node_69010", "module === `AMD` or `UMD` or `System` or `ES6`, then `Classic`, Otherwise `Node`"), Computed_from_the_list_of_input_files: a(6911, e.DiagnosticCategory.Message, "Computed_from_the_list_of_input_files_6911", "Computed from the list of input files"), Platform_specific: a(6912, e.DiagnosticCategory.Message, "Platform_specific_6912", "Platform specific"), You_can_learn_about_all_of_the_compiler_options_at_0: a(6913, e.DiagnosticCategory.Message, "You_can_learn_about_all_of_the_compiler_options_at_0_6913", "You can learn about all of the compiler options at {0}"), Including_watch_w_will_start_watching_the_current_project_for_the_file_changes_Once_set_you_can_config_watch_mode_with_Colon: a(6914, e.DiagnosticCategory.Message, "Including_watch_w_will_start_watching_the_current_project_for_the_file_changes_Once_set_you_can_conf_6914", "Including --watch, -w will start watching the current project for the file changes. Once set, you can config watch mode with:"), Using_build_b_will_make_tsc_behave_more_like_a_build_orchestrator_than_a_compiler_This_is_used_to_trigger_building_composite_projects_which_you_can_learn_more_about_at_0: a(6915, e.DiagnosticCategory.Message, "Using_build_b_will_make_tsc_behave_more_like_a_build_orchestrator_than_a_compiler_This_is_used_to_tr_6915", "Using --build, -b will make tsc behave more like a build orchestrator than a compiler. This is used to trigger building composite projects which you can learn more about at {0}"), COMMON_COMMANDS: a(6916, e.DiagnosticCategory.Message, "COMMON_COMMANDS_6916", "COMMON COMMANDS"), ALL_COMPILER_OPTIONS: a(6917, e.DiagnosticCategory.Message, "ALL_COMPILER_OPTIONS_6917", "ALL COMPILER OPTIONS"), WATCH_OPTIONS: a(6918, e.DiagnosticCategory.Message, "WATCH_OPTIONS_6918", "WATCH OPTIONS"), BUILD_OPTIONS: a(6919, e.DiagnosticCategory.Message, "BUILD_OPTIONS_6919", "BUILD OPTIONS"), COMMON_COMPILER_OPTIONS: a(6920, e.DiagnosticCategory.Message, "COMMON_COMPILER_OPTIONS_6920", "COMMON COMPILER OPTIONS"), COMMAND_LINE_FLAGS: a(6921, e.DiagnosticCategory.Message, "COMMAND_LINE_FLAGS_6921", "COMMAND LINE FLAGS"), tsc_Colon_The_TypeScript_Compiler: a(6922, e.DiagnosticCategory.Message, "tsc_Colon_The_TypeScript_Compiler_6922", "tsc: The TypeScript Compiler"), Compiles_the_current_project_tsconfig_json_in_the_working_directory: a(6923, e.DiagnosticCategory.Message, "Compiles_the_current_project_tsconfig_json_in_the_working_directory_6923", "Compiles the current project (tsconfig.json in the working directory.)"), Ignoring_tsconfig_json_compiles_the_specified_files_with_default_compiler_options: a(6924, e.DiagnosticCategory.Message, "Ignoring_tsconfig_json_compiles_the_specified_files_with_default_compiler_options_6924", "Ignoring tsconfig.json, compiles the specified files with default compiler options."), Build_a_composite_project_in_the_working_directory: a(6925, e.DiagnosticCategory.Message, "Build_a_composite_project_in_the_working_directory_6925", "Build a composite project in the working directory."), Creates_a_tsconfig_json_with_the_recommended_settings_in_the_working_directory: a(6926, e.DiagnosticCategory.Message, "Creates_a_tsconfig_json_with_the_recommended_settings_in_the_working_directory_6926", "Creates a tsconfig.json with the recommended settings in the working directory."), Compiles_the_TypeScript_project_located_at_the_specified_path: a(6927, e.DiagnosticCategory.Message, "Compiles_the_TypeScript_project_located_at_the_specified_path_6927", "Compiles the TypeScript project located at the specified path."), An_expanded_version_of_this_information_showing_all_possible_compiler_options: a(6928, e.DiagnosticCategory.Message, "An_expanded_version_of_this_information_showing_all_possible_compiler_options_6928", "An expanded version of this information, showing all possible compiler options"), Compiles_the_current_project_with_additional_settings: a(6929, e.DiagnosticCategory.Message, "Compiles_the_current_project_with_additional_settings_6929", "Compiles the current project, with additional settings."), true_for_ES2022_and_above_including_ESNext: a(6930, e.DiagnosticCategory.Message, "true_for_ES2022_and_above_including_ESNext_6930", "`true` for ES2022 and above, including ESNext."), List_of_file_name_suffixes_to_search_when_resolving_a_module: a(6931, e.DiagnosticCategory.Error, "List_of_file_name_suffixes_to_search_when_resolving_a_module_6931", "List of file name suffixes to search when resolving a module."), Variable_0_implicitly_has_an_1_type: a(7005, e.DiagnosticCategory.Error, "Variable_0_implicitly_has_an_1_type_7005", "Variable '{0}' implicitly has an '{1}' type."), Parameter_0_implicitly_has_an_1_type: a(7006, e.DiagnosticCategory.Error, "Parameter_0_implicitly_has_an_1_type_7006", "Parameter '{0}' implicitly has an '{1}' type."), Member_0_implicitly_has_an_1_type: a(7008, e.DiagnosticCategory.Error, "Member_0_implicitly_has_an_1_type_7008", "Member '{0}' implicitly has an '{1}' type."), new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type: a(7009, e.DiagnosticCategory.Error, "new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type_7009", "'new' expression, whose target lacks a construct signature, implicitly has an 'any' type."), _0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type: a(7010, e.DiagnosticCategory.Error, "_0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type_7010", "'{0}', which lacks return-type annotation, implicitly has an '{1}' return type."), Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type: a(7011, e.DiagnosticCategory.Error, "Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7011", "Function expression, which lacks return-type annotation, implicitly has an '{0}' return type."), Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type: a(7013, e.DiagnosticCategory.Error, "Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7013", "Construct signature, which lacks return-type annotation, implicitly has an 'any' return type."), Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type: a(7014, e.DiagnosticCategory.Error, "Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7014", "Function type, which lacks return-type annotation, implicitly has an '{0}' return type."), Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number: a(7015, e.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number_7015", "Element implicitly has an 'any' type because index expression is not of type 'number'."), Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type: a(7016, e.DiagnosticCategory.Error, "Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type_7016", "Could not find a declaration file for module '{0}'. '{1}' implicitly has an 'any' type."), Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature: a(7017, e.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_7017", "Element implicitly has an 'any' type because type '{0}' has no index signature."), Object_literal_s_property_0_implicitly_has_an_1_type: a(7018, e.DiagnosticCategory.Error, "Object_literal_s_property_0_implicitly_has_an_1_type_7018", "Object literal's property '{0}' implicitly has an '{1}' type."), Rest_parameter_0_implicitly_has_an_any_type: a(7019, e.DiagnosticCategory.Error, "Rest_parameter_0_implicitly_has_an_any_type_7019", "Rest parameter '{0}' implicitly has an 'any[]' type."), Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type: a(7020, e.DiagnosticCategory.Error, "Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7020", "Call signature, which lacks return-type annotation, implicitly has an 'any' return type."), _0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer: a(7022, e.DiagnosticCategory.Error, "_0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or__7022", "'{0}' implicitly has type 'any' because it does not have a type annotation and is referenced directly or indirectly in its own initializer."), _0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions: a(7023, e.DiagnosticCategory.Error, "_0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_reference_7023", "'{0}' implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."), Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions: a(7024, e.DiagnosticCategory.Error, "Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_ref_7024", "Function implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."), Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type_annotation: a(7025, e.DiagnosticCategory.Error, "Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_retu_7025", "Generator implicitly has yield type '{0}' because it does not yield any values. Consider supplying a return type annotation."), JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists: a(7026, e.DiagnosticCategory.Error, "JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists_7026", "JSX element implicitly has type 'any' because no interface 'JSX.{0}' exists."), Unreachable_code_detected: a(7027, e.DiagnosticCategory.Error, "Unreachable_code_detected_7027", "Unreachable code detected.", true), Unused_label: a(7028, e.DiagnosticCategory.Error, "Unused_label_7028", "Unused label.", true), Fallthrough_case_in_switch: a(7029, e.DiagnosticCategory.Error, "Fallthrough_case_in_switch_7029", "Fallthrough case in switch."), Not_all_code_paths_return_a_value: a(7030, e.DiagnosticCategory.Error, "Not_all_code_paths_return_a_value_7030", "Not all code paths return a value."), Binding_element_0_implicitly_has_an_1_type: a(7031, e.DiagnosticCategory.Error, "Binding_element_0_implicitly_has_an_1_type_7031", "Binding element '{0}' implicitly has an '{1}' type."), Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation: a(7032, e.DiagnosticCategory.Error, "Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation_7032", "Property '{0}' implicitly has type 'any', because its set accessor lacks a parameter type annotation."), Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation: a(7033, e.DiagnosticCategory.Error, "Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation_7033", "Property '{0}' implicitly has type 'any', because its get accessor lacks a return type annotation."), Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined: a(7034, e.DiagnosticCategory.Error, "Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined_7034", "Variable '{0}' implicitly has type '{1}' in some locations where its type cannot be determined."), Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0: a(7035, e.DiagnosticCategory.Error, "Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare__7035", "Try `npm i --save-dev @types/{1}` if it exists or add a new declaration (.d.ts) file containing `declare module '{0}';`"), Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0: a(7036, e.DiagnosticCategory.Error, "Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0_7036", "Dynamic import's specifier must be of type 'string', but here has type '{0}'."), Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for_all_imports_Implies_allowSyntheticDefaultImports: a(7037, e.DiagnosticCategory.Message, "Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for__7037", "Enables emit interoperability between CommonJS and ES Modules via creation of namespace objects for all imports. Implies 'allowSyntheticDefaultImports'."), Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead: a(7038, e.DiagnosticCategory.Message, "Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cau_7038", "Type originates at this import. A namespace-style import cannot be called or constructed, and will cause a failure at runtime. Consider using a default import or import require here instead."), Mapped_object_type_implicitly_has_an_any_template_type: a(7039, e.DiagnosticCategory.Error, "Mapped_object_type_implicitly_has_an_any_template_type_7039", "Mapped object type implicitly has an 'any' template type."), If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1: a(7040, e.DiagnosticCategory.Error, "If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_S_7040", "If the '{0}' package actually exposes this module, consider sending a pull request to amend 'https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/{1}'"), The_containing_arrow_function_captures_the_global_value_of_this: a(7041, e.DiagnosticCategory.Error, "The_containing_arrow_function_captures_the_global_value_of_this_7041", "The containing arrow function captures the global value of 'this'."), Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used: a(7042, e.DiagnosticCategory.Error, "Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used_7042", "Module '{0}' was resolved to '{1}', but '--resolveJsonModule' is not used."), Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: a(7043, e.DiagnosticCategory.Suggestion, "Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7043", "Variable '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."), Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: a(7044, e.DiagnosticCategory.Suggestion, "Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7044", "Parameter '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."), Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: a(7045, e.DiagnosticCategory.Suggestion, "Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7045", "Member '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."), Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage: a(7046, e.DiagnosticCategory.Suggestion, "Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage_7046", "Variable '{0}' implicitly has type '{1}' in some locations, but a better type may be inferred from usage."), Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage: a(7047, e.DiagnosticCategory.Suggestion, "Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage_7047", "Rest parameter '{0}' implicitly has an 'any[]' type, but a better type may be inferred from usage."), Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage: a(7048, e.DiagnosticCategory.Suggestion, "Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage_7048", "Property '{0}' implicitly has type 'any', but a better type for its get accessor may be inferred from usage."), Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage: a(7049, e.DiagnosticCategory.Suggestion, "Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage_7049", "Property '{0}' implicitly has type 'any', but a better type for its set accessor may be inferred from usage."), _0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage: a(7050, e.DiagnosticCategory.Suggestion, "_0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage_7050", "'{0}' implicitly has an '{1}' return type, but a better type may be inferred from usage."), Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1: a(7051, e.DiagnosticCategory.Error, "Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1_7051", "Parameter has a name but no type. Did you mean '{0}: {1}'?"), Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1: a(7052, e.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1_7052", "Element implicitly has an 'any' type because type '{0}' has no index signature. Did you mean to call '{1}'?"), Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1: a(7053, e.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1_7053", "Element implicitly has an 'any' type because expression of type '{0}' can't be used to index type '{1}'."), No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1: a(7054, e.DiagnosticCategory.Error, "No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1_7054", "No index signature with a parameter of type '{0}' was found on type '{1}'."), _0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type: a(7055, e.DiagnosticCategory.Error, "_0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type_7055", "'{0}', which lacks return-type annotation, implicitly has an '{1}' yield type."), The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_type_annotation_is_needed: a(7056, e.DiagnosticCategory.Error, "The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_ty_7056", "The inferred type of this node exceeds the maximum length the compiler will serialize. An explicit type annotation is needed."), yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_type_annotation: a(7057, e.DiagnosticCategory.Error, "yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_t_7057", "'yield' expression implicitly results in an 'any' type because its containing generator lacks a return-type annotation."), If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_declare_module_1: a(7058, e.DiagnosticCategory.Error, "If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_decl_7058", "If the '{0}' package actually exposes this module, try adding a new declaration (.d.ts) file containing `declare module '{1}';`"), This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead: a(7059, e.DiagnosticCategory.Error, "This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead_7059", "This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead."), This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_constraint: a(7060, e.DiagnosticCategory.Error, "This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_cons_7060", "This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma or explicit constraint."), A_mapped_type_may_not_declare_properties_or_methods: a(7061, e.DiagnosticCategory.Error, "A_mapped_type_may_not_declare_properties_or_methods_7061", "A mapped type may not declare properties or methods."), You_cannot_rename_this_element: a(8e3, e.DiagnosticCategory.Error, "You_cannot_rename_this_element_8000", "You cannot rename this element."), You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library: a(8001, e.DiagnosticCategory.Error, "You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library_8001", "You cannot rename elements that are defined in the standard TypeScript library."), import_can_only_be_used_in_TypeScript_files: a(8002, e.DiagnosticCategory.Error, "import_can_only_be_used_in_TypeScript_files_8002", "'import ... =' can only be used in TypeScript files."), export_can_only_be_used_in_TypeScript_files: a(8003, e.DiagnosticCategory.Error, "export_can_only_be_used_in_TypeScript_files_8003", "'export =' can only be used in TypeScript files."), Type_parameter_declarations_can_only_be_used_in_TypeScript_files: a(8004, e.DiagnosticCategory.Error, "Type_parameter_declarations_can_only_be_used_in_TypeScript_files_8004", "Type parameter declarations can only be used in TypeScript files."), implements_clauses_can_only_be_used_in_TypeScript_files: a(8005, e.DiagnosticCategory.Error, "implements_clauses_can_only_be_used_in_TypeScript_files_8005", "'implements' clauses can only be used in TypeScript files."), _0_declarations_can_only_be_used_in_TypeScript_files: a(8006, e.DiagnosticCategory.Error, "_0_declarations_can_only_be_used_in_TypeScript_files_8006", "'{0}' declarations can only be used in TypeScript files."), Type_aliases_can_only_be_used_in_TypeScript_files: a(8008, e.DiagnosticCategory.Error, "Type_aliases_can_only_be_used_in_TypeScript_files_8008", "Type aliases can only be used in TypeScript files."), The_0_modifier_can_only_be_used_in_TypeScript_files: a(8009, e.DiagnosticCategory.Error, "The_0_modifier_can_only_be_used_in_TypeScript_files_8009", "The '{0}' modifier can only be used in TypeScript files."), Type_annotations_can_only_be_used_in_TypeScript_files: a(8010, e.DiagnosticCategory.Error, "Type_annotations_can_only_be_used_in_TypeScript_files_8010", "Type annotations can only be used in TypeScript files."), Type_arguments_can_only_be_used_in_TypeScript_files: a(8011, e.DiagnosticCategory.Error, "Type_arguments_can_only_be_used_in_TypeScript_files_8011", "Type arguments can only be used in TypeScript files."), Parameter_modifiers_can_only_be_used_in_TypeScript_files: a(8012, e.DiagnosticCategory.Error, "Parameter_modifiers_can_only_be_used_in_TypeScript_files_8012", "Parameter modifiers can only be used in TypeScript files."), Non_null_assertions_can_only_be_used_in_TypeScript_files: a(8013, e.DiagnosticCategory.Error, "Non_null_assertions_can_only_be_used_in_TypeScript_files_8013", "Non-null assertions can only be used in TypeScript files."), Type_assertion_expressions_can_only_be_used_in_TypeScript_files: a(8016, e.DiagnosticCategory.Error, "Type_assertion_expressions_can_only_be_used_in_TypeScript_files_8016", "Type assertion expressions can only be used in TypeScript files."), Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0: a(8017, e.DiagnosticCategory.Error, "Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0_8017", "Octal literal types must use ES2015 syntax. Use the syntax '{0}'."), Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0: a(8018, e.DiagnosticCategory.Error, "Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0_8018", "Octal literals are not allowed in enums members initializer. Use the syntax '{0}'."), Report_errors_in_js_files: a(8019, e.DiagnosticCategory.Message, "Report_errors_in_js_files_8019", "Report errors in .js files."), JSDoc_types_can_only_be_used_inside_documentation_comments: a(8020, e.DiagnosticCategory.Error, "JSDoc_types_can_only_be_used_inside_documentation_comments_8020", "JSDoc types can only be used inside documentation comments."), JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags: a(8021, e.DiagnosticCategory.Error, "JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags_8021", "JSDoc '@typedef' tag should either have a type annotation or be followed by '@property' or '@member' tags."), JSDoc_0_is_not_attached_to_a_class: a(8022, e.DiagnosticCategory.Error, "JSDoc_0_is_not_attached_to_a_class_8022", "JSDoc '@{0}' is not attached to a class."), JSDoc_0_1_does_not_match_the_extends_2_clause: a(8023, e.DiagnosticCategory.Error, "JSDoc_0_1_does_not_match_the_extends_2_clause_8023", "JSDoc '@{0} {1}' does not match the 'extends {2}' clause."), JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name: a(8024, e.DiagnosticCategory.Error, "JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_8024", "JSDoc '@param' tag has name '{0}', but there is no parameter with that name."), Class_declarations_cannot_have_more_than_one_augments_or_extends_tag: a(8025, e.DiagnosticCategory.Error, "Class_declarations_cannot_have_more_than_one_augments_or_extends_tag_8025", "Class declarations cannot have more than one '@augments' or '@extends' tag."), Expected_0_type_arguments_provide_these_with_an_extends_tag: a(8026, e.DiagnosticCategory.Error, "Expected_0_type_arguments_provide_these_with_an_extends_tag_8026", "Expected {0} type arguments; provide these with an '@extends' tag."), Expected_0_1_type_arguments_provide_these_with_an_extends_tag: a(8027, e.DiagnosticCategory.Error, "Expected_0_1_type_arguments_provide_these_with_an_extends_tag_8027", "Expected {0}-{1} type arguments; provide these with an '@extends' tag."), JSDoc_may_only_appear_in_the_last_parameter_of_a_signature: a(8028, e.DiagnosticCategory.Error, "JSDoc_may_only_appear_in_the_last_parameter_of_a_signature_8028", "JSDoc '...' may only appear in the last parameter of a signature."), JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type: a(8029, e.DiagnosticCategory.Error, "JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_h_8029", "JSDoc '@param' tag has name '{0}', but there is no parameter with that name. It would match 'arguments' if it had an array type."), The_type_of_a_function_declaration_must_match_the_function_s_signature: a(8030, e.DiagnosticCategory.Error, "The_type_of_a_function_declaration_must_match_the_function_s_signature_8030", "The type of a function declaration must match the function's signature."), You_cannot_rename_a_module_via_a_global_import: a(8031, e.DiagnosticCategory.Error, "You_cannot_rename_a_module_via_a_global_import_8031", "You cannot rename a module via a global import."), Qualified_name_0_is_not_allowed_without_a_leading_param_object_1: a(8032, e.DiagnosticCategory.Error, "Qualified_name_0_is_not_allowed_without_a_leading_param_object_1_8032", "Qualified name '{0}' is not allowed without a leading '@param {object} {1}'."), A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags: a(8033, e.DiagnosticCategory.Error, "A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags_8033", "A JSDoc '@typedef' comment may not contain multiple '@type' tags."), The_tag_was_first_specified_here: a(8034, e.DiagnosticCategory.Error, "The_tag_was_first_specified_here_8034", "The tag was first specified here."), Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_declaration_emit: a(9005, e.DiagnosticCategory.Error, "Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_9005", "Declaration emit for this file requires using private name '{0}'. An explicit type annotation may unblock declaration emit."), Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotation_may_unblock_declaration_emit: a(9006, e.DiagnosticCategory.Error, "Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotati_9006", "Declaration emit for this file requires using private name '{0}' from module '{1}'. An explicit type annotation may unblock declaration emit."), JSX_attributes_must_only_be_assigned_a_non_empty_expression: a(17e3, e.DiagnosticCategory.Error, "JSX_attributes_must_only_be_assigned_a_non_empty_expression_17000", "JSX attributes must only be assigned a non-empty 'expression'."), JSX_elements_cannot_have_multiple_attributes_with_the_same_name: a(17001, e.DiagnosticCategory.Error, "JSX_elements_cannot_have_multiple_attributes_with_the_same_name_17001", "JSX elements cannot have multiple attributes with the same name."), Expected_corresponding_JSX_closing_tag_for_0: a(17002, e.DiagnosticCategory.Error, "Expected_corresponding_JSX_closing_tag_for_0_17002", "Expected corresponding JSX closing tag for '{0}'."), Cannot_use_JSX_unless_the_jsx_flag_is_provided: a(17004, e.DiagnosticCategory.Error, "Cannot_use_JSX_unless_the_jsx_flag_is_provided_17004", "Cannot use JSX unless the '--jsx' flag is provided."), A_constructor_cannot_contain_a_super_call_when_its_class_extends_null: a(17005, e.DiagnosticCategory.Error, "A_constructor_cannot_contain_a_super_call_when_its_class_extends_null_17005", "A constructor cannot contain a 'super' call when its class extends 'null'."), An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses: a(17006, e.DiagnosticCategory.Error, "An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_ex_17006", "An unary expression with the '{0}' operator is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."), A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses: a(17007, e.DiagnosticCategory.Error, "A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Con_17007", "A type assertion expression is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."), JSX_element_0_has_no_corresponding_closing_tag: a(17008, e.DiagnosticCategory.Error, "JSX_element_0_has_no_corresponding_closing_tag_17008", "JSX element '{0}' has no corresponding closing tag."), super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class: a(17009, e.DiagnosticCategory.Error, "super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class_17009", "'super' must be called before accessing 'this' in the constructor of a derived class."), Unknown_type_acquisition_option_0: a(17010, e.DiagnosticCategory.Error, "Unknown_type_acquisition_option_0_17010", "Unknown type acquisition option '{0}'."), super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class: a(17011, e.DiagnosticCategory.Error, "super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class_17011", "'super' must be called before accessing a property of 'super' in the constructor of a derived class."), _0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2: a(17012, e.DiagnosticCategory.Error, "_0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2_17012", "'{0}' is not a valid meta-property for keyword '{1}'. Did you mean '{2}'?"), Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor: a(17013, e.DiagnosticCategory.Error, "Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constru_17013", "Meta-property '{0}' is only allowed in the body of a function declaration, function expression, or constructor."), JSX_fragment_has_no_corresponding_closing_tag: a(17014, e.DiagnosticCategory.Error, "JSX_fragment_has_no_corresponding_closing_tag_17014", "JSX fragment has no corresponding closing tag."), Expected_corresponding_closing_tag_for_JSX_fragment: a(17015, e.DiagnosticCategory.Error, "Expected_corresponding_closing_tag_for_JSX_fragment_17015", "Expected corresponding closing tag for JSX fragment."), The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_compiler_option: a(17016, e.DiagnosticCategory.Error, "The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_com_17016", "The 'jsxFragmentFactory' compiler option must be provided to use JSX fragments with the 'jsxFactory' compiler option."), An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments: a(17017, e.DiagnosticCategory.Error, "An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments_17017", "An @jsxFrag pragma is required when using an @jsx pragma with JSX fragments."), Unknown_type_acquisition_option_0_Did_you_mean_1: a(17018, e.DiagnosticCategory.Error, "Unknown_type_acquisition_option_0_Did_you_mean_1_17018", "Unknown type acquisition option '{0}'. Did you mean '{1}'?"), Circularity_detected_while_resolving_configuration_Colon_0: a(18e3, e.DiagnosticCategory.Error, "Circularity_detected_while_resolving_configuration_Colon_0_18000", "Circularity detected while resolving configuration: {0}"), The_files_list_in_config_file_0_is_empty: a(18002, e.DiagnosticCategory.Error, "The_files_list_in_config_file_0_is_empty_18002", "The 'files' list in config file '{0}' is empty."), No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2: a(18003, e.DiagnosticCategory.Error, "No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2_18003", "No inputs were found in config file '{0}'. Specified 'include' paths were '{1}' and 'exclude' paths were '{2}'."), File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module: a(80001, e.DiagnosticCategory.Suggestion, "File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module_80001", "File is a CommonJS module; it may be converted to an ES module."), This_constructor_function_may_be_converted_to_a_class_declaration: a(80002, e.DiagnosticCategory.Suggestion, "This_constructor_function_may_be_converted_to_a_class_declaration_80002", "This constructor function may be converted to a class declaration."), Import_may_be_converted_to_a_default_import: a(80003, e.DiagnosticCategory.Suggestion, "Import_may_be_converted_to_a_default_import_80003", "Import may be converted to a default import."), JSDoc_types_may_be_moved_to_TypeScript_types: a(80004, e.DiagnosticCategory.Suggestion, "JSDoc_types_may_be_moved_to_TypeScript_types_80004", "JSDoc types may be moved to TypeScript types."), require_call_may_be_converted_to_an_import: a(80005, e.DiagnosticCategory.Suggestion, "require_call_may_be_converted_to_an_import_80005", "'require' call may be converted to an import."), This_may_be_converted_to_an_async_function: a(80006, e.DiagnosticCategory.Suggestion, "This_may_be_converted_to_an_async_function_80006", "This may be converted to an async function."), await_has_no_effect_on_the_type_of_this_expression: a(80007, e.DiagnosticCategory.Suggestion, "await_has_no_effect_on_the_type_of_this_expression_80007", "'await' has no effect on the type of this expression."), Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers: a(80008, e.DiagnosticCategory.Suggestion, "Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accur_80008", "Numeric literals with absolute values equal to 2^53 or greater are too large to be represented accurately as integers."), Add_missing_super_call: a(90001, e.DiagnosticCategory.Message, "Add_missing_super_call_90001", "Add missing 'super()' call"), Make_super_call_the_first_statement_in_the_constructor: a(90002, e.DiagnosticCategory.Message, "Make_super_call_the_first_statement_in_the_constructor_90002", "Make 'super()' call the first statement in the constructor"), Change_extends_to_implements: a(90003, e.DiagnosticCategory.Message, "Change_extends_to_implements_90003", "Change 'extends' to 'implements'"), Remove_unused_declaration_for_Colon_0: a(90004, e.DiagnosticCategory.Message, "Remove_unused_declaration_for_Colon_0_90004", "Remove unused declaration for: '{0}'"), Remove_import_from_0: a(90005, e.DiagnosticCategory.Message, "Remove_import_from_0_90005", "Remove import from '{0}'"), Implement_interface_0: a(90006, e.DiagnosticCategory.Message, "Implement_interface_0_90006", "Implement interface '{0}'"), Implement_inherited_abstract_class: a(90007, e.DiagnosticCategory.Message, "Implement_inherited_abstract_class_90007", "Implement inherited abstract class"), Add_0_to_unresolved_variable: a(90008, e.DiagnosticCategory.Message, "Add_0_to_unresolved_variable_90008", "Add '{0}.' to unresolved variable"), Remove_variable_statement: a(90010, e.DiagnosticCategory.Message, "Remove_variable_statement_90010", "Remove variable statement"), Remove_template_tag: a(90011, e.DiagnosticCategory.Message, "Remove_template_tag_90011", "Remove template tag"), Remove_type_parameters: a(90012, e.DiagnosticCategory.Message, "Remove_type_parameters_90012", "Remove type parameters"), Import_0_from_1: a(90013, e.DiagnosticCategory.Message, "Import_0_from_1_90013", `Import '{0}' from "{1}"`), Change_0_to_1: a(90014, e.DiagnosticCategory.Message, "Change_0_to_1_90014", "Change '{0}' to '{1}'"), Declare_property_0: a(90016, e.DiagnosticCategory.Message, "Declare_property_0_90016", "Declare property '{0}'"), Add_index_signature_for_property_0: a(90017, e.DiagnosticCategory.Message, "Add_index_signature_for_property_0_90017", "Add index signature for property '{0}'"), Disable_checking_for_this_file: a(90018, e.DiagnosticCategory.Message, "Disable_checking_for_this_file_90018", "Disable checking for this file"), Ignore_this_error_message: a(90019, e.DiagnosticCategory.Message, "Ignore_this_error_message_90019", "Ignore this error message"), Initialize_property_0_in_the_constructor: a(90020, e.DiagnosticCategory.Message, "Initialize_property_0_in_the_constructor_90020", "Initialize property '{0}' in the constructor"), Initialize_static_property_0: a(90021, e.DiagnosticCategory.Message, "Initialize_static_property_0_90021", "Initialize static property '{0}'"), Change_spelling_to_0: a(90022, e.DiagnosticCategory.Message, "Change_spelling_to_0_90022", "Change spelling to '{0}'"), Declare_method_0: a(90023, e.DiagnosticCategory.Message, "Declare_method_0_90023", "Declare method '{0}'"), Declare_static_method_0: a(90024, e.DiagnosticCategory.Message, "Declare_static_method_0_90024", "Declare static method '{0}'"), Prefix_0_with_an_underscore: a(90025, e.DiagnosticCategory.Message, "Prefix_0_with_an_underscore_90025", "Prefix '{0}' with an underscore"), Rewrite_as_the_indexed_access_type_0: a(90026, e.DiagnosticCategory.Message, "Rewrite_as_the_indexed_access_type_0_90026", "Rewrite as the indexed access type '{0}'"), Declare_static_property_0: a(90027, e.DiagnosticCategory.Message, "Declare_static_property_0_90027", "Declare static property '{0}'"), Call_decorator_expression: a(90028, e.DiagnosticCategory.Message, "Call_decorator_expression_90028", "Call decorator expression"), Add_async_modifier_to_containing_function: a(90029, e.DiagnosticCategory.Message, "Add_async_modifier_to_containing_function_90029", "Add async modifier to containing function"), Replace_infer_0_with_unknown: a(90030, e.DiagnosticCategory.Message, "Replace_infer_0_with_unknown_90030", "Replace 'infer {0}' with 'unknown'"), Replace_all_unused_infer_with_unknown: a(90031, e.DiagnosticCategory.Message, "Replace_all_unused_infer_with_unknown_90031", "Replace all unused 'infer' with 'unknown'"), Add_parameter_name: a(90034, e.DiagnosticCategory.Message, "Add_parameter_name_90034", "Add parameter name"), Declare_private_property_0: a(90035, e.DiagnosticCategory.Message, "Declare_private_property_0_90035", "Declare private property '{0}'"), Replace_0_with_Promise_1: a(90036, e.DiagnosticCategory.Message, "Replace_0_with_Promise_1_90036", "Replace '{0}' with 'Promise<{1}>'"), Fix_all_incorrect_return_type_of_an_async_functions: a(90037, e.DiagnosticCategory.Message, "Fix_all_incorrect_return_type_of_an_async_functions_90037", "Fix all incorrect return type of an async functions"), Declare_private_method_0: a(90038, e.DiagnosticCategory.Message, "Declare_private_method_0_90038", "Declare private method '{0}'"), Remove_unused_destructuring_declaration: a(90039, e.DiagnosticCategory.Message, "Remove_unused_destructuring_declaration_90039", "Remove unused destructuring declaration"), Remove_unused_declarations_for_Colon_0: a(90041, e.DiagnosticCategory.Message, "Remove_unused_declarations_for_Colon_0_90041", "Remove unused declarations for: '{0}'"), Declare_a_private_field_named_0: a(90053, e.DiagnosticCategory.Message, "Declare_a_private_field_named_0_90053", "Declare a private field named '{0}'."), Includes_imports_of_types_referenced_by_0: a(90054, e.DiagnosticCategory.Message, "Includes_imports_of_types_referenced_by_0_90054", "Includes imports of types referenced by '{0}'"), Remove_type_from_import_declaration_from_0: a(90055, e.DiagnosticCategory.Message, "Remove_type_from_import_declaration_from_0_90055", `Remove 'type' from import declaration from "{0}"`), Remove_type_from_import_of_0_from_1: a(90056, e.DiagnosticCategory.Message, "Remove_type_from_import_of_0_from_1_90056", `Remove 'type' from import of '{0}' from "{1}"`), Add_import_from_0: a(90057, e.DiagnosticCategory.Message, "Add_import_from_0_90057", 'Add import from "{0}"'), Update_import_from_0: a(90058, e.DiagnosticCategory.Message, "Update_import_from_0_90058", 'Update import from "{0}"'), Convert_function_to_an_ES2015_class: a(95001, e.DiagnosticCategory.Message, "Convert_function_to_an_ES2015_class_95001", "Convert function to an ES2015 class"), Convert_0_to_1_in_0: a(95003, e.DiagnosticCategory.Message, "Convert_0_to_1_in_0_95003", "Convert '{0}' to '{1} in {0}'"), Extract_to_0_in_1: a(95004, e.DiagnosticCategory.Message, "Extract_to_0_in_1_95004", "Extract to {0} in {1}"), Extract_function: a(95005, e.DiagnosticCategory.Message, "Extract_function_95005", "Extract function"), Extract_constant: a(95006, e.DiagnosticCategory.Message, "Extract_constant_95006", "Extract constant"), Extract_to_0_in_enclosing_scope: a(95007, e.DiagnosticCategory.Message, "Extract_to_0_in_enclosing_scope_95007", "Extract to {0} in enclosing scope"), Extract_to_0_in_1_scope: a(95008, e.DiagnosticCategory.Message, "Extract_to_0_in_1_scope_95008", "Extract to {0} in {1} scope"), Annotate_with_type_from_JSDoc: a(95009, e.DiagnosticCategory.Message, "Annotate_with_type_from_JSDoc_95009", "Annotate with type from JSDoc"), Infer_type_of_0_from_usage: a(95011, e.DiagnosticCategory.Message, "Infer_type_of_0_from_usage_95011", "Infer type of '{0}' from usage"), Infer_parameter_types_from_usage: a(95012, e.DiagnosticCategory.Message, "Infer_parameter_types_from_usage_95012", "Infer parameter types from usage"), Convert_to_default_import: a(95013, e.DiagnosticCategory.Message, "Convert_to_default_import_95013", "Convert to default import"), Install_0: a(95014, e.DiagnosticCategory.Message, "Install_0_95014", "Install '{0}'"), Replace_import_with_0: a(95015, e.DiagnosticCategory.Message, "Replace_import_with_0_95015", "Replace import with '{0}'."), Use_synthetic_default_member: a(95016, e.DiagnosticCategory.Message, "Use_synthetic_default_member_95016", "Use synthetic 'default' member."), Convert_to_ES_module: a(95017, e.DiagnosticCategory.Message, "Convert_to_ES_module_95017", "Convert to ES module"), Add_undefined_type_to_property_0: a(95018, e.DiagnosticCategory.Message, "Add_undefined_type_to_property_0_95018", "Add 'undefined' type to property '{0}'"), Add_initializer_to_property_0: a(95019, e.DiagnosticCategory.Message, "Add_initializer_to_property_0_95019", "Add initializer to property '{0}'"), Add_definite_assignment_assertion_to_property_0: a(95020, e.DiagnosticCategory.Message, "Add_definite_assignment_assertion_to_property_0_95020", "Add definite assignment assertion to property '{0}'"), Convert_all_type_literals_to_mapped_type: a(95021, e.DiagnosticCategory.Message, "Convert_all_type_literals_to_mapped_type_95021", "Convert all type literals to mapped type"), Add_all_missing_members: a(95022, e.DiagnosticCategory.Message, "Add_all_missing_members_95022", "Add all missing members"), Infer_all_types_from_usage: a(95023, e.DiagnosticCategory.Message, "Infer_all_types_from_usage_95023", "Infer all types from usage"), Delete_all_unused_declarations: a(95024, e.DiagnosticCategory.Message, "Delete_all_unused_declarations_95024", "Delete all unused declarations"), Prefix_all_unused_declarations_with_where_possible: a(95025, e.DiagnosticCategory.Message, "Prefix_all_unused_declarations_with_where_possible_95025", "Prefix all unused declarations with '_' where possible"), Fix_all_detected_spelling_errors: a(95026, e.DiagnosticCategory.Message, "Fix_all_detected_spelling_errors_95026", "Fix all detected spelling errors"), Add_initializers_to_all_uninitialized_properties: a(95027, e.DiagnosticCategory.Message, "Add_initializers_to_all_uninitialized_properties_95027", "Add initializers to all uninitialized properties"), Add_definite_assignment_assertions_to_all_uninitialized_properties: a(95028, e.DiagnosticCategory.Message, "Add_definite_assignment_assertions_to_all_uninitialized_properties_95028", "Add definite assignment assertions to all uninitialized properties"), Add_undefined_type_to_all_uninitialized_properties: a(95029, e.DiagnosticCategory.Message, "Add_undefined_type_to_all_uninitialized_properties_95029", "Add undefined type to all uninitialized properties"), Change_all_jsdoc_style_types_to_TypeScript: a(95030, e.DiagnosticCategory.Message, "Change_all_jsdoc_style_types_to_TypeScript_95030", "Change all jsdoc-style types to TypeScript"), Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types: a(95031, e.DiagnosticCategory.Message, "Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types_95031", "Change all jsdoc-style types to TypeScript (and add '| undefined' to nullable types)"), Implement_all_unimplemented_interfaces: a(95032, e.DiagnosticCategory.Message, "Implement_all_unimplemented_interfaces_95032", "Implement all unimplemented interfaces"), Install_all_missing_types_packages: a(95033, e.DiagnosticCategory.Message, "Install_all_missing_types_packages_95033", "Install all missing types packages"), Rewrite_all_as_indexed_access_types: a(95034, e.DiagnosticCategory.Message, "Rewrite_all_as_indexed_access_types_95034", "Rewrite all as indexed access types"), Convert_all_to_default_imports: a(95035, e.DiagnosticCategory.Message, "Convert_all_to_default_imports_95035", "Convert all to default imports"), Make_all_super_calls_the_first_statement_in_their_constructor: a(95036, e.DiagnosticCategory.Message, "Make_all_super_calls_the_first_statement_in_their_constructor_95036", "Make all 'super()' calls the first statement in their constructor"), Add_qualifier_to_all_unresolved_variables_matching_a_member_name: a(95037, e.DiagnosticCategory.Message, "Add_qualifier_to_all_unresolved_variables_matching_a_member_name_95037", "Add qualifier to all unresolved variables matching a member name"), Change_all_extended_interfaces_to_implements: a(95038, e.DiagnosticCategory.Message, "Change_all_extended_interfaces_to_implements_95038", "Change all extended interfaces to 'implements'"), Add_all_missing_super_calls: a(95039, e.DiagnosticCategory.Message, "Add_all_missing_super_calls_95039", "Add all missing super calls"), Implement_all_inherited_abstract_classes: a(95040, e.DiagnosticCategory.Message, "Implement_all_inherited_abstract_classes_95040", "Implement all inherited abstract classes"), Add_all_missing_async_modifiers: a(95041, e.DiagnosticCategory.Message, "Add_all_missing_async_modifiers_95041", "Add all missing 'async' modifiers"), Add_ts_ignore_to_all_error_messages: a(95042, e.DiagnosticCategory.Message, "Add_ts_ignore_to_all_error_messages_95042", "Add '@ts-ignore' to all error messages"), Annotate_everything_with_types_from_JSDoc: a(95043, e.DiagnosticCategory.Message, "Annotate_everything_with_types_from_JSDoc_95043", "Annotate everything with types from JSDoc"), Add_to_all_uncalled_decorators: a(95044, e.DiagnosticCategory.Message, "Add_to_all_uncalled_decorators_95044", "Add '()' to all uncalled decorators"), Convert_all_constructor_functions_to_classes: a(95045, e.DiagnosticCategory.Message, "Convert_all_constructor_functions_to_classes_95045", "Convert all constructor functions to classes"), Generate_get_and_set_accessors: a(95046, e.DiagnosticCategory.Message, "Generate_get_and_set_accessors_95046", "Generate 'get' and 'set' accessors"), Convert_require_to_import: a(95047, e.DiagnosticCategory.Message, "Convert_require_to_import_95047", "Convert 'require' to 'import'"), Convert_all_require_to_import: a(95048, e.DiagnosticCategory.Message, "Convert_all_require_to_import_95048", "Convert all 'require' to 'import'"), Move_to_a_new_file: a(95049, e.DiagnosticCategory.Message, "Move_to_a_new_file_95049", "Move to a new file"), Remove_unreachable_code: a(95050, e.DiagnosticCategory.Message, "Remove_unreachable_code_95050", "Remove unreachable code"), Remove_all_unreachable_code: a(95051, e.DiagnosticCategory.Message, "Remove_all_unreachable_code_95051", "Remove all unreachable code"), Add_missing_typeof: a(95052, e.DiagnosticCategory.Message, "Add_missing_typeof_95052", "Add missing 'typeof'"), Remove_unused_label: a(95053, e.DiagnosticCategory.Message, "Remove_unused_label_95053", "Remove unused label"), Remove_all_unused_labels: a(95054, e.DiagnosticCategory.Message, "Remove_all_unused_labels_95054", "Remove all unused labels"), Convert_0_to_mapped_object_type: a(95055, e.DiagnosticCategory.Message, "Convert_0_to_mapped_object_type_95055", "Convert '{0}' to mapped object type"), Convert_namespace_import_to_named_imports: a(95056, e.DiagnosticCategory.Message, "Convert_namespace_import_to_named_imports_95056", "Convert namespace import to named imports"), Convert_named_imports_to_namespace_import: a(95057, e.DiagnosticCategory.Message, "Convert_named_imports_to_namespace_import_95057", "Convert named imports to namespace import"), Add_or_remove_braces_in_an_arrow_function: a(95058, e.DiagnosticCategory.Message, "Add_or_remove_braces_in_an_arrow_function_95058", "Add or remove braces in an arrow function"), Add_braces_to_arrow_function: a(95059, e.DiagnosticCategory.Message, "Add_braces_to_arrow_function_95059", "Add braces to arrow function"), Remove_braces_from_arrow_function: a(95060, e.DiagnosticCategory.Message, "Remove_braces_from_arrow_function_95060", "Remove braces from arrow function"), Convert_default_export_to_named_export: a(95061, e.DiagnosticCategory.Message, "Convert_default_export_to_named_export_95061", "Convert default export to named export"), Convert_named_export_to_default_export: a(95062, e.DiagnosticCategory.Message, "Convert_named_export_to_default_export_95062", "Convert named export to default export"), Add_missing_enum_member_0: a(95063, e.DiagnosticCategory.Message, "Add_missing_enum_member_0_95063", "Add missing enum member '{0}'"), Add_all_missing_imports: a(95064, e.DiagnosticCategory.Message, "Add_all_missing_imports_95064", "Add all missing imports"), Convert_to_async_function: a(95065, e.DiagnosticCategory.Message, "Convert_to_async_function_95065", "Convert to async function"), Convert_all_to_async_functions: a(95066, e.DiagnosticCategory.Message, "Convert_all_to_async_functions_95066", "Convert all to async functions"), Add_missing_call_parentheses: a(95067, e.DiagnosticCategory.Message, "Add_missing_call_parentheses_95067", "Add missing call parentheses"), Add_all_missing_call_parentheses: a(95068, e.DiagnosticCategory.Message, "Add_all_missing_call_parentheses_95068", "Add all missing call parentheses"), Add_unknown_conversion_for_non_overlapping_types: a(95069, e.DiagnosticCategory.Message, "Add_unknown_conversion_for_non_overlapping_types_95069", "Add 'unknown' conversion for non-overlapping types"), Add_unknown_to_all_conversions_of_non_overlapping_types: a(95070, e.DiagnosticCategory.Message, "Add_unknown_to_all_conversions_of_non_overlapping_types_95070", "Add 'unknown' to all conversions of non-overlapping types"), Add_missing_new_operator_to_call: a(95071, e.DiagnosticCategory.Message, "Add_missing_new_operator_to_call_95071", "Add missing 'new' operator to call"), Add_missing_new_operator_to_all_calls: a(95072, e.DiagnosticCategory.Message, "Add_missing_new_operator_to_all_calls_95072", "Add missing 'new' operator to all calls"), Add_names_to_all_parameters_without_names: a(95073, e.DiagnosticCategory.Message, "Add_names_to_all_parameters_without_names_95073", "Add names to all parameters without names"), Enable_the_experimentalDecorators_option_in_your_configuration_file: a(95074, e.DiagnosticCategory.Message, "Enable_the_experimentalDecorators_option_in_your_configuration_file_95074", "Enable the 'experimentalDecorators' option in your configuration file"), Convert_parameters_to_destructured_object: a(95075, e.DiagnosticCategory.Message, "Convert_parameters_to_destructured_object_95075", "Convert parameters to destructured object"), Extract_type: a(95077, e.DiagnosticCategory.Message, "Extract_type_95077", "Extract type"), Extract_to_type_alias: a(95078, e.DiagnosticCategory.Message, "Extract_to_type_alias_95078", "Extract to type alias"), Extract_to_typedef: a(95079, e.DiagnosticCategory.Message, "Extract_to_typedef_95079", "Extract to typedef"), Infer_this_type_of_0_from_usage: a(95080, e.DiagnosticCategory.Message, "Infer_this_type_of_0_from_usage_95080", "Infer 'this' type of '{0}' from usage"), Add_const_to_unresolved_variable: a(95081, e.DiagnosticCategory.Message, "Add_const_to_unresolved_variable_95081", "Add 'const' to unresolved variable"), Add_const_to_all_unresolved_variables: a(95082, e.DiagnosticCategory.Message, "Add_const_to_all_unresolved_variables_95082", "Add 'const' to all unresolved variables"), Add_await: a(95083, e.DiagnosticCategory.Message, "Add_await_95083", "Add 'await'"), Add_await_to_initializer_for_0: a(95084, e.DiagnosticCategory.Message, "Add_await_to_initializer_for_0_95084", "Add 'await' to initializer for '{0}'"), Fix_all_expressions_possibly_missing_await: a(95085, e.DiagnosticCategory.Message, "Fix_all_expressions_possibly_missing_await_95085", "Fix all expressions possibly missing 'await'"), Remove_unnecessary_await: a(95086, e.DiagnosticCategory.Message, "Remove_unnecessary_await_95086", "Remove unnecessary 'await'"), Remove_all_unnecessary_uses_of_await: a(95087, e.DiagnosticCategory.Message, "Remove_all_unnecessary_uses_of_await_95087", "Remove all unnecessary uses of 'await'"), Enable_the_jsx_flag_in_your_configuration_file: a(95088, e.DiagnosticCategory.Message, "Enable_the_jsx_flag_in_your_configuration_file_95088", "Enable the '--jsx' flag in your configuration file"), Add_await_to_initializers: a(95089, e.DiagnosticCategory.Message, "Add_await_to_initializers_95089", "Add 'await' to initializers"), Extract_to_interface: a(95090, e.DiagnosticCategory.Message, "Extract_to_interface_95090", "Extract to interface"), Convert_to_a_bigint_numeric_literal: a(95091, e.DiagnosticCategory.Message, "Convert_to_a_bigint_numeric_literal_95091", "Convert to a bigint numeric literal"), Convert_all_to_bigint_numeric_literals: a(95092, e.DiagnosticCategory.Message, "Convert_all_to_bigint_numeric_literals_95092", "Convert all to bigint numeric literals"), Convert_const_to_let: a(95093, e.DiagnosticCategory.Message, "Convert_const_to_let_95093", "Convert 'const' to 'let'"), Prefix_with_declare: a(95094, e.DiagnosticCategory.Message, "Prefix_with_declare_95094", "Prefix with 'declare'"), Prefix_all_incorrect_property_declarations_with_declare: a(95095, e.DiagnosticCategory.Message, "Prefix_all_incorrect_property_declarations_with_declare_95095", "Prefix all incorrect property declarations with 'declare'"), Convert_to_template_string: a(95096, e.DiagnosticCategory.Message, "Convert_to_template_string_95096", "Convert to template string"), Add_export_to_make_this_file_into_a_module: a(95097, e.DiagnosticCategory.Message, "Add_export_to_make_this_file_into_a_module_95097", "Add 'export {}' to make this file into a module"), Set_the_target_option_in_your_configuration_file_to_0: a(95098, e.DiagnosticCategory.Message, "Set_the_target_option_in_your_configuration_file_to_0_95098", "Set the 'target' option in your configuration file to '{0}'"), Set_the_module_option_in_your_configuration_file_to_0: a(95099, e.DiagnosticCategory.Message, "Set_the_module_option_in_your_configuration_file_to_0_95099", "Set the 'module' option in your configuration file to '{0}'"), Convert_invalid_character_to_its_html_entity_code: a(95100, e.DiagnosticCategory.Message, "Convert_invalid_character_to_its_html_entity_code_95100", "Convert invalid character to its html entity code"), Convert_all_invalid_characters_to_HTML_entity_code: a(95101, e.DiagnosticCategory.Message, "Convert_all_invalid_characters_to_HTML_entity_code_95101", "Convert all invalid characters to HTML entity code"), Convert_function_expression_0_to_arrow_function: a(95105, e.DiagnosticCategory.Message, "Convert_function_expression_0_to_arrow_function_95105", "Convert function expression '{0}' to arrow function"), Convert_function_declaration_0_to_arrow_function: a(95106, e.DiagnosticCategory.Message, "Convert_function_declaration_0_to_arrow_function_95106", "Convert function declaration '{0}' to arrow function"), Fix_all_implicit_this_errors: a(95107, e.DiagnosticCategory.Message, "Fix_all_implicit_this_errors_95107", "Fix all implicit-'this' errors"), Wrap_invalid_character_in_an_expression_container: a(95108, e.DiagnosticCategory.Message, "Wrap_invalid_character_in_an_expression_container_95108", "Wrap invalid character in an expression container"), Wrap_all_invalid_characters_in_an_expression_container: a(95109, e.DiagnosticCategory.Message, "Wrap_all_invalid_characters_in_an_expression_container_95109", "Wrap all invalid characters in an expression container"), Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file: a(95110, e.DiagnosticCategory.Message, "Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file_95110", "Visit https://aka.ms/tsconfig to read more about this file"), Add_a_return_statement: a(95111, e.DiagnosticCategory.Message, "Add_a_return_statement_95111", "Add a return statement"), Remove_braces_from_arrow_function_body: a(95112, e.DiagnosticCategory.Message, "Remove_braces_from_arrow_function_body_95112", "Remove braces from arrow function body"), Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal: a(95113, e.DiagnosticCategory.Message, "Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal_95113", "Wrap the following body with parentheses which should be an object literal"), Add_all_missing_return_statement: a(95114, e.DiagnosticCategory.Message, "Add_all_missing_return_statement_95114", "Add all missing return statement"), Remove_braces_from_all_arrow_function_bodies_with_relevant_issues: a(95115, e.DiagnosticCategory.Message, "Remove_braces_from_all_arrow_function_bodies_with_relevant_issues_95115", "Remove braces from all arrow function bodies with relevant issues"), Wrap_all_object_literal_with_parentheses: a(95116, e.DiagnosticCategory.Message, "Wrap_all_object_literal_with_parentheses_95116", "Wrap all object literal with parentheses"), Move_labeled_tuple_element_modifiers_to_labels: a(95117, e.DiagnosticCategory.Message, "Move_labeled_tuple_element_modifiers_to_labels_95117", "Move labeled tuple element modifiers to labels"), Convert_overload_list_to_single_signature: a(95118, e.DiagnosticCategory.Message, "Convert_overload_list_to_single_signature_95118", "Convert overload list to single signature"), Generate_get_and_set_accessors_for_all_overriding_properties: a(95119, e.DiagnosticCategory.Message, "Generate_get_and_set_accessors_for_all_overriding_properties_95119", "Generate 'get' and 'set' accessors for all overriding properties"), Wrap_in_JSX_fragment: a(95120, e.DiagnosticCategory.Message, "Wrap_in_JSX_fragment_95120", "Wrap in JSX fragment"), Wrap_all_unparented_JSX_in_JSX_fragment: a(95121, e.DiagnosticCategory.Message, "Wrap_all_unparented_JSX_in_JSX_fragment_95121", "Wrap all unparented JSX in JSX fragment"), Convert_arrow_function_or_function_expression: a(95122, e.DiagnosticCategory.Message, "Convert_arrow_function_or_function_expression_95122", "Convert arrow function or function expression"), Convert_to_anonymous_function: a(95123, e.DiagnosticCategory.Message, "Convert_to_anonymous_function_95123", "Convert to anonymous function"), Convert_to_named_function: a(95124, e.DiagnosticCategory.Message, "Convert_to_named_function_95124", "Convert to named function"), Convert_to_arrow_function: a(95125, e.DiagnosticCategory.Message, "Convert_to_arrow_function_95125", "Convert to arrow function"), Remove_parentheses: a(95126, e.DiagnosticCategory.Message, "Remove_parentheses_95126", "Remove parentheses"), Could_not_find_a_containing_arrow_function: a(95127, e.DiagnosticCategory.Message, "Could_not_find_a_containing_arrow_function_95127", "Could not find a containing arrow function"), Containing_function_is_not_an_arrow_function: a(95128, e.DiagnosticCategory.Message, "Containing_function_is_not_an_arrow_function_95128", "Containing function is not an arrow function"), Could_not_find_export_statement: a(95129, e.DiagnosticCategory.Message, "Could_not_find_export_statement_95129", "Could not find export statement"), This_file_already_has_a_default_export: a(95130, e.DiagnosticCategory.Message, "This_file_already_has_a_default_export_95130", "This file already has a default export"), Could_not_find_import_clause: a(95131, e.DiagnosticCategory.Message, "Could_not_find_import_clause_95131", "Could not find import clause"), Could_not_find_namespace_import_or_named_imports: a(95132, e.DiagnosticCategory.Message, "Could_not_find_namespace_import_or_named_imports_95132", "Could not find namespace import or named imports"), Selection_is_not_a_valid_type_node: a(95133, e.DiagnosticCategory.Message, "Selection_is_not_a_valid_type_node_95133", "Selection is not a valid type node"), No_type_could_be_extracted_from_this_type_node: a(95134, e.DiagnosticCategory.Message, "No_type_could_be_extracted_from_this_type_node_95134", "No type could be extracted from this type node"), Could_not_find_property_for_which_to_generate_accessor: a(95135, e.DiagnosticCategory.Message, "Could_not_find_property_for_which_to_generate_accessor_95135", "Could not find property for which to generate accessor"), Name_is_not_valid: a(95136, e.DiagnosticCategory.Message, "Name_is_not_valid_95136", "Name is not valid"), Can_only_convert_property_with_modifier: a(95137, e.DiagnosticCategory.Message, "Can_only_convert_property_with_modifier_95137", "Can only convert property with modifier"), Switch_each_misused_0_to_1: a(95138, e.DiagnosticCategory.Message, "Switch_each_misused_0_to_1_95138", "Switch each misused '{0}' to '{1}'"), Convert_to_optional_chain_expression: a(95139, e.DiagnosticCategory.Message, "Convert_to_optional_chain_expression_95139", "Convert to optional chain expression"), Could_not_find_convertible_access_expression: a(95140, e.DiagnosticCategory.Message, "Could_not_find_convertible_access_expression_95140", "Could not find convertible access expression"), Could_not_find_matching_access_expressions: a(95141, e.DiagnosticCategory.Message, "Could_not_find_matching_access_expressions_95141", "Could not find matching access expressions"), Can_only_convert_logical_AND_access_chains: a(95142, e.DiagnosticCategory.Message, "Can_only_convert_logical_AND_access_chains_95142", "Can only convert logical AND access chains"), Add_void_to_Promise_resolved_without_a_value: a(95143, e.DiagnosticCategory.Message, "Add_void_to_Promise_resolved_without_a_value_95143", "Add 'void' to Promise resolved without a value"), Add_void_to_all_Promises_resolved_without_a_value: a(95144, e.DiagnosticCategory.Message, "Add_void_to_all_Promises_resolved_without_a_value_95144", "Add 'void' to all Promises resolved without a value"), Use_element_access_for_0: a(95145, e.DiagnosticCategory.Message, "Use_element_access_for_0_95145", "Use element access for '{0}'"), Use_element_access_for_all_undeclared_properties: a(95146, e.DiagnosticCategory.Message, "Use_element_access_for_all_undeclared_properties_95146", "Use element access for all undeclared properties."), Delete_all_unused_imports: a(95147, e.DiagnosticCategory.Message, "Delete_all_unused_imports_95147", "Delete all unused imports"), Infer_function_return_type: a(95148, e.DiagnosticCategory.Message, "Infer_function_return_type_95148", "Infer function return type"), Return_type_must_be_inferred_from_a_function: a(95149, e.DiagnosticCategory.Message, "Return_type_must_be_inferred_from_a_function_95149", "Return type must be inferred from a function"), Could_not_determine_function_return_type: a(95150, e.DiagnosticCategory.Message, "Could_not_determine_function_return_type_95150", "Could not determine function return type"), Could_not_convert_to_arrow_function: a(95151, e.DiagnosticCategory.Message, "Could_not_convert_to_arrow_function_95151", "Could not convert to arrow function"), Could_not_convert_to_named_function: a(95152, e.DiagnosticCategory.Message, "Could_not_convert_to_named_function_95152", "Could not convert to named function"), Could_not_convert_to_anonymous_function: a(95153, e.DiagnosticCategory.Message, "Could_not_convert_to_anonymous_function_95153", "Could not convert to anonymous function"), Can_only_convert_string_concatenation: a(95154, e.DiagnosticCategory.Message, "Can_only_convert_string_concatenation_95154", "Can only convert string concatenation"), Selection_is_not_a_valid_statement_or_statements: a(95155, e.DiagnosticCategory.Message, "Selection_is_not_a_valid_statement_or_statements_95155", "Selection is not a valid statement or statements"), Add_missing_function_declaration_0: a(95156, e.DiagnosticCategory.Message, "Add_missing_function_declaration_0_95156", "Add missing function declaration '{0}'"), Add_all_missing_function_declarations: a(95157, e.DiagnosticCategory.Message, "Add_all_missing_function_declarations_95157", "Add all missing function declarations"), Method_not_implemented: a(95158, e.DiagnosticCategory.Message, "Method_not_implemented_95158", "Method not implemented."), Function_not_implemented: a(95159, e.DiagnosticCategory.Message, "Function_not_implemented_95159", "Function not implemented."), Add_override_modifier: a(95160, e.DiagnosticCategory.Message, "Add_override_modifier_95160", "Add 'override' modifier"), Remove_override_modifier: a(95161, e.DiagnosticCategory.Message, "Remove_override_modifier_95161", "Remove 'override' modifier"), Add_all_missing_override_modifiers: a(95162, e.DiagnosticCategory.Message, "Add_all_missing_override_modifiers_95162", "Add all missing 'override' modifiers"), Remove_all_unnecessary_override_modifiers: a(95163, e.DiagnosticCategory.Message, "Remove_all_unnecessary_override_modifiers_95163", "Remove all unnecessary 'override' modifiers"), Can_only_convert_named_export: a(95164, e.DiagnosticCategory.Message, "Can_only_convert_named_export_95164", "Can only convert named export"), Add_missing_properties: a(95165, e.DiagnosticCategory.Message, "Add_missing_properties_95165", "Add missing properties"), Add_all_missing_properties: a(95166, e.DiagnosticCategory.Message, "Add_all_missing_properties_95166", "Add all missing properties"), Add_missing_attributes: a(95167, e.DiagnosticCategory.Message, "Add_missing_attributes_95167", "Add missing attributes"), Add_all_missing_attributes: a(95168, e.DiagnosticCategory.Message, "Add_all_missing_attributes_95168", "Add all missing attributes"), Add_undefined_to_optional_property_type: a(95169, e.DiagnosticCategory.Message, "Add_undefined_to_optional_property_type_95169", "Add 'undefined' to optional property type"), Convert_named_imports_to_default_import: a(95170, e.DiagnosticCategory.Message, "Convert_named_imports_to_default_import_95170", "Convert named imports to default import"), Delete_unused_param_tag_0: a(95171, e.DiagnosticCategory.Message, "Delete_unused_param_tag_0_95171", "Delete unused '@param' tag '{0}'"), Delete_all_unused_param_tags: a(95172, e.DiagnosticCategory.Message, "Delete_all_unused_param_tags_95172", "Delete all unused '@param' tags"), Rename_param_tag_name_0_to_1: a(95173, e.DiagnosticCategory.Message, "Rename_param_tag_name_0_to_1_95173", "Rename '@param' tag name '{0}' to '{1}'"), No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer: a(18004, e.DiagnosticCategory.Error, "No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer_18004", "No value exists in scope for the shorthand property '{0}'. Either declare one or provide an initializer."), Classes_may_not_have_a_field_named_constructor: a(18006, e.DiagnosticCategory.Error, "Classes_may_not_have_a_field_named_constructor_18006", "Classes may not have a field named 'constructor'."), JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array: a(18007, e.DiagnosticCategory.Error, "JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array_18007", "JSX expressions may not use the comma operator. Did you mean to write an array?"), Private_identifiers_cannot_be_used_as_parameters: a(18009, e.DiagnosticCategory.Error, "Private_identifiers_cannot_be_used_as_parameters_18009", "Private identifiers cannot be used as parameters."), An_accessibility_modifier_cannot_be_used_with_a_private_identifier: a(18010, e.DiagnosticCategory.Error, "An_accessibility_modifier_cannot_be_used_with_a_private_identifier_18010", "An accessibility modifier cannot be used with a private identifier."), The_operand_of_a_delete_operator_cannot_be_a_private_identifier: a(18011, e.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_cannot_be_a_private_identifier_18011", "The operand of a 'delete' operator cannot be a private identifier."), constructor_is_a_reserved_word: a(18012, e.DiagnosticCategory.Error, "constructor_is_a_reserved_word_18012", "'#constructor' is a reserved word."), Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier: a(18013, e.DiagnosticCategory.Error, "Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier_18013", "Property '{0}' is not accessible outside class '{1}' because it has a private identifier."), The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_private_identifier_with_the_same_spelling: a(18014, e.DiagnosticCategory.Error, "The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_priv_18014", "The property '{0}' cannot be accessed on type '{1}' within this class because it is shadowed by another private identifier with the same spelling."), Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2: a(18015, e.DiagnosticCategory.Error, "Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2_18015", "Property '{0}' in type '{1}' refers to a different member that cannot be accessed from within type '{2}'."), Private_identifiers_are_not_allowed_outside_class_bodies: a(18016, e.DiagnosticCategory.Error, "Private_identifiers_are_not_allowed_outside_class_bodies_18016", "Private identifiers are not allowed outside class bodies."), The_shadowing_declaration_of_0_is_defined_here: a(18017, e.DiagnosticCategory.Error, "The_shadowing_declaration_of_0_is_defined_here_18017", "The shadowing declaration of '{0}' is defined here"), The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here: a(18018, e.DiagnosticCategory.Error, "The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here_18018", "The declaration of '{0}' that you probably intended to use is defined here"), _0_modifier_cannot_be_used_with_a_private_identifier: a(18019, e.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_with_a_private_identifier_18019", "'{0}' modifier cannot be used with a private identifier."), An_enum_member_cannot_be_named_with_a_private_identifier: a(18024, e.DiagnosticCategory.Error, "An_enum_member_cannot_be_named_with_a_private_identifier_18024", "An enum member cannot be named with a private identifier."), can_only_be_used_at_the_start_of_a_file: a(18026, e.DiagnosticCategory.Error, "can_only_be_used_at_the_start_of_a_file_18026", "'#!' can only be used at the start of a file."), Compiler_reserves_name_0_when_emitting_private_identifier_downlevel: a(18027, e.DiagnosticCategory.Error, "Compiler_reserves_name_0_when_emitting_private_identifier_downlevel_18027", "Compiler reserves name '{0}' when emitting private identifier downlevel."), Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher: a(18028, e.DiagnosticCategory.Error, "Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher_18028", "Private identifiers are only available when targeting ECMAScript 2015 and higher."), Private_identifiers_are_not_allowed_in_variable_declarations: a(18029, e.DiagnosticCategory.Error, "Private_identifiers_are_not_allowed_in_variable_declarations_18029", "Private identifiers are not allowed in variable declarations."), An_optional_chain_cannot_contain_private_identifiers: a(18030, e.DiagnosticCategory.Error, "An_optional_chain_cannot_contain_private_identifiers_18030", "An optional chain cannot contain private identifiers."), The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituents: a(18031, e.DiagnosticCategory.Error, "The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituent_18031", "The intersection '{0}' was reduced to 'never' because property '{1}' has conflicting types in some constituents."), The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_private_in_some: a(18032, e.DiagnosticCategory.Error, "The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_pr_18032", "The intersection '{0}' was reduced to 'never' because property '{1}' exists in multiple constituents and is private in some."), Only_numeric_enums_can_have_computed_members_but_this_expression_has_type_0_If_you_do_not_need_exhaustiveness_checks_consider_using_an_object_literal_instead: a(18033, e.DiagnosticCategory.Error, "Only_numeric_enums_can_have_computed_members_but_this_expression_has_type_0_If_you_do_not_need_exhau_18033", "Only numeric enums can have computed members, but this expression has type '{0}'. If you do not need exhaustiveness checks, consider using an object literal instead."), Specify_the_JSX_fragment_factory_function_to_use_when_targeting_react_JSX_emit_with_jsxFactory_compiler_option_is_specified_e_g_Fragment: a(18034, e.DiagnosticCategory.Message, "Specify_the_JSX_fragment_factory_function_to_use_when_targeting_react_JSX_emit_with_jsxFactory_compi_18034", "Specify the JSX fragment factory function to use when targeting 'react' JSX emit with 'jsxFactory' compiler option is specified, e.g. 'Fragment'."), Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name: a(18035, e.DiagnosticCategory.Error, "Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name_18035", "Invalid value for 'jsxFragmentFactory'. '{0}' is not a valid identifier or qualified-name."), Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator: a(18036, e.DiagnosticCategory.Error, "Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_dec_18036", "Class decorators can't be used with static private identifier. Consider removing the experimental decorator."), Await_expression_cannot_be_used_inside_a_class_static_block: a(18037, e.DiagnosticCategory.Error, "Await_expression_cannot_be_used_inside_a_class_static_block_18037", "Await expression cannot be used inside a class static block."), For_await_loops_cannot_be_used_inside_a_class_static_block: a(18038, e.DiagnosticCategory.Error, "For_await_loops_cannot_be_used_inside_a_class_static_block_18038", "'For await' loops cannot be used inside a class static block."), Invalid_use_of_0_It_cannot_be_used_inside_a_class_static_block: a(18039, e.DiagnosticCategory.Error, "Invalid_use_of_0_It_cannot_be_used_inside_a_class_static_block_18039", "Invalid use of '{0}'. It cannot be used inside a class static block."), A_return_statement_cannot_be_used_inside_a_class_static_block: a(18041, e.DiagnosticCategory.Error, "A_return_statement_cannot_be_used_inside_a_class_static_block_18041", "A 'return' statement cannot be used inside a class static block.") };
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            function C(ye) {
              return ye >= 79;
            }
            e.tokenIsIdentifierOrKeyword = C;
            function w(ye) {
              return ye === 31 || C(ye);
            }
            e.tokenIsIdentifierOrKeywordOrGreaterThan = w, e.textToKeywordObj = (a = { abstract: 126, any: 130, as: 127, asserts: 128, assert: 129, bigint: 158, boolean: 133, break: 81, case: 82, catch: 83, class: 84, continue: 86, const: 85 }, a.constructor = 134, a.debugger = 87, a.declare = 135, a.default = 88, a.delete = 89, a.do = 90, a.else = 91, a.enum = 92, a.export = 93, a.extends = 94, a.false = 95, a.finally = 96, a.for = 97, a.from = 156, a.function = 98, a.get = 136, a.if = 99, a.implements = 117, a.import = 100, a.in = 101, a.infer = 137, a.instanceof = 102, a.interface = 118, a.intrinsic = 138, a.is = 139, a.keyof = 140, a.let = 119, a.module = 141, a.namespace = 142, a.never = 143, a.new = 103, a.null = 104, a.number = 147, a.object = 148, a.package = 120, a.private = 121, a.protected = 122, a.public = 123, a.override = 159, a.out = 144, a.readonly = 145, a.require = 146, a.global = 157, a.return = 105, a.set = 149, a.static = 124, a.string = 150, a.super = 106, a.switch = 107, a.symbol = 151, a.this = 108, a.throw = 109, a.true = 110, a.try = 111, a.type = 152, a.typeof = 112, a.undefined = 153, a.unique = 154, a.unknown = 155, a.var = 113, a.void = 114, a.while = 115, a.with = 116, a.yield = 125, a.async = 131, a.await = 132, a.of = 160, a);
            var B = new e.Map(e.getEntries(e.textToKeywordObj)), E = new e.Map(e.getEntries(Ke(Ke({}, e.textToKeywordObj), { "{": 18, "}": 19, "(": 20, ")": 21, "[": 22, "]": 23, ".": 24, "...": 25, ";": 26, ",": 27, "<": 29, ">": 31, "<=": 32, ">=": 33, "==": 34, "!=": 35, "===": 36, "!==": 37, "=>": 38, "+": 39, "-": 40, "**": 42, "*": 41, "/": 43, "%": 44, "++": 45, "--": 46, "<<": 47, "</": 30, ">>": 48, ">>>": 49, "&": 50, "|": 51, "^": 52, "!": 53, "~": 54, "&&": 55, "||": 56, "?": 57, "??": 60, "?.": 28, ":": 58, "=": 63, "+=": 64, "-=": 65, "*=": 66, "**=": 67, "/=": 68, "%=": 69, "<<=": 70, ">>=": 71, ">>>=": 72, "&=": 73, "|=": 74, "^=": 78, "||=": 75, "&&=": 76, "??=": 77, "@": 59, "#": 62, "`": 61 }))), Q = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 543, 546, 563, 592, 685, 688, 696, 699, 705, 720, 721, 736, 740, 750, 750, 890, 890, 902, 902, 904, 906, 908, 908, 910, 929, 931, 974, 976, 983, 986, 1011, 1024, 1153, 1164, 1220, 1223, 1224, 1227, 1228, 1232, 1269, 1272, 1273, 1329, 1366, 1369, 1369, 1377, 1415, 1488, 1514, 1520, 1522, 1569, 1594, 1600, 1610, 1649, 1747, 1749, 1749, 1765, 1766, 1786, 1788, 1808, 1808, 1810, 1836, 1920, 1957, 2309, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2524, 2525, 2527, 2529, 2544, 2545, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2699, 2701, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2784, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2870, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 2997, 2999, 3001, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3168, 3169, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3294, 3294, 3296, 3297, 3333, 3340, 3342, 3344, 3346, 3368, 3370, 3385, 3424, 3425, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3805, 3840, 3840, 3904, 3911, 3913, 3946, 3976, 3979, 4096, 4129, 4131, 4135, 4137, 4138, 4176, 4181, 4256, 4293, 4304, 4342, 4352, 4441, 4447, 4514, 4520, 4601, 4608, 4614, 4616, 4678, 4680, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4742, 4744, 4744, 4746, 4749, 4752, 4782, 4784, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4814, 4816, 4822, 4824, 4846, 4848, 4878, 4880, 4880, 4882, 4885, 4888, 4894, 4896, 4934, 4936, 4954, 5024, 5108, 5121, 5740, 5743, 5750, 5761, 5786, 5792, 5866, 6016, 6067, 6176, 6263, 6272, 6312, 7680, 7835, 7840, 7929, 7936, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8319, 8319, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8497, 8499, 8505, 8544, 8579, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12346, 12353, 12436, 12445, 12446, 12449, 12538, 12540, 12542, 12549, 12588, 12593, 12686, 12704, 12727, 13312, 19893, 19968, 40869, 40960, 42124, 44032, 55203, 63744, 64045, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65138, 65140, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500], le = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 543, 546, 563, 592, 685, 688, 696, 699, 705, 720, 721, 736, 740, 750, 750, 768, 846, 864, 866, 890, 890, 902, 902, 904, 906, 908, 908, 910, 929, 931, 974, 976, 983, 986, 1011, 1024, 1153, 1155, 1158, 1164, 1220, 1223, 1224, 1227, 1228, 1232, 1269, 1272, 1273, 1329, 1366, 1369, 1369, 1377, 1415, 1425, 1441, 1443, 1465, 1467, 1469, 1471, 1471, 1473, 1474, 1476, 1476, 1488, 1514, 1520, 1522, 1569, 1594, 1600, 1621, 1632, 1641, 1648, 1747, 1749, 1756, 1759, 1768, 1770, 1773, 1776, 1788, 1808, 1836, 1840, 1866, 1920, 1968, 2305, 2307, 2309, 2361, 2364, 2381, 2384, 2388, 2392, 2403, 2406, 2415, 2433, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2492, 2494, 2500, 2503, 2504, 2507, 2509, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2562, 2562, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2649, 2652, 2654, 2654, 2662, 2676, 2689, 2691, 2693, 2699, 2701, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2784, 2790, 2799, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2870, 2873, 2876, 2883, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2913, 2918, 2927, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 2997, 2999, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3031, 3031, 3047, 3055, 3073, 3075, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3134, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3168, 3169, 3174, 3183, 3202, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3262, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3297, 3302, 3311, 3330, 3331, 3333, 3340, 3342, 3344, 3346, 3368, 3370, 3385, 3390, 3395, 3398, 3400, 3402, 3405, 3415, 3415, 3424, 3425, 3430, 3439, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3769, 3771, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3805, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3946, 3953, 3972, 3974, 3979, 3984, 3991, 3993, 4028, 4038, 4038, 4096, 4129, 4131, 4135, 4137, 4138, 4140, 4146, 4150, 4153, 4160, 4169, 4176, 4185, 4256, 4293, 4304, 4342, 4352, 4441, 4447, 4514, 4520, 4601, 4608, 4614, 4616, 4678, 4680, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4742, 4744, 4744, 4746, 4749, 4752, 4782, 4784, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4814, 4816, 4822, 4824, 4846, 4848, 4878, 4880, 4880, 4882, 4885, 4888, 4894, 4896, 4934, 4936, 4954, 4969, 4977, 5024, 5108, 5121, 5740, 5743, 5750, 5761, 5786, 5792, 5866, 6016, 6099, 6112, 6121, 6160, 6169, 6176, 6263, 6272, 6313, 7680, 7835, 7840, 7929, 7936, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8255, 8256, 8319, 8319, 8400, 8412, 8417, 8417, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8497, 8499, 8505, 8544, 8579, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12346, 12353, 12436, 12441, 12442, 12445, 12446, 12449, 12542, 12549, 12588, 12593, 12686, 12704, 12727, 13312, 19893, 19968, 40869, 40960, 42124, 44032, 55203, 63744, 64045, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65056, 65059, 65075, 65076, 65101, 65103, 65136, 65138, 65140, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65381, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500], N = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 880, 884, 886, 887, 890, 893, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1162, 1319, 1329, 1366, 1369, 1369, 1377, 1415, 1488, 1514, 1520, 1522, 1568, 1610, 1646, 1647, 1649, 1747, 1749, 1749, 1765, 1766, 1774, 1775, 1786, 1788, 1791, 1791, 1808, 1808, 1810, 1839, 1869, 1957, 1969, 1969, 1994, 2026, 2036, 2037, 2042, 2042, 2048, 2069, 2074, 2074, 2084, 2084, 2088, 2088, 2112, 2136, 2208, 2208, 2210, 2220, 2308, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2417, 2423, 2425, 2431, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2493, 2493, 2510, 2510, 2524, 2525, 2527, 2529, 2544, 2545, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2785, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2929, 2929, 2947, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3024, 3024, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3133, 3133, 3160, 3161, 3168, 3169, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3261, 3261, 3294, 3294, 3296, 3297, 3313, 3314, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3389, 3406, 3406, 3424, 3425, 3450, 3455, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3807, 3840, 3840, 3904, 3911, 3913, 3948, 3976, 3980, 4096, 4138, 4159, 4159, 4176, 4181, 4186, 4189, 4193, 4193, 4197, 4198, 4206, 4208, 4213, 4225, 4238, 4238, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4992, 5007, 5024, 5108, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5872, 5888, 5900, 5902, 5905, 5920, 5937, 5952, 5969, 5984, 5996, 5998, 6e3, 6016, 6067, 6103, 6103, 6108, 6108, 6176, 6263, 6272, 6312, 6314, 6314, 6320, 6389, 6400, 6428, 6480, 6509, 6512, 6516, 6528, 6571, 6593, 6599, 6656, 6678, 6688, 6740, 6823, 6823, 6917, 6963, 6981, 6987, 7043, 7072, 7086, 7087, 7098, 7141, 7168, 7203, 7245, 7247, 7258, 7293, 7401, 7404, 7406, 7409, 7413, 7414, 7424, 7615, 7680, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8305, 8305, 8319, 8319, 8336, 8348, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11502, 11506, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11648, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11823, 11823, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12348, 12353, 12438, 12445, 12447, 12449, 12538, 12540, 12543, 12549, 12589, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40908, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42527, 42538, 42539, 42560, 42606, 42623, 42647, 42656, 42735, 42775, 42783, 42786, 42888, 42891, 42894, 42896, 42899, 42912, 42922, 43e3, 43009, 43011, 43013, 43015, 43018, 43020, 43042, 43072, 43123, 43138, 43187, 43250, 43255, 43259, 43259, 43274, 43301, 43312, 43334, 43360, 43388, 43396, 43442, 43471, 43471, 43520, 43560, 43584, 43586, 43588, 43595, 43616, 43638, 43642, 43642, 43648, 43695, 43697, 43697, 43701, 43702, 43705, 43709, 43712, 43712, 43714, 43714, 43739, 43741, 43744, 43754, 43762, 43764, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43968, 44002, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500], p = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 768, 884, 886, 887, 890, 893, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1155, 1159, 1162, 1319, 1329, 1366, 1369, 1369, 1377, 1415, 1425, 1469, 1471, 1471, 1473, 1474, 1476, 1477, 1479, 1479, 1488, 1514, 1520, 1522, 1552, 1562, 1568, 1641, 1646, 1747, 1749, 1756, 1759, 1768, 1770, 1788, 1791, 1791, 1808, 1866, 1869, 1969, 1984, 2037, 2042, 2042, 2048, 2093, 2112, 2139, 2208, 2208, 2210, 2220, 2276, 2302, 2304, 2403, 2406, 2415, 2417, 2423, 2425, 2431, 2433, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2500, 2503, 2504, 2507, 2510, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2561, 2563, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2641, 2641, 2649, 2652, 2654, 2654, 2662, 2677, 2689, 2691, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2787, 2790, 2799, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2876, 2884, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2915, 2918, 2927, 2929, 2929, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3024, 3024, 3031, 3031, 3046, 3055, 3073, 3075, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3133, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3160, 3161, 3168, 3171, 3174, 3183, 3202, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3260, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3299, 3302, 3311, 3313, 3314, 3330, 3331, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3396, 3398, 3400, 3402, 3406, 3415, 3415, 3424, 3427, 3430, 3439, 3450, 3455, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3769, 3771, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3807, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3948, 3953, 3972, 3974, 3991, 3993, 4028, 4038, 4038, 4096, 4169, 4176, 4253, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4957, 4959, 4992, 5007, 5024, 5108, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5872, 5888, 5900, 5902, 5908, 5920, 5940, 5952, 5971, 5984, 5996, 5998, 6e3, 6002, 6003, 6016, 6099, 6103, 6103, 6108, 6109, 6112, 6121, 6155, 6157, 6160, 6169, 6176, 6263, 6272, 6314, 6320, 6389, 6400, 6428, 6432, 6443, 6448, 6459, 6470, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6608, 6617, 6656, 6683, 6688, 6750, 6752, 6780, 6783, 6793, 6800, 6809, 6823, 6823, 6912, 6987, 6992, 7001, 7019, 7027, 7040, 7155, 7168, 7223, 7232, 7241, 7245, 7293, 7376, 7378, 7380, 7414, 7424, 7654, 7676, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8204, 8205, 8255, 8256, 8276, 8276, 8305, 8305, 8319, 8319, 8336, 8348, 8400, 8412, 8417, 8417, 8421, 8432, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11647, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11744, 11775, 11823, 11823, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12348, 12353, 12438, 12441, 12442, 12445, 12447, 12449, 12538, 12540, 12543, 12549, 12589, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40908, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42539, 42560, 42607, 42612, 42621, 42623, 42647, 42655, 42737, 42775, 42783, 42786, 42888, 42891, 42894, 42896, 42899, 42912, 42922, 43e3, 43047, 43072, 43123, 43136, 43204, 43216, 43225, 43232, 43255, 43259, 43259, 43264, 43309, 43312, 43347, 43360, 43388, 43392, 43456, 43471, 43481, 43520, 43574, 43584, 43597, 43600, 43609, 43616, 43638, 43642, 43643, 43648, 43714, 43739, 43741, 43744, 43759, 43762, 43766, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43968, 44010, 44012, 44013, 44016, 44025, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65024, 65039, 65056, 65062, 65075, 65076, 65101, 65103, 65136, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500], m = [65, 90, 97, 122, 170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 880, 884, 886, 887, 890, 893, 895, 895, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1162, 1327, 1329, 1366, 1369, 1369, 1376, 1416, 1488, 1514, 1519, 1522, 1568, 1610, 1646, 1647, 1649, 1747, 1749, 1749, 1765, 1766, 1774, 1775, 1786, 1788, 1791, 1791, 1808, 1808, 1810, 1839, 1869, 1957, 1969, 1969, 1994, 2026, 2036, 2037, 2042, 2042, 2048, 2069, 2074, 2074, 2084, 2084, 2088, 2088, 2112, 2136, 2144, 2154, 2208, 2228, 2230, 2237, 2308, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2417, 2432, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2493, 2493, 2510, 2510, 2524, 2525, 2527, 2529, 2544, 2545, 2556, 2556, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2785, 2809, 2809, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2929, 2929, 2947, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3024, 3024, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3129, 3133, 3133, 3160, 3162, 3168, 3169, 3200, 3200, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3261, 3261, 3294, 3294, 3296, 3297, 3313, 3314, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3389, 3406, 3406, 3412, 3414, 3423, 3425, 3450, 3455, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3718, 3722, 3724, 3747, 3749, 3749, 3751, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3807, 3840, 3840, 3904, 3911, 3913, 3948, 3976, 3980, 4096, 4138, 4159, 4159, 4176, 4181, 4186, 4189, 4193, 4193, 4197, 4198, 4206, 4208, 4213, 4225, 4238, 4238, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4992, 5007, 5024, 5109, 5112, 5117, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5880, 5888, 5900, 5902, 5905, 5920, 5937, 5952, 5969, 5984, 5996, 5998, 6e3, 6016, 6067, 6103, 6103, 6108, 6108, 6176, 6264, 6272, 6312, 6314, 6314, 6320, 6389, 6400, 6430, 6480, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6656, 6678, 6688, 6740, 6823, 6823, 6917, 6963, 6981, 6987, 7043, 7072, 7086, 7087, 7098, 7141, 7168, 7203, 7245, 7247, 7258, 7293, 7296, 7304, 7312, 7354, 7357, 7359, 7401, 7404, 7406, 7411, 7413, 7414, 7418, 7418, 7424, 7615, 7680, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8305, 8305, 8319, 8319, 8336, 8348, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8472, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11502, 11506, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11648, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12348, 12353, 12438, 12443, 12447, 12449, 12538, 12540, 12543, 12549, 12591, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40943, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42527, 42538, 42539, 42560, 42606, 42623, 42653, 42656, 42735, 42775, 42783, 42786, 42888, 42891, 42943, 42946, 42950, 42999, 43009, 43011, 43013, 43015, 43018, 43020, 43042, 43072, 43123, 43138, 43187, 43250, 43255, 43259, 43259, 43261, 43262, 43274, 43301, 43312, 43334, 43360, 43388, 43396, 43442, 43471, 43471, 43488, 43492, 43494, 43503, 43514, 43518, 43520, 43560, 43584, 43586, 43588, 43595, 43616, 43638, 43642, 43642, 43646, 43695, 43697, 43697, 43701, 43702, 43705, 43709, 43712, 43712, 43714, 43714, 43739, 43741, 43744, 43754, 43762, 43764, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43824, 43866, 43868, 43879, 43888, 44002, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500, 65536, 65547, 65549, 65574, 65576, 65594, 65596, 65597, 65599, 65613, 65616, 65629, 65664, 65786, 65856, 65908, 66176, 66204, 66208, 66256, 66304, 66335, 66349, 66378, 66384, 66421, 66432, 66461, 66464, 66499, 66504, 66511, 66513, 66517, 66560, 66717, 66736, 66771, 66776, 66811, 66816, 66855, 66864, 66915, 67072, 67382, 67392, 67413, 67424, 67431, 67584, 67589, 67592, 67592, 67594, 67637, 67639, 67640, 67644, 67644, 67647, 67669, 67680, 67702, 67712, 67742, 67808, 67826, 67828, 67829, 67840, 67861, 67872, 67897, 67968, 68023, 68030, 68031, 68096, 68096, 68112, 68115, 68117, 68119, 68121, 68149, 68192, 68220, 68224, 68252, 68288, 68295, 68297, 68324, 68352, 68405, 68416, 68437, 68448, 68466, 68480, 68497, 68608, 68680, 68736, 68786, 68800, 68850, 68864, 68899, 69376, 69404, 69415, 69415, 69424, 69445, 69600, 69622, 69635, 69687, 69763, 69807, 69840, 69864, 69891, 69926, 69956, 69956, 69968, 70002, 70006, 70006, 70019, 70066, 70081, 70084, 70106, 70106, 70108, 70108, 70144, 70161, 70163, 70187, 70272, 70278, 70280, 70280, 70282, 70285, 70287, 70301, 70303, 70312, 70320, 70366, 70405, 70412, 70415, 70416, 70419, 70440, 70442, 70448, 70450, 70451, 70453, 70457, 70461, 70461, 70480, 70480, 70493, 70497, 70656, 70708, 70727, 70730, 70751, 70751, 70784, 70831, 70852, 70853, 70855, 70855, 71040, 71086, 71128, 71131, 71168, 71215, 71236, 71236, 71296, 71338, 71352, 71352, 71424, 71450, 71680, 71723, 71840, 71903, 71935, 71935, 72096, 72103, 72106, 72144, 72161, 72161, 72163, 72163, 72192, 72192, 72203, 72242, 72250, 72250, 72272, 72272, 72284, 72329, 72349, 72349, 72384, 72440, 72704, 72712, 72714, 72750, 72768, 72768, 72818, 72847, 72960, 72966, 72968, 72969, 72971, 73008, 73030, 73030, 73056, 73061, 73063, 73064, 73066, 73097, 73112, 73112, 73440, 73458, 73728, 74649, 74752, 74862, 74880, 75075, 77824, 78894, 82944, 83526, 92160, 92728, 92736, 92766, 92880, 92909, 92928, 92975, 92992, 92995, 93027, 93047, 93053, 93071, 93760, 93823, 93952, 94026, 94032, 94032, 94099, 94111, 94176, 94177, 94179, 94179, 94208, 100343, 100352, 101106, 110592, 110878, 110928, 110930, 110948, 110951, 110960, 111355, 113664, 113770, 113776, 113788, 113792, 113800, 113808, 113817, 119808, 119892, 119894, 119964, 119966, 119967, 119970, 119970, 119973, 119974, 119977, 119980, 119982, 119993, 119995, 119995, 119997, 120003, 120005, 120069, 120071, 120074, 120077, 120084, 120086, 120092, 120094, 120121, 120123, 120126, 120128, 120132, 120134, 120134, 120138, 120144, 120146, 120485, 120488, 120512, 120514, 120538, 120540, 120570, 120572, 120596, 120598, 120628, 120630, 120654, 120656, 120686, 120688, 120712, 120714, 120744, 120746, 120770, 120772, 120779, 123136, 123180, 123191, 123197, 123214, 123214, 123584, 123627, 124928, 125124, 125184, 125251, 125259, 125259, 126464, 126467, 126469, 126495, 126497, 126498, 126500, 126500, 126503, 126503, 126505, 126514, 126516, 126519, 126521, 126521, 126523, 126523, 126530, 126530, 126535, 126535, 126537, 126537, 126539, 126539, 126541, 126543, 126545, 126546, 126548, 126548, 126551, 126551, 126553, 126553, 126555, 126555, 126557, 126557, 126559, 126559, 126561, 126562, 126564, 126564, 126567, 126570, 126572, 126578, 126580, 126583, 126585, 126588, 126590, 126590, 126592, 126601, 126603, 126619, 126625, 126627, 126629, 126633, 126635, 126651, 131072, 173782, 173824, 177972, 177984, 178205, 178208, 183969, 183984, 191456, 194560, 195101], G = [48, 57, 65, 90, 95, 95, 97, 122, 170, 170, 181, 181, 183, 183, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 768, 884, 886, 887, 890, 893, 895, 895, 902, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1155, 1159, 1162, 1327, 1329, 1366, 1369, 1369, 1376, 1416, 1425, 1469, 1471, 1471, 1473, 1474, 1476, 1477, 1479, 1479, 1488, 1514, 1519, 1522, 1552, 1562, 1568, 1641, 1646, 1747, 1749, 1756, 1759, 1768, 1770, 1788, 1791, 1791, 1808, 1866, 1869, 1969, 1984, 2037, 2042, 2042, 2045, 2045, 2048, 2093, 2112, 2139, 2144, 2154, 2208, 2228, 2230, 2237, 2259, 2273, 2275, 2403, 2406, 2415, 2417, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2500, 2503, 2504, 2507, 2510, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2556, 2556, 2558, 2558, 2561, 2563, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2641, 2641, 2649, 2652, 2654, 2654, 2662, 2677, 2689, 2691, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2787, 2790, 2799, 2809, 2815, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2876, 2884, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2915, 2918, 2927, 2929, 2929, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3024, 3024, 3031, 3031, 3046, 3055, 3072, 3084, 3086, 3088, 3090, 3112, 3114, 3129, 3133, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3160, 3162, 3168, 3171, 3174, 3183, 3200, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3260, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3299, 3302, 3311, 3313, 3314, 3328, 3331, 3333, 3340, 3342, 3344, 3346, 3396, 3398, 3400, 3402, 3406, 3412, 3415, 3423, 3427, 3430, 3439, 3450, 3455, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3558, 3567, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3718, 3722, 3724, 3747, 3749, 3749, 3751, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3807, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3948, 3953, 3972, 3974, 3991, 3993, 4028, 4038, 4038, 4096, 4169, 4176, 4253, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4957, 4959, 4969, 4977, 4992, 5007, 5024, 5109, 5112, 5117, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5880, 5888, 5900, 5902, 5908, 5920, 5940, 5952, 5971, 5984, 5996, 5998, 6e3, 6002, 6003, 6016, 6099, 6103, 6103, 6108, 6109, 6112, 6121, 6155, 6157, 6160, 6169, 6176, 6264, 6272, 6314, 6320, 6389, 6400, 6430, 6432, 6443, 6448, 6459, 6470, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6608, 6618, 6656, 6683, 6688, 6750, 6752, 6780, 6783, 6793, 6800, 6809, 6823, 6823, 6832, 6845, 6912, 6987, 6992, 7001, 7019, 7027, 7040, 7155, 7168, 7223, 7232, 7241, 7245, 7293, 7296, 7304, 7312, 7354, 7357, 7359, 7376, 7378, 7380, 7418, 7424, 7673, 7675, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8255, 8256, 8276, 8276, 8305, 8305, 8319, 8319, 8336, 8348, 8400, 8412, 8417, 8417, 8421, 8432, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8472, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11647, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11744, 11775, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12348, 12353, 12438, 12441, 12447, 12449, 12538, 12540, 12543, 12549, 12591, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40943, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42539, 42560, 42607, 42612, 42621, 42623, 42737, 42775, 42783, 42786, 42888, 42891, 42943, 42946, 42950, 42999, 43047, 43072, 43123, 43136, 43205, 43216, 43225, 43232, 43255, 43259, 43259, 43261, 43309, 43312, 43347, 43360, 43388, 43392, 43456, 43471, 43481, 43488, 43518, 43520, 43574, 43584, 43597, 43600, 43609, 43616, 43638, 43642, 43714, 43739, 43741, 43744, 43759, 43762, 43766, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43824, 43866, 43868, 43879, 43888, 44010, 44012, 44013, 44016, 44025, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65024, 65039, 65056, 65071, 65075, 65076, 65101, 65103, 65136, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500, 65536, 65547, 65549, 65574, 65576, 65594, 65596, 65597, 65599, 65613, 65616, 65629, 65664, 65786, 65856, 65908, 66045, 66045, 66176, 66204, 66208, 66256, 66272, 66272, 66304, 66335, 66349, 66378, 66384, 66426, 66432, 66461, 66464, 66499, 66504, 66511, 66513, 66517, 66560, 66717, 66720, 66729, 66736, 66771, 66776, 66811, 66816, 66855, 66864, 66915, 67072, 67382, 67392, 67413, 67424, 67431, 67584, 67589, 67592, 67592, 67594, 67637, 67639, 67640, 67644, 67644, 67647, 67669, 67680, 67702, 67712, 67742, 67808, 67826, 67828, 67829, 67840, 67861, 67872, 67897, 67968, 68023, 68030, 68031, 68096, 68099, 68101, 68102, 68108, 68115, 68117, 68119, 68121, 68149, 68152, 68154, 68159, 68159, 68192, 68220, 68224, 68252, 68288, 68295, 68297, 68326, 68352, 68405, 68416, 68437, 68448, 68466, 68480, 68497, 68608, 68680, 68736, 68786, 68800, 68850, 68864, 68903, 68912, 68921, 69376, 69404, 69415, 69415, 69424, 69456, 69600, 69622, 69632, 69702, 69734, 69743, 69759, 69818, 69840, 69864, 69872, 69881, 69888, 69940, 69942, 69951, 69956, 69958, 69968, 70003, 70006, 70006, 70016, 70084, 70089, 70092, 70096, 70106, 70108, 70108, 70144, 70161, 70163, 70199, 70206, 70206, 70272, 70278, 70280, 70280, 70282, 70285, 70287, 70301, 70303, 70312, 70320, 70378, 70384, 70393, 70400, 70403, 70405, 70412, 70415, 70416, 70419, 70440, 70442, 70448, 70450, 70451, 70453, 70457, 70459, 70468, 70471, 70472, 70475, 70477, 70480, 70480, 70487, 70487, 70493, 70499, 70502, 70508, 70512, 70516, 70656, 70730, 70736, 70745, 70750, 70751, 70784, 70853, 70855, 70855, 70864, 70873, 71040, 71093, 71096, 71104, 71128, 71133, 71168, 71232, 71236, 71236, 71248, 71257, 71296, 71352, 71360, 71369, 71424, 71450, 71453, 71467, 71472, 71481, 71680, 71738, 71840, 71913, 71935, 71935, 72096, 72103, 72106, 72151, 72154, 72161, 72163, 72164, 72192, 72254, 72263, 72263, 72272, 72345, 72349, 72349, 72384, 72440, 72704, 72712, 72714, 72758, 72760, 72768, 72784, 72793, 72818, 72847, 72850, 72871, 72873, 72886, 72960, 72966, 72968, 72969, 72971, 73014, 73018, 73018, 73020, 73021, 73023, 73031, 73040, 73049, 73056, 73061, 73063, 73064, 73066, 73102, 73104, 73105, 73107, 73112, 73120, 73129, 73440, 73462, 73728, 74649, 74752, 74862, 74880, 75075, 77824, 78894, 82944, 83526, 92160, 92728, 92736, 92766, 92768, 92777, 92880, 92909, 92912, 92916, 92928, 92982, 92992, 92995, 93008, 93017, 93027, 93047, 93053, 93071, 93760, 93823, 93952, 94026, 94031, 94087, 94095, 94111, 94176, 94177, 94179, 94179, 94208, 100343, 100352, 101106, 110592, 110878, 110928, 110930, 110948, 110951, 110960, 111355, 113664, 113770, 113776, 113788, 113792, 113800, 113808, 113817, 113821, 113822, 119141, 119145, 119149, 119154, 119163, 119170, 119173, 119179, 119210, 119213, 119362, 119364, 119808, 119892, 119894, 119964, 119966, 119967, 119970, 119970, 119973, 119974, 119977, 119980, 119982, 119993, 119995, 119995, 119997, 120003, 120005, 120069, 120071, 120074, 120077, 120084, 120086, 120092, 120094, 120121, 120123, 120126, 120128, 120132, 120134, 120134, 120138, 120144, 120146, 120485, 120488, 120512, 120514, 120538, 120540, 120570, 120572, 120596, 120598, 120628, 120630, 120654, 120656, 120686, 120688, 120712, 120714, 120744, 120746, 120770, 120772, 120779, 120782, 120831, 121344, 121398, 121403, 121452, 121461, 121461, 121476, 121476, 121499, 121503, 121505, 121519, 122880, 122886, 122888, 122904, 122907, 122913, 122915, 122916, 122918, 122922, 123136, 123180, 123184, 123197, 123200, 123209, 123214, 123214, 123584, 123641, 124928, 125124, 125136, 125142, 125184, 125259, 125264, 125273, 126464, 126467, 126469, 126495, 126497, 126498, 126500, 126500, 126503, 126503, 126505, 126514, 126516, 126519, 126521, 126521, 126523, 126523, 126530, 126530, 126535, 126535, 126537, 126537, 126539, 126539, 126541, 126543, 126545, 126546, 126548, 126548, 126551, 126551, 126553, 126553, 126555, 126555, 126557, 126557, 126559, 126559, 126561, 126562, 126564, 126564, 126567, 126570, 126572, 126578, 126580, 126583, 126585, 126588, 126590, 126590, 126592, 126601, 126603, 126619, 126625, 126627, 126629, 126633, 126635, 126651, 131072, 173782, 173824, 177972, 177984, 178205, 178208, 183969, 183984, 191456, 194560, 195101, 917760, 917999], oe = /^\/\/\/?\s*@(ts-expect-error|ts-ignore)/, f = /^(?:\/|\*)*\s*@(ts-expect-error|ts-ignore)/;
            function T(ye, Ae) {
              if (ye < Ae[0]) return false;
              for (var er = 0, ir = Ae.length, Cr; er + 1 < ir; ) {
                if (Cr = er + (ir - er) / 2, Cr -= Cr % 2, Ae[Cr] <= ye && ye <= Ae[Cr + 1]) return true;
                ye < Ae[Cr] ? ir = Cr : er = Cr + 2;
              }
              return false;
            }
            function K(ye, Ae) {
              return Ae >= 2 ? T(ye, m) : Ae === 1 ? T(ye, N) : T(ye, Q);
            }
            e.isUnicodeIdentifierStart = K;
            function b(ye, Ae) {
              return Ae >= 2 ? T(ye, G) : Ae === 1 ? T(ye, p) : T(ye, le);
            }
            function se(ye) {
              var Ae = [];
              return ye.forEach(function(er, ir) {
                Ae[er] = ir;
              }), Ae;
            }
            var J = se(E);
            function ie(ye) {
              return J[ye];
            }
            e.tokenToString = ie;
            function R(ye) {
              return E.get(ye);
            }
            e.stringToToken = R;
            function q(ye) {
              for (var Ae = new Array(), er = 0, ir = 0; er < ye.length; ) {
                var Cr = ye.charCodeAt(er);
                switch (er++, Cr) {
                  case 13:
                    ye.charCodeAt(er) === 10 && er++;
                  case 10:
                    Ae.push(ir), ir = er;
                    break;
                  default:
                    Cr > 127 && y(Cr) && (Ae.push(ir), ir = er);
                    break;
                }
              }
              return Ae.push(ir), Ae;
            }
            e.computeLineStarts = q;
            function O(ye, Ae, er, ir) {
              return ye.getPositionOfLineAndCharacter ? ye.getPositionOfLineAndCharacter(Ae, er, ir) : ve(ee(ye), Ae, er, ye.text, ir);
            }
            e.getPositionOfLineAndCharacter = O;
            function ve(ye, Ae, er, ir, Cr) {
              (Ae < 0 || Ae >= ye.length) && (Cr ? Ae = Ae < 0 ? 0 : Ae >= ye.length ? ye.length - 1 : Ae : e.Debug.fail("Bad line number. Line: ".concat(Ae, ", lineStarts.length: ").concat(ye.length, " , line map is correct? ").concat(ir !== void 0 ? e.arraysEqual(ye, q(ir)) : "unknown")));
              var Ye = ye[Ae] + er;
              return Cr ? Ye > ye[Ae + 1] ? ye[Ae + 1] : typeof ir == "string" && Ye > ir.length ? ir.length : Ye : (Ae < ye.length - 1 ? e.Debug.assert(Ye < ye[Ae + 1]) : ir !== void 0 && e.Debug.assert(Ye <= ir.length), Ye);
            }
            e.computePositionOfLineAndCharacter = ve;
            function ee(ye) {
              return ye.lineMap || (ye.lineMap = q(ye.text));
            }
            e.getLineStarts = ee;
            function he(ye, Ae) {
              var er = F(ye, Ae);
              return { line: er, character: Ae - ye[er] };
            }
            e.computeLineAndCharacterOfPosition = he;
            function F(ye, Ae, er) {
              var ir = e.binarySearch(ye, Ae, e.identity, e.compareValues, er);
              return ir < 0 && (ir = ~ir - 1, e.Debug.assert(ir !== -1, "position cannot precede the beginning of the file")), ir;
            }
            e.computeLineOfPosition = F;
            function x(ye, Ae, er) {
              if (Ae === er) return 0;
              var ir = ee(ye), Cr = Math.min(Ae, er), Ye = Cr === er, Br = Ye ? Ae : er, Er = F(ir, Cr), Ne = F(ir, Br, Er);
              return Ye ? Er - Ne : Ne - Er;
            }
            e.getLinesBetweenPositions = x;
            function X(ye, Ae) {
              return he(ee(ye), Ae);
            }
            e.getLineAndCharacterOfPosition = X;
            function $(ye) {
              return A(ye) || y(ye);
            }
            e.isWhiteSpaceLike = $;
            function A(ye) {
              return ye === 32 || ye === 9 || ye === 11 || ye === 12 || ye === 160 || ye === 133 || ye === 5760 || ye >= 8192 && ye <= 8203 || ye === 8239 || ye === 8287 || ye === 12288 || ye === 65279;
            }
            e.isWhiteSpaceSingleLine = A;
            function y(ye) {
              return ye === 10 || ye === 13 || ye === 8232 || ye === 8233;
            }
            e.isLineBreak = y;
            function V(ye) {
              return ye >= 48 && ye <= 57;
            }
            function L(ye) {
              return V(ye) || ye >= 65 && ye <= 70 || ye >= 97 && ye <= 102;
            }
            function P(ye) {
              return ye <= 1114111;
            }
            function k(ye) {
              return ye >= 48 && ye <= 55;
            }
            e.isOctalDigit = k;
            function Y(ye, Ae) {
              var er = ye.charCodeAt(Ae);
              switch (er) {
                case 13:
                case 10:
                case 9:
                case 11:
                case 12:
                case 32:
                case 47:
                case 60:
                case 124:
                case 61:
                case 62:
                  return true;
                case 35:
                  return Ae === 0;
                default:
                  return er > 127;
              }
            }
            e.couldStartTrivia = Y;
            function U(ye, Ae, er, ir, Cr) {
              if (e.positionIsSynthesized(Ae)) return Ae;
              for (var Ye = false; ; ) {
                var Br = ye.charCodeAt(Ae);
                switch (Br) {
                  case 13:
                    ye.charCodeAt(Ae + 1) === 10 && Ae++;
                  case 10:
                    if (Ae++, er) return Ae;
                    Ye = !!Cr;
                    continue;
                  case 9:
                  case 11:
                  case 12:
                  case 32:
                    Ae++;
                    continue;
                  case 47:
                    if (ir) break;
                    if (ye.charCodeAt(Ae + 1) === 47) {
                      for (Ae += 2; Ae < ye.length && !y(ye.charCodeAt(Ae)); ) Ae++;
                      Ye = false;
                      continue;
                    }
                    if (ye.charCodeAt(Ae + 1) === 42) {
                      for (Ae += 2; Ae < ye.length; ) {
                        if (ye.charCodeAt(Ae) === 42 && ye.charCodeAt(Ae + 1) === 47) {
                          Ae += 2;
                          break;
                        }
                        Ae++;
                      }
                      Ye = false;
                      continue;
                    }
                    break;
                  case 60:
                  case 124:
                  case 61:
                  case 62:
                    if (H(ye, Ae)) {
                      Ae = I(ye, Ae), Ye = false;
                      continue;
                    }
                    break;
                  case 35:
                    if (Ae === 0 && d(ye, Ae)) {
                      Ae = D(ye, Ae), Ye = false;
                      continue;
                    }
                    break;
                  case 42:
                    if (Ye) {
                      Ae++, Ye = false;
                      continue;
                    }
                    break;
                  default:
                    if (Br > 127 && $(Br)) {
                      Ae++;
                      continue;
                    }
                    break;
                }
                return Ae;
              }
            }
            e.skipTrivia = U;
            var j = 7;
            function H(ye, Ae) {
              if (e.Debug.assert(Ae >= 0), Ae === 0 || y(ye.charCodeAt(Ae - 1))) {
                var er = ye.charCodeAt(Ae);
                if (Ae + j < ye.length) {
                  for (var ir = 0; ir < j; ir++) if (ye.charCodeAt(Ae + ir) !== er) return false;
                  return er === 61 || ye.charCodeAt(Ae + j) === 32;
                }
              }
              return false;
            }
            function I(ye, Ae, er) {
              er && er(e.Diagnostics.Merge_conflict_marker_encountered, Ae, j);
              var ir = ye.charCodeAt(Ae), Cr = ye.length;
              if (ir === 60 || ir === 62) for (; Ae < Cr && !y(ye.charCodeAt(Ae)); ) Ae++;
              else for (e.Debug.assert(ir === 124 || ir === 61); Ae < Cr; ) {
                var Ye = ye.charCodeAt(Ae);
                if ((Ye === 61 || Ye === 62) && Ye !== ir && H(ye, Ae)) break;
                Ae++;
              }
              return Ae;
            }
            var l = /^#!.*/;
            function d(ye, Ae) {
              return e.Debug.assert(Ae === 0), l.test(ye);
            }
            e.isShebangTrivia = d;
            function D(ye, Ae) {
              var er = l.exec(ye)[0];
              return Ae = Ae + er.length, Ae;
            }
            e.scanShebangTrivia = D;
            function fe(ye, Ae, er, ir, Cr, Ye, Br) {
              var Er, Ne, n, lr, be = false, Ge = ir, ur = Br;
              if (er === 0) {
                Ge = true;
                var yr = ge(Ae);
                yr && (er = yr.length);
              }
              e: for (; er >= 0 && er < Ae.length; ) {
                var Ir = Ae.charCodeAt(er);
                switch (Ir) {
                  case 13:
                    Ae.charCodeAt(er + 1) === 10 && er++;
                  case 10:
                    if (er++, ir) break e;
                    Ge = true, be && (lr = true);
                    continue;
                  case 9:
                  case 11:
                  case 12:
                  case 32:
                    er++;
                    continue;
                  case 47:
                    var wr = Ae.charCodeAt(er + 1), Ur = false;
                    if (wr === 47 || wr === 42) {
                      var ii = wr === 47 ? 2 : 3, mi = er;
                      if (er += 2, wr === 47) for (; er < Ae.length; ) {
                        if (y(Ae.charCodeAt(er))) {
                          Ur = true;
                          break;
                        }
                        er++;
                      }
                      else for (; er < Ae.length; ) {
                        if (Ae.charCodeAt(er) === 42 && Ae.charCodeAt(er + 1) === 47) {
                          er += 2;
                          break;
                        }
                        er++;
                      }
                      if (Ge) {
                        if (be && (ur = Cr(Er, Ne, n, lr, Ye, ur), !ye && ur)) return ur;
                        Er = mi, Ne = er, n = ii, lr = Ur, be = true;
                      }
                      continue;
                    }
                    break e;
                  default:
                    if (Ir > 127 && $(Ir)) {
                      be && y(Ir) && (lr = true), er++;
                      continue;
                    }
                    break e;
                }
              }
              return be && (ur = Cr(Er, Ne, n, lr, Ye, ur)), ur;
            }
            function g(ye, Ae, er, ir) {
              return fe(false, ye, Ae, false, er, ir);
            }
            e.forEachLeadingCommentRange = g;
            function ne(ye, Ae, er, ir) {
              return fe(false, ye, Ae, true, er, ir);
            }
            e.forEachTrailingCommentRange = ne;
            function ue(ye, Ae, er, ir, Cr) {
              return fe(true, ye, Ae, false, er, ir, Cr);
            }
            e.reduceEachLeadingCommentRange = ue;
            function We(ye, Ae, er, ir, Cr) {
              return fe(true, ye, Ae, true, er, ir, Cr);
            }
            e.reduceEachTrailingCommentRange = We;
            function Fe(ye, Ae, er, ir, Cr, Ye) {
              return Ye || (Ye = []), Ye.push({ kind: er, pos: ye, end: Ae, hasTrailingNewLine: ir }), Ye;
            }
            function Z(ye, Ae) {
              return ue(ye, Ae, Fe, void 0, void 0);
            }
            e.getLeadingCommentRanges = Z;
            function Be(ye, Ae) {
              return We(ye, Ae, Fe, void 0, void 0);
            }
            e.getTrailingCommentRanges = Be;
            function ge(ye) {
              var Ae = l.exec(ye);
              if (Ae) return Ae[0];
            }
            e.getShebang = ge;
            function Re(ye, Ae) {
              return ye >= 65 && ye <= 90 || ye >= 97 && ye <= 122 || ye === 36 || ye === 95 || ye > 127 && K(ye, Ae);
            }
            e.isIdentifierStart = Re;
            function ze(ye, Ae, er) {
              return ye >= 65 && ye <= 90 || ye >= 97 && ye <= 122 || ye >= 48 && ye <= 57 || ye === 36 || ye === 95 || (er === 1 ? ye === 45 || ye === 58 : false) || ye > 127 && b(ye, Ae);
            }
            e.isIdentifierPart = ze;
            function Ee(ye, Ae, er) {
              var ir = rr(ye, 0);
              if (!Re(ir, Ae)) return false;
              for (var Cr = Ie(ir); Cr < ye.length; Cr += Ie(ir)) if (!ze(ir = rr(ye, Cr), Ae, er)) return false;
              return true;
            }
            e.isIdentifierText = Ee;
            function He(ye, Ae, er, ir, Cr, Ye, Br) {
              er === void 0 && (er = 0);
              var Er = ir, Ne, n, lr, be, Ge, ur, yr, Ir, wr = 0;
              nt(Er, Ye, Br);
              var Ur = { getStartPos: function() {
                return lr;
              }, getTextPos: function() {
                return Ne;
              }, getToken: function() {
                return Ge;
              }, getTokenPos: function() {
                return be;
              }, getTokenText: function() {
                return Er.substring(be, Ne);
              }, getTokenValue: function() {
                return ur;
              }, hasUnicodeEscape: function() {
                return (yr & 1024) !== 0;
              }, hasExtendedUnicodeEscape: function() {
                return (yr & 8) !== 0;
              }, hasPrecedingLineBreak: function() {
                return (yr & 1) !== 0;
              }, hasPrecedingJSDocComment: function() {
                return (yr & 2) !== 0;
              }, isIdentifier: function() {
                return Ge === 79 || Ge > 116;
              }, isReservedWord: function() {
                return Ge >= 81 && Ge <= 116;
              }, isUnterminated: function() {
                return (yr & 4) !== 0;
              }, getCommentDirectives: function() {
                return Ir;
              }, getNumericLiteralFlags: function() {
                return yr & 1008;
              }, getTokenFlags: function() {
                return yr;
              }, reScanGreaterToken: Wr, reScanAsteriskEqualsToken: Je, reScanSlashToken: xe, reScanTemplateToken: Ar, reScanTemplateHeadOrNoSubstitutionTemplate: Oe, scanJsxIdentifier: De, scanJsxAttributeValue: gr, reScanJsxAttributeValue: Vr, reScanJsxToken: nr, reScanLessThanToken: Mr, reScanHashToken: Pe, reScanQuestionToken: Ue, reScanInvalidIdentifier: Sr, scanJsxToken: fr, scanJsDocToken: Tr, scan: Ze, getText: ct, clearCommentDirectives: Li, setText: nt, setScriptTarget: xt, setLanguageVariant: ut, setOnError: Mt, setTextPos: Dt, setInJSDocType: Rt, tryScan: Wi, lookAhead: Yi, scanRange: Ui };
              return e.Debug.isDebugging && Object.defineProperty(Ur, "__debugShowCurrentPositionInText", { get: function() {
                var Ii = Ur.getText();
                return Ii.slice(0, Ur.getStartPos()) + "\u2551" + Ii.slice(Ur.getStartPos());
              } }), Ur;
              function ii(Ii, Ki, Fi) {
                if (Ki === void 0 && (Ki = Ne), Cr) {
                  var ui = Ne;
                  Ne = Ki, Cr(Ii, Fi || 0), Ne = ui;
                }
              }
              function mi() {
                for (var Ii = Ne, Ki = false, Fi = false, ui = ""; ; ) {
                  var Bt = Er.charCodeAt(Ne);
                  if (Bt === 95) {
                    yr |= 512, Ki ? (Ki = false, Fi = true, ui += Er.substring(Ii, Ne)) : ii(Fi ? e.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted : e.Diagnostics.Numeric_separators_are_not_allowed_here, Ne, 1), Ne++, Ii = Ne;
                    continue;
                  }
                  if (V(Bt)) {
                    Ki = true, Fi = false, Ne++;
                    continue;
                  }
                  break;
                }
                return Er.charCodeAt(Ne - 1) === 95 && ii(e.Diagnostics.Numeric_separators_are_not_allowed_here, Ne - 1, 1), ui + Er.substring(Ii, Ne);
              }
              function pe() {
                var Ii = Ne, Ki = mi(), Fi, ui;
                Er.charCodeAt(Ne) === 46 && (Ne++, Fi = mi());
                var Bt = Ne;
                if (Er.charCodeAt(Ne) === 69 || Er.charCodeAt(Ne) === 101) {
                  Ne++, yr |= 16, (Er.charCodeAt(Ne) === 43 || Er.charCodeAt(Ne) === 45) && Ne++;
                  var wt = Ne, na = mi();
                  na ? (ui = Er.substring(Bt, wt) + na, Bt = Ne) : ii(e.Diagnostics.Digit_expected);
                }
                var Ai;
                if (yr & 512 ? (Ai = Ki, Fi && (Ai += "." + Fi), ui && (Ai += ui)) : Ai = Er.substring(Ii, Bt), Fi !== void 0 || yr & 16) return or(Ii, Fi === void 0 && !!(yr & 16)), { type: 8, value: "" + +Ai };
                ur = Ai;
                var Oi = ti();
                return or(Ii), { type: Oi, value: ur };
              }
              function or(Ii, Ki) {
                if (!!Re(rr(Er, Ne), ye)) {
                  var Fi = Ne, ui = ae().length;
                  ui === 1 && Er[Fi] === "n" ? ii(Ki ? e.Diagnostics.A_bigint_literal_cannot_use_exponential_notation : e.Diagnostics.A_bigint_literal_must_be_an_integer, Ii, Fi - Ii + 1) : (ii(e.Diagnostics.An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal, Fi, ui), Ne = Fi);
                }
              }
              function qr() {
                for (var Ii = Ne; k(Er.charCodeAt(Ne)); ) Ne++;
                return +Er.substring(Ii, Ne);
              }
              function si(Ii, Ki) {
                var Fi = wi(Ii, false, Ki);
                return Fi ? parseInt(Fi, 16) : -1;
              }
              function Di(Ii, Ki) {
                return wi(Ii, true, Ki);
              }
              function wi(Ii, Ki, Fi) {
                for (var ui = [], Bt = false, wt = false; ui.length < Ii || Ki; ) {
                  var na = Er.charCodeAt(Ne);
                  if (Fi && na === 95) {
                    yr |= 512, Bt ? (Bt = false, wt = true) : ii(wt ? e.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted : e.Diagnostics.Numeric_separators_are_not_allowed_here, Ne, 1), Ne++;
                    continue;
                  }
                  if (Bt = Fi, na >= 65 && na <= 70) na += 97 - 65;
                  else if (!(na >= 48 && na <= 57 || na >= 97 && na <= 102)) break;
                  ui.push(na), Ne++, wt = false;
                }
                return ui.length < Ii && (ui = []), Er.charCodeAt(Ne - 1) === 95 && ii(e.Diagnostics.Numeric_separators_are_not_allowed_here, Ne - 1, 1), String.fromCharCode.apply(String, ui);
              }
              function Xi(Ii) {
                Ii === void 0 && (Ii = false);
                var Ki = Er.charCodeAt(Ne);
                Ne++;
                for (var Fi = "", ui = Ne; ; ) {
                  if (Ne >= n) {
                    Fi += Er.substring(ui, Ne), yr |= 4, ii(e.Diagnostics.Unterminated_string_literal);
                    break;
                  }
                  var Bt = Er.charCodeAt(Ne);
                  if (Bt === Ki) {
                    Fi += Er.substring(ui, Ne), Ne++;
                    break;
                  }
                  if (Bt === 92 && !Ii) {
                    Fi += Er.substring(ui, Ne), Fi += Gi(), ui = Ne;
                    continue;
                  }
                  if (y(Bt) && !Ii) {
                    Fi += Er.substring(ui, Ne), yr |= 4, ii(e.Diagnostics.Unterminated_string_literal);
                    break;
                  }
                  Ne++;
                }
                return Fi;
              }
              function et(Ii) {
                var Ki = Er.charCodeAt(Ne) === 96;
                Ne++;
                for (var Fi = Ne, ui = "", Bt; ; ) {
                  if (Ne >= n) {
                    ui += Er.substring(Fi, Ne), yr |= 4, ii(e.Diagnostics.Unterminated_template_literal), Bt = Ki ? 14 : 17;
                    break;
                  }
                  var wt = Er.charCodeAt(Ne);
                  if (wt === 96) {
                    ui += Er.substring(Fi, Ne), Ne++, Bt = Ki ? 14 : 17;
                    break;
                  }
                  if (wt === 36 && Ne + 1 < n && Er.charCodeAt(Ne + 1) === 123) {
                    ui += Er.substring(Fi, Ne), Ne += 2, Bt = Ki ? 15 : 16;
                    break;
                  }
                  if (wt === 92) {
                    ui += Er.substring(Fi, Ne), ui += Gi(Ii), Fi = Ne;
                    continue;
                  }
                  if (wt === 13) {
                    ui += Er.substring(Fi, Ne), Ne++, Ne < n && Er.charCodeAt(Ne) === 10 && Ne++, ui += `
`, Fi = Ne;
                    continue;
                  }
                  Ne++;
                }
                return e.Debug.assert(Bt !== void 0), ur = ui, Bt;
              }
              function Gi(Ii) {
                var Ki = Ne;
                if (Ne++, Ne >= n) return ii(e.Diagnostics.Unexpected_end_of_text), "";
                var Fi = Er.charCodeAt(Ne);
                switch (Ne++, Fi) {
                  case 48:
                    return Ii && Ne < n && V(Er.charCodeAt(Ne)) ? (Ne++, yr |= 2048, Er.substring(Ki, Ne)) : "\0";
                  case 98:
                    return "\b";
                  case 116:
                    return "	";
                  case 110:
                    return `
`;
                  case 118:
                    return "\v";
                  case 102:
                    return "\f";
                  case 114:
                    return "\r";
                  case 39:
                    return "'";
                  case 34:
                    return '"';
                  case 117:
                    if (Ii) {
                      for (var ui = Ne; ui < Ne + 4; ui++) if (ui < n && !L(Er.charCodeAt(ui)) && Er.charCodeAt(ui) !== 123) return Ne = ui, yr |= 2048, Er.substring(Ki, Ne);
                    }
                    if (Ne < n && Er.charCodeAt(Ne) === 123) {
                      if (Ne++, Ii && !L(Er.charCodeAt(Ne))) return yr |= 2048, Er.substring(Ki, Ne);
                      if (Ii) {
                        var Bt = Ne, wt = Di(1, false), na = wt ? parseInt(wt, 16) : -1;
                        if (!P(na) || Er.charCodeAt(Ne) !== 125) return yr |= 2048, Er.substring(Ki, Ne);
                        Ne = Bt;
                      }
                      return yr |= 8, Zt();
                    }
                    return yr |= 1024, Wt(4);
                  case 120:
                    if (Ii) if (L(Er.charCodeAt(Ne))) {
                      if (!L(Er.charCodeAt(Ne + 1))) return Ne++, yr |= 2048, Er.substring(Ki, Ne);
                    } else return yr |= 2048, Er.substring(Ki, Ne);
                    return Wt(2);
                  case 13:
                    Ne < n && Er.charCodeAt(Ne) === 10 && Ne++;
                  case 10:
                  case 8232:
                  case 8233:
                    return "";
                  default:
                    return String.fromCharCode(Fi);
                }
              }
              function Wt(Ii) {
                var Ki = si(Ii, false);
                return Ki >= 0 ? String.fromCharCode(Ki) : (ii(e.Diagnostics.Hexadecimal_digit_expected), "");
              }
              function Zt() {
                var Ii = Di(1, false), Ki = Ii ? parseInt(Ii, 16) : -1, Fi = false;
                return Ki < 0 ? (ii(e.Diagnostics.Hexadecimal_digit_expected), Fi = true) : Ki > 1114111 && (ii(e.Diagnostics.An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive), Fi = true), Ne >= n ? (ii(e.Diagnostics.Unexpected_end_of_text), Fi = true) : Er.charCodeAt(Ne) === 125 ? Ne++ : (ii(e.Diagnostics.Unterminated_Unicode_escape_sequence), Fi = true), Fi ? "" : de(Ki);
              }
              function _r() {
                if (Ne + 5 < n && Er.charCodeAt(Ne + 1) === 117) {
                  var Ii = Ne;
                  Ne += 2;
                  var Ki = si(4, false);
                  return Ne = Ii, Ki;
                }
                return -1;
              }
              function pi() {
                if (ye >= 2 && rr(Er, Ne + 1) === 117 && rr(Er, Ne + 2) === 123) {
                  var Ii = Ne;
                  Ne += 3;
                  var Ki = Di(1, false), Fi = Ki ? parseInt(Ki, 16) : -1;
                  return Ne = Ii, Fi;
                }
                return -1;
              }
              function ae() {
                for (var Ii = "", Ki = Ne; Ne < n; ) {
                  var Fi = rr(Er, Ne);
                  if (ze(Fi, ye)) Ne += Ie(Fi);
                  else if (Fi === 92) {
                    if (Fi = pi(), Fi >= 0 && ze(Fi, ye)) {
                      Ne += 3, yr |= 8, Ii += Zt(), Ki = Ne;
                      continue;
                    }
                    if (Fi = _r(), !(Fi >= 0 && ze(Fi, ye))) break;
                    yr |= 1024, Ii += Er.substring(Ki, Ne), Ii += de(Fi), Ne += 6, Ki = Ne;
                  } else break;
                }
                return Ii += Er.substring(Ki, Ne), Ii;
              }
              function Xe() {
                var Ii = ur.length;
                if (Ii >= 2 && Ii <= 12) {
                  var Ki = ur.charCodeAt(0);
                  if (Ki >= 97 && Ki <= 122) {
                    var Fi = B.get(ur);
                    if (Fi !== void 0) return Ge = Fi;
                  }
                }
                return Ge = 79;
              }
              function Jr(Ii) {
                for (var Ki = "", Fi = false, ui = false; ; ) {
                  var Bt = Er.charCodeAt(Ne);
                  if (Bt === 95) {
                    yr |= 512, Fi ? (Fi = false, ui = true) : ii(ui ? e.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted : e.Diagnostics.Numeric_separators_are_not_allowed_here, Ne, 1), Ne++;
                    continue;
                  }
                  if (Fi = true, !V(Bt) || Bt - 48 >= Ii) break;
                  Ki += Er[Ne], Ne++, ui = false;
                }
                return Er.charCodeAt(Ne - 1) === 95 && ii(e.Diagnostics.Numeric_separators_are_not_allowed_here, Ne - 1, 1), Ki;
              }
              function ti() {
                if (Er.charCodeAt(Ne) === 110) return ur += "n", yr & 384 && (ur = e.parsePseudoBigInt(ur) + "n"), Ne++, 9;
                var Ii = yr & 128 ? parseInt(ur.slice(2), 2) : yr & 256 ? parseInt(ur.slice(2), 8) : +ur;
                return ur = "" + Ii, 8;
              }
              function Ze() {
                var Ii;
                lr = Ne, yr = 0;
                for (var Ki = false; ; ) {
                  if (be = Ne, Ne >= n) return Ge = 1;
                  var Fi = rr(Er, Ne);
                  if (Fi === 35 && Ne === 0 && d(Er, Ne)) {
                    if (Ne = D(Er, Ne), Ae) continue;
                    return Ge = 6;
                  }
                  switch (Fi) {
                    case 10:
                    case 13:
                      if (yr |= 1, Ae) {
                        Ne++;
                        continue;
                      } else return Fi === 13 && Ne + 1 < n && Er.charCodeAt(Ne + 1) === 10 ? Ne += 2 : Ne++, Ge = 4;
                    case 9:
                    case 11:
                    case 12:
                    case 32:
                    case 160:
                    case 5760:
                    case 8192:
                    case 8193:
                    case 8194:
                    case 8195:
                    case 8196:
                    case 8197:
                    case 8198:
                    case 8199:
                    case 8200:
                    case 8201:
                    case 8202:
                    case 8203:
                    case 8239:
                    case 8287:
                    case 12288:
                    case 65279:
                      if (Ae) {
                        Ne++;
                        continue;
                      } else {
                        for (; Ne < n && A(Er.charCodeAt(Ne)); ) Ne++;
                        return Ge = 5;
                      }
                    case 33:
                      return Er.charCodeAt(Ne + 1) === 61 ? Er.charCodeAt(Ne + 2) === 61 ? (Ne += 3, Ge = 37) : (Ne += 2, Ge = 35) : (Ne++, Ge = 53);
                    case 34:
                    case 39:
                      return ur = Xi(), Ge = 10;
                    case 96:
                      return Ge = et(false);
                    case 37:
                      return Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 69) : (Ne++, Ge = 44);
                    case 38:
                      return Er.charCodeAt(Ne + 1) === 38 ? Er.charCodeAt(Ne + 2) === 61 ? (Ne += 3, Ge = 76) : (Ne += 2, Ge = 55) : Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 73) : (Ne++, Ge = 50);
                    case 40:
                      return Ne++, Ge = 20;
                    case 41:
                      return Ne++, Ge = 21;
                    case 42:
                      if (Er.charCodeAt(Ne + 1) === 61) return Ne += 2, Ge = 66;
                      if (Er.charCodeAt(Ne + 1) === 42) return Er.charCodeAt(Ne + 2) === 61 ? (Ne += 3, Ge = 67) : (Ne += 2, Ge = 42);
                      if (Ne++, wr && !Ki && yr & 1) {
                        Ki = true;
                        continue;
                      }
                      return Ge = 41;
                    case 43:
                      return Er.charCodeAt(Ne + 1) === 43 ? (Ne += 2, Ge = 45) : Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 64) : (Ne++, Ge = 39);
                    case 44:
                      return Ne++, Ge = 27;
                    case 45:
                      return Er.charCodeAt(Ne + 1) === 45 ? (Ne += 2, Ge = 46) : Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 65) : (Ne++, Ge = 40);
                    case 46:
                      return V(Er.charCodeAt(Ne + 1)) ? (ur = pe().value, Ge = 8) : Er.charCodeAt(Ne + 1) === 46 && Er.charCodeAt(Ne + 2) === 46 ? (Ne += 3, Ge = 25) : (Ne++, Ge = 24);
                    case 47:
                      if (Er.charCodeAt(Ne + 1) === 47) {
                        for (Ne += 2; Ne < n && !y(Er.charCodeAt(Ne)); ) Ne++;
                        if (Ir = vr(Ir, Er.slice(be, Ne), oe, be), Ae) continue;
                        return Ge = 2;
                      }
                      if (Er.charCodeAt(Ne + 1) === 42) {
                        Ne += 2, Er.charCodeAt(Ne) === 42 && Er.charCodeAt(Ne + 1) !== 47 && (yr |= 2);
                        for (var ui = false, Bt = be; Ne < n; ) {
                          var wt = Er.charCodeAt(Ne);
                          if (wt === 42 && Er.charCodeAt(Ne + 1) === 47) {
                            Ne += 2, ui = true;
                            break;
                          }
                          Ne++, y(wt) && (Bt = Ne, yr |= 1);
                        }
                        if (Ir = vr(Ir, Er.slice(Bt, Ne), f, Bt), ui || ii(e.Diagnostics.Asterisk_Slash_expected), Ae) continue;
                        return ui || (yr |= 4), Ge = 3;
                      }
                      return Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 68) : (Ne++, Ge = 43);
                    case 48:
                      if (Ne + 2 < n && (Er.charCodeAt(Ne + 1) === 88 || Er.charCodeAt(Ne + 1) === 120)) return Ne += 2, ur = Di(1, true), ur || (ii(e.Diagnostics.Hexadecimal_digit_expected), ur = "0"), ur = "0x" + ur, yr |= 64, Ge = ti();
                      if (Ne + 2 < n && (Er.charCodeAt(Ne + 1) === 66 || Er.charCodeAt(Ne + 1) === 98)) return Ne += 2, ur = Jr(2), ur || (ii(e.Diagnostics.Binary_digit_expected), ur = "0"), ur = "0b" + ur, yr |= 128, Ge = ti();
                      if (Ne + 2 < n && (Er.charCodeAt(Ne + 1) === 79 || Er.charCodeAt(Ne + 1) === 111)) return Ne += 2, ur = Jr(8), ur || (ii(e.Diagnostics.Octal_digit_expected), ur = "0"), ur = "0o" + ur, yr |= 256, Ge = ti();
                      if (Ne + 1 < n && k(Er.charCodeAt(Ne + 1))) return ur = "" + qr(), yr |= 32, Ge = 8;
                    case 49:
                    case 50:
                    case 51:
                    case 52:
                    case 53:
                    case 54:
                    case 55:
                    case 56:
                    case 57:
                      return Ii = pe(), Ge = Ii.type, ur = Ii.value, Ge;
                    case 58:
                      return Ne++, Ge = 58;
                    case 59:
                      return Ne++, Ge = 26;
                    case 60:
                      if (H(Er, Ne)) {
                        if (Ne = I(Er, Ne, ii), Ae) continue;
                        return Ge = 7;
                      }
                      return Er.charCodeAt(Ne + 1) === 60 ? Er.charCodeAt(Ne + 2) === 61 ? (Ne += 3, Ge = 70) : (Ne += 2, Ge = 47) : Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 32) : er === 1 && Er.charCodeAt(Ne + 1) === 47 && Er.charCodeAt(Ne + 2) !== 42 ? (Ne += 2, Ge = 30) : (Ne++, Ge = 29);
                    case 61:
                      if (H(Er, Ne)) {
                        if (Ne = I(Er, Ne, ii), Ae) continue;
                        return Ge = 7;
                      }
                      return Er.charCodeAt(Ne + 1) === 61 ? Er.charCodeAt(Ne + 2) === 61 ? (Ne += 3, Ge = 36) : (Ne += 2, Ge = 34) : Er.charCodeAt(Ne + 1) === 62 ? (Ne += 2, Ge = 38) : (Ne++, Ge = 63);
                    case 62:
                      if (H(Er, Ne)) {
                        if (Ne = I(Er, Ne, ii), Ae) continue;
                        return Ge = 7;
                      }
                      return Ne++, Ge = 31;
                    case 63:
                      return Er.charCodeAt(Ne + 1) === 46 && !V(Er.charCodeAt(Ne + 2)) ? (Ne += 2, Ge = 28) : Er.charCodeAt(Ne + 1) === 63 ? Er.charCodeAt(Ne + 2) === 61 ? (Ne += 3, Ge = 77) : (Ne += 2, Ge = 60) : (Ne++, Ge = 57);
                    case 91:
                      return Ne++, Ge = 22;
                    case 93:
                      return Ne++, Ge = 23;
                    case 94:
                      return Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 78) : (Ne++, Ge = 52);
                    case 123:
                      return Ne++, Ge = 18;
                    case 124:
                      if (H(Er, Ne)) {
                        if (Ne = I(Er, Ne, ii), Ae) continue;
                        return Ge = 7;
                      }
                      return Er.charCodeAt(Ne + 1) === 124 ? Er.charCodeAt(Ne + 2) === 61 ? (Ne += 3, Ge = 75) : (Ne += 2, Ge = 56) : Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 74) : (Ne++, Ge = 51);
                    case 125:
                      return Ne++, Ge = 19;
                    case 126:
                      return Ne++, Ge = 54;
                    case 64:
                      return Ne++, Ge = 59;
                    case 92:
                      var na = pi();
                      if (na >= 0 && Re(na, ye)) return Ne += 3, yr |= 8, ur = Zt() + ae(), Ge = Xe();
                      var Ai = _r();
                      return Ai >= 0 && Re(Ai, ye) ? (Ne += 6, yr |= 1024, ur = String.fromCharCode(Ai) + ae(), Ge = Xe()) : (ii(e.Diagnostics.Invalid_character), Ne++, Ge = 0);
                    case 35:
                      return Ne !== 0 && Er[Ne + 1] === "!" ? (ii(e.Diagnostics.can_only_be_used_at_the_start_of_a_file), Ne++, Ge = 0) : (Re(rr(Er, Ne + 1), ye) ? (Ne++, zr(rr(Er, Ne), ye)) : (ur = String.fromCharCode(rr(Er, Ne)), ii(e.Diagnostics.Invalid_character, Ne++, Ie(Fi))), Ge = 80);
                    default:
                      var Oi = zr(Fi, ye);
                      if (Oi) return Ge = Oi;
                      if (A(Fi)) {
                        Ne += Ie(Fi);
                        continue;
                      } else if (y(Fi)) {
                        yr |= 1, Ne += Ie(Fi);
                        continue;
                      }
                      var ji = Ie(Fi);
                      return ii(e.Diagnostics.Invalid_character, Ne, ji), Ne += ji, Ge = 0;
                  }
                }
              }
              function Sr() {
                e.Debug.assert(Ge === 0, "'reScanInvalidIdentifier' should only be called when the current token is 'SyntaxKind.Unknown'."), Ne = be = lr, yr = 0;
                var Ii = rr(Er, Ne), Ki = zr(Ii, 99);
                return Ki ? Ge = Ki : (Ne += Ie(Ii), Ge);
              }
              function zr(Ii, Ki) {
                var Fi = Ii;
                if (Re(Fi, Ki)) {
                  for (Ne += Ie(Fi); Ne < n && ze(Fi = rr(Er, Ne), Ki); ) Ne += Ie(Fi);
                  return ur = Er.substring(be, Ne), Fi === 92 && (ur += ae()), Xe();
                }
              }
              function Wr() {
                if (Ge === 31) {
                  if (Er.charCodeAt(Ne) === 62) return Er.charCodeAt(Ne + 1) === 62 ? Er.charCodeAt(Ne + 2) === 61 ? (Ne += 3, Ge = 72) : (Ne += 2, Ge = 49) : Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 71) : (Ne++, Ge = 48);
                  if (Er.charCodeAt(Ne) === 61) return Ne++, Ge = 33;
                }
                return Ge;
              }
              function Je() {
                return e.Debug.assert(Ge === 66, "'reScanAsteriskEqualsToken' should only be called on a '*='"), Ne = be + 1, Ge = 63;
              }
              function xe() {
                if (Ge === 43 || Ge === 68) {
                  for (var Ii = be + 1, Ki = false, Fi = false; ; ) {
                    if (Ii >= n) {
                      yr |= 4, ii(e.Diagnostics.Unterminated_regular_expression_literal);
                      break;
                    }
                    var ui = Er.charCodeAt(Ii);
                    if (y(ui)) {
                      yr |= 4, ii(e.Diagnostics.Unterminated_regular_expression_literal);
                      break;
                    }
                    if (Ki) Ki = false;
                    else if (ui === 47 && !Fi) {
                      Ii++;
                      break;
                    } else ui === 91 ? Fi = true : ui === 92 ? Ki = true : ui === 93 && (Fi = false);
                    Ii++;
                  }
                  for (; Ii < n && ze(Er.charCodeAt(Ii), ye); ) Ii++;
                  Ne = Ii, ur = Er.substring(be, Ne), Ge = 13;
                }
                return Ge;
              }
              function vr(Ii, Ki, Fi, ui) {
                var Bt = mr(e.trimStringStart(Ki), Fi);
                return Bt === void 0 ? Ii : e.append(Ii, { range: { pos: ui, end: Ne }, type: Bt });
              }
              function mr(Ii, Ki) {
                var Fi = Ki.exec(Ii);
                if (!!Fi) switch (Fi[1]) {
                  case "ts-expect-error":
                    return 0;
                  case "ts-ignore":
                    return 1;
                }
              }
              function Ar(Ii) {
                return e.Debug.assert(Ge === 19, "'reScanTemplateToken' should only be called on a '}'"), Ne = be, Ge = et(Ii);
              }
              function Oe() {
                return Ne = be, Ge = et(true);
              }
              function nr(Ii) {
                return Ii === void 0 && (Ii = true), Ne = be = lr, Ge = fr(Ii);
              }
              function Mr() {
                return Ge === 47 ? (Ne = be + 1, Ge = 29) : Ge;
              }
              function Pe() {
                return Ge === 80 ? (Ne = be + 1, Ge = 62) : Ge;
              }
              function Ue() {
                return e.Debug.assert(Ge === 60, "'reScanQuestionToken' should only be called on a '??'"), Ne = be + 1, Ge = 57;
              }
              function fr(Ii) {
                if (Ii === void 0 && (Ii = true), lr = be = Ne, Ne >= n) return Ge = 1;
                var Ki = Er.charCodeAt(Ne);
                if (Ki === 60) return Er.charCodeAt(Ne + 1) === 47 ? (Ne += 2, Ge = 30) : (Ne++, Ge = 29);
                if (Ki === 123) return Ne++, Ge = 18;
                for (var Fi = 0; Ne < n && (Ki = Er.charCodeAt(Ne), Ki !== 123); ) {
                  if (Ki === 60) {
                    if (H(Er, Ne)) return Ne = I(Er, Ne, ii), Ge = 7;
                    break;
                  }
                  if (Ki === 62 && ii(e.Diagnostics.Unexpected_token_Did_you_mean_or_gt, Ne, 1), Ki === 125 && ii(e.Diagnostics.Unexpected_token_Did_you_mean_or_rbrace, Ne, 1), y(Ki) && Fi === 0) Fi = -1;
                  else {
                    if (!Ii && y(Ki) && Fi > 0) break;
                    $(Ki) || (Fi = Ne);
                  }
                  Ne++;
                }
                return ur = Er.substring(lr, Ne), Fi === -1 ? 12 : 11;
              }
              function De() {
                if (C(Ge)) {
                  for (var Ii = false; Ne < n; ) {
                    var Ki = Er.charCodeAt(Ne);
                    if (Ki === 45) {
                      ur += "-", Ne++;
                      continue;
                    } else if (Ki === 58 && !Ii) {
                      ur += ":", Ne++, Ii = true, Ge = 79;
                      continue;
                    }
                    var Fi = Ne;
                    if (ur += ae(), Ne === Fi) break;
                  }
                  return ur.slice(-1) === ":" && (ur = ur.slice(0, -1), Ne--), Xe();
                }
                return Ge;
              }
              function gr() {
                switch (lr = Ne, Er.charCodeAt(Ne)) {
                  case 34:
                  case 39:
                    return ur = Xi(true), Ge = 10;
                  default:
                    return Ze();
                }
              }
              function Vr() {
                return Ne = be = lr, gr();
              }
              function Tr() {
                if (lr = be = Ne, yr = 0, Ne >= n) return Ge = 1;
                var Ii = rr(Er, Ne);
                switch (Ne += Ie(Ii), Ii) {
                  case 9:
                  case 11:
                  case 12:
                  case 32:
                    for (; Ne < n && A(Er.charCodeAt(Ne)); ) Ne++;
                    return Ge = 5;
                  case 64:
                    return Ge = 59;
                  case 13:
                    Er.charCodeAt(Ne) === 10 && Ne++;
                  case 10:
                    return yr |= 1, Ge = 4;
                  case 42:
                    return Ge = 41;
                  case 123:
                    return Ge = 18;
                  case 125:
                    return Ge = 19;
                  case 91:
                    return Ge = 22;
                  case 93:
                    return Ge = 23;
                  case 60:
                    return Ge = 29;
                  case 62:
                    return Ge = 31;
                  case 61:
                    return Ge = 63;
                  case 44:
                    return Ge = 27;
                  case 46:
                    return Ge = 24;
                  case 96:
                    return Ge = 61;
                  case 35:
                    return Ge = 62;
                  case 92:
                    Ne--;
                    var Ki = pi();
                    if (Ki >= 0 && Re(Ki, ye)) return Ne += 3, yr |= 8, ur = Zt() + ae(), Ge = Xe();
                    var Fi = _r();
                    return Fi >= 0 && Re(Fi, ye) ? (Ne += 6, yr |= 1024, ur = String.fromCharCode(Fi) + ae(), Ge = Xe()) : (Ne++, Ge = 0);
                }
                if (Re(Ii, ye)) {
                  for (var ui = Ii; Ne < n && ze(ui = rr(Er, Ne), ye) || Er.charCodeAt(Ne) === 45; ) Ne += Ie(ui);
                  return ur = Er.substring(be, Ne), ui === 92 && (ur += ae()), Ge = Xe();
                } else return Ge = 0;
              }
              function vi(Ii, Ki) {
                var Fi = Ne, ui = lr, Bt = be, wt = Ge, na = ur, Ai = yr, Oi = Ii();
                return (!Oi || Ki) && (Ne = Fi, lr = ui, be = Bt, Ge = wt, ur = na, yr = Ai), Oi;
              }
              function Ui(Ii, Ki, Fi) {
                var ui = n, Bt = Ne, wt = lr, na = be, Ai = Ge, Oi = ur, ji = yr, Vi = Ir;
                nt(Er, Ii, Ki);
                var at = Fi();
                return n = ui, Ne = Bt, lr = wt, be = na, Ge = Ai, ur = Oi, yr = ji, Ir = Vi, at;
              }
              function Yi(Ii) {
                return vi(Ii, true);
              }
              function Wi(Ii) {
                return vi(Ii, false);
              }
              function ct() {
                return Er;
              }
              function Li() {
                Ir = void 0;
              }
              function nt(Ii, Ki, Fi) {
                Er = Ii || "", n = Fi === void 0 ? Er.length : Ki + Fi, Dt(Ki || 0);
              }
              function Mt(Ii) {
                Cr = Ii;
              }
              function xt(Ii) {
                ye = Ii;
              }
              function ut(Ii) {
                er = Ii;
              }
              function Dt(Ii) {
                e.Debug.assert(Ii >= 0), Ne = Ii, lr = Ii, be = Ii, Ge = 0, ur = void 0, yr = 0;
              }
              function Rt(Ii) {
                wr += Ii ? 1 : -1;
              }
            }
            e.createScanner = He;
            var rr = String.prototype.codePointAt ? function(ye, Ae) {
              return ye.codePointAt(Ae);
            } : function(Ae, er) {
              var ir = Ae.length;
              if (!(er < 0 || er >= ir)) {
                var Cr = Ae.charCodeAt(er);
                if (Cr >= 55296 && Cr <= 56319 && ir > er + 1) {
                  var Ye = Ae.charCodeAt(er + 1);
                  if (Ye >= 56320 && Ye <= 57343) return (Cr - 55296) * 1024 + Ye - 56320 + 65536;
                }
                return Cr;
              }
            };
            function Ie(ye) {
              return ye >= 65536 ? 2 : 1;
            }
            function _e(ye) {
              if (e.Debug.assert(0 <= ye && ye <= 1114111), ye <= 65535) return String.fromCharCode(ye);
              var Ae = Math.floor((ye - 65536) / 1024) + 55296, er = (ye - 65536) % 1024 + 56320;
              return String.fromCharCode(Ae, er);
            }
            var we = String.fromCodePoint ? function(ye) {
              return String.fromCodePoint(ye);
            } : _e;
            function de(ye) {
              return we(ye);
            }
            e.utf16EncodeAsString = de;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(je) {
              return e.pathIsRelative(je) || e.isRootedDiskPath(je);
            }
            e.isExternalModuleNameRelative = a;
            function C(je) {
              return e.sortAndDeduplicate(je, e.compareDiagnostics);
            }
            e.sortAndDeduplicateDiagnostics = C;
            function w(je) {
              switch (e.getEmitScriptTarget(je)) {
                case 99:
                  return "lib.esnext.full.d.ts";
                case 9:
                  return "lib.es2022.full.d.ts";
                case 8:
                  return "lib.es2021.full.d.ts";
                case 7:
                  return "lib.es2020.full.d.ts";
                case 6:
                  return "lib.es2019.full.d.ts";
                case 5:
                  return "lib.es2018.full.d.ts";
                case 4:
                  return "lib.es2017.full.d.ts";
                case 3:
                  return "lib.es2016.full.d.ts";
                case 2:
                  return "lib.es6.d.ts";
                default:
                  return "lib.d.ts";
              }
            }
            e.getDefaultLibFileName = w;
            function B(je) {
              return je.start + je.length;
            }
            e.textSpanEnd = B;
            function E(je) {
              return je.length === 0;
            }
            e.textSpanIsEmpty = E;
            function Q(je, Hr) {
              return Hr >= je.start && Hr < B(je);
            }
            e.textSpanContainsPosition = Q;
            function le(je, Hr) {
              return Hr >= je.pos && Hr <= je.end;
            }
            e.textRangeContainsPositionInclusive = le;
            function N(je, Hr) {
              return Hr.start >= je.start && B(Hr) <= B(je);
            }
            e.textSpanContainsTextSpan = N;
            function p(je, Hr) {
              return m(je, Hr) !== void 0;
            }
            e.textSpanOverlapsWith = p;
            function m(je, Hr) {
              var pt = K(je, Hr);
              return pt && pt.length === 0 ? void 0 : pt;
            }
            e.textSpanOverlap = m;
            function G(je, Hr) {
              return f(je.start, je.length, Hr.start, Hr.length);
            }
            e.textSpanIntersectsWithTextSpan = G;
            function oe(je, Hr, pt) {
              return f(je.start, je.length, Hr, pt);
            }
            e.textSpanIntersectsWith = oe;
            function f(je, Hr, pt, Pt) {
              var ga = je + Hr, ua = pt + Pt;
              return pt <= ga && ua >= je;
            }
            e.decodedTextSpanIntersectsWith = f;
            function T(je, Hr) {
              return Hr <= B(je) && Hr >= je.start;
            }
            e.textSpanIntersectsWithPosition = T;
            function K(je, Hr) {
              var pt = Math.max(je.start, Hr.start), Pt = Math.min(B(je), B(Hr));
              return pt <= Pt ? se(pt, Pt) : void 0;
            }
            e.textSpanIntersection = K;
            function b(je, Hr) {
              if (je < 0) throw new Error("start < 0");
              if (Hr < 0) throw new Error("length < 0");
              return { start: je, length: Hr };
            }
            e.createTextSpan = b;
            function se(je, Hr) {
              return b(je, Hr - je);
            }
            e.createTextSpanFromBounds = se;
            function J(je) {
              return b(je.span.start, je.newLength);
            }
            e.textChangeRangeNewSpan = J;
            function ie(je) {
              return E(je.span) && je.newLength === 0;
            }
            e.textChangeRangeIsUnchanged = ie;
            function R(je, Hr) {
              if (Hr < 0) throw new Error("newLength < 0");
              return { span: je, newLength: Hr };
            }
            e.createTextChangeRange = R, e.unchangedTextChangeRange = R(b(0, 0), 0);
            function q(je) {
              if (je.length === 0) return e.unchangedTextChangeRange;
              if (je.length === 1) return je[0];
              for (var Hr = je[0], pt = Hr.span.start, Pt = B(Hr.span), ga = pt + Hr.newLength, ua = 1; ua < je.length; ua++) {
                var Xn = je[ua], jr = pt, fo = Pt, xs = ga, Fo = Xn.span.start, ko = B(Xn.span), Ao = Fo + Xn.newLength;
                pt = Math.min(jr, Fo), Pt = Math.max(fo, fo + (ko - xs)), ga = Math.max(Ao, Ao + (xs - ko));
              }
              return R(se(pt, Pt), ga - pt);
            }
            e.collapseTextChangeRangesAcrossMultipleVersions = q;
            function O(je) {
              if (je && je.kind === 163) {
                for (var Hr = je; Hr; Hr = Hr.parent) if (Dt(Hr) || na(Hr) || Hr.kind === 258) return Hr;
              }
            }
            e.getTypeParameterOwner = O;
            function ve(je, Hr) {
              return e.hasSyntacticModifier(je, 16476) && Hr.kind === 171;
            }
            e.isParameterPropertyDeclaration = ve;
            function ee(je) {
              return $a(je) ? e.every(je.elements, he) : false;
            }
            e.isEmptyBindingPattern = ee;
            function he(je) {
              return e.isOmittedExpression(je) ? true : ee(je.name);
            }
            e.isEmptyBindingElement = he;
            function F(je) {
              for (var Hr = je.parent; e.isBindingElement(Hr.parent); ) Hr = Hr.parent.parent;
              return Hr.parent;
            }
            e.walkUpBindingElementsAndPatterns = F;
            function x(je, Hr) {
              e.isBindingElement(je) && (je = F(je));
              var pt = Hr(je);
              return je.kind === 254 && (je = je.parent), je && je.kind === 255 && (pt |= Hr(je), je = je.parent), je && je.kind === 237 && (pt |= Hr(je)), pt;
            }
            function X(je) {
              return x(je, e.getEffectiveModifierFlags);
            }
            e.getCombinedModifierFlags = X;
            function $(je) {
              return x(je, e.getEffectiveModifierFlagsAlwaysIncludeJSDoc);
            }
            e.getCombinedNodeFlagsAlwaysIncludeJSDoc = $;
            function A(je) {
              return x(je, function(Hr) {
                return Hr.flags;
              });
            }
            e.getCombinedNodeFlags = A, e.supportedLocaleDirectories = ["cs", "de", "es", "fr", "it", "ja", "ko", "pl", "pt-br", "ru", "tr", "zh-cn", "zh-tw"];
            function y(je, Hr, pt) {
              var Pt = je.toLowerCase(), ga = /^([a-z]+)([_\-]([a-z]+))?$/.exec(Pt);
              if (!ga) {
                pt && pt.push(e.createCompilerDiagnostic(e.Diagnostics.Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1, "en", "ja-jp"));
                return;
              }
              var ua = ga[1], Xn = ga[3];
              e.contains(e.supportedLocaleDirectories, Pt) && !jr(ua, Xn, pt) && jr(ua, void 0, pt), e.setUILocale(je);
              function jr(fo, xs, Fo) {
                var ko = e.normalizePath(Hr.getExecutingFilePath()), Ao = e.getDirectoryPath(ko), Ms = e.combinePaths(Ao, fo);
                if (xs && (Ms = Ms + "-" + xs), Ms = Hr.resolvePath(e.combinePaths(Ms, "diagnosticMessages.generated.json")), !Hr.fileExists(Ms)) return false;
                var Bs = "";
                try {
                  Bs = Hr.readFile(Ms);
                } catch {
                  return Fo && Fo.push(e.createCompilerDiagnostic(e.Diagnostics.Unable_to_open_file_0, Ms)), false;
                }
                try {
                  e.setLocalizedDiagnosticMessages(JSON.parse(Bs));
                } catch {
                  return Fo && Fo.push(e.createCompilerDiagnostic(e.Diagnostics.Corrupted_locale_file_0, Ms)), false;
                }
                return true;
              }
            }
            e.validateLocaleAndSetLanguage = y;
            function V(je, Hr) {
              if (je) for (; je.original !== void 0; ) je = je.original;
              return !Hr || Hr(je) ? je : void 0;
            }
            e.getOriginalNode = V;
            function L(je, Hr) {
              for (; je; ) {
                var pt = Hr(je);
                if (pt === "quit") return;
                if (pt) return je;
                je = je.parent;
              }
            }
            e.findAncestor = L;
            function P(je) {
              return (je.flags & 8) === 0;
            }
            e.isParseTreeNode = P;
            function k(je, Hr) {
              if (je === void 0 || P(je)) return je;
              for (je = je.original; je; ) {
                if (P(je)) return !Hr || Hr(je) ? je : void 0;
                je = je.original;
              }
            }
            e.getParseTreeNode = k;
            function Y(je) {
              return je.length >= 2 && je.charCodeAt(0) === 95 && je.charCodeAt(1) === 95 ? "_" + je : je;
            }
            e.escapeLeadingUnderscores = Y;
            function U(je) {
              var Hr = je;
              return Hr.length >= 3 && Hr.charCodeAt(0) === 95 && Hr.charCodeAt(1) === 95 && Hr.charCodeAt(2) === 95 ? Hr.substr(1) : Hr;
            }
            e.unescapeLeadingUnderscores = U;
            function j(je) {
              return U(je.escapedText);
            }
            e.idText = j;
            function H(je) {
              return je.valueDeclaration && Ui(je.valueDeclaration) ? j(je.valueDeclaration.name) : U(je.escapedName);
            }
            e.symbolName = H;
            function I(je) {
              var Hr = je.parent.parent;
              if (!!Hr) {
                if (Si(Hr)) return l(Hr);
                switch (Hr.kind) {
                  case 237:
                    if (Hr.declarationList && Hr.declarationList.declarations[0]) return l(Hr.declarationList.declarations[0]);
                    break;
                  case 238:
                    var pt = Hr.expression;
                    switch (pt.kind === 221 && pt.operatorToken.kind === 63 && (pt = pt.left), pt.kind) {
                      case 206:
                        return pt.name;
                      case 207:
                        var Pt = pt.argumentExpression;
                        if (e.isIdentifier(Pt)) return Pt;
                    }
                    break;
                  case 212:
                    return l(Hr.expression);
                  case 250: {
                    if (Si(Hr.statement) || En(Hr.statement)) return l(Hr.statement);
                    break;
                  }
                }
              }
            }
            function l(je) {
              var Hr = ne(je);
              return Hr && e.isIdentifier(Hr) ? Hr : void 0;
            }
            function d(je, Hr) {
              return !!(fe(je) && e.isIdentifier(je.name) && j(je.name) === j(Hr) || e.isVariableStatement(je) && e.some(je.declarationList.declarations, function(pt) {
                return d(pt, Hr);
              }));
            }
            e.nodeHasName = d;
            function D(je) {
              return je.name || I(je);
            }
            e.getNameOfJSDocTypedef = D;
            function fe(je) {
              return !!je.name;
            }
            e.isNamedDeclaration = fe;
            function g(je) {
              switch (je.kind) {
                case 79:
                  return je;
                case 347:
                case 340: {
                  var Hr = je.name;
                  if (Hr.kind === 161) return Hr.right;
                  break;
                }
                case 208:
                case 221: {
                  var pt = je;
                  switch (e.getAssignmentDeclarationKind(pt)) {
                    case 1:
                    case 4:
                    case 5:
                    case 3:
                      return e.getElementOrPropertyAccessArgumentExpressionOrName(pt.left);
                    case 7:
                    case 8:
                    case 9:
                      return pt.arguments[1];
                    default:
                      return;
                  }
                }
                case 345:
                  return D(je);
                case 339:
                  return I(je);
                case 271: {
                  var Pt = je.expression;
                  return e.isIdentifier(Pt) ? Pt : void 0;
                }
                case 207:
                  var ga = je;
                  if (e.isBindableStaticElementAccessExpression(ga)) return ga.argumentExpression;
              }
              return je.name;
            }
            e.getNonAssignedNameOfDeclaration = g;
            function ne(je) {
              if (je !== void 0) return g(je) || (e.isFunctionExpression(je) || e.isArrowFunction(je) || e.isClassExpression(je) ? ue(je) : void 0);
            }
            e.getNameOfDeclaration = ne;
            function ue(je) {
              if (je.parent) {
                if (e.isPropertyAssignment(je.parent) || e.isBindingElement(je.parent)) return je.parent.name;
                if (e.isBinaryExpression(je.parent) && je === je.parent.right) {
                  if (e.isIdentifier(je.parent.left)) return je.parent.left;
                  if (e.isAccessExpression(je.parent.left)) return e.getElementOrPropertyAccessArgumentExpressionOrName(je.parent.left);
                } else if (e.isVariableDeclaration(je.parent) && e.isIdentifier(je.parent.name)) return je.parent.name;
              } else return;
            }
            e.getAssignedName = ue;
            function We(je, Hr) {
              if (je.name) if (e.isIdentifier(je.name)) {
                var pt = je.name.escapedText;
                return yr(je.parent, Hr).filter(function(ua) {
                  return e.isJSDocParameterTag(ua) && e.isIdentifier(ua.name) && ua.name.escapedText === pt;
                });
              } else {
                var Pt = je.parent.parameters.indexOf(je);
                e.Debug.assert(Pt > -1, "Parameters should always be in their parents' parameter list");
                var ga = yr(je.parent, Hr).filter(e.isJSDocParameterTag);
                if (Pt < ga.length) return [ga[Pt]];
              }
              return e.emptyArray;
            }
            function Fe(je) {
              return We(je, false);
            }
            e.getJSDocParameterTags = Fe;
            function Z(je) {
              return We(je, true);
            }
            e.getJSDocParameterTagsNoCache = Z;
            function Be(je, Hr) {
              var pt = je.name.escapedText;
              return yr(je.parent, Hr).filter(function(Pt) {
                return e.isJSDocTemplateTag(Pt) && Pt.typeParameters.some(function(ga) {
                  return ga.name.escapedText === pt;
                });
              });
            }
            function ge(je) {
              return Be(je, false);
            }
            e.getJSDocTypeParameterTags = ge;
            function Re(je) {
              return Be(je, true);
            }
            e.getJSDocTypeParameterTagsNoCache = Re;
            function ze(je) {
              return !!Ur(je, e.isJSDocParameterTag);
            }
            e.hasJSDocParameterTags = ze;
            function Ee(je) {
              return Ur(je, e.isJSDocAugmentsTag);
            }
            e.getJSDocAugmentsTag = Ee;
            function He(je) {
              return ii(je, e.isJSDocImplementsTag);
            }
            e.getJSDocImplementsTags = He;
            function rr(je) {
              return Ur(je, e.isJSDocClassTag);
            }
            e.getJSDocClassTag = rr;
            function Ie(je) {
              return Ur(je, e.isJSDocPublicTag);
            }
            e.getJSDocPublicTag = Ie;
            function _e(je) {
              return Ur(je, e.isJSDocPublicTag, true);
            }
            e.getJSDocPublicTagNoCache = _e;
            function we(je) {
              return Ur(je, e.isJSDocPrivateTag);
            }
            e.getJSDocPrivateTag = we;
            function de(je) {
              return Ur(je, e.isJSDocPrivateTag, true);
            }
            e.getJSDocPrivateTagNoCache = de;
            function ye(je) {
              return Ur(je, e.isJSDocProtectedTag);
            }
            e.getJSDocProtectedTag = ye;
            function Ae(je) {
              return Ur(je, e.isJSDocProtectedTag, true);
            }
            e.getJSDocProtectedTagNoCache = Ae;
            function er(je) {
              return Ur(je, e.isJSDocReadonlyTag);
            }
            e.getJSDocReadonlyTag = er;
            function ir(je) {
              return Ur(je, e.isJSDocReadonlyTag, true);
            }
            e.getJSDocReadonlyTagNoCache = ir;
            function Cr(je) {
              return Ur(je, e.isJSDocOverrideTag, true);
            }
            e.getJSDocOverrideTagNoCache = Cr;
            function Ye(je) {
              return Ur(je, e.isJSDocDeprecatedTag);
            }
            e.getJSDocDeprecatedTag = Ye;
            function Br(je) {
              return Ur(je, e.isJSDocDeprecatedTag, true);
            }
            e.getJSDocDeprecatedTagNoCache = Br;
            function Er(je) {
              return Ur(je, e.isJSDocEnumTag);
            }
            e.getJSDocEnumTag = Er;
            function Ne(je) {
              return Ur(je, e.isJSDocThisTag);
            }
            e.getJSDocThisTag = Ne;
            function n(je) {
              return Ur(je, e.isJSDocReturnTag);
            }
            e.getJSDocReturnTag = n;
            function lr(je) {
              return Ur(je, e.isJSDocTemplateTag);
            }
            e.getJSDocTemplateTag = lr;
            function be(je) {
              var Hr = Ur(je, e.isJSDocTypeTag);
              if (Hr && Hr.typeExpression && Hr.typeExpression.type) return Hr;
            }
            e.getJSDocTypeTag = be;
            function Ge(je) {
              var Hr = Ur(je, e.isJSDocTypeTag);
              return !Hr && e.isParameter(je) && (Hr = e.find(Fe(je), function(pt) {
                return !!pt.typeExpression;
              })), Hr && Hr.typeExpression && Hr.typeExpression.type;
            }
            e.getJSDocType = Ge;
            function ur(je) {
              var Hr = n(je);
              if (Hr && Hr.typeExpression) return Hr.typeExpression.type;
              var pt = be(je);
              if (pt && pt.typeExpression) {
                var Pt = pt.typeExpression.type;
                if (e.isTypeLiteralNode(Pt)) {
                  var ga = e.find(Pt.members, e.isCallSignatureDeclaration);
                  return ga && ga.type;
                }
                if (e.isFunctionTypeNode(Pt) || e.isJSDocFunctionType(Pt)) return Pt.type;
              }
            }
            e.getJSDocReturnType = ur;
            function yr(je, Hr) {
              var pt = je.jsDocCache;
              if (pt === void 0 || Hr) {
                var Pt = e.getJSDocCommentsAndTags(je, Hr);
                e.Debug.assert(Pt.length < 2 || Pt[0] !== Pt[1]), pt = e.flatMap(Pt, function(ga) {
                  return e.isJSDoc(ga) ? ga.tags : ga;
                }), Hr || (je.jsDocCache = pt);
              }
              return pt;
            }
            function Ir(je) {
              return yr(je, false);
            }
            e.getJSDocTags = Ir;
            function wr(je) {
              return yr(je, true);
            }
            e.getJSDocTagsNoCache = wr;
            function Ur(je, Hr, pt) {
              return e.find(yr(je, pt), Hr);
            }
            function ii(je, Hr) {
              return Ir(je).filter(Hr);
            }
            e.getAllJSDocTags = ii;
            function mi(je, Hr) {
              return Ir(je).filter(function(pt) {
                return pt.kind === Hr;
              });
            }
            e.getAllJSDocTagsOfKind = mi;
            function pe(je) {
              return typeof je == "string" ? je : je == null ? void 0 : je.map(function(Hr) {
                return Hr.kind === 321 ? Hr.text : or(Hr);
              }).join("");
            }
            e.getTextOfJSDocComment = pe;
            function or(je) {
              var Hr = je.kind === 324 ? "link" : je.kind === 325 ? "linkcode" : "linkplain", pt = je.name ? e.entityNameToString(je.name) : "", Pt = je.name && je.text.startsWith("://") ? "" : " ";
              return "{@".concat(Hr, " ").concat(pt).concat(Pt).concat(je.text, "}");
            }
            function qr(je) {
              if (e.isJSDocSignature(je)) return e.emptyArray;
              if (e.isJSDocTypeAlias(je)) return e.Debug.assert(je.parent.kind === 320), e.flatMap(je.parent.tags, function(Pt) {
                return e.isJSDocTemplateTag(Pt) ? Pt.typeParameters : void 0;
              });
              if (je.typeParameters) return je.typeParameters;
              if (e.isInJSFile(je)) {
                var Hr = e.getJSDocTypeParameterDeclarations(je);
                if (Hr.length) return Hr;
                var pt = Ge(je);
                if (pt && e.isFunctionTypeNode(pt) && pt.typeParameters) return pt.typeParameters;
              }
              return e.emptyArray;
            }
            e.getEffectiveTypeParameterDeclarations = qr;
            function si(je) {
              return je.constraint ? je.constraint : e.isJSDocTemplateTag(je.parent) && je === je.parent.typeParameters[0] ? je.parent.constraint : void 0;
            }
            e.getEffectiveConstraintOfTypeParameter = si;
            function Di(je) {
              return je.kind === 79 || je.kind === 80;
            }
            e.isMemberName = Di;
            function wi(je) {
              return je.kind === 173 || je.kind === 172;
            }
            e.isGetOrSetAccessorDeclaration = wi;
            function Xi(je) {
              return e.isPropertyAccessExpression(je) && !!(je.flags & 32);
            }
            e.isPropertyAccessChain = Xi;
            function et(je) {
              return e.isElementAccessExpression(je) && !!(je.flags & 32);
            }
            e.isElementAccessChain = et;
            function Gi(je) {
              return e.isCallExpression(je) && !!(je.flags & 32);
            }
            e.isCallChain = Gi;
            function Wt(je) {
              var Hr = je.kind;
              return !!(je.flags & 32) && (Hr === 206 || Hr === 207 || Hr === 208 || Hr === 230);
            }
            e.isOptionalChain = Wt;
            function Zt(je) {
              return Wt(je) && !e.isNonNullExpression(je) && !!je.questionDotToken;
            }
            e.isOptionalChainRoot = Zt;
            function _r(je) {
              return Zt(je.parent) && je.parent.expression === je;
            }
            e.isExpressionOfOptionalChainRoot = _r;
            function pi(je) {
              return !Wt(je.parent) || Zt(je.parent) || je !== je.parent.expression;
            }
            e.isOutermostOptionalChain = pi;
            function ae(je) {
              return je.kind === 221 && je.operatorToken.kind === 60;
            }
            e.isNullishCoalesce = ae;
            function Xe(je) {
              return e.isTypeReferenceNode(je) && e.isIdentifier(je.typeName) && je.typeName.escapedText === "const" && !je.typeArguments;
            }
            e.isConstTypeReference = Xe;
            function Jr(je) {
              return e.skipOuterExpressions(je, 8);
            }
            e.skipPartiallyEmittedExpressions = Jr;
            function ti(je) {
              return e.isNonNullExpression(je) && !!(je.flags & 32);
            }
            e.isNonNullChain = ti;
            function Ze(je) {
              return je.kind === 246 || je.kind === 245;
            }
            e.isBreakOrContinueStatement = Ze;
            function Sr(je) {
              return je.kind === 274 || je.kind === 273;
            }
            e.isNamedExportBindings = Sr;
            function zr(je) {
              switch (je.kind) {
                case 302:
                case 303:
                  return true;
                default:
                  return false;
              }
            }
            e.isUnparsedTextLike = zr;
            function Wr(je) {
              return zr(je) || je.kind === 300 || je.kind === 304;
            }
            e.isUnparsedNode = Wr;
            function Je(je) {
              return je.kind === 347 || je.kind === 340;
            }
            e.isJSDocPropertyLikeTag = Je;
            function xe(je) {
              return vr(je.kind);
            }
            e.isNode = xe;
            function vr(je) {
              return je >= 161;
            }
            e.isNodeKind = vr;
            function mr(je) {
              return je >= 0 && je <= 160;
            }
            e.isTokenKind = mr;
            function Ar(je) {
              return mr(je.kind);
            }
            e.isToken = Ar;
            function Oe(je) {
              return je.hasOwnProperty("pos") && je.hasOwnProperty("end");
            }
            e.isNodeArray = Oe;
            function nr(je) {
              return 8 <= je && je <= 14;
            }
            e.isLiteralKind = nr;
            function Mr(je) {
              return nr(je.kind);
            }
            e.isLiteralExpression = Mr;
            function Pe(je) {
              return 14 <= je && je <= 17;
            }
            e.isTemplateLiteralKind = Pe;
            function Ue(je) {
              return Pe(je.kind);
            }
            e.isTemplateLiteralToken = Ue;
            function fr(je) {
              var Hr = je.kind;
              return Hr === 16 || Hr === 17;
            }
            e.isTemplateMiddleOrTemplateTail = fr;
            function De(je) {
              return e.isImportSpecifier(je) || e.isExportSpecifier(je);
            }
            e.isImportOrExportSpecifier = De;
            function gr(je) {
              switch (je.kind) {
                case 270:
                case 275:
                  return je.isTypeOnly || je.parent.parent.isTypeOnly;
                case 268:
                  return je.parent.isTypeOnly;
                case 267:
                case 265:
                  return je.isTypeOnly;
                default:
                  return false;
              }
            }
            e.isTypeOnlyImportOrExportDeclaration = gr;
            function Vr(je) {
              return e.isStringLiteral(je) || e.isIdentifier(je);
            }
            e.isAssertionKey = Vr;
            function Tr(je) {
              return je.kind === 10 || Pe(je.kind);
            }
            e.isStringTextContainingNode = Tr;
            function vi(je) {
              return e.isIdentifier(je) && (je.autoGenerateFlags & 7) > 0;
            }
            e.isGeneratedIdentifier = vi;
            function Ui(je) {
              return (e.isPropertyDeclaration(je) || Oi(je)) && e.isPrivateIdentifier(je.name);
            }
            e.isPrivateIdentifierClassElementDeclaration = Ui;
            function Yi(je) {
              return e.isPropertyAccessExpression(je) && e.isPrivateIdentifier(je.name);
            }
            e.isPrivateIdentifierPropertyAccessExpression = Yi;
            function Wi(je) {
              switch (je) {
                case 126:
                case 131:
                case 85:
                case 135:
                case 88:
                case 93:
                case 101:
                case 123:
                case 121:
                case 122:
                case 145:
                case 124:
                case 144:
                case 159:
                  return true;
              }
              return false;
            }
            e.isModifierKind = Wi;
            function ct(je) {
              return !!(e.modifierToFlag(je) & 16476);
            }
            e.isParameterPropertyModifier = ct;
            function Li(je) {
              return ct(je) || je === 124 || je === 159;
            }
            e.isClassMemberModifier = Li;
            function nt(je) {
              return Wi(je.kind);
            }
            e.isModifier = nt;
            function Mt(je) {
              var Hr = je.kind;
              return Hr === 161 || Hr === 79;
            }
            e.isEntityName = Mt;
            function xt(je) {
              var Hr = je.kind;
              return Hr === 79 || Hr === 80 || Hr === 10 || Hr === 8 || Hr === 162;
            }
            e.isPropertyName = xt;
            function ut(je) {
              var Hr = je.kind;
              return Hr === 79 || Hr === 201 || Hr === 202;
            }
            e.isBindingName = ut;
            function Dt(je) {
              return !!je && ui(je.kind);
            }
            e.isFunctionLike = Dt;
            function Rt(je) {
              return !!je && (ui(je.kind) || e.isClassStaticBlockDeclaration(je));
            }
            e.isFunctionLikeOrClassStaticBlockDeclaration = Rt;
            function Ii(je) {
              return je && Fi(je.kind);
            }
            e.isFunctionLikeDeclaration = Ii;
            function Ki(je) {
              return je.kind === 110 || je.kind === 95;
            }
            e.isBooleanLiteral = Ki;
            function Fi(je) {
              switch (je) {
                case 256:
                case 169:
                case 171:
                case 172:
                case 173:
                case 213:
                case 214:
                  return true;
                default:
                  return false;
              }
            }
            function ui(je) {
              switch (je) {
                case 168:
                case 174:
                case 323:
                case 175:
                case 176:
                case 179:
                case 317:
                case 180:
                  return true;
                default:
                  return Fi(je);
              }
            }
            e.isFunctionLikeKind = ui;
            function Bt(je) {
              return e.isSourceFile(je) || e.isModuleBlock(je) || e.isBlock(je) && Dt(je.parent);
            }
            e.isFunctionOrModuleBlock = Bt;
            function wt(je) {
              var Hr = je.kind;
              return Hr === 171 || Hr === 167 || Hr === 169 || Hr === 172 || Hr === 173 || Hr === 176 || Hr === 170 || Hr === 234;
            }
            e.isClassElement = wt;
            function na(je) {
              return je && (je.kind === 257 || je.kind === 226);
            }
            e.isClassLike = na;
            function Ai(je) {
              return je && (je.kind === 172 || je.kind === 173);
            }
            e.isAccessor = Ai;
            function Oi(je) {
              switch (je.kind) {
                case 169:
                case 172:
                case 173:
                  return true;
                default:
                  return false;
              }
            }
            e.isMethodOrAccessor = Oi;
            function ji(je) {
              var Hr = je.kind;
              return Hr === 175 || Hr === 174 || Hr === 166 || Hr === 168 || Hr === 176 || Hr === 172 || Hr === 173;
            }
            e.isTypeElement = ji;
            function Vi(je) {
              return ji(je) || wt(je);
            }
            e.isClassOrTypeElement = Vi;
            function at(je) {
              var Hr = je.kind;
              return Hr === 296 || Hr === 297 || Hr === 298 || Hr === 169 || Hr === 172 || Hr === 173;
            }
            e.isObjectLiteralElementLike = at;
            function At(je) {
              return e.isTypeNodeKind(je.kind);
            }
            e.isTypeNode = At;
            function ba(je) {
              switch (je.kind) {
                case 179:
                case 180:
                  return true;
              }
              return false;
            }
            e.isFunctionOrConstructorTypeNode = ba;
            function $a(je) {
              if (je) {
                var Hr = je.kind;
                return Hr === 202 || Hr === 201;
              }
              return false;
            }
            e.isBindingPattern = $a;
            function Qa(je) {
              var Hr = je.kind;
              return Hr === 204 || Hr === 205;
            }
            e.isAssignmentPattern = Qa;
            function ai(je) {
              var Hr = je.kind;
              return Hr === 203 || Hr === 227;
            }
            e.isArrayBindingElement = ai;
            function Dn(je) {
              switch (je.kind) {
                case 254:
                case 164:
                case 203:
                  return true;
              }
              return false;
            }
            e.isDeclarationBindingElement = Dn;
            function ka(je) {
              return Ba(je) || Cn(je);
            }
            e.isBindingOrAssignmentPattern = ka;
            function Ba(je) {
              switch (je.kind) {
                case 201:
                case 205:
                  return true;
              }
              return false;
            }
            e.isObjectBindingOrAssignmentPattern = Ba;
            function pn(je) {
              switch (je.kind) {
                case 203:
                case 296:
                case 297:
                case 298:
                  return true;
              }
              return false;
            }
            e.isObjectBindingOrAssignmentElement = pn;
            function Cn(je) {
              switch (je.kind) {
                case 202:
                case 204:
                  return true;
              }
              return false;
            }
            e.isArrayBindingOrAssignmentPattern = Cn;
            function Bi(je) {
              var Hr = je.kind;
              return Hr === 206 || Hr === 161 || Hr === 200;
            }
            e.isPropertyAccessOrQualifiedNameOrImportTypeNode = Bi;
            function kn(je) {
              var Hr = je.kind;
              return Hr === 206 || Hr === 161;
            }
            e.isPropertyAccessOrQualifiedName = kn;
            function xn(je) {
              switch (je.kind) {
                case 280:
                case 279:
                case 208:
                case 209:
                case 210:
                case 165:
                  return true;
                default:
                  return false;
              }
            }
            e.isCallLikeExpression = xn;
            function Kn(je) {
              return je.kind === 208 || je.kind === 209;
            }
            e.isCallOrNewExpression = Kn;
            function Pn(je) {
              var Hr = je.kind;
              return Hr === 223 || Hr === 14;
            }
            e.isTemplateLiteral = Pn;
            function eo(je) {
              return Rn(Jr(je).kind);
            }
            e.isLeftHandSideExpression = eo;
            function Rn(je) {
              switch (je) {
                case 206:
                case 207:
                case 209:
                case 208:
                case 278:
                case 279:
                case 282:
                case 210:
                case 204:
                case 212:
                case 205:
                case 226:
                case 213:
                case 79:
                case 80:
                case 13:
                case 8:
                case 9:
                case 10:
                case 14:
                case 223:
                case 95:
                case 104:
                case 108:
                case 110:
                case 106:
                case 230:
                case 228:
                case 231:
                case 100:
                  return true;
                default:
                  return false;
              }
            }
            function Da(je) {
              return bo(Jr(je).kind);
            }
            e.isUnaryExpression = Da;
            function bo(je) {
              switch (je) {
                case 219:
                case 220:
                case 215:
                case 216:
                case 217:
                case 218:
                case 211:
                  return true;
                default:
                  return Rn(je);
              }
            }
            function Ro(je) {
              switch (je.kind) {
                case 220:
                  return true;
                case 219:
                  return je.operator === 45 || je.operator === 46;
                default:
                  return false;
              }
            }
            e.isUnaryExpressionWithWrite = Ro;
            function En(je) {
              return Wn(Jr(je).kind);
            }
            e.isExpression = En;
            function Wn(je) {
              switch (je) {
                case 222:
                case 224:
                case 214:
                case 221:
                case 225:
                case 229:
                case 227:
                case 351:
                case 350:
                  return true;
                default:
                  return bo(je);
              }
            }
            function to(je) {
              var Hr = je.kind;
              return Hr === 211 || Hr === 229;
            }
            e.isAssertionExpression = to;
            function Co(je) {
              return e.isNotEmittedStatement(je) || e.isPartiallyEmittedExpression(je);
            }
            e.isNotEmittedOrPartiallyEmittedNode = Co;
            function Ko(je, Hr) {
              switch (je.kind) {
                case 242:
                case 243:
                case 244:
                case 240:
                case 241:
                  return true;
                case 250:
                  return Hr && Ko(je.statement, Hr);
              }
              return false;
            }
            e.isIterationStatement = Ko;
            function Oo(je) {
              return e.isExportAssignment(je) || e.isExportDeclaration(je);
            }
            e.isScopeMarker = Oo;
            function no(je) {
              return e.some(je, Oo);
            }
            e.hasScopeMarker = no;
            function $o(je) {
              return !e.isAnyImportOrReExport(je) && !e.isExportAssignment(je) && !e.hasSyntacticModifier(je, 1) && !e.isAmbientModule(je);
            }
            e.needsScopeMarker = $o;
            function Pr(je) {
              return e.isAnyImportOrReExport(je) || e.isExportAssignment(je) || e.hasSyntacticModifier(je, 1);
            }
            e.isExternalModuleIndicator = Pr;
            function xi(je) {
              return je.kind === 243 || je.kind === 244;
            }
            e.isForInOrOfStatement = xi;
            function St(je) {
              return e.isBlock(je) || En(je);
            }
            e.isConciseBody = St;
            function pa(je) {
              return e.isBlock(je);
            }
            e.isFunctionBody = pa;
            function dn(je) {
              return e.isVariableDeclarationList(je) || En(je);
            }
            e.isForInitializer = dn;
            function Jn(je) {
              var Hr = je.kind;
              return Hr === 262 || Hr === 261 || Hr === 79;
            }
            e.isModuleBody = Jn;
            function Qe(je) {
              var Hr = je.kind;
              return Hr === 262 || Hr === 261;
            }
            e.isNamespaceBody = Qe;
            function Gr(je) {
              var Hr = je.kind;
              return Hr === 79 || Hr === 261;
            }
            e.isJSDocNamespaceBody = Gr;
            function S(je) {
              var Hr = je.kind;
              return Hr === 269 || Hr === 268;
            }
            e.isNamedImportBindings = S;
            function Ce(je) {
              return je.kind === 261 || je.kind === 260;
            }
            e.isModuleOrEnumDeclaration = Ce;
            function qe(je) {
              return je === 214 || je === 203 || je === 257 || je === 226 || je === 170 || je === 171 || je === 260 || je === 299 || je === 275 || je === 256 || je === 213 || je === 172 || je === 267 || je === 265 || je === 270 || je === 258 || je === 285 || je === 169 || je === 168 || je === 261 || je === 264 || je === 268 || je === 274 || je === 164 || je === 296 || je === 167 || je === 166 || je === 173 || je === 297 || je === 259 || je === 163 || je === 254 || je === 345 || je === 338 || je === 347;
            }
            function br(je) {
              return je === 256 || je === 276 || je === 257 || je === 258 || je === 259 || je === 260 || je === 261 || je === 266 || je === 265 || je === 272 || je === 271 || je === 264;
            }
            function Zr(je) {
              return je === 246 || je === 245 || je === 253 || je === 240 || je === 238 || je === 236 || je === 243 || je === 244 || je === 242 || je === 239 || je === 250 || je === 247 || je === 249 || je === 251 || je === 252 || je === 237 || je === 241 || je === 248 || je === 349 || je === 353 || je === 352;
            }
            function Si(je) {
              return je.kind === 163 ? je.parent && je.parent.kind !== 344 || e.isInJSFile(je) : qe(je.kind);
            }
            e.isDeclaration = Si;
            function Pi(je) {
              return br(je.kind);
            }
            e.isDeclarationStatement = Pi;
            function Qi(je) {
              return Zr(je.kind);
            }
            e.isStatementButNotDeclaration = Qi;
            function Ct(je) {
              var Hr = je.kind;
              return Zr(Hr) || br(Hr) || sa(je);
            }
            e.isStatement = Ct;
            function sa(je) {
              return je.kind !== 235 || je.parent !== void 0 && (je.parent.kind === 252 || je.parent.kind === 292) ? false : !e.isFunctionBlock(je);
            }
            function en(je) {
              var Hr = je.kind;
              return Zr(Hr) || br(Hr) || Hr === 235;
            }
            e.isStatementOrBlock = en;
            function Wa(je) {
              var Hr = je.kind;
              return Hr === 277 || Hr === 161 || Hr === 79;
            }
            e.isModuleReference = Wa;
            function qn(je) {
              var Hr = je.kind;
              return Hr === 108 || Hr === 79 || Hr === 206;
            }
            e.isJsxTagNameExpression = qn;
            function mo(je) {
              var Hr = je.kind;
              return Hr === 278 || Hr === 288 || Hr === 279 || Hr === 11 || Hr === 282;
            }
            e.isJsxChild = mo;
            function So(je) {
              var Hr = je.kind;
              return Hr === 285 || Hr === 287;
            }
            e.isJsxAttributeLike = So;
            function Go(je) {
              var Hr = je.kind;
              return Hr === 10 || Hr === 288;
            }
            e.isStringLiteralOrJsxExpression = Go;
            function ys(je) {
              var Hr = je.kind;
              return Hr === 280 || Hr === 279;
            }
            e.isJsxOpeningLikeElement = ys;
            function Pc(je) {
              var Hr = je.kind;
              return Hr === 289 || Hr === 290;
            }
            e.isCaseOrDefaultClause = Pc;
            function Vc(je) {
              return je.kind >= 309 && je.kind <= 347;
            }
            e.isJSDocNode = Vc;
            function Kc(je) {
              return je.kind === 320 || je.kind === 319 || je.kind === 321 || qi(je) || Xs(je) || e.isJSDocTypeLiteral(je) || e.isJSDocSignature(je);
            }
            e.isJSDocCommentContainingNode = Kc;
            function Xs(je) {
              return je.kind >= 327 && je.kind <= 347;
            }
            e.isJSDocTag = Xs;
            function pc(je) {
              return je.kind === 173;
            }
            e.isSetAccessor = pc;
            function hs(je) {
              return je.kind === 172;
            }
            e.isGetAccessor = hs;
            function tc(je) {
              var Hr = je.jsDoc;
              return !!Hr && Hr.length > 0;
            }
            e.hasJSDocNodes = tc;
            function ps(je) {
              return !!je.type;
            }
            e.hasType = ps;
            function Qs(je) {
              return !!je.initializer;
            }
            e.hasInitializer = Qs;
            function js(je) {
              switch (je.kind) {
                case 254:
                case 164:
                case 203:
                case 166:
                case 167:
                case 296:
                case 299:
                  return true;
                default:
                  return false;
              }
            }
            e.hasOnlyExpressionInitializer = js;
            function ds(je) {
              return je.kind === 285 || je.kind === 287 || at(je);
            }
            e.isObjectLiteralElement = ds;
            function Ji(je) {
              return je.kind === 178 || je.kind === 228;
            }
            e.isTypeReferenceType = Ji;
            var ce = 1073741823;
            function Rr(je) {
              for (var Hr = ce, pt = 0, Pt = je; pt < Pt.length; pt++) {
                var ga = Pt[pt];
                if (!!ga.length) {
                  for (var ua = 0; ua < ga.length && ua < Hr && e.isWhiteSpaceLike(ga.charCodeAt(ua)); ua++) ;
                  if (ua < Hr && (Hr = ua), Hr === 0) return 0;
                }
              }
              return Hr === ce ? void 0 : Hr;
            }
            e.guessIndentation = Rr;
            function yi(je) {
              return je.kind === 10 || je.kind === 14;
            }
            e.isStringLiteralLike = yi;
            function qi(je) {
              return je.kind === 324 || je.kind === 325 || je.kind === 326;
            }
            e.isJSDocLinkLike = qi;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            e.resolvingEmptyArray = [], e.externalHelpersModuleNameText = "tslib", e.defaultMaximumTruncationLength = 160, e.noTruncationMaximumTruncationLength = 1e6;
            function a(c, te) {
              var xr = c.declarations;
              if (xr) for (var ei = 0, bi = xr; ei < bi.length; ei++) {
                var Ft = bi[ei];
                if (Ft.kind === te) return Ft;
              }
            }
            e.getDeclarationOfKind = a;
            function C(c, te) {
              return e.filter(c.declarations || e.emptyArray, function(xr) {
                return xr.kind === te;
              });
            }
            e.getDeclarationsOfKind = C;
            function w(c) {
              var te = new e.Map();
              if (c) for (var xr = 0, ei = c; xr < ei.length; xr++) {
                var bi = ei[xr];
                te.set(bi.escapedName, bi);
              }
              return te;
            }
            e.createSymbolTable = w;
            function B(c) {
              return (c.flags & 33554432) !== 0;
            }
            e.isTransientSymbol = B;
            var E = Q();
            function Q() {
              var c = "", te = function(xr) {
                return c += xr;
              };
              return { getText: function() {
                return c;
              }, write: te, rawWrite: te, writeKeyword: te, writeOperator: te, writePunctuation: te, writeSpace: te, writeStringLiteral: te, writeLiteral: te, writeParameter: te, writeProperty: te, writeSymbol: function(xr, ei) {
                return te(xr);
              }, writeTrailingSemicolon: te, writeComment: te, getTextPos: function() {
                return c.length;
              }, getLine: function() {
                return 0;
              }, getColumn: function() {
                return 0;
              }, getIndent: function() {
                return 0;
              }, isAtStartOfLine: function() {
                return false;
              }, hasTrailingComment: function() {
                return false;
              }, hasTrailingWhitespace: function() {
                return !!c.length && e.isWhiteSpaceLike(c.charCodeAt(c.length - 1));
              }, writeLine: function() {
                return c += " ";
              }, increaseIndent: e.noop, decreaseIndent: e.noop, clear: function() {
                return c = "";
              }, trackSymbol: function() {
                return false;
              }, reportInaccessibleThisError: e.noop, reportInaccessibleUniqueSymbolError: e.noop, reportPrivateInBaseOfClassExpression: e.noop };
            }
            function le(c, te) {
              return c.configFilePath !== te.configFilePath || N(c, te);
            }
            e.changesAffectModuleResolution = le;
            function N(c, te) {
              return m(c, te, e.moduleResolutionOptionDeclarations);
            }
            e.optionsHaveModuleResolutionChanges = N;
            function p(c, te) {
              return m(c, te, e.optionsAffectingProgramStructure);
            }
            e.changesAffectingProgramStructure = p;
            function m(c, te, xr) {
              return c !== te && xr.some(function(ei) {
                return !uo(Bm(c, ei), Bm(te, ei));
              });
            }
            e.optionsHaveChanges = m;
            function G(c, te) {
              for (; ; ) {
                var xr = te(c);
                if (xr === "quit") return;
                if (xr !== void 0) return xr;
                if (e.isSourceFile(c)) return;
                c = c.parent;
              }
            }
            e.forEachAncestor = G;
            function oe(c, te) {
              for (var xr = c.entries(), ei = xr.next(); !ei.done; ei = xr.next()) {
                var bi = ei.value, Ft = bi[0], ot = bi[1], xa = te(ot, Ft);
                if (xa) return xa;
              }
            }
            e.forEachEntry = oe;
            function f(c, te) {
              for (var xr = c.keys(), ei = xr.next(); !ei.done; ei = xr.next()) {
                var bi = te(ei.value);
                if (bi) return bi;
              }
            }
            e.forEachKey = f;
            function T(c, te) {
              c.forEach(function(xr, ei) {
                te.set(ei, xr);
              });
            }
            e.copyEntries = T;
            function K(c) {
              var te = E.getText();
              try {
                return c(E), E.getText();
              } finally {
                E.clear(), E.writeKeyword(te);
              }
            }
            e.usingSingleLineStringWriter = K;
            function b(c) {
              return c.end - c.pos;
            }
            e.getFullWidth = b;
            function se(c, te, xr) {
              return c && c.resolvedModules && c.resolvedModules.get(te, xr);
            }
            e.getResolvedModule = se;
            function J(c, te, xr, ei) {
              c.resolvedModules || (c.resolvedModules = e.createModeAwareCache()), c.resolvedModules.set(te, ei, xr);
            }
            e.setResolvedModule = J;
            function ie(c, te, xr) {
              c.resolvedTypeReferenceDirectiveNames || (c.resolvedTypeReferenceDirectiveNames = e.createModeAwareCache()), c.resolvedTypeReferenceDirectiveNames.set(te, void 0, xr);
            }
            e.setResolvedTypeReferenceDirective = ie;
            function R(c, te) {
              return c.path === te.path && !c.prepend == !te.prepend && !c.circular == !te.circular;
            }
            e.projectReferenceIsEqualTo = R;
            function q(c, te) {
              return c.isExternalLibraryImport === te.isExternalLibraryImport && c.extension === te.extension && c.resolvedFileName === te.resolvedFileName && c.originalPath === te.originalPath && O(c.packageId, te.packageId);
            }
            e.moduleResolutionIsEqualTo = q;
            function O(c, te) {
              return c === te || !!c && !!te && c.name === te.name && c.subModuleName === te.subModuleName && c.version === te.version;
            }
            function ve(c) {
              var te = c.name, xr = c.subModuleName;
              return xr ? "".concat(te, "/").concat(xr) : te;
            }
            e.packageIdToPackageName = ve;
            function ee(c) {
              return "".concat(ve(c), "@").concat(c.version);
            }
            e.packageIdToString = ee;
            function he(c, te) {
              return c.resolvedFileName === te.resolvedFileName && c.primary === te.primary && c.originalPath === te.originalPath;
            }
            e.typeDirectiveIsEqualTo = he;
            function F(c, te, xr, ei, bi) {
              e.Debug.assert(c.length === te.length);
              for (var Ft = 0; Ft < c.length; Ft++) {
                var ot = te[Ft], xa = c[Ft], mn = e.isString(xa) ? xa : xa.fileName.toLowerCase(), an = e.isString(xa) ? ei && e.getModeForResolutionAtIndex(ei, Ft) : e.getModeForFileReference(xa, ei == null ? void 0 : ei.impliedNodeFormat), To = xr && xr.get(mn, an), Hn = To ? !ot || !bi(To, ot) : ot;
                if (Hn) return true;
              }
              return false;
            }
            e.hasChangesInResolutions = F;
            function x(c) {
              return X(c), (c.flags & 524288) !== 0;
            }
            e.containsParseError = x;
            function X(c) {
              if (!(c.flags & 1048576)) {
                var te = (c.flags & 131072) !== 0 || e.forEachChild(c, x);
                te && (c.flags |= 524288), c.flags |= 1048576;
              }
            }
            function $(c) {
              for (; c && c.kind !== 305; ) c = c.parent;
              return c;
            }
            e.getSourceFileOfNode = $;
            function A(c) {
              return $(c.valueDeclaration || Ir(c));
            }
            e.getSourceFileOfModule = A;
            function y(c, te) {
              return !!c && (c.scriptKind === 1 || c.scriptKind === 2) && !c.checkJsDirective && te === void 0;
            }
            e.isPlainJsFile = y;
            function V(c) {
              switch (c.kind) {
                case 235:
                case 263:
                case 242:
                case 243:
                case 244:
                  return true;
              }
              return false;
            }
            e.isStatementWithLocals = V;
            function L(c, te) {
              return e.Debug.assert(c >= 0), e.getLineStarts(te)[c];
            }
            e.getStartPositionOfLine = L;
            function P(c) {
              var te = $(c), xr = e.getLineAndCharacterOfPosition(te, c.pos);
              return "".concat(te.fileName, "(").concat(xr.line + 1, ",").concat(xr.character + 1, ")");
            }
            e.nodePosToString = P;
            function k(c, te) {
              e.Debug.assert(c >= 0);
              var xr = e.getLineStarts(te), ei = c, bi = te.text;
              if (ei + 1 === xr.length) return bi.length - 1;
              var Ft = xr[ei], ot = xr[ei + 1] - 1;
              for (e.Debug.assert(e.isLineBreak(bi.charCodeAt(ot))); Ft <= ot && e.isLineBreak(bi.charCodeAt(ot)); ) ot--;
              return ot;
            }
            e.getEndLinePosition = k;
            function Y(c, te, xr) {
              return !(xr && xr(te)) && !c.identifiers.has(te);
            }
            e.isFileLevelUniqueName = Y;
            function U(c) {
              return c === void 0 ? true : c.pos === c.end && c.pos >= 0 && c.kind !== 1;
            }
            e.nodeIsMissing = U;
            function j(c) {
              return !U(c);
            }
            e.nodeIsPresent = j;
            function H(c, te, xr) {
              if (te === void 0 || te.length === 0) return c;
              for (var ei = 0; ei < c.length && xr(c[ei]); ++ei) ;
              return c.splice.apply(c, Ve([ei, 0], te, false)), c;
            }
            function I(c, te, xr) {
              if (te === void 0) return c;
              for (var ei = 0; ei < c.length && xr(c[ei]); ++ei) ;
              return c.splice(ei, 0, te), c;
            }
            function l(c) {
              return Ui(c) || !!(Ie(c) & 1048576);
            }
            function d(c, te) {
              return H(c, te, Ui);
            }
            e.insertStatementsAfterStandardPrologue = d;
            function D(c, te) {
              return H(c, te, l);
            }
            e.insertStatementsAfterCustomPrologue = D;
            function fe(c, te) {
              return I(c, te, Ui);
            }
            e.insertStatementAfterStandardPrologue = fe;
            function g(c, te) {
              return I(c, te, l);
            }
            e.insertStatementAfterCustomPrologue = g;
            function ne(c, te, xr) {
              if (c.charCodeAt(te + 1) === 47 && te + 2 < xr && c.charCodeAt(te + 2) === 47) {
                var ei = c.substring(te, xr);
                return !!(e.fullTripleSlashReferencePathRegEx.test(ei) || e.fullTripleSlashAMDReferencePathRegEx.test(ei) || xt.test(ei) || ut.test(ei));
              }
              return false;
            }
            e.isRecognizedTripleSlashComment = ne;
            function ue(c, te) {
              return c.charCodeAt(te + 1) === 42 && c.charCodeAt(te + 2) === 33;
            }
            e.isPinnedComment = ue;
            function We(c, te) {
              var xr = new e.Map(te.map(function(ot) {
                return ["".concat(e.getLineAndCharacterOfPosition(c, ot.range.end).line), ot];
              })), ei = new e.Map();
              return { getUnusedExpectations: bi, markUsed: Ft };
              function bi() {
                return e.arrayFrom(xr.entries()).filter(function(ot) {
                  var xa = ot[0], mn = ot[1];
                  return mn.type === 0 && !ei.get(xa);
                }).map(function(ot) {
                  var xa = ot[0], mn = ot[1];
                  return mn;
                });
              }
              function Ft(ot) {
                return xr.has("".concat(ot)) ? (ei.set("".concat(ot), true), true) : false;
              }
            }
            e.createCommentDirectivesMap = We;
            function Fe(c, te, xr) {
              return U(c) ? c.pos : e.isJSDocNode(c) || c.kind === 11 ? e.skipTrivia((te || $(c)).text, c.pos, false, true) : xr && e.hasJSDocNodes(c) ? Fe(c.jsDoc[0], te) : c.kind === 348 && c._children.length > 0 ? Fe(c._children[0], te, xr) : e.skipTrivia((te || $(c)).text, c.pos, false, false, Wa(c));
            }
            e.getTokenPosOfNode = Fe;
            function Z(c, te) {
              return U(c) || !c.decorators ? Fe(c, te) : e.skipTrivia((te || $(c)).text, c.decorators.end);
            }
            e.getNonDecoratorTokenPosOfNode = Z;
            function Be(c, te, xr) {
              return xr === void 0 && (xr = false), ze(c.text, te, xr);
            }
            e.getSourceTextOfNodeFromSourceFile = Be;
            function ge(c) {
              return !!e.findAncestor(c, e.isJSDocTypeExpression);
            }
            function Re(c) {
              return !!(e.isExportDeclaration(c) && c.exportClause && e.isNamespaceExport(c.exportClause) && c.exportClause.name.escapedText === "default");
            }
            e.isExportNamespaceAsDefaultDeclaration = Re;
            function ze(c, te, xr) {
              if (xr === void 0 && (xr = false), U(te)) return "";
              var ei = c.substring(xr ? te.pos : e.skipTrivia(c, te.pos), te.end);
              return ge(te) && (ei = ei.split(/\r\n|\n|\r/).map(function(bi) {
                return e.trimStringStart(bi.replace(/^\s*\*/, ""));
              }).join(`
`)), ei;
            }
            e.getTextOfNodeFromSourceText = ze;
            function Ee(c, te) {
              return te === void 0 && (te = false), Be($(c), c, te);
            }
            e.getTextOfNode = Ee;
            function He(c) {
              return c.pos;
            }
            function rr(c, te) {
              return e.binarySearch(c, te, He, e.compareValues);
            }
            e.indexOfNode = rr;
            function Ie(c) {
              var te = c.emitNode;
              return te && te.flags || 0;
            }
            e.getEmitFlags = Ie;
            function _e() {
              return { es2015: { Array: ["find", "findIndex", "fill", "copyWithin", "entries", "keys", "values"], RegExp: ["flags", "sticky", "unicode"], Reflect: ["apply", "construct", "defineProperty", "deleteProperty", "get", " getOwnPropertyDescriptor", "getPrototypeOf", "has", "isExtensible", "ownKeys", "preventExtensions", "set", "setPrototypeOf"], ArrayConstructor: ["from", "of"], ObjectConstructor: ["assign", "getOwnPropertySymbols", "keys", "is", "setPrototypeOf"], NumberConstructor: ["isFinite", "isInteger", "isNaN", "isSafeInteger", "parseFloat", "parseInt"], Math: ["clz32", "imul", "sign", "log10", "log2", "log1p", "expm1", "cosh", "sinh", "tanh", "acosh", "asinh", "atanh", "hypot", "trunc", "fround", "cbrt"], Map: ["entries", "keys", "values"], Set: ["entries", "keys", "values"], Promise: e.emptyArray, PromiseConstructor: ["all", "race", "reject", "resolve"], Symbol: ["for", "keyFor"], WeakMap: ["entries", "keys", "values"], WeakSet: ["entries", "keys", "values"], Iterator: e.emptyArray, AsyncIterator: e.emptyArray, String: ["codePointAt", "includes", "endsWith", "normalize", "repeat", "startsWith", "anchor", "big", "blink", "bold", "fixed", "fontcolor", "fontsize", "italics", "link", "small", "strike", "sub", "sup"], StringConstructor: ["fromCodePoint", "raw"] }, es2016: { Array: ["includes"] }, es2017: { Atomics: e.emptyArray, SharedArrayBuffer: e.emptyArray, String: ["padStart", "padEnd"], ObjectConstructor: ["values", "entries", "getOwnPropertyDescriptors"], DateTimeFormat: ["formatToParts"] }, es2018: { Promise: ["finally"], RegExpMatchArray: ["groups"], RegExpExecArray: ["groups"], RegExp: ["dotAll"], Intl: ["PluralRules"], AsyncIterable: e.emptyArray, AsyncIterableIterator: e.emptyArray, AsyncGenerator: e.emptyArray, AsyncGeneratorFunction: e.emptyArray, NumberFormat: ["formatToParts"] }, es2019: { Array: ["flat", "flatMap"], ObjectConstructor: ["fromEntries"], String: ["trimStart", "trimEnd", "trimLeft", "trimRight"], Symbol: ["description"] }, es2020: { BigInt: e.emptyArray, BigInt64Array: e.emptyArray, BigUint64Array: e.emptyArray, PromiseConstructor: ["allSettled"], SymbolConstructor: ["matchAll"], String: ["matchAll"], DataView: ["setBigInt64", "setBigUint64", "getBigInt64", "getBigUint64"], RelativeTimeFormat: ["format", "formatToParts", "resolvedOptions"] }, es2021: { PromiseConstructor: ["any"], String: ["replaceAll"] }, es2022: { Array: ["at"], String: ["at"], Int8Array: ["at"], Uint8Array: ["at"], Uint8ClampedArray: ["at"], Int16Array: ["at"], Uint16Array: ["at"], Int32Array: ["at"], Uint32Array: ["at"], Float32Array: ["at"], Float64Array: ["at"], BigInt64Array: ["at"], BigUint64Array: ["at"], ObjectConstructor: ["hasOwn"], Error: ["cause"] } };
            }
            e.getScriptTargetFeatures = _e;
            var we;
            (function(c) {
              c[c.None = 0] = "None", c[c.NeverAsciiEscape = 1] = "NeverAsciiEscape", c[c.JsxAttributeEscape = 2] = "JsxAttributeEscape", c[c.TerminateUnterminatedLiterals = 4] = "TerminateUnterminatedLiterals", c[c.AllowNumericSeparator = 8] = "AllowNumericSeparator";
            })(we = e.GetLiteralTextFlags || (e.GetLiteralTextFlags = {}));
            function de(c, te, xr) {
              var ei;
              if (te && ye(c, xr)) return Be(te, c);
              switch (c.kind) {
                case 10: {
                  var bi = xr & 2 ? wc : xr & 1 || Ie(c) & 16777216 ? ks : Zl;
                  return c.singleQuote ? "'" + bi(c.text, 39) + "'" : '"' + bi(c.text, 34) + '"';
                }
                case 14:
                case 15:
                case 16:
                case 17: {
                  var bi = xr & 1 || Ie(c) & 16777216 ? ks : Zl, Ft = (ei = c.rawText) !== null && ei !== void 0 ? ei : gd(bi(c.text, 96));
                  switch (c.kind) {
                    case 14:
                      return "`" + Ft + "`";
                    case 15:
                      return "`" + Ft + "${";
                    case 16:
                      return "}" + Ft + "${";
                    case 17:
                      return "}" + Ft + "`";
                  }
                  break;
                }
                case 8:
                case 9:
                  return c.text;
                case 13:
                  return xr & 4 && c.isUnterminated ? c.text + (c.text.charCodeAt(c.text.length - 1) === 92 ? " /" : "/") : c.text;
              }
              return e.Debug.fail("Literal kind '".concat(c.kind, "' not accounted for."));
            }
            e.getLiteralText = de;
            function ye(c, te) {
              return F_(c) || !c.parent || te & 4 && c.isUnterminated ? false : e.isNumericLiteral(c) && c.numericLiteralFlags & 512 ? !!(te & 8) : !e.isBigIntLiteral(c);
            }
            function Ae(c) {
              return e.isString(c) ? '"' + Zl(c) + '"' : "" + c;
            }
            e.getTextOfConstantValue = Ae;
            function er(c) {
              return e.getBaseFileName(c).replace(/^(\d)/, "_$1").replace(/\W/g, "_");
            }
            e.makeIdentifierFromModuleName = er;
            function ir(c) {
              return (e.getCombinedNodeFlags(c) & 3) !== 0 || Cr(c);
            }
            e.isBlockOrCatchScoped = ir;
            function Cr(c) {
              var te = jf(c);
              return te.kind === 254 && te.parent.kind === 292;
            }
            e.isCatchClauseVariableDeclarationOrBindingElement = Cr;
            function Ye(c) {
              return e.isModuleDeclaration(c) && (c.name.kind === 10 || Ge(c));
            }
            e.isAmbientModule = Ye;
            function Br(c) {
              return e.isModuleDeclaration(c) && c.name.kind === 10;
            }
            e.isModuleWithStringLiteralName = Br;
            function Er(c) {
              return e.isModuleDeclaration(c) && e.isStringLiteral(c.name);
            }
            e.isNonGlobalAmbientModule = Er;
            function Ne(c) {
              return e.isModuleDeclaration(c) || e.isIdentifier(c);
            }
            e.isEffectiveModuleDeclaration = Ne;
            function n(c) {
              return lr(c.valueDeclaration);
            }
            e.isShorthandAmbientModuleSymbol = n;
            function lr(c) {
              return !!c && c.kind === 261 && !c.body;
            }
            function be(c) {
              return c.kind === 305 || c.kind === 261 || e.isFunctionLikeOrClassStaticBlockDeclaration(c);
            }
            e.isBlockScopedContainerTopLevel = be;
            function Ge(c) {
              return !!(c.flags & 1024);
            }
            e.isGlobalScopeAugmentation = Ge;
            function ur(c) {
              return Ye(c) && yr(c);
            }
            e.isExternalModuleAugmentation = ur;
            function yr(c) {
              switch (c.parent.kind) {
                case 305:
                  return e.isExternalModule(c.parent);
                case 262:
                  return Ye(c.parent.parent) && e.isSourceFile(c.parent.parent.parent) && !e.isExternalModule(c.parent.parent.parent);
              }
              return false;
            }
            e.isModuleAugmentationExternal = yr;
            function Ir(c) {
              var te;
              return (te = c.declarations) === null || te === void 0 ? void 0 : te.find(function(xr) {
                return !ur(xr) && !(e.isModuleDeclaration(xr) && Ge(xr));
              });
            }
            e.getNonAugmentationDeclaration = Ir;
            function wr(c) {
              return c === e.ModuleKind.CommonJS || c === e.ModuleKind.Node16 || c === e.ModuleKind.NodeNext;
            }
            function Ur(c, te) {
              return e.isExternalModule(c) || te.isolatedModules || wr(Ja(te)) && !!c.commonJsModuleIndicator;
            }
            e.isEffectiveExternalModule = Ur;
            function ii(c, te) {
              switch (c.scriptKind) {
                case 1:
                case 3:
                case 2:
                case 4:
                  break;
                default:
                  return false;
              }
              return c.isDeclarationFile ? false : Sd(te, "alwaysStrict") || e.startsWithUseStrict(c.statements) ? true : e.isExternalModule(c) || te.isolatedModules ? Ja(te) >= e.ModuleKind.ES2015 ? true : !te.noImplicitUseStrict : false;
            }
            e.isEffectiveStrictModeSourceFile = ii;
            function mi(c, te) {
              switch (c.kind) {
                case 305:
                case 263:
                case 292:
                case 261:
                case 242:
                case 243:
                case 244:
                case 171:
                case 169:
                case 172:
                case 173:
                case 256:
                case 213:
                case 214:
                case 167:
                case 170:
                  return true;
                case 235:
                  return !e.isFunctionLikeOrClassStaticBlockDeclaration(te);
              }
              return false;
            }
            e.isBlockScope = mi;
            function pe(c) {
              switch (c.kind) {
                case 338:
                case 345:
                case 323:
                  return true;
                default:
                  return e.assertType(c), or(c);
              }
            }
            e.isDeclarationWithTypeParameters = pe;
            function or(c) {
              switch (c.kind) {
                case 174:
                case 175:
                case 168:
                case 176:
                case 179:
                case 180:
                case 317:
                case 257:
                case 226:
                case 258:
                case 259:
                case 344:
                case 256:
                case 169:
                case 171:
                case 172:
                case 173:
                case 213:
                case 214:
                  return true;
                default:
                  return e.assertType(c), false;
              }
            }
            e.isDeclarationWithTypeParameterChildren = or;
            function qr(c) {
              switch (c.kind) {
                case 266:
                case 265:
                  return true;
                default:
                  return false;
              }
            }
            e.isAnyImportSyntax = qr;
            function si(c) {
              return qr(c) || Go(c);
            }
            e.isAnyImportOrBareOrAccessedRequire = si;
            function Di(c) {
              switch (c.kind) {
                case 266:
                case 265:
                case 237:
                case 257:
                case 256:
                case 261:
                case 259:
                case 258:
                case 260:
                  return true;
                default:
                  return false;
              }
            }
            e.isLateVisibilityPaintedStatement = Di;
            function wi(c) {
              return Xi(c) || e.isModuleDeclaration(c) || e.isImportTypeNode(c) || Vr(c);
            }
            e.hasPossibleExternalModuleReference = wi;
            function Xi(c) {
              return qr(c) || e.isExportDeclaration(c);
            }
            e.isAnyImportOrReExport = Xi;
            function et(c) {
              return e.findAncestor(c.parent, function(te) {
                return mi(te, te.parent);
              });
            }
            e.getEnclosingBlockScopeContainer = et;
            function Gi(c, te) {
              for (var xr = et(c); xr; ) te(xr), xr = et(xr);
            }
            e.forEachEnclosingBlockScopeContainer = Gi;
            function Wt(c) {
              return !c || b(c) === 0 ? "(Missing)" : Ee(c);
            }
            e.declarationNameToString = Wt;
            function Zt(c) {
              return c.declaration ? Wt(c.declaration.parameters[0].name) : void 0;
            }
            e.getNameFromIndexInfo = Zt;
            function _r(c) {
              return c.kind === 162 && !ns(c.expression);
            }
            e.isComputedNonLiteralName = _r;
            function pi(c) {
              switch (c.kind) {
                case 79:
                case 80:
                  return c.escapedText;
                case 10:
                case 8:
                case 14:
                  return e.escapeLeadingUnderscores(c.text);
                case 162:
                  return ns(c.expression) ? e.escapeLeadingUnderscores(c.expression.text) : void 0;
                default:
                  return e.Debug.assertNever(c);
              }
            }
            e.tryGetTextOfPropertyName = pi;
            function ae(c) {
              return e.Debug.checkDefined(pi(c));
            }
            e.getTextOfPropertyName = ae;
            function Xe(c) {
              switch (c.kind) {
                case 108:
                  return "this";
                case 80:
                case 79:
                  return b(c) === 0 ? e.idText(c) : Ee(c);
                case 161:
                  return Xe(c.left) + "." + Xe(c.right);
                case 206:
                  return e.isIdentifier(c.name) || e.isPrivateIdentifier(c.name) ? Xe(c.expression) + "." + Xe(c.name) : e.Debug.assertNever(c.name);
                case 311:
                  return Xe(c.left) + Xe(c.right);
                default:
                  return e.Debug.assertNever(c);
              }
            }
            e.entityNameToString = Xe;
            function Jr(c, te, xr, ei, bi, Ft) {
              var ot = $(c);
              return Ze(ot, c, te, xr, ei, bi, Ft);
            }
            e.createDiagnosticForNode = Jr;
            function ti(c, te, xr, ei, bi, Ft, ot) {
              var xa = e.skipTrivia(c.text, te.pos);
              return Hg(c, xa, te.end - xa, xr, ei, bi, Ft, ot);
            }
            e.createDiagnosticForNodeArray = ti;
            function Ze(c, te, xr, ei, bi, Ft, ot) {
              var xa = Oe(c, te);
              return Hg(c, xa.start, xa.length, xr, ei, bi, Ft, ot);
            }
            e.createDiagnosticForNodeInSourceFile = Ze;
            function Sr(c, te, xr) {
              var ei = $(c), bi = Oe(ei, c);
              return Wr(ei, bi.start, bi.length, te, xr);
            }
            e.createDiagnosticForNodeFromMessageChain = Sr;
            function zr(c, te, xr) {
              e.Debug.assertGreaterThanOrEqual(te, 0), e.Debug.assertGreaterThanOrEqual(xr, 0), c && (e.Debug.assertLessThanOrEqual(te, c.text.length), e.Debug.assertLessThanOrEqual(te + xr, c.text.length));
            }
            function Wr(c, te, xr, ei, bi) {
              return zr(c, te, xr), { file: c, start: te, length: xr, code: ei.code, category: ei.category, messageText: ei.next ? ei : ei.messageText, relatedInformation: bi };
            }
            e.createFileDiagnosticFromMessageChain = Wr;
            function Je(c, te, xr) {
              return { file: c, start: 0, length: 0, code: te.code, category: te.category, messageText: te.next ? te : te.messageText, relatedInformation: xr };
            }
            e.createDiagnosticForFileFromMessageChain = Je;
            function xe(c) {
              return typeof c.messageText == "string" ? { code: c.code, category: c.category, messageText: c.messageText, next: c.next } : c.messageText;
            }
            e.createDiagnosticMessageChainFromDiagnostic = xe;
            function vr(c, te, xr) {
              return { file: c, start: te.pos, length: te.end - te.pos, code: xr.code, category: xr.category, messageText: xr.message };
            }
            e.createDiagnosticForRange = vr;
            function mr(c, te) {
              var xr = e.createScanner(c.languageVersion, true, c.languageVariant, c.text, void 0, te);
              xr.scan();
              var ei = xr.getTokenPos();
              return e.createTextSpanFromBounds(ei, xr.getTextPos());
            }
            e.getSpanOfTokenAtPosition = mr;
            function Ar(c, te) {
              var xr = e.skipTrivia(c.text, te.pos);
              if (te.body && te.body.kind === 235) {
                var ei = e.getLineAndCharacterOfPosition(c, te.body.pos).line, bi = e.getLineAndCharacterOfPosition(c, te.body.end).line;
                if (ei < bi) return e.createTextSpan(xr, k(ei, c) - xr + 1);
              }
              return e.createTextSpanFromBounds(xr, te.end);
            }
            function Oe(c, te) {
              var xr = te;
              switch (te.kind) {
                case 305:
                  var ei = e.skipTrivia(c.text, 0, false);
                  return ei === c.text.length ? e.createTextSpan(0, 0) : mr(c, ei);
                case 254:
                case 203:
                case 257:
                case 226:
                case 258:
                case 261:
                case 260:
                case 299:
                case 256:
                case 213:
                case 169:
                case 172:
                case 173:
                case 259:
                case 167:
                case 166:
                case 268:
                  xr = te.name;
                  break;
                case 214:
                  return Ar(c, te);
                case 289:
                case 290:
                  var bi = e.skipTrivia(c.text, te.pos), Ft = te.statements.length > 0 ? te.statements[0].pos : te.end;
                  return e.createTextSpanFromBounds(bi, Ft);
              }
              if (xr === void 0) return mr(c, te.pos);
              e.Debug.assert(!e.isJSDoc(xr));
              var ot = U(xr), xa = ot || e.isJsxText(te) ? xr.pos : e.skipTrivia(c.text, xr.pos);
              return ot ? (e.Debug.assert(xa === xr.pos, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809"), e.Debug.assert(xa === xr.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809")) : (e.Debug.assert(xa >= xr.pos, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809"), e.Debug.assert(xa <= xr.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809")), e.createTextSpanFromBounds(xa, xr.end);
            }
            e.getErrorSpanForNode = Oe;
            function nr(c) {
              return (c.externalModuleIndicator || c.commonJsModuleIndicator) !== void 0;
            }
            e.isExternalOrCommonJsModule = nr;
            function Mr(c) {
              return c.scriptKind === 6;
            }
            e.isJsonSourceFile = Mr;
            function Pe(c) {
              return !!(e.getCombinedModifierFlags(c) & 2048);
            }
            e.isEnumConst = Pe;
            function Ue(c) {
              return !!(e.getCombinedModifierFlags(c) & 64 && !e.isParameterPropertyDeclaration(c, c.parent));
            }
            e.isDeclarationReadonly = Ue;
            function fr(c) {
              return !!(e.getCombinedNodeFlags(c) & 2);
            }
            e.isVarConst = fr;
            function De(c) {
              return !!(e.getCombinedNodeFlags(c) & 1);
            }
            e.isLet = De;
            function gr(c) {
              return c.kind === 208 && c.expression.kind === 106;
            }
            e.isSuperCall = gr;
            function Vr(c) {
              return c.kind === 208 && c.expression.kind === 100;
            }
            e.isImportCall = Vr;
            function Tr(c) {
              return e.isMetaProperty(c) && c.keywordToken === 100 && c.name.escapedText === "meta";
            }
            e.isImportMeta = Tr;
            function vi(c) {
              return e.isImportTypeNode(c) && e.isLiteralTypeNode(c.argument) && e.isStringLiteral(c.argument.literal);
            }
            e.isLiteralImportTypeNode = vi;
            function Ui(c) {
              return c.kind === 238 && c.expression.kind === 10;
            }
            e.isPrologueDirective = Ui;
            function Yi(c) {
              return !!(Ie(c) & 1048576);
            }
            e.isCustomPrologue = Yi;
            function Wi(c) {
              return Yi(c) && e.isFunctionDeclaration(c);
            }
            e.isHoistedFunction = Wi;
            function ct(c) {
              return e.isIdentifier(c.name) && !c.initializer;
            }
            function Li(c) {
              return Yi(c) && e.isVariableStatement(c) && e.every(c.declarationList.declarations, ct);
            }
            e.isHoistedVariableStatement = Li;
            function nt(c, te) {
              return c.kind !== 11 ? e.getLeadingCommentRanges(te.text, c.pos) : void 0;
            }
            e.getLeadingCommentRangesOfNode = nt;
            function Mt(c, te) {
              var xr = c.kind === 164 || c.kind === 163 || c.kind === 213 || c.kind === 214 || c.kind === 212 || c.kind === 254 || c.kind === 275 ? e.concatenate(e.getTrailingCommentRanges(te, c.pos), e.getLeadingCommentRanges(te, c.pos)) : e.getLeadingCommentRanges(te, c.pos);
              return e.filter(xr, function(ei) {
                return te.charCodeAt(ei.pos + 1) === 42 && te.charCodeAt(ei.pos + 2) === 42 && te.charCodeAt(ei.pos + 3) !== 47;
              });
            }
            e.getJSDocCommentRanges = Mt, e.fullTripleSlashReferencePathRegEx = /^(\/\/\/\s*<reference\s+path\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/;
            var xt = /^(\/\/\/\s*<reference\s+types\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/;
            e.fullTripleSlashAMDReferencePathRegEx = /^(\/\/\/\s*<amd-dependency\s+path\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/;
            var ut = /^(\/\/\/\s*<reference\s+no-default-lib\s*=\s*)(('[^']*')|("[^"]*"))\s*\/>/;
            function Dt(c) {
              if (177 <= c.kind && c.kind <= 200) return true;
              switch (c.kind) {
                case 130:
                case 155:
                case 147:
                case 158:
                case 150:
                case 133:
                case 151:
                case 148:
                case 153:
                case 143:
                  return true;
                case 114:
                  return c.parent.kind !== 217;
                case 228:
                  return e.isHeritageClause(c.parent) && !Fc(c);
                case 163:
                  return c.parent.kind === 195 || c.parent.kind === 190;
                case 79:
                  (c.parent.kind === 161 && c.parent.right === c || c.parent.kind === 206 && c.parent.name === c) && (c = c.parent), e.Debug.assert(c.kind === 79 || c.kind === 161 || c.kind === 206, "'node' was expected to be a qualified name, identifier or property access in 'isPartOfTypeNode'.");
                case 161:
                case 206:
                case 108: {
                  var te = c.parent;
                  if (te.kind === 181) return false;
                  if (te.kind === 200) return !te.isTypeOf;
                  if (177 <= te.kind && te.kind <= 200) return true;
                  switch (te.kind) {
                    case 228:
                      return e.isHeritageClause(te.parent) && !Fc(te);
                    case 163:
                      return c === te.constraint;
                    case 344:
                      return c === te.constraint;
                    case 167:
                    case 166:
                    case 164:
                    case 254:
                      return c === te.type;
                    case 256:
                    case 213:
                    case 214:
                    case 171:
                    case 169:
                    case 168:
                    case 172:
                    case 173:
                      return c === te.type;
                    case 174:
                    case 175:
                    case 176:
                      return c === te.type;
                    case 211:
                      return c === te.type;
                    case 208:
                    case 209:
                      return e.contains(te.typeArguments, c);
                    case 210:
                      return false;
                  }
                }
              }
              return false;
            }
            e.isPartOfTypeNode = Dt;
            function Rt(c, te) {
              for (; c; ) {
                if (c.kind === te) return true;
                c = c.parent;
              }
              return false;
            }
            e.isChildOfNodeWithKind = Rt;
            function Ii(c, te) {
              return xr(c);
              function xr(ei) {
                switch (ei.kind) {
                  case 247:
                    return te(ei);
                  case 263:
                  case 235:
                  case 239:
                  case 240:
                  case 241:
                  case 242:
                  case 243:
                  case 244:
                  case 248:
                  case 249:
                  case 289:
                  case 290:
                  case 250:
                  case 252:
                  case 292:
                    return e.forEachChild(ei, xr);
                }
              }
            }
            e.forEachReturnStatement = Ii;
            function Ki(c, te) {
              return xr(c);
              function xr(ei) {
                switch (ei.kind) {
                  case 224:
                    te(ei);
                    var bi = ei.expression;
                    bi && xr(bi);
                    return;
                  case 260:
                  case 258:
                  case 261:
                  case 259:
                    return;
                  default:
                    if (e.isFunctionLike(ei)) {
                      if (ei.name && ei.name.kind === 162) {
                        xr(ei.name.expression);
                        return;
                      }
                    } else Dt(ei) || e.forEachChild(ei, xr);
                }
              }
            }
            e.forEachYieldExpression = Ki;
            function Fi(c) {
              return c && c.kind === 183 ? c.elementType : c && c.kind === 178 ? e.singleOrUndefined(c.typeArguments) : void 0;
            }
            e.getRestParameterElementType = Fi;
            function ui(c) {
              switch (c.kind) {
                case 258:
                case 257:
                case 226:
                case 182:
                  return c.members;
                case 205:
                  return c.properties;
              }
            }
            e.getMembersOfDeclaration = ui;
            function Bt(c) {
              if (c) switch (c.kind) {
                case 203:
                case 299:
                case 164:
                case 296:
                case 167:
                case 166:
                case 297:
                case 254:
                  return true;
              }
              return false;
            }
            e.isVariableLike = Bt;
            function wt(c) {
              return Bt(c) || e.isAccessor(c);
            }
            e.isVariableLikeOrAccessor = wt;
            function na(c) {
              return c.parent.kind === 255 && c.parent.parent.kind === 237;
            }
            e.isVariableDeclarationInVariableStatement = na;
            function Ai(c) {
              return Ct(c) ? e.isObjectLiteralExpression(c.parent) && e.isBinaryExpression(c.parent.parent) && Hr(c.parent.parent) === 2 || Oi(c.parent) : false;
            }
            e.isCommonJsExportedExpression = Ai;
            function Oi(c) {
              return Ct(c) ? e.isBinaryExpression(c) && Hr(c) === 1 : false;
            }
            e.isCommonJsExportPropertyAssignment = Oi;
            function ji(c) {
              return (e.isVariableDeclaration(c) ? fr(c) && e.isIdentifier(c.name) && na(c) : e.isPropertyDeclaration(c) ? wp(c) && mc(c) : e.isPropertySignature(c) && wp(c)) || Oi(c);
            }
            e.isValidESSymbolDeclaration = ji;
            function Vi(c) {
              switch (c.kind) {
                case 169:
                case 168:
                case 171:
                case 172:
                case 173:
                case 256:
                case 213:
                  return true;
              }
              return false;
            }
            e.introducesArgumentsExoticObject = Vi;
            function at(c, te) {
              for (; ; ) {
                if (te && te(c), c.statement.kind !== 250) return c.statement;
                c = c.statement;
              }
            }
            e.unwrapInnermostStatementOfLabel = at;
            function At(c) {
              return c && c.kind === 235 && e.isFunctionLike(c.parent);
            }
            e.isFunctionBlock = At;
            function ba(c) {
              return c && c.kind === 169 && c.parent.kind === 205;
            }
            e.isObjectLiteralMethod = ba;
            function $a(c) {
              return (c.kind === 169 || c.kind === 172 || c.kind === 173) && (c.parent.kind === 205 || c.parent.kind === 226);
            }
            e.isObjectLiteralOrClassExpressionMethodOrAccessor = $a;
            function Qa(c) {
              return c && c.kind === 1;
            }
            e.isIdentifierTypePredicate = Qa;
            function ai(c) {
              return c && c.kind === 0;
            }
            e.isThisTypePredicate = ai;
            function Dn(c, te, xr) {
              return c.properties.filter(function(ei) {
                if (ei.kind === 296) {
                  var bi = pi(ei.name);
                  return te === bi || !!xr && xr === bi;
                }
                return false;
              });
            }
            e.getPropertyAssignment = Dn;
            function ka(c, te, xr) {
              return e.firstDefined(Dn(c, te), function(ei) {
                return e.isArrayLiteralExpression(ei.initializer) ? e.find(ei.initializer.elements, function(bi) {
                  return e.isStringLiteral(bi) && bi.text === xr;
                }) : void 0;
              });
            }
            e.getPropertyArrayElementValue = ka;
            function Ba(c) {
              if (c && c.statements.length) {
                var te = c.statements[0].expression;
                return e.tryCast(te, e.isObjectLiteralExpression);
              }
            }
            e.getTsConfigObjectLiteralExpression = Ba;
            function pn(c, te, xr) {
              return e.firstDefined(Cn(c, te), function(ei) {
                return e.isArrayLiteralExpression(ei.initializer) ? e.find(ei.initializer.elements, function(bi) {
                  return e.isStringLiteral(bi) && bi.text === xr;
                }) : void 0;
              });
            }
            e.getTsConfigPropArrayElementValue = pn;
            function Cn(c, te) {
              var xr = Ba(c);
              return xr ? Dn(xr, te) : e.emptyArray;
            }
            e.getTsConfigPropArray = Cn;
            function Bi(c) {
              return e.findAncestor(c.parent, e.isFunctionLike);
            }
            e.getContainingFunction = Bi;
            function kn(c) {
              return e.findAncestor(c.parent, e.isFunctionLikeDeclaration);
            }
            e.getContainingFunctionDeclaration = kn;
            function xn(c) {
              return e.findAncestor(c.parent, e.isClassLike);
            }
            e.getContainingClass = xn;
            function Kn(c) {
              return e.findAncestor(c.parent, function(te) {
                return e.isClassLike(te) || e.isFunctionLike(te) ? "quit" : e.isClassStaticBlockDeclaration(te);
              });
            }
            e.getContainingClassStaticBlock = Kn;
            function Pn(c) {
              return e.findAncestor(c.parent, e.isFunctionLikeOrClassStaticBlockDeclaration);
            }
            e.getContainingFunctionOrClassStaticBlock = Pn;
            function eo(c, te) {
              for (e.Debug.assert(c.kind !== 305); ; ) {
                if (c = c.parent, !c) return e.Debug.fail();
                switch (c.kind) {
                  case 162:
                    if (e.isClassLike(c.parent.parent)) return c;
                    c = c.parent;
                    break;
                  case 165:
                    c.parent.kind === 164 && e.isClassElement(c.parent.parent) ? c = c.parent.parent : e.isClassElement(c.parent) && (c = c.parent);
                    break;
                  case 214:
                    if (!te) continue;
                  case 256:
                  case 213:
                  case 261:
                  case 170:
                  case 167:
                  case 166:
                  case 169:
                  case 168:
                  case 171:
                  case 172:
                  case 173:
                  case 174:
                  case 175:
                  case 176:
                  case 260:
                  case 305:
                    return c;
                }
              }
            }
            e.getThisContainer = eo;
            function Rn(c) {
              switch (c.kind) {
                case 214:
                case 256:
                case 213:
                case 167:
                  return true;
                case 235:
                  switch (c.parent.kind) {
                    case 171:
                    case 169:
                    case 172:
                    case 173:
                      return true;
                    default:
                      return false;
                  }
                default:
                  return false;
              }
            }
            e.isThisContainerOrFunctionBlock = Rn;
            function Da(c) {
              e.isIdentifier(c) && (e.isClassDeclaration(c.parent) || e.isFunctionDeclaration(c.parent)) && c.parent.name === c && (c = c.parent);
              var te = eo(c, true);
              return e.isSourceFile(te);
            }
            e.isInTopLevelContext = Da;
            function bo(c) {
              var te = eo(c, false);
              if (te) switch (te.kind) {
                case 171:
                case 256:
                case 213:
                  return te;
              }
            }
            e.getNewTargetContainer = bo;
            function Ro(c, te) {
              for (; ; ) {
                if (c = c.parent, !c) return c;
                switch (c.kind) {
                  case 162:
                    c = c.parent;
                    break;
                  case 256:
                  case 213:
                  case 214:
                    if (!te) continue;
                  case 167:
                  case 166:
                  case 169:
                  case 168:
                  case 171:
                  case 172:
                  case 173:
                  case 170:
                    return c;
                  case 165:
                    c.parent.kind === 164 && e.isClassElement(c.parent.parent) ? c = c.parent.parent : e.isClassElement(c.parent) && (c = c.parent);
                    break;
                }
              }
            }
            e.getSuperContainer = Ro;
            function En(c) {
              if (c.kind === 213 || c.kind === 214) {
                for (var te = c, xr = c.parent; xr.kind === 212; ) te = xr, xr = xr.parent;
                if (xr.kind === 208 && xr.expression === te) return xr;
              }
            }
            e.getImmediatelyInvokedFunctionExpression = En;
            function Wn(c) {
              return c.kind === 106 || to(c);
            }
            e.isSuperOrSuperProperty = Wn;
            function to(c) {
              var te = c.kind;
              return (te === 206 || te === 207) && c.expression.kind === 106;
            }
            e.isSuperProperty = to;
            function Co(c) {
              var te = c.kind;
              return (te === 206 || te === 207) && c.expression.kind === 108;
            }
            e.isThisProperty = Co;
            function Ko(c) {
              var te;
              return !!c && e.isVariableDeclaration(c) && ((te = c.initializer) === null || te === void 0 ? void 0 : te.kind) === 108;
            }
            e.isThisInitializedDeclaration = Ko;
            function Oo(c) {
              return !!c && (e.isShorthandPropertyAssignment(c) || e.isPropertyAssignment(c)) && e.isBinaryExpression(c.parent.parent) && c.parent.parent.operatorToken.kind === 63 && c.parent.parent.right.kind === 108;
            }
            e.isThisInitializedObjectBindingExpression = Oo;
            function no(c) {
              switch (c.kind) {
                case 178:
                  return c.typeName;
                case 228:
                  return Hu(c.expression) ? c.expression : void 0;
                case 79:
                case 161:
                  return c;
              }
            }
            e.getEntityNameFromTypeNode = no;
            function $o(c) {
              switch (c.kind) {
                case 210:
                  return c.tag;
                case 280:
                case 279:
                  return c.tagName;
                default:
                  return c.expression;
              }
            }
            e.getInvokedExpression = $o;
            function Pr(c, te, xr) {
              if (e.isNamedDeclaration(c) && e.isPrivateIdentifier(c.name)) return false;
              switch (c.kind) {
                case 257:
                  return true;
                case 167:
                  return te.kind === 257;
                case 172:
                case 173:
                case 169:
                  return c.body !== void 0 && te.kind === 257;
                case 164:
                  return te.body !== void 0 && (te.kind === 171 || te.kind === 169 || te.kind === 173) && xr.kind === 257;
              }
              return false;
            }
            e.nodeCanBeDecorated = Pr;
            function xi(c, te, xr) {
              return c.decorators !== void 0 && Pr(c, te, xr);
            }
            e.nodeIsDecorated = xi;
            function St(c, te, xr) {
              return xi(c, te, xr) || pa(c, te);
            }
            e.nodeOrChildIsDecorated = St;
            function pa(c, te) {
              switch (c.kind) {
                case 257:
                  return e.some(c.members, function(xr) {
                    return St(xr, c, te);
                  });
                case 169:
                case 173:
                case 171:
                  return e.some(c.parameters, function(xr) {
                    return xi(xr, c, te);
                  });
                default:
                  return false;
              }
            }
            e.childIsDecorated = pa;
            function dn(c) {
              if (xi(c)) return true;
              var te = Nu(c);
              return !!te && pa(te, c);
            }
            e.classOrConstructorParameterIsDecorated = dn;
            function Jn(c) {
              var te = c.parent;
              return te.kind === 280 || te.kind === 279 || te.kind === 281 ? te.tagName === c : false;
            }
            e.isJSXTagName = Jn;
            function Qe(c) {
              switch (c.kind) {
                case 106:
                case 104:
                case 110:
                case 95:
                case 13:
                case 204:
                case 205:
                case 206:
                case 207:
                case 208:
                case 209:
                case 210:
                case 229:
                case 211:
                case 230:
                case 212:
                case 213:
                case 226:
                case 214:
                case 217:
                case 215:
                case 216:
                case 219:
                case 220:
                case 221:
                case 222:
                case 225:
                case 223:
                case 227:
                case 278:
                case 279:
                case 282:
                case 224:
                case 218:
                case 231:
                  return true;
                case 161:
                  for (; c.parent.kind === 161; ) c = c.parent;
                  return c.parent.kind === 181 || e.isJSDocLinkLike(c.parent) || e.isJSDocNameReference(c.parent) || e.isJSDocMemberName(c.parent) || Jn(c);
                case 311:
                  for (; e.isJSDocMemberName(c.parent); ) c = c.parent;
                  return c.parent.kind === 181 || e.isJSDocLinkLike(c.parent) || e.isJSDocNameReference(c.parent) || e.isJSDocMemberName(c.parent) || Jn(c);
                case 80:
                  return e.isBinaryExpression(c.parent) && c.parent.left === c && c.parent.operatorToken.kind === 101;
                case 79:
                  if (c.parent.kind === 181 || e.isJSDocLinkLike(c.parent) || e.isJSDocNameReference(c.parent) || e.isJSDocMemberName(c.parent) || Jn(c)) return true;
                case 8:
                case 9:
                case 10:
                case 14:
                case 108:
                  return Gr(c);
                default:
                  return false;
              }
            }
            e.isExpressionNode = Qe;
            function Gr(c) {
              var te = c.parent;
              switch (te.kind) {
                case 254:
                case 164:
                case 167:
                case 166:
                case 299:
                case 296:
                case 203:
                  return te.initializer === c;
                case 238:
                case 239:
                case 240:
                case 241:
                case 247:
                case 248:
                case 249:
                case 289:
                case 251:
                  return te.expression === c;
                case 242:
                  var xr = te;
                  return xr.initializer === c && xr.initializer.kind !== 255 || xr.condition === c || xr.incrementor === c;
                case 243:
                case 244:
                  var ei = te;
                  return ei.initializer === c && ei.initializer.kind !== 255 || ei.expression === c;
                case 211:
                case 229:
                  return c === te.expression;
                case 233:
                  return c === te.expression;
                case 162:
                  return c === te.expression;
                case 165:
                case 288:
                case 287:
                case 298:
                  return true;
                case 228:
                  return te.expression === c && !Dt(te);
                case 297:
                  return te.objectAssignmentInitializer === c;
                default:
                  return Qe(te);
              }
            }
            e.isInExpressionContext = Gr;
            function S(c) {
              for (; c.kind === 161 || c.kind === 79; ) c = c.parent;
              return c.kind === 181;
            }
            e.isPartOfTypeQuery = S;
            function Ce(c) {
              return e.isNamespaceExport(c) && !!c.parent.moduleSpecifier;
            }
            e.isNamespaceReexportDeclaration = Ce;
            function qe(c) {
              return c.kind === 265 && c.moduleReference.kind === 277;
            }
            e.isExternalModuleImportEqualsDeclaration = qe;
            function br(c) {
              return e.Debug.assert(qe(c)), c.moduleReference.expression;
            }
            e.getExternalModuleImportEqualsDeclarationExpression = br;
            function Zr(c) {
              return Go(c) && Xa(c.initializer).arguments[0];
            }
            e.getExternalModuleRequireArgument = Zr;
            function Si(c) {
              return c.kind === 265 && c.moduleReference.kind !== 277;
            }
            e.isInternalModuleImportEqualsDeclaration = Si;
            function Pi(c) {
              return Ct(c);
            }
            e.isSourceFileJS = Pi;
            function Qi(c) {
              return !Ct(c);
            }
            e.isSourceFileNotJS = Qi;
            function Ct(c) {
              return !!c && !!(c.flags & 262144);
            }
            e.isInJSFile = Ct;
            function sa(c) {
              return !!c && !!(c.flags & 67108864);
            }
            e.isInJsonFile = sa;
            function en(c) {
              return !Mr(c);
            }
            e.isSourceFileNotJson = en;
            function Wa(c) {
              return !!c && !!(c.flags & 8388608);
            }
            e.isInJSDoc = Wa;
            function qn(c) {
              return e.isTypeReferenceNode(c) && e.isIdentifier(c.typeName) && c.typeName.escapedText === "Object" && c.typeArguments && c.typeArguments.length === 2 && (c.typeArguments[0].kind === 150 || c.typeArguments[0].kind === 147);
            }
            e.isJSDocIndexSignature = qn;
            function mo(c, te) {
              if (c.kind !== 208) return false;
              var xr = c, ei = xr.expression, bi = xr.arguments;
              if (ei.kind !== 79 || ei.escapedText !== "require" || bi.length !== 1) return false;
              var Ft = bi[0];
              return !te || e.isStringLiteralLike(Ft);
            }
            e.isRequireCall = mo;
            function So(c) {
              return ys(c, false);
            }
            e.isVariableDeclarationInitializedToRequire = So;
            function Go(c) {
              return ys(c, true);
            }
            e.isVariableDeclarationInitializedToBareOrAccessedRequire = Go;
            function ys(c, te) {
              return c.kind === 203 && (c = c.parent.parent), e.isVariableDeclaration(c) && !!c.initializer && mo(te ? Xa(c.initializer) : c.initializer, true);
            }
            function Pc(c) {
              return e.isVariableStatement(c) && c.declarationList.declarations.length > 0 && e.every(c.declarationList.declarations, function(te) {
                return So(te);
              });
            }
            e.isRequireVariableStatement = Pc;
            function Vc(c) {
              return c === 39 || c === 34;
            }
            e.isSingleOrDoubleQuote = Vc;
            function Kc(c, te) {
              return Be(te, c).charCodeAt(0) === 34;
            }
            e.isStringDoubleQuoted = Kc;
            function Xs(c) {
              return e.isBinaryExpression(c) || cr(c) || e.isIdentifier(c) || e.isCallExpression(c);
            }
            e.isAssignmentDeclaration = Xs;
            function pc(c) {
              return Ct(c) && c.initializer && e.isBinaryExpression(c.initializer) && (c.initializer.operatorToken.kind === 56 || c.initializer.operatorToken.kind === 60) && c.name && Hu(c.name) && ce(c.name, c.initializer.left) ? c.initializer.right : c.initializer;
            }
            e.getEffectiveInitializer = pc;
            function hs(c) {
              var te = pc(c);
              return te && Qs(te, nf(c.name));
            }
            e.getDeclaredExpandoInitializer = hs;
            function tc(c, te) {
              return e.forEach(c.properties, function(xr) {
                return e.isPropertyAssignment(xr) && e.isIdentifier(xr.name) && xr.name.escapedText === "value" && xr.initializer && Qs(xr.initializer, te);
              });
            }
            function ps(c) {
              if (c && c.parent && e.isBinaryExpression(c.parent) && c.parent.operatorToken.kind === 63) {
                var te = nf(c.parent.left);
                return Qs(c.parent.right, te) || js(c.parent.left, c.parent.right, te);
              }
              if (c && e.isCallExpression(c) && pt(c)) {
                var xr = tc(c.arguments[2], c.arguments[1].text === "prototype");
                if (xr) return xr;
              }
            }
            e.getAssignedExpandoInitializer = ps;
            function Qs(c, te) {
              if (e.isCallExpression(c)) {
                var xr = po(c.expression);
                return xr.kind === 213 || xr.kind === 214 ? c : void 0;
              }
              if (c.kind === 213 || c.kind === 226 || c.kind === 214 || e.isObjectLiteralExpression(c) && (c.properties.length === 0 || te)) return c;
            }
            e.getExpandoInitializer = Qs;
            function js(c, te, xr) {
              var ei = e.isBinaryExpression(te) && (te.operatorToken.kind === 56 || te.operatorToken.kind === 60) && Qs(te.right, xr);
              if (ei && ce(c, te.left)) return ei;
            }
            function ds(c) {
              var te = e.isVariableDeclaration(c.parent) ? c.parent.name : e.isBinaryExpression(c.parent) && c.parent.operatorToken.kind === 63 ? c.parent.left : void 0;
              return te && Qs(c.right, nf(te)) && Hu(te) && ce(te, c.left);
            }
            e.isDefaultedExpandoInitializer = ds;
            function Ji(c) {
              if (e.isBinaryExpression(c.parent)) {
                var te = (c.parent.operatorToken.kind === 56 || c.parent.operatorToken.kind === 60) && e.isBinaryExpression(c.parent.parent) ? c.parent.parent : c.parent;
                if (te.operatorToken.kind === 63 && e.isIdentifier(te.left)) return te.left;
              } else if (e.isVariableDeclaration(c.parent)) return c.parent.name;
            }
            e.getNameOfExpando = Ji;
            function ce(c, te) {
              return Jf(c) && Jf(te) ? w_(c) === w_(te) : e.isMemberName(c) && Pt(te) && (te.expression.kind === 108 || e.isIdentifier(te.expression) && (te.expression.escapedText === "window" || te.expression.escapedText === "self" || te.expression.escapedText === "global")) ? ce(c, fo(te)) : Pt(c) && Pt(te) ? Ao(c) === Ao(te) && ce(c.expression, te.expression) : false;
            }
            e.isSameEntityName = ce;
            function Rr(c) {
              for (; dl(c, true); ) c = c.right;
              return c;
            }
            e.getRightMostAssignedExpression = Rr;
            function yi(c) {
              return e.isIdentifier(c) && c.escapedText === "exports";
            }
            e.isExportsIdentifier = yi;
            function qi(c) {
              return e.isIdentifier(c) && c.escapedText === "module";
            }
            e.isModuleIdentifier = qi;
            function je(c) {
              return (e.isPropertyAccessExpression(c) || ga(c)) && qi(c.expression) && Ao(c) === "exports";
            }
            e.isModuleExportsAccessExpression = je;
            function Hr(c) {
              var te = xs(c);
              return te === 5 || Ct(c) ? te : 0;
            }
            e.getAssignmentDeclarationKind = Hr;
            function pt(c) {
              return e.length(c.arguments) === 3 && e.isPropertyAccessExpression(c.expression) && e.isIdentifier(c.expression.expression) && e.idText(c.expression.expression) === "Object" && e.idText(c.expression.name) === "defineProperty" && ns(c.arguments[1]) && jr(c.arguments[0], true);
            }
            e.isBindableObjectDefinePropertyCall = pt;
            function Pt(c) {
              return e.isPropertyAccessExpression(c) || ga(c);
            }
            e.isLiteralLikeAccess = Pt;
            function ga(c) {
              return e.isElementAccessExpression(c) && ns(c.argumentExpression);
            }
            e.isLiteralLikeElementAccess = ga;
            function ua(c, te) {
              return e.isPropertyAccessExpression(c) && (!te && c.expression.kind === 108 || e.isIdentifier(c.name) && jr(c.expression, true)) || Xn(c, te);
            }
            e.isBindableStaticAccessExpression = ua;
            function Xn(c, te) {
              return ga(c) && (!te && c.expression.kind === 108 || Hu(c.expression) || ua(c.expression, true));
            }
            e.isBindableStaticElementAccessExpression = Xn;
            function jr(c, te) {
              return Hu(c) || ua(c, te);
            }
            e.isBindableStaticNameExpression = jr;
            function fo(c) {
              return e.isPropertyAccessExpression(c) ? c.name : c.argumentExpression;
            }
            e.getNameOrArgument = fo;
            function xs(c) {
              if (e.isCallExpression(c)) {
                if (!pt(c)) return 0;
                var te = c.arguments[0];
                return yi(te) || je(te) ? 8 : ua(te) && Ao(te) === "prototype" ? 9 : 7;
              }
              return c.operatorToken.kind !== 63 || !cr(c.left) || Fo(Rr(c)) ? 0 : jr(c.left.expression, true) && Ao(c.left) === "prototype" && e.isObjectLiteralExpression(Bs(c)) ? 6 : Ms(c.left);
            }
            function Fo(c) {
              return e.isVoidExpression(c) && e.isNumericLiteral(c.expression) && c.expression.text === "0";
            }
            function ko(c) {
              if (e.isPropertyAccessExpression(c)) return c.name;
              var te = po(c.argumentExpression);
              return e.isNumericLiteral(te) || e.isStringLiteralLike(te) ? te : c;
            }
            e.getElementOrPropertyAccessArgumentExpressionOrName = ko;
            function Ao(c) {
              var te = ko(c);
              if (te) {
                if (e.isIdentifier(te)) return te.escapedText;
                if (e.isStringLiteralLike(te) || e.isNumericLiteral(te)) return e.escapeLeadingUnderscores(te.text);
              }
            }
            e.getElementOrPropertyAccessName = Ao;
            function Ms(c) {
              if (c.expression.kind === 108) return 4;
              if (je(c)) return 2;
              if (jr(c.expression, true)) {
                if (nf(c.expression)) return 3;
                for (var te = c; !e.isIdentifier(te.expression); ) te = te.expression;
                var xr = te.expression;
                if ((xr.escapedText === "exports" || xr.escapedText === "module" && Ao(te) === "exports") && ua(c)) return 1;
                if (jr(c, true) || e.isElementAccessExpression(c) && es(c)) return 5;
              }
              return 0;
            }
            e.getAssignmentDeclarationPropertyAccessKind = Ms;
            function Bs(c) {
              for (; e.isBinaryExpression(c.right); ) c = c.right;
              return c.right;
            }
            e.getInitializerOfBinaryExpression = Bs;
            function xc(c) {
              return e.isBinaryExpression(c) && Hr(c) === 3;
            }
            e.isPrototypePropertyAssignment = xc;
            function su(c) {
              return Ct(c) && c.parent && c.parent.kind === 238 && (!e.isElementAccessExpression(c) || ga(c)) && !!e.getJSDocTypeTag(c.parent);
            }
            e.isSpecialPropertyDeclaration = su;
            function tl(c, te) {
              var xr = c.valueDeclaration;
              (!xr || !(te.flags & 16777216 && !(xr.flags & 16777216)) && Xs(xr) && !Xs(te) || xr.kind !== te.kind && Ne(xr)) && (c.valueDeclaration = te);
            }
            e.setValueDeclaration = tl;
            function Zc(c) {
              if (!c || !c.valueDeclaration) return false;
              var te = c.valueDeclaration;
              return te.kind === 256 || e.isVariableDeclaration(te) && te.initializer && e.isFunctionLike(te.initializer);
            }
            e.isFunctionSymbol = Zc;
            function Rf(c) {
              var te, xr;
              switch (c.kind) {
                case 254:
                  return (te = e.findAncestor(c.initializer, function(ei) {
                    return mo(ei, true);
                  })) === null || te === void 0 ? void 0 : te.arguments[0];
                case 266:
                  return e.tryCast(c.moduleSpecifier, e.isStringLiteralLike);
                case 265:
                  return e.tryCast((xr = e.tryCast(c.moduleReference, e.isExternalModuleReference)) === null || xr === void 0 ? void 0 : xr.expression, e.isStringLiteralLike);
                default:
                  e.Debug.assertNever(c);
              }
            }
            e.tryGetModuleSpecifierFromDeclaration = Rf;
            function al(c) {
              return Jo(c) || e.Debug.failBadSyntaxKind(c.parent);
            }
            e.importFromModuleSpecifier = al;
            function Jo(c) {
              switch (c.parent.kind) {
                case 266:
                case 272:
                  return c.parent;
                case 277:
                  return c.parent.parent;
                case 208:
                  return Vr(c.parent) || mo(c.parent, false) ? c.parent : void 0;
                case 196:
                  return e.Debug.assert(e.isStringLiteral(c)), e.tryCast(c.parent.parent, e.isImportTypeNode);
                default:
                  return;
              }
            }
            e.tryGetImportFromModuleSpecifier = Jo;
            function eu(c) {
              switch (c.kind) {
                case 266:
                case 272:
                  return c.moduleSpecifier;
                case 265:
                  return c.moduleReference.kind === 277 ? c.moduleReference.expression : void 0;
                case 200:
                  return vi(c) ? c.argument.literal : void 0;
                case 208:
                  return c.arguments[0];
                case 261:
                  return c.name.kind === 10 ? c.name : void 0;
                default:
                  return e.Debug.assertNever(c);
              }
            }
            e.getExternalModuleName = eu;
            function Ws(c) {
              switch (c.kind) {
                case 266:
                  return c.importClause && e.tryCast(c.importClause.namedBindings, e.isNamespaceImport);
                case 265:
                  return c;
                case 272:
                  return c.exportClause && e.tryCast(c.exportClause, e.isNamespaceExport);
                default:
                  return e.Debug.assertNever(c);
              }
            }
            e.getNamespaceDeclarationNode = Ws;
            function pu(c) {
              return c.kind === 266 && !!c.importClause && !!c.importClause.name;
            }
            e.isDefaultImport = pu;
            function Uu(c, te) {
              if (c.name) {
                var xr = te(c);
                if (xr) return xr;
              }
              if (c.namedBindings) {
                var xr = e.isNamespaceImport(c.namedBindings) ? te(c.namedBindings) : e.forEach(c.namedBindings.elements, te);
                if (xr) return xr;
              }
            }
            e.forEachImportClauseDeclaration = Uu;
            function Ql(c) {
              if (c) switch (c.kind) {
                case 164:
                case 169:
                case 168:
                case 297:
                case 296:
                case 167:
                case 166:
                  return c.questionToken !== void 0;
              }
              return false;
            }
            e.hasQuestionToken = Ql;
            function xl(c) {
              var te = e.isJSDocFunctionType(c) ? e.firstOrUndefined(c.parameters) : void 0, xr = e.tryCast(te && te.name, e.isIdentifier);
              return !!xr && xr.escapedText === "new";
            }
            e.isJSDocConstructSignature = xl;
            function Ya(c) {
              return c.kind === 345 || c.kind === 338 || c.kind === 339;
            }
            e.isJSDocTypeAlias = Ya;
            function du(c) {
              return Ya(c) || e.isTypeAliasDeclaration(c);
            }
            e.isTypeAlias = du;
            function vc(c) {
              return e.isExpressionStatement(c) && e.isBinaryExpression(c.expression) && c.expression.operatorToken.kind === 63 ? Rr(c.expression) : void 0;
            }
            function Kr(c) {
              return e.isExpressionStatement(c) && e.isBinaryExpression(c.expression) && Hr(c.expression) !== 0 && e.isBinaryExpression(c.expression.right) && (c.expression.right.operatorToken.kind === 56 || c.expression.right.operatorToken.kind === 60) ? c.expression.right.right : void 0;
            }
            function _i(c) {
              switch (c.kind) {
                case 237:
                  var te = Ei(c);
                  return te && te.initializer;
                case 167:
                  return c.initializer;
                case 296:
                  return c.initializer;
              }
            }
            e.getSingleInitializerOfVariableStatementOrPropertyDeclaration = _i;
            function Ei(c) {
              return e.isVariableStatement(c) ? e.firstOrUndefined(c.declarationList.declarations) : void 0;
            }
            e.getSingleVariableOfVariableStatement = Ei;
            function tt(c) {
              return e.isModuleDeclaration(c) && c.body && c.body.kind === 261 ? c.body : void 0;
            }
            function kt(c, te) {
              var xr;
              Bt(c) && e.hasInitializer(c) && e.hasJSDocNodes(c.initializer) && (xr = e.addRange(xr, bt(c, e.last(c.initializer.jsDoc))));
              for (var ei = c; ei && ei.parent; ) {
                if (e.hasJSDocNodes(ei) && (xr = e.addRange(xr, bt(c, e.last(ei.jsDoc)))), ei.kind === 164) {
                  xr = e.addRange(xr, (te ? e.getJSDocParameterTagsNoCache : e.getJSDocParameterTags)(ei));
                  break;
                }
                if (ei.kind === 163) {
                  xr = e.addRange(xr, (te ? e.getJSDocTypeParameterTagsNoCache : e.getJSDocTypeParameterTags)(ei));
                  break;
                }
                ei = Xt(ei);
              }
              return xr || e.emptyArray;
            }
            e.getJSDocCommentsAndTags = kt;
            function bt(c, te) {
              if (e.isJSDoc(te)) {
                var xr = e.filter(te.tags, function(ei) {
                  return ia(c, ei);
                });
                return te.tags === xr ? [te] : xr;
              }
              return ia(c, te) ? [te] : void 0;
            }
            function ia(c, te) {
              return !e.isJSDocTypeTag(te) || !te.parent || !e.isJSDoc(te.parent) || !e.isParenthesizedExpression(te.parent.parent) || te.parent.parent === c;
            }
            function Xt(c) {
              var te = c.parent;
              if (te.kind === 296 || te.kind === 271 || te.kind === 167 || te.kind === 238 && c.kind === 206 || te.kind === 247 || tt(te) || e.isBinaryExpression(c) && c.operatorToken.kind === 63) return te;
              if (te.parent && (Ei(te.parent) === c || e.isBinaryExpression(te) && te.operatorToken.kind === 63)) return te.parent;
              if (te.parent && te.parent.parent && (Ei(te.parent.parent) || _i(te.parent.parent) === c || Kr(te.parent.parent))) return te.parent.parent;
            }
            e.getNextJSDocCommentLocation = Xt;
            function Za(c) {
              if (c.symbol) return c.symbol;
              if (!!e.isIdentifier(c.name)) {
                var te = c.name.escapedText, xr = _a(c);
                if (!!xr) {
                  var ei = e.find(xr.parameters, function(bi) {
                    return bi.name.kind === 79 && bi.name.escapedText === te;
                  });
                  return ei && ei.symbol;
                }
              }
            }
            e.getParameterSymbolFromJSDoc = Za;
            function bn(c) {
              if (e.isJSDoc(c.parent) && c.parent.tags) {
                var te = e.find(c.parent.tags, Ya);
                if (te) return te;
              }
              return _a(c);
            }
            e.getEffectiveContainerForJSDocTemplateTag = bn;
            function _a(c) {
              var te = qa(c);
              if (te) return e.isPropertySignature(te) && te.type && e.isFunctionLike(te.type) ? te.type : e.isFunctionLike(te) ? te : void 0;
            }
            e.getHostSignatureFromJSDoc = _a;
            function qa(c) {
              var te = rn(c);
              if (te) return Kr(te) || vc(te) || _i(te) || Ei(te) || tt(te) || te;
            }
            e.getEffectiveJSDocHost = qa;
            function rn(c) {
              var te = jn(c);
              if (!!te) {
                var xr = te.parent;
                if (xr && xr.jsDoc && te === e.lastOrUndefined(xr.jsDoc)) return xr;
              }
            }
            e.getJSDocHost = rn;
            function jn(c) {
              return e.findAncestor(c.parent, e.isJSDoc);
            }
            e.getJSDocRoot = jn;
            function Mo(c) {
              var te = c.name.escapedText, xr = c.parent.parent.parent.typeParameters;
              return xr && e.find(xr, function(ei) {
                return ei.name.escapedText === te;
              });
            }
            e.getTypeParameterFromJsDoc = Mo;
            function ho(c) {
              var te = e.lastOrUndefined(c.parameters);
              return !!te && gs(te);
            }
            e.hasRestParameter = ho;
            function gs(c) {
              var te = e.isJSDocParameterTag(c) ? c.typeExpression && c.typeExpression.type : c.type;
              return c.dotDotDotToken !== void 0 || !!te && te.kind === 318;
            }
            e.isRestParameter = gs;
            function Se(c) {
              return !!c.typeArguments;
            }
            e.hasTypeArguments = Se;
            var hr;
            (function(c) {
              c[c.None = 0] = "None", c[c.Definite = 1] = "Definite", c[c.Compound = 2] = "Compound";
            })(hr = e.AssignmentKind || (e.AssignmentKind = {}));
            function Or(c) {
              for (var te = c.parent; ; ) {
                switch (te.kind) {
                  case 221:
                    var xr = te.operatorToken.kind;
                    return Cf(xr) && te.left === c ? xr === 63 || Gu(xr) ? 1 : 2 : 0;
                  case 219:
                  case 220:
                    var ei = te.operator;
                    return ei === 45 || ei === 46 ? 2 : 0;
                  case 243:
                  case 244:
                    return te.initializer === c ? 1 : 0;
                  case 212:
                  case 204:
                  case 225:
                  case 230:
                    c = te;
                    break;
                  case 298:
                    c = te.parent;
                    break;
                  case 297:
                    if (te.name !== c) return 0;
                    c = te.parent;
                    break;
                  case 296:
                    if (te.name === c) return 0;
                    c = te.parent;
                    break;
                  default:
                    return 0;
                }
                te = c.parent;
              }
            }
            e.getAssignmentTargetKind = Or;
            function ki(c) {
              return Or(c) !== 0;
            }
            e.isAssignmentTarget = ki;
            function dt(c) {
              switch (c.kind) {
                case 235:
                case 237:
                case 248:
                case 239:
                case 249:
                case 263:
                case 289:
                case 290:
                case 250:
                case 242:
                case 243:
                case 244:
                case 240:
                case 241:
                case 252:
                case 292:
                  return true;
              }
              return false;
            }
            e.isNodeWithPossibleHoistedDeclaration = dt;
            function la(c) {
              return e.isFunctionExpression(c) || e.isArrowFunction(c) || e.isMethodOrAccessor(c) || e.isFunctionDeclaration(c) || e.isConstructorDeclaration(c);
            }
            e.isValueSignatureDeclaration = la;
            function wa(c, te) {
              for (; c && c.kind === te; ) c = c.parent;
              return c;
            }
            function On(c) {
              return wa(c, 191);
            }
            e.walkUpParenthesizedTypes = On;
            function No(c) {
              return wa(c, 212);
            }
            e.walkUpParenthesizedExpressions = No;
            function jo(c) {
              for (var te; c && c.kind === 191; ) te = c, c = c.parent;
              return [te, c];
            }
            e.walkUpParenthesizedTypesAndGetParentAndChild = jo;
            function po(c, te) {
              var xr = te ? 17 : 1;
              return e.skipOuterExpressions(c, xr);
            }
            e.skipParentheses = po;
            function Gn(c) {
              return c.kind !== 206 && c.kind !== 207 ? false : (c = No(c.parent), c && c.kind === 215);
            }
            e.isDeleteTarget = Gn;
            function $n(c, te) {
              for (; c; ) {
                if (c === te) return true;
                c = c.parent;
              }
              return false;
            }
            e.isNodeDescendantOf = $n;
            function Ho(c) {
              return !e.isSourceFile(c) && !e.isBindingPattern(c) && e.isDeclaration(c.parent) && c.parent.name === c;
            }
            e.isDeclarationName = Ho;
            function Zo(c) {
              var te = c.parent;
              switch (c.kind) {
                case 10:
                case 14:
                case 8:
                  if (e.isComputedPropertyName(te)) return te.parent;
                case 79:
                  if (e.isDeclaration(te)) return te.name === c ? te : void 0;
                  if (e.isQualifiedName(te)) {
                    var xr = te.parent;
                    return e.isJSDocParameterTag(xr) && xr.name === te ? xr : void 0;
                  } else {
                    var ei = te.parent;
                    return e.isBinaryExpression(ei) && Hr(ei) !== 0 && (ei.left.symbol || ei.symbol) && e.getNameOfDeclaration(ei) === c ? ei : void 0;
                  }
                case 80:
                  return e.isDeclaration(te) && te.name === c ? te : void 0;
                default:
                  return;
              }
            }
            e.getDeclarationFromName = Zo;
            function Es(c) {
              return ns(c) && c.parent.kind === 162 && e.isDeclaration(c.parent.parent);
            }
            e.isLiteralComputedPropertyDeclarationName = Es;
            function yc(c) {
              var te = c.parent;
              switch (te.kind) {
                case 167:
                case 166:
                case 169:
                case 168:
                case 172:
                case 173:
                case 299:
                case 296:
                case 206:
                  return te.name === c;
                case 161:
                  return te.right === c;
                case 203:
                case 270:
                  return te.propertyName === c;
                case 275:
                case 285:
                case 279:
                case 280:
                case 281:
                  return true;
              }
              return false;
            }
            e.isIdentifierName = yc;
            function Xr(c) {
              return c.kind === 265 || c.kind === 264 || c.kind === 267 && !!c.name || c.kind === 268 || c.kind === 274 || c.kind === 270 || c.kind === 275 || c.kind === 271 && zu(c) ? true : Ct(c) && (e.isBinaryExpression(c) && Hr(c) === 2 && zu(c) || e.isPropertyAccessExpression(c) && e.isBinaryExpression(c.parent) && c.parent.left === c && c.parent.operatorToken.kind === 63 && Ic(c.parent.right));
            }
            e.isAliasSymbolDeclaration = Xr;
            function Ls(c) {
              switch (c.parent.kind) {
                case 267:
                case 270:
                case 268:
                case 275:
                case 271:
                case 265:
                case 274:
                  return c.parent;
                case 161:
                  do
                    c = c.parent;
                  while (c.parent.kind === 161);
                  return Ls(c);
              }
            }
            e.getAliasDeclarationFromName = Ls;
            function Ic(c) {
              return Hu(c) || e.isClassExpression(c);
            }
            e.isAliasableExpression = Ic;
            function zu(c) {
              var te = vf(c);
              return Ic(te);
            }
            e.exportAssignmentIsAlias = zu;
            function vf(c) {
              return e.isExportAssignment(c) ? c.expression : c.right;
            }
            e.getExportAssignmentExpression = vf;
            function P_(c) {
              return c.kind === 297 ? c.name : c.kind === 296 ? c.initializer : c.parent.right;
            }
            e.getPropertyAssignmentAliasLikeExpression = P_;
            function El(c) {
              var te = vp(c);
              if (te && Ct(c)) {
                var xr = e.getJSDocAugmentsTag(c);
                if (xr) return xr.class;
              }
              return te;
            }
            e.getEffectiveBaseTypeNode = El;
            function vp(c) {
              var te = Yl(c.heritageClauses, 94);
              return te && te.types.length > 0 ? te.types[0] : void 0;
            }
            e.getClassExtendsHeritageElement = vp;
            function oo(c) {
              if (Ct(c)) return e.getJSDocImplementsTags(c).map(function(xr) {
                return xr.class;
              });
              var te = Yl(c.heritageClauses, 117);
              return te == null ? void 0 : te.types;
            }
            e.getEffectiveImplementsTypeNodes = oo;
            function I_(c) {
              return e.isInterfaceDeclaration(c) ? yp(c) || e.emptyArray : e.isClassLike(c) && e.concatenate(e.singleElementArray(El(c)), oo(c)) || e.emptyArray;
            }
            e.getAllSuperTypeNodes = I_;
            function yp(c) {
              var te = Yl(c.heritageClauses, 94);
              return te ? te.types : void 0;
            }
            e.getInterfaceBaseTypeNodes = yp;
            function Yl(c, te) {
              if (c) for (var xr = 0, ei = c; xr < ei.length; xr++) {
                var bi = ei[xr];
                if (bi.token === te) return bi;
              }
            }
            e.getHeritageClause = Yl;
            function Bf(c, te) {
              for (; c; ) {
                if (c.kind === te) return c;
                c = c.parent;
              }
            }
            e.getAncestor = Bf;
            function Cl(c) {
              return 81 <= c && c <= 160;
            }
            e.isKeyword = Cl;
            function c_(c) {
              return 126 <= c && c <= 160;
            }
            e.isContextualKeyword = c_;
            function hp(c) {
              return Cl(c) && !c_(c);
            }
            e.isNonContextualKeyword = hp;
            function gu(c) {
              return 117 <= c && c <= 125;
            }
            e.isFutureReservedKeyword = gu;
            function Dp(c) {
              var te = e.stringToToken(c);
              return te !== void 0 && hp(te);
            }
            e.isStringANonContextualKeyword = Dp;
            function sd(c) {
              var te = e.stringToToken(c);
              return te !== void 0 && Cl(te);
            }
            e.isStringAKeyword = sd;
            function Aa(c) {
              var te = c.originalKeywordKind;
              return !!te && !c_(te);
            }
            e.isIdentifierANonContextualKeyword = Aa;
            function va(c) {
              return 2 <= c && c <= 7;
            }
            e.isTrivia = va;
            var Cu;
            (function(c) {
              c[c.Normal = 0] = "Normal", c[c.Generator = 1] = "Generator", c[c.Async = 2] = "Async", c[c.Invalid = 4] = "Invalid", c[c.AsyncGenerator = 3] = "AsyncGenerator";
            })(Cu = e.FunctionFlags || (e.FunctionFlags = {}));
            function qs(c) {
              if (!c) return 4;
              var te = 0;
              switch (c.kind) {
                case 256:
                case 213:
                case 169:
                  c.asteriskToken && (te |= 1);
                case 214:
                  gc(c, 256) && (te |= 2);
                  break;
              }
              return c.body || (te |= 4), te;
            }
            e.getFunctionFlags = qs;
            function cd(c) {
              switch (c.kind) {
                case 256:
                case 213:
                case 214:
                case 169:
                  return c.body !== void 0 && c.asteriskToken === void 0 && gc(c, 256);
              }
              return false;
            }
            e.isAsyncFunction = cd;
            function ns(c) {
              return e.isStringLiteralLike(c) || e.isNumericLiteral(c);
            }
            e.isStringOrNumericLiteralLike = ns;
            function nl(c) {
              return e.isPrefixUnaryExpression(c) && (c.operator === 39 || c.operator === 40) && e.isNumericLiteral(c.operand);
            }
            e.isSignedNumericLiteral = nl;
            function hc(c) {
              var te = e.getNameOfDeclaration(c);
              return !!te && es(te);
            }
            e.hasDynamicName = hc;
            function es(c) {
              if (!(c.kind === 162 || c.kind === 207)) return false;
              var te = e.isElementAccessExpression(c) ? po(c.argumentExpression) : c.expression;
              return !ns(te) && !nl(te);
            }
            e.isDynamicName = es;
            function u_(c) {
              switch (c.kind) {
                case 79:
                case 80:
                  return c.escapedText;
                case 10:
                case 8:
                  return e.escapeLeadingUnderscores(c.text);
                case 162:
                  var te = c.expression;
                  return ns(te) ? e.escapeLeadingUnderscores(te.text) : nl(te) ? te.operator === 40 ? e.tokenToString(te.operator) + te.operand.text : te.operand.text : void 0;
                default:
                  return e.Debug.assertNever(c);
              }
            }
            e.getPropertyNameForPropertyNameNode = u_;
            function Jf(c) {
              switch (c.kind) {
                case 79:
                case 10:
                case 14:
                case 8:
                  return true;
                default:
                  return false;
              }
            }
            e.isPropertyNameLiteral = Jf;
            function w_(c) {
              return e.isMemberName(c) ? e.idText(c) : c.text;
            }
            e.getTextOfIdentifierOrLiteral = w_;
            function ud(c) {
              return e.isMemberName(c) ? c.escapedText : e.escapeLeadingUnderscores(c.text);
            }
            e.getEscapedTextOfIdentifierOrLiteral = ud;
            function ku(c) {
              return "__@".concat(e.getSymbolId(c), "@").concat(c.escapedName);
            }
            e.getPropertyNameForUniqueESSymbol = ku;
            function ld(c, te) {
              return "__#".concat(e.getSymbolId(c), "@").concat(te);
            }
            e.getSymbolNameForPrivateIdentifier = ld;
            function fd(c) {
              return e.startsWith(c.escapedName, "__@");
            }
            e.isKnownSymbol = fd;
            function bp(c) {
              return e.startsWith(c.escapedName, "__#");
            }
            e.isPrivateIdentifierSymbol = bp;
            function Sp(c) {
              return c.kind === 79 && c.escapedText === "Symbol";
            }
            e.isESSymbolIdentifier = Sp;
            function Tp(c) {
              return c.escapedText === "push" || c.escapedText === "unshift";
            }
            e.isPushOrUnshiftIdentifier = Tp;
            function _d(c) {
              var te = jf(c);
              return te.kind === 164;
            }
            e.isParameterDeclaration = _d;
            function jf(c) {
              for (; c.kind === 203; ) c = c.parent.parent;
              return c;
            }
            e.getRootDeclaration = jf;
            function O_(c) {
              var te = c.kind;
              return te === 171 || te === 213 || te === 256 || te === 214 || te === 169 || te === 172 || te === 173 || te === 261 || te === 305;
            }
            e.nodeStartsNewLexicalEnvironment = O_;
            function F_(c) {
              return Jl(c.pos) || Jl(c.end);
            }
            e.nodeIsSynthesized = F_;
            function pd(c) {
              return e.getParseTreeNode(c, e.isSourceFile) || c;
            }
            e.getOriginalSourceFile = pd;
            var xp;
            (function(c) {
              c[c.Left = 0] = "Left", c[c.Right = 1] = "Right";
            })(xp = e.Associativity || (e.Associativity = {}));
            function M_(c) {
              var te = Au(c), xr = c.kind === 209 && c.arguments !== void 0;
              return Ep(c.kind, te, xr);
            }
            e.getExpressionAssociativity = M_;
            function Ep(c, te, xr) {
              switch (c) {
                case 209:
                  return xr ? 0 : 1;
                case 219:
                case 216:
                case 217:
                case 215:
                case 218:
                case 222:
                case 224:
                  return 1;
                case 221:
                  switch (te) {
                    case 42:
                    case 63:
                    case 64:
                    case 65:
                    case 67:
                    case 66:
                    case 68:
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 78:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                      return 1;
                  }
              }
              return 0;
            }
            e.getOperatorAssociativity = Ep;
            function ol(c) {
              var te = Au(c), xr = c.kind === 209 && c.arguments !== void 0;
              return yf(c.kind, te, xr);
            }
            e.getExpressionPrecedence = ol;
            function Au(c) {
              return c.kind === 221 ? c.operatorToken.kind : c.kind === 219 || c.kind === 220 ? c.operator : c.kind;
            }
            e.getOperator = Au;
            var ru;
            (function(c) {
              c[c.Comma = 0] = "Comma", c[c.Spread = 1] = "Spread", c[c.Yield = 2] = "Yield", c[c.Assignment = 3] = "Assignment", c[c.Conditional = 4] = "Conditional", c[c.Coalesce = 4] = "Coalesce", c[c.LogicalOR = 5] = "LogicalOR", c[c.LogicalAND = 6] = "LogicalAND", c[c.BitwiseOR = 7] = "BitwiseOR", c[c.BitwiseXOR = 8] = "BitwiseXOR", c[c.BitwiseAND = 9] = "BitwiseAND", c[c.Equality = 10] = "Equality", c[c.Relational = 11] = "Relational", c[c.Shift = 12] = "Shift", c[c.Additive = 13] = "Additive", c[c.Multiplicative = 14] = "Multiplicative", c[c.Exponentiation = 15] = "Exponentiation", c[c.Unary = 16] = "Unary", c[c.Update = 17] = "Update", c[c.LeftHandSide = 18] = "LeftHandSide", c[c.Member = 19] = "Member", c[c.Primary = 20] = "Primary", c[c.Highest = 20] = "Highest", c[c.Lowest = 0] = "Lowest", c[c.Invalid = -1] = "Invalid";
            })(ru = e.OperatorPrecedence || (e.OperatorPrecedence = {}));
            function yf(c, te, xr) {
              switch (c) {
                case 351:
                  return 0;
                case 225:
                  return 1;
                case 224:
                  return 2;
                case 222:
                  return 4;
                case 221:
                  switch (te) {
                    case 27:
                      return 0;
                    case 63:
                    case 64:
                    case 65:
                    case 67:
                    case 66:
                    case 68:
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 78:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                      return 3;
                    default:
                      return Cp(te);
                  }
                case 211:
                case 230:
                case 219:
                case 216:
                case 217:
                case 215:
                case 218:
                  return 16;
                case 220:
                  return 17;
                case 208:
                  return 18;
                case 209:
                  return xr ? 19 : 18;
                case 210:
                case 206:
                case 207:
                case 231:
                  return 19;
                case 229:
                  return 11;
                case 108:
                case 106:
                case 79:
                case 80:
                case 104:
                case 110:
                case 95:
                case 8:
                case 9:
                case 10:
                case 204:
                case 205:
                case 213:
                case 214:
                case 226:
                case 13:
                case 14:
                case 223:
                case 212:
                case 227:
                case 278:
                case 279:
                case 282:
                  return 20;
                default:
                  return -1;
              }
            }
            e.getOperatorPrecedence = yf;
            function Cp(c) {
              switch (c) {
                case 60:
                  return 4;
                case 56:
                  return 5;
                case 55:
                  return 6;
                case 51:
                  return 7;
                case 52:
                  return 8;
                case 50:
                  return 9;
                case 34:
                case 35:
                case 36:
                case 37:
                  return 10;
                case 29:
                case 31:
                case 32:
                case 33:
                case 102:
                case 101:
                case 127:
                  return 11;
                case 47:
                case 48:
                case 49:
                  return 12;
                case 39:
                case 40:
                  return 13;
                case 41:
                case 43:
                case 44:
                  return 14;
                case 42:
                  return 15;
              }
              return -1;
            }
            e.getBinaryOperatorPrecedence = Cp;
            function dd(c) {
              return e.filter(c, function(te) {
                switch (te.kind) {
                  case 288:
                    return !!te.expression;
                  case 11:
                    return !te.containsOnlyTriviaWhiteSpaces;
                  default:
                    return true;
                }
              });
            }
            e.getSemanticJsxChildren = dd;
            function kp() {
              var c = [], te = [], xr = new e.Map(), ei = false;
              return { add: Ft, lookup: bi, getGlobalDiagnostics: ot, getDiagnostics: xa };
              function bi(mn) {
                var an;
                if (mn.file ? an = xr.get(mn.file.fileName) : an = c, !!an) {
                  var To = e.binarySearch(an, mn, e.identity, _g);
                  if (To >= 0) return an[To];
                }
              }
              function Ft(mn) {
                var an;
                mn.file ? (an = xr.get(mn.file.fileName), an || (an = [], xr.set(mn.file.fileName, an), e.insertSorted(te, mn.file.fileName, e.compareStringsCaseSensitive))) : (ei && (ei = false, c = c.slice()), an = c), e.insertSorted(an, mn, Qg);
              }
              function ot() {
                return ei = true, c;
              }
              function xa(mn) {
                if (mn) return xr.get(mn) || [];
                var an = e.flatMapToMutable(te, function(To) {
                  return xr.get(To);
                });
                return c.length && an.unshift.apply(an, c), an;
              }
            }
            e.createDiagnosticCollection = kp;
            var mu = /\$\{/g;
            function gd(c) {
              return c.replace(mu, "\\${");
            }
            function hf(c) {
              return c && !!(e.isNoSubstitutionTemplateLiteral(c) ? c.templateFlags : c.head.templateFlags || e.some(c.templateSpans, function(te) {
                return !!te.literal.templateFlags;
              }));
            }
            e.hasInvalidEscape = hf;
            var $l = /[\\\"\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g, Uf = /[\\\'\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g, L_ = /\r\n|[\\\`\u0000-\u001f\t\v\f\b\r\u2028\u2029\u0085]/g, l_ = new e.Map(e.getEntries({ "	": "\\t", "\v": "\\v", "\f": "\\f", "\b": "\\b", "\r": "\\r", "\n": "\\n", "\\": "\\\\", '"': '\\"', "'": "\\'", "`": "\\`", "\u2028": "\\u2028", "\u2029": "\\u2029", "\x85": "\\u0085", "\r\n": "\\r\\n" }));
            function f_(c) {
              var te = c.toString(16).toUpperCase(), xr = ("0000" + te).slice(-4);
              return "\\u" + xr;
            }
            function md(c, te, xr) {
              if (c.charCodeAt(0) === 0) {
                var ei = xr.charCodeAt(te + c.length);
                return ei >= 48 && ei <= 57 ? "\\x00" : "\\0";
              }
              return l_.get(c) || f_(c.charCodeAt(0));
            }
            function ks(c, te) {
              var xr = te === 96 ? L_ : te === 39 ? Uf : $l;
              return c.replace(xr, md);
            }
            e.escapeString = ks;
            var Wu = /[^\u0000-\u007F]/g;
            function Zl(c, te) {
              return c = ks(c, te), Wu.test(c) ? c.replace(Wu, function(xr) {
                return f_(xr.charCodeAt(0));
              }) : c;
            }
            e.escapeNonAsciiString = Zl;
            var R_ = /[\"\u0000-\u001f\u2028\u2029\u0085]/g, kl = /[\'\u0000-\u001f\u2028\u2029\u0085]/g, __ = new e.Map(e.getEntries({ '"': "&quot;", "'": "&apos;" }));
            function zd(c) {
              var te = c.toString(16).toUpperCase();
              return "&#x" + te + ";";
            }
            function Al(c) {
              return c.charCodeAt(0) === 0 ? "&#0;" : __.get(c) || zd(c.charCodeAt(0));
            }
            function wc(c, te) {
              var xr = te === 39 ? kl : R_;
              return c.replace(xr, Al);
            }
            e.escapeJsxAttributeString = wc;
            function qu(c) {
              var te = c.length;
              return te >= 2 && c.charCodeAt(0) === c.charCodeAt(te - 1) && Vu(c.charCodeAt(0)) ? c.substring(1, te - 1) : c;
            }
            e.stripQuotes = qu;
            function Vu(c) {
              return c === 39 || c === 34 || c === 96;
            }
            function ef(c) {
              var te = c.charCodeAt(0);
              return te >= 97 && te <= 122 || e.stringContains(c, "-") || e.stringContains(c, ":");
            }
            e.isIntrinsicJsxName = ef;
            var sl = ["", "    "];
            function p_(c) {
              for (var te = sl[1], xr = sl.length; xr <= c; xr++) sl.push(sl[xr - 1] + te);
              return sl[c];
            }
            e.getIndentString = p_;
            function Df() {
              return sl[1].length;
            }
            e.getIndentSize = Df;
            function Ec() {
              return e.stringContains(e.version, "-dev") || e.stringContains(e.version, "-insiders");
            }
            e.isNightly = Ec;
            function Zn(c) {
              var te, xr, ei, bi, Ft, ot = false;
              function xa(Xo) {
                var jl = e.computeLineStarts(Xo);
                jl.length > 1 ? (bi = bi + jl.length - 1, Ft = te.length - Xo.length + e.last(jl), ei = Ft - te.length === 0) : ei = false;
              }
              function mn(Xo) {
                Xo && Xo.length && (ei && (Xo = p_(xr) + Xo, ei = false), te += Xo, xa(Xo));
              }
              function an(Xo) {
                Xo && (ot = false), mn(Xo);
              }
              function To(Xo) {
                Xo && (ot = true), mn(Xo);
              }
              function Hn() {
                te = "", xr = 0, ei = true, bi = 0, Ft = 0, ot = false;
              }
              function ss(Xo) {
                Xo !== void 0 && (te += Xo, xa(Xo), ot = false);
              }
              function cs(Xo) {
                Xo && Xo.length && an(Xo);
              }
              function ws(Xo) {
                (!ei || Xo) && (te += c, bi++, Ft = te.length, ei = true, ot = false);
              }
              function nu() {
                return ei ? te.length : te.length + c.length;
              }
              return Hn(), { write: an, rawWrite: ss, writeLiteral: cs, writeLine: ws, increaseIndent: function() {
                xr++;
              }, decreaseIndent: function() {
                xr--;
              }, getIndent: function() {
                return xr;
              }, getTextPos: function() {
                return te.length;
              }, getLine: function() {
                return bi;
              }, getColumn: function() {
                return ei ? xr * Df() : te.length - Ft;
              }, getText: function() {
                return te;
              }, isAtStartOfLine: function() {
                return ei;
              }, hasTrailingComment: function() {
                return ot;
              }, hasTrailingWhitespace: function() {
                return !!te.length && e.isWhiteSpaceLike(te.charCodeAt(te.length - 1));
              }, clear: Hn, reportInaccessibleThisError: e.noop, reportPrivateInBaseOfClassExpression: e.noop, reportInaccessibleUniqueSymbolError: e.noop, trackSymbol: function() {
                return false;
              }, writeKeyword: an, writeOperator: an, writeParameter: an, writeProperty: an, writePunctuation: an, writeSpace: an, writeStringLiteral: an, writeSymbol: function(Xo, jl) {
                return an(Xo);
              }, writeTrailingSemicolon: an, writeComment: To, getTextPosWithWriteLine: nu };
            }
            e.createTextWriter = Zn;
            function os(c) {
              var te = false;
              function xr() {
                te && (c.writeTrailingSemicolon(";"), te = false);
              }
              return Ke(Ke({}, c), { writeTrailingSemicolon: function() {
                te = true;
              }, writeLiteral: function(ei) {
                xr(), c.writeLiteral(ei);
              }, writeStringLiteral: function(ei) {
                xr(), c.writeStringLiteral(ei);
              }, writeSymbol: function(ei, bi) {
                xr(), c.writeSymbol(ei, bi);
              }, writePunctuation: function(ei) {
                xr(), c.writePunctuation(ei);
              }, writeKeyword: function(ei) {
                xr(), c.writeKeyword(ei);
              }, writeOperator: function(ei) {
                xr(), c.writeOperator(ei);
              }, writeParameter: function(ei) {
                xr(), c.writeParameter(ei);
              }, writeSpace: function(ei) {
                xr(), c.writeSpace(ei);
              }, writeProperty: function(ei) {
                xr(), c.writeProperty(ei);
              }, writeComment: function(ei) {
                xr(), c.writeComment(ei);
              }, writeLine: function() {
                xr(), c.writeLine();
              }, increaseIndent: function() {
                xr(), c.increaseIndent();
              }, decreaseIndent: function() {
                xr(), c.decreaseIndent();
              } });
            }
            e.getTrailingSemicolonDeferringWriter = os;
            function Ps(c) {
              return c.useCaseSensitiveFileNames ? c.useCaseSensitiveFileNames() : false;
            }
            e.hostUsesCaseSensitiveFileNames = Ps;
            function d_(c) {
              return e.createGetCanonicalFileName(Ps(c));
            }
            e.hostGetCanonicalFileName = d_;
            function Gc(c, te, xr) {
              return te.moduleName || Gt(c, te.fileName, xr && xr.fileName);
            }
            e.getResolvedExternalModuleName = Gc;
            function B_(c, te) {
              return c.getCanonicalFileName(e.getNormalizedAbsolutePath(te, c.getCurrentDirectory()));
            }
            function vu(c, te, xr) {
              var ei = te.getExternalModuleFileFromDeclaration(xr);
              if (!(!ei || ei.isDeclarationFile)) {
                var bi = eu(xr);
                if (!(bi && e.isStringLiteralLike(bi) && !e.pathIsRelative(bi.text) && B_(c, ei.path).indexOf(B_(c, e.ensureTrailingDirectorySeparator(c.getCommonSourceDirectory()))) === -1)) return Gc(c, ei);
              }
            }
            e.getExternalModuleNameFromDeclaration = vu;
            function Gt(c, te, xr) {
              var ei = function(mn) {
                return c.getCanonicalFileName(mn);
              }, bi = e.toPath(xr ? e.getDirectoryPath(xr) : c.getCommonSourceDirectory(), c.getCurrentDirectory(), ei), Ft = e.getNormalizedAbsolutePath(te, c.getCurrentDirectory()), ot = e.getRelativePathToDirectoryOrUrl(bi, Ft, bi, ei, false), xa = Gd(ot);
              return xr ? e.ensurePathIsNonModuleName(xa) : xa;
            }
            e.getExternalModuleNameFromPath = Gt;
            function As(c, te, xr) {
              var ei = te.getCompilerOptions(), bi;
              return ei.outDir ? bi = Gd(Dc(c, te, ei.outDir)) : bi = Gd(c), bi + xr;
            }
            e.getOwnEmitOutputFilePath = As;
            function vn(c, te) {
              return Nl(c, te.getCompilerOptions(), te.getCurrentDirectory(), te.getCommonSourceDirectory(), function(xr) {
                return te.getCanonicalFileName(xr);
              });
            }
            e.getDeclarationEmitOutputFilePath = vn;
            function Nl(c, te, xr, ei, bi) {
              var Ft = te.declarationDir || te.outDir, ot = Ft ? Cc(c, Ft, xr, ei, bi) : c, xa = cl(ot);
              return Gd(ot) + xa;
            }
            e.getDeclarationEmitOutputFilePathWorker = Nl;
            function cl(c) {
              return e.fileExtensionIsOneOf(c, [".mjs", ".mts"]) ? ".d.mts" : e.fileExtensionIsOneOf(c, [".cjs", ".cts"]) ? ".d.cts" : e.fileExtensionIsOneOf(c, [".json"]) ? ".json.d.ts" : ".d.ts";
            }
            e.getDeclarationEmitExtensionForPath = cl;
            function rf(c) {
              return e.fileExtensionIsOneOf(c, [".d.mts", ".mjs", ".mts"]) ? [".mts", ".mjs"] : e.fileExtensionIsOneOf(c, [".d.cts", ".cjs", ".cts"]) ? [".cts", ".cjs"] : e.fileExtensionIsOneOf(c, [".json.d.ts"]) ? [".json"] : [".tsx", ".ts", ".jsx", ".js"];
            }
            e.getPossibleOriginalInputExtensionForExtension = rf;
            function Ut(c) {
              return c.outFile || c.out;
            }
            e.outFile = Ut;
            function Ds(c, te) {
              var xr, ei;
              if (!!c.paths) return (xr = c.baseUrl) !== null && xr !== void 0 ? xr : e.Debug.checkDefined(c.pathsBasePath || ((ei = te.getCurrentDirectory) === null || ei === void 0 ? void 0 : ei.call(te)), "Encountered 'paths' without a 'baseUrl', config file, or host 'getCurrentDirectory'.");
            }
            e.getPathsBasePath = Ds;
            function bf(c, te, xr) {
              var ei = c.getCompilerOptions();
              if (Ut(ei)) {
                var bi = Ja(ei), Ft = ei.emitDeclarationOnly || bi === e.ModuleKind.AMD || bi === e.ModuleKind.System;
                return e.filter(c.getSourceFiles(), function(xa) {
                  return (Ft || !e.isExternalModule(xa)) && bs(xa, c, xr);
                });
              } else {
                var ot = te === void 0 ? c.getSourceFiles() : [te];
                return e.filter(ot, function(xa) {
                  return bs(xa, c, xr);
                });
              }
            }
            e.getSourceFilesToEmit = bf;
            function bs(c, te, xr) {
              var ei = te.getCompilerOptions();
              return !(ei.noEmitForJsFiles && Pi(c)) && !c.isDeclarationFile && !te.isSourceFileFromExternalLibrary(c) && (xr || !(Mr(c) && te.getResolvedProjectReferenceToRedirect(c.fileName)) && !te.isSourceOfProjectReferenceRedirect(c.fileName));
            }
            e.sourceFileMayBeEmitted = bs;
            function Dc(c, te, xr) {
              return Cc(c, xr, te.getCurrentDirectory(), te.getCommonSourceDirectory(), function(ei) {
                return te.getCanonicalFileName(ei);
              });
            }
            e.getSourceFilePathInNewDir = Dc;
            function Cc(c, te, xr, ei, bi) {
              var Ft = e.getNormalizedAbsolutePath(c, xr), ot = bi(Ft).indexOf(bi(ei)) === 0;
              return Ft = ot ? Ft.substring(ei.length) : Ft, e.combinePaths(te, Ft);
            }
            e.getSourceFilePathInNewDirWorker = Cc;
            function ac(c, te, xr, ei, bi, Ft, ot) {
              c.writeFile(xr, ei, bi, function(xa) {
                te.add(qd(e.Diagnostics.Could_not_write_file_0_Colon_1, xr, xa));
              }, Ft, ot);
            }
            e.writeFile = ac;
            function Pl(c, te, xr) {
              if (c.length > e.getRootLength(c) && !xr(c)) {
                var ei = e.getDirectoryPath(c);
                Pl(ei, te, xr), te(c);
              }
            }
            function Il(c, te, xr, ei, bi, Ft) {
              try {
                ei(c, te, xr);
              } catch {
                Pl(e.getDirectoryPath(e.normalizePath(c)), bi, Ft), ei(c, te, xr);
              }
            }
            e.writeFileEnsuringDirectories = Il;
            function zf(c, te) {
              var xr = e.getLineStarts(c);
              return e.computeLineOfPosition(xr, te);
            }
            e.getLineOfLocalPosition = zf;
            function ul(c, te) {
              return e.computeLineOfPosition(c, te);
            }
            e.getLineOfLocalPositionFromLineMap = ul;
            function Nu(c) {
              return e.find(c.members, function(te) {
                return e.isConstructorDeclaration(te) && j(te.body);
              });
            }
            e.getFirstConstructorWithBody = Nu;
            function Us(c) {
              if (c && c.parameters.length > 0) {
                var te = c.parameters.length === 2 && Sf(c.parameters[0]);
                return c.parameters[te ? 1 : 0];
              }
            }
            e.getSetAccessorValueParameter = Us;
            function Ap(c) {
              var te = Us(c);
              return te && te.type;
            }
            e.getSetAccessorTypeAnnotationNode = Ap;
            function Wf(c) {
              if (c.parameters.length && !e.isJSDocSignature(c)) {
                var te = c.parameters[0];
                if (Sf(te)) return te;
              }
            }
            e.getThisParameter = Wf;
            function Sf(c) {
              return ll(c.name);
            }
            e.parameterIsThisKeyword = Sf;
            function ll(c) {
              return !!c && c.kind === 79 && j_(c);
            }
            e.isThisIdentifier = ll;
            function J_(c) {
              if (!ll(c)) return false;
              for (; e.isQualifiedName(c.parent) && c.parent.left === c; ) c = c.parent;
              return c.parent.kind === 181;
            }
            e.isThisInTypeQuery = J_;
            function j_(c) {
              return c.originalKeywordKind === 108;
            }
            e.identifierIsThisKeyword = j_;
            function U_(c, te) {
              var xr, ei, bi, Ft;
              return hc(te) ? (xr = te, te.kind === 172 ? bi = te : te.kind === 173 ? Ft = te : e.Debug.fail("Accessor has wrong kind")) : e.forEach(c, function(ot) {
                if (e.isAccessor(ot) && Tf(ot) === Tf(te)) {
                  var xa = u_(ot.name), mn = u_(te.name);
                  xa === mn && (xr ? ei || (ei = ot) : xr = ot, ot.kind === 172 && !bi && (bi = ot), ot.kind === 173 && !Ft && (Ft = ot));
                }
              }), { firstAccessor: xr, secondAccessor: ei, getAccessor: bi, setAccessor: Ft };
            }
            e.getAllAccessorDeclarations = U_;
            function iu(c) {
              if (!(!Ct(c) && e.isFunctionDeclaration(c))) {
                var te = c.type;
                return te || !Ct(c) ? te : e.isJSDocPropertyLikeTag(c) ? c.typeExpression && c.typeExpression.type : e.getJSDocType(c);
              }
            }
            e.getEffectiveTypeAnnotationNode = iu;
            function vd(c) {
              return c.type;
            }
            e.getTypeAnnotationNode = vd;
            function qf(c) {
              return e.isJSDocSignature(c) ? c.type && c.type.typeExpression && c.type.typeExpression.type : c.type || (Ct(c) ? e.getJSDocReturnType(c) : void 0);
            }
            e.getEffectiveReturnTypeNode = qf;
            function dc(c) {
              return e.flatMap(e.getJSDocTags(c), function(te) {
                return Pu(te) ? te.typeParameters : void 0;
              });
            }
            e.getJSDocTypeParameterDeclarations = dc;
            function Pu(c) {
              return e.isJSDocTemplateTag(c) && !(c.parent.kind === 320 && c.parent.tags.some(Ya));
            }
            function wl(c) {
              var te = Us(c);
              return te && iu(te);
            }
            e.getEffectiveSetAccessorTypeAnnotationNode = wl;
            function Iu(c, te, xr, ei) {
              so(c, te, xr.pos, ei);
            }
            e.emitNewLineBeforeLeadingComments = Iu;
            function so(c, te, xr, ei) {
              ei && ei.length && xr !== ei[0].pos && ul(c, xr) !== ul(c, ei[0].pos) && te.writeLine();
            }
            e.emitNewLineBeforeLeadingCommentsOfPosition = so;
            function Et(c, te, xr, ei) {
              xr !== ei && ul(c, xr) !== ul(c, ei) && te.writeLine();
            }
            e.emitNewLineBeforeLeadingCommentOfPosition = Et;
            function Ys(c, te, xr, ei, bi, Ft, ot, xa) {
              if (ei && ei.length > 0) {
                bi && xr.writeSpace(" ");
                for (var mn = false, an = 0, To = ei; an < To.length; an++) {
                  var Hn = To[an];
                  mn && (xr.writeSpace(" "), mn = false), xa(c, te, xr, Hn.pos, Hn.end, ot), Hn.hasTrailingNewLine ? xr.writeLine() : mn = true;
                }
                mn && Ft && xr.writeSpace(" ");
              }
            }
            e.emitComments = Ys;
            function Ku(c, te, xr, ei, bi, Ft, ot) {
              var xa, mn;
              if (ot ? bi.pos === 0 && (xa = e.filter(e.getLeadingCommentRanges(c, bi.pos), jl)) : xa = e.getLeadingCommentRanges(c, bi.pos), xa) {
                for (var an = [], To = void 0, Hn = 0, ss = xa; Hn < ss.length; Hn++) {
                  var cs = ss[Hn];
                  if (To) {
                    var ws = ul(te, To.end), nu = ul(te, cs.pos);
                    if (nu >= ws + 2) break;
                  }
                  an.push(cs), To = cs;
                }
                if (an.length) {
                  var ws = ul(te, e.last(an).end), Xo = ul(te, e.skipTrivia(c, bi.pos));
                  Xo >= ws + 2 && (Iu(te, xr, bi, xa), Ys(c, te, xr, an, false, true, Ft, ei), mn = { nodePos: bi.pos, detachedCommentEndPos: e.last(an).end });
                }
              }
              return mn;
              function jl(Y_) {
                return ue(c, Y_.pos);
              }
            }
            e.emitDetachedComments = Ku;
            function Np(c, te, xr, ei, bi, Ft) {
              if (c.charCodeAt(ei + 1) === 42) for (var ot = e.computeLineAndCharacterOfPosition(te, ei), xa = te.length, mn = void 0, an = ei, To = ot.line; an < bi; To++) {
                var Hn = To + 1 === xa ? c.length + 1 : te[To + 1];
                if (an !== ei) {
                  mn === void 0 && (mn = nc(c, te[ot.line], ei));
                  var ss = xr.getIndent() * Df(), cs = ss - mn + nc(c, an, Hn);
                  if (cs > 0) {
                    var ws = cs % Df(), nu = p_((cs - ws) / Df());
                    for (xr.rawWrite(nu); ws; ) xr.rawWrite(" "), ws--;
                  } else xr.rawWrite("");
                }
                Pp(c, bi, xr, Ft, an, Hn), an = Hn;
              }
              else xr.writeComment(c.substring(ei, bi));
            }
            e.writeCommentRange = Np;
            function Pp(c, te, xr, ei, bi, Ft) {
              var ot = Math.min(te, Ft - 1), xa = e.trimString(c.substring(bi, ot));
              xa ? (xr.writeComment(xa), ot !== te && xr.writeLine()) : xr.rawWrite(ei);
            }
            function nc(c, te, xr) {
              for (var ei = 0; te < xr && e.isWhiteSpaceSingleLine(c.charCodeAt(te)); te++) c.charCodeAt(te) === 9 ? ei += Df() - ei % Df() : ei++;
              return ei;
            }
            function fl(c) {
              return xf(c) !== 0;
            }
            e.hasEffectiveModifiers = fl;
            function _l(c) {
              return Oc(c) !== 0;
            }
            e.hasSyntacticModifiers = _l;
            function cu(c, te) {
              return !!Hc(c, te);
            }
            e.hasEffectiveModifier = cu;
            function gc(c, te) {
              return !!Ol(c, te);
            }
            e.hasSyntacticModifier = gc;
            function Tf(c) {
              return e.isClassElement(c) && mc(c) || e.isClassStaticBlockDeclaration(c);
            }
            e.isStatic = Tf;
            function mc(c) {
              return gc(c, 32);
            }
            e.hasStaticModifier = mc;
            function Ip(c) {
              return cu(c, 16384);
            }
            e.hasOverrideModifier = Ip;
            function ms(c) {
              return gc(c, 128);
            }
            e.hasAbstractModifier = ms;
            function tu(c) {
              return gc(c, 2);
            }
            e.hasAmbientModifier = tu;
            function wp(c) {
              return cu(c, 64);
            }
            e.hasEffectiveReadonlyModifier = wp;
            function Hc(c, te) {
              return xf(c) & te;
            }
            e.getSelectedEffectiveModifierFlags = Hc;
            function Ol(c, te) {
              return Oc(c) & te;
            }
            e.getSelectedSyntacticModifierFlags = Ol;
            function tf(c, te, xr) {
              return c.kind >= 0 && c.kind <= 160 ? 0 : (c.modifierFlagsCache & 536870912 || (c.modifierFlagsCache = Ef(c) | 536870912), te && !(c.modifierFlagsCache & 4096) && (xr || Ct(c)) && c.parent && (c.modifierFlagsCache |= rs(c) | 4096), c.modifierFlagsCache & -536875009);
            }
            function xf(c) {
              return tf(c, true);
            }
            e.getEffectiveModifierFlags = xf;
            function z_(c) {
              return tf(c, true, true);
            }
            e.getEffectiveModifierFlagsAlwaysIncludeJSDoc = z_;
            function Oc(c) {
              return tf(c, false);
            }
            e.getSyntacticModifierFlags = Oc;
            function rs(c) {
              var te = 0;
              return !!c.parent && !e.isParameter(c) && (Ct(c) && (e.getJSDocPublicTagNoCache(c) && (te |= 4), e.getJSDocPrivateTagNoCache(c) && (te |= 8), e.getJSDocProtectedTagNoCache(c) && (te |= 16), e.getJSDocReadonlyTagNoCache(c) && (te |= 64), e.getJSDocOverrideTagNoCache(c) && (te |= 16384)), e.getJSDocDeprecatedTagNoCache(c) && (te |= 8192)), te;
            }
            function Op(c) {
              return Ef(c) | rs(c);
            }
            e.getEffectiveModifierFlagsNoCache = Op;
            function Ef(c) {
              var te = Fl(c.modifiers);
              return (c.flags & 4 || c.kind === 79 && c.isInJSDocNamespace) && (te |= 1), te;
            }
            e.getSyntacticModifierFlagsNoCache = Ef;
            function Fl(c) {
              var te = 0;
              if (c) for (var xr = 0, ei = c; xr < ei.length; xr++) {
                var bi = ei[xr];
                te |= pl(bi.kind);
              }
              return te;
            }
            e.modifiersToFlags = Fl;
            function pl(c) {
              switch (c) {
                case 124:
                  return 32;
                case 123:
                  return 4;
                case 122:
                  return 16;
                case 121:
                  return 8;
                case 126:
                  return 128;
                case 93:
                  return 1;
                case 135:
                  return 2;
                case 85:
                  return 2048;
                case 88:
                  return 512;
                case 131:
                  return 256;
                case 145:
                  return 64;
                case 159:
                  return 16384;
                case 101:
                  return 32768;
                case 144:
                  return 65536;
              }
              return 0;
            }
            e.modifierToFlag = pl;
            function Fp(c) {
              return c ? e.factory.createNodeArray(e.factory.createModifiersFromModifierFlags(c)) : void 0;
            }
            e.createModifiers = Fp;
            function Mp(c) {
              return c === 56 || c === 55 || c === 53;
            }
            e.isLogicalOperator = Mp;
            function Gu(c) {
              return c === 75 || c === 76 || c === 77;
            }
            e.isLogicalOrCoalescingAssignmentOperator = Gu;
            function Lp(c) {
              return Gu(c.operatorToken.kind);
            }
            e.isLogicalOrCoalescingAssignmentExpression = Lp;
            function Cf(c) {
              return c >= 63 && c <= 78;
            }
            e.isAssignmentOperator = Cf;
            function W_(c) {
              var te = g_(c);
              return te && !te.isImplements ? te.class : void 0;
            }
            e.tryGetClassExtendingExpressionWithTypeArguments = W_;
            function g_(c) {
              return e.isExpressionWithTypeArguments(c) && e.isHeritageClause(c.parent) && e.isClassLike(c.parent.parent) ? { class: c.parent.parent, isImplements: c.parent.token === 117 } : void 0;
            }
            e.tryGetClassImplementingOrExtendingExpressionWithTypeArguments = g_;
            function dl(c, te) {
              return e.isBinaryExpression(c) && (te ? c.operatorToken.kind === 63 : Cf(c.operatorToken.kind)) && e.isLeftHandSideExpression(c.left);
            }
            e.isAssignmentExpression = dl;
            function gl(c) {
              return dl(c.parent) && c.parent.left === c;
            }
            e.isLeftHandSideOfAssignment = gl;
            function Vf(c) {
              if (dl(c, true)) {
                var te = c.left.kind;
                return te === 205 || te === 204;
              }
              return false;
            }
            e.isDestructuringAssignment = Vf;
            function Fc(c) {
              return W_(c) !== void 0;
            }
            e.isExpressionWithTypeArgumentsInClassExtendsClause = Fc;
            function Hu(c) {
              return c.kind === 79 || Ml(c);
            }
            e.isEntityNameExpression = Hu;
            function af(c) {
              switch (c.kind) {
                case 79:
                  return c;
                case 161:
                  do
                    c = c.left;
                  while (c.kind !== 79);
                  return c;
                case 206:
                  do
                    c = c.expression;
                  while (c.kind !== 79);
                  return c;
              }
            }
            e.getFirstIdentifier = af;
            function tn(c) {
              return c.kind === 79 || c.kind === 108 || c.kind === 106 || c.kind === 231 || c.kind === 206 && tn(c.expression) || c.kind === 212 && tn(c.expression);
            }
            e.isDottedName = tn;
            function Ml(c) {
              return e.isPropertyAccessExpression(c) && e.isIdentifier(c.name) && Hu(c.expression);
            }
            e.isPropertyAccessEntityNameExpression = Ml;
            function Ot(c) {
              if (e.isPropertyAccessExpression(c)) {
                var te = Ot(c.expression);
                if (te !== void 0) return te + "." + Xe(c.name);
              } else if (e.isElementAccessExpression(c)) {
                var te = Ot(c.expression);
                if (te !== void 0 && e.isPropertyName(c.argumentExpression)) return te + "." + u_(c.argumentExpression);
              } else if (e.isIdentifier(c)) return e.unescapeLeadingUnderscores(c.escapedText);
            }
            e.tryGetPropertyAccessOrIdentifierToString = Ot;
            function nf(c) {
              return ua(c) && Ao(c) === "prototype";
            }
            e.isPrototypeAccess = nf;
            function q_(c) {
              return c.parent.kind === 161 && c.parent.right === c || c.parent.kind === 206 && c.parent.name === c;
            }
            e.isRightSideOfQualifiedNameOrPropertyAccess = q_;
            function Kf(c) {
              return e.isPropertyAccessExpression(c.parent) && c.parent.name === c || e.isElementAccessExpression(c.parent) && c.parent.argumentExpression === c;
            }
            e.isRightSideOfAccessExpression = Kf;
            function Rp(c) {
              return e.isQualifiedName(c.parent) && c.parent.right === c || e.isPropertyAccessExpression(c.parent) && c.parent.name === c || e.isJSDocMemberName(c.parent) && c.parent.right === c;
            }
            e.isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName = Rp;
            function yd(c) {
              return c.kind === 205 && c.properties.length === 0;
            }
            e.isEmptyObjectLiteral = yd;
            function m_(c) {
              return c.kind === 204 && c.elements.length === 0;
            }
            e.isEmptyArrayLiteral = m_;
            function Ll(c) {
              if (!(!hd(c) || !c.declarations)) for (var te = 0, xr = c.declarations; te < xr.length; te++) {
                var ei = xr[te];
                if (ei.localSymbol) return ei.localSymbol;
              }
            }
            e.getLocalSymbolForExportDefault = Ll;
            function hd(c) {
              return c && e.length(c.declarations) > 0 && gc(c.declarations[0], 512);
            }
            function v_(c) {
              return e.find(oh, function(te) {
                return e.fileExtensionIs(c, te);
              });
            }
            e.tryExtractTSExtension = v_;
            function Bp(c) {
              for (var te = [], xr = c.length, ei = 0; ei < xr; ei++) {
                var bi = c.charCodeAt(ei);
                bi < 128 ? te.push(bi) : bi < 2048 ? (te.push(bi >> 6 | 192), te.push(bi & 63 | 128)) : bi < 65536 ? (te.push(bi >> 12 | 224), te.push(bi >> 6 & 63 | 128), te.push(bi & 63 | 128)) : bi < 131072 ? (te.push(bi >> 18 | 240), te.push(bi >> 12 & 63 | 128), te.push(bi >> 6 & 63 | 128), te.push(bi & 63 | 128)) : e.Debug.assert(false, "Unexpected code point");
              }
              return te;
            }
            var Xu = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
            function Xc(c) {
              for (var te = "", xr = Bp(c), ei = 0, bi = xr.length, Ft, ot, xa, mn; ei < bi; ) Ft = xr[ei] >> 2, ot = (xr[ei] & 3) << 4 | xr[ei + 1] >> 4, xa = (xr[ei + 1] & 15) << 2 | xr[ei + 2] >> 6, mn = xr[ei + 2] & 63, ei + 1 >= bi ? xa = mn = 64 : ei + 2 >= bi && (mn = 64), te += Xu.charAt(Ft) + Xu.charAt(ot) + Xu.charAt(xa) + Xu.charAt(mn), ei += 3;
              return te;
            }
            e.convertToBase64 = Xc;
            function Gf(c) {
              for (var te = "", xr = 0, ei = c.length; xr < ei; ) {
                var bi = c[xr];
                if (bi < 128) te += String.fromCharCode(bi), xr++;
                else if ((bi & 192) === 192) {
                  var Ft = bi & 63;
                  xr++;
                  for (var ot = c[xr]; (ot & 192) === 128; ) Ft = Ft << 6 | ot & 63, xr++, ot = c[xr];
                  te += String.fromCharCode(Ft);
                } else te += String.fromCharCode(bi), xr++;
              }
              return te;
            }
            function of(c, te) {
              return c && c.base64encode ? c.base64encode(te) : Xc(te);
            }
            e.base64encode = of;
            function wu(c, te) {
              if (c && c.base64decode) return c.base64decode(te);
              for (var xr = te.length, ei = [], bi = 0; bi < xr && te.charCodeAt(bi) !== Xu.charCodeAt(64); ) {
                var Ft = Xu.indexOf(te[bi]), ot = Xu.indexOf(te[bi + 1]), xa = Xu.indexOf(te[bi + 2]), mn = Xu.indexOf(te[bi + 3]), an = (Ft & 63) << 2 | ot >> 4 & 3, To = (ot & 15) << 4 | xa >> 2 & 15, Hn = (xa & 3) << 6 | mn & 63;
                To === 0 && xa !== 0 ? ei.push(an) : Hn === 0 && mn !== 0 ? ei.push(an, To) : ei.push(an, To, Hn), bi += 4;
              }
              return Gf(ei);
            }
            e.base64decode = wu;
            function V_(c, te) {
              try {
                var xr = te.readFile(c);
                if (!xr) return {};
                var ei = e.parseConfigFileTextToJson(c, xr);
                return ei.error ? {} : ei.config;
              } catch {
                return {};
              }
            }
            e.readJson = V_;
            function yu(c, te) {
              return !te.directoryExists || te.directoryExists(c);
            }
            e.directoryProbablyExists = yu;
            var v = `\r
`, sr = `
`;
            function fi(c, te) {
              switch (c.newLine) {
                case 0:
                  return v;
                case 1:
                  return sr;
              }
              return te ? te() : e.sys ? e.sys.newLine : v;
            }
            e.getNewLineCharacter = fi;
            function zi(c, te) {
              return te === void 0 && (te = c), e.Debug.assert(te >= c || te === -1), { pos: c, end: te };
            }
            e.createRange = zi;
            function Sa(c, te) {
              return zi(c.pos, te);
            }
            e.moveRangeEnd = Sa;
            function da(c, te) {
              return zi(te, c.end);
            }
            e.moveRangePos = da;
            function Ha(c) {
              return c.decorators && c.decorators.length > 0 ? da(c, c.decorators.end) : c;
            }
            e.moveRangePastDecorators = Ha;
            function ta(c) {
              return c.modifiers && c.modifiers.length > 0 ? da(c, c.modifiers.end) : Ha(c);
            }
            e.moveRangePastModifiers = ta;
            function nn(c) {
              return c.pos === c.end;
            }
            e.isCollapsedRange = nn;
            function Wo(c, te) {
              return zi(c, c + e.tokenToString(te).length);
            }
            e.createTokenRange = Wo;
            function Lo(c, te) {
              return is(c, c, te);
            }
            e.rangeIsOnSingleLine = Lo;
            function oc(c, te, xr) {
              return cf(uf(c, xr, false), uf(te, xr, false), xr);
            }
            e.rangeStartPositionsAreOnSameLine = oc;
            function uu(c, te, xr) {
              return cf(c.end, te.end, xr);
            }
            e.rangeEndPositionsAreOnSameLine = uu;
            function is(c, te, xr) {
              return cf(uf(c, xr, false), te.end, xr);
            }
            e.rangeStartIsOnSameLineAsRangeEnd = is;
            function au(c, te, xr) {
              return cf(c.end, uf(te, xr, false), xr);
            }
            e.rangeEndIsOnSameLineAsRangeStart = au;
            function Ou(c, te, xr, ei) {
              var bi = uf(te, xr, ei);
              return e.getLinesBetweenPositions(xr, c.end, bi);
            }
            e.getLinesBetweenRangeEndAndRangeStart = Ou;
            function sf(c, te, xr) {
              return e.getLinesBetweenPositions(xr, c.end, te.end);
            }
            e.getLinesBetweenRangeEndPositions = sf;
            function lu(c, te) {
              return !cf(c.pos, c.end, te);
            }
            e.isNodeArrayMultiLine = lu;
            function cf(c, te, xr) {
              return e.getLinesBetweenPositions(xr, c, te) === 0;
            }
            e.positionsAreOnSameLine = cf;
            function uf(c, te, xr) {
              return Jl(c.pos) ? -1 : e.skipTrivia(te.text, c.pos, false, xr);
            }
            e.getStartPositionOfRange = uf;
            function K_(c, te, xr, ei) {
              var bi = e.skipTrivia(xr.text, c, false, ei), Ft = Hf(bi, te, xr);
              return e.getLinesBetweenPositions(xr, Ft != null ? Ft : te, bi);
            }
            e.getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter = K_;
            function Jp(c, te, xr, ei) {
              var bi = e.skipTrivia(xr.text, c, false, ei);
              return e.getLinesBetweenPositions(xr, c, Math.min(te, bi));
            }
            e.getLinesBetweenPositionAndNextNonWhitespaceCharacter = Jp;
            function Hf(c, te, xr) {
              for (te === void 0 && (te = 0); c-- > te; ) if (!e.isWhiteSpaceLike(xr.text.charCodeAt(c))) return c;
            }
            function kc(c) {
              var te = e.getParseTreeNode(c);
              if (te) switch (te.parent.kind) {
                case 260:
                case 261:
                  return te === te.parent.name;
              }
              return false;
            }
            e.isDeclarationNameOfEnumOrNamespace = kc;
            function G_(c) {
              return e.filter(c.declarations, Le);
            }
            e.getInitializedVariables = G_;
            function Le(c) {
              return c.initializer !== void 0;
            }
            function Nr(c) {
              return c.watch && c.hasOwnProperty("watch");
            }
            e.isWatchSet = Nr;
            function ri(c) {
              c.close();
            }
            e.closeFileWatcher = ri;
            function di(c) {
              return c.flags & 33554432 ? c.checkFlags : 0;
            }
            e.getCheckFlags = di;
            function Mi(c, te) {
              if (te === void 0 && (te = false), c.valueDeclaration) {
                var xr = te && c.declarations && e.find(c.declarations, function(xa) {
                  return xa.kind === 173;
                }) || c.valueDeclaration, ei = e.getCombinedModifierFlags(xr);
                return c.parent && c.parent.flags & 32 ? ei : ei & -29;
              }
              if (di(c) & 6) {
                var bi = c.checkFlags, Ft = bi & 1024 ? 8 : bi & 256 ? 4 : 16, ot = bi & 2048 ? 32 : 0;
                return Ft | ot;
              }
              return c.flags & 4194304 ? 36 : 0;
            }
            e.getDeclarationModifierFlagsFromSymbol = Mi;
            function st(c, te) {
              return c.flags & 2097152 ? te.getAliasedSymbol(c) : c;
            }
            e.skipAlias = st;
            function ra(c) {
              return c.exportSymbol ? c.exportSymbol.flags | c.flags : c.flags;
            }
            e.getCombinedLocalAndExportSymbolFlags = ra;
            function Ta(c) {
              return In(c) === 1;
            }
            e.isWriteOnlyAccess = Ta;
            function ha(c) {
              return In(c) !== 0;
            }
            e.isWriteAccess = ha;
            var Na;
            (function(c) {
              c[c.Read = 0] = "Read", c[c.Write = 1] = "Write", c[c.ReadWrite = 2] = "ReadWrite";
            })(Na || (Na = {}));
            function In(c) {
              var te = c.parent;
              if (!te) return 0;
              switch (te.kind) {
                case 212:
                  return In(te);
                case 220:
                case 219:
                  var xr = te.operator;
                  return xr === 45 || xr === 46 ? xa() : 0;
                case 221:
                  var ei = te, bi = ei.left, Ft = ei.operatorToken;
                  return bi === c && Cf(Ft.kind) ? Ft.kind === 63 ? 1 : xa() : 0;
                case 206:
                  return te.name !== c ? 0 : In(te);
                case 296: {
                  var ot = In(te.parent);
                  return c === te.name ? qo(ot) : ot;
                }
                case 297:
                  return c === te.objectAssignmentInitializer ? 0 : In(te.parent);
                case 204:
                  return In(te);
                default:
                  return 0;
              }
              function xa() {
                return te.parent && No(te.parent).kind === 238 ? 1 : 2;
              }
            }
            function qo(c) {
              switch (c) {
                case 0:
                  return 1;
                case 1:
                  return 0;
                case 2:
                  return 2;
                default:
                  return e.Debug.assertNever(c);
              }
            }
            function co(c, te) {
              if (!c || !te || Object.keys(c).length !== Object.keys(te).length) return false;
              for (var xr in c) if (typeof c[xr] == "object") {
                if (!co(c[xr], te[xr])) return false;
              } else if (typeof c[xr] != "function" && c[xr] !== te[xr]) return false;
              return true;
            }
            e.compareDataObjects = co;
            function ts(c, te) {
              c.forEach(te), c.clear();
            }
            e.clearMap = ts;
            function vs(c, te, xr) {
              var ei = xr.onDeleteValue, bi = xr.onExistingValue;
              c.forEach(function(Ft, ot) {
                var xa = te.get(ot);
                xa === void 0 ? (c.delete(ot), ei(Ft, ot)) : bi && bi(Ft, xa, ot);
              });
            }
            e.mutateMapSkippingNewValues = vs;
            function Ac(c, te, xr) {
              vs(c, te, xr);
              var ei = xr.createNewValue;
              te.forEach(function(bi, Ft) {
                c.has(Ft) || c.set(Ft, ei(Ft, bi));
              });
            }
            e.mutateMap = Ac;
            function Is(c) {
              if (c.flags & 32) {
                var te = Qu(c);
                return !!te && gc(te, 128);
              }
              return false;
            }
            e.isAbstractConstructorSymbol = Is;
            function Qu(c) {
              var te;
              return (te = c.declarations) === null || te === void 0 ? void 0 : te.find(e.isClassLike);
            }
            e.getClassLikeDeclarationOfSymbol = Qu;
            function sc(c) {
              return c.flags & 3899393 ? c.objectFlags : 0;
            }
            e.getObjectFlags = sc;
            function bc(c, te) {
              return te.getSignaturesOfType(c, 0).length !== 0 || te.getSignaturesOfType(c, 1).length !== 0;
            }
            e.typeHasCallOrConstructSignatures = bc;
            function Mc(c, te) {
              return !!e.forEachAncestorDirectory(c, function(xr) {
                return te(xr) ? true : void 0;
              });
            }
            e.forSomeAncestorDirectory = Mc;
            function Yu(c) {
              return !!c && !!c.declarations && !!c.declarations[0] && e.isNamespaceExportDeclaration(c.declarations[0]);
            }
            e.isUMDExportSymbol = Yu;
            function Rl(c) {
              var te = c.moduleSpecifier;
              return e.isStringLiteral(te) ? te.text : Ee(te);
            }
            e.showModuleSpecifier = Rl;
            function Lc(c) {
              var te;
              return e.forEachChild(c, function(xr) {
                j(xr) && (te = xr);
              }, function(xr) {
                for (var ei = xr.length - 1; ei >= 0; ei--) if (j(xr[ei])) {
                  te = xr[ei];
                  break;
                }
              }), te;
            }
            e.getLastChild = Lc;
            function _(c, te, xr) {
              return xr === void 0 && (xr = true), c.has(te) ? false : (c.set(te, xr), true);
            }
            e.addToSeen = _;
            function W(c) {
              return e.isClassLike(c) || e.isInterfaceDeclaration(c) || e.isTypeLiteralNode(c);
            }
            e.isObjectTypeDeclaration = W;
            function Te(c) {
              return c >= 177 && c <= 200 || c === 130 || c === 155 || c === 147 || c === 158 || c === 148 || c === 133 || c === 150 || c === 151 || c === 114 || c === 153 || c === 143 || c === 228 || c === 312 || c === 313 || c === 314 || c === 315 || c === 316 || c === 317 || c === 318;
            }
            e.isTypeNodeKind = Te;
            function cr(c) {
              return c.kind === 206 || c.kind === 207;
            }
            e.isAccessExpression = cr;
            function ni(c) {
              return c.kind === 206 ? c.name : (e.Debug.assert(c.kind === 207), c.argumentExpression);
            }
            e.getNameOfAccessExpression = ni;
            function rt(c) {
              switch (c.kind) {
                case "text":
                case "internal":
                  return true;
                default:
                  return false;
              }
            }
            e.isBundleFileTextLike = rt;
            function yt(c) {
              return c.kind === 269 || c.kind === 273;
            }
            e.isNamedImportsOrExports = yt;
            function Xa(c) {
              for (; cr(c); ) c = c.expression;
              return c;
            }
            e.getLeftmostAccessExpression = Xa;
            function vo(c, te) {
              if (cr(c.parent) && Kf(c)) return xr(c.parent);
              function xr(ei) {
                if (ei.kind === 206) {
                  var bi = te(ei.name);
                  if (bi !== void 0) return bi;
                } else if (ei.kind === 207) if (e.isIdentifier(ei.argumentExpression) || e.isStringLiteralLike(ei.argumentExpression)) {
                  var bi = te(ei.argumentExpression);
                  if (bi !== void 0) return bi;
                } else return;
                if (cr(ei.expression)) return xr(ei.expression);
                if (e.isIdentifier(ei.expression)) return te(ei.expression);
              }
            }
            e.forEachNameInAccessChainWalkingLeft = vo;
            function Vs(c, te) {
              for (; ; ) {
                switch (c.kind) {
                  case 220:
                    c = c.operand;
                    continue;
                  case 221:
                    c = c.left;
                    continue;
                  case 222:
                    c = c.condition;
                    continue;
                  case 210:
                    c = c.tag;
                    continue;
                  case 208:
                    if (te) return c;
                  case 229:
                  case 207:
                  case 206:
                  case 230:
                  case 350:
                    c = c.expression;
                    continue;
                }
                return c;
              }
            }
            e.getLeftmostExpression = Vs;
            function H_(c, te) {
              this.flags = c, this.escapedName = te, this.declarations = void 0, this.valueDeclaration = void 0, this.id = void 0, this.mergeId = void 0, this.parent = void 0;
            }
            function y_(c, te) {
              this.flags = te, (e.Debug.isDebugging || e.tracing) && (this.checker = c);
            }
            function Dd(c, te) {
              this.flags = te, e.Debug.isDebugging && (this.checker = c);
            }
            function jp(c, te, xr) {
              this.pos = te, this.end = xr, this.kind = c, this.id = 0, this.flags = 0, this.modifierFlagsCache = 0, this.transformFlags = 0, this.parent = void 0, this.original = void 0;
            }
            function lg(c, te, xr) {
              this.pos = te, this.end = xr, this.kind = c, this.id = 0, this.flags = 0, this.transformFlags = 0, this.parent = void 0;
            }
            function Om(c, te, xr) {
              this.pos = te, this.end = xr, this.kind = c, this.id = 0, this.flags = 0, this.transformFlags = 0, this.parent = void 0, this.original = void 0, this.flowNode = void 0;
            }
            function Fm(c, te, xr) {
              this.fileName = c, this.text = te, this.skipTrivia = xr || function(ei) {
                return ei;
              };
            }
            e.objectAllocator = { getNodeConstructor: function() {
              return jp;
            }, getTokenConstructor: function() {
              return lg;
            }, getIdentifierConstructor: function() {
              return Om;
            }, getPrivateIdentifierConstructor: function() {
              return jp;
            }, getSourceFileConstructor: function() {
              return jp;
            }, getSymbolConstructor: function() {
              return H_;
            }, getTypeConstructor: function() {
              return y_;
            }, getSignatureConstructor: function() {
              return Dd;
            }, getSourceMapSourceConstructor: function() {
              return Fm;
            } };
            function Vg(c) {
              Object.assign(e.objectAllocator, c);
            }
            e.setObjectAllocator = Vg;
            function Jt(c, te, xr) {
              return xr === void 0 && (xr = 0), c.replace(/{(\d+)}/g, function(ei, bi) {
                return "" + e.Debug.checkDefined(te[+bi + xr]);
              });
            }
            e.formatStringFromArgs = Jt;
            var ml;
            function Xf(c) {
              ml = c;
            }
            e.setLocalizedDiagnosticMessages = Xf;
            function bd(c) {
              !ml && c && (ml = c());
            }
            e.maybeSetLocalizedDiagnosticMessages = bd;
            function lf(c) {
              return ml && ml[c.key] || c.message;
            }
            e.getLocaleSpecificMessage = lf;
            function Kg(c, te, xr, ei) {
              zr(void 0, te, xr);
              var bi = lf(ei);
              return arguments.length > 4 && (bi = Jt(bi, arguments, 4)), { file: void 0, start: te, length: xr, messageText: bi, category: ei.category, code: ei.code, reportsUnnecessary: ei.reportsUnnecessary, fileName: c };
            }
            e.createDetachedDiagnostic = Kg;
            function kf(c) {
              return c.file === void 0 && c.start !== void 0 && c.length !== void 0 && typeof c.fileName == "string";
            }
            function Gg(c, te) {
              var xr = te.fileName || "", ei = te.text.length;
              e.Debug.assertEqual(c.fileName, xr), e.Debug.assertLessThanOrEqual(c.start, ei), e.Debug.assertLessThanOrEqual(c.start + c.length, ei);
              var bi = { file: te, start: c.start, length: c.length, messageText: c.messageText, category: c.category, code: c.code, reportsUnnecessary: c.reportsUnnecessary };
              if (c.relatedInformation) {
                bi.relatedInformation = [];
                for (var Ft = 0, ot = c.relatedInformation; Ft < ot.length; Ft++) {
                  var xa = ot[Ft];
                  kf(xa) && xa.fileName === xr ? (e.Debug.assertLessThanOrEqual(xa.start, ei), e.Debug.assertLessThanOrEqual(xa.start + xa.length, ei), bi.relatedInformation.push(Gg(xa, te))) : bi.relatedInformation.push(xa);
                }
              }
              return bi;
            }
            function Af(c, te) {
              for (var xr = [], ei = 0, bi = c; ei < bi.length; ei++) {
                var Ft = bi[ei];
                xr.push(Gg(Ft, te));
              }
              return xr;
            }
            e.attachFileToDiagnostics = Af;
            function Hg(c, te, xr, ei) {
              zr(c, te, xr);
              var bi = lf(ei);
              return arguments.length > 4 && (bi = Jt(bi, arguments, 4)), { file: c, start: te, length: xr, messageText: bi, category: ei.category, code: ei.code, reportsUnnecessary: ei.reportsUnnecessary, reportsDeprecated: ei.reportsDeprecated };
            }
            e.createFileDiagnostic = Hg;
            function Wd(c, te) {
              var xr = lf(te);
              return arguments.length > 2 && (xr = Jt(xr, arguments, 2)), xr;
            }
            e.formatMessage = Wd;
            function qd(c) {
              var te = lf(c);
              return arguments.length > 1 && (te = Jt(te, arguments, 1)), { file: void 0, start: void 0, length: void 0, messageText: te, category: c.category, code: c.code, reportsUnnecessary: c.reportsUnnecessary, reportsDeprecated: c.reportsDeprecated };
            }
            e.createCompilerDiagnostic = qd;
            function fg(c, te) {
              return { file: void 0, start: void 0, length: void 0, code: c.code, category: c.category, messageText: c.next ? c : c.messageText, relatedInformation: te };
            }
            e.createCompilerDiagnosticFromMessageChain = fg;
            function Mm(c, te) {
              var xr = lf(te);
              return arguments.length > 2 && (xr = Jt(xr, arguments, 2)), { messageText: xr, category: te.category, code: te.code, next: c === void 0 || Array.isArray(c) ? c : [c] };
            }
            e.chainDiagnosticMessages = Mm;
            function Xg(c, te) {
              for (var xr = c; xr.next; ) xr = xr.next[0];
              xr.next = [te];
            }
            e.concatenateDiagnosticMessageChains = Xg;
            function Bl(c) {
              return c.file ? c.file.path : void 0;
            }
            function Qg(c, te) {
              return _g(c, te) || Qc(c, te) || 0;
            }
            e.compareDiagnostics = Qg;
            function _g(c, te) {
              return e.compareStringsCaseSensitive(Bl(c), Bl(te)) || e.compareValues(c.start, te.start) || e.compareValues(c.length, te.length) || e.compareValues(c.code, te.code) || Lm(c.messageText, te.messageText) || 0;
            }
            e.compareDiagnosticsSkipRelatedInformation = _g;
            function Qc(c, te) {
              return !c.relatedInformation && !te.relatedInformation ? 0 : c.relatedInformation && te.relatedInformation ? e.compareValues(c.relatedInformation.length, te.relatedInformation.length) || e.forEach(c.relatedInformation, function(xr, ei) {
                var bi = te.relatedInformation[ei];
                return Qg(xr, bi);
              }) || 0 : c.relatedInformation ? -1 : 1;
            }
            function Lm(c, te) {
              if (typeof c == "string" && typeof te == "string") return e.compareStringsCaseSensitive(c, te);
              if (typeof c == "string") return -1;
              if (typeof te == "string") return 1;
              var xr = e.compareStringsCaseSensitive(c.messageText, te.messageText);
              if (xr) return xr;
              if (!c.next && !te.next) return 0;
              if (!c.next) return -1;
              if (!te.next) return 1;
              for (var ei = Math.min(c.next.length, te.next.length), bi = 0; bi < ei; bi++) if (xr = Lm(c.next[bi], te.next[bi]), xr) return xr;
              return c.next.length < te.next.length ? -1 : c.next.length > te.next.length ? 1 : 0;
            }
            function Up(c) {
              return c === 4 || c === 2 || c === 1 || c === 6 ? 1 : 0;
            }
            e.getLanguageVariant = Up;
            function Rm(c) {
              if (!!(c.transformFlags & 2)) return e.isJsxOpeningLikeElement(c) || e.isJsxFragment(c) ? c : e.forEachChild(c, Rm);
            }
            function ff(c) {
              return c.isDeclarationFile ? void 0 : Rm(c);
            }
            function It(c) {
              return c.impliedNodeFormat === e.ModuleKind.ESNext && !c.isDeclarationFile ? true : void 0;
            }
            function Ma(c) {
              switch (ro(c)) {
                case e.ModuleDetectionKind.Force:
                  return function(Ft) {
                    Ft.externalModuleIndicator = !Ft.isDeclarationFile || e.isFileProbablyExternalModule(Ft);
                  };
                case e.ModuleDetectionKind.Legacy:
                  return function(Ft) {
                    Ft.externalModuleIndicator = e.isFileProbablyExternalModule(Ft);
                  };
                case e.ModuleDetectionKind.Auto:
                  var te = [e.isFileProbablyExternalModule];
                  (c.jsx === 4 || c.jsx === 5) && te.push(ff);
                  var xr = Ja(c);
                  (xr === e.ModuleKind.Node16 || xr === e.ModuleKind.NodeNext) && te.push(It);
                  var ei = e.or.apply(void 0, te), bi = function(Ft) {
                    return void (Ft.externalModuleIndicator = ei(Ft));
                  };
                  return bi;
              }
            }
            e.getSetExternalModuleIndicator = Ma;
            function aa(c) {
              return c.target || c.module === e.ModuleKind.Node16 && 9 || c.module === e.ModuleKind.NodeNext && 99 || 0;
            }
            e.getEmitScriptTarget = aa;
            function Ja(c) {
              return typeof c.module == "number" ? c.module : aa(c) >= 2 ? e.ModuleKind.ES2015 : e.ModuleKind.CommonJS;
            }
            e.getEmitModuleKind = Ja;
            function _n(c) {
              var te = c.moduleResolution;
              if (te === void 0) switch (Ja(c)) {
                case e.ModuleKind.CommonJS:
                  te = e.ModuleResolutionKind.NodeJs;
                  break;
                case e.ModuleKind.Node16:
                  te = e.ModuleResolutionKind.Node16;
                  break;
                case e.ModuleKind.NodeNext:
                  te = e.ModuleResolutionKind.NodeNext;
                  break;
                default:
                  te = e.ModuleResolutionKind.Classic;
                  break;
              }
              return te;
            }
            e.getEmitModuleResolutionKind = _n;
            function ro(c) {
              return c.moduleDetection || e.ModuleDetectionKind.Auto;
            }
            e.getEmitModuleDetectionKind = ro;
            function as(c) {
              switch (Ja(c)) {
                case e.ModuleKind.CommonJS:
                case e.ModuleKind.AMD:
                case e.ModuleKind.ES2015:
                case e.ModuleKind.ES2020:
                case e.ModuleKind.ES2022:
                case e.ModuleKind.ESNext:
                case e.ModuleKind.Node16:
                case e.ModuleKind.NodeNext:
                  return true;
                default:
                  return false;
              }
            }
            e.hasJsonModuleEmitEnabled = as;
            function cc(c) {
              return c.allowUnreachableCode === false;
            }
            e.unreachableCodeIsError = cc;
            function Sc(c) {
              return c.allowUnusedLabels === false;
            }
            e.unusedLabelIsError = Sc;
            function hu(c) {
              return !!(go(c) && c.declarationMap);
            }
            e.getAreDeclarationMapsEnabled = hu;
            function Js(c) {
              if (c.esModuleInterop !== void 0) return c.esModuleInterop;
              switch (Ja(c)) {
                case e.ModuleKind.Node16:
                case e.ModuleKind.NodeNext:
                  return true;
              }
            }
            e.getESModuleInterop = Js;
            function Qf(c) {
              var te = Ja(c);
              return c.allowSyntheticDefaultImports !== void 0 ? c.allowSyntheticDefaultImports : Js(c) || te === e.ModuleKind.System;
            }
            e.getAllowSyntheticDefaultImports = Qf;
            function go(c) {
              return !!(c.declaration || c.composite);
            }
            e.getEmitDeclarations = go;
            function Vd(c) {
              return !!(c.preserveConstEnums || c.isolatedModules);
            }
            e.shouldPreserveConstEnums = Vd;
            function X_(c) {
              return !!(c.incremental || c.composite);
            }
            e.isIncrementalCompilation = X_;
            function Sd(c, te) {
              return c[te] === void 0 ? !!c.strict : !!c[te];
            }
            e.getStrictOptionValue = Sd;
            function Yg(c) {
              return c.allowJs === void 0 ? !!c.checkJs : c.allowJs;
            }
            e.getAllowJSCompilerOption = Yg;
            function N1(c) {
              return c.useDefineForClassFields === void 0 ? aa(c) >= 9 : c.useDefineForClassFields;
            }
            e.getUseDefineForClassFields = N1;
            function P1(c, te) {
              return m(te, c, e.semanticDiagnosticsOptionDeclarations);
            }
            e.compilerOptionsAffectSemanticDiagnostics = P1;
            function Yy(c, te) {
              return m(te, c, e.affectsEmitOptionDeclarations);
            }
            e.compilerOptionsAffectEmit = Yy;
            function Bm(c, te) {
              return te.strictFlag ? Sd(c, te.name) : c[te.name];
            }
            e.getCompilerOptionValue = Bm;
            function $y(c) {
              var te = c.jsx;
              return te === 2 || te === 4 || te === 5;
            }
            e.getJSXTransformEnabled = $y;
            function Lv(c, te) {
              var xr = te == null ? void 0 : te.pragmas.get("jsximportsource"), ei = e.isArray(xr) ? xr[xr.length - 1] : xr;
              return c.jsx === 4 || c.jsx === 5 || c.jsxImportSource || ei ? (ei == null ? void 0 : ei.arguments.factory) || c.jsxImportSource || "react" : void 0;
            }
            e.getJSXImplicitImportBase = Lv;
            function _f(c, te) {
              return c ? "".concat(c, "/").concat(te.jsx === 5 ? "jsx-dev-runtime" : "jsx-runtime") : void 0;
            }
            e.getJSXRuntimeImport = _f;
            function Rv(c) {
              for (var te = false, xr = 0; xr < c.length; xr++) if (c.charCodeAt(xr) === 42) if (!te) te = true;
              else return false;
              return true;
            }
            e.hasZeroOrOneAsteriskCharacter = Rv;
            function pg(c, te) {
              var xr, ei, bi, Ft = false;
              return { getSymlinkedFiles: function() {
                return bi;
              }, getSymlinkedDirectories: function() {
                return xr;
              }, getSymlinkedDirectoriesByRealpath: function() {
                return ei;
              }, setSymlinkedFile: function(xa, mn) {
                return (bi || (bi = new e.Map())).set(xa, mn);
              }, setSymlinkedDirectory: function(xa, mn) {
                var an = e.toPath(xa, c, te);
                D_(an) || (an = e.ensureTrailingDirectorySeparator(an), mn !== false && !(xr != null && xr.has(an)) && (ei || (ei = e.createMultiMap())).add(e.ensureTrailingDirectorySeparator(mn.realPath), xa), (xr || (xr = new e.Map())).set(an, mn));
              }, setSymlinksFromResolutions: function(xa, mn) {
                var an = this, To;
                e.Debug.assert(!Ft), Ft = true;
                for (var Hn = 0, ss = xa; Hn < ss.length; Hn++) {
                  var cs = ss[Hn];
                  (To = cs.resolvedModules) === null || To === void 0 || To.forEach(function(ws) {
                    return ot(an, ws);
                  });
                }
                mn == null || mn.forEach(function(ws) {
                  return ot(an, ws);
                });
              }, hasProcessedResolutions: function() {
                return Ft;
              } };
              function ot(xa, mn) {
                if (!(!mn || !mn.originalPath || !mn.resolvedFileName)) {
                  var an = mn.resolvedFileName, To = mn.originalPath;
                  xa.setSymlinkedFile(e.toPath(To, c, te), an);
                  var Hn = $g(an, To, c, te) || e.emptyArray, ss = Hn[0], cs = Hn[1];
                  ss && cs && xa.setSymlinkedDirectory(cs, { real: ss, realPath: e.toPath(ss, c, te) });
                }
              }
            }
            e.createSymlinkCache = pg;
            function $g(c, te, xr, ei) {
              for (var bi = e.getPathComponents(e.getNormalizedAbsolutePath(c, xr)), Ft = e.getPathComponents(e.getNormalizedAbsolutePath(te, xr)), ot = false; bi.length >= 2 && Ft.length >= 2 && !Td(bi[bi.length - 2], ei) && !Td(Ft[Ft.length - 2], ei) && ei(bi[bi.length - 1]) === ei(Ft[Ft.length - 1]); ) bi.pop(), Ft.pop(), ot = true;
              return ot ? [e.getPathFromPathComponents(bi), e.getPathFromPathComponents(Ft)] : void 0;
            }
            function Td(c, te) {
              return c !== void 0 && (te(c) === "node_modules" || e.startsWith(c, "@"));
            }
            function I1(c) {
              return e.isAnyDirectorySeparator(c.charCodeAt(0)) ? c.slice(1) : void 0;
            }
            function pf(c, te, xr) {
              var ei = e.tryRemovePrefix(c, te, xr);
              return ei === void 0 ? void 0 : I1(ei);
            }
            e.tryRemoveDirectoryPrefix = pf;
            var Bv = /[^\w\s\/]/g;
            function Zy(c) {
              return c.replace(Bv, Jv);
            }
            e.regExpEscape = Zy;
            function Jv(c) {
              return "\\" + c;
            }
            var Nf = [42, 63];
            e.commonPackageFolders = ["node_modules", "bower_components", "jspm_packages"];
            var dg = "(?!(".concat(e.commonPackageFolders.join("|"), ")(/|$))"), Rc = { singleAsteriskRegexFragment: "([^./]|(\\.(?!min\\.js$))?)*", doubleAsteriskRegexFragment: "(/".concat(dg, "[^/.][^/]*)*?"), replaceWildcardCharacter: function(c) {
              return Jm(c, Rc.singleAsteriskRegexFragment);
            } }, jv = { singleAsteriskRegexFragment: "[^/]*", doubleAsteriskRegexFragment: "(/".concat(dg, "[^/.][^/]*)*?"), replaceWildcardCharacter: function(c) {
              return Jm(c, jv.singleAsteriskRegexFragment);
            } }, eh = { singleAsteriskRegexFragment: "[^/]*", doubleAsteriskRegexFragment: "(/.+?)?", replaceWildcardCharacter: function(c) {
              return Jm(c, eh.singleAsteriskRegexFragment);
            } }, rh = { files: Rc, directories: jv, exclude: eh };
            function Fu(c, te, xr) {
              var ei = xd(c, te, xr);
              if (!(!ei || !ei.length)) {
                var bi = ei.map(function(ot) {
                  return "(".concat(ot, ")");
                }).join("|"), Ft = xr === "exclude" ? "($|/)" : "$";
                return "^(".concat(bi, ")").concat(Ft);
              }
            }
            e.getRegularExpressionForWildcard = Fu;
            function xd(c, te, xr) {
              if (!(c === void 0 || c.length === 0)) return e.flatMap(c, function(ei) {
                return ei && ih(ei, te, xr, rh[xr]);
              });
            }
            e.getRegularExpressionsForWildcards = xd;
            function Uv(c) {
              return !/[.*?]/.test(c);
            }
            e.isImplicitGlob = Uv;
            function w1(c, te, xr) {
              var ei = c && ih(c, te, xr, rh[xr]);
              return ei && "^(".concat(ei, ")").concat(xr === "exclude" ? "($|/)" : "$");
            }
            e.getPatternFromSpec = w1;
            function ih(c, te, xr, ei) {
              var bi = ei.singleAsteriskRegexFragment, Ft = ei.doubleAsteriskRegexFragment, ot = ei.replaceWildcardCharacter, xa = "", mn = false, an = e.getNormalizedPathComponents(c, te), To = e.last(an);
              if (!(xr !== "exclude" && To === "**")) {
                an[0] = e.removeTrailingDirectorySeparator(an[0]), Uv(To) && an.push("**", "*");
                for (var Hn = 0, ss = 0, cs = an; ss < cs.length; ss++) {
                  var ws = cs[ss];
                  if (ws === "**") xa += Ft;
                  else if (xr === "directories" && (xa += "(", Hn++), mn && (xa += e.directorySeparator), xr !== "exclude") {
                    var nu = "";
                    ws.charCodeAt(0) === 42 ? (nu += "([^./]" + bi + ")?", ws = ws.substr(1)) : ws.charCodeAt(0) === 63 && (nu += "[^./]", ws = ws.substr(1)), nu += ws.replace(Bv, ot), nu !== ws && (xa += dg), xa += nu;
                  } else xa += ws.replace(Bv, ot);
                  mn = true;
                }
                for (; Hn > 0; ) xa += ")?", Hn--;
                return xa;
              }
            }
            function Jm(c, te) {
              return c === "*" ? te : c === "?" ? "[^/]" : "\\" + c;
            }
            function th(c, te, xr, ei, bi) {
              c = e.normalizePath(c), bi = e.normalizePath(bi);
              var Ft = e.combinePaths(bi, c);
              return { includeFilePatterns: e.map(xd(xr, Ft, "files"), function(ot) {
                return "^".concat(ot, "$");
              }), includeFilePattern: Fu(xr, Ft, "files"), includeDirectoryPattern: Fu(xr, Ft, "directories"), excludePattern: Fu(te, Ft, "exclude"), basePaths: zv(c, xr, ei) };
            }
            e.getFileMatcherPatterns = th;
            function gg(c, te) {
              return new RegExp(c, te ? "" : "i");
            }
            e.getRegexFromPattern = gg;
            function O1(c, te, xr, ei, bi, Ft, ot, xa, mn) {
              c = e.normalizePath(c), Ft = e.normalizePath(Ft);
              for (var an = th(c, xr, ei, bi, Ft), To = an.includeFilePatterns && an.includeFilePatterns.map(function(b_) {
                return gg(b_, bi);
              }), Hn = an.includeDirectoryPattern && gg(an.includeDirectoryPattern, bi), ss = an.excludePattern && gg(an.excludePattern, bi), cs = To ? To.map(function() {
                return [];
              }) : [[]], ws = new e.Map(), nu = e.createGetCanonicalFileName(bi), Xo = 0, jl = an.basePaths; Xo < jl.length; Xo++) {
                var Y_ = jl[Xo];
                Cd(Y_, e.combinePaths(Ft, Y_), ot);
              }
              return e.flatten(cs);
              function Cd(b_, kd, qm) {
                var Vm = nu(mn(kd));
                if (!ws.has(Vm)) {
                  ws.set(Vm, true);
                  for (var vg = xa(b_), Ul = vg.files, zp = vg.directories, yl = function(T_) {
                    var Yc = e.combinePaths(b_, T_), gh = e.combinePaths(kd, T_);
                    if (te && !e.fileExtensionIsOneOf(Yc, te) || ss && ss.test(gh)) return "continue";
                    if (!To) cs[0].push(Yc);
                    else {
                      var iy = e.findIndex(To, function(yo) {
                        return yo.test(gh);
                      });
                      iy !== -1 && cs[iy].push(Yc);
                    }
                  }, ey = 0, rm = e.sort(Ul, e.compareStringsCaseSensitive); ey < rm.length; ey++) {
                    var Km = rm[ey];
                    yl(Km);
                  }
                  if (!(qm !== void 0 && (qm--, qm === 0))) for (var ry = 0, Gm = e.sort(zp, e.compareStringsCaseSensitive); ry < Gm.length; ry++) {
                    var Km = Gm[ry], S_ = e.combinePaths(b_, Km), Hm = e.combinePaths(kd, Km);
                    (!Hn || Hn.test(Hm)) && (!ss || !ss.test(Hm)) && Cd(S_, Hm, qm);
                  }
                }
              }
            }
            e.matchFiles = O1;
            function zv(c, te, xr) {
              var ei = [c];
              if (te) {
                for (var bi = [], Ft = 0, ot = te; Ft < ot.length; Ft++) {
                  var xa = ot[Ft], mn = e.isRootedDiskPath(xa) ? xa : e.normalizePath(e.combinePaths(c, xa));
                  bi.push(ah(mn));
                }
                bi.sort(e.getStringComparer(!xr));
                for (var an = function(cs) {
                  e.every(ei, function(ws) {
                    return !e.containsPath(ws, cs, c, !xr);
                  }) && ei.push(cs);
                }, To = 0, Hn = bi; To < Hn.length; To++) {
                  var ss = Hn[To];
                  an(ss);
                }
              }
              return ei;
            }
            function ah(c) {
              var te = e.indexOfAnyCharCode(c, Nf);
              return te < 0 ? e.hasExtension(c) ? e.removeTrailingDirectorySeparator(e.getDirectoryPath(c)) : c : c.substring(0, c.lastIndexOf(e.directorySeparator, te));
            }
            function F1(c, te) {
              return te || nh(c) || 3;
            }
            e.ensureScriptKind = F1;
            function nh(c) {
              var te = c.substr(c.lastIndexOf("."));
              switch (te.toLowerCase()) {
                case ".js":
                case ".cjs":
                case ".mjs":
                  return 1;
                case ".jsx":
                  return 2;
                case ".ts":
                case ".cts":
                case ".mts":
                  return 3;
                case ".tsx":
                  return 4;
                case ".json":
                  return 6;
                default:
                  return 0;
              }
            }
            e.getScriptKindFromFileName = nh, e.supportedTSExtensions = [[".ts", ".tsx", ".d.ts"], [".cts", ".d.cts"], [".mts", ".d.mts"]], e.supportedTSExtensionsFlat = e.flatten(e.supportedTSExtensions);
            var M1 = Ve(Ve([], e.supportedTSExtensions, true), [[".json"]], false), oh = [".d.ts", ".d.cts", ".d.mts", ".cts", ".mts", ".ts", ".tsx", ".cts", ".mts"];
            e.supportedJSExtensions = [[".js", ".jsx"], [".mjs"], [".cjs"]], e.supportedJSExtensionsFlat = e.flatten(e.supportedJSExtensions);
            var jm = [[".ts", ".tsx", ".d.ts", ".js", ".jsx"], [".cts", ".d.cts", ".cjs"], [".mts", ".d.mts", ".mjs"]], Zg = Ve(Ve([], jm, true), [[".json"]], false);
            e.supportedDeclarationExtensions = [".d.ts", ".d.cts", ".d.mts"];
            function Wv(c, te) {
              var xr = c && Yg(c);
              if (!te || te.length === 0) return xr ? jm : e.supportedTSExtensions;
              var ei = xr ? jm : e.supportedTSExtensions, bi = e.flatten(ei), Ft = Ve(Ve([], ei, true), e.mapDefined(te, function(ot) {
                return ot.scriptKind === 7 || xr && L1(ot.scriptKind) && bi.indexOf(ot.extension) === -1 ? [ot.extension] : void 0;
              }), true);
              return Ft;
            }
            e.getSupportedExtensions = Wv;
            function sh(c, te) {
              return !c || !c.resolveJsonModule ? te : te === jm ? Zg : te === e.supportedTSExtensions ? M1 : Ve(Ve([], te, true), [[".json"]], false);
            }
            e.getSupportedExtensionsWithJsonIfResolveJsonModule = sh;
            function L1(c) {
              return c === 1 || c === 2;
            }
            function ch(c) {
              return e.some(e.supportedJSExtensionsFlat, function(te) {
                return e.fileExtensionIs(c, te);
              });
            }
            e.hasJSFileExtension = ch;
            function uh(c) {
              return e.some(e.supportedTSExtensionsFlat, function(te) {
                return e.fileExtensionIs(c, te);
              });
            }
            e.hasTSFileExtension = uh;
            function R1(c, te, xr) {
              if (!c) return false;
              for (var ei = Wv(te, xr), bi = 0, Ft = e.flatten(sh(te, ei)); bi < Ft.length; bi++) {
                var ot = Ft[bi];
                if (e.fileExtensionIs(c, ot)) return true;
              }
              return false;
            }
            e.isSupportedSourceFileName = R1;
            function lh(c) {
              var te = c.match(/\//g);
              return te ? te.length : 0;
            }
            function B1(c, te) {
              return e.compareValues(lh(c), lh(te));
            }
            e.compareNumberOfDirectorySeparators = B1;
            var Kd = [".d.ts", ".d.mts", ".d.cts", ".mjs", ".mts", ".cjs", ".cts", ".ts", ".js", ".tsx", ".jsx", ".json"];
            function Gd(c) {
              for (var te = 0, xr = Kd; te < xr.length; te++) {
                var ei = xr[te], bi = Um(c, ei);
                if (bi !== void 0) return bi;
              }
              return c;
            }
            e.removeFileExtension = Gd;
            function Um(c, te) {
              return e.fileExtensionIs(c, te) ? fh(c, te) : void 0;
            }
            e.tryRemoveExtension = Um;
            function fh(c, te) {
              return c.substring(0, c.length - te.length);
            }
            e.removeExtension = fh;
            function J1(c, te) {
              return e.changeAnyExtension(c, te, Kd, false);
            }
            e.changeExtension = J1;
            function Du(c) {
              var te = c.indexOf("*");
              return te === -1 ? c : c.indexOf("*", te + 1) !== -1 ? void 0 : { prefix: c.substr(0, te), suffix: c.substr(te + 1) };
            }
            e.tryParsePattern = Du;
            function Mu(c) {
              return e.mapDefined(e.getOwnKeys(c), function(te) {
                return Du(te);
              });
            }
            e.tryParsePatterns = Mu;
            function Jl(c) {
              return !(c >= 0);
            }
            e.positionIsSynthesized = Jl;
            function vl(c) {
              return c === ".ts" || c === ".tsx" || c === ".d.ts" || c === ".cts" || c === ".mts" || c === ".d.mts" || c === ".d.cts";
            }
            e.extensionIsTS = vl;
            function _h(c) {
              return vl(c) || c === ".json";
            }
            e.resolutionExtensionIsTSOrJson = _h;
            function mg(c) {
              var te = Lu(c);
              return te !== void 0 ? te : e.Debug.fail("File ".concat(c, " has unknown extension."));
            }
            e.extensionFromPath = mg;
            function Ed(c) {
              return Lu(c) !== void 0;
            }
            e.isAnySupportedFileExtension = Ed;
            function Lu(c) {
              return e.find(Kd, function(te) {
                return e.fileExtensionIs(c, te);
              });
            }
            e.tryGetExtensionFromPath = Lu;
            function ph(c, te) {
              return c.checkJsDirective ? c.checkJsDirective.enabled : te.checkJs;
            }
            e.isCheckJsEnabledForFile = ph, e.emptyFileSystemEntries = { files: e.emptyArray, directories: e.emptyArray };
            function qv(c, te) {
              for (var xr = [], ei = 0, bi = c; ei < bi.length; ei++) {
                var Ft = bi[ei];
                if (Ft === te) return te;
                e.isString(Ft) || xr.push(Ft);
              }
              return e.findBestPatternMatch(xr, function(ot) {
                return ot;
              }, te);
            }
            e.matchPatternOrExact = qv;
            function j1(c, te) {
              var xr = c.indexOf(te);
              return e.Debug.assert(xr !== -1), c.slice(xr);
            }
            e.sliceAfter = j1;
            function Bc(c) {
              for (var te, xr = [], ei = 1; ei < arguments.length; ei++) xr[ei - 1] = arguments[ei];
              return xr.length && (c.relatedInformation || (c.relatedInformation = []), e.Debug.assert(c.relatedInformation !== e.emptyArray, "Diagnostic had empty array singleton for related info, but is still being constructed!"), (te = c.relatedInformation).push.apply(te, xr)), c;
            }
            e.addRelatedInfo = Bc;
            function Ru(c, te) {
              e.Debug.assert(c.length !== 0);
              for (var xr = te(c[0]), ei = xr, bi = 1; bi < c.length; bi++) {
                var Ft = te(c[bi]);
                Ft < xr ? xr = Ft : Ft > ei && (ei = Ft);
              }
              return { min: xr, max: ei };
            }
            e.minAndMax = Ru;
            function Pf(c) {
              return { pos: Fe(c), end: c.end };
            }
            e.rangeOfNode = Pf;
            function h_(c, te) {
              var xr = te.pos - 1, ei = e.skipTrivia(c.text, te.end) + 1;
              return { pos: xr, end: ei };
            }
            e.rangeOfTypeParameters = h_;
            function em(c, te, xr) {
              return te.skipLibCheck && c.isDeclarationFile || te.skipDefaultLibCheck && c.hasNoDefaultLib || xr.isSourceOfProjectReferenceRedirect(c.fileName);
            }
            e.skipTypeChecking = em;
            function uo(c, te) {
              return c === te || typeof c == "object" && c !== null && typeof te == "object" && te !== null && e.equalOwnProperties(c, te, uo);
            }
            e.isJsonEqual = uo;
            function U1(c) {
              var te;
              switch (c.charCodeAt(1)) {
                case 98:
                case 66:
                  te = 1;
                  break;
                case 111:
                case 79:
                  te = 3;
                  break;
                case 120:
                case 88:
                  te = 4;
                  break;
                default:
                  for (var xr = c.length - 1, ei = 0; c.charCodeAt(ei) === 48; ) ei++;
                  return c.slice(ei, xr) || "0";
              }
              for (var bi = 2, Ft = c.length - 1, ot = (Ft - bi) * te, xa = new Uint16Array((ot >>> 4) + (ot & 15 ? 1 : 0)), mn = Ft - 1, an = 0; mn >= bi; mn--, an += te) {
                var To = an >>> 4, Hn = c.charCodeAt(mn), ss = Hn <= 57 ? Hn - 48 : 10 + Hn - (Hn <= 70 ? 65 : 97), cs = ss << (an & 15);
                xa[To] |= cs;
                var ws = cs >>> 16;
                ws && (xa[To + 1] |= ws);
              }
              for (var nu = "", Xo = xa.length - 1, jl = true; jl; ) {
                var Y_ = 0;
                jl = false;
                for (var To = Xo; To >= 0; To--) {
                  var Cd = Y_ << 16 | xa[To], b_ = Cd / 10 | 0;
                  xa[To] = b_, Y_ = Cd - b_ * 10, b_ && !jl && (Xo = To, jl = true);
                }
                nu = Y_ + nu;
              }
              return nu;
            }
            e.parsePseudoBigInt = U1;
            function z1(c) {
              var te = c.negative, xr = c.base10Value;
              return (te && xr !== "0" ? "-" : "") + xr;
            }
            e.pseudoBigIntToString = z1;
            function W1(c) {
              return !!(c.flags & 16777216) || S(c) || q1(c) || Tc(c) || !(Qe(c) || Q_(c));
            }
            e.isValidTypeOnlyAliasUseSite = W1;
            function Q_(c) {
              return e.isIdentifier(c) && e.isShorthandPropertyAssignment(c.parent) && c.parent.name === c;
            }
            function Tc(c) {
              for (; c.kind === 79 || c.kind === 206; ) c = c.parent;
              if (c.kind !== 162) return false;
              if (gc(c.parent, 128)) return true;
              var te = c.parent.parent.kind;
              return te === 258 || te === 182;
            }
            function q1(c) {
              if (c.kind !== 79) return false;
              var te = e.findAncestor(c.parent, function(xr) {
                switch (xr.kind) {
                  case 291:
                    return true;
                  case 206:
                  case 228:
                    return false;
                  default:
                    return "quit";
                }
              });
              return (te == null ? void 0 : te.token) === 117 || (te == null ? void 0 : te.parent.kind) === 258;
            }
            function Vv(c) {
              return e.isTypeReferenceNode(c) && e.isIdentifier(c.typeName);
            }
            e.isIdentifierTypeReference = Vv;
            function V1(c, te) {
              if (te === void 0 && (te = e.equateValues), c.length < 2) return true;
              for (var xr = c[0], ei = 1, bi = c.length; ei < bi; ei++) {
                var Ft = c[ei];
                if (!te(xr, Ft)) return false;
              }
              return true;
            }
            e.arrayIsHomogeneous = V1;
            function zm(c, te) {
              return c.pos = te, c;
            }
            e.setTextRangePos = zm;
            function Kv(c, te) {
              return c.end = te, c;
            }
            e.setTextRangeEnd = Kv;
            function Gv(c, te, xr) {
              return Kv(zm(c, te), xr);
            }
            e.setTextRangePosEnd = Gv;
            function K1(c, te, xr) {
              return Gv(c, te, te + xr);
            }
            e.setTextRangePosWidth = K1;
            function G1(c, te) {
              return c && (c.flags = te), c;
            }
            e.setNodeFlags = G1;
            function uc(c, te) {
              return c && te && (c.parent = te), c;
            }
            e.setParent = uc;
            function Hd(c, te) {
              if (c) for (var xr = 0, ei = c; xr < ei.length; xr++) {
                var bi = ei[xr];
                uc(bi, te);
              }
              return c;
            }
            e.setEachParent = Hd;
            function Wm(c, te) {
              if (!c) return c;
              return e.forEachChildRecursively(c, e.isJSDocNode(c) ? xr : bi), c;
              function xr(Ft, ot) {
                if (te && Ft.parent === ot) return "skip";
                uc(Ft, ot);
              }
              function ei(Ft) {
                if (e.hasJSDocNodes(Ft)) for (var ot = 0, xa = Ft.jsDoc; ot < xa.length; ot++) {
                  var mn = xa[ot];
                  xr(mn, Ft), e.forEachChildRecursively(mn, xr);
                }
              }
              function bi(Ft, ot) {
                return xr(Ft, ot) || ei(Ft);
              }
            }
            e.setParentRecursive = Wm;
            function Hv(c) {
              return !e.isOmittedExpression(c);
            }
            function H1(c) {
              return e.isArrayLiteralExpression(c) && e.every(c.elements, Hv);
            }
            e.isPackedArrayLiteral = H1;
            function Xv(c) {
              for (e.Debug.assertIsDefined(c.parent); ; ) {
                var te = c.parent;
                if (e.isParenthesizedExpression(te)) {
                  c = te;
                  continue;
                }
                if (e.isExpressionStatement(te) || e.isVoidExpression(te) || e.isForStatement(te) && (te.initializer === c || te.incrementor === c)) return true;
                if (e.isCommaListExpression(te)) {
                  if (c !== e.last(te.elements)) return true;
                  c = te;
                  continue;
                }
                if (e.isBinaryExpression(te) && te.operatorToken.kind === 27) {
                  if (c === te.left) return true;
                  c = te;
                  continue;
                }
                return false;
              }
            }
            e.expressionResultIsUnused = Xv;
            function D_(c) {
              return e.some(e.ignoredPaths, function(te) {
                return e.stringContains(c, te);
              });
            }
            e.containsIgnoredPath = D_;
            function X1(c) {
              if (!!c.parent) {
                switch (c.kind) {
                  case 163:
                    var te = c.parent;
                    return te.kind === 190 ? void 0 : te.typeParameters;
                  case 164:
                    return c.parent.parameters;
                  case 199:
                    return c.parent.templateSpans;
                  case 233:
                    return c.parent.templateSpans;
                  case 165:
                    return c.parent.decorators;
                  case 291:
                    return c.parent.heritageClauses;
                }
                var xr = c.parent;
                if (e.isJSDocTag(c)) return e.isJSDocTypeLiteral(c.parent) ? void 0 : c.parent.tags;
                switch (xr.kind) {
                  case 182:
                  case 258:
                    return e.isTypeElement(c) ? xr.members : void 0;
                  case 187:
                  case 188:
                    return xr.types;
                  case 184:
                  case 204:
                  case 351:
                  case 269:
                  case 273:
                    return xr.elements;
                  case 205:
                  case 286:
                    return xr.properties;
                  case 208:
                  case 209:
                    return e.isTypeNode(c) ? xr.typeArguments : xr.expression === c ? void 0 : xr.arguments;
                  case 278:
                  case 282:
                    return e.isJsxChild(c) ? xr.children : void 0;
                  case 280:
                  case 279:
                    return e.isTypeNode(c) ? xr.typeArguments : void 0;
                  case 235:
                  case 289:
                  case 290:
                  case 262:
                    return xr.statements;
                  case 263:
                    return xr.clauses;
                  case 257:
                  case 226:
                    return e.isClassElement(c) ? xr.members : void 0;
                  case 260:
                    return e.isEnumMember(c) ? xr.members : void 0;
                  case 305:
                    return xr.statements;
                }
              }
            }
            e.getContainingNodeArray = X1;
            function Q1(c) {
              if (!c.typeParameters) {
                if (e.some(c.parameters, function(xr) {
                  return !iu(xr);
                })) return true;
                if (c.kind !== 214) {
                  var te = e.firstOrUndefined(c.parameters);
                  if (!(te && Sf(te))) return true;
                }
              }
              return false;
            }
            e.hasContextSensitiveParameters = Q1;
            function Y1(c) {
              return c === "Infinity" || c === "-Infinity" || c === "NaN";
            }
            e.isInfinityOrNaNString = Y1;
            function dh(c) {
              return c.kind === 254 && c.parent.kind === 292;
            }
            e.isCatchClauseVariableDeclaration = dh;
            function Qv(c) {
              var te = c.valueDeclaration && jf(c.valueDeclaration);
              return !!te && (e.isParameter(te) || dh(te));
            }
            e.isParameterOrCatchClauseVariable = Qv;
            function $s(c) {
              return c.kind === 213 || c.kind === 214;
            }
            e.isFunctionExpressionOrArrowFunction = $s;
            function Xd(c) {
              return c.replace(/\$/gm, function() {
                return "\\$";
              });
            }
            e.escapeSnippetText = Xd;
            function Yv(c) {
              return (+c).toString() === c;
            }
            e.isNumericLiteralName = Yv;
            function $v(c, te, xr, ei) {
              return e.isIdentifierText(c, te) ? e.factory.createIdentifier(c) : !ei && Yv(c) && +c >= 0 ? e.factory.createNumericLiteral(+c) : e.factory.createStringLiteral(c, !!xr);
            }
            e.createPropertyNameNodeForIdentifierOrLiteral = $v;
            function Zv(c) {
              return !!(c.flags & 262144 && c.isThisType);
            }
            e.isThisTypeParameter = Zv;
            function bu(c) {
              var te = 0, xr = 0, ei = 0, bi = 0, Ft;
              (function(an) {
                an[an.BeforeNodeModules = 0] = "BeforeNodeModules", an[an.NodeModules = 1] = "NodeModules", an[an.Scope = 2] = "Scope", an[an.PackageContent = 3] = "PackageContent";
              })(Ft || (Ft = {}));
              for (var ot = 0, xa = 0, mn = 0; xa >= 0; ) switch (ot = xa, xa = c.indexOf("/", ot + 1), mn) {
                case 0:
                  c.indexOf(e.nodeModulesPathPart, ot) === ot && (te = ot, xr = xa, mn = 1);
                  break;
                case 1:
                case 2:
                  mn === 1 && c.charAt(ot + 1) === "@" ? mn = 2 : (ei = xa, mn = 3);
                  break;
                case 3:
                  c.indexOf(e.nodeModulesPathPart, ot) === ot ? mn = 1 : mn = 3;
                  break;
              }
              return bi = ot, mn > 1 ? { topLevelNodeModulesIndex: te, topLevelPackageNameIndex: xr, packageRootIndex: ei, fileNameIndex: bi } : void 0;
            }
            e.getNodeModulePathParts = bu;
            function $1(c) {
              var te;
              return c.kind === 340 ? (te = c.typeExpression) === null || te === void 0 ? void 0 : te.type : c.type;
            }
            e.getParameterTypeNode = $1;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a() {
              var C, w, B, E, Q;
              return { createBaseSourceFileNode: le, createBaseIdentifierNode: N, createBasePrivateIdentifierNode: p, createBaseTokenNode: m, createBaseNode: G };
              function le(oe) {
                return new (Q || (Q = e.objectAllocator.getSourceFileConstructor()))(oe, -1, -1);
              }
              function N(oe) {
                return new (B || (B = e.objectAllocator.getIdentifierConstructor()))(oe, -1, -1);
              }
              function p(oe) {
                return new (E || (E = e.objectAllocator.getPrivateIdentifierConstructor()))(oe, -1, -1);
              }
              function m(oe) {
                return new (w || (w = e.objectAllocator.getTokenConstructor()))(oe, -1, -1);
              }
              function G(oe) {
                return new (C || (C = e.objectAllocator.getNodeConstructor()))(oe, -1, -1);
              }
            }
            e.createBaseNodeFactory = a;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(C) {
              var w, B;
              return { getParenthesizeLeftSideOfBinaryForOperator: E, getParenthesizeRightSideOfBinaryForOperator: Q, parenthesizeLeftSideOfBinary: G, parenthesizeRightSideOfBinary: oe, parenthesizeExpressionOfComputedPropertyName: f, parenthesizeConditionOfConditionalExpression: T, parenthesizeBranchOfConditionalExpression: K, parenthesizeExpressionOfExportDefault: b, parenthesizeExpressionOfNew: se, parenthesizeLeftSideOfAccess: J, parenthesizeOperandOfPostfixUnary: ie, parenthesizeOperandOfPrefixUnary: R, parenthesizeExpressionsOfCommaDelimitedList: q, parenthesizeExpressionForDisallowedComma: O, parenthesizeExpressionOfExpressionStatement: ve, parenthesizeConciseBodyOfArrowFunction: ee, parenthesizeCheckTypeOfConditionalType: he, parenthesizeExtendsTypeOfConditionalType: F, parenthesizeConstituentTypesOfUnionType: X, parenthesizeConstituentTypeOfUnionType: x, parenthesizeConstituentTypesOfIntersectionType: A, parenthesizeConstituentTypeOfIntersectionType: $, parenthesizeOperandOfTypeOperator: y, parenthesizeOperandOfReadonlyTypeOperator: V, parenthesizeNonArrayTypeOfPostfixType: L, parenthesizeElementTypesOfTupleType: P, parenthesizeElementTypeOfTupleType: k, parenthesizeTypeOfOptionalType: U, parenthesizeTypeArguments: I, parenthesizeLeadingTypeArgument: j };
              function E(l) {
                w || (w = new e.Map());
                var d = w.get(l);
                return d || (d = function(D) {
                  return G(l, D);
                }, w.set(l, d)), d;
              }
              function Q(l) {
                B || (B = new e.Map());
                var d = B.get(l);
                return d || (d = function(D) {
                  return oe(l, void 0, D);
                }, B.set(l, d)), d;
              }
              function le(l, d, D, fe) {
                var g = e.getOperatorPrecedence(221, l), ne = e.getOperatorAssociativity(221, l), ue = e.skipPartiallyEmittedExpressions(d);
                if (!D && d.kind === 214 && g > 3) return true;
                var We = e.getExpressionPrecedence(ue);
                switch (e.compareValues(We, g)) {
                  case -1:
                    return !(!D && ne === 1 && d.kind === 224);
                  case 1:
                    return false;
                  case 0:
                    if (D) return ne === 1;
                    if (e.isBinaryExpression(ue) && ue.operatorToken.kind === l) {
                      if (N(l)) return false;
                      if (l === 39) {
                        var Fe = fe ? p(fe) : 0;
                        if (e.isLiteralKind(Fe) && Fe === p(ue)) return false;
                      }
                    }
                    var Z = e.getExpressionAssociativity(ue);
                    return Z === 0;
                }
              }
              function N(l) {
                return l === 41 || l === 51 || l === 50 || l === 52;
              }
              function p(l) {
                if (l = e.skipPartiallyEmittedExpressions(l), e.isLiteralKind(l.kind)) return l.kind;
                if (l.kind === 221 && l.operatorToken.kind === 39) {
                  if (l.cachedLiteralKind !== void 0) return l.cachedLiteralKind;
                  var d = p(l.left), D = e.isLiteralKind(d) && d === p(l.right) ? d : 0;
                  return l.cachedLiteralKind = D, D;
                }
                return 0;
              }
              function m(l, d, D, fe) {
                var g = e.skipPartiallyEmittedExpressions(d);
                return g.kind === 212 ? d : le(l, d, D, fe) ? C.createParenthesizedExpression(d) : d;
              }
              function G(l, d) {
                return m(l, d, true);
              }
              function oe(l, d, D) {
                return m(l, D, false, d);
              }
              function f(l) {
                return e.isCommaSequence(l) ? C.createParenthesizedExpression(l) : l;
              }
              function T(l) {
                var d = e.getOperatorPrecedence(222, 57), D = e.skipPartiallyEmittedExpressions(l), fe = e.getExpressionPrecedence(D);
                return e.compareValues(fe, d) !== 1 ? C.createParenthesizedExpression(l) : l;
              }
              function K(l) {
                var d = e.skipPartiallyEmittedExpressions(l);
                return e.isCommaSequence(d) ? C.createParenthesizedExpression(l) : l;
              }
              function b(l) {
                var d = e.skipPartiallyEmittedExpressions(l), D = e.isCommaSequence(d);
                if (!D) switch (e.getLeftmostExpression(d, false).kind) {
                  case 226:
                  case 213:
                    D = true;
                }
                return D ? C.createParenthesizedExpression(l) : l;
              }
              function se(l) {
                var d = e.getLeftmostExpression(l, true);
                switch (d.kind) {
                  case 208:
                    return C.createParenthesizedExpression(l);
                  case 209:
                    return d.arguments ? l : C.createParenthesizedExpression(l);
                }
                return J(l);
              }
              function J(l) {
                var d = e.skipPartiallyEmittedExpressions(l);
                return e.isLeftHandSideExpression(d) && (d.kind !== 209 || d.arguments) ? l : e.setTextRange(C.createParenthesizedExpression(l), l);
              }
              function ie(l) {
                return e.isLeftHandSideExpression(l) ? l : e.setTextRange(C.createParenthesizedExpression(l), l);
              }
              function R(l) {
                return e.isUnaryExpression(l) ? l : e.setTextRange(C.createParenthesizedExpression(l), l);
              }
              function q(l) {
                var d = e.sameMap(l, O);
                return e.setTextRange(C.createNodeArray(d, l.hasTrailingComma), l);
              }
              function O(l) {
                var d = e.skipPartiallyEmittedExpressions(l), D = e.getExpressionPrecedence(d), fe = e.getOperatorPrecedence(221, 27);
                return D > fe ? l : e.setTextRange(C.createParenthesizedExpression(l), l);
              }
              function ve(l) {
                var d = e.skipPartiallyEmittedExpressions(l);
                if (e.isCallExpression(d)) {
                  var D = d.expression, fe = e.skipPartiallyEmittedExpressions(D).kind;
                  if (fe === 213 || fe === 214) {
                    var g = C.updateCallExpression(d, e.setTextRange(C.createParenthesizedExpression(D), D), d.typeArguments, d.arguments);
                    return C.restoreOuterExpressions(l, g, 8);
                  }
                }
                var ne = e.getLeftmostExpression(d, false).kind;
                return ne === 205 || ne === 213 ? e.setTextRange(C.createParenthesizedExpression(l), l) : l;
              }
              function ee(l) {
                return !e.isBlock(l) && (e.isCommaSequence(l) || e.getLeftmostExpression(l, false).kind === 205) ? e.setTextRange(C.createParenthesizedExpression(l), l) : l;
              }
              function he(l) {
                switch (l.kind) {
                  case 179:
                  case 180:
                  case 189:
                    return C.createParenthesizedType(l);
                }
                return l;
              }
              function F(l) {
                switch (l.kind) {
                  case 189:
                    return C.createParenthesizedType(l);
                }
                return l;
              }
              function x(l) {
                switch (l.kind) {
                  case 187:
                  case 188:
                    return C.createParenthesizedType(l);
                }
                return he(l);
              }
              function X(l) {
                return C.createNodeArray(e.sameMap(l, x));
              }
              function $(l) {
                switch (l.kind) {
                  case 187:
                  case 188:
                    return C.createParenthesizedType(l);
                }
                return x(l);
              }
              function A(l) {
                return C.createNodeArray(e.sameMap(l, $));
              }
              function y(l) {
                switch (l.kind) {
                  case 188:
                    return C.createParenthesizedType(l);
                }
                return $(l);
              }
              function V(l) {
                switch (l.kind) {
                  case 193:
                    return C.createParenthesizedType(l);
                }
                return y(l);
              }
              function L(l) {
                switch (l.kind) {
                  case 190:
                  case 193:
                  case 181:
                    return C.createParenthesizedType(l);
                }
                return y(l);
              }
              function P(l) {
                return C.createNodeArray(e.sameMap(l, k));
              }
              function k(l) {
                return Y(l) ? C.createParenthesizedType(l) : l;
              }
              function Y(l) {
                return e.isJSDocNullableType(l) ? l.postfix : e.isNamedTupleMember(l) || e.isFunctionTypeNode(l) || e.isConstructorTypeNode(l) || e.isTypeOperatorNode(l) ? Y(l.type) : e.isConditionalTypeNode(l) ? Y(l.falseType) : e.isUnionTypeNode(l) || e.isIntersectionTypeNode(l) ? Y(e.last(l.types)) : e.isInferTypeNode(l) ? !!l.typeParameter.constraint && Y(l.typeParameter.constraint) : false;
              }
              function U(l) {
                return Y(l) ? C.createParenthesizedType(l) : L(l);
              }
              function j(l) {
                return e.isFunctionOrConstructorTypeNode(l) && l.typeParameters ? C.createParenthesizedType(l) : l;
              }
              function H(l, d) {
                return d === 0 ? j(l) : l;
              }
              function I(l) {
                if (e.some(l)) return C.createNodeArray(e.sameMap(l, H));
              }
            }
            e.createParenthesizerRules = a, e.nullParenthesizerRules = { getParenthesizeLeftSideOfBinaryForOperator: function(C) {
              return e.identity;
            }, getParenthesizeRightSideOfBinaryForOperator: function(C) {
              return e.identity;
            }, parenthesizeLeftSideOfBinary: function(C, w) {
              return w;
            }, parenthesizeRightSideOfBinary: function(C, w, B) {
              return B;
            }, parenthesizeExpressionOfComputedPropertyName: e.identity, parenthesizeConditionOfConditionalExpression: e.identity, parenthesizeBranchOfConditionalExpression: e.identity, parenthesizeExpressionOfExportDefault: e.identity, parenthesizeExpressionOfNew: function(C) {
              return e.cast(C, e.isLeftHandSideExpression);
            }, parenthesizeLeftSideOfAccess: function(C) {
              return e.cast(C, e.isLeftHandSideExpression);
            }, parenthesizeOperandOfPostfixUnary: function(C) {
              return e.cast(C, e.isLeftHandSideExpression);
            }, parenthesizeOperandOfPrefixUnary: function(C) {
              return e.cast(C, e.isUnaryExpression);
            }, parenthesizeExpressionsOfCommaDelimitedList: function(C) {
              return e.cast(C, e.isNodeArray);
            }, parenthesizeExpressionForDisallowedComma: e.identity, parenthesizeExpressionOfExpressionStatement: e.identity, parenthesizeConciseBodyOfArrowFunction: e.identity, parenthesizeCheckTypeOfConditionalType: e.identity, parenthesizeExtendsTypeOfConditionalType: e.identity, parenthesizeConstituentTypesOfUnionType: function(C) {
              return e.cast(C, e.isNodeArray);
            }, parenthesizeConstituentTypeOfUnionType: e.identity, parenthesizeConstituentTypesOfIntersectionType: function(C) {
              return e.cast(C, e.isNodeArray);
            }, parenthesizeConstituentTypeOfIntersectionType: e.identity, parenthesizeOperandOfTypeOperator: e.identity, parenthesizeOperandOfReadonlyTypeOperator: e.identity, parenthesizeNonArrayTypeOfPostfixType: e.identity, parenthesizeElementTypesOfTupleType: function(C) {
              return e.cast(C, e.isNodeArray);
            }, parenthesizeElementTypeOfTupleType: e.identity, parenthesizeTypeOfOptionalType: e.identity, parenthesizeTypeArguments: function(C) {
              return C && e.cast(C, e.isNodeArray);
            }, parenthesizeLeadingTypeArgument: e.identity };
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(C) {
              return { convertToFunctionBlock: w, convertToFunctionExpression: B, convertToArrayAssignmentElement: E, convertToObjectAssignmentElement: Q, convertToAssignmentPattern: le, convertToObjectAssignmentPattern: N, convertToArrayAssignmentPattern: p, convertToAssignmentElementTarget: m };
              function w(G, oe) {
                if (e.isBlock(G)) return G;
                var f = C.createReturnStatement(G);
                e.setTextRange(f, G);
                var T = C.createBlock([f], oe);
                return e.setTextRange(T, G), T;
              }
              function B(G) {
                if (!G.body) return e.Debug.fail("Cannot convert a FunctionDeclaration without a body");
                var oe = C.createFunctionExpression(G.modifiers, G.asteriskToken, G.name, G.typeParameters, G.parameters, G.type, G.body);
                return e.setOriginalNode(oe, G), e.setTextRange(oe, G), e.getStartsOnNewLine(G) && e.setStartsOnNewLine(oe, true), oe;
              }
              function E(G) {
                if (e.isBindingElement(G)) {
                  if (G.dotDotDotToken) return e.Debug.assertNode(G.name, e.isIdentifier), e.setOriginalNode(e.setTextRange(C.createSpreadElement(G.name), G), G);
                  var oe = m(G.name);
                  return G.initializer ? e.setOriginalNode(e.setTextRange(C.createAssignment(oe, G.initializer), G), G) : oe;
                }
                return e.cast(G, e.isExpression);
              }
              function Q(G) {
                if (e.isBindingElement(G)) {
                  if (G.dotDotDotToken) return e.Debug.assertNode(G.name, e.isIdentifier), e.setOriginalNode(e.setTextRange(C.createSpreadAssignment(G.name), G), G);
                  if (G.propertyName) {
                    var oe = m(G.name);
                    return e.setOriginalNode(e.setTextRange(C.createPropertyAssignment(G.propertyName, G.initializer ? C.createAssignment(oe, G.initializer) : oe), G), G);
                  }
                  return e.Debug.assertNode(G.name, e.isIdentifier), e.setOriginalNode(e.setTextRange(C.createShorthandPropertyAssignment(G.name, G.initializer), G), G);
                }
                return e.cast(G, e.isObjectLiteralElementLike);
              }
              function le(G) {
                switch (G.kind) {
                  case 202:
                  case 204:
                    return p(G);
                  case 201:
                  case 205:
                    return N(G);
                }
              }
              function N(G) {
                return e.isObjectBindingPattern(G) ? e.setOriginalNode(e.setTextRange(C.createObjectLiteralExpression(e.map(G.elements, Q)), G), G) : e.cast(G, e.isObjectLiteralExpression);
              }
              function p(G) {
                return e.isArrayBindingPattern(G) ? e.setOriginalNode(e.setTextRange(C.createArrayLiteralExpression(e.map(G.elements, E)), G), G) : e.cast(G, e.isArrayLiteralExpression);
              }
              function m(G) {
                return e.isBindingPattern(G) ? le(G) : e.cast(G, e.isExpression);
              }
            }
            e.createNodeConverters = a, e.nullNodeConverters = { convertToFunctionBlock: e.notImplemented, convertToFunctionExpression: e.notImplemented, convertToArrayAssignmentElement: e.notImplemented, convertToObjectAssignmentElement: e.notImplemented, convertToAssignmentPattern: e.notImplemented, convertToObjectAssignmentPattern: e.notImplemented, convertToArrayAssignmentPattern: e.notImplemented, convertToAssignmentElementTarget: e.notImplemented };
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a = 0, C;
            (function(X) {
              X[X.None = 0] = "None", X[X.NoParenthesizerRules = 1] = "NoParenthesizerRules", X[X.NoNodeConverters = 2] = "NoNodeConverters", X[X.NoIndentationOnFreshPropertyAccess = 4] = "NoIndentationOnFreshPropertyAccess", X[X.NoOriginalNode = 8] = "NoOriginalNode";
            })(C = e.NodeFactoryFlags || (e.NodeFactoryFlags = {}));
            function w(X, $) {
              var A = X & 8 ? B : E, y = e.memoize(function() {
                return X & 1 ? e.nullParenthesizerRules : e.createParenthesizerRules(g);
              }), V = e.memoize(function() {
                return X & 2 ? e.nullNodeConverters : e.createNodeConverters(g);
              }), L = e.memoizeOne(function(_) {
                return function(W, Te) {
                  return jr(W, _, Te);
                };
              }), P = e.memoizeOne(function(_) {
                return function(W) {
                  return Pt(_, W);
                };
              }), k = e.memoizeOne(function(_) {
                return function(W) {
                  return ua(W, _);
                };
              }), Y = e.memoizeOne(function(_) {
                return function() {
                  return Zl(_);
                };
              }), U = e.memoizeOne(function(_) {
                return function(W) {
                  return kl(_, W);
                };
              }), j = e.memoizeOne(function(_) {
                return function(W, Te) {
                  return zd(_, W, Te);
                };
              }), H = e.memoizeOne(function(_) {
                return function(W, Te) {
                  return R_(_, W, Te);
                };
              }), I = e.memoizeOne(function(_) {
                return function(W, Te) {
                  return __(_, W, Te);
                };
              }), l = e.memoizeOne(function(_) {
                return function(W, Te) {
                  return Wf(_, W, Te);
                };
              }), d = e.memoizeOne(function(_) {
                return function(W, Te, cr) {
                  return Sf(_, W, Te, cr);
                };
              }), D = e.memoizeOne(function(_) {
                return function(W, Te, cr) {
                  return ll(_, W, Te, cr);
                };
              }), fe = e.memoizeOne(function(_) {
                return function(W, Te, cr, ni) {
                  return J_(_, W, Te, cr, ni);
                };
              }), g = { get parenthesizer() {
                return y();
              }, get converters() {
                return V();
              }, baseFactory: $, flags: X, createNodeArray: ne, createNumericLiteral: we, createBigIntLiteral: de, createStringLiteral: Ae, createStringLiteralFromNode: er, createRegularExpressionLiteral: ir, createLiteralLikeNode: Cr, createIdentifier: Er, updateIdentifier: Ne, createTempVariable: n, createLoopVariable: lr, createUniqueName: be, getGeneratedNameForNode: Ge, createPrivateIdentifier: ur, createToken: Ir, createSuper: wr, createThis: Ur, createNull: ii, createTrue: mi, createFalse: pe, createModifier: or, createModifiersFromModifierFlags: qr, createQualifiedName: si, updateQualifiedName: Di, createComputedPropertyName: wi, updateComputedPropertyName: Xi, createTypeParameterDeclaration: et, updateTypeParameterDeclaration: Gi, createParameterDeclaration: Wt, updateParameterDeclaration: Zt, createDecorator: _r, updateDecorator: pi, createPropertySignature: ae, updatePropertySignature: Xe, createPropertyDeclaration: Jr, updatePropertyDeclaration: ti, createMethodSignature: Ze, updateMethodSignature: Sr, createMethodDeclaration: zr, updateMethodDeclaration: Wr, createConstructorDeclaration: vr, updateConstructorDeclaration: mr, createGetAccessorDeclaration: Ar, updateGetAccessorDeclaration: Oe, createSetAccessorDeclaration: nr, updateSetAccessorDeclaration: Mr, createCallSignature: Pe, updateCallSignature: Ue, createConstructSignature: fr, updateConstructSignature: De, createIndexSignature: gr, updateIndexSignature: Vr, createClassStaticBlockDeclaration: Je, updateClassStaticBlockDeclaration: xe, createTemplateLiteralTypeSpan: Tr, updateTemplateLiteralTypeSpan: vi, createKeywordTypeNode: Ui, createTypePredicateNode: Yi, updateTypePredicateNode: Wi, createTypeReferenceNode: ct, updateTypeReferenceNode: Li, createFunctionTypeNode: nt, updateFunctionTypeNode: Mt, createConstructorTypeNode: xt, updateConstructorTypeNode: Rt, createTypeQueryNode: Fi, updateTypeQueryNode: ui, createTypeLiteralNode: Bt, updateTypeLiteralNode: wt, createArrayTypeNode: na, updateArrayTypeNode: Ai, createTupleTypeNode: Oi, updateTupleTypeNode: ji, createNamedTupleMember: Vi, updateNamedTupleMember: at, createOptionalTypeNode: At, updateOptionalTypeNode: ba, createRestTypeNode: $a, updateRestTypeNode: Qa, createUnionTypeNode: ka, updateUnionTypeNode: Ba, createIntersectionTypeNode: pn, updateIntersectionTypeNode: Cn, createConditionalTypeNode: Bi, updateConditionalTypeNode: kn, createInferTypeNode: xn, updateInferTypeNode: Kn, createImportTypeNode: Rn, updateImportTypeNode: Da, createParenthesizedType: bo, updateParenthesizedType: Ro, createThisTypeNode: En, createTypeOperatorNode: Wn, updateTypeOperatorNode: to, createIndexedAccessTypeNode: Co, updateIndexedAccessTypeNode: Ko, createMappedTypeNode: Oo, updateMappedTypeNode: no, createLiteralTypeNode: $o, updateLiteralTypeNode: Pr, createTemplateLiteralType: Pn, updateTemplateLiteralType: eo, createObjectBindingPattern: xi, updateObjectBindingPattern: St, createArrayBindingPattern: pa, updateArrayBindingPattern: dn, createBindingElement: Jn, updateBindingElement: Qe, createArrayLiteralExpression: S, updateArrayLiteralExpression: Ce, createObjectLiteralExpression: qe, updateObjectLiteralExpression: br, createPropertyAccessExpression: X & 4 ? function(_, W) {
                return e.setEmitFlags(Zr(_, W), 131072);
              } : Zr, updatePropertyAccessExpression: Si, createPropertyAccessChain: X & 4 ? function(_, W, Te) {
                return e.setEmitFlags(Pi(_, W, Te), 131072);
              } : Pi, updatePropertyAccessChain: Qi, createElementAccessExpression: Ct, updateElementAccessExpression: sa, createElementAccessChain: en, updateElementAccessChain: Wa, createCallExpression: qn, updateCallExpression: mo, createCallChain: So, updateCallChain: Go, createNewExpression: ys, updateNewExpression: Pc, createTaggedTemplateExpression: Vc, updateTaggedTemplateExpression: Kc, createTypeAssertion: Xs, updateTypeAssertion: pc, createParenthesizedExpression: hs, updateParenthesizedExpression: tc, createFunctionExpression: ps, updateFunctionExpression: Qs, createArrowFunction: js, updateArrowFunction: ds, createDeleteExpression: Ji, updateDeleteExpression: ce, createTypeOfExpression: Rr, updateTypeOfExpression: yi, createVoidExpression: qi, updateVoidExpression: je, createAwaitExpression: Hr, updateAwaitExpression: pt, createPrefixUnaryExpression: Pt, updatePrefixUnaryExpression: ga, createPostfixUnaryExpression: ua, updatePostfixUnaryExpression: Xn, createBinaryExpression: jr, updateBinaryExpression: xs, createConditionalExpression: Fo, updateConditionalExpression: ko, createTemplateExpression: Ao, updateTemplateExpression: Ms, createTemplateHead: su, createTemplateMiddle: tl, createTemplateTail: Zc, createNoSubstitutionTemplateLiteral: Rf, createTemplateLiteralLikeNode: xc, createYieldExpression: al, updateYieldExpression: Jo, createSpreadElement: eu, updateSpreadElement: Ws, createClassExpression: pu, updateClassExpression: Uu, createOmittedExpression: Ql, createExpressionWithTypeArguments: xl, updateExpressionWithTypeArguments: Ya, createAsExpression: du, updateAsExpression: vc, createNonNullExpression: Kr, updateNonNullExpression: _i, createNonNullChain: Ei, updateNonNullChain: tt, createMetaProperty: kt, updateMetaProperty: bt, createTemplateSpan: ia, updateTemplateSpan: Xt, createSemicolonClassElement: Za, createBlock: bn, updateBlock: _a, createVariableStatement: qa, updateVariableStatement: rn, createEmptyStatement: jn, createExpressionStatement: Mo, updateExpressionStatement: ho, createIfStatement: gs, updateIfStatement: Se, createDoStatement: hr, updateDoStatement: Or, createWhileStatement: ki, updateWhileStatement: dt, createForStatement: la, updateForStatement: wa, createForInStatement: On, updateForInStatement: No, createForOfStatement: jo, updateForOfStatement: po, createContinueStatement: Gn, updateContinueStatement: $n, createBreakStatement: Ho, updateBreakStatement: Zo, createReturnStatement: Es, updateReturnStatement: yc, createWithStatement: Xr, updateWithStatement: Ls, createSwitchStatement: Ic, updateSwitchStatement: zu, createLabeledStatement: vf, updateLabeledStatement: P_, createThrowStatement: El, updateThrowStatement: vp, createTryStatement: oo, updateTryStatement: I_, createDebuggerStatement: yp, createVariableDeclaration: Yl, updateVariableDeclaration: Bf, createVariableDeclarationList: Cl, updateVariableDeclarationList: c_, createFunctionDeclaration: hp, updateFunctionDeclaration: gu, createClassDeclaration: Dp, updateClassDeclaration: sd, createInterfaceDeclaration: Aa, updateInterfaceDeclaration: va, createTypeAliasDeclaration: Cu, updateTypeAliasDeclaration: qs, createEnumDeclaration: cd, updateEnumDeclaration: ns, createModuleDeclaration: nl, updateModuleDeclaration: hc, createModuleBlock: es, updateModuleBlock: u_, createCaseBlock: Jf, updateCaseBlock: w_, createNamespaceExportDeclaration: ud, updateNamespaceExportDeclaration: ku, createImportEqualsDeclaration: ld, updateImportEqualsDeclaration: fd, createImportDeclaration: bp, updateImportDeclaration: Sp, createImportClause: Tp, updateImportClause: _d, createAssertClause: jf, updateAssertClause: O_, createAssertEntry: F_, updateAssertEntry: pd, createImportTypeAssertionContainer: xp, updateImportTypeAssertionContainer: M_, createNamespaceImport: Ep, updateNamespaceImport: ol, createNamespaceExport: Au, updateNamespaceExport: ru, createNamedImports: yf, updateNamedImports: Cp, createImportSpecifier: dd, updateImportSpecifier: kp, createExportAssignment: mu, updateExportAssignment: gd, createExportDeclaration: hf, updateExportDeclaration: $l, createNamedExports: Uf, updateNamedExports: L_, createExportSpecifier: l_, updateExportSpecifier: f_, createMissingDeclaration: md, createExternalModuleReference: ks, updateExternalModuleReference: Wu, get createJSDocAllType() {
                return Y(312);
              }, get createJSDocUnknownType() {
                return Y(313);
              }, get createJSDocNonNullableType() {
                return H(315);
              }, get updateJSDocNonNullableType() {
                return I(315);
              }, get createJSDocNullableType() {
                return H(314);
              }, get updateJSDocNullableType() {
                return I(314);
              }, get createJSDocOptionalType() {
                return U(316);
              }, get updateJSDocOptionalType() {
                return j(316);
              }, get createJSDocVariadicType() {
                return U(318);
              }, get updateJSDocVariadicType() {
                return j(318);
              }, get createJSDocNamepathType() {
                return U(319);
              }, get updateJSDocNamepathType() {
                return j(319);
              }, createJSDocFunctionType: Al, updateJSDocFunctionType: wc, createJSDocTypeLiteral: qu, updateJSDocTypeLiteral: Vu, createJSDocTypeExpression: ef, updateJSDocTypeExpression: sl, createJSDocSignature: p_, updateJSDocSignature: Df, createJSDocTemplateTag: os, updateJSDocTemplateTag: Ps, createJSDocTypedefTag: d_, updateJSDocTypedefTag: Gc, createJSDocParameterTag: B_, updateJSDocParameterTag: vu, createJSDocPropertyTag: Gt, updateJSDocPropertyTag: As, createJSDocCallbackTag: vn, updateJSDocCallbackTag: Nl, createJSDocAugmentsTag: cl, updateJSDocAugmentsTag: rf, createJSDocImplementsTag: Ut, updateJSDocImplementsTag: Ap, createJSDocSeeTag: Ds, updateJSDocSeeTag: bf, createJSDocNameReference: bs, updateJSDocNameReference: Dc, createJSDocMemberName: Cc, updateJSDocMemberName: ac, createJSDocLink: Pl, updateJSDocLink: Il, createJSDocLinkCode: zf, updateJSDocLinkCode: ul, createJSDocLinkPlain: Nu, updateJSDocLinkPlain: Us, get createJSDocTypeTag() {
                return D(343);
              }, get updateJSDocTypeTag() {
                return fe(343);
              }, get createJSDocReturnTag() {
                return D(341);
              }, get updateJSDocReturnTag() {
                return fe(341);
              }, get createJSDocThisTag() {
                return D(342);
              }, get updateJSDocThisTag() {
                return fe(342);
              }, get createJSDocEnumTag() {
                return D(339);
              }, get updateJSDocEnumTag() {
                return fe(339);
              }, get createJSDocAuthorTag() {
                return l(330);
              }, get updateJSDocAuthorTag() {
                return d(330);
              }, get createJSDocClassTag() {
                return l(332);
              }, get updateJSDocClassTag() {
                return d(332);
              }, get createJSDocPublicTag() {
                return l(333);
              }, get updateJSDocPublicTag() {
                return d(333);
              }, get createJSDocPrivateTag() {
                return l(334);
              }, get updateJSDocPrivateTag() {
                return d(334);
              }, get createJSDocProtectedTag() {
                return l(335);
              }, get updateJSDocProtectedTag() {
                return d(335);
              }, get createJSDocReadonlyTag() {
                return l(336);
              }, get updateJSDocReadonlyTag() {
                return d(336);
              }, get createJSDocOverrideTag() {
                return l(337);
              }, get updateJSDocOverrideTag() {
                return d(337);
              }, get createJSDocDeprecatedTag() {
                return l(331);
              }, get updateJSDocDeprecatedTag() {
                return d(331);
              }, createJSDocUnknownTag: j_, updateJSDocUnknownTag: U_, createJSDocText: iu, updateJSDocText: vd, createJSDocComment: qf, updateJSDocComment: dc, createJsxElement: Pu, updateJsxElement: wl, createJsxSelfClosingElement: Iu, updateJsxSelfClosingElement: so, createJsxOpeningElement: Et, updateJsxOpeningElement: Ys, createJsxClosingElement: Ku, updateJsxClosingElement: Np, createJsxFragment: Pp, createJsxText: fl, updateJsxText: _l, createJsxOpeningFragment: cu, createJsxJsxClosingFragment: gc, updateJsxFragment: nc, createJsxAttribute: Tf, updateJsxAttribute: mc, createJsxAttributes: Ip, updateJsxAttributes: ms, createJsxSpreadAttribute: tu, updateJsxSpreadAttribute: wp, createJsxExpression: Hc, updateJsxExpression: Ol, createCaseClause: tf, updateCaseClause: xf, createDefaultClause: z_, updateDefaultClause: Oc, createHeritageClause: rs, updateHeritageClause: Op, createCatchClause: Ef, updateCatchClause: Fl, createPropertyAssignment: pl, updatePropertyAssignment: Mp, createShorthandPropertyAssignment: Gu, updateShorthandPropertyAssignment: Cf, createSpreadAssignment: W_, updateSpreadAssignment: g_, createEnumMember: dl, updateEnumMember: gl, createSourceFile: Vf, updateSourceFile: Hu, createBundle: af, updateBundle: tn, createUnparsedSource: Ml, createUnparsedPrologue: nf, createUnparsedPrepend: q_, createUnparsedTextLike: Kf, createUnparsedSyntheticReference: Rp, createInputFiles: yd, createSyntheticExpression: m_, createSyntaxList: Ll, createNotEmittedStatement: hd, createPartiallyEmittedExpression: v_, updatePartiallyEmittedExpression: Bp, createCommaListExpression: Xc, updateCommaListExpression: Gf, createEndOfDeclarationMarker: of, createMergeDeclarationMarker: wu, createSyntheticReferenceExpression: V_, updateSyntheticReferenceExpression: yu, cloneNode: v, get createComma() {
                return L(27);
              }, get createAssignment() {
                return L(63);
              }, get createLogicalOr() {
                return L(56);
              }, get createLogicalAnd() {
                return L(55);
              }, get createBitwiseOr() {
                return L(51);
              }, get createBitwiseXor() {
                return L(52);
              }, get createBitwiseAnd() {
                return L(50);
              }, get createStrictEquality() {
                return L(36);
              }, get createStrictInequality() {
                return L(37);
              }, get createEquality() {
                return L(34);
              }, get createInequality() {
                return L(35);
              }, get createLessThan() {
                return L(29);
              }, get createLessThanEquals() {
                return L(32);
              }, get createGreaterThan() {
                return L(31);
              }, get createGreaterThanEquals() {
                return L(33);
              }, get createLeftShift() {
                return L(47);
              }, get createRightShift() {
                return L(48);
              }, get createUnsignedRightShift() {
                return L(49);
              }, get createAdd() {
                return L(39);
              }, get createSubtract() {
                return L(40);
              }, get createMultiply() {
                return L(41);
              }, get createDivide() {
                return L(43);
              }, get createModulo() {
                return L(44);
              }, get createExponent() {
                return L(42);
              }, get createPrefixPlus() {
                return P(39);
              }, get createPrefixMinus() {
                return P(40);
              }, get createPrefixIncrement() {
                return P(45);
              }, get createPrefixDecrement() {
                return P(46);
              }, get createBitwiseNot() {
                return P(54);
              }, get createLogicalNot() {
                return P(53);
              }, get createPostfixIncrement() {
                return k(45);
              }, get createPostfixDecrement() {
                return k(46);
              }, createImmediatelyInvokedFunctionExpression: sr, createImmediatelyInvokedArrowFunction: fi, createVoidZero: zi, createExportDefault: Sa, createExternalModuleExport: da, createTypeCheck: Ha, createMethodCall: ta, createGlobalMethodCall: oc, createFunctionBindCall: nn, createFunctionCallCall: Wo, createFunctionApplyCall: Lo, createArraySliceCall: uu, createArrayConcatCall: is, createObjectDefinePropertyCall: au, createReflectGetCall: Ou, createReflectSetCall: sf, createPropertyDescriptor: cf, createCallBinding: G_, createAssignmentTargetWrapper: Le, inlineExpressions: Nr, getInternalName: di, getLocalName: Mi, getExportName: st, getDeclarationName: ra, getNamespaceMemberName: Ta, getExternalModuleOrNamespaceExportName: ha, restoreOuterExpressions: Jp, restoreEnclosingLabel: Hf, createUseStrictPrologue: qo, copyPrologue: Na, copyStandardPrologue: co, copyCustomPrologue: ts, ensureUseStrict: vs, liftToBlock: Ac, mergeLexicalEnvironment: Qu, updateModifiers: sc };
              return g;
              function ne(_, W) {
                if (_ === void 0 || _ === e.emptyArray) _ = [];
                else if (e.isNodeArray(_)) {
                  if (W === void 0 || _.hasTrailingComma === W) return _.transformFlags === void 0 && T(_), e.Debug.attachNodeArrayDebugInfo(_), _;
                  var Te = _.slice();
                  return Te.pos = _.pos, Te.end = _.end, Te.hasTrailingComma = W, Te.transformFlags = _.transformFlags, e.Debug.attachNodeArrayDebugInfo(Te), Te;
                }
                var cr = _.length, ni = cr >= 1 && cr <= 4 ? _.slice() : _;
                return e.setTextRangePosEnd(ni, -1, -1), ni.hasTrailingComma = !!W, T(ni), e.Debug.attachNodeArrayDebugInfo(ni), ni;
              }
              function ue(_) {
                return $.createBaseNode(_);
              }
              function We(_, W, Te) {
                var cr = ue(_);
                return cr.decorators = bc(W), cr.modifiers = bc(Te), cr.transformFlags |= f(cr.decorators) | f(cr.modifiers), cr.symbol = void 0, cr.localSymbol = void 0, cr.locals = void 0, cr.nextContainer = void 0, cr;
              }
              function Fe(_, W, Te, cr) {
                var ni = We(_, W, Te);
                if (cr = Mc(cr), ni.name = cr, cr) switch (ni.kind) {
                  case 169:
                  case 172:
                  case 173:
                  case 167:
                  case 296:
                    if (e.isIdentifier(cr)) {
                      ni.transformFlags |= m(cr);
                      break;
                    }
                  default:
                    ni.transformFlags |= oe(cr);
                    break;
                }
                return ni;
              }
              function Z(_, W, Te, cr, ni) {
                var rt = Fe(_, W, Te, cr);
                return rt.typeParameters = bc(ni), rt.transformFlags |= f(rt.typeParameters), ni && (rt.transformFlags |= 1), rt;
              }
              function Be(_, W, Te, cr, ni, rt, yt) {
                var Xa = Z(_, W, Te, cr, ni);
                return Xa.parameters = ne(rt), Xa.type = yt, Xa.transformFlags |= f(Xa.parameters) | oe(Xa.type), yt && (Xa.transformFlags |= 1), Xa;
              }
              function ge(_, W) {
                return W.typeArguments && (_.typeArguments = W.typeArguments), A(_, W);
              }
              function Re(_, W, Te, cr, ni, rt, yt, Xa) {
                var vo = Be(_, W, Te, cr, ni, rt, yt);
                return vo.body = Xa, vo.transformFlags |= oe(vo.body) & -16777217, Xa || (vo.transformFlags |= 1), vo;
              }
              function ze(_, W) {
                return W.exclamationToken && (_.exclamationToken = W.exclamationToken), W.typeArguments && (_.typeArguments = W.typeArguments), ge(_, W);
              }
              function Ee(_, W, Te, cr, ni, rt) {
                var yt = Z(_, W, Te, cr, ni);
                return yt.heritageClauses = bc(rt), yt.transformFlags |= f(yt.heritageClauses), yt;
              }
              function He(_, W, Te, cr, ni, rt, yt) {
                var Xa = Ee(_, W, Te, cr, ni, rt);
                return Xa.members = ne(yt), Xa.transformFlags |= f(Xa.members), Xa;
              }
              function rr(_, W, Te, cr, ni) {
                var rt = Fe(_, W, Te, cr);
                return rt.initializer = ni, rt.transformFlags |= oe(rt.initializer), rt;
              }
              function Ie(_, W, Te, cr, ni, rt) {
                var yt = rr(_, W, Te, cr, rt);
                return yt.type = ni, yt.transformFlags |= oe(ni), ni && (yt.transformFlags |= 1), yt;
              }
              function _e(_, W) {
                var Te = yr(_);
                return Te.text = W, Te;
              }
              function we(_, W) {
                W === void 0 && (W = 0);
                var Te = _e(8, typeof _ == "number" ? _ + "" : _);
                return Te.numericLiteralFlags = W, W & 384 && (Te.transformFlags |= 1024), Te;
              }
              function de(_) {
                var W = _e(9, typeof _ == "string" ? _ : e.pseudoBigIntToString(_) + "n");
                return W.transformFlags |= 4, W;
              }
              function ye(_, W) {
                var Te = _e(10, _);
                return Te.singleQuote = W, Te;
              }
              function Ae(_, W, Te) {
                var cr = ye(_, W);
                return cr.hasExtendedUnicodeEscape = Te, Te && (cr.transformFlags |= 1024), cr;
              }
              function er(_) {
                var W = ye(e.getTextOfIdentifierOrLiteral(_), void 0);
                return W.textSourceNode = _, W;
              }
              function ir(_) {
                var W = _e(13, _);
                return W;
              }
              function Cr(_, W) {
                switch (_) {
                  case 8:
                    return we(W, 0);
                  case 9:
                    return de(W);
                  case 10:
                    return Ae(W, void 0);
                  case 11:
                    return fl(W, false);
                  case 12:
                    return fl(W, true);
                  case 13:
                    return ir(W);
                  case 14:
                    return xc(_, W, void 0, 0);
                }
              }
              function Ye(_, W) {
                W === void 0 && _ && (W = e.stringToToken(_)), W === 79 && (W = void 0);
                var Te = $.createBaseIdentifierNode(79);
                return Te.originalKeywordKind = W, Te.escapedText = e.escapeLeadingUnderscores(_), Te;
              }
              function Br(_, W) {
                var Te = Ye(_, void 0);
                return Te.autoGenerateFlags = W, Te.autoGenerateId = a, a++, Te;
              }
              function Er(_, W, Te) {
                var cr = Ye(_, Te);
                return W && (cr.typeArguments = ne(W)), cr.originalKeywordKind === 132 && (cr.transformFlags |= 16777216), cr;
              }
              function Ne(_, W) {
                return _.typeArguments !== W ? A(Er(e.idText(_), W), _) : _;
              }
              function n(_, W) {
                var Te = 1;
                W && (Te |= 8);
                var cr = Br("", Te);
                return _ && _(cr), cr;
              }
              function lr(_) {
                var W = 2;
                return _ && (W |= 8), Br("", W);
              }
              function be(_, W) {
                return W === void 0 && (W = 0), e.Debug.assert(!(W & 7), "Argument out of range: flags"), e.Debug.assert((W & 48) !== 32, "GeneratedIdentifierFlags.FileLevel cannot be set without also setting GeneratedIdentifierFlags.Optimistic"), Br(_, 3 | W);
              }
              function Ge(_, W) {
                W === void 0 && (W = 0), e.Debug.assert(!(W & 7), "Argument out of range: flags");
                var Te = Br(_ && e.isIdentifier(_) ? e.idText(_) : "", 4 | W);
                return Te.original = _, Te;
              }
              function ur(_) {
                e.startsWith(_, "#") || e.Debug.fail("First character of private identifier must be #: " + _);
                var W = $.createBasePrivateIdentifierNode(80);
                return W.escapedText = e.escapeLeadingUnderscores(_), W.transformFlags |= 8388608, W;
              }
              function yr(_) {
                return $.createBaseTokenNode(_);
              }
              function Ir(_) {
                e.Debug.assert(_ >= 0 && _ <= 160, "Invalid token"), e.Debug.assert(_ <= 14 || _ >= 17, "Invalid token. Use 'createTemplateLiteralLikeNode' to create template literals."), e.Debug.assert(_ <= 8 || _ >= 14, "Invalid token. Use 'createLiteralLikeNode' to create literals."), e.Debug.assert(_ !== 79, "Invalid token. Use 'createIdentifier' to create identifiers");
                var W = yr(_), Te = 0;
                switch (_) {
                  case 131:
                    Te = 384;
                    break;
                  case 123:
                  case 121:
                  case 122:
                  case 145:
                  case 126:
                  case 135:
                  case 85:
                  case 130:
                  case 147:
                  case 158:
                  case 143:
                  case 148:
                  case 101:
                  case 144:
                  case 159:
                  case 150:
                  case 133:
                  case 151:
                  case 114:
                  case 155:
                  case 153:
                    Te = 1;
                    break;
                  case 106:
                    Te = 33555456;
                    break;
                  case 124:
                    Te = 1024;
                    break;
                  case 108:
                    Te = 8192;
                    break;
                }
                return Te && (W.transformFlags |= Te), W;
              }
              function wr() {
                return Ir(106);
              }
              function Ur() {
                return Ir(108);
              }
              function ii() {
                return Ir(104);
              }
              function mi() {
                return Ir(110);
              }
              function pe() {
                return Ir(95);
              }
              function or(_) {
                return Ir(_);
              }
              function qr(_) {
                var W = [];
                return _ & 1 && W.push(or(93)), _ & 2 && W.push(or(135)), _ & 512 && W.push(or(88)), _ & 2048 && W.push(or(85)), _ & 4 && W.push(or(123)), _ & 8 && W.push(or(121)), _ & 16 && W.push(or(122)), _ & 128 && W.push(or(126)), _ & 32 && W.push(or(124)), _ & 16384 && W.push(or(159)), _ & 64 && W.push(or(145)), _ & 256 && W.push(or(131)), _ & 32768 && W.push(or(101)), _ & 65536 && W.push(or(144)), W.length ? W : void 0;
              }
              function si(_, W) {
                var Te = ue(161);
                return Te.left = _, Te.right = Mc(W), Te.transformFlags |= oe(Te.left) | m(Te.right), Te;
              }
              function Di(_, W, Te) {
                return _.left !== W || _.right !== Te ? A(si(W, Te), _) : _;
              }
              function wi(_) {
                var W = ue(162);
                return W.expression = y().parenthesizeExpressionOfComputedPropertyName(_), W.transformFlags |= oe(W.expression) | 1024 | 65536, W;
              }
              function Xi(_, W) {
                return _.expression !== W ? A(wi(W), _) : _;
              }
              function et(_, W, Te, cr) {
                var ni, rt, yt;
                _ === void 0 || e.isArray(_) ? (rt = _, ni = W, yt = Te) : (rt = void 0, ni = _, yt = W);
                var Xa = Fe(163, void 0, rt, ni);
                return Xa.constraint = yt, Xa.default = cr, Xa.transformFlags = 1, Xa;
              }
              function Gi(_, W, Te, cr, ni) {
                var rt, yt, Xa;
                return W === void 0 || e.isArray(W) ? (yt = W, rt = Te, Xa = cr) : (yt = void 0, rt = W, Xa = Te), _.modifiers !== yt || _.name !== rt || _.constraint !== Xa || _.default !== ni ? A(et(yt, rt, Xa, ni), _) : _;
              }
              function Wt(_, W, Te, cr, ni, rt, yt) {
                var Xa = Ie(164, _, W, cr, rt, yt && y().parenthesizeExpressionForDisallowedComma(yt));
                return Xa.dotDotDotToken = Te, Xa.questionToken = ni, e.isThisIdentifier(Xa.name) ? Xa.transformFlags = 1 : (Xa.transformFlags |= oe(Xa.dotDotDotToken) | oe(Xa.questionToken), ni && (Xa.transformFlags |= 1), e.modifiersToFlags(Xa.modifiers) & 16476 && (Xa.transformFlags |= 4096), (yt || Te) && (Xa.transformFlags |= 1024)), Xa;
              }
              function Zt(_, W, Te, cr, ni, rt, yt, Xa) {
                return _.decorators !== W || _.modifiers !== Te || _.dotDotDotToken !== cr || _.name !== ni || _.questionToken !== rt || _.type !== yt || _.initializer !== Xa ? A(Wt(W, Te, cr, ni, rt, yt, Xa), _) : _;
              }
              function _r(_) {
                var W = ue(165);
                return W.expression = y().parenthesizeLeftSideOfAccess(_), W.transformFlags |= oe(W.expression) | 1 | 4096, W;
              }
              function pi(_, W) {
                return _.expression !== W ? A(_r(W), _) : _;
              }
              function ae(_, W, Te, cr) {
                var ni = Fe(166, void 0, _, W);
                return ni.type = cr, ni.questionToken = Te, ni.transformFlags = 1, ni;
              }
              function Xe(_, W, Te, cr, ni) {
                return _.modifiers !== W || _.name !== Te || _.questionToken !== cr || _.type !== ni ? A(ae(W, Te, cr, ni), _) : _;
              }
              function Jr(_, W, Te, cr, ni, rt) {
                var yt = Ie(167, _, W, Te, ni, rt);
                return yt.questionToken = cr && e.isQuestionToken(cr) ? cr : void 0, yt.exclamationToken = cr && e.isExclamationToken(cr) ? cr : void 0, yt.transformFlags |= oe(yt.questionToken) | oe(yt.exclamationToken) | 8388608, (e.isComputedPropertyName(yt.name) || e.hasStaticModifier(yt) && yt.initializer) && (yt.transformFlags |= 4096), (cr || e.modifiersToFlags(yt.modifiers) & 2) && (yt.transformFlags |= 1), yt;
              }
              function ti(_, W, Te, cr, ni, rt, yt) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.questionToken !== (ni !== void 0 && e.isQuestionToken(ni) ? ni : void 0) || _.exclamationToken !== (ni !== void 0 && e.isExclamationToken(ni) ? ni : void 0) || _.type !== rt || _.initializer !== yt ? A(Jr(W, Te, cr, ni, rt, yt), _) : _;
              }
              function Ze(_, W, Te, cr, ni, rt) {
                var yt = Be(168, void 0, _, W, cr, ni, rt);
                return yt.questionToken = Te, yt.transformFlags = 1, yt;
              }
              function Sr(_, W, Te, cr, ni, rt, yt) {
                return _.modifiers !== W || _.name !== Te || _.questionToken !== cr || _.typeParameters !== ni || _.parameters !== rt || _.type !== yt ? ge(Ze(W, Te, cr, ni, rt, yt), _) : _;
              }
              function zr(_, W, Te, cr, ni, rt, yt, Xa, vo) {
                var Vs = Re(169, _, W, cr, rt, yt, Xa, vo);
                return Vs.asteriskToken = Te, Vs.questionToken = ni, Vs.transformFlags |= oe(Vs.asteriskToken) | oe(Vs.questionToken) | 1024, ni && (Vs.transformFlags |= 1), e.modifiersToFlags(Vs.modifiers) & 256 ? Te ? Vs.transformFlags |= 128 : Vs.transformFlags |= 256 : Te && (Vs.transformFlags |= 2048), Vs;
              }
              function Wr(_, W, Te, cr, ni, rt, yt, Xa, vo, Vs) {
                return _.decorators !== W || _.modifiers !== Te || _.asteriskToken !== cr || _.name !== ni || _.questionToken !== rt || _.typeParameters !== yt || _.parameters !== Xa || _.type !== vo || _.body !== Vs ? ze(zr(W, Te, cr, ni, rt, yt, Xa, vo, Vs), _) : _;
              }
              function Je(_, W, Te) {
                var cr = Z(170, _, W, void 0, void 0);
                return cr.body = Te, cr.transformFlags = oe(Te) | 8388608, cr;
              }
              function xe(_, W, Te, cr) {
                return _.decorators !== W || _.modifier !== Te || _.body !== cr ? A(Je(W, Te, cr), _) : _;
              }
              function vr(_, W, Te, cr) {
                var ni = Re(171, _, W, void 0, void 0, Te, void 0, cr);
                return ni.transformFlags |= 1024, ni;
              }
              function mr(_, W, Te, cr, ni) {
                return _.decorators !== W || _.modifiers !== Te || _.parameters !== cr || _.body !== ni ? ze(vr(W, Te, cr, ni), _) : _;
              }
              function Ar(_, W, Te, cr, ni, rt) {
                return Re(172, _, W, Te, void 0, cr, ni, rt);
              }
              function Oe(_, W, Te, cr, ni, rt, yt) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.parameters !== ni || _.type !== rt || _.body !== yt ? ze(Ar(W, Te, cr, ni, rt, yt), _) : _;
              }
              function nr(_, W, Te, cr, ni) {
                return Re(173, _, W, Te, void 0, cr, void 0, ni);
              }
              function Mr(_, W, Te, cr, ni, rt) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.parameters !== ni || _.body !== rt ? ze(nr(W, Te, cr, ni, rt), _) : _;
              }
              function Pe(_, W, Te) {
                var cr = Be(174, void 0, void 0, void 0, _, W, Te);
                return cr.transformFlags = 1, cr;
              }
              function Ue(_, W, Te, cr) {
                return _.typeParameters !== W || _.parameters !== Te || _.type !== cr ? ge(Pe(W, Te, cr), _) : _;
              }
              function fr(_, W, Te) {
                var cr = Be(175, void 0, void 0, void 0, _, W, Te);
                return cr.transformFlags = 1, cr;
              }
              function De(_, W, Te, cr) {
                return _.typeParameters !== W || _.parameters !== Te || _.type !== cr ? ge(fr(W, Te, cr), _) : _;
              }
              function gr(_, W, Te, cr) {
                var ni = Be(176, _, W, void 0, void 0, Te, cr);
                return ni.transformFlags = 1, ni;
              }
              function Vr(_, W, Te, cr, ni) {
                return _.parameters !== cr || _.type !== ni || _.decorators !== W || _.modifiers !== Te ? ge(gr(W, Te, cr, ni), _) : _;
              }
              function Tr(_, W) {
                var Te = ue(199);
                return Te.type = _, Te.literal = W, Te.transformFlags = 1, Te;
              }
              function vi(_, W, Te) {
                return _.type !== W || _.literal !== Te ? A(Tr(W, Te), _) : _;
              }
              function Ui(_) {
                return Ir(_);
              }
              function Yi(_, W, Te) {
                var cr = ue(177);
                return cr.assertsModifier = _, cr.parameterName = Mc(W), cr.type = Te, cr.transformFlags = 1, cr;
              }
              function Wi(_, W, Te, cr) {
                return _.assertsModifier !== W || _.parameterName !== Te || _.type !== cr ? A(Yi(W, Te, cr), _) : _;
              }
              function ct(_, W) {
                var Te = ue(178);
                return Te.typeName = Mc(_), Te.typeArguments = W && y().parenthesizeTypeArguments(ne(W)), Te.transformFlags = 1, Te;
              }
              function Li(_, W, Te) {
                return _.typeName !== W || _.typeArguments !== Te ? A(ct(W, Te), _) : _;
              }
              function nt(_, W, Te) {
                var cr = Be(179, void 0, void 0, void 0, _, W, Te);
                return cr.transformFlags = 1, cr;
              }
              function Mt(_, W, Te, cr) {
                return _.typeParameters !== W || _.parameters !== Te || _.type !== cr ? ge(nt(W, Te, cr), _) : _;
              }
              function xt() {
                for (var _ = [], W = 0; W < arguments.length; W++) _[W] = arguments[W];
                return _.length === 4 ? ut.apply(void 0, _) : _.length === 3 ? Dt.apply(void 0, _) : e.Debug.fail("Incorrect number of arguments specified.");
              }
              function ut(_, W, Te, cr) {
                var ni = Be(180, void 0, _, void 0, W, Te, cr);
                return ni.transformFlags = 1, ni;
              }
              function Dt(_, W, Te) {
                return ut(void 0, _, W, Te);
              }
              function Rt() {
                for (var _ = [], W = 0; W < arguments.length; W++) _[W] = arguments[W];
                return _.length === 5 ? Ii.apply(void 0, _) : _.length === 4 ? Ki.apply(void 0, _) : e.Debug.fail("Incorrect number of arguments specified.");
              }
              function Ii(_, W, Te, cr, ni) {
                return _.modifiers !== W || _.typeParameters !== Te || _.parameters !== cr || _.type !== ni ? ge(xt(W, Te, cr, ni), _) : _;
              }
              function Ki(_, W, Te, cr) {
                return Ii(_, _.modifiers, W, Te, cr);
              }
              function Fi(_, W) {
                var Te = ue(181);
                return Te.exprName = _, Te.typeArguments = W && y().parenthesizeTypeArguments(W), Te.transformFlags = 1, Te;
              }
              function ui(_, W, Te) {
                return _.exprName !== W || _.typeArguments !== Te ? A(Fi(W, Te), _) : _;
              }
              function Bt(_) {
                var W = ue(182);
                return W.members = ne(_), W.transformFlags = 1, W;
              }
              function wt(_, W) {
                return _.members !== W ? A(Bt(W), _) : _;
              }
              function na(_) {
                var W = ue(183);
                return W.elementType = y().parenthesizeNonArrayTypeOfPostfixType(_), W.transformFlags = 1, W;
              }
              function Ai(_, W) {
                return _.elementType !== W ? A(na(W), _) : _;
              }
              function Oi(_) {
                var W = ue(184);
                return W.elements = ne(y().parenthesizeElementTypesOfTupleType(_)), W.transformFlags = 1, W;
              }
              function ji(_, W) {
                return _.elements !== W ? A(Oi(W), _) : _;
              }
              function Vi(_, W, Te, cr) {
                var ni = ue(197);
                return ni.dotDotDotToken = _, ni.name = W, ni.questionToken = Te, ni.type = cr, ni.transformFlags = 1, ni;
              }
              function at(_, W, Te, cr, ni) {
                return _.dotDotDotToken !== W || _.name !== Te || _.questionToken !== cr || _.type !== ni ? A(Vi(W, Te, cr, ni), _) : _;
              }
              function At(_) {
                var W = ue(185);
                return W.type = y().parenthesizeTypeOfOptionalType(_), W.transformFlags = 1, W;
              }
              function ba(_, W) {
                return _.type !== W ? A(At(W), _) : _;
              }
              function $a(_) {
                var W = ue(186);
                return W.type = _, W.transformFlags = 1, W;
              }
              function Qa(_, W) {
                return _.type !== W ? A($a(W), _) : _;
              }
              function ai(_, W, Te) {
                var cr = ue(_);
                return cr.types = g.createNodeArray(Te(W)), cr.transformFlags = 1, cr;
              }
              function Dn(_, W, Te) {
                return _.types !== W ? A(ai(_.kind, W, Te), _) : _;
              }
              function ka(_) {
                return ai(187, _, y().parenthesizeConstituentTypesOfUnionType);
              }
              function Ba(_, W) {
                return Dn(_, W, y().parenthesizeConstituentTypesOfUnionType);
              }
              function pn(_) {
                return ai(188, _, y().parenthesizeConstituentTypesOfIntersectionType);
              }
              function Cn(_, W) {
                return Dn(_, W, y().parenthesizeConstituentTypesOfIntersectionType);
              }
              function Bi(_, W, Te, cr) {
                var ni = ue(189);
                return ni.checkType = y().parenthesizeCheckTypeOfConditionalType(_), ni.extendsType = y().parenthesizeExtendsTypeOfConditionalType(W), ni.trueType = Te, ni.falseType = cr, ni.transformFlags = 1, ni;
              }
              function kn(_, W, Te, cr, ni) {
                return _.checkType !== W || _.extendsType !== Te || _.trueType !== cr || _.falseType !== ni ? A(Bi(W, Te, cr, ni), _) : _;
              }
              function xn(_) {
                var W = ue(190);
                return W.typeParameter = _, W.transformFlags = 1, W;
              }
              function Kn(_, W) {
                return _.typeParameter !== W ? A(xn(W), _) : _;
              }
              function Pn(_, W) {
                var Te = ue(198);
                return Te.head = _, Te.templateSpans = ne(W), Te.transformFlags = 1, Te;
              }
              function eo(_, W, Te) {
                return _.head !== W || _.templateSpans !== Te ? A(Pn(W, Te), _) : _;
              }
              function Rn(_, W, Te, cr, ni) {
                var rt = W && W.kind === 295 ? W : void 0, yt = W && e.isEntityName(W) ? W : Te && !e.isArray(Te) ? Te : void 0, Xa = e.isArray(Te) ? Te : e.isArray(cr) ? cr : void 0;
                ni = typeof cr == "boolean" ? cr : typeof ni == "boolean" ? ni : false;
                var vo = ue(200);
                return vo.argument = _, vo.assertions = rt, vo.qualifier = yt, vo.typeArguments = Xa && y().parenthesizeTypeArguments(Xa), vo.isTypeOf = ni, vo.transformFlags = 1, vo;
              }
              function Da(_, W, Te, cr, ni, rt) {
                var yt = Te && Te.kind === 295 ? Te : void 0, Xa = Te && e.isEntityName(Te) ? Te : cr && !e.isArray(cr) ? cr : void 0, vo = e.isArray(cr) ? cr : e.isArray(ni) ? ni : void 0;
                return rt = typeof ni == "boolean" ? ni : typeof rt == "boolean" ? rt : _.isTypeOf, _.argument !== W || _.assertions !== yt || _.qualifier !== Xa || _.typeArguments !== vo || _.isTypeOf !== rt ? A(Rn(W, yt, Xa, vo, rt), _) : _;
              }
              function bo(_) {
                var W = ue(191);
                return W.type = _, W.transformFlags = 1, W;
              }
              function Ro(_, W) {
                return _.type !== W ? A(bo(W), _) : _;
              }
              function En() {
                var _ = ue(192);
                return _.transformFlags = 1, _;
              }
              function Wn(_, W) {
                var Te = ue(193);
                return Te.operator = _, Te.type = _ === 145 ? y().parenthesizeOperandOfReadonlyTypeOperator(W) : y().parenthesizeOperandOfTypeOperator(W), Te.transformFlags = 1, Te;
              }
              function to(_, W) {
                return _.type !== W ? A(Wn(_.operator, W), _) : _;
              }
              function Co(_, W) {
                var Te = ue(194);
                return Te.objectType = y().parenthesizeNonArrayTypeOfPostfixType(_), Te.indexType = W, Te.transformFlags = 1, Te;
              }
              function Ko(_, W, Te) {
                return _.objectType !== W || _.indexType !== Te ? A(Co(W, Te), _) : _;
              }
              function Oo(_, W, Te, cr, ni, rt) {
                var yt = ue(195);
                return yt.readonlyToken = _, yt.typeParameter = W, yt.nameType = Te, yt.questionToken = cr, yt.type = ni, yt.members = rt && ne(rt), yt.transformFlags = 1, yt;
              }
              function no(_, W, Te, cr, ni, rt, yt) {
                return _.readonlyToken !== W || _.typeParameter !== Te || _.nameType !== cr || _.questionToken !== ni || _.type !== rt || _.members !== yt ? A(Oo(W, Te, cr, ni, rt, yt), _) : _;
              }
              function $o(_) {
                var W = ue(196);
                return W.literal = _, W.transformFlags = 1, W;
              }
              function Pr(_, W) {
                return _.literal !== W ? A($o(W), _) : _;
              }
              function xi(_) {
                var W = ue(201);
                return W.elements = ne(_), W.transformFlags |= f(W.elements) | 1024 | 262144, W.transformFlags & 16384 && (W.transformFlags |= 32896), W;
              }
              function St(_, W) {
                return _.elements !== W ? A(xi(W), _) : _;
              }
              function pa(_) {
                var W = ue(202);
                return W.elements = ne(_), W.transformFlags |= f(W.elements) | 1024 | 262144, W;
              }
              function dn(_, W) {
                return _.elements !== W ? A(pa(W), _) : _;
              }
              function Jn(_, W, Te, cr) {
                var ni = rr(203, void 0, void 0, Te, cr && y().parenthesizeExpressionForDisallowedComma(cr));
                return ni.propertyName = Mc(W), ni.dotDotDotToken = _, ni.transformFlags |= oe(ni.dotDotDotToken) | 1024, ni.propertyName && (ni.transformFlags |= e.isIdentifier(ni.propertyName) ? m(ni.propertyName) : oe(ni.propertyName)), _ && (ni.transformFlags |= 16384), ni;
              }
              function Qe(_, W, Te, cr, ni) {
                return _.propertyName !== Te || _.dotDotDotToken !== W || _.name !== cr || _.initializer !== ni ? A(Jn(W, Te, cr, ni), _) : _;
              }
              function Gr(_) {
                var W = ue(_);
                return W;
              }
              function S(_, W) {
                var Te = Gr(204), cr = _ && e.lastOrUndefined(_), ni = ne(_, cr && e.isOmittedExpression(cr) ? true : void 0);
                return Te.elements = y().parenthesizeExpressionsOfCommaDelimitedList(ni), Te.multiLine = W, Te.transformFlags |= f(Te.elements), Te;
              }
              function Ce(_, W) {
                return _.elements !== W ? A(S(W, _.multiLine), _) : _;
              }
              function qe(_, W) {
                var Te = Gr(205);
                return Te.properties = ne(_), Te.multiLine = W, Te.transformFlags |= f(Te.properties), Te;
              }
              function br(_, W) {
                return _.properties !== W ? A(qe(W, _.multiLine), _) : _;
              }
              function Zr(_, W) {
                var Te = Gr(206);
                return Te.expression = y().parenthesizeLeftSideOfAccess(_), Te.name = Mc(W), Te.transformFlags = oe(Te.expression) | (e.isIdentifier(Te.name) ? m(Te.name) : oe(Te.name)), e.isSuperKeyword(_) && (Te.transformFlags |= 384), Te;
              }
              function Si(_, W, Te) {
                return e.isPropertyAccessChain(_) ? Qi(_, W, _.questionDotToken, e.cast(Te, e.isIdentifier)) : _.expression !== W || _.name !== Te ? A(Zr(W, Te), _) : _;
              }
              function Pi(_, W, Te) {
                var cr = Gr(206);
                return cr.flags |= 32, cr.expression = y().parenthesizeLeftSideOfAccess(_), cr.questionDotToken = W, cr.name = Mc(Te), cr.transformFlags |= 32 | oe(cr.expression) | oe(cr.questionDotToken) | (e.isIdentifier(cr.name) ? m(cr.name) : oe(cr.name)), cr;
              }
              function Qi(_, W, Te, cr) {
                return e.Debug.assert(!!(_.flags & 32), "Cannot update a PropertyAccessExpression using updatePropertyAccessChain. Use updatePropertyAccess instead."), _.expression !== W || _.questionDotToken !== Te || _.name !== cr ? A(Pi(W, Te, cr), _) : _;
              }
              function Ct(_, W) {
                var Te = Gr(207);
                return Te.expression = y().parenthesizeLeftSideOfAccess(_), Te.argumentExpression = Yu(W), Te.transformFlags |= oe(Te.expression) | oe(Te.argumentExpression), e.isSuperKeyword(_) && (Te.transformFlags |= 384), Te;
              }
              function sa(_, W, Te) {
                return e.isElementAccessChain(_) ? Wa(_, W, _.questionDotToken, Te) : _.expression !== W || _.argumentExpression !== Te ? A(Ct(W, Te), _) : _;
              }
              function en(_, W, Te) {
                var cr = Gr(207);
                return cr.flags |= 32, cr.expression = y().parenthesizeLeftSideOfAccess(_), cr.questionDotToken = W, cr.argumentExpression = Yu(Te), cr.transformFlags |= oe(cr.expression) | oe(cr.questionDotToken) | oe(cr.argumentExpression) | 32, cr;
              }
              function Wa(_, W, Te, cr) {
                return e.Debug.assert(!!(_.flags & 32), "Cannot update a ElementAccessExpression using updateElementAccessChain. Use updateElementAccess instead."), _.expression !== W || _.questionDotToken !== Te || _.argumentExpression !== cr ? A(en(W, Te, cr), _) : _;
              }
              function qn(_, W, Te) {
                var cr = Gr(208);
                return cr.expression = y().parenthesizeLeftSideOfAccess(_), cr.typeArguments = bc(W), cr.arguments = y().parenthesizeExpressionsOfCommaDelimitedList(ne(Te)), cr.transformFlags |= oe(cr.expression) | f(cr.typeArguments) | f(cr.arguments), cr.typeArguments && (cr.transformFlags |= 1), e.isImportKeyword(cr.expression) ? cr.transformFlags |= 4194304 : e.isSuperProperty(cr.expression) && (cr.transformFlags |= 8192), cr;
              }
              function mo(_, W, Te, cr) {
                return e.isCallChain(_) ? Go(_, W, _.questionDotToken, Te, cr) : _.expression !== W || _.typeArguments !== Te || _.arguments !== cr ? A(qn(W, Te, cr), _) : _;
              }
              function So(_, W, Te, cr) {
                var ni = Gr(208);
                return ni.flags |= 32, ni.expression = y().parenthesizeLeftSideOfAccess(_), ni.questionDotToken = W, ni.typeArguments = bc(Te), ni.arguments = y().parenthesizeExpressionsOfCommaDelimitedList(ne(cr)), ni.transformFlags |= oe(ni.expression) | oe(ni.questionDotToken) | f(ni.typeArguments) | f(ni.arguments) | 32, ni.typeArguments && (ni.transformFlags |= 1), e.isSuperProperty(ni.expression) && (ni.transformFlags |= 8192), ni;
              }
              function Go(_, W, Te, cr, ni) {
                return e.Debug.assert(!!(_.flags & 32), "Cannot update a CallExpression using updateCallChain. Use updateCall instead."), _.expression !== W || _.questionDotToken !== Te || _.typeArguments !== cr || _.arguments !== ni ? A(So(W, Te, cr, ni), _) : _;
              }
              function ys(_, W, Te) {
                var cr = Gr(209);
                return cr.expression = y().parenthesizeExpressionOfNew(_), cr.typeArguments = bc(W), cr.arguments = Te ? y().parenthesizeExpressionsOfCommaDelimitedList(Te) : void 0, cr.transformFlags |= oe(cr.expression) | f(cr.typeArguments) | f(cr.arguments) | 32, cr.typeArguments && (cr.transformFlags |= 1), cr;
              }
              function Pc(_, W, Te, cr) {
                return _.expression !== W || _.typeArguments !== Te || _.arguments !== cr ? A(ys(W, Te, cr), _) : _;
              }
              function Vc(_, W, Te) {
                var cr = Gr(210);
                return cr.tag = y().parenthesizeLeftSideOfAccess(_), cr.typeArguments = bc(W), cr.template = Te, cr.transformFlags |= oe(cr.tag) | f(cr.typeArguments) | oe(cr.template) | 1024, cr.typeArguments && (cr.transformFlags |= 1), e.hasInvalidEscape(cr.template) && (cr.transformFlags |= 128), cr;
              }
              function Kc(_, W, Te, cr) {
                return _.tag !== W || _.typeArguments !== Te || _.template !== cr ? A(Vc(W, Te, cr), _) : _;
              }
              function Xs(_, W) {
                var Te = Gr(211);
                return Te.expression = y().parenthesizeOperandOfPrefixUnary(W), Te.type = _, Te.transformFlags |= oe(Te.expression) | oe(Te.type) | 1, Te;
              }
              function pc(_, W, Te) {
                return _.type !== W || _.expression !== Te ? A(Xs(W, Te), _) : _;
              }
              function hs(_) {
                var W = Gr(212);
                return W.expression = _, W.transformFlags = oe(W.expression), W;
              }
              function tc(_, W) {
                return _.expression !== W ? A(hs(W), _) : _;
              }
              function ps(_, W, Te, cr, ni, rt, yt) {
                var Xa = Re(213, void 0, _, Te, cr, ni, rt, yt);
                return Xa.asteriskToken = W, Xa.transformFlags |= oe(Xa.asteriskToken), Xa.typeParameters && (Xa.transformFlags |= 1), e.modifiersToFlags(Xa.modifiers) & 256 ? Xa.asteriskToken ? Xa.transformFlags |= 128 : Xa.transformFlags |= 256 : Xa.asteriskToken && (Xa.transformFlags |= 2048), Xa;
              }
              function Qs(_, W, Te, cr, ni, rt, yt, Xa) {
                return _.name !== cr || _.modifiers !== W || _.asteriskToken !== Te || _.typeParameters !== ni || _.parameters !== rt || _.type !== yt || _.body !== Xa ? ze(ps(W, Te, cr, ni, rt, yt, Xa), _) : _;
              }
              function js(_, W, Te, cr, ni, rt) {
                var yt = Re(214, void 0, _, void 0, W, Te, cr, y().parenthesizeConciseBodyOfArrowFunction(rt));
                return yt.equalsGreaterThanToken = ni != null ? ni : Ir(38), yt.transformFlags |= oe(yt.equalsGreaterThanToken) | 1024, e.modifiersToFlags(yt.modifiers) & 256 && (yt.transformFlags |= 8448), yt;
              }
              function ds(_, W, Te, cr, ni, rt, yt) {
                return _.modifiers !== W || _.typeParameters !== Te || _.parameters !== cr || _.type !== ni || _.equalsGreaterThanToken !== rt || _.body !== yt ? ze(js(W, Te, cr, ni, rt, yt), _) : _;
              }
              function Ji(_) {
                var W = Gr(215);
                return W.expression = y().parenthesizeOperandOfPrefixUnary(_), W.transformFlags |= oe(W.expression), W;
              }
              function ce(_, W) {
                return _.expression !== W ? A(Ji(W), _) : _;
              }
              function Rr(_) {
                var W = Gr(216);
                return W.expression = y().parenthesizeOperandOfPrefixUnary(_), W.transformFlags |= oe(W.expression), W;
              }
              function yi(_, W) {
                return _.expression !== W ? A(Rr(W), _) : _;
              }
              function qi(_) {
                var W = Gr(217);
                return W.expression = y().parenthesizeOperandOfPrefixUnary(_), W.transformFlags |= oe(W.expression), W;
              }
              function je(_, W) {
                return _.expression !== W ? A(qi(W), _) : _;
              }
              function Hr(_) {
                var W = Gr(218);
                return W.expression = y().parenthesizeOperandOfPrefixUnary(_), W.transformFlags |= oe(W.expression) | 256 | 128 | 1048576, W;
              }
              function pt(_, W) {
                return _.expression !== W ? A(Hr(W), _) : _;
              }
              function Pt(_, W) {
                var Te = Gr(219);
                return Te.operator = _, Te.operand = y().parenthesizeOperandOfPrefixUnary(W), Te.transformFlags |= oe(Te.operand), (_ === 45 || _ === 46) && e.isIdentifier(Te.operand) && !e.isGeneratedIdentifier(Te.operand) && !e.isLocalName(Te.operand) && (Te.transformFlags |= 67108864), Te;
              }
              function ga(_, W) {
                return _.operand !== W ? A(Pt(_.operator, W), _) : _;
              }
              function ua(_, W) {
                var Te = Gr(220);
                return Te.operator = W, Te.operand = y().parenthesizeOperandOfPostfixUnary(_), Te.transformFlags |= oe(Te.operand), e.isIdentifier(Te.operand) && !e.isGeneratedIdentifier(Te.operand) && !e.isLocalName(Te.operand) && (Te.transformFlags |= 67108864), Te;
              }
              function Xn(_, W) {
                return _.operand !== W ? A(ua(W, _.operator), _) : _;
              }
              function jr(_, W, Te) {
                var cr = Gr(221), ni = Rl(W), rt = ni.kind;
                return cr.left = y().parenthesizeLeftSideOfBinary(rt, _), cr.operatorToken = ni, cr.right = y().parenthesizeRightSideOfBinary(rt, cr.left, Te), cr.transformFlags |= oe(cr.left) | oe(cr.operatorToken) | oe(cr.right), rt === 60 ? cr.transformFlags |= 32 : rt === 63 ? e.isObjectLiteralExpression(cr.left) ? cr.transformFlags |= 5248 | fo(cr.left) : e.isArrayLiteralExpression(cr.left) && (cr.transformFlags |= 5120 | fo(cr.left)) : rt === 42 || rt === 67 ? cr.transformFlags |= 512 : e.isLogicalOrCoalescingAssignmentOperator(rt) && (cr.transformFlags |= 16), cr;
              }
              function fo(_) {
                if (_.transformFlags & 32768) return 32768;
                if (_.transformFlags & 128) for (var W = 0, Te = e.getElementsOfBindingOrAssignmentPattern(_); W < Te.length; W++) {
                  var cr = Te[W], ni = e.getTargetOfBindingOrAssignmentElement(cr);
                  if (ni && e.isAssignmentPattern(ni)) {
                    if (ni.transformFlags & 32768) return 32768;
                    if (ni.transformFlags & 128) {
                      var rt = fo(ni);
                      if (rt) return rt;
                    }
                  }
                }
                return 0;
              }
              function xs(_, W, Te, cr) {
                return _.left !== W || _.operatorToken !== Te || _.right !== cr ? A(jr(W, Te, cr), _) : _;
              }
              function Fo(_, W, Te, cr, ni) {
                var rt = Gr(222);
                return rt.condition = y().parenthesizeConditionOfConditionalExpression(_), rt.questionToken = W != null ? W : Ir(57), rt.whenTrue = y().parenthesizeBranchOfConditionalExpression(Te), rt.colonToken = cr != null ? cr : Ir(58), rt.whenFalse = y().parenthesizeBranchOfConditionalExpression(ni), rt.transformFlags |= oe(rt.condition) | oe(rt.questionToken) | oe(rt.whenTrue) | oe(rt.colonToken) | oe(rt.whenFalse), rt;
              }
              function ko(_, W, Te, cr, ni, rt) {
                return _.condition !== W || _.questionToken !== Te || _.whenTrue !== cr || _.colonToken !== ni || _.whenFalse !== rt ? A(Fo(W, Te, cr, ni, rt), _) : _;
              }
              function Ao(_, W) {
                var Te = Gr(223);
                return Te.head = _, Te.templateSpans = ne(W), Te.transformFlags |= oe(Te.head) | f(Te.templateSpans) | 1024, Te;
              }
              function Ms(_, W, Te) {
                return _.head !== W || _.templateSpans !== Te ? A(Ao(W, Te), _) : _;
              }
              function Bs(_, W, Te, cr) {
                cr === void 0 && (cr = 0), e.Debug.assert(!(cr & -2049), "Unsupported template flags.");
                var ni = void 0;
                if (Te !== void 0 && Te !== W && (ni = p(_, Te), typeof ni == "object")) return e.Debug.fail("Invalid raw text");
                if (W === void 0) {
                  if (ni === void 0) return e.Debug.fail("Arguments 'text' and 'rawText' may not both be undefined.");
                  W = ni;
                } else ni !== void 0 && e.Debug.assert(W === ni, "Expected argument 'text' to be the normalized (i.e. 'cooked') version of argument 'rawText'.");
                return xc(_, W, Te, cr);
              }
              function xc(_, W, Te, cr) {
                var ni = yr(_);
                return ni.text = W, ni.rawText = Te, ni.templateFlags = cr & 2048, ni.transformFlags |= 1024, ni.templateFlags && (ni.transformFlags |= 128), ni;
              }
              function su(_, W, Te) {
                return Bs(15, _, W, Te);
              }
              function tl(_, W, Te) {
                return Bs(16, _, W, Te);
              }
              function Zc(_, W, Te) {
                return Bs(17, _, W, Te);
              }
              function Rf(_, W, Te) {
                return Bs(14, _, W, Te);
              }
              function al(_, W) {
                e.Debug.assert(!_ || !!W, "A `YieldExpression` with an asteriskToken must have an expression.");
                var Te = Gr(224);
                return Te.expression = W && y().parenthesizeExpressionForDisallowedComma(W), Te.asteriskToken = _, Te.transformFlags |= oe(Te.expression) | oe(Te.asteriskToken) | 1024 | 128 | 524288, Te;
              }
              function Jo(_, W, Te) {
                return _.expression !== Te || _.asteriskToken !== W ? A(al(W, Te), _) : _;
              }
              function eu(_) {
                var W = Gr(225);
                return W.expression = y().parenthesizeExpressionForDisallowedComma(_), W.transformFlags |= oe(W.expression) | 1024 | 16384, W;
              }
              function Ws(_, W) {
                return _.expression !== W ? A(eu(W), _) : _;
              }
              function pu(_, W, Te, cr, ni, rt) {
                var yt = He(226, _, W, Te, cr, ni, rt);
                return yt.transformFlags |= 1024, yt;
              }
              function Uu(_, W, Te, cr, ni, rt, yt) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.typeParameters !== ni || _.heritageClauses !== rt || _.members !== yt ? A(pu(W, Te, cr, ni, rt, yt), _) : _;
              }
              function Ql() {
                return Gr(227);
              }
              function xl(_, W) {
                var Te = ue(228);
                return Te.expression = y().parenthesizeLeftSideOfAccess(_), Te.typeArguments = W && y().parenthesizeTypeArguments(W), Te.transformFlags |= oe(Te.expression) | f(Te.typeArguments) | 1024, Te;
              }
              function Ya(_, W, Te) {
                return _.expression !== W || _.typeArguments !== Te ? A(xl(W, Te), _) : _;
              }
              function du(_, W) {
                var Te = Gr(229);
                return Te.expression = _, Te.type = W, Te.transformFlags |= oe(Te.expression) | oe(Te.type) | 1, Te;
              }
              function vc(_, W, Te) {
                return _.expression !== W || _.type !== Te ? A(du(W, Te), _) : _;
              }
              function Kr(_) {
                var W = Gr(230);
                return W.expression = y().parenthesizeLeftSideOfAccess(_), W.transformFlags |= oe(W.expression) | 1, W;
              }
              function _i(_, W) {
                return e.isNonNullChain(_) ? tt(_, W) : _.expression !== W ? A(Kr(W), _) : _;
              }
              function Ei(_) {
                var W = Gr(230);
                return W.flags |= 32, W.expression = y().parenthesizeLeftSideOfAccess(_), W.transformFlags |= oe(W.expression) | 1, W;
              }
              function tt(_, W) {
                return e.Debug.assert(!!(_.flags & 32), "Cannot update a NonNullExpression using updateNonNullChain. Use updateNonNullExpression instead."), _.expression !== W ? A(Ei(W), _) : _;
              }
              function kt(_, W) {
                var Te = Gr(231);
                switch (Te.keywordToken = _, Te.name = W, Te.transformFlags |= oe(Te.name), _) {
                  case 103:
                    Te.transformFlags |= 1024;
                    break;
                  case 100:
                    Te.transformFlags |= 4;
                    break;
                  default:
                    return e.Debug.assertNever(_);
                }
                return Te;
              }
              function bt(_, W) {
                return _.name !== W ? A(kt(_.keywordToken, W), _) : _;
              }
              function ia(_, W) {
                var Te = ue(233);
                return Te.expression = _, Te.literal = W, Te.transformFlags |= oe(Te.expression) | oe(Te.literal) | 1024, Te;
              }
              function Xt(_, W, Te) {
                return _.expression !== W || _.literal !== Te ? A(ia(W, Te), _) : _;
              }
              function Za() {
                var _ = ue(234);
                return _.transformFlags |= 1024, _;
              }
              function bn(_, W) {
                var Te = ue(235);
                return Te.statements = ne(_), Te.multiLine = W, Te.transformFlags |= f(Te.statements), Te;
              }
              function _a(_, W) {
                return _.statements !== W ? A(bn(W, _.multiLine), _) : _;
              }
              function qa(_, W) {
                var Te = We(237, void 0, _);
                return Te.declarationList = e.isArray(W) ? Cl(W) : W, Te.transformFlags |= oe(Te.declarationList), e.modifiersToFlags(Te.modifiers) & 2 && (Te.transformFlags = 1), Te;
              }
              function rn(_, W, Te) {
                return _.modifiers !== W || _.declarationList !== Te ? A(qa(W, Te), _) : _;
              }
              function jn() {
                return ue(236);
              }
              function Mo(_) {
                var W = ue(238);
                return W.expression = y().parenthesizeExpressionOfExpressionStatement(_), W.transformFlags |= oe(W.expression), W;
              }
              function ho(_, W) {
                return _.expression !== W ? A(Mo(W), _) : _;
              }
              function gs(_, W, Te) {
                var cr = ue(239);
                return cr.expression = _, cr.thenStatement = Lc(W), cr.elseStatement = Lc(Te), cr.transformFlags |= oe(cr.expression) | oe(cr.thenStatement) | oe(cr.elseStatement), cr;
              }
              function Se(_, W, Te, cr) {
                return _.expression !== W || _.thenStatement !== Te || _.elseStatement !== cr ? A(gs(W, Te, cr), _) : _;
              }
              function hr(_, W) {
                var Te = ue(240);
                return Te.statement = Lc(_), Te.expression = W, Te.transformFlags |= oe(Te.statement) | oe(Te.expression), Te;
              }
              function Or(_, W, Te) {
                return _.statement !== W || _.expression !== Te ? A(hr(W, Te), _) : _;
              }
              function ki(_, W) {
                var Te = ue(241);
                return Te.expression = _, Te.statement = Lc(W), Te.transformFlags |= oe(Te.expression) | oe(Te.statement), Te;
              }
              function dt(_, W, Te) {
                return _.expression !== W || _.statement !== Te ? A(ki(W, Te), _) : _;
              }
              function la(_, W, Te, cr) {
                var ni = ue(242);
                return ni.initializer = _, ni.condition = W, ni.incrementor = Te, ni.statement = Lc(cr), ni.transformFlags |= oe(ni.initializer) | oe(ni.condition) | oe(ni.incrementor) | oe(ni.statement), ni;
              }
              function wa(_, W, Te, cr, ni) {
                return _.initializer !== W || _.condition !== Te || _.incrementor !== cr || _.statement !== ni ? A(la(W, Te, cr, ni), _) : _;
              }
              function On(_, W, Te) {
                var cr = ue(243);
                return cr.initializer = _, cr.expression = W, cr.statement = Lc(Te), cr.transformFlags |= oe(cr.initializer) | oe(cr.expression) | oe(cr.statement), cr;
              }
              function No(_, W, Te, cr) {
                return _.initializer !== W || _.expression !== Te || _.statement !== cr ? A(On(W, Te, cr), _) : _;
              }
              function jo(_, W, Te, cr) {
                var ni = ue(244);
                return ni.awaitModifier = _, ni.initializer = W, ni.expression = y().parenthesizeExpressionForDisallowedComma(Te), ni.statement = Lc(cr), ni.transformFlags |= oe(ni.awaitModifier) | oe(ni.initializer) | oe(ni.expression) | oe(ni.statement) | 1024, _ && (ni.transformFlags |= 128), ni;
              }
              function po(_, W, Te, cr, ni) {
                return _.awaitModifier !== W || _.initializer !== Te || _.expression !== cr || _.statement !== ni ? A(jo(W, Te, cr, ni), _) : _;
              }
              function Gn(_) {
                var W = ue(245);
                return W.label = Mc(_), W.transformFlags |= oe(W.label) | 2097152, W;
              }
              function $n(_, W) {
                return _.label !== W ? A(Gn(W), _) : _;
              }
              function Ho(_) {
                var W = ue(246);
                return W.label = Mc(_), W.transformFlags |= oe(W.label) | 2097152, W;
              }
              function Zo(_, W) {
                return _.label !== W ? A(Ho(W), _) : _;
              }
              function Es(_) {
                var W = ue(247);
                return W.expression = _, W.transformFlags |= oe(W.expression) | 128 | 2097152, W;
              }
              function yc(_, W) {
                return _.expression !== W ? A(Es(W), _) : _;
              }
              function Xr(_, W) {
                var Te = ue(248);
                return Te.expression = _, Te.statement = Lc(W), Te.transformFlags |= oe(Te.expression) | oe(Te.statement), Te;
              }
              function Ls(_, W, Te) {
                return _.expression !== W || _.statement !== Te ? A(Xr(W, Te), _) : _;
              }
              function Ic(_, W) {
                var Te = ue(249);
                return Te.expression = y().parenthesizeExpressionForDisallowedComma(_), Te.caseBlock = W, Te.transformFlags |= oe(Te.expression) | oe(Te.caseBlock), Te;
              }
              function zu(_, W, Te) {
                return _.expression !== W || _.caseBlock !== Te ? A(Ic(W, Te), _) : _;
              }
              function vf(_, W) {
                var Te = ue(250);
                return Te.label = Mc(_), Te.statement = Lc(W), Te.transformFlags |= oe(Te.label) | oe(Te.statement), Te;
              }
              function P_(_, W, Te) {
                return _.label !== W || _.statement !== Te ? A(vf(W, Te), _) : _;
              }
              function El(_) {
                var W = ue(251);
                return W.expression = _, W.transformFlags |= oe(W.expression), W;
              }
              function vp(_, W) {
                return _.expression !== W ? A(El(W), _) : _;
              }
              function oo(_, W, Te) {
                var cr = ue(252);
                return cr.tryBlock = _, cr.catchClause = W, cr.finallyBlock = Te, cr.transformFlags |= oe(cr.tryBlock) | oe(cr.catchClause) | oe(cr.finallyBlock), cr;
              }
              function I_(_, W, Te, cr) {
                return _.tryBlock !== W || _.catchClause !== Te || _.finallyBlock !== cr ? A(oo(W, Te, cr), _) : _;
              }
              function yp() {
                return ue(253);
              }
              function Yl(_, W, Te, cr) {
                var ni = Ie(254, void 0, void 0, _, Te, cr && y().parenthesizeExpressionForDisallowedComma(cr));
                return ni.exclamationToken = W, ni.transformFlags |= oe(ni.exclamationToken), W && (ni.transformFlags |= 1), ni;
              }
              function Bf(_, W, Te, cr, ni) {
                return _.name !== W || _.type !== cr || _.exclamationToken !== Te || _.initializer !== ni ? A(Yl(W, Te, cr, ni), _) : _;
              }
              function Cl(_, W) {
                W === void 0 && (W = 0);
                var Te = ue(255);
                return Te.flags |= W & 3, Te.declarations = ne(_), Te.transformFlags |= f(Te.declarations) | 2097152, W & 3 && (Te.transformFlags |= 132096), Te;
              }
              function c_(_, W) {
                return _.declarations !== W ? A(Cl(W, _.flags), _) : _;
              }
              function hp(_, W, Te, cr, ni, rt, yt, Xa) {
                var vo = Re(256, _, W, cr, ni, rt, yt, Xa);
                return vo.asteriskToken = Te, !vo.body || e.modifiersToFlags(vo.modifiers) & 2 ? vo.transformFlags = 1 : (vo.transformFlags |= oe(vo.asteriskToken) | 2097152, e.modifiersToFlags(vo.modifiers) & 256 ? vo.asteriskToken ? vo.transformFlags |= 128 : vo.transformFlags |= 256 : vo.asteriskToken && (vo.transformFlags |= 2048)), vo;
              }
              function gu(_, W, Te, cr, ni, rt, yt, Xa, vo) {
                return _.decorators !== W || _.modifiers !== Te || _.asteriskToken !== cr || _.name !== ni || _.typeParameters !== rt || _.parameters !== yt || _.type !== Xa || _.body !== vo ? ze(hp(W, Te, cr, ni, rt, yt, Xa, vo), _) : _;
              }
              function Dp(_, W, Te, cr, ni, rt) {
                var yt = He(257, _, W, Te, cr, ni, rt);
                return e.modifiersToFlags(yt.modifiers) & 2 ? yt.transformFlags = 1 : (yt.transformFlags |= 1024, yt.transformFlags & 4096 && (yt.transformFlags |= 1)), yt;
              }
              function sd(_, W, Te, cr, ni, rt, yt) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.typeParameters !== ni || _.heritageClauses !== rt || _.members !== yt ? A(Dp(W, Te, cr, ni, rt, yt), _) : _;
              }
              function Aa(_, W, Te, cr, ni, rt) {
                var yt = Ee(258, _, W, Te, cr, ni);
                return yt.members = ne(rt), yt.transformFlags = 1, yt;
              }
              function va(_, W, Te, cr, ni, rt, yt) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.typeParameters !== ni || _.heritageClauses !== rt || _.members !== yt ? A(Aa(W, Te, cr, ni, rt, yt), _) : _;
              }
              function Cu(_, W, Te, cr, ni) {
                var rt = Z(259, _, W, Te, cr);
                return rt.type = ni, rt.transformFlags = 1, rt;
              }
              function qs(_, W, Te, cr, ni, rt) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.typeParameters !== ni || _.type !== rt ? A(Cu(W, Te, cr, ni, rt), _) : _;
              }
              function cd(_, W, Te, cr) {
                var ni = Fe(260, _, W, Te);
                return ni.members = ne(cr), ni.transformFlags |= f(ni.members) | 1, ni.transformFlags &= -16777217, ni;
              }
              function ns(_, W, Te, cr, ni) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.members !== ni ? A(cd(W, Te, cr, ni), _) : _;
              }
              function nl(_, W, Te, cr, ni) {
                ni === void 0 && (ni = 0);
                var rt = We(261, _, W);
                return rt.flags |= ni & 1044, rt.name = Te, rt.body = cr, e.modifiersToFlags(rt.modifiers) & 2 ? rt.transformFlags = 1 : rt.transformFlags |= oe(rt.name) | oe(rt.body) | 1, rt.transformFlags &= -16777217, rt;
              }
              function hc(_, W, Te, cr, ni) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.body !== ni ? A(nl(W, Te, cr, ni, _.flags), _) : _;
              }
              function es(_) {
                var W = ue(262);
                return W.statements = ne(_), W.transformFlags |= f(W.statements), W;
              }
              function u_(_, W) {
                return _.statements !== W ? A(es(W), _) : _;
              }
              function Jf(_) {
                var W = ue(263);
                return W.clauses = ne(_), W.transformFlags |= f(W.clauses), W;
              }
              function w_(_, W) {
                return _.clauses !== W ? A(Jf(W), _) : _;
              }
              function ud(_) {
                var W = Fe(264, void 0, void 0, _);
                return W.transformFlags = 1, W;
              }
              function ku(_, W) {
                return _.name !== W ? A(ud(W), _) : _;
              }
              function ld(_, W, Te, cr, ni) {
                var rt = Fe(265, _, W, cr);
                return rt.isTypeOnly = Te, rt.moduleReference = ni, rt.transformFlags |= oe(rt.moduleReference), e.isExternalModuleReference(rt.moduleReference) || (rt.transformFlags |= 1), rt.transformFlags &= -16777217, rt;
              }
              function fd(_, W, Te, cr, ni, rt) {
                return _.decorators !== W || _.modifiers !== Te || _.isTypeOnly !== cr || _.name !== ni || _.moduleReference !== rt ? A(ld(W, Te, cr, ni, rt), _) : _;
              }
              function bp(_, W, Te, cr, ni) {
                var rt = We(266, _, W);
                return rt.importClause = Te, rt.moduleSpecifier = cr, rt.assertClause = ni, rt.transformFlags |= oe(rt.importClause) | oe(rt.moduleSpecifier), rt.transformFlags &= -16777217, rt;
              }
              function Sp(_, W, Te, cr, ni, rt) {
                return _.decorators !== W || _.modifiers !== Te || _.importClause !== cr || _.moduleSpecifier !== ni || _.assertClause !== rt ? A(bp(W, Te, cr, ni, rt), _) : _;
              }
              function Tp(_, W, Te) {
                var cr = ue(267);
                return cr.isTypeOnly = _, cr.name = W, cr.namedBindings = Te, cr.transformFlags |= oe(cr.name) | oe(cr.namedBindings), _ && (cr.transformFlags |= 1), cr.transformFlags &= -16777217, cr;
              }
              function _d(_, W, Te, cr) {
                return _.isTypeOnly !== W || _.name !== Te || _.namedBindings !== cr ? A(Tp(W, Te, cr), _) : _;
              }
              function jf(_, W) {
                var Te = ue(293);
                return Te.elements = ne(_), Te.multiLine = W, Te.transformFlags |= 4, Te;
              }
              function O_(_, W, Te) {
                return _.elements !== W || _.multiLine !== Te ? A(jf(W, Te), _) : _;
              }
              function F_(_, W) {
                var Te = ue(294);
                return Te.name = _, Te.value = W, Te.transformFlags |= 4, Te;
              }
              function pd(_, W, Te) {
                return _.name !== W || _.value !== Te ? A(F_(W, Te), _) : _;
              }
              function xp(_, W) {
                var Te = ue(295);
                return Te.assertClause = _, Te.multiLine = W, Te;
              }
              function M_(_, W, Te) {
                return _.assertClause !== W || _.multiLine !== Te ? A(xp(W, Te), _) : _;
              }
              function Ep(_) {
                var W = ue(268);
                return W.name = _, W.transformFlags |= oe(W.name), W.transformFlags &= -16777217, W;
              }
              function ol(_, W) {
                return _.name !== W ? A(Ep(W), _) : _;
              }
              function Au(_) {
                var W = ue(274);
                return W.name = _, W.transformFlags |= oe(W.name) | 4, W.transformFlags &= -16777217, W;
              }
              function ru(_, W) {
                return _.name !== W ? A(Au(W), _) : _;
              }
              function yf(_) {
                var W = ue(269);
                return W.elements = ne(_), W.transformFlags |= f(W.elements), W.transformFlags &= -16777217, W;
              }
              function Cp(_, W) {
                return _.elements !== W ? A(yf(W), _) : _;
              }
              function dd(_, W, Te) {
                var cr = ue(270);
                return cr.isTypeOnly = _, cr.propertyName = W, cr.name = Te, cr.transformFlags |= oe(cr.propertyName) | oe(cr.name), cr.transformFlags &= -16777217, cr;
              }
              function kp(_, W, Te, cr) {
                return _.isTypeOnly !== W || _.propertyName !== Te || _.name !== cr ? A(dd(W, Te, cr), _) : _;
              }
              function mu(_, W, Te, cr) {
                var ni = We(271, _, W);
                return ni.isExportEquals = Te, ni.expression = Te ? y().parenthesizeRightSideOfBinary(63, void 0, cr) : y().parenthesizeExpressionOfExportDefault(cr), ni.transformFlags |= oe(ni.expression), ni.transformFlags &= -16777217, ni;
              }
              function gd(_, W, Te, cr) {
                return _.decorators !== W || _.modifiers !== Te || _.expression !== cr ? A(mu(W, Te, _.isExportEquals, cr), _) : _;
              }
              function hf(_, W, Te, cr, ni, rt) {
                var yt = We(272, _, W);
                return yt.isTypeOnly = Te, yt.exportClause = cr, yt.moduleSpecifier = ni, yt.assertClause = rt, yt.transformFlags |= oe(yt.exportClause) | oe(yt.moduleSpecifier), yt.transformFlags &= -16777217, yt;
              }
              function $l(_, W, Te, cr, ni, rt, yt) {
                return _.decorators !== W || _.modifiers !== Te || _.isTypeOnly !== cr || _.exportClause !== ni || _.moduleSpecifier !== rt || _.assertClause !== yt ? A(hf(W, Te, cr, ni, rt, yt), _) : _;
              }
              function Uf(_) {
                var W = ue(273);
                return W.elements = ne(_), W.transformFlags |= f(W.elements), W.transformFlags &= -16777217, W;
              }
              function L_(_, W) {
                return _.elements !== W ? A(Uf(W), _) : _;
              }
              function l_(_, W, Te) {
                var cr = ue(275);
                return cr.isTypeOnly = _, cr.propertyName = Mc(W), cr.name = Mc(Te), cr.transformFlags |= oe(cr.propertyName) | oe(cr.name), cr.transformFlags &= -16777217, cr;
              }
              function f_(_, W, Te, cr) {
                return _.isTypeOnly !== W || _.propertyName !== Te || _.name !== cr ? A(l_(W, Te, cr), _) : _;
              }
              function md() {
                var _ = We(276, void 0, void 0);
                return _;
              }
              function ks(_) {
                var W = ue(277);
                return W.expression = _, W.transformFlags |= oe(W.expression), W.transformFlags &= -16777217, W;
              }
              function Wu(_, W) {
                return _.expression !== W ? A(ks(W), _) : _;
              }
              function Zl(_) {
                return ue(_);
              }
              function R_(_, W, Te) {
                Te === void 0 && (Te = false);
                var cr = kl(_, Te ? W && y().parenthesizeNonArrayTypeOfPostfixType(W) : W);
                return cr.postfix = Te, cr;
              }
              function kl(_, W) {
                var Te = ue(_);
                return Te.type = W, Te;
              }
              function __(_, W, Te) {
                return W.type !== Te ? A(R_(_, Te, W.postfix), W) : W;
              }
              function zd(_, W, Te) {
                return W.type !== Te ? A(kl(_, Te), W) : W;
              }
              function Al(_, W) {
                var Te = Be(317, void 0, void 0, void 0, void 0, _, W);
                return Te;
              }
              function wc(_, W, Te) {
                return _.parameters !== W || _.type !== Te ? A(Al(W, Te), _) : _;
              }
              function qu(_, W) {
                W === void 0 && (W = false);
                var Te = ue(322);
                return Te.jsDocPropertyTags = bc(_), Te.isArrayType = W, Te;
              }
              function Vu(_, W, Te) {
                return _.jsDocPropertyTags !== W || _.isArrayType !== Te ? A(qu(W, Te), _) : _;
              }
              function ef(_) {
                var W = ue(309);
                return W.type = _, W;
              }
              function sl(_, W) {
                return _.type !== W ? A(ef(W), _) : _;
              }
              function p_(_, W, Te) {
                var cr = ue(323);
                return cr.typeParameters = bc(_), cr.parameters = ne(W), cr.type = Te, cr;
              }
              function Df(_, W, Te, cr) {
                return _.typeParameters !== W || _.parameters !== Te || _.type !== cr ? A(p_(W, Te, cr), _) : _;
              }
              function Ec(_) {
                var W = Q(_.kind);
                return _.tagName.escapedText === e.escapeLeadingUnderscores(W) ? _.tagName : Er(W);
              }
              function Zn(_, W, Te) {
                var cr = ue(_);
                return cr.tagName = W, cr.comment = Te, cr;
              }
              function os(_, W, Te, cr) {
                var ni = Zn(344, _ != null ? _ : Er("template"), cr);
                return ni.constraint = W, ni.typeParameters = ne(Te), ni;
              }
              function Ps(_, W, Te, cr, ni) {
                return W === void 0 && (W = Ec(_)), _.tagName !== W || _.constraint !== Te || _.typeParameters !== cr || _.comment !== ni ? A(os(W, Te, cr, ni), _) : _;
              }
              function d_(_, W, Te, cr) {
                var ni = Zn(345, _ != null ? _ : Er("typedef"), cr);
                return ni.typeExpression = W, ni.fullName = Te, ni.name = e.getJSDocTypeAliasName(Te), ni;
              }
              function Gc(_, W, Te, cr, ni) {
                return W === void 0 && (W = Ec(_)), _.tagName !== W || _.typeExpression !== Te || _.fullName !== cr || _.comment !== ni ? A(d_(W, Te, cr, ni), _) : _;
              }
              function B_(_, W, Te, cr, ni, rt) {
                var yt = Zn(340, _ != null ? _ : Er("param"), rt);
                return yt.typeExpression = cr, yt.name = W, yt.isNameFirst = !!ni, yt.isBracketed = Te, yt;
              }
              function vu(_, W, Te, cr, ni, rt, yt) {
                return W === void 0 && (W = Ec(_)), _.tagName !== W || _.name !== Te || _.isBracketed !== cr || _.typeExpression !== ni || _.isNameFirst !== rt || _.comment !== yt ? A(B_(W, Te, cr, ni, rt, yt), _) : _;
              }
              function Gt(_, W, Te, cr, ni, rt) {
                var yt = Zn(347, _ != null ? _ : Er("prop"), rt);
                return yt.typeExpression = cr, yt.name = W, yt.isNameFirst = !!ni, yt.isBracketed = Te, yt;
              }
              function As(_, W, Te, cr, ni, rt, yt) {
                return W === void 0 && (W = Ec(_)), _.tagName !== W || _.name !== Te || _.isBracketed !== cr || _.typeExpression !== ni || _.isNameFirst !== rt || _.comment !== yt ? A(Gt(W, Te, cr, ni, rt, yt), _) : _;
              }
              function vn(_, W, Te, cr) {
                var ni = Zn(338, _ != null ? _ : Er("callback"), cr);
                return ni.typeExpression = W, ni.fullName = Te, ni.name = e.getJSDocTypeAliasName(Te), ni;
              }
              function Nl(_, W, Te, cr, ni) {
                return W === void 0 && (W = Ec(_)), _.tagName !== W || _.typeExpression !== Te || _.fullName !== cr || _.comment !== ni ? A(vn(W, Te, cr, ni), _) : _;
              }
              function cl(_, W, Te) {
                var cr = Zn(328, _ != null ? _ : Er("augments"), Te);
                return cr.class = W, cr;
              }
              function rf(_, W, Te, cr) {
                return W === void 0 && (W = Ec(_)), _.tagName !== W || _.class !== Te || _.comment !== cr ? A(cl(W, Te, cr), _) : _;
              }
              function Ut(_, W, Te) {
                var cr = Zn(329, _ != null ? _ : Er("implements"), Te);
                return cr.class = W, cr;
              }
              function Ds(_, W, Te) {
                var cr = Zn(346, _ != null ? _ : Er("see"), Te);
                return cr.name = W, cr;
              }
              function bf(_, W, Te, cr) {
                return _.tagName !== W || _.name !== Te || _.comment !== cr ? A(Ds(W, Te, cr), _) : _;
              }
              function bs(_) {
                var W = ue(310);
                return W.name = _, W;
              }
              function Dc(_, W) {
                return _.name !== W ? A(bs(W), _) : _;
              }
              function Cc(_, W) {
                var Te = ue(311);
                return Te.left = _, Te.right = W, Te.transformFlags |= oe(Te.left) | oe(Te.right), Te;
              }
              function ac(_, W, Te) {
                return _.left !== W || _.right !== Te ? A(Cc(W, Te), _) : _;
              }
              function Pl(_, W) {
                var Te = ue(324);
                return Te.name = _, Te.text = W, Te;
              }
              function Il(_, W, Te) {
                return _.name !== W ? A(Pl(W, Te), _) : _;
              }
              function zf(_, W) {
                var Te = ue(325);
                return Te.name = _, Te.text = W, Te;
              }
              function ul(_, W, Te) {
                return _.name !== W ? A(zf(W, Te), _) : _;
              }
              function Nu(_, W) {
                var Te = ue(326);
                return Te.name = _, Te.text = W, Te;
              }
              function Us(_, W, Te) {
                return _.name !== W ? A(Nu(W, Te), _) : _;
              }
              function Ap(_, W, Te, cr) {
                return W === void 0 && (W = Ec(_)), _.tagName !== W || _.class !== Te || _.comment !== cr ? A(Ut(W, Te, cr), _) : _;
              }
              function Wf(_, W, Te) {
                var cr = Zn(_, W != null ? W : Er(Q(_)), Te);
                return cr;
              }
              function Sf(_, W, Te, cr) {
                return Te === void 0 && (Te = Ec(W)), W.tagName !== Te || W.comment !== cr ? A(Wf(_, Te, cr), W) : W;
              }
              function ll(_, W, Te, cr) {
                var ni = Zn(_, W != null ? W : Er(Q(_)), cr);
                return ni.typeExpression = Te, ni;
              }
              function J_(_, W, Te, cr, ni) {
                return Te === void 0 && (Te = Ec(W)), W.tagName !== Te || W.typeExpression !== cr || W.comment !== ni ? A(ll(_, Te, cr, ni), W) : W;
              }
              function j_(_, W) {
                var Te = Zn(327, _, W);
                return Te;
              }
              function U_(_, W, Te) {
                return _.tagName !== W || _.comment !== Te ? A(j_(W, Te), _) : _;
              }
              function iu(_) {
                var W = ue(321);
                return W.text = _, W;
              }
              function vd(_, W) {
                return _.text !== W ? A(iu(W), _) : _;
              }
              function qf(_, W) {
                var Te = ue(320);
                return Te.comment = _, Te.tags = bc(W), Te;
              }
              function dc(_, W, Te) {
                return _.comment !== W || _.tags !== Te ? A(qf(W, Te), _) : _;
              }
              function Pu(_, W, Te) {
                var cr = ue(278);
                return cr.openingElement = _, cr.children = ne(W), cr.closingElement = Te, cr.transformFlags |= oe(cr.openingElement) | f(cr.children) | oe(cr.closingElement) | 2, cr;
              }
              function wl(_, W, Te, cr) {
                return _.openingElement !== W || _.children !== Te || _.closingElement !== cr ? A(Pu(W, Te, cr), _) : _;
              }
              function Iu(_, W, Te) {
                var cr = ue(279);
                return cr.tagName = _, cr.typeArguments = bc(W), cr.attributes = Te, cr.transformFlags |= oe(cr.tagName) | f(cr.typeArguments) | oe(cr.attributes) | 2, cr.typeArguments && (cr.transformFlags |= 1), cr;
              }
              function so(_, W, Te, cr) {
                return _.tagName !== W || _.typeArguments !== Te || _.attributes !== cr ? A(Iu(W, Te, cr), _) : _;
              }
              function Et(_, W, Te) {
                var cr = ue(280);
                return cr.tagName = _, cr.typeArguments = bc(W), cr.attributes = Te, cr.transformFlags |= oe(cr.tagName) | f(cr.typeArguments) | oe(cr.attributes) | 2, W && (cr.transformFlags |= 1), cr;
              }
              function Ys(_, W, Te, cr) {
                return _.tagName !== W || _.typeArguments !== Te || _.attributes !== cr ? A(Et(W, Te, cr), _) : _;
              }
              function Ku(_) {
                var W = ue(281);
                return W.tagName = _, W.transformFlags |= oe(W.tagName) | 2, W;
              }
              function Np(_, W) {
                return _.tagName !== W ? A(Ku(W), _) : _;
              }
              function Pp(_, W, Te) {
                var cr = ue(282);
                return cr.openingFragment = _, cr.children = ne(W), cr.closingFragment = Te, cr.transformFlags |= oe(cr.openingFragment) | f(cr.children) | oe(cr.closingFragment) | 2, cr;
              }
              function nc(_, W, Te, cr) {
                return _.openingFragment !== W || _.children !== Te || _.closingFragment !== cr ? A(Pp(W, Te, cr), _) : _;
              }
              function fl(_, W) {
                var Te = ue(11);
                return Te.text = _, Te.containsOnlyTriviaWhiteSpaces = !!W, Te.transformFlags |= 2, Te;
              }
              function _l(_, W, Te) {
                return _.text !== W || _.containsOnlyTriviaWhiteSpaces !== Te ? A(fl(W, Te), _) : _;
              }
              function cu() {
                var _ = ue(283);
                return _.transformFlags |= 2, _;
              }
              function gc() {
                var _ = ue(284);
                return _.transformFlags |= 2, _;
              }
              function Tf(_, W) {
                var Te = ue(285);
                return Te.name = _, Te.initializer = W, Te.transformFlags |= oe(Te.name) | oe(Te.initializer) | 2, Te;
              }
              function mc(_, W, Te) {
                return _.name !== W || _.initializer !== Te ? A(Tf(W, Te), _) : _;
              }
              function Ip(_) {
                var W = ue(286);
                return W.properties = ne(_), W.transformFlags |= f(W.properties) | 2, W;
              }
              function ms(_, W) {
                return _.properties !== W ? A(Ip(W), _) : _;
              }
              function tu(_) {
                var W = ue(287);
                return W.expression = _, W.transformFlags |= oe(W.expression) | 2, W;
              }
              function wp(_, W) {
                return _.expression !== W ? A(tu(W), _) : _;
              }
              function Hc(_, W) {
                var Te = ue(288);
                return Te.dotDotDotToken = _, Te.expression = W, Te.transformFlags |= oe(Te.dotDotDotToken) | oe(Te.expression) | 2, Te;
              }
              function Ol(_, W) {
                return _.expression !== W ? A(Hc(_.dotDotDotToken, W), _) : _;
              }
              function tf(_, W) {
                var Te = ue(289);
                return Te.expression = y().parenthesizeExpressionForDisallowedComma(_), Te.statements = ne(W), Te.transformFlags |= oe(Te.expression) | f(Te.statements), Te;
              }
              function xf(_, W, Te) {
                return _.expression !== W || _.statements !== Te ? A(tf(W, Te), _) : _;
              }
              function z_(_) {
                var W = ue(290);
                return W.statements = ne(_), W.transformFlags = f(W.statements), W;
              }
              function Oc(_, W) {
                return _.statements !== W ? A(z_(W), _) : _;
              }
              function rs(_, W) {
                var Te = ue(291);
                switch (Te.token = _, Te.types = ne(W), Te.transformFlags |= f(Te.types), _) {
                  case 94:
                    Te.transformFlags |= 1024;
                    break;
                  case 117:
                    Te.transformFlags |= 1;
                    break;
                  default:
                    return e.Debug.assertNever(_);
                }
                return Te;
              }
              function Op(_, W) {
                return _.types !== W ? A(rs(_.token, W), _) : _;
              }
              function Ef(_, W) {
                var Te = ue(292);
                return (typeof _ == "string" || _ && !e.isVariableDeclaration(_)) && (_ = Yl(_, void 0, void 0, void 0)), Te.variableDeclaration = _, Te.block = W, Te.transformFlags |= oe(Te.variableDeclaration) | oe(Te.block), _ || (Te.transformFlags |= 64), Te;
              }
              function Fl(_, W, Te) {
                return _.variableDeclaration !== W || _.block !== Te ? A(Ef(W, Te), _) : _;
              }
              function pl(_, W) {
                var Te = Fe(296, void 0, void 0, _);
                return Te.initializer = y().parenthesizeExpressionForDisallowedComma(W), Te.transformFlags |= oe(Te.name) | oe(Te.initializer), Te;
              }
              function Fp(_, W) {
                return W.decorators && (_.decorators = W.decorators), W.modifiers && (_.modifiers = W.modifiers), W.questionToken && (_.questionToken = W.questionToken), W.exclamationToken && (_.exclamationToken = W.exclamationToken), A(_, W);
              }
              function Mp(_, W, Te) {
                return _.name !== W || _.initializer !== Te ? Fp(pl(W, Te), _) : _;
              }
              function Gu(_, W) {
                var Te = Fe(297, void 0, void 0, _);
                return Te.objectAssignmentInitializer = W && y().parenthesizeExpressionForDisallowedComma(W), Te.transformFlags |= oe(Te.objectAssignmentInitializer) | 1024, Te;
              }
              function Lp(_, W) {
                return W.decorators && (_.decorators = W.decorators), W.modifiers && (_.modifiers = W.modifiers), W.equalsToken && (_.equalsToken = W.equalsToken), W.questionToken && (_.questionToken = W.questionToken), W.exclamationToken && (_.exclamationToken = W.exclamationToken), A(_, W);
              }
              function Cf(_, W, Te) {
                return _.name !== W || _.objectAssignmentInitializer !== Te ? Lp(Gu(W, Te), _) : _;
              }
              function W_(_) {
                var W = ue(298);
                return W.expression = y().parenthesizeExpressionForDisallowedComma(_), W.transformFlags |= oe(W.expression) | 128 | 32768, W;
              }
              function g_(_, W) {
                return _.expression !== W ? A(W_(W), _) : _;
              }
              function dl(_, W) {
                var Te = ue(299);
                return Te.name = Mc(_), Te.initializer = W && y().parenthesizeExpressionForDisallowedComma(W), Te.transformFlags |= oe(Te.name) | oe(Te.initializer) | 1, Te;
              }
              function gl(_, W, Te) {
                return _.name !== W || _.initializer !== Te ? A(dl(W, Te), _) : _;
              }
              function Vf(_, W, Te) {
                var cr = $.createBaseSourceFileNode(305);
                return cr.statements = ne(_), cr.endOfFileToken = W, cr.flags |= Te, cr.fileName = "", cr.text = "", cr.languageVersion = 0, cr.languageVariant = 0, cr.scriptKind = 0, cr.isDeclarationFile = false, cr.hasNoDefaultLib = false, cr.transformFlags |= f(cr.statements) | oe(cr.endOfFileToken), cr;
              }
              function Fc(_, W, Te, cr, ni, rt, yt) {
                var Xa = _.redirectInfo ? Object.create(_.redirectInfo.redirectTarget) : $.createBaseSourceFileNode(305);
                for (var vo in _) vo === "emitNode" || e.hasProperty(Xa, vo) || !e.hasProperty(_, vo) || (Xa[vo] = _[vo]);
                return Xa.flags |= _.flags, Xa.statements = ne(W), Xa.endOfFileToken = _.endOfFileToken, Xa.isDeclarationFile = Te, Xa.referencedFiles = cr, Xa.typeReferenceDirectives = ni, Xa.hasNoDefaultLib = rt, Xa.libReferenceDirectives = yt, Xa.transformFlags = f(Xa.statements) | oe(Xa.endOfFileToken), Xa.impliedNodeFormat = _.impliedNodeFormat, Xa;
              }
              function Hu(_, W, Te, cr, ni, rt, yt) {
                return Te === void 0 && (Te = _.isDeclarationFile), cr === void 0 && (cr = _.referencedFiles), ni === void 0 && (ni = _.typeReferenceDirectives), rt === void 0 && (rt = _.hasNoDefaultLib), yt === void 0 && (yt = _.libReferenceDirectives), _.statements !== W || _.isDeclarationFile !== Te || _.referencedFiles !== cr || _.typeReferenceDirectives !== ni || _.hasNoDefaultLib !== rt || _.libReferenceDirectives !== yt ? A(Fc(_, W, Te, cr, ni, rt, yt), _) : _;
              }
              function af(_, W) {
                W === void 0 && (W = e.emptyArray);
                var Te = ue(306);
                return Te.prepends = W, Te.sourceFiles = _, Te;
              }
              function tn(_, W, Te) {
                return Te === void 0 && (Te = e.emptyArray), _.sourceFiles !== W || _.prepends !== Te ? A(af(W, Te), _) : _;
              }
              function Ml(_, W, Te) {
                var cr = ue(307);
                return cr.prologues = _, cr.syntheticReferences = W, cr.texts = Te, cr.fileName = "", cr.text = "", cr.referencedFiles = e.emptyArray, cr.libReferenceDirectives = e.emptyArray, cr.getLineAndCharacterOfPosition = function(ni) {
                  return e.getLineAndCharacterOfPosition(cr, ni);
                }, cr;
              }
              function Ot(_, W) {
                var Te = ue(_);
                return Te.data = W, Te;
              }
              function nf(_) {
                return Ot(300, _);
              }
              function q_(_, W) {
                var Te = Ot(301, _);
                return Te.texts = W, Te;
              }
              function Kf(_, W) {
                return Ot(W ? 303 : 302, _);
              }
              function Rp(_) {
                var W = ue(304);
                return W.data = _.data, W.section = _, W;
              }
              function yd() {
                var _ = ue(308);
                return _.javascriptText = "", _.declarationText = "", _;
              }
              function m_(_, W, Te) {
                W === void 0 && (W = false);
                var cr = ue(232);
                return cr.type = _, cr.isSpread = W, cr.tupleNameSource = Te, cr;
              }
              function Ll(_) {
                var W = ue(348);
                return W._children = _, W;
              }
              function hd(_) {
                var W = ue(349);
                return W.original = _, e.setTextRange(W, _), W;
              }
              function v_(_, W) {
                var Te = ue(350);
                return Te.expression = _, Te.original = W, Te.transformFlags |= oe(Te.expression) | 1, e.setTextRange(Te, W), Te;
              }
              function Bp(_, W) {
                return _.expression !== W ? A(v_(W, _.original), _) : _;
              }
              function Xu(_) {
                if (e.nodeIsSynthesized(_) && !e.isParseTreeNode(_) && !_.original && !_.emitNode && !_.id) {
                  if (e.isCommaListExpression(_)) return _.elements;
                  if (e.isBinaryExpression(_) && e.isCommaToken(_.operatorToken)) return [_.left, _.right];
                }
                return _;
              }
              function Xc(_) {
                var W = ue(351);
                return W.elements = ne(e.sameFlatMap(_, Xu)), W.transformFlags |= f(W.elements), W;
              }
              function Gf(_, W) {
                return _.elements !== W ? A(Xc(W), _) : _;
              }
              function of(_) {
                var W = ue(353);
                return W.emitNode = {}, W.original = _, W;
              }
              function wu(_) {
                var W = ue(352);
                return W.emitNode = {}, W.original = _, W;
              }
              function V_(_, W) {
                var Te = ue(354);
                return Te.expression = _, Te.thisArg = W, Te.transformFlags |= oe(Te.expression) | oe(Te.thisArg), Te;
              }
              function yu(_, W, Te) {
                return _.expression !== W || _.thisArg !== Te ? A(V_(W, Te), _) : _;
              }
              function v(_) {
                if (_ === void 0) return _;
                var W = e.isSourceFile(_) ? $.createBaseSourceFileNode(305) : e.isIdentifier(_) ? $.createBaseIdentifierNode(79) : e.isPrivateIdentifier(_) ? $.createBasePrivateIdentifierNode(80) : e.isNodeKind(_.kind) ? $.createBaseNode(_.kind) : $.createBaseTokenNode(_.kind);
                W.flags |= _.flags & -9, W.transformFlags = _.transformFlags, he(W, _);
                for (var Te in _) W.hasOwnProperty(Te) || !_.hasOwnProperty(Te) || (W[Te] = _[Te]);
                return W;
              }
              function sr(_, W, Te) {
                return qn(ps(void 0, void 0, void 0, void 0, W ? [W] : [], void 0, bn(_, true)), void 0, Te ? [Te] : []);
              }
              function fi(_, W, Te) {
                return qn(js(void 0, void 0, W ? [W] : [], void 0, void 0, bn(_, true)), void 0, Te ? [Te] : []);
              }
              function zi() {
                return qi(we("0"));
              }
              function Sa(_) {
                return mu(void 0, void 0, false, _);
              }
              function da(_) {
                return hf(void 0, void 0, false, Uf([l_(false, void 0, _)]));
              }
              function Ha(_, W) {
                return W === "undefined" ? g.createStrictEquality(_, zi()) : g.createStrictEquality(Rr(_), Ae(W));
              }
              function ta(_, W, Te) {
                return e.isCallChain(_) ? So(Pi(_, void 0, W), void 0, void 0, Te) : qn(Zr(_, W), void 0, Te);
              }
              function nn(_, W, Te) {
                return ta(_, "bind", Ve([W], Te, true));
              }
              function Wo(_, W, Te) {
                return ta(_, "call", Ve([W], Te, true));
              }
              function Lo(_, W, Te) {
                return ta(_, "apply", [W, Te]);
              }
              function oc(_, W, Te) {
                return ta(Er(_), W, Te);
              }
              function uu(_, W) {
                return ta(_, "slice", W === void 0 ? [] : [Yu(W)]);
              }
              function is(_, W) {
                return ta(_, "concat", W);
              }
              function au(_, W, Te) {
                return oc("Object", "defineProperty", [_, Yu(W), Te]);
              }
              function Ou(_, W, Te) {
                return oc("Reflect", "get", Te ? [_, W, Te] : [_, W]);
              }
              function sf(_, W, Te, cr) {
                return oc("Reflect", "set", cr ? [_, W, Te, cr] : [_, W, Te]);
              }
              function lu(_, W, Te) {
                return Te ? (_.push(pl(W, Te)), true) : false;
              }
              function cf(_, W) {
                var Te = [];
                lu(Te, "enumerable", Yu(_.enumerable)), lu(Te, "configurable", Yu(_.configurable));
                var cr = lu(Te, "writable", Yu(_.writable));
                cr = lu(Te, "value", _.value) || cr;
                var ni = lu(Te, "get", _.get);
                return ni = lu(Te, "set", _.set) || ni, e.Debug.assert(!(cr && ni), "A PropertyDescriptor may not be both an accessor descriptor and a data descriptor."), qe(Te, !W);
              }
              function uf(_, W) {
                switch (_.kind) {
                  case 212:
                    return tc(_, W);
                  case 211:
                    return pc(_, _.type, W);
                  case 229:
                    return vc(_, W, _.type);
                  case 230:
                    return _i(_, W);
                  case 350:
                    return Bp(_, W);
                }
              }
              function K_(_) {
                return e.isParenthesizedExpression(_) && e.nodeIsSynthesized(_) && e.nodeIsSynthesized(e.getSourceMapRange(_)) && e.nodeIsSynthesized(e.getCommentRange(_)) && !e.some(e.getSyntheticLeadingComments(_)) && !e.some(e.getSyntheticTrailingComments(_));
              }
              function Jp(_, W, Te) {
                return Te === void 0 && (Te = 15), _ && e.isOuterExpression(_, Te) && !K_(_) ? uf(_, Jp(_.expression, W)) : W;
              }
              function Hf(_, W, Te) {
                if (!W) return _;
                var cr = P_(W, W.label, e.isLabeledStatement(W.statement) ? Hf(_, W.statement) : _);
                return Te && Te(W), cr;
              }
              function kc(_, W) {
                var Te = e.skipParentheses(_);
                switch (Te.kind) {
                  case 79:
                    return W;
                  case 108:
                  case 8:
                  case 9:
                  case 10:
                    return false;
                  case 204:
                    var cr = Te.elements;
                    return cr.length !== 0;
                  case 205:
                    return Te.properties.length > 0;
                  default:
                    return true;
                }
              }
              function G_(_, W, Te, cr) {
                cr === void 0 && (cr = false);
                var ni = e.skipOuterExpressions(_, 15), rt, yt;
                return e.isSuperProperty(ni) ? (rt = Ur(), yt = ni) : e.isSuperKeyword(ni) ? (rt = Ur(), yt = Te !== void 0 && Te < 2 ? e.setTextRange(Er("_super"), ni) : ni) : e.getEmitFlags(ni) & 4096 ? (rt = zi(), yt = y().parenthesizeLeftSideOfAccess(ni)) : e.isPropertyAccessExpression(ni) ? kc(ni.expression, cr) ? (rt = n(W), yt = Zr(e.setTextRange(g.createAssignment(rt, ni.expression), ni.expression), ni.name), e.setTextRange(yt, ni)) : (rt = ni.expression, yt = ni) : e.isElementAccessExpression(ni) ? kc(ni.expression, cr) ? (rt = n(W), yt = Ct(e.setTextRange(g.createAssignment(rt, ni.expression), ni.expression), ni.argumentExpression), e.setTextRange(yt, ni)) : (rt = ni.expression, yt = ni) : (rt = zi(), yt = y().parenthesizeLeftSideOfAccess(_)), { target: yt, thisArg: rt };
              }
              function Le(_, W) {
                return Zr(hs(qe([nr(void 0, void 0, "value", [Wt(void 0, void 0, void 0, _, void 0, void 0, void 0)], bn([Mo(W)]))])), "value");
              }
              function Nr(_) {
                return _.length > 10 ? Xc(_) : e.reduceLeft(_, g.createComma);
              }
              function ri(_, W, Te, cr) {
                cr === void 0 && (cr = 0);
                var ni = e.getNameOfDeclaration(_);
                if (ni && e.isIdentifier(ni) && !e.isGeneratedIdentifier(ni)) {
                  var rt = e.setParent(e.setTextRange(v(ni), ni), ni.parent);
                  return cr |= e.getEmitFlags(ni), Te || (cr |= 48), W || (cr |= 1536), cr && e.setEmitFlags(rt, cr), rt;
                }
                return Ge(_);
              }
              function di(_, W, Te) {
                return ri(_, W, Te, 49152);
              }
              function Mi(_, W, Te) {
                return ri(_, W, Te, 16384);
              }
              function st(_, W, Te) {
                return ri(_, W, Te, 8192);
              }
              function ra(_, W, Te) {
                return ri(_, W, Te);
              }
              function Ta(_, W, Te, cr) {
                var ni = Zr(_, e.nodeIsSynthesized(W) ? W : v(W));
                e.setTextRange(ni, W);
                var rt = 0;
                return cr || (rt |= 48), Te || (rt |= 1536), rt && e.setEmitFlags(ni, rt), ni;
              }
              function ha(_, W, Te, cr) {
                return _ && e.hasSyntacticModifier(W, 1) ? Ta(_, ri(W), Te, cr) : st(W, Te, cr);
              }
              function Na(_, W, Te, cr) {
                var ni = co(_, W, 0, Te);
                return ts(_, W, ni, cr);
              }
              function In(_) {
                return e.isStringLiteral(_.expression) && _.expression.text === "use strict";
              }
              function qo() {
                return e.startOnNewLine(Mo(Ae("use strict")));
              }
              function co(_, W, Te, cr) {
                Te === void 0 && (Te = 0), e.Debug.assert(W.length === 0, "Prologue directives should be at the first statement in the target statements array");
                for (var ni = false, rt = _.length; Te < rt; ) {
                  var yt = _[Te];
                  if (e.isPrologueDirective(yt)) In(yt) && (ni = true), W.push(yt);
                  else break;
                  Te++;
                }
                return cr && !ni && W.push(qo()), Te;
              }
              function ts(_, W, Te, cr, ni) {
                ni === void 0 && (ni = e.returnTrue);
                for (var rt = _.length; Te !== void 0 && Te < rt; ) {
                  var yt = _[Te];
                  if (e.getEmitFlags(yt) & 1048576 && ni(yt)) e.append(W, cr ? e.visitNode(yt, cr, e.isStatement) : yt);
                  else break;
                  Te++;
                }
                return Te;
              }
              function vs(_) {
                var W = e.findUseStrictPrologue(_);
                return W ? _ : e.setTextRange(ne(Ve([qo()], _, true)), _);
              }
              function Ac(_) {
                return e.Debug.assert(e.every(_, e.isStatementOrBlock), "Cannot lift nodes to a Block."), e.singleOrUndefined(_) || bn(_);
              }
              function Is(_, W, Te) {
                for (var cr = Te; cr < _.length && W(_[cr]); ) cr++;
                return cr;
              }
              function Qu(_, W) {
                if (!e.some(W)) return _;
                var Te = Is(_, e.isPrologueDirective, 0), cr = Is(_, e.isHoistedFunction, Te), ni = Is(_, e.isHoistedVariableStatement, cr), rt = Is(W, e.isPrologueDirective, 0), yt = Is(W, e.isHoistedFunction, rt), Xa = Is(W, e.isHoistedVariableStatement, yt), vo = Is(W, e.isCustomPrologue, Xa);
                e.Debug.assert(vo === W.length, "Expected declarations to be valid standard or custom prologues");
                var Vs = e.isNodeArray(_) ? _.slice() : _;
                if (vo > Xa && Vs.splice.apply(Vs, Ve([ni, 0], W.slice(Xa, vo), false)), Xa > yt && Vs.splice.apply(Vs, Ve([cr, 0], W.slice(yt, Xa), false)), yt > rt && Vs.splice.apply(Vs, Ve([Te, 0], W.slice(rt, yt), false)), rt > 0) if (Te === 0) Vs.splice.apply(Vs, Ve([0, 0], W.slice(0, rt), false));
                else {
                  for (var H_ = new e.Map(), y_ = 0; y_ < Te; y_++) {
                    var Dd = _[y_];
                    H_.set(Dd.expression.text, true);
                  }
                  for (var y_ = rt - 1; y_ >= 0; y_--) {
                    var jp = W[y_];
                    H_.has(jp.expression.text) || Vs.unshift(jp);
                  }
                }
                return e.isNodeArray(_) ? e.setTextRange(ne(Vs, _.hasTrailingComma), _) : _;
              }
              function sc(_, W) {
                var Te, cr;
                return typeof W == "number" ? cr = qr(W) : cr = W, e.isParameter(_) ? Zt(_, _.decorators, cr, _.dotDotDotToken, _.name, _.questionToken, _.type, _.initializer) : e.isPropertySignature(_) ? Xe(_, cr, _.name, _.questionToken, _.type) : e.isPropertyDeclaration(_) ? ti(_, _.decorators, cr, _.name, (Te = _.questionToken) !== null && Te !== void 0 ? Te : _.exclamationToken, _.type, _.initializer) : e.isMethodSignature(_) ? Sr(_, cr, _.name, _.questionToken, _.typeParameters, _.parameters, _.type) : e.isMethodDeclaration(_) ? Wr(_, _.decorators, cr, _.asteriskToken, _.name, _.questionToken, _.typeParameters, _.parameters, _.type, _.body) : e.isConstructorDeclaration(_) ? mr(_, _.decorators, cr, _.parameters, _.body) : e.isGetAccessorDeclaration(_) ? Oe(_, _.decorators, cr, _.name, _.parameters, _.type, _.body) : e.isSetAccessorDeclaration(_) ? Mr(_, _.decorators, cr, _.name, _.parameters, _.body) : e.isIndexSignatureDeclaration(_) ? Vr(_, _.decorators, cr, _.parameters, _.type) : e.isFunctionExpression(_) ? Qs(_, cr, _.asteriskToken, _.name, _.typeParameters, _.parameters, _.type, _.body) : e.isArrowFunction(_) ? ds(_, cr, _.typeParameters, _.parameters, _.type, _.equalsGreaterThanToken, _.body) : e.isClassExpression(_) ? Uu(_, _.decorators, cr, _.name, _.typeParameters, _.heritageClauses, _.members) : e.isVariableStatement(_) ? rn(_, cr, _.declarationList) : e.isFunctionDeclaration(_) ? gu(_, _.decorators, cr, _.asteriskToken, _.name, _.typeParameters, _.parameters, _.type, _.body) : e.isClassDeclaration(_) ? sd(_, _.decorators, cr, _.name, _.typeParameters, _.heritageClauses, _.members) : e.isInterfaceDeclaration(_) ? va(_, _.decorators, cr, _.name, _.typeParameters, _.heritageClauses, _.members) : e.isTypeAliasDeclaration(_) ? qs(_, _.decorators, cr, _.name, _.typeParameters, _.type) : e.isEnumDeclaration(_) ? ns(_, _.decorators, cr, _.name, _.members) : e.isModuleDeclaration(_) ? hc(_, _.decorators, cr, _.name, _.body) : e.isImportEqualsDeclaration(_) ? fd(_, _.decorators, cr, _.isTypeOnly, _.name, _.moduleReference) : e.isImportDeclaration(_) ? Sp(_, _.decorators, cr, _.importClause, _.moduleSpecifier, _.assertClause) : e.isExportAssignment(_) ? gd(_, _.decorators, cr, _.expression) : e.isExportDeclaration(_) ? $l(_, _.decorators, cr, _.isTypeOnly, _.exportClause, _.moduleSpecifier, _.assertClause) : e.Debug.assertNever(_);
              }
              function bc(_) {
                return _ ? ne(_) : void 0;
              }
              function Mc(_) {
                return typeof _ == "string" ? Er(_) : _;
              }
              function Yu(_) {
                return typeof _ == "string" ? Ae(_) : typeof _ == "number" ? we(_) : typeof _ == "boolean" ? _ ? mi() : pe() : _;
              }
              function Rl(_) {
                return typeof _ == "number" ? Ir(_) : _;
              }
              function Lc(_) {
                return _ && e.isNotEmittedStatement(_) ? e.setTextRange(he(jn(), _), _) : _;
              }
            }
            e.createNodeFactory = w;
            function B(X, $) {
              return X !== $ && e.setTextRange(X, $), X;
            }
            function E(X, $) {
              return X !== $ && (he(X, $), e.setTextRange(X, $)), X;
            }
            function Q(X) {
              switch (X) {
                case 343:
                  return "type";
                case 341:
                  return "returns";
                case 342:
                  return "this";
                case 339:
                  return "enum";
                case 330:
                  return "author";
                case 332:
                  return "class";
                case 333:
                  return "public";
                case 334:
                  return "private";
                case 335:
                  return "protected";
                case 336:
                  return "readonly";
                case 337:
                  return "override";
                case 344:
                  return "template";
                case 345:
                  return "typedef";
                case 340:
                  return "param";
                case 347:
                  return "prop";
                case 338:
                  return "callback";
                case 328:
                  return "augments";
                case 329:
                  return "implements";
                default:
                  return e.Debug.fail("Unsupported kind: ".concat(e.Debug.formatSyntaxKind(X)));
              }
            }
            var le, N = {};
            function p(X, $) {
              switch (le || (le = e.createScanner(99, false, 0)), X) {
                case 14:
                  le.setText("`" + $ + "`");
                  break;
                case 15:
                  le.setText("`" + $ + "${");
                  break;
                case 16:
                  le.setText("}" + $ + "${");
                  break;
                case 17:
                  le.setText("}" + $ + "`");
                  break;
              }
              var A = le.scan();
              if (A === 19 && (A = le.reScanTemplateToken(false)), le.isUnterminated()) return le.setText(void 0), N;
              var y;
              switch (A) {
                case 14:
                case 15:
                case 16:
                case 17:
                  y = le.getTokenValue();
                  break;
              }
              return y === void 0 || le.scan() !== 1 ? (le.setText(void 0), N) : (le.setText(void 0), y);
            }
            function m(X) {
              return oe(X) & -16777217;
            }
            function G(X, $) {
              return $ | X.transformFlags & 33562624;
            }
            function oe(X) {
              if (!X) return 0;
              var $ = X.transformFlags & ~K(X.kind);
              return e.isNamedDeclaration(X) && e.isPropertyName(X.name) ? G(X.name, $) : $;
            }
            function f(X) {
              return X ? X.transformFlags : 0;
            }
            function T(X) {
              for (var $ = 0, A = 0, y = X; A < y.length; A++) {
                var V = y[A];
                $ |= oe(V);
              }
              X.transformFlags = $;
            }
            function K(X) {
              if (X >= 177 && X <= 200) return -2;
              switch (X) {
                case 208:
                case 209:
                case 204:
                  return 536887296;
                case 261:
                  return 589443072;
                case 164:
                  return 536870912;
                case 214:
                  return 557748224;
                case 213:
                case 256:
                  return 591310848;
                case 255:
                  return 537165824;
                case 257:
                case 226:
                  return 536940544;
                case 171:
                  return 591306752;
                case 167:
                  return 570433536;
                case 169:
                case 172:
                case 173:
                  return 574529536;
                case 130:
                case 147:
                case 158:
                case 143:
                case 150:
                case 148:
                case 133:
                case 151:
                case 114:
                case 163:
                case 166:
                case 168:
                case 174:
                case 175:
                case 176:
                case 258:
                case 259:
                  return -2;
                case 205:
                  return 536973312;
                case 292:
                  return 536903680;
                case 201:
                case 202:
                  return 536887296;
                case 211:
                case 229:
                case 350:
                case 212:
                case 106:
                  return 536870912;
                case 206:
                case 207:
                  return 536870912;
                default:
                  return 536870912;
              }
            }
            e.getTransformFlagsSubtreeExclusions = K;
            var b = e.createBaseNodeFactory();
            function se(X) {
              return X.flags |= 8, X;
            }
            var J = { createBaseSourceFileNode: function(X) {
              return se(b.createBaseSourceFileNode(X));
            }, createBaseIdentifierNode: function(X) {
              return se(b.createBaseIdentifierNode(X));
            }, createBasePrivateIdentifierNode: function(X) {
              return se(b.createBasePrivateIdentifierNode(X));
            }, createBaseTokenNode: function(X) {
              return se(b.createBaseTokenNode(X));
            }, createBaseNode: function(X) {
              return se(b.createBaseNode(X));
            } };
            e.factory = w(4, J);
            function ie(X, $, A) {
              var y, V, L, P, k, Y, U, j, H, I;
              e.isString(X) ? (L = "", P = X, k = X.length, Y = $, U = A) : (e.Debug.assert($ === "js" || $ === "dts"), L = ($ === "js" ? X.javascriptPath : X.declarationPath) || "", Y = $ === "js" ? X.javascriptMapPath : X.declarationMapPath, j = function() {
                return $ === "js" ? X.javascriptText : X.declarationText;
              }, H = function() {
                return $ === "js" ? X.javascriptMapText : X.declarationMapText;
              }, k = function() {
                return j().length;
              }, X.buildInfo && X.buildInfo.bundle && (e.Debug.assert(A === void 0 || typeof A == "boolean"), y = A, V = $ === "js" ? X.buildInfo.bundle.js : X.buildInfo.bundle.dts, I = X.oldFileOfCurrentEmit));
              var l = I ? q(e.Debug.checkDefined(V)) : R(V, y, k);
              return l.fileName = L, l.sourceMapPath = Y, l.oldFileOfCurrentEmit = I, j && H ? (Object.defineProperty(l, "text", { get: j }), Object.defineProperty(l, "sourceMapText", { get: H })) : (e.Debug.assert(!I), l.text = P != null ? P : "", l.sourceMapText = U), l;
            }
            e.createUnparsedSourceFile = ie;
            function R(X, $, A) {
              for (var y, V, L, P, k, Y, U, j, H = 0, I = X ? X.sections : e.emptyArray; H < I.length; H++) {
                var l = I[H];
                switch (l.kind) {
                  case "prologue":
                    y = e.append(y, e.setTextRange(e.factory.createUnparsedPrologue(l.data), l));
                    break;
                  case "emitHelpers":
                    V = e.append(V, e.getAllUnscopedEmitHelpers().get(l.data));
                    break;
                  case "no-default-lib":
                    j = true;
                    break;
                  case "reference":
                    L = e.append(L, { pos: -1, end: -1, fileName: l.data });
                    break;
                  case "type":
                    P = e.append(P, { pos: -1, end: -1, fileName: l.data });
                    break;
                  case "type-import":
                    P = e.append(P, { pos: -1, end: -1, fileName: l.data, resolutionMode: e.ModuleKind.ESNext });
                    break;
                  case "type-require":
                    P = e.append(P, { pos: -1, end: -1, fileName: l.data, resolutionMode: e.ModuleKind.CommonJS });
                    break;
                  case "lib":
                    k = e.append(k, { pos: -1, end: -1, fileName: l.data });
                    break;
                  case "prepend":
                    for (var d = void 0, D = 0, fe = l.texts; D < fe.length; D++) {
                      var g = fe[D];
                      (!$ || g.kind !== "internal") && (d = e.append(d, e.setTextRange(e.factory.createUnparsedTextLike(g.data, g.kind === "internal"), g)));
                    }
                    Y = e.addRange(Y, d), U = e.append(U, e.factory.createUnparsedPrepend(l.data, d != null ? d : e.emptyArray));
                    break;
                  case "internal":
                    if ($) {
                      U || (U = []);
                      break;
                    }
                  case "text":
                    U = e.append(U, e.setTextRange(e.factory.createUnparsedTextLike(l.data, l.kind === "internal"), l));
                    break;
                  default:
                    e.Debug.assertNever(l);
                }
              }
              if (!U) {
                var ne = e.factory.createUnparsedTextLike(void 0, false);
                e.setTextRangePosWidth(ne, 0, typeof A == "function" ? A() : A), U = [ne];
              }
              var ue = e.parseNodeFactory.createUnparsedSource(y != null ? y : e.emptyArray, void 0, U);
              return e.setEachParent(y, ue), e.setEachParent(U, ue), e.setEachParent(Y, ue), ue.hasNoDefaultLib = j, ue.helpers = V, ue.referencedFiles = L || e.emptyArray, ue.typeReferenceDirectives = P, ue.libReferenceDirectives = k || e.emptyArray, ue;
            }
            function q(X) {
              for (var $, A, y = 0, V = X.sections; y < V.length; y++) {
                var L = V[y];
                switch (L.kind) {
                  case "internal":
                  case "text":
                    $ = e.append($, e.setTextRange(e.factory.createUnparsedTextLike(L.data, L.kind === "internal"), L));
                    break;
                  case "no-default-lib":
                  case "reference":
                  case "type":
                  case "type-import":
                  case "type-require":
                  case "lib":
                    A = e.append(A, e.setTextRange(e.factory.createUnparsedSyntheticReference(L), L));
                    break;
                  case "prologue":
                  case "emitHelpers":
                  case "prepend":
                    break;
                  default:
                    e.Debug.assertNever(L);
                }
              }
              var P = e.factory.createUnparsedSource(e.emptyArray, A, $ != null ? $ : e.emptyArray);
              return e.setEachParent(A, P), e.setEachParent($, P), P.helpers = e.map(X.sources && X.sources.helpers, function(k) {
                return e.getAllUnscopedEmitHelpers().get(k);
              }), P;
            }
            function O(X, $, A, y, V, L, P, k, Y, U, j) {
              var H = e.parseNodeFactory.createInputFiles();
              if (e.isString(X)) H.javascriptText = X, H.javascriptMapPath = A, H.javascriptMapText = y, H.declarationText = $, H.declarationMapPath = V, H.declarationMapText = L, H.javascriptPath = P, H.declarationPath = k, H.buildInfoPath = Y, H.buildInfo = U, H.oldFileOfCurrentEmit = j;
              else {
                var I = new e.Map(), l = function(g) {
                  if (g !== void 0) {
                    var ne = I.get(g);
                    return ne === void 0 && (ne = X(g), I.set(g, ne !== void 0 ? ne : false)), ne !== false ? ne : void 0;
                  }
                }, d = function(g) {
                  var ne = l(g);
                  return ne !== void 0 ? ne : "/* Input file ".concat(g, ` was missing */\r
`);
                }, D, fe = function(g) {
                  if (D === void 0) {
                    var ne = g();
                    D = ne !== void 0 ? e.getBuildInfo(ne) : false;
                  }
                  return D || void 0;
                };
                H.javascriptPath = $, H.javascriptMapPath = A, H.declarationPath = e.Debug.checkDefined(y), H.declarationMapPath = V, H.buildInfoPath = L, Object.defineProperties(H, { javascriptText: { get: function() {
                  return d($);
                } }, javascriptMapText: { get: function() {
                  return l(A);
                } }, declarationText: { get: function() {
                  return d(e.Debug.checkDefined(y));
                } }, declarationMapText: { get: function() {
                  return l(V);
                } }, buildInfo: { get: function() {
                  return fe(function() {
                    return l(L);
                  });
                } } });
              }
              return H;
            }
            e.createInputFiles = O;
            var ve;
            function ee(X, $, A) {
              return new (ve || (ve = e.objectAllocator.getSourceMapSourceConstructor()))(X, $, A);
            }
            e.createSourceMapSource = ee;
            function he(X, $) {
              if (X.original = $, $) {
                var A = $.emitNode;
                A && (X.emitNode = F(A, X.emitNode));
              }
              return X;
            }
            e.setOriginalNode = he;
            function F(X, $) {
              var A = X.flags, y = X.leadingComments, V = X.trailingComments, L = X.commentRange, P = X.sourceMapRange, k = X.tokenSourceMapRanges, Y = X.constantValue, U = X.helpers, j = X.startsOnNewLine;
              if ($ || ($ = {}), y && ($.leadingComments = e.addRange(y.slice(), $.leadingComments)), V && ($.trailingComments = e.addRange(V.slice(), $.trailingComments)), A && ($.flags = A & -268435457), L && ($.commentRange = L), P && ($.sourceMapRange = P), k && ($.tokenSourceMapRanges = x(k, $.tokenSourceMapRanges)), Y !== void 0 && ($.constantValue = Y), U) for (var H = 0, I = U; H < I.length; H++) {
                var l = I[H];
                $.helpers = e.appendIfUnique($.helpers, l);
              }
              return j !== void 0 && ($.startsOnNewLine = j), $;
            }
            function x(X, $) {
              $ || ($ = []);
              for (var A in X) $[A] = X[A];
              return $;
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(L) {
              var P;
              if (L.emitNode) e.Debug.assert(!(L.emitNode.flags & 268435456), "Invalid attempt to mutate an immutable node.");
              else {
                if (e.isParseTreeNode(L)) {
                  if (L.kind === 305) return L.emitNode = { annotatedNodes: [L] };
                  var k = (P = e.getSourceFileOfNode(e.getParseTreeNode(e.getSourceFileOfNode(L)))) !== null && P !== void 0 ? P : e.Debug.fail("Could not determine parsed source file.");
                  a(k).annotatedNodes.push(L);
                }
                L.emitNode = {};
              }
              return L.emitNode;
            }
            e.getOrCreateEmitNode = a;
            function C(L) {
              var P, k, Y = (k = (P = e.getSourceFileOfNode(e.getParseTreeNode(L))) === null || P === void 0 ? void 0 : P.emitNode) === null || k === void 0 ? void 0 : k.annotatedNodes;
              if (Y) for (var U = 0, j = Y; U < j.length; U++) {
                var H = j[U];
                H.emitNode = void 0;
              }
            }
            e.disposeEmitNodes = C;
            function w(L) {
              var P = a(L);
              return P.flags |= 1536, P.leadingComments = void 0, P.trailingComments = void 0, L;
            }
            e.removeAllComments = w;
            function B(L, P) {
              return a(L).flags = P, L;
            }
            e.setEmitFlags = B;
            function E(L, P) {
              var k = a(L);
              return k.flags = k.flags | P, L;
            }
            e.addEmitFlags = E;
            function Q(L) {
              var P, k;
              return (k = (P = L.emitNode) === null || P === void 0 ? void 0 : P.sourceMapRange) !== null && k !== void 0 ? k : L;
            }
            e.getSourceMapRange = Q;
            function le(L, P) {
              return a(L).sourceMapRange = P, L;
            }
            e.setSourceMapRange = le;
            function N(L, P) {
              var k, Y;
              return (Y = (k = L.emitNode) === null || k === void 0 ? void 0 : k.tokenSourceMapRanges) === null || Y === void 0 ? void 0 : Y[P];
            }
            e.getTokenSourceMapRange = N;
            function p(L, P, k) {
              var Y, U = a(L), j = (Y = U.tokenSourceMapRanges) !== null && Y !== void 0 ? Y : U.tokenSourceMapRanges = [];
              return j[P] = k, L;
            }
            e.setTokenSourceMapRange = p;
            function m(L) {
              var P;
              return (P = L.emitNode) === null || P === void 0 ? void 0 : P.startsOnNewLine;
            }
            e.getStartsOnNewLine = m;
            function G(L, P) {
              return a(L).startsOnNewLine = P, L;
            }
            e.setStartsOnNewLine = G;
            function oe(L) {
              var P, k;
              return (k = (P = L.emitNode) === null || P === void 0 ? void 0 : P.commentRange) !== null && k !== void 0 ? k : L;
            }
            e.getCommentRange = oe;
            function f(L, P) {
              return a(L).commentRange = P, L;
            }
            e.setCommentRange = f;
            function T(L) {
              var P;
              return (P = L.emitNode) === null || P === void 0 ? void 0 : P.leadingComments;
            }
            e.getSyntheticLeadingComments = T;
            function K(L, P) {
              return a(L).leadingComments = P, L;
            }
            e.setSyntheticLeadingComments = K;
            function b(L, P, k, Y) {
              return K(L, e.append(T(L), { kind: P, pos: -1, end: -1, hasTrailingNewLine: Y, text: k }));
            }
            e.addSyntheticLeadingComment = b;
            function se(L) {
              var P;
              return (P = L.emitNode) === null || P === void 0 ? void 0 : P.trailingComments;
            }
            e.getSyntheticTrailingComments = se;
            function J(L, P) {
              return a(L).trailingComments = P, L;
            }
            e.setSyntheticTrailingComments = J;
            function ie(L, P, k, Y) {
              return J(L, e.append(se(L), { kind: P, pos: -1, end: -1, hasTrailingNewLine: Y, text: k }));
            }
            e.addSyntheticTrailingComment = ie;
            function R(L, P) {
              K(L, T(P)), J(L, se(P));
              var k = a(P);
              return k.leadingComments = void 0, k.trailingComments = void 0, L;
            }
            e.moveSyntheticComments = R;
            function q(L) {
              var P;
              return (P = L.emitNode) === null || P === void 0 ? void 0 : P.constantValue;
            }
            e.getConstantValue = q;
            function O(L, P) {
              var k = a(L);
              return k.constantValue = P, L;
            }
            e.setConstantValue = O;
            function ve(L, P) {
              var k = a(L);
              return k.helpers = e.append(k.helpers, P), L;
            }
            e.addEmitHelper = ve;
            function ee(L, P) {
              if (e.some(P)) for (var k = a(L), Y = 0, U = P; Y < U.length; Y++) {
                var j = U[Y];
                k.helpers = e.appendIfUnique(k.helpers, j);
              }
              return L;
            }
            e.addEmitHelpers = ee;
            function he(L, P) {
              var k, Y = (k = L.emitNode) === null || k === void 0 ? void 0 : k.helpers;
              return Y ? e.orderedRemoveItem(Y, P) : false;
            }
            e.removeEmitHelper = he;
            function F(L) {
              var P;
              return (P = L.emitNode) === null || P === void 0 ? void 0 : P.helpers;
            }
            e.getEmitHelpers = F;
            function x(L, P, k) {
              var Y = L.emitNode, U = Y && Y.helpers;
              if (!!e.some(U)) {
                for (var j = a(P), H = 0, I = 0; I < U.length; I++) {
                  var l = U[I];
                  k(l) ? (H++, j.helpers = e.appendIfUnique(j.helpers, l)) : H > 0 && (U[I - H] = l);
                }
                H > 0 && (U.length -= H);
              }
            }
            e.moveEmitHelpers = x;
            function X(L) {
              var P;
              return (P = L.emitNode) === null || P === void 0 ? void 0 : P.snippetElement;
            }
            e.getSnippetElement = X;
            function $(L, P) {
              var k = a(L);
              return k.snippetElement = P, L;
            }
            e.setSnippetElement = $;
            function A(L) {
              return a(L).flags |= 134217728, L;
            }
            e.ignoreSourceNewlines = A;
            function y(L, P) {
              var k = a(L);
              return k.typeNode = P, L;
            }
            e.setTypeNode = y;
            function V(L) {
              var P;
              return (P = L.emitNode) === null || P === void 0 ? void 0 : P.typeNode;
            }
            e.getTypeNode = V;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(le) {
              var N = le.factory, p = e.memoize(function() {
                return e.setEmitFlags(N.createTrue(), 268435456);
              }), m = e.memoize(function() {
                return e.setEmitFlags(N.createFalse(), 268435456);
              });
              return { getUnscopedHelperName: G, createDecorateHelper: oe, createMetadataHelper: f, createParamHelper: T, createAssignHelper: K, createAwaitHelper: b, createAsyncGeneratorHelper: se, createAsyncDelegatorHelper: J, createAsyncValuesHelper: ie, createRestHelper: R, createAwaiterHelper: q, createExtendsHelper: O, createTemplateObjectHelper: ve, createSpreadArrayHelper: ee, createValuesHelper: he, createReadHelper: F, createGeneratorHelper: x, createCreateBindingHelper: X, createImportStarHelper: $, createImportStarCallbackHelper: A, createImportDefaultHelper: y, createExportStarHelper: V, createClassPrivateFieldGetHelper: L, createClassPrivateFieldSetHelper: P, createClassPrivateFieldInHelper: k };
              function G(Y) {
                return e.setEmitFlags(N.createIdentifier(Y), 4098);
              }
              function oe(Y, U, j, H) {
                le.requestEmitHelper(e.decorateHelper);
                var I = [];
                return I.push(N.createArrayLiteralExpression(Y, true)), I.push(U), j && (I.push(j), H && I.push(H)), N.createCallExpression(G("__decorate"), void 0, I);
              }
              function f(Y, U) {
                return le.requestEmitHelper(e.metadataHelper), N.createCallExpression(G("__metadata"), void 0, [N.createStringLiteral(Y), U]);
              }
              function T(Y, U, j) {
                return le.requestEmitHelper(e.paramHelper), e.setTextRange(N.createCallExpression(G("__param"), void 0, [N.createNumericLiteral(U + ""), Y]), j);
              }
              function K(Y) {
                return e.getEmitScriptTarget(le.getCompilerOptions()) >= 2 ? N.createCallExpression(N.createPropertyAccessExpression(N.createIdentifier("Object"), "assign"), void 0, Y) : (le.requestEmitHelper(e.assignHelper), N.createCallExpression(G("__assign"), void 0, Y));
              }
              function b(Y) {
                return le.requestEmitHelper(e.awaitHelper), N.createCallExpression(G("__await"), void 0, [Y]);
              }
              function se(Y, U) {
                return le.requestEmitHelper(e.awaitHelper), le.requestEmitHelper(e.asyncGeneratorHelper), (Y.emitNode || (Y.emitNode = {})).flags |= 786432, N.createCallExpression(G("__asyncGenerator"), void 0, [U ? N.createThis() : N.createVoidZero(), N.createIdentifier("arguments"), Y]);
              }
              function J(Y) {
                return le.requestEmitHelper(e.awaitHelper), le.requestEmitHelper(e.asyncDelegator), N.createCallExpression(G("__asyncDelegator"), void 0, [Y]);
              }
              function ie(Y) {
                return le.requestEmitHelper(e.asyncValues), N.createCallExpression(G("__asyncValues"), void 0, [Y]);
              }
              function R(Y, U, j, H) {
                le.requestEmitHelper(e.restHelper);
                for (var I = [], l = 0, d = 0; d < U.length - 1; d++) {
                  var D = e.getPropertyNameOfBindingOrAssignmentElement(U[d]);
                  if (D) if (e.isComputedPropertyName(D)) {
                    e.Debug.assertIsDefined(j, "Encountered computed property name but 'computedTempVariables' argument was not provided.");
                    var fe = j[l];
                    l++, I.push(N.createConditionalExpression(N.createTypeCheck(fe, "symbol"), void 0, fe, void 0, N.createAdd(fe, N.createStringLiteral(""))));
                  } else I.push(N.createStringLiteralFromNode(D));
                }
                return N.createCallExpression(G("__rest"), void 0, [Y, e.setTextRange(N.createArrayLiteralExpression(I), H)]);
              }
              function q(Y, U, j, H) {
                le.requestEmitHelper(e.awaiterHelper);
                var I = N.createFunctionExpression(void 0, N.createToken(41), void 0, void 0, [], void 0, H);
                return (I.emitNode || (I.emitNode = {})).flags |= 786432, N.createCallExpression(G("__awaiter"), void 0, [Y ? N.createThis() : N.createVoidZero(), U ? N.createIdentifier("arguments") : N.createVoidZero(), j ? e.createExpressionFromEntityName(N, j) : N.createVoidZero(), I]);
              }
              function O(Y) {
                return le.requestEmitHelper(e.extendsHelper), N.createCallExpression(G("__extends"), void 0, [Y, N.createUniqueName("_super", 48)]);
              }
              function ve(Y, U) {
                return le.requestEmitHelper(e.templateObjectHelper), N.createCallExpression(G("__makeTemplateObject"), void 0, [Y, U]);
              }
              function ee(Y, U, j) {
                return le.requestEmitHelper(e.spreadArrayHelper), N.createCallExpression(G("__spreadArray"), void 0, [Y, U, j ? p() : m()]);
              }
              function he(Y) {
                return le.requestEmitHelper(e.valuesHelper), N.createCallExpression(G("__values"), void 0, [Y]);
              }
              function F(Y, U) {
                return le.requestEmitHelper(e.readHelper), N.createCallExpression(G("__read"), void 0, U !== void 0 ? [Y, N.createNumericLiteral(U + "")] : [Y]);
              }
              function x(Y) {
                return le.requestEmitHelper(e.generatorHelper), N.createCallExpression(G("__generator"), void 0, [N.createThis(), Y]);
              }
              function X(Y, U, j) {
                return le.requestEmitHelper(e.createBindingHelper), N.createCallExpression(G("__createBinding"), void 0, Ve([N.createIdentifier("exports"), Y, U], j ? [j] : [], true));
              }
              function $(Y) {
                return le.requestEmitHelper(e.importStarHelper), N.createCallExpression(G("__importStar"), void 0, [Y]);
              }
              function A() {
                return le.requestEmitHelper(e.importStarHelper), G("__importStar");
              }
              function y(Y) {
                return le.requestEmitHelper(e.importDefaultHelper), N.createCallExpression(G("__importDefault"), void 0, [Y]);
              }
              function V(Y, U) {
                return U === void 0 && (U = N.createIdentifier("exports")), le.requestEmitHelper(e.exportStarHelper), le.requestEmitHelper(e.createBindingHelper), N.createCallExpression(G("__exportStar"), void 0, [Y, U]);
              }
              function L(Y, U, j, H) {
                le.requestEmitHelper(e.classPrivateFieldGetHelper);
                var I;
                return H ? I = [Y, U, N.createStringLiteral(j), H] : I = [Y, U, N.createStringLiteral(j)], N.createCallExpression(G("__classPrivateFieldGet"), void 0, I);
              }
              function P(Y, U, j, H, I) {
                le.requestEmitHelper(e.classPrivateFieldSetHelper);
                var l;
                return I ? l = [Y, U, j, N.createStringLiteral(H), I] : l = [Y, U, j, N.createStringLiteral(H)], N.createCallExpression(G("__classPrivateFieldSet"), void 0, l);
              }
              function k(Y, U) {
                return le.requestEmitHelper(e.classPrivateFieldInHelper), N.createCallExpression(G("__classPrivateFieldIn"), void 0, [Y, U]);
              }
            }
            e.createEmitHelperFactory = a;
            function C(le, N) {
              return le === N || le.priority === N.priority ? 0 : le.priority === void 0 ? 1 : N.priority === void 0 ? -1 : e.compareValues(le.priority, N.priority);
            }
            e.compareEmitHelpers = C;
            function w(le) {
              for (var N = [], p = 1; p < arguments.length; p++) N[p - 1] = arguments[p];
              return function(m) {
                for (var G = "", oe = 0; oe < N.length; oe++) G += le[oe], G += m(N[oe]);
                return G += le[le.length - 1], G;
              };
            }
            e.helperString = w, e.decorateHelper = { name: "typescript:decorate", importName: "__decorate", scoped: false, priority: 2, text: `
            var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
                var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
                if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
                else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
                return c > 3 && r && Object.defineProperty(target, key, r), r;
            };` }, e.metadataHelper = { name: "typescript:metadata", importName: "__metadata", scoped: false, priority: 3, text: `
            var __metadata = (this && this.__metadata) || function (k, v) {
                if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
            };` }, e.paramHelper = { name: "typescript:param", importName: "__param", scoped: false, priority: 4, text: `
            var __param = (this && this.__param) || function (paramIndex, decorator) {
                return function (target, key) { decorator(target, key, paramIndex); }
            };` }, e.assignHelper = { name: "typescript:assign", importName: "__assign", scoped: false, priority: 1, text: `
            var __assign = (this && this.__assign) || function () {
                __assign = Object.assign || function(t) {
                    for (var s, i = 1, n = arguments.length; i < n; i++) {
                        s = arguments[i];
                        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                            t[p] = s[p];
                    }
                    return t;
                };
                return __assign.apply(this, arguments);
            };` }, e.awaitHelper = { name: "typescript:await", importName: "__await", scoped: false, text: `
            var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }` }, e.asyncGeneratorHelper = { name: "typescript:asyncGenerator", importName: "__asyncGenerator", scoped: false, dependencies: [e.awaitHelper], text: `
            var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
                if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
                var g = generator.apply(thisArg, _arguments || []), i, q = [];
                return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
                function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
                function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
                function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
                function fulfill(value) { resume("next", value); }
                function reject(value) { resume("throw", value); }
                function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
            };` }, e.asyncDelegator = { name: "typescript:asyncDelegator", importName: "__asyncDelegator", scoped: false, dependencies: [e.awaitHelper], text: `
            var __asyncDelegator = (this && this.__asyncDelegator) || function (o) {
                var i, p;
                return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
                function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
            };` }, e.asyncValues = { name: "typescript:asyncValues", importName: "__asyncValues", scoped: false, text: `
            var __asyncValues = (this && this.__asyncValues) || function (o) {
                if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
                var m = o[Symbol.asyncIterator], i;
                return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
                function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
                function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
            };` }, e.restHelper = { name: "typescript:rest", importName: "__rest", scoped: false, text: `
            var __rest = (this && this.__rest) || function (s, e) {
                var t = {};
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                    t[p] = s[p];
                if (s != null && typeof Object.getOwnPropertySymbols === "function")
                    for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                        if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                            t[p[i]] = s[p[i]];
                    }
                return t;
            };` }, e.awaiterHelper = { name: "typescript:awaiter", importName: "__awaiter", scoped: false, priority: 5, text: `
            var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
                function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
                return new (P || (P = Promise))(function (resolve, reject) {
                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
                    function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
                    step((generator = generator.apply(thisArg, _arguments || [])).next());
                });
            };` }, e.extendsHelper = { name: "typescript:extends", importName: "__extends", scoped: false, priority: 0, text: `
            var __extends = (this && this.__extends) || (function () {
                var extendStatics = function (d, b) {
                    extendStatics = Object.setPrototypeOf ||
                        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
                    return extendStatics(d, b);
                };

                return function (d, b) {
                    if (typeof b !== "function" && b !== null)
                        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
                    extendStatics(d, b);
                    function __() { this.constructor = d; }
                    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
                };
            })();` }, e.templateObjectHelper = { name: "typescript:makeTemplateObject", importName: "__makeTemplateObject", scoped: false, priority: 0, text: `
            var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
                if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
                return cooked;
            };` }, e.readHelper = { name: "typescript:read", importName: "__read", scoped: false, text: `
            var __read = (this && this.__read) || function (o, n) {
                var m = typeof Symbol === "function" && o[Symbol.iterator];
                if (!m) return o;
                var i = m.call(o), r, ar = [], e;
                try {
                    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
                }
                catch (error) { e = { error: error }; }
                finally {
                    try {
                        if (r && !r.done && (m = i["return"])) m.call(i);
                    }
                    finally { if (e) throw e.error; }
                }
                return ar;
            };` }, e.spreadArrayHelper = { name: "typescript:spreadArray", importName: "__spreadArray", scoped: false, text: `
            var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
                if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
                    if (ar || !(i in from)) {
                        if (!ar) ar = Array.prototype.slice.call(from, 0, i);
                        ar[i] = from[i];
                    }
                }
                return to.concat(ar || Array.prototype.slice.call(from));
            };` }, e.valuesHelper = { name: "typescript:values", importName: "__values", scoped: false, text: `
            var __values = (this && this.__values) || function(o) {
                var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
                if (m) return m.call(o);
                if (o && typeof o.length === "number") return {
                    next: function () {
                        if (o && i >= o.length) o = void 0;
                        return { value: o && o[i++], done: !o };
                    }
                };
                throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
            };` }, e.generatorHelper = { name: "typescript:generator", importName: "__generator", scoped: false, priority: 6, text: `
            var __generator = (this && this.__generator) || function (thisArg, body) {
                var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
                return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
                function verb(n) { return function (v) { return step([n, v]); }; }
                function step(op) {
                    if (f) throw new TypeError("Generator is already executing.");
                    while (_) try {
                        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                        if (y = 0, t) op = [op[0] & 2, t.value];
                        switch (op[0]) {
                            case 0: case 1: t = op; break;
                            case 4: _.label++; return { value: op[1], done: false };
                            case 5: _.label++; y = op[1]; op = [0]; continue;
                            case 7: op = _.ops.pop(); _.trys.pop(); continue;
                            default:
                                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                                if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                                if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                                if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                                if (t[2]) _.ops.pop();
                                _.trys.pop(); continue;
                        }
                        op = body.call(thisArg, _);
                    } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
                    if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
                }
            };` }, e.createBindingHelper = { name: "typescript:commonjscreatebinding", importName: "__createBinding", scoped: false, priority: 1, text: `
            var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
                if (k2 === undefined) k2 = k;
                var desc = Object.getOwnPropertyDescriptor(m, k);
                if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
                  desc = { enumerable: true, get: function() { return m[k]; } };
                }
                Object.defineProperty(o, k2, desc);
            }) : (function(o, m, k, k2) {
                if (k2 === undefined) k2 = k;
                o[k2] = m[k];
            }));` }, e.setModuleDefaultHelper = { name: "typescript:commonjscreatevalue", importName: "__setModuleDefault", scoped: false, priority: 1, text: `
            var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
                Object.defineProperty(o, "default", { enumerable: true, value: v });
            }) : function(o, v) {
                o["default"] = v;
            });` }, e.importStarHelper = { name: "typescript:commonjsimportstar", importName: "__importStar", scoped: false, dependencies: [e.createBindingHelper, e.setModuleDefaultHelper], priority: 2, text: `
            var __importStar = (this && this.__importStar) || function (mod) {
                if (mod && mod.__esModule) return mod;
                var result = {};
                if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
                __setModuleDefault(result, mod);
                return result;
            };` }, e.importDefaultHelper = { name: "typescript:commonjsimportdefault", importName: "__importDefault", scoped: false, text: `
            var __importDefault = (this && this.__importDefault) || function (mod) {
                return (mod && mod.__esModule) ? mod : { "default": mod };
            };` }, e.exportStarHelper = { name: "typescript:export-star", importName: "__exportStar", scoped: false, dependencies: [e.createBindingHelper], priority: 2, text: `
            var __exportStar = (this && this.__exportStar) || function(m, exports) {
                for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
            };` }, e.classPrivateFieldGetHelper = { name: "typescript:classPrivateFieldGet", importName: "__classPrivateFieldGet", scoped: false, text: `
            var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
                if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
                if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
                return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
            };` }, e.classPrivateFieldSetHelper = { name: "typescript:classPrivateFieldSet", importName: "__classPrivateFieldSet", scoped: false, text: `
            var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
                if (kind === "m") throw new TypeError("Private method is not writable");
                if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
                if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
                return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
            };` }, e.classPrivateFieldInHelper = { name: "typescript:classPrivateFieldIn", importName: "__classPrivateFieldIn", scoped: false, text: `
            var __classPrivateFieldIn = (this && this.__classPrivateFieldIn) || function(state, receiver) {
                if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function")) throw new TypeError("Cannot use 'in' operator on non-object");
                return typeof state === "function" ? receiver === state : state.has(receiver);
            };` };
            var B;
            function E() {
              return B || (B = e.arrayToMap([e.decorateHelper, e.metadataHelper, e.paramHelper, e.assignHelper, e.awaitHelper, e.asyncGeneratorHelper, e.asyncDelegator, e.asyncValues, e.restHelper, e.awaiterHelper, e.extendsHelper, e.templateObjectHelper, e.spreadArrayHelper, e.valuesHelper, e.readHelper, e.generatorHelper, e.importStarHelper, e.importDefaultHelper, e.exportStarHelper, e.classPrivateFieldGetHelper, e.classPrivateFieldSetHelper, e.classPrivateFieldInHelper, e.createBindingHelper, e.setModuleDefaultHelper], function(le) {
                return le.name;
              }));
            }
            e.getAllUnscopedEmitHelpers = E, e.asyncSuperHelper = { name: "typescript:async-super", scoped: true, text: w(oi([`
            const `, " = name => super[name];"], [`
            const `, " = name => super[name];"]), "_superIndex") }, e.advancedAsyncSuperHelper = { name: "typescript:advanced-async-super", scoped: true, text: w(oi([`
            const `, ` = (function (geti, seti) {
                const cache = Object.create(null);
                return name => cache[name] || (cache[name] = { get value() { return geti(name); }, set value(v) { seti(name, v); } });
            })(name => super[name], (name, value) => super[name] = value);`], [`
            const `, ` = (function (geti, seti) {
                const cache = Object.create(null);
                return name => cache[name] || (cache[name] = { get value() { return geti(name); }, set value(v) { seti(name, v); } });
            })(name => super[name], (name, value) => super[name] = value);`]), "_superIndex") };
            function Q(le, N) {
              return e.isCallExpression(le) && e.isIdentifier(le.expression) && (e.getEmitFlags(le.expression) & 4096) !== 0 && le.expression.escapedText === N;
            }
            e.isCallToHelper = Q;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(jr) {
              return jr.kind === 8;
            }
            e.isNumericLiteral = a;
            function C(jr) {
              return jr.kind === 9;
            }
            e.isBigIntLiteral = C;
            function w(jr) {
              return jr.kind === 10;
            }
            e.isStringLiteral = w;
            function B(jr) {
              return jr.kind === 11;
            }
            e.isJsxText = B;
            function E(jr) {
              return jr.kind === 13;
            }
            e.isRegularExpressionLiteral = E;
            function Q(jr) {
              return jr.kind === 14;
            }
            e.isNoSubstitutionTemplateLiteral = Q;
            function le(jr) {
              return jr.kind === 15;
            }
            e.isTemplateHead = le;
            function N(jr) {
              return jr.kind === 16;
            }
            e.isTemplateMiddle = N;
            function p(jr) {
              return jr.kind === 17;
            }
            e.isTemplateTail = p;
            function m(jr) {
              return jr.kind === 25;
            }
            e.isDotDotDotToken = m;
            function G(jr) {
              return jr.kind === 27;
            }
            e.isCommaToken = G;
            function oe(jr) {
              return jr.kind === 39;
            }
            e.isPlusToken = oe;
            function f(jr) {
              return jr.kind === 40;
            }
            e.isMinusToken = f;
            function T(jr) {
              return jr.kind === 41;
            }
            e.isAsteriskToken = T;
            function K(jr) {
              return jr.kind === 53;
            }
            e.isExclamationToken = K;
            function b(jr) {
              return jr.kind === 57;
            }
            e.isQuestionToken = b;
            function se(jr) {
              return jr.kind === 58;
            }
            e.isColonToken = se;
            function J(jr) {
              return jr.kind === 28;
            }
            e.isQuestionDotToken = J;
            function ie(jr) {
              return jr.kind === 38;
            }
            e.isEqualsGreaterThanToken = ie;
            function R(jr) {
              return jr.kind === 79;
            }
            e.isIdentifier = R;
            function q(jr) {
              return jr.kind === 80;
            }
            e.isPrivateIdentifier = q;
            function O(jr) {
              return jr.kind === 93;
            }
            e.isExportModifier = O;
            function ve(jr) {
              return jr.kind === 131;
            }
            e.isAsyncModifier = ve;
            function ee(jr) {
              return jr.kind === 128;
            }
            e.isAssertsKeyword = ee;
            function he(jr) {
              return jr.kind === 132;
            }
            e.isAwaitKeyword = he;
            function F(jr) {
              return jr.kind === 145;
            }
            e.isReadonlyKeyword = F;
            function x(jr) {
              return jr.kind === 124;
            }
            e.isStaticModifier = x;
            function X(jr) {
              return jr.kind === 126;
            }
            e.isAbstractModifier = X;
            function $(jr) {
              return jr.kind === 106;
            }
            e.isSuperKeyword = $;
            function A(jr) {
              return jr.kind === 100;
            }
            e.isImportKeyword = A;
            function y(jr) {
              return jr.kind === 161;
            }
            e.isQualifiedName = y;
            function V(jr) {
              return jr.kind === 162;
            }
            e.isComputedPropertyName = V;
            function L(jr) {
              return jr.kind === 163;
            }
            e.isTypeParameterDeclaration = L;
            function P(jr) {
              return jr.kind === 164;
            }
            e.isParameter = P;
            function k(jr) {
              return jr.kind === 165;
            }
            e.isDecorator = k;
            function Y(jr) {
              return jr.kind === 166;
            }
            e.isPropertySignature = Y;
            function U(jr) {
              return jr.kind === 167;
            }
            e.isPropertyDeclaration = U;
            function j(jr) {
              return jr.kind === 168;
            }
            e.isMethodSignature = j;
            function H(jr) {
              return jr.kind === 169;
            }
            e.isMethodDeclaration = H;
            function I(jr) {
              return jr.kind === 170;
            }
            e.isClassStaticBlockDeclaration = I;
            function l(jr) {
              return jr.kind === 171;
            }
            e.isConstructorDeclaration = l;
            function d(jr) {
              return jr.kind === 172;
            }
            e.isGetAccessorDeclaration = d;
            function D(jr) {
              return jr.kind === 173;
            }
            e.isSetAccessorDeclaration = D;
            function fe(jr) {
              return jr.kind === 174;
            }
            e.isCallSignatureDeclaration = fe;
            function g(jr) {
              return jr.kind === 175;
            }
            e.isConstructSignatureDeclaration = g;
            function ne(jr) {
              return jr.kind === 176;
            }
            e.isIndexSignatureDeclaration = ne;
            function ue(jr) {
              return jr.kind === 177;
            }
            e.isTypePredicateNode = ue;
            function We(jr) {
              return jr.kind === 178;
            }
            e.isTypeReferenceNode = We;
            function Fe(jr) {
              return jr.kind === 179;
            }
            e.isFunctionTypeNode = Fe;
            function Z(jr) {
              return jr.kind === 180;
            }
            e.isConstructorTypeNode = Z;
            function Be(jr) {
              return jr.kind === 181;
            }
            e.isTypeQueryNode = Be;
            function ge(jr) {
              return jr.kind === 182;
            }
            e.isTypeLiteralNode = ge;
            function Re(jr) {
              return jr.kind === 183;
            }
            e.isArrayTypeNode = Re;
            function ze(jr) {
              return jr.kind === 184;
            }
            e.isTupleTypeNode = ze;
            function Ee(jr) {
              return jr.kind === 197;
            }
            e.isNamedTupleMember = Ee;
            function He(jr) {
              return jr.kind === 185;
            }
            e.isOptionalTypeNode = He;
            function rr(jr) {
              return jr.kind === 186;
            }
            e.isRestTypeNode = rr;
            function Ie(jr) {
              return jr.kind === 187;
            }
            e.isUnionTypeNode = Ie;
            function _e(jr) {
              return jr.kind === 188;
            }
            e.isIntersectionTypeNode = _e;
            function we(jr) {
              return jr.kind === 189;
            }
            e.isConditionalTypeNode = we;
            function de(jr) {
              return jr.kind === 190;
            }
            e.isInferTypeNode = de;
            function ye(jr) {
              return jr.kind === 191;
            }
            e.isParenthesizedTypeNode = ye;
            function Ae(jr) {
              return jr.kind === 192;
            }
            e.isThisTypeNode = Ae;
            function er(jr) {
              return jr.kind === 193;
            }
            e.isTypeOperatorNode = er;
            function ir(jr) {
              return jr.kind === 194;
            }
            e.isIndexedAccessTypeNode = ir;
            function Cr(jr) {
              return jr.kind === 195;
            }
            e.isMappedTypeNode = Cr;
            function Ye(jr) {
              return jr.kind === 196;
            }
            e.isLiteralTypeNode = Ye;
            function Br(jr) {
              return jr.kind === 200;
            }
            e.isImportTypeNode = Br;
            function Er(jr) {
              return jr.kind === 199;
            }
            e.isTemplateLiteralTypeSpan = Er;
            function Ne(jr) {
              return jr.kind === 198;
            }
            e.isTemplateLiteralTypeNode = Ne;
            function n(jr) {
              return jr.kind === 201;
            }
            e.isObjectBindingPattern = n;
            function lr(jr) {
              return jr.kind === 202;
            }
            e.isArrayBindingPattern = lr;
            function be(jr) {
              return jr.kind === 203;
            }
            e.isBindingElement = be;
            function Ge(jr) {
              return jr.kind === 204;
            }
            e.isArrayLiteralExpression = Ge;
            function ur(jr) {
              return jr.kind === 205;
            }
            e.isObjectLiteralExpression = ur;
            function yr(jr) {
              return jr.kind === 206;
            }
            e.isPropertyAccessExpression = yr;
            function Ir(jr) {
              return jr.kind === 207;
            }
            e.isElementAccessExpression = Ir;
            function wr(jr) {
              return jr.kind === 208;
            }
            e.isCallExpression = wr;
            function Ur(jr) {
              return jr.kind === 209;
            }
            e.isNewExpression = Ur;
            function ii(jr) {
              return jr.kind === 210;
            }
            e.isTaggedTemplateExpression = ii;
            function mi(jr) {
              return jr.kind === 211;
            }
            e.isTypeAssertionExpression = mi;
            function pe(jr) {
              return jr.kind === 212;
            }
            e.isParenthesizedExpression = pe;
            function or(jr) {
              return jr.kind === 213;
            }
            e.isFunctionExpression = or;
            function qr(jr) {
              return jr.kind === 214;
            }
            e.isArrowFunction = qr;
            function si(jr) {
              return jr.kind === 215;
            }
            e.isDeleteExpression = si;
            function Di(jr) {
              return jr.kind === 216;
            }
            e.isTypeOfExpression = Di;
            function wi(jr) {
              return jr.kind === 217;
            }
            e.isVoidExpression = wi;
            function Xi(jr) {
              return jr.kind === 218;
            }
            e.isAwaitExpression = Xi;
            function et(jr) {
              return jr.kind === 219;
            }
            e.isPrefixUnaryExpression = et;
            function Gi(jr) {
              return jr.kind === 220;
            }
            e.isPostfixUnaryExpression = Gi;
            function Wt(jr) {
              return jr.kind === 221;
            }
            e.isBinaryExpression = Wt;
            function Zt(jr) {
              return jr.kind === 222;
            }
            e.isConditionalExpression = Zt;
            function _r(jr) {
              return jr.kind === 223;
            }
            e.isTemplateExpression = _r;
            function pi(jr) {
              return jr.kind === 224;
            }
            e.isYieldExpression = pi;
            function ae(jr) {
              return jr.kind === 225;
            }
            e.isSpreadElement = ae;
            function Xe(jr) {
              return jr.kind === 226;
            }
            e.isClassExpression = Xe;
            function Jr(jr) {
              return jr.kind === 227;
            }
            e.isOmittedExpression = Jr;
            function ti(jr) {
              return jr.kind === 228;
            }
            e.isExpressionWithTypeArguments = ti;
            function Ze(jr) {
              return jr.kind === 229;
            }
            e.isAsExpression = Ze;
            function Sr(jr) {
              return jr.kind === 230;
            }
            e.isNonNullExpression = Sr;
            function zr(jr) {
              return jr.kind === 231;
            }
            e.isMetaProperty = zr;
            function Wr(jr) {
              return jr.kind === 232;
            }
            e.isSyntheticExpression = Wr;
            function Je(jr) {
              return jr.kind === 350;
            }
            e.isPartiallyEmittedExpression = Je;
            function xe(jr) {
              return jr.kind === 351;
            }
            e.isCommaListExpression = xe;
            function vr(jr) {
              return jr.kind === 233;
            }
            e.isTemplateSpan = vr;
            function mr(jr) {
              return jr.kind === 234;
            }
            e.isSemicolonClassElement = mr;
            function Ar(jr) {
              return jr.kind === 235;
            }
            e.isBlock = Ar;
            function Oe(jr) {
              return jr.kind === 237;
            }
            e.isVariableStatement = Oe;
            function nr(jr) {
              return jr.kind === 236;
            }
            e.isEmptyStatement = nr;
            function Mr(jr) {
              return jr.kind === 238;
            }
            e.isExpressionStatement = Mr;
            function Pe(jr) {
              return jr.kind === 239;
            }
            e.isIfStatement = Pe;
            function Ue(jr) {
              return jr.kind === 240;
            }
            e.isDoStatement = Ue;
            function fr(jr) {
              return jr.kind === 241;
            }
            e.isWhileStatement = fr;
            function De(jr) {
              return jr.kind === 242;
            }
            e.isForStatement = De;
            function gr(jr) {
              return jr.kind === 243;
            }
            e.isForInStatement = gr;
            function Vr(jr) {
              return jr.kind === 244;
            }
            e.isForOfStatement = Vr;
            function Tr(jr) {
              return jr.kind === 245;
            }
            e.isContinueStatement = Tr;
            function vi(jr) {
              return jr.kind === 246;
            }
            e.isBreakStatement = vi;
            function Ui(jr) {
              return jr.kind === 247;
            }
            e.isReturnStatement = Ui;
            function Yi(jr) {
              return jr.kind === 248;
            }
            e.isWithStatement = Yi;
            function Wi(jr) {
              return jr.kind === 249;
            }
            e.isSwitchStatement = Wi;
            function ct(jr) {
              return jr.kind === 250;
            }
            e.isLabeledStatement = ct;
            function Li(jr) {
              return jr.kind === 251;
            }
            e.isThrowStatement = Li;
            function nt(jr) {
              return jr.kind === 252;
            }
            e.isTryStatement = nt;
            function Mt(jr) {
              return jr.kind === 253;
            }
            e.isDebuggerStatement = Mt;
            function xt(jr) {
              return jr.kind === 254;
            }
            e.isVariableDeclaration = xt;
            function ut(jr) {
              return jr.kind === 255;
            }
            e.isVariableDeclarationList = ut;
            function Dt(jr) {
              return jr.kind === 256;
            }
            e.isFunctionDeclaration = Dt;
            function Rt(jr) {
              return jr.kind === 257;
            }
            e.isClassDeclaration = Rt;
            function Ii(jr) {
              return jr.kind === 258;
            }
            e.isInterfaceDeclaration = Ii;
            function Ki(jr) {
              return jr.kind === 259;
            }
            e.isTypeAliasDeclaration = Ki;
            function Fi(jr) {
              return jr.kind === 260;
            }
            e.isEnumDeclaration = Fi;
            function ui(jr) {
              return jr.kind === 261;
            }
            e.isModuleDeclaration = ui;
            function Bt(jr) {
              return jr.kind === 262;
            }
            e.isModuleBlock = Bt;
            function wt(jr) {
              return jr.kind === 263;
            }
            e.isCaseBlock = wt;
            function na(jr) {
              return jr.kind === 264;
            }
            e.isNamespaceExportDeclaration = na;
            function Ai(jr) {
              return jr.kind === 265;
            }
            e.isImportEqualsDeclaration = Ai;
            function Oi(jr) {
              return jr.kind === 266;
            }
            e.isImportDeclaration = Oi;
            function ji(jr) {
              return jr.kind === 267;
            }
            e.isImportClause = ji;
            function Vi(jr) {
              return jr.kind === 293;
            }
            e.isAssertClause = Vi;
            function at(jr) {
              return jr.kind === 294;
            }
            e.isAssertEntry = at;
            function At(jr) {
              return jr.kind === 268;
            }
            e.isNamespaceImport = At;
            function ba(jr) {
              return jr.kind === 274;
            }
            e.isNamespaceExport = ba;
            function $a(jr) {
              return jr.kind === 269;
            }
            e.isNamedImports = $a;
            function Qa(jr) {
              return jr.kind === 270;
            }
            e.isImportSpecifier = Qa;
            function ai(jr) {
              return jr.kind === 271;
            }
            e.isExportAssignment = ai;
            function Dn(jr) {
              return jr.kind === 272;
            }
            e.isExportDeclaration = Dn;
            function ka(jr) {
              return jr.kind === 273;
            }
            e.isNamedExports = ka;
            function Ba(jr) {
              return jr.kind === 275;
            }
            e.isExportSpecifier = Ba;
            function pn(jr) {
              return jr.kind === 276;
            }
            e.isMissingDeclaration = pn;
            function Cn(jr) {
              return jr.kind === 349;
            }
            e.isNotEmittedStatement = Cn;
            function Bi(jr) {
              return jr.kind === 354;
            }
            e.isSyntheticReference = Bi;
            function kn(jr) {
              return jr.kind === 352;
            }
            e.isMergeDeclarationMarker = kn;
            function xn(jr) {
              return jr.kind === 353;
            }
            e.isEndOfDeclarationMarker = xn;
            function Kn(jr) {
              return jr.kind === 277;
            }
            e.isExternalModuleReference = Kn;
            function Pn(jr) {
              return jr.kind === 278;
            }
            e.isJsxElement = Pn;
            function eo(jr) {
              return jr.kind === 279;
            }
            e.isJsxSelfClosingElement = eo;
            function Rn(jr) {
              return jr.kind === 280;
            }
            e.isJsxOpeningElement = Rn;
            function Da(jr) {
              return jr.kind === 281;
            }
            e.isJsxClosingElement = Da;
            function bo(jr) {
              return jr.kind === 282;
            }
            e.isJsxFragment = bo;
            function Ro(jr) {
              return jr.kind === 283;
            }
            e.isJsxOpeningFragment = Ro;
            function En(jr) {
              return jr.kind === 284;
            }
            e.isJsxClosingFragment = En;
            function Wn(jr) {
              return jr.kind === 285;
            }
            e.isJsxAttribute = Wn;
            function to(jr) {
              return jr.kind === 286;
            }
            e.isJsxAttributes = to;
            function Co(jr) {
              return jr.kind === 287;
            }
            e.isJsxSpreadAttribute = Co;
            function Ko(jr) {
              return jr.kind === 288;
            }
            e.isJsxExpression = Ko;
            function Oo(jr) {
              return jr.kind === 289;
            }
            e.isCaseClause = Oo;
            function no(jr) {
              return jr.kind === 290;
            }
            e.isDefaultClause = no;
            function $o(jr) {
              return jr.kind === 291;
            }
            e.isHeritageClause = $o;
            function Pr(jr) {
              return jr.kind === 292;
            }
            e.isCatchClause = Pr;
            function xi(jr) {
              return jr.kind === 296;
            }
            e.isPropertyAssignment = xi;
            function St(jr) {
              return jr.kind === 297;
            }
            e.isShorthandPropertyAssignment = St;
            function pa(jr) {
              return jr.kind === 298;
            }
            e.isSpreadAssignment = pa;
            function dn(jr) {
              return jr.kind === 299;
            }
            e.isEnumMember = dn;
            function Jn(jr) {
              return jr.kind === 301;
            }
            e.isUnparsedPrepend = Jn;
            function Qe(jr) {
              return jr.kind === 305;
            }
            e.isSourceFile = Qe;
            function Gr(jr) {
              return jr.kind === 306;
            }
            e.isBundle = Gr;
            function S(jr) {
              return jr.kind === 307;
            }
            e.isUnparsedSource = S;
            function Ce(jr) {
              return jr.kind === 309;
            }
            e.isJSDocTypeExpression = Ce;
            function qe(jr) {
              return jr.kind === 310;
            }
            e.isJSDocNameReference = qe;
            function br(jr) {
              return jr.kind === 311;
            }
            e.isJSDocMemberName = br;
            function Zr(jr) {
              return jr.kind === 324;
            }
            e.isJSDocLink = Zr;
            function Si(jr) {
              return jr.kind === 325;
            }
            e.isJSDocLinkCode = Si;
            function Pi(jr) {
              return jr.kind === 326;
            }
            e.isJSDocLinkPlain = Pi;
            function Qi(jr) {
              return jr.kind === 312;
            }
            e.isJSDocAllType = Qi;
            function Ct(jr) {
              return jr.kind === 313;
            }
            e.isJSDocUnknownType = Ct;
            function sa(jr) {
              return jr.kind === 314;
            }
            e.isJSDocNullableType = sa;
            function en(jr) {
              return jr.kind === 315;
            }
            e.isJSDocNonNullableType = en;
            function Wa(jr) {
              return jr.kind === 316;
            }
            e.isJSDocOptionalType = Wa;
            function qn(jr) {
              return jr.kind === 317;
            }
            e.isJSDocFunctionType = qn;
            function mo(jr) {
              return jr.kind === 318;
            }
            e.isJSDocVariadicType = mo;
            function So(jr) {
              return jr.kind === 319;
            }
            e.isJSDocNamepathType = So;
            function Go(jr) {
              return jr.kind === 320;
            }
            e.isJSDoc = Go;
            function ys(jr) {
              return jr.kind === 322;
            }
            e.isJSDocTypeLiteral = ys;
            function Pc(jr) {
              return jr.kind === 323;
            }
            e.isJSDocSignature = Pc;
            function Vc(jr) {
              return jr.kind === 328;
            }
            e.isJSDocAugmentsTag = Vc;
            function Kc(jr) {
              return jr.kind === 330;
            }
            e.isJSDocAuthorTag = Kc;
            function Xs(jr) {
              return jr.kind === 332;
            }
            e.isJSDocClassTag = Xs;
            function pc(jr) {
              return jr.kind === 338;
            }
            e.isJSDocCallbackTag = pc;
            function hs(jr) {
              return jr.kind === 333;
            }
            e.isJSDocPublicTag = hs;
            function tc(jr) {
              return jr.kind === 334;
            }
            e.isJSDocPrivateTag = tc;
            function ps(jr) {
              return jr.kind === 335;
            }
            e.isJSDocProtectedTag = ps;
            function Qs(jr) {
              return jr.kind === 336;
            }
            e.isJSDocReadonlyTag = Qs;
            function js(jr) {
              return jr.kind === 337;
            }
            e.isJSDocOverrideTag = js;
            function ds(jr) {
              return jr.kind === 331;
            }
            e.isJSDocDeprecatedTag = ds;
            function Ji(jr) {
              return jr.kind === 346;
            }
            e.isJSDocSeeTag = Ji;
            function ce(jr) {
              return jr.kind === 339;
            }
            e.isJSDocEnumTag = ce;
            function Rr(jr) {
              return jr.kind === 340;
            }
            e.isJSDocParameterTag = Rr;
            function yi(jr) {
              return jr.kind === 341;
            }
            e.isJSDocReturnTag = yi;
            function qi(jr) {
              return jr.kind === 342;
            }
            e.isJSDocThisTag = qi;
            function je(jr) {
              return jr.kind === 343;
            }
            e.isJSDocTypeTag = je;
            function Hr(jr) {
              return jr.kind === 344;
            }
            e.isJSDocTemplateTag = Hr;
            function pt(jr) {
              return jr.kind === 345;
            }
            e.isJSDocTypedefTag = pt;
            function Pt(jr) {
              return jr.kind === 327;
            }
            e.isJSDocUnknownTag = Pt;
            function ga(jr) {
              return jr.kind === 347;
            }
            e.isJSDocPropertyTag = ga;
            function ua(jr) {
              return jr.kind === 329;
            }
            e.isJSDocImplementsTag = ua;
            function Xn(jr) {
              return jr.kind === 348;
            }
            e.isSyntaxList = Xn;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(lr) {
              return lr.createExportDeclaration(void 0, void 0, false, lr.createNamedExports([]), void 0);
            }
            e.createEmptyExports = a;
            function C(lr, be, Ge, ur) {
              if (e.isComputedPropertyName(Ge)) return e.setTextRange(lr.createElementAccessExpression(be, Ge.expression), ur);
              var yr = e.setTextRange(e.isMemberName(Ge) ? lr.createPropertyAccessExpression(be, Ge) : lr.createElementAccessExpression(be, Ge), Ge);
              return e.getOrCreateEmitNode(yr).flags |= 64, yr;
            }
            e.createMemberAccessForPropertyName = C;
            function w(lr, be) {
              var Ge = e.parseNodeFactory.createIdentifier(lr || "React");
              return e.setParent(Ge, e.getParseTreeNode(be)), Ge;
            }
            function B(lr, be, Ge) {
              if (e.isQualifiedName(be)) {
                var ur = B(lr, be.left, Ge), yr = lr.createIdentifier(e.idText(be.right));
                return yr.escapedText = be.right.escapedText, lr.createPropertyAccessExpression(ur, yr);
              } else return w(e.idText(be), Ge);
            }
            function E(lr, be, Ge, ur) {
              return be ? B(lr, be, ur) : lr.createPropertyAccessExpression(w(Ge, ur), "createElement");
            }
            e.createJsxFactoryExpression = E;
            function Q(lr, be, Ge, ur) {
              return be ? B(lr, be, ur) : lr.createPropertyAccessExpression(w(Ge, ur), "Fragment");
            }
            function le(lr, be, Ge, ur, yr, Ir) {
              var wr = [Ge];
              if (ur && wr.push(ur), yr && yr.length > 0) if (ur || wr.push(lr.createNull()), yr.length > 1) for (var Ur = 0, ii = yr; Ur < ii.length; Ur++) {
                var mi = ii[Ur];
                y(mi), wr.push(mi);
              }
              else wr.push(yr[0]);
              return e.setTextRange(lr.createCallExpression(be, void 0, wr), Ir);
            }
            e.createExpressionForJsxElement = le;
            function N(lr, be, Ge, ur, yr, Ir, wr) {
              var Ur = Q(lr, Ge, ur, Ir), ii = [Ur, lr.createNull()];
              if (yr && yr.length > 0) if (yr.length > 1) for (var mi = 0, pe = yr; mi < pe.length; mi++) {
                var or = pe[mi];
                y(or), ii.push(or);
              }
              else ii.push(yr[0]);
              return e.setTextRange(lr.createCallExpression(E(lr, be, ur, Ir), void 0, ii), wr);
            }
            e.createExpressionForJsxFragment = N;
            function p(lr, be, Ge) {
              if (e.isVariableDeclarationList(be)) {
                var ur = e.first(be.declarations), yr = lr.updateVariableDeclaration(ur, ur.name, void 0, void 0, Ge);
                return e.setTextRange(lr.createVariableStatement(void 0, lr.updateVariableDeclarationList(be, [yr])), be);
              } else {
                var Ir = e.setTextRange(lr.createAssignment(be, Ge), be);
                return e.setTextRange(lr.createExpressionStatement(Ir), be);
              }
            }
            e.createForOfBindingStatement = p;
            function m(lr, be, Ge) {
              return e.isBlock(be) ? lr.updateBlock(be, e.setTextRange(lr.createNodeArray(Ve([Ge], be.statements, true)), be.statements)) : lr.createBlock(lr.createNodeArray([be, Ge]), true);
            }
            e.insertLeadingStatement = m;
            function G(lr, be) {
              if (e.isQualifiedName(be)) {
                var Ge = G(lr, be.left), ur = e.setParent(e.setTextRange(lr.cloneNode(be.right), be.right), be.right.parent);
                return e.setTextRange(lr.createPropertyAccessExpression(Ge, ur), be);
              } else return e.setParent(e.setTextRange(lr.cloneNode(be), be), be.parent);
            }
            e.createExpressionFromEntityName = G;
            function oe(lr, be) {
              return e.isIdentifier(be) ? lr.createStringLiteralFromNode(be) : e.isComputedPropertyName(be) ? e.setParent(e.setTextRange(lr.cloneNode(be.expression), be.expression), be.expression.parent) : e.setParent(e.setTextRange(lr.cloneNode(be), be), be.parent);
            }
            e.createExpressionForPropertyName = oe;
            function f(lr, be, Ge, ur, yr) {
              var Ir = e.getAllAccessorDeclarations(be, Ge), wr = Ir.firstAccessor, Ur = Ir.getAccessor, ii = Ir.setAccessor;
              if (Ge === wr) return e.setTextRange(lr.createObjectDefinePropertyCall(ur, oe(lr, Ge.name), lr.createPropertyDescriptor({ enumerable: lr.createFalse(), configurable: true, get: Ur && e.setTextRange(e.setOriginalNode(lr.createFunctionExpression(Ur.modifiers, void 0, void 0, void 0, Ur.parameters, void 0, Ur.body), Ur), Ur), set: ii && e.setTextRange(e.setOriginalNode(lr.createFunctionExpression(ii.modifiers, void 0, void 0, void 0, ii.parameters, void 0, ii.body), ii), ii) }, !yr)), wr);
            }
            function T(lr, be, Ge) {
              return e.setOriginalNode(e.setTextRange(lr.createAssignment(C(lr, Ge, be.name, be.name), be.initializer), be), be);
            }
            function K(lr, be, Ge) {
              return e.setOriginalNode(e.setTextRange(lr.createAssignment(C(lr, Ge, be.name, be.name), lr.cloneNode(be.name)), be), be);
            }
            function b(lr, be, Ge) {
              return e.setOriginalNode(e.setTextRange(lr.createAssignment(C(lr, Ge, be.name, be.name), e.setOriginalNode(e.setTextRange(lr.createFunctionExpression(be.modifiers, be.asteriskToken, void 0, void 0, be.parameters, void 0, be.body), be), be)), be), be);
            }
            function se(lr, be, Ge, ur) {
              switch (Ge.name && e.isPrivateIdentifier(Ge.name) && e.Debug.failBadSyntaxKind(Ge.name, "Private identifiers are not allowed in object literals."), Ge.kind) {
                case 172:
                case 173:
                  return f(lr, be.properties, Ge, ur, !!be.multiLine);
                case 296:
                  return T(lr, Ge, ur);
                case 297:
                  return K(lr, Ge, ur);
                case 169:
                  return b(lr, Ge, ur);
              }
            }
            e.createExpressionForObjectLiteralElementLike = se;
            function J(lr, be, Ge, ur, yr) {
              var Ir = be.operator;
              e.Debug.assert(Ir === 45 || Ir === 46, "Expected 'node' to be a pre- or post-increment or pre- or post-decrement expression");
              var wr = lr.createTempVariable(ur);
              Ge = lr.createAssignment(wr, Ge), e.setTextRange(Ge, be.operand);
              var Ur = e.isPrefixUnaryExpression(be) ? lr.createPrefixUnaryExpression(Ir, wr) : lr.createPostfixUnaryExpression(wr, Ir);
              return e.setTextRange(Ur, be), yr && (Ur = lr.createAssignment(yr, Ur), e.setTextRange(Ur, be)), Ge = lr.createComma(Ge, Ur), e.setTextRange(Ge, be), e.isPostfixUnaryExpression(be) && (Ge = lr.createComma(Ge, wr), e.setTextRange(Ge, be)), Ge;
            }
            e.expandPreOrPostfixIncrementOrDecrementExpression = J;
            function ie(lr) {
              return (e.getEmitFlags(lr) & 32768) !== 0;
            }
            e.isInternalName = ie;
            function R(lr) {
              return (e.getEmitFlags(lr) & 16384) !== 0;
            }
            e.isLocalName = R;
            function q(lr) {
              return (e.getEmitFlags(lr) & 8192) !== 0;
            }
            e.isExportName = q;
            function O(lr) {
              return e.isStringLiteral(lr.expression) && lr.expression.text === "use strict";
            }
            function ve(lr) {
              for (var be = 0, Ge = lr; be < Ge.length; be++) {
                var ur = Ge[be];
                if (e.isPrologueDirective(ur)) {
                  if (O(ur)) return ur;
                } else break;
              }
            }
            e.findUseStrictPrologue = ve;
            function ee(lr) {
              var be = e.firstOrUndefined(lr);
              return be !== void 0 && e.isPrologueDirective(be) && O(be);
            }
            e.startsWithUseStrict = ee;
            function he(lr) {
              return lr.kind === 221 && lr.operatorToken.kind === 27 || lr.kind === 351;
            }
            e.isCommaSequence = he;
            function F(lr) {
              return e.isParenthesizedExpression(lr) && e.isInJSFile(lr) && !!e.getJSDocTypeTag(lr);
            }
            e.isJSDocTypeAssertion = F;
            function x(lr) {
              var be = e.getJSDocType(lr);
              return e.Debug.assertIsDefined(be), be;
            }
            e.getJSDocTypeAssertionType = x;
            function X(lr, be) {
              switch (be === void 0 && (be = 15), lr.kind) {
                case 212:
                  return be & 16 && F(lr) ? false : (be & 1) !== 0;
                case 211:
                case 229:
                  return (be & 2) !== 0;
                case 230:
                  return (be & 4) !== 0;
                case 350:
                  return (be & 8) !== 0;
              }
              return false;
            }
            e.isOuterExpression = X;
            function $(lr, be) {
              for (be === void 0 && (be = 15); X(lr, be); ) lr = lr.expression;
              return lr;
            }
            e.skipOuterExpressions = $;
            function A(lr) {
              return $(lr, 6);
            }
            e.skipAssertions = A;
            function y(lr) {
              return e.setStartsOnNewLine(lr, true);
            }
            e.startOnNewLine = y;
            function V(lr) {
              var be = e.getOriginalNode(lr, e.isSourceFile), Ge = be && be.emitNode;
              return Ge && Ge.externalHelpersModuleName;
            }
            e.getExternalHelpersModuleName = V;
            function L(lr) {
              var be = e.getOriginalNode(lr, e.isSourceFile), Ge = be && be.emitNode;
              return !!Ge && (!!Ge.externalHelpersModuleName || !!Ge.externalHelpers);
            }
            e.hasRecordedExternalHelpers = L;
            function P(lr, be, Ge, ur, yr, Ir, wr) {
              if (ur.importHelpers && e.isEffectiveExternalModule(Ge, ur)) {
                var Ur = void 0, ii = e.getEmitModuleKind(ur);
                if (ii >= e.ModuleKind.ES2015 && ii <= e.ModuleKind.ESNext || Ge.impliedNodeFormat === e.ModuleKind.ESNext) {
                  var mi = e.getEmitHelpers(Ge);
                  if (mi) {
                    for (var pe = [], or = 0, qr = mi; or < qr.length; or++) {
                      var si = qr[or];
                      if (!si.scoped) {
                        var Di = si.importName;
                        Di && e.pushIfUnique(pe, Di);
                      }
                    }
                    if (e.some(pe)) {
                      pe.sort(e.compareStringsCaseSensitive), Ur = lr.createNamedImports(e.map(pe, function(Wt) {
                        return e.isFileLevelUniqueName(Ge, Wt) ? lr.createImportSpecifier(false, void 0, lr.createIdentifier(Wt)) : lr.createImportSpecifier(false, lr.createIdentifier(Wt), be.getUnscopedHelperName(Wt));
                      }));
                      var wi = e.getOriginalNode(Ge, e.isSourceFile), Xi = e.getOrCreateEmitNode(wi);
                      Xi.externalHelpers = true;
                    }
                  }
                } else {
                  var et = k(lr, Ge, ur, yr, Ir || wr);
                  et && (Ur = lr.createNamespaceImport(et));
                }
                if (Ur) {
                  var Gi = lr.createImportDeclaration(void 0, void 0, lr.createImportClause(false, void 0, Ur), lr.createStringLiteral(e.externalHelpersModuleNameText), void 0);
                  return e.addEmitFlags(Gi, 67108864), Gi;
                }
              }
            }
            e.createExternalHelpersImportDeclarationIfNeeded = P;
            function k(lr, be, Ge, ur, yr) {
              if (Ge.importHelpers && e.isEffectiveExternalModule(be, Ge)) {
                var Ir = V(be);
                if (Ir) return Ir;
                var wr = e.getEmitModuleKind(Ge), Ur = (ur || e.getESModuleInterop(Ge) && yr) && wr !== e.ModuleKind.System && (wr < e.ModuleKind.ES2015 || be.impliedNodeFormat === e.ModuleKind.CommonJS);
                if (!Ur) {
                  var ii = e.getEmitHelpers(be);
                  if (ii) for (var mi = 0, pe = ii; mi < pe.length; mi++) {
                    var or = pe[mi];
                    if (!or.scoped) {
                      Ur = true;
                      break;
                    }
                  }
                }
                if (Ur) {
                  var qr = e.getOriginalNode(be, e.isSourceFile), si = e.getOrCreateEmitNode(qr);
                  return si.externalHelpersModuleName || (si.externalHelpersModuleName = lr.createUniqueName(e.externalHelpersModuleNameText));
                }
              }
            }
            e.getOrCreateExternalHelpersModuleNameIfNeeded = k;
            function Y(lr, be, Ge) {
              var ur = e.getNamespaceDeclarationNode(be);
              if (ur && !e.isDefaultImport(be) && !e.isExportNamespaceAsDefaultDeclaration(be)) {
                var yr = ur.name;
                return e.isGeneratedIdentifier(yr) ? yr : lr.createIdentifier(e.getSourceTextOfNodeFromSourceFile(Ge, yr) || e.idText(yr));
              }
              if (be.kind === 266 && be.importClause || be.kind === 272 && be.moduleSpecifier) return lr.getGeneratedNameForNode(be);
            }
            e.getLocalNameForExternalImport = Y;
            function U(lr, be, Ge, ur, yr, Ir) {
              var wr = e.getExternalModuleName(be);
              if (wr && e.isStringLiteral(wr)) return I(be, ur, lr, yr, Ir) || j(lr, wr, Ge) || lr.cloneNode(wr);
            }
            e.getExternalModuleNameLiteral = U;
            function j(lr, be, Ge) {
              var ur = Ge.renamedDependencies && Ge.renamedDependencies.get(be.text);
              return ur ? lr.createStringLiteral(ur) : void 0;
            }
            function H(lr, be, Ge, ur) {
              if (!!be) {
                if (be.moduleName) return lr.createStringLiteral(be.moduleName);
                if (!be.isDeclarationFile && e.outFile(ur)) return lr.createStringLiteral(e.getExternalModuleNameFromPath(Ge, be.fileName));
              }
            }
            e.tryGetModuleNameFromFile = H;
            function I(lr, be, Ge, ur, yr) {
              return H(Ge, ur.getExternalModuleFileFromDeclaration(lr), be, yr);
            }
            function l(lr) {
              if (e.isDeclarationBindingElement(lr)) return lr.initializer;
              if (e.isPropertyAssignment(lr)) {
                var be = lr.initializer;
                return e.isAssignmentExpression(be, true) ? be.right : void 0;
              }
              if (e.isShorthandPropertyAssignment(lr)) return lr.objectAssignmentInitializer;
              if (e.isAssignmentExpression(lr, true)) return lr.right;
              if (e.isSpreadElement(lr)) return l(lr.expression);
            }
            e.getInitializerOfBindingOrAssignmentElement = l;
            function d(lr) {
              if (e.isDeclarationBindingElement(lr)) return lr.name;
              if (e.isObjectLiteralElementLike(lr)) {
                switch (lr.kind) {
                  case 296:
                    return d(lr.initializer);
                  case 297:
                    return lr.name;
                  case 298:
                    return d(lr.expression);
                }
                return;
              }
              return e.isAssignmentExpression(lr, true) ? d(lr.left) : e.isSpreadElement(lr) ? d(lr.expression) : lr;
            }
            e.getTargetOfBindingOrAssignmentElement = d;
            function D(lr) {
              switch (lr.kind) {
                case 164:
                case 203:
                  return lr.dotDotDotToken;
                case 225:
                case 298:
                  return lr;
              }
            }
            e.getRestIndicatorOfBindingOrAssignmentElement = D;
            function fe(lr) {
              var be = g(lr);
              return e.Debug.assert(!!be || e.isSpreadAssignment(lr), "Invalid property name for binding element."), be;
            }
            e.getPropertyNameOfBindingOrAssignmentElement = fe;
            function g(lr) {
              switch (lr.kind) {
                case 203:
                  if (lr.propertyName) {
                    var be = lr.propertyName;
                    return e.isPrivateIdentifier(be) ? e.Debug.failBadSyntaxKind(be) : e.isComputedPropertyName(be) && ne(be.expression) ? be.expression : be;
                  }
                  break;
                case 296:
                  if (lr.name) {
                    var be = lr.name;
                    return e.isPrivateIdentifier(be) ? e.Debug.failBadSyntaxKind(be) : e.isComputedPropertyName(be) && ne(be.expression) ? be.expression : be;
                  }
                  break;
                case 298:
                  return lr.name && e.isPrivateIdentifier(lr.name) ? e.Debug.failBadSyntaxKind(lr.name) : lr.name;
              }
              var Ge = d(lr);
              if (Ge && e.isPropertyName(Ge)) return Ge;
            }
            e.tryGetPropertyNameOfBindingOrAssignmentElement = g;
            function ne(lr) {
              var be = lr.kind;
              return be === 10 || be === 8;
            }
            function ue(lr) {
              switch (lr.kind) {
                case 201:
                case 202:
                case 204:
                  return lr.elements;
                case 205:
                  return lr.properties;
              }
            }
            e.getElementsOfBindingOrAssignmentPattern = ue;
            function We(lr) {
              if (lr) for (var be = lr; ; ) {
                if (e.isIdentifier(be) || !be.body) return e.isIdentifier(be) ? be : be.name;
                be = be.body;
              }
            }
            e.getJSDocTypeAliasName = We;
            function Fe(lr) {
              var be = lr.kind;
              return be === 164 || be === 166 || be === 167 || be === 168 || be === 169 || be === 171 || be === 172 || be === 173 || be === 176 || be === 213 || be === 214 || be === 226 || be === 237 || be === 256 || be === 257 || be === 258 || be === 259 || be === 260 || be === 261 || be === 265 || be === 266 || be === 271 || be === 272;
            }
            e.canHaveModifiers = Fe, e.isTypeNodeOrTypeParameterDeclaration = e.or(e.isTypeNode, e.isTypeParameterDeclaration), e.isQuestionOrExclamationToken = e.or(e.isQuestionToken, e.isExclamationToken), e.isIdentifierOrThisTypeNode = e.or(e.isIdentifier, e.isThisTypeNode), e.isReadonlyKeywordOrPlusOrMinusToken = e.or(e.isReadonlyKeyword, e.isPlusToken, e.isMinusToken), e.isQuestionOrPlusOrMinusToken = e.or(e.isQuestionToken, e.isPlusToken, e.isMinusToken), e.isModuleName = e.or(e.isIdentifier, e.isStringLiteral);
            function Z(lr) {
              var be = lr.kind;
              return be === 104 || be === 110 || be === 95 || e.isLiteralExpression(lr) || e.isPrefixUnaryExpression(lr);
            }
            e.isLiteralTypeLikeExpression = Z;
            function Be(lr) {
              return lr === 42;
            }
            function ge(lr) {
              return lr === 41 || lr === 43 || lr === 44;
            }
            function Re(lr) {
              return Be(lr) || ge(lr);
            }
            function ze(lr) {
              return lr === 39 || lr === 40;
            }
            function Ee(lr) {
              return ze(lr) || Re(lr);
            }
            function He(lr) {
              return lr === 47 || lr === 48 || lr === 49;
            }
            function rr(lr) {
              return He(lr) || Ee(lr);
            }
            function Ie(lr) {
              return lr === 29 || lr === 32 || lr === 31 || lr === 33 || lr === 102 || lr === 101;
            }
            function _e(lr) {
              return Ie(lr) || rr(lr);
            }
            function we(lr) {
              return lr === 34 || lr === 36 || lr === 35 || lr === 37;
            }
            function de(lr) {
              return we(lr) || _e(lr);
            }
            function ye(lr) {
              return lr === 50 || lr === 51 || lr === 52;
            }
            function Ae(lr) {
              return ye(lr) || de(lr);
            }
            function er(lr) {
              return lr === 55 || lr === 56;
            }
            function ir(lr) {
              return er(lr) || Ae(lr);
            }
            function Cr(lr) {
              return lr === 60 || ir(lr) || e.isAssignmentOperator(lr);
            }
            function Ye(lr) {
              return Cr(lr) || lr === 27;
            }
            function Br(lr) {
              return Ye(lr.kind);
            }
            e.isBinaryOperatorToken = Br;
            var Er;
            (function(lr) {
              function be(pe, or, qr, si, Di, wi, Xi) {
                var et = or > 0 ? Di[or - 1] : void 0;
                return e.Debug.assertEqual(qr[or], be), Di[or] = pe.onEnter(si[or], et, Xi), qr[or] = Ur(pe, be), or;
              }
              lr.enter = be;
              function Ge(pe, or, qr, si, Di, wi, Xi) {
                e.Debug.assertEqual(qr[or], Ge), e.Debug.assertIsDefined(pe.onLeft), qr[or] = Ur(pe, Ge);
                var et = pe.onLeft(si[or].left, Di[or], si[or]);
                return et ? (mi(or, si, et), ii(or, qr, si, Di, et)) : or;
              }
              lr.left = Ge;
              function ur(pe, or, qr, si, Di, wi, Xi) {
                return e.Debug.assertEqual(qr[or], ur), e.Debug.assertIsDefined(pe.onOperator), qr[or] = Ur(pe, ur), pe.onOperator(si[or].operatorToken, Di[or], si[or]), or;
              }
              lr.operator = ur;
              function yr(pe, or, qr, si, Di, wi, Xi) {
                e.Debug.assertEqual(qr[or], yr), e.Debug.assertIsDefined(pe.onRight), qr[or] = Ur(pe, yr);
                var et = pe.onRight(si[or].right, Di[or], si[or]);
                return et ? (mi(or, si, et), ii(or, qr, si, Di, et)) : or;
              }
              lr.right = yr;
              function Ir(pe, or, qr, si, Di, wi, Xi) {
                e.Debug.assertEqual(qr[or], Ir), qr[or] = Ur(pe, Ir);
                var et = pe.onExit(si[or], Di[or]);
                if (or > 0) {
                  if (or--, pe.foldState) {
                    var Gi = qr[or] === Ir ? "right" : "left";
                    Di[or] = pe.foldState(Di[or], et, Gi);
                  }
                } else wi.value = et;
                return or;
              }
              lr.exit = Ir;
              function wr(pe, or, qr, si, Di, wi, Xi) {
                return e.Debug.assertEqual(qr[or], wr), or;
              }
              lr.done = wr;
              function Ur(pe, or) {
                switch (or) {
                  case be:
                    if (pe.onLeft) return Ge;
                  case Ge:
                    if (pe.onOperator) return ur;
                  case ur:
                    if (pe.onRight) return yr;
                  case yr:
                    return Ir;
                  case Ir:
                    return wr;
                  case wr:
                    return wr;
                  default:
                    e.Debug.fail("Invalid state");
                }
              }
              lr.nextState = Ur;
              function ii(pe, or, qr, si, Di) {
                return pe++, or[pe] = be, qr[pe] = Di, si[pe] = void 0, pe;
              }
              function mi(pe, or, qr) {
                if (e.Debug.shouldAssert(2)) for (; pe >= 0; ) e.Debug.assert(or[pe] !== qr, "Circular traversal detected."), pe--;
              }
            })(Er || (Er = {}));
            var Ne = /* @__PURE__ */ function() {
              function lr(be, Ge, ur, yr, Ir, wr) {
                this.onEnter = be, this.onLeft = Ge, this.onOperator = ur, this.onRight = yr, this.onExit = Ir, this.foldState = wr;
              }
              return lr;
            }();
            function n(lr, be, Ge, ur, yr, Ir) {
              var wr = new Ne(lr, be, Ge, ur, yr, Ir);
              return Ur;
              function Ur(ii, mi) {
                for (var pe = { value: void 0 }, or = [Er.enter], qr = [ii], si = [void 0], Di = 0; or[Di] !== Er.done; ) Di = or[Di](wr, Di, or, qr, si, pe, mi);
                return e.Debug.assertEqual(Di, 0), pe.value;
              }
            }
            e.createBinaryExpressionTrampoline = n;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(C, w) {
              return w ? e.setTextRangePosEnd(C, w.pos, w.end) : C;
            }
            e.setTextRange = a;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(d) {
              d[d.None = 0] = "None", d[d.Yield = 1] = "Yield", d[d.Await = 2] = "Await", d[d.Type = 4] = "Type", d[d.IgnoreMissingOpenBrace = 16] = "IgnoreMissingOpenBrace", d[d.JSDoc = 32] = "JSDoc";
            })(a || (a = {}));
            var C;
            (function(d) {
              d[d.TryParse = 0] = "TryParse", d[d.Lookahead = 1] = "Lookahead", d[d.Reparse = 2] = "Reparse";
            })(C || (C = {}));
            var w, B, E, Q, le;
            e.parseBaseNodeFactory = { createBaseSourceFileNode: function(d) {
              return new (le || (le = e.objectAllocator.getSourceFileConstructor()))(d, -1, -1);
            }, createBaseIdentifierNode: function(d) {
              return new (E || (E = e.objectAllocator.getIdentifierConstructor()))(d, -1, -1);
            }, createBasePrivateIdentifierNode: function(d) {
              return new (Q || (Q = e.objectAllocator.getPrivateIdentifierConstructor()))(d, -1, -1);
            }, createBaseTokenNode: function(d) {
              return new (B || (B = e.objectAllocator.getTokenConstructor()))(d, -1, -1);
            }, createBaseNode: function(d) {
              return new (w || (w = e.objectAllocator.getNodeConstructor()))(d, -1, -1);
            } }, e.parseNodeFactory = e.createNodeFactory(1, e.parseBaseNodeFactory);
            function N(d, D) {
              return D && d(D);
            }
            function p(d, D, fe) {
              if (fe) {
                if (D) return D(fe);
                for (var g = 0, ne = fe; g < ne.length; g++) {
                  var ue = ne[g], We = d(ue);
                  if (We) return We;
                }
              }
            }
            function m(d, D) {
              return d.charCodeAt(D + 1) === 42 && d.charCodeAt(D + 2) === 42 && d.charCodeAt(D + 3) !== 47;
            }
            e.isJSDocLikeText = m;
            function G(d) {
              return e.forEach(d.statements, oe) || f(d);
            }
            e.isFileProbablyExternalModule = G;
            function oe(d) {
              return K(d, 93) || e.isImportEqualsDeclaration(d) && e.isExternalModuleReference(d.moduleReference) || e.isImportDeclaration(d) || e.isExportAssignment(d) || e.isExportDeclaration(d) ? d : void 0;
            }
            function f(d) {
              return d.flags & 4194304 ? T(d) : void 0;
            }
            function T(d) {
              return b(d) ? d : se(d, T);
            }
            function K(d, D) {
              return e.some(d.modifiers, function(fe) {
                return fe.kind === D;
              });
            }
            function b(d) {
              return e.isMetaProperty(d) && d.keywordToken === 100 && d.name.escapedText === "meta";
            }
            function se(d, D, fe) {
              if (!(!d || d.kind <= 160)) switch (d.kind) {
                case 161:
                  return N(D, d.left) || N(D, d.right);
                case 163:
                  return p(D, fe, d.modifiers) || N(D, d.name) || N(D, d.constraint) || N(D, d.default) || N(D, d.expression);
                case 297:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || N(D, d.questionToken) || N(D, d.exclamationToken) || N(D, d.equalsToken) || N(D, d.objectAssignmentInitializer);
                case 298:
                  return N(D, d.expression);
                case 164:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.dotDotDotToken) || N(D, d.name) || N(D, d.questionToken) || N(D, d.type) || N(D, d.initializer);
                case 167:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || N(D, d.questionToken) || N(D, d.exclamationToken) || N(D, d.type) || N(D, d.initializer);
                case 166:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || N(D, d.questionToken) || N(D, d.type) || N(D, d.initializer);
                case 296:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || N(D, d.questionToken) || N(D, d.initializer);
                case 254:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || N(D, d.exclamationToken) || N(D, d.type) || N(D, d.initializer);
                case 203:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.dotDotDotToken) || N(D, d.propertyName) || N(D, d.name) || N(D, d.initializer);
                case 179:
                case 180:
                case 174:
                case 175:
                case 176:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || p(D, fe, d.typeParameters) || p(D, fe, d.parameters) || N(D, d.type);
                case 169:
                case 168:
                case 171:
                case 172:
                case 173:
                case 213:
                case 256:
                case 214:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.asteriskToken) || N(D, d.name) || N(D, d.questionToken) || N(D, d.exclamationToken) || p(D, fe, d.typeParameters) || p(D, fe, d.parameters) || N(D, d.type) || N(D, d.equalsGreaterThanToken) || N(D, d.body);
                case 170:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.body);
                case 178:
                  return N(D, d.typeName) || p(D, fe, d.typeArguments);
                case 177:
                  return N(D, d.assertsModifier) || N(D, d.parameterName) || N(D, d.type);
                case 181:
                  return N(D, d.exprName) || p(D, fe, d.typeArguments);
                case 182:
                  return p(D, fe, d.members);
                case 183:
                  return N(D, d.elementType);
                case 184:
                  return p(D, fe, d.elements);
                case 187:
                case 188:
                  return p(D, fe, d.types);
                case 189:
                  return N(D, d.checkType) || N(D, d.extendsType) || N(D, d.trueType) || N(D, d.falseType);
                case 190:
                  return N(D, d.typeParameter);
                case 200:
                  return N(D, d.argument) || N(D, d.assertions) || N(D, d.qualifier) || p(D, fe, d.typeArguments);
                case 295:
                  return N(D, d.assertClause);
                case 191:
                case 193:
                  return N(D, d.type);
                case 194:
                  return N(D, d.objectType) || N(D, d.indexType);
                case 195:
                  return N(D, d.readonlyToken) || N(D, d.typeParameter) || N(D, d.nameType) || N(D, d.questionToken) || N(D, d.type) || p(D, fe, d.members);
                case 196:
                  return N(D, d.literal);
                case 197:
                  return N(D, d.dotDotDotToken) || N(D, d.name) || N(D, d.questionToken) || N(D, d.type);
                case 201:
                case 202:
                  return p(D, fe, d.elements);
                case 204:
                  return p(D, fe, d.elements);
                case 205:
                  return p(D, fe, d.properties);
                case 206:
                  return N(D, d.expression) || N(D, d.questionDotToken) || N(D, d.name);
                case 207:
                  return N(D, d.expression) || N(D, d.questionDotToken) || N(D, d.argumentExpression);
                case 208:
                case 209:
                  return N(D, d.expression) || N(D, d.questionDotToken) || p(D, fe, d.typeArguments) || p(D, fe, d.arguments);
                case 210:
                  return N(D, d.tag) || N(D, d.questionDotToken) || p(D, fe, d.typeArguments) || N(D, d.template);
                case 211:
                  return N(D, d.type) || N(D, d.expression);
                case 212:
                  return N(D, d.expression);
                case 215:
                  return N(D, d.expression);
                case 216:
                  return N(D, d.expression);
                case 217:
                  return N(D, d.expression);
                case 219:
                  return N(D, d.operand);
                case 224:
                  return N(D, d.asteriskToken) || N(D, d.expression);
                case 218:
                  return N(D, d.expression);
                case 220:
                  return N(D, d.operand);
                case 221:
                  return N(D, d.left) || N(D, d.operatorToken) || N(D, d.right);
                case 229:
                  return N(D, d.expression) || N(D, d.type);
                case 230:
                  return N(D, d.expression);
                case 231:
                  return N(D, d.name);
                case 222:
                  return N(D, d.condition) || N(D, d.questionToken) || N(D, d.whenTrue) || N(D, d.colonToken) || N(D, d.whenFalse);
                case 225:
                  return N(D, d.expression);
                case 235:
                case 262:
                  return p(D, fe, d.statements);
                case 305:
                  return p(D, fe, d.statements) || N(D, d.endOfFileToken);
                case 237:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.declarationList);
                case 255:
                  return p(D, fe, d.declarations);
                case 238:
                  return N(D, d.expression);
                case 239:
                  return N(D, d.expression) || N(D, d.thenStatement) || N(D, d.elseStatement);
                case 240:
                  return N(D, d.statement) || N(D, d.expression);
                case 241:
                  return N(D, d.expression) || N(D, d.statement);
                case 242:
                  return N(D, d.initializer) || N(D, d.condition) || N(D, d.incrementor) || N(D, d.statement);
                case 243:
                  return N(D, d.initializer) || N(D, d.expression) || N(D, d.statement);
                case 244:
                  return N(D, d.awaitModifier) || N(D, d.initializer) || N(D, d.expression) || N(D, d.statement);
                case 245:
                case 246:
                  return N(D, d.label);
                case 247:
                  return N(D, d.expression);
                case 248:
                  return N(D, d.expression) || N(D, d.statement);
                case 249:
                  return N(D, d.expression) || N(D, d.caseBlock);
                case 263:
                  return p(D, fe, d.clauses);
                case 289:
                  return N(D, d.expression) || p(D, fe, d.statements);
                case 290:
                  return p(D, fe, d.statements);
                case 250:
                  return N(D, d.label) || N(D, d.statement);
                case 251:
                  return N(D, d.expression);
                case 252:
                  return N(D, d.tryBlock) || N(D, d.catchClause) || N(D, d.finallyBlock);
                case 292:
                  return N(D, d.variableDeclaration) || N(D, d.block);
                case 165:
                  return N(D, d.expression);
                case 257:
                case 226:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || p(D, fe, d.typeParameters) || p(D, fe, d.heritageClauses) || p(D, fe, d.members);
                case 258:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || p(D, fe, d.typeParameters) || p(D, fe, d.heritageClauses) || p(D, fe, d.members);
                case 259:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || p(D, fe, d.typeParameters) || N(D, d.type);
                case 260:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || p(D, fe, d.members);
                case 299:
                  return N(D, d.name) || N(D, d.initializer);
                case 261:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || N(D, d.body);
                case 265:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || N(D, d.moduleReference);
                case 266:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.importClause) || N(D, d.moduleSpecifier) || N(D, d.assertClause);
                case 267:
                  return N(D, d.name) || N(D, d.namedBindings);
                case 293:
                  return p(D, fe, d.elements);
                case 294:
                  return N(D, d.name) || N(D, d.value);
                case 264:
                  return N(D, d.name);
                case 268:
                  return N(D, d.name);
                case 274:
                  return N(D, d.name);
                case 269:
                case 273:
                  return p(D, fe, d.elements);
                case 272:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.exportClause) || N(D, d.moduleSpecifier) || N(D, d.assertClause);
                case 270:
                case 275:
                  return N(D, d.propertyName) || N(D, d.name);
                case 271:
                  return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.expression);
                case 223:
                  return N(D, d.head) || p(D, fe, d.templateSpans);
                case 233:
                  return N(D, d.expression) || N(D, d.literal);
                case 198:
                  return N(D, d.head) || p(D, fe, d.templateSpans);
                case 199:
                  return N(D, d.type) || N(D, d.literal);
                case 162:
                  return N(D, d.expression);
                case 291:
                  return p(D, fe, d.types);
                case 228:
                  return N(D, d.expression) || p(D, fe, d.typeArguments);
                case 277:
                  return N(D, d.expression);
                case 276:
                  return p(D, fe, d.decorators);
                case 351:
                  return p(D, fe, d.elements);
                case 278:
                  return N(D, d.openingElement) || p(D, fe, d.children) || N(D, d.closingElement);
                case 282:
                  return N(D, d.openingFragment) || p(D, fe, d.children) || N(D, d.closingFragment);
                case 279:
                case 280:
                  return N(D, d.tagName) || p(D, fe, d.typeArguments) || N(D, d.attributes);
                case 286:
                  return p(D, fe, d.properties);
                case 285:
                  return N(D, d.name) || N(D, d.initializer);
                case 287:
                  return N(D, d.expression);
                case 288:
                  return N(D, d.dotDotDotToken) || N(D, d.expression);
                case 281:
                  return N(D, d.tagName);
                case 185:
                case 186:
                case 309:
                case 315:
                case 314:
                case 316:
                case 318:
                  return N(D, d.type);
                case 317:
                  return p(D, fe, d.parameters) || N(D, d.type);
                case 320:
                  return (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment)) || p(D, fe, d.tags);
                case 346:
                  return N(D, d.tagName) || N(D, d.name) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment));
                case 310:
                  return N(D, d.name);
                case 311:
                  return N(D, d.left) || N(D, d.right);
                case 340:
                case 347:
                  return N(D, d.tagName) || (d.isNameFirst ? N(D, d.name) || N(D, d.typeExpression) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment)) : N(D, d.typeExpression) || N(D, d.name) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment)));
                case 330:
                  return N(D, d.tagName) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment));
                case 329:
                  return N(D, d.tagName) || N(D, d.class) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment));
                case 328:
                  return N(D, d.tagName) || N(D, d.class) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment));
                case 344:
                  return N(D, d.tagName) || N(D, d.constraint) || p(D, fe, d.typeParameters) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment));
                case 345:
                  return N(D, d.tagName) || (d.typeExpression && d.typeExpression.kind === 309 ? N(D, d.typeExpression) || N(D, d.fullName) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment)) : N(D, d.fullName) || N(D, d.typeExpression) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment)));
                case 338:
                  return N(D, d.tagName) || N(D, d.fullName) || N(D, d.typeExpression) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment));
                case 341:
                case 343:
                case 342:
                case 339:
                  return N(D, d.tagName) || N(D, d.typeExpression) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment));
                case 323:
                  return e.forEach(d.typeParameters, D) || e.forEach(d.parameters, D) || N(D, d.type);
                case 324:
                case 325:
                case 326:
                  return N(D, d.name);
                case 322:
                  return e.forEach(d.jsDocPropertyTags, D);
                case 327:
                case 332:
                case 333:
                case 334:
                case 335:
                case 336:
                case 331:
                  return N(D, d.tagName) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment));
                case 350:
                  return N(D, d.expression);
              }
            }
            e.forEachChild = se;
            function J(d, D, fe) {
              for (var g = ie(d), ne = []; ne.length < g.length; ) ne.push(d);
              for (; g.length !== 0; ) {
                var ue = g.pop(), We = ne.pop();
                if (e.isArray(ue)) {
                  if (fe) {
                    var Fe = fe(ue, We);
                    if (Fe) {
                      if (Fe === "skip") continue;
                      return Fe;
                    }
                  }
                  for (var Z = ue.length - 1; Z >= 0; --Z) g.push(ue[Z]), ne.push(We);
                } else {
                  var Fe = D(ue, We);
                  if (Fe) {
                    if (Fe === "skip") continue;
                    return Fe;
                  }
                  if (ue.kind >= 161) for (var Be = 0, ge = ie(ue); Be < ge.length; Be++) {
                    var Re = ge[Be];
                    g.push(Re), ne.push(ue);
                  }
                }
              }
            }
            e.forEachChildRecursively = J;
            function ie(d) {
              var D = [];
              return se(d, fe, fe), D;
              function fe(g) {
                D.unshift(g);
              }
            }
            function R(d) {
              d.externalModuleIndicator = G(d);
            }
            function q(d, D, fe, g, ne) {
              g === void 0 && (g = false), e.tracing === null || e.tracing === void 0 || e.tracing.push("parse", "createSourceFile", { path: d }, true), e.performance.mark("beforeParse");
              var ue;
              e.perfLogger.logStartParseSourceFile(d);
              var We = typeof fe == "object" ? fe : { languageVersion: fe }, Fe = We.languageVersion, Z = We.setExternalModuleIndicator, Be = We.impliedNodeFormat;
              if (Fe === 100) ue = X.parseSourceFile(d, D, Fe, void 0, g, 6, e.noop);
              else {
                var ge = Be === void 0 ? Z : function(Re) {
                  return Re.impliedNodeFormat = Be, (Z || R)(Re);
                };
                ue = X.parseSourceFile(d, D, Fe, void 0, g, ne, ge);
              }
              return e.perfLogger.logStopParseSourceFile(), e.performance.mark("afterParse"), e.performance.measure("Parse", "beforeParse", "afterParse"), e.tracing === null || e.tracing === void 0 || e.tracing.pop(), ue;
            }
            e.createSourceFile = q;
            function O(d, D) {
              return X.parseIsolatedEntityName(d, D);
            }
            e.parseIsolatedEntityName = O;
            function ve(d, D) {
              return X.parseJsonText(d, D);
            }
            e.parseJsonText = ve;
            function ee(d) {
              return d.externalModuleIndicator !== void 0;
            }
            e.isExternalModule = ee;
            function he(d, D, fe, g) {
              g === void 0 && (g = false);
              var ne = $.updateSourceFile(d, D, fe, g);
              return ne.flags |= d.flags & 6291456, ne;
            }
            e.updateSourceFile = he;
            function F(d, D, fe) {
              var g = X.JSDocParser.parseIsolatedJSDocComment(d, D, fe);
              return g && g.jsDoc && X.fixupParentReferences(g.jsDoc), g;
            }
            e.parseIsolatedJSDocComment = F;
            function x(d, D, fe) {
              return X.JSDocParser.parseJSDocTypeExpressionForTests(d, D, fe);
            }
            e.parseJSDocTypeExpressionForTests = x;
            var X;
            (function(d) {
              var D = e.createScanner(99, true), fe = 20480, g, ne, ue, We, Fe;
              function Z(Le) {
                return Ae++, Le;
              }
              var Be = { createBaseSourceFileNode: function(Le) {
                return Z(new Fe(Le, 0, 0));
              }, createBaseIdentifierNode: function(Le) {
                return Z(new ue(Le, 0, 0));
              }, createBasePrivateIdentifierNode: function(Le) {
                return Z(new We(Le, 0, 0));
              }, createBaseTokenNode: function(Le) {
                return Z(new ne(Le, 0, 0));
              }, createBaseNode: function(Le) {
                return Z(new g(Le, 0, 0));
              } }, ge = e.createNodeFactory(11, Be), Re, ze, Ee, He, rr, Ie, _e, we, de, ye, Ae, er, ir, Cr, Ye, Br, Er, Ne = true, n = false;
              function lr(Le, Nr, ri, di, Mi, st, ra) {
                var Ta;
                if (Mi === void 0 && (Mi = false), st = e.ensureScriptKind(Le, st), st === 6) {
                  var ha = Ge(Le, Nr, ri, di, Mi);
                  return e.convertToObjectWorker(ha, (Ta = ha.statements[0]) === null || Ta === void 0 ? void 0 : Ta.expression, ha.parseDiagnostics, false, void 0, void 0), ha.referencedFiles = e.emptyArray, ha.typeReferenceDirectives = e.emptyArray, ha.libReferenceDirectives = e.emptyArray, ha.amdDependencies = e.emptyArray, ha.hasNoDefaultLib = false, ha.pragmas = e.emptyMap, ha;
                }
                ur(Le, Nr, ri, di, st);
                var Na = Ir(ri, Mi, st, ra || R);
                return yr(), Na;
              }
              d.parseSourceFile = lr;
              function be(Le, Nr) {
                ur("", Le, Nr, void 0, 1), Tr();
                var ri = ds(true), di = De() === 1 && !_e.length;
                return yr(), di ? ri : void 0;
              }
              d.parseIsolatedEntityName = be;
              function Ge(Le, Nr, ri, di, Mi) {
                ri === void 0 && (ri = 2), Mi === void 0 && (Mi = false), ur(Le, Nr, ri, di, 6), ze = Er, Tr();
                var st = Ue(), ra, Ta;
                if (De() === 1) ra = Cn([], st, st), Ta = ai();
                else {
                  for (var ha = void 0; De() !== 1; ) {
                    var Na = void 0;
                    switch (De()) {
                      case 22:
                        Na = cl();
                        break;
                      case 110:
                      case 95:
                      case 104:
                        Na = ai();
                        break;
                      case 40:
                        Rt(function() {
                          return Tr() === 8 && Tr() !== 58;
                        }) ? Na = ol() : Na = Ut();
                        break;
                      case 8:
                      case 10:
                        if (Rt(function() {
                          return Tr() !== 58;
                        })) {
                          Na = ga();
                          break;
                        }
                      default:
                        Na = Ut();
                        break;
                    }
                    ha && e.isArray(ha) ? ha.push(Na) : ha ? ha = [ha, Na] : (ha = Na, De() !== 1 && Ar(e.Diagnostics.Unexpected_token));
                  }
                  var In = e.isArray(ha) ? Bi(ge.createArrayLiteralExpression(ha), st) : e.Debug.checkDefined(ha), qo = ge.createExpressionStatement(In);
                  Bi(qo, st), ra = Cn([qo], st), Ta = $a(1, e.Diagnostics.Unexpected_token);
                }
                var co = or(Le, 2, 6, false, ra, Ta, ze, e.noop);
                Mi && pe(co), co.nodeCount = Ae, co.identifierCount = Cr, co.identifiers = er, co.parseDiagnostics = e.attachFileToDiagnostics(_e, co), we && (co.jsDocDiagnostics = e.attachFileToDiagnostics(we, co));
                var ts = co;
                return yr(), ts;
              }
              d.parseJsonText = Ge;
              function ur(Le, Nr, ri, di, Mi) {
                switch (g = e.objectAllocator.getNodeConstructor(), ne = e.objectAllocator.getTokenConstructor(), ue = e.objectAllocator.getIdentifierConstructor(), We = e.objectAllocator.getPrivateIdentifierConstructor(), Fe = e.objectAllocator.getSourceFileConstructor(), Re = e.normalizePath(Le), Ee = Nr, He = ri, de = di, rr = Mi, Ie = e.getLanguageVariant(Mi), _e = [], Ye = 0, er = new e.Map(), ir = new e.Map(), Cr = 0, Ae = 0, ze = 0, Ne = true, rr) {
                  case 1:
                  case 2:
                    Er = 262144;
                    break;
                  case 6:
                    Er = 67371008;
                    break;
                  default:
                    Er = 0;
                    break;
                }
                n = false, D.setText(Ee), D.setOnError(Pe), D.setScriptTarget(He), D.setLanguageVariant(Ie);
              }
              function yr() {
                D.clearCommentDirectives(), D.setText(""), D.setOnError(void 0), Ee = void 0, He = void 0, de = void 0, rr = void 0, Ie = void 0, ze = 0, _e = void 0, we = void 0, Ye = 0, er = void 0, Br = void 0, Ne = true;
              }
              function Ir(Le, Nr, ri, di) {
                var Mi = A(Re);
                Mi && (Er |= 16777216), ze = Er, Tr();
                var st = Qi(0, nc);
                e.Debug.assert(De() === 1);
                var ra = ii(ai()), Ta = or(Re, Le, ri, Mi, st, ra, ze, di);
                return V(Ta, Ee), L(Ta, ha), Ta.commentDirectives = D.getCommentDirectives(), Ta.nodeCount = Ae, Ta.identifierCount = Cr, Ta.identifiers = er, Ta.parseDiagnostics = e.attachFileToDiagnostics(_e, Ta), we && (Ta.jsDocDiagnostics = e.attachFileToDiagnostics(we, Ta)), Nr && pe(Ta), Ta;
                function ha(Na, In, qo) {
                  _e.push(e.createDetachedDiagnostic(Re, Na, In, qo));
                }
              }
              function wr(Le, Nr) {
                return Nr ? ii(Le) : Le;
              }
              var Ur = false;
              function ii(Le) {
                e.Debug.assert(!Le.jsDoc);
                var Nr = e.mapDefined(e.getJSDocCommentRanges(Le, Ee), function(ri) {
                  return G_.parseJSDocComment(Le, ri.pos, ri.end - ri.pos);
                });
                return Nr.length && (Le.jsDoc = Nr), Ur && (Ur = false, Le.flags |= 268435456), Le;
              }
              function mi(Le) {
                var Nr = de, ri = $.createSyntaxCursor(Le);
                de = { currentNode: ts };
                var di = [], Mi = _e;
                _e = [];
                for (var st = 0, ra = qo(Le.statements, 0), Ta = function() {
                  var vs = Le.statements[st], Ac = Le.statements[ra];
                  e.addRange(di, Le.statements, st, ra), st = co(Le.statements, ra);
                  var Is = e.findIndex(Mi, function(sc) {
                    return sc.start >= vs.pos;
                  }), Qu = Is >= 0 ? e.findIndex(Mi, function(sc) {
                    return sc.start >= Ac.pos;
                  }, Is) : -1;
                  Is >= 0 && e.addRange(_e, Mi, Is, Qu >= 0 ? Qu : void 0), Dt(function() {
                    var sc = Er;
                    for (Er |= 32768, D.setTextPos(Ac.pos), Tr(); De() !== 1; ) {
                      var bc = D.getStartPos(), Mc = Ct(0, nc);
                      if (di.push(Mc), bc === D.getStartPos() && Tr(), st >= 0) {
                        var Yu = Le.statements[st];
                        if (Mc.end === Yu.pos) break;
                        Mc.end > Yu.pos && (st = co(Le.statements, st + 1));
                      }
                    }
                    Er = sc;
                  }, 2), ra = st >= 0 ? qo(Le.statements, st) : -1;
                }; ra !== -1; ) Ta();
                if (st >= 0) {
                  var ha = Le.statements[st];
                  e.addRange(di, Le.statements, st);
                  var Na = e.findIndex(Mi, function(vs) {
                    return vs.start >= ha.pos;
                  });
                  Na >= 0 && e.addRange(_e, Mi, Na);
                }
                return de = Nr, ge.updateSourceFile(Le, e.setTextRange(ge.createNodeArray(di), Le.statements));
                function In(vs) {
                  return !(vs.flags & 32768) && !!(vs.transformFlags & 16777216);
                }
                function qo(vs, Ac) {
                  for (var Is = Ac; Is < vs.length; Is++) if (In(vs[Is])) return Is;
                  return -1;
                }
                function co(vs, Ac) {
                  for (var Is = Ac; Is < vs.length; Is++) if (!In(vs[Is])) return Is;
                  return -1;
                }
                function ts(vs) {
                  var Ac = ri.currentNode(vs);
                  return Ne && Ac && In(Ac) && (Ac.intersectsChange = true), Ac;
                }
              }
              function pe(Le) {
                e.setParentRecursive(Le, true);
              }
              d.fixupParentReferences = pe;
              function or(Le, Nr, ri, di, Mi, st, ra, Ta) {
                var ha = ge.createSourceFile(Mi, st, ra);
                return e.setTextRangePosWidth(ha, 0, Ee.length), Na(ha), !di && ee(ha) && ha.transformFlags & 16777216 && (ha = mi(ha), Na(ha)), ha;
                function Na(In) {
                  In.text = Ee, In.bindDiagnostics = [], In.bindSuggestionDiagnostics = void 0, In.languageVersion = Nr, In.fileName = Le, In.languageVariant = e.getLanguageVariant(ri), In.isDeclarationFile = di, In.scriptKind = ri, Ta(In), In.setExternalModuleIndicator = Ta;
                }
              }
              function qr(Le, Nr) {
                Le ? Er |= Nr : Er &= ~Nr;
              }
              function si(Le) {
                qr(Le, 4096);
              }
              function Di(Le) {
                qr(Le, 8192);
              }
              function wi(Le) {
                qr(Le, 16384);
              }
              function Xi(Le) {
                qr(Le, 32768);
              }
              function et(Le, Nr) {
                var ri = Le & Er;
                if (ri) {
                  qr(false, ri);
                  var di = Nr();
                  return qr(true, ri), di;
                }
                return Nr();
              }
              function Gi(Le, Nr) {
                var ri = Le & ~Er;
                if (ri) {
                  qr(true, ri);
                  var di = Nr();
                  return qr(false, ri), di;
                }
                return Nr();
              }
              function Wt(Le) {
                return et(4096, Le);
              }
              function Zt(Le) {
                return Gi(4096, Le);
              }
              function _r(Le) {
                return et(65536, Le);
              }
              function pi(Le) {
                return Gi(65536, Le);
              }
              function ae(Le) {
                return Gi(8192, Le);
              }
              function Xe(Le) {
                return Gi(16384, Le);
              }
              function Jr(Le) {
                return Gi(32768, Le);
              }
              function ti(Le) {
                return et(32768, Le);
              }
              function Ze(Le) {
                return Gi(40960, Le);
              }
              function Sr(Le) {
                return et(40960, Le);
              }
              function zr(Le) {
                return (Er & Le) !== 0;
              }
              function Wr() {
                return zr(8192);
              }
              function Je() {
                return zr(4096);
              }
              function xe() {
                return zr(65536);
              }
              function vr() {
                return zr(16384);
              }
              function mr() {
                return zr(32768);
              }
              function Ar(Le, Nr) {
                return nr(D.getTokenPos(), D.getTextPos(), Le, Nr);
              }
              function Oe(Le, Nr, ri, di) {
                var Mi = e.lastOrUndefined(_e), st;
                return (!Mi || Le !== Mi.start) && (st = e.createDetachedDiagnostic(Re, Le, Nr, ri, di), _e.push(st)), n = true, st;
              }
              function nr(Le, Nr, ri, di) {
                return Oe(Le, Nr - Le, ri, di);
              }
              function Mr(Le, Nr, ri) {
                nr(Le.pos, Le.end, Nr, ri);
              }
              function Pe(Le, Nr) {
                Oe(D.getTextPos(), Nr, Le);
              }
              function Ue() {
                return D.getStartPos();
              }
              function fr() {
                return D.hasPrecedingJSDocComment();
              }
              function De() {
                return ye;
              }
              function gr() {
                return ye = D.scan();
              }
              function Vr(Le) {
                return Tr(), Le();
              }
              function Tr() {
                return e.isKeyword(ye) && (D.hasUnicodeEscape() || D.hasExtendedUnicodeEscape()) && nr(D.getTokenPos(), D.getTextPos(), e.Diagnostics.Keywords_cannot_contain_escape_characters), gr();
              }
              function vi() {
                return ye = D.scanJsDocToken();
              }
              function Ui() {
                return ye = D.reScanGreaterToken();
              }
              function Yi() {
                return ye = D.reScanSlashToken();
              }
              function Wi(Le) {
                return ye = D.reScanTemplateToken(Le);
              }
              function ct() {
                return ye = D.reScanTemplateHeadOrNoSubstitutionTemplate();
              }
              function Li() {
                return ye = D.reScanLessThanToken();
              }
              function nt() {
                return ye = D.reScanHashToken();
              }
              function Mt() {
                return ye = D.scanJsxIdentifier();
              }
              function xt() {
                return ye = D.scanJsxToken();
              }
              function ut() {
                return ye = D.scanJsxAttributeValue();
              }
              function Dt(Le, Nr) {
                var ri = ye, di = _e.length, Mi = n, st = Er, ra = Nr !== 0 ? D.lookAhead(Le) : D.tryScan(Le);
                return e.Debug.assert(st === Er), (!ra || Nr !== 0) && (ye = ri, Nr !== 2 && (_e.length = di), n = Mi), ra;
              }
              function Rt(Le) {
                return Dt(Le, 1);
              }
              function Ii(Le) {
                return Dt(Le, 0);
              }
              function Ki() {
                return De() === 79 ? true : De() > 116;
              }
              function Fi() {
                return De() === 79 ? true : De() === 125 && Wr() || De() === 132 && mr() ? false : De() > 116;
              }
              function ui(Le, Nr, ri) {
                return ri === void 0 && (ri = true), De() === Le ? (ri && Tr(), true) : (Nr ? Ar(Nr) : Ar(e.Diagnostics._0_expected, e.tokenToString(Le)), false);
              }
              var Bt = Object.keys(e.textToKeywordObj).filter(function(Le) {
                return Le.length > 2;
              });
              function wt(Le) {
                var Nr;
                if (e.isTaggedTemplateExpression(Le)) {
                  nr(e.skipTrivia(Ee, Le.template.pos), Le.template.end, e.Diagnostics.Module_declaration_names_may_only_use_or_quoted_strings);
                  return;
                }
                var ri = e.isIdentifier(Le) ? e.idText(Le) : void 0;
                if (!ri || !e.isIdentifierText(ri, He)) {
                  Ar(e.Diagnostics._0_expected, e.tokenToString(26));
                  return;
                }
                var di = e.skipTrivia(Ee, Le.pos);
                switch (ri) {
                  case "const":
                  case "let":
                  case "var":
                    nr(di, Le.end, e.Diagnostics.Variable_declaration_not_allowed_at_this_location);
                    return;
                  case "declare":
                    return;
                  case "interface":
                    na(e.Diagnostics.Interface_name_cannot_be_0, e.Diagnostics.Interface_must_be_given_a_name, 18);
                    return;
                  case "is":
                    nr(di, D.getTextPos(), e.Diagnostics.A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods);
                    return;
                  case "module":
                  case "namespace":
                    na(e.Diagnostics.Namespace_name_cannot_be_0, e.Diagnostics.Namespace_must_be_given_a_name, 18);
                    return;
                  case "type":
                    na(e.Diagnostics.Type_alias_name_cannot_be_0, e.Diagnostics.Type_alias_must_be_given_a_name, 63);
                    return;
                }
                var Mi = (Nr = e.getSpellingSuggestion(ri, Bt, function(st) {
                  return st;
                })) !== null && Nr !== void 0 ? Nr : Ai(ri);
                if (Mi) {
                  nr(di, Le.end, e.Diagnostics.Unknown_keyword_or_identifier_Did_you_mean_0, Mi);
                  return;
                }
                De() !== 0 && nr(di, Le.end, e.Diagnostics.Unexpected_keyword_or_identifier);
              }
              function na(Le, Nr, ri) {
                De() === ri ? Ar(Nr) : Ar(Le, D.getTokenValue());
              }
              function Ai(Le) {
                for (var Nr = 0, ri = Bt; Nr < ri.length; Nr++) {
                  var di = ri[Nr];
                  if (Le.length > di.length + 2 && e.startsWith(Le, di)) return "".concat(di, " ").concat(Le.slice(di.length));
                }
              }
              function Oi(Le, Nr, ri) {
                if (De() === 59 && !D.hasPrecedingLineBreak()) {
                  Ar(e.Diagnostics.Decorators_must_precede_the_name_and_all_keywords_of_property_declarations);
                  return;
                }
                if (De() === 20) {
                  Ar(e.Diagnostics.Cannot_start_a_function_call_in_a_type_annotation), Tr();
                  return;
                }
                if (Nr && !ka()) {
                  ri ? Ar(e.Diagnostics._0_expected, e.tokenToString(26)) : Ar(e.Diagnostics.Expected_for_property_initializer);
                  return;
                }
                if (!Ba()) {
                  if (ri) {
                    Ar(e.Diagnostics._0_expected, e.tokenToString(26));
                    return;
                  }
                  wt(Le);
                }
              }
              function ji(Le) {
                return De() === Le ? (vi(), true) : (Ar(e.Diagnostics._0_expected, e.tokenToString(Le)), false);
              }
              function Vi(Le, Nr, ri, di) {
                if (De() === Nr) {
                  Tr();
                  return;
                }
                var Mi = Ar(e.Diagnostics._0_expected, e.tokenToString(Nr));
                !ri || Mi && e.addRelatedInfo(Mi, e.createDetachedDiagnostic(Re, di, 1, e.Diagnostics.The_parser_expected_to_find_a_1_to_match_the_0_token_here, e.tokenToString(Le), e.tokenToString(Nr)));
              }
              function at(Le) {
                return De() === Le ? (Tr(), true) : false;
              }
              function At(Le) {
                if (De() === Le) return ai();
              }
              function ba(Le) {
                if (De() === Le) return Dn();
              }
              function $a(Le, Nr, ri) {
                return At(Le) || kn(Le, false, Nr || e.Diagnostics._0_expected, ri || e.tokenToString(Le));
              }
              function Qa(Le) {
                return ba(Le) || kn(Le, false, e.Diagnostics._0_expected, e.tokenToString(Le));
              }
              function ai() {
                var Le = Ue(), Nr = De();
                return Tr(), Bi(ge.createToken(Nr), Le);
              }
              function Dn() {
                var Le = Ue(), Nr = De();
                return vi(), Bi(ge.createToken(Nr), Le);
              }
              function ka() {
                return De() === 26 ? true : De() === 19 || De() === 1 || D.hasPrecedingLineBreak();
              }
              function Ba() {
                return ka() ? (De() === 26 && Tr(), true) : false;
              }
              function pn() {
                return Ba() || ui(26);
              }
              function Cn(Le, Nr, ri, di) {
                var Mi = ge.createNodeArray(Le, di);
                return e.setTextRangePosEnd(Mi, Nr, ri != null ? ri : D.getStartPos()), Mi;
              }
              function Bi(Le, Nr, ri) {
                return e.setTextRangePosEnd(Le, Nr, ri != null ? ri : D.getStartPos()), Er && (Le.flags |= Er), n && (n = false, Le.flags |= 131072), Le;
              }
              function kn(Le, Nr, ri, di) {
                Nr ? Oe(D.getStartPos(), 0, ri, di) : ri && Ar(ri, di);
                var Mi = Ue(), st = Le === 79 ? ge.createIdentifier("", void 0, void 0) : e.isTemplateLiteralKind(Le) ? ge.createTemplateLiteralLikeNode(Le, "", "", void 0) : Le === 8 ? ge.createNumericLiteral("", void 0) : Le === 10 ? ge.createStringLiteral("", void 0) : Le === 276 ? ge.createMissingDeclaration() : ge.createToken(Le);
                return Bi(st, Mi);
              }
              function xn(Le) {
                var Nr = er.get(Le);
                return Nr === void 0 && er.set(Le, Nr = Le), Nr;
              }
              function Kn(Le, Nr, ri) {
                if (Le) {
                  Cr++;
                  var di = Ue(), Mi = De(), st = xn(D.getTokenValue());
                  return gr(), Bi(ge.createIdentifier(st, void 0, Mi), di);
                }
                if (De() === 80) return Ar(ri || e.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies), Kn(true);
                if (De() === 0 && D.tryScan(function() {
                  return D.reScanInvalidIdentifier() === 79;
                })) return Kn(true);
                Cr++;
                var ra = De() === 1, Ta = D.isReservedWord(), ha = D.getTokenText(), Na = Ta ? e.Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here : e.Diagnostics.Identifier_expected;
                return kn(79, ra, Nr || Na, ha);
              }
              function Pn(Le) {
                return Kn(Ki(), void 0, Le);
              }
              function eo(Le, Nr) {
                return Kn(Fi(), Le, Nr);
              }
              function Rn(Le) {
                return Kn(e.tokenIsIdentifierOrKeyword(De()), Le);
              }
              function Da() {
                return e.tokenIsIdentifierOrKeyword(De()) || De() === 10 || De() === 8;
              }
              function bo() {
                return e.tokenIsIdentifierOrKeyword(De()) || De() === 10;
              }
              function Ro(Le) {
                if (De() === 10 || De() === 8) {
                  var Nr = ga();
                  return Nr.text = xn(Nr.text), Nr;
                }
                return Le && De() === 22 ? Wn() : De() === 80 ? Co() : Rn();
              }
              function En() {
                return Ro(true);
              }
              function Wn() {
                var Le = Ue();
                ui(22);
                var Nr = Wt(ns);
                return ui(23), Bi(ge.createComputedPropertyName(Nr), Le);
              }
              function to(Le) {
                var Nr = ir.get(Le);
                return Nr === void 0 && ir.set(Le, Nr = Le), Nr;
              }
              function Co() {
                var Le = Ue(), Nr = ge.createPrivateIdentifier(to(D.getTokenText()));
                return Tr(), Bi(Nr, Le);
              }
              function Ko(Le) {
                return De() === Le && Ii(no);
              }
              function Oo() {
                return Tr(), D.hasPrecedingLineBreak() ? false : St();
              }
              function no() {
                switch (De()) {
                  case 85:
                    return Tr() === 92;
                  case 93:
                    return Tr(), De() === 88 ? Rt(pa) : De() === 152 ? Rt(Pr) : $o();
                  case 88:
                    return pa();
                  case 124:
                  case 136:
                  case 149:
                    return Tr(), St();
                  default:
                    return Oo();
                }
              }
              function $o() {
                return De() !== 41 && De() !== 127 && De() !== 18 && St();
              }
              function Pr() {
                return Tr(), $o();
              }
              function xi() {
                return e.isModifierKind(De()) && Ii(no);
              }
              function St() {
                return De() === 22 || De() === 18 || De() === 41 || De() === 25 || Da();
              }
              function pa() {
                return Tr(), De() === 84 || De() === 98 || De() === 118 || De() === 126 && Rt(wl) || De() === 131 && Rt(Iu);
              }
              function dn(Le, Nr) {
                var ri = sa(Le);
                if (ri) return true;
                switch (Le) {
                  case 0:
                  case 1:
                  case 3:
                    return !(De() === 26 && Nr) && Ku();
                  case 2:
                    return De() === 82 || De() === 88;
                  case 4:
                    return Rt(bn);
                  case 5:
                    return Rt(Lp) || De() === 26 && !Nr;
                  case 6:
                    return De() === 22 || Da();
                  case 12:
                    switch (De()) {
                      case 22:
                      case 41:
                      case 25:
                      case 24:
                        return true;
                      default:
                        return Da();
                    }
                  case 18:
                    return Da();
                  case 9:
                    return De() === 22 || De() === 25 || Da();
                  case 24:
                    return bo();
                  case 7:
                    return De() === 18 ? Rt(Jn) : Nr ? Fi() && !Ce() : Cu() && !Ce();
                  case 8:
                    return Hc();
                  case 10:
                    return De() === 27 || De() === 25 || Hc();
                  case 19:
                    return De() === 101 || Fi();
                  case 15:
                    switch (De()) {
                      case 27:
                      case 24:
                        return true;
                    }
                  case 11:
                    return De() === 25 || qs();
                  case 16:
                    return pu(false);
                  case 17:
                    return pu(true);
                  case 20:
                  case 21:
                    return De() === 27 || Xr();
                  case 22:
                    return Ll();
                  case 23:
                    return e.tokenIsIdentifierOrKeyword(De());
                  case 13:
                    return e.tokenIsIdentifierOrKeyword(De()) || De() === 18;
                  case 14:
                    return true;
                }
                return e.Debug.fail("Non-exhaustive case in 'isListElement'.");
              }
              function Jn() {
                if (e.Debug.assert(De() === 18), Tr() === 19) {
                  var Le = Tr();
                  return Le === 27 || Le === 18 || Le === 94 || Le === 117;
                }
                return true;
              }
              function Qe() {
                return Tr(), Fi();
              }
              function Gr() {
                return Tr(), e.tokenIsIdentifierOrKeyword(De());
              }
              function S() {
                return Tr(), e.tokenIsIdentifierOrKeywordOrGreaterThan(De());
              }
              function Ce() {
                return De() === 117 || De() === 94 ? Rt(qe) : false;
              }
              function qe() {
                return Tr(), qs();
              }
              function br() {
                return Tr(), Xr();
              }
              function Zr(Le) {
                if (De() === 1) return true;
                switch (Le) {
                  case 1:
                  case 2:
                  case 4:
                  case 5:
                  case 6:
                  case 12:
                  case 9:
                  case 23:
                  case 24:
                    return De() === 19;
                  case 3:
                    return De() === 19 || De() === 82 || De() === 88;
                  case 7:
                    return De() === 18 || De() === 94 || De() === 117;
                  case 8:
                    return Si();
                  case 19:
                    return De() === 31 || De() === 20 || De() === 18 || De() === 94 || De() === 117;
                  case 11:
                    return De() === 21 || De() === 26;
                  case 15:
                  case 21:
                  case 10:
                    return De() === 23;
                  case 17:
                  case 16:
                  case 18:
                    return De() === 21 || De() === 23;
                  case 20:
                    return De() !== 27;
                  case 22:
                    return De() === 18 || De() === 19;
                  case 13:
                    return De() === 31 || De() === 43;
                  case 14:
                    return De() === 29 && Rt(fi);
                  default:
                    return false;
                }
              }
              function Si() {
                return !!(ka() || F_(De()) || De() === 38);
              }
              function Pi() {
                for (var Le = 0; Le < 25; Le++) if (Ye & 1 << Le && (dn(Le, true) || Zr(Le))) return true;
                return false;
              }
              function Qi(Le, Nr) {
                var ri = Ye;
                Ye |= 1 << Le;
                for (var di = [], Mi = Ue(); !Zr(Le); ) {
                  if (dn(Le, false)) {
                    di.push(Ct(Le, Nr));
                    continue;
                  }
                  if (Xs(Le)) break;
                }
                return Ye = ri, Cn(di, Mi);
              }
              function Ct(Le, Nr) {
                var ri = sa(Le);
                return ri ? en(ri) : Nr();
              }
              function sa(Le) {
                if (!(!de || !Wa(Le) || n)) {
                  var Nr = de.currentNode(D.getStartPos());
                  if (!(e.nodeIsMissing(Nr) || Nr.intersectsChange || e.containsParseError(Nr))) {
                    var ri = Nr.flags & 50720768;
                    if (ri === Er && !!qn(Nr, Le)) return Nr.jsDocCache && (Nr.jsDocCache = void 0), Nr;
                  }
                }
              }
              function en(Le) {
                return D.setTextPos(Le.end), Tr(), Le;
              }
              function Wa(Le) {
                switch (Le) {
                  case 5:
                  case 2:
                  case 0:
                  case 1:
                  case 3:
                  case 6:
                  case 4:
                  case 8:
                  case 17:
                  case 16:
                    return true;
                }
                return false;
              }
              function qn(Le, Nr) {
                switch (Nr) {
                  case 5:
                    return mo(Le);
                  case 2:
                    return So(Le);
                  case 0:
                  case 1:
                  case 3:
                    return Go(Le);
                  case 6:
                    return ys(Le);
                  case 4:
                    return Pc(Le);
                  case 8:
                    return Vc(Le);
                  case 17:
                  case 16:
                    return Kc(Le);
                }
                return false;
              }
              function mo(Le) {
                if (Le) switch (Le.kind) {
                  case 171:
                  case 176:
                  case 172:
                  case 173:
                  case 167:
                  case 234:
                    return true;
                  case 169:
                    var Nr = Le, ri = Nr.name.kind === 79 && Nr.name.originalKeywordKind === 134;
                    return !ri;
                }
                return false;
              }
              function So(Le) {
                if (Le) switch (Le.kind) {
                  case 289:
                  case 290:
                    return true;
                }
                return false;
              }
              function Go(Le) {
                if (Le) switch (Le.kind) {
                  case 256:
                  case 237:
                  case 235:
                  case 239:
                  case 238:
                  case 251:
                  case 247:
                  case 249:
                  case 246:
                  case 245:
                  case 243:
                  case 244:
                  case 242:
                  case 241:
                  case 248:
                  case 236:
                  case 252:
                  case 250:
                  case 240:
                  case 253:
                  case 266:
                  case 265:
                  case 272:
                  case 271:
                  case 261:
                  case 257:
                  case 258:
                  case 260:
                  case 259:
                    return true;
                }
                return false;
              }
              function ys(Le) {
                return Le.kind === 299;
              }
              function Pc(Le) {
                if (Le) switch (Le.kind) {
                  case 175:
                  case 168:
                  case 176:
                  case 166:
                  case 174:
                    return true;
                }
                return false;
              }
              function Vc(Le) {
                if (Le.kind !== 254) return false;
                var Nr = Le;
                return Nr.initializer === void 0;
              }
              function Kc(Le) {
                if (Le.kind !== 164) return false;
                var Nr = Le;
                return Nr.initializer === void 0;
              }
              function Xs(Le) {
                return pc(Le), Pi() ? true : (Tr(), false);
              }
              function pc(Le) {
                switch (Le) {
                  case 0:
                    return De() === 88 ? Ar(e.Diagnostics._0_expected, e.tokenToString(93)) : Ar(e.Diagnostics.Declaration_or_statement_expected);
                  case 1:
                    return Ar(e.Diagnostics.Declaration_or_statement_expected);
                  case 2:
                    return Ar(e.Diagnostics.case_or_default_expected);
                  case 3:
                    return Ar(e.Diagnostics.Statement_expected);
                  case 18:
                  case 4:
                    return Ar(e.Diagnostics.Property_or_signature_expected);
                  case 5:
                    return Ar(e.Diagnostics.Unexpected_token_A_constructor_method_accessor_or_property_was_expected);
                  case 6:
                    return Ar(e.Diagnostics.Enum_member_expected);
                  case 7:
                    return Ar(e.Diagnostics.Expression_expected);
                  case 8:
                    return e.isKeyword(De()) ? Ar(e.Diagnostics._0_is_not_allowed_as_a_variable_declaration_name, e.tokenToString(De())) : Ar(e.Diagnostics.Variable_declaration_expected);
                  case 9:
                    return Ar(e.Diagnostics.Property_destructuring_pattern_expected);
                  case 10:
                    return Ar(e.Diagnostics.Array_element_destructuring_pattern_expected);
                  case 11:
                    return Ar(e.Diagnostics.Argument_expression_expected);
                  case 12:
                    return Ar(e.Diagnostics.Property_assignment_expected);
                  case 15:
                    return Ar(e.Diagnostics.Expression_or_comma_expected);
                  case 17:
                    return Ar(e.Diagnostics.Parameter_declaration_expected);
                  case 16:
                    return e.isKeyword(De()) ? Ar(e.Diagnostics._0_is_not_allowed_as_a_parameter_name, e.tokenToString(De())) : Ar(e.Diagnostics.Parameter_declaration_expected);
                  case 19:
                    return Ar(e.Diagnostics.Type_parameter_declaration_expected);
                  case 20:
                    return Ar(e.Diagnostics.Type_argument_expected);
                  case 21:
                    return Ar(e.Diagnostics.Type_expected);
                  case 22:
                    return Ar(e.Diagnostics.Unexpected_token_expected);
                  case 23:
                    return Ar(e.Diagnostics.Identifier_expected);
                  case 13:
                    return Ar(e.Diagnostics.Identifier_expected);
                  case 14:
                    return Ar(e.Diagnostics.Identifier_expected);
                  default:
                    return [void 0];
                }
              }
              function hs(Le, Nr, ri) {
                var di = Ye;
                Ye |= 1 << Le;
                for (var Mi = [], st = Ue(), ra = -1; ; ) {
                  if (dn(Le, false)) {
                    var Ta = D.getStartPos(), ha = Ct(Le, Nr);
                    if (!ha) {
                      Ye = di;
                      return;
                    }
                    if (Mi.push(ha), ra = D.getTokenPos(), at(27)) continue;
                    if (ra = -1, Zr(Le)) break;
                    ui(27, tc(Le)), ri && De() === 26 && !D.hasPrecedingLineBreak() && Tr(), Ta === D.getStartPos() && Tr();
                    continue;
                  }
                  if (Zr(Le) || Xs(Le)) break;
                }
                return Ye = di, Cn(Mi, st, void 0, ra >= 0);
              }
              function tc(Le) {
                return Le === 6 ? e.Diagnostics.An_enum_member_name_must_be_followed_by_a_or : void 0;
              }
              function ps() {
                var Le = Cn([], Ue());
                return Le.isMissingList = true, Le;
              }
              function Qs(Le) {
                return !!Le.isMissingList;
              }
              function js(Le, Nr, ri, di) {
                if (ui(ri)) {
                  var Mi = hs(Le, Nr);
                  return ui(di), Mi;
                }
                return ps();
              }
              function ds(Le, Nr) {
                for (var ri = Ue(), di = Le ? Rn(Nr) : eo(Nr), Mi = Ue(); at(24); ) {
                  if (De() === 29) {
                    di.jsdocDotPos = Mi;
                    break;
                  }
                  Mi = Ue(), di = Bi(ge.createQualifiedName(di, ce(Le, false)), ri);
                }
                return di;
              }
              function Ji(Le, Nr) {
                return Bi(ge.createQualifiedName(Le, Nr), Le.pos);
              }
              function ce(Le, Nr) {
                if (D.hasPrecedingLineBreak() && e.tokenIsIdentifierOrKeyword(De())) {
                  var ri = Rt(Pu);
                  if (ri) return kn(79, true, e.Diagnostics.Identifier_expected);
                }
                if (De() === 80) {
                  var di = Co();
                  return Nr ? di : kn(79, true, e.Diagnostics.Identifier_expected);
                }
                return Le ? Rn() : eo();
              }
              function Rr(Le) {
                var Nr = Ue(), ri = [], di;
                do
                  di = Pt(Le), ri.push(di);
                while (di.literal.kind === 16);
                return Cn(ri, Nr);
              }
              function yi(Le) {
                var Nr = Ue();
                return Bi(ge.createTemplateExpression(ua(Le), Rr(Le)), Nr);
              }
              function qi() {
                var Le = Ue();
                return Bi(ge.createTemplateLiteralType(ua(false), je()), Le);
              }
              function je() {
                var Le = Ue(), Nr = [], ri;
                do
                  ri = Hr(), Nr.push(ri);
                while (ri.literal.kind === 16);
                return Cn(Nr, Le);
              }
              function Hr() {
                var Le = Ue();
                return Bi(ge.createTemplateLiteralTypeSpan(Aa(), pt(false)), Le);
              }
              function pt(Le) {
                return De() === 19 ? (Wi(Le), Xn()) : $a(17, e.Diagnostics._0_expected, e.tokenToString(19));
              }
              function Pt(Le) {
                var Nr = Ue();
                return Bi(ge.createTemplateSpan(Wt(ns), pt(Le)), Nr);
              }
              function ga() {
                return fo(De());
              }
              function ua(Le) {
                Le && ct();
                var Nr = fo(De());
                return e.Debug.assert(Nr.kind === 15, "Template head has wrong token kind"), Nr;
              }
              function Xn() {
                var Le = fo(De());
                return e.Debug.assert(Le.kind === 16 || Le.kind === 17, "Template fragment has wrong token kind"), Le;
              }
              function jr(Le) {
                var Nr = Le === 14 || Le === 17, ri = D.getTokenText();
                return ri.substring(1, ri.length - (D.isUnterminated() ? 0 : Nr ? 1 : 2));
              }
              function fo(Le) {
                var Nr = Ue(), ri = e.isTemplateLiteralKind(Le) ? ge.createTemplateLiteralLikeNode(Le, D.getTokenValue(), jr(Le), D.getTokenFlags() & 2048) : Le === 8 ? ge.createNumericLiteral(D.getTokenValue(), D.getNumericLiteralFlags()) : Le === 10 ? ge.createStringLiteral(D.getTokenValue(), void 0, D.hasExtendedUnicodeEscape()) : e.isLiteralKind(Le) ? ge.createLiteralLikeNode(Le, D.getTokenValue()) : e.Debug.fail();
                return D.hasExtendedUnicodeEscape() && (ri.hasExtendedUnicodeEscape = true), D.isUnterminated() && (ri.isUnterminated = true), Tr(), Bi(ri, Nr);
              }
              function xs() {
                return ds(true, e.Diagnostics.Type_expected);
              }
              function Fo() {
                if (!D.hasPrecedingLineBreak() && Li() === 29) return js(20, Aa, 29, 31);
              }
              function ko() {
                var Le = Ue();
                return Bi(ge.createTypeReferenceNode(xs(), Fo()), Le);
              }
              function Ao(Le) {
                switch (Le.kind) {
                  case 178:
                    return e.nodeIsMissing(Le.typeName);
                  case 179:
                  case 180: {
                    var Nr = Le, ri = Nr.parameters, di = Nr.type;
                    return Qs(ri) || Ao(di);
                  }
                  case 191:
                    return Ao(Le.type);
                  default:
                    return false;
                }
              }
              function Ms(Le) {
                return Tr(), Bi(ge.createTypePredicateNode(void 0, Le, Aa()), Le.pos);
              }
              function Bs() {
                var Le = Ue();
                return Tr(), Bi(ge.createThisTypeNode(), Le);
              }
              function xc() {
                var Le = Ue();
                return Tr(), Bi(ge.createJSDocAllType(), Le);
              }
              function su() {
                var Le = Ue();
                return Tr(), Bi(ge.createJSDocNonNullableType(yc(), false), Le);
              }
              function tl() {
                var Le = Ue();
                return Tr(), De() === 27 || De() === 19 || De() === 21 || De() === 31 || De() === 63 || De() === 51 ? Bi(ge.createJSDocUnknownType(), Le) : Bi(ge.createJSDocNullableType(Aa(), false), Le);
              }
              function Zc() {
                var Le = Ue(), Nr = fr();
                if (Rt(v)) {
                  Tr();
                  var ri = Ei(36), di = vc(58, false);
                  return wr(Bi(ge.createJSDocFunctionType(ri, di), Le), Nr);
                }
                return Bi(ge.createTypeReferenceNode(Rn(), void 0), Le);
              }
              function Rf() {
                var Le = Ue(), Nr;
                return (De() === 108 || De() === 103) && (Nr = Rn(), ui(58)), Bi(ge.createParameterDeclaration(void 0, void 0, void 0, Nr, void 0, al(), void 0), Le);
              }
              function al() {
                D.setInJSDocType(true);
                var Le = Ue();
                if (at(141)) {
                  var Nr = ge.createJSDocNamepathType(void 0);
                  e: for (; ; ) switch (De()) {
                    case 19:
                    case 1:
                    case 27:
                    case 5:
                      break e;
                    default:
                      vi();
                  }
                  return D.setInJSDocType(false), Bi(Nr, Le);
                }
                var ri = at(25), di = gu();
                return D.setInJSDocType(false), ri && (di = Bi(ge.createJSDocVariadicType(di), Le)), De() === 63 ? (Tr(), Bi(ge.createJSDocOptionalType(di), Le)) : di;
              }
              function Jo() {
                var Le = Ue();
                ui(112);
                var Nr = ds(true), ri = D.hasPrecedingLineBreak() ? void 0 : m_();
                return Bi(ge.createTypeQueryNode(Nr, ri), Le);
              }
              function eu() {
                var Le = Ue(), Nr = Fc(), ri = eo(), di, Mi;
                at(94) && (Xr() || !qs() ? di = Aa() : Mi = kp());
                var st = at(63) ? Aa() : void 0, ra = ge.createTypeParameterDeclaration(Nr, ri, di, st);
                return ra.expression = Mi, Bi(ra, Le);
              }
              function Ws() {
                if (De() === 29) return js(19, eu, 29, 31);
              }
              function pu(Le) {
                return De() === 25 || Hc() || e.isModifierKind(De()) || De() === 59 || Xr(!Le);
              }
              function Uu(Le) {
                var Nr = Ol(e.Diagnostics.Private_identifiers_cannot_be_used_as_parameters);
                return e.getFullWidth(Nr) === 0 && !e.some(Le) && e.isModifierKind(De()) && Tr(), Nr;
              }
              function Ql() {
                return Ki() || De() === 22 || De() === 18;
              }
              function xl(Le) {
                return du(Le);
              }
              function Ya(Le) {
                return du(Le, false);
              }
              function du(Le, Nr) {
                Nr === void 0 && (Nr = true);
                var ri = Ue(), di = fr(), Mi = Le ? Jr(gl) : gl();
                if (De() === 108) {
                  var st = ge.createParameterDeclaration(Mi, void 0, void 0, Kn(true), void 0, va(), void 0);
                  return Mi && Mr(Mi[0], e.Diagnostics.Decorators_may_not_be_applied_to_this_parameters), wr(Bi(st, ri), di);
                }
                var ra = Ne;
                Ne = false;
                var Ta = Fc(), ha = At(25);
                if (!(!Nr && !Ql())) {
                  var Na = wr(Bi(ge.createParameterDeclaration(Mi, Ta, ha, Uu(Ta), At(57), va(), nl()), ri), di);
                  return Ne = ra, Na;
                }
              }
              function vc(Le, Nr) {
                if (Kr(Le, Nr)) return _r(gu);
              }
              function Kr(Le, Nr) {
                return Le === 38 ? (ui(Le), true) : at(58) ? true : Nr && De() === 38 ? (Ar(e.Diagnostics._0_expected, e.tokenToString(58)), Tr(), true) : false;
              }
              function _i(Le, Nr) {
                var ri = Wr(), di = mr();
                Di(!!(Le & 1)), Xi(!!(Le & 2));
                var Mi = Le & 32 ? hs(17, Rf) : hs(16, function() {
                  return Nr ? xl(di) : Ya(di);
                });
                return Di(ri), Xi(di), Mi;
              }
              function Ei(Le) {
                if (!ui(20)) return ps();
                var Nr = _i(Le, true);
                return ui(21), Nr;
              }
              function tt() {
                at(27) || pn();
              }
              function kt(Le) {
                var Nr = Ue(), ri = fr();
                Le === 175 && ui(103);
                var di = Ws(), Mi = Ei(4), st = vc(58, true);
                tt();
                var ra = Le === 174 ? ge.createCallSignature(di, Mi, st) : ge.createConstructSignature(di, Mi, st);
                return wr(Bi(ra, Nr), ri);
              }
              function bt() {
                return De() === 22 && Rt(ia);
              }
              function ia() {
                if (Tr(), De() === 25 || De() === 23) return true;
                if (e.isModifierKind(De())) {
                  if (Tr(), Fi()) return true;
                } else if (Fi()) Tr();
                else return false;
                return De() === 58 || De() === 27 ? true : De() !== 57 ? false : (Tr(), De() === 58 || De() === 27 || De() === 23);
              }
              function Xt(Le, Nr, ri, di) {
                var Mi = js(16, function() {
                  return xl(false);
                }, 22, 23), st = va();
                tt();
                var ra = ge.createIndexSignature(ri, di, Mi, st);
                return wr(Bi(ra, Le), Nr);
              }
              function Za(Le, Nr, ri) {
                var di = En(), Mi = At(57), st;
                if (De() === 20 || De() === 29) {
                  var ra = Ws(), Ta = Ei(4), ha = vc(58, true);
                  st = ge.createMethodSignature(ri, di, Mi, ra, Ta, ha);
                } else {
                  var ha = va();
                  st = ge.createPropertySignature(ri, di, Mi, ha), De() === 63 && (st.initializer = nl());
                }
                return tt(), wr(Bi(st, Le), Nr);
              }
              function bn() {
                if (De() === 20 || De() === 29 || De() === 136 || De() === 149) return true;
                for (var Le = false; e.isModifierKind(De()); ) Le = true, Tr();
                return De() === 22 ? true : (Da() && (Le = true, Tr()), Le ? De() === 20 || De() === 29 || De() === 57 || De() === 58 || De() === 27 || ka() : false);
              }
              function _a() {
                if (De() === 20 || De() === 29) return kt(174);
                if (De() === 103 && Rt(qa)) return kt(175);
                var Le = Ue(), Nr = fr(), ri = Fc();
                return Ko(136) ? Gu(Le, Nr, void 0, ri, 172) : Ko(149) ? Gu(Le, Nr, void 0, ri, 173) : bt() ? Xt(Le, Nr, void 0, ri) : Za(Le, Nr, ri);
              }
              function qa() {
                return Tr(), De() === 20 || De() === 29;
              }
              function rn() {
                return Tr() === 24;
              }
              function jn() {
                switch (Tr()) {
                  case 20:
                  case 29:
                  case 24:
                    return true;
                }
                return false;
              }
              function Mo() {
                var Le = Ue();
                return Bi(ge.createTypeLiteralNode(ho()), Le);
              }
              function ho() {
                var Le;
                return ui(18) ? (Le = Qi(4, _a), ui(19)) : Le = ps(), Le;
              }
              function gs() {
                return Tr(), De() === 39 || De() === 40 ? Tr() === 145 : (De() === 145 && Tr(), De() === 22 && Qe() && Tr() === 101);
              }
              function Se() {
                var Le = Ue(), Nr = Rn();
                ui(101);
                var ri = Aa();
                return Bi(ge.createTypeParameterDeclaration(void 0, Nr, ri, void 0), Le);
              }
              function hr() {
                var Le = Ue();
                ui(18);
                var Nr;
                (De() === 145 || De() === 39 || De() === 40) && (Nr = ai(), Nr.kind !== 145 && ui(145)), ui(22);
                var ri = Se(), di = at(127) ? Aa() : void 0;
                ui(23);
                var Mi;
                (De() === 57 || De() === 39 || De() === 40) && (Mi = ai(), Mi.kind !== 57 && ui(57));
                var st = va();
                pn();
                var ra = Qi(4, _a);
                return ui(19), Bi(ge.createMappedTypeNode(Nr, ri, di, Mi, st, ra), Le);
              }
              function Or() {
                var Le = Ue();
                if (at(25)) return Bi(ge.createRestTypeNode(Aa()), Le);
                var Nr = Aa();
                if (e.isJSDocNullableType(Nr) && Nr.pos === Nr.type.pos) {
                  var ri = ge.createOptionalTypeNode(Nr.type);
                  return e.setTextRange(ri, Nr), ri.flags = Nr.flags, ri;
                }
                return Nr;
              }
              function ki() {
                return Tr() === 58 || De() === 57 && Tr() === 58;
              }
              function dt() {
                return De() === 25 ? e.tokenIsIdentifierOrKeyword(Tr()) && ki() : e.tokenIsIdentifierOrKeyword(De()) && ki();
              }
              function la() {
                if (Rt(dt)) {
                  var Le = Ue(), Nr = fr(), ri = At(25), di = Rn(), Mi = At(57);
                  ui(58);
                  var st = Or(), ra = ge.createNamedTupleMember(ri, di, Mi, st);
                  return wr(Bi(ra, Le), Nr);
                }
                return Or();
              }
              function wa() {
                var Le = Ue();
                return Bi(ge.createTupleTypeNode(js(21, la, 22, 23)), Le);
              }
              function On() {
                var Le = Ue();
                ui(20);
                var Nr = Aa();
                return ui(21), Bi(ge.createParenthesizedType(Nr), Le);
              }
              function No() {
                var Le;
                if (De() === 126) {
                  var Nr = Ue();
                  Tr();
                  var ri = Bi(ge.createToken(126), Nr);
                  Le = Cn([ri], Nr);
                }
                return Le;
              }
              function jo() {
                var Le = Ue(), Nr = fr(), ri = No(), di = at(103), Mi = Ws(), st = Ei(4), ra = vc(38, false), Ta = di ? ge.createConstructorTypeNode(ri, Mi, st, ra) : ge.createFunctionTypeNode(Mi, st, ra);
                return di || (Ta.modifiers = ri), wr(Bi(Ta, Le), Nr);
              }
              function po() {
                var Le = ai();
                return De() === 24 ? void 0 : Le;
              }
              function Gn(Le) {
                var Nr = Ue();
                Le && Tr();
                var ri = De() === 110 || De() === 95 || De() === 104 ? ai() : fo(De());
                return Le && (ri = Bi(ge.createPrefixUnaryExpression(40, ri), Nr)), Bi(ge.createLiteralTypeNode(ri), Nr);
              }
              function $n() {
                return Tr(), De() === 100;
              }
              function Ho() {
                var Le = Ue(), Nr = D.getTokenPos();
                ui(18);
                var ri = D.hasPrecedingLineBreak();
                ui(129), ui(58);
                var di = Ha(true);
                if (!ui(19)) {
                  var Mi = e.lastOrUndefined(_e);
                  Mi && Mi.code === e.Diagnostics._0_expected.code && e.addRelatedInfo(Mi, e.createDetachedDiagnostic(Re, Nr, 1, e.Diagnostics.The_parser_expected_to_find_a_1_to_match_the_0_token_here, "{", "}"));
                }
                return Bi(ge.createImportTypeAssertionContainer(di, ri), Le);
              }
              function Zo() {
                ze |= 2097152;
                var Le = Ue(), Nr = at(112);
                ui(100), ui(20);
                var ri = Aa(), di;
                at(27) && (di = Ho()), ui(21);
                var Mi = at(24) ? xs() : void 0, st = Fo();
                return Bi(ge.createImportTypeNode(ri, di, Mi, st, Nr), Le);
              }
              function Es() {
                return Tr(), De() === 8 || De() === 9;
              }
              function yc() {
                switch (De()) {
                  case 130:
                  case 155:
                  case 150:
                  case 147:
                  case 158:
                  case 151:
                  case 133:
                  case 153:
                  case 143:
                  case 148:
                    return Ii(po) || ko();
                  case 66:
                    D.reScanAsteriskEqualsToken();
                  case 41:
                    return xc();
                  case 60:
                    D.reScanQuestionToken();
                  case 57:
                    return tl();
                  case 98:
                    return Zc();
                  case 53:
                    return su();
                  case 14:
                  case 10:
                  case 8:
                  case 9:
                  case 110:
                  case 95:
                  case 104:
                    return Gn();
                  case 40:
                    return Rt(Es) ? Gn(true) : ko();
                  case 114:
                    return ai();
                  case 108: {
                    var Le = Bs();
                    return De() === 139 && !D.hasPrecedingLineBreak() ? Ms(Le) : Le;
                  }
                  case 112:
                    return Rt($n) ? Zo() : Jo();
                  case 18:
                    return Rt(gs) ? hr() : Mo();
                  case 22:
                    return wa();
                  case 20:
                    return On();
                  case 100:
                    return Zo();
                  case 128:
                    return Rt(Pu) ? sd() : ko();
                  case 15:
                    return qi();
                  default:
                    return ko();
                }
              }
              function Xr(Le) {
                switch (De()) {
                  case 130:
                  case 155:
                  case 150:
                  case 147:
                  case 158:
                  case 133:
                  case 145:
                  case 151:
                  case 154:
                  case 114:
                  case 153:
                  case 104:
                  case 108:
                  case 112:
                  case 143:
                  case 18:
                  case 22:
                  case 29:
                  case 51:
                  case 50:
                  case 103:
                  case 10:
                  case 8:
                  case 9:
                  case 110:
                  case 95:
                  case 148:
                  case 41:
                  case 57:
                  case 53:
                  case 25:
                  case 137:
                  case 100:
                  case 128:
                  case 14:
                  case 15:
                    return true;
                  case 98:
                    return !Le;
                  case 40:
                    return !Le && Rt(Es);
                  case 20:
                    return !Le && Rt(Ls);
                  default:
                    return Fi();
                }
              }
              function Ls() {
                return Tr(), De() === 21 || pu(false) || Xr();
              }
              function Ic() {
                for (var Le = Ue(), Nr = yc(); !D.hasPrecedingLineBreak(); ) switch (De()) {
                  case 53:
                    Tr(), Nr = Bi(ge.createJSDocNonNullableType(Nr, true), Le);
                    break;
                  case 57:
                    if (Rt(br)) return Nr;
                    Tr(), Nr = Bi(ge.createJSDocNullableType(Nr, true), Le);
                    break;
                  case 22:
                    if (ui(22), Xr()) {
                      var ri = Aa();
                      ui(23), Nr = Bi(ge.createIndexedAccessTypeNode(Nr, ri), Le);
                    } else ui(23), Nr = Bi(ge.createArrayTypeNode(Nr), Le);
                    break;
                  default:
                    return Nr;
                }
                return Nr;
              }
              function zu(Le) {
                var Nr = Ue();
                return ui(Le), Bi(ge.createTypeOperatorNode(Le, vp()), Nr);
              }
              function vf() {
                if (at(94)) {
                  var Le = pi(Aa);
                  if (xe() || De() !== 57) return Le;
                }
              }
              function P_() {
                var Le = Ue(), Nr = eo(), ri = Ii(vf), di = ge.createTypeParameterDeclaration(void 0, Nr, ri);
                return Bi(di, Le);
              }
              function El() {
                var Le = Ue();
                return ui(137), Bi(ge.createInferTypeNode(P_()), Le);
              }
              function vp() {
                var Le = De();
                switch (Le) {
                  case 140:
                  case 154:
                  case 145:
                    return zu(Le);
                  case 137:
                    return El();
                }
                return _r(Ic);
              }
              function oo(Le) {
                if (Cl()) {
                  var Nr = jo(), ri = void 0;
                  return e.isFunctionTypeNode(Nr) ? ri = Le ? e.Diagnostics.Function_type_notation_must_be_parenthesized_when_used_in_a_union_type : e.Diagnostics.Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type : ri = Le ? e.Diagnostics.Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type : e.Diagnostics.Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type, Mr(Nr, ri), Nr;
                }
              }
              function I_(Le, Nr, ri) {
                var di = Ue(), Mi = Le === 51, st = at(Le), ra = st && oo(Mi) || Nr();
                if (De() === Le || st) {
                  for (var Ta = [ra]; at(Le); ) Ta.push(oo(Mi) || Nr());
                  ra = Bi(ri(Cn(Ta, di)), di);
                }
                return ra;
              }
              function yp() {
                return I_(50, vp, ge.createIntersectionTypeNode);
              }
              function Yl() {
                return I_(51, yp, ge.createUnionTypeNode);
              }
              function Bf() {
                return Tr(), De() === 103;
              }
              function Cl() {
                return De() === 29 || De() === 20 && Rt(hp) ? true : De() === 103 || De() === 126 && Rt(Bf);
              }
              function c_() {
                if (e.isModifierKind(De()) && Fc(), Fi() || De() === 108) return Tr(), true;
                if (De() === 22 || De() === 18) {
                  var Le = _e.length;
                  return Ol(), Le === _e.length;
                }
                return false;
              }
              function hp() {
                return Tr(), !!(De() === 21 || De() === 25 || c_() && (De() === 58 || De() === 27 || De() === 57 || De() === 63 || De() === 21 && (Tr(), De() === 38)));
              }
              function gu() {
                var Le = Ue(), Nr = Fi() && Ii(Dp), ri = Aa();
                return Nr ? Bi(ge.createTypePredicateNode(void 0, Nr, ri), Le) : ri;
              }
              function Dp() {
                var Le = eo();
                if (De() === 139 && !D.hasPrecedingLineBreak()) return Tr(), Le;
              }
              function sd() {
                var Le = Ue(), Nr = $a(128), ri = De() === 108 ? Bs() : eo(), di = at(139) ? Aa() : void 0;
                return Bi(ge.createTypePredicateNode(Nr, ri, di), Le);
              }
              function Aa() {
                if (Er & 40960) return et(40960, Aa);
                if (Cl()) return jo();
                var Le = Ue(), Nr = Yl();
                if (!xe() && !D.hasPrecedingLineBreak() && at(94)) {
                  var ri = pi(Aa);
                  ui(57);
                  var di = _r(Aa);
                  ui(58);
                  var Mi = _r(Aa);
                  return Bi(ge.createConditionalTypeNode(Nr, ri, di, Mi), Le);
                }
                return Nr;
              }
              function va() {
                return at(58) ? Aa() : void 0;
              }
              function Cu() {
                switch (De()) {
                  case 108:
                  case 106:
                  case 104:
                  case 110:
                  case 95:
                  case 8:
                  case 9:
                  case 10:
                  case 14:
                  case 15:
                  case 20:
                  case 22:
                  case 18:
                  case 98:
                  case 84:
                  case 103:
                  case 43:
                  case 68:
                  case 79:
                    return true;
                  case 100:
                    return Rt(jn);
                  default:
                    return Fi();
                }
              }
              function qs() {
                if (Cu()) return true;
                switch (De()) {
                  case 39:
                  case 40:
                  case 54:
                  case 53:
                  case 89:
                  case 112:
                  case 114:
                  case 45:
                  case 46:
                  case 29:
                  case 132:
                  case 125:
                  case 80:
                    return true;
                  default:
                    return xp() ? true : Fi();
                }
              }
              function cd() {
                return De() !== 18 && De() !== 98 && De() !== 84 && De() !== 59 && qs();
              }
              function ns() {
                var Le = vr();
                Le && wi(false);
                for (var Nr = Ue(), ri = hc(), di; di = At(27); ) ri = M_(ri, di, hc(), Nr);
                return Le && wi(true), ri;
              }
              function nl() {
                return at(63) ? hc() : void 0;
              }
              function hc() {
                if (es()) return Jf();
                var Le = ud() || bp();
                if (Le) return Le;
                var Nr = Ue(), ri = O_(0);
                return ri.kind === 79 && De() === 38 ? w_(Nr, ri, void 0) : e.isLeftHandSideExpression(ri) && e.isAssignmentOperator(Ui()) ? M_(ri, ai(), hc(), Nr) : jf(ri, Nr);
              }
              function es() {
                return De() === 125 ? Wr() ? true : Rt(so) : false;
              }
              function u_() {
                return Tr(), !D.hasPrecedingLineBreak() && Fi();
              }
              function Jf() {
                var Le = Ue();
                return Tr(), !D.hasPrecedingLineBreak() && (De() === 41 || qs()) ? Bi(ge.createYieldExpression(At(41), hc()), Le) : Bi(ge.createYieldExpression(void 0, void 0), Le);
              }
              function w_(Le, Nr, ri) {
                e.Debug.assert(De() === 38, "parseSimpleArrowFunctionExpression should only have been called if we had a =>");
                var di = ge.createParameterDeclaration(void 0, void 0, void 0, Nr, void 0, void 0, void 0);
                Bi(di, Nr.pos);
                var Mi = Cn([di], di.pos, di.end), st = $a(38), ra = _d(!!ri), Ta = ge.createArrowFunction(ri, void 0, Mi, void 0, st, ra);
                return ii(Bi(Ta, Le));
              }
              function ud() {
                var Le = ku();
                if (Le !== 0) return Le === 1 ? Tp(true) : Ii(fd);
              }
              function ku() {
                return De() === 20 || De() === 29 || De() === 131 ? Rt(ld) : De() === 38 ? 1 : 0;
              }
              function ld() {
                if (De() === 131 && (Tr(), D.hasPrecedingLineBreak() || De() !== 20 && De() !== 29)) return 0;
                var Le = De(), Nr = Tr();
                if (Le === 20) {
                  if (Nr === 21) {
                    var ri = Tr();
                    switch (ri) {
                      case 38:
                      case 58:
                      case 18:
                        return 1;
                      default:
                        return 0;
                    }
                  }
                  if (Nr === 22 || Nr === 18) return 2;
                  if (Nr === 25) return 1;
                  if (e.isModifierKind(Nr) && Nr !== 131 && Rt(Qe)) return Rt(function() {
                    return Tr() === 127;
                  }) ? 0 : 1;
                  if (!Fi() && Nr !== 108) return 0;
                  switch (Tr()) {
                    case 58:
                      return 1;
                    case 57:
                      return Tr(), De() === 58 || De() === 27 || De() === 63 || De() === 21 ? 1 : 0;
                    case 27:
                    case 63:
                    case 21:
                      return 2;
                  }
                  return 0;
                } else {
                  if (e.Debug.assert(Le === 29), !Fi()) return 0;
                  if (Ie === 1) {
                    var di = Rt(function() {
                      var Mi = Tr();
                      if (Mi === 94) {
                        var st = Tr();
                        switch (st) {
                          case 63:
                          case 31:
                            return false;
                          default:
                            return true;
                        }
                      } else if (Mi === 27 || Mi === 63) return true;
                      return false;
                    });
                    return di ? 1 : 0;
                  }
                  return 2;
                }
              }
              function fd() {
                var Le = D.getTokenPos();
                if (!(Br != null && Br.has(Le))) {
                  var Nr = Tp(false);
                  return Nr || (Br || (Br = new e.Set())).add(Le), Nr;
                }
              }
              function bp() {
                if (De() === 131 && Rt(Sp) === 1) {
                  var Le = Ue(), Nr = Hu(), ri = O_(0);
                  return w_(Le, ri, Nr);
                }
              }
              function Sp() {
                if (De() === 131) {
                  if (Tr(), D.hasPrecedingLineBreak() || De() === 38) return 0;
                  var Le = O_(0);
                  if (!D.hasPrecedingLineBreak() && Le.kind === 79 && De() === 38) return 1;
                }
                return 0;
              }
              function Tp(Le) {
                var Nr = Ue(), ri = fr(), di = Hu(), Mi = e.some(di, e.isAsyncModifier) ? 2 : 0, st = Ws(), ra;
                if (ui(20)) {
                  if (Le) ra = _i(Mi, Le);
                  else {
                    var Ta = _i(Mi, Le);
                    if (!Ta) return;
                    ra = Ta;
                  }
                  if (!ui(21) && !Le) return;
                } else {
                  if (!Le) return;
                  ra = ps();
                }
                var ha = vc(58, false);
                if (!(ha && !Le && Ao(ha))) {
                  for (var Na = ha; (Na == null ? void 0 : Na.kind) === 191; ) Na = Na.type;
                  var In = Na && e.isJSDocFunctionType(Na);
                  if (!(!Le && De() !== 38 && (In || De() !== 18))) {
                    var qo = De(), co = $a(38), ts = qo === 38 || qo === 18 ? _d(e.some(di, e.isAsyncModifier)) : eo(), vs = ge.createArrowFunction(di, st, ra, ha, co, ts);
                    return wr(Bi(vs, Nr), ri);
                  }
                }
              }
              function _d(Le) {
                if (De() === 18) return Cc(Le ? 2 : 0);
                if (De() !== 26 && De() !== 98 && De() !== 84 && Ku() && !cd()) return Cc(16 | (Le ? 2 : 0));
                var Nr = Ne;
                Ne = false;
                var ri = Le ? Jr(hc) : ti(hc);
                return Ne = Nr, ri;
              }
              function jf(Le, Nr) {
                var ri = At(57);
                if (!ri) return Le;
                var di;
                return Bi(ge.createConditionalExpression(Le, ri, et(fe, hc), di = $a(58), e.nodeIsPresent(di) ? hc() : kn(79, false, e.Diagnostics._0_expected, e.tokenToString(58))), Nr);
              }
              function O_(Le) {
                var Nr = Ue(), ri = kp();
                return pd(Le, ri, Nr);
              }
              function F_(Le) {
                return Le === 101 || Le === 160;
              }
              function pd(Le, Nr, ri) {
                for (; ; ) {
                  Ui();
                  var di = e.getBinaryOperatorPrecedence(De()), Mi = De() === 42 ? di >= Le : di > Le;
                  if (!Mi || De() === 101 && Je()) break;
                  if (De() === 127) {
                    if (D.hasPrecedingLineBreak()) break;
                    Tr(), Nr = Ep(Nr, Aa());
                  } else Nr = M_(Nr, ai(), O_(di), ri);
                }
                return Nr;
              }
              function xp() {
                return Je() && De() === 101 ? false : e.getBinaryOperatorPrecedence(De()) > 0;
              }
              function M_(Le, Nr, ri, di) {
                return Bi(ge.createBinaryExpression(Le, Nr, ri), di);
              }
              function Ep(Le, Nr) {
                return Bi(ge.createAsExpression(Le, Nr), Le.pos);
              }
              function ol() {
                var Le = Ue();
                return Bi(ge.createPrefixUnaryExpression(De(), Vr(mu)), Le);
              }
              function Au() {
                var Le = Ue();
                return Bi(ge.createDeleteExpression(Vr(mu)), Le);
              }
              function ru() {
                var Le = Ue();
                return Bi(ge.createTypeOfExpression(Vr(mu)), Le);
              }
              function yf() {
                var Le = Ue();
                return Bi(ge.createVoidExpression(Vr(mu)), Le);
              }
              function Cp() {
                return De() === 132 ? mr() ? true : Rt(so) : false;
              }
              function dd() {
                var Le = Ue();
                return Bi(ge.createAwaitExpression(Vr(mu)), Le);
              }
              function kp() {
                if (gd()) {
                  var Le = Ue(), Nr = hf();
                  return De() === 42 ? pd(e.getBinaryOperatorPrecedence(De()), Nr, Le) : Nr;
                }
                var ri = De(), di = mu();
                if (De() === 42) {
                  var Le = e.skipTrivia(Ee, di.pos), Mi = di.end;
                  di.kind === 211 ? nr(Le, Mi, e.Diagnostics.A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses) : nr(Le, Mi, e.Diagnostics.An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses, e.tokenToString(ri));
                }
                return di;
              }
              function mu() {
                switch (De()) {
                  case 39:
                  case 40:
                  case 54:
                  case 53:
                    return ol();
                  case 89:
                    return Au();
                  case 112:
                    return ru();
                  case 114:
                    return yf();
                  case 29:
                    return qu();
                  case 132:
                    if (Cp()) return dd();
                  default:
                    return hf();
                }
              }
              function gd() {
                switch (De()) {
                  case 39:
                  case 40:
                  case 54:
                  case 53:
                  case 89:
                  case 112:
                  case 114:
                  case 132:
                    return false;
                  case 29:
                    if (Ie !== 1) return false;
                  default:
                    return true;
                }
              }
              function hf() {
                if (De() === 45 || De() === 46) {
                  var Le = Ue();
                  return Bi(ge.createPrefixUnaryExpression(De(), Vr($l)), Le);
                } else if (Ie === 1 && De() === 29 && Rt(S)) return l_(true);
                var Nr = $l();
                if (e.Debug.assert(e.isLeftHandSideExpression(Nr)), (De() === 45 || De() === 46) && !D.hasPrecedingLineBreak()) {
                  var ri = De();
                  return Tr(), Bi(ge.createPostfixUnaryExpression(Nr, ri), Nr.pos);
                }
                return Nr;
              }
              function $l() {
                var Le = Ue(), Nr;
                return De() === 100 ? Rt(qa) ? (ze |= 2097152, Nr = ai()) : Rt(rn) ? (Tr(), Tr(), Nr = Bi(ge.createMetaProperty(100, Rn()), Le), ze |= 4194304) : Nr = Uf() : Nr = De() === 106 ? L_() : Uf(), Ps(Le, Nr);
              }
              function Uf() {
                var Le = Ue(), Nr = vu();
                return Ec(Le, Nr, true);
              }
              function L_() {
                var Le = Ue(), Nr = ai();
                if (De() === 29) {
                  var ri = Ue(), di = Ii(Gc);
                  di !== void 0 && nr(ri, Ue(), e.Diagnostics.super_may_not_use_type_arguments);
                }
                return De() === 20 || De() === 24 || De() === 22 ? Nr : ($a(24, e.Diagnostics.super_must_be_followed_by_an_argument_list_or_member_access), Bi(ge.createPropertyAccessExpression(Nr, ce(true, true)), Le));
              }
              function l_(Le, Nr, ri) {
                var di = Ue(), Mi = Zl(Le), st;
                if (Mi.kind === 280) {
                  var ra = ks(Mi), Ta = void 0, ha = ra[ra.length - 1];
                  if ((ha == null ? void 0 : ha.kind) === 278 && !l(ha.openingElement.tagName, ha.closingElement.tagName) && l(Mi.tagName, ha.closingElement.tagName)) {
                    var Na = ha.children.end, In = Bi(ge.createJsxElement(ha.openingElement, ha.children, Bi(ge.createJsxClosingElement(Bi(ge.createIdentifier(""), Na, Na)), Na, Na)), ha.openingElement.pos, Na);
                    ra = Cn(Ve(Ve([], ra.slice(0, ra.length - 1), true), [In], false), ra.pos, Na), Ta = ha.closingElement;
                  } else Ta = Al(Mi, Le), l(Mi.tagName, Ta.tagName) || (ri && e.isJsxOpeningElement(ri) && l(Ta.tagName, ri.tagName) ? Mr(Mi.tagName, e.Diagnostics.JSX_element_0_has_no_corresponding_closing_tag, e.getTextOfNodeFromSourceText(Ee, Mi.tagName)) : Mr(Ta.tagName, e.Diagnostics.Expected_corresponding_JSX_closing_tag_for_0, e.getTextOfNodeFromSourceText(Ee, Mi.tagName)));
                  st = Bi(ge.createJsxElement(Mi, ra, Ta), di);
                } else Mi.kind === 283 ? st = Bi(ge.createJsxFragment(Mi, ks(Mi), wc(Le)), di) : (e.Debug.assert(Mi.kind === 279), st = Mi);
                if (Le && De() === 29) {
                  var qo = typeof Nr > "u" ? st.pos : Nr, co = Ii(function() {
                    return l_(true, qo);
                  });
                  if (co) {
                    var ts = kn(27, false);
                    return e.setTextRangePosWidth(ts, co.pos, 0), nr(e.skipTrivia(Ee, qo), co.end, e.Diagnostics.JSX_expressions_must_have_one_parent_element), Bi(ge.createBinaryExpression(st, ts, co), di);
                  }
                }
                return st;
              }
              function f_() {
                var Le = Ue(), Nr = ge.createJsxText(D.getTokenValue(), ye === 12);
                return ye = D.scanJsxToken(), Bi(Nr, Le);
              }
              function md(Le, Nr) {
                switch (Nr) {
                  case 1:
                    if (e.isJsxOpeningFragment(Le)) Mr(Le, e.Diagnostics.JSX_fragment_has_no_corresponding_closing_tag);
                    else {
                      var ri = Le.tagName, di = e.skipTrivia(Ee, ri.pos);
                      nr(di, ri.end, e.Diagnostics.JSX_element_0_has_no_corresponding_closing_tag, e.getTextOfNodeFromSourceText(Ee, Le.tagName));
                    }
                    return;
                  case 30:
                  case 7:
                    return;
                  case 11:
                  case 12:
                    return f_();
                  case 18:
                    return kl(false);
                  case 29:
                    return l_(false, void 0, Le);
                  default:
                    return e.Debug.assertNever(Nr);
                }
              }
              function ks(Le) {
                var Nr = [], ri = Ue(), di = Ye;
                for (Ye |= 1 << 14; ; ) {
                  var Mi = md(Le, ye = D.reScanJsxToken());
                  if (!Mi || (Nr.push(Mi), e.isJsxOpeningElement(Le) && (Mi == null ? void 0 : Mi.kind) === 278 && !l(Mi.openingElement.tagName, Mi.closingElement.tagName) && l(Le.tagName, Mi.closingElement.tagName))) break;
                }
                return Ye = di, Cn(Nr, ri);
              }
              function Wu() {
                var Le = Ue();
                return Bi(ge.createJsxAttributes(Qi(13, __)), Le);
              }
              function Zl(Le) {
                var Nr = Ue();
                if (ui(29), De() === 31) return xt(), Bi(ge.createJsxOpeningFragment(), Nr);
                var ri = R_(), di = (Er & 262144) === 0 ? m_() : void 0, Mi = Wu(), st;
                return De() === 31 ? (xt(), st = ge.createJsxOpeningElement(ri, di, Mi)) : (ui(43), ui(31, void 0, false) && (Le ? Tr() : xt()), st = ge.createJsxSelfClosingElement(ri, di, Mi)), Bi(st, Nr);
              }
              function R_() {
                var Le = Ue();
                Mt();
                for (var Nr = De() === 108 ? ai() : Rn(); at(24); ) Nr = Bi(ge.createPropertyAccessExpression(Nr, ce(true, false)), Le);
                return Nr;
              }
              function kl(Le) {
                var Nr = Ue();
                if (!!ui(18)) {
                  var ri, di;
                  return De() !== 19 && (ri = At(25), di = ns()), Le ? ui(19) : ui(19, void 0, false) && xt(), Bi(ge.createJsxExpression(ri, di), Nr);
                }
              }
              function __() {
                if (De() === 18) return zd();
                Mt();
                var Le = Ue();
                return Bi(ge.createJsxAttribute(Rn(), De() !== 63 ? void 0 : ut() === 10 ? ga() : kl(true)), Le);
              }
              function zd() {
                var Le = Ue();
                ui(18), ui(25);
                var Nr = ns();
                return ui(19), Bi(ge.createJsxSpreadAttribute(Nr), Le);
              }
              function Al(Le, Nr) {
                var ri = Ue();
                ui(30);
                var di = R_();
                return ui(31, void 0, false) && (Nr || !l(Le.tagName, di) ? Tr() : xt()), Bi(ge.createJsxClosingElement(di), ri);
              }
              function wc(Le) {
                var Nr = Ue();
                return ui(30), e.tokenIsIdentifierOrKeyword(De()) && Mr(R_(), e.Diagnostics.Expected_corresponding_closing_tag_for_JSX_fragment), ui(31, void 0, false) && (Le ? Tr() : xt()), Bi(ge.createJsxJsxClosingFragment(), Nr);
              }
              function qu() {
                var Le = Ue();
                ui(29);
                var Nr = Aa();
                ui(31);
                var ri = mu();
                return Bi(ge.createTypeAssertion(Nr, ri), Le);
              }
              function Vu() {
                return Tr(), e.tokenIsIdentifierOrKeyword(De()) || De() === 22 || Zn();
              }
              function ef() {
                return De() === 28 && Rt(Vu);
              }
              function sl(Le) {
                if (Le.flags & 32) return true;
                if (e.isNonNullExpression(Le)) {
                  for (var Nr = Le.expression; e.isNonNullExpression(Nr) && !(Nr.flags & 32); ) Nr = Nr.expression;
                  if (Nr.flags & 32) {
                    for (; e.isNonNullExpression(Le); ) Le.flags |= 32, Le = Le.expression;
                    return true;
                  }
                }
                return false;
              }
              function p_(Le, Nr, ri) {
                var di = ce(true, true), Mi = ri || sl(Nr), st = Mi ? ge.createPropertyAccessChain(Nr, ri, di) : ge.createPropertyAccessExpression(Nr, di);
                return Mi && e.isPrivateIdentifier(st.name) && Mr(st.name, e.Diagnostics.An_optional_chain_cannot_contain_private_identifiers), Bi(st, Le);
              }
              function Df(Le, Nr, ri) {
                var di;
                if (De() === 23) di = kn(79, true, e.Diagnostics.An_element_access_expression_should_take_an_argument);
                else {
                  var Mi = Wt(ns);
                  e.isStringOrNumericLiteralLike(Mi) && (Mi.text = xn(Mi.text)), di = Mi;
                }
                ui(23);
                var st = ri || sl(Nr) ? ge.createElementAccessChain(Nr, ri, di) : ge.createElementAccessExpression(Nr, di);
                return Bi(st, Le);
              }
              function Ec(Le, Nr, ri) {
                for (; ; ) {
                  var di = void 0, Mi = false;
                  if (ri && ef() ? (di = $a(28), Mi = e.tokenIsIdentifierOrKeyword(De())) : Mi = at(24), Mi) {
                    Nr = p_(Le, Nr, di);
                    continue;
                  }
                  if ((di || !vr()) && at(22)) {
                    Nr = Df(Le, Nr, di);
                    continue;
                  }
                  if (Zn()) {
                    Nr = !di && Nr.kind === 228 ? os(Le, Nr.expression, di, Nr.typeArguments) : os(Le, Nr, di, void 0);
                    continue;
                  }
                  if (!di) {
                    if (De() === 53 && !D.hasPrecedingLineBreak()) {
                      Tr(), Nr = Bi(ge.createNonNullExpression(Nr), Le);
                      continue;
                    }
                    var st = Ii(Gc);
                    if (st) {
                      Nr = Bi(ge.createExpressionWithTypeArguments(Nr, st), Le);
                      continue;
                    }
                  }
                  return Nr;
                }
              }
              function Zn() {
                return De() === 14 || De() === 15;
              }
              function os(Le, Nr, ri, di) {
                var Mi = ge.createTaggedTemplateExpression(Nr, di, De() === 14 ? (ct(), ga()) : yi(true));
                return (ri || Nr.flags & 32) && (Mi.flags |= 32), Mi.questionDotToken = ri, Bi(Mi, Le);
              }
              function Ps(Le, Nr) {
                for (; ; ) {
                  Nr = Ec(Le, Nr, true);
                  var ri = void 0, di = At(28);
                  if (di && (ri = Ii(Gc), Zn())) {
                    Nr = os(Le, Nr, di, ri);
                    continue;
                  }
                  if (ri || De() === 20) {
                    !di && Nr.kind === 228 && (ri = Nr.typeArguments, Nr = Nr.expression);
                    var Mi = d_(), st = di || sl(Nr) ? ge.createCallChain(Nr, di, ri, Mi) : ge.createCallExpression(Nr, ri, Mi);
                    Nr = Bi(st, Le);
                    continue;
                  }
                  if (di) {
                    var ra = kn(79, false, e.Diagnostics.Identifier_expected);
                    Nr = Bi(ge.createPropertyAccessChain(Nr, di, ra), Le);
                  }
                  break;
                }
                return Nr;
              }
              function d_() {
                ui(20);
                var Le = hs(11, Nl);
                return ui(21), Le;
              }
              function Gc() {
                if ((Er & 262144) === 0 && Li() === 29) {
                  Tr();
                  var Le = hs(20, Aa);
                  if (!!ui(31)) return Le && B_() ? Le : void 0;
                }
              }
              function B_() {
                switch (De()) {
                  case 20:
                  case 14:
                  case 15:
                    return true;
                }
                return !qs();
              }
              function vu() {
                switch (De()) {
                  case 8:
                  case 9:
                  case 10:
                  case 14:
                    return ga();
                  case 108:
                  case 106:
                  case 104:
                  case 110:
                  case 95:
                    return ai();
                  case 20:
                    return Gt();
                  case 22:
                    return cl();
                  case 18:
                    return Ut();
                  case 131:
                    if (!Rt(Iu)) break;
                    return Ds();
                  case 84:
                    return tn();
                  case 98:
                    return Ds();
                  case 103:
                    return bs();
                  case 43:
                  case 68:
                    if (Yi() === 13) return ga();
                    break;
                  case 15:
                    return yi(false);
                  case 80:
                    return Co();
                }
                return eo(e.Diagnostics.Expression_expected);
              }
              function Gt() {
                var Le = Ue(), Nr = fr();
                ui(20);
                var ri = Wt(ns);
                return ui(21), wr(Bi(ge.createParenthesizedExpression(ri), Le), Nr);
              }
              function As() {
                var Le = Ue();
                ui(25);
                var Nr = hc();
                return Bi(ge.createSpreadElement(Nr), Le);
              }
              function vn() {
                return De() === 25 ? As() : De() === 27 ? Bi(ge.createOmittedExpression(), Ue()) : hc();
              }
              function Nl() {
                return et(fe, vn);
              }
              function cl() {
                var Le = Ue(), Nr = D.getTokenPos(), ri = ui(22), di = D.hasPrecedingLineBreak(), Mi = hs(15, vn);
                return Vi(22, 23, ri, Nr), Bi(ge.createArrayLiteralExpression(Mi, di), Le);
              }
              function rf() {
                var Le = Ue(), Nr = fr();
                if (At(25)) {
                  var ri = hc();
                  return wr(Bi(ge.createSpreadAssignment(ri), Le), Nr);
                }
                var di = gl(), Mi = Fc();
                if (Ko(136)) return Gu(Le, Nr, di, Mi, 172);
                if (Ko(149)) return Gu(Le, Nr, di, Mi, 173);
                var st = At(41), ra = Fi(), Ta = En(), ha = At(57), Na = At(53);
                if (st || De() === 20 || De() === 29) return pl(Le, Nr, di, Mi, st, Ta, ha, Na);
                var In, qo = ra && De() !== 58;
                if (qo) {
                  var co = At(63), ts = co ? Wt(hc) : void 0;
                  In = ge.createShorthandPropertyAssignment(Ta, ts), In.equalsToken = co;
                } else {
                  ui(58);
                  var vs = Wt(hc);
                  In = ge.createPropertyAssignment(Ta, vs);
                }
                return In.decorators = di, In.modifiers = Mi, In.questionToken = ha, In.exclamationToken = Na, wr(Bi(In, Le), Nr);
              }
              function Ut() {
                var Le = Ue(), Nr = D.getTokenPos(), ri = ui(18), di = D.hasPrecedingLineBreak(), Mi = hs(12, rf, true);
                return Vi(18, 19, ri, Nr), Bi(ge.createObjectLiteralExpression(Mi, di), Le);
              }
              function Ds() {
                var Le = vr();
                wi(false);
                var Nr = Ue(), ri = fr(), di = Fc();
                ui(98);
                var Mi = At(41), st = Mi ? 1 : 0, ra = e.some(di, e.isAsyncModifier) ? 2 : 0, Ta = st && ra ? Ze(bf) : st ? ae(bf) : ra ? Jr(bf) : bf(), ha = Ws(), Na = Ei(st | ra), In = vc(58, false), qo = Cc(st | ra);
                wi(Le);
                var co = ge.createFunctionExpression(di, Mi, Ta, ha, Na, In, qo);
                return wr(Bi(co, Nr), ri);
              }
              function bf() {
                return Ki() ? Pn() : void 0;
              }
              function bs() {
                var Le = Ue();
                if (ui(103), at(24)) {
                  var Nr = Rn();
                  return Bi(ge.createMetaProperty(103, Nr), Le);
                }
                var ri = Ue(), di = Ec(ri, vu(), false), Mi;
                di.kind === 228 && (Mi = di.typeArguments, di = di.expression);
                var st = De() === 20 ? d_() : void 0;
                return Bi(ge.createNewExpression(di, Mi, st), Le);
              }
              function Dc(Le, Nr) {
                var ri = Ue(), di = fr(), Mi = D.getTokenPos(), st = ui(18, Nr);
                if (st || Le) {
                  var ra = D.hasPrecedingLineBreak(), Ta = Qi(1, nc);
                  Vi(18, 19, st, Mi);
                  var ha = wr(Bi(ge.createBlock(Ta, ra), ri), di);
                  return De() === 63 && (Ar(e.Diagnostics.Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_destructuring_assignment_you_might_need_to_wrap_the_the_whole_assignment_in_parentheses), Tr()), ha;
                } else {
                  var Ta = ps();
                  return wr(Bi(ge.createBlock(Ta, void 0), ri), di);
                }
              }
              function Cc(Le, Nr) {
                var ri = Wr();
                Di(!!(Le & 1));
                var di = mr();
                Xi(!!(Le & 2));
                var Mi = Ne;
                Ne = false;
                var st = vr();
                st && wi(false);
                var ra = Dc(!!(Le & 16), Nr);
                return st && wi(true), Ne = Mi, Di(ri), Xi(di), ra;
              }
              function ac() {
                var Le = Ue(), Nr = fr();
                return ui(26), wr(Bi(ge.createEmptyStatement(), Le), Nr);
              }
              function Pl() {
                var Le = Ue(), Nr = fr();
                ui(99);
                var ri = D.getTokenPos(), di = ui(20), Mi = Wt(ns);
                Vi(20, 21, di, ri);
                var st = nc(), ra = at(91) ? nc() : void 0;
                return wr(Bi(ge.createIfStatement(Mi, st, ra), Le), Nr);
              }
              function Il() {
                var Le = Ue(), Nr = fr();
                ui(90);
                var ri = nc();
                ui(115);
                var di = D.getTokenPos(), Mi = ui(20), st = Wt(ns);
                return Vi(20, 21, Mi, di), at(26), wr(Bi(ge.createDoStatement(ri, st), Le), Nr);
              }
              function zf() {
                var Le = Ue(), Nr = fr();
                ui(115);
                var ri = D.getTokenPos(), di = ui(20), Mi = Wt(ns);
                Vi(20, 21, di, ri);
                var st = nc();
                return wr(Bi(ge.createWhileStatement(Mi, st), Le), Nr);
              }
              function ul() {
                var Le = Ue(), Nr = fr();
                ui(97);
                var ri = At(132);
                ui(20);
                var di;
                De() !== 26 && (De() === 113 || De() === 119 || De() === 85 ? di = z_(true) : di = Zt(ns));
                var Mi;
                if (ri ? ui(160) : at(160)) {
                  var st = Wt(hc);
                  ui(21), Mi = ge.createForOfStatement(ri, di, st, nc());
                } else if (at(101)) {
                  var st = Wt(ns);
                  ui(21), Mi = ge.createForInStatement(di, st, nc());
                } else {
                  ui(26);
                  var ra = De() !== 26 && De() !== 21 ? Wt(ns) : void 0;
                  ui(26);
                  var Ta = De() !== 21 ? Wt(ns) : void 0;
                  ui(21), Mi = ge.createForStatement(di, ra, Ta, nc());
                }
                return wr(Bi(Mi, Le), Nr);
              }
              function Nu(Le) {
                var Nr = Ue(), ri = fr();
                ui(Le === 246 ? 81 : 86);
                var di = ka() ? void 0 : eo();
                pn();
                var Mi = Le === 246 ? ge.createBreakStatement(di) : ge.createContinueStatement(di);
                return wr(Bi(Mi, Nr), ri);
              }
              function Us() {
                var Le = Ue(), Nr = fr();
                ui(105);
                var ri = ka() ? void 0 : Wt(ns);
                return pn(), wr(Bi(ge.createReturnStatement(ri), Le), Nr);
              }
              function Ap() {
                var Le = Ue(), Nr = fr();
                ui(116);
                var ri = D.getTokenPos(), di = ui(20), Mi = Wt(ns);
                Vi(20, 21, di, ri);
                var st = Gi(33554432, nc);
                return wr(Bi(ge.createWithStatement(Mi, st), Le), Nr);
              }
              function Wf() {
                var Le = Ue(), Nr = fr();
                ui(82);
                var ri = Wt(ns);
                ui(58);
                var di = Qi(3, nc);
                return wr(Bi(ge.createCaseClause(ri, di), Le), Nr);
              }
              function Sf() {
                var Le = Ue();
                ui(88), ui(58);
                var Nr = Qi(3, nc);
                return Bi(ge.createDefaultClause(Nr), Le);
              }
              function ll() {
                return De() === 82 ? Wf() : Sf();
              }
              function J_() {
                var Le = Ue();
                ui(18);
                var Nr = Qi(2, ll);
                return ui(19), Bi(ge.createCaseBlock(Nr), Le);
              }
              function j_() {
                var Le = Ue(), Nr = fr();
                ui(107), ui(20);
                var ri = Wt(ns);
                ui(21);
                var di = J_();
                return wr(Bi(ge.createSwitchStatement(ri, di), Le), Nr);
              }
              function U_() {
                var Le = Ue(), Nr = fr();
                ui(109);
                var ri = D.hasPrecedingLineBreak() ? void 0 : Wt(ns);
                return ri === void 0 && (Cr++, ri = Bi(ge.createIdentifier(""), Ue())), Ba() || wt(ri), wr(Bi(ge.createThrowStatement(ri), Le), Nr);
              }
              function iu() {
                var Le = Ue(), Nr = fr();
                ui(111);
                var ri = Dc(false), di = De() === 83 ? vd() : void 0, Mi;
                return (!di || De() === 96) && (ui(96, e.Diagnostics.catch_or_finally_expected), Mi = Dc(false)), wr(Bi(ge.createTryStatement(ri, di, Mi), Le), Nr);
              }
              function vd() {
                var Le = Ue();
                ui(83);
                var Nr;
                at(20) ? (Nr = xf(), ui(21)) : Nr = void 0;
                var ri = Dc(false);
                return Bi(ge.createCatchClause(Nr, ri), Le);
              }
              function qf() {
                var Le = Ue(), Nr = fr();
                return ui(87), pn(), wr(Bi(ge.createDebuggerStatement(), Le), Nr);
              }
              function dc() {
                var Le = Ue(), Nr = fr(), ri, di = De() === 20, Mi = Wt(ns);
                return e.isIdentifier(Mi) && at(58) ? ri = ge.createLabeledStatement(Mi, nc()) : (Ba() || wt(Mi), ri = ge.createExpressionStatement(Mi), di && (Nr = false)), wr(Bi(ri, Le), Nr);
              }
              function Pu() {
                return Tr(), e.tokenIsIdentifierOrKeyword(De()) && !D.hasPrecedingLineBreak();
              }
              function wl() {
                return Tr(), De() === 84 && !D.hasPrecedingLineBreak();
              }
              function Iu() {
                return Tr(), De() === 98 && !D.hasPrecedingLineBreak();
              }
              function so() {
                return Tr(), (e.tokenIsIdentifierOrKeyword(De()) || De() === 8 || De() === 9 || De() === 10) && !D.hasPrecedingLineBreak();
              }
              function Et() {
                for (; ; ) switch (De()) {
                  case 113:
                  case 119:
                  case 85:
                  case 98:
                  case 84:
                  case 92:
                    return true;
                  case 118:
                  case 152:
                    return u_();
                  case 141:
                  case 142:
                    return Tf();
                  case 126:
                  case 131:
                  case 135:
                  case 121:
                  case 122:
                  case 123:
                  case 145:
                    if (Tr(), D.hasPrecedingLineBreak()) return false;
                    continue;
                  case 157:
                    return Tr(), De() === 18 || De() === 79 || De() === 93;
                  case 100:
                    return Tr(), De() === 10 || De() === 41 || De() === 18 || e.tokenIsIdentifierOrKeyword(De());
                  case 93:
                    var Le = Tr();
                    if (Le === 152 && (Le = Rt(Tr)), Le === 63 || Le === 41 || Le === 18 || Le === 88 || Le === 127) return true;
                    continue;
                  case 124:
                    Tr();
                    continue;
                  default:
                    return false;
                }
              }
              function Ys() {
                return Rt(Et);
              }
              function Ku() {
                switch (De()) {
                  case 59:
                  case 26:
                  case 18:
                  case 113:
                  case 119:
                  case 98:
                  case 84:
                  case 92:
                  case 99:
                  case 90:
                  case 115:
                  case 97:
                  case 86:
                  case 81:
                  case 105:
                  case 116:
                  case 107:
                  case 109:
                  case 111:
                  case 87:
                  case 83:
                  case 96:
                    return true;
                  case 100:
                    return Ys() || Rt(jn);
                  case 85:
                  case 93:
                    return Ys();
                  case 131:
                  case 135:
                  case 118:
                  case 141:
                  case 142:
                  case 152:
                  case 157:
                    return true;
                  case 123:
                  case 121:
                  case 122:
                  case 124:
                  case 145:
                    return Ys() || !Rt(Pu);
                  default:
                    return qs();
                }
              }
              function Np() {
                return Tr(), Ki() || De() === 18 || De() === 22;
              }
              function Pp() {
                return Rt(Np);
              }
              function nc() {
                switch (De()) {
                  case 26:
                    return ac();
                  case 18:
                    return Dc(false);
                  case 113:
                    return rs(Ue(), fr(), void 0, void 0);
                  case 119:
                    if (Pp()) return rs(Ue(), fr(), void 0, void 0);
                    break;
                  case 98:
                    return Op(Ue(), fr(), void 0, void 0);
                  case 84:
                    return Ml(Ue(), fr(), void 0, void 0);
                  case 99:
                    return Pl();
                  case 90:
                    return Il();
                  case 115:
                    return zf();
                  case 97:
                    return ul();
                  case 86:
                    return Nu(245);
                  case 81:
                    return Nu(246);
                  case 105:
                    return Us();
                  case 116:
                    return Ap();
                  case 107:
                    return j_();
                  case 109:
                    return U_();
                  case 111:
                  case 83:
                  case 96:
                    return iu();
                  case 87:
                    return qf();
                  case 59:
                    return _l();
                  case 131:
                  case 118:
                  case 152:
                  case 141:
                  case 142:
                  case 135:
                  case 85:
                  case 92:
                  case 93:
                  case 100:
                  case 121:
                  case 122:
                  case 123:
                  case 126:
                  case 124:
                  case 145:
                  case 157:
                    if (Ys()) return _l();
                    break;
                }
                return dc();
              }
              function fl(Le) {
                return Le.kind === 135;
              }
              function _l() {
                var Le = e.some(Rt(function() {
                  return gl(), Fc();
                }), fl);
                if (Le) {
                  var Nr = cu();
                  if (Nr) return Nr;
                }
                var ri = Ue(), di = fr(), Mi = gl(), st = Fc();
                if (Le) {
                  for (var ra = 0, Ta = st; ra < Ta.length; ra++) {
                    var ha = Ta[ra];
                    ha.flags |= 16777216;
                  }
                  return Gi(16777216, function() {
                    return gc(ri, di, Mi, st);
                  });
                } else return gc(ri, di, Mi, st);
              }
              function cu() {
                return Gi(16777216, function() {
                  var Le = sa(Ye);
                  if (Le) return en(Le);
                });
              }
              function gc(Le, Nr, ri, di) {
                switch (De()) {
                  case 113:
                  case 119:
                  case 85:
                    return rs(Le, Nr, ri, di);
                  case 98:
                    return Op(Le, Nr, ri, di);
                  case 84:
                    return Ml(Le, Nr, ri, di);
                  case 118:
                    return v_(Le, Nr, ri, di);
                  case 152:
                    return Bp(Le, Nr, ri, di);
                  case 92:
                    return Xc(Le, Nr, ri, di);
                  case 157:
                  case 141:
                  case 142:
                    return V_(Le, Nr, ri, di);
                  case 100:
                    return Sa(Le, Nr, ri, di);
                  case 93:
                    switch (Tr(), De()) {
                      case 88:
                      case 63:
                        return Jp(Le, Nr, ri, di);
                      case 127:
                        return zi(Le, Nr, ri, di);
                      default:
                        return K_(Le, Nr, ri, di);
                    }
                  default:
                    if (ri || di) {
                      var Mi = kn(276, true, e.Diagnostics.Declaration_expected);
                      return e.setTextRangePos(Mi, Le), Mi.decorators = ri, Mi.modifiers = di, Mi;
                    }
                    return;
                }
              }
              function Tf() {
                return Tr(), !D.hasPrecedingLineBreak() && (Fi() || De() === 10);
              }
              function mc(Le, Nr) {
                if (De() !== 18 && ka()) {
                  pn();
                  return;
                }
                return Cc(Le, Nr);
              }
              function Ip() {
                var Le = Ue();
                if (De() === 27) return Bi(ge.createOmittedExpression(), Le);
                var Nr = At(25), ri = Ol(), di = nl();
                return Bi(ge.createBindingElement(Nr, void 0, ri, di), Le);
              }
              function ms() {
                var Le = Ue(), Nr = At(25), ri = Ki(), di = En(), Mi;
                ri && De() !== 58 ? (Mi = di, di = void 0) : (ui(58), Mi = Ol());
                var st = nl();
                return Bi(ge.createBindingElement(Nr, di, Mi, st), Le);
              }
              function tu() {
                var Le = Ue();
                ui(18);
                var Nr = hs(9, ms);
                return ui(19), Bi(ge.createObjectBindingPattern(Nr), Le);
              }
              function wp() {
                var Le = Ue();
                ui(22);
                var Nr = hs(10, Ip);
                return ui(23), Bi(ge.createArrayBindingPattern(Nr), Le);
              }
              function Hc() {
                return De() === 18 || De() === 22 || De() === 80 || Ki();
              }
              function Ol(Le) {
                return De() === 22 ? wp() : De() === 18 ? tu() : Pn(Le);
              }
              function tf() {
                return xf(true);
              }
              function xf(Le) {
                var Nr = Ue(), ri = fr(), di = Ol(e.Diagnostics.Private_identifiers_are_not_allowed_in_variable_declarations), Mi;
                Le && di.kind === 79 && De() === 53 && !D.hasPrecedingLineBreak() && (Mi = ai());
                var st = va(), ra = F_(De()) ? void 0 : nl(), Ta = ge.createVariableDeclaration(di, Mi, st, ra);
                return wr(Bi(Ta, Nr), ri);
              }
              function z_(Le) {
                var Nr = Ue(), ri = 0;
                switch (De()) {
                  case 113:
                    break;
                  case 119:
                    ri |= 1;
                    break;
                  case 85:
                    ri |= 2;
                    break;
                  default:
                    e.Debug.fail();
                }
                Tr();
                var di;
                if (De() === 160 && Rt(Oc)) di = ps();
                else {
                  var Mi = Je();
                  si(Le), di = hs(8, Le ? xf : tf), si(Mi);
                }
                return Bi(ge.createVariableDeclarationList(di, ri), Nr);
              }
              function Oc() {
                return Qe() && Tr() === 21;
              }
              function rs(Le, Nr, ri, di) {
                var Mi = z_(false);
                pn();
                var st = ge.createVariableStatement(di, Mi);
                return st.decorators = ri, wr(Bi(st, Le), Nr);
              }
              function Op(Le, Nr, ri, di) {
                var Mi = mr(), st = e.modifiersToFlags(di);
                ui(98);
                var ra = At(41), Ta = st & 512 ? bf() : Pn(), ha = ra ? 1 : 0, Na = st & 256 ? 2 : 0, In = Ws();
                st & 1 && Xi(true);
                var qo = Ei(ha | Na), co = vc(58, false), ts = mc(ha | Na, e.Diagnostics.or_expected);
                Xi(Mi);
                var vs = ge.createFunctionDeclaration(ri, di, ra, Ta, In, qo, co, ts);
                return wr(Bi(vs, Le), Nr);
              }
              function Ef() {
                if (De() === 134) return ui(134);
                if (De() === 10 && Rt(Tr) === 20) return Ii(function() {
                  var Le = ga();
                  return Le.text === "constructor" ? Le : void 0;
                });
              }
              function Fl(Le, Nr, ri, di) {
                return Ii(function() {
                  if (Ef()) {
                    var Mi = Ws(), st = Ei(0), ra = vc(58, false), Ta = mc(0, e.Diagnostics.or_expected), ha = ge.createConstructorDeclaration(ri, di, st, Ta);
                    return ha.typeParameters = Mi, ha.type = ra, wr(Bi(ha, Le), Nr);
                  }
                });
              }
              function pl(Le, Nr, ri, di, Mi, st, ra, Ta, ha) {
                var Na = Mi ? 1 : 0, In = e.some(di, e.isAsyncModifier) ? 2 : 0, qo = Ws(), co = Ei(Na | In), ts = vc(58, false), vs = mc(Na | In, ha), Ac = ge.createMethodDeclaration(ri, di, Mi, st, ra, qo, co, ts, vs);
                return Ac.exclamationToken = Ta, wr(Bi(Ac, Le), Nr);
              }
              function Fp(Le, Nr, ri, di, Mi, st) {
                var ra = !st && !D.hasPrecedingLineBreak() ? At(53) : void 0, Ta = va(), ha = et(45056, nl);
                Oi(Mi, Ta, ha);
                var Na = ge.createPropertyDeclaration(ri, di, Mi, st || ra, Ta, ha);
                return wr(Bi(Na, Le), Nr);
              }
              function Mp(Le, Nr, ri, di) {
                var Mi = At(41), st = En(), ra = At(57);
                return Mi || De() === 20 || De() === 29 ? pl(Le, Nr, ri, di, Mi, st, ra, void 0, e.Diagnostics.or_expected) : Fp(Le, Nr, ri, di, st, ra);
              }
              function Gu(Le, Nr, ri, di, Mi) {
                var st = En(), ra = Ws(), Ta = Ei(0), ha = vc(58, false), Na = mc(0), In = Mi === 172 ? ge.createGetAccessorDeclaration(ri, di, st, Ta, ha, Na) : ge.createSetAccessorDeclaration(ri, di, st, Ta, Na);
                return In.typeParameters = ra, ha && In.kind === 173 && (In.type = ha), wr(Bi(In, Le), Nr);
              }
              function Lp() {
                var Le;
                if (De() === 59) return true;
                for (; e.isModifierKind(De()); ) {
                  if (Le = De(), e.isClassMemberModifier(Le)) return true;
                  Tr();
                }
                if (De() === 41 || (Da() && (Le = De(), Tr()), De() === 22)) return true;
                if (Le !== void 0) {
                  if (!e.isKeyword(Le) || Le === 149 || Le === 136) return true;
                  switch (De()) {
                    case 20:
                    case 29:
                    case 53:
                    case 58:
                    case 63:
                    case 57:
                      return true;
                    default:
                      return ka();
                  }
                }
                return false;
              }
              function Cf(Le, Nr, ri, di) {
                $a(124);
                var Mi = W_();
                return wr(Bi(ge.createClassStaticBlockDeclaration(ri, di, Mi), Le), Nr);
              }
              function W_() {
                var Le = Wr(), Nr = mr();
                Di(false), Xi(true);
                var ri = Dc(false);
                return Di(Le), Xi(Nr), ri;
              }
              function g_() {
                if (mr() && De() === 132) {
                  var Le = Ue(), Nr = eo(e.Diagnostics.Expression_expected);
                  Tr();
                  var ri = Ec(Le, Nr, true);
                  return Ps(Le, ri);
                }
                return $l();
              }
              function dl() {
                var Le = Ue();
                if (!!at(59)) {
                  var Nr = Xe(g_);
                  return Bi(ge.createDecorator(Nr), Le);
                }
              }
              function gl() {
                for (var Le = Ue(), Nr, ri; ri = dl(); ) Nr = e.append(Nr, ri);
                return Nr && Cn(Nr, Le);
              }
              function Vf(Le, Nr, ri) {
                var di = Ue(), Mi = De();
                if (De() === 85 && Le) {
                  if (!Ii(Oo)) return;
                } else {
                  if (Nr && De() === 124 && Rt(sr)) return;
                  if (ri && De() === 124) return;
                  if (!xi()) return;
                }
                return Bi(ge.createToken(Mi), di);
              }
              function Fc(Le, Nr) {
                for (var ri = Ue(), di, Mi, st = false; Mi = Vf(Le, Nr, st); ) Mi.kind === 124 && (st = true), di = e.append(di, Mi);
                return di && Cn(di, ri);
              }
              function Hu() {
                var Le;
                if (De() === 131) {
                  var Nr = Ue();
                  Tr();
                  var ri = Bi(ge.createToken(131), Nr);
                  Le = Cn([ri], Nr);
                }
                return Le;
              }
              function af() {
                var Le = Ue();
                if (De() === 26) return Tr(), Bi(ge.createSemicolonClassElement(), Le);
                var Nr = fr(), ri = gl(), di = Fc(true, true);
                if (De() === 124 && Rt(sr)) return Cf(Le, Nr, ri, di);
                if (Ko(136)) return Gu(Le, Nr, ri, di, 172);
                if (Ko(149)) return Gu(Le, Nr, ri, di, 173);
                if (De() === 134 || De() === 10) {
                  var Mi = Fl(Le, Nr, ri, di);
                  if (Mi) return Mi;
                }
                if (bt()) return Xt(Le, Nr, ri, di);
                if (e.tokenIsIdentifierOrKeyword(De()) || De() === 10 || De() === 8 || De() === 41 || De() === 22) {
                  var st = e.some(di, fl);
                  if (st) {
                    for (var ra = 0, Ta = di; ra < Ta.length; ra++) {
                      var ha = Ta[ra];
                      ha.flags |= 16777216;
                    }
                    return Gi(16777216, function() {
                      return Mp(Le, Nr, ri, di);
                    });
                  } else return Mp(Le, Nr, ri, di);
                }
                if (ri || di) {
                  var Na = kn(79, true, e.Diagnostics.Declaration_expected);
                  return Fp(Le, Nr, ri, di, Na, void 0);
                }
                return e.Debug.fail("Should not have attempted to parse class member declaration.");
              }
              function tn() {
                return Ot(Ue(), fr(), void 0, void 0, 226);
              }
              function Ml(Le, Nr, ri, di) {
                return Ot(Le, Nr, ri, di, 257);
              }
              function Ot(Le, Nr, ri, di, Mi) {
                var st = mr();
                ui(84);
                var ra = nf(), Ta = Ws();
                e.some(di, e.isExportModifier) && Xi(true);
                var ha = Kf(), Na;
                ui(18) ? (Na = hd(), ui(19)) : Na = ps(), Xi(st);
                var In = Mi === 257 ? ge.createClassDeclaration(ri, di, ra, Ta, ha, Na) : ge.createClassExpression(ri, di, ra, Ta, ha, Na);
                return wr(Bi(In, Le), Nr);
              }
              function nf() {
                return Ki() && !q_() ? Kn(Ki()) : void 0;
              }
              function q_() {
                return De() === 117 && Rt(Gr);
              }
              function Kf() {
                if (Ll()) return Qi(22, Rp);
              }
              function Rp() {
                var Le = Ue(), Nr = De();
                e.Debug.assert(Nr === 94 || Nr === 117), Tr();
                var ri = hs(7, yd);
                return Bi(ge.createHeritageClause(Nr, ri), Le);
              }
              function yd() {
                var Le = Ue(), Nr = $l();
                if (Nr.kind === 228) return Nr;
                var ri = m_();
                return Bi(ge.createExpressionWithTypeArguments(Nr, ri), Le);
              }
              function m_() {
                return De() === 29 ? js(20, Aa, 29, 31) : void 0;
              }
              function Ll() {
                return De() === 94 || De() === 117;
              }
              function hd() {
                return Qi(5, af);
              }
              function v_(Le, Nr, ri, di) {
                ui(118);
                var Mi = eo(), st = Ws(), ra = Kf(), Ta = ho(), ha = ge.createInterfaceDeclaration(ri, di, Mi, st, ra, Ta);
                return wr(Bi(ha, Le), Nr);
              }
              function Bp(Le, Nr, ri, di) {
                ui(152);
                var Mi = eo(), st = Ws();
                ui(63);
                var ra = De() === 138 && Ii(po) || Aa();
                pn();
                var Ta = ge.createTypeAliasDeclaration(ri, di, Mi, st, ra);
                return wr(Bi(Ta, Le), Nr);
              }
              function Xu() {
                var Le = Ue(), Nr = fr(), ri = En(), di = Wt(nl);
                return wr(Bi(ge.createEnumMember(ri, di), Le), Nr);
              }
              function Xc(Le, Nr, ri, di) {
                ui(92);
                var Mi = eo(), st;
                ui(18) ? (st = Sr(function() {
                  return hs(6, Xu);
                }), ui(19)) : st = ps();
                var ra = ge.createEnumDeclaration(ri, di, Mi, st);
                return wr(Bi(ra, Le), Nr);
              }
              function Gf() {
                var Le = Ue(), Nr;
                return ui(18) ? (Nr = Qi(1, nc), ui(19)) : Nr = ps(), Bi(ge.createModuleBlock(Nr), Le);
              }
              function of(Le, Nr, ri, di, Mi) {
                var st = Mi & 16, ra = eo(), Ta = at(24) ? of(Ue(), false, void 0, void 0, 4 | st) : Gf(), ha = ge.createModuleDeclaration(ri, di, ra, Ta, Mi);
                return wr(Bi(ha, Le), Nr);
              }
              function wu(Le, Nr, ri, di) {
                var Mi = 0, st;
                De() === 157 ? (st = eo(), Mi |= 1024) : (st = ga(), st.text = xn(st.text));
                var ra;
                De() === 18 ? ra = Gf() : pn();
                var Ta = ge.createModuleDeclaration(ri, di, st, ra, Mi);
                return wr(Bi(Ta, Le), Nr);
              }
              function V_(Le, Nr, ri, di) {
                var Mi = 0;
                if (De() === 157) return wu(Le, Nr, ri, di);
                if (at(142)) Mi |= 16;
                else if (ui(141), De() === 10) return wu(Le, Nr, ri, di);
                return of(Le, Nr, ri, di, Mi);
              }
              function yu() {
                return De() === 146 && Rt(v);
              }
              function v() {
                return Tr() === 20;
              }
              function sr() {
                return Tr() === 18;
              }
              function fi() {
                return Tr() === 43;
              }
              function zi(Le, Nr, ri, di) {
                ui(127), ui(142);
                var Mi = eo();
                pn();
                var st = ge.createNamespaceExportDeclaration(Mi);
                return st.decorators = ri, st.modifiers = di, wr(Bi(st, Le), Nr);
              }
              function Sa(Le, Nr, ri, di) {
                ui(100);
                var Mi = D.getStartPos(), st;
                Fi() && (st = eo());
                var ra = false;
                if (De() !== 156 && (st == null ? void 0 : st.escapedText) === "type" && (Fi() || ta()) && (ra = true, st = Fi() ? eo() : void 0), st && !nn()) return Wo(Le, Nr, ri, di, st, ra);
                var Ta;
                (st || De() === 41 || De() === 18) && (Ta = Lo(st, Mi, ra), ui(156));
                var ha = is(), Na;
                De() === 129 && !D.hasPrecedingLineBreak() && (Na = Ha()), pn();
                var In = ge.createImportDeclaration(ri, di, Ta, ha, Na);
                return wr(Bi(In, Le), Nr);
              }
              function da() {
                var Le = Ue(), Nr = e.tokenIsIdentifierOrKeyword(De()) ? Rn() : fo(10);
                ui(58);
                var ri = hc();
                return Bi(ge.createAssertEntry(Nr, ri), Le);
              }
              function Ha(Le) {
                var Nr = Ue();
                Le || ui(129);
                var ri = D.getTokenPos();
                if (ui(18)) {
                  var di = D.hasPrecedingLineBreak(), Mi = hs(24, da, true);
                  if (!ui(19)) {
                    var st = e.lastOrUndefined(_e);
                    st && st.code === e.Diagnostics._0_expected.code && e.addRelatedInfo(st, e.createDetachedDiagnostic(Re, ri, 1, e.Diagnostics.The_parser_expected_to_find_a_1_to_match_the_0_token_here, "{", "}"));
                  }
                  return Bi(ge.createAssertClause(Mi, di), Nr);
                } else {
                  var Mi = Cn([], Ue(), void 0, false);
                  return Bi(ge.createAssertClause(Mi, false), Nr);
                }
              }
              function ta() {
                return De() === 41 || De() === 18;
              }
              function nn() {
                return De() === 27 || De() === 156;
              }
              function Wo(Le, Nr, ri, di, Mi, st) {
                ui(63);
                var ra = oc();
                pn();
                var Ta = ge.createImportEqualsDeclaration(ri, di, st, Mi, ra), ha = wr(Bi(Ta, Le), Nr);
                return ha;
              }
              function Lo(Le, Nr, ri) {
                var di;
                return (!Le || at(27)) && (di = De() === 41 ? au() : Ou(269)), Bi(ge.createImportClause(ri, Le, di), Nr);
              }
              function oc() {
                return yu() ? uu() : ds(false);
              }
              function uu() {
                var Le = Ue();
                ui(146), ui(20);
                var Nr = is();
                return ui(21), Bi(ge.createExternalModuleReference(Nr), Le);
              }
              function is() {
                if (De() === 10) {
                  var Le = ga();
                  return Le.text = xn(Le.text), Le;
                } else return ns();
              }
              function au() {
                var Le = Ue();
                ui(41), ui(127);
                var Nr = eo();
                return Bi(ge.createNamespaceImport(Nr), Le);
              }
              function Ou(Le) {
                var Nr = Ue(), ri = Le === 269 ? ge.createNamedImports(js(23, lu, 18, 19)) : ge.createNamedExports(js(23, sf, 18, 19));
                return Bi(ri, Nr);
              }
              function sf() {
                var Le = fr();
                return wr(cf(275), Le);
              }
              function lu() {
                return cf(270);
              }
              function cf(Le) {
                var Nr = Ue(), ri = e.isKeyword(De()) && !Fi(), di = D.getTokenPos(), Mi = D.getTextPos(), st = false, ra, Ta = true, ha = Rn();
                if (ha.escapedText === "type") if (De() === 127) {
                  var Na = Rn();
                  if (De() === 127) {
                    var In = Rn();
                    e.tokenIsIdentifierOrKeyword(De()) ? (st = true, ra = Na, ha = co(), Ta = false) : (ra = ha, ha = In, Ta = false);
                  } else e.tokenIsIdentifierOrKeyword(De()) ? (ra = ha, Ta = false, ha = co()) : (st = true, ha = Na);
                } else e.tokenIsIdentifierOrKeyword(De()) && (st = true, ha = co());
                Ta && De() === 127 && (ra = ha, ui(127), ha = co()), Le === 270 && ri && nr(di, Mi, e.Diagnostics.Identifier_expected);
                var qo = Le === 270 ? ge.createImportSpecifier(st, ra, ha) : ge.createExportSpecifier(st, ra, ha);
                return Bi(qo, Nr);
                function co() {
                  return ri = e.isKeyword(De()) && !Fi(), di = D.getTokenPos(), Mi = D.getTextPos(), Rn();
                }
              }
              function uf(Le) {
                return Bi(ge.createNamespaceExport(Rn()), Le);
              }
              function K_(Le, Nr, ri, di) {
                var Mi = mr();
                Xi(true);
                var st, ra, Ta, ha = at(152), Na = Ue();
                at(41) ? (at(127) && (st = uf(Na)), ui(156), ra = is()) : (st = Ou(273), (De() === 156 || De() === 10 && !D.hasPrecedingLineBreak()) && (ui(156), ra = is())), ra && De() === 129 && !D.hasPrecedingLineBreak() && (Ta = Ha()), pn(), Xi(Mi);
                var In = ge.createExportDeclaration(ri, di, ha, st, ra, Ta);
                return wr(Bi(In, Le), Nr);
              }
              function Jp(Le, Nr, ri, di) {
                var Mi = mr();
                Xi(true);
                var st;
                at(63) ? st = true : ui(88);
                var ra = hc();
                pn(), Xi(Mi);
                var Ta = ge.createExportAssignment(ri, di, st, ra);
                return wr(Bi(Ta, Le), Nr);
              }
              var Hf;
              (function(Le) {
                Le[Le.SourceElements = 0] = "SourceElements", Le[Le.BlockStatements = 1] = "BlockStatements", Le[Le.SwitchClauses = 2] = "SwitchClauses", Le[Le.SwitchClauseStatements = 3] = "SwitchClauseStatements", Le[Le.TypeMembers = 4] = "TypeMembers", Le[Le.ClassMembers = 5] = "ClassMembers", Le[Le.EnumMembers = 6] = "EnumMembers", Le[Le.HeritageClauseElement = 7] = "HeritageClauseElement", Le[Le.VariableDeclarations = 8] = "VariableDeclarations", Le[Le.ObjectBindingElements = 9] = "ObjectBindingElements", Le[Le.ArrayBindingElements = 10] = "ArrayBindingElements", Le[Le.ArgumentExpressions = 11] = "ArgumentExpressions", Le[Le.ObjectLiteralMembers = 12] = "ObjectLiteralMembers", Le[Le.JsxAttributes = 13] = "JsxAttributes", Le[Le.JsxChildren = 14] = "JsxChildren", Le[Le.ArrayLiteralMembers = 15] = "ArrayLiteralMembers", Le[Le.Parameters = 16] = "Parameters", Le[Le.JSDocParameters = 17] = "JSDocParameters", Le[Le.RestProperties = 18] = "RestProperties", Le[Le.TypeParameters = 19] = "TypeParameters", Le[Le.TypeArguments = 20] = "TypeArguments", Le[Le.TupleElementTypes = 21] = "TupleElementTypes", Le[Le.HeritageClauses = 22] = "HeritageClauses", Le[Le.ImportOrExportSpecifiers = 23] = "ImportOrExportSpecifiers", Le[Le.AssertEntries = 24] = "AssertEntries", Le[Le.Count = 25] = "Count";
              })(Hf || (Hf = {}));
              var kc;
              (function(Le) {
                Le[Le.False = 0] = "False", Le[Le.True = 1] = "True", Le[Le.Unknown = 2] = "Unknown";
              })(kc || (kc = {}));
              var G_;
              (function(Le) {
                function Nr(Na, In, qo) {
                  ur("file.js", Na, 99, void 0, 1), D.setText(Na, In, qo), ye = D.scan();
                  var co = ri(), ts = or("file.js", 99, 1, false, [], ge.createToken(1), 0, e.noop), vs = e.attachFileToDiagnostics(_e, ts);
                  return we && (ts.jsDocDiagnostics = e.attachFileToDiagnostics(we, ts)), yr(), co ? { jsDocTypeExpression: co, diagnostics: vs } : void 0;
                }
                Le.parseJSDocTypeExpressionForTests = Nr;
                function ri(Na) {
                  var In = Ue(), qo = (Na ? at : ui)(18), co = Gi(8388608, al);
                  (!Na || qo) && ji(19);
                  var ts = ge.createJSDocTypeExpression(co);
                  return pe(ts), Bi(ts, In);
                }
                Le.parseJSDocTypeExpression = ri;
                function di() {
                  for (var Na = Ue(), In = at(18), qo = Ue(), co = ds(false); De() === 80; ) nt(), vi(), co = Bi(ge.createJSDocMemberName(co, eo()), qo);
                  In && ji(19);
                  var ts = ge.createJSDocNameReference(co);
                  return pe(ts), Bi(ts, Na);
                }
                Le.parseJSDocNameReference = di;
                function Mi(Na, In, qo) {
                  ur("", Na, 99, void 0, 1);
                  var co = Gi(8388608, function() {
                    return ha(In, qo);
                  }), ts = { languageVariant: 0, text: Na }, vs = e.attachFileToDiagnostics(_e, ts);
                  return yr(), co ? { jsDoc: co, diagnostics: vs } : void 0;
                }
                Le.parseIsolatedJSDocComment = Mi;
                function st(Na, In, qo) {
                  var co = ye, ts = _e.length, vs = n, Ac = Gi(8388608, function() {
                    return ha(In, qo);
                  });
                  return e.setParent(Ac, Na), Er & 262144 && (we || (we = []), we.push.apply(we, _e)), ye = co, _e.length = ts, n = vs, Ac;
                }
                Le.parseJSDocComment = st;
                var ra;
                (function(Na) {
                  Na[Na.BeginningOfLine = 0] = "BeginningOfLine", Na[Na.SawAsterisk = 1] = "SawAsterisk", Na[Na.SavingComments = 2] = "SavingComments", Na[Na.SavingBackticks = 3] = "SavingBackticks";
                })(ra || (ra = {}));
                var Ta;
                (function(Na) {
                  Na[Na.Property = 1] = "Property", Na[Na.Parameter = 2] = "Parameter", Na[Na.CallbackParameter = 4] = "CallbackParameter";
                })(Ta || (Ta = {}));
                function ha(Na, In) {
                  Na === void 0 && (Na = 0);
                  var qo = Ee, co = In === void 0 ? qo.length : Na + In;
                  if (In = co - Na, e.Debug.assert(Na >= 0), e.Debug.assert(Na <= co), e.Debug.assert(co <= qo.length), !m(qo, Na)) return;
                  var ts, vs, Ac, Is, Qu, sc = [], bc = [];
                  return D.scanRange(Na + 3, In - 5, function() {
                    var It = 1, Ma, aa = Na - (qo.lastIndexOf(`
`, Na) + 1) + 4;
                    function Ja(Js) {
                      Ma || (Ma = aa), sc.push(Js), aa += Js.length;
                    }
                    for (vi(); Up(5); ) ;
                    Up(4) && (It = 0, aa = 0);
                    e: for (; ; ) {
                      switch (De()) {
                        case 59:
                          It === 0 || It === 1 ? (Yu(sc), Qu || (Qu = Ue()), Vs(W(aa)), It = 0, Ma = void 0) : Ja(D.getTokenText());
                          break;
                        case 4:
                          sc.push(D.getTokenText()), It = 0, aa = 0;
                          break;
                        case 41:
                          var _n = D.getTokenText();
                          It === 1 || It === 2 ? (It = 2, Ja(_n)) : (It = 1, aa += _n.length);
                          break;
                        case 5:
                          var ro = D.getTokenText();
                          It === 2 ? sc.push(ro) : Ma !== void 0 && aa + ro.length > Ma && sc.push(ro.slice(Ma - aa)), aa += ro.length;
                          break;
                        case 1:
                          break e;
                        case 18:
                          It = 2;
                          var as = D.getStartPos(), cc = D.getTextPos() - 1, Sc = rt(cc);
                          if (Sc) {
                            Is || Mc(sc), bc.push(Bi(ge.createJSDocText(sc.join("")), Is != null ? Is : Na, as)), bc.push(Sc), sc = [], Is = D.getTextPos();
                            break;
                          }
                        default:
                          It = 2, Ja(D.getTokenText());
                          break;
                      }
                      vi();
                    }
                    Yu(sc), bc.length && sc.length && bc.push(Bi(ge.createJSDocText(sc.join("")), Is != null ? Is : Na, Qu)), bc.length && ts && e.Debug.assertIsDefined(Qu, "having parsed tags implies that the end of the comment span should be set");
                    var hu = ts && Cn(ts, vs, Ac);
                    return Bi(ge.createJSDocComment(bc.length ? Cn(bc, Na, Qu) : sc.length ? sc.join("") : void 0, hu), Na, co);
                  });
                  function Mc(It) {
                    for (; It.length && (It[0] === `
` || It[0] === "\r"); ) It.shift();
                  }
                  function Yu(It) {
                    for (; It.length && It[It.length - 1].trim() === ""; ) It.pop();
                  }
                  function Rl() {
                    for (; ; ) {
                      if (vi(), De() === 1) return true;
                      if (!(De() === 5 || De() === 4)) return false;
                    }
                  }
                  function Lc() {
                    if (!((De() === 5 || De() === 4) && Rt(Rl))) for (; De() === 5 || De() === 4; ) vi();
                  }
                  function _() {
                    if ((De() === 5 || De() === 4) && Rt(Rl)) return "";
                    for (var It = D.hasPrecedingLineBreak(), Ma = false, aa = ""; It && De() === 41 || De() === 5 || De() === 4; ) aa += D.getTokenText(), De() === 4 ? (It = true, Ma = true, aa = "") : De() === 41 && (It = false), vi();
                    return Ma ? aa : "";
                  }
                  function W(It) {
                    e.Debug.assert(De() === 59);
                    var Ma = D.getTokenPos();
                    vi();
                    var aa = ff(void 0), Ja = _(), _n;
                    switch (aa.escapedText) {
                      case "author":
                        _n = Jt(Ma, aa, It, Ja);
                        break;
                      case "implements":
                        _n = Xf(Ma, aa, It, Ja);
                        break;
                      case "augments":
                      case "extends":
                        _n = bd(Ma, aa, It, Ja);
                        break;
                      case "class":
                      case "constructor":
                        _n = kf(Ma, ge.createJSDocClassTag, aa, It, Ja);
                        break;
                      case "public":
                        _n = kf(Ma, ge.createJSDocPublicTag, aa, It, Ja);
                        break;
                      case "private":
                        _n = kf(Ma, ge.createJSDocPrivateTag, aa, It, Ja);
                        break;
                      case "protected":
                        _n = kf(Ma, ge.createJSDocProtectedTag, aa, It, Ja);
                        break;
                      case "readonly":
                        _n = kf(Ma, ge.createJSDocReadonlyTag, aa, It, Ja);
                        break;
                      case "override":
                        _n = kf(Ma, ge.createJSDocOverrideTag, aa, It, Ja);
                        break;
                      case "deprecated":
                        Ur = true, _n = kf(Ma, ge.createJSDocDeprecatedTag, aa, It, Ja);
                        break;
                      case "this":
                        _n = Gg(Ma, aa, It, Ja);
                        break;
                      case "enum":
                        _n = Af(Ma, aa, It, Ja);
                        break;
                      case "arg":
                      case "argument":
                      case "param":
                        return jp(Ma, aa, 2, It);
                      case "return":
                      case "returns":
                        _n = Om(Ma, aa, It, Ja);
                        break;
                      case "template":
                        _n = Lm(Ma, aa, It, Ja);
                        break;
                      case "type":
                        _n = Fm(Ma, aa, It, Ja);
                        break;
                      case "typedef":
                        _n = Hg(Ma, aa, It, Ja);
                        break;
                      case "callback":
                        _n = fg(Ma, aa, It, Ja);
                        break;
                      case "see":
                        _n = Vg(Ma, aa, It, Ja);
                        break;
                      default:
                        _n = vo(Ma, aa, It, Ja);
                        break;
                    }
                    return _n;
                  }
                  function Te(It, Ma, aa, Ja) {
                    return Ja || (aa += Ma - It), cr(aa, Ja.slice(aa));
                  }
                  function cr(It, Ma) {
                    var aa = Ue(), Ja = [], _n = [], ro, as = 0, cc = true, Sc;
                    function hu(Sd) {
                      Sc || (Sc = It), Ja.push(Sd), It += Sd.length;
                    }
                    Ma !== void 0 && (Ma !== "" && hu(Ma), as = 1);
                    var Js = De();
                    e: for (; ; ) {
                      switch (Js) {
                        case 4:
                          as = 0, Ja.push(D.getTokenText()), It = 0;
                          break;
                        case 59:
                          if (as === 3 || as === 2 && (!cc || Rt(ni))) {
                            Ja.push(D.getTokenText());
                            break;
                          }
                          D.setTextPos(D.getTextPos() - 1);
                        case 1:
                          break e;
                        case 5:
                          if (as === 2 || as === 3) hu(D.getTokenText());
                          else {
                            var Qf = D.getTokenText();
                            Sc !== void 0 && It + Qf.length > Sc && Ja.push(Qf.slice(Sc - It)), It += Qf.length;
                          }
                          break;
                        case 18:
                          as = 2;
                          var go = D.getStartPos(), Vd = D.getTextPos() - 1, X_ = rt(Vd);
                          X_ ? (_n.push(Bi(ge.createJSDocText(Ja.join("")), ro != null ? ro : aa, go)), _n.push(X_), Ja = [], ro = D.getTextPos()) : hu(D.getTokenText());
                          break;
                        case 61:
                          as === 3 ? as = 2 : as = 3, hu(D.getTokenText());
                          break;
                        case 41:
                          if (as === 0) {
                            as = 1, It += 1;
                            break;
                          }
                        default:
                          as !== 3 && (as = 2), hu(D.getTokenText());
                          break;
                      }
                      cc = De() === 5, Js = vi();
                    }
                    if (Mc(Ja), Yu(Ja), _n.length) return Ja.length && _n.push(Bi(ge.createJSDocText(Ja.join("")), ro != null ? ro : aa)), Cn(_n, aa, D.getTextPos());
                    if (Ja.length) return Ja.join("");
                  }
                  function ni() {
                    var It = vi();
                    return It === 5 || It === 4;
                  }
                  function rt(It) {
                    var Ma = Ii(yt);
                    if (!!Ma) {
                      vi(), Lc();
                      var aa = Ue(), Ja = e.tokenIsIdentifierOrKeyword(De()) ? ds(true) : void 0;
                      if (Ja) for (; De() === 80; ) nt(), vi(), Ja = Bi(ge.createJSDocMemberName(Ja, eo()), aa);
                      for (var _n = []; De() !== 19 && De() !== 4 && De() !== 1; ) _n.push(D.getTokenText()), vi();
                      var ro = Ma === "link" ? ge.createJSDocLink : Ma === "linkcode" ? ge.createJSDocLinkCode : ge.createJSDocLinkPlain;
                      return Bi(ro(Ja, _n.join("")), It, D.getTextPos());
                    }
                  }
                  function yt() {
                    if (_(), De() === 18 && vi() === 59 && e.tokenIsIdentifierOrKeyword(vi())) {
                      var It = D.getTokenValue();
                      if (Xa(It)) return It;
                    }
                  }
                  function Xa(It) {
                    return It === "link" || It === "linkcode" || It === "linkplain";
                  }
                  function vo(It, Ma, aa, Ja) {
                    return Bi(ge.createJSDocUnknownTag(Ma, Te(It, Ue(), aa, Ja)), It);
                  }
                  function Vs(It) {
                    !It || (ts ? ts.push(It) : (ts = [It], vs = It.pos), Ac = It.end);
                  }
                  function H_() {
                    return _(), De() === 18 ? ri() : void 0;
                  }
                  function y_() {
                    var It = Up(22);
                    It && Lc();
                    var Ma = Up(61), aa = Rm();
                    return Ma && Qa(61), It && (Lc(), At(63) && ns(), ui(23)), { name: aa, isBracketed: It };
                  }
                  function Dd(It) {
                    switch (It.kind) {
                      case 148:
                        return true;
                      case 183:
                        return Dd(It.elementType);
                      default:
                        return e.isTypeReferenceNode(It) && e.isIdentifier(It.typeName) && It.typeName.escapedText === "Object" && !It.typeArguments;
                    }
                  }
                  function jp(It, Ma, aa, Ja) {
                    var _n = H_(), ro = !_n;
                    _();
                    var as = y_(), cc = as.name, Sc = as.isBracketed, hu = _();
                    ro && !Rt(yt) && (_n = H_());
                    var Js = Te(It, Ue(), Ja, hu), Qf = aa !== 4 && lg(_n, cc, aa, Ja);
                    Qf && (_n = Qf, ro = true);
                    var go = aa === 1 ? ge.createJSDocPropertyTag(Ma, cc, Sc, _n, ro, Js) : ge.createJSDocParameterTag(Ma, cc, Sc, _n, ro, Js);
                    return Bi(go, It);
                  }
                  function lg(It, Ma, aa, Ja) {
                    if (It && Dd(It.type)) {
                      for (var _n = Ue(), ro = void 0, as = void 0; ro = Ii(function() {
                        return Bl(aa, Ja, Ma);
                      }); ) (ro.kind === 340 || ro.kind === 347) && (as = e.append(as, ro));
                      if (as) {
                        var cc = Bi(ge.createJSDocTypeLiteral(as, It.type.kind === 183), _n);
                        return Bi(ge.createJSDocTypeExpression(cc), _n);
                      }
                    }
                  }
                  function Om(It, Ma, aa, Ja) {
                    e.some(ts, e.isJSDocReturnTag) && nr(Ma.pos, D.getTokenPos(), e.Diagnostics._0_tag_already_specified, Ma.escapedText);
                    var _n = H_();
                    return Bi(ge.createJSDocReturnTag(Ma, _n, Te(It, Ue(), aa, Ja)), It);
                  }
                  function Fm(It, Ma, aa, Ja) {
                    e.some(ts, e.isJSDocTypeTag) && nr(Ma.pos, D.getTokenPos(), e.Diagnostics._0_tag_already_specified, Ma.escapedText);
                    var _n = ri(true), ro = aa !== void 0 && Ja !== void 0 ? Te(It, Ue(), aa, Ja) : void 0;
                    return Bi(ge.createJSDocTypeTag(Ma, _n, ro), It);
                  }
                  function Vg(It, Ma, aa, Ja) {
                    var _n = De() === 22 || Rt(function() {
                      return vi() === 59 && e.tokenIsIdentifierOrKeyword(vi()) && Xa(D.getTokenValue());
                    }), ro = _n ? void 0 : di(), as = aa !== void 0 && Ja !== void 0 ? Te(It, Ue(), aa, Ja) : void 0;
                    return Bi(ge.createJSDocSeeTag(Ma, ro, as), It);
                  }
                  function Jt(It, Ma, aa, Ja) {
                    var _n = Ue(), ro = ml(), as = D.getStartPos(), cc = Te(It, as, aa, Ja);
                    cc || (as = D.getStartPos());
                    var Sc = typeof cc != "string" ? Cn(e.concatenate([Bi(ro, _n, as)], cc), _n) : ro.text + cc;
                    return Bi(ge.createJSDocAuthorTag(Ma, Sc), It);
                  }
                  function ml() {
                    for (var It = [], Ma = false, aa = D.getToken(); aa !== 1 && aa !== 4; ) {
                      if (aa === 29) Ma = true;
                      else {
                        if (aa === 59 && !Ma) break;
                        if (aa === 31 && Ma) {
                          It.push(D.getTokenText()), D.setTextPos(D.getTokenPos() + 1);
                          break;
                        }
                      }
                      It.push(D.getTokenText()), aa = vi();
                    }
                    return ge.createJSDocText(It.join(""));
                  }
                  function Xf(It, Ma, aa, Ja) {
                    var _n = lf();
                    return Bi(ge.createJSDocImplementsTag(Ma, _n, Te(It, Ue(), aa, Ja)), It);
                  }
                  function bd(It, Ma, aa, Ja) {
                    var _n = lf();
                    return Bi(ge.createJSDocAugmentsTag(Ma, _n, Te(It, Ue(), aa, Ja)), It);
                  }
                  function lf() {
                    var It = at(18), Ma = Ue(), aa = Kg(), Ja = m_(), _n = ge.createExpressionWithTypeArguments(aa, Ja), ro = Bi(_n, Ma);
                    return It && ui(19), ro;
                  }
                  function Kg() {
                    for (var It = Ue(), Ma = ff(); at(24); ) {
                      var aa = ff();
                      Ma = Bi(ge.createPropertyAccessExpression(Ma, aa), It);
                    }
                    return Ma;
                  }
                  function kf(It, Ma, aa, Ja, _n) {
                    return Bi(Ma(aa, Te(It, Ue(), Ja, _n)), It);
                  }
                  function Gg(It, Ma, aa, Ja) {
                    var _n = ri(true);
                    return Lc(), Bi(ge.createJSDocThisTag(Ma, _n, Te(It, Ue(), aa, Ja)), It);
                  }
                  function Af(It, Ma, aa, Ja) {
                    var _n = ri(true);
                    return Lc(), Bi(ge.createJSDocEnumTag(Ma, _n, Te(It, Ue(), aa, Ja)), It);
                  }
                  function Hg(It, Ma, aa, Ja) {
                    var _n, ro = H_();
                    _();
                    var as = Wd();
                    Lc();
                    var cc = cr(aa), Sc;
                    if (!ro || Dd(ro.type)) {
                      for (var hu = void 0, Js = void 0, Qf = void 0, go = false; hu = Ii(function() {
                        return Xg(aa);
                      }); ) if (go = true, hu.kind === 343) if (Js) {
                        var Vd = Ar(e.Diagnostics.A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags);
                        Vd && e.addRelatedInfo(Vd, e.createDetachedDiagnostic(Re, 0, 0, e.Diagnostics.The_tag_was_first_specified_here));
                        break;
                      } else Js = hu;
                      else Qf = e.append(Qf, hu);
                      if (go) {
                        var X_ = ro && ro.type.kind === 183, Sd = ge.createJSDocTypeLiteral(Qf, X_);
                        ro = Js && Js.typeExpression && !Dd(Js.typeExpression.type) ? Js.typeExpression : Bi(Sd, It), Sc = ro.end;
                      }
                    }
                    Sc = Sc || cc !== void 0 ? Ue() : ((_n = as != null ? as : ro) !== null && _n !== void 0 ? _n : Ma).end, cc || (cc = Te(It, Sc, aa, Ja));
                    var Yg = ge.createJSDocTypedefTag(Ma, ro, as, cc);
                    return Bi(Yg, It, Sc);
                  }
                  function Wd(It) {
                    var Ma = D.getTokenPos();
                    if (!!e.tokenIsIdentifierOrKeyword(De())) {
                      var aa = ff();
                      if (at(24)) {
                        var Ja = Wd(true), _n = ge.createModuleDeclaration(void 0, void 0, aa, Ja, It ? 4 : void 0);
                        return Bi(_n, Ma);
                      }
                      return It && (aa.isInJSDocNamespace = true), aa;
                    }
                  }
                  function qd(It) {
                    for (var Ma = Ue(), aa, Ja; aa = Ii(function() {
                      return Bl(4, It);
                    }); ) Ja = e.append(Ja, aa);
                    return Cn(Ja || [], Ma);
                  }
                  function fg(It, Ma, aa, Ja) {
                    var _n = Wd();
                    Lc();
                    var ro = cr(aa), as = qd(aa), cc = Ii(function() {
                      if (Up(59)) {
                        var Js = W(aa);
                        if (Js && Js.kind === 341) return Js;
                      }
                    }), Sc = Bi(ge.createJSDocSignature(void 0, as, cc), It);
                    ro || (ro = Te(It, Ue(), aa, Ja));
                    var hu = ro !== void 0 ? Ue() : Sc.end;
                    return Bi(ge.createJSDocCallbackTag(Ma, Sc, _n, ro), It, hu);
                  }
                  function Mm(It, Ma) {
                    for (; !e.isIdentifier(It) || !e.isIdentifier(Ma); ) if (!e.isIdentifier(It) && !e.isIdentifier(Ma) && It.right.escapedText === Ma.right.escapedText) It = It.left, Ma = Ma.left;
                    else return false;
                    return It.escapedText === Ma.escapedText;
                  }
                  function Xg(It) {
                    return Bl(1, It);
                  }
                  function Bl(It, Ma, aa) {
                    for (var Ja = true, _n = false; ; ) switch (vi()) {
                      case 59:
                        if (Ja) {
                          var ro = Qg(It, Ma);
                          return ro && (ro.kind === 340 || ro.kind === 347) && It !== 4 && aa && (e.isIdentifier(ro.name) || !Mm(aa, ro.name.left)) ? false : ro;
                        }
                        _n = false;
                        break;
                      case 4:
                        Ja = true, _n = false;
                        break;
                      case 41:
                        _n && (Ja = false), _n = true;
                        break;
                      case 79:
                        Ja = false;
                        break;
                      case 1:
                        return false;
                    }
                  }
                  function Qg(It, Ma) {
                    e.Debug.assert(De() === 59);
                    var aa = D.getStartPos();
                    vi();
                    var Ja = ff();
                    Lc();
                    var _n;
                    switch (Ja.escapedText) {
                      case "type":
                        return It === 1 && Fm(aa, Ja);
                      case "prop":
                      case "property":
                        _n = 1;
                        break;
                      case "arg":
                      case "argument":
                      case "param":
                        _n = 6;
                        break;
                      default:
                        return false;
                    }
                    return It & _n ? jp(aa, Ja, It, Ma) : false;
                  }
                  function _g() {
                    var It = Ue(), Ma = Up(22);
                    Ma && Lc();
                    var aa = ff(e.Diagnostics.Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces), Ja;
                    if (Ma && (Lc(), ui(63), Ja = Gi(8388608, al), ui(23)), !e.nodeIsMissing(aa)) return Bi(ge.createTypeParameterDeclaration(void 0, aa, void 0, Ja), It);
                  }
                  function Qc() {
                    var It = Ue(), Ma = [];
                    do {
                      Lc();
                      var aa = _g();
                      aa !== void 0 && Ma.push(aa), _();
                    } while (Up(27));
                    return Cn(Ma, It);
                  }
                  function Lm(It, Ma, aa, Ja) {
                    var _n = De() === 18 ? ri() : void 0, ro = Qc();
                    return Bi(ge.createJSDocTemplateTag(Ma, _n, ro, Te(It, Ue(), aa, Ja)), It);
                  }
                  function Up(It) {
                    return De() === It ? (vi(), true) : false;
                  }
                  function Rm() {
                    var It = ff();
                    for (at(22) && ui(23); at(24); ) {
                      var Ma = ff();
                      at(22) && ui(23), It = Ji(It, Ma);
                    }
                    return It;
                  }
                  function ff(It) {
                    if (!e.tokenIsIdentifierOrKeyword(De())) return kn(79, !It, It || e.Diagnostics.Identifier_expected);
                    Cr++;
                    var Ma = D.getTokenPos(), aa = D.getTextPos(), Ja = De(), _n = xn(D.getTokenValue()), ro = Bi(ge.createIdentifier(_n, void 0, Ja), Ma, aa);
                    return vi(), ro;
                  }
                }
              })(G_ = d.JSDocParser || (d.JSDocParser = {}));
            })(X || (X = {}));
            var $;
            (function(d) {
              function D(Ee, He, rr, Ie) {
                if (Ie = Ie || e.Debug.shouldAssert(2), ge(Ee, He, rr, Ie), e.textChangeRangeIsUnchanged(rr)) return Ee;
                if (Ee.statements.length === 0) return X.parseSourceFile(Ee.fileName, He, Ee.languageVersion, void 0, true, Ee.scriptKind, Ee.setExternalModuleIndicator);
                var _e = Ee;
                e.Debug.assert(!_e.hasBeenIncrementallyParsed), _e.hasBeenIncrementallyParsed = true, X.fixupParentReferences(_e);
                var we = Ee.text, de = Re(Ee), ye = Z(Ee, rr);
                ge(Ee, He, ye, Ie), e.Debug.assert(ye.span.start <= rr.span.start), e.Debug.assert(e.textSpanEnd(ye.span) === e.textSpanEnd(rr.span)), e.Debug.assert(e.textSpanEnd(e.textChangeRangeNewSpan(ye)) === e.textSpanEnd(e.textChangeRangeNewSpan(rr)));
                var Ae = e.textChangeRangeNewSpan(ye).length - ye.span.length;
                Fe(_e, ye.span.start, e.textSpanEnd(ye.span), e.textSpanEnd(e.textChangeRangeNewSpan(ye)), Ae, we, He, Ie);
                var er = X.parseSourceFile(Ee.fileName, He, Ee.languageVersion, de, true, Ee.scriptKind, Ee.setExternalModuleIndicator);
                return er.commentDirectives = fe(Ee.commentDirectives, er.commentDirectives, ye.span.start, e.textSpanEnd(ye.span), Ae, we, He, Ie), er.impliedNodeFormat = Ee.impliedNodeFormat, er;
              }
              d.updateSourceFile = D;
              function fe(Ee, He, rr, Ie, _e, we, de, ye) {
                if (!Ee) return He;
                for (var Ae, er = false, ir = 0, Cr = Ee; ir < Cr.length; ir++) {
                  var Ye = Cr[ir], Br = Ye.range, Er = Ye.type;
                  if (Br.end < rr) Ae = e.append(Ae, Ye);
                  else if (Br.pos > Ie) {
                    n();
                    var Ne = { range: { pos: Br.pos + _e, end: Br.end + _e }, type: Er };
                    Ae = e.append(Ae, Ne), ye && e.Debug.assert(we.substring(Br.pos, Br.end) === de.substring(Ne.range.pos, Ne.range.end));
                  }
                }
                return n(), Ae;
                function n() {
                  er || (er = true, Ae ? He && Ae.push.apply(Ae, He) : Ae = He);
                }
              }
              function g(Ee, He, rr, Ie, _e, we) {
                He ? ye(Ee) : de(Ee);
                return;
                function de(Ae) {
                  var er = "";
                  if (we && ne(Ae) && (er = Ie.substring(Ae.pos, Ae.end)), Ae._children && (Ae._children = void 0), e.setTextRangePosEnd(Ae, Ae.pos + rr, Ae.end + rr), we && ne(Ae) && e.Debug.assert(er === _e.substring(Ae.pos, Ae.end)), se(Ae, de, ye), e.hasJSDocNodes(Ae)) for (var ir = 0, Cr = Ae.jsDoc; ir < Cr.length; ir++) {
                    var Ye = Cr[ir];
                    de(Ye);
                  }
                  We(Ae, we);
                }
                function ye(Ae) {
                  Ae._children = void 0, e.setTextRangePosEnd(Ae, Ae.pos + rr, Ae.end + rr);
                  for (var er = 0, ir = Ae; er < ir.length; er++) {
                    var Cr = ir[er];
                    de(Cr);
                  }
                }
              }
              function ne(Ee) {
                switch (Ee.kind) {
                  case 10:
                  case 8:
                  case 79:
                    return true;
                }
                return false;
              }
              function ue(Ee, He, rr, Ie, _e) {
                e.Debug.assert(Ee.end >= He, "Adjusting an element that was entirely before the change range"), e.Debug.assert(Ee.pos <= rr, "Adjusting an element that was entirely after the change range"), e.Debug.assert(Ee.pos <= Ee.end);
                var we = Math.min(Ee.pos, Ie), de = Ee.end >= rr ? Ee.end + _e : Math.min(Ee.end, Ie);
                e.Debug.assert(we <= de), Ee.parent && (e.Debug.assertGreaterThanOrEqual(we, Ee.parent.pos), e.Debug.assertLessThanOrEqual(de, Ee.parent.end)), e.setTextRangePosEnd(Ee, we, de);
              }
              function We(Ee, He) {
                if (He) {
                  var rr = Ee.pos, Ie = function(ye) {
                    e.Debug.assert(ye.pos >= rr), rr = ye.end;
                  };
                  if (e.hasJSDocNodes(Ee)) for (var _e = 0, we = Ee.jsDoc; _e < we.length; _e++) {
                    var de = we[_e];
                    Ie(de);
                  }
                  se(Ee, Ie), e.Debug.assert(rr <= Ee.end);
                }
              }
              function Fe(Ee, He, rr, Ie, _e, we, de, ye) {
                Ae(Ee);
                return;
                function Ae(ir) {
                  if (e.Debug.assert(ir.pos <= ir.end), ir.pos > rr) {
                    g(ir, false, _e, we, de, ye);
                    return;
                  }
                  var Cr = ir.end;
                  if (Cr >= He) {
                    if (ir.intersectsChange = true, ir._children = void 0, ue(ir, He, rr, Ie, _e), se(ir, Ae, er), e.hasJSDocNodes(ir)) for (var Ye = 0, Br = ir.jsDoc; Ye < Br.length; Ye++) {
                      var Er = Br[Ye];
                      Ae(Er);
                    }
                    We(ir, ye);
                    return;
                  }
                  e.Debug.assert(Cr < He);
                }
                function er(ir) {
                  if (e.Debug.assert(ir.pos <= ir.end), ir.pos > rr) {
                    g(ir, true, _e, we, de, ye);
                    return;
                  }
                  var Cr = ir.end;
                  if (Cr >= He) {
                    ir.intersectsChange = true, ir._children = void 0, ue(ir, He, rr, Ie, _e);
                    for (var Ye = 0, Br = ir; Ye < Br.length; Ye++) {
                      var Er = Br[Ye];
                      Ae(Er);
                    }
                    return;
                  }
                  e.Debug.assert(Cr < He);
                }
              }
              function Z(Ee, He) {
                for (var rr = 1, Ie = He.span.start, _e = 0; Ie > 0 && _e <= rr; _e++) {
                  var we = Be(Ee, Ie);
                  e.Debug.assert(we.pos <= Ie);
                  var de = we.pos;
                  Ie = Math.max(0, de - 1);
                }
                var ye = e.createTextSpanFromBounds(Ie, e.textSpanEnd(He.span)), Ae = He.newLength + (He.span.start - Ie);
                return e.createTextChangeRange(ye, Ae);
              }
              function Be(Ee, He) {
                var rr = Ee, Ie;
                if (se(Ee, de), Ie) {
                  var _e = we(Ie);
                  _e.pos > rr.pos && (rr = _e);
                }
                return rr;
                function we(ye) {
                  for (; ; ) {
                    var Ae = e.getLastChild(ye);
                    if (Ae) ye = Ae;
                    else return ye;
                  }
                }
                function de(ye) {
                  if (!e.nodeIsMissing(ye)) if (ye.pos <= He) {
                    if (ye.pos >= rr.pos && (rr = ye), He < ye.end) return se(ye, de), true;
                    e.Debug.assert(ye.end <= He), Ie = ye;
                  } else return e.Debug.assert(ye.pos > He), true;
                }
              }
              function ge(Ee, He, rr, Ie) {
                var _e = Ee.text;
                if (rr && (e.Debug.assert(_e.length - rr.span.length + rr.newLength === He.length), Ie || e.Debug.shouldAssert(3))) {
                  var we = _e.substr(0, rr.span.start), de = He.substr(0, rr.span.start);
                  e.Debug.assert(we === de);
                  var ye = _e.substring(e.textSpanEnd(rr.span), _e.length), Ae = He.substring(e.textSpanEnd(e.textChangeRangeNewSpan(rr)), He.length);
                  e.Debug.assert(ye === Ae);
                }
              }
              function Re(Ee) {
                var He = Ee.statements, rr = 0;
                e.Debug.assert(rr < He.length);
                var Ie = He[rr], _e = -1;
                return { currentNode: function(de) {
                  return de !== _e && (Ie && Ie.end === de && rr < He.length - 1 && (rr++, Ie = He[rr]), (!Ie || Ie.pos !== de) && we(de)), _e = de, e.Debug.assert(!Ie || Ie.pos === de), Ie;
                } };
                function we(de) {
                  He = void 0, rr = -1, Ie = void 0, se(Ee, ye, Ae);
                  return;
                  function ye(er) {
                    return de >= er.pos && de < er.end ? (se(er, ye, Ae), true) : false;
                  }
                  function Ae(er) {
                    if (de >= er.pos && de < er.end) for (var ir = 0; ir < er.length; ir++) {
                      var Cr = er[ir];
                      if (Cr) {
                        if (Cr.pos === de) return He = er, rr = ir, Ie = Cr, true;
                        if (Cr.pos < de && de < Cr.end) return se(Cr, ye, Ae), true;
                      }
                    }
                    return false;
                  }
                }
              }
              d.createSyntaxCursor = Re;
              var ze;
              (function(Ee) {
                Ee[Ee.Value = -1] = "Value";
              })(ze || (ze = {}));
            })($ || ($ = {}));
            function A(d) {
              return e.fileExtensionIsOneOf(d, e.supportedDeclarationExtensions);
            }
            e.isDeclarationFileName = A;
            function y(d, D, fe, g) {
              if (!!d) {
                if (d === "import") return e.ModuleKind.ESNext;
                if (d === "require") return e.ModuleKind.CommonJS;
                g(D, fe - D, e.Diagnostics.resolution_mode_should_be_either_require_or_import);
              }
            }
            function V(d, D) {
              for (var fe = [], g = 0, ne = e.getLeadingCommentRanges(D, 0) || e.emptyArray; g < ne.length; g++) {
                var ue = ne[g], We = D.substring(ue.pos, ue.end);
                j(fe, ue, We);
              }
              d.pragmas = new e.Map();
              for (var Fe = 0, Z = fe; Fe < Z.length; Fe++) {
                var Be = Z[Fe];
                if (d.pragmas.has(Be.name)) {
                  var ge = d.pragmas.get(Be.name);
                  ge instanceof Array ? ge.push(Be.args) : d.pragmas.set(Be.name, [ge, Be.args]);
                  continue;
                }
                d.pragmas.set(Be.name, Be.args);
              }
            }
            e.processCommentPragmas = V;
            function L(d, D) {
              d.checkJsDirective = void 0, d.referencedFiles = [], d.typeReferenceDirectives = [], d.libReferenceDirectives = [], d.amdDependencies = [], d.hasNoDefaultLib = false, d.pragmas.forEach(function(fe, g) {
                switch (g) {
                  case "reference": {
                    var ne = d.referencedFiles, ue = d.typeReferenceDirectives, We = d.libReferenceDirectives;
                    e.forEach(e.toArray(fe), function(ge) {
                      var Re = ge.arguments, ze = Re.types, Ee = Re.lib, He = Re.path, rr = Re["resolution-mode"];
                      if (ge.arguments["no-default-lib"]) d.hasNoDefaultLib = true;
                      else if (ze) {
                        var Ie = y(rr, ze.pos, ze.end, D);
                        ue.push(Ke({ pos: ze.pos, end: ze.end, fileName: ze.value }, Ie ? { resolutionMode: Ie } : {}));
                      } else Ee ? We.push({ pos: Ee.pos, end: Ee.end, fileName: Ee.value }) : He ? ne.push({ pos: He.pos, end: He.end, fileName: He.value }) : D(ge.range.pos, ge.range.end - ge.range.pos, e.Diagnostics.Invalid_reference_directive_syntax);
                    });
                    break;
                  }
                  case "amd-dependency": {
                    d.amdDependencies = e.map(e.toArray(fe), function(ge) {
                      return { name: ge.arguments.name, path: ge.arguments.path };
                    });
                    break;
                  }
                  case "amd-module": {
                    if (fe instanceof Array) for (var Fe = 0, Z = fe; Fe < Z.length; Fe++) {
                      var Be = Z[Fe];
                      d.moduleName && D(Be.range.pos, Be.range.end - Be.range.pos, e.Diagnostics.An_AMD_module_cannot_have_multiple_name_assignments), d.moduleName = Be.arguments.name;
                    }
                    else d.moduleName = fe.arguments.name;
                    break;
                  }
                  case "ts-nocheck":
                  case "ts-check": {
                    e.forEach(e.toArray(fe), function(ge) {
                      (!d.checkJsDirective || ge.range.pos > d.checkJsDirective.pos) && (d.checkJsDirective = { enabled: g === "ts-check", end: ge.range.end, pos: ge.range.pos });
                    });
                    break;
                  }
                  case "jsx":
                  case "jsxfrag":
                  case "jsximportsource":
                  case "jsxruntime":
                    return;
                  default:
                    e.Debug.fail("Unhandled pragma kind");
                }
              });
            }
            e.processPragmasIntoFields = L;
            var P = new e.Map();
            function k(d) {
              if (P.has(d)) return P.get(d);
              var D = new RegExp("(\\s".concat(d, `\\s*=\\s*)(?:(?:'([^']*)')|(?:"([^"]*)"))`), "im");
              return P.set(d, D), D;
            }
            var Y = /^\/\/\/\s*<(\S+)\s.*?\/>/im, U = /^\/\/\/?\s*@(\S+)\s*(.*)\s*$/im;
            function j(d, D, fe) {
              var g = D.kind === 2 && Y.exec(fe);
              if (g) {
                var ne = g[1].toLowerCase(), ue = e.commentPragmas[ne];
                if (!ue || !(ue.kind & 1)) return;
                if (ue.args) {
                  for (var We = {}, Fe = 0, Z = ue.args; Fe < Z.length; Fe++) {
                    var Be = Z[Fe], ge = k(Be.name), Re = ge.exec(fe);
                    if (!Re && !Be.optional) return;
                    if (Re) {
                      var ze = Re[2] || Re[3];
                      if (Be.captureSpan) {
                        var Ee = D.pos + Re.index + Re[1].length + 1;
                        We[Be.name] = { value: ze, pos: Ee, end: Ee + ze.length };
                      } else We[Be.name] = ze;
                    }
                  }
                  d.push({ name: ne, args: { arguments: We, range: D } });
                } else d.push({ name: ne, args: { arguments: {}, range: D } });
                return;
              }
              var He = D.kind === 2 && U.exec(fe);
              if (He) return H(d, D, 2, He);
              if (D.kind === 3) for (var rr = /@(\S+)(\s+.*)?$/gim, Ie = void 0; Ie = rr.exec(fe); ) H(d, D, 4, Ie);
            }
            function H(d, D, fe, g) {
              if (!!g) {
                var ne = g[1].toLowerCase(), ue = e.commentPragmas[ne];
                if (!(!ue || !(ue.kind & fe))) {
                  var We = g[2], Fe = I(ue, We);
                  Fe !== "fail" && d.push({ name: ne, args: { arguments: Fe, range: D } });
                }
              }
            }
            function I(d, D) {
              if (!D) return {};
              if (!d.args) return {};
              for (var fe = e.trimString(D).split(/\s+/), g = {}, ne = 0; ne < d.args.length; ne++) {
                var ue = d.args[ne];
                if (!fe[ne] && !ue.optional) return "fail";
                if (ue.captureSpan) return e.Debug.fail("Capture spans not yet implemented for non-xml pragmas");
                g[ue.name] = fe[ne];
              }
              return g;
            }
            function l(d, D) {
              return d.kind !== D.kind ? false : d.kind === 79 ? d.escapedText === D.escapedText : d.kind === 108 ? true : d.name.escapedText === D.name.escapedText && l(d.expression, D.expression);
            }
            e.tagNamesAreEquivalent = l;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            e.compileOnSaveCommandLineOption = { name: "compileOnSave", type: "boolean", defaultValueDescription: false };
            var a = new e.Map(e.getEntries({ preserve: 1, "react-native": 3, react: 2, "react-jsx": 4, "react-jsxdev": 5 }));
            e.inverseJsxOptionMap = new e.Map(e.arrayFrom(e.mapIterator(a.entries(), function(Pe) {
              var Ue = Pe[0], fr = Pe[1];
              return ["" + fr, Ue];
            })));
            var C = [["es5", "lib.es5.d.ts"], ["es6", "lib.es2015.d.ts"], ["es2015", "lib.es2015.d.ts"], ["es7", "lib.es2016.d.ts"], ["es2016", "lib.es2016.d.ts"], ["es2017", "lib.es2017.d.ts"], ["es2018", "lib.es2018.d.ts"], ["es2019", "lib.es2019.d.ts"], ["es2020", "lib.es2020.d.ts"], ["es2021", "lib.es2021.d.ts"], ["es2022", "lib.es2022.d.ts"], ["esnext", "lib.esnext.d.ts"], ["dom", "lib.dom.d.ts"], ["dom.iterable", "lib.dom.iterable.d.ts"], ["webworker", "lib.webworker.d.ts"], ["webworker.importscripts", "lib.webworker.importscripts.d.ts"], ["webworker.iterable", "lib.webworker.iterable.d.ts"], ["scripthost", "lib.scripthost.d.ts"], ["es2015.core", "lib.es2015.core.d.ts"], ["es2015.collection", "lib.es2015.collection.d.ts"], ["es2015.generator", "lib.es2015.generator.d.ts"], ["es2015.iterable", "lib.es2015.iterable.d.ts"], ["es2015.promise", "lib.es2015.promise.d.ts"], ["es2015.proxy", "lib.es2015.proxy.d.ts"], ["es2015.reflect", "lib.es2015.reflect.d.ts"], ["es2015.symbol", "lib.es2015.symbol.d.ts"], ["es2015.symbol.wellknown", "lib.es2015.symbol.wellknown.d.ts"], ["es2016.array.include", "lib.es2016.array.include.d.ts"], ["es2017.object", "lib.es2017.object.d.ts"], ["es2017.sharedmemory", "lib.es2017.sharedmemory.d.ts"], ["es2017.string", "lib.es2017.string.d.ts"], ["es2017.intl", "lib.es2017.intl.d.ts"], ["es2017.typedarrays", "lib.es2017.typedarrays.d.ts"], ["es2018.asyncgenerator", "lib.es2018.asyncgenerator.d.ts"], ["es2018.asynciterable", "lib.es2018.asynciterable.d.ts"], ["es2018.intl", "lib.es2018.intl.d.ts"], ["es2018.promise", "lib.es2018.promise.d.ts"], ["es2018.regexp", "lib.es2018.regexp.d.ts"], ["es2019.array", "lib.es2019.array.d.ts"], ["es2019.object", "lib.es2019.object.d.ts"], ["es2019.string", "lib.es2019.string.d.ts"], ["es2019.symbol", "lib.es2019.symbol.d.ts"], ["es2020.bigint", "lib.es2020.bigint.d.ts"], ["es2020.date", "lib.es2020.date.d.ts"], ["es2020.promise", "lib.es2020.promise.d.ts"], ["es2020.sharedmemory", "lib.es2020.sharedmemory.d.ts"], ["es2020.string", "lib.es2020.string.d.ts"], ["es2020.symbol.wellknown", "lib.es2020.symbol.wellknown.d.ts"], ["es2020.intl", "lib.es2020.intl.d.ts"], ["es2020.number", "lib.es2020.number.d.ts"], ["es2021.promise", "lib.es2021.promise.d.ts"], ["es2021.string", "lib.es2021.string.d.ts"], ["es2021.weakref", "lib.es2021.weakref.d.ts"], ["es2021.intl", "lib.es2021.intl.d.ts"], ["es2022.array", "lib.es2022.array.d.ts"], ["es2022.error", "lib.es2022.error.d.ts"], ["es2022.intl", "lib.es2022.intl.d.ts"], ["es2022.object", "lib.es2022.object.d.ts"], ["es2022.string", "lib.es2022.string.d.ts"], ["esnext.array", "lib.es2022.array.d.ts"], ["esnext.symbol", "lib.es2019.symbol.d.ts"], ["esnext.asynciterable", "lib.es2018.asynciterable.d.ts"], ["esnext.intl", "lib.esnext.intl.d.ts"], ["esnext.bigint", "lib.es2020.bigint.d.ts"], ["esnext.string", "lib.es2022.string.d.ts"], ["esnext.promise", "lib.es2021.promise.d.ts"], ["esnext.weakref", "lib.es2021.weakref.d.ts"]];
            e.libs = C.map(function(Pe) {
              return Pe[0];
            }), e.libMap = new e.Map(C), e.optionsForWatch = [{ name: "watchFile", type: new e.Map(e.getEntries({ fixedpollinginterval: e.WatchFileKind.FixedPollingInterval, prioritypollinginterval: e.WatchFileKind.PriorityPollingInterval, dynamicprioritypolling: e.WatchFileKind.DynamicPriorityPolling, fixedchunksizepolling: e.WatchFileKind.FixedChunkSizePolling, usefsevents: e.WatchFileKind.UseFsEvents, usefseventsonparentdirectory: e.WatchFileKind.UseFsEventsOnParentDirectory })), category: e.Diagnostics.Watch_and_Build_Modes, description: e.Diagnostics.Specify_how_the_TypeScript_watch_mode_works, defaultValueDescription: e.WatchFileKind.UseFsEvents }, { name: "watchDirectory", type: new e.Map(e.getEntries({ usefsevents: e.WatchDirectoryKind.UseFsEvents, fixedpollinginterval: e.WatchDirectoryKind.FixedPollingInterval, dynamicprioritypolling: e.WatchDirectoryKind.DynamicPriorityPolling, fixedchunksizepolling: e.WatchDirectoryKind.FixedChunkSizePolling })), category: e.Diagnostics.Watch_and_Build_Modes, description: e.Diagnostics.Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality, defaultValueDescription: e.WatchDirectoryKind.UseFsEvents }, { name: "fallbackPolling", type: new e.Map(e.getEntries({ fixedinterval: e.PollingWatchKind.FixedInterval, priorityinterval: e.PollingWatchKind.PriorityInterval, dynamicpriority: e.PollingWatchKind.DynamicPriority, fixedchunksize: e.PollingWatchKind.FixedChunkSize })), category: e.Diagnostics.Watch_and_Build_Modes, description: e.Diagnostics.Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers, defaultValueDescription: e.PollingWatchKind.PriorityInterval }, { name: "synchronousWatchDirectory", type: "boolean", category: e.Diagnostics.Watch_and_Build_Modes, description: e.Diagnostics.Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively, defaultValueDescription: false }, { name: "excludeDirectories", type: "list", element: { name: "excludeDirectory", type: "string", isFilePath: true, extraValidation: Je }, category: e.Diagnostics.Watch_and_Build_Modes, description: e.Diagnostics.Remove_a_list_of_directories_from_the_watch_process }, { name: "excludeFiles", type: "list", element: { name: "excludeFile", type: "string", isFilePath: true, extraValidation: Je }, category: e.Diagnostics.Watch_and_Build_Modes, description: e.Diagnostics.Remove_a_list_of_files_from_the_watch_mode_s_processing }], e.commonOptionsWithBuild = [{ name: "help", shortName: "h", type: "boolean", showInSimplifiedHelpView: true, category: e.Diagnostics.Command_line_Options, description: e.Diagnostics.Print_this_message, defaultValueDescription: false }, { name: "help", shortName: "?", type: "boolean", defaultValueDescription: false }, { name: "watch", shortName: "w", type: "boolean", showInSimplifiedHelpView: true, isCommandLineOnly: true, category: e.Diagnostics.Command_line_Options, description: e.Diagnostics.Watch_input_files, defaultValueDescription: false }, { name: "preserveWatchOutput", type: "boolean", showInSimplifiedHelpView: false, category: e.Diagnostics.Output_Formatting, description: e.Diagnostics.Disable_wiping_the_console_in_watch_mode, defaultValueDescription: false }, { name: "listFiles", type: "boolean", category: e.Diagnostics.Compiler_Diagnostics, description: e.Diagnostics.Print_all_of_the_files_read_during_the_compilation, defaultValueDescription: false }, { name: "explainFiles", type: "boolean", category: e.Diagnostics.Compiler_Diagnostics, description: e.Diagnostics.Print_files_read_during_the_compilation_including_why_it_was_included, defaultValueDescription: false }, { name: "listEmittedFiles", type: "boolean", category: e.Diagnostics.Compiler_Diagnostics, description: e.Diagnostics.Print_the_names_of_emitted_files_after_a_compilation, defaultValueDescription: false }, { name: "pretty", type: "boolean", showInSimplifiedHelpView: true, category: e.Diagnostics.Output_Formatting, description: e.Diagnostics.Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read, defaultValueDescription: true }, { name: "traceResolution", type: "boolean", category: e.Diagnostics.Compiler_Diagnostics, description: e.Diagnostics.Log_paths_used_during_the_moduleResolution_process, defaultValueDescription: false }, { name: "diagnostics", type: "boolean", category: e.Diagnostics.Compiler_Diagnostics, description: e.Diagnostics.Output_compiler_performance_information_after_building, defaultValueDescription: false }, { name: "extendedDiagnostics", type: "boolean", category: e.Diagnostics.Compiler_Diagnostics, description: e.Diagnostics.Output_more_detailed_compiler_performance_information_after_building, defaultValueDescription: false }, { name: "generateCpuProfile", type: "string", isFilePath: true, paramType: e.Diagnostics.FILE_OR_DIRECTORY, category: e.Diagnostics.Compiler_Diagnostics, description: e.Diagnostics.Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging, defaultValueDescription: "profile.cpuprofile" }, { name: "generateTrace", type: "string", isFilePath: true, isCommandLineOnly: true, paramType: e.Diagnostics.DIRECTORY, category: e.Diagnostics.Compiler_Diagnostics, description: e.Diagnostics.Generates_an_event_trace_and_a_list_of_types }, { name: "incremental", shortName: "i", type: "boolean", category: e.Diagnostics.Projects, description: e.Diagnostics.Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects, transpileOptionValue: void 0, defaultValueDescription: e.Diagnostics.false_unless_composite_is_set }, { name: "assumeChangesOnlyAffectDirectDependencies", type: "boolean", affectsSemanticDiagnostics: true, affectsEmit: true, category: e.Diagnostics.Watch_and_Build_Modes, description: e.Diagnostics.Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it, defaultValueDescription: false }, { name: "locale", type: "string", category: e.Diagnostics.Command_line_Options, isCommandLineOnly: true, description: e.Diagnostics.Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit, defaultValueDescription: e.Diagnostics.Platform_specific }], e.targetOptionDeclaration = { name: "target", shortName: "t", type: new e.Map(e.getEntries({ es3: 0, es5: 1, es6: 2, es2015: 2, es2016: 3, es2017: 4, es2018: 5, es2019: 6, es2020: 7, es2021: 8, es2022: 9, esnext: 99 })), affectsSourceFile: true, affectsModuleResolution: true, affectsEmit: true, paramType: e.Diagnostics.VERSION, showInSimplifiedHelpView: true, category: e.Diagnostics.Language_and_Environment, description: e.Diagnostics.Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declarations, defaultValueDescription: 0 };
            var w = [{ name: "all", type: "boolean", showInSimplifiedHelpView: true, category: e.Diagnostics.Command_line_Options, description: e.Diagnostics.Show_all_compiler_options, defaultValueDescription: false }, { name: "version", shortName: "v", type: "boolean", showInSimplifiedHelpView: true, category: e.Diagnostics.Command_line_Options, description: e.Diagnostics.Print_the_compiler_s_version, defaultValueDescription: false }, { name: "init", type: "boolean", showInSimplifiedHelpView: true, category: e.Diagnostics.Command_line_Options, description: e.Diagnostics.Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file, defaultValueDescription: false }, { name: "project", shortName: "p", type: "string", isFilePath: true, showInSimplifiedHelpView: true, category: e.Diagnostics.Command_line_Options, paramType: e.Diagnostics.FILE_OR_DIRECTORY, description: e.Diagnostics.Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json }, { name: "build", type: "boolean", shortName: "b", showInSimplifiedHelpView: true, category: e.Diagnostics.Command_line_Options, description: e.Diagnostics.Build_one_or_more_projects_and_their_dependencies_if_out_of_date, defaultValueDescription: false }, { name: "showConfig", type: "boolean", showInSimplifiedHelpView: true, category: e.Diagnostics.Command_line_Options, isCommandLineOnly: true, description: e.Diagnostics.Print_the_final_configuration_instead_of_building, defaultValueDescription: false }, { name: "listFilesOnly", type: "boolean", category: e.Diagnostics.Command_line_Options, affectsSemanticDiagnostics: true, affectsEmit: true, isCommandLineOnly: true, description: e.Diagnostics.Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing, defaultValueDescription: false }, e.targetOptionDeclaration, { name: "module", shortName: "m", type: new e.Map(e.getEntries({ none: e.ModuleKind.None, commonjs: e.ModuleKind.CommonJS, amd: e.ModuleKind.AMD, system: e.ModuleKind.System, umd: e.ModuleKind.UMD, es6: e.ModuleKind.ES2015, es2015: e.ModuleKind.ES2015, es2020: e.ModuleKind.ES2020, es2022: e.ModuleKind.ES2022, esnext: e.ModuleKind.ESNext, node16: e.ModuleKind.Node16, nodenext: e.ModuleKind.NodeNext })), affectsModuleResolution: true, affectsEmit: true, paramType: e.Diagnostics.KIND, showInSimplifiedHelpView: true, category: e.Diagnostics.Modules, description: e.Diagnostics.Specify_what_module_code_is_generated, defaultValueDescription: void 0 }, { name: "lib", type: "list", element: { name: "lib", type: e.libMap, defaultValueDescription: void 0 }, affectsProgramStructure: true, showInSimplifiedHelpView: true, category: e.Diagnostics.Language_and_Environment, description: e.Diagnostics.Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment, transpileOptionValue: void 0 }, { name: "allowJs", type: "boolean", affectsModuleResolution: true, showInSimplifiedHelpView: true, category: e.Diagnostics.JavaScript_Support, description: e.Diagnostics.Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these_files, defaultValueDescription: false }, { name: "checkJs", type: "boolean", showInSimplifiedHelpView: true, category: e.Diagnostics.JavaScript_Support, description: e.Diagnostics.Enable_error_reporting_in_type_checked_JavaScript_files, defaultValueDescription: false }, { name: "jsx", type: a, affectsSourceFile: true, affectsEmit: true, affectsModuleResolution: true, paramType: e.Diagnostics.KIND, showInSimplifiedHelpView: true, category: e.Diagnostics.Language_and_Environment, description: e.Diagnostics.Specify_what_JSX_code_is_generated, defaultValueDescription: void 0 }, { name: "declaration", shortName: "d", type: "boolean", affectsEmit: true, showInSimplifiedHelpView: true, category: e.Diagnostics.Emit, transpileOptionValue: void 0, description: e.Diagnostics.Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project, defaultValueDescription: e.Diagnostics.false_unless_composite_is_set }, { name: "declarationMap", type: "boolean", affectsEmit: true, showInSimplifiedHelpView: true, category: e.Diagnostics.Emit, transpileOptionValue: void 0, defaultValueDescription: false, description: e.Diagnostics.Create_sourcemaps_for_d_ts_files }, { name: "emitDeclarationOnly", type: "boolean", affectsEmit: true, showInSimplifiedHelpView: true, category: e.Diagnostics.Emit, description: e.Diagnostics.Only_output_d_ts_files_and_not_JavaScript_files, transpileOptionValue: void 0, defaultValueDescription: false }, { name: "sourceMap", type: "boolean", affectsEmit: true, showInSimplifiedHelpView: true, category: e.Diagnostics.Emit, defaultValueDescription: false, description: e.Diagnostics.Create_source_map_files_for_emitted_JavaScript_files }, { name: "outFile", type: "string", affectsEmit: true, isFilePath: true, paramType: e.Diagnostics.FILE, showInSimplifiedHelpView: true, category: e.Diagnostics.Emit, description: e.Diagnostics.Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designates_a_file_that_bundles_all_d_ts_output, transpileOptionValue: void 0 }, { name: "outDir", type: "string", affectsEmit: true, isFilePath: true, paramType: e.Diagnostics.DIRECTORY, showInSimplifiedHelpView: true, category: e.Diagnostics.Emit, description: e.Diagnostics.Specify_an_output_folder_for_all_emitted_files }, { name: "rootDir", type: "string", affectsEmit: true, isFilePath: true, paramType: e.Diagnostics.LOCATION, category: e.Diagnostics.Modules, description: e.Diagnostics.Specify_the_root_folder_within_your_source_files, defaultValueDescription: e.Diagnostics.Computed_from_the_list_of_input_files }, { name: "composite", type: "boolean", affectsEmit: true, isTSConfigOnly: true, category: e.Diagnostics.Projects, transpileOptionValue: void 0, defaultValueDescription: false, description: e.Diagnostics.Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references }, { name: "tsBuildInfoFile", type: "string", affectsEmit: true, isFilePath: true, paramType: e.Diagnostics.FILE, category: e.Diagnostics.Projects, transpileOptionValue: void 0, defaultValueDescription: ".tsbuildinfo", description: e.Diagnostics.Specify_the_path_to_tsbuildinfo_incremental_compilation_file }, { name: "removeComments", type: "boolean", affectsEmit: true, showInSimplifiedHelpView: true, category: e.Diagnostics.Emit, defaultValueDescription: false, description: e.Diagnostics.Disable_emitting_comments }, { name: "noEmit", type: "boolean", showInSimplifiedHelpView: true, category: e.Diagnostics.Emit, description: e.Diagnostics.Disable_emitting_files_from_a_compilation, transpileOptionValue: void 0, defaultValueDescription: false }, { name: "importHelpers", type: "boolean", affectsEmit: true, category: e.Diagnostics.Emit, description: e.Diagnostics.Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file, defaultValueDescription: false }, { name: "importsNotUsedAsValues", type: new e.Map(e.getEntries({ remove: 0, preserve: 1, error: 2 })), affectsEmit: true, affectsSemanticDiagnostics: true, category: e.Diagnostics.Emit, description: e.Diagnostics.Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types, defaultValueDescription: 0 }, { name: "downlevelIteration", type: "boolean", affectsEmit: true, category: e.Diagnostics.Emit, description: e.Diagnostics.Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration, defaultValueDescription: false }, { name: "isolatedModules", type: "boolean", category: e.Diagnostics.Interop_Constraints, description: e.Diagnostics.Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports, transpileOptionValue: true, defaultValueDescription: false }, { name: "strict", type: "boolean", showInSimplifiedHelpView: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.Enable_all_strict_type_checking_options, defaultValueDescription: false }, { name: "noImplicitAny", type: "boolean", affectsSemanticDiagnostics: true, strictFlag: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type, defaultValueDescription: e.Diagnostics.false_unless_strict_is_set }, { name: "strictNullChecks", type: "boolean", affectsSemanticDiagnostics: true, strictFlag: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.When_type_checking_take_into_account_null_and_undefined, defaultValueDescription: e.Diagnostics.false_unless_strict_is_set }, { name: "strictFunctionTypes", type: "boolean", strictFlag: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible, defaultValueDescription: e.Diagnostics.false_unless_strict_is_set }, { name: "strictBindCallApply", type: "boolean", strictFlag: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function, defaultValueDescription: e.Diagnostics.false_unless_strict_is_set }, { name: "strictPropertyInitialization", type: "boolean", affectsSemanticDiagnostics: true, strictFlag: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor, defaultValueDescription: e.Diagnostics.false_unless_strict_is_set }, { name: "noImplicitThis", type: "boolean", affectsSemanticDiagnostics: true, strictFlag: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.Enable_error_reporting_when_this_is_given_the_type_any, defaultValueDescription: e.Diagnostics.false_unless_strict_is_set }, { name: "useUnknownInCatchVariables", type: "boolean", affectsSemanticDiagnostics: true, strictFlag: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.Default_catch_clause_variables_as_unknown_instead_of_any, defaultValueDescription: false }, { name: "alwaysStrict", type: "boolean", affectsSourceFile: true, strictFlag: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.Ensure_use_strict_is_always_emitted, defaultValueDescription: e.Diagnostics.false_unless_strict_is_set }, { name: "noUnusedLocals", type: "boolean", affectsSemanticDiagnostics: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.Enable_error_reporting_when_local_variables_aren_t_read, defaultValueDescription: false }, { name: "noUnusedParameters", type: "boolean", affectsSemanticDiagnostics: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.Raise_an_error_when_a_function_parameter_isn_t_read, defaultValueDescription: false }, { name: "exactOptionalPropertyTypes", type: "boolean", affectsSemanticDiagnostics: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.Interpret_optional_property_types_as_written_rather_than_adding_undefined, defaultValueDescription: false }, { name: "noImplicitReturns", type: "boolean", affectsSemanticDiagnostics: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function, defaultValueDescription: false }, { name: "noFallthroughCasesInSwitch", type: "boolean", affectsBindDiagnostics: true, affectsSemanticDiagnostics: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.Enable_error_reporting_for_fallthrough_cases_in_switch_statements, defaultValueDescription: false }, { name: "noUncheckedIndexedAccess", type: "boolean", affectsSemanticDiagnostics: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.Add_undefined_to_a_type_when_accessed_using_an_index, defaultValueDescription: false }, { name: "noImplicitOverride", type: "boolean", affectsSemanticDiagnostics: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier, defaultValueDescription: false }, { name: "noPropertyAccessFromIndexSignature", type: "boolean", showInSimplifiedHelpView: false, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type, defaultValueDescription: false }, { name: "moduleResolution", type: new e.Map(e.getEntries({ node: e.ModuleResolutionKind.NodeJs, classic: e.ModuleResolutionKind.Classic, node16: e.ModuleResolutionKind.Node16, nodenext: e.ModuleResolutionKind.NodeNext })), affectsModuleResolution: true, paramType: e.Diagnostics.STRATEGY, category: e.Diagnostics.Modules, description: e.Diagnostics.Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier, defaultValueDescription: e.Diagnostics.module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node }, { name: "baseUrl", type: "string", affectsModuleResolution: true, isFilePath: true, category: e.Diagnostics.Modules, description: e.Diagnostics.Specify_the_base_directory_to_resolve_non_relative_module_names }, { name: "paths", type: "object", affectsModuleResolution: true, isTSConfigOnly: true, category: e.Diagnostics.Modules, description: e.Diagnostics.Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations, transpileOptionValue: void 0 }, { name: "rootDirs", type: "list", isTSConfigOnly: true, element: { name: "rootDirs", type: "string", isFilePath: true }, affectsModuleResolution: true, category: e.Diagnostics.Modules, description: e.Diagnostics.Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules, transpileOptionValue: void 0, defaultValueDescription: e.Diagnostics.Computed_from_the_list_of_input_files }, { name: "typeRoots", type: "list", element: { name: "typeRoots", type: "string", isFilePath: true }, affectsModuleResolution: true, category: e.Diagnostics.Modules, description: e.Diagnostics.Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types }, { name: "types", type: "list", element: { name: "types", type: "string" }, affectsProgramStructure: true, showInSimplifiedHelpView: true, category: e.Diagnostics.Modules, description: e.Diagnostics.Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file, transpileOptionValue: void 0 }, { name: "allowSyntheticDefaultImports", type: "boolean", affectsSemanticDiagnostics: true, category: e.Diagnostics.Interop_Constraints, description: e.Diagnostics.Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export, defaultValueDescription: e.Diagnostics.module_system_or_esModuleInterop }, { name: "esModuleInterop", type: "boolean", affectsSemanticDiagnostics: true, affectsEmit: true, showInSimplifiedHelpView: true, category: e.Diagnostics.Interop_Constraints, description: e.Diagnostics.Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheticDefaultImports_for_type_compatibility, defaultValueDescription: false }, { name: "preserveSymlinks", type: "boolean", category: e.Diagnostics.Interop_Constraints, description: e.Diagnostics.Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node, defaultValueDescription: false }, { name: "allowUmdGlobalAccess", type: "boolean", affectsSemanticDiagnostics: true, category: e.Diagnostics.Modules, description: e.Diagnostics.Allow_accessing_UMD_globals_from_modules, defaultValueDescription: false }, { name: "moduleSuffixes", type: "list", element: { name: "suffix", type: "string" }, listPreserveFalsyValues: true, affectsModuleResolution: true, category: e.Diagnostics.Modules, description: e.Diagnostics.List_of_file_name_suffixes_to_search_when_resolving_a_module }, { name: "sourceRoot", type: "string", affectsEmit: true, paramType: e.Diagnostics.LOCATION, category: e.Diagnostics.Emit, description: e.Diagnostics.Specify_the_root_path_for_debuggers_to_find_the_reference_source_code }, { name: "mapRoot", type: "string", affectsEmit: true, paramType: e.Diagnostics.LOCATION, category: e.Diagnostics.Emit, description: e.Diagnostics.Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations }, { name: "inlineSourceMap", type: "boolean", affectsEmit: true, category: e.Diagnostics.Emit, description: e.Diagnostics.Include_sourcemap_files_inside_the_emitted_JavaScript, defaultValueDescription: false }, { name: "inlineSources", type: "boolean", affectsEmit: true, category: e.Diagnostics.Emit, description: e.Diagnostics.Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript, defaultValueDescription: false }, { name: "experimentalDecorators", type: "boolean", affectsSemanticDiagnostics: true, category: e.Diagnostics.Language_and_Environment, description: e.Diagnostics.Enable_experimental_support_for_TC39_stage_2_draft_decorators, defaultValueDescription: false }, { name: "emitDecoratorMetadata", type: "boolean", affectsSemanticDiagnostics: true, affectsEmit: true, category: e.Diagnostics.Language_and_Environment, description: e.Diagnostics.Emit_design_type_metadata_for_decorated_declarations_in_source_files, defaultValueDescription: false }, { name: "jsxFactory", type: "string", category: e.Diagnostics.Language_and_Environment, description: e.Diagnostics.Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h, defaultValueDescription: "`React.createElement`" }, { name: "jsxFragmentFactory", type: "string", category: e.Diagnostics.Language_and_Environment, description: e.Diagnostics.Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragment_or_Fragment, defaultValueDescription: "React.Fragment" }, { name: "jsxImportSource", type: "string", affectsSemanticDiagnostics: true, affectsEmit: true, affectsModuleResolution: true, category: e.Diagnostics.Language_and_Environment, description: e.Diagnostics.Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Asterisk, defaultValueDescription: "react" }, { name: "resolveJsonModule", type: "boolean", affectsModuleResolution: true, category: e.Diagnostics.Modules, description: e.Diagnostics.Enable_importing_json_files, defaultValueDescription: false }, { name: "out", type: "string", affectsEmit: true, isFilePath: false, category: e.Diagnostics.Backwards_Compatibility, paramType: e.Diagnostics.FILE, transpileOptionValue: void 0, description: e.Diagnostics.Deprecated_setting_Use_outFile_instead }, { name: "reactNamespace", type: "string", affectsEmit: true, category: e.Diagnostics.Language_and_Environment, description: e.Diagnostics.Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit, defaultValueDescription: "`React`" }, { name: "skipDefaultLibCheck", type: "boolean", category: e.Diagnostics.Completeness, description: e.Diagnostics.Skip_type_checking_d_ts_files_that_are_included_with_TypeScript, defaultValueDescription: false }, { name: "charset", type: "string", category: e.Diagnostics.Backwards_Compatibility, description: e.Diagnostics.No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files, defaultValueDescription: "utf8" }, { name: "emitBOM", type: "boolean", affectsEmit: true, category: e.Diagnostics.Emit, description: e.Diagnostics.Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files, defaultValueDescription: false }, { name: "newLine", type: new e.Map(e.getEntries({ crlf: 0, lf: 1 })), affectsEmit: true, paramType: e.Diagnostics.NEWLINE, category: e.Diagnostics.Emit, description: e.Diagnostics.Set_the_newline_character_for_emitting_files, defaultValueDescription: e.Diagnostics.Platform_specific }, { name: "noErrorTruncation", type: "boolean", affectsSemanticDiagnostics: true, category: e.Diagnostics.Output_Formatting, description: e.Diagnostics.Disable_truncating_types_in_error_messages, defaultValueDescription: false }, { name: "noLib", type: "boolean", category: e.Diagnostics.Language_and_Environment, affectsProgramStructure: true, description: e.Diagnostics.Disable_including_any_library_files_including_the_default_lib_d_ts, transpileOptionValue: true, defaultValueDescription: false }, { name: "noResolve", type: "boolean", affectsModuleResolution: true, category: e.Diagnostics.Modules, description: e.Diagnostics.Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add_to_a_project, transpileOptionValue: true, defaultValueDescription: false }, { name: "stripInternal", type: "boolean", affectsEmit: true, category: e.Diagnostics.Emit, description: e.Diagnostics.Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments, defaultValueDescription: false }, { name: "disableSizeLimit", type: "boolean", affectsProgramStructure: true, category: e.Diagnostics.Editor_Support, description: e.Diagnostics.Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server, defaultValueDescription: false }, { name: "disableSourceOfProjectReferenceRedirect", type: "boolean", isTSConfigOnly: true, category: e.Diagnostics.Projects, description: e.Diagnostics.Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects, defaultValueDescription: false }, { name: "disableSolutionSearching", type: "boolean", isTSConfigOnly: true, category: e.Diagnostics.Projects, description: e.Diagnostics.Opt_a_project_out_of_multi_project_reference_checking_when_editing, defaultValueDescription: false }, { name: "disableReferencedProjectLoad", type: "boolean", isTSConfigOnly: true, category: e.Diagnostics.Projects, description: e.Diagnostics.Reduce_the_number_of_projects_loaded_automatically_by_TypeScript, defaultValueDescription: false }, { name: "noImplicitUseStrict", type: "boolean", affectsSemanticDiagnostics: true, category: e.Diagnostics.Backwards_Compatibility, description: e.Diagnostics.Disable_adding_use_strict_directives_in_emitted_JavaScript_files, defaultValueDescription: false }, { name: "noEmitHelpers", type: "boolean", affectsEmit: true, category: e.Diagnostics.Emit, description: e.Diagnostics.Disable_generating_custom_helper_functions_like_extends_in_compiled_output, defaultValueDescription: false }, { name: "noEmitOnError", type: "boolean", affectsEmit: true, category: e.Diagnostics.Emit, transpileOptionValue: void 0, description: e.Diagnostics.Disable_emitting_files_if_any_type_checking_errors_are_reported, defaultValueDescription: false }, { name: "preserveConstEnums", type: "boolean", affectsEmit: true, category: e.Diagnostics.Emit, description: e.Diagnostics.Disable_erasing_const_enum_declarations_in_generated_code, defaultValueDescription: false }, { name: "declarationDir", type: "string", affectsEmit: true, isFilePath: true, paramType: e.Diagnostics.DIRECTORY, category: e.Diagnostics.Emit, transpileOptionValue: void 0, description: e.Diagnostics.Specify_the_output_directory_for_generated_declaration_files }, { name: "skipLibCheck", type: "boolean", category: e.Diagnostics.Completeness, description: e.Diagnostics.Skip_type_checking_all_d_ts_files, defaultValueDescription: false }, { name: "allowUnusedLabels", type: "boolean", affectsBindDiagnostics: true, affectsSemanticDiagnostics: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.Disable_error_reporting_for_unused_labels, defaultValueDescription: void 0 }, { name: "allowUnreachableCode", type: "boolean", affectsBindDiagnostics: true, affectsSemanticDiagnostics: true, category: e.Diagnostics.Type_Checking, description: e.Diagnostics.Disable_error_reporting_for_unreachable_code, defaultValueDescription: void 0 }, { name: "suppressExcessPropertyErrors", type: "boolean", affectsSemanticDiagnostics: true, category: e.Diagnostics.Backwards_Compatibility, description: e.Diagnostics.Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals, defaultValueDescription: false }, { name: "suppressImplicitAnyIndexErrors", type: "boolean", affectsSemanticDiagnostics: true, category: e.Diagnostics.Backwards_Compatibility, description: e.Diagnostics.Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures, defaultValueDescription: false }, { name: "forceConsistentCasingInFileNames", type: "boolean", affectsModuleResolution: true, category: e.Diagnostics.Interop_Constraints, description: e.Diagnostics.Ensure_that_casing_is_correct_in_imports, defaultValueDescription: false }, { name: "maxNodeModuleJsDepth", type: "number", affectsModuleResolution: true, category: e.Diagnostics.JavaScript_Support, description: e.Diagnostics.Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicable_with_allowJs, defaultValueDescription: 0 }, { name: "noStrictGenericChecks", type: "boolean", affectsSemanticDiagnostics: true, category: e.Diagnostics.Backwards_Compatibility, description: e.Diagnostics.Disable_strict_checking_of_generic_signatures_in_function_types, defaultValueDescription: false }, { name: "useDefineForClassFields", type: "boolean", affectsSemanticDiagnostics: true, affectsEmit: true, category: e.Diagnostics.Language_and_Environment, description: e.Diagnostics.Emit_ECMAScript_standard_compliant_class_fields, defaultValueDescription: e.Diagnostics.true_for_ES2022_and_above_including_ESNext }, { name: "preserveValueImports", type: "boolean", affectsEmit: true, category: e.Diagnostics.Emit, description: e.Diagnostics.Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed, defaultValueDescription: false }, { name: "keyofStringsOnly", type: "boolean", category: e.Diagnostics.Backwards_Compatibility, description: e.Diagnostics.Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option, defaultValueDescription: false }, { name: "plugins", type: "list", isTSConfigOnly: true, element: { name: "plugin", type: "object" }, description: e.Diagnostics.Specify_a_list_of_language_service_plugins_to_include, category: e.Diagnostics.Editor_Support }, { name: "moduleDetection", type: new e.Map(e.getEntries({ auto: e.ModuleDetectionKind.Auto, legacy: e.ModuleDetectionKind.Legacy, force: e.ModuleDetectionKind.Force })), affectsModuleResolution: true, description: e.Diagnostics.Control_what_method_is_used_to_detect_module_format_JS_files, category: e.Diagnostics.Language_and_Environment, defaultValueDescription: e.Diagnostics.auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_with_module_Colon_node16_as_modules }];
            e.optionDeclarations = Ve(Ve([], e.commonOptionsWithBuild, true), w, true), e.semanticDiagnosticsOptionDeclarations = e.optionDeclarations.filter(function(Pe) {
              return !!Pe.affectsSemanticDiagnostics;
            }), e.affectsEmitOptionDeclarations = e.optionDeclarations.filter(function(Pe) {
              return !!Pe.affectsEmit;
            }), e.moduleResolutionOptionDeclarations = e.optionDeclarations.filter(function(Pe) {
              return !!Pe.affectsModuleResolution;
            }), e.sourceFileAffectingCompilerOptions = e.optionDeclarations.filter(function(Pe) {
              return !!Pe.affectsSourceFile || !!Pe.affectsModuleResolution || !!Pe.affectsBindDiagnostics;
            }), e.optionsAffectingProgramStructure = e.optionDeclarations.filter(function(Pe) {
              return !!Pe.affectsProgramStructure;
            }), e.transpileOptionValueCompilerOptions = e.optionDeclarations.filter(function(Pe) {
              return e.hasProperty(Pe, "transpileOptionValue");
            }), e.optionsForBuild = [{ name: "verbose", shortName: "v", category: e.Diagnostics.Command_line_Options, description: e.Diagnostics.Enable_verbose_logging, type: "boolean", defaultValueDescription: false }, { name: "dry", shortName: "d", category: e.Diagnostics.Command_line_Options, description: e.Diagnostics.Show_what_would_be_built_or_deleted_if_specified_with_clean, type: "boolean", defaultValueDescription: false }, { name: "force", shortName: "f", category: e.Diagnostics.Command_line_Options, description: e.Diagnostics.Build_all_projects_including_those_that_appear_to_be_up_to_date, type: "boolean", defaultValueDescription: false }, { name: "clean", category: e.Diagnostics.Command_line_Options, description: e.Diagnostics.Delete_the_outputs_of_all_projects, type: "boolean", defaultValueDescription: false }], e.buildOpts = Ve(Ve([], e.commonOptionsWithBuild, true), e.optionsForBuild, true), e.typeAcquisitionDeclarations = [{ name: "enableAutoDiscovery", type: "boolean", defaultValueDescription: false }, { name: "enable", type: "boolean", defaultValueDescription: false }, { name: "include", type: "list", element: { name: "include", type: "string" } }, { name: "exclude", type: "list", element: { name: "exclude", type: "string" } }, { name: "disableFilenameBasedTypeAcquisition", type: "boolean", defaultValueDescription: false }];
            function B(Pe) {
              var Ue = new e.Map(), fr = new e.Map();
              return e.forEach(Pe, function(De) {
                Ue.set(De.name.toLowerCase(), De), De.shortName && fr.set(De.shortName, De.name);
              }), { optionsNameMap: Ue, shortOptionNames: fr };
            }
            e.createOptionNameMap = B;
            var E;
            function Q() {
              return E || (E = B(e.optionDeclarations));
            }
            e.getOptionsNameMap = Q;
            var le = { diagnostic: e.Diagnostics.Compiler_option_0_may_only_be_used_with_build, getOptionsNameMap: q };
            e.defaultInitCompilerOptions = { module: e.ModuleKind.CommonJS, target: 3, strict: true, esModuleInterop: true, forceConsistentCasingInFileNames: true, skipLibCheck: true };
            function N(Pe) {
              return Pe && Pe.enableAutoDiscovery !== void 0 && Pe.enable === void 0 ? { enable: Pe.enableAutoDiscovery, include: Pe.include || [], exclude: Pe.exclude || [] } : Pe;
            }
            e.convertEnableAutoDiscoveryToEnable = N;
            function p(Pe) {
              return m(Pe, e.createCompilerDiagnostic);
            }
            e.createCompilerDiagnosticForInvalidCustomType = p;
            function m(Pe, Ue) {
              var fr = e.arrayFrom(Pe.type.keys()).map(function(De) {
                return "'".concat(De, "'");
              }).join(", ");
              return Ue(e.Diagnostics.Argument_for_0_option_must_be_Colon_1, "--".concat(Pe.name), fr);
            }
            function G(Pe, Ue, fr) {
              return _r(Pe, e.trimString(Ue || ""), fr);
            }
            e.parseCustomTypeOption = G;
            function oe(Pe, Ue, fr) {
              if (Ue === void 0 && (Ue = ""), Ue = e.trimString(Ue), !e.startsWith(Ue, "-")) {
                if (Ue === "") return [];
                var De = Ue.split(",");
                switch (Pe.element.type) {
                  case "number":
                    return e.mapDefined(De, function(gr) {
                      return Zt(Pe.element, parseInt(gr), fr);
                    });
                  case "string":
                    return e.mapDefined(De, function(gr) {
                      return Zt(Pe.element, gr || "", fr);
                    });
                  default:
                    return e.mapDefined(De, function(gr) {
                      return G(Pe.element, gr, fr);
                    });
                }
              }
            }
            e.parseListTypeOption = oe;
            function f(Pe) {
              return Pe.name;
            }
            function T(Pe, Ue, fr, De) {
              var gr;
              if (!((gr = Ue.alternateMode) === null || gr === void 0) && gr.getOptionsNameMap().optionsNameMap.has(Pe.toLowerCase())) return fr(Ue.alternateMode.diagnostic, Pe);
              var Vr = e.getSpellingSuggestion(Pe, Ue.optionDeclarations, f);
              return Vr ? fr(Ue.unknownDidYouMeanDiagnostic, De || Pe, Vr.name) : fr(Ue.unknownOptionDiagnostic, De || Pe);
            }
            function K(Pe, Ue, fr) {
              var De = {}, gr, Vr = [], Tr = [];
              return vi(Ue), { options: De, watchOptions: gr, fileNames: Vr, errors: Tr };
              function vi(Yi) {
                for (var Wi = 0; Wi < Yi.length; ) {
                  var ct = Yi[Wi];
                  if (Wi++, ct.charCodeAt(0) === 64) Ui(ct.slice(1));
                  else if (ct.charCodeAt(0) === 45) {
                    var Li = ct.slice(ct.charCodeAt(1) === 45 ? 2 : 1), nt = ie(Pe.getOptionsNameMap, Li, true);
                    if (nt) Wi = b(Yi, Wi, Pe, nt, De, Tr);
                    else {
                      var Mt = ie(k.getOptionsNameMap, Li, true);
                      Mt ? Wi = b(Yi, Wi, k, Mt, gr || (gr = {}), Tr) : Tr.push(T(Li, Pe, e.createCompilerDiagnostic, ct));
                    }
                  } else Vr.push(ct);
                }
              }
              function Ui(Yi) {
                var Wi = A(Yi, fr || function(Mt) {
                  return e.sys.readFile(Mt);
                });
                if (!e.isString(Wi)) {
                  Tr.push(Wi);
                  return;
                }
                for (var ct = [], Li = 0; ; ) {
                  for (; Li < Wi.length && Wi.charCodeAt(Li) <= 32; ) Li++;
                  if (Li >= Wi.length) break;
                  var nt = Li;
                  if (Wi.charCodeAt(nt) === 34) {
                    for (Li++; Li < Wi.length && Wi.charCodeAt(Li) !== 34; ) Li++;
                    Li < Wi.length ? (ct.push(Wi.substring(nt + 1, Li)), Li++) : Tr.push(e.createCompilerDiagnostic(e.Diagnostics.Unterminated_quoted_string_in_response_file_0, Yi));
                  } else {
                    for (; Wi.charCodeAt(Li) > 32; ) Li++;
                    ct.push(Wi.substring(nt, Li));
                  }
                }
                vi(ct);
              }
            }
            e.parseCommandLineWorker = K;
            function b(Pe, Ue, fr, De, gr, Vr) {
              if (De.isTSConfigOnly) {
                var Tr = Pe[Ue];
                Tr === "null" ? (gr[De.name] = void 0, Ue++) : De.type === "boolean" ? Tr === "false" ? (gr[De.name] = Zt(De, false, Vr), Ue++) : (Tr === "true" && Ue++, Vr.push(e.createCompilerDiagnostic(e.Diagnostics.Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line, De.name))) : (Vr.push(e.createCompilerDiagnostic(e.Diagnostics.Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line, De.name)), Tr && !e.startsWith(Tr, "-") && Ue++);
              } else if (!Pe[Ue] && De.type !== "boolean" && Vr.push(e.createCompilerDiagnostic(fr.optionTypeMismatchDiagnostic, De.name, ue(De))), Pe[Ue] !== "null") switch (De.type) {
                case "number":
                  gr[De.name] = Zt(De, parseInt(Pe[Ue]), Vr), Ue++;
                  break;
                case "boolean":
                  var Tr = Pe[Ue];
                  gr[De.name] = Zt(De, Tr !== "false", Vr), (Tr === "false" || Tr === "true") && Ue++;
                  break;
                case "string":
                  gr[De.name] = Zt(De, Pe[Ue] || "", Vr), Ue++;
                  break;
                case "list":
                  var vi = oe(De, Pe[Ue], Vr);
                  gr[De.name] = vi || [], vi && Ue++;
                  break;
                default:
                  gr[De.name] = G(De, Pe[Ue], Vr), Ue++;
                  break;
              }
              else gr[De.name] = void 0, Ue++;
              return Ue;
            }
            e.compilerOptionsDidYouMeanDiagnostics = { alternateMode: le, getOptionsNameMap: Q, optionDeclarations: e.optionDeclarations, unknownOptionDiagnostic: e.Diagnostics.Unknown_compiler_option_0, unknownDidYouMeanDiagnostic: e.Diagnostics.Unknown_compiler_option_0_Did_you_mean_1, optionTypeMismatchDiagnostic: e.Diagnostics.Compiler_option_0_expects_an_argument };
            function se(Pe, Ue) {
              return K(e.compilerOptionsDidYouMeanDiagnostics, Pe, Ue);
            }
            e.parseCommandLine = se;
            function J(Pe, Ue) {
              return ie(Q, Pe, Ue);
            }
            e.getOptionFromName = J;
            function ie(Pe, Ue, fr) {
              fr === void 0 && (fr = false), Ue = Ue.toLowerCase();
              var De = Pe(), gr = De.optionsNameMap, Vr = De.shortOptionNames;
              if (fr) {
                var Tr = Vr.get(Ue);
                Tr !== void 0 && (Ue = Tr);
              }
              return gr.get(Ue);
            }
            var R;
            function q() {
              return R || (R = B(e.buildOpts));
            }
            var O = { diagnostic: e.Diagnostics.Compiler_option_0_may_not_be_used_with_build, getOptionsNameMap: Q }, ve = { alternateMode: O, getOptionsNameMap: q, optionDeclarations: e.buildOpts, unknownOptionDiagnostic: e.Diagnostics.Unknown_build_option_0, unknownDidYouMeanDiagnostic: e.Diagnostics.Unknown_build_option_0_Did_you_mean_1, optionTypeMismatchDiagnostic: e.Diagnostics.Build_option_0_requires_a_value_of_type_1 };
            function ee(Pe) {
              var Ue = K(ve, Pe), fr = Ue.options, De = Ue.watchOptions, gr = Ue.fileNames, Vr = Ue.errors, Tr = fr;
              return gr.length === 0 && gr.push("."), Tr.clean && Tr.force && Vr.push(e.createCompilerDiagnostic(e.Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "force")), Tr.clean && Tr.verbose && Vr.push(e.createCompilerDiagnostic(e.Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "verbose")), Tr.clean && Tr.watch && Vr.push(e.createCompilerDiagnostic(e.Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "watch")), Tr.watch && Tr.dry && Vr.push(e.createCompilerDiagnostic(e.Diagnostics.Options_0_and_1_cannot_be_combined, "watch", "dry")), { buildOptions: Tr, watchOptions: De, projects: gr, errors: Vr };
            }
            e.parseBuildCommand = ee;
            function he(Pe) {
              for (var Ue = [], fr = 1; fr < arguments.length; fr++) Ue[fr - 1] = arguments[fr];
              var De = e.createCompilerDiagnostic.apply(void 0, arguments);
              return De.messageText;
            }
            e.getDiagnosticText = he;
            function F(Pe, Ue, fr, De, gr, Vr) {
              var Tr = A(Pe, function(Yi) {
                return fr.readFile(Yi);
              });
              if (!e.isString(Tr)) {
                fr.onUnRecoverableConfigFileDiagnostic(Tr);
                return;
              }
              var vi = e.parseJsonText(Pe, Tr), Ui = fr.getCurrentDirectory();
              return vi.path = e.toPath(Pe, Ui, e.createGetCanonicalFileName(fr.useCaseSensitiveFileNames)), vi.resolvedPath = vi.path, vi.originalFileName = vi.fileName, er(vi, fr, e.getNormalizedAbsolutePath(e.getDirectoryPath(Pe), Ui), Ue, e.getNormalizedAbsolutePath(Pe, Ui), void 0, Vr, De, gr);
            }
            e.getParsedCommandLineOfConfigFile = F;
            function x(Pe, Ue) {
              var fr = A(Pe, Ue);
              return e.isString(fr) ? X(Pe, fr) : { config: {}, error: fr };
            }
            e.readConfigFile = x;
            function X(Pe, Ue) {
              var fr = e.parseJsonText(Pe, Ue);
              return { config: fe(fr, fr.parseDiagnostics, false, void 0), error: fr.parseDiagnostics.length ? fr.parseDiagnostics[0] : void 0 };
            }
            e.parseConfigFileTextToJson = X;
            function $(Pe, Ue) {
              var fr = A(Pe, Ue);
              return e.isString(fr) ? e.parseJsonText(Pe, fr) : { fileName: Pe, parseDiagnostics: [fr] };
            }
            e.readJsonConfigFile = $;
            function A(Pe, Ue) {
              var fr;
              try {
                fr = Ue(Pe);
              } catch (De) {
                return e.createCompilerDiagnostic(e.Diagnostics.Cannot_read_file_0_Colon_1, Pe, De.message);
              }
              return fr === void 0 ? e.createCompilerDiagnostic(e.Diagnostics.Cannot_read_file_0, Pe) : fr;
            }
            e.tryReadFile = A;
            function y(Pe) {
              return e.arrayToMap(Pe, f);
            }
            var V = { optionDeclarations: e.typeAcquisitionDeclarations, unknownOptionDiagnostic: e.Diagnostics.Unknown_type_acquisition_option_0, unknownDidYouMeanDiagnostic: e.Diagnostics.Unknown_type_acquisition_option_0_Did_you_mean_1 }, L;
            function P() {
              return L || (L = B(e.optionsForWatch));
            }
            var k = { getOptionsNameMap: P, optionDeclarations: e.optionsForWatch, unknownOptionDiagnostic: e.Diagnostics.Unknown_watch_option_0, unknownDidYouMeanDiagnostic: e.Diagnostics.Unknown_watch_option_0_Did_you_mean_1, optionTypeMismatchDiagnostic: e.Diagnostics.Watch_option_0_requires_a_value_of_type_1 }, Y;
            function U() {
              return Y || (Y = y(e.optionDeclarations));
            }
            var j;
            function H() {
              return j || (j = y(e.optionsForWatch));
            }
            var I;
            function l() {
              return I || (I = y(e.typeAcquisitionDeclarations));
            }
            var d;
            function D() {
              return d === void 0 && (d = { name: void 0, type: "object", elementOptions: y([{ name: "compilerOptions", type: "object", elementOptions: U(), extraKeyDiagnostics: e.compilerOptionsDidYouMeanDiagnostics }, { name: "watchOptions", type: "object", elementOptions: H(), extraKeyDiagnostics: k }, { name: "typingOptions", type: "object", elementOptions: l(), extraKeyDiagnostics: V }, { name: "typeAcquisition", type: "object", elementOptions: l(), extraKeyDiagnostics: V }, { name: "extends", type: "string", category: e.Diagnostics.File_Management }, { name: "references", type: "list", element: { name: "references", type: "object" }, category: e.Diagnostics.Projects }, { name: "files", type: "list", element: { name: "files", type: "string" }, category: e.Diagnostics.File_Management }, { name: "include", type: "list", element: { name: "include", type: "string" }, category: e.Diagnostics.File_Management, defaultValueDescription: e.Diagnostics.if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk }, { name: "exclude", type: "list", element: { name: "exclude", type: "string" }, category: e.Diagnostics.File_Management, defaultValueDescription: e.Diagnostics.node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified }, e.compileOnSaveCommandLineOption]) }), d;
            }
            function fe(Pe, Ue, fr, De) {
              var gr, Vr = (gr = Pe.statements[0]) === null || gr === void 0 ? void 0 : gr.expression, Tr = fr ? D() : void 0;
              if (Vr && Vr.kind !== 205) {
                if (Ue.push(e.createDiagnosticForNodeInSourceFile(Pe, Vr, e.Diagnostics.The_root_value_of_a_0_file_must_be_an_object, e.getBaseFileName(Pe.fileName) === "jsconfig.json" ? "jsconfig.json" : "tsconfig.json")), e.isArrayLiteralExpression(Vr)) {
                  var vi = e.find(Vr.elements, e.isObjectLiteralExpression);
                  if (vi) return ne(Pe, vi, Ue, true, Tr, De);
                }
                return {};
              }
              return ne(Pe, Vr, Ue, true, Tr, De);
            }
            function g(Pe, Ue) {
              var fr;
              return ne(Pe, (fr = Pe.statements[0]) === null || fr === void 0 ? void 0 : fr.expression, Ue, true, void 0, void 0);
            }
            e.convertToObject = g;
            function ne(Pe, Ue, fr, De, gr, Vr) {
              if (!Ue) return De ? {} : void 0;
              return Yi(Ue, gr);
              function Tr(ct) {
                return gr && gr.elementOptions === ct;
              }
              function vi(ct, Li, nt, Mt) {
                for (var xt = De ? {} : void 0, ut = function(Ki) {
                  if (Ki.kind !== 296) return fr.push(e.createDiagnosticForNodeInSourceFile(Pe, Ki, e.Diagnostics.Property_assignment_expected)), "continue";
                  Ki.questionToken && fr.push(e.createDiagnosticForNodeInSourceFile(Pe, Ki.questionToken, e.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, "?")), Wi(Ki.name) || fr.push(e.createDiagnosticForNodeInSourceFile(Pe, Ki.name, e.Diagnostics.String_literal_with_double_quotes_expected));
                  var Fi = e.isComputedNonLiteralName(Ki.name) ? void 0 : e.getTextOfPropertyName(Ki.name), ui = Fi && e.unescapeLeadingUnderscores(Fi), Bt = ui && Li ? Li.get(ui) : void 0;
                  ui && nt && !Bt && (Li ? fr.push(T(ui, nt, function(Ai, Oi, ji) {
                    return e.createDiagnosticForNodeInSourceFile(Pe, Ki.name, Ai, Oi, ji);
                  })) : fr.push(e.createDiagnosticForNodeInSourceFile(Pe, Ki.name, nt.unknownOptionDiagnostic, ui)));
                  var wt = Yi(Ki.initializer, Bt);
                  if (typeof ui < "u" && (De && (xt[ui] = wt), Vr && (Mt || Tr(Li)))) {
                    var na = We(Bt, wt);
                    Mt ? na && Vr.onSetValidOptionKeyValueInParent(Mt, Bt, wt) : Tr(Li) && (na ? Vr.onSetValidOptionKeyValueInRoot(ui, Ki.name, wt, Ki.initializer) : Bt || Vr.onSetUnknownOptionKeyValueInRoot(ui, Ki.name, wt, Ki.initializer));
                  }
                }, Dt = 0, Rt = ct.properties; Dt < Rt.length; Dt++) {
                  var Ii = Rt[Dt];
                  ut(Ii);
                }
                return xt;
              }
              function Ui(ct, Li) {
                if (!De) {
                  ct.forEach(function(nt) {
                    return Yi(nt, Li);
                  });
                  return;
                }
                return e.filter(ct.map(function(nt) {
                  return Yi(nt, Li);
                }), function(nt) {
                  return nt !== void 0;
                });
              }
              function Yi(ct, Li) {
                var nt;
                switch (ct.kind) {
                  case 110:
                    return ui(Li && Li.type !== "boolean"), Fi(true);
                  case 95:
                    return ui(Li && Li.type !== "boolean"), Fi(false);
                  case 104:
                    return ui(Li && Li.name === "extends"), Fi(null);
                  case 10:
                    Wi(ct) || fr.push(e.createDiagnosticForNodeInSourceFile(Pe, ct, e.Diagnostics.String_literal_with_double_quotes_expected)), ui(Li && e.isString(Li.type) && Li.type !== "string");
                    var Mt = ct.text;
                    if (Li && !e.isString(Li.type)) {
                      var xt = Li;
                      xt.type.has(Mt.toLowerCase()) || (fr.push(m(xt, function(Bt, wt, na) {
                        return e.createDiagnosticForNodeInSourceFile(Pe, ct, Bt, wt, na);
                      })), nt = true);
                    }
                    return Fi(Mt);
                  case 8:
                    return ui(Li && Li.type !== "number"), Fi(Number(ct.text));
                  case 219:
                    if (ct.operator !== 40 || ct.operand.kind !== 8) break;
                    return ui(Li && Li.type !== "number"), Fi(-Number(ct.operand.text));
                  case 205:
                    ui(Li && Li.type !== "object");
                    var ut = ct;
                    if (Li) {
                      var Dt = Li, Rt = Dt.elementOptions, Ii = Dt.extraKeyDiagnostics, Ki = Dt.name;
                      return Fi(vi(ut, Rt, Ii, Ki));
                    } else return Fi(vi(ut, void 0, void 0, void 0));
                  case 204:
                    return ui(Li && Li.type !== "list"), Fi(Ui(ct.elements, Li && Li.element));
                }
                Li ? ui(true) : fr.push(e.createDiagnosticForNodeInSourceFile(Pe, ct, e.Diagnostics.Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal));
                return;
                function Fi(Bt) {
                  var wt;
                  if (!nt) {
                    var na = (wt = Li == null ? void 0 : Li.extraValidation) === null || wt === void 0 ? void 0 : wt.call(Li, Bt);
                    if (na) {
                      fr.push(e.createDiagnosticForNodeInSourceFile.apply(void 0, Ve([Pe, ct], na, false)));
                      return;
                    }
                  }
                  return Bt;
                }
                function ui(Bt) {
                  Bt && (fr.push(e.createDiagnosticForNodeInSourceFile(Pe, ct, e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, Li.name, ue(Li))), nt = true);
                }
              }
              function Wi(ct) {
                return e.isStringLiteral(ct) && e.isStringDoubleQuoted(ct, Pe);
              }
            }
            e.convertToObjectWorker = ne;
            function ue(Pe) {
              return Pe.type === "list" ? "Array" : e.isString(Pe.type) ? Pe.type : "string";
            }
            function We(Pe, Ue) {
              if (Pe) {
                if (Cr(Ue)) return true;
                if (Pe.type === "list") return e.isArray(Ue);
                var fr = e.isString(Pe.type) ? Pe.type : "string";
                return typeof Ue === fr;
              }
              return false;
            }
            function Fe(Pe, Ue, fr) {
              var De, gr, Vr, Tr = e.createGetCanonicalFileName(fr.useCaseSensitiveFileNames), vi = e.map(e.filter(Pe.fileNames, !((gr = (De = Pe.options.configFile) === null || De === void 0 ? void 0 : De.configFileSpecs) === null || gr === void 0) && gr.validatedIncludeSpecs ? ge(Ue, Pe.options.configFile.configFileSpecs.validatedIncludeSpecs, Pe.options.configFile.configFileSpecs.validatedExcludeSpecs, fr) : e.returnTrue), function(ct) {
                return e.getRelativePathFromFile(e.getNormalizedAbsolutePath(Ue, fr.getCurrentDirectory()), e.getNormalizedAbsolutePath(ct, fr.getCurrentDirectory()), Tr);
              }), Ui = Ee(Pe.options, { configFilePath: e.getNormalizedAbsolutePath(Ue, fr.getCurrentDirectory()), useCaseSensitiveFileNames: fr.useCaseSensitiveFileNames }), Yi = Pe.watchOptions && He(Pe.watchOptions), Wi = Ke(Ke({ compilerOptions: Ke(Ke({}, Z(Ui)), { showConfig: void 0, configFile: void 0, configFilePath: void 0, help: void 0, init: void 0, listFiles: void 0, listEmittedFiles: void 0, project: void 0, build: void 0, version: void 0 }), watchOptions: Yi && Z(Yi), references: e.map(Pe.projectReferences, function(ct) {
                return Ke(Ke({}, ct), { path: ct.originalPath ? ct.originalPath : "", originalPath: void 0 });
              }), files: e.length(vi) ? vi : void 0 }, !((Vr = Pe.options.configFile) === null || Vr === void 0) && Vr.configFileSpecs ? { include: Be(Pe.options.configFile.configFileSpecs.validatedIncludeSpecs), exclude: Pe.options.configFile.configFileSpecs.validatedExcludeSpecs } : {}), { compileOnSave: Pe.compileOnSave ? true : void 0 });
              return Wi;
            }
            e.convertToTSConfig = Fe;
            function Z(Pe) {
              return Ke({}, e.arrayFrom(Pe.entries()).reduce(function(Ue, fr) {
                var De;
                return Ke(Ke({}, Ue), (De = {}, De[fr[0]] = fr[1], De));
              }, {}));
            }
            function Be(Pe) {
              if (!!e.length(Pe)) {
                if (e.length(Pe) !== 1) return Pe;
                if (Pe[0] !== "**/*") return Pe;
              }
            }
            function ge(Pe, Ue, fr, De) {
              if (!Ue) return e.returnTrue;
              var gr = e.getFileMatcherPatterns(Pe, fr, Ue, De.useCaseSensitiveFileNames, De.getCurrentDirectory()), Vr = gr.excludePattern && e.getRegexFromPattern(gr.excludePattern, De.useCaseSensitiveFileNames), Tr = gr.includeFilePattern && e.getRegexFromPattern(gr.includeFilePattern, De.useCaseSensitiveFileNames);
              return Tr ? Vr ? function(vi) {
                return !(Tr.test(vi) && !Vr.test(vi));
              } : function(vi) {
                return !Tr.test(vi);
              } : Vr ? function(vi) {
                return Vr.test(vi);
              } : e.returnTrue;
            }
            function Re(Pe) {
              if (!(Pe.type === "string" || Pe.type === "number" || Pe.type === "boolean" || Pe.type === "object")) return Pe.type === "list" ? Re(Pe.element) : Pe.type;
            }
            function ze(Pe, Ue) {
              return e.forEachEntry(Ue, function(fr, De) {
                if (fr === Pe) return De;
              });
            }
            function Ee(Pe, Ue) {
              return rr(Pe, Q(), Ue);
            }
            function He(Pe) {
              return rr(Pe, P());
            }
            function rr(Pe, Ue, fr) {
              var De = Ue.optionsNameMap, gr = new e.Map(), Vr = fr && e.createGetCanonicalFileName(fr.useCaseSensitiveFileNames), Tr = function(Ui) {
                if (e.hasProperty(Pe, Ui)) {
                  if (De.has(Ui) && (De.get(Ui).category === e.Diagnostics.Command_line_Options || De.get(Ui).category === e.Diagnostics.Output_Formatting)) return "continue";
                  var Yi = Pe[Ui], Wi = De.get(Ui.toLowerCase());
                  if (Wi) {
                    var ct = Re(Wi);
                    ct ? Wi.type === "list" ? gr.set(Ui, Yi.map(function(Li) {
                      return ze(Li, ct);
                    })) : gr.set(Ui, ze(Yi, ct)) : fr && Wi.isFilePath ? gr.set(Ui, e.getRelativePathFromFile(fr.configFilePath, e.getNormalizedAbsolutePath(Yi, e.getDirectoryPath(fr.configFilePath)), Vr)) : gr.set(Ui, Yi);
                  }
                }
              };
              for (var vi in Pe) Tr(vi);
              return gr;
            }
            function Ie(Pe, Ue) {
              var fr = _e(Pe);
              return gr();
              function De(Vr) {
                return Array(Vr + 1).join(" ");
              }
              function gr() {
                var Vr = [], Tr = De(2);
                return w.forEach(function(vi) {
                  if (!!fr.has(vi.name)) {
                    var Ui = fr.get(vi.name), Yi = Mr(vi);
                    Ui !== Yi ? Vr.push("".concat(Tr).concat(vi.name, ": ").concat(Ui)) : e.hasProperty(e.defaultInitCompilerOptions, vi.name) && Vr.push("".concat(Tr).concat(vi.name, ": ").concat(Yi));
                  }
                }), Vr.join(Ue) + Ue;
              }
            }
            e.getCompilerOptionsDiffValue = Ie;
            function _e(Pe) {
              var Ue = e.extend(Pe, e.defaultInitCompilerOptions);
              return Ee(Ue);
            }
            function we(Pe, Ue, fr) {
              var De = _e(Pe);
              return Tr();
              function gr(vi) {
                return Array(vi + 1).join(" ");
              }
              function Vr(vi) {
                var Ui = vi.category, Yi = vi.name, Wi = vi.isCommandLineOnly, ct = [e.Diagnostics.Command_line_Options, e.Diagnostics.Editor_Support, e.Diagnostics.Compiler_Diagnostics, e.Diagnostics.Backwards_Compatibility, e.Diagnostics.Watch_and_Build_Modes, e.Diagnostics.Output_Formatting];
                return !Wi && Ui !== void 0 && (!ct.includes(Ui) || De.has(Yi));
              }
              function Tr() {
                for (var vi = e.createMultiMap(), Ui = 0, Yi = e.optionDeclarations; Ui < Yi.length; Ui++) {
                  var Wi = Yi[Ui], ct = Wi.category;
                  Vr(Wi) && vi.add(e.getLocaleSpecificMessage(ct), Wi);
                }
                var Li = 0, nt = 0, Mt = [];
                vi.forEach(function(wt, na) {
                  Mt.length !== 0 && Mt.push({ value: "" }), Mt.push({ value: "/* ".concat(na, " */") });
                  for (var Ai = 0, Oi = wt; Ai < Oi.length; Ai++) {
                    var ji = Oi[Ai], Vi = void 0;
                    De.has(ji.name) ? Vi = '"'.concat(ji.name, '": ').concat(JSON.stringify(De.get(ji.name))).concat((nt += 1) === De.size ? "" : ",") : Vi = '// "'.concat(ji.name, '": ').concat(JSON.stringify(Mr(ji)), ","), Mt.push({ value: Vi, description: "/* ".concat(ji.description && e.getLocaleSpecificMessage(ji.description) || ji.name, " */") }), Li = Math.max(Vi.length, Li);
                  }
                });
                var xt = gr(2), ut = [];
                ut.push("{"), ut.push("".concat(xt, '"compilerOptions": {')), ut.push("".concat(xt).concat(xt, "/* ").concat(e.getLocaleSpecificMessage(e.Diagnostics.Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file), " */")), ut.push("");
                for (var Dt = 0, Rt = Mt; Dt < Rt.length; Dt++) {
                  var Ii = Rt[Dt], Ki = Ii.value, Fi = Ii.description, ui = Fi === void 0 ? "" : Fi;
                  ut.push(Ki && "".concat(xt).concat(xt).concat(Ki).concat(ui && gr(Li - Ki.length + 2) + ui));
                }
                if (Ue.length) {
                  ut.push("".concat(xt, "},")), ut.push("".concat(xt, '"files": ['));
                  for (var Bt = 0; Bt < Ue.length; Bt++) ut.push("".concat(xt).concat(xt).concat(JSON.stringify(Ue[Bt])).concat(Bt === Ue.length - 1 ? "" : ","));
                  ut.push("".concat(xt, "]"));
                } else ut.push("".concat(xt, "}"));
                return ut.push("}"), ut.join(fr) + fr;
              }
            }
            e.generateTSConfig = we;
            function de(Pe, Ue) {
              var fr = {}, De = Q().optionsNameMap;
              for (var gr in Pe) e.hasProperty(Pe, gr) && (fr[gr] = ye(De.get(gr.toLowerCase()), Pe[gr], Ue));
              return fr.configFilePath && (fr.configFilePath = Ue(fr.configFilePath)), fr;
            }
            e.convertToOptionsWithAbsolutePaths = de;
            function ye(Pe, Ue, fr) {
              if (Pe && !Cr(Ue)) {
                if (Pe.type === "list") {
                  var De = Ue;
                  if (Pe.element.isFilePath && De.length) return De.map(fr);
                } else if (Pe.isFilePath) return fr(Ue);
              }
              return Ue;
            }
            function Ae(Pe, Ue, fr, De, gr, Vr, Tr, vi, Ui) {
              return Br(Pe, void 0, Ue, fr, De, Ui, gr, Vr, Tr, vi);
            }
            e.parseJsonConfigFileContent = Ae;
            function er(Pe, Ue, fr, De, gr, Vr, Tr, vi, Ui) {
              e.tracing === null || e.tracing === void 0 || e.tracing.push("parse", "parseJsonSourceFileConfigFileContent", { path: Pe.fileName });
              var Yi = Br(void 0, Pe, Ue, fr, De, Ui, gr, Vr, Tr, vi);
              return e.tracing === null || e.tracing === void 0 || e.tracing.pop(), Yi;
            }
            e.parseJsonSourceFileConfigFileContent = er;
            function ir(Pe, Ue) {
              Ue && Object.defineProperty(Pe, "configFile", { enumerable: false, writable: false, value: Ue });
            }
            e.setConfigFileInOptions = ir;
            function Cr(Pe) {
              return Pe == null;
            }
            function Ye(Pe, Ue) {
              return e.getDirectoryPath(e.getNormalizedAbsolutePath(Pe, Ue));
            }
            function Br(Pe, Ue, fr, De, gr, Vr, Tr, vi, Ui, Yi) {
              gr === void 0 && (gr = {}), vi === void 0 && (vi = []), Ui === void 0 && (Ui = []), e.Debug.assert(Pe === void 0 && Ue !== void 0 || Pe !== void 0 && Ue === void 0);
              var Wi = [], ct = ur(Pe, Ue, fr, De, Tr, vi, Wi, Yi), Li = ct.raw, nt = e.extend(gr, ct.options || {}), Mt = Vr && ct.watchOptions ? e.extend(Vr, ct.watchOptions) : ct.watchOptions || Vr;
              nt.configFilePath = Tr && e.normalizeSlashes(Tr);
              var xt = Dt();
              Ue && (Ue.configFileSpecs = xt), ir(nt, Ue);
              var ut = e.normalizePath(Tr ? Ye(Tr, De) : De);
              return { options: nt, watchOptions: Mt, fileNames: Rt(ut), projectReferences: Ii(ut), typeAcquisition: ct.typeAcquisition || si(), raw: Li, errors: Wi, wildcardDirectories: xe(xt, ut, fr.useCaseSensitiveFileNames), compileOnSave: !!Li.compileOnSave };
              function Dt() {
                var wt = ui("references", function(pn) {
                  return typeof pn == "object";
                }, "object"), na = Ki(Fi("files"));
                if (na) {
                  var Ai = wt === "no-prop" || e.isArray(wt) && wt.length === 0, Oi = e.hasProperty(Li, "extends");
                  if (na.length === 0 && Ai && !Oi) if (Ue) {
                    var ji = Tr || "tsconfig.json", Vi = e.Diagnostics.The_files_list_in_config_file_0_is_empty, at = e.firstDefined(e.getTsConfigPropArray(Ue, "files"), function(pn) {
                      return pn.initializer;
                    }), At = at ? e.createDiagnosticForNodeInSourceFile(Ue, at, Vi, ji) : e.createCompilerDiagnostic(Vi, ji);
                    Wi.push(At);
                  } else Bt(e.Diagnostics.The_files_list_in_config_file_0_is_empty, Tr || "tsconfig.json");
                }
                var ba = Ki(Fi("include")), $a = Fi("exclude"), Qa = Ki($a);
                if ($a === "no-prop" && Li.compilerOptions) {
                  var ai = Li.compilerOptions.outDir, Dn = Li.compilerOptions.declarationDir;
                  (ai || Dn) && (Qa = [ai, Dn].filter(function(pn) {
                    return !!pn;
                  }));
                }
                na === void 0 && ba === void 0 && (ba = ["**/*"]);
                var ka, Ba;
                return ba && (ka = Wr(ba, Wi, true, Ue, "include")), Qa && (Ba = Wr(Qa, Wi, false, Ue, "exclude")), { filesSpecs: na, includeSpecs: ba, excludeSpecs: Qa, validatedFilesSpec: e.filter(na, e.isString), validatedIncludeSpecs: ka, validatedExcludeSpecs: Ba, pathPatterns: void 0 };
              }
              function Rt(wt) {
                var na = Jr(xt, wt, nt, fr, Ui);
                return n(na, lr(Li), vi) && Wi.push(Ne(xt, Tr)), na;
              }
              function Ii(wt) {
                var na, Ai = ui("references", function(at) {
                  return typeof at == "object";
                }, "object");
                if (e.isArray(Ai)) for (var Oi = 0, ji = Ai; Oi < ji.length; Oi++) {
                  var Vi = ji[Oi];
                  typeof Vi.path != "string" ? Bt(e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, "reference.path", "string") : (na || (na = [])).push({ path: e.getNormalizedAbsolutePath(Vi.path, wt), originalPath: Vi.path, prepend: Vi.prepend, circular: Vi.circular });
                }
                return na;
              }
              function Ki(wt) {
                return e.isArray(wt) ? wt : void 0;
              }
              function Fi(wt) {
                return ui(wt, e.isString, "string");
              }
              function ui(wt, na, Ai) {
                if (e.hasProperty(Li, wt) && !Cr(Li[wt])) if (e.isArray(Li[wt])) {
                  var Oi = Li[wt];
                  return !Ue && !e.every(Oi, na) && Wi.push(e.createCompilerDiagnostic(e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, wt, Ai)), Oi;
                } else return Bt(e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, wt, "Array"), "not-array";
                return "no-prop";
              }
              function Bt(wt, na, Ai) {
                Ue || Wi.push(e.createCompilerDiagnostic(wt, na, Ai));
              }
            }
            function Er(Pe) {
              return Pe.code === e.Diagnostics.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2.code;
            }
            function Ne(Pe, Ue) {
              var fr = Pe.includeSpecs, De = Pe.excludeSpecs;
              return e.createCompilerDiagnostic(e.Diagnostics.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2, Ue || "tsconfig.json", JSON.stringify(fr || []), JSON.stringify(De || []));
            }
            function n(Pe, Ue, fr) {
              return Pe.length === 0 && Ue && (!fr || fr.length === 0);
            }
            function lr(Pe) {
              return !e.hasProperty(Pe, "files") && !e.hasProperty(Pe, "references");
            }
            e.canJsonReportNoInputFiles = lr;
            function be(Pe, Ue, fr, De, gr) {
              var Vr = De.length;
              return n(Pe, gr) ? De.push(Ne(fr, Ue)) : e.filterMutate(De, function(Tr) {
                return !Er(Tr);
              }), Vr !== De.length;
            }
            e.updateErrorForNoInputFiles = be;
            function Ge(Pe) {
              return !!Pe.options;
            }
            function ur(Pe, Ue, fr, De, gr, Vr, Tr, vi) {
              var Ui;
              De = e.normalizeSlashes(De);
              var Yi = e.getNormalizedAbsolutePath(gr || "", De);
              if (Vr.indexOf(Yi) >= 0) return Tr.push(e.createCompilerDiagnostic(e.Diagnostics.Circularity_detected_while_resolving_configuration_Colon_0, Ve(Ve([], Vr, true), [Yi], false).join(" -> "))), { raw: Pe || g(Ue, Tr) };
              var Wi = Pe ? yr(Pe, fr, De, gr, Tr) : Ir(Ue, fr, De, gr, Tr);
              if (!((Ui = Wi.options) === null || Ui === void 0) && Ui.paths && (Wi.options.pathsBasePath = De), Wi.extendedConfigPath) {
                Vr = Vr.concat([Yi]);
                var ct = Ur(Ue, Wi.extendedConfigPath, fr, Vr, Tr, vi);
                if (ct && Ge(ct)) {
                  var Li = ct.raw, nt = Wi.raw, Mt, xt = function(ut) {
                    !nt[ut] && Li[ut] && (nt[ut] = e.map(Li[ut], function(Dt) {
                      return e.isRootedDiskPath(Dt) ? Dt : e.combinePaths(Mt || (Mt = e.convertToRelativePath(e.getDirectoryPath(Wi.extendedConfigPath), De, e.createGetCanonicalFileName(fr.useCaseSensitiveFileNames))), Dt);
                    }));
                  };
                  xt("include"), xt("exclude"), xt("files"), nt.compileOnSave === void 0 && (nt.compileOnSave = Li.compileOnSave), Wi.options = e.assign({}, ct.options, Wi.options), Wi.watchOptions = Wi.watchOptions && ct.watchOptions ? e.assign({}, ct.watchOptions, Wi.watchOptions) : Wi.watchOptions || ct.watchOptions;
                }
              }
              return Wi;
            }
            function yr(Pe, Ue, fr, De, gr) {
              e.hasProperty(Pe, "excludes") && gr.push(e.createCompilerDiagnostic(e.Diagnostics.Unknown_option_excludes_Did_you_mean_exclude));
              var Vr = qr(Pe.compilerOptions, fr, gr, De), Tr = Di(Pe.typeAcquisition || Pe.typingOptions, fr, gr, De), vi = wi(Pe.watchOptions, fr, gr);
              Pe.compileOnSave = ii(Pe, fr, gr);
              var Ui;
              if (Pe.extends) if (!e.isString(Pe.extends)) gr.push(e.createCompilerDiagnostic(e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, "extends", "string"));
              else {
                var Yi = De ? Ye(De, fr) : fr;
                Ui = wr(Pe.extends, Ue, Yi, gr, e.createCompilerDiagnostic);
              }
              return { raw: Pe, options: Vr, watchOptions: vi, typeAcquisition: Tr, extendedConfigPath: Ui };
            }
            function Ir(Pe, Ue, fr, De, gr) {
              var Vr = or(De), Tr, vi, Ui, Yi, Wi, ct = { onSetValidOptionKeyValueInParent: function(nt, Mt, xt) {
                var ut;
                switch (nt) {
                  case "compilerOptions":
                    ut = Vr;
                    break;
                  case "watchOptions":
                    ut = Ui || (Ui = {});
                    break;
                  case "typeAcquisition":
                    ut = Tr || (Tr = si(De));
                    break;
                  case "typingOptions":
                    ut = vi || (vi = si(De));
                    break;
                  default:
                    e.Debug.fail("Unknown option");
                }
                ut[Mt.name] = Gi(Mt, fr, xt);
              }, onSetValidOptionKeyValueInRoot: function(nt, Mt, xt, ut) {
                switch (nt) {
                  case "extends":
                    var Dt = De ? Ye(De, fr) : fr;
                    Yi = wr(xt, Ue, Dt, gr, function(Rt, Ii) {
                      return e.createDiagnosticForNodeInSourceFile(Pe, ut, Rt, Ii);
                    });
                    return;
                }
              }, onSetUnknownOptionKeyValueInRoot: function(nt, Mt, xt, ut) {
                nt === "excludes" && gr.push(e.createDiagnosticForNodeInSourceFile(Pe, Mt, e.Diagnostics.Unknown_option_excludes_Did_you_mean_exclude)), e.find(w, function(Dt) {
                  return Dt.name === nt;
                }) && (Wi = e.append(Wi, Mt));
              } }, Li = fe(Pe, gr, true, ct);
              return Tr || (vi ? Tr = vi.enableAutoDiscovery !== void 0 ? { enable: vi.enableAutoDiscovery, include: vi.include, exclude: vi.exclude } : vi : Tr = si(De)), Wi && Li && Li.compilerOptions === void 0 && gr.push(e.createDiagnosticForNodeInSourceFile(Pe, Wi[0], e.Diagnostics._0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file, e.getTextOfPropertyName(Wi[0]))), { raw: Li, options: Vr, watchOptions: Ui, typeAcquisition: Tr, extendedConfigPath: Yi };
            }
            function wr(Pe, Ue, fr, De, gr) {
              if (Pe = e.normalizeSlashes(Pe), e.isRootedDiskPath(Pe) || e.startsWith(Pe, "./") || e.startsWith(Pe, "../")) {
                var Vr = e.getNormalizedAbsolutePath(Pe, fr);
                if (!Ue.fileExists(Vr) && !e.endsWith(Vr, ".json") && (Vr = "".concat(Vr, ".json"), !Ue.fileExists(Vr))) {
                  De.push(gr(e.Diagnostics.File_0_not_found, Pe));
                  return;
                }
                return Vr;
              }
              var Tr = e.nodeModuleNameResolver(Pe, e.combinePaths(fr, "tsconfig.json"), { moduleResolution: e.ModuleResolutionKind.NodeJs }, Ue, void 0, void 0, true);
              if (Tr.resolvedModule) return Tr.resolvedModule.resolvedFileName;
              De.push(gr(e.Diagnostics.File_0_not_found, Pe));
            }
            function Ur(Pe, Ue, fr, De, gr, Vr) {
              var Tr, vi = fr.useCaseSensitiveFileNames ? Ue : e.toFileNameLowerCase(Ue), Ui, Yi, Wi;
              if (Vr && (Ui = Vr.get(vi)) ? (Yi = Ui.extendedResult, Wi = Ui.extendedConfig) : (Yi = $(Ue, function(ct) {
                return fr.readFile(ct);
              }), Yi.parseDiagnostics.length || (Wi = ur(void 0, Yi, fr, e.getDirectoryPath(Ue), e.getBaseFileName(Ue), De, gr, Vr)), Vr && Vr.set(vi, { extendedResult: Yi, extendedConfig: Wi })), Pe && (Pe.extendedSourceFiles = [Yi.fileName], Yi.extendedSourceFiles && (Tr = Pe.extendedSourceFiles).push.apply(Tr, Yi.extendedSourceFiles)), Yi.parseDiagnostics.length) {
                gr.push.apply(gr, Yi.parseDiagnostics);
                return;
              }
              return Wi;
            }
            function ii(Pe, Ue, fr) {
              if (!e.hasProperty(Pe, e.compileOnSaveCommandLineOption.name)) return false;
              var De = et(e.compileOnSaveCommandLineOption, Pe.compileOnSave, Ue, fr);
              return typeof De == "boolean" && De;
            }
            function mi(Pe, Ue, fr) {
              var De = [], gr = qr(Pe, Ue, De, fr);
              return { options: gr, errors: De };
            }
            e.convertCompilerOptionsFromJson = mi;
            function pe(Pe, Ue, fr) {
              var De = [], gr = Di(Pe, Ue, De, fr);
              return { options: gr, errors: De };
            }
            e.convertTypeAcquisitionFromJson = pe;
            function or(Pe) {
              var Ue = Pe && e.getBaseFileName(Pe) === "jsconfig.json" ? { allowJs: true, maxNodeModuleJsDepth: 2, allowSyntheticDefaultImports: true, skipLibCheck: true, noEmit: true } : {};
              return Ue;
            }
            function qr(Pe, Ue, fr, De) {
              var gr = or(De);
              return Xi(U(), Pe, Ue, gr, e.compilerOptionsDidYouMeanDiagnostics, fr), De && (gr.configFilePath = e.normalizeSlashes(De)), gr;
            }
            function si(Pe) {
              return { enable: !!Pe && e.getBaseFileName(Pe) === "jsconfig.json", include: [], exclude: [] };
            }
            function Di(Pe, Ue, fr, De) {
              var gr = si(De), Vr = N(Pe);
              return Xi(l(), Vr, Ue, gr, V, fr), gr;
            }
            function wi(Pe, Ue, fr) {
              return Xi(H(), Pe, Ue, void 0, k, fr);
            }
            function Xi(Pe, Ue, fr, De, gr, Vr) {
              if (!!Ue) {
                for (var Tr in Ue) {
                  var vi = Pe.get(Tr);
                  vi ? (De || (De = {}))[vi.name] = et(vi, Ue[Tr], fr, Vr) : Vr.push(T(Tr, gr, e.createCompilerDiagnostic));
                }
                return De;
              }
            }
            function et(Pe, Ue, fr, De) {
              if (We(Pe, Ue)) {
                var gr = Pe.type;
                if (gr === "list" && e.isArray(Ue)) return pi(Pe, Ue, fr, De);
                if (!e.isString(gr)) return _r(Pe, Ue, De);
                var Vr = Zt(Pe, Ue, De);
                return Cr(Vr) ? Vr : Wt(Pe, fr, Vr);
              } else De.push(e.createCompilerDiagnostic(e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, Pe.name, ue(Pe)));
            }
            e.convertJsonOption = et;
            function Gi(Pe, Ue, fr) {
              if (!Cr(fr)) {
                if (Pe.type === "list") {
                  var De = Pe;
                  return De.element.isFilePath || !e.isString(De.element.type) ? e.filter(e.map(fr, function(gr) {
                    return Gi(De.element, Ue, gr);
                  }), function(gr) {
                    return De.listPreserveFalsyValues ? true : !!gr;
                  }) : fr;
                } else if (!e.isString(Pe.type)) return Pe.type.get(e.isString(fr) ? fr.toLowerCase() : fr);
                return Wt(Pe, Ue, fr);
              }
            }
            function Wt(Pe, Ue, fr) {
              return Pe.isFilePath && (fr = e.getNormalizedAbsolutePath(fr, Ue), fr === "" && (fr = ".")), fr;
            }
            function Zt(Pe, Ue, fr) {
              var De;
              if (!Cr(Ue)) {
                var gr = (De = Pe.extraValidation) === null || De === void 0 ? void 0 : De.call(Pe, Ue);
                if (!gr) return Ue;
                fr.push(e.createCompilerDiagnostic.apply(void 0, gr));
              }
            }
            function _r(Pe, Ue, fr) {
              if (!Cr(Ue)) {
                var De = Ue.toLowerCase(), gr = Pe.type.get(De);
                if (gr !== void 0) return Zt(Pe, gr, fr);
                fr.push(p(Pe));
              }
            }
            function pi(Pe, Ue, fr, De) {
              return e.filter(e.map(Ue, function(gr) {
                return et(Pe.element, gr, fr, De);
              }), function(gr) {
                return Pe.listPreserveFalsyValues ? true : !!gr;
              });
            }
            var ae = /(^|\/)\*\*\/?$/, Xe = /^[^*?]*(?=\/[^/]*[*?])/;
            function Jr(Pe, Ue, fr, De, gr) {
              gr === void 0 && (gr = e.emptyArray), Ue = e.normalizePath(Ue);
              var Vr = e.createGetCanonicalFileName(De.useCaseSensitiveFileNames), Tr = new e.Map(), vi = new e.Map(), Ui = new e.Map(), Yi = Pe.validatedFilesSpec, Wi = Pe.validatedIncludeSpecs, ct = Pe.validatedExcludeSpecs, Li = e.getSupportedExtensions(fr, gr), nt = e.getSupportedExtensionsWithJsonIfResolveJsonModule(fr, Li);
              if (Yi) for (var Mt = 0, xt = Yi; Mt < xt.length; Mt++) {
                var ut = xt[Mt], Dt = e.getNormalizedAbsolutePath(ut, Ue);
                Tr.set(Vr(Dt), Dt);
              }
              var Rt;
              if (Wi && Wi.length > 0) for (var Ii = function(wt) {
                if (e.fileExtensionIs(wt, ".json")) {
                  if (!Rt) {
                    var na = Wi.filter(function(at) {
                      return e.endsWith(at, ".json");
                    }), Ai = e.map(e.getRegularExpressionsForWildcards(na, Ue, "files"), function(at) {
                      return "^".concat(at, "$");
                    });
                    Rt = Ai ? Ai.map(function(at) {
                      return e.getRegexFromPattern(at, De.useCaseSensitiveFileNames);
                    }) : e.emptyArray;
                  }
                  var Oi = e.findIndex(Rt, function(at) {
                    return at.test(wt);
                  });
                  if (Oi !== -1) {
                    var ji = Vr(wt);
                    !Tr.has(ji) && !Ui.has(ji) && Ui.set(ji, wt);
                  }
                  return "continue";
                }
                if (mr(wt, Tr, vi, Li, Vr)) return "continue";
                Ar(wt, vi, Li, Vr);
                var Vi = Vr(wt);
                !Tr.has(Vi) && !vi.has(Vi) && vi.set(Vi, wt);
              }, Ki = 0, Fi = De.readDirectory(Ue, e.flatten(nt), ct, Wi, void 0); Ki < Fi.length; Ki++) {
                var Dt = Fi[Ki];
                Ii(Dt);
              }
              var ui = e.arrayFrom(Tr.values()), Bt = e.arrayFrom(vi.values());
              return ui.concat(Bt, e.arrayFrom(Ui.values()));
            }
            e.getFileNamesFromConfigSpecs = Jr;
            function ti(Pe, Ue, fr, De, gr) {
              var Vr = Ue.validatedFilesSpec, Tr = Ue.validatedIncludeSpecs, vi = Ue.validatedExcludeSpecs;
              if (!e.length(Tr) || !e.length(vi)) return false;
              fr = e.normalizePath(fr);
              var Ui = e.createGetCanonicalFileName(De);
              if (Vr) for (var Yi = 0, Wi = Vr; Yi < Wi.length; Yi++) {
                var ct = Wi[Yi];
                if (Ui(e.getNormalizedAbsolutePath(ct, fr)) === Pe) return false;
              }
              return zr(Pe, vi, De, gr, fr);
            }
            e.isExcludedFile = ti;
            function Ze(Pe) {
              var Ue = e.startsWith(Pe, "**/") ? 0 : Pe.indexOf("/**/");
              if (Ue === -1) return false;
              var fr = e.endsWith(Pe, "/..") ? Pe.length : Pe.lastIndexOf("/../");
              return fr > Ue;
            }
            function Sr(Pe, Ue, fr, De) {
              return zr(Pe, e.filter(Ue, function(gr) {
                return !Ze(gr);
              }), fr, De);
            }
            e.matchesExclude = Sr;
            function zr(Pe, Ue, fr, De, gr) {
              var Vr = e.getRegularExpressionForWildcard(Ue, e.combinePaths(e.normalizePath(De), gr), "exclude"), Tr = Vr && e.getRegexFromPattern(Vr, fr);
              return Tr ? Tr.test(Pe) ? true : !e.hasExtension(Pe) && Tr.test(e.ensureTrailingDirectorySeparator(Pe)) : false;
            }
            function Wr(Pe, Ue, fr, De, gr) {
              return Pe.filter(function(Tr) {
                if (!e.isString(Tr)) return false;
                var vi = Je(Tr, fr);
                return vi !== void 0 && Ue.push(Vr.apply(void 0, vi)), vi === void 0;
              });
              function Vr(Tr, vi) {
                var Ui = e.getTsConfigPropArrayElementValue(De, gr, vi);
                return Ui ? e.createDiagnosticForNodeInSourceFile(De, Ui, Tr, vi) : e.createCompilerDiagnostic(Tr, vi);
              }
            }
            function Je(Pe, Ue) {
              if (Ue && ae.test(Pe)) return [e.Diagnostics.File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0, Pe];
              if (Ze(Pe)) return [e.Diagnostics.File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0, Pe];
            }
            function xe(Pe, Ue, fr) {
              var De = Pe.validatedIncludeSpecs, gr = Pe.validatedExcludeSpecs, Vr = e.getRegularExpressionForWildcard(gr, Ue, "exclude"), Tr = Vr && new RegExp(Vr, fr ? "" : "i"), vi = {};
              if (De !== void 0) {
                for (var Ui = [], Yi = 0, Wi = De; Yi < Wi.length; Yi++) {
                  var ct = Wi[Yi], Li = e.normalizePath(e.combinePaths(Ue, ct));
                  if (!(Tr && Tr.test(Li))) {
                    var nt = vr(Li, fr);
                    if (nt) {
                      var Mt = nt.key, xt = nt.flags, ut = vi[Mt];
                      (ut === void 0 || ut < xt) && (vi[Mt] = xt, xt === 1 && Ui.push(Mt));
                    }
                  }
                }
                for (var Mt in vi) if (e.hasProperty(vi, Mt)) for (var Dt = 0, Rt = Ui; Dt < Rt.length; Dt++) {
                  var Ii = Rt[Dt];
                  Mt !== Ii && e.containsPath(Ii, Mt, Ue, !fr) && delete vi[Mt];
                }
              }
              return vi;
            }
            function vr(Pe, Ue) {
              var fr = Xe.exec(Pe);
              if (fr) {
                var De = Pe.indexOf("?"), gr = Pe.indexOf("*"), Vr = Pe.lastIndexOf(e.directorySeparator);
                return { key: Ue ? fr[0] : e.toFileNameLowerCase(fr[0]), flags: De !== -1 && De < Vr || gr !== -1 && gr < Vr ? 1 : 0 };
              }
              if (e.isImplicitGlob(Pe.substring(Pe.lastIndexOf(e.directorySeparator) + 1))) return { key: Ue ? Pe : e.toFileNameLowerCase(Pe), flags: 1 };
            }
            function mr(Pe, Ue, fr, De, gr) {
              var Vr = e.forEach(De, function(Wi) {
                return e.fileExtensionIsOneOf(Pe, Wi) ? Wi : void 0;
              });
              if (!Vr) return false;
              for (var Tr = 0, vi = Vr; Tr < vi.length; Tr++) {
                var Ui = vi[Tr];
                if (e.fileExtensionIs(Pe, Ui)) return false;
                var Yi = gr(e.changeExtension(Pe, Ui));
                if (Ue.has(Yi) || fr.has(Yi)) {
                  if (Ui === ".d.ts" && (e.fileExtensionIs(Pe, ".js") || e.fileExtensionIs(Pe, ".jsx"))) continue;
                  return true;
                }
              }
              return false;
            }
            function Ar(Pe, Ue, fr, De) {
              var gr = e.forEach(fr, function(Ui) {
                return e.fileExtensionIsOneOf(Pe, Ui) ? Ui : void 0;
              });
              if (!!gr) for (var Vr = gr.length - 1; Vr >= 0; Vr--) {
                var Tr = gr[Vr];
                if (e.fileExtensionIs(Pe, Tr)) return;
                var vi = De(e.changeExtension(Pe, Tr));
                Ue.delete(vi);
              }
            }
            function Oe(Pe) {
              var Ue = {};
              for (var fr in Pe) if (Pe.hasOwnProperty(fr)) {
                var De = J(fr);
                De !== void 0 && (Ue[fr] = nr(Pe[fr], De));
              }
              return Ue;
            }
            e.convertCompilerOptionsForTelemetry = Oe;
            function nr(Pe, Ue) {
              switch (Ue.type) {
                case "object":
                  return "";
                case "string":
                  return "";
                case "number":
                  return typeof Pe == "number" ? Pe : "";
                case "boolean":
                  return typeof Pe == "boolean" ? Pe : "";
                case "list":
                  var fr = Ue.element;
                  return e.isArray(Pe) ? Pe.map(function(De) {
                    return nr(De, fr);
                  }) : "";
                default:
                  return e.forEachEntry(Ue.type, function(De, gr) {
                    if (De === Pe) return gr;
                  });
              }
            }
            function Mr(Pe) {
              switch (Pe.type) {
                case "number":
                  return 1;
                case "boolean":
                  return true;
                case "string":
                  var Ue = Pe.defaultValueDescription;
                  return Pe.isFilePath ? "./".concat(Ue && typeof Ue == "string" ? Ue : "") : "";
                case "list":
                  return [];
                case "object":
                  return {};
                default:
                  var fr = Pe.type.keys().next();
                  return fr.done ? e.Debug.fail("Expected 'option.type' to have entries.") : fr.value;
              }
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(Ze) {
              Ze.trace(e.formatMessage.apply(void 0, arguments));
            }
            e.trace = a;
            function C(Ze, Sr) {
              return !!Ze.traceResolution && Sr.trace !== void 0;
            }
            e.isTraceEnabled = C;
            function w(Ze, Sr) {
              var zr;
              if (Sr && Ze) {
                var Wr = Ze.packageJsonContent;
                typeof Wr.name == "string" && typeof Wr.version == "string" && (zr = { name: Wr.name, subModuleName: Sr.path.slice(Ze.packageDirectory.length + e.directorySeparator.length), version: Wr.version });
              }
              return Sr && { path: Sr.path, extension: Sr.ext, packageId: zr };
            }
            function B(Ze) {
              return w(void 0, Ze);
            }
            function E(Ze) {
              if (Ze) return e.Debug.assert(Ze.packageId === void 0), { path: Ze.path, ext: Ze.extension };
            }
            var Q;
            (function(Ze) {
              Ze[Ze.TypeScript = 0] = "TypeScript", Ze[Ze.JavaScript = 1] = "JavaScript", Ze[Ze.Json = 2] = "Json", Ze[Ze.TSConfig = 3] = "TSConfig", Ze[Ze.DtsOnly = 4] = "DtsOnly", Ze[Ze.TsOnly = 5] = "TsOnly";
            })(Q || (Q = {}));
            function le(Ze) {
              if (!!Ze) return e.Debug.assert(e.extensionIsTS(Ze.extension)), { fileName: Ze.path, packageId: Ze.packageId };
            }
            function N(Ze, Sr, zr, Wr, Je) {
              var xe;
              return Je ? ((xe = Je.failedLookupLocations).push.apply(xe, zr), Je) : { resolvedModule: Ze && { resolvedFileName: Ze.path, originalPath: Ze.originalPath === true ? void 0 : Ze.originalPath, extension: Ze.extension, isExternalLibraryImport: Sr, packageId: Ze.packageId }, failedLookupLocations: zr, resolutionDiagnostics: Wr };
            }
            function p(Ze, Sr, zr, Wr) {
              if (!e.hasProperty(Ze, Sr)) {
                Wr.traceEnabled && a(Wr.host, e.Diagnostics.package_json_does_not_have_a_0_field, Sr);
                return;
              }
              var Je = Ze[Sr];
              if (typeof Je !== zr || Je === null) {
                Wr.traceEnabled && a(Wr.host, e.Diagnostics.Expected_type_of_0_field_in_package_json_to_be_1_got_2, Sr, zr, Je === null ? "null" : typeof Je);
                return;
              }
              return Je;
            }
            function m(Ze, Sr, zr, Wr) {
              var Je = p(Ze, Sr, "string", Wr);
              if (Je !== void 0) {
                if (!Je) {
                  Wr.traceEnabled && a(Wr.host, e.Diagnostics.package_json_had_a_falsy_0_field, Sr);
                  return;
                }
                var xe = e.normalizePath(e.combinePaths(zr, Je));
                return Wr.traceEnabled && a(Wr.host, e.Diagnostics.package_json_has_0_field_1_that_references_2, Sr, Je, xe), xe;
              }
            }
            function G(Ze, Sr, zr) {
              return m(Ze, "typings", Sr, zr) || m(Ze, "types", Sr, zr);
            }
            function oe(Ze, Sr, zr) {
              return m(Ze, "tsconfig", Sr, zr);
            }
            function f(Ze, Sr, zr) {
              return m(Ze, "main", Sr, zr);
            }
            function T(Ze, Sr) {
              var zr = p(Ze, "typesVersions", "object", Sr);
              if (zr !== void 0) return Sr.traceEnabled && a(Sr.host, e.Diagnostics.package_json_has_a_typesVersions_field_with_version_specific_path_mappings), zr;
            }
            function K(Ze, Sr) {
              var zr = T(Ze, Sr);
              if (zr !== void 0) {
                if (Sr.traceEnabled) for (var Wr in zr) e.hasProperty(zr, Wr) && !e.VersionRange.tryParse(Wr) && a(Sr.host, e.Diagnostics.package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range, Wr);
                var Je = se(zr);
                if (!Je) {
                  Sr.traceEnabled && a(Sr.host, e.Diagnostics.package_json_does_not_have_a_typesVersions_entry_that_matches_version_0, e.versionMajorMinor);
                  return;
                }
                var xe = Je.version, vr = Je.paths;
                if (typeof vr != "object") {
                  Sr.traceEnabled && a(Sr.host, e.Diagnostics.Expected_type_of_0_field_in_package_json_to_be_1_got_2, "typesVersions['".concat(xe, "']"), "object", typeof vr);
                  return;
                }
                return Je;
              }
            }
            var b;
            function se(Ze) {
              b || (b = new e.Version(e.version));
              for (var Sr in Ze) if (!!e.hasProperty(Ze, Sr)) {
                var zr = e.VersionRange.tryParse(Sr);
                if (zr !== void 0 && zr.test(b)) return { version: Sr, paths: Ze[Sr] };
              }
            }
            e.getPackageJsonTypesVersionsPaths = se;
            function J(Ze, Sr) {
              if (Ze.typeRoots) return Ze.typeRoots;
              var zr;
              if (Ze.configFilePath ? zr = e.getDirectoryPath(Ze.configFilePath) : Sr.getCurrentDirectory && (zr = Sr.getCurrentDirectory()), zr !== void 0) return ie(zr, Sr);
            }
            e.getEffectiveTypeRoots = J;
            function ie(Ze, Sr) {
              if (!Sr.directoryExists) return [e.combinePaths(Ze, R)];
              var zr;
              return e.forEachAncestorDirectory(e.normalizePath(Ze), function(Wr) {
                var Je = e.combinePaths(Wr, R);
                Sr.directoryExists(Je) && (zr || (zr = [])).push(Je);
              }), zr;
            }
            var R = e.combinePaths("node_modules", "@types");
            function q(Ze, Sr, zr) {
              var Wr = typeof zr.useCaseSensitiveFileNames == "function" ? zr.useCaseSensitiveFileNames() : zr.useCaseSensitiveFileNames;
              return e.comparePaths(Ze, Sr, !Wr) === 0;
            }
            function O(Ze, Sr, zr, Wr, Je, xe, vr) {
              e.Debug.assert(typeof Ze == "string", "Non-string value passed to `ts.resolveTypeReferenceDirective`, likely by a wrapping package working with an outdated `resolveTypeReferenceDirectives` signature. This is probably not a problem in TS itself.");
              var mr = C(zr, Wr);
              Je && (zr = Je.commandLine.options);
              var Ar = Sr ? e.getDirectoryPath(Sr) : void 0, Oe = Ar ? xe && xe.getOrCreateCacheForDirectory(Ar, Je) : void 0, nr = Oe && Oe.get(Ze, vr);
              if (nr) return mr && (a(Wr, e.Diagnostics.Resolving_type_reference_directive_0_containing_file_1, Ze, Sr), Je && a(Wr, e.Diagnostics.Using_compiler_options_of_project_reference_redirect_0, Je.sourceFile.fileName), a(Wr, e.Diagnostics.Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1, Ze, Ar), ct(nr)), nr;
              var Mr = J(zr, Wr);
              mr && (Sr === void 0 ? Mr === void 0 ? a(Wr, e.Diagnostics.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set, Ze) : a(Wr, e.Diagnostics.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1, Ze, Mr) : Mr === void 0 ? a(Wr, e.Diagnostics.Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set, Ze, Sr) : a(Wr, e.Diagnostics.Resolving_type_reference_directive_0_containing_file_1_root_directory_2, Ze, Sr, Mr), Je && a(Wr, e.Diagnostics.Using_compiler_options_of_project_reference_redirect_0, Je.sourceFile.fileName));
              var Pe = [], Ue = ve(zr);
              vr === e.ModuleKind.ESNext && (e.getEmitModuleResolutionKind(zr) === e.ModuleResolutionKind.Node16 || e.getEmitModuleResolutionKind(zr) === e.ModuleResolutionKind.NodeNext) && (Ue |= d.EsmMode);
              var fr = Ue & d.Exports ? Ue & d.EsmMode ? ["node", "import", "types"] : ["node", "require", "types"] : [], De = [], gr = { compilerOptions: zr, host: Wr, traceEnabled: mr, failedLookupLocations: Pe, packageJsonInfoCache: xe, features: Ue, conditions: fr, requestContainingDirectory: Ar, reportDiagnostic: function(Mt) {
                return void De.push(Mt);
              } }, Vr = Li(), Tr = true;
              Vr || (Vr = nt(), Tr = false);
              var vi;
              if (Vr) {
                var Ui = Vr.fileName, Yi = Vr.packageId, Wi = zr.preserveSymlinks ? Ui : ze(Ui, Wr, mr);
                vi = { primary: Tr, resolvedFileName: Wi, originalPath: q(Ui, Wi, Wr) ? void 0 : Ui, packageId: Yi, isExternalLibraryImport: He(Ui) };
              }
              return nr = { resolvedTypeReferenceDirective: vi, failedLookupLocations: Pe, resolutionDiagnostics: De }, Oe == null || Oe.set(Ze, vr, nr), mr && ct(nr), nr;
              function ct(Mt) {
                var xt;
                !((xt = Mt.resolvedTypeReferenceDirective) === null || xt === void 0) && xt.resolvedFileName ? Mt.resolvedTypeReferenceDirective.packageId ? a(Wr, e.Diagnostics.Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3, Ze, Mt.resolvedTypeReferenceDirective.resolvedFileName, e.packageIdToString(Mt.resolvedTypeReferenceDirective.packageId), Mt.resolvedTypeReferenceDirective.primary) : a(Wr, e.Diagnostics.Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2, Ze, Mt.resolvedTypeReferenceDirective.resolvedFileName, Mt.resolvedTypeReferenceDirective.primary) : a(Wr, e.Diagnostics.Type_reference_directive_0_was_not_resolved, Ze);
              }
              function Li() {
                if (Mr && Mr.length) return mr && a(Wr, e.Diagnostics.Resolving_with_primary_search_path_0, Mr.join(", ")), e.firstDefined(Mr, function(Mt) {
                  var xt = e.combinePaths(Mt, Ze), ut = e.getDirectoryPath(xt), Dt = e.directoryProbablyExists(ut, Wr);
                  return !Dt && mr && a(Wr, e.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, ut), le(Cr(Q.DtsOnly, xt, !Dt, gr));
                });
                mr && a(Wr, e.Diagnostics.Root_directory_cannot_be_determined_skipping_primary_search_paths);
              }
              function nt() {
                var Mt = Sr && e.getDirectoryPath(Sr);
                if (Mt !== void 0) {
                  mr && a(Wr, e.Diagnostics.Looking_up_in_node_modules_folder_initial_location_0, Mt);
                  var xt;
                  if (e.isExternalModuleNameRelative(Ze)) {
                    var Dt = Re(Mt, Ze).path;
                    xt = Ee(Q.DtsOnly, Dt, false, gr, true);
                  } else {
                    var ut = or(Q.DtsOnly, Ze, Mt, gr, void 0, void 0);
                    xt = ut && ut.value;
                  }
                  return le(xt);
                } else mr && a(Wr, e.Diagnostics.Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder);
              }
            }
            e.resolveTypeReferenceDirective = O;
            function ve(Ze) {
              return e.getEmitModuleResolutionKind(Ze) === e.ModuleResolutionKind.Node16 ? d.Node16Default : e.getEmitModuleResolutionKind(Ze) === e.ModuleResolutionKind.NodeNext ? d.NodeNextDefault : d.None;
            }
            function ee(Ze, Sr, zr, Wr, Je) {
              var xe = { compilerOptions: zr, host: Wr, traceEnabled: C(zr, Wr), failedLookupLocations: [], packageJsonInfoCache: Je == null ? void 0 : Je.getPackageJsonInfoCache(), conditions: e.emptyArray, features: d.None, requestContainingDirectory: Sr, reportDiagnostic: e.noop };
              return e.forEachAncestorDirectory(Sr, function(vr) {
                if (e.getBaseFileName(vr) !== "node_modules") {
                  var mr = e.combinePaths(vr, "node_modules"), Ar = e.combinePaths(mr, Ze);
                  return Ne(Ar, false, xe);
                }
              });
            }
            e.resolvePackageNameToPackageJson = ee;
            function he(Ze, Sr) {
              if (Ze.types) return Ze.types;
              var zr = [];
              if (Sr.directoryExists && Sr.getDirectories) {
                var Wr = J(Ze, Sr);
                if (Wr) for (var Je = 0, xe = Wr; Je < xe.length; Je++) {
                  var vr = xe[Je];
                  if (Sr.directoryExists(vr)) for (var mr = 0, Ar = Sr.getDirectories(vr); mr < Ar.length; mr++) {
                    var Oe = Ar[mr], nr = e.normalizePath(Oe), Mr = e.combinePaths(vr, nr, "package.json"), Pe = Sr.fileExists(Mr) && e.readJson(Mr, Sr).typings === null;
                    if (!Pe) {
                      var Ue = e.getBaseFileName(nr);
                      Ue.charCodeAt(0) !== 46 && zr.push(Ue);
                    }
                  }
                }
              }
              return zr;
            }
            e.getAutomaticTypeDirectiveNames = he;
            function F(Ze) {
              var Sr = new e.Map(), zr = new e.Map();
              return { getOwnMap: Wr, redirectsMap: zr, getOrCreateMapOfCacheRedirects: vr, clear: mr, setOwnOptions: Je, setOwnMap: xe };
              function Wr() {
                return Sr;
              }
              function Je(Ar) {
                Ze = Ar;
              }
              function xe(Ar) {
                Sr = Ar;
              }
              function vr(Ar) {
                if (!Ar) return Sr;
                var Oe = Ar.sourceFile.path, nr = zr.get(Oe);
                return nr || (nr = !Ze || e.optionsHaveModuleResolutionChanges(Ze, Ar.commandLine.options) ? new e.Map() : Sr, zr.set(Oe, nr)), nr;
              }
              function mr() {
                Sr.clear(), zr.clear();
              }
            }
            e.createCacheWithRedirects = F;
            function x(Ze, Sr) {
              var zr;
              return { getPackageJsonInfo: Wr, setPackageJsonInfo: Je, clear: xe, entries: vr };
              function Wr(mr) {
                return zr == null ? void 0 : zr.get(e.toPath(mr, Ze, Sr));
              }
              function Je(mr, Ar) {
                (zr || (zr = new e.Map())).set(e.toPath(mr, Ze, Sr), Ar);
              }
              function xe() {
                zr = void 0;
              }
              function vr() {
                var mr = zr == null ? void 0 : zr.entries();
                return mr ? e.arrayFrom(mr) : [];
              }
            }
            function X(Ze, Sr, zr, Wr) {
              var Je = Ze.getOrCreateMapOfCacheRedirects(Sr), xe = Je.get(zr);
              return xe || (xe = Wr(), Je.set(zr, xe)), xe;
            }
            function $(Ze, Sr, zr) {
              if (!!Ze.configFile) {
                if (Sr.redirectsMap.size === 0) e.Debug.assert(!zr || zr.redirectsMap.size === 0), e.Debug.assert(Sr.getOwnMap().size === 0), e.Debug.assert(!zr || zr.getOwnMap().size === 0), Sr.redirectsMap.set(Ze.configFile.path, Sr.getOwnMap()), zr == null || zr.redirectsMap.set(Ze.configFile.path, zr.getOwnMap());
                else {
                  e.Debug.assert(!zr || zr.redirectsMap.size > 0);
                  var Wr = { sourceFile: Ze.configFile, commandLine: { options: Ze } };
                  Sr.setOwnMap(Sr.getOrCreateMapOfCacheRedirects(Wr)), zr == null || zr.setOwnMap(zr.getOrCreateMapOfCacheRedirects(Wr));
                }
                Sr.setOwnOptions(Ze), zr == null || zr.setOwnOptions(Ze);
              }
            }
            function A(Ze, Sr, zr) {
              return { getOrCreateCacheForDirectory: xe, clear: Wr, update: Je };
              function Wr() {
                zr.clear();
              }
              function Je(vr) {
                $(vr, zr);
              }
              function xe(vr, mr) {
                var Ar = e.toPath(vr, Ze, Sr);
                return X(zr, mr, Ar, function() {
                  return y();
                });
              }
            }
            function y() {
              var Ze = new e.Map(), Sr = new e.Map(), zr = { get: function(Je, xe) {
                return Ze.get(Wr(Je, xe));
              }, set: function(Je, xe, vr) {
                return Ze.set(Wr(Je, xe), vr), zr;
              }, delete: function(Je, xe) {
                return Ze.delete(Wr(Je, xe)), zr;
              }, has: function(Je, xe) {
                return Ze.has(Wr(Je, xe));
              }, forEach: function(Je) {
                return Ze.forEach(function(xe, vr) {
                  var mr = Sr.get(vr), Ar = mr[0], Oe = mr[1];
                  return Je(xe, Ar, Oe);
                });
              }, size: function() {
                return Ze.size;
              } };
              return zr;
              function Wr(Je, xe) {
                var vr = xe === void 0 ? Je : "".concat(xe, "|").concat(Je);
                return Sr.set(vr, [Je, xe]), vr;
              }
            }
            e.createModeAwareCache = y;
            function V(Ze, Sr, zr) {
              e.Debug.assert(Sr.length === zr.length);
              for (var Wr = y(), Je = 0; Je < Sr.length; ++Je) {
                var xe = Sr[Je], vr = e.isString(xe) ? xe : xe.fileName.toLowerCase(), mr = e.isString(xe) ? e.getModeForResolutionAtIndex(Ze, Je) : xe.resolutionMode || Ze.impliedNodeFormat;
                Wr.set(vr, mr, zr[Je]);
              }
              return Wr;
            }
            e.zipToModeAwareCache = V;
            function L(Ze, Sr, zr, Wr, Je) {
              var xe = A(Ze, Sr, Wr || (Wr = F(zr)));
              Je || (Je = F(zr));
              var vr = x(Ze, Sr);
              return Ke(Ke(Ke({}, vr), xe), { getOrCreateCacheForModuleName: Oe, clear: mr, update: Ar, getPackageJsonInfoCache: function() {
                return vr;
              } });
              function mr() {
                xe.clear(), Je.clear(), vr.clear();
              }
              function Ar(Mr) {
                $(Mr, Wr, Je);
              }
              function Oe(Mr, Pe, Ue) {
                return e.Debug.assert(!e.isExternalModuleNameRelative(Mr)), X(Je, Ue, Pe === void 0 ? Mr : "".concat(Pe, "|").concat(Mr), nr);
              }
              function nr() {
                var Mr = new e.Map();
                return { get: Pe, set: Ue };
                function Pe(De) {
                  return Mr.get(e.toPath(De, Ze, Sr));
                }
                function Ue(De, gr) {
                  var Vr = e.toPath(De, Ze, Sr);
                  if (!Mr.has(Vr)) {
                    Mr.set(Vr, gr);
                    for (var Tr = gr.resolvedModule && (gr.resolvedModule.originalPath || gr.resolvedModule.resolvedFileName), vi = Tr && fr(Vr, Tr), Ui = Vr; Ui !== vi; ) {
                      var Yi = e.getDirectoryPath(Ui);
                      if (Yi === Ui || Mr.has(Yi)) break;
                      Mr.set(Yi, gr), Ui = Yi;
                    }
                  }
                }
                function fr(De, gr) {
                  for (var Vr = e.toPath(e.getDirectoryPath(gr), Ze, Sr), Tr = 0, vi = Math.min(De.length, Vr.length); Tr < vi && De.charCodeAt(Tr) === Vr.charCodeAt(Tr); ) Tr++;
                  if (Tr === De.length && (Vr.length === Tr || Vr[Tr] === e.directorySeparator)) return De;
                  var Ui = e.getRootLength(De);
                  if (!(Tr < Ui)) {
                    var Yi = De.lastIndexOf(e.directorySeparator, Tr - 1);
                    if (Yi !== -1) return De.substr(0, Math.max(Yi, Ui));
                  }
                }
              }
            }
            e.createModuleResolutionCache = L;
            function P(Ze, Sr, zr, Wr, Je) {
              var xe = A(Ze, Sr, Je || (Je = F(zr)));
              return Wr || (Wr = x(Ze, Sr)), Ke(Ke(Ke({}, Wr), xe), { clear: vr });
              function vr() {
                xe.clear(), Wr.clear();
              }
            }
            e.createTypeReferenceDirectiveResolutionCache = P;
            function k(Ze, Sr, zr, Wr) {
              var Je = e.getDirectoryPath(Sr), xe = zr && zr.getOrCreateCacheForDirectory(Je);
              if (!!xe) return xe.get(Ze, Wr);
            }
            e.resolveModuleNameFromCache = k;
            function Y(Ze, Sr, zr, Wr, Je, xe, vr) {
              var mr = C(zr, Wr);
              xe && (zr = xe.commandLine.options), mr && (a(Wr, e.Diagnostics.Resolving_module_0_from_1, Ze, Sr), xe && a(Wr, e.Diagnostics.Using_compiler_options_of_project_reference_redirect_0, xe.sourceFile.fileName));
              var Ar = e.getDirectoryPath(Sr), Oe = Je && Je.getOrCreateCacheForDirectory(Ar, xe), nr = Oe && Oe.get(Ze, vr);
              if (nr) mr && a(Wr, e.Diagnostics.Resolution_for_module_0_was_found_in_cache_from_location_1, Ze, Ar);
              else {
                var Mr = zr.moduleResolution;
                if (Mr === void 0) {
                  switch (e.getEmitModuleKind(zr)) {
                    case e.ModuleKind.CommonJS:
                      Mr = e.ModuleResolutionKind.NodeJs;
                      break;
                    case e.ModuleKind.Node16:
                      Mr = e.ModuleResolutionKind.Node16;
                      break;
                    case e.ModuleKind.NodeNext:
                      Mr = e.ModuleResolutionKind.NodeNext;
                      break;
                    default:
                      Mr = e.ModuleResolutionKind.Classic;
                      break;
                  }
                  mr && a(Wr, e.Diagnostics.Module_resolution_kind_is_not_specified_using_0, e.ModuleResolutionKind[Mr]);
                } else mr && a(Wr, e.Diagnostics.Explicitly_specified_module_resolution_kind_Colon_0, e.ModuleResolutionKind[Mr]);
                switch (e.perfLogger.logStartResolveModule(Ze), Mr) {
                  case e.ModuleResolutionKind.Node16:
                    nr = D(Ze, Sr, zr, Wr, Je, xe, vr);
                    break;
                  case e.ModuleResolutionKind.NodeNext:
                    nr = fe(Ze, Sr, zr, Wr, Je, xe, vr);
                    break;
                  case e.ModuleResolutionKind.NodeJs:
                    nr = Be(Ze, Sr, zr, Wr, Je, xe);
                    break;
                  case e.ModuleResolutionKind.Classic:
                    nr = Xe(Ze, Sr, zr, Wr, Je, xe);
                    break;
                  default:
                    return e.Debug.fail("Unexpected moduleResolution: ".concat(Mr));
                }
                nr && nr.resolvedModule && e.perfLogger.logInfoEvent('Module "'.concat(Ze, '" resolved to "').concat(nr.resolvedModule.resolvedFileName, '"')), e.perfLogger.logStopResolveModule(nr && nr.resolvedModule ? "" + nr.resolvedModule.resolvedFileName : "null"), Oe && (Oe.set(Ze, vr, nr), e.isExternalModuleNameRelative(Ze) || Je.getOrCreateCacheForModuleName(Ze, vr, xe).set(Ar, nr));
              }
              return mr && (nr.resolvedModule ? nr.resolvedModule.packageId ? a(Wr, e.Diagnostics.Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2, Ze, nr.resolvedModule.resolvedFileName, e.packageIdToString(nr.resolvedModule.packageId)) : a(Wr, e.Diagnostics.Module_name_0_was_successfully_resolved_to_1, Ze, nr.resolvedModule.resolvedFileName) : a(Wr, e.Diagnostics.Module_name_0_was_not_resolved, Ze)), nr;
            }
            e.resolveModuleName = Y;
            function U(Ze, Sr, zr, Wr, Je) {
              var xe = j(Ze, Sr, Wr, Je);
              return xe ? xe.value : e.isExternalModuleNameRelative(Sr) ? H(Ze, Sr, zr, Wr, Je) : I(Ze, Sr, Wr, Je);
            }
            function j(Ze, Sr, zr, Wr) {
              var Je, xe = Wr.compilerOptions, vr = xe.baseUrl, mr = xe.paths, Ar = xe.configFile;
              if (mr && !e.pathIsRelative(Sr)) {
                Wr.traceEnabled && (vr && a(Wr.host, e.Diagnostics.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1, vr, Sr), a(Wr.host, e.Diagnostics.paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0, Sr));
                var Oe = e.getPathsBasePath(Wr.compilerOptions, Wr.host), nr = Ar != null && Ar.configFileSpecs ? (Je = Ar.configFileSpecs).pathPatterns || (Je.pathPatterns = e.tryParsePatterns(mr)) : void 0;
                return Xi(Ze, Sr, Oe, mr, nr, zr, false, Wr);
              }
            }
            function H(Ze, Sr, zr, Wr, Je) {
              if (!!Je.compilerOptions.rootDirs) {
                Je.traceEnabled && a(Je.host, e.Diagnostics.rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0, Sr);
                for (var xe = e.normalizePath(e.combinePaths(zr, Sr)), vr, mr, Ar = 0, Oe = Je.compilerOptions.rootDirs; Ar < Oe.length; Ar++) {
                  var nr = Oe[Ar], Mr = e.normalizePath(nr);
                  e.endsWith(Mr, e.directorySeparator) || (Mr += e.directorySeparator);
                  var Pe = e.startsWith(xe, Mr) && (mr === void 0 || mr.length < Mr.length);
                  Je.traceEnabled && a(Je.host, e.Diagnostics.Checking_if_0_is_the_longest_matching_prefix_for_1_2, Mr, xe, Pe), Pe && (mr = Mr, vr = nr);
                }
                if (mr) {
                  Je.traceEnabled && a(Je.host, e.Diagnostics.Longest_matching_prefix_for_0_is_1, xe, mr);
                  var Ue = xe.substr(mr.length);
                  Je.traceEnabled && a(Je.host, e.Diagnostics.Loading_0_from_the_root_dir_1_candidate_location_2, Ue, mr, xe);
                  var fr = Wr(Ze, xe, !e.directoryProbablyExists(zr, Je.host), Je);
                  if (fr) return fr;
                  Je.traceEnabled && a(Je.host, e.Diagnostics.Trying_other_entries_in_rootDirs);
                  for (var De = 0, gr = Je.compilerOptions.rootDirs; De < gr.length; De++) {
                    var nr = gr[De];
                    if (nr !== vr) {
                      var Vr = e.combinePaths(e.normalizePath(nr), Ue);
                      Je.traceEnabled && a(Je.host, e.Diagnostics.Loading_0_from_the_root_dir_1_candidate_location_2, Ue, nr, Vr);
                      var Tr = e.getDirectoryPath(Vr), vi = Wr(Ze, Vr, !e.directoryProbablyExists(Tr, Je.host), Je);
                      if (vi) return vi;
                    }
                  }
                  Je.traceEnabled && a(Je.host, e.Diagnostics.Module_resolution_using_rootDirs_has_failed);
                }
              }
            }
            function I(Ze, Sr, zr, Wr) {
              var Je = Wr.compilerOptions.baseUrl;
              if (!!Je) {
                Wr.traceEnabled && a(Wr.host, e.Diagnostics.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1, Je, Sr);
                var xe = e.normalizePath(e.combinePaths(Je, Sr));
                return Wr.traceEnabled && a(Wr.host, e.Diagnostics.Resolving_module_name_0_relative_to_base_url_1_2, Sr, Je, xe), zr(Ze, xe, !e.directoryProbablyExists(e.getDirectoryPath(xe), Wr.host), Wr);
              }
            }
            function l(Ze, Sr, zr) {
              var Wr = Z(Ze, Sr, zr), Je = Wr.resolvedModule, xe = Wr.failedLookupLocations;
              if (!Je) throw new Error("Could not resolve JS module '".concat(Ze, "' starting at '").concat(Sr, "'. Looked in: ").concat(xe.join(", ")));
              return Je.resolvedFileName;
            }
            e.resolveJSModule = l;
            var d;
            (function(Ze) {
              Ze[Ze.None = 0] = "None", Ze[Ze.Imports = 2] = "Imports", Ze[Ze.SelfName = 4] = "SelfName", Ze[Ze.Exports = 8] = "Exports", Ze[Ze.ExportsPatternTrailers = 16] = "ExportsPatternTrailers", Ze[Ze.AllFeatures = 30] = "AllFeatures", Ze[Ze.Node16Default = 30] = "Node16Default", Ze[Ze.NodeNextDefault = 30] = "NodeNextDefault", Ze[Ze.EsmMode = 32] = "EsmMode";
            })(d || (d = {}));
            function D(Ze, Sr, zr, Wr, Je, xe, vr) {
              return g(d.Node16Default, Ze, Sr, zr, Wr, Je, xe, vr);
            }
            function fe(Ze, Sr, zr, Wr, Je, xe, vr) {
              return g(d.NodeNextDefault, Ze, Sr, zr, Wr, Je, xe, vr);
            }
            function g(Ze, Sr, zr, Wr, Je, xe, vr, mr) {
              var Ar = e.getDirectoryPath(zr), Oe = mr === e.ModuleKind.ESNext ? d.EsmMode : 0;
              return ge(Ze | Oe, Sr, Ar, Wr, Je, xe, Wr.resolveJsonModule ? We : ue, vr);
            }
            var ne = [Q.JavaScript], ue = [Q.TypeScript, Q.JavaScript], We = Ve(Ve([], ue, true), [Q.Json], false), Fe = [Q.TSConfig];
            function Z(Ze, Sr, zr) {
              return ge(d.None, Ze, Sr, { moduleResolution: e.ModuleResolutionKind.NodeJs, allowJs: true }, zr, void 0, ne, void 0);
            }
            function Be(Ze, Sr, zr, Wr, Je, xe, vr) {
              var mr;
              return vr ? mr = Fe : zr.noDtsResolution ? (mr = [Q.TsOnly], zr.allowJs && mr.push(Q.JavaScript), zr.resolveJsonModule && mr.push(Q.Json)) : mr = zr.resolveJsonModule ? We : ue, ge(d.None, Ze, e.getDirectoryPath(Sr), zr, Wr, Je, mr, xe);
            }
            e.nodeModuleNameResolver = Be;
            function ge(Ze, Sr, zr, Wr, Je, xe, vr, mr) {
              var Ar, Oe, nr = C(Wr, Je), Mr = [], Pe = Ze & d.EsmMode ? ["node", "import", "types"] : ["node", "require", "types"];
              Wr.noDtsResolution && Pe.pop();
              var Ue = [], fr = { compilerOptions: Wr, host: Je, traceEnabled: nr, failedLookupLocations: Mr, packageJsonInfoCache: xe, features: Ze, conditions: Pe, requestContainingDirectory: zr, reportDiagnostic: function(Vr) {
                return void Ue.push(Vr);
              } }, De = e.forEach(vr, function(Vr) {
                return gr(Vr);
              });
              return N((Ar = De == null ? void 0 : De.value) === null || Ar === void 0 ? void 0 : Ar.resolved, (Oe = De == null ? void 0 : De.value) === null || Oe === void 0 ? void 0 : Oe.isExternalLibraryImport, Mr, Ue, fr.resultFromCache);
              function gr(Vr) {
                var Tr = function(ut, Dt, Rt, Ii) {
                  return Ee(ut, Dt, Rt, Ii, true);
                }, vi = U(Vr, Sr, zr, Tr, fr);
                if (vi) return ti({ resolved: vi, isExternalLibraryImport: He(vi.path) });
                if (e.isExternalModuleNameRelative(Sr)) {
                  var Li = Re(zr, Sr), nt = Li.path, Mt = Li.parts, xt = Ee(Vr, nt, false, fr, true);
                  return xt && ti({ resolved: xt, isExternalLibraryImport: e.contains(Mt, "node_modules") });
                } else {
                  var Ui;
                  if (Ze & d.Imports && e.startsWith(Sr, "#") && (Ui = Ur(Vr, Sr, zr, fr, xe, mr)), !Ui && Ze & d.SelfName && (Ui = Ir(Vr, Sr, zr, fr, xe, mr)), Ui || (nr && a(Je, e.Diagnostics.Loading_module_0_from_node_modules_folder_target_file_type_1, Sr, Q[Vr]), Ui = or(Vr, Sr, zr, fr, xe, mr)), !Ui) return;
                  var Yi = Ui.value;
                  if (!Wr.preserveSymlinks && Yi && !Yi.originalPath) {
                    var Wi = ze(Yi.path, Je, nr), ct = q(Wi, Yi.path, Je) ? void 0 : Yi.path;
                    Yi = Ke(Ke({}, Yi), { path: Wi, originalPath: ct });
                  }
                  return { value: Yi && { resolved: Yi, isExternalLibraryImport: true } };
                }
              }
            }
            function Re(Ze, Sr) {
              var zr = e.combinePaths(Ze, Sr), Wr = e.getPathComponents(zr), Je = e.lastOrUndefined(Wr), xe = Je === "." || Je === ".." ? e.ensureTrailingDirectorySeparator(e.normalizePath(zr)) : e.normalizePath(zr);
              return { path: xe, parts: Wr };
            }
            function ze(Ze, Sr, zr) {
              if (!Sr.realpath) return Ze;
              var Wr = e.normalizePath(Sr.realpath(Ze));
              return zr && a(Sr, e.Diagnostics.Resolving_real_path_for_0_result_1, Ze, Wr), e.Debug.assert(Sr.fileExists(Wr), "".concat(Ze, " linked to nonexistent file ").concat(Wr)), Wr;
            }
            function Ee(Ze, Sr, zr, Wr, Je) {
              if (Wr.traceEnabled && a(Wr.host, e.Diagnostics.Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1, Sr, Q[Ze]), !e.hasTrailingDirectorySeparator(Sr)) {
                if (!zr) {
                  var xe = e.getDirectoryPath(Sr);
                  e.directoryProbablyExists(xe, Wr.host) || (Wr.traceEnabled && a(Wr.host, e.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, xe), zr = true);
                }
                var vr = we(Ze, Sr, zr, Wr);
                if (vr) {
                  var mr = Je ? rr(vr.path) : void 0, Ar = mr ? Ne(mr, false, Wr) : void 0;
                  return w(Ar, vr);
                }
              }
              if (!zr) {
                var Oe = e.directoryProbablyExists(Sr, Wr.host);
                Oe || (Wr.traceEnabled && a(Wr.host, e.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, Sr), zr = true);
              }
              if (!(Wr.features & d.EsmMode)) return Cr(Ze, Sr, zr, Wr, Je);
            }
            e.nodeModulesPathPart = "/node_modules/";
            function He(Ze) {
              return e.stringContains(Ze, e.nodeModulesPathPart);
            }
            e.pathContainsNodeModules = He;
            function rr(Ze) {
              var Sr = e.normalizePath(Ze), zr = Sr.lastIndexOf(e.nodeModulesPathPart);
              if (zr !== -1) {
                var Wr = zr + e.nodeModulesPathPart.length, Je = Ie(Sr, Wr);
                return Sr.charCodeAt(Wr) === 64 && (Je = Ie(Sr, Je)), Sr.slice(0, Je);
              }
            }
            e.parseNodeModuleFromPath = rr;
            function Ie(Ze, Sr) {
              var zr = Ze.indexOf(e.directorySeparator, Sr + 1);
              return zr === -1 ? Sr : zr;
            }
            function _e(Ze, Sr, zr, Wr) {
              return B(we(Ze, Sr, zr, Wr));
            }
            function we(Ze, Sr, zr, Wr) {
              if (Ze === Q.Json || Ze === Q.TSConfig) {
                var Je = e.tryRemoveExtension(Sr, ".json"), xe = Je ? Sr.substring(Je.length) : "";
                return Je === void 0 && Ze === Q.Json ? void 0 : Ae(Je || Sr, Ze, xe, zr, Wr);
              }
              if (!(Wr.features & d.EsmMode)) {
                var vr = Ae(Sr, Ze, "", zr, Wr);
                if (vr) return vr;
              }
              return de(Ze, Sr, zr, Wr);
            }
            function de(Ze, Sr, zr, Wr) {
              if (e.hasJSFileExtension(Sr) || e.fileExtensionIs(Sr, ".json") && Wr.compilerOptions.resolveJsonModule) {
                var Je = e.removeFileExtension(Sr), xe = Sr.substring(Je.length);
                return Wr.traceEnabled && a(Wr.host, e.Diagnostics.File_name_0_has_a_1_extension_stripping_it, Sr, xe), Ae(Je, Ze, xe, zr, Wr);
              }
            }
            function ye(Ze, Sr, zr, Wr) {
              if ((Ze === Q.TypeScript || Ze === Q.DtsOnly) && e.fileExtensionIsOneOf(Sr, e.supportedTSExtensionsFlat)) {
                var Je = er(Sr, zr, Wr);
                return Je !== void 0 ? { path: Sr, ext: e.tryExtractTSExtension(Sr) } : void 0;
              }
              return de(Ze, Sr, zr, Wr);
            }
            function Ae(Ze, Sr, zr, Wr, Je) {
              if (!Wr) {
                var xe = e.getDirectoryPath(Ze);
                xe && (Wr = !e.directoryProbablyExists(xe, Je.host));
              }
              switch (Sr) {
                case Q.DtsOnly:
                  switch (zr) {
                    case ".mjs":
                    case ".mts":
                    case ".d.mts":
                      return mr(".d.mts");
                    case ".cjs":
                    case ".cts":
                    case ".d.cts":
                      return mr(".d.cts");
                    case ".json":
                      return Ze += ".json", mr(".d.ts");
                    default:
                      return mr(".d.ts");
                  }
                case Q.TypeScript:
                case Q.TsOnly:
                  var vr = Sr === Q.TypeScript;
                  switch (zr) {
                    case ".mjs":
                    case ".mts":
                    case ".d.mts":
                      return mr(".mts") || (vr ? mr(".d.mts") : void 0);
                    case ".cjs":
                    case ".cts":
                    case ".d.cts":
                      return mr(".cts") || (vr ? mr(".d.cts") : void 0);
                    case ".json":
                      return Ze += ".json", vr ? mr(".d.ts") : void 0;
                    default:
                      return mr(".ts") || mr(".tsx") || (vr ? mr(".d.ts") : void 0);
                  }
                case Q.JavaScript:
                  switch (zr) {
                    case ".mjs":
                    case ".mts":
                    case ".d.mts":
                      return mr(".mjs");
                    case ".cjs":
                    case ".cts":
                    case ".d.cts":
                      return mr(".cjs");
                    case ".json":
                      return mr(".json");
                    default:
                      return mr(".js") || mr(".jsx");
                  }
                case Q.TSConfig:
                case Q.Json:
                  return mr(".json");
              }
              function mr(Ar) {
                var Oe = er(Ze + Ar, Wr, Je);
                return Oe === void 0 ? void 0 : { path: Oe, ext: Ar };
              }
            }
            function er(Ze, Sr, zr) {
              var Wr, Je;
              if (!(!((Wr = zr.compilerOptions.moduleSuffixes) === null || Wr === void 0) && Wr.length)) return ir(Ze, Sr, zr);
              var xe = (Je = e.tryGetExtensionFromPath(Ze)) !== null && Je !== void 0 ? Je : "", vr = xe ? e.removeExtension(Ze, xe) : Ze;
              return e.forEach(zr.compilerOptions.moduleSuffixes, function(mr) {
                return ir(vr + mr + xe, Sr, zr);
              });
            }
            function ir(Ze, Sr, zr) {
              if (!Sr) {
                if (zr.host.fileExists(Ze)) return zr.traceEnabled && a(zr.host, e.Diagnostics.File_0_exist_use_it_as_a_name_resolution_result, Ze), Ze;
                zr.traceEnabled && a(zr.host, e.Diagnostics.File_0_does_not_exist, Ze);
              }
              zr.failedLookupLocations.push(Ze);
            }
            function Cr(Ze, Sr, zr, Wr, Je) {
              Je === void 0 && (Je = true);
              var xe = Je ? Ne(Sr, zr, Wr) : void 0, vr = xe && xe.packageJsonContent, mr = xe && xe.versionPaths;
              return w(xe, n(Ze, Sr, zr, Wr, vr, mr));
            }
            function Ye(Ze, Sr, zr, Wr, Je) {
              if (!Je && Ze.resolvedEntrypoints !== void 0) return Ze.resolvedEntrypoints;
              var xe, vr = Je ? Q.JavaScript : Q.TypeScript, mr = ve(Sr), Ar = { compilerOptions: Sr, host: zr, traceEnabled: C(Sr, zr), failedLookupLocations: [], packageJsonInfoCache: Wr == null ? void 0 : Wr.getPackageJsonInfoCache(), conditions: ["node", "require", "types"], features: mr, requestContainingDirectory: Ze.packageDirectory, reportDiagnostic: e.noop }, Oe = n(vr, Ze.packageDirectory, false, Ar, Ze.packageJsonContent, Ze.versionPaths);
              if (xe = e.append(xe, Oe == null ? void 0 : Oe.path), mr & d.Exports && Ze.packageJsonContent.exports) for (var nr = 0, Mr = [["node", "import", "types"], ["node", "require", "types"]]; nr < Mr.length; nr++) {
                var Pe = Mr[nr], Ue = Ke(Ke({}, Ar), { failedLookupLocations: [], conditions: Pe }), fr = Br(Ze, Ze.packageJsonContent.exports, Ue, vr);
                if (fr) for (var De = 0, gr = fr; De < gr.length; De++) {
                  var Vr = gr[De];
                  xe = e.appendIfUnique(xe, Vr.path);
                }
              }
              return Ze.resolvedEntrypoints = xe || false;
            }
            e.getEntrypointsFromPackageJsonInfo = Ye;
            function Br(Ze, Sr, zr, Wr) {
              var Je;
              if (e.isArray(Sr)) for (var xe = 0, vr = Sr; xe < vr.length; xe++) {
                var mr = vr[xe];
                Oe(mr);
              }
              else if (typeof Sr == "object" && Sr !== null && ur(Sr)) for (var Ar in Sr) Oe(Sr[Ar]);
              else Oe(Sr);
              return Je;
              function Oe(nr) {
                var Mr, Pe;
                if (typeof nr == "string" && e.startsWith(nr, "./") && nr.indexOf("*") === -1) {
                  var Ue = e.getPathComponents(nr).slice(2);
                  if (Ue.indexOf("..") >= 0 || Ue.indexOf(".") >= 0 || Ue.indexOf("node_modules") >= 0) return false;
                  var fr = e.combinePaths(Ze.packageDirectory, nr), De = e.getNormalizedAbsolutePath(fr, (Pe = (Mr = zr.host).getCurrentDirectory) === null || Pe === void 0 ? void 0 : Pe.call(Mr)), gr = ye(Wr, De, false, zr);
                  if (gr) return Je = e.appendIfUnique(Je, gr, function(Yi, Wi) {
                    return Yi.path === Wi.path;
                  }), true;
                } else if (Array.isArray(nr)) for (var Vr = 0, Tr = nr; Vr < Tr.length; Vr++) {
                  var vi = Tr[Vr], Ui = Oe(vi);
                  if (Ui) return true;
                }
                else if (typeof nr == "object" && nr !== null) return e.forEach(e.getOwnKeys(nr), function(Yi) {
                  if (Yi === "default" || e.contains(zr.conditions, Yi) || pe(zr.conditions, Yi)) return Oe(nr[Yi]), true;
                });
              }
            }
            function Er(Ze, Sr, zr, Wr) {
              var Je = { host: zr, compilerOptions: Wr, traceEnabled: C(Wr, zr), failedLookupLocations: [], packageJsonInfoCache: Sr, features: 0, conditions: [], requestContainingDirectory: void 0, reportDiagnostic: e.noop }, xe = e.getPathComponents(Ze);
              for (xe.pop(); xe.length > 0; ) {
                var vr = Ne(e.getPathFromPathComponents(xe), false, Je);
                if (vr) return vr;
                xe.pop();
              }
            }
            e.getPackageScopeForPath = Er;
            function Ne(Ze, Sr, zr) {
              var Wr, Je, xe, vr = zr.host, mr = zr.traceEnabled, Ar = e.combinePaths(Ze, "package.json");
              if (Sr) {
                zr.failedLookupLocations.push(Ar);
                return;
              }
              var Oe = (Wr = zr.packageJsonInfoCache) === null || Wr === void 0 ? void 0 : Wr.getPackageJsonInfo(Ar);
              if (Oe !== void 0) {
                if (typeof Oe != "boolean") return mr && a(vr, e.Diagnostics.File_0_exists_according_to_earlier_cached_lookups, Ar), Oe;
                Oe && mr && a(vr, e.Diagnostics.File_0_does_not_exist_according_to_earlier_cached_lookups, Ar), zr.failedLookupLocations.push(Ar);
                return;
              }
              var nr = e.directoryProbablyExists(Ze, vr);
              if (nr && vr.fileExists(Ar)) {
                var Mr = e.readJson(Ar, vr);
                mr && a(vr, e.Diagnostics.Found_package_json_at_0, Ar);
                var Pe = K(Mr, zr), Ue = { packageDirectory: Ze, packageJsonContent: Mr, versionPaths: Pe, resolvedEntrypoints: void 0 };
                return (Je = zr.packageJsonInfoCache) === null || Je === void 0 || Je.setPackageJsonInfo(Ar, Ue), Ue;
              } else nr && mr && a(vr, e.Diagnostics.File_0_does_not_exist, Ar), (xe = zr.packageJsonInfoCache) === null || xe === void 0 || xe.setPackageJsonInfo(Ar, nr), zr.failedLookupLocations.push(Ar);
            }
            e.getPackageJsonInfo = Ne;
            function n(Ze, Sr, zr, Wr, Je, xe) {
              var vr;
              if (Je) switch (Ze) {
                case Q.JavaScript:
                case Q.Json:
                case Q.TsOnly:
                  vr = f(Je, Sr, Wr);
                  break;
                case Q.TypeScript:
                  vr = G(Je, Sr, Wr) || f(Je, Sr, Wr);
                  break;
                case Q.DtsOnly:
                  vr = G(Je, Sr, Wr);
                  break;
                case Q.TSConfig:
                  vr = oe(Je, Sr, Wr);
                  break;
                default:
                  return e.Debug.assertNever(Ze);
              }
              var mr = function(fr, De, gr, Vr) {
                var Tr = er(De, gr, Vr);
                if (Tr) {
                  var vi = lr(fr, Tr);
                  if (vi) return B(vi);
                  Vr.traceEnabled && a(Vr.host, e.Diagnostics.File_0_has_an_unsupported_extension_so_skipping_it, Tr);
                }
                var Ui = fr === Q.DtsOnly ? Q.TypeScript : fr, Yi = Vr.features;
                (Je == null ? void 0 : Je.type) !== "module" && (Vr.features &= ~d.EsmMode);
                var Wi = Ee(Ui, De, gr, Vr, false);
                return Vr.features = Yi, Wi;
              }, Ar = vr ? !e.directoryProbablyExists(e.getDirectoryPath(vr), Wr.host) : void 0, Oe = zr || !e.directoryProbablyExists(Sr, Wr.host), nr = e.combinePaths(Sr, Ze === Q.TSConfig ? "tsconfig" : "index");
              if (xe && (!vr || e.containsPath(Sr, vr))) {
                var Mr = e.getRelativePathFromDirectory(Sr, vr || nr, false);
                Wr.traceEnabled && a(Wr.host, e.Diagnostics.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2, xe.version, e.version, Mr);
                var Pe = Xi(Ze, Mr, Sr, xe.paths, void 0, mr, Ar || Oe, Wr);
                if (Pe) return E(Pe.value);
              }
              var Ue = vr && E(mr(Ze, vr, Ar, Wr));
              if (Ue) return Ue;
              if (!(Wr.features & d.EsmMode)) return we(Ze, nr, Oe, Wr);
            }
            function lr(Ze, Sr) {
              var zr = e.tryGetExtensionFromPath(Sr);
              return zr !== void 0 && be(Ze, zr) ? { path: Sr, ext: zr } : void 0;
            }
            function be(Ze, Sr) {
              switch (Ze) {
                case Q.JavaScript:
                  return Sr === ".js" || Sr === ".jsx" || Sr === ".mjs" || Sr === ".cjs";
                case Q.TSConfig:
                case Q.Json:
                  return Sr === ".json";
                case Q.TypeScript:
                  return Sr === ".ts" || Sr === ".tsx" || Sr === ".mts" || Sr === ".cts" || Sr === ".d.ts" || Sr === ".d.mts" || Sr === ".d.cts";
                case Q.TsOnly:
                  return Sr === ".ts" || Sr === ".tsx" || Sr === ".mts" || Sr === ".cts";
                case Q.DtsOnly:
                  return Sr === ".d.ts" || Sr === ".d.mts" || Sr === ".d.cts";
              }
            }
            function Ge(Ze) {
              var Sr = Ze.indexOf(e.directorySeparator);
              return Ze[0] === "@" && (Sr = Ze.indexOf(e.directorySeparator, Sr + 1)), Sr === -1 ? { packageName: Ze, rest: "" } : { packageName: Ze.slice(0, Sr), rest: Ze.slice(Sr + 1) };
            }
            e.parsePackageName = Ge;
            function ur(Ze) {
              return e.every(e.getOwnKeys(Ze), function(Sr) {
                return e.startsWith(Sr, ".");
              });
            }
            e.allKeysStartWithDot = ur;
            function yr(Ze) {
              return !e.some(e.getOwnKeys(Ze), function(Sr) {
                return e.startsWith(Sr, ".");
              });
            }
            function Ir(Ze, Sr, zr, Wr, Je, xe) {
              var vr, mr, Ar = typeof Wr.host.useCaseSensitiveFileNames == "function" ? Wr.host.useCaseSensitiveFileNames() : Wr.host.useCaseSensitiveFileNames, Oe = e.toPath(e.combinePaths(zr, "dummy"), (mr = (vr = Wr.host).getCurrentDirectory) === null || mr === void 0 ? void 0 : mr.call(vr), e.createGetCanonicalFileName(Ar === void 0 ? true : Ar)), nr = Er(Oe, Wr.packageJsonInfoCache, Wr.host, Wr.compilerOptions);
              if (!(!nr || !nr.packageJsonContent.exports) && typeof nr.packageJsonContent.name == "string") {
                var Mr = e.getPathComponents(Sr), Pe = e.getPathComponents(nr.packageJsonContent.name);
                if (!!e.every(Pe, function(fr, De) {
                  return Mr[De] === fr;
                })) {
                  var Ue = Mr.slice(Pe.length);
                  return wr(nr, Ze, e.length(Ue) ? ".".concat(e.directorySeparator).concat(Ue.join(e.directorySeparator)) : ".", Wr, Je, xe);
                }
              }
            }
            function wr(Ze, Sr, zr, Wr, Je, xe) {
              if (!!Ze.packageJsonContent.exports) {
                if (zr === ".") {
                  var vr = void 0;
                  if (typeof Ze.packageJsonContent.exports == "string" || Array.isArray(Ze.packageJsonContent.exports) || typeof Ze.packageJsonContent.exports == "object" && yr(Ze.packageJsonContent.exports) ? vr = Ze.packageJsonContent.exports : e.hasProperty(Ze.packageJsonContent.exports, ".") && (vr = Ze.packageJsonContent.exports["."]), vr) {
                    var mr = mi(Sr, Wr, Je, xe, zr, Ze, false);
                    return mr(vr, "", false);
                  }
                } else if (ur(Ze.packageJsonContent.exports)) {
                  if (typeof Ze.packageJsonContent.exports != "object") return Wr.traceEnabled && a(Wr.host, e.Diagnostics.Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1, zr, Ze.packageDirectory), ti(void 0);
                  var Ar = ii(Sr, Wr, Je, xe, zr, Ze.packageJsonContent.exports, Ze, false);
                  if (Ar) return Ar;
                }
                return Wr.traceEnabled && a(Wr.host, e.Diagnostics.Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1, zr, Ze.packageDirectory), ti(void 0);
              }
            }
            function Ur(Ze, Sr, zr, Wr, Je, xe) {
              var vr, mr;
              if (Sr === "#" || e.startsWith(Sr, "#/")) return Wr.traceEnabled && a(Wr.host, e.Diagnostics.Invalid_import_specifier_0_has_no_possible_resolutions, Sr), ti(void 0);
              var Ar = typeof Wr.host.useCaseSensitiveFileNames == "function" ? Wr.host.useCaseSensitiveFileNames() : Wr.host.useCaseSensitiveFileNames, Oe = e.toPath(e.combinePaths(zr, "dummy"), (mr = (vr = Wr.host).getCurrentDirectory) === null || mr === void 0 ? void 0 : mr.call(vr), e.createGetCanonicalFileName(Ar === void 0 ? true : Ar)), nr = Er(Oe, Wr.packageJsonInfoCache, Wr.host, Wr.compilerOptions);
              if (!nr) return Wr.traceEnabled && a(Wr.host, e.Diagnostics.Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve, Oe), ti(void 0);
              if (!nr.packageJsonContent.imports) return Wr.traceEnabled && a(Wr.host, e.Diagnostics.package_json_scope_0_has_no_imports_defined, nr.packageDirectory), ti(void 0);
              var Mr = ii(Ze, Wr, Je, xe, Sr, nr.packageJsonContent.imports, nr, true);
              return Mr || (Wr.traceEnabled && a(Wr.host, e.Diagnostics.Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1, Sr, nr.packageDirectory), ti(void 0));
            }
            function ii(Ze, Sr, zr, Wr, Je, xe, vr, mr) {
              var Ar = mi(Ze, Sr, zr, Wr, Je, vr, mr);
              if (!e.endsWith(Je, e.directorySeparator) && Je.indexOf("*") === -1 && e.hasProperty(xe, Je)) {
                var Oe = xe[Je];
                return Ar(Oe, "", false);
              }
              for (var nr = e.sort(e.filter(e.getOwnKeys(xe), function(Vr) {
                return Vr.indexOf("*") !== -1 || e.endsWith(Vr, "/");
              }), function(Vr, Tr) {
                return Vr.length - Tr.length;
              }), Mr = 0, Pe = nr; Mr < Pe.length; Mr++) {
                var Ue = Pe[Mr];
                if (Sr.features & d.ExportsPatternTrailers && gr(Ue, Je)) {
                  var Oe = xe[Ue], fr = Ue.indexOf("*"), De = Je.substring(Ue.substring(0, fr).length, Je.length - (Ue.length - 1 - fr));
                  return Ar(Oe, De, true);
                } else if (e.endsWith(Ue, "*") && e.startsWith(Je, Ue.substring(0, Ue.length - 1))) {
                  var Oe = xe[Ue], De = Je.substring(Ue.length - 1);
                  return Ar(Oe, De, true);
                } else if (e.startsWith(Je, Ue)) {
                  var Oe = xe[Ue], De = Je.substring(Ue.length);
                  return Ar(Oe, De, false);
                }
              }
              function gr(Vr, Tr) {
                if (e.endsWith(Vr, "*")) return false;
                var vi = Vr.indexOf("*");
                return vi === -1 ? false : e.startsWith(Tr, Vr.substring(0, vi)) && e.endsWith(Tr, Vr.substring(vi + 1));
              }
            }
            function mi(Ze, Sr, zr, Wr, Je, xe, vr) {
              return mr;
              function mr(Ar, Oe, nr) {
                if (typeof Ar == "string") {
                  if (!nr && Oe.length > 0 && !e.endsWith(Ar, "/")) return Sr.traceEnabled && a(Sr.host, e.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, xe.packageDirectory, Je), ti(void 0);
                  if (!e.startsWith(Ar, "./")) {
                    if (vr && !e.startsWith(Ar, "../") && !e.startsWith(Ar, "/") && !e.isRootedDiskPath(Ar)) {
                      var Mr = nr ? Ar.replace(/\*/g, Oe) : Ar + Oe, Pe = ge(Sr.features, Mr, xe.packageDirectory + "/", Sr.compilerOptions, Sr.host, zr, [Ze], Wr);
                      return ti(Pe.resolvedModule ? { path: Pe.resolvedModule.resolvedFileName, extension: Pe.resolvedModule.extension, packageId: Pe.resolvedModule.packageId, originalPath: Pe.resolvedModule.originalPath } : void 0);
                    }
                    return Sr.traceEnabled && a(Sr.host, e.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, xe.packageDirectory, Je), ti(void 0);
                  }
                  var Ue = e.pathIsRelative(Ar) ? e.getPathComponents(Ar).slice(1) : e.getPathComponents(Ar), fr = Ue.slice(1);
                  if (fr.indexOf("..") >= 0 || fr.indexOf(".") >= 0 || fr.indexOf("node_modules") >= 0) return Sr.traceEnabled && a(Sr.host, e.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, xe.packageDirectory, Je), ti(void 0);
                  var De = e.combinePaths(xe.packageDirectory, Ar), gr = e.getPathComponents(Oe);
                  if (gr.indexOf("..") >= 0 || gr.indexOf(".") >= 0 || gr.indexOf("node_modules") >= 0) return Sr.traceEnabled && a(Sr.host, e.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, xe.packageDirectory, Je), ti(void 0);
                  var Vr = Mt(nr ? De.replace(/\*/g, Oe) : De + Oe), Tr = Dt(Vr, Oe, e.combinePaths(xe.packageDirectory, "package.json"), vr);
                  return Tr || ti(w(xe, ye(Ze, Vr, false, Sr)));
                } else if (typeof Ar == "object" && Ar !== null) if (Array.isArray(Ar)) {
                  if (!e.length(Ar)) return Sr.traceEnabled && a(Sr.host, e.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, xe.packageDirectory, Je), ti(void 0);
                  for (var ct = 0, Li = Ar; ct < Li.length; ct++) {
                    var nt = Li[ct], Pe = mr(nt, Oe, nr);
                    if (Pe) return Pe;
                  }
                } else {
                  for (var vi = 0, Ui = e.getOwnKeys(Ar); vi < Ui.length; vi++) {
                    var Yi = Ui[vi];
                    if (Yi === "default" || Sr.conditions.indexOf(Yi) >= 0 || pe(Sr.conditions, Yi)) {
                      var Wi = Ar[Yi], Pe = mr(Wi, Oe, nr);
                      if (Pe) return Pe;
                    }
                  }
                  return;
                }
                else if (Ar === null) return Sr.traceEnabled && a(Sr.host, e.Diagnostics.package_json_scope_0_explicitly_maps_specifier_1_to_null, xe.packageDirectory, Je), ti(void 0);
                return Sr.traceEnabled && a(Sr.host, e.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, xe.packageDirectory, Je), ti(void 0);
                function Mt(Rt) {
                  var Ii, Ki;
                  return Rt === void 0 ? Rt : e.hostGetCanonicalFileName({ useCaseSensitiveFileNames: ut })(e.getNormalizedAbsolutePath(Rt, (Ki = (Ii = Sr.host).getCurrentDirectory) === null || Ki === void 0 ? void 0 : Ki.call(Ii)));
                }
                function xt(Rt, Ii) {
                  return e.ensureTrailingDirectorySeparator(e.combinePaths(Rt, Ii));
                }
                function ut() {
                  return Sr.host.useCaseSensitiveFileNames ? typeof Sr.host.useCaseSensitiveFileNames == "boolean" ? Sr.host.useCaseSensitiveFileNames : Sr.host.useCaseSensitiveFileNames() : true;
                }
                function Dt(Rt, Ii, Ki, Fi) {
                  var ui, Bt, wt, na;
                  if ((Ze === Q.TypeScript || Ze === Q.JavaScript || Ze === Q.Json) && (Sr.compilerOptions.declarationDir || Sr.compilerOptions.outDir) && Rt.indexOf("/node_modules/") === -1 && (Sr.compilerOptions.configFile ? e.startsWith(Mt(Sr.compilerOptions.configFile.fileName), xe.packageDirectory) : true)) {
                    var Ai = e.hostGetCanonicalFileName({ useCaseSensitiveFileNames: ut }), Oi = [];
                    if (Sr.compilerOptions.rootDir || Sr.compilerOptions.composite && Sr.compilerOptions.configFilePath) {
                      var ji = Mt(e.getCommonSourceDirectory(Sr.compilerOptions, function() {
                        return [];
                      }, ((Bt = (ui = Sr.host).getCurrentDirectory) === null || Bt === void 0 ? void 0 : Bt.call(ui)) || "", Ai));
                      Oi.push(ji);
                    } else if (Sr.requestContainingDirectory) {
                      var Vi = Mt(e.combinePaths(Sr.requestContainingDirectory, "index.ts")), ji = Mt(e.getCommonSourceDirectory(Sr.compilerOptions, function() {
                        return [Vi, Mt(Ki)];
                      }, ((na = (wt = Sr.host).getCurrentDirectory) === null || na === void 0 ? void 0 : na.call(wt)) || "", Ai));
                      Oi.push(ji);
                      for (var at = e.ensureTrailingDirectorySeparator(ji); at && at.length > 1; ) {
                        var At = e.getPathComponents(at);
                        At.pop();
                        var ba = e.getPathFromPathComponents(At);
                        Oi.unshift(ba), at = e.ensureTrailingDirectorySeparator(ba);
                      }
                    }
                    Oi.length > 1 && Sr.reportDiagnostic(e.createCompilerDiagnostic(Fi ? e.Diagnostics.The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate : e.Diagnostics.The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate, Ii === "" ? "." : Ii, Ki));
                    for (var $a = 0, Qa = Oi; $a < Qa.length; $a++) for (var ai = Qa[$a], Dn = En(ai), ka = 0, Ba = Dn; ka < Ba.length; ka++) {
                      var pn = Ba[ka];
                      if (e.startsWith(Rt, pn)) for (var Cn = Rt.slice(pn.length + 1), Bi = e.combinePaths(ai, Cn), kn = [".mjs", ".cjs", ".js", ".json", ".d.mts", ".d.cts", ".d.ts"], xn = 0, Kn = kn; xn < Kn.length; xn++) {
                        var Pn = Kn[xn];
                        if (e.fileExtensionIs(Bi, Pn)) for (var eo = e.getPossibleOriginalInputExtensionForExtension(Bi), Rn = 0, Da = eo; Rn < Da.length; Rn++) {
                          var bo = Da[Rn], Ro = e.changeAnyExtension(Bi, bo, Pn, !ut());
                          if (!(Ze === Q.TypeScript && e.hasJSFileExtension(Ro) || Ze === Q.JavaScript && e.hasTSFileExtension(Ro)) && Sr.host.fileExists(Ro)) return ti(w(xe, ye(Ze, Ro, false, Sr)));
                        }
                      }
                    }
                  }
                  return;
                  function En(Wn) {
                    var to, Co, Ko = Sr.compilerOptions.configFile ? ((Co = (to = Sr.host).getCurrentDirectory) === null || Co === void 0 ? void 0 : Co.call(to)) || "" : Wn, Oo = [];
                    return Sr.compilerOptions.declarationDir && Oo.push(Mt(xt(Ko, Sr.compilerOptions.declarationDir))), Sr.compilerOptions.outDir && Sr.compilerOptions.outDir !== Sr.compilerOptions.declarationDir && Oo.push(Mt(xt(Ko, Sr.compilerOptions.outDir))), Oo;
                  }
                }
              }
            }
            function pe(Ze, Sr) {
              if (Ze.indexOf("types") === -1 || !e.startsWith(Sr, "types@")) return false;
              var zr = e.VersionRange.tryParse(Sr.substring(6));
              return zr ? zr.test(e.version) : false;
            }
            e.isApplicableVersionedTypesKey = pe;
            function or(Ze, Sr, zr, Wr, Je, xe) {
              return si(Ze, Sr, zr, Wr, false, Je, xe);
            }
            function qr(Ze, Sr, zr) {
              return si(Q.DtsOnly, Ze, Sr, zr, true, void 0, void 0);
            }
            function si(Ze, Sr, zr, Wr, Je, xe, vr) {
              var mr = xe && xe.getOrCreateCacheForModuleName(Sr, Wr.features === 0 ? void 0 : Wr.features & d.EsmMode ? e.ModuleKind.ESNext : e.ModuleKind.CommonJS, vr);
              return e.forEachAncestorDirectory(e.normalizeSlashes(zr), function(Ar) {
                if (e.getBaseFileName(Ar) !== "node_modules") {
                  var Oe = ae(mr, Sr, Ar, Wr);
                  return Oe || ti(Di(Ze, Sr, Ar, Wr, Je, xe, vr));
                }
              });
            }
            function Di(Ze, Sr, zr, Wr, Je, xe, vr) {
              var mr = e.combinePaths(zr, "node_modules"), Ar = e.directoryProbablyExists(mr, Wr.host);
              !Ar && Wr.traceEnabled && a(Wr.host, e.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, mr);
              var Oe = Je ? void 0 : wi(Ze, Sr, mr, Ar, Wr, xe, vr);
              if (Oe) return Oe;
              if (Ze === Q.TypeScript || Ze === Q.DtsOnly) {
                var nr = e.combinePaths(mr, "@types"), Mr = Ar;
                return Ar && !e.directoryProbablyExists(nr, Wr.host) && (Wr.traceEnabled && a(Wr.host, e.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, nr), Mr = false), wi(Q.DtsOnly, Gi(Sr, Wr), nr, Mr, Wr, xe, vr);
              }
            }
            function wi(Ze, Sr, zr, Wr, Je, xe, vr) {
              var mr = e.normalizePath(e.combinePaths(zr, Sr)), Ar = Ne(mr, !Wr, Je);
              if (!(Je.features & d.Exports) && Ar) {
                var Oe = we(Ze, mr, !Wr, Je);
                if (Oe) return B(Oe);
                var nr = n(Ze, mr, !Wr, Je, Ar.packageJsonContent, Ar.versionPaths);
                return w(Ar, nr);
              }
              var Mr = Ge(Sr), Pe = Mr.packageName, Ue = Mr.rest, fr = function(Tr, vi, Ui, Yi) {
                var Wi;
                if (Ar && Ar.packageJsonContent.exports && Yi.features & d.Exports) return (Wi = wr(Ar, Tr, e.combinePaths(".", Ue), Yi, xe, vr)) === null || Wi === void 0 ? void 0 : Wi.value;
                var ct = we(Tr, vi, Ui, Yi) || n(Tr, vi, Ui, Yi, Ar && Ar.packageJsonContent, Ar && Ar.versionPaths);
                return !ct && Ar && Ar.packageJsonContent.exports === void 0 && Ar.packageJsonContent.main === void 0 && Yi.features & d.EsmMode && (ct = we(Tr, e.combinePaths(vi, "index.js"), Ui, Yi)), w(Ar, ct);
              };
              if (Ue !== "") {
                var De = e.combinePaths(zr, Pe);
                if (Ar = Ne(De, !Wr, Je), Ar && Ar.versionPaths) {
                  Je.traceEnabled && a(Je.host, e.Diagnostics.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2, Ar.versionPaths.version, e.version, Ue);
                  var gr = Wr && e.directoryProbablyExists(De, Je.host), Vr = Xi(Ze, Ue, De, Ar.versionPaths.paths, void 0, fr, !gr, Je);
                  if (Vr) return Vr.value;
                }
              }
              return fr(Ze, mr, !Wr, Je);
            }
            function Xi(Ze, Sr, zr, Wr, Je, xe, vr, mr) {
              Je || (Je = e.tryParsePatterns(Wr));
              var Ar = e.matchPatternOrExact(Je, Sr);
              if (Ar) {
                var Oe = e.isString(Ar) ? void 0 : e.matchedText(Ar, Sr), nr = e.isString(Ar) ? Ar : e.patternText(Ar);
                mr.traceEnabled && a(mr.host, e.Diagnostics.Module_name_0_matched_pattern_1, Sr, nr);
                var Mr = e.forEach(Wr[nr], function(Pe) {
                  var Ue = Oe ? Pe.replace("*", Oe) : Pe, fr = e.normalizePath(e.combinePaths(zr, Ue));
                  mr.traceEnabled && a(mr.host, e.Diagnostics.Trying_substitution_0_candidate_module_location_Colon_1, Pe, Ue);
                  var De = e.tryGetExtensionFromPath(Pe);
                  if (De !== void 0) {
                    var gr = er(fr, vr, mr);
                    if (gr !== void 0) return B({ path: gr, ext: De });
                  }
                  return xe(Ze, fr, vr || !e.directoryProbablyExists(e.getDirectoryPath(fr), mr.host), mr);
                });
                return { value: Mr };
              }
            }
            var et = "__";
            function Gi(Ze, Sr) {
              var zr = Zt(Ze);
              return Sr.traceEnabled && zr !== Ze && a(Sr.host, e.Diagnostics.Scoped_package_detected_looking_in_0, zr), zr;
            }
            function Wt(Ze) {
              return "@types/".concat(Zt(Ze));
            }
            e.getTypesPackageName = Wt;
            function Zt(Ze) {
              if (e.startsWith(Ze, "@")) {
                var Sr = Ze.replace(e.directorySeparator, et);
                if (Sr !== Ze) return Sr.slice(1);
              }
              return Ze;
            }
            e.mangleScopedPackageName = Zt;
            function _r(Ze) {
              var Sr = e.removePrefix(Ze, "@types/");
              return Sr !== Ze ? pi(Sr) : Ze;
            }
            e.getPackageNameFromTypesPackageName = _r;
            function pi(Ze) {
              return e.stringContains(Ze, et) ? "@" + Ze.replace(et, e.directorySeparator) : Ze;
            }
            e.unmangleScopedPackageName = pi;
            function ae(Ze, Sr, zr, Wr) {
              var Je = Ze && Ze.get(zr);
              if (Je) return Wr.traceEnabled && a(Wr.host, e.Diagnostics.Resolution_for_module_0_was_found_in_cache_from_location_1, Sr, zr), Wr.resultFromCache = Je, { value: Je.resolvedModule && { path: Je.resolvedModule.resolvedFileName, originalPath: Je.resolvedModule.originalPath || true, extension: Je.resolvedModule.extension, packageId: Je.resolvedModule.packageId } };
            }
            function Xe(Ze, Sr, zr, Wr, Je, xe) {
              var vr = C(zr, Wr), mr = [], Ar = e.getDirectoryPath(Sr), Oe = [], nr = { compilerOptions: zr, host: Wr, traceEnabled: vr, failedLookupLocations: mr, packageJsonInfoCache: Je, features: d.None, conditions: [], requestContainingDirectory: Ar, reportDiagnostic: function(Ue) {
                return void Oe.push(Ue);
              } }, Mr = Pe(Q.TypeScript) || Pe(Q.JavaScript);
              return N(Mr && Mr.value, false, mr, Oe, nr.resultFromCache);
              function Pe(Ue) {
                var fr = U(Ue, Ze, Ar, _e, nr);
                if (fr) return { value: fr };
                if (e.isExternalModuleNameRelative(Ze)) {
                  var Vr = e.normalizePath(e.combinePaths(Ar, Ze));
                  return ti(_e(Ue, Vr, false, nr));
                } else {
                  var De = Je && Je.getOrCreateCacheForModuleName(Ze, void 0, xe), gr = e.forEachAncestorDirectory(Ar, function(Tr) {
                    var vi = ae(De, Ze, Tr, nr);
                    if (vi) return vi;
                    var Ui = e.normalizePath(e.combinePaths(Tr, Ze));
                    return ti(_e(Ue, Ui, false, nr));
                  });
                  if (gr) return gr;
                  if (Ue === Q.TypeScript) return qr(Ze, Ar, nr);
                }
              }
            }
            e.classicNameResolver = Xe;
            function Jr(Ze, Sr, zr, Wr, Je, xe) {
              var vr = C(zr, Wr);
              vr && a(Wr, e.Diagnostics.Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2, Sr, Ze, Je);
              var mr = [], Ar = [], Oe = { compilerOptions: zr, host: Wr, traceEnabled: vr, failedLookupLocations: mr, packageJsonInfoCache: xe, features: d.None, conditions: [], requestContainingDirectory: void 0, reportDiagnostic: function(Mr) {
                return void Ar.push(Mr);
              } }, nr = Di(Q.DtsOnly, Ze, Je, Oe, false, void 0, void 0);
              return N(nr, true, mr, Ar, Oe.resultFromCache);
            }
            e.loadModuleFromGlobalCache = Jr;
            function ti(Ze) {
              return Ze !== void 0 ? { value: Ze } : void 0;
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(b) {
              b[b.NonInstantiated = 0] = "NonInstantiated", b[b.Instantiated = 1] = "Instantiated", b[b.ConstEnumOnly = 2] = "ConstEnumOnly";
            })(a = e.ModuleInstanceState || (e.ModuleInstanceState = {}));
            function C(b, se) {
              return b.body && !b.body.parent && (e.setParent(b.body, b), e.setParentRecursive(b.body, false)), b.body ? w(b.body, se) : 1;
            }
            e.getModuleInstanceState = C;
            function w(b, se) {
              se === void 0 && (se = new e.Map());
              var J = e.getNodeId(b);
              if (se.has(J)) return se.get(J) || 0;
              se.set(J, void 0);
              var ie = B(b, se);
              return se.set(J, ie), ie;
            }
            function B(b, se) {
              switch (b.kind) {
                case 258:
                case 259:
                  return 0;
                case 260:
                  if (e.isEnumConst(b)) return 2;
                  break;
                case 266:
                case 265:
                  if (!e.hasSyntacticModifier(b, 1)) return 0;
                  break;
                case 272:
                  var J = b;
                  if (!J.moduleSpecifier && J.exportClause && J.exportClause.kind === 273) {
                    for (var ie = 0, R = 0, q = J.exportClause.elements; R < q.length; R++) {
                      var O = q[R], ve = E(O, se);
                      if (ve > ie && (ie = ve), ie === 1) return ie;
                    }
                    return ie;
                  }
                  break;
                case 262: {
                  var ee = 0;
                  return e.forEachChild(b, function(he) {
                    var F = w(he, se);
                    switch (F) {
                      case 0:
                        return;
                      case 2:
                        ee = 2;
                        return;
                      case 1:
                        return ee = 1, true;
                      default:
                        e.Debug.assertNever(F);
                    }
                  }), ee;
                }
                case 261:
                  return C(b, se);
                case 79:
                  if (b.isInJSDocNamespace) return 0;
              }
              return 1;
            }
            function E(b, se) {
              for (var J = b.propertyName || b.name, ie = b.parent; ie; ) {
                if (e.isBlock(ie) || e.isModuleBlock(ie) || e.isSourceFile(ie)) {
                  for (var R = ie.statements, q = void 0, O = 0, ve = R; O < ve.length; O++) {
                    var ee = ve[O];
                    if (e.nodeHasName(ee, J)) {
                      ee.parent || (e.setParent(ee, ie), e.setParentRecursive(ee, false));
                      var he = w(ee, se);
                      if ((q === void 0 || he > q) && (q = he), q === 1) return q;
                    }
                  }
                  if (q !== void 0) return q;
                }
                ie = ie.parent;
              }
              return 1;
            }
            var Q;
            (function(b) {
              b[b.None = 0] = "None", b[b.IsContainer = 1] = "IsContainer", b[b.IsBlockScopedContainer = 2] = "IsBlockScopedContainer", b[b.IsControlFlowContainer = 4] = "IsControlFlowContainer", b[b.IsFunctionLike = 8] = "IsFunctionLike", b[b.IsFunctionExpression = 16] = "IsFunctionExpression", b[b.HasLocals = 32] = "HasLocals", b[b.IsInterface = 64] = "IsInterface", b[b.IsObjectLiteralOrClassExpressionMethodOrAccessor = 128] = "IsObjectLiteralOrClassExpressionMethodOrAccessor";
            })(Q || (Q = {}));
            function le(b) {
              return e.Debug.attachFlowNodeDebugInfo(b), b;
            }
            var N = m();
            function p(b, se) {
              e.performance.mark("beforeBind"), e.perfLogger.logStartBindFile("" + b.fileName), N(b, se), e.perfLogger.logStopBindFile(), e.performance.mark("afterBind"), e.performance.measure("Bind", "beforeBind", "afterBind");
            }
            e.bindSourceFile = p;
            function m() {
              var b, se, J, ie, R, q, O, ve, ee, he, F, x, X, $, A, y, V, L, P, k, Y, U, j = false, H = 0, I, l, d = { flags: 1 }, D = { flags: 1 }, fe = Ar();
              function g(ce, Rr, yi, qi, je) {
                return e.createDiagnosticForNodeInSourceFile(e.getSourceFileOfNode(ce) || b, ce, Rr, yi, qi, je);
              }
              function ne(ce, Rr) {
                b = ce, se = Rr, J = e.getEmitScriptTarget(se), U = ue(b, Rr), l = new e.Set(), H = 0, I = e.objectAllocator.getSymbolConstructor(), e.Debug.attachFlowNodeDebugInfo(d), e.Debug.attachFlowNodeDebugInfo(D), b.locals || (e.tracing === null || e.tracing === void 0 || e.tracing.push("bind", "bindSourceFile", { path: b.path }, true), Da(b), e.tracing === null || e.tracing === void 0 || e.tracing.pop(), b.symbolCount = H, b.classifiableNames = l, Ai()), b = void 0, se = void 0, J = void 0, ie = void 0, R = void 0, q = void 0, O = void 0, ve = void 0, ee = void 0, he = false, F = void 0, x = void 0, X = void 0, $ = void 0, A = void 0, y = void 0, V = void 0, P = void 0, k = false, j = false, Y = 0;
              }
              return ne;
              function ue(ce, Rr) {
                return e.getStrictOptionValue(Rr, "alwaysStrict") && !ce.isDeclarationFile ? true : !!ce.externalModuleIndicator;
              }
              function We(ce, Rr) {
                return H++, new I(ce, Rr);
              }
              function Fe(ce, Rr, yi) {
                ce.flags |= yi, Rr.symbol = ce, ce.declarations = e.appendIfUnique(ce.declarations, Rr), yi & 1955 && !ce.exports && (ce.exports = e.createSymbolTable()), yi & 6240 && !ce.members && (ce.members = e.createSymbolTable()), ce.constEnumOnlyModule && ce.flags & 304 && (ce.constEnumOnlyModule = false), yi & 111551 && e.setValueDeclaration(ce, Rr);
              }
              function Z(ce) {
                if (ce.kind === 271) return ce.isExportEquals ? "export=" : "default";
                var Rr = e.getNameOfDeclaration(ce);
                if (Rr) {
                  if (e.isAmbientModule(ce)) {
                    var yi = e.getTextOfIdentifierOrLiteral(Rr);
                    return e.isGlobalScopeAugmentation(ce) ? "__global" : '"'.concat(yi, '"');
                  }
                  if (Rr.kind === 162) {
                    var qi = Rr.expression;
                    if (e.isStringOrNumericLiteralLike(qi)) return e.escapeLeadingUnderscores(qi.text);
                    if (e.isSignedNumericLiteral(qi)) return e.tokenToString(qi.operator) + qi.operand.text;
                    e.Debug.fail("Only computed properties with literal names have declaration names");
                  }
                  if (e.isPrivateIdentifier(Rr)) {
                    var je = e.getContainingClass(ce);
                    if (!je) return;
                    var Hr = je.symbol;
                    return e.getSymbolNameForPrivateIdentifier(Hr, Rr.escapedText);
                  }
                  return e.isPropertyNameLiteral(Rr) ? e.getEscapedTextOfIdentifierOrLiteral(Rr) : void 0;
                }
                switch (ce.kind) {
                  case 171:
                    return "__constructor";
                  case 179:
                  case 174:
                  case 323:
                    return "__call";
                  case 180:
                  case 175:
                    return "__new";
                  case 176:
                    return "__index";
                  case 272:
                    return "__export";
                  case 305:
                    return "export=";
                  case 221:
                    if (e.getAssignmentDeclarationKind(ce) === 2) return "export=";
                    e.Debug.fail("Unknown binary declaration kind");
                    break;
                  case 317:
                    return e.isJSDocConstructSignature(ce) ? "__new" : "__call";
                  case 164:
                    e.Debug.assert(ce.parent.kind === 317, "Impossible parameter parent kind", function() {
                      return "parent is: ".concat(e.SyntaxKind ? e.SyntaxKind[ce.parent.kind] : ce.parent.kind, ", expected JSDocFunctionType");
                    });
                    var pt = ce.parent, Pt = pt.parameters.indexOf(ce);
                    return "arg" + Pt;
                }
              }
              function Be(ce) {
                return e.isNamedDeclaration(ce) ? e.declarationNameToString(ce.name) : e.unescapeLeadingUnderscores(e.Debug.checkDefined(Z(ce)));
              }
              function ge(ce, Rr, yi, qi, je, Hr, pt) {
                e.Debug.assert(pt || !e.hasDynamicName(yi));
                var Pt = e.hasSyntacticModifier(yi, 512) || e.isExportSpecifier(yi) && yi.name.escapedText === "default", ga = pt ? "__computed" : Pt && Rr ? "default" : Z(yi), ua;
                if (ga === void 0) ua = We(0, "__missing");
                else if (ua = ce.get(ga), qi & 2885600 && l.add(ga), !ua) ce.set(ga, ua = We(0, ga)), Hr && (ua.isReplaceableByMethod = true);
                else {
                  if (Hr && !ua.isReplaceableByMethod) return ua;
                  if (ua.flags & je) {
                    if (ua.isReplaceableByMethod) ce.set(ga, ua = We(0, ga));
                    else if (!(qi & 3 && ua.flags & 67108864)) {
                      e.isNamedDeclaration(yi) && e.setParent(yi.name, yi);
                      var Xn = ua.flags & 2 ? e.Diagnostics.Cannot_redeclare_block_scoped_variable_0 : e.Diagnostics.Duplicate_identifier_0, jr = true;
                      (ua.flags & 384 || qi & 384) && (Xn = e.Diagnostics.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations, jr = false);
                      var fo = false;
                      e.length(ua.declarations) && (Pt || ua.declarations && ua.declarations.length && yi.kind === 271 && !yi.isExportEquals) && (Xn = e.Diagnostics.A_module_cannot_have_multiple_default_exports, jr = false, fo = true);
                      var xs = [];
                      e.isTypeAliasDeclaration(yi) && e.nodeIsMissing(yi.type) && e.hasSyntacticModifier(yi, 1) && ua.flags & 2887656 && xs.push(g(yi, e.Diagnostics.Did_you_mean_0, "export type { ".concat(e.unescapeLeadingUnderscores(yi.name.escapedText), " }")));
                      var Fo = e.getNameOfDeclaration(yi) || yi;
                      e.forEach(ua.declarations, function(Ao, Ms) {
                        var Bs = e.getNameOfDeclaration(Ao) || Ao, xc = g(Bs, Xn, jr ? Be(Ao) : void 0);
                        b.bindDiagnostics.push(fo ? e.addRelatedInfo(xc, g(Fo, Ms === 0 ? e.Diagnostics.Another_export_default_is_here : e.Diagnostics.and_here)) : xc), fo && xs.push(g(Bs, e.Diagnostics.The_first_export_default_is_here));
                      });
                      var ko = g(Fo, Xn, jr ? Be(yi) : void 0);
                      b.bindDiagnostics.push(e.addRelatedInfo.apply(void 0, Ve([ko], xs, false))), ua = We(0, ga);
                    }
                  }
                }
                return Fe(ua, yi, qi), ua.parent ? e.Debug.assert(ua.parent === Rr, "Existing symbol parent should match new one") : ua.parent = Rr, ua;
              }
              function Re(ce, Rr, yi) {
                var qi = !!(e.getCombinedModifierFlags(ce) & 1) || ze(ce);
                if (Rr & 2097152) return ce.kind === 275 || ce.kind === 265 && qi ? ge(R.symbol.exports, R.symbol, ce, Rr, yi) : ge(R.locals, void 0, ce, Rr, yi);
                if (e.isJSDocTypeAlias(ce) && e.Debug.assert(e.isInJSFile(ce)), !e.isAmbientModule(ce) && (qi || R.flags & 64)) {
                  if (!R.locals || e.hasSyntacticModifier(ce, 512) && !Z(ce)) return ge(R.symbol.exports, R.symbol, ce, Rr, yi);
                  var je = Rr & 111551 ? 1048576 : 0, Hr = ge(R.locals, void 0, ce, je, yi);
                  return Hr.exportSymbol = ge(R.symbol.exports, R.symbol, ce, Rr, yi), ce.localSymbol = Hr, Hr;
                } else return ge(R.locals, void 0, ce, Rr, yi);
              }
              function ze(ce) {
                if (ce.parent && e.isModuleDeclaration(ce) && (ce = ce.parent), !e.isJSDocTypeAlias(ce)) return false;
                if (!e.isJSDocEnumTag(ce) && !!ce.fullName) return true;
                var Rr = e.getNameOfDeclaration(ce);
                return Rr ? !!(e.isPropertyAccessEntityNameExpression(Rr.parent) && Wa(Rr.parent) || e.isDeclaration(Rr.parent) && e.getCombinedModifierFlags(Rr.parent) & 1) : false;
              }
              function Ee(ce, Rr) {
                var yi = R, qi = q, je = O;
                if (Rr & 1 ? (ce.kind !== 214 && (q = R), R = O = ce, Rr & 32 && (R.locals = e.createSymbolTable()), Li(R)) : Rr & 2 && (O = ce, O.locals = void 0), Rr & 4) {
                  var Hr = F, pt = x, Pt = X, ga = $, ua = V, Xn = P, jr = k, fo = Rr & 16 && !e.hasSyntacticModifier(ce, 256) && !ce.asteriskToken && !!e.getImmediatelyInvokedFunctionExpression(ce) || ce.kind === 170;
                  fo || (F = le({ flags: 2 }), Rr & 144 && (F.node = ce)), $ = fo || ce.kind === 171 || e.isInJSFile(ce) && (ce.kind === 256 || ce.kind === 213) ? Ye() : void 0, V = void 0, x = void 0, X = void 0, P = void 0, k = false, _e(ce), ce.flags &= -2817, !(F.flags & 1) && Rr & 8 && e.nodeIsPresent(ce.body) && (ce.flags |= 256, k && (ce.flags |= 512), ce.endFlowNode = F), ce.kind === 305 && (ce.flags |= Y, ce.endFlowNode = F), $ && (n($, F), F = yr($), (ce.kind === 171 || ce.kind === 170 || e.isInJSFile(ce) && (ce.kind === 256 || ce.kind === 213)) && (ce.returnFlowNode = F)), fo || (F = Hr), x = pt, X = Pt, $ = ga, V = ua, P = Xn, k = jr;
                } else Rr & 64 ? (he = false, _e(ce), ce.flags = he ? ce.flags | 128 : ce.flags & -129) : _e(ce);
                R = yi, q = qi, O = je;
              }
              function He(ce) {
                rr(ce, function(Rr) {
                  return Rr.kind === 256 ? Da(Rr) : void 0;
                }), rr(ce, function(Rr) {
                  return Rr.kind !== 256 ? Da(Rr) : void 0;
                });
              }
              function rr(ce, Rr) {
                Rr === void 0 && (Rr = Da), ce !== void 0 && e.forEach(ce, Rr);
              }
              function Ie(ce) {
                e.forEachChild(ce, Da, rr);
              }
              function _e(ce) {
                var Rr = j;
                if (j = false, Ji(ce)) {
                  Ie(ce), bo(ce), j = Rr;
                  return;
                }
                switch (ce.kind >= 237 && ce.kind <= 253 && !se.allowUnreachableCode && (ce.flowNode = F), ce.kind) {
                  case 241:
                    si(ce);
                    break;
                  case 240:
                    Di(ce);
                    break;
                  case 242:
                    wi(ce);
                    break;
                  case 243:
                  case 244:
                    Xi(ce);
                    break;
                  case 239:
                    et(ce);
                    break;
                  case 247:
                  case 251:
                    Gi(ce);
                    break;
                  case 246:
                  case 245:
                    _r(ce);
                    break;
                  case 252:
                    pi(ce);
                    break;
                  case 249:
                    ae(ce);
                    break;
                  case 263:
                    Xe(ce);
                    break;
                  case 289:
                    Jr(ce);
                    break;
                  case 238:
                    ti(ce);
                    break;
                  case 250:
                    Sr(ce);
                    break;
                  case 219:
                    xe(ce);
                    break;
                  case 220:
                    vr(ce);
                    break;
                  case 221:
                    if (e.isDestructuringAssignment(ce)) {
                      j = Rr, mr(ce);
                      return;
                    }
                    fe(ce);
                    break;
                  case 215:
                    Oe(ce);
                    break;
                  case 222:
                    nr(ce);
                    break;
                  case 254:
                    Pe(ce);
                    break;
                  case 206:
                  case 207:
                    Yi(ce);
                    break;
                  case 208:
                    Wi(ce);
                    break;
                  case 230:
                    Ui(ce);
                    break;
                  case 345:
                  case 338:
                  case 339:
                    fr(ce);
                    break;
                  case 305: {
                    He(ce.statements), Da(ce.endOfFileToken);
                    break;
                  }
                  case 235:
                  case 262:
                    He(ce.statements);
                    break;
                  case 203:
                    Ue(ce);
                    break;
                  case 205:
                  case 204:
                  case 296:
                  case 225:
                    j = Rr;
                  default:
                    Ie(ce);
                    break;
                }
                bo(ce), j = Rr;
              }
              function we(ce) {
                switch (ce.kind) {
                  case 79:
                  case 80:
                  case 108:
                  case 206:
                  case 207:
                    return ye(ce);
                  case 208:
                    return Ae(ce);
                  case 212:
                  case 230:
                    return we(ce.expression);
                  case 221:
                    return ir(ce);
                  case 219:
                    return ce.operator === 53 && we(ce.operand);
                  case 216:
                    return we(ce.expression);
                }
                return false;
              }
              function de(ce) {
                return e.isDottedName(ce) || (e.isPropertyAccessExpression(ce) || e.isNonNullExpression(ce) || e.isParenthesizedExpression(ce)) && de(ce.expression) || e.isBinaryExpression(ce) && ce.operatorToken.kind === 27 && de(ce.right) || e.isElementAccessExpression(ce) && (e.isStringOrNumericLiteralLike(ce.argumentExpression) || e.isEntityNameExpression(ce.argumentExpression)) && de(ce.expression) || e.isAssignmentExpression(ce) && de(ce.left);
              }
              function ye(ce) {
                return de(ce) || e.isOptionalChain(ce) && ye(ce.expression);
              }
              function Ae(ce) {
                if (ce.arguments) for (var Rr = 0, yi = ce.arguments; Rr < yi.length; Rr++) {
                  var qi = yi[Rr];
                  if (ye(qi)) return true;
                }
                return !!(ce.expression.kind === 206 && ye(ce.expression.expression));
              }
              function er(ce, Rr) {
                return e.isTypeOfExpression(ce) && Cr(ce.expression) && e.isStringLiteralLike(Rr);
              }
              function ir(ce) {
                switch (ce.operatorToken.kind) {
                  case 63:
                  case 75:
                  case 76:
                  case 77:
                    return ye(ce.left);
                  case 34:
                  case 35:
                  case 36:
                  case 37:
                    return Cr(ce.left) || Cr(ce.right) || er(ce.right, ce.left) || er(ce.left, ce.right);
                  case 102:
                    return Cr(ce.left);
                  case 101:
                    return we(ce.right);
                  case 27:
                    return we(ce.right);
                }
                return false;
              }
              function Cr(ce) {
                switch (ce.kind) {
                  case 212:
                    return Cr(ce.expression);
                  case 221:
                    switch (ce.operatorToken.kind) {
                      case 63:
                        return Cr(ce.left);
                      case 27:
                        return Cr(ce.right);
                    }
                }
                return ye(ce);
              }
              function Ye() {
                return le({ flags: 4, antecedents: void 0 });
              }
              function Br() {
                return le({ flags: 8, antecedents: void 0 });
              }
              function Er(ce, Rr, yi) {
                return le({ flags: 1024, target: ce, antecedents: Rr, antecedent: yi });
              }
              function Ne(ce) {
                ce.flags |= ce.flags & 2048 ? 4096 : 2048;
              }
              function n(ce, Rr) {
                !(Rr.flags & 1) && !e.contains(ce.antecedents, Rr) && ((ce.antecedents || (ce.antecedents = [])).push(Rr), Ne(Rr));
              }
              function lr(ce, Rr, yi) {
                return Rr.flags & 1 ? Rr : yi ? (yi.kind === 110 && ce & 64 || yi.kind === 95 && ce & 32) && !e.isExpressionOfOptionalChainRoot(yi) && !e.isNullishCoalesce(yi.parent) ? d : we(yi) ? (Ne(Rr), le({ flags: ce, antecedent: Rr, node: yi })) : Rr : ce & 32 ? Rr : d;
              }
              function be(ce, Rr, yi, qi) {
                return Ne(ce), le({ flags: 128, antecedent: ce, switchStatement: Rr, clauseStart: yi, clauseEnd: qi });
              }
              function Ge(ce, Rr, yi) {
                Ne(Rr);
                var qi = le({ flags: ce, antecedent: Rr, node: yi });
                return V && n(V, qi), qi;
              }
              function ur(ce, Rr) {
                return Ne(ce), le({ flags: 512, antecedent: ce, node: Rr });
              }
              function yr(ce) {
                var Rr = ce.antecedents;
                return Rr ? Rr.length === 1 ? Rr[0] : ce : d;
              }
              function Ir(ce) {
                var Rr = ce.parent;
                switch (Rr.kind) {
                  case 239:
                  case 241:
                  case 240:
                    return Rr.expression === ce;
                  case 242:
                  case 222:
                    return Rr.condition === ce;
                }
                return false;
              }
              function wr(ce) {
                for (; ; ) if (ce.kind === 212) ce = ce.expression;
                else if (ce.kind === 219 && ce.operator === 53) ce = ce.operand;
                else return ce.kind === 221 && (ce.operatorToken.kind === 55 || ce.operatorToken.kind === 56 || ce.operatorToken.kind === 60);
              }
              function Ur(ce) {
                return ce = e.skipParentheses(ce), e.isBinaryExpression(ce) && e.isLogicalOrCoalescingAssignmentOperator(ce.operatorToken.kind);
              }
              function ii(ce) {
                for (; e.isParenthesizedExpression(ce.parent) || e.isPrefixUnaryExpression(ce.parent) && ce.parent.operator === 53; ) ce = ce.parent;
                return !Ir(ce) && !wr(ce.parent) && !(e.isOptionalChain(ce.parent) && ce.parent.expression === ce);
              }
              function mi(ce, Rr, yi, qi) {
                var je = A, Hr = y;
                A = yi, y = qi, ce(Rr), A = je, y = Hr;
              }
              function pe(ce, Rr, yi) {
                mi(Da, ce, Rr, yi), (!ce || !Ur(ce) && !wr(ce) && !(e.isOptionalChain(ce) && e.isOutermostOptionalChain(ce))) && (n(Rr, lr(32, F, ce)), n(yi, lr(64, F, ce)));
              }
              function or(ce, Rr, yi) {
                var qi = x, je = X;
                x = Rr, X = yi, Da(ce), x = qi, X = je;
              }
              function qr(ce, Rr) {
                for (var yi = P; yi && ce.parent.kind === 250; ) yi.continueTarget = Rr, yi = yi.next, ce = ce.parent;
                return Rr;
              }
              function si(ce) {
                var Rr = qr(ce, Br()), yi = Ye(), qi = Ye();
                n(Rr, F), F = Rr, pe(ce.expression, yi, qi), F = yr(yi), or(ce.statement, qi, Rr), n(Rr, F), F = yr(qi);
              }
              function Di(ce) {
                var Rr = Br(), yi = qr(ce, Ye()), qi = Ye();
                n(Rr, F), F = Rr, or(ce.statement, qi, yi), n(yi, F), F = yr(yi), pe(ce.expression, Rr, qi), F = yr(qi);
              }
              function wi(ce) {
                var Rr = qr(ce, Br()), yi = Ye(), qi = Ye();
                Da(ce.initializer), n(Rr, F), F = Rr, pe(ce.condition, yi, qi), F = yr(yi), or(ce.statement, qi, Rr), Da(ce.incrementor), n(Rr, F), F = yr(qi);
              }
              function Xi(ce) {
                var Rr = qr(ce, Br()), yi = Ye();
                Da(ce.expression), n(Rr, F), F = Rr, ce.kind === 244 && Da(ce.awaitModifier), n(yi, F), Da(ce.initializer), ce.initializer.kind !== 255 && Wr(ce.initializer), or(ce.statement, yi, Rr), n(Rr, F), F = yr(yi);
              }
              function et(ce) {
                var Rr = Ye(), yi = Ye(), qi = Ye();
                pe(ce.expression, Rr, yi), F = yr(Rr), Da(ce.thenStatement), n(qi, F), F = yr(yi), Da(ce.elseStatement), n(qi, F), F = yr(qi);
              }
              function Gi(ce) {
                Da(ce.expression), ce.kind === 247 && (k = true, $ && n($, F)), F = d;
              }
              function Wt(ce) {
                for (var Rr = P; Rr; Rr = Rr.next) if (Rr.name === ce) return Rr;
              }
              function Zt(ce, Rr, yi) {
                var qi = ce.kind === 246 ? Rr : yi;
                qi && (n(qi, F), F = d);
              }
              function _r(ce) {
                if (Da(ce.label), ce.label) {
                  var Rr = Wt(ce.label.escapedText);
                  Rr && (Rr.referenced = true, Zt(ce, Rr.breakTarget, Rr.continueTarget));
                } else Zt(ce, x, X);
              }
              function pi(ce) {
                var Rr = $, yi = V, qi = Ye(), je = Ye(), Hr = Ye();
                if (ce.finallyBlock && ($ = je), n(Hr, F), V = Hr, Da(ce.tryBlock), n(qi, F), ce.catchClause && (F = yr(Hr), Hr = Ye(), n(Hr, F), V = Hr, Da(ce.catchClause), n(qi, F)), $ = Rr, V = yi, ce.finallyBlock) {
                  var pt = Ye();
                  pt.antecedents = e.concatenate(e.concatenate(qi.antecedents, Hr.antecedents), je.antecedents), F = pt, Da(ce.finallyBlock), F.flags & 1 ? F = d : ($ && je.antecedents && n($, Er(pt, je.antecedents, F)), V && Hr.antecedents && n(V, Er(pt, Hr.antecedents, F)), F = qi.antecedents ? Er(pt, qi.antecedents, F) : d);
                } else F = yr(qi);
              }
              function ae(ce) {
                var Rr = Ye();
                Da(ce.expression);
                var yi = x, qi = L;
                x = Rr, L = F, Da(ce.caseBlock), n(Rr, F);
                var je = e.forEach(ce.caseBlock.clauses, function(Hr) {
                  return Hr.kind === 290;
                });
                ce.possiblyExhaustive = !je && !Rr.antecedents, je || n(Rr, be(L, ce, 0, 0)), x = yi, L = qi, F = yr(Rr);
              }
              function Xe(ce) {
                for (var Rr = ce.clauses, yi = we(ce.parent.expression), qi = d, je = 0; je < Rr.length; je++) {
                  for (var Hr = je; !Rr[je].statements.length && je + 1 < Rr.length; ) Da(Rr[je]), je++;
                  var pt = Ye();
                  n(pt, yi ? be(L, ce.parent, Hr, je + 1) : L), n(pt, qi), F = yr(pt);
                  var Pt = Rr[je];
                  Da(Pt), qi = F, !(F.flags & 1) && je !== Rr.length - 1 && se.noFallthroughCasesInSwitch && (Pt.fallthroughFlowNode = F);
                }
              }
              function Jr(ce) {
                var Rr = F;
                F = L, Da(ce.expression), F = Rr, rr(ce.statements);
              }
              function ti(ce) {
                Da(ce.expression), Ze(ce.expression);
              }
              function Ze(ce) {
                if (ce.kind === 208) {
                  var Rr = ce;
                  Rr.expression.kind !== 106 && e.isDottedName(Rr.expression) && (F = ur(F, Rr));
                }
              }
              function Sr(ce) {
                var Rr = Ye();
                P = { next: P, name: ce.label.escapedText, breakTarget: Rr, continueTarget: void 0, referenced: false }, Da(ce.label), Da(ce.statement), !P.referenced && !se.allowUnusedLabels && Pn(e.unusedLabelIsError(se), ce.label, e.Diagnostics.Unused_label), P = P.next, n(Rr, F), F = yr(Rr);
              }
              function zr(ce) {
                ce.kind === 221 && ce.operatorToken.kind === 63 ? Wr(ce.left) : Wr(ce);
              }
              function Wr(ce) {
                if (de(ce)) F = Ge(16, F, ce);
                else if (ce.kind === 204) for (var Rr = 0, yi = ce.elements; Rr < yi.length; Rr++) {
                  var qi = yi[Rr];
                  qi.kind === 225 ? Wr(qi.expression) : zr(qi);
                }
                else if (ce.kind === 205) for (var je = 0, Hr = ce.properties; je < Hr.length; je++) {
                  var pt = Hr[je];
                  pt.kind === 296 ? zr(pt.initializer) : pt.kind === 297 ? Wr(pt.name) : pt.kind === 298 && Wr(pt.expression);
                }
              }
              function Je(ce, Rr, yi) {
                var qi = Ye();
                ce.operatorToken.kind === 55 || ce.operatorToken.kind === 76 ? pe(ce.left, qi, yi) : pe(ce.left, Rr, qi), F = yr(qi), Da(ce.operatorToken), e.isLogicalOrCoalescingAssignmentOperator(ce.operatorToken.kind) ? (mi(Da, ce.right, Rr, yi), Wr(ce.left), n(Rr, lr(32, F, ce)), n(yi, lr(64, F, ce))) : pe(ce.right, Rr, yi);
              }
              function xe(ce) {
                if (ce.operator === 53) {
                  var Rr = A;
                  A = y, y = Rr, Ie(ce), y = A, A = Rr;
                } else Ie(ce), (ce.operator === 45 || ce.operator === 46) && Wr(ce.operand);
              }
              function vr(ce) {
                Ie(ce), (ce.operator === 45 || ce.operator === 46) && Wr(ce.operand);
              }
              function mr(ce) {
                j ? (j = false, Da(ce.operatorToken), Da(ce.right), j = true, Da(ce.left)) : (j = true, Da(ce.left), j = false, Da(ce.operatorToken), Da(ce.right)), Wr(ce.left);
              }
              function Ar() {
                return e.createBinaryExpressionTrampoline(ce, Rr, yi, qi, je, void 0);
                function ce(pt, Pt) {
                  if (Pt) {
                    Pt.stackIndex++, e.setParent(pt, ie);
                    var ga = U;
                    Wn(pt);
                    var ua = ie;
                    ie = pt, Pt.skip = false, Pt.inStrictModeStack[Pt.stackIndex] = ga, Pt.parentStack[Pt.stackIndex] = ua;
                  } else Pt = { stackIndex: 0, skip: false, inStrictModeStack: [void 0], parentStack: [void 0] };
                  var Xn = pt.operatorToken.kind;
                  if (Xn === 55 || Xn === 56 || Xn === 60 || e.isLogicalOrCoalescingAssignmentOperator(Xn)) {
                    if (ii(pt)) {
                      var jr = Ye();
                      Je(pt, jr, jr), F = yr(jr);
                    } else Je(pt, A, y);
                    Pt.skip = true;
                  }
                  return Pt;
                }
                function Rr(pt, Pt, ga) {
                  if (!Pt.skip) {
                    var ua = Hr(pt);
                    return ga.operatorToken.kind === 27 && Ze(pt), ua;
                  }
                }
                function yi(pt, Pt, ga) {
                  Pt.skip || Da(pt);
                }
                function qi(pt, Pt, ga) {
                  if (!Pt.skip) {
                    var ua = Hr(pt);
                    return ga.operatorToken.kind === 27 && Ze(pt), ua;
                  }
                }
                function je(pt, Pt) {
                  if (!Pt.skip) {
                    var ga = pt.operatorToken.kind;
                    if (e.isAssignmentOperator(ga) && !e.isAssignmentTarget(pt) && (Wr(pt.left), ga === 63 && pt.left.kind === 207)) {
                      var ua = pt.left;
                      Cr(ua.expression) && (F = Ge(256, F, pt));
                    }
                  }
                  var Xn = Pt.inStrictModeStack[Pt.stackIndex], jr = Pt.parentStack[Pt.stackIndex];
                  Xn !== void 0 && (U = Xn), jr !== void 0 && (ie = jr), Pt.skip = false, Pt.stackIndex--;
                }
                function Hr(pt) {
                  if (pt && e.isBinaryExpression(pt) && !e.isDestructuringAssignment(pt)) return pt;
                  Da(pt);
                }
              }
              function Oe(ce) {
                Ie(ce), ce.expression.kind === 206 && Wr(ce.expression);
              }
              function nr(ce) {
                var Rr = Ye(), yi = Ye(), qi = Ye();
                pe(ce.condition, Rr, yi), F = yr(Rr), Da(ce.questionToken), Da(ce.whenTrue), n(qi, F), F = yr(yi), Da(ce.colonToken), Da(ce.whenFalse), n(qi, F), F = yr(qi);
              }
              function Mr(ce) {
                var Rr = e.isOmittedExpression(ce) ? void 0 : ce.name;
                if (e.isBindingPattern(Rr)) for (var yi = 0, qi = Rr.elements; yi < qi.length; yi++) {
                  var je = qi[yi];
                  Mr(je);
                }
                else F = Ge(16, F, ce);
              }
              function Pe(ce) {
                Ie(ce), (ce.initializer || e.isForInOrOfStatement(ce.parent.parent)) && Mr(ce);
              }
              function Ue(ce) {
                e.isBindingPattern(ce.name) ? (rr(ce.decorators), rr(ce.modifiers), Da(ce.dotDotDotToken), Da(ce.propertyName), Da(ce.initializer), Da(ce.name)) : Ie(ce);
              }
              function fr(ce) {
                Da(ce.tagName), ce.kind !== 339 && ce.fullName && (e.setParent(ce.fullName, ce), e.setParentRecursive(ce.fullName, false)), typeof ce.comment != "string" && rr(ce.comment);
              }
              function De(ce) {
                Ie(ce);
                var Rr = e.getHostSignatureFromJSDoc(ce);
                Rr && Rr.kind !== 169 && Fe(Rr.symbol, Rr, 32);
              }
              function gr(ce, Rr, yi) {
                mi(Da, ce, Rr, yi), (!e.isOptionalChain(ce) || e.isOutermostOptionalChain(ce)) && (n(Rr, lr(32, F, ce)), n(yi, lr(64, F, ce)));
              }
              function Vr(ce) {
                switch (ce.kind) {
                  case 206:
                    Da(ce.questionDotToken), Da(ce.name);
                    break;
                  case 207:
                    Da(ce.questionDotToken), Da(ce.argumentExpression);
                    break;
                  case 208:
                    Da(ce.questionDotToken), rr(ce.typeArguments), rr(ce.arguments);
                    break;
                }
              }
              function Tr(ce, Rr, yi) {
                var qi = e.isOptionalChainRoot(ce) ? Ye() : void 0;
                gr(ce.expression, qi || Rr, yi), qi && (F = yr(qi)), mi(Vr, ce, Rr, yi), e.isOutermostOptionalChain(ce) && (n(Rr, lr(32, F, ce)), n(yi, lr(64, F, ce)));
              }
              function vi(ce) {
                if (ii(ce)) {
                  var Rr = Ye();
                  Tr(ce, Rr, Rr), F = yr(Rr);
                } else Tr(ce, A, y);
              }
              function Ui(ce) {
                e.isOptionalChain(ce) ? vi(ce) : Ie(ce);
              }
              function Yi(ce) {
                e.isOptionalChain(ce) ? vi(ce) : Ie(ce);
              }
              function Wi(ce) {
                if (e.isOptionalChain(ce)) vi(ce);
                else {
                  var Rr = e.skipParentheses(ce.expression);
                  Rr.kind === 213 || Rr.kind === 214 ? (rr(ce.typeArguments), rr(ce.arguments), Da(ce.expression)) : (Ie(ce), ce.expression.kind === 106 && (F = ur(F, ce)));
                }
                if (ce.expression.kind === 206) {
                  var yi = ce.expression;
                  e.isIdentifier(yi.name) && Cr(yi.expression) && e.isPushOrUnshiftIdentifier(yi.name) && (F = Ge(256, F, ce));
                }
              }
              function ct(ce) {
                switch (ce.kind) {
                  case 226:
                  case 257:
                  case 260:
                  case 205:
                  case 182:
                  case 322:
                  case 286:
                    return 1;
                  case 258:
                    return 65;
                  case 261:
                  case 259:
                  case 195:
                  case 176:
                    return 33;
                  case 305:
                    return 37;
                  case 172:
                  case 173:
                  case 169:
                    if (e.isObjectLiteralOrClassExpressionMethodOrAccessor(ce)) return 173;
                  case 171:
                  case 256:
                  case 168:
                  case 174:
                  case 323:
                  case 317:
                  case 179:
                  case 175:
                  case 180:
                  case 170:
                    return 45;
                  case 213:
                  case 214:
                    return 61;
                  case 262:
                    return 4;
                  case 167:
                    return ce.initializer ? 4 : 0;
                  case 292:
                  case 242:
                  case 243:
                  case 244:
                  case 263:
                    return 2;
                  case 235:
                    return e.isFunctionLike(ce.parent) || e.isClassStaticBlockDeclaration(ce.parent) ? 0 : 2;
                }
                return 0;
              }
              function Li(ce) {
                ve && (ve.nextContainer = ce), ve = ce;
              }
              function nt(ce, Rr, yi) {
                switch (R.kind) {
                  case 261:
                    return Re(ce, Rr, yi);
                  case 305:
                    return xt(ce, Rr, yi);
                  case 226:
                  case 257:
                    return Mt(ce, Rr, yi);
                  case 260:
                    return ge(R.symbol.exports, R.symbol, ce, Rr, yi);
                  case 182:
                  case 322:
                  case 205:
                  case 258:
                  case 286:
                    return ge(R.symbol.members, R.symbol, ce, Rr, yi);
                  case 179:
                  case 180:
                  case 174:
                  case 175:
                  case 323:
                  case 176:
                  case 169:
                  case 168:
                  case 171:
                  case 172:
                  case 173:
                  case 256:
                  case 213:
                  case 214:
                  case 317:
                  case 345:
                  case 338:
                  case 170:
                  case 259:
                  case 195:
                    return ge(R.locals, void 0, ce, Rr, yi);
                }
              }
              function Mt(ce, Rr, yi) {
                return e.isStatic(ce) ? ge(R.symbol.exports, R.symbol, ce, Rr, yi) : ge(R.symbol.members, R.symbol, ce, Rr, yi);
              }
              function xt(ce, Rr, yi) {
                return e.isExternalModule(b) ? Re(ce, Rr, yi) : ge(b.locals, void 0, ce, Rr, yi);
              }
              function ut(ce) {
                var Rr = e.isSourceFile(ce) ? ce : e.tryCast(ce.body, e.isModuleBlock);
                return !!Rr && Rr.statements.some(function(yi) {
                  return e.isExportDeclaration(yi) || e.isExportAssignment(yi);
                });
              }
              function Dt(ce) {
                ce.flags & 16777216 && !ut(ce) ? ce.flags |= 64 : ce.flags &= -65;
              }
              function Rt(ce) {
                if (Dt(ce), e.isAmbientModule(ce)) if (e.hasSyntacticModifier(ce, 1) && Kn(ce, e.Diagnostics.export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible), e.isModuleAugmentationExternal(ce)) Ii(ce);
                else {
                  var Rr = void 0;
                  if (ce.name.kind === 10) {
                    var yi = ce.name.text;
                    Rr = e.tryParsePattern(yi), Rr === void 0 && Kn(ce.name, e.Diagnostics.Pattern_0_can_have_at_most_one_Asterisk_character, yi);
                  }
                  var qi = nt(ce, 512, 110735);
                  b.patternAmbientModules = e.append(b.patternAmbientModules, Rr && !e.isString(Rr) ? { pattern: Rr, symbol: qi } : void 0);
                }
                else {
                  var je = Ii(ce);
                  if (je !== 0) {
                    var qi = ce.symbol;
                    qi.constEnumOnlyModule = !(qi.flags & 304) && je === 2 && qi.constEnumOnlyModule !== false;
                  }
                }
              }
              function Ii(ce) {
                var Rr = C(ce), yi = Rr !== 0;
                return nt(ce, yi ? 512 : 1024, yi ? 110735 : 0), Rr;
              }
              function Ki(ce) {
                var Rr = We(131072, Z(ce));
                Fe(Rr, ce, 131072);
                var yi = We(2048, "__type");
                Fe(yi, ce, 2048), yi.members = e.createSymbolTable(), yi.members.set(Rr.escapedName, Rr);
              }
              function Fi(ce) {
                var Rr;
                if (function(ua) {
                  ua[ua.Property = 1] = "Property", ua[ua.Accessor = 2] = "Accessor";
                }(Rr || (Rr = {})), U && !e.isAssignmentTarget(ce)) for (var yi = new e.Map(), qi = 0, je = ce.properties; qi < je.length; qi++) {
                  var Hr = je[qi];
                  if (!(Hr.kind === 298 || Hr.name.kind !== 79)) {
                    var pt = Hr.name, Pt = Hr.kind === 296 || Hr.kind === 297 || Hr.kind === 169 ? 1 : 2, ga = yi.get(pt.escapedText);
                    if (!ga) {
                      yi.set(pt.escapedText, Pt);
                      continue;
                    }
                  }
                }
                return wt(ce, 4096, "__object");
              }
              function ui(ce) {
                return wt(ce, 4096, "__jsxAttributes");
              }
              function Bt(ce, Rr, yi) {
                return nt(ce, Rr, yi);
              }
              function wt(ce, Rr, yi) {
                var qi = We(Rr, yi);
                return Rr & 106508 && (qi.parent = R.symbol), Fe(qi, ce, Rr), qi;
              }
              function na(ce, Rr, yi) {
                switch (O.kind) {
                  case 261:
                    Re(ce, Rr, yi);
                    break;
                  case 305:
                    if (e.isExternalOrCommonJsModule(R)) {
                      Re(ce, Rr, yi);
                      break;
                    }
                  default:
                    O.locals || (O.locals = e.createSymbolTable(), Li(O)), ge(O.locals, void 0, ce, Rr, yi);
                }
              }
              function Ai() {
                if (!!ee) {
                  for (var ce = R, Rr = ve, yi = O, qi = ie, je = F, Hr = 0, pt = ee; Hr < pt.length; Hr++) {
                    var Pt = pt[Hr], ga = Pt.parent.parent;
                    R = e.findAncestor(ga.parent, function(fo) {
                      return !!(ct(fo) & 1);
                    }) || b, O = e.getEnclosingBlockScopeContainer(ga) || b, F = le({ flags: 2 }), ie = Pt, Da(Pt.typeExpression);
                    var ua = e.getNameOfDeclaration(Pt);
                    if ((e.isJSDocEnumTag(Pt) || !Pt.fullName) && ua && e.isPropertyAccessEntityNameExpression(ua.parent)) {
                      var Xn = Wa(ua.parent);
                      if (Xn) {
                        sa(b.symbol, ua.parent, Xn, !!e.findAncestor(ua, function(fo) {
                          return e.isPropertyAccessExpression(fo) && fo.name.escapedText === "prototype";
                        }), false);
                        var jr = R;
                        switch (e.getAssignmentDeclarationPropertyAccessKind(ua.parent)) {
                          case 1:
                          case 2:
                            e.isExternalOrCommonJsModule(b) ? R = b : R = void 0;
                            break;
                          case 4:
                            R = ua.parent.expression;
                            break;
                          case 3:
                            R = ua.parent.expression.name;
                            break;
                          case 5:
                            R = T(b, ua.parent.expression) ? b : e.isPropertyAccessExpression(ua.parent.expression) ? ua.parent.expression.name : ua.parent.expression;
                            break;
                          case 0:
                            return e.Debug.fail("Shouldn't have detected typedef or enum on non-assignment declaration");
                        }
                        R && Re(Pt, 524288, 788968), R = jr;
                      }
                    } else e.isJSDocEnumTag(Pt) || !Pt.fullName || Pt.fullName.kind === 79 ? (ie = Pt.parent, na(Pt, 524288, 788968)) : Da(Pt.fullName);
                  }
                  R = ce, ve = Rr, O = yi, ie = qi, F = je;
                }
              }
              function Oi(ce) {
                !b.parseDiagnostics.length && !(ce.flags & 16777216) && !(ce.flags & 8388608) && !e.isIdentifierName(ce) && (U && ce.originalKeywordKind >= 117 && ce.originalKeywordKind <= 125 ? b.bindDiagnostics.push(g(ce, ji(ce), e.declarationNameToString(ce))) : ce.originalKeywordKind === 132 ? e.isExternalModule(b) && e.isInTopLevelContext(ce) ? b.bindDiagnostics.push(g(ce, e.Diagnostics.Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module, e.declarationNameToString(ce))) : ce.flags & 32768 && b.bindDiagnostics.push(g(ce, e.Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here, e.declarationNameToString(ce))) : ce.originalKeywordKind === 125 && ce.flags & 8192 && b.bindDiagnostics.push(g(ce, e.Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here, e.declarationNameToString(ce))));
              }
              function ji(ce) {
                return e.getContainingClass(ce) ? e.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode : b.externalModuleIndicator ? e.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode : e.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode;
              }
              function Vi(ce) {
                ce.escapedText === "#constructor" && (b.parseDiagnostics.length || b.bindDiagnostics.push(g(ce, e.Diagnostics.constructor_is_a_reserved_word, e.declarationNameToString(ce))));
              }
              function at(ce) {
                U && e.isLeftHandSideExpression(ce.left) && e.isAssignmentOperator(ce.operatorToken.kind) && Qa(ce, ce.left);
              }
              function At(ce) {
                U && ce.variableDeclaration && Qa(ce, ce.variableDeclaration.name);
              }
              function ba(ce) {
                if (U && ce.expression.kind === 79) {
                  var Rr = e.getErrorSpanForNode(b, ce.expression);
                  b.bindDiagnostics.push(e.createFileDiagnostic(b, Rr.start, Rr.length, e.Diagnostics.delete_cannot_be_called_on_an_identifier_in_strict_mode));
                }
              }
              function $a(ce) {
                return e.isIdentifier(ce) && (ce.escapedText === "eval" || ce.escapedText === "arguments");
              }
              function Qa(ce, Rr) {
                if (Rr && Rr.kind === 79) {
                  var yi = Rr;
                  if ($a(yi)) {
                    var qi = e.getErrorSpanForNode(b, Rr);
                    b.bindDiagnostics.push(e.createFileDiagnostic(b, qi.start, qi.length, ai(ce), e.idText(yi)));
                  }
                }
              }
              function ai(ce) {
                return e.getContainingClass(ce) ? e.Diagnostics.Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode : b.externalModuleIndicator ? e.Diagnostics.Invalid_use_of_0_Modules_are_automatically_in_strict_mode : e.Diagnostics.Invalid_use_of_0_in_strict_mode;
              }
              function Dn(ce) {
                U && Qa(ce, ce.name);
              }
              function ka(ce) {
                return e.getContainingClass(ce) ? e.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode : b.externalModuleIndicator ? e.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode : e.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5;
              }
              function Ba(ce) {
                if (J < 2 && O.kind !== 305 && O.kind !== 261 && !e.isFunctionLikeOrClassStaticBlockDeclaration(O)) {
                  var Rr = e.getErrorSpanForNode(b, ce);
                  b.bindDiagnostics.push(e.createFileDiagnostic(b, Rr.start, Rr.length, ka(ce)));
                }
              }
              function pn(ce) {
                J < 1 && U && ce.numericLiteralFlags & 32 && b.bindDiagnostics.push(g(ce, e.Diagnostics.Octal_literals_are_not_allowed_in_strict_mode));
              }
              function Cn(ce) {
                U && Qa(ce, ce.operand);
              }
              function Bi(ce) {
                U && (ce.operator === 45 || ce.operator === 46) && Qa(ce, ce.operand);
              }
              function kn(ce) {
                U && Kn(ce, e.Diagnostics.with_statements_are_not_allowed_in_strict_mode);
              }
              function xn(ce) {
                U && e.getEmitScriptTarget(se) >= 2 && (e.isDeclarationStatement(ce.statement) || e.isVariableStatement(ce.statement)) && Kn(ce.label, e.Diagnostics.A_label_is_not_allowed_here);
              }
              function Kn(ce, Rr, yi, qi, je) {
                var Hr = e.getSpanOfTokenAtPosition(b, ce.pos);
                b.bindDiagnostics.push(e.createFileDiagnostic(b, Hr.start, Hr.length, Rr, yi, qi, je));
              }
              function Pn(ce, Rr, yi) {
                eo(ce, Rr, Rr, yi);
              }
              function eo(ce, Rr, yi, qi) {
                Rn(ce, { pos: e.getTokenPosOfNode(Rr, b), end: yi.end }, qi);
              }
              function Rn(ce, Rr, yi) {
                var qi = e.createFileDiagnostic(b, Rr.pos, Rr.end - Rr.pos, yi);
                ce ? b.bindDiagnostics.push(qi) : b.bindSuggestionDiagnostics = e.append(b.bindSuggestionDiagnostics, Ke(Ke({}, qi), { category: e.DiagnosticCategory.Suggestion }));
              }
              function Da(ce) {
                if (!!ce) {
                  e.setParent(ce, ie), e.tracing && (ce.tracingPath = b.path);
                  var Rr = U;
                  if (Wn(ce), ce.kind > 160) {
                    var yi = ie;
                    ie = ce;
                    var qi = ct(ce);
                    qi === 0 ? _e(ce) : Ee(ce, qi), ie = yi;
                  } else {
                    var yi = ie;
                    ce.kind === 1 && (ie = ce), bo(ce), ie = yi;
                  }
                  U = Rr;
                }
              }
              function bo(ce) {
                if (e.hasJSDocNodes(ce)) if (e.isInJSFile(ce)) for (var Rr = 0, yi = ce.jsDoc; Rr < yi.length; Rr++) {
                  var qi = yi[Rr];
                  Da(qi);
                }
                else for (var je = 0, Hr = ce.jsDoc; je < Hr.length; je++) {
                  var qi = Hr[je];
                  e.setParent(qi, ce), e.setParentRecursive(qi, false);
                }
              }
              function Ro(ce) {
                if (!U) for (var Rr = 0, yi = ce; Rr < yi.length; Rr++) {
                  var qi = yi[Rr];
                  if (!e.isPrologueDirective(qi)) return;
                  if (En(qi)) {
                    U = true;
                    return;
                  }
                }
              }
              function En(ce) {
                var Rr = e.getSourceTextOfNodeFromSourceFile(b, ce.expression);
                return Rr === '"use strict"' || Rr === "'use strict'";
              }
              function Wn(ce) {
                switch (ce.kind) {
                  case 79:
                    if (ce.isInJSDocNamespace) {
                      for (var Rr = ce.parent; Rr && !e.isJSDocTypeAlias(Rr); ) Rr = Rr.parent;
                      na(Rr, 524288, 788968);
                      break;
                    }
                  case 108:
                    return F && (e.isExpression(ce) || ie.kind === 297) && (ce.flowNode = F), Oi(ce);
                  case 161:
                    F && e.isPartOfTypeQuery(ce) && (ce.flowNode = F);
                    break;
                  case 231:
                  case 106:
                    ce.flowNode = F;
                    break;
                  case 80:
                    return Vi(ce);
                  case 206:
                  case 207:
                    var yi = ce;
                    F && de(yi) && (yi.flowNode = F), e.isSpecialPropertyDeclaration(yi) && qe(yi), e.isInJSFile(yi) && b.commonJsModuleIndicator && e.isModuleExportsAccessExpression(yi) && !K(O, "module") && ge(b.locals, void 0, yi.expression, 134217729, 111550);
                    break;
                  case 221:
                    var qi = e.getAssignmentDeclarationKind(ce);
                    switch (qi) {
                      case 1:
                        dn(ce);
                        break;
                      case 2:
                        Jn(ce);
                        break;
                      case 3:
                        Si(ce.left, ce);
                        break;
                      case 6:
                        br(ce);
                        break;
                      case 4:
                        Gr(ce);
                        break;
                      case 5:
                        var je = ce.left.expression;
                        if (e.isInJSFile(ce) && e.isIdentifier(je)) {
                          var Hr = K(O, je.escapedText);
                          if (e.isThisInitializedDeclaration(Hr == null ? void 0 : Hr.valueDeclaration)) {
                            Gr(ce);
                            break;
                          }
                        }
                        Qi(ce);
                        break;
                      case 0:
                        break;
                      default:
                        e.Debug.fail("Unknown binary expression special property assignment kind");
                    }
                    return at(ce);
                  case 292:
                    return At(ce);
                  case 215:
                    return ba(ce);
                  case 8:
                    return pn(ce);
                  case 220:
                    return Cn(ce);
                  case 219:
                    return Bi(ce);
                  case 248:
                    return kn(ce);
                  case 250:
                    return xn(ce);
                  case 192:
                    he = true;
                    return;
                  case 177:
                    break;
                  case 163:
                    return js(ce);
                  case 164:
                    return pc(ce);
                  case 254:
                    return Xs(ce);
                  case 203:
                    return ce.flowNode = F, Xs(ce);
                  case 167:
                  case 166:
                    return to(ce);
                  case 296:
                  case 297:
                    return ps(ce, 4, 0);
                  case 299:
                    return ps(ce, 8, 900095);
                  case 174:
                  case 175:
                  case 176:
                    return nt(ce, 131072, 0);
                  case 169:
                  case 168:
                    return ps(ce, 8192 | (ce.questionToken ? 16777216 : 0), e.isObjectLiteralMethod(ce) ? 0 : 103359);
                  case 256:
                    return hs(ce);
                  case 171:
                    return nt(ce, 16384, 0);
                  case 172:
                    return ps(ce, 32768, 46015);
                  case 173:
                    return ps(ce, 65536, 78783);
                  case 179:
                  case 317:
                  case 323:
                  case 180:
                    return Ki(ce);
                  case 182:
                  case 322:
                  case 195:
                    return Co(ce);
                  case 332:
                    return De(ce);
                  case 205:
                    return Fi(ce);
                  case 213:
                  case 214:
                    return tc(ce);
                  case 208:
                    var pt = e.getAssignmentDeclarationKind(ce);
                    switch (pt) {
                      case 7:
                        return Pi(ce);
                      case 8:
                        return pa(ce);
                      case 9:
                        return Zr(ce);
                      case 0:
                        break;
                      default:
                        return e.Debug.fail("Unknown call expression assignment declaration kind");
                    }
                    e.isInJSFile(ce) && Pc(ce);
                    break;
                  case 226:
                  case 257:
                    return U = true, Vc(ce);
                  case 258:
                    return na(ce, 64, 788872);
                  case 259:
                    return na(ce, 524288, 788968);
                  case 260:
                    return Kc(ce);
                  case 261:
                    return Rt(ce);
                  case 286:
                    return ui(ce);
                  case 285:
                    return Bt(ce, 4, 0);
                  case 265:
                  case 268:
                  case 270:
                  case 275:
                    return nt(ce, 2097152, 2097152);
                  case 264:
                    return $o(ce);
                  case 267:
                    return xi(ce);
                  case 272:
                    return Pr(ce);
                  case 271:
                    return no(ce);
                  case 305:
                    return Ro(ce.statements), Ko();
                  case 235:
                    if (!e.isFunctionLikeOrClassStaticBlockDeclaration(ce.parent)) return;
                  case 262:
                    return Ro(ce.statements);
                  case 340:
                    if (ce.parent.kind === 323) return pc(ce);
                    if (ce.parent.kind !== 322) break;
                  case 347:
                    var Pt = ce, ga = Pt.isBracketed || Pt.typeExpression && Pt.typeExpression.type.kind === 316 ? 16777220 : 4;
                    return nt(Pt, ga, 0);
                  case 345:
                  case 338:
                  case 339:
                    return (ee || (ee = [])).push(ce);
                }
              }
              function to(ce) {
                return ps(ce, 4 | (ce.questionToken ? 16777216 : 0), 0);
              }
              function Co(ce) {
                return wt(ce, 2048, "__type");
              }
              function Ko() {
                if (Dt(b), e.isExternalModule(b)) Oo();
                else if (e.isJsonSourceFile(b)) {
                  Oo();
                  var ce = b.symbol;
                  ge(b.symbol.exports, b.symbol, b, 4, 67108863), b.symbol = ce;
                }
              }
              function Oo() {
                wt(b, 512, '"'.concat(e.removeFileExtension(b.fileName), '"'));
              }
              function no(ce) {
                if (!R.symbol || !R.symbol.exports) wt(ce, 111551, Z(ce));
                else {
                  var Rr = e.exportAssignmentIsAlias(ce) ? 2097152 : 4, yi = ge(R.symbol.exports, R.symbol, ce, Rr, 67108863);
                  ce.isExportEquals && e.setValueDeclaration(yi, ce);
                }
              }
              function $o(ce) {
                ce.modifiers && ce.modifiers.length && b.bindDiagnostics.push(g(ce, e.Diagnostics.Modifiers_cannot_appear_here));
                var Rr = e.isSourceFile(ce.parent) ? e.isExternalModule(ce.parent) ? ce.parent.isDeclarationFile ? void 0 : e.Diagnostics.Global_module_exports_may_only_appear_in_declaration_files : e.Diagnostics.Global_module_exports_may_only_appear_in_module_files : e.Diagnostics.Global_module_exports_may_only_appear_at_top_level;
                Rr ? b.bindDiagnostics.push(g(ce, Rr)) : (b.symbol.globalExports = b.symbol.globalExports || e.createSymbolTable(), ge(b.symbol.globalExports, b.symbol, ce, 2097152, 2097152));
              }
              function Pr(ce) {
                !R.symbol || !R.symbol.exports ? wt(ce, 8388608, Z(ce)) : ce.exportClause ? e.isNamespaceExport(ce.exportClause) && (e.setParent(ce.exportClause, ce), ge(R.symbol.exports, R.symbol, ce.exportClause, 2097152, 2097152)) : ge(R.symbol.exports, R.symbol, ce, 8388608, 0);
              }
              function xi(ce) {
                ce.name && nt(ce, 2097152, 2097152);
              }
              function St(ce) {
                return b.externalModuleIndicator ? false : (b.commonJsModuleIndicator || (b.commonJsModuleIndicator = ce, Oo()), true);
              }
              function pa(ce) {
                if (!!St(ce)) {
                  var Rr = ys(ce.arguments[0], void 0, function(qi, je) {
                    return je && Fe(je, qi, 67110400), je;
                  });
                  if (Rr) {
                    var yi = 1048580;
                    ge(Rr.exports, Rr, ce, yi, 0);
                  }
                }
              }
              function dn(ce) {
                if (!!St(ce)) {
                  var Rr = ys(ce.left.expression, void 0, function(je, Hr) {
                    return Hr && Fe(Hr, je, 67110400), Hr;
                  });
                  if (Rr) {
                    var yi = e.isAliasableExpression(ce.right) && (e.isExportsIdentifier(ce.left.expression) || e.isModuleExportsAccessExpression(ce.left.expression)), qi = yi ? 2097152 : 1048580;
                    e.setParent(ce.left, ce), ge(Rr.exports, Rr, ce.left, qi, 0);
                  }
                }
              }
              function Jn(ce) {
                if (!!St(ce)) {
                  var Rr = e.getRightMostAssignedExpression(ce.right);
                  if (!(e.isEmptyObjectLiteral(Rr) || R === b && T(b, Rr))) {
                    if (e.isObjectLiteralExpression(Rr) && e.every(Rr.properties, e.isShorthandPropertyAssignment)) {
                      e.forEach(Rr.properties, Qe);
                      return;
                    }
                    var yi = e.exportAssignmentIsAlias(ce) ? 2097152 : 1049092, qi = ge(b.symbol.exports, b.symbol, ce, yi | 67108864, 0);
                    e.setValueDeclaration(qi, ce);
                  }
                }
              }
              function Qe(ce) {
                ge(b.symbol.exports, b.symbol, ce, 69206016, 0);
              }
              function Gr(ce) {
                e.Debug.assert(e.isInJSFile(ce));
                var Rr = e.isBinaryExpression(ce) && e.isPropertyAccessExpression(ce.left) && e.isPrivateIdentifier(ce.left.name) || e.isPropertyAccessExpression(ce) && e.isPrivateIdentifier(ce.name);
                if (!Rr) {
                  var yi = e.getThisContainer(ce, false);
                  switch (yi.kind) {
                    case 256:
                    case 213:
                      var qi = yi.symbol;
                      if (e.isBinaryExpression(yi.parent) && yi.parent.operatorToken.kind === 63) {
                        var je = yi.parent.left;
                        e.isBindableStaticAccessExpression(je) && e.isPrototypeAccess(je.expression) && (qi = Go(je.expression.expression, q));
                      }
                      qi && qi.valueDeclaration && (qi.members = qi.members || e.createSymbolTable(), e.hasDynamicName(ce) ? S(ce, qi, qi.members) : ge(qi.members, qi, ce, 67108868, 0), Fe(qi, qi.valueDeclaration, 32));
                      break;
                    case 171:
                    case 167:
                    case 169:
                    case 172:
                    case 173:
                    case 170:
                      var Hr = yi.parent, pt = e.isStatic(yi) ? Hr.symbol.exports : Hr.symbol.members;
                      e.hasDynamicName(ce) ? S(ce, Hr.symbol, pt) : ge(pt, Hr.symbol, ce, 67108868, 0, true);
                      break;
                    case 305:
                      if (e.hasDynamicName(ce)) break;
                      yi.commonJsModuleIndicator ? ge(yi.symbol.exports, yi.symbol, ce, 1048580, 0) : nt(ce, 1, 111550);
                      break;
                    default:
                      e.Debug.failBadSyntaxKind(yi);
                  }
                }
              }
              function S(ce, Rr, yi) {
                ge(yi, Rr, ce, 4, 0, true, true), Ce(ce, Rr);
              }
              function Ce(ce, Rr) {
                Rr && (Rr.assignmentDeclarationMembers || (Rr.assignmentDeclarationMembers = new e.Map())).set(e.getNodeId(ce), ce);
              }
              function qe(ce) {
                ce.expression.kind === 108 ? Gr(ce) : e.isBindableStaticAccessExpression(ce) && ce.parent.parent.kind === 305 && (e.isPrototypeAccess(ce.expression) ? Si(ce, ce.parent) : Ct(ce));
              }
              function br(ce) {
                e.setParent(ce.left, ce), e.setParent(ce.right, ce), qn(ce.left.expression, ce.left, false, true);
              }
              function Zr(ce) {
                var Rr = Go(ce.arguments[0].expression);
                Rr && Rr.valueDeclaration && Fe(Rr, Rr.valueDeclaration, 32), en(ce, Rr, true);
              }
              function Si(ce, Rr) {
                var yi = ce.expression, qi = yi.expression;
                e.setParent(qi, yi), e.setParent(yi, ce), e.setParent(ce, Rr), qn(qi, ce, true, true);
              }
              function Pi(ce) {
                var Rr = Go(ce.arguments[0]), yi = ce.parent.parent.kind === 305;
                Rr = sa(Rr, ce.arguments[0], yi, false, false), en(ce, Rr, false);
              }
              function Qi(ce) {
                var Rr, yi = Go(ce.left.expression, R) || Go(ce.left.expression, O);
                if (!(!e.isInJSFile(ce) && !e.isFunctionSymbol(yi))) {
                  var qi = e.getLeftmostAccessExpression(ce.left);
                  if (!(e.isIdentifier(qi) && ((Rr = K(R, qi.escapedText)) === null || Rr === void 0 ? void 0 : Rr.flags) & 2097152)) if (e.setParent(ce.left, ce), e.setParent(ce.right, ce), e.isIdentifier(ce.left.expression) && R === b && T(b, ce.left.expression)) dn(ce);
                  else if (e.hasDynamicName(ce)) {
                    wt(ce, 67108868, "__computed");
                    var je = sa(yi, ce.left.expression, Wa(ce.left), false, false);
                    Ce(ce, je);
                  } else Ct(e.cast(ce.left, e.isBindableStaticNameExpression));
                }
              }
              function Ct(ce) {
                e.Debug.assert(!e.isIdentifier(ce)), e.setParent(ce.expression, ce), qn(ce.expression, ce, false, false);
              }
              function sa(ce, Rr, yi, qi, je) {
                if ((ce == null ? void 0 : ce.flags) & 2097152) return ce;
                if (yi && !qi) {
                  var Hr = 67110400, pt = 110735;
                  ce = ys(Rr, ce, function(Pt, ga, ua) {
                    if (ga) return Fe(ga, Pt, Hr), ga;
                    var Xn = ua ? ua.exports : b.jsGlobalAugmentations || (b.jsGlobalAugmentations = e.createSymbolTable());
                    return ge(Xn, ua, Pt, Hr, pt);
                  });
                }
                return je && ce && ce.valueDeclaration && Fe(ce, ce.valueDeclaration, 32), ce;
              }
              function en(ce, Rr, yi) {
                if (!(!Rr || !mo(Rr))) {
                  var qi = yi ? Rr.members || (Rr.members = e.createSymbolTable()) : Rr.exports || (Rr.exports = e.createSymbolTable()), je = 0, Hr = 0;
                  e.isFunctionLikeDeclaration(e.getAssignedExpandoInitializer(ce)) ? (je = 8192, Hr = 103359) : e.isCallExpression(ce) && e.isBindableObjectDefinePropertyCall(ce) && (e.some(ce.arguments[2].properties, function(pt) {
                    var Pt = e.getNameOfDeclaration(pt);
                    return !!Pt && e.isIdentifier(Pt) && e.idText(Pt) === "set";
                  }) && (je |= 65540, Hr |= 78783), e.some(ce.arguments[2].properties, function(pt) {
                    var Pt = e.getNameOfDeclaration(pt);
                    return !!Pt && e.isIdentifier(Pt) && e.idText(Pt) === "get";
                  }) && (je |= 32772, Hr |= 46015)), je === 0 && (je = 4, Hr = 0), ge(qi, Rr, ce, je | 67108864, Hr & -67108865);
                }
              }
              function Wa(ce) {
                return e.isBinaryExpression(ce.parent) ? So(ce.parent).parent.kind === 305 : ce.parent.parent.kind === 305;
              }
              function qn(ce, Rr, yi, qi) {
                var je = Go(ce, R) || Go(ce, O), Hr = Wa(Rr);
                je = sa(je, Rr.expression, Hr, yi, qi), en(Rr, je, yi);
              }
              function mo(ce) {
                if (ce.flags & 1072) return true;
                var Rr = ce.valueDeclaration;
                if (Rr && e.isCallExpression(Rr)) return !!e.getAssignedExpandoInitializer(Rr);
                var yi = Rr ? e.isVariableDeclaration(Rr) ? Rr.initializer : e.isBinaryExpression(Rr) ? Rr.right : e.isPropertyAccessExpression(Rr) && e.isBinaryExpression(Rr.parent) ? Rr.parent.right : void 0 : void 0;
                if (yi = yi && e.getRightMostAssignedExpression(yi), yi) {
                  var qi = e.isPrototypeAccess(e.isVariableDeclaration(Rr) ? Rr.name : e.isBinaryExpression(Rr) ? Rr.left : Rr);
                  return !!e.getExpandoInitializer(e.isBinaryExpression(yi) && (yi.operatorToken.kind === 56 || yi.operatorToken.kind === 60) ? yi.right : yi, qi);
                }
                return false;
              }
              function So(ce) {
                for (; e.isBinaryExpression(ce.parent); ) ce = ce.parent;
                return ce.parent;
              }
              function Go(ce, Rr) {
                if (Rr === void 0 && (Rr = R), e.isIdentifier(ce)) return K(Rr, ce.escapedText);
                var yi = Go(ce.expression);
                return yi && yi.exports && yi.exports.get(e.getElementOrPropertyAccessName(ce));
              }
              function ys(ce, Rr, yi) {
                if (T(b, ce)) return b.symbol;
                if (e.isIdentifier(ce)) return yi(ce, Go(ce), Rr);
                var qi = ys(ce.expression, Rr, yi), je = e.getNameOrArgument(ce);
                return e.isPrivateIdentifier(je) && e.Debug.fail("unexpected PrivateIdentifier"), yi(je, qi && qi.exports && qi.exports.get(e.getElementOrPropertyAccessName(ce)), qi);
              }
              function Pc(ce) {
                !b.commonJsModuleIndicator && e.isRequireCall(ce, false) && St(ce);
              }
              function Vc(ce) {
                if (ce.kind === 257) na(ce, 32, 899503);
                else {
                  var Rr = ce.name ? ce.name.escapedText : "__class";
                  wt(ce, 32, Rr), ce.name && l.add(ce.name.escapedText);
                }
                var yi = ce.symbol, qi = We(4194308, "prototype"), je = yi.exports.get(qi.escapedName);
                je && (ce.name && e.setParent(ce.name, ce), b.bindDiagnostics.push(g(je.declarations[0], e.Diagnostics.Duplicate_identifier_0, e.symbolName(qi)))), yi.exports.set(qi.escapedName, qi), qi.parent = yi;
              }
              function Kc(ce) {
                return e.isEnumConst(ce) ? na(ce, 128, 899967) : na(ce, 256, 899327);
              }
              function Xs(ce) {
                U && Qa(ce, ce.name), e.isBindingPattern(ce.name) || (e.isInJSFile(ce) && e.isVariableDeclarationInitializedToBareOrAccessedRequire(ce) && !e.getJSDocTypeTag(ce) && !(e.getCombinedModifierFlags(ce) & 1) ? nt(ce, 2097152, 2097152) : e.isBlockOrCatchScoped(ce) ? na(ce, 2, 111551) : e.isParameterDeclaration(ce) ? nt(ce, 1, 111551) : nt(ce, 1, 111550));
              }
              function pc(ce) {
                if (!(ce.kind === 340 && R.kind !== 323) && (U && !(ce.flags & 16777216) && Qa(ce, ce.name), e.isBindingPattern(ce.name) ? wt(ce, 1, "__" + ce.parent.parameters.indexOf(ce)) : nt(ce, 1, 111551), e.isParameterPropertyDeclaration(ce, ce.parent))) {
                  var Rr = ce.parent.parent;
                  ge(Rr.symbol.members, Rr.symbol, ce, 4 | (ce.questionToken ? 16777216 : 0), 0);
                }
              }
              function hs(ce) {
                !b.isDeclarationFile && !(ce.flags & 16777216) && e.isAsyncFunction(ce) && (Y |= 2048), Dn(ce), U ? (Ba(ce), na(ce, 16, 110991)) : nt(ce, 16, 110991);
              }
              function tc(ce) {
                !b.isDeclarationFile && !(ce.flags & 16777216) && e.isAsyncFunction(ce) && (Y |= 2048), F && (ce.flowNode = F), Dn(ce);
                var Rr = ce.name ? ce.name.escapedText : "__function";
                return wt(ce, 16, Rr);
              }
              function ps(ce, Rr, yi) {
                return !b.isDeclarationFile && !(ce.flags & 16777216) && e.isAsyncFunction(ce) && (Y |= 2048), F && e.isObjectLiteralOrClassExpressionMethodOrAccessor(ce) && (ce.flowNode = F), e.hasDynamicName(ce) ? wt(ce, Rr, "__computed") : nt(ce, Rr, yi);
              }
              function Qs(ce) {
                var Rr = e.findAncestor(ce, function(yi) {
                  return yi.parent && e.isConditionalTypeNode(yi.parent) && yi.parent.extendsType === yi;
                });
                return Rr && Rr.parent;
              }
              function js(ce) {
                if (e.isJSDocTemplateTag(ce.parent)) {
                  var Rr = e.getEffectiveContainerForJSDocTemplateTag(ce.parent);
                  Rr ? (Rr.locals || (Rr.locals = e.createSymbolTable()), ge(Rr.locals, void 0, ce, 262144, 526824)) : nt(ce, 262144, 526824);
                } else if (ce.parent.kind === 190) {
                  var yi = Qs(ce.parent);
                  yi ? (yi.locals || (yi.locals = e.createSymbolTable()), ge(yi.locals, void 0, ce, 262144, 526824)) : wt(ce, 262144, Z(ce));
                } else nt(ce, 262144, 526824);
              }
              function ds(ce) {
                var Rr = C(ce);
                return Rr === 1 || Rr === 2 && e.shouldPreserveConstEnums(se);
              }
              function Ji(ce) {
                if (!(F.flags & 1)) return false;
                if (F === d) {
                  var Rr = e.isStatementButNotDeclaration(ce) && ce.kind !== 236 || ce.kind === 257 || ce.kind === 261 && ds(ce);
                  if (Rr && (F = D, !se.allowUnreachableCode)) {
                    var yi = e.unreachableCodeIsError(se) && !(ce.flags & 16777216) && (!e.isVariableStatement(ce) || !!(e.getCombinedNodeFlags(ce.declarationList) & 3) || ce.declarationList.declarations.some(function(qi) {
                      return !!qi.initializer;
                    }));
                    G(ce, function(qi, je) {
                      return eo(yi, qi, je, e.Diagnostics.Unreachable_code_detected);
                    });
                  }
                }
                return true;
              }
            }
            function G(b, se) {
              if (e.isStatement(b) && oe(b) && e.isBlock(b.parent)) {
                var J = b.parent.statements, ie = e.sliceAfter(J, b);
                e.getRangesWhere(ie, oe, function(R, q) {
                  return se(ie[R], ie[q - 1]);
                });
              } else se(b, b);
            }
            function oe(b) {
              return !e.isFunctionDeclaration(b) && !f(b) && !e.isEnumDeclaration(b) && !(e.isVariableStatement(b) && !(e.getCombinedNodeFlags(b) & 3) && b.declarationList.declarations.some(function(se) {
                return !se.initializer;
              }));
            }
            function f(b) {
              switch (b.kind) {
                case 258:
                case 259:
                  return true;
                case 261:
                  return C(b) !== 1;
                case 260:
                  return e.hasSyntacticModifier(b, 2048);
                default:
                  return false;
              }
            }
            function T(b, se) {
              for (var J = 0, ie = [se]; ie.length && J < 100; ) {
                if (J++, se = ie.shift(), e.isExportsIdentifier(se) || e.isModuleExportsAccessExpression(se)) return true;
                if (e.isIdentifier(se)) {
                  var R = K(b, se.escapedText);
                  if (!!R && !!R.valueDeclaration && e.isVariableDeclaration(R.valueDeclaration) && !!R.valueDeclaration.initializer) {
                    var q = R.valueDeclaration.initializer;
                    ie.push(q), e.isAssignmentExpression(q, true) && (ie.push(q.left), ie.push(q.right));
                  }
                }
              }
              return false;
            }
            e.isExportsOrModuleExportsOrAlias = T;
            function K(b, se) {
              var J = b.locals && b.locals.get(se);
              return J ? J.exportSymbol || J : e.isSourceFile(b) && b.jsGlobalAugmentations && b.jsGlobalAugmentations.has(se) ? b.jsGlobalAugmentations.get(se) : b.symbol && b.symbol.exports && b.symbol.exports.get(se);
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(C, w, B, E, Q, le, N, p, m, G) {
              return oe;
              function oe(f) {
                f === void 0 && (f = function() {
                  return true;
                });
                var T = [], K = [];
                return { walkType: function(x) {
                  try {
                    return b(x), { visitedTypes: e.getOwnValues(T), visitedSymbols: e.getOwnValues(K) };
                  } finally {
                    e.clear(T), e.clear(K);
                  }
                }, walkSymbol: function(x) {
                  try {
                    return F(x), { visitedTypes: e.getOwnValues(T), visitedSymbols: e.getOwnValues(K) };
                  } finally {
                    e.clear(T), e.clear(K);
                  }
                } };
                function b(x) {
                  if (!!x && !T[x.id]) {
                    T[x.id] = x;
                    var X = F(x.symbol);
                    if (!X) {
                      if (x.flags & 524288) {
                        var $ = x, A = $.objectFlags;
                        A & 4 && se(x), A & 32 && O(x), A & 3 && ee(x), A & 24 && he($);
                      }
                      x.flags & 262144 && J(x), x.flags & 3145728 && ie(x), x.flags & 4194304 && R(x), x.flags & 8388608 && q(x);
                    }
                  }
                }
                function se(x) {
                  b(x.target), e.forEach(G(x), b);
                }
                function J(x) {
                  b(p(x));
                }
                function ie(x) {
                  e.forEach(x.types, b);
                }
                function R(x) {
                  b(x.type);
                }
                function q(x) {
                  b(x.objectType), b(x.indexType), b(x.constraint);
                }
                function O(x) {
                  b(x.typeParameter), b(x.constraintType), b(x.templateType), b(x.modifiersType);
                }
                function ve(x) {
                  var X = w(x);
                  X && b(X.type), e.forEach(x.typeParameters, b);
                  for (var $ = 0, A = x.parameters; $ < A.length; $++) {
                    var y = A[$];
                    F(y);
                  }
                  b(C(x)), b(B(x));
                }
                function ee(x) {
                  he(x), e.forEach(x.typeParameters, b), e.forEach(E(x), b), b(x.thisType);
                }
                function he(x) {
                  for (var X = Q(x), $ = 0, A = X.indexInfos; $ < A.length; $++) {
                    var y = A[$];
                    b(y.keyType), b(y.type);
                  }
                  for (var V = 0, L = X.callSignatures; V < L.length; V++) {
                    var P = L[V];
                    ve(P);
                  }
                  for (var k = 0, Y = X.constructSignatures; k < Y.length; k++) {
                    var P = Y[k];
                    ve(P);
                  }
                  for (var U = 0, j = X.properties; U < j.length; U++) {
                    var H = j[U];
                    F(H);
                  }
                }
                function F(x) {
                  if (!x) return false;
                  var X = e.getSymbolId(x);
                  if (K[X]) return false;
                  if (K[X] = x, !f(x)) return true;
                  var $ = le(x);
                  return b($), x.exports && x.exports.forEach(F), e.forEach(x.declarations, function(A) {
                    if (A.type && A.type.kind === 181) {
                      var y = A.type, V = N(m(y.exprName));
                      F(V);
                    }
                  }), false;
                }
              }
            }
            e.createGetSymbolWalker = a;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a = /^".+"$/, C = "(anonymous)", w = 1, B = 1, E = 1, Q = 1, le;
            (function(l) {
              l[l.AllowsSyncIterablesFlag = 1] = "AllowsSyncIterablesFlag", l[l.AllowsAsyncIterablesFlag = 2] = "AllowsAsyncIterablesFlag", l[l.AllowsStringInputFlag = 4] = "AllowsStringInputFlag", l[l.ForOfFlag = 8] = "ForOfFlag", l[l.YieldStarFlag = 16] = "YieldStarFlag", l[l.SpreadFlag = 32] = "SpreadFlag", l[l.DestructuringFlag = 64] = "DestructuringFlag", l[l.PossiblyOutOfBounds = 128] = "PossiblyOutOfBounds", l[l.Element = 1] = "Element", l[l.Spread = 33] = "Spread", l[l.Destructuring = 65] = "Destructuring", l[l.ForOf = 13] = "ForOf", l[l.ForAwaitOf = 15] = "ForAwaitOf", l[l.YieldStar = 17] = "YieldStar", l[l.AsyncYieldStar = 19] = "AsyncYieldStar", l[l.GeneratorReturnType = 1] = "GeneratorReturnType", l[l.AsyncGeneratorReturnType = 2] = "AsyncGeneratorReturnType";
            })(le || (le = {}));
            var N;
            (function(l) {
              l[l.Yield = 0] = "Yield", l[l.Return = 1] = "Return", l[l.Next = 2] = "Next";
            })(N || (N = {}));
            var p;
            (function(l) {
              l[l.Normal = 0] = "Normal", l[l.FunctionReturn = 1] = "FunctionReturn", l[l.GeneratorNext = 2] = "GeneratorNext", l[l.GeneratorYield = 3] = "GeneratorYield";
            })(p || (p = {}));
            var m;
            (function(l) {
              l[l.None = 0] = "None", l[l.TypeofEQString = 1] = "TypeofEQString", l[l.TypeofEQNumber = 2] = "TypeofEQNumber", l[l.TypeofEQBigInt = 4] = "TypeofEQBigInt", l[l.TypeofEQBoolean = 8] = "TypeofEQBoolean", l[l.TypeofEQSymbol = 16] = "TypeofEQSymbol", l[l.TypeofEQObject = 32] = "TypeofEQObject", l[l.TypeofEQFunction = 64] = "TypeofEQFunction", l[l.TypeofEQHostObject = 128] = "TypeofEQHostObject", l[l.TypeofNEString = 256] = "TypeofNEString", l[l.TypeofNENumber = 512] = "TypeofNENumber", l[l.TypeofNEBigInt = 1024] = "TypeofNEBigInt", l[l.TypeofNEBoolean = 2048] = "TypeofNEBoolean", l[l.TypeofNESymbol = 4096] = "TypeofNESymbol", l[l.TypeofNEObject = 8192] = "TypeofNEObject", l[l.TypeofNEFunction = 16384] = "TypeofNEFunction", l[l.TypeofNEHostObject = 32768] = "TypeofNEHostObject", l[l.EQUndefined = 65536] = "EQUndefined", l[l.EQNull = 131072] = "EQNull", l[l.EQUndefinedOrNull = 262144] = "EQUndefinedOrNull", l[l.NEUndefined = 524288] = "NEUndefined", l[l.NENull = 1048576] = "NENull", l[l.NEUndefinedOrNull = 2097152] = "NEUndefinedOrNull", l[l.Truthy = 4194304] = "Truthy", l[l.Falsy = 8388608] = "Falsy", l[l.All = 16777215] = "All", l[l.BaseStringStrictFacts = 3735041] = "BaseStringStrictFacts", l[l.BaseStringFacts = 12582401] = "BaseStringFacts", l[l.StringStrictFacts = 16317953] = "StringStrictFacts", l[l.StringFacts = 16776705] = "StringFacts", l[l.EmptyStringStrictFacts = 12123649] = "EmptyStringStrictFacts", l[l.EmptyStringFacts = 12582401] = "EmptyStringFacts", l[l.NonEmptyStringStrictFacts = 7929345] = "NonEmptyStringStrictFacts", l[l.NonEmptyStringFacts = 16776705] = "NonEmptyStringFacts", l[l.BaseNumberStrictFacts = 3734786] = "BaseNumberStrictFacts", l[l.BaseNumberFacts = 12582146] = "BaseNumberFacts", l[l.NumberStrictFacts = 16317698] = "NumberStrictFacts", l[l.NumberFacts = 16776450] = "NumberFacts", l[l.ZeroNumberStrictFacts = 12123394] = "ZeroNumberStrictFacts", l[l.ZeroNumberFacts = 12582146] = "ZeroNumberFacts", l[l.NonZeroNumberStrictFacts = 7929090] = "NonZeroNumberStrictFacts", l[l.NonZeroNumberFacts = 16776450] = "NonZeroNumberFacts", l[l.BaseBigIntStrictFacts = 3734276] = "BaseBigIntStrictFacts", l[l.BaseBigIntFacts = 12581636] = "BaseBigIntFacts", l[l.BigIntStrictFacts = 16317188] = "BigIntStrictFacts", l[l.BigIntFacts = 16775940] = "BigIntFacts", l[l.ZeroBigIntStrictFacts = 12122884] = "ZeroBigIntStrictFacts", l[l.ZeroBigIntFacts = 12581636] = "ZeroBigIntFacts", l[l.NonZeroBigIntStrictFacts = 7928580] = "NonZeroBigIntStrictFacts", l[l.NonZeroBigIntFacts = 16775940] = "NonZeroBigIntFacts", l[l.BaseBooleanStrictFacts = 3733256] = "BaseBooleanStrictFacts", l[l.BaseBooleanFacts = 12580616] = "BaseBooleanFacts", l[l.BooleanStrictFacts = 16316168] = "BooleanStrictFacts", l[l.BooleanFacts = 16774920] = "BooleanFacts", l[l.FalseStrictFacts = 12121864] = "FalseStrictFacts", l[l.FalseFacts = 12580616] = "FalseFacts", l[l.TrueStrictFacts = 7927560] = "TrueStrictFacts", l[l.TrueFacts = 16774920] = "TrueFacts", l[l.SymbolStrictFacts = 7925520] = "SymbolStrictFacts", l[l.SymbolFacts = 16772880] = "SymbolFacts", l[l.ObjectStrictFacts = 7888800] = "ObjectStrictFacts", l[l.ObjectFacts = 16736160] = "ObjectFacts", l[l.FunctionStrictFacts = 7880640] = "FunctionStrictFacts", l[l.FunctionFacts = 16728e3] = "FunctionFacts", l[l.UndefinedFacts = 9830144] = "UndefinedFacts", l[l.NullFacts = 9363232] = "NullFacts", l[l.EmptyObjectStrictFacts = 16318463] = "EmptyObjectStrictFacts", l[l.AllTypeofNE = 556800] = "AllTypeofNE", l[l.EmptyObjectFacts = 16777215] = "EmptyObjectFacts", l[l.OrFactsMask = 8256] = "OrFactsMask", l[l.AndFactsMask = 16768959] = "AndFactsMask";
            })(m || (m = {}));
            var G = new e.Map(e.getEntries({ string: 1, number: 2, bigint: 4, boolean: 8, symbol: 16, undefined: 65536, object: 32, function: 64 })), oe = new e.Map(e.getEntries({ string: 256, number: 512, bigint: 1024, boolean: 2048, symbol: 4096, undefined: 524288, object: 8192, function: 16384 })), f;
            (function(l) {
              l[l.Type = 0] = "Type", l[l.ResolvedBaseConstructorType = 1] = "ResolvedBaseConstructorType", l[l.DeclaredType = 2] = "DeclaredType", l[l.ResolvedReturnType = 3] = "ResolvedReturnType", l[l.ImmediateBaseConstraint = 4] = "ImmediateBaseConstraint", l[l.EnumTagType = 5] = "EnumTagType", l[l.ResolvedTypeArguments = 6] = "ResolvedTypeArguments", l[l.ResolvedBaseTypes = 7] = "ResolvedBaseTypes", l[l.WriteType = 8] = "WriteType";
            })(f || (f = {}));
            var T;
            (function(l) {
              l[l.Normal = 0] = "Normal", l[l.Contextual = 1] = "Contextual", l[l.Inferential = 2] = "Inferential", l[l.SkipContextSensitive = 4] = "SkipContextSensitive", l[l.SkipGenericFunctions = 8] = "SkipGenericFunctions", l[l.IsForSignatureHelp = 16] = "IsForSignatureHelp", l[l.IsForStringLiteralArgumentCompletions = 32] = "IsForStringLiteralArgumentCompletions", l[l.RestBindingElement = 64] = "RestBindingElement";
            })(T || (T = {}));
            var K;
            (function(l) {
              l[l.BivariantCallback = 1] = "BivariantCallback", l[l.StrictCallback = 2] = "StrictCallback", l[l.IgnoreReturnTypes = 4] = "IgnoreReturnTypes", l[l.StrictArity = 8] = "StrictArity", l[l.Callback = 3] = "Callback";
            })(K || (K = {}));
            var b;
            (function(l) {
              l[l.None = 0] = "None", l[l.Source = 1] = "Source", l[l.Target = 2] = "Target", l[l.PropertyCheck = 4] = "PropertyCheck", l[l.InPropertyCheck = 8] = "InPropertyCheck";
            })(b || (b = {}));
            var se;
            (function(l) {
              l[l.None = 0] = "None", l[l.Source = 1] = "Source", l[l.Target = 2] = "Target", l[l.Both = 3] = "Both";
            })(se || (se = {}));
            var J;
            (function(l) {
              l[l.IncludeReadonly = 1] = "IncludeReadonly", l[l.ExcludeReadonly = 2] = "ExcludeReadonly", l[l.IncludeOptional = 4] = "IncludeOptional", l[l.ExcludeOptional = 8] = "ExcludeOptional";
            })(J || (J = {}));
            var ie;
            (function(l) {
              l[l.None = 0] = "None", l[l.Source = 1] = "Source", l[l.Target = 2] = "Target", l[l.Both = 3] = "Both";
            })(ie || (ie = {}));
            var R;
            (function(l) {
              l.resolvedExports = "resolvedExports", l.resolvedMembers = "resolvedMembers";
            })(R || (R = {}));
            var q;
            (function(l) {
              l[l.Local = 0] = "Local", l[l.Parameter = 1] = "Parameter";
            })(q || (q = {}));
            var O = e.and(k, P), ve;
            (function(l) {
              l[l.GetAccessor = 1] = "GetAccessor", l[l.SetAccessor = 2] = "SetAccessor", l[l.PropertyAssignment = 4] = "PropertyAssignment", l[l.Method = 8] = "Method", l[l.PrivateStatic = 16] = "PrivateStatic", l[l.GetOrSetAccessor = 3] = "GetOrSetAccessor", l[l.PropertyAssignmentOrMethod = 12] = "PropertyAssignmentOrMethod";
            })(ve || (ve = {}));
            var ee;
            (function(l) {
              l[l.None = 0] = "None", l[l.ExportValue = 1] = "ExportValue", l[l.ExportType = 2] = "ExportType", l[l.ExportNamespace = 4] = "ExportNamespace";
            })(ee || (ee = {}));
            var he;
            (function(l) {
              l[l.None = 0] = "None", l[l.StrongArityForUntypedJS = 1] = "StrongArityForUntypedJS", l[l.VoidIsNonOptional = 2] = "VoidIsNonOptional";
            })(he || (he = {}));
            var F;
            (function(l) {
              l[l.Uppercase = 0] = "Uppercase", l[l.Lowercase = 1] = "Lowercase", l[l.Capitalize = 2] = "Capitalize", l[l.Uncapitalize = 3] = "Uncapitalize";
            })(F || (F = {}));
            var x = new e.Map(e.getEntries({ Uppercase: 0, Lowercase: 1, Capitalize: 2, Uncapitalize: 3 }));
            function X() {
            }
            function $() {
              this.flags = 0;
            }
            function A(l) {
              return l.id || (l.id = B, B++), l.id;
            }
            e.getNodeId = A;
            function y(l) {
              return l.id || (l.id = w, w++), l.id;
            }
            e.getSymbolId = y;
            function V(l, d) {
              var D = e.getModuleInstanceState(l);
              return D === 1 || d && D === 2;
            }
            e.isInstantiatedModule = V;
            function L(l) {
              var d = e.memoize(function() {
                var r = new e.Map();
                return l.getSourceFiles().forEach(function(i) {
                  !i.resolvedModules || i.resolvedModules.forEach(function(t) {
                    t && t.packageId && r.set(t.packageId.name, t.extension === ".d.ts" || !!r.get(t.packageId.name));
                  });
                }), r;
              }), D = [], fe = function(r) {
                D.push(r);
              }, g, ne, ue, We = e.objectAllocator.getSymbolConstructor(), Fe = e.objectAllocator.getTypeConstructor(), Z = e.objectAllocator.getSignatureConstructor(), Be = 0, ge = 0, Re = 0, ze = 0, Ee = 0, He = 0, rr = 0, Ie, _e, we = e.createSymbolTable(), de = [1], ye = l.getCompilerOptions(), Ae = e.getEmitScriptTarget(ye), er = e.getEmitModuleKind(ye), ir = e.getUseDefineForClassFields(ye), Cr = e.getAllowSyntheticDefaultImports(ye), Ye = e.getStrictOptionValue(ye, "strictNullChecks"), Br = e.getStrictOptionValue(ye, "strictFunctionTypes"), Er = e.getStrictOptionValue(ye, "strictBindCallApply"), Ne = e.getStrictOptionValue(ye, "strictPropertyInitialization"), n = e.getStrictOptionValue(ye, "noImplicitAny"), lr = e.getStrictOptionValue(ye, "noImplicitThis"), be = e.getStrictOptionValue(ye, "useUnknownInCatchVariables"), Ge = !!ye.keyofStringsOnly, ur = ye.suppressExcessPropertyErrors ? 0 : 8192, yr = ye.exactOptionalPropertyTypes, Ir = dO(), wr = M9(), Ur = m_(), ii = e.createSymbolTable(), mi = oo(4, "undefined");
              mi.declarations = [];
              var pe = oo(1536, "globalThis", 8);
              pe.exports = ii, pe.declarations = [], ii.set(pe.escapedName, pe);
              var or = oo(4, "arguments"), qr = oo(4, "require"), si, Di = { getNodeCount: function() {
                return e.sum(l.getSourceFiles(), "nodeCount");
              }, getIdentifierCount: function() {
                return e.sum(l.getSourceFiles(), "identifierCount");
              }, getSymbolCount: function() {
                return e.sum(l.getSourceFiles(), "symbolCount") + ge;
              }, getTypeCount: function() {
                return Be;
              }, getInstantiationCount: function() {
                return ze;
              }, getRelationCacheSizes: function() {
                return { assignable: dt.size, identity: wa.size, subtype: Or.size, strictSubtype: ki.size };
              }, isUndefinedSymbol: function(r) {
                return r === mi;
              }, isArgumentsSymbol: function(r) {
                return r === or;
              }, isUnknownSymbol: function(r) {
                return r === xe;
              }, getMergedSymbol: so, getDiagnostics: X6, getGlobalDiagnostics: $M, getRecursionIdentity: ov, getUnmatchedProperties: sb, getTypeOfSymbolAtLocation: function(r, i) {
                var t = e.getParseTreeNode(i);
                return t ? N8(r, t) : Pe;
              }, getTypeOfSymbol: Jt, getSymbolsOfParameterPropertyDeclaration: function(r, i) {
                var t = e.getParseTreeNode(r, e.isParameter);
                return t === void 0 ? e.Debug.fail("Cannot get symbols of a synthetic parameter that cannot be resolved to a parse-tree node.") : cd(t, e.escapeLeadingUnderscores(i));
              }, getDeclaredTypeOfSymbol: go, getPropertiesOfType: uo, getPropertyOfType: function(r, i) {
                return bi(r, e.escapeLeadingUnderscores(i));
              }, getPrivateIdentifierPropertyOfType: function(r, i, t) {
                var o = e.getParseTreeNode(t);
                if (!!o) {
                  var s = e.escapeLeadingUnderscores(i), u = g0(s, o);
                  return u ? Ub(r, u) : void 0;
                }
              }, getTypeOfPropertyOfType: function(r, i) {
                return da(r, e.escapeLeadingUnderscores(i));
              }, getIndexInfoOfType: function(r, i) {
                return ss(r, i === 0 ? Li : nt);
              }, getIndexInfosOfType: Hn, getSignaturesOfType: ot, getIndexTypeOfType: function(r, i) {
                return cs(r, i === 0 ? Li : nt);
              }, getIndexType: function(r) {
                return ql(r);
              }, getBaseTypes: Qc, getBaseTypeOfLiteralType: Kl, getWidenedType: $c, getTypeFromTypeNode: function(r) {
                var i = e.getParseTreeNode(r, e.isTypeNode);
                return i ? Va(i) : Pe;
              }, getParameterType: $u, getParameterIdentifierNameAtPosition: q7, getPromisedTypeOfPromise: Tv, getAwaitedType: function(r) {
                return ag(r);
              }, getReturnTypeOfSignature: yo, isNullableType: d0, getNullableType: Uh, getNonNullableType: C_, getNonOptionalType: YD, getTypeArguments: xo, typeToTypeNode: Ur.typeToTypeNode, indexInfoToIndexSignatureDeclaration: Ur.indexInfoToIndexSignatureDeclaration, signatureToSignatureDeclaration: Ur.signatureToSignatureDeclaration, symbolToEntityName: Ur.symbolToEntityName, symbolToExpression: Ur.symbolToExpression, symbolToTypeParameterDeclarations: Ur.symbolToTypeParameterDeclarations, symbolToParameterDeclaration: Ur.symbolToParameterDeclaration, typeParameterToDeclaration: Ur.typeParameterToDeclaration, getSymbolsInScope: function(r, i) {
                var t = e.getParseTreeNode(r);
                return t ? ZM(t, i) : [];
              }, getSymbolAtLocation: function(r) {
                var i = e.getParseTreeNode(r);
                return i ? el(i, true) : void 0;
              }, getIndexInfosAtLocation: function(r) {
                var i = e.getParseTreeNode(r);
                return i ? o9(i) : void 0;
              }, getShorthandAssignmentValueSymbol: function(r) {
                var i = e.getParseTreeNode(r);
                return i ? s9(i) : void 0;
              }, getExportSpecifierLocalTargetSymbol: function(r) {
                var i = e.getParseTreeNode(r, e.isExportSpecifier);
                return i ? c9(i) : void 0;
              }, getExportSymbolOfSymbol: function(r) {
                return so(r.exportSymbol || r);
              }, getTypeAtLocation: function(r) {
                var i = e.getParseTreeNode(r);
                return i ? Bd(i) : Pe;
              }, getTypeOfAssignmentPattern: function(r) {
                var i = e.getParseTreeNode(r, e.isAssignmentPattern);
                return i && V0(i) || Pe;
              }, getPropertySymbolOfDestructuringAssignment: function(r) {
                var i = e.getParseTreeNode(r, e.isIdentifier);
                return i ? u9(i) : void 0;
              }, signatureToString: function(r, i, t, o) {
                return Ml(r, e.getParseTreeNode(i), t, o);
              }, typeToString: function(r, i, t) {
                return Ot(r, e.getParseTreeNode(i), t);
              }, symbolToString: function(r, i, t, o) {
                return tn(r, e.getParseTreeNode(i), t, o);
              }, typePredicateToString: function(r, i, t) {
                return Ll(r, e.getParseTreeNode(i), t);
              }, writeSignature: function(r, i, t, o, s) {
                return Ml(r, e.getParseTreeNode(i), t, o, s);
              }, writeType: function(r, i, t, o) {
                return Ot(r, e.getParseTreeNode(i), t, o);
              }, writeSymbol: function(r, i, t, o, s) {
                return tn(r, e.getParseTreeNode(i), t, o, s);
              }, writeTypePredicate: function(r, i, t, o) {
                return Ll(r, e.getParseTreeNode(i), t, o);
              }, getAugmentedPropertiesOfType: LS, getRootSymbols: eA, getSymbolOfExpando: T0, getContextualType: function(r, i) {
                var t = e.getParseTreeNode(r, e.isExpression);
                if (!!t) return i & 4 ? wi(t, function() {
                  return ou(t, i);
                }) : ou(t, i);
              }, getContextualTypeForObjectLiteralElement: function(r) {
                var i = e.getParseTreeNode(r, e.isObjectLiteralElementLike);
                return i ? kb(i) : void 0;
              }, getContextualTypeForArgumentAtIndex: function(r, i) {
                var t = e.getParseTreeNode(r, e.isCallLikeExpression);
                return t && Cb(t, i);
              }, getContextualTypeForJsxAttribute: function(r) {
                var i = e.getParseTreeNode(r, e.isJsxAttributeLike);
                return i && AC(i);
              }, isContextSensitive: Ju, getTypeOfPropertyOfContextualType: Md, getFullyQualifiedName: cl, getResolvedSignature: function(r, i, t) {
                return Xi(r, i, t, 0);
              }, getResolvedSignatureForStringLiteralCompletions: function(r, i, t) {
                return Xi(r, t, void 0, 32, i);
              }, getResolvedSignatureForSignatureHelp: function(r, i, t) {
                return Xi(r, i, t, 16);
              }, getExpandedParameters: Jm, hasEffectiveRestParameter: Xl, containsArgumentsReference: Gm, getConstantValue: function(r) {
                var i = e.getParseTreeNode(r, nA);
                return i ? BS(i) : void 0;
              }, isValidPropertyAccess: function(r, i) {
                var t = e.getParseTreeNode(r, e.isPropertyAccessOrQualifiedNameOrImportTypeNode);
                return !!t && a7(t, e.escapeLeadingUnderscores(i));
              }, isValidPropertyAccessForCompletions: function(r, i, t) {
                var o = e.getParseTreeNode(r, e.isPropertyAccessExpression);
                return !!o && ik(o, i, t);
              }, getSignatureFromDeclaration: function(r) {
                var i = e.getParseTreeNode(r, e.isFunctionLike);
                return i ? yl(i) : void 0;
              }, isImplementationOfOverload: function(r) {
                var i = e.getParseTreeNode(r, e.isFunctionLike);
                return i ? tA(i) : void 0;
              }, getImmediateAliasedSymbol: wb, getAliasedSymbol: Ps, getEmitResolver: Ho, getExportsOfModule: J_, getExportsAndPropertiesOfModule: j_, forEachExportAndPropertyOfModule: U_, getSymbolWalker: e.createGetSymbolWalker(_3, Yc, yo, Qc, Ru, Jt, Dl, Tc, e.getFirstIdentifier, xo), getAmbientModules: xL, getJsxIntrinsicTagNamesAt: R5, isOptionalParameter: function(r) {
                var i = e.getParseTreeNode(r, e.isParameter);
                return i ? kd(i) : false;
              }, tryGetMemberInModuleExports: function(r, i) {
                return iu(e.escapeLeadingUnderscores(r), i);
              }, tryGetMemberInModuleExportsAndProperties: function(r, i) {
                return vd(e.escapeLeadingUnderscores(r), i);
              }, tryFindAmbientModule: function(r) {
                return b_(r, true);
              }, tryFindAmbientModuleWithoutAugmentations: function(r) {
                return b_(r, false);
              }, getApparentType: $s, getUnionType: Pa, isTypeAssignableTo: ao, createAnonymousType: rs, createSignature: Fu, createSymbol: oo, createIndexInfo: zl, getAnyType: function() {
                return Oe;
              }, getStringType: function() {
                return Li;
              }, getNumberType: function() {
                return nt;
              }, createPromiseType: Ny, createArrayType: Zs, getElementTypeOfArrayType: KD, getBooleanType: function() {
                return Ii;
              }, getFalseType: function(r) {
                return r ? xt : ut;
              }, getTrueType: function(r) {
                return r ? Dt : Rt;
              }, getVoidType: function() {
                return Fi;
              }, getUndefinedType: function() {
                return Tr;
              }, getNullType: function() {
                return Wi;
              }, getESSymbolType: function() {
                return Ki;
              }, getNeverType: function() {
                return ui;
              }, getOptionalType: function() {
                return Ui;
              }, getPromiseType: function() {
                return ay(false);
              }, getPromiseLikeType: function() {
                return kx(false);
              }, isSymbolAccessible: g_, isArrayType: Tu, isTupleType: Yn, isArrayLikeType: sp, isTypeInvalidDueToUnionDiscriminant: z1, getExactOptionalProperties: lw, getAllPossiblePropertiesOfTypes: W1, getSuggestedSymbolForNonexistentProperty: qb, getSuggestionForNonexistentProperty: Vb, getSuggestedSymbolForNonexistentJSXAttribute: ek, getSuggestedSymbolForNonexistentSymbol: function(r, i, t) {
                return Kb(r, e.escapeLeadingUnderscores(i), t);
              }, getSuggestionForNonexistentSymbol: function(r, i, t) {
                return e7(r, e.escapeLeadingUnderscores(i), t);
              }, getSuggestedSymbolForNonexistentModule: v0, getSuggestionForNonexistentExport: r7, getSuggestedSymbolForNonexistentClassMember: ZC, getBaseConstraintOfType: uc, getDefaultFromTypeParameter: function(r) {
                return r && r.flags & 262144 ? D_(r) : void 0;
              }, resolveName: function(r, i, t, o) {
                return es(i, e.escapeLeadingUnderscores(r), t, void 0, void 0, false, o);
              }, getJsxNamespace: function(r) {
                return e.unescapeLeadingUnderscores(po(r));
              }, getJsxFragmentFactory: function(r) {
                var i = jS(r);
                return i && e.unescapeLeadingUnderscores(e.getFirstIdentifier(i).escapedText);
              }, getAccessibleSymbolChain: pl, getTypePredicateOfSignature: Yc, resolveExternalModuleName: function(r) {
                var i = e.getParseTreeNode(r, e.isExpression);
                return i && ac(i, i, true);
              }, resolveExternalModuleSymbol: Us, tryGetThisTypeAt: function(r, i) {
                var t = e.getParseTreeNode(r);
                return t && bb(t, i);
              }, getTypeArgumentConstraint: function(r) {
                var i = e.getParseTreeNode(r, e.isTypeNode);
                return i && WO(i);
              }, getSuggestionDiagnostics: function(r, i) {
                var t = e.getParseTreeNode(r, e.isSourceFile) || e.Debug.fail("Could not determine parsed source file.");
                if (e.skipTypeChecking(t, ye, l)) return e.emptyArray;
                var o;
                try {
                  return g = i, FS(t), e.Debug.assert(!!(va(t).flags & 1)), o = e.addRange(o, jn.getDiagnostics(t.fileName)), _6(H6(t), function(s, u, h) {
                    !e.containsParseError(s) && !G6(u, !!(s.flags & 16777216)) && (o || (o = [])).push(Ke(Ke({}, h), { category: e.DiagnosticCategory.Suggestion }));
                  }), o || e.emptyArray;
                } finally {
                  g = void 0;
                }
              }, runWithCancellationToken: function(r, i) {
                try {
                  return g = r, i(Di);
                } finally {
                  g = void 0;
                }
              }, getLocalTypeParametersOfClassOrInterfaceOrTypeAlias: Af, isDeclarationVisible: wu, isPropertyAccessible: Hb, getTypeOnlyAliasDeclaration: vu, getMemberOverrideModifierStatus: dM };
              function wi(r, i) {
                var t = e.findAncestor(r, e.isCallLikeExpression), o = t && va(t).resolvedSignature;
                if (t) {
                  var s = r;
                  do
                    va(s).skipDirectInference = true, s = s.parent;
                  while (s && s !== t);
                  va(t).resolvedSignature = void 0;
                }
                var u = i();
                if (t) {
                  var s = r;
                  do
                    va(s).skipDirectInference = void 0, s = s.parent;
                  while (s && s !== t);
                  va(t).resolvedSignature = o;
                }
                return u;
              }
              function Xi(r, i, t, o, s) {
                var u = e.getParseTreeNode(r, e.isCallLikeExpression);
                si = t;
                var h = u ? s ? wi(s, function() {
                  return Mg(u, i, o);
                }) : Mg(u, i, o) : void 0;
                return si = void 0, h;
              }
              var et = new e.Map(), Gi = new e.Map(), Wt = new e.Map(), Zt = new e.Map(), _r = new e.Map(), pi = new e.Map(), ae = new e.Map(), Xe = new e.Map(), Jr = new e.Map(), ti = new e.Map(), Ze = new e.Map(), Sr = new e.Map(), zr = [], Wr = new e.Map(), Je = new e.Set(), xe = oo(4, "unknown"), vr = oo(0, "__resolving__"), mr = new e.Map(), Ar = new e.Map(), Oe = ms(1, "any"), nr = ms(1, "any"), Mr = ms(1, "any"), Pe = ms(1, "error"), Ue = ms(1, "unresolved"), fr = ms(1, "any", 65536), De = ms(1, "intrinsic"), gr = ms(2, "unknown"), Vr = ms(2, "unknown"), Tr = ms(32768, "undefined"), vi = Ye ? Tr : ms(32768, "undefined", 65536), Ui = ms(32768, "undefined"), Yi = yr ? ms(32768, "undefined") : Tr, Wi = ms(65536, "null"), ct = Ye ? Wi : ms(65536, "null", 65536), Li = ms(4, "string"), nt = ms(8, "number"), Mt = ms(64, "bigint"), xt = ms(512, "false"), ut = ms(512, "false"), Dt = ms(512, "true"), Rt = ms(512, "true");
              Dt.regularType = Rt, Dt.freshType = Dt, Rt.regularType = Rt, Rt.freshType = Dt, xt.regularType = ut, xt.freshType = xt, ut.regularType = ut, ut.freshType = xt;
              var Ii = Pa([ut, Rt]), Ki = ms(4096, "symbol"), Fi = ms(16384, "void"), ui = ms(131072, "never"), Bt = ms(131072, "never"), wt = ms(131072, "never", 262144), na = ms(131072, "never"), Ai = ms(131072, "never"), Oi = ms(67108864, "object"), ji = Pa([Li, nt]), Vi = Pa([Li, nt, Ki]), at = Ge ? Li : Vi, At = Pa([nt, Mt]), ba = Pa([Li, nt, Ii, Mt, Wi, Tr]), $a = Dg(["", ""], [nt]), Qa = Gp(function(r) {
                return r.flags & 262144 ? RI(r) : r;
              }), ai = Gp(function(r) {
                return r.flags & 262144 ? Mr : r;
              }), Dn = ms(131072, "never"), ka = Gp(function(r) {
                return r.flags & 262144 ? Dn : r;
              }), Ba = rs(void 0, we, e.emptyArray, e.emptyArray, e.emptyArray), pn = rs(void 0, we, e.emptyArray, e.emptyArray, e.emptyArray);
              pn.objectFlags |= 2048;
              var Cn = oo(2048, "__type");
              Cn.members = e.createSymbolTable();
              var Bi = rs(Cn, we, e.emptyArray, e.emptyArray, e.emptyArray), kn = rs(void 0, we, e.emptyArray, e.emptyArray, e.emptyArray);
              kn.instantiations = new e.Map();
              var xn = rs(void 0, we, e.emptyArray, e.emptyArray, e.emptyArray);
              xn.objectFlags |= 262144;
              var Kn = rs(void 0, we, e.emptyArray, e.emptyArray, e.emptyArray), Pn = rs(void 0, we, e.emptyArray, e.emptyArray, e.emptyArray), eo = rs(void 0, we, e.emptyArray, e.emptyArray, e.emptyArray), Rn = Hc(), Da = Hc();
              Da.constraint = Rn;
              var bo = Hc(), Ro = vg(1, "<<unresolved>>", 0, Oe), En = Fu(void 0, void 0, void 0, e.emptyArray, Oe, void 0, 0, 0), Wn = Fu(void 0, void 0, void 0, e.emptyArray, Pe, void 0, 0, 0), to = Fu(void 0, void 0, void 0, e.emptyArray, Oe, void 0, 0, 0), Co = Fu(void 0, void 0, void 0, e.emptyArray, Bt, void 0, 0, 0), Ko = zl(nt, Li, true), Oo = new e.Map(), no = { get yieldType() {
                return e.Debug.fail("Not supported");
              }, get returnType() {
                return e.Debug.fail("Not supported");
              }, get nextType() {
                return e.Debug.fail("Not supported");
              } }, $o = a_(Oe, Oe, Oe), Pr = a_(Oe, Oe, gr), xi = a_(ui, Oe, Tr), St = { iterableCacheKey: "iterationTypesOfAsyncIterable", iteratorCacheKey: "iterationTypesOfAsyncIterator", iteratorSymbolName: "asyncIterator", getGlobalIteratorType: k3, getGlobalIterableType: C3, getGlobalIterableIteratorType: A3, getGlobalGeneratorType: N3, resolveIterationType: ag, mustHaveANextMethodDiagnostic: e.Diagnostics.An_async_iterator_must_have_a_next_method, mustBeAMethodDiagnostic: e.Diagnostics.The_0_property_of_an_async_iterator_must_be_a_method, mustHaveAValueDiagnostic: e.Diagnostics.The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property }, pa = { iterableCacheKey: "iterationTypesOfIterable", iteratorCacheKey: "iterationTypesOfIterator", iteratorSymbolName: "iterator", getGlobalIteratorType: P3, getGlobalIterableType: Ax, getGlobalIterableIteratorType: I3, getGlobalGeneratorType: w3, resolveIterationType: function(r, i) {
                return r;
              }, mustHaveANextMethodDiagnostic: e.Diagnostics.An_iterator_must_have_a_next_method, mustBeAMethodDiagnostic: e.Diagnostics.The_0_property_of_an_iterator_must_be_a_method, mustHaveAValueDiagnostic: e.Diagnostics.The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property }, dn, Jn = new e.Map(), Qe = false, Gr, S, Ce, qe, br, Zr, Si, Pi, Qi, Ct, sa, en, Wa, qn, mo, So, Go, ys, Pc, Vc, Kc, Xs, pc, hs, tc, ps, Qs, js, ds, Ji, ce, Rr, yi, qi, je, Hr, pt, Pt, ga, ua, Xn, jr, fo, xs, Fo = new e.Map(), ko = 0, Ao = 0, Ms = 0, Bs = false, xc = 0, su, tl, Zc, Rf = Bu(""), al = If(0), Jo = ED({ negative: false, base10Value: "0" }), eu = [], Ws = [], pu = [], Uu = 0, Ql = 10, xl = [], Ya = [], du = [], vc = [], Kr = [], _i = [], Ei = [], tt = [], kt = [], bt = [], ia = [], Xt = [], Za = [], bn = [], _a = [], qa = [], rn = e.createDiagnosticCollection(), jn = e.createDiagnosticCollection(), Mo = new e.Map(e.getEntries({ string: Li, number: nt, bigint: Mt, boolean: Ii, symbol: Ki, undefined: Tr })), ho = wp(), gs, Se, hr, Or = new e.Map(), ki = new e.Map(), dt = new e.Map(), la = new e.Map(), wa = new e.Map(), On = new e.Map(), No = e.createSymbolTable();
              No.set(mi.escapedName, mi);
              var jo = [[".mts", ".mjs"], [".ts", ".js"], [".cts", ".cjs"], [".mjs", ".mjs"], [".js", ".js"], [".cjs", ".cjs"], [".tsx", ye.jsx === 1 ? ".jsx" : ".js"], [".jsx", ".jsx"], [".json", ".json"]];
              return L9(), Di;
              function po(r) {
                if (r) {
                  var i = e.getSourceFileOfNode(r);
                  if (i) if (e.isJsxOpeningFragment(r)) {
                    if (i.localJsxFragmentNamespace) return i.localJsxFragmentNamespace;
                    var t = i.pragmas.get("jsxfrag");
                    if (t) {
                      var o = e.isArray(t) ? t[0] : t;
                      if (i.localJsxFragmentFactory = e.parseIsolatedEntityName(o.arguments.factory, Ae), e.visitNode(i.localJsxFragmentFactory, $n), i.localJsxFragmentFactory) return i.localJsxFragmentNamespace = e.getFirstIdentifier(i.localJsxFragmentFactory).escapedText;
                    }
                    var s = jS(r);
                    if (s) return i.localJsxFragmentFactory = s, i.localJsxFragmentNamespace = e.getFirstIdentifier(s).escapedText;
                  } else {
                    var u = Gn(i);
                    if (u) return i.localJsxNamespace = u;
                  }
                }
                return gs || (gs = "React", ye.jsxFactory ? (Se = e.parseIsolatedEntityName(ye.jsxFactory, Ae), e.visitNode(Se, $n), Se && (gs = e.getFirstIdentifier(Se).escapedText)) : ye.reactNamespace && (gs = e.escapeLeadingUnderscores(ye.reactNamespace))), Se || (Se = e.factory.createQualifiedName(e.factory.createIdentifier(e.unescapeLeadingUnderscores(gs)), "createElement")), gs;
              }
              function Gn(r) {
                if (r.localJsxNamespace) return r.localJsxNamespace;
                var i = r.pragmas.get("jsx");
                if (i) {
                  var t = e.isArray(i) ? i[0] : i;
                  if (r.localJsxFactory = e.parseIsolatedEntityName(t.arguments.factory, Ae), e.visitNode(r.localJsxFactory, $n), r.localJsxFactory) return r.localJsxNamespace = e.getFirstIdentifier(r.localJsxFactory).escapedText;
                }
              }
              function $n(r) {
                return e.setTextRangePosEnd(r, -1, -1), e.visitEachChild(r, $n, e.nullTransformationContext);
              }
              function Ho(r, i) {
                return X6(r, i), wr;
              }
              function Zo(r, i, t, o, s, u) {
                var h = r ? e.createDiagnosticForNode(r, i, t, o, s, u) : e.createCompilerDiagnostic(i, t, o, s, u), z2 = rn.lookup(h);
                return z2 || (rn.add(h), h);
              }
              function Es(r, i, t, o, s, u, h) {
                var z2 = Xr(i, t, o, s, u, h);
                return z2.skippedOn = r, z2;
              }
              function yc(r, i, t, o, s, u) {
                return r ? e.createDiagnosticForNode(r, i, t, o, s, u) : e.createCompilerDiagnostic(i, t, o, s, u);
              }
              function Xr(r, i, t, o, s, u) {
                var h = yc(r, i, t, o, s, u);
                return rn.add(h), h;
              }
              function Ls(r, i) {
                r ? rn.add(i) : jn.add(Ke(Ke({}, i), { category: e.DiagnosticCategory.Suggestion }));
              }
              function Ic(r, i, t, o, s, u, h) {
                if (i.pos < 0 || i.end < 0) {
                  if (!r) return;
                  var z2 = e.getSourceFileOfNode(i);
                  Ls(r, "message" in t ? e.createFileDiagnostic(z2, 0, 0, t, o, s, u, h) : e.createDiagnosticForFileFromMessageChain(z2, t));
                  return;
                }
                Ls(r, "message" in t ? e.createDiagnosticForNode(i, t, o, s, u, h) : e.createDiagnosticForNodeFromMessageChain(i, t));
              }
              function zu(r, i, t, o, s, u, h) {
                var z2 = Xr(r, t, o, s, u, h);
                if (i) {
                  var me = e.createDiagnosticForNode(r, e.Diagnostics.Did_you_forget_to_use_await);
                  e.addRelatedInfo(z2, me);
                }
                return z2;
              }
              function vf(r, i) {
                var t = Array.isArray(r) ? e.forEach(r, e.getJSDocDeprecatedTag) : e.getJSDocDeprecatedTag(r);
                return t && e.addRelatedInfo(i, e.createDiagnosticForNode(t, e.Diagnostics.The_declaration_was_marked_as_deprecated_here)), jn.add(i), i;
              }
              function P_(r) {
                return !!(p0(r) & 268435456);
              }
              function El(r, i, t) {
                var o = e.createDiagnosticForNode(r, e.Diagnostics._0_is_deprecated, t);
                return vf(i, o);
              }
              function vp(r, i, t, o) {
                var s = t ? e.createDiagnosticForNode(r, e.Diagnostics.The_signature_0_of_1_is_deprecated, o, t) : e.createDiagnosticForNode(r, e.Diagnostics._0_is_deprecated, o);
                return vf(i, s);
              }
              function oo(r, i, t) {
                ge++;
                var o = new We(r | 33554432, i);
                return o.checkFlags = t || 0, o;
              }
              function I_(r) {
                var i = 0;
                return r & 2 && (i |= 111551), r & 1 && (i |= 111550), r & 4 && (i |= 0), r & 8 && (i |= 900095), r & 16 && (i |= 110991), r & 32 && (i |= 899503), r & 64 && (i |= 788872), r & 256 && (i |= 899327), r & 128 && (i |= 899967), r & 512 && (i |= 110735), r & 8192 && (i |= 103359), r & 32768 && (i |= 46015), r & 65536 && (i |= 78783), r & 262144 && (i |= 526824), r & 524288 && (i |= 788968), r & 2097152 && (i |= 2097152), i;
              }
              function yp(r, i) {
                i.mergeId || (i.mergeId = E, E++), xl[i.mergeId] = r;
              }
              function Yl(r) {
                var i = oo(r.flags, r.escapedName);
                return i.declarations = r.declarations ? r.declarations.slice() : [], i.parent = r.parent, r.valueDeclaration && (i.valueDeclaration = r.valueDeclaration), r.constEnumOnlyModule && (i.constEnumOnlyModule = true), r.members && (i.members = new e.Map(r.members)), r.exports && (i.exports = new e.Map(r.exports)), yp(i, r), i;
              }
              function Bf(r, i, t) {
                if (t === void 0 && (t = false), !(r.flags & I_(i.flags)) || (i.flags | r.flags) & 67108864) {
                  if (i === r) return r;
                  if (!(r.flags & 33554432)) {
                    var o = os(r);
                    if (o === xe) return i;
                    r = Yl(o);
                  }
                  i.flags & 512 && r.flags & 512 && r.constEnumOnlyModule && !i.constEnumOnlyModule && (r.constEnumOnlyModule = false), r.flags |= i.flags, i.valueDeclaration && e.setValueDeclaration(r, i.valueDeclaration), e.addRange(r.declarations, i.declarations), i.members && (r.members || (r.members = e.createSymbolTable()), gu(r.members, i.members, t)), i.exports && (r.exports || (r.exports = e.createSymbolTable()), gu(r.exports, i.exports, t)), t || yp(r, i);
                } else if (r.flags & 1024) r !== pe && Xr(i.declarations && e.getNameOfDeclaration(i.declarations[0]), e.Diagnostics.Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity, tn(r));
                else {
                  var s = !!(r.flags & 384 || i.flags & 384), u = !!(r.flags & 2 || i.flags & 2), h = s ? e.Diagnostics.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations : u ? e.Diagnostics.Cannot_redeclare_block_scoped_variable_0 : e.Diagnostics.Duplicate_identifier_0, z2 = i.declarations && e.getSourceFileOfNode(i.declarations[0]), me = r.declarations && e.getSourceFileOfNode(r.declarations[0]), Me = e.isPlainJsFile(z2, ye.checkJs), $e = e.isPlainJsFile(me, ye.checkJs), tr = tn(i);
                  if (z2 && me && dn && !s && z2 !== me) {
                    var dr = e.comparePaths(z2.path, me.path) === -1 ? z2 : me, Dr = dr === z2 ? me : z2, Qr = e.getOrUpdate(dn, "".concat(dr.path, "|").concat(Dr.path), function() {
                      return { firstFile: dr, secondFile: Dr, conflictingSymbols: new e.Map() };
                    }), li = e.getOrUpdate(Qr.conflictingSymbols, tr, function() {
                      return { isBlockScoped: u, firstFileLocations: [], secondFileLocations: [] };
                    });
                    Me || Ti(li.firstFileLocations, i), $e || Ti(li.secondFileLocations, r);
                  } else Me || Cl(i, h, tr, r), $e || Cl(r, h, tr, i);
                }
                return r;
                function Ti(Ci, $i) {
                  if ($i.declarations) for (var Zi = 0, qt = $i.declarations; Zi < qt.length; Zi++) {
                    var Nt = qt[Zi];
                    e.pushIfUnique(Ci, Nt);
                  }
                }
              }
              function Cl(r, i, t, o) {
                e.forEach(r.declarations, function(s) {
                  c_(s, i, t, o.declarations);
                });
              }
              function c_(r, i, t, o) {
                for (var s = (e.getExpandoInitializer(r, false) ? e.getNameOfExpando(r) : e.getNameOfDeclaration(r)) || r, u = Zo(s, i, t), h = function($e) {
                  var tr = (e.getExpandoInitializer($e, false) ? e.getNameOfExpando($e) : e.getNameOfDeclaration($e)) || $e;
                  if (tr === s) return "continue";
                  u.relatedInformation = u.relatedInformation || [];
                  var dr = e.createDiagnosticForNode(tr, e.Diagnostics._0_was_also_declared_here, t), Dr = e.createDiagnosticForNode(tr, e.Diagnostics.and_here);
                  if (e.length(u.relatedInformation) >= 5 || e.some(u.relatedInformation, function(Qr) {
                    return e.compareDiagnostics(Qr, Dr) === 0 || e.compareDiagnostics(Qr, dr) === 0;
                  })) return "continue";
                  e.addRelatedInfo(u, e.length(u.relatedInformation) ? Dr : dr);
                }, z2 = 0, me = o || e.emptyArray; z2 < me.length; z2++) {
                  var Me = me[z2];
                  h(Me);
                }
              }
              function hp(r, i) {
                if (!(r != null && r.size)) return i;
                if (!(i != null && i.size)) return r;
                var t = e.createSymbolTable();
                return gu(t, r), gu(t, i), t;
              }
              function gu(r, i, t) {
                t === void 0 && (t = false), i.forEach(function(o, s) {
                  var u = r.get(s);
                  r.set(s, u ? Bf(u, o, t) : o);
                });
              }
              function Dp(r) {
                var i, t, o, s = r.parent;
                if (((i = s.symbol.declarations) === null || i === void 0 ? void 0 : i[0]) !== s) {
                  e.Debug.assert(s.symbol.declarations.length > 1);
                  return;
                }
                if (e.isGlobalScopeAugmentation(s)) gu(ii, s.symbol.exports);
                else {
                  var u = r.parent.parent.flags & 16777216 ? void 0 : e.Diagnostics.Invalid_module_name_in_augmentation_module_0_cannot_be_found, h = Pl(r, r, u, true);
                  if (!h) return;
                  if (h = Us(h), h.flags & 1920) if (e.some(S, function(Qr) {
                    return h === Qr.symbol;
                  })) {
                    var z2 = Bf(s.symbol, h, true);
                    Ce || (Ce = new e.Map()), Ce.set(r.text, z2);
                  } else {
                    if (((t = h.exports) === null || t === void 0 ? void 0 : t.get("__export")) && ((o = s.symbol.exports) === null || o === void 0 ? void 0 : o.size)) for (var me = Jv(h, "resolvedExports"), Me = 0, $e = e.arrayFrom(s.symbol.exports.entries()); Me < $e.length; Me++) {
                      var tr = $e[Me], dr = tr[0], Dr = tr[1];
                      me.has(dr) && !h.exports.has(dr) && Bf(me.get(dr), Dr);
                    }
                    Bf(h, s.symbol);
                  }
                  else Xr(r, e.Diagnostics.Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity, r.text);
                }
              }
              function sd(r, i, t) {
                i.forEach(function(s, u) {
                  var h = r.get(u);
                  h ? e.forEach(h.declarations, o(e.unescapeLeadingUnderscores(u), t)) : r.set(u, s);
                });
                function o(s, u) {
                  return function(h) {
                    return rn.add(e.createDiagnosticForNode(h, u, s));
                  };
                }
              }
              function Aa(r) {
                if (r.flags & 33554432) return r;
                var i = y(r);
                return Ya[i] || (Ya[i] = new X());
              }
              function va(r) {
                var i = A(r);
                return du[i] || (du[i] = new $());
              }
              function Cu(r) {
                return r.kind === 305 && !e.isExternalOrCommonJsModule(r);
              }
              function qs(r, i, t) {
                if (t) {
                  var o = so(r.get(i));
                  if (o) {
                    if (e.Debug.assert((e.getCheckFlags(o) & 1) === 0, "Should never get an instantiated symbol here."), o.flags & t) return o;
                    if (o.flags & 2097152) {
                      var s = Ps(o);
                      if (s === xe || s.flags & t) return o;
                    }
                  }
                }
              }
              function cd(r, i) {
                var t = r.parent, o = r.parent.parent, s = qs(t.locals, i, 111551), u = qs(Nf(o.symbol), i, 111551);
                return s && u ? [s, u] : e.Debug.fail("There should exist two symbols, one as property declaration and one as parameter declaration");
              }
              function ns(r, i) {
                var t = e.getSourceFileOfNode(r), o = e.getSourceFileOfNode(i), s = e.getEnclosingBlockScopeContainer(r);
                if (t !== o) {
                  if (er && (t.externalModuleIndicator || o.externalModuleIndicator) || !e.outFile(ye) || _m(i) || r.flags & 16777216 || Me(i, r)) return true;
                  var u = l.getSourceFiles();
                  return u.indexOf(t) <= u.indexOf(o);
                }
                if (r.pos <= i.pos && !(e.isPropertyDeclaration(r) && e.isThisProperty(i.parent) && !r.initializer && !r.exclamationToken)) {
                  if (r.kind === 203) {
                    var h = e.getAncestor(i, 203);
                    return h ? e.findAncestor(h, e.isBindingElement) !== e.findAncestor(r, e.isBindingElement) || r.pos < h.pos : ns(e.getAncestor(r, 254), i);
                  } else {
                    if (r.kind === 254) return !me(r, i);
                    if (e.isClassDeclaration(r)) return !e.findAncestor(i, function(tr) {
                      return e.isComputedPropertyName(tr) && tr.parent.parent === r;
                    });
                    if (e.isPropertyDeclaration(r)) return !$e(r, i, false);
                    if (e.isParameterPropertyDeclaration(r, r.parent)) return !(e.getEmitScriptTarget(ye) === 99 && ir && e.getContainingClass(r) === e.getContainingClass(i) && Me(i, r));
                  }
                  return true;
                }
                if (i.parent.kind === 275 || i.parent.kind === 271 && i.parent.isExportEquals || i.kind === 271 && i.isExportEquals || !!(i.flags & 8388608) || _m(i) || z2()) return true;
                if (Me(i, r)) return e.getEmitScriptTarget(ye) === 99 && ir && e.getContainingClass(r) && (e.isPropertyDeclaration(r) || e.isParameterPropertyDeclaration(r, r.parent)) ? !$e(r, i, true) : true;
                return false;
                function z2() {
                  return !!e.findAncestor(i, function(tr) {
                    return e.isInterfaceDeclaration(tr) || e.isTypeAliasDeclaration(tr);
                  });
                }
                function me(tr, dr) {
                  switch (tr.parent.parent.kind) {
                    case 237:
                    case 242:
                    case 244:
                      if (ol(dr, tr, s)) return true;
                      break;
                  }
                  var Dr = tr.parent.parent;
                  return e.isForInOrOfStatement(Dr) && ol(dr, Dr.expression, s);
                }
                function Me(tr, dr) {
                  return !!e.findAncestor(tr, function(Dr) {
                    if (Dr === s) return "quit";
                    if (e.isFunctionLike(Dr)) return true;
                    if (e.isClassStaticBlockDeclaration(Dr)) return dr.pos < tr.pos;
                    var Qr = e.tryCast(Dr.parent, e.isPropertyDeclaration);
                    if (Qr) {
                      var li = Qr.initializer === Dr;
                      if (li) if (e.isStatic(Dr.parent)) {
                        if (dr.kind === 169) return true;
                        if (e.isPropertyDeclaration(dr) && e.getContainingClass(tr) === e.getContainingClass(dr)) {
                          var Ti = dr.name;
                          if (e.isIdentifier(Ti) || e.isPrivateIdentifier(Ti)) {
                            var Ci = Jt(Et(dr)), $i = e.filter(dr.parent.members, e.isClassStaticBlockDeclaration);
                            if (DM(Ti, Ci, $i, dr.parent.pos, Dr.pos)) return true;
                          }
                        }
                      } else {
                        var Zi = dr.kind === 167 && !e.isStatic(dr);
                        if (!Zi || e.getContainingClass(tr) !== e.getContainingClass(dr)) return true;
                      }
                    }
                    return false;
                  });
                }
                function $e(tr, dr, Dr) {
                  if (dr.end > tr.end) return false;
                  var Qr = e.findAncestor(dr, function(li) {
                    if (li === tr) return "quit";
                    switch (li.kind) {
                      case 214:
                        return true;
                      case 167:
                        return Dr && (e.isPropertyDeclaration(tr) && li.parent === tr.parent || e.isParameterPropertyDeclaration(tr, tr.parent) && li.parent === tr.parent.parent) ? "quit" : true;
                      case 235:
                        switch (li.parent.kind) {
                          case 172:
                          case 169:
                          case 173:
                            return true;
                          default:
                            return false;
                        }
                      default:
                        return false;
                    }
                  });
                  return Qr === void 0;
                }
              }
              function nl(r, i, t) {
                var o = e.getEmitScriptTarget(ye), s = i;
                if (e.isParameter(t) && s.body && r.valueDeclaration && r.valueDeclaration.pos >= s.body.pos && r.valueDeclaration.end <= s.body.end && o >= 2) {
                  var u = va(s);
                  return u.declarationRequiresScopeChange === void 0 && (u.declarationRequiresScopeChange = e.forEach(s.parameters, h) || false), !u.declarationRequiresScopeChange;
                }
                return false;
                function h(me) {
                  return z2(me.name) || !!me.initializer && z2(me.initializer);
                }
                function z2(me) {
                  switch (me.kind) {
                    case 214:
                    case 213:
                    case 256:
                    case 171:
                      return false;
                    case 169:
                    case 172:
                    case 173:
                    case 296:
                      return z2(me.name);
                    case 167:
                      return e.hasStaticModifier(me) ? o < 99 || !ir : z2(me.name);
                    default:
                      return e.isNullishCoalesce(me) || e.isOptionalChain(me) ? o < 7 : e.isBindingElement(me) && me.dotDotDotToken && e.isObjectBindingPattern(me.parent) ? o < 4 : e.isTypeNode(me) ? false : e.forEachChild(me, z2) || false;
                  }
                }
              }
              function hc(r) {
                return e.isAssertionExpression(r) && e.isConstTypeReference(r.type) || e.isJSDocTypeTag(r) && e.isConstTypeReference(r.typeExpression);
              }
              function es(r, i, t, o, s, u, h, z2) {
                return h === void 0 && (h = false), z2 === void 0 && (z2 = true), u_(r, i, t, o, s, u, h, z2, qs);
              }
              function u_(r, i, t, o, s, u, h, z2, me) {
                var Me, $e, tr, dr = r, Dr, Qr, li, Ti, Ci, $i = false, Zi = r, qt, Nt = false;
                e: for (; r; ) {
                  if (i === "const" && hc(r)) return;
                  if (r.locals && !Cu(r) && (Dr = me(r.locals, i, t))) {
                    var Ra = true;
                    if (e.isFunctionLike(r) && Qr && Qr !== r.body ? (t & Dr.flags & 788968 && Qr.kind !== 320 && (Ra = Dr.flags & 262144 ? Qr === r.type || Qr.kind === 164 || Qr.kind === 340 || Qr.kind === 341 || Qr.kind === 163 : false), t & Dr.flags & 3 && (nl(Dr, r, Qr) ? Ra = false : Dr.flags & 1 && (Ra = Qr.kind === 164 || Qr === r.type && !!e.findAncestor(Dr.valueDeclaration, e.isParameter)))) : r.kind === 189 && (Ra = Qr === r.trueType), Ra) break e;
                    Dr = void 0;
                  }
                  switch ($i = $i || w_(r, Qr), r.kind) {
                    case 305:
                      if (!e.isExternalOrCommonJsModule(r)) break;
                      Nt = true;
                    case 261:
                      var ca = ((Me = Et(r)) === null || Me === void 0 ? void 0 : Me.exports) || we;
                      if (r.kind === 305 || e.isModuleDeclaration(r) && r.flags & 16777216 && !e.isGlobalScopeAugmentation(r)) {
                        if (Dr = ca.get("default")) {
                          var Sn = e.getLocalSymbolForExportDefault(Dr);
                          if (Sn && Dr.flags & t && Sn.escapedName === i) break e;
                          Dr = void 0;
                        }
                        var ja = ca.get(i);
                        if (ja && ja.flags === 2097152 && (e.getDeclarationOfKind(ja, 275) || e.getDeclarationOfKind(ja, 274))) break;
                      }
                      if (i !== "default" && (Dr = me(ca, i, t & 2623475))) if (e.isSourceFile(r) && r.commonJsModuleIndicator && !(!(($e = Dr.declarations) === null || $e === void 0) && $e.some(e.isJSDocTypeAlias))) Dr = void 0;
                      else break e;
                      break;
                    case 260:
                      if (Dr = me(((tr = Et(r)) === null || tr === void 0 ? void 0 : tr.exports) || we, i, t & 8)) break e;
                      break;
                    case 167:
                      if (!e.isStatic(r)) {
                        var Fn = Tf(r.parent);
                        Fn && Fn.locals && me(Fn.locals, i, t & 111551) && (Ti = r);
                      }
                      break;
                    case 257:
                    case 226:
                    case 258:
                      if (Dr = me(Et(r).members || we, i, t & 788968)) {
                        if (!ld(Dr, r)) {
                          Dr = void 0;
                          break;
                        }
                        if (Qr && e.isStatic(Qr)) {
                          Xr(Zi, e.Diagnostics.Static_members_cannot_reference_class_type_parameters);
                          return;
                        }
                        break e;
                      }
                      if (r.kind === 226 && t & 32) {
                        var wn = r.name;
                        if (wn && i === wn.escapedText) {
                          Dr = r.symbol;
                          break e;
                        }
                      }
                      break;
                    case 228:
                      if (Qr === r.expression && r.parent.token === 94) {
                        var Tn = r.parent.parent;
                        if (e.isClassLike(Tn) && (Dr = me(Et(Tn).members, i, t & 788968))) {
                          o && Xr(Zi, e.Diagnostics.Base_class_expressions_cannot_reference_class_type_parameters);
                          return;
                        }
                      }
                      break;
                    case 162:
                      if (qt = r.parent.parent, (e.isClassLike(qt) || qt.kind === 258) && (Dr = me(Et(qt).members, i, t & 788968))) {
                        Xr(Zi, e.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
                        return;
                      }
                      break;
                    case 214:
                      if (e.getEmitScriptTarget(ye) >= 2) break;
                    case 169:
                    case 171:
                    case 172:
                    case 173:
                    case 256:
                      if (t & 3 && i === "arguments") {
                        Dr = or;
                        break e;
                      }
                      break;
                    case 213:
                      if (t & 3 && i === "arguments") {
                        Dr = or;
                        break e;
                      }
                      if (t & 16) {
                        var Eo = r.name;
                        if (Eo && i === Eo.escapedText) {
                          Dr = r.symbol;
                          break e;
                        }
                      }
                      break;
                    case 165:
                      r.parent && r.parent.kind === 164 && (r = r.parent), r.parent && (e.isClassElement(r.parent) || r.parent.kind === 257) && (r = r.parent);
                      break;
                    case 345:
                    case 338:
                    case 339:
                      var lt = e.getJSDocRoot(r);
                      lt && (r = lt.parent);
                      break;
                    case 164:
                      Qr && (Qr === r.initializer || Qr === r.name && e.isBindingPattern(Qr)) && (Ci || (Ci = r));
                      break;
                    case 203:
                      Qr && (Qr === r.initializer || Qr === r.name && e.isBindingPattern(Qr)) && e.isParameterDeclaration(r) && !Ci && (Ci = r);
                      break;
                    case 190:
                      if (t & 262144) {
                        var it = r.typeParameter.name;
                        if (it && i === it.escapedText) {
                          Dr = r.typeParameter.symbol;
                          break e;
                        }
                      }
                      break;
                  }
                  ud(r) && (li = r), Qr = r, r = e.isJSDocTemplateTag(r) ? e.getEffectiveContainerForJSDocTemplateTag(r) || r.parent : (e.isJSDocParameterTag(r) || e.isJSDocReturnTag(r)) && e.getHostSignatureFromJSDoc(r) || r.parent;
                }
                if (u && Dr && (!li || Dr !== li.symbol) && (Dr.isReferenced |= t), !Dr) {
                  if (Qr && (e.Debug.assert(Qr.kind === 305), Qr.commonJsModuleIndicator && i === "exports" && t & Qr.symbol.flags)) return Qr.symbol;
                  h || (Dr = me(ii, i, t));
                }
                if (!Dr && dr && e.isInJSFile(dr) && dr.parent && e.isRequireCall(dr.parent, false)) return qr;
                if (!Dr) {
                  o && fe(function() {
                    if (!Zi || !fd(Zi, i, s) && !bp(Zi) && !Tp(Zi, i, t) && !O_(Zi, i) && !F_(Zi, i, t) && !M_(Zi, i, t) && !_d(Zi, i, t)) {
                      var Ia = void 0;
                      if (z2 && Uu < Ql) {
                        Ia = Kb(dr, i, t);
                        var Qt = (Ia == null ? void 0 : Ia.valueDeclaration) && e.isAmbientModule(Ia.valueDeclaration) && e.isGlobalScopeAugmentation(Ia.valueDeclaration);
                        if (Qt && (Ia = void 0), Ia) {
                          var Ka = tn(Ia), cn = Wb(dr, Ia, false), Un = t === 1920 || s && typeof s != "string" && e.nodeIsSynthesized(s) ? e.Diagnostics.Cannot_find_namespace_0_Did_you_mean_1 : cn ? e.Diagnostics.Could_not_find_name_0_Did_you_mean_1 : e.Diagnostics.Cannot_find_name_0_Did_you_mean_1, oa = yc(Zi, Un, ku(s), Ka);
                          Ls(!cn, oa), Ia.valueDeclaration && e.addRelatedInfo(oa, e.createDiagnosticForNode(Ia.valueDeclaration, e.Diagnostics._0_is_declared_here, Ka));
                        }
                      }
                      if (!Ia && s) {
                        var Mn = $5(s);
                        Mn ? Xr(Zi, o, ku(s), Mn) : Xr(Zi, o, ku(s));
                      }
                      Uu++;
                    }
                  });
                  return;
                }
                if (Ti && !(e.getEmitScriptTarget(ye) === 99 && ir)) {
                  var Yt = Ti.name;
                  Xr(Zi, e.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor, e.declarationNameToString(Yt), ku(s));
                  return;
                }
                return o && fe(function() {
                  if (Zi && (t & 2 || (t & 32 || t & 384) && (t & 111551) === 111551)) {
                    var Ia = cu(Dr);
                    (Ia.flags & 2 || Ia.flags & 32 || Ia.flags & 384) && Ep(Ia, Zi);
                  }
                  if (Dr && Nt && (t & 111551) === 111551 && !(dr.flags & 8388608)) {
                    var Qt = so(Dr);
                    e.length(Qt.declarations) && e.every(Qt.declarations, function(Ln) {
                      return e.isNamespaceExportDeclaration(Ln) || e.isSourceFile(Ln) && !!Ln.symbol.globalExports;
                    }) && Ic(!ye.allowUmdGlobalAccess, Zi, e.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, e.unescapeLeadingUnderscores(i));
                  }
                  if (Dr && Ci && !$i && (t & 111551) === 111551) {
                    var Ka = so(dg(Dr)), cn = e.getRootDeclaration(Ci);
                    Ka === Et(Ci) ? Xr(Zi, e.Diagnostics.Parameter_0_cannot_reference_itself, e.declarationNameToString(Ci.name)) : Ka.valueDeclaration && Ka.valueDeclaration.pos > Ci.pos && cn.parent.locals && me(cn.parent.locals, Ka.escapedName, t) === Ka && Xr(Zi, e.Diagnostics.Parameter_0_cannot_reference_identifier_1_declared_after_it, e.declarationNameToString(Ci.name), e.declarationNameToString(Zi));
                  }
                  if (Dr && Zi && t & 111551 && Dr.flags & 2097152 && !(Dr.flags & 111551) && !e.isValidTypeOnlyAliasUseSite(Zi)) {
                    var Un = vu(Dr);
                    if (Un) {
                      var oa = Un.kind === 275 ? e.Diagnostics._0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type : e.Diagnostics._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type, Mn = e.unescapeLeadingUnderscores(i);
                      Jf(Xr(Zi, oa, Mn), Un, Mn);
                    }
                  }
                }), Dr;
              }
              function Jf(r, i, t) {
                return i ? e.addRelatedInfo(r, e.createDiagnosticForNode(i, i.kind === 275 ? e.Diagnostics._0_was_exported_here : e.Diagnostics._0_was_imported_here, t)) : r;
              }
              function w_(r, i) {
                return r.kind !== 214 && r.kind !== 213 ? e.isTypeQueryNode(r) || (e.isFunctionLikeDeclaration(r) || r.kind === 167 && !e.isStatic(r)) && (!i || i !== r.name) : i && i === r.name ? false : r.asteriskToken || e.hasSyntacticModifier(r, 256) ? true : !e.getImmediatelyInvokedFunctionExpression(r);
              }
              function ud(r) {
                switch (r.kind) {
                  case 256:
                  case 257:
                  case 258:
                  case 260:
                  case 259:
                  case 261:
                    return true;
                  default:
                    return false;
                }
              }
              function ku(r) {
                return e.isString(r) ? e.unescapeLeadingUnderscores(r) : e.declarationNameToString(r);
              }
              function ld(r, i) {
                if (r.declarations) for (var t = 0, o = r.declarations; t < o.length; t++) {
                  var s = o[t];
                  if (s.kind === 163) {
                    var u = e.isJSDocTemplateTag(s.parent) ? e.getJSDocHost(s.parent) : s.parent;
                    if (u === i) return !(e.isJSDocTemplateTag(s.parent) && e.find(s.parent.parent.tags, e.isJSDocTypeAlias));
                  }
                }
                return false;
              }
              function fd(r, i, t) {
                if (!e.isIdentifier(r) || r.escapedText !== i || Q6(r) || _m(r)) return false;
                for (var o = e.getThisContainer(r, false), s = o; s; ) {
                  if (e.isClassLike(s.parent)) {
                    var u = Et(s.parent);
                    if (!u) break;
                    var h = Jt(u);
                    if (bi(h, i)) return Xr(r, e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0, ku(t), tn(u)), true;
                    if (s === o && !e.isStatic(s)) {
                      var z2 = go(u).thisType;
                      if (bi(z2, i)) return Xr(r, e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0, ku(t)), true;
                    }
                  }
                  s = s.parent;
                }
                return false;
              }
              function bp(r) {
                var i = Sp(r);
                return i && Ds(i, 64, true) ? (Xr(r, e.Diagnostics.Cannot_extend_an_interface_0_Did_you_mean_implements, e.getTextOfNode(i)), true) : false;
              }
              function Sp(r) {
                switch (r.kind) {
                  case 79:
                  case 206:
                    return r.parent ? Sp(r.parent) : void 0;
                  case 228:
                    if (e.isEntityNameExpression(r.expression)) return r.expression;
                  default:
                    return;
                }
              }
              function Tp(r, i, t) {
                var o = 1920 | (e.isInJSFile(r) ? 111551 : 0);
                if (t === o) {
                  var s = os(es(r, i, 788968 & ~o, void 0, void 0, false)), u = r.parent;
                  if (s) {
                    if (e.isQualifiedName(u)) {
                      e.Debug.assert(u.left === r, "Should only be resolving left side of qualified name as a namespace");
                      var h = u.right.escapedText, z2 = bi(go(s), h);
                      if (z2) return Xr(u, e.Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1, e.unescapeLeadingUnderscores(i), e.unescapeLeadingUnderscores(h)), true;
                    }
                    return Xr(r, e.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here, e.unescapeLeadingUnderscores(i)), true;
                  }
                }
                return false;
              }
              function _d(r, i, t) {
                if (t & 788584) {
                  var o = os(es(r, i, 111127, void 0, void 0, false));
                  if (o && !(o.flags & 1920)) return Xr(r, e.Diagnostics._0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0, e.unescapeLeadingUnderscores(i)), true;
                }
                return false;
              }
              function jf(r) {
                return r === "any" || r === "string" || r === "number" || r === "boolean" || r === "never" || r === "unknown";
              }
              function O_(r, i) {
                return jf(i) && r.parent.kind === 275 ? (Xr(r, e.Diagnostics.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module, i), true) : false;
              }
              function F_(r, i, t) {
                if (t & 111551) {
                  if (jf(i)) return Xr(r, e.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here, e.unescapeLeadingUnderscores(i)), true;
                  var o = os(es(r, i, 788544, void 0, void 0, false));
                  if (o && !(o.flags & 1024)) {
                    var s = e.unescapeLeadingUnderscores(i);
                    return xp(i) ? Xr(r, e.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later, s) : pd(r, o) ? Xr(r, e.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0, s, s === "K" ? "P" : "K") : Xr(r, e.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here, s), true;
                  }
                }
                return false;
              }
              function pd(r, i) {
                var t = e.findAncestor(r.parent, function(s) {
                  return e.isComputedPropertyName(s) || e.isPropertySignature(s) ? false : e.isTypeLiteralNode(s) || "quit";
                });
                if (t && t.members.length === 1) {
                  var o = go(i);
                  return !!(o.flags & 1048576) && Lg(o, 384, true);
                }
                return false;
              }
              function xp(r) {
                switch (r) {
                  case "Promise":
                  case "Symbol":
                  case "Map":
                  case "WeakMap":
                  case "Set":
                  case "WeakSet":
                    return true;
                }
                return false;
              }
              function M_(r, i, t) {
                if (t & 111127) {
                  var o = os(es(r, i, 1024, void 0, void 0, false));
                  if (o) return Xr(r, e.Diagnostics.Cannot_use_namespace_0_as_a_value, e.unescapeLeadingUnderscores(i)), true;
                } else if (t & 788544) {
                  var o = os(es(r, i, 1536, void 0, void 0, false));
                  if (o) return Xr(r, e.Diagnostics.Cannot_use_namespace_0_as_a_type, e.unescapeLeadingUnderscores(i)), true;
                }
                return false;
              }
              function Ep(r, i) {
                var t;
                if (e.Debug.assert(!!(r.flags & 2 || r.flags & 32 || r.flags & 384)), !(r.flags & 67108881 && r.flags & 32)) {
                  var o = (t = r.declarations) === null || t === void 0 ? void 0 : t.find(function(h) {
                    return e.isBlockOrCatchScoped(h) || e.isClassLike(h) || h.kind === 260;
                  });
                  if (o === void 0) return e.Debug.fail("checkResolvedBlockScopedVariable could not find block-scoped declaration");
                  if (!(o.flags & 16777216) && !ns(o, i)) {
                    var s = void 0, u = e.declarationNameToString(e.getNameOfDeclaration(o));
                    r.flags & 2 ? s = Xr(i, e.Diagnostics.Block_scoped_variable_0_used_before_its_declaration, u) : r.flags & 32 ? s = Xr(i, e.Diagnostics.Class_0_used_before_its_declaration, u) : r.flags & 256 ? s = Xr(i, e.Diagnostics.Enum_0_used_before_its_declaration, u) : (e.Debug.assert(!!(r.flags & 128)), e.shouldPreserveConstEnums(ye) && (s = Xr(i, e.Diagnostics.Enum_0_used_before_its_declaration, u))), s && e.addRelatedInfo(s, e.createDiagnosticForNode(o, e.Diagnostics._0_is_declared_here, u));
                  }
                }
              }
              function ol(r, i, t) {
                return !!i && !!e.findAncestor(r, function(o) {
                  return o === i || (o === t || e.isFunctionLike(o) && !e.getImmediatelyInvokedFunctionExpression(o) ? "quit" : false);
                });
              }
              function Au(r) {
                switch (r.kind) {
                  case 265:
                    return r;
                  case 267:
                    return r.parent;
                  case 268:
                    return r.parent.parent;
                  case 270:
                    return r.parent.parent.parent;
                  default:
                    return;
                }
              }
              function ru(r) {
                return r.declarations && e.findLast(r.declarations, yf);
              }
              function yf(r) {
                return r.kind === 265 || r.kind === 264 || r.kind === 267 && !!r.name || r.kind === 268 || r.kind === 274 || r.kind === 270 || r.kind === 275 || r.kind === 271 && e.exportAssignmentIsAlias(r) || e.isBinaryExpression(r) && e.getAssignmentDeclarationKind(r) === 2 && e.exportAssignmentIsAlias(r) || e.isAccessExpression(r) && e.isBinaryExpression(r.parent) && r.parent.left === r && r.parent.operatorToken.kind === 63 && Cp(r.parent.right) || r.kind === 297 || r.kind === 296 && Cp(r.initializer) || e.isVariableDeclarationInitializedToBareOrAccessedRequire(r);
              }
              function Cp(r) {
                return e.isAliasableExpression(r) || e.isFunctionExpression(r) && Sl(r);
              }
              function dd(r, i) {
                var t = wc(r);
                if (t) {
                  var o = e.getLeftmostAccessExpression(t.expression).arguments[0];
                  return e.isIdentifier(t.name) ? os(bi(Hm(o), t.name.escapedText)) : void 0;
                }
                if (e.isVariableDeclaration(r) || r.moduleReference.kind === 277) {
                  var s = ac(r, e.getExternalModuleRequireArgument(r) || e.getExternalModuleImportEqualsDeclarationExpression(r)), u = Us(s);
                  return Gc(r, s, u, false), u;
                }
                var h = Nl(r.moduleReference, i);
                return kp(r, h), h;
              }
              function kp(r, i) {
                if (Gc(r, void 0, i, false) && !r.isTypeOnly) {
                  var t = vu(Et(r)), o = t.kind === 275, s = o ? e.Diagnostics.An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type : e.Diagnostics.An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type, u = o ? e.Diagnostics._0_was_exported_here : e.Diagnostics._0_was_imported_here, h = e.unescapeLeadingUnderscores(t.name.escapedText);
                  e.addRelatedInfo(Xr(r.moduleReference, s), e.createDiagnosticForNode(t, u, h));
                }
              }
              function mu(r, i, t, o) {
                var s = r.exports.get("export="), u = s ? bi(Jt(s), i) : r.exports.get(i), h = os(u, o);
                return Gc(t, u, h, false), h;
              }
              function gd(r) {
                return e.isExportAssignment(r) && !r.isExportEquals || e.hasSyntacticModifier(r, 512) || e.isExportSpecifier(r);
              }
              function hf(r) {
                return e.isStringLiteralLike(r) ? e.getModeForUsageLocation(e.getSourceFileOfNode(r), r) : void 0;
              }
              function $l(r, i) {
                return r === e.ModuleKind.ESNext && i === e.ModuleKind.CommonJS;
              }
              function Uf(r) {
                var i = hf(r);
                return i === e.ModuleKind.ESNext && e.endsWith(r.text, ".json");
              }
              function L_(r, i, t, o) {
                var s = r && hf(o);
                if (r && s !== void 0) {
                  var u = $l(s, r.impliedNodeFormat);
                  if (s === e.ModuleKind.ESNext || u) return u;
                }
                if (!Cr) return false;
                if (!r || r.isDeclarationFile) {
                  var h = mu(i, "default", void 0, true);
                  return !(h && e.some(h.declarations, gd) || mu(i, e.escapeLeadingUnderscores("__esModule"), void 0, t));
                }
                return e.isSourceFileJS(r) ? !r.externalModuleIndicator && !mu(i, e.escapeLeadingUnderscores("__esModule"), void 0, t) : ll(i);
              }
              function l_(r, i) {
                var t, o = ac(r, r.parent.moduleSpecifier);
                if (o) {
                  var s = void 0;
                  e.isShorthandAmbientModuleSymbol(o) ? s = o : s = mu(o, "default", r, i);
                  var u = (t = o.declarations) === null || t === void 0 ? void 0 : t.find(e.isSourceFile), h = Uf(r.parent.moduleSpecifier), z2 = L_(u, o, i, r.parent.moduleSpecifier);
                  if (!s && !z2 && !h) if (ll(o)) {
                    var me = er >= e.ModuleKind.ES2015 ? "allowSyntheticDefaultImports" : "esModuleInterop", Me = o.exports.get("export="), $e = Me.valueDeclaration, tr = Xr(r.name, e.Diagnostics.Module_0_can_only_be_default_imported_using_the_1_flag, tn(o), me);
                    $e && e.addRelatedInfo(tr, e.createDiagnosticForNode($e, e.Diagnostics.This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag, me));
                  } else f_(o, r);
                  else if (z2 || h) {
                    var dr = Us(o, i) || os(o, i);
                    return Gc(r, o, dr, false), dr;
                  }
                  return Gc(r, s, void 0, false), s;
                }
              }
              function f_(r, i) {
                var t, o, s;
                if (!((t = r.exports) === null || t === void 0) && t.has(i.symbol.escapedName)) Xr(i.name, e.Diagnostics.Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead, tn(r), tn(i.symbol));
                else {
                  var u = Xr(i.name, e.Diagnostics.Module_0_has_no_default_export, tn(r)), h = (o = r.exports) === null || o === void 0 ? void 0 : o.get("__export");
                  if (h) {
                    var z2 = (s = h.declarations) === null || s === void 0 ? void 0 : s.find(function(me) {
                      var Me, $e;
                      return !!(e.isExportDeclaration(me) && me.moduleSpecifier && (($e = (Me = ac(me, me.moduleSpecifier)) === null || Me === void 0 ? void 0 : Me.exports) === null || $e === void 0 ? void 0 : $e.has("default")));
                    });
                    z2 && e.addRelatedInfo(u, e.createDiagnosticForNode(z2, e.Diagnostics.export_Asterisk_does_not_re_export_a_default));
                  }
                }
              }
              function md(r, i) {
                var t = r.parent.parent.moduleSpecifier, o = ac(r, t), s = Wf(o, t, i, false);
                return Gc(r, o, s, false), s;
              }
              function ks(r, i) {
                var t = r.parent.moduleSpecifier, o = t && ac(r, t), s = t && Wf(o, t, i, false);
                return Gc(r, o, s, false), s;
              }
              function Wu(r, i) {
                if (r === xe && i === xe) return xe;
                if (r.flags & 790504) return r;
                var t = oo(r.flags | i.flags, r.escapedName);
                return t.declarations = e.deduplicate(e.concatenate(r.declarations, i.declarations), e.equateValues), t.parent = r.parent || i.parent, r.valueDeclaration && (t.valueDeclaration = r.valueDeclaration), i.members && (t.members = new e.Map(i.members)), r.exports && (t.exports = new e.Map(r.exports)), t;
              }
              function Zl(r, i, t, o) {
                if (r.flags & 1536) {
                  var s = dc(r).get(i.escapedText), u = os(s, o);
                  return Gc(t, s, u, false), u;
                }
              }
              function R_(r, i) {
                if (r.flags & 3) {
                  var t = r.valueDeclaration.type;
                  if (t) return os(bi(Va(t), i));
                }
              }
              function kl(r, i, t) {
                var o, s;
                t === void 0 && (t = false);
                var u = e.getExternalModuleRequireArgument(r) || r.moduleSpecifier, h = ac(r, u), z2 = !e.isPropertyAccessExpression(i) && i.propertyName || i.name;
                if (!!e.isIdentifier(z2)) {
                  var me = z2.escapedText === "default" && !!(ye.allowSyntheticDefaultImports || e.getESModuleInterop(ye)), Me = Wf(h, u, false, me);
                  if (Me && z2.escapedText) {
                    if (e.isShorthandAmbientModuleSymbol(h)) return h;
                    var $e = void 0;
                    h && h.exports && h.exports.get("export=") ? $e = bi(Jt(Me), z2.escapedText, true) : $e = R_(Me, z2.escapedText), $e = os($e, t);
                    var tr = Zl(Me, z2, i, t);
                    if (tr === void 0 && z2.escapedText === "default") {
                      var dr = (o = h.declarations) === null || o === void 0 ? void 0 : o.find(e.isSourceFile);
                      (Uf(u) || L_(dr, h, t, u)) && (tr = Us(h, t) || os(h, t));
                    }
                    var Dr = tr && $e && tr !== $e ? Wu($e, tr) : tr || $e;
                    if (!Dr) {
                      var Qr = cl(h, r), li = e.declarationNameToString(z2), Ti = v0(z2, Me);
                      if (Ti !== void 0) {
                        var Ci = tn(Ti), $i = Xr(z2, e.Diagnostics._0_has_no_exported_member_named_1_Did_you_mean_2, Qr, li, Ci);
                        Ti.valueDeclaration && e.addRelatedInfo($i, e.createDiagnosticForNode(Ti.valueDeclaration, e.Diagnostics._0_is_declared_here, Ci));
                      } else !((s = h.exports) === null || s === void 0) && s.has("default") ? Xr(z2, e.Diagnostics.Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead, Qr, li) : __(r, z2, li, h, Qr);
                    }
                    return Dr;
                  }
                }
              }
              function __(r, i, t, o, s) {
                var u, h, z2 = (h = (u = o.valueDeclaration) === null || u === void 0 ? void 0 : u.locals) === null || h === void 0 ? void 0 : h.get(i.escapedText), me = o.exports;
                if (z2) {
                  var Me = me == null ? void 0 : me.get("export=");
                  if (Me) _l(Me, z2) ? zd(r, i, t, s) : Xr(i, e.Diagnostics.Module_0_has_no_exported_member_1, s, t);
                  else {
                    var $e = me ? e.find(Y_(me), function(dr) {
                      return !!_l(dr, z2);
                    }) : void 0, tr = $e ? Xr(i, e.Diagnostics.Module_0_declares_1_locally_but_it_is_exported_as_2, s, t, tn($e)) : Xr(i, e.Diagnostics.Module_0_declares_1_locally_but_it_is_not_exported, s, t);
                    z2.declarations && e.addRelatedInfo.apply(void 0, Ve([tr], e.map(z2.declarations, function(dr, Dr) {
                      return e.createDiagnosticForNode(dr, Dr === 0 ? e.Diagnostics._0_is_declared_here : e.Diagnostics.and_here, t);
                    }), false));
                  }
                } else Xr(i, e.Diagnostics.Module_0_has_no_exported_member_1, s, t);
              }
              function zd(r, i, t, o) {
                if (er >= e.ModuleKind.ES2015) {
                  var s = e.getESModuleInterop(ye) ? e.Diagnostics._0_can_only_be_imported_by_using_a_default_import : e.Diagnostics._0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
                  Xr(i, s, t);
                } else if (e.isInJSFile(r)) {
                  var s = e.getESModuleInterop(ye) ? e.Diagnostics._0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import : e.Diagnostics._0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
                  Xr(i, s, t);
                } else {
                  var s = e.getESModuleInterop(ye) ? e.Diagnostics._0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import : e.Diagnostics._0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
                  Xr(i, s, t, t, o);
                }
              }
              function Al(r, i) {
                var t = e.isBindingElement(r) ? e.getRootDeclaration(r) : r.parent.parent.parent, o = wc(t), s = kl(t, o || r, i), u = r.propertyName || r.name;
                return o && s && e.isIdentifier(u) ? os(bi(Jt(s), u.escapedText), i) : (Gc(r, void 0, s, false), s);
              }
              function wc(r) {
                if (e.isVariableDeclaration(r) && r.initializer && e.isPropertyAccessExpression(r.initializer)) return r.initializer;
              }
              function qu(r, i) {
                var t = Us(r.parent.symbol, i);
                return Gc(r, void 0, t, false), t;
              }
              function Vu(r, i, t) {
                var o = r.parent.parent.moduleSpecifier ? kl(r.parent.parent, r, t) : Ds(r.propertyName || r.name, i, false, t);
                return Gc(r, void 0, o, false), o;
              }
              function ef(r, i) {
                var t = e.isExportAssignment(r) ? r.expression : r.right, o = sl(t, i);
                return Gc(r, void 0, o, false), o;
              }
              function sl(r, i) {
                if (e.isClassExpression(r)) return Os(r).symbol;
                if (!(!e.isEntityName(r) && !e.isEntityNameExpression(r))) {
                  var t = Ds(r, 901119, true, i);
                  return t || (Os(r), va(r).resolvedSymbol);
                }
              }
              function p_(r, i) {
                var t = r.initializer;
                return sl(t, i);
              }
              function Df(r, i) {
                if (!!(e.isBinaryExpression(r.parent) && r.parent.left === r && r.parent.operatorToken.kind === 63)) return sl(r.parent.right, i);
              }
              function Ec(r, i) {
                switch (i === void 0 && (i = false), r.kind) {
                  case 265:
                  case 254:
                    return dd(r, i);
                  case 267:
                    return l_(r, i);
                  case 268:
                    return md(r, i);
                  case 274:
                    return ks(r, i);
                  case 270:
                  case 203:
                    return Al(r, i);
                  case 275:
                    return Vu(r, 901119, i);
                  case 271:
                  case 221:
                    return ef(r, i);
                  case 264:
                    return qu(r, i);
                  case 297:
                    return Ds(r.name, 901119, true, i);
                  case 296:
                    return p_(r, i);
                  case 207:
                  case 206:
                    return Df(r, i);
                  default:
                    return e.Debug.fail();
                }
              }
              function Zn(r, i) {
                return i === void 0 && (i = 901119), r ? (r.flags & (2097152 | i)) === 2097152 || !!(r.flags & 2097152 && r.flags & 67108864) : false;
              }
              function os(r, i) {
                return !i && Zn(r) ? Ps(r) : r;
              }
              function Ps(r) {
                e.Debug.assert((r.flags & 2097152) !== 0, "Should only get Alias here.");
                var i = Aa(r);
                if (i.aliasTarget) i.aliasTarget === vr && (i.aliasTarget = xe);
                else {
                  i.aliasTarget = vr;
                  var t = ru(r);
                  if (!t) return e.Debug.fail();
                  var o = Ec(t);
                  i.aliasTarget === vr ? i.aliasTarget = o || xe : Xr(t, e.Diagnostics.Circular_definition_of_import_alias_0, tn(r));
                }
                return i.aliasTarget;
              }
              function d_(r) {
                var i = Aa(r);
                if (i.aliasTarget !== vr) return Ps(r);
              }
              function Gc(r, i, t, o) {
                if (!r || e.isPropertyAccessExpression(r)) return false;
                var s = Et(r);
                if (e.isTypeOnlyImportOrExportDeclaration(r)) {
                  var u = Aa(s);
                  return u.typeOnlyDeclaration = r, true;
                }
                var h = Aa(s);
                return B_(h, i, o) || B_(h, t, o);
              }
              function B_(r, i, t) {
                var o, s, u;
                if (i && (r.typeOnlyDeclaration === void 0 || t && r.typeOnlyDeclaration === false)) {
                  var h = (s = (o = i.exports) === null || o === void 0 ? void 0 : o.get("export=")) !== null && s !== void 0 ? s : i, z2 = h.declarations && e.find(h.declarations, e.isTypeOnlyImportOrExportDeclaration);
                  r.typeOnlyDeclaration = (u = z2 != null ? z2 : Aa(h).typeOnlyDeclaration) !== null && u !== void 0 ? u : false;
                }
                return !!r.typeOnlyDeclaration;
              }
              function vu(r) {
                if (!!(r.flags & 2097152)) {
                  var i = Aa(r);
                  return i.typeOnlyDeclaration || void 0;
                }
              }
              function Gt(r) {
                var i = Et(r), t = Ps(i);
                if (t) {
                  var o = t === xe || t.flags & 111551 && !Av(t) && !vu(i);
                  o && As(i);
                }
              }
              function As(r) {
                var i = Aa(r);
                if (!i.referenced) {
                  i.referenced = true;
                  var t = ru(r);
                  if (!t) return e.Debug.fail();
                  if (e.isInternalModuleImportEqualsDeclaration(t)) {
                    var o = os(r);
                    (o === xe || o.flags & 111551) && Os(t.moduleReference);
                  }
                }
              }
              function vn(r) {
                var i = Aa(r);
                i.constEnumReferenced || (i.constEnumReferenced = true);
              }
              function Nl(r, i) {
                return r.kind === 79 && e.isRightSideOfQualifiedNameOrPropertyAccess(r) && (r = r.parent), r.kind === 79 || r.parent.kind === 161 ? Ds(r, 1920, false, i) : (e.Debug.assert(r.parent.kind === 265), Ds(r, 901119, false, i));
              }
              function cl(r, i) {
                return r.parent ? cl(r.parent, i) + "." + tn(r) : tn(r, i, void 0, 20);
              }
              function rf(r) {
                for (; e.isQualifiedName(r.parent); ) r = r.parent;
                return r;
              }
              function Ut(r) {
                var i = e.getFirstIdentifier(r), t = es(i, i.escapedText, 111551, void 0, i, true);
                if (!!t) {
                  for (; e.isQualifiedName(i.parent); ) {
                    var o = Jt(t);
                    if (t = bi(o, i.parent.right.escapedText), !t) return;
                    i = i.parent;
                  }
                  return t;
                }
              }
              function Ds(r, i, t, o, s) {
                if (!e.nodeIsMissing(r)) {
                  var u = 1920 | (e.isInJSFile(r) ? i & 111551 : 0), h;
                  if (r.kind === 79) {
                    var z2 = i === u || e.nodeIsSynthesized(r) ? e.Diagnostics.Cannot_find_namespace_0 : HE(e.getFirstIdentifier(r)), me = e.isInJSFile(r) && !e.nodeIsSynthesized(r) ? bf(r, i) : void 0;
                    if (h = so(es(s || r, r.escapedText, i, t || me ? void 0 : z2, r, true, false)), !h) return so(me);
                  } else if (r.kind === 161 || r.kind === 206) {
                    var Me = r.kind === 161 ? r.left : r.expression, $e = r.kind === 161 ? r.right : r.name, tr = Ds(Me, u, t, false, s);
                    if (!tr || e.nodeIsMissing($e)) return;
                    if (tr === xe) return tr;
                    if (tr.valueDeclaration && e.isInJSFile(tr.valueDeclaration) && e.isVariableDeclaration(tr.valueDeclaration) && tr.valueDeclaration.initializer && xk(tr.valueDeclaration.initializer)) {
                      var dr = tr.valueDeclaration.initializer.arguments[0], Dr = ac(dr, dr);
                      if (Dr) {
                        var Qr = Us(Dr);
                        Qr && (tr = Qr);
                      }
                    }
                    if (h = so(qs(dc(tr), $e.escapedText, i)), !h) {
                      if (!t) {
                        var li = cl(tr), Ti = e.declarationNameToString($e), Ci = v0($e, tr);
                        if (Ci) {
                          Xr($e, e.Diagnostics._0_has_no_exported_member_named_1_Did_you_mean_2, li, Ti, tn(Ci));
                          return;
                        }
                        var $i = e.isQualifiedName(r) && rf(r), Zi = qe && i & 788968 && $i && !e.isTypeOfExpression($i.parent) && Ut($i);
                        if (Zi) {
                          Xr($i, e.Diagnostics._0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0, e.entityNameToString($i));
                          return;
                        }
                        if (i & 1920 && e.isQualifiedName(r.parent)) {
                          var qt = so(qs(dc(tr), $e.escapedText, 788968));
                          if (qt) {
                            Xr(r.parent.right, e.Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1, tn(qt), e.unescapeLeadingUnderscores(r.parent.right.escapedText));
                            return;
                          }
                        }
                        Xr($e, e.Diagnostics.Namespace_0_has_no_exported_member_1, li, Ti);
                      }
                      return;
                    }
                  } else throw e.Debug.assertNever(r, "Unknown entity name kind.");
                  return e.Debug.assert((e.getCheckFlags(h) & 1) === 0, "Should never get an instantiated symbol here."), !e.nodeIsSynthesized(r) && e.isEntityName(r) && (h.flags & 2097152 || r.parent.kind === 271) && Gc(e.getAliasDeclarationFromName(r), h, void 0, true), h.flags & i || o ? h : Ps(h);
                }
              }
              function bf(r, i) {
                if (Dh(r.parent)) {
                  var t = bs(r.parent);
                  if (t) return es(t, r.escapedText, i, void 0, r, true);
                }
              }
              function bs(r) {
                var i = e.findAncestor(r, function(u) {
                  return e.isJSDocNode(u) || u.flags & 8388608 ? e.isJSDocTypeAlias(u) : "quit";
                });
                if (!i) {
                  var t = e.getJSDocHost(r);
                  if (t && e.isExpressionStatement(t) && e.isPrototypePropertyAssignment(t.expression)) {
                    var o = Et(t.expression.left);
                    if (o) return Dc(o);
                  }
                  if (t && e.isFunctionExpression(t) && e.isPrototypePropertyAssignment(t.parent) && e.isExpressionStatement(t.parent.parent)) {
                    var o = Et(t.parent.left);
                    if (o) return Dc(o);
                  }
                  if (t && (e.isObjectLiteralMethod(t) || e.isPropertyAssignment(t)) && e.isBinaryExpression(t.parent.parent) && e.getAssignmentDeclarationKind(t.parent.parent) === 6) {
                    var o = Et(t.parent.parent.left);
                    if (o) return Dc(o);
                  }
                  var s = e.getEffectiveJSDocHost(r);
                  if (s && e.isFunctionLike(s)) {
                    var o = Et(s);
                    return o && o.valueDeclaration;
                  }
                }
              }
              function Dc(r) {
                var i = r.parent.valueDeclaration;
                if (!!i) {
                  var t = e.isAssignmentDeclaration(i) ? e.getAssignedExpandoInitializer(i) : e.hasOnlyExpressionInitializer(i) ? e.getDeclaredExpandoInitializer(i) : void 0;
                  return t || i;
                }
              }
              function Cc(r) {
                var i = r.valueDeclaration;
                if (!(!i || !e.isInJSFile(i) || r.flags & 524288 || e.getExpandoInitializer(i, false))) {
                  var t = e.isVariableDeclaration(i) ? e.getDeclaredExpandoInitializer(i) : e.getAssignedExpandoInitializer(i);
                  if (t) {
                    var o = Et(t);
                    if (o) return iS(o, r);
                  }
                }
              }
              function ac(r, i, t) {
                var o = e.getEmitModuleResolutionKind(ye) === e.ModuleResolutionKind.Classic, s = o ? e.Diagnostics.Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_node_or_to_add_aliases_to_the_paths_option : e.Diagnostics.Cannot_find_module_0_or_its_corresponding_type_declarations;
                return Pl(r, i, t ? void 0 : s);
              }
              function Pl(r, i, t, o) {
                return o === void 0 && (o = false), e.isStringLiteralLike(i) ? Il(r, i.text, t, i, o) : void 0;
              }
              function Il(r, i, t, o, s) {
                var u, h, z2, me, Me, $e, tr, dr;
                if (s === void 0 && (s = false), e.startsWith(i, "@types/")) {
                  var Dr = e.Diagnostics.Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1, Qr = e.removePrefix(i, "@types/");
                  Xr(o, Dr, Qr, i);
                }
                var li = b_(i, true);
                if (li) return li;
                var Ti = e.getSourceFileOfNode(r), Ci = e.isStringLiteralLike(r) ? r : ((u = e.findAncestor(r, e.isImportCall)) === null || u === void 0 ? void 0 : u.arguments[0]) || ((h = e.findAncestor(r, e.isImportDeclaration)) === null || h === void 0 ? void 0 : h.moduleSpecifier) || ((z2 = e.findAncestor(r, e.isExternalModuleImportEqualsDeclaration)) === null || z2 === void 0 ? void 0 : z2.moduleReference.expression) || ((me = e.findAncestor(r, e.isExportDeclaration)) === null || me === void 0 ? void 0 : me.moduleSpecifier) || ((Me = e.isModuleDeclaration(r) ? r : r.parent && e.isModuleDeclaration(r.parent) && r.parent.name === r ? r.parent : void 0) === null || Me === void 0 ? void 0 : Me.name) || (($e = e.isLiteralImportTypeNode(r) ? r : void 0) === null || $e === void 0 ? void 0 : $e.argument.literal), $i = Ci && e.isStringLiteralLike(Ci) ? e.getModeForUsageLocation(Ti, Ci) : Ti.impliedNodeFormat, Zi = e.getResolvedModule(Ti, i, $i), qt = Zi && e.getResolutionDiagnostic(ye, Zi), Nt = Zi && (!qt || qt === e.Diagnostics.Module_0_was_resolved_to_1_but_jsx_is_not_set) && l.getSourceFile(Zi.resolvedFileName);
                if (Nt) {
                  if (qt && Xr(o, qt, i, Zi.resolvedFileName), Nt.symbol) {
                    if (Zi.isExternalLibraryImport && !e.resolutionExtensionIsTSOrJson(Zi.extension) && zf(false, o, Zi, i), e.getEmitModuleResolutionKind(ye) === e.ModuleResolutionKind.Node16 || e.getEmitModuleResolutionKind(ye) === e.ModuleResolutionKind.NodeNext) {
                      var Ra = Ti.impliedNodeFormat === e.ModuleKind.CommonJS && !e.findAncestor(r, e.isImportCall) || !!e.findAncestor(r, e.isImportEqualsDeclaration), ca = e.findAncestor(r, function(cn) {
                        return e.isImportTypeNode(cn) || e.isExportDeclaration(cn) || e.isImportDeclaration(cn);
                      }), Sn = ca && e.isImportTypeNode(ca) ? (tr = ca.assertions) === null || tr === void 0 ? void 0 : tr.assertClause : ca == null ? void 0 : ca.assertClause;
                      Ra && Nt.impliedNodeFormat === e.ModuleKind.ESNext && !e.getResolutionModeOverrideForClause(Sn) && Xr(o, e.Diagnostics.Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_cannot_be_imported_synchronously_Use_dynamic_import_instead, i);
                    }
                    return so(Nt.symbol);
                  }
                  t && Xr(o, e.Diagnostics.File_0_is_not_a_module, Nt.fileName);
                  return;
                }
                if (S) {
                  var ja = e.findBestPatternMatch(S, function(cn) {
                    return cn.pattern;
                  }, i);
                  if (ja) {
                    var Fn = Ce && Ce.get(i);
                    return so(Fn || ja.symbol);
                  }
                }
                if (Zi && !e.resolutionExtensionIsTSOrJson(Zi.extension) && qt === void 0 || qt === e.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type) {
                  if (s) {
                    var Dr = e.Diagnostics.Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented;
                    Xr(o, Dr, i, Zi.resolvedFileName);
                  } else zf(n && !!t, o, Zi, i);
                  return;
                }
                if (t) {
                  if (Zi) {
                    var wn = l.getProjectReferenceRedirect(Zi.resolvedFileName);
                    if (wn) {
                      Xr(o, e.Diagnostics.Output_file_0_has_not_been_built_from_source_file_1, wn, Zi.resolvedFileName);
                      return;
                    }
                  }
                  if (qt) Xr(o, qt, i, Zi.resolvedFileName);
                  else {
                    var Tn = e.tryExtractTSExtension(i), Eo = e.pathIsRelative(i) && !e.hasExtension(i), lt = e.getEmitModuleResolutionKind(ye), it = lt === e.ModuleResolutionKind.Node16 || lt === e.ModuleResolutionKind.NodeNext;
                    if (Tn) {
                      var Dr = e.Diagnostics.An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead, Yt = e.removeExtension(i, Tn), Ia = Yt;
                      er >= e.ModuleKind.ES2015 && (Ia += Tn === ".mts" ? ".mjs" : Tn === ".cts" ? ".cjs" : ".js"), Xr(o, Dr, Tn, Ia);
                    } else if (!ye.resolveJsonModule && e.fileExtensionIs(i, ".json") && e.getEmitModuleResolutionKind(ye) !== e.ModuleResolutionKind.Classic && e.hasJsonModuleEmitEnabled(ye)) Xr(o, e.Diagnostics.Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension, i);
                    else if ($i === e.ModuleKind.ESNext && it && Eo) {
                      var Qt = e.getNormalizedAbsolutePath(i, e.getDirectoryPath(Ti.path)), Ka = (dr = jo.find(function(cn) {
                        var Un = cn[0], oa = cn[1];
                        return l.fileExists(Qt + Un);
                      })) === null || dr === void 0 ? void 0 : dr[1];
                      Ka ? Xr(o, e.Diagnostics.Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_node16_or_nodenext_Did_you_mean_0, i + Ka) : Xr(o, e.Diagnostics.Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_node16_or_nodenext_Consider_adding_an_extension_to_the_import_path);
                    } else Xr(o, t, i);
                  }
                }
              }
              function zf(r, i, t, o) {
                var s = t.packageId, u = t.resolvedFileName, h = !e.isExternalModuleNameRelative(o) && s ? ul(s.name) ? e.chainDiagnosticMessages(void 0, e.Diagnostics.If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1, s.name, e.mangleScopedPackageName(s.name)) : Nu(s.name) ? e.chainDiagnosticMessages(void 0, e.Diagnostics.If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_declare_module_1, s.name, o) : e.chainDiagnosticMessages(void 0, e.Diagnostics.Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0, o, e.mangleScopedPackageName(s.name)) : void 0;
                Ic(r, i, e.chainDiagnosticMessages(h, e.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type, o, u));
              }
              function ul(r) {
                return d().has(e.getTypesPackageName(r));
              }
              function Nu(r) {
                return !!d().get(r);
              }
              function Us(r, i) {
                if (r != null && r.exports) {
                  var t = os(r.exports.get("export="), i), o = Ap(so(t), so(r));
                  return so(o) || r;
                }
              }
              function Ap(r, i) {
                if (!r || r === xe || r === i || i.exports.size === 1 || r.flags & 2097152) return r;
                var t = Aa(r);
                if (t.cjsExportMerged) return t.cjsExportMerged;
                var o = r.flags & 33554432 ? r : Yl(r);
                return o.flags = o.flags | 512, o.exports === void 0 && (o.exports = e.createSymbolTable()), i.exports.forEach(function(s, u) {
                  u !== "export=" && o.exports.set(u, o.exports.has(u) ? Bf(o.exports.get(u), s) : s);
                }), Aa(o).cjsExportMerged = o, t.cjsExportMerged = o;
              }
              function Wf(r, i, t, o) {
                var s, u = Us(r, t);
                if (!t && u) {
                  if (!o && !(u.flags & 1539) && !e.getDeclarationOfKind(u, 305)) {
                    var h = er >= e.ModuleKind.ES2015 ? "allowSyntheticDefaultImports" : "esModuleInterop";
                    return Xr(i, e.Diagnostics.This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export, h), u;
                  }
                  var z2 = i.parent;
                  if (e.isImportDeclaration(z2) && e.getNamespaceDeclarationNode(z2) || e.isImportCall(z2)) {
                    var me = e.isImportCall(z2) ? z2.arguments[0] : z2.moduleSpecifier, Me = Jt(u), $e = Sk(Me, u, r, me);
                    if ($e) return Sf(u, $e, z2);
                    var tr = (s = r == null ? void 0 : r.declarations) === null || s === void 0 ? void 0 : s.find(e.isSourceFile), dr = tr && $l(hf(me), tr.impliedNodeFormat);
                    if (e.getESModuleInterop(ye) || dr) {
                      var Dr = Ft(Me, 0);
                      if ((!Dr || !Dr.length) && (Dr = Ft(Me, 1)), Dr && Dr.length || bi(Me, "default", true) || dr) {
                        var Qr = Tk(Me, u, r, me);
                        return Sf(u, Qr, z2);
                      }
                    }
                  }
                }
                return u;
              }
              function Sf(r, i, t) {
                var o = oo(r.flags, r.escapedName);
                o.declarations = r.declarations ? r.declarations.slice() : [], o.parent = r.parent, o.target = r, o.originatingImport = t, r.valueDeclaration && (o.valueDeclaration = r.valueDeclaration), r.constEnumOnlyModule && (o.constEnumOnlyModule = true), r.members && (o.members = new e.Map(r.members)), r.exports && (o.exports = new e.Map(r.exports));
                var s = Ru(i);
                return o.type = rs(o, s.members, e.emptyArray, e.emptyArray, s.indexInfos), o;
              }
              function ll(r) {
                return r.exports.get("export=") !== void 0;
              }
              function J_(r) {
                return Y_(Pu(r));
              }
              function j_(r) {
                var i = J_(r), t = Us(r);
                if (t !== r) {
                  var o = Jt(t);
                  qf(o) && e.addRange(i, uo(o));
                }
                return i;
              }
              function U_(r, i) {
                var t = Pu(r);
                t.forEach(function(u, h) {
                  Ol(h) || i(u, h);
                });
                var o = Us(r);
                if (o !== r) {
                  var s = Jt(o);
                  qf(s) && U1(s, function(u, h) {
                    i(u, h);
                  });
                }
              }
              function iu(r, i) {
                var t = Pu(i);
                if (t) return t.get(r);
              }
              function vd(r, i) {
                var t = iu(r, i);
                if (t) return t;
                var o = Us(i);
                if (o !== i) {
                  var s = Jt(o);
                  return qf(s) ? bi(s, r) : void 0;
                }
              }
              function qf(r) {
                return !(r.flags & 131068 || e.getObjectFlags(r) & 1 || Tu(r) || Yn(r));
              }
              function dc(r) {
                return r.flags & 6256 ? Jv(r, "resolvedExports") : r.flags & 1536 ? Pu(r) : r.exports || we;
              }
              function Pu(r) {
                var i = Aa(r);
                return i.resolvedExports || (i.resolvedExports = Iu(r));
              }
              function wl(r, i, t, o) {
                !i || i.forEach(function(s, u) {
                  if (u !== "default") {
                    var h = r.get(u);
                    if (!h) r.set(u, s), t && o && t.set(u, { specifierText: e.getTextOfNode(o.moduleSpecifier) });
                    else if (t && o && h && os(h) !== os(s)) {
                      var z2 = t.get(u);
                      z2.exportsWithDuplicate ? z2.exportsWithDuplicate.push(o) : z2.exportsWithDuplicate = [o];
                    }
                  }
                });
              }
              function Iu(r) {
                var i = [];
                return r = Us(r), t(r) || we;
                function t(o) {
                  if (!!(o && o.exports && e.pushIfUnique(i, o))) {
                    var s = new e.Map(o.exports), u = o.exports.get("__export");
                    if (u) {
                      var h = e.createSymbolTable(), z2 = new e.Map();
                      if (u.declarations) for (var me = 0, Me = u.declarations; me < Me.length; me++) {
                        var $e = Me[me], tr = ac($e, $e.moduleSpecifier), dr = t(tr);
                        wl(h, dr, z2, $e);
                      }
                      z2.forEach(function(Dr, Qr) {
                        var li = Dr.exportsWithDuplicate;
                        if (!(Qr === "export=" || !(li && li.length) || s.has(Qr))) for (var Ti = 0, Ci = li; Ti < Ci.length; Ti++) {
                          var $i = Ci[Ti];
                          rn.add(e.createDiagnosticForNode($i, e.Diagnostics.Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity, z2.get(Qr).specifierText, e.unescapeLeadingUnderscores(Qr)));
                        }
                      }), wl(s, h);
                    }
                    return s;
                  }
                }
              }
              function so(r) {
                var i;
                return r && r.mergeId && (i = xl[r.mergeId]) ? i : r;
              }
              function Et(r) {
                return so(r.symbol && dg(r.symbol));
              }
              function Ys(r) {
                return so(r.parent && dg(r.parent));
              }
              function Ku(r, i) {
                var t = e.getSourceFileOfNode(i), o = A(t), s = Aa(r), u;
                if (s.extendedContainersByFile && (u = s.extendedContainersByFile.get(o))) return u;
                if (t && t.imports) {
                  for (var h = 0, z2 = t.imports; h < z2.length; h++) {
                    var me = z2[h];
                    if (!e.nodeIsSynthesized(me)) {
                      var Me = ac(i, me, true);
                      if (!!Me) {
                        var $e = fl(Me, r);
                        !$e || (u = e.append(u, Me));
                      }
                    }
                  }
                  if (e.length(u)) return (s.extendedContainersByFile || (s.extendedContainersByFile = new e.Map())).set(o, u), u;
                }
                if (s.extendedContainers) return s.extendedContainers;
                for (var tr = l.getSourceFiles(), dr = 0, Dr = tr; dr < Dr.length; dr++) {
                  var Qr = Dr[dr];
                  if (!!e.isExternalModule(Qr)) {
                    var li = Et(Qr), $e = fl(li, r);
                    !$e || (u = e.append(u, li));
                  }
                }
                return s.extendedContainers = u || e.emptyArray;
              }
              function Np(r, i, t) {
                var o = Ys(r);
                if (o && !(r.flags & 262144)) {
                  var s = e.mapDefined(o.declarations, $e), u = i && Ku(r, i), h = Pp(o, t);
                  if (i && o.flags & Fl(t) && pl(o, i, 1920, false)) return e.append(e.concatenate(e.concatenate([o], s), u), h);
                  var z2 = !(o.flags & Fl(t)) && o.flags & 788968 && go(o).flags & 524288 && t === 111551 ? Ef(i, function(tr) {
                    return e.forEachEntry(tr, function(dr) {
                      if (dr.flags & Fl(t) && Jt(dr) === go(o)) return dr;
                    });
                  }) : void 0, me = z2 ? Ve(Ve([z2], s, true), [o], false) : Ve(Ve([], s, true), [o], false);
                  return me = e.append(me, h), me = e.addRange(me, u), me;
                }
                var Me = e.mapDefined(r.declarations, function(tr) {
                  if (!e.isAmbientModule(tr) && tr.parent) {
                    if (Fc(tr.parent)) return Et(tr.parent);
                    if (e.isModuleBlock(tr.parent) && tr.parent.parent && Us(Et(tr.parent.parent)) === r) return Et(tr.parent.parent);
                  }
                  if (e.isClassExpression(tr) && e.isBinaryExpression(tr.parent) && tr.parent.operatorToken.kind === 63 && e.isAccessExpression(tr.parent.left) && e.isEntityNameExpression(tr.parent.left.expression)) return e.isModuleExportsAccessExpression(tr.parent.left) || e.isExportsIdentifier(tr.parent.left.expression) ? Et(e.getSourceFileOfNode(tr)) : (Os(tr.parent.left.expression), va(tr.parent.left.expression).resolvedSymbol);
                });
                if (!e.length(Me)) return;
                return e.mapDefined(Me, function(tr) {
                  return fl(tr, r) ? tr : void 0;
                });
                function $e(tr) {
                  return o && nc(tr, o);
                }
              }
              function Pp(r, i) {
                var t = !!e.length(r.declarations) && e.first(r.declarations);
                if (i & 111551 && t && t.parent && e.isVariableDeclaration(t.parent) && (e.isObjectLiteralExpression(t) && t === t.parent.initializer || e.isTypeLiteralNode(t) && t === t.parent.type)) return Et(t.parent);
              }
              function nc(r, i) {
                var t = gl(r), o = t && t.exports && t.exports.get("export=");
                return o && _l(o, i) ? t : void 0;
              }
              function fl(r, i) {
                if (r === Ys(i)) return i;
                var t = r.exports && r.exports.get("export=");
                if (t && _l(t, i)) return r;
                var o = dc(r), s = o.get(i.escapedName);
                return s && _l(s, i) ? s : e.forEachEntry(o, function(u) {
                  if (_l(u, i)) return u;
                });
              }
              function _l(r, i) {
                if (so(os(so(r))) === so(os(so(i)))) return r;
              }
              function cu(r) {
                return so(r && (r.flags & 1048576) !== 0 && r.exportSymbol || r);
              }
              function gc(r) {
                return !!(r.flags & 111551 || r.flags & 2097152 && Ps(r).flags & 111551 && !vu(r));
              }
              function Tf(r) {
                for (var i = r.members, t = 0, o = i; t < o.length; t++) {
                  var s = o[t];
                  if (s.kind === 171 && e.nodeIsPresent(s.body)) return s;
                }
              }
              function mc(r) {
                var i = new Fe(Di, r);
                return Be++, i.id = Be, e.tracing === null || e.tracing === void 0 || e.tracing.recordType(i), i;
              }
              function Ip(r) {
                return new Fe(Di, r);
              }
              function ms(r, i, t) {
                t === void 0 && (t = 0);
                var o = mc(r);
                return o.intrinsicName = i, o.objectFlags = t, o;
              }
              function tu(r, i) {
                var t = mc(524288);
                return t.objectFlags = r, t.symbol = i, t.members = void 0, t.properties = void 0, t.callSignatures = void 0, t.constructSignatures = void 0, t.indexInfos = void 0, t;
              }
              function wp() {
                return Pa(e.arrayFrom(G.keys(), Bu));
              }
              function Hc(r) {
                var i = mc(262144);
                return r && (i.symbol = r), i;
              }
              function Ol(r) {
                return r.charCodeAt(0) === 95 && r.charCodeAt(1) === 95 && r.charCodeAt(2) !== 95 && r.charCodeAt(2) !== 64 && r.charCodeAt(2) !== 35;
              }
              function tf(r) {
                var i;
                return r.forEach(function(t, o) {
                  xf(t, o) && (i || (i = [])).push(t);
                }), i || e.emptyArray;
              }
              function xf(r, i) {
                return !Ol(i) && gc(r);
              }
              function z_(r) {
                var i = tf(r), t = rD(r);
                return t ? e.concatenate(i, [t]) : i;
              }
              function Oc(r, i, t, o, s) {
                var u = r;
                return u.members = i, u.properties = e.emptyArray, u.callSignatures = t, u.constructSignatures = o, u.indexInfos = s, i !== we && (u.properties = tf(i)), u;
              }
              function rs(r, i, t, o, s) {
                return Oc(tu(16, r), i, t, o, s);
              }
              function Op(r) {
                if (r.constructSignatures.length === 0) return r;
                if (r.objectTypeWithoutAbstractConstructSignatures) return r.objectTypeWithoutAbstractConstructSignatures;
                var i = e.filter(r.constructSignatures, function(o) {
                  return !(o.flags & 4);
                });
                if (r.constructSignatures === i) return r;
                var t = rs(r.symbol, r.members, r.callSignatures, e.some(i) ? i : e.emptyArray, r.indexInfos);
                return r.objectTypeWithoutAbstractConstructSignatures = t, t.objectTypeWithoutAbstractConstructSignatures = t, t;
              }
              function Ef(r, i) {
                for (var t, o = function(h) {
                  if (h.locals && !Cu(h) && (t = i(h.locals, void 0, true, h))) return { value: t };
                  switch (h.kind) {
                    case 305:
                      if (!e.isExternalOrCommonJsModule(h)) break;
                    case 261:
                      var z2 = Et(h);
                      if (t = i((z2 == null ? void 0 : z2.exports) || we, void 0, true, h)) return { value: t };
                      break;
                    case 257:
                    case 226:
                    case 258:
                      var me;
                      if ((Et(h).members || we).forEach(function(Me, $e) {
                        Me.flags & 788968 && (me || (me = e.createSymbolTable())).set($e, Me);
                      }), me && (t = i(me, void 0, false, h))) return { value: t };
                      break;
                  }
                }, s = r; s; s = s.parent) {
                  var u = o(s);
                  if (typeof u == "object") return u.value;
                }
                return i(ii, void 0, true);
              }
              function Fl(r) {
                return r === 111551 ? 111551 : 1920;
              }
              function pl(r, i, t, o, s) {
                if (s === void 0 && (s = new e.Map()), !(r && !Mp(r))) return;
                var u = Aa(r), h = u.accessibleChainCache || (u.accessibleChainCache = new e.Map()), z2 = Ef(i, function(Ci, $i, Zi, qt) {
                  return qt;
                }), me = "".concat(o ? 0 : 1, "|").concat(z2 && A(z2), "|").concat(t);
                if (h.has(me)) return h.get(me);
                var Me = y(r), $e = s.get(Me);
                $e || s.set(Me, $e = []);
                var tr = Ef(i, dr);
                return h.set(me, tr), tr;
                function dr(Ci, $i, Zi) {
                  if (!!e.pushIfUnique($e, Ci)) {
                    var qt = li(Ci, $i, Zi);
                    return $e.pop(), qt;
                  }
                }
                function Dr(Ci, $i) {
                  return !Fp(Ci, i, $i) || !!pl(Ci.parent, i, Fl($i), o, s);
                }
                function Qr(Ci, $i, Zi) {
                  return (r === ($i || Ci) || so(r) === so($i || Ci)) && !e.some(Ci.declarations, Fc) && (Zi || Dr(so(Ci), t));
                }
                function li(Ci, $i, Zi) {
                  if (Qr(Ci.get(r.escapedName), void 0, $i)) return [r];
                  var qt = e.forEachEntry(Ci, function(Nt) {
                    if (Nt.flags & 2097152 && Nt.escapedName !== "export=" && Nt.escapedName !== "default" && !(e.isUMDExportSymbol(Nt) && i && e.isExternalModule(e.getSourceFileOfNode(i))) && (!o || e.some(Nt.declarations, e.isExternalModuleImportEqualsDeclaration)) && (Zi ? !e.some(Nt.declarations, e.isNamespaceReexportDeclaration) : true) && ($i || !e.getDeclarationOfKind(Nt, 275))) {
                      var Ra = Ps(Nt), ca = Ti(Nt, Ra, $i);
                      if (ca) return ca;
                    }
                    if (Nt.escapedName === r.escapedName && Nt.exportSymbol && Qr(so(Nt.exportSymbol), void 0, $i)) return [r];
                  });
                  return qt || (Ci === ii ? Ti(pe, pe, $i) : void 0);
                }
                function Ti(Ci, $i, Zi) {
                  if (Qr(Ci, $i, Zi)) return [Ci];
                  var qt = dc($i), Nt = qt && dr(qt, true);
                  if (Nt && Dr(Ci, Fl(t))) return [Ci].concat(Nt);
                }
              }
              function Fp(r, i, t) {
                var o = false;
                return Ef(i, function(s) {
                  var u = so(s.get(r.escapedName));
                  return u ? u === r ? true : (u = u.flags & 2097152 && !e.getDeclarationOfKind(u, 275) ? Ps(u) : u, u.flags & t ? (o = true, true) : false) : false;
                }), o;
              }
              function Mp(r) {
                if (r.declarations && r.declarations.length) {
                  for (var i = 0, t = r.declarations; i < t.length; i++) {
                    var o = t[i];
                    switch (o.kind) {
                      case 167:
                      case 169:
                      case 172:
                      case 173:
                        continue;
                      default:
                        return false;
                    }
                  }
                  return true;
                }
                return false;
              }
              function Gu(r, i) {
                var t = dl(r, i, 788968, false, true);
                return t.accessibility === 0;
              }
              function Lp(r, i) {
                var t = dl(r, i, 111551, false, true);
                return t.accessibility === 0;
              }
              function Cf(r, i, t) {
                var o = dl(r, i, t, false, false);
                return o.accessibility === 0;
              }
              function W_(r, i, t, o, s, u) {
                if (!!e.length(r)) {
                  for (var h, z2 = false, me = 0, Me = r; me < Me.length; me++) {
                    var $e = Me[me], tr = pl($e, i, o, false);
                    if (tr) {
                      h = $e;
                      var dr = Hu(tr[0], s);
                      if (dr) return dr;
                    }
                    if (u && e.some($e.declarations, Fc)) {
                      if (s) {
                        z2 = true;
                        continue;
                      }
                      return { accessibility: 0 };
                    }
                    var Dr = Np($e, i, o), Qr = W_(Dr, i, t, t === $e ? Fl(o) : o, s, u);
                    if (Qr) return Qr;
                  }
                  if (z2) return { accessibility: 0 };
                  if (h) return { accessibility: 1, errorSymbolName: tn(t, i, o), errorModuleName: h !== t ? tn(h, i, 1920) : void 0 };
                }
              }
              function g_(r, i, t, o) {
                return dl(r, i, t, o, true);
              }
              function dl(r, i, t, o, s) {
                if (r && i) {
                  var u = W_([r], i, r, t, o, s);
                  if (u) return u;
                  var h = e.forEach(r.declarations, gl);
                  if (h) {
                    var z2 = gl(i);
                    if (h !== z2) return { accessibility: 2, errorSymbolName: tn(r, i, t), errorModuleName: tn(h), errorNode: e.isInJSFile(i) ? i : void 0 };
                  }
                  return { accessibility: 1, errorSymbolName: tn(r, i, t) };
                }
                return { accessibility: 0 };
              }
              function gl(r) {
                var i = e.findAncestor(r, Vf);
                return i && Et(i);
              }
              function Vf(r) {
                return e.isAmbientModule(r) || r.kind === 305 && e.isExternalOrCommonJsModule(r);
              }
              function Fc(r) {
                return e.isModuleWithStringLiteralName(r) || r.kind === 305 && e.isExternalOrCommonJsModule(r);
              }
              function Hu(r, i) {
                var t;
                if (!e.every(e.filter(r.declarations, function(u) {
                  return u.kind !== 79;
                }), o)) return;
                return { accessibility: 0, aliasesToMakeVisible: t };
                function o(u) {
                  var h, z2;
                  if (!wu(u)) {
                    var me = Au(u);
                    return me && !e.hasSyntacticModifier(me, 1) && wu(me.parent) ? s(u, me) : e.isVariableDeclaration(u) && e.isVariableStatement(u.parent.parent) && !e.hasSyntacticModifier(u.parent.parent, 1) && wu(u.parent.parent.parent) ? s(u, u.parent.parent) : e.isLateVisibilityPaintedStatement(u) && !e.hasSyntacticModifier(u, 1) && wu(u.parent) ? s(u, u) : r.flags & 2097152 && e.isBindingElement(u) && e.isInJSFile(u) && ((h = u.parent) === null || h === void 0 ? void 0 : h.parent) && e.isVariableDeclaration(u.parent.parent) && ((z2 = u.parent.parent.parent) === null || z2 === void 0 ? void 0 : z2.parent) && e.isVariableStatement(u.parent.parent.parent.parent) && !e.hasSyntacticModifier(u.parent.parent.parent.parent, 1) && u.parent.parent.parent.parent.parent && wu(u.parent.parent.parent.parent.parent) ? s(u, u.parent.parent.parent.parent) : false;
                  }
                  return true;
                }
                function s(u, h) {
                  return i && (va(u).isVisible = true, t = e.appendIfUnique(t, h)), true;
                }
              }
              function af(r, i) {
                var t;
                r.parent.kind === 181 || r.parent.kind === 228 && !e.isPartOfTypeNode(r.parent) || r.parent.kind === 162 ? t = 1160127 : r.kind === 161 || r.kind === 206 || r.parent.kind === 265 ? t = 1920 : t = 788968;
                var o = e.getFirstIdentifier(r), s = es(i, o.escapedText, t, void 0, void 0, false);
                return s && s.flags & 262144 && t & 788968 ? { accessibility: 0 } : s && Hu(s, true) || { accessibility: 1, errorSymbolName: e.getTextOfNode(o), errorNode: o };
              }
              function tn(r, i, t, o, s) {
                o === void 0 && (o = 4);
                var u = 70221824;
                o & 2 && (u |= 128), o & 1 && (u |= 512), o & 8 && (u |= 16384), o & 16 && (u |= 134217728);
                var h = o & 4 ? Ur.symbolToExpression : Ur.symbolToEntityName;
                return s ? z2(s).getText() : e.usingSingleLineStringWriter(z2);
                function z2(me) {
                  var Me = h(r, t, i, u), $e = (i == null ? void 0 : i.kind) === 305 ? e.createPrinter({ removeComments: true, neverAsciiEscape: true }) : e.createPrinter({ removeComments: true }), tr = i && e.getSourceFileOfNode(i);
                  return $e.writeNode(4, Me, tr, me), me;
                }
              }
              function Ml(r, i, t, o, s) {
                return t === void 0 && (t = 0), s ? u(s).getText() : e.usingSingleLineStringWriter(u);
                function u(h) {
                  var z2;
                  t & 262144 ? z2 = o === 1 ? 180 : 179 : z2 = o === 1 ? 175 : 174;
                  var me = Ur.signatureToSignatureDeclaration(r, z2, i, Rp(t) | 70221824 | 512), Me = e.createPrinter({ removeComments: true, omitTrailingSemicolon: true }), $e = i && e.getSourceFileOfNode(i);
                  return Me.writeNode(4, me, $e, e.getTrailingSemicolonDeferringWriter(h)), h;
                }
              }
              function Ot(r, i, t, o) {
                t === void 0 && (t = 1064960), o === void 0 && (o = e.createTextWriter(""));
                var s = ye.noErrorTruncation || t & 1, u = Ur.typeToTypeNode(r, i, Rp(t) | 70221824 | (s ? 1 : 0), o);
                if (u === void 0) return e.Debug.fail("should always get typenode");
                var h = { removeComments: r !== Ue }, z2 = e.createPrinter(h), me = i && e.getSourceFileOfNode(i);
                z2.writeNode(4, u, me, o);
                var Me = o.getText(), $e = s ? e.noTruncationMaximumTruncationLength * 2 : e.defaultMaximumTruncationLength * 2;
                return $e && Me && Me.length >= $e ? Me.substr(0, $e - 3) + "..." : Me;
              }
              function nf(r, i) {
                var t = Kf(r.symbol) ? Ot(r, r.symbol.valueDeclaration) : Ot(r), o = Kf(i.symbol) ? Ot(i, i.symbol.valueDeclaration) : Ot(i);
                return t === o && (t = q_(r), o = q_(i)), [t, o];
              }
              function q_(r) {
                return Ot(r, void 0, 64);
              }
              function Kf(r) {
                return r && !!r.valueDeclaration && e.isExpression(r.valueDeclaration) && !Ju(r.valueDeclaration);
              }
              function Rp(r) {
                return r === void 0 && (r = 0), r & 814775659;
              }
              function yd(r) {
                return !!r.symbol && !!(r.symbol.flags & 32) && (r === aa(r.symbol) || !!(r.flags & 524288) && !!(e.getObjectFlags(r) & 16777216));
              }
              function m_() {
                return { typeToTypeNode: function(ci, Fr, jt, Lt) {
                  return r(Fr, jt, Lt, function(ea) {
                    return o(ci, ea);
                  });
                }, indexInfoToIndexSignatureDeclaration: function(ci, Fr, jt, Lt) {
                  return r(Fr, jt, Lt, function(ea) {
                    return Me(ci, ea, void 0);
                  });
                }, signatureToSignatureDeclaration: function(ci, Fr, jt, Lt, ea) {
                  return r(jt, Lt, ea, function(Kt) {
                    return $e(ci, Fr, Kt);
                  });
                }, symbolToEntityName: function(ci, Fr, jt, Lt, ea) {
                  return r(jt, Lt, ea, function(Kt) {
                    return Fn(ci, Kt, Fr, false);
                  });
                }, symbolToExpression: function(ci, Fr, jt, Lt, ea) {
                  return r(jt, Lt, ea, function(Kt) {
                    return wn(ci, Kt, Fr);
                  });
                }, symbolToTypeParameterDeclarations: function(ci, Fr, jt, Lt) {
                  return r(Fr, jt, Lt, function(ea) {
                    return $i(ci, ea);
                  });
                }, symbolToParameterDeclaration: function(ci, Fr, jt, Lt) {
                  return r(Fr, jt, Lt, function(ea) {
                    return Qr(ci, ea);
                  });
                }, typeParameterToDeclaration: function(ci, Fr, jt, Lt) {
                  return r(Fr, jt, Lt, function(ea) {
                    return Dr(ci, ea);
                  });
                }, symbolTableToDeclarationStatements: function(ci, Fr, jt, Lt, ea) {
                  return r(Fr, jt, Lt, function(Kt) {
                    return Ln(ci, Kt, ea);
                  });
                } };
                function r(ci, Fr, jt, Lt) {
                  var ea, Kt;
                  e.Debug.assert(ci === void 0 || (ci.flags & 8) === 0);
                  var $t = { enclosingDeclaration: ci, flags: Fr || 0, tracker: jt && jt.trackSymbol ? jt : { trackSymbol: function() {
                    return false;
                  }, moduleResolverHost: Fr & 134217728 ? { getCommonSourceDirectory: l.getCommonSourceDirectory ? function() {
                    return l.getCommonSourceDirectory();
                  } : function() {
                    return "";
                  }, getCurrentDirectory: function() {
                    return l.getCurrentDirectory();
                  }, getSymlinkCache: e.maybeBind(l, l.getSymlinkCache), getPackageJsonInfoCache: function() {
                    var Yr;
                    return (Yr = l.getPackageJsonInfoCache) === null || Yr === void 0 ? void 0 : Yr.call(l);
                  }, useCaseSensitiveFileNames: e.maybeBind(l, l.useCaseSensitiveFileNames), redirectTargetsMap: l.redirectTargetsMap, getProjectReferenceRedirect: function(Yr) {
                    return l.getProjectReferenceRedirect(Yr);
                  }, isSourceOfProjectReferenceRedirect: function(Yr) {
                    return l.isSourceOfProjectReferenceRedirect(Yr);
                  }, fileExists: function(Yr) {
                    return l.fileExists(Yr);
                  }, getFileIncludeReasons: function() {
                    return l.getFileIncludeReasons();
                  }, readFile: l.readFile ? function(Yr) {
                    return l.readFile(Yr);
                  } : void 0 } : void 0 }, encounteredError: false, reportedDiagnostic: false, visitedTypes: void 0, symbolDepth: void 0, inferTypeParameters: void 0, approximateLength: 0 };
                  $t.tracker = i($t, $t.tracker);
                  var Ua = Lt($t);
                  return $t.truncating && $t.flags & 1 && ((Kt = (ea = $t.tracker) === null || ea === void 0 ? void 0 : ea.reportTruncationError) === null || Kt === void 0 || Kt.call(ea)), $t.encounteredError ? void 0 : Ua;
                }
                function i(ci, Fr) {
                  var jt = Fr.trackSymbol;
                  return Ke(Ke({}, Fr), { reportCyclicStructureError: Lt(Fr.reportCyclicStructureError), reportInaccessibleThisError: Lt(Fr.reportInaccessibleThisError), reportInaccessibleUniqueSymbolError: Lt(Fr.reportInaccessibleUniqueSymbolError), reportLikelyUnsafeImportRequiredError: Lt(Fr.reportLikelyUnsafeImportRequiredError), reportNonlocalAugmentation: Lt(Fr.reportNonlocalAugmentation), reportPrivateInBaseOfClassExpression: Lt(Fr.reportPrivateInBaseOfClassExpression), reportNonSerializableProperty: Lt(Fr.reportNonSerializableProperty), trackSymbol: jt && function() {
                    for (var ea = [], Kt = 0; Kt < arguments.length; Kt++) ea[Kt] = arguments[Kt];
                    var $t = jt.apply(void 0, ea);
                    return $t && (ci.reportedDiagnostic = true), $t;
                  } });
                  function Lt(ea) {
                    return ea && function() {
                      for (var Kt = [], $t = 0; $t < arguments.length; $t++) Kt[$t] = arguments[$t];
                      return ci.reportedDiagnostic = true, ea.apply(void 0, Kt);
                    };
                  }
                }
                function t(ci) {
                  return ci.truncating ? ci.truncating : ci.truncating = ci.approximateLength > (ci.flags & 1 ? e.noTruncationMaximumTruncationLength : e.defaultMaximumTruncationLength);
                }
                function o(ci, Fr) {
                  g && g.throwIfCancellationRequested && g.throwIfCancellationRequested();
                  var jt = Fr.flags & 8388608;
                  if (Fr.flags &= -8388609, !ci) {
                    if (!(Fr.flags & 262144)) {
                      Fr.encounteredError = true;
                      return;
                    }
                    return Fr.approximateLength += 3, e.factory.createKeywordTypeNode(130);
                  }
                  if (Fr.flags & 536870912 || (ci = bu(ci)), ci.flags & 1) return ci.aliasSymbol ? e.factory.createTypeReferenceNode(Ra(ci.aliasSymbol), z2(ci.aliasTypeArguments, Fr)) : ci === Ue ? e.addSyntheticLeadingComment(e.factory.createKeywordTypeNode(130), 3, "unresolved") : (Fr.approximateLength += 3, e.factory.createKeywordTypeNode(ci === De ? 138 : 130));
                  if (ci.flags & 2) return e.factory.createKeywordTypeNode(155);
                  if (ci.flags & 4) return Fr.approximateLength += 6, e.factory.createKeywordTypeNode(150);
                  if (ci.flags & 8) return Fr.approximateLength += 6, e.factory.createKeywordTypeNode(147);
                  if (ci.flags & 64) return Fr.approximateLength += 6, e.factory.createKeywordTypeNode(158);
                  if (ci.flags & 16 && !ci.aliasSymbol) return Fr.approximateLength += 7, e.factory.createKeywordTypeNode(133);
                  if (ci.flags & 1024 && !(ci.flags & 1048576)) {
                    var Lt = Ys(ci.symbol), ea = ca(Lt, Fr, 788968);
                    if (go(Lt) === ci) return ea;
                    var Kt = e.symbolName(ci.symbol);
                    return e.isIdentifierText(Kt, 0) ? fp(ea, e.factory.createTypeReferenceNode(Kt, void 0)) : e.isImportTypeNode(ea) ? (ea.isTypeOf = true, e.factory.createIndexedAccessTypeNode(ea, e.factory.createLiteralTypeNode(e.factory.createStringLiteral(Kt)))) : e.isTypeReferenceNode(ea) ? e.factory.createIndexedAccessTypeNode(e.factory.createTypeQueryNode(ea.typeName), e.factory.createLiteralTypeNode(e.factory.createStringLiteral(Kt))) : e.Debug.fail("Unhandled type node kind returned from `symbolToTypeNode`.");
                  }
                  if (ci.flags & 1056) return ca(ci.symbol, Fr, 788968);
                  if (ci.flags & 128) return Fr.approximateLength += ci.value.length + 2, e.factory.createLiteralTypeNode(e.setEmitFlags(e.factory.createStringLiteral(ci.value, !!(Fr.flags & 268435456)), 16777216));
                  if (ci.flags & 256) {
                    var $t = ci.value;
                    return Fr.approximateLength += ("" + $t).length, e.factory.createLiteralTypeNode($t < 0 ? e.factory.createPrefixUnaryExpression(40, e.factory.createNumericLiteral(-$t)) : e.factory.createNumericLiteral($t));
                  }
                  if (ci.flags & 2048) return Fr.approximateLength += e.pseudoBigIntToString(ci.value).length + 1, e.factory.createLiteralTypeNode(e.factory.createBigIntLiteral(ci.value));
                  if (ci.flags & 512) return Fr.approximateLength += ci.intrinsicName.length, e.factory.createLiteralTypeNode(ci.intrinsicName === "true" ? e.factory.createTrue() : e.factory.createFalse());
                  if (ci.flags & 8192) {
                    if (!(Fr.flags & 1048576)) {
                      if (Lp(ci.symbol, Fr.enclosingDeclaration)) return Fr.approximateLength += 6, ca(ci.symbol, Fr, 111551);
                      Fr.tracker.reportInaccessibleUniqueSymbolError && Fr.tracker.reportInaccessibleUniqueSymbolError();
                    }
                    return Fr.approximateLength += 13, e.factory.createTypeOperatorNode(154, e.factory.createKeywordTypeNode(151));
                  }
                  if (ci.flags & 16384) return Fr.approximateLength += 4, e.factory.createKeywordTypeNode(114);
                  if (ci.flags & 32768) return Fr.approximateLength += 9, e.factory.createKeywordTypeNode(153);
                  if (ci.flags & 65536) return Fr.approximateLength += 4, e.factory.createLiteralTypeNode(e.factory.createNull());
                  if (ci.flags & 131072) return Fr.approximateLength += 5, e.factory.createKeywordTypeNode(143);
                  if (ci.flags & 4096) return Fr.approximateLength += 6, e.factory.createKeywordTypeNode(151);
                  if (ci.flags & 67108864) return Fr.approximateLength += 6, e.factory.createKeywordTypeNode(148);
                  if (e.isThisTypeParameter(ci)) return Fr.flags & 4194304 && (!Fr.encounteredError && !(Fr.flags & 32768) && (Fr.encounteredError = true), Fr.tracker.reportInaccessibleThisError && Fr.tracker.reportInaccessibleThisError()), Fr.approximateLength += 4, e.factory.createThisTypeNode();
                  if (!jt && ci.aliasSymbol && (Fr.flags & 16384 || Gu(ci.aliasSymbol, Fr.enclosingDeclaration))) {
                    var Ua = z2(ci.aliasTypeArguments, Fr);
                    return Ol(ci.aliasSymbol.escapedName) && !(ci.aliasSymbol.flags & 32) ? e.factory.createTypeReferenceNode(e.factory.createIdentifier(""), Ua) : ca(ci.aliasSymbol, Fr, 788968, Ua);
                  }
                  var Yr = e.getObjectFlags(ci);
                  if (Yr & 4) return e.Debug.assert(!!(ci.flags & 524288)), ci.node ? jd(ci, Tl) : Tl(ci);
                  if (ci.flags & 262144 || Yr & 3) {
                    if (ci.flags & 262144 && e.contains(Fr.inferTypeParameters, ci)) {
                      Fr.approximateLength += e.symbolName(ci.symbol).length + 6;
                      var Ni = void 0, Hi = Tc(ci);
                      if (Hi) {
                        var _t = sx(ci, true);
                        _t && wf(Hi, _t) || (Fr.approximateLength += 9, Ni = Hi && o(Hi, Fr));
                      }
                      return e.factory.createInferTypeNode(dr(ci, Fr, Ni));
                    }
                    if (Fr.flags & 4 && ci.flags & 262144 && !Gu(ci.symbol, Fr.enclosingDeclaration)) {
                      var gt = ja(ci, Fr);
                      return Fr.approximateLength += e.idText(gt).length, e.factory.createTypeReferenceNode(e.factory.createIdentifier(e.idText(gt)), void 0);
                    }
                    if (ci.symbol) return ca(ci.symbol, Fr, 788968);
                    var Vt = (ci === Rn || ci === Da) && _e && _e.symbol ? (ci === Da ? "sub-" : "super-") + e.symbolName(_e.symbol) : "?";
                    return e.factory.createTypeReferenceNode(e.factory.createIdentifier(Vt), void 0);
                  }
                  if (ci.flags & 1048576 && ci.origin && (ci = ci.origin), ci.flags & 3145728) {
                    var Fa = ci.flags & 1048576 ? hd(ci.types) : ci.types;
                    if (e.length(Fa) === 1) return o(Fa[0], Fr);
                    var on = z2(Fa, Fr, true);
                    if (on && on.length > 0) return ci.flags & 1048576 ? e.factory.createUnionTypeNode(on) : e.factory.createIntersectionTypeNode(on);
                    !Fr.encounteredError && !(Fr.flags & 262144) && (Fr.encounteredError = true);
                    return;
                  }
                  if (Yr & 48) return e.Debug.assert(!!(ci.flags & 524288)), rl(ci);
                  if (ci.flags & 4194304) {
                    var zn = ci.type;
                    Fr.approximateLength += 6;
                    var Ga = o(zn, Fr);
                    return e.factory.createTypeOperatorNode(140, Ga);
                  }
                  if (ci.flags & 134217728) {
                    var Qn = ci.texts, wo = ci.types, Po = e.factory.createTemplateHead(Qn[0]), Uo = e.factory.createNodeArray(e.map(wo, function(za, $r) {
                      return e.factory.createTemplateLiteralTypeSpan(o(za, Fr), ($r < wo.length - 1 ? e.factory.createTemplateMiddle : e.factory.createTemplateTail)(Qn[$r + 1]));
                    }));
                    return Fr.approximateLength += 2, e.factory.createTemplateLiteralType(Po, Uo);
                  }
                  if (ci.flags & 268435456) {
                    var Rs = o(ci.type, Fr);
                    return ca(ci.symbol, Fr, 788968, [Rs]);
                  }
                  if (ci.flags & 8388608) {
                    var Fs = o(ci.objectType, Fr), Ga = o(ci.indexType, Fr);
                    return Fr.approximateLength += 2, e.factory.createIndexedAccessTypeNode(Fs, Ga);
                  }
                  if (ci.flags & 16777216) return jd(ci, function(za) {
                    return rc(za);
                  });
                  if (ci.flags & 33554432) return o(ci.baseType, Fr);
                  return e.Debug.fail("Should be unreachable.");
                  function rc(za) {
                    var $r = o(za.checkType, Fr);
                    if (Fr.approximateLength += 15, Fr.flags & 4 && za.root.isDistributive && !(za.checkType.flags & 262144)) {
                      var hi = Hc(oo(262144, "T")), Ri = ja(hi, Fr), mt = e.factory.createTypeReferenceNode(Ri);
                      Fr.approximateLength += 37;
                      var ft = $d(za.root.checkType, hi, za.combinedMapper || za.mapper), Ht = Fr.inferTypeParameters;
                      Fr.inferTypeParameters = za.root.inferTypeParameters;
                      var vt = o(un(za.root.extendsType, ft), Fr);
                      Fr.inferTypeParameters = Ht;
                      var ht = xu(un(Va(za.root.node.trueType), ft)), ma = xu(un(Va(za.root.node.falseType), ft));
                      return e.factory.createConditionalTypeNode($r, e.factory.createInferTypeNode(e.factory.createTypeParameterDeclaration(void 0, e.factory.cloneNode(mt.typeName))), e.factory.createConditionalTypeNode(e.factory.createTypeReferenceNode(e.factory.cloneNode(Ri)), o(za.checkType, Fr), e.factory.createConditionalTypeNode(mt, vt, ht, ma), e.factory.createKeywordTypeNode(143)), e.factory.createKeywordTypeNode(143));
                    }
                    var Ca = Fr.inferTypeParameters;
                    Fr.inferTypeParameters = za.root.inferTypeParameters;
                    var An = o(za.extendsType, Fr);
                    Fr.inferTypeParameters = Ca;
                    var gn = xu(ip(za)), Vn = xu(tp(za));
                    return e.factory.createConditionalTypeNode($r, An, gn, Vn);
                  }
                  function xu(za) {
                    var $r, hi, Ri;
                    return za.flags & 1048576 ? !(($r = Fr.visitedTypes) === null || $r === void 0) && $r.has(fu(za)) ? (Fr.flags & 131072 || (Fr.encounteredError = true, (Ri = (hi = Fr.tracker) === null || hi === void 0 ? void 0 : hi.reportCyclicStructureError) === null || Ri === void 0 || Ri.call(hi)), s(Fr)) : jd(za, function(mt) {
                      return o(mt, Fr);
                    }) : o(za, Fr);
                  }
                  function Ts(za) {
                    e.Debug.assert(!!(za.flags & 524288));
                    var $r = za.declaration.readonlyToken ? e.factory.createToken(za.declaration.readonlyToken.kind) : void 0, hi = za.declaration.questionToken ? e.factory.createToken(za.declaration.questionToken.kind) : void 0, Ri, mt;
                    if (mg(za)) {
                      if (!(Ed(za).flags & 262144) && Fr.flags & 4) {
                        var ft = Hc(oo(262144, "T")), Ht = ja(ft, Fr);
                        mt = e.factory.createTypeReferenceNode(Ht);
                      }
                      Ri = e.factory.createTypeOperatorNode(140, mt || o(Ed(za), Fr));
                    } else Ri = o(Mu(za), Fr);
                    var vt = dr(Du(za), Fr, Ri), ht = za.declaration.nameType ? o(Jl(za), Fr) : void 0, ma = o(kg(vl(za), !!(Lu(za) & 4)), Fr), Ca = e.factory.createMappedTypeNode($r, vt, ht, hi, ma, void 0);
                    Fr.approximateLength += 10;
                    var An = e.setEmitFlags(Ca, 1);
                    return mg(za) && !(Ed(za).flags & 262144) && Fr.flags & 4 ? e.factory.createConditionalTypeNode(o(Ed(za), Fr), e.factory.createInferTypeNode(e.factory.createTypeParameterDeclaration(void 0, e.factory.cloneNode(mt.typeName))), An, e.factory.createKeywordTypeNode(143)) : An;
                  }
                  function rl(za) {
                    var $r, hi = za.id, Ri = za.symbol;
                    if (Ri) {
                      var mt = yd(za) ? 788968 : 111551;
                      if (Sl(Ri.valueDeclaration)) return ca(Ri, Fr, mt);
                      if (Ri.flags & 32 && !Xa(Ri) && !(Ri.valueDeclaration && Ri.valueDeclaration.kind === 226 && Fr.flags & 2048) || Ri.flags & 896 || Ht()) return ca(Ri, Fr, mt);
                      if (!(($r = Fr.visitedTypes) === null || $r === void 0) && $r.has(hi)) {
                        var ft = Bp(za);
                        return ft ? ca(ft, Fr, 788968) : s(Fr);
                      } else return jd(za, lp);
                    } else return lp(za);
                    function Ht() {
                      var vt, ht = !!(Ri.flags & 8192) && e.some(Ri.declarations, function(Ca) {
                        return e.isStatic(Ca);
                      }), ma = !!(Ri.flags & 16) && (Ri.parent || e.forEach(Ri.declarations, function(Ca) {
                        return Ca.parent.kind === 305 || Ca.parent.kind === 262;
                      }));
                      if (ht || ma) return (!!(Fr.flags & 4096) || ((vt = Fr.visitedTypes) === null || vt === void 0 ? void 0 : vt.has(hi))) && (!(Fr.flags & 8) || Lp(Ri, Fr.enclosingDeclaration));
                    }
                  }
                  function jd(za, $r) {
                    var hi, Ri, mt = za.id, ft = e.getObjectFlags(za) & 16 && za.symbol && za.symbol.flags & 32, Ht = e.getObjectFlags(za) & 4 && za.node ? "N" + A(za.node) : za.flags & 16777216 ? "N" + A(za.root.node) : za.symbol ? (ft ? "+" : "") + y(za.symbol) : void 0;
                    Fr.visitedTypes || (Fr.visitedTypes = new e.Set()), Ht && !Fr.symbolDepth && (Fr.symbolDepth = new e.Map());
                    var vt = Fr.enclosingDeclaration && va(Fr.enclosingDeclaration), ht = "".concat(fu(za), "|").concat(Fr.flags);
                    vt && (vt.serializedTypes || (vt.serializedTypes = new e.Map()));
                    var ma = (hi = vt == null ? void 0 : vt.serializedTypes) === null || hi === void 0 ? void 0 : hi.get(ht);
                    if (ma) return ma.truncating && (Fr.truncating = true), Fr.approximateLength += ma.addedLength, zo(ma);
                    var Ca;
                    if (Ht) {
                      if (Ca = Fr.symbolDepth.get(Ht) || 0, Ca > 10) return s(Fr);
                      Fr.symbolDepth.set(Ht, Ca + 1);
                    }
                    Fr.visitedTypes.add(mt);
                    var An = Fr.approximateLength, gn = $r(za), Vn = Fr.approximateLength - An;
                    return !Fr.reportedDiagnostic && !Fr.encounteredError && (Fr.truncating && (gn.truncating = true), gn.addedLength = Vn, (Ri = vt == null ? void 0 : vt.serializedTypes) === null || Ri === void 0 || Ri.set(ht, gn)), Fr.visitedTypes.delete(mt), Ht && Fr.symbolDepth.set(Ht, Ca), gn;
                    function zo(Bo) {
                      return !e.nodeIsSynthesized(Bo) && e.getParseTreeNode(Bo) === Bo ? Bo : e.setTextRange(e.factory.cloneNode(e.visitEachChild(Bo, zo, e.nullTransformationContext, us)), Bo);
                    }
                    function us(Bo, Io, Qo, ls, gi) {
                      return Bo && Bo.length === 0 ? e.setTextRange(e.factory.createNodeArray(void 0, Bo.hasTrailingComma), Bo) : e.visitNodes(Bo, Io, Qo, ls, gi);
                    }
                  }
                  function lp(za) {
                    if (Bc(za) || za.containsError) return Ts(za);
                    var $r = Ru(za);
                    if (!$r.properties.length && !$r.indexInfos.length) {
                      if (!$r.callSignatures.length && !$r.constructSignatures.length) return Fr.approximateLength += 2, e.setEmitFlags(e.factory.createTypeLiteralNode(void 0), 1);
                      if ($r.callSignatures.length === 1 && !$r.constructSignatures.length) {
                        var hi = $r.callSignatures[0], Ri = $e(hi, 179, Fr);
                        return Ri;
                      }
                      if ($r.constructSignatures.length === 1 && !$r.callSignatures.length) {
                        var hi = $r.constructSignatures[0], Ri = $e(hi, 180, Fr);
                        return Ri;
                      }
                    }
                    var mt = e.filter($r.constructSignatures, function(Ca) {
                      return !!(Ca.flags & 4);
                    });
                    if (e.some(mt)) {
                      var ft = e.map(mt, im), Ht = $r.callSignatures.length + ($r.constructSignatures.length - mt.length) + $r.indexInfos.length + (Fr.flags & 2048 ? e.countWhere($r.properties, function(Ca) {
                        return !(Ca.flags & 4194304);
                      }) : e.length($r.properties));
                      return Ht && ft.push(Op($r)), o(Do(ft), Fr);
                    }
                    var vt = Fr.flags;
                    Fr.flags |= 4194304;
                    var ht = id($r);
                    Fr.flags = vt;
                    var ma = e.factory.createTypeLiteralNode(ht);
                    return Fr.approximateLength += 2, e.setEmitFlags(ma, Fr.flags & 1024 ? 0 : 1), ma;
                  }
                  function Tl(za) {
                    var $r = xo(za);
                    if (za.target === Pi || za.target === Qi) {
                      if (Fr.flags & 2) {
                        var hi = o($r[0], Fr);
                        return e.factory.createTypeReferenceNode(za.target === Pi ? "Array" : "ReadonlyArray", [hi]);
                      }
                      var Ri = o($r[0], Fr), mt = e.factory.createArrayTypeNode(Ri);
                      return za.target === Pi ? mt : e.factory.createTypeOperatorNode(145, mt);
                    } else if (za.target.objectFlags & 8) {
                      if ($r = e.sameMap($r, function(zt, La) {
                        return kg(zt, !!(za.target.elementFlags[La] & 2));
                      }), $r.length > 0) {
                        var ft = $_(za), Ht = z2($r.slice(0, ft), Fr);
                        if (Ht) {
                          if (za.target.labeledElementDeclarations) for (var vt = 0; vt < Ht.length; vt++) {
                            var ht = za.target.elementFlags[vt];
                            Ht[vt] = e.factory.createNamedTupleMember(ht & 12 ? e.factory.createToken(25) : void 0, e.factory.createIdentifier(e.unescapeLeadingUnderscores(E0(za.target.labeledElementDeclarations[vt]))), ht & 2 ? e.factory.createToken(57) : void 0, ht & 4 ? e.factory.createArrayTypeNode(Ht[vt]) : Ht[vt]);
                          }
                          else for (var vt = 0; vt < Math.min(ft, Ht.length); vt++) {
                            var ht = za.target.elementFlags[vt];
                            Ht[vt] = ht & 12 ? e.factory.createRestTypeNode(ht & 4 ? e.factory.createArrayTypeNode(Ht[vt]) : Ht[vt]) : ht & 2 ? e.factory.createOptionalTypeNode(Ht[vt]) : Ht[vt];
                          }
                          var ma = e.setEmitFlags(e.factory.createTupleTypeNode(Ht), 1);
                          return za.target.readonly ? e.factory.createTypeOperatorNode(145, ma) : ma;
                        }
                      }
                      if (Fr.encounteredError || Fr.flags & 524288) {
                        var ma = e.setEmitFlags(e.factory.createTupleTypeNode([]), 1);
                        return za.target.readonly ? e.factory.createTypeOperatorNode(145, ma) : ma;
                      }
                      Fr.encounteredError = true;
                      return;
                    } else {
                      if (Fr.flags & 2048 && za.symbol.valueDeclaration && e.isClassLike(za.symbol.valueDeclaration) && !Lp(za.symbol, Fr.enclosingDeclaration)) return rl(za);
                      var Ca = za.target.outerTypeParameters, vt = 0, An = void 0;
                      if (Ca) for (var gn = Ca.length; vt < gn; ) {
                        var Vn = vt, zo = cx(Ca[vt]);
                        do
                          vt++;
                        while (vt < gn && cx(Ca[vt]) === zo);
                        if (!e.rangeEquals(Ca, $r, Vn, vt)) {
                          var us = z2($r.slice(Vn, vt), Fr), Bo = Fr.flags;
                          Fr.flags |= 16;
                          var Io = ca(zo, Fr, 788968, us);
                          Fr.flags = Bo, An = An ? fp(An, Io) : Io;
                        }
                      }
                      var Qo = void 0;
                      if ($r.length > 0) {
                        var ls = (za.target.typeParameters || e.emptyArray).length;
                        Qo = z2($r.slice(vt, ls), Fr);
                      }
                      var ht = Fr.flags;
                      Fr.flags |= 16;
                      var gi = ca(za.symbol, Fr, 788968, Qo);
                      return Fr.flags = ht, An ? fp(An, gi) : gi;
                    }
                  }
                  function fp(za, $r) {
                    if (e.isImportTypeNode(za)) {
                      var hi = za.typeArguments, Ri = za.qualifier;
                      Ri && (e.isIdentifier(Ri) ? Ri = e.factory.updateIdentifier(Ri, hi) : Ri = e.factory.updateQualifiedName(Ri, Ri.left, e.factory.updateIdentifier(Ri.right, hi))), hi = $r.typeArguments;
                      for (var mt = zg($r), ft = 0, Ht = mt; ft < Ht.length; ft++) {
                        var vt = Ht[ft];
                        Ri = Ri ? e.factory.createQualifiedName(Ri, vt) : vt;
                      }
                      return e.factory.updateImportTypeNode(za, za.argument, Ri, hi, za.isTypeOf);
                    } else {
                      var hi = za.typeArguments, ht = za.typeName;
                      e.isIdentifier(ht) ? ht = e.factory.updateIdentifier(ht, hi) : ht = e.factory.updateQualifiedName(ht, ht.left, e.factory.updateIdentifier(ht.right, hi)), hi = $r.typeArguments;
                      for (var mt = zg($r), ma = 0, Ca = mt; ma < Ca.length; ma++) {
                        var vt = Ca[ma];
                        ht = e.factory.createQualifiedName(ht, vt);
                      }
                      return e.factory.updateTypeReferenceNode(za, ht, hi);
                    }
                  }
                  function zg(za) {
                    for (var $r = za.typeName, hi = []; !e.isIdentifier($r); ) hi.unshift($r.right), $r = $r.left;
                    return hi.unshift($r), hi;
                  }
                  function id(za) {
                    if (t(Fr)) return [e.factory.createPropertySignature(void 0, "...", void 0, void 0)];
                    for (var $r = [], hi = 0, Ri = za.callSignatures; hi < Ri.length; hi++) {
                      var mt = Ri[hi];
                      $r.push($e(mt, 174, Fr));
                    }
                    for (var ft = 0, Ht = za.constructSignatures; ft < Ht.length; ft++) {
                      var mt = Ht[ft];
                      mt.flags & 4 || $r.push($e(mt, 175, Fr));
                    }
                    for (var vt = 0, ht = za.indexInfos; vt < ht.length; vt++) {
                      var ma = ht[vt];
                      $r.push(Me(ma, Fr, za.objectFlags & 1024 ? s(Fr) : void 0));
                    }
                    var Ca = za.properties;
                    if (!Ca) return $r;
                    for (var An = 0, gn = 0, Vn = Ca; gn < Vn.length; gn++) {
                      var zo = Vn[gn];
                      if (An++, Fr.flags & 2048) {
                        if (zo.flags & 4194304) continue;
                        e.getDeclarationModifierFlagsFromSymbol(zo) & 24 && Fr.tracker.reportPrivateInBaseOfClassExpression && Fr.tracker.reportPrivateInBaseOfClassExpression(e.unescapeLeadingUnderscores(zo.escapedName));
                      }
                      if (t(Fr) && An + 2 < Ca.length - 1) {
                        $r.push(e.factory.createPropertySignature(void 0, "... ".concat(Ca.length - An, " more ..."), void 0, void 0)), h(Ca[Ca.length - 1], Fr, $r);
                        break;
                      }
                      h(zo, Fr, $r);
                    }
                    return $r.length ? $r : void 0;
                  }
                }
                function s(ci) {
                  return ci.approximateLength += 3, ci.flags & 1 ? e.factory.createKeywordTypeNode(130) : e.factory.createTypeReferenceNode(e.factory.createIdentifier("..."), void 0);
                }
                function u(ci, Fr) {
                  var jt;
                  return !!(e.getCheckFlags(ci) & 8192) && (e.contains(Fr.reverseMappedStack, ci) || ((jt = Fr.reverseMappedStack) === null || jt === void 0 ? void 0 : jt[0]) && !(e.getObjectFlags(e.last(Fr.reverseMappedStack).propertyType) & 16));
                }
                function h(ci, Fr, jt) {
                  var Lt, ea, Kt = !!(e.getCheckFlags(ci) & 8192), $t = u(ci, Fr) ? Oe : ml(ci), Ua = Fr.enclosingDeclaration;
                  if (Fr.enclosingDeclaration = void 0, Fr.tracker.trackSymbol && e.getCheckFlags(ci) & 4096 && pg(ci.escapedName)) if (ci.declarations) {
                    var Yr = e.first(ci.declarations);
                    if ($g(Yr)) if (e.isBinaryExpression(Yr)) {
                      var Ni = e.getNameOfDeclaration(Yr);
                      Ni && e.isElementAccessExpression(Ni) && e.isPropertyAccessEntityNameExpression(Ni.argumentExpression) && li(Ni.argumentExpression, Ua, Fr);
                    } else li(Yr.name.expression, Ua, Fr);
                  } else !((Lt = Fr.tracker) === null || Lt === void 0) && Lt.reportNonSerializableProperty && Fr.tracker.reportNonSerializableProperty(tn(ci));
                  Fr.enclosingDeclaration = ci.valueDeclaration || ((ea = ci.declarations) === null || ea === void 0 ? void 0 : ea[0]) || Ua;
                  var Hi = lt(ci, Fr);
                  Fr.enclosingDeclaration = Ua, Fr.approximateLength += e.symbolName(ci).length + 1;
                  var _t = ci.flags & 16777216 ? e.factory.createToken(57) : void 0;
                  if (ci.flags & 8208 && !Pf($t).length && !Zu(ci)) for (var gt = ot(ec($t, function(Uo) {
                    return !(Uo.flags & 32768);
                  }), 0), Vt = 0, Fa = gt; Vt < Fa.length; Vt++) {
                    var on = Fa[Vt], zn = $e(on, 168, Fr, { name: Hi, questionToken: _t });
                    jt.push(Po(zn));
                  }
                  else {
                    var Ga = void 0;
                    u(ci, Fr) ? Ga = s(Fr) : (Kt && (Fr.reverseMappedStack || (Fr.reverseMappedStack = []), Fr.reverseMappedStack.push(ci)), Ga = $t ? Ka(Fr, $t, ci, Ua) : e.factory.createKeywordTypeNode(130), Kt && Fr.reverseMappedStack.pop());
                    var Qn = Zu(ci) ? [e.factory.createToken(145)] : void 0;
                    Qn && (Fr.approximateLength += 9);
                    var wo = e.factory.createPropertySignature(Qn, Hi, _t, Ga);
                    jt.push(Po(wo));
                  }
                  function Po(Uo) {
                    var Rs;
                    if (e.some(ci.declarations, function(xu) {
                      return xu.kind === 347;
                    })) {
                      var Fs = (Rs = ci.declarations) === null || Rs === void 0 ? void 0 : Rs.find(function(xu) {
                        return xu.kind === 347;
                      }), rc = e.getTextOfJSDocComment(Fs.comment);
                      rc && e.setSyntheticLeadingComments(Uo, [{ kind: 3, text: `*
 * ` + rc.replace(/\n/g, `
 * `) + `
 `, pos: -1, end: -1, hasTrailingNewLine: true }]);
                    } else ci.valueDeclaration && e.setCommentRange(Uo, ci.valueDeclaration);
                    return Uo;
                  }
                }
                function z2(ci, Fr, jt) {
                  if (e.some(ci)) {
                    if (t(Fr)) if (jt) {
                      if (ci.length > 2) return [o(ci[0], Fr), e.factory.createTypeReferenceNode("... ".concat(ci.length - 2, " more ..."), void 0), o(ci[ci.length - 1], Fr)];
                    } else return [e.factory.createTypeReferenceNode("...", void 0)];
                    for (var Lt = !(Fr.flags & 64), ea = Lt ? e.createUnderscoreEscapedMultiMap() : void 0, Kt = [], $t = 0, Ua = 0, Yr = ci; Ua < Yr.length; Ua++) {
                      var Ni = Yr[Ua];
                      if ($t++, t(Fr) && $t + 2 < ci.length - 1) {
                        Kt.push(e.factory.createTypeReferenceNode("... ".concat(ci.length - $t, " more ..."), void 0));
                        var Hi = o(ci[ci.length - 1], Fr);
                        Hi && Kt.push(Hi);
                        break;
                      }
                      Fr.approximateLength += 2;
                      var _t = o(Ni, Fr);
                      _t && (Kt.push(_t), ea && e.isIdentifierTypeReference(_t) && ea.add(_t.typeName.escapedText, [Ni, Kt.length - 1]));
                    }
                    if (ea) {
                      var gt = Fr.flags;
                      Fr.flags |= 64, ea.forEach(function(Vt) {
                        if (!e.arrayIsHomogeneous(Vt, function(wo, Po) {
                          var Uo = wo[0], Rs = Po[0];
                          return me(Uo, Rs);
                        })) for (var Fa = 0, on = Vt; Fa < on.length; Fa++) {
                          var zn = on[Fa], Ga = zn[0], Qn = zn[1];
                          Kt[Qn] = o(Ga, Fr);
                        }
                      }), Fr.flags = gt;
                    }
                    return Kt;
                  }
                }
                function me(ci, Fr) {
                  return ci === Fr || !!ci.symbol && ci.symbol === Fr.symbol || !!ci.aliasSymbol && ci.aliasSymbol === Fr.aliasSymbol;
                }
                function Me(ci, Fr, jt) {
                  var Lt = e.getNameFromIndexInfo(ci) || "x", ea = o(ci.keyType, Fr), Kt = e.factory.createParameterDeclaration(void 0, void 0, void 0, Lt, void 0, ea, void 0);
                  return jt || (jt = o(ci.type || Oe, Fr)), !ci.type && !(Fr.flags & 2097152) && (Fr.encounteredError = true), Fr.approximateLength += Lt.length + 4, e.factory.createIndexSignature(void 0, ci.isReadonly ? [e.factory.createToken(145)] : void 0, [Kt], jt);
                }
                function $e(ci, Fr, jt, Lt) {
                  var ea, Kt, $t, Ua, Yr = jt.flags & 256;
                  Yr && (jt.flags &= -257), jt.approximateLength += 3;
                  var Ni, Hi;
                  jt.flags & 32 && ci.target && ci.mapper && ci.target.typeParameters ? Hi = ci.target.typeParameters.map(function(Fs) {
                    return o(un(Fs, ci.mapper), jt);
                  }) : Ni = ci.typeParameters && ci.typeParameters.map(function(Fs) {
                    return Dr(Fs, jt);
                  });
                  var _t = Jm(ci, true)[0], gt = (e.some(_t, function(Fs) {
                    return Fs !== _t[_t.length - 1] && !!(e.getCheckFlags(Fs) & 32768);
                  }) ? ci.parameters : _t).map(function(Fs) {
                    return Qr(Fs, jt, Fr === 171, Lt == null ? void 0 : Lt.privateSymbolVisitor, Lt == null ? void 0 : Lt.bundledImports);
                  }), Vt = tr(ci, jt);
                  Vt && gt.unshift(Vt);
                  var Fa, on = Yc(ci);
                  if (on) {
                    var zn = on.kind === 2 || on.kind === 3 ? e.factory.createToken(128) : void 0, Ga = on.kind === 1 || on.kind === 3 ? e.setEmitFlags(e.factory.createIdentifier(on.parameterName), 16777216) : e.factory.createThisTypeNode(), Qn = on.type && o(on.type, jt);
                    Fa = e.factory.createTypePredicateNode(zn, Ga, Qn);
                  } else {
                    var wo = yo(ci);
                    wo && !(Yr && ta(wo)) ? Fa = Un(jt, wo, ci, Lt == null ? void 0 : Lt.privateSymbolVisitor, Lt == null ? void 0 : Lt.bundledImports) : Yr || (Fa = e.factory.createKeywordTypeNode(130));
                  }
                  var Po = Lt == null ? void 0 : Lt.modifiers;
                  if (Fr === 180 && ci.flags & 4) {
                    var Uo = e.modifiersToFlags(Po);
                    Po = e.factory.createModifiersFromModifierFlags(Uo | 128);
                  }
                  var Rs = Fr === 174 ? e.factory.createCallSignature(Ni, gt, Fa) : Fr === 175 ? e.factory.createConstructSignature(Ni, gt, Fa) : Fr === 168 ? e.factory.createMethodSignature(Po, (ea = Lt == null ? void 0 : Lt.name) !== null && ea !== void 0 ? ea : e.factory.createIdentifier(""), Lt == null ? void 0 : Lt.questionToken, Ni, gt, Fa) : Fr === 169 ? e.factory.createMethodDeclaration(void 0, Po, void 0, (Kt = Lt == null ? void 0 : Lt.name) !== null && Kt !== void 0 ? Kt : e.factory.createIdentifier(""), void 0, Ni, gt, Fa, void 0) : Fr === 171 ? e.factory.createConstructorDeclaration(void 0, Po, gt, void 0) : Fr === 172 ? e.factory.createGetAccessorDeclaration(void 0, Po, ($t = Lt == null ? void 0 : Lt.name) !== null && $t !== void 0 ? $t : e.factory.createIdentifier(""), gt, Fa, void 0) : Fr === 173 ? e.factory.createSetAccessorDeclaration(void 0, Po, (Ua = Lt == null ? void 0 : Lt.name) !== null && Ua !== void 0 ? Ua : e.factory.createIdentifier(""), gt, void 0) : Fr === 176 ? e.factory.createIndexSignature(void 0, Po, gt, Fa) : Fr === 317 ? e.factory.createJSDocFunctionType(gt, Fa) : Fr === 179 ? e.factory.createFunctionTypeNode(Ni, gt, Fa != null ? Fa : e.factory.createTypeReferenceNode(e.factory.createIdentifier(""))) : Fr === 180 ? e.factory.createConstructorTypeNode(Po, Ni, gt, Fa != null ? Fa : e.factory.createTypeReferenceNode(e.factory.createIdentifier(""))) : Fr === 256 ? e.factory.createFunctionDeclaration(void 0, Po, void 0, Lt != null && Lt.name ? e.cast(Lt.name, e.isIdentifier) : e.factory.createIdentifier(""), Ni, gt, Fa, void 0) : Fr === 213 ? e.factory.createFunctionExpression(Po, void 0, Lt != null && Lt.name ? e.cast(Lt.name, e.isIdentifier) : e.factory.createIdentifier(""), Ni, gt, Fa, e.factory.createBlock([])) : Fr === 214 ? e.factory.createArrowFunction(Po, Ni, gt, Fa, void 0, e.factory.createBlock([])) : e.Debug.assertNever(Fr);
                  return Hi && (Rs.typeArguments = e.factory.createNodeArray(Hi)), Rs;
                }
                function tr(ci, Fr) {
                  if (ci.thisParameter) return Qr(ci.thisParameter, Fr);
                  if (ci.declaration) {
                    var jt = e.getJSDocThisTag(ci.declaration);
                    if (jt && jt.typeExpression) return e.factory.createParameterDeclaration(void 0, void 0, void 0, "this", void 0, o(Va(jt.typeExpression), Fr));
                  }
                }
                function dr(ci, Fr, jt) {
                  var Lt = Fr.flags;
                  Fr.flags &= -513;
                  var ea = e.factory.createModifiersFromModifierFlags(WD(ci)), Kt = ja(ci, Fr), $t = D_(ci), Ua = $t && o($t, Fr);
                  return Fr.flags = Lt, e.factory.createTypeParameterDeclaration(ea, Kt, jt, Ua);
                }
                function Dr(ci, Fr, jt) {
                  jt === void 0 && (jt = Tc(ci));
                  var Lt = jt && o(jt, Fr);
                  return dr(ci, Fr, Lt);
                }
                function Qr(ci, Fr, jt, Lt, ea) {
                  var Kt = e.getDeclarationOfKind(ci, 164);
                  !Kt && !e.isTransientSymbol(ci) && (Kt = e.getDeclarationOfKind(ci, 340));
                  var $t = Jt(ci);
                  Kt && aA(Kt) && ($t = i_($t));
                  var Ua = Ka(Fr, $t, ci, Fr.enclosingDeclaration, Lt, ea), Yr = !(Fr.flags & 8192) && jt && Kt && Kt.modifiers ? Kt.modifiers.map(e.factory.cloneNode) : void 0, Ni = Kt && e.isRestParameter(Kt) || e.getCheckFlags(ci) & 32768, Hi = Ni ? e.factory.createToken(25) : void 0, _t = Kt && Kt.name ? Kt.name.kind === 79 ? e.setEmitFlags(e.factory.cloneNode(Kt.name), 16777216) : Kt.name.kind === 161 ? e.setEmitFlags(e.factory.cloneNode(Kt.name.right), 16777216) : on(Kt.name) : e.symbolName(ci), gt = Kt && kd(Kt) || e.getCheckFlags(ci) & 16384, Vt = gt ? e.factory.createToken(57) : void 0, Fa = e.factory.createParameterDeclaration(void 0, Yr, Hi, _t, Vt, Ua, void 0);
                  return Fr.approximateLength += e.symbolName(ci).length + 3, Fa;
                  function on(zn) {
                    return Ga(zn);
                    function Ga(Qn) {
                      Fr.tracker.trackSymbol && e.isComputedPropertyName(Qn) && Rv(Qn) && li(Qn.expression, Fr.enclosingDeclaration, Fr);
                      var wo = e.visitEachChild(Qn, Ga, e.nullTransformationContext, void 0, Ga);
                      return e.isBindingElement(wo) && (wo = e.factory.updateBindingElement(wo, wo.dotDotDotToken, wo.propertyName, wo.name, void 0)), e.nodeIsSynthesized(wo) || (wo = e.factory.cloneNode(wo)), e.setEmitFlags(wo, 16777217);
                    }
                  }
                }
                function li(ci, Fr, jt) {
                  if (!!jt.tracker.trackSymbol) {
                    var Lt = e.getFirstIdentifier(ci), ea = es(Lt, Lt.escapedText, 1160127, void 0, void 0, true);
                    ea && jt.tracker.trackSymbol(ea, Fr, 111551);
                  }
                }
                function Ti(ci, Fr, jt, Lt) {
                  return Fr.tracker.trackSymbol(ci, Fr.enclosingDeclaration, jt), Ci(ci, Fr, jt, Lt);
                }
                function Ci(ci, Fr, jt, Lt) {
                  var ea, Kt = ci.flags & 262144;
                  return !Kt && (Fr.enclosingDeclaration || Fr.flags & 64) && !(Fr.flags & 134217728) ? (ea = e.Debug.checkDefined($t(ci, jt, true)), e.Debug.assert(ea && ea.length > 0)) : ea = [ci], ea;
                  function $t(Ua, Yr, Ni) {
                    var Hi = pl(Ua, Fr.enclosingDeclaration, Yr, !!(Fr.flags & 128)), _t;
                    if (!Hi || Fp(Hi[0], Fr.enclosingDeclaration, Hi.length === 1 ? Yr : Fl(Yr))) {
                      var gt = Np(Hi ? Hi[0] : Ua, Fr.enclosingDeclaration, Yr);
                      if (e.length(gt)) {
                        _t = gt.map(function(Po) {
                          return e.some(Po.declarations, Fc) ? Nt(Po, Fr) : void 0;
                        });
                        var Vt = gt.map(function(Po, Uo) {
                          return Uo;
                        });
                        Vt.sort(wo);
                        for (var Fa = Vt.map(function(Po) {
                          return gt[Po];
                        }), on = 0, zn = Fa; on < zn.length; on++) {
                          var Ga = zn[on], Qn = $t(Ga, Fl(Yr), false);
                          if (Qn) {
                            if (Ga.exports && Ga.exports.get("export=") && _l(Ga.exports.get("export="), Ua)) {
                              Hi = Qn;
                              break;
                            }
                            Hi = Qn.concat(Hi || [fl(Ga, Ua) || Ua]);
                            break;
                          }
                        }
                      }
                    }
                    if (Hi) return Hi;
                    if (Ni || !(Ua.flags & 6144)) return !Ni && !Lt && !!e.forEach(Ua.declarations, Fc) ? void 0 : [Ua];
                    function wo(Po, Uo) {
                      var Rs = _t[Po], Fs = _t[Uo];
                      if (Rs && Fs) {
                        var rc = e.pathIsRelative(Fs);
                        return e.pathIsRelative(Rs) === rc ? e.moduleSpecifiers.countPathComponents(Rs) - e.moduleSpecifiers.countPathComponents(Fs) : rc ? -1 : 1;
                      }
                      return 0;
                    }
                  }
                }
                function $i(ci, Fr) {
                  var jt, Lt = jg(ci);
                  return Lt.flags & 524384 && (jt = e.factory.createNodeArray(e.map(Af(ci), function(ea) {
                    return Dr(ea, Fr);
                  }))), jt;
                }
                function Zi(ci, Fr, jt) {
                  var Lt;
                  e.Debug.assert(ci && 0 <= Fr && Fr < ci.length);
                  var ea = ci[Fr], Kt = y(ea);
                  if (!(!((Lt = jt.typeParameterSymbolList) === null || Lt === void 0) && Lt.has(Kt))) {
                    (jt.typeParameterSymbolList || (jt.typeParameterSymbolList = new e.Set())).add(Kt);
                    var $t;
                    if (jt.flags & 512 && Fr < ci.length - 1) {
                      var Ua = ea, Yr = ci[Fr + 1];
                      if (e.getCheckFlags(Yr) & 1) {
                        var Ni = Hg(Ua.flags & 2097152 ? Ps(Ua) : Ua);
                        $t = z2(e.map(Ni, function(Hi) {
                          return ap(Hi, Yr.mapper);
                        }), jt);
                      } else $t = $i(ea, jt);
                    }
                    return $t;
                  }
                }
                function qt(ci) {
                  return e.isIndexedAccessTypeNode(ci.objectType) ? qt(ci.objectType) : ci;
                }
                function Nt(ci, Fr, jt) {
                  var Lt, ea = e.getDeclarationOfKind(ci, 305);
                  if (!ea) {
                    var Kt = e.firstDefined(ci.declarations, function(wo) {
                      return nc(wo, ci);
                    });
                    Kt && (ea = e.getDeclarationOfKind(Kt, 305));
                  }
                  if (ea && ea.moduleName !== void 0) return ea.moduleName;
                  if (!ea) {
                    if (Fr.tracker.trackReferencedAmbientModule) {
                      var $t = e.filter(ci.declarations, e.isAmbientModule);
                      if (e.length($t)) for (var Ua = 0, Yr = $t; Ua < Yr.length; Ua++) {
                        var Ni = Yr[Ua];
                        Fr.tracker.trackReferencedAmbientModule(Ni, ci);
                      }
                    }
                    if (a.test(ci.escapedName)) return ci.escapedName.substring(1, ci.escapedName.length - 1);
                  }
                  if (!Fr.enclosingDeclaration || !Fr.tracker.moduleResolverHost) return a.test(ci.escapedName) ? ci.escapedName.substring(1, ci.escapedName.length - 1) : e.getSourceFileOfNode(e.getNonAugmentationDeclaration(ci)).fileName;
                  var Hi = e.getSourceFileOfNode(e.getOriginalNode(Fr.enclosingDeclaration)), _t = jt || (Hi == null ? void 0 : Hi.impliedNodeFormat), gt = Qn(Hi.path, _t), Vt = Aa(ci), Fa = Vt.specifierCache && Vt.specifierCache.get(gt);
                  if (!Fa) {
                    var on = !!e.outFile(ye), zn = Fr.tracker.moduleResolverHost, Ga = on ? Ke(Ke({}, ye), { baseUrl: zn.getCommonSourceDirectory() }) : ye;
                    Fa = e.first(e.moduleSpecifiers.getModuleSpecifiers(ci, Di, Ga, Hi, zn, { importModuleSpecifierPreference: on ? "non-relative" : "project-relative", importModuleSpecifierEnding: on ? "minimal" : _t === e.ModuleKind.ESNext ? "js" : void 0 }, { overrideImportMode: jt })), (Lt = Vt.specifierCache) !== null && Lt !== void 0 || (Vt.specifierCache = new e.Map()), Vt.specifierCache.set(gt, Fa);
                  }
                  return Fa;
                  function Qn(wo, Po) {
                    return Po === void 0 ? wo : "".concat(Po, "|").concat(wo);
                  }
                }
                function Ra(ci) {
                  var Fr = e.factory.createIdentifier(e.unescapeLeadingUnderscores(ci.escapedName));
                  return ci.parent ? e.factory.createQualifiedName(Ra(ci.parent), Fr) : Fr;
                }
                function ca(ci, Fr, jt, Lt) {
                  var ea = Ti(ci, Fr, jt, !(Fr.flags & 16384)), Kt = jt === 111551;
                  if (e.some(ea[0].declarations, Fc)) {
                    var $t = ea.length > 1 ? Po(ea, ea.length - 1, 1) : void 0, Ua = Lt || Zi(ea, 0, Fr), Yr = e.getSourceFileOfNode(e.getOriginalNode(Fr.enclosingDeclaration)), Ni = e.getSourceFileOfModule(ea[0]), Hi = void 0, _t = void 0;
                    if ((e.getEmitModuleResolutionKind(ye) === e.ModuleResolutionKind.Node16 || e.getEmitModuleResolutionKind(ye) === e.ModuleResolutionKind.NodeNext) && (Ni == null ? void 0 : Ni.impliedNodeFormat) === e.ModuleKind.ESNext && Ni.impliedNodeFormat !== (Yr == null ? void 0 : Yr.impliedNodeFormat) && (Hi = Nt(ea[0], Fr, e.ModuleKind.ESNext), _t = e.factory.createImportTypeAssertionContainer(e.factory.createAssertClause(e.factory.createNodeArray([e.factory.createAssertEntry(e.factory.createStringLiteral("resolution-mode"), e.factory.createStringLiteral("import"))])))), Hi || (Hi = Nt(ea[0], Fr)), !(Fr.flags & 67108864) && e.getEmitModuleResolutionKind(ye) !== e.ModuleResolutionKind.Classic && Hi.indexOf("/node_modules/") >= 0) {
                      var gt = Hi;
                      if (e.getEmitModuleResolutionKind(ye) === e.ModuleResolutionKind.Node16 || e.getEmitModuleResolutionKind(ye) === e.ModuleResolutionKind.NodeNext) {
                        var Vt = (Yr == null ? void 0 : Yr.impliedNodeFormat) === e.ModuleKind.ESNext ? e.ModuleKind.CommonJS : e.ModuleKind.ESNext;
                        Hi = Nt(ea[0], Fr, Vt), Hi.indexOf("/node_modules/") >= 0 ? Hi = gt : _t = e.factory.createImportTypeAssertionContainer(e.factory.createAssertClause(e.factory.createNodeArray([e.factory.createAssertEntry(e.factory.createStringLiteral("resolution-mode"), e.factory.createStringLiteral(Vt === e.ModuleKind.ESNext ? "import" : "require"))])));
                      }
                      _t || (Fr.encounteredError = true, Fr.tracker.reportLikelyUnsafeImportRequiredError && Fr.tracker.reportLikelyUnsafeImportRequiredError(gt));
                    }
                    var Fa = e.factory.createLiteralTypeNode(e.factory.createStringLiteral(Hi));
                    if (Fr.tracker.trackExternalModuleSymbolOfImportTypeNode && Fr.tracker.trackExternalModuleSymbolOfImportTypeNode(ea[0]), Fr.approximateLength += Hi.length + 10, !$t || e.isEntityName($t)) {
                      if ($t) {
                        var on = e.isIdentifier($t) ? $t : $t.right;
                        on.typeArguments = void 0;
                      }
                      return e.factory.createImportTypeNode(Fa, _t, $t, Ua, Kt);
                    } else {
                      var zn = qt($t), Ga = zn.objectType.typeName;
                      return e.factory.createIndexedAccessTypeNode(e.factory.createImportTypeNode(Fa, _t, Ga, Ua, Kt), zn.indexType);
                    }
                  }
                  var Qn = Po(ea, ea.length - 1, 0);
                  if (e.isIndexedAccessTypeNode(Qn)) return Qn;
                  if (Kt) return e.factory.createTypeQueryNode(Qn);
                  var on = e.isIdentifier(Qn) ? Qn : Qn.right, wo = on.typeArguments;
                  return on.typeArguments = void 0, e.factory.createTypeReferenceNode(Qn, wo);
                  function Po(Uo, Rs, Fs) {
                    var rc = Rs === Uo.length - 1 ? Lt : Zi(Uo, Rs, Fr), xu = Uo[Rs], Ts = Uo[Rs - 1], rl;
                    if (Rs === 0) Fr.flags |= 16777216, rl = of(xu, Fr), Fr.approximateLength += (rl ? rl.length : 0) + 1, Fr.flags ^= 16777216;
                    else if (Ts && dc(Ts)) {
                      var jd = dc(Ts);
                      e.forEachEntry(jd, function(zg, id) {
                        if (_l(zg, xu) && !pg(id) && id !== "export=") return rl = e.unescapeLeadingUnderscores(id), true;
                      });
                    }
                    if (rl === void 0) {
                      var lp = e.firstDefined(xu.declarations, e.getNameOfDeclaration);
                      if (lp && e.isComputedPropertyName(lp) && e.isEntityName(lp.expression)) {
                        var Tl = Po(Uo, Rs - 1, Fs);
                        return e.isEntityName(Tl) ? e.factory.createIndexedAccessTypeNode(e.factory.createParenthesizedType(e.factory.createTypeQueryNode(Tl)), e.factory.createTypeQueryNode(lp.expression)) : Tl;
                      }
                      rl = of(xu, Fr);
                    }
                    if (Fr.approximateLength += rl.length + 1, !(Fr.flags & 16) && Ts && Nf(Ts) && Nf(Ts).get(xu.escapedName) && _l(Nf(Ts).get(xu.escapedName), xu)) {
                      var Tl = Po(Uo, Rs - 1, Fs);
                      return e.isIndexedAccessTypeNode(Tl) ? e.factory.createIndexedAccessTypeNode(Tl, e.factory.createLiteralTypeNode(e.factory.createStringLiteral(rl))) : e.factory.createIndexedAccessTypeNode(e.factory.createTypeReferenceNode(Tl, rc), e.factory.createLiteralTypeNode(e.factory.createStringLiteral(rl)));
                    }
                    var fp = e.setEmitFlags(e.factory.createIdentifier(rl, rc), 16777216);
                    if (fp.symbol = xu, Rs > Fs) {
                      var Tl = Po(Uo, Rs - 1, Fs);
                      return e.isEntityName(Tl) ? e.factory.createQualifiedName(Tl, fp) : e.Debug.fail("Impossible construct - an export of an indexed access cannot be reachable");
                    }
                    return fp;
                  }
                }
                function Sn(ci, Fr, jt) {
                  var Lt = es(Fr.enclosingDeclaration, ci, 788968, void 0, ci, false);
                  return Lt ? !(Lt.flags & 262144 && Lt === jt.symbol) : false;
                }
                function ja(ci, Fr) {
                  var jt, Lt;
                  if (Fr.flags & 4 && Fr.typeParameterNames) {
                    var ea = Fr.typeParameterNames.get(fu(ci));
                    if (ea) return ea;
                  }
                  var Kt = Fn(ci.symbol, Fr, 788968, true);
                  if (!(Kt.kind & 79)) return e.factory.createIdentifier("(Missing type parameter)");
                  if (Fr.flags & 4) {
                    for (var $t = Kt.escapedText, Ua = ((jt = Fr.typeParameterNamesByTextNextNameCount) === null || jt === void 0 ? void 0 : jt.get($t)) || 0, Yr = $t; ((Lt = Fr.typeParameterNamesByText) === null || Lt === void 0 ? void 0 : Lt.has(Yr)) || Sn(Yr, Fr, ci); ) Ua++, Yr = "".concat($t, "_").concat(Ua);
                    Yr !== $t && (Kt = e.factory.createIdentifier(Yr, Kt.typeArguments)), (Fr.typeParameterNamesByTextNextNameCount || (Fr.typeParameterNamesByTextNextNameCount = new e.Map())).set($t, Ua), (Fr.typeParameterNames || (Fr.typeParameterNames = new e.Map())).set(fu(ci), Kt), (Fr.typeParameterNamesByText || (Fr.typeParameterNamesByText = new e.Set())).add($t);
                  }
                  return Kt;
                }
                function Fn(ci, Fr, jt, Lt) {
                  var ea = Ti(ci, Fr, jt);
                  return Lt && ea.length !== 1 && !Fr.encounteredError && !(Fr.flags & 65536) && (Fr.encounteredError = true), Kt(ea, ea.length - 1);
                  function Kt($t, Ua) {
                    var Yr = Zi($t, Ua, Fr), Ni = $t[Ua];
                    Ua === 0 && (Fr.flags |= 16777216);
                    var Hi = of(Ni, Fr);
                    Ua === 0 && (Fr.flags ^= 16777216);
                    var _t = e.setEmitFlags(e.factory.createIdentifier(Hi, Yr), 16777216);
                    return _t.symbol = Ni, Ua > 0 ? e.factory.createQualifiedName(Kt($t, Ua - 1), _t) : _t;
                  }
                }
                function wn(ci, Fr, jt) {
                  var Lt = Ti(ci, Fr, jt);
                  return ea(Lt, Lt.length - 1);
                  function ea(Kt, $t) {
                    var Ua = Zi(Kt, $t, Fr), Yr = Kt[$t];
                    $t === 0 && (Fr.flags |= 16777216);
                    var Ni = of(Yr, Fr);
                    $t === 0 && (Fr.flags ^= 16777216);
                    var Hi = Ni.charCodeAt(0);
                    if (e.isSingleOrDoubleQuote(Hi) && e.some(Yr.declarations, Fc)) return e.factory.createStringLiteral(Nt(Yr, Fr));
                    var _t = Hi === 35 ? Ni.length > 1 && e.isIdentifierStart(Ni.charCodeAt(1), Ae) : e.isIdentifierStart(Hi, Ae);
                    if ($t === 0 || _t) {
                      var gt = e.setEmitFlags(e.factory.createIdentifier(Ni, Ua), 16777216);
                      return gt.symbol = Yr, $t > 0 ? e.factory.createPropertyAccessExpression(ea(Kt, $t - 1), gt) : gt;
                    } else {
                      Hi === 91 && (Ni = Ni.substring(1, Ni.length - 1), Hi = Ni.charCodeAt(0));
                      var Vt = void 0;
                      return e.isSingleOrDoubleQuote(Hi) && !(Yr.flags & 8) ? Vt = e.factory.createStringLiteral(e.stripQuotes(Ni).replace(/\\./g, function(Fa) {
                        return Fa.substring(1);
                      }), Hi === 39) : "" + +Ni === Ni && (Vt = e.factory.createNumericLiteral(+Ni)), Vt || (Vt = e.setEmitFlags(e.factory.createIdentifier(Ni, Ua), 16777216), Vt.symbol = Yr), e.factory.createElementAccessExpression(ea(Kt, $t - 1), Vt);
                    }
                  }
                }
                function Tn(ci) {
                  var Fr = e.getNameOfDeclaration(ci);
                  return !!Fr && e.isStringLiteral(Fr);
                }
                function Eo(ci) {
                  var Fr = e.getNameOfDeclaration(ci);
                  return !!(Fr && e.isStringLiteral(Fr) && (Fr.singleQuote || !e.nodeIsSynthesized(Fr) && e.startsWith(e.getTextOfNode(Fr, false), "'")));
                }
                function lt(ci, Fr) {
                  var jt = !!e.length(ci.declarations) && e.every(ci.declarations, Eo), Lt = it(ci, Fr, jt);
                  if (Lt) return Lt;
                  var ea = e.unescapeLeadingUnderscores(ci.escapedName), Kt = !!e.length(ci.declarations) && e.every(ci.declarations, Tn);
                  return e.createPropertyNameNodeForIdentifierOrLiteral(ea, e.getEmitScriptTarget(ye), jt, Kt);
                }
                function it(ci, Fr, jt) {
                  var Lt = Aa(ci).nameType;
                  if (Lt) {
                    if (Lt.flags & 384) {
                      var ea = "" + Lt.value;
                      return !e.isIdentifierText(ea, e.getEmitScriptTarget(ye)) && !e.isNumericLiteralName(ea) ? e.factory.createStringLiteral(ea, !!jt) : e.isNumericLiteralName(ea) && e.startsWith(ea, "-") ? e.factory.createComputedPropertyName(e.factory.createNumericLiteral(+ea)) : e.createPropertyNameNodeForIdentifierOrLiteral(ea, e.getEmitScriptTarget(ye));
                    }
                    if (Lt.flags & 8192) return e.factory.createComputedPropertyName(wn(Lt.symbol, Fr, 111551));
                  }
                }
                function Yt(ci) {
                  var Fr = Ke({}, ci);
                  return Fr.typeParameterNames && (Fr.typeParameterNames = new e.Map(Fr.typeParameterNames)), Fr.typeParameterNamesByText && (Fr.typeParameterNamesByText = new e.Set(Fr.typeParameterNamesByText)), Fr.typeParameterSymbolList && (Fr.typeParameterSymbolList = new e.Set(Fr.typeParameterSymbolList)), Fr.tracker = i(Fr, Fr.tracker), Fr;
                }
                function Ia(ci, Fr) {
                  return ci.declarations && e.find(ci.declarations, function(jt) {
                    return !!e.getEffectiveTypeAnnotationNode(jt) && (!Fr || !!e.findAncestor(jt, function(Lt) {
                      return Lt === Fr;
                    }));
                  });
                }
                function Qt(ci, Fr) {
                  return !(e.getObjectFlags(Fr) & 4) || !e.isTypeReferenceNode(ci) || e.length(ci.typeArguments) >= Ul(Fr.target.typeParameters);
                }
                function Ka(ci, Fr, jt, Lt, ea, Kt) {
                  if (!nn(Fr) && Lt) {
                    var $t = Ia(jt, Lt);
                    if ($t && !e.isFunctionLikeDeclaration($t) && !e.isGetAccessorDeclaration($t)) {
                      var Ua = e.getEffectiveTypeAnnotationNode($t);
                      if (cn(Ua, $t, Fr) && Qt(Ua, Fr)) {
                        var Yr = Mn(ci, Ua, ea, Kt);
                        if (Yr) return Yr;
                      }
                    }
                  }
                  var Ni = ci.flags;
                  Fr.flags & 8192 && Fr.symbol === jt && (!ci.enclosingDeclaration || e.some(jt.declarations, function(_t) {
                    return e.getSourceFileOfNode(_t) === e.getSourceFileOfNode(ci.enclosingDeclaration);
                  })) && (ci.flags |= 1048576);
                  var Hi = o(Fr, ci);
                  return ci.flags = Ni, Hi;
                }
                function cn(ci, Fr, jt) {
                  var Lt = Va(ci);
                  return Lt === jt ? true : e.isParameter(Fr) && Fr.questionToken ? Ks(jt, 524288) === Lt : false;
                }
                function Un(ci, Fr, jt, Lt, ea) {
                  if (!nn(Fr) && ci.enclosingDeclaration) {
                    var Kt = jt.declaration && e.getEffectiveReturnTypeNode(jt.declaration);
                    if (!!e.findAncestor(Kt, function(Ni) {
                      return Ni === ci.enclosingDeclaration;
                    }) && Kt) {
                      var $t = Va(Kt), Ua = $t.flags & 262144 && $t.isThisType ? un($t, jt.mapper) : $t;
                      if (Ua === Fr && Qt(Kt, Fr)) {
                        var Yr = Mn(ci, Kt, Lt, ea);
                        if (Yr) return Yr;
                      }
                    }
                  }
                  return o(Fr, ci);
                }
                function oa(ci, Fr, jt) {
                  var Lt, ea, Kt = false, $t = e.getFirstIdentifier(ci);
                  if (e.isInJSFile(ci) && (e.isExportsIdentifier($t) || e.isModuleExportsAccessExpression($t.parent) || e.isQualifiedName($t.parent) && e.isModuleIdentifier($t.parent.left) && e.isExportsIdentifier($t.parent.right))) return Kt = true, { introducesError: Kt, node: ci };
                  var Ua = Ds($t, 67108863, true, true);
                  if (Ua && (g_(Ua, Fr.enclosingDeclaration, 67108863, false).accessibility !== 0 ? Kt = true : ((ea = (Lt = Fr.tracker) === null || Lt === void 0 ? void 0 : Lt.trackSymbol) === null || ea === void 0 || ea.call(Lt, Ua, Fr.enclosingDeclaration, 67108863), jt == null || jt(Ua)), e.isIdentifier(ci))) {
                    var Yr = go(Ua), Ni = Ua.flags & 262144 && !Gu(Yr.symbol, Fr.enclosingDeclaration) ? ja(Yr, Fr) : e.factory.cloneNode(ci);
                    return Ni.symbol = Ua, { introducesError: Kt, node: e.setEmitFlags(e.setOriginalNode(Ni, ci), 16777216) };
                  }
                  return { introducesError: Kt, node: ci };
                }
                function Mn(ci, Fr, jt, Lt) {
                  g && g.throwIfCancellationRequested && g.throwIfCancellationRequested();
                  var ea = false, Kt = e.getSourceFileOfNode(Fr), $t = e.visitNode(Fr, Ua);
                  if (ea) return;
                  return $t === Fr ? e.setTextRange(e.factory.cloneNode(Fr), Fr) : $t;
                  function Ua(Yr) {
                    if (e.isJSDocAllType(Yr) || Yr.kind === 319) return e.factory.createKeywordTypeNode(130);
                    if (e.isJSDocUnknownType(Yr)) return e.factory.createKeywordTypeNode(155);
                    if (e.isJSDocNullableType(Yr)) return e.factory.createUnionTypeNode([e.visitNode(Yr.type, Ua), e.factory.createLiteralTypeNode(e.factory.createNull())]);
                    if (e.isJSDocOptionalType(Yr)) return e.factory.createUnionTypeNode([e.visitNode(Yr.type, Ua), e.factory.createKeywordTypeNode(153)]);
                    if (e.isJSDocNonNullableType(Yr)) return e.visitNode(Yr.type, Ua);
                    if (e.isJSDocVariadicType(Yr)) return e.factory.createArrayTypeNode(e.visitNode(Yr.type, Ua));
                    if (e.isJSDocTypeLiteral(Yr)) return e.factory.createTypeLiteralNode(e.map(Yr.jsDocPropertyTags, function(Ga) {
                      var Qn = e.isIdentifier(Ga.name) ? Ga.name : Ga.name.right, wo = da(Va(Yr), Qn.escapedText), Po = wo && Ga.typeExpression && Va(Ga.typeExpression.type) !== wo ? o(wo, ci) : void 0;
                      return e.factory.createPropertySignature(void 0, Qn, Ga.isBracketed || Ga.typeExpression && e.isJSDocOptionalType(Ga.typeExpression.type) ? e.factory.createToken(57) : void 0, Po || Ga.typeExpression && e.visitNode(Ga.typeExpression.type, Ua) || e.factory.createKeywordTypeNode(130));
                    }));
                    if (e.isTypeReferenceNode(Yr) && e.isIdentifier(Yr.typeName) && Yr.typeName.escapedText === "") return e.setOriginalNode(e.factory.createKeywordTypeNode(130), Yr);
                    if ((e.isExpressionWithTypeArguments(Yr) || e.isTypeReferenceNode(Yr)) && e.isJSDocIndexSignature(Yr)) return e.factory.createTypeLiteralNode([e.factory.createIndexSignature(void 0, void 0, [e.factory.createParameterDeclaration(void 0, void 0, void 0, "x", void 0, e.visitNode(Yr.typeArguments[0], Ua))], e.visitNode(Yr.typeArguments[1], Ua))]);
                    if (e.isJSDocFunctionType(Yr)) if (e.isJSDocConstructSignature(Yr)) {
                      var Ni;
                      return e.factory.createConstructorTypeNode(Yr.modifiers, e.visitNodes(Yr.typeParameters, Ua), e.mapDefined(Yr.parameters, function(Ga, Qn) {
                        return Ga.name && e.isIdentifier(Ga.name) && Ga.name.escapedText === "new" ? (Ni = Ga.type, void 0) : e.factory.createParameterDeclaration(void 0, void 0, Fa(Ga), on(Ga, Qn), Ga.questionToken, e.visitNode(Ga.type, Ua), void 0);
                      }), e.visitNode(Ni || Yr.type, Ua) || e.factory.createKeywordTypeNode(130));
                    } else return e.factory.createFunctionTypeNode(e.visitNodes(Yr.typeParameters, Ua), e.map(Yr.parameters, function(Ga, Qn) {
                      return e.factory.createParameterDeclaration(void 0, void 0, Fa(Ga), on(Ga, Qn), Ga.questionToken, e.visitNode(Ga.type, Ua), void 0);
                    }), e.visitNode(Yr.type, Ua) || e.factory.createKeywordTypeNode(130));
                    if (e.isTypeReferenceNode(Yr) && e.isInJSDoc(Yr) && (!Qt(Yr, Va(Yr)) || vx(Yr) || xe === nm(Yr, 788968, true))) return e.setOriginalNode(o(Va(Yr), ci), Yr);
                    if (e.isLiteralImportTypeNode(Yr)) {
                      var Hi = va(Yr).resolvedSymbol;
                      return e.isInJSDoc(Yr) && Hi && (!Yr.isTypeOf && !(Hi.flags & 788968) || !(e.length(Yr.typeArguments) >= Ul(Af(Hi)))) ? e.setOriginalNode(o(Va(Yr), ci), Yr) : e.factory.updateImportTypeNode(Yr, e.factory.updateLiteralTypeNode(Yr.argument, zn(Yr, Yr.argument.literal)), Yr.qualifier, e.visitNodes(Yr.typeArguments, Ua, e.isTypeNode), Yr.isTypeOf);
                    }
                    if (e.isEntityName(Yr) || e.isEntityNameExpression(Yr)) {
                      var _t = oa(Yr, ci, jt), gt = _t.introducesError, Vt = _t.node;
                      if (ea = ea || gt, Vt !== Yr) return Vt;
                    }
                    return Kt && e.isTupleTypeNode(Yr) && e.getLineAndCharacterOfPosition(Kt, Yr.pos).line === e.getLineAndCharacterOfPosition(Kt, Yr.end).line && e.setEmitFlags(Yr, 1), e.visitEachChild(Yr, Ua, e.nullTransformationContext);
                    function Fa(Ga) {
                      return Ga.dotDotDotToken || (Ga.type && e.isJSDocVariadicType(Ga.type) ? e.factory.createToken(25) : void 0);
                    }
                    function on(Ga, Qn) {
                      return Ga.name && e.isIdentifier(Ga.name) && Ga.name.escapedText === "this" ? "this" : Fa(Ga) ? "args" : "arg".concat(Qn);
                    }
                    function zn(Ga, Qn) {
                      if (Lt) {
                        if (ci.tracker && ci.tracker.moduleResolverHost) {
                          var wo = US(Ga);
                          if (wo) {
                            var Po = e.createGetCanonicalFileName(!!l.useCaseSensitiveFileNames), Uo = { getCanonicalFileName: Po, getCurrentDirectory: function() {
                              return ci.tracker.moduleResolverHost.getCurrentDirectory();
                            }, getCommonSourceDirectory: function() {
                              return ci.tracker.moduleResolverHost.getCommonSourceDirectory();
                            } }, Rs = e.getResolvedExternalModuleName(Uo, wo);
                            return e.factory.createStringLiteral(Rs);
                          }
                        }
                      } else if (ci.tracker && ci.tracker.trackExternalModuleSymbolOfImportTypeNode) {
                        var Fs = Pl(Qn, Qn, void 0);
                        Fs && ci.tracker.trackExternalModuleSymbolOfImportTypeNode(Fs);
                      }
                      return Qn;
                    }
                  }
                }
                function Ln(ci, Fr, jt) {
                  var Lt = Ca(e.factory.createPropertyDeclaration, 169, true), ea = Ca(function(gi, zt, La, fa, ya) {
                    return e.factory.createPropertySignature(zt, La, fa, ya);
                  }, 168, false), Kt = Fr.enclosingDeclaration, $t = [], Ua = new e.Set(), Yr = [], Ni = Fr;
                  Fr = Ke(Ke({}, Ni), { usedSymbolNames: new e.Set(Ni.usedSymbolNames), remappedSymbolNames: new e.Map(), tracker: Ke(Ke({}, Ni.tracker), { trackSymbol: function(gi, zt, La) {
                    var fa = g_(gi, zt, La, false);
                    if (fa.accessibility === 0) {
                      var ya = Ci(gi, Fr, La);
                      gi.flags & 4 || rc(ya[0]);
                    } else if (Ni.tracker && Ni.tracker.trackSymbol) return Ni.tracker.trackSymbol(gi, zt, La);
                    return false;
                  } }) }), Fr.tracker = i(Fr, Fr.tracker), e.forEachEntry(ci, function(gi, zt) {
                    var La = e.unescapeLeadingUnderscores(zt);
                    ls(gi, La);
                  });
                  var Hi = !jt, _t = ci.get("export=");
                  return _t && ci.size > 1 && _t.flags & 2097152 && (ci = e.createSymbolTable(), ci.set("export=", _t)), Uo(ci), Ga($t);
                  function gt(gi) {
                    return !!gi && gi.kind === 79;
                  }
                  function Vt(gi) {
                    return e.isVariableStatement(gi) ? e.filter(e.map(gi.declarationList.declarations, e.getNameOfDeclaration), gt) : e.filter([e.getNameOfDeclaration(gi)], gt);
                  }
                  function Fa(gi) {
                    var zt = e.find(gi, e.isExportAssignment), La = e.findIndex(gi, e.isModuleDeclaration), fa = La !== -1 ? gi[La] : void 0;
                    if (fa && zt && zt.isExportEquals && e.isIdentifier(zt.expression) && e.isIdentifier(fa.name) && e.idText(fa.name) === e.idText(zt.expression) && fa.body && e.isModuleBlock(fa.body)) {
                      var ya = e.filter(gi, function(sn) {
                        return !!(e.getEffectiveModifierFlags(sn) & 1);
                      }), Nn = fa.name, fn = fa.body;
                      if (e.length(ya) && (fa = e.factory.updateModuleDeclaration(fa, fa.decorators, fa.modifiers, fa.name, fn = e.factory.updateModuleBlock(fn, e.factory.createNodeArray(Ve(Ve([], fa.body.statements, true), [e.factory.createExportDeclaration(void 0, void 0, false, e.factory.createNamedExports(e.map(e.flatMap(ya, function(sn) {
                        return Vt(sn);
                      }), function(sn) {
                        return e.factory.createExportSpecifier(false, void 0, sn);
                      })), void 0)], false)))), gi = Ve(Ve(Ve([], gi.slice(0, La), true), [fa], false), gi.slice(La + 1), true)), !e.find(gi, function(sn) {
                        return sn !== fa && e.nodeHasName(sn, Nn);
                      })) {
                        $t = [];
                        var hn = !e.some(fn.statements, function(sn) {
                          return e.hasSyntacticModifier(sn, 1) || e.isExportAssignment(sn) || e.isExportDeclaration(sn);
                        });
                        e.forEach(fn.statements, function(sn) {
                          Ts(sn, hn ? 1 : 0);
                        }), gi = Ve(Ve([], e.filter(gi, function(sn) {
                          return sn !== fa && sn !== zt;
                        }), true), $t, true);
                      }
                    }
                    return gi;
                  }
                  function on(gi) {
                    var zt = e.filter(gi, function(ln) {
                      return e.isExportDeclaration(ln) && !ln.moduleSpecifier && !!ln.exportClause && e.isNamedExports(ln.exportClause);
                    });
                    if (e.length(zt) > 1) {
                      var La = e.filter(gi, function(ln) {
                        return !e.isExportDeclaration(ln) || !!ln.moduleSpecifier || !ln.exportClause;
                      });
                      gi = Ve(Ve([], La, true), [e.factory.createExportDeclaration(void 0, void 0, false, e.factory.createNamedExports(e.flatMap(zt, function(ln) {
                        return e.cast(ln.exportClause, e.isNamedExports).elements;
                      })), void 0)], false);
                    }
                    var fa = e.filter(gi, function(ln) {
                      return e.isExportDeclaration(ln) && !!ln.moduleSpecifier && !!ln.exportClause && e.isNamedExports(ln.exportClause);
                    });
                    if (e.length(fa) > 1) {
                      var ya = e.group(fa, function(ln) {
                        return e.isStringLiteral(ln.moduleSpecifier) ? ">" + ln.moduleSpecifier.text : ">";
                      });
                      if (ya.length !== fa.length) for (var Nn = function(ln) {
                        ln.length > 1 && (gi = Ve(Ve([], e.filter(gi, function(lo) {
                          return ln.indexOf(lo) === -1;
                        }), true), [e.factory.createExportDeclaration(void 0, void 0, false, e.factory.createNamedExports(e.flatMap(ln, function(lo) {
                          return e.cast(lo.exportClause, e.isNamedExports).elements;
                        })), ln[0].moduleSpecifier)], false));
                      }, fn = 0, hn = ya; fn < hn.length; fn++) {
                        var sn = hn[fn];
                        Nn(sn);
                      }
                    }
                    return gi;
                  }
                  function zn(gi) {
                    var zt = e.findIndex(gi, function(ya) {
                      return e.isExportDeclaration(ya) && !ya.moduleSpecifier && !ya.assertClause && !!ya.exportClause && e.isNamedExports(ya.exportClause);
                    });
                    if (zt >= 0) {
                      var La = gi[zt], fa = e.mapDefined(La.exportClause.elements, function(ya) {
                        if (!ya.propertyName) {
                          var Nn = e.indicesOf(gi), fn = e.filter(Nn, function(lo) {
                            return e.nodeHasName(gi[lo], ya.name);
                          });
                          if (e.length(fn) && e.every(fn, function(lo) {
                            return Qn(gi[lo]);
                          })) {
                            for (var hn = 0, sn = fn; hn < sn.length; hn++) {
                              var ln = sn[hn];
                              gi[ln] = wo(gi[ln]);
                            }
                            return;
                          }
                        }
                        return ya;
                      });
                      e.length(fa) ? gi[zt] = e.factory.updateExportDeclaration(La, La.decorators, La.modifiers, La.isTypeOnly, e.factory.updateNamedExports(La.exportClause, fa), La.moduleSpecifier, La.assertClause) : e.orderedRemoveItemAt(gi, zt);
                    }
                    return gi;
                  }
                  function Ga(gi) {
                    return gi = Fa(gi), gi = on(gi), gi = zn(gi), Kt && (e.isSourceFile(Kt) && e.isExternalOrCommonJsModule(Kt) || e.isModuleDeclaration(Kt)) && (!e.some(gi, e.isExternalModuleIndicator) || !e.hasScopeMarker(gi) && e.some(gi, e.needsScopeMarker)) && gi.push(e.createEmptyExports(e.factory)), gi;
                  }
                  function Qn(gi) {
                    return e.isEnumDeclaration(gi) || e.isVariableStatement(gi) || e.isFunctionDeclaration(gi) || e.isClassDeclaration(gi) || e.isModuleDeclaration(gi) && !e.isExternalModuleAugmentation(gi) && !e.isGlobalScopeAugmentation(gi) || e.isInterfaceDeclaration(gi) || zy(gi);
                  }
                  function wo(gi) {
                    var zt = (e.getEffectiveModifierFlags(gi) | 1) & -3;
                    return e.factory.updateModifiers(gi, zt);
                  }
                  function Po(gi) {
                    var zt = e.getEffectiveModifierFlags(gi) & -2;
                    return e.factory.updateModifiers(gi, zt);
                  }
                  function Uo(gi, zt, La) {
                    zt || Yr.push(new e.Map()), gi.forEach(function(fa) {
                      Rs(fa, false, !!La);
                    }), zt || (Yr[Yr.length - 1].forEach(function(fa) {
                      Rs(fa, true, !!La);
                    }), Yr.pop());
                  }
                  function Rs(gi, zt, La) {
                    var fa = so(gi);
                    if (!Ua.has(y(fa))) {
                      Ua.add(y(fa));
                      var ya = !zt;
                      if (ya || !!e.length(gi.declarations) && e.some(gi.declarations, function(hn) {
                        return !!e.findAncestor(hn, function(sn) {
                          return sn === Kt;
                        });
                      })) {
                        var Nn = Fr;
                        Fr = Yt(Fr);
                        var fn = Fs(gi, zt, La);
                        return Fr.reportedDiagnostic && (Ni.reportedDiagnostic = Fr.reportedDiagnostic), Fr = Nn, fn;
                      }
                    }
                  }
                  function Fs(gi, zt, La) {
                    var fa, ya, Nn, fn, hn = e.unescapeLeadingUnderscores(gi.escapedName), sn = gi.escapedName === "default";
                    if (zt && !(Fr.flags & 131072) && e.isStringANonContextualKeyword(hn) && !sn) {
                      Fr.encounteredError = true;
                      return;
                    }
                    var ln = sn && !!(gi.flags & -113 || gi.flags & 16 && e.length(uo(Jt(gi)))) && !(gi.flags & 2097152), lo = !ln && !zt && e.isStringANonContextualKeyword(hn) && !sn;
                    (ln || lo) && (zt = true);
                    var _o = (zt ? 0 : 1) | (sn && !ln ? 512 : 0), _s = gi.flags & 1536 && gi.flags & 7 && gi.escapedName !== "export=", Vo = _s && ma(Jt(gi), gi);
                    if ((gi.flags & 8208 || Vo) && id(Jt(gi), gi, ls(gi, hn), _o), gi.flags & 524288 && rl(gi, hn, _o), gi.flags & 7 && gi.escapedName !== "export=" && !(gi.flags & 4194304) && !(gi.flags & 32) && !Vo) if (La) {
                      var Yo = ht(gi);
                      Yo && (lo = false, ln = false);
                    } else {
                      var Cs = Jt(gi), ic = ls(gi, hn);
                      if (!(gi.flags & 16) && ma(Cs, gi)) id(Cs, gi, ic, _o);
                      else {
                        var _c = gi.flags & 2 ? pv(gi) ? 2 : 1 : ((fa = gi.parent) === null || fa === void 0 ? void 0 : fa.valueDeclaration) && e.isSourceFile((ya = gi.parent) === null || ya === void 0 ? void 0 : ya.valueDeclaration) ? 2 : void 0, il = ln || !(gi.flags & 4) ? ic : Io(ic, gi), n_ = gi.declarations && e.find(gi.declarations, function(pp) {
                          return e.isVariableDeclaration(pp);
                        });
                        n_ && e.isVariableDeclarationList(n_.parent) && n_.parent.declarations.length === 1 && (n_ = n_.parent.parent);
                        var o_ = (Nn = gi.declarations) === null || Nn === void 0 ? void 0 : Nn.find(e.isPropertyAccessExpression);
                        if (o_ && e.isBinaryExpression(o_.parent) && e.isIdentifier(o_.parent.right) && ((fn = Cs.symbol) === null || fn === void 0 ? void 0 : fn.valueDeclaration) && e.isSourceFile(Cs.symbol.valueDeclaration)) {
                          var og = ic === o_.parent.right.escapedText ? void 0 : o_.parent.right;
                          Ts(e.factory.createExportDeclaration(void 0, void 0, false, e.factory.createNamedExports([e.factory.createExportSpecifier(false, og, ic)])), 0), Fr.tracker.trackSymbol(Cs.symbol, Fr.enclosingDeclaration, 111551);
                        } else {
                          var _p = e.setTextRange(e.factory.createVariableStatement(void 0, e.factory.createVariableDeclarationList([e.factory.createVariableDeclaration(il, void 0, Ka(Fr, Cs, gi, Kt, rc, jt))], _c)), n_);
                          Ts(_p, il !== ic ? _o & -2 : _o), il !== ic && !zt && (Ts(e.factory.createExportDeclaration(void 0, void 0, false, e.factory.createNamedExports([e.factory.createExportSpecifier(false, il, ic)])), 0), lo = false, ln = false);
                        }
                      }
                    }
                    if (gi.flags & 384 && zg(gi, hn, _o), gi.flags & 32 && (gi.flags & 4 && gi.valueDeclaration && e.isBinaryExpression(gi.valueDeclaration.parent) && e.isClassExpression(gi.valueDeclaration.parent.right) ? Ht(gi, ls(gi, hn), _o) : mt(gi, ls(gi, hn), _o)), (gi.flags & 1536 && (!_s || Tl(gi)) || Vo) && fp(gi, hn, _o), gi.flags & 64 && !(gi.flags & 32) && jd(gi, hn, _o), gi.flags & 2097152 && Ht(gi, ls(gi, hn), _o), gi.flags & 4 && gi.escapedName === "export=" && ht(gi), gi.flags & 8388608 && gi.declarations) for (var td = 0, s_ = gi.declarations; td < s_.length; td++) {
                      var sg = s_[td], Nc = ac(sg, sg.moduleSpecifier);
                      !Nc || Ts(e.factory.createExportDeclaration(void 0, void 0, false, void 0, e.factory.createStringLiteral(Nt(Nc, Fr))), 0);
                    }
                    ln ? Ts(e.factory.createExportAssignment(void 0, void 0, false, e.factory.createIdentifier(ls(gi, hn))), 0) : lo && Ts(e.factory.createExportDeclaration(void 0, void 0, false, e.factory.createNamedExports([e.factory.createExportSpecifier(false, ls(gi, hn), hn)])), 0);
                  }
                  function rc(gi) {
                    if (!e.some(gi.declarations, e.isParameterDeclaration)) {
                      e.Debug.assertIsDefined(Yr[Yr.length - 1]), Io(e.unescapeLeadingUnderscores(gi.escapedName), gi);
                      var zt = !!(gi.flags & 2097152) && !e.some(gi.declarations, function(La) {
                        return !!e.findAncestor(La, e.isExportDeclaration) || e.isNamespaceExport(La) || e.isImportEqualsDeclaration(La) && !e.isExternalModuleReference(La.moduleReference);
                      });
                      Yr[zt ? 0 : Yr.length - 1].set(y(gi), gi);
                    }
                  }
                  function xu(gi) {
                    return e.isSourceFile(gi) && (e.isExternalOrCommonJsModule(gi) || e.isJsonSourceFile(gi)) || e.isAmbientModule(gi) && !e.isGlobalScopeAugmentation(gi);
                  }
                  function Ts(gi, zt) {
                    if (e.canHaveModifiers(gi)) {
                      var La = 0, fa = Fr.enclosingDeclaration && (e.isJSDocTypeAlias(Fr.enclosingDeclaration) ? e.getSourceFileOfNode(Fr.enclosingDeclaration) : Fr.enclosingDeclaration);
                      zt & 1 && fa && (xu(fa) || e.isModuleDeclaration(fa)) && Qn(gi) && (La |= 1), Hi && !(La & 1) && (!fa || !(fa.flags & 16777216)) && (e.isEnumDeclaration(gi) || e.isVariableStatement(gi) || e.isFunctionDeclaration(gi) || e.isClassDeclaration(gi) || e.isModuleDeclaration(gi)) && (La |= 2), zt & 512 && (e.isClassDeclaration(gi) || e.isInterfaceDeclaration(gi) || e.isFunctionDeclaration(gi)) && (La |= 512), La && (gi = e.factory.updateModifiers(gi, La | e.getEffectiveModifierFlags(gi)));
                    }
                    $t.push(gi);
                  }
                  function rl(gi, zt, La) {
                    var fa, ya = Ja(gi), Nn = Aa(gi).typeParameters, fn = e.map(Nn, function(_s) {
                      return Dr(_s, Fr);
                    }), hn = (fa = gi.declarations) === null || fa === void 0 ? void 0 : fa.find(e.isJSDocTypeAlias), sn = e.getTextOfJSDocComment(hn ? hn.comment || hn.parent.comment : void 0), ln = Fr.flags;
                    Fr.flags |= 8388608;
                    var lo = Fr.enclosingDeclaration;
                    Fr.enclosingDeclaration = hn;
                    var _o = hn && hn.typeExpression && e.isJSDocTypeExpression(hn.typeExpression) && Mn(Fr, hn.typeExpression.type, rc, jt) || o(ya, Fr);
                    Ts(e.setSyntheticLeadingComments(e.factory.createTypeAliasDeclaration(void 0, void 0, ls(gi, zt), fn, _o), sn ? [{ kind: 3, text: `*
 * ` + sn.replace(/\n/g, `
 * `) + `
 `, pos: -1, end: -1, hasTrailingNewLine: true }] : []), La), Fr.flags = ln, Fr.enclosingDeclaration = lo;
                  }
                  function jd(gi, zt, La) {
                    var fa = aa(gi), ya = Af(gi), Nn = e.map(ya, function(Vo) {
                      return Dr(Vo, Fr);
                    }), fn = Qc(fa), hn = e.length(fn) ? Do(fn) : void 0, sn = e.flatMap(uo(fa), function(Vo) {
                      return An(Vo, hn);
                    }), ln = gn(0, fa, hn, 174), lo = gn(1, fa, hn, 175), _o = Vn(fa, hn), _s = e.length(fn) ? [e.factory.createHeritageClause(94, e.mapDefined(fn, function(Vo) {
                      return us(Vo, 111551);
                    }))] : void 0;
                    Ts(e.factory.createInterfaceDeclaration(void 0, void 0, ls(gi, zt), Nn, _s, Ve(Ve(Ve(Ve([], _o, true), lo, true), ln, true), sn, true)), La);
                  }
                  function lp(gi) {
                    return gi.exports ? e.filter(e.arrayFrom(gi.exports.values()), hi) : [];
                  }
                  function Tl(gi) {
                    return e.every(lp(gi), function(zt) {
                      return !(os(zt).flags & 111551);
                    });
                  }
                  function fp(gi, zt, La) {
                    var fa = lp(gi), ya = e.arrayToMultiMap(fa, function(lo) {
                      return lo.parent && lo.parent === gi ? "real" : "merged";
                    }), Nn = ya.get("real") || e.emptyArray, fn = ya.get("merged") || e.emptyArray;
                    if (e.length(Nn)) {
                      var hn = ls(gi, zt);
                      $r(Nn, hn, La, !!(gi.flags & 67108880));
                    }
                    if (e.length(fn)) {
                      var sn = e.getSourceFileOfNode(Fr.enclosingDeclaration), hn = ls(gi, zt), ln = e.factory.createModuleBlock([e.factory.createExportDeclaration(void 0, void 0, false, e.factory.createNamedExports(e.mapDefined(e.filter(fn, function(_o) {
                        return _o.escapedName !== "export=";
                      }), function(_o) {
                        var _s, Vo, Yo = e.unescapeLeadingUnderscores(_o.escapedName), Cs = ls(_o, Yo), ic = _o.declarations && ru(_o);
                        if (sn && (ic ? sn !== e.getSourceFileOfNode(ic) : !e.some(_o.declarations, function(n_) {
                          return e.getSourceFileOfNode(n_) === sn;
                        }))) {
                          (Vo = (_s = Fr.tracker) === null || _s === void 0 ? void 0 : _s.reportNonlocalAugmentation) === null || Vo === void 0 || Vo.call(_s, sn, gi, _o);
                          return;
                        }
                        var _c = ic && Ec(ic, true);
                        rc(_c || _o);
                        var il = _c ? ls(_c, e.unescapeLeadingUnderscores(_c.escapedName)) : Cs;
                        return e.factory.createExportSpecifier(false, Yo === il ? void 0 : il, Yo);
                      })))]);
                      Ts(e.factory.createModuleDeclaration(void 0, void 0, e.factory.createIdentifier(hn), ln, 16), 0);
                    }
                  }
                  function zg(gi, zt, La) {
                    Ts(e.factory.createEnumDeclaration(void 0, e.factory.createModifiersFromModifierFlags(lS(gi) ? 2048 : 0), ls(gi, zt), e.map(e.filter(uo(Jt(gi)), function(fa) {
                      return !!(fa.flags & 8);
                    }), function(fa) {
                      var ya = fa.declarations && fa.declarations[0] && e.isEnumMember(fa.declarations[0]) ? BS(fa.declarations[0]) : void 0;
                      return e.factory.createEnumMember(e.unescapeLeadingUnderscores(fa.escapedName), ya === void 0 ? void 0 : typeof ya == "string" ? e.factory.createStringLiteral(ya) : e.factory.createNumericLiteral(ya));
                    })), La);
                  }
                  function id(gi, zt, La, fa) {
                    for (var ya = ot(gi, 0), Nn = 0, fn = ya; Nn < fn.length; Nn++) {
                      var hn = fn[Nn], sn = $e(hn, 256, Fr, { name: e.factory.createIdentifier(La), privateSymbolVisitor: rc, bundledImports: jt });
                      Ts(e.setTextRange(sn, za(hn)), fa);
                    }
                    if (!(zt.flags & 1536 && !!zt.exports && !!zt.exports.size)) {
                      var ln = e.filter(uo(gi), hi);
                      $r(ln, La, fa, true);
                    }
                  }
                  function za(gi) {
                    if (gi.declaration && gi.declaration.parent) {
                      if (e.isBinaryExpression(gi.declaration.parent) && e.getAssignmentDeclarationKind(gi.declaration.parent) === 5) return gi.declaration.parent;
                      if (e.isVariableDeclaration(gi.declaration.parent) && gi.declaration.parent.parent) return gi.declaration.parent.parent;
                    }
                    return gi.declaration;
                  }
                  function $r(gi, zt, La, fa) {
                    if (e.length(gi)) {
                      var ya = e.arrayToMultiMap(gi, function(Yo) {
                        return !e.length(Yo.declarations) || e.some(Yo.declarations, function(Cs) {
                          return e.getSourceFileOfNode(Cs) === e.getSourceFileOfNode(Fr.enclosingDeclaration);
                        }) ? "local" : "remote";
                      }), Nn = ya.get("local") || e.emptyArray, fn = e.parseNodeFactory.createModuleDeclaration(void 0, void 0, e.factory.createIdentifier(zt), e.factory.createModuleBlock([]), 16);
                      e.setParent(fn, Kt), fn.locals = e.createSymbolTable(gi), fn.symbol = gi[0].parent;
                      var hn = $t;
                      $t = [];
                      var sn = Hi;
                      Hi = false;
                      var ln = Ke(Ke({}, Fr), { enclosingDeclaration: fn }), lo = Fr;
                      Fr = ln, Uo(e.createSymbolTable(Nn), fa, true), Fr = lo, Hi = sn;
                      var _o = $t;
                      $t = hn;
                      var _s = e.map(_o, function(Yo) {
                        return e.isExportAssignment(Yo) && !Yo.isExportEquals && e.isIdentifier(Yo.expression) ? e.factory.createExportDeclaration(void 0, void 0, false, e.factory.createNamedExports([e.factory.createExportSpecifier(false, Yo.expression, e.factory.createIdentifier("default"))])) : Yo;
                      }), Vo = e.every(_s, function(Yo) {
                        return e.hasSyntacticModifier(Yo, 1);
                      }) ? e.map(_s, Po) : _s;
                      fn = e.factory.updateModuleDeclaration(fn, fn.decorators, fn.modifiers, fn.name, e.factory.createModuleBlock(Vo)), Ts(fn, La);
                    }
                  }
                  function hi(gi) {
                    return !!(gi.flags & 2887656) || !(gi.flags & 4194304 || gi.escapedName === "prototype" || gi.valueDeclaration && e.isStatic(gi.valueDeclaration) && e.isClassLike(gi.valueDeclaration.parent));
                  }
                  function Ri(gi) {
                    var zt = e.mapDefined(gi, function(La) {
                      var fa, ya = Fr.enclosingDeclaration;
                      Fr.enclosingDeclaration = La;
                      var Nn = La.expression;
                      if (e.isEntityNameExpression(Nn)) {
                        if (e.isIdentifier(Nn) && e.idText(Nn) === "") return hn(void 0);
                        var fn = void 0;
                        if (fa = oa(Nn, Fr, rc), fn = fa.introducesError, Nn = fa.node, fn) return hn(void 0);
                      }
                      return hn(e.factory.createExpressionWithTypeArguments(Nn, e.map(La.typeArguments, function(sn) {
                        return Mn(Fr, sn, rc, jt) || o(Va(sn), Fr);
                      })));
                      function hn(sn) {
                        return Fr.enclosingDeclaration = ya, sn;
                      }
                    });
                    if (zt.length === gi.length) return zt;
                  }
                  function mt(gi, zt, La) {
                    var fa, ya, Nn = (fa = gi.declarations) === null || fa === void 0 ? void 0 : fa.find(e.isClassLike), fn = Fr.enclosingDeclaration;
                    Fr.enclosingDeclaration = Nn || fn;
                    var hn = Af(gi), sn = e.map(hn, function(Nc) {
                      return Dr(Nc, Fr);
                    }), ln = aa(gi), lo = Qc(ln), _o = Nn && e.getEffectiveImplementsTypeNodes(Nn), _s = _o && Ri(_o) || e.mapDefined(Qg(ln), Bo), Vo = Jt(gi), Yo = !!(!((ya = Vo.symbol) === null || ya === void 0) && ya.valueDeclaration) && e.isClassLike(Vo.symbol.valueDeclaration), Cs = Yo ? Bl(Vo) : Oe, ic = Ve(Ve([], e.length(lo) ? [e.factory.createHeritageClause(94, e.map(lo, function(Nc) {
                      return zo(Nc, Cs, zt);
                    }))] : [], true), e.length(_s) ? [e.factory.createHeritageClause(117, _s)] : [], true), _c = vM(ln, lo, uo(ln)), il = e.filter(_c, function(Nc) {
                      var pp = Nc.valueDeclaration;
                      return !!pp && !(e.isNamedDeclaration(pp) && e.isPrivateIdentifier(pp.name));
                    }), n_ = e.some(_c, function(Nc) {
                      var pp = Nc.valueDeclaration;
                      return !!pp && e.isNamedDeclaration(pp) && e.isPrivateIdentifier(pp.name);
                    }), o_ = n_ ? [e.factory.createPropertyDeclaration(void 0, void 0, e.factory.createPrivateIdentifier("#private"), void 0, void 0, void 0)] : e.emptyArray, og = e.flatMap(il, function(Nc) {
                      return Lt(Nc, false, lo[0]);
                    }), _p = e.flatMap(e.filter(uo(Vo), function(Nc) {
                      return !(Nc.flags & 4194304) && Nc.escapedName !== "prototype" && !hi(Nc);
                    }), function(Nc) {
                      return Lt(Nc, true, Cs);
                    }), td = !Yo && !!gi.valueDeclaration && e.isInJSFile(gi.valueDeclaration) && !e.some(ot(Vo, 1)), s_ = td ? [e.factory.createConstructorDeclaration(void 0, e.factory.createModifiersFromModifierFlags(8), [], void 0)] : gn(1, Vo, Cs, 171), sg = Vn(ln, lo[0]);
                    Fr.enclosingDeclaration = fn, Ts(e.setTextRange(e.factory.createClassDeclaration(void 0, void 0, zt, sn, ic, Ve(Ve(Ve(Ve(Ve([], sg, true), _p, true), s_, true), og, true), o_, true)), gi.declarations && e.filter(gi.declarations, function(Nc) {
                      return e.isClassDeclaration(Nc) || e.isClassExpression(Nc);
                    })[0]), La);
                  }
                  function ft(gi) {
                    return e.firstDefined(gi, function(zt) {
                      if (e.isImportSpecifier(zt) || e.isExportSpecifier(zt)) return e.idText(zt.propertyName || zt.name);
                      if (e.isBinaryExpression(zt) || e.isExportAssignment(zt)) {
                        var La = e.isExportAssignment(zt) ? zt.expression : zt.right;
                        if (e.isPropertyAccessExpression(La)) return e.idText(La.name);
                      }
                      if (yf(zt)) {
                        var fa = e.getNameOfDeclaration(zt);
                        if (fa && e.isIdentifier(fa)) return e.idText(fa);
                      }
                    });
                  }
                  function Ht(gi, zt, La) {
                    var fa, ya, Nn, fn, hn, sn = ru(gi);
                    if (!sn) return e.Debug.fail();
                    var ln = so(Ec(sn, true));
                    if (!!ln) {
                      var lo = e.isShorthandAmbientModuleSymbol(ln) && ft(gi.declarations) || e.unescapeLeadingUnderscores(ln.escapedName);
                      lo === "export=" && (e.getESModuleInterop(ye) || ye.allowSyntheticDefaultImports) && (lo = "default");
                      var _o = ls(ln, lo);
                      switch (rc(ln), sn.kind) {
                        case 203:
                          if (((ya = (fa = sn.parent) === null || fa === void 0 ? void 0 : fa.parent) === null || ya === void 0 ? void 0 : ya.kind) === 254) {
                            var _s = Nt(ln.parent || ln, Fr), Vo = sn.propertyName;
                            Ts(e.factory.createImportDeclaration(void 0, void 0, e.factory.createImportClause(false, void 0, e.factory.createNamedImports([e.factory.createImportSpecifier(false, Vo && e.isIdentifier(Vo) ? e.factory.createIdentifier(e.idText(Vo)) : void 0, e.factory.createIdentifier(zt))])), e.factory.createStringLiteral(_s), void 0), 0);
                            break;
                          }
                          e.Debug.failBadSyntaxKind(((Nn = sn.parent) === null || Nn === void 0 ? void 0 : Nn.parent) || sn, "Unhandled binding element grandparent kind in declaration serialization");
                          break;
                        case 297:
                          ((hn = (fn = sn.parent) === null || fn === void 0 ? void 0 : fn.parent) === null || hn === void 0 ? void 0 : hn.kind) === 221 && vt(e.unescapeLeadingUnderscores(gi.escapedName), _o);
                          break;
                        case 254:
                          if (e.isPropertyAccessExpression(sn.initializer)) {
                            var Yo = sn.initializer, Cs = e.factory.createUniqueName(zt), ic = Nt(ln.parent || ln, Fr);
                            Ts(e.factory.createImportEqualsDeclaration(void 0, void 0, false, Cs, e.factory.createExternalModuleReference(e.factory.createStringLiteral(ic))), 0), Ts(e.factory.createImportEqualsDeclaration(void 0, void 0, false, e.factory.createIdentifier(zt), e.factory.createQualifiedName(Cs, Yo.name)), La);
                            break;
                          }
                        case 265:
                          if (ln.escapedName === "export=" && e.some(ln.declarations, e.isJsonSourceFile)) {
                            ht(gi);
                            break;
                          }
                          var _c = !(ln.flags & 512) && !e.isVariableDeclaration(sn);
                          Ts(e.factory.createImportEqualsDeclaration(void 0, void 0, false, e.factory.createIdentifier(zt), _c ? Fn(ln, Fr, 67108863, false) : e.factory.createExternalModuleReference(e.factory.createStringLiteral(Nt(ln, Fr)))), _c ? La : 0);
                          break;
                        case 264:
                          Ts(e.factory.createNamespaceExportDeclaration(e.idText(sn.name)), 0);
                          break;
                        case 267:
                          Ts(e.factory.createImportDeclaration(void 0, void 0, e.factory.createImportClause(false, e.factory.createIdentifier(zt), void 0), e.factory.createStringLiteral(Nt(ln.parent || ln, Fr)), void 0), 0);
                          break;
                        case 268:
                          Ts(e.factory.createImportDeclaration(void 0, void 0, e.factory.createImportClause(false, void 0, e.factory.createNamespaceImport(e.factory.createIdentifier(zt))), e.factory.createStringLiteral(Nt(ln, Fr)), void 0), 0);
                          break;
                        case 274:
                          Ts(e.factory.createExportDeclaration(void 0, void 0, false, e.factory.createNamespaceExport(e.factory.createIdentifier(zt)), e.factory.createStringLiteral(Nt(ln, Fr))), 0);
                          break;
                        case 270:
                          Ts(e.factory.createImportDeclaration(void 0, void 0, e.factory.createImportClause(false, void 0, e.factory.createNamedImports([e.factory.createImportSpecifier(false, zt !== lo ? e.factory.createIdentifier(lo) : void 0, e.factory.createIdentifier(zt))])), e.factory.createStringLiteral(Nt(ln.parent || ln, Fr)), void 0), 0);
                          break;
                        case 275:
                          var il = sn.parent.parent.moduleSpecifier;
                          vt(e.unescapeLeadingUnderscores(gi.escapedName), il ? lo : _o, il && e.isStringLiteralLike(il) ? e.factory.createStringLiteral(il.text) : void 0);
                          break;
                        case 271:
                          ht(gi);
                          break;
                        case 221:
                        case 206:
                        case 207:
                          gi.escapedName === "default" || gi.escapedName === "export=" ? ht(gi) : vt(zt, _o);
                          break;
                        default:
                          return e.Debug.failBadSyntaxKind(sn, "Unhandled alias declaration kind in symbol serializer!");
                      }
                    }
                  }
                  function vt(gi, zt, La) {
                    Ts(e.factory.createExportDeclaration(void 0, void 0, false, e.factory.createNamedExports([e.factory.createExportSpecifier(false, gi !== zt ? zt : void 0, gi)]), La), 0);
                  }
                  function ht(gi) {
                    if (gi.flags & 4194304) return false;
                    var zt = e.unescapeLeadingUnderscores(gi.escapedName), La = zt === "export=", fa = zt === "default", ya = La || fa, Nn = gi.declarations && ru(gi), fn = Nn && Ec(Nn, true);
                    if (fn && e.length(fn.declarations) && e.some(fn.declarations, function(Yo) {
                      return e.getSourceFileOfNode(Yo) === e.getSourceFileOfNode(Kt);
                    })) {
                      var hn = Nn && (e.isExportAssignment(Nn) || e.isBinaryExpression(Nn) ? e.getExportAssignmentExpression(Nn) : e.getPropertyAssignmentAliasLikeExpression(Nn)), sn = hn && e.isEntityNameExpression(hn) ? IM(hn) : void 0, ln = sn && Ds(sn, 67108863, true, true, Kt);
                      (ln || fn) && rc(ln || fn);
                      var lo = Fr.tracker.trackSymbol;
                      if (Fr.tracker.trackSymbol = function() {
                        return false;
                      }, ya) $t.push(e.factory.createExportAssignment(void 0, void 0, La, wn(fn, Fr, 67108863)));
                      else if (sn === hn && sn) vt(zt, e.idText(sn));
                      else if (hn && e.isClassExpression(hn)) vt(zt, ls(fn, e.symbolName(fn)));
                      else {
                        var _o = Io(zt, gi);
                        Ts(e.factory.createImportEqualsDeclaration(void 0, void 0, false, e.factory.createIdentifier(_o), Fn(fn, Fr, 67108863, false)), 0), vt(zt, _o);
                      }
                      return Fr.tracker.trackSymbol = lo, true;
                    } else {
                      var _o = Io(zt, gi), _s = $c(Jt(so(gi)));
                      if (ma(_s, gi)) id(_s, gi, _o, ya ? 0 : 1);
                      else {
                        var Vo = e.factory.createVariableStatement(void 0, e.factory.createVariableDeclarationList([e.factory.createVariableDeclaration(_o, void 0, Ka(Fr, _s, gi, Kt, rc, jt))], 2));
                        Ts(Vo, fn && fn.flags & 4 && fn.escapedName === "export=" ? 2 : zt === _o ? 1 : 0);
                      }
                      return ya ? ($t.push(e.factory.createExportAssignment(void 0, void 0, La, e.factory.createIdentifier(_o))), true) : zt !== _o ? (vt(zt, _o), true) : false;
                    }
                  }
                  function ma(gi, zt) {
                    var La = e.getSourceFileOfNode(Fr.enclosingDeclaration);
                    return e.getObjectFlags(gi) & 48 && !e.length(Hn(gi)) && !yd(gi) && !!(e.length(e.filter(uo(gi), hi)) || e.length(ot(gi, 0))) && !e.length(ot(gi, 1)) && !Ia(zt, Kt) && !(gi.symbol && e.some(gi.symbol.declarations, function(fa) {
                      return e.getSourceFileOfNode(fa) !== La;
                    })) && !e.some(uo(gi), function(fa) {
                      return pg(fa.escapedName);
                    }) && !e.some(uo(gi), function(fa) {
                      return e.some(fa.declarations, function(ya) {
                        return e.getSourceFileOfNode(ya) !== La;
                      });
                    }) && e.every(uo(gi), function(fa) {
                      return e.isIdentifierText(e.symbolName(fa), Ae);
                    });
                  }
                  function Ca(gi, zt, La) {
                    return function(ya, Nn, fn) {
                      var hn, sn, ln, lo, _o, _s = e.getDeclarationModifierFlagsFromSymbol(ya), Vo = !!(_s & 8);
                      if (Nn && ya.flags & 2887656) return [];
                      if (ya.flags & 4194304 || fn && bi(fn, ya.escapedName) && Zu(bi(fn, ya.escapedName)) === Zu(ya) && (ya.flags & 16777216) === (bi(fn, ya.escapedName).flags & 16777216) && wf(Jt(ya), da(fn, ya.escapedName))) return [];
                      var Yo = _s & -257 | (Nn ? 32 : 0), Cs = lt(ya, Fr), ic = (hn = ya.declarations) === null || hn === void 0 ? void 0 : hn.find(e.or(e.isPropertyDeclaration, e.isAccessor, e.isVariableDeclaration, e.isPropertySignature, e.isBinaryExpression, e.isPropertyAccessExpression));
                      if (ya.flags & 98304 && La) {
                        var _c = [];
                        if (ya.flags & 65536 && _c.push(e.setTextRange(e.factory.createSetAccessorDeclaration(void 0, e.factory.createModifiersFromModifierFlags(Yo), Cs, [e.factory.createParameterDeclaration(void 0, void 0, void 0, "arg", void 0, Vo ? void 0 : Ka(Fr, Jt(ya), ya, Kt, rc, jt))], void 0), ((sn = ya.declarations) === null || sn === void 0 ? void 0 : sn.find(e.isSetAccessor)) || ic)), ya.flags & 32768) {
                          var il = _s & 8;
                          _c.push(e.setTextRange(e.factory.createGetAccessorDeclaration(void 0, e.factory.createModifiersFromModifierFlags(Yo), Cs, [], il ? void 0 : Ka(Fr, Jt(ya), ya, Kt, rc, jt), void 0), ((ln = ya.declarations) === null || ln === void 0 ? void 0 : ln.find(e.isGetAccessor)) || ic));
                        }
                        return _c;
                      } else if (ya.flags & 98311) return e.setTextRange(gi(void 0, e.factory.createModifiersFromModifierFlags((Zu(ya) ? 64 : 0) | Yo), Cs, ya.flags & 16777216 ? e.factory.createToken(57) : void 0, Vo ? void 0 : Ka(Fr, Jt(ya), ya, Kt, rc, jt), void 0), ((lo = ya.declarations) === null || lo === void 0 ? void 0 : lo.find(e.or(e.isPropertyDeclaration, e.isVariableDeclaration))) || ic);
                      if (ya.flags & 8208) {
                        var n_ = Jt(ya), o_ = ot(n_, 0);
                        if (Yo & 8) return e.setTextRange(gi(void 0, e.factory.createModifiersFromModifierFlags((Zu(ya) ? 64 : 0) | Yo), Cs, ya.flags & 16777216 ? e.factory.createToken(57) : void 0, void 0, void 0), ((_o = ya.declarations) === null || _o === void 0 ? void 0 : _o.find(e.isFunctionLikeDeclaration)) || o_[0] && o_[0].declaration || ya.declarations && ya.declarations[0]);
                        for (var og = [], _p = 0, td = o_; _p < td.length; _p++) {
                          var s_ = td[_p], sg = $e(s_, zt, Fr, { name: Cs, questionToken: ya.flags & 16777216 ? e.factory.createToken(57) : void 0, modifiers: Yo ? e.factory.createModifiersFromModifierFlags(Yo) : void 0 }), Nc = s_.declaration && e.isPrototypePropertyAssignment(s_.declaration.parent) ? s_.declaration.parent : s_.declaration;
                          og.push(e.setTextRange(sg, Nc));
                        }
                        return og;
                      }
                      return e.Debug.fail("Unhandled class member kind! ".concat(ya.__debugFlags || ya.flags));
                    };
                  }
                  function An(gi, zt) {
                    return ea(gi, false, zt);
                  }
                  function gn(gi, zt, La, fa) {
                    var ya = ot(zt, gi);
                    if (gi === 1) {
                      if (!La && e.every(ya, function(_c) {
                        return e.length(_c.parameters) === 0;
                      })) return [];
                      if (La) {
                        var Nn = ot(La, 1);
                        if (!e.length(Nn) && e.every(ya, function(_c) {
                          return e.length(_c.parameters) === 0;
                        })) return [];
                        if (Nn.length === ya.length) {
                          for (var fn = false, hn = 0; hn < Nn.length; hn++) if (!_y(ya[hn], Nn[hn], false, false, true, av)) {
                            fn = true;
                            break;
                          }
                          if (!fn) return [];
                        }
                      }
                      for (var sn = 0, ln = 0, lo = ya; ln < lo.length; ln++) {
                        var _o = lo[ln];
                        _o.declaration && (sn |= e.getSelectedEffectiveModifierFlags(_o.declaration, 24));
                      }
                      if (sn) return [e.setTextRange(e.factory.createConstructorDeclaration(void 0, e.factory.createModifiersFromModifierFlags(sn), [], void 0), ya[0].declaration)];
                    }
                    for (var _s = [], Vo = 0, Yo = ya; Vo < Yo.length; Vo++) {
                      var Cs = Yo[Vo], ic = $e(Cs, fa, Fr);
                      _s.push(e.setTextRange(ic, Cs.declaration));
                    }
                    return _s;
                  }
                  function Vn(gi, zt) {
                    for (var La = [], fa = 0, ya = Hn(gi); fa < ya.length; fa++) {
                      var Nn = ya[fa];
                      if (zt) {
                        var fn = ss(zt, Nn.keyType);
                        if (fn && wf(Nn.type, fn.type)) continue;
                      }
                      La.push(Me(Nn, Fr, void 0));
                    }
                    return La;
                  }
                  function zo(gi, zt, La) {
                    var fa = us(gi, 111551);
                    if (fa) return fa;
                    var ya = Io("".concat(La, "_base")), Nn = e.factory.createVariableStatement(void 0, e.factory.createVariableDeclarationList([e.factory.createVariableDeclaration(ya, void 0, o(zt, Fr))], 2));
                    return Ts(Nn, 0), e.factory.createExpressionWithTypeArguments(e.factory.createIdentifier(ya), void 0);
                  }
                  function us(gi, zt) {
                    var La, fa;
                    if (gi.target && Cf(gi.target.symbol, Kt, zt) ? (La = e.map(xo(gi), function(ya) {
                      return o(ya, Fr);
                    }), fa = wn(gi.target.symbol, Fr, 788968)) : gi.symbol && Cf(gi.symbol, Kt, zt) && (fa = wn(gi.symbol, Fr, 788968)), fa) return e.factory.createExpressionWithTypeArguments(fa, La);
                  }
                  function Bo(gi) {
                    var zt = us(gi, 788968);
                    if (zt) return zt;
                    if (gi.symbol) return e.factory.createExpressionWithTypeArguments(wn(gi.symbol, Fr, 788968), void 0);
                  }
                  function Io(gi, zt) {
                    var La, fa, ya = zt ? y(zt) : void 0;
                    if (ya && Fr.remappedSymbolNames.has(ya)) return Fr.remappedSymbolNames.get(ya);
                    zt && (gi = Qo(zt, gi));
                    for (var Nn = 0, fn = gi; !((La = Fr.usedSymbolNames) === null || La === void 0) && La.has(gi); ) Nn++, gi = "".concat(fn, "_").concat(Nn);
                    return (fa = Fr.usedSymbolNames) === null || fa === void 0 || fa.add(gi), ya && Fr.remappedSymbolNames.set(ya, gi), gi;
                  }
                  function Qo(gi, zt) {
                    if (zt === "default" || zt === "__class" || zt === "__function") {
                      var La = Fr.flags;
                      Fr.flags |= 16777216;
                      var fa = of(gi, Fr);
                      Fr.flags = La, zt = fa.length > 0 && e.isSingleOrDoubleQuote(fa.charCodeAt(0)) ? e.stripQuotes(fa) : fa;
                    }
                    return zt === "default" ? zt = "_default" : zt === "export=" && (zt = "_exports"), zt = e.isIdentifierText(zt, Ae) && !e.isStringANonContextualKeyword(zt) ? zt : "_" + zt.replace(/[^a-zA-Z0-9]/g, "_"), zt;
                  }
                  function ls(gi, zt) {
                    var La = y(gi);
                    return Fr.remappedSymbolNames.has(La) ? Fr.remappedSymbolNames.get(La) : (zt = Qo(gi, zt), Fr.remappedSymbolNames.set(La, zt), zt);
                  }
                }
              }
              function Ll(r, i, t, o) {
                return t === void 0 && (t = 16384), o ? s(o).getText() : e.usingSingleLineStringWriter(s);
                function s(u) {
                  var h = e.factory.createTypePredicateNode(r.kind === 2 || r.kind === 3 ? e.factory.createToken(128) : void 0, r.kind === 1 || r.kind === 3 ? e.factory.createIdentifier(r.parameterName) : e.factory.createThisTypeNode(), r.type && Ur.typeToTypeNode(r.type, i, Rp(t) | 70221824 | 512)), z2 = e.createPrinter({ removeComments: true }), me = i && e.getSourceFileOfNode(i);
                  return z2.writeNode(4, h, me, u), u;
                }
              }
              function hd(r) {
                for (var i = [], t = 0, o = 0; o < r.length; o++) {
                  var s = r[o];
                  if (t |= s.flags, !(s.flags & 98304)) {
                    if (s.flags & 1536) {
                      var u = s.flags & 512 ? Ii : cc(s);
                      if (u.flags & 1048576) {
                        var h = u.types.length;
                        if (o + h <= r.length && jc(r[o + h - 1]) === jc(u.types[h - 1])) {
                          i.push(u), o += h - 1;
                          continue;
                        }
                      }
                    }
                    i.push(s);
                  }
                }
                return t & 65536 && i.push(Wi), t & 32768 && i.push(Tr), i || r;
              }
              function v_(r) {
                return r === 8 ? "private" : r === 16 ? "protected" : "public";
              }
              function Bp(r) {
                if (r.symbol && r.symbol.flags & 2048 && r.symbol.declarations) {
                  var i = e.walkUpParenthesizedTypes(r.symbol.declarations[0].parent);
                  if (i.kind === 259) return Et(i);
                }
              }
              function Xu(r) {
                return r && r.parent && r.parent.kind === 262 && e.isExternalModuleAugmentation(r.parent.parent);
              }
              function Xc(r) {
                return r.kind === 305 || e.isAmbientModule(r);
              }
              function Gf(r, i) {
                var t = Aa(r).nameType;
                if (t) {
                  if (t.flags & 384) {
                    var o = "" + t.value;
                    return !e.isIdentifierText(o, e.getEmitScriptTarget(ye)) && !e.isNumericLiteralName(o) ? '"'.concat(e.escapeString(o, 34), '"') : e.isNumericLiteralName(o) && e.startsWith(o, "-") ? "[".concat(o, "]") : o;
                  }
                  if (t.flags & 8192) return "[".concat(of(t.symbol, i), "]");
                }
              }
              function of(r, i) {
                if (i && r.escapedName === "default" && !(i.flags & 16384) && (!(i.flags & 16777216) || !r.declarations || i.enclosingDeclaration && e.findAncestor(r.declarations[0], Xc) !== e.findAncestor(i.enclosingDeclaration, Xc))) return "default";
                if (r.declarations && r.declarations.length) {
                  var t = e.firstDefined(r.declarations, function(z2) {
                    return e.getNameOfDeclaration(z2) ? z2 : void 0;
                  }), o = t && e.getNameOfDeclaration(t);
                  if (t && o) {
                    if (e.isCallExpression(t) && e.isBindableObjectDefinePropertyCall(t)) return e.symbolName(r);
                    if (e.isComputedPropertyName(o) && !(e.getCheckFlags(r) & 4096)) {
                      var s = Aa(r).nameType;
                      if (s && s.flags & 384) {
                        var u = Gf(r, i);
                        if (u !== void 0) return u;
                      }
                    }
                    return e.declarationNameToString(o);
                  }
                  if (t || (t = r.declarations[0]), t.parent && t.parent.kind === 254) return e.declarationNameToString(t.parent.name);
                  switch (t.kind) {
                    case 226:
                    case 213:
                    case 214:
                      return i && !i.encounteredError && !(i.flags & 131072) && (i.encounteredError = true), t.kind === 226 ? "(Anonymous class)" : "(Anonymous function)";
                  }
                }
                var h = Gf(r, i);
                return h !== void 0 ? h : e.symbolName(r);
              }
              function wu(r) {
                if (r) {
                  var i = va(r);
                  return i.isVisible === void 0 && (i.isVisible = !!t()), i.isVisible;
                }
                return false;
                function t() {
                  switch (r.kind) {
                    case 338:
                    case 345:
                    case 339:
                      return !!(r.parent && r.parent.parent && r.parent.parent.parent && e.isSourceFile(r.parent.parent.parent));
                    case 203:
                      return wu(r.parent.parent);
                    case 254:
                      if (e.isBindingPattern(r.name) && !r.name.elements.length) return false;
                    case 261:
                    case 257:
                    case 258:
                    case 259:
                    case 256:
                    case 260:
                    case 265:
                      if (e.isExternalModuleAugmentation(r)) return true;
                      var o = zi(r);
                      return !(e.getCombinedModifierFlags(r) & 1) && !(r.kind !== 265 && o.kind !== 305 && o.flags & 16777216) ? Cu(o) : wu(o);
                    case 167:
                    case 166:
                    case 172:
                    case 173:
                    case 169:
                    case 168:
                      if (e.hasEffectiveModifier(r, 24)) return false;
                    case 171:
                    case 175:
                    case 174:
                    case 176:
                    case 164:
                    case 262:
                    case 179:
                    case 180:
                    case 182:
                    case 178:
                    case 183:
                    case 184:
                    case 187:
                    case 188:
                    case 191:
                    case 197:
                      return wu(r.parent);
                    case 267:
                    case 268:
                    case 270:
                      return false;
                    case 163:
                    case 305:
                    case 264:
                      return true;
                    case 271:
                      return false;
                    default:
                      return false;
                  }
                }
              }
              function V_(r, i) {
                var t;
                r.parent && r.parent.kind === 271 ? t = es(r, r.escapedText, 2998271, void 0, r, false) : r.parent.kind === 275 && (t = Vu(r.parent, 2998271));
                var o, s;
                return t && (s = new e.Set(), s.add(y(t)), u(t.declarations)), o;
                function u(h) {
                  e.forEach(h, function(z2) {
                    var me = Au(z2) || z2;
                    if (i ? va(z2).isVisible = true : (o = o || [], e.pushIfUnique(o, me)), e.isInternalModuleImportEqualsDeclaration(z2)) {
                      var Me = z2.moduleReference, $e = e.getFirstIdentifier(Me), tr = es(z2, $e.escapedText, 901119, void 0, void 0, false);
                      tr && s && e.tryAddToSet(s, y(tr)) && u(tr.declarations);
                    }
                  });
                }
              }
              function yu(r, i) {
                var t = v(r, i);
                if (t >= 0) {
                  for (var o = eu.length, s = t; s < o; s++) Ws[s] = false;
                  return false;
                }
                return eu.push(r), Ws.push(true), pu.push(i), true;
              }
              function v(r, i) {
                for (var t = eu.length - 1; t >= 0; t--) {
                  if (sr(eu[t], pu[t])) return -1;
                  if (eu[t] === r && pu[t] === i) return t;
                }
                return -1;
              }
              function sr(r, i) {
                switch (i) {
                  case 0:
                    return !!Aa(r).type;
                  case 5:
                    return !!va(r).resolvedEnumType;
                  case 2:
                    return !!Aa(r).declaredType;
                  case 1:
                    return !!r.resolvedBaseConstructorType;
                  case 3:
                    return !!r.resolvedReturnType;
                  case 4:
                    return !!r.immediateBaseConstraint;
                  case 6:
                    return !!r.resolvedTypeArguments;
                  case 7:
                    return !!r.baseTypesResolved;
                  case 8:
                    return !!Aa(r).writeType;
                }
                return e.Debug.assertNever(i);
              }
              function fi() {
                return eu.pop(), pu.pop(), Ws.pop();
              }
              function zi(r) {
                return e.findAncestor(e.getRootDeclaration(r), function(i) {
                  switch (i.kind) {
                    case 254:
                    case 255:
                    case 270:
                    case 269:
                    case 268:
                    case 267:
                      return false;
                    default:
                      return true;
                  }
                }).parent;
              }
              function Sa(r) {
                var i = go(Ys(r));
                return i.typeParameters ? Yf(i, e.map(i.typeParameters, function(t) {
                  return Oe;
                })) : i;
              }
              function da(r, i) {
                var t = bi(r, i);
                return t ? Jt(t) : void 0;
              }
              function Ha(r, i) {
                var t;
                return da(r, i) || ((t = Xo(r, i)) === null || t === void 0 ? void 0 : t.type) || gr;
              }
              function ta(r) {
                return r && (r.flags & 1) !== 0;
              }
              function nn(r) {
                return r === Pe || !!(r.flags & 1 && r.aliasSymbol);
              }
              function Wo(r, i) {
                if (i !== 0) return G_(r, false, i);
                var t = Et(r);
                return t && Aa(t).type || G_(r, false, i);
              }
              function Lo(r, i, t) {
                if (r = ec(r, function(li) {
                  return !(li.flags & 98304);
                }), r.flags & 131072) return Ba;
                if (r.flags & 1048576) return Ss(r, function(li) {
                  return Lo(li, i, t);
                });
                for (var o = Pa(e.map(i, Z_)), s = [], u = [], h = 0, z2 = uo(r); h < z2.length; h++) {
                  var me = z2[h], Me = om(me, 8576);
                  !ao(Me, o) && !(e.getDeclarationModifierFlagsFromSymbol(me) & 24) && Eh(me) ? s.push(me) : u.push(Me);
                }
                if (Ad(r) || qp(o)) {
                  if (u.length && (o = Pa(Ve([o], u, true))), o.flags & 131072) return r;
                  var $e = L3();
                  return $e ? am($e, [r, o]) : Pe;
                }
                for (var tr = e.createSymbolTable(), dr = 0, Dr = s; dr < Dr.length; dr++) {
                  var me = Dr[dr];
                  tr.set(me.escapedName, xD(me, false));
                }
                var Qr = rs(t, tr, e.emptyArray, e.emptyArray, Hn(r));
                return Qr.objectFlags |= 4194304, Qr;
              }
              function oc(r) {
                return !!(r.flags & 465829888) && fs(uc(r) || gr, 32768);
              }
              function uu(r) {
                var i = rg(r, oc) ? Ss(r, function(t) {
                  return t.flags & 465829888 ? Hd(t) : t;
                }) : r;
                return Ks(i, 524288);
              }
              function is(r, i) {
                var t = au(r);
                return t ? up(t, i) : i;
              }
              function au(r) {
                var i = Ou(r);
                if (i && i.flowNode) {
                  var t = sf(r);
                  if (t) {
                    var o = e.setTextRange(e.parseNodeFactory.createStringLiteral(t), r), s = e.isLeftHandSideExpression(i) ? i : e.parseNodeFactory.createParenthesizedExpression(i), u = e.setTextRange(e.parseNodeFactory.createElementAccessExpression(s, o), r);
                    return e.setParent(o, u), e.setParent(u, r), s !== i && e.setParent(s, u), u.flowNode = i.flowNode, u;
                  }
                }
              }
              function Ou(r) {
                var i = r.parent.parent;
                switch (i.kind) {
                  case 203:
                  case 296:
                    return au(i);
                  case 204:
                    return au(r.parent);
                  case 254:
                    return i.initializer;
                  case 221:
                    return i.right;
                }
              }
              function sf(r) {
                var i = r.parent;
                return r.kind === 203 && i.kind === 201 ? lu(r.propertyName || r.name) : r.kind === 296 || r.kind === 297 ? lu(r.name) : "" + i.elements.indexOf(r);
              }
              function lu(r) {
                var i = Z_(r);
                return i.flags & 384 ? "" + i.value : void 0;
              }
              function cf(r) {
                var i = r.dotDotDotToken ? 64 : 0, t = Wo(r.parent.parent, i);
                return t && uf(r, t);
              }
              function uf(r, i) {
                if (ta(i)) return i;
                var t = r.parent;
                Ye && r.flags & 16777216 && e.isParameterDeclaration(r) ? i = C_(i) : Ye && t.parent.initializer && !(cp(nC(t.parent.initializer)) & 65536) && (i = Ks(i, 524288));
                var o;
                if (t.kind === 201) if (r.dotDotDotToken) {
                  if (i = bu(i), i.flags & 2 || !Dy(i)) return Xr(r, e.Diagnostics.Rest_types_may_only_be_created_from_object_types), Pe;
                  for (var s = [], u = 0, h = t.elements; u < h.length; u++) {
                    var z2 = h[u];
                    z2.dotDotDotToken || s.push(z2.propertyName || z2.name);
                  }
                  o = Lo(i, s, r.symbol);
                } else {
                  var me = r.propertyName || r.name, Me = Z_(me), $e = Jc(i, Me, 32, me);
                  o = is(r, $e);
                }
                else {
                  var tr = N_(65 | (r.dotDotDotToken ? 0 : 128), i, Tr, t), dr = t.elements.indexOf(r);
                  if (r.dotDotDotToken) o = gf(i, Yn) ? Ss(i, function(Qr) {
                    return Zm(Qr, dr);
                  }) : Zs(tr);
                  else if (sp(i)) {
                    var Me = If(dr), Dr = 32 | (pm(r) ? 16 : 0), $e = ep(i, Me, Dr, r.name) || Pe;
                    o = is(r, $e);
                  } else o = tr;
                }
                return r.initializer ? e.getEffectiveTypeAnnotationNode(e.walkUpBindingElementsAndPatterns(r)) ? Ye && !(ju(wy(r, 0)) & 32768) ? uu(o) : o : _S(r, Pa([uu(o), wy(r, 0)], 2)) : o;
              }
              function K_(r) {
                var i = e.getJSDocType(r);
                if (i) return Va(i);
              }
              function Jp(r) {
                var i = e.skipParentheses(r, true);
                return i.kind === 104 || i.kind === 79 && Dl(i) === mi;
              }
              function Hf(r) {
                var i = e.skipParentheses(r, true);
                return i.kind === 204 && i.elements.length === 0;
              }
              function kc(r, i, t) {
                return i === void 0 && (i = false), t === void 0 && (t = true), Ye && t ? i_(r, i) : r;
              }
              function G_(r, i, t) {
                if (e.isVariableDeclaration(r) && r.parent.parent.kind === 243) {
                  var o = ql(jb(yn(r.parent.parent.expression, t)));
                  return o.flags & 4456448 ? Vx(o) : Li;
                }
                if (e.isVariableDeclaration(r) && r.parent.parent.kind === 244) {
                  var s = r.parent.parent;
                  return By(s) || Oe;
                }
                if (e.isBindingPattern(r.parent)) return cf(r);
                var u = e.isPropertyDeclaration(r) || e.isPropertySignature(r), h = i && (u && !!r.questionToken || e.isParameter(r) && (!!r.questionToken || Cd(r)) || Vm(r)), z2 = Rl(r);
                if (z2) return kc(z2, u, h);
                if ((n || e.isInJSFile(r)) && e.isVariableDeclaration(r) && !e.isBindingPattern(r.name) && !(e.getCombinedModifierFlags(r) & 1) && !(r.flags & 16777216)) {
                  if (!(e.getCombinedNodeFlags(r) & 2) && (!r.initializer || Jp(r.initializer))) return nr;
                  if (r.initializer && Hf(r.initializer)) return So;
                }
                if (e.isParameter(r)) {
                  var me = r.parent;
                  if (me.kind === 173 && Td(me)) {
                    var Me = e.getDeclarationOfKind(Et(r.parent), 172);
                    if (Me) {
                      var $e = yl(Me), tr = qS(me);
                      return tr && r === tr ? (e.Debug.assert(!tr.type), Jt($e.thisParameter)) : yo($e);
                    }
                  }
                  if (e.isInJSFile(r)) {
                    var dr = Km(me, r);
                    if (dr) return dr;
                  }
                  var Dr = r.symbol.escapedName === "this" ? SC(me) : TC(r);
                  if (Dr) return kc(Dr, false, h);
                }
                if (e.hasOnlyExpressionInitializer(r) && !!r.initializer) {
                  if (e.isInJSFile(r) && !e.isParameter(r)) {
                    var Qr = ha(r, Et(r), e.getDeclaredExpandoInitializer(r));
                    if (Qr) return Qr;
                  }
                  var Dr = _S(r, wy(r, t));
                  return kc(Dr, u, h);
                }
                if (e.isPropertyDeclaration(r) && (n || e.isInJSFile(r))) if (e.hasStaticModifier(r)) {
                  var Ti = e.filter(r.parent.members, e.isClassStaticBlockDeclaration), Dr = Ti.length ? Mi(r.symbol, Ti) : e.getEffectiveModifierFlags(r) & 2 ? Lh(r.symbol) : void 0;
                  return Dr && kc(Dr, true, h);
                } else {
                  var li = Tf(r.parent), Dr = li ? st(r.symbol, li) : e.getEffectiveModifierFlags(r) & 2 ? Lh(r.symbol) : void 0;
                  return Dr && kc(Dr, true, h);
                }
                if (e.isJsxAttribute(r)) return Dt;
                if (e.isBindingPattern(r.name)) return Qu(r.name, false, true);
              }
              function Le(r) {
                if (r.valueDeclaration && e.isBinaryExpression(r.valueDeclaration)) {
                  var i = Aa(r);
                  return i.isConstructorDeclaredProperty === void 0 && (i.isConstructorDeclaredProperty = false, i.isConstructorDeclaredProperty = !!ri(r) && e.every(r.declarations, function(t) {
                    return e.isBinaryExpression(t) && s0(t) && (t.left.kind !== 207 || e.isStringOrNumericLiteralLike(t.left.argumentExpression)) && !Na(void 0, t, r, t);
                  })), i.isConstructorDeclaredProperty;
                }
                return false;
              }
              function Nr(r) {
                var i = r.valueDeclaration;
                return i && e.isPropertyDeclaration(i) && !e.getEffectiveTypeAnnotationNode(i) && !i.initializer && (n || e.isInJSFile(i));
              }
              function ri(r) {
                if (!!r.declarations) for (var i = 0, t = r.declarations; i < t.length; i++) {
                  var o = t[i], s = e.getThisContainer(o, false);
                  if (s && (s.kind === 171 || Sl(s))) return s;
                }
              }
              function di(r) {
                var i = e.getSourceFileOfNode(r.declarations[0]), t = e.unescapeLeadingUnderscores(r.escapedName), o = r.declarations.every(function(u) {
                  return e.isInJSFile(u) && e.isAccessExpression(u) && e.isModuleExportsAccessExpression(u.expression);
                }), s = o ? e.factory.createPropertyAccessExpression(e.factory.createPropertyAccessExpression(e.factory.createIdentifier("module"), e.factory.createIdentifier("exports")), t) : e.factory.createPropertyAccessExpression(e.factory.createIdentifier("exports"), t);
                return o && e.setParent(s.expression.expression, s.expression), e.setParent(s.expression, s), e.setParent(s, i), s.flowNode = i.endFlowNode, up(s, nr, Tr);
              }
              function Mi(r, i) {
                for (var t = e.startsWith(r.escapedName, "__#") ? e.factory.createPrivateIdentifier(r.escapedName.split("@")[1]) : e.unescapeLeadingUnderscores(r.escapedName), o = 0, s = i; o < s.length; o++) {
                  var u = s[o], h = e.factory.createPropertyAccessExpression(e.factory.createThis(), t);
                  e.setParent(h.expression, h), e.setParent(h, u), h.flowNode = u.returnFlowNode;
                  var z2 = ra(h, r);
                  if (n && (z2 === nr || z2 === So) && Xr(r.valueDeclaration, e.Diagnostics.Member_0_implicitly_has_an_1_type, tn(r), Ot(z2)), !gf(z2, d0)) return kv(z2);
                }
              }
              function st(r, i) {
                var t = e.startsWith(r.escapedName, "__#") ? e.factory.createPrivateIdentifier(r.escapedName.split("@")[1]) : e.unescapeLeadingUnderscores(r.escapedName), o = e.factory.createPropertyAccessExpression(e.factory.createThis(), t);
                e.setParent(o.expression, o), e.setParent(o, i), o.flowNode = i.returnFlowNode;
                var s = ra(o, r);
                return n && (s === nr || s === So) && Xr(r.valueDeclaration, e.Diagnostics.Member_0_implicitly_has_an_1_type, tn(r), Ot(s)), gf(s, d0) ? void 0 : kv(s);
              }
              function ra(r, i) {
                var t = (i == null ? void 0 : i.valueDeclaration) && (!Nr(i) || e.getEffectiveModifierFlags(i.valueDeclaration) & 2) && Lh(i) || Tr;
                return up(r, nr, t);
              }
              function Ta(r, i) {
                var t = e.getAssignedExpandoInitializer(r.valueDeclaration);
                if (t) {
                  var o = e.getJSDocTypeTag(t);
                  if (o && o.typeExpression) return Va(o.typeExpression);
                  var s = r.valueDeclaration && ha(r.valueDeclaration, r, t);
                  return s || Hp(Os(t));
                }
                var u, h = false, z2 = false;
                if (Le(r) && (u = st(r, ri(r))), !u) {
                  var me = void 0;
                  if (r.declarations) {
                    for (var Me = void 0, $e = 0, tr = r.declarations; $e < tr.length; $e++) {
                      var dr = tr[$e], Dr = e.isBinaryExpression(dr) || e.isCallExpression(dr) ? dr : e.isAccessExpression(dr) ? e.isBinaryExpression(dr.parent) ? dr.parent : dr : void 0;
                      if (!!Dr) {
                        var Qr = e.isAccessExpression(Dr) ? e.getAssignmentDeclarationPropertyAccessKind(Dr) : e.getAssignmentDeclarationKind(Dr);
                        (Qr === 4 || e.isBinaryExpression(Dr) && s0(Dr, Qr)) && (co(Dr) ? h = true : z2 = true), e.isCallExpression(Dr) || (Me = Na(Me, Dr, r, dr)), Me || (me || (me = [])).push(e.isBinaryExpression(Dr) || e.isCallExpression(Dr) ? In(r, i, Dr, Qr) : ui);
                      }
                    }
                    u = Me;
                  }
                  if (!u) {
                    if (!e.length(me)) return Pe;
                    var li = h && r.declarations ? ts(me, r.declarations) : void 0;
                    if (z2) {
                      var Ti = Lh(r);
                      Ti && ((li || (li = [])).push(Ti), h = true);
                    }
                    var Ci = e.some(li, function(Zi) {
                      return !!(Zi.flags & -98305);
                    }) ? li : me;
                    u = Pa(Ci);
                  }
                }
                var $i = $c(kc(u, false, z2 && !h));
                return r.valueDeclaration && ec($i, function(Zi) {
                  return !!(Zi.flags & -98305);
                }) === ui ? (Xp(r.valueDeclaration, Oe), Oe) : $i;
              }
              function ha(r, i, t) {
                var o, s;
                if (!(!e.isInJSFile(r) || !t || !e.isObjectLiteralExpression(t) || t.properties.length)) {
                  for (var u = e.createSymbolTable(); e.isBinaryExpression(r) || e.isPropertyAccessExpression(r); ) {
                    var h = Et(r);
                    !((o = h == null ? void 0 : h.exports) === null || o === void 0) && o.size && gu(u, h.exports), r = e.isBinaryExpression(r) ? r.parent : r.parent.parent;
                  }
                  var z2 = Et(r);
                  !((s = z2 == null ? void 0 : z2.exports) === null || s === void 0) && s.size && gu(u, z2.exports);
                  var me = rs(i, u, e.emptyArray, e.emptyArray, e.emptyArray);
                  return me.objectFlags |= 4096, me;
                }
              }
              function Na(r, i, t, o) {
                var s, u = e.getEffectiveTypeAnnotationNode(i.parent);
                if (u) {
                  var h = $c(Va(u));
                  if (r) !nn(r) && !nn(h) && !wf(r, h) && v6(void 0, r, o, h);
                  else return h;
                }
                if (!((s = t.parent) === null || s === void 0) && s.valueDeclaration) {
                  var z2 = e.getEffectiveTypeAnnotationNode(t.parent.valueDeclaration);
                  if (z2) {
                    var me = bi(Va(z2), t.escapedName);
                    if (me) return ml(me);
                  }
                }
                return r;
              }
              function In(r, i, t, o) {
                if (e.isCallExpression(t)) {
                  if (i) return Jt(i);
                  var s = Os(t.arguments[2]), u = da(s, "value");
                  if (u) return u;
                  var h = da(s, "get");
                  if (h) {
                    var z2 = ig(h);
                    if (z2) return yo(z2);
                  }
                  var me = da(s, "set");
                  if (me) {
                    var Me = ig(me);
                    if (Me) return aS(Me);
                  }
                  return Oe;
                }
                if (qo(t.left, t.right)) return Oe;
                var $e = o === 1 && (e.isPropertyAccessExpression(t.left) || e.isElementAccessExpression(t.left)) && (e.isModuleExportsAccessExpression(t.left.expression) || e.isIdentifier(t.left.expression) && e.isExportsIdentifier(t.left.expression)), tr = i ? Jt(i) : $e ? jc(Os(t.right)) : Hp(Os(t.right));
                if (tr.flags & 524288 && o === 2 && r.escapedName === "export=") {
                  var dr = Ru(tr), Dr = e.createSymbolTable();
                  e.copyEntries(dr.members, Dr);
                  var Qr = Dr.size;
                  i && !i.exports && (i.exports = e.createSymbolTable()), (i || r).exports.forEach(function(Ti, Ci) {
                    var $i, Zi = Dr.get(Ci);
                    if (Zi && Zi !== Ti) if (Ti.flags & 111551 && Zi.flags & 111551) {
                      if (Ti.valueDeclaration && Zi.valueDeclaration && e.getSourceFileOfNode(Ti.valueDeclaration) !== e.getSourceFileOfNode(Zi.valueDeclaration)) {
                        var qt = e.unescapeLeadingUnderscores(Ti.escapedName), Nt = (($i = e.tryCast(Zi.valueDeclaration, e.isNamedDeclaration)) === null || $i === void 0 ? void 0 : $i.name) || Zi.valueDeclaration;
                        e.addRelatedInfo(Xr(Ti.valueDeclaration, e.Diagnostics.Duplicate_identifier_0, qt), e.createDiagnosticForNode(Nt, e.Diagnostics._0_was_also_declared_here, qt)), e.addRelatedInfo(Xr(Nt, e.Diagnostics.Duplicate_identifier_0, qt), e.createDiagnosticForNode(Ti.valueDeclaration, e.Diagnostics._0_was_also_declared_here, qt));
                      }
                      var Ra = oo(Ti.flags | Zi.flags, Ci);
                      Ra.type = Pa([Jt(Ti), Jt(Zi)]), Ra.valueDeclaration = Zi.valueDeclaration, Ra.declarations = e.concatenate(Zi.declarations, Ti.declarations), Dr.set(Ci, Ra);
                    } else Dr.set(Ci, Bf(Ti, Zi));
                    else Dr.set(Ci, Ti);
                  });
                  var li = rs(Qr !== Dr.size ? void 0 : dr.symbol, Dr, dr.callSignatures, dr.constructSignatures, dr.indexInfos);
                  return li.objectFlags |= e.getObjectFlags(tr) & 4096, li.symbol && li.symbol.flags & 32 && tr === aa(li.symbol) && (li.objectFlags |= 16777216), li;
                }
                return Jh(tr) ? (Xp(t, mo), mo) : tr;
              }
              function qo(r, i) {
                return e.isPropertyAccessExpression(r) && r.expression.kind === 108 && e.forEachChildRecursively(i, function(t) {
                  return zs(r, t);
                });
              }
              function co(r) {
                var i = e.getThisContainer(r, false);
                return i.kind === 171 || i.kind === 256 || i.kind === 213 && !e.isPrototypePropertyAssignment(i.parent);
              }
              function ts(r, i) {
                return e.Debug.assert(r.length === i.length), r.filter(function(t, o) {
                  var s = i[o], u = e.isBinaryExpression(s) ? s : e.isBinaryExpression(s.parent) ? s.parent : void 0;
                  return u && co(u);
                });
              }
              function vs(r, i, t) {
                if (r.initializer) {
                  var o = e.isBindingPattern(r.name) ? Qu(r.name, true, false) : gr;
                  return kc(_S(r, wy(r, 0, o)));
                }
                return e.isBindingPattern(r.name) ? Qu(r.name, i, t) : (t && !Yu(r) && Xp(r, Oe), i ? fr : Oe);
              }
              function Ac(r, i, t) {
                var o = e.createSymbolTable(), s, u = 131200;
                e.forEach(r.elements, function(z2) {
                  var me = z2.propertyName || z2.name;
                  if (z2.dotDotDotToken) {
                    s = zl(Li, Oe, false);
                    return;
                  }
                  var Me = Z_(me);
                  if (!_f(Me)) {
                    u |= 512;
                    return;
                  }
                  var $e = pf(Me), tr = 4 | (z2.initializer ? 16777216 : 0), dr = oo(tr, $e);
                  dr.type = vs(z2, i, t), dr.bindingElement = z2, o.set(dr.escapedName, dr);
                });
                var h = rs(void 0, o, e.emptyArray, e.emptyArray, s ? [s] : e.emptyArray);
                return h.objectFlags |= u, i && (h.pattern = r, h.objectFlags |= 131072), h;
              }
              function Is(r, i, t) {
                var o = r.elements, s = e.lastOrUndefined(o), u = s && s.kind === 203 && s.dotDotDotToken ? s : void 0;
                if (o.length === 0 || o.length === 1 && u) return Ae >= 2 ? B3(Oe) : mo;
                var h = e.map(o, function($e) {
                  return e.isOmittedExpression($e) ? Oe : vs($e, i, t);
                }), z2 = e.findLastIndex(o, function($e) {
                  return !($e === u || e.isOmittedExpression($e) || pm($e));
                }, o.length - 1) + 1, me = e.map(o, function($e, tr) {
                  return $e === u ? 4 : tr >= z2 ? 2 : 1;
                }), Me = Wl(h, me);
                return i && (Me = ux(Me), Me.pattern = r, Me.objectFlags |= 131072), Me;
              }
              function Qu(r, i, t) {
                return i === void 0 && (i = false), t === void 0 && (t = false), r.kind === 201 ? Ac(r, i, t) : Is(r, i, t);
              }
              function sc(r, i) {
                return Mc(G_(r, true, 0), r, i);
              }
              function bc(r) {
                var i = Et(r), t = x3(false);
                return t && i && i === t;
              }
              function Mc(r, i, t) {
                return r ? (r.flags & 4096 && bc(i.parent) && (r = CD(i)), t && Kh(i, r), r.flags & 8192 && (e.isBindingElement(i) || !i.type) && r.symbol !== Et(i) && (r = Ki), $c(r)) : (r = e.isParameter(i) && i.dotDotDotToken ? mo : Oe, t && (Yu(i) || Xp(i, r)), r);
              }
              function Yu(r) {
                var i = e.getRootDeclaration(r), t = i.kind === 164 ? i.parent : i;
                return I0(t);
              }
              function Rl(r) {
                var i = e.getEffectiveTypeAnnotationNode(r);
                if (i) return Va(i);
              }
              function Lc(r) {
                var i = Aa(r);
                if (!i.type) {
                  var t = _(r);
                  i.type || (i.type = t);
                }
                return i.type;
              }
              function _(r) {
                if (r.flags & 4194304) return Sa(r);
                if (r === qr) return Oe;
                if (r.flags & 134217728 && r.valueDeclaration) {
                  var i = Et(e.getSourceFileOfNode(r.valueDeclaration)), t = oo(i.flags, "exports");
                  t.declarations = i.declarations ? i.declarations.slice() : [], t.parent = r, t.target = i, i.valueDeclaration && (t.valueDeclaration = i.valueDeclaration), i.members && (t.members = new e.Map(i.members)), i.exports && (t.exports = new e.Map(i.exports));
                  var o = e.createSymbolTable();
                  return o.set("exports", t), rs(r, o, e.emptyArray, e.emptyArray, e.emptyArray);
                }
                e.Debug.assertIsDefined(r.valueDeclaration);
                var s = r.valueDeclaration;
                if (e.isCatchClauseVariableDeclarationOrBindingElement(s)) {
                  var u = e.getEffectiveTypeAnnotationNode(s);
                  if (u === void 0) return be ? gr : Oe;
                  var h = Bd(u);
                  return ta(h) || h === gr ? h : Pe;
                }
                if (e.isSourceFile(s) && e.isJsonSourceFile(s)) return s.statements.length ? $c(Hp(yn(s.statements[0].expression))) : Ba;
                if (e.isAccessor(s)) return rt(r);
                if (!yu(r, 0)) return r.flags & 512 && !(r.flags & 67108864) ? vo(r) : lg(r);
                var z2;
                if (s.kind === 271) z2 = Mc(Rl(s) || Os(s.expression), s);
                else if (e.isBinaryExpression(s) || e.isInJSFile(s) && (e.isCallExpression(s) || (e.isPropertyAccessExpression(s) || e.isBindableStaticElementAccessExpression(s)) && e.isBinaryExpression(s.parent))) z2 = Ta(r);
                else if (e.isPropertyAccessExpression(s) || e.isElementAccessExpression(s) || e.isIdentifier(s) || e.isStringLiteralLike(s) || e.isNumericLiteral(s) || e.isClassDeclaration(s) || e.isFunctionDeclaration(s) || e.isMethodDeclaration(s) && !e.isObjectLiteralMethod(s) || e.isMethodSignature(s) || e.isSourceFile(s)) {
                  if (r.flags & 9136) return vo(r);
                  z2 = e.isBinaryExpression(s.parent) ? Ta(r) : Rl(s) || Oe;
                } else if (e.isPropertyAssignment(s)) z2 = Rl(s) || Kk(s);
                else if (e.isJsxAttribute(s)) z2 = Rl(s) || OC(s);
                else if (e.isShorthandPropertyAssignment(s)) z2 = Rl(s) || Dm(s.name, 0);
                else if (e.isObjectLiteralMethod(s)) z2 = Rl(s) || Gk(s, 0);
                else if (e.isParameter(s) || e.isPropertyDeclaration(s) || e.isPropertySignature(s) || e.isVariableDeclaration(s) || e.isBindingElement(s) || e.isJSDocPropertyLikeTag(s)) z2 = sc(s, true);
                else if (e.isEnumDeclaration(s)) z2 = vo(r);
                else if (e.isEnumMember(s)) z2 = H_(r);
                else return e.Debug.fail("Unhandled declaration kind! " + e.Debug.formatSyntaxKind(s.kind) + " for " + e.Debug.formatSymbol(r));
                return fi() ? z2 : r.flags & 512 && !(r.flags & 67108864) ? vo(r) : lg(r);
              }
              function W(r) {
                if (r) if (r.kind === 172) {
                  var i = e.getEffectiveReturnTypeNode(r);
                  return i;
                } else {
                  var t = e.getEffectiveSetAccessorTypeAnnotationNode(r);
                  return t;
                }
              }
              function Te(r) {
                var i = W(r);
                return i && Va(i);
              }
              function cr(r) {
                var i = qS(r);
                return i && i.symbol;
              }
              function ni(r) {
                return T_(yl(r));
              }
              function rt(r) {
                var i = Aa(r);
                if (!i.type) {
                  if (!yu(r, 0)) return Pe;
                  var t = e.getDeclarationOfKind(r, 172), o = e.getDeclarationOfKind(r, 173), s = t && e.isInJSFile(t) && K_(t) || Te(t) || Te(o) || t && t.body && C0(t);
                  s || (o && !I0(o) ? Ic(n, o, e.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation, tn(r)) : t && !I0(t) && Ic(n, t, e.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation, tn(r)), s = Oe), fi() || (W(t) ? Xr(t, e.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, tn(r)) : W(o) ? Xr(o, e.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, tn(r)) : t && n && Xr(t, e.Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions, tn(r)), s = Oe), i.type = s;
                }
                return i.type;
              }
              function yt(r) {
                var i = Aa(r);
                if (!i.writeType) {
                  if (!yu(r, 8)) return Pe;
                  var t = e.getDeclarationOfKind(r, 173), o = Te(t);
                  fi() || (W(t) && Xr(t, e.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, tn(r)), o = Oe), i.writeType = o || rt(r);
                }
                return i.writeType;
              }
              function Xa(r) {
                var i = Bl(aa(r));
                return i.flags & 8650752 ? i : i.flags & 2097152 ? e.find(i.types, function(t) {
                  return !!(t.flags & 8650752);
                }) : void 0;
              }
              function vo(r) {
                var i = Aa(r), t = i;
                if (!i.type) {
                  var o = r.valueDeclaration && T0(r.valueDeclaration, false);
                  if (o) {
                    var s = iS(r, o);
                    s && (r = i = s);
                  }
                  t.type = i.type = Vs(r);
                }
                return i.type;
              }
              function Vs(r) {
                var i = r.valueDeclaration;
                if (r.flags & 1536 && e.isShorthandAmbientModuleSymbol(r)) return Oe;
                if (i && (i.kind === 221 || e.isAccessExpression(i) && i.parent.kind === 221)) return Ta(r);
                if (r.flags & 512 && i && e.isSourceFile(i) && i.commonJsModuleIndicator) {
                  var t = Us(r);
                  if (t !== r) {
                    if (!yu(r, 0)) return Pe;
                    var o = so(r.exports.get("export=")), s = Ta(o, o === t ? void 0 : t);
                    return fi() ? s : lg(r);
                  }
                }
                var u = tu(16, r);
                if (r.flags & 32) {
                  var h = Xa(r);
                  return h ? Do([u, h]) : u;
                } else return Ye && r.flags & 16777216 ? i_(u) : u;
              }
              function H_(r) {
                var i = Aa(r);
                return i.type || (i.type = hu(r));
              }
              function y_(r) {
                var i = Aa(r);
                if (!i.type) {
                  var t = Ps(r), o = r.declarations && Ec(ru(r), true), s = e.firstDefined(o == null ? void 0 : o.declarations, function(u) {
                    return e.isExportAssignment(u) ? Rl(u) : void 0;
                  });
                  i.type = (o == null ? void 0 : o.declarations) && z0(o.declarations) && r.declarations.length ? di(o) : z0(r.declarations) ? nr : s || (t.flags & 111551 ? Jt(t) : Pe);
                }
                return i.type;
              }
              function Dd(r) {
                var i = Aa(r);
                return i.type || (i.type = un(Jt(i.target), i.mapper));
              }
              function jp(r) {
                var i = Aa(r);
                return i.writeType || (i.writeType = un(Vg(i.target), i.mapper));
              }
              function lg(r) {
                var i = r.valueDeclaration;
                return e.getEffectiveTypeAnnotationNode(i) ? (Xr(r.valueDeclaration, e.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, tn(r)), Pe) : (n && (i.kind !== 164 || i.initializer) && Xr(r.valueDeclaration, e.Diagnostics._0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer, tn(r)), Oe);
              }
              function Om(r) {
                var i = Aa(r);
                return i.type || (e.Debug.assertIsDefined(i.deferralParent), e.Debug.assertIsDefined(i.deferralConstituents), i.type = i.deferralParent.flags & 1048576 ? Pa(i.deferralConstituents) : Do(i.deferralConstituents)), i.type;
              }
              function Fm(r) {
                var i = Aa(r);
                return !i.writeType && i.deferralWriteConstituents && (e.Debug.assertIsDefined(i.deferralParent), e.Debug.assertIsDefined(i.deferralConstituents), i.writeType = i.deferralParent.flags & 1048576 ? Pa(i.deferralWriteConstituents) : Do(i.deferralWriteConstituents)), i.writeType;
              }
              function Vg(r) {
                var i = e.getCheckFlags(r);
                return r.flags & 4 ? i & 2 ? i & 65536 ? Fm(r) || Om(r) : r.writeType || r.type : Jt(r) : r.flags & 98304 ? i & 1 ? jp(r) : yt(r) : Jt(r);
              }
              function Jt(r) {
                var i = e.getCheckFlags(r);
                return i & 65536 ? Om(r) : i & 1 ? Dd(r) : i & 262144 ? J1(r) : i & 8192 ? qw(r) : r.flags & 7 ? Lc(r) : r.flags & 9136 ? vo(r) : r.flags & 8 ? H_(r) : r.flags & 98304 ? rt(r) : r.flags & 2097152 ? y_(r) : Pe;
              }
              function ml(r) {
                return kg(Jt(r), !!(r.flags & 16777216));
              }
              function Xf(r, i) {
                return r !== void 0 && i !== void 0 && (e.getObjectFlags(r) & 4) !== 0 && r.target === i;
              }
              function bd(r) {
                return e.getObjectFlags(r) & 4 ? r.target : r;
              }
              function lf(r, i) {
                return t(r);
                function t(o) {
                  if (e.getObjectFlags(o) & 7) {
                    var s = bd(o);
                    return s === i || e.some(Qc(s), t);
                  } else if (o.flags & 2097152) return e.some(o.types, t);
                  return false;
                }
              }
              function Kg(r, i) {
                for (var t = 0, o = i; t < o.length; t++) {
                  var s = o[t];
                  r = e.appendIfUnique(r, Js(Et(s)));
                }
                return r;
              }
              function kf(r, i) {
                for (; ; ) {
                  if (r = r.parent, r && e.isBinaryExpression(r)) {
                    var t = e.getAssignmentDeclarationKind(r);
                    if (t === 6 || t === 3) {
                      var o = Et(r.left);
                      o && o.parent && !e.findAncestor(o.parent.valueDeclaration, function(me) {
                        return r === me;
                      }) && (r = o.parent.valueDeclaration);
                    }
                  }
                  if (!r) return;
                  switch (r.kind) {
                    case 257:
                    case 226:
                    case 258:
                    case 174:
                    case 175:
                    case 168:
                    case 179:
                    case 180:
                    case 317:
                    case 256:
                    case 169:
                    case 213:
                    case 214:
                    case 259:
                    case 344:
                    case 345:
                    case 339:
                    case 338:
                    case 195:
                    case 189: {
                      var s = kf(r, i);
                      if (r.kind === 195) return e.append(s, Js(Et(r.typeParameter)));
                      if (r.kind === 189) return e.concatenate(s, eE(r));
                      var u = Kg(s, e.getEffectiveTypeParameterDeclarations(r)), h = i && (r.kind === 257 || r.kind === 226 || r.kind === 258 || Sl(r)) && aa(Et(r)).thisType;
                      return h ? e.append(u, h) : u;
                    }
                    case 340:
                      var z2 = e.getParameterSymbolFromJSDoc(r);
                      z2 && (r = z2.valueDeclaration);
                      break;
                    case 320: {
                      var s = kf(r, i);
                      return r.tags ? Kg(s, e.flatMap(r.tags, function(Me) {
                        return e.isJSDocTemplateTag(Me) ? Me.typeParameters : void 0;
                      })) : s;
                    }
                  }
                }
              }
              function Gg(r) {
                var i = r.flags & 32 ? r.valueDeclaration : e.getDeclarationOfKind(r, 258);
                return e.Debug.assert(!!i, "Class was missing valueDeclaration -OR- non-class had no interface declarations"), kf(i);
              }
              function Af(r) {
                if (!!r.declarations) {
                  for (var i, t = 0, o = r.declarations; t < o.length; t++) {
                    var s = o[t];
                    if (s.kind === 258 || s.kind === 257 || s.kind === 226 || Sl(s) || e.isTypeAlias(s)) {
                      var u = s;
                      i = Kg(i, e.getEffectiveTypeParameterDeclarations(u));
                    }
                  }
                  return i;
                }
              }
              function Hg(r) {
                return e.concatenate(Gg(r), Af(r));
              }
              function Wd(r) {
                var i = ot(r, 1);
                if (i.length === 1) {
                  var t = i[0];
                  if (!t.typeParameters && t.parameters.length === 1 && H(t)) {
                    var o = mv(t.parameters[0]);
                    return ta(o) || KD(o) === Oe;
                  }
                }
                return false;
              }
              function qd(r) {
                if (ot(r, 1).length > 0) return true;
                if (r.flags & 8650752) {
                  var i = uc(r);
                  return !!i && Wd(i);
                }
                return false;
              }
              function fg(r) {
                var i = e.getClassLikeDeclarationOfSymbol(r.symbol);
                return i && e.getEffectiveBaseTypeNode(i);
              }
              function Mm(r, i, t) {
                var o = e.length(i), s = e.isInJSFile(t);
                return e.filter(ot(r, 1), function(u) {
                  return (s || o >= Ul(u.typeParameters)) && o <= e.length(u.typeParameters);
                });
              }
              function Xg(r, i, t) {
                var o = Mm(r, i, t), s = e.map(i, Va);
                return e.sameMap(o, function(u) {
                  return e.some(u.typeParameters) ? Xm(u, s, e.isInJSFile(t)) : u;
                });
              }
              function Bl(r) {
                if (!r.resolvedBaseConstructorType) {
                  var i = e.getClassLikeDeclarationOfSymbol(r.symbol), t = i && e.getEffectiveBaseTypeNode(i), o = fg(r);
                  if (!o) return r.resolvedBaseConstructorType = Tr;
                  if (!yu(r, 1)) return Pe;
                  var s = yn(o.expression);
                  if (t && o !== t && (e.Debug.assert(!t.typeArguments), yn(t.expression)), s.flags & 2621440 && Ru(s), !fi()) return Xr(r.symbol.valueDeclaration, e.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_base_expression, tn(r.symbol)), r.resolvedBaseConstructorType = Pe;
                  if (!(s.flags & 1) && s !== ct && !qd(s)) {
                    var u = Xr(o.expression, e.Diagnostics.Type_0_is_not_a_constructor_function_type, Ot(s));
                    if (s.flags & 262144) {
                      var h = tm(s), z2 = gr;
                      if (h) {
                        var me = ot(h, 1);
                        me[0] && (z2 = yo(me[0]));
                      }
                      s.symbol.declarations && e.addRelatedInfo(u, e.createDiagnosticForNode(s.symbol.declarations[0], e.Diagnostics.Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1, tn(s.symbol), Ot(z2)));
                    }
                    return r.resolvedBaseConstructorType = Pe;
                  }
                  r.resolvedBaseConstructorType = s;
                }
                return r.resolvedBaseConstructorType;
              }
              function Qg(r) {
                var i = e.emptyArray;
                if (r.symbol.declarations) for (var t = 0, o = r.symbol.declarations; t < o.length; t++) {
                  var s = o[t], u = e.getEffectiveImplementsTypeNodes(s);
                  if (!!u) for (var h = 0, z2 = u; h < z2.length; h++) {
                    var me = z2[h], Me = Va(me);
                    nn(Me) || (i === e.emptyArray ? i = [Me] : i.push(Me));
                  }
                }
                return i;
              }
              function _g(r, i) {
                Xr(r, e.Diagnostics.Type_0_recursively_references_itself_as_a_base_type, Ot(i, void 0, 2));
              }
              function Qc(r) {
                if (!r.baseTypesResolved) {
                  if (yu(r, 7) && (r.objectFlags & 8 ? r.resolvedBaseTypes = [Lm(r)] : r.symbol.flags & 96 ? (r.symbol.flags & 32 && Up(r), r.symbol.flags & 64 && It(r)) : e.Debug.fail("type must be class or interface"), !fi() && r.symbol.declarations)) for (var i = 0, t = r.symbol.declarations; i < t.length; i++) {
                    var o = t[i];
                    (o.kind === 257 || o.kind === 258) && _g(o, r);
                  }
                  r.baseTypesResolved = true;
                }
                return r.resolvedBaseTypes;
              }
              function Lm(r) {
                var i = e.sameMap(r.typeParameters, function(t, o) {
                  return r.elementFlags[o] & 8 ? Jc(t, nt) : t;
                });
                return Zs(Pa(i || e.emptyArray), r.readonly);
              }
              function Up(r) {
                r.resolvedBaseTypes = e.resolvingEmptyArray;
                var i = $s(Bl(r));
                if (!(i.flags & 2621441)) return r.resolvedBaseTypes = e.emptyArray;
                var t = fg(r), o, s = i.symbol ? go(i.symbol) : void 0;
                if (i.symbol && i.symbol.flags & 32 && Rm(s)) o = lx(t, i.symbol);
                else if (i.flags & 1) o = i;
                else {
                  var u = Xg(i, t.typeArguments, t);
                  if (!u.length) return Xr(t.expression, e.Diagnostics.No_base_constructor_has_the_specified_number_of_type_arguments), r.resolvedBaseTypes = e.emptyArray;
                  o = yo(u[0]);
                }
                if (nn(o)) return r.resolvedBaseTypes = e.emptyArray;
                var h = bu(o);
                if (!ff(h)) {
                  var z2 = ei(void 0, o), me = e.chainDiagnosticMessages(z2, e.Diagnostics.Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members, Ot(h));
                  return rn.add(e.createDiagnosticForNodeFromMessageChain(t.expression, me)), r.resolvedBaseTypes = e.emptyArray;
                }
                return r === h || lf(h, r) ? (Xr(r.symbol.valueDeclaration, e.Diagnostics.Type_0_recursively_references_itself_as_a_base_type, Ot(r, void 0, 2)), r.resolvedBaseTypes = e.emptyArray) : (r.resolvedBaseTypes === e.resolvingEmptyArray && (r.members = void 0), r.resolvedBaseTypes = [h]);
              }
              function Rm(r) {
                var i = r.outerTypeParameters;
                if (i) {
                  var t = i.length - 1, o = xo(r);
                  return i[t].symbol !== o[t].symbol;
                }
                return true;
              }
              function ff(r) {
                if (r.flags & 262144) {
                  var i = uc(r);
                  if (i) return ff(i);
                }
                return !!(r.flags & 67633153 && !Bc(r) || r.flags & 2097152 && e.every(r.types, ff));
              }
              function It(r) {
                if (r.resolvedBaseTypes = r.resolvedBaseTypes || e.emptyArray, r.symbol.declarations) for (var i = 0, t = r.symbol.declarations; i < t.length; i++) {
                  var o = t[i];
                  if (o.kind === 258 && e.getInterfaceBaseTypeNodes(o)) for (var s = 0, u = e.getInterfaceBaseTypeNodes(o); s < u.length; s++) {
                    var h = u[s], z2 = bu(Va(h));
                    nn(z2) || (ff(z2) ? r !== z2 && !lf(z2, r) ? r.resolvedBaseTypes === e.emptyArray ? r.resolvedBaseTypes = [z2] : r.resolvedBaseTypes.push(z2) : _g(o, r) : Xr(h, e.Diagnostics.An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members));
                  }
                }
              }
              function Ma(r) {
                if (!r.declarations) return true;
                for (var i = 0, t = r.declarations; i < t.length; i++) {
                  var o = t[i];
                  if (o.kind === 258) {
                    if (o.flags & 128) return false;
                    var s = e.getInterfaceBaseTypeNodes(o);
                    if (s) for (var u = 0, h = s; u < h.length; u++) {
                      var z2 = h[u];
                      if (e.isEntityNameExpression(z2.expression)) {
                        var me = Ds(z2.expression, 788968, true);
                        if (!me || !(me.flags & 64) || aa(me).thisType) return false;
                      }
                    }
                  }
                }
                return true;
              }
              function aa(r) {
                var i = Aa(r), t = i;
                if (!i.declaredType) {
                  var o = r.flags & 32 ? 1 : 2, s = iS(r, r.valueDeclaration && F7(r.valueDeclaration));
                  s && (r = i = s);
                  var u = t.declaredType = i.declaredType = tu(o, r), h = Gg(r), z2 = Af(r);
                  (h || z2 || o === 1 || !Ma(r)) && (u.objectFlags |= 4, u.typeParameters = e.concatenate(h, z2), u.outerTypeParameters = h, u.localTypeParameters = z2, u.instantiations = new e.Map(), u.instantiations.set(Su(u.typeParameters), u), u.target = u, u.resolvedTypeArguments = u.typeParameters, u.thisType = Hc(r), u.thisType.isThisType = true, u.thisType.constraint = u);
                }
                return i.declaredType;
              }
              function Ja(r) {
                var i, t = Aa(r);
                if (!t.declaredType) {
                  if (!yu(r, 2)) return Pe;
                  var o = e.Debug.checkDefined((i = r.declarations) === null || i === void 0 ? void 0 : i.find(e.isTypeAlias), "Type alias symbol with no valid declaration found"), s = e.isJSDocTypeAlias(o) ? o.typeExpression : o.type, u = s ? Va(s) : Pe;
                  if (fi()) {
                    var h = Af(r);
                    h && (t.typeParameters = h, t.instantiations = new e.Map(), t.instantiations.set(Su(h), u));
                  } else u = Pe, o.kind === 339 ? Xr(o.typeExpression.type, e.Diagnostics.Type_alias_0_circularly_references_itself, tn(r)) : Xr(e.isNamedDeclaration(o) ? o.name : o || o, e.Diagnostics.Type_alias_0_circularly_references_itself, tn(r));
                  t.declaredType = u;
                }
                return t.declaredType;
              }
              function _n(r) {
                return e.isStringLiteralLike(r) ? true : r.kind === 221 ? _n(r.left) && _n(r.right) : false;
              }
              function ro(r) {
                var i = r.initializer;
                if (!i) return !(r.flags & 16777216);
                switch (i.kind) {
                  case 10:
                  case 8:
                  case 14:
                    return true;
                  case 219:
                    return i.operator === 40 && i.operand.kind === 8;
                  case 79:
                    return e.nodeIsMissing(i) || !!Et(r.parent).exports.get(i.escapedText);
                  case 221:
                    return _n(i);
                  default:
                    return false;
                }
              }
              function as(r) {
                var i = Aa(r);
                if (i.enumKind !== void 0) return i.enumKind;
                var t = false;
                if (r.declarations) for (var o = 0, s = r.declarations; o < s.length; o++) {
                  var u = s[o];
                  if (u.kind === 260) for (var h = 0, z2 = u.members; h < z2.length; h++) {
                    var me = z2[h];
                    if (me.initializer && e.isStringLiteralLike(me.initializer)) return i.enumKind = 1;
                    ro(me) || (t = true);
                  }
                }
                return i.enumKind = t ? 0 : 1;
              }
              function cc(r) {
                return r.flags & 1024 && !(r.flags & 1048576) ? go(Ys(r.symbol)) : r;
              }
              function Sc(r) {
                var i = Aa(r);
                if (i.declaredType) return i.declaredType;
                if (as(r) === 1) {
                  Re++;
                  var t = [];
                  if (r.declarations) for (var o = 0, s = r.declarations; o < s.length; o++) {
                    var u = s[o];
                    if (u.kind === 260) for (var h = 0, z2 = u.members; h < z2.length; h++) {
                      var me = z2[h], Me = H0(me), $e = Sg(NI(Me !== void 0 ? Me : 0, Re, Et(me)));
                      Aa(Et(me)).declaredType = $e, t.push(jc($e));
                    }
                  }
                  if (t.length) {
                    var tr = Pa(t, 1, r, void 0);
                    return tr.flags & 1048576 && (tr.flags |= 1024, tr.symbol = r), i.declaredType = tr;
                  }
                }
                var dr = mc(32);
                return dr.symbol = r, i.declaredType = dr;
              }
              function hu(r) {
                var i = Aa(r);
                if (!i.declaredType) {
                  var t = Sc(Ys(r));
                  i.declaredType || (i.declaredType = t);
                }
                return i.declaredType;
              }
              function Js(r) {
                var i = Aa(r);
                return i.declaredType || (i.declaredType = Hc(r));
              }
              function Qf(r) {
                var i = Aa(r);
                return i.declaredType || (i.declaredType = go(Ps(r)));
              }
              function go(r) {
                return Vd(r) || Pe;
              }
              function Vd(r) {
                if (r.flags & 96) return aa(r);
                if (r.flags & 524288) return Ja(r);
                if (r.flags & 262144) return Js(r);
                if (r.flags & 384) return Sc(r);
                if (r.flags & 8) return hu(r);
                if (r.flags & 2097152) return Qf(r);
              }
              function X_(r) {
                switch (r.kind) {
                  case 130:
                  case 155:
                  case 150:
                  case 147:
                  case 158:
                  case 133:
                  case 151:
                  case 148:
                  case 114:
                  case 153:
                  case 143:
                  case 196:
                    return true;
                  case 183:
                    return X_(r.elementType);
                  case 178:
                    return !r.typeArguments || r.typeArguments.every(X_);
                }
                return false;
              }
              function Sd(r) {
                var i = e.getEffectiveConstraintOfTypeParameter(r);
                return !i || X_(i);
              }
              function Yg(r) {
                var i = e.getEffectiveTypeAnnotationNode(r);
                return i ? X_(i) : !e.hasInitializer(r);
              }
              function N1(r) {
                var i = e.getEffectiveReturnTypeNode(r), t = e.getEffectiveTypeParameterDeclarations(r);
                return (r.kind === 171 || !!i && X_(i)) && r.parameters.every(Yg) && t.every(Sd);
              }
              function P1(r) {
                if (r.declarations && r.declarations.length === 1) {
                  var i = r.declarations[0];
                  if (i) switch (i.kind) {
                    case 167:
                    case 166:
                      return Yg(i);
                    case 169:
                    case 168:
                    case 171:
                    case 172:
                    case 173:
                      return N1(i);
                  }
                }
                return false;
              }
              function Yy(r, i, t) {
                for (var o = e.createSymbolTable(), s = 0, u = r; s < u.length; s++) {
                  var h = u[s];
                  o.set(h.escapedName, t && P1(h) ? h : AD(h, i));
                }
                return o;
              }
              function Bm(r, i) {
                for (var t = 0, o = i; t < o.length; t++) {
                  var s = o[t];
                  !r.has(s.escapedName) && !$y(s) && r.set(s.escapedName, s);
                }
              }
              function $y(r) {
                return !!r.valueDeclaration && e.isPrivateIdentifierClassElementDeclaration(r.valueDeclaration) && e.isStatic(r.valueDeclaration);
              }
              function Lv(r) {
                if (!r.declaredProperties) {
                  var i = r.symbol, t = Nf(i);
                  r.declaredProperties = tf(t), r.declaredCallSignatures = e.emptyArray, r.declaredConstructSignatures = e.emptyArray, r.declaredIndexInfos = e.emptyArray, r.declaredCallSignatures = S_(t.get("__call")), r.declaredConstructSignatures = S_(t.get("__new")), r.declaredIndexInfos = ax(i);
                }
                return r;
              }
              function _f(r) {
                return !!(r.flags & 8576);
              }
              function Rv(r) {
                if (!e.isComputedPropertyName(r) && !e.isElementAccessExpression(r)) return false;
                var i = e.isComputedPropertyName(r) ? r.expression : r.argumentExpression;
                return e.isEntityNameExpression(i) && _f(e.isComputedPropertyName(r) ? t_(r) : Os(i));
              }
              function pg(r) {
                return r.charCodeAt(0) === 95 && r.charCodeAt(1) === 95 && r.charCodeAt(2) === 64;
              }
              function $g(r) {
                var i = e.getNameOfDeclaration(r);
                return !!i && Rv(i);
              }
              function Td(r) {
                return !e.hasDynamicName(r) || $g(r);
              }
              function I1(r) {
                return e.isDynamicName(r) && !Rv(r);
              }
              function pf(r) {
                return r.flags & 8192 ? r.escapedName : r.flags & 384 ? e.escapeLeadingUnderscores("" + r.value) : e.Debug.fail();
              }
              function Bv(r, i, t) {
                e.Debug.assert(!!(e.getCheckFlags(r) & 4096), "Expected a late-bound symbol."), r.flags |= t, Aa(i.symbol).lateSymbol = r, r.declarations ? i.symbol.isReplaceableByMethod || r.declarations.push(i) : r.declarations = [i], t & 111551 && (!r.valueDeclaration || r.valueDeclaration.kind !== i.kind) && (r.valueDeclaration = i);
              }
              function Zy(r, i, t, o) {
                e.Debug.assert(!!o.symbol, "The member is expected to have a symbol.");
                var s = va(o);
                if (!s.resolvedSymbol) {
                  s.resolvedSymbol = o.symbol;
                  var u = e.isBinaryExpression(o) ? o.left : o.name, h = e.isElementAccessExpression(u) ? Os(u.argumentExpression) : t_(u);
                  if (_f(h)) {
                    var z2 = pf(h), me = o.symbol.flags, Me = t.get(z2);
                    Me || t.set(z2, Me = oo(0, z2, 4096));
                    var $e = i && i.get(z2);
                    if (Me.flags & I_(me) || $e) {
                      var tr = $e ? e.concatenate($e.declarations, Me.declarations) : Me.declarations, dr = !(h.flags & 8192) && e.unescapeLeadingUnderscores(z2) || e.declarationNameToString(u);
                      e.forEach(tr, function(Dr) {
                        return Xr(e.getNameOfDeclaration(Dr) || Dr, e.Diagnostics.Property_0_was_also_declared_here, dr);
                      }), Xr(u || o, e.Diagnostics.Duplicate_property_0, dr), Me = oo(0, z2, 4096);
                    }
                    return Me.nameType = h, Bv(Me, o, me), Me.parent ? e.Debug.assert(Me.parent === r, "Existing symbol parent should match new one") : Me.parent = r, s.resolvedSymbol = Me;
                  }
                }
                return s.resolvedSymbol;
              }
              function Jv(r, i) {
                var t = Aa(r);
                if (!t[i]) {
                  var o = i === "resolvedExports", s = o ? r.flags & 1536 ? Iu(r) : r.exports : r.members;
                  t[i] = s || we;
                  for (var u = e.createSymbolTable(), h = 0, z2 = r.declarations || e.emptyArray; h < z2.length; h++) {
                    var me = z2[h], Me = e.getMembersOfDeclaration(me);
                    if (Me) for (var $e = 0, tr = Me; $e < tr.length; $e++) {
                      var dr = tr[$e];
                      o === e.hasStaticModifier(dr) && $g(dr) && Zy(r, s, u, dr);
                    }
                  }
                  var Dr = r.assignmentDeclarationMembers;
                  if (Dr) for (var Qr = e.arrayFrom(Dr.values()), li = 0, Ti = Qr; li < Ti.length; li++) {
                    var dr = Ti[li], Ci = e.getAssignmentDeclarationKind(dr), $i = Ci === 3 || e.isBinaryExpression(dr) && s0(dr, Ci) || Ci === 9 || Ci === 6;
                    o === !$i && $g(dr) && Zy(r, s, u, dr);
                  }
                  t[i] = hp(s, u) || we;
                }
                return t[i];
              }
              function Nf(r) {
                return r.flags & 6256 ? Jv(r, "resolvedMembers") : r.members || we;
              }
              function dg(r) {
                if (r.flags & 106500 && r.escapedName === "__computed") {
                  var i = Aa(r);
                  if (!i.lateSymbol && e.some(r.declarations, $g)) {
                    var t = so(r.parent);
                    e.some(r.declarations, e.hasStaticModifier) ? dc(t) : Nf(t);
                  }
                  return i.lateSymbol || (i.lateSymbol = r);
                }
                return r;
              }
              function Rc(r, i, t) {
                if (e.getObjectFlags(r) & 4) {
                  var o = r.target, s = xo(r);
                  if (e.length(o.typeParameters) === e.length(s)) {
                    var u = Yf(o, e.concatenate(s, [i || o.thisType]));
                    return t ? $s(u) : u;
                  }
                } else if (r.flags & 2097152) {
                  var h = e.sameMap(r.types, function(z2) {
                    return Rc(z2, i, t);
                  });
                  return h !== r.types ? Do(h) : r;
                }
                return t ? $s(r) : r;
              }
              function jv(r, i, t, o) {
                var s, u, h, z2, me;
                e.rangeEquals(t, o, 0, t.length) ? (u = i.symbol ? Nf(i.symbol) : e.createSymbolTable(i.declaredProperties), h = i.declaredCallSignatures, z2 = i.declaredConstructSignatures, me = i.declaredIndexInfos) : (s = Uc(t, o), u = Yy(i.declaredProperties, s, t.length === 1), h = Ah(i.declaredCallSignatures, s), z2 = Ah(i.declaredConstructSignatures, s), me = oE(i.declaredIndexInfos, s));
                var Me = Qc(i);
                if (Me.length) {
                  i.symbol && u === Nf(i.symbol) && (u = e.createSymbolTable(i.declaredProperties)), Oc(r, u, h, z2, me);
                  for (var $e = e.lastOrUndefined(o), tr = 0, dr = Me; tr < dr.length; tr++) {
                    var Dr = dr[tr], Qr = $e ? Rc(un(Dr, s), $e) : Dr;
                    Bm(u, uo(Qr)), h = e.concatenate(h, ot(Qr, 0)), z2 = e.concatenate(z2, ot(Qr, 1));
                    var li = Qr !== Oe ? Hn(Qr) : [zl(Li, Oe, false)];
                    me = e.concatenate(me, e.filter(li, function(Ti) {
                      return !xa(me, Ti.keyType);
                    }));
                  }
                }
                Oc(r, u, h, z2, me);
              }
              function eh(r) {
                jv(r, Lv(r), e.emptyArray, e.emptyArray);
              }
              function rh(r) {
                var i = Lv(r.target), t = e.concatenate(i.typeParameters, [i.thisType]), o = xo(r), s = o.length === t.length ? o : e.concatenate(o, [r]);
                jv(r, i, t, s);
              }
              function Fu(r, i, t, o, s, u, h, z2) {
                var me = new Z(Di, z2);
                return me.declaration = r, me.typeParameters = i, me.parameters = o, me.thisParameter = t, me.resolvedReturnType = s, me.resolvedTypePredicate = u, me.minArgumentCount = h, me.resolvedMinArgumentCount = void 0, me.target = void 0, me.mapper = void 0, me.compositeSignatures = void 0, me.compositeKind = void 0, me;
              }
              function xd(r) {
                var i = Fu(r.declaration, r.typeParameters, r.thisParameter, r.parameters, void 0, void 0, r.minArgumentCount, r.flags & 39);
                return i.target = r.target, i.mapper = r.mapper, i.compositeSignatures = r.compositeSignatures, i.compositeKind = r.compositeKind, i;
              }
              function Uv(r, i) {
                var t = xd(r);
                return t.compositeSignatures = i, t.compositeKind = 1048576, t.target = void 0, t.mapper = void 0, t;
              }
              function w1(r, i) {
                if ((r.flags & 24) === i) return r;
                r.optionalCallSignatureCache || (r.optionalCallSignatureCache = {});
                var t = i === 8 ? "inner" : "outer";
                return r.optionalCallSignatureCache[t] || (r.optionalCallSignatureCache[t] = ih(r, i));
              }
              function ih(r, i) {
                e.Debug.assert(i === 8 || i === 16, "An optional call signature can either be for an inner call chain or an outer call chain, but not both.");
                var t = xd(r);
                return t.flags |= i, t;
              }
              function Jm(r, i) {
                if (H(r)) {
                  var t = r.parameters.length - 1, o = Jt(r.parameters[t]);
                  if (Yn(o)) return [s(o, t)];
                  if (!i && o.flags & 1048576 && e.every(o.types, Yn)) return e.map(o.types, function(u) {
                    return s(u, t);
                  });
                }
                return [r.parameters];
                function s(u, h) {
                  var z2 = xo(u), me = u.target.labeledElementDeclarations, Me = e.map(z2, function($e, tr) {
                    var dr = !!me && E0(me[tr]), Dr = dr || vm(r, h + tr, u), Qr = u.target.elementFlags[tr], li = Qr & 12 ? 32768 : Qr & 2 ? 16384 : 0, Ti = oo(1, Dr, li);
                    return Ti.type = Qr & 4 ? Zs($e) : $e, Ti;
                  });
                  return e.concatenate(r.parameters.slice(0, h), Me);
                }
              }
              function th(r) {
                var i = Bl(r), t = ot(i, 1), o = e.getClassLikeDeclarationOfSymbol(r.symbol), s = !!o && e.hasSyntacticModifier(o, 128);
                if (t.length === 0) return [Fu(void 0, r.localTypeParameters, void 0, e.emptyArray, r, void 0, 0, s ? 4 : 0)];
                for (var u = fg(r), h = e.isInJSFile(u), z2 = bh(u), me = e.length(z2), Me = [], $e = 0, tr = t; $e < tr.length; $e++) {
                  var dr = tr[$e], Dr = Ul(dr.typeParameters), Qr = e.length(dr.typeParameters);
                  if (h || me >= Dr && me <= Qr) {
                    var li = Qr ? mh(dr, zp(z2, dr.typeParameters, Dr, h)) : xd(dr);
                    li.typeParameters = r.localTypeParameters, li.resolvedReturnType = r, li.flags = s ? li.flags | 4 : li.flags & -5, Me.push(li);
                  }
                }
                return Me;
              }
              function gg(r, i, t, o, s) {
                for (var u = 0, h = r; u < h.length; u++) {
                  var z2 = h[u];
                  if (_y(z2, i, t, o, s, t ? XI : av)) return z2;
                }
              }
              function O1(r, i, t) {
                if (i.typeParameters) {
                  if (t > 0) return;
                  for (var o = 1; o < r.length; o++) if (!gg(r[o], i, false, false, false)) return;
                  return [i];
                }
                for (var s, o = 0; o < r.length; o++) {
                  var u = o === t ? i : gg(r[o], i, true, false, true);
                  if (!u) return;
                  s = e.appendIfUnique(s, u);
                }
                return s;
              }
              function zv(r) {
                for (var i, t, o = 0; o < r.length; o++) {
                  if (r[o].length === 0) return e.emptyArray;
                  r[o].length > 1 && (t = t === void 0 ? o : -1);
                  for (var s = 0, u = r[o]; s < u.length; s++) {
                    var h = u[s];
                    if (!i || !gg(i, h, false, false, true)) {
                      var z2 = O1(r, h, o);
                      if (z2) {
                        var me = h;
                        if (z2.length > 1) {
                          var Me = h.thisParameter, $e = e.forEach(z2, function(Zi) {
                            return Zi.thisParameter;
                          });
                          if ($e) {
                            var tr = Do(e.mapDefined(z2, function(Zi) {
                              return Zi.thisParameter && Jt(Zi.thisParameter);
                            }));
                            Me = eg($e, tr);
                          }
                          me = Uv(h, z2), me.thisParameter = Me;
                        }
                        (i || (i = [])).push(me);
                      }
                    }
                  }
                }
                if (!e.length(i) && t !== -1) {
                  for (var dr = r[t !== void 0 ? t : 0], Dr = dr.slice(), Qr = function(Zi) {
                    if (Zi !== dr) {
                      var qt = Zi[0];
                      if (e.Debug.assert(!!qt, "getUnionSignatures bails early on empty signature lists and should not have empty lists on second pass"), Dr = !!qt.typeParameters && e.some(Dr, function(Nt) {
                        return !!Nt.typeParameters && !ah(qt.typeParameters, Nt.typeParameters);
                      }) ? void 0 : e.map(Dr, function(Nt) {
                        return M1(Nt, qt);
                      }), !Dr) return "break";
                    }
                  }, li = 0, Ti = r; li < Ti.length; li++) {
                    var Ci = Ti[li], $i = Qr(Ci);
                    if ($i === "break") break;
                  }
                  i = Dr;
                }
                return i || e.emptyArray;
              }
              function ah(r, i) {
                if (e.length(r) !== e.length(i)) return false;
                if (!r || !i) return true;
                for (var t = Uc(i, r), o = 0; o < r.length; o++) {
                  var s = r[o], u = i[o];
                  if (s !== u && !wf(tm(s) || gr, un(tm(u) || gr, t))) return false;
                }
                return true;
              }
              function F1(r, i, t) {
                if (!r || !i) return r || i;
                var o = Do([Jt(r), un(Jt(i), t)]);
                return eg(r, o);
              }
              function nh(r, i, t) {
                for (var o = Wc(r), s = Wc(i), u = o >= s ? r : i, h = u === r ? i : r, z2 = u === r ? o : s, me = Xl(r) || Xl(i), Me = me && !Xl(u), $e = new Array(z2 + (Me ? 1 : 0)), tr = 0; tr < z2; tr++) {
                  var dr = Ld(u, tr);
                  u === i && (dr = un(dr, t));
                  var Dr = Ld(h, tr) || gr;
                  h === i && (Dr = un(Dr, t));
                  var Qr = Do([dr, Dr]), li = me && !Me && tr === z2 - 1, Ti = tr >= Hl(u) && tr >= Hl(h), Ci = tr >= o ? void 0 : vm(r, tr), $i = tr >= s ? void 0 : vm(i, tr), Zi = Ci === $i ? Ci : Ci ? $i ? void 0 : Ci : $i, qt = oo(1 | (Ti && !li ? 16777216 : 0), Zi || "arg".concat(tr));
                  qt.type = li ? Zs(Qr) : Qr, $e[tr] = qt;
                }
                if (Me) {
                  var Nt = oo(1, "args");
                  Nt.type = Zs($u(h, z2)), h === i && (Nt.type = un(Nt.type, t)), $e[z2] = Nt;
                }
                return $e;
              }
              function M1(r, i) {
                var t = r.typeParameters || i.typeParameters, o;
                r.typeParameters && i.typeParameters && (o = Uc(i.typeParameters, r.typeParameters));
                var s = r.declaration, u = nh(r, i, o), h = F1(r.thisParameter, i.thisParameter, o), z2 = Math.max(r.minArgumentCount, i.minArgumentCount), me = Fu(s, t, h, u, void 0, void 0, z2, (r.flags | i.flags) & 39);
                return me.compositeKind = 1048576, me.compositeSignatures = e.concatenate(r.compositeKind !== 2097152 && r.compositeSignatures || [r], [i]), o && (me.mapper = r.compositeKind !== 2097152 && r.mapper && r.compositeSignatures ? np(r.mapper, o) : o), me;
              }
              function oh(r) {
                var i = Hn(r[0]);
                if (i) {
                  for (var t = [], o = function(z2) {
                    var me = z2.keyType;
                    e.every(r, function(Me) {
                      return !!ss(Me, me);
                    }) && t.push(zl(me, Pa(e.map(r, function(Me) {
                      return cs(Me, me);
                    })), e.some(r, function(Me) {
                      return ss(Me, me).isReadonly;
                    })));
                  }, s = 0, u = i; s < u.length; s++) {
                    var h = u[s];
                    o(h);
                  }
                  return t;
                }
                return e.emptyArray;
              }
              function jm(r) {
                var i = zv(e.map(r.types, function(s) {
                  return s === br ? [Wn] : ot(s, 0);
                })), t = zv(e.map(r.types, function(s) {
                  return ot(s, 1);
                })), o = oh(r.types);
                Oc(r, we, i, t, o);
              }
              function Zg(r, i) {
                return r ? i ? Do([r, i]) : r : i;
              }
              function Wv(r) {
                var i = e.countWhere(r, function(s) {
                  return ot(s, 1).length > 0;
                }), t = e.map(r, Wd);
                if (i > 0 && i === e.countWhere(t, function(s) {
                  return s;
                })) {
                  var o = t.indexOf(true);
                  t[o] = false;
                }
                return t;
              }
              function sh(r, i, t, o) {
                for (var s = [], u = 0; u < i.length; u++) u === o ? s.push(r) : t[u] && s.push(yo(ot(i[u], 1)[0]));
                return Do(s);
              }
              function L1(r) {
                for (var i, t, o, s = r.types, u = Wv(s), h = e.countWhere(u, function(Me) {
                  return Me;
                }), z2 = function(Me) {
                  var $e = r.types[Me];
                  if (!u[Me]) {
                    var tr = ot($e, 1);
                    tr.length && h > 0 && (tr = e.map(tr, function(dr) {
                      var Dr = xd(dr);
                      return Dr.resolvedReturnType = sh(yo(dr), s, u, Me), Dr;
                    })), t = ch(t, tr);
                  }
                  i = ch(i, ot($e, 0)), o = e.reduceLeft(Hn($e), function(dr, Dr) {
                    return uh(dr, Dr, false);
                  }, o);
                }, me = 0; me < s.length; me++) z2(me);
                Oc(r, we, i || e.emptyArray, t || e.emptyArray, o || e.emptyArray);
              }
              function ch(r, i) {
                for (var t = function(h) {
                  (!r || e.every(r, function(z2) {
                    return !_y(z2, h, false, false, false, av);
                  })) && (r = e.append(r, h));
                }, o = 0, s = i; o < s.length; o++) {
                  var u = s[o];
                  t(u);
                }
                return r;
              }
              function uh(r, i, t) {
                if (r) for (var o = 0; o < r.length; o++) {
                  var s = r[o];
                  if (s.keyType === i.keyType) return r[o] = zl(s.keyType, t ? Pa([s.type, i.type]) : Do([s.type, i.type]), t ? s.isReadonly || i.isReadonly : s.isReadonly && i.isReadonly), r;
                }
                return e.append(r, i);
              }
              function R1(r) {
                if (r.target) {
                  Oc(r, we, e.emptyArray, e.emptyArray, e.emptyArray);
                  var i = Yy(Pf(r.target), r.mapper, false), t = Ah(ot(r.target, 0), r.mapper), o = Ah(ot(r.target, 1), r.mapper), s = oE(Hn(r.target), r.mapper);
                  Oc(r, i, t, o, s);
                  return;
                }
                var u = so(r.symbol);
                if (u.flags & 2048) {
                  Oc(r, we, e.emptyArray, e.emptyArray, e.emptyArray);
                  var h = Nf(u), t = S_(h.get("__call")), o = S_(h.get("__new")), z2 = ax(u);
                  Oc(r, h, t, o, z2);
                  return;
                }
                var me = we, Me;
                if (u.exports && (me = dc(u), u === pe)) {
                  var $e = new e.Map();
                  me.forEach(function(Ti) {
                    var Ci;
                    !(Ti.flags & 418) && !(Ti.flags & 512 && ((Ci = Ti.declarations) === null || Ci === void 0 ? void 0 : Ci.length) && e.every(Ti.declarations, e.isAmbientModule)) && $e.set(Ti.escapedName, Ti);
                  }), me = $e;
                }
                var tr;
                if (Oc(r, me, e.emptyArray, e.emptyArray, e.emptyArray), u.flags & 32) {
                  var dr = aa(u), Dr = Bl(dr);
                  Dr.flags & 11272192 ? (me = e.createSymbolTable(z_(me)), Bm(me, uo(Dr))) : Dr === Oe && (tr = zl(Li, Oe, false));
                }
                var Qr = rD(me);
                if (Qr ? Me = nx(Qr) : (tr && (Me = e.append(Me, tr)), u.flags & 384 && (go(u).flags & 32 || e.some(r.properties, function(Ti) {
                  return !!(Jt(Ti).flags & 296);
                })) && (Me = e.append(Me, Ko))), Oc(r, me, e.emptyArray, e.emptyArray, Me || e.emptyArray), u.flags & 8208 && (r.callSignatures = S_(u)), u.flags & 32) {
                  var li = aa(u), o = u.members ? S_(u.members.get("__constructor")) : e.emptyArray;
                  u.flags & 16 && (o = e.addRange(o.slice(), e.mapDefined(r.callSignatures, function(Ci) {
                    return Sl(Ci.declaration) ? Fu(Ci.declaration, Ci.typeParameters, Ci.thisParameter, Ci.parameters, li, void 0, Ci.minArgumentCount, Ci.flags & 39) : void 0;
                  }))), o.length || (o = th(li)), r.constructSignatures = o;
                }
              }
              function lh(r, i, t) {
                return un(r, Uc([i.indexType, i.objectType], [If(0), Wl([t])]));
              }
              function B1(r) {
                for (var i = ss(r.source, Li), t = Lu(r.mappedType), o = !(t & 1), s = t & 4 ? 0 : 16777216, u = i ? [zl(Li, Hh(i.type, r.mappedType, r.constraintType), o && i.isReadonly)] : e.emptyArray, h = e.createSymbolTable(), z2 = 0, me = uo(r.source); z2 < me.length; z2++) {
                  var Me = me[z2], $e = 8192 | (o && Zu(Me) ? 8 : 0), tr = oo(4 | Me.flags & s, Me.escapedName, $e);
                  if (tr.declarations = Me.declarations, tr.nameType = Aa(Me).nameType, tr.propertyType = Jt(Me), r.constraintType.type.flags & 8388608 && r.constraintType.type.objectType.flags & 262144 && r.constraintType.type.indexType.flags & 262144) {
                    var dr = r.constraintType.type.objectType, Dr = lh(r.mappedType, r.constraintType.type, dr);
                    tr.mappedType = Dr, tr.constraintType = ql(dr);
                  } else tr.mappedType = r.mappedType, tr.constraintType = r.constraintType;
                  h.set(Me.escapedName, tr);
                }
                Oc(r, h, e.emptyArray, e.emptyArray, u);
              }
              function Kd(r) {
                if (r.flags & 4194304) {
                  var i = $s(r.type);
                  return lm(i) ? Mx(i) : ql(i);
                }
                if (r.flags & 16777216) {
                  if (r.root.isDistributive) {
                    var t = r.checkType, o = Kd(t);
                    if (o !== t) return ID(r, $d(r.root.checkType, o, r.mapper));
                  }
                  return r;
                }
                return r.flags & 1048576 ? Ss(r, Kd) : r.flags & 2097152 ? Do(e.sameMap(r.types, Kd)) : r;
              }
              function Gd(r) {
                return e.getCheckFlags(r) & 4096;
              }
              function Um(r, i, t, o) {
                for (var s = 0, u = uo(r); s < u.length; s++) {
                  var h = u[s];
                  o(om(h, i));
                }
                if (r.flags & 1) o(Li);
                else for (var z2 = 0, me = Hn(r); z2 < me.length; z2++) {
                  var Me = me[z2];
                  (!t || Me.keyType.flags & 134217732) && o(Me.keyType);
                }
              }
              function fh(r) {
                var i = e.createSymbolTable(), t;
                Oc(r, we, e.emptyArray, e.emptyArray, e.emptyArray);
                var o = Du(r), s = Mu(r), u = Jl(r.target || r), h = vl(r.target || r), z2 = $s(Ed(r)), me = Lu(r), Me = Ge ? 128 : 8576;
                mg(r) ? Um(z2, Me, Ge, $e) : Od(Kd(s), $e), Oc(r, i, e.emptyArray, e.emptyArray, t || e.emptyArray);
                function $e(dr) {
                  var Dr = u ? un(u, tv(r.mapper, o, dr)) : dr;
                  Od(Dr, function(Qr) {
                    return tr(dr, Qr);
                  });
                }
                function tr(dr, Dr) {
                  if (_f(Dr)) {
                    var Qr = pf(Dr), li = i.get(Qr);
                    if (li) li.nameType = Pa([li.nameType, Dr]), li.keyType = Pa([li.keyType, dr]);
                    else {
                      var Ti = _f(dr) ? bi(z2, pf(dr)) : void 0, Ci = !!(me & 4 || !(me & 8) && Ti && Ti.flags & 16777216), $i = !!(me & 1 || !(me & 2) && Ti && Zu(Ti)), Zi = Ye && !Ci && Ti && Ti.flags & 16777216, qt = Ti ? Gd(Ti) : 0, Nt = oo(4 | (Ci ? 16777216 : 0), Qr, qt | 262144 | ($i ? 8 : 0) | (Zi ? 524288 : 0));
                      Nt.mappedType = r, Nt.nameType = Dr, Nt.keyType = dr, Ti && (Nt.syntheticOrigin = Ti, Nt.declarations = u ? void 0 : Ti.declarations), i.set(Qr, Nt);
                    }
                  } else if (vh(Dr) || Dr.flags & 33) {
                    var Ra = Dr.flags & 5 ? Li : Dr.flags & 40 ? nt : Dr, ca = un(h, tv(r.mapper, o, dr)), Sn = zl(Ra, ca, !!(me & 1));
                    t = uh(t, Sn, true);
                  }
                }
              }
              function J1(r) {
                if (!r.type) {
                  var i = r.mappedType;
                  if (!yu(r, 0)) return i.containsError = true, Pe;
                  var t = vl(i.target || i), o = tv(i.mapper, Du(i), r.keyType), s = un(t, o), u = Ye && r.flags & 16777216 && !fs(s, 49152) ? i_(s, true) : r.checkFlags & 524288 ? $D(s) : s;
                  fi() || (Xr(Ie, e.Diagnostics.Type_of_property_0_circularly_references_itself_in_mapped_type_1, tn(r), Ot(i)), u = Pe), r.type = u;
                }
                return r.type;
              }
              function Du(r) {
                return r.typeParameter || (r.typeParameter = Js(Et(r.declaration.typeParameter)));
              }
              function Mu(r) {
                return r.constraintType || (r.constraintType = Tc(Du(r)) || Pe);
              }
              function Jl(r) {
                return r.declaration.nameType ? r.nameType || (r.nameType = un(Va(r.declaration.nameType), r.mapper)) : void 0;
              }
              function vl(r) {
                return r.templateType || (r.templateType = r.declaration.type ? un(kc(Va(r.declaration.type), true, !!(Lu(r) & 4)), r.mapper) : Pe);
              }
              function _h(r) {
                return e.getEffectiveConstraintOfTypeParameter(r.declaration.typeParameter);
              }
              function mg(r) {
                var i = _h(r);
                return i.kind === 193 && i.operator === 140;
              }
              function Ed(r) {
                if (!r.modifiersType) if (mg(r)) r.modifiersType = un(Va(_h(r).type), r.mapper);
                else {
                  var i = yD(r.declaration), t = Mu(i), o = t && t.flags & 262144 ? Tc(t) : t;
                  r.modifiersType = o && o.flags & 4194304 ? un(o.type, r.mapper) : gr;
                }
                return r.modifiersType;
              }
              function Lu(r) {
                var i = r.declaration;
                return (i.readonlyToken ? i.readonlyToken.kind === 40 ? 2 : 1 : 0) | (i.questionToken ? i.questionToken.kind === 40 ? 8 : 4 : 0);
              }
              function ph(r) {
                var i = Lu(r);
                return i & 8 ? -1 : i & 4 ? 1 : 0;
              }
              function qv(r) {
                var i = ph(r), t = Ed(r);
                return i || (Bc(t) ? ph(t) : 0);
              }
              function j1(r) {
                return !!(e.getObjectFlags(r) & 32 && Lu(r) & 4);
              }
              function Bc(r) {
                return !!(e.getObjectFlags(r) & 32) && qp(Mu(r));
              }
              function Ru(r) {
                return r.members || (r.flags & 524288 ? r.objectFlags & 4 ? rh(r) : r.objectFlags & 3 ? eh(r) : r.objectFlags & 1024 ? B1(r) : r.objectFlags & 16 ? R1(r) : r.objectFlags & 32 && fh(r) : r.flags & 1048576 ? jm(r) : r.flags & 2097152 && L1(r)), r;
              }
              function Pf(r) {
                return r.flags & 524288 ? Ru(r).properties : e.emptyArray;
              }
              function h_(r, i) {
                if (r.flags & 524288) {
                  var t = Ru(r), o = t.members.get(i);
                  if (o && gc(o)) return o;
                }
              }
              function em(r) {
                if (!r.resolvedProperties) {
                  for (var i = e.createSymbolTable(), t = 0, o = r.types; t < o.length; t++) {
                    for (var s = o[t], u = 0, h = uo(s); u < h.length; u++) {
                      var z2 = h[u];
                      if (!i.has(z2.escapedName)) {
                        var me = Zv(r, z2.escapedName);
                        me && i.set(z2.escapedName, me);
                      }
                    }
                    if (r.flags & 1048576 && Hn(s).length === 0) break;
                  }
                  r.resolvedProperties = tf(i);
                }
                return r.resolvedProperties;
              }
              function uo(r) {
                return r = Xd(r), r.flags & 3145728 ? em(r) : Pf(r);
              }
              function U1(r, i) {
                r = Xd(r), r.flags & 3670016 && Ru(r).members.forEach(function(t, o) {
                  xf(t, o) && i(t, o);
                });
              }
              function z1(r, i) {
                var t = i.properties;
                return t.some(function(o) {
                  var s = o.name && Z_(o.name), u = s && _f(s) ? pf(s) : void 0, h = u === void 0 ? void 0 : da(r, u);
                  return !!h && Cg(h) && !ao(Bd(o), h);
                });
              }
              function W1(r) {
                var i = Pa(r);
                if (!(i.flags & 1048576)) return LS(i);
                for (var t = e.createSymbolTable(), o = 0, s = r; o < s.length; o++) for (var u = s[o], h = 0, z2 = LS(u); h < z2.length; h++) {
                  var me = z2[h].escapedName;
                  if (!t.has(me)) {
                    var Me = Yv(i, me);
                    Me && t.set(me, Me);
                  }
                }
                return e.arrayFrom(t.values());
              }
              function Q_(r) {
                return r.flags & 262144 ? Tc(r) : r.flags & 8388608 ? q1(r) : r.flags & 16777216 ? K1(r) : uc(r);
              }
              function Tc(r) {
                return Wm(r) ? tm(r) : void 0;
              }
              function q1(r) {
                return Wm(r) ? V1(r) : void 0;
              }
              function Vv(r) {
                var i = Zf(r, false);
                return i !== r ? i : Q_(r);
              }
              function V1(r) {
                if (Qv(r)) return xh(r.objectType, r.indexType);
                var i = Vv(r.indexType);
                if (i && i !== r.indexType) {
                  var t = ep(r.objectType, i, r.accessFlags);
                  if (t) return t;
                }
                var o = Vv(r.objectType);
                if (o && o !== r.objectType) return ep(o, r.indexType, r.accessFlags);
              }
              function zm(r) {
                if (!r.resolvedDefaultConstraint) {
                  var i = TI(r), t = tp(r);
                  r.resolvedDefaultConstraint = ta(i) ? t : ta(t) ? i : Pa([i, t]);
                }
                return r.resolvedDefaultConstraint;
              }
              function Kv(r) {
                if (r.root.isDistributive && r.restrictiveInstantiation !== r) {
                  var i = Zf(r.checkType, false), t = i === r.checkType ? Q_(i) : i;
                  if (t && t !== r.checkType) {
                    var o = ID(r, $d(r.root.checkType, t, r.mapper));
                    if (!(o.flags & 131072)) return o;
                  }
                }
              }
              function Gv(r) {
                return Kv(r) || zm(r);
              }
              function K1(r) {
                return Wm(r) ? Gv(r) : void 0;
              }
              function G1(r, i) {
                for (var t, o = false, s = 0, u = r; s < u.length; s++) {
                  var h = u[s];
                  if (h.flags & 465829888) {
                    for (var z2 = Q_(h); z2 && z2.flags & 21233664; ) z2 = Q_(z2);
                    z2 && (t = e.append(t, z2), i && (t = e.append(t, h)));
                  } else h.flags & 469892092 && (o = true);
                }
                if (t && (i || o)) {
                  if (o) for (var me = 0, Me = r; me < Me.length; me++) {
                    var h = Me[me];
                    h.flags & 469892092 && (t = e.append(t, h));
                  }
                  return Do(t);
                }
              }
              function uc(r) {
                if (r.flags & 464781312) {
                  var i = Hv(r);
                  return i !== Kn && i !== Pn ? i : void 0;
                }
                return r.flags & 4194304 ? at : void 0;
              }
              function Hd(r) {
                return uc(r) || r;
              }
              function Wm(r) {
                return Hv(r) !== Pn;
              }
              function Hv(r) {
                if (r.resolvedBaseConstraint) return r.resolvedBaseConstraint;
                var i = [];
                return r.resolvedBaseConstraint = Rc(t(r), r);
                function t(u) {
                  if (!u.immediateBaseConstraint) {
                    if (!yu(u, 4)) return Pn;
                    var h = void 0, z2 = ov(u);
                    if ((i.length < 10 || i.length < 50 && !e.contains(i, z2)) && (i.push(z2), h = s(Zf(u, false)), i.pop()), !fi()) {
                      if (u.flags & 262144) {
                        var me = ox(u);
                        if (me) {
                          var Me = Xr(me, e.Diagnostics.Type_parameter_0_has_a_circular_constraint, Ot(u));
                          Ie && !e.isNodeDescendantOf(me, Ie) && !e.isNodeDescendantOf(Ie, me) && e.addRelatedInfo(Me, e.createDiagnosticForNode(Ie, e.Diagnostics.Circularity_originates_in_type_at_this_location));
                        }
                      }
                      h = Pn;
                    }
                    u.immediateBaseConstraint = h || Kn;
                  }
                  return u.immediateBaseConstraint;
                }
                function o(u) {
                  var h = t(u);
                  return h !== Kn && h !== Pn ? h : void 0;
                }
                function s(u) {
                  if (u.flags & 262144) {
                    var h = tm(u);
                    return u.isThisType || !h ? h : o(h);
                  }
                  if (u.flags & 3145728) {
                    for (var z2 = u.types, me = [], Me = false, $e = 0, tr = z2; $e < tr.length; $e++) {
                      var dr = tr[$e], Dr = o(dr);
                      Dr ? (Dr !== dr && (Me = true), me.push(Dr)) : Me = true;
                    }
                    return Me ? u.flags & 1048576 && me.length === z2.length ? Pa(me) : u.flags & 2097152 && me.length ? Do(me) : void 0 : u;
                  }
                  if (u.flags & 4194304) return at;
                  if (u.flags & 134217728) {
                    var z2 = u.types, Qr = e.mapDefined(z2, o);
                    return Qr.length === z2.length ? Dg(u.texts, Qr) : Li;
                  }
                  if (u.flags & 268435456) {
                    var h = o(u.type);
                    return h ? Th(u.symbol, h) : Li;
                  }
                  if (u.flags & 8388608) {
                    if (Qv(u)) return o(xh(u.objectType, u.indexType));
                    var li = o(u.objectType), Ti = o(u.indexType), Ci = li && Ti && ep(li, Ti, u.accessFlags);
                    return Ci && o(Ci);
                  }
                  if (u.flags & 16777216) {
                    var h = Gv(u);
                    return h && o(h);
                  }
                  return u.flags & 33554432 ? o(u.substitute) : u;
                }
              }
              function H1(r) {
                return r.resolvedApparentType || (r.resolvedApparentType = Rc(r, r, true));
              }
              function Xv(r) {
                if (r.default) r.default === eo && (r.default = Pn);
                else if (r.target) {
                  var i = Xv(r.target);
                  r.default = i ? un(i, r.mapper) : Kn;
                } else {
                  r.default = eo;
                  var t = r.symbol && e.forEach(r.symbol.declarations, function(s) {
                    return e.isTypeParameterDeclaration(s) && s.default;
                  }), o = t ? Va(t) : Kn;
                  r.default === eo && (r.default = o);
                }
                return r.default;
              }
              function D_(r) {
                var i = Xv(r);
                return i !== Kn && i !== Pn ? i : void 0;
              }
              function X1(r) {
                return Xv(r) !== Pn;
              }
              function Q1(r) {
                return !!(r.symbol && e.forEach(r.symbol.declarations, function(i) {
                  return e.isTypeParameterDeclaration(i) && i.default;
                }));
              }
              function Y1(r) {
                return r.resolvedApparentType || (r.resolvedApparentType = dh(r));
              }
              function dh(r) {
                var i = Ih(r);
                if (i && !r.declaration.nameType) {
                  var t = Tc(i);
                  if (t && Pd(t)) return un(r, $d(i, t, r.mapper));
                }
                return r;
              }
              function Qv(r) {
                var i;
                return !!(r.flags & 8388608 && e.getObjectFlags(i = r.objectType) & 32 && !Bc(i) && qp(r.indexType) && !i.declaration.questionToken && !i.declaration.nameType);
              }
              function $s(r) {
                var i = r.flags & 465829888 ? uc(r) || gr : r;
                return e.getObjectFlags(i) & 32 ? Y1(i) : i.flags & 2097152 ? H1(i) : i.flags & 402653316 ? Ct : i.flags & 296 ? sa : i.flags & 2112 ? R3() : i.flags & 528 ? en : i.flags & 12288 ? Cx() : i.flags & 67108864 ? Ba : i.flags & 4194304 ? at : i.flags & 2 && !Ye ? Ba : i;
              }
              function Xd(r) {
                return bu($s(bu(r)));
              }
              function Yv(r, i, t) {
                for (var o, s, u, h, z2, me = r.flags & 1048576, Me = me ? 0 : 16777216, $e = 4, tr = me ? 0 : 8, dr = false, Dr = 0, Qr = r.types; Dr < Qr.length; Dr++) {
                  var li = Qr[Dr], Ti = $s(li);
                  if (!(nn(Ti) || Ti.flags & 131072)) {
                    var Ci = bi(Ti, i, t), $i = Ci ? e.getDeclarationModifierFlagsFromSymbol(Ci) : 0;
                    if (Ci) {
                      if (me ? Me |= Ci.flags & 16777216 : Me &= Ci.flags, !u) u = Ci;
                      else if (Ci !== u) {
                        var Zi = (jg(Ci) || Ci) === (jg(u) || u);
                        if (Zi && VD(u, Ci, function(Ka, cn) {
                          return Ka === cn ? -1 : 0;
                        }) === -1) dr = !!u.parent && !!e.length(Af(u.parent));
                        else {
                          h || (h = new e.Map(), h.set(y(u), u));
                          var qt = y(Ci);
                          h.has(qt) || h.set(qt, Ci);
                        }
                      }
                      me && Zu(Ci) ? tr |= 8 : !me && !Zu(Ci) && (tr &= -9), tr |= ($i & 24 ? 0 : 256) | ($i & 16 ? 512 : 0) | ($i & 8 ? 1024 : 0) | ($i & 32 ? 2048 : 0), Bb(Ci) || ($e = 2);
                    } else if (me) {
                      var Nt = !pg(i) && Xo(Ti, i);
                      Nt ? (tr |= 32 | (Nt.isReadonly ? 8 : 0), z2 = e.append(z2, Yn(Ti) ? sv(Ti) || Tr : Nt.type)) : Qp(Ti) && !(e.getObjectFlags(Ti) & 2097152) ? (tr |= 32, z2 = e.append(z2, Tr)) : tr |= 16;
                    }
                  }
                }
                if (!(!u || me && (h || tr & 48) && tr & 1536)) {
                  if (!h && !(tr & 16) && !z2) if (dr) {
                    var Ra = eg(u, u.type);
                    return Ra.parent = (s = (o = u.valueDeclaration) === null || o === void 0 ? void 0 : o.symbol) === null || s === void 0 ? void 0 : s.parent, Ra.containingType = r, Ra.mapper = u.mapper, Ra;
                  } else return u;
                  for (var ca = h ? e.arrayFrom(h.values()) : [u], Sn, ja, Fn, wn = [], Tn, Eo, lt = false, it = 0, Yt = ca; it < Yt.length; it++) {
                    var Ci = Yt[it];
                    Eo ? Ci.valueDeclaration && Ci.valueDeclaration !== Eo && (lt = true) : Eo = Ci.valueDeclaration, Sn = e.addRange(Sn, Ci.declarations);
                    var Ti = Jt(Ci);
                    ja || (ja = Ti, Fn = Aa(Ci).nameType);
                    var Ia = Vg(Ci);
                    Tn || Ia !== Ti ? Tn = e.append(Tn || wn.slice(), Ia) : Ti !== ja && (tr |= 64), (Cg(Ti) || sm(Ti) || Ti === Dn) && (tr |= 128), Ti.flags & 131072 && Ti !== Dn && (tr |= 131072), wn.push(Ti);
                  }
                  e.addRange(wn, z2);
                  var Qt = oo(4 | Me, i, $e | tr);
                  return Qt.containingType = r, !lt && Eo && (Qt.valueDeclaration = Eo, Eo.symbol.parent && (Qt.parent = Eo.symbol.parent)), Qt.declarations = Sn, Qt.nameType = Fn, wn.length > 2 ? (Qt.checkFlags |= 65536, Qt.deferralParent = r, Qt.deferralConstituents = wn, Qt.deferralWriteConstituents = Tn) : (Qt.type = me ? Pa(wn) : Do(wn), Tn && (Qt.writeType = me ? Pa(Tn) : Do(Tn))), Qt;
                }
              }
              function $v(r, i, t) {
                var o, s, u = ((o = r.propertyCacheWithoutObjectFunctionPropertyAugment) === null || o === void 0 ? void 0 : o.get(i)) || !t ? (s = r.propertyCache) === null || s === void 0 ? void 0 : s.get(i) : void 0;
                if (!u && (u = Yv(r, i, t), u)) {
                  var h = t ? r.propertyCacheWithoutObjectFunctionPropertyAugment || (r.propertyCacheWithoutObjectFunctionPropertyAugment = e.createSymbolTable()) : r.propertyCache || (r.propertyCache = e.createSymbolTable());
                  h.set(i, u);
                }
                return u;
              }
              function Zv(r, i, t) {
                var o = $v(r, i, t);
                return o && !(e.getCheckFlags(o) & 16) ? o : void 0;
              }
              function bu(r) {
                return r.flags & 1048576 && r.objectFlags & 16777216 ? r.resolvedReducedType || (r.resolvedReducedType = $1(r)) : r.flags & 2097152 ? (r.objectFlags & 16777216 || (r.objectFlags |= 16777216 | (e.some(em(r), c) ? 33554432 : 0)), r.objectFlags & 33554432 ? ui : r) : r;
              }
              function $1(r) {
                var i = e.sameMap(r.types, bu);
                if (i === r.types) return r;
                var t = Pa(i);
                return t.flags & 1048576 && (t.resolvedReducedType = t), t;
              }
              function c(r) {
                return te(r) || xr(r);
              }
              function te(r) {
                return !(r.flags & 16777216) && (e.getCheckFlags(r) & 131264) === 192 && !!(Jt(r).flags & 131072);
              }
              function xr(r) {
                return !r.valueDeclaration && !!(e.getCheckFlags(r) & 1024);
              }
              function ei(r, i) {
                if (i.flags & 2097152 && e.getObjectFlags(i) & 33554432) {
                  var t = e.find(em(i), te);
                  if (t) return e.chainDiagnosticMessages(r, e.Diagnostics.The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituents, Ot(i, void 0, 536870912), tn(t));
                  var o = e.find(em(i), xr);
                  if (o) return e.chainDiagnosticMessages(r, e.Diagnostics.The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_private_in_some, Ot(i, void 0, 536870912), tn(o));
                }
                return r;
              }
              function bi(r, i, t) {
                if (r = Xd(r), r.flags & 524288) {
                  var o = Ru(r), s = o.members.get(i);
                  if (s && gc(s)) return s;
                  if (t) return;
                  var u = o === xn ? br : o.callSignatures.length ? Zr : o.constructSignatures.length ? Si : void 0;
                  if (u) {
                    var h = h_(u, i);
                    if (h) return h;
                  }
                  return h_(qe, i);
                }
                if (r.flags & 3145728) return Zv(r, i, t);
              }
              function Ft(r, i) {
                if (r.flags & 3670016) {
                  var t = Ru(r);
                  return i === 0 ? t.callSignatures : t.constructSignatures;
                }
                return e.emptyArray;
              }
              function ot(r, i) {
                return Ft(Xd(r), i);
              }
              function xa(r, i) {
                return e.find(r, function(t) {
                  return t.keyType === i;
                });
              }
              function mn(r, i) {
                for (var t, o, s, u = 0, h = r; u < h.length; u++) {
                  var z2 = h[u];
                  z2.keyType === Li ? t = z2 : an(i, z2.keyType) && (o ? (s || (s = [o])).push(z2) : o = z2);
                }
                return s ? zl(gr, Do(e.map(s, function(me) {
                  return me.type;
                })), e.reduceLeft(s, function(me, Me) {
                  return me && Me.isReadonly;
                }, true)) : o || (t && an(i, Li) ? t : void 0);
              }
              function an(r, i) {
                return ao(r, i) || i === Li && ao(r, nt) || i === nt && (r === $a || !!(r.flags & 128) && e.isNumericLiteralName(r.value));
              }
              function To(r) {
                if (r.flags & 3670016) {
                  var i = Ru(r);
                  return i.indexInfos;
                }
                return e.emptyArray;
              }
              function Hn(r) {
                return To(Xd(r));
              }
              function ss(r, i) {
                return xa(Hn(r), i);
              }
              function cs(r, i) {
                var t;
                return (t = ss(r, i)) === null || t === void 0 ? void 0 : t.type;
              }
              function ws(r, i) {
                return Hn(r).filter(function(t) {
                  return an(i, t.keyType);
                });
              }
              function nu(r, i) {
                return mn(Hn(r), i);
              }
              function Xo(r, i) {
                return nu(r, pg(i) ? Ki : Bu(e.unescapeLeadingUnderscores(i)));
              }
              function jl(r) {
                for (var i, t = 0, o = e.getEffectiveTypeParameterDeclarations(r); t < o.length; t++) {
                  var s = o[t];
                  i = e.appendIfUnique(i, Js(s.symbol));
                }
                return i;
              }
              function Y_(r) {
                var i = [];
                return r.forEach(function(t, o) {
                  Ol(o) || i.push(t);
                }), i;
              }
              function Cd(r) {
                return e.isInJSFile(r) && (r.type && r.type.kind === 316 || e.getJSDocParameterTags(r).some(function(i) {
                  var t = i.isBracketed, o = i.typeExpression;
                  return t || !!o && o.type.kind === 316;
                }));
              }
              function b_(r, i) {
                if (!e.isExternalModuleNameRelative(r)) {
                  var t = qs(ii, '"' + r + '"', 512);
                  return t && i ? so(t) : t;
                }
              }
              function kd(r) {
                if (e.hasQuestionToken(r) || Vm(r) || Cd(r)) return true;
                if (r.initializer) {
                  var i = yl(r.parent), t = r.parent.parameters.indexOf(r);
                  return e.Debug.assert(t >= 0), t >= Hl(i, 3);
                }
                var o = e.getImmediatelyInvokedFunctionExpression(r.parent);
                return o ? !r.type && !r.dotDotDotToken && r.parent.parameters.indexOf(r) >= o.arguments.length : false;
              }
              function qm(r) {
                return e.isPropertyDeclaration(r) && r.questionToken;
              }
              function Vm(r) {
                if (!e.isJSDocPropertyLikeTag(r)) return false;
                var i = r.isBracketed, t = r.typeExpression;
                return i || !!t && t.type.kind === 316;
              }
              function vg(r, i, t, o) {
                return { kind: r, parameterName: i, parameterIndex: t, type: o };
              }
              function Ul(r) {
                var i = 0;
                if (r) for (var t = 0; t < r.length; t++) Q1(r[t]) || (i = t + 1);
                return i;
              }
              function zp(r, i, t, o) {
                var s = e.length(i);
                if (!s) return [];
                var u = e.length(r);
                if (o || u >= t && u <= s) {
                  for (var h = r ? r.slice() : [], z2 = u; z2 < s; z2++) h[z2] = Pe;
                  for (var me = fb(o), z2 = u; z2 < s; z2++) {
                    var Me = D_(i[z2]);
                    o && Me && (wf(Me, gr) || wf(Me, Ba)) && (Me = Oe), h[z2] = Me ? un(Me, Uc(i, h)) : me;
                  }
                  return h.length = i.length, h;
                }
                return r && r.slice();
              }
              function yl(r) {
                var i = va(r);
                if (!i.resolvedSignature) {
                  var t = [], o = 0, s = 0, u = void 0, h = false, z2 = e.getImmediatelyInvokedFunctionExpression(r), me = e.isJSDocConstructSignature(r), Me = !z2 && e.isInJSFile(r) && e.isValueSignatureDeclaration(r) && !e.hasJSDocParameterTags(r) && !e.getJSDocType(r);
                  Me && (o |= 32);
                  for (var $e = me ? 1 : 0; $e < r.parameters.length; $e++) {
                    var tr = r.parameters[$e], dr = tr.symbol, Dr = e.isJSDocParameterTag(tr) ? tr.typeExpression && tr.typeExpression.type : tr.type;
                    if (dr && !!(dr.flags & 4) && !e.isBindingPattern(tr.name)) {
                      var Qr = es(tr, dr.escapedName, 111551, void 0, void 0, false);
                      dr = Qr;
                    }
                    $e === 0 && dr.escapedName === "this" ? (h = true, u = tr.symbol) : t.push(dr), Dr && Dr.kind === 196 && (o |= 2);
                    var li = Vm(tr) || tr.initializer || tr.questionToken || e.isRestParameter(tr) || z2 && t.length > z2.arguments.length && !Dr || Cd(tr);
                    li || (s = t.length);
                  }
                  if ((r.kind === 172 || r.kind === 173) && Td(r) && (!h || !u)) {
                    var Ti = r.kind === 172 ? 173 : 172, Ci = e.getDeclarationOfKind(Et(r), Ti);
                    Ci && (u = cr(Ci));
                  }
                  var $i = r.kind === 171 ? aa(so(r.parent.symbol)) : void 0, Zi = $i ? $i.localTypeParameters : jl(r);
                  (e.hasRestParameter(r) || e.isInJSFile(r) && ey(r, t)) && (o |= 1), (e.isConstructorTypeNode(r) && e.hasSyntacticModifier(r, 128) || e.isConstructorDeclaration(r) && e.hasSyntacticModifier(r.parent, 128)) && (o |= 4), i.resolvedSignature = Fu(r, Zi, u, t, void 0, void 0, s, o);
                }
                return i.resolvedSignature;
              }
              function ey(r, i) {
                if (e.isJSDocSignature(r) || !Gm(r)) return false;
                var t = e.lastOrUndefined(r.parameters), o = t ? e.getJSDocParameterTags(t) : e.getJSDocTags(r).filter(e.isJSDocParameterTag), s = e.firstDefined(o, function(h) {
                  return h.typeExpression && e.isJSDocVariadicType(h.typeExpression.type) ? h.typeExpression.type : void 0;
                }), u = oo(3, "args", 32768);
                return s ? u.type = Zs(Va(s.type)) : (u.checkFlags |= 65536, u.deferralParent = ui, u.deferralConstituents = [mo], u.deferralWriteConstituents = [mo]), s && i.pop(), i.push(u), true;
              }
              function rm(r) {
                if (!!(e.isInJSFile(r) && e.isFunctionLikeDeclaration(r))) {
                  var i = e.getJSDocTypeTag(r);
                  return (i == null ? void 0 : i.typeExpression) && ig(Va(i.typeExpression));
                }
              }
              function Km(r, i) {
                var t = rm(r);
                if (!!t) {
                  var o = r.parameters.indexOf(i);
                  return i.dotDotDotToken ? ym(t, o) : $u(t, o);
                }
              }
              function ry(r) {
                var i = rm(r);
                return i && yo(i);
              }
              function Gm(r) {
                var i = va(r);
                return i.containsArgumentsReference === void 0 && (i.flags & 8192 ? i.containsArgumentsReference = true : i.containsArgumentsReference = t(r.body)), i.containsArgumentsReference;
                function t(o) {
                  if (!o) return false;
                  switch (o.kind) {
                    case 79:
                      return o.escapedText === or.escapedName && Nv(o) === or;
                    case 167:
                    case 169:
                    case 172:
                    case 173:
                      return o.name.kind === 162 && t(o.name);
                    case 206:
                    case 207:
                      return t(o.expression);
                    case 296:
                      return t(o.initializer);
                    default:
                      return !e.nodeStartsNewLexicalEnvironment(o) && !e.isPartOfTypeNode(o) && !!e.forEachChild(o, t);
                  }
                }
              }
              function S_(r) {
                if (!r || !r.declarations) return e.emptyArray;
                for (var i = [], t = 0; t < r.declarations.length; t++) {
                  var o = r.declarations[t];
                  if (!!e.isFunctionLike(o)) {
                    if (t > 0 && o.body) {
                      var s = r.declarations[t - 1];
                      if (o.parent === s.parent && o.kind === s.kind && o.pos === s.end) continue;
                    }
                    i.push(yl(o));
                  }
                }
                return i;
              }
              function Hm(r) {
                var i = ac(r, r);
                if (i) {
                  var t = Us(i);
                  if (t) return Jt(t);
                }
                return Oe;
              }
              function T_(r) {
                if (r.thisParameter) return Jt(r.thisParameter);
              }
              function Yc(r) {
                if (!r.resolvedTypePredicate) {
                  if (r.target) {
                    var i = Yc(r.target);
                    r.resolvedTypePredicate = i ? BI(i, r.mapper) : Ro;
                  } else if (r.compositeSignatures) r.resolvedTypePredicate = X3(r.compositeSignatures, r.compositeKind) || Ro;
                  else {
                    var t = r.declaration && e.getEffectiveReturnTypeNode(r.declaration), o = void 0;
                    if (!t && e.isInJSFile(r.declaration)) {
                      var s = rm(r.declaration);
                      s && r !== s && (o = Yc(s));
                    }
                    r.resolvedTypePredicate = t && e.isTypePredicateNode(t) ? gh(t, r) : o || Ro;
                  }
                  e.Debug.assert(!!r.resolvedTypePredicate);
                }
                return r.resolvedTypePredicate === Ro ? void 0 : r.resolvedTypePredicate;
              }
              function gh(r, i) {
                var t = r.parameterName, o = r.type && Va(r.type);
                return t.kind === 192 ? vg(r.assertsModifier ? 2 : 0, void 0, void 0, o) : vg(r.assertsModifier ? 3 : 1, t.escapedText, e.findIndex(i.parameters, function(s) {
                  return s.escapedName === t.escapedText;
                }), o);
              }
              function iy(r, i, t) {
                return i !== 2097152 ? Pa(r, t) : Do(r);
              }
              function yo(r) {
                if (!r.resolvedReturnType) {
                  if (!yu(r, 3)) return Pe;
                  var i = r.target ? un(yo(r.target), r.mapper) : r.compositeSignatures ? un(iy(e.map(r.compositeSignatures, yo), r.compositeKind, 2), r.mapper) : yg(r.declaration) || (e.nodeIsMissing(r.declaration.body) ? Oe : C0(r.declaration));
                  if (r.flags & 8 ? i = FE(i) : r.flags & 16 && (i = i_(i)), !fi()) {
                    if (r.declaration) {
                      var t = e.getEffectiveReturnTypeNode(r.declaration);
                      if (t) Xr(t, e.Diagnostics.Return_type_annotation_circularly_references_itself);
                      else if (n) {
                        var o = r.declaration, s = e.getNameOfDeclaration(o);
                        s ? Xr(s, e.Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions, e.declarationNameToString(s)) : Xr(o, e.Diagnostics.Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions);
                      }
                    }
                    i = Oe;
                  }
                  r.resolvedReturnType = i;
                }
                return r.resolvedReturnType;
              }
              function yg(r) {
                if (r.kind === 171) return aa(so(r.parent.symbol));
                if (e.isJSDocConstructSignature(r)) return Va(r.parameters[0].type);
                var i = e.getEffectiveReturnTypeNode(r);
                if (i) return Va(i);
                if (r.kind === 172 && Td(r)) {
                  var t = e.isInJSFile(r) && K_(r);
                  if (t) return t;
                  var o = e.getDeclarationOfKind(Et(r), 173), s = Te(o);
                  if (s) return s;
                }
                return ry(r);
              }
              function Z1(r) {
                return !r.resolvedReturnType && v(r, 3) >= 0;
              }
              function _3(r) {
                return ix(r) || Oe;
              }
              function ix(r) {
                if (H(r)) {
                  var i = Jt(r.parameters[r.parameters.length - 1]), t = Yn(i) ? sv(i) : i;
                  return t && cs(t, nt);
                }
              }
              function Xm(r, i, t, o) {
                var s = eD(r, zp(i, r.typeParameters, Ul(r.typeParameters), t));
                if (o) {
                  var u = ok(yo(s));
                  if (u) {
                    var h = xd(u);
                    h.typeParameters = o;
                    var z2 = xd(s);
                    return z2.resolvedReturnType = im(h), z2;
                  }
                }
                return s;
              }
              function eD(r, i) {
                var t = r.instantiations || (r.instantiations = new e.Map()), o = Su(i), s = t.get(o);
                return s || t.set(o, s = mh(r, i)), s;
              }
              function mh(r, i) {
                return Tg(r, p3(r, i), true);
              }
              function p3(r, i) {
                return Uc(r.typeParameters, i);
              }
              function Qm(r) {
                return r.typeParameters ? r.erasedSignatureCache || (r.erasedSignatureCache = d3(r)) : r;
              }
              function d3(r) {
                return Tg(r, sE(r.typeParameters), true);
              }
              function g3(r) {
                return r.typeParameters ? r.canonicalSignatureCache || (r.canonicalSignatureCache = m3(r)) : r;
              }
              function m3(r) {
                return Xm(r, e.map(r.typeParameters, function(i) {
                  return i.target && !Tc(i.target) ? i.target : i;
                }), e.isInJSFile(r.declaration));
              }
              function v3(r) {
                var i = r.typeParameters;
                if (i) {
                  if (r.baseSignatureCache) return r.baseSignatureCache;
                  for (var t = sE(i), o = Uc(i, e.map(i, function(h) {
                    return Tc(h) || gr;
                  })), s = e.map(i, function(h) {
                    return un(h, o) || gr;
                  }), u = 0; u < i.length - 1; u++) s = e_(s, o);
                  return s = e_(s, t), r.baseSignatureCache = Tg(r, Uc(i, s), true);
                }
                return r;
              }
              function im(r) {
                var i;
                if (!r.isolatedSignatureType) {
                  var t = (i = r.declaration) === null || i === void 0 ? void 0 : i.kind, o = t === void 0 || t === 171 || t === 175 || t === 180, s = tu(16);
                  s.members = we, s.properties = e.emptyArray, s.callSignatures = o ? e.emptyArray : [r], s.constructSignatures = o ? [r] : e.emptyArray, s.indexInfos = e.emptyArray, r.isolatedSignatureType = s;
                }
                return r.isolatedSignatureType;
              }
              function tx(r) {
                return r.members ? rD(r.members) : void 0;
              }
              function rD(r) {
                return r.get("__index");
              }
              function zl(r, i, t, o) {
                return { keyType: r, type: i, isReadonly: t, declaration: o };
              }
              function ax(r) {
                var i = tx(r);
                return i ? nx(i) : e.emptyArray;
              }
              function nx(r) {
                if (r.declarations) {
                  for (var i = [], t = function(h) {
                    if (h.parameters.length === 1) {
                      var z2 = h.parameters[0];
                      z2.type && Od(Va(z2.type), function(me) {
                        vh(me) && !xa(i, me) && i.push(zl(me, h.type ? Va(h.type) : Oe, e.hasEffectiveModifier(h, 64), h));
                      });
                    }
                  }, o = 0, s = r.declarations; o < s.length; o++) {
                    var u = s[o];
                    t(u);
                  }
                  return i;
                }
                return e.emptyArray;
              }
              function vh(r) {
                return !!(r.flags & 4108) || sm(r) || !!(r.flags & 2097152) && !rv(r) && e.some(r.types, vh);
              }
              function ox(r) {
                return e.mapDefined(e.filter(r.symbol && r.symbol.declarations, e.isTypeParameterDeclaration), e.getEffectiveConstraintOfTypeParameter)[0];
              }
              function sx(r, i) {
                var t, o;
                if (!((t = r.symbol) === null || t === void 0) && t.declarations) for (var s = 0, u = r.symbol.declarations; s < u.length; s++) {
                  var h = u[s];
                  if (h.parent.kind === 190) {
                    var z2 = e.walkUpParenthesizedTypesAndGetParentAndChild(h.parent.parent), me = z2[0], Me = me === void 0 ? h.parent : me, $e = z2[1];
                    if ($e.kind === 178 && !i) {
                      var tr = $e, dr = mS(tr);
                      if (dr) {
                        var Dr = tr.typeArguments.indexOf(Me);
                        if (Dr < dr.length) {
                          var Qr = Tc(dr[Dr]);
                          if (Qr) {
                            var li = Uc(dr, P0(tr, dr)), Ti = un(Qr, li);
                            Ti !== r && (o = e.append(o, Ti));
                          }
                        }
                      }
                    } else if ($e.kind === 164 && $e.dotDotDotToken || $e.kind === 186 || $e.kind === 197 && $e.dotDotDotToken) o = e.append(o, Zs(gr));
                    else if ($e.kind === 199) o = e.append(o, Li);
                    else if ($e.kind === 163 && $e.parent.kind === 195) o = e.append(o, at);
                    else if ($e.kind === 195 && $e.type && e.skipParentheses($e.type) === h.parent && $e.parent.kind === 189 && $e.parent.extendsType === $e && $e.parent.checkType.kind === 195 && $e.parent.checkType.type) {
                      var Ci = $e.parent.checkType, $i = Va(Ci.type);
                      o = e.append(o, un($i, Yd(Js(Et(Ci.typeParameter)), Ci.typeParameter.constraint ? Va(Ci.typeParameter.constraint) : at)));
                    }
                  }
                }
                return o && Do(o);
              }
              function tm(r) {
                if (!r.constraint) if (r.target) {
                  var i = Tc(r.target);
                  r.constraint = i ? un(i, r.mapper) : Kn;
                } else {
                  var t = ox(r);
                  if (!t) r.constraint = sx(r) || Kn;
                  else {
                    var o = Va(t);
                    o.flags & 1 && !nn(o) && (o = t.parent.parent.kind === 195 ? at : gr), r.constraint = o;
                  }
                }
                return r.constraint === Kn ? void 0 : r.constraint;
              }
              function cx(r) {
                var i = e.getDeclarationOfKind(r.symbol, 163), t = e.isJSDocTemplateTag(i.parent) ? e.getEffectiveContainerForJSDocTemplateTag(i.parent) : i.parent;
                return t && Et(t);
              }
              function Su(r) {
                var i = "";
                if (r) for (var t = r.length, o = 0; o < t; ) {
                  for (var s = r[o].id, u = 1; o + u < t && r[o + u].id === s + u; ) u++;
                  i.length && (i += ","), i += s, u > 1 && (i += ":" + u), o += u;
                }
                return i;
              }
              function hg(r, i) {
                return r ? "@".concat(y(r)) + (i ? ":".concat(Su(i)) : "") : "";
              }
              function iD(r, i) {
                for (var t = 0, o = 0, s = r; o < s.length; o++) {
                  var u = s[o];
                  u.flags & i || (t |= e.getObjectFlags(u));
                }
                return t & 458752;
              }
              function Yf(r, i) {
                var t = Su(i), o = r.instantiations.get(t);
                return o || (o = tu(4, r.symbol), r.instantiations.set(t, o), o.objectFlags |= i ? iD(i, 0) : 0, o.target = r, o.resolvedTypeArguments = i), o;
              }
              function ux(r) {
                var i = mc(r.flags);
                return i.symbol = r.symbol, i.objectFlags = r.objectFlags, i.target = r.target, i.resolvedTypeArguments = r.resolvedTypeArguments, i;
              }
              function tD(r, i, t, o, s) {
                if (!o) {
                  o = Qd(i);
                  var u = bg(o);
                  s = t ? e_(u, t) : u;
                }
                var h = tu(4, r.symbol);
                return h.target = r, h.node = i, h.mapper = t, h.aliasSymbol = o, h.aliasTypeArguments = s, h;
              }
              function xo(r) {
                var i, t;
                if (!r.resolvedTypeArguments) {
                  if (!yu(r, 6)) return ((i = r.target.localTypeParameters) === null || i === void 0 ? void 0 : i.map(function() {
                    return Pe;
                  })) || e.emptyArray;
                  var o = r.node, s = o ? o.kind === 178 ? e.concatenate(r.target.outerTypeParameters, P0(o, r.target.localTypeParameters)) : o.kind === 183 ? [Va(o.elementType)] : e.map(o.elements, Va) : e.emptyArray;
                  fi() ? r.resolvedTypeArguments = r.mapper ? e_(s, r.mapper) : s : (r.resolvedTypeArguments = ((t = r.target.localTypeParameters) === null || t === void 0 ? void 0 : t.map(function() {
                    return Pe;
                  })) || e.emptyArray, Xr(r.node || Ie, r.target.symbol ? e.Diagnostics.Type_arguments_for_0_circularly_reference_themselves : e.Diagnostics.Tuple_type_arguments_circularly_reference_themselves, r.target.symbol && tn(r.target.symbol)));
                }
                return r.resolvedTypeArguments;
              }
              function $_(r) {
                return e.length(r.target.typeParameters);
              }
              function lx(r, i) {
                var t = go(so(i)), o = t.localTypeParameters;
                if (o) {
                  var s = e.length(r.typeArguments), u = Ul(o), h = e.isInJSFile(r), z2 = !n && h;
                  if (!z2 && (s < u || s > o.length)) {
                    var me = h && e.isExpressionWithTypeArguments(r) && !e.isJSDocAugmentsTag(r.parent), Me = u === o.length ? me ? e.Diagnostics.Expected_0_type_arguments_provide_these_with_an_extends_tag : e.Diagnostics.Generic_type_0_requires_1_type_argument_s : me ? e.Diagnostics.Expected_0_1_type_arguments_provide_these_with_an_extends_tag : e.Diagnostics.Generic_type_0_requires_between_1_and_2_type_arguments, $e = Ot(t, void 0, 2);
                    if (Xr(r, Me, $e, u, o.length), !h) return Pe;
                  }
                  if (r.kind === 178 && wx(r, e.length(r.typeArguments) !== o.length)) return tD(t, r, void 0);
                  var tr = e.concatenate(t.outerTypeParameters, zp(bh(r), o, u, h));
                  return Yf(t, tr);
                }
                return Wp(r, i) ? t : Pe;
              }
              function am(r, i, t, o) {
                var s = go(r);
                if (s === De && x.has(r.escapedName) && i && i.length === 1) return Th(r, i[0]);
                var u = Aa(r), h = u.typeParameters, z2 = Su(i) + hg(t, o), me = u.instantiations.get(z2);
                return me || u.instantiations.set(z2, me = lE(s, Uc(h, zp(i, h, Ul(h), e.isInJSFile(r.valueDeclaration))), t, o)), me;
              }
              function y3(r, i) {
                if (e.getCheckFlags(i) & 1048576) {
                  var t = bh(r), o = hg(i, t), s = Ar.get(o);
                  return s || (s = ms(1, "error"), s.aliasSymbol = i, s.aliasTypeArguments = t, Ar.set(o, s)), s;
                }
                var u = go(i), h = Aa(i).typeParameters;
                if (h) {
                  var z2 = e.length(r.typeArguments), me = Ul(h);
                  if (z2 < me || z2 > h.length) return Xr(r, me === h.length ? e.Diagnostics.Generic_type_0_requires_1_type_argument_s : e.Diagnostics.Generic_type_0_requires_between_1_and_2_type_arguments, tn(i), me, h.length), Pe;
                  var Me = Qd(r), $e = Me && (fx(i) || !fx(Me)) ? Me : void 0;
                  return am(i, bh(r), $e, bg($e));
                }
                return Wp(r, i) ? u : Pe;
              }
              function fx(r) {
                var i, t = (i = r.declarations) === null || i === void 0 ? void 0 : i.find(e.isTypeAlias);
                return !!(t && e.getContainingFunction(t));
              }
              function h3(r) {
                switch (r.kind) {
                  case 178:
                    return r.typeName;
                  case 228:
                    var i = r.expression;
                    if (e.isEntityNameExpression(i)) return i;
                }
              }
              function _x(r) {
                return r.parent ? "".concat(_x(r.parent), ".").concat(r.escapedName) : r.escapedName;
              }
              function yh(r) {
                var i = r.kind === 161 ? r.right : r.kind === 206 ? r.name : r, t = i.escapedText;
                if (t) {
                  var o = r.kind === 161 ? yh(r.left) : r.kind === 206 ? yh(r.expression) : void 0, s = o ? "".concat(_x(o), ".").concat(t) : t, u = mr.get(s);
                  return u || (mr.set(s, u = oo(524288, t, 1048576)), u.parent = o, u.declaredType = Ue), u;
                }
                return xe;
              }
              function nm(r, i, t) {
                var o = h3(r);
                if (!o) return xe;
                var s = Ds(o, i, t);
                return s && s !== xe ? s : t ? xe : yh(o);
              }
              function hh(r, i) {
                if (i === xe) return Pe;
                if (i = Cc(i) || i, i.flags & 96) return lx(r, i);
                if (i.flags & 524288) return y3(r, i);
                var t = Vd(i);
                if (t) return Wp(r, i) ? jc(t) : Pe;
                if (i.flags & 111551 && Dh(r)) {
                  var o = D3(r, i);
                  return o || (nm(r, 788968), Jt(i));
                }
                return Pe;
              }
              function D3(r, i) {
                var t = va(r);
                if (!t.resolvedJSDocType) {
                  var o = Jt(i), s = o;
                  if (i.valueDeclaration) {
                    var u = r.kind === 200 && r.qualifier;
                    o.symbol && o.symbol !== i && u && (s = hh(r, o.symbol));
                  }
                  t.resolvedJSDocType = s;
                }
                return t.resolvedJSDocType;
              }
              function px(r, i) {
                if (i.flags & 3 || i === r) return r;
                var t = "".concat(fu(r), ">").concat(fu(i)), o = Ze.get(t);
                if (o) return o;
                var s = mc(33554432);
                return s.baseType = r, s.substitute = i, Ze.set(t, s), s;
              }
              function dx(r) {
                return r.kind === 184 && r.elements.length === 1;
              }
              function gx(r, i, t) {
                return dx(i) && dx(t) ? gx(r, i.elements[0], t.elements[0]) : rp(Va(i)) === rp(r) ? Va(t) : void 0;
              }
              function mx(r, i) {
                for (var t, o = true; i && !e.isStatement(i) && i.kind !== 320; ) {
                  var s = i.parent;
                  if (s.kind === 164 && (o = !o), (o || r.flags & 8650752) && s.kind === 189 && i === s.trueType) {
                    var u = gx(r, s.checkType, s.extendsType);
                    u && (t = e.append(t, u));
                  } else if (r.flags & 262144 && s.kind === 195 && i === s.type) {
                    var h = Va(s);
                    if (Du(h) === rp(r)) {
                      var z2 = Ih(h);
                      if (z2) {
                        var u = Tc(z2);
                        u && gf(u, Pd) && (t = e.append(t, Pa([nt, $a])));
                      }
                    }
                  }
                  i = s;
                }
                return t ? px(r, Do(e.append(t, r))) : r;
              }
              function Dh(r) {
                return !!(r.flags & 8388608) && (r.kind === 178 || r.kind === 200);
              }
              function Wp(r, i) {
                return r.typeArguments ? (Xr(r, e.Diagnostics.Type_0_is_not_generic, i ? tn(i) : r.typeName ? e.declarationNameToString(r.typeName) : C), false) : true;
              }
              function vx(r) {
                if (e.isIdentifier(r.typeName)) {
                  var i = r.typeArguments;
                  switch (r.typeName.escapedText) {
                    case "String":
                      return Wp(r), Li;
                    case "Number":
                      return Wp(r), nt;
                    case "Boolean":
                      return Wp(r), Ii;
                    case "Void":
                      return Wp(r), Fi;
                    case "Undefined":
                      return Wp(r), Tr;
                    case "Null":
                      return Wp(r), Wi;
                    case "Function":
                    case "function":
                      return Wp(r), br;
                    case "array":
                      return (!i || !i.length) && !n ? mo : void 0;
                    case "promise":
                      return (!i || !i.length) && !n ? Ny(Oe) : void 0;
                    case "Object":
                      if (i && i.length === 2) {
                        if (e.isJSDocIndexSignature(r)) {
                          var t = Va(i[0]), o = Va(i[1]), s = t === Li || t === nt ? [zl(t, o, false)] : e.emptyArray;
                          return rs(void 0, we, e.emptyArray, e.emptyArray, s);
                        }
                        return Oe;
                      }
                      return Wp(r), n ? void 0 : Oe;
                  }
                }
              }
              function b3(r) {
                var i = Va(r.type);
                return Ye ? Uh(i, 65536) : i;
              }
              function ty(r) {
                var i = va(r);
                if (!i.resolvedType) {
                  if (e.isConstTypeReference(r) && e.isAssertionExpression(r.parent)) return i.resolvedSymbol = xe, i.resolvedType = Os(r.parent.expression);
                  var t = void 0, o = void 0, s = 788968;
                  Dh(r) && (o = vx(r), o || (t = nm(r, s, true), t === xe ? t = nm(r, s | 111551) : nm(r, s), o = hh(r, t))), o || (t = nm(r, s), o = hh(r, t)), i.resolvedSymbol = t, i.resolvedType = o;
                }
                return i.resolvedType;
              }
              function bh(r) {
                return e.map(r.typeArguments, Va);
              }
              function yx(r) {
                var i = va(r);
                if (!i.resolvedType) {
                  var t = kk(r);
                  i.resolvedType = jc($c(t));
                }
                return i.resolvedType;
              }
              function hx(r, i) {
                function t(s) {
                  var u = s.declarations;
                  if (u) for (var h = 0, z2 = u; h < z2.length; h++) {
                    var me = z2[h];
                    switch (me.kind) {
                      case 257:
                      case 258:
                      case 260:
                        return me;
                    }
                  }
                }
                if (!r) return i ? kn : Ba;
                var o = go(r);
                return o.flags & 524288 ? e.length(o.typeParameters) !== i ? (Xr(t(r), e.Diagnostics.Global_type_0_must_have_1_type_parameter_s, e.symbolName(r), i), i ? kn : Ba) : o : (Xr(t(r), e.Diagnostics.Global_type_0_must_be_a_class_or_interface_type, e.symbolName(r)), i ? kn : Ba);
              }
              function Dx(r, i) {
                return Ym(r, 111551, i ? e.Diagnostics.Cannot_find_global_value_0 : void 0);
              }
              function bx(r, i) {
                return Ym(r, 788968, i ? e.Diagnostics.Cannot_find_global_type_0 : void 0);
              }
              function aD(r, i, t) {
                var o = Ym(r, 788968, t ? e.Diagnostics.Cannot_find_global_type_0 : void 0);
                if (o && (go(o), e.length(Aa(o).typeParameters) !== i)) {
                  var s = o.declarations && e.find(o.declarations, e.isTypeAliasDeclaration);
                  Xr(s, e.Diagnostics.Global_type_0_must_have_1_type_parameter_s, e.symbolName(o), i);
                  return;
                }
                return o;
              }
              function Ym(r, i, t) {
                return es(void 0, r, i, t, r, false, false, false);
              }
              function lc(r, i, t) {
                var o = bx(r, t);
                return o || t ? hx(o, i) : void 0;
              }
              function S3() {
                return Xs || (Xs = lc("TypedPropertyDescriptor", 1, true) || kn);
              }
              function T3() {
                return pt || (pt = lc("TemplateStringsArray", 0, true) || Ba);
              }
              function Sx() {
                return Pt || (Pt = lc("ImportMeta", 0, true) || Ba);
              }
              function Tx() {
                if (!ga) {
                  var r = oo(0, "ImportMetaExpression"), i = Sx(), t = oo(4, "meta", 8);
                  t.parent = r, t.type = i;
                  var o = e.createSymbolTable([t]);
                  r.members = o, ga = rs(r, o, e.emptyArray, e.emptyArray, e.emptyArray);
                }
                return ga;
              }
              function xx(r) {
                return ua || (ua = lc("ImportCallOptions", 0, r)) || Ba;
              }
              function Ex(r) {
                return Pc || (Pc = Dx("Symbol", r));
              }
              function x3(r) {
                return Vc || (Vc = bx("SymbolConstructor", r));
              }
              function Cx() {
                return Kc || (Kc = lc("Symbol", 0, false)) || Ba;
              }
              function ay(r) {
                return pc || (pc = lc("Promise", 1, r)) || kn;
              }
              function kx(r) {
                return hs || (hs = lc("PromiseLike", 1, r)) || kn;
              }
              function nD(r) {
                return tc || (tc = Dx("Promise", r));
              }
              function E3(r) {
                return ps || (ps = lc("PromiseConstructorLike", 0, r)) || Ba;
              }
              function C3(r) {
                return yi || (yi = lc("AsyncIterable", 1, r)) || kn;
              }
              function k3(r) {
                return qi || (qi = lc("AsyncIterator", 3, r)) || kn;
              }
              function A3(r) {
                return je || (je = lc("AsyncIterableIterator", 1, r)) || kn;
              }
              function N3(r) {
                return Hr || (Hr = lc("AsyncGenerator", 3, r)) || kn;
              }
              function Ax(r) {
                return Qs || (Qs = lc("Iterable", 1, r)) || kn;
              }
              function P3(r) {
                return js || (js = lc("Iterator", 3, r)) || kn;
              }
              function I3(r) {
                return ds || (ds = lc("IterableIterator", 1, r)) || kn;
              }
              function w3(r) {
                return Ji || (Ji = lc("Generator", 3, r)) || kn;
              }
              function O3(r) {
                return ce || (ce = lc("IteratorYieldResult", 1, r)) || kn;
              }
              function F3(r) {
                return Rr || (Rr = lc("IteratorReturnResult", 1, r)) || kn;
              }
              function Nx(r, i) {
                i === void 0 && (i = 0);
                var t = Ym(r, 788968, void 0);
                return t && hx(t, i);
              }
              function M3() {
                return Xn || (Xn = aD("Extract", 2, true) || xe), Xn === xe ? void 0 : Xn;
              }
              function L3() {
                return jr || (jr = aD("Omit", 2, true) || xe), jr === xe ? void 0 : jr;
              }
              function oD(r) {
                return fo || (fo = aD("Awaited", 1, r) || (r ? xe : void 0)), fo === xe ? void 0 : fo;
              }
              function R3() {
                return xs || (xs = lc("BigInt", 0, false)) || Ba;
              }
              function $m(r, i) {
                return r !== kn ? Yf(r, i) : Ba;
              }
              function Px(r) {
                return $m(S3(), [r]);
              }
              function B3(r) {
                return $m(Ax(true), [r]);
              }
              function Zs(r, i) {
                return $m(i ? Qi : Pi, [r]);
              }
              function sD(r) {
                switch (r.kind) {
                  case 185:
                    return 2;
                  case 186:
                    return Ix(r);
                  case 197:
                    return r.questionToken ? 2 : r.dotDotDotToken ? Ix(r) : 1;
                  default:
                    return 1;
                }
              }
              function Ix(r) {
                return sy(r.type) ? 4 : 8;
              }
              function J3(r) {
                var i = U3(r.parent), t = sy(r);
                if (t) return i ? Qi : Pi;
                var o = e.map(r.elements, sD), s = e.some(r.elements, function(u) {
                  return u.kind !== 197;
                });
                return cD(o, i, s ? void 0 : r.elements);
              }
              function wx(r, i) {
                return !!Qd(r) || Ox(r) && (r.kind === 183 ? x_(r.elementType) : r.kind === 184 ? e.some(r.elements, x_) : i || e.some(r.typeArguments, x_));
              }
              function Ox(r) {
                var i = r.parent;
                switch (i.kind) {
                  case 191:
                  case 197:
                  case 178:
                  case 187:
                  case 188:
                  case 194:
                  case 189:
                  case 193:
                  case 183:
                  case 184:
                    return Ox(i);
                  case 259:
                    return true;
                }
                return false;
              }
              function x_(r) {
                switch (r.kind) {
                  case 178:
                    return Dh(r) || !!(nm(r, 788968).flags & 524288);
                  case 181:
                    return true;
                  case 193:
                    return r.operator !== 154 && x_(r.type);
                  case 191:
                  case 185:
                  case 197:
                  case 316:
                  case 314:
                  case 315:
                  case 309:
                    return x_(r.type);
                  case 186:
                    return r.type.kind !== 183 || x_(r.type.elementType);
                  case 187:
                  case 188:
                    return e.some(r.types, x_);
                  case 194:
                    return x_(r.objectType) || x_(r.indexType);
                  case 189:
                    return x_(r.checkType) || x_(r.extendsType) || x_(r.trueType) || x_(r.falseType);
                }
                return false;
              }
              function j3(r) {
                var i = va(r);
                if (!i.resolvedType) {
                  var t = J3(r);
                  if (t === kn) i.resolvedType = Ba;
                  else if (!(r.kind === 184 && e.some(r.elements, function(s) {
                    return !!(sD(s) & 8);
                  })) && wx(r)) i.resolvedType = r.kind === 184 && r.elements.length === 0 ? t : tD(t, r, void 0);
                  else {
                    var o = r.kind === 183 ? [Va(r.elementType)] : e.map(r.elements, Va);
                    i.resolvedType = uD(t, o);
                  }
                }
                return i.resolvedType;
              }
              function U3(r) {
                return e.isTypeOperatorNode(r) && r.operator === 145;
              }
              function Wl(r, i, t, o) {
                t === void 0 && (t = false);
                var s = cD(i || e.map(r, function(u) {
                  return 1;
                }), t, o);
                return s === kn ? Ba : r.length ? uD(s, r) : s;
              }
              function cD(r, i, t) {
                if (r.length === 1 && r[0] & 4) return i ? Qi : Pi;
                var o = e.map(r, function(u) {
                  return u & 1 ? "#" : u & 2 ? "?" : u & 4 ? "." : "*";
                }).join() + (i ? "R" : "") + (t && t.length ? "," + e.map(t, A).join(",") : ""), s = et.get(o);
                return s || et.set(o, s = z3(r, i, t)), s;
              }
              function z3(r, i, t) {
                var o = r.length, s = e.countWhere(r, function(Ti) {
                  return !!(Ti & 9);
                }), u, h = [], z2 = 0;
                if (o) {
                  u = new Array(o);
                  for (var me = 0; me < o; me++) {
                    var Me = u[me] = Hc(), $e = r[me];
                    if (z2 |= $e, !(z2 & 12)) {
                      var tr = oo(4 | ($e & 2 ? 16777216 : 0), "" + me, i ? 8 : 0);
                      tr.tupleLabelDeclaration = t == null ? void 0 : t[me], tr.type = Me, h.push(tr);
                    }
                  }
                }
                var dr = h.length, Dr = oo(4, "length", i ? 8 : 0);
                if (z2 & 12) Dr.type = nt;
                else {
                  for (var Qr = [], me = s; me <= o; me++) Qr.push(If(me));
                  Dr.type = Pa(Qr);
                }
                h.push(Dr);
                var li = tu(12);
                return li.typeParameters = u, li.outerTypeParameters = void 0, li.localTypeParameters = u, li.instantiations = new e.Map(), li.instantiations.set(Su(li.typeParameters), li), li.target = li, li.resolvedTypeArguments = li.typeParameters, li.thisType = Hc(), li.thisType.isThisType = true, li.thisType.constraint = li, li.declaredProperties = h, li.declaredCallSignatures = e.emptyArray, li.declaredConstructSignatures = e.emptyArray, li.declaredIndexInfos = e.emptyArray, li.elementFlags = r, li.minLength = s, li.fixedLength = dr, li.hasRestElement = !!(z2 & 12), li.combinedFlags = z2, li.readonly = i, li.labeledElementDeclarations = t, li;
              }
              function uD(r, i) {
                return r.objectFlags & 8 ? Fx(r, i) : Yf(r, i);
              }
              function Fx(r, i) {
                var t, o, s;
                if (!(r.combinedFlags & 14)) return Yf(r, i);
                if (r.combinedFlags & 8) {
                  var u = e.findIndex(i, function(Ci, $i) {
                    return !!(r.elementFlags[$i] & 8 && Ci.flags & 1179648);
                  });
                  if (u >= 0) return ny(e.map(i, function(Ci, $i) {
                    return r.elementFlags[$i] & 8 ? Ci : gr;
                  })) ? Ss(i[u], function(Ci) {
                    return Fx(r, e.replaceElement(i, u, Ci));
                  }) : Pe;
                }
                for (var h = [], z2 = [], me = [], Me = -1, $e = -1, tr = -1, dr = function(Ci) {
                  var $i = i[Ci], Zi = r.elementFlags[Ci];
                  if (Zi & 8) if ($i.flags & 58982400 || Bc($i)) Ti($i, 8, (t = r.labeledElementDeclarations) === null || t === void 0 ? void 0 : t[Ci]);
                  else if (Yn($i)) {
                    var qt = xo($i);
                    if (qt.length + h.length >= 1e4) return Xr(Ie, e.isPartOfTypeNode(Ie) ? e.Diagnostics.Type_produces_a_tuple_type_that_is_too_large_to_represent : e.Diagnostics.Expression_produces_a_tuple_type_that_is_too_large_to_represent), { value: Pe };
                    e.forEach(qt, function(Nt, Ra) {
                      var ca;
                      return Ti(Nt, $i.target.elementFlags[Ra], (ca = $i.target.labeledElementDeclarations) === null || ca === void 0 ? void 0 : ca[Ra]);
                    });
                  } else Ti(sp($i) && cs($i, nt) || Pe, 4, (o = r.labeledElementDeclarations) === null || o === void 0 ? void 0 : o[Ci]);
                  else Ti($i, Zi, (s = r.labeledElementDeclarations) === null || s === void 0 ? void 0 : s[Ci]);
                }, Dr = 0; Dr < i.length; Dr++) {
                  var Qr = dr(Dr);
                  if (typeof Qr == "object") return Qr.value;
                }
                for (var Dr = 0; Dr < Me; Dr++) z2[Dr] & 2 && (z2[Dr] = 1);
                $e >= 0 && $e < tr && (h[$e] = Pa(e.sameMap(h.slice($e, tr + 1), function(Ci, $i) {
                  return z2[$e + $i] & 8 ? Jc(Ci, nt) : Ci;
                })), h.splice($e + 1, tr - $e), z2.splice($e + 1, tr - $e), me == null || me.splice($e + 1, tr - $e));
                var li = cD(z2, r.readonly, me);
                return li === kn ? Ba : z2.length ? Yf(li, h) : li;
                function Ti(Ci, $i, Zi) {
                  $i & 1 && (Me = z2.length), $i & 4 && $e < 0 && ($e = z2.length), $i & 6 && (tr = z2.length), h.push(Ci), z2.push($i), me && Zi ? me.push(Zi) : me = void 0;
                }
              }
              function Zm(r, i, t) {
                t === void 0 && (t = 0);
                var o = r.target, s = $_(r) - t;
                return i > o.fixedLength ? Aw(r) || Wl(e.emptyArray) : Wl(xo(r).slice(i, s), o.elementFlags.slice(i, s), false, o.labeledElementDeclarations && o.labeledElementDeclarations.slice(i, s));
              }
              function Mx(r) {
                return Pa(e.append(e.arrayOf(r.target.fixedLength, function(i) {
                  return Bu("" + i);
                }), ql(r.target.readonly ? Qi : Pi)));
              }
              function Lx(r, i) {
                var t = e.findIndex(r.elementFlags, function(o) {
                  return !(o & i);
                });
                return t >= 0 ? t : r.elementFlags.length;
              }
              function Sh(r, i) {
                return r.elementFlags.length - e.findLastIndex(r.elementFlags, function(t) {
                  return !(t & i);
                }) - 1;
              }
              function W3(r) {
                return kc(Va(r.type), true);
              }
              function fu(r) {
                return r.id;
              }
              function $f(r, i) {
                return e.binarySearch(r, i, fu, e.compareValues) >= 0;
              }
              function lD(r, i) {
                var t = e.binarySearch(r, i, fu, e.compareValues);
                return t < 0 ? (r.splice(~t, 0, i), true) : false;
              }
              function q3(r, i, t) {
                var o = t.flags;
                if (o & 1048576) return Rx(r, i | (H3(t) ? 1048576 : 0), t.types);
                if (!(o & 131072)) if (i |= o & 205258751, o & 465829888 && (i |= 33554432), t === Mr && (i |= 8388608), !Ye && o & 98304) e.getObjectFlags(t) & 65536 || (i |= 4194304);
                else {
                  var s = r.length, u = s && t.id > r[s - 1].id ? ~s : e.binarySearch(r, t, fu, e.compareValues);
                  u < 0 && r.splice(~u, 0, t);
                }
                return i;
              }
              function Rx(r, i, t) {
                for (var o = 0, s = t; o < s.length; o++) {
                  var u = s[o];
                  i = q3(r, i, u);
                }
                return i;
              }
              function V3(r, i) {
                if (r.length < 2) return r;
                var t = Su(r), o = Sr.get(t);
                if (o) return o;
                for (var s = i && e.some(r, function(Ti) {
                  return !!(Ti.flags & 524288) && !Bc(Ti) && LD(Ru(Ti));
                }), u = r.length, h = u, z2 = 0; h > 0; ) {
                  h--;
                  var me = r[h];
                  if (s || me.flags & 469499904) for (var Me = me.flags & 61603840 ? e.find(uo(me), function(Ti) {
                    return Vl(Jt(Ti));
                  }) : void 0, $e = Me && jc(Jt(Me)), tr = 0, dr = r; tr < dr.length; tr++) {
                    var Dr = dr[tr];
                    if (me !== Dr) {
                      if (z2 === 1e5) {
                        var Qr = z2 / (u - h) * u;
                        if (Qr > 1e6) {
                          e.tracing === null || e.tracing === void 0 || e.tracing.instant("checkTypes", "removeSubtypes_DepthLimit", { typeIds: r.map(function(Ti) {
                            return Ti.id;
                          }) }), Xr(Ie, e.Diagnostics.Expression_produces_a_union_type_that_is_too_complex_to_represent);
                          return;
                        }
                      }
                      if (z2++, Me && Dr.flags & 61603840) {
                        var li = da(Dr, Me.escapedName);
                        if (li && Vl(li) && jc(li) !== $e) continue;
                      }
                      if (r_(me, Dr, ki) && (!(e.getObjectFlags(bd(me)) & 1) || !(e.getObjectFlags(bd(Dr)) & 1) || xg(me, Dr))) {
                        e.orderedRemoveItemAt(r, h);
                        break;
                      }
                    }
                  }
                }
                return Sr.set(t, r), r;
              }
              function K3(r, i, t) {
                for (var o = r.length; o > 0; ) {
                  o--;
                  var s = r[o], u = s.flags, h = u & 402653312 && i & 4 || u & 256 && i & 8 || u & 2048 && i & 64 || u & 8192 && i & 4096 || t && u & 32768 && i & 16384 || Kp(s) && $f(r, s.regularType);
                  h && e.orderedRemoveItemAt(r, o);
                }
              }
              function G3(r) {
                var i = e.filter(r, sm);
                if (i.length) for (var t = r.length, o = function() {
                  t--;
                  var s = r[t];
                  s.flags & 128 && e.some(i, function(u) {
                    return VE(s, u);
                  }) && e.orderedRemoveItemAt(r, t);
                }; t > 0; ) o();
              }
              function H3(r) {
                return !!(r.flags & 1048576 && (r.aliasSymbol || r.origin));
              }
              function Bx(r, i) {
                for (var t = 0, o = i; t < o.length; t++) {
                  var s = o[t];
                  if (s.flags & 1048576) {
                    var u = s.origin;
                    s.aliasSymbol || u && !(u.flags & 1048576) ? e.pushIfUnique(r, s) : u && u.flags & 1048576 && Bx(r, u.types);
                  }
                }
              }
              function fD(r, i) {
                var t = Ip(r);
                return t.types = i, t;
              }
              function Pa(r, i, t, o, s) {
                if (i === void 0 && (i = 1), r.length === 0) return ui;
                if (r.length === 1) return r[0];
                var u = [], h = Rx(u, 0, r);
                if (i !== 0) {
                  if (h & 3) return h & 1 ? h & 8388608 ? Mr : Oe : h & 65536 || $f(u, gr) ? gr : Vr;
                  if (yr && h & 32768) {
                    var z2 = e.binarySearch(u, Yi, fu, e.compareValues);
                    z2 >= 0 && $f(u, Tr) && e.orderedRemoveItemAt(u, z2);
                  }
                  if ((h & 402664320 || h & 16384 && h & 32768) && K3(u, h, !!(i & 2)), h & 128 && h & 134217728 && G3(u), i === 2 && (u = V3(u, !!(h & 524288)), !u)) return Pe;
                  if (u.length === 0) return h & 65536 ? h & 4194304 ? Wi : ct : h & 32768 ? h & 4194304 ? Tr : vi : ui;
                }
                if (!s && h & 1048576) {
                  var me = [];
                  Bx(me, r);
                  for (var Me = [], $e = function($i) {
                    e.some(me, function(Zi) {
                      return $f(Zi.types, $i);
                    }) || Me.push($i);
                  }, tr = 0, dr = u; tr < dr.length; tr++) {
                    var Dr = dr[tr];
                    $e(Dr);
                  }
                  if (!t && me.length === 1 && Me.length === 0) return me[0];
                  var Qr = e.reduceLeft(me, function($i, Zi) {
                    return $i + Zi.types.length;
                  }, 0);
                  if (Qr + Me.length === u.length) {
                    for (var li = 0, Ti = me; li < Ti.length; li++) {
                      var Dr = Ti[li];
                      lD(Me, Dr);
                    }
                    s = fD(1048576, Me);
                  }
                }
                var Ci = (h & 36323363 ? 0 : 32768) | (h & 2097152 ? 16777216 : 0);
                return pD(u, Ci, t, o, s);
              }
              function X3(r, i) {
                for (var t, o = [], s = 0, u = r; s < u.length; s++) {
                  var h = u[s], z2 = Yc(h);
                  if (!z2 || z2.kind === 2 || z2.kind === 3) {
                    if (i !== 2097152) continue;
                    return;
                  }
                  if (t) {
                    if (!_D(t, z2)) return;
                  } else t = z2;
                  o.push(z2.type);
                }
                if (!!t) {
                  var me = iy(o, i);
                  return vg(t.kind, t.parameterName, t.parameterIndex, me);
                }
              }
              function _D(r, i) {
                return r.kind === i.kind && r.parameterIndex === i.parameterIndex;
              }
              function pD(r, i, t, o, s) {
                if (r.length === 0) return ui;
                if (r.length === 1) return r[0];
                var u = s ? s.flags & 1048576 ? "|".concat(Su(s.types)) : s.flags & 2097152 ? "&".concat(Su(s.types)) : "#".concat(s.type.id, "|").concat(Su(r)) : Su(r), h = u + hg(t, o), z2 = Gi.get(h);
                return z2 || (z2 = mc(1048576), z2.objectFlags = i | iD(r, 98304), z2.types = r, z2.origin = s, z2.aliasSymbol = t, z2.aliasTypeArguments = o, r.length === 2 && r[0].flags & 512 && r[1].flags & 512 && (z2.flags |= 16, z2.intrinsicName = "boolean"), Gi.set(h, z2)), z2;
              }
              function Q3(r) {
                var i = va(r);
                if (!i.resolvedType) {
                  var t = Qd(r);
                  i.resolvedType = Pa(e.map(r.types, Va), 1, t, bg(t));
                }
                return i.resolvedType;
              }
              function Y3(r, i, t) {
                var o = t.flags;
                return o & 2097152 ? Jx(r, i, t.types) : (vE(t) ? i & 16777216 || (i |= 16777216, r.set(t.id.toString(), t)) : (o & 3 ? t === Mr && (i |= 8388608) : (Ye || !(o & 98304)) && (yr && t === Yi && (i |= 262144, t = Tr), r.has(t.id.toString()) || (t.flags & 109440 && i & 109440 && (i |= 67108864), r.set(t.id.toString(), t))), i |= o & 205258751), i);
              }
              function Jx(r, i, t) {
                for (var o = 0, s = t; o < s.length; o++) {
                  var u = s[o];
                  i = Y3(r, i, jc(u));
                }
                return i;
              }
              function $3(r, i) {
                for (var t = r.length; t > 0; ) {
                  t--;
                  var o = r[t], s = o.flags & 4 && i & 402653312 || o.flags & 8 && i & 256 || o.flags & 64 && i & 2048 || o.flags & 4096 && i & 8192;
                  s && e.orderedRemoveItemAt(r, t);
                }
              }
              function Z3(r, i) {
                for (var t = 0, o = r; t < o.length; t++) {
                  var s = o[t];
                  if (!$f(s.types, i)) {
                    var u = i.flags & 128 ? Li : i.flags & 256 ? nt : i.flags & 2048 ? Mt : i.flags & 8192 ? Ki : void 0;
                    if (!u || !$f(s.types, u)) return false;
                  }
                }
                return true;
              }
              function eI(r) {
                for (var i = r.length, t = e.filter(r, function(z2) {
                  return !!(z2.flags & 128);
                }); i > 0; ) {
                  i--;
                  var o = r[i];
                  if (!!(o.flags & 134217728)) for (var s = 0, u = t; s < u.length; s++) {
                    var h = u[s];
                    if (E_(h, o)) {
                      e.orderedRemoveItemAt(r, i);
                      break;
                    } else if (sm(o)) return true;
                  }
                }
                return false;
              }
              function jx(r, i) {
                return e.every(r, function(t) {
                  return !!(t.flags & 1048576) && e.some(t.types, function(o) {
                    return !!(o.flags & i);
                  });
                });
              }
              function Ux(r, i) {
                for (var t = 0; t < r.length; t++) r[t] = ec(r[t], function(o) {
                  return !(o.flags & i);
                });
              }
              function rI(r) {
                var i, t = e.findIndex(r, function(dr) {
                  return !!(e.getObjectFlags(dr) & 32768);
                });
                if (t < 0) return false;
                for (var o = t + 1; o < r.length; ) {
                  var s = r[o];
                  e.getObjectFlags(s) & 32768 ? ((i || (i = [r[t]])).push(s), e.orderedRemoveItemAt(r, o)) : o++;
                }
                if (!i) return false;
                for (var u = [], h = [], z2 = 0, me = i; z2 < me.length; z2++) for (var Me = me[z2], $e = 0, tr = Me.types; $e < tr.length; $e++) {
                  var s = tr[$e];
                  lD(u, s) && Z3(i, s) && lD(h, s);
                }
                return r[t] = pD(h, 32768), true;
              }
              function iI(r, i, t) {
                var o = mc(2097152);
                return o.objectFlags = iD(r, 98304), o.types = r, o.aliasSymbol = i, o.aliasTypeArguments = t, o;
              }
              function Do(r, i, t) {
                var o = new e.Map(), s = Jx(o, 0, r), u = e.arrayFrom(o.values());
                if (s & 131072) return e.contains(u, Bt) ? Bt : ui;
                if (Ye && s & 98304 && s & 84410368 || s & 67108864 && s & 402783228 || s & 402653316 && s & 67238776 || s & 296 && s & 469891796 || s & 2112 && s & 469889980 || s & 12288 && s & 469879804 || s & 49152 && s & 469842940 || s & 134217728 && s & 128 && eI(u)) return ui;
                if (s & 1) return s & 8388608 ? Mr : Oe;
                if (!Ye && s & 98304) return s & 32768 ? Tr : Wi;
                if ((s & 4 && s & 402653312 || s & 8 && s & 256 || s & 64 && s & 2048 || s & 4096 && s & 8192) && $3(u, s), s & 16777216 && s & 524288 && e.orderedRemoveItemAt(u, e.findIndex(u, vE)), s & 262144 && (u[u.indexOf(Tr)] = Yi), u.length === 0) return gr;
                if (u.length === 1) return u[0];
                var h = Su(u) + hg(i, t), z2 = Wt.get(h);
                if (!z2) {
                  if (s & 1048576) if (rI(u)) z2 = Do(u, i, t);
                  else if (jx(u, 32768)) {
                    var me = yr && e.some(u, function(tr) {
                      return $f(tr.types, Yi);
                    }) ? Yi : Tr;
                    Ux(u, 32768), z2 = Pa([Do(u), me], 1, i, t);
                  } else if (jx(u, 65536)) Ux(u, 65536), z2 = Pa([Do(u), Wi], 1, i, t);
                  else {
                    if (!ny(u)) return Pe;
                    var Me = tI(u), $e = e.some(Me, function(tr) {
                      return !!(tr.flags & 2097152);
                    }) ? fD(2097152, u) : void 0;
                    z2 = Pa(Me, 1, i, t, $e);
                  }
                  else z2 = iI(u, i, t);
                  Wt.set(h, z2);
                }
                return z2;
              }
              function zx(r) {
                return e.reduceLeft(r, function(i, t) {
                  return t.flags & 1048576 ? i * t.types.length : t.flags & 131072 ? 0 : i;
                }, 1);
              }
              function ny(r) {
                var i = zx(r);
                return i >= 1e5 ? (e.tracing === null || e.tracing === void 0 || e.tracing.instant("checkTypes", "checkCrossProductUnion_DepthLimit", { typeIds: r.map(function(t) {
                  return t.id;
                }), size: i }), Xr(Ie, e.Diagnostics.Expression_produces_a_union_type_that_is_too_complex_to_represent), false) : true;
              }
              function tI(r) {
                for (var i = zx(r), t = [], o = 0; o < i; o++) {
                  for (var s = r.slice(), u = o, h = r.length - 1; h >= 0; h--) if (r[h].flags & 1048576) {
                    var z2 = r[h].types, me = z2.length;
                    s[h] = z2[u % me], u = Math.floor(u / me);
                  }
                  var Me = Do(s);
                  Me.flags & 131072 || t.push(Me);
                }
                return t;
              }
              function aI(r) {
                var i = va(r);
                if (!i.resolvedType) {
                  var t = Qd(r);
                  i.resolvedType = Do(e.map(r.types, Va), t, bg(t));
                }
                return i.resolvedType;
              }
              function Wx(r, i) {
                var t = mc(4194304);
                return t.type = r, t.stringsOnly = i, t;
              }
              function nI(r) {
                var i = Ip(4194304);
                return i.type = r, i;
              }
              function dD(r, i) {
                return i ? r.resolvedStringIndexType || (r.resolvedStringIndexType = Wx(r, true)) : r.resolvedIndexType || (r.resolvedIndexType = Wx(r, false));
              }
              function oI(r, i, t) {
                var o = Du(r), s = Mu(r), u = Jl(r.target || r);
                if (!u && !t) return s;
                var h = [];
                if (mg(r)) {
                  if (qp(s)) return dD(r, i);
                  var z2 = $s(Ed(r));
                  Um(z2, 8576, i, Me);
                } else Od(Kd(s), Me);
                qp(s) && Od(s, Me);
                var me = t ? ec(Pa(h), function($e) {
                  return !($e.flags & 5);
                }) : Pa(h);
                if (me.flags & 1048576 && s.flags & 1048576 && Su(me.types) === Su(s.types)) return s;
                return me;
                function Me($e) {
                  var tr = u ? un(u, tv(r.mapper, o, $e)) : $e;
                  h.push(tr === Li ? ji : tr);
                }
              }
              function sI(r) {
                var i = Du(r);
                return t(Jl(r) || i);
                function t(o) {
                  return o.flags & 68157439 ? true : o.flags & 16777216 ? o.root.isDistributive && o.checkType === i : o.flags & 137363456 ? e.every(o.types, t) : o.flags & 8388608 ? t(o.objectType) && t(o.indexType) : o.flags & 33554432 ? t(o.substitute) : o.flags & 268435456 ? t(o.type) : false;
                }
              }
              function Z_(r) {
                return e.isPrivateIdentifier(r) ? ui : e.isIdentifier(r) ? Bu(e.unescapeLeadingUnderscores(r.escapedText)) : jc(e.isComputedPropertyName(r) ? t_(r) : yn(r));
              }
              function om(r, i, t) {
                if (t || !(e.getDeclarationModifierFlagsFromSymbol(r) & 24)) {
                  var o = Aa(dg(r)).nameType;
                  if (!o) {
                    var s = e.getNameOfDeclaration(r.valueDeclaration);
                    o = r.escapedName === "default" ? Bu("default") : s && Z_(s) || (e.isKnownSymbol(r) ? void 0 : Bu(e.symbolName(r)));
                  }
                  if (o && o.flags & i) return o;
                }
                return ui;
              }
              function qx(r, i) {
                return !!(r.flags & i || r.flags & 2097152 && e.some(r.types, function(t) {
                  return qx(t, i);
                }));
              }
              function cI(r, i, t) {
                var o = t && (e.getObjectFlags(r) & 7 || r.aliasSymbol) ? nI(r) : void 0, s = e.map(uo(r), function(h) {
                  return om(h, i);
                }), u = e.map(Hn(r), function(h) {
                  return h !== Ko && qx(h.keyType, i) ? h.keyType === Li && i & 8 ? ji : h.keyType : ui;
                });
                return Pa(e.concatenate(s, u), 1, void 0, void 0, o);
              }
              function uI(r) {
                return e.some(r.types, function(i) {
                  var t = KI(i);
                  return bu(t) !== t;
                });
              }
              function ql(r, i, t) {
                return i === void 0 && (i = Ge), r = bu(r), r.flags & 1048576 ? uI(r) ? dD(r, i) : Do(e.map(r.types, function(o) {
                  return ql(o, i, t);
                })) : r.flags & 2097152 ? Pa(e.map(r.types, function(o) {
                  return ql(o, i, t);
                })) : r.flags & 58982400 || lm(r) || Bc(r) && !sI(r) ? dD(r, i) : e.getObjectFlags(r) & 32 ? oI(r, i, t) : r === Mr ? Mr : r.flags & 2 ? ui : r.flags & 131073 ? at : cI(r, (t ? 128 : 402653316) | (i ? 0 : 12584), i === Ge && !t);
              }
              function Vx(r) {
                if (Ge) return r;
                var i = M3();
                return i ? am(i, [r, Li]) : Li;
              }
              function lI(r) {
                var i = Vx(ql(r));
                return i.flags & 131072 ? Li : i;
              }
              function fI(r) {
                var i = va(r);
                if (!i.resolvedType) switch (r.operator) {
                  case 140:
                    i.resolvedType = ql(Va(r.type));
                    break;
                  case 154:
                    i.resolvedType = r.type.kind === 151 ? CD(e.walkUpParenthesizedTypes(r.parent)) : Pe;
                    break;
                  case 145:
                    i.resolvedType = Va(r.type);
                    break;
                  default:
                    throw e.Debug.assertNever(r.operator);
                }
                return i.resolvedType;
              }
              function _I(r) {
                var i = va(r);
                return i.resolvedType || (i.resolvedType = Dg(Ve([r.head.text], e.map(r.templateSpans, function(t) {
                  return t.literal.text;
                }), true), e.map(r.templateSpans, function(t) {
                  return Va(t.type);
                }))), i.resolvedType;
              }
              function Dg(r, i) {
                var t = e.findIndex(i, function(Me) {
                  return !!(Me.flags & 1179648);
                });
                if (t >= 0) return ny(i) ? Ss(i[t], function(Me) {
                  return Dg(r, e.replaceElement(i, t, Me));
                }) : Pe;
                if (e.contains(i, Mr)) return Mr;
                var o = [], s = [], u = r[0];
                if (!me(r, i)) return Li;
                if (o.length === 0) return Bu(u);
                if (s.push(u), e.every(s, function(Me) {
                  return Me === "";
                }) && e.every(o, function(Me) {
                  return !!(Me.flags & 4);
                })) return Li;
                var h = "".concat(Su(o), "|").concat(e.map(s, function(Me) {
                  return Me.length;
                }).join(","), "|").concat(s.join("")), z2 = Jr.get(h);
                return z2 || Jr.set(h, z2 = dI(s, o)), z2;
                function me(Me, $e) {
                  for (var tr = e.isArray(Me), dr = 0; dr < $e.length; dr++) {
                    var Dr = $e[dr], Qr = tr ? Me[dr + 1] : Me;
                    if (Dr.flags & 101248) {
                      if (u += pI(Dr) || "", u += Qr, !tr) return true;
                    } else if (Dr.flags & 134217728) {
                      if (u += Dr.texts[0], !me(Dr.texts, Dr.types)) return false;
                      if (u += Qr, !tr) return true;
                    } else if (qp(Dr) || Gx(Dr)) o.push(Dr), s.push(u), u = Qr;
                    else if (Dr.flags & 2097152) {
                      var li = me(Me[dr + 1], Dr.types);
                      if (!li) return false;
                    } else if (tr) return false;
                  }
                  return true;
                }
              }
              function pI(r) {
                return r.flags & 128 ? r.value : r.flags & 256 ? "" + r.value : r.flags & 2048 ? e.pseudoBigIntToString(r.value) : r.flags & 98816 ? r.intrinsicName : void 0;
              }
              function dI(r, i) {
                var t = mc(134217728);
                return t.texts = r, t.types = i, t;
              }
              function Th(r, i) {
                return i.flags & 1179648 ? Ss(i, function(t) {
                  return Th(r, t);
                }) : qp(i) ? mI(r, i) : i.flags & 128 ? Bu(gI(r, i.value)) : i;
              }
              function gI(r, i) {
                switch (x.get(r.escapedName)) {
                  case 0:
                    return i.toUpperCase();
                  case 1:
                    return i.toLowerCase();
                  case 2:
                    return i.charAt(0).toUpperCase() + i.slice(1);
                  case 3:
                    return i.charAt(0).toLowerCase() + i.slice(1);
                }
                return i;
              }
              function mI(r, i) {
                var t = "".concat(y(r), ",").concat(fu(i)), o = ti.get(t);
                return o || ti.set(t, o = vI(r, i)), o;
              }
              function vI(r, i) {
                var t = mc(268435456);
                return t.symbol = r, t.type = i, t;
              }
              function yI(r, i, t, o, s) {
                var u = mc(8388608);
                return u.objectType = r, u.indexType = i, u.accessFlags = t, u.aliasSymbol = o, u.aliasTypeArguments = s, u;
              }
              function ev(r) {
                if (n) return false;
                if (e.getObjectFlags(r) & 4096) return true;
                if (r.flags & 1048576) return e.every(r.types, ev);
                if (r.flags & 2097152) return e.some(r.types, ev);
                if (r.flags & 465829888) {
                  var i = Hv(r);
                  return i !== r && ev(i);
                }
                return false;
              }
              function gD(r, i) {
                return _f(r) ? pf(r) : i && e.isPropertyName(i) ? e.getPropertyNameForPropertyNameNode(i) : void 0;
              }
              function mD(r, i) {
                if (i.flags & 8208) {
                  var t = e.findAncestor(r.parent, function(o) {
                    return !e.isAccessExpression(o);
                  }) || r.parent;
                  return e.isCallLikeExpression(t) ? e.isCallOrNewExpression(t) && e.isIdentifier(r) && eC(t, r) : e.every(i.declarations, function(o) {
                    return !e.isFunctionLike(o) || !!(e.getCombinedNodeFlags(o) & 268435456);
                  });
                }
                return true;
              }
              function Kx(r, i, t, o, s, u) {
                var h, z2 = s && s.kind === 207 ? s : void 0, me = s && e.isPrivateIdentifier(s) ? void 0 : gD(t, s);
                if (me !== void 0) {
                  if (u & 256) return Md(i, me) || Oe;
                  var Me = bi(i, me);
                  if (Me) {
                    if (u & 64 && s && Me.declarations && P_(Me) && mD(s, Me)) {
                      var $e = (h = z2 == null ? void 0 : z2.argumentExpression) !== null && h !== void 0 ? h : e.isIndexedAccessTypeNode(s) ? s.indexType : s;
                      El($e, Me.declarations, me);
                    }
                    if (z2) {
                      if (xy(Me, z2, rk(z2.expression, i.symbol)), jk(z2, Me, e.getAssignmentTargetKind(z2))) {
                        Xr(z2.argumentExpression, e.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, tn(Me));
                        return;
                      }
                      if (u & 8 && (va(s).resolvedSymbol = Me), HC(z2, Me)) return nr;
                    }
                    var tr = Jt(Me);
                    return z2 && e.getAssignmentTargetKind(z2) !== 1 ? up(z2, tr) : tr;
                  }
                  if (gf(i, Yn) && e.isNumericLiteralName(me) && +me >= 0) {
                    if (s && gf(i, function(Nt) {
                      return !Nt.target.hasRestElement;
                    }) && !(u & 16)) {
                      var dr = vD(s);
                      Yn(i) ? Xr(dr, e.Diagnostics.Tuple_type_0_of_length_1_has_no_element_at_index_2, Ot(i), $_(i), e.unescapeLeadingUnderscores(me)) : Xr(dr, e.Diagnostics.Property_0_does_not_exist_on_type_1, e.unescapeLeadingUnderscores(me), Ot(i));
                    }
                    return qt(ss(i, nt)), Ss(i, function(Nt) {
                      var Ra = sv(Nt) || Tr;
                      return u & 1 ? Pa([Ra, Tr]) : Ra;
                    });
                  }
                }
                if (!(t.flags & 98304) && Ns(t, 402665900)) {
                  if (i.flags & 131073) return i;
                  var Dr = nu(i, t) || ss(i, Li);
                  if (Dr) {
                    if (u & 2 && Dr.keyType !== nt) {
                      z2 && Xr(z2, e.Diagnostics.Type_0_cannot_be_used_to_index_type_1, Ot(t), Ot(r));
                      return;
                    }
                    if (s && Dr.keyType === Li && !Ns(t, 12)) {
                      var dr = vD(s);
                      return Xr(dr, e.Diagnostics.Type_0_cannot_be_used_as_an_index_type, Ot(t)), u & 1 ? Pa([Dr.type, Tr]) : Dr.type;
                    }
                    return qt(Dr), u & 1 ? Pa([Dr.type, Tr]) : Dr.type;
                  }
                  if (t.flags & 131072) return ui;
                  if (ev(i)) return Oe;
                  if (z2 && !uS(i)) {
                    if (Qp(i)) {
                      if (n && t.flags & 384) return rn.add(e.createDiagnosticForNode(z2, e.Diagnostics.Property_0_does_not_exist_on_type_1, t.value, Ot(i))), Tr;
                      if (t.flags & 12) {
                        var Qr = e.map(i.properties, function(Nt) {
                          return Jt(Nt);
                        });
                        return Pa(e.append(Qr, Tr));
                      }
                    }
                    if (i.symbol === pe && me !== void 0 && pe.exports.has(me) && pe.exports.get(me).flags & 418) Xr(z2, e.Diagnostics.Property_0_does_not_exist_on_type_1, e.unescapeLeadingUnderscores(me), Ot(i));
                    else if (n && !ye.suppressImplicitAnyIndexErrors && !(u & 128)) if (me !== void 0 && $C(me, i)) {
                      var li = Ot(i);
                      Xr(z2, e.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead, me, li, li + "[" + e.getTextOfNode(z2.argumentExpression) + "]");
                    } else if (cs(i, nt)) Xr(z2.argumentExpression, e.Diagnostics.Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number);
                    else {
                      var Ti = void 0;
                      if (me !== void 0 && (Ti = Vb(me, i))) Ti !== void 0 && Xr(z2.argumentExpression, e.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2, me, Ot(i), Ti);
                      else {
                        var Ci = i7(i, z2, t);
                        if (Ci !== void 0) Xr(z2, e.Diagnostics.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1, Ot(i), Ci);
                        else {
                          var $i = void 0;
                          if (t.flags & 1024) $i = e.chainDiagnosticMessages(void 0, e.Diagnostics.Property_0_does_not_exist_on_type_1, "[" + Ot(t) + "]", Ot(i));
                          else if (t.flags & 8192) {
                            var Zi = cl(t.symbol, z2);
                            $i = e.chainDiagnosticMessages(void 0, e.Diagnostics.Property_0_does_not_exist_on_type_1, "[" + Zi + "]", Ot(i));
                          } else t.flags & 128 || t.flags & 256 ? $i = e.chainDiagnosticMessages(void 0, e.Diagnostics.Property_0_does_not_exist_on_type_1, t.value, Ot(i)) : t.flags & 12 && ($i = e.chainDiagnosticMessages(void 0, e.Diagnostics.No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1, Ot(t), Ot(i)));
                          $i = e.chainDiagnosticMessages($i, e.Diagnostics.Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1, Ot(o), Ot(i)), rn.add(e.createDiagnosticForNodeFromMessageChain(z2, $i));
                        }
                      }
                    }
                    return;
                  }
                }
                if (ev(i)) return Oe;
                if (s) {
                  var dr = vD(s);
                  t.flags & 384 ? Xr(dr, e.Diagnostics.Property_0_does_not_exist_on_type_1, "" + t.value, Ot(i)) : t.flags & 12 ? Xr(dr, e.Diagnostics.Type_0_has_no_matching_index_signature_for_type_1, Ot(i), Ot(t)) : Xr(dr, e.Diagnostics.Type_0_cannot_be_used_as_an_index_type, Ot(t));
                }
                if (ta(t)) return t;
                return;
                function qt(Nt) {
                  Nt && Nt.isReadonly && z2 && (e.isAssignmentTarget(z2) || e.isDeleteTarget(z2)) && Xr(z2, e.Diagnostics.Index_signature_in_type_0_only_permits_reading, Ot(i));
                }
              }
              function vD(r) {
                return r.kind === 207 ? r.argumentExpression : r.kind === 194 ? r.indexType : r.kind === 162 ? r.expression : r;
              }
              function Gx(r) {
                return !!(r.flags & 77);
              }
              function sm(r) {
                return !!(r.flags & 134217728) && e.every(r.types, Gx);
              }
              function rv(r) {
                return !!iv(r);
              }
              function Ad(r) {
                return !!(iv(r) & 4194304);
              }
              function qp(r) {
                return !!(iv(r) & 8388608);
              }
              function iv(r) {
                return r.flags & 3145728 ? (r.objectFlags & 2097152 || (r.objectFlags |= 2097152 | e.reduceLeft(r.types, function(i, t) {
                  return i | iv(t);
                }, 0)), r.objectFlags & 12582912) : r.flags & 33554432 ? (r.objectFlags & 2097152 || (r.objectFlags |= 2097152 | iv(r.substitute) | iv(r.baseType)), r.objectFlags & 12582912) : (r.flags & 58982400 || Bc(r) || lm(r) ? 4194304 : 0) | (r.flags & 465829888 && !sm(r) ? 8388608 : 0);
              }
              function Zf(r, i) {
                return r.flags & 8388608 ? DI(r, i) : r.flags & 16777216 ? bI(r, i) : r;
              }
              function Hx(r, i, t) {
                if (r.flags & 3145728) {
                  var o = e.map(r.types, function(s) {
                    return Zf(Jc(s, i), t);
                  });
                  return r.flags & 2097152 || t ? Do(o) : Pa(o);
                }
              }
              function hI(r, i, t) {
                if (i.flags & 1048576) {
                  var o = e.map(i.types, function(s) {
                    return Zf(Jc(r, s), t);
                  });
                  return t ? Do(o) : Pa(o);
                }
              }
              function DI(r, i) {
                var t = i ? "simplifiedForWriting" : "simplifiedForReading";
                if (r[t]) return r[t] === Pn ? r : r[t];
                r[t] = Pn;
                var o = Zf(r.objectType, i), s = Zf(r.indexType, i), u = hI(o, s, i);
                if (u) return r[t] = u;
                if (!(s.flags & 465829888)) {
                  var h = Hx(o, s, i);
                  if (h) return r[t] = h;
                }
                if (lm(o) && s.flags & 296) {
                  var z2 = jh(o, s.flags & 8 ? 0 : o.target.fixedLength, 0, i);
                  if (z2) return r[t] = z2;
                }
                if (Bc(o)) {
                  var me = Jl(o);
                  if (!me || ao(me, Du(o))) return r[t] = Ss(xh(o, r.indexType), function(Me) {
                    return Zf(Me, i);
                  });
                }
                return r[t] = r;
              }
              function bI(r, i) {
                var t = r.checkType, o = r.extendsType, s = ip(r), u = tp(r);
                if (u.flags & 131072 && rp(s) === rp(t)) {
                  if (t.flags & 1 || ao(Nd(t), Nd(o))) return Zf(s, i);
                  if (Xx(t, o)) return ui;
                } else if (s.flags & 131072 && rp(u) === rp(t)) {
                  if (!(t.flags & 1) && ao(Nd(t), Nd(o))) return ui;
                  if (t.flags & 1 || Xx(t, o)) return Zf(u, i);
                }
                return r;
              }
              function Xx(r, i) {
                return !!(Pa([Zg(r, i), ui]).flags & 131072);
              }
              function xh(r, i) {
                var t = Uc([Du(r)], [i]), o = np(r.mapper, t);
                return un(vl(r), o);
              }
              function Jc(r, i, t, o, s, u) {
                return t === void 0 && (t = 0), ep(r, i, t, o, s, u) || (o ? Pe : gr);
              }
              function Qx(r, i) {
                return gf(r, function(t) {
                  if (t.flags & 384) {
                    var o = pf(t);
                    if (e.isNumericLiteralName(o)) {
                      var s = +o;
                      return s >= 0 && s < i;
                    }
                  }
                  return false;
                });
              }
              function ep(r, i, t, o, s, u) {
                if (t === void 0 && (t = 0), r === Mr || i === Mr) return Mr;
                if (yE(r) && !(i.flags & 98304) && Ns(i, 12) && (i = Li), ye.noUncheckedIndexedAccess && t & 32 && (t |= 1), qp(i) || (o && o.kind !== 194 ? lm(r) && !Qx(i, r.target.fixedLength) : Ad(r) && !(Yn(r) && Qx(i, r.target.fixedLength)))) {
                  if (r.flags & 3) return r;
                  var h = t & 1, z2 = r.id + "," + i.id + "," + h + hg(s, u), me = Xe.get(z2);
                  return me || Xe.set(z2, me = yI(r, i, h, s, u)), me;
                }
                var Me = Xd(r);
                if (i.flags & 1048576 && !(i.flags & 16)) {
                  for (var $e = [], tr = false, dr = 0, Dr = i.types; dr < Dr.length; dr++) {
                    var Qr = Dr[dr], li = Kx(r, Me, Qr, i, o, t | (tr ? 128 : 0));
                    if (li) $e.push(li);
                    else if (o) tr = true;
                    else return;
                  }
                  return tr ? void 0 : t & 4 ? Do($e, s, u) : Pa($e, 1, s, u);
                }
                return Kx(r, Me, i, i, o, t | 8 | 64);
              }
              function Yx(r) {
                var i = va(r);
                if (!i.resolvedType) {
                  var t = Va(r.objectType), o = Va(r.indexType), s = Qd(r), u = Jc(t, o, 0, r, s, bg(s));
                  i.resolvedType = u.flags & 8388608 && u.objectType === t && u.indexType === o ? mx(u, r) : u;
                }
                return i.resolvedType;
              }
              function yD(r) {
                var i = va(r);
                if (!i.resolvedType) {
                  var t = tu(32, r.symbol);
                  t.declaration = r, t.aliasSymbol = Qd(r), t.aliasTypeArguments = bg(t.aliasSymbol), i.resolvedType = t, Mu(t);
                }
                return i.resolvedType;
              }
              function rp(r) {
                return r.flags & 33554432 ? r.baseType : r.flags & 8388608 && (r.objectType.flags & 33554432 || r.indexType.flags & 33554432) ? Jc(rp(r.objectType), rp(r.indexType)) : r;
              }
              function SI(r) {
                var i = Tc(r);
                return i && (Ad(i) || qp(i)) ? kD(r) : r;
              }
              function $x(r) {
                return !r.isDistributive && Zx(r.node.checkType) && Zx(r.node.extendsType);
              }
              function Zx(r) {
                return e.isTupleTypeNode(r) && e.length(r.elements) === 1 && !e.isOptionalTypeNode(r.elements[0]) && !e.isRestTypeNode(r.elements[0]) && !(e.isNamedTupleMember(r.elements[0]) && (r.elements[0].questionToken || r.elements[0].dotDotDotToken));
              }
              function hD(r, i) {
                return $x(r) && Yn(i) ? xo(i)[0] : i;
              }
              function DD(r, i, t, o) {
                for (var s, u, h = 0, z2 = function() {
                  if (h === 1e3) return Xr(Ie, e.Diagnostics.Type_instantiation_is_excessively_deep_and_possibly_infinite), s = Pe, "break";
                  var $e = $x(r), tr = un(hD(r, rp(r.checkType)), i), dr = rv(tr), Dr = un(hD(r, r.extendsType), i);
                  if (tr === Mr || Dr === Mr) return { value: Mr };
                  var Qr = void 0;
                  if (r.inferTypeParameters) {
                    var li = e.sameMap(r.inferTypeParameters, SI), Ti = li !== r.inferTypeParameters ? Uc(r.inferTypeParameters, li) : void 0, Ci = uv(li, void 0, 0);
                    if (Ti) for (var $i = np(i, Ti), Zi = 0, qt = li; Zi < qt.length; Zi++) {
                      var Nt = qt[Zi];
                      r.inferTypeParameters.indexOf(Nt) === -1 && (Nt.mapper = $i);
                    }
                    (!dr || !e.some(r.inferTypeParameters, function(Tn) {
                      return Tn === Dr;
                    })) && df(Ci.inferences, tr, un(Dr, Ti), 1536);
                    var Ra = np(Ti, Ci.mapper);
                    Qr = i ? np(Ra, i) : Ra;
                  }
                  var ca = Qr ? un(hD(r, r.extendsType), Qr) : Dr;
                  if (!dr && !rv(ca)) {
                    if (!(ca.flags & 3) && (tr.flags & 1 && !$e || !ao(wh(tr), wh(ca)))) {
                      tr.flags & 1 && !$e && (u || (u = [])).push(un(Va(r.node.trueType), Qr || i));
                      var Sn = Va(r.node.falseType);
                      if (Sn.flags & 16777216) {
                        var ja = Sn.root;
                        if (ja.node.parent === r.node && (!ja.isDistributive || ja.checkType === r.checkType)) return r = ja, "continue";
                        if (Me(Sn, i)) return "continue";
                      }
                      return s = un(Sn, i), "break";
                    }
                    if (ca.flags & 3 || ao(Nd(tr), Nd(ca))) {
                      var Fn = Va(r.node.trueType), wn = Qr || i;
                      return Me(Fn, wn) ? "continue" : (s = un(Fn, wn), "break");
                    }
                  }
                  return s = mc(16777216), s.root = r, s.checkType = un(r.checkType, i), s.extendsType = un(r.extendsType, i), s.mapper = i, s.combinedMapper = Qr, s.aliasSymbol = t || r.aliasSymbol, s.aliasTypeArguments = t ? o : e_(r.aliasTypeArguments, i), "break";
                }; ; ) {
                  var me = z2();
                  if (typeof me == "object") return me.value;
                  if (me === "break") break;
                }
                return u ? Pa(e.append(u, s)) : s;
                function Me($e, tr) {
                  if ($e.flags & 16777216 && tr) {
                    var dr = $e.root;
                    if (dr.outerTypeParameters) {
                      var Dr = np($e.mapper, tr), Qr = e.map(dr.outerTypeParameters, function(Ci) {
                        return ap(Ci, Dr);
                      }), li = Uc(dr.outerTypeParameters, Qr), Ti = dr.isDistributive ? ap(dr.checkType, li) : void 0;
                      if (!Ti || Ti === dr.checkType || !(Ti.flags & 1179648)) return r = dr, i = li, t = void 0, o = void 0, dr.aliasSymbol && h++, true;
                    }
                  }
                  return false;
                }
              }
              function ip(r) {
                return r.resolvedTrueType || (r.resolvedTrueType = un(Va(r.root.node.trueType), r.mapper));
              }
              function tp(r) {
                return r.resolvedFalseType || (r.resolvedFalseType = un(Va(r.root.node.falseType), r.mapper));
              }
              function TI(r) {
                return r.resolvedInferredTrueType || (r.resolvedInferredTrueType = r.combinedMapper ? un(Va(r.root.node.trueType), r.combinedMapper) : ip(r));
              }
              function eE(r) {
                var i;
                return r.locals && r.locals.forEach(function(t) {
                  t.flags & 262144 && (i = e.append(i, go(t)));
                }), i;
              }
              function xI(r) {
                return r.isDistributive && (Ph(r.checkType, r.node.trueType) || Ph(r.checkType, r.node.falseType));
              }
              function EI(r) {
                var i = va(r);
                if (!i.resolvedType) {
                  var t = Va(r.checkType), o = Qd(r), s = bg(o), u = kf(r, true), h = s ? u : e.filter(u, function(me) {
                    return Ph(me, r);
                  }), z2 = { node: r, checkType: t, extendsType: Va(r.extendsType), isDistributive: !!(t.flags & 262144), inferTypeParameters: eE(r), outerTypeParameters: h, instantiations: void 0, aliasSymbol: o, aliasTypeArguments: s };
                  i.resolvedType = DD(z2, void 0), h && (z2.instantiations = new e.Map(), z2.instantiations.set(Su(h), i.resolvedType));
                }
                return i.resolvedType;
              }
              function CI(r) {
                var i = va(r);
                return i.resolvedType || (i.resolvedType = Js(Et(r.typeParameter))), i.resolvedType;
              }
              function rE(r) {
                return e.isIdentifier(r) ? [r] : e.append(rE(r.left), r.right);
              }
              function kI(r) {
                var i = va(r);
                if (!i.resolvedType) {
                  if (r.isTypeOf && r.typeArguments) return Xr(r, e.Diagnostics.Type_arguments_cannot_be_used_here), i.resolvedSymbol = xe, i.resolvedType = Pe;
                  if (!e.isLiteralImportTypeNode(r)) return Xr(r.argument, e.Diagnostics.String_literal_expected), i.resolvedSymbol = xe, i.resolvedType = Pe;
                  var t = r.isTypeOf ? 111551 : r.flags & 8388608 ? 900095 : 788968, o = ac(r, r.argument.literal);
                  if (!o) return i.resolvedSymbol = xe, i.resolvedType = Pe;
                  var s = Us(o, false);
                  if (e.nodeIsMissing(r.qualifier)) if (s.flags & t) i.resolvedType = iE(r, i, s, t);
                  else {
                    var tr = t === 111551 ? e.Diagnostics.Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here : e.Diagnostics.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0;
                    Xr(r, tr, r.argument.literal.text), i.resolvedSymbol = xe, i.resolvedType = Pe;
                  }
                  else {
                    for (var u = rE(r.qualifier), h = s, z2 = void 0; z2 = u.shift(); ) {
                      var me = u.length ? 1920 : t, Me = so(os(h)), $e = r.isTypeOf ? bi(Jt(Me), z2.escapedText) : qs(dc(Me), z2.escapedText, me);
                      if (!$e) return Xr(z2, e.Diagnostics.Namespace_0_has_no_exported_member_1, cl(h), e.declarationNameToString(z2)), i.resolvedType = Pe;
                      va(z2).resolvedSymbol = $e, va(z2.parent).resolvedSymbol = $e, h = $e;
                    }
                    i.resolvedType = iE(r, i, h, t);
                  }
                }
                return i.resolvedType;
              }
              function iE(r, i, t, o) {
                var s = os(t);
                return i.resolvedSymbol = s, o === 111551 ? Jt(t) : hh(r, s);
              }
              function tE(r) {
                var i = va(r);
                if (!i.resolvedType) {
                  var t = Qd(r);
                  if (Nf(r.symbol).size === 0 && !t) i.resolvedType = Bi;
                  else {
                    var o = tu(16, r.symbol);
                    o.aliasSymbol = t, o.aliasTypeArguments = bg(t), e.isJSDocTypeLiteral(r) && r.isArrayType && (o = Zs(o)), i.resolvedType = o;
                  }
                }
                return i.resolvedType;
              }
              function Qd(r) {
                for (var i = r.parent; e.isParenthesizedTypeNode(i) || e.isJSDocTypeExpression(i) || e.isTypeOperatorNode(i) && i.operator === 145; ) i = i.parent;
                return e.isTypeAlias(i) ? Et(i) : void 0;
              }
              function bg(r) {
                return r ? Af(r) : void 0;
              }
              function bD(r) {
                return !!(r.flags & 524288) && !Bc(r);
              }
              function SD(r) {
                return Of(r) || !!(r.flags & 474058748);
              }
              function TD(r, i) {
                if (!(r.flags & 1048576)) return r;
                if (e.every(r.types, SD)) return e.find(r.types, Of) || Ba;
                var t = e.find(r.types, function(u) {
                  return !SD(u);
                });
                if (!t) return r;
                var o = e.find(r.types, function(u) {
                  return u !== t && !SD(u);
                });
                if (o) return r;
                return s(t);
                function s(u) {
                  for (var h = e.createSymbolTable(), z2 = 0, me = uo(u); z2 < me.length; z2++) {
                    var Me = me[z2];
                    if (!(e.getDeclarationModifierFlagsFromSymbol(Me) & 24)) {
                      if (Eh(Me)) {
                        var $e = Me.flags & 65536 && !(Me.flags & 32768), tr = 16777220, dr = oo(tr, Me.escapedName, Gd(Me) | (i ? 8 : 0));
                        dr.type = $e ? Tr : kc(Jt(Me), true), dr.declarations = Me.declarations, dr.nameType = Aa(Me).nameType, dr.syntheticOrigin = Me, h.set(Me.escapedName, dr);
                      }
                    }
                  }
                  var Dr = rs(u.symbol, h, e.emptyArray, e.emptyArray, Hn(u));
                  return Dr.objectFlags |= 131200, Dr;
                }
              }
              function Vp(r, i, t, o, s) {
                if (r.flags & 1 || i.flags & 1) return Oe;
                if (r.flags & 2 || i.flags & 2) return gr;
                if (r.flags & 131072) return i;
                if (i.flags & 131072) return r;
                if (r = TD(r, s), r.flags & 1048576) return ny([r, i]) ? Ss(r, function(Nt) {
                  return Vp(Nt, i, t, o, s);
                }) : Pe;
                if (i = TD(i, s), i.flags & 1048576) return ny([r, i]) ? Ss(i, function(Nt) {
                  return Vp(r, Nt, t, o, s);
                }) : Pe;
                if (i.flags & 473960444) return r;
                if (Ad(r) || Ad(i)) {
                  if (Of(r)) return i;
                  if (r.flags & 2097152) {
                    var u = r.types, h = u[u.length - 1];
                    if (bD(h) && bD(i)) return Do(e.concatenate(u.slice(0, u.length - 1), [Vp(h, i, t, o, s)]));
                  }
                  return Do([r, i]);
                }
                for (var z2 = e.createSymbolTable(), me = new e.Set(), Me = r === Ba ? Hn(i) : oh([r, i]), $e = 0, tr = uo(i); $e < tr.length; $e++) {
                  var dr = tr[$e];
                  e.getDeclarationModifierFlagsFromSymbol(dr) & 24 ? me.add(dr.escapedName) : Eh(dr) && z2.set(dr.escapedName, xD(dr, s));
                }
                for (var Dr = 0, Qr = uo(r); Dr < Qr.length; Dr++) {
                  var li = Qr[Dr];
                  if (!(me.has(li.escapedName) || !Eh(li))) if (z2.has(li.escapedName)) {
                    var dr = z2.get(li.escapedName), Ti = Jt(dr);
                    if (dr.flags & 16777216) {
                      var Ci = e.concatenate(li.declarations, dr.declarations), $i = 4 | li.flags & 16777216, Zi = oo($i, li.escapedName);
                      Zi.type = Pa([Jt(li), $D(Ti)], 2), Zi.leftSpread = li, Zi.rightSpread = dr, Zi.declarations = Ci, Zi.nameType = Aa(li).nameType, z2.set(li.escapedName, Zi);
                    }
                  } else z2.set(li.escapedName, xD(li, s));
                }
                var qt = rs(t, z2, e.emptyArray, e.emptyArray, e.sameMap(Me, function(Nt) {
                  return AI(Nt, s);
                }));
                return qt.objectFlags |= 2228352 | o, qt;
              }
              function Eh(r) {
                var i;
                return !e.some(r.declarations, e.isPrivateIdentifierClassElementDeclaration) && (!(r.flags & 106496) || !(!((i = r.declarations) === null || i === void 0) && i.some(function(t) {
                  return e.isClassLike(t.parent);
                })));
              }
              function xD(r, i) {
                var t = r.flags & 65536 && !(r.flags & 32768);
                if (!t && i === Zu(r)) return r;
                var o = 4 | r.flags & 16777216, s = oo(o, r.escapedName, Gd(r) | (i ? 8 : 0));
                return s.type = t ? Tr : Jt(r), s.declarations = r.declarations, s.nameType = Aa(r).nameType, s.syntheticOrigin = r, s;
              }
              function AI(r, i) {
                return r.isReadonly !== i ? zl(r.keyType, r.type, i, r.declaration) : r;
              }
              function oy(r, i, t, o) {
                var s = mc(r);
                return s.symbol = t, s.value = i, s.regularType = o || s, s;
              }
              function Sg(r) {
                if (r.flags & 2944) {
                  if (!r.freshType) {
                    var i = oy(r.flags, r.value, r.symbol, r);
                    i.freshType = i, r.freshType = i;
                  }
                  return r.freshType;
                }
                return r;
              }
              function jc(r) {
                return r.flags & 2944 ? r.regularType : r.flags & 1048576 ? r.regularType || (r.regularType = Ss(r, jc)) : r;
              }
              function Kp(r) {
                return !!(r.flags & 2944) && r.freshType === r;
              }
              function Bu(r) {
                var i;
                return Zt.get(r) || (Zt.set(r, i = oy(128, r)), i);
              }
              function If(r) {
                var i;
                return _r.get(r) || (_r.set(r, i = oy(256, r)), i);
              }
              function ED(r) {
                var i, t = e.pseudoBigIntToString(r);
                return pi.get(t) || (pi.set(t, i = oy(2048, r)), i);
              }
              function NI(r, i, t) {
                var o, s = typeof r == "string" ? "@" : "#", u = i + s + r, h = 1024 | (typeof r == "string" ? 128 : 256);
                return ae.get(u) || (ae.set(u, o = oy(h, r, t)), o);
              }
              function PI(r) {
                if (r.literal.kind === 104) return Wi;
                var i = va(r);
                return i.resolvedType || (i.resolvedType = jc(yn(r.literal))), i.resolvedType;
              }
              function II(r) {
                var i = mc(8192);
                return i.symbol = r, i.escapedName = "__@".concat(i.symbol.escapedName, "@").concat(y(i.symbol)), i;
              }
              function CD(r) {
                if (e.isValidESSymbolDeclaration(r)) {
                  var i = e.isCommonJsExportPropertyAssignment(r) ? Et(r.left) : Et(r);
                  if (i) {
                    var t = Aa(i);
                    return t.uniqueESSymbolType || (t.uniqueESSymbolType = II(i));
                  }
                }
                return Ki;
              }
              function wI(r) {
                var i = e.getThisContainer(r, false), t = i && i.parent;
                if (t && (e.isClassLike(t) || t.kind === 258) && !e.isStatic(i) && (!e.isConstructorDeclaration(i) || e.isNodeDescendantOf(r, i.body))) return aa(Et(t)).thisType;
                if (t && e.isObjectLiteralExpression(t) && e.isBinaryExpression(t.parent) && e.getAssignmentDeclarationKind(t.parent) === 6) return aa(Et(t.parent.left).parent).thisType;
                var o = r.flags & 8388608 ? e.getHostSignatureFromJSDoc(r) : void 0;
                return o && e.isFunctionExpression(o) && e.isBinaryExpression(o.parent) && e.getAssignmentDeclarationKind(o.parent) === 3 ? aa(Et(o.parent.left).parent).thisType : Sl(i) && e.isNodeDescendantOf(r, i.body) ? aa(Et(i)).thisType : (Xr(r, e.Diagnostics.A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface), Pe);
              }
              function Ch(r) {
                var i = va(r);
                return i.resolvedType || (i.resolvedType = wI(r)), i.resolvedType;
              }
              function aE(r) {
                return Va(sy(r.type) || r.type);
              }
              function sy(r) {
                switch (r.kind) {
                  case 191:
                    return sy(r.type);
                  case 184:
                    if (r.elements.length === 1 && (r = r.elements[0], r.kind === 186 || r.kind === 197 && r.dotDotDotToken)) return sy(r.type);
                    break;
                  case 183:
                    return r.elementType;
                }
              }
              function OI(r) {
                var i = va(r);
                return i.resolvedType || (i.resolvedType = r.dotDotDotToken ? aE(r) : kc(Va(r.type), true, !!r.questionToken));
              }
              function Va(r) {
                return mx(nE(r), r);
              }
              function nE(r) {
                switch (r.kind) {
                  case 130:
                  case 312:
                  case 313:
                    return Oe;
                  case 155:
                    return gr;
                  case 150:
                    return Li;
                  case 147:
                    return nt;
                  case 158:
                    return Mt;
                  case 133:
                    return Ii;
                  case 151:
                    return Ki;
                  case 114:
                    return Fi;
                  case 153:
                    return Tr;
                  case 104:
                    return Wi;
                  case 143:
                    return ui;
                  case 148:
                    return r.flags & 262144 && !n ? Oe : Oi;
                  case 138:
                    return De;
                  case 192:
                  case 108:
                    return Ch(r);
                  case 196:
                    return PI(r);
                  case 178:
                    return ty(r);
                  case 177:
                    return r.assertsModifier ? Fi : Ii;
                  case 228:
                    return ty(r);
                  case 181:
                    return yx(r);
                  case 183:
                  case 184:
                    return j3(r);
                  case 185:
                    return W3(r);
                  case 187:
                    return Q3(r);
                  case 188:
                    return aI(r);
                  case 314:
                    return b3(r);
                  case 316:
                    return kc(Va(r.type));
                  case 197:
                    return OI(r);
                  case 191:
                  case 315:
                  case 309:
                    return Va(r.type);
                  case 186:
                    return aE(r);
                  case 318:
                    return KM(r);
                  case 179:
                  case 180:
                  case 182:
                  case 322:
                  case 317:
                  case 323:
                    return tE(r);
                  case 193:
                    return fI(r);
                  case 194:
                    return Yx(r);
                  case 195:
                    return yD(r);
                  case 189:
                    return EI(r);
                  case 190:
                    return CI(r);
                  case 198:
                    return _I(r);
                  case 200:
                    return kI(r);
                  case 79:
                  case 161:
                  case 206:
                    var i = el(r);
                    return i ? go(i) : Pe;
                  default:
                    return Pe;
                }
              }
              function kh(r, i, t) {
                if (r && r.length) for (var o = 0; o < r.length; o++) {
                  var s = r[o], u = t(s, i);
                  if (s !== u) {
                    var h = o === 0 ? [] : r.slice(0, o);
                    for (h.push(u), o++; o < r.length; o++) h.push(t(r[o], i));
                    return h;
                  }
                }
                return r;
              }
              function e_(r, i) {
                return kh(r, i, un);
              }
              function Ah(r, i) {
                return kh(r, i, Tg);
              }
              function oE(r, i) {
                return kh(r, i, GI);
              }
              function Uc(r, i) {
                return r.length === 1 ? Yd(r[0], i ? i[0] : Oe) : FI(r, i);
              }
              function ap(r, i) {
                switch (i.kind) {
                  case 0:
                    return r === i.source ? i.target : r;
                  case 1:
                    for (var t = i.sources, o = i.targets, s = 0; s < t.length; s++) if (r === t[s]) return o ? o[s] : Oe;
                    return r;
                  case 2:
                    return i.func(r);
                  case 3:
                  case 4:
                    var u = ap(r, i.mapper1);
                    return u !== r && i.kind === 3 ? un(u, i.mapper2) : ap(u, i.mapper2);
                }
              }
              function Yd(r, i) {
                return { kind: 0, source: r, target: i };
              }
              function FI(r, i) {
                return { kind: 1, sources: r, targets: i };
              }
              function Gp(r) {
                return { kind: 2, func: r };
              }
              function Nh(r, i, t) {
                return { kind: r, mapper1: i, mapper2: t };
              }
              function sE(r) {
                return Uc(r, void 0);
              }
              function MI(r, i) {
                return Gp(function(t) {
                  return e.findIndex(r.inferences, function(o) {
                    return o.typeParameter === t;
                  }) >= i ? gr : t;
                });
              }
              function np(r, i) {
                return r ? Nh(3, r, i) : i;
              }
              function LI(r, i) {
                return r ? Nh(4, r, i) : i;
              }
              function $d(r, i, t) {
                return t ? Nh(4, Yd(r, i), t) : Yd(r, i);
              }
              function tv(r, i, t) {
                return r ? Nh(4, r, Yd(i, t)) : Yd(i, t);
              }
              function RI(r) {
                return r.constraint === gr ? r : r.restrictiveInstantiation || (r.restrictiveInstantiation = Hc(r.symbol), r.restrictiveInstantiation.constraint = gr, r.restrictiveInstantiation);
              }
              function kD(r) {
                var i = Hc(r.symbol);
                return i.target = r, i;
              }
              function BI(r, i) {
                return vg(r.kind, r.parameterName, r.parameterIndex, un(r.type, i));
              }
              function Tg(r, i, t) {
                var o;
                if (r.typeParameters && !t) {
                  o = e.map(r.typeParameters, kD), i = np(Uc(r.typeParameters, o), i);
                  for (var s = 0, u = o; s < u.length; s++) {
                    var h = u[s];
                    h.mapper = i;
                  }
                }
                var z2 = Fu(r.declaration, o, r.thisParameter && AD(r.thisParameter, i), kh(r.parameters, i, AD), void 0, void 0, r.minArgumentCount, r.flags & 39);
                return z2.target = r, z2.mapper = i, z2;
              }
              function AD(r, i) {
                var t = Aa(r);
                if (t.type && !Id(t.type)) return r;
                e.getCheckFlags(r) & 1 && (r = t.target, i = np(t.mapper, i));
                var o = oo(r.flags, r.escapedName, 1 | e.getCheckFlags(r) & 53256);
                return o.declarations = r.declarations, o.parent = r.parent, o.target = r, o.mapper = i, r.valueDeclaration && (o.valueDeclaration = r.valueDeclaration), t.nameType && (o.nameType = t.nameType), o;
              }
              function JI(r, i, t, o) {
                var s = r.objectFlags & 4 || r.objectFlags & 8388608 ? r.node : r.symbol.declarations[0], u = va(s), h = r.objectFlags & 4 ? u.resolvedType : r.objectFlags & 64 ? r.target : r, z2 = u.outerTypeParameters;
                if (!z2) {
                  var me = kf(s, true);
                  if (Sl(s)) {
                    var Me = jl(s);
                    me = e.addRange(me, Me);
                  }
                  z2 = me || e.emptyArray;
                  var $e = r.objectFlags & 8388612 ? [s] : r.symbol.declarations;
                  z2 = (h.objectFlags & 8388612 || h.symbol.flags & 8192 || h.symbol.flags & 2048) && !h.aliasTypeArguments ? e.filter(z2, function($i) {
                    return e.some($e, function(Zi) {
                      return Ph($i, Zi);
                    });
                  }) : z2, u.outerTypeParameters = z2;
                }
                if (z2.length) {
                  var tr = np(r.mapper, i), dr = e.map(z2, function($i) {
                    return ap($i, tr);
                  }), Dr = t || r.aliasSymbol, Qr = t ? o : e_(r.aliasTypeArguments, i), li = Su(dr) + hg(Dr, Qr);
                  h.instantiations || (h.instantiations = new e.Map(), h.instantiations.set(Su(z2) + hg(h.aliasSymbol, h.aliasTypeArguments), h));
                  var Ti = h.instantiations.get(li);
                  if (!Ti) {
                    var Ci = Uc(z2, dr);
                    Ti = h.objectFlags & 4 ? tD(r.target, r.node, Ci, Dr, Qr) : h.objectFlags & 32 ? cE(h, Ci, Dr, Qr) : PD(h, Ci, Dr, Qr), h.instantiations.set(li, Ti);
                  }
                  return Ti;
                }
                return r;
              }
              function jI(r) {
                return !(r.parent.kind === 178 && r.parent.typeArguments && r === r.parent.typeName || r.parent.kind === 200 && r.parent.typeArguments && r === r.parent.qualifier);
              }
              function Ph(r, i) {
                if (r.symbol && r.symbol.declarations && r.symbol.declarations.length === 1) {
                  for (var t = r.symbol.declarations[0].parent, o = i; o !== t; o = o.parent) if (!o || o.kind === 235 || o.kind === 189 && e.forEachChild(o.extendsType, s)) return true;
                  return s(i);
                }
                return true;
                function s(u) {
                  switch (u.kind) {
                    case 192:
                      return !!r.isThisType;
                    case 79:
                      return !r.isThisType && e.isPartOfTypeNode(u) && jI(u) && nE(u) === r;
                    case 181:
                      return true;
                    case 169:
                    case 168:
                      return !u.type && !!u.body || e.some(u.typeParameters, s) || e.some(u.parameters, s) || !!u.type && s(u.type);
                  }
                  return !!e.forEachChild(u, s);
                }
              }
              function Ih(r) {
                var i = Mu(r);
                if (i.flags & 4194304) {
                  var t = rp(i.type);
                  if (t.flags & 262144) return t;
                }
              }
              function cE(r, i, t, o) {
                var s = Ih(r);
                if (s) {
                  var u = un(s, i);
                  if (s !== u) return uC(bu(u), function(h) {
                    if (h.flags & 61603843 && h !== Mr && !nn(h)) {
                      if (!r.declaration.nameType) {
                        var z2 = void 0;
                        if (Tu(h) || h.flags & 1 && v(s, 4) < 0 && (z2 = Tc(s)) && gf(z2, Pd)) return zI(h, r, $d(s, h, i));
                        if (lm(h)) return UI(h, r, s, i);
                        if (Yn(h)) return WI(h, r, $d(s, h, i));
                      }
                      return PD(r, $d(s, h, i));
                    }
                    return h;
                  }, t, o);
                }
                return un(Mu(r), i) === Mr ? Mr : PD(r, i, t, o);
              }
              function ND(r, i) {
                return i & 1 ? true : i & 2 ? false : r;
              }
              function UI(r, i, t, o) {
                var s = r.target.elementFlags, u = e.map(xo(r), function(z2, me) {
                  var Me = s[me] & 8 ? z2 : s[me] & 4 ? Zs(z2) : Wl([z2], [s[me]]);
                  return cE(i, $d(t, Me, o));
                }), h = ND(r.target.readonly, Lu(i));
                return Wl(u, e.map(u, function(z2) {
                  return 8;
                }), h);
              }
              function zI(r, i, t) {
                var o = uE(i, nt, true, t);
                return nn(o) ? Pe : Zs(o, ND(um(r), Lu(i)));
              }
              function WI(r, i, t) {
                var o = r.target.elementFlags, s = e.map(xo(r), function(me, Me) {
                  return uE(i, Bu("" + Me), !!(o[Me] & 2), t);
                }), u = Lu(i), h = u & 4 ? e.map(o, function(me) {
                  return me & 1 ? 2 : me;
                }) : u & 8 ? e.map(o, function(me) {
                  return me & 2 ? 1 : me;
                }) : o, z2 = ND(r.target.readonly, u);
                return e.contains(s, Pe) ? Pe : Wl(s, h, z2, r.target.labeledElementDeclarations);
              }
              function uE(r, i, t, o) {
                var s = tv(o, Du(r), i), u = un(vl(r.target || r), s), h = Lu(r);
                return Ye && h & 4 && !fs(u, 49152) ? i_(u, true) : Ye && h & 8 && t ? Ks(u, 524288) : u;
              }
              function PD(r, i, t, o) {
                var s = tu(r.objectFlags | 64, r.symbol);
                if (r.objectFlags & 32) {
                  s.declaration = r.declaration;
                  var u = Du(r), h = kD(u);
                  s.typeParameter = h, i = np(Yd(u, h), i), h.mapper = i;
                }
                return r.objectFlags & 8388608 && (s.node = r.node), s.target = r, s.mapper = i, s.aliasSymbol = t || r.aliasSymbol, s.aliasTypeArguments = t ? o : e_(r.aliasTypeArguments, i), s;
              }
              function ID(r, i, t, o) {
                var s = r.root;
                if (s.outerTypeParameters) {
                  var u = e.map(s.outerTypeParameters, function(tr) {
                    return ap(tr, i);
                  }), h = Su(u) + hg(t, o), z2 = s.instantiations.get(h);
                  if (!z2) {
                    var me = Uc(s.outerTypeParameters, u), Me = s.checkType, $e = s.isDistributive ? ap(Me, me) : void 0;
                    z2 = $e && Me !== $e && $e.flags & 1179648 ? uC(bu($e), function(tr) {
                      return DD(s, $d(Me, tr, me));
                    }, t, o) : DD(s, me, t, o), s.instantiations.set(h, z2);
                  }
                  return z2;
                }
                return r;
              }
              function un(r, i) {
                return r && i ? lE(r, i, void 0, void 0) : r;
              }
              function lE(r, i, t, o) {
                if (!Id(r)) return r;
                if (He === 100 || Ee >= 5e6) return e.tracing === null || e.tracing === void 0 || e.tracing.instant("checkTypes", "instantiateType_DepthLimit", { typeId: r.id, instantiationDepth: He, instantiationCount: Ee }), Xr(Ie, e.Diagnostics.Type_instantiation_is_excessively_deep_and_possibly_infinite), Pe;
                ze++, Ee++, He++;
                var s = qI(r, i, t, o);
                return He--, s;
              }
              function qI(r, i, t, o) {
                var s = r.flags;
                if (s & 262144) return ap(r, i);
                if (s & 524288) {
                  var u = r.objectFlags;
                  if (u & 52) {
                    if (u & 4 && !r.node) {
                      var h = r.resolvedTypeArguments, z2 = e_(h, i);
                      return z2 !== h ? uD(r.target, z2) : r;
                    }
                    return u & 1024 ? VI(r, i) : JI(r, i, t, o);
                  }
                  return r;
                }
                if (s & 3145728) {
                  var me = r.flags & 1048576 ? r.origin : void 0, Me = me && me.flags & 3145728 ? me.types : r.types, $e = e_(Me, i);
                  if ($e === Me && t === r.aliasSymbol) return r;
                  var tr = t || r.aliasSymbol, dr = t ? o : e_(r.aliasTypeArguments, i);
                  return s & 2097152 || me && me.flags & 2097152 ? Do($e, tr, dr) : Pa($e, 1, tr, dr);
                }
                if (s & 4194304) return ql(un(r.type, i));
                if (s & 134217728) return Dg(r.texts, e_(r.types, i));
                if (s & 268435456) return Th(r.symbol, un(r.type, i));
                if (s & 8388608) {
                  var tr = t || r.aliasSymbol, dr = t ? o : e_(r.aliasTypeArguments, i);
                  return Jc(un(r.objectType, i), un(r.indexType, i), r.accessFlags, void 0, tr, dr);
                }
                if (s & 16777216) return ID(r, np(r.mapper, i), t, o);
                if (s & 33554432) {
                  var Dr = un(r.baseType, i);
                  if (Dr.flags & 8650752) return px(Dr, un(r.substitute, i));
                  var Qr = un(r.substitute, i);
                  return Qr.flags & 3 || ao(Nd(Dr), Nd(Qr)) ? Dr : Qr;
                }
                return r;
              }
              function VI(r, i) {
                var t = un(r.mappedType, i);
                if (!(e.getObjectFlags(t) & 32)) return r;
                var o = un(r.constraintType, i);
                if (!(o.flags & 4194304)) return r;
                var s = UE(un(r.source, i), t, o);
                return s || r;
              }
              function KI(r) {
                return r.flags & 262143 ? r : r.uniqueLiteralFilledInstantiation || (r.uniqueLiteralFilledInstantiation = un(r, ka));
              }
              function wh(r) {
                return r.flags & 262143 ? r : r.permissiveInstantiation || (r.permissiveInstantiation = un(r, ai));
              }
              function Nd(r) {
                return r.flags & 262143 ? r : (r.restrictiveInstantiation || (r.restrictiveInstantiation = un(r, Qa), r.restrictiveInstantiation.restrictiveInstantiation = r.restrictiveInstantiation), r.restrictiveInstantiation);
              }
              function GI(r, i) {
                return zl(r.keyType, un(r.type, i), r.isReadonly, r.declaration);
              }
              function Ju(r) {
                switch (e.Debug.assert(r.kind !== 169 || e.isObjectLiteralMethod(r)), r.kind) {
                  case 213:
                  case 214:
                  case 169:
                  case 256:
                    return fE(r);
                  case 205:
                    return e.some(r.properties, Ju);
                  case 204:
                    return e.some(r.elements, Ju);
                  case 222:
                    return Ju(r.whenTrue) || Ju(r.whenFalse);
                  case 221:
                    return (r.operatorToken.kind === 56 || r.operatorToken.kind === 60) && (Ju(r.left) || Ju(r.right));
                  case 296:
                    return Ju(r.initializer);
                  case 212:
                    return Ju(r.expression);
                  case 286:
                    return e.some(r.properties, Ju) || e.isJsxOpeningElement(r.parent) && e.some(r.parent.parent.children, Ju);
                  case 285: {
                    var i = r.initializer;
                    return !!i && Ju(i);
                  }
                  case 288: {
                    var t = r.expression;
                    return !!t && Ju(t);
                  }
                }
                return false;
              }
              function fE(r) {
                return (!e.isFunctionDeclaration(r) || e.isInJSFile(r) && !!K_(r)) && (e.hasContextSensitiveParameters(r) || HI(r));
              }
              function HI(r) {
                return !r.typeParameters && !e.getEffectiveReturnTypeNode(r) && !!r.body && r.body.kind !== 235 && Ju(r.body);
              }
              function wD(r) {
                return (e.isInJSFile(r) && e.isFunctionDeclaration(r) || e.isFunctionExpressionOrArrowFunction(r) || e.isObjectLiteralMethod(r)) && fE(r);
              }
              function _E(r) {
                if (r.flags & 524288) {
                  var i = Ru(r);
                  if (i.constructSignatures.length || i.callSignatures.length) {
                    var t = tu(16, r.symbol);
                    return t.members = i.members, t.properties = i.properties, t.callSignatures = e.emptyArray, t.constructSignatures = e.emptyArray, t.indexInfos = e.emptyArray, t;
                  }
                } else if (r.flags & 2097152) return Do(e.map(r.types, _E));
                return r;
              }
              function wf(r, i) {
                return r_(r, i, wa);
              }
              function av(r, i) {
                return r_(r, i, wa) ? -1 : 0;
              }
              function OD(r, i) {
                return r_(r, i, dt) ? -1 : 0;
              }
              function XI(r, i) {
                return r_(r, i, Or) ? -1 : 0;
              }
              function E_(r, i) {
                return r_(r, i, Or);
              }
              function ao(r, i) {
                return r_(r, i, dt);
              }
              function xg(r, i) {
                return r.flags & 1048576 ? e.every(r.types, function(t) {
                  return xg(t, i);
                }) : i.flags & 1048576 ? e.some(i.types, function(t) {
                  return xg(r, t);
                }) : r.flags & 58982400 ? xg(uc(r) || gr, i) : i === qe ? !!(r.flags & 67633152) : i === br ? !!(r.flags & 524288) && db(r) : lf(r, bd(i)) || Tu(i) && !um(i) && xg(r, Qi);
              }
              function cm(r, i) {
                return r_(r, i, la);
              }
              function Oh(r, i) {
                return cm(r, i) || cm(i, r);
              }
              function zc(r, i, t, o, s, u) {
                return hl(r, i, dt, t, o, s, u);
              }
              function op(r, i, t, o, s, u) {
                return FD(r, i, dt, t, o, s, u, void 0);
              }
              function FD(r, i, t, o, s, u, h, z2) {
                return r_(r, i, t) ? true : !o || !cy(s, r, i, t, u, h, z2) ? hl(r, i, t, o, u, h, z2) : false;
              }
              function pE(r) {
                return !!(r.flags & 16777216 || r.flags & 2097152 && e.some(r.types, pE));
              }
              function cy(r, i, t, o, s, u, h) {
                if (!r || pE(t)) return false;
                if (!hl(i, t, o, void 0) && QI(r, i, t, o, s, u, h)) return true;
                switch (r.kind) {
                  case 288:
                  case 212:
                    return cy(r.expression, i, t, o, s, u, h);
                  case 221:
                    switch (r.operatorToken.kind) {
                      case 63:
                      case 27:
                        return cy(r.right, i, t, o, s, u, h);
                    }
                    break;
                  case 205:
                    return nw(r, i, t, o, u, h);
                  case 204:
                    return tw(r, i, t, o, u, h);
                  case 286:
                    return iw(r, i, t, o, u, h);
                  case 214:
                    return YI(r, i, t, o, u, h);
                }
                return false;
              }
              function QI(r, i, t, o, s, u, h) {
                for (var z2 = ot(i, 0), me = ot(i, 1), Me = 0, $e = [me, z2]; Me < $e.length; Me++) {
                  var tr = $e[Me];
                  if (e.some(tr, function(Qr) {
                    var li = yo(Qr);
                    return !(li.flags & 131073) && hl(li, t, o, void 0);
                  })) {
                    var dr = h || {};
                    zc(i, t, r, s, u, dr);
                    var Dr = dr.errors[dr.errors.length - 1];
                    return e.addRelatedInfo(Dr, e.createDiagnosticForNode(r, tr === me ? e.Diagnostics.Did_you_mean_to_use_new_with_this_expression : e.Diagnostics.Did_you_mean_to_call_this_expression)), true;
                  }
                }
                return false;
              }
              function YI(r, i, t, o, s, u) {
                if (e.isBlock(r.body) || e.some(r.parameters, e.hasType)) return false;
                var h = ig(i);
                if (!h) return false;
                var z2 = ot(t, 0);
                if (!e.length(z2)) return false;
                var me = r.body, Me = yo(h), $e = Pa(e.map(z2, yo));
                if (!hl(Me, $e, o, void 0)) {
                  var tr = me && cy(me, Me, $e, o, void 0, s, u);
                  if (tr) return tr;
                  var dr = u || {};
                  if (hl(Me, $e, o, me, void 0, s, dr), dr.errors) return t.symbol && e.length(t.symbol.declarations) && e.addRelatedInfo(dr.errors[dr.errors.length - 1], e.createDiagnosticForNode(t.symbol.declarations[0], e.Diagnostics.The_expected_type_comes_from_the_return_type_of_this_signature)), (e.getFunctionFlags(r) & 2) === 0 && !da(Me, "then") && hl(Ny(Me), $e, o, void 0) && e.addRelatedInfo(dr.errors[dr.errors.length - 1], e.createDiagnosticForNode(r, e.Diagnostics.Did_you_mean_to_mark_this_function_as_async)), true;
                }
                return false;
              }
              function $I(r, i, t) {
                var o = ep(i, t);
                if (o) return o;
                if (i.flags & 1048576) {
                  var s = bE(r, i);
                  if (s) return ep(s, t);
                }
              }
              function ZI(r, i) {
                r.contextualType = i;
                try {
                  return Dm(r, 1, i);
                } finally {
                  r.contextualType = void 0;
                }
              }
              function nv(r, i, t, o, s, u) {
                for (var h = false, z2 = r.next(); !z2.done; z2 = r.next()) {
                  var me = z2.value, Me = me.errorNode, $e = me.innerExpression, tr = me.nameType, dr = me.errorMessage, Dr = $I(i, t, tr);
                  if (!(!Dr || Dr.flags & 8388608)) {
                    var Qr = ep(i, tr);
                    if (!!Qr) {
                      var li = gD(tr, void 0);
                      if (!hl(Qr, Dr, o, void 0)) {
                        var Ti = $e && cy($e, Qr, Dr, o, void 0, s, u);
                        if (h = true, !Ti) {
                          var Ci = u || {}, $i = $e ? ZI($e, Qr) : Qr;
                          if (yr && jD($i, Dr)) {
                            var Zi = e.createDiagnosticForNode(Me, e.Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target, Ot($i), Ot(Dr));
                            rn.add(Zi), Ci.errors = [Zi];
                          } else {
                            var qt = !!(li && (bi(t, li) || xe).flags & 16777216), Nt = !!(li && (bi(i, li) || xe).flags & 16777216);
                            Dr = kg(Dr, qt), Qr = kg(Qr, qt && Nt);
                            var Ra = hl($i, Dr, o, Me, dr, s, Ci);
                            Ra && $i !== Qr && hl(Qr, Dr, o, Me, dr, s, Ci);
                          }
                          if (Ci.errors) {
                            var ca = Ci.errors[Ci.errors.length - 1], Sn = _f(tr) ? pf(tr) : void 0, ja = Sn !== void 0 ? bi(t, Sn) : void 0, Fn = false;
                            if (!ja) {
                              var wn = nu(t, tr);
                              wn && wn.declaration && !e.getSourceFileOfNode(wn.declaration).hasNoDefaultLib && (Fn = true, e.addRelatedInfo(ca, e.createDiagnosticForNode(wn.declaration, e.Diagnostics.The_expected_type_comes_from_this_index_signature)));
                            }
                            if (!Fn && (ja && e.length(ja.declarations) || t.symbol && e.length(t.symbol.declarations))) {
                              var Tn = ja && e.length(ja.declarations) ? ja.declarations[0] : t.symbol.declarations[0];
                              e.getSourceFileOfNode(Tn).hasNoDefaultLib || e.addRelatedInfo(ca, e.createDiagnosticForNode(Tn, e.Diagnostics.The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1, Sn && !(tr.flags & 8192) ? e.unescapeLeadingUnderscores(Sn) : Ot(tr), Ot(t)));
                            }
                          }
                        }
                      }
                    }
                  }
                }
                return h;
              }
              function ew(r) {
                var i, t, o;
                return kr(this, function(s) {
                  switch (s.label) {
                    case 0:
                      if (!e.length(r.properties)) return [2];
                      i = 0, t = r.properties, s.label = 1;
                    case 1:
                      return i < t.length ? (o = t[i], e.isJsxSpreadAttribute(o) || Ob(e.idText(o.name)) ? [3, 3] : [4, { errorNode: o.name, innerExpression: o.initializer, nameType: Bu(e.idText(o.name)) }]) : [3, 4];
                    case 2:
                      s.sent(), s.label = 3;
                    case 3:
                      return i++, [3, 1];
                    case 4:
                      return [2];
                  }
                });
              }
              function rw(r, i) {
                var t, o, s, u, h;
                return kr(this, function(z2) {
                  switch (z2.label) {
                    case 0:
                      if (!e.length(r.children)) return [2];
                      t = 0, o = 0, z2.label = 1;
                    case 1:
                      return o < r.children.length ? (s = r.children[o], u = If(o - t), h = dE(s, u, i), h ? [4, h] : [3, 3]) : [3, 5];
                    case 2:
                      return z2.sent(), [3, 4];
                    case 3:
                      t++, z2.label = 4;
                    case 4:
                      return o++, [3, 1];
                    case 5:
                      return [2];
                  }
                });
              }
              function dE(r, i, t) {
                switch (r.kind) {
                  case 288:
                    return { errorNode: r, innerExpression: r.expression, nameType: i };
                  case 11:
                    if (r.containsOnlyTriviaWhiteSpaces) break;
                    return { errorNode: r, innerExpression: void 0, nameType: i, errorMessage: t() };
                  case 278:
                  case 279:
                  case 282:
                    return { errorNode: r, innerExpression: r, nameType: i };
                  default:
                    return e.Debug.assertNever(r, "Found invalid jsx child");
                }
              }
              function iw(r, i, t, o, s, u) {
                var h = nv(ew(r), i, t, o, s, u), z2;
                if (e.isJsxOpeningElement(r.parent) && e.isJsxElement(r.parent.parent)) {
                  var me = r.parent.parent, Me = _0(Og(r)), $e = Me === void 0 ? "children" : e.unescapeLeadingUnderscores(Me), tr = Bu($e), dr = Jc(t, tr), Dr = e.getSemanticJsxChildren(me.children);
                  if (!e.length(Dr)) return h;
                  var Qr = e.length(Dr) > 1, li = ec(dr, AE), Ti = ec(dr, function(ca) {
                    return !AE(ca);
                  });
                  if (Qr) {
                    if (li !== ui) {
                      var Ci = Wl(f0(me, 0)), $i = rw(me, Ra);
                      h = nv($i, Ci, li, o, s, u) || h;
                    } else if (!r_(Jc(i, tr), dr, o)) {
                      h = true;
                      var Zi = Xr(me.openingElement.tagName, e.Diagnostics.This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided, $e, Ot(dr));
                      u && u.skipLogging && (u.errors || (u.errors = [])).push(Zi);
                    }
                  } else if (Ti !== ui) {
                    var qt = Dr[0], Nt = dE(qt, tr, Ra);
                    Nt && (h = nv(function() {
                      return kr(this, function(ca) {
                        switch (ca.label) {
                          case 0:
                            return [4, Nt];
                          case 1:
                            return ca.sent(), [2];
                        }
                      });
                    }(), i, t, o, s, u) || h);
                  } else if (!r_(Jc(i, tr), dr, o)) {
                    h = true;
                    var Zi = Xr(me.openingElement.tagName, e.Diagnostics.This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided, $e, Ot(dr));
                    u && u.skipLogging && (u.errors || (u.errors = [])).push(Zi);
                  }
                }
                return h;
                function Ra() {
                  if (!z2) {
                    var ca = e.getTextOfNode(r.parent.tagName), Sn = _0(Og(r)), ja = Sn === void 0 ? "children" : e.unescapeLeadingUnderscores(Sn), Fn = Jc(t, Bu(ja)), wn = e.Diagnostics._0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2;
                    z2 = Ke(Ke({}, wn), { key: "!!ALREADY FORMATTED!!", message: e.formatMessage(void 0, wn, ca, ja, Ot(Fn)) });
                  }
                  return z2;
                }
              }
              function gE(r, i) {
                var t, o, s, u;
                return kr(this, function(h) {
                  switch (h.label) {
                    case 0:
                      if (t = e.length(r.elements), !t) return [2];
                      o = 0, h.label = 1;
                    case 1:
                      return o < t ? Eg(i) && !bi(i, "" + o) ? [3, 3] : (s = r.elements[o], e.isOmittedExpression(s) ? [3, 3] : (u = If(o), [4, { errorNode: s, innerExpression: s, nameType: u }])) : [3, 4];
                    case 2:
                      h.sent(), h.label = 3;
                    case 3:
                      return o++, [3, 1];
                    case 4:
                      return [2];
                  }
                });
              }
              function tw(r, i, t, o, s, u) {
                if (t.flags & 131068) return false;
                if (Eg(i)) return nv(gE(r, t), i, t, o, s, u);
                var h = r.contextualType;
                r.contextualType = t;
                try {
                  var z2 = PC(r, 1, true);
                  return r.contextualType = h, Eg(z2) ? nv(gE(r, t), z2, t, o, s, u) : false;
                } finally {
                  r.contextualType = h;
                }
              }
              function aw(r) {
                var i, t, o, s, u;
                return kr(this, function(h) {
                  switch (h.label) {
                    case 0:
                      if (!e.length(r.properties)) return [2];
                      i = 0, t = r.properties, h.label = 1;
                    case 1:
                      if (!(i < t.length)) return [3, 8];
                      if (o = t[i], e.isSpreadAssignment(o)) return [3, 7];
                      if (s = om(Et(o), 8576), !s || s.flags & 131072) return [3, 7];
                      switch (u = o.kind, u) {
                        case 173:
                          return [3, 2];
                        case 172:
                          return [3, 2];
                        case 169:
                          return [3, 2];
                        case 297:
                          return [3, 2];
                        case 296:
                          return [3, 4];
                      }
                      return [3, 6];
                    case 2:
                      return [4, { errorNode: o.name, innerExpression: void 0, nameType: s }];
                    case 3:
                      return h.sent(), [3, 7];
                    case 4:
                      return [4, { errorNode: o.name, innerExpression: o.initializer, nameType: s, errorMessage: e.isComputedNonLiteralName(o.name) ? e.Diagnostics.Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1 : void 0 }];
                    case 5:
                      return h.sent(), [3, 7];
                    case 6:
                      e.Debug.assertNever(o), h.label = 7;
                    case 7:
                      return i++, [3, 1];
                    case 8:
                      return [2];
                  }
                });
              }
              function nw(r, i, t, o, s, u) {
                return t.flags & 131068 ? false : nv(aw(r), i, t, o, s, u);
              }
              function mE(r, i, t, o, s) {
                return hl(r, i, la, t, o, s);
              }
              function ow(r, i, t) {
                return MD(r, i, t ? 4 : 0, false, void 0, void 0, OD, void 0) !== 0;
              }
              function sw(r) {
                return !r.typeParameters && (!r.thisParameter || ta(mv(r.thisParameter))) && r.parameters.length === 1 && H(r) && (mv(r.parameters[0]) === mo || ta(mv(r.parameters[0]))) && ta(yo(r));
              }
              function MD(r, i, t, o, s, u, h, z2) {
                if (r === i || sw(i)) return -1;
                var me = Wc(i), Me = !Xl(i) && (t & 8 ? Xl(r) || Wc(r) > me : Hl(r) > me);
                if (Me) return 0;
                r.typeParameters && r.typeParameters !== i.typeParameters && (i = g3(i), r = sk(r, i, void 0, h));
                var $e = Wc(r), tr = yv(r), dr = yv(i);
                (tr || dr) && un(tr || dr, z2);
                var Dr = i.declaration ? i.declaration.kind : 0, Qr = !(t & 3) && Br && Dr !== 169 && Dr !== 168 && Dr !== 171, li = -1, Ti = T_(r);
                if (Ti && Ti !== Fi) {
                  var Ci = T_(i);
                  if (Ci) {
                    var $i = !Qr && h(Ti, Ci, false) || h(Ci, Ti, o);
                    if (!$i) return o && s(e.Diagnostics.The_this_types_of_each_signature_are_incompatible), 0;
                    li &= $i;
                  }
                }
                for (var Zi = tr || dr ? Math.min($e, me) : Math.max($e, me), qt = tr || dr ? Zi - 1 : -1, Nt = 0; Nt < Zi; Nt++) {
                  var Ra = Nt === qt ? ym(r, Nt) : Ld(r, Nt), ca = Nt === qt ? ym(i, Nt) : Ld(i, Nt);
                  if (Ra && ca) {
                    var Sn = t & 3 ? void 0 : ig(C_(Ra)), ja = t & 3 ? void 0 : ig(C_(ca)), Fn = Sn && ja && !Yc(Sn) && !Yc(ja) && (ju(Ra) & 98304) === (ju(ca) & 98304), $i = Fn ? MD(ja, Sn, t & 8 | (Qr ? 2 : 1), o, s, u, h, z2) : !(t & 3) && !Qr && h(Ra, ca, false) || h(ca, Ra, o);
                    if ($i && t & 8 && Nt >= Hl(r) && Nt < Hl(i) && h(Ra, ca, false) && ($i = 0), !$i) return o && s(e.Diagnostics.Types_of_parameters_0_and_1_are_incompatible, e.unescapeLeadingUnderscores(vm(r, Nt)), e.unescapeLeadingUnderscores(vm(i, Nt))), 0;
                    li &= $i;
                  }
                }
                if (!(t & 4)) {
                  var wn = Z1(i) ? Oe : i.declaration && Sl(i.declaration) ? aa(so(i.declaration.symbol)) : yo(i);
                  if (wn === Fi || wn === Oe) return li;
                  var Tn = Z1(r) ? Oe : r.declaration && Sl(r.declaration) ? aa(so(r.declaration.symbol)) : yo(r), Eo = Yc(i);
                  if (Eo) {
                    var lt = Yc(r);
                    if (lt) li &= cw(lt, Eo, o, s, h);
                    else if (e.isIdentifierTypePredicate(Eo)) return o && s(e.Diagnostics.Signature_0_must_be_a_type_predicate, Ml(r)), 0;
                  } else li &= t & 1 && h(wn, Tn, false) || h(Tn, wn, o), !li && o && u && u(Tn, wn);
                }
                return li;
              }
              function cw(r, i, t, o, s) {
                if (r.kind !== i.kind) return t && (o(e.Diagnostics.A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard), o(e.Diagnostics.Type_predicate_0_is_not_assignable_to_1, Ll(r), Ll(i))), 0;
                if ((r.kind === 1 || r.kind === 3) && r.parameterIndex !== i.parameterIndex) return t && (o(e.Diagnostics.Parameter_0_is_not_in_the_same_position_as_parameter_1, r.parameterName, i.parameterName), o(e.Diagnostics.Type_predicate_0_is_not_assignable_to_1, Ll(r), Ll(i))), 0;
                var u = r.type === i.type ? -1 : r.type && i.type ? s(r.type, i.type, t) : 0;
                return u === 0 && t && o(e.Diagnostics.Type_predicate_0_is_not_assignable_to_1, Ll(r), Ll(i)), u;
              }
              function uw(r, i) {
                var t = Qm(r), o = Qm(i), s = yo(t), u = yo(o);
                return u === Fi || r_(u, s, dt) || r_(s, u, dt) ? ow(t, o, true) : false;
              }
              function LD(r) {
                return r !== xn && r.properties.length === 0 && r.callSignatures.length === 0 && r.constructSignatures.length === 0 && r.indexInfos.length === 0;
              }
              function Of(r) {
                return r.flags & 524288 ? !Bc(r) && LD(Ru(r)) : r.flags & 67108864 ? true : r.flags & 1048576 ? e.some(r.types, Of) : r.flags & 2097152 ? e.every(r.types, Of) : false;
              }
              function vE(r) {
                return !!(e.getObjectFlags(r) & 16 && (r.members && LD(r) || r.symbol && r.symbol.flags & 2048 && Nf(r.symbol).size === 0));
              }
              function yE(r) {
                return r.flags & 524288 && !Bc(r) && uo(r).length === 0 && Hn(r).length === 1 && !!ss(r, Li) || r.flags & 3145728 && e.every(r.types, yE) || false;
              }
              function RD(r, i, t) {
                if (r === i) return true;
                var o = y(r) + "," + y(i), s = On.get(o);
                if (s !== void 0 && !(!(s & 4) && s & 2 && t)) return !!(s & 1);
                if (r.escapedName !== i.escapedName || !(r.flags & 256) || !(i.flags & 256)) return On.set(o, 6), false;
                for (var u = Jt(i), h = 0, z2 = uo(Jt(r)); h < z2.length; h++) {
                  var me = z2[h];
                  if (me.flags & 8) {
                    var Me = bi(u, me.escapedName);
                    if (!Me || !(Me.flags & 8)) return t ? (t(e.Diagnostics.Property_0_is_missing_in_type_1, e.symbolName(me), Ot(go(i), void 0, 64)), On.set(o, 6)) : On.set(o, 2), false;
                  }
                }
                return On.set(o, 1), true;
              }
              function uy(r, i, t, o) {
                var s = r.flags, u = i.flags;
                return u & 3 || s & 131072 || r === Mr ? true : u & 131072 ? false : !!(s & 402653316 && u & 4 || s & 128 && s & 1024 && u & 128 && !(u & 1024) && r.value === i.value || s & 296 && u & 8 || s & 256 && s & 1024 && u & 256 && !(u & 1024) && r.value === i.value || s & 2112 && u & 64 || s & 528 && u & 16 || s & 12288 && u & 4096 || s & 32 && u & 32 && RD(r.symbol, i.symbol, o) || s & 1024 && u & 1024 && (s & 1048576 && u & 1048576 && RD(r.symbol, i.symbol, o) || s & 2944 && u & 2944 && r.value === i.value && RD(Ys(r.symbol), Ys(i.symbol), o)) || s & 32768 && (!Ye && !(u & 3145728) || u & 49152) || s & 65536 && (!Ye && !(u & 3145728) || u & 65536) || s & 524288 && u & 67108864 || (t === dt || t === la) && (s & 1 || s & 264 && !(s & 1024) && (u & 32 || t === dt && u & 256 && u & 1024)));
              }
              function r_(r, i, t) {
                if (Kp(r) && (r = r.regularType), Kp(i) && (i = i.regularType), r === i) return true;
                if (t !== wa) {
                  if (t === la && !(i.flags & 131072) && uy(i, r, t) || uy(r, i, t)) return true;
                } else if (!((r.flags | i.flags) & 61865984)) {
                  if (r.flags !== i.flags) return false;
                  if (r.flags & 67358815) return true;
                }
                if (r.flags & 524288 && i.flags & 524288) {
                  var o = t.get(qD(r, i, 0, t, false));
                  if (o !== void 0) return !!(o & 1);
                }
                return r.flags & 469499904 || i.flags & 469499904 ? hl(r, i, t, void 0) : false;
              }
              function hE(r, i) {
                return e.getObjectFlags(r) & 2048 && Ob(i.escapedName);
              }
              function BD(r, i) {
                for (; ; ) {
                  var t = Kp(r) ? r.regularType : e.getObjectFlags(r) & 4 && r.node ? Yf(r.target, xo(r)) : r.flags & 3145728 ? bu(r) : r.flags & 33554432 ? i ? r.baseType : r.substitute : r.flags & 25165824 ? Zf(r, i) : r;
                  if (t = GD(t) || t, t === r) break;
                  r = t;
                }
                return r;
              }
              function hl(r, i, t, o, s, u, h) {
                var z2, me, Me, $e, tr, dr = 0, Dr = 0, Qr = 0, li = 0, Ti = false, Ci = 0, $i, Zi, qt = false;
                e.Debug.assert(t !== wa || !o, "no error reporting in identity checking");
                var Nt = oa(r, i, 3, !!o, s);
                if (Zi && it(), Ti) {
                  e.tracing === null || e.tracing === void 0 || e.tracing.instant("checkTypes", "checkTypeRelatedTo_DepthLimit", { sourceId: r.id, targetId: i.id, depth: Dr, targetDepth: Qr });
                  var Ra = Xr(o || Ie, e.Diagnostics.Excessive_stack_depth_comparing_types_0_and_1, Ot(r), Ot(i));
                  h && (h.errors || (h.errors = [])).push(Ra);
                } else if (z2) {
                  if (u) {
                    var ca = u();
                    ca && (e.concatenateDiagnosticMessageChains(ca, z2), z2 = ca);
                  }
                  var Sn = void 0;
                  if (s && o && !Nt && r.symbol) {
                    var ja = Aa(r.symbol);
                    if (ja.originatingImport && !e.isImportCall(ja.originatingImport)) {
                      var Fn = hl(Jt(ja.target), i, t, void 0);
                      if (Fn) {
                        var wn = e.createDiagnosticForNode(ja.originatingImport, e.Diagnostics.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead);
                        Sn = e.append(Sn, wn);
                      }
                    }
                  }
                  var Ra = e.createDiagnosticForNodeFromMessageChain(o, z2, Sn);
                  me && e.addRelatedInfo.apply(void 0, Ve([Ra], me, false)), h && (h.errors || (h.errors = [])).push(Ra), (!h || !h.skipLogging) && rn.add(Ra);
                }
                return o && h && h.skipLogging && Nt === 0 && e.Debug.assert(!!h.errors, "missed opportunity to interact with error."), Nt !== 0;
                function Tn($r) {
                  z2 = $r.errorInfo, $i = $r.lastSkippedInfo, Zi = $r.incompatibleStack, Ci = $r.overrideNextErrorInfo, me = $r.relatedInfo;
                }
                function Eo() {
                  return { errorInfo: z2, lastSkippedInfo: $i, incompatibleStack: Zi == null ? void 0 : Zi.slice(), overrideNextErrorInfo: Ci, relatedInfo: me == null ? void 0 : me.slice() };
                }
                function lt($r, hi, Ri, mt, ft) {
                  Ci++, $i = void 0, (Zi || (Zi = [])).push([$r, hi, Ri, mt, ft]);
                }
                function it() {
                  var $r = Zi || [];
                  Zi = void 0;
                  var hi = $i;
                  if ($i = void 0, $r.length === 1) {
                    Yt.apply(void 0, $r[0]), hi && Qt.apply(void 0, Ve([void 0], hi, false));
                    return;
                  }
                  for (var Ri = "", mt = []; $r.length; ) {
                    var ft = $r.pop(), Ht = ft[0], vt = ft.slice(1);
                    switch (Ht.code) {
                      case e.Diagnostics.Types_of_property_0_are_incompatible.code: {
                        Ri.indexOf("new ") === 0 && (Ri = "(".concat(Ri, ")"));
                        var ht = "" + vt[0];
                        Ri.length === 0 ? Ri = "".concat(ht) : e.isIdentifierText(ht, e.getEmitScriptTarget(ye)) ? Ri = "".concat(Ri, ".").concat(ht) : ht[0] === "[" && ht[ht.length - 1] === "]" ? Ri = "".concat(Ri).concat(ht) : Ri = "".concat(Ri, "[").concat(ht, "]");
                        break;
                      }
                      case e.Diagnostics.Call_signature_return_types_0_and_1_are_incompatible.code:
                      case e.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible.code:
                      case e.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code:
                      case e.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code: {
                        if (Ri.length === 0) {
                          var ma = Ht;
                          Ht.code === e.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code ? ma = e.Diagnostics.Call_signature_return_types_0_and_1_are_incompatible : Ht.code === e.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code && (ma = e.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible), mt.unshift([ma, vt[0], vt[1]]);
                        } else {
                          var Ca = Ht.code === e.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible.code || Ht.code === e.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code ? "new " : "", An = Ht.code === e.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code || Ht.code === e.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code ? "" : "...";
                          Ri = "".concat(Ca).concat(Ri, "(").concat(An, ")");
                        }
                        break;
                      }
                      case e.Diagnostics.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target.code: {
                        mt.unshift([e.Diagnostics.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target, vt[0], vt[1]]);
                        break;
                      }
                      case e.Diagnostics.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target.code: {
                        mt.unshift([e.Diagnostics.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target, vt[0], vt[1], vt[2]]);
                        break;
                      }
                      default:
                        return e.Debug.fail("Unhandled Diagnostic: ".concat(Ht.code));
                    }
                  }
                  Ri ? Yt(Ri[Ri.length - 1] === ")" ? e.Diagnostics.The_types_returned_by_0_are_incompatible_between_these_types : e.Diagnostics.The_types_of_0_are_incompatible_between_these_types, Ri) : mt.shift();
                  for (var gn = 0, Vn = mt; gn < Vn.length; gn++) {
                    var zo = Vn[gn], Ht = zo[0], vt = zo.slice(1), us = Ht.elidedInCompatabilityPyramid;
                    Ht.elidedInCompatabilityPyramid = false, Yt.apply(void 0, Ve([Ht], vt, false)), Ht.elidedInCompatabilityPyramid = us;
                  }
                  hi && Qt.apply(void 0, Ve([void 0], hi, false));
                }
                function Yt($r, hi, Ri, mt, ft) {
                  e.Debug.assert(!!o), Zi && it(), !$r.elidedInCompatabilityPyramid && (z2 = e.chainDiagnosticMessages(z2, $r, hi, Ri, mt, ft));
                }
                function Ia($r) {
                  e.Debug.assert(!!z2), me ? me.push($r) : me = [$r];
                }
                function Qt($r, hi, Ri) {
                  Zi && it();
                  var mt = nf(hi, Ri), ft = mt[0], Ht = mt[1], vt = hi, ht = ft;
                  if (Cg(hi) && !JD(Ri) && (vt = Kl(hi), e.Debug.assert(!ao(vt, Ri), "generalized source shouldn't be assignable"), ht = q_(vt)), Ri.flags & 262144 && Ri !== Rn && Ri !== Da) {
                    var ma = uc(Ri), Ca = void 0;
                    ma && (ao(vt, ma) || (Ca = ao(hi, ma))) ? Yt(e.Diagnostics._0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2, Ca ? ft : ht, Ht, Ot(ma)) : (z2 = void 0, Yt(e.Diagnostics._0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1, Ht, ht));
                  }
                  if ($r) $r === e.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1 && yr && DE(hi, Ri).length && ($r = e.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties);
                  else if (t === la) $r = e.Diagnostics.Type_0_is_not_comparable_to_type_1;
                  else if (ft === Ht) $r = e.Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated;
                  else if (yr && DE(hi, Ri).length) $r = e.Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties;
                  else {
                    if (hi.flags & 128 && Ri.flags & 1048576) {
                      var An = t7(hi, Ri);
                      if (An) {
                        Yt(e.Diagnostics.Type_0_is_not_assignable_to_type_1_Did_you_mean_2, ht, Ht, Ot(An));
                        return;
                      }
                    }
                    $r = e.Diagnostics.Type_0_is_not_assignable_to_type_1;
                  }
                  Yt($r, ht, Ht);
                }
                function Ka($r, hi) {
                  var Ri = Kf($r.symbol) ? Ot($r, $r.symbol.valueDeclaration) : Ot($r), mt = Kf(hi.symbol) ? Ot(hi, hi.symbol.valueDeclaration) : Ot(hi);
                  (Ct === $r && Li === hi || sa === $r && nt === hi || en === $r && Ii === hi || Cx() === $r && Ki === hi) && Yt(e.Diagnostics._0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible, mt, Ri);
                }
                function cn($r, hi, Ri) {
                  return Yn($r) ? $r.target.readonly && Bh(hi) ? (Ri && Yt(e.Diagnostics.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1, Ot($r), Ot(hi)), false) : Pd(hi) : um($r) && Bh(hi) ? (Ri && Yt(e.Diagnostics.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1, Ot($r), Ot(hi)), false) : Yn(hi) ? Tu($r) : true;
                }
                function Un($r, hi, Ri) {
                  return oa($r, hi, 3, Ri);
                }
                function oa($r, hi, Ri, mt, ft, Ht) {
                  if (Ri === void 0 && (Ri = 3), mt === void 0 && (mt = false), Ht === void 0 && (Ht = 0), $r.flags & 524288 && hi.flags & 131068) return uy($r, hi, t, mt ? Yt : void 0) ? -1 : (mt && Mn($r, hi, $r, hi, ft), 0);
                  var vt = BD($r, false), ht = BD(hi, true);
                  if (vt === ht) return -1;
                  if (t === wa) return vt.flags !== ht.flags ? 0 : vt.flags & 67358815 ? -1 : (Ln(vt, ht), _t(vt, ht, false, 0, Ri));
                  if (vt.flags & 262144 && Q_(vt) === ht) return -1;
                  if (vt.flags & 470302716 && ht.flags & 1048576) {
                    var ma = ht.types, Ca = ma.length === 2 && ma[0].flags & 98304 ? ma[1] : ma.length === 3 && ma[0].flags & 98304 && ma[1].flags & 98304 ? ma[2] : void 0;
                    if (Ca && !(Ca.flags & 98304) && (ht = BD(Ca, true), vt === ht)) return -1;
                  }
                  if (t === la && !(ht.flags & 131072) && uy(ht, vt, t) || uy(vt, ht, t, mt ? Yt : void 0)) return -1;
                  if (vt.flags & 469499904 || ht.flags & 469499904) {
                    var An = !(Ht & 2) && Qp(vt) && e.getObjectFlags(vt) & 8192;
                    if (An && Fr(vt, ht, mt)) return mt && Qt(ft, vt, hi.aliasSymbol ? hi : ht), 0;
                    var gn = t !== la && !(Ht & 2) && vt.flags & 2752508 && vt !== qe && ht.flags & 2621440 && SE(ht) && (uo(vt).length > 0 || RS(vt)), Vn = !!(e.getObjectFlags(vt) & 2048);
                    if (gn && !fw(vt, ht, Vn)) {
                      if (mt) {
                        var zo = Ot($r.aliasSymbol ? $r : vt), us = Ot(hi.aliasSymbol ? hi : ht), Bo = ot(vt, 0), Io = ot(vt, 1);
                        Bo.length > 0 && oa(yo(Bo[0]), ht, 1, false) || Io.length > 0 && oa(yo(Io[0]), ht, 1, false) ? Yt(e.Diagnostics.Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it, zo, us) : Yt(e.Diagnostics.Type_0_has_no_properties_in_common_with_type_1, zo, us);
                      }
                      return 0;
                    }
                    Ln(vt, ht);
                    var Qo = vt.flags & 1048576 && vt.types.length < 4 && !(ht.flags & 1048576) || ht.flags & 1048576 && ht.types.length < 4 && !(vt.flags & 469499904), ls = Qo ? Lt(vt, ht, mt, Ht) : _t(vt, ht, mt, Ht, Ri);
                    if (ls && !qt && (ht.flags & 2097152 && (An || gn) || bD(ht) && !Pd(ht) && vt.flags & 2097152 && $s(vt).flags & 3670016 && !e.some(vt.types, function(gi) {
                      return !!(e.getObjectFlags(gi) & 262144);
                    })) && (qt = true, ls &= _t(vt, ht, mt, 4, Ri), qt = false), ls) return ls;
                  }
                  return mt && Mn($r, hi, vt, ht, ft), 0;
                }
                function Mn($r, hi, Ri, mt, ft) {
                  var Ht = !!GD($r), vt = !!GD(hi);
                  Ri = $r.aliasSymbol || Ht ? $r : Ri, mt = hi.aliasSymbol || vt ? hi : mt;
                  var ht = Ci > 0;
                  if (ht && Ci--, Ri.flags & 524288 && mt.flags & 524288) {
                    var ma = z2;
                    cn(Ri, mt, true), z2 !== ma && (ht = !!z2);
                  }
                  if (Ri.flags & 524288 && mt.flags & 131068) Ka(Ri, mt);
                  else if (Ri.symbol && Ri.flags & 524288 && qe === Ri) Yt(e.Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);
                  else if (e.getObjectFlags(Ri) & 2048 && mt.flags & 2097152) {
                    var Ca = mt.types, An = Zp(U.IntrinsicAttributes, o), gn = Zp(U.IntrinsicClassAttributes, o);
                    if (!nn(An) && !nn(gn) && (e.contains(Ca, An) || e.contains(Ca, gn))) return;
                  } else z2 = ei(z2, hi);
                  if (!ft && ht) {
                    $i = [Ri, mt];
                    return;
                  }
                  Qt(ft, Ri, mt);
                }
                function Ln($r, hi) {
                  if (!!e.tracing && $r.flags & 3145728 && hi.flags & 3145728) {
                    var Ri = $r, mt = hi;
                    if (Ri.objectFlags & mt.objectFlags & 32768) return;
                    var ft = Ri.types.length, Ht = mt.types.length;
                    ft * Ht > 1e6 && e.tracing.instant("checkTypes", "traceUnionsOrIntersectionsTooLarge_DepthLimit", { sourceId: $r.id, sourceSize: ft, targetId: hi.id, targetSize: Ht, pos: o == null ? void 0 : o.pos, end: o == null ? void 0 : o.end });
                  }
                }
                function ci($r, hi) {
                  var Ri = function(mt, ft) {
                    var Ht;
                    ft = $s(ft);
                    var vt = ft.flags & 3145728 ? Zv(ft, hi) : h_(ft, hi), ht = vt && Jt(vt) || ((Ht = Xo(ft, hi)) === null || Ht === void 0 ? void 0 : Ht.type) || Tr;
                    return e.append(mt, ht);
                  };
                  return Pa(e.reduceLeft($r, Ri, void 0) || e.emptyArray);
                }
                function Fr($r, hi, Ri) {
                  var mt;
                  if (!Sy(hi) || !n && e.getObjectFlags(hi) & 4096) return false;
                  var ft = !!(e.getObjectFlags($r) & 2048);
                  if ((t === dt || t === la) && (dy(qe, hi) || !ft && Of(hi))) return false;
                  var Ht = hi, vt;
                  hi.flags & 1048576 && (Ht = bA($r, hi, oa) || IL(hi), vt = Ht.flags & 1048576 ? Ht.types : [Ht]);
                  for (var ht = function(Vn) {
                    if (jt(Vn, $r.symbol) && !hE($r, Vn)) {
                      if (!Rb(Ht, Vn.escapedName, ft)) {
                        if (Ri) {
                          var zo = ec(Ht, Sy);
                          if (!o) return { value: e.Debug.fail() };
                          if (e.isJsxAttributes(o) || e.isJsxOpeningLikeElement(o) || e.isJsxOpeningLikeElement(o.parent)) {
                            Vn.valueDeclaration && e.isJsxAttribute(Vn.valueDeclaration) && e.getSourceFileOfNode(o) === e.getSourceFileOfNode(Vn.valueDeclaration.name) && (o = Vn.valueDeclaration.name);
                            var us = tn(Vn), Bo = ek(us, zo), Io = Bo ? tn(Bo) : void 0;
                            Io ? Yt(e.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2, us, Ot(zo), Io) : Yt(e.Diagnostics.Property_0_does_not_exist_on_type_1, us, Ot(zo));
                          } else {
                            var Qo = ((mt = $r.symbol) === null || mt === void 0 ? void 0 : mt.declarations) && e.firstOrUndefined($r.symbol.declarations), Io = void 0;
                            if (Vn.valueDeclaration && e.findAncestor(Vn.valueDeclaration, function(La) {
                              return La === Qo;
                            }) && e.getSourceFileOfNode(Qo) === e.getSourceFileOfNode(o)) {
                              var ls = Vn.valueDeclaration;
                              e.Debug.assertNode(ls, e.isObjectLiteralElementLike), o = ls;
                              var gi = ls.name;
                              e.isIdentifier(gi) && (Io = Vb(gi, zo));
                            }
                            Io !== void 0 ? Yt(e.Diagnostics.Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2, tn(Vn), Ot(zo), Io) : Yt(e.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1, tn(Vn), Ot(zo));
                          }
                        }
                        return { value: true };
                      }
                      if (vt && !oa(Jt(Vn), ci(vt, Vn.escapedName), 3, Ri)) return Ri && lt(e.Diagnostics.Types_of_property_0_are_incompatible, tn(Vn)), { value: true };
                    }
                  }, ma = 0, Ca = uo($r); ma < Ca.length; ma++) {
                    var An = Ca[ma], gn = ht(An);
                    if (typeof gn == "object") return gn.value;
                  }
                  return false;
                }
                function jt($r, hi) {
                  return $r.valueDeclaration && hi.valueDeclaration && $r.valueDeclaration.parent === hi.valueDeclaration;
                }
                function Lt($r, hi, Ri, mt) {
                  if ($r.flags & 1048576) return t === la ? Ua($r, hi, Ri && !($r.flags & 131068), mt) : Ni($r, hi, Ri && !($r.flags & 131068), mt);
                  if (hi.flags & 1048576) return Kt(fm($r), hi, Ri && !($r.flags & 131068) && !(hi.flags & 131068));
                  if (hi.flags & 2097152) return $t(fm($r), hi, Ri, 2);
                  if (t === la && hi.flags & 131068) {
                    var ft = e.sameMap($r.types, Hd);
                    if (ft !== $r.types && ($r = Do(ft), !($r.flags & 2097152))) return oa($r, hi, 1, false);
                  }
                  return Ua($r, hi, false, 1);
                }
                function ea($r, hi) {
                  for (var Ri = -1, mt = $r.types, ft = 0, Ht = mt; ft < Ht.length; ft++) {
                    var vt = Ht[ft], ht = Kt(vt, hi, false);
                    if (!ht) return 0;
                    Ri &= ht;
                  }
                  return Ri;
                }
                function Kt($r, hi, Ri) {
                  var mt = hi.types;
                  if (hi.flags & 1048576) {
                    if ($f(mt, $r)) return -1;
                    var ft = $E(hi, $r);
                    if (ft) {
                      var Ht = oa($r, ft, 2, false);
                      if (Ht) return Ht;
                    }
                  }
                  for (var vt = 0, ht = mt; vt < ht.length; vt++) {
                    var ma = ht[vt], Ht = oa($r, ma, 2, false);
                    if (Ht) return Ht;
                  }
                  if (Ri) {
                    var Ca = bE($r, hi, oa);
                    Ca && oa($r, Ca, 2, true);
                  }
                  return 0;
                }
                function $t($r, hi, Ri, mt) {
                  for (var ft = -1, Ht = hi.types, vt = 0, ht = Ht; vt < ht.length; vt++) {
                    var ma = ht[vt], Ca = oa($r, ma, 2, Ri, void 0, mt);
                    if (!Ca) return 0;
                    ft &= Ca;
                  }
                  return ft;
                }
                function Ua($r, hi, Ri, mt) {
                  var ft = $r.types;
                  if ($r.flags & 1048576 && $f(ft, hi)) return -1;
                  for (var Ht = ft.length, vt = 0; vt < Ht; vt++) {
                    var ht = oa(ft[vt], hi, 1, Ri && vt === Ht - 1, void 0, mt);
                    if (ht) return ht;
                  }
                  return 0;
                }
                function Yr($r, hi) {
                  return $r.flags & 1048576 && hi.flags & 1048576 && !($r.types[0].flags & 32768) && hi.types[0].flags & 32768 ? Ng(hi, -32769) : hi;
                }
                function Ni($r, hi, Ri, mt) {
                  for (var ft = -1, Ht = $r.types, vt = Yr($r, hi), ht = 0; ht < Ht.length; ht++) {
                    var ma = Ht[ht];
                    if (vt.flags & 1048576 && Ht.length >= vt.types.length && Ht.length % vt.types.length === 0) {
                      var Ca = oa(ma, vt.types[ht % vt.types.length], 3, false, void 0, mt);
                      if (Ca) {
                        ft &= Ca;
                        continue;
                      }
                    }
                    var An = oa(ma, hi, 1, Ri, void 0, mt);
                    if (!An) return 0;
                    ft &= An;
                  }
                  return ft;
                }
                function Hi($r, hi, Ri, mt, ft) {
                  if ($r === void 0 && ($r = e.emptyArray), hi === void 0 && (hi = e.emptyArray), Ri === void 0 && (Ri = e.emptyArray), $r.length !== hi.length && t === wa) return 0;
                  for (var Ht = $r.length <= hi.length ? $r.length : hi.length, vt = -1, ht = 0; ht < Ht; ht++) {
                    var ma = ht < Ri.length ? Ri[ht] : 1, Ca = ma & 7;
                    if (Ca !== 4) {
                      var An = $r[ht], gn = hi[ht], Vn = -1;
                      if (ma & 8 ? Vn = t === wa ? oa(An, gn, 3, false) : av(An, gn) : Ca === 1 ? Vn = oa(An, gn, 3, mt, void 0, ft) : Ca === 2 ? Vn = oa(gn, An, 3, mt, void 0, ft) : Ca === 3 ? (Vn = oa(gn, An, 3, false), Vn || (Vn = oa(An, gn, 3, mt, void 0, ft))) : (Vn = oa(An, gn, 3, mt, void 0, ft), Vn && (Vn &= oa(gn, An, 3, mt, void 0, ft))), !Vn) return 0;
                      vt &= Vn;
                    }
                  }
                  return vt;
                }
                function _t($r, hi, Ri, mt, ft) {
                  if (Ti) return 0;
                  var Ht = mt | (qt ? 8 : 0), vt = qD($r, hi, Ht, t, false), ht = t.get(vt);
                  if (ht !== void 0 && !(Ri && ht & 2 && !(ht & 4))) {
                    if (hr) {
                      var ma = ht & 24;
                      ma & 8 && un($r, Gp(Vt)), ma & 16 && un($r, Gp(Fa));
                    }
                    return ht & 1 ? -1 : 0;
                  }
                  if (!Me) Me = [], $e = [], tr = [];
                  else {
                    for (var Ca = vt.startsWith("*") ? qD($r, hi, Ht, t, true) : void 0, An = 0; An < dr; An++) if (vt === Me[An] || Ca && Ca === Me[An]) return 3;
                    if (Dr === 100 || Qr === 100) return Ti = true, 0;
                  }
                  var gn = dr;
                  Me[dr] = vt, dr++;
                  var Vn = li;
                  ft & 1 && ($e[Dr] = $r, Dr++, !(li & 1) && Rh($r, $e, Dr) && (li |= 1)), ft & 2 && (tr[Qr] = hi, Qr++, !(li & 2) && Rh(hi, tr, Qr) && (li |= 2));
                  var zo, us = 0;
                  hr && (zo = hr, hr = function(Io) {
                    return us |= Io ? 16 : 8, zo(Io);
                  });
                  var Bo;
                  if (li === 3 ? (e.tracing === null || e.tracing === void 0 || e.tracing.instant("checkTypes", "recursiveTypeRelatedTo_DepthLimit", { sourceId: $r.id, sourceIdStack: $e.map(function(Io) {
                    return Io.id;
                  }), targetId: hi.id, targetIdStack: tr.map(function(Io) {
                    return Io.id;
                  }), depth: Dr, targetDepth: Qr }), Bo = 3) : (e.tracing === null || e.tracing === void 0 || e.tracing.push("checkTypes", "structuredTypeRelatedTo", { sourceId: $r.id, targetId: hi.id }), Bo = gt($r, hi, Ri, mt), e.tracing === null || e.tracing === void 0 || e.tracing.pop()), hr && (hr = zo), ft & 1 && Dr--, ft & 2 && Qr--, li = Vn, Bo) {
                    if (Bo === -1 || Dr === 0 && Qr === 0) {
                      if (Bo === -1 || Bo === 3) for (var An = gn; An < dr; An++) t.set(Me[An], 1 | us);
                      dr = gn;
                    }
                  } else t.set(vt, (Ri ? 4 : 0) | 2 | us), dr = gn;
                  return Bo;
                }
                function gt($r, hi, Ri, mt) {
                  if (mt & 4) return Uo($r, hi, Ri, void 0, 0);
                  var ft, Ht, vt = false, ht = Eo(), ma = $r.flags, Ca = hi.flags;
                  if (t === wa) {
                    if (ma & 3145728) {
                      var An = ea($r, hi);
                      return An && (An &= ea(hi, $r)), An;
                    }
                    if (ma & 4194304) return oa($r.type, hi.type, 3, false);
                    if (ma & 8388608 && (ft = oa($r.objectType, hi.objectType, 3, false)) && (ft &= oa($r.indexType, hi.indexType, 3, false)) || ma & 16777216 && $r.root.isDistributive === hi.root.isDistributive && (ft = oa($r.checkType, hi.checkType, 3, false)) && (ft &= oa($r.extendsType, hi.extendsType, 3, false)) && (ft &= oa(ip($r), ip(hi), 3, false)) && (ft &= oa(tp($r), tp(hi), 3, false))) return ft;
                    if (ma & 33554432) return oa($r.substitute, hi.substitute, 3, false);
                    if (!(ma & 524288)) return 0;
                  } else if (ma & 3145728 || Ca & 3145728) {
                    if (ft = Lt($r, hi, Ri, mt)) return ft;
                    if ($r.flags & 2097152 || $r.flags & 262144 && hi.flags & 1048576) {
                      var gn = G1($r.flags & 2097152 ? $r.types : [$r], !!(hi.flags & 1048576));
                      if (gn && gf(gn, function(Pv) {
                        return Pv !== $r;
                      }) && (ft = oa(gn, hi, 1, false, void 0, mt))) return Tn(ht), ft;
                    }
                    if (!(ma & 465829888 || ma & 524288 && Ca & 1048576 || ma & 2097152 && Ca & 467402752)) return 0;
                  }
                  if (ma & 17301504 && $r.aliasSymbol && $r.aliasTypeArguments && $r.aliasSymbol === hi.aliasSymbol && !(Fh($r) || Fh(hi))) {
                    var Vn = TE($r.aliasSymbol);
                    if (Vn === e.emptyArray) return 1;
                    var zo = xA($r.aliasTypeArguments, hi.aliasTypeArguments, Vn, mt);
                    if (zo !== void 0) return zo;
                  }
                  if (IE($r) && !$r.target.readonly && (ft = oa(xo($r)[0], hi, 1)) || IE(hi) && (hi.target.readonly || Bh(uc($r) || $r)) && (ft = oa($r, xo(hi)[0], 2))) return ft;
                  if (Ca & 262144) {
                    if (e.getObjectFlags($r) & 32 && !$r.declaration.nameType && oa(ql(hi), Mu($r), 3) && !(Lu($r) & 4)) {
                      var us = vl($r), Bo = Jc(hi, Du($r));
                      if (ft = oa(us, Bo, 3, Ri)) return ft;
                    }
                  } else if (Ca & 4194304) {
                    var Io = hi.type;
                    if (ma & 4194304 && (ft = oa(Io, $r.type, 3, false))) return ft;
                    if (Yn(Io)) {
                      if (ft = oa($r, Mx(Io), 2, Ri)) return ft;
                    } else {
                      var gn = Vv(Io);
                      if (gn) {
                        if (oa($r, ql(gn, hi.stringsOnly), 2, Ri) === -1) return -1;
                      } else if (Bc(Io)) {
                        var Qo = Jl(Io), ls = Mu(Io), gi = void 0;
                        if (Qo && mg(Io)) {
                          var zt = $s(Ed(Io)), La = [];
                          Um(zt, 8576, false, function(Cm) {
                            return void La.push(un(Qo, tv(Io.mapper, Du(Io), Cm)));
                          }), gi = Pa(Ve(Ve([], La, true), [Qo], false));
                        } else gi = Qo || ls;
                        if (oa($r, gi, 2, Ri) === -1) return -1;
                      }
                    }
                  } else if (Ca & 8388608) {
                    if (ma & 8388608) {
                      if ((ft = oa($r.objectType, hi.objectType, 3, Ri)) && (ft &= oa($r.indexType, hi.indexType, 3, Ri)), ft) return Tn(ht), ft;
                      Ri && (Ht = z2);
                    }
                    if (t === dt || t === la) {
                      var fa = hi.objectType, ya = hi.indexType, Nn = uc(fa) || fa, fn = uc(ya) || ya;
                      if (!Ad(Nn) && !qp(fn)) {
                        var hn = 4 | (Nn !== fa ? 2 : 0), gn = ep(Nn, fn, hn);
                        if (gn) {
                          if (Ri && Ht && Tn(ht), ft = oa($r, gn, 2, Ri)) return ft;
                          Ri && Ht && z2 && (z2 = GS([Ht]) <= GS([z2]) ? Ht : z2);
                        }
                      }
                    }
                    Ri && (Ht = void 0);
                  } else if (Bc(hi) && t !== wa) {
                    var sn = !!hi.declaration.nameType, us = vl(hi), ln = Lu(hi);
                    if (!(ln & 8)) {
                      if (!sn && us.flags & 8388608 && us.objectType === $r && us.indexType === Du(hi)) return -1;
                      if (!Bc($r)) {
                        var gi = sn ? Jl(hi) : Mu(hi), lo = ql($r, void 0, true), _o = ln & 4, _s = _o ? Zg(gi, lo) : void 0;
                        if (_o ? !(_s.flags & 131072) : oa(gi, lo, 3)) {
                          var Vo = vl(hi), Yo = Du(hi), Cs = Ng(Vo, -98305);
                          if (!sn && Cs.flags & 8388608 && Cs.indexType === Yo) {
                            if (ft = oa($r, Cs.objectType, 2, Ri)) return ft;
                          } else {
                            var ic = sn ? _s || gi : _s ? Do([_s, Yo]) : Yo, Bo = Jc($r, ic);
                            if (ft = oa(Bo, Vo, 3, Ri)) return ft;
                          }
                        }
                        Ht = z2, Tn(ht);
                      }
                    }
                  } else if (Ca & 16777216) {
                    if (Rh(hi, tr, Qr, 10)) return Tn(ht), 3;
                    var _c = hi;
                    if (!_c.root.inferTypeParameters && !xI(_c.root)) {
                      var il = !ao(wh(_c.checkType), wh(_c.extendsType)), n_ = !il && ao(Nd(_c.checkType), Nd(_c.extendsType));
                      if ((ft = il ? -1 : oa($r, ip(_c), 2, false)) && (ft &= n_ ? -1 : oa($r, tp(_c), 2, false), ft)) return Tn(ht), ft;
                    }
                  } else if (Ca & 134217728) {
                    if (ma & 134217728) {
                      if (t === la) return Gw($r, hi) ? 0 : -1;
                      un($r, Gp(Fa));
                    }
                    if (VE($r, hi)) return -1;
                  }
                  if (ma & 8650752) {
                    if (!(ma & 8388608 && Ca & 8388608)) {
                      var gn = Q_($r);
                      if (!gn || ma & 262144 && gn.flags & 1) {
                        if (ft = oa(Ba, Ng(hi, -67108865), 3)) return Tn(ht), ft;
                      } else {
                        if (ft = oa(gn, hi, 1, false, void 0, mt)) return Tn(ht), ft;
                        if (ft = oa(Rc(gn, $r), hi, 1, Ri && !(Ca & ma & 262144), void 0, mt)) return Tn(ht), ft;
                      }
                      if (Qv($r)) {
                        var o_ = Q_($r.indexType);
                        if (o_ && (ft = oa(Jc($r.objectType, o_), hi, 1, Ri))) return Tn(ht), ft;
                      }
                    }
                  } else if (ma & 4194304) {
                    if (ft = oa(at, hi, 1, Ri)) return Tn(ht), ft;
                  } else if (ma & 134217728 && !(Ca & 524288)) {
                    if (!(Ca & 134217728)) {
                      var gn = uc($r);
                      if (gn && gn !== $r && (ft = oa(gn, hi, 1, Ri))) return Tn(ht), ft;
                    }
                  } else if (ma & 268435456) if (Ca & 268435456 && $r.symbol === hi.symbol) {
                    if (ft = oa($r.type, hi.type, 3, Ri)) return Tn(ht), ft;
                  } else {
                    var gn = uc($r);
                    if (gn && (ft = oa(gn, hi, 1, Ri))) return Tn(ht), ft;
                  }
                  else if (ma & 16777216) {
                    if (Rh($r, $e, Dr, 10)) return Tn(ht), 3;
                    if (Ca & 16777216) {
                      var og = $r.root.inferTypeParameters, _p = $r.extendsType, td = void 0;
                      if (og) {
                        var s_ = uv(og, void 0, 0, Un);
                        df(s_.inferences, hi.extendsType, _p, 1536), _p = un(_p, s_.mapper), td = s_.mapper;
                      }
                      if (wf(_p, hi.extendsType) && (oa($r.checkType, hi.checkType, 3) || oa(hi.checkType, $r.checkType, 3)) && ((ft = oa(un(ip($r), td), ip(hi), 3, Ri)) && (ft &= oa(tp($r), tp(hi), 3, Ri)), ft)) return Tn(ht), ft;
                    } else {
                      var sg = Wm($r) ? Kv($r) : void 0;
                      if (sg && (ft = oa(sg, hi, 1, Ri))) return Tn(ht), ft;
                    }
                    var Nc = zm($r);
                    if (Nc && (ft = oa(Nc, hi, 1, Ri))) return Tn(ht), ft;
                  } else {
                    if (t !== Or && t !== ki && j1(hi) && Of($r)) return -1;
                    if (Bc(hi)) return Bc($r) && (ft = on($r, hi, Ri)) ? (Tn(ht), ft) : 0;
                    var pp = !!(ma & 131068);
                    if (t !== wa) $r = $s($r), ma = $r.flags;
                    else if (Bc($r)) return 0;
                    if (e.getObjectFlags($r) & 4 && e.getObjectFlags(hi) & 4 && $r.target === hi.target && !Yn($r) && !(Fh($r) || Fh(hi))) {
                      if (Jh($r)) return -1;
                      var Vn = zD($r.target);
                      if (Vn === e.emptyArray) return 1;
                      var zo = xA(xo($r), xo(hi), Vn, mt);
                      if (zo !== void 0) return zo;
                    } else {
                      if (um(hi) ? Pd($r) : Tu(hi) && Yn($r) && !$r.target.readonly) return t !== wa ? oa(cs($r, nt) || Oe, cs(hi, nt) || Oe, 3, Ri) : 0;
                      if ((t === Or || t === ki) && Of(hi) && e.getObjectFlags(hi) & 8192 && !Of($r)) return 0;
                    }
                    if (ma & 2621440 && Ca & 524288) {
                      var Y0 = Ri && z2 === ht.errorInfo && !pp;
                      if (ft = Uo($r, hi, Y0, void 0, mt), ft && (ft &= Fs($r, hi, 0, Y0), ft && (ft &= Fs($r, hi, 1, Y0), ft && (ft &= fp($r, hi, pp, Y0, mt)))), vt && ft) z2 = Ht || z2 || ht.errorInfo;
                      else if (ft) return ft;
                    }
                    if (ma & 2621440 && Ca & 1048576) {
                      var SA = Ng(hi, 36175872);
                      if (SA.flags & 1048576) {
                        var TA = zn($r, SA);
                        if (TA) return TA;
                      }
                    }
                  }
                  return 0;
                  function GS(Pv) {
                    return Pv ? e.reduceLeft(Pv, function(Cm, km) {
                      return Cm + 1 + GS(km.next);
                    }, 0) : 0;
                  }
                  function xA(Pv, Cm, km, wL) {
                    if (ft = Hi(Pv, Cm, km, Ri, wL)) return ft;
                    if (e.some(km, function(HS) {
                      return !!(HS & 24);
                    })) {
                      Ht = void 0, Tn(ht);
                      return;
                    }
                    var EA = Cm && _w(Cm, km);
                    if (vt = !EA, km !== e.emptyArray && !EA) {
                      if (vt && !(Ri && e.some(km, function(HS) {
                        return (HS & 7) === 0;
                      }))) return 0;
                      Ht = z2, Tn(ht);
                    }
                  }
                }
                function Vt($r) {
                  return hr && ($r === Rn || $r === Da || $r === bo) && hr(false), $r;
                }
                function Fa($r) {
                  return hr && ($r === Rn || $r === Da || $r === bo) && hr(true), $r;
                }
                function on($r, hi, Ri) {
                  var mt = t === la || (t === wa ? Lu($r) === Lu(hi) : qv($r) <= qv(hi));
                  if (mt) {
                    var ft, Ht = Mu(hi), vt = un(Mu($r), Gp(qv($r) < 0 ? Vt : Fa));
                    if (ft = oa(Ht, vt, 3, Ri)) {
                      var ht = Uc([Du($r)], [Du(hi)]);
                      if (un(Jl($r), ht) === un(Jl(hi), ht)) return ft & oa(un(vl($r), ht), vl(hi), 3, Ri);
                    }
                  }
                  return 0;
                }
                function zn($r, hi) {
                  var Ri = uo($r), mt = YE(Ri, hi);
                  if (!mt) return 0;
                  for (var ft = 1, Ht = 0, vt = mt; Ht < vt.length; Ht++) {
                    var ht = vt[Ht];
                    if (ft *= D8(ml(ht)), ft > 25) return e.tracing === null || e.tracing === void 0 || e.tracing.instant("checkTypes", "typeRelatedToDiscriminatedType_DepthLimit", { sourceId: $r.id, targetId: hi.id, numCombinations: ft }), 0;
                  }
                  for (var ma = new Array(mt.length), Ca = new e.Set(), An = 0; An < mt.length; An++) {
                    var ht = mt[An], gn = ml(ht);
                    ma[An] = gn.flags & 1048576 ? gn.types : [gn], Ca.add(ht.escapedName);
                  }
                  for (var Vn = e.cartesianProduct(ma), zo = [], us = function(ya) {
                    var Nn = false;
                    e: for (var fn = 0, hn = hi.types; fn < hn.length; fn++) {
                      for (var sn = hn[fn], ln = function(_s) {
                        var Vo = mt[_s], Yo = bi(sn, Vo.escapedName);
                        if (!Yo) return "continue-outer";
                        if (Vo === Yo) return "continue";
                        var Cs = wo($r, hi, Vo, Yo, function(ic) {
                          return ya[_s];
                        }, false, 0, Ye || t === la);
                        if (!Cs) return "continue-outer";
                      }, lo = 0; lo < mt.length; lo++) {
                        var _o = ln(lo);
                        switch (_o) {
                          case "continue-outer":
                            continue e;
                        }
                      }
                      e.pushIfUnique(zo, sn, e.equateValues), Nn = true;
                    }
                    if (!Nn) return { value: 0 };
                  }, Bo = 0, Io = Vn; Bo < Io.length; Bo++) {
                    var Qo = Io[Bo], ls = us(Qo);
                    if (typeof ls == "object") return ls.value;
                  }
                  for (var gi = -1, zt = 0, La = zo; zt < La.length; zt++) {
                    var fa = La[zt];
                    if (gi &= Uo($r, fa, false, Ca, 0), gi && (gi &= Fs($r, fa, 0, false), gi && (gi &= Fs($r, fa, 1, false), gi && !(Yn($r) && Yn(fa)) && (gi &= fp($r, fa, false, false, 0)))), !gi) return gi;
                  }
                  return gi;
                }
                function Ga($r, hi) {
                  if (!hi || $r.length === 0) return $r;
                  for (var Ri, mt = 0; mt < $r.length; mt++) hi.has($r[mt].escapedName) ? Ri || (Ri = $r.slice(0, mt)) : Ri && Ri.push($r[mt]);
                  return Ri || $r;
                }
                function Qn($r, hi, Ri, mt, ft) {
                  var Ht = Ye && !!(e.getCheckFlags(hi) & 48), vt = kc(ml(hi), false, Ht), ht = Ri($r);
                  return oa(ht, vt, 3, mt, void 0, ft);
                }
                function wo($r, hi, Ri, mt, ft, Ht, vt, ht) {
                  var ma = e.getDeclarationModifierFlagsFromSymbol(Ri), Ca = e.getDeclarationModifierFlagsFromSymbol(mt);
                  if (ma & 8 || Ca & 8) {
                    if (Ri.valueDeclaration !== mt.valueDeclaration) return Ht && (ma & 8 && Ca & 8 ? Yt(e.Diagnostics.Types_have_separate_declarations_of_a_private_property_0, tn(mt)) : Yt(e.Diagnostics.Property_0_is_private_in_type_1_but_not_in_type_2, tn(mt), Ot(ma & 8 ? $r : hi), Ot(ma & 8 ? hi : $r))), 0;
                  } else if (Ca & 16) {
                    if (!vw(Ri, mt)) return Ht && Yt(e.Diagnostics.Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2, tn(mt), Ot(Zd(Ri) || $r), Ot(Zd(mt) || hi)), 0;
                  } else if (ma & 16) return Ht && Yt(e.Diagnostics.Property_0_is_protected_in_type_1_but_public_in_type_2, tn(mt), Ot($r), Ot(hi)), 0;
                  if (t === ki && Zu(Ri) && !Zu(mt)) return 0;
                  var An = Qn(Ri, mt, ft, Ht, vt);
                  return An ? !ht && Ri.flags & 16777216 && !(mt.flags & 16777216) ? (Ht && Yt(e.Diagnostics.Property_0_is_optional_in_type_1_but_required_in_type_2, tn(mt), Ot($r), Ot(hi)), 0) : An : (Ht && lt(e.Diagnostics.Types_of_property_0_are_incompatible, tn(mt)), 0);
                }
                function Po($r, hi, Ri, mt) {
                  var ft = false;
                  if (Ri.valueDeclaration && e.isNamedDeclaration(Ri.valueDeclaration) && e.isPrivateIdentifier(Ri.valueDeclaration.name) && $r.symbol && $r.symbol.flags & 32) {
                    var Ht = Ri.valueDeclaration.name.escapedText, vt = e.getSymbolNameForPrivateIdentifier($r.symbol, Ht);
                    if (vt && bi($r, vt)) {
                      var ht = e.factory.getDeclarationName($r.symbol.valueDeclaration), ma = e.factory.getDeclarationName(hi.symbol.valueDeclaration);
                      Yt(e.Diagnostics.Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2, ku(Ht), ku(ht.escapedText === "" ? C : ht), ku(ma.escapedText === "" ? C : ma));
                      return;
                    }
                  }
                  var Ca = e.arrayFrom(sb($r, hi, mt, false));
                  if ((!s || s.code !== e.Diagnostics.Class_0_incorrectly_implements_interface_1.code && s.code !== e.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code) && (ft = true), Ca.length === 1) {
                    var An = tn(Ri);
                    Yt.apply(void 0, Ve([e.Diagnostics.Property_0_is_missing_in_type_1_but_required_in_type_2, An], nf($r, hi), false)), e.length(Ri.declarations) && Ia(e.createDiagnosticForNode(Ri.declarations[0], e.Diagnostics._0_is_declared_here, An)), ft && z2 && Ci++;
                  } else cn($r, hi, false) && (Ca.length > 5 ? Yt(e.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more, Ot($r), Ot(hi), e.map(Ca.slice(0, 4), function(gn) {
                    return tn(gn);
                  }).join(", "), Ca.length - 4) : Yt(e.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2, Ot($r), Ot(hi), e.map(Ca, function(gn) {
                    return tn(gn);
                  }).join(", ")), ft && z2 && Ci++);
                }
                function Uo($r, hi, Ri, mt, ft) {
                  if (t === wa) return Rs($r, hi, mt);
                  var Ht = -1;
                  if (Yn(hi)) {
                    if (Pd($r)) {
                      if (!hi.target.readonly && (um($r) || Yn($r) && $r.target.readonly)) return 0;
                      var vt = $_($r), ht = $_(hi), ma = Yn($r) ? $r.target.combinedFlags & 4 : 4, Ca = hi.target.combinedFlags & 4, An = Yn($r) ? $r.target.minLength : 0, gn = hi.target.minLength;
                      if (!ma && vt < gn) return Ri && Yt(e.Diagnostics.Source_has_0_element_s_but_target_requires_1, vt, gn), 0;
                      if (!Ca && ht < An) return Ri && Yt(e.Diagnostics.Source_has_0_element_s_but_target_allows_only_1, An, ht), 0;
                      if (!Ca && (ma || ht < vt)) return Ri && (An < gn ? Yt(e.Diagnostics.Target_requires_0_element_s_but_source_may_have_fewer, gn) : Yt(e.Diagnostics.Target_allows_only_0_element_s_but_source_may_have_more, ht)), 0;
                      for (var Vn = xo($r), zo = xo(hi), us = Math.min(Yn($r) ? Lx($r.target, 11) : 0, Lx(hi.target, 11)), Bo = Math.min(Yn($r) ? Sh($r.target, 11) : 0, Ca ? Sh(hi.target, 11) : 0), Io = !!mt, Qo = 0; Qo < ht; Qo++) {
                        var ls = Qo < ht - Bo ? Qo : Qo + vt - ht, gi = Yn($r) && (Qo < us || Qo >= ht - Bo) ? $r.target.elementFlags[ls] : 4, zt = hi.target.elementFlags[Qo];
                        if (zt & 8 && !(gi & 8)) return Ri && Yt(e.Diagnostics.Source_provides_no_match_for_variadic_element_at_position_0_in_target, Qo), 0;
                        if (gi & 8 && !(zt & 12)) return Ri && Yt(e.Diagnostics.Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target, ls, Qo), 0;
                        if (zt & 1 && !(gi & 1)) return Ri && Yt(e.Diagnostics.Source_provides_no_match_for_required_element_at_position_0_in_target, Qo), 0;
                        if (!(Io && ((gi & 12 || zt & 12) && (Io = false), Io && (mt == null ? void 0 : mt.has("" + Qo))))) {
                          var La = Yn($r) ? Qo < us || Qo >= ht - Bo ? kg(Vn[ls], !!(gi & zt & 2)) : jh($r, us, Bo) || ui : Vn[0], fa = zo[Qo], ya = gi & 8 && zt & 4 ? Zs(fa) : kg(fa, !!(zt & 2)), Nn = oa(La, ya, 3, Ri, void 0, ft);
                          if (!Nn) return Ri && (ht > 1 || vt > 1) && (Qo < us || Qo >= ht - Bo || vt - us - Bo === 1 ? lt(e.Diagnostics.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target, ls, Qo) : lt(e.Diagnostics.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target, us, vt - Bo - 1, Qo)), 0;
                          Ht &= Nn;
                        }
                      }
                      return Ht;
                    }
                    if (hi.target.combinedFlags & 12) return 0;
                  }
                  var fn = (t === Or || t === ki) && !Qp($r) && !Jh($r) && !Yn($r), hn = cb($r, hi, fn, false);
                  if (hn) return Ri && rc($r, hi) && Po($r, hi, hn, fn), 0;
                  if (Qp(hi)) for (var sn = 0, ln = Ga(uo($r), mt); sn < ln.length; sn++) {
                    var lo = ln[sn];
                    if (!h_(hi, lo.escapedName)) {
                      var La = Jt(lo);
                      if (!(La.flags & 32768)) return Ri && Yt(e.Diagnostics.Property_0_does_not_exist_on_type_1, tn(lo), Ot(hi)), 0;
                    }
                  }
                  for (var _o = uo(hi), _s = Yn($r) && Yn(hi), Vo = 0, Yo = Ga(_o, mt); Vo < Yo.length; Vo++) {
                    var Cs = Yo[Vo], ic = Cs.escapedName;
                    if (!(Cs.flags & 4194304) && (!_s || e.isNumericLiteralName(ic) || ic === "length")) {
                      var lo = bi($r, ic);
                      if (lo && lo !== Cs) {
                        var Nn = wo($r, hi, lo, Cs, ml, Ri, ft, t === la);
                        if (!Nn) return 0;
                        Ht &= Nn;
                      }
                    }
                  }
                  return Ht;
                }
                function Rs($r, hi, Ri) {
                  if (!($r.flags & 524288 && hi.flags & 524288)) return 0;
                  var mt = Ga(Pf($r), Ri), ft = Ga(Pf(hi), Ri);
                  if (mt.length !== ft.length) return 0;
                  for (var Ht = -1, vt = 0, ht = mt; vt < ht.length; vt++) {
                    var ma = ht[vt], Ca = h_(hi, ma.escapedName);
                    if (!Ca) return 0;
                    var An = VD(ma, Ca, oa);
                    if (!An) return 0;
                    Ht &= An;
                  }
                  return Ht;
                }
                function Fs($r, hi, Ri, mt) {
                  var ft, Ht;
                  if (t === wa) return jd($r, hi, Ri);
                  if (hi === xn || $r === xn) return -1;
                  var vt = $r.symbol && Sl($r.symbol.valueDeclaration), ht = hi.symbol && Sl(hi.symbol.valueDeclaration), ma = ot($r, vt && Ri === 1 ? 0 : Ri), Ca = ot(hi, ht && Ri === 1 ? 0 : Ri);
                  if (Ri === 1 && ma.length && Ca.length) {
                    var An = !!(ma[0].flags & 4), gn = !!(Ca[0].flags & 4);
                    if (An && !gn) return mt && Yt(e.Diagnostics.Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type), 0;
                    if (!za(ma[0], Ca[0], mt)) return 0;
                  }
                  var Vn = -1, zo = Ri === 1 ? Ts : xu, us = e.getObjectFlags($r), Bo = e.getObjectFlags(hi);
                  if (us & 64 && Bo & 64 && $r.symbol === hi.symbol || us & 4 && Bo & 4 && $r.target === hi.target) for (var Io = 0; Io < Ca.length; Io++) {
                    var Qo = rl(ma[Io], Ca[Io], true, mt, zo(ma[Io], Ca[Io]));
                    if (!Qo) return 0;
                    Vn &= Qo;
                  }
                  else if (ma.length === 1 && Ca.length === 1) {
                    var ls = t === la || !!ye.noStrictGenericChecks, gi = e.first(ma), zt = e.first(Ca);
                    if (Vn = rl(gi, zt, ls, mt, zo(gi, zt)), !Vn && mt && Ri === 1 && us & Bo && (((ft = zt.declaration) === null || ft === void 0 ? void 0 : ft.kind) === 171 || ((Ht = gi.declaration) === null || Ht === void 0 ? void 0 : Ht.kind) === 171)) {
                      var La = function(_o) {
                        return Ml(_o, void 0, 262144, Ri);
                      };
                      return Yt(e.Diagnostics.Type_0_is_not_assignable_to_type_1, La(gi), La(zt)), Yt(e.Diagnostics.Types_of_construct_signatures_are_incompatible), Vn;
                    }
                  } else {
                    e: for (var fa = 0, ya = Ca; fa < ya.length; fa++) {
                      for (var Nn = ya[fa], fn = Eo(), hn = mt, sn = 0, ln = ma; sn < ln.length; sn++) {
                        var lo = ln[sn], Qo = rl(lo, Nn, true, hn, zo(lo, Nn));
                        if (Qo) {
                          Vn &= Qo, Tn(fn);
                          continue e;
                        }
                        hn = false;
                      }
                      return hn && Yt(e.Diagnostics.Type_0_provides_no_match_for_the_signature_1, Ot($r), Ml(Nn, void 0, void 0, Ri)), 0;
                    }
                  }
                  return Vn;
                }
                function rc($r, hi) {
                  var Ri = Ft($r, 0), mt = Ft($r, 1), ft = Pf($r);
                  return (Ri.length || mt.length) && !ft.length ? !!(ot(hi, 0).length && Ri.length || ot(hi, 1).length && mt.length) : true;
                }
                function xu($r, hi) {
                  return $r.parameters.length === 0 && hi.parameters.length === 0 ? function(Ri, mt) {
                    return lt(e.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1, Ot(Ri), Ot(mt));
                  } : function(Ri, mt) {
                    return lt(e.Diagnostics.Call_signature_return_types_0_and_1_are_incompatible, Ot(Ri), Ot(mt));
                  };
                }
                function Ts($r, hi) {
                  return $r.parameters.length === 0 && hi.parameters.length === 0 ? function(Ri, mt) {
                    return lt(e.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1, Ot(Ri), Ot(mt));
                  } : function(Ri, mt) {
                    return lt(e.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible, Ot(Ri), Ot(mt));
                  };
                }
                function rl($r, hi, Ri, mt, ft) {
                  return MD(Ri ? Qm($r) : $r, Ri ? Qm(hi) : hi, t === ki ? 8 : 0, mt, Yt, ft, Un, Gp(Fa));
                }
                function jd($r, hi, Ri) {
                  var mt = ot($r, Ri), ft = ot(hi, Ri);
                  if (mt.length !== ft.length) return 0;
                  for (var Ht = -1, vt = 0; vt < mt.length; vt++) {
                    var ht = _y(mt[vt], ft[vt], false, false, false, oa);
                    if (!ht) return 0;
                    Ht &= ht;
                  }
                  return Ht;
                }
                function lp($r, hi, Ri) {
                  for (var mt = -1, ft = hi.keyType, Ht = $r.flags & 2097152 ? em($r) : Pf($r), vt = 0, ht = Ht; vt < ht.length; vt++) {
                    var ma = ht[vt];
                    if (!hE($r, ma) && an(om(ma, 8576), ft)) {
                      var Ca = ml(ma), An = yr || Ca.flags & 32768 || ft === nt || !(ma.flags & 16777216) ? Ca : Ks(Ca, 524288), gn = oa(An, hi.type, 3, Ri);
                      if (!gn) return Ri && Yt(e.Diagnostics.Property_0_is_incompatible_with_index_signature, tn(ma)), 0;
                      mt &= gn;
                    }
                  }
                  for (var Vn = 0, zo = Hn($r); Vn < zo.length; Vn++) {
                    var us = zo[Vn];
                    if (an(us.keyType, ft)) {
                      var gn = Tl(us, hi, Ri);
                      if (!gn) return 0;
                      mt &= gn;
                    }
                  }
                  return mt;
                }
                function Tl($r, hi, Ri) {
                  var mt = oa($r.type, hi.type, 3, Ri);
                  return !mt && Ri && ($r.keyType === hi.keyType ? Yt(e.Diagnostics._0_index_signatures_are_incompatible, Ot($r.keyType)) : Yt(e.Diagnostics._0_and_1_index_signatures_are_incompatible, Ot($r.keyType), Ot(hi.keyType))), mt;
                }
                function fp($r, hi, Ri, mt, ft) {
                  if (t === wa) return id($r, hi);
                  for (var Ht = Hn(hi), vt = e.some(Ht, function(Vn) {
                    return Vn.keyType === Li;
                  }), ht = -1, ma = 0, Ca = Ht; ma < Ca.length; ma++) {
                    var An = Ca[ma], gn = !Ri && vt && An.type.flags & 1 ? -1 : Bc($r) && vt ? oa(vl($r), An.type, 3, mt) : zg($r, An, mt, ft);
                    if (!gn) return 0;
                    ht &= gn;
                  }
                  return ht;
                }
                function zg($r, hi, Ri, mt) {
                  var ft = nu($r, hi.keyType);
                  return ft ? Tl(ft, hi, Ri) : !(mt & 1) && qh($r) ? lp($r, hi, Ri) : (Ri && Yt(e.Diagnostics.Index_signature_for_type_0_is_missing_in_type_1, Ot(hi.keyType), Ot($r)), 0);
                }
                function id($r, hi) {
                  var Ri = Hn($r), mt = Hn(hi);
                  if (Ri.length !== mt.length) return 0;
                  for (var ft = 0, Ht = mt; ft < Ht.length; ft++) {
                    var vt = Ht[ft], ht = ss($r, vt.keyType);
                    if (!(ht && oa(ht.type, vt.type, 3) && ht.isReadonly === vt.isReadonly)) return 0;
                  }
                  return -1;
                }
                function za($r, hi, Ri) {
                  if (!$r.declaration || !hi.declaration) return true;
                  var mt = e.getSelectedEffectiveModifierFlags($r.declaration, 24), ft = e.getSelectedEffectiveModifierFlags(hi.declaration, 24);
                  return ft === 8 || ft === 16 && mt !== 8 || ft !== 16 && !mt ? true : (Ri && Yt(e.Diagnostics.Cannot_assign_a_0_constructor_type_to_a_1_constructor_type, v_(mt), v_(ft)), false);
                }
              }
              function JD(r) {
                if (r.flags & 16) return false;
                if (r.flags & 3145728) return !!e.forEach(r.types, JD);
                if (r.flags & 465829888) {
                  var i = Q_(r);
                  if (i && i !== r) return JD(i);
                }
                return Vl(r) || !!(r.flags & 134217728);
              }
              function DE(r, i) {
                return Yn(r) && Yn(i) ? e.emptyArray : uo(i).filter(function(t) {
                  return jD(da(r, t.escapedName), Jt(t));
                });
              }
              function jD(r, i) {
                return !!r && !!i && fs(r, 32768) && !!Wh(i);
              }
              function lw(r) {
                return uo(r).filter(function(i) {
                  return Wh(Jt(i));
                });
              }
              function bE(r, i, t) {
                return t === void 0 && (t = OD), bA(r, i, t, true) || kL(r, i) || AL(r, i) || NL(r, i) || PL(r, i);
              }
              function UD(r, i, t, o, s) {
                for (var u = r.types.map(function(Zi) {
                }), h = 0, z2 = i; h < z2.length; h++) {
                  var me = z2[h], Me = me[0], $e = me[1], tr = $v(r, $e);
                  if (!(s && tr && e.getCheckFlags(tr) & 16)) for (var dr = 0, Dr = 0, Qr = r.types; Dr < Qr.length; Dr++) {
                    var li = Qr[Dr], Ti = da(li, $e);
                    Ti && t(Me(), Ti) ? u[dr] = u[dr] === void 0 ? true : u[dr] : u[dr] = false, dr++;
                  }
                }
                var Ci = u.indexOf(true);
                if (Ci === -1) return o;
                for (var $i = u.indexOf(true, Ci + 1); $i !== -1; ) {
                  if (!wf(r.types[Ci], r.types[$i])) return o;
                  $i = u.indexOf(true, $i + 1);
                }
                return r.types[Ci];
              }
              function SE(r) {
                if (r.flags & 524288) {
                  var i = Ru(r);
                  return i.callSignatures.length === 0 && i.constructSignatures.length === 0 && i.indexInfos.length === 0 && i.properties.length > 0 && e.every(i.properties, function(t) {
                    return !!(t.flags & 16777216);
                  });
                }
                return r.flags & 2097152 ? e.every(r.types, SE) : false;
              }
              function fw(r, i, t) {
                for (var o = 0, s = uo(r); o < s.length; o++) {
                  var u = s[o];
                  if (Rb(i, u.escapedName, t)) return true;
                }
                return false;
              }
              function zD(r) {
                return r === Pi || r === Qi || r.objectFlags & 8 ? de : xE(r.symbol, r.typeParameters);
              }
              function TE(r) {
                return xE(r, Aa(r).typeParameters);
              }
              function xE(r, i) {
                i === void 0 && (i = e.emptyArray);
                var t = Aa(r);
                if (!t.variances) {
                  e.tracing === null || e.tracing === void 0 || e.tracing.push("checkTypes", "getVariancesWorker", { arity: i.length, id: fu(go(r)) }), t.variances = e.emptyArray;
                  for (var o = [], s = function(me) {
                    var Me = WD(me), $e = Me & 65536 ? Me & 32768 ? 0 : 1 : Me & 32768 ? 2 : void 0;
                    if ($e === void 0) {
                      var tr = false, dr = false, Dr = hr;
                      hr = function(Ti) {
                        return Ti ? dr = true : tr = true;
                      };
                      var Qr = ly(r, me, Rn), li = ly(r, me, Da);
                      $e = (ao(li, Qr) ? 1 : 0) | (ao(Qr, li) ? 2 : 0), $e === 3 && ao(ly(r, me, bo), Qr) && ($e = 4), hr = Dr, (tr || dr) && (tr && ($e |= 8), dr && ($e |= 16));
                    }
                    o.push($e);
                  }, u = 0, h = i; u < h.length; u++) {
                    var z2 = h[u];
                    s(z2);
                  }
                  t.variances = o, e.tracing === null || e.tracing === void 0 || e.tracing.pop();
                }
                return t.variances;
              }
              function ly(r, i, t) {
                var o = Yd(i, t), s = go(r);
                if (nn(s)) return s;
                var u = r.flags & 524288 ? am(r, e_(Aa(r).typeParameters, o)) : Yf(s, e_(s.typeParameters, o));
                return Je.add(fu(u)), u;
              }
              function Fh(r) {
                return Je.has(fu(r));
              }
              function WD(r) {
                var i, t;
                return (e.some((i = r.symbol) === null || i === void 0 ? void 0 : i.declarations, function(o) {
                  return e.hasSyntacticModifier(o, 32768);
                }) ? 32768 : 0) | (e.some((t = r.symbol) === null || t === void 0 ? void 0 : t.declarations, function(o) {
                  return e.hasSyntacticModifier(o, 65536);
                }) ? 65536 : 0);
              }
              function _w(r, i) {
                for (var t = 0; t < i.length; t++) if ((i[t] & 7) === 1 && r[t].flags & 16384) return true;
                return false;
              }
              function pw(r) {
                return r.flags & 262144 && !Tc(r);
              }
              function dw(r) {
                return !!(e.getObjectFlags(r) & 4) && !r.node;
              }
              function Mh(r) {
                return dw(r) && e.some(xo(r), function(i) {
                  return !!(i.flags & 262144) || Mh(i);
                });
              }
              function gw(r, i, t, o) {
                var s = [], u = "", h = me(r, 0), z2 = me(i, 0);
                return "".concat(u).concat(h, ",").concat(z2).concat(t);
                function me(Me, $e) {
                  $e === void 0 && ($e = 0);
                  for (var tr = "" + Me.target.id, dr = 0, Dr = xo(Me); dr < Dr.length; dr++) {
                    var Qr = Dr[dr];
                    if (Qr.flags & 262144) {
                      if (o || pw(Qr)) {
                        var li = s.indexOf(Qr);
                        li < 0 && (li = s.length, s.push(Qr)), tr += "=" + li;
                        continue;
                      }
                      u = "*";
                    } else if ($e < 4 && Mh(Qr)) {
                      tr += "<" + me(Qr, $e + 1) + ">";
                      continue;
                    }
                    tr += "-" + Qr.id;
                  }
                  return tr;
                }
              }
              function qD(r, i, t, o, s) {
                if (o === wa && r.id > i.id) {
                  var u = r;
                  r = i, i = u;
                }
                var h = t ? ":" + t : "";
                return Mh(r) && Mh(i) ? gw(r, i, h, s) : "".concat(r.id, ",").concat(i.id).concat(h);
              }
              function fy(r, i) {
                if (e.getCheckFlags(r) & 6) {
                  for (var t = 0, o = r.containingType.types; t < o.length; t++) {
                    var s = o[t], u = bi(s, r.escapedName), h = u && fy(u, i);
                    if (h) return h;
                  }
                  return;
                }
                return i(r);
              }
              function Zd(r) {
                return r.parent && r.parent.flags & 32 ? go(Ys(r)) : void 0;
              }
              function Lh(r) {
                var i = Zd(r), t = i && Qc(i)[0];
                return t && da(t, r.escapedName);
              }
              function mw(r, i) {
                return fy(r, function(t) {
                  var o = Zd(t);
                  return o ? lf(o, i) : false;
                });
              }
              function vw(r, i) {
                return !fy(i, function(t) {
                  return e.getDeclarationModifierFlagsFromSymbol(t) & 16 ? !mw(r, Zd(t)) : false;
                });
              }
              function EE(r, i, t) {
                return fy(i, function(o) {
                  return e.getDeclarationModifierFlagsFromSymbol(o, t) & 16 ? !lf(r, Zd(o)) : false;
                }) ? void 0 : r;
              }
              function Rh(r, i, t, o) {
                if (o === void 0 && (o = 3), t >= o) for (var s = ov(r), u = 0, h = 0, z2 = 0; z2 < t; z2++) {
                  var me = i[z2];
                  if (ov(me) === s) {
                    if (me.id >= h && (u++, u >= o)) return true;
                    h = me.id;
                  }
                }
                return false;
              }
              function ov(r) {
                if (r.flags & 524288 && !lb(r)) {
                  if (e.getObjectFlags(r) && 4 && r.node) return r.node;
                  if (r.symbol && !(e.getObjectFlags(r) & 16 && r.symbol.flags & 32)) return r.symbol;
                  if (Yn(r)) return r.target;
                }
                if (r.flags & 262144) return r.symbol;
                if (r.flags & 8388608) {
                  do
                    r = r.objectType;
                  while (r.flags & 8388608);
                  return r;
                }
                return r.flags & 16777216 ? r.root : r;
              }
              function yw(r, i) {
                return VD(r, i, av) !== 0;
              }
              function VD(r, i, t) {
                if (r === i) return -1;
                var o = e.getDeclarationModifierFlagsFromSymbol(r) & 24, s = e.getDeclarationModifierFlagsFromSymbol(i) & 24;
                if (o !== s) return 0;
                if (o) {
                  if (jg(r) !== jg(i)) return 0;
                } else if ((r.flags & 16777216) !== (i.flags & 16777216)) return 0;
                return Zu(r) !== Zu(i) ? 0 : t(Jt(r), Jt(i));
              }
              function hw(r, i, t) {
                var o = Wc(r), s = Wc(i), u = Hl(r), h = Hl(i), z2 = Xl(r), me = Xl(i);
                return !!(o === s && u === h && z2 === me || t && u <= h);
              }
              function _y(r, i, t, o, s, u) {
                if (r === i) return -1;
                if (!hw(r, i, t) || e.length(r.typeParameters) !== e.length(i.typeParameters)) return 0;
                if (i.typeParameters) {
                  for (var h = Uc(r.typeParameters, i.typeParameters), z2 = 0; z2 < i.typeParameters.length; z2++) {
                    var me = r.typeParameters[z2], Me = i.typeParameters[z2];
                    if (!(me === Me || u(un(tm(me), h) || gr, tm(Me) || gr) && u(un(D_(me), h) || gr, D_(Me) || gr))) return 0;
                  }
                  r = Tg(r, h, true);
                }
                var $e = -1;
                if (!o) {
                  var tr = T_(r);
                  if (tr) {
                    var dr = T_(i);
                    if (dr) {
                      var Dr = u(tr, dr);
                      if (!Dr) return 0;
                      $e &= Dr;
                    }
                  }
                }
                for (var Qr = Wc(i), z2 = 0; z2 < Qr; z2++) {
                  var me = $u(r, z2), Me = $u(i, z2), Dr = u(Me, me);
                  if (!Dr) return 0;
                  $e &= Dr;
                }
                if (!s) {
                  var li = Yc(r), Ti = Yc(i);
                  $e &= li || Ti ? Dw(li, Ti, u) : u(yo(r), yo(i));
                }
                return $e;
              }
              function Dw(r, i, t) {
                return r && i && _D(r, i) ? r.type === i.type ? -1 : r.type && i.type ? t(r.type, i.type) : 0 : 0;
              }
              function bw(r) {
                for (var i, t = 0, o = r; t < o.length; t++) {
                  var s = o[t], u = Kl(s);
                  if (i || (i = u), u === s || u !== i) return false;
                }
                return true;
              }
              function CE(r) {
                return r.length === 1 ? r[0] : bw(r) ? Pa(r) : e.reduceLeft(r, function(i, t) {
                  return E_(i, t) ? t : i;
                });
              }
              function Sw(r) {
                if (!Ye) return CE(r);
                var i = e.filter(r, function(t) {
                  return !(t.flags & 98304);
                });
                return i.length ? Uh(CE(i), wE(r) & 98304) : Pa(r, 2);
              }
              function Tw(r) {
                return e.reduceLeft(r, function(i, t) {
                  return E_(t, i) ? t : i;
                });
              }
              function Tu(r) {
                return !!(e.getObjectFlags(r) & 4) && (r.target === Pi || r.target === Qi);
              }
              function um(r) {
                return !!(e.getObjectFlags(r) & 4) && r.target === Qi;
              }
              function Pd(r) {
                return Tu(r) || Yn(r);
              }
              function Bh(r) {
                return Tu(r) && !um(r) || Yn(r) && !r.target.readonly;
              }
              function KD(r) {
                return Tu(r) ? xo(r)[0] : void 0;
              }
              function sp(r) {
                return Tu(r) || !(r.flags & 98304) && ao(r, Go);
              }
              function GD(r) {
                if (!(!(e.getObjectFlags(r) & 4) || !(e.getObjectFlags(r.target) & 3))) {
                  if (e.getObjectFlags(r) & 33554432) return e.getObjectFlags(r) & 67108864 ? r.cachedEquivalentBaseType : void 0;
                  r.objectFlags |= 33554432;
                  var i = r.target;
                  if (e.getObjectFlags(i) & 1) {
                    var t = fg(i);
                    if (t && t.expression.kind !== 79 && t.expression.kind !== 206) return;
                  }
                  var o = Qc(i);
                  if (o.length === 1 && !Nf(r.symbol).size) {
                    var s = e.length(i.typeParameters) ? un(o[0], Uc(i.typeParameters, xo(r).slice(0, i.typeParameters.length))) : o[0];
                    return e.length(xo(r)) > e.length(i.typeParameters) && (s = Rc(s, e.last(xo(r)))), r.objectFlags |= 67108864, r.cachedEquivalentBaseType = s;
                  }
                }
              }
              function kE(r) {
                return Ye ? r === na : r === vi;
              }
              function Jh(r) {
                var i = KD(r);
                return !!i && kE(i);
              }
              function Eg(r) {
                return Yn(r) || !!bi(r, "0");
              }
              function AE(r) {
                return sp(r) || Eg(r);
              }
              function xw(r, i) {
                var t = da(r, "" + i);
                if (t) return t;
                if (gf(r, Yn)) return Ss(r, function(o) {
                  return sv(o) || Tr;
                });
              }
              function Ew(r) {
                return !(r.flags & 240512);
              }
              function Vl(r) {
                return !!(r.flags & 109440);
              }
              function NE(r) {
                return r.flags & 2097152 ? e.some(r.types, Vl) : !!(r.flags & 109440);
              }
              function Cw(r) {
                return r.flags & 2097152 && e.find(r.types, Vl) || r;
              }
              function Cg(r) {
                return r.flags & 16 ? true : r.flags & 1048576 ? r.flags & 1024 ? true : e.every(r.types, Vl) : Vl(r);
              }
              function Kl(r) {
                return r.flags & 1024 ? cc(r) : r.flags & 402653312 ? Li : r.flags & 256 ? nt : r.flags & 2048 ? Mt : r.flags & 512 ? Ii : r.flags & 1048576 ? Ss(r, Kl) : r;
              }
              function Hp(r) {
                return r.flags & 1024 && Kp(r) ? cc(r) : r.flags & 128 && Kp(r) ? Li : r.flags & 256 && Kp(r) ? nt : r.flags & 2048 && Kp(r) ? Mt : r.flags & 512 && Kp(r) ? Ii : r.flags & 1048576 ? Ss(r, Hp) : r;
              }
              function PE(r) {
                return r.flags & 8192 ? Ki : r.flags & 1048576 ? Ss(r, PE) : r;
              }
              function HD(r, i) {
                return N0(r, i) || (r = PE(Hp(r))), r;
              }
              function kw(r, i, t) {
                if (r && Vl(r)) {
                  var o = i ? t ? Tv(i) : i : void 0;
                  r = HD(r, o);
                }
                return r;
              }
              function XD(r, i, t, o) {
                if (r && Vl(r)) {
                  var s = i ? Jg(t, i, o) : void 0;
                  r = HD(r, s);
                }
                return r;
              }
              function Yn(r) {
                return !!(e.getObjectFlags(r) & 4 && r.target.objectFlags & 8);
              }
              function lm(r) {
                return Yn(r) && !!(r.target.combinedFlags & 8);
              }
              function IE(r) {
                return lm(r) && r.target.elementFlags.length === 1;
              }
              function sv(r) {
                return jh(r, r.target.fixedLength);
              }
              function Aw(r) {
                var i = sv(r);
                return i && Zs(i);
              }
              function jh(r, i, t, o) {
                t === void 0 && (t = 0), o === void 0 && (o = false);
                var s = $_(r) - t;
                if (i < s) {
                  for (var u = xo(r), h = [], z2 = i; z2 < s; z2++) {
                    var me = u[z2];
                    h.push(r.target.elementFlags[z2] & 8 ? Jc(me, nt) : me);
                  }
                  return o ? Do(h) : Pa(h);
                }
              }
              function Nw(r, i) {
                return $_(r) === $_(i) && e.every(r.target.elementFlags, function(t, o) {
                  return (t & 12) === (i.target.elementFlags[o] & 12);
                });
              }
              function QD(r) {
                var i = r.value;
                return i.base10Value === "0";
              }
              function wE(r) {
                for (var i = 0, t = 0, o = r; t < o.length; t++) {
                  var s = o[t];
                  i |= ju(s);
                }
                return i;
              }
              function ju(r) {
                return r.flags & 1048576 ? wE(r.types) : r.flags & 128 ? r.value === "" ? 128 : 0 : r.flags & 256 ? r.value === 0 ? 256 : 0 : r.flags & 2048 ? QD(r) ? 2048 : 0 : r.flags & 512 ? r === xt || r === ut ? 512 : 0 : r.flags & 117724;
              }
              function OE(r) {
                return ju(r) & 117632 ? ec(r, function(i) {
                  return !(ju(i) & 117632);
                }) : r;
              }
              function Pw(r) {
                return Ss(r, Iw);
              }
              function Iw(r) {
                return r.flags & 4 ? Rf : r.flags & 8 ? al : r.flags & 64 ? Jo : r === ut || r === xt || r.flags & 114691 || r.flags & 128 && r.value === "" || r.flags & 256 && r.value === 0 || r.flags & 2048 && QD(r) ? r : ui;
              }
              function Uh(r, i) {
                var t = i & ~r.flags & 98304;
                return t === 0 ? r : Pa(t === 32768 ? [r, Tr] : t === 65536 ? [r, Wi] : [r, Tr, Wi]);
              }
              function i_(r, i) {
                return i === void 0 && (i = false), e.Debug.assert(Ye), r.flags & 32768 ? r : Pa([r, i ? Yi : Tr]);
              }
              function ww(r) {
                var i = Ks(r, 2097152);
                return ys || (ys = Ym("NonNullable", 524288, void 0) || xe), ys !== xe ? am(ys, [i]) : i;
              }
              function C_(r) {
                return Ye ? ww(r) : r;
              }
              function FE(r) {
                return Ye ? Pa([r, Ui]) : r;
              }
              function YD(r) {
                return Ye ? Zh(r, Ui) : r;
              }
              function zh(r, i, t) {
                return t ? e.isOutermostOptionalChain(i) ? i_(r) : FE(r) : r;
              }
              function cv(r, i) {
                return e.isExpressionOfOptionalChainRoot(i) ? C_(r) : e.isOptionalChain(i) ? YD(r) : r;
              }
              function kg(r, i) {
                return yr && i ? Zh(r, Yi) : r;
              }
              function Wh(r) {
                return yr && (r === Yi || r.flags & 1048576 && $f(r.types, Yi));
              }
              function $D(r) {
                return yr ? Zh(r, Yi) : Ks(r, 524288);
              }
              function Ow(r, i) {
                return (r.flags & 524) !== 0 && (i.flags & 28) !== 0;
              }
              function qh(r) {
                return r.flags & 2097152 ? e.every(r.types, qh) : !!(r.symbol && (r.symbol.flags & 7040) !== 0 && !(r.symbol.flags & 32) && !RS(r)) || !!(e.getObjectFlags(r) & 1024 && qh(r.source));
              }
              function eg(r, i) {
                var t = oo(r.flags, r.escapedName, e.getCheckFlags(r) & 8);
                t.declarations = r.declarations, t.parent = r.parent, t.type = i, t.target = r, r.valueDeclaration && (t.valueDeclaration = r.valueDeclaration);
                var o = Aa(r).nameType;
                return o && (t.nameType = o), t;
              }
              function Fw(r, i) {
                for (var t = e.createSymbolTable(), o = 0, s = Pf(r); o < s.length; o++) {
                  var u = s[o], h = Jt(u), z2 = i(h);
                  t.set(u.escapedName, z2 === h ? u : eg(u, z2));
                }
                return t;
              }
              function fm(r) {
                if (!(Qp(r) && e.getObjectFlags(r) & 8192)) return r;
                var i = r.regularType;
                if (i) return i;
                var t = r, o = Fw(r, fm), s = rs(t.symbol, o, t.callSignatures, t.constructSignatures, t.indexInfos);
                return s.flags = t.flags, s.objectFlags |= t.objectFlags & -8193, r.regularType = s, s;
              }
              function ME(r, i, t) {
                return { parent: r, propertyName: i, siblings: t, resolvedProperties: void 0 };
              }
              function LE(r) {
                if (!r.siblings) {
                  for (var i = [], t = 0, o = LE(r.parent); t < o.length; t++) {
                    var s = o[t];
                    if (Qp(s)) {
                      var u = h_(s, r.propertyName);
                      u && Od(Jt(u), function(h) {
                        i.push(h);
                      });
                    }
                  }
                  r.siblings = i;
                }
                return r.siblings;
              }
              function Mw(r) {
                if (!r.resolvedProperties) {
                  for (var i = new e.Map(), t = 0, o = LE(r); t < o.length; t++) {
                    var s = o[t];
                    if (Qp(s) && !(e.getObjectFlags(s) & 2097152)) for (var u = 0, h = uo(s); u < h.length; u++) {
                      var z2 = h[u];
                      i.set(z2.escapedName, z2);
                    }
                  }
                  r.resolvedProperties = e.arrayFrom(i.values());
                }
                return r.resolvedProperties;
              }
              function Lw(r, i) {
                if (!(r.flags & 4)) return r;
                var t = Jt(r), o = i && ME(i, r.escapedName, void 0), s = ZD(t, o);
                return s === t ? r : eg(r, s);
              }
              function Rw(r) {
                var i = Wr.get(r.escapedName);
                if (i) return i;
                var t = eg(r, Yi);
                return t.flags |= 16777216, Wr.set(r.escapedName, t), t;
              }
              function Bw(r, i) {
                for (var t = e.createSymbolTable(), o = 0, s = Pf(r); o < s.length; o++) {
                  var u = s[o];
                  t.set(u.escapedName, Lw(u, i));
                }
                if (i) for (var h = 0, z2 = Mw(i); h < z2.length; h++) {
                  var u = z2[h];
                  t.has(u.escapedName) || t.set(u.escapedName, Rw(u));
                }
                var me = rs(r.symbol, t, e.emptyArray, e.emptyArray, e.sameMap(Hn(r), function(Me) {
                  return zl(Me.keyType, $c(Me.type), Me.isReadonly);
                }));
                return me.objectFlags |= e.getObjectFlags(r) & 266240, me;
              }
              function $c(r) {
                return ZD(r, void 0);
              }
              function ZD(r, i) {
                if (e.getObjectFlags(r) & 196608) {
                  if (i === void 0 && r.widened) return r.widened;
                  var t = void 0;
                  if (r.flags & 98305) t = Oe;
                  else if (Qp(r)) t = Bw(r, i);
                  else if (r.flags & 1048576) {
                    var o = i || ME(void 0, void 0, r.types), s = e.sameMap(r.types, function(u) {
                      return u.flags & 98304 ? u : ZD(u, o);
                    });
                    t = Pa(s, e.some(s, Of) ? 2 : 1);
                  } else r.flags & 2097152 ? t = Do(e.sameMap(r.types, $c)) : Pd(r) && (t = Yf(r.target, e.sameMap(xo(r), $c)));
                  return t && i === void 0 && (r.widened = t), t || r;
                }
                return r;
              }
              function Vh(r) {
                var i = false;
                if (e.getObjectFlags(r) & 65536) {
                  if (r.flags & 1048576) if (e.some(r.types, Of)) i = true;
                  else for (var t = 0, o = r.types; t < o.length; t++) {
                    var s = o[t];
                    Vh(s) && (i = true);
                  }
                  if (Pd(r)) for (var u = 0, h = xo(r); u < h.length; u++) {
                    var s = h[u];
                    Vh(s) && (i = true);
                  }
                  if (Qp(r)) for (var z2 = 0, me = Pf(r); z2 < me.length; z2++) {
                    var Me = me[z2], s = Jt(Me);
                    e.getObjectFlags(s) & 65536 && (Vh(s) || Xr(Me.valueDeclaration, e.Diagnostics.Object_literal_s_property_0_implicitly_has_an_1_type, tn(Me), Ot($c(s))), i = true);
                  }
                }
                return i;
              }
              function Xp(r, i, t) {
                var o = Ot($c(i));
                if (!(e.isInJSFile(r) && !e.isCheckJsEnabledForFile(e.getSourceFileOfNode(r), ye))) {
                  var s;
                  switch (r.kind) {
                    case 221:
                    case 167:
                    case 166:
                      s = n ? e.Diagnostics.Member_0_implicitly_has_an_1_type : e.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
                      break;
                    case 164:
                      var u = r;
                      if (e.isIdentifier(u.name) && (e.isCallSignatureDeclaration(u.parent) || e.isMethodSignature(u.parent) || e.isFunctionTypeNode(u.parent)) && u.parent.parameters.indexOf(u) > -1 && (es(u, u.name.escapedText, 788968, void 0, u.name.escapedText, true) || u.name.originalKeywordKind && e.isTypeNodeKind(u.name.originalKeywordKind))) {
                        var h = "arg" + u.parent.parameters.indexOf(u), z2 = e.declarationNameToString(u.name) + (u.dotDotDotToken ? "[]" : "");
                        Ic(n, r, e.Diagnostics.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1, h, z2);
                        return;
                      }
                      s = r.dotDotDotToken ? n ? e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type : e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage : n ? e.Diagnostics.Parameter_0_implicitly_has_an_1_type : e.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
                      break;
                    case 203:
                      if (s = e.Diagnostics.Binding_element_0_implicitly_has_an_1_type, !n) return;
                      break;
                    case 317:
                      Xr(r, e.Diagnostics.Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type, o);
                      return;
                    case 256:
                    case 169:
                    case 168:
                    case 172:
                    case 173:
                    case 213:
                    case 214:
                      if (n && !r.name) {
                        t === 3 ? Xr(r, e.Diagnostics.Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type_annotation, o) : Xr(r, e.Diagnostics.Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type, o);
                        return;
                      }
                      s = n ? t === 3 ? e.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type : e.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type : e.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage;
                      break;
                    case 195:
                      n && Xr(r, e.Diagnostics.Mapped_object_type_implicitly_has_an_any_template_type);
                      return;
                    default:
                      s = n ? e.Diagnostics.Variable_0_implicitly_has_an_1_type : e.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
                  }
                  Ic(n, r, s, e.declarationNameToString(e.getNameOfDeclaration(r)), o);
                }
              }
              function Kh(r, i, t) {
                fe(function() {
                  n && e.getObjectFlags(i) & 65536 && (!t || !Pb(r)) && (Vh(i) || Xp(r, i, t));
                });
              }
              function eb(r, i, t) {
                var o = Wc(r), s = Wc(i), u = vv(r), h = vv(i), z2 = h ? s - 1 : s, me = u ? z2 : Math.min(o, z2), Me = T_(r);
                if (Me) {
                  var $e = T_(i);
                  $e && t(Me, $e);
                }
                for (var tr = 0; tr < me; tr++) t($u(r, tr), $u(i, tr));
                h && t(ym(r, me), h);
              }
              function rb(r, i, t) {
                var o = Yc(r), s = Yc(i);
                o && s && _D(o, s) && o.type && s.type ? t(o.type, s.type) : t(yo(r), yo(i));
              }
              function uv(r, i, t, o) {
                return ib(r.map(tb), i, t, o || OD);
              }
              function Jw(r, i) {
                return i === void 0 && (i = 0), r && ib(e.map(r.inferences, JE), r.signature, r.flags | i, r.compareTypes);
              }
              function ib(r, i, t, o) {
                var s = { inferences: r, signature: i, flags: t, compareTypes: o, mapper: Gp(function(u) {
                  return RE(s, u, true);
                }), nonFixingMapper: Gp(function(u) {
                  return RE(s, u, false);
                }) };
                return s;
              }
              function RE(r, i, t) {
                for (var o = r.inferences, s = 0; s < o.length; s++) {
                  var u = o[s];
                  if (i === u.typeParameter) return t && !u.isFixed && (jw(r), Gh(o), u.isFixed = true), GE(r, s);
                }
                return i;
              }
              function Gh(r) {
                for (var i = 0, t = r; i < t.length; i++) {
                  var o = t[i];
                  o.isFixed || (o.inferredType = void 0);
                }
              }
              function BE(r, i, t) {
                var o;
                ((o = r.intraExpressionInferenceSites) !== null && o !== void 0 ? o : r.intraExpressionInferenceSites = []).push({ node: i, type: t });
              }
              function jw(r) {
                if (r.intraExpressionInferenceSites) {
                  for (var i = 0, t = r.intraExpressionInferenceSites; i < t.length; i++) {
                    var o = t[i], s = o.node, u = o.type, h = s.kind === 169 ? kC(s, 2) : ou(s, 2);
                    h && df(r.inferences, u, h);
                  }
                  r.intraExpressionInferenceSites = void 0;
                }
              }
              function tb(r) {
                return { typeParameter: r, candidates: void 0, contraCandidates: void 0, inferredType: void 0, priority: void 0, topLevel: true, isFixed: false, impliedArity: void 0 };
              }
              function JE(r) {
                return { typeParameter: r.typeParameter, candidates: r.candidates && r.candidates.slice(), contraCandidates: r.contraCandidates && r.contraCandidates.slice(), inferredType: r.inferredType, priority: r.priority, topLevel: r.topLevel, isFixed: r.isFixed, impliedArity: r.impliedArity };
              }
              function Uw(r) {
                var i = e.filter(r.inferences, tg);
                return i.length ? ib(e.map(i, JE), r.signature, r.flags, r.compareTypes) : void 0;
              }
              function ab(r) {
                return r && r.mapper;
              }
              function Id(r) {
                var i = e.getObjectFlags(r);
                if (i & 524288) return !!(i & 1048576);
                var t = !!(r.flags & 465829888 || r.flags & 524288 && !jE(r) && (i & 4 && (r.node || e.forEach(xo(r), Id)) || i & 16 && r.symbol && r.symbol.flags & 14384 && r.symbol.declarations || i & 12583968) || r.flags & 3145728 && !(r.flags & 1024) && !jE(r) && e.some(r.types, Id));
                return r.flags & 3899393 && (r.objectFlags |= 524288 | (t ? 1048576 : 0)), t;
              }
              function jE(r) {
                if (r.aliasSymbol && !r.aliasTypeArguments) {
                  var i = e.getDeclarationOfKind(r.aliasSymbol, 259);
                  return !!(i && e.findAncestor(i.parent, function(t) {
                    return t.kind === 305 ? true : t.kind === 261 ? false : "quit";
                  }));
                }
                return false;
              }
              function nb(r, i) {
                return !!(r === i || r.flags & 3145728 && e.some(r.types, function(t) {
                  return nb(t, i);
                }) || r.flags & 16777216 && (ip(r) === i || tp(r) === i));
              }
              function zw(r) {
                var i = e.createSymbolTable();
                Od(r, function(o) {
                  if (!!(o.flags & 128)) {
                    var s = e.escapeLeadingUnderscores(o.value), u = oo(4, s);
                    u.type = Oe, o.symbol && (u.declarations = o.symbol.declarations, u.valueDeclaration = o.symbol.valueDeclaration), i.set(s, u);
                  }
                });
                var t = r.flags & 4 ? [zl(Li, Ba, false)] : e.emptyArray;
                return rs(void 0, i, e.emptyArray, e.emptyArray, t);
              }
              function UE(r, i, t) {
                if (!Qe) {
                  var o = r.id + "," + i.id + "," + t.id;
                  if (Jn.has(o)) return Jn.get(o);
                  Qe = true;
                  var s = Ww(r, i, t);
                  return Qe = false, Jn.set(o, s), s;
                }
              }
              function ob(r) {
                return !(e.getObjectFlags(r) & 262144) || Qp(r) && e.some(uo(r), function(i) {
                  return ob(Jt(i));
                }) || Yn(r) && e.some(xo(r), ob);
              }
              function Ww(r, i, t) {
                if (!!(ss(r, Li) || uo(r).length !== 0 && ob(r))) {
                  if (Tu(r)) return Zs(Hh(xo(r)[0], i, t), um(r));
                  if (Yn(r)) {
                    var o = e.map(xo(r), function(h) {
                      return Hh(h, i, t);
                    }), s = Lu(i) & 4 ? e.sameMap(r.target.elementFlags, function(h) {
                      return h & 2 ? 1 : h;
                    }) : r.target.elementFlags;
                    return Wl(o, s, r.target.readonly, r.target.labeledElementDeclarations);
                  }
                  var u = tu(1040, void 0);
                  return u.source = r, u.mappedType = i, u.constraintType = t, u;
                }
              }
              function qw(r) {
                var i = Aa(r);
                return i.type || (i.type = Hh(r.propertyType, r.mappedType, r.constraintType)), i.type;
              }
              function Hh(r, i, t) {
                var o = Jc(t.type, Du(i)), s = vl(i), u = tb(o);
                return df([u], r, s), zE(u) || gr;
              }
              function sb(r, i, t, o) {
                var s, u, h, z2, me, Me, $e;
                return kr(this, function(tr) {
                  switch (tr.label) {
                    case 0:
                      s = uo(i), u = 0, h = s, tr.label = 1;
                    case 1:
                      return u < h.length ? (z2 = h[u], $y(z2) ? [3, 5] : t || !(z2.flags & 16777216 || e.getCheckFlags(z2) & 48) ? (me = bi(r, z2.escapedName), me ? [3, 3] : [4, z2]) : [3, 5]) : [3, 6];
                    case 2:
                      return tr.sent(), [3, 5];
                    case 3:
                      return o ? (Me = Jt(z2), Me.flags & 109440 ? ($e = Jt(me), $e.flags & 1 || jc($e) === jc(Me) ? [3, 5] : [4, z2]) : [3, 5]) : [3, 5];
                    case 4:
                      tr.sent(), tr.label = 5;
                    case 5:
                      return u++, [3, 1];
                    case 6:
                      return [2];
                  }
                });
              }
              function cb(r, i, t, o) {
                var s = sb(r, i, t, o).next();
                if (!s.done) return s.value;
              }
              function Vw(r, i) {
                return !(i.target.combinedFlags & 8) && i.target.minLength > r.target.minLength || !i.target.hasRestElement && (r.target.hasRestElement || i.target.fixedLength < r.target.fixedLength);
              }
              function Kw(r, i) {
                return Yn(r) && Yn(i) ? Vw(r, i) : !!cb(r, i, false, true) && !!cb(i, r, false, false);
              }
              function zE(r) {
                return r.candidates ? Pa(r.candidates, 2) : r.contraCandidates ? Do(r.contraCandidates) : void 0;
              }
              function ub(r) {
                return !!va(r).skipDirectInference;
              }
              function WE(r) {
                return !!(r.symbol && e.some(r.symbol.declarations, ub));
              }
              function Gw(r, i) {
                var t = r.texts[0], o = i.texts[0], s = r.texts[r.texts.length - 1], u = i.texts[i.texts.length - 1], h = Math.min(t.length, o.length), z2 = Math.min(s.length, u.length);
                return t.slice(0, h) !== o.slice(0, h) || s.slice(s.length - z2) !== u.slice(u.length - z2);
              }
              function Hw(r) {
                var i = e.createScanner(99, false), t = true;
                i.setOnError(function() {
                  return t = false;
                }), i.setText(r + "n");
                var o = i.scan();
                o === 40 && (o = i.scan());
                var s = i.getTokenFlags();
                return t && o === 9 && i.getTextPos() === r.length + 1 && !(s & 512);
              }
              function Xw(r, i) {
                if (r === i || i.flags & 5) return true;
                if (r.flags & 128) {
                  var t = r.value;
                  return !!(i.flags & 8 && t !== "" && isFinite(+t) || i.flags & 64 && t !== "" && Hw(t) || i.flags & 98816 && t === i.intrinsicName);
                }
                if (r.flags & 134217728) {
                  var o = r.texts;
                  return o.length === 2 && o[0] === "" && o[1] === "" && ao(r.types[0], i);
                }
                return ao(r, i);
              }
              function qE(r, i) {
                return r.flags & 128 ? KE([r.value], e.emptyArray, i) : r.flags & 134217728 ? e.arraysEqual(r.texts, i.texts) ? e.map(r.types, Qw) : KE(r.texts, r.types, i) : void 0;
              }
              function VE(r, i) {
                var t = qE(r, i);
                return !!t && e.every(t, function(o, s) {
                  return Xw(o, i.types[s]);
                });
              }
              function Qw(r) {
                return r.flags & 402653317 ? r : Dg(["", ""], [r]);
              }
              function KE(r, i, t) {
                var o = r.length - 1, s = r[0], u = r[o], h = t.texts, z2 = h.length - 1, me = h[0], Me = h[z2];
                if (o === 0 && s.length < me.length + Me.length || !s.startsWith(me) || !u.endsWith(Me)) return;
                for (var $e = u.slice(0, u.length - Me.length), tr = [], dr = 0, Dr = me.length, Qr = 1; Qr < z2; Qr++) {
                  var li = h[Qr];
                  if (li.length > 0) {
                    for (var Ti = dr, Ci = Dr; Ci = $i(Ti).indexOf(li, Ci), !(Ci >= 0); ) {
                      if (Ti++, Ti === r.length) return;
                      Ci = 0;
                    }
                    Zi(Ti, Ci), Dr += li.length;
                  } else if (Dr < $i(dr).length) Zi(dr, Dr + 1);
                  else if (dr < o) Zi(dr + 1, 0);
                  else return;
                }
                return Zi(o, $i(o).length), tr;
                function $i(qt) {
                  return qt < o ? r[qt] : $e;
                }
                function Zi(qt, Nt) {
                  var Ra = qt === dr ? Bu($i(qt).slice(Dr, Nt)) : Dg(Ve(Ve([r[dr].slice(Dr)], r.slice(dr + 1, qt), true), [$i(qt).slice(0, Nt)], false), i.slice(dr, qt));
                  tr.push(Ra), dr = qt, Dr = Nt;
                }
              }
              function df(r, i, t, o, s) {
                o === void 0 && (o = 0), s === void 0 && (s = false);
                var u = false, h, z2 = 2048, me = true, Me, $e, tr, dr = 0;
                Dr(i, t);
                function Dr(lt, it) {
                  if (!!Id(it)) {
                    if (lt === Mr) {
                      var Yt = h;
                      h = lt, Dr(it, it), h = Yt;
                      return;
                    }
                    if (lt.aliasSymbol && lt.aliasTypeArguments && lt.aliasSymbol === it.aliasSymbol) {
                      Ci(lt.aliasTypeArguments, it.aliasTypeArguments, TE(lt.aliasSymbol));
                      return;
                    }
                    if (lt === it && lt.flags & 3145728) {
                      for (var Ia = 0, Qt = lt.types; Ia < Qt.length; Ia++) {
                        var Ka = Qt[Ia];
                        Dr(Ka, Ka);
                      }
                      return;
                    }
                    if (it.flags & 1048576) {
                      var cn = Ti(lt.flags & 1048576 ? lt.types : [lt], it.types, Yw), Un = cn[0], oa = cn[1], Mn = Ti(Un, oa, $w), Ln = Mn[0], ci = Mn[1];
                      if (ci.length === 0) return;
                      if (it = Pa(ci), Ln.length === 0) {
                        Qr(lt, it, 1);
                        return;
                      }
                      lt = Pa(Ln);
                    } else if (it.flags & 2097152 && e.some(it.types, function(Fa) {
                      return !!Zi(Fa) || Bc(Fa) && !!Zi(Ih(Fa) || ui);
                    })) {
                      if (!(lt.flags & 1048576)) {
                        var Fr = Ti(lt.flags & 2097152 ? lt.types : [lt], it.types, wf), Ln = Fr[0], ci = Fr[1];
                        if (Ln.length === 0 || ci.length === 0) return;
                        lt = Do(Ln), it = Do(ci);
                      }
                    } else it.flags & 41943040 && (it = rp(it));
                    if (it.flags & 8650752) {
                      if (lt === fr || lt === Bt || o & 128 && (lt === nr || lt === So) || WE(lt)) return;
                      var jt = Zi(it);
                      if (jt) {
                        if (e.getObjectFlags(lt) & 262144) return;
                        if (!jt.isFixed) {
                          if ((jt.priority === void 0 || o < jt.priority) && (jt.candidates = void 0, jt.contraCandidates = void 0, jt.topLevel = true, jt.priority = o), o === jt.priority) {
                            var Lt = h || lt;
                            s && !u ? e.contains(jt.contraCandidates, Lt) || (jt.contraCandidates = e.append(jt.contraCandidates, Lt), Gh(r)) : e.contains(jt.candidates, Lt) || (jt.candidates = e.append(jt.candidates, Lt), Gh(r));
                          }
                          !(o & 128) && it.flags & 262144 && jt.topLevel && !nb(t, it) && (jt.topLevel = false, Gh(r));
                        }
                        z2 = Math.min(z2, o);
                        return;
                      }
                      var ea = Zf(it, false);
                      if (ea !== it) Dr(lt, ea);
                      else if (it.flags & 8388608) {
                        var Kt = Zf(it.indexType, false);
                        if (Kt.flags & 465829888) {
                          var $t = Hx(Zf(it.objectType, false), Kt, false);
                          $t && $t !== it && Dr(lt, $t);
                        }
                      }
                    }
                    if (e.getObjectFlags(lt) & 4 && e.getObjectFlags(it) & 4 && (lt.target === it.target || Tu(lt) && Tu(it)) && !(lt.node && it.node)) Ci(xo(lt), xo(it), zD(lt.target));
                    else if (lt.flags & 4194304 && it.flags & 4194304) s = !s, Dr(lt.type, it.type), s = !s;
                    else if ((Cg(lt) || lt.flags & 4) && it.flags & 4194304) {
                      var Ua = zw(lt);
                      s = !s, Qr(Ua, it.type, 256), s = !s;
                    } else if (lt.flags & 8388608 && it.flags & 8388608) Dr(lt.objectType, it.objectType), Dr(lt.indexType, it.indexType);
                    else if (lt.flags & 268435456 && it.flags & 268435456) lt.symbol === it.symbol && Dr(lt.type, it.type);
                    else if (lt.flags & 33554432) {
                      Dr(lt.baseType, it);
                      var Yr = o;
                      o |= 4, Dr(lt.substitute, it), o = Yr;
                    } else if (it.flags & 16777216) li(lt, it, ca);
                    else if (it.flags & 3145728) Nt(lt, it.types, it.flags);
                    else if (lt.flags & 1048576) for (var Ni = lt.types, Hi = 0, _t = Ni; Hi < _t.length; Hi++) {
                      var gt = _t[Hi];
                      Dr(gt, it);
                    }
                    else if (it.flags & 134217728) Sn(lt, it);
                    else {
                      if (lt = bu(lt), !(o & 512 && lt.flags & 467927040)) {
                        var Vt = $s(lt);
                        if (Vt !== lt && me && !(Vt.flags & 2621440)) return me = false, Dr(Vt, it);
                        lt = Vt;
                      }
                      lt.flags & 2621440 && li(lt, it, ja);
                    }
                  }
                }
                function Qr(lt, it, Yt) {
                  var Ia = o;
                  o |= Yt, Dr(lt, it), o = Ia;
                }
                function li(lt, it, Yt) {
                  var Ia = lt.id + "," + it.id, Qt = Me && Me.get(Ia);
                  if (Qt !== void 0) {
                    z2 = Math.min(z2, Qt);
                    return;
                  }
                  (Me || (Me = new e.Map())).set(Ia, -1);
                  var Ka = z2;
                  z2 = 2048;
                  var cn = dr, Un = ov(lt), oa = ov(it);
                  e.contains($e, Un) && (dr |= 1), e.contains(tr, oa) && (dr |= 2), dr !== 3 ? (($e || ($e = [])).push(Un), (tr || (tr = [])).push(oa), Yt(lt, it), tr.pop(), $e.pop()) : z2 = -1, dr = cn, Me.set(Ia, z2), z2 = Math.min(z2, Ka);
                }
                function Ti(lt, it, Yt) {
                  for (var Ia, Qt, Ka = 0, cn = it; Ka < cn.length; Ka++) for (var Un = cn[Ka], oa = 0, Mn = lt; oa < Mn.length; oa++) {
                    var Ln = Mn[oa];
                    Yt(Ln, Un) && (Dr(Ln, Un), Ia = e.appendIfUnique(Ia, Ln), Qt = e.appendIfUnique(Qt, Un));
                  }
                  return [Ia ? e.filter(lt, function(ci) {
                    return !e.contains(Ia, ci);
                  }) : lt, Qt ? e.filter(it, function(ci) {
                    return !e.contains(Qt, ci);
                  }) : it];
                }
                function Ci(lt, it, Yt) {
                  for (var Ia = lt.length < it.length ? lt.length : it.length, Qt = 0; Qt < Ia; Qt++) Qt < Yt.length && (Yt[Qt] & 7) === 2 ? $i(lt[Qt], it[Qt]) : Dr(lt[Qt], it[Qt]);
                }
                function $i(lt, it) {
                  Br || o & 1024 ? (s = !s, Dr(lt, it), s = !s) : Dr(lt, it);
                }
                function Zi(lt) {
                  if (lt.flags & 8650752) for (var it = 0, Yt = r; it < Yt.length; it++) {
                    var Ia = Yt[it];
                    if (lt === Ia.typeParameter) return Ia;
                  }
                }
                function qt(lt) {
                  for (var it, Yt = 0, Ia = lt; Yt < Ia.length; Yt++) {
                    var Qt = Ia[Yt], Ka = Qt.flags & 2097152 && e.find(Qt.types, function(cn) {
                      return !!Zi(cn);
                    });
                    if (!Ka || it && Ka !== it) return;
                    it = Ka;
                  }
                  return it;
                }
                function Nt(lt, it, Yt) {
                  var Ia = 0;
                  if (Yt & 1048576) {
                    for (var Qt = void 0, Ka = lt.flags & 1048576 ? lt.types : [lt], cn = new Array(Ka.length), Un = false, oa = 0, Mn = it; oa < Mn.length; oa++) {
                      var Ln = Mn[oa];
                      if (Zi(Ln)) Qt = Ln, Ia++;
                      else for (var ci = 0; ci < Ka.length; ci++) {
                        var Fr = z2;
                        z2 = 2048, Dr(Ka[ci], Ln), z2 === o && (cn[ci] = true), Un = Un || z2 === -1, z2 = Math.min(z2, Fr);
                      }
                    }
                    if (Ia === 0) {
                      var jt = qt(it);
                      jt && Qr(lt, jt, 1);
                      return;
                    }
                    if (Ia === 1 && !Un) {
                      var Lt = e.flatMap(Ka, function(Yr, Ni) {
                        return cn[Ni] ? void 0 : Yr;
                      });
                      if (Lt.length) {
                        Dr(Pa(Lt), Qt);
                        return;
                      }
                    }
                  } else for (var ea = 0, Kt = it; ea < Kt.length; ea++) {
                    var Ln = Kt[ea];
                    Zi(Ln) ? Ia++ : Dr(lt, Ln);
                  }
                  if (Yt & 2097152 ? Ia === 1 : Ia > 0) for (var $t = 0, Ua = it; $t < Ua.length; $t++) {
                    var Ln = Ua[$t];
                    Zi(Ln) && Qr(lt, Ln, 1);
                  }
                }
                function Ra(lt, it, Yt) {
                  if (Yt.flags & 1048576) {
                    for (var Ia = false, Qt = 0, Ka = Yt.types; Qt < Ka.length; Qt++) {
                      var cn = Ka[Qt];
                      Ia = Ra(lt, it, cn) || Ia;
                    }
                    return Ia;
                  }
                  if (Yt.flags & 4194304) {
                    var Un = Zi(Yt.type);
                    if (Un && !Un.isFixed && !WE(lt)) {
                      var oa = UE(lt, it, Yt);
                      oa && Qr(oa, Un.typeParameter, e.getObjectFlags(lt) & 262144 ? 16 : 8);
                    }
                    return true;
                  }
                  if (Yt.flags & 262144) {
                    Qr(ql(lt), Yt, 32);
                    var Mn = Q_(Yt);
                    if (Mn && Ra(lt, it, Mn)) return true;
                    var Ln = e.map(uo(lt), Jt), ci = e.map(Hn(lt), function(Fr) {
                      return Fr !== Ko ? Fr.type : ui;
                    });
                    return Dr(Pa(e.concatenate(Ln, ci)), vl(it)), true;
                  }
                  return false;
                }
                function ca(lt, it) {
                  if (lt.flags & 16777216) Dr(lt.checkType, it.checkType), Dr(lt.extendsType, it.extendsType), Dr(ip(lt), ip(it)), Dr(tp(lt), tp(it));
                  else {
                    var Yt = o;
                    o |= s ? 64 : 0;
                    var Ia = [ip(it), tp(it)];
                    Nt(lt, Ia, it.flags), o = Yt;
                  }
                }
                function Sn(lt, it) {
                  var Yt = qE(lt, it), Ia = it.types;
                  if (Yt || e.every(it.texts, function(Ka) {
                    return Ka.length === 0;
                  })) for (var Qt = 0; Qt < Ia.length; Qt++) Dr(Yt ? Yt[Qt] : ui, Ia[Qt]);
                }
                function ja(lt, it) {
                  if (e.getObjectFlags(lt) & 4 && e.getObjectFlags(it) & 4 && (lt.target === it.target || Tu(lt) && Tu(it))) {
                    Ci(xo(lt), xo(it), zD(lt.target));
                    return;
                  }
                  if (Bc(lt) && Bc(it)) {
                    Dr(Mu(lt), Mu(it)), Dr(vl(lt), vl(it));
                    var Yt = Jl(lt), Ia = Jl(it);
                    Yt && Ia && Dr(Yt, Ia);
                  }
                  if (e.getObjectFlags(it) & 32 && !it.declaration.nameType) {
                    var Qt = Mu(it);
                    if (Ra(lt, it, Qt)) return;
                  }
                  if (!Kw(lt, it)) {
                    if (Pd(lt)) {
                      if (Yn(it)) {
                        var Ka = $_(lt), cn = $_(it), Un = xo(it), oa = it.target.elementFlags;
                        if (Yn(lt) && Nw(lt, it)) {
                          for (var Mn = 0; Mn < cn; Mn++) Dr(xo(lt)[Mn], Un[Mn]);
                          return;
                        }
                        for (var Ln = Yn(lt) ? Math.min(lt.target.fixedLength, it.target.fixedLength) : 0, ci = Math.min(Yn(lt) ? Sh(lt.target, 3) : 0, it.target.hasRestElement ? Sh(it.target, 3) : 0), Mn = 0; Mn < Ln; Mn++) Dr(xo(lt)[Mn], Un[Mn]);
                        if (!Yn(lt) || Ka - Ln - ci === 1 && lt.target.elementFlags[Ln] & 4) for (var Fr = xo(lt)[Ln], Mn = Ln; Mn < cn - ci; Mn++) Dr(oa[Mn] & 8 ? Zs(Fr) : Fr, Un[Mn]);
                        else {
                          var jt = cn - Ln - ci;
                          if (jt === 2 && oa[Ln] & oa[Ln + 1] & 8 && Yn(lt)) {
                            var Lt = Zi(Un[Ln]);
                            Lt && Lt.impliedArity !== void 0 && (Dr(Zm(lt, Ln, ci + Ka - Lt.impliedArity), Un[Ln]), Dr(Zm(lt, Ln + Lt.impliedArity, ci), Un[Ln + 1]));
                          } else if (jt === 1 && oa[Ln] & 8) {
                            var ea = it.target.elementFlags[cn - 1] & 2, Kt = Yn(lt) ? Zm(lt, Ln, ci) : Zs(xo(lt)[0]);
                            Qr(Kt, Un[Ln], ea ? 2 : 0);
                          } else if (jt === 1 && oa[Ln] & 4) {
                            var Fr = Yn(lt) ? jh(lt, Ln, ci) : xo(lt)[0];
                            Fr && Dr(Fr, Un[Ln]);
                          }
                        }
                        for (var Mn = 0; Mn < ci; Mn++) Dr(xo(lt)[Ka - Mn - 1], Un[cn - Mn - 1]);
                        return;
                      }
                      if (Tu(it)) {
                        Eo(lt, it);
                        return;
                      }
                    }
                    Fn(lt, it), wn(lt, it, 0), wn(lt, it, 1), Eo(lt, it);
                  }
                }
                function Fn(lt, it) {
                  for (var Yt = Pf(it), Ia = 0, Qt = Yt; Ia < Qt.length; Ia++) {
                    var Ka = Qt[Ia], cn = bi(lt, Ka.escapedName);
                    cn && !e.some(cn.declarations, ub) && Dr(Jt(cn), Jt(Ka));
                  }
                }
                function wn(lt, it, Yt) {
                  for (var Ia = ot(lt, Yt), Qt = ot(it, Yt), Ka = Ia.length, cn = Qt.length, Un = Ka < cn ? Ka : cn, oa = !!(e.getObjectFlags(lt) & 262144), Mn = 0; Mn < Un; Mn++) Tn(v3(Ia[Ka - Un + Mn]), Qm(Qt[cn - Un + Mn]), oa);
                }
                function Tn(lt, it, Yt) {
                  if (!Yt) {
                    var Ia = u, Qt = it.declaration ? it.declaration.kind : 0;
                    u = u || Qt === 169 || Qt === 168 || Qt === 171, eb(lt, it, $i), u = Ia;
                  }
                  rb(lt, it, Dr);
                }
                function Eo(lt, it) {
                  var Yt = e.getObjectFlags(lt) & e.getObjectFlags(it) & 32 ? 8 : 0, Ia = Hn(it);
                  if (qh(lt)) for (var Qt = 0, Ka = Ia; Qt < Ka.length; Qt++) {
                    for (var cn = Ka[Qt], Un = [], oa = 0, Mn = uo(lt); oa < Mn.length; oa++) {
                      var Ln = Mn[oa];
                      if (an(om(Ln, 8576), cn.keyType)) {
                        var ci = Jt(Ln);
                        Un.push(Ln.flags & 16777216 ? $D(ci) : ci);
                      }
                    }
                    for (var Fr = 0, jt = Hn(lt); Fr < jt.length; Fr++) {
                      var Lt = jt[Fr];
                      an(Lt.keyType, cn.keyType) && Un.push(Lt.type);
                    }
                    Un.length && Qr(Pa(Un), cn.type, Yt);
                  }
                  for (var ea = 0, Kt = Ia; ea < Kt.length; ea++) {
                    var cn = Kt[ea], $t = nu(lt, cn.keyType);
                    $t && Qr($t.type, cn.type, Yt);
                  }
                }
              }
              function Yw(r, i) {
                return yr && i === Yi ? r === i : wf(r, i) || !!(i.flags & 4 && r.flags & 128 || i.flags & 8 && r.flags & 256);
              }
              function $w(r, i) {
                return !!(r.flags & 524288 && i.flags & 524288 && r.symbol && r.symbol === i.symbol || r.aliasSymbol && r.aliasTypeArguments && r.aliasSymbol === i.aliasSymbol);
              }
              function Zw(r) {
                var i = Tc(r);
                return !!i && fs(i.flags & 16777216 ? zm(i) : i, 406978556);
              }
              function Qp(r) {
                return !!(e.getObjectFlags(r) & 128);
              }
              function lb(r) {
                return !!(e.getObjectFlags(r) & 16512);
              }
              function e8(r) {
                if (r.length > 1) {
                  var i = e.filter(r, lb);
                  if (i.length) {
                    var t = Pa(i, 2);
                    return e.concatenate(e.filter(r, function(o) {
                      return !lb(o);
                    }), [t]);
                  }
                }
                return r;
              }
              function r8(r) {
                return r.priority & 416 ? Do(r.contraCandidates) : Tw(r.contraCandidates);
              }
              function i8(r, i) {
                var t = e8(r.candidates), o = Zw(r.typeParameter), s = !o && r.topLevel && (r.isFixed || !nb(yo(i), r.typeParameter)), u = o ? e.sameMap(t, jc) : s ? e.sameMap(t, Hp) : t, h = r.priority & 416 ? Pa(u, 2) : Sw(u);
                return $c(h);
              }
              function GE(r, i) {
                var t = r.inferences[i];
                if (!t.inferredType) {
                  var o = void 0, s = r.signature;
                  if (s) {
                    var u = t.candidates ? i8(t, s) : void 0;
                    if (t.contraCandidates) o = u && !(u.flags & 131072) && e.some(t.contraCandidates, function(Me) {
                      return E_(u, Me);
                    }) ? u : r8(t);
                    else if (u) o = u;
                    else if (r.flags & 1) o = Bt;
                    else {
                      var h = D_(t.typeParameter);
                      h && (o = un(h, LI(MI(r, i), r.nonFixingMapper)));
                    }
                  } else o = zE(t);
                  t.inferredType = o || fb(!!(r.flags & 2));
                  var z2 = Tc(t.typeParameter);
                  if (z2) {
                    var me = un(z2, r.nonFixingMapper);
                    (!o || !r.compareTypes(o, Rc(me, o))) && (t.inferredType = o = me);
                  }
                }
                return t.inferredType;
              }
              function fb(r) {
                return r ? Oe : gr;
              }
              function _b(r) {
                for (var i = [], t = 0; t < r.inferences.length; t++) i.push(GE(r, t));
                return i;
              }
              function HE(r) {
                switch (r.escapedText) {
                  case "document":
                  case "console":
                    return e.Diagnostics.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom;
                  case "$":
                    return ye.types ? e.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig : e.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery;
                  case "describe":
                  case "suite":
                  case "it":
                  case "test":
                    return ye.types ? e.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig : e.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha;
                  case "process":
                  case "require":
                  case "Buffer":
                  case "module":
                    return ye.types ? e.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig : e.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode;
                  case "Map":
                  case "Set":
                  case "Promise":
                  case "Symbol":
                  case "WeakMap":
                  case "WeakSet":
                  case "Iterator":
                  case "AsyncIterator":
                  case "SharedArrayBuffer":
                  case "Atomics":
                  case "AsyncIterable":
                  case "AsyncIterableIterator":
                  case "AsyncGenerator":
                  case "AsyncGeneratorFunction":
                  case "BigInt":
                  case "Reflect":
                  case "BigInt64Array":
                  case "BigUint64Array":
                    return e.Diagnostics.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_1_or_later;
                  case "await":
                    if (e.isCallExpression(r.parent)) return e.Diagnostics.Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function;
                  default:
                    return r.parent.kind === 297 ? e.Diagnostics.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer : e.Diagnostics.Cannot_find_name_0;
                }
              }
              function Dl(r) {
                var i = va(r);
                return i.resolvedSymbol || (i.resolvedSymbol = !e.nodeIsMissing(r) && es(r, r.escapedText, 1160127, HE(r), r, !e.isWriteOnlyAccess(r), false) || xe), i.resolvedSymbol;
              }
              function _m(r) {
                return !!e.findAncestor(r, function(i) {
                  return i.kind === 181 ? true : i.kind === 79 || i.kind === 161 ? false : "quit";
                });
              }
              function Xh(r, i, t, o) {
                switch (r.kind) {
                  case 79:
                    if (!e.isThisInTypeQuery(r)) {
                      var s = Dl(r);
                      return s !== xe ? "".concat(o ? A(o) : "-1", "|").concat(fu(i), "|").concat(fu(t), "|").concat(y(s)) : void 0;
                    }
                  case 108:
                    return "0|".concat(o ? A(o) : "-1", "|").concat(fu(i), "|").concat(fu(t));
                  case 230:
                  case 212:
                    return Xh(r.expression, i, t, o);
                  case 161:
                    var u = Xh(r.left, i, t, o);
                    return u && u + "." + r.right.escapedText;
                  case 206:
                  case 207:
                    var h = wd(r);
                    if (h !== void 0) {
                      var z2 = Xh(r.expression, i, t, o);
                      return z2 && z2 + "." + h;
                    }
                }
              }
              function zs(r, i) {
                switch (i.kind) {
                  case 212:
                  case 230:
                    return zs(r, i.expression);
                  case 221:
                    return e.isAssignmentExpression(i) && zs(r, i.left) || e.isBinaryExpression(i) && i.operatorToken.kind === 27 && zs(r, i.right);
                }
                switch (r.kind) {
                  case 231:
                    return i.kind === 231 && r.keywordToken === i.keywordToken && r.name.escapedText === i.name.escapedText;
                  case 79:
                  case 80:
                    return e.isThisInTypeQuery(r) ? i.kind === 108 : i.kind === 79 && Dl(r) === Dl(i) || (i.kind === 254 || i.kind === 203) && cu(Dl(r)) === Et(i);
                  case 108:
                    return i.kind === 108;
                  case 106:
                    return i.kind === 106;
                  case 230:
                  case 212:
                    return zs(r.expression, i);
                  case 206:
                  case 207:
                    var t = wd(r), o = e.isAccessExpression(i) ? wd(i) : void 0;
                    return t !== void 0 && o !== void 0 && o === t && zs(r.expression, i.expression);
                  case 161:
                    return e.isAccessExpression(i) && r.right.escapedText === wd(i) && zs(r.left, i.expression);
                  case 221:
                    return e.isBinaryExpression(r) && r.operatorToken.kind === 27 && zs(r.right, i);
                }
                return false;
              }
              function wd(r) {
                if (e.isPropertyAccessExpression(r)) return r.name.escapedText;
                if (e.isElementAccessExpression(r)) return t8(r);
                if (e.isBindingElement(r)) {
                  var i = sf(r);
                  return i ? e.escapeLeadingUnderscores(i) : void 0;
                }
                if (e.isParameter(r)) return "" + r.parent.parameters.indexOf(r);
              }
              function XE(r) {
                return r.flags & 8192 ? r.escapedName : r.flags & 384 ? e.escapeLeadingUnderscores("" + r.value) : void 0;
              }
              function t8(r) {
                if (e.isStringOrNumericLiteralLike(r.argumentExpression)) return e.escapeLeadingUnderscores(r.argumentExpression.text);
                if (e.isEntityNameExpression(r.argumentExpression)) {
                  var i = Ds(r.argumentExpression, 111551, true);
                  if (!i || !pv(i)) return;
                  var t = i.valueDeclaration;
                  if (t === void 0) return;
                  var o = Rl(t);
                  if (o) {
                    var s = XE(o);
                    if (s !== void 0) return s;
                  }
                  if (e.hasOnlyExpressionInitializer(t)) {
                    var u = e.getEffectiveInitializer(t);
                    return u && XE(Gs(u));
                  }
                }
              }
              function QE(r, i) {
                for (; e.isAccessExpression(r); ) if (r = r.expression, zs(r, i)) return true;
                return false;
              }
              function Ag(r, i) {
                for (; e.isOptionalChain(r); ) if (r = r.expression, zs(r, i)) return true;
                return false;
              }
              function lv(r, i) {
                if (r && r.flags & 1048576) {
                  var t = $v(r, i);
                  if (t && e.getCheckFlags(t) & 2) return t.isDiscriminantProperty === void 0 && (t.isDiscriminantProperty = (t.checkFlags & 192) === 192 && !rv(Jt(t))), !!t.isDiscriminantProperty;
                }
                return false;
              }
              function YE(r, i) {
                for (var t, o = 0, s = r; o < s.length; o++) {
                  var u = s[o];
                  if (lv(i, u.escapedName)) {
                    if (t) {
                      t.push(u);
                      continue;
                    }
                    t = [u];
                  }
                }
                return t;
              }
              function a8(r, i) {
                for (var t = new e.Map(), o = 0, s = function(Me) {
                  if (Me.flags & 61603840) {
                    var $e = da(Me, i);
                    if ($e) {
                      if (!Cg($e)) return { value: void 0 };
                      var tr = false;
                      Od($e, function(dr) {
                        var Dr = fu(jc(dr)), Qr = t.get(Dr);
                        Qr ? Qr !== gr && (t.set(Dr, gr), tr = true) : t.set(Dr, Me);
                      }), tr || o++;
                    }
                  }
                }, u = 0, h = r; u < h.length; u++) {
                  var z2 = h[u], me = s(z2);
                  if (typeof me == "object") return me.value;
                }
                return o >= 10 && o * 2 >= r.length ? t : void 0;
              }
              function Qh(r) {
                var i = r.types;
                if (!(i.length < 10 || e.getObjectFlags(r) & 32768 || e.countWhere(i, function(s) {
                  return !!(s.flags & 59506688);
                }) < 10)) {
                  if (r.keyPropertyName === void 0) {
                    var t = e.forEach(i, function(s) {
                      return s.flags & 59506688 ? e.forEach(uo(s), function(u) {
                        return Vl(Jt(u)) ? u.escapedName : void 0;
                      }) : void 0;
                    }), o = t && a8(i, t);
                    r.keyPropertyName = o ? t : "", r.constituentMap = o;
                  }
                  return r.keyPropertyName.length ? r.keyPropertyName : void 0;
                }
              }
              function Yh(r, i) {
                var t, o = (t = r.constituentMap) === null || t === void 0 ? void 0 : t.get(fu(jc(i)));
                return o !== gr ? o : void 0;
              }
              function $E(r, i) {
                var t = Qh(r), o = t && da(i, t);
                return o && Yh(r, o);
              }
              function n8(r, i) {
                var t = Qh(r), o = t && e.find(i.properties, function(u) {
                  return u.symbol && u.kind === 296 && u.symbol.escapedName === t && hy(u.initializer);
                }), s = o && Oy(o.initializer);
                return s && Yh(r, s);
              }
              function ZE(r, i) {
                return zs(r, i) || QE(r, i);
              }
              function eC(r, i) {
                if (r.arguments) for (var t = 0, o = r.arguments; t < o.length; t++) {
                  var s = o[t];
                  if (ZE(i, s)) return true;
                }
                return !!(r.expression.kind === 206 && ZE(i, r.expression.expression));
              }
              function pb(r) {
                return (!r.id || r.id < 0) && (r.id = Q, Q++), r.id;
              }
              function o8(r, i) {
                if (!(r.flags & 1048576)) return ao(r, i);
                for (var t = 0, o = r.types; t < o.length; t++) {
                  var s = o[t];
                  if (ao(s, i)) return true;
                }
                return false;
              }
              function s8(r, i) {
                if (r !== i) {
                  if (i.flags & 131072) return i;
                  var t = ec(r, function(o) {
                    return o8(i, o);
                  });
                  if (i.flags & 512 && Kp(i) && (t = Ss(t, Sg)), ao(i, t)) return t;
                }
                return r;
              }
              function db(r) {
                var i = Ru(r);
                return !!(i.callSignatures.length || i.constructSignatures.length || i.members.get("bind") && E_(r, br));
              }
              function cp(r, i) {
                i === void 0 && (i = false);
                var t = r.flags;
                if (t & 4) return Ye ? 16317953 : 16776705;
                if (t & 128) {
                  var o = r.value === "";
                  return Ye ? o ? 12123649 : 7929345 : o ? 12582401 : 16776705;
                }
                if (t & 40) return Ye ? 16317698 : 16776450;
                if (t & 256) {
                  var s = r.value === 0;
                  return Ye ? s ? 12123394 : 7929090 : s ? 12582146 : 16776450;
                }
                if (t & 64) return Ye ? 16317188 : 16775940;
                if (t & 2048) {
                  var s = QD(r);
                  return Ye ? s ? 12122884 : 7928580 : s ? 12581636 : 16775940;
                }
                return t & 16 ? Ye ? 16316168 : 16774920 : t & 528 ? Ye ? r === xt || r === ut ? 12121864 : 7927560 : r === xt || r === ut ? 12580616 : 16774920 : t & 524288 ? i ? 16768959 : e.getObjectFlags(r) & 16 && Of(r) ? Ye ? 16318463 : 16777215 : db(r) ? Ye ? 7880640 : 16728e3 : Ye ? 7888800 : 16736160 : t & 49152 ? 9830144 : t & 65536 ? 9363232 : t & 12288 ? Ye ? 7925520 : 16772880 : t & 67108864 ? Ye ? 7888800 : 16736160 : t & 131072 ? 0 : t & 465829888 ? sm(r) ? Ye ? 7929345 : 16776705 : cp(uc(r) || gr, i) : t & 1048576 ? e.reduceLeft(r.types, function(u, h) {
                  return u | cp(h, i);
                }, 0) : t & 2097152 ? (i || (i = fs(r, 131068)), c8(r, i)) : 16777215;
              }
              function c8(r, i) {
                for (var t = 0, o = 16777215, s = 0, u = r.types; s < u.length; s++) {
                  var h = u[s], z2 = cp(h, i);
                  t |= z2, o &= z2;
                }
                return t & 8256 | o & 16768959;
              }
              function Ks(r, i) {
                return ec(r, function(t) {
                  return (cp(t) & i) !== 0;
                });
              }
              function gb(r, i) {
                return i ? Pa([uu(r), Gs(i)]) : r;
              }
              function rC(r, i) {
                var t, o = Z_(i);
                if (!_f(o)) return Pe;
                var s = pf(o);
                return da(r, s) || fv((t = Xo(r, s)) === null || t === void 0 ? void 0 : t.type) || Pe;
              }
              function iC(r, i) {
                return gf(r, Eg) && xw(r, i) || fv(N_(65, r, Tr, void 0)) || Pe;
              }
              function fv(r) {
                return r && (ye.noUncheckedIndexedAccess ? Pa([r, Tr]) : r);
              }
              function tC(r) {
                return Zs(N_(65, r, Tr, void 0) || Pe);
              }
              function u8(r) {
                var i = r.parent.kind === 204 && mb(r.parent) || r.parent.kind === 296 && mb(r.parent.parent);
                return i ? gb(py(r), r.right) : Gs(r.right);
              }
              function mb(r) {
                return r.parent.kind === 221 && r.parent.left === r || r.parent.kind === 244 && r.parent.initializer === r;
              }
              function l8(r, i) {
                return iC(py(r), r.elements.indexOf(i));
              }
              function f8(r) {
                return tC(py(r.parent));
              }
              function aC(r) {
                return rC(py(r.parent), r.name);
              }
              function _8(r) {
                return gb(aC(r), r.objectAssignmentInitializer);
              }
              function py(r) {
                var i = r.parent;
                switch (i.kind) {
                  case 243:
                    return Li;
                  case 244:
                    return By(i) || Pe;
                  case 221:
                    return u8(i);
                  case 215:
                    return Tr;
                  case 204:
                    return l8(i, r);
                  case 225:
                    return f8(i);
                  case 296:
                    return aC(i);
                  case 297:
                    return _8(i);
                }
                return Pe;
              }
              function p8(r) {
                var i = r.parent, t = oC(i.parent), o = i.kind === 201 ? rC(t, r.propertyName || r.name) : r.dotDotDotToken ? tC(t) : iC(t, i.elements.indexOf(r));
                return gb(o, r.initializer);
              }
              function nC(r) {
                var i = va(r);
                return i.resolvedType || Gs(r);
              }
              function d8(r) {
                return r.initializer ? nC(r.initializer) : r.parent.parent.kind === 243 ? Li : r.parent.parent.kind === 244 && By(r.parent.parent) || Pe;
              }
              function oC(r) {
                return r.kind === 254 ? d8(r) : p8(r);
              }
              function g8(r) {
                return r.kind === 254 && r.initializer && Hf(r.initializer) || r.kind !== 203 && r.parent.kind === 221 && Hf(r.parent.right);
              }
              function Yp(r) {
                switch (r.kind) {
                  case 212:
                    return Yp(r.expression);
                  case 221:
                    switch (r.operatorToken.kind) {
                      case 63:
                      case 75:
                      case 76:
                      case 77:
                        return Yp(r.left);
                      case 27:
                        return Yp(r.right);
                    }
                }
                return r;
              }
              function sC(r) {
                var i = r.parent;
                return i.kind === 212 || i.kind === 221 && i.operatorToken.kind === 63 && i.left === r || i.kind === 221 && i.operatorToken.kind === 27 && i.right === r ? sC(i) : r;
              }
              function m8(r) {
                return r.kind === 289 ? jc(Gs(r.expression)) : ui;
              }
              function $h(r) {
                var i = va(r);
                if (!i.switchTypes) {
                  i.switchTypes = [];
                  for (var t = 0, o = r.caseBlock.clauses; t < o.length; t++) {
                    var s = o[t];
                    i.switchTypes.push(m8(s));
                  }
                }
                return i.switchTypes;
              }
              function cC(r, i) {
                for (var t = [], o = 0, s = r.caseBlock.clauses; o < s.length; o++) {
                  var u = s[o];
                  if (u.kind === 289) {
                    if (e.isStringLiteralLike(u.expression)) {
                      t.push(u.expression.text);
                      continue;
                    }
                    return e.emptyArray;
                  }
                  i && t.push(void 0);
                }
                return t;
              }
              function v8(r, i) {
                return r.flags & 1048576 ? !e.forEach(r.types, function(t) {
                  return !e.contains(i, t);
                }) : e.contains(i, r);
              }
              function dy(r, i) {
                return r === i || i.flags & 1048576 && y8(r, i);
              }
              function y8(r, i) {
                if (r.flags & 1048576) {
                  for (var t = 0, o = r.types; t < o.length; t++) {
                    var s = o[t];
                    if (!$f(i.types, s)) return false;
                  }
                  return true;
                }
                return r.flags & 1024 && cc(r) === i ? true : $f(i.types, r);
              }
              function Od(r, i) {
                return r.flags & 1048576 ? e.forEach(r.types, i) : i(r);
              }
              function rg(r, i) {
                return r.flags & 1048576 ? e.some(r.types, i) : i(r);
              }
              function gf(r, i) {
                return r.flags & 1048576 ? e.every(r.types, i) : i(r);
              }
              function h8(r, i) {
                return r.flags & 3145728 ? e.every(r.types, i) : i(r);
              }
              function ec(r, i) {
                if (r.flags & 1048576) {
                  var t = r.types, o = e.filter(t, i);
                  if (o === t) return r;
                  var s = r.origin, u = void 0;
                  if (s && s.flags & 1048576) {
                    var h = s.types, z2 = e.filter(h, function(me) {
                      return !!(me.flags & 1048576) || i(me);
                    });
                    if (h.length - z2.length === t.length - o.length) {
                      if (z2.length === 1) return z2[0];
                      u = fD(1048576, z2);
                    }
                  }
                  return pD(o, r.objectFlags, void 0, void 0, u);
                }
                return r.flags & 131072 || i(r) ? r : ui;
              }
              function Zh(r, i) {
                return ec(r, function(t) {
                  return t !== i;
                });
              }
              function D8(r) {
                return r.flags & 1048576 ? r.types.length : 1;
              }
              function Ss(r, i, t) {
                if (r.flags & 131072) return r;
                if (!(r.flags & 1048576)) return i(r);
                for (var o = r.origin, s = o && o.flags & 1048576 ? o.types : r.types, u, h = false, z2 = 0, me = s; z2 < me.length; z2++) {
                  var Me = me[z2], $e = Me.flags & 1048576 ? Ss(Me, i, t) : i(Me);
                  h || (h = Me !== $e), $e && (u ? u.push($e) : u = [$e]);
                }
                return h ? u && Pa(u, t ? 0 : 1) : r;
              }
              function uC(r, i, t, o) {
                return r.flags & 1048576 && t ? Pa(e.map(r.types, i), 1, t, o) : Ss(r, i);
              }
              function Ng(r, i) {
                return ec(r, function(t) {
                  return (t.flags & i) !== 0;
                });
              }
              function lC(r, i) {
                return fs(r, 134217804) && fs(i, 402655616) ? Ss(r, function(t) {
                  return t.flags & 4 ? Ng(i, 402653316) : sm(t) && !fs(i, 402653188) ? Ng(i, 128) : t.flags & 8 ? Ng(i, 264) : t.flags & 64 ? Ng(i, 2112) : t;
                }) : r;
              }
              function Pg(r) {
                return r.flags === 0;
              }
              function Fd(r) {
                return r.flags === 0 ? r.type : r;
              }
              function Ig(r, i) {
                return i ? { flags: 0, type: r.flags & 131072 ? Bt : r } : r;
              }
              function b8(r) {
                var i = tu(256);
                return i.elementType = r, i;
              }
              function vb(r) {
                return zr[r.id] || (zr[r.id] = b8(r));
              }
              function fC(r, i) {
                var t = fm(Kl(Oy(i)));
                return dy(t, r.elementType) ? r : vb(Pa([r.elementType, t]));
              }
              function S8(r) {
                return r.flags & 131072 ? So : Zs(r.flags & 1048576 ? Pa(r.types, 2) : r);
              }
              function T8(r) {
                return r.finalArrayType || (r.finalArrayType = S8(r.elementType));
              }
              function e0(r) {
                return e.getObjectFlags(r) & 256 ? T8(r) : r;
              }
              function x8(r) {
                return e.getObjectFlags(r) & 256 ? r.elementType : ui;
              }
              function E8(r) {
                for (var i = false, t = 0, o = r; t < o.length; t++) {
                  var s = o[t];
                  if (!(s.flags & 131072)) {
                    if (!(e.getObjectFlags(s) & 256)) return false;
                    i = true;
                  }
                }
                return i;
              }
              function _C(r) {
                var i = sC(r), t = i.parent, o = e.isPropertyAccessExpression(t) && (t.name.escapedText === "length" || t.parent.kind === 208 && e.isIdentifier(t.name) && e.isPushOrUnshiftIdentifier(t.name)), s = t.kind === 207 && t.expression === i && t.parent.kind === 221 && t.parent.operatorToken.kind === 63 && t.parent.left === t && !e.isAssignmentTarget(t.parent) && Ns(Gs(t.argumentExpression), 296);
                return o || s;
              }
              function C8(r) {
                return (e.isVariableDeclaration(r) || e.isPropertyDeclaration(r) || e.isPropertySignature(r) || e.isParameter(r)) && !!(e.getEffectiveTypeAnnotationNode(r) || e.isInJSFile(r) && e.hasInitializer(r) && r.initializer && e.isFunctionExpressionOrArrowFunction(r.initializer) && e.getEffectiveReturnTypeNode(r.initializer));
              }
              function r0(r, i) {
                if (r.flags & 8752) return Jt(r);
                if (r.flags & 7) {
                  if (e.getCheckFlags(r) & 262144) {
                    var t = r.syntheticOrigin;
                    if (t && r0(t)) return Jt(r);
                  }
                  var o = r.valueDeclaration;
                  if (o) {
                    if (C8(o)) return Jt(r);
                    if (e.isVariableDeclaration(o) && o.parent.parent.kind === 244) {
                      var s = o.parent.parent, u = gy(s.expression, void 0);
                      if (u) {
                        var h = s.awaitModifier ? 15 : 13;
                        return N_(h, u, Tr, void 0);
                      }
                    }
                    i && e.addRelatedInfo(i, e.createDiagnosticForNode(o, e.Diagnostics._0_needs_an_explicit_type_annotation, tn(r)));
                  }
                }
              }
              function gy(r, i) {
                if (!(r.flags & 33554432)) switch (r.kind) {
                  case 79:
                    var t = cu(Dl(r));
                    return r0(t.flags & 2097152 ? Ps(t) : t, i);
                  case 108:
                    return q8(r);
                  case 106:
                    return Sb(r);
                  case 206: {
                    var o = gy(r.expression, i);
                    if (o) {
                      var s = r.name, u = void 0;
                      if (e.isPrivateIdentifier(s)) {
                        if (!o.symbol) return;
                        u = bi(o, e.getSymbolNameForPrivateIdentifier(o.symbol, s.escapedText));
                      } else u = bi(o, s.escapedText);
                      return u && r0(u, i);
                    }
                    return;
                  }
                  case 212:
                    return gy(r.expression, i);
                }
              }
              function i0(r) {
                var i = va(r), t = i.effectsSignature;
                if (t === void 0) {
                  var o = void 0;
                  r.parent.kind === 238 ? o = gy(r.expression, void 0) : r.expression.kind !== 106 && (e.isOptionalChain(r) ? o = bl(cv(yn(r.expression), r.expression), r.expression) : o = gm(r.expression));
                  var s = ot(o && $s(o) || gr, 0), u = s.length === 1 && !s[0].typeParameters ? s[0] : e.some(s, pC) ? Mg(r) : void 0;
                  t = i.effectsSignature = u && pC(u) ? u : Wn;
                }
                return t === Wn ? void 0 : t;
              }
              function pC(r) {
                return !!(Yc(r) || r.declaration && (yg(r.declaration) || gr).flags & 131072);
              }
              function k8(r, i) {
                if (r.kind === 1 || r.kind === 3) return i.arguments[r.parameterIndex];
                var t = e.skipParentheses(i.expression);
                return e.isAccessExpression(t) ? e.skipParentheses(t.expression) : void 0;
              }
              function A8(r) {
                var i = e.findAncestor(r, e.isFunctionOrModuleBlock), t = e.getSourceFileOfNode(r), o = e.getSpanOfTokenAtPosition(t, i.statements.pos);
                rn.add(e.createFileDiagnostic(t, o.start, o.length, e.Diagnostics.The_containing_function_or_module_body_is_too_large_for_control_flow_analysis));
              }
              function my(r) {
                var i = t0(r, false);
                return su = r, tl = i, i;
              }
              function vy(r) {
                var i = e.skipParentheses(r, true);
                return i.kind === 95 || i.kind === 221 && (i.operatorToken.kind === 55 && (vy(i.left) || vy(i.right)) || i.operatorToken.kind === 56 && vy(i.left) && vy(i.right));
              }
              function t0(r, i) {
                for (; ; ) {
                  if (r === su) return tl;
                  var t = r.flags;
                  if (t & 4096) {
                    if (!i) {
                      var o = pb(r), s = bt[o];
                      return s !== void 0 ? s : bt[o] = t0(r, true);
                    }
                    i = false;
                  }
                  if (t & 368) r = r.antecedent;
                  else if (t & 512) {
                    var u = i0(r.node);
                    if (u) {
                      var h = Yc(u);
                      if (h && h.kind === 3 && !h.type) {
                        var z2 = r.node.arguments[h.parameterIndex];
                        if (z2 && vy(z2)) return false;
                      }
                      if (yo(u).flags & 131072) return false;
                    }
                    r = r.antecedent;
                  } else {
                    if (t & 4) return e.some(r.antecedents, function(dr) {
                      return t0(dr, false);
                    });
                    if (t & 8) {
                      var me = r.antecedents;
                      if (me === void 0 || me.length === 0) return false;
                      r = me[0];
                    } else if (t & 128) {
                      if (r.clauseStart === r.clauseEnd && Lk(r.switchStatement)) return false;
                      r = r.antecedent;
                    } else if (t & 1024) {
                      su = void 0;
                      var Me = r.target, $e = Me.antecedents;
                      Me.antecedents = r.antecedents;
                      var tr = t0(r.antecedent, false);
                      return Me.antecedents = $e, tr;
                    } else return !(t & 1);
                  }
                }
              }
              function a0(r, i) {
                for (; ; ) {
                  var t = r.flags;
                  if (t & 4096) {
                    if (!i) {
                      var o = pb(r), s = ia[o];
                      return s !== void 0 ? s : ia[o] = a0(r, true);
                    }
                    i = false;
                  }
                  if (t & 496) r = r.antecedent;
                  else if (t & 512) {
                    if (r.node.expression.kind === 106) return true;
                    r = r.antecedent;
                  } else {
                    if (t & 4) return e.every(r.antecedents, function(me) {
                      return a0(me, false);
                    });
                    if (t & 8) r = r.antecedents[0];
                    else if (t & 1024) {
                      var u = r.target, h = u.antecedents;
                      u.antecedents = r.antecedents;
                      var z2 = a0(r.antecedent, false);
                      return u.antecedents = h, z2;
                    } else return !!(t & 1);
                  }
                }
              }
              function dC(r) {
                switch (r.kind) {
                  case 79: {
                    var i = Dl(r);
                    return pv(i) || e.isParameterOrCatchClauseVariable(i) && !n0(i);
                  }
                  case 206:
                  case 207:
                    return dC(r.expression) && Zu(va(r).resolvedSymbol || xe);
                }
                return false;
              }
              function up(r, i, t, o, s) {
                t === void 0 && (t = i), s === void 0 && (s = r.flowNode);
                var u, h = false, z2 = 0;
                if (Bs) return Pe;
                if (!s) return i;
                xc++;
                var me = Ms, Me = Fd(dr(s));
                Ms = me;
                var $e = e.getObjectFlags(Me) & 256 && _C(r) ? So : e0(Me);
                if ($e === Ai || r.parent && r.parent.kind === 230 && !($e.flags & 131072) && Ks($e, 2097152).flags & 131072) return i;
                return $e === Vr ? gr : $e;
                function tr() {
                  return h ? u : (h = true, u = Xh(r, i, t, o));
                }
                function dr(Yr) {
                  if (z2 === 2e3) return e.tracing === null || e.tracing === void 0 || e.tracing.instant("checkTypes", "getTypeAtFlowNode_DepthLimit", { flowId: Yr.id }), Bs = true, A8(r), Pe;
                  z2++;
                  for (var Ni; ; ) {
                    var Hi = Yr.flags;
                    if (Hi & 4096) {
                      for (var _t = me; _t < Ms; _t++) if (tt[_t] === Yr) return z2--, kt[_t];
                      Ni = Yr;
                    }
                    var gt = void 0;
                    if (Hi & 16) {
                      if (gt = Qr(Yr), !gt) {
                        Yr = Yr.antecedent;
                        continue;
                      }
                    } else if (Hi & 512) {
                      if (gt = Ti(Yr), !gt) {
                        Yr = Yr.antecedent;
                        continue;
                      }
                    } else if (Hi & 96) gt = $i(Yr);
                    else if (Hi & 128) gt = Zi(Yr);
                    else if (Hi & 12) {
                      if (Yr.antecedents.length === 1) {
                        Yr = Yr.antecedents[0];
                        continue;
                      }
                      gt = Hi & 4 ? qt(Yr) : Nt(Yr);
                    } else if (Hi & 256) {
                      if (gt = Ci(Yr), !gt) {
                        Yr = Yr.antecedent;
                        continue;
                      }
                    } else if (Hi & 1024) {
                      var Vt = Yr.target, Fa = Vt.antecedents;
                      Vt.antecedents = Yr.antecedents, gt = dr(Yr.antecedent), Vt.antecedents = Fa;
                    } else if (Hi & 2) {
                      var on = Yr.node;
                      if (on && on !== o && r.kind !== 206 && r.kind !== 207 && r.kind !== 108) {
                        Yr = on.flowNode;
                        continue;
                      }
                      gt = t;
                    } else gt = kv(i);
                    return Ni && (tt[Ms] = Ni, kt[Ms] = gt, Ms++), z2--, gt;
                  }
                }
                function Dr(Yr) {
                  var Ni = Yr.node;
                  return yb(Ni.kind === 254 || Ni.kind === 203 ? oC(Ni) : py(Ni), r);
                }
                function Qr(Yr) {
                  var Ni = Yr.node;
                  if (zs(r, Ni)) {
                    if (!my(Yr)) return Ai;
                    if (e.getAssignmentTargetKind(Ni) === 2) {
                      var Hi = dr(Yr.antecedent);
                      return Ig(Kl(Fd(Hi)), Pg(Hi));
                    }
                    if (i === nr || i === So) {
                      if (g8(Ni)) return vb(ui);
                      var _t = Hp(Dr(Yr));
                      return ao(_t, i) ? _t : mo;
                    }
                    return i.flags & 1048576 ? s8(i, Dr(Yr)) : i;
                  }
                  if (QE(r, Ni)) {
                    if (!my(Yr)) return Ai;
                    if (e.isVariableDeclaration(Ni) && (e.isInJSFile(Ni) || e.isVarConst(Ni))) {
                      var gt = e.getDeclaredExpandoInitializer(Ni);
                      if (gt && (gt.kind === 213 || gt.kind === 214)) return dr(Yr.antecedent);
                    }
                    return i;
                  }
                  if (e.isVariableDeclaration(Ni) && Ni.parent.parent.kind === 243 && zs(r, Ni.parent.parent.expression)) return jb(Fd(dr(Yr.antecedent)));
                }
                function li(Yr, Ni) {
                  var Hi = e.skipParentheses(Ni, true);
                  if (Hi.kind === 95) return Ai;
                  if (Hi.kind === 221) {
                    if (Hi.operatorToken.kind === 55) return li(li(Yr, Hi.left), Hi.right);
                    if (Hi.operatorToken.kind === 56) return Pa([li(Yr, Hi.left), li(Yr, Hi.right)]);
                  }
                  return $t(Yr, Hi, true);
                }
                function Ti(Yr) {
                  var Ni = i0(Yr.node);
                  if (Ni) {
                    var Hi = Yc(Ni);
                    if (Hi && (Hi.kind === 2 || Hi.kind === 3)) {
                      var _t = dr(Yr.antecedent), gt = e0(Fd(_t)), Vt = Hi.type ? Kt(gt, Hi, Yr.node, true) : Hi.kind === 3 && Hi.parameterIndex >= 0 && Hi.parameterIndex < Yr.node.arguments.length ? li(gt, Yr.node.arguments[Hi.parameterIndex]) : gt;
                      return Vt === gt ? _t : Ig(Vt, Pg(_t));
                    }
                    if (yo(Ni).flags & 131072) return Ai;
                  }
                }
                function Ci(Yr) {
                  if (i === nr || i === So) {
                    var Ni = Yr.node, Hi = Ni.kind === 208 ? Ni.expression.expression : Ni.left.expression;
                    if (zs(r, Yp(Hi))) {
                      var _t = dr(Yr.antecedent), gt = Fd(_t);
                      if (e.getObjectFlags(gt) & 256) {
                        var Vt = gt;
                        if (Ni.kind === 208) for (var Fa = 0, on = Ni.arguments; Fa < on.length; Fa++) {
                          var zn = on[Fa];
                          Vt = fC(Vt, zn);
                        }
                        else {
                          var Ga = Oy(Ni.left.argumentExpression);
                          Ns(Ga, 296) && (Vt = fC(Vt, Ni.right));
                        }
                        return Vt === gt ? _t : Ig(Vt, Pg(_t));
                      }
                      return _t;
                    }
                  }
                }
                function $i(Yr) {
                  var Ni = dr(Yr.antecedent), Hi = Fd(Ni);
                  if (Hi.flags & 131072) return Ni;
                  var _t = (Yr.flags & 32) !== 0, gt = e0(Hi), Vt = $t(gt, Yr.node, _t);
                  return Vt === gt ? Ni : Ig(Vt, Pg(Ni));
                }
                function Zi(Yr) {
                  var Ni = Yr.switchStatement.expression, Hi = dr(Yr.antecedent), _t = Fd(Hi);
                  if (zs(r, Ni)) _t = Un(_t, Yr.switchStatement, Yr.clauseStart, Yr.clauseEnd);
                  else if (Ni.kind === 216 && zs(r, Ni.expression)) _t = Ln(_t, Yr.switchStatement, Yr.clauseStart, Yr.clauseEnd);
                  else {
                    Ye && (Ag(Ni, r) ? _t = cn(_t, Yr.switchStatement, Yr.clauseStart, Yr.clauseEnd, function(Vt) {
                      return !(Vt.flags & 163840);
                    }) : Ni.kind === 216 && Ag(Ni.expression, r) && (_t = cn(_t, Yr.switchStatement, Yr.clauseStart, Yr.clauseEnd, function(Vt) {
                      return !(Vt.flags & 131072 || Vt.flags & 128 && Vt.value === "undefined");
                    })));
                    var gt = Sn(Ni, _t);
                    gt && (_t = wn(_t, gt, Yr.switchStatement, Yr.clauseStart, Yr.clauseEnd));
                  }
                  return Ig(_t, Pg(Hi));
                }
                function qt(Yr) {
                  for (var Ni = [], Hi = false, _t = false, gt, Vt = 0, Fa = Yr.antecedents; Vt < Fa.length; Vt++) {
                    var on = Fa[Vt];
                    if (!gt && on.flags & 128 && on.clauseStart === on.clauseEnd) {
                      gt = on;
                      continue;
                    }
                    var zn = dr(on), Ga = Fd(zn);
                    if (Ga === i && i === t) return Ga;
                    e.pushIfUnique(Ni, Ga), dy(Ga, i) || (Hi = true), Pg(zn) && (_t = true);
                  }
                  if (gt) {
                    var zn = dr(gt), Ga = Fd(zn);
                    if (!e.contains(Ni, Ga) && !Lk(gt.switchStatement)) {
                      if (Ga === i && i === t) return Ga;
                      Ni.push(Ga), dy(Ga, i) || (Hi = true), Pg(zn) && (_t = true);
                    }
                  }
                  return Ig(Ra(Ni, Hi ? 2 : 1), _t);
                }
                function Nt(Yr) {
                  var Ni = pb(Yr), Hi = vc[Ni] || (vc[Ni] = new e.Map()), _t = tr();
                  if (!_t) return i;
                  var gt = Hi.get(_t);
                  if (gt) return gt;
                  for (var Vt = ko; Vt < Ao; Vt++) if (Kr[Vt] === Yr && _i[Vt] === _t && Ei[Vt].length) return Ig(Ra(Ei[Vt], 1), true);
                  for (var Fa = [], on = false, zn, Ga = 0, Qn = Yr.antecedents; Ga < Qn.length; Ga++) {
                    var wo = Qn[Ga], Po = void 0;
                    if (!zn) Po = zn = dr(wo);
                    else {
                      Kr[Ao] = Yr, _i[Ao] = _t, Ei[Ao] = Fa, Ao++;
                      var Uo = Zc;
                      Zc = void 0, Po = dr(wo), Zc = Uo, Ao--;
                      var Rs = Hi.get(_t);
                      if (Rs) return Rs;
                    }
                    var Fs = Fd(Po);
                    if (e.pushIfUnique(Fa, Fs), dy(Fs, i) || (on = true), Fs === i) break;
                  }
                  var rc = Ra(Fa, on ? 2 : 1);
                  return Pg(zn) ? Ig(rc, true) : (Hi.set(_t, rc), rc);
                }
                function Ra(Yr, Ni) {
                  if (E8(Yr)) return vb(Pa(e.map(Yr, x8)));
                  var Hi = Pa(e.sameMap(Yr, e0), Ni);
                  return Hi !== i && Hi.flags & i.flags & 1048576 && e.arraysEqual(Hi.types, i.types) ? i : Hi;
                }
                function ca(Yr) {
                  if (e.isBindingPattern(r) || e.isFunctionExpressionOrArrowFunction(r) || e.isObjectLiteralMethod(r)) {
                    if (e.isIdentifier(Yr)) {
                      var Ni = Dl(Yr), Hi = Ni.valueDeclaration;
                      if (Hi && (e.isBindingElement(Hi) || e.isParameter(Hi)) && r === Hi.parent && !Hi.initializer && !Hi.dotDotDotToken) return Hi;
                    }
                  } else if (e.isAccessExpression(Yr)) {
                    if (zs(r, Yr.expression)) return Yr;
                  } else if (e.isIdentifier(Yr)) {
                    var Ni = Dl(Yr);
                    if (pv(Ni)) {
                      var Hi = Ni.valueDeclaration;
                      if (e.isVariableDeclaration(Hi) && !Hi.type && Hi.initializer && e.isAccessExpression(Hi.initializer) && zs(r, Hi.initializer.expression)) return Hi.initializer;
                      if (e.isBindingElement(Hi) && !Hi.initializer) {
                        var _t = Hi.parent.parent;
                        if (e.isVariableDeclaration(_t) && !_t.type && _t.initializer && (e.isIdentifier(_t.initializer) || e.isAccessExpression(_t.initializer)) && zs(r, _t.initializer)) return Hi;
                      }
                    }
                  }
                }
                function Sn(Yr, Ni) {
                  var Hi = i.flags & 1048576 ? i : Ni;
                  if (Hi.flags & 1048576) {
                    var _t = ca(Yr);
                    if (_t) {
                      var gt = wd(_t);
                      if (gt && lv(Hi, gt)) return _t;
                    }
                  }
                }
                function ja(Yr, Ni, Hi) {
                  var _t = wd(Ni);
                  if (_t === void 0) return Yr;
                  var gt = Ye && e.isOptionalChain(Ni) && fs(Yr, 98304), Vt = da(gt ? Ks(Yr, 2097152) : Yr, _t);
                  if (!Vt) return Yr;
                  Vt = gt ? i_(Vt) : Vt;
                  var Fa = Hi(Vt);
                  return ec(Yr, function(on) {
                    var zn = Ha(on, _t);
                    return !(Fa.flags & 131072) && cm(Fa, zn);
                  });
                }
                function Fn(Yr, Ni, Hi, _t, gt) {
                  if ((Hi === 36 || Hi === 37) && Yr.flags & 1048576) {
                    var Vt = Qh(Yr);
                    if (Vt && Vt === wd(Ni)) {
                      var Fa = Yh(Yr, Gs(_t));
                      if (Fa) return Hi === (gt ? 36 : 37) ? Fa : Vl(da(Fa, Vt) || gr) ? Zh(Yr, Fa) : Yr;
                    }
                  }
                  return ja(Yr, Ni, function(on) {
                    return Qt(on, Hi, _t, gt);
                  });
                }
                function wn(Yr, Ni, Hi, _t, gt) {
                  if (_t < gt && Yr.flags & 1048576 && Qh(Yr) === wd(Ni)) {
                    var Vt = $h(Hi).slice(_t, gt), Fa = Pa(e.map(Vt, function(on) {
                      return Yh(Yr, on) || gr;
                    }));
                    if (Fa !== gr) return Fa;
                  }
                  return ja(Yr, Ni, function(on) {
                    return Un(on, Hi, _t, gt);
                  });
                }
                function Tn(Yr, Ni, Hi) {
                  if (zs(r, Ni)) return Yr.flags & 2 && Hi ? Vr : Ks(Yr, Hi ? 4194304 : 8388608);
                  Ye && Hi && Ag(Ni, r) && (Yr = Ks(Yr, 2097152));
                  var _t = Sn(Ni, Yr);
                  return _t ? ja(Yr, _t, function(gt) {
                    return Ks(gt, Hi ? 4194304 : 8388608);
                  }) : Yr;
                }
                function Eo(Yr, Ni, Hi) {
                  var _t = bi(Yr, Ni);
                  return _t ? _t.flags & 16777216 ? true : Hi : Xo(Yr, Ni) ? true : !Hi;
                }
                function lt(Yr, Ni, Hi) {
                  return Yr.flags & 1048576 || Yr.flags & 524288 && i !== Yr || e.isThisTypeParameter(Yr) || Yr.flags & 2097152 && e.every(Yr.types, function(_t) {
                    return _t.symbol !== pe;
                  }) ? ec(Yr, function(_t) {
                    return Eo(_t, Ni, Hi);
                  }) : Yr;
                }
                function it(Yr, Ni, Hi) {
                  switch (Ni.operatorToken.kind) {
                    case 63:
                    case 75:
                    case 76:
                    case 77:
                      return Tn($t(Yr, Ni.right, Hi), Ni.left, Hi);
                    case 34:
                    case 35:
                    case 36:
                    case 37:
                      var _t = Ni.operatorToken.kind, gt = Yp(Ni.left), Vt = Yp(Ni.right);
                      if (gt.kind === 216 && e.isStringLiteralLike(Vt)) return Ka(Yr, gt, _t, Vt, Hi);
                      if (Vt.kind === 216 && e.isStringLiteralLike(gt)) return Ka(Yr, Vt, _t, gt, Hi);
                      if (zs(r, gt)) return Qt(Yr, _t, Vt, Hi);
                      if (zs(r, Vt)) return Qt(Yr, _t, gt, Hi);
                      Ye && (Ag(gt, r) ? Yr = Ia(Yr, _t, Vt, Hi) : Ag(Vt, r) && (Yr = Ia(Yr, _t, gt, Hi)));
                      var Fa = Sn(gt, Yr);
                      if (Fa) return Fn(Yr, Fa, _t, Vt, Hi);
                      var on = Sn(Vt, Yr);
                      if (on) return Fn(Yr, on, _t, gt, Hi);
                      if (ci(gt)) return Fr(Yr, _t, Vt, Hi);
                      if (ci(Vt)) return Fr(Yr, _t, gt, Hi);
                      break;
                    case 102:
                      return jt(Yr, Ni, Hi);
                    case 101:
                      if (e.isPrivateIdentifier(Ni.left)) return Yt(Yr, Ni, Hi);
                      var zn = Yp(Ni.right), Ga = Bd(Ni.left);
                      if (Ga.flags & 128) {
                        var Qn = e.escapeLeadingUnderscores(Ga.value);
                        if (Wh(Yr) && e.isAccessExpression(r) && zs(r.expression, zn) && wd(r) === Qn) return Ks(Yr, Hi ? 524288 : 65536);
                        if (zs(r, zn)) return lt(Yr, Qn, Hi);
                      }
                      break;
                    case 27:
                      return $t(Yr, Ni.right, Hi);
                    case 55:
                      return Hi ? $t($t(Yr, Ni.left, true), Ni.right, true) : Pa([$t(Yr, Ni.left, false), $t(Yr, Ni.right, false)]);
                    case 56:
                      return Hi ? Pa([$t(Yr, Ni.left, true), $t(Yr, Ni.right, true)]) : $t($t(Yr, Ni.left, false), Ni.right, false);
                  }
                  return Yr;
                }
                function Yt(Yr, Ni, Hi) {
                  var _t = Yp(Ni.right);
                  if (!zs(r, _t)) return Yr;
                  e.Debug.assertNode(Ni.left, e.isPrivateIdentifier);
                  var gt = m0(Ni.left);
                  if (gt === void 0) return Yr;
                  var Vt = gt.parent, Fa = e.hasStaticModifier(e.Debug.checkDefined(gt.valueDeclaration, "should always have a declaration")) ? Jt(Vt) : go(Vt);
                  return Lt(Yr, Fa, Hi, xg);
                }
                function Ia(Yr, Ni, Hi, _t) {
                  var gt = Ni === 34 || Ni === 36, Vt = Ni === 34 || Ni === 35 ? 98304 : 32768, Fa = Gs(Hi), on = gt !== _t && gf(Fa, function(zn) {
                    return !!(zn.flags & Vt);
                  }) || gt === _t && gf(Fa, function(zn) {
                    return !(zn.flags & (3 | Vt));
                  });
                  return on ? Ks(Yr, 2097152) : Yr;
                }
                function Qt(Yr, Ni, Hi, _t) {
                  if (Yr.flags & 1) return Yr;
                  (Ni === 35 || Ni === 37) && (_t = !_t);
                  var gt = Gs(Hi);
                  if (_t && Yr.flags & 2 && (Ni === 34 || Ni === 35) && gt.flags & 65536) return Pa([Wi, Tr]);
                  if (Yr.flags & 2 && _t && (Ni === 36 || Ni === 37)) return gt.flags & 67239932 ? gt : gt.flags & 524288 ? Oi : Yr;
                  if (gt.flags & 98304) {
                    if (!Ye) return Yr;
                    var Vt = Ni === 34 || Ni === 35, Fa = Vt ? _t ? 262144 : 2097152 : gt.flags & 65536 ? _t ? 131072 : 1048576 : _t ? 65536 : 524288;
                    return Yr.flags & 2 && Fa & 3145728 ? Vr : Ks(Yr, Fa);
                  }
                  if (_t) {
                    var on = Ni === 34 ? function(zn) {
                      return Oh(zn, gt) || Ow(zn, gt);
                    } : function(zn) {
                      return Oh(zn, gt);
                    };
                    return lC(ec(Yr, on), gt);
                  }
                  return Vl(gt) ? ec(Yr, function(zn) {
                    return !(NE(zn) && Oh(zn, gt));
                  }) : Yr;
                }
                function Ka(Yr, Ni, Hi, _t, gt) {
                  (Hi === 35 || Hi === 37) && (gt = !gt);
                  var Vt = Yp(Ni.expression);
                  if (!zs(r, Vt)) return Ye && Ag(Vt, r) && gt === (_t.text !== "undefined") ? Ks(Yr, 2097152) : Yr;
                  if (Yr.flags & 1 && _t.text === "function") return Yr;
                  if (gt && Yr.flags & 2 && _t.text === "object") return Yr === Vr ? Oi : Pa([Oi, Wi]);
                  var Fa = gt ? G.get(_t.text) || 128 : oe.get(_t.text) || 32768, on = oa(Yr, _t.text);
                  return Ks(gt && on ? Ss(Yr, Mn(on)) : Yr, Fa);
                }
                function cn(Yr, Ni, Hi, _t, gt) {
                  var Vt = Hi !== _t && e.every($h(Ni).slice(Hi, _t), gt);
                  return Vt ? Ks(Yr, 2097152) : Yr;
                }
                function Un(Yr, Ni, Hi, _t) {
                  var gt = $h(Ni);
                  if (!gt.length) return Yr;
                  var Vt = gt.slice(Hi, _t), Fa = Hi === _t || e.contains(Vt, ui);
                  if (Yr.flags & 2 && !Fa) {
                    for (var on = void 0, zn = 0; zn < Vt.length; zn += 1) {
                      var Ga = Vt[zn];
                      if (Ga.flags & 67239932) on !== void 0 && on.push(Ga);
                      else if (Ga.flags & 524288) on === void 0 && (on = Vt.slice(0, zn)), on.push(Oi);
                      else return Yr;
                    }
                    return Pa(on === void 0 ? Vt : on);
                  }
                  var Qn = Pa(Vt), wo = Qn.flags & 131072 ? ui : lC(ec(Yr, function(Uo) {
                    return Oh(Qn, Uo);
                  }), Qn);
                  if (!Fa) return wo;
                  var Po = ec(Yr, function(Uo) {
                    return !(NE(Uo) && e.contains(gt, jc(Cw(Uo))));
                  });
                  return wo.flags & 131072 ? Po : Pa([wo, Po]);
                }
                function oa(Yr, Ni) {
                  switch (Ni) {
                    case "function":
                      return Yr.flags & 1 ? Yr : br;
                    case "object":
                      return Yr.flags & 2 ? Pa([Oi, Wi]) : Yr;
                    default:
                      return Mo.get(Ni);
                  }
                }
                function Mn(Yr) {
                  return function(Ni) {
                    if (E_(Ni, Yr)) return Ni;
                    if (E_(Yr, Ni)) return Yr;
                    if (Ni.flags & 465829888) {
                      var Hi = uc(Ni) || Oe;
                      if (E_(Yr, Hi)) return Do([Ni, Yr]);
                    }
                    return Ni;
                  };
                }
                function Ln(Yr, Ni, Hi, _t) {
                  var gt = cC(Ni, true);
                  if (!gt.length) return Yr;
                  var Vt = e.findIndex(gt, function(Uo) {
                    return Uo === void 0;
                  }), Fa = Hi === _t || Vt >= Hi && Vt < _t, on, zn;
                  if (Vt > -1) {
                    var Ga = gt.filter(function(Uo) {
                      return Uo !== void 0;
                    }), Qn = Vt < Hi ? Hi - 1 : Hi, wo = Vt < _t ? _t - 1 : _t;
                    on = Ga.slice(Qn, wo), zn = oS(Qn, wo, Ga, Fa);
                  } else on = gt.slice(Hi, _t), zn = oS(Hi, _t, gt, Fa);
                  if (Fa) return ec(Yr, function(Uo) {
                    return (cp(Uo) & zn) === zn;
                  });
                  var Po = Ks(Pa(on.map(function(Uo) {
                    return oa(Yr, Uo) || Yr;
                  })), zn);
                  return Ks(Ss(Yr, Mn(Po)), zn);
                }
                function ci(Yr) {
                  return (e.isPropertyAccessExpression(Yr) && e.idText(Yr.name) === "constructor" || e.isElementAccessExpression(Yr) && e.isStringLiteralLike(Yr.argumentExpression) && Yr.argumentExpression.text === "constructor") && zs(r, Yr.expression);
                }
                function Fr(Yr, Ni, Hi, _t) {
                  if (_t ? Ni !== 34 && Ni !== 36 : Ni !== 35 && Ni !== 37) return Yr;
                  var gt = Gs(Hi);
                  if (!JS(gt) && !qd(gt)) return Yr;
                  var Vt = bi(gt, "prototype");
                  if (!Vt) return Yr;
                  var Fa = Jt(Vt), on = ta(Fa) ? void 0 : Fa;
                  if (!on || on === qe || on === br) return Yr;
                  if (ta(Yr)) return on;
                  return ec(Yr, function(Ga) {
                    return zn(Ga, on);
                  });
                  function zn(Ga, Qn) {
                    return Ga.flags & 524288 && e.getObjectFlags(Ga) & 1 || Qn.flags & 524288 && e.getObjectFlags(Qn) & 1 ? Ga.symbol === Qn.symbol : E_(Ga, Qn);
                  }
                }
                function jt(Yr, Ni, Hi) {
                  var _t = Yp(Ni.left);
                  if (!zs(r, _t)) return Hi && Ye && Ag(_t, r) ? Ks(Yr, 2097152) : Yr;
                  var gt = Gs(Ni.right);
                  if (!xg(gt, br)) return Yr;
                  var Vt, Fa = bi(gt, "prototype");
                  if (Fa) {
                    var on = Jt(Fa);
                    ta(on) || (Vt = on);
                  }
                  if (ta(Yr) && (Vt === qe || Vt === br)) return Yr;
                  if (!Vt) {
                    var zn = ot(gt, 1);
                    Vt = zn.length ? Pa(e.map(zn, function(Qn) {
                      return yo(Qm(Qn));
                    })) : Ba;
                  }
                  if (!Hi && gt.flags & 1048576) {
                    var Ga = e.find(gt.types, function(Qn) {
                      return !qd(Qn);
                    });
                    if (!Ga) return Yr;
                  }
                  return Lt(Yr, Vt, Hi, xg);
                }
                function Lt(Yr, Ni, Hi, _t) {
                  if (!Hi) return ec(Yr, function(Vt) {
                    return !_t(Vt, Ni);
                  });
                  if (Yr.flags & 1048576) {
                    var gt = ec(Yr, function(Vt) {
                      return _t(Vt, Ni);
                    });
                    if (!(gt.flags & 131072)) return gt;
                  }
                  return E_(Ni, Yr) ? Ni : ao(Yr, Ni) ? Yr : ao(Ni, Yr) ? Ni : Do([Yr, Ni]);
                }
                function ea(Yr, Ni, Hi) {
                  if (eC(Ni, r)) {
                    var _t = Hi || !e.isCallChain(Ni) ? i0(Ni) : void 0, gt = _t && Yc(_t);
                    if (gt && (gt.kind === 0 || gt.kind === 1)) return Kt(Yr, gt, Ni, Hi);
                  }
                  if (Wh(Yr) && e.isAccessExpression(r) && e.isPropertyAccessExpression(Ni.expression)) {
                    var Vt = Ni.expression;
                    if (zs(r.expression, Yp(Vt.expression)) && e.isIdentifier(Vt.name) && Vt.name.escapedText === "hasOwnProperty" && Ni.arguments.length === 1) {
                      var Fa = Ni.arguments[0];
                      if (e.isStringLiteralLike(Fa) && wd(r) === e.escapeLeadingUnderscores(Fa.text)) return Ks(Yr, Hi ? 524288 : 65536);
                    }
                  }
                  return Yr;
                }
                function Kt(Yr, Ni, Hi, _t) {
                  if (Ni.type && !(ta(Yr) && (Ni.type === qe || Ni.type === br))) {
                    var gt = k8(Ni, Hi);
                    if (gt) {
                      if (zs(r, gt)) return Lt(Yr, Ni.type, _t, E_);
                      Ye && _t && Ag(gt, r) && !(cp(Ni.type) & 65536) && (Yr = Ks(Yr, 2097152));
                      var Vt = Sn(gt, Yr);
                      if (Vt) return ja(Yr, Vt, function(Fa) {
                        return Lt(Fa, Ni.type, _t, E_);
                      });
                    }
                  }
                  return Yr;
                }
                function $t(Yr, Ni, Hi) {
                  if (e.isExpressionOfOptionalChainRoot(Ni) || e.isBinaryExpression(Ni.parent) && Ni.parent.operatorToken.kind === 60 && Ni.parent.left === Ni) return Ua(Yr, Ni, Hi);
                  switch (Ni.kind) {
                    case 79:
                      if (!zs(r, Ni) && rr < 5) {
                        var _t = Dl(Ni);
                        if (pv(_t)) {
                          var gt = _t.valueDeclaration;
                          if (gt && e.isVariableDeclaration(gt) && !gt.type && gt.initializer && dC(r)) {
                            rr++;
                            var Vt = $t(Yr, gt.initializer, Hi);
                            return rr--, Vt;
                          }
                        }
                      }
                    case 108:
                    case 106:
                    case 206:
                    case 207:
                      return Tn(Yr, Ni, Hi);
                    case 208:
                      return ea(Yr, Ni, Hi);
                    case 212:
                    case 230:
                      return $t(Yr, Ni.expression, Hi);
                    case 221:
                      return it(Yr, Ni, Hi);
                    case 219:
                      if (Ni.operator === 53) return $t(Yr, Ni.operand, !Hi);
                      break;
                  }
                  return Yr;
                }
                function Ua(Yr, Ni, Hi) {
                  if (zs(r, Ni)) return Ks(Yr, Hi ? 2097152 : 262144);
                  var _t = Sn(Ni, Yr);
                  return _t ? ja(Yr, _t, function(gt) {
                    return Ks(gt, Hi ? 2097152 : 262144);
                  }) : Yr;
                }
              }
              function N8(r, i) {
                if (r = r.exportSymbol || r, (i.kind === 79 || i.kind === 80) && (e.isRightSideOfQualifiedNameOrPropertyAccess(i) && (i = i.parent), e.isExpressionNode(i) && (!e.isAssignmentTarget(i) || e.isWriteAccess(i)))) {
                  var t = Gs(i);
                  if (cu(va(i).resolvedSymbol) === r) return t;
                }
                return e.isDeclarationName(i) && e.isSetAccessor(i.parent) && W(i.parent) ? yt(i.parent.symbol) : ml(r);
              }
              function _v(r) {
                return e.findAncestor(r.parent, function(i) {
                  return e.isFunctionLike(i) && !e.getImmediatelyInvokedFunctionExpression(i) || i.kind === 262 || i.kind === 305 || i.kind === 167;
                });
              }
              function n0(r) {
                if (!r.valueDeclaration) return false;
                var i = e.getRootDeclaration(r.valueDeclaration).parent, t = va(i);
                return t.flags & 8388608 || (t.flags |= 8388608, P8(i) || gC(i)), r.isAssigned || false;
              }
              function P8(r) {
                return !!e.findAncestor(r.parent, function(i) {
                  return (e.isFunctionLike(i) || e.isCatchClause(i)) && !!(va(i).flags & 8388608);
                });
              }
              function gC(r) {
                if (r.kind === 79) {
                  if (e.isAssignmentTarget(r)) {
                    var i = Dl(r);
                    e.isParameterOrCatchClauseVariable(i) && (i.isAssigned = true);
                  }
                } else e.forEachChild(r, gC);
              }
              function pv(r) {
                return r.flags & 3 && (p0(r) & 2) !== 0;
              }
              function I8(r, i) {
                if (yu(i.symbol, 2)) {
                  var t = Ye && i.kind === 164 && i.initializer && ju(r) & 32768 && !(ju(yn(i.initializer)) & 32768);
                  return fi(), t ? Ks(r, 524288) : r;
                } else return lg(i.symbol), r;
              }
              function w8(r, i) {
                var t = i.parent;
                return t.kind === 206 || t.kind === 161 || t.kind === 208 && t.expression === i || t.kind === 207 && t.expression === i && !(rg(r, F8) && qp(Gs(t.argumentExpression)));
              }
              function O8(r) {
                return !!(r.flags & 465829888 && Hd(r).flags & 1146880);
              }
              function F8(r) {
                return !!(r.flags & 465829888 && !fs(Hd(r), 98304));
              }
              function M8(r, i) {
                var t = (e.isIdentifier(r) || e.isPropertyAccessExpression(r) || e.isElementAccessExpression(r)) && !((e.isJsxOpeningElement(r.parent) || e.isJsxSelfClosingElement(r.parent)) && r.parent.tagName === r) && (i && i & 64 ? ou(r, 8) : ou(r));
                return t && !rv(t);
              }
              function yb(r, i, t) {
                var o = !(t && t & 2) && rg(r, O8) && (w8(r, i) || M8(i, t));
                return o ? Ss(r, function(s) {
                  return s.flags & 465829888 ? Hd(s) : s;
                }) : r;
              }
              function mC(r) {
                return !!e.findAncestor(r, function(i) {
                  var t = i.parent;
                  return t === void 0 ? "quit" : e.isExportAssignment(t) ? t.expression === i && e.isEntityNameExpression(i) : e.isExportSpecifier(t) ? t.name === i || t.propertyName === i : false;
                });
              }
              function o0(r, i) {
                if (Zn(r, 111551) && !_m(i) && !vu(r)) {
                  var t = Ps(r);
                  t.flags & 111551 && (ye.isolatedModules || e.shouldPreserveConstEnums(ye) && mC(i) || !Av(t) ? As(r) : vn(r));
                }
              }
              function L8(r, i) {
                var t = r.valueDeclaration;
                if (t) {
                  if (e.isBindingElement(t) && !t.initializer && !t.dotDotDotToken && t.parent.elements.length >= 2) {
                    var o = t.parent.parent;
                    if (o.kind === 254 && e.getCombinedNodeFlags(t) & 2 || o.kind === 164) {
                      var s = va(o);
                      if (!(s.flags & 268435456)) {
                        s.flags |= 268435456;
                        var u = Wo(o, 0);
                        if (s.flags &= -268435457, u && u.flags & 1048576 && !(o.kind === 164 && n0(r))) {
                          var h = t.parent, z2 = up(h, u, u, void 0, i.flowNode);
                          return z2.flags & 131072 ? ui : uf(t, z2);
                        }
                      }
                    }
                  }
                  if (e.isParameter(t) && !t.type && !t.initializer && !t.dotDotDotToken) {
                    var me = t.parent;
                    if (me.parameters.length >= 2 && wD(me)) {
                      var Me = dv(me);
                      if (Me && Me.parameters.length === 1 && H(Me)) {
                        var $e = Xd(Jt(Me.parameters[0]));
                        if ($e.flags & 1048576 && gf($e, Yn) && !n0(r)) {
                          var z2 = up(me, $e, $e, void 0, i.flowNode), tr = me.parameters.indexOf(t) - (e.getThisParameter(me) ? 1 : 0);
                          return Jc(z2, If(tr));
                        }
                      }
                    }
                  }
                }
                return Jt(r);
              }
              function R8(r, i) {
                if (e.isThisInTypeQuery(r)) return yy(r);
                var t = Dl(r);
                if (t === xe) return Pe;
                if (t === or) {
                  if (QC(r)) return Xr(r, e.Diagnostics.arguments_cannot_be_referenced_in_property_initializers), Pe;
                  var o = e.getContainingFunction(r);
                  return Ae < 2 && (o.kind === 214 ? Xr(r, e.Diagnostics.The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression) : e.hasSyntacticModifier(o, 256) && Xr(r, e.Diagnostics.The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method)), va(o).flags |= 8192, Jt(t);
                }
                r.parent && e.isPropertyAccessExpression(r.parent) && r.parent.expression === r || o0(t, r);
                var s = cu(t), u = W6(s, r);
                P_(u) && mD(r, u) && u.declarations && El(r, u.declarations, r.escapedText);
                var h = s.valueDeclaration;
                if (h && s.flags & 32) {
                  if (h.kind === 257 && e.nodeIsDecorated(h)) for (var o = e.getContainingClass(r); o !== void 0; ) {
                    if (o === h && o.name !== r) {
                      va(h).flags |= 16777216, va(r).flags |= 33554432;
                      break;
                    }
                    o = e.getContainingClass(o);
                  }
                  else if (h.kind === 226) for (var o = e.getThisContainer(r, false); o.kind !== 305; ) {
                    if (o.parent === h) {
                      (e.isPropertyDeclaration(o) && e.isStatic(o) || e.isClassStaticBlockDeclaration(o)) && (va(h).flags |= 16777216, va(r).flags |= 33554432);
                      break;
                    }
                    o = e.getThisContainer(o, false);
                  }
                }
                j8(r, t);
                var z2 = L8(s, r), me = e.getAssignmentTargetKind(r);
                if (me) {
                  if (!(s.flags & 3) && !(e.isInJSFile(r) && s.flags & 512)) {
                    var Me = s.flags & 384 ? e.Diagnostics.Cannot_assign_to_0_because_it_is_an_enum : s.flags & 32 ? e.Diagnostics.Cannot_assign_to_0_because_it_is_a_class : s.flags & 1536 ? e.Diagnostics.Cannot_assign_to_0_because_it_is_a_namespace : s.flags & 16 ? e.Diagnostics.Cannot_assign_to_0_because_it_is_a_function : s.flags & 2097152 ? e.Diagnostics.Cannot_assign_to_0_because_it_is_an_import : e.Diagnostics.Cannot_assign_to_0_because_it_is_not_a_variable;
                    return Xr(r, Me, tn(t)), Pe;
                  }
                  if (Zu(s)) return s.flags & 3 ? Xr(r, e.Diagnostics.Cannot_assign_to_0_because_it_is_a_constant, tn(t)) : Xr(r, e.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, tn(t)), Pe;
                }
                var $e = s.flags & 2097152;
                if (s.flags & 3) {
                  if (me === 1) return z2;
                } else if ($e) h = ru(t);
                else return z2;
                if (!h) return z2;
                z2 = yb(z2, r, i);
                for (var tr = e.getRootDeclaration(h).kind === 164, dr = _v(h), Dr = _v(r), Qr = Dr !== dr, li = r.parent && r.parent.parent && e.isSpreadAssignment(r.parent) && mb(r.parent.parent), Ti = t.flags & 134217728; Dr !== dr && (Dr.kind === 213 || Dr.kind === 214 || e.isObjectLiteralOrClassExpressionMethodOrAccessor(Dr)) && (pv(s) && z2 !== So || tr && !n0(s)); ) Dr = _v(Dr);
                var Ci = tr || $e || Qr || li || Ti || e.isBindingElement(h) || z2 !== nr && z2 !== So && (!Ye || (z2.flags & 16387) !== 0 || _m(r) || r.parent.kind === 275) || r.parent.kind === 230 || h.kind === 254 && h.exclamationToken || h.flags & 16777216, $i = Ci ? tr ? I8(z2, h) : z2 : z2 === nr || z2 === So ? Tr : i_(z2), Zi = up(r, z2, $i, Dr);
                if (!_C(r) && (z2 === nr || z2 === So)) {
                  if (Zi === nr || Zi === So) return n && (Xr(e.getNameOfDeclaration(h), e.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined, tn(t), Ot(Zi)), Xr(r, e.Diagnostics.Variable_0_implicitly_has_an_1_type, tn(t), Ot(Zi))), kv(Zi);
                } else if (!Ci && !(ju(z2) & 32768) && ju(Zi) & 32768) return Xr(r, e.Diagnostics.Variable_0_is_used_before_being_assigned, tn(t)), z2;
                return me ? Kl(Zi) : Zi;
              }
              function B8(r, i) {
                return !!e.findAncestor(r, function(t) {
                  return t === i ? "quit" : e.isFunctionLike(t) || t.parent && e.isPropertyDeclaration(t.parent) && !e.hasStaticModifier(t.parent) && t.parent.initializer === t;
                });
              }
              function J8(r, i) {
                return e.findAncestor(r, function(t) {
                  return t === i ? "quit" : t === i.initializer || t === i.condition || t === i.incrementor || t === i.statement;
                });
              }
              function hb(r) {
                return e.findAncestor(r, function(i) {
                  return !i || e.nodeStartsNewLexicalEnvironment(i) ? "quit" : e.isIterationStatement(i, false);
                });
              }
              function j8(r, i) {
                if (!(Ae >= 2 || (i.flags & 34) === 0 || !i.valueDeclaration || e.isSourceFile(i.valueDeclaration) || i.valueDeclaration.parent.kind === 292)) {
                  var t = e.getEnclosingBlockScopeContainer(i.valueDeclaration), o = B8(r, t), s = hb(t);
                  if (s) {
                    if (o) {
                      var u = true;
                      if (e.isForStatement(t)) {
                        var h = e.getAncestor(i.valueDeclaration, 255);
                        if (h && h.parent === t) {
                          var z2 = J8(r.parent, t);
                          if (z2) {
                            var me = va(z2);
                            me.flags |= 131072;
                            var Me = me.capturedBlockScopeBindings || (me.capturedBlockScopeBindings = []);
                            e.pushIfUnique(Me, i), z2 === t.initializer && (u = false);
                          }
                        }
                      }
                      u && (va(s).flags |= 65536);
                    }
                    if (e.isForStatement(t)) {
                      var h = e.getAncestor(i.valueDeclaration, 255);
                      h && h.parent === t && z8(r, t) && (va(i.valueDeclaration).flags |= 4194304);
                    }
                    va(i.valueDeclaration).flags |= 524288;
                  }
                  o && (va(i.valueDeclaration).flags |= 262144);
                }
              }
              function U8(r, i) {
                var t = va(r);
                return !!t && e.contains(t.capturedBlockScopeBindings, Et(i));
              }
              function z8(r, i) {
                for (var t = r; t.parent.kind === 212; ) t = t.parent;
                var o = false;
                if (e.isAssignmentTarget(t)) o = true;
                else if (t.parent.kind === 219 || t.parent.kind === 220) {
                  var s = t.parent;
                  o = s.operator === 45 || s.operator === 46;
                }
                return o ? !!e.findAncestor(t, function(u) {
                  return u === i ? "quit" : u === i.statement;
                }) : false;
              }
              function Db(r, i) {
                if (va(r).flags |= 2, i.kind === 167 || i.kind === 171) {
                  var t = i.parent;
                  va(t).flags |= 4;
                } else va(i).flags |= 4;
              }
              function vC(r) {
                return e.isSuperCall(r) ? r : e.isFunctionLike(r) ? void 0 : e.forEachChild(r, vC);
              }
              function yC(r) {
                var i = Et(r), t = go(i), o = Bl(t);
                return o === ct;
              }
              function hC(r, i, t) {
                var o = i.parent, s = e.getClassExtendsHeritageElement(o);
                s && !yC(o) && r.flowNode && !a0(r.flowNode, false) && Xr(r, t);
              }
              function W8(r, i) {
                e.isPropertyDeclaration(i) && e.hasStaticModifier(i) && i.initializer && e.textRangeContainsPositionInclusive(i.initializer, r.pos) && e.length(i.parent.decorators) && Xr(r, e.Diagnostics.Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class);
              }
              function yy(r) {
                var i = _m(r), t = e.getThisContainer(r, true), o = false;
                switch (t.kind === 171 && hC(r, t, e.Diagnostics.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class), t.kind === 214 && (t = e.getThisContainer(t, false), o = true), W8(r, t), t.kind) {
                  case 261:
                    Xr(r, e.Diagnostics.this_cannot_be_referenced_in_a_module_or_namespace_body);
                    break;
                  case 260:
                    Xr(r, e.Diagnostics.this_cannot_be_referenced_in_current_location);
                    break;
                  case 171:
                    DC(r, t) && Xr(r, e.Diagnostics.this_cannot_be_referenced_in_constructor_arguments);
                    break;
                  case 162:
                    Xr(r, e.Diagnostics.this_cannot_be_referenced_in_a_computed_property_name);
                    break;
                }
                !i && o && Ae < 2 && Db(r, t);
                var s = bb(r, true, t);
                if (lr) {
                  var u = Jt(pe);
                  if (s === u && o) Xr(r, e.Diagnostics.The_containing_arrow_function_captures_the_global_value_of_this);
                  else if (!s) {
                    var h = Xr(r, e.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation);
                    if (!e.isSourceFile(t)) {
                      var z2 = bb(t);
                      z2 && z2 !== u && e.addRelatedInfo(h, e.createDiagnosticForNode(t, e.Diagnostics.An_outer_value_of_this_is_shadowed_by_this_container));
                    }
                  }
                }
                return s || Oe;
              }
              function bb(r, i, t) {
                i === void 0 && (i = true), t === void 0 && (t = e.getThisContainer(r, false));
                var o = e.isInJSFile(r);
                if (e.isFunctionLike(t) && (!xb(r) || e.getThisParameter(t))) {
                  var s = ni(t) || o && K8(t);
                  if (!s) {
                    var u = V8(t);
                    if (o && u) {
                      var h = yn(u).symbol;
                      h && h.members && h.flags & 16 && (s = go(h).thisType);
                    } else Sl(t) && (s = go(so(t.symbol)).thisType);
                    s || (s = SC(t));
                  }
                  if (s) return up(r, s);
                }
                if (e.isClassLike(t.parent)) {
                  var z2 = Et(t.parent), me = e.isStatic(t) ? Jt(z2) : go(z2).thisType;
                  return up(r, me);
                }
                if (e.isSourceFile(t)) if (t.commonJsModuleIndicator) {
                  var Me = Et(t);
                  return Me && Jt(Me);
                } else {
                  if (t.externalModuleIndicator) return Tr;
                  if (i) return Jt(pe);
                }
              }
              function q8(r) {
                var i = e.getThisContainer(r, false);
                if (e.isFunctionLike(i)) {
                  var t = yl(i);
                  if (t.thisParameter) return r0(t.thisParameter);
                }
                if (e.isClassLike(i.parent)) {
                  var o = Et(i.parent);
                  return e.isStatic(i) ? Jt(o) : go(o).thisType;
                }
              }
              function V8(r) {
                if (r.kind === 213 && e.isBinaryExpression(r.parent) && e.getAssignmentDeclarationKind(r.parent) === 3) return r.parent.left.expression.expression;
                if (r.kind === 169 && r.parent.kind === 205 && e.isBinaryExpression(r.parent.parent) && e.getAssignmentDeclarationKind(r.parent.parent) === 6) return r.parent.parent.left.expression;
                if (r.kind === 213 && r.parent.kind === 296 && r.parent.parent.kind === 205 && e.isBinaryExpression(r.parent.parent.parent) && e.getAssignmentDeclarationKind(r.parent.parent.parent) === 6) return r.parent.parent.parent.left.expression;
                if (r.kind === 213 && e.isPropertyAssignment(r.parent) && e.isIdentifier(r.parent.name) && (r.parent.name.escapedText === "value" || r.parent.name.escapedText === "get" || r.parent.name.escapedText === "set") && e.isObjectLiteralExpression(r.parent.parent) && e.isCallExpression(r.parent.parent.parent) && r.parent.parent.parent.arguments[2] === r.parent.parent && e.getAssignmentDeclarationKind(r.parent.parent.parent) === 9) return r.parent.parent.parent.arguments[0].expression;
                if (e.isMethodDeclaration(r) && e.isIdentifier(r.name) && (r.name.escapedText === "value" || r.name.escapedText === "get" || r.name.escapedText === "set") && e.isObjectLiteralExpression(r.parent) && e.isCallExpression(r.parent.parent) && r.parent.parent.arguments[2] === r.parent && e.getAssignmentDeclarationKind(r.parent.parent) === 9) return r.parent.parent.arguments[0].expression;
              }
              function K8(r) {
                var i = e.getJSDocType(r);
                if (i && i.kind === 317) {
                  var t = i;
                  if (t.parameters.length > 0 && t.parameters[0].name && t.parameters[0].name.escapedText === "this") return Va(t.parameters[0].type);
                }
                var o = e.getJSDocThisTag(r);
                if (o && o.typeExpression) return Va(o.typeExpression);
              }
              function DC(r, i) {
                return !!e.findAncestor(r, function(t) {
                  return e.isFunctionLikeDeclaration(t) ? "quit" : t.kind === 164 && t.parent === i;
                });
              }
              function Sb(r) {
                var i = r.parent.kind === 208 && r.parent.expression === r, t = e.getSuperContainer(r, true), o = t, s = false;
                if (!i) for (; o && o.kind === 214; ) o = e.getSuperContainer(o, true), s = Ae < 2;
                var u = tr(o), h = 0;
                if (!u) {
                  var z2 = e.findAncestor(r, function(dr) {
                    return dr === o ? "quit" : dr.kind === 162;
                  });
                  return z2 && z2.kind === 162 ? Xr(r, e.Diagnostics.super_cannot_be_referenced_in_a_computed_property_name) : i ? Xr(r, e.Diagnostics.Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors) : !o || !o.parent || !(e.isClassLike(o.parent) || o.parent.kind === 205) ? Xr(r, e.Diagnostics.super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions) : Xr(r, e.Diagnostics.super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class), Pe;
                }
                if (!i && t.kind === 171 && hC(r, o, e.Diagnostics.super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class), e.isStatic(o) || i ? (h = 512, !i && Ae >= 2 && Ae <= 8 && (e.isPropertyDeclaration(o) || e.isClassStaticBlockDeclaration(o)) && e.forEachEnclosingBlockScopeContainer(r.parent, function(dr) {
                  (!e.isSourceFile(dr) || e.isExternalOrCommonJsModule(dr)) && (va(dr).flags |= 134217728);
                })) : h = 256, va(r).flags |= h, o.kind === 169 && e.hasSyntacticModifier(o, 256) && (e.isSuperProperty(r.parent) && e.isAssignmentTarget(r.parent) ? va(o).flags |= 4096 : va(o).flags |= 2048), s && Db(r.parent, o), o.parent.kind === 205) return Ae < 2 ? (Xr(r, e.Diagnostics.super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher), Pe) : Oe;
                var me = o.parent;
                if (!e.getClassExtendsHeritageElement(me)) return Xr(r, e.Diagnostics.super_can_only_be_referenced_in_a_derived_class), Pe;
                var Me = go(Et(me)), $e = Me && Qc(Me)[0];
                if (!$e) return Pe;
                if (o.kind === 171 && DC(r, o)) return Xr(r, e.Diagnostics.super_cannot_be_referenced_in_constructor_arguments), Pe;
                return h === 512 ? Bl(Me) : Rc($e, Me.thisType);
                function tr(dr) {
                  return dr ? i ? dr.kind === 171 : e.isClassLike(dr.parent) || dr.parent.kind === 205 ? e.isStatic(dr) ? dr.kind === 169 || dr.kind === 168 || dr.kind === 172 || dr.kind === 173 || dr.kind === 167 || dr.kind === 170 : dr.kind === 169 || dr.kind === 168 || dr.kind === 172 || dr.kind === 173 || dr.kind === 167 || dr.kind === 166 || dr.kind === 171 : false : false;
                }
              }
              function G8(r) {
                return (r.kind === 169 || r.kind === 172 || r.kind === 173) && r.parent.kind === 205 ? r.parent : r.kind === 213 && r.parent.kind === 296 ? r.parent.parent : void 0;
              }
              function bC(r) {
                return e.getObjectFlags(r) & 4 && r.target === qn ? xo(r)[0] : void 0;
              }
              function H8(r) {
                return Ss(r, function(i) {
                  return i.flags & 2097152 ? e.forEach(i.types, bC) : bC(i);
                });
              }
              function SC(r) {
                if (r.kind !== 214) {
                  if (wD(r)) {
                    var i = dv(r);
                    if (i) {
                      var t = i.thisParameter;
                      if (t) return Jt(t);
                    }
                  }
                  var o = e.isInJSFile(r);
                  if (lr || o) {
                    var s = G8(r);
                    if (s) {
                      for (var u = $p(s), h = s, z2 = u; z2; ) {
                        var me = H8(z2);
                        if (me) return un(me, ab(wg(s)));
                        if (h.parent.kind !== 296) break;
                        h = h.parent.parent, z2 = $p(h);
                      }
                      return $c(u ? C_(u) : Os(s));
                    }
                    var Me = e.walkUpParenthesizedExpressions(r.parent);
                    if (Me.kind === 221 && Me.operatorToken.kind === 63) {
                      var $e = Me.left;
                      if (e.isAccessExpression($e)) {
                        var tr = $e.expression;
                        if (o && e.isIdentifier(tr)) {
                          var dr = e.getSourceFileOfNode(Me);
                          if (dr.commonJsModuleIndicator && Dl(tr) === dr.symbol) return;
                        }
                        return $c(Os(tr));
                      }
                    }
                  }
                }
              }
              function TC(r) {
                var i = r.parent;
                if (!!wD(i)) {
                  var t = e.getImmediatelyInvokedFunctionExpression(i);
                  if (t && t.arguments) {
                    var o = Zb(t), s = i.parameters.indexOf(r);
                    if (r.dotDotDotToken) return Yb(o, s, o.length, Oe, void 0, 0);
                    var u = va(t), h = u.resolvedSignature;
                    u.resolvedSignature = En;
                    var z2 = s < o.length ? Hp(yn(o[s])) : r.initializer ? void 0 : vi;
                    return u.resolvedSignature = h, z2;
                  }
                  var me = dv(i);
                  if (me) {
                    var Me = i.parameters.indexOf(r) - (e.getThisParameter(i) ? 1 : 0);
                    return r.dotDotDotToken && e.lastOrUndefined(i.parameters) === r ? ym(me, Me) : Ld(me, Me);
                  }
                }
              }
              function Tb(r) {
                var i = e.getEffectiveTypeAnnotationNode(r);
                if (i) return Va(i);
                switch (r.kind) {
                  case 164:
                    return TC(r);
                  case 203:
                    return X8(r);
                  case 167:
                    if (e.isStatic(r)) return Q8(r);
                }
              }
              function X8(r) {
                var i = r.parent.parent, t = r.propertyName || r.name, o = Tb(i) || i.kind !== 203 && i.initializer && wy(i, r.dotDotDotToken ? 64 : 0);
                if (!(!o || e.isBindingPattern(t) || e.isComputedNonLiteralName(t))) {
                  if (i.name.kind === 202) {
                    var s = e.indexOfNode(r.parent.elements, r);
                    return s < 0 ? void 0 : Ab(o, s);
                  }
                  var u = Z_(t);
                  if (_f(u)) {
                    var h = pf(u);
                    return da(o, h);
                  }
                }
              }
              function Q8(r) {
                var i = e.isExpression(r.parent) && ou(r.parent);
                if (!!i) return Md(i, Et(r).escapedName);
              }
              function Y8(r, i) {
                var t = r.parent;
                if (e.hasInitializer(t) && r === t.initializer) {
                  var o = Tb(t);
                  if (o) return o;
                  if (!(i & 8) && e.isBindingPattern(t.name)) return Qu(t.name, true, false);
                }
              }
              function $8(r) {
                var i = e.getContainingFunction(r);
                if (i) {
                  var t = Eb(i);
                  if (t) {
                    var o = e.getFunctionFlags(i);
                    if (o & 1) {
                      var s = o & 2 ? 2 : 1, u = Jy(t, s, void 0);
                      if (!u) return;
                      t = u.returnType;
                    }
                    if (o & 2) {
                      var h = Ss(t, k_);
                      return h && Pa([h, Ok(h)]);
                    }
                    return t;
                  }
                }
              }
              function Z8(r, i) {
                var t = ou(r, i);
                if (t) {
                  var o = k_(t);
                  return o && Pa([o, Ok(o)]);
                }
              }
              function e5(r) {
                var i = e.getContainingFunction(r);
                if (i) {
                  var t = e.getFunctionFlags(i), o = Eb(i);
                  if (o) return r.asteriskToken ? o : Jg(0, o, (t & 2) !== 0);
                }
              }
              function xb(r) {
                for (var i = false; r.parent && !e.isFunctionLike(r.parent); ) {
                  if (e.isParameter(r.parent) && (i || r.parent.initializer === r)) return true;
                  e.isBindingElement(r.parent) && r.parent.initializer === r && (i = true), r = r.parent;
                }
                return false;
              }
              function xC(r, i) {
                var t = !!(e.getFunctionFlags(i) & 2), o = Eb(i);
                if (o) return Jg(r, o, t) || void 0;
              }
              function Eb(r) {
                var i = yg(r);
                if (i) return i;
                var t = Pb(r);
                if (t && !Z1(t)) return yo(t);
                var o = e.getImmediatelyInvokedFunctionExpression(r);
                if (o) return ou(o);
              }
              function EC(r, i) {
                var t = Zb(r), o = t.indexOf(i);
                return o === -1 ? void 0 : Cb(r, o);
              }
              function Cb(r, i) {
                if (e.isImportCall(r)) return i === 0 ? Li : i === 1 ? xx(false) : Oe;
                var t = va(r).resolvedSignature === to ? to : Mg(r);
                if (e.isJsxOpeningLikeElement(r) && i === 0) return l0(t, r);
                var o = t.parameters.length - 1;
                return H(t) && i >= o ? Jc(Jt(t.parameters[o]), If(i - o), 256) : $u(t, i);
              }
              function r5(r, i) {
                if (r.parent.kind === 210) return EC(r.parent, i);
              }
              function i5(r, i) {
                var t = r.parent, o = t.left, s = t.operatorToken, u = t.right;
                switch (s.kind) {
                  case 63:
                  case 76:
                  case 75:
                  case 77:
                    return r === u ? a5(t) : void 0;
                  case 56:
                  case 60:
                    var h = ou(t, i);
                    return r === u && (h && h.pattern || !h && !e.isDefaultedExpandoInitializer(t)) ? Gs(o) : h;
                  case 55:
                  case 27:
                    return r === u ? ou(t, i) : void 0;
                  default:
                    return;
                }
              }
              function t5(r) {
                if (r.symbol) return r.symbol;
                if (e.isIdentifier(r)) return Dl(r);
                if (e.isPropertyAccessExpression(r)) {
                  var i = Gs(r.expression);
                  return e.isPrivateIdentifier(r.name) ? t(i, r.name) : bi(i, r.name.escapedText);
                }
                return;
                function t(o, s) {
                  var u = g0(s.escapedText, s);
                  return u && Ub(o, u);
                }
              }
              function a5(r) {
                var i, t, o = e.getAssignmentDeclarationKind(r);
                switch (o) {
                  case 0:
                  case 4:
                    var s = t5(r.left), u = s && s.valueDeclaration;
                    if (u && (e.isPropertyDeclaration(u) || e.isPropertySignature(u))) {
                      var h = e.getEffectiveTypeAnnotationNode(u);
                      return h && un(Va(h), Aa(s).mapper) || u.initializer && Gs(r.left);
                    }
                    return o === 0 ? Gs(r.left) : CC(r);
                  case 5:
                    if (s0(r, o)) return CC(r);
                    if (r.left.symbol) {
                      var z2 = r.left.symbol.valueDeclaration;
                      if (!z2) return;
                      var me = e.cast(r.left, e.isAccessExpression), h = e.getEffectiveTypeAnnotationNode(z2);
                      if (h) return Va(h);
                      if (e.isIdentifier(me.expression)) {
                        var Me = me.expression, $e = es(Me, Me.escapedText, 111551, void 0, Me.escapedText, true);
                        if ($e) {
                          var tr = $e.valueDeclaration && e.getEffectiveTypeAnnotationNode($e.valueDeclaration);
                          if (tr) {
                            var dr = e.getElementOrPropertyAccessName(me);
                            if (dr !== void 0) return Md(Va(tr), dr);
                          }
                          return;
                        }
                      }
                      return e.isInJSFile(z2) ? void 0 : Gs(r.left);
                    } else return Gs(r.left);
                  case 1:
                  case 6:
                  case 3:
                    var Dr = (i = r.left.symbol) === null || i === void 0 ? void 0 : i.valueDeclaration;
                  case 2:
                    Dr || (Dr = (t = r.symbol) === null || t === void 0 ? void 0 : t.valueDeclaration);
                    var Qr = Dr && e.getEffectiveTypeAnnotationNode(Dr);
                    return Qr ? Va(Qr) : void 0;
                  case 7:
                  case 8:
                  case 9:
                    return e.Debug.fail("Does not apply");
                  default:
                    return e.Debug.assertNever(o);
                }
              }
              function s0(r, i) {
                if (i === void 0 && (i = e.getAssignmentDeclarationKind(r)), i === 4) return true;
                if (!e.isInJSFile(r) || i !== 5 || !e.isIdentifier(r.left.expression)) return false;
                var t = r.left.expression.escapedText, o = es(r.left, t, 111551, void 0, void 0, true, true);
                return e.isThisInitializedDeclaration(o == null ? void 0 : o.valueDeclaration);
              }
              function CC(r) {
                if (!r.symbol) return Gs(r.left);
                if (r.symbol.valueDeclaration) {
                  var i = e.getEffectiveTypeAnnotationNode(r.symbol.valueDeclaration);
                  if (i) {
                    var t = Va(i);
                    if (t) return t;
                  }
                }
                var o = e.cast(r.left, e.isAccessExpression);
                if (!!e.isObjectLiteralMethod(e.getThisContainer(o.expression, false))) {
                  var s = yy(o.expression), u = e.getElementOrPropertyAccessName(o);
                  return u !== void 0 && Md(s, u) || void 0;
                }
              }
              function n5(r) {
                return !!(e.getCheckFlags(r) & 262144 && !r.type && v(r, 0) >= 0);
              }
              function Md(r, i, t) {
                return Ss(r, function(o) {
                  var s;
                  if (Bc(o) && !o.declaration.nameType) {
                    var u = Mu(o), h = uc(u) || u, z2 = t || Bu(e.unescapeLeadingUnderscores(i));
                    if (ao(z2, h)) return xh(o, z2);
                  } else if (o.flags & 3670016) {
                    var me = bi(o, i);
                    if (me) return n5(me) ? void 0 : Jt(me);
                    if (Yn(o)) {
                      var Me = sv(o);
                      if (Me && e.isNumericLiteralName(i) && +i >= 0) return Me;
                    }
                    return (s = mn(To(o), t || Bu(e.unescapeLeadingUnderscores(i)))) === null || s === void 0 ? void 0 : s.type;
                  }
                }, true);
              }
              function kC(r, i) {
                if (e.Debug.assert(e.isObjectLiteralMethod(r)), !(r.flags & 33554432)) return kb(r, i);
              }
              function kb(r, i) {
                var t = r.parent, o = e.isPropertyAssignment(r) && Tb(r);
                if (o) return o;
                var s = $p(t, i);
                if (s) {
                  if (Td(r)) {
                    var u = Et(r);
                    return Md(s, u.escapedName, Aa(u).nameType);
                  }
                  if (r.name) {
                    var h = Z_(r.name);
                    return Ss(s, function(z2) {
                      var me;
                      return (me = mn(To(z2), h)) === null || me === void 0 ? void 0 : me.type;
                    }, true);
                  }
                }
              }
              function Ab(r, i) {
                return r && (Md(r, "" + i) || Ss(r, function(t) {
                  return xS(1, t, Tr, void 0, false);
                }, true));
              }
              function o5(r, i) {
                var t = r.parent;
                return r === t.whenTrue || r === t.whenFalse ? ou(t, i) : void 0;
              }
              function s5(r, i) {
                var t = $p(r.openingElement.tagName), o = _0(Og(r));
                if (!!(t && !ta(t) && o && o !== "")) {
                  var s = e.getSemanticJsxChildren(r.children), u = s.indexOf(i), h = Md(t, o);
                  return h && (s.length === 1 ? h : Ss(h, function(z2) {
                    return sp(z2) ? Jc(z2, If(u)) : z2;
                  }, true));
                }
              }
              function c5(r) {
                var i = r.parent;
                return e.isJsxAttributeLike(i) ? ou(r) : e.isJsxElement(i) ? s5(i, r) : void 0;
              }
              function AC(r) {
                if (e.isJsxAttribute(r)) {
                  var i = $p(r.parent);
                  return !i || ta(i) ? void 0 : Md(i, r.name.escapedText);
                } else return ou(r.parent);
              }
              function hy(r) {
                switch (r.kind) {
                  case 10:
                  case 8:
                  case 9:
                  case 14:
                  case 110:
                  case 95:
                  case 104:
                  case 79:
                  case 153:
                    return true;
                  case 206:
                  case 212:
                    return hy(r.expression);
                  case 288:
                    return !r.expression || hy(r.expression);
                }
                return false;
              }
              function u5(r, i) {
                return n8(i, r) || UD(i, e.concatenate(e.map(e.filter(r.properties, function(t) {
                  return !!t.symbol && t.kind === 296 && hy(t.initializer) && lv(i, t.symbol.escapedName);
                }), function(t) {
                  return [function() {
                    return Oy(t.initializer);
                  }, t.symbol.escapedName];
                }), e.map(e.filter(uo(i), function(t) {
                  var o;
                  return !!(t.flags & 16777216) && !!(!((o = r == null ? void 0 : r.symbol) === null || o === void 0) && o.members) && !r.symbol.members.has(t.escapedName) && lv(i, t.escapedName);
                }), function(t) {
                  return [function() {
                    return Tr;
                  }, t.escapedName];
                })), ao, i);
              }
              function l5(r, i) {
                return UD(i, e.concatenate(e.map(e.filter(r.properties, function(t) {
                  return !!t.symbol && t.kind === 285 && lv(i, t.symbol.escapedName) && (!t.initializer || hy(t.initializer));
                }), function(t) {
                  return [t.initializer ? function() {
                    return Oy(t.initializer);
                  } : function() {
                    return Dt;
                  }, t.symbol.escapedName];
                }), e.map(e.filter(uo(i), function(t) {
                  var o;
                  return !!(t.flags & 16777216) && !!(!((o = r == null ? void 0 : r.symbol) === null || o === void 0) && o.members) && !r.symbol.members.has(t.escapedName) && lv(i, t.escapedName);
                }), function(t) {
                  return [function() {
                    return Tr;
                  }, t.escapedName];
                })), ao, i);
              }
              function $p(r, i) {
                var t = e.isObjectLiteralMethod(r) ? kC(r, i) : ou(r, i), o = c0(t, r, i);
                if (o && !(i && i & 2 && o.flags & 8650752)) {
                  var s = Ss(o, $s, true);
                  return s.flags & 1048576 && e.isObjectLiteralExpression(r) ? u5(r, s) : s.flags & 1048576 && e.isJsxAttributes(r) ? l5(r, s) : s;
                }
              }
              function c0(r, i, t) {
                if (r && fs(r, 465829888)) {
                  var o = wg(i);
                  if (o && e.some(o.inferences, tg)) {
                    if (t && t & 1) return u0(r, o.nonFixingMapper);
                    if (o.returnMapper) {
                      var s = u0(r, o.returnMapper);
                      return s.flags & 1048576 && $f(s.types, ut) && $f(s.types, Rt) ? ec(s, function(u) {
                        return u !== ut && u !== Rt;
                      }) : s;
                    }
                  }
                }
                return r;
              }
              function u0(r, i) {
                return r.flags & 465829888 ? un(r, i) : r.flags & 1048576 ? Pa(e.map(r.types, function(t) {
                  return u0(t, i);
                }), 0) : r.flags & 2097152 ? Do(e.map(r.types, function(t) {
                  return u0(t, i);
                })) : r;
              }
              function ou(r, i) {
                if (r.flags & 33554432) return;
                if (r.contextualType) return r.contextualType;
                var t = r.parent;
                switch (t.kind) {
                  case 254:
                  case 164:
                  case 167:
                  case 166:
                  case 203:
                    return Y8(r, i);
                  case 214:
                  case 247:
                    return $8(r);
                  case 224:
                    return e5(t);
                  case 218:
                    return Z8(t, i);
                  case 208:
                  case 209:
                    return EC(t, r);
                  case 211:
                  case 229:
                    return e.isConstTypeReference(t.type) ? h(t) : Va(t.type);
                  case 221:
                    return i5(r, i);
                  case 296:
                  case 297:
                    return kb(t, i);
                  case 298:
                    return ou(t.parent, i);
                  case 204: {
                    var o = t, s = $p(o, i);
                    return Ab(s, e.indexOfNode(o.elements, r));
                  }
                  case 222:
                    return o5(r, i);
                  case 233:
                    return e.Debug.assert(t.parent.kind === 223), r5(t.parent, r);
                  case 212: {
                    var u = e.isInJSFile(t) ? e.getJSDocTypeTag(t) : void 0;
                    return u ? e.isJSDocTypeTag(u) && e.isConstTypeReference(u.typeExpression.type) ? h(t) : Va(u.typeExpression.type) : ou(t, i);
                  }
                  case 230:
                    return ou(t, i);
                  case 271:
                    return Rl(t);
                  case 288:
                    return c5(t);
                  case 285:
                  case 287:
                    return AC(t);
                  case 280:
                  case 279:
                    return f5(t, i);
                }
                return;
                function h(z2) {
                  return ou(z2);
                }
              }
              function wg(r) {
                var i = e.findAncestor(r, function(t) {
                  return !!t.inferenceContext;
                });
                return i && i.inferenceContext;
              }
              function f5(r, i) {
                return e.isJsxOpeningElement(r) && r.parent.contextualType && i !== 4 ? r.parent.contextualType : Cb(r, 0);
              }
              function l0(r, i) {
                return lk(i) !== 0 ? _5(r, i) : g5(r, i);
              }
              function _5(r, i) {
                var t = nS(r, gr);
                t = NC(i, Og(i), t);
                var o = Zp(U.IntrinsicAttributes, i);
                return nn(o) || (t = Zg(o, t)), t;
              }
              function p5(r, i) {
                if (r.compositeSignatures) {
                  for (var t = [], o = 0, s = r.compositeSignatures; o < s.length; o++) {
                    var u = s[o], h = yo(u);
                    if (ta(h)) return h;
                    var z2 = da(h, i);
                    if (!z2) return;
                    t.push(z2);
                  }
                  return Do(t);
                }
                var me = yo(r);
                return ta(me) ? me : da(me, i);
              }
              function d5(r) {
                if (dm(r.tagName)) {
                  var i = BC(r), t = S0(r, i);
                  return im(t);
                }
                var o = Os(r.tagName);
                if (o.flags & 128) {
                  var i = RC(o, r);
                  if (!i) return Pe;
                  var t = S0(r, i);
                  return im(t);
                }
                return o;
              }
              function NC(r, i, t) {
                var o = F5(i);
                if (o) {
                  var s = go(o), u = d5(r);
                  if (o.flags & 524288) {
                    var h = Aa(o).typeParameters;
                    if (e.length(h) >= 2) {
                      var z2 = zp([u, t], h, 2, e.isInJSFile(r));
                      return am(o, z2);
                    }
                  }
                  if (e.length(s.typeParameters) >= 2) {
                    var z2 = zp([u, t], s.typeParameters, 2, e.isInJSFile(r));
                    return Yf(s, z2);
                  }
                }
                return t;
              }
              function g5(r, i) {
                var t = Og(i), o = M5(t), s = o === void 0 ? nS(r, gr) : o === "" ? yo(r) : p5(r, o);
                if (!s) return !!o && !!e.length(i.attributes.properties) && Xr(i, e.Diagnostics.JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property, e.unescapeLeadingUnderscores(o)), gr;
                if (s = NC(i, t, s), ta(s)) return s;
                var u = s, h = Zp(U.IntrinsicClassAttributes, i);
                if (!nn(h)) {
                  var z2 = Af(h.symbol), me = yo(r);
                  u = Zg(z2 ? Yf(h, zp([me], z2, Ul(z2), e.isInJSFile(i))) : h, u);
                }
                var Me = Zp(U.IntrinsicAttributes, i);
                return nn(Me) || (u = Zg(Me, u)), u;
              }
              function m5(r) {
                return e.getStrictOptionValue(ye, "noImplicitAny") ? e.reduceLeft(r, function(i, t) {
                  return i === t || !i ? i : ah(i.typeParameters, t.typeParameters) ? h5(i, t) : void 0;
                }) : void 0;
              }
              function v5(r, i, t) {
                if (!r || !i) return r || i;
                var o = Pa([Jt(r), un(Jt(i), t)]);
                return eg(r, o);
              }
              function y5(r, i, t) {
                for (var o = Wc(r), s = Wc(i), u = o >= s ? r : i, h = u === r ? i : r, z2 = u === r ? o : s, me = Xl(r) || Xl(i), Me = me && !Xl(u), $e = new Array(z2 + (Me ? 1 : 0)), tr = 0; tr < z2; tr++) {
                  var dr = Ld(u, tr);
                  u === i && (dr = un(dr, t));
                  var Dr = Ld(h, tr) || gr;
                  h === i && (Dr = un(Dr, t));
                  var Qr = Pa([dr, Dr]), li = me && !Me && tr === z2 - 1, Ti = tr >= Hl(u) && tr >= Hl(h), Ci = tr >= o ? void 0 : vm(r, tr), $i = tr >= s ? void 0 : vm(i, tr), Zi = Ci === $i ? Ci : Ci ? $i ? void 0 : Ci : $i, qt = oo(1 | (Ti && !li ? 16777216 : 0), Zi || "arg".concat(tr));
                  qt.type = li ? Zs(Qr) : Qr, $e[tr] = qt;
                }
                if (Me) {
                  var Nt = oo(1, "args");
                  Nt.type = Zs($u(h, z2)), h === i && (Nt.type = un(Nt.type, t)), $e[z2] = Nt;
                }
                return $e;
              }
              function h5(r, i) {
                var t = r.typeParameters || i.typeParameters, o;
                r.typeParameters && i.typeParameters && (o = Uc(i.typeParameters, r.typeParameters));
                var s = r.declaration, u = y5(r, i, o), h = v5(r.thisParameter, i.thisParameter, o), z2 = Math.max(r.minArgumentCount, i.minArgumentCount), me = Fu(s, t, h, u, void 0, void 0, z2, (r.flags | i.flags) & 39);
                return me.compositeKind = 2097152, me.compositeSignatures = e.concatenate(r.compositeKind === 2097152 && r.compositeSignatures || [r], [i]), o && (me.mapper = r.compositeKind === 2097152 && r.mapper && r.compositeSignatures ? np(r.mapper, o) : o), me;
              }
              function Nb(r, i) {
                var t = ot(r, 0), o = e.filter(t, function(s) {
                  return !D5(s, i);
                });
                return o.length === 1 ? o[0] : m5(o);
              }
              function D5(r, i) {
                for (var t = 0; t < i.parameters.length; t++) {
                  var o = i.parameters[t];
                  if (o.initializer || o.questionToken || o.dotDotDotToken || Cd(o)) break;
                }
                return i.parameters.length && e.parameterIsThisKeyword(i.parameters[0]) && t--, !Xl(r) && Wc(r) < t;
              }
              function Pb(r) {
                return e.isFunctionExpressionOrArrowFunction(r) || e.isObjectLiteralMethod(r) ? dv(r) : void 0;
              }
              function dv(r) {
                e.Debug.assert(r.kind !== 169 || e.isObjectLiteralMethod(r));
                var i = rm(r);
                if (i) return i;
                var t = $p(r, 1);
                if (!!t) {
                  if (!(t.flags & 1048576)) return Nb(t, r);
                  for (var o, s = t.types, u = 0, h = s; u < h.length; u++) {
                    var z2 = h[u], me = Nb(z2, r);
                    if (me) if (!o) o = [me];
                    else if (_y(o[0], me, false, true, true, av)) o.push(me);
                    else return;
                  }
                  if (o) return o.length === 1 ? o[0] : Uv(o[0], o);
                }
              }
              function b5(r, i) {
                Ae < 2 && fc(r, ye.downlevelIteration ? 1536 : 1024);
                var t = yn(r.expression, i);
                return N_(33, t, Tr, r.expression);
              }
              function S5(r) {
                return r.isSpread ? Jc(r.type, nt) : r.type;
              }
              function pm(r) {
                return r.kind === 203 && !!r.initializer || r.kind === 221 && r.operatorToken.kind === 63;
              }
              function PC(r, i, t) {
                for (var o = r.elements, s = o.length, u = [], h = [], z2 = $p(r), me = e.isAssignmentTarget(r), Me = hm(r), $e = false, tr = 0; tr < s; tr++) {
                  var dr = o[tr];
                  if (dr.kind === 225) {
                    Ae < 2 && fc(dr, ye.downlevelIteration ? 1536 : 1024);
                    var Dr = yn(dr.expression, i, t);
                    if (sp(Dr)) u.push(Dr), h.push(8);
                    else if (me) {
                      var Qr = cs(Dr, nt) || xS(65, Dr, Tr, void 0, false) || gr;
                      u.push(Qr), h.push(4);
                    } else u.push(N_(33, Dr, Tr, dr.expression)), h.push(4);
                  } else if (yr && dr.kind === 227) $e = true, u.push(Yi), h.push(2);
                  else {
                    var li = Ab(z2, u.length), Ti = Dm(dr, i, li, t);
                    if (u.push(kc(Ti, true, $e)), h.push($e ? 2 : 1), z2 && rg(z2, Eg) && i && i & 2 && !(i & 4) && Ju(dr)) {
                      var Ci = wg(r);
                      e.Debug.assert(Ci), BE(Ci, dr, Ti);
                    }
                  }
                }
                return me ? Wl(u, h) : t || Me || z2 && rg(z2, Eg) ? IC(Wl(u, h, Me)) : IC(Zs(u.length ? Pa(e.sameMap(u, function($i, Zi) {
                  return h[Zi] & 8 ? ep($i, nt) || Oe : $i;
                }), 2) : Ye ? na : vi, Me));
              }
              function IC(r) {
                if (!(e.getObjectFlags(r) & 4)) return r;
                var i = r.literalType;
                return i || (i = r.literalType = ux(r), i.objectFlags |= 147456), i;
              }
              function T5(r) {
                switch (r.kind) {
                  case 162:
                    return x5(r);
                  case 79:
                    return e.isNumericLiteralName(r.escapedText);
                  case 8:
                  case 10:
                    return e.isNumericLiteralName(r.text);
                  default:
                    return false;
                }
              }
              function x5(r) {
                return Ns(t_(r), 296);
              }
              function t_(r) {
                var i = va(r.expression);
                if (!i.resolvedType) {
                  if ((e.isTypeLiteralNode(r.parent.parent) || e.isClassLike(r.parent.parent) || e.isInterfaceDeclaration(r.parent.parent)) && e.isBinaryExpression(r.expression) && r.expression.operatorToken.kind === 101 && r.parent.kind !== 172 && r.parent.kind !== 173) return i.resolvedType = Pe;
                  if (i.resolvedType = yn(r.expression), e.isPropertyDeclaration(r.parent) && !e.hasStaticModifier(r.parent) && e.isClassExpression(r.parent.parent)) {
                    var t = e.getEnclosingBlockScopeContainer(r.parent.parent), o = hb(t);
                    o && (va(o).flags |= 65536, va(r).flags |= 524288, va(r.parent.parent).flags |= 524288);
                  }
                  (i.resolvedType.flags & 98304 || !Ns(i.resolvedType, 402665900) && !ao(i.resolvedType, Vi)) && Xr(r, e.Diagnostics.A_computed_property_name_must_be_of_type_string_number_symbol_or_any);
                }
                return i.resolvedType;
              }
              function E5(r) {
                var i, t = (i = r.declarations) === null || i === void 0 ? void 0 : i[0];
                return e.isNumericLiteralName(r.escapedName) || t && e.isNamedDeclaration(t) && T5(t.name);
              }
              function wC(r) {
                var i, t = (i = r.declarations) === null || i === void 0 ? void 0 : i[0];
                return e.isKnownSymbol(r) || t && e.isNamedDeclaration(t) && e.isComputedPropertyName(t.name) && Ns(t_(t.name), 4096);
              }
              function Ib(r, i, t, o) {
                for (var s = [], u = i; u < t.length; u++) {
                  var h = t[u];
                  (o === Li && !wC(h) || o === nt && E5(h) || o === Ki && wC(h)) && s.push(Jt(t[u]));
                }
                var z2 = s.length ? Pa(s, 2) : Tr;
                return zl(o, z2, hm(r));
              }
              function wb(r) {
                e.Debug.assert((r.flags & 2097152) !== 0, "Should only get Alias here.");
                var i = Aa(r);
                if (!i.immediateTarget) {
                  var t = ru(r);
                  if (!t) return e.Debug.fail();
                  i.immediateTarget = Ec(t, true);
                }
                return i.immediateTarget;
              }
              function C5(r, i) {
                var t = e.isAssignmentTarget(r);
                eL(r, t);
                for (var o = Ye ? e.createSymbolTable() : void 0, s = e.createSymbolTable(), u = [], h = Ba, z2 = $p(r), me = z2 && z2.pattern && (z2.pattern.kind === 201 || z2.pattern.kind === 205), Me = hm(r), $e = Me ? 8 : 0, tr = e.isInJSFile(r) && !e.isInJsonFile(r), dr = e.getJSDocEnumTag(r), Dr = !z2 && tr && !dr, Qr = ur, li = false, Ti = false, Ci = false, $i = false, Zi = 0, qt = r.properties; Zi < qt.length; Zi++) {
                  var Nt = qt[Zi];
                  Nt.name && e.isComputedPropertyName(Nt.name) && t_(Nt.name);
                }
                for (var Ra = 0, ca = 0, Sn = r.properties; ca < Sn.length; ca++) {
                  var ja = Sn[ca], Fn = Et(ja), wn = ja.name && ja.name.kind === 162 ? t_(ja.name) : void 0;
                  if (ja.kind === 296 || ja.kind === 297 || e.isObjectLiteralMethod(ja)) {
                    var Tn = ja.kind === 296 ? Kk(ja, i) : ja.kind === 297 ? Dm(!t && ja.objectAssignmentInitializer ? ja.objectAssignmentInitializer : ja.name, i) : Gk(ja, i);
                    if (tr) {
                      var Eo = K_(ja);
                      Eo ? (zc(Tn, Eo, ja), Tn = Eo) : dr && dr.typeExpression && zc(Tn, Va(dr.typeExpression), ja);
                    }
                    Qr |= e.getObjectFlags(Tn) & 458752;
                    var lt = wn && _f(wn) ? wn : void 0, it = lt ? oo(4 | Fn.flags, pf(lt), $e | 4096) : oo(4 | Fn.flags, Fn.escapedName, $e);
                    if (lt && (it.nameType = lt), t) {
                      var Yt = ja.kind === 296 && pm(ja.initializer) || ja.kind === 297 && ja.objectAssignmentInitializer;
                      Yt && (it.flags |= 16777216);
                    } else if (me && !(e.getObjectFlags(z2) & 512)) {
                      var Ia = bi(z2, Fn.escapedName);
                      Ia ? it.flags |= Ia.flags & 16777216 : !ye.suppressExcessPropertyErrors && !ss(z2, Li) && Xr(ja.name, e.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1, tn(Fn), Ot(z2));
                    }
                    if (it.declarations = Fn.declarations, it.parent = Fn.parent, Fn.valueDeclaration && (it.valueDeclaration = Fn.valueDeclaration), it.type = Tn, it.target = Fn, Fn = it, o == null || o.set(it.escapedName, it), z2 && i && i & 2 && !(i & 4) && (ja.kind === 296 || ja.kind === 169) && Ju(ja)) {
                      var Qt = wg(r);
                      e.Debug.assert(Qt);
                      var Ka = ja.kind === 296 ? ja.initializer : ja;
                      BE(Qt, Ka, Tn);
                    }
                  } else if (ja.kind === 298) {
                    Ae < 2 && fc(ja, 2), u.length > 0 && (h = Vp(h, Mn(), r.symbol, Qr, Me), u = [], s = e.createSymbolTable(), Ti = false, Ci = false, $i = false);
                    var Tn = bu(yn(ja.expression));
                    if (Dy(Tn)) {
                      var cn = TD(Tn, Me);
                      if (o && FC(cn, o, ja), Ra = u.length, nn(h)) continue;
                      h = Vp(h, cn, r.symbol, Qr, Me);
                    } else Xr(ja, e.Diagnostics.Spread_types_may_only_be_created_from_object_types), h = Pe;
                    continue;
                  } else e.Debug.assert(ja.kind === 172 || ja.kind === 173), xm(ja);
                  wn && !(wn.flags & 8576) ? ao(wn, Vi) && (ao(wn, nt) ? Ci = true : ao(wn, Ki) ? $i = true : Ti = true, t && (li = true)) : s.set(Fn.escapedName, Fn), u.push(Fn);
                }
                if (me && r.parent.kind !== 298) for (var Un = 0, oa = uo(z2); Un < oa.length; Un++) {
                  var it = oa[Un];
                  !s.get(it.escapedName) && !bi(h, it.escapedName) && (it.flags & 16777216 || Xr(it.valueDeclaration || it.bindingElement, e.Diagnostics.Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value), s.set(it.escapedName, it), u.push(it));
                }
                if (nn(h)) return Pe;
                if (h !== Ba) return u.length > 0 && (h = Vp(h, Mn(), r.symbol, Qr, Me), u = [], s = e.createSymbolTable(), Ti = false, Ci = false), Ss(h, function(Ln) {
                  return Ln === Ba ? Mn() : Ln;
                });
                return Mn();
                function Mn() {
                  var Ln = [];
                  Ti && Ln.push(Ib(r, Ra, u, Li)), Ci && Ln.push(Ib(r, Ra, u, nt)), $i && Ln.push(Ib(r, Ra, u, Ki));
                  var ci = rs(r.symbol, s, e.emptyArray, e.emptyArray, Ln);
                  return ci.objectFlags |= Qr | 128 | 131072, Dr && (ci.objectFlags |= 4096), li && (ci.objectFlags |= 512), t && (ci.pattern = r), ci;
                }
              }
              function Dy(r) {
                var i = OE(Ss(r, Hd));
                return !!(i.flags & 126615553 || i.flags & 3145728 && e.every(i.types, Dy));
              }
              function k5(r) {
                Lb(r);
              }
              function A5(r, i) {
                return xm(r), by(r) || Oe;
              }
              function N5(r) {
                Lb(r.openingElement), dm(r.closingElement.tagName) ? Fb(r.closingElement) : yn(r.closingElement.tagName), f0(r);
              }
              function P5(r, i) {
                return xm(r), by(r) || Oe;
              }
              function I5(r) {
                Lb(r.openingFragment);
                var i = e.getSourceFileOfNode(r);
                return e.getJSXTransformEnabled(ye) && (ye.jsxFactory || i.pragmas.has("jsx")) && !ye.jsxFragmentFactory && !i.pragmas.has("jsxfrag") && Xr(r, ye.jsxFactory ? e.Diagnostics.The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_compiler_option : e.Diagnostics.An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments), f0(r), by(r) || Oe;
              }
              function Ob(r) {
                return e.stringContains(r, "-");
              }
              function dm(r) {
                return r.kind === 79 && e.isIntrinsicJsxName(r.escapedText);
              }
              function OC(r, i) {
                return r.initializer ? Dm(r.initializer, i) : Dt;
              }
              function w5(r, i) {
                for (var t = r.attributes, o = Ye ? e.createSymbolTable() : void 0, s = e.createSymbolTable(), u = pn, h = false, z2, me = false, Me = 2048, $e = _0(Og(r)), tr = 0, dr = t.properties; tr < dr.length; tr++) {
                  var Dr = dr[tr], Qr = Dr.symbol;
                  if (e.isJsxAttribute(Dr)) {
                    var li = OC(Dr, i);
                    Me |= e.getObjectFlags(li) & 458752;
                    var Ti = oo(4 | Qr.flags, Qr.escapedName);
                    Ti.declarations = Qr.declarations, Ti.parent = Qr.parent, Qr.valueDeclaration && (Ti.valueDeclaration = Qr.valueDeclaration), Ti.type = li, Ti.target = Qr, s.set(Ti.escapedName, Ti), o == null || o.set(Ti.escapedName, Ti), Dr.name.escapedText === $e && (me = true);
                  } else {
                    e.Debug.assert(Dr.kind === 287), s.size > 0 && (u = Vp(u, ca(), t.symbol, Me, false), s = e.createSymbolTable());
                    var li = bu(Os(Dr.expression, i));
                    ta(li) && (h = true), Dy(li) ? (u = Vp(u, li, t.symbol, Me, false), o && FC(li, o, Dr)) : (Xr(Dr.expression, e.Diagnostics.Spread_types_may_only_be_created_from_object_types), z2 = z2 ? Do([z2, li]) : li);
                  }
                }
                h || s.size > 0 && (u = Vp(u, ca(), t.symbol, Me, false));
                var Ci = r.parent.kind === 278 ? r.parent : void 0;
                if (Ci && Ci.openingElement === r && Ci.children.length > 0) {
                  var $i = f0(Ci, i);
                  if (!h && $e && $e !== "") {
                    me && Xr(t, e.Diagnostics._0_are_specified_twice_The_attribute_named_0_will_be_overwritten, e.unescapeLeadingUnderscores($e));
                    var Zi = $p(r.attributes), qt = Zi && Md(Zi, $e), Nt = oo(4, $e);
                    Nt.type = $i.length === 1 ? $i[0] : qt && rg(qt, Eg) ? Wl($i) : Zs(Pa($i)), Nt.valueDeclaration = e.factory.createPropertySignature(void 0, e.unescapeLeadingUnderscores($e), void 0, void 0), e.setParent(Nt.valueDeclaration, t), Nt.valueDeclaration.symbol = Nt;
                    var Ra = e.createSymbolTable();
                    Ra.set($e, Nt), u = Vp(u, rs(t.symbol, Ra, e.emptyArray, e.emptyArray, e.emptyArray), t.symbol, Me, false);
                  }
                }
                if (h) return Oe;
                if (z2 && u !== pn) return Do([z2, u]);
                return z2 || (u === pn ? ca() : u);
                function ca() {
                  Me |= ur;
                  var Sn = rs(t.symbol, s, e.emptyArray, e.emptyArray, e.emptyArray);
                  return Sn.objectFlags |= Me | 128 | 131072, Sn;
                }
              }
              function f0(r, i) {
                for (var t = [], o = 0, s = r.children; o < s.length; o++) {
                  var u = s[o];
                  if (u.kind === 11) u.containsOnlyTriviaWhiteSpaces || t.push(Li);
                  else {
                    if (u.kind === 288 && !u.expression) continue;
                    t.push(Dm(u, i));
                  }
                }
                return t;
              }
              function FC(r, i, t) {
                for (var o = 0, s = uo(r); o < s.length; o++) {
                  var u = s[o];
                  if (!(u.flags & 16777216)) {
                    var h = i.get(u.escapedName);
                    if (h) {
                      var z2 = Xr(h.valueDeclaration, e.Diagnostics._0_is_specified_more_than_once_so_this_usage_will_be_overwritten, e.unescapeLeadingUnderscores(h.escapedName));
                      e.addRelatedInfo(z2, e.createDiagnosticForNode(t, e.Diagnostics.This_spread_always_overwrites_this_property));
                    }
                  }
                }
              }
              function O5(r, i) {
                return w5(r.parent, i);
              }
              function Zp(r, i) {
                var t = Og(i), o = t && dc(t), s = o && qs(o, r, 788968);
                return s ? go(s) : Pe;
              }
              function Fb(r) {
                var i = va(r);
                if (!i.resolvedSymbol) {
                  var t = Zp(U.IntrinsicElements, r);
                  if (nn(t)) return n && Xr(r, e.Diagnostics.JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists, e.unescapeLeadingUnderscores(U.IntrinsicElements)), i.resolvedSymbol = xe;
                  if (!e.isIdentifier(r.tagName)) return e.Debug.fail();
                  var o = bi(t, r.tagName.escapedText);
                  if (o) return i.jsxFlags |= 1, i.resolvedSymbol = o;
                  var s = cs(t, Li);
                  return s ? (i.jsxFlags |= 2, i.resolvedSymbol = t.symbol) : (Xr(r, e.Diagnostics.Property_0_does_not_exist_on_type_1, e.idText(r.tagName), "JSX." + U.IntrinsicElements), i.resolvedSymbol = xe);
                }
                return i.resolvedSymbol;
              }
              function Mb(r) {
                var i = r && e.getSourceFileOfNode(r), t = i && va(i);
                if (!(t && t.jsxImplicitImportContainer === false)) {
                  if (t && t.jsxImplicitImportContainer) return t.jsxImplicitImportContainer;
                  var o = e.getJSXRuntimeImport(e.getJSXImplicitImportBase(ye, i), ye);
                  if (!!o) {
                    var s = e.getEmitModuleResolutionKind(ye) === e.ModuleResolutionKind.Classic, u = s ? e.Diagnostics.Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_node_or_to_add_aliases_to_the_paths_option : e.Diagnostics.Cannot_find_module_0_or_its_corresponding_type_declarations, h = Il(r, o, u, r), z2 = h && h !== xe ? so(os(h)) : void 0;
                    return t && (t.jsxImplicitImportContainer = z2 || false), z2;
                  }
                }
              }
              function Og(r) {
                var i = r && va(r);
                if (i && i.jsxNamespace) return i.jsxNamespace;
                if (!i || i.jsxNamespace !== false) {
                  var t = Mb(r);
                  if (!t || t === xe) {
                    var o = po(r);
                    t = es(r, o, 1920, void 0, o, false);
                  }
                  if (t) {
                    var s = os(qs(dc(os(t)), U.JSX, 1920));
                    if (s && s !== xe) return i && (i.jsxNamespace = s), s;
                  }
                  i && (i.jsxNamespace = false);
                }
                var u = os(Ym(U.JSX, 1920, void 0));
                if (u !== xe) return u;
              }
              function MC(r, i) {
                var t = i && qs(i.exports, r, 788968), o = t && go(t), s = o && uo(o);
                if (s) {
                  if (s.length === 0) return "";
                  if (s.length === 1) return s[0].escapedName;
                  s.length > 1 && t.declarations && Xr(t.declarations[0], e.Diagnostics.The_global_type_JSX_0_may_not_have_more_than_one_property, e.unescapeLeadingUnderscores(r));
                }
              }
              function F5(r) {
                return r && qs(r.exports, U.LibraryManagedAttributes, 788968);
              }
              function M5(r) {
                return MC(U.ElementAttributesPropertyNameContainer, r);
              }
              function _0(r) {
                return MC(U.ElementChildrenAttributeNameContainer, r);
              }
              function LC(r, i) {
                if (r.flags & 4) return [En];
                if (r.flags & 128) {
                  var t = RC(r, i);
                  if (t) {
                    var o = S0(i, t);
                    return [o];
                  } else return Xr(i, e.Diagnostics.Property_0_does_not_exist_on_type_1, r.value, "JSX." + U.IntrinsicElements), e.emptyArray;
                }
                var s = $s(r), u = ot(s, 1);
                return u.length === 0 && (u = ot(s, 0)), u.length === 0 && s.flags & 1048576 && (u = zv(e.map(s.types, function(h) {
                  return LC(h, i);
                }))), u;
              }
              function RC(r, i) {
                var t = Zp(U.IntrinsicElements, i);
                if (!nn(t)) {
                  var o = r.value, s = bi(t, e.escapeLeadingUnderscores(o));
                  if (s) return Jt(s);
                  var u = cs(t, Li);
                  return u || void 0;
                }
                return Oe;
              }
              function L5(r, i, t) {
                if (r === 1) {
                  var o = jC(t);
                  o && hl(i, o, dt, t.tagName, e.Diagnostics.Its_return_type_0_is_not_a_valid_JSX_element, h);
                } else if (r === 0) {
                  var s = JC(t);
                  s && hl(i, s, dt, t.tagName, e.Diagnostics.Its_instance_type_0_is_not_a_valid_JSX_element, h);
                } else {
                  var o = jC(t), s = JC(t);
                  if (!o || !s) return;
                  var u = Pa([o, s]);
                  hl(i, u, dt, t.tagName, e.Diagnostics.Its_element_type_0_is_not_a_valid_JSX_element, h);
                }
                function h() {
                  var z2 = e.getTextOfNode(t.tagName);
                  return e.chainDiagnosticMessages(void 0, e.Diagnostics._0_cannot_be_used_as_a_JSX_component, z2);
                }
              }
              function BC(r) {
                e.Debug.assert(dm(r.tagName));
                var i = va(r);
                if (!i.resolvedJsxElementAttributesType) {
                  var t = Fb(r);
                  return i.jsxFlags & 1 ? i.resolvedJsxElementAttributesType = Jt(t) || Pe : i.jsxFlags & 2 ? i.resolvedJsxElementAttributesType = cs(Zp(U.IntrinsicElements, r), Li) || Pe : i.resolvedJsxElementAttributesType = Pe;
                }
                return i.resolvedJsxElementAttributesType;
              }
              function JC(r) {
                var i = Zp(U.ElementClass, r);
                if (!nn(i)) return i;
              }
              function by(r) {
                return Zp(U.Element, r);
              }
              function jC(r) {
                var i = by(r);
                if (i) return Pa([i, Wi]);
              }
              function R5(r) {
                var i = Zp(U.IntrinsicElements, r);
                return i ? uo(i) : e.emptyArray;
              }
              function B5(r) {
                (ye.jsx || 0) === 0 && Xr(r, e.Diagnostics.Cannot_use_JSX_unless_the_jsx_flag_is_provided), by(r) === void 0 && n && Xr(r, e.Diagnostics.JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist);
              }
              function Lb(r) {
                var i = e.isJsxOpeningLikeElement(r);
                if (i && rL(r), B5(r), !Mb(r)) {
                  var t = rn && ye.jsx === 2 ? e.Diagnostics.Cannot_find_name_0 : void 0, o = po(r), s = i ? r.tagName : r, u = void 0;
                  if (e.isJsxOpeningFragment(r) && o === "null" || (u = es(s, o, 111551, t, o, true)), u && (u.isReferenced = 67108863, u.flags & 2097152 && !vu(u) && As(u)), e.isJsxOpeningFragment(r)) {
                    var h = e.getSourceFileOfNode(r), z2 = Gn(h);
                    z2 && es(s, z2, 111551, t, z2, true);
                  }
                }
                if (i) {
                  var me = r, Me = Mg(me);
                  x0(Me, r), L5(lk(me), yo(Me), me);
                }
              }
              function Rb(r, i, t) {
                if (r.flags & 524288) {
                  if (h_(r, i) || Xo(r, i) || pg(i) && ss(r, Li) || t && Ob(i)) return true;
                } else if (r.flags & 3145728 && Sy(r)) for (var o = 0, s = r.types; o < s.length; o++) {
                  var u = s[o];
                  if (Rb(u, i, t)) return true;
                }
                return false;
              }
              function Sy(r) {
                return !!(r.flags & 524288 && !(e.getObjectFlags(r) & 512) || r.flags & 67108864 || r.flags & 1048576 && e.some(r.types, Sy) || r.flags & 2097152 && e.every(r.types, Sy));
              }
              function J5(r, i) {
                if (tL(r), r.expression) {
                  var t = yn(r.expression, i);
                  return r.dotDotDotToken && t !== Oe && !Tu(t) && Xr(r, e.Diagnostics.JSX_spread_child_must_be_an_array_type), t;
                } else return Pe;
              }
              function p0(r) {
                return r.valueDeclaration ? e.getCombinedNodeFlags(r.valueDeclaration) : 0;
              }
              function Bb(r) {
                if (r.flags & 8192 || e.getCheckFlags(r) & 4) return true;
                if (e.isInJSFile(r.valueDeclaration)) {
                  var i = r.valueDeclaration.parent;
                  return i && e.isBinaryExpression(i) && e.getAssignmentDeclarationKind(i) === 3;
                }
              }
              function Jb(r, i, t, o, s, u) {
                u === void 0 && (u = true);
                var h = u ? r.kind === 161 ? r.right : r.kind === 200 ? r : r.kind === 203 && r.propertyName ? r.propertyName : r.name : void 0;
                return UC(r, i, t, o, s, h);
              }
              function UC(r, i, t, o, s, u) {
                var h = e.getDeclarationModifierFlagsFromSymbol(s, t);
                if (i) {
                  if (Ae < 2 && zC(s)) return u && Xr(u, e.Diagnostics.Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword), false;
                  if (h & 128) return u && Xr(u, e.Diagnostics.Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression, tn(s), Ot(Zd(s))), false;
                }
                if (h & 128 && zC(s) && (e.isThisProperty(r) || e.isThisInitializedObjectBindingExpression(r) || e.isObjectBindingPattern(r.parent) && e.isThisInitializedDeclaration(r.parent.parent))) {
                  var z2 = e.getClassLikeDeclarationOfSymbol(Ys(s));
                  if (z2 && i9(r)) return u && Xr(u, e.Diagnostics.Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor, tn(s), e.getTextOfIdentifierOrLiteral(z2.name)), false;
                }
                if (!(h & 24)) return true;
                if (h & 8) {
                  var z2 = e.getClassLikeDeclarationOfSymbol(Ys(s));
                  return MS(r, z2) ? true : (u && Xr(u, e.Diagnostics.Property_0_is_private_and_only_accessible_within_class_1, tn(s), Ot(Zd(s))), false);
                }
                if (i) return true;
                var me = Y6(r, function(Me) {
                  var $e = go(Et(Me));
                  return EE($e, s, t);
                });
                return !me && (me = j5(r), me = me && EE(me, s, t), h & 32 || !me) ? (u && Xr(u, e.Diagnostics.Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses, tn(s), Ot(Zd(s) || o)), false) : h & 32 ? true : (o.flags & 262144 && (o = o.isThisType ? Tc(o) : uc(o)), !o || !lf(o, me) ? (u && Xr(u, e.Diagnostics.Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_class_2, tn(s), Ot(me), Ot(o)), false) : true);
              }
              function j5(r) {
                var i = U5(r), t = (i == null ? void 0 : i.type) && Va(i.type);
                if (t && t.flags & 262144 && (t = Tc(t)), t && e.getObjectFlags(t) & 7) return bd(t);
              }
              function U5(r) {
                var i = e.getThisContainer(r, false);
                return i && e.isFunctionLike(i) ? e.getThisParameter(i) : void 0;
              }
              function zC(r) {
                return !!fy(r, function(i) {
                  return !(i.flags & 8192);
                });
              }
              function gm(r) {
                return bl(yn(r), r);
              }
              function d0(r) {
                return !!((Ye ? ju(r) : r.flags) & 98304);
              }
              function jb(r) {
                return d0(r) ? C_(r) : r;
              }
              function z5(r, i) {
                Xr(r, i & 32768 ? i & 65536 ? e.Diagnostics.Object_is_possibly_null_or_undefined : e.Diagnostics.Object_is_possibly_undefined : e.Diagnostics.Object_is_possibly_null);
              }
              function W5(r, i) {
                Xr(r, i & 32768 ? i & 65536 ? e.Diagnostics.Cannot_invoke_an_object_which_is_possibly_null_or_undefined : e.Diagnostics.Cannot_invoke_an_object_which_is_possibly_undefined : e.Diagnostics.Cannot_invoke_an_object_which_is_possibly_null);
              }
              function WC(r, i, t) {
                if (Ye && r.flags & 2) return Xr(i, e.Diagnostics.Object_is_of_type_unknown), Pe;
                var o = (Ye ? ju(r) : r.flags) & 98304;
                if (o) {
                  t(i, o);
                  var s = C_(r);
                  return s.flags & 229376 ? Pe : s;
                }
                return r;
              }
              function bl(r, i) {
                return WC(r, i, z5);
              }
              function qC(r, i) {
                var t = bl(r, i);
                return t.flags & 16384 && Xr(i, e.Diagnostics.Object_is_possibly_undefined), t;
              }
              function VC(r, i) {
                return r.flags & 32 ? q5(r, i) : zb(r, r.expression, gm(r.expression), r.name, i);
              }
              function q5(r, i) {
                var t = yn(r.expression), o = cv(t, r.expression);
                return zh(zb(r, r.expression, bl(o, r.expression), r.name, i), r, o !== t);
              }
              function KC(r, i) {
                var t = e.isPartOfTypeQuery(r) && e.isThisIdentifier(r.left) ? bl(yy(r.left), r.left) : gm(r.left);
                return zb(r, r.left, t, r.right, i);
              }
              function GC(r) {
                for (; r.parent.kind === 212; ) r = r.parent;
                return e.isCallOrNewExpression(r.parent) && r.parent.expression === r;
              }
              function g0(r, i) {
                for (var t = e.getContainingClass(i); t; t = e.getContainingClass(t)) {
                  var o = t.symbol, s = e.getSymbolNameForPrivateIdentifier(o, r), u = o.members && o.members.get(s) || o.exports && o.exports.get(s);
                  if (u) return u;
                }
              }
              function V5(r) {
                if (!e.getContainingClass(r)) return Tt(r, e.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
                if (!e.isForInStatement(r.parent)) {
                  if (!e.isExpressionNode(r)) return Tt(r, e.Diagnostics.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression);
                  var i = e.isBinaryExpression(r.parent) && r.parent.operatorToken.kind === 101;
                  if (!m0(r) && !i) return Tt(r, e.Diagnostics.Cannot_find_name_0, e.idText(r));
                }
                return false;
              }
              function K5(r) {
                V5(r);
                var i = m0(r);
                return i && xy(i, void 0, false), Oe;
              }
              function m0(r) {
                if (!!e.isExpressionNode(r)) {
                  var i = va(r);
                  return i.resolvedSymbol === void 0 && (i.resolvedSymbol = g0(r.escapedText, r)), i.resolvedSymbol;
                }
              }
              function Ub(r, i) {
                return bi(r, i.escapedName);
              }
              function G5(r, i, t) {
                var o, s = uo(r);
                s && e.forEach(s, function(tr) {
                  var dr = tr.valueDeclaration;
                  if (dr && e.isNamedDeclaration(dr) && e.isPrivateIdentifier(dr.name) && dr.name.escapedText === i.escapedText) return o = tr, true;
                });
                var u = ku(i);
                if (o) {
                  var h = e.Debug.checkDefined(o.valueDeclaration), z2 = e.Debug.checkDefined(e.getContainingClass(h));
                  if (t != null && t.valueDeclaration) {
                    var me = t.valueDeclaration, Me = e.getContainingClass(me);
                    if (e.Debug.assert(!!Me), e.findAncestor(Me, function(tr) {
                      return z2 === tr;
                    })) {
                      var $e = Xr(i, e.Diagnostics.The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_private_identifier_with_the_same_spelling, u, Ot(r));
                      return e.addRelatedInfo($e, e.createDiagnosticForNode(me, e.Diagnostics.The_shadowing_declaration_of_0_is_defined_here, u), e.createDiagnosticForNode(h, e.Diagnostics.The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here, u)), true;
                    }
                  }
                  return Xr(i, e.Diagnostics.Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier, u, ku(z2.name || C)), true;
                }
                return false;
              }
              function HC(r, i) {
                return (Le(i) || e.isThisProperty(r) && Nr(i)) && e.getThisContainer(r, true) === ri(i);
              }
              function zb(r, i, t, o, s) {
                var u = va(i).resolvedSymbol, h = e.getAssignmentTargetKind(r), z2 = $s(h !== 0 || GC(r) ? $c(t) : t), me = ta(z2) || z2 === Bt, Me;
                if (e.isPrivateIdentifier(o)) {
                  Ae < 99 && (h !== 0 && fc(r, 1048576), h !== 1 && fc(r, 524288));
                  var $e = g0(o.escapedText, o);
                  if (h && $e && $e.valueDeclaration && e.isMethodDeclaration($e.valueDeclaration) && Tt(o, e.Diagnostics.Cannot_assign_to_private_method_0_Private_methods_are_not_writable, e.idText(o)), me) {
                    if ($e) return nn(z2) ? Pe : z2;
                    if (!e.getContainingClass(o)) return Tt(o, e.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies), Oe;
                  }
                  if (Me = $e ? Ub(t, $e) : void 0, !Me && G5(t, o, $e)) return Pe;
                  var tr = Me && Me.flags & 65536 && !(Me.flags & 32768);
                  tr && h !== 1 && Xr(r, e.Diagnostics.Private_accessor_was_defined_without_a_getter);
                } else {
                  if (me) return e.isIdentifier(i) && u && o0(u, r), nn(z2) ? Pe : z2;
                  Me = bi(z2, o.escapedText);
                }
                e.isIdentifier(i) && u && (ye.isolatedModules || !(Me && (Av(Me) || Me.flags & 8 && r.parent.kind === 299)) || e.shouldPreserveConstEnums(ye) && mC(r)) && o0(u, r);
                var dr;
                if (Me) {
                  P_(Me) && mD(r, Me) && Me.declarations && El(o, Me.declarations, o.escapedText), H5(Me, r, o), xy(Me, r, rk(i, u)), va(r).resolvedSymbol = Me;
                  var li = e.isWriteAccess(r);
                  if (Jb(r, i.kind === 106, li, z2, Me), jk(r, Me, h)) return Xr(o, e.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, e.idText(o)), Pe;
                  dr = HC(r, Me) ? nr : li ? Vg(Me) : Jt(Me);
                } else {
                  var Dr = !e.isPrivateIdentifier(o) && (h === 0 || !Ad(t) || e.isThisTypeParameter(t)) ? Xo(z2, o.escapedText) : void 0;
                  if (!(Dr && Dr.type)) {
                    var Qr = Wb(r, t.symbol, true);
                    return !Qr && ev(t) ? Oe : t.symbol === pe ? (pe.exports.has(o.escapedText) && pe.exports.get(o.escapedText).flags & 418 ? Xr(o, e.Diagnostics.Property_0_does_not_exist_on_type_1, e.unescapeLeadingUnderscores(o.escapedText), Ot(t)) : n && Xr(o, e.Diagnostics.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature, Ot(t)), Oe) : (o.escapedText && !bp(r) && YC(o, e.isThisTypeParameter(t) ? z2 : t, Qr), Pe);
                  }
                  Dr.isReadonly && (e.isAssignmentTarget(r) || e.isDeleteTarget(r)) && Xr(r, e.Diagnostics.Index_signature_in_type_0_only_permits_reading, Ot(z2)), dr = ye.noUncheckedIndexedAccess && !e.isAssignmentTarget(r) ? Pa([Dr.type, Tr]) : Dr.type, ye.noPropertyAccessFromIndexSignature && e.isPropertyAccessExpression(r) && Xr(o, e.Diagnostics.Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0, e.unescapeLeadingUnderscores(o.escapedText)), Dr.declaration && e.getCombinedNodeFlags(Dr.declaration) & 268435456 && El(o, [Dr.declaration], o.escapedText);
                }
                return XC(r, Me, dr, o, s);
              }
              function Wb(r, i, t) {
                var o = e.getSourceFileOfNode(r);
                if (o && ye.checkJs === void 0 && o.checkJsDirective === void 0 && (o.scriptKind === 1 || o.scriptKind === 2)) {
                  var s = e.forEach(i == null ? void 0 : i.declarations, e.getSourceFileOfNode);
                  return !(o !== s && !!s && Cu(s)) && !(t && i && i.flags & 32) && !(!!r && t && e.isPropertyAccessExpression(r) && r.expression.kind === 108);
                }
                return false;
              }
              function XC(r, i, t, o, s) {
                var u = e.getAssignmentTargetKind(r);
                if (u === 1) return kg(t, !!(i && i.flags & 16777216));
                if (i && !(i.flags & 98311) && !(i.flags & 8192 && t.flags & 1048576) && !z0(i.declarations)) return t;
                if (t === nr) return ra(r, i);
                t = yb(t, r, s);
                var h = false;
                if (Ye && Ne && e.isAccessExpression(r) && r.expression.kind === 108) {
                  var z2 = i && i.valueDeclaration;
                  if (z2 && J6(z2) && !e.isStatic(z2)) {
                    var me = _v(r);
                    me.kind === 171 && me.parent === z2.parent && !(z2.flags & 16777216) && (h = true);
                  }
                } else Ye && i && i.valueDeclaration && e.isPropertyAccessExpression(i.valueDeclaration) && e.getAssignmentDeclarationPropertyAccessKind(i.valueDeclaration) && _v(r) === _v(i.valueDeclaration) && (h = true);
                var Me = up(r, t, h ? i_(t) : t);
                return h && !(ju(t) & 32768) && ju(Me) & 32768 ? (Xr(o, e.Diagnostics.Property_0_is_used_before_being_assigned, tn(i)), t) : u ? Kl(Me) : Me;
              }
              function H5(r, i, t) {
                var o = r.valueDeclaration;
                if (!(!o || e.getSourceFileOfNode(i).isDeclarationFile)) {
                  var s, u = e.idText(t);
                  QC(i) && !qm(o) && !(e.isAccessExpression(i) && e.isAccessExpression(i.expression)) && !ns(o, t) && !(e.isMethodDeclaration(o) && e.getCombinedModifierFlags(o) & 32) && (ye.useDefineForClassFields || !X5(r)) ? s = Xr(t, e.Diagnostics.Property_0_is_used_before_its_initialization, u) : o.kind === 257 && i.parent.kind !== 178 && !(o.flags & 16777216) && !ns(o, t) && (s = Xr(t, e.Diagnostics.Class_0_used_before_its_declaration, u)), s && e.addRelatedInfo(s, e.createDiagnosticForNode(o, e.Diagnostics._0_is_declared_here, u));
                }
              }
              function QC(r) {
                return !!e.findAncestor(r, function(i) {
                  switch (i.kind) {
                    case 167:
                      return true;
                    case 296:
                    case 169:
                    case 172:
                    case 173:
                    case 298:
                    case 162:
                    case 233:
                    case 288:
                    case 285:
                    case 286:
                    case 287:
                    case 280:
                    case 228:
                    case 291:
                      return false;
                    case 214:
                    case 238:
                      return e.isBlock(i.parent) && e.isClassStaticBlockDeclaration(i.parent.parent) ? true : "quit";
                    default:
                      return e.isExpressionNode(i) ? false : "quit";
                  }
                });
              }
              function X5(r) {
                if (!(r.parent.flags & 32)) return false;
                for (var i = Jt(r.parent); ; ) {
                  if (i = i.symbol && Q5(i), !i) return false;
                  var t = bi(i, r.escapedName);
                  if (t && t.valueDeclaration) return true;
                }
              }
              function Q5(r) {
                var i = Qc(r);
                if (i.length !== 0) return Do(i);
              }
              function YC(r, i, t) {
                var o, s;
                if (!e.isPrivateIdentifier(r) && i.flags & 1048576 && !(i.flags & 131068)) for (var u = 0, h = i.types; u < h.length; u++) {
                  var z2 = h[u];
                  if (!bi(z2, r.escapedText) && !Xo(z2, r.escapedText)) {
                    o = e.chainDiagnosticMessages(o, e.Diagnostics.Property_0_does_not_exist_on_type_1, e.declarationNameToString(r), Ot(z2));
                    break;
                  }
                }
                if ($C(r.escapedText, i)) {
                  var me = e.declarationNameToString(r), Me = Ot(i);
                  o = e.chainDiagnosticMessages(o, e.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead, me, Me, Me + "." + me);
                } else {
                  var $e = Tv(i);
                  if ($e && bi($e, r.escapedText)) o = e.chainDiagnosticMessages(o, e.Diagnostics.Property_0_does_not_exist_on_type_1, e.declarationNameToString(r), Ot(i)), s = e.createDiagnosticForNode(r, e.Diagnostics.Did_you_forget_to_use_await);
                  else {
                    var tr = e.declarationNameToString(r), dr = Ot(i), Dr = Z5(tr, i);
                    if (Dr !== void 0) o = e.chainDiagnosticMessages(o, e.Diagnostics.Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2_or_later, tr, dr, Dr);
                    else {
                      var Qr = qb(r, i);
                      if (Qr !== void 0) {
                        var li = e.symbolName(Qr), Ti = t ? e.Diagnostics.Property_0_may_not_exist_on_type_1_Did_you_mean_2 : e.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2;
                        o = e.chainDiagnosticMessages(o, Ti, tr, dr, li), s = Qr.valueDeclaration && e.createDiagnosticForNode(Qr.valueDeclaration, e.Diagnostics._0_is_declared_here, li);
                      } else {
                        var Ci = Y5(i) ? e.Diagnostics.Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom : e.Diagnostics.Property_0_does_not_exist_on_type_1;
                        o = e.chainDiagnosticMessages(ei(o, i), Ci, tr, dr);
                      }
                    }
                  }
                }
                var $i = e.createDiagnosticForNodeFromMessageChain(r, o);
                s && e.addRelatedInfo($i, s), Ls(!t || o.code !== e.Diagnostics.Property_0_may_not_exist_on_type_1_Did_you_mean_2.code, $i);
              }
              function Y5(r) {
                return ye.lib && !ye.lib.includes("dom") && h8(r, function(i) {
                  return i.symbol && /^(EventTarget|Node|((HTML[a-zA-Z]*)?Element))$/.test(e.unescapeLeadingUnderscores(i.symbol.escapedName));
                }) && Of(r);
              }
              function $C(r, i) {
                var t = i.symbol && bi(Jt(i.symbol), r);
                return t !== void 0 && !!t.valueDeclaration && e.isStatic(t.valueDeclaration);
              }
              function $5(r) {
                for (var i = ku(r), t = e.getScriptTargetFeatures(), o = e.getOwnKeys(t), s = 0, u = o; s < u.length; s++) {
                  var h = u[s], z2 = e.getOwnKeys(t[h]);
                  if (z2 !== void 0 && e.contains(z2, i)) return h;
                }
              }
              function Z5(r, i) {
                var t = $s(i).symbol;
                if (!!t) for (var o = e.getScriptTargetFeatures(), s = e.getOwnKeys(o), u = 0, h = s; u < h.length; u++) {
                  var z2 = h[u], me = o[z2], Me = me[e.symbolName(t)];
                  if (Me !== void 0 && e.contains(Me, r)) return z2;
                }
              }
              function ZC(r, i) {
                return Ty(r, uo(i), 106500);
              }
              function qb(r, i) {
                var t = uo(i);
                if (typeof r != "string") {
                  var o = r.parent;
                  e.isPropertyAccessExpression(o) && (t = e.filter(t, function(s) {
                    return ik(o, i, s);
                  })), r = e.idText(r);
                }
                return Ty(r, t, 111551);
              }
              function ek(r, i) {
                var t = e.isString(r) ? r : e.idText(r), o = uo(i), s = t === "for" ? e.find(o, function(u) {
                  return e.symbolName(u) === "htmlFor";
                }) : t === "class" ? e.find(o, function(u) {
                  return e.symbolName(u) === "className";
                }) : void 0;
                return s != null ? s : Ty(t, o, 111551);
              }
              function Vb(r, i) {
                var t = qb(r, i);
                return t && e.symbolName(t);
              }
              function Kb(r, i, t) {
                e.Debug.assert(i !== void 0, "outername should always be defined");
                var o = u_(r, i, t, void 0, i, false, false, true, function(s, u, h) {
                  e.Debug.assertEqual(i, u, "name should equal outerName");
                  var z2 = qs(s, u, h);
                  if (z2) return z2;
                  var me;
                  if (s === ii) {
                    var Me = e.mapDefined(["string", "number", "boolean", "object", "bigint", "symbol"], function($e) {
                      return s.has($e.charAt(0).toUpperCase() + $e.slice(1)) ? oo(524288, $e) : void 0;
                    });
                    me = Me.concat(e.arrayFrom(s.values()));
                  } else me = e.arrayFrom(s.values());
                  return Ty(e.unescapeLeadingUnderscores(u), me, h);
                });
                return o;
              }
              function e7(r, i, t) {
                var o = Kb(r, i, t);
                return o && e.symbolName(o);
              }
              function v0(r, i) {
                return i.exports && Ty(e.idText(r), J_(i), 2623475);
              }
              function r7(r, i) {
                var t = v0(r, i);
                return t && e.symbolName(t);
              }
              function i7(r, i, t) {
                function o(h) {
                  var z2 = h_(r, h);
                  if (z2) {
                    var me = ig(Jt(z2));
                    return !!me && Hl(me) >= 1 && ao(t, $u(me, 0));
                  }
                  return false;
                }
                var s = e.isAssignmentTarget(i) ? "set" : "get";
                if (!!o(s)) {
                  var u = e.tryGetPropertyAccessOrIdentifierToString(i.expression);
                  return u === void 0 ? u = s : u += "." + s, u;
                }
              }
              function t7(r, i) {
                var t = i.types.filter(function(o) {
                  return !!(o.flags & 128);
                });
                return e.getSpellingSuggestion(r.value, t, function(o) {
                  return o.value;
                });
              }
              function Ty(r, i, t) {
                return e.getSpellingSuggestion(r, i, o);
                function o(s) {
                  var u = e.symbolName(s);
                  if (!e.startsWith(u, '"')) {
                    if (s.flags & t) return u;
                    if (s.flags & 2097152) {
                      var h = d_(s);
                      if (h && h.flags & t) return u;
                    }
                  }
                }
              }
              function xy(r, i, t) {
                var o = r && r.flags & 106500 && r.valueDeclaration;
                if (!!o) {
                  var s = e.hasEffectiveModifier(o, 8), u = r.valueDeclaration && e.isNamedDeclaration(r.valueDeclaration) && e.isPrivateIdentifier(r.valueDeclaration.name);
                  if (!(!s && !u) && !(i && e.isWriteOnlyAccess(i) && !(r.flags & 65536))) {
                    if (t) {
                      var h = e.findAncestor(i, e.isFunctionLikeDeclaration);
                      if (h && h.symbol === r) return;
                    }
                    (e.getCheckFlags(r) & 1 ? Aa(r).target : r).isReferenced = 67108863;
                  }
                }
              }
              function rk(r, i) {
                return r.kind === 108 || !!i && e.isEntityNameExpression(r) && i === Dl(e.getFirstIdentifier(r));
              }
              function a7(r, i) {
                switch (r.kind) {
                  case 206:
                    return Gb(r, r.expression.kind === 106, i, $c(yn(r.expression)));
                  case 161:
                    return Gb(r, false, i, $c(yn(r.left)));
                  case 200:
                    return Gb(r, false, i, Va(r));
                }
              }
              function ik(r, i, t) {
                return Hb(r, r.kind === 206 && r.expression.kind === 106, false, i, t);
              }
              function Gb(r, i, t, o) {
                if (ta(o)) return true;
                var s = bi(o, t);
                return !!s && Hb(r, i, false, o, s);
              }
              function Hb(r, i, t, o, s) {
                if (ta(o)) return true;
                if (s.valueDeclaration && e.isPrivateIdentifierClassElementDeclaration(s.valueDeclaration)) {
                  var u = e.getContainingClass(s.valueDeclaration);
                  return !e.isOptionalChain(r) && !!e.findAncestor(r, function(h) {
                    return h === u;
                  });
                }
                return UC(r, i, t, o, s);
              }
              function n7(r) {
                var i = r.initializer;
                if (i.kind === 255) {
                  var t = i.declarations[0];
                  if (t && !e.isBindingPattern(t.name)) return Et(t);
                } else if (i.kind === 79) return Dl(i);
              }
              function o7(r) {
                return Hn(r).length === 1 && !!ss(r, nt);
              }
              function s7(r) {
                var i = e.skipParentheses(r);
                if (i.kind === 79) {
                  var t = Dl(i);
                  if (t.flags & 3) for (var o = r, s = r.parent; s; ) {
                    if (s.kind === 243 && o === s.statement && n7(s) === t && o7(Gs(s.expression))) return true;
                    o = s, s = s.parent;
                  }
                }
                return false;
              }
              function c7(r, i) {
                return r.flags & 32 ? u7(r, i) : tk(r, gm(r.expression), i);
              }
              function u7(r, i) {
                var t = yn(r.expression), o = cv(t, r.expression);
                return zh(tk(r, bl(o, r.expression), i), r, o !== t);
              }
              function tk(r, i, t) {
                var o = e.getAssignmentTargetKind(r) !== 0 || GC(r) ? $c(i) : i, s = r.argumentExpression, u = yn(s);
                if (nn(o) || o === Bt) return o;
                if (uS(o) && !e.isStringLiteralLike(s)) return Xr(s, e.Diagnostics.A_const_enum_member_can_only_be_accessed_using_a_string_literal), Pe;
                var h = s7(s) ? nt : u, z2 = e.isAssignmentTarget(r) ? 4 | (Ad(o) && !e.isThisTypeParameter(o) ? 2 : 0) : 32, me = ep(o, h, z2, r) || Pe;
                return o6(XC(r, va(r).resolvedSymbol, me, s, t), r);
              }
              function ak(r) {
                return e.isCallOrNewExpression(r) || e.isTaggedTemplateExpression(r) || e.isJsxOpeningLikeElement(r);
              }
              function Fg(r) {
                return ak(r) && e.forEach(r.typeArguments, io), r.kind === 210 ? yn(r.template) : e.isJsxOpeningLikeElement(r) ? yn(r.attributes) : r.kind !== 165 && e.forEach(r.arguments, function(i) {
                  yn(i);
                }), En;
              }
              function Gl(r) {
                return Fg(r), Wn;
              }
              function l7(r, i, t) {
                var o, s, u = 0, h, z2 = -1, me;
                e.Debug.assert(!i.length);
                for (var Me = 0, $e = r; Me < $e.length; Me++) {
                  var tr = $e[Me], dr = tr.declaration && Et(tr.declaration), Dr = tr.declaration && tr.declaration.parent;
                  !s || dr === s ? o && Dr === o ? h = h + 1 : (o = Dr, h = u) : (h = u = i.length, o = Dr), s = dr, I(tr) ? (z2++, me = z2, u++) : me = h, i.splice(me, 0, t ? w1(tr, t) : tr);
                }
              }
              function y0(r) {
                return !!r && (r.kind === 225 || r.kind === 232 && r.isSpread);
              }
              function h0(r) {
                return e.findIndex(r, y0);
              }
              function nk(r) {
                return !!(r.flags & 16384);
              }
              function f7(r) {
                return !!(r.flags & 49155);
              }
              function D0(r, i, t, o) {
                o === void 0 && (o = false);
                var s, u = false, h = Wc(t), z2 = Hl(t);
                if (r.kind === 210) if (s = i.length, r.template.kind === 223) {
                  var me = e.last(r.template.templateSpans);
                  u = e.nodeIsMissing(me.literal) || !!me.literal.isUnterminated;
                } else {
                  var Me = r.template;
                  e.Debug.assert(Me.kind === 14), u = !!Me.isUnterminated;
                }
                else if (r.kind === 165) s = _k(r, t);
                else if (e.isJsxOpeningLikeElement(r)) {
                  if (u = r.attributes.end === r.end, u) return true;
                  s = z2 === 0 ? i.length : 1, h = i.length === 0 ? h : 1, z2 = Math.min(z2, 1);
                } else if (r.arguments) {
                  s = o ? i.length + 1 : i.length, u = r.arguments.end === r.end;
                  var $e = h0(i);
                  if ($e >= 0) return $e >= Hl(t) && (Xl(t) || $e < Wc(t));
                } else return e.Debug.assert(r.kind === 209), Hl(t) === 0;
                if (!Xl(t) && s > h) return false;
                if (u || s >= z2) return true;
                for (var tr = s; tr < z2; tr++) {
                  var dr = $u(t, tr);
                  if (ec(dr, e.isInJSFile(r) && !Ye ? f7 : nk).flags & 131072) return false;
                }
                return true;
              }
              function Xb(r, i) {
                var t = e.length(r.typeParameters), o = Ul(r.typeParameters);
                return !e.some(i) || i.length >= o && i.length <= t;
              }
              function ig(r) {
                return gv(r, 0, false);
              }
              function ok(r) {
                return gv(r, 0, false) || gv(r, 1, false);
              }
              function gv(r, i, t) {
                if (r.flags & 524288) {
                  var o = Ru(r);
                  if (t || o.properties.length === 0 && o.indexInfos.length === 0) {
                    if (i === 0 && o.callSignatures.length === 1 && o.constructSignatures.length === 0) return o.callSignatures[0];
                    if (i === 1 && o.constructSignatures.length === 1 && o.callSignatures.length === 0) return o.constructSignatures[0];
                  }
                }
              }
              function sk(r, i, t, o) {
                var s = uv(r.typeParameters, r, 0, o), u = vv(i), h = t && (u && u.flags & 262144 ? t.nonFixingMapper : t.mapper), z2 = h ? Tg(i, h) : i;
                return eb(z2, r, function(me, Me) {
                  df(s.inferences, me, Me);
                }), t || rb(i, r, function(me, Me) {
                  df(s.inferences, me, Me, 128);
                }), Xm(r, _b(s), e.isInJSFile(i.declaration));
              }
              function _7(r, i, t, o) {
                var s = l0(i, r), u = Rg(r.attributes, s, o, t);
                return df(o.inferences, u, s), _b(o);
              }
              function ck(r) {
                if (!r) return Fi;
                var i = yn(r);
                return e.isOptionalChainRoot(r.parent) ? C_(i) : e.isOptionalChain(r.parent) ? YD(i) : i;
              }
              function Qb(r, i, t, o, s) {
                if (e.isJsxOpeningLikeElement(r)) return _7(r, i, o, s);
                if (r.kind !== 165) {
                  var u = ou(r, e.every(i.typeParameters, function(Sn) {
                    return !!D_(Sn);
                  }) ? 8 : 0);
                  if (u) {
                    var h = yo(i);
                    if (Id(h)) {
                      var z2 = wg(r), me = ab(Jw(z2, 1)), Me = un(u, me), $e = ig(Me), tr = $e && $e.typeParameters ? im(eD($e, $e.typeParameters)) : Me;
                      df(s.inferences, tr, h, 128);
                      var dr = uv(i.typeParameters, i, s.flags), Dr = un(u, z2 && z2.returnMapper);
                      df(dr.inferences, Dr, h), s.returnMapper = e.some(dr.inferences, tg) ? ab(Uw(dr)) : void 0;
                    }
                  }
                }
                var Qr = yv(i), li = Qr ? Math.min(Wc(i) - 1, t.length) : t.length;
                if (Qr && Qr.flags & 262144) {
                  var Ti = e.find(s.inferences, function(Sn) {
                    return Sn.typeParameter === Qr;
                  });
                  Ti && (Ti.impliedArity = e.findIndex(t, y0, li) < 0 ? t.length - li : void 0);
                }
                var Ci = T_(i);
                if (Ci && Id(Ci)) {
                  var $i = fk(r);
                  df(s.inferences, ck($i), Ci);
                }
                for (var Zi = 0; Zi < li; Zi++) {
                  var qt = t[Zi];
                  if (qt.kind !== 227 && !(o & 32 && ub(qt))) {
                    var Nt = $u(i, Zi);
                    if (Id(Nt)) {
                      var Ra = Rg(qt, Nt, s, o);
                      df(s.inferences, Ra, Nt);
                    }
                  }
                }
                if (Qr && Id(Qr)) {
                  var ca = Yb(t, li, t.length, Qr, s, o);
                  df(s.inferences, ca, Qr);
                }
                return _b(s);
              }
              function uk(r) {
                return r.flags & 1048576 ? Ss(r, uk) : r.flags & 1 || Bh(uc(r) || r) ? r : Yn(r) ? Wl(xo(r), r.target.elementFlags, false, r.target.labeledElementDeclarations) : Wl([r], [8]);
              }
              function Yb(r, i, t, o, s, u) {
                if (i >= t - 1) {
                  var h = r[t - 1];
                  if (y0(h)) return uk(h.kind === 232 ? h.type : Rg(h.expression, o, s, u));
                }
                for (var z2 = [], me = [], Me = [], $e = i; $e < t; $e++) {
                  var h = r[$e];
                  if (y0(h)) {
                    var tr = h.kind === 232 ? h.type : yn(h.expression);
                    sp(tr) ? (z2.push(tr), me.push(8)) : (z2.push(N_(33, tr, Tr, h.kind === 225 ? h.expression : h)), me.push(4));
                  } else {
                    var dr = Jc(o, If($e - i), 256), Dr = Rg(h, dr, s, u), Qr = fs(dr, 406978556);
                    z2.push(Qr ? jc(Dr) : Hp(Dr)), me.push(1);
                  }
                  h.kind === 232 && h.tupleNameSource && Me.push(h.tupleNameSource);
                }
                return Wl(z2, me, false, e.length(Me) === e.length(z2) ? Me : void 0);
              }
              function $b(r, i, t, o) {
                for (var s = e.isInJSFile(r.declaration), u = r.typeParameters, h = zp(e.map(i, Va), u, Ul(u), s), z2, me = 0; me < i.length; me++) {
                  e.Debug.assert(u[me] !== void 0, "Should not call checkTypeArguments with too many type arguments");
                  var Me = Tc(u[me]);
                  if (Me) {
                    var $e = t && o ? function() {
                      return e.chainDiagnosticMessages(void 0, e.Diagnostics.Type_0_does_not_satisfy_the_constraint_1);
                    } : void 0, tr = o || e.Diagnostics.Type_0_does_not_satisfy_the_constraint_1;
                    z2 || (z2 = Uc(u, h));
                    var dr = h[me];
                    if (!zc(dr, Rc(un(Me, z2), dr), t ? i[me] : void 0, tr, $e)) return;
                  }
                }
                return h;
              }
              function lk(r) {
                if (dm(r.tagName)) return 2;
                var i = $s(yn(r.tagName));
                return e.length(ot(i, 1)) ? 0 : e.length(ot(i, 0)) ? 1 : 2;
              }
              function p7(r, i, t, o, s, u, h) {
                var z2 = l0(i, r), me = Rg(r.attributes, z2, void 0, o);
                return Me() && FD(me, z2, t, s ? r.tagName : void 0, r.attributes, void 0, u, h);
                function Me() {
                  var $e;
                  if (Mb(r)) return true;
                  var tr = e.isJsxOpeningElement(r) || e.isJsxSelfClosingElement(r) && !dm(r.tagName) ? yn(r.tagName) : void 0;
                  if (!tr) return true;
                  var dr = ot(tr, 0);
                  if (!e.length(dr)) return true;
                  var Dr = oA(r);
                  if (!Dr) return true;
                  var Qr = Ds(Dr, 111551, true, false, r);
                  if (!Qr) return true;
                  var li = Jt(Qr), Ti = ot(li, 0);
                  if (!e.length(Ti)) return true;
                  for (var Ci = false, $i = 0, Zi = 0, qt = Ti; Zi < qt.length; Zi++) {
                    var Nt = qt[Zi], Ra = $u(Nt, 0), ca = ot(Ra, 0);
                    if (!!e.length(ca)) for (var Sn = 0, ja = ca; Sn < ja.length; Sn++) {
                      var Fn = ja[Sn];
                      if (Ci = true, Xl(Fn)) return true;
                      var wn = Wc(Fn);
                      wn > $i && ($i = wn);
                    }
                  }
                  if (!Ci) return true;
                  for (var Tn = 1 / 0, Eo = 0, lt = dr; Eo < lt.length; Eo++) {
                    var it = lt[Eo], Yt = Hl(it);
                    Yt < Tn && (Tn = Yt);
                  }
                  if (Tn <= $i) return true;
                  if (s) {
                    var Ia = e.createDiagnosticForNode(r.tagName, e.Diagnostics.Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3, e.entityNameToString(r.tagName), Tn, e.entityNameToString(Dr), $i), Qt = ($e = el(r.tagName)) === null || $e === void 0 ? void 0 : $e.valueDeclaration;
                    Qt && e.addRelatedInfo(Ia, e.createDiagnosticForNode(Qt, e.Diagnostics._0_is_declared_here, e.entityNameToString(r.tagName))), h && h.skipLogging && (h.errors || (h.errors = [])).push(Ia), h.skipLogging || rn.add(Ia);
                  }
                  return false;
                }
              }
              function Ey(r, i, t, o, s, u, h) {
                var z2 = { errors: void 0, skipLogging: true };
                if (e.isJsxOpeningLikeElement(r)) return p7(r, t, o, s, u, h, z2) ? void 0 : (e.Debug.assert(!u || !!z2.errors, "jsx should have errors when reporting errors"), z2.errors || e.emptyArray);
                var me = T_(t);
                if (me && me !== Fi && r.kind !== 209) {
                  var Me = fk(r), $e = ck(Me), tr = u ? Me || r : void 0, dr = e.Diagnostics.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1;
                  if (!hl($e, me, o, tr, dr, h, z2)) return e.Debug.assert(!u || !!z2.errors, "this parameter should have errors when reporting errors"), z2.errors || e.emptyArray;
                }
                for (var Dr = e.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1, Qr = yv(t), li = Qr ? Math.min(Wc(t) - 1, i.length) : i.length, Ti = 0; Ti < li; Ti++) {
                  var Ci = i[Ti];
                  if (Ci.kind !== 227) {
                    var $i = $u(t, Ti), Zi = Rg(Ci, $i, void 0, s), qt = s & 4 ? fm(Zi) : Zi;
                    if (!FD(qt, $i, o, u ? Ci : void 0, Ci, Dr, h, z2)) return e.Debug.assert(!u || !!z2.errors, "parameter should have errors when reporting errors"), ca(Ci, qt, $i), z2.errors || e.emptyArray;
                  }
                }
                if (Qr) {
                  var Nt = Yb(i, li, i.length, Qr, void 0, s), Ra = i.length - li, tr = u ? Ra === 0 ? r : Ra === 1 ? i[li] : e.setTextRangePosEnd(ed(r, Nt), i[li].pos, i[i.length - 1].end) : void 0;
                  if (!hl(Nt, Qr, o, tr, Dr, void 0, z2)) return e.Debug.assert(!u || !!z2.errors, "rest parameter should have errors when reporting errors"), ca(tr, Nt, Qr), z2.errors || e.emptyArray;
                }
                return;
                function ca(Sn, ja, Fn) {
                  if (Sn && u && z2.errors && z2.errors.length) {
                    if (Sv(Fn)) return;
                    var wn = Sv(ja);
                    wn && r_(wn, Fn, o) && e.addRelatedInfo(z2.errors[0], e.createDiagnosticForNode(Sn, e.Diagnostics.Did_you_forget_to_use_await));
                  }
                }
              }
              function fk(r) {
                var i = r.kind === 208 ? r.expression : r.kind === 210 ? r.tag : void 0;
                if (i) {
                  var t = e.skipOuterExpressions(i);
                  if (e.isAccessExpression(t)) return t.expression;
                }
              }
              function ed(r, i, t, o) {
                var s = e.parseNodeFactory.createSyntheticExpression(i, t, o);
                return e.setTextRange(s, r), e.setParent(s, r), s;
              }
              function Zb(r) {
                if (r.kind === 210) {
                  var i = r.template, t = [ed(i, T3())];
                  return i.kind === 223 && e.forEach(i.templateSpans, function(me) {
                    t.push(me.expression);
                  }), t;
                }
                if (r.kind === 165) return d7(r);
                if (e.isJsxOpeningLikeElement(r)) return r.attributes.properties.length > 0 || e.isJsxOpeningElement(r) && r.parent.children.length > 0 ? [r.attributes] : e.emptyArray;
                var o = r.arguments || e.emptyArray, s = h0(o);
                if (s >= 0) {
                  for (var u = o.slice(0, s), h = function(me) {
                    var Me = o[me], $e = Me.kind === 225 && (Ao ? yn(Me.expression) : Os(Me.expression));
                    $e && Yn($e) ? e.forEach(xo($e), function(tr, dr) {
                      var Dr, Qr = $e.target.elementFlags[dr], li = ed(Me, Qr & 4 ? Zs(tr) : tr, !!(Qr & 12), (Dr = $e.target.labeledElementDeclarations) === null || Dr === void 0 ? void 0 : Dr[dr]);
                      u.push(li);
                    }) : u.push(Me);
                  }, z2 = s; z2 < o.length; z2++) h(z2);
                  return u;
                }
                return o;
              }
              function d7(r) {
                var i = r.parent, t = r.expression;
                switch (i.kind) {
                  case 257:
                  case 226:
                    return [ed(t, Jt(Et(i)))];
                  case 164:
                    var o = i.parent;
                    return [ed(t, i.parent.kind === 171 ? Jt(Et(o)) : Pe), ed(t, Oe), ed(t, nt)];
                  case 167:
                  case 169:
                  case 172:
                  case 173:
                    var s = i.kind !== 167 && Ae !== 0;
                    return [ed(t, l9(i)), ed(t, f9(i)), ed(t, s ? Px(Bd(i)) : Oe)];
                }
                return e.Debug.fail();
              }
              function _k(r, i) {
                switch (r.parent.kind) {
                  case 257:
                  case 226:
                    return 1;
                  case 167:
                    return 2;
                  case 169:
                  case 172:
                  case 173:
                    return Ae === 0 || i.parameters.length <= 2 ? 2 : 3;
                  case 164:
                    return 3;
                  default:
                    return e.Debug.fail();
                }
              }
              function pk(r, i) {
                var t, o, s = e.getSourceFileOfNode(r);
                if (e.isPropertyAccessExpression(r.expression)) {
                  var u = e.getErrorSpanForNode(s, r.expression.name);
                  t = u.start, o = i ? u.length : r.end - t;
                } else {
                  var h = e.getErrorSpanForNode(s, r.expression);
                  t = h.start, o = i ? h.length : r.end - t;
                }
                return { start: t, length: o, sourceFile: s };
              }
              function Cy(r, i, t, o, s, u) {
                if (e.isCallExpression(r)) {
                  var h = pk(r), z2 = h.sourceFile, me = h.start, Me = h.length;
                  return e.createFileDiagnostic(z2, me, Me, i, t, o, s, u);
                } else return e.createDiagnosticForNode(r, i, t, o, s, u);
              }
              function g7(r) {
                if (!e.isCallExpression(r) || !e.isIdentifier(r.expression)) return false;
                var i = es(r.expression, r.expression.escapedText, 111551, void 0, void 0, false), t = i == null ? void 0 : i.valueDeclaration;
                if (!t || !e.isParameter(t) || !e.isFunctionExpressionOrArrowFunction(t.parent) || !e.isNewExpression(t.parent.parent) || !e.isIdentifier(t.parent.parent.expression)) return false;
                var o = nD(false);
                if (!o) return false;
                var s = el(t.parent.parent.expression, true);
                return s === o;
              }
              function dk(r, i, t) {
                var o, s = h0(t);
                if (s > -1) return e.createDiagnosticForNode(t[s], e.Diagnostics.A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter);
                for (var u = Number.POSITIVE_INFINITY, h = Number.NEGATIVE_INFINITY, z2 = Number.NEGATIVE_INFINITY, me = Number.POSITIVE_INFINITY, Me, $e = 0, tr = i; $e < tr.length; $e++) {
                  var dr = tr[$e], Dr = Hl(dr), Qr = Wc(dr);
                  Dr < u && (u = Dr, Me = dr), h = Math.max(h, Qr), Dr < t.length && Dr > z2 && (z2 = Dr), t.length < Qr && Qr < me && (me = Qr);
                }
                var li = e.some(i, Xl), Ti = li ? u : u < h ? u + "-" + h : u, Ci = !li && Ti === 1 && t.length === 0 && g7(r);
                if (Ci && e.isInJSFile(r)) return Cy(r, e.Diagnostics.Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments);
                var $i = li ? e.Diagnostics.Expected_at_least_0_arguments_but_got_1 : Ci ? e.Diagnostics.Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise : e.Diagnostics.Expected_0_arguments_but_got_1;
                if (u < t.length && t.length < h) return Cy(r, e.Diagnostics.No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments, t.length, z2, me);
                if (t.length < u) {
                  var Zi = Cy(r, $i, Ti, t.length), qt = (o = Me == null ? void 0 : Me.declaration) === null || o === void 0 ? void 0 : o.parameters[Me.thisParameter ? t.length + 1 : t.length];
                  if (qt) {
                    var Nt = e.createDiagnosticForNode(qt, e.isBindingPattern(qt.name) ? e.Diagnostics.An_argument_matching_this_binding_pattern_was_not_provided : e.isRestParameter(qt) ? e.Diagnostics.Arguments_for_the_rest_parameter_0_were_not_provided : e.Diagnostics.An_argument_for_0_was_not_provided, qt.name ? e.isBindingPattern(qt.name) ? void 0 : e.idText(e.getFirstIdentifier(qt.name)) : t.length);
                    return e.addRelatedInfo(Zi, Nt);
                  }
                  return Zi;
                } else {
                  var Ra = e.factory.createNodeArray(t.slice(h)), ca = e.first(Ra).pos, Sn = e.last(Ra).end;
                  return Sn === ca && Sn++, e.setTextRangePosEnd(Ra, ca, Sn), e.createDiagnosticForNodeArray(e.getSourceFileOfNode(r), Ra, $i, Ti, t.length);
                }
              }
              function m7(r, i, t) {
                var o = t.length;
                if (i.length === 1) {
                  var s = i[0], u = Ul(s.typeParameters), h = e.length(s.typeParameters);
                  return e.createDiagnosticForNodeArray(e.getSourceFileOfNode(r), t, e.Diagnostics.Expected_0_type_arguments_but_got_1, u < h ? u + "-" + h : u, o);
                }
                for (var z2 = -1 / 0, me = 1 / 0, Me = 0, $e = i; Me < $e.length; Me++) {
                  var s = $e[Me], tr = Ul(s.typeParameters), h = e.length(s.typeParameters);
                  tr > o ? me = Math.min(me, tr) : h < o && (z2 = Math.max(z2, h));
                }
                return z2 !== -1 / 0 && me !== 1 / 0 ? e.createDiagnosticForNodeArray(e.getSourceFileOfNode(r), t, e.Diagnostics.No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments, o, z2, me) : e.createDiagnosticForNodeArray(e.getSourceFileOfNode(r), t, e.Diagnostics.Expected_0_type_arguments_but_got_1, z2 === -1 / 0 ? me : z2, o);
              }
              function mm(r, i, t, o, s, u) {
                var h = r.kind === 210, z2 = r.kind === 165, me = e.isJsxOpeningLikeElement(r), Me = !t, $e;
                z2 || ($e = r.typeArguments, (h || me || r.expression.kind !== 106) && e.forEach($e, io));
                var tr = t || [];
                if (l7(i, tr, s), !tr.length) return Me && rn.add(Cy(r, e.Diagnostics.Call_target_does_not_contain_any_signatures)), Gl(r);
                var dr = Zb(r), Dr = tr.length === 1 && !tr[0].typeParameters, Qr = !z2 && !Dr && e.some(dr, Ju) ? 4 : 0;
                Qr |= o & 32;
                var li, Ti, Ci, $i, Zi = !!(o & 16) && r.kind === 208 && r.arguments.hasTrailingComma;
                if (tr.length > 1 && ($i = ea(tr, Or, Dr, Zi)), $i || ($i = ea(tr, dt, Dr, Zi)), $i) return $i;
                if (Me) if (li) if (li.length === 1 || li.length > 3) {
                  var qt = li[li.length - 1], Nt;
                  li.length > 3 && (Nt = e.chainDiagnosticMessages(Nt, e.Diagnostics.The_last_overload_gave_the_following_error), Nt = e.chainDiagnosticMessages(Nt, e.Diagnostics.No_overload_matches_this_call));
                  var Ra = Ey(r, dr, qt, dt, 0, true, function() {
                    return Nt;
                  });
                  if (Ra) for (var ca = 0, Sn = Ra; ca < Sn.length; ca++) {
                    var ja = Sn[ca];
                    qt.declaration && li.length > 3 && e.addRelatedInfo(ja, e.createDiagnosticForNode(qt.declaration, e.Diagnostics.The_last_overload_is_declared_here)), Lt(qt, ja), rn.add(ja);
                  }
                  else e.Debug.fail("No error for last overload signature");
                } else {
                  for (var Fn = [], wn = 0, Tn = Number.MAX_VALUE, Eo = 0, lt = 0, it = function(Kt) {
                    var $t = function() {
                      return e.chainDiagnosticMessages(void 0, e.Diagnostics.Overload_0_of_1_2_gave_the_following_error, lt + 1, tr.length, Ml(Kt));
                    }, Ua = Ey(r, dr, Kt, dt, 0, true, $t);
                    Ua ? (Ua.length <= Tn && (Tn = Ua.length, Eo = lt), wn = Math.max(wn, Ua.length), Fn.push(Ua)) : e.Debug.fail("No error for 3 or fewer overload signatures"), lt++;
                  }, Yt = 0, Ia = li; Yt < Ia.length; Yt++) {
                    var Qt = Ia[Yt];
                    it(Qt);
                  }
                  var Ka = wn > 1 ? Fn[Eo] : e.flatten(Fn);
                  e.Debug.assert(Ka.length > 0, "No errors reported for 3 or fewer overload signatures");
                  var cn = e.chainDiagnosticMessages(e.map(Ka, e.createDiagnosticMessageChainFromDiagnostic), e.Diagnostics.No_overload_matches_this_call), Un = Ve([], e.flatMap(Ka, function(Kt) {
                    return Kt.relatedInformation;
                  }), true), oa = void 0;
                  if (e.every(Ka, function(Kt) {
                    return Kt.start === Ka[0].start && Kt.length === Ka[0].length && Kt.file === Ka[0].file;
                  })) {
                    var Mn = Ka[0], Ln = Mn.file, ci = Mn.start, Fr = Mn.length;
                    oa = { file: Ln, start: ci, length: Fr, code: cn.code, category: cn.category, messageText: cn, relatedInformation: Un };
                  } else oa = e.createDiagnosticForNodeFromMessageChain(r, cn, Un);
                  Lt(li[0], oa), rn.add(oa);
                }
                else if (Ti) rn.add(dk(r, [Ti], dr));
                else if (Ci) $b(Ci, r.typeArguments, true, u);
                else {
                  var jt = e.filter(i, function(Kt) {
                    return Xb(Kt, $e);
                  });
                  jt.length === 0 ? rn.add(m7(r, i, $e)) : z2 ? u && rn.add(Cy(r, u)) : rn.add(dk(r, jt, dr));
                }
                return v7(r, tr, dr, !!t, o);
                function Lt(Kt, $t) {
                  var Ua, Yr, Ni = li, Hi = Ti, _t = Ci, gt = ((Yr = (Ua = Kt.declaration) === null || Ua === void 0 ? void 0 : Ua.symbol) === null || Yr === void 0 ? void 0 : Yr.declarations) || e.emptyArray, Vt = gt.length > 1, Fa = Vt ? e.find(gt, function(Ga) {
                    return e.isFunctionLikeDeclaration(Ga) && e.nodeIsPresent(Ga.body);
                  }) : void 0;
                  if (Fa) {
                    var on = yl(Fa), zn = !on.typeParameters;
                    ea([on], dt, zn) && e.addRelatedInfo($t, e.createDiagnosticForNode(Fa, e.Diagnostics.The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_are_not_externally_visible));
                  }
                  li = Ni, Ti = Hi, Ci = _t;
                }
                function ea(Kt, $t, Ua, Yr) {
                  if (Yr === void 0 && (Yr = false), li = void 0, Ti = void 0, Ci = void 0, Ua) {
                    var Ni = Kt[0];
                    if (e.some($e) || !D0(r, dr, Ni, Yr)) return;
                    if (Ey(r, dr, Ni, $t, 0, false, void 0)) {
                      li = [Ni];
                      return;
                    }
                    return Ni;
                  }
                  for (var Hi = 0; Hi < Kt.length; Hi++) {
                    var Ni = Kt[Hi];
                    if (!(!Xb(Ni, $e) || !D0(r, dr, Ni, Yr))) {
                      var _t = void 0, gt = void 0;
                      if (Ni.typeParameters) {
                        var Vt = void 0;
                        if (e.some($e)) {
                          if (Vt = $b(Ni, $e, false), !Vt) {
                            Ci = Ni;
                            continue;
                          }
                        } else gt = uv(Ni.typeParameters, Ni, e.isInJSFile(r) ? 2 : 0), Vt = Qb(r, Ni, dr, Qr | 8, gt), Qr |= gt.flags & 4 ? 8 : 0;
                        if (_t = Xm(Ni, Vt, e.isInJSFile(Ni.declaration), gt && gt.inferredTypeParameters), yv(Ni) && !D0(r, dr, _t, Yr)) {
                          Ti = _t;
                          continue;
                        }
                      } else _t = Ni;
                      if (Ey(r, dr, _t, $t, Qr, false, void 0)) {
                        (li || (li = [])).push(_t);
                        continue;
                      }
                      if (Qr) {
                        if (Qr = o & 32, gt) {
                          var Vt = Qb(r, Ni, dr, Qr, gt);
                          if (_t = Xm(Ni, Vt, e.isInJSFile(Ni.declaration), gt && gt.inferredTypeParameters), yv(Ni) && !D0(r, dr, _t, Yr)) {
                            Ti = _t;
                            continue;
                          }
                        }
                        if (Ey(r, dr, _t, $t, Qr, false, void 0)) {
                          (li || (li = [])).push(_t);
                          continue;
                        }
                      }
                      return Kt[Hi] = _t, _t;
                    }
                  }
                }
              }
              function v7(r, i, t, o, s) {
                return e.Debug.assert(i.length > 0), xm(r), o || i.length === 1 || i.some(function(u) {
                  return !!u.typeParameters;
                }) ? D7(r, i, t, s) : y7(i);
              }
              function y7(r) {
                var i = e.mapDefined(r, function(dr) {
                  return dr.thisParameter;
                }), t;
                i.length && (t = gk(i, i.map(mv)));
                for (var o = e.minAndMax(r, h7), s = o.min, u = o.max, h = [], z2 = function(dr) {
                  var Dr = e.mapDefined(r, function(Qr) {
                    return H(Qr) ? dr < Qr.parameters.length - 1 ? Qr.parameters[dr] : e.last(Qr.parameters) : dr < Qr.parameters.length ? Qr.parameters[dr] : void 0;
                  });
                  e.Debug.assert(Dr.length !== 0), h.push(gk(Dr, e.mapDefined(r, function(Qr) {
                    return Ld(Qr, dr);
                  })));
                }, me = 0; me < u; me++) z2(me);
                var Me = e.mapDefined(r, function(dr) {
                  return H(dr) ? e.last(dr.parameters) : void 0;
                }), $e = 0;
                if (Me.length !== 0) {
                  var tr = Zs(Pa(e.mapDefined(r, ix), 2));
                  h.push(mk(Me, tr)), $e |= 1;
                }
                return r.some(I) && ($e |= 2), Fu(r[0].declaration, void 0, t, h, Do(r.map(yo)), void 0, s, $e);
              }
              function h7(r) {
                var i = r.parameters.length;
                return H(r) ? i - 1 : i;
              }
              function gk(r, i) {
                return mk(r, Pa(i, 2));
              }
              function mk(r, i) {
                return eg(e.first(r), i);
              }
              function D7(r, i, t, o) {
                var s = T7(i, si === void 0 ? t.length : si), u = i[s], h = u.typeParameters;
                if (!h) return u;
                var z2 = ak(r) ? r.typeArguments : void 0, me = z2 ? mh(u, b7(z2, h, e.isInJSFile(r))) : S7(r, h, u, t, o);
                return i[s] = me, me;
              }
              function b7(r, i, t) {
                for (var o = r.map(Bd); o.length > i.length; ) o.pop();
                for (; o.length < i.length; ) o.push(D_(i[o.length]) || Tc(i[o.length]) || fb(t));
                return o;
              }
              function S7(r, i, t, o, s) {
                var u = uv(i, t, e.isInJSFile(r) ? 2 : 0), h = Qb(r, t, o, s | 4 | 8, u);
                return mh(t, h);
              }
              function T7(r, i) {
                for (var t = -1, o = -1, s = 0; s < r.length; s++) {
                  var u = r[s], h = Wc(u);
                  if (Xl(u) || h >= i) return s;
                  h > o && (o = h, t = s);
                }
                return t;
              }
              function x7(r, i, t) {
                if (r.expression.kind === 106) {
                  var o = Sb(r.expression);
                  if (ta(o)) {
                    for (var s = 0, u = r.arguments; s < u.length; s++) {
                      var h = u[s];
                      yn(h);
                    }
                    return En;
                  }
                  if (!nn(o)) {
                    var z2 = e.getEffectiveBaseTypeNode(e.getContainingClass(r));
                    if (z2) {
                      var me = Xg(o, z2.typeArguments, z2);
                      return mm(r, me, i, t, 0);
                    }
                  }
                  return Fg(r);
                }
                var Me, $e = yn(r.expression);
                if (e.isCallChain(r)) {
                  var tr = cv($e, r.expression);
                  Me = tr === $e ? 0 : e.isOutermostOptionalChain(r) ? 16 : 8, $e = tr;
                } else Me = 0;
                if ($e = WC($e, r.expression, W5), $e === Bt) return Co;
                var dr = $s($e);
                if (nn(dr)) return Gl(r);
                var Dr = ot(dr, 0), Qr = ot(dr, 1).length;
                if (b0($e, dr, Dr.length, Qr)) return !nn($e) && r.typeArguments && Xr(r, e.Diagnostics.Untyped_function_calls_may_not_accept_type_arguments), Fg(r);
                if (!Dr.length) {
                  if (Qr) Xr(r, e.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new, Ot($e));
                  else {
                    var li = void 0;
                    if (r.arguments.length === 1) {
                      var Ti = e.getSourceFileOfNode(r).text;
                      e.isLineBreak(Ti.charCodeAt(e.skipTrivia(Ti, r.expression.end, true) - 1)) && (li = e.createDiagnosticForNode(r.expression, e.Diagnostics.Are_you_missing_a_semicolon));
                    }
                    rS(r.expression, dr, 0, li);
                  }
                  return Gl(r);
                }
                return t & 8 && !r.typeArguments && Dr.some(E7) ? (Xk(r, t), to) : Dr.some(function(Ci) {
                  return e.isInJSFile(Ci.declaration) && !!e.getJSDocClassTag(Ci.declaration);
                }) ? (Xr(r, e.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new, Ot($e)), Gl(r)) : mm(r, Dr, i, t, Me);
              }
              function E7(r) {
                return !!(r.typeParameters && JS(yo(r)));
              }
              function b0(r, i, t, o) {
                return ta(r) || ta(i) && !!(r.flags & 262144) || !t && !o && !(i.flags & 1048576) && !(bu(i).flags & 131072) && ao(r, br);
              }
              function C7(r, i, t) {
                if (r.arguments && Ae < 1) {
                  var o = h0(r.arguments);
                  o >= 0 && Xr(r.arguments[o], e.Diagnostics.Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher);
                }
                var s = gm(r.expression);
                if (s === Bt) return Co;
                if (s = $s(s), nn(s)) return Gl(r);
                if (ta(s)) return r.typeArguments && Xr(r, e.Diagnostics.Untyped_function_calls_may_not_accept_type_arguments), Fg(r);
                var u = ot(s, 1);
                if (u.length) {
                  if (!k7(r, u[0])) return Gl(r);
                  if (vk(u, function(Me) {
                    return !!(Me.flags & 4);
                  })) return Xr(r, e.Diagnostics.Cannot_create_an_instance_of_an_abstract_class), Gl(r);
                  var h = s.symbol && e.getClassLikeDeclarationOfSymbol(s.symbol);
                  return h && e.hasSyntacticModifier(h, 128) ? (Xr(r, e.Diagnostics.Cannot_create_an_instance_of_an_abstract_class), Gl(r)) : mm(r, u, i, t, 0);
                }
                var z2 = ot(s, 0);
                if (z2.length) {
                  var me = mm(r, z2, i, t, 0);
                  return n || (me.declaration && !Sl(me.declaration) && yo(me) !== Fi && Xr(r, e.Diagnostics.Only_a_void_function_can_be_called_with_the_new_keyword), T_(me) === Fi && Xr(r, e.Diagnostics.A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void)), me;
                }
                return rS(r.expression, s, 1), Gl(r);
              }
              function vk(r, i) {
                return e.isArray(r) ? e.some(r, function(t) {
                  return vk(t, i);
                }) : r.compositeKind === 1048576 ? e.some(r.compositeSignatures, i) : i(r);
              }
              function eS(r, i) {
                var t = Qc(i);
                if (!e.length(t)) return false;
                var o = t[0];
                if (o.flags & 2097152) {
                  for (var s = o.types, u = Wv(s), h = 0, z2 = 0, me = o.types; z2 < me.length; z2++) {
                    var Me = me[z2];
                    if (!u[h] && e.getObjectFlags(Me) & 3 && (Me.symbol === r || eS(r, Me))) return true;
                    h++;
                  }
                  return false;
                }
                return o.symbol === r ? true : eS(r, o);
              }
              function k7(r, i) {
                if (!i || !i.declaration) return true;
                var t = i.declaration, o = e.getSelectedEffectiveModifierFlags(t, 24);
                if (!o || t.kind !== 171) return true;
                var s = e.getClassLikeDeclarationOfSymbol(t.parent.symbol), u = go(t.parent.symbol);
                if (!MS(r, s)) {
                  var h = e.getContainingClass(r);
                  if (h && o & 16) {
                    var z2 = Bd(h);
                    if (eS(t.parent.symbol, z2)) return true;
                  }
                  return o & 8 && Xr(r, e.Diagnostics.Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration, Ot(u)), o & 16 && Xr(r, e.Diagnostics.Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration, Ot(u)), false;
                }
                return true;
              }
              function yk(r, i, t) {
                var o, s = t === 0, u = ag(i), h = u && ot(u, t).length > 0;
                if (i.flags & 1048576) {
                  for (var z2 = i.types, me = false, Me = 0, $e = z2; Me < $e.length; Me++) {
                    var tr = $e[Me], dr = ot(tr, t);
                    if (dr.length !== 0) {
                      if (me = true, o) break;
                    } else if (o || (o = e.chainDiagnosticMessages(o, s ? e.Diagnostics.Type_0_has_no_call_signatures : e.Diagnostics.Type_0_has_no_construct_signatures, Ot(tr)), o = e.chainDiagnosticMessages(o, s ? e.Diagnostics.Not_all_constituents_of_type_0_are_callable : e.Diagnostics.Not_all_constituents_of_type_0_are_constructable, Ot(i))), me) break;
                  }
                  me || (o = e.chainDiagnosticMessages(void 0, s ? e.Diagnostics.No_constituent_of_type_0_is_callable : e.Diagnostics.No_constituent_of_type_0_is_constructable, Ot(i))), o || (o = e.chainDiagnosticMessages(o, s ? e.Diagnostics.Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_other : e.Diagnostics.Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_with_each_other, Ot(i)));
                } else o = e.chainDiagnosticMessages(o, s ? e.Diagnostics.Type_0_has_no_call_signatures : e.Diagnostics.Type_0_has_no_construct_signatures, Ot(i));
                var Dr = s ? e.Diagnostics.This_expression_is_not_callable : e.Diagnostics.This_expression_is_not_constructable;
                if (e.isCallExpression(r.parent) && r.parent.arguments.length === 0) {
                  var Qr = va(r).resolvedSymbol;
                  Qr && Qr.flags & 32768 && (Dr = e.Diagnostics.This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without);
                }
                return { messageChain: e.chainDiagnosticMessages(o, Dr), relatedMessage: h ? e.Diagnostics.Did_you_forget_to_use_await : void 0 };
              }
              function rS(r, i, t, o) {
                var s = yk(r, i, t), u = s.messageChain, h = s.relatedMessage, z2 = e.createDiagnosticForNodeFromMessageChain(r, u);
                if (h && e.addRelatedInfo(z2, e.createDiagnosticForNode(r, h)), e.isCallExpression(r.parent)) {
                  var me = pk(r.parent, true), Me = me.start, $e = me.length;
                  z2.start = Me, z2.length = $e;
                }
                rn.add(z2), hk(i, t, o ? e.addRelatedInfo(z2, o) : z2);
              }
              function hk(r, i, t) {
                if (!!r.symbol) {
                  var o = Aa(r.symbol).originatingImport;
                  if (o && !e.isImportCall(o)) {
                    var s = ot(Jt(Aa(r.symbol).target), i);
                    if (!s || !s.length) return;
                    e.addRelatedInfo(t, e.createDiagnosticForNode(o, e.Diagnostics.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead));
                  }
                }
              }
              function A7(r, i, t) {
                var o = yn(r.tag), s = $s(o);
                if (nn(s)) return Gl(r);
                var u = ot(s, 0), h = ot(s, 1).length;
                if (b0(o, s, u.length, h)) return Fg(r);
                if (!u.length) {
                  if (e.isArrayLiteralExpression(r.parent)) {
                    var z2 = e.createDiagnosticForNode(r.tag, e.Diagnostics.It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tagged_template_expression_which_cannot_be_invoked);
                    return rn.add(z2), Gl(r);
                  }
                  return rS(r.tag, s, 0), Gl(r);
                }
                return mm(r, u, i, t, 0);
              }
              function N7(r) {
                switch (r.parent.kind) {
                  case 257:
                  case 226:
                    return e.Diagnostics.Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression;
                  case 164:
                    return e.Diagnostics.Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression;
                  case 167:
                    return e.Diagnostics.Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression;
                  case 169:
                  case 172:
                  case 173:
                    return e.Diagnostics.Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression;
                  default:
                    return e.Debug.fail();
                }
              }
              function P7(r, i, t) {
                var o = yn(r.expression), s = $s(o);
                if (nn(s)) return Gl(r);
                var u = ot(s, 0), h = ot(s, 1).length;
                if (b0(o, s, u.length, h)) return Fg(r);
                if (w7(r, u)) {
                  var z2 = e.getTextOfNode(r.expression, false);
                  return Xr(r, e.Diagnostics._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0, z2), Gl(r);
                }
                var me = N7(r);
                if (!u.length) {
                  var Me = yk(r.expression, s, 0), $e = e.chainDiagnosticMessages(Me.messageChain, me), tr = e.createDiagnosticForNodeFromMessageChain(r.expression, $e);
                  return Me.relatedMessage && e.addRelatedInfo(tr, e.createDiagnosticForNode(r.expression, Me.relatedMessage)), rn.add(tr), hk(s, 0, tr), Gl(r);
                }
                return mm(r, u, i, t, 0, me);
              }
              function S0(r, i) {
                var t = Og(r), o = t && dc(t), s = o && qs(o, U.Element, 788968), u = s && Ur.symbolToEntityName(s, 788968, r), h = e.factory.createFunctionTypeNode(void 0, [e.factory.createParameterDeclaration(void 0, void 0, void 0, "props", void 0, Ur.typeToTypeNode(i, r))], u ? e.factory.createTypeReferenceNode(u, void 0) : e.factory.createKeywordTypeNode(130)), z2 = oo(1, "props");
                return z2.type = i, Fu(h, void 0, void 0, [z2], s ? go(s) : Pe, void 0, 1, 0);
              }
              function I7(r, i, t) {
                if (dm(r.tagName)) {
                  var o = BC(r), s = S0(r, o);
                  return op(Rg(r.attributes, l0(s, r), void 0, 0), o, r.tagName, r.attributes), e.length(r.typeArguments) && (e.forEach(r.typeArguments, io), rn.add(e.createDiagnosticForNodeArray(e.getSourceFileOfNode(r), r.typeArguments, e.Diagnostics.Expected_0_type_arguments_but_got_1, 0, e.length(r.typeArguments)))), s;
                }
                var u = yn(r.tagName), h = $s(u);
                if (nn(h)) return Gl(r);
                var z2 = LC(u, r);
                return b0(u, h, z2.length, 0) ? Fg(r) : z2.length === 0 ? (Xr(r.tagName, e.Diagnostics.JSX_element_type_0_does_not_have_any_construct_or_call_signatures, e.getTextOfNode(r.tagName)), Gl(r)) : mm(r, z2, i, t, 0);
              }
              function w7(r, i) {
                return i.length && e.every(i, function(t) {
                  return t.minArgumentCount === 0 && !H(t) && t.parameters.length < _k(r, t);
                });
              }
              function O7(r, i, t) {
                switch (r.kind) {
                  case 208:
                    return x7(r, i, t);
                  case 209:
                    return C7(r, i, t);
                  case 210:
                    return A7(r, i, t);
                  case 165:
                    return P7(r, i, t);
                  case 280:
                  case 279:
                    return I7(r, i, t);
                }
                throw e.Debug.assertNever(r, "Branch in 'resolveSignature' should be unreachable.");
              }
              function Mg(r, i, t) {
                var o = va(r), s = o.resolvedSignature;
                if (s && s !== to && !i) return s;
                o.resolvedSignature = to;
                var u = O7(r, i, t || 0);
                return u !== to && (o.resolvedSignature = ko === Ao ? u : s), u;
              }
              function Sl(r) {
                var i;
                if (!r || !e.isInJSFile(r)) return false;
                var t = e.isFunctionDeclaration(r) || e.isFunctionExpression(r) ? r : e.isVariableDeclaration(r) && r.initializer && e.isFunctionExpression(r.initializer) ? r.initializer : void 0;
                if (t) {
                  if (e.getJSDocClassTag(r)) return true;
                  var o = Et(t);
                  return !!(!((i = o == null ? void 0 : o.members) === null || i === void 0) && i.size);
                }
                return false;
              }
              function iS(r, i) {
                var t, o;
                if (i) {
                  var s = Aa(i);
                  if (!s.inferredClassSymbol || !s.inferredClassSymbol.has(y(r))) {
                    var u = e.isTransientSymbol(r) ? r : Yl(r);
                    return u.exports = u.exports || e.createSymbolTable(), u.members = u.members || e.createSymbolTable(), u.flags |= i.flags & 32, !((t = i.exports) === null || t === void 0) && t.size && gu(u.exports, i.exports), !((o = i.members) === null || o === void 0) && o.size && gu(u.members, i.members), (s.inferredClassSymbol || (s.inferredClassSymbol = new e.Map())).set(y(u), u), u;
                  }
                  return s.inferredClassSymbol.get(y(r));
                }
              }
              function F7(r) {
                var i, t = r && T0(r, true), o = (i = t == null ? void 0 : t.exports) === null || i === void 0 ? void 0 : i.get("prototype"), s = (o == null ? void 0 : o.valueDeclaration) && M7(o.valueDeclaration);
                return s ? Et(s) : void 0;
              }
              function T0(r, i) {
                if (!!r.parent) {
                  var t, o;
                  if (e.isVariableDeclaration(r.parent) && r.parent.initializer === r) {
                    if (!e.isInJSFile(r) && !(e.isVarConst(r.parent) && e.isFunctionLikeDeclaration(r))) return;
                    t = r.parent.name, o = r.parent;
                  } else if (e.isBinaryExpression(r.parent)) {
                    var s = r.parent, u = r.parent.operatorToken.kind;
                    if (u === 63 && (i || s.right === r)) t = s.left, o = t;
                    else if ((u === 56 || u === 60) && (e.isVariableDeclaration(s.parent) && s.parent.initializer === s ? (t = s.parent.name, o = s.parent) : e.isBinaryExpression(s.parent) && s.parent.operatorToken.kind === 63 && (i || s.parent.right === s) && (t = s.parent.left, o = t), !t || !e.isBindableStaticNameExpression(t) || !e.isSameEntityName(t, s.left))) return;
                  } else i && e.isFunctionDeclaration(r) && (t = r.name, o = r);
                  if (!(!o || !t || !i && !e.getExpandoInitializer(r, e.isPrototypeAccess(t)))) return Et(o);
                }
              }
              function M7(r) {
                if (!r.parent) return false;
                for (var i = r.parent; i && i.kind === 206; ) i = i.parent;
                if (i && e.isBinaryExpression(i) && e.isPrototypeAccess(i.left) && i.operatorToken.kind === 63) {
                  var t = e.getInitializerOfBinaryExpression(i);
                  return e.isObjectLiteralExpression(t) && t;
                }
              }
              function L7(r, i) {
                var t;
                Wy(r, r.typeArguments);
                var o = Mg(r, void 0, i);
                if (o === to) return wt;
                if (x0(o, r), r.expression.kind === 106) return Fi;
                if (r.kind === 209) {
                  var s = o.declaration;
                  if (s && s.kind !== 171 && s.kind !== 175 && s.kind !== 180 && !e.isJSDocConstructSignature(s) && !Sl(s)) return n && Xr(r, e.Diagnostics.new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type), Oe;
                }
                if (e.isInJSFile(r) && xk(r)) return Hm(r.arguments[0]);
                var u = yo(o);
                if (u.flags & 12288 && Dk(r)) return CD(e.walkUpParenthesizedExpressions(r.parent));
                if (r.kind === 208 && !r.questionDotToken && r.parent.kind === 238 && u.flags & 16384 && Yc(o)) {
                  if (!e.isDottedName(r.expression)) Xr(r.expression, e.Diagnostics.Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name);
                  else if (!i0(r)) {
                    var h = Xr(r.expression, e.Diagnostics.Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation);
                    gy(r.expression, h);
                  }
                }
                if (e.isInJSFile(r)) {
                  var z2 = T0(r, false);
                  if (!((t = z2 == null ? void 0 : z2.exports) === null || t === void 0) && t.size) {
                    var me = rs(z2, z2.exports, e.emptyArray, e.emptyArray, e.emptyArray);
                    return me.objectFlags |= 4096, Do([u, me]);
                  }
                }
                return u;
              }
              function x0(r, i) {
                if (r.declaration && r.declaration.flags & 268435456) {
                  var t = ky(i), o = e.tryGetPropertyAccessOrIdentifierToString(e.getInvokedExpression(i));
                  vp(t, r.declaration, o, Ml(r));
                }
              }
              function ky(r) {
                switch (r = e.skipParentheses(r), r.kind) {
                  case 208:
                  case 165:
                  case 209:
                    return ky(r.expression);
                  case 210:
                    return ky(r.tag);
                  case 280:
                  case 279:
                    return ky(r.tagName);
                  case 207:
                    return r.argumentExpression;
                  case 206:
                    return r.name;
                  case 178:
                    var i = r;
                    return e.isQualifiedName(i.typeName) ? i.typeName.right : i;
                  default:
                    return r;
                }
              }
              function Dk(r) {
                if (!e.isCallExpression(r)) return false;
                var i = r.expression;
                if (e.isPropertyAccessExpression(i) && i.name.escapedText === "for" && (i = i.expression), !e.isIdentifier(i) || i.escapedText !== "Symbol") return false;
                var t = Ex(false);
                return t ? t === es(i, "Symbol", 111551, void 0, void 0, false) : false;
              }
              function R7(r) {
                if (CL(r), r.arguments.length === 0) return Py(r, Oe);
                for (var i = r.arguments[0], t = Os(i), o = r.arguments.length > 1 ? Os(r.arguments[1]) : void 0, s = 2; s < r.arguments.length; ++s) Os(r.arguments[s]);
                if ((t.flags & 32768 || t.flags & 65536 || !ao(t, Li)) && Xr(i, e.Diagnostics.Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0, Ot(t)), o) {
                  var u = xx(true);
                  u !== Ba && zc(o, Uh(u, 32768), r.arguments[1]);
                }
                var h = ac(r, i);
                if (h) {
                  var z2 = Wf(h, i, true, false);
                  if (z2) return Py(r, Sk(Jt(z2), z2, h, i) || Tk(Jt(z2), z2, h, i));
                }
                return Py(r, Oe);
              }
              function bk(r, i, t) {
                var o = e.createSymbolTable(), s = oo(2097152, "default");
                return s.parent = i, s.nameType = Bu("default"), s.aliasTarget = os(r), o.set("default", s), rs(t, o, e.emptyArray, e.emptyArray, e.emptyArray);
              }
              function Sk(r, i, t, o) {
                var s = Uf(o);
                if (s && r && !nn(r)) {
                  var u = r;
                  if (!u.defaultOnlyType) {
                    var h = bk(i, t);
                    u.defaultOnlyType = h;
                  }
                  return u.defaultOnlyType;
                }
              }
              function Tk(r, i, t, o) {
                var s;
                if (Cr && r && !nn(r)) {
                  var u = r;
                  if (!u.syntheticType) {
                    var h = (s = t.declarations) === null || s === void 0 ? void 0 : s.find(e.isSourceFile), z2 = L_(h, t, false, o);
                    if (z2) {
                      var me = oo(2048, "__type"), Me = bk(i, t, me);
                      me.type = Me, u.syntheticType = Dy(r) ? Vp(r, Me, me, 0, false) : Me;
                    } else u.syntheticType = r;
                  }
                  return u.syntheticType;
                }
                return r;
              }
              function xk(r) {
                if (!e.isRequireCall(r, true)) return false;
                if (!e.isIdentifier(r.expression)) return e.Debug.fail();
                var i = es(r.expression, r.expression.escapedText, 111551, void 0, void 0, true);
                if (i === qr) return true;
                if (i.flags & 2097152) return false;
                var t = i.flags & 16 ? 256 : i.flags & 3 ? 254 : 0;
                if (t !== 0) {
                  var o = e.getDeclarationOfKind(i, t);
                  return !!o && !!(o.flags & 16777216);
                }
                return false;
              }
              function B7(r) {
                Y9(r) || Wy(r, r.typeArguments), Ae < 2 && fc(r, 262144);
                var i = Mg(r);
                return x0(i, r), yo(i);
              }
              function J7(r) {
                if (r.kind === 211) {
                  var i = e.getSourceFileOfNode(r);
                  i && e.fileExtensionIsOneOf(i.fileName, [".cts", ".mts"]) && Tt(r, e.Diagnostics.This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead);
                }
                return Ck(r, r.type, r.expression);
              }
              function Ek(r) {
                switch (r.kind) {
                  case 10:
                  case 14:
                  case 8:
                  case 9:
                  case 110:
                  case 95:
                  case 204:
                  case 205:
                  case 223:
                    return true;
                  case 212:
                    return Ek(r.expression);
                  case 219:
                    var i = r.operator, t = r.operand;
                    return i === 40 && (t.kind === 8 || t.kind === 9) || i === 39 && t.kind === 8;
                  case 206:
                  case 207:
                    var o = r.expression, s = Bd(o).symbol;
                    return s && s.flags & 2097152 && (s = Ps(s)), !!(s && s.flags & 384 && as(s) === 1);
                }
                return false;
              }
              function Ck(r, i, t, o) {
                var s = yn(t, o);
                if (e.isConstTypeReference(i)) return Ek(t) || Xr(t, e.Diagnostics.A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals), jc(s);
                io(i), s = fm(Kl(s));
                var u = Va(i);
                return nn(u) || fe(function() {
                  var h = $c(s);
                  cm(u, h) || mE(s, u, r, e.Diagnostics.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first);
                }), u;
              }
              function j7(r) {
                var i = yn(r.expression), t = cv(i, r.expression);
                return zh(C_(t), r, t !== i);
              }
              function U7(r) {
                return r.flags & 32 ? j7(r) : C_(yn(r.expression));
              }
              function kk(r) {
                lA(r);
                var i = r.kind === 228 ? yn(r.expression) : e.isThisIdentifier(r.exprName) ? yy(r.exprName) : yn(r.exprName), t = r.typeArguments;
                if (i === Bt || nn(i) || !e.some(t)) return i;
                var o = false, s, u = z2(i), h = o ? s : i;
                return h && rn.add(e.createDiagnosticForNodeArray(e.getSourceFileOfNode(r), t, e.Diagnostics.Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable, Ot(h))), u;
                function z2(Me) {
                  var $e = false, tr = false, dr = Dr(Me);
                  return o || (o = tr), $e && !tr && (s != null || (s = Me)), dr;
                  function Dr(Qr) {
                    if (Qr.flags & 524288) {
                      var li = Ru(Qr), Ti = me(li.callSignatures), Ci = me(li.constructSignatures);
                      if ($e || ($e = li.callSignatures.length !== 0 || li.constructSignatures.length !== 0), tr || (tr = Ti.length !== 0 || Ci.length !== 0), Ti !== li.callSignatures || Ci !== li.constructSignatures) {
                        var $i = rs(void 0, li.members, Ti, Ci, li.indexInfos);
                        return $i.objectFlags |= 8388608, $i.node = r, $i;
                      }
                    } else if (Qr.flags & 58982400) {
                      var Zi = uc(Qr);
                      if (Zi) {
                        var qt = Dr(Zi);
                        if (qt !== Zi) return qt;
                      }
                    } else {
                      if (Qr.flags & 1048576) return Ss(Qr, z2);
                      if (Qr.flags & 2097152) return Do(e.sameMap(Qr.types, Dr));
                    }
                    return Qr;
                  }
                }
                function me(Me) {
                  var $e = e.filter(Me, function(tr) {
                    return !!tr.typeParameters && Xb(tr, t);
                  });
                  return e.sameMap($e, function(tr) {
                    var dr = $b(tr, t, true);
                    return dr ? Xm(tr, dr, e.isInJSFile(tr.declaration)) : tr;
                  });
                }
              }
              function z7(r) {
                return pL(r), r.keywordToken === 103 ? tS(r) : r.keywordToken === 100 ? W7(r) : e.Debug.assertNever(r.keywordToken);
              }
              function Ak(r) {
                switch (r.keywordToken) {
                  case 100:
                    return Tx();
                  case 103:
                    var i = tS(r);
                    return nn(i) ? Pe : H7(i);
                  default:
                    e.Debug.assertNever(r.keywordToken);
                }
              }
              function tS(r) {
                var i = e.getNewTargetContainer(r);
                if (i) if (i.kind === 171) {
                  var t = Et(i.parent);
                  return Jt(t);
                } else {
                  var t = Et(i);
                  return Jt(t);
                }
                else return Xr(r, e.Diagnostics.Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor, "new.target"), Pe;
              }
              function W7(r) {
                er === e.ModuleKind.Node16 || er === e.ModuleKind.NodeNext ? e.getSourceFileOfNode(r).impliedNodeFormat !== e.ModuleKind.ESNext && Xr(r, e.Diagnostics.The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output) : er < e.ModuleKind.ES2020 && er !== e.ModuleKind.System && Xr(r, e.Diagnostics.The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system_node16_or_nodenext);
                var i = e.getSourceFileOfNode(r);
                return e.Debug.assert(!!(i.flags & 4194304), "Containing file is missing import meta node flag."), r.name.escapedText === "meta" ? Sx() : Pe;
              }
              function mv(r) {
                var i = Jt(r);
                if (Ye) {
                  var t = r.valueDeclaration;
                  if (t && e.hasInitializer(t)) return i_(i);
                }
                return i;
              }
              function E0(r) {
                return e.Debug.assert(e.isIdentifier(r.name)), r.name.escapedText;
              }
              function vm(r, i, t) {
                var o = r.parameters.length - (H(r) ? 1 : 0);
                if (i < o) return r.parameters[i].escapedName;
                var s = r.parameters[o] || xe, u = t || Jt(s);
                if (Yn(u)) {
                  var h = u.target.labeledElementDeclarations, z2 = i - o;
                  return h && E0(h[z2]) || s.escapedName + "_" + z2;
                }
                return s.escapedName;
              }
              function q7(r, i) {
                var t;
                if (((t = r.declaration) === null || t === void 0 ? void 0 : t.kind) !== 317) {
                  var o = r.parameters.length - (H(r) ? 1 : 0);
                  if (i < o) {
                    var s = r.parameters[i];
                    return Nk(s) ? [s.escapedName, false] : void 0;
                  }
                  var u = r.parameters[o] || xe;
                  if (!!Nk(u)) {
                    var h = Jt(u);
                    if (Yn(h)) {
                      var z2 = h.target.labeledElementDeclarations, me = i - o, Me = z2 == null ? void 0 : z2[me], $e = !!(Me != null && Me.dotDotDotToken);
                      return Me ? [E0(Me), $e] : void 0;
                    }
                    if (i === o) return [u.escapedName, true];
                  }
                }
              }
              function Nk(r) {
                return r.valueDeclaration && e.isParameter(r.valueDeclaration) && e.isIdentifier(r.valueDeclaration.name);
              }
              function Pk(r) {
                return r.kind === 197 || e.isParameter(r) && r.name && e.isIdentifier(r.name);
              }
              function V7(r, i) {
                var t = r.parameters.length - (H(r) ? 1 : 0);
                if (i < t) {
                  var o = r.parameters[i].valueDeclaration;
                  return o && Pk(o) ? o : void 0;
                }
                var s = r.parameters[t] || xe, u = Jt(s);
                if (Yn(u)) {
                  var h = u.target.labeledElementDeclarations, z2 = i - t;
                  return h && h[z2];
                }
                return s.valueDeclaration && Pk(s.valueDeclaration) ? s.valueDeclaration : void 0;
              }
              function $u(r, i) {
                return Ld(r, i) || Oe;
              }
              function Ld(r, i) {
                var t = r.parameters.length - (H(r) ? 1 : 0);
                if (i < t) return mv(r.parameters[i]);
                if (H(r)) {
                  var o = Jt(r.parameters[t]), s = i - t;
                  if (!Yn(o) || o.target.hasRestElement || s < o.target.fixedLength) return Jc(o, If(s));
                }
              }
              function ym(r, i) {
                var t = Wc(r), o = Hl(r), s = vv(r);
                if (s && i >= t - 1) return i === t - 1 ? s : Zs(Jc(s, nt));
                for (var u = [], h = [], z2 = [], me = i; me < t; me++) {
                  !s || me < t - 1 ? (u.push($u(r, me)), h.push(me < o ? 1 : 2)) : (u.push(s), h.push(8));
                  var Me = V7(r, me);
                  Me && z2.push(Me);
                }
                return Wl(u, h, false, e.length(z2) === e.length(u) ? z2 : void 0);
              }
              function Wc(r) {
                var i = r.parameters.length;
                if (H(r)) {
                  var t = Jt(r.parameters[i - 1]);
                  if (Yn(t)) return i + t.target.fixedLength - (t.target.hasRestElement ? 0 : 1);
                }
                return i;
              }
              function Hl(r, i) {
                var t = i & 1, o = i & 2;
                if (o || r.resolvedMinArgumentCount === void 0) {
                  var s = void 0;
                  if (H(r)) {
                    var u = Jt(r.parameters[r.parameters.length - 1]);
                    if (Yn(u)) {
                      var h = e.findIndex(u.target.elementFlags, function($e) {
                        return !($e & 1);
                      }), z2 = h < 0 ? u.target.fixedLength : h;
                      z2 > 0 && (s = r.parameters.length - 1 + z2);
                    }
                  }
                  if (s === void 0) {
                    if (!t && r.flags & 32) return 0;
                    s = r.minArgumentCount;
                  }
                  if (o) return s;
                  for (var me = s - 1; me >= 0; me--) {
                    var Me = $u(r, me);
                    if (ec(Me, nk).flags & 131072) break;
                    s = me;
                  }
                  r.resolvedMinArgumentCount = s;
                }
                return r.resolvedMinArgumentCount;
              }
              function Xl(r) {
                if (H(r)) {
                  var i = Jt(r.parameters[r.parameters.length - 1]);
                  return !Yn(i) || i.target.hasRestElement;
                }
                return false;
              }
              function vv(r) {
                if (H(r)) {
                  var i = Jt(r.parameters[r.parameters.length - 1]);
                  if (!Yn(i)) return i;
                  if (i.target.hasRestElement) return Zm(i, i.target.fixedLength);
                }
              }
              function yv(r) {
                var i = vv(r);
                return i && !Tu(i) && !ta(i) && (bu(i).flags & 131072) === 0 ? i : void 0;
              }
              function aS(r) {
                return nS(r, ui);
              }
              function nS(r, i) {
                return r.parameters.length > 0 ? $u(r, 0) : i;
              }
              function K7(r, i, t) {
                for (var o = r.parameters.length - (H(r) ? 1 : 0), s = 0; s < o; s++) {
                  var u = r.parameters[s].valueDeclaration;
                  if (u.type) {
                    var h = e.getEffectiveTypeAnnotationNode(u);
                    h && df(t.inferences, Va(h), $u(i, s));
                  }
                }
                var z2 = vv(i);
                if (z2 && z2.flags & 262144) {
                  var me = Tg(i, t.nonFixingMapper);
                  Ik(r, me);
                  var Me = Wc(i) - 1;
                  df(t.inferences, ym(r, Me), z2);
                }
              }
              function Ik(r, i) {
                if (i.typeParameters) if (!r.typeParameters) r.typeParameters = i.typeParameters;
                else return;
                if (i.thisParameter) {
                  var t = r.thisParameter;
                  (!t || t.valueDeclaration && !t.valueDeclaration.type) && (t || (r.thisParameter = eg(i.thisParameter, void 0)), Ay(r.thisParameter, Jt(i.thisParameter)));
                }
                for (var o = r.parameters.length - (H(r) ? 1 : 0), s = 0; s < o; s++) {
                  var t = r.parameters[s];
                  if (!e.getEffectiveTypeAnnotationNode(t.valueDeclaration)) {
                    var u = Ld(i, s);
                    Ay(t, u);
                  }
                }
                if (H(r)) {
                  var t = e.last(r.parameters);
                  if (t.valueDeclaration ? !e.getEffectiveTypeAnnotationNode(t.valueDeclaration) : !!(e.getCheckFlags(t) & 65536)) {
                    var u = ym(i, o);
                    Ay(t, u);
                  }
                }
              }
              function G7(r) {
                r.thisParameter && Ay(r.thisParameter);
                for (var i = 0, t = r.parameters; i < t.length; i++) {
                  var o = t[i];
                  Ay(o);
                }
              }
              function Ay(r, i) {
                var t = Aa(r);
                if (t.type) i && e.Debug.assertEqual(t.type, i, "Parameter symbol already has a cached type which differs from newly assigned type");
                else {
                  var o = r.valueDeclaration;
                  t.type = i || (o ? sc(o, true) : Jt(r)), o && o.name.kind !== 79 && (t.type === gr && (t.type = Qu(o.name)), wk(o.name, t.type));
                }
              }
              function wk(r, i) {
                for (var t = 0, o = r.elements; t < o.length; t++) {
                  var s = o[t];
                  if (!e.isOmittedExpression(s)) {
                    var u = uf(s, i);
                    s.name.kind === 79 ? Aa(Et(s)).type = u : wk(s.name, u);
                  }
                }
              }
              function Ny(r) {
                var i = ay(true);
                return i !== kn ? (r = k_(Ev(r)) || gr, Yf(i, [r])) : gr;
              }
              function Ok(r) {
                var i = kx(true);
                return i !== kn ? (r = k_(Ev(r)) || gr, Yf(i, [r])) : gr;
              }
              function Py(r, i) {
                var t = Ny(i);
                return t === gr ? (Xr(r, e.isImportCall(r) ? e.Diagnostics.A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option : e.Diagnostics.An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option), Pe) : (nD(true) || Xr(r, e.isImportCall(r) ? e.Diagnostics.A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option : e.Diagnostics.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option), t);
              }
              function H7(r) {
                var i = oo(0, "NewTargetExpression"), t = oo(4, "target", 8);
                t.parent = i, t.type = r;
                var o = e.createSymbolTable([t]);
                return i.members = o, rs(i, o, e.emptyArray, e.emptyArray, e.emptyArray);
              }
              function C0(r, i) {
                if (!r.body) return Pe;
                var t = e.getFunctionFlags(r), o = (t & 2) !== 0, s = (t & 1) !== 0, u, h, z2, me = Fi;
                if (r.body.kind !== 235) u = Os(r.body, i && i & -9), o && (u = Ev(xv(u, false, r, e.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member)));
                else if (s) {
                  var Me = Bk(r, i);
                  Me ? Me.length > 0 && (u = Pa(Me, 2)) : me = ui;
                  var $e = X7(r, i), tr = $e.yieldTypes, dr = $e.nextTypes;
                  h = e.some(tr) ? Pa(tr, 2) : void 0, z2 = e.some(dr) ? Do(dr) : void 0;
                } else {
                  var Dr = Bk(r, i);
                  if (!Dr) return t & 2 ? Py(r, ui) : ui;
                  if (Dr.length === 0) return t & 2 ? Py(r, Fi) : Fi;
                  u = Pa(Dr, 2);
                }
                if (u || h || z2) {
                  if (h && Kh(r, h, 3), u && Kh(r, u, 1), z2 && Kh(r, z2, 2), u && Vl(u) || h && Vl(h) || z2 && Vl(z2)) {
                    var Qr = Pb(r), li = Qr ? Qr === yl(r) ? s ? void 0 : u : c0(yo(Qr), r) : void 0;
                    s ? (h = XD(h, li, 0, o), u = XD(u, li, 1, o), z2 = XD(z2, li, 2, o)) : u = kw(u, li, o);
                  }
                  h && (h = $c(h)), u && (u = $c(u)), z2 && (z2 = $c(z2));
                }
                return s ? Fk(h || ui, u || me, z2 || xC(2, r) || gr, o) : o ? Ny(u || me) : u || me;
              }
              function Fk(r, i, t, o) {
                var s = o ? St : pa, u = s.getGlobalGeneratorType(false);
                if (r = s.resolveIterationType(r, void 0) || gr, i = s.resolveIterationType(i, void 0) || gr, t = s.resolveIterationType(t, void 0) || gr, u === kn) {
                  var h = s.getGlobalIterableIteratorType(false), z2 = h !== kn ? x6(h, s) : void 0, me = z2 ? z2.returnType : Oe, Me = z2 ? z2.nextType : Tr;
                  return ao(i, me) && ao(Me, t) ? h !== kn ? $m(h, [r]) : (s.getGlobalIterableIteratorType(true), Ba) : (s.getGlobalGeneratorType(true), Ba);
                }
                return $m(u, [r, i, t]);
              }
              function X7(r, i) {
                var t = [], o = [], s = (e.getFunctionFlags(r) & 2) !== 0;
                return e.forEachYieldExpression(r.body, function(u) {
                  var h = u.expression ? yn(u.expression, i) : vi;
                  e.pushIfUnique(t, Mk(u, h, Oe, s));
                  var z2;
                  if (u.asteriskToken) {
                    var me = Jy(h, s ? 19 : 17, u.expression);
                    z2 = me && me.nextType;
                  } else z2 = ou(u);
                  z2 && e.pushIfUnique(o, z2);
                }), { yieldTypes: t, nextTypes: o };
              }
              function Mk(r, i, t, o) {
                var s = r.expression || r, u = r.asteriskToken ? N_(o ? 19 : 17, i, t, s) : i;
                return o ? ag(u, s, r.asteriskToken ? e.Diagnostics.Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member : e.Diagnostics.Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member) : u;
              }
              function oS(r, i, t, o) {
                var s = 0;
                if (o) {
                  for (var u = i; u < t.length; u++) s |= oe.get(t[u]) || 32768;
                  for (var u = r; u < i; u++) s &= ~(oe.get(t[u]) || 0);
                  for (var u = 0; u < r; u++) s |= oe.get(t[u]) || 32768;
                } else {
                  for (var u = r; u < i; u++) s |= G.get(t[u]) || 128;
                  for (var u = 0; u < r; u++) s &= ~(G.get(t[u]) || 0);
                }
                return s;
              }
              function Lk(r) {
                var i = va(r);
                return i.isExhaustive !== void 0 ? i.isExhaustive : i.isExhaustive = Q7(r);
              }
              function Q7(r) {
                if (r.expression.kind === 216) {
                  var i = Gs(r.expression.expression), t = cC(r, false), o = oS(0, 0, t, true), s = uc(i) || i;
                  return s.flags & 3 ? (556800 & o) === 556800 : !!(ec(s, function(z2) {
                    return (cp(z2) & o) === o;
                  }).flags & 131072);
                }
                var u = Gs(r.expression);
                if (!Cg(u)) return false;
                var h = $h(r);
                return !h.length || e.some(h, Ew) ? false : v8(Ss(u, jc), h);
              }
              function Rk(r) {
                return r.endFlowNode && my(r.endFlowNode);
              }
              function Bk(r, i) {
                var t = e.getFunctionFlags(r), o = [], s = Rk(r), u = false;
                if (e.forEachReturnStatement(r.body, function(h) {
                  var z2 = h.expression;
                  if (z2) {
                    var me = Os(z2, i && i & -9);
                    t & 2 && (me = Ev(xv(me, false, r, e.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member))), me.flags & 131072 && (u = true), e.pushIfUnique(o, me);
                  } else s = true;
                }), !(o.length === 0 && !s && (u || Y7(r)))) return Ye && o.length && s && !(Sl(r) && o.some(function(h) {
                  return h.symbol === r.symbol;
                })) && e.pushIfUnique(o, Tr), o;
              }
              function Y7(r) {
                switch (r.kind) {
                  case 213:
                  case 214:
                    return true;
                  case 169:
                    return r.parent.kind === 205;
                  default:
                    return false;
                }
              }
              function sS(r, i) {
                fe(t);
                return;
                function t() {
                  var o = e.getFunctionFlags(r), s = i && B0(i, o);
                  if (!(s && fs(s, 16385)) && !(r.kind === 168 || e.nodeIsMissing(r.body) || r.body.kind !== 235 || !Rk(r))) {
                    var u = r.flags & 512, h = e.getEffectiveReturnTypeNode(r) || r;
                    if (s && s.flags & 131072) Xr(h, e.Diagnostics.A_function_returning_never_cannot_have_a_reachable_end_point);
                    else if (s && !u) Xr(h, e.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value);
                    else if (s && Ye && !ao(Tr, s)) Xr(h, e.Diagnostics.Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined);
                    else if (ye.noImplicitReturns) {
                      if (!s) {
                        if (!u) return;
                        var z2 = yo(yl(r));
                        if (I6(r, z2)) return;
                      }
                      Xr(h, e.Diagnostics.Not_all_code_paths_return_a_value);
                    }
                  }
                }
              }
              function Jk(r, i) {
                if (e.Debug.assert(r.kind !== 169 || e.isObjectLiteralMethod(r)), xm(r), e.isFunctionExpression(r) && Sm(r, r.name), i && i & 4 && Ju(r)) {
                  if (!e.getEffectiveReturnTypeNode(r) && !e.hasContextSensitiveParameters(r)) {
                    var t = dv(r);
                    if (t && Id(yo(t))) {
                      var o = va(r);
                      if (o.contextFreeType) return o.contextFreeType;
                      var s = C0(r, i), u = Fu(void 0, void 0, void 0, e.emptyArray, s, void 0, 0, 0), h = rs(r.symbol, we, [u], e.emptyArray, e.emptyArray);
                      return h.objectFlags |= 262144, o.contextFreeType = h;
                    }
                  }
                  return xn;
                }
                var z2 = X0(r);
                return !z2 && r.kind === 213 && WS(r), $7(r, i), Jt(Et(r));
              }
              function $7(r, i) {
                var t = va(r);
                if (!(t.flags & 1024)) {
                  var o = dv(r);
                  if (!(t.flags & 1024)) {
                    t.flags |= 1024;
                    var s = e.firstOrUndefined(ot(Jt(Et(r)), 0));
                    if (!s) return;
                    if (Ju(r)) if (o) {
                      var u = wg(r);
                      i && i & 2 && K7(s, o, u);
                      var h = u ? Tg(o, u.mapper) : o;
                      Ik(s, h);
                    } else G7(s);
                    if (o && !yg(r) && !s.resolvedReturnType) {
                      var z2 = C0(r, i);
                      s.resolvedReturnType || (s.resolvedReturnType = z2);
                    }
                    Dv(r);
                  }
                }
              }
              function Z7(r) {
                e.Debug.assert(r.kind !== 169 || e.isObjectLiteralMethod(r));
                var i = e.getFunctionFlags(r), t = yg(r);
                if (sS(r, t), r.body) if (e.getEffectiveReturnTypeNode(r) || yo(yl(r)), r.body.kind === 235) io(r.body);
                else {
                  var o = yn(r.body), s = t && B0(t, i);
                  if (s) if ((i & 3) === 2) {
                    var u = xv(o, false, r.body, e.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
                    op(u, s, r.body, r.body);
                  } else op(o, s, r.body, r.body);
                }
              }
              function k0(r, i, t, o) {
                if (o === void 0 && (o = false), !ao(i, At)) {
                  var s = o && Sv(i);
                  return zu(r, !!s && ao(s, At), t), false;
                }
                return true;
              }
              function eO(r) {
                if (!e.isCallExpression(r) || !e.isBindableObjectDefinePropertyCall(r)) return false;
                var i = Os(r.arguments[2]), t = da(i, "value");
                if (t) {
                  var o = bi(i, "writable"), s = o && Jt(o);
                  if (!s || s === xt || s === ut) return true;
                  if (o && o.valueDeclaration && e.isPropertyAssignment(o.valueDeclaration)) {
                    var u = o.valueDeclaration.initializer, h = yn(u);
                    if (h === xt || h === ut) return true;
                  }
                  return false;
                }
                var z2 = bi(i, "set");
                return !z2;
              }
              function Zu(r) {
                return !!(e.getCheckFlags(r) & 8 || r.flags & 4 && e.getDeclarationModifierFlagsFromSymbol(r) & 64 || r.flags & 3 && p0(r) & 2 || r.flags & 98304 && !(r.flags & 65536) || r.flags & 8 || e.some(r.declarations, eO));
              }
              function jk(r, i, t) {
                var o, s;
                if (t === 0) return false;
                if (Zu(i)) {
                  if (i.flags & 4 && e.isAccessExpression(r) && r.expression.kind === 108) {
                    var u = e.getContainingFunction(r);
                    if (!(u && (u.kind === 171 || Sl(u)))) return true;
                    if (i.valueDeclaration) {
                      var h = e.isBinaryExpression(i.valueDeclaration), z2 = u.parent === i.valueDeclaration.parent, me = u === i.valueDeclaration.parent, Me = h && ((o = i.parent) === null || o === void 0 ? void 0 : o.valueDeclaration) === u.parent, $e = h && ((s = i.parent) === null || s === void 0 ? void 0 : s.valueDeclaration) === u, tr = z2 || me || Me || $e;
                      return !tr;
                    }
                  }
                  return true;
                }
                if (e.isAccessExpression(r)) {
                  var dr = e.skipParentheses(r.expression);
                  if (dr.kind === 79) {
                    var Dr = va(dr).resolvedSymbol;
                    if (Dr.flags & 2097152) {
                      var Qr = ru(Dr);
                      return !!Qr && Qr.kind === 268;
                    }
                  }
                }
                return false;
              }
              function hv(r, i, t) {
                var o = e.skipOuterExpressions(r, 7);
                return o.kind !== 79 && !e.isAccessExpression(o) ? (Xr(r, i), false) : o.flags & 32 ? (Xr(r, t), false) : true;
              }
              function rO(r) {
                yn(r.expression);
                var i = e.skipParentheses(r.expression);
                if (!e.isAccessExpression(i)) return Xr(i, e.Diagnostics.The_operand_of_a_delete_operator_must_be_a_property_reference), Ii;
                e.isPropertyAccessExpression(i) && e.isPrivateIdentifier(i.name) && Xr(i, e.Diagnostics.The_operand_of_a_delete_operator_cannot_be_a_private_identifier);
                var t = va(i), o = cu(t.resolvedSymbol);
                return o && (Zu(o) && Xr(i, e.Diagnostics.The_operand_of_a_delete_operator_cannot_be_a_read_only_property), iO(i, o)), Ii;
              }
              function iO(r, i) {
                var t = Jt(i);
                Ye && !(t.flags & 131075) && !(yr ? i.flags & 16777216 : ju(t) & 32768) && Xr(r, e.Diagnostics.The_operand_of_a_delete_operator_must_be_optional);
              }
              function tO(r) {
                return yn(r.expression), ho;
              }
              function aO(r) {
                return yn(r.expression), vi;
              }
              function nO(r) {
                var i = e.getContainingFunctionOrClassStaticBlock(r);
                if (i && e.isClassStaticBlockDeclaration(i)) Xr(r, e.Diagnostics.Await_expression_cannot_be_used_inside_a_class_static_block);
                else if (!(r.flags & 32768)) if (e.isInTopLevelContext(r)) {
                  var t = e.getSourceFileOfNode(r);
                  if (!Jd(t)) {
                    var o = void 0;
                    if (!e.isEffectiveExternalModule(t, ye)) {
                      o != null || (o = e.getSpanOfTokenAtPosition(t, r.pos));
                      var s = e.createFileDiagnostic(t, o.start, o.length, e.Diagnostics.await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module);
                      rn.add(s);
                    }
                    switch (er) {
                      case e.ModuleKind.Node16:
                      case e.ModuleKind.NodeNext:
                        if (t.impliedNodeFormat === e.ModuleKind.CommonJS) {
                          o != null || (o = e.getSpanOfTokenAtPosition(t, r.pos)), rn.add(e.createFileDiagnostic(t, o.start, o.length, e.Diagnostics.The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level));
                          break;
                        }
                      case e.ModuleKind.ES2022:
                      case e.ModuleKind.ESNext:
                      case e.ModuleKind.System:
                        if (Ae >= 4) break;
                      default:
                        o != null || (o = e.getSpanOfTokenAtPosition(t, r.pos)), rn.add(e.createFileDiagnostic(t, o.start, o.length, e.Diagnostics.Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher));
                        break;
                    }
                  }
                } else {
                  var t = e.getSourceFileOfNode(r);
                  if (!Jd(t)) {
                    var o = e.getSpanOfTokenAtPosition(t, r.pos), s = e.createFileDiagnostic(t, o.start, o.length, e.Diagnostics.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules);
                    if (i && i.kind !== 171 && (e.getFunctionFlags(i) & 2) === 0) {
                      var u = e.createDiagnosticForNode(i, e.Diagnostics.Did_you_mean_to_mark_this_function_as_async);
                      e.addRelatedInfo(s, u);
                    }
                    rn.add(s);
                  }
                }
                xb(r) && Xr(r, e.Diagnostics.await_expressions_cannot_be_used_in_a_parameter_initializer);
              }
              function oO(r) {
                fe(function() {
                  return nO(r);
                });
                var i = yn(r.expression), t = xv(i, true, r, e.Diagnostics.Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
                return t === i && !nn(t) && !(i.flags & 3) && Ls(false, e.createDiagnosticForNode(r, e.Diagnostics.await_has_no_effect_on_the_type_of_this_expression)), t;
              }
              function sO(r) {
                var i = yn(r.operand);
                if (i === Bt) return Bt;
                switch (r.operand.kind) {
                  case 8:
                    switch (r.operator) {
                      case 40:
                        return Sg(If(-r.operand.text));
                      case 39:
                        return Sg(If(+r.operand.text));
                    }
                    break;
                  case 9:
                    if (r.operator === 40) return Sg(ED({ negative: true, base10Value: e.parsePseudoBigInt(r.operand.text) }));
                }
                switch (r.operator) {
                  case 39:
                  case 40:
                  case 54:
                    return bl(i, r.operand), A0(i, 12288) && Xr(r.operand, e.Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol, e.tokenToString(r.operator)), r.operator === 39 ? (fs(i, 2112) && Xr(r.operand, e.Diagnostics.Operator_0_cannot_be_applied_to_type_1, e.tokenToString(r.operator), Ot(Kl(i))), nt) : cS(i);
                  case 53:
                    Bg(r.operand);
                    var t = cp(i) & 12582912;
                    return t === 4194304 ? xt : t === 8388608 ? Dt : Ii;
                  case 45:
                  case 46:
                    var o = k0(r.operand, bl(i, r.operand), e.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type);
                    return o && hv(r.operand, e.Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access, e.Diagnostics.The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access), cS(i);
                }
                return Pe;
              }
              function cO(r) {
                var i = yn(r.operand);
                if (i === Bt) return Bt;
                var t = k0(r.operand, bl(i, r.operand), e.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type);
                return t && hv(r.operand, e.Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access, e.Diagnostics.The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access), cS(i);
              }
              function cS(r) {
                return fs(r, 2112) ? Ns(r, 3) || fs(r, 296) ? At : Mt : nt;
              }
              function A0(r, i) {
                if (fs(r, i)) return true;
                var t = Hd(r);
                return !!t && fs(t, i);
              }
              function fs(r, i) {
                if (r.flags & i) return true;
                if (r.flags & 3145728) for (var t = r.types, o = 0, s = t; o < s.length; o++) {
                  var u = s[o];
                  if (fs(u, i)) return true;
                }
                return false;
              }
              function Ns(r, i, t) {
                return r.flags & i ? true : t && r.flags & 114691 ? false : !!(i & 296) && ao(r, nt) || !!(i & 2112) && ao(r, Mt) || !!(i & 402653316) && ao(r, Li) || !!(i & 528) && ao(r, Ii) || !!(i & 16384) && ao(r, Fi) || !!(i & 131072) && ao(r, ui) || !!(i & 65536) && ao(r, Wi) || !!(i & 32768) && ao(r, Tr) || !!(i & 4096) && ao(r, Ki) || !!(i & 67108864) && ao(r, Oi);
              }
              function Lg(r, i, t) {
                return r.flags & 1048576 ? e.every(r.types, function(o) {
                  return Lg(o, i, t);
                }) : Ns(r, i, t);
              }
              function uS(r) {
                return !!(e.getObjectFlags(r) & 16) && !!r.symbol && lS(r.symbol);
              }
              function lS(r) {
                return (r.flags & 128) !== 0;
              }
              function uO(r, i, t, o) {
                return t === Bt || o === Bt ? Bt : (!ta(t) && Lg(t, 131068) && Xr(r, e.Diagnostics.The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter), ta(o) || RS(o) || E_(o, br) || Xr(i, e.Diagnostics.The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_Function_interface_type), Ii);
              }
              function lO(r, i, t, o) {
                if (t === Bt || o === Bt) return Bt;
                if (e.isPrivateIdentifier(r)) {
                  if (Ae < 99 && fc(r, 2097152), !va(r).resolvedSymbol && e.getContainingClass(r)) {
                    var s = Wb(r, o.symbol, true);
                    YC(r, o, s);
                  }
                } else t = bl(t, r), Lg(t, 402665900) || Ns(t, 407109632) || Xr(r, e.Diagnostics.The_left_hand_side_of_an_in_expression_must_be_a_private_identifier_or_of_type_any_string_number_or_symbol);
                o = bl(o, i);
                var u = Q_(o);
                return (!Lg(o, 126091264) || u && (Ns(o, 3145728) && !Lg(u, 126091264) || !fs(u, 126615552))) && Xr(i, e.Diagnostics.The_right_hand_side_of_an_in_expression_must_not_be_a_primitive), Ii;
              }
              function fO(r, i, t) {
                var o = r.properties;
                if (Ye && o.length === 0) return bl(i, r);
                for (var s = 0; s < o.length; s++) Uk(r, i, s, o, t);
                return i;
              }
              function Uk(r, i, t, o, s) {
                s === void 0 && (s = false);
                var u = r.properties, h = u[t];
                if (h.kind === 296 || h.kind === 297) {
                  var z2 = h.name, me = Z_(z2);
                  if (_f(me)) {
                    var Me = pf(me), $e = bi(i, Me);
                    $e && (xy($e, h, s), Jb(h, false, true, i, $e));
                  }
                  var tr = Jc(i, me, 32, z2), dr = is(h, tr);
                  return Rd(h.kind === 297 ? h : h.initializer, dr);
                } else if (h.kind === 298) if (t < u.length - 1) Xr(h, e.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
                else {
                  Ae < 99 && fc(h, 4);
                  var Dr = [];
                  if (o) for (var Qr = 0, li = o; Qr < li.length; Qr++) {
                    var Ti = li[Qr];
                    e.isSpreadAssignment(Ti) || Dr.push(Ti.name);
                  }
                  var dr = Lo(i, Dr, i.symbol);
                  return ng(o, e.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma), Rd(h.expression, dr);
                }
                else Xr(h, e.Diagnostics.Property_assignment_expected);
              }
              function _O(r, i, t) {
                var o = r.elements;
                Ae < 2 && ye.downlevelIteration && fc(r, 512);
                for (var s = N_(193, i, Tr, r) || Pe, u = ye.noUncheckedIndexedAccess ? void 0 : s, h = 0; h < o.length; h++) {
                  var z2 = s;
                  r.elements[h].kind === 225 && (z2 = u = u != null ? u : N_(65, i, Tr, r) || Pe), zk(r, i, h, z2, t);
                }
                return i;
              }
              function zk(r, i, t, o, s) {
                var u = r.elements, h = u[t];
                if (h.kind !== 227) {
                  if (h.kind !== 225) {
                    var z2 = If(t);
                    if (sp(i)) {
                      var me = 32 | (pm(h) ? 16 : 0), Me = ep(i, z2, me, ed(h, z2)) || Pe, $e = pm(h) ? Ks(Me, 524288) : Me, tr = is(h, $e);
                      return Rd(h, tr, s);
                    }
                    return Rd(h, o, s);
                  }
                  if (t < u.length - 1) Xr(h, e.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
                  else {
                    var dr = h.expression;
                    if (dr.kind === 221 && dr.operatorToken.kind === 63) Xr(dr.operatorToken, e.Diagnostics.A_rest_element_cannot_have_an_initializer);
                    else {
                      ng(r.elements, e.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
                      var tr = gf(i, Yn) ? Ss(i, function(Qr) {
                        return Zm(Qr, t);
                      }) : Zs(o);
                      return Rd(dr, tr, s);
                    }
                  }
                }
              }
              function Rd(r, i, t, o) {
                var s;
                if (r.kind === 297) {
                  var u = r;
                  u.objectAssignmentInitializer && (Ye && !(ju(yn(u.objectAssignmentInitializer)) & 32768) && (i = Ks(i, 524288)), mO(u.name, u.equalsToken, u.objectAssignmentInitializer, t)), s = r.name;
                } else s = r;
                return s.kind === 221 && s.operatorToken.kind === 63 && (Ir(s, t), s = s.left), s.kind === 205 ? fO(s, i, o) : s.kind === 204 ? _O(s, i, t) : pO(s, i, t);
              }
              function pO(r, i, t) {
                var o = yn(r, t), s = r.parent.kind === 298 ? e.Diagnostics.The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access : e.Diagnostics.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access, u = r.parent.kind === 298 ? e.Diagnostics.The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access : e.Diagnostics.The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access;
                return hv(r, s, u) && op(i, o, r, r), e.isPrivateIdentifierPropertyAccessExpression(r) && fc(r.parent, 1048576), i;
              }
              function Iy(r) {
                switch (r = e.skipParentheses(r), r.kind) {
                  case 79:
                  case 10:
                  case 13:
                  case 210:
                  case 223:
                  case 14:
                  case 8:
                  case 9:
                  case 110:
                  case 95:
                  case 104:
                  case 153:
                  case 213:
                  case 226:
                  case 214:
                  case 204:
                  case 205:
                  case 216:
                  case 230:
                  case 279:
                  case 278:
                    return true;
                  case 222:
                    return Iy(r.whenTrue) && Iy(r.whenFalse);
                  case 221:
                    return e.isAssignmentOperator(r.operatorToken.kind) ? false : Iy(r.left) && Iy(r.right);
                  case 219:
                  case 220:
                    switch (r.operator) {
                      case 53:
                      case 39:
                      case 40:
                      case 54:
                        return true;
                    }
                    return false;
                  case 217:
                  case 211:
                  case 229:
                  default:
                    return false;
                }
              }
              function fS(r, i) {
                return (i.flags & 98304) !== 0 || cm(r, i);
              }
              function dO() {
                var r = e.createBinaryExpressionTrampoline(i, t, o, s, u, h);
                return function(dr, Dr) {
                  var Qr = r(dr, Dr);
                  return e.Debug.assertIsDefined(Qr), Qr;
                };
                function i(dr, Dr, Qr) {
                  if (Dr ? (Dr.stackIndex++, Dr.skip = false, Me(Dr, void 0), tr(Dr, void 0)) : Dr = { checkMode: Qr, skip: false, stackIndex: 0, typeStack: [void 0, void 0] }, e.isInJSFile(dr) && e.getAssignedExpandoInitializer(dr)) return Dr.skip = true, tr(Dr, yn(dr.right, Qr)), Dr;
                  gO(dr);
                  var li = dr.operatorToken.kind;
                  return li === 63 && (dr.left.kind === 205 || dr.left.kind === 204) && (Dr.skip = true, tr(Dr, Rd(dr.left, yn(dr.right, Qr), Qr, dr.right.kind === 108))), Dr;
                }
                function t(dr, Dr, Qr) {
                  if (!Dr.skip) return z2(Dr, dr);
                }
                function o(dr, Dr, Qr) {
                  if (!Dr.skip) {
                    var li = $e(Dr);
                    e.Debug.assertIsDefined(li), Me(Dr, li), tr(Dr, void 0);
                    var Ti = dr.kind;
                    if (Ti === 55 || Ti === 56 || Ti === 60) {
                      if (Ti === 55) {
                        var Ci = e.walkUpParenthesizedExpressions(Qr.parent);
                        TS(Qr.left, e.isIfStatement(Ci) ? Ci.thenStatement : void 0);
                      }
                      h6(li, Qr.left);
                    }
                  }
                }
                function s(dr, Dr, Qr) {
                  if (!Dr.skip) return z2(Dr, dr);
                }
                function u(dr, Dr) {
                  var Qr;
                  if (Dr.skip) Qr = $e(Dr);
                  else {
                    var li = me(Dr);
                    e.Debug.assertIsDefined(li);
                    var Ti = $e(Dr);
                    e.Debug.assertIsDefined(Ti), Qr = Wk(dr.left, dr.operatorToken, dr.right, li, Ti, dr);
                  }
                  return Dr.skip = false, Me(Dr, void 0), tr(Dr, void 0), Dr.stackIndex--, Qr;
                }
                function h(dr, Dr, Qr) {
                  return tr(dr, Dr), dr;
                }
                function z2(dr, Dr) {
                  if (e.isBinaryExpression(Dr)) return Dr;
                  tr(dr, yn(Dr, dr.checkMode));
                }
                function me(dr) {
                  return dr.typeStack[dr.stackIndex];
                }
                function Me(dr, Dr) {
                  dr.typeStack[dr.stackIndex] = Dr;
                }
                function $e(dr) {
                  return dr.typeStack[dr.stackIndex + 1];
                }
                function tr(dr, Dr) {
                  dr.typeStack[dr.stackIndex + 1] = Dr;
                }
              }
              function gO(r) {
                var i = r.left, t = r.operatorToken, o = r.right;
                t.kind === 60 && (e.isBinaryExpression(i) && (i.operatorToken.kind === 56 || i.operatorToken.kind === 55) && Tt(i, e.Diagnostics._0_and_1_operations_cannot_be_mixed_without_parentheses, e.tokenToString(i.operatorToken.kind), e.tokenToString(t.kind)), e.isBinaryExpression(o) && (o.operatorToken.kind === 56 || o.operatorToken.kind === 55) && Tt(o, e.Diagnostics._0_and_1_operations_cannot_be_mixed_without_parentheses, e.tokenToString(o.operatorToken.kind), e.tokenToString(t.kind)));
              }
              function mO(r, i, t, o, s) {
                var u = i.kind;
                if (u === 63 && (r.kind === 205 || r.kind === 204)) return Rd(r, yn(t, o), o, t.kind === 108);
                var h;
                u === 55 || u === 56 || u === 60 ? h = Bg(r, o) : h = yn(r, o);
                var z2 = yn(t, o);
                return Wk(r, i, t, h, z2, s);
              }
              function Wk(r, i, t, o, s, u) {
                var h = i.kind;
                switch (h) {
                  case 41:
                  case 42:
                  case 66:
                  case 67:
                  case 43:
                  case 68:
                  case 44:
                  case 69:
                  case 40:
                  case 65:
                  case 47:
                  case 70:
                  case 48:
                  case 71:
                  case 49:
                  case 72:
                  case 51:
                  case 74:
                  case 52:
                  case 78:
                  case 50:
                  case 73:
                    if (o === Bt || s === Bt) return Bt;
                    o = bl(o, r), s = bl(s, t);
                    var z2 = void 0;
                    if (o.flags & 528 && s.flags & 528 && (z2 = ja(i.kind)) !== void 0) return Xr(u || i, e.Diagnostics.The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead, e.tokenToString(i.kind), e.tokenToString(z2)), nt;
                    var me = k0(r, o, e.Diagnostics.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type, true), Me = k0(t, s, e.Diagnostics.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type, true), $e;
                    if (Ns(o, 3) && Ns(s, 3) || !(fs(o, 2112) || fs(s, 2112))) $e = nt;
                    else if (Nt(o, s)) {
                      switch (h) {
                        case 49:
                        case 72:
                          Eo();
                          break;
                        case 42:
                        case 67:
                          Ae < 3 && Xr(u, e.Diagnostics.Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_later);
                      }
                      $e = Mt;
                    } else Eo(Nt), $e = Pe;
                    return me && Me && Fn($e), $e;
                  case 39:
                  case 64:
                    if (o === Bt || s === Bt) return Bt;
                    !Ns(o, 402653316) && !Ns(s, 402653316) && (o = bl(o, r), s = bl(s, t));
                    var tr = void 0;
                    if (Ns(o, 296, true) && Ns(s, 296, true) ? tr = nt : Ns(o, 2112, true) && Ns(s, 2112, true) ? tr = Mt : Ns(o, 402653316, true) || Ns(s, 402653316, true) ? tr = Li : (ta(o) || ta(s)) && (tr = nn(o) || nn(s) ? Pe : Oe), tr && !Sn(h)) return tr;
                    if (!tr) {
                      var dr = 402655727;
                      return Eo(function(it, Yt) {
                        return Ns(it, dr) && Ns(Yt, dr);
                      }), Oe;
                    }
                    return h === 64 && Fn(tr), tr;
                  case 29:
                  case 31:
                  case 32:
                  case 33:
                    return Sn(h) && (o = Kl(bl(o, r)), s = Kl(bl(s, t)), Tn(function(it, Yt) {
                      return cm(it, Yt) || cm(Yt, it) || ao(it, At) && ao(Yt, At);
                    })), Ii;
                  case 34:
                  case 35:
                  case 36:
                  case 37:
                    return Tn(function(it, Yt) {
                      return fS(it, Yt) || fS(Yt, it);
                    }), Ii;
                  case 102:
                    return uO(r, t, o, s);
                  case 101:
                    return lO(r, t, o, s);
                  case 55:
                  case 76: {
                    var Dr = cp(o) & 4194304 ? Pa([Pw(Ye ? o : Kl(s)), s]) : o;
                    return h === 76 && Fn(s), Dr;
                  }
                  case 56:
                  case 75: {
                    var Qr = cp(o) & 8388608 ? Pa([OE(o), s], 2) : o;
                    return h === 75 && Fn(s), Qr;
                  }
                  case 60:
                  case 77: {
                    var li = cp(o) & 262144 ? Pa([C_(o), s], 2) : o;
                    return h === 77 && Fn(s), li;
                  }
                  case 63:
                    var Ti = e.isBinaryExpression(r.parent) ? e.getAssignmentDeclarationKind(r.parent) : 0;
                    return Ra(Ti, s), wn(Ti) ? ((!(s.flags & 524288) || Ti !== 2 && Ti !== 6 && !Of(s) && !db(s) && !(e.getObjectFlags(s) & 1)) && Fn(s), o) : (Fn(s), fm(s));
                  case 27:
                    if (!ye.allowUnreachableCode && Iy(r) && !ca(t)) {
                      var Ci = e.getSourceFileOfNode(r), $i = Ci.text, Zi = e.skipTrivia($i, r.pos), qt = Ci.parseDiagnostics.some(function(it) {
                        return it.code !== e.Diagnostics.JSX_expressions_must_have_one_parent_element.code ? false : e.textSpanContainsPosition(it, Zi);
                      });
                      qt || Xr(r, e.Diagnostics.Left_side_of_comma_operator_is_unused_and_has_no_side_effects);
                    }
                    return s;
                  default:
                    return e.Debug.fail();
                }
                function Nt(it, Yt) {
                  return Ns(it, 2112) && Ns(Yt, 2112);
                }
                function Ra(it, Yt) {
                  if (it === 2) for (var Ia = 0, Qt = Pf(Yt); Ia < Qt.length; Ia++) {
                    var Ka = Qt[Ia], cn = Jt(Ka);
                    if (cn.symbol && cn.symbol.flags & 32) {
                      var Un = Ka.escapedName, oa = es(Ka.valueDeclaration, Un, 788968, void 0, Un, false);
                      (oa == null ? void 0 : oa.declarations) && oa.declarations.some(e.isJSDocTypedefTag) && (Cl(oa, e.Diagnostics.Duplicate_identifier_0, e.unescapeLeadingUnderscores(Un), Ka), Cl(Ka, e.Diagnostics.Duplicate_identifier_0, e.unescapeLeadingUnderscores(Un), oa));
                    }
                  }
                }
                function ca(it) {
                  return it.kind === 79 && it.escapedText === "eval";
                }
                function Sn(it) {
                  var Yt = A0(o, 12288) ? r : A0(s, 12288) ? t : void 0;
                  return Yt ? (Xr(Yt, e.Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol, e.tokenToString(it)), false) : true;
                }
                function ja(it) {
                  switch (it) {
                    case 51:
                    case 74:
                      return 56;
                    case 52:
                    case 78:
                      return 37;
                    case 50:
                    case 73:
                      return 55;
                    default:
                      return;
                  }
                }
                function Fn(it) {
                  e.isAssignmentOperator(h) && fe(Yt);
                  function Yt() {
                    if (hv(r, e.Diagnostics.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access, e.Diagnostics.The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access) && (!e.isIdentifier(r) || e.unescapeLeadingUnderscores(r.escapedText) !== "exports")) {
                      var Ia = void 0;
                      if (yr && e.isPropertyAccessExpression(r) && fs(it, 32768)) {
                        var Qt = da(Gs(r.expression), r.name.escapedText);
                        jD(it, Qt) && (Ia = e.Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target);
                      }
                      op(it, o, r, t, Ia);
                    }
                  }
                }
                function wn(it) {
                  var Yt;
                  switch (it) {
                    case 2:
                      return true;
                    case 1:
                    case 5:
                    case 6:
                    case 3:
                    case 4:
                      var Ia = Et(r), Qt = e.getAssignedExpandoInitializer(t);
                      return !!Qt && e.isObjectLiteralExpression(Qt) && !!(!((Yt = Ia == null ? void 0 : Ia.exports) === null || Yt === void 0) && Yt.size);
                    default:
                      return false;
                  }
                }
                function Tn(it) {
                  return it(o, s) ? false : (Eo(it), true);
                }
                function Eo(it) {
                  var Yt, Ia = false, Qt = u || i;
                  if (it) {
                    var Ka = k_(o), cn = k_(s);
                    Ia = !(Ka === o && cn === s) && !!(Ka && cn) && it(Ka, cn);
                  }
                  var Un = o, oa = s;
                  !Ia && it && (Yt = vO(o, s, it), Un = Yt[0], oa = Yt[1]);
                  var Mn = nf(Un, oa), Ln = Mn[0], ci = Mn[1];
                  lt(Qt, Ia, Ln, ci) || zu(Qt, Ia, e.Diagnostics.Operator_0_cannot_be_applied_to_types_1_and_2, e.tokenToString(i.kind), Ln, ci);
                }
                function lt(it, Yt, Ia, Qt) {
                  var Ka;
                  switch (i.kind) {
                    case 36:
                    case 34:
                      Ka = "false";
                      break;
                    case 37:
                    case 35:
                      Ka = "true";
                  }
                  if (Ka) return zu(it, Yt, e.Diagnostics.This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap, Ka, Ia, Qt);
                }
              }
              function vO(r, i, t) {
                var o = r, s = i, u = Kl(r), h = Kl(i);
                return t(u, h) || (o = u, s = h), [o, s];
              }
              function yO(r) {
                fe(Dr);
                var i = e.getContainingFunction(r);
                if (!i) return Oe;
                var t = e.getFunctionFlags(i);
                if (!(t & 1)) return Oe;
                var o = (t & 2) !== 0;
                r.asteriskToken && (o && Ae < 99 && fc(r, 26624), !o && Ae < 2 && ye.downlevelIteration && fc(r, 256));
                var s = yg(i), u = s && P6(s, o), h = u && u.yieldType || Oe, z2 = u && u.nextType || Oe, me = o ? ag(z2) || Oe : z2, Me = r.expression ? yn(r.expression) : vi, $e = Mk(r, Me, me, o);
                if (s && $e && op($e, h, r.expression || r, r.expression), r.asteriskToken) {
                  var tr = o ? 19 : 17;
                  return b6(tr, 1, Me, r.expression) || Oe;
                } else if (s) return Jg(2, s, o) || Oe;
                var dr = xC(2, i);
                return dr || (dr = Oe, fe(function() {
                  if (n && !e.expressionResultIsUnused(r)) {
                    var Qr = ou(r);
                    (!Qr || ta(Qr)) && Xr(r, e.Diagnostics.yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_type_annotation);
                  }
                })), dr;
                function Dr() {
                  r.flags & 8192 || Hs(r, e.Diagnostics.A_yield_expression_is_only_allowed_in_a_generator_body), xb(r) && Xr(r, e.Diagnostics.yield_expressions_cannot_be_used_in_a_parameter_initializer);
                }
              }
              function hO(r, i) {
                Bg(r.condition), TS(r.condition, r.whenTrue);
                var t = yn(r.whenTrue, i), o = yn(r.whenFalse, i);
                return Pa([t, o], 2);
              }
              function qk(r) {
                var i = r.parent;
                return e.isParenthesizedExpression(i) && qk(i) || e.isElementAccessExpression(i) && i.argumentExpression === r;
              }
              function DO(r) {
                for (var i = [r.head.text], t = [], o = 0, s = r.templateSpans; o < s.length; o++) {
                  var u = s[o], h = yn(u.expression);
                  A0(h, 12288) && Xr(u.expression, e.Diagnostics.Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String), i.push(u.literal.text), t.push(ao(h, ba) ? h : Li);
                }
                return hm(r) || qk(r) || rg(ou(r) || gr, bO) ? Dg(i, t) : Li;
              }
              function bO(r) {
                return !!(r.flags & 134217856 || r.flags & 58982400 && fs(uc(r) || gr, 402653316));
              }
              function SO(r) {
                return r.kind === 286 && !e.isJsxSelfClosingElement(r.parent) ? r.parent.parent : r;
              }
              function Rg(r, i, t, o) {
                var s = SO(r), u = s.contextualType, h = s.inferenceContext;
                try {
                  s.contextualType = i, s.inferenceContext = t;
                  var z2 = yn(r, o | 1 | (t ? 2 : 0));
                  t && t.intraExpressionInferenceSites && (t.intraExpressionInferenceSites = void 0);
                  var me = fs(z2, 2944) && N0(z2, c0(i, r)) ? jc(z2) : z2;
                  return me;
                } finally {
                  s.contextualType = u, s.inferenceContext = h;
                }
              }
              function Os(r, i) {
                if (i && i !== 0) return yn(r, i);
                var t = va(r);
                if (!t.resolvedType) {
                  var o = ko, s = Zc;
                  ko = Ao, Zc = void 0, t.resolvedType = yn(r, i), Zc = s, ko = o;
                }
                return t.resolvedType;
              }
              function Vk(r) {
                return r = e.skipParentheses(r, true), r.kind === 211 || r.kind === 229 || e.isJSDocTypeAssertion(r);
              }
              function wy(r, i, t) {
                var o = e.getEffectiveInitializer(r), s = Yk(o) || (t ? Rg(o, t, void 0, i || 0) : Os(o, i));
                return e.isParameter(r) && r.name.kind === 202 && Yn(s) && !s.target.hasRestElement && $_(s) < r.name.elements.length ? TO(s, r.name) : s;
              }
              function TO(r, i) {
                for (var t = i.elements, o = xo(r).slice(), s = r.target.elementFlags.slice(), u = $_(r); u < t.length; u++) {
                  var h = t[u];
                  (u < t.length - 1 || !(h.kind === 203 && h.dotDotDotToken)) && (o.push(!e.isOmittedExpression(h) && pm(h) ? vs(h, false, false) : Oe), s.push(2), !e.isOmittedExpression(h) && !pm(h) && Xp(h, Oe));
                }
                return Wl(o, s, r.target.readonly);
              }
              function _S(r, i) {
                var t = e.getCombinedNodeFlags(r) & 2 || e.isDeclarationReadonly(r) ? i : Hp(i);
                if (e.isInJSFile(r)) {
                  if (kE(t)) return Xp(r, Oe), Oe;
                  if (Jh(t)) return Xp(r, mo), mo;
                }
                return t;
              }
              function N0(r, i) {
                if (i) {
                  if (i.flags & 3145728) {
                    var t = i.types;
                    return e.some(t, function(s) {
                      return N0(r, s);
                    });
                  }
                  if (i.flags & 58982400) {
                    var o = uc(i) || gr;
                    return fs(o, 4) && fs(r, 128) || fs(o, 8) && fs(r, 256) || fs(o, 64) && fs(r, 2048) || fs(o, 4096) && fs(r, 8192) || N0(r, o);
                  }
                  return !!(i.flags & 406847616 && fs(r, 128) || i.flags & 256 && fs(r, 256) || i.flags & 2048 && fs(r, 2048) || i.flags & 512 && fs(r, 512) || i.flags & 8192 && fs(r, 8192));
                }
                return false;
              }
              function hm(r) {
                var i = r.parent;
                return e.isAssertionExpression(i) && e.isConstTypeReference(i.type) || e.isJSDocTypeAssertion(i) && e.isConstTypeReference(e.getJSDocTypeAssertionType(i)) || (e.isParenthesizedExpression(i) || e.isArrayLiteralExpression(i) || e.isSpreadElement(i)) && hm(i) || (e.isPropertyAssignment(i) || e.isShorthandPropertyAssignment(i) || e.isTemplateSpan(i)) && hm(i.parent);
              }
              function Dm(r, i, t, o) {
                var s = yn(r, i, o);
                return hm(r) || e.isCommonJsExportedExpression(r) ? jc(s) : Vk(r) ? s : HD(s, c0(arguments.length === 2 ? ou(r) : t, r));
              }
              function Kk(r, i) {
                return r.name.kind === 162 && t_(r.name), Dm(r.initializer, i);
              }
              function Gk(r, i) {
                dA(r), r.name.kind === 162 && t_(r.name);
                var t = Jk(r, i);
                return Hk(r, t, i);
              }
              function Hk(r, i, t) {
                if (t && t & 10) {
                  var o = gv(i, 0, true), s = gv(i, 1, true), u = o || s;
                  if (u && u.typeParameters) {
                    var h = $p(r, 2);
                    if (h) {
                      var z2 = gv(C_(h), o ? 0 : 1, false);
                      if (z2 && !z2.typeParameters) {
                        if (t & 8) return Xk(r, t), xn;
                        var me = wg(r), Me = me.signature && yo(me.signature), $e = Me && ok(Me);
                        if ($e && !$e.typeParameters && !e.every(me.inferences, tg)) {
                          var tr = CO(me, u.typeParameters), dr = eD(u, tr), Dr = e.map(me.inferences, function(Qr) {
                            return tb(Qr.typeParameter);
                          });
                          if (eb(dr, z2, function(Qr, li) {
                            df(Dr, Qr, li, 0, true);
                          }), e.some(Dr, tg) && (rb(dr, z2, function(Qr, li) {
                            df(Dr, Qr, li);
                          }), !xO(me.inferences, Dr))) return EO(me.inferences, Dr), me.inferredTypeParameters = e.concatenate(me.inferredTypeParameters, tr), im(dr);
                        }
                        return im(sk(u, z2, me));
                      }
                    }
                  }
                }
                return i;
              }
              function Xk(r, i) {
                if (i & 2) {
                  var t = wg(r);
                  t.flags |= 4;
                }
              }
              function tg(r) {
                return !!(r.candidates || r.contraCandidates);
              }
              function xO(r, i) {
                for (var t = 0; t < r.length; t++) if (tg(r[t]) && tg(i[t])) return true;
                return false;
              }
              function EO(r, i) {
                for (var t = 0; t < r.length; t++) !tg(r[t]) && tg(i[t]) && (r[t] = i[t]);
              }
              function CO(r, i) {
                for (var t = [], o, s, u = 0, h = i; u < h.length; u++) {
                  var z2 = h[u], me = z2.symbol.escapedName;
                  if (pS(r.inferredTypeParameters, me) || pS(t, me)) {
                    var Me = kO(e.concatenate(r.inferredTypeParameters, t), me), $e = oo(262144, Me), tr = Hc($e);
                    tr.target = z2, o = e.append(o, z2), s = e.append(s, tr), t.push(tr);
                  } else t.push(z2);
                }
                if (s) for (var dr = Uc(o, s), Dr = 0, Qr = s; Dr < Qr.length; Dr++) {
                  var z2 = Qr[Dr];
                  z2.mapper = dr;
                }
                return t;
              }
              function pS(r, i) {
                return e.some(r, function(t) {
                  return t.symbol.escapedName === i;
                });
              }
              function kO(r, i) {
                for (var t = i.length; t > 1 && i.charCodeAt(t - 1) >= 48 && i.charCodeAt(t - 1) <= 57; ) t--;
                for (var o = i.slice(0, t), s = 1; ; s++) {
                  var u = o + s;
                  if (!pS(r, u)) return u;
                }
              }
              function Qk(r) {
                var i = ig(r);
                if (i && !i.typeParameters) return yo(i);
              }
              function AO(r) {
                var i = yn(r.expression), t = cv(i, r.expression), o = Qk(i);
                return o && zh(o, r, t !== i);
              }
              function Gs(r) {
                var i = Yk(r);
                if (i) return i;
                if (r.flags & 134217728 && Zc) {
                  var t = Zc[A(r)];
                  if (t) return t;
                }
                var o = xc, s = yn(r);
                if (xc !== o) {
                  var u = Zc || (Zc = []);
                  u[A(r)] = s, e.setNodeFlags(r, r.flags | 134217728);
                }
                return s;
              }
              function Yk(r) {
                var i = e.skipParentheses(r, true);
                if (e.isJSDocTypeAssertion(i)) {
                  var t = e.getJSDocTypeAssertionType(i);
                  if (!e.isConstTypeReference(t)) return Va(t);
                }
                if (i = e.skipParentheses(r), e.isCallExpression(i) && i.expression.kind !== 106 && !e.isRequireCall(i, true) && !Dk(i)) {
                  var t = e.isCallChain(i) ? AO(i) : Qk(gm(i.expression));
                  if (t) return t;
                } else {
                  if (e.isAssertionExpression(i) && !e.isConstTypeReference(i.type)) return Va(i.type);
                  if (r.kind === 8 || r.kind === 10 || r.kind === 110 || r.kind === 95) return yn(r);
                }
              }
              function Oy(r) {
                var i = va(r);
                if (i.contextFreeType) return i.contextFreeType;
                var t = r.contextualType;
                r.contextualType = Oe;
                try {
                  var o = i.contextFreeType = yn(r, 4);
                  return o;
                } finally {
                  r.contextualType = t;
                }
              }
              function yn(r, i, t) {
                e.tracing === null || e.tracing === void 0 || e.tracing.push("check", "checkExpression", { kind: r.kind, pos: r.pos, end: r.end, path: r.tracingPath });
                var o = Ie;
                Ie = r, Ee = 0;
                var s = IO(r, i, t), u = Hk(r, s, i);
                return uS(u) && NO(r, u), Ie = o, e.tracing === null || e.tracing === void 0 || e.tracing.pop(), u;
              }
              function NO(r, i) {
                var t = r.parent.kind === 206 && r.parent.expression === r || r.parent.kind === 207 && r.parent.expression === r || (r.kind === 79 || r.kind === 161) && W0(r) || r.parent.kind === 181 && r.parent.exprName === r || r.parent.kind === 275;
                if (t || Xr(r, e.Diagnostics.const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query), ye.isolatedModules) {
                  e.Debug.assert(!!(i.symbol.flags & 128));
                  var o = i.symbol.valueDeclaration;
                  o.flags & 16777216 && Xr(r, e.Diagnostics.Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided);
                }
              }
              function PO(r, i) {
                if (e.hasJSDocNodes(r) && e.isJSDocTypeAssertion(r)) {
                  var t = e.getJSDocTypeAssertionType(r);
                  return Ck(t, t, r.expression, i);
                }
                return yn(r.expression, i);
              }
              function IO(r, i, t) {
                var o = r.kind;
                if (g) switch (o) {
                  case 226:
                  case 213:
                  case 214:
                    g.throwIfCancellationRequested();
                }
                switch (o) {
                  case 79:
                    return R8(r, i);
                  case 80:
                    return K5(r);
                  case 108:
                    return yy(r);
                  case 106:
                    return Sb(r);
                  case 104:
                    return ct;
                  case 14:
                  case 10:
                    return Sg(Bu(r.text));
                  case 8:
                    return KS(r), Sg(If(+r.text));
                  case 9:
                    return SL(r), Sg(ED({ negative: false, base10Value: e.parsePseudoBigInt(r.text) }));
                  case 110:
                    return Dt;
                  case 95:
                    return xt;
                  case 223:
                    return DO(r);
                  case 13:
                    return Wa;
                  case 204:
                    return PC(r, i, t);
                  case 205:
                    return C5(r, i);
                  case 206:
                    return VC(r, i);
                  case 161:
                    return KC(r, i);
                  case 207:
                    return c7(r, i);
                  case 208:
                    if (r.expression.kind === 100) return R7(r);
                  case 209:
                    return L7(r, i);
                  case 210:
                    return B7(r);
                  case 212:
                    return PO(r, i);
                  case 226:
                    return uM(r);
                  case 213:
                  case 214:
                    return Jk(r, i);
                  case 216:
                    return tO(r);
                  case 211:
                  case 229:
                    return J7(r);
                  case 230:
                    return U7(r);
                  case 228:
                    return kk(r);
                  case 231:
                    return z7(r);
                  case 215:
                    return rO(r);
                  case 217:
                    return aO(r);
                  case 218:
                    return oO(r);
                  case 219:
                    return sO(r);
                  case 220:
                    return cO(r);
                  case 221:
                    return Ir(r, i);
                  case 222:
                    return hO(r, i);
                  case 225:
                    return b5(r, i);
                  case 227:
                    return vi;
                  case 224:
                    return yO(r);
                  case 232:
                    return S5(r);
                  case 288:
                    return J5(r, i);
                  case 278:
                    return P5(r, i);
                  case 279:
                    return A5(r, i);
                  case 282:
                    return I5(r);
                  case 286:
                    return O5(r, i);
                  case 280:
                    e.Debug.fail("Shouldn't ever directly check a JsxOpeningElement");
                }
                return Pe;
              }
              function $k(r) {
                sA(r), r.expression && Hs(r.expression, e.Diagnostics.Type_expected), io(r.constraint), io(r.default);
                var i = Js(Et(r));
                uc(i), X1(i) || Xr(r.default, e.Diagnostics.Type_parameter_0_has_a_circular_default, Ot(i));
                var t = Tc(i), o = D_(i);
                t && o && zc(o, Rc(un(t, Yd(i, o)), o), r.default, e.Diagnostics.Type_0_does_not_satisfy_the_constraint_1), xm(r), fe(function() {
                  return Tm(r.name, e.Diagnostics.Type_parameter_name_cannot_be_0);
                });
              }
              function wO(r) {
                if (e.isInterfaceDeclaration(r.parent) || e.isClassLike(r.parent) || e.isTypeAliasDeclaration(r.parent)) {
                  var i = Js(Et(r)), t = WD(i);
                  if (t) {
                    var o = Et(r.parent);
                    if (e.isTypeAliasDeclaration(r.parent) && !(e.getObjectFlags(go(o)) & 48)) Xr(r, e.Diagnostics.Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_types);
                    else if (t === 32768 || t === 65536) {
                      var s = ly(o, i, t === 65536 ? Da : Rn), u = ly(o, i, t === 65536 ? Rn : Da), h = i;
                      _e = i, zc(s, u, r, e.Diagnostics.Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation), _e = h;
                    }
                  }
                }
              }
              function Zk(r) {
                Ff(r), L0(r);
                var i = e.getContainingFunction(r);
                e.hasSyntacticModifier(r, 16476) && (i.kind === 171 && e.nodeIsPresent(i.body) || Xr(r, e.Diagnostics.A_parameter_property_is_only_allowed_in_a_constructor_implementation), i.kind === 171 && e.isIdentifier(r.name) && r.name.escapedText === "constructor" && Xr(r.name, e.Diagnostics.constructor_cannot_be_used_as_a_parameter_property_name)), r.questionToken && e.isBindingPattern(r.name) && i.body && Xr(r, e.Diagnostics.A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature), r.name && e.isIdentifier(r.name) && (r.name.escapedText === "this" || r.name.escapedText === "new") && (i.parameters.indexOf(r) !== 0 && Xr(r, e.Diagnostics.A_0_parameter_must_be_the_first_parameter, r.name.escapedText), (i.kind === 171 || i.kind === 175 || i.kind === 180) && Xr(r, e.Diagnostics.A_constructor_cannot_have_a_this_parameter), i.kind === 214 && Xr(r, e.Diagnostics.An_arrow_function_cannot_have_a_this_parameter), (i.kind === 172 || i.kind === 173) && Xr(r, e.Diagnostics.get_and_set_accessors_cannot_declare_this_parameters)), r.dotDotDotToken && !e.isBindingPattern(r.name) && !ao(bu(Jt(r.symbol)), Go) && Xr(r, e.Diagnostics.A_rest_parameter_must_be_of_an_array_type);
              }
              function OO(r) {
                var i = FO(r);
                if (!i) {
                  Xr(r, e.Diagnostics.A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods);
                  return;
                }
                var t = yl(i), o = Yc(t);
                if (!!o) {
                  io(r.type);
                  var s = r.parameterName;
                  if (o.kind === 0 || o.kind === 2) Ch(s);
                  else if (o.parameterIndex >= 0) {
                    if (H(t) && o.parameterIndex === t.parameters.length - 1) Xr(s, e.Diagnostics.A_type_predicate_cannot_reference_a_rest_parameter);
                    else if (o.type) {
                      var u = function() {
                        return e.chainDiagnosticMessages(void 0, e.Diagnostics.A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type);
                      };
                      zc(o.type, Jt(t.parameters[o.parameterIndex]), r.type, void 0, u);
                    }
                  } else if (s) {
                    for (var h = false, z2 = 0, me = i.parameters; z2 < me.length; z2++) {
                      var Me = me[z2].name;
                      if (e.isBindingPattern(Me) && e6(Me, s, o.parameterName)) {
                        h = true;
                        break;
                      }
                    }
                    h || Xr(r.parameterName, e.Diagnostics.Cannot_find_parameter_0, o.parameterName);
                  }
                }
              }
              function FO(r) {
                switch (r.parent.kind) {
                  case 214:
                  case 174:
                  case 256:
                  case 213:
                  case 179:
                  case 169:
                  case 168:
                    var i = r.parent;
                    if (r === i.type) return i;
                }
              }
              function e6(r, i, t) {
                for (var o = 0, s = r.elements; o < s.length; o++) {
                  var u = s[o];
                  if (!e.isOmittedExpression(u)) {
                    var h = u.name;
                    if (h.kind === 79 && h.escapedText === t) return Xr(i, e.Diagnostics.A_type_predicate_cannot_reference_element_0_in_a_binding_pattern, t), true;
                    if ((h.kind === 202 || h.kind === 201) && e6(h, i, t)) return true;
                  }
                }
              }
              function Dv(r) {
                r.kind === 176 ? X9(r) : (r.kind === 179 || r.kind === 256 || r.kind === 180 || r.kind === 174 || r.kind === 171 || r.kind === 175) && X0(r);
                var i = e.getFunctionFlags(r);
                i & 4 || ((i & 3) === 3 && Ae < 99 && fc(r, 6144), (i & 3) === 2 && Ae < 4 && fc(r, 64), (i & 3) !== 0 && Ae < 2 && fc(r, 128)), jy(e.getEffectiveTypeParameterDeclarations(r)), sM(r), e.forEach(r.parameters, Zk), r.type && io(r.type), fe(t);
                function t() {
                  EF(r);
                  var o = e.getEffectiveReturnTypeNode(r);
                  if (n && !o) switch (r.kind) {
                    case 175:
                      Xr(r, e.Diagnostics.Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);
                      break;
                    case 174:
                      Xr(r, e.Diagnostics.Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);
                      break;
                  }
                  if (o) {
                    var s = e.getFunctionFlags(r);
                    if ((s & 5) === 1) {
                      var u = Va(o);
                      if (u === Fi) Xr(o, e.Diagnostics.A_generator_cannot_have_a_void_type_annotation);
                      else {
                        var h = Jg(0, u, (s & 2) !== 0) || Oe, z2 = Jg(1, u, (s & 2) !== 0) || h, me = Jg(2, u, (s & 2) !== 0) || gr, Me = Fk(h, z2, me, !!(s & 2));
                        zc(Me, u, o);
                      }
                    } else (s & 3) === 2 && cF(r, o);
                  }
                  r.kind !== 176 && r.kind !== 317 && A_(r);
                }
              }
              function MO(r) {
                for (var i = new e.Map(), t = new e.Map(), o = new e.Map(), s = 0, u = r.members; s < u.length; s++) {
                  var h = u[s];
                  if (h.kind === 171) for (var z2 = 0, me = h.parameters; z2 < me.length; z2++) {
                    var Me = me[z2];
                    e.isParameterPropertyDeclaration(Me, h) && !e.isBindingPattern(Me.name) && Ti(i, Me.name, Me.name.escapedText, 3);
                  }
                  else {
                    var $e = e.isStatic(h), tr = h.name;
                    if (!tr) continue;
                    var dr = e.isPrivateIdentifier(tr), Dr = dr && $e ? 16 : 0, Qr = dr ? o : $e ? t : i, li = tr && e.getPropertyNameForPropertyNameNode(tr);
                    if (li) switch (h.kind) {
                      case 172:
                        Ti(Qr, tr, li, 1 | Dr);
                        break;
                      case 173:
                        Ti(Qr, tr, li, 2 | Dr);
                        break;
                      case 167:
                        Ti(Qr, tr, li, 3 | Dr);
                        break;
                      case 169:
                        Ti(Qr, tr, li, 8 | Dr);
                        break;
                    }
                  }
                }
                function Ti(Ci, $i, Zi, qt) {
                  var Nt = Ci.get(Zi);
                  if (Nt) if ((Nt & 16) !== (qt & 16)) Xr($i, e.Diagnostics.Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name, e.getTextOfNode($i));
                  else {
                    var Ra = !!(Nt & 8), ca = !!(qt & 8);
                    Ra || ca ? Ra !== ca && Xr($i, e.Diagnostics.Duplicate_identifier_0, e.getTextOfNode($i)) : Nt & qt & -17 ? Xr($i, e.Diagnostics.Duplicate_identifier_0, e.getTextOfNode($i)) : Ci.set(Zi, Nt | qt);
                  }
                  else Ci.set(Zi, qt);
                }
              }
              function LO(r) {
                for (var i = 0, t = r.members; i < t.length; i++) {
                  var o = t[i], s = o.name, u = e.isStatic(o);
                  if (u && s) {
                    var h = e.getPropertyNameForPropertyNameNode(s);
                    switch (h) {
                      case "name":
                      case "length":
                      case "caller":
                      case "arguments":
                      case "prototype":
                        var z2 = e.Diagnostics.Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1, me = of(Et(r));
                        Xr(s, z2, h, me);
                        break;
                    }
                  }
                }
              }
              function r6(r) {
                for (var i = new e.Map(), t = 0, o = r.members; t < o.length; t++) {
                  var s = o[t];
                  if (s.kind === 166) {
                    var u = void 0, h = s.name;
                    switch (h.kind) {
                      case 10:
                      case 8:
                        u = h.text;
                        break;
                      case 79:
                        u = e.idText(h);
                        break;
                      default:
                        continue;
                    }
                    i.get(u) ? (Xr(e.getNameOfDeclaration(s.symbol.valueDeclaration), e.Diagnostics.Duplicate_identifier_0, u), Xr(s.name, e.Diagnostics.Duplicate_identifier_0, u)) : i.set(u, true);
                  }
                }
              }
              function dS(r) {
                if (r.kind === 258) {
                  var i = Et(r);
                  if (i.declarations && i.declarations.length > 0 && i.declarations[0] !== r) return;
                }
                var t = tx(Et(r));
                if (t != null && t.declarations) {
                  for (var o = new e.Map(), s = function(me) {
                    me.parameters.length === 1 && me.parameters[0].type && Od(Va(me.parameters[0].type), function(Me) {
                      var $e = o.get(fu(Me));
                      $e ? $e.declarations.push(me) : o.set(fu(Me), { type: Me, declarations: [me] });
                    });
                  }, u = 0, h = t.declarations; u < h.length; u++) {
                    var z2 = h[u];
                    s(z2);
                  }
                  o.forEach(function(me) {
                    if (me.declarations.length > 1) for (var Me = 0, $e = me.declarations; Me < $e.length; Me++) {
                      var tr = $e[Me];
                      Xr(tr, e.Diagnostics.Duplicate_index_signature_for_type_0, Ot(me.type));
                    }
                  });
                }
              }
              function i6(r) {
                !Ff(r) && !vL(r) && Q0(r.name), L0(r), gS(r), e.hasSyntacticModifier(r, 128) && r.kind === 167 && r.initializer && Xr(r, e.Diagnostics.Property_0_cannot_have_an_initializer_because_it_is_marked_abstract, e.declarationNameToString(r.name));
              }
              function RO(r) {
                return e.isPrivateIdentifier(r.name) && Xr(r, e.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies), i6(r);
              }
              function BO(r) {
                dA(r) || Q0(r.name), f6(r), e.hasSyntacticModifier(r, 128) && r.kind === 169 && r.body && Xr(r, e.Diagnostics.Method_0_cannot_have_an_implementation_because_it_is_marked_abstract, e.declarationNameToString(r.name)), e.isPrivateIdentifier(r.name) && !e.getContainingClass(r) && Xr(r, e.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies), gS(r);
              }
              function gS(r) {
                if (e.isPrivateIdentifier(r.name) && Ae < 99) {
                  for (var i = e.getEnclosingBlockScopeContainer(r); i; i = e.getEnclosingBlockScopeContainer(i)) va(i).flags |= 67108864;
                  if (e.isClassExpression(r.parent)) {
                    var t = hb(r.parent);
                    t && (va(r.name).flags |= 524288, va(t).flags |= 65536);
                  }
                }
              }
              function JO(r) {
                Ff(r), e.forEachChild(r, io);
              }
              function jO(r) {
                Dv(r), gL(r) || mL(r), io(r.body);
                var i = Et(r), t = e.getDeclarationOfKind(i, r.kind);
                if (r === t && O0(i), e.nodeIsMissing(r.body)) return;
                fe(s);
                return;
                function o(u) {
                  return e.isPrivateIdentifierClassElementDeclaration(u) ? true : u.kind === 167 && !e.isStatic(u) && !!u.initializer;
                }
                function s() {
                  var u = r.parent;
                  if (e.getClassExtendsHeritageElement(u)) {
                    Db(r.parent, u);
                    var h = yC(u), z2 = vC(r.body);
                    if (z2) {
                      h && Xr(z2, e.Diagnostics.A_constructor_cannot_contain_a_super_call_when_its_class_extends_null);
                      var me = (e.getEmitScriptTarget(ye) !== 99 || !ir) && (e.some(r.parent.members, o) || e.some(r.parameters, function(Dr) {
                        return e.hasSyntacticModifier(Dr, 16476);
                      }));
                      if (me) if (!UO(z2, r.body)) Xr(z2, e.Diagnostics.A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_initialized_properties_parameter_properties_or_private_identifiers);
                      else {
                        for (var Me = void 0, $e = 0, tr = r.body.statements; $e < tr.length; $e++) {
                          var dr = tr[$e];
                          if (e.isExpressionStatement(dr) && e.isSuperCall(e.skipOuterExpressions(dr.expression))) {
                            Me = dr;
                            break;
                          }
                          if (t6(dr)) break;
                        }
                        Me === void 0 && Xr(r, e.Diagnostics.A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_class_contains_initialized_properties_parameter_properties_or_private_identifiers);
                      }
                    } else h || Xr(r, e.Diagnostics.Constructors_for_derived_classes_must_contain_a_super_call);
                  }
                }
              }
              function UO(r, i) {
                var t = e.walkUpParenthesizedExpressions(r.parent);
                return e.isExpressionStatement(t) && t.parent === i;
              }
              function t6(r) {
                return r.kind === 106 || r.kind === 108 ? true : e.isThisContainerOrFunctionBlock(r) ? false : !!e.forEachChild(r, t6);
              }
              function a6(r) {
                fe(i), io(r.body), gS(r);
                function i() {
                  if (!X0(r) && !aL(r) && Q0(r.name), Fy(r), Dv(r), r.kind === 172 && !(r.flags & 16777216) && e.nodeIsPresent(r.body) && r.flags & 256 && (r.flags & 512 || Xr(r.name, e.Diagnostics.A_get_accessor_must_return_a_value)), r.name.kind === 162 && t_(r.name), Td(r)) {
                    var t = Et(r), o = e.getDeclarationOfKind(t, 172), s = e.getDeclarationOfKind(t, 173);
                    if (o && s && !(Ug(o) & 1)) {
                      va(o).flags |= 1;
                      var u = e.getEffectiveModifierFlags(o), h = e.getEffectiveModifierFlags(s);
                      (u & 128) !== (h & 128) && (Xr(o.name, e.Diagnostics.Accessors_must_both_be_abstract_or_non_abstract), Xr(s.name, e.Diagnostics.Accessors_must_both_be_abstract_or_non_abstract)), (u & 16 && !(h & 24) || u & 8 && !(h & 8)) && (Xr(o.name, e.Diagnostics.A_get_accessor_must_be_at_least_as_accessible_as_the_setter), Xr(s.name, e.Diagnostics.A_get_accessor_must_be_at_least_as_accessible_as_the_setter));
                      var z2 = Te(o), me = Te(s);
                      z2 && me && zc(z2, me, o, e.Diagnostics.The_return_type_of_a_get_accessor_must_be_assignable_to_its_set_accessor_type);
                    }
                  }
                  var Me = rt(Et(r));
                  r.kind === 172 && sS(r, Me);
                }
              }
              function zO(r) {
                Fy(r);
              }
              function P0(r, i) {
                return zp(e.map(r.typeArguments, Va), i, Ul(i), e.isInJSFile(r));
              }
              function n6(r, i) {
                for (var t, o, s = true, u = 0; u < i.length; u++) {
                  var h = Tc(i[u]);
                  h && (t || (t = P0(r, i), o = Uc(i, t)), s = s && zc(t[u], un(h, o), r.typeArguments[u], e.Diagnostics.Type_0_does_not_satisfy_the_constraint_1));
                }
                return s;
              }
              function mS(r) {
                var i = ty(r);
                if (!nn(i)) {
                  var t = va(r).resolvedSymbol;
                  if (t) return t.flags & 524288 && Aa(t).typeParameters || (e.getObjectFlags(i) & 4 ? i.target.localTypeParameters : void 0);
                }
              }
              function vS(r) {
                Wy(r, r.typeArguments), r.kind === 178 && r.typeName.jsdocDotPos !== void 0 && !e.isInJSFile(r) && !e.isInJSDoc(r) && rd(r, r.typeName.jsdocDotPos, 1, e.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments), e.forEach(r.typeArguments, io);
                var i = ty(r);
                if (!nn(i)) {
                  r.typeArguments && fe(function() {
                    var o = mS(r);
                    o && n6(r, o);
                  });
                  var t = va(r).resolvedSymbol;
                  t && (e.some(t.declarations, function(o) {
                    return zy(o) && !!(o.flags & 268435456);
                  }) && El(ky(r), t.declarations, t.escapedName), i.flags & 32 && t.flags & 8 && Xr(r, e.Diagnostics.Enum_type_0_has_members_with_initializers_that_are_not_literals, Ot(i)));
                }
              }
              function WO(r) {
                var i = e.tryCast(r.parent, e.isTypeReferenceType);
                if (!!i) {
                  var t = mS(i);
                  if (!!t) {
                    var o = Tc(t[i.typeArguments.indexOf(r)]);
                    return o && un(o, Uc(t, P0(i, t)));
                  }
                }
              }
              function qO(r) {
                yx(r);
              }
              function VO(r) {
                e.forEach(r.members, io), fe(i);
                function i() {
                  var t = tE(r);
                  J0(t, t.symbol), dS(r), r6(r);
                }
              }
              function KO(r) {
                io(r.elementType);
              }
              function GO(r) {
                for (var i = r.elements, t = false, o = false, s = e.some(i, e.isNamedTupleMember), u = 0, h = i; u < h.length; u++) {
                  var z2 = h[u];
                  if (z2.kind !== 197 && s) {
                    Tt(z2, e.Diagnostics.Tuple_members_must_all_have_names_or_all_not_have_names);
                    break;
                  }
                  var me = sD(z2);
                  if (me & 8) {
                    var Me = Va(z2.type);
                    if (!sp(Me)) {
                      Xr(z2, e.Diagnostics.A_rest_element_type_must_be_an_array_type);
                      break;
                    }
                    (Tu(Me) || Yn(Me) && Me.target.combinedFlags & 4) && (o = true);
                  } else if (me & 4) {
                    if (o) {
                      Tt(z2, e.Diagnostics.A_rest_element_cannot_follow_another_rest_element);
                      break;
                    }
                    o = true;
                  } else if (me & 2) {
                    if (o) {
                      Tt(z2, e.Diagnostics.An_optional_element_cannot_follow_a_rest_element);
                      break;
                    }
                    t = true;
                  } else if (t) {
                    Tt(z2, e.Diagnostics.A_required_element_cannot_follow_an_optional_element);
                    break;
                  }
                }
                e.forEach(r.elements, io), Va(r);
              }
              function HO(r) {
                e.forEach(r.types, io), Va(r);
              }
              function o6(r, i) {
                if (!(r.flags & 8388608)) return r;
                var t = r.objectType, o = r.indexType;
                if (ao(o, ql(t, false))) return i.kind === 207 && e.isAssignmentTarget(i) && e.getObjectFlags(t) & 32 && Lu(t) & 1 && Xr(i, e.Diagnostics.Index_signature_in_type_0_only_permits_reading, Ot(t)), r;
                var s = $s(t);
                if (ss(s, nt) && Ns(o, 296)) return r;
                if (Ad(t)) {
                  var u = gD(o, i);
                  if (u) {
                    var h = Od(s, function(z2) {
                      return bi(z2, u);
                    });
                    if (h && e.getDeclarationModifierFlagsFromSymbol(h) & 24) return Xr(i, e.Diagnostics.Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter, e.unescapeLeadingUnderscores(u)), Pe;
                  }
                }
                return Xr(i, e.Diagnostics.Type_0_cannot_be_used_to_index_type_1, Ot(o), Ot(t)), Pe;
              }
              function XO(r) {
                io(r.objectType), io(r.indexType), o6(Yx(r), r);
              }
              function QO(r) {
                YO(r), io(r.typeParameter), io(r.nameType), io(r.type), r.type || Xp(r, Oe);
                var i = yD(r), t = Jl(i);
                if (t) zc(t, at, r.nameType);
                else {
                  var o = Mu(i);
                  zc(o, at, e.getEffectiveConstraintOfTypeParameter(r.typeParameter));
                }
              }
              function YO(r) {
                var i;
                if (!((i = r.members) === null || i === void 0) && i.length) return Tt(r.members[0], e.Diagnostics.A_mapped_type_may_not_declare_properties_or_methods);
              }
              function $O(r) {
                Ch(r);
              }
              function ZO(r) {
                oL(r), io(r.type);
              }
              function eF(r) {
                e.forEachChild(r, io);
              }
              function rF(r) {
                e.findAncestor(r, function(Me) {
                  return Me.parent && Me.parent.kind === 189 && Me.parent.extendsType === Me;
                }) || Tt(r, e.Diagnostics.infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type), io(r.typeParameter);
                var i = Et(r.typeParameter);
                if (i.declarations && i.declarations.length > 1) {
                  var t = Aa(i);
                  if (!t.typeParametersChecked) {
                    t.typeParametersChecked = true;
                    var o = Js(i), s = e.getDeclarationsOfKind(i, 163);
                    if (!F6(s, [o], function(Me) {
                      return [Me];
                    })) for (var u = tn(i), h = 0, z2 = s; h < z2.length; h++) {
                      var me = z2[h];
                      Xr(me.name, e.Diagnostics.All_declarations_of_0_must_have_identical_constraints, u);
                    }
                  }
                }
                A_(r);
              }
              function iF(r) {
                for (var i = 0, t = r.templateSpans; i < t.length; i++) {
                  var o = t[i];
                  io(o.type);
                  var s = Va(o.type);
                  zc(s, ba, o.type);
                }
                Va(r);
              }
              function tF(r) {
                if (io(r.argument), r.assertions) {
                  var i = e.getResolutionModeOverrideForClause(r.assertions.assertClause, Tt);
                  i && e.getEmitModuleResolutionKind(ye) !== e.ModuleResolutionKind.Node16 && e.getEmitModuleResolutionKind(ye) !== e.ModuleResolutionKind.NodeNext && Tt(r.assertions.assertClause, e.Diagnostics.Resolution_modes_are_only_supported_when_moduleResolution_is_node16_or_nodenext);
                }
                Va(r);
              }
              function aF(r) {
                r.dotDotDotToken && r.questionToken && Tt(r, e.Diagnostics.A_tuple_member_cannot_be_both_optional_and_rest), r.type.kind === 185 && Tt(r.type, e.Diagnostics.A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type), r.type.kind === 186 && Tt(r.type, e.Diagnostics.A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type), io(r.type), Va(r);
              }
              function I0(r) {
                return (e.hasEffectiveModifier(r, 8) || e.isPrivateIdentifierClassElementDeclaration(r)) && !!(r.flags & 16777216);
              }
              function w0(r, i) {
                var t = e.getCombinedModifierFlags(r);
                return r.parent.kind !== 258 && r.parent.kind !== 257 && r.parent.kind !== 226 && r.flags & 16777216 && (!(t & 2) && !(e.isModuleBlock(r.parent) && e.isModuleDeclaration(r.parent.parent) && e.isGlobalScopeAugmentation(r.parent.parent)) && (t |= 1), t |= 2), t & i;
              }
              function O0(r) {
                fe(function() {
                  return nF(r);
                });
              }
              function nF(r) {
                function i(Qt, Ka) {
                  var cn = Ka !== void 0 && Ka.parent === Qt[0].parent;
                  return cn ? Ka : Qt[0];
                }
                function t(Qt, Ka, cn, Un, oa) {
                  var Mn = Un ^ oa;
                  if (Mn !== 0) {
                    var Ln = w0(i(Qt, Ka), cn);
                    e.forEach(Qt, function(ci) {
                      var Fr = w0(ci, cn) ^ Ln;
                      Fr & 1 ? Xr(e.getNameOfDeclaration(ci), e.Diagnostics.Overload_signatures_must_all_be_exported_or_non_exported) : Fr & 2 ? Xr(e.getNameOfDeclaration(ci), e.Diagnostics.Overload_signatures_must_all_be_ambient_or_non_ambient) : Fr & 24 ? Xr(e.getNameOfDeclaration(ci) || ci, e.Diagnostics.Overload_signatures_must_all_be_public_private_or_protected) : Fr & 128 && Xr(e.getNameOfDeclaration(ci), e.Diagnostics.Overload_signatures_must_all_be_abstract_or_non_abstract);
                    });
                  }
                }
                function o(Qt, Ka, cn, Un) {
                  if (cn !== Un) {
                    var oa = e.hasQuestionToken(i(Qt, Ka));
                    e.forEach(Qt, function(Mn) {
                      var Ln = e.hasQuestionToken(Mn) !== oa;
                      Ln && Xr(e.getNameOfDeclaration(Mn), e.Diagnostics.Overload_signatures_must_all_be_optional_or_required);
                    });
                  }
                }
                var s = 155, u = 0, h = s, z2 = false, me = true, Me = false, $e, tr, dr, Dr = r.declarations, Qr = (r.flags & 16384) !== 0;
                function li(Qt) {
                  if (!(Qt.name && e.nodeIsMissing(Qt.name))) {
                    var Ka = false, cn = e.forEachChild(Qt.parent, function(Fr) {
                      if (Ka) return Fr;
                      Ka = Fr === Qt;
                    });
                    if (cn && cn.pos === Qt.end && cn.kind === Qt.kind) {
                      var Un = cn.name || cn, oa = cn.name;
                      if (Qt.name && oa && (e.isPrivateIdentifier(Qt.name) && e.isPrivateIdentifier(oa) && Qt.name.escapedText === oa.escapedText || e.isComputedPropertyName(Qt.name) && e.isComputedPropertyName(oa) || e.isPropertyNameLiteral(Qt.name) && e.isPropertyNameLiteral(oa) && e.getEscapedTextOfIdentifierOrLiteral(Qt.name) === e.getEscapedTextOfIdentifierOrLiteral(oa))) {
                        var Mn = (Qt.kind === 169 || Qt.kind === 168) && e.isStatic(Qt) !== e.isStatic(cn);
                        if (Mn) {
                          var Ln = e.isStatic(Qt) ? e.Diagnostics.Function_overload_must_be_static : e.Diagnostics.Function_overload_must_not_be_static;
                          Xr(Un, Ln);
                        }
                        return;
                      }
                      if (e.nodeIsPresent(cn.body)) {
                        Xr(Un, e.Diagnostics.Function_implementation_name_must_be_0, e.declarationNameToString(Qt.name));
                        return;
                      }
                    }
                    var ci = Qt.name || Qt;
                    Qr ? Xr(ci, e.Diagnostics.Constructor_implementation_is_missing) : e.hasSyntacticModifier(Qt, 128) ? Xr(ci, e.Diagnostics.All_declarations_of_an_abstract_method_must_be_consecutive) : Xr(ci, e.Diagnostics.Function_implementation_is_missing_or_not_immediately_following_the_declaration);
                  }
                }
                var Ti = false, Ci = false, $i = false, Zi = [];
                if (Dr) for (var qt = 0, Nt = Dr; qt < Nt.length; qt++) {
                  var Ra = Nt[qt], ca = Ra, Sn = ca.flags & 16777216, ja = ca.parent && (ca.parent.kind === 258 || ca.parent.kind === 182) || Sn;
                  if (ja && (dr = void 0), (ca.kind === 257 || ca.kind === 226) && !Sn && ($i = true), ca.kind === 256 || ca.kind === 169 || ca.kind === 168 || ca.kind === 171) {
                    Zi.push(ca);
                    var Fn = w0(ca, s);
                    u |= Fn, h &= Fn, z2 = z2 || e.hasQuestionToken(ca), me = me && e.hasQuestionToken(ca);
                    var wn = e.nodeIsPresent(ca.body);
                    wn && $e ? Qr ? Ci = true : Ti = true : (dr == null ? void 0 : dr.parent) === ca.parent && dr.end !== ca.pos && li(dr), wn ? $e || ($e = ca) : Me = true, dr = ca, ja || (tr = ca);
                  }
                }
                if (Ci && e.forEach(Zi, function(Qt) {
                  Xr(Qt, e.Diagnostics.Multiple_constructor_implementations_are_not_allowed);
                }), Ti && e.forEach(Zi, function(Qt) {
                  Xr(e.getNameOfDeclaration(Qt) || Qt, e.Diagnostics.Duplicate_function_implementation);
                }), $i && !Qr && r.flags & 16 && Dr) {
                  var Tn = e.filter(Dr, function(Qt) {
                    return Qt.kind === 257;
                  }).map(function(Qt) {
                    return e.createDiagnosticForNode(Qt, e.Diagnostics.Consider_adding_a_declare_modifier_to_this_class);
                  });
                  e.forEach(Dr, function(Qt) {
                    var Ka = Qt.kind === 257 ? e.Diagnostics.Class_declaration_cannot_implement_overload_list_for_0 : Qt.kind === 256 ? e.Diagnostics.Function_with_bodies_can_only_merge_with_classes_that_are_ambient : void 0;
                    Ka && e.addRelatedInfo.apply(void 0, Ve([Xr(e.getNameOfDeclaration(Qt) || Qt, Ka, e.symbolName(r))], Tn, false));
                  });
                }
                if (tr && !tr.body && !e.hasSyntacticModifier(tr, 128) && !tr.questionToken && li(tr), Me && (Dr && (t(Dr, $e, s, u, h), o(Dr, $e, z2, me)), $e)) for (var Eo = S_(r), lt = yl($e), it = 0, Yt = Eo; it < Yt.length; it++) {
                  var Ia = Yt[it];
                  if (!uw(lt, Ia)) {
                    e.addRelatedInfo(Xr(Ia.declaration, e.Diagnostics.This_overload_signature_is_not_compatible_with_its_implementation_signature), e.createDiagnosticForNode($e, e.Diagnostics.The_implementation_signature_is_declared_here));
                    break;
                  }
                }
              }
              function bv(r) {
                fe(function() {
                  return oF(r);
                });
              }
              function oF(r) {
                var i = r.localSymbol;
                if (!i && (i = Et(r), !i.exportSymbol) || e.getDeclarationOfKind(i, r.kind) !== r) return;
                for (var t = 0, o = 0, s = 0, u = 0, h = i.declarations; u < h.length; u++) {
                  var z2 = h[u], me = Ti(z2), Me = w0(z2, 513);
                  Me & 1 ? Me & 512 ? s |= me : t |= me : o |= me;
                }
                var $e = t | o, tr = t & o, dr = s & $e;
                if (tr || dr) for (var Dr = 0, Qr = i.declarations; Dr < Qr.length; Dr++) {
                  var z2 = Qr[Dr], me = Ti(z2), li = e.getNameOfDeclaration(z2);
                  me & dr ? Xr(li, e.Diagnostics.Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead, e.declarationNameToString(li)) : me & tr && Xr(li, e.Diagnostics.Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local, e.declarationNameToString(li));
                }
                function Ti(Ci) {
                  var $i = Ci;
                  switch ($i.kind) {
                    case 258:
                    case 259:
                    case 345:
                    case 338:
                    case 339:
                      return 2;
                    case 261:
                      return e.isAmbientModule($i) || e.getModuleInstanceState($i) !== 0 ? 5 : 4;
                    case 257:
                    case 260:
                    case 299:
                      return 3;
                    case 305:
                      return 7;
                    case 271:
                    case 221:
                      var Zi = $i, qt = e.isExportAssignment(Zi) ? Zi.expression : Zi.right;
                      if (!e.isEntityNameExpression(qt)) return 1;
                      $i = qt;
                    case 265:
                    case 268:
                    case 267:
                      var Nt = 0, Ra = Ps(Et($i));
                      return e.forEach(Ra.declarations, function(ca) {
                        Nt |= Ti(ca);
                      }), Nt;
                    case 254:
                    case 203:
                    case 256:
                    case 270:
                    case 79:
                      return 1;
                    default:
                      return e.Debug.failBadSyntaxKind($i);
                  }
                }
              }
              function Sv(r, i, t, o) {
                var s = Tv(r, i);
                return s && ag(s, i, t, o);
              }
              function Tv(r, i) {
                if (!ta(r)) {
                  var t = r;
                  if (t.promisedTypeOfPromise) return t.promisedTypeOfPromise;
                  if (Xf(r, ay(false))) return t.promisedTypeOfPromise = xo(r)[0];
                  if (!Lg(r, 262140)) {
                    var o = da(r, "then");
                    if (!ta(o)) {
                      var s = o ? ot(o, 0) : e.emptyArray;
                      if (s.length === 0) {
                        i && Xr(i, e.Diagnostics.A_promise_must_have_a_then_method);
                        return;
                      }
                      var u = Ks(Pa(e.map(s, aS)), 2097152);
                      if (!ta(u)) {
                        var h = ot(u, 0);
                        if (h.length === 0) {
                          i && Xr(i, e.Diagnostics.The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback);
                          return;
                        }
                        return t.promisedTypeOfPromise = Pa(e.map(h, aS), 2);
                      }
                    }
                  }
                }
              }
              function xv(r, i, t, o, s) {
                var u = i ? ag(r, t, o, s) : k_(r, t, o, s);
                return u || Pe;
              }
              function s6(r) {
                if (Lg(r, 262140)) return false;
                var i = da(r, "then");
                return !!i && ot(Ks(i, 2097152), 0).length > 0;
              }
              function yS(r) {
                var i;
                if (r.flags & 16777216) {
                  var t = oD(false);
                  return !!t && r.aliasSymbol === t && ((i = r.aliasTypeArguments) === null || i === void 0 ? void 0 : i.length) === 1;
                }
                return false;
              }
              function Ev(r) {
                return r.flags & 1048576 ? Ss(r, Ev) : yS(r) ? r.aliasTypeArguments[0] : r;
              }
              function sF(r) {
                if (ta(r) || yS(r)) return r;
                if (Ad(r)) {
                  var i = uc(r);
                  if (!i || i.flags & 3 || Of(i) || s6(i)) {
                    var t = oD(true);
                    if (t) return am(t, [Ev(r)]);
                  }
                }
                return e.Debug.assert(Tv(r) === void 0, "type provided should not be a non-generic 'promise'-like."), r;
              }
              function ag(r, i, t, o) {
                var s = k_(r, i, t, o);
                return s && sF(s);
              }
              function k_(r, i, t, o) {
                if (ta(r) || yS(r)) return r;
                var s = r;
                if (s.awaitedTypeOfType) return s.awaitedTypeOfType;
                if (r.flags & 1048576) {
                  var u = i ? function(me) {
                    return k_(me, i, t, o);
                  } : k_;
                  return s.awaitedTypeOfType = Ss(r, u);
                }
                var h = Tv(r);
                if (h) {
                  if (r.id === h.id || qa.lastIndexOf(h.id) >= 0) {
                    i && Xr(i, e.Diagnostics.Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method);
                    return;
                  }
                  qa.push(r.id);
                  var z2 = k_(h, i, t, o);
                  return qa.pop(), z2 ? s.awaitedTypeOfType = z2 : void 0;
                }
                if (s6(r)) {
                  i && (e.Debug.assertIsDefined(t), Xr(i, t, o));
                  return;
                }
                return s.awaitedTypeOfType = r;
              }
              function cF(r, i) {
                var t = Va(i);
                if (Ae >= 2) {
                  if (nn(t)) return;
                  var o = ay(true);
                  if (o !== kn && !Xf(t, o)) {
                    Xr(i, e.Diagnostics.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0, Ot(k_(t) || Fi));
                    return;
                  }
                } else {
                  if (lF(i), nn(t)) return;
                  var s = e.getEntityNameFromTypeNode(i);
                  if (s === void 0) {
                    Xr(i, e.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, Ot(t));
                    return;
                  }
                  var u = Ds(s, 111551, true), h = u ? Jt(u) : Pe;
                  if (nn(h)) {
                    s.kind === 79 && s.escapedText === "Promise" && bd(t) === ay(false) ? Xr(i, e.Diagnostics.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option) : Xr(i, e.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, e.entityNameToString(s));
                    return;
                  }
                  var z2 = E3(true);
                  if (z2 === Ba) {
                    Xr(i, e.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, e.entityNameToString(s));
                    return;
                  }
                  if (!zc(h, z2, i, e.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value)) return;
                  var me = s && e.getFirstIdentifier(s), Me = qs(r.locals, me.escapedText, 111551);
                  if (Me) {
                    Xr(Me.valueDeclaration, e.Diagnostics.Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions, e.idText(me), e.entityNameToString(s));
                    return;
                  }
                }
                xv(t, false, r, e.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
              }
              function uF(r) {
                var i = Mg(r);
                x0(i, r);
                var t = yo(i);
                if (!(t.flags & 1)) {
                  var o, s;
                  switch (r.parent.kind) {
                    case 257:
                      o = e.Diagnostics.Decorator_function_return_type_0_is_not_assignable_to_type_1;
                      var u = Et(r.parent), h = Jt(u);
                      s = Pa([h, Fi]);
                      break;
                    case 167:
                    case 164:
                      o = e.Diagnostics.Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any, s = Fi;
                      break;
                    case 169:
                    case 172:
                    case 173:
                      o = e.Diagnostics.Decorator_function_return_type_0_is_not_assignable_to_type_1;
                      var z2 = Bd(r.parent), me = Px(z2);
                      s = Pa([me, Fi]);
                      break;
                    default:
                      return e.Debug.fail();
                  }
                  zc(t, s, r, o);
                }
              }
              function lF(r) {
                c6(r && e.getEntityNameFromTypeNode(r), false);
              }
              function c6(r, i) {
                if (!!r) {
                  var t = e.getFirstIdentifier(r), o = (r.kind === 79 ? 788968 : 1920) | 2097152, s = es(t, t.escapedText, o, void 0, void 0, true);
                  if (s && s.flags & 2097152) {
                    if (gc(s) && !Av(Ps(s)) && !vu(s)) As(s);
                    else if (i && ye.isolatedModules && e.getEmitModuleKind(ye) >= e.ModuleKind.ES2015 && !gc(s) && !e.some(s.declarations, e.isTypeOnlyImportOrExportDeclaration)) {
                      var u = Xr(r, e.Diagnostics.A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled), h = e.find(s.declarations || e.emptyArray, yf);
                      h && e.addRelatedInfo(u, e.createDiagnosticForNode(h, e.Diagnostics._0_was_imported_here, e.idText(t)));
                    }
                  }
                }
              }
              function bm(r) {
                var i = hS(r);
                i && e.isEntityName(i) && c6(i, true);
              }
              function hS(r) {
                if (r) switch (r.kind) {
                  case 188:
                  case 187:
                    return u6(r.types);
                  case 189:
                    return u6([r.trueType, r.falseType]);
                  case 191:
                  case 197:
                    return hS(r.type);
                  case 178:
                    return r.typeName;
                }
              }
              function u6(r) {
                for (var i, t = 0, o = r; t < o.length; t++) {
                  for (var s = o[t]; s.kind === 191 || s.kind === 197; ) s = s.type;
                  if (s.kind !== 143 && !(!Ye && (s.kind === 196 && s.literal.kind === 104 || s.kind === 153))) {
                    var u = hS(s);
                    if (!u) return;
                    if (i) {
                      if (!e.isIdentifier(i) || !e.isIdentifier(u) || i.escapedText !== u.escapedText) return;
                    } else i = u;
                  }
                }
                return i;
              }
              function F0(r) {
                var i = e.getEffectiveTypeAnnotationNode(r);
                return e.isRestParameter(r) ? e.getRestParameterElementType(i) : i;
              }
              function Fy(r) {
                if (!!r.decorators && !!e.nodeCanBeDecorated(r, r.parent, r.parent.parent)) {
                  ye.experimentalDecorators || Xr(r, e.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning);
                  var i = r.decorators[0];
                  if (fc(i, 8), r.kind === 164 && fc(i, 32), ye.emitDecoratorMetadata) switch (fc(i, 16), r.kind) {
                    case 257:
                      var t = e.getFirstConstructorWithBody(r);
                      if (t) for (var o = 0, s = t.parameters; o < s.length; o++) {
                        var u = s[o];
                        bm(F0(u));
                      }
                      break;
                    case 172:
                    case 173:
                      var h = r.kind === 172 ? 173 : 172, z2 = e.getDeclarationOfKind(Et(r), h);
                      bm(W(r) || z2 && W(z2));
                      break;
                    case 169:
                      for (var me = 0, Me = r.parameters; me < Me.length; me++) {
                        var u = Me[me];
                        bm(F0(u));
                      }
                      bm(e.getEffectiveReturnTypeNode(r));
                      break;
                    case 167:
                      bm(e.getEffectiveTypeAnnotationNode(r));
                      break;
                    case 164:
                      bm(F0(r));
                      for (var $e = r.parent, tr = 0, dr = $e.parameters; tr < dr.length; tr++) {
                        var u = dr[tr];
                        bm(F0(u));
                      }
                      break;
                  }
                  e.forEach(r.decorators, uF);
                }
              }
              function fF(r) {
                fe(i);
                function i() {
                  f6(r), WS(r), Sm(r, r.name);
                }
              }
              function _F(r) {
                r.typeExpression || Xr(r.name, e.Diagnostics.JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags), r.name && Tm(r.name, e.Diagnostics.Type_alias_name_cannot_be_0), io(r.typeExpression), jy(e.getEffectiveTypeParameterDeclarations(r));
              }
              function pF(r) {
                io(r.constraint);
                for (var i = 0, t = r.typeParameters; i < t.length; i++) {
                  var o = t[i];
                  io(o);
                }
              }
              function dF(r) {
                io(r.typeExpression);
              }
              function gF(r) {
                io(r.typeExpression);
              }
              function mF(r) {
                io(r.typeExpression);
              }
              function vF(r) {
                fe(i), Dv(r);
                function i() {
                  !r.type && !e.isJSDocConstructSignature(r) && Xp(r, Oe);
                }
              }
              function yF(r) {
                var i = e.getEffectiveJSDocHost(r);
                (!i || !e.isClassDeclaration(i) && !e.isClassExpression(i)) && Xr(i, e.Diagnostics.JSDoc_0_is_not_attached_to_a_class, e.idText(r.tagName));
              }
              function hF(r) {
                var i = e.getEffectiveJSDocHost(r);
                if (!i || !e.isClassDeclaration(i) && !e.isClassExpression(i)) {
                  Xr(i, e.Diagnostics.JSDoc_0_is_not_attached_to_a_class, e.idText(r.tagName));
                  return;
                }
                var t = e.getJSDocTags(i).filter(e.isJSDocAugmentsTag);
                e.Debug.assert(t.length > 0), t.length > 1 && Xr(t[1], e.Diagnostics.Class_declarations_cannot_have_more_than_one_augments_or_extends_tag);
                var o = l6(r.class.expression), s = e.getClassExtendsHeritageElement(i);
                if (s) {
                  var u = l6(s.expression);
                  u && o.escapedText !== u.escapedText && Xr(o, e.Diagnostics.JSDoc_0_1_does_not_match_the_extends_2_clause, e.idText(r.tagName), e.idText(o), e.idText(u));
                }
              }
              function DF(r) {
                var i = e.getJSDocHost(r);
                i && e.isPrivateIdentifierClassElementDeclaration(i) && Xr(r, e.Diagnostics.An_accessibility_modifier_cannot_be_used_with_a_private_identifier);
              }
              function l6(r) {
                switch (r.kind) {
                  case 79:
                    return r;
                  case 206:
                    return r.name;
                  default:
                    return;
                }
              }
              function f6(r) {
                var i;
                Fy(r), Dv(r);
                var t = e.getFunctionFlags(r);
                if (r.name && r.name.kind === 162 && t_(r.name), Td(r)) {
                  var o = Et(r), s = r.localSymbol || o, u = (i = s.declarations) === null || i === void 0 ? void 0 : i.find(function(Me) {
                    return Me.kind === r.kind && !(Me.flags & 262144);
                  });
                  r === u && O0(s), o.parent && O0(o);
                }
                var h = r.kind === 168 ? void 0 : r.body;
                if (io(h), sS(r, yg(r)), fe(me), e.isInJSFile(r)) {
                  var z2 = e.getJSDocTypeTag(r);
                  z2 && z2.typeExpression && !Nb(Va(z2.typeExpression), r) && Xr(z2.typeExpression.type, e.Diagnostics.The_type_of_a_function_declaration_must_match_the_function_s_signature);
                }
                function me() {
                  e.getEffectiveReturnTypeNode(r) || (e.nodeIsMissing(h) && !I0(r) && Xp(r, Oe), t & 1 && e.nodeIsPresent(h) && yo(yl(r)));
                }
              }
              function A_(r) {
                fe(i);
                function i() {
                  var t = e.getSourceFileOfNode(r), o = Fo.get(t.path);
                  o || (o = [], Fo.set(t.path, o)), o.push(r);
                }
              }
              function _6(r, i) {
                for (var t = 0, o = r; t < o.length; t++) {
                  var s = o[t];
                  switch (s.kind) {
                    case 257:
                    case 226:
                      bF(s, i), DS(s, i);
                      break;
                    case 305:
                    case 261:
                    case 235:
                    case 263:
                    case 242:
                    case 243:
                    case 244:
                      g6(s, i);
                      break;
                    case 171:
                    case 213:
                    case 256:
                    case 214:
                    case 169:
                    case 172:
                    case 173:
                      s.body && g6(s, i), DS(s, i);
                      break;
                    case 168:
                    case 174:
                    case 175:
                    case 179:
                    case 180:
                    case 259:
                    case 258:
                      DS(s, i);
                      break;
                    case 190:
                      SF(s, i);
                      break;
                    default:
                      e.Debug.assertNever(s, "Node should not have been registered for unused identifiers check");
                  }
                }
              }
              function p6(r, i, t) {
                var o = e.getNameOfDeclaration(r) || r, s = zy(r) ? e.Diagnostics._0_is_declared_but_never_used : e.Diagnostics._0_is_declared_but_its_value_is_never_read;
                t(r, 0, e.createDiagnosticForNode(o, s, i));
              }
              function My(r) {
                return e.isIdentifier(r) && e.idText(r).charCodeAt(0) === 95;
              }
              function bF(r, i) {
                for (var t = 0, o = r.members; t < o.length; t++) {
                  var s = o[t];
                  switch (s.kind) {
                    case 169:
                    case 167:
                    case 172:
                    case 173:
                      if (s.kind === 173 && s.symbol.flags & 32768) break;
                      var u = Et(s);
                      !u.isReferenced && (e.hasEffectiveModifier(s, 8) || e.isNamedDeclaration(s) && e.isPrivateIdentifier(s.name)) && !(s.flags & 16777216) && i(s, 0, e.createDiagnosticForNode(s.name, e.Diagnostics._0_is_declared_but_its_value_is_never_read, tn(u)));
                      break;
                    case 171:
                      for (var h = 0, z2 = s.parameters; h < z2.length; h++) {
                        var me = z2[h];
                        !me.symbol.isReferenced && e.hasSyntacticModifier(me, 8) && i(me, 0, e.createDiagnosticForNode(me.name, e.Diagnostics.Property_0_is_declared_but_its_value_is_never_read, e.symbolName(me.symbol)));
                      }
                      break;
                    case 176:
                    case 234:
                    case 170:
                      break;
                    default:
                      e.Debug.fail("Unexpected class member");
                  }
                }
              }
              function SF(r, i) {
                var t = r.typeParameter;
                bS(t) && i(r, 1, e.createDiagnosticForNode(r, e.Diagnostics._0_is_declared_but_its_value_is_never_read, e.idText(t.name)));
              }
              function DS(r, i) {
                var t = Et(r).declarations;
                if (!(!t || e.last(t) !== r)) for (var o = e.getEffectiveTypeParameterDeclarations(r), s = new e.Set(), u = 0, h = o; u < h.length; u++) {
                  var z2 = h[u];
                  if (!!bS(z2)) {
                    var me = e.idText(z2.name), Me = z2.parent;
                    if (Me.kind !== 190 && Me.typeParameters.every(bS)) {
                      if (e.tryAddToSet(s, Me)) {
                        var $e = e.getSourceFileOfNode(Me), tr = e.isJSDocTemplateTag(Me) ? e.rangeOfNode(Me) : e.rangeOfTypeParameters($e, Me.typeParameters), dr = Me.typeParameters.length === 1, Dr = dr ? e.Diagnostics._0_is_declared_but_its_value_is_never_read : e.Diagnostics.All_type_parameters_are_unused, Qr = dr ? me : void 0;
                        i(z2, 1, e.createFileDiagnostic($e, tr.pos, tr.end - tr.pos, Dr, Qr));
                      }
                    } else i(z2, 1, e.createDiagnosticForNode(z2, e.Diagnostics._0_is_declared_but_its_value_is_never_read, me));
                  }
                }
              }
              function bS(r) {
                return !(so(r.symbol).isReferenced & 262144) && !My(r.name);
              }
              function Ly(r, i, t, o) {
                var s = String(o(i)), u = r.get(s);
                u ? u[1].push(t) : r.set(s, [i, [t]]);
              }
              function d6(r) {
                return e.tryCast(e.getRootDeclaration(r), e.isParameter);
              }
              function TF(r) {
                return e.isBindingElement(r) ? e.isObjectBindingPattern(r.parent) ? !!(r.propertyName && My(r.name)) : My(r.name) : e.isAmbientModule(r) || (e.isVariableDeclaration(r) && e.isForInOrOfStatement(r.parent.parent) || m6(r)) && My(r.name);
              }
              function g6(r, i) {
                var t = new e.Map(), o = new e.Map(), s = new e.Map();
                r.locals.forEach(function(u) {
                  if (!(u.flags & 262144 ? !(u.flags & 3 && !(u.isReferenced & 3)) : u.isReferenced || u.exportSymbol) && u.declarations) for (var h = 0, z2 = u.declarations; h < z2.length; h++) {
                    var me = z2[h];
                    if (!TF(me)) if (m6(me)) Ly(t, xF(me), me, A);
                    else if (e.isBindingElement(me) && e.isObjectBindingPattern(me.parent)) {
                      var Me = e.last(me.parent.elements);
                      (me === Me || !e.last(me.parent.elements).dotDotDotToken) && Ly(o, me.parent, me, A);
                    } else if (e.isVariableDeclaration(me)) Ly(s, me.parent, me, A);
                    else {
                      var $e = u.valueDeclaration && d6(u.valueDeclaration), tr = u.valueDeclaration && e.getNameOfDeclaration(u.valueDeclaration);
                      $e && tr ? !e.isParameterPropertyDeclaration($e, $e.parent) && !e.parameterIsThisKeyword($e) && !My(tr) && (e.isBindingElement(me) && e.isArrayBindingPattern(me.parent) ? Ly(o, me.parent, me, A) : i($e, 1, e.createDiagnosticForNode(tr, e.Diagnostics._0_is_declared_but_its_value_is_never_read, e.symbolName(u)))) : p6(me, e.symbolName(u), i);
                    }
                  }
                }), t.forEach(function(u) {
                  var h = u[0], z2 = u[1], me = h.parent, Me = (h.name ? 1 : 0) + (h.namedBindings ? h.namedBindings.kind === 268 ? 1 : h.namedBindings.elements.length : 0);
                  if (Me === z2.length) i(me, 0, z2.length === 1 ? e.createDiagnosticForNode(me, e.Diagnostics._0_is_declared_but_its_value_is_never_read, e.idText(e.first(z2).name)) : e.createDiagnosticForNode(me, e.Diagnostics.All_imports_in_import_declaration_are_unused));
                  else for (var $e = 0, tr = z2; $e < tr.length; $e++) {
                    var dr = tr[$e];
                    p6(dr, e.idText(dr.name), i);
                  }
                }), o.forEach(function(u) {
                  var h = u[0], z2 = u[1], me = d6(h.parent) ? 1 : 0;
                  if (h.elements.length === z2.length) z2.length === 1 && h.parent.kind === 254 && h.parent.parent.kind === 255 ? Ly(s, h.parent.parent, h.parent, A) : i(h, me, z2.length === 1 ? e.createDiagnosticForNode(h, e.Diagnostics._0_is_declared_but_its_value_is_never_read, Ry(e.first(z2).name)) : e.createDiagnosticForNode(h, e.Diagnostics.All_destructured_elements_are_unused));
                  else for (var Me = 0, $e = z2; Me < $e.length; Me++) {
                    var tr = $e[Me];
                    i(tr, me, e.createDiagnosticForNode(tr, e.Diagnostics._0_is_declared_but_its_value_is_never_read, Ry(tr.name)));
                  }
                }), s.forEach(function(u) {
                  var h = u[0], z2 = u[1];
                  if (h.declarations.length === z2.length) i(h, 0, z2.length === 1 ? e.createDiagnosticForNode(e.first(z2).name, e.Diagnostics._0_is_declared_but_its_value_is_never_read, Ry(e.first(z2).name)) : e.createDiagnosticForNode(h.parent.kind === 237 ? h.parent : h, e.Diagnostics.All_variables_are_unused));
                  else for (var me = 0, Me = z2; me < Me.length; me++) {
                    var $e = Me[me];
                    i($e, 0, e.createDiagnosticForNode($e, e.Diagnostics._0_is_declared_but_its_value_is_never_read, Ry($e.name)));
                  }
                });
              }
              function Ry(r) {
                switch (r.kind) {
                  case 79:
                    return e.idText(r);
                  case 202:
                  case 201:
                    return Ry(e.cast(e.first(r.elements), e.isBindingElement).name);
                  default:
                    return e.Debug.assertNever(r);
                }
              }
              function m6(r) {
                return r.kind === 267 || r.kind === 270 || r.kind === 268;
              }
              function xF(r) {
                return r.kind === 267 ? r : r.kind === 268 ? r.parent : r.parent.parent;
              }
              function M0(r) {
                if (r.kind === 235 && Mf(r), e.isFunctionOrModuleBlock(r)) {
                  var i = Bs;
                  e.forEach(r.statements, io), Bs = i;
                } else e.forEach(r.statements, io);
                r.locals && A_(r);
              }
              function EF(r) {
                Ae >= 2 || !e.hasRestParameter(r) || r.flags & 16777216 || e.nodeIsMissing(r.body) || e.forEach(r.parameters, function(i) {
                  i.name && !e.isBindingPattern(i.name) && i.name.escapedText === or.escapedName && Es("noEmit", i, e.Diagnostics.Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters);
                });
              }
              function Cv(r, i, t) {
                if ((i == null ? void 0 : i.escapedText) !== t || r.kind === 167 || r.kind === 166 || r.kind === 169 || r.kind === 168 || r.kind === 172 || r.kind === 173 || r.kind === 296 || r.flags & 16777216 || (e.isImportClause(r) || e.isImportEqualsDeclaration(r) || e.isImportSpecifier(r)) && e.isTypeOnlyImportOrExportDeclaration(r)) return false;
                var o = e.getRootDeclaration(r);
                return !(e.isParameter(o) && e.nodeIsMissing(o.parent.body));
              }
              function CF(r) {
                e.findAncestor(r, function(i) {
                  if (Ug(i) & 4) {
                    var t = r.kind !== 79;
                    return t ? Xr(e.getNameOfDeclaration(r), e.Diagnostics.Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference) : Xr(r, e.Diagnostics.Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference), true;
                  }
                  return false;
                });
              }
              function kF(r) {
                e.findAncestor(r, function(i) {
                  if (Ug(i) & 8) {
                    var t = r.kind !== 79;
                    return t ? Xr(e.getNameOfDeclaration(r), e.Diagnostics.Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference) : Xr(r, e.Diagnostics.Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference), true;
                  }
                  return false;
                });
              }
              function AF(r, i) {
                if (!(er >= e.ModuleKind.ES2015 && !(er >= e.ModuleKind.Node16 && e.getSourceFileOfNode(r).impliedNodeFormat === e.ModuleKind.CommonJS)) && !(!i || !Cv(r, i, "require") && !Cv(r, i, "exports")) && !(e.isModuleDeclaration(r) && e.getModuleInstanceState(r) !== 1)) {
                  var t = zi(r);
                  t.kind === 305 && e.isExternalOrCommonJsModule(t) && Es("noEmit", i, e.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module, e.declarationNameToString(i), e.declarationNameToString(i));
                }
              }
              function NF(r, i) {
                if (!(!i || Ae >= 4 || !Cv(r, i, "Promise")) && !(e.isModuleDeclaration(r) && e.getModuleInstanceState(r) !== 1)) {
                  var t = zi(r);
                  t.kind === 305 && e.isExternalOrCommonJsModule(t) && t.flags & 2048 && Es("noEmit", i, e.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions, e.declarationNameToString(i), e.declarationNameToString(i));
                }
              }
              function PF(r, i) {
                Ae <= 8 && (Cv(r, i, "WeakMap") || Cv(r, i, "WeakSet")) && bn.push(r);
              }
              function IF(r) {
                var i = e.getEnclosingBlockScopeContainer(r);
                Ug(i) & 67108864 && (e.Debug.assert(e.isNamedDeclaration(r) && e.isIdentifier(r.name) && typeof r.name.escapedText == "string", "The target of a WeakMap/WeakSet collision check should be an identifier"), Es("noEmit", r, e.Diagnostics.Compiler_reserves_name_0_when_emitting_private_identifier_downlevel, r.name.escapedText));
              }
              function wF(r, i) {
                i && Ae >= 2 && Ae <= 8 && Cv(r, i, "Reflect") && _a.push(r);
              }
              function OF(r) {
                var i = false;
                if (e.isClassExpression(r)) for (var t = 0, o = r.members; t < o.length; t++) {
                  var s = o[t];
                  if (Ug(s) & 134217728) {
                    i = true;
                    break;
                  }
                }
                else if (e.isFunctionExpression(r)) Ug(r) & 134217728 && (i = true);
                else {
                  var u = e.getEnclosingBlockScopeContainer(r);
                  u && Ug(u) & 134217728 && (i = true);
                }
                i && (e.Debug.assert(e.isNamedDeclaration(r) && e.isIdentifier(r.name), "The target of a Reflect collision check should be an identifier"), Es("noEmit", r, e.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializers, e.declarationNameToString(r.name), "Reflect"));
              }
              function Sm(r, i) {
                !i || (AF(r, i), NF(r, i), PF(r, i), wF(r, i), e.isClassLike(r) ? (Tm(i, e.Diagnostics.Class_name_cannot_be_0), r.flags & 16777216 || oM(i)) : e.isEnumDeclaration(r) && Tm(i, e.Diagnostics.Enum_name_cannot_be_0));
              }
              function FF(r) {
                if (!((e.getCombinedNodeFlags(r) & 3) !== 0 || e.isParameterDeclaration(r)) && !(r.kind === 254 && !r.initializer)) {
                  var i = Et(r);
                  if (i.flags & 1) {
                    if (!e.isIdentifier(r.name)) return e.Debug.fail();
                    var t = es(r, r.name.escapedText, 3, void 0, void 0, false);
                    if (t && t !== i && t.flags & 2 && p0(t) & 3) {
                      var o = e.getAncestor(t.valueDeclaration, 255), s = o.parent.kind === 237 && o.parent.parent ? o.parent.parent : void 0, u = s && (s.kind === 235 && e.isFunctionLike(s.parent) || s.kind === 262 || s.kind === 261 || s.kind === 305);
                      if (!u) {
                        var h = tn(t);
                        Xr(r, e.Diagnostics.Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1, h, h);
                      }
                    }
                  }
                }
              }
              function kv(r) {
                return r === nr ? Oe : r === So ? mo : r;
              }
              function L0(r) {
                var i;
                if (Fy(r), e.isBindingElement(r) || io(r.type), !!r.name) {
                  if (r.name.kind === 162 && (t_(r.name), r.initializer && Os(r.initializer)), e.isBindingElement(r)) {
                    e.isObjectBindingPattern(r.parent) && r.dotDotDotToken && Ae < 5 && fc(r, 4), r.propertyName && r.propertyName.kind === 162 && t_(r.propertyName);
                    var t = r.parent.parent, o = r.dotDotDotToken ? 64 : 0, s = Wo(t, o), u = r.propertyName || r.name;
                    if (s && !e.isBindingPattern(u)) {
                      var h = Z_(u);
                      if (_f(h)) {
                        var z2 = pf(h), me = bi(s, z2);
                        me && (xy(me, void 0, false), Jb(r, !!t.initializer && t.initializer.kind === 106, false, s, me));
                      }
                    }
                  }
                  if (e.isBindingPattern(r.name) && (r.name.kind === 202 && Ae < 2 && ye.downlevelIteration && fc(r, 512), e.forEach(r.name.elements, io)), r.initializer && e.isParameterDeclaration(r) && e.nodeIsMissing(e.getContainingFunction(r).body)) {
                    Xr(r, e.Diagnostics.A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation);
                    return;
                  }
                  if (e.isBindingPattern(r.name)) {
                    var Me = r.initializer && r.parent.parent.kind !== 243, $e = r.name.elements.length === 0;
                    if (Me || $e) {
                      var tr = sc(r);
                      if (Me) {
                        var dr = Os(r.initializer);
                        Ye && $e ? qC(dr, r) : op(dr, sc(r), r, r.initializer);
                      }
                      $e && (e.isArrayBindingPattern(r.name) ? N_(65, tr, Tr, r) : Ye && qC(tr, r));
                    }
                    return;
                  }
                  var Dr = Et(r);
                  if (Dr.flags & 2097152 && e.isVariableDeclarationInitializedToBareOrAccessedRequire(r)) {
                    j0(r);
                    return;
                  }
                  var Qr = kv(Jt(Dr));
                  if (r === Dr.valueDeclaration) {
                    var li = e.getEffectiveInitializer(r);
                    if (li) {
                      var Ti = e.isInJSFile(r) && e.isObjectLiteralExpression(li) && (li.properties.length === 0 || e.isPrototypeAccess(r.name)) && !!(!((i = Dr.exports) === null || i === void 0) && i.size);
                      !Ti && r.parent.parent.kind !== 243 && op(Os(li), Qr, r, li, void 0);
                    }
                    Dr.declarations && Dr.declarations.length > 1 && e.some(Dr.declarations, function($i) {
                      return $i !== r && e.isVariableLike($i) && !y6($i, r);
                    }) && Xr(r.name, e.Diagnostics.All_declarations_of_0_must_have_identical_modifiers, e.declarationNameToString(r.name));
                  } else {
                    var Ci = kv(sc(r));
                    !nn(Qr) && !nn(Ci) && !wf(Qr, Ci) && !(Dr.flags & 67108864) && v6(Dr.valueDeclaration, Qr, r, Ci), r.initializer && op(Os(r.initializer), Ci, r, r.initializer, void 0), Dr.valueDeclaration && !y6(r, Dr.valueDeclaration) && Xr(r.name, e.Diagnostics.All_declarations_of_0_must_have_identical_modifiers, e.declarationNameToString(r.name));
                  }
                  r.kind !== 167 && r.kind !== 166 && (bv(r), (r.kind === 254 || r.kind === 203) && FF(r), Sm(r, r.name));
                }
              }
              function v6(r, i, t, o) {
                var s = e.getNameOfDeclaration(t), u = t.kind === 167 || t.kind === 166 ? e.Diagnostics.Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2 : e.Diagnostics.Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2, h = e.declarationNameToString(s), z2 = Xr(s, u, h, Ot(i), Ot(o));
                r && e.addRelatedInfo(z2, e.createDiagnosticForNode(r, e.Diagnostics._0_was_also_declared_here, h));
              }
              function y6(r, i) {
                if (r.kind === 164 && i.kind === 254 || r.kind === 254 && i.kind === 164) return true;
                if (e.hasQuestionToken(r) !== e.hasQuestionToken(i)) return false;
                var t = 504;
                return e.getSelectedEffectiveModifierFlags(r, t) === e.getSelectedEffectiveModifierFlags(i, t);
              }
              function SS(r) {
                e.tracing === null || e.tracing === void 0 || e.tracing.push("check", "checkVariableDeclaration", { kind: r.kind, pos: r.pos, end: r.end, path: r.tracingPath }), fL(r), L0(r), e.tracing === null || e.tracing === void 0 || e.tracing.pop();
              }
              function MF(r) {
                return cL(r), L0(r);
              }
              function LF(r) {
                !Ff(r) && !VS(r.declarationList) && _L(r), e.forEach(r.declarationList.declarations, io);
              }
              function RF(r) {
                Mf(r), yn(r.expression);
              }
              function BF(r) {
                Mf(r), Bg(r.expression), TS(r.expression, r.thenStatement), io(r.thenStatement), r.thenStatement.kind === 236 && Xr(r.thenStatement, e.Diagnostics.The_body_of_an_if_statement_cannot_be_the_empty_statement), io(r.elseStatement);
              }
              function TS(r, i) {
                if (!Ye) return;
                for (t(r, i); e.isBinaryExpression(r) && r.operatorToken.kind === 56; ) r = r.left, t(r, i);
                function t(o, s) {
                  var u = e.isBinaryExpression(o) && (o.operatorToken.kind === 56 || o.operatorToken.kind === 55) ? o.right : o;
                  if (!e.isModuleExportsAccessExpression(u)) {
                    var h = Bg(u), z2 = e.isPropertyAccessExpression(u) && Vk(u.expression);
                    if (!(ju(h) || z2)) {
                      var me = ot(h, 0), Me = !!Sv(h);
                      if (!(me.length === 0 && !Me)) {
                        var $e = e.isIdentifier(u) ? u : e.isPropertyAccessExpression(u) ? u.name : e.isBinaryExpression(u) && e.isIdentifier(u.right) ? u.right : void 0, tr = $e && el($e);
                        if (!(!tr && !Me)) {
                          var dr = tr && e.isBinaryExpression(o.parent) && jF(o.parent, tr) || tr && s && JF(o, s, $e, tr);
                          dr || (Me ? zu(u, true, e.Diagnostics.This_condition_will_always_return_true_since_this_0_is_always_defined, q_(h)) : Xr(u, e.Diagnostics.This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead));
                        }
                      }
                    }
                  }
                }
              }
              function JF(r, i, t, o) {
                return !!e.forEachChild(i, function s(u) {
                  if (e.isIdentifier(u)) {
                    var h = el(u);
                    if (h && h === o) {
                      if (e.isIdentifier(r) || e.isIdentifier(t) && e.isBinaryExpression(t.parent)) return true;
                      for (var z2 = t.parent, me = u.parent; z2 && me; ) {
                        if (e.isIdentifier(z2) && e.isIdentifier(me) || z2.kind === 108 && me.kind === 108) return el(z2) === el(me);
                        if (e.isPropertyAccessExpression(z2) && e.isPropertyAccessExpression(me)) {
                          if (el(z2.name) !== el(me.name)) return false;
                          me = me.expression, z2 = z2.expression;
                        } else if (e.isCallExpression(z2) && e.isCallExpression(me)) me = me.expression, z2 = z2.expression;
                        else return false;
                      }
                    }
                  }
                  return e.forEachChild(u, s);
                });
              }
              function jF(r, i) {
                for (; e.isBinaryExpression(r) && r.operatorToken.kind === 55; ) {
                  var t = e.forEachChild(r.right, function o(s) {
                    if (e.isIdentifier(s)) {
                      var u = el(s);
                      if (u && u === i) return true;
                    }
                    return e.forEachChild(s, o);
                  });
                  if (t) return true;
                  r = r.parent;
                }
                return false;
              }
              function UF(r) {
                Mf(r), io(r.statement), Bg(r.expression);
              }
              function zF(r) {
                Mf(r), Bg(r.expression), io(r.statement);
              }
              function h6(r, i) {
                return r.flags & 16384 && Xr(i, e.Diagnostics.An_expression_of_type_void_cannot_be_tested_for_truthiness), r;
              }
              function Bg(r, i) {
                return h6(yn(r, i), r);
              }
              function WF(r) {
                Mf(r) || r.initializer && r.initializer.kind === 255 && VS(r.initializer), r.initializer && (r.initializer.kind === 255 ? e.forEach(r.initializer.declarations, SS) : yn(r.initializer)), r.condition && Bg(r.condition), r.incrementor && yn(r.incrementor), io(r.statement), r.locals && A_(r);
              }
              function qF(r) {
                pA(r);
                var i = e.getContainingFunctionOrClassStaticBlock(r);
                if (r.awaitModifier) if (i && e.isClassStaticBlockDeclaration(i)) Tt(r.awaitModifier, e.Diagnostics.For_await_loops_cannot_be_used_inside_a_class_static_block);
                else {
                  var t = e.getFunctionFlags(i);
                  (t & 6) === 2 && Ae < 99 && fc(r, 16384);
                }
                else ye.downlevelIteration && Ae < 2 && fc(r, 256);
                if (r.initializer.kind === 255) D6(r);
                else {
                  var o = r.initializer, s = By(r);
                  if (o.kind === 204 || o.kind === 205) Rd(o, s || Pe);
                  else {
                    var u = yn(o);
                    hv(o, e.Diagnostics.The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access, e.Diagnostics.The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access), s && op(s, u, o, r.expression);
                  }
                }
                io(r.statement), r.locals && A_(r);
              }
              function VF(r) {
                pA(r);
                var i = jb(yn(r.expression));
                if (r.initializer.kind === 255) {
                  var t = r.initializer.declarations[0];
                  t && e.isBindingPattern(t.name) && Xr(t.name, e.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern), D6(r);
                } else {
                  var o = r.initializer, s = yn(o);
                  o.kind === 204 || o.kind === 205 ? Xr(o, e.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern) : ao(lI(i), s) ? hv(o, e.Diagnostics.The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access, e.Diagnostics.The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access) : Xr(o, e.Diagnostics.The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any);
                }
                (i === ui || !Ns(i, 126091264)) && Xr(r.expression, e.Diagnostics.The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0, Ot(i)), io(r.statement), r.locals && A_(r);
              }
              function D6(r) {
                var i = r.initializer;
                if (i.declarations.length >= 1) {
                  var t = i.declarations[0];
                  SS(t);
                }
              }
              function By(r) {
                var i = r.awaitModifier ? 15 : 13;
                return N_(i, gm(r.expression), Tr, r.expression);
              }
              function N_(r, i, t, o) {
                return ta(i) ? i : xS(r, i, t, o, true) || Oe;
              }
              function xS(r, i, t, o, s) {
                var u = (r & 2) !== 0;
                if (i === ui) {
                  AS(o, i, u);
                  return;
                }
                var h = Ae >= 2, z2 = !h && ye.downlevelIteration, me = ye.noUncheckedIndexedAccess && !!(r & 128);
                if (h || z2 || u) {
                  var Me = Jy(i, r, h ? o : void 0);
                  if (s && Me) {
                    var $e = r & 8 ? e.Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_send_0 : r & 32 ? e.Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_always_send_0 : r & 64 ? e.Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring_will_always_send_0 : r & 16 ? e.Diagnostics.Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_containing_generator_will_always_send_0 : void 0;
                    $e && zc(t, Me.nextType, o, $e);
                  }
                  if (Me || h) return me ? fv(Me && Me.yieldType) : Me && Me.yieldType;
                }
                var tr = i, dr = false, Dr = false;
                if (r & 4) {
                  if (tr.flags & 1048576) {
                    var Qr = i.types, li = e.filter(Qr, function(Ra) {
                      return !(Ra.flags & 402653316);
                    });
                    li !== Qr && (tr = Pa(li, 2));
                  } else tr.flags & 402653316 && (tr = ui);
                  if (Dr = tr !== i, Dr && (Ae < 1 && o && (Xr(o, e.Diagnostics.Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher), dr = true), tr.flags & 131072)) return me ? fv(Li) : Li;
                }
                if (!sp(tr)) {
                  if (o && !dr) {
                    var Ti = !!(r & 4) && !Dr, Ci = Nt(Ti, z2), $i = Ci[0], Zi = Ci[1];
                    zu(o, Zi && !!Sv(tr), $i, Ot(tr));
                  }
                  return Dr ? me ? fv(Li) : Li : void 0;
                }
                var qt = cs(tr, nt);
                if (Dr && qt) return qt.flags & 402653316 && !ye.noUncheckedIndexedAccess ? Li : Pa(me ? [qt, Li, Tr] : [qt, Li], 2);
                return r & 128 ? fv(qt) : qt;
                function Nt(Ra, ca) {
                  var Sn;
                  if (ca) return Ra ? [e.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator, true] : [e.Diagnostics.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator, true];
                  var ja = b6(r, 0, i, void 0);
                  return ja ? [e.Diagnostics.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher, false] : KF((Sn = i.symbol) === null || Sn === void 0 ? void 0 : Sn.escapedName) ? [e.Diagnostics.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher, true] : Ra ? [e.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type, true] : [e.Diagnostics.Type_0_is_not_an_array_type, true];
                }
              }
              function KF(r) {
                switch (r) {
                  case "Float32Array":
                  case "Float64Array":
                  case "Int16Array":
                  case "Int32Array":
                  case "Int8Array":
                  case "NodeList":
                  case "Uint16Array":
                  case "Uint32Array":
                  case "Uint8Array":
                  case "Uint8ClampedArray":
                    return true;
                }
                return false;
              }
              function b6(r, i, t, o) {
                if (!ta(t)) {
                  var s = Jy(t, r, o);
                  return s && s[j(i)];
                }
              }
              function a_(r, i, t) {
                if (r === void 0 && (r = ui), i === void 0 && (i = ui), t === void 0 && (t = gr), r.flags & 67359327 && i.flags & 180227 && t.flags & 180227) {
                  var o = Su([r, i, t]), s = Oo.get(o);
                  return s || (s = { yieldType: r, returnType: i, nextType: t }, Oo.set(o, s)), s;
                }
                return { yieldType: r, returnType: i, nextType: t };
              }
              function S6(r) {
                for (var i, t, o, s = 0, u = r; s < u.length; s++) {
                  var h = u[s];
                  if (!(h === void 0 || h === no)) {
                    if (h === $o) return $o;
                    i = e.append(i, h.yieldType), t = e.append(t, h.returnType), o = e.append(o, h.nextType);
                  }
                }
                return i || t || o ? a_(i && Pa(i), t && Pa(t), o && Do(o)) : no;
              }
              function R0(r, i) {
                return r[i];
              }
              function mf(r, i, t) {
                return r[i] = t;
              }
              function Jy(r, i, t) {
                if (ta(r)) return $o;
                if (!(r.flags & 1048576)) {
                  var o = T6(r, i, t);
                  if (o === no) {
                    t && AS(t, r, !!(i & 2));
                    return;
                  }
                  return o;
                }
                var s = i & 2 ? "iterationTypesOfAsyncIterable" : "iterationTypesOfIterable", u = R0(r, s);
                if (u) return u === no ? void 0 : u;
                for (var h, z2 = 0, me = r.types; z2 < me.length; z2++) {
                  var Me = me[z2], $e = T6(Me, i, t);
                  if ($e === no) {
                    t && AS(t, r, !!(i & 2)), mf(r, s, no);
                    return;
                  } else h = e.append(h, $e);
                }
                var tr = h ? S6(h) : no;
                return mf(r, s, tr), tr === no ? void 0 : tr;
              }
              function ES(r, i) {
                if (r === no) return no;
                if (r === $o) return $o;
                var t = r.yieldType, o = r.returnType, s = r.nextType;
                return i && oD(true), a_(ag(t, i) || Oe, ag(o, i) || Oe, s);
              }
              function T6(r, i, t) {
                if (ta(r)) return $o;
                if (i & 2) {
                  var o = CS(r, St) || E6(r, St);
                  if (o) return i & 8 ? ES(o, t) : o;
                }
                if (i & 1) {
                  var o = CS(r, pa) || E6(r, pa);
                  if (o) if (i & 2) {
                    if (o !== no) return mf(r, "iterationTypesOfAsyncIterable", ES(o, t));
                  } else return o;
                }
                if (i & 2) {
                  var o = kS(r, St, t);
                  if (o !== no) return o;
                }
                if (i & 1) {
                  var o = kS(r, pa, t);
                  if (o !== no) return i & 2 ? mf(r, "iterationTypesOfAsyncIterable", o ? ES(o, t) : no) : o;
                }
                return no;
              }
              function CS(r, i) {
                return R0(r, i.iterableCacheKey);
              }
              function x6(r, i) {
                var t = CS(r, i) || kS(r, i, void 0);
                return t === no ? xi : t;
              }
              function E6(r, i) {
                var t;
                if (Xf(r, t = i.getGlobalIterableType(false)) || Xf(r, t = i.getGlobalIterableIteratorType(false))) {
                  var o = xo(r)[0], s = x6(t, i), u = s.returnType, h = s.nextType;
                  return mf(r, i.iterableCacheKey, a_(i.resolveIterationType(o, void 0) || o, i.resolveIterationType(u, void 0) || u, h));
                }
                if (Xf(r, i.getGlobalGeneratorType(false))) {
                  var z2 = xo(r), o = z2[0], u = z2[1], h = z2[2];
                  return mf(r, i.iterableCacheKey, a_(i.resolveIterationType(o, void 0) || o, i.resolveIterationType(u, void 0) || u, h));
                }
              }
              function GF(r) {
                var i = Ex(false), t = i && da(Jt(i), e.escapeLeadingUnderscores(r));
                return t && _f(t) ? pf(t) : "__@".concat(r);
              }
              function kS(r, i, t) {
                var o, s = bi(r, GF(i.iteratorSymbolName)), u = s && !(s.flags & 16777216) ? Jt(s) : void 0;
                if (ta(u)) return mf(r, i.iterableCacheKey, $o);
                var h = u ? ot(u, 0) : void 0;
                if (!e.some(h)) return mf(r, i.iterableCacheKey, no);
                var z2 = Do(e.map(h, yo)), me = (o = C6(z2, i, t)) !== null && o !== void 0 ? o : no;
                return mf(r, i.iterableCacheKey, me);
              }
              function AS(r, i, t) {
                var o = t ? e.Diagnostics.Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator : e.Diagnostics.Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator;
                zu(r, !!Sv(i), o, Ot(i));
              }
              function C6(r, i, t) {
                if (ta(r)) return $o;
                var o = k6(r, i) || HF(r, i) || N6(r, i, t);
                return o === no ? void 0 : o;
              }
              function k6(r, i) {
                return R0(r, i.iteratorCacheKey);
              }
              function HF(r, i) {
                var t = i.getGlobalIterableIteratorType(false);
                if (Xf(r, t)) {
                  var o = xo(r)[0], s = k6(t, i) || N6(t, i, void 0), u = s === no ? xi : s, h = u.returnType, z2 = u.nextType;
                  return mf(r, i.iteratorCacheKey, a_(o, h, z2));
                }
                if (Xf(r, i.getGlobalIteratorType(false)) || Xf(r, i.getGlobalGeneratorType(false))) {
                  var me = xo(r), o = me[0], h = me[1], z2 = me[2];
                  return mf(r, i.iteratorCacheKey, a_(o, h, z2));
                }
              }
              function A6(r, i) {
                var t = da(r, "done") || xt;
                return ao(i === 0 ? xt : Dt, t);
              }
              function XF(r) {
                return A6(r, 0);
              }
              function QF(r) {
                return A6(r, 1);
              }
              function YF(r) {
                if (ta(r)) return $o;
                var i = R0(r, "iterationTypesOfIteratorResult");
                if (i) return i;
                if (Xf(r, O3(false))) {
                  var t = xo(r)[0];
                  return mf(r, "iterationTypesOfIteratorResult", a_(t, void 0, void 0));
                }
                if (Xf(r, F3(false))) {
                  var o = xo(r)[0];
                  return mf(r, "iterationTypesOfIteratorResult", a_(void 0, o, void 0));
                }
                var s = ec(r, XF), u = s !== ui ? da(s, "value") : void 0, h = ec(r, QF), z2 = h !== ui ? da(h, "value") : void 0;
                return !u && !z2 ? mf(r, "iterationTypesOfIteratorResult", no) : mf(r, "iterationTypesOfIteratorResult", a_(u, z2 || Fi, void 0));
              }
              function NS(r, i, t, o) {
                var s, u, h, z2, me = bi(r, t);
                if (!(!me && t !== "next")) {
                  var Me = me && !(t === "next" && me.flags & 16777216) ? t === "next" ? Jt(me) : Ks(Jt(me), 2097152) : void 0;
                  if (ta(Me)) return t === "next" ? $o : Pr;
                  var $e = Me ? ot(Me, 0) : e.emptyArray;
                  if ($e.length === 0) {
                    if (o) {
                      var tr = t === "next" ? i.mustHaveANextMethodDiagnostic : i.mustBeAMethodDiagnostic;
                      Xr(o, tr, t);
                    }
                    return t === "next" ? $o : void 0;
                  }
                  if ((Me == null ? void 0 : Me.symbol) && $e.length === 1) {
                    var dr = i.getGlobalGeneratorType(false), Dr = i.getGlobalIteratorType(false), Qr = ((u = (s = dr.symbol) === null || s === void 0 ? void 0 : s.members) === null || u === void 0 ? void 0 : u.get(t)) === Me.symbol, li = !Qr && ((z2 = (h = Dr.symbol) === null || h === void 0 ? void 0 : h.members) === null || z2 === void 0 ? void 0 : z2.get(t)) === Me.symbol;
                    if (Qr || li) {
                      var Ti = Qr ? dr : Dr, Ci = Me.mapper;
                      return a_(ap(Ti.typeParameters[0], Ci), ap(Ti.typeParameters[1], Ci), t === "next" ? ap(Ti.typeParameters[2], Ci) : void 0);
                    }
                  }
                  for (var $i, Zi, qt = 0, Nt = $e; qt < Nt.length; qt++) {
                    var Ra = Nt[qt];
                    t !== "throw" && e.some(Ra.parameters) && ($i = e.append($i, $u(Ra, 0))), Zi = e.append(Zi, yo(Ra));
                  }
                  var ca, Sn;
                  if (t !== "throw") {
                    var ja = $i ? Pa($i) : gr;
                    if (t === "next") Sn = ja;
                    else if (t === "return") {
                      var Fn = i.resolveIterationType(ja, o) || Oe;
                      ca = e.append(ca, Fn);
                    }
                  }
                  var wn, Tn = Zi ? Do(Zi) : ui, Eo = i.resolveIterationType(Tn, o) || Oe, lt = YF(Eo);
                  return lt === no ? (o && Xr(o, i.mustHaveAValueDiagnostic, t), wn = Oe, ca = e.append(ca, Oe)) : (wn = lt.yieldType, ca = e.append(ca, lt.returnType)), a_(wn, Pa(ca), Sn);
                }
              }
              function N6(r, i, t) {
                var o = S6([NS(r, i, "next", t), NS(r, i, "return", t), NS(r, i, "throw", t)]);
                return mf(r, i.iteratorCacheKey, o);
              }
              function Jg(r, i, t) {
                if (!ta(i)) {
                  var o = P6(i, t);
                  return o && o[j(r)];
                }
              }
              function P6(r, i) {
                if (ta(r)) return $o;
                var t = i ? 2 : 1, o = i ? St : pa;
                return Jy(r, t, void 0) || C6(r, o, void 0);
              }
              function $F(r) {
                Mf(r) || sL(r);
              }
              function B0(r, i) {
                var t = !!(i & 1), o = !!(i & 2);
                return t ? Jg(1, r, o) || Pe : o ? k_(r) || Pe : r;
              }
              function I6(r, i) {
                var t = B0(i, e.getFunctionFlags(r));
                return !!t && fs(t, 16387);
              }
              function ZF(r) {
                var i;
                if (!Mf(r)) {
                  var t = e.getContainingFunctionOrClassStaticBlock(r);
                  if (t && e.isClassStaticBlockDeclaration(t)) {
                    Hs(r, e.Diagnostics.A_return_statement_cannot_be_used_inside_a_class_static_block);
                    return;
                  }
                  if (!t) {
                    Hs(r, e.Diagnostics.A_return_statement_can_only_be_used_within_a_function_body);
                    return;
                  }
                  var o = yl(t), s = yo(o), u = e.getFunctionFlags(t);
                  if (Ye || r.expression || s.flags & 131072) {
                    var h = r.expression ? Os(r.expression) : Tr;
                    if (t.kind === 173) r.expression && Xr(r, e.Diagnostics.Setters_cannot_return_a_value);
                    else if (t.kind === 171) r.expression && !op(h, s, r, r.expression) && Xr(r, e.Diagnostics.Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class);
                    else if (yg(t)) {
                      var z2 = (i = B0(s, u)) !== null && i !== void 0 ? i : s, me = u & 2 ? xv(h, false, r, e.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member) : h;
                      z2 && op(me, z2, r, r.expression);
                    }
                  } else t.kind !== 171 && ye.noImplicitReturns && !I6(t, s) && Xr(r, e.Diagnostics.Not_all_code_paths_return_a_value);
                }
              }
              function eM(r) {
                Mf(r) || r.flags & 32768 && Hs(r, e.Diagnostics.with_statements_are_not_allowed_in_an_async_function_block), yn(r.expression);
                var i = e.getSourceFileOfNode(r);
                if (!Jd(i)) {
                  var t = e.getSpanOfTokenAtPosition(i, r.pos).start, o = r.statement.pos;
                  rd(i, t, o - t, e.Diagnostics.The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any);
                }
              }
              function rM(r) {
                Mf(r);
                var i, t = false, o = yn(r.expression), s = Cg(o);
                e.forEach(r.caseBlock.clauses, function(u) {
                  u.kind === 290 && !t && (i === void 0 ? i = u : (Tt(u, e.Diagnostics.A_default_clause_cannot_appear_more_than_once_in_a_switch_statement), t = true)), u.kind === 289 && fe(h(u)), e.forEach(u.statements, io), ye.noFallthroughCasesInSwitch && u.fallthroughFlowNode && my(u.fallthroughFlowNode) && Xr(u, e.Diagnostics.Fallthrough_case_in_switch);
                  function h(z2) {
                    return function() {
                      var me = yn(z2.expression), Me = Cg(me), $e = o;
                      (!Me || !s) && (me = Me ? Kl(me) : me, $e = Kl(o)), fS($e, me) || mE(me, $e, z2.expression, void 0);
                    };
                  }
                }), r.caseBlock.locals && A_(r.caseBlock);
              }
              function iM(r) {
                Mf(r) || e.findAncestor(r.parent, function(i) {
                  return e.isFunctionLike(i) ? "quit" : i.kind === 250 && i.label.escapedText === r.label.escapedText ? (Tt(r.label, e.Diagnostics.Duplicate_label_0, e.getTextOfNode(r.label)), true) : false;
                }), io(r.statement);
              }
              function tM(r) {
                Mf(r) || e.isIdentifier(r.expression) && !r.expression.escapedText && TL(r, e.Diagnostics.Line_break_not_permitted_here), r.expression && yn(r.expression);
              }
              function aM(r) {
                Mf(r), M0(r.tryBlock);
                var i = r.catchClause;
                if (i) {
                  if (i.variableDeclaration) {
                    var t = i.variableDeclaration, o = e.getEffectiveTypeAnnotationNode(e.getRootDeclaration(t));
                    if (o) {
                      var s = G_(t, false, 0);
                      s && !(s.flags & 3) && Hs(o, e.Diagnostics.Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified);
                    } else if (t.initializer) Hs(t.initializer, e.Diagnostics.Catch_clause_variable_cannot_have_an_initializer);
                    else {
                      var u = i.block.locals;
                      u && e.forEachKey(i.locals, function(h) {
                        var z2 = u.get(h);
                        (z2 == null ? void 0 : z2.valueDeclaration) && (z2.flags & 2) !== 0 && Tt(z2.valueDeclaration, e.Diagnostics.Cannot_redeclare_identifier_0_in_catch_clause, h);
                      });
                    }
                  }
                  M0(i.block);
                }
                r.finallyBlock && M0(r.finallyBlock);
              }
              function J0(r, i, t) {
                var o = Hn(r);
                if (o.length !== 0) {
                  for (var s = 0, u = Pf(r); s < u.length; s++) {
                    var h = u[s];
                    t && h.flags & 4194304 || w6(r, h, om(h, 8576, true), ml(h));
                  }
                  var z2 = i.valueDeclaration;
                  if (z2 && e.isClassLike(z2)) for (var me = 0, Me = z2.members; me < Me.length; me++) {
                    var $e = Me[me];
                    if (!e.isStatic($e) && !Td($e)) {
                      var tr = Et($e);
                      w6(r, tr, Gs($e.name.expression), ml(tr));
                    }
                  }
                  if (o.length > 1) for (var dr = 0, Dr = o; dr < Dr.length; dr++) {
                    var Qr = Dr[dr];
                    nM(r, Qr);
                  }
                }
              }
              function w6(r, i, t, o) {
                var s = i.valueDeclaration, u = e.getNameOfDeclaration(s);
                if (!(u && e.isPrivateIdentifier(u))) for (var h = ws(r, t), z2 = e.getObjectFlags(r) & 2 ? e.getDeclarationOfKind(r.symbol, 258) : void 0, me = s && s.kind === 221 || u && u.kind === 162 || Ys(i) === r.symbol ? s : void 0, Me = function(Dr) {
                  var Qr = Dr.declaration && Ys(Et(Dr.declaration)) === r.symbol ? Dr.declaration : void 0, li = me || Qr || (z2 && !e.some(Qc(r), function(Ti) {
                    return !!h_(Ti, i.escapedName) && !!cs(Ti, Dr.keyType);
                  }) ? z2 : void 0);
                  li && !ao(o, Dr.type) && Xr(li, e.Diagnostics.Property_0_of_type_1_is_not_assignable_to_2_index_type_3, tn(i), Ot(o), Ot(Dr.keyType), Ot(Dr.type));
                }, $e = 0, tr = h; $e < tr.length; $e++) {
                  var dr = tr[$e];
                  Me(dr);
                }
              }
              function nM(r, i) {
                for (var t = i.declaration, o = ws(r, i.keyType), s = e.getObjectFlags(r) & 2 ? e.getDeclarationOfKind(r.symbol, 258) : void 0, u = t && Ys(Et(t)) === r.symbol ? t : void 0, h = function($e) {
                  if ($e === i) return "continue";
                  var tr = $e.declaration && Ys(Et($e.declaration)) === r.symbol ? $e.declaration : void 0, dr = u || tr || (s && !e.some(Qc(r), function(Dr) {
                    return !!ss(Dr, i.keyType) && !!cs(Dr, $e.keyType);
                  }) ? s : void 0);
                  dr && !ao(i.type, $e.type) && Xr(dr, e.Diagnostics._0_index_type_1_is_not_assignable_to_2_index_type_3, Ot(i.keyType), Ot(i.type), Ot($e.keyType), Ot($e.type));
                }, z2 = 0, me = o; z2 < me.length; z2++) {
                  var Me = me[z2];
                  h(Me);
                }
              }
              function Tm(r, i) {
                switch (r.escapedText) {
                  case "any":
                  case "unknown":
                  case "never":
                  case "number":
                  case "bigint":
                  case "boolean":
                  case "string":
                  case "symbol":
                  case "void":
                  case "object":
                    Xr(r, i, r.escapedText);
                }
              }
              function oM(r) {
                Ae >= 1 && r.escapedText === "Object" && (er < e.ModuleKind.ES2015 || e.getSourceFileOfNode(r).impliedNodeFormat === e.ModuleKind.CommonJS) && Xr(r, e.Diagnostics.Class_name_cannot_be_Object_when_targeting_ES5_with_module_0, e.ModuleKind[er]);
              }
              function sM(r) {
                var i = e.filter(e.getJSDocTags(r), e.isJSDocParameterTag);
                if (!!e.length(i)) {
                  var t = e.isInJSFile(r), o = new e.Set(), s = new e.Set();
                  e.forEach(r.parameters, function(z2, me) {
                    var Me = z2.name;
                    e.isIdentifier(Me) && o.add(Me.escapedText), e.isBindingPattern(Me) && s.add(me);
                  });
                  var u = Gm(r);
                  if (u) {
                    var h = e.lastOrUndefined(i);
                    t && h && e.isIdentifier(h.name) && h.typeExpression && h.typeExpression.type && !o.has(h.name.escapedText) && !Tu(Va(h.typeExpression.type)) && Xr(h.name, e.Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type, e.idText(h.name));
                  } else e.forEach(i, function(z2, me) {
                    var Me = z2.name;
                    s.has(me) || e.isIdentifier(Me) && o.has(Me.escapedText) || (e.isQualifiedName(Me) ? t && Xr(Me, e.Diagnostics.Qualified_name_0_is_not_allowed_without_a_leading_param_object_1, e.entityNameToString(Me), e.entityNameToString(Me.left)) : Ic(t, Me, e.Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name, e.idText(Me)));
                  });
                }
              }
              function jy(r) {
                var i = false;
                if (r) for (var t = 0; t < r.length; t++) {
                  var o = r[t];
                  $k(o), fe(s(o, t));
                }
                function s(u, h) {
                  return function() {
                    u.default ? (i = true, cM(u.default, r, h)) : i && Xr(u, e.Diagnostics.Required_type_parameters_may_not_follow_optional_type_parameters);
                    for (var z2 = 0; z2 < h; z2++) r[z2].symbol === u.symbol && Xr(u.name, e.Diagnostics.Duplicate_identifier_0, e.declarationNameToString(u.name));
                  };
                }
              }
              function cM(r, i, t) {
                o(r);
                function o(s) {
                  if (s.kind === 178) {
                    var u = ty(s);
                    if (u.flags & 262144) for (var h = t; h < i.length; h++) u.symbol === Et(i[h]) && Xr(s, e.Diagnostics.Type_parameter_defaults_can_only_reference_previously_declared_type_parameters);
                  }
                  e.forEachChild(s, o);
                }
              }
              function O6(r) {
                if (!(r.declarations && r.declarations.length === 1)) {
                  var i = Aa(r);
                  if (!i.typeParametersChecked) {
                    i.typeParametersChecked = true;
                    var t = gM(r);
                    if (!t || t.length <= 1) return;
                    var o = go(r);
                    if (!F6(t, o.localTypeParameters, e.getEffectiveTypeParameterDeclarations)) for (var s = tn(r), u = 0, h = t; u < h.length; u++) {
                      var z2 = h[u];
                      Xr(z2.name, e.Diagnostics.All_declarations_of_0_must_have_identical_type_parameters, s);
                    }
                  }
                }
              }
              function F6(r, i, t) {
                for (var o = e.length(i), s = Ul(i), u = 0, h = r; u < h.length; u++) {
                  var z2 = h[u], me = t(z2), Me = me.length;
                  if (Me < s || Me > o) return false;
                  for (var $e = 0; $e < Me; $e++) {
                    var tr = me[$e], dr = i[$e];
                    if (tr.name.escapedText !== dr.symbol.escapedName) return false;
                    var Dr = e.getEffectiveConstraintOfTypeParameter(tr), Qr = Dr && Va(Dr), li = Tc(dr);
                    if (Qr && li && !wf(Qr, li)) return false;
                    var Ti = tr.default && Va(tr.default), Ci = D_(dr);
                    if (Ti && Ci && !wf(Ti, Ci)) return false;
                  }
                }
                return true;
              }
              function uM(r) {
                return M6(r), xm(r), Jt(Et(r));
              }
              function lM(r) {
                e.forEach(r.members, io), A_(r);
              }
              function fM(r) {
                e.some(r.decorators) && e.some(r.members, function(i) {
                  return e.hasStaticModifier(i) && e.isPrivateIdentifierClassElementDeclaration(i);
                }) && Tt(r.decorators[0], e.Diagnostics.Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator), !r.name && !e.hasSyntacticModifier(r, 512) && Hs(r, e.Diagnostics.A_class_declaration_without_the_default_modifier_must_have_a_name), M6(r), e.forEach(r.members, io), A_(r);
              }
              function M6(r) {
                K9(r), Fy(r), Sm(r, r.name), jy(e.getEffectiveTypeParameterDeclarations(r)), bv(r);
                var i = Et(r), t = go(i), o = Rc(t), s = Jt(i);
                O6(i), O0(i), MO(r);
                var u = !!(r.flags & 16777216);
                u || LO(r);
                var h = e.getEffectiveBaseTypeNode(r);
                if (h) {
                  e.forEach(h.typeArguments, io), Ae < 2 && fc(h.parent, 1);
                  var z2 = e.getClassExtendsHeritageElement(r);
                  z2 && z2 !== h && yn(z2.expression);
                  var me = Qc(t);
                  me.length && fe(function() {
                    var Qr = me[0], li = Bl(t), Ti = $s(li);
                    if (pM(Ti, h), io(h.expression), e.some(h.typeArguments)) {
                      e.forEach(h.typeArguments, io);
                      for (var Ci = 0, $i = Mm(Ti, h.typeArguments, h); Ci < $i.length; Ci++) {
                        var Zi = $i[Ci];
                        if (!n6(h, Zi.typeParameters)) break;
                      }
                    }
                    var qt = Rc(Qr, t.thisType);
                    if (zc(o, qt, void 0) ? zc(s, _E(Ti), r.name || r, e.Diagnostics.Class_static_side_0_incorrectly_extends_base_class_static_side_1) : B6(r, o, qt, e.Diagnostics.Class_0_incorrectly_extends_base_class_1), li.flags & 8650752) if (!Wd(s)) Xr(r.name || r, e.Diagnostics.A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any);
                    else {
                      var Nt = ot(li, 1);
                      Nt.some(function(ca) {
                        return ca.flags & 4;
                      }) && !e.hasSyntacticModifier(r, 128) && Xr(r.name || r, e.Diagnostics.A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_be_declared_abstract);
                    }
                    if (!(Ti.symbol && Ti.symbol.flags & 32) && !(li.flags & 8650752)) {
                      var Ra = Xg(Ti, h.typeArguments, h);
                      e.forEach(Ra, function(ca) {
                        return !Sl(ca.declaration) && !wf(yo(ca), Qr);
                      }) && Xr(h.expression, e.Diagnostics.Base_constructors_must_all_have_the_same_return_type);
                    }
                    mM(t, Qr);
                  });
                }
                _M(r, t, o, s);
                var Me = e.getEffectiveImplementsTypeNodes(r);
                if (Me) for (var $e = 0, tr = Me; $e < tr.length; $e++) {
                  var dr = tr[$e];
                  (!e.isEntityNameExpression(dr.expression) || e.isOptionalChain(dr.expression)) && Xr(dr.expression, e.Diagnostics.A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments), vS(dr), fe(Dr(dr));
                }
                fe(function() {
                  J0(t, i), J0(s, i, true), dS(r), hM(r);
                });
                function Dr(Qr) {
                  return function() {
                    var li = bu(Va(Qr));
                    if (!nn(li)) if (ff(li)) {
                      var Ti = li.symbol && li.symbol.flags & 32 ? e.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass : e.Diagnostics.Class_0_incorrectly_implements_interface_1, Ci = Rc(li, t.thisType);
                      zc(o, Ci, void 0) || B6(r, o, Ci, Ti);
                    } else Xr(Qr, e.Diagnostics.A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members);
                  };
                }
              }
              function _M(r, i, t, o) {
                for (var s = e.getEffectiveBaseTypeNode(r), u = s && Qc(i), h = u != null && u.length ? Rc(e.first(u), i.thisType) : void 0, z2 = Bl(i), me = function(dr) {
                  if (e.hasAmbientModifier(dr)) return "continue";
                  e.isConstructorDeclaration(dr) && e.forEach(dr.parameters, function(Dr) {
                    e.isParameterPropertyDeclaration(Dr, dr) && L6(r, o, z2, h, i, t, Dr, true);
                  }), L6(r, o, z2, h, i, t, dr, false);
                }, Me = 0, $e = r.members; Me < $e.length; Me++) {
                  var tr = $e[Me];
                  me(tr);
                }
              }
              function L6(r, i, t, o, s, u, h, z2, me) {
                me === void 0 && (me = true);
                var Me = h.name && el(h.name) || el(h);
                return Me ? R6(r, i, t, o, s, u, e.hasOverrideModifier(h), e.hasAbstractModifier(h), e.isStatic(h), z2, e.symbolName(Me), me ? h : void 0) : 0;
              }
              function R6(r, i, t, o, s, u, h, z2, me, Me, $e, tr) {
                var dr = e.isInJSFile(r), Dr = !!(r.flags & 16777216);
                if (o && (h || ye.noImplicitOverride)) {
                  var Qr = e.escapeLeadingUnderscores($e), li = me ? i : u, Ti = me ? t : o, Ci = bi(li, Qr), $i = bi(Ti, Qr), Zi = Ot(o);
                  if (Ci && !$i && h) {
                    if (tr) {
                      var qt = ZC($e, Ti);
                      qt ? Xr(tr, dr ? e.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1 : e.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1, Zi, tn(qt)) : Xr(tr, dr ? e.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0 : e.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0, Zi);
                    }
                    return 2;
                  } else if (Ci && ($i == null ? void 0 : $i.declarations) && ye.noImplicitOverride && !Dr) {
                    var Nt = e.some($i.declarations, e.hasAbstractModifier);
                    if (h) return 0;
                    if (Nt) {
                      if (z2 && Nt) return tr && Xr(tr, e.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0, Zi), 1;
                    } else {
                      if (tr) {
                        var Ra = Me ? dr ? e.Diagnostics.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0 : e.Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0 : dr ? e.Diagnostics.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0 : e.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0;
                        Xr(tr, Ra, Zi);
                      }
                      return 1;
                    }
                  }
                } else if (h) {
                  if (tr) {
                    var ca = Ot(s);
                    Xr(tr, dr ? e.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class : e.Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class, ca);
                  }
                  return 2;
                }
                return 0;
              }
              function B6(r, i, t, o) {
                for (var s = false, u = function(Me) {
                  if (e.isStatic(Me)) return "continue";
                  var $e = Me.name && el(Me.name) || el(Me);
                  if ($e) {
                    var tr = bi(i, $e.escapedName), dr = bi(t, $e.escapedName);
                    if (tr && dr) {
                      var Dr = function() {
                        return e.chainDiagnosticMessages(void 0, e.Diagnostics.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2, tn($e), Ot(i), Ot(t));
                      };
                      zc(Jt(tr), Jt(dr), Me.name || Me, void 0, Dr) || (s = true);
                    }
                  }
                }, h = 0, z2 = r.members; h < z2.length; h++) {
                  var me = z2[h];
                  u(me);
                }
                s || zc(i, t, r.name || r, o);
              }
              function pM(r, i) {
                var t = ot(r, 1);
                if (t.length) {
                  var o = t[0].declaration;
                  if (o && e.hasEffectiveModifier(o, 8)) {
                    var s = e.getClassLikeDeclarationOfSymbol(r.symbol);
                    MS(i, s) || Xr(i, e.Diagnostics.Cannot_extend_a_class_0_Class_constructor_is_marked_as_private, cl(r.symbol));
                  }
                }
              }
              function dM(r, i) {
                if (!i.name) return 0;
                var t = Et(r), o = go(t), s = Rc(o), u = Jt(t), h = e.getEffectiveBaseTypeNode(r), z2 = h && Qc(o), me = z2 != null && z2.length ? Rc(e.first(z2), o.thisType) : void 0, Me = Bl(o), $e = i.parent ? e.hasOverrideModifier(i) : e.hasSyntacticModifier(i, 16384), tr = e.unescapeLeadingUnderscores(e.getTextOfPropertyName(i.name));
                return R6(r, u, Me, me, o, s, $e, e.hasAbstractModifier(i), e.isStatic(i), false, tr);
              }
              function jg(r) {
                return e.getCheckFlags(r) & 1 ? r.target : r;
              }
              function gM(r) {
                return e.filter(r.declarations, function(i) {
                  return i.kind === 257 || i.kind === 258;
                });
              }
              function mM(r, i) {
                var t, o, s = uo(i);
                e: for (var u = 0, h = s; u < h.length; u++) {
                  var z2 = h[u], me = jg(z2);
                  if (!(me.flags & 4194304)) {
                    var Me = h_(r, me.escapedName);
                    if (!!Me) {
                      var $e = jg(Me), tr = e.getDeclarationModifierFlagsFromSymbol(me);
                      if (e.Debug.assert(!!$e, "derived should point to something, even if it is the base class' declaration."), $e === me) {
                        var dr = e.getClassLikeDeclarationOfSymbol(r.symbol);
                        if (tr & 128 && (!dr || !e.hasSyntacticModifier(dr, 128))) {
                          for (var Dr = 0, Qr = Qc(r); Dr < Qr.length; Dr++) {
                            var li = Qr[Dr];
                            if (li !== i) {
                              var Ti = h_(li, me.escapedName), Ci = Ti && jg(Ti);
                              if (Ci && Ci !== me) continue e;
                            }
                          }
                          dr.kind === 226 ? Xr(dr, e.Diagnostics.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1, tn(z2), Ot(i)) : Xr(dr, e.Diagnostics.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2, Ot(r), tn(z2), Ot(i));
                        }
                      } else {
                        var $i = e.getDeclarationModifierFlagsFromSymbol($e);
                        if (tr & 8 || $i & 8) continue;
                        var Zi = void 0, qt = me.flags & 98308, Nt = $e.flags & 98308;
                        if (qt && Nt) {
                          if (tr & 128 && !(me.valueDeclaration && e.isPropertyDeclaration(me.valueDeclaration) && me.valueDeclaration.initializer) || me.valueDeclaration && me.valueDeclaration.parent.kind === 258 || $e.valueDeclaration && e.isBinaryExpression($e.valueDeclaration)) continue;
                          var Ra = qt !== 4 && Nt === 4, ca = qt === 4 && Nt !== 4;
                          if (Ra || ca) {
                            var Sn = Ra ? e.Diagnostics._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property : e.Diagnostics._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor;
                            Xr(e.getNameOfDeclaration($e.valueDeclaration) || $e.valueDeclaration, Sn, tn(me), Ot(i), Ot(r));
                          } else if (ir) {
                            var ja = (t = $e.declarations) === null || t === void 0 ? void 0 : t.find(function(Eo) {
                              return Eo.kind === 167 && !Eo.initializer;
                            });
                            if (ja && !($e.flags & 33554432) && !(tr & 128) && !($i & 128) && !(!((o = $e.declarations) === null || o === void 0) && o.some(function(Eo) {
                              return !!(Eo.flags & 16777216);
                            }))) {
                              var Fn = Tf(e.getClassLikeDeclarationOfSymbol(r.symbol)), wn = ja.name;
                              if (ja.exclamationToken || !Fn || !e.isIdentifier(wn) || !Ye || !j6(wn, r, Fn)) {
                                var Tn = e.Diagnostics.Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration;
                                Xr(e.getNameOfDeclaration($e.valueDeclaration) || $e.valueDeclaration, Tn, tn(me), Ot(i));
                              }
                            }
                          }
                          continue;
                        } else if (Bb(me)) {
                          if (Bb($e) || $e.flags & 4) continue;
                          e.Debug.assert(!!($e.flags & 98304)), Zi = e.Diagnostics.Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor;
                        } else me.flags & 98304 ? Zi = e.Diagnostics.Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function : Zi = e.Diagnostics.Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function;
                        Xr(e.getNameOfDeclaration($e.valueDeclaration) || $e.valueDeclaration, Zi, Ot(i), tn(me), Ot(r));
                      }
                    }
                  }
                }
              }
              function vM(r, i, t) {
                if (!e.length(i)) return t;
                var o = new e.Map();
                e.forEach(t, function(dr) {
                  o.set(dr.escapedName, dr);
                });
                for (var s = 0, u = i; s < u.length; s++) for (var h = u[s], z2 = uo(Rc(h, r.thisType)), me = 0, Me = z2; me < Me.length; me++) {
                  var $e = Me[me], tr = o.get($e.escapedName);
                  tr && $e.parent === tr.parent && o.delete($e.escapedName);
                }
                return e.arrayFrom(o.values());
              }
              function yM(r, i) {
                var t = Qc(r);
                if (t.length < 2) return true;
                var o = new e.Map();
                e.forEach(Lv(r).declaredProperties, function(Ci) {
                  o.set(Ci.escapedName, { prop: Ci, containingType: r });
                });
                for (var s = true, u = 0, h = t; u < h.length; u++) for (var z2 = h[u], me = uo(Rc(z2, r.thisType)), Me = 0, $e = me; Me < $e.length; Me++) {
                  var tr = $e[Me], dr = o.get(tr.escapedName);
                  if (!dr) o.set(tr.escapedName, { prop: tr, containingType: z2 });
                  else {
                    var Dr = dr.containingType !== r;
                    if (Dr && !yw(dr.prop, tr)) {
                      s = false;
                      var Qr = Ot(dr.containingType), li = Ot(z2), Ti = e.chainDiagnosticMessages(void 0, e.Diagnostics.Named_property_0_of_types_1_and_2_are_not_identical, tn(tr), Qr, li);
                      Ti = e.chainDiagnosticMessages(Ti, e.Diagnostics.Interface_0_cannot_simultaneously_extend_types_1_and_2, Ot(r), Qr, li), rn.add(e.createDiagnosticForNodeFromMessageChain(i, Ti));
                    }
                  }
                }
                return s;
              }
              function hM(r) {
                if (!(!Ye || !Ne || r.flags & 16777216)) for (var i = Tf(r), t = 0, o = r.members; t < o.length; t++) {
                  var s = o[t];
                  if (!(e.getEffectiveModifierFlags(s) & 2) && !e.isStatic(s) && J6(s)) {
                    var u = s.name;
                    if (e.isIdentifier(u) || e.isPrivateIdentifier(u) || e.isComputedPropertyName(u)) {
                      var h = Jt(Et(s));
                      h.flags & 3 || ju(h) & 32768 || (!i || !j6(u, h, i)) && Xr(s.name, e.Diagnostics.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor, e.declarationNameToString(u));
                    }
                  }
                }
              }
              function J6(r) {
                return r.kind === 167 && !e.hasAbstractModifier(r) && !r.exclamationToken && !r.initializer;
              }
              function DM(r, i, t, o, s) {
                for (var u = 0, h = t; u < h.length; u++) {
                  var z2 = h[u];
                  if (z2.pos >= o && z2.pos <= s) {
                    var me = e.factory.createPropertyAccessExpression(e.factory.createThis(), r);
                    e.setParent(me.expression, me), e.setParent(me, z2), me.flowNode = z2.returnFlowNode;
                    var Me = up(me, i, i_(i));
                    if (!(ju(Me) & 32768)) return true;
                  }
                }
                return false;
              }
              function j6(r, i, t) {
                var o = e.isComputedPropertyName(r) ? e.factory.createElementAccessExpression(e.factory.createThis(), r.expression) : e.factory.createPropertyAccessExpression(e.factory.createThis(), r);
                e.setParent(o.expression, o), e.setParent(o, t), o.flowNode = t.returnFlowNode;
                var s = up(o, i, i_(i));
                return !(ju(s) & 32768);
              }
              function bM(r) {
                Ff(r) || Z9(r), jy(r.typeParameters), fe(function() {
                  Tm(r.name, e.Diagnostics.Interface_name_cannot_be_0), bv(r);
                  var i = Et(r);
                  O6(i);
                  var t = e.getDeclarationOfKind(i, 258);
                  if (r === t) {
                    var o = go(i), s = Rc(o);
                    if (yM(o, r.name)) {
                      for (var u = 0, h = Qc(o); u < h.length; u++) {
                        var z2 = h[u];
                        zc(s, Rc(z2, o.thisType), r.name, e.Diagnostics.Interface_0_incorrectly_extends_interface_1);
                      }
                      J0(o, i);
                    }
                  }
                  r6(r);
                }), e.forEach(e.getInterfaceBaseTypeNodes(r), function(i) {
                  (!e.isEntityNameExpression(i.expression) || e.isOptionalChain(i.expression)) && Xr(i.expression, e.Diagnostics.An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments), vS(i);
                }), e.forEach(r.members, io), fe(function() {
                  dS(r), A_(r);
                });
              }
              function SM(r) {
                Ff(r), Tm(r.name, e.Diagnostics.Type_alias_name_cannot_be_0), bv(r), jy(r.typeParameters), r.type.kind === 138 ? (!x.has(r.name.escapedText) || e.length(r.typeParameters) !== 1) && Xr(r.type, e.Diagnostics.The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types) : (io(r.type), A_(r));
              }
              function U6(r) {
                var i = va(r);
                if (!(i.flags & 16384)) {
                  i.flags |= 16384;
                  for (var t = 0, o = 0, s = r.members; o < s.length; o++) {
                    var u = s[o], h = TM(u, t);
                    va(u).enumMemberValue = h, t = typeof h == "number" ? h + 1 : void 0;
                  }
                }
              }
              function TM(r, i) {
                if (e.isComputedNonLiteralName(r.name)) Xr(r.name, e.Diagnostics.Computed_property_names_are_not_allowed_in_enums);
                else {
                  var t = e.getTextOfPropertyName(r.name);
                  e.isNumericLiteralName(t) && !e.isInfinityOrNaNString(t) && Xr(r.name, e.Diagnostics.An_enum_member_cannot_have_a_numeric_name);
                }
                if (r.initializer) return xM(r);
                if (!(r.parent.flags & 16777216 && !e.isEnumConst(r.parent) && as(Et(r.parent)) === 0)) {
                  if (i !== void 0) return i;
                  Xr(r.name, e.Diagnostics.Enum_member_must_have_initializer);
                }
              }
              function xM(r) {
                var i = as(Et(r.parent)), t = e.isEnumConst(r.parent), o = r.initializer, s = i === 1 && !ro(r) ? void 0 : h(o);
                if (s !== void 0) t && typeof s == "number" && !isFinite(s) && Xr(o, isNaN(s) ? e.Diagnostics.const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN : e.Diagnostics.const_enum_member_initializer_was_evaluated_to_a_non_finite_value);
                else {
                  if (i === 1) return Xr(o, e.Diagnostics.Computed_values_are_not_permitted_in_an_enum_with_string_valued_members), 0;
                  if (t) Xr(o, e.Diagnostics.const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values);
                  else if (r.parent.flags & 16777216) Xr(o, e.Diagnostics.In_ambient_enum_declarations_member_initializer_must_be_constant_expression);
                  else {
                    var u = yn(o);
                    Ns(u, 296) ? zc(u, go(Et(r.parent)), o, void 0) : Xr(o, e.Diagnostics.Only_numeric_enums_can_have_computed_members_but_this_expression_has_type_0_If_you_do_not_need_exhaustiveness_checks_consider_using_an_object_literal_instead, Ot(u));
                  }
                }
                return s;
                function h(me) {
                  switch (me.kind) {
                    case 219:
                      var Me = h(me.operand);
                      if (typeof Me == "number") switch (me.operator) {
                        case 39:
                          return Me;
                        case 40:
                          return -Me;
                        case 54:
                          return ~Me;
                      }
                      break;
                    case 221:
                      var $e = h(me.left), tr = h(me.right);
                      if (typeof $e == "number" && typeof tr == "number") switch (me.operatorToken.kind) {
                        case 51:
                          return $e | tr;
                        case 50:
                          return $e & tr;
                        case 48:
                          return $e >> tr;
                        case 49:
                          return $e >>> tr;
                        case 47:
                          return $e << tr;
                        case 52:
                          return $e ^ tr;
                        case 41:
                          return $e * tr;
                        case 43:
                          return $e / tr;
                        case 39:
                          return $e + tr;
                        case 40:
                          return $e - tr;
                        case 44:
                          return $e % tr;
                        case 42:
                          return Math.pow($e, tr);
                      }
                      else if (typeof $e == "string" && typeof tr == "string" && me.operatorToken.kind === 39) return $e + tr;
                      break;
                    case 10:
                    case 14:
                      return me.text;
                    case 8:
                      return KS(me), +me.text;
                    case 212:
                      return h(me.expression);
                    case 79:
                      var dr = me;
                      return e.isInfinityOrNaNString(dr.escapedText) ? +dr.escapedText : e.nodeIsMissing(me) ? 0 : z2(me, Et(r.parent), dr.escapedText);
                    case 207:
                    case 206:
                      if (PS(me)) {
                        var Dr = Gs(me.expression);
                        if (Dr.symbol && Dr.symbol.flags & 384) {
                          var Qr = void 0;
                          return me.kind === 206 ? Qr = me.name.escapedText : Qr = e.escapeLeadingUnderscores(e.cast(me.argumentExpression, e.isLiteralExpression).text), z2(me, Dr.symbol, Qr);
                        }
                      }
                      break;
                  }
                }
                function z2(me, Me, $e) {
                  var tr = Me.exports.get($e);
                  if (tr) {
                    var dr = tr.valueDeclaration;
                    if (dr !== r) return dr && ns(dr, r) && e.isEnumDeclaration(dr.parent) ? H0(dr) : (Xr(me, e.Diagnostics.A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums), 0);
                    Xr(me, e.Diagnostics.Property_0_is_used_before_being_assigned, tn(tr));
                  }
                }
              }
              function PS(r) {
                var i = Gs(r);
                return i === Pe ? false : r.kind === 79 || r.kind === 206 && PS(r.expression) || r.kind === 207 && PS(r.expression) && e.isStringLiteralLike(r.argumentExpression);
              }
              function EM(r) {
                fe(function() {
                  return CM(r);
                });
              }
              function CM(r) {
                Ff(r), Sm(r, r.name), bv(r), r.members.forEach(kM), U6(r);
                var i = Et(r), t = e.getDeclarationOfKind(i, r.kind);
                if (r === t) {
                  if (i.declarations && i.declarations.length > 1) {
                    var o = e.isEnumConst(r);
                    e.forEach(i.declarations, function(u) {
                      e.isEnumDeclaration(u) && e.isEnumConst(u) !== o && Xr(e.getNameOfDeclaration(u), e.Diagnostics.Enum_declarations_must_all_be_const_or_non_const);
                    });
                  }
                  var s = false;
                  e.forEach(i.declarations, function(u) {
                    if (u.kind !== 260) return false;
                    var h = u;
                    if (!h.members.length) return false;
                    var z2 = h.members[0];
                    z2.initializer || (s ? Xr(z2.name, e.Diagnostics.In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element) : s = true);
                  });
                }
              }
              function kM(r) {
                e.isPrivateIdentifier(r.name) && Xr(r, e.Diagnostics.An_enum_member_cannot_be_named_with_a_private_identifier);
              }
              function AM(r) {
                var i = r.declarations;
                if (i) for (var t = 0, o = i; t < o.length; t++) {
                  var s = o[t];
                  if ((s.kind === 257 || s.kind === 256 && e.nodeIsPresent(s.body)) && !(s.flags & 16777216)) return s;
                }
              }
              function NM(r, i) {
                var t = e.getEnclosingBlockScopeContainer(r), o = e.getEnclosingBlockScopeContainer(i);
                return Cu(t) ? Cu(o) : Cu(o) ? false : t === o;
              }
              function PM(r) {
                r.body && (io(r.body), e.isGlobalScopeAugmentation(r) || A_(r)), fe(i);
                function i() {
                  var t = e.isGlobalScopeAugmentation(r), o = r.flags & 16777216;
                  t && !o && Xr(r.name, e.Diagnostics.Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context);
                  var s = e.isAmbientModule(r), u = s ? e.Diagnostics.An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file : e.Diagnostics.A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module;
                  if (!Uy(r, u)) {
                    Ff(r) || !o && r.name.kind === 10 && Tt(r.name, e.Diagnostics.Only_ambient_modules_can_use_quoted_names), e.isIdentifier(r.name) && Sm(r, r.name), bv(r);
                    var h = Et(r);
                    if (h.flags & 512 && !o && h.declarations && h.declarations.length > 1 && V(r, e.shouldPreserveConstEnums(ye))) {
                      var z2 = AM(h);
                      z2 && (e.getSourceFileOfNode(r) !== e.getSourceFileOfNode(z2) ? Xr(r.name, e.Diagnostics.A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged) : r.pos < z2.pos && Xr(r.name, e.Diagnostics.A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged));
                      var me = e.getDeclarationOfKind(h, 257);
                      me && NM(r, me) && (va(r).flags |= 32768);
                    }
                    if (s) if (e.isExternalModuleAugmentation(r)) {
                      var Me = t || Et(r).flags & 33554432;
                      if (Me && r.body) for (var $e = 0, tr = r.body.statements; $e < tr.length; $e++) {
                        var dr = tr[$e];
                        IS(dr, t);
                      }
                    } else Cu(r.parent) ? t ? Xr(r.name, e.Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations) : e.isExternalModuleNameRelative(e.getTextOfIdentifierOrLiteral(r.name)) && Xr(r.name, e.Diagnostics.Ambient_module_declaration_cannot_specify_relative_module_name) : t ? Xr(r.name, e.Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations) : Xr(r.name, e.Diagnostics.Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces);
                  }
                }
              }
              function IS(r, i) {
                var t;
                switch (r.kind) {
                  case 237:
                    for (var o = 0, s = r.declarationList.declarations; o < s.length; o++) {
                      var u = s[o];
                      IS(u, i);
                    }
                    break;
                  case 271:
                  case 272:
                    Hs(r, e.Diagnostics.Exports_and_export_assignments_are_not_permitted_in_module_augmentations);
                    break;
                  case 265:
                  case 266:
                    Hs(r, e.Diagnostics.Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module);
                    break;
                  case 203:
                  case 254:
                    var h = r.name;
                    if (e.isBindingPattern(h)) {
                      for (var z2 = 0, me = h.elements; z2 < me.length; z2++) {
                        var Me = me[z2];
                        IS(Me, i);
                      }
                      break;
                    }
                  case 257:
                  case 260:
                  case 256:
                  case 258:
                  case 261:
                  case 259:
                    if (i) return;
                    var $e = Et(r);
                    if ($e) {
                      var tr = !($e.flags & 33554432);
                      tr || (tr = !!(!((t = $e.parent) === null || t === void 0) && t.declarations) && e.isExternalModuleAugmentation($e.parent.declarations[0]));
                    }
                    break;
                }
              }
              function IM(r) {
                switch (r.kind) {
                  case 79:
                    return r;
                  case 161:
                    do
                      r = r.left;
                    while (r.kind !== 79);
                    return r;
                  case 206:
                    do {
                      if (e.isModuleExportsAccessExpression(r.expression) && !e.isPrivateIdentifier(r.name)) return r.name;
                      r = r.expression;
                    } while (r.kind !== 79);
                    return r;
                }
              }
              function wS(r) {
                var i = e.getExternalModuleName(r);
                if (!i || e.nodeIsMissing(i)) return false;
                if (!e.isStringLiteral(i)) return Xr(i, e.Diagnostics.String_literal_expected), false;
                var t = r.parent.kind === 262 && e.isAmbientModule(r.parent.parent);
                if (r.parent.kind !== 305 && !t) return Xr(i, r.kind === 272 ? e.Diagnostics.Export_declarations_are_not_permitted_in_a_namespace : e.Diagnostics.Import_declarations_in_a_namespace_cannot_reference_a_module), false;
                if (t && e.isExternalModuleNameRelative(i.text) && !Xu(r)) return Xr(r, e.Diagnostics.Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name), false;
                if (!e.isImportEqualsDeclaration(r) && r.assertClause) {
                  for (var o = false, s = 0, u = r.assertClause.elements; s < u.length; s++) {
                    var h = u[s];
                    e.isStringLiteral(h.value) || (o = true, Xr(h.value, e.Diagnostics.Import_assertion_values_must_be_string_literal_expressions));
                  }
                  return !o;
                }
                return true;
              }
              function j0(r) {
                var i = Et(r), t = Ps(i);
                if (t !== xe) {
                  i = so(i.exportSymbol || i);
                  var o = (i.flags & 1160127 ? 111551 : 0) | (i.flags & 788968 ? 788968 : 0) | (i.flags & 1920 ? 1920 : 0);
                  if (t.flags & o) {
                    var s = r.kind === 275 ? e.Diagnostics.Export_declaration_conflicts_with_exported_declaration_of_0 : e.Diagnostics.Import_declaration_conflicts_with_local_declaration_of_0;
                    Xr(r, s, tn(i));
                  }
                  if (ye.isolatedModules && !e.isTypeOnlyImportOrExportDeclaration(r) && !(r.flags & 16777216)) {
                    var u = vu(i), h = !(t.flags & 111551);
                    if (h || u) switch (r.kind) {
                      case 267:
                      case 270:
                      case 265: {
                        if (ye.preserveValueImports) {
                          e.Debug.assertIsDefined(r.name, "An ImportClause with a symbol should have a name");
                          var s = h ? e.Diagnostics._0_is_a_type_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled : e.Diagnostics._0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled, z2 = e.idText(r.kind === 270 && r.propertyName || r.name);
                          Jf(Xr(r, s, z2), h ? void 0 : u, z2);
                        }
                        h && r.kind === 265 && e.hasEffectiveModifier(r, 1) && Xr(r, e.Diagnostics.Cannot_use_export_import_on_a_type_or_type_only_namespace_when_the_isolatedModules_flag_is_provided);
                        break;
                      }
                      case 275:
                        if (e.getSourceFileOfNode(u) !== e.getSourceFileOfNode(r)) {
                          var s = h ? e.Diagnostics.Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type : e.Diagnostics._0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_isolatedModules_is_enabled, z2 = e.idText(r.propertyName || r.name);
                          Jf(Xr(r, s, z2), h ? void 0 : u, z2);
                          return;
                        }
                    }
                  }
                  if (e.isImportSpecifier(r)) {
                    var me = W6(i, r);
                    z6(me) && me.declarations && El(r, me.declarations, me.escapedName);
                  }
                }
              }
              function z6(r) {
                return !!r.declarations && e.every(r.declarations, function(i) {
                  return !!(e.getCombinedNodeFlags(i) & 268435456);
                });
              }
              function W6(r, i) {
                if (!(r.flags & 2097152)) return r;
                var t = Ps(r);
                if (t === xe) return t;
                for (; r.flags & 2097152; ) {
                  var o = wb(r);
                  if (o) {
                    if (o === t) break;
                    if (o.declarations && e.length(o.declarations)) if (z6(o)) {
                      El(i, o.declarations, o.escapedName);
                      break;
                    } else {
                      if (r === t) break;
                      r = o;
                    }
                  } else break;
                }
                return t;
              }
              function U0(r) {
                Sm(r, r.name), j0(r), r.kind === 270 && e.idText(r.propertyName || r.name) === "default" && e.getESModuleInterop(ye) && er !== e.ModuleKind.System && (er < e.ModuleKind.ES2015 || e.getSourceFileOfNode(r).impliedNodeFormat === e.ModuleKind.CommonJS) && fc(r, 131072);
              }
              function q6(r) {
                var i;
                if (r.assertClause) {
                  var t = e.isExclusivelyTypeOnlyImportOrExport(r), o = e.getResolutionModeOverrideForClause(r.assertClause, t ? Tt : void 0);
                  if (t && o) return e.isNightly() || Tt(r.assertClause, e.Diagnostics.Resolution_mode_assertions_are_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next), e.getEmitModuleResolutionKind(ye) !== e.ModuleResolutionKind.Node16 && e.getEmitModuleResolutionKind(ye) !== e.ModuleResolutionKind.NodeNext ? Tt(r.assertClause, e.Diagnostics.Resolution_modes_are_only_supported_when_moduleResolution_is_node16_or_nodenext) : void 0;
                  var s = er === e.ModuleKind.NodeNext && r.moduleSpecifier && hf(r.moduleSpecifier);
                  if (s !== e.ModuleKind.ESNext && er !== e.ModuleKind.ESNext) return Tt(r.assertClause, er === e.ModuleKind.NodeNext ? e.Diagnostics.Import_assertions_are_not_allowed_on_statements_that_transpile_to_commonjs_require_calls : e.Diagnostics.Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_or_nodenext);
                  if (e.isImportDeclaration(r) ? (i = r.importClause) === null || i === void 0 ? void 0 : i.isTypeOnly : r.isTypeOnly) return Tt(r.assertClause, e.Diagnostics.Import_assertions_cannot_be_used_with_type_only_imports_or_exports);
                  if (o) return Tt(r.assertClause, e.Diagnostics.resolution_mode_can_only_be_set_for_type_only_imports);
                }
              }
              function wM(r) {
                if (!Uy(r, e.isInJSFile(r) ? e.Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module : e.Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module)) {
                  if (!Ff(r) && e.hasEffectiveModifiers(r) && Hs(r, e.Diagnostics.An_import_declaration_cannot_have_modifiers), wS(r)) {
                    var i = r.importClause;
                    if (i && !EL(i) && (i.name && U0(i), i.namedBindings)) if (i.namedBindings.kind === 268) U0(i.namedBindings), er !== e.ModuleKind.System && (er < e.ModuleKind.ES2015 || e.getSourceFileOfNode(r).impliedNodeFormat === e.ModuleKind.CommonJS) && e.getESModuleInterop(ye) && fc(r, 65536);
                    else {
                      var t = ac(r, r.moduleSpecifier);
                      t && e.forEach(i.namedBindings.elements, U0);
                    }
                  }
                  q6(r);
                }
              }
              function OM(r) {
                if (!Uy(r, e.isInJSFile(r) ? e.Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module : e.Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module) && (Ff(r), e.isInternalModuleImportEqualsDeclaration(r) || wS(r))) if (U0(r), e.hasSyntacticModifier(r, 1) && Gt(r), r.moduleReference.kind !== 277) {
                  var i = Ps(Et(r));
                  if (i !== xe) {
                    if (i.flags & 111551) {
                      var t = e.getFirstIdentifier(r.moduleReference);
                      Ds(t, 112575).flags & 1920 || Xr(t, e.Diagnostics.Module_0_is_hidden_by_a_local_declaration_with_the_same_name, e.declarationNameToString(t));
                    }
                    i.flags & 788968 && Tm(r.name, e.Diagnostics.Import_name_cannot_be_0);
                  }
                  r.isTypeOnly && Tt(r, e.Diagnostics.An_import_alias_cannot_use_import_type);
                } else er >= e.ModuleKind.ES2015 && e.getSourceFileOfNode(r).impliedNodeFormat === void 0 && !r.isTypeOnly && !(r.flags & 16777216) && Tt(r, e.Diagnostics.Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead);
              }
              function FM(r) {
                if (!Uy(r, e.isInJSFile(r) ? e.Diagnostics.An_export_declaration_can_only_be_used_at_the_top_level_of_a_module : e.Diagnostics.An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module)) {
                  if (!Ff(r) && e.hasSyntacticModifiers(r) && Hs(r, e.Diagnostics.An_export_declaration_cannot_have_modifiers), r.moduleSpecifier && r.exportClause && e.isNamedExports(r.exportClause) && e.length(r.exportClause.elements) && Ae === 0 && fc(r, 4194304), MM(r), !r.moduleSpecifier || wS(r)) if (r.exportClause && !e.isNamespaceExport(r.exportClause)) {
                    e.forEach(r.exportClause.elements, UM);
                    var i = r.parent.kind === 262 && e.isAmbientModule(r.parent.parent), t = !i && r.parent.kind === 262 && !r.moduleSpecifier && r.flags & 16777216;
                    r.parent.kind !== 305 && !i && !t && Xr(r, e.Diagnostics.Export_declarations_are_not_permitted_in_a_namespace);
                  } else {
                    var o = ac(r, r.moduleSpecifier);
                    o && ll(o) ? Xr(r.moduleSpecifier, e.Diagnostics.Module_0_uses_export_and_cannot_be_used_with_export_Asterisk, tn(o)) : r.exportClause && j0(r.exportClause), er !== e.ModuleKind.System && (er < e.ModuleKind.ES2015 || e.getSourceFileOfNode(r).impliedNodeFormat === e.ModuleKind.CommonJS) && (r.exportClause ? e.getESModuleInterop(ye) && fc(r, 65536) : fc(r, 32768));
                  }
                  q6(r);
                }
              }
              function MM(r) {
                var i;
                return r.isTypeOnly ? ((i = r.exportClause) === null || i === void 0 ? void 0 : i.kind) === 273 ? DA(r.exportClause) : Tt(r, e.Diagnostics.Only_named_exports_may_use_export_type) : false;
              }
              function Uy(r, i) {
                var t = r.parent.kind === 305 || r.parent.kind === 262 || r.parent.kind === 261;
                return t || Hs(r, i), !t;
              }
              function LM(r) {
                return e.forEachImportClauseDeclaration(r, function(i) {
                  return !!Et(i).isReferenced;
                });
              }
              function RM(r) {
                return e.forEachImportClauseDeclaration(r, function(i) {
                  return !!Aa(Et(i)).constEnumReferenced;
                });
              }
              function BM(r) {
                return e.isImportDeclaration(r) && r.importClause && !r.importClause.isTypeOnly && LM(r.importClause) && !G0(r.importClause, true) && !RM(r.importClause);
              }
              function JM(r) {
                return e.isImportEqualsDeclaration(r) && e.isExternalModuleReference(r.moduleReference) && !r.isTypeOnly && Et(r).isReferenced && !G0(r, false) && !Aa(Et(r)).constEnumReferenced;
              }
              function jM(r) {
                for (var i = 0, t = r.statements; i < t.length; i++) {
                  var o = t[i];
                  (BM(o) || JM(o)) && Xr(o, e.Diagnostics.This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error);
                }
              }
              function UM(r) {
                if (j0(r), e.getEmitDeclarations(ye) && V_(r.propertyName || r.name, true), r.parent.parent.moduleSpecifier) e.getESModuleInterop(ye) && er !== e.ModuleKind.System && (er < e.ModuleKind.ES2015 || e.getSourceFileOfNode(r).impliedNodeFormat === e.ModuleKind.CommonJS) && e.idText(r.propertyName || r.name) === "default" && fc(r, 131072);
                else {
                  var i = r.propertyName || r.name, t = es(i, i.escapedText, 2998271, void 0, void 0, true);
                  if (t && (t === mi || t === pe || t.declarations && Cu(zi(t.declarations[0])))) Xr(i, e.Diagnostics.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module, e.idText(i));
                  else {
                    Gt(r);
                    var o = t && (t.flags & 2097152 ? Ps(t) : t);
                    (!o || o === xe || o.flags & 111551) && Os(r.propertyName || r.name);
                  }
                }
              }
              function zM(r) {
                var i = r.isExportEquals ? e.Diagnostics.An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration : e.Diagnostics.A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration;
                if (!Uy(r, i)) {
                  var t = r.parent.kind === 305 ? r.parent : r.parent.parent;
                  if (t.kind === 261 && !e.isAmbientModule(t)) {
                    r.isExportEquals ? Xr(r, e.Diagnostics.An_export_assignment_cannot_be_used_in_a_namespace) : Xr(r, e.Diagnostics.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);
                    return;
                  }
                  !Ff(r) && e.hasEffectiveModifiers(r) && Hs(r, e.Diagnostics.An_export_assignment_cannot_have_modifiers);
                  var o = e.getEffectiveTypeAnnotationNode(r);
                  if (o && zc(Os(r.expression), Va(o), r.expression), r.expression.kind === 79) {
                    var s = r.expression, u = Ds(s, 67108863, true, true, r);
                    if (u) {
                      o0(u, s);
                      var h = u.flags & 2097152 ? Ps(u) : u;
                      (h === xe || h.flags & 111551) && Os(r.expression);
                    } else Os(r.expression);
                    e.getEmitDeclarations(ye) && V_(r.expression, true);
                  } else Os(r.expression);
                  V6(t), r.flags & 16777216 && !e.isEntityNameExpression(r.expression) && Tt(r.expression, e.Diagnostics.The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context), r.isExportEquals && !(r.flags & 16777216) && (er >= e.ModuleKind.ES2015 && e.getSourceFileOfNode(r).impliedNodeFormat !== e.ModuleKind.CommonJS ? Tt(r, e.Diagnostics.Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead) : er === e.ModuleKind.System && Tt(r, e.Diagnostics.Export_assignment_is_not_supported_when_module_flag_is_system));
                }
              }
              function WM(r) {
                return e.forEachEntry(r.exports, function(i, t) {
                  return t !== "export=";
                });
              }
              function V6(r) {
                var i = Et(r), t = Aa(i);
                if (!t.exportsChecked) {
                  var o = i.exports.get("export=");
                  if (o && WM(i)) {
                    var s = ru(o) || o.valueDeclaration;
                    s && !Xu(s) && !e.isInJSFile(s) && Xr(s, e.Diagnostics.An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements);
                  }
                  var u = Pu(i);
                  u && u.forEach(function(h, z2) {
                    var me = h.declarations, Me = h.flags;
                    if (z2 !== "__export" && !(Me & 1920)) {
                      var $e = e.countWhere(me, e.and(O, e.not(e.isInterfaceDeclaration)));
                      if (!(Me & 524288 && $e <= 2) && $e > 1 && !z0(me)) for (var tr = 0, dr = me; tr < dr.length; tr++) {
                        var Dr = dr[tr];
                        k(Dr) && rn.add(e.createDiagnosticForNode(Dr, e.Diagnostics.Cannot_redeclare_exported_variable_0, e.unescapeLeadingUnderscores(z2)));
                      }
                    }
                  }), t.exportsChecked = true;
                }
              }
              function z0(r) {
                return r && r.length > 1 && r.every(function(i) {
                  return e.isInJSFile(i) && e.isAccessExpression(i) && (e.isExportsIdentifier(i.expression) || e.isModuleExportsAccessExpression(i.expression));
                });
              }
              function io(r) {
                if (r) {
                  var i = Ie;
                  Ie = r, Ee = 0, qM(r), Ie = i;
                }
              }
              function qM(r) {
                e.isInJSFile(r) && e.forEach(r.jsDoc, function(t) {
                  var o = t.tags;
                  return e.forEach(o, io);
                });
                var i = r.kind;
                if (g) switch (i) {
                  case 261:
                  case 257:
                  case 258:
                  case 256:
                    g.throwIfCancellationRequested();
                }
                switch (i >= 237 && i <= 253 && r.flowNode && !my(r.flowNode) && Ic(ye.allowUnreachableCode === false, r, e.Diagnostics.Unreachable_code_detected), i) {
                  case 163:
                    return $k(r);
                  case 164:
                    return Zk(r);
                  case 167:
                    return i6(r);
                  case 166:
                    return RO(r);
                  case 180:
                  case 179:
                  case 174:
                  case 175:
                  case 176:
                    return Dv(r);
                  case 169:
                  case 168:
                    return BO(r);
                  case 170:
                    return JO(r);
                  case 171:
                    return jO(r);
                  case 172:
                  case 173:
                    return a6(r);
                  case 178:
                    return vS(r);
                  case 177:
                    return OO(r);
                  case 181:
                    return qO(r);
                  case 182:
                    return VO(r);
                  case 183:
                    return KO(r);
                  case 184:
                    return GO(r);
                  case 187:
                  case 188:
                    return HO(r);
                  case 191:
                  case 185:
                  case 186:
                    return io(r.type);
                  case 192:
                    return $O(r);
                  case 193:
                    return ZO(r);
                  case 189:
                    return eF(r);
                  case 190:
                    return rF(r);
                  case 198:
                    return iF(r);
                  case 200:
                    return tF(r);
                  case 197:
                    return aF(r);
                  case 328:
                    return hF(r);
                  case 329:
                    return yF(r);
                  case 345:
                  case 338:
                  case 339:
                    return _F(r);
                  case 344:
                    return pF(r);
                  case 343:
                    return dF(r);
                  case 340:
                    return gF(r);
                  case 347:
                    return mF(r);
                  case 317:
                    vF(r);
                  case 315:
                  case 314:
                  case 312:
                  case 313:
                  case 322:
                    K6(r), e.forEachChild(r, io);
                    return;
                  case 318:
                    VM(r);
                    return;
                  case 309:
                    return io(r.type);
                  case 333:
                  case 335:
                  case 334:
                    return DF(r);
                  case 194:
                    return XO(r);
                  case 195:
                    return QO(r);
                  case 256:
                    return fF(r);
                  case 235:
                  case 262:
                    return M0(r);
                  case 237:
                    return LF(r);
                  case 238:
                    return RF(r);
                  case 239:
                    return BF(r);
                  case 240:
                    return UF(r);
                  case 241:
                    return zF(r);
                  case 242:
                    return WF(r);
                  case 243:
                    return VF(r);
                  case 244:
                    return qF(r);
                  case 245:
                  case 246:
                    return $F(r);
                  case 247:
                    return ZF(r);
                  case 248:
                    return eM(r);
                  case 249:
                    return rM(r);
                  case 250:
                    return iM(r);
                  case 251:
                    return tM(r);
                  case 252:
                    return aM(r);
                  case 254:
                    return SS(r);
                  case 203:
                    return MF(r);
                  case 257:
                    return fM(r);
                  case 258:
                    return bM(r);
                  case 259:
                    return SM(r);
                  case 260:
                    return EM(r);
                  case 261:
                    return PM(r);
                  case 266:
                    return wM(r);
                  case 265:
                    return OM(r);
                  case 272:
                    return FM(r);
                  case 271:
                    return zM(r);
                  case 236:
                  case 253:
                    Mf(r);
                    return;
                  case 276:
                    return zO(r);
                }
              }
              function K6(r) {
                e.isInJSFile(r) || Tt(r, e.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments);
              }
              function VM(r) {
                K6(r), io(r.type);
                var i = r.parent;
                if (e.isParameter(i) && e.isJSDocFunctionType(i.parent)) {
                  e.last(i.parent.parameters) !== i && Xr(r, e.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
                  return;
                }
                e.isJSDocTypeExpression(i) || Xr(r, e.Diagnostics.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);
                var t = r.parent.parent;
                if (!e.isJSDocParameterTag(t)) {
                  Xr(r, e.Diagnostics.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);
                  return;
                }
                var o = e.getParameterSymbolFromJSDoc(t);
                if (!!o) {
                  var s = e.getHostSignatureFromJSDoc(t);
                  (!s || e.last(s.parameters).symbol !== o) && Xr(r, e.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
                }
              }
              function KM(r) {
                var i = Va(r.type), t = r.parent, o = r.parent.parent;
                if (e.isJSDocTypeExpression(r.parent) && e.isJSDocParameterTag(o)) {
                  var s = e.getHostSignatureFromJSDoc(o), u = e.isJSDocCallbackTag(o.parent.parent);
                  if (s || u) {
                    var h = u ? e.lastOrUndefined(o.parent.parent.typeExpression.parameters) : e.lastOrUndefined(s.parameters), z2 = e.getParameterSymbolFromJSDoc(o);
                    if (!h || z2 && h.symbol === z2 && e.isRestParameter(h)) return Zs(i);
                  }
                }
                return e.isParameter(t) && e.isJSDocFunctionType(t.parent) ? Zs(i) : kc(i);
              }
              function xm(r) {
                var i = e.getSourceFileOfNode(r), t = va(i);
                t.flags & 1 || (t.deferredNodes || (t.deferredNodes = new e.Set()), t.deferredNodes.add(r));
              }
              function GM(r) {
                var i = va(r);
                i.deferredNodes && i.deferredNodes.forEach(HM);
              }
              function HM(r) {
                e.tracing === null || e.tracing === void 0 || e.tracing.push("check", "checkDeferredNode", { kind: r.kind, pos: r.pos, end: r.end, path: r.tracingPath });
                var i = Ie;
                switch (Ie = r, Ee = 0, r.kind) {
                  case 208:
                  case 209:
                  case 210:
                  case 165:
                  case 280:
                    Fg(r);
                    break;
                  case 213:
                  case 214:
                  case 169:
                  case 168:
                    Z7(r);
                    break;
                  case 172:
                  case 173:
                    a6(r);
                    break;
                  case 226:
                    lM(r);
                    break;
                  case 163:
                    wO(r);
                    break;
                  case 279:
                    k5(r);
                    break;
                  case 278:
                    N5(r);
                    break;
                }
                Ie = i, e.tracing === null || e.tracing === void 0 || e.tracing.pop();
              }
              function XM(r) {
                e.tracing === null || e.tracing === void 0 || e.tracing.push("check", "checkSourceFile", { path: r.path }, true), e.performance.mark("beforeCheck"), QM(r), e.performance.mark("afterCheck"), e.performance.measure("Check", "beforeCheck", "afterCheck"), e.tracing === null || e.tracing === void 0 || e.tracing.pop();
              }
              function G6(r, i) {
                if (i) return false;
                switch (r) {
                  case 0:
                    return !!ye.noUnusedLocals;
                  case 1:
                    return !!ye.noUnusedParameters;
                  default:
                    return e.Debug.assertNever(r);
                }
              }
              function H6(r) {
                return Fo.get(r.path) || e.emptyArray;
              }
              function QM(r) {
                var i = va(r);
                if (!(i.flags & 1)) {
                  if (e.skipTypeChecking(r, ye, l)) return;
                  DL(r), e.clear(Xt), e.clear(Za), e.clear(bn), e.clear(_a), e.forEach(r.statements, io), io(r.endOfFileToken), GM(r), e.isExternalOrCommonJsModule(r) && A_(r), fe(function() {
                    !r.isDeclarationFile && (ye.noUnusedLocals || ye.noUnusedParameters) && _6(H6(r), function(t, o, s) {
                      !e.containsParseError(t) && G6(o, !!(t.flags & 16777216)) && rn.add(s);
                    });
                  }), ye.importsNotUsedAsValues === 2 && !r.isDeclarationFile && e.isExternalModule(r) && jM(r), e.isExternalOrCommonJsModule(r) && V6(r), Xt.length && (e.forEach(Xt, CF), e.clear(Xt)), Za.length && (e.forEach(Za, kF), e.clear(Za)), bn.length && (e.forEach(bn, IF), e.clear(bn)), _a.length && (e.forEach(_a, OF), e.clear(_a)), i.flags |= 1;
                }
              }
              function X6(r, i) {
                try {
                  return g = i, YM(r);
                } finally {
                  g = void 0;
                }
              }
              function OS() {
                for (var r = 0, i = D; r < i.length; r++) {
                  var t = i[r];
                  t();
                }
                D = [];
              }
              function FS(r) {
                OS();
                var i = fe;
                fe = function(t) {
                  return t();
                }, XM(r), fe = i;
              }
              function YM(r) {
                if (r) {
                  OS();
                  var i = rn.getGlobalDiagnostics(), t = i.length;
                  FS(r);
                  var o = rn.getDiagnostics(r.fileName), s = rn.getGlobalDiagnostics();
                  if (s !== i) {
                    var u = e.relativeComplement(i, s, e.compareDiagnostics);
                    return e.concatenate(u, o);
                  } else if (t === 0 && s.length > 0) return e.concatenate(s, o);
                  return o;
                }
                return e.forEach(l.getSourceFiles(), FS), rn.getDiagnostics();
              }
              function $M() {
                return OS(), rn.getGlobalDiagnostics();
              }
              function ZM(r, i) {
                if (r.flags & 33554432) return [];
                var t = e.createSymbolTable(), o = false;
                return s(), t.delete("this"), Y_(t);
                function s() {
                  for (; r; ) {
                    switch (r.locals && !Cu(r) && h(r.locals, i), r.kind) {
                      case 305:
                        if (!e.isExternalModule(r)) break;
                      case 261:
                        z2(Et(r).exports, i & 2623475);
                        break;
                      case 260:
                        h(Et(r).exports, i & 8);
                        break;
                      case 226:
                        var me = r.name;
                        me && u(r.symbol, i);
                      case 257:
                      case 258:
                        o || h(Nf(Et(r)), i & 788968);
                        break;
                      case 213:
                        var Me = r.name;
                        Me && u(r.symbol, i);
                        break;
                    }
                    e.introducesArgumentsExoticObject(r) && u(or, i), o = e.isStatic(r), r = r.parent;
                  }
                  h(ii, i);
                }
                function u(me, Me) {
                  if (e.getCombinedLocalAndExportSymbolFlags(me) & Me) {
                    var $e = me.escapedName;
                    t.has($e) || t.set($e, me);
                  }
                }
                function h(me, Me) {
                  Me && me.forEach(function($e) {
                    u($e, Me);
                  });
                }
                function z2(me, Me) {
                  Me && me.forEach(function($e) {
                    !e.getDeclarationOfKind($e, 275) && !e.getDeclarationOfKind($e, 274) && u($e, Me);
                  });
                }
              }
              function e9(r) {
                return r.kind === 79 && zy(r.parent) && e.getNameOfDeclaration(r.parent) === r;
              }
              function zy(r) {
                switch (r.kind) {
                  case 163:
                  case 257:
                  case 258:
                  case 259:
                  case 260:
                  case 345:
                  case 338:
                  case 339:
                    return true;
                  case 267:
                    return r.isTypeOnly;
                  case 270:
                  case 275:
                    return r.parent.parent.isTypeOnly;
                  default:
                    return false;
                }
              }
              function Q6(r) {
                for (; r.parent.kind === 161; ) r = r.parent;
                return r.parent.kind === 178;
              }
              function r9(r) {
                for (; r.parent.kind === 206; ) r = r.parent;
                return r.parent.kind === 228;
              }
              function Y6(r, i) {
                for (var t; r = e.getContainingClass(r), !(!r || (t = i(r))); ) ;
                return t;
              }
              function i9(r) {
                return !!e.findAncestor(r, function(i) {
                  return e.isConstructorDeclaration(i) && e.nodeIsPresent(i.body) || e.isPropertyDeclaration(i) ? true : e.isClassLike(i) || e.isFunctionLikeDeclaration(i) ? "quit" : false;
                });
              }
              function MS(r, i) {
                return !!Y6(r, function(t) {
                  return t === i;
                });
              }
              function t9(r) {
                for (; r.parent.kind === 161; ) r = r.parent;
                if (r.parent.kind === 265) return r.parent.moduleReference === r ? r.parent : void 0;
                if (r.parent.kind === 271) return r.parent.expression === r ? r.parent : void 0;
              }
              function W0(r) {
                return t9(r) !== void 0;
              }
              function a9(r) {
                var i = e.getAssignmentDeclarationKind(r.parent.parent);
                switch (i) {
                  case 1:
                  case 3:
                    return Et(r.parent);
                  case 4:
                  case 2:
                  case 5:
                    return Et(r.parent.parent);
                }
              }
              function n9(r) {
                for (var i = r.parent; e.isQualifiedName(i); ) r = i, i = i.parent;
                if (i && i.kind === 200 && i.qualifier === r) return i;
              }
              function $6(r) {
                if (e.isDeclarationName(r)) return Et(r.parent);
                if (e.isInJSFile(r) && r.parent.kind === 206 && r.parent === r.parent.parent.left && !e.isPrivateIdentifier(r) && !e.isJSDocMemberName(r)) {
                  var i = a9(r);
                  if (i) return i;
                }
                if (r.parent.kind === 271 && e.isEntityNameExpression(r)) {
                  var t = Ds(r, 2998271, true);
                  if (t && t !== xe) return t;
                } else if (e.isEntityName(r) && W0(r)) {
                  var o = e.getAncestor(r, 265);
                  return e.Debug.assert(o !== void 0), Nl(r, true);
                }
                if (e.isEntityName(r)) {
                  var s = n9(r);
                  if (s) {
                    Va(s);
                    var u = va(r).resolvedSymbol;
                    return u === xe ? void 0 : u;
                  }
                }
                for (; e.isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName(r); ) r = r.parent;
                if (r9(r)) {
                  var h = 0;
                  r.parent.kind === 228 ? (h = 788968, e.isExpressionWithTypeArgumentsInClassExtendsClause(r.parent) && (h |= 111551)) : h = 1920, h |= 2097152;
                  var z2 = e.isEntityNameExpression(r) ? Ds(r, h) : void 0;
                  if (z2) return z2;
                }
                if (r.parent.kind === 340) return e.getParameterSymbolFromJSDoc(r.parent);
                if (r.parent.kind === 163 && r.parent.parent.kind === 344) {
                  e.Debug.assert(!e.isInJSFile(r));
                  var me = e.getTypeParameterFromJsDoc(r.parent);
                  return me && me.symbol;
                }
                if (e.isExpressionNode(r)) {
                  if (e.nodeIsMissing(r)) return;
                  var Me = e.findAncestor(r, e.or(e.isJSDocLinkLike, e.isJSDocNameReference, e.isJSDocMemberName)), h = Me ? 901119 : 111551;
                  if (r.kind === 79) {
                    if (e.isJSXTagName(r) && dm(r)) {
                      var $e = Fb(r.parent);
                      return $e === xe ? void 0 : $e;
                    }
                    var tr = Ds(r, h, false, true, e.getHostSignatureFromJSDoc(r));
                    if (!tr && Me) {
                      var dr = e.findAncestor(r, e.or(e.isClassLike, e.isInterfaceDeclaration));
                      if (dr) return q0(r, Et(dr));
                    }
                    return tr;
                  } else {
                    if (e.isPrivateIdentifier(r)) return m0(r);
                    if (r.kind === 206 || r.kind === 161) {
                      var Dr = va(r);
                      return Dr.resolvedSymbol ? Dr.resolvedSymbol : (r.kind === 206 ? VC(r, 0) : KC(r, 0), !Dr.resolvedSymbol && Me && e.isQualifiedName(r) ? q0(r) : Dr.resolvedSymbol);
                    } else if (e.isJSDocMemberName(r)) return q0(r);
                  }
                } else if (Q6(r)) {
                  var h = r.parent.kind === 178 ? 788968 : 1920, $e = Ds(r, h, false, true);
                  return $e && $e !== xe ? $e : yh(r);
                }
                if (r.parent.kind === 177) return Ds(r, 1);
              }
              function q0(r, i) {
                if (e.isEntityName(r)) {
                  var t = 901119, o = Ds(r, t, false, true, e.getHostSignatureFromJSDoc(r));
                  if (!o && e.isIdentifier(r) && i && (o = so(qs(dc(i), r.escapedText, t))), o) return o;
                }
                var s = e.isIdentifier(r) ? i : q0(r.left), u = e.isIdentifier(r) ? r.escapedText : r.right.escapedText;
                if (s) {
                  var h = s.flags & 111551 && bi(Jt(s), "prototype"), z2 = h ? Jt(h) : go(s);
                  return bi(z2, u);
                }
              }
              function el(r, i) {
                if (r.kind === 305) return e.isExternalModule(r) ? so(r.symbol) : void 0;
                var t = r.parent, o = t.parent;
                if (!(r.flags & 33554432)) {
                  if (Y(r)) {
                    var s = Et(t);
                    return e.isImportOrExportSpecifier(r.parent) && r.parent.propertyName === r ? wb(s) : s;
                  } else if (e.isLiteralComputedPropertyDeclarationName(r)) return Et(t.parent);
                  if (r.kind === 79) {
                    if (W0(r)) return $6(r);
                    if (t.kind === 203 && o.kind === 201 && r === t.propertyName) {
                      var u = Bd(o), h = bi(u, r.escapedText);
                      if (h) return h;
                    } else if (e.isMetaProperty(t) && t.name === r) return t.keywordToken === 103 && e.idText(r) === "target" ? tS(t).symbol : t.keywordToken === 100 && e.idText(r) === "meta" ? Tx().members.get("meta") : void 0;
                  }
                  switch (r.kind) {
                    case 79:
                    case 80:
                    case 206:
                    case 161:
                      if (!e.isThisInTypeQuery(r)) return $6(r);
                    case 108:
                      var z2 = e.getThisContainer(r, false);
                      if (e.isFunctionLike(z2)) {
                        var me = yl(z2);
                        if (me.thisParameter) return me.thisParameter;
                      }
                      if (e.isInExpressionContext(r)) return yn(r).symbol;
                    case 192:
                      return Ch(r).symbol;
                    case 106:
                      return yn(r).symbol;
                    case 134:
                      var Me = r.parent;
                      return Me && Me.kind === 171 ? Me.parent.symbol : void 0;
                    case 10:
                    case 14:
                      if (e.isExternalModuleImportEqualsDeclaration(r.parent.parent) && e.getExternalModuleImportEqualsDeclarationExpression(r.parent.parent) === r || (r.parent.kind === 266 || r.parent.kind === 272) && r.parent.moduleSpecifier === r || e.isInJSFile(r) && e.isRequireCall(r.parent, false) || e.isImportCall(r.parent) || e.isLiteralTypeNode(r.parent) && e.isLiteralImportTypeNode(r.parent.parent) && r.parent.parent.argument === r.parent) return ac(r, r, i);
                      if (e.isCallExpression(t) && e.isBindableObjectDefinePropertyCall(t) && t.arguments[1] === r) return Et(t);
                    case 8:
                      var $e = e.isElementAccessExpression(t) ? t.argumentExpression === r ? Gs(t.expression) : void 0 : e.isLiteralTypeNode(t) && e.isIndexedAccessTypeNode(o) ? Va(o.objectType) : void 0;
                      return $e && bi($e, e.escapeLeadingUnderscores(r.text));
                    case 88:
                    case 98:
                    case 38:
                    case 84:
                      return Et(r.parent);
                    case 200:
                      return e.isLiteralImportTypeNode(r) ? el(r.argument.literal, i) : void 0;
                    case 93:
                      return e.isExportAssignment(r.parent) ? e.Debug.checkDefined(r.parent.symbol) : void 0;
                    case 100:
                    case 103:
                      return e.isMetaProperty(r.parent) ? Ak(r.parent).symbol : void 0;
                    case 231:
                      return yn(r).symbol;
                    default:
                      return;
                  }
                }
              }
              function o9(r) {
                if (e.isIdentifier(r) && e.isPropertyAccessExpression(r.parent) && r.parent.name === r) {
                  var i = Z_(r), t = Gs(r.parent.expression), o = t.flags & 1048576 ? t.types : [t];
                  return e.flatMap(o, function(s) {
                    return e.filter(Hn(s), function(u) {
                      return an(i, u.keyType);
                    });
                  });
                }
              }
              function s9(r) {
                if (r && r.kind === 297) return Ds(r.name, 2208703);
              }
              function c9(r) {
                return e.isExportSpecifier(r) ? r.parent.parent.moduleSpecifier ? kl(r.parent.parent, r) : Ds(r.propertyName || r.name, 2998271) : Ds(r, 2998271);
              }
              function Bd(r) {
                if (e.isSourceFile(r) && !e.isExternalModule(r) || r.flags & 33554432) return Pe;
                var i = e.tryGetClassImplementingOrExtendingExpressionWithTypeArguments(r), t = i && aa(Et(i.class));
                if (e.isPartOfTypeNode(r)) {
                  var o = Va(r);
                  return t ? Rc(o, t.thisType) : o;
                }
                if (e.isExpressionNode(r)) return Z6(r);
                if (t && !i.isImplements) {
                  var s = e.firstOrUndefined(Qc(t));
                  return s ? Rc(s, t.thisType) : Pe;
                }
                if (zy(r)) {
                  var u = Et(r);
                  return go(u);
                }
                if (e9(r)) {
                  var u = el(r);
                  return u ? go(u) : Pe;
                }
                if (e.isDeclaration(r)) {
                  var u = Et(r);
                  return u ? Jt(u) : Pe;
                }
                if (Y(r)) {
                  var u = el(r);
                  return u ? Jt(u) : Pe;
                }
                if (e.isBindingPattern(r)) return G_(r.parent, true, 0) || Pe;
                if (W0(r)) {
                  var u = el(r);
                  if (u) {
                    var h = go(u);
                    return nn(h) ? Jt(u) : h;
                  }
                }
                return e.isMetaProperty(r.parent) && r.parent.keywordToken === r.kind ? Ak(r.parent) : Pe;
              }
              function V0(r) {
                if (e.Debug.assert(r.kind === 205 || r.kind === 204), r.parent.kind === 244) {
                  var i = By(r.parent);
                  return Rd(r, i || Pe);
                }
                if (r.parent.kind === 221) {
                  var i = Gs(r.parent.right);
                  return Rd(r, i || Pe);
                }
                if (r.parent.kind === 296) {
                  var t = e.cast(r.parent.parent, e.isObjectLiteralExpression), o = V0(t) || Pe, s = e.indexOfNode(t.properties, r.parent);
                  return Uk(t, o, s);
                }
                var u = e.cast(r.parent, e.isArrayLiteralExpression), h = V0(u) || Pe, z2 = N_(65, h, Tr, r.parent) || Pe;
                return zk(u, h, u.elements.indexOf(r), z2);
              }
              function u9(r) {
                var i = V0(e.cast(r.parent.parent, e.isAssignmentPattern));
                return i && bi(i, r.escapedText);
              }
              function Z6(r) {
                return e.isRightSideOfQualifiedNameOrPropertyAccess(r) && (r = r.parent), jc(Gs(r));
              }
              function l9(r) {
                var i = Et(r.parent);
                return e.isStatic(r) ? Jt(i) : go(i);
              }
              function f9(r) {
                var i = r.name;
                switch (i.kind) {
                  case 79:
                    return Bu(e.idText(i));
                  case 8:
                  case 10:
                    return Bu(i.text);
                  case 162:
                    var t = t_(i);
                    return Ns(t, 12288) ? t : Li;
                  default:
                    return e.Debug.fail("Unsupported property name.");
                }
              }
              function LS(r) {
                r = $s(r);
                var i = e.createSymbolTable(uo(r)), t = ot(r, 0).length ? Zr : ot(r, 1).length ? Si : void 0;
                return t && e.forEach(uo(t), function(o) {
                  i.has(o.escapedName) || i.set(o.escapedName, o);
                }), tf(i);
              }
              function RS(r) {
                return e.typeHasCallOrConstructSignatures(r, Di);
              }
              function eA(r) {
                var i = _9(r);
                return i ? e.flatMap(i, eA) : [r];
              }
              function _9(r) {
                if (e.getCheckFlags(r) & 6) return e.mapDefined(Aa(r).containingType.types, function(u) {
                  return bi(u, r.escapedName);
                });
                if (r.flags & 33554432) {
                  var i = r, t = i.leftSpread, o = i.rightSpread, s = i.syntheticOrigin;
                  return t ? [t, o] : s ? [s] : e.singleElementArray(p9(r));
                }
              }
              function p9(r) {
                for (var i, t = r; t = Aa(t).target; ) i = t;
                return i;
              }
              function d9(r) {
                if (e.isGeneratedIdentifier(r)) return false;
                var i = e.getParseTreeNode(r, e.isIdentifier);
                if (!i) return false;
                var t = i.parent;
                if (!t) return false;
                var o = (e.isPropertyAccessExpression(t) || e.isPropertyAssignment(t)) && t.name === i;
                return !o && Nv(i) === or;
              }
              function g9(r) {
                var i = ac(r.parent, r);
                if (!i || e.isShorthandAmbientModuleSymbol(i)) return true;
                var t = ll(i);
                i = Us(i);
                var o = Aa(i);
                return o.exportsSomeValue === void 0 && (o.exportsSomeValue = t ? !!(i.flags & 111551) : e.forEachEntry(Pu(i), s)), o.exportsSomeValue;
                function s(u) {
                  return u = os(u), u && !!(u.flags & 111551);
                }
              }
              function m9(r) {
                return e.isModuleOrEnumDeclaration(r.parent) && r === r.parent.name;
              }
              function v9(r, i) {
                var t, o = e.getParseTreeNode(r, e.isIdentifier);
                if (o) {
                  var s = Nv(o, m9(o));
                  if (s) {
                    if (s.flags & 1048576) {
                      var u = so(s.exportSymbol);
                      if (!i && u.flags & 944 && !(u.flags & 3)) return;
                      s = u;
                    }
                    var h = Ys(s);
                    if (h) {
                      if (h.flags & 512 && ((t = h.valueDeclaration) === null || t === void 0 ? void 0 : t.kind) === 305) {
                        var z2 = h.valueDeclaration, me = e.getSourceFileOfNode(o), Me = z2 !== me;
                        return Me ? void 0 : z2;
                      }
                      return e.findAncestor(o.parent, function($e) {
                        return e.isModuleOrEnumDeclaration($e) && Et($e) === h;
                      });
                    }
                  }
                }
              }
              function y9(r) {
                if (r.generatedImportReference) return r.generatedImportReference;
                var i = e.getParseTreeNode(r, e.isIdentifier);
                if (i) {
                  var t = Nv(i);
                  if (Zn(t, 111551) && !vu(t)) return ru(t);
                }
              }
              function h9(r) {
                return r.valueDeclaration && e.isBindingElement(r.valueDeclaration) && e.walkUpBindingElementsAndPatterns(r.valueDeclaration).parent.kind === 292;
              }
              function rA(r) {
                if (r.flags & 418 && r.valueDeclaration && !e.isSourceFile(r.valueDeclaration)) {
                  var i = Aa(r);
                  if (i.isDeclarationWithCollidingName === void 0) {
                    var t = e.getEnclosingBlockScopeContainer(r.valueDeclaration);
                    if (e.isStatementWithLocals(t) || h9(r)) {
                      var o = va(r.valueDeclaration);
                      if (es(t.parent, r.escapedName, 111551, void 0, void 0, false)) i.isDeclarationWithCollidingName = true;
                      else if (o.flags & 262144) {
                        var s = o.flags & 524288, u = e.isIterationStatement(t, false), h = t.kind === 235 && e.isIterationStatement(t.parent, false);
                        i.isDeclarationWithCollidingName = !e.isBlockScopedContainerTopLevel(t) && (!s || !u && !h);
                      } else i.isDeclarationWithCollidingName = false;
                    }
                  }
                  return i.isDeclarationWithCollidingName;
                }
                return false;
              }
              function D9(r) {
                if (!e.isGeneratedIdentifier(r)) {
                  var i = e.getParseTreeNode(r, e.isIdentifier);
                  if (i) {
                    var t = Nv(i);
                    if (t && rA(t)) return t.valueDeclaration;
                  }
                }
              }
              function b9(r) {
                var i = e.getParseTreeNode(r, e.isDeclaration);
                if (i) {
                  var t = Et(i);
                  if (t) return rA(t);
                }
                return false;
              }
              function iA(r) {
                switch (r.kind) {
                  case 265:
                    return K0(Et(r));
                  case 267:
                  case 268:
                  case 270:
                  case 275:
                    var i = Et(r);
                    return !!i && K0(i) && !vu(i);
                  case 272:
                    var t = r.exportClause;
                    return !!t && (e.isNamespaceExport(t) || e.some(t.elements, iA));
                  case 271:
                    return r.expression && r.expression.kind === 79 ? K0(Et(r)) : true;
                }
                return false;
              }
              function S9(r) {
                var i = e.getParseTreeNode(r, e.isImportEqualsDeclaration);
                if (i === void 0 || i.parent.kind !== 305 || !e.isInternalModuleImportEqualsDeclaration(i)) return false;
                var t = K0(Et(i));
                return t && i.moduleReference && !e.nodeIsMissing(i.moduleReference);
              }
              function K0(r) {
                if (!r) return false;
                var i = cu(Ps(r));
                return i === xe ? true : !!(i.flags & 111551) && (e.shouldPreserveConstEnums(ye) || !Av(i));
              }
              function Av(r) {
                return lS(r) || !!r.constEnumOnlyModule;
              }
              function G0(r, i) {
                if (yf(r)) {
                  var t = Et(r), o = t && Aa(t);
                  if (o != null && o.referenced) return true;
                  var s = Aa(t).aliasTarget;
                  if (s && e.getEffectiveModifierFlags(r) & 1 && s.flags & 111551 && (e.shouldPreserveConstEnums(ye) || !Av(s))) return true;
                }
                return i ? !!e.forEachChild(r, function(u) {
                  return G0(u, i);
                }) : false;
              }
              function tA(r) {
                if (e.nodeIsPresent(r.body)) {
                  if (e.isGetAccessor(r) || e.isSetAccessor(r)) return false;
                  var i = Et(r), t = S_(i);
                  return t.length > 1 || t.length === 1 && t[0].declaration !== r;
                }
                return false;
              }
              function aA(r) {
                return !!Ye && !kd(r) && !e.isJSDocParameterTag(r) && !!r.initializer && !e.hasSyntacticModifier(r, 16476);
              }
              function T9(r) {
                return Ye && kd(r) && !r.initializer && e.hasSyntacticModifier(r, 16476);
              }
              function x9(r) {
                var i = e.getParseTreeNode(r, e.isFunctionDeclaration);
                if (!i) return false;
                var t = Et(i);
                return !t || !(t.flags & 16) ? false : !!e.forEachEntry(dc(t), function(o) {
                  return o.flags & 111551 && o.valueDeclaration && e.isPropertyAccessExpression(o.valueDeclaration);
                });
              }
              function E9(r) {
                var i = e.getParseTreeNode(r, e.isFunctionDeclaration);
                if (!i) return e.emptyArray;
                var t = Et(i);
                return t && uo(Jt(t)) || e.emptyArray;
              }
              function Ug(r) {
                var i, t = r.id || 0;
                return t < 0 || t >= du.length ? 0 : ((i = du[t]) === null || i === void 0 ? void 0 : i.flags) || 0;
              }
              function H0(r) {
                return U6(r.parent), va(r).enumMemberValue;
              }
              function nA(r) {
                switch (r.kind) {
                  case 299:
                  case 206:
                  case 207:
                    return true;
                }
                return false;
              }
              function BS(r) {
                if (r.kind === 299) return H0(r);
                var i = va(r).resolvedSymbol;
                if (i && i.flags & 8) {
                  var t = i.valueDeclaration;
                  if (e.isEnumConst(t.parent)) return H0(t);
                }
              }
              function JS(r) {
                return !!(r.flags & 524288) && ot(r, 0).length > 0;
              }
              function C9(r, i) {
                var t, o, s = e.getParseTreeNode(r, e.isEntityName);
                if (!s || i && (i = e.getParseTreeNode(i), !i)) return e.TypeReferenceSerializationKind.Unknown;
                var u = false;
                if (e.isQualifiedName(s)) {
                  var h = Ds(e.getFirstIdentifier(s), 111551, true, true, i);
                  u = !!(!((t = h == null ? void 0 : h.declarations) === null || t === void 0) && t.every(e.isTypeOnlyImportOrExportDeclaration));
                }
                var z2 = Ds(s, 111551, true, true, i), me = z2 && z2.flags & 2097152 ? Ps(z2) : z2;
                u || (u = !!(!((o = z2 == null ? void 0 : z2.declarations) === null || o === void 0) && o.every(e.isTypeOnlyImportOrExportDeclaration)));
                var Me = Ds(s, 788968, true, false, i);
                if (me && me === Me) {
                  var $e = nD(false);
                  if ($e && me === $e) return e.TypeReferenceSerializationKind.Promise;
                  var tr = Jt(me);
                  if (tr && qd(tr)) return u ? e.TypeReferenceSerializationKind.TypeWithCallSignature : e.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue;
                }
                if (!Me) return u ? e.TypeReferenceSerializationKind.ObjectType : e.TypeReferenceSerializationKind.Unknown;
                var dr = go(Me);
                return nn(dr) ? u ? e.TypeReferenceSerializationKind.ObjectType : e.TypeReferenceSerializationKind.Unknown : dr.flags & 3 ? e.TypeReferenceSerializationKind.ObjectType : Ns(dr, 245760) ? e.TypeReferenceSerializationKind.VoidNullableOrNeverType : Ns(dr, 528) ? e.TypeReferenceSerializationKind.BooleanType : Ns(dr, 296) ? e.TypeReferenceSerializationKind.NumberLikeType : Ns(dr, 2112) ? e.TypeReferenceSerializationKind.BigIntLikeType : Ns(dr, 402653316) ? e.TypeReferenceSerializationKind.StringLikeType : Yn(dr) ? e.TypeReferenceSerializationKind.ArrayLikeType : Ns(dr, 12288) ? e.TypeReferenceSerializationKind.ESSymbolType : JS(dr) ? e.TypeReferenceSerializationKind.TypeWithCallSignature : Tu(dr) ? e.TypeReferenceSerializationKind.ArrayLikeType : e.TypeReferenceSerializationKind.ObjectType;
              }
              function k9(r, i, t, o, s) {
                var u = e.getParseTreeNode(r, e.isVariableLikeOrAccessor);
                if (!u) return e.factory.createToken(130);
                var h = Et(u), z2 = h && !(h.flags & 133120) ? Hp(Jt(h)) : Pe;
                return z2.flags & 8192 && z2.symbol === h && (t |= 1048576), s && (z2 = i_(z2)), Ur.typeToTypeNode(z2, i, t | 1024, o);
              }
              function A9(r, i, t, o) {
                var s = e.getParseTreeNode(r, e.isFunctionLike);
                if (!s) return e.factory.createToken(130);
                var u = yl(s);
                return Ur.typeToTypeNode(yo(u), i, t | 1024, o);
              }
              function N9(r, i, t, o) {
                var s = e.getParseTreeNode(r, e.isExpression);
                if (!s) return e.factory.createToken(130);
                var u = $c(Z6(s));
                return Ur.typeToTypeNode(u, i, t | 1024, o);
              }
              function P9(r) {
                return ii.has(e.escapeLeadingUnderscores(r));
              }
              function Nv(r, i) {
                var t = va(r).resolvedSymbol;
                if (t) return t;
                var o = r;
                if (i) {
                  var s = r.parent;
                  e.isDeclaration(s) && r === s.name && (o = zi(s));
                }
                return es(o, r.escapedText, 3257279, void 0, void 0, true);
              }
              function I9(r) {
                if (!e.isGeneratedIdentifier(r)) {
                  var i = e.getParseTreeNode(r, e.isIdentifier);
                  if (i) {
                    var t = Nv(i);
                    if (t) return cu(t).valueDeclaration;
                  }
                }
              }
              function w9(r) {
                return e.isDeclarationReadonly(r) || e.isVariableDeclaration(r) && e.isVarConst(r) ? Kp(Jt(Et(r))) : false;
              }
              function O9(r, i, t) {
                var o = r.flags & 1024 ? Ur.symbolToExpression(r.symbol, 111551, i, void 0, t) : r === Dt ? e.factory.createTrue() : r === xt && e.factory.createFalse();
                if (o) return o;
                var s = r.value;
                return typeof s == "object" ? e.factory.createBigIntLiteral(s) : typeof s == "number" ? e.factory.createNumericLiteral(s) : e.factory.createStringLiteral(s);
              }
              function F9(r, i) {
                var t = Jt(Et(r));
                return O9(t, r, i);
              }
              function oA(r) {
                return r ? (po(r), e.getSourceFileOfNode(r).localJsxFactory || Se) : Se;
              }
              function jS(r) {
                if (r) {
                  var i = e.getSourceFileOfNode(r);
                  if (i) {
                    if (i.localJsxFragmentFactory) return i.localJsxFragmentFactory;
                    var t = i.pragmas.get("jsxfrag"), o = e.isArray(t) ? t[0] : t;
                    if (o) return i.localJsxFragmentFactory = e.parseIsolatedEntityName(o.arguments.factory, Ae), i.localJsxFragmentFactory;
                  }
                }
                if (ye.jsxFragmentFactory) return e.parseIsolatedEntityName(ye.jsxFragmentFactory, Ae);
              }
              function M9() {
                var r = l.getResolvedTypeReferenceDirectives(), i;
                return r && (i = new e.Map(), r.forEach(function(me, Me, $e) {
                  if (!(!me || !me.resolvedFileName)) {
                    var tr = l.getSourceFile(me.resolvedFileName);
                    tr && z2(tr, Me, $e);
                  }
                })), { getReferencedExportContainer: v9, getReferencedImportDeclaration: y9, getReferencedDeclarationWithCollidingName: D9, isDeclarationWithCollidingName: b9, isValueAliasDeclaration: function(me) {
                  var Me = e.getParseTreeNode(me);
                  return Me ? iA(Me) : true;
                }, hasGlobalName: P9, isReferencedAliasDeclaration: function(me, Me) {
                  var $e = e.getParseTreeNode(me);
                  return $e ? G0($e, Me) : true;
                }, getNodeCheckFlags: function(me) {
                  var Me = e.getParseTreeNode(me);
                  return Me ? Ug(Me) : 0;
                }, isTopLevelValueImportEqualsWithEntityName: S9, isDeclarationVisible: wu, isImplementationOfOverload: tA, isRequiredInitializedParameter: aA, isOptionalUninitializedParameterProperty: T9, isExpandoFunctionDeclaration: x9, getPropertiesOfContainerFunction: E9, createTypeOfDeclaration: k9, createReturnTypeOfSignatureDeclaration: A9, createTypeOfExpression: N9, createLiteralConstValue: F9, isSymbolAccessible: g_, isEntityNameVisible: af, getConstantValue: function(me) {
                  var Me = e.getParseTreeNode(me, nA);
                  return Me ? BS(Me) : void 0;
                }, collectLinkedAliases: V_, getReferencedValueDeclaration: I9, getTypeReferenceSerializationKind: C9, isOptionalParameter: kd, moduleExportsSomeValue: g9, isArgumentsLocalBinding: d9, getExternalModuleFileFromDeclaration: function(me) {
                  var Me = e.getParseTreeNode(me, e.hasPossibleExternalModuleReference);
                  return Me && US(Me);
                }, getTypeReferenceDirectivesForEntityName: s, getTypeReferenceDirectivesForSymbol: u, isLiteralConstDeclaration: w9, isLateBound: function(me) {
                  var Me = e.getParseTreeNode(me, e.isDeclaration), $e = Me && Et(Me);
                  return !!($e && e.getCheckFlags($e) & 4096);
                }, getJsxFactoryEntity: oA, getJsxFragmentFactoryEntity: jS, getAllAccessorDeclarations: function(me) {
                  me = e.getParseTreeNode(me, e.isGetOrSetAccessorDeclaration);
                  var Me = me.kind === 173 ? 172 : 173, $e = e.getDeclarationOfKind(Et(me), Me), tr = $e && $e.pos < me.pos ? $e : me, dr = $e && $e.pos < me.pos ? me : $e, Dr = me.kind === 173 ? me : $e, Qr = me.kind === 172 ? me : $e;
                  return { firstAccessor: tr, secondAccessor: dr, setAccessor: Dr, getAccessor: Qr };
                }, getSymbolOfExternalModuleSpecifier: function(me) {
                  return Pl(me, me, void 0);
                }, isBindingCapturedByNode: function(me, Me) {
                  var $e = e.getParseTreeNode(me), tr = e.getParseTreeNode(Me);
                  return !!$e && !!tr && (e.isVariableDeclaration(tr) || e.isBindingElement(tr)) && U8($e, tr);
                }, getDeclarationStatementsForSourceFile: function(me, Me, $e, tr) {
                  var dr = e.getParseTreeNode(me);
                  e.Debug.assert(dr && dr.kind === 305, "Non-sourcefile node passed into getDeclarationsForSourceFile");
                  var Dr = Et(me);
                  return Dr ? Dr.exports ? Ur.symbolTableToDeclarationStatements(Dr.exports, me, Me, $e, tr) : [] : me.locals ? Ur.symbolTableToDeclarationStatements(me.locals, me, Me, $e, tr) : [];
                }, isImportRequiredByAugmentation: t };
                function t(me) {
                  var Me = e.getSourceFileOfNode(me);
                  if (!Me.symbol) return false;
                  var $e = US(me);
                  if (!$e || $e === Me) return false;
                  for (var tr = Pu(Me.symbol), dr = 0, Dr = e.arrayFrom(tr.values()); dr < Dr.length; dr++) {
                    var Qr = Dr[dr];
                    if (Qr.mergeId) {
                      var li = so(Qr);
                      if (li.declarations) for (var Ti = 0, Ci = li.declarations; Ti < Ci.length; Ti++) {
                        var $i = Ci[Ti], Zi = e.getSourceFileOfNode($i);
                        if (Zi === $e) return true;
                      }
                    }
                  }
                  return false;
                }
                function o(me) {
                  return me.parent && me.parent.kind === 228 && me.parent.parent && me.parent.parent.kind === 291;
                }
                function s(me) {
                  if (!!i) {
                    var Me = 790504;
                    (me.kind === 79 && _m(me) || me.kind === 206 && !o(me)) && (Me = 1160127);
                    var $e = Ds(me, Me, true);
                    return $e && $e !== xe ? u($e, Me) : void 0;
                  }
                }
                function u(me, Me) {
                  if (!(!i || !h(me))) {
                    for (var $e, tr = 0, dr = me.declarations; tr < dr.length; tr++) {
                      var Dr = dr[tr];
                      if (Dr.symbol && Dr.symbol.flags & Me) {
                        var Qr = e.getSourceFileOfNode(Dr), li = i.get(Qr.path);
                        if (li) ($e || ($e = [])).push(li);
                        else return;
                      }
                    }
                    return $e;
                  }
                }
                function h(me) {
                  if (!me.declarations) return false;
                  for (var Me = me; ; ) {
                    var $e = Ys(Me);
                    if ($e) Me = $e;
                    else break;
                  }
                  if (Me.valueDeclaration && Me.valueDeclaration.kind === 305 && Me.flags & 512) return false;
                  for (var tr = 0, dr = me.declarations; tr < dr.length; tr++) {
                    var Dr = dr[tr], Qr = e.getSourceFileOfNode(Dr);
                    if (i.has(Qr.path)) return true;
                  }
                  return false;
                }
                function z2(me, Me, $e) {
                  if (!i.has(me.path)) {
                    i.set(me.path, [Me, $e]);
                    for (var tr = 0, dr = me.referencedFiles; tr < dr.length; tr++) {
                      var Dr = dr[tr], Qr = Dr.fileName, li = Dr.resolutionMode, Ti = e.resolveTripleslashReference(Qr, me.fileName), Ci = l.getSourceFile(Ti);
                      Ci && z2(Ci, Me, li || me.impliedNodeFormat);
                    }
                  }
                }
              }
              function US(r) {
                var i = r.kind === 261 ? e.tryCast(r.name, e.isStringLiteral) : e.getExternalModuleName(r), t = Pl(i, i, void 0);
                if (!!t) return e.getDeclarationOfKind(t, 305);
              }
              function L9() {
                for (var r = 0, i = l.getSourceFiles(); r < i.length; r++) {
                  var t = i[r];
                  e.bindSourceFile(t, ye);
                }
                dn = new e.Map();
                for (var o, s = 0, u = l.getSourceFiles(); s < u.length; s++) {
                  var t = u[s];
                  if (!t.redirectInfo) {
                    if (!e.isExternalOrCommonJsModule(t)) {
                      var h = t.locals.get("globalThis");
                      if (h != null && h.declarations) for (var z2 = 0, me = h.declarations; z2 < me.length; z2++) {
                        var Me = me[z2];
                        rn.add(e.createDiagnosticForNode(Me, e.Diagnostics.Declaration_name_conflicts_with_built_in_global_identifier_0, "globalThis"));
                      }
                      gu(ii, t.locals);
                    }
                    if (t.jsGlobalAugmentations && gu(ii, t.jsGlobalAugmentations), t.patternAmbientModules && t.patternAmbientModules.length && (S = e.concatenate(S, t.patternAmbientModules)), t.moduleAugmentations.length && (o || (o = [])).push(t.moduleAugmentations), t.symbol && t.symbol.globalExports) {
                      var $e = t.symbol.globalExports;
                      $e.forEach(function(Ra, ca) {
                        ii.has(ca) || ii.set(ca, Ra);
                      });
                    }
                  }
                }
                if (o) for (var tr = 0, dr = o; tr < dr.length; tr++) for (var Dr = dr[tr], Qr = 0, li = Dr; Qr < li.length; Qr++) {
                  var Ti = li[Qr];
                  !e.isGlobalScopeAugmentation(Ti.parent) || Dp(Ti);
                }
                if (sd(ii, No, e.Diagnostics.Declaration_name_conflicts_with_built_in_global_identifier_0), Aa(mi).type = vi, Aa(or).type = lc("IArguments", 0, true), Aa(xe).type = Pe, Aa(pe).type = tu(16, pe), Pi = lc("Array", 1, true), qe = lc("Object", 0, true), br = lc("Function", 0, true), Zr = Er && lc("CallableFunction", 0, true) || br, Si = Er && lc("NewableFunction", 0, true) || br, Ct = lc("String", 0, true), sa = lc("Number", 0, true), en = lc("Boolean", 0, true), Wa = lc("RegExp", 0, true), mo = Zs(Oe), So = Zs(nr), So === Ba && (So = rs(void 0, we, e.emptyArray, e.emptyArray, e.emptyArray)), Qi = Nx("ReadonlyArray", 1) || Pi, Go = Qi ? $m(Qi, [Oe]) : mo, qn = Nx("ThisType", 1), o) for (var Ci = 0, $i = o; Ci < $i.length; Ci++) for (var Dr = $i[Ci], Zi = 0, qt = Dr; Zi < qt.length; Zi++) {
                  var Ti = qt[Zi];
                  e.isGlobalScopeAugmentation(Ti.parent) || Dp(Ti);
                }
                dn.forEach(function(Nt) {
                  var Ra = Nt.firstFile, ca = Nt.secondFile, Sn = Nt.conflictingSymbols;
                  if (Sn.size < 8) Sn.forEach(function(Fn, wn) {
                    for (var Tn = Fn.isBlockScoped, Eo = Fn.firstFileLocations, lt = Fn.secondFileLocations, it = Tn ? e.Diagnostics.Cannot_redeclare_block_scoped_variable_0 : e.Diagnostics.Duplicate_identifier_0, Yt = 0, Ia = Eo; Yt < Ia.length; Yt++) {
                      var Qt = Ia[Yt];
                      c_(Qt, it, wn, lt);
                    }
                    for (var Ka = 0, cn = lt; Ka < cn.length; Ka++) {
                      var Qt = cn[Ka];
                      c_(Qt, it, wn, Eo);
                    }
                  });
                  else {
                    var ja = e.arrayFrom(Sn.keys()).join(", ");
                    rn.add(e.addRelatedInfo(e.createDiagnosticForNode(Ra, e.Diagnostics.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0, ja), e.createDiagnosticForNode(ca, e.Diagnostics.Conflicts_are_in_this_file))), rn.add(e.addRelatedInfo(e.createDiagnosticForNode(ca, e.Diagnostics.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0, ja), e.createDiagnosticForNode(Ra, e.Diagnostics.Conflicts_are_in_this_file)));
                  }
                }), dn = void 0;
              }
              function fc(r, i) {
                if ((ne & i) !== i && ye.importHelpers) {
                  var t = e.getSourceFileOfNode(r);
                  if (e.isEffectiveExternalModule(t, ye) && !(r.flags & 16777216)) {
                    var o = B9(t, r);
                    if (o !== xe) {
                      for (var s = i & ~ne, u = 1; u <= 4194304; u <<= 1) if (s & u) {
                        var h = R9(u), z2 = qs(o.exports, e.escapeLeadingUnderscores(h), 111551);
                        z2 ? u & 524288 ? e.some(S_(z2), function(me) {
                          return Wc(me) > 3;
                        }) || Xr(r, e.Diagnostics.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0, e.externalHelpersModuleNameText, h, 4) : u & 1048576 ? e.some(S_(z2), function(me) {
                          return Wc(me) > 4;
                        }) || Xr(r, e.Diagnostics.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0, e.externalHelpersModuleNameText, h, 5) : u & 1024 && (e.some(S_(z2), function(me) {
                          return Wc(me) > 2;
                        }) || Xr(r, e.Diagnostics.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0, e.externalHelpersModuleNameText, h, 3)) : Xr(r, e.Diagnostics.This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_version_of_0, e.externalHelpersModuleNameText, h);
                      }
                    }
                    ne |= i;
                  }
                }
              }
              function R9(r) {
                switch (r) {
                  case 1:
                    return "__extends";
                  case 2:
                    return "__assign";
                  case 4:
                    return "__rest";
                  case 8:
                    return "__decorate";
                  case 16:
                    return "__metadata";
                  case 32:
                    return "__param";
                  case 64:
                    return "__awaiter";
                  case 128:
                    return "__generator";
                  case 256:
                    return "__values";
                  case 512:
                    return "__read";
                  case 1024:
                    return "__spreadArray";
                  case 2048:
                    return "__await";
                  case 4096:
                    return "__asyncGenerator";
                  case 8192:
                    return "__asyncDelegator";
                  case 16384:
                    return "__asyncValues";
                  case 32768:
                    return "__exportStar";
                  case 65536:
                    return "__importStar";
                  case 131072:
                    return "__importDefault";
                  case 262144:
                    return "__makeTemplateObject";
                  case 524288:
                    return "__classPrivateFieldGet";
                  case 1048576:
                    return "__classPrivateFieldSet";
                  case 2097152:
                    return "__classPrivateFieldIn";
                  case 4194304:
                    return "__createBinding";
                  default:
                    return e.Debug.fail("Unrecognized helper");
                }
              }
              function B9(r, i) {
                return ue || (ue = Il(r, e.externalHelpersModuleNameText, e.Diagnostics.This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found, i) || xe), ue;
              }
              function Ff(r) {
                return J9(r) || sA(r);
              }
              function J9(r) {
                if (!r.decorators) return false;
                if (e.nodeCanBeDecorated(r, r.parent, r.parent.parent)) {
                  if (r.kind === 172 || r.kind === 173) {
                    var i = e.getAllAccessorDeclarations(r.parent.members, r);
                    if (i.firstAccessor.decorators && r === i.secondAccessor) return Hs(r, e.Diagnostics.Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name);
                  }
                } else return r.kind === 169 && !e.nodeIsPresent(r.body) ? Hs(r, e.Diagnostics.A_decorator_can_only_decorate_a_method_implementation_not_an_overload) : Hs(r, e.Diagnostics.Decorators_are_not_valid_here);
                return false;
              }
              function sA(r) {
                var i = j9(r);
                if (i !== void 0) return i;
                for (var t, o, s, u, h = 0, z2 = 0, me = r.modifiers; z2 < me.length; z2++) {
                  var Me = me[z2];
                  if (Me.kind !== 145) {
                    if (r.kind === 166 || r.kind === 168) return Tt(Me, e.Diagnostics._0_modifier_cannot_appear_on_a_type_member, e.tokenToString(Me.kind));
                    if (r.kind === 176 && (Me.kind !== 124 || !e.isClassLike(r.parent))) return Tt(Me, e.Diagnostics._0_modifier_cannot_appear_on_an_index_signature, e.tokenToString(Me.kind));
                  }
                  if (Me.kind !== 101 && Me.kind !== 144 && r.kind === 163) return Tt(Me, e.Diagnostics._0_modifier_cannot_appear_on_a_type_parameter, e.tokenToString(Me.kind));
                  switch (Me.kind) {
                    case 85:
                      if (r.kind !== 260) return Tt(r, e.Diagnostics.A_class_member_cannot_have_the_0_keyword, e.tokenToString(85));
                      break;
                    case 159:
                      if (h & 16384) return Tt(Me, e.Diagnostics._0_modifier_already_seen, "override");
                      if (h & 2) return Tt(Me, e.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "override", "declare");
                      if (h & 64) return Tt(Me, e.Diagnostics._0_modifier_must_precede_1_modifier, "override", "readonly");
                      if (h & 256) return Tt(Me, e.Diagnostics._0_modifier_must_precede_1_modifier, "override", "async");
                      h |= 16384, u = Me;
                      break;
                    case 123:
                    case 122:
                    case 121:
                      var $e = v_(e.modifierToFlag(Me.kind));
                      if (h & 28) return Tt(Me, e.Diagnostics.Accessibility_modifier_already_seen);
                      if (h & 16384) return Tt(Me, e.Diagnostics._0_modifier_must_precede_1_modifier, $e, "override");
                      if (h & 32) return Tt(Me, e.Diagnostics._0_modifier_must_precede_1_modifier, $e, "static");
                      if (h & 64) return Tt(Me, e.Diagnostics._0_modifier_must_precede_1_modifier, $e, "readonly");
                      if (h & 256) return Tt(Me, e.Diagnostics._0_modifier_must_precede_1_modifier, $e, "async");
                      if (r.parent.kind === 262 || r.parent.kind === 305) return Tt(Me, e.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element, $e);
                      if (h & 128) return Me.kind === 121 ? Tt(Me, e.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, $e, "abstract") : Tt(Me, e.Diagnostics._0_modifier_must_precede_1_modifier, $e, "abstract");
                      if (e.isPrivateIdentifierClassElementDeclaration(r)) return Tt(Me, e.Diagnostics.An_accessibility_modifier_cannot_be_used_with_a_private_identifier);
                      h |= e.modifierToFlag(Me.kind);
                      break;
                    case 124:
                      if (h & 32) return Tt(Me, e.Diagnostics._0_modifier_already_seen, "static");
                      if (h & 64) return Tt(Me, e.Diagnostics._0_modifier_must_precede_1_modifier, "static", "readonly");
                      if (h & 256) return Tt(Me, e.Diagnostics._0_modifier_must_precede_1_modifier, "static", "async");
                      if (r.parent.kind === 262 || r.parent.kind === 305) return Tt(Me, e.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element, "static");
                      if (r.kind === 164) return Tt(Me, e.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "static");
                      if (h & 128) return Tt(Me, e.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "static", "abstract");
                      if (h & 16384) return Tt(Me, e.Diagnostics._0_modifier_must_precede_1_modifier, "static", "override");
                      h |= 32, t = Me;
                      break;
                    case 145:
                      if (h & 64) return Tt(Me, e.Diagnostics._0_modifier_already_seen, "readonly");
                      if (r.kind !== 167 && r.kind !== 166 && r.kind !== 176 && r.kind !== 164) return Tt(Me, e.Diagnostics.readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature);
                      h |= 64;
                      break;
                    case 93:
                      if (h & 1) return Tt(Me, e.Diagnostics._0_modifier_already_seen, "export");
                      if (h & 2) return Tt(Me, e.Diagnostics._0_modifier_must_precede_1_modifier, "export", "declare");
                      if (h & 128) return Tt(Me, e.Diagnostics._0_modifier_must_precede_1_modifier, "export", "abstract");
                      if (h & 256) return Tt(Me, e.Diagnostics._0_modifier_must_precede_1_modifier, "export", "async");
                      if (e.isClassLike(r.parent)) return Tt(Me, e.Diagnostics._0_modifier_cannot_appear_on_class_elements_of_this_kind, "export");
                      if (r.kind === 164) return Tt(Me, e.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "export");
                      h |= 1;
                      break;
                    case 88:
                      var tr = r.parent.kind === 305 ? r.parent : r.parent.parent;
                      if (tr.kind === 261 && !e.isAmbientModule(tr)) return Tt(Me, e.Diagnostics.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);
                      if (!(h & 1)) return Tt(Me, e.Diagnostics._0_modifier_must_precede_1_modifier, "export", "default");
                      h |= 512;
                      break;
                    case 135:
                      if (h & 2) return Tt(Me, e.Diagnostics._0_modifier_already_seen, "declare");
                      if (h & 256) return Tt(Me, e.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "async");
                      if (h & 16384) return Tt(Me, e.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "override");
                      if (e.isClassLike(r.parent) && !e.isPropertyDeclaration(r)) return Tt(Me, e.Diagnostics._0_modifier_cannot_appear_on_class_elements_of_this_kind, "declare");
                      if (r.kind === 164) return Tt(Me, e.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "declare");
                      if (r.parent.flags & 16777216 && r.parent.kind === 262) return Tt(Me, e.Diagnostics.A_declare_modifier_cannot_be_used_in_an_already_ambient_context);
                      if (e.isPrivateIdentifierClassElementDeclaration(r)) return Tt(Me, e.Diagnostics._0_modifier_cannot_be_used_with_a_private_identifier, "declare");
                      h |= 2, o = Me;
                      break;
                    case 126:
                      if (h & 128) return Tt(Me, e.Diagnostics._0_modifier_already_seen, "abstract");
                      if (r.kind !== 257 && r.kind !== 180) {
                        if (r.kind !== 169 && r.kind !== 167 && r.kind !== 172 && r.kind !== 173) return Tt(Me, e.Diagnostics.abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration);
                        if (!(r.parent.kind === 257 && e.hasSyntacticModifier(r.parent, 128))) return Tt(Me, e.Diagnostics.Abstract_methods_can_only_appear_within_an_abstract_class);
                        if (h & 32) return Tt(Me, e.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "static", "abstract");
                        if (h & 8) return Tt(Me, e.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "private", "abstract");
                        if (h & 256 && s) return Tt(s, e.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "async", "abstract");
                        if (h & 16384) return Tt(Me, e.Diagnostics._0_modifier_must_precede_1_modifier, "abstract", "override");
                      }
                      if (e.isNamedDeclaration(r) && r.name.kind === 80) return Tt(Me, e.Diagnostics._0_modifier_cannot_be_used_with_a_private_identifier, "abstract");
                      h |= 128;
                      break;
                    case 131:
                      if (h & 256) return Tt(Me, e.Diagnostics._0_modifier_already_seen, "async");
                      if (h & 2 || r.parent.flags & 16777216) return Tt(Me, e.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "async");
                      if (r.kind === 164) return Tt(Me, e.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "async");
                      if (h & 128) return Tt(Me, e.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "async", "abstract");
                      h |= 256, s = Me;
                      break;
                    case 101:
                    case 144:
                      var dr = Me.kind === 101 ? 32768 : 65536, Dr = Me.kind === 101 ? "in" : "out";
                      if (r.kind !== 163 || !(e.isInterfaceDeclaration(r.parent) || e.isClassLike(r.parent) || e.isTypeAliasDeclaration(r.parent))) return Tt(Me, e.Diagnostics._0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias, Dr);
                      if (h & dr) return Tt(Me, e.Diagnostics._0_modifier_already_seen, Dr);
                      if (dr & 32768 && h & 65536) return Tt(Me, e.Diagnostics._0_modifier_must_precede_1_modifier, "in", "out");
                      h |= dr;
                      break;
                  }
                }
                return r.kind === 171 ? h & 32 ? Tt(t, e.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "static") : h & 16384 ? Tt(u, e.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "override") : h & 256 ? Tt(s, e.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "async") : false : (r.kind === 266 || r.kind === 265) && h & 2 ? Tt(o, e.Diagnostics.A_0_modifier_cannot_be_used_with_an_import_declaration, "declare") : r.kind === 164 && h & 16476 && e.isBindingPattern(r.name) ? Tt(r, e.Diagnostics.A_parameter_property_may_not_be_declared_using_a_binding_pattern) : r.kind === 164 && h & 16476 && r.dotDotDotToken ? Tt(r, e.Diagnostics.A_parameter_property_cannot_be_declared_using_a_rest_parameter) : h & 256 ? z9(r, s) : false;
              }
              function j9(r) {
                return r.modifiers ? U9(r) ? Hs(r, e.Diagnostics.Modifiers_cannot_appear_here) : void 0 : false;
              }
              function U9(r) {
                switch (r.kind) {
                  case 172:
                  case 173:
                  case 171:
                  case 167:
                  case 166:
                  case 169:
                  case 168:
                  case 176:
                  case 261:
                  case 266:
                  case 265:
                  case 272:
                  case 271:
                  case 213:
                  case 214:
                  case 164:
                  case 163:
                    return false;
                  default:
                    if (r.parent.kind === 262 || r.parent.kind === 305) return false;
                    switch (r.kind) {
                      case 256:
                        return zS(r, 131);
                      case 257:
                      case 180:
                        return zS(r, 126);
                      case 258:
                      case 237:
                      case 259:
                      case 170:
                        return true;
                      case 260:
                        return zS(r, 85);
                      default:
                        e.Debug.fail();
                    }
                }
              }
              function zS(r, i) {
                return r.modifiers.length > 1 || r.modifiers[0].kind !== i;
              }
              function z9(r, i) {
                switch (r.kind) {
                  case 169:
                  case 256:
                  case 213:
                  case 214:
                    return false;
                }
                return Tt(i, e.Diagnostics._0_modifier_cannot_be_used_here, "async");
              }
              function ng(r, i) {
                return i === void 0 && (i = e.Diagnostics.Trailing_comma_not_allowed), r && r.hasTrailingComma ? rd(r[0], r.end - 1, 1, i) : false;
              }
              function cA(r, i) {
                if (r && r.length === 0) {
                  var t = r.pos - 1, o = e.skipTrivia(i.text, r.end) + 1;
                  return rd(i, t, o - t, e.Diagnostics.Type_parameter_list_cannot_be_empty);
                }
                return false;
              }
              function W9(r) {
                for (var i = false, t = r.length, o = 0; o < t; o++) {
                  var s = r[o];
                  if (s.dotDotDotToken) {
                    if (o !== t - 1) return Tt(s.dotDotDotToken, e.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
                    if (s.flags & 16777216 || ng(r, e.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma), s.questionToken) return Tt(s.questionToken, e.Diagnostics.A_rest_parameter_cannot_be_optional);
                    if (s.initializer) return Tt(s.name, e.Diagnostics.A_rest_parameter_cannot_have_an_initializer);
                  } else if (kd(s)) {
                    if (i = true, s.questionToken && s.initializer) return Tt(s.name, e.Diagnostics.Parameter_cannot_have_question_mark_and_initializer);
                  } else if (i && !s.initializer) return Tt(s.name, e.Diagnostics.A_required_parameter_cannot_follow_an_optional_parameter);
                }
              }
              function q9(r) {
                return e.filter(r, function(i) {
                  return !!i.initializer || e.isBindingPattern(i.name) || e.isRestParameter(i);
                });
              }
              function V9(r) {
                if (Ae >= 3) {
                  var i = r.body && e.isBlock(r.body) && e.findUseStrictPrologue(r.body.statements);
                  if (i) {
                    var t = q9(r.parameters);
                    if (e.length(t)) {
                      e.forEach(t, function(s) {
                        e.addRelatedInfo(Xr(s, e.Diagnostics.This_parameter_is_not_allowed_with_use_strict_directive), e.createDiagnosticForNode(i, e.Diagnostics.use_strict_directive_used_here));
                      });
                      var o = t.map(function(s, u) {
                        return u === 0 ? e.createDiagnosticForNode(s, e.Diagnostics.Non_simple_parameter_declared_here) : e.createDiagnosticForNode(s, e.Diagnostics.and_here);
                      });
                      return e.addRelatedInfo.apply(void 0, Ve([Xr(i, e.Diagnostics.use_strict_directive_cannot_be_used_with_non_simple_parameter_list)], o, false)), true;
                    }
                  }
                }
                return false;
              }
              function X0(r) {
                var i = e.getSourceFileOfNode(r);
                return Ff(r) || cA(r.typeParameters, i) || W9(r.parameters) || G9(r, i) || e.isFunctionLikeDeclaration(r) && V9(r);
              }
              function K9(r) {
                var i = e.getSourceFileOfNode(r);
                return $9(r) || cA(r.typeParameters, i);
              }
              function G9(r, i) {
                if (!e.isArrowFunction(r)) return false;
                r.typeParameters && !(e.length(r.typeParameters) > 1 || r.typeParameters.hasTrailingComma || r.typeParameters[0].constraint) && i && e.fileExtensionIsOneOf(i.fileName, [".mts", ".cts"]) && Tt(r.typeParameters[0], e.Diagnostics.This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_constraint);
                var t = r.equalsGreaterThanToken, o = e.getLineAndCharacterOfPosition(i, t.pos).line, s = e.getLineAndCharacterOfPosition(i, t.end).line;
                return o !== s && Tt(t, e.Diagnostics.Line_terminator_not_permitted_before_arrow);
              }
              function H9(r) {
                var i = r.parameters[0];
                if (r.parameters.length !== 1) return Tt(i ? i.name : r, e.Diagnostics.An_index_signature_must_have_exactly_one_parameter);
                if (ng(r.parameters, e.Diagnostics.An_index_signature_cannot_have_a_trailing_comma), i.dotDotDotToken) return Tt(i.dotDotDotToken, e.Diagnostics.An_index_signature_cannot_have_a_rest_parameter);
                if (e.hasEffectiveModifiers(i)) return Tt(i.name, e.Diagnostics.An_index_signature_parameter_cannot_have_an_accessibility_modifier);
                if (i.questionToken) return Tt(i.questionToken, e.Diagnostics.An_index_signature_parameter_cannot_have_a_question_mark);
                if (i.initializer) return Tt(i.name, e.Diagnostics.An_index_signature_parameter_cannot_have_an_initializer);
                if (!i.type) return Tt(i.name, e.Diagnostics.An_index_signature_parameter_must_have_a_type_annotation);
                var t = Va(i.type);
                return rg(t, function(o) {
                  return !!(o.flags & 8576);
                }) || rv(t) ? Tt(i.name, e.Diagnostics.An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead) : gf(t, vh) ? r.type ? false : Tt(r, e.Diagnostics.An_index_signature_must_have_a_type_annotation) : Tt(i.name, e.Diagnostics.An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type);
              }
              function X9(r) {
                return Ff(r) || H9(r);
              }
              function Q9(r, i) {
                if (i && i.length === 0) {
                  var t = e.getSourceFileOfNode(r), o = i.pos - 1, s = e.skipTrivia(t.text, i.end) + 1;
                  return rd(t, o, s - o, e.Diagnostics.Type_argument_list_cannot_be_empty);
                }
                return false;
              }
              function Wy(r, i) {
                return ng(i) || Q9(r, i);
              }
              function Y9(r) {
                return r.questionDotToken || r.flags & 32 ? Tt(r.template, e.Diagnostics.Tagged_template_expressions_are_not_permitted_in_an_optional_chain) : false;
              }
              function uA(r) {
                var i = r.types;
                if (ng(i)) return true;
                if (i && i.length === 0) {
                  var t = e.tokenToString(r.token);
                  return rd(r, i.pos, 0, e.Diagnostics._0_list_cannot_be_empty, t);
                }
                return e.some(i, lA);
              }
              function lA(r) {
                return e.isExpressionWithTypeArguments(r) && e.isImportKeyword(r.expression) && r.typeArguments ? Tt(r, e.Diagnostics.This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments) : Wy(r, r.typeArguments);
              }
              function $9(r) {
                var i = false, t = false;
                if (!Ff(r) && r.heritageClauses) for (var o = 0, s = r.heritageClauses; o < s.length; o++) {
                  var u = s[o];
                  if (u.token === 94) {
                    if (i) return Hs(u, e.Diagnostics.extends_clause_already_seen);
                    if (t) return Hs(u, e.Diagnostics.extends_clause_must_precede_implements_clause);
                    if (u.types.length > 1) return Hs(u.types[1], e.Diagnostics.Classes_can_only_extend_a_single_class);
                    i = true;
                  } else {
                    if (e.Debug.assert(u.token === 117), t) return Hs(u, e.Diagnostics.implements_clause_already_seen);
                    t = true;
                  }
                  uA(u);
                }
              }
              function Z9(r) {
                var i = false;
                if (r.heritageClauses) for (var t = 0, o = r.heritageClauses; t < o.length; t++) {
                  var s = o[t];
                  if (s.token === 94) {
                    if (i) return Hs(s, e.Diagnostics.extends_clause_already_seen);
                    i = true;
                  } else return e.Debug.assert(s.token === 117), Hs(s, e.Diagnostics.Interface_declaration_cannot_have_implements_clause);
                  uA(s);
                }
                return false;
              }
              function Q0(r) {
                if (r.kind !== 162) return false;
                var i = r;
                return i.expression.kind === 221 && i.expression.operatorToken.kind === 27 ? Tt(i.expression, e.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name) : false;
              }
              function WS(r) {
                if (r.asteriskToken) {
                  if (e.Debug.assert(r.kind === 256 || r.kind === 213 || r.kind === 169), r.flags & 16777216) return Tt(r.asteriskToken, e.Diagnostics.Generators_are_not_allowed_in_an_ambient_context);
                  if (!r.body) return Tt(r.asteriskToken, e.Diagnostics.An_overload_signature_cannot_be_declared_as_a_generator);
                }
              }
              function fA(r, i) {
                return !!r && Tt(r, i);
              }
              function _A(r, i) {
                return !!r && Tt(r, i);
              }
              function eL(r, i) {
                for (var t = new e.Map(), o = 0, s = r.properties; o < s.length; o++) {
                  var u = s[o];
                  if (u.kind === 298) {
                    if (i) {
                      var h = e.skipParentheses(u.expression);
                      if (e.isArrayLiteralExpression(h) || e.isObjectLiteralExpression(h)) return Tt(u.expression, e.Diagnostics.A_rest_element_cannot_contain_a_binding_pattern);
                    }
                    continue;
                  }
                  var z2 = u.name;
                  if (z2.kind === 162 && Q0(z2), u.kind === 297 && !i && u.objectAssignmentInitializer && Tt(u.equalsToken, e.Diagnostics.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern), z2.kind === 80 && Tt(z2, e.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies), u.modifiers) for (var me = 0, Me = u.modifiers; me < Me.length; me++) {
                    var $e = Me[me];
                    ($e.kind !== 131 || u.kind !== 169) && Tt($e, e.Diagnostics._0_modifier_cannot_be_used_here, e.getTextOfNode($e));
                  }
                  var tr = void 0;
                  switch (u.kind) {
                    case 297:
                      _A(u.exclamationToken, e.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context);
                    case 296:
                      fA(u.questionToken, e.Diagnostics.An_object_member_cannot_be_declared_optional), z2.kind === 8 && KS(z2), tr = 4;
                      break;
                    case 169:
                      tr = 8;
                      break;
                    case 172:
                      tr = 1;
                      break;
                    case 173:
                      tr = 2;
                      break;
                    default:
                      throw e.Debug.assertNever(u, "Unexpected syntax kind:" + u.kind);
                  }
                  if (!i) {
                    var dr = e.getPropertyNameForPropertyNameNode(z2);
                    if (dr === void 0) continue;
                    var Dr = t.get(dr);
                    if (!Dr) t.set(dr, tr);
                    else if (tr & 8 && Dr & 8) Tt(z2, e.Diagnostics.Duplicate_identifier_0, e.getTextOfNode(z2));
                    else if (tr & 4 && Dr & 4) Tt(z2, e.Diagnostics.An_object_literal_cannot_have_multiple_properties_with_the_same_name, e.getTextOfNode(z2));
                    else if (tr & 3 && Dr & 3) if (Dr !== 3 && tr !== Dr) t.set(dr, tr | Dr);
                    else return Tt(z2, e.Diagnostics.An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name);
                    else return Tt(z2, e.Diagnostics.An_object_literal_cannot_have_property_and_accessor_with_the_same_name);
                  }
                }
              }
              function rL(r) {
                iL(r.tagName), Wy(r, r.typeArguments);
                for (var i = new e.Map(), t = 0, o = r.attributes.properties; t < o.length; t++) {
                  var s = o[t];
                  if (s.kind !== 287) {
                    var u = s.name, h = s.initializer;
                    if (!i.get(u.escapedText)) i.set(u.escapedText, true);
                    else return Tt(u, e.Diagnostics.JSX_elements_cannot_have_multiple_attributes_with_the_same_name);
                    if (h && h.kind === 288 && !h.expression) return Tt(h, e.Diagnostics.JSX_attributes_must_only_be_assigned_a_non_empty_expression);
                  }
                }
              }
              function iL(r) {
                if (e.isPropertyAccessExpression(r)) {
                  var i = r;
                  do {
                    var t = s(i.name);
                    if (t) return t;
                    i = i.expression;
                  } while (e.isPropertyAccessExpression(i));
                  var o = s(i);
                  if (o) return o;
                }
                function s(u) {
                  if (e.isIdentifier(u) && e.idText(u).indexOf(":") !== -1) return Tt(u, e.Diagnostics.JSX_property_access_expressions_cannot_include_JSX_namespace_names);
                }
              }
              function tL(r) {
                if (r.expression && e.isCommaSequence(r.expression)) return Tt(r.expression, e.Diagnostics.JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array);
              }
              function pA(r) {
                if (Mf(r)) return true;
                if (r.kind === 244 && r.awaitModifier && !(r.flags & 32768)) {
                  var i = e.getSourceFileOfNode(r);
                  if (e.isInTopLevelContext(r)) {
                    if (!Jd(i)) switch (e.isEffectiveExternalModule(i, ye) || rn.add(e.createDiagnosticForNode(r.awaitModifier, e.Diagnostics.for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module)), er) {
                      case e.ModuleKind.Node16:
                      case e.ModuleKind.NodeNext:
                        if (i.impliedNodeFormat === e.ModuleKind.CommonJS) {
                          rn.add(e.createDiagnosticForNode(r.awaitModifier, e.Diagnostics.The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level));
                          break;
                        }
                      case e.ModuleKind.ES2022:
                      case e.ModuleKind.ESNext:
                      case e.ModuleKind.System:
                        if (Ae >= 4) break;
                      default:
                        rn.add(e.createDiagnosticForNode(r.awaitModifier, e.Diagnostics.Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher));
                        break;
                    }
                  } else if (!Jd(i)) {
                    var t = e.createDiagnosticForNode(r.awaitModifier, e.Diagnostics.for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules), o = e.getContainingFunction(r);
                    if (o && o.kind !== 171) {
                      e.Debug.assert((e.getFunctionFlags(o) & 2) === 0, "Enclosing function should never be an async function.");
                      var s = e.createDiagnosticForNode(o, e.Diagnostics.Did_you_mean_to_mark_this_function_as_async);
                      e.addRelatedInfo(t, s);
                    }
                    return rn.add(t), true;
                  }
                  return false;
                }
                if (e.isForOfStatement(r) && !(r.flags & 32768) && e.isIdentifier(r.initializer) && r.initializer.escapedText === "async") return Tt(r.initializer, e.Diagnostics.The_left_hand_side_of_a_for_of_statement_may_not_be_async), false;
                if (r.initializer.kind === 255) {
                  var u = r.initializer;
                  if (!VS(u)) {
                    var h = u.declarations;
                    if (!h.length) return false;
                    if (h.length > 1) {
                      var t = r.kind === 243 ? e.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement : e.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement;
                      return Hs(u.declarations[1], t);
                    }
                    var z2 = h[0];
                    if (z2.initializer) {
                      var t = r.kind === 243 ? e.Diagnostics.The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer : e.Diagnostics.The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer;
                      return Tt(z2.name, t);
                    }
                    if (z2.type) {
                      var t = r.kind === 243 ? e.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation : e.Diagnostics.The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation;
                      return Tt(z2, t);
                    }
                  }
                }
                return false;
              }
              function aL(r) {
                if (!(r.flags & 16777216) && r.parent.kind !== 182 && r.parent.kind !== 258) {
                  if (Ae < 1) return Tt(r.name, e.Diagnostics.Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher);
                  if (Ae < 2 && e.isPrivateIdentifier(r.name)) return Tt(r.name, e.Diagnostics.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);
                  if (r.body === void 0 && !e.hasSyntacticModifier(r, 128)) return rd(r, r.end - 1, 1, e.Diagnostics._0_expected, "{");
                }
                if (r.body) {
                  if (e.hasSyntacticModifier(r, 128)) return Tt(r, e.Diagnostics.An_abstract_accessor_cannot_have_an_implementation);
                  if (r.parent.kind === 182 || r.parent.kind === 258) return Tt(r.body, e.Diagnostics.An_implementation_cannot_be_declared_in_ambient_contexts);
                }
                if (r.typeParameters) return Tt(r.name, e.Diagnostics.An_accessor_cannot_have_type_parameters);
                if (!nL(r)) return Tt(r.name, r.kind === 172 ? e.Diagnostics.A_get_accessor_cannot_have_parameters : e.Diagnostics.A_set_accessor_must_have_exactly_one_parameter);
                if (r.kind === 173) {
                  if (r.type) return Tt(r.name, e.Diagnostics.A_set_accessor_cannot_have_a_return_type_annotation);
                  var i = e.Debug.checkDefined(e.getSetAccessorValueParameter(r), "Return value does not match parameter count assertion.");
                  if (i.dotDotDotToken) return Tt(i.dotDotDotToken, e.Diagnostics.A_set_accessor_cannot_have_rest_parameter);
                  if (i.questionToken) return Tt(i.questionToken, e.Diagnostics.A_set_accessor_cannot_have_an_optional_parameter);
                  if (i.initializer) return Tt(r.name, e.Diagnostics.A_set_accessor_parameter_cannot_have_an_initializer);
                }
                return false;
              }
              function nL(r) {
                return qS(r) || r.parameters.length === (r.kind === 172 ? 0 : 1);
              }
              function qS(r) {
                if (r.parameters.length === (r.kind === 172 ? 1 : 2)) return e.getThisParameter(r);
              }
              function oL(r) {
                if (r.operator === 154) {
                  if (r.type.kind !== 151) return Tt(r.type, e.Diagnostics._0_expected, e.tokenToString(151));
                  var i = e.walkUpParenthesizedTypes(r.parent);
                  if (e.isInJSFile(i) && e.isJSDocTypeExpression(i)) {
                    var t = e.getJSDocHost(i);
                    t && (i = e.getSingleVariableOfVariableStatement(t) || t);
                  }
                  switch (i.kind) {
                    case 254:
                      var o = i;
                      if (o.name.kind !== 79) return Tt(r, e.Diagnostics.unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name);
                      if (!e.isVariableDeclarationInVariableStatement(o)) return Tt(r, e.Diagnostics.unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement);
                      if (!(o.parent.flags & 2)) return Tt(i.name, e.Diagnostics.A_variable_whose_type_is_a_unique_symbol_type_must_be_const);
                      break;
                    case 167:
                      if (!e.isStatic(i) || !e.hasEffectiveReadonlyModifier(i)) return Tt(i.name, e.Diagnostics.A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly);
                      break;
                    case 166:
                      if (!e.hasSyntacticModifier(i, 64)) return Tt(i.name, e.Diagnostics.A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly);
                      break;
                    default:
                      return Tt(r, e.Diagnostics.unique_symbol_types_are_not_allowed_here);
                  }
                } else if (r.operator === 145 && r.type.kind !== 183 && r.type.kind !== 184) return Hs(r, e.Diagnostics.readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types, e.tokenToString(151));
              }
              function Em(r, i) {
                if (I1(r)) return Tt(r, i);
              }
              function dA(r) {
                if (X0(r)) return true;
                if (r.kind === 169) {
                  if (r.parent.kind === 205) {
                    if (r.modifiers && !(r.modifiers.length === 1 && e.first(r.modifiers).kind === 131)) return Hs(r, e.Diagnostics.Modifiers_cannot_appear_here);
                    if (fA(r.questionToken, e.Diagnostics.An_object_member_cannot_be_declared_optional)) return true;
                    if (_A(r.exclamationToken, e.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context)) return true;
                    if (r.body === void 0) return rd(r, r.end - 1, 1, e.Diagnostics._0_expected, "{");
                  }
                  if (WS(r)) return true;
                }
                if (e.isClassLike(r.parent)) {
                  if (Ae < 2 && e.isPrivateIdentifier(r.name)) return Tt(r.name, e.Diagnostics.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);
                  if (r.flags & 16777216) return Em(r.name, e.Diagnostics.A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
                  if (r.kind === 169 && !r.body) return Em(r.name, e.Diagnostics.A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
                } else {
                  if (r.parent.kind === 258) return Em(r.name, e.Diagnostics.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
                  if (r.parent.kind === 182) return Em(r.name, e.Diagnostics.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
                }
              }
              function sL(r) {
                for (var i = r; i; ) {
                  if (e.isFunctionLikeOrClassStaticBlockDeclaration(i)) return Tt(r, e.Diagnostics.Jump_target_cannot_cross_function_boundary);
                  switch (i.kind) {
                    case 250:
                      if (r.label && i.label.escapedText === r.label.escapedText) {
                        var t = r.kind === 245 && !e.isIterationStatement(i.statement, true);
                        return t ? Tt(r, e.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement) : false;
                      }
                      break;
                    case 249:
                      if (r.kind === 246 && !r.label) return false;
                      break;
                    default:
                      if (e.isIterationStatement(i, false) && !r.label) return false;
                      break;
                  }
                  i = i.parent;
                }
                if (r.label) {
                  var o = r.kind === 246 ? e.Diagnostics.A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement : e.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement;
                  return Tt(r, o);
                } else {
                  var o = r.kind === 246 ? e.Diagnostics.A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement : e.Diagnostics.A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement;
                  return Tt(r, o);
                }
              }
              function cL(r) {
                if (r.dotDotDotToken) {
                  var i = r.parent.elements;
                  if (r !== e.last(i)) return Tt(r, e.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
                  if (ng(i, e.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma), r.propertyName) return Tt(r.name, e.Diagnostics.A_rest_element_cannot_have_a_property_name);
                }
                if (r.dotDotDotToken && r.initializer) return rd(r, r.initializer.pos - 1, 1, e.Diagnostics.A_rest_element_cannot_have_an_initializer);
              }
              function gA(r) {
                return e.isStringOrNumericLiteralLike(r) || r.kind === 219 && r.operator === 40 && r.operand.kind === 8;
              }
              function uL(r) {
                return r.kind === 9 || r.kind === 219 && r.operator === 40 && r.operand.kind === 9;
              }
              function lL(r) {
                if ((e.isPropertyAccessExpression(r) || e.isElementAccessExpression(r) && gA(r.argumentExpression)) && e.isEntityNameExpression(r.expression)) return !!(Os(r).flags & 1024);
              }
              function mA(r) {
                var i = r.initializer;
                if (i) {
                  var t = !(gA(i) || lL(i) || i.kind === 110 || i.kind === 95 || uL(i)), o = e.isDeclarationReadonly(r) || e.isVariableDeclaration(r) && e.isVarConst(r);
                  if (o && !r.type) {
                    if (t) return Tt(i, e.Diagnostics.A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference);
                  } else return Tt(i, e.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts);
                  if (!o || t) return Tt(i, e.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts);
                }
              }
              function fL(r) {
                if (r.parent.parent.kind !== 243 && r.parent.parent.kind !== 244) {
                  if (r.flags & 16777216) mA(r);
                  else if (!r.initializer) {
                    if (e.isBindingPattern(r.name) && !e.isBindingPattern(r.parent)) return Tt(r, e.Diagnostics.A_destructuring_declaration_must_have_an_initializer);
                    if (e.isVarConst(r)) return Tt(r, e.Diagnostics.const_declarations_must_be_initialized);
                  }
                }
                if (r.exclamationToken && (r.parent.parent.kind !== 237 || !r.type || r.initializer || r.flags & 16777216)) {
                  var i = r.initializer ? e.Diagnostics.Declarations_with_initializers_cannot_also_have_definite_assignment_assertions : r.type ? e.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context : e.Diagnostics.Declarations_with_definite_assignment_assertions_must_also_have_type_annotations;
                  return Tt(r.exclamationToken, i);
                }
                (er < e.ModuleKind.ES2015 || e.getSourceFileOfNode(r).impliedNodeFormat === e.ModuleKind.CommonJS) && er !== e.ModuleKind.System && !(r.parent.parent.flags & 16777216) && e.hasSyntacticModifier(r.parent.parent, 1) && vA(r.name);
                var t = e.isLet(r) || e.isVarConst(r);
                return t && yA(r.name);
              }
              function vA(r) {
                if (r.kind === 79) {
                  if (e.idText(r) === "__esModule") return dL("noEmit", r, e.Diagnostics.Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules);
                } else for (var i = r.elements, t = 0, o = i; t < o.length; t++) {
                  var s = o[t];
                  if (!e.isOmittedExpression(s)) return vA(s.name);
                }
                return false;
              }
              function yA(r) {
                if (r.kind === 79) {
                  if (r.originalKeywordKind === 119) return Tt(r, e.Diagnostics.let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations);
                } else for (var i = r.elements, t = 0, o = i; t < o.length; t++) {
                  var s = o[t];
                  e.isOmittedExpression(s) || yA(s.name);
                }
                return false;
              }
              function VS(r) {
                var i = r.declarations;
                return ng(r.declarations) ? true : r.declarations.length ? false : rd(r, i.pos, i.end - i.pos, e.Diagnostics.Variable_declaration_list_cannot_be_empty);
              }
              function hA(r) {
                switch (r.kind) {
                  case 239:
                  case 240:
                  case 241:
                  case 248:
                  case 242:
                  case 243:
                  case 244:
                    return false;
                  case 250:
                    return hA(r.parent);
                }
                return true;
              }
              function _L(r) {
                if (!hA(r.parent)) {
                  if (e.isLet(r.declarationList)) return Tt(r, e.Diagnostics.let_declarations_can_only_be_declared_inside_a_block);
                  if (e.isVarConst(r.declarationList)) return Tt(r, e.Diagnostics.const_declarations_can_only_be_declared_inside_a_block);
                }
              }
              function pL(r) {
                var i = r.name.escapedText;
                switch (r.keywordToken) {
                  case 103:
                    if (i !== "target") return Tt(r.name, e.Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2, r.name.escapedText, e.tokenToString(r.keywordToken), "target");
                    break;
                  case 100:
                    if (i !== "meta") return Tt(r.name, e.Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2, r.name.escapedText, e.tokenToString(r.keywordToken), "meta");
                    break;
                }
              }
              function Jd(r) {
                return r.parseDiagnostics.length > 0;
              }
              function Hs(r, i, t, o, s) {
                var u = e.getSourceFileOfNode(r);
                if (!Jd(u)) {
                  var h = e.getSpanOfTokenAtPosition(u, r.pos);
                  return rn.add(e.createFileDiagnostic(u, h.start, h.length, i, t, o, s)), true;
                }
                return false;
              }
              function rd(r, i, t, o, s, u, h) {
                var z2 = e.getSourceFileOfNode(r);
                return Jd(z2) ? false : (rn.add(e.createFileDiagnostic(z2, i, t, o, s, u, h)), true);
              }
              function dL(r, i, t, o, s, u) {
                var h = e.getSourceFileOfNode(i);
                return Jd(h) ? false : (Es(r, i, t, o, s, u), true);
              }
              function Tt(r, i, t, o, s) {
                var u = e.getSourceFileOfNode(r);
                return Jd(u) ? false : (rn.add(e.createDiagnosticForNode(r, i, t, o, s)), true);
              }
              function gL(r) {
                var i = e.isInJSFile(r) ? e.getJSDocTypeParameterDeclarations(r) : void 0, t = r.typeParameters || i && e.firstOrUndefined(i);
                if (t) {
                  var o = t.pos === t.end ? t.pos : e.skipTrivia(e.getSourceFileOfNode(r).text, t.pos);
                  return rd(r, o, t.end - o, e.Diagnostics.Type_parameters_cannot_appear_on_a_constructor_declaration);
                }
              }
              function mL(r) {
                var i = e.getEffectiveReturnTypeNode(r);
                if (i) return Tt(i, e.Diagnostics.Type_annotation_cannot_appear_on_a_constructor_declaration);
              }
              function vL(r) {
                if (e.isComputedPropertyName(r.name) && e.isBinaryExpression(r.name.expression) && r.name.expression.operatorToken.kind === 101) return Tt(r.parent.members[0], e.Diagnostics.A_mapped_type_may_not_declare_properties_or_methods);
                if (e.isClassLike(r.parent)) {
                  if (e.isStringLiteral(r.name) && r.name.text === "constructor") return Tt(r.name, e.Diagnostics.Classes_may_not_have_a_field_named_constructor);
                  if (Em(r.name, e.Diagnostics.A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_symbol_type)) return true;
                  if (Ae < 2 && e.isPrivateIdentifier(r.name)) return Tt(r.name, e.Diagnostics.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);
                } else if (r.parent.kind === 258) {
                  if (Em(r.name, e.Diagnostics.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type)) return true;
                  if (r.initializer) return Tt(r.initializer, e.Diagnostics.An_interface_property_cannot_have_an_initializer);
                } else if (e.isTypeLiteralNode(r.parent)) {
                  if (Em(r.name, e.Diagnostics.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type)) return true;
                  if (r.initializer) return Tt(r.initializer, e.Diagnostics.A_type_literal_property_cannot_have_an_initializer);
                }
                if (r.flags & 16777216 && mA(r), e.isPropertyDeclaration(r) && r.exclamationToken && (!e.isClassLike(r.parent) || !r.type || r.initializer || r.flags & 16777216 || e.isStatic(r) || e.hasAbstractModifier(r))) {
                  var i = r.initializer ? e.Diagnostics.Declarations_with_initializers_cannot_also_have_definite_assignment_assertions : r.type ? e.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context : e.Diagnostics.Declarations_with_definite_assignment_assertions_must_also_have_type_annotations;
                  return Tt(r.exclamationToken, i);
                }
              }
              function yL(r) {
                return r.kind === 258 || r.kind === 259 || r.kind === 266 || r.kind === 265 || r.kind === 272 || r.kind === 271 || r.kind === 264 || e.hasSyntacticModifier(r, 515) ? false : Hs(r, e.Diagnostics.Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier);
              }
              function hL(r) {
                for (var i = 0, t = r.statements; i < t.length; i++) {
                  var o = t[i];
                  if ((e.isDeclaration(o) || o.kind === 237) && yL(o)) return true;
                }
                return false;
              }
              function DL(r) {
                return !!(r.flags & 16777216) && hL(r);
              }
              function Mf(r) {
                if (r.flags & 16777216) {
                  var i = va(r);
                  if (!i.hasReportedStatementInAmbientContext && (e.isFunctionLike(r.parent) || e.isAccessor(r.parent))) return va(r).hasReportedStatementInAmbientContext = Hs(r, e.Diagnostics.An_implementation_cannot_be_declared_in_ambient_contexts);
                  if (r.parent.kind === 235 || r.parent.kind === 262 || r.parent.kind === 305) {
                    var t = va(r.parent);
                    if (!t.hasReportedStatementInAmbientContext) return t.hasReportedStatementInAmbientContext = Hs(r, e.Diagnostics.Statements_are_not_allowed_in_ambient_contexts);
                  }
                }
                return false;
              }
              function KS(r) {
                if (r.numericLiteralFlags & 32) {
                  var i = void 0;
                  if (Ae >= 1 ? i = e.Diagnostics.Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0 : e.isChildOfNodeWithKind(r, 196) ? i = e.Diagnostics.Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0 : e.isChildOfNodeWithKind(r, 299) && (i = e.Diagnostics.Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0), i) {
                    var t = e.isPrefixUnaryExpression(r.parent) && r.parent.operator === 40, o = (t ? "-" : "") + "0o" + r.text;
                    return Tt(t ? r.parent : r, i, o);
                  }
                }
                return bL(r), false;
              }
              function bL(r) {
                var i = e.getTextOfNode(r).indexOf(".") !== -1, t = r.numericLiteralFlags & 16;
                if (!(i || t)) {
                  var o = +r.text;
                  o <= Math.pow(2, 53) - 1 || Ls(false, e.createDiagnosticForNode(r, e.Diagnostics.Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers));
                }
              }
              function SL(r) {
                var i = e.isLiteralTypeNode(r.parent) || e.isPrefixUnaryExpression(r.parent) && e.isLiteralTypeNode(r.parent.parent);
                return !!(!i && Ae < 7 && Tt(r, e.Diagnostics.BigInt_literals_are_not_available_when_targeting_lower_than_ES2020));
              }
              function TL(r, i, t, o, s) {
                var u = e.getSourceFileOfNode(r);
                if (!Jd(u)) {
                  var h = e.getSpanOfTokenAtPosition(u, r.pos);
                  return rn.add(e.createFileDiagnostic(u, e.textSpanEnd(h), 0, i, t, o, s)), true;
                }
                return false;
              }
              function xL() {
                return Gr || (Gr = [], ii.forEach(function(r, i) {
                  a.test(i) && Gr.push(r);
                })), Gr;
              }
              function EL(r) {
                var i;
                return r.isTypeOnly && r.name && r.namedBindings ? Tt(r, e.Diagnostics.A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both) : r.isTypeOnly && ((i = r.namedBindings) === null || i === void 0 ? void 0 : i.kind) === 269 ? DA(r.namedBindings) : false;
              }
              function DA(r) {
                return !!e.forEach(r.elements, function(i) {
                  if (i.isTypeOnly) return Hs(i, i.kind === 270 ? e.Diagnostics.The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement : e.Diagnostics.The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement);
                });
              }
              function CL(r) {
                if (er === e.ModuleKind.ES2015) return Tt(r, e.Diagnostics.Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd_system_umd_node16_or_nodenext);
                if (r.typeArguments) return Tt(r, e.Diagnostics.This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments);
                var i = r.arguments;
                if (er !== e.ModuleKind.ESNext && er !== e.ModuleKind.NodeNext && (ng(i), i.length > 1)) {
                  var t = i[1];
                  return Tt(t, e.Diagnostics.Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nodenext);
                }
                if (i.length === 0 || i.length > 2) return Tt(r, e.Diagnostics.Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_assertion_as_arguments);
                var o = e.find(i, e.isSpreadElement);
                return o ? Tt(o, e.Diagnostics.Argument_of_dynamic_import_cannot_be_spread_element) : false;
              }
              function kL(r, i) {
                var t = e.getObjectFlags(r);
                if (t & 20 && i.flags & 1048576) return e.find(i.types, function(o) {
                  if (o.flags & 524288) {
                    var s = t & e.getObjectFlags(o);
                    if (s & 4) return r.target === o.target;
                    if (s & 16) return !!r.aliasSymbol && r.aliasSymbol === o.aliasSymbol;
                  }
                  return false;
                });
              }
              function AL(r, i) {
                if (e.getObjectFlags(r) & 128 && rg(i, sp)) return e.find(i.types, function(t) {
                  return !sp(t);
                });
              }
              function NL(r, i) {
                var t = 0, o = ot(r, t).length > 0 || (t = 1, ot(r, t).length > 0);
                if (o) return e.find(i.types, function(s) {
                  return ot(s, t).length > 0;
                });
              }
              function PL(r, i) {
                var t;
                if (!(r.flags & 406978556)) for (var o = 0, s = 0, u = i.types; s < u.length; s++) {
                  var h = u[s];
                  if (!(h.flags & 406978556)) {
                    var z2 = Do([ql(r), ql(h)]);
                    if (z2.flags & 4194304) return h;
                    if (Vl(z2) || z2.flags & 1048576) {
                      var me = z2.flags & 1048576 ? e.countWhere(z2.types, Vl) : 1;
                      me >= o && (t = h, o = me);
                    }
                  }
                }
                return t;
              }
              function IL(r) {
                if (fs(r, 67108864)) {
                  var i = ec(r, function(t) {
                    return !(t.flags & 131068);
                  });
                  if (!(i.flags & 131072)) return i;
                }
                return r;
              }
              function bA(r, i, t, o) {
                if (i.flags & 1048576 && r.flags & 2621440) {
                  var s = $E(i, r);
                  if (s) return s;
                  var u = uo(r);
                  if (u) {
                    var h = YE(u, i);
                    if (h) return UD(i, e.map(h, function(z2) {
                      return [function() {
                        return Jt(z2);
                      }, z2.escapedName];
                    }), t, void 0, o);
                  }
                }
              }
            }
            e.createTypeChecker = L;
            function P(l) {
              return !e.isAccessor(l);
            }
            function k(l) {
              return l.kind !== 256 && l.kind !== 169 || !!l.body;
            }
            function Y(l) {
              switch (l.parent.kind) {
                case 270:
                case 275:
                  return e.isIdentifier(l);
                default:
                  return e.isDeclarationName(l);
              }
            }
            var U;
            (function(l) {
              l.JSX = "JSX", l.IntrinsicElements = "IntrinsicElements", l.ElementClass = "ElementClass", l.ElementAttributesPropertyNameContainer = "ElementAttributesProperty", l.ElementChildrenAttributeNameContainer = "ElementChildrenAttribute", l.Element = "Element", l.IntrinsicAttributes = "IntrinsicAttributes", l.IntrinsicClassAttributes = "IntrinsicClassAttributes", l.LibraryManagedAttributes = "LibraryManagedAttributes";
            })(U || (U = {}));
            function j(l) {
              switch (l) {
                case 0:
                  return "yieldType";
                case 1:
                  return "returnType";
                case 2:
                  return "nextType";
              }
            }
            function H(l) {
              return !!(l.flags & 1);
            }
            e.signatureHasRestParameter = H;
            function I(l) {
              return !!(l.flags & 2);
            }
            e.signatureHasLiteralTypes = I;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(f, T, K, b) {
              if (f === void 0 || T === void 0) return f;
              var se = T(f);
              if (se === f) return f;
              var J;
              if (se !== void 0) return e.isArray(se) ? J = (b || oe)(se) : J = se, e.Debug.assertNode(J, K), J;
            }
            e.visitNode = a;
            function C(f, T, K, b, se) {
              if (f === void 0 || T === void 0) return f;
              var J, ie = f.length;
              (b === void 0 || b < 0) && (b = 0), (se === void 0 || se > ie - b) && (se = ie - b);
              var R, q = -1, O = -1;
              (b > 0 || se < ie) && (J = [], R = f.hasTrailingComma && b + se === ie);
              for (var ve = 0; ve < se; ve++) {
                var ee = f[ve + b], he = ee !== void 0 ? T(ee) : void 0;
                if ((J !== void 0 || he === void 0 || he !== ee) && (J === void 0 && (J = f.slice(0, ve), R = f.hasTrailingComma, q = f.pos, O = f.end), he)) if (e.isArray(he)) for (var F = 0, x = he; F < x.length; F++) {
                  var X = x[F];
                  e.Debug.assertNode(X, K), J.push(X);
                }
                else e.Debug.assertNode(he, K), J.push(he);
              }
              if (J) {
                var $ = e.factory.createNodeArray(J, R);
                return e.setTextRangePosEnd($, q, O), $;
              }
              return f;
            }
            e.visitNodes = C;
            function w(f, T, K, b, se, J) {
              return J === void 0 && (J = C), K.startLexicalEnvironment(), f = J(f, T, e.isStatement, b), se && (f = K.factory.ensureUseStrict(f)), e.factory.mergeLexicalEnvironment(f, K.endLexicalEnvironment());
            }
            e.visitLexicalEnvironment = w;
            function B(f, T, K, b) {
              b === void 0 && (b = C);
              var se;
              return K.startLexicalEnvironment(), f && (K.setLexicalEnvironmentFlags(1, true), se = b(f, T, e.isParameterDeclaration), K.getLexicalEnvironmentFlags() & 2 && e.getEmitScriptTarget(K.getCompilerOptions()) >= 2 && (se = E(se, K)), K.setLexicalEnvironmentFlags(1, false)), K.suspendLexicalEnvironment(), se;
            }
            e.visitParameterList = B;
            function E(f, T) {
              for (var K, b = 0; b < f.length; b++) {
                var se = f[b], J = Q(se, T);
                (K || J !== se) && (K || (K = f.slice(0, b)), K[b] = J);
              }
              return K ? e.setTextRange(T.factory.createNodeArray(K, f.hasTrailingComma), f) : f;
            }
            function Q(f, T) {
              return f.dotDotDotToken ? f : e.isBindingPattern(f.name) ? le(f, T) : f.initializer ? N(f, f.name, f.initializer, T) : f;
            }
            function le(f, T) {
              var K = T.factory;
              return T.addInitializationStatement(K.createVariableStatement(void 0, K.createVariableDeclarationList([K.createVariableDeclaration(f.name, void 0, f.type, f.initializer ? K.createConditionalExpression(K.createStrictEquality(K.getGeneratedNameForNode(f), K.createVoidZero()), void 0, f.initializer, void 0, K.getGeneratedNameForNode(f)) : K.getGeneratedNameForNode(f))]))), K.updateParameterDeclaration(f, f.decorators, f.modifiers, f.dotDotDotToken, K.getGeneratedNameForNode(f), f.questionToken, f.type, void 0);
            }
            function N(f, T, K, b) {
              var se = b.factory;
              return b.addInitializationStatement(se.createIfStatement(se.createTypeCheck(se.cloneNode(T), "undefined"), e.setEmitFlags(e.setTextRange(se.createBlock([se.createExpressionStatement(e.setEmitFlags(e.setTextRange(se.createAssignment(e.setEmitFlags(se.cloneNode(T), 48), e.setEmitFlags(K, 48 | e.getEmitFlags(K) | 1536)), f), 1536))]), f), 1953))), se.updateParameterDeclaration(f, f.decorators, f.modifiers, f.dotDotDotToken, f.name, f.questionToken, f.type, void 0);
            }
            function p(f, T, K, b) {
              b === void 0 && (b = a), K.resumeLexicalEnvironment();
              var se = b(f, T, e.isConciseBody), J = K.endLexicalEnvironment();
              if (e.some(J)) {
                if (!se) return K.factory.createBlock(J);
                var ie = K.factory.converters.convertToFunctionBlock(se), R = e.factory.mergeLexicalEnvironment(ie.statements, J);
                return K.factory.updateBlock(ie, R);
              }
              return se;
            }
            e.visitFunctionBody = p;
            function m(f, T, K) {
              K.startBlockScope();
              var b = a(f, T, e.isStatement, K.factory.liftToBlock), se = K.endBlockScope();
              return e.some(se) ? e.isBlock(b) ? (se.push.apply(se, b.statements), K.factory.updateBlock(b, se)) : (se.push(b), K.factory.createBlock(se)) : b;
            }
            e.visitIterationBody = m;
            function G(f, T, K, b, se, J) {
              if (b === void 0 && (b = C), J === void 0 && (J = a), f !== void 0) {
                var ie = f.kind;
                if (ie > 0 && ie <= 160 || ie === 192) return f;
                var R = K.factory;
                switch (ie) {
                  case 79:
                    return e.Debug.type(f), R.updateIdentifier(f, b(f.typeArguments, T, e.isTypeNodeOrTypeParameterDeclaration));
                  case 161:
                    return e.Debug.type(f), R.updateQualifiedName(f, J(f.left, T, e.isEntityName), J(f.right, T, e.isIdentifier));
                  case 162:
                    return e.Debug.type(f), R.updateComputedPropertyName(f, J(f.expression, T, e.isExpression));
                  case 163:
                    return e.Debug.type(f), R.updateTypeParameterDeclaration(f, b(f.modifiers, T, e.isModifier), J(f.name, T, e.isIdentifier), J(f.constraint, T, e.isTypeNode), J(f.default, T, e.isTypeNode));
                  case 164:
                    return e.Debug.type(f), R.updateParameterDeclaration(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), J(f.dotDotDotToken, se, e.isDotDotDotToken), J(f.name, T, e.isBindingName), J(f.questionToken, se, e.isQuestionToken), J(f.type, T, e.isTypeNode), J(f.initializer, T, e.isExpression));
                  case 165:
                    return e.Debug.type(f), R.updateDecorator(f, J(f.expression, T, e.isExpression));
                  case 166:
                    return e.Debug.type(f), R.updatePropertySignature(f, b(f.modifiers, T, e.isModifier), J(f.name, T, e.isPropertyName), J(f.questionToken, se, e.isToken), J(f.type, T, e.isTypeNode));
                  case 167:
                    return e.Debug.type(f), R.updatePropertyDeclaration(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), J(f.name, T, e.isPropertyName), J(f.questionToken || f.exclamationToken, se, e.isQuestionOrExclamationToken), J(f.type, T, e.isTypeNode), J(f.initializer, T, e.isExpression));
                  case 168:
                    return e.Debug.type(f), R.updateMethodSignature(f, b(f.modifiers, T, e.isModifier), J(f.name, T, e.isPropertyName), J(f.questionToken, se, e.isQuestionToken), b(f.typeParameters, T, e.isTypeParameterDeclaration), b(f.parameters, T, e.isParameterDeclaration), J(f.type, T, e.isTypeNode));
                  case 169:
                    return e.Debug.type(f), R.updateMethodDeclaration(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), J(f.asteriskToken, se, e.isAsteriskToken), J(f.name, T, e.isPropertyName), J(f.questionToken, se, e.isQuestionToken), b(f.typeParameters, T, e.isTypeParameterDeclaration), B(f.parameters, T, K, b), J(f.type, T, e.isTypeNode), p(f.body, T, K, J));
                  case 171:
                    return e.Debug.type(f), R.updateConstructorDeclaration(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), B(f.parameters, T, K, b), p(f.body, T, K, J));
                  case 172:
                    return e.Debug.type(f), R.updateGetAccessorDeclaration(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), J(f.name, T, e.isPropertyName), B(f.parameters, T, K, b), J(f.type, T, e.isTypeNode), p(f.body, T, K, J));
                  case 173:
                    return e.Debug.type(f), R.updateSetAccessorDeclaration(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), J(f.name, T, e.isPropertyName), B(f.parameters, T, K, b), p(f.body, T, K, J));
                  case 170:
                    return e.Debug.type(f), K.startLexicalEnvironment(), K.suspendLexicalEnvironment(), R.updateClassStaticBlockDeclaration(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), p(f.body, T, K, J));
                  case 174:
                    return e.Debug.type(f), R.updateCallSignature(f, b(f.typeParameters, T, e.isTypeParameterDeclaration), b(f.parameters, T, e.isParameterDeclaration), J(f.type, T, e.isTypeNode));
                  case 175:
                    return e.Debug.type(f), R.updateConstructSignature(f, b(f.typeParameters, T, e.isTypeParameterDeclaration), b(f.parameters, T, e.isParameterDeclaration), J(f.type, T, e.isTypeNode));
                  case 176:
                    return e.Debug.type(f), R.updateIndexSignature(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), b(f.parameters, T, e.isParameterDeclaration), J(f.type, T, e.isTypeNode));
                  case 177:
                    return e.Debug.type(f), R.updateTypePredicateNode(f, J(f.assertsModifier, T, e.isAssertsKeyword), J(f.parameterName, T, e.isIdentifierOrThisTypeNode), J(f.type, T, e.isTypeNode));
                  case 178:
                    return e.Debug.type(f), R.updateTypeReferenceNode(f, J(f.typeName, T, e.isEntityName), b(f.typeArguments, T, e.isTypeNode));
                  case 179:
                    return e.Debug.type(f), R.updateFunctionTypeNode(f, b(f.typeParameters, T, e.isTypeParameterDeclaration), b(f.parameters, T, e.isParameterDeclaration), J(f.type, T, e.isTypeNode));
                  case 180:
                    return e.Debug.type(f), R.updateConstructorTypeNode(f, b(f.modifiers, T, e.isModifier), b(f.typeParameters, T, e.isTypeParameterDeclaration), b(f.parameters, T, e.isParameterDeclaration), J(f.type, T, e.isTypeNode));
                  case 181:
                    return e.Debug.type(f), R.updateTypeQueryNode(f, J(f.exprName, T, e.isEntityName), b(f.typeArguments, T, e.isTypeNode));
                  case 182:
                    return e.Debug.type(f), R.updateTypeLiteralNode(f, b(f.members, T, e.isTypeElement));
                  case 183:
                    return e.Debug.type(f), R.updateArrayTypeNode(f, J(f.elementType, T, e.isTypeNode));
                  case 184:
                    return e.Debug.type(f), R.updateTupleTypeNode(f, b(f.elements, T, e.isTypeNode));
                  case 185:
                    return e.Debug.type(f), R.updateOptionalTypeNode(f, J(f.type, T, e.isTypeNode));
                  case 186:
                    return e.Debug.type(f), R.updateRestTypeNode(f, J(f.type, T, e.isTypeNode));
                  case 187:
                    return e.Debug.type(f), R.updateUnionTypeNode(f, b(f.types, T, e.isTypeNode));
                  case 188:
                    return e.Debug.type(f), R.updateIntersectionTypeNode(f, b(f.types, T, e.isTypeNode));
                  case 189:
                    return e.Debug.type(f), R.updateConditionalTypeNode(f, J(f.checkType, T, e.isTypeNode), J(f.extendsType, T, e.isTypeNode), J(f.trueType, T, e.isTypeNode), J(f.falseType, T, e.isTypeNode));
                  case 190:
                    return e.Debug.type(f), R.updateInferTypeNode(f, J(f.typeParameter, T, e.isTypeParameterDeclaration));
                  case 200:
                    return e.Debug.type(f), R.updateImportTypeNode(f, J(f.argument, T, e.isTypeNode), J(f.assertions, T, e.isNode), J(f.qualifier, T, e.isEntityName), C(f.typeArguments, T, e.isTypeNode), f.isTypeOf);
                  case 295:
                    return e.Debug.type(f), R.updateImportTypeAssertionContainer(f, J(f.assertClause, T, e.isNode), f.multiLine);
                  case 197:
                    return e.Debug.type(f), R.updateNamedTupleMember(f, a(f.dotDotDotToken, T, e.isDotDotDotToken), a(f.name, T, e.isIdentifier), a(f.questionToken, T, e.isQuestionToken), a(f.type, T, e.isTypeNode));
                  case 191:
                    return e.Debug.type(f), R.updateParenthesizedType(f, J(f.type, T, e.isTypeNode));
                  case 193:
                    return e.Debug.type(f), R.updateTypeOperatorNode(f, J(f.type, T, e.isTypeNode));
                  case 194:
                    return e.Debug.type(f), R.updateIndexedAccessTypeNode(f, J(f.objectType, T, e.isTypeNode), J(f.indexType, T, e.isTypeNode));
                  case 195:
                    return e.Debug.type(f), R.updateMappedTypeNode(f, J(f.readonlyToken, se, e.isReadonlyKeywordOrPlusOrMinusToken), J(f.typeParameter, T, e.isTypeParameterDeclaration), J(f.nameType, T, e.isTypeNode), J(f.questionToken, se, e.isQuestionOrPlusOrMinusToken), J(f.type, T, e.isTypeNode), b(f.members, T, e.isTypeElement));
                  case 196:
                    return e.Debug.type(f), R.updateLiteralTypeNode(f, J(f.literal, T, e.isExpression));
                  case 198:
                    return e.Debug.type(f), R.updateTemplateLiteralType(f, J(f.head, T, e.isTemplateHead), b(f.templateSpans, T, e.isTemplateLiteralTypeSpan));
                  case 199:
                    return e.Debug.type(f), R.updateTemplateLiteralTypeSpan(f, J(f.type, T, e.isTypeNode), J(f.literal, T, e.isTemplateMiddleOrTemplateTail));
                  case 201:
                    return e.Debug.type(f), R.updateObjectBindingPattern(f, b(f.elements, T, e.isBindingElement));
                  case 202:
                    return e.Debug.type(f), R.updateArrayBindingPattern(f, b(f.elements, T, e.isArrayBindingElement));
                  case 203:
                    return e.Debug.type(f), R.updateBindingElement(f, J(f.dotDotDotToken, se, e.isDotDotDotToken), J(f.propertyName, T, e.isPropertyName), J(f.name, T, e.isBindingName), J(f.initializer, T, e.isExpression));
                  case 204:
                    return e.Debug.type(f), R.updateArrayLiteralExpression(f, b(f.elements, T, e.isExpression));
                  case 205:
                    return e.Debug.type(f), R.updateObjectLiteralExpression(f, b(f.properties, T, e.isObjectLiteralElementLike));
                  case 206:
                    return f.flags & 32 ? (e.Debug.type(f), R.updatePropertyAccessChain(f, J(f.expression, T, e.isExpression), J(f.questionDotToken, se, e.isQuestionDotToken), J(f.name, T, e.isMemberName))) : (e.Debug.type(f), R.updatePropertyAccessExpression(f, J(f.expression, T, e.isExpression), J(f.name, T, e.isMemberName)));
                  case 207:
                    return f.flags & 32 ? (e.Debug.type(f), R.updateElementAccessChain(f, J(f.expression, T, e.isExpression), J(f.questionDotToken, se, e.isQuestionDotToken), J(f.argumentExpression, T, e.isExpression))) : (e.Debug.type(f), R.updateElementAccessExpression(f, J(f.expression, T, e.isExpression), J(f.argumentExpression, T, e.isExpression)));
                  case 208:
                    return f.flags & 32 ? (e.Debug.type(f), R.updateCallChain(f, J(f.expression, T, e.isExpression), J(f.questionDotToken, se, e.isQuestionDotToken), b(f.typeArguments, T, e.isTypeNode), b(f.arguments, T, e.isExpression))) : (e.Debug.type(f), R.updateCallExpression(f, J(f.expression, T, e.isExpression), b(f.typeArguments, T, e.isTypeNode), b(f.arguments, T, e.isExpression)));
                  case 209:
                    return e.Debug.type(f), R.updateNewExpression(f, J(f.expression, T, e.isExpression), b(f.typeArguments, T, e.isTypeNode), b(f.arguments, T, e.isExpression));
                  case 210:
                    return e.Debug.type(f), R.updateTaggedTemplateExpression(f, J(f.tag, T, e.isExpression), C(f.typeArguments, T, e.isTypeNode), J(f.template, T, e.isTemplateLiteral));
                  case 211:
                    return e.Debug.type(f), R.updateTypeAssertion(f, J(f.type, T, e.isTypeNode), J(f.expression, T, e.isExpression));
                  case 212:
                    return e.Debug.type(f), R.updateParenthesizedExpression(f, J(f.expression, T, e.isExpression));
                  case 213:
                    return e.Debug.type(f), R.updateFunctionExpression(f, b(f.modifiers, T, e.isModifier), J(f.asteriskToken, se, e.isAsteriskToken), J(f.name, T, e.isIdentifier), b(f.typeParameters, T, e.isTypeParameterDeclaration), B(f.parameters, T, K, b), J(f.type, T, e.isTypeNode), p(f.body, T, K, J));
                  case 214:
                    return e.Debug.type(f), R.updateArrowFunction(f, b(f.modifiers, T, e.isModifier), b(f.typeParameters, T, e.isTypeParameterDeclaration), B(f.parameters, T, K, b), J(f.type, T, e.isTypeNode), J(f.equalsGreaterThanToken, se, e.isEqualsGreaterThanToken), p(f.body, T, K, J));
                  case 215:
                    return e.Debug.type(f), R.updateDeleteExpression(f, J(f.expression, T, e.isExpression));
                  case 216:
                    return e.Debug.type(f), R.updateTypeOfExpression(f, J(f.expression, T, e.isExpression));
                  case 217:
                    return e.Debug.type(f), R.updateVoidExpression(f, J(f.expression, T, e.isExpression));
                  case 218:
                    return e.Debug.type(f), R.updateAwaitExpression(f, J(f.expression, T, e.isExpression));
                  case 219:
                    return e.Debug.type(f), R.updatePrefixUnaryExpression(f, J(f.operand, T, e.isExpression));
                  case 220:
                    return e.Debug.type(f), R.updatePostfixUnaryExpression(f, J(f.operand, T, e.isExpression));
                  case 221:
                    return e.Debug.type(f), R.updateBinaryExpression(f, J(f.left, T, e.isExpression), J(f.operatorToken, se, e.isBinaryOperatorToken), J(f.right, T, e.isExpression));
                  case 222:
                    return e.Debug.type(f), R.updateConditionalExpression(f, J(f.condition, T, e.isExpression), J(f.questionToken, se, e.isQuestionToken), J(f.whenTrue, T, e.isExpression), J(f.colonToken, se, e.isColonToken), J(f.whenFalse, T, e.isExpression));
                  case 223:
                    return e.Debug.type(f), R.updateTemplateExpression(f, J(f.head, T, e.isTemplateHead), b(f.templateSpans, T, e.isTemplateSpan));
                  case 224:
                    return e.Debug.type(f), R.updateYieldExpression(f, J(f.asteriskToken, se, e.isAsteriskToken), J(f.expression, T, e.isExpression));
                  case 225:
                    return e.Debug.type(f), R.updateSpreadElement(f, J(f.expression, T, e.isExpression));
                  case 226:
                    return e.Debug.type(f), R.updateClassExpression(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), J(f.name, T, e.isIdentifier), b(f.typeParameters, T, e.isTypeParameterDeclaration), b(f.heritageClauses, T, e.isHeritageClause), b(f.members, T, e.isClassElement));
                  case 228:
                    return e.Debug.type(f), R.updateExpressionWithTypeArguments(f, J(f.expression, T, e.isExpression), b(f.typeArguments, T, e.isTypeNode));
                  case 229:
                    return e.Debug.type(f), R.updateAsExpression(f, J(f.expression, T, e.isExpression), J(f.type, T, e.isTypeNode));
                  case 230:
                    return f.flags & 32 ? (e.Debug.type(f), R.updateNonNullChain(f, J(f.expression, T, e.isExpression))) : (e.Debug.type(f), R.updateNonNullExpression(f, J(f.expression, T, e.isExpression)));
                  case 231:
                    return e.Debug.type(f), R.updateMetaProperty(f, J(f.name, T, e.isIdentifier));
                  case 233:
                    return e.Debug.type(f), R.updateTemplateSpan(f, J(f.expression, T, e.isExpression), J(f.literal, T, e.isTemplateMiddleOrTemplateTail));
                  case 235:
                    return e.Debug.type(f), R.updateBlock(f, b(f.statements, T, e.isStatement));
                  case 237:
                    return e.Debug.type(f), R.updateVariableStatement(f, b(f.modifiers, T, e.isModifier), J(f.declarationList, T, e.isVariableDeclarationList));
                  case 238:
                    return e.Debug.type(f), R.updateExpressionStatement(f, J(f.expression, T, e.isExpression));
                  case 239:
                    return e.Debug.type(f), R.updateIfStatement(f, J(f.expression, T, e.isExpression), J(f.thenStatement, T, e.isStatement, R.liftToBlock), J(f.elseStatement, T, e.isStatement, R.liftToBlock));
                  case 240:
                    return e.Debug.type(f), R.updateDoStatement(f, m(f.statement, T, K), J(f.expression, T, e.isExpression));
                  case 241:
                    return e.Debug.type(f), R.updateWhileStatement(f, J(f.expression, T, e.isExpression), m(f.statement, T, K));
                  case 242:
                    return e.Debug.type(f), R.updateForStatement(f, J(f.initializer, T, e.isForInitializer), J(f.condition, T, e.isExpression), J(f.incrementor, T, e.isExpression), m(f.statement, T, K));
                  case 243:
                    return e.Debug.type(f), R.updateForInStatement(f, J(f.initializer, T, e.isForInitializer), J(f.expression, T, e.isExpression), m(f.statement, T, K));
                  case 244:
                    return e.Debug.type(f), R.updateForOfStatement(f, J(f.awaitModifier, se, e.isAwaitKeyword), J(f.initializer, T, e.isForInitializer), J(f.expression, T, e.isExpression), m(f.statement, T, K));
                  case 245:
                    return e.Debug.type(f), R.updateContinueStatement(f, J(f.label, T, e.isIdentifier));
                  case 246:
                    return e.Debug.type(f), R.updateBreakStatement(f, J(f.label, T, e.isIdentifier));
                  case 247:
                    return e.Debug.type(f), R.updateReturnStatement(f, J(f.expression, T, e.isExpression));
                  case 248:
                    return e.Debug.type(f), R.updateWithStatement(f, J(f.expression, T, e.isExpression), J(f.statement, T, e.isStatement, R.liftToBlock));
                  case 249:
                    return e.Debug.type(f), R.updateSwitchStatement(f, J(f.expression, T, e.isExpression), J(f.caseBlock, T, e.isCaseBlock));
                  case 250:
                    return e.Debug.type(f), R.updateLabeledStatement(f, J(f.label, T, e.isIdentifier), J(f.statement, T, e.isStatement, R.liftToBlock));
                  case 251:
                    return e.Debug.type(f), R.updateThrowStatement(f, J(f.expression, T, e.isExpression));
                  case 252:
                    return e.Debug.type(f), R.updateTryStatement(f, J(f.tryBlock, T, e.isBlock), J(f.catchClause, T, e.isCatchClause), J(f.finallyBlock, T, e.isBlock));
                  case 254:
                    return e.Debug.type(f), R.updateVariableDeclaration(f, J(f.name, T, e.isBindingName), J(f.exclamationToken, se, e.isExclamationToken), J(f.type, T, e.isTypeNode), J(f.initializer, T, e.isExpression));
                  case 255:
                    return e.Debug.type(f), R.updateVariableDeclarationList(f, b(f.declarations, T, e.isVariableDeclaration));
                  case 256:
                    return e.Debug.type(f), R.updateFunctionDeclaration(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), J(f.asteriskToken, se, e.isAsteriskToken), J(f.name, T, e.isIdentifier), b(f.typeParameters, T, e.isTypeParameterDeclaration), B(f.parameters, T, K, b), J(f.type, T, e.isTypeNode), p(f.body, T, K, J));
                  case 257:
                    return e.Debug.type(f), R.updateClassDeclaration(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), J(f.name, T, e.isIdentifier), b(f.typeParameters, T, e.isTypeParameterDeclaration), b(f.heritageClauses, T, e.isHeritageClause), b(f.members, T, e.isClassElement));
                  case 258:
                    return e.Debug.type(f), R.updateInterfaceDeclaration(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), J(f.name, T, e.isIdentifier), b(f.typeParameters, T, e.isTypeParameterDeclaration), b(f.heritageClauses, T, e.isHeritageClause), b(f.members, T, e.isTypeElement));
                  case 259:
                    return e.Debug.type(f), R.updateTypeAliasDeclaration(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), J(f.name, T, e.isIdentifier), b(f.typeParameters, T, e.isTypeParameterDeclaration), J(f.type, T, e.isTypeNode));
                  case 260:
                    return e.Debug.type(f), R.updateEnumDeclaration(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), J(f.name, T, e.isIdentifier), b(f.members, T, e.isEnumMember));
                  case 261:
                    return e.Debug.type(f), R.updateModuleDeclaration(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), J(f.name, T, e.isModuleName), J(f.body, T, e.isModuleBody));
                  case 262:
                    return e.Debug.type(f), R.updateModuleBlock(f, b(f.statements, T, e.isStatement));
                  case 263:
                    return e.Debug.type(f), R.updateCaseBlock(f, b(f.clauses, T, e.isCaseOrDefaultClause));
                  case 264:
                    return e.Debug.type(f), R.updateNamespaceExportDeclaration(f, J(f.name, T, e.isIdentifier));
                  case 265:
                    return e.Debug.type(f), R.updateImportEqualsDeclaration(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), f.isTypeOnly, J(f.name, T, e.isIdentifier), J(f.moduleReference, T, e.isModuleReference));
                  case 266:
                    return e.Debug.type(f), R.updateImportDeclaration(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), J(f.importClause, T, e.isImportClause), J(f.moduleSpecifier, T, e.isExpression), J(f.assertClause, T, e.isAssertClause));
                  case 293:
                    return e.Debug.type(f), R.updateAssertClause(f, b(f.elements, T, e.isAssertEntry), f.multiLine);
                  case 294:
                    return e.Debug.type(f), R.updateAssertEntry(f, J(f.name, T, e.isAssertionKey), J(f.value, T, e.isExpressionNode));
                  case 267:
                    return e.Debug.type(f), R.updateImportClause(f, f.isTypeOnly, J(f.name, T, e.isIdentifier), J(f.namedBindings, T, e.isNamedImportBindings));
                  case 268:
                    return e.Debug.type(f), R.updateNamespaceImport(f, J(f.name, T, e.isIdentifier));
                  case 274:
                    return e.Debug.type(f), R.updateNamespaceExport(f, J(f.name, T, e.isIdentifier));
                  case 269:
                    return e.Debug.type(f), R.updateNamedImports(f, b(f.elements, T, e.isImportSpecifier));
                  case 270:
                    return e.Debug.type(f), R.updateImportSpecifier(f, f.isTypeOnly, J(f.propertyName, T, e.isIdentifier), J(f.name, T, e.isIdentifier));
                  case 271:
                    return e.Debug.type(f), R.updateExportAssignment(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), J(f.expression, T, e.isExpression));
                  case 272:
                    return e.Debug.type(f), R.updateExportDeclaration(f, b(f.decorators, T, e.isDecorator), b(f.modifiers, T, e.isModifier), f.isTypeOnly, J(f.exportClause, T, e.isNamedExportBindings), J(f.moduleSpecifier, T, e.isExpression), J(f.assertClause, T, e.isAssertClause));
                  case 273:
                    return e.Debug.type(f), R.updateNamedExports(f, b(f.elements, T, e.isExportSpecifier));
                  case 275:
                    return e.Debug.type(f), R.updateExportSpecifier(f, f.isTypeOnly, J(f.propertyName, T, e.isIdentifier), J(f.name, T, e.isIdentifier));
                  case 277:
                    return e.Debug.type(f), R.updateExternalModuleReference(f, J(f.expression, T, e.isExpression));
                  case 278:
                    return e.Debug.type(f), R.updateJsxElement(f, J(f.openingElement, T, e.isJsxOpeningElement), b(f.children, T, e.isJsxChild), J(f.closingElement, T, e.isJsxClosingElement));
                  case 279:
                    return e.Debug.type(f), R.updateJsxSelfClosingElement(f, J(f.tagName, T, e.isJsxTagNameExpression), b(f.typeArguments, T, e.isTypeNode), J(f.attributes, T, e.isJsxAttributes));
                  case 280:
                    return e.Debug.type(f), R.updateJsxOpeningElement(f, J(f.tagName, T, e.isJsxTagNameExpression), b(f.typeArguments, T, e.isTypeNode), J(f.attributes, T, e.isJsxAttributes));
                  case 281:
                    return e.Debug.type(f), R.updateJsxClosingElement(f, J(f.tagName, T, e.isJsxTagNameExpression));
                  case 282:
                    return e.Debug.type(f), R.updateJsxFragment(f, J(f.openingFragment, T, e.isJsxOpeningFragment), b(f.children, T, e.isJsxChild), J(f.closingFragment, T, e.isJsxClosingFragment));
                  case 285:
                    return e.Debug.type(f), R.updateJsxAttribute(f, J(f.name, T, e.isIdentifier), J(f.initializer, T, e.isStringLiteralOrJsxExpression));
                  case 286:
                    return e.Debug.type(f), R.updateJsxAttributes(f, b(f.properties, T, e.isJsxAttributeLike));
                  case 287:
                    return e.Debug.type(f), R.updateJsxSpreadAttribute(f, J(f.expression, T, e.isExpression));
                  case 288:
                    return e.Debug.type(f), R.updateJsxExpression(f, J(f.expression, T, e.isExpression));
                  case 289:
                    return e.Debug.type(f), R.updateCaseClause(f, J(f.expression, T, e.isExpression), b(f.statements, T, e.isStatement));
                  case 290:
                    return e.Debug.type(f), R.updateDefaultClause(f, b(f.statements, T, e.isStatement));
                  case 291:
                    return e.Debug.type(f), R.updateHeritageClause(f, b(f.types, T, e.isExpressionWithTypeArguments));
                  case 292:
                    return e.Debug.type(f), R.updateCatchClause(f, J(f.variableDeclaration, T, e.isVariableDeclaration), J(f.block, T, e.isBlock));
                  case 296:
                    return e.Debug.type(f), R.updatePropertyAssignment(f, J(f.name, T, e.isPropertyName), J(f.initializer, T, e.isExpression));
                  case 297:
                    return e.Debug.type(f), R.updateShorthandPropertyAssignment(f, J(f.name, T, e.isIdentifier), J(f.objectAssignmentInitializer, T, e.isExpression));
                  case 298:
                    return e.Debug.type(f), R.updateSpreadAssignment(f, J(f.expression, T, e.isExpression));
                  case 299:
                    return e.Debug.type(f), R.updateEnumMember(f, J(f.name, T, e.isPropertyName), J(f.initializer, T, e.isExpression));
                  case 305:
                    return e.Debug.type(f), R.updateSourceFile(f, w(f.statements, T, K));
                  case 350:
                    return e.Debug.type(f), R.updatePartiallyEmittedExpression(f, J(f.expression, T, e.isExpression));
                  case 351:
                    return e.Debug.type(f), R.updateCommaListExpression(f, b(f.elements, T, e.isExpression));
                  default:
                    return f;
                }
              }
            }
            e.visitEachChild = G;
            function oe(f) {
              return e.Debug.assert(f.length <= 1, "Too many nodes written to output."), e.singleOrUndefined(f);
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(q, O, ve, ee, he) {
              var F = he.extendedDiagnostics ? e.performance.createTimer("Source Map", "beforeSourcemap", "afterSourcemap") : e.performance.nullTimer, x = F.enter, X = F.exit, $ = [], A = [], y = new e.Map(), V, L = [], P, k = [], Y = "", U = 0, j = 0, H = 0, I = 0, l = 0, d = 0, D = false, fe = 0, g = 0, ne = 0, ue = 0, We = 0, Fe = 0, Z = false, Be = false, ge = false;
              return { getSources: function() {
                return $;
              }, addSource: Re, setSourceContent: ze, addName: Ee, addMapping: Ie, appendSourceMap: _e, toJSON: er, toString: function() {
                return JSON.stringify(er());
              } };
              function Re(Cr) {
                x();
                var Ye = e.getRelativePathToDirectoryOrUrl(ee, Cr, q.getCurrentDirectory(), q.getCanonicalFileName, true), Br = y.get(Ye);
                return Br === void 0 && (Br = A.length, A.push(Ye), $.push(Cr), y.set(Ye, Br)), X(), Br;
              }
              function ze(Cr, Ye) {
                if (x(), Ye !== null) {
                  for (V || (V = []); V.length < Cr; ) V.push(null);
                  V[Cr] = Ye;
                }
                X();
              }
              function Ee(Cr) {
                x(), P || (P = new e.Map());
                var Ye = P.get(Cr);
                return Ye === void 0 && (Ye = L.length, L.push(Cr), P.set(Cr, Ye)), X(), Ye;
              }
              function He(Cr, Ye) {
                return !Z || fe !== Cr || g !== Ye;
              }
              function rr(Cr, Ye, Br) {
                return Cr !== void 0 && Ye !== void 0 && Br !== void 0 && ne === Cr && (ue > Ye || ue === Ye && We > Br);
              }
              function Ie(Cr, Ye, Br, Er, Ne, n) {
                e.Debug.assert(Cr >= fe, "generatedLine cannot backtrack"), e.Debug.assert(Ye >= 0, "generatedCharacter cannot be negative"), e.Debug.assert(Br === void 0 || Br >= 0, "sourceIndex cannot be negative"), e.Debug.assert(Er === void 0 || Er >= 0, "sourceLine cannot be negative"), e.Debug.assert(Ne === void 0 || Ne >= 0, "sourceCharacter cannot be negative"), x(), (He(Cr, Ye) || rr(Br, Er, Ne)) && (ye(), fe = Cr, g = Ye, Be = false, ge = false, Z = true), Br !== void 0 && Er !== void 0 && Ne !== void 0 && (ne = Br, ue = Er, We = Ne, Be = true, n !== void 0 && (Fe = n, ge = true)), X();
              }
              function _e(Cr, Ye, Br, Er, Ne, n) {
                e.Debug.assert(Cr >= fe, "generatedLine cannot backtrack"), e.Debug.assert(Ye >= 0, "generatedCharacter cannot be negative"), x();
                for (var lr = [], be, Ge = p(Br.mappings), ur = Ge.next(); !ur.done; ur = Ge.next()) {
                  var yr = ur.value;
                  if (n && (yr.generatedLine > n.line || yr.generatedLine === n.line && yr.generatedCharacter > n.character)) break;
                  if (!(Ne && (yr.generatedLine < Ne.line || Ne.line === yr.generatedLine && yr.generatedCharacter < Ne.character))) {
                    var Ir = void 0, wr = void 0, Ur = void 0, ii = void 0;
                    if (yr.sourceIndex !== void 0) {
                      if (Ir = lr[yr.sourceIndex], Ir === void 0) {
                        var mi = Br.sources[yr.sourceIndex], pe = Br.sourceRoot ? e.combinePaths(Br.sourceRoot, mi) : mi, or = e.combinePaths(e.getDirectoryPath(Er), pe);
                        lr[yr.sourceIndex] = Ir = Re(or), Br.sourcesContent && typeof Br.sourcesContent[yr.sourceIndex] == "string" && ze(Ir, Br.sourcesContent[yr.sourceIndex]);
                      }
                      wr = yr.sourceLine, Ur = yr.sourceCharacter, Br.names && yr.nameIndex !== void 0 && (be || (be = []), ii = be[yr.nameIndex], ii === void 0 && (be[yr.nameIndex] = ii = Ee(Br.names[yr.nameIndex])));
                    }
                    var qr = yr.generatedLine - (Ne ? Ne.line : 0), si = qr + Cr, Di = Ne && Ne.line === yr.generatedLine ? yr.generatedCharacter - Ne.character : yr.generatedCharacter, wi = qr === 0 ? Di + Ye : Di;
                    Ie(si, wi, Ir, wr, Ur, ii);
                  }
                }
                X();
              }
              function we() {
                return !D || U !== fe || j !== g || H !== ne || I !== ue || l !== We || d !== Fe;
              }
              function de(Cr) {
                k.push(Cr), k.length >= 1024 && Ae();
              }
              function ye() {
                if (!(!Z || !we())) {
                  if (x(), U < fe) {
                    do
                      de(59), U++;
                    while (U < fe);
                    j = 0;
                  } else e.Debug.assertEqual(U, fe, "generatedLine cannot backtrack"), D && de(44);
                  ir(g - j), j = g, Be && (ir(ne - H), H = ne, ir(ue - I), I = ue, ir(We - l), l = We, ge && (ir(Fe - d), d = Fe)), D = true, X();
                }
              }
              function Ae() {
                k.length > 0 && (Y += String.fromCharCode.apply(void 0, k), k.length = 0);
              }
              function er() {
                return ye(), Ae(), { version: 3, file: O, sourceRoot: ve, sources: A, names: L, mappings: Y, sourcesContent: V };
              }
              function ir(Cr) {
                Cr < 0 ? Cr = (-Cr << 1) + 1 : Cr = Cr << 1;
                do {
                  var Ye = Cr & 31;
                  Cr = Cr >> 5, Cr > 0 && (Ye = Ye | 32), de(oe(Ye));
                } while (Cr > 0);
              }
            }
            e.createSourceMapGenerator = a;
            var C = /^\/\/[@#] source[M]appingURL=(.+)\r?\n?$/, w = /^\s*(\/\/[@#] .*)?$/;
            function B(q, O) {
              return { getLineCount: function() {
                return O.length;
              }, getLineText: function(ve) {
                return q.substring(O[ve], O[ve + 1]);
              } };
            }
            e.getLineInfo = B;
            function E(q) {
              for (var O = q.getLineCount() - 1; O >= 0; O--) {
                var ve = q.getLineText(O), ee = C.exec(ve);
                if (ee) return e.trimStringEnd(ee[1]);
                if (!ve.match(w)) break;
              }
            }
            e.tryGetSourceMappingURL = E;
            function Q(q) {
              return typeof q == "string" || q === null;
            }
            function le(q) {
              return q !== null && typeof q == "object" && q.version === 3 && typeof q.file == "string" && typeof q.mappings == "string" && e.isArray(q.sources) && e.every(q.sources, e.isString) && (q.sourceRoot === void 0 || q.sourceRoot === null || typeof q.sourceRoot == "string") && (q.sourcesContent === void 0 || q.sourcesContent === null || e.isArray(q.sourcesContent) && e.every(q.sourcesContent, Q)) && (q.names === void 0 || q.names === null || e.isArray(q.names) && e.every(q.names, e.isString));
            }
            e.isRawSourceMap = le;
            function N(q) {
              try {
                var O = JSON.parse(q);
                if (le(O)) return O;
              } catch {
              }
            }
            e.tryParseRawSourceMap = N;
            function p(q) {
              var O = false, ve = 0, ee = 0, he = 0, F = 0, x = 0, X = 0, $ = 0, A;
              return { get pos() {
                return ve;
              }, get error() {
                return A;
              }, get state() {
                return y(true, true);
              }, next: function() {
                for (; !O && ve < q.length; ) {
                  var j = q.charCodeAt(ve);
                  if (j === 59) {
                    ee++, he = 0, ve++;
                    continue;
                  }
                  if (j === 44) {
                    ve++;
                    continue;
                  }
                  var H = false, I = false;
                  if (he += U(), k()) return V();
                  if (he < 0) return P("Invalid generatedCharacter found");
                  if (!Y()) {
                    if (H = true, F += U(), k()) return V();
                    if (F < 0) return P("Invalid sourceIndex found");
                    if (Y()) return P("Unsupported Format: No entries after sourceIndex");
                    if (x += U(), k()) return V();
                    if (x < 0) return P("Invalid sourceLine found");
                    if (Y()) return P("Unsupported Format: No entries after sourceLine");
                    if (X += U(), k()) return V();
                    if (X < 0) return P("Invalid sourceCharacter found");
                    if (!Y()) {
                      if (I = true, $ += U(), k()) return V();
                      if ($ < 0) return P("Invalid nameIndex found");
                      if (!Y()) return P("Unsupported Error Format: Entries after nameIndex");
                    }
                  }
                  return { value: y(H, I), done: O };
                }
                return V();
              } };
              function y(j, H) {
                return { generatedLine: ee, generatedCharacter: he, sourceIndex: j ? F : void 0, sourceLine: j ? x : void 0, sourceCharacter: j ? X : void 0, nameIndex: H ? $ : void 0 };
              }
              function V() {
                return O = true, { value: void 0, done: true };
              }
              function L(j) {
                A === void 0 && (A = j);
              }
              function P(j) {
                return L(j), V();
              }
              function k() {
                return A !== void 0;
              }
              function Y() {
                return ve === q.length || q.charCodeAt(ve) === 44 || q.charCodeAt(ve) === 59;
              }
              function U() {
                for (var j = true, H = 0, I = 0; j; ve++) {
                  if (ve >= q.length) return L("Error in decoding base64VLQFormatDecode, past the mapping string"), -1;
                  var l = f(q.charCodeAt(ve));
                  if (l === -1) return L("Invalid character in VLQ"), -1;
                  j = (l & 32) !== 0, I = I | (l & 31) << H, H += 5;
                }
                return (I & 1) === 0 ? I = I >> 1 : (I = I >> 1, I = -I), I;
              }
            }
            e.decodeMappings = p;
            function m(q, O) {
              return q === O || q.generatedLine === O.generatedLine && q.generatedCharacter === O.generatedCharacter && q.sourceIndex === O.sourceIndex && q.sourceLine === O.sourceLine && q.sourceCharacter === O.sourceCharacter && q.nameIndex === O.nameIndex;
            }
            e.sameMapping = m;
            function G(q) {
              return q.sourceIndex !== void 0 && q.sourceLine !== void 0 && q.sourceCharacter !== void 0;
            }
            e.isSourceMapping = G;
            function oe(q) {
              return q >= 0 && q < 26 ? 65 + q : q >= 26 && q < 52 ? 97 + q - 26 : q >= 52 && q < 62 ? 48 + q - 52 : q === 62 ? 43 : q === 63 ? 47 : e.Debug.fail("".concat(q, ": not a base64 value"));
            }
            function f(q) {
              return q >= 65 && q <= 90 ? q - 65 : q >= 97 && q <= 122 ? q - 97 + 26 : q >= 48 && q <= 57 ? q - 48 + 52 : q === 43 ? 62 : q === 47 ? 63 : -1;
            }
            function T(q) {
              return q.sourceIndex !== void 0 && q.sourcePosition !== void 0;
            }
            function K(q, O) {
              return q.generatedPosition === O.generatedPosition && q.sourceIndex === O.sourceIndex && q.sourcePosition === O.sourcePosition;
            }
            function b(q, O) {
              return e.Debug.assert(q.sourceIndex === O.sourceIndex), e.compareValues(q.sourcePosition, O.sourcePosition);
            }
            function se(q, O) {
              return e.compareValues(q.generatedPosition, O.generatedPosition);
            }
            function J(q) {
              return q.sourcePosition;
            }
            function ie(q) {
              return q.generatedPosition;
            }
            function R(q, O, ve) {
              var ee = e.getDirectoryPath(ve), he = O.sourceRoot ? e.getNormalizedAbsolutePath(O.sourceRoot, ee) : ee, F = e.getNormalizedAbsolutePath(O.file, ee), x = q.getSourceFileLike(F), X = O.sources.map(function(H) {
                return e.getNormalizedAbsolutePath(H, he);
              }), $ = new e.Map(X.map(function(H, I) {
                return [q.getCanonicalFileName(H), I];
              })), A, y, V;
              return { getSourcePosition: j, getGeneratedPosition: U };
              function L(H) {
                var I = x !== void 0 ? e.getPositionOfLineAndCharacter(x, H.generatedLine, H.generatedCharacter, true) : -1, l, d;
                if (G(H)) {
                  var D = q.getSourceFileLike(X[H.sourceIndex]);
                  l = O.sources[H.sourceIndex], d = D !== void 0 ? e.getPositionOfLineAndCharacter(D, H.sourceLine, H.sourceCharacter, true) : -1;
                }
                return { generatedPosition: I, source: l, sourceIndex: H.sourceIndex, sourcePosition: d, nameIndex: H.nameIndex };
              }
              function P() {
                if (A === void 0) {
                  var H = p(O.mappings), I = e.arrayFrom(H, L);
                  H.error !== void 0 ? (q.log && q.log("Encountered error while decoding sourcemap: ".concat(H.error)), A = e.emptyArray) : A = I;
                }
                return A;
              }
              function k(H) {
                if (V === void 0) {
                  for (var I = [], l = 0, d = P(); l < d.length; l++) {
                    var D = d[l];
                    if (!!T(D)) {
                      var fe = I[D.sourceIndex];
                      fe || (I[D.sourceIndex] = fe = []), fe.push(D);
                    }
                  }
                  V = I.map(function(g) {
                    return e.sortAndDeduplicate(g, b, K);
                  });
                }
                return V[H];
              }
              function Y() {
                if (y === void 0) {
                  for (var H = [], I = 0, l = P(); I < l.length; I++) {
                    var d = l[I];
                    H.push(d);
                  }
                  y = e.sortAndDeduplicate(H, se, K);
                }
                return y;
              }
              function U(H) {
                var I = $.get(q.getCanonicalFileName(H.fileName));
                if (I === void 0) return H;
                var l = k(I);
                if (!e.some(l)) return H;
                var d = e.binarySearchKey(l, H.pos, J, e.compareValues);
                d < 0 && (d = ~d);
                var D = l[d];
                return D === void 0 || D.sourceIndex !== I ? H : { fileName: F, pos: D.generatedPosition };
              }
              function j(H) {
                var I = Y();
                if (!e.some(I)) return H;
                var l = e.binarySearchKey(I, H.pos, ie, e.compareValues);
                l < 0 && (l = ~l);
                var d = I[l];
                return d === void 0 || !T(d) ? H : { fileName: X[d.sourceIndex], pos: d.sourcePosition };
              }
            }
            e.createDocumentPositionMapper = R, e.identitySourceMapConsumer = { getSourcePosition: e.identity, getGeneratedPosition: e.identity };
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(ee) {
              return ee = e.getOriginalNode(ee), ee ? e.getNodeId(ee) : 0;
            }
            e.getOriginalNodeId = a;
            function C(ee) {
              return !ee || !e.isNamedImports(ee) ? false : e.some(ee.elements, w);
            }
            function w(ee) {
              return ee.propertyName !== void 0 && ee.propertyName.escapedText === "default";
            }
            function B(ee, he) {
              return F;
              function F(X) {
                return X.kind === 305 ? he(X) : x(X);
              }
              function x(X) {
                return ee.factory.createBundle(e.map(X.sourceFiles, he), X.prepends);
              }
            }
            e.chainBundle = B;
            function E(ee) {
              return !!e.getNamespaceDeclarationNode(ee);
            }
            e.getExportNeedsImportStarHelper = E;
            function Q(ee) {
              if (e.getNamespaceDeclarationNode(ee)) return true;
              var he = ee.importClause && ee.importClause.namedBindings;
              if (!he || !e.isNamedImports(he)) return false;
              for (var F = 0, x = 0, X = he.elements; x < X.length; x++) {
                var $ = X[x];
                w($) && F++;
              }
              return F > 0 && F !== he.elements.length || !!(he.elements.length - F) && e.isDefaultImport(ee);
            }
            e.getImportNeedsImportStarHelper = Q;
            function le(ee) {
              return !Q(ee) && (e.isDefaultImport(ee) || !!ee.importClause && e.isNamedImports(ee.importClause.namedBindings) && C(ee.importClause.namedBindings));
            }
            e.getImportNeedsImportDefaultHelper = le;
            function N(ee, he, F, x) {
              for (var X = [], $ = e.createMultiMap(), A = [], y = new e.Map(), V, L = false, P, k = false, Y = false, U = false, j = 0, H = he.statements; j < H.length; j++) {
                var I = H[j];
                switch (I.kind) {
                  case 266:
                    X.push(I), !Y && Q(I) && (Y = true), !U && le(I) && (U = true);
                    break;
                  case 265:
                    I.moduleReference.kind === 277 && X.push(I);
                    break;
                  case 272:
                    if (I.moduleSpecifier) if (!I.exportClause) X.push(I), k = true;
                    else if (X.push(I), e.isNamedExports(I.exportClause)) ne(I);
                    else {
                      var l = I.exportClause.name;
                      y.get(e.idText(l)) || (m(A, a(I), l), y.set(e.idText(l), true), V = e.append(V, l)), Y = true;
                    }
                    else ne(I);
                    break;
                  case 271:
                    I.isExportEquals && !P && (P = I);
                    break;
                  case 237:
                    if (e.hasSyntacticModifier(I, 1)) for (var d = 0, D = I.declarationList.declarations; d < D.length; d++) {
                      var fe = D[d];
                      V = p(fe, y, V);
                    }
                    break;
                  case 256:
                    if (e.hasSyntacticModifier(I, 1)) if (e.hasSyntacticModifier(I, 512)) L || (m(A, a(I), ee.factory.getDeclarationName(I)), L = true);
                    else {
                      var l = I.name;
                      y.get(e.idText(l)) || (m(A, a(I), l), y.set(e.idText(l), true), V = e.append(V, l));
                    }
                    break;
                  case 257:
                    if (e.hasSyntacticModifier(I, 1)) if (e.hasSyntacticModifier(I, 512)) L || (m(A, a(I), ee.factory.getDeclarationName(I)), L = true);
                    else {
                      var l = I.name;
                      l && !y.get(e.idText(l)) && (m(A, a(I), l), y.set(e.idText(l), true), V = e.append(V, l));
                    }
                    break;
                }
              }
              var g = e.createExternalHelpersImportDeclarationIfNeeded(ee.factory, ee.getEmitHelperFactory(), he, x, k, Y, U);
              return g && X.unshift(g), { externalImports: X, exportSpecifiers: $, exportEquals: P, hasExportStarsToExportValues: k, exportedBindings: A, exportedNames: V, externalHelpersImportDeclaration: g };
              function ne(ue) {
                for (var We = 0, Fe = e.cast(ue.exportClause, e.isNamedExports).elements; We < Fe.length; We++) {
                  var Z = Fe[We];
                  if (!y.get(e.idText(Z.name))) {
                    var Be = Z.propertyName || Z.name;
                    ue.moduleSpecifier || $.add(e.idText(Be), Z);
                    var ge = F.getReferencedImportDeclaration(Be) || F.getReferencedValueDeclaration(Be);
                    ge && m(A, a(ge), Z.name), y.set(e.idText(Z.name), true), V = e.append(V, Z.name);
                  }
                }
              }
            }
            e.collectExternalModuleInfo = N;
            function p(ee, he, F) {
              if (e.isBindingPattern(ee.name)) for (var x = 0, X = ee.name.elements; x < X.length; x++) {
                var $ = X[x];
                e.isOmittedExpression($) || (F = p($, he, F));
              }
              else if (!e.isGeneratedIdentifier(ee.name)) {
                var A = e.idText(ee.name);
                he.get(A) || (he.set(A, true), F = e.append(F, ee.name));
              }
              return F;
            }
            function m(ee, he, F) {
              var x = ee[he];
              return x ? x.push(F) : ee[he] = x = [F], x;
            }
            function G(ee) {
              return e.isStringLiteralLike(ee) || ee.kind === 8 || e.isKeyword(ee.kind) || e.isIdentifier(ee);
            }
            e.isSimpleCopiableExpression = G;
            function oe(ee) {
              return !e.isIdentifier(ee) && G(ee);
            }
            e.isSimpleInlineableExpression = oe;
            function f(ee) {
              return ee >= 64 && ee <= 78;
            }
            e.isCompoundAssignment = f;
            function T(ee) {
              switch (ee) {
                case 64:
                  return 39;
                case 65:
                  return 40;
                case 66:
                  return 41;
                case 67:
                  return 42;
                case 68:
                  return 43;
                case 69:
                  return 44;
                case 70:
                  return 47;
                case 71:
                  return 48;
                case 72:
                  return 49;
                case 73:
                  return 50;
                case 74:
                  return 51;
                case 78:
                  return 52;
                case 75:
                  return 56;
                case 76:
                  return 55;
                case 77:
                  return 60;
              }
            }
            e.getNonAssignmentOperatorForCompoundAssignment = T;
            function K(ee) {
              if (!!e.isExpressionStatement(ee)) {
                var he = e.skipParentheses(ee.expression);
                return e.isSuperCall(he) ? he : void 0;
              }
            }
            e.getSuperCallFromStatement = K;
            function b(ee, he) {
              for (var F = he; F < ee.length; F += 1) {
                var x = ee[F];
                if (K(x)) return F;
              }
              return -1;
            }
            e.findSuperStatementIndex = b;
            function se(ee, he, F) {
              return e.filter(ee.members, function(x) {
                return R(x, he, F);
              });
            }
            e.getProperties = se;
            function J(ee) {
              return q(ee) || e.isClassStaticBlockDeclaration(ee);
            }
            function ie(ee) {
              return e.filter(ee.members, J);
            }
            e.getStaticPropertiesAndClassStaticBlock = ie;
            function R(ee, he, F) {
              return e.isPropertyDeclaration(ee) && (!!ee.initializer || !he) && e.hasStaticModifier(ee) === F;
            }
            function q(ee) {
              return e.isPropertyDeclaration(ee) && e.hasStaticModifier(ee);
            }
            function O(ee) {
              return ee.kind === 167 && ee.initializer !== void 0;
            }
            e.isInitializedProperty = O;
            function ve(ee) {
              return !e.isStatic(ee) && e.isMethodOrAccessor(ee) && e.isPrivateIdentifier(ee.name);
            }
            e.isNonStaticMethodOrAccessorWithPrivateName = ve;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(q) {
              q[q.All = 0] = "All", q[q.ObjectRest = 1] = "ObjectRest";
            })(a = e.FlattenLevel || (e.FlattenLevel = {}));
            function C(q, O, ve, ee, he, F) {
              var x = q, X;
              if (e.isDestructuringAssignment(q)) for (X = q.right; e.isEmptyArrayLiteral(q.left) || e.isEmptyObjectLiteral(q.left); ) if (e.isDestructuringAssignment(X)) x = q = X, X = q.right;
              else return e.visitNode(X, O, e.isExpression);
              var $, A = { context: ve, level: ee, downlevelIteration: !!ve.getCompilerOptions().downlevelIteration, hoistTempVariables: true, emitExpression: y, emitBindingOrAssignment: V, createArrayBindingOrAssignmentPattern: function(L) {
                return b(ve.factory, L);
              }, createObjectBindingOrAssignmentPattern: function(L) {
                return J(ve.factory, L);
              }, createArrayBindingOrAssignmentElement: R, visitor: O };
              if (X && (X = e.visitNode(X, O, e.isExpression), e.isIdentifier(X) && w(q, X.escapedText) || E(q) ? X = T(A, X, false, x) : he ? X = T(A, X, true, x) : e.nodeIsSynthesized(q) && (x = X)), N(A, q, X, x, e.isDestructuringAssignment(q)), X && he) {
                if (!e.some($)) return X;
                $.push(X);
              }
              return ve.factory.inlineExpressions($) || ve.factory.createOmittedExpression();
              function y(L) {
                $ = e.append($, L);
              }
              function V(L, P, k, Y) {
                e.Debug.assertNode(L, F ? e.isIdentifier : e.isExpression);
                var U = F ? F(L, P, k) : e.setTextRange(ve.factory.createAssignment(e.visitNode(L, O, e.isExpression), P), k);
                U.original = Y, y(U);
              }
            }
            e.flattenDestructuringAssignment = C;
            function w(q, O) {
              var ve = e.getTargetOfBindingOrAssignmentElement(q);
              return e.isBindingOrAssignmentPattern(ve) ? B(ve, O) : e.isIdentifier(ve) ? ve.escapedText === O : false;
            }
            function B(q, O) {
              for (var ve = e.getElementsOfBindingOrAssignmentPattern(q), ee = 0, he = ve; ee < he.length; ee++) {
                var F = he[ee];
                if (w(F, O)) return true;
              }
              return false;
            }
            function E(q) {
              var O = e.tryGetPropertyNameOfBindingOrAssignmentElement(q);
              if (O && e.isComputedPropertyName(O) && !e.isLiteralExpression(O.expression)) return true;
              var ve = e.getTargetOfBindingOrAssignmentElement(q);
              return !!ve && e.isBindingOrAssignmentPattern(ve) && Q(ve);
            }
            function Q(q) {
              return !!e.forEach(e.getElementsOfBindingOrAssignmentPattern(q), E);
            }
            function le(q, O, ve, ee, he, F, x) {
              F === void 0 && (F = false);
              var X, $ = [], A = [], y = { context: ve, level: ee, downlevelIteration: !!ve.getCompilerOptions().downlevelIteration, hoistTempVariables: F, emitExpression: fe, emitBindingOrAssignment: g, createArrayBindingOrAssignmentPattern: function(ne) {
                return K(ve.factory, ne);
              }, createObjectBindingOrAssignmentPattern: function(ne) {
                return se(ve.factory, ne);
              }, createArrayBindingOrAssignmentElement: function(ne) {
                return ie(ve.factory, ne);
              }, visitor: O };
              if (e.isVariableDeclaration(q)) {
                var V = e.getInitializerOfBindingOrAssignmentElement(q);
                V && (e.isIdentifier(V) && w(q, V.escapedText) || E(q)) && (V = T(y, e.visitNode(V, y.visitor), false, V), q = ve.factory.updateVariableDeclaration(q, q.name, void 0, void 0, V));
              }
              if (N(y, q, he, q, x), X) {
                var L = ve.factory.createTempVariable(void 0);
                if (F) {
                  var P = ve.factory.inlineExpressions(X);
                  X = void 0, g(L, P, void 0, void 0);
                } else {
                  ve.hoistVariableDeclaration(L);
                  var k = e.last($);
                  k.pendingExpressions = e.append(k.pendingExpressions, ve.factory.createAssignment(L, k.value)), e.addRange(k.pendingExpressions, X), k.value = L;
                }
              }
              for (var Y = 0, U = $; Y < U.length; Y++) {
                var j = U[Y], H = j.pendingExpressions, I = j.name, P = j.value, l = j.location, d = j.original, D = ve.factory.createVariableDeclaration(I, void 0, void 0, H ? ve.factory.inlineExpressions(e.append(H, P)) : P);
                D.original = d, e.setTextRange(D, l), A.push(D);
              }
              return A;
              function fe(ne) {
                X = e.append(X, ne);
              }
              function g(ne, ue, We, Fe) {
                e.Debug.assertNode(ne, e.isBindingName), X && (ue = ve.factory.inlineExpressions(e.append(X, ue)), X = void 0), $.push({ pendingExpressions: X, name: ne, value: ue, location: We, original: Fe });
              }
            }
            e.flattenDestructuringBinding = le;
            function N(q, O, ve, ee, he) {
              var F = e.getTargetOfBindingOrAssignmentElement(O);
              if (!he) {
                var x = e.visitNode(e.getInitializerOfBindingOrAssignmentElement(O), q.visitor, e.isExpression);
                x ? ve ? (ve = oe(q, ve, x, ee), !e.isSimpleInlineableExpression(x) && e.isBindingOrAssignmentPattern(F) && (ve = T(q, ve, true, ee))) : ve = x : ve || (ve = q.context.factory.createVoidZero());
              }
              e.isObjectBindingOrAssignmentPattern(F) ? p(q, O, F, ve, ee) : e.isArrayBindingOrAssignmentPattern(F) ? m(q, O, F, ve, ee) : q.emitBindingOrAssignment(F, ve, ee, O);
            }
            function p(q, O, ve, ee, he) {
              var F = e.getElementsOfBindingOrAssignmentPattern(ve), x = F.length;
              if (x !== 1) {
                var X = !e.isDeclarationBindingElement(O) || x !== 0;
                ee = T(q, ee, X, he);
              }
              for (var $, A, y = 0; y < x; y++) {
                var V = F[y];
                if (e.getRestIndicatorOfBindingOrAssignmentElement(V)) {
                  if (y === x - 1) {
                    $ && (q.emitBindingOrAssignment(q.createObjectBindingOrAssignmentPattern($), ee, he, ve), $ = void 0);
                    var P = q.context.getEmitHelperFactory().createRestHelper(ee, F, A, ve);
                    N(q, V, P, V);
                  }
                } else {
                  var L = e.getPropertyNameOfBindingOrAssignmentElement(V);
                  if (q.level >= 1 && !(V.transformFlags & 49152) && !(e.getTargetOfBindingOrAssignmentElement(V).transformFlags & 49152) && !e.isComputedPropertyName(L)) $ = e.append($, e.visitNode(V, q.visitor));
                  else {
                    $ && (q.emitBindingOrAssignment(q.createObjectBindingOrAssignmentPattern($), ee, he, ve), $ = void 0);
                    var P = f(q, ee, L);
                    e.isComputedPropertyName(L) && (A = e.append(A, P.argumentExpression)), N(q, V, P, V);
                  }
                }
              }
              $ && q.emitBindingOrAssignment(q.createObjectBindingOrAssignmentPattern($), ee, he, ve);
            }
            function m(q, O, ve, ee, he) {
              var F = e.getElementsOfBindingOrAssignmentPattern(ve), x = F.length;
              if (q.level < 1 && q.downlevelIteration) ee = T(q, e.setTextRange(q.context.getEmitHelperFactory().createReadHelper(ee, x > 0 && e.getRestIndicatorOfBindingOrAssignmentElement(F[x - 1]) ? void 0 : x), he), false, he);
              else if (x !== 1 && (q.level < 1 || x === 0) || e.every(F, e.isOmittedExpression)) {
                var X = !e.isDeclarationBindingElement(O) || x !== 0;
                ee = T(q, ee, X, he);
              }
              for (var $, A, y = 0; y < x; y++) {
                var V = F[y];
                if (q.level >= 1) if (V.transformFlags & 32768 || q.hasTransformedPriorElement && !G(V)) {
                  q.hasTransformedPriorElement = true;
                  var L = q.context.factory.createTempVariable(void 0);
                  q.hoistTempVariables && q.context.hoistVariableDeclaration(L), A = e.append(A, [L, V]), $ = e.append($, q.createArrayBindingOrAssignmentElement(L));
                } else $ = e.append($, V);
                else {
                  if (e.isOmittedExpression(V)) continue;
                  if (e.getRestIndicatorOfBindingOrAssignmentElement(V)) {
                    if (y === x - 1) {
                      var P = q.context.factory.createArraySliceCall(ee, y);
                      N(q, V, P, V);
                    }
                  } else {
                    var P = q.context.factory.createElementAccessExpression(ee, y);
                    N(q, V, P, V);
                  }
                }
              }
              if ($ && q.emitBindingOrAssignment(q.createArrayBindingOrAssignmentPattern($), ee, he, ve), A) for (var k = 0, Y = A; k < Y.length; k++) {
                var U = Y[k], j = U[0], V = U[1];
                N(q, V, j, V);
              }
            }
            function G(q) {
              var O = e.getTargetOfBindingOrAssignmentElement(q);
              if (!O || e.isOmittedExpression(O)) return true;
              var ve = e.tryGetPropertyNameOfBindingOrAssignmentElement(q);
              if (ve && !e.isPropertyNameLiteral(ve)) return false;
              var ee = e.getInitializerOfBindingOrAssignmentElement(q);
              return ee && !e.isSimpleInlineableExpression(ee) ? false : e.isBindingOrAssignmentPattern(O) ? e.every(e.getElementsOfBindingOrAssignmentPattern(O), G) : e.isIdentifier(O);
            }
            function oe(q, O, ve, ee) {
              return O = T(q, O, true, ee), q.context.factory.createConditionalExpression(q.context.factory.createTypeCheck(O, "undefined"), void 0, ve, void 0, O);
            }
            function f(q, O, ve) {
              if (e.isComputedPropertyName(ve)) {
                var ee = T(q, e.visitNode(ve.expression, q.visitor), false, ve);
                return q.context.factory.createElementAccessExpression(O, ee);
              } else if (e.isStringOrNumericLiteralLike(ve)) {
                var ee = e.factory.cloneNode(ve);
                return q.context.factory.createElementAccessExpression(O, ee);
              } else {
                var he = q.context.factory.createIdentifier(e.idText(ve));
                return q.context.factory.createPropertyAccessExpression(O, he);
              }
            }
            function T(q, O, ve, ee) {
              if (e.isIdentifier(O) && ve) return O;
              var he = q.context.factory.createTempVariable(void 0);
              return q.hoistTempVariables ? (q.context.hoistVariableDeclaration(he), q.emitExpression(e.setTextRange(q.context.factory.createAssignment(he, O), ee))) : q.emitBindingOrAssignment(he, O, ee, void 0), he;
            }
            function K(q, O) {
              return e.Debug.assertEachNode(O, e.isArrayBindingElement), q.createArrayBindingPattern(O);
            }
            function b(q, O) {
              return q.createArrayLiteralExpression(e.map(O, q.converters.convertToArrayAssignmentElement));
            }
            function se(q, O) {
              return e.Debug.assertEachNode(O, e.isBindingElement), q.createObjectBindingPattern(O);
            }
            function J(q, O) {
              return q.createObjectLiteralExpression(e.map(O, q.converters.convertToObjectAssignmentElement));
            }
            function ie(q, O) {
              return q.createBindingElement(void 0, void 0, O);
            }
            function R(q) {
              return q;
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(E) {
              E[E.LiftRestriction = 0] = "LiftRestriction", E[E.All = 1] = "All";
            })(a = e.ProcessLevel || (e.ProcessLevel = {}));
            function C(E, Q, le, N, p, m) {
              var G = e.visitNode(Q.tag, le, e.isExpression), oe = [void 0], f = [], T = [], K = Q.template;
              if (m === a.LiftRestriction && !e.hasInvalidEscape(K)) return e.visitEachChild(Q, le, E);
              if (e.isNoSubstitutionTemplateLiteral(K)) f.push(w(K)), T.push(B(K, N));
              else {
                f.push(w(K.head)), T.push(B(K.head, N));
                for (var b = 0, se = K.templateSpans; b < se.length; b++) {
                  var J = se[b];
                  f.push(w(J.literal)), T.push(B(J.literal, N)), oe.push(e.visitNode(J.expression, le, e.isExpression));
                }
              }
              var ie = E.getEmitHelperFactory().createTemplateObjectHelper(e.factory.createArrayLiteralExpression(f), e.factory.createArrayLiteralExpression(T));
              if (e.isExternalModule(N)) {
                var R = e.factory.createUniqueName("templateObject");
                p(R), oe[0] = e.factory.createLogicalOr(R, e.factory.createAssignment(R, ie));
              } else oe[0] = ie;
              return e.factory.createCallExpression(G, void 0, oe);
            }
            e.processTaggedTemplateExpression = C;
            function w(E) {
              return E.templateFlags ? e.factory.createVoidZero() : e.factory.createStringLiteral(E.text);
            }
            function B(E, Q) {
              var le = E.rawText;
              if (le === void 0) {
                e.Debug.assertIsDefined(Q, "Template literal node is missing 'rawText' and does not have a source file. Possibly bad transform."), le = e.getSourceTextOfNodeFromSourceFile(Q, E);
                var N = E.kind === 14 || E.kind === 17;
                le = le.substring(1, le.length - (N ? 1 : 2));
              }
              return le = le.replace(/\r\n?/g, `
`), e.setTextRange(e.factory.createStringLiteral(le), E);
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a = false, C;
            (function(E) {
              E[E.ClassAliases = 1] = "ClassAliases", E[E.NamespaceExports = 2] = "NamespaceExports", E[E.NonQualifiedEnumMembers = 8] = "NonQualifiedEnumMembers";
            })(C || (C = {}));
            var w;
            (function(E) {
              E[E.None = 0] = "None", E[E.HasStaticInitializedProperties = 1] = "HasStaticInitializedProperties", E[E.HasConstructorDecorators = 2] = "HasConstructorDecorators", E[E.HasMemberDecorators = 4] = "HasMemberDecorators", E[E.IsExportOfNamespace = 8] = "IsExportOfNamespace", E[E.IsNamedExternalExport = 16] = "IsNamedExternalExport", E[E.IsDefaultExternalExport = 32] = "IsDefaultExternalExport", E[E.IsDerivedClass = 64] = "IsDerivedClass", E[E.UseImmediatelyInvokedFunctionExpression = 128] = "UseImmediatelyInvokedFunctionExpression", E[E.HasAnyDecorators = 6] = "HasAnyDecorators", E[E.NeedsName = 5] = "NeedsName", E[E.MayNeedImmediatelyInvokedFunctionExpression = 7] = "MayNeedImmediatelyInvokedFunctionExpression", E[E.IsExported = 56] = "IsExported";
            })(w || (w = {}));
            function B(E) {
              var Q = E.factory, le = E.getEmitHelperFactory, N = E.startLexicalEnvironment, p = E.resumeLexicalEnvironment, m = E.endLexicalEnvironment, G = E.hoistVariableDeclaration, oe = E.getEmitResolver(), f = E.getCompilerOptions(), T = e.getStrictOptionValue(f, "strictNullChecks"), K = e.getEmitScriptTarget(f), b = e.getEmitModuleKind(f), se = E.onEmitNode, J = E.onSubstituteNode;
              E.onEmitNode = Co, E.onSubstituteNode = Ko, E.enableSubstitution(206), E.enableSubstitution(207);
              var ie, R, q, O, ve, ee, he, F, x, X;
              return $;
              function $(S) {
                return S.kind === 306 ? A(S) : y(S);
              }
              function A(S) {
                return Q.createBundle(S.sourceFiles.map(y), e.mapDefined(S.prepends, function(Ce) {
                  return Ce.kind === 308 ? e.createUnparsedSourceFile(Ce, "js") : Ce;
                }));
              }
              function y(S) {
                if (S.isDeclarationFile) return S;
                ie = S;
                var Ce = V(S, g);
                return e.addEmitHelpers(Ce, E.readEmitHelpers()), ie = void 0, Ce;
              }
              function V(S, Ce) {
                var qe = O, br = ve, Zr = ee, Si = he;
                L(S);
                var Pi = Ce(S);
                return O !== qe && (ee = Zr), O = qe, ve = br, he = Si, Pi;
              }
              function L(S) {
                switch (S.kind) {
                  case 305:
                  case 263:
                  case 262:
                  case 235:
                    O = S, ve = void 0, ee = void 0;
                    break;
                  case 257:
                  case 256:
                    if (e.hasSyntacticModifier(S, 2)) break;
                    S.name ? ut(S) : e.Debug.assert(S.kind === 257 || e.hasSyntacticModifier(S, 512)), e.isClassDeclaration(S) && (ve = S);
                    break;
                }
              }
              function P(S) {
                return V(S, k);
              }
              function k(S) {
                return S.transformFlags & 1 ? fe(S) : S;
              }
              function Y(S) {
                return V(S, U);
              }
              function U(S) {
                switch (S.kind) {
                  case 266:
                  case 265:
                  case 271:
                  case 272:
                    return j(S);
                  default:
                    return k(S);
                }
              }
              function j(S) {
                var Ce = e.getParseTreeNode(S);
                if (Ce !== S) return S.transformFlags & 1 ? e.visitEachChild(S, P, E) : S;
                switch (S.kind) {
                  case 266:
                    return Bt(S);
                  case 265:
                    return Qa(S);
                  case 271:
                    return Oi(S);
                  case 272:
                    return ji(S);
                  default:
                    e.Debug.fail("Unhandled ellided statement");
                }
              }
              function H(S) {
                return V(S, I);
              }
              function I(S) {
                if (!(S.kind === 272 || S.kind === 266 || S.kind === 267 || S.kind === 265 && S.moduleReference.kind === 277)) return S.transformFlags & 1 || e.hasSyntacticModifier(S, 1) ? fe(S) : S;
              }
              function l(S) {
                return V(S, d);
              }
              function d(S) {
                switch (S.kind) {
                  case 171:
                    return ti(S);
                  case 167:
                    return Jr(S);
                  case 176:
                  case 172:
                  case 173:
                  case 169:
                  case 170:
                    return k(S);
                  case 234:
                    return S;
                  default:
                    return e.Debug.failBadSyntaxKind(S);
                }
              }
              function D(S) {
                if (!(e.modifierToFlag(S.kind) & 116958) && !(R && S.kind === 93)) return S;
              }
              function fe(S) {
                if (e.isStatement(S) && e.hasSyntacticModifier(S, 2)) return Q.createNotEmittedStatement(S);
                switch (S.kind) {
                  case 93:
                  case 88:
                    return R ? void 0 : S;
                  case 123:
                  case 121:
                  case 122:
                  case 126:
                  case 159:
                  case 85:
                  case 135:
                  case 145:
                  case 101:
                  case 144:
                  case 183:
                  case 184:
                  case 185:
                  case 186:
                  case 182:
                  case 177:
                  case 163:
                  case 130:
                  case 155:
                  case 133:
                  case 150:
                  case 147:
                  case 143:
                  case 114:
                  case 151:
                  case 180:
                  case 179:
                  case 181:
                  case 178:
                  case 187:
                  case 188:
                  case 189:
                  case 191:
                  case 192:
                  case 193:
                  case 194:
                  case 195:
                  case 196:
                  case 176:
                  case 165:
                    return;
                  case 259:
                    return Q.createNotEmittedStatement(S);
                  case 167:
                    return Jr(S);
                  case 264:
                    return;
                  case 171:
                    return ti(S);
                  case 258:
                    return Q.createNotEmittedStatement(S);
                  case 257:
                    return Fe(S);
                  case 226:
                    return ge(S);
                  case 291:
                    return pi(S);
                  case 228:
                    return ae(S);
                  case 169:
                    return zr(S);
                  case 172:
                    return Je(S);
                  case 173:
                    return xe(S);
                  case 256:
                    return vr(S);
                  case 213:
                    return mr(S);
                  case 214:
                    return Ar(S);
                  case 164:
                    return Oe(S);
                  case 212:
                    return Ue(S);
                  case 211:
                  case 229:
                    return fr(S);
                  case 208:
                    return gr(S);
                  case 209:
                    return Vr(S);
                  case 210:
                    return Tr(S);
                  case 230:
                    return De(S);
                  case 260:
                    return Wi(S);
                  case 237:
                    return nr(S);
                  case 254:
                    return Pe(S);
                  case 261:
                    return Ki(S);
                  case 265:
                    return Qa(S);
                  case 279:
                    return vi(S);
                  case 280:
                    return Ui(S);
                  default:
                    return e.visitEachChild(S, P, E);
                }
              }
              function g(S) {
                var Ce = e.getStrictOptionValue(f, "alwaysStrict") && !(e.isExternalModule(S) && b >= e.ModuleKind.ES2015) && !e.isJsonSourceFile(S);
                return Q.updateSourceFile(S, e.visitLexicalEnvironment(S.statements, Y, E, 0, Ce));
              }
              function ne(S, Ce) {
                var qe = 0;
                e.some(Ce) && (qe |= 1);
                var br = e.getEffectiveBaseTypeNode(S);
                return br && e.skipOuterExpressions(br.expression).kind !== 104 && (qe |= 64), e.classOrConstructorParameterIsDecorated(S) && (qe |= 2), e.childIsDecorated(S) && (qe |= 4), ai(S) ? qe |= 8 : Ba(S) ? qe |= 32 : ka(S) && (qe |= 16), K <= 1 && qe & 7 && (qe |= 128), qe;
              }
              function ue(S) {
                return !!(S.transformFlags & 4096);
              }
              function We(S) {
                return e.some(S.decorators) || e.some(S.typeParameters) || e.some(S.heritageClauses, ue) || e.some(S.members, ue);
              }
              function Fe(S) {
                if (!We(S) && !(R && e.hasSyntacticModifier(S, 1))) return e.visitEachChild(S, P, E);
                var Ce = e.getProperties(S, true, true), qe = ne(S, Ce);
                qe & 128 && E.startLexicalEnvironment();
                var br = S.name || (qe & 5 ? Q.getGeneratedNameForNode(S) : void 0), Zr = qe & 2 ? Be(S, br) : Z(S, br, qe), Si = [Zr];
                if (ir(Si, S, false), ir(Si, S, true), Br(Si, S), qe & 128) {
                  var Pi = e.createTokenRange(e.skipTrivia(ie.text, S.members.end), 19), Qi = Q.getInternalName(S), Ct = Q.createPartiallyEmittedExpression(Qi);
                  e.setTextRangeEnd(Ct, Pi.end), e.setEmitFlags(Ct, 1536);
                  var sa = Q.createReturnStatement(Ct);
                  e.setTextRangePos(sa, Pi.pos), e.setEmitFlags(sa, 1920), Si.push(sa), e.insertStatementsAfterStandardPrologue(Si, E.endLexicalEnvironment());
                  var en = Q.createImmediatelyInvokedArrowFunction(Si);
                  e.setEmitFlags(en, 33554432);
                  var Wa = Q.createVariableStatement(void 0, Q.createVariableDeclarationList([Q.createVariableDeclaration(Q.getLocalName(S, false, false), void 0, void 0, en)]));
                  e.setOriginalNode(Wa, S), e.setCommentRange(Wa, S), e.setSourceMapRange(Wa, e.moveRangePastDecorators(S)), e.startOnNewLine(Wa), Si = [Wa];
                }
                return qe & 8 ? Cn(Si, S) : (qe & 128 || qe & 2) && (qe & 32 ? Si.push(Q.createExportDefault(Q.getLocalName(S, false, true))) : qe & 16 && Si.push(Q.createExternalModuleExport(Q.getLocalName(S, false, true)))), Si.length > 1 && (Si.push(Q.createEndOfDeclarationMarker(S)), e.setEmitFlags(Zr, e.getEmitFlags(Zr) | 4194304)), e.singleOrMany(Si);
              }
              function Z(S, Ce, qe) {
                var br = qe & 128 ? void 0 : e.visitNodes(S.modifiers, D, e.isModifier), Zr = Q.createClassDeclaration(void 0, br, Ce, void 0, e.visitNodes(S.heritageClauses, P, e.isHeritageClause), Re(S)), Si = e.getEmitFlags(S);
                return qe & 1 && (Si |= 32), e.setTextRange(Zr, S), e.setOriginalNode(Zr, S), e.setEmitFlags(Zr, Si), Zr;
              }
              function Be(S, Ce) {
                var qe = e.moveRangePastDecorators(S), br = eo(S), Zr = K <= 2 ? Q.getInternalName(S, false, true) : Q.getLocalName(S, false, true), Si = e.visitNodes(S.heritageClauses, P, e.isHeritageClause), Pi = Re(S), Qi = Q.createClassExpression(void 0, void 0, Ce, void 0, Si, Pi);
                e.setOriginalNode(Qi, S), e.setTextRange(Qi, qe);
                var Ct = Q.createVariableStatement(void 0, Q.createVariableDeclarationList([Q.createVariableDeclaration(Zr, void 0, void 0, br ? Q.createAssignment(br, Qi) : Qi)], 1));
                return e.setOriginalNode(Ct, S), e.setTextRange(Ct, qe), e.setCommentRange(Ct, S), Ct;
              }
              function ge(S) {
                if (!We(S)) return e.visitEachChild(S, P, E);
                var Ce = Q.createClassExpression(void 0, void 0, S.name, void 0, e.visitNodes(S.heritageClauses, P, e.isHeritageClause), Re(S));
                return e.setOriginalNode(Ce, S), e.setTextRange(Ce, S), Ce;
              }
              function Re(S) {
                var Ce = [], qe = e.getFirstConstructorWithBody(S), br = qe && e.filter(qe.parameters, function(Qi) {
                  return e.isParameterPropertyDeclaration(Qi, qe);
                });
                if (br) for (var Zr = 0, Si = br; Zr < Si.length; Zr++) {
                  var Pi = Si[Zr];
                  e.isIdentifier(Pi.name) && Ce.push(e.setOriginalNode(Q.createPropertyDeclaration(void 0, void 0, Pi.name, void 0, void 0, void 0), Pi));
                }
                return e.addRange(Ce, e.visitNodes(S.members, l, e.isClassElement)), e.setTextRange(Q.createNodeArray(Ce), S.members);
              }
              function ze(S, Ce) {
                return e.filter(S.members, Ce ? function(qe) {
                  return Ee(qe, S);
                } : function(qe) {
                  return He(qe, S);
                });
              }
              function Ee(S, Ce) {
                return rr(S, true, Ce);
              }
              function He(S, Ce) {
                return rr(S, false, Ce);
              }
              function rr(S, Ce, qe) {
                return e.nodeOrChildIsDecorated(S, qe) && Ce === e.isStatic(S);
              }
              function Ie(S) {
                var Ce;
                if (S) for (var qe = S.parameters, br = qe.length > 0 && e.parameterIsThisKeyword(qe[0]), Zr = br ? 1 : 0, Si = br ? qe.length - 1 : qe.length, Pi = 0; Pi < Si; Pi++) {
                  var Qi = qe[Pi + Zr];
                  (Ce || Qi.decorators) && (Ce || (Ce = new Array(Si)), Ce[Pi] = Qi.decorators);
                }
                return Ce;
              }
              function _e(S) {
                var Ce = S.decorators, qe = Ie(e.getFirstConstructorWithBody(S));
                if (!(!Ce && !qe)) return { decorators: Ce, parameters: qe };
              }
              function we(S, Ce) {
                switch (Ce.kind) {
                  case 172:
                  case 173:
                    return de(S, Ce);
                  case 169:
                    return ye(Ce);
                  case 167:
                    return Ae(Ce);
                  default:
                    return;
                }
              }
              function de(S, Ce) {
                if (!!Ce.body) {
                  var qe = e.getAllAccessorDeclarations(S.members, Ce), br = qe.firstAccessor, Zr = qe.secondAccessor, Si = qe.setAccessor, Pi = br.decorators ? br : Zr && Zr.decorators ? Zr : void 0;
                  if (!(!Pi || Ce !== Pi)) {
                    var Qi = Pi.decorators, Ct = Ie(Si);
                    if (!(!Qi && !Ct)) return { decorators: Qi, parameters: Ct };
                  }
                }
              }
              function ye(S) {
                if (!!S.body) {
                  var Ce = S.decorators, qe = Ie(S);
                  if (!(!Ce && !qe)) return { decorators: Ce, parameters: qe };
                }
              }
              function Ae(S) {
                var Ce = S.decorators;
                if (!!Ce) return { decorators: Ce };
              }
              function er(S, Ce, qe) {
                if (!!qe) {
                  var br = [];
                  return e.addRange(br, e.map(qe.decorators, Ne)), e.addRange(br, e.flatMap(qe.parameters, n)), lr(S, Ce, br), br;
                }
              }
              function ir(S, Ce, qe) {
                e.addRange(S, e.map(Cr(Ce, qe), pn));
              }
              function Cr(S, Ce) {
                for (var qe = ze(S, Ce), br, Zr = 0, Si = qe; Zr < Si.length; Zr++) {
                  var Pi = Si[Zr], Qi = Ye(S, Pi);
                  Qi && (br ? br.push(Qi) : br = [Qi]);
                }
                return br;
              }
              function Ye(S, Ce) {
                var qe = we(S, Ce), br = er(Ce, S, qe);
                if (!!br) {
                  var Zr = Da(S, Ce), Si = Zt(Ce, !e.hasSyntacticModifier(Ce, 2)), Pi = K > 0 ? Ce.kind === 167 ? Q.createVoidZero() : Q.createNull() : void 0, Qi = le().createDecorateHelper(br, Zr, Si, Pi);
                  return e.setTextRange(Qi, e.moveRangePastDecorators(Ce)), e.setEmitFlags(Qi, 1536), Qi;
                }
              }
              function Br(S, Ce) {
                var qe = Er(Ce);
                qe && S.push(e.setOriginalNode(Q.createExpressionStatement(qe), Ce));
              }
              function Er(S) {
                var Ce = _e(S), qe = er(S, S, Ce);
                if (!!qe) {
                  var br = x && x[e.getOriginalNodeId(S)], Zr = K <= 2 ? Q.getInternalName(S, false, true) : Q.getLocalName(S, false, true), Si = le().createDecorateHelper(qe, Zr), Pi = Q.createAssignment(Zr, br ? Q.createAssignment(br, Si) : Si);
                  return e.setEmitFlags(Pi, 1536), e.setSourceMapRange(Pi, e.moveRangePastDecorators(S)), Pi;
                }
              }
              function Ne(S) {
                return e.visitNode(S.expression, P, e.isExpression);
              }
              function n(S, Ce) {
                var qe;
                if (S) {
                  qe = [];
                  for (var br = 0, Zr = S; br < Zr.length; br++) {
                    var Si = Zr[br], Pi = le().createParamHelper(Ne(Si), Ce);
                    e.setTextRange(Pi, Si.expression), e.setEmitFlags(Pi, 1536), qe.push(Pi);
                  }
                }
                return qe;
              }
              function lr(S, Ce, qe) {
                a ? Ge(S, Ce, qe) : be(S, Ce, qe);
              }
              function be(S, Ce, qe) {
                f.emitDecoratorMetadata && (ur(S) && qe.push(le().createMetadataHelper("design:type", Ur(S))), Ir(S) && qe.push(le().createMetadataHelper("design:paramtypes", ii(S, Ce))), yr(S) && qe.push(le().createMetadataHelper("design:returntype", pe(S))));
              }
              function Ge(S, Ce, qe) {
                if (f.emitDecoratorMetadata) {
                  var br = void 0;
                  ur(S) && (br || (br = [])).push(Q.createPropertyAssignment("type", Q.createArrowFunction(void 0, void 0, [], void 0, Q.createToken(38), Ur(S)))), Ir(S) && (br || (br = [])).push(Q.createPropertyAssignment("paramTypes", Q.createArrowFunction(void 0, void 0, [], void 0, Q.createToken(38), ii(S, Ce)))), yr(S) && (br || (br = [])).push(Q.createPropertyAssignment("returnType", Q.createArrowFunction(void 0, void 0, [], void 0, Q.createToken(38), pe(S)))), br && qe.push(le().createMetadataHelper("design:typeinfo", Q.createObjectLiteralExpression(br, true)));
                }
              }
              function ur(S) {
                var Ce = S.kind;
                return Ce === 169 || Ce === 172 || Ce === 173 || Ce === 167;
              }
              function yr(S) {
                return S.kind === 169;
              }
              function Ir(S) {
                switch (S.kind) {
                  case 257:
                  case 226:
                    return e.getFirstConstructorWithBody(S) !== void 0;
                  case 169:
                  case 172:
                  case 173:
                    return true;
                }
                return false;
              }
              function wr(S) {
                var Ce = oe.getAllAccessorDeclarations(S);
                return Ce.setAccessor && e.getSetAccessorTypeAnnotationNode(Ce.setAccessor) || Ce.getAccessor && e.getEffectiveReturnTypeNode(Ce.getAccessor);
              }
              function Ur(S) {
                switch (S.kind) {
                  case 167:
                  case 164:
                    return or(S.type);
                  case 173:
                  case 172:
                    return or(wr(S));
                  case 257:
                  case 226:
                  case 169:
                    return Q.createIdentifier("Function");
                  default:
                    return Q.createVoidZero();
                }
              }
              function ii(S, Ce) {
                var qe = e.isClassLike(S) ? e.getFirstConstructorWithBody(S) : e.isFunctionLike(S) && e.nodeIsPresent(S.body) ? S : void 0, br = [];
                if (qe) for (var Zr = mi(qe, Ce), Si = Zr.length, Pi = 0; Pi < Si; Pi++) {
                  var Qi = Zr[Pi];
                  Pi === 0 && e.isIdentifier(Qi.name) && Qi.name.escapedText === "this" || (Qi.dotDotDotToken ? br.push(or(e.getRestParameterElementType(Qi.type))) : br.push(Ur(Qi)));
                }
                return Q.createArrayLiteralExpression(br);
              }
              function mi(S, Ce) {
                if (Ce && S.kind === 172) {
                  var qe = e.getAllAccessorDeclarations(Ce.members, S).setAccessor;
                  if (qe) return qe.parameters;
                }
                return S.parameters;
              }
              function pe(S) {
                return e.isFunctionLike(S) && S.type ? or(S.type) : e.isAsyncFunction(S) ? Q.createIdentifier("Promise") : Q.createVoidZero();
              }
              function or(S) {
                if (S === void 0) return Q.createIdentifier("Object");
                switch (S.kind) {
                  case 114:
                  case 153:
                  case 143:
                    return Q.createVoidZero();
                  case 191:
                    return or(S.type);
                  case 179:
                  case 180:
                    return Q.createIdentifier("Function");
                  case 183:
                  case 184:
                    return Q.createIdentifier("Array");
                  case 177:
                  case 133:
                    return Q.createIdentifier("Boolean");
                  case 198:
                  case 150:
                    return Q.createIdentifier("String");
                  case 148:
                    return Q.createIdentifier("Object");
                  case 196:
                    switch (S.literal.kind) {
                      case 10:
                      case 14:
                        return Q.createIdentifier("String");
                      case 219:
                      case 8:
                        return Q.createIdentifier("Number");
                      case 9:
                        return Wt();
                      case 110:
                      case 95:
                        return Q.createIdentifier("Boolean");
                      case 104:
                        return Q.createVoidZero();
                      default:
                        return e.Debug.failBadSyntaxKind(S.literal);
                    }
                  case 147:
                    return Q.createIdentifier("Number");
                  case 158:
                    return Wt();
                  case 151:
                    return K < 2 ? Gi() : Q.createIdentifier("Symbol");
                  case 178:
                    return si(S);
                  case 188:
                  case 187:
                    return qr(S.types);
                  case 189:
                    return qr([S.trueType, S.falseType]);
                  case 193:
                    if (S.operator === 145) return or(S.type);
                    break;
                  case 181:
                  case 194:
                  case 195:
                  case 182:
                  case 130:
                  case 155:
                  case 192:
                  case 200:
                    break;
                  case 312:
                  case 313:
                  case 317:
                  case 318:
                  case 319:
                    break;
                  case 314:
                  case 315:
                  case 316:
                    return or(S.type);
                  default:
                    return e.Debug.failBadSyntaxKind(S);
                }
                return Q.createIdentifier("Object");
              }
              function qr(S) {
                for (var Ce, qe = 0, br = S; qe < br.length; qe++) {
                  for (var Zr = br[qe]; Zr.kind === 191; ) Zr = Zr.type;
                  if (Zr.kind !== 143 && !(!T && (Zr.kind === 196 && Zr.literal.kind === 104 || Zr.kind === 153))) {
                    var Si = or(Zr);
                    if (e.isIdentifier(Si) && Si.escapedText === "Object") return Si;
                    if (Ce) {
                      if (!e.isIdentifier(Ce) || !e.isIdentifier(Si) || Ce.escapedText !== Si.escapedText) return Q.createIdentifier("Object");
                    } else Ce = Si;
                  }
                }
                return Ce || Q.createVoidZero();
              }
              function si(S) {
                var Ce = oe.getTypeReferenceSerializationKind(S.typeName, ve || O);
                switch (Ce) {
                  case e.TypeReferenceSerializationKind.Unknown:
                    if (e.findAncestor(S, function(Zr) {
                      return Zr.parent && e.isConditionalTypeNode(Zr.parent) && (Zr.parent.trueType === Zr || Zr.parent.falseType === Zr);
                    })) return Q.createIdentifier("Object");
                    var qe = wi(S.typeName), br = Q.createTempVariable(G);
                    return Q.createConditionalExpression(Q.createTypeCheck(Q.createAssignment(br, qe), "function"), void 0, br, void 0, Q.createIdentifier("Object"));
                  case e.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue:
                    return Xi(S.typeName);
                  case e.TypeReferenceSerializationKind.VoidNullableOrNeverType:
                    return Q.createVoidZero();
                  case e.TypeReferenceSerializationKind.BigIntLikeType:
                    return Wt();
                  case e.TypeReferenceSerializationKind.BooleanType:
                    return Q.createIdentifier("Boolean");
                  case e.TypeReferenceSerializationKind.NumberLikeType:
                    return Q.createIdentifier("Number");
                  case e.TypeReferenceSerializationKind.StringLikeType:
                    return Q.createIdentifier("String");
                  case e.TypeReferenceSerializationKind.ArrayLikeType:
                    return Q.createIdentifier("Array");
                  case e.TypeReferenceSerializationKind.ESSymbolType:
                    return K < 2 ? Gi() : Q.createIdentifier("Symbol");
                  case e.TypeReferenceSerializationKind.TypeWithCallSignature:
                    return Q.createIdentifier("Function");
                  case e.TypeReferenceSerializationKind.Promise:
                    return Q.createIdentifier("Promise");
                  case e.TypeReferenceSerializationKind.ObjectType:
                    return Q.createIdentifier("Object");
                  default:
                    return e.Debug.assertNever(Ce);
                }
              }
              function Di(S, Ce) {
                return Q.createLogicalAnd(Q.createStrictInequality(Q.createTypeOfExpression(S), Q.createStringLiteral("undefined")), Ce);
              }
              function wi(S) {
                if (S.kind === 79) {
                  var Ce = Xi(S);
                  return Di(Ce, Ce);
                }
                if (S.left.kind === 79) return Di(Xi(S.left), Xi(S));
                var qe = wi(S.left), br = Q.createTempVariable(G);
                return Q.createLogicalAnd(Q.createLogicalAnd(qe.left, Q.createStrictInequality(Q.createAssignment(br, qe.right), Q.createVoidZero())), Q.createPropertyAccessExpression(br, S.right));
              }
              function Xi(S) {
                switch (S.kind) {
                  case 79:
                    var Ce = e.setParent(e.setTextRange(e.parseNodeFactory.cloneNode(S), S), S.parent);
                    return Ce.original = void 0, e.setParent(Ce, e.getParseTreeNode(O)), Ce;
                  case 161:
                    return et(S);
                }
              }
              function et(S) {
                return Q.createPropertyAccessExpression(Xi(S.left), S.right);
              }
              function Gi() {
                return Q.createConditionalExpression(Q.createTypeCheck(Q.createIdentifier("Symbol"), "function"), void 0, Q.createIdentifier("Symbol"), void 0, Q.createIdentifier("Object"));
              }
              function Wt() {
                return K < 99 ? Q.createConditionalExpression(Q.createTypeCheck(Q.createIdentifier("BigInt"), "function"), void 0, Q.createIdentifier("BigInt"), void 0, Q.createIdentifier("Object")) : Q.createIdentifier("BigInt");
              }
              function Zt(S, Ce) {
                var qe = S.name;
                return e.isPrivateIdentifier(qe) ? Q.createIdentifier("") : e.isComputedPropertyName(qe) ? Ce && !e.isSimpleInlineableExpression(qe.expression) ? Q.getGeneratedNameForNode(qe) : qe.expression : e.isIdentifier(qe) ? Q.createStringLiteral(e.idText(qe)) : Q.cloneNode(qe);
              }
              function _r(S) {
                var Ce = S.name;
                if (e.isComputedPropertyName(Ce) && (!e.hasStaticModifier(S) && he || e.some(S.decorators))) {
                  var qe = e.visitNode(Ce.expression, P, e.isExpression), br = e.skipPartiallyEmittedExpressions(qe);
                  if (!e.isSimpleInlineableExpression(br)) {
                    var Zr = Q.getGeneratedNameForNode(Ce);
                    return G(Zr), Q.updateComputedPropertyName(Ce, Q.createAssignment(Zr, qe));
                  }
                }
                return e.visitNode(Ce, P, e.isPropertyName);
              }
              function pi(S) {
                if (S.token !== 117) return e.visitEachChild(S, P, E);
              }
              function ae(S) {
                return Q.updateExpressionWithTypeArguments(S, e.visitNode(S.expression, P, e.isLeftHandSideExpression), void 0);
              }
              function Xe(S) {
                return !e.nodeIsMissing(S.body);
              }
              function Jr(S) {
                if (!(S.flags & 16777216 || e.hasSyntacticModifier(S, 128))) {
                  var Ce = Q.updatePropertyDeclaration(S, void 0, e.visitNodes(S.modifiers, P, e.isModifier), _r(S), void 0, void 0, e.visitNode(S.initializer, P));
                  return Ce !== S && (e.setCommentRange(Ce, S), e.setSourceMapRange(Ce, e.moveRangePastDecorators(S))), Ce;
                }
              }
              function ti(S) {
                if (!!Xe(S)) return Q.updateConstructorDeclaration(S, void 0, void 0, e.visitParameterList(S.parameters, P, E), Ze(S.body, S));
              }
              function Ze(S, Ce) {
                var qe = Ce && e.filter(Ce.parameters, function(Ct) {
                  return e.isParameterPropertyDeclaration(Ct, Ce);
                });
                if (!e.some(qe)) return e.visitFunctionBody(S, P, E);
                var br = [];
                p();
                var Zr = Q.copyPrologue(S.statements, br, false, P), Si = e.findSuperStatementIndex(S.statements, Zr);
                Si >= 0 && e.addRange(br, e.visitNodes(S.statements, P, e.isStatement, Zr, Si + 1 - Zr));
                var Pi = e.mapDefined(qe, Sr);
                Si >= 0 ? e.addRange(br, Pi) : br = Ve(Ve(Ve([], br.slice(0, Zr), true), Pi, true), br.slice(Zr), true), e.addRange(br, e.visitNodes(S.statements, P, e.isStatement, Si + 1 + Zr)), br = Q.mergeLexicalEnvironment(br, m());
                var Qi = Q.createBlock(e.setTextRange(Q.createNodeArray(br), S.statements), true);
                return e.setTextRange(Qi, S), e.setOriginalNode(Qi, S), Qi;
              }
              function Sr(S) {
                var Ce = S.name;
                if (!!e.isIdentifier(Ce)) {
                  var qe = e.setParent(e.setTextRange(Q.cloneNode(Ce), Ce), Ce.parent);
                  e.setEmitFlags(qe, 1584);
                  var br = e.setParent(e.setTextRange(Q.cloneNode(Ce), Ce), Ce.parent);
                  return e.setEmitFlags(br, 1536), e.startOnNewLine(e.removeAllComments(e.setTextRange(e.setOriginalNode(Q.createExpressionStatement(Q.createAssignment(e.setTextRange(Q.createPropertyAccessExpression(Q.createThis(), qe), S.name), br)), S), e.moveRangePos(S, -1))));
                }
              }
              function zr(S) {
                if (!!Xe(S)) {
                  var Ce = Q.updateMethodDeclaration(S, void 0, e.visitNodes(S.modifiers, D, e.isModifier), S.asteriskToken, _r(S), void 0, void 0, e.visitParameterList(S.parameters, P, E), void 0, e.visitFunctionBody(S.body, P, E));
                  return Ce !== S && (e.setCommentRange(Ce, S), e.setSourceMapRange(Ce, e.moveRangePastDecorators(S))), Ce;
                }
              }
              function Wr(S) {
                return !(e.nodeIsMissing(S.body) && e.hasSyntacticModifier(S, 128));
              }
              function Je(S) {
                if (!!Wr(S)) {
                  var Ce = Q.updateGetAccessorDeclaration(S, void 0, e.visitNodes(S.modifiers, D, e.isModifier), _r(S), e.visitParameterList(S.parameters, P, E), void 0, e.visitFunctionBody(S.body, P, E) || Q.createBlock([]));
                  return Ce !== S && (e.setCommentRange(Ce, S), e.setSourceMapRange(Ce, e.moveRangePastDecorators(S))), Ce;
                }
              }
              function xe(S) {
                if (!!Wr(S)) {
                  var Ce = Q.updateSetAccessorDeclaration(S, void 0, e.visitNodes(S.modifiers, D, e.isModifier), _r(S), e.visitParameterList(S.parameters, P, E), e.visitFunctionBody(S.body, P, E) || Q.createBlock([]));
                  return Ce !== S && (e.setCommentRange(Ce, S), e.setSourceMapRange(Ce, e.moveRangePastDecorators(S))), Ce;
                }
              }
              function vr(S) {
                if (!Xe(S)) return Q.createNotEmittedStatement(S);
                var Ce = Q.updateFunctionDeclaration(S, void 0, e.visitNodes(S.modifiers, D, e.isModifier), S.asteriskToken, S.name, void 0, e.visitParameterList(S.parameters, P, E), void 0, e.visitFunctionBody(S.body, P, E) || Q.createBlock([]));
                if (ai(S)) {
                  var qe = [Ce];
                  return Cn(qe, S), qe;
                }
                return Ce;
              }
              function mr(S) {
                if (!Xe(S)) return Q.createOmittedExpression();
                var Ce = Q.updateFunctionExpression(S, e.visitNodes(S.modifiers, D, e.isModifier), S.asteriskToken, S.name, void 0, e.visitParameterList(S.parameters, P, E), void 0, e.visitFunctionBody(S.body, P, E) || Q.createBlock([]));
                return Ce;
              }
              function Ar(S) {
                var Ce = Q.updateArrowFunction(S, e.visitNodes(S.modifiers, D, e.isModifier), void 0, e.visitParameterList(S.parameters, P, E), void 0, S.equalsGreaterThanToken, e.visitFunctionBody(S.body, P, E));
                return Ce;
              }
              function Oe(S) {
                if (!e.parameterIsThisKeyword(S)) {
                  var Ce = Q.updateParameterDeclaration(S, void 0, void 0, S.dotDotDotToken, e.visitNode(S.name, P, e.isBindingName), void 0, void 0, e.visitNode(S.initializer, P, e.isExpression));
                  return Ce !== S && (e.setCommentRange(Ce, S), e.setTextRange(Ce, e.moveRangePastModifiers(S)), e.setSourceMapRange(Ce, e.moveRangePastModifiers(S)), e.setEmitFlags(Ce.name, 32)), Ce;
                }
              }
              function nr(S) {
                if (ai(S)) {
                  var Ce = e.getInitializedVariables(S.declarationList);
                  return Ce.length === 0 ? void 0 : e.setTextRange(Q.createExpressionStatement(Q.inlineExpressions(e.map(Ce, Mr))), S);
                } else return e.visitEachChild(S, P, E);
              }
              function Mr(S) {
                var Ce = S.name;
                return e.isBindingPattern(Ce) ? e.flattenDestructuringAssignment(S, P, E, 0, false, kn) : e.setTextRange(Q.createAssignment(xn(Ce), e.visitNode(S.initializer, P, e.isExpression)), S);
              }
              function Pe(S) {
                var Ce = Q.updateVariableDeclaration(S, e.visitNode(S.name, P, e.isBindingName), void 0, void 0, e.visitNode(S.initializer, P, e.isExpression));
                return S.type && e.setTypeNode(Ce.name, S.type), Ce;
              }
              function Ue(S) {
                var Ce = e.skipOuterExpressions(S.expression, -7);
                if (e.isAssertionExpression(Ce)) {
                  var qe = e.visitNode(S.expression, P, e.isExpression);
                  return Q.createPartiallyEmittedExpression(qe, S);
                }
                return e.visitEachChild(S, P, E);
              }
              function fr(S) {
                var Ce = e.visitNode(S.expression, P, e.isExpression);
                return Q.createPartiallyEmittedExpression(Ce, S);
              }
              function De(S) {
                var Ce = e.visitNode(S.expression, P, e.isLeftHandSideExpression);
                return Q.createPartiallyEmittedExpression(Ce, S);
              }
              function gr(S) {
                return Q.updateCallExpression(S, e.visitNode(S.expression, P, e.isExpression), void 0, e.visitNodes(S.arguments, P, e.isExpression));
              }
              function Vr(S) {
                return Q.updateNewExpression(S, e.visitNode(S.expression, P, e.isExpression), void 0, e.visitNodes(S.arguments, P, e.isExpression));
              }
              function Tr(S) {
                return Q.updateTaggedTemplateExpression(S, e.visitNode(S.tag, P, e.isExpression), void 0, e.visitNode(S.template, P, e.isExpression));
              }
              function vi(S) {
                return Q.updateJsxSelfClosingElement(S, e.visitNode(S.tagName, P, e.isJsxTagNameExpression), void 0, e.visitNode(S.attributes, P, e.isJsxAttributes));
              }
              function Ui(S) {
                return Q.updateJsxOpeningElement(S, e.visitNode(S.tagName, P, e.isJsxTagNameExpression), void 0, e.visitNode(S.attributes, P, e.isJsxAttributes));
              }
              function Yi(S) {
                return !e.isEnumConst(S) || e.shouldPreserveConstEnums(f);
              }
              function Wi(S) {
                if (!Yi(S)) return Q.createNotEmittedStatement(S);
                var Ce = [], qe = 2, br = Ii(Ce, S);
                br && (b !== e.ModuleKind.System || O !== ie) && (qe |= 512);
                var Zr = Kn(S), Si = Pn(S), Pi = e.hasSyntacticModifier(S, 1) ? Q.getExternalModuleOrNamespaceExportName(q, S, false, true) : Q.getLocalName(S, false, true), Qi = Q.createLogicalOr(Pi, Q.createAssignment(Pi, Q.createObjectLiteralExpression()));
                if (xt(S)) {
                  var Ct = Q.getLocalName(S, false, true);
                  Qi = Q.createAssignment(Ct, Qi);
                }
                var sa = Q.createExpressionStatement(Q.createCallExpression(Q.createFunctionExpression(void 0, void 0, void 0, void 0, [Q.createParameterDeclaration(void 0, void 0, void 0, Zr)], void 0, ct(S, Si)), void 0, [Qi]));
                return e.setOriginalNode(sa, S), br && (e.setSyntheticLeadingComments(sa, void 0), e.setSyntheticTrailingComments(sa, void 0)), e.setTextRange(sa, S), e.addEmitFlags(sa, qe), Ce.push(sa), Ce.push(Q.createEndOfDeclarationMarker(S)), Ce;
              }
              function ct(S, Ce) {
                var qe = q;
                q = Ce;
                var br = [];
                N();
                var Zr = e.map(S.members, Li);
                return e.insertStatementsAfterStandardPrologue(br, m()), e.addRange(br, Zr), q = qe, Q.createBlock(e.setTextRange(Q.createNodeArray(br), S.members), true);
              }
              function Li(S) {
                var Ce = Zt(S, false), qe = nt(S), br = Q.createAssignment(Q.createElementAccessExpression(q, Ce), qe), Zr = qe.kind === 10 ? br : Q.createAssignment(Q.createElementAccessExpression(q, br), Ce);
                return e.setTextRange(Q.createExpressionStatement(e.setTextRange(Zr, S)), S);
              }
              function nt(S) {
                var Ce = oe.getConstantValue(S);
                return Ce !== void 0 ? typeof Ce == "string" ? Q.createStringLiteral(Ce) : Q.createNumericLiteral(Ce) : (bo(), S.initializer ? e.visitNode(S.initializer, P, e.isExpression) : Q.createVoidZero());
              }
              function Mt(S) {
                var Ce = e.getParseTreeNode(S, e.isModuleDeclaration);
                return Ce ? e.isInstantiatedModule(Ce, e.shouldPreserveConstEnums(f)) : true;
              }
              function xt(S) {
                return ai(S) || Dn(S) && b !== e.ModuleKind.ES2015 && b !== e.ModuleKind.ES2020 && b !== e.ModuleKind.ES2022 && b !== e.ModuleKind.ESNext && b !== e.ModuleKind.System;
              }
              function ut(S) {
                ee || (ee = new e.Map());
                var Ce = Rt(S);
                ee.has(Ce) || ee.set(Ce, S);
              }
              function Dt(S) {
                if (ee) {
                  var Ce = Rt(S);
                  return ee.get(Ce) === S;
                }
                return true;
              }
              function Rt(S) {
                return e.Debug.assertNode(S.name, e.isIdentifier), S.name.escapedText;
              }
              function Ii(S, Ce) {
                var qe = Q.createVariableStatement(e.visitNodes(Ce.modifiers, D, e.isModifier), Q.createVariableDeclarationList([Q.createVariableDeclaration(Q.getLocalName(Ce, false, true))], O.kind === 305 ? 0 : 1));
                if (e.setOriginalNode(qe, Ce), ut(Ce), Dt(Ce)) return Ce.kind === 260 ? e.setSourceMapRange(qe.declarationList, Ce) : e.setSourceMapRange(qe, Ce), e.setCommentRange(qe, Ce), e.addEmitFlags(qe, 4195328), S.push(qe), true;
                var br = Q.createMergeDeclarationMarker(qe);
                return e.setEmitFlags(br, 4195840), S.push(br), false;
              }
              function Ki(S) {
                if (!Mt(S)) return Q.createNotEmittedStatement(S);
                e.Debug.assertNode(S.name, e.isIdentifier, "A TypeScript namespace should have an Identifier name."), En();
                var Ce = [], qe = 2, br = Ii(Ce, S);
                br && (b !== e.ModuleKind.System || O !== ie) && (qe |= 512);
                var Zr = Kn(S), Si = Pn(S), Pi = e.hasSyntacticModifier(S, 1) ? Q.getExternalModuleOrNamespaceExportName(q, S, false, true) : Q.getLocalName(S, false, true), Qi = Q.createLogicalOr(Pi, Q.createAssignment(Pi, Q.createObjectLiteralExpression()));
                if (xt(S)) {
                  var Ct = Q.getLocalName(S, false, true);
                  Qi = Q.createAssignment(Ct, Qi);
                }
                var sa = Q.createExpressionStatement(Q.createCallExpression(Q.createFunctionExpression(void 0, void 0, void 0, void 0, [Q.createParameterDeclaration(void 0, void 0, void 0, Zr)], void 0, Fi(S, Si)), void 0, [Qi]));
                return e.setOriginalNode(sa, S), br && (e.setSyntheticLeadingComments(sa, void 0), e.setSyntheticTrailingComments(sa, void 0)), e.setTextRange(sa, S), e.addEmitFlags(sa, qe), Ce.push(sa), Ce.push(Q.createEndOfDeclarationMarker(S)), Ce;
              }
              function Fi(S, Ce) {
                var qe = q, br = R, Zr = ee;
                q = Ce, R = S, ee = void 0;
                var Si = [];
                N();
                var Pi, Qi;
                if (S.body) if (S.body.kind === 262) V(S.body, function(Wa) {
                  return e.addRange(Si, e.visitNodes(Wa.statements, H, e.isStatement));
                }), Pi = S.body.statements, Qi = S.body;
                else {
                  var Ct = Ki(S.body);
                  Ct && (e.isArray(Ct) ? e.addRange(Si, Ct) : Si.push(Ct));
                  var sa = ui(S).body;
                  Pi = e.moveRangePos(sa.statements, -1);
                }
                e.insertStatementsAfterStandardPrologue(Si, m()), q = qe, R = br, ee = Zr;
                var en = Q.createBlock(e.setTextRange(Q.createNodeArray(Si), Pi), true);
                return e.setTextRange(en, Qi), (!S.body || S.body.kind !== 262) && e.setEmitFlags(en, e.getEmitFlags(en) | 1536), en;
              }
              function ui(S) {
                if (S.body.kind === 261) {
                  var Ce = ui(S.body);
                  return Ce || S.body;
                }
              }
              function Bt(S) {
                if (!S.importClause) return S;
                if (!S.importClause.isTypeOnly) {
                  var Ce = e.visitNode(S.importClause, wt, e.isImportClause);
                  return Ce || f.importsNotUsedAsValues === 1 || f.importsNotUsedAsValues === 2 ? Q.updateImportDeclaration(S, void 0, void 0, Ce, S.moduleSpecifier, S.assertClause) : void 0;
                }
              }
              function wt(S) {
                e.Debug.assert(!S.isTypeOnly);
                var Ce = Gr(S) ? S.name : void 0, qe = e.visitNode(S.namedBindings, na, e.isNamedImportBindings);
                return Ce || qe ? Q.updateImportClause(S, false, Ce, qe) : void 0;
              }
              function na(S) {
                if (S.kind === 268) return Gr(S) ? S : void 0;
                var Ce = f.preserveValueImports && (f.importsNotUsedAsValues === 1 || f.importsNotUsedAsValues === 2), qe = e.visitNodes(S.elements, Ai, e.isImportSpecifier);
                return Ce || e.some(qe) ? Q.updateNamedImports(S, qe) : void 0;
              }
              function Ai(S) {
                return !S.isTypeOnly && Gr(S) ? S : void 0;
              }
              function Oi(S) {
                return oe.isValueAliasDeclaration(S) ? e.visitEachChild(S, P, E) : void 0;
              }
              function ji(S) {
                if (!S.isTypeOnly) {
                  if (!S.exportClause || e.isNamespaceExport(S.exportClause)) return S;
                  var Ce = !!S.moduleSpecifier && (f.importsNotUsedAsValues === 1 || f.importsNotUsedAsValues === 2), qe = e.visitNode(S.exportClause, function(br) {
                    return At(br, Ce);
                  }, e.isNamedExportBindings);
                  return qe ? Q.updateExportDeclaration(S, void 0, void 0, S.isTypeOnly, qe, S.moduleSpecifier, S.assertClause) : void 0;
                }
              }
              function Vi(S, Ce) {
                var qe = e.visitNodes(S.elements, ba, e.isExportSpecifier);
                return Ce || e.some(qe) ? Q.updateNamedExports(S, qe) : void 0;
              }
              function at(S) {
                return Q.updateNamespaceExport(S, e.visitNode(S.name, P, e.isIdentifier));
              }
              function At(S, Ce) {
                return e.isNamespaceExport(S) ? at(S) : Vi(S, Ce);
              }
              function ba(S) {
                return !S.isTypeOnly && oe.isValueAliasDeclaration(S) ? S : void 0;
              }
              function $a(S) {
                return Gr(S) || !e.isExternalModule(ie) && oe.isTopLevelValueImportEqualsWithEntityName(S);
              }
              function Qa(S) {
                if (!S.isTypeOnly) {
                  if (e.isExternalModuleImportEqualsDeclaration(S)) {
                    var Ce = Gr(S);
                    return !Ce && f.importsNotUsedAsValues === 1 ? e.setOriginalNode(e.setTextRange(Q.createImportDeclaration(void 0, void 0, void 0, S.moduleReference.expression, void 0), S), S) : Ce ? e.visitEachChild(S, P, E) : void 0;
                  }
                  if (!!$a(S)) {
                    var qe = e.createExpressionFromEntityName(Q, S.moduleReference);
                    return e.setEmitFlags(qe, 3584), ka(S) || !ai(S) ? e.setOriginalNode(e.setTextRange(Q.createVariableStatement(e.visitNodes(S.modifiers, D, e.isModifier), Q.createVariableDeclarationList([e.setOriginalNode(Q.createVariableDeclaration(S.name, void 0, void 0, qe), S)])), S), S) : e.setOriginalNode(Bi(S.name, qe, S), S);
                  }
                }
              }
              function ai(S) {
                return R !== void 0 && e.hasSyntacticModifier(S, 1);
              }
              function Dn(S) {
                return R === void 0 && e.hasSyntacticModifier(S, 1);
              }
              function ka(S) {
                return Dn(S) && !e.hasSyntacticModifier(S, 512);
              }
              function Ba(S) {
                return Dn(S) && e.hasSyntacticModifier(S, 512);
              }
              function pn(S) {
                return Q.createExpressionStatement(S);
              }
              function Cn(S, Ce) {
                var qe = Q.createAssignment(Q.getExternalModuleOrNamespaceExportName(q, Ce, false, true), Q.getLocalName(Ce));
                e.setSourceMapRange(qe, e.createRange(Ce.name ? Ce.name.pos : Ce.pos, Ce.end));
                var br = Q.createExpressionStatement(qe);
                e.setSourceMapRange(br, e.createRange(-1, Ce.end)), S.push(br);
              }
              function Bi(S, Ce, qe) {
                return e.setTextRange(Q.createExpressionStatement(Q.createAssignment(Q.getNamespaceMemberName(q, S, false, true), Ce)), qe);
              }
              function kn(S, Ce, qe) {
                return e.setTextRange(Q.createAssignment(xn(S), Ce), qe);
              }
              function xn(S) {
                return Q.getNamespaceMemberName(q, S, false, true);
              }
              function Kn(S) {
                var Ce = Q.getGeneratedNameForNode(S);
                return e.setSourceMapRange(Ce, S.name), Ce;
              }
              function Pn(S) {
                return Q.getGeneratedNameForNode(S);
              }
              function eo(S) {
                if (oe.getNodeCheckFlags(S) & 16777216) {
                  Ro();
                  var Ce = Q.createUniqueName(S.name && !e.isGeneratedIdentifier(S.name) ? e.idText(S.name) : "default");
                  return x[e.getOriginalNodeId(S)] = Ce, G(Ce), Ce;
                }
              }
              function Rn(S) {
                return Q.createPropertyAccessExpression(Q.getDeclarationName(S), "prototype");
              }
              function Da(S, Ce) {
                return e.isStatic(Ce) ? Q.getDeclarationName(S) : Rn(S);
              }
              function bo() {
                (F & 8) === 0 && (F |= 8, E.enableSubstitution(79));
              }
              function Ro() {
                (F & 1) === 0 && (F |= 1, E.enableSubstitution(79), x = []);
              }
              function En() {
                (F & 2) === 0 && (F |= 2, E.enableSubstitution(79), E.enableSubstitution(297), E.enableEmitNotification(261));
              }
              function Wn(S) {
                return e.getOriginalNode(S).kind === 261;
              }
              function to(S) {
                return e.getOriginalNode(S).kind === 260;
              }
              function Co(S, Ce, qe) {
                var br = X, Zr = ie;
                e.isSourceFile(Ce) && (ie = Ce), F & 2 && Wn(Ce) && (X |= 2), F & 8 && to(Ce) && (X |= 8), se(S, Ce, qe), X = br, ie = Zr;
              }
              function Ko(S, Ce) {
                return Ce = J(S, Ce), S === 1 ? no(Ce) : e.isShorthandPropertyAssignment(Ce) ? Oo(Ce) : Ce;
              }
              function Oo(S) {
                if (F & 2) {
                  var Ce = S.name, qe = xi(Ce);
                  if (qe) {
                    if (S.objectAssignmentInitializer) {
                      var br = Q.createAssignment(qe, S.objectAssignmentInitializer);
                      return e.setTextRange(Q.createPropertyAssignment(Ce, br), S);
                    }
                    return e.setTextRange(Q.createPropertyAssignment(Ce, qe), S);
                  }
                }
                return S;
              }
              function no(S) {
                switch (S.kind) {
                  case 79:
                    return $o(S);
                  case 206:
                    return St(S);
                  case 207:
                    return pa(S);
                }
                return S;
              }
              function $o(S) {
                return Pr(S) || xi(S) || S;
              }
              function Pr(S) {
                if (F & 1 && oe.getNodeCheckFlags(S) & 33554432) {
                  var Ce = oe.getReferencedValueDeclaration(S);
                  if (Ce) {
                    var qe = x[Ce.id];
                    if (qe) {
                      var br = Q.cloneNode(qe);
                      return e.setSourceMapRange(br, S), e.setCommentRange(br, S), br;
                    }
                  }
                }
              }
              function xi(S) {
                if (F & X && !e.isGeneratedIdentifier(S) && !e.isLocalName(S)) {
                  var Ce = oe.getReferencedExportContainer(S, false);
                  if (Ce && Ce.kind !== 305) {
                    var qe = X & 2 && Ce.kind === 261 || X & 8 && Ce.kind === 260;
                    if (qe) return e.setTextRange(Q.createPropertyAccessExpression(Q.getGeneratedNameForNode(Ce), S), S);
                  }
                }
              }
              function St(S) {
                return Jn(S);
              }
              function pa(S) {
                return Jn(S);
              }
              function dn(S) {
                return S.replace(/\*\//g, "*_/");
              }
              function Jn(S) {
                var Ce = Qe(S);
                if (Ce !== void 0) {
                  e.setConstantValue(S, Ce);
                  var qe = typeof Ce == "string" ? Q.createStringLiteral(Ce) : Q.createNumericLiteral(Ce);
                  if (!f.removeComments) {
                    var br = e.getOriginalNode(S, e.isAccessExpression);
                    e.addSyntheticTrailingComment(qe, 3, " ".concat(dn(e.getTextOfNode(br)), " "));
                  }
                  return qe;
                }
                return S;
              }
              function Qe(S) {
                if (!f.isolatedModules) return e.isPropertyAccessExpression(S) || e.isElementAccessExpression(S) ? oe.getConstantValue(S) : void 0;
              }
              function Gr(S) {
                return f.preserveValueImports ? oe.isValueAliasDeclaration(S) : oe.isReferencedAliasDeclaration(S);
              }
            }
            e.transformTypeScript = B;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(p) {
              p[p.ClassAliases = 1] = "ClassAliases", p[p.ClassStaticThisOrSuperReference = 2] = "ClassStaticThisOrSuperReference";
            })(a || (a = {}));
            var C;
            (function(p) {
              p.Field = "f", p.Method = "m", p.Accessor = "a";
            })(C = e.PrivateIdentifierKind || (e.PrivateIdentifierKind = {}));
            var w;
            (function(p) {
              p[p.None = 0] = "None", p[p.ClassWasDecorated = 1] = "ClassWasDecorated", p[p.NeedsClassConstructorReference = 2] = "NeedsClassConstructorReference", p[p.NeedsClassSuperReference = 4] = "NeedsClassSuperReference", p[p.NeedsSubstitutionForThisInClassStaticField = 8] = "NeedsSubstitutionForThisInClassStaticField";
            })(w || (w = {}));
            function B(p) {
              var m = p.factory, G = p.hoistVariableDeclaration, oe = p.endLexicalEnvironment, f = p.startLexicalEnvironment, T = p.resumeLexicalEnvironment, K = p.addBlockScopedVariable, b = p.getEmitResolver(), se = p.getCompilerOptions(), J = e.getEmitScriptTarget(se), ie = e.getUseDefineForClassFields(se), R = J < 9, q = J < 9, O = q && J >= 2, ve = p.onSubstituteNode;
              p.onSubstituteNode = qr;
              var ee = p.onEmitNode;
              p.onEmitNode = or;
              var he, F, x, X, $ = [], A = new e.Map(), y, V, L;
              return e.chainBundle(p, P);
              function P(Je) {
                var xe = p.getCompilerOptions();
                if (Je.isDeclarationFile || ie && e.getEmitScriptTarget(xe) >= 9) return Je;
                var vr = e.visitEachChild(Je, U, p);
                return e.addEmitHelpers(vr, p.readEmitHelpers()), vr;
              }
              function k(Je, xe) {
                if (Je.transformFlags & 8388608) switch (Je.kind) {
                  case 226:
                  case 257:
                    return de(Je);
                  case 167:
                    return ue(Je);
                  case 237:
                    return D(Je);
                  case 80:
                    return I(Je);
                  case 170:
                    return Br(Je);
                }
                if (Je.transformFlags & 8388608 || Je.transformFlags & 33554432 && O && L && y) switch (Je.kind) {
                  case 219:
                  case 220:
                    return ge(Je, xe);
                  case 221:
                    return _e(Je, xe);
                  case 208:
                    return He(Je);
                  case 210:
                    return rr(Je);
                  case 206:
                    return Z(Je);
                  case 207:
                    return Be(Je);
                  case 238:
                    return ze(Je);
                  case 242:
                    return Re(Je);
                  case 256:
                  case 213:
                  case 171:
                  case 169:
                  case 172:
                  case 173: {
                    var vr = L;
                    L = void 0;
                    var mr = e.visitEachChild(Je, U, p);
                    return L = vr, mr;
                  }
                }
                return e.visitEachChild(Je, U, p);
              }
              function Y(Je) {
                return k(Je, true);
              }
              function U(Je) {
                return k(Je, false);
              }
              function j(Je) {
                switch (Je.kind) {
                  case 291:
                    return e.visitEachChild(Je, j, p);
                  case 228:
                    return ir(Je);
                }
                return U(Je);
              }
              function H(Je) {
                switch (Je.kind) {
                  case 205:
                  case 204:
                    return Wr(Je);
                  default:
                    return U(Je);
                }
              }
              function I(Je) {
                return !R || e.isStatement(Je.parent) ? Je : e.setOriginalNode(m.createIdentifier(""), Je);
              }
              function l(Je) {
                if (!R) return Je;
                var xe = Je.left;
                e.Debug.assertNode(xe, e.isPrivateIdentifier), e.Debug.assert(Je.operatorToken.kind === 101);
                var vr = ti(xe);
                if (vr) {
                  var mr = e.visitNode(Je.right, U, e.isExpression);
                  return e.setOriginalNode(p.getEmitHelperFactory().createClassPrivateFieldInHelper(vr.brandCheckIdentifier, mr), Je);
                }
                return e.visitEachChild(Je, U, p);
              }
              function d(Je) {
                switch (Je.kind) {
                  case 171:
                    return;
                  case 172:
                  case 173:
                  case 169:
                    return g(Je);
                  case 167:
                    return ue(Je);
                  case 162:
                    return fe(Je);
                  case 234:
                    return Je;
                  default:
                    return U(Je);
                }
              }
              function D(Je) {
                var xe = X;
                X = [];
                var vr = e.visitEachChild(Je, U, p), mr = e.some(X) ? Ve([vr], X, true) : vr;
                return X = xe, mr;
              }
              function fe(Je) {
                var xe = e.visitEachChild(Je, U, p);
                if (e.some(x)) {
                  var vr = x;
                  vr.push(xe.expression), x = [], xe = m.updateComputedPropertyName(xe, m.inlineExpressions(vr));
                }
                return xe;
              }
              function g(Je) {
                if (e.Debug.assert(!e.some(Je.decorators)), !R || !e.isPrivateIdentifier(Je.name)) return e.visitEachChild(Je, d, p);
                var xe = ti(Je.name);
                if (e.Debug.assert(xe, "Undeclared private name for property declaration."), !xe.isValid) return Je;
                var vr = ne(Je);
                vr && pi().push(m.createAssignment(vr, m.createFunctionExpression(e.filter(Je.modifiers, function(mr) {
                  return !e.isStaticModifier(mr);
                }), Je.asteriskToken, vr, void 0, e.visitParameterList(Je.parameters, d, p), void 0, e.visitFunctionBody(Je.body, d, p))));
              }
              function ne(Je) {
                e.Debug.assert(e.isPrivateIdentifier(Je.name));
                var xe = ti(Je.name);
                if (e.Debug.assert(xe, "Undeclared private name for property declaration."), xe.kind === "m") return xe.methodName;
                if (xe.kind === "a") {
                  if (e.isGetAccessor(Je)) return xe.getterName;
                  if (e.isSetAccessor(Je)) return xe.setterName;
                }
              }
              function ue(Je) {
                if (e.Debug.assert(!e.some(Je.decorators)), e.isPrivateIdentifier(Je.name)) {
                  if (!R) return e.isStatic(Je) ? e.visitEachChild(Je, U, p) : m.updatePropertyDeclaration(Je, void 0, e.visitNodes(Je.modifiers, U, e.isModifier), Je.name, void 0, void 0, void 0);
                  var xe = ti(Je.name);
                  if (e.Debug.assert(xe, "Undeclared private name for property declaration."), !xe.isValid) return Je;
                }
                var vr = et(Je.name, !!Je.initializer || ie);
                if (vr && !e.isSimpleInlineableExpression(vr) && pi().push(vr), e.isStatic(Je) && !R && !ie) {
                  var mr = ur(Je, m.createThis());
                  if (mr) {
                    var Ar = m.createClassStaticBlockDeclaration(void 0, void 0, m.createBlock([mr]));
                    return e.setOriginalNode(Ar, Je), e.setCommentRange(Ar, Je), e.setCommentRange(mr, { pos: -1, end: -1 }), e.setSyntheticLeadingComments(mr, void 0), e.setSyntheticTrailingComments(mr, void 0), Ar;
                  }
                }
              }
              function We(Je, xe) {
                return Fe(Je, e.visitNode(xe, U, e.isExpression));
              }
              function Fe(Je, xe) {
                switch (e.setCommentRange(xe, e.moveRangePos(xe, -1)), Je.kind) {
                  case "a":
                    return p.getEmitHelperFactory().createClassPrivateFieldGetHelper(xe, Je.brandCheckIdentifier, Je.kind, Je.getterName);
                  case "m":
                    return p.getEmitHelperFactory().createClassPrivateFieldGetHelper(xe, Je.brandCheckIdentifier, Je.kind, Je.methodName);
                  case "f":
                    return p.getEmitHelperFactory().createClassPrivateFieldGetHelper(xe, Je.brandCheckIdentifier, Je.kind, Je.variableName);
                  default:
                    e.Debug.assertNever(Je, "Unknown private element type");
                }
              }
              function Z(Je) {
                if (R && e.isPrivateIdentifier(Je.name)) {
                  var xe = ti(Je.name);
                  if (xe) return e.setTextRange(e.setOriginalNode(We(xe, Je.expression), Je), Je);
                }
                if (O && e.isSuperProperty(Je) && e.isIdentifier(Je.name) && L && y) {
                  var vr = y.classConstructor, mr = y.superClassReference, Ar = y.facts;
                  if (Ar & 1) return pe(Je);
                  if (vr && mr) {
                    var Oe = m.createReflectGetCall(mr, m.createStringLiteralFromNode(Je.name), vr);
                    return e.setOriginalNode(Oe, Je.expression), e.setTextRange(Oe, Je.expression), Oe;
                  }
                }
                return e.visitEachChild(Je, U, p);
              }
              function Be(Je) {
                if (O && e.isSuperProperty(Je) && L && y) {
                  var xe = y.classConstructor, vr = y.superClassReference, mr = y.facts;
                  if (mr & 1) return pe(Je);
                  if (xe && vr) {
                    var Ar = m.createReflectGetCall(vr, e.visitNode(Je.argumentExpression, U, e.isExpression), xe);
                    return e.setOriginalNode(Ar, Je.expression), e.setTextRange(Ar, Je.expression), Ar;
                  }
                }
                return e.visitEachChild(Je, U, p);
              }
              function ge(Je, xe) {
                if (Je.operator === 45 || Je.operator === 46) {
                  if (R && e.isPrivateIdentifierPropertyAccessExpression(Je.operand)) {
                    var vr = void 0;
                    if (vr = ti(Je.operand.name)) {
                      var mr = e.visitNode(Je.operand.expression, U, e.isExpression), Ar = Ee(mr), Oe = Ar.readExpression, nr = Ar.initializeExpression, Mr = We(vr, Oe), Pe = e.isPrefixUnaryExpression(Je) || xe ? void 0 : m.createTempVariable(G);
                      return Mr = e.expandPreOrPostfixIncrementOrDecrementExpression(m, Je, Mr, G, Pe), Mr = we(vr, nr || Oe, Mr, 63), e.setOriginalNode(Mr, Je), e.setTextRange(Mr, Je), Pe && (Mr = m.createComma(Mr, Pe), e.setTextRange(Mr, Je)), Mr;
                    }
                  } else if (O && e.isSuperProperty(Je.operand) && L && y) {
                    var Ue = y.classConstructor, fr = y.superClassReference, De = y.facts;
                    if (De & 1) {
                      var gr = pe(Je.operand);
                      return e.isPrefixUnaryExpression(Je) ? m.updatePrefixUnaryExpression(Je, gr) : m.updatePostfixUnaryExpression(Je, gr);
                    }
                    if (Ue && fr) {
                      var Vr = void 0, Tr = void 0;
                      if (e.isPropertyAccessExpression(Je.operand) ? e.isIdentifier(Je.operand.name) && (Tr = Vr = m.createStringLiteralFromNode(Je.operand.name)) : e.isSimpleInlineableExpression(Je.operand.argumentExpression) ? Tr = Vr = Je.operand.argumentExpression : (Tr = m.createTempVariable(G), Vr = m.createAssignment(Tr, e.visitNode(Je.operand.argumentExpression, U, e.isExpression))), Vr && Tr) {
                        var Mr = m.createReflectGetCall(fr, Tr, Ue);
                        e.setTextRange(Mr, Je.operand);
                        var Pe = xe ? void 0 : m.createTempVariable(G);
                        return Mr = e.expandPreOrPostfixIncrementOrDecrementExpression(m, Je, Mr, G, Pe), Mr = m.createReflectSetCall(fr, Vr, Mr, Ue), e.setOriginalNode(Mr, Je), e.setTextRange(Mr, Je), Pe && (Mr = m.createComma(Mr, Pe), e.setTextRange(Mr, Je)), Mr;
                      }
                    }
                  }
                }
                return e.visitEachChild(Je, U, p);
              }
              function Re(Je) {
                return m.updateForStatement(Je, e.visitNode(Je.initializer, Y, e.isForInitializer), e.visitNode(Je.condition, U, e.isExpression), e.visitNode(Je.incrementor, Y, e.isExpression), e.visitIterationBody(Je.statement, U, p));
              }
              function ze(Je) {
                return m.updateExpressionStatement(Je, e.visitNode(Je.expression, Y, e.isExpression));
              }
              function Ee(Je) {
                var xe = e.nodeIsSynthesized(Je) ? Je : m.cloneNode(Je);
                if (e.isSimpleInlineableExpression(Je)) return { readExpression: xe, initializeExpression: void 0 };
                var vr = m.createTempVariable(G), mr = m.createAssignment(vr, xe);
                return { readExpression: vr, initializeExpression: mr };
              }
              function He(Je) {
                if (R && e.isPrivateIdentifierPropertyAccessExpression(Je.expression)) {
                  var xe = m.createCallBinding(Je.expression, G, J), vr = xe.thisArg, mr = xe.target;
                  return e.isCallChain(Je) ? m.updateCallChain(Je, m.createPropertyAccessChain(e.visitNode(mr, U), Je.questionDotToken, "call"), void 0, void 0, Ve([e.visitNode(vr, U, e.isExpression)], e.visitNodes(Je.arguments, U, e.isExpression), true)) : m.updateCallExpression(Je, m.createPropertyAccessExpression(e.visitNode(mr, U), "call"), void 0, Ve([e.visitNode(vr, U, e.isExpression)], e.visitNodes(Je.arguments, U, e.isExpression), true));
                }
                if (O && e.isSuperProperty(Je.expression) && L && (y == null ? void 0 : y.classConstructor)) {
                  var Ar = m.createFunctionCallCall(e.visitNode(Je.expression, U, e.isExpression), y.classConstructor, e.visitNodes(Je.arguments, U, e.isExpression));
                  return e.setOriginalNode(Ar, Je), e.setTextRange(Ar, Je), Ar;
                }
                return e.visitEachChild(Je, U, p);
              }
              function rr(Je) {
                if (R && e.isPrivateIdentifierPropertyAccessExpression(Je.tag)) {
                  var xe = m.createCallBinding(Je.tag, G, J), vr = xe.thisArg, mr = xe.target;
                  return m.updateTaggedTemplateExpression(Je, m.createCallExpression(m.createPropertyAccessExpression(e.visitNode(mr, U), "bind"), void 0, [e.visitNode(vr, U, e.isExpression)]), void 0, e.visitNode(Je.template, U, e.isTemplateLiteral));
                }
                if (O && e.isSuperProperty(Je.tag) && L && (y == null ? void 0 : y.classConstructor)) {
                  var Ar = m.createFunctionBindCall(e.visitNode(Je.tag, U, e.isExpression), y.classConstructor, []);
                  return e.setOriginalNode(Ar, Je), e.setTextRange(Ar, Je), m.updateTaggedTemplateExpression(Je, Ar, void 0, e.visitNode(Je.template, U, e.isTemplateLiteral));
                }
                return e.visitEachChild(Je, U, p);
              }
              function Ie(Je) {
                if (R) {
                  y && A.set(e.getOriginalNodeId(Je), y), f();
                  var xe = L;
                  L = Je;
                  var vr = e.visitNodes(Je.body.statements, U, e.isStatement);
                  vr = m.mergeLexicalEnvironment(vr, oe()), L = xe;
                  var mr = m.createImmediatelyInvokedArrowFunction(vr);
                  return e.setOriginalNode(mr, Je), e.setTextRange(mr, Je), e.addEmitFlags(mr, 2), mr;
                }
              }
              function _e(Je, xe) {
                if (e.isDestructuringAssignment(Je)) {
                  var vr = x;
                  x = void 0, Je = m.updateBinaryExpression(Je, e.visitNode(Je.left, H), Je.operatorToken, e.visitNode(Je.right, U));
                  var mr = e.some(x) ? m.inlineExpressions(e.compact(Ve(Ve([], x, true), [Je], false))) : Je;
                  return x = vr, mr;
                }
                if (e.isAssignmentExpression(Je)) {
                  if (R && e.isPrivateIdentifierPropertyAccessExpression(Je.left)) {
                    var Ar = ti(Je.left.name);
                    if (Ar) return e.setTextRange(e.setOriginalNode(we(Ar, Je.left.expression, Je.right, Je.operatorToken.kind), Je), Je);
                  } else if (O && e.isSuperProperty(Je.left) && L && y) {
                    var Oe = y.classConstructor, nr = y.superClassReference, Mr = y.facts;
                    if (Mr & 1) return m.updateBinaryExpression(Je, pe(Je.left), Je.operatorToken, e.visitNode(Je.right, U, e.isExpression));
                    if (Oe && nr) {
                      var Pe = e.isElementAccessExpression(Je.left) ? e.visitNode(Je.left.argumentExpression, U, e.isExpression) : e.isIdentifier(Je.left.name) ? m.createStringLiteralFromNode(Je.left.name) : void 0;
                      if (Pe) {
                        var Ue = e.visitNode(Je.right, U, e.isExpression);
                        if (e.isCompoundAssignment(Je.operatorToken.kind)) {
                          var fr = Pe;
                          e.isSimpleInlineableExpression(Pe) || (fr = m.createTempVariable(G), Pe = m.createAssignment(fr, Pe));
                          var De = m.createReflectGetCall(nr, fr, Oe);
                          e.setOriginalNode(De, Je.left), e.setTextRange(De, Je.left), Ue = m.createBinaryExpression(De, e.getNonAssignmentOperatorForCompoundAssignment(Je.operatorToken.kind), Ue), e.setTextRange(Ue, Je);
                        }
                        var gr = xe ? void 0 : m.createTempVariable(G);
                        return gr && (Ue = m.createAssignment(gr, Ue), e.setTextRange(gr, Je)), Ue = m.createReflectSetCall(nr, Pe, Ue, Oe), e.setOriginalNode(Ue, Je), e.setTextRange(Ue, Je), gr && (Ue = m.createComma(Ue, gr), e.setTextRange(Ue, Je)), Ue;
                      }
                    }
                  }
                }
                return Je.operatorToken.kind === 101 && e.isPrivateIdentifier(Je.left) ? l(Je) : e.visitEachChild(Je, U, p);
              }
              function we(Je, xe, vr, mr) {
                if (xe = e.visitNode(xe, U, e.isExpression), vr = e.visitNode(vr, U, e.isExpression), e.isCompoundAssignment(mr)) {
                  var Ar = Ee(xe), Oe = Ar.readExpression, nr = Ar.initializeExpression;
                  xe = nr || Oe, vr = m.createBinaryExpression(Fe(Je, Oe), e.getNonAssignmentOperatorForCompoundAssignment(mr), vr);
                }
                switch (e.setCommentRange(xe, e.moveRangePos(xe, -1)), Je.kind) {
                  case "a":
                    return p.getEmitHelperFactory().createClassPrivateFieldSetHelper(xe, Je.brandCheckIdentifier, vr, Je.kind, Je.setterName);
                  case "m":
                    return p.getEmitHelperFactory().createClassPrivateFieldSetHelper(xe, Je.brandCheckIdentifier, vr, Je.kind, void 0);
                  case "f":
                    return p.getEmitHelperFactory().createClassPrivateFieldSetHelper(xe, Je.brandCheckIdentifier, vr, Je.kind, Je.variableName);
                  default:
                    e.Debug.assertNever(Je, "Unknown private element type");
                }
              }
              function de(Je) {
                if (!e.forEach(Je.members, ye)) return e.visitEachChild(Je, U, p);
                var xe = x;
                if (x = void 0, Gi(), R) {
                  var vr = e.getNameOfDeclaration(Je);
                  vr && e.isIdentifier(vr) && (_r().className = e.idText(vr));
                  var mr = Ae(Je);
                  e.some(mr) && (_r().weakSetName = Xe("instances", mr[0].name));
                }
                var Ar = e.isClassDeclaration(Je) ? Cr(Je) : Ye(Je);
                return Wt(), x = xe, Ar;
              }
              function ye(Je) {
                return e.isPropertyDeclaration(Je) || e.isClassStaticBlockDeclaration(Je) || R && Je.name && e.isPrivateIdentifier(Je.name);
              }
              function Ae(Je) {
                return e.filter(Je.members, e.isNonStaticMethodOrAccessorWithPrivateName);
              }
              function er(Je) {
                var xe = 0, vr = e.getOriginalNode(Je);
                e.isClassDeclaration(vr) && e.classOrConstructorParameterIsDecorated(vr) && (xe |= 1);
                for (var mr = 0, Ar = Je.members; mr < Ar.length; mr++) {
                  var Oe = Ar[mr];
                  !e.isStatic(Oe) || (Oe.name && e.isPrivateIdentifier(Oe.name) && R && (xe |= 2), (e.isPropertyDeclaration(Oe) || e.isClassStaticBlockDeclaration(Oe)) && (q && Oe.transformFlags & 8192 && (xe |= 8, xe & 1 || (xe |= 2)), O && Oe.transformFlags & 33554432 && (xe & 1 || (xe |= 6))));
                }
                return xe;
              }
              function ir(Je) {
                var xe = (y == null ? void 0 : y.facts) || 0;
                if (xe & 4) {
                  var vr = m.createTempVariable(G, true);
                  return Zt().superClassReference = vr, m.updateExpressionWithTypeArguments(Je, m.createAssignment(vr, e.visitNode(Je.expression, U, e.isExpression)), void 0);
                }
                return e.visitEachChild(Je, U, p);
              }
              function Cr(Je) {
                var xe = er(Je);
                xe && (Zt().facts = xe), xe & 8 && ii();
                var vr;
                if (xe & 2) {
                  var mr = m.createTempVariable(G, true);
                  Zt().classConstructor = m.cloneNode(mr), vr = m.createAssignment(mr, m.getInternalName(Je));
                }
                var Ar = e.getEffectiveBaseTypeNode(Je), Oe = !!(Ar && e.skipOuterExpressions(Ar.expression).kind !== 104), nr = [m.updateClassDeclaration(Je, void 0, Je.modifiers, Je.name, void 0, e.visitNodes(Je.heritageClauses, j, e.isHeritageClause), Er(Je, Oe))];
                vr && pi().unshift(vr), e.some(x) && nr.push(m.createExpressionStatement(m.inlineExpressions(x)));
                var Mr = e.getStaticPropertiesAndClassStaticBlock(Je);
                return e.some(Mr) && Ge(nr, Mr, m.getInternalName(Je)), nr;
              }
              function Ye(Je) {
                var xe = er(Je);
                xe && (Zt().facts = xe), xe & 8 && ii();
                var vr = !!(xe & 1), mr = e.getStaticPropertiesAndClassStaticBlock(Je), Ar = e.getEffectiveBaseTypeNode(Je), Oe = !!(Ar && e.skipOuterExpressions(Ar.expression).kind !== 104), nr = b.getNodeCheckFlags(Je) & 16777216, Mr;
                function Pe() {
                  var Vr = b.getNodeCheckFlags(Je), Tr = Vr & 16777216, vi = Vr & 524288;
                  return m.createTempVariable(vi ? K : G, !!Tr);
                }
                xe & 2 && (Mr = Pe(), Zt().classConstructor = m.cloneNode(Mr));
                var Ue = m.updateClassExpression(Je, e.visitNodes(Je.decorators, U, e.isDecorator), Je.modifiers, Je.name, void 0, e.visitNodes(Je.heritageClauses, j, e.isHeritageClause), Er(Je, Oe)), fr = R && e.some(mr, function(Vr) {
                  return e.isClassStaticBlockDeclaration(Vr) || !!Vr.initializer || e.isPrivateIdentifier(Vr.name);
                });
                if (fr || e.some(x)) {
                  if (vr) return e.Debug.assertIsDefined(X, "Decorated classes transformed by TypeScript are expected to be within a variable declaration."), X && x && e.some(x) && X.push(m.createExpressionStatement(m.inlineExpressions(x))), X && e.some(mr) && Ge(X, mr, m.getInternalName(Je)), Mr ? m.inlineExpressions([m.createAssignment(Mr, Ue), Mr]) : Ue;
                  var De = [];
                  if (Mr || (Mr = Pe()), nr) {
                    Ur();
                    var gr = m.cloneNode(Mr);
                    gr.autoGenerateFlags &= -9, F[e.getOriginalNodeId(Je)] = gr;
                  }
                  return e.setEmitFlags(Ue, 65536 | e.getEmitFlags(Ue)), De.push(e.startOnNewLine(m.createAssignment(Mr, Ue))), e.addRange(De, e.map(x, e.startOnNewLine)), e.addRange(De, yr(mr, Mr)), De.push(e.startOnNewLine(Mr)), m.inlineExpressions(De);
                }
                return Ue;
              }
              function Br(Je) {
                if (!R) return e.visitEachChild(Je, d, p);
              }
              function Er(Je, xe) {
                var vr = [];
                if (R) {
                  for (var mr = 0, Ar = Je.members; mr < Ar.length; mr++) {
                    var Oe = Ar[mr];
                    e.isPrivateIdentifierClassElementDeclaration(Oe) && ae(Oe);
                  }
                  e.some(Ae(Je)) && Ne();
                }
                var nr = lr(Je, xe), Mr = e.visitNodes(Je.members, d, e.isClassElement);
                return nr && vr.push(nr), !R && e.some(x) && (vr.push(m.createClassStaticBlockDeclaration(void 0, void 0, m.createBlock([m.createExpressionStatement(m.inlineExpressions(x))]))), x = void 0), e.addRange(vr, Mr), e.setTextRange(m.createNodeArray(vr), Je.members);
              }
              function Ne() {
                var Je = _r().weakSetName;
                e.Debug.assert(Je, "weakSetName should be set in private identifier environment"), pi().push(m.createAssignment(Je, m.createNewExpression(m.createIdentifier("WeakSet"), void 0, [])));
              }
              function n(Je) {
                return e.isStatic(Je) || e.hasSyntacticModifier(e.getOriginalNode(Je), 128) ? false : ie ? J < 9 : e.isInitializedProperty(Je) || R && e.isPrivateIdentifierClassElementDeclaration(Je);
              }
              function lr(Je, xe) {
                var vr = e.visitNode(e.getFirstConstructorWithBody(Je), U, e.isConstructorDeclaration), mr = Je.members.filter(n);
                if (!e.some(mr)) return vr;
                var Ar = e.visitParameterList(vr ? vr.parameters : void 0, U, p), Oe = be(Je, vr, xe);
                if (!!Oe) return e.startOnNewLine(e.setOriginalNode(e.setTextRange(m.createConstructorDeclaration(void 0, void 0, Ar != null ? Ar : [], Oe), vr || Je), vr));
              }
              function be(Je, xe, vr) {
                var mr, Ar = e.getProperties(Je, false, false);
                ie || (Ar = e.filter(Ar, function(Li) {
                  return !!Li.initializer || e.isPrivateIdentifier(Li.name);
                }));
                var Oe = Ae(Je), nr = e.some(Ar) || e.some(Oe);
                if (!xe && !nr) return e.visitFunctionBody(void 0, U, p);
                T();
                var Mr = !xe && vr, Pe = 0, Ue = 0, fr = -1, De = [];
                !((mr = xe == null ? void 0 : xe.body) === null || mr === void 0) && mr.statements && (Ue = m.copyPrologue(xe.body.statements, De, false, U), fr = e.findSuperStatementIndex(xe.body.statements, Ue), fr >= 0 ? (Pe = fr + 1, De = Ve(Ve(Ve([], De.slice(0, Ue), true), e.visitNodes(xe.body.statements, U, e.isStatement, Ue, Pe - Ue), true), De.slice(Ue), true)) : Ue >= 0 && (Pe = Ue)), Mr && De.push(m.createExpressionStatement(m.createCallExpression(m.createSuper(), void 0, [m.createSpreadElement(m.createIdentifier("arguments"))])));
                var gr = 0;
                if (xe != null && xe.body) if (ie) De = De.filter(function(Li) {
                  return !e.isParameterPropertyDeclaration(e.getOriginalNode(Li), xe);
                });
                else {
                  for (var Vr = 0, Tr = xe.body.statements; Vr < Tr.length; Vr++) {
                    var vi = Tr[Vr];
                    e.isParameterPropertyDeclaration(e.getOriginalNode(vi), xe) && gr++;
                  }
                  if (gr > 0) {
                    var Ui = e.visitNodes(xe.body.statements, U, e.isStatement, Pe, gr);
                    if (fr >= 0) e.addRange(De, Ui);
                    else {
                      var Yi = Ue;
                      Mr && Yi++, De = Ve(Ve(Ve([], De.slice(0, Yi), true), Ui, true), De.slice(Yi), true);
                    }
                    Pe += gr;
                  }
                }
                var Wi = m.createThis();
                return mi(De, Oe, Wi), Ge(De, Ar, Wi), xe && e.addRange(De, e.visitNodes(xe.body.statements, ct, e.isStatement, Pe)), De = m.mergeLexicalEnvironment(De, oe()), e.setTextRange(m.createBlock(e.setTextRange(m.createNodeArray(De), xe ? xe.body.statements : Je.members), true), xe ? xe.body : void 0);
                function ct(Li) {
                  if (!(ie && e.isParameterPropertyDeclaration(e.getOriginalNode(Li), xe))) return U(Li);
                }
              }
              function Ge(Je, xe, vr) {
                for (var mr = 0, Ar = xe; mr < Ar.length; mr++) {
                  var Oe = Ar[mr];
                  if (!(e.isStatic(Oe) && !R && !ie)) {
                    var nr = ur(Oe, vr);
                    !nr || Je.push(nr);
                  }
                }
              }
              function ur(Je, xe) {
                var vr = e.isClassStaticBlockDeclaration(Je) ? Ie(Je) : Ir(Je, xe);
                if (!!vr) {
                  var mr = m.createExpressionStatement(vr);
                  return e.setSourceMapRange(mr, e.moveRangePastModifiers(Je)), e.setCommentRange(mr, Je), e.setOriginalNode(mr, Je), e.setSyntheticLeadingComments(vr, void 0), e.setSyntheticTrailingComments(vr, void 0), mr;
                }
              }
              function yr(Je, xe) {
                for (var vr = [], mr = 0, Ar = Je; mr < Ar.length; mr++) {
                  var Oe = Ar[mr], nr = e.isClassStaticBlockDeclaration(Oe) ? Ie(Oe) : Ir(Oe, xe);
                  !nr || (e.startOnNewLine(nr), e.setSourceMapRange(nr, e.moveRangePastModifiers(Oe)), e.setCommentRange(nr, Oe), e.setOriginalNode(nr, Oe), vr.push(nr));
                }
                return vr;
              }
              function Ir(Je, xe) {
                var vr = L, mr = wr(Je, xe);
                return mr && e.hasStaticModifier(Je) && (y == null ? void 0 : y.facts) && (e.setOriginalNode(mr, Je), e.addEmitFlags(mr, 2), A.set(e.getOriginalNodeId(mr), y)), L = vr, mr;
              }
              function wr(Je, xe) {
                var vr, mr = !ie, Ar = e.isComputedPropertyName(Je.name) && !e.isSimpleInlineableExpression(Je.name.expression) ? m.updateComputedPropertyName(Je.name, m.getGeneratedNameForNode(Je.name)) : Je.name;
                if (e.hasStaticModifier(Je) && (L = Je), R && e.isPrivateIdentifier(Ar)) {
                  var Oe = ti(Ar);
                  if (Oe) return Oe.kind === "f" ? Oe.isStatic ? E(Oe.variableName, e.visitNode(Je.initializer, U, e.isExpression)) : Q(xe, e.visitNode(Je.initializer, U, e.isExpression), Oe.brandCheckIdentifier) : void 0;
                  e.Debug.fail("Undeclared private name for property declaration.");
                }
                if (!((e.isPrivateIdentifier(Ar) || e.hasStaticModifier(Je)) && !Je.initializer)) {
                  var nr = e.getOriginalNode(Je);
                  if (!e.hasSyntacticModifier(nr, 128)) {
                    var Mr = Je.initializer || mr ? (vr = e.visitNode(Je.initializer, U, e.isExpression)) !== null && vr !== void 0 ? vr : m.createVoidZero() : e.isParameterPropertyDeclaration(nr, nr.parent) && e.isIdentifier(Ar) ? Ar : m.createVoidZero();
                    if (mr || e.isPrivateIdentifier(Ar)) {
                      var Pe = e.createMemberAccessForPropertyName(m, xe, Ar, Ar);
                      return m.createAssignment(Pe, Mr);
                    } else {
                      var Ue = e.isComputedPropertyName(Ar) ? Ar.expression : e.isIdentifier(Ar) ? m.createStringLiteral(e.unescapeLeadingUnderscores(Ar.escapedText)) : Ar, fr = m.createPropertyDescriptor({ value: Mr, configurable: true, writable: true, enumerable: true });
                      return m.createObjectDefinePropertyCall(xe, Ue, fr);
                    }
                  }
                }
              }
              function Ur() {
                (he & 1) === 0 && (he |= 1, p.enableSubstitution(79), F = []);
              }
              function ii() {
                (he & 2) === 0 && (he |= 2, p.enableSubstitution(108), p.enableEmitNotification(256), p.enableEmitNotification(213), p.enableEmitNotification(171), p.enableEmitNotification(172), p.enableEmitNotification(173), p.enableEmitNotification(169), p.enableEmitNotification(167), p.enableEmitNotification(162));
              }
              function mi(Je, xe, vr) {
                if (!(!R || !e.some(xe))) {
                  var mr = _r().weakSetName;
                  e.Debug.assert(mr, "weakSetName should be set in private identifier environment"), Je.push(m.createExpressionStatement(le(vr, mr)));
                }
              }
              function pe(Je) {
                return e.isPropertyAccessExpression(Je) ? m.updatePropertyAccessExpression(Je, m.createVoidZero(), Je.name) : m.updateElementAccessExpression(Je, m.createVoidZero(), e.visitNode(Je.argumentExpression, U, e.isExpression));
              }
              function or(Je, xe, vr) {
                var mr = e.getOriginalNode(xe);
                if (mr.id) {
                  var Ar = A.get(mr.id);
                  if (Ar) {
                    var Oe = y, nr = V;
                    y = Ar, V = Ar, ee(Je, xe, vr), y = Oe, V = nr;
                    return;
                  }
                }
                switch (xe.kind) {
                  case 213:
                    if (e.isArrowFunction(mr) || e.getEmitFlags(xe) & 262144) break;
                  case 256:
                  case 171: {
                    var Oe = y, nr = V;
                    y = void 0, V = void 0, ee(Je, xe, vr), y = Oe, V = nr;
                    return;
                  }
                  case 172:
                  case 173:
                  case 169:
                  case 167: {
                    var Oe = y, nr = V;
                    V = y, y = void 0, ee(Je, xe, vr), y = Oe, V = nr;
                    return;
                  }
                  case 162: {
                    var Oe = y, nr = V;
                    y = V, V = void 0, ee(Je, xe, vr), y = Oe, V = nr;
                    return;
                  }
                }
                ee(Je, xe, vr);
              }
              function qr(Je, xe) {
                return xe = ve(Je, xe), Je === 1 ? si(xe) : xe;
              }
              function si(Je) {
                switch (Je.kind) {
                  case 79:
                    return wi(Je);
                  case 108:
                    return Di(Je);
                }
                return Je;
              }
              function Di(Je) {
                if (he & 2 && y) {
                  var xe = y.facts, vr = y.classConstructor;
                  if (xe & 1) return m.createParenthesizedExpression(m.createVoidZero());
                  if (vr) return e.setTextRange(e.setOriginalNode(m.cloneNode(vr), Je), Je);
                }
                return Je;
              }
              function wi(Je) {
                return Xi(Je) || Je;
              }
              function Xi(Je) {
                if (he & 1 && b.getNodeCheckFlags(Je) & 33554432) {
                  var xe = b.getReferencedValueDeclaration(Je);
                  if (xe) {
                    var vr = F[xe.id];
                    if (vr) {
                      var mr = m.cloneNode(vr);
                      return e.setSourceMapRange(mr, Je), e.setCommentRange(mr, Je), mr;
                    }
                  }
                }
              }
              function et(Je, xe) {
                if (e.isComputedPropertyName(Je)) {
                  var vr = e.visitNode(Je.expression, U, e.isExpression), mr = e.skipPartiallyEmittedExpressions(vr), Ar = e.isSimpleInlineableExpression(mr), Oe = e.isAssignmentExpression(mr) && e.isGeneratedIdentifier(mr.left);
                  if (!Oe && !Ar && xe) {
                    var nr = m.getGeneratedNameForNode(Je);
                    return b.getNodeCheckFlags(Je) & 524288 ? K(nr) : G(nr), m.createAssignment(nr, vr);
                  }
                  return Ar || e.isIdentifier(mr) ? void 0 : vr;
                }
              }
              function Gi() {
                $.push(y), y = void 0;
              }
              function Wt() {
                y = $.pop();
              }
              function Zt() {
                return y || (y = { facts: 0, classConstructor: void 0, superClassReference: void 0, privateIdentifierEnvironment: void 0 });
              }
              function _r() {
                var Je = Zt();
                return Je.privateIdentifierEnvironment || (Je.privateIdentifierEnvironment = { className: "", identifiers: new e.Map() }), Je.privateIdentifierEnvironment;
              }
              function pi() {
                return x || (x = []);
              }
              function ae(Je) {
                var xe, vr = e.getTextOfPropertyName(Je.name), mr = Zt(), Ar = mr.classConstructor, Oe = _r(), nr = Oe.weakSetName, Mr = [], Pe = Je.name.escapedText, Ue = Oe.identifiers.get(Pe), fr = !N(Je.name) && Ue === void 0;
                if (e.hasStaticModifier(Je)) if (e.Debug.assert(Ar, "weakSetName should be set in private identifier environment"), e.isPropertyDeclaration(Je)) {
                  var De = Jr(vr, Je);
                  Oe.identifiers.set(Pe, { kind: "f", variableName: De, brandCheckIdentifier: Ar, isStatic: true, isValid: fr });
                } else if (e.isMethodDeclaration(Je)) {
                  var gr = Jr(vr, Je);
                  Oe.identifiers.set(Pe, { kind: "m", methodName: gr, brandCheckIdentifier: Ar, isStatic: true, isValid: fr });
                } else if (e.isGetAccessorDeclaration(Je)) {
                  var Vr = Jr(vr + "_get", Je);
                  (Ue == null ? void 0 : Ue.kind) === "a" && Ue.isStatic && !Ue.getterName ? Ue.getterName = Vr : Oe.identifiers.set(Pe, { kind: "a", getterName: Vr, setterName: void 0, brandCheckIdentifier: Ar, isStatic: true, isValid: fr });
                } else if (e.isSetAccessorDeclaration(Je)) {
                  var Tr = Jr(vr + "_set", Je);
                  (Ue == null ? void 0 : Ue.kind) === "a" && Ue.isStatic && !Ue.setterName ? Ue.setterName = Tr : Oe.identifiers.set(Pe, { kind: "a", getterName: void 0, setterName: Tr, brandCheckIdentifier: Ar, isStatic: true, isValid: fr });
                } else e.Debug.assertNever(Je, "Unknown class element type.");
                else if (e.isPropertyDeclaration(Je)) {
                  var vi = Jr(vr, Je);
                  Oe.identifiers.set(Pe, { kind: "f", brandCheckIdentifier: vi, isStatic: false, variableName: void 0, isValid: fr }), Mr.push(m.createAssignment(vi, m.createNewExpression(m.createIdentifier("WeakMap"), void 0, [])));
                } else if (e.isMethodDeclaration(Je)) e.Debug.assert(nr, "weakSetName should be set in private identifier environment"), Oe.identifiers.set(Pe, { kind: "m", methodName: Jr(vr, Je), brandCheckIdentifier: nr, isStatic: false, isValid: fr });
                else if (e.isAccessor(Je)) if (e.Debug.assert(nr, "weakSetName should be set in private identifier environment"), e.isGetAccessor(Je)) {
                  var Vr = Jr(vr + "_get", Je);
                  (Ue == null ? void 0 : Ue.kind) === "a" && !Ue.isStatic && !Ue.getterName ? Ue.getterName = Vr : Oe.identifiers.set(Pe, { kind: "a", getterName: Vr, setterName: void 0, brandCheckIdentifier: nr, isStatic: false, isValid: fr });
                } else {
                  var Tr = Jr(vr + "_set", Je);
                  (Ue == null ? void 0 : Ue.kind) === "a" && !Ue.isStatic && !Ue.setterName ? Ue.setterName = Tr : Oe.identifiers.set(Pe, { kind: "a", getterName: void 0, setterName: Tr, brandCheckIdentifier: nr, isStatic: false, isValid: fr });
                }
                else e.Debug.assertNever(Je, "Unknown class element type.");
                (xe = pi()).push.apply(xe, Mr);
              }
              function Xe(Je, xe) {
                var vr = _r().className, mr = vr ? "_".concat(vr) : "", Ar = m.createUniqueName("".concat(mr, "_").concat(Je), 16);
                return b.getNodeCheckFlags(xe) & 524288 ? K(Ar) : G(Ar), Ar;
              }
              function Jr(Je, xe) {
                return Xe(Je.substring(1), xe.name);
              }
              function ti(Je) {
                var xe;
                if (y != null && y.privateIdentifierEnvironment) {
                  var vr = y.privateIdentifierEnvironment.identifiers.get(Je.escapedText);
                  if (vr) return vr;
                }
                for (var mr = $.length - 1; mr >= 0; --mr) {
                  var Ar = $[mr];
                  if (!!Ar) {
                    var vr = (xe = Ar.privateIdentifierEnvironment) === null || xe === void 0 ? void 0 : xe.identifiers.get(Je.escapedText);
                    if (vr) return vr;
                  }
                }
              }
              function Ze(Je) {
                var xe = m.getGeneratedNameForNode(Je), vr = ti(Je.name);
                if (!vr) return e.visitEachChild(Je, U, p);
                var mr = Je.expression;
                return (e.isThisProperty(Je) || e.isSuperProperty(Je) || !e.isSimpleCopiableExpression(Je.expression)) && (mr = m.createTempVariable(G, true), pi().push(m.createBinaryExpression(mr, 63, e.visitNode(Je.expression, U, e.isExpression)))), m.createAssignmentTargetWrapper(xe, we(vr, mr, xe, 63));
              }
              function Sr(Je) {
                var xe = e.getTargetOfBindingOrAssignmentElement(Je);
                if (xe) {
                  var vr = void 0;
                  if (e.isPrivateIdentifierPropertyAccessExpression(xe)) vr = Ze(xe);
                  else if (O && e.isSuperProperty(xe) && L && y) {
                    var mr = y.classConstructor, Ar = y.superClassReference, Oe = y.facts;
                    if (Oe & 1) vr = pe(xe);
                    else if (mr && Ar) {
                      var nr = e.isElementAccessExpression(xe) ? e.visitNode(xe.argumentExpression, U, e.isExpression) : e.isIdentifier(xe.name) ? m.createStringLiteralFromNode(xe.name) : void 0;
                      if (nr) {
                        var Mr = m.createTempVariable(void 0);
                        vr = m.createAssignmentTargetWrapper(Mr, m.createReflectSetCall(Ar, nr, Mr, mr));
                      }
                    }
                  }
                  if (vr) return e.isAssignmentExpression(Je) ? m.updateBinaryExpression(Je, vr, Je.operatorToken, e.visitNode(Je.right, U, e.isExpression)) : e.isSpreadElement(Je) ? m.updateSpreadElement(Je, vr) : vr;
                }
                return e.visitNode(Je, H);
              }
              function zr(Je) {
                if (e.isObjectBindingOrAssignmentElement(Je) && !e.isShorthandPropertyAssignment(Je)) {
                  var xe = e.getTargetOfBindingOrAssignmentElement(Je), vr = void 0;
                  if (xe) {
                    if (e.isPrivateIdentifierPropertyAccessExpression(xe)) vr = Ze(xe);
                    else if (O && e.isSuperProperty(xe) && L && y) {
                      var mr = y.classConstructor, Ar = y.superClassReference, Oe = y.facts;
                      if (Oe & 1) vr = pe(xe);
                      else if (mr && Ar) {
                        var nr = e.isElementAccessExpression(xe) ? e.visitNode(xe.argumentExpression, U, e.isExpression) : e.isIdentifier(xe.name) ? m.createStringLiteralFromNode(xe.name) : void 0;
                        if (nr) {
                          var Mr = m.createTempVariable(void 0);
                          vr = m.createAssignmentTargetWrapper(Mr, m.createReflectSetCall(Ar, nr, Mr, mr));
                        }
                      }
                    }
                  }
                  if (e.isPropertyAssignment(Je)) {
                    var Pe = e.getInitializerOfBindingOrAssignmentElement(Je);
                    return m.updatePropertyAssignment(Je, e.visitNode(Je.name, U, e.isPropertyName), vr ? Pe ? m.createAssignment(vr, e.visitNode(Pe, U)) : vr : e.visitNode(Je.initializer, H, e.isExpression));
                  }
                  if (e.isSpreadAssignment(Je)) return m.updateSpreadAssignment(Je, vr || e.visitNode(Je.expression, H, e.isExpression));
                  e.Debug.assert(vr === void 0, "Should not have generated a wrapped target");
                }
                return e.visitNode(Je, U);
              }
              function Wr(Je) {
                return e.isArrayLiteralExpression(Je) ? m.updateArrayLiteralExpression(Je, e.visitNodes(Je.elements, Sr, e.isExpression)) : m.updateObjectLiteralExpression(Je, e.visitNodes(Je.properties, zr, e.isObjectLiteralElementLike));
              }
            }
            e.transformClassFields = B;
            function E(p, m) {
              return e.factory.createAssignment(p, e.factory.createObjectLiteralExpression([e.factory.createPropertyAssignment("value", m || e.factory.createVoidZero())]));
            }
            function Q(p, m, G) {
              return e.factory.createCallExpression(e.factory.createPropertyAccessExpression(G, "set"), void 0, [p, m || e.factory.createVoidZero()]);
            }
            function le(p, m) {
              return e.factory.createCallExpression(e.factory.createPropertyAccessExpression(m, "add"), void 0, [p]);
            }
            function N(p) {
              return p.escapedText === "#constructor";
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(E) {
              E[E.AsyncMethodsWithSuper = 1] = "AsyncMethodsWithSuper";
            })(a || (a = {}));
            var C;
            (function(E) {
              E[E.NonTopLevel = 1] = "NonTopLevel", E[E.HasLexicalThis = 2] = "HasLexicalThis";
            })(C || (C = {}));
            function w(E) {
              var Q = E.factory, le = E.getEmitHelperFactory, N = E.resumeLexicalEnvironment, p = E.endLexicalEnvironment, m = E.hoistVariableDeclaration, G = E.getEmitResolver(), oe = E.getCompilerOptions(), f = e.getEmitScriptTarget(oe), T, K = 0, b, se, J, ie = [], R = 0, q = E.onEmitNode, O = E.onSubstituteNode;
              return E.onEmitNode = Re, E.onSubstituteNode = ze, e.chainBundle(E, ve);
              function ve(de) {
                if (de.isDeclarationFile) return de;
                ee(1, false), ee(2, !e.isEffectiveStrictModeSourceFile(de, oe));
                var ye = e.visitEachChild(de, A, E);
                return e.addEmitHelpers(ye, E.readEmitHelpers()), ye;
              }
              function ee(de, ye) {
                R = ye ? R | de : R & ~de;
              }
              function he(de) {
                return (R & de) !== 0;
              }
              function F() {
                return !he(1);
              }
              function x() {
                return he(2);
              }
              function X(de, ye, Ae) {
                var er = de & ~R;
                if (er) {
                  ee(er, true);
                  var ir = ye(Ae);
                  return ee(er, false), ir;
                }
                return ye(Ae);
              }
              function $(de) {
                return e.visitEachChild(de, A, E);
              }
              function A(de) {
                if ((de.transformFlags & 256) === 0) return de;
                switch (de.kind) {
                  case 131:
                    return;
                  case 218:
                    return U(de);
                  case 169:
                    return X(3, j, de);
                  case 256:
                    return X(3, H, de);
                  case 213:
                    return X(3, I, de);
                  case 214:
                    return X(1, l, de);
                  case 206:
                    return se && e.isPropertyAccessExpression(de) && de.expression.kind === 106 && se.add(de.name.escapedText), e.visitEachChild(de, A, E);
                  case 207:
                    return se && de.expression.kind === 106 && (J = true), e.visitEachChild(de, A, E);
                  case 172:
                  case 173:
                  case 171:
                  case 257:
                  case 226:
                    return X(3, $, de);
                  default:
                    return e.visitEachChild(de, A, E);
                }
              }
              function y(de) {
                if (e.isNodeWithPossibleHoistedDeclaration(de)) switch (de.kind) {
                  case 237:
                    return L(de);
                  case 242:
                    return Y(de);
                  case 243:
                    return P(de);
                  case 244:
                    return k(de);
                  case 292:
                    return V(de);
                  case 235:
                  case 249:
                  case 263:
                  case 289:
                  case 290:
                  case 252:
                  case 240:
                  case 241:
                  case 239:
                  case 248:
                  case 250:
                    return e.visitEachChild(de, y, E);
                  default:
                    return e.Debug.assertNever(de, "Unhandled node.");
                }
                return A(de);
              }
              function V(de) {
                var ye = new e.Set();
                d(de.variableDeclaration, ye);
                var Ae;
                if (ye.forEach(function(Cr, Ye) {
                  b.has(Ye) && (Ae || (Ae = new e.Set(b)), Ae.delete(Ye));
                }), Ae) {
                  var er = b;
                  b = Ae;
                  var ir = e.visitEachChild(de, y, E);
                  return b = er, ir;
                } else return e.visitEachChild(de, y, E);
              }
              function L(de) {
                if (D(de.declarationList)) {
                  var ye = fe(de.declarationList, false);
                  return ye ? Q.createExpressionStatement(ye) : void 0;
                }
                return e.visitEachChild(de, A, E);
              }
              function P(de) {
                return Q.updateForInStatement(de, D(de.initializer) ? fe(de.initializer, true) : e.visitNode(de.initializer, A, e.isForInitializer), e.visitNode(de.expression, A, e.isExpression), e.visitIterationBody(de.statement, y, E));
              }
              function k(de) {
                return Q.updateForOfStatement(de, e.visitNode(de.awaitModifier, A, e.isToken), D(de.initializer) ? fe(de.initializer, true) : e.visitNode(de.initializer, A, e.isForInitializer), e.visitNode(de.expression, A, e.isExpression), e.visitIterationBody(de.statement, y, E));
              }
              function Y(de) {
                var ye = de.initializer;
                return Q.updateForStatement(de, D(ye) ? fe(ye, false) : e.visitNode(de.initializer, A, e.isForInitializer), e.visitNode(de.condition, A, e.isExpression), e.visitNode(de.incrementor, A, e.isExpression), e.visitIterationBody(de.statement, y, E));
              }
              function U(de) {
                return F() ? e.visitEachChild(de, A, E) : e.setOriginalNode(e.setTextRange(Q.createYieldExpression(void 0, e.visitNode(de.expression, A, e.isExpression)), de), de);
              }
              function j(de) {
                return Q.updateMethodDeclaration(de, void 0, e.visitNodes(de.modifiers, A, e.isModifier), de.asteriskToken, de.name, void 0, void 0, e.visitParameterList(de.parameters, A, E), void 0, e.getFunctionFlags(de) & 2 ? Fe(de) : e.visitFunctionBody(de.body, A, E));
              }
              function H(de) {
                return Q.updateFunctionDeclaration(de, void 0, e.visitNodes(de.modifiers, A, e.isModifier), de.asteriskToken, de.name, void 0, e.visitParameterList(de.parameters, A, E), void 0, e.getFunctionFlags(de) & 2 ? Fe(de) : e.visitFunctionBody(de.body, A, E));
              }
              function I(de) {
                return Q.updateFunctionExpression(de, e.visitNodes(de.modifiers, A, e.isModifier), de.asteriskToken, de.name, void 0, e.visitParameterList(de.parameters, A, E), void 0, e.getFunctionFlags(de) & 2 ? Fe(de) : e.visitFunctionBody(de.body, A, E));
              }
              function l(de) {
                return Q.updateArrowFunction(de, e.visitNodes(de.modifiers, A, e.isModifier), void 0, e.visitParameterList(de.parameters, A, E), void 0, de.equalsGreaterThanToken, e.getFunctionFlags(de) & 2 ? Fe(de) : e.visitFunctionBody(de.body, A, E));
              }
              function d(de, ye) {
                var Ae = de.name;
                if (e.isIdentifier(Ae)) ye.add(Ae.escapedText);
                else for (var er = 0, ir = Ae.elements; er < ir.length; er++) {
                  var Cr = ir[er];
                  e.isOmittedExpression(Cr) || d(Cr, ye);
                }
              }
              function D(de) {
                return !!de && e.isVariableDeclarationList(de) && !(de.flags & 3) && de.declarations.some(We);
              }
              function fe(de, ye) {
                g(de);
                var Ae = e.getInitializedVariables(de);
                return Ae.length === 0 ? ye ? e.visitNode(Q.converters.convertToAssignmentElementTarget(de.declarations[0].name), A, e.isExpression) : void 0 : Q.inlineExpressions(e.map(Ae, ue));
              }
              function g(de) {
                e.forEach(de.declarations, ne);
              }
              function ne(de) {
                var ye = de.name;
                if (e.isIdentifier(ye)) m(ye);
                else for (var Ae = 0, er = ye.elements; Ae < er.length; Ae++) {
                  var ir = er[Ae];
                  e.isOmittedExpression(ir) || ne(ir);
                }
              }
              function ue(de) {
                var ye = e.setSourceMapRange(Q.createAssignment(Q.converters.convertToAssignmentElementTarget(de.name), de.initializer), de);
                return e.visitNode(ye, A, e.isExpression);
              }
              function We(de) {
                var ye = de.name;
                if (e.isIdentifier(ye)) return b.has(ye.escapedText);
                for (var Ae = 0, er = ye.elements; Ae < er.length; Ae++) {
                  var ir = er[Ae];
                  if (!e.isOmittedExpression(ir) && We(ir)) return true;
                }
                return false;
              }
              function Fe(de) {
                N();
                var ye = e.getOriginalNode(de, e.isFunctionLike), Ae = ye.type, er = f < 2 ? Be(Ae) : void 0, ir = de.kind === 214, Cr = (G.getNodeCheckFlags(de) & 8192) !== 0, Ye = b;
                b = new e.Set();
                for (var Br = 0, Er = de.parameters; Br < Er.length; Br++) {
                  var Ne = Er[Br];
                  d(Ne, b);
                }
                var n = se, lr = J;
                ir || (se = new e.Set(), J = false);
                var be;
                if (ir) {
                  var Ur = le().createAwaiterHelper(x(), Cr, er, Z(de.body)), ii = p();
                  if (e.some(ii)) {
                    var wr = Q.converters.convertToFunctionBlock(Ur);
                    be = Q.updateBlock(wr, e.setTextRange(Q.createNodeArray(e.concatenate(ii, wr.statements)), wr.statements));
                  } else be = Ur;
                } else {
                  var Ge = [], ur = Q.copyPrologue(de.body.statements, Ge, false, A);
                  Ge.push(Q.createReturnStatement(le().createAwaiterHelper(x(), Cr, er, Z(de.body, ur)))), e.insertStatementsAfterStandardPrologue(Ge, p());
                  var yr = f >= 2 && G.getNodeCheckFlags(de) & 6144;
                  if (yr && (ge(), se.size)) {
                    var Ir = B(Q, G, de, se);
                    ie[e.getNodeId(Ir)] = true, e.insertStatementsAfterStandardPrologue(Ge, [Ir]);
                  }
                  var wr = Q.createBlock(Ge, true);
                  e.setTextRange(wr, de.body), yr && J && (G.getNodeCheckFlags(de) & 4096 ? e.addEmitHelper(wr, e.advancedAsyncSuperHelper) : G.getNodeCheckFlags(de) & 2048 && e.addEmitHelper(wr, e.asyncSuperHelper)), be = wr;
                }
                return b = Ye, ir || (se = n, J = lr), be;
              }
              function Z(de, ye) {
                return e.isBlock(de) ? Q.updateBlock(de, e.visitNodes(de.statements, y, e.isStatement, ye)) : Q.converters.convertToFunctionBlock(e.visitNode(de, y, e.isConciseBody));
              }
              function Be(de) {
                var ye = de && e.getEntityNameFromTypeNode(de);
                if (ye && e.isEntityName(ye)) {
                  var Ae = G.getTypeReferenceSerializationKind(ye);
                  if (Ae === e.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue || Ae === e.TypeReferenceSerializationKind.Unknown) return ye;
                }
              }
              function ge() {
                (T & 1) === 0 && (T |= 1, E.enableSubstitution(208), E.enableSubstitution(206), E.enableSubstitution(207), E.enableEmitNotification(257), E.enableEmitNotification(169), E.enableEmitNotification(172), E.enableEmitNotification(173), E.enableEmitNotification(171), E.enableEmitNotification(237));
              }
              function Re(de, ye, Ae) {
                if (T & 1 && _e(ye)) {
                  var er = G.getNodeCheckFlags(ye) & 6144;
                  if (er !== K) {
                    var ir = K;
                    K = er, q(de, ye, Ae), K = ir;
                    return;
                  }
                } else if (T && ie[e.getNodeId(ye)]) {
                  var ir = K;
                  K = 0, q(de, ye, Ae), K = ir;
                  return;
                }
                q(de, ye, Ae);
              }
              function ze(de, ye) {
                return ye = O(de, ye), de === 1 && K ? Ee(ye) : ye;
              }
              function Ee(de) {
                switch (de.kind) {
                  case 206:
                    return He(de);
                  case 207:
                    return rr(de);
                  case 208:
                    return Ie(de);
                }
                return de;
              }
              function He(de) {
                return de.expression.kind === 106 ? e.setTextRange(Q.createPropertyAccessExpression(Q.createUniqueName("_super", 48), de.name), de) : de;
              }
              function rr(de) {
                return de.expression.kind === 106 ? we(de.argumentExpression, de) : de;
              }
              function Ie(de) {
                var ye = de.expression;
                if (e.isSuperProperty(ye)) {
                  var Ae = e.isPropertyAccessExpression(ye) ? He(ye) : rr(ye);
                  return Q.createCallExpression(Q.createPropertyAccessExpression(Ae, "call"), void 0, Ve([Q.createThis()], de.arguments, true));
                }
                return de;
              }
              function _e(de) {
                var ye = de.kind;
                return ye === 257 || ye === 171 || ye === 169 || ye === 172 || ye === 173;
              }
              function we(de, ye) {
                return K & 4096 ? e.setTextRange(Q.createPropertyAccessExpression(Q.createCallExpression(Q.createUniqueName("_superIndex", 48), void 0, [de]), "value"), ye) : e.setTextRange(Q.createCallExpression(Q.createUniqueName("_superIndex", 48), void 0, [de]), ye);
              }
            }
            e.transformES2017 = w;
            function B(E, Q, le, N) {
              var p = (Q.getNodeCheckFlags(le) & 4096) !== 0, m = [];
              return N.forEach(function(G, oe) {
                var f = e.unescapeLeadingUnderscores(oe), T = [];
                T.push(E.createPropertyAssignment("get", E.createArrowFunction(void 0, void 0, [], void 0, void 0, e.setEmitFlags(E.createPropertyAccessExpression(e.setEmitFlags(E.createSuper(), 4), f), 4)))), p && T.push(E.createPropertyAssignment("set", E.createArrowFunction(void 0, void 0, [E.createParameterDeclaration(void 0, void 0, void 0, "v", void 0, void 0, void 0)], void 0, void 0, E.createAssignment(e.setEmitFlags(E.createPropertyAccessExpression(e.setEmitFlags(E.createSuper(), 4), f), 4), E.createIdentifier("v"))))), m.push(E.createPropertyAssignment(f, E.createObjectLiteralExpression(T)));
              }), E.createVariableStatement(void 0, E.createVariableDeclarationList([E.createVariableDeclaration(E.createUniqueName("_super", 48), void 0, void 0, E.createCallExpression(E.createPropertyAccessExpression(E.createIdentifier("Object"), "create"), void 0, [E.createNull(), E.createObjectLiteralExpression(m, true)]))], 2));
            }
            e.createSuperAccessVariableStatement = B;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(B) {
              B[B.AsyncMethodsWithSuper = 1] = "AsyncMethodsWithSuper";
            })(a || (a = {}));
            var C;
            (function(B) {
              B[B.None = 0] = "None", B[B.HasLexicalThis = 1] = "HasLexicalThis", B[B.IterationContainer = 2] = "IterationContainer", B[B.AncestorFactsMask = 3] = "AncestorFactsMask", B[B.SourceFileIncludes = 1] = "SourceFileIncludes", B[B.SourceFileExcludes = 2] = "SourceFileExcludes", B[B.StrictModeSourceFileIncludes = 0] = "StrictModeSourceFileIncludes", B[B.ClassOrFunctionIncludes = 1] = "ClassOrFunctionIncludes", B[B.ClassOrFunctionExcludes = 2] = "ClassOrFunctionExcludes", B[B.ArrowFunctionIncludes = 0] = "ArrowFunctionIncludes", B[B.ArrowFunctionExcludes = 2] = "ArrowFunctionExcludes", B[B.IterationStatementIncludes = 2] = "IterationStatementIncludes", B[B.IterationStatementExcludes = 0] = "IterationStatementExcludes";
            })(C || (C = {}));
            function w(B) {
              var E = B.factory, Q = B.getEmitHelperFactory, le = B.resumeLexicalEnvironment, N = B.endLexicalEnvironment, p = B.hoistVariableDeclaration, m = B.getEmitResolver(), G = B.getCompilerOptions(), oe = e.getEmitScriptTarget(G), f = B.onEmitNode;
              B.onEmitNode = Ge;
              var T = B.onSubstituteNode;
              B.onSubstituteNode = ur;
              var K = false, b, se, J, ie = 0, R = 0, q, O, ve, ee, he = [];
              return e.chainBundle(B, A);
              function F(pe, or) {
                return R !== (R & ~pe | or);
              }
              function x(pe, or) {
                var qr = R;
                return R = (R & ~pe | or) & 3, qr;
              }
              function X(pe) {
                R = pe;
              }
              function $(pe) {
                O = e.append(O, E.createVariableDeclaration(pe));
              }
              function A(pe) {
                if (pe.isDeclarationFile) return pe;
                q = pe;
                var or = g(pe);
                return e.addEmitHelpers(or, B.readEmitHelpers()), q = void 0, O = void 0, or;
              }
              function y(pe) {
                return Y(pe, false);
              }
              function V(pe) {
                return Y(pe, true);
              }
              function L(pe) {
                if (pe.kind !== 131) return pe;
              }
              function P(pe, or, qr, si) {
                if (F(qr, si)) {
                  var Di = x(qr, si), wi = pe(or);
                  return X(Di), wi;
                }
                return pe(or);
              }
              function k(pe) {
                return e.visitEachChild(pe, y, B);
              }
              function Y(pe, or) {
                if ((pe.transformFlags & 128) === 0) return pe;
                switch (pe.kind) {
                  case 218:
                    return U(pe);
                  case 224:
                    return j(pe);
                  case 247:
                    return H(pe);
                  case 250:
                    return I(pe);
                  case 205:
                    return d(pe);
                  case 221:
                    return ue(pe, or);
                  case 351:
                    return We(pe, or);
                  case 292:
                    return Fe(pe);
                  case 237:
                    return Z(pe);
                  case 254:
                    return Be(pe);
                  case 240:
                  case 241:
                  case 243:
                    return P(k, pe, 0, 2);
                  case 244:
                    return Ee(pe, void 0);
                  case 242:
                    return P(Re, pe, 0, 2);
                  case 217:
                    return ze(pe);
                  case 171:
                    return P(Ae, pe, 2, 1);
                  case 169:
                    return P(Cr, pe, 2, 1);
                  case 172:
                    return P(er, pe, 2, 1);
                  case 173:
                    return P(ir, pe, 2, 1);
                  case 256:
                    return P(Ye, pe, 2, 1);
                  case 213:
                    return P(Er, pe, 2, 1);
                  case 214:
                    return P(Br, pe, 2, 0);
                  case 164:
                    return de(pe);
                  case 238:
                    return D(pe);
                  case 212:
                    return fe(pe, or);
                  case 210:
                    return ne(pe);
                  case 206:
                    return ve && e.isPropertyAccessExpression(pe) && pe.expression.kind === 106 && ve.add(pe.name.escapedText), e.visitEachChild(pe, y, B);
                  case 207:
                    return ve && pe.expression.kind === 106 && (ee = true), e.visitEachChild(pe, y, B);
                  case 257:
                  case 226:
                    return P(k, pe, 2, 1);
                  default:
                    return e.visitEachChild(pe, y, B);
                }
              }
              function U(pe) {
                return se & 2 && se & 1 ? e.setOriginalNode(e.setTextRange(E.createYieldExpression(void 0, Q().createAwaitHelper(e.visitNode(pe.expression, y, e.isExpression))), pe), pe) : e.visitEachChild(pe, y, B);
              }
              function j(pe) {
                if (se & 2 && se & 1) {
                  if (pe.asteriskToken) {
                    var or = e.visitNode(e.Debug.checkDefined(pe.expression), y, e.isExpression);
                    return e.setOriginalNode(e.setTextRange(E.createYieldExpression(void 0, Q().createAwaitHelper(E.updateYieldExpression(pe, pe.asteriskToken, e.setTextRange(Q().createAsyncDelegatorHelper(e.setTextRange(Q().createAsyncValuesHelper(or), or)), or)))), pe), pe);
                  }
                  return e.setOriginalNode(e.setTextRange(E.createYieldExpression(void 0, Ie(pe.expression ? e.visitNode(pe.expression, y, e.isExpression) : E.createVoidZero())), pe), pe);
                }
                return e.visitEachChild(pe, y, B);
              }
              function H(pe) {
                return se & 2 && se & 1 ? E.updateReturnStatement(pe, Ie(pe.expression ? e.visitNode(pe.expression, y, e.isExpression) : E.createVoidZero())) : e.visitEachChild(pe, y, B);
              }
              function I(pe) {
                if (se & 2) {
                  var or = e.unwrapInnermostStatementOfLabel(pe);
                  return or.kind === 244 && or.awaitModifier ? Ee(or, pe) : E.restoreEnclosingLabel(e.visitNode(or, y, e.isStatement, E.liftToBlock), pe);
                }
                return e.visitEachChild(pe, y, B);
              }
              function l(pe) {
                for (var or, qr = [], si = 0, Di = pe; si < Di.length; si++) {
                  var wi = Di[si];
                  if (wi.kind === 298) {
                    or && (qr.push(E.createObjectLiteralExpression(or)), or = void 0);
                    var Xi = wi.expression;
                    qr.push(e.visitNode(Xi, y, e.isExpression));
                  } else or = e.append(or, wi.kind === 296 ? E.createPropertyAssignment(wi.name, e.visitNode(wi.initializer, y, e.isExpression)) : e.visitNode(wi, y, e.isObjectLiteralElementLike));
                }
                return or && qr.push(E.createObjectLiteralExpression(or)), qr;
              }
              function d(pe) {
                if (pe.transformFlags & 32768) {
                  var or = l(pe.properties);
                  or.length && or[0].kind !== 205 && or.unshift(E.createObjectLiteralExpression());
                  var qr = or[0];
                  if (or.length > 1) {
                    for (var si = 1; si < or.length; si++) qr = Q().createAssignHelper([qr, or[si]]);
                    return qr;
                  } else return Q().createAssignHelper(or);
                }
                return e.visitEachChild(pe, y, B);
              }
              function D(pe) {
                return e.visitEachChild(pe, V, B);
              }
              function fe(pe, or) {
                return e.visitEachChild(pe, or ? V : y, B);
              }
              function g(pe) {
                var or = x(2, e.isEffectiveStrictModeSourceFile(pe, G) ? 0 : 1);
                K = false;
                var qr = e.visitEachChild(pe, y, B), si = e.concatenate(qr.statements, O && [E.createVariableStatement(void 0, E.createVariableDeclarationList(O))]), Di = E.updateSourceFile(qr, e.setTextRange(E.createNodeArray(si), pe.statements));
                return X(or), Di;
              }
              function ne(pe) {
                return e.processTaggedTemplateExpression(B, pe, y, q, $, e.ProcessLevel.LiftRestriction);
              }
              function ue(pe, or) {
                return e.isDestructuringAssignment(pe) && pe.left.transformFlags & 32768 ? e.flattenDestructuringAssignment(pe, y, B, 1, !or) : pe.operatorToken.kind === 27 ? E.updateBinaryExpression(pe, e.visitNode(pe.left, V, e.isExpression), pe.operatorToken, e.visitNode(pe.right, or ? V : y, e.isExpression)) : e.visitEachChild(pe, y, B);
              }
              function We(pe, or) {
                if (or) return e.visitEachChild(pe, V, B);
                for (var qr, si = 0; si < pe.elements.length; si++) {
                  var Di = pe.elements[si], wi = e.visitNode(Di, si < pe.elements.length - 1 ? V : y, e.isExpression);
                  (qr || wi !== Di) && (qr || (qr = pe.elements.slice(0, si)), qr.push(wi));
                }
                var Xi = qr ? e.setTextRange(E.createNodeArray(qr), pe.elements) : pe.elements;
                return E.updateCommaListExpression(pe, Xi);
              }
              function Fe(pe) {
                if (pe.variableDeclaration && e.isBindingPattern(pe.variableDeclaration.name) && pe.variableDeclaration.name.transformFlags & 32768) {
                  var or = E.getGeneratedNameForNode(pe.variableDeclaration.name), qr = E.updateVariableDeclaration(pe.variableDeclaration, pe.variableDeclaration.name, void 0, void 0, or), si = e.flattenDestructuringBinding(qr, y, B, 1), Di = e.visitNode(pe.block, y, e.isBlock);
                  return e.some(si) && (Di = E.updateBlock(Di, Ve([E.createVariableStatement(void 0, si)], Di.statements, true))), E.updateCatchClause(pe, E.updateVariableDeclaration(pe.variableDeclaration, or, void 0, void 0, void 0), Di);
                }
                return e.visitEachChild(pe, y, B);
              }
              function Z(pe) {
                if (e.hasSyntacticModifier(pe, 1)) {
                  var or = K;
                  K = true;
                  var qr = e.visitEachChild(pe, y, B);
                  return K = or, qr;
                }
                return e.visitEachChild(pe, y, B);
              }
              function Be(pe) {
                if (K) {
                  var or = K;
                  K = false;
                  var qr = ge(pe, true);
                  return K = or, qr;
                }
                return ge(pe, false);
              }
              function ge(pe, or) {
                return e.isBindingPattern(pe.name) && pe.name.transformFlags & 32768 ? e.flattenDestructuringBinding(pe, y, B, 1, void 0, or) : e.visitEachChild(pe, y, B);
              }
              function Re(pe) {
                return E.updateForStatement(pe, e.visitNode(pe.initializer, V, e.isForInitializer), e.visitNode(pe.condition, y, e.isExpression), e.visitNode(pe.incrementor, V, e.isExpression), e.visitIterationBody(pe.statement, y, B));
              }
              function ze(pe) {
                return e.visitEachChild(pe, V, B);
              }
              function Ee(pe, or) {
                var qr = x(0, 2);
                pe.initializer.transformFlags & 32768 && (pe = He(pe));
                var si = pe.awaitModifier ? _e(pe, or, qr) : E.restoreEnclosingLabel(e.visitEachChild(pe, y, B), or);
                return X(qr), si;
              }
              function He(pe) {
                var or = e.skipParentheses(pe.initializer);
                if (e.isVariableDeclarationList(or) || e.isAssignmentPattern(or)) {
                  var qr = void 0, si = void 0, Di = E.createTempVariable(void 0), wi = [e.createForOfBindingStatement(E, or, Di)];
                  return e.isBlock(pe.statement) ? (e.addRange(wi, pe.statement.statements), qr = pe.statement, si = pe.statement.statements) : pe.statement && (e.append(wi, pe.statement), qr = pe.statement, si = pe.statement), E.updateForOfStatement(pe, pe.awaitModifier, e.setTextRange(E.createVariableDeclarationList([e.setTextRange(E.createVariableDeclaration(Di), pe.initializer)], 1), pe.initializer), pe.expression, e.setTextRange(E.createBlock(e.setTextRange(E.createNodeArray(wi), si), true), qr));
                }
                return pe;
              }
              function rr(pe, or) {
                var qr = e.createForOfBindingStatement(E, pe.initializer, or), si, Di, wi = [e.visitNode(qr, y, e.isStatement)], Xi = e.visitIterationBody(pe.statement, y, B);
                return e.isBlock(Xi) ? (e.addRange(wi, Xi.statements), si = Xi, Di = Xi.statements) : wi.push(Xi), e.setEmitFlags(e.setTextRange(E.createBlock(e.setTextRange(E.createNodeArray(wi), Di), true), si), 432);
              }
              function Ie(pe) {
                return se & 1 ? E.createYieldExpression(void 0, Q().createAwaitHelper(pe)) : E.createAwaitExpression(pe);
              }
              function _e(pe, or, qr) {
                var si = e.visitNode(pe.expression, y, e.isExpression), Di = e.isIdentifier(si) ? E.getGeneratedNameForNode(si) : E.createTempVariable(void 0), wi = e.isIdentifier(si) ? E.getGeneratedNameForNode(Di) : E.createTempVariable(void 0), Xi = E.createUniqueName("e"), et = E.getGeneratedNameForNode(Xi), Gi = E.createTempVariable(void 0), Wt = e.setTextRange(Q().createAsyncValuesHelper(si), pe.expression), Zt = E.createCallExpression(E.createPropertyAccessExpression(Di, "next"), void 0, []), _r = E.createPropertyAccessExpression(wi, "done"), pi = E.createPropertyAccessExpression(wi, "value"), ae = E.createFunctionCallCall(Gi, Di, []);
                p(Xi), p(Gi);
                var Xe = qr & 2 ? E.inlineExpressions([E.createAssignment(Xi, E.createVoidZero()), Wt]) : Wt, Jr = e.setEmitFlags(e.setTextRange(E.createForStatement(e.setEmitFlags(e.setTextRange(E.createVariableDeclarationList([e.setTextRange(E.createVariableDeclaration(Di, void 0, void 0, Xe), pe.expression), E.createVariableDeclaration(wi)]), pe.expression), 2097152), E.createComma(E.createAssignment(wi, Ie(Zt)), E.createLogicalNot(_r)), void 0, rr(pe, pi)), pe), 256);
                return e.setOriginalNode(Jr, pe), E.createTryStatement(E.createBlock([E.restoreEnclosingLabel(Jr, or)]), E.createCatchClause(E.createVariableDeclaration(et), e.setEmitFlags(E.createBlock([E.createExpressionStatement(E.createAssignment(Xi, E.createObjectLiteralExpression([E.createPropertyAssignment("error", et)])))]), 1)), E.createBlock([E.createTryStatement(E.createBlock([e.setEmitFlags(E.createIfStatement(E.createLogicalAnd(E.createLogicalAnd(wi, E.createLogicalNot(_r)), E.createAssignment(Gi, E.createPropertyAccessExpression(Di, "return"))), E.createExpressionStatement(Ie(ae))), 1)]), void 0, e.setEmitFlags(E.createBlock([e.setEmitFlags(E.createIfStatement(Xi, E.createThrowStatement(E.createPropertyAccessExpression(Xi, "error"))), 1)]), 1))]));
              }
              function we(pe) {
                return e.Debug.assertNode(pe, e.isParameter), de(pe);
              }
              function de(pe) {
                return J != null && J.has(pe) ? E.updateParameterDeclaration(pe, void 0, void 0, pe.dotDotDotToken, e.isBindingPattern(pe.name) ? E.getGeneratedNameForNode(pe) : pe.name, void 0, void 0, void 0) : pe.transformFlags & 32768 ? E.updateParameterDeclaration(pe, void 0, void 0, pe.dotDotDotToken, E.getGeneratedNameForNode(pe), void 0, void 0, e.visitNode(pe.initializer, y, e.isExpression)) : e.visitEachChild(pe, y, B);
              }
              function ye(pe) {
                for (var or, qr = 0, si = pe.parameters; qr < si.length; qr++) {
                  var Di = si[qr];
                  or ? or.add(Di) : Di.transformFlags & 32768 && (or = new e.Set());
                }
                return or;
              }
              function Ae(pe) {
                var or = se, qr = J;
                se = e.getFunctionFlags(pe), J = ye(pe);
                var si = E.updateConstructorDeclaration(pe, void 0, pe.modifiers, e.visitParameterList(pe.parameters, we, B), n(pe));
                return se = or, J = qr, si;
              }
              function er(pe) {
                var or = se, qr = J;
                se = e.getFunctionFlags(pe), J = ye(pe);
                var si = E.updateGetAccessorDeclaration(pe, void 0, pe.modifiers, e.visitNode(pe.name, y, e.isPropertyName), e.visitParameterList(pe.parameters, we, B), void 0, n(pe));
                return se = or, J = qr, si;
              }
              function ir(pe) {
                var or = se, qr = J;
                se = e.getFunctionFlags(pe), J = ye(pe);
                var si = E.updateSetAccessorDeclaration(pe, void 0, pe.modifiers, e.visitNode(pe.name, y, e.isPropertyName), e.visitParameterList(pe.parameters, we, B), n(pe));
                return se = or, J = qr, si;
              }
              function Cr(pe) {
                var or = se, qr = J;
                se = e.getFunctionFlags(pe), J = ye(pe);
                var si = E.updateMethodDeclaration(pe, void 0, se & 1 ? e.visitNodes(pe.modifiers, L, e.isModifier) : pe.modifiers, se & 2 ? void 0 : pe.asteriskToken, e.visitNode(pe.name, y, e.isPropertyName), e.visitNode(void 0, y, e.isToken), void 0, e.visitParameterList(pe.parameters, we, B), void 0, se & 2 && se & 1 ? Ne(pe) : n(pe));
                return se = or, J = qr, si;
              }
              function Ye(pe) {
                var or = se, qr = J;
                se = e.getFunctionFlags(pe), J = ye(pe);
                var si = E.updateFunctionDeclaration(pe, void 0, se & 1 ? e.visitNodes(pe.modifiers, L, e.isModifier) : pe.modifiers, se & 2 ? void 0 : pe.asteriskToken, pe.name, void 0, e.visitParameterList(pe.parameters, we, B), void 0, se & 2 && se & 1 ? Ne(pe) : n(pe));
                return se = or, J = qr, si;
              }
              function Br(pe) {
                var or = se, qr = J;
                se = e.getFunctionFlags(pe), J = ye(pe);
                var si = E.updateArrowFunction(pe, pe.modifiers, void 0, e.visitParameterList(pe.parameters, we, B), void 0, pe.equalsGreaterThanToken, n(pe));
                return se = or, J = qr, si;
              }
              function Er(pe) {
                var or = se, qr = J;
                se = e.getFunctionFlags(pe), J = ye(pe);
                var si = E.updateFunctionExpression(pe, se & 1 ? e.visitNodes(pe.modifiers, L, e.isModifier) : pe.modifiers, se & 2 ? void 0 : pe.asteriskToken, pe.name, void 0, e.visitParameterList(pe.parameters, we, B), void 0, se & 2 && se & 1 ? Ne(pe) : n(pe));
                return se = or, J = qr, si;
              }
              function Ne(pe) {
                le();
                var or = [], qr = E.copyPrologue(pe.body.statements, or, false, y);
                lr(or, pe);
                var si = ve, Di = ee;
                ve = new e.Set(), ee = false;
                var wi = E.createReturnStatement(Q().createAsyncGeneratorHelper(E.createFunctionExpression(void 0, E.createToken(41), pe.name && E.getGeneratedNameForNode(pe.name), void 0, [], void 0, E.updateBlock(pe.body, e.visitLexicalEnvironment(pe.body.statements, y, B, qr))), !!(R & 1))), Xi = oe >= 2 && m.getNodeCheckFlags(pe) & 6144;
                if (Xi) {
                  be();
                  var et = e.createSuperAccessVariableStatement(E, m, pe, ve);
                  he[e.getNodeId(et)] = true, e.insertStatementsAfterStandardPrologue(or, [et]);
                }
                or.push(wi), e.insertStatementsAfterStandardPrologue(or, N());
                var Gi = E.updateBlock(pe.body, or);
                return Xi && ee && (m.getNodeCheckFlags(pe) & 4096 ? e.addEmitHelper(Gi, e.advancedAsyncSuperHelper) : m.getNodeCheckFlags(pe) & 2048 && e.addEmitHelper(Gi, e.asyncSuperHelper)), ve = si, ee = Di, Gi;
              }
              function n(pe) {
                var or;
                le();
                var qr = 0, si = [], Di = (or = e.visitNode(pe.body, y, e.isConciseBody)) !== null && or !== void 0 ? or : E.createBlock([]);
                e.isBlock(Di) && (qr = E.copyPrologue(Di.statements, si, false, y)), e.addRange(si, lr(void 0, pe));
                var wi = N();
                if (qr > 0 || e.some(si) || e.some(wi)) {
                  var Xi = E.converters.convertToFunctionBlock(Di, true);
                  return e.insertStatementsAfterStandardPrologue(si, wi), e.addRange(si, Xi.statements.slice(qr)), E.updateBlock(Xi, e.setTextRange(E.createNodeArray(si), Xi.statements));
                }
                return Di;
              }
              function lr(pe, or) {
                for (var qr = false, si = 0, Di = or.parameters; si < Di.length; si++) {
                  var wi = Di[si];
                  if (qr) {
                    if (e.isBindingPattern(wi.name)) {
                      if (wi.name.elements.length > 0) {
                        var Xi = e.flattenDestructuringBinding(wi, y, B, 0, E.getGeneratedNameForNode(wi));
                        if (e.some(Xi)) {
                          var et = E.createVariableDeclarationList(Xi), Gi = E.createVariableStatement(void 0, et);
                          e.setEmitFlags(Gi, 1048576), pe = e.append(pe, Gi);
                        }
                      } else if (wi.initializer) {
                        var Wt = E.getGeneratedNameForNode(wi), Zt = e.visitNode(wi.initializer, y, e.isExpression), _r = E.createAssignment(Wt, Zt), Gi = E.createExpressionStatement(_r);
                        e.setEmitFlags(Gi, 1048576), pe = e.append(pe, Gi);
                      }
                    } else if (wi.initializer) {
                      var Wt = E.cloneNode(wi.name);
                      e.setTextRange(Wt, wi.name), e.setEmitFlags(Wt, 48);
                      var Zt = e.visitNode(wi.initializer, y, e.isExpression);
                      e.addEmitFlags(Zt, 1584);
                      var _r = E.createAssignment(Wt, Zt);
                      e.setTextRange(_r, wi), e.setEmitFlags(_r, 1536);
                      var pi = E.createBlock([E.createExpressionStatement(_r)]);
                      e.setTextRange(pi, wi), e.setEmitFlags(pi, 1953);
                      var ae = E.createTypeCheck(E.cloneNode(wi.name), "undefined"), Gi = E.createIfStatement(ae, pi);
                      e.startOnNewLine(Gi), e.setTextRange(Gi, wi), e.setEmitFlags(Gi, 1050528), pe = e.append(pe, Gi);
                    }
                  } else if (wi.transformFlags & 32768) {
                    qr = true;
                    var Xi = e.flattenDestructuringBinding(wi, y, B, 1, E.getGeneratedNameForNode(wi), false, true);
                    if (e.some(Xi)) {
                      var et = E.createVariableDeclarationList(Xi), Gi = E.createVariableStatement(void 0, et);
                      e.setEmitFlags(Gi, 1048576), pe = e.append(pe, Gi);
                    }
                  }
                }
                return pe;
              }
              function be() {
                (b & 1) === 0 && (b |= 1, B.enableSubstitution(208), B.enableSubstitution(206), B.enableSubstitution(207), B.enableEmitNotification(257), B.enableEmitNotification(169), B.enableEmitNotification(172), B.enableEmitNotification(173), B.enableEmitNotification(171), B.enableEmitNotification(237));
              }
              function Ge(pe, or, qr) {
                if (b & 1 && ii(or)) {
                  var si = m.getNodeCheckFlags(or) & 6144;
                  if (si !== ie) {
                    var Di = ie;
                    ie = si, f(pe, or, qr), ie = Di;
                    return;
                  }
                } else if (b && he[e.getNodeId(or)]) {
                  var Di = ie;
                  ie = 0, f(pe, or, qr), ie = Di;
                  return;
                }
                f(pe, or, qr);
              }
              function ur(pe, or) {
                return or = T(pe, or), pe === 1 && ie ? yr(or) : or;
              }
              function yr(pe) {
                switch (pe.kind) {
                  case 206:
                    return Ir(pe);
                  case 207:
                    return wr(pe);
                  case 208:
                    return Ur(pe);
                }
                return pe;
              }
              function Ir(pe) {
                return pe.expression.kind === 106 ? e.setTextRange(E.createPropertyAccessExpression(E.createUniqueName("_super", 48), pe.name), pe) : pe;
              }
              function wr(pe) {
                return pe.expression.kind === 106 ? mi(pe.argumentExpression, pe) : pe;
              }
              function Ur(pe) {
                var or = pe.expression;
                if (e.isSuperProperty(or)) {
                  var qr = e.isPropertyAccessExpression(or) ? Ir(or) : wr(or);
                  return E.createCallExpression(E.createPropertyAccessExpression(qr, "call"), void 0, Ve([E.createThis()], pe.arguments, true));
                }
                return pe;
              }
              function ii(pe) {
                var or = pe.kind;
                return or === 257 || or === 171 || or === 169 || or === 172 || or === 173;
              }
              function mi(pe, or) {
                return ie & 4096 ? e.setTextRange(E.createPropertyAccessExpression(E.createCallExpression(E.createIdentifier("_superIndex"), void 0, [pe]), "value"), or) : e.setTextRange(E.createCallExpression(E.createIdentifier("_superIndex"), void 0, [pe]), or);
              }
            }
            e.transformES2018 = w;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(C) {
              var w = C.factory;
              return e.chainBundle(C, B);
              function B(le) {
                return le.isDeclarationFile ? le : e.visitEachChild(le, E, C);
              }
              function E(le) {
                if ((le.transformFlags & 64) === 0) return le;
                switch (le.kind) {
                  case 292:
                    return Q(le);
                  default:
                    return e.visitEachChild(le, E, C);
                }
              }
              function Q(le) {
                return le.variableDeclaration ? e.visitEachChild(le, E, C) : w.updateCatchClause(le, w.createVariableDeclaration(w.createTempVariable(void 0)), e.visitNode(le.block, E, e.isBlock));
              }
            }
            e.transformES2019 = a;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(C) {
              var w = C.factory, B = C.hoistVariableDeclaration;
              return e.chainBundle(C, E);
              function E(b) {
                return b.isDeclarationFile ? b : e.visitEachChild(b, Q, C);
              }
              function Q(b) {
                if ((b.transformFlags & 32) === 0) return b;
                switch (b.kind) {
                  case 208: {
                    var se = m(b, false);
                    return e.Debug.assertNotNode(se, e.isSyntheticReference), se;
                  }
                  case 206:
                  case 207:
                    if (e.isOptionalChain(b)) {
                      var se = oe(b, false, false);
                      return e.Debug.assertNotNode(se, e.isSyntheticReference), se;
                    }
                    return e.visitEachChild(b, Q, C);
                  case 221:
                    return b.operatorToken.kind === 60 ? T(b) : e.visitEachChild(b, Q, C);
                  case 215:
                    return K(b);
                  default:
                    return e.visitEachChild(b, Q, C);
                }
              }
              function le(b) {
                e.Debug.assertNotNode(b, e.isNonNullChain);
                for (var se = [b]; !b.questionDotToken && !e.isTaggedTemplateExpression(b); ) b = e.cast(e.skipPartiallyEmittedExpressions(b.expression), e.isOptionalChain), e.Debug.assertNotNode(b, e.isNonNullChain), se.unshift(b);
                return { expression: b.expression, chain: se };
              }
              function N(b, se, J) {
                var ie = G(b.expression, se, J);
                return e.isSyntheticReference(ie) ? w.createSyntheticReferenceExpression(w.updateParenthesizedExpression(b, ie.expression), ie.thisArg) : w.updateParenthesizedExpression(b, ie);
              }
              function p(b, se, J) {
                if (e.isOptionalChain(b)) return oe(b, se, J);
                var ie = e.visitNode(b.expression, Q, e.isExpression);
                e.Debug.assertNotNode(ie, e.isSyntheticReference);
                var R;
                return se && (e.isSimpleCopiableExpression(ie) ? R = ie : (R = w.createTempVariable(B), ie = w.createAssignment(R, ie))), ie = b.kind === 206 ? w.updatePropertyAccessExpression(b, ie, e.visitNode(b.name, Q, e.isIdentifier)) : w.updateElementAccessExpression(b, ie, e.visitNode(b.argumentExpression, Q, e.isExpression)), R ? w.createSyntheticReferenceExpression(ie, R) : ie;
              }
              function m(b, se) {
                if (e.isOptionalChain(b)) return oe(b, se, false);
                if (e.isParenthesizedExpression(b.expression) && e.isOptionalChain(e.skipParentheses(b.expression))) {
                  var J = N(b.expression, true, false), ie = e.visitNodes(b.arguments, Q, e.isExpression);
                  return e.isSyntheticReference(J) ? e.setTextRange(w.createFunctionCallCall(J.expression, J.thisArg, ie), b) : w.updateCallExpression(b, J, void 0, ie);
                }
                return e.visitEachChild(b, Q, C);
              }
              function G(b, se, J) {
                switch (b.kind) {
                  case 212:
                    return N(b, se, J);
                  case 206:
                  case 207:
                    return p(b, se, J);
                  case 208:
                    return m(b, se);
                  default:
                    return e.visitNode(b, Q, e.isExpression);
                }
              }
              function oe(b, se, J) {
                var ie = le(b), R = ie.expression, q = ie.chain, O = G(e.skipPartiallyEmittedExpressions(R), e.isCallChain(q[0]), false), ve = e.isSyntheticReference(O) ? O.thisArg : void 0, ee = e.isSyntheticReference(O) ? O.expression : O, he = w.restoreOuterExpressions(R, ee, 8);
                e.isSimpleCopiableExpression(ee) || (ee = w.createTempVariable(B), he = w.createAssignment(ee, he));
                for (var F = ee, x, X = 0; X < q.length; X++) {
                  var $ = q[X];
                  switch ($.kind) {
                    case 206:
                    case 207:
                      X === q.length - 1 && se && (e.isSimpleCopiableExpression(F) ? x = F : (x = w.createTempVariable(B), F = w.createAssignment(x, F))), F = $.kind === 206 ? w.createPropertyAccessExpression(F, e.visitNode($.name, Q, e.isIdentifier)) : w.createElementAccessExpression(F, e.visitNode($.argumentExpression, Q, e.isExpression));
                      break;
                    case 208:
                      X === 0 && ve ? (e.isGeneratedIdentifier(ve) || (ve = w.cloneNode(ve), e.addEmitFlags(ve, 1536)), F = w.createFunctionCallCall(F, ve.kind === 106 ? w.createThis() : ve, e.visitNodes($.arguments, Q, e.isExpression))) : F = w.createCallExpression(F, void 0, e.visitNodes($.arguments, Q, e.isExpression));
                      break;
                  }
                  e.setOriginalNode(F, $);
                }
                var A = J ? w.createConditionalExpression(f(he, ee, true), void 0, w.createTrue(), void 0, w.createDeleteExpression(F)) : w.createConditionalExpression(f(he, ee, true), void 0, w.createVoidZero(), void 0, F);
                return e.setTextRange(A, b), x ? w.createSyntheticReferenceExpression(A, x) : A;
              }
              function f(b, se, J) {
                return w.createBinaryExpression(w.createBinaryExpression(b, w.createToken(J ? 36 : 37), w.createNull()), w.createToken(J ? 56 : 55), w.createBinaryExpression(se, w.createToken(J ? 36 : 37), w.createVoidZero()));
              }
              function T(b) {
                var se = e.visitNode(b.left, Q, e.isExpression), J = se;
                return e.isSimpleCopiableExpression(se) || (J = w.createTempVariable(B), se = w.createAssignment(J, se)), e.setTextRange(w.createConditionalExpression(f(se, J), void 0, J, void 0, e.visitNode(b.right, Q, e.isExpression)), b);
              }
              function K(b) {
                return e.isOptionalChain(e.skipParentheses(b.expression)) ? e.setOriginalNode(G(b.expression, false, true), b) : w.updateDeleteExpression(b, e.visitNode(b.expression, Q, e.isExpression));
              }
            }
            e.transformES2020 = a;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(C) {
              var w = C.hoistVariableDeclaration, B = C.factory;
              return e.chainBundle(C, E);
              function E(N) {
                return N.isDeclarationFile ? N : e.visitEachChild(N, Q, C);
              }
              function Q(N) {
                if ((N.transformFlags & 16) === 0) return N;
                switch (N.kind) {
                  case 221:
                    var p = N;
                    if (e.isLogicalOrCoalescingAssignmentExpression(p)) return le(p);
                  default:
                    return e.visitEachChild(N, Q, C);
                }
              }
              function le(N) {
                var p = N.operatorToken, m = e.getNonAssignmentOperatorForCompoundAssignment(p.kind), G = e.skipParentheses(e.visitNode(N.left, Q, e.isLeftHandSideExpression)), oe = G, f = e.skipParentheses(e.visitNode(N.right, Q, e.isExpression));
                if (e.isAccessExpression(G)) {
                  var T = e.isSimpleCopiableExpression(G.expression), K = T ? G.expression : B.createTempVariable(w), b = T ? G.expression : B.createAssignment(K, G.expression);
                  if (e.isPropertyAccessExpression(G)) oe = B.createPropertyAccessExpression(K, G.name), G = B.createPropertyAccessExpression(b, G.name);
                  else {
                    var se = e.isSimpleCopiableExpression(G.argumentExpression), J = se ? G.argumentExpression : B.createTempVariable(w);
                    oe = B.createElementAccessExpression(K, J), G = B.createElementAccessExpression(b, se ? G.argumentExpression : B.createAssignment(J, G.argumentExpression));
                  }
                }
                return B.createBinaryExpression(G, m, B.createParenthesizedExpression(B.createAssignment(oe, f)));
              }
            }
            e.transformES2021 = a;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(C) {
              return e.chainBundle(C, w);
              function w(E) {
                return E.isDeclarationFile ? E : e.visitEachChild(E, B, C);
              }
              function B(E) {
                if ((E.transformFlags & 4) === 0) return E;
                switch (E.kind) {
                  default:
                    return e.visitEachChild(E, B, C);
                }
              }
            }
            e.transformESNext = a;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(w) {
              var B = w.factory, E = w.getEmitHelperFactory, Q = w.getCompilerOptions(), le, N;
              return e.chainBundle(w, T);
              function p() {
                if (N.filenameDeclaration) return N.filenameDeclaration.name;
                var g = B.createVariableDeclaration(B.createUniqueName("_jsxFileName", 48), void 0, void 0, B.createStringLiteral(le.fileName));
                return N.filenameDeclaration = g, N.filenameDeclaration.name;
              }
              function m(g) {
                return Q.jsx === 5 ? "jsxDEV" : g ? "jsxs" : "jsx";
              }
              function G(g) {
                var ne = m(g);
                return f(ne);
              }
              function oe() {
                return f("Fragment");
              }
              function f(g) {
                var ne, ue, We = g === "createElement" ? N.importSpecifier : e.getJSXRuntimeImport(N.importSpecifier, Q), Fe = (ue = (ne = N.utilizedImplicitRuntimeImports) === null || ne === void 0 ? void 0 : ne.get(We)) === null || ue === void 0 ? void 0 : ue.get(g);
                if (Fe) return Fe.name;
                N.utilizedImplicitRuntimeImports || (N.utilizedImplicitRuntimeImports = new e.Map());
                var Z = N.utilizedImplicitRuntimeImports.get(We);
                Z || (Z = new e.Map(), N.utilizedImplicitRuntimeImports.set(We, Z));
                var Be = B.createUniqueName("_".concat(g), 112), ge = B.createImportSpecifier(false, B.createIdentifier(g), Be);
                return Be.generatedImportReference = ge, Z.set(g, ge), Be;
              }
              function T(g) {
                if (g.isDeclarationFile) return g;
                le = g, N = {}, N.importSpecifier = e.getJSXImplicitImportBase(Q, g);
                var ne = e.visitEachChild(g, K, w);
                e.addEmitHelpers(ne, w.readEmitHelpers());
                var ue = ne.statements;
                if (N.filenameDeclaration && (ue = e.insertStatementAfterCustomPrologue(ue.slice(), B.createVariableStatement(void 0, B.createVariableDeclarationList([N.filenameDeclaration], 2)))), N.utilizedImplicitRuntimeImports) for (var We = 0, Fe = e.arrayFrom(N.utilizedImplicitRuntimeImports.entries()); We < Fe.length; We++) {
                  var Z = Fe[We], Be = Z[0], ge = Z[1];
                  if (e.isExternalModule(g)) {
                    var Re = B.createImportDeclaration(void 0, void 0, B.createImportClause(false, void 0, B.createNamedImports(e.arrayFrom(ge.values()))), B.createStringLiteral(Be), void 0);
                    e.setParentRecursive(Re, false), ue = e.insertStatementAfterCustomPrologue(ue.slice(), Re);
                  } else if (e.isExternalOrCommonJsModule(g)) {
                    var ze = B.createVariableStatement(void 0, B.createVariableDeclarationList([B.createVariableDeclaration(B.createObjectBindingPattern(e.map(e.arrayFrom(ge.values()), function(Ee) {
                      return B.createBindingElement(void 0, Ee.propertyName, Ee.name);
                    })), void 0, void 0, B.createCallExpression(B.createIdentifier("require"), void 0, [B.createStringLiteral(Be)]))], 2));
                    e.setParentRecursive(ze, false), ue = e.insertStatementAfterCustomPrologue(ue.slice(), ze);
                  }
                }
                return ue !== ne.statements && (ne = B.updateSourceFile(ne, ue)), N = void 0, ne;
              }
              function K(g) {
                return g.transformFlags & 2 ? b(g) : g;
              }
              function b(g) {
                switch (g.kind) {
                  case 278:
                    return R(g, false);
                  case 279:
                    return q(g, false);
                  case 282:
                    return O(g, false);
                  case 288:
                    return fe(g);
                  default:
                    return e.visitEachChild(g, K, w);
                }
              }
              function se(g) {
                switch (g.kind) {
                  case 11:
                    return U(g);
                  case 288:
                    return fe(g);
                  case 278:
                    return R(g, true);
                  case 279:
                    return q(g, true);
                  case 282:
                    return O(g, true);
                  default:
                    return e.Debug.failBadSyntaxKind(g);
                }
              }
              function J(g) {
                for (var ne = false, ue = 0, We = g.attributes.properties; ue < We.length; ue++) {
                  var Fe = We[ue];
                  if (e.isJsxSpreadAttribute(Fe)) ne = true;
                  else if (ne && e.isJsxAttribute(Fe) && Fe.name.escapedText === "key") return true;
                }
                return false;
              }
              function ie(g) {
                return N.importSpecifier === void 0 || J(g);
              }
              function R(g, ne) {
                var ue = ie(g.openingElement) ? x : he;
                return ue(g.openingElement, g.children, ne, g);
              }
              function q(g, ne) {
                var ue = ie(g) ? x : he;
                return ue(g, void 0, ne, g);
              }
              function O(g, ne) {
                var ue = N.importSpecifier === void 0 ? $ : X;
                return ue(g.openingFragment, g.children, ne, g);
              }
              function ve(g) {
                var ne = ee(g);
                return ne && B.createObjectLiteralExpression([ne]);
              }
              function ee(g) {
                var ne = e.getSemanticJsxChildren(g);
                if (e.length(ne) === 1 && !ne[0].dotDotDotToken) {
                  var ue = se(ne[0]);
                  return ue && B.createPropertyAssignment("children", ue);
                }
                var We = e.mapDefined(g, se);
                return e.length(We) ? B.createPropertyAssignment("children", B.createArrayLiteralExpression(We)) : void 0;
              }
              function he(g, ne, ue, We) {
                var Fe = d(g), Z = ne && ne.length ? ee(ne) : void 0, Be = e.find(g.attributes.properties, function(ze) {
                  return !!ze.name && e.isIdentifier(ze.name) && ze.name.escapedText === "key";
                }), ge = Be ? e.filter(g.attributes.properties, function(ze) {
                  return ze !== Be;
                }) : g.attributes.properties, Re = e.length(ge) ? y(ge, Z) : B.createObjectLiteralExpression(Z ? [Z] : e.emptyArray);
                return F(Fe, Re, Be, ne || e.emptyArray, ue, We);
              }
              function F(g, ne, ue, We, Fe, Z) {
                var Be, ge = e.getSemanticJsxChildren(We), Re = e.length(ge) > 1 || !!(!((Be = ge[0]) === null || Be === void 0) && Be.dotDotDotToken), ze = [g, ne];
                if (ue && ze.push(Y(ue.initializer)), Q.jsx === 5) {
                  var Ee = e.getOriginalNode(le);
                  if (Ee && e.isSourceFile(Ee)) {
                    ue === void 0 && ze.push(B.createVoidZero()), ze.push(Re ? B.createTrue() : B.createFalse());
                    var He = e.getLineAndCharacterOfPosition(Ee, Z.pos);
                    ze.push(B.createObjectLiteralExpression([B.createPropertyAssignment("fileName", p()), B.createPropertyAssignment("lineNumber", B.createNumericLiteral(He.line + 1)), B.createPropertyAssignment("columnNumber", B.createNumericLiteral(He.character + 1))])), ze.push(B.createThis());
                  }
                }
                var rr = e.setTextRange(B.createCallExpression(G(Re), void 0, ze), Z);
                return Fe && e.startOnNewLine(rr), rr;
              }
              function x(g, ne, ue, We) {
                var Fe = d(g), Z = g.attributes.properties, Be = e.length(Z) ? y(Z) : B.createNull(), ge = N.importSpecifier === void 0 ? e.createJsxFactoryExpression(B, w.getEmitResolver().getJsxFactoryEntity(le), Q.reactNamespace, g) : f("createElement"), Re = e.createExpressionForJsxElement(B, ge, Fe, Be, e.mapDefined(ne, se), We);
                return ue && e.startOnNewLine(Re), Re;
              }
              function X(g, ne, ue, We) {
                var Fe;
                if (ne && ne.length) {
                  var Z = ve(ne);
                  Z && (Fe = Z);
                }
                return F(oe(), Fe || B.createObjectLiteralExpression([]), void 0, ne, ue, We);
              }
              function $(g, ne, ue, We) {
                var Fe = e.createExpressionForJsxFragment(B, w.getEmitResolver().getJsxFactoryEntity(le), w.getEmitResolver().getJsxFragmentFactoryEntity(le), Q.reactNamespace, e.mapDefined(ne, se), g, We);
                return ue && e.startOnNewLine(Fe), Fe;
              }
              function A(g) {
                return B.createSpreadAssignment(e.visitNode(g.expression, K, e.isExpression));
              }
              function y(g, ne) {
                var ue = e.getEmitScriptTarget(Q);
                return ue && ue >= 5 ? B.createObjectLiteralExpression(V(g, ne)) : L(g, ne);
              }
              function V(g, ne) {
                var ue = e.flatten(e.spanMap(g, e.isJsxSpreadAttribute, function(We, Fe) {
                  return e.map(We, function(Z) {
                    return Fe ? A(Z) : k(Z);
                  });
                }));
                return ne && ue.push(ne), ue;
              }
              function L(g, ne) {
                var ue = e.flatten(e.spanMap(g, e.isJsxSpreadAttribute, function(We, Fe) {
                  return Fe ? e.map(We, P) : B.createObjectLiteralExpression(e.map(We, k));
                }));
                return e.isJsxSpreadAttribute(g[0]) && ue.unshift(B.createObjectLiteralExpression()), ne && ue.push(B.createObjectLiteralExpression([ne])), e.singleOrUndefined(ue) || E().createAssignHelper(ue);
              }
              function P(g) {
                return e.visitNode(g.expression, K, e.isExpression);
              }
              function k(g) {
                var ne = D(g), ue = Y(g.initializer);
                return B.createPropertyAssignment(ne, ue);
              }
              function Y(g) {
                if (g === void 0) return B.createTrue();
                if (g.kind === 10) {
                  var ne = g.singleQuote !== void 0 ? g.singleQuote : !e.isStringDoubleQuoted(g, le), ue = B.createStringLiteral(l(g.text) || g.text, ne);
                  return e.setTextRange(ue, g);
                } else return g.kind === 288 ? g.expression === void 0 ? B.createTrue() : e.visitNode(g.expression, K, e.isExpression) : e.Debug.failBadSyntaxKind(g);
              }
              function U(g) {
                var ne = j(g.text);
                return ne === void 0 ? void 0 : B.createStringLiteral(ne);
              }
              function j(g) {
                for (var ne, ue = 0, We = -1, Fe = 0; Fe < g.length; Fe++) {
                  var Z = g.charCodeAt(Fe);
                  e.isLineBreak(Z) ? (ue !== -1 && We !== -1 && (ne = H(ne, g.substr(ue, We - ue + 1))), ue = -1) : e.isWhiteSpaceSingleLine(Z) || (We = Fe, ue === -1 && (ue = Fe));
                }
                return ue !== -1 ? H(ne, g.substr(ue)) : ne;
              }
              function H(g, ne) {
                var ue = I(ne);
                return g === void 0 ? ue : g + " " + ue;
              }
              function I(g) {
                return g.replace(/&((#((\d+)|x([\da-fA-F]+)))|(\w+));/g, function(ne, ue, We, Fe, Z, Be, ge) {
                  if (Z) return e.utf16EncodeAsString(parseInt(Z, 10));
                  if (Be) return e.utf16EncodeAsString(parseInt(Be, 16));
                  var Re = C.get(ge);
                  return Re ? e.utf16EncodeAsString(Re) : ne;
                });
              }
              function l(g) {
                var ne = I(g);
                return ne === g ? void 0 : ne;
              }
              function d(g) {
                if (g.kind === 278) return d(g.openingElement);
                var ne = g.tagName;
                return e.isIdentifier(ne) && e.isIntrinsicJsxName(ne.escapedText) ? B.createStringLiteral(e.idText(ne)) : e.createExpressionFromEntityName(B, ne);
              }
              function D(g) {
                var ne = g.name, ue = e.idText(ne);
                return /^[A-Za-z_]\w*$/.test(ue) ? ne : B.createStringLiteral(ue);
              }
              function fe(g) {
                var ne = e.visitNode(g.expression, K, e.isExpression);
                return g.dotDotDotToken ? B.createSpreadElement(ne) : ne;
              }
            }
            e.transformJsx = a;
            var C = new e.Map(e.getEntries({ quot: 34, amp: 38, apos: 39, lt: 60, gt: 62, nbsp: 160, iexcl: 161, cent: 162, pound: 163, curren: 164, yen: 165, brvbar: 166, sect: 167, uml: 168, copy: 169, ordf: 170, laquo: 171, not: 172, shy: 173, reg: 174, macr: 175, deg: 176, plusmn: 177, sup2: 178, sup3: 179, acute: 180, micro: 181, para: 182, middot: 183, cedil: 184, sup1: 185, ordm: 186, raquo: 187, frac14: 188, frac12: 189, frac34: 190, iquest: 191, Agrave: 192, Aacute: 193, Acirc: 194, Atilde: 195, Auml: 196, Aring: 197, AElig: 198, Ccedil: 199, Egrave: 200, Eacute: 201, Ecirc: 202, Euml: 203, Igrave: 204, Iacute: 205, Icirc: 206, Iuml: 207, ETH: 208, Ntilde: 209, Ograve: 210, Oacute: 211, Ocirc: 212, Otilde: 213, Ouml: 214, times: 215, Oslash: 216, Ugrave: 217, Uacute: 218, Ucirc: 219, Uuml: 220, Yacute: 221, THORN: 222, szlig: 223, agrave: 224, aacute: 225, acirc: 226, atilde: 227, auml: 228, aring: 229, aelig: 230, ccedil: 231, egrave: 232, eacute: 233, ecirc: 234, euml: 235, igrave: 236, iacute: 237, icirc: 238, iuml: 239, eth: 240, ntilde: 241, ograve: 242, oacute: 243, ocirc: 244, otilde: 245, ouml: 246, divide: 247, oslash: 248, ugrave: 249, uacute: 250, ucirc: 251, uuml: 252, yacute: 253, thorn: 254, yuml: 255, OElig: 338, oelig: 339, Scaron: 352, scaron: 353, Yuml: 376, fnof: 402, circ: 710, tilde: 732, Alpha: 913, Beta: 914, Gamma: 915, Delta: 916, Epsilon: 917, Zeta: 918, Eta: 919, Theta: 920, Iota: 921, Kappa: 922, Lambda: 923, Mu: 924, Nu: 925, Xi: 926, Omicron: 927, Pi: 928, Rho: 929, Sigma: 931, Tau: 932, Upsilon: 933, Phi: 934, Chi: 935, Psi: 936, Omega: 937, alpha: 945, beta: 946, gamma: 947, delta: 948, epsilon: 949, zeta: 950, eta: 951, theta: 952, iota: 953, kappa: 954, lambda: 955, mu: 956, nu: 957, xi: 958, omicron: 959, pi: 960, rho: 961, sigmaf: 962, sigma: 963, tau: 964, upsilon: 965, phi: 966, chi: 967, psi: 968, omega: 969, thetasym: 977, upsih: 978, piv: 982, ensp: 8194, emsp: 8195, thinsp: 8201, zwnj: 8204, zwj: 8205, lrm: 8206, rlm: 8207, ndash: 8211, mdash: 8212, lsquo: 8216, rsquo: 8217, sbquo: 8218, ldquo: 8220, rdquo: 8221, bdquo: 8222, dagger: 8224, Dagger: 8225, bull: 8226, hellip: 8230, permil: 8240, prime: 8242, Prime: 8243, lsaquo: 8249, rsaquo: 8250, oline: 8254, frasl: 8260, euro: 8364, image: 8465, weierp: 8472, real: 8476, trade: 8482, alefsym: 8501, larr: 8592, uarr: 8593, rarr: 8594, darr: 8595, harr: 8596, crarr: 8629, lArr: 8656, uArr: 8657, rArr: 8658, dArr: 8659, hArr: 8660, forall: 8704, part: 8706, exist: 8707, empty: 8709, nabla: 8711, isin: 8712, notin: 8713, ni: 8715, prod: 8719, sum: 8721, minus: 8722, lowast: 8727, radic: 8730, prop: 8733, infin: 8734, ang: 8736, and: 8743, or: 8744, cap: 8745, cup: 8746, int: 8747, there4: 8756, sim: 8764, cong: 8773, asymp: 8776, ne: 8800, equiv: 8801, le: 8804, ge: 8805, sub: 8834, sup: 8835, nsub: 8836, sube: 8838, supe: 8839, oplus: 8853, otimes: 8855, perp: 8869, sdot: 8901, lceil: 8968, rceil: 8969, lfloor: 8970, rfloor: 8971, lang: 9001, rang: 9002, loz: 9674, spades: 9824, clubs: 9827, hearts: 9829, diams: 9830 }));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(C) {
              var w = C.factory, B = C.hoistVariableDeclaration;
              return e.chainBundle(C, E);
              function E(m) {
                return m.isDeclarationFile ? m : e.visitEachChild(m, Q, C);
              }
              function Q(m) {
                if ((m.transformFlags & 512) === 0) return m;
                switch (m.kind) {
                  case 221:
                    return le(m);
                  default:
                    return e.visitEachChild(m, Q, C);
                }
              }
              function le(m) {
                switch (m.operatorToken.kind) {
                  case 67:
                    return N(m);
                  case 42:
                    return p(m);
                  default:
                    return e.visitEachChild(m, Q, C);
                }
              }
              function N(m) {
                var G, oe, f = e.visitNode(m.left, Q, e.isExpression), T = e.visitNode(m.right, Q, e.isExpression);
                if (e.isElementAccessExpression(f)) {
                  var K = w.createTempVariable(B), b = w.createTempVariable(B);
                  G = e.setTextRange(w.createElementAccessExpression(e.setTextRange(w.createAssignment(K, f.expression), f.expression), e.setTextRange(w.createAssignment(b, f.argumentExpression), f.argumentExpression)), f), oe = e.setTextRange(w.createElementAccessExpression(K, b), f);
                } else if (e.isPropertyAccessExpression(f)) {
                  var K = w.createTempVariable(B);
                  G = e.setTextRange(w.createPropertyAccessExpression(e.setTextRange(w.createAssignment(K, f.expression), f.expression), f.name), f), oe = e.setTextRange(w.createPropertyAccessExpression(K, f.name), f);
                } else G = f, oe = f;
                return e.setTextRange(w.createAssignment(G, e.setTextRange(w.createGlobalMethodCall("Math", "pow", [oe, T]), m)), m);
              }
              function p(m) {
                var G = e.visitNode(m.left, Q, e.isExpression), oe = e.visitNode(m.right, Q, e.isExpression);
                return e.setTextRange(w.createGlobalMethodCall("Math", "pow", [G, oe]), m);
              }
            }
            e.transformES2016 = a;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(p) {
              p[p.CapturedThis = 1] = "CapturedThis", p[p.BlockScopedBindings = 2] = "BlockScopedBindings";
            })(a || (a = {}));
            var C;
            (function(p) {
              p[p.Body = 1] = "Body", p[p.Initializer = 2] = "Initializer";
            })(C || (C = {}));
            var w;
            (function(p) {
              p[p.ToOriginal = 0] = "ToOriginal", p[p.ToOutParameter = 1] = "ToOutParameter";
            })(w || (w = {}));
            var B;
            (function(p) {
              p[p.Break = 2] = "Break", p[p.Continue = 4] = "Continue", p[p.Return = 8] = "Return";
            })(B || (B = {}));
            var E;
            (function(p) {
              p[p.None = 0] = "None", p[p.Function = 1] = "Function", p[p.ArrowFunction = 2] = "ArrowFunction", p[p.AsyncFunctionBody = 4] = "AsyncFunctionBody", p[p.NonStaticClassElement = 8] = "NonStaticClassElement", p[p.CapturesThis = 16] = "CapturesThis", p[p.ExportedVariableStatement = 32] = "ExportedVariableStatement", p[p.TopLevel = 64] = "TopLevel", p[p.Block = 128] = "Block", p[p.IterationStatement = 256] = "IterationStatement", p[p.IterationStatementBlock = 512] = "IterationStatementBlock", p[p.IterationContainer = 1024] = "IterationContainer", p[p.ForStatement = 2048] = "ForStatement", p[p.ForInOrForOfStatement = 4096] = "ForInOrForOfStatement", p[p.ConstructorWithCapturedSuper = 8192] = "ConstructorWithCapturedSuper", p[p.StaticInitializer = 16384] = "StaticInitializer", p[p.AncestorFactsMask = 32767] = "AncestorFactsMask", p[p.BlockScopeIncludes = 0] = "BlockScopeIncludes", p[p.BlockScopeExcludes = 7104] = "BlockScopeExcludes", p[p.SourceFileIncludes = 64] = "SourceFileIncludes", p[p.SourceFileExcludes = 8064] = "SourceFileExcludes", p[p.FunctionIncludes = 65] = "FunctionIncludes", p[p.FunctionExcludes = 32670] = "FunctionExcludes", p[p.AsyncFunctionBodyIncludes = 69] = "AsyncFunctionBodyIncludes", p[p.AsyncFunctionBodyExcludes = 32662] = "AsyncFunctionBodyExcludes", p[p.ArrowFunctionIncludes = 66] = "ArrowFunctionIncludes", p[p.ArrowFunctionExcludes = 15232] = "ArrowFunctionExcludes", p[p.ConstructorIncludes = 73] = "ConstructorIncludes", p[p.ConstructorExcludes = 32662] = "ConstructorExcludes", p[p.DoOrWhileStatementIncludes = 1280] = "DoOrWhileStatementIncludes", p[p.DoOrWhileStatementExcludes = 0] = "DoOrWhileStatementExcludes", p[p.ForStatementIncludes = 3328] = "ForStatementIncludes", p[p.ForStatementExcludes = 5056] = "ForStatementExcludes", p[p.ForInOrForOfStatementIncludes = 5376] = "ForInOrForOfStatementIncludes", p[p.ForInOrForOfStatementExcludes = 3008] = "ForInOrForOfStatementExcludes", p[p.BlockIncludes = 128] = "BlockIncludes", p[p.BlockExcludes = 6976] = "BlockExcludes", p[p.IterationStatementBlockIncludes = 512] = "IterationStatementBlockIncludes", p[p.IterationStatementBlockExcludes = 7104] = "IterationStatementBlockExcludes", p[p.StaticInitializerIncludes = 16449] = "StaticInitializerIncludes", p[p.StaticInitializerExcludes = 32670] = "StaticInitializerExcludes", p[p.NewTarget = 32768] = "NewTarget", p[p.CapturedLexicalThis = 65536] = "CapturedLexicalThis", p[p.SubtreeFactsMask = -32768] = "SubtreeFactsMask", p[p.ArrowFunctionSubtreeExcludes = 0] = "ArrowFunctionSubtreeExcludes", p[p.FunctionSubtreeExcludes = 98304] = "FunctionSubtreeExcludes";
            })(E || (E = {}));
            var Q;
            (function(p) {
              p[p.None = 0] = "None", p[p.UnpackedSpread = 1] = "UnpackedSpread", p[p.PackedSpread = 2] = "PackedSpread";
            })(Q || (Q = {}));
            function le(p, m) {
              return { kind: p, expression: m };
            }
            function N(p) {
              var m = p.factory, G = p.getEmitHelperFactory, oe = p.startLexicalEnvironment, f = p.resumeLexicalEnvironment, T = p.endLexicalEnvironment, K = p.hoistVariableDeclaration, b = p.getCompilerOptions(), se = p.getEmitResolver(), J = p.onSubstituteNode, ie = p.onEmitNode;
              p.onEmitNode = to, p.onSubstituteNode = Oo;
              var R, q, O, ve;
              function ee(Qe) {
                ve = e.append(ve, m.createVariableDeclaration(Qe));
              }
              var he, F;
              return e.chainBundle(p, x);
              function x(Qe) {
                if (Qe.isDeclarationFile) return Qe;
                R = Qe, q = Qe.text;
                var Gr = j(Qe);
                return e.addEmitHelpers(Gr, p.readEmitHelpers()), R = void 0, q = void 0, ve = void 0, O = 0, Gr;
              }
              function X(Qe, Gr) {
                var S = O;
                return O = (O & ~Qe | Gr) & 32767, S;
              }
              function $(Qe, Gr, S) {
                O = (O & ~Gr | S) & -32768 | Qe;
              }
              function A(Qe) {
                return (O & 8192) !== 0 && Qe.kind === 247 && !Qe.expression;
              }
              function y(Qe) {
                return Qe.transformFlags & 2097152 && (e.isReturnStatement(Qe) || e.isIfStatement(Qe) || e.isWithStatement(Qe) || e.isSwitchStatement(Qe) || e.isCaseBlock(Qe) || e.isCaseClause(Qe) || e.isDefaultClause(Qe) || e.isTryStatement(Qe) || e.isCatchClause(Qe) || e.isLabeledStatement(Qe) || e.isIterationStatement(Qe, false) || e.isBlock(Qe));
              }
              function V(Qe) {
                return (Qe.transformFlags & 1024) !== 0 || he !== void 0 || O & 8192 && y(Qe) || e.isIterationStatement(Qe, false) && Ue(Qe) || (e.getEmitFlags(Qe) & 33554432) !== 0;
              }
              function L(Qe) {
                return V(Qe) ? U(Qe, false) : Qe;
              }
              function P(Qe) {
                return V(Qe) ? U(Qe, true) : Qe;
              }
              function k(Qe) {
                if (V(Qe)) {
                  var Gr = e.getOriginalNode(Qe);
                  if (e.isPropertyDeclaration(Gr) && e.hasStaticModifier(Gr)) {
                    var S = X(32670, 16449), Ce = U(Qe, false);
                    return $(S, 98304, 0), Ce;
                  }
                  return U(Qe, false);
                }
                return Qe;
              }
              function Y(Qe) {
                return Qe.kind === 106 ? En(true) : L(Qe);
              }
              function U(Qe, Gr) {
                switch (Qe.kind) {
                  case 124:
                    return;
                  case 257:
                    return ue(Qe);
                  case 226:
                    return We(Qe);
                  case 164:
                    return we(Qe);
                  case 256:
                    return wr(Qe);
                  case 214:
                    return yr(Qe);
                  case 213:
                    return Ir(Qe);
                  case 254:
                    return Zt(Qe);
                  case 79:
                    return g(Qe);
                  case 255:
                    return Xi(Qe);
                  case 249:
                    return H(Qe);
                  case 263:
                    return I(Qe);
                  case 235:
                    return mi(Qe, false);
                  case 246:
                  case 245:
                    return ne(Qe);
                  case 250:
                    return ae(Qe);
                  case 240:
                  case 241:
                    return ti(Qe, void 0);
                  case 242:
                    return Ze(Qe, void 0);
                  case 243:
                    return zr(Qe, void 0);
                  case 244:
                    return Wr(Qe, void 0);
                  case 238:
                    return pe(Qe);
                  case 205:
                    return Ar(Qe);
                  case 292:
                    return Oi(Qe);
                  case 297:
                    return At(Qe);
                  case 162:
                    return ba(Qe);
                  case 204:
                    return Qa(Qe);
                  case 208:
                    return ai(Qe);
                  case 209:
                    return pn(Qe);
                  case 212:
                    return or(Qe, Gr);
                  case 221:
                    return qr(Qe, Gr);
                  case 351:
                    return si(Qe, Gr);
                  case 14:
                  case 15:
                  case 16:
                  case 17:
                    return eo(Qe);
                  case 10:
                    return Rn(Qe);
                  case 8:
                    return Da(Qe);
                  case 210:
                    return bo(Qe);
                  case 223:
                    return Ro(Qe);
                  case 224:
                    return $a(Qe);
                  case 225:
                    return Pn(Qe);
                  case 106:
                    return En(false);
                  case 108:
                    return D(Qe);
                  case 231:
                    return Wn(Qe);
                  case 169:
                    return Vi(Qe);
                  case 172:
                  case 173:
                    return at(Qe);
                  case 237:
                    return wi(Qe);
                  case 247:
                    return d(Qe);
                  case 217:
                    return fe(Qe);
                  default:
                    return e.visitEachChild(Qe, L, p);
                }
              }
              function j(Qe) {
                var Gr = X(8064, 64), S = [], Ce = [];
                oe();
                var qe = m.copyPrologue(Qe.statements, S, false, L);
                return e.addRange(Ce, e.visitNodes(Qe.statements, L, e.isStatement, qe)), ve && Ce.push(m.createVariableStatement(void 0, m.createVariableDeclarationList(ve))), m.mergeLexicalEnvironment(S, T()), Ye(S, Qe), $(Gr, 0, 0), m.updateSourceFile(Qe, e.setTextRange(m.createNodeArray(e.concatenate(S, Ce)), Qe.statements));
              }
              function H(Qe) {
                if (he !== void 0) {
                  var Gr = he.allowedNonLabeledJumps;
                  he.allowedNonLabeledJumps |= 2;
                  var S = e.visitEachChild(Qe, L, p);
                  return he.allowedNonLabeledJumps = Gr, S;
                }
                return e.visitEachChild(Qe, L, p);
              }
              function I(Qe) {
                var Gr = X(7104, 0), S = e.visitEachChild(Qe, L, p);
                return $(Gr, 0, 0), S;
              }
              function l(Qe) {
                return e.setOriginalNode(m.createReturnStatement(m.createUniqueName("_this", 48)), Qe);
              }
              function d(Qe) {
                return he ? (he.nonLocalJumps |= 8, A(Qe) && (Qe = l(Qe)), m.createReturnStatement(m.createObjectLiteralExpression([m.createPropertyAssignment(m.createIdentifier("value"), Qe.expression ? e.visitNode(Qe.expression, L, e.isExpression) : m.createVoidZero())]))) : A(Qe) ? l(Qe) : e.visitEachChild(Qe, L, p);
              }
              function D(Qe) {
                return O & 2 && !(O & 16384) && (O |= 65536), he ? O & 2 ? (he.containsLexicalThis = true, Qe) : he.thisName || (he.thisName = m.createUniqueName("this")) : Qe;
              }
              function fe(Qe) {
                return e.visitEachChild(Qe, P, p);
              }
              function g(Qe) {
                return he && se.isArgumentsLocalBinding(Qe) ? he.argumentsName || (he.argumentsName = m.createUniqueName("arguments")) : Qe;
              }
              function ne(Qe) {
                if (he) {
                  var Gr = Qe.kind === 246 ? 2 : 4, S = Qe.label && he.labels && he.labels.get(e.idText(Qe.label)) || !Qe.label && he.allowedNonLabeledJumps & Gr;
                  if (!S) {
                    var Ce = void 0, qe = Qe.label;
                    qe ? Qe.kind === 246 ? (Ce = "break-".concat(qe.escapedText), Ki(he, true, e.idText(qe), Ce)) : (Ce = "continue-".concat(qe.escapedText), Ki(he, false, e.idText(qe), Ce)) : Qe.kind === 246 ? (he.nonLocalJumps |= 2, Ce = "break") : (he.nonLocalJumps |= 4, Ce = "continue");
                    var br = m.createStringLiteral(Ce);
                    if (he.loopOutParameters.length) {
                      for (var Zr = he.loopOutParameters, Si = void 0, Pi = 0; Pi < Zr.length; Pi++) {
                        var Qi = ut(Zr[Pi], 1);
                        Pi === 0 ? Si = Qi : Si = m.createBinaryExpression(Si, 27, Qi);
                      }
                      br = m.createBinaryExpression(Si, 27, br);
                    }
                    return m.createReturnStatement(br);
                  }
                }
                return e.visitEachChild(Qe, L, p);
              }
              function ue(Qe) {
                var Gr = m.createVariableDeclaration(m.getLocalName(Qe, true), void 0, void 0, Fe(Qe));
                e.setOriginalNode(Gr, Qe);
                var S = [], Ce = m.createVariableStatement(void 0, m.createVariableDeclarationList([Gr]));
                if (e.setOriginalNode(Ce, Qe), e.setTextRange(Ce, Qe), e.startOnNewLine(Ce), S.push(Ce), e.hasSyntacticModifier(Qe, 1)) {
                  var qe = e.hasSyntacticModifier(Qe, 512) ? m.createExportDefault(m.getLocalName(Qe)) : m.createExternalModuleExport(m.getLocalName(Qe));
                  e.setOriginalNode(qe, Ce), S.push(qe);
                }
                var br = e.getEmitFlags(Qe);
                return (br & 4194304) === 0 && (S.push(m.createEndOfDeclarationMarker(Qe)), e.setEmitFlags(Ce, br | 4194304)), e.singleOrMany(S);
              }
              function We(Qe) {
                return Fe(Qe);
              }
              function Fe(Qe) {
                Qe.name && Co();
                var Gr = e.getClassExtendsHeritageElement(Qe), S = m.createFunctionExpression(void 0, void 0, void 0, void 0, Gr ? [m.createParameterDeclaration(void 0, void 0, void 0, m.createUniqueName("_super", 48))] : [], void 0, Z(Qe, Gr));
                e.setEmitFlags(S, e.getEmitFlags(Qe) & 65536 | 524288);
                var Ce = m.createPartiallyEmittedExpression(S);
                e.setTextRangeEnd(Ce, Qe.end), e.setEmitFlags(Ce, 1536);
                var qe = m.createPartiallyEmittedExpression(Ce);
                e.setTextRangeEnd(qe, e.skipTrivia(q, Qe.pos)), e.setEmitFlags(qe, 1536);
                var br = m.createParenthesizedExpression(m.createCallExpression(qe, void 0, Gr ? [e.visitNode(Gr.expression, L, e.isExpression)] : []));
                return e.addSyntheticLeadingComment(br, 3, "* @class "), br;
              }
              function Z(Qe, Gr) {
                var S = [], Ce = m.getInternalName(Qe), qe = e.isIdentifierANonContextualKeyword(Ce) ? m.getGeneratedNameForNode(Ce) : Ce;
                oe(), Be(S, Qe, Gr), ge(S, Qe, qe, Gr), n(S, Qe);
                var br = e.createTokenRange(e.skipTrivia(q, Qe.members.end), 19), Zr = m.createPartiallyEmittedExpression(qe);
                e.setTextRangeEnd(Zr, br.end), e.setEmitFlags(Zr, 1536);
                var Si = m.createReturnStatement(Zr);
                e.setTextRangePos(Si, br.pos), e.setEmitFlags(Si, 1920), S.push(Si), e.insertStatementsAfterStandardPrologue(S, T());
                var Pi = m.createBlock(e.setTextRange(m.createNodeArray(S), Qe.members), true);
                return e.setEmitFlags(Pi, 1536), Pi;
              }
              function Be(Qe, Gr, S) {
                S && Qe.push(e.setTextRange(m.createExpressionStatement(G().createExtendsHelper(m.getInternalName(Gr))), S));
              }
              function ge(Qe, Gr, S, Ce) {
                var qe = he;
                he = void 0;
                var br = X(32662, 73), Zr = e.getFirstConstructorWithBody(Gr), Si = Jn(Zr, Ce !== void 0), Pi = m.createFunctionDeclaration(void 0, void 0, void 0, S, void 0, Re(Zr, Si), void 0, Ee(Zr, Gr, Ce, Si));
                e.setTextRange(Pi, Zr || Gr), Ce && e.setEmitFlags(Pi, 8), Qe.push(Pi), $(br, 98304, 0), he = qe;
              }
              function Re(Qe, Gr) {
                return e.visitParameterList(Qe && !Gr ? Qe.parameters : void 0, L, p) || [];
              }
              function ze(Qe, Gr) {
                var S = [];
                f(), m.mergeLexicalEnvironment(S, T()), Gr && S.push(m.createReturnStatement(_e()));
                var Ce = m.createNodeArray(S);
                e.setTextRange(Ce, Qe.members);
                var qe = m.createBlock(Ce, true);
                return e.setTextRange(qe, Qe), e.setEmitFlags(qe, 1536), qe;
              }
              function Ee(Qe, Gr, S, Ce) {
                var qe = !!S && e.skipOuterExpressions(S.expression).kind !== 104;
                if (!Qe) return ze(Gr, qe);
                var br = [], Zr = [];
                f();
                var Si = e.takeWhile(Qe.body.statements, e.isPrologueDirective), Pi = He(Qe.body.statements, Si), Qi = Pi.superCall, Ct = Pi.superStatementIndex, sa = Ct === -1 ? Si.length : Ct + 1, en = sa;
                Ce || (en = m.copyStandardPrologue(Qe.body.statements, br, en, false)), Ce || (en = m.copyCustomPrologue(Qe.body.statements, Zr, en, L, void 0));
                var Wa;
                if (Ce ? Wa = _e() : Qi && (Wa = ka(Qi)), Wa && (O |= 8192), ye(br, Qe), Cr(br, Qe, Ce), e.addRange(Zr, e.visitNodes(Qe.body.statements, L, e.isStatement, en)), m.mergeLexicalEnvironment(br, T()), Ne(br, Qe, false), qe || Wa) if (Wa && sa === Qe.body.statements.length && !(Qe.body.transformFlags & 8192)) {
                  var qn = e.cast(e.cast(Wa, e.isBinaryExpression).left, e.isCallExpression), mo = m.createReturnStatement(Wa);
                  e.setCommentRange(mo, e.getCommentRange(qn)), e.setEmitFlags(qn, 1536), Zr.push(mo);
                } else Ct <= Si.length ? Er(Zr, Qe, Wa || Ie()) : (Er(br, Qe, Ie()), Wa && Br(Zr, Wa)), rr(Qe.body) || Zr.push(m.createReturnStatement(m.createUniqueName("_this", 48)));
                else Ye(br, Qe);
                var So = m.createBlock(e.setTextRange(m.createNodeArray(Ve(Ve(Ve(Ve([], Si, true), br, true), Ct <= Si.length ? e.emptyArray : e.visitNodes(Qe.body.statements, L, e.isStatement, Si.length, Ct - Si.length), true), Zr, true)), Qe.body.statements), true);
                return e.setTextRange(So, Qe.body), So;
              }
              function He(Qe, Gr) {
                for (var S = Gr.length; S < Qe.length; S += 1) {
                  var Ce = e.getSuperCallFromStatement(Qe[S]);
                  if (Ce) return { superCall: Ce, superStatementIndex: S };
                }
                return { superStatementIndex: -1 };
              }
              function rr(Qe) {
                if (Qe.kind === 247) return true;
                if (Qe.kind === 239) {
                  var Gr = Qe;
                  if (Gr.elseStatement) return rr(Gr.thenStatement) && rr(Gr.elseStatement);
                } else if (Qe.kind === 235) {
                  var S = e.lastOrUndefined(Qe.statements);
                  if (S && rr(S)) return true;
                }
                return false;
              }
              function Ie() {
                return e.setEmitFlags(m.createThis(), 4);
              }
              function _e() {
                return m.createLogicalOr(m.createLogicalAnd(m.createStrictInequality(m.createUniqueName("_super", 48), m.createNull()), m.createFunctionApplyCall(m.createUniqueName("_super", 48), Ie(), m.createIdentifier("arguments"))), Ie());
              }
              function we(Qe) {
                if (!Qe.dotDotDotToken) return e.isBindingPattern(Qe.name) ? e.setOriginalNode(e.setTextRange(m.createParameterDeclaration(void 0, void 0, void 0, m.getGeneratedNameForNode(Qe), void 0, void 0, void 0), Qe), Qe) : Qe.initializer ? e.setOriginalNode(e.setTextRange(m.createParameterDeclaration(void 0, void 0, void 0, Qe.name, void 0, void 0, void 0), Qe), Qe) : Qe;
              }
              function de(Qe) {
                return Qe.initializer !== void 0 || e.isBindingPattern(Qe.name);
              }
              function ye(Qe, Gr) {
                if (!e.some(Gr.parameters, de)) return false;
                for (var S = false, Ce = 0, qe = Gr.parameters; Ce < qe.length; Ce++) {
                  var br = qe[Ce], Zr = br.name, Si = br.initializer, Pi = br.dotDotDotToken;
                  Pi || (e.isBindingPattern(Zr) ? S = Ae(Qe, br, Zr, Si) || S : Si && (er(Qe, br, Zr, Si), S = true));
                }
                return S;
              }
              function Ae(Qe, Gr, S, Ce) {
                return S.elements.length > 0 ? (e.insertStatementAfterCustomPrologue(Qe, e.setEmitFlags(m.createVariableStatement(void 0, m.createVariableDeclarationList(e.flattenDestructuringBinding(Gr, L, p, 0, m.getGeneratedNameForNode(Gr)))), 1048576)), true) : Ce ? (e.insertStatementAfterCustomPrologue(Qe, e.setEmitFlags(m.createExpressionStatement(m.createAssignment(m.getGeneratedNameForNode(Gr), e.visitNode(Ce, L, e.isExpression))), 1048576)), true) : false;
              }
              function er(Qe, Gr, S, Ce) {
                Ce = e.visitNode(Ce, L, e.isExpression);
                var qe = m.createIfStatement(m.createTypeCheck(m.cloneNode(S), "undefined"), e.setEmitFlags(e.setTextRange(m.createBlock([m.createExpressionStatement(e.setEmitFlags(e.setTextRange(m.createAssignment(e.setEmitFlags(e.setParent(e.setTextRange(m.cloneNode(S), S), S.parent), 48), e.setEmitFlags(Ce, 48 | e.getEmitFlags(Ce) | 1536)), Gr), 1536))]), Gr), 1953));
                e.startOnNewLine(qe), e.setTextRange(qe, Gr), e.setEmitFlags(qe, 1050528), e.insertStatementAfterCustomPrologue(Qe, qe);
              }
              function ir(Qe, Gr) {
                return !!(Qe && Qe.dotDotDotToken && !Gr);
              }
              function Cr(Qe, Gr, S) {
                var Ce = [], qe = e.lastOrUndefined(Gr.parameters);
                if (!ir(qe, S)) return false;
                var br = qe.name.kind === 79 ? e.setParent(e.setTextRange(m.cloneNode(qe.name), qe.name), qe.name.parent) : m.createTempVariable(void 0);
                e.setEmitFlags(br, 48);
                var Zr = qe.name.kind === 79 ? m.cloneNode(qe.name) : br, Si = Gr.parameters.length - 1, Pi = m.createLoopVariable();
                Ce.push(e.setEmitFlags(e.setTextRange(m.createVariableStatement(void 0, m.createVariableDeclarationList([m.createVariableDeclaration(br, void 0, void 0, m.createArrayLiteralExpression([]))])), qe), 1048576));
                var Qi = m.createForStatement(e.setTextRange(m.createVariableDeclarationList([m.createVariableDeclaration(Pi, void 0, void 0, m.createNumericLiteral(Si))]), qe), e.setTextRange(m.createLessThan(Pi, m.createPropertyAccessExpression(m.createIdentifier("arguments"), "length")), qe), e.setTextRange(m.createPostfixIncrement(Pi), qe), m.createBlock([e.startOnNewLine(e.setTextRange(m.createExpressionStatement(m.createAssignment(m.createElementAccessExpression(Zr, Si === 0 ? Pi : m.createSubtract(Pi, m.createNumericLiteral(Si))), m.createElementAccessExpression(m.createIdentifier("arguments"), Pi))), qe))]));
                return e.setEmitFlags(Qi, 1048576), e.startOnNewLine(Qi), Ce.push(Qi), qe.name.kind !== 79 && Ce.push(e.setEmitFlags(e.setTextRange(m.createVariableStatement(void 0, m.createVariableDeclarationList(e.flattenDestructuringBinding(qe, L, p, 0, Zr))), qe), 1048576)), e.insertStatementsAfterCustomPrologue(Qe, Ce), true;
              }
              function Ye(Qe, Gr) {
                return O & 65536 && Gr.kind !== 214 ? (Er(Qe, Gr, m.createThis()), true) : false;
              }
              function Br(Qe, Gr) {
                Ko();
                var S = m.createExpressionStatement(m.createBinaryExpression(m.createThis(), 63, Gr));
                e.insertStatementAfterCustomPrologue(Qe, S), e.setCommentRange(S, e.getOriginalNode(Gr).parent);
              }
              function Er(Qe, Gr, S) {
                Ko();
                var Ce = m.createVariableStatement(void 0, m.createVariableDeclarationList([m.createVariableDeclaration(m.createUniqueName("_this", 48), void 0, void 0, S)]));
                e.setEmitFlags(Ce, 1050112), e.setSourceMapRange(Ce, Gr), e.insertStatementAfterCustomPrologue(Qe, Ce);
              }
              function Ne(Qe, Gr, S) {
                if (O & 32768) {
                  var Ce = void 0;
                  switch (Gr.kind) {
                    case 214:
                      return Qe;
                    case 169:
                    case 172:
                    case 173:
                      Ce = m.createVoidZero();
                      break;
                    case 171:
                      Ce = m.createPropertyAccessExpression(e.setEmitFlags(m.createThis(), 4), "constructor");
                      break;
                    case 256:
                    case 213:
                      Ce = m.createConditionalExpression(m.createLogicalAnd(e.setEmitFlags(m.createThis(), 4), m.createBinaryExpression(e.setEmitFlags(m.createThis(), 4), 102, m.getLocalName(Gr))), void 0, m.createPropertyAccessExpression(e.setEmitFlags(m.createThis(), 4), "constructor"), void 0, m.createVoidZero());
                      break;
                    default:
                      return e.Debug.failBadSyntaxKind(Gr);
                  }
                  var qe = m.createVariableStatement(void 0, m.createVariableDeclarationList([m.createVariableDeclaration(m.createUniqueName("_newTarget", 48), void 0, void 0, Ce)]));
                  e.setEmitFlags(qe, 1050112), S && (Qe = Qe.slice()), e.insertStatementAfterCustomPrologue(Qe, qe);
                }
                return Qe;
              }
              function n(Qe, Gr) {
                for (var S = 0, Ce = Gr.members; S < Ce.length; S++) {
                  var qe = Ce[S];
                  switch (qe.kind) {
                    case 234:
                      Qe.push(lr(qe));
                      break;
                    case 169:
                      Qe.push(be(dn(Gr, qe), qe, Gr));
                      break;
                    case 172:
                    case 173:
                      var br = e.getAllAccessorDeclarations(Gr.members, qe);
                      qe === br.firstAccessor && Qe.push(Ge(dn(Gr, qe), br, Gr));
                      break;
                    case 171:
                    case 170:
                      break;
                    default:
                      e.Debug.failBadSyntaxKind(qe, R && R.fileName);
                      break;
                  }
                }
              }
              function lr(Qe) {
                return e.setTextRange(m.createEmptyStatement(), Qe);
              }
              function be(Qe, Gr, S) {
                var Ce = e.getCommentRange(Gr), qe = e.getSourceMapRange(Gr), br = Ur(Gr, Gr, void 0, S), Zr = e.visitNode(Gr.name, L, e.isPropertyName), Si;
                if (!e.isPrivateIdentifier(Zr) && e.getUseDefineForClassFields(p.getCompilerOptions())) {
                  var Pi = e.isComputedPropertyName(Zr) ? Zr.expression : e.isIdentifier(Zr) ? m.createStringLiteral(e.unescapeLeadingUnderscores(Zr.escapedText)) : Zr;
                  Si = m.createObjectDefinePropertyCall(Qe, Pi, m.createPropertyDescriptor({ value: br, enumerable: false, writable: true, configurable: true }));
                } else {
                  var Qi = e.createMemberAccessForPropertyName(m, Qe, Zr, Gr.name);
                  Si = m.createAssignment(Qi, br);
                }
                e.setEmitFlags(br, 1536), e.setSourceMapRange(br, qe);
                var Ct = e.setTextRange(m.createExpressionStatement(Si), Gr);
                return e.setOriginalNode(Ct, Gr), e.setCommentRange(Ct, Ce), e.setEmitFlags(Ct, 48), Ct;
              }
              function Ge(Qe, Gr, S) {
                var Ce = m.createExpressionStatement(ur(Qe, Gr, S, false));
                return e.setEmitFlags(Ce, 1536), e.setSourceMapRange(Ce, e.getSourceMapRange(Gr.firstAccessor)), Ce;
              }
              function ur(Qe, Gr, S, Ce) {
                var qe = Gr.firstAccessor, br = Gr.getAccessor, Zr = Gr.setAccessor, Si = e.setParent(e.setTextRange(m.cloneNode(Qe), Qe), Qe.parent);
                e.setEmitFlags(Si, 1568), e.setSourceMapRange(Si, qe.name);
                var Pi = e.visitNode(qe.name, L, e.isPropertyName);
                if (e.isPrivateIdentifier(Pi)) return e.Debug.failBadSyntaxKind(Pi, "Encountered unhandled private identifier while transforming ES2015.");
                var Qi = e.createExpressionForPropertyName(m, Pi);
                e.setEmitFlags(Qi, 1552), e.setSourceMapRange(Qi, qe.name);
                var Ct = [];
                if (br) {
                  var sa = Ur(br, void 0, void 0, S);
                  e.setSourceMapRange(sa, e.getSourceMapRange(br)), e.setEmitFlags(sa, 512);
                  var en = m.createPropertyAssignment("get", sa);
                  e.setCommentRange(en, e.getCommentRange(br)), Ct.push(en);
                }
                if (Zr) {
                  var Wa = Ur(Zr, void 0, void 0, S);
                  e.setSourceMapRange(Wa, e.getSourceMapRange(Zr)), e.setEmitFlags(Wa, 512);
                  var qn = m.createPropertyAssignment("set", Wa);
                  e.setCommentRange(qn, e.getCommentRange(Zr)), Ct.push(qn);
                }
                Ct.push(m.createPropertyAssignment("enumerable", br || Zr ? m.createFalse() : m.createTrue()), m.createPropertyAssignment("configurable", m.createTrue()));
                var mo = m.createCallExpression(m.createPropertyAccessExpression(m.createIdentifier("Object"), "defineProperty"), void 0, [Si, Qi, m.createObjectLiteralExpression(Ct, true)]);
                return Ce && e.startOnNewLine(mo), mo;
              }
              function yr(Qe) {
                Qe.transformFlags & 8192 && !(O & 16384) && (O |= 65536);
                var Gr = he;
                he = void 0;
                var S = X(15232, 66), Ce = m.createFunctionExpression(void 0, void 0, void 0, void 0, e.visitParameterList(Qe.parameters, L, p), void 0, ii(Qe));
                return e.setTextRange(Ce, Qe), e.setOriginalNode(Ce, Qe), e.setEmitFlags(Ce, 8), $(S, 0, 0), he = Gr, Ce;
              }
              function Ir(Qe) {
                var Gr = e.getEmitFlags(Qe) & 262144 ? X(32662, 69) : X(32670, 65), S = he;
                he = void 0;
                var Ce = e.visitParameterList(Qe.parameters, L, p), qe = ii(Qe), br = O & 32768 ? m.getLocalName(Qe) : Qe.name;
                return $(Gr, 98304, 0), he = S, m.updateFunctionExpression(Qe, void 0, Qe.asteriskToken, br, void 0, Ce, void 0, qe);
              }
              function wr(Qe) {
                var Gr = he;
                he = void 0;
                var S = X(32670, 65), Ce = e.visitParameterList(Qe.parameters, L, p), qe = ii(Qe), br = O & 32768 ? m.getLocalName(Qe) : Qe.name;
                return $(S, 98304, 0), he = Gr, m.updateFunctionDeclaration(Qe, void 0, e.visitNodes(Qe.modifiers, L, e.isModifier), Qe.asteriskToken, br, void 0, Ce, void 0, qe);
              }
              function Ur(Qe, Gr, S, Ce) {
                var qe = he;
                he = void 0;
                var br = Ce && e.isClassLike(Ce) && !e.isStatic(Qe) ? X(32670, 73) : X(32670, 65), Zr = e.visitParameterList(Qe.parameters, L, p), Si = ii(Qe);
                return O & 32768 && !S && (Qe.kind === 256 || Qe.kind === 213) && (S = m.getGeneratedNameForNode(Qe)), $(br, 98304, 0), he = qe, e.setOriginalNode(e.setTextRange(m.createFunctionExpression(void 0, Qe.asteriskToken, S, void 0, Zr, void 0, Si), Gr), Qe);
              }
              function ii(Qe) {
                var Gr = false, S = false, Ce, qe, br = [], Zr = [], Si = Qe.body, Pi;
                if (f(), e.isBlock(Si) && (Pi = m.copyStandardPrologue(Si.statements, br, 0, false), Pi = m.copyCustomPrologue(Si.statements, Zr, Pi, L, e.isHoistedFunction), Pi = m.copyCustomPrologue(Si.statements, Zr, Pi, L, e.isHoistedVariableStatement)), Gr = ye(Zr, Qe) || Gr, Gr = Cr(Zr, Qe, false) || Gr, e.isBlock(Si)) Pi = m.copyCustomPrologue(Si.statements, Zr, Pi, L), Ce = Si.statements, e.addRange(Zr, e.visitNodes(Si.statements, L, e.isStatement, Pi)), !Gr && Si.multiLine && (Gr = true);
                else {
                  e.Debug.assert(Qe.kind === 214), Ce = e.moveRangeEnd(Si, -1);
                  var Qi = Qe.equalsGreaterThanToken;
                  !e.nodeIsSynthesized(Qi) && !e.nodeIsSynthesized(Si) && (e.rangeEndIsOnSameLineAsRangeStart(Qi, Si, R) ? S = true : Gr = true);
                  var Ct = e.visitNode(Si, L, e.isExpression), sa = m.createReturnStatement(Ct);
                  e.setTextRange(sa, Si), e.moveSyntheticComments(sa, Si), e.setEmitFlags(sa, 1440), Zr.push(sa), qe = Si;
                }
                if (m.mergeLexicalEnvironment(br, T()), Ne(br, Qe, false), Ye(br, Qe), e.some(br) && (Gr = true), Zr.unshift.apply(Zr, br), e.isBlock(Si) && e.arrayIsEqualTo(Zr, Si.statements)) return Si;
                var en = m.createBlock(e.setTextRange(m.createNodeArray(Zr), Ce), Gr);
                return e.setTextRange(en, Qe.body), !Gr && S && e.setEmitFlags(en, 1), qe && e.setTokenSourceMapRange(en, 19, qe), e.setOriginalNode(en, Qe.body), en;
              }
              function mi(Qe, Gr) {
                if (Gr) return e.visitEachChild(Qe, L, p);
                var S = O & 256 ? X(7104, 512) : X(6976, 128), Ce = e.visitEachChild(Qe, L, p);
                return $(S, 0, 0), Ce;
              }
              function pe(Qe) {
                return e.visitEachChild(Qe, P, p);
              }
              function or(Qe, Gr) {
                return e.visitEachChild(Qe, Gr ? P : L, p);
              }
              function qr(Qe, Gr) {
                return e.isDestructuringAssignment(Qe) ? e.flattenDestructuringAssignment(Qe, L, p, 0, !Gr) : Qe.operatorToken.kind === 27 ? m.updateBinaryExpression(Qe, e.visitNode(Qe.left, P, e.isExpression), Qe.operatorToken, e.visitNode(Qe.right, Gr ? P : L, e.isExpression)) : e.visitEachChild(Qe, L, p);
              }
              function si(Qe, Gr) {
                if (Gr) return e.visitEachChild(Qe, P, p);
                for (var S, Ce = 0; Ce < Qe.elements.length; Ce++) {
                  var qe = Qe.elements[Ce], br = e.visitNode(qe, Ce < Qe.elements.length - 1 ? P : L, e.isExpression);
                  (S || br !== qe) && (S || (S = Qe.elements.slice(0, Ce)), S.push(br));
                }
                var Zr = S ? e.setTextRange(m.createNodeArray(S), Qe.elements) : Qe.elements;
                return m.updateCommaListExpression(Qe, Zr);
              }
              function Di(Qe) {
                return Qe.declarationList.declarations.length === 1 && !!Qe.declarationList.declarations[0].initializer && !!(e.getEmitFlags(Qe.declarationList.declarations[0].initializer) & 33554432);
              }
              function wi(Qe) {
                var Gr = X(0, e.hasSyntacticModifier(Qe, 1) ? 32 : 0), S;
                if (he && (Qe.declarationList.flags & 3) === 0 && !Di(Qe)) {
                  for (var Ce = void 0, qe = 0, br = Qe.declarationList.declarations; qe < br.length; qe++) {
                    var Zr = br[qe];
                    if (De(he, Zr), Zr.initializer) {
                      var Si = void 0;
                      e.isBindingPattern(Zr.name) ? Si = e.flattenDestructuringAssignment(Zr, L, p, 0) : (Si = m.createBinaryExpression(Zr.name, 63, e.visitNode(Zr.initializer, L, e.isExpression)), e.setTextRange(Si, Zr)), Ce = e.append(Ce, Si);
                    }
                  }
                  Ce ? S = e.setTextRange(m.createExpressionStatement(m.inlineExpressions(Ce)), Qe) : S = void 0;
                } else S = e.visitEachChild(Qe, L, p);
                return $(Gr, 0, 0), S;
              }
              function Xi(Qe) {
                if (Qe.flags & 3 || Qe.transformFlags & 262144) {
                  Qe.flags & 3 && Co();
                  var Gr = e.flatMap(Qe.declarations, Qe.flags & 1 ? Wt : Zt), S = m.createVariableDeclarationList(Gr);
                  return e.setOriginalNode(S, Qe), e.setTextRange(S, Qe), e.setCommentRange(S, Qe), Qe.transformFlags & 262144 && (e.isBindingPattern(Qe.declarations[0].name) || e.isBindingPattern(e.last(Qe.declarations).name)) && e.setSourceMapRange(S, et(Gr)), S;
                }
                return e.visitEachChild(Qe, L, p);
              }
              function et(Qe) {
                for (var Gr = -1, S = -1, Ce = 0, qe = Qe; Ce < qe.length; Ce++) {
                  var br = qe[Ce];
                  Gr = Gr === -1 ? br.pos : br.pos === -1 ? Gr : Math.min(Gr, br.pos), S = Math.max(S, br.end);
                }
                return e.createRange(Gr, S);
              }
              function Gi(Qe) {
                var Gr = se.getNodeCheckFlags(Qe), S = Gr & 262144, Ce = Gr & 524288, qe = (O & 64) !== 0 || S && Ce && (O & 512) !== 0, br = !qe && (O & 4096) === 0 && (!se.isDeclarationWithCollidingName(Qe) || Ce && !S && (O & 6144) === 0);
                return br;
              }
              function Wt(Qe) {
                var Gr = Qe.name;
                return e.isBindingPattern(Gr) ? Zt(Qe) : !Qe.initializer && Gi(Qe) ? m.updateVariableDeclaration(Qe, Qe.name, void 0, void 0, m.createVoidZero()) : e.visitEachChild(Qe, L, p);
              }
              function Zt(Qe) {
                var Gr = X(32, 0), S;
                return e.isBindingPattern(Qe.name) ? S = e.flattenDestructuringBinding(Qe, L, p, 0, void 0, (Gr & 32) !== 0) : S = e.visitEachChild(Qe, L, p), $(Gr, 0, 0), S;
              }
              function _r(Qe) {
                he.labels.set(e.idText(Qe.label), true);
              }
              function pi(Qe) {
                he.labels.set(e.idText(Qe.label), false);
              }
              function ae(Qe) {
                he && !he.labels && (he.labels = new e.Map());
                var Gr = e.unwrapInnermostStatementOfLabel(Qe, he && _r);
                return e.isIterationStatement(Gr, false) ? Xe(Gr, Qe) : m.restoreEnclosingLabel(e.visitNode(Gr, L, e.isStatement, m.liftToBlock), Qe, he && pi);
              }
              function Xe(Qe, Gr) {
                switch (Qe.kind) {
                  case 240:
                  case 241:
                    return ti(Qe, Gr);
                  case 242:
                    return Ze(Qe, Gr);
                  case 243:
                    return zr(Qe, Gr);
                  case 244:
                    return Wr(Qe, Gr);
                }
              }
              function Jr(Qe, Gr, S, Ce, qe) {
                var br = X(Qe, Gr), Zr = gr(S, Ce, br, qe);
                return $(br, 0, 0), Zr;
              }
              function ti(Qe, Gr) {
                return Jr(0, 1280, Qe, Gr);
              }
              function Ze(Qe, Gr) {
                return Jr(5056, 3328, Qe, Gr);
              }
              function Sr(Qe) {
                return m.updateForStatement(Qe, e.visitNode(Qe.initializer, P, e.isForInitializer), e.visitNode(Qe.condition, L, e.isExpression), e.visitNode(Qe.incrementor, P, e.isExpression), e.visitNode(Qe.statement, L, e.isStatement, m.liftToBlock));
              }
              function zr(Qe, Gr) {
                return Jr(3008, 5376, Qe, Gr);
              }
              function Wr(Qe, Gr) {
                return Jr(3008, 5376, Qe, Gr, b.downlevelIteration ? mr : vr);
              }
              function Je(Qe, Gr, S) {
                var Ce = [], qe = Qe.initializer;
                if (e.isVariableDeclarationList(qe)) {
                  Qe.initializer.flags & 3 && Co();
                  var br = e.firstOrUndefined(qe.declarations);
                  if (br && e.isBindingPattern(br.name)) {
                    var Zr = e.flattenDestructuringBinding(br, L, p, 0, Gr), Si = e.setTextRange(m.createVariableDeclarationList(Zr), Qe.initializer);
                    e.setOriginalNode(Si, Qe.initializer), e.setSourceMapRange(Si, e.createRange(Zr[0].pos, e.last(Zr).end)), Ce.push(m.createVariableStatement(void 0, Si));
                  } else Ce.push(e.setTextRange(m.createVariableStatement(void 0, e.setOriginalNode(e.setTextRange(m.createVariableDeclarationList([m.createVariableDeclaration(br ? br.name : m.createTempVariable(void 0), void 0, void 0, Gr)]), e.moveRangePos(qe, -1)), qe)), e.moveRangeEnd(qe, -1)));
                } else {
                  var Pi = m.createAssignment(qe, Gr);
                  e.isDestructuringAssignment(Pi) ? Ce.push(m.createExpressionStatement(qr(Pi, true))) : (e.setTextRangeEnd(Pi, qe.end), Ce.push(e.setTextRange(m.createExpressionStatement(e.visitNode(Pi, L, e.isExpression)), e.moveRangeEnd(qe, -1))));
                }
                if (S) return xe(e.addRange(Ce, S));
                var Qi = e.visitNode(Qe.statement, L, e.isStatement, m.liftToBlock);
                return e.isBlock(Qi) ? m.updateBlock(Qi, e.setTextRange(m.createNodeArray(e.concatenate(Ce, Qi.statements)), Qi.statements)) : (Ce.push(Qi), xe(Ce));
              }
              function xe(Qe) {
                return e.setEmitFlags(m.createBlock(m.createNodeArray(Qe), true), 432);
              }
              function vr(Qe, Gr, S) {
                var Ce = e.visitNode(Qe.expression, L, e.isExpression), qe = m.createLoopVariable(), br = e.isIdentifier(Ce) ? m.getGeneratedNameForNode(Ce) : m.createTempVariable(void 0);
                e.setEmitFlags(Ce, 48 | e.getEmitFlags(Ce));
                var Zr = e.setTextRange(m.createForStatement(e.setEmitFlags(e.setTextRange(m.createVariableDeclarationList([e.setTextRange(m.createVariableDeclaration(qe, void 0, void 0, m.createNumericLiteral(0)), e.moveRangePos(Qe.expression, -1)), e.setTextRange(m.createVariableDeclaration(br, void 0, void 0, Ce), Qe.expression)]), Qe.expression), 2097152), e.setTextRange(m.createLessThan(qe, m.createPropertyAccessExpression(br, "length")), Qe.expression), e.setTextRange(m.createPostfixIncrement(qe), Qe.expression), Je(Qe, m.createElementAccessExpression(br, qe), S)), Qe);
                return e.setEmitFlags(Zr, 256), e.setTextRange(Zr, Qe), m.restoreEnclosingLabel(Zr, Gr, he && pi);
              }
              function mr(Qe, Gr, S, Ce) {
                var qe = e.visitNode(Qe.expression, L, e.isExpression), br = e.isIdentifier(qe) ? m.getGeneratedNameForNode(qe) : m.createTempVariable(void 0), Zr = e.isIdentifier(qe) ? m.getGeneratedNameForNode(br) : m.createTempVariable(void 0), Si = m.createUniqueName("e"), Pi = m.getGeneratedNameForNode(Si), Qi = m.createTempVariable(void 0), Ct = e.setTextRange(G().createValuesHelper(qe), Qe.expression), sa = m.createCallExpression(m.createPropertyAccessExpression(br, "next"), void 0, []);
                K(Si), K(Qi);
                var en = Ce & 1024 ? m.inlineExpressions([m.createAssignment(Si, m.createVoidZero()), Ct]) : Ct, Wa = e.setEmitFlags(e.setTextRange(m.createForStatement(e.setEmitFlags(e.setTextRange(m.createVariableDeclarationList([e.setTextRange(m.createVariableDeclaration(br, void 0, void 0, en), Qe.expression), m.createVariableDeclaration(Zr, void 0, void 0, sa)]), Qe.expression), 2097152), m.createLogicalNot(m.createPropertyAccessExpression(Zr, "done")), m.createAssignment(Zr, sa), Je(Qe, m.createPropertyAccessExpression(Zr, "value"), S)), Qe), 256);
                return m.createTryStatement(m.createBlock([m.restoreEnclosingLabel(Wa, Gr, he && pi)]), m.createCatchClause(m.createVariableDeclaration(Pi), e.setEmitFlags(m.createBlock([m.createExpressionStatement(m.createAssignment(Si, m.createObjectLiteralExpression([m.createPropertyAssignment("error", Pi)])))]), 1)), m.createBlock([m.createTryStatement(m.createBlock([e.setEmitFlags(m.createIfStatement(m.createLogicalAnd(m.createLogicalAnd(Zr, m.createLogicalNot(m.createPropertyAccessExpression(Zr, "done"))), m.createAssignment(Qi, m.createPropertyAccessExpression(br, "return"))), m.createExpressionStatement(m.createFunctionCallCall(Qi, br, []))), 1)]), void 0, e.setEmitFlags(m.createBlock([e.setEmitFlags(m.createIfStatement(Si, m.createThrowStatement(m.createPropertyAccessExpression(Si, "error"))), 1)]), 1))]));
              }
              function Ar(Qe) {
                for (var Gr = Qe.properties, S = -1, Ce = false, qe = 0; qe < Gr.length; qe++) {
                  var br = Gr[qe];
                  if (br.transformFlags & 524288 && O & 4 || (Ce = e.Debug.checkDefined(br.name).kind === 162)) {
                    S = qe;
                    break;
                  }
                }
                if (S < 0) return e.visitEachChild(Qe, L, p);
                var Zr = m.createTempVariable(K), Si = [], Pi = m.createAssignment(Zr, e.setEmitFlags(m.createObjectLiteralExpression(e.visitNodes(Gr, L, e.isObjectLiteralElementLike, 0, S), Qe.multiLine), Ce ? 65536 : 0));
                return Qe.multiLine && e.startOnNewLine(Pi), Si.push(Pi), Bt(Si, Qe, Zr, S), Si.push(Qe.multiLine ? e.startOnNewLine(e.setParent(e.setTextRange(m.cloneNode(Zr), Zr), Zr.parent)) : Zr), m.inlineExpressions(Si);
              }
              function Oe(Qe) {
                return (se.getNodeCheckFlags(Qe) & 131072) !== 0;
              }
              function nr(Qe) {
                return e.isForStatement(Qe) && !!Qe.initializer && Oe(Qe.initializer);
              }
              function Mr(Qe) {
                return e.isForStatement(Qe) && !!Qe.condition && Oe(Qe.condition);
              }
              function Pe(Qe) {
                return e.isForStatement(Qe) && !!Qe.incrementor && Oe(Qe.incrementor);
              }
              function Ue(Qe) {
                return fr(Qe) || nr(Qe);
              }
              function fr(Qe) {
                return (se.getNodeCheckFlags(Qe) & 65536) !== 0;
              }
              function De(Qe, Gr) {
                Qe.hoistedLocalVariables || (Qe.hoistedLocalVariables = []), S(Gr.name);
                function S(Ce) {
                  if (Ce.kind === 79) Qe.hoistedLocalVariables.push(Ce);
                  else for (var qe = 0, br = Ce.elements; qe < br.length; qe++) {
                    var Zr = br[qe];
                    e.isOmittedExpression(Zr) || S(Zr.name);
                  }
                }
              }
              function gr(Qe, Gr, S, Ce) {
                if (!Ue(Qe)) {
                  var qe = void 0;
                  he && (qe = he.allowedNonLabeledJumps, he.allowedNonLabeledJumps = 6);
                  var br = Ce ? Ce(Qe, Gr, void 0, S) : m.restoreEnclosingLabel(e.isForStatement(Qe) ? Sr(Qe) : e.visitEachChild(Qe, L, p), Gr, he && pi);
                  return he && (he.allowedNonLabeledJumps = qe), br;
                }
                var Zr = ct(Qe), Si = [], Pi = he;
                he = Zr;
                var Qi = nr(Qe) ? Mt(Qe, Zr) : void 0, Ct = fr(Qe) ? xt(Qe, Zr, Pi) : void 0;
                he = Pi, Qi && Si.push(Qi.functionDeclaration), Ct && Si.push(Ct.functionDeclaration), Li(Si, Zr, Pi), Qi && Si.push(Rt(Qi.functionName, Qi.containsYield));
                var sa;
                if (Ct) if (Ce) sa = Ce(Qe, Gr, Ct.part, S);
                else {
                  var en = Vr(Qe, Qi, m.createBlock(Ct.part, true));
                  sa = m.restoreEnclosingLabel(en, Gr, he && pi);
                }
                else {
                  var Wa = Vr(Qe, Qi, e.visitNode(Qe.statement, L, e.isStatement, m.liftToBlock));
                  sa = m.restoreEnclosingLabel(Wa, Gr, he && pi);
                }
                return Si.push(sa), Si;
              }
              function Vr(Qe, Gr, S) {
                switch (Qe.kind) {
                  case 242:
                    return Tr(Qe, Gr, S);
                  case 243:
                    return Ui(Qe, S);
                  case 244:
                    return vi(Qe, S);
                  case 240:
                    return Yi(Qe, S);
                  case 241:
                    return Wi(Qe, S);
                  default:
                    return e.Debug.failBadSyntaxKind(Qe, "IterationStatement expected");
                }
              }
              function Tr(Qe, Gr, S) {
                var Ce = Qe.condition && Oe(Qe.condition), qe = Ce || Qe.incrementor && Oe(Qe.incrementor);
                return m.updateForStatement(Qe, e.visitNode(Gr ? Gr.part : Qe.initializer, P, e.isForInitializer), e.visitNode(Ce ? void 0 : Qe.condition, L, e.isExpression), e.visitNode(qe ? void 0 : Qe.incrementor, P, e.isExpression), S);
              }
              function vi(Qe, Gr) {
                return m.updateForOfStatement(Qe, void 0, e.visitNode(Qe.initializer, L, e.isForInitializer), e.visitNode(Qe.expression, L, e.isExpression), Gr);
              }
              function Ui(Qe, Gr) {
                return m.updateForInStatement(Qe, e.visitNode(Qe.initializer, L, e.isForInitializer), e.visitNode(Qe.expression, L, e.isExpression), Gr);
              }
              function Yi(Qe, Gr) {
                return m.updateDoStatement(Qe, Gr, e.visitNode(Qe.expression, L, e.isExpression));
              }
              function Wi(Qe, Gr) {
                return m.updateWhileStatement(Qe, e.visitNode(Qe.expression, L, e.isExpression), Gr);
              }
              function ct(Qe) {
                var Gr;
                switch (Qe.kind) {
                  case 242:
                  case 243:
                  case 244:
                    var S = Qe.initializer;
                    S && S.kind === 255 && (Gr = S);
                    break;
                }
                var Ce = [], qe = [];
                if (Gr && e.getCombinedNodeFlags(Gr) & 3) for (var br = nr(Qe) || Mr(Qe) || Pe(Qe), Zr = 0, Si = Gr.declarations; Zr < Si.length; Zr++) {
                  var Pi = Si[Zr];
                  ui(Qe, Pi, Ce, qe, br);
                }
                var Qi = { loopParameters: Ce, loopOutParameters: qe };
                return he && (he.argumentsName && (Qi.argumentsName = he.argumentsName), he.thisName && (Qi.thisName = he.thisName), he.hoistedLocalVariables && (Qi.hoistedLocalVariables = he.hoistedLocalVariables)), Qi;
              }
              function Li(Qe, Gr, S) {
                var Ce;
                if (Gr.argumentsName && (S ? S.argumentsName = Gr.argumentsName : (Ce || (Ce = [])).push(m.createVariableDeclaration(Gr.argumentsName, void 0, void 0, m.createIdentifier("arguments")))), Gr.thisName && (S ? S.thisName = Gr.thisName : (Ce || (Ce = [])).push(m.createVariableDeclaration(Gr.thisName, void 0, void 0, m.createIdentifier("this")))), Gr.hoistedLocalVariables) if (S) S.hoistedLocalVariables = Gr.hoistedLocalVariables;
                else {
                  Ce || (Ce = []);
                  for (var qe = 0, br = Gr.hoistedLocalVariables; qe < br.length; qe++) {
                    var Zr = br[qe];
                    Ce.push(m.createVariableDeclaration(Zr));
                  }
                }
                if (Gr.loopOutParameters.length) {
                  Ce || (Ce = []);
                  for (var Si = 0, Pi = Gr.loopOutParameters; Si < Pi.length; Si++) {
                    var Qi = Pi[Si];
                    Ce.push(m.createVariableDeclaration(Qi.outParamName));
                  }
                }
                Gr.conditionVariable && (Ce || (Ce = []), Ce.push(m.createVariableDeclaration(Gr.conditionVariable, void 0, void 0, m.createFalse()))), Ce && Qe.push(m.createVariableStatement(void 0, m.createVariableDeclarationList(Ce)));
              }
              function nt(Qe) {
                return m.createVariableDeclaration(Qe.originalName, void 0, void 0, Qe.outParamName);
              }
              function Mt(Qe, Gr) {
                var S = m.createUniqueName("_loop_init"), Ce = (Qe.initializer.transformFlags & 524288) !== 0, qe = 0;
                Gr.containsLexicalThis && (qe |= 8), Ce && O & 4 && (qe |= 262144);
                var br = [];
                br.push(m.createVariableStatement(void 0, Qe.initializer)), Dt(Gr.loopOutParameters, 2, 1, br);
                var Zr = m.createVariableStatement(void 0, e.setEmitFlags(m.createVariableDeclarationList([m.createVariableDeclaration(S, void 0, void 0, e.setEmitFlags(m.createFunctionExpression(void 0, Ce ? m.createToken(41) : void 0, void 0, void 0, void 0, void 0, e.visitNode(m.createBlock(br, true), L, e.isBlock)), qe))]), 2097152)), Si = m.createVariableDeclarationList(e.map(Gr.loopOutParameters, nt));
                return { functionName: S, containsYield: Ce, functionDeclaration: Zr, part: Si };
              }
              function xt(Qe, Gr, S) {
                var Ce = m.createUniqueName("_loop");
                oe();
                var qe = e.visitNode(Qe.statement, L, e.isStatement, m.liftToBlock), br = T(), Zr = [];
                (Mr(Qe) || Pe(Qe)) && (Gr.conditionVariable = m.createUniqueName("inc"), Qe.incrementor ? Zr.push(m.createIfStatement(Gr.conditionVariable, m.createExpressionStatement(e.visitNode(Qe.incrementor, L, e.isExpression)), m.createExpressionStatement(m.createAssignment(Gr.conditionVariable, m.createTrue())))) : Zr.push(m.createIfStatement(m.createLogicalNot(Gr.conditionVariable), m.createExpressionStatement(m.createAssignment(Gr.conditionVariable, m.createTrue())))), Mr(Qe) && Zr.push(m.createIfStatement(m.createPrefixUnaryExpression(53, e.visitNode(Qe.condition, L, e.isExpression)), e.visitNode(m.createBreakStatement(), L, e.isStatement)))), e.isBlock(qe) ? e.addRange(Zr, qe.statements) : Zr.push(qe), Dt(Gr.loopOutParameters, 1, 1, Zr), e.insertStatementsAfterStandardPrologue(Zr, br);
                var Si = m.createBlock(Zr, true);
                e.isBlock(qe) && e.setOriginalNode(Si, qe);
                var Pi = (Qe.statement.transformFlags & 524288) !== 0, Qi = 524288;
                Gr.containsLexicalThis && (Qi |= 8), Pi && (O & 4) !== 0 && (Qi |= 262144);
                var Ct = m.createVariableStatement(void 0, e.setEmitFlags(m.createVariableDeclarationList([m.createVariableDeclaration(Ce, void 0, void 0, e.setEmitFlags(m.createFunctionExpression(void 0, Pi ? m.createToken(41) : void 0, void 0, void 0, Gr.loopParameters, void 0, Si), Qi))]), 2097152)), sa = Ii(Ce, Gr, S, Pi);
                return { functionName: Ce, containsYield: Pi, functionDeclaration: Ct, part: sa };
              }
              function ut(Qe, Gr) {
                var S = Gr === 0 ? Qe.outParamName : Qe.originalName, Ce = Gr === 0 ? Qe.originalName : Qe.outParamName;
                return m.createBinaryExpression(Ce, 63, S);
              }
              function Dt(Qe, Gr, S, Ce) {
                for (var qe = 0, br = Qe; qe < br.length; qe++) {
                  var Zr = br[qe];
                  Zr.flags & Gr && Ce.push(m.createExpressionStatement(ut(Zr, S)));
                }
              }
              function Rt(Qe, Gr) {
                var S = m.createCallExpression(Qe, void 0, []), Ce = Gr ? m.createYieldExpression(m.createToken(41), e.setEmitFlags(S, 8388608)) : S;
                return m.createExpressionStatement(Ce);
              }
              function Ii(Qe, Gr, S, Ce) {
                var qe = [], br = !(Gr.nonLocalJumps & -5) && !Gr.labeledNonLocalBreaks && !Gr.labeledNonLocalContinues, Zr = m.createCallExpression(Qe, void 0, e.map(Gr.loopParameters, function(en) {
                  return en.name;
                })), Si = Ce ? m.createYieldExpression(m.createToken(41), e.setEmitFlags(Zr, 8388608)) : Zr;
                if (br) qe.push(m.createExpressionStatement(Si)), Dt(Gr.loopOutParameters, 1, 0, qe);
                else {
                  var Pi = m.createUniqueName("state"), Qi = m.createVariableStatement(void 0, m.createVariableDeclarationList([m.createVariableDeclaration(Pi, void 0, void 0, Si)]));
                  if (qe.push(Qi), Dt(Gr.loopOutParameters, 1, 0, qe), Gr.nonLocalJumps & 8) {
                    var Ct = void 0;
                    S ? (S.nonLocalJumps |= 8, Ct = m.createReturnStatement(Pi)) : Ct = m.createReturnStatement(m.createPropertyAccessExpression(Pi, "value")), qe.push(m.createIfStatement(m.createTypeCheck(Pi, "object"), Ct));
                  }
                  if (Gr.nonLocalJumps & 2 && qe.push(m.createIfStatement(m.createStrictEquality(Pi, m.createStringLiteral("break")), m.createBreakStatement())), Gr.labeledNonLocalBreaks || Gr.labeledNonLocalContinues) {
                    var sa = [];
                    Fi(Gr.labeledNonLocalBreaks, true, Pi, S, sa), Fi(Gr.labeledNonLocalContinues, false, Pi, S, sa), qe.push(m.createSwitchStatement(Pi, m.createCaseBlock(sa)));
                  }
                }
                return qe;
              }
              function Ki(Qe, Gr, S, Ce) {
                Gr ? (Qe.labeledNonLocalBreaks || (Qe.labeledNonLocalBreaks = new e.Map()), Qe.labeledNonLocalBreaks.set(S, Ce)) : (Qe.labeledNonLocalContinues || (Qe.labeledNonLocalContinues = new e.Map()), Qe.labeledNonLocalContinues.set(S, Ce));
              }
              function Fi(Qe, Gr, S, Ce, qe) {
                !Qe || Qe.forEach(function(br, Zr) {
                  var Si = [];
                  if (!Ce || Ce.labels && Ce.labels.get(Zr)) {
                    var Pi = m.createIdentifier(Zr);
                    Si.push(Gr ? m.createBreakStatement(Pi) : m.createContinueStatement(Pi));
                  } else Ki(Ce, Gr, Zr, br), Si.push(m.createReturnStatement(S));
                  qe.push(m.createCaseClause(m.createStringLiteral(br), Si));
                });
              }
              function ui(Qe, Gr, S, Ce, qe) {
                var br = Gr.name;
                if (e.isBindingPattern(br)) for (var Zr = 0, Si = br.elements; Zr < Si.length; Zr++) {
                  var Pi = Si[Zr];
                  e.isOmittedExpression(Pi) || ui(Qe, Pi, S, Ce, qe);
                }
                else {
                  S.push(m.createParameterDeclaration(void 0, void 0, void 0, br));
                  var Qi = se.getNodeCheckFlags(Gr);
                  if (Qi & 4194304 || qe) {
                    var Ct = m.createUniqueName("out_" + e.idText(br)), sa = 0;
                    Qi & 4194304 && (sa |= 1), e.isForStatement(Qe) && (Qe.initializer && se.isBindingCapturedByNode(Qe.initializer, Gr) && (sa |= 2), (Qe.condition && se.isBindingCapturedByNode(Qe.condition, Gr) || Qe.incrementor && se.isBindingCapturedByNode(Qe.incrementor, Gr)) && (sa |= 1)), Ce.push({ flags: sa, originalName: br, outParamName: Ct });
                  }
                }
              }
              function Bt(Qe, Gr, S, Ce) {
                for (var qe = Gr.properties, br = qe.length, Zr = Ce; Zr < br; Zr++) {
                  var Si = qe[Zr];
                  switch (Si.kind) {
                    case 172:
                    case 173:
                      var Pi = e.getAllAccessorDeclarations(Gr.properties, Si);
                      Si === Pi.firstAccessor && Qe.push(ur(S, Pi, Gr, !!Gr.multiLine));
                      break;
                    case 169:
                      Qe.push(Ai(Si, S, Gr, Gr.multiLine));
                      break;
                    case 296:
                      Qe.push(wt(Si, S, Gr.multiLine));
                      break;
                    case 297:
                      Qe.push(na(Si, S, Gr.multiLine));
                      break;
                    default:
                      e.Debug.failBadSyntaxKind(Gr);
                      break;
                  }
                }
              }
              function wt(Qe, Gr, S) {
                var Ce = m.createAssignment(e.createMemberAccessForPropertyName(m, Gr, e.visitNode(Qe.name, L, e.isPropertyName)), e.visitNode(Qe.initializer, L, e.isExpression));
                return e.setTextRange(Ce, Qe), S && e.startOnNewLine(Ce), Ce;
              }
              function na(Qe, Gr, S) {
                var Ce = m.createAssignment(e.createMemberAccessForPropertyName(m, Gr, e.visitNode(Qe.name, L, e.isPropertyName)), m.cloneNode(Qe.name));
                return e.setTextRange(Ce, Qe), S && e.startOnNewLine(Ce), Ce;
              }
              function Ai(Qe, Gr, S, Ce) {
                var qe = m.createAssignment(e.createMemberAccessForPropertyName(m, Gr, e.visitNode(Qe.name, L, e.isPropertyName)), Ur(Qe, Qe, void 0, S));
                return e.setTextRange(qe, Qe), Ce && e.startOnNewLine(qe), qe;
              }
              function Oi(Qe) {
                var Gr = X(7104, 0), S;
                if (e.Debug.assert(!!Qe.variableDeclaration, "Catch clause variable should always be present when downleveling ES2015."), e.isBindingPattern(Qe.variableDeclaration.name)) {
                  var Ce = m.createTempVariable(void 0), qe = m.createVariableDeclaration(Ce);
                  e.setTextRange(qe, Qe.variableDeclaration);
                  var br = e.flattenDestructuringBinding(Qe.variableDeclaration, L, p, 0, Ce), Zr = m.createVariableDeclarationList(br);
                  e.setTextRange(Zr, Qe.variableDeclaration);
                  var Si = m.createVariableStatement(void 0, Zr);
                  S = m.updateCatchClause(Qe, qe, ji(Qe.block, Si));
                } else S = e.visitEachChild(Qe, L, p);
                return $(Gr, 0, 0), S;
              }
              function ji(Qe, Gr) {
                var S = e.visitNodes(Qe.statements, L, e.isStatement);
                return m.updateBlock(Qe, Ve([Gr], S, true));
              }
              function Vi(Qe) {
                e.Debug.assert(!e.isComputedPropertyName(Qe.name));
                var Gr = Ur(Qe, e.moveRangePos(Qe, -1), void 0, void 0);
                return e.setEmitFlags(Gr, 512 | e.getEmitFlags(Gr)), e.setTextRange(m.createPropertyAssignment(Qe.name, Gr), Qe);
              }
              function at(Qe) {
                e.Debug.assert(!e.isComputedPropertyName(Qe.name));
                var Gr = he;
                he = void 0;
                var S = X(32670, 65), Ce, qe = e.visitParameterList(Qe.parameters, L, p), br = ii(Qe);
                return Qe.kind === 172 ? Ce = m.updateGetAccessorDeclaration(Qe, Qe.decorators, Qe.modifiers, Qe.name, qe, Qe.type, br) : Ce = m.updateSetAccessorDeclaration(Qe, Qe.decorators, Qe.modifiers, Qe.name, qe, br), $(S, 98304, 0), he = Gr, Ce;
              }
              function At(Qe) {
                return e.setTextRange(m.createPropertyAssignment(Qe.name, g(m.cloneNode(Qe.name))), Qe);
              }
              function ba(Qe) {
                return e.visitEachChild(Qe, L, p);
              }
              function $a(Qe) {
                return e.visitEachChild(Qe, L, p);
              }
              function Qa(Qe) {
                return e.some(Qe.elements, e.isSpreadElement) ? Cn(Qe.elements, false, !!Qe.multiLine, !!Qe.elements.hasTrailingComma) : e.visitEachChild(Qe, L, p);
              }
              function ai(Qe) {
                if (e.getEmitFlags(Qe) & 33554432) return Dn(Qe);
                var Gr = e.skipOuterExpressions(Qe.expression);
                return Gr.kind === 106 || e.isSuperProperty(Gr) || e.some(Qe.arguments, e.isSpreadElement) ? Ba(Qe, true) : m.updateCallExpression(Qe, e.visitNode(Qe.expression, Y, e.isExpression), void 0, e.visitNodes(Qe.arguments, L, e.isExpression));
              }
              function Dn(Qe) {
                var Gr = e.cast(e.cast(e.skipOuterExpressions(Qe.expression), e.isArrowFunction).body, e.isBlock), S = function(ys) {
                  return e.isVariableStatement(ys) && !!e.first(ys.declarationList.declarations).initializer;
                }, Ce = he;
                he = void 0;
                var qe = e.visitNodes(Gr.statements, k, e.isStatement);
                he = Ce;
                var br = e.filter(qe, S), Zr = e.filter(qe, function(ys) {
                  return !S(ys);
                }), Si = e.cast(e.first(br), e.isVariableStatement), Pi = Si.declarationList.declarations[0], Qi = e.skipOuterExpressions(Pi.initializer), Ct = e.tryCast(Qi, e.isAssignmentExpression);
                !Ct && e.isBinaryExpression(Qi) && Qi.operatorToken.kind === 27 && (Ct = e.tryCast(Qi.left, e.isAssignmentExpression));
                var sa = e.cast(Ct ? e.skipOuterExpressions(Ct.right) : Qi, e.isCallExpression), en = e.cast(e.skipOuterExpressions(sa.expression), e.isFunctionExpression), Wa = en.body.statements, qn = 0, mo = -1, So = [];
                if (Ct) {
                  var Go = e.tryCast(Wa[qn], e.isExpressionStatement);
                  Go && (So.push(Go), qn++), So.push(Wa[qn]), qn++, So.push(m.createExpressionStatement(m.createAssignment(Ct.left, e.cast(Pi.name, e.isIdentifier))));
                }
                for (; !e.isReturnStatement(e.elementAt(Wa, mo)); ) mo--;
                return e.addRange(So, Wa, qn, mo), mo < -1 && e.addRange(So, Wa, mo + 1), e.addRange(So, Zr), e.addRange(So, br, 1), m.restoreOuterExpressions(Qe.expression, m.restoreOuterExpressions(Pi.initializer, m.restoreOuterExpressions(Ct && Ct.right, m.updateCallExpression(sa, m.restoreOuterExpressions(sa.expression, m.updateFunctionExpression(en, void 0, void 0, void 0, void 0, en.parameters, void 0, m.updateBlock(en.body, So))), void 0, sa.arguments))));
              }
              function ka(Qe) {
                return Ba(Qe, false);
              }
              function Ba(Qe, Gr) {
                if (Qe.transformFlags & 16384 || Qe.expression.kind === 106 || e.isSuperProperty(e.skipOuterExpressions(Qe.expression))) {
                  var S = m.createCallBinding(Qe.expression, K), Ce = S.target, qe = S.thisArg;
                  Qe.expression.kind === 106 && e.setEmitFlags(qe, 4);
                  var br = void 0;
                  if (Qe.transformFlags & 16384 ? br = m.createFunctionApplyCall(e.visitNode(Ce, Y, e.isExpression), Qe.expression.kind === 106 ? qe : e.visitNode(qe, L, e.isExpression), Cn(Qe.arguments, true, false, false)) : br = e.setTextRange(m.createFunctionCallCall(e.visitNode(Ce, Y, e.isExpression), Qe.expression.kind === 106 ? qe : e.visitNode(qe, L, e.isExpression), e.visitNodes(Qe.arguments, L, e.isExpression)), Qe), Qe.expression.kind === 106) {
                    var Zr = m.createLogicalOr(br, Ie());
                    br = Gr ? m.createAssignment(m.createUniqueName("_this", 48), Zr) : Zr;
                  }
                  return e.setOriginalNode(br, Qe);
                }
                return e.visitEachChild(Qe, L, p);
              }
              function pn(Qe) {
                if (e.some(Qe.arguments, e.isSpreadElement)) {
                  var Gr = m.createCallBinding(m.createPropertyAccessExpression(Qe.expression, "bind"), K), S = Gr.target, Ce = Gr.thisArg;
                  return m.createNewExpression(m.createFunctionApplyCall(e.visitNode(S, L, e.isExpression), Ce, Cn(m.createNodeArray(Ve([m.createVoidZero()], Qe.arguments, true)), true, false, false)), void 0, []);
                }
                return e.visitEachChild(Qe, L, p);
              }
              function Cn(Qe, Gr, S, Ce) {
                var qe = Qe.length, br = e.flatten(e.spanMap(Qe, Bi, function(en, Wa, qn, mo) {
                  return Wa(en, S, Ce && mo === qe);
                }));
                if (br.length === 1) {
                  var Zr = br[0];
                  if (Gr && !b.downlevelIteration || e.isPackedArrayLiteral(Zr.expression) || e.isCallToHelper(Zr.expression, "___spreadArray")) return Zr.expression;
                }
                for (var Si = G(), Pi = br[0].kind !== 0, Qi = Pi ? m.createArrayLiteralExpression() : br[0].expression, Ct = Pi ? 0 : 1; Ct < br.length; Ct++) {
                  var sa = br[Ct];
                  Qi = Si.createSpreadArrayHelper(Qi, sa.expression, sa.kind === 1 && !Gr);
                }
                return Qi;
              }
              function Bi(Qe) {
                return e.isSpreadElement(Qe) ? kn : Kn;
              }
              function kn(Qe) {
                return e.map(Qe, xn);
              }
              function xn(Qe) {
                var Gr = e.visitNode(Qe.expression, L, e.isExpression), S = e.isCallToHelper(Gr, "___read"), Ce = S || e.isPackedArrayLiteral(Gr) ? 2 : 1;
                return b.downlevelIteration && Ce === 1 && !e.isArrayLiteralExpression(Gr) && !S && (Gr = G().createReadHelper(Gr, void 0), Ce = 2), le(Ce, Gr);
              }
              function Kn(Qe, Gr, S) {
                var Ce = m.createArrayLiteralExpression(e.visitNodes(m.createNodeArray(Qe, S), L, e.isExpression), Gr);
                return le(0, Ce);
              }
              function Pn(Qe) {
                return e.visitNode(Qe.expression, L, e.isExpression);
              }
              function eo(Qe) {
                return e.setTextRange(m.createStringLiteral(Qe.text), Qe);
              }
              function Rn(Qe) {
                return Qe.hasExtendedUnicodeEscape ? e.setTextRange(m.createStringLiteral(Qe.text), Qe) : Qe;
              }
              function Da(Qe) {
                return Qe.numericLiteralFlags & 384 ? e.setTextRange(m.createNumericLiteral(Qe.text), Qe) : Qe;
              }
              function bo(Qe) {
                return e.processTaggedTemplateExpression(p, Qe, L, R, ee, e.ProcessLevel.All);
              }
              function Ro(Qe) {
                for (var Gr = m.createStringLiteral(Qe.head.text), S = 0, Ce = Qe.templateSpans; S < Ce.length; S++) {
                  var qe = Ce[S], br = [e.visitNode(qe.expression, L, e.isExpression)];
                  qe.literal.text.length > 0 && br.push(m.createStringLiteral(qe.literal.text)), Gr = m.createCallExpression(m.createPropertyAccessExpression(Gr, "concat"), void 0, br);
                }
                return e.setTextRange(Gr, Qe);
              }
              function En(Qe) {
                return O & 8 && !Qe ? m.createPropertyAccessExpression(m.createUniqueName("_super", 48), "prototype") : m.createUniqueName("_super", 48);
              }
              function Wn(Qe) {
                return Qe.keywordToken === 103 && Qe.name.escapedText === "target" ? (O |= 32768, m.createUniqueName("_newTarget", 48)) : Qe;
              }
              function to(Qe, Gr, S) {
                if (F & 1 && e.isFunctionLike(Gr)) {
                  var Ce = X(32670, e.getEmitFlags(Gr) & 8 ? 81 : 65);
                  ie(Qe, Gr, S), $(Ce, 0, 0);
                  return;
                }
                ie(Qe, Gr, S);
              }
              function Co() {
                (F & 2) === 0 && (F |= 2, p.enableSubstitution(79));
              }
              function Ko() {
                (F & 1) === 0 && (F |= 1, p.enableSubstitution(108), p.enableEmitNotification(171), p.enableEmitNotification(169), p.enableEmitNotification(172), p.enableEmitNotification(173), p.enableEmitNotification(214), p.enableEmitNotification(213), p.enableEmitNotification(256));
              }
              function Oo(Qe, Gr) {
                return Gr = J(Qe, Gr), Qe === 1 ? Pr(Gr) : e.isIdentifier(Gr) ? no(Gr) : Gr;
              }
              function no(Qe) {
                if (F & 2 && !e.isInternalName(Qe)) {
                  var Gr = e.getParseTreeNode(Qe, e.isIdentifier);
                  if (Gr && $o(Gr)) return e.setTextRange(m.getGeneratedNameForNode(Gr), Qe);
                }
                return Qe;
              }
              function $o(Qe) {
                switch (Qe.parent.kind) {
                  case 203:
                  case 257:
                  case 260:
                  case 254:
                    return Qe.parent.name === Qe && se.isDeclarationWithCollidingName(Qe.parent);
                }
                return false;
              }
              function Pr(Qe) {
                switch (Qe.kind) {
                  case 79:
                    return xi(Qe);
                  case 108:
                    return pa(Qe);
                }
                return Qe;
              }
              function xi(Qe) {
                if (F & 2 && !e.isInternalName(Qe)) {
                  var Gr = se.getReferencedDeclarationWithCollidingName(Qe);
                  if (Gr && !(e.isClassLike(Gr) && St(Gr, Qe))) return e.setTextRange(m.getGeneratedNameForNode(e.getNameOfDeclaration(Gr)), Qe);
                }
                return Qe;
              }
              function St(Qe, Gr) {
                var S = e.getParseTreeNode(Gr);
                if (!S || S === Qe || S.end <= Qe.pos || S.pos >= Qe.end) return false;
                for (var Ce = e.getEnclosingBlockScopeContainer(Qe); S; ) {
                  if (S === Ce || S === Qe) return false;
                  if (e.isClassElement(S) && S.parent === Qe) return true;
                  S = S.parent;
                }
                return false;
              }
              function pa(Qe) {
                return F & 1 && O & 16 ? e.setTextRange(m.createUniqueName("_this", 48), Qe) : Qe;
              }
              function dn(Qe, Gr) {
                return e.isStatic(Gr) ? m.getInternalName(Qe) : m.createPropertyAccessExpression(m.getInternalName(Qe), "prototype");
              }
              function Jn(Qe, Gr) {
                if (!Qe || !Gr || e.some(Qe.parameters)) return false;
                var S = e.firstOrUndefined(Qe.body.statements);
                if (!S || !e.nodeIsSynthesized(S) || S.kind !== 238) return false;
                var Ce = S.expression;
                if (!e.nodeIsSynthesized(Ce) || Ce.kind !== 208) return false;
                var qe = Ce.expression;
                if (!e.nodeIsSynthesized(qe) || qe.kind !== 106) return false;
                var br = e.singleOrUndefined(Ce.arguments);
                if (!br || !e.nodeIsSynthesized(br) || br.kind !== 225) return false;
                var Zr = br.expression;
                return e.isIdentifier(Zr) && Zr.escapedText === "arguments";
              }
            }
            e.transformES2015 = N;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(C) {
              var w = C.factory, B = C.getCompilerOptions(), E, Q;
              (B.jsx === 1 || B.jsx === 3) && (E = C.onEmitNode, C.onEmitNode = p, C.enableEmitNotification(280), C.enableEmitNotification(281), C.enableEmitNotification(279), Q = []);
              var le = C.onSubstituteNode;
              return C.onSubstituteNode = m, C.enableSubstitution(206), C.enableSubstitution(296), e.chainBundle(C, N);
              function N(T) {
                return T;
              }
              function p(T, K, b) {
                switch (K.kind) {
                  case 280:
                  case 281:
                  case 279:
                    var se = K.tagName;
                    Q[e.getOriginalNodeId(se)] = true;
                    break;
                }
                E(T, K, b);
              }
              function m(T, K) {
                return K.id && Q && Q[K.id] ? le(T, K) : (K = le(T, K), e.isPropertyAccessExpression(K) ? G(K) : e.isPropertyAssignment(K) ? oe(K) : K);
              }
              function G(T) {
                if (e.isPrivateIdentifier(T.name)) return T;
                var K = f(T.name);
                return K ? e.setTextRange(w.createElementAccessExpression(T.expression, K), T) : T;
              }
              function oe(T) {
                var K = e.isIdentifier(T.name) && f(T.name);
                return K ? w.updatePropertyAssignment(T, K, T.initializer) : T;
              }
              function f(T) {
                var K = T.originalKeywordKind || (e.nodeIsSynthesized(T) ? e.stringToToken(e.idText(T)) : void 0);
                if (K !== void 0 && K >= 81 && K <= 116) return e.setTextRange(w.createStringLiteralFromNode(T), T);
              }
            }
            e.transformES5 = a;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(N) {
              N[N.Nop = 0] = "Nop", N[N.Statement = 1] = "Statement", N[N.Assign = 2] = "Assign", N[N.Break = 3] = "Break", N[N.BreakWhenTrue = 4] = "BreakWhenTrue", N[N.BreakWhenFalse = 5] = "BreakWhenFalse", N[N.Yield = 6] = "Yield", N[N.YieldStar = 7] = "YieldStar", N[N.Return = 8] = "Return", N[N.Throw = 9] = "Throw", N[N.Endfinally = 10] = "Endfinally";
            })(a || (a = {}));
            var C;
            (function(N) {
              N[N.Open = 0] = "Open", N[N.Close = 1] = "Close";
            })(C || (C = {}));
            var w;
            (function(N) {
              N[N.Exception = 0] = "Exception", N[N.With = 1] = "With", N[N.Switch = 2] = "Switch", N[N.Loop = 3] = "Loop", N[N.Labeled = 4] = "Labeled";
            })(w || (w = {}));
            var B;
            (function(N) {
              N[N.Try = 0] = "Try", N[N.Catch = 1] = "Catch", N[N.Finally = 2] = "Finally", N[N.Done = 3] = "Done";
            })(B || (B = {}));
            var E;
            (function(N) {
              N[N.Next = 0] = "Next", N[N.Throw = 1] = "Throw", N[N.Return = 2] = "Return", N[N.Break = 3] = "Break", N[N.Yield = 4] = "Yield", N[N.YieldStar = 5] = "YieldStar", N[N.Catch = 6] = "Catch", N[N.Endfinally = 7] = "Endfinally";
            })(E || (E = {}));
            function Q(N) {
              switch (N) {
                case 2:
                  return "return";
                case 3:
                  return "break";
                case 4:
                  return "yield";
                case 5:
                  return "yield*";
                case 7:
                  return "endfinally";
                default:
                  return;
              }
            }
            function le(N) {
              var p = N.factory, m = N.getEmitHelperFactory, G = N.resumeLexicalEnvironment, oe = N.endLexicalEnvironment, f = N.hoistFunctionDeclaration, T = N.hoistVariableDeclaration, K = N.getCompilerOptions(), b = e.getEmitScriptTarget(K), se = N.getEmitResolver(), J = N.onSubstituteNode;
              N.onSubstituteNode = zr;
              var ie, R, q, O, ve, ee, he, F, x, X, $ = 1, A, y, V, L, P = 0, k = 0, Y, U, j, H, I, l, d, D;
              return e.chainBundle(N, fe);
              function fe(Pr) {
                if (Pr.isDeclarationFile || (Pr.transformFlags & 2048) === 0) return Pr;
                var xi = e.visitEachChild(Pr, g, N);
                return e.addEmitHelpers(xi, N.readEmitHelpers()), xi;
              }
              function g(Pr) {
                var xi = Pr.transformFlags;
                return O ? ne(Pr) : q ? ue(Pr) : e.isFunctionLikeDeclaration(Pr) && Pr.asteriskToken ? Fe(Pr) : xi & 2048 ? e.visitEachChild(Pr, g, N) : Pr;
              }
              function ne(Pr) {
                switch (Pr.kind) {
                  case 240:
                    return Ur(Pr);
                  case 241:
                    return mi(Pr);
                  case 249:
                    return pi(Pr);
                  case 250:
                    return Xe(Pr);
                  default:
                    return ue(Pr);
                }
              }
              function ue(Pr) {
                switch (Pr.kind) {
                  case 256:
                    return Z(Pr);
                  case 213:
                    return Be(Pr);
                  case 172:
                  case 173:
                    return ge(Pr);
                  case 237:
                    return ze(Pr);
                  case 242:
                    return or(Pr);
                  case 243:
                    return si(Pr);
                  case 246:
                    return et(Pr);
                  case 245:
                    return wi(Pr);
                  case 247:
                    return Wt(Pr);
                  default:
                    return Pr.transformFlags & 524288 ? We(Pr) : Pr.transformFlags & 2099200 ? e.visitEachChild(Pr, g, N) : Pr;
                }
              }
              function We(Pr) {
                switch (Pr.kind) {
                  case 221:
                    return Ee(Pr);
                  case 351:
                    return _e(Pr);
                  case 222:
                    return de(Pr);
                  case 224:
                    return ye(Pr);
                  case 204:
                    return Ae(Pr);
                  case 205:
                    return ir(Pr);
                  case 207:
                    return Cr(Pr);
                  case 208:
                    return Ye(Pr);
                  case 209:
                    return Br(Pr);
                  default:
                    return e.visitEachChild(Pr, g, N);
                }
              }
              function Fe(Pr) {
                switch (Pr.kind) {
                  case 256:
                    return Z(Pr);
                  case 213:
                    return Be(Pr);
                  default:
                    return e.Debug.failBadSyntaxKind(Pr);
                }
              }
              function Z(Pr) {
                if (Pr.asteriskToken) Pr = e.setOriginalNode(e.setTextRange(p.createFunctionDeclaration(void 0, Pr.modifiers, void 0, Pr.name, void 0, e.visitParameterList(Pr.parameters, g, N), void 0, Re(Pr.body)), Pr), Pr);
                else {
                  var xi = q, St = O;
                  q = false, O = false, Pr = e.visitEachChild(Pr, g, N), q = xi, O = St;
                }
                if (q) {
                  f(Pr);
                  return;
                } else return Pr;
              }
              function Be(Pr) {
                if (Pr.asteriskToken) Pr = e.setOriginalNode(e.setTextRange(p.createFunctionExpression(void 0, void 0, Pr.name, void 0, e.visitParameterList(Pr.parameters, g, N), void 0, Re(Pr.body)), Pr), Pr);
                else {
                  var xi = q, St = O;
                  q = false, O = false, Pr = e.visitEachChild(Pr, g, N), q = xi, O = St;
                }
                return Pr;
              }
              function ge(Pr) {
                var xi = q, St = O;
                return q = false, O = false, Pr = e.visitEachChild(Pr, g, N), q = xi, O = St, Pr;
              }
              function Re(Pr) {
                var xi = [], St = q, pa = O, dn = ve, Jn = ee, Qe = he, Gr = F, S = x, Ce = X, qe = $, br = A, Zr = y, Si = V, Pi = L;
                q = true, O = false, ve = void 0, ee = void 0, he = void 0, F = void 0, x = void 0, X = void 0, $ = 1, A = void 0, y = void 0, V = void 0, L = p.createTempVariable(void 0), G();
                var Qi = p.copyPrologue(Pr.statements, xi, false, g);
                Er(Pr.statements, Qi);
                var Ct = pn();
                return e.insertStatementsAfterStandardPrologue(xi, oe()), xi.push(p.createReturnStatement(Ct)), q = St, O = pa, ve = dn, ee = Jn, he = Qe, F = Gr, x = S, X = Ce, $ = qe, A = br, y = Zr, V = Si, L = Pi, e.setTextRange(p.createBlock(xi, Pr.multiLine), Pr);
              }
              function ze(Pr) {
                if (Pr.transformFlags & 524288) {
                  ur(Pr.declarationList);
                  return;
                } else {
                  if (e.getEmitFlags(Pr) & 1048576) return Pr;
                  for (var xi = 0, St = Pr.declarationList.declarations; xi < St.length; xi++) {
                    var pa = St[xi];
                    T(pa.name);
                  }
                  var dn = e.getInitializedVariables(Pr.declarationList);
                  return dn.length === 0 ? void 0 : e.setSourceMapRange(p.createExpressionStatement(p.inlineExpressions(e.map(dn, yr))), Pr);
                }
              }
              function Ee(Pr) {
                var xi = e.getExpressionAssociativity(Pr);
                switch (xi) {
                  case 0:
                    return rr(Pr);
                  case 1:
                    return He(Pr);
                  default:
                    return e.Debug.assertNever(xi);
                }
              }
              function He(Pr) {
                var xi = Pr.left, St = Pr.right;
                if (Ze(St)) {
                  var pa = void 0;
                  switch (xi.kind) {
                    case 206:
                      pa = p.updatePropertyAccessExpression(xi, xe(e.visitNode(xi.expression, g, e.isLeftHandSideExpression)), xi.name);
                      break;
                    case 207:
                      pa = p.updateElementAccessExpression(xi, xe(e.visitNode(xi.expression, g, e.isLeftHandSideExpression)), xe(e.visitNode(xi.argumentExpression, g, e.isExpression)));
                      break;
                    default:
                      pa = e.visitNode(xi, g, e.isExpression);
                      break;
                  }
                  var dn = Pr.operatorToken.kind;
                  return e.isCompoundAssignment(dn) ? e.setTextRange(p.createAssignment(pa, e.setTextRange(p.createBinaryExpression(xe(pa), e.getNonAssignmentOperatorForCompoundAssignment(dn), e.visitNode(St, g, e.isExpression)), Pr)), Pr) : p.updateBinaryExpression(Pr, pa, Pr.operatorToken, e.visitNode(St, g, e.isExpression));
                }
                return e.visitEachChild(Pr, g, N);
              }
              function rr(Pr) {
                return Ze(Pr.right) ? e.isLogicalOperator(Pr.operatorToken.kind) ? we(Pr) : Pr.operatorToken.kind === 27 ? Ie(Pr) : p.updateBinaryExpression(Pr, xe(e.visitNode(Pr.left, g, e.isExpression)), Pr.operatorToken, e.visitNode(Pr.right, g, e.isExpression)) : e.visitEachChild(Pr, g, N);
              }
              function Ie(Pr) {
                var xi = [];
                return St(Pr.left), St(Pr.right), p.inlineExpressions(xi);
                function St(pa) {
                  e.isBinaryExpression(pa) && pa.operatorToken.kind === 27 ? (St(pa.left), St(pa.right)) : (Ze(pa) && xi.length > 0 && (Ba(1, [p.createExpressionStatement(p.inlineExpressions(xi))]), xi = []), xi.push(e.visitNode(pa, g, e.isExpression)));
                }
              }
              function _e(Pr) {
                for (var xi = [], St = 0, pa = Pr.elements; St < pa.length; St++) {
                  var dn = pa[St];
                  e.isBinaryExpression(dn) && dn.operatorToken.kind === 27 ? xi.push(Ie(dn)) : (Ze(dn) && xi.length > 0 && (Ba(1, [p.createExpressionStatement(p.inlineExpressions(xi))]), xi = []), xi.push(e.visitNode(dn, g, e.isExpression)));
                }
                return p.inlineExpressions(xi);
              }
              function we(Pr) {
                var xi = mr(), St = vr();
                return Vi(St, e.visitNode(Pr.left, g, e.isExpression), Pr.left), Pr.operatorToken.kind === 55 ? ba(xi, St, Pr.left) : At(xi, St, Pr.left), Vi(St, e.visitNode(Pr.right, g, e.isExpression), Pr.right), Ar(xi), St;
              }
              function de(Pr) {
                if (Ze(Pr.whenTrue) || Ze(Pr.whenFalse)) {
                  var xi = mr(), St = mr(), pa = vr();
                  return ba(xi, e.visitNode(Pr.condition, g, e.isExpression), Pr.condition), Vi(pa, e.visitNode(Pr.whenTrue, g, e.isExpression), Pr.whenTrue), at(St), Ar(xi), Vi(pa, e.visitNode(Pr.whenFalse, g, e.isExpression), Pr.whenFalse), Ar(St), pa;
                }
                return e.visitEachChild(Pr, g, N);
              }
              function ye(Pr) {
                var xi = mr(), St = e.visitNode(Pr.expression, g, e.isExpression);
                if (Pr.asteriskToken) {
                  var pa = (e.getEmitFlags(Pr.expression) & 8388608) === 0 ? e.setTextRange(m().createValuesHelper(St), Pr) : St;
                  $a(pa, Pr);
                } else Qa(St, Pr);
                return Ar(xi), Ai(Pr);
              }
              function Ae(Pr) {
                return er(Pr.elements, void 0, void 0, Pr.multiLine);
              }
              function er(Pr, xi, St, pa) {
                var dn = Sr(Pr), Jn;
                if (dn > 0) {
                  Jn = vr();
                  var Qe = e.visitNodes(Pr, g, e.isExpression, 0, dn);
                  Vi(Jn, p.createArrayLiteralExpression(xi ? Ve([xi], Qe, true) : Qe)), xi = void 0;
                }
                var Gr = e.reduceLeft(Pr, S, [], dn);
                return Jn ? p.createArrayConcatCall(Jn, [p.createArrayLiteralExpression(Gr, pa)]) : e.setTextRange(p.createArrayLiteralExpression(xi ? Ve([xi], Gr, true) : Gr, pa), St);
                function S(Ce, qe) {
                  if (Ze(qe) && Ce.length > 0) {
                    var br = Jn !== void 0;
                    Jn || (Jn = vr()), Vi(Jn, br ? p.createArrayConcatCall(Jn, [p.createArrayLiteralExpression(Ce, pa)]) : p.createArrayLiteralExpression(xi ? Ve([xi], Ce, true) : Ce, pa)), xi = void 0, Ce = [];
                  }
                  return Ce.push(e.visitNode(qe, g, e.isExpression)), Ce;
                }
              }
              function ir(Pr) {
                var xi = Pr.properties, St = Pr.multiLine, pa = Sr(xi), dn = vr();
                Vi(dn, p.createObjectLiteralExpression(e.visitNodes(xi, g, e.isObjectLiteralElementLike, 0, pa), St));
                var Jn = e.reduceLeft(xi, Qe, [], pa);
                return Jn.push(St ? e.startOnNewLine(e.setParent(e.setTextRange(p.cloneNode(dn), dn), dn.parent)) : dn), p.inlineExpressions(Jn);
                function Qe(Gr, S) {
                  Ze(S) && Gr.length > 0 && (ji(p.createExpressionStatement(p.inlineExpressions(Gr))), Gr = []);
                  var Ce = e.createExpressionForObjectLiteralElementLike(p, Pr, S, dn), qe = e.visitNode(Ce, g, e.isExpression);
                  return qe && (St && e.startOnNewLine(qe), Gr.push(qe)), Gr;
                }
              }
              function Cr(Pr) {
                return Ze(Pr.argumentExpression) ? p.updateElementAccessExpression(Pr, xe(e.visitNode(Pr.expression, g, e.isLeftHandSideExpression)), e.visitNode(Pr.argumentExpression, g, e.isExpression)) : e.visitEachChild(Pr, g, N);
              }
              function Ye(Pr) {
                if (!e.isImportCall(Pr) && e.forEach(Pr.arguments, Ze)) {
                  var xi = p.createCallBinding(Pr.expression, T, b, true), St = xi.target, pa = xi.thisArg;
                  return e.setOriginalNode(e.setTextRange(p.createFunctionApplyCall(xe(e.visitNode(St, g, e.isLeftHandSideExpression)), pa, er(Pr.arguments)), Pr), Pr);
                }
                return e.visitEachChild(Pr, g, N);
              }
              function Br(Pr) {
                if (e.forEach(Pr.arguments, Ze)) {
                  var xi = p.createCallBinding(p.createPropertyAccessExpression(Pr.expression, "bind"), T), St = xi.target, pa = xi.thisArg;
                  return e.setOriginalNode(e.setTextRange(p.createNewExpression(p.createFunctionApplyCall(xe(e.visitNode(St, g, e.isExpression)), pa, er(Pr.arguments, p.createVoidZero())), void 0, []), Pr), Pr);
                }
                return e.visitEachChild(Pr, g, N);
              }
              function Er(Pr, xi) {
                xi === void 0 && (xi = 0);
                for (var St = Pr.length, pa = xi; pa < St; pa++) n(Pr[pa]);
              }
              function Ne(Pr) {
                e.isBlock(Pr) ? Er(Pr.statements) : n(Pr);
              }
              function n(Pr) {
                var xi = O;
                O || (O = Ze(Pr)), lr(Pr), O = xi;
              }
              function lr(Pr) {
                switch (Pr.kind) {
                  case 235:
                    return be(Pr);
                  case 238:
                    return Ge(Pr);
                  case 239:
                    return Ir(Pr);
                  case 240:
                    return wr(Pr);
                  case 241:
                    return ii(Pr);
                  case 242:
                    return pe(Pr);
                  case 243:
                    return qr(Pr);
                  case 245:
                    return Di(Pr);
                  case 246:
                    return Xi(Pr);
                  case 247:
                    return Gi(Pr);
                  case 248:
                    return Zt(Pr);
                  case 249:
                    return _r(Pr);
                  case 250:
                    return ae(Pr);
                  case 251:
                    return Jr(Pr);
                  case 252:
                    return ti(Pr);
                  default:
                    return ji(e.visitNode(Pr, g, e.isStatement));
                }
              }
              function be(Pr) {
                Ze(Pr) ? Er(Pr.statements) : ji(e.visitNode(Pr, g, e.isStatement));
              }
              function Ge(Pr) {
                ji(e.visitNode(Pr, g, e.isStatement));
              }
              function ur(Pr) {
                for (var xi = 0, St = Pr.declarations; xi < St.length; xi++) {
                  var pa = St[xi], dn = p.cloneNode(pa.name);
                  e.setCommentRange(dn, pa.name), T(dn);
                }
                for (var Jn = e.getInitializedVariables(Pr), Qe = Jn.length, Gr = 0, S = []; Gr < Qe; ) {
                  for (var Ce = Gr; Ce < Qe; Ce++) {
                    var pa = Jn[Ce];
                    if (Ze(pa.initializer) && S.length > 0) break;
                    S.push(yr(pa));
                  }
                  S.length && (ji(p.createExpressionStatement(p.inlineExpressions(S))), Gr += S.length, S = []);
                }
              }
              function yr(Pr) {
                return e.setSourceMapRange(p.createAssignment(e.setSourceMapRange(p.cloneNode(Pr.name), Pr.name), e.visitNode(Pr.initializer, g, e.isExpression)), Pr);
              }
              function Ir(Pr) {
                if (Ze(Pr)) if (Ze(Pr.thenStatement) || Ze(Pr.elseStatement)) {
                  var xi = mr(), St = Pr.elseStatement ? mr() : void 0;
                  ba(Pr.elseStatement ? St : xi, e.visitNode(Pr.expression, g, e.isExpression), Pr.expression), Ne(Pr.thenStatement), Pr.elseStatement && (at(xi), Ar(St), Ne(Pr.elseStatement)), Ar(xi);
                } else ji(e.visitNode(Pr, g, e.isStatement));
                else ji(e.visitNode(Pr, g, e.isStatement));
              }
              function wr(Pr) {
                if (Ze(Pr)) {
                  var xi = mr(), St = mr();
                  Ui(xi), Ar(St), Ne(Pr.statement), Ar(xi), At(St, e.visitNode(Pr.expression, g, e.isExpression)), Yi();
                } else ji(e.visitNode(Pr, g, e.isStatement));
              }
              function Ur(Pr) {
                return O ? (vi(), Pr = e.visitEachChild(Pr, g, N), Yi(), Pr) : e.visitEachChild(Pr, g, N);
              }
              function ii(Pr) {
                if (Ze(Pr)) {
                  var xi = mr(), St = Ui(xi);
                  Ar(xi), ba(St, e.visitNode(Pr.expression, g, e.isExpression)), Ne(Pr.statement), at(xi), Yi();
                } else ji(e.visitNode(Pr, g, e.isStatement));
              }
              function mi(Pr) {
                return O ? (vi(), Pr = e.visitEachChild(Pr, g, N), Yi(), Pr) : e.visitEachChild(Pr, g, N);
              }
              function pe(Pr) {
                if (Ze(Pr)) {
                  var xi = mr(), St = mr(), pa = Ui(St);
                  if (Pr.initializer) {
                    var dn = Pr.initializer;
                    e.isVariableDeclarationList(dn) ? ur(dn) : ji(e.setTextRange(p.createExpressionStatement(e.visitNode(dn, g, e.isExpression)), dn));
                  }
                  Ar(xi), Pr.condition && ba(pa, e.visitNode(Pr.condition, g, e.isExpression)), Ne(Pr.statement), Ar(St), Pr.incrementor && ji(e.setTextRange(p.createExpressionStatement(e.visitNode(Pr.incrementor, g, e.isExpression)), Pr.incrementor)), at(xi), Yi();
                } else ji(e.visitNode(Pr, g, e.isStatement));
              }
              function or(Pr) {
                O && vi();
                var xi = Pr.initializer;
                if (xi && e.isVariableDeclarationList(xi)) {
                  for (var St = 0, pa = xi.declarations; St < pa.length; St++) {
                    var dn = pa[St];
                    T(dn.name);
                  }
                  var Jn = e.getInitializedVariables(xi);
                  Pr = p.updateForStatement(Pr, Jn.length > 0 ? p.inlineExpressions(e.map(Jn, yr)) : void 0, e.visitNode(Pr.condition, g, e.isExpression), e.visitNode(Pr.incrementor, g, e.isExpression), e.visitIterationBody(Pr.statement, g, N));
                } else Pr = e.visitEachChild(Pr, g, N);
                return O && Yi(), Pr;
              }
              function qr(Pr) {
                if (Ze(Pr)) {
                  var xi = vr(), St = vr(), pa = p.createLoopVariable(), dn = Pr.initializer;
                  T(pa), Vi(xi, p.createArrayLiteralExpression()), ji(p.createForInStatement(St, e.visitNode(Pr.expression, g, e.isExpression), p.createExpressionStatement(p.createCallExpression(p.createPropertyAccessExpression(xi, "push"), void 0, [St])))), Vi(pa, p.createNumericLiteral(0));
                  var Jn = mr(), Qe = mr(), Gr = Ui(Qe);
                  Ar(Jn), ba(Gr, p.createLessThan(pa, p.createPropertyAccessExpression(xi, "length")));
                  var S = void 0;
                  if (e.isVariableDeclarationList(dn)) {
                    for (var Ce = 0, qe = dn.declarations; Ce < qe.length; Ce++) {
                      var br = qe[Ce];
                      T(br.name);
                    }
                    S = p.cloneNode(dn.declarations[0].name);
                  } else S = e.visitNode(dn, g, e.isExpression), e.Debug.assert(e.isLeftHandSideExpression(S));
                  Vi(S, p.createElementAccessExpression(xi, pa)), Ne(Pr.statement), Ar(Qe), ji(p.createExpressionStatement(p.createPostfixIncrement(pa))), at(Jn), Yi();
                } else ji(e.visitNode(Pr, g, e.isStatement));
              }
              function si(Pr) {
                O && vi();
                var xi = Pr.initializer;
                if (e.isVariableDeclarationList(xi)) {
                  for (var St = 0, pa = xi.declarations; St < pa.length; St++) {
                    var dn = pa[St];
                    T(dn.name);
                  }
                  Pr = p.updateForInStatement(Pr, xi.declarations[0].name, e.visitNode(Pr.expression, g, e.isExpression), e.visitNode(Pr.statement, g, e.isStatement, p.liftToBlock));
                } else Pr = e.visitEachChild(Pr, g, N);
                return O && Yi(), Pr;
              }
              function Di(Pr) {
                var xi = Fi(Pr.label ? e.idText(Pr.label) : void 0);
                xi > 0 ? at(xi, Pr) : ji(Pr);
              }
              function wi(Pr) {
                if (O) {
                  var xi = Fi(Pr.label && e.idText(Pr.label));
                  if (xi > 0) return wt(xi, Pr);
                }
                return e.visitEachChild(Pr, g, N);
              }
              function Xi(Pr) {
                var xi = Ki(Pr.label ? e.idText(Pr.label) : void 0);
                xi > 0 ? at(xi, Pr) : ji(Pr);
              }
              function et(Pr) {
                if (O) {
                  var xi = Ki(Pr.label && e.idText(Pr.label));
                  if (xi > 0) return wt(xi, Pr);
                }
                return e.visitEachChild(Pr, g, N);
              }
              function Gi(Pr) {
                ai(e.visitNode(Pr.expression, g, e.isExpression), Pr);
              }
              function Wt(Pr) {
                return na(e.visitNode(Pr.expression, g, e.isExpression), Pr);
              }
              function Zt(Pr) {
                Ze(Pr) ? (Ue(xe(e.visitNode(Pr.expression, g, e.isExpression))), Ne(Pr.statement), fr()) : ji(e.visitNode(Pr, g, e.isStatement));
              }
              function _r(Pr) {
                if (Ze(Pr.caseBlock)) {
                  for (var xi = Pr.caseBlock, St = xi.clauses.length, pa = ct(), dn = xe(e.visitNode(Pr.expression, g, e.isExpression)), Jn = [], Qe = -1, Gr = 0; Gr < St; Gr++) {
                    var S = xi.clauses[Gr];
                    Jn.push(mr()), S.kind === 290 && Qe === -1 && (Qe = Gr);
                  }
                  for (var Ce = 0, qe = []; Ce < St; ) {
                    for (var br = 0, Gr = Ce; Gr < St; Gr++) {
                      var S = xi.clauses[Gr];
                      if (S.kind === 289) {
                        if (Ze(S.expression) && qe.length > 0) break;
                        qe.push(p.createCaseClause(e.visitNode(S.expression, g, e.isExpression), [wt(Jn[Gr], S.expression)]));
                      } else br++;
                    }
                    qe.length && (ji(p.createSwitchStatement(dn, p.createCaseBlock(qe))), Ce += qe.length, qe = []), br > 0 && (Ce += br, br = 0);
                  }
                  Qe >= 0 ? at(Jn[Qe]) : at(pa);
                  for (var Gr = 0; Gr < St; Gr++) Ar(Jn[Gr]), Er(xi.clauses[Gr].statements);
                  Li();
                } else ji(e.visitNode(Pr, g, e.isStatement));
              }
              function pi(Pr) {
                return O && Wi(), Pr = e.visitEachChild(Pr, g, N), O && Li(), Pr;
              }
              function ae(Pr) {
                Ze(Pr) ? (Mt(e.idText(Pr.label)), Ne(Pr.statement), xt()) : ji(e.visitNode(Pr, g, e.isStatement));
              }
              function Xe(Pr) {
                return O && nt(e.idText(Pr.label)), Pr = e.visitEachChild(Pr, g, N), O && xt(), Pr;
              }
              function Jr(Pr) {
                var xi;
                Dn(e.visitNode((xi = Pr.expression) !== null && xi !== void 0 ? xi : p.createVoidZero(), g, e.isExpression), Pr);
              }
              function ti(Pr) {
                Ze(Pr) ? (De(), Ne(Pr.tryBlock), Pr.catchClause && (gr(Pr.catchClause.variableDeclaration), Ne(Pr.catchClause.block)), Pr.finallyBlock && (Vr(), Ne(Pr.finallyBlock)), Tr()) : ji(e.visitEachChild(Pr, g, N));
              }
              function Ze(Pr) {
                return !!Pr && (Pr.transformFlags & 524288) !== 0;
              }
              function Sr(Pr) {
                for (var xi = Pr.length, St = 0; St < xi; St++) if (Ze(Pr[St])) return St;
                return -1;
              }
              function zr(Pr, xi) {
                return xi = J(Pr, xi), Pr === 1 ? Wr(xi) : xi;
              }
              function Wr(Pr) {
                return e.isIdentifier(Pr) ? Je(Pr) : Pr;
              }
              function Je(Pr) {
                if (!e.isGeneratedIdentifier(Pr) && ie && ie.has(e.idText(Pr))) {
                  var xi = e.getOriginalNode(Pr);
                  if (e.isIdentifier(xi) && xi.parent) {
                    var St = se.getReferencedValueDeclaration(xi);
                    if (St) {
                      var pa = R[e.getOriginalNodeId(St)];
                      if (pa) {
                        var dn = e.setParent(e.setTextRange(p.cloneNode(pa), pa), pa.parent);
                        return e.setSourceMapRange(dn, Pr), e.setCommentRange(dn, Pr), dn;
                      }
                    }
                  }
                }
                return Pr;
              }
              function xe(Pr) {
                if (e.isGeneratedIdentifier(Pr) || e.getEmitFlags(Pr) & 4096) return Pr;
                var xi = p.createTempVariable(T);
                return Vi(xi, Pr, Pr), xi;
              }
              function vr(Pr) {
                var xi = Pr ? p.createUniqueName(Pr) : p.createTempVariable(void 0);
                return T(xi), xi;
              }
              function mr() {
                x || (x = []);
                var Pr = $;
                return $++, x[Pr] = -1, Pr;
              }
              function Ar(Pr) {
                e.Debug.assert(x !== void 0, "No labels were defined."), x[Pr] = A ? A.length : 0;
              }
              function Oe(Pr) {
                ve || (ve = [], he = [], ee = [], F = []);
                var xi = he.length;
                return he[xi] = 0, ee[xi] = A ? A.length : 0, ve[xi] = Pr, F.push(Pr), xi;
              }
              function nr() {
                var Pr = Mr();
                if (Pr === void 0) return e.Debug.fail("beginBlock was never called.");
                var xi = he.length;
                return he[xi] = 1, ee[xi] = A ? A.length : 0, ve[xi] = Pr, F.pop(), Pr;
              }
              function Mr() {
                return e.lastOrUndefined(F);
              }
              function Pe() {
                var Pr = Mr();
                return Pr && Pr.kind;
              }
              function Ue(Pr) {
                var xi = mr(), St = mr();
                Ar(xi), Oe({ kind: 1, expression: Pr, startLabel: xi, endLabel: St });
              }
              function fr() {
                e.Debug.assert(Pe() === 1);
                var Pr = nr();
                Ar(Pr.endLabel);
              }
              function De() {
                var Pr = mr(), xi = mr();
                return Ar(Pr), Oe({ kind: 0, state: 0, startLabel: Pr, endLabel: xi }), Oi(), xi;
              }
              function gr(Pr) {
                e.Debug.assert(Pe() === 0);
                var xi;
                if (e.isGeneratedIdentifier(Pr.name)) xi = Pr.name, T(Pr.name);
                else {
                  var St = e.idText(Pr.name);
                  xi = vr(St), ie || (ie = new e.Map(), R = [], N.enableSubstitution(79)), ie.set(St, true), R[e.getOriginalNodeId(Pr)] = xi;
                }
                var pa = Mr();
                e.Debug.assert(pa.state < 1);
                var dn = pa.endLabel;
                at(dn);
                var Jn = mr();
                Ar(Jn), pa.state = 1, pa.catchVariable = xi, pa.catchLabel = Jn, Vi(xi, p.createCallExpression(p.createPropertyAccessExpression(L, "sent"), void 0, [])), Oi();
              }
              function Vr() {
                e.Debug.assert(Pe() === 0);
                var Pr = Mr();
                e.Debug.assert(Pr.state < 2);
                var xi = Pr.endLabel;
                at(xi);
                var St = mr();
                Ar(St), Pr.state = 2, Pr.finallyLabel = St;
              }
              function Tr() {
                e.Debug.assert(Pe() === 0);
                var Pr = nr(), xi = Pr.state;
                xi < 2 ? at(Pr.endLabel) : ka(), Ar(Pr.endLabel), Oi(), Pr.state = 3;
              }
              function vi() {
                Oe({ kind: 3, isScript: true, breakLabel: -1, continueLabel: -1 });
              }
              function Ui(Pr) {
                var xi = mr();
                return Oe({ kind: 3, isScript: false, breakLabel: xi, continueLabel: Pr }), xi;
              }
              function Yi() {
                e.Debug.assert(Pe() === 3);
                var Pr = nr(), xi = Pr.breakLabel;
                Pr.isScript || Ar(xi);
              }
              function Wi() {
                Oe({ kind: 2, isScript: true, breakLabel: -1 });
              }
              function ct() {
                var Pr = mr();
                return Oe({ kind: 2, isScript: false, breakLabel: Pr }), Pr;
              }
              function Li() {
                e.Debug.assert(Pe() === 2);
                var Pr = nr(), xi = Pr.breakLabel;
                Pr.isScript || Ar(xi);
              }
              function nt(Pr) {
                Oe({ kind: 4, isScript: true, labelText: Pr, breakLabel: -1 });
              }
              function Mt(Pr) {
                var xi = mr();
                Oe({ kind: 4, isScript: false, labelText: Pr, breakLabel: xi });
              }
              function xt() {
                e.Debug.assert(Pe() === 4);
                var Pr = nr();
                Pr.isScript || Ar(Pr.breakLabel);
              }
              function ut(Pr) {
                return Pr.kind === 2 || Pr.kind === 3;
              }
              function Dt(Pr) {
                return Pr.kind === 4;
              }
              function Rt(Pr) {
                return Pr.kind === 3;
              }
              function Ii(Pr, xi) {
                for (var St = xi; St >= 0; St--) {
                  var pa = F[St];
                  if (Dt(pa)) {
                    if (pa.labelText === Pr) return true;
                  } else break;
                }
                return false;
              }
              function Ki(Pr) {
                if (F) if (Pr) for (var xi = F.length - 1; xi >= 0; xi--) {
                  var St = F[xi];
                  if (Dt(St) && St.labelText === Pr) return St.breakLabel;
                  if (ut(St) && Ii(Pr, xi - 1)) return St.breakLabel;
                }
                else for (var xi = F.length - 1; xi >= 0; xi--) {
                  var St = F[xi];
                  if (ut(St)) return St.breakLabel;
                }
                return 0;
              }
              function Fi(Pr) {
                if (F) if (Pr) for (var xi = F.length - 1; xi >= 0; xi--) {
                  var St = F[xi];
                  if (Rt(St) && Ii(Pr, xi - 1)) return St.continueLabel;
                }
                else for (var xi = F.length - 1; xi >= 0; xi--) {
                  var St = F[xi];
                  if (Rt(St)) return St.continueLabel;
                }
                return 0;
              }
              function ui(Pr) {
                if (Pr !== void 0 && Pr > 0) {
                  X === void 0 && (X = []);
                  var xi = p.createNumericLiteral(-1);
                  return X[Pr] === void 0 ? X[Pr] = [xi] : X[Pr].push(xi), xi;
                }
                return p.createOmittedExpression();
              }
              function Bt(Pr) {
                var xi = p.createNumericLiteral(Pr);
                return e.addSyntheticTrailingComment(xi, 3, Q(Pr)), xi;
              }
              function wt(Pr, xi) {
                return e.Debug.assertLessThan(0, Pr, "Invalid label"), e.setTextRange(p.createReturnStatement(p.createArrayLiteralExpression([Bt(3), ui(Pr)])), xi);
              }
              function na(Pr, xi) {
                return e.setTextRange(p.createReturnStatement(p.createArrayLiteralExpression(Pr ? [Bt(2), Pr] : [Bt(2)])), xi);
              }
              function Ai(Pr) {
                return e.setTextRange(p.createCallExpression(p.createPropertyAccessExpression(L, "sent"), void 0, []), Pr);
              }
              function Oi() {
                Ba(0);
              }
              function ji(Pr) {
                Pr ? Ba(1, [Pr]) : Oi();
              }
              function Vi(Pr, xi, St) {
                Ba(2, [Pr, xi], St);
              }
              function at(Pr, xi) {
                Ba(3, [Pr], xi);
              }
              function At(Pr, xi, St) {
                Ba(4, [Pr, xi], St);
              }
              function ba(Pr, xi, St) {
                Ba(5, [Pr, xi], St);
              }
              function $a(Pr, xi) {
                Ba(7, [Pr], xi);
              }
              function Qa(Pr, xi) {
                Ba(6, [Pr], xi);
              }
              function ai(Pr, xi) {
                Ba(8, [Pr], xi);
              }
              function Dn(Pr, xi) {
                Ba(9, [Pr], xi);
              }
              function ka() {
                Ba(10);
              }
              function Ba(Pr, xi, St) {
                A === void 0 && (A = [], y = [], V = []), x === void 0 && Ar(mr());
                var pa = A.length;
                A[pa] = Pr, y[pa] = xi, V[pa] = St;
              }
              function pn() {
                P = 0, k = 0, Y = void 0, U = false, j = false, H = void 0, I = void 0, l = void 0, d = void 0, D = void 0;
                var Pr = Cn();
                return m().createGeneratorHelper(e.setEmitFlags(p.createFunctionExpression(void 0, void 0, void 0, void 0, [p.createParameterDeclaration(void 0, void 0, void 0, L)], void 0, p.createBlock(Pr, Pr.length > 0)), 524288));
              }
              function Cn() {
                if (A) {
                  for (var Pr = 0; Pr < A.length; Pr++) Da(Pr);
                  kn(A.length);
                } else kn(0);
                if (H) {
                  var xi = p.createPropertyAccessExpression(L, "label"), St = p.createSwitchStatement(xi, p.createCaseBlock(H));
                  return [e.startOnNewLine(St)];
                }
                return I || [];
              }
              function Bi() {
                !I || (Kn(!U), U = false, j = false, k++);
              }
              function kn(Pr) {
                xn(Pr) && (Pn(Pr), D = void 0, Wn(void 0, void 0)), I && H && Kn(false), eo();
              }
              function xn(Pr) {
                if (!j) return true;
                if (!x || !X) return false;
                for (var xi = 0; xi < x.length; xi++) if (x[xi] === Pr && X[xi]) return true;
                return false;
              }
              function Kn(Pr) {
                if (H || (H = []), I) {
                  if (D) for (var xi = D.length - 1; xi >= 0; xi--) {
                    var St = D[xi];
                    I = [p.createWithStatement(St.expression, p.createBlock(I))];
                  }
                  if (d) {
                    var pa = d.startLabel, dn = d.catchLabel, Jn = d.finallyLabel, Qe = d.endLabel;
                    I.unshift(p.createExpressionStatement(p.createCallExpression(p.createPropertyAccessExpression(p.createPropertyAccessExpression(L, "trys"), "push"), void 0, [p.createArrayLiteralExpression([ui(pa), ui(dn), ui(Jn), ui(Qe)])]))), d = void 0;
                  }
                  Pr && I.push(p.createExpressionStatement(p.createAssignment(p.createPropertyAccessExpression(L, "label"), p.createNumericLiteral(k + 1))));
                }
                H.push(p.createCaseClause(p.createNumericLiteral(k), I || [])), I = void 0;
              }
              function Pn(Pr) {
                if (!!x) for (var xi = 0; xi < x.length; xi++) x[xi] === Pr && (Bi(), Y === void 0 && (Y = []), Y[k] === void 0 ? Y[k] = [xi] : Y[k].push(xi));
              }
              function eo() {
                if (X !== void 0 && Y !== void 0) for (var Pr = 0; Pr < Y.length; Pr++) {
                  var xi = Y[Pr];
                  if (xi !== void 0) for (var St = 0, pa = xi; St < pa.length; St++) {
                    var dn = pa[St], Jn = X[dn];
                    if (Jn !== void 0) for (var Qe = 0, Gr = Jn; Qe < Gr.length; Qe++) {
                      var S = Gr[Qe];
                      S.text = String(Pr);
                    }
                  }
                }
              }
              function Rn(Pr) {
                if (ve) for (; P < he.length && ee[P] <= Pr; P++) {
                  var xi = ve[P], St = he[P];
                  switch (xi.kind) {
                    case 0:
                      St === 0 ? (l || (l = []), I || (I = []), l.push(d), d = xi) : St === 1 && (d = l.pop());
                      break;
                    case 1:
                      St === 0 ? (D || (D = []), D.push(xi)) : St === 1 && D.pop();
                      break;
                  }
                }
              }
              function Da(Pr) {
                if (Pn(Pr), Rn(Pr), !U) {
                  U = false, j = false;
                  var xi = A[Pr];
                  if (xi !== 0) {
                    if (xi === 10) return $o();
                    var St = y[Pr];
                    if (xi === 1) return bo(St[0]);
                    var pa = V[Pr];
                    switch (xi) {
                      case 2:
                        return Ro(St[0], St[1], pa);
                      case 3:
                        return to(St[0], pa);
                      case 4:
                        return Co(St[0], St[1], pa);
                      case 5:
                        return Ko(St[0], St[1], pa);
                      case 6:
                        return Oo(St[0], pa);
                      case 7:
                        return no(St[0], pa);
                      case 8:
                        return Wn(St[0], pa);
                      case 9:
                        return En(St[0], pa);
                    }
                  }
                }
              }
              function bo(Pr) {
                Pr && (I ? I.push(Pr) : I = [Pr]);
              }
              function Ro(Pr, xi, St) {
                bo(e.setTextRange(p.createExpressionStatement(p.createAssignment(Pr, xi)), St));
              }
              function En(Pr, xi) {
                U = true, j = true, bo(e.setTextRange(p.createThrowStatement(Pr), xi));
              }
              function Wn(Pr, xi) {
                U = true, j = true, bo(e.setEmitFlags(e.setTextRange(p.createReturnStatement(p.createArrayLiteralExpression(Pr ? [Bt(2), Pr] : [Bt(2)])), xi), 384));
              }
              function to(Pr, xi) {
                U = true, bo(e.setEmitFlags(e.setTextRange(p.createReturnStatement(p.createArrayLiteralExpression([Bt(3), ui(Pr)])), xi), 384));
              }
              function Co(Pr, xi, St) {
                bo(e.setEmitFlags(p.createIfStatement(xi, e.setEmitFlags(e.setTextRange(p.createReturnStatement(p.createArrayLiteralExpression([Bt(3), ui(Pr)])), St), 384)), 1));
              }
              function Ko(Pr, xi, St) {
                bo(e.setEmitFlags(p.createIfStatement(p.createLogicalNot(xi), e.setEmitFlags(e.setTextRange(p.createReturnStatement(p.createArrayLiteralExpression([Bt(3), ui(Pr)])), St), 384)), 1));
              }
              function Oo(Pr, xi) {
                U = true, bo(e.setEmitFlags(e.setTextRange(p.createReturnStatement(p.createArrayLiteralExpression(Pr ? [Bt(4), Pr] : [Bt(4)])), xi), 384));
              }
              function no(Pr, xi) {
                U = true, bo(e.setEmitFlags(e.setTextRange(p.createReturnStatement(p.createArrayLiteralExpression([Bt(5), Pr])), xi), 384));
              }
              function $o() {
                U = true, bo(p.createReturnStatement(p.createArrayLiteralExpression([Bt(7)])));
              }
            }
            e.transformGenerators = le;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(w) {
              function B(pe) {
                switch (pe) {
                  case e.ModuleKind.AMD:
                    return F;
                  case e.ModuleKind.UMD:
                    return x;
                  default:
                    return he;
                }
              }
              var E = w.factory, Q = w.getEmitHelperFactory, le = w.startLexicalEnvironment, N = w.endLexicalEnvironment, p = w.hoistVariableDeclaration, m = w.getCompilerOptions(), G = w.getEmitResolver(), oe = w.getEmitHost(), f = e.getEmitScriptTarget(m), T = e.getEmitModuleKind(m), K = w.onSubstituteNode, b = w.onEmitNode;
              w.onSubstituteNode = Ge, w.onEmitNode = be, w.enableSubstitution(208), w.enableSubstitution(210), w.enableSubstitution(79), w.enableSubstitution(221), w.enableSubstitution(297), w.enableEmitNotification(305);
              var se = [], J = [], ie, R, q = [], O;
              return e.chainBundle(w, ve);
              function ve(pe) {
                if (pe.isDeclarationFile || !(e.isEffectiveExternalModule(pe, m) || pe.transformFlags & 4194304 || e.isJsonSourceFile(pe) && e.hasJsonModuleEmitEnabled(m) && e.outFile(m))) return pe;
                ie = pe, R = e.collectExternalModuleInfo(w, pe, G, m), se[e.getOriginalNodeId(pe)] = R;
                var or = B(T), qr = or(pe);
                return ie = void 0, R = void 0, O = false, qr;
              }
              function ee() {
                return !!(!R.exportEquals && e.isExternalModule(ie));
              }
              function he(pe) {
                le();
                var or = [], qr = e.getStrictOptionValue(m, "alwaysStrict") || !m.noImplicitUseStrict && e.isExternalModule(ie), si = E.copyPrologue(pe.statements, or, qr && !e.isJsonSourceFile(pe), V);
                if (ee() && e.append(or, Er()), e.length(R.exportedNames)) for (var Di = 50, wi = 0; wi < R.exportedNames.length; wi += Di) e.append(or, E.createExpressionStatement(e.reduceLeft(R.exportedNames.slice(wi, wi + Di), function(et, Gi) {
                  return E.createAssignment(E.createPropertyAccessExpression(E.createIdentifier("exports"), E.createIdentifier(e.idText(Gi))), et);
                }, E.createVoidZero())));
                e.append(or, e.visitNode(R.externalHelpersImportDeclaration, V, e.isStatement)), e.addRange(or, e.visitNodes(pe.statements, V, e.isStatement, si)), y(or, false), e.insertStatementsAfterStandardPrologue(or, N());
                var Xi = E.updateSourceFile(pe, e.setTextRange(E.createNodeArray(or), pe.statements));
                return e.addEmitHelpers(Xi, w.readEmitHelpers()), Xi;
              }
              function F(pe) {
                var or = E.createIdentifier("define"), qr = e.tryGetModuleNameFromFile(E, pe, oe, m), si = e.isJsonSourceFile(pe) && pe, Di = X(pe, true), wi = Di.aliasedModuleNames, Xi = Di.unaliasedModuleNames, et = Di.importAliasNames, Gi = E.updateSourceFile(pe, e.setTextRange(E.createNodeArray([E.createExpressionStatement(E.createCallExpression(or, void 0, Ve(Ve([], qr ? [qr] : [], true), [E.createArrayLiteralExpression(si ? e.emptyArray : Ve(Ve([E.createStringLiteral("require"), E.createStringLiteral("exports")], wi, true), Xi, true)), si ? si.statements.length ? si.statements[0].expression : E.createObjectLiteralExpression() : E.createFunctionExpression(void 0, void 0, void 0, void 0, Ve([E.createParameterDeclaration(void 0, void 0, void 0, "require"), E.createParameterDeclaration(void 0, void 0, void 0, "exports")], et, true), void 0, A(pe))], false)))]), pe.statements));
                return e.addEmitHelpers(Gi, w.readEmitHelpers()), Gi;
              }
              function x(pe) {
                var or = X(pe, false), qr = or.aliasedModuleNames, si = or.unaliasedModuleNames, Di = or.importAliasNames, wi = e.tryGetModuleNameFromFile(E, pe, oe, m), Xi = E.createFunctionExpression(void 0, void 0, void 0, void 0, [E.createParameterDeclaration(void 0, void 0, void 0, "factory")], void 0, e.setTextRange(E.createBlock([E.createIfStatement(E.createLogicalAnd(E.createTypeCheck(E.createIdentifier("module"), "object"), E.createTypeCheck(E.createPropertyAccessExpression(E.createIdentifier("module"), "exports"), "object")), E.createBlock([E.createVariableStatement(void 0, [E.createVariableDeclaration("v", void 0, void 0, E.createCallExpression(E.createIdentifier("factory"), void 0, [E.createIdentifier("require"), E.createIdentifier("exports")]))]), e.setEmitFlags(E.createIfStatement(E.createStrictInequality(E.createIdentifier("v"), E.createIdentifier("undefined")), E.createExpressionStatement(E.createAssignment(E.createPropertyAccessExpression(E.createIdentifier("module"), "exports"), E.createIdentifier("v")))), 1)]), E.createIfStatement(E.createLogicalAnd(E.createTypeCheck(E.createIdentifier("define"), "function"), E.createPropertyAccessExpression(E.createIdentifier("define"), "amd")), E.createBlock([E.createExpressionStatement(E.createCallExpression(E.createIdentifier("define"), void 0, Ve(Ve([], wi ? [wi] : [], true), [E.createArrayLiteralExpression(Ve(Ve([E.createStringLiteral("require"), E.createStringLiteral("exports")], qr, true), si, true)), E.createIdentifier("factory")], false)))])))], true), void 0)), et = E.updateSourceFile(pe, e.setTextRange(E.createNodeArray([E.createExpressionStatement(E.createCallExpression(Xi, void 0, [E.createFunctionExpression(void 0, void 0, void 0, void 0, Ve([E.createParameterDeclaration(void 0, void 0, void 0, "require"), E.createParameterDeclaration(void 0, void 0, void 0, "exports")], Di, true), void 0, A(pe))]))]), pe.statements));
                return e.addEmitHelpers(et, w.readEmitHelpers()), et;
              }
              function X(pe, or) {
                for (var qr = [], si = [], Di = [], wi = 0, Xi = pe.amdDependencies; wi < Xi.length; wi++) {
                  var et = Xi[wi];
                  et.name ? (qr.push(E.createStringLiteral(et.path)), Di.push(E.createParameterDeclaration(void 0, void 0, void 0, et.name))) : si.push(E.createStringLiteral(et.path));
                }
                for (var Gi = 0, Wt = R.externalImports; Gi < Wt.length; Gi++) {
                  var Zt = Wt[Gi], _r = e.getExternalModuleNameLiteral(E, Zt, ie, oe, G, m), pi = e.getLocalNameForExternalImport(E, Zt, ie);
                  _r && (or && pi ? (e.setEmitFlags(pi, 4), qr.push(_r), Di.push(E.createParameterDeclaration(void 0, void 0, void 0, pi))) : si.push(_r));
                }
                return { aliasedModuleNames: qr, unaliasedModuleNames: si, importAliasNames: Di };
              }
              function $(pe) {
                if (!(e.isImportEqualsDeclaration(pe) || e.isExportDeclaration(pe) || !e.getExternalModuleNameLiteral(E, pe, ie, oe, G, m))) {
                  var or = e.getLocalNameForExternalImport(E, pe, ie), qr = We(pe, or);
                  if (qr !== or) return E.createExpressionStatement(E.createAssignment(or, qr));
                }
              }
              function A(pe) {
                le();
                var or = [], qr = E.copyPrologue(pe.statements, or, !m.noImplicitUseStrict, V);
                ee() && e.append(or, Er()), e.length(R.exportedNames) && e.append(or, E.createExpressionStatement(e.reduceLeft(R.exportedNames, function(Di, wi) {
                  return E.createAssignment(E.createPropertyAccessExpression(E.createIdentifier("exports"), E.createIdentifier(e.idText(wi))), Di);
                }, E.createVoidZero()))), e.append(or, e.visitNode(R.externalHelpersImportDeclaration, V, e.isStatement)), T === e.ModuleKind.AMD && e.addRange(or, e.mapDefined(R.externalImports, $)), e.addRange(or, e.visitNodes(pe.statements, V, e.isStatement, qr)), y(or, true), e.insertStatementsAfterStandardPrologue(or, N());
                var si = E.createBlock(or, true);
                return O && e.addEmitHelper(si, C), si;
              }
              function y(pe, or) {
                if (R.exportEquals) {
                  var qr = e.visitNode(R.exportEquals.expression, P);
                  if (qr) if (or) {
                    var si = E.createReturnStatement(qr);
                    e.setTextRange(si, R.exportEquals), e.setEmitFlags(si, 1920), pe.push(si);
                  } else {
                    var si = E.createExpressionStatement(E.createAssignment(E.createPropertyAccessExpression(E.createIdentifier("module"), "exports"), qr));
                    e.setTextRange(si, R.exportEquals), e.setEmitFlags(si, 1536), pe.push(si);
                  }
                }
              }
              function V(pe) {
                switch (pe.kind) {
                  case 266:
                    return Fe(pe);
                  case 265:
                    return Be(pe);
                  case 272:
                    return ge(pe);
                  case 271:
                    return Re(pe);
                  case 237:
                    return He(pe);
                  case 256:
                    return ze(pe);
                  case 257:
                    return Ee(pe);
                  case 352:
                    return _e(pe);
                  case 353:
                    return de(pe);
                  default:
                    return P(pe);
                }
              }
              function L(pe, or) {
                if (!(pe.transformFlags & 71307264)) return pe;
                switch (pe.kind) {
                  case 242:
                    return j(pe);
                  case 238:
                    return H(pe);
                  case 212:
                    return I(pe, or);
                  case 350:
                    return l(pe, or);
                  case 208:
                    if (e.isImportCall(pe) && ie.impliedNodeFormat === void 0) return D(pe);
                    break;
                  case 221:
                    if (e.isDestructuringAssignment(pe)) return U(pe, or);
                    break;
                  case 219:
                  case 220:
                    return d(pe, or);
                }
                return e.visitEachChild(pe, P, w);
              }
              function P(pe) {
                return L(pe, false);
              }
              function k(pe) {
                return L(pe, true);
              }
              function Y(pe) {
                if (e.isObjectLiteralExpression(pe)) for (var or = 0, qr = pe.properties; or < qr.length; or++) {
                  var si = qr[or];
                  switch (si.kind) {
                    case 296:
                      if (Y(si.initializer)) return true;
                      break;
                    case 297:
                      if (Y(si.name)) return true;
                      break;
                    case 298:
                      if (Y(si.expression)) return true;
                      break;
                    case 169:
                    case 172:
                    case 173:
                      return false;
                    default:
                      e.Debug.assertNever(si, "Unhandled object member kind");
                  }
                }
                else if (e.isArrayLiteralExpression(pe)) for (var Di = 0, wi = pe.elements; Di < wi.length; Di++) {
                  var si = wi[Di];
                  if (e.isSpreadElement(si)) {
                    if (Y(si.expression)) return true;
                  } else if (Y(si)) return true;
                }
                else if (e.isIdentifier(pe)) return e.length(mi(pe)) > (e.isExportName(pe) ? 1 : 0);
                return false;
              }
              function U(pe, or) {
                return Y(pe.left) ? e.flattenDestructuringAssignment(pe, P, w, 0, !or, rr) : e.visitEachChild(pe, P, w);
              }
              function j(pe) {
                return E.updateForStatement(pe, e.visitNode(pe.initializer, k, e.isForInitializer), e.visitNode(pe.condition, P, e.isExpression), e.visitNode(pe.incrementor, k, e.isExpression), e.visitIterationBody(pe.statement, P, w));
              }
              function H(pe) {
                return E.updateExpressionStatement(pe, e.visitNode(pe.expression, k, e.isExpression));
              }
              function I(pe, or) {
                return E.updateParenthesizedExpression(pe, e.visitNode(pe.expression, or ? k : P, e.isExpression));
              }
              function l(pe, or) {
                return E.updatePartiallyEmittedExpression(pe, e.visitNode(pe.expression, or ? k : P, e.isExpression));
              }
              function d(pe, or) {
                if ((pe.operator === 45 || pe.operator === 46) && e.isIdentifier(pe.operand) && !e.isGeneratedIdentifier(pe.operand) && !e.isLocalName(pe.operand) && !e.isDeclarationNameOfEnumOrNamespace(pe.operand)) {
                  var qr = mi(pe.operand);
                  if (qr) {
                    var si = void 0, Di = e.visitNode(pe.operand, P, e.isExpression);
                    e.isPrefixUnaryExpression(pe) ? Di = E.updatePrefixUnaryExpression(pe, Di) : (Di = E.updatePostfixUnaryExpression(pe, Di), or || (si = E.createTempVariable(p), Di = E.createAssignment(si, Di), e.setTextRange(Di, pe)), Di = E.createComma(Di, E.cloneNode(pe.operand)), e.setTextRange(Di, pe));
                    for (var wi = 0, Xi = qr; wi < Xi.length; wi++) {
                      var et = Xi[wi];
                      q[e.getNodeId(Di)] = true, Di = n(et, Di), e.setTextRange(Di, pe);
                    }
                    return si && (q[e.getNodeId(Di)] = true, Di = E.createComma(Di, si), e.setTextRange(Di, pe)), Di;
                  }
                }
                return e.visitEachChild(pe, P, w);
              }
              function D(pe) {
                var or = e.getExternalModuleNameLiteral(E, pe, ie, oe, G, m), qr = e.visitNode(e.firstOrUndefined(pe.arguments), P), si = or && (!qr || !e.isStringLiteral(qr) || qr.text !== or.text) ? or : qr, Di = !!(pe.transformFlags & 8192);
                switch (m.module) {
                  case e.ModuleKind.AMD:
                    return g(si, Di);
                  case e.ModuleKind.UMD:
                    return fe(si != null ? si : E.createVoidZero(), Di);
                  case e.ModuleKind.CommonJS:
                  default:
                    return ne(si, Di);
                }
              }
              function fe(pe, or) {
                if (O = true, e.isSimpleCopiableExpression(pe)) {
                  var qr = e.isGeneratedIdentifier(pe) ? pe : e.isStringLiteral(pe) ? E.createStringLiteralFromNode(pe) : e.setEmitFlags(e.setTextRange(E.cloneNode(pe), pe), 1536);
                  return E.createConditionalExpression(E.createIdentifier("__syncRequire"), void 0, ne(pe, or), void 0, g(qr, or));
                } else {
                  var si = E.createTempVariable(p);
                  return E.createComma(E.createAssignment(si, pe), E.createConditionalExpression(E.createIdentifier("__syncRequire"), void 0, ne(si, or), void 0, g(si, or)));
                }
              }
              function g(pe, or) {
                var qr = E.createUniqueName("resolve"), si = E.createUniqueName("reject"), Di = [E.createParameterDeclaration(void 0, void 0, void 0, qr), E.createParameterDeclaration(void 0, void 0, void 0, si)], wi = E.createBlock([E.createExpressionStatement(E.createCallExpression(E.createIdentifier("require"), void 0, [E.createArrayLiteralExpression([pe || E.createOmittedExpression()]), qr, si]))]), Xi;
                f >= 2 ? Xi = E.createArrowFunction(void 0, void 0, Di, void 0, void 0, wi) : (Xi = E.createFunctionExpression(void 0, void 0, void 0, void 0, Di, void 0, wi), or && e.setEmitFlags(Xi, 8));
                var et = E.createNewExpression(E.createIdentifier("Promise"), void 0, [Xi]);
                return e.getESModuleInterop(m) ? E.createCallExpression(E.createPropertyAccessExpression(et, E.createIdentifier("then")), void 0, [Q().createImportStarCallbackHelper()]) : et;
              }
              function ne(pe, or) {
                var qr = E.createCallExpression(E.createPropertyAccessExpression(E.createIdentifier("Promise"), "resolve"), void 0, []), si = E.createCallExpression(E.createIdentifier("require"), void 0, pe ? [pe] : []);
                e.getESModuleInterop(m) && (si = Q().createImportStarHelper(si));
                var Di;
                return f >= 2 ? Di = E.createArrowFunction(void 0, void 0, [], void 0, void 0, si) : (Di = E.createFunctionExpression(void 0, void 0, void 0, void 0, [], void 0, E.createBlock([E.createReturnStatement(si)])), or && e.setEmitFlags(Di, 8)), E.createCallExpression(E.createPropertyAccessExpression(qr, "then"), void 0, [Di]);
              }
              function ue(pe, or) {
                return !e.getESModuleInterop(m) || e.getEmitFlags(pe) & 67108864 ? or : e.getExportNeedsImportStarHelper(pe) ? Q().createImportStarHelper(or) : or;
              }
              function We(pe, or) {
                return !e.getESModuleInterop(m) || e.getEmitFlags(pe) & 67108864 ? or : e.getImportNeedsImportStarHelper(pe) ? Q().createImportStarHelper(or) : e.getImportNeedsImportDefaultHelper(pe) ? Q().createImportDefaultHelper(or) : or;
              }
              function Fe(pe) {
                var or, qr = e.getNamespaceDeclarationNode(pe);
                if (T !== e.ModuleKind.AMD) if (pe.importClause) {
                  var si = [];
                  qr && !e.isDefaultImport(pe) ? si.push(E.createVariableDeclaration(E.cloneNode(qr.name), void 0, void 0, We(pe, Z(pe)))) : (si.push(E.createVariableDeclaration(E.getGeneratedNameForNode(pe), void 0, void 0, We(pe, Z(pe)))), qr && e.isDefaultImport(pe) && si.push(E.createVariableDeclaration(E.cloneNode(qr.name), void 0, void 0, E.getGeneratedNameForNode(pe)))), or = e.append(or, e.setOriginalNode(e.setTextRange(E.createVariableStatement(void 0, E.createVariableDeclarationList(si, f >= 2 ? 2 : 0)), pe), pe));
                } else return e.setOriginalNode(e.setTextRange(E.createExpressionStatement(Z(pe)), pe), pe);
                else qr && e.isDefaultImport(pe) && (or = e.append(or, E.createVariableStatement(void 0, E.createVariableDeclarationList([e.setOriginalNode(e.setTextRange(E.createVariableDeclaration(E.cloneNode(qr.name), void 0, void 0, E.getGeneratedNameForNode(pe)), pe), pe)], f >= 2 ? 2 : 0))));
                if (we(pe)) {
                  var Di = e.getOriginalNodeId(pe);
                  J[Di] = ye(J[Di], pe);
                } else or = ye(or, pe);
                return e.singleOrMany(or);
              }
              function Z(pe) {
                var or = e.getExternalModuleNameLiteral(E, pe, ie, oe, G, m), qr = [];
                return or && qr.push(or), E.createCallExpression(E.createIdentifier("require"), void 0, qr);
              }
              function Be(pe) {
                e.Debug.assert(e.isExternalModuleImportEqualsDeclaration(pe), "import= for internal module references should be handled in an earlier transformer.");
                var or;
                if (T !== e.ModuleKind.AMD ? e.hasSyntacticModifier(pe, 1) ? or = e.append(or, e.setOriginalNode(e.setTextRange(E.createExpressionStatement(n(pe.name, Z(pe))), pe), pe)) : or = e.append(or, e.setOriginalNode(e.setTextRange(E.createVariableStatement(void 0, E.createVariableDeclarationList([E.createVariableDeclaration(E.cloneNode(pe.name), void 0, void 0, Z(pe))], f >= 2 ? 2 : 0)), pe), pe)) : e.hasSyntacticModifier(pe, 1) && (or = e.append(or, e.setOriginalNode(e.setTextRange(E.createExpressionStatement(n(E.getExportName(pe), E.getLocalName(pe))), pe), pe))), we(pe)) {
                  var qr = e.getOriginalNodeId(pe);
                  J[qr] = Ae(J[qr], pe);
                } else or = Ae(or, pe);
                return e.singleOrMany(or);
              }
              function ge(pe) {
                if (!!pe.moduleSpecifier) {
                  var or = E.getGeneratedNameForNode(pe);
                  if (pe.exportClause && e.isNamedExports(pe.exportClause)) {
                    var qr = [];
                    T !== e.ModuleKind.AMD && qr.push(e.setOriginalNode(e.setTextRange(E.createVariableStatement(void 0, E.createVariableDeclarationList([E.createVariableDeclaration(or, void 0, void 0, Z(pe))])), pe), pe));
                    for (var si = 0, Di = pe.exportClause.elements; si < Di.length; si++) {
                      var wi = Di[si];
                      if (f === 0) qr.push(e.setOriginalNode(e.setTextRange(E.createExpressionStatement(Q().createCreateBindingHelper(or, E.createStringLiteralFromNode(wi.propertyName || wi.name), wi.propertyName ? E.createStringLiteralFromNode(wi.name) : void 0)), wi), wi));
                      else {
                        var Xi = !!e.getESModuleInterop(m) && !(e.getEmitFlags(pe) & 67108864) && e.idText(wi.propertyName || wi.name) === "default", et = E.createPropertyAccessExpression(Xi ? Q().createImportDefaultHelper(or) : or, wi.propertyName || wi.name);
                        qr.push(e.setOriginalNode(e.setTextRange(E.createExpressionStatement(n(E.getExportName(wi), et, void 0, true)), wi), wi));
                      }
                    }
                    return e.singleOrMany(qr);
                  } else if (pe.exportClause) {
                    var qr = [];
                    return qr.push(e.setOriginalNode(e.setTextRange(E.createExpressionStatement(n(E.cloneNode(pe.exportClause.name), ue(pe, T !== e.ModuleKind.AMD ? Z(pe) : e.isExportNamespaceAsDefaultDeclaration(pe) ? or : E.createIdentifier(e.idText(pe.exportClause.name))))), pe), pe)), e.singleOrMany(qr);
                  } else return e.setOriginalNode(e.setTextRange(E.createExpressionStatement(Q().createExportStarHelper(T !== e.ModuleKind.AMD ? Z(pe) : or)), pe), pe);
                }
              }
              function Re(pe) {
                if (!pe.isExportEquals) {
                  var or, qr = pe.original;
                  if (qr && we(qr)) {
                    var si = e.getOriginalNodeId(pe);
                    J[si] = Br(J[si], E.createIdentifier("default"), e.visitNode(pe.expression, P), pe, true);
                  } else or = Br(or, E.createIdentifier("default"), e.visitNode(pe.expression, P), pe, true);
                  return e.singleOrMany(or);
                }
              }
              function ze(pe) {
                var or;
                if (e.hasSyntacticModifier(pe, 1) ? or = e.append(or, e.setOriginalNode(e.setTextRange(E.createFunctionDeclaration(void 0, e.visitNodes(pe.modifiers, lr, e.isModifier), pe.asteriskToken, E.getDeclarationName(pe, true, true), void 0, e.visitNodes(pe.parameters, P), void 0, e.visitEachChild(pe.body, P, w)), pe), pe)) : or = e.append(or, e.visitEachChild(pe, P, w)), we(pe)) {
                  var qr = e.getOriginalNodeId(pe);
                  J[qr] = Cr(J[qr], pe);
                } else or = Cr(or, pe);
                return e.singleOrMany(or);
              }
              function Ee(pe) {
                var or;
                if (e.hasSyntacticModifier(pe, 1) ? or = e.append(or, e.setOriginalNode(e.setTextRange(E.createClassDeclaration(void 0, e.visitNodes(pe.modifiers, lr, e.isModifier), E.getDeclarationName(pe, true, true), void 0, e.visitNodes(pe.heritageClauses, P), e.visitNodes(pe.members, P)), pe), pe)) : or = e.append(or, e.visitEachChild(pe, P, w)), we(pe)) {
                  var qr = e.getOriginalNodeId(pe);
                  J[qr] = Cr(J[qr], pe);
                } else or = Cr(or, pe);
                return e.singleOrMany(or);
              }
              function He(pe) {
                var or, qr, si;
                if (e.hasSyntacticModifier(pe, 1)) {
                  for (var Di = void 0, wi = false, Xi = 0, et = pe.declarationList.declarations; Xi < et.length; Xi++) {
                    var Gi = et[Xi];
                    if (e.isIdentifier(Gi.name) && e.isLocalName(Gi.name)) Di || (Di = e.visitNodes(pe.modifiers, lr, e.isModifier)), qr = e.append(qr, Gi);
                    else if (Gi.initializer) if (!e.isBindingPattern(Gi.name) && (e.isArrowFunction(Gi.initializer) || e.isFunctionExpression(Gi.initializer) || e.isClassExpression(Gi.initializer))) {
                      var Wt = E.createAssignment(e.setTextRange(E.createPropertyAccessExpression(E.createIdentifier("exports"), Gi.name), Gi.name), E.createIdentifier(e.getTextOfIdentifierOrLiteral(Gi.name))), Zt = E.createVariableDeclaration(Gi.name, Gi.exclamationToken, Gi.type, e.visitNode(Gi.initializer, P));
                      qr = e.append(qr, Zt), si = e.append(si, Wt), wi = true;
                    } else si = e.append(si, Ie(Gi));
                  }
                  if (qr && (or = e.append(or, E.updateVariableStatement(pe, Di, E.updateVariableDeclarationList(pe.declarationList, qr)))), si) {
                    var _r = e.setOriginalNode(e.setTextRange(E.createExpressionStatement(E.inlineExpressions(si)), pe), pe);
                    wi && e.removeAllComments(_r), or = e.append(or, _r);
                  }
                } else or = e.append(or, e.visitEachChild(pe, P, w));
                if (we(pe)) {
                  var pi = e.getOriginalNodeId(pe);
                  J[pi] = er(J[pi], pe);
                } else or = er(or, pe);
                return e.singleOrMany(or);
              }
              function rr(pe, or, qr) {
                var si = mi(pe);
                if (si) {
                  for (var Di = e.isExportName(pe) ? or : E.createAssignment(pe, or), wi = 0, Xi = si; wi < Xi.length; wi++) {
                    var et = Xi[wi];
                    e.setEmitFlags(Di, 4), Di = n(et, Di, qr);
                  }
                  return Di;
                }
                return E.createAssignment(pe, or);
              }
              function Ie(pe) {
                return e.isBindingPattern(pe.name) ? e.flattenDestructuringAssignment(e.visitNode(pe, P), void 0, w, 0, false, rr) : E.createAssignment(e.setTextRange(E.createPropertyAccessExpression(E.createIdentifier("exports"), pe.name), pe.name), pe.initializer ? e.visitNode(pe.initializer, P) : E.createVoidZero());
              }
              function _e(pe) {
                if (we(pe) && pe.original.kind === 237) {
                  var or = e.getOriginalNodeId(pe);
                  J[or] = er(J[or], pe.original);
                }
                return pe;
              }
              function we(pe) {
                return (e.getEmitFlags(pe) & 4194304) !== 0;
              }
              function de(pe) {
                var or = e.getOriginalNodeId(pe), qr = J[or];
                return qr ? (delete J[or], e.append(qr, pe)) : pe;
              }
              function ye(pe, or) {
                if (R.exportEquals) return pe;
                var qr = or.importClause;
                if (!qr) return pe;
                qr.name && (pe = Ye(pe, qr));
                var si = qr.namedBindings;
                if (si) switch (si.kind) {
                  case 268:
                    pe = Ye(pe, si);
                    break;
                  case 269:
                    for (var Di = 0, wi = si.elements; Di < wi.length; Di++) {
                      var Xi = wi[Di];
                      pe = Ye(pe, Xi, true);
                    }
                    break;
                }
                return pe;
              }
              function Ae(pe, or) {
                return R.exportEquals ? pe : Ye(pe, or);
              }
              function er(pe, or) {
                if (R.exportEquals) return pe;
                for (var qr = 0, si = or.declarationList.declarations; qr < si.length; qr++) {
                  var Di = si[qr];
                  pe = ir(pe, Di);
                }
                return pe;
              }
              function ir(pe, or) {
                if (R.exportEquals) return pe;
                if (e.isBindingPattern(or.name)) for (var qr = 0, si = or.name.elements; qr < si.length; qr++) {
                  var Di = si[qr];
                  e.isOmittedExpression(Di) || (pe = ir(pe, Di));
                }
                else e.isGeneratedIdentifier(or.name) || (pe = Ye(pe, or));
                return pe;
              }
              function Cr(pe, or) {
                if (R.exportEquals) return pe;
                if (e.hasSyntacticModifier(or, 1)) {
                  var qr = e.hasSyntacticModifier(or, 512) ? E.createIdentifier("default") : E.getDeclarationName(or);
                  pe = Br(pe, qr, E.getLocalName(or), or);
                }
                return or.name && (pe = Ye(pe, or)), pe;
              }
              function Ye(pe, or, qr) {
                var si = E.getDeclarationName(or), Di = R.exportSpecifiers.get(e.idText(si));
                if (Di) for (var wi = 0, Xi = Di; wi < Xi.length; wi++) {
                  var et = Xi[wi];
                  pe = Br(pe, et.name, si, et.name, void 0, qr);
                }
                return pe;
              }
              function Br(pe, or, qr, si, Di, wi) {
                return pe = e.append(pe, Ne(or, qr, si, Di, wi)), pe;
              }
              function Er() {
                var pe;
                return f === 0 ? pe = E.createExpressionStatement(n(E.createIdentifier("__esModule"), E.createTrue())) : pe = E.createExpressionStatement(E.createCallExpression(E.createPropertyAccessExpression(E.createIdentifier("Object"), "defineProperty"), void 0, [E.createIdentifier("exports"), E.createStringLiteral("__esModule"), E.createObjectLiteralExpression([E.createPropertyAssignment("value", E.createTrue())])])), e.setEmitFlags(pe, 1048576), pe;
              }
              function Ne(pe, or, qr, si, Di) {
                var wi = e.setTextRange(E.createExpressionStatement(n(pe, or, void 0, Di)), qr);
                return e.startOnNewLine(wi), si || e.setEmitFlags(wi, 1536), wi;
              }
              function n(pe, or, qr, si) {
                return e.setTextRange(si && f !== 0 ? E.createCallExpression(E.createPropertyAccessExpression(E.createIdentifier("Object"), "defineProperty"), void 0, [E.createIdentifier("exports"), E.createStringLiteralFromNode(pe), E.createObjectLiteralExpression([E.createPropertyAssignment("enumerable", E.createTrue()), E.createPropertyAssignment("get", E.createFunctionExpression(void 0, void 0, void 0, void 0, [], void 0, E.createBlock([E.createReturnStatement(or)])))])]) : E.createAssignment(E.createPropertyAccessExpression(E.createIdentifier("exports"), E.cloneNode(pe)), or), qr);
              }
              function lr(pe) {
                switch (pe.kind) {
                  case 93:
                  case 88:
                    return;
                }
                return pe;
              }
              function be(pe, or, qr) {
                or.kind === 305 ? (ie = or, R = se[e.getOriginalNodeId(ie)], b(pe, or, qr), ie = void 0, R = void 0) : b(pe, or, qr);
              }
              function Ge(pe, or) {
                return or = K(pe, or), or.id && q[or.id] ? or : pe === 1 ? yr(or) : e.isShorthandPropertyAssignment(or) ? ur(or) : or;
              }
              function ur(pe) {
                var or = pe.name, qr = Ur(or);
                if (qr !== or) {
                  if (pe.objectAssignmentInitializer) {
                    var si = E.createAssignment(qr, pe.objectAssignmentInitializer);
                    return e.setTextRange(E.createPropertyAssignment(or, si), pe);
                  }
                  return e.setTextRange(E.createPropertyAssignment(or, qr), pe);
                }
                return pe;
              }
              function yr(pe) {
                switch (pe.kind) {
                  case 79:
                    return Ur(pe);
                  case 208:
                    return Ir(pe);
                  case 210:
                    return wr(pe);
                  case 221:
                    return ii(pe);
                }
                return pe;
              }
              function Ir(pe) {
                if (e.isIdentifier(pe.expression)) {
                  var or = Ur(pe.expression);
                  if (q[e.getNodeId(or)] = true, !e.isIdentifier(or) && !(e.getEmitFlags(pe.expression) & 4096)) return e.addEmitFlags(E.updateCallExpression(pe, or, void 0, pe.arguments), 536870912);
                }
                return pe;
              }
              function wr(pe) {
                if (e.isIdentifier(pe.tag)) {
                  var or = Ur(pe.tag);
                  if (q[e.getNodeId(or)] = true, !e.isIdentifier(or) && !(e.getEmitFlags(pe.tag) & 4096)) return e.addEmitFlags(E.updateTaggedTemplateExpression(pe, or, void 0, pe.template), 536870912);
                }
                return pe;
              }
              function Ur(pe) {
                var or, qr;
                if (e.getEmitFlags(pe) & 4096) {
                  var si = e.getExternalHelpersModuleName(ie);
                  return si ? E.createPropertyAccessExpression(si, pe) : pe;
                } else if (!(e.isGeneratedIdentifier(pe) && !(pe.autoGenerateFlags & 64)) && !e.isLocalName(pe)) {
                  var Di = G.getReferencedExportContainer(pe, e.isExportName(pe));
                  if (Di && Di.kind === 305) return e.setTextRange(E.createPropertyAccessExpression(E.createIdentifier("exports"), E.cloneNode(pe)), pe);
                  var wi = G.getReferencedImportDeclaration(pe);
                  if (wi) {
                    if (e.isImportClause(wi)) return e.setTextRange(E.createPropertyAccessExpression(E.getGeneratedNameForNode(wi.parent), E.createIdentifier("default")), pe);
                    if (e.isImportSpecifier(wi)) {
                      var Xi = wi.propertyName || wi.name;
                      return e.setTextRange(E.createPropertyAccessExpression(E.getGeneratedNameForNode(((qr = (or = wi.parent) === null || or === void 0 ? void 0 : or.parent) === null || qr === void 0 ? void 0 : qr.parent) || wi), E.cloneNode(Xi)), pe);
                    }
                  }
                }
                return pe;
              }
              function ii(pe) {
                if (e.isAssignmentOperator(pe.operatorToken.kind) && e.isIdentifier(pe.left) && !e.isGeneratedIdentifier(pe.left) && !e.isLocalName(pe.left) && !e.isDeclarationNameOfEnumOrNamespace(pe.left)) {
                  var or = mi(pe.left);
                  if (or) {
                    for (var qr = pe, si = 0, Di = or; si < Di.length; si++) {
                      var wi = Di[si];
                      q[e.getNodeId(qr)] = true, qr = n(wi, qr, pe);
                    }
                    return qr;
                  }
                }
                return pe;
              }
              function mi(pe) {
                if (!e.isGeneratedIdentifier(pe)) {
                  var or = G.getReferencedImportDeclaration(pe) || G.getReferencedValueDeclaration(pe);
                  if (or) return R && R.exportedBindings[e.getOriginalNodeId(or)];
                }
              }
            }
            e.transformModule = a;
            var C = { name: "typescript:dynamicimport-sync-require", scoped: true, text: `
            var __syncRequire = typeof module === "object" && typeof module.exports === "object";` };
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(C) {
              var w = C.factory, B = C.startLexicalEnvironment, E = C.endLexicalEnvironment, Q = C.hoistVariableDeclaration, le = C.getCompilerOptions(), N = C.getEmitResolver(), p = C.getEmitHost(), m = C.onSubstituteNode, G = C.onEmitNode;
              C.onSubstituteNode = si, C.onEmitNode = qr, C.enableSubstitution(79), C.enableSubstitution(297), C.enableSubstitution(221), C.enableSubstitution(231), C.enableEmitNotification(305);
              var oe = [], f = [], T = [], K = [], b = [], se, J, ie, R, q, O, ve;
              return e.chainBundle(C, ee);
              function ee(ae) {
                if (ae.isDeclarationFile || !(e.isEffectiveExternalModule(ae, le) || ae.transformFlags & 4194304)) return ae;
                var Xe = e.getOriginalNodeId(ae);
                se = ae, O = ae, J = oe[Xe] = e.collectExternalModuleInfo(C, ae, N, le), ie = w.createUniqueName("exports"), T[Xe] = ie, R = b[Xe] = w.createUniqueName("context");
                var Jr = he(J.externalImports), ti = F(ae, Jr), Ze = w.createFunctionExpression(void 0, void 0, void 0, void 0, [w.createParameterDeclaration(void 0, void 0, void 0, ie), w.createParameterDeclaration(void 0, void 0, void 0, R)], void 0, ti), Sr = e.tryGetModuleNameFromFile(w, ae, p, le), zr = w.createArrayLiteralExpression(e.map(Jr, function(Je) {
                  return Je.name;
                })), Wr = e.setEmitFlags(w.updateSourceFile(ae, e.setTextRange(w.createNodeArray([w.createExpressionStatement(w.createCallExpression(w.createPropertyAccessExpression(w.createIdentifier("System"), "register"), void 0, Sr ? [Sr, zr, Ze] : [zr, Ze]))]), ae.statements)), 1024);
                return e.outFile(le) || e.moveEmitHelpers(Wr, ti, function(Je) {
                  return !Je.scoped;
                }), ve && (K[Xe] = ve, ve = void 0), se = void 0, J = void 0, ie = void 0, R = void 0, q = void 0, O = void 0, Wr;
              }
              function he(ae) {
                for (var Xe = new e.Map(), Jr = [], ti = 0, Ze = ae; ti < Ze.length; ti++) {
                  var Sr = Ze[ti], zr = e.getExternalModuleNameLiteral(w, Sr, se, p, N, le);
                  if (zr) {
                    var Wr = zr.text, Je = Xe.get(Wr);
                    Je !== void 0 ? Jr[Je].externalImports.push(Sr) : (Xe.set(Wr, Jr.length), Jr.push({ name: zr, externalImports: [Sr] }));
                  }
                }
                return Jr;
              }
              function F(ae, Xe) {
                var Jr = [];
                B();
                var ti = e.getStrictOptionValue(le, "alwaysStrict") || !le.noImplicitUseStrict && e.isExternalModule(se), Ze = w.copyPrologue(ae.statements, Jr, ti, A);
                Jr.push(w.createVariableStatement(void 0, w.createVariableDeclarationList([w.createVariableDeclaration("__moduleName", void 0, void 0, w.createLogicalAnd(R, w.createPropertyAccessExpression(R, "id")))]))), e.visitNode(J.externalHelpersImportDeclaration, A, e.isStatement);
                var Sr = e.visitNodes(ae.statements, A, e.isStatement, Ze);
                e.addRange(Jr, q), e.insertStatementsAfterStandardPrologue(Jr, E());
                var zr = x(Jr), Wr = ae.transformFlags & 1048576 ? w.createModifiersFromModifierFlags(256) : void 0, Je = w.createObjectLiteralExpression([w.createPropertyAssignment("setters", $(zr, Xe)), w.createPropertyAssignment("execute", w.createFunctionExpression(Wr, void 0, void 0, void 0, [], void 0, w.createBlock(Sr, true)))], true);
                return Jr.push(w.createReturnStatement(Je)), w.createBlock(Jr, true);
              }
              function x(ae) {
                if (!!J.hasExportStarsToExportValues) {
                  if (!J.exportedNames && J.exportSpecifiers.size === 0) {
                    for (var Xe = false, Jr = 0, ti = J.externalImports; Jr < ti.length; Jr++) {
                      var Ze = ti[Jr];
                      if (Ze.kind === 272 && Ze.exportClause) {
                        Xe = true;
                        break;
                      }
                    }
                    if (!Xe) {
                      var Sr = X(void 0);
                      return ae.push(Sr), Sr.name;
                    }
                  }
                  var zr = [];
                  if (J.exportedNames) for (var Wr = 0, Je = J.exportedNames; Wr < Je.length; Wr++) {
                    var xe = Je[Wr];
                    xe.escapedText !== "default" && zr.push(w.createPropertyAssignment(w.createStringLiteralFromNode(xe), w.createTrue()));
                  }
                  var vr = w.createUniqueName("exportedNames");
                  ae.push(w.createVariableStatement(void 0, w.createVariableDeclarationList([w.createVariableDeclaration(vr, void 0, void 0, w.createObjectLiteralExpression(zr, true))])));
                  var mr = X(vr);
                  return ae.push(mr), mr.name;
                }
              }
              function X(ae) {
                var Xe = w.createUniqueName("exportStar"), Jr = w.createIdentifier("m"), ti = w.createIdentifier("n"), Ze = w.createIdentifier("exports"), Sr = w.createStrictInequality(ti, w.createStringLiteral("default"));
                return ae && (Sr = w.createLogicalAnd(Sr, w.createLogicalNot(w.createCallExpression(w.createPropertyAccessExpression(ae, "hasOwnProperty"), void 0, [ti])))), w.createFunctionDeclaration(void 0, void 0, void 0, Xe, void 0, [w.createParameterDeclaration(void 0, void 0, void 0, Jr)], void 0, w.createBlock([w.createVariableStatement(void 0, w.createVariableDeclarationList([w.createVariableDeclaration(Ze, void 0, void 0, w.createObjectLiteralExpression([]))])), w.createForInStatement(w.createVariableDeclarationList([w.createVariableDeclaration(ti)]), Jr, w.createBlock([e.setEmitFlags(w.createIfStatement(Sr, w.createExpressionStatement(w.createAssignment(w.createElementAccessExpression(Ze, ti), w.createElementAccessExpression(Jr, ti)))), 1)])), w.createExpressionStatement(w.createCallExpression(ie, void 0, [Ze]))], true));
              }
              function $(ae, Xe) {
                for (var Jr = [], ti = 0, Ze = Xe; ti < Ze.length; ti++) {
                  for (var Sr = Ze[ti], zr = e.forEach(Sr.externalImports, function(Ue) {
                    return e.getLocalNameForExternalImport(w, Ue, se);
                  }), Wr = zr ? w.getGeneratedNameForNode(zr) : w.createUniqueName(""), Je = [], xe = 0, vr = Sr.externalImports; xe < vr.length; xe++) {
                    var mr = vr[xe], Ar = e.getLocalNameForExternalImport(w, mr, se);
                    switch (mr.kind) {
                      case 266:
                        if (!mr.importClause) break;
                      case 265:
                        e.Debug.assert(Ar !== void 0), Je.push(w.createExpressionStatement(w.createAssignment(Ar, Wr)));
                        break;
                      case 272:
                        if (e.Debug.assert(Ar !== void 0), mr.exportClause) if (e.isNamedExports(mr.exportClause)) {
                          for (var Oe = [], nr = 0, Mr = mr.exportClause.elements; nr < Mr.length; nr++) {
                            var Pe = Mr[nr];
                            Oe.push(w.createPropertyAssignment(w.createStringLiteral(e.idText(Pe.name)), w.createElementAccessExpression(Wr, w.createStringLiteral(e.idText(Pe.propertyName || Pe.name)))));
                          }
                          Je.push(w.createExpressionStatement(w.createCallExpression(ie, void 0, [w.createObjectLiteralExpression(Oe, true)])));
                        } else Je.push(w.createExpressionStatement(w.createCallExpression(ie, void 0, [w.createStringLiteral(e.idText(mr.exportClause.name)), Wr])));
                        else Je.push(w.createExpressionStatement(w.createCallExpression(ae, void 0, [Wr])));
                        break;
                    }
                  }
                  Jr.push(w.createFunctionExpression(void 0, void 0, void 0, void 0, [w.createParameterDeclaration(void 0, void 0, void 0, Wr)], void 0, w.createBlock(Je, true)));
                }
                return w.createArrayLiteralExpression(Jr, true);
              }
              function A(ae) {
                switch (ae.kind) {
                  case 266:
                    return y(ae);
                  case 265:
                    return L(ae);
                  case 272:
                    return V(ae);
                  case 271:
                    return P(ae);
                  default:
                    return He(ae);
                }
              }
              function y(ae) {
                var Xe;
                if (ae.importClause && Q(e.getLocalNameForExternalImport(w, ae, se)), g(ae)) {
                  var Jr = e.getOriginalNodeId(ae);
                  f[Jr] = ue(f[Jr], ae);
                } else Xe = ue(Xe, ae);
                return e.singleOrMany(Xe);
              }
              function V(ae) {
                e.Debug.assertIsDefined(ae);
              }
              function L(ae) {
                e.Debug.assert(e.isExternalModuleImportEqualsDeclaration(ae), "import= for internal module references should be handled in an earlier transformer.");
                var Xe;
                if (Q(e.getLocalNameForExternalImport(w, ae, se)), g(ae)) {
                  var Jr = e.getOriginalNodeId(ae);
                  f[Jr] = We(f[Jr], ae);
                } else Xe = We(Xe, ae);
                return e.singleOrMany(Xe);
              }
              function P(ae) {
                if (!ae.isExportEquals) {
                  var Xe = e.visitNode(ae.expression, Ge, e.isExpression), Jr = ae.original;
                  if (Jr && g(Jr)) {
                    var ti = e.getOriginalNodeId(ae);
                    f[ti] = Re(f[ti], w.createIdentifier("default"), Xe, true);
                  } else return ze(w.createIdentifier("default"), Xe, true);
                }
              }
              function k(ae) {
                if (e.hasSyntacticModifier(ae, 1) ? q = e.append(q, w.updateFunctionDeclaration(ae, ae.decorators, e.visitNodes(ae.modifiers, or, e.isModifier), ae.asteriskToken, w.getDeclarationName(ae, true, true), void 0, e.visitNodes(ae.parameters, Ge, e.isParameterDeclaration), void 0, e.visitNode(ae.body, Ge, e.isBlock))) : q = e.append(q, e.visitEachChild(ae, Ge, C)), g(ae)) {
                  var Xe = e.getOriginalNodeId(ae);
                  f[Xe] = Be(f[Xe], ae);
                } else q = Be(q, ae);
              }
              function Y(ae) {
                var Xe, Jr = w.getLocalName(ae);
                if (Q(Jr), Xe = e.append(Xe, e.setTextRange(w.createExpressionStatement(w.createAssignment(Jr, e.setTextRange(w.createClassExpression(e.visitNodes(ae.decorators, Ge, e.isDecorator), void 0, ae.name, void 0, e.visitNodes(ae.heritageClauses, Ge, e.isHeritageClause), e.visitNodes(ae.members, Ge, e.isClassElement)), ae))), ae)), g(ae)) {
                  var ti = e.getOriginalNodeId(ae);
                  f[ti] = Be(f[ti], ae);
                } else Xe = Be(Xe, ae);
                return e.singleOrMany(Xe);
              }
              function U(ae) {
                if (!H(ae.declarationList)) return e.visitNode(ae, Ge, e.isStatement);
                for (var Xe, Jr = e.hasSyntacticModifier(ae, 1), ti = g(ae), Ze = 0, Sr = ae.declarationList.declarations; Ze < Sr.length; Ze++) {
                  var zr = Sr[Ze];
                  zr.initializer ? Xe = e.append(Xe, I(zr, Jr && !ti)) : j(zr);
                }
                var Wr;
                if (Xe && (Wr = e.append(Wr, e.setTextRange(w.createExpressionStatement(w.inlineExpressions(Xe)), ae))), ti) {
                  var Je = e.getOriginalNodeId(ae);
                  f[Je] = Fe(f[Je], ae, Jr);
                } else Wr = Fe(Wr, ae, false);
                return e.singleOrMany(Wr);
              }
              function j(ae) {
                if (e.isBindingPattern(ae.name)) for (var Xe = 0, Jr = ae.name.elements; Xe < Jr.length; Xe++) {
                  var ti = Jr[Xe];
                  e.isOmittedExpression(ti) || j(ti);
                }
                else Q(w.cloneNode(ae.name));
              }
              function H(ae) {
                return (e.getEmitFlags(ae) & 2097152) === 0 && (O.kind === 305 || (e.getOriginalNode(ae).flags & 3) === 0);
              }
              function I(ae, Xe) {
                var Jr = Xe ? l : d;
                return e.isBindingPattern(ae.name) ? e.flattenDestructuringAssignment(ae, Ge, C, 0, false, Jr) : ae.initializer ? Jr(ae.name, e.visitNode(ae.initializer, Ge, e.isExpression)) : ae.name;
              }
              function l(ae, Xe, Jr) {
                return D(ae, Xe, Jr, true);
              }
              function d(ae, Xe, Jr) {
                return D(ae, Xe, Jr, false);
              }
              function D(ae, Xe, Jr, ti) {
                return Q(w.cloneNode(ae)), ti ? Ee(ae, _r(e.setTextRange(w.createAssignment(ae, Xe), Jr))) : _r(e.setTextRange(w.createAssignment(ae, Xe), Jr));
              }
              function fe(ae) {
                if (g(ae) && ae.original.kind === 237) {
                  var Xe = e.getOriginalNodeId(ae), Jr = e.hasSyntacticModifier(ae.original, 1);
                  f[Xe] = Fe(f[Xe], ae.original, Jr);
                }
                return ae;
              }
              function g(ae) {
                return (e.getEmitFlags(ae) & 4194304) !== 0;
              }
              function ne(ae) {
                var Xe = e.getOriginalNodeId(ae), Jr = f[Xe];
                if (Jr) return delete f[Xe], e.append(Jr, ae);
                var ti = e.getOriginalNode(ae);
                return e.isModuleOrEnumDeclaration(ti) ? e.append(ge(Jr, ti), ae) : ae;
              }
              function ue(ae, Xe) {
                if (J.exportEquals) return ae;
                var Jr = Xe.importClause;
                if (!Jr) return ae;
                Jr.name && (ae = ge(ae, Jr));
                var ti = Jr.namedBindings;
                if (ti) switch (ti.kind) {
                  case 268:
                    ae = ge(ae, ti);
                    break;
                  case 269:
                    for (var Ze = 0, Sr = ti.elements; Ze < Sr.length; Ze++) {
                      var zr = Sr[Ze];
                      ae = ge(ae, zr);
                    }
                    break;
                }
                return ae;
              }
              function We(ae, Xe) {
                return J.exportEquals ? ae : ge(ae, Xe);
              }
              function Fe(ae, Xe, Jr) {
                if (J.exportEquals) return ae;
                for (var ti = 0, Ze = Xe.declarationList.declarations; ti < Ze.length; ti++) {
                  var Sr = Ze[ti];
                  (Sr.initializer || Jr) && (ae = Z(ae, Sr, Jr));
                }
                return ae;
              }
              function Z(ae, Xe, Jr) {
                if (J.exportEquals) return ae;
                if (e.isBindingPattern(Xe.name)) for (var ti = 0, Ze = Xe.name.elements; ti < Ze.length; ti++) {
                  var Sr = Ze[ti];
                  e.isOmittedExpression(Sr) || (ae = Z(ae, Sr, Jr));
                }
                else if (!e.isGeneratedIdentifier(Xe.name)) {
                  var zr = void 0;
                  Jr && (ae = Re(ae, Xe.name, w.getLocalName(Xe)), zr = e.idText(Xe.name)), ae = ge(ae, Xe, zr);
                }
                return ae;
              }
              function Be(ae, Xe) {
                if (J.exportEquals) return ae;
                var Jr;
                if (e.hasSyntacticModifier(Xe, 1)) {
                  var ti = e.hasSyntacticModifier(Xe, 512) ? w.createStringLiteral("default") : Xe.name;
                  ae = Re(ae, ti, w.getLocalName(Xe)), Jr = e.getTextOfIdentifierOrLiteral(ti);
                }
                return Xe.name && (ae = ge(ae, Xe, Jr)), ae;
              }
              function ge(ae, Xe, Jr) {
                if (J.exportEquals) return ae;
                var ti = w.getDeclarationName(Xe), Ze = J.exportSpecifiers.get(e.idText(ti));
                if (Ze) for (var Sr = 0, zr = Ze; Sr < zr.length; Sr++) {
                  var Wr = zr[Sr];
                  Wr.name.escapedText !== Jr && (ae = Re(ae, Wr.name, ti));
                }
                return ae;
              }
              function Re(ae, Xe, Jr, ti) {
                return ae = e.append(ae, ze(Xe, Jr, ti)), ae;
              }
              function ze(ae, Xe, Jr) {
                var ti = w.createExpressionStatement(Ee(ae, Xe));
                return e.startOnNewLine(ti), Jr || e.setEmitFlags(ti, 1536), ti;
              }
              function Ee(ae, Xe) {
                var Jr = e.isIdentifier(ae) ? w.createStringLiteralFromNode(ae) : ae;
                return e.setEmitFlags(Xe, e.getEmitFlags(Xe) | 1536), e.setCommentRange(w.createCallExpression(ie, void 0, [Jr, Xe]), Xe);
              }
              function He(ae) {
                switch (ae.kind) {
                  case 237:
                    return U(ae);
                  case 256:
                    return k(ae);
                  case 257:
                    return Y(ae);
                  case 242:
                    return rr(ae, true);
                  case 243:
                    return Ie(ae);
                  case 244:
                    return _e(ae);
                  case 240:
                    return ye(ae);
                  case 241:
                    return Ae(ae);
                  case 250:
                    return er(ae);
                  case 248:
                    return ir(ae);
                  case 249:
                    return Cr(ae);
                  case 263:
                    return Ye(ae);
                  case 289:
                    return Br(ae);
                  case 290:
                    return Er(ae);
                  case 252:
                    return Ne(ae);
                  case 292:
                    return n(ae);
                  case 235:
                    return lr(ae);
                  case 352:
                    return fe(ae);
                  case 353:
                    return ne(ae);
                  default:
                    return Ge(ae);
                }
              }
              function rr(ae, Xe) {
                var Jr = O;
                return O = ae, ae = w.updateForStatement(ae, e.visitNode(ae.initializer, Xe ? de : ur, e.isForInitializer), e.visitNode(ae.condition, Ge, e.isExpression), e.visitNode(ae.incrementor, ur, e.isExpression), e.visitIterationBody(ae.statement, Xe ? He : Ge, C)), O = Jr, ae;
              }
              function Ie(ae) {
                var Xe = O;
                return O = ae, ae = w.updateForInStatement(ae, de(ae.initializer), e.visitNode(ae.expression, Ge, e.isExpression), e.visitIterationBody(ae.statement, He, C)), O = Xe, ae;
              }
              function _e(ae) {
                var Xe = O;
                return O = ae, ae = w.updateForOfStatement(ae, ae.awaitModifier, de(ae.initializer), e.visitNode(ae.expression, Ge, e.isExpression), e.visitIterationBody(ae.statement, He, C)), O = Xe, ae;
              }
              function we(ae) {
                return e.isVariableDeclarationList(ae) && H(ae);
              }
              function de(ae) {
                if (we(ae)) {
                  for (var Xe = void 0, Jr = 0, ti = ae.declarations; Jr < ti.length; Jr++) {
                    var Ze = ti[Jr];
                    Xe = e.append(Xe, I(Ze, false)), Ze.initializer || j(Ze);
                  }
                  return Xe ? w.inlineExpressions(Xe) : w.createOmittedExpression();
                } else return e.visitNode(ae, ur, e.isExpression);
              }
              function ye(ae) {
                return w.updateDoStatement(ae, e.visitIterationBody(ae.statement, He, C), e.visitNode(ae.expression, Ge, e.isExpression));
              }
              function Ae(ae) {
                return w.updateWhileStatement(ae, e.visitNode(ae.expression, Ge, e.isExpression), e.visitIterationBody(ae.statement, He, C));
              }
              function er(ae) {
                return w.updateLabeledStatement(ae, ae.label, e.visitNode(ae.statement, He, e.isStatement, w.liftToBlock));
              }
              function ir(ae) {
                return w.updateWithStatement(ae, e.visitNode(ae.expression, Ge, e.isExpression), e.visitNode(ae.statement, He, e.isStatement, w.liftToBlock));
              }
              function Cr(ae) {
                return w.updateSwitchStatement(ae, e.visitNode(ae.expression, Ge, e.isExpression), e.visitNode(ae.caseBlock, He, e.isCaseBlock));
              }
              function Ye(ae) {
                var Xe = O;
                return O = ae, ae = w.updateCaseBlock(ae, e.visitNodes(ae.clauses, He, e.isCaseOrDefaultClause)), O = Xe, ae;
              }
              function Br(ae) {
                return w.updateCaseClause(ae, e.visitNode(ae.expression, Ge, e.isExpression), e.visitNodes(ae.statements, He, e.isStatement));
              }
              function Er(ae) {
                return e.visitEachChild(ae, He, C);
              }
              function Ne(ae) {
                return e.visitEachChild(ae, He, C);
              }
              function n(ae) {
                var Xe = O;
                return O = ae, ae = w.updateCatchClause(ae, ae.variableDeclaration, e.visitNode(ae.block, He, e.isBlock)), O = Xe, ae;
              }
              function lr(ae) {
                var Xe = O;
                return O = ae, ae = e.visitEachChild(ae, He, C), O = Xe, ae;
              }
              function be(ae, Xe) {
                if (!(ae.transformFlags & 71307264)) return ae;
                switch (ae.kind) {
                  case 242:
                    return rr(ae, false);
                  case 238:
                    return yr(ae);
                  case 212:
                    return Ir(ae, Xe);
                  case 350:
                    return wr(ae, Xe);
                  case 221:
                    if (e.isDestructuringAssignment(ae)) return ii(ae, Xe);
                    break;
                  case 208:
                    if (e.isImportCall(ae)) return Ur(ae);
                    break;
                  case 219:
                  case 220:
                    return pe(ae, Xe);
                }
                return e.visitEachChild(ae, Ge, C);
              }
              function Ge(ae) {
                return be(ae, false);
              }
              function ur(ae) {
                return be(ae, true);
              }
              function yr(ae) {
                return w.updateExpressionStatement(ae, e.visitNode(ae.expression, ur, e.isExpression));
              }
              function Ir(ae, Xe) {
                return w.updateParenthesizedExpression(ae, e.visitNode(ae.expression, Xe ? ur : Ge, e.isExpression));
              }
              function wr(ae, Xe) {
                return w.updatePartiallyEmittedExpression(ae, e.visitNode(ae.expression, Xe ? ur : Ge, e.isExpression));
              }
              function Ur(ae) {
                var Xe = e.getExternalModuleNameLiteral(w, ae, se, p, N, le), Jr = e.visitNode(e.firstOrUndefined(ae.arguments), Ge), ti = Xe && (!Jr || !e.isStringLiteral(Jr) || Jr.text !== Xe.text) ? Xe : Jr;
                return w.createCallExpression(w.createPropertyAccessExpression(R, w.createIdentifier("import")), void 0, ti ? [ti] : []);
              }
              function ii(ae, Xe) {
                return mi(ae.left) ? e.flattenDestructuringAssignment(ae, Ge, C, 0, !Xe) : e.visitEachChild(ae, Ge, C);
              }
              function mi(ae) {
                if (e.isAssignmentExpression(ae, true)) return mi(ae.left);
                if (e.isSpreadElement(ae)) return mi(ae.expression);
                if (e.isObjectLiteralExpression(ae)) return e.some(ae.properties, mi);
                if (e.isArrayLiteralExpression(ae)) return e.some(ae.elements, mi);
                if (e.isShorthandPropertyAssignment(ae)) return mi(ae.name);
                if (e.isPropertyAssignment(ae)) return mi(ae.initializer);
                if (e.isIdentifier(ae)) {
                  var Xe = N.getReferencedExportContainer(ae);
                  return Xe !== void 0 && Xe.kind === 305;
                } else return false;
              }
              function pe(ae, Xe) {
                if ((ae.operator === 45 || ae.operator === 46) && e.isIdentifier(ae.operand) && !e.isGeneratedIdentifier(ae.operand) && !e.isLocalName(ae.operand) && !e.isDeclarationNameOfEnumOrNamespace(ae.operand)) {
                  var Jr = Zt(ae.operand);
                  if (Jr) {
                    var ti = void 0, Ze = e.visitNode(ae.operand, Ge, e.isExpression);
                    e.isPrefixUnaryExpression(ae) ? Ze = w.updatePrefixUnaryExpression(ae, Ze) : (Ze = w.updatePostfixUnaryExpression(ae, Ze), Xe || (ti = w.createTempVariable(Q), Ze = w.createAssignment(ti, Ze), e.setTextRange(Ze, ae)), Ze = w.createComma(Ze, w.cloneNode(ae.operand)), e.setTextRange(Ze, ae));
                    for (var Sr = 0, zr = Jr; Sr < zr.length; Sr++) {
                      var Wr = zr[Sr];
                      Ze = Ee(Wr, _r(Ze));
                    }
                    return ti && (Ze = w.createComma(Ze, ti), e.setTextRange(Ze, ae)), Ze;
                  }
                }
                return e.visitEachChild(ae, Ge, C);
              }
              function or(ae) {
                switch (ae.kind) {
                  case 93:
                  case 88:
                    return;
                }
                return ae;
              }
              function qr(ae, Xe, Jr) {
                if (Xe.kind === 305) {
                  var ti = e.getOriginalNodeId(Xe);
                  se = Xe, J = oe[ti], ie = T[ti], ve = K[ti], R = b[ti], ve && delete K[ti], G(ae, Xe, Jr), se = void 0, J = void 0, ie = void 0, R = void 0, ve = void 0;
                } else G(ae, Xe, Jr);
              }
              function si(ae, Xe) {
                return Xe = m(ae, Xe), pi(Xe) ? Xe : ae === 1 ? Xi(Xe) : ae === 4 ? Di(Xe) : Xe;
              }
              function Di(ae) {
                switch (ae.kind) {
                  case 297:
                    return wi(ae);
                }
                return ae;
              }
              function wi(ae) {
                var Xe, Jr, ti = ae.name;
                if (!e.isGeneratedIdentifier(ti) && !e.isLocalName(ti)) {
                  var Ze = N.getReferencedImportDeclaration(ti);
                  if (Ze) {
                    if (e.isImportClause(Ze)) return e.setTextRange(w.createPropertyAssignment(w.cloneNode(ti), w.createPropertyAccessExpression(w.getGeneratedNameForNode(Ze.parent), w.createIdentifier("default"))), ae);
                    if (e.isImportSpecifier(Ze)) return e.setTextRange(w.createPropertyAssignment(w.cloneNode(ti), w.createPropertyAccessExpression(w.getGeneratedNameForNode(((Jr = (Xe = Ze.parent) === null || Xe === void 0 ? void 0 : Xe.parent) === null || Jr === void 0 ? void 0 : Jr.parent) || Ze), w.cloneNode(Ze.propertyName || Ze.name))), ae);
                  }
                }
                return ae;
              }
              function Xi(ae) {
                switch (ae.kind) {
                  case 79:
                    return et(ae);
                  case 221:
                    return Gi(ae);
                  case 231:
                    return Wt(ae);
                }
                return ae;
              }
              function et(ae) {
                var Xe, Jr;
                if (e.getEmitFlags(ae) & 4096) {
                  var ti = e.getExternalHelpersModuleName(se);
                  return ti ? w.createPropertyAccessExpression(ti, ae) : ae;
                }
                if (!e.isGeneratedIdentifier(ae) && !e.isLocalName(ae)) {
                  var Ze = N.getReferencedImportDeclaration(ae);
                  if (Ze) {
                    if (e.isImportClause(Ze)) return e.setTextRange(w.createPropertyAccessExpression(w.getGeneratedNameForNode(Ze.parent), w.createIdentifier("default")), ae);
                    if (e.isImportSpecifier(Ze)) return e.setTextRange(w.createPropertyAccessExpression(w.getGeneratedNameForNode(((Jr = (Xe = Ze.parent) === null || Xe === void 0 ? void 0 : Xe.parent) === null || Jr === void 0 ? void 0 : Jr.parent) || Ze), w.cloneNode(Ze.propertyName || Ze.name)), ae);
                  }
                }
                return ae;
              }
              function Gi(ae) {
                if (e.isAssignmentOperator(ae.operatorToken.kind) && e.isIdentifier(ae.left) && !e.isGeneratedIdentifier(ae.left) && !e.isLocalName(ae.left) && !e.isDeclarationNameOfEnumOrNamespace(ae.left)) {
                  var Xe = Zt(ae.left);
                  if (Xe) {
                    for (var Jr = ae, ti = 0, Ze = Xe; ti < Ze.length; ti++) {
                      var Sr = Ze[ti];
                      Jr = Ee(Sr, _r(Jr));
                    }
                    return Jr;
                  }
                }
                return ae;
              }
              function Wt(ae) {
                return e.isImportMeta(ae) ? w.createPropertyAccessExpression(R, w.createIdentifier("meta")) : ae;
              }
              function Zt(ae) {
                var Xe;
                if (!e.isGeneratedIdentifier(ae)) {
                  var Jr = N.getReferencedImportDeclaration(ae) || N.getReferencedValueDeclaration(ae);
                  if (Jr) {
                    var ti = N.getReferencedExportContainer(ae, false);
                    ti && ti.kind === 305 && (Xe = e.append(Xe, w.getDeclarationName(Jr))), Xe = e.addRange(Xe, J && J.exportedBindings[e.getOriginalNodeId(Jr)]);
                  }
                }
                return Xe;
              }
              function _r(ae) {
                return ve === void 0 && (ve = []), ve[e.getNodeId(ae)] = true, ae;
              }
              function pi(ae) {
                return ve && ae.id && ve[ae.id];
              }
            }
            e.transformSystemModule = a;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(C) {
              var w = C.factory, B = C.getEmitHelperFactory, E = C.getEmitHost(), Q = C.getEmitResolver(), le = C.getCompilerOptions(), N = e.getEmitScriptTarget(le), p = C.onEmitNode, m = C.onSubstituteNode;
              C.onEmitNode = O, C.onSubstituteNode = ve, C.enableEmitNotification(305), C.enableSubstitution(79);
              var G, oe, f;
              return e.chainBundle(C, T);
              function T(he) {
                if (he.isDeclarationFile) return he;
                if (e.isExternalModule(he) || le.isolatedModules) {
                  oe = he, f = void 0;
                  var F = K(he);
                  return oe = void 0, f && (F = w.updateSourceFile(F, e.setTextRange(w.createNodeArray(e.insertStatementsAfterCustomPrologue(F.statements.slice(), f)), F.statements))), !e.isExternalModule(he) || e.some(F.statements, e.isExternalModuleIndicator) ? F : w.updateSourceFile(F, e.setTextRange(w.createNodeArray(Ve(Ve([], F.statements, true), [e.createEmptyExports(w)], false)), F.statements));
                }
                return he;
              }
              function K(he) {
                var F = e.createExternalHelpersImportDeclarationIfNeeded(w, B(), he, le);
                if (F) {
                  var x = [], X = w.copyPrologue(he.statements, x);
                  return e.append(x, F), e.addRange(x, e.visitNodes(he.statements, b, e.isStatement, X)), w.updateSourceFile(he, e.setTextRange(w.createNodeArray(x), he.statements));
                } else return e.visitEachChild(he, b, C);
              }
              function b(he) {
                switch (he.kind) {
                  case 265:
                    return e.getEmitScriptTarget(le) >= e.ModuleKind.ES2020 ? J(he) : void 0;
                  case 271:
                    return R(he);
                  case 272:
                    var F = he;
                    return q(F);
                }
                return he;
              }
              function se(he) {
                var F = e.getExternalModuleNameLiteral(w, he, e.Debug.checkDefined(oe), E, Q, le), x = [];
                if (F && x.push(F), !f) {
                  var X = w.createUniqueName("_createRequire", 48), $ = w.createImportDeclaration(void 0, void 0, w.createImportClause(false, void 0, w.createNamedImports([w.createImportSpecifier(false, w.createIdentifier("createRequire"), X)])), w.createStringLiteral("module")), A = w.createUniqueName("__require", 48), y = w.createVariableStatement(void 0, w.createVariableDeclarationList([w.createVariableDeclaration(A, void 0, void 0, w.createCallExpression(w.cloneNode(X), void 0, [w.createPropertyAccessExpression(w.createMetaProperty(100, w.createIdentifier("meta")), w.createIdentifier("url"))]))], N >= 2 ? 2 : 0));
                  f = [$, y];
                }
                var V = f[1].declarationList.declarations[0].name;
                return e.Debug.assertNode(V, e.isIdentifier), w.createCallExpression(w.cloneNode(V), void 0, x);
              }
              function J(he) {
                e.Debug.assert(e.isExternalModuleImportEqualsDeclaration(he), "import= for internal module references should be handled in an earlier transformer.");
                var F;
                return F = e.append(F, e.setOriginalNode(e.setTextRange(w.createVariableStatement(void 0, w.createVariableDeclarationList([w.createVariableDeclaration(w.cloneNode(he.name), void 0, void 0, se(he))], N >= 2 ? 2 : 0)), he), he)), F = ie(F, he), e.singleOrMany(F);
              }
              function ie(he, F) {
                return e.hasSyntacticModifier(F, 1) && (he = e.append(he, w.createExportDeclaration(void 0, void 0, F.isTypeOnly, w.createNamedExports([w.createExportSpecifier(false, void 0, e.idText(F.name))])))), he;
              }
              function R(he) {
                return he.isExportEquals ? void 0 : he;
              }
              function q(he) {
                if (le.module !== void 0 && le.module > e.ModuleKind.ES2015 || !he.exportClause || !e.isNamespaceExport(he.exportClause) || !he.moduleSpecifier) return he;
                var F = he.exportClause.name, x = w.getGeneratedNameForNode(F), X = w.createImportDeclaration(void 0, void 0, w.createImportClause(false, void 0, w.createNamespaceImport(x)), he.moduleSpecifier, he.assertClause);
                e.setOriginalNode(X, he.exportClause);
                var $ = e.isExportNamespaceAsDefaultDeclaration(he) ? w.createExportDefault(x) : w.createExportDeclaration(void 0, void 0, false, w.createNamedExports([w.createExportSpecifier(false, x, F)]));
                return e.setOriginalNode($, he), [X, $];
              }
              function O(he, F, x) {
                e.isSourceFile(F) ? ((e.isExternalModule(F) || le.isolatedModules) && le.importHelpers && (G = new e.Map()), p(he, F, x), G = void 0) : p(he, F, x);
              }
              function ve(he, F) {
                return F = m(he, F), G && e.isIdentifier(F) && e.getEmitFlags(F) & 4096 ? ee(F) : F;
              }
              function ee(he) {
                var F = e.idText(he), x = G.get(F);
                return x || G.set(F, x = w.createUniqueName(F, 48)), x;
              }
            }
            e.transformECMAScriptModule = a;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(C) {
              var w = C.onSubstituteNode, B = C.onEmitNode, E = e.transformECMAScriptModule(C), Q = C.onSubstituteNode, le = C.onEmitNode;
              C.onSubstituteNode = w, C.onEmitNode = B;
              var N = e.transformModule(C), p = C.onSubstituteNode, m = C.onEmitNode;
              C.onSubstituteNode = oe, C.onEmitNode = f, C.enableSubstitution(305), C.enableEmitNotification(305);
              var G;
              return b;
              function oe(J, ie) {
                return e.isSourceFile(ie) ? (G = ie, w(J, ie)) : G ? G.impliedNodeFormat === e.ModuleKind.ESNext ? Q(J, ie) : p(J, ie) : w(J, ie);
              }
              function f(J, ie, R) {
                return e.isSourceFile(ie) && (G = ie), G ? G.impliedNodeFormat === e.ModuleKind.ESNext ? le(J, ie, R) : m(J, ie, R) : B(J, ie, R);
              }
              function T(J) {
                return J.impliedNodeFormat === e.ModuleKind.ESNext ? E : N;
              }
              function K(J) {
                if (J.isDeclarationFile) return J;
                G = J;
                var ie = T(J)(J);
                return G = void 0, e.Debug.assert(e.isSourceFile(ie)), ie;
              }
              function b(J) {
                return J.kind === 305 ? K(J) : se(J);
              }
              function se(J) {
                return C.factory.createBundle(e.map(J.sourceFiles, K), J.prepends);
              }
            }
            e.transformNodeModule = a;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(B) {
              return e.isVariableDeclaration(B) || e.isPropertyDeclaration(B) || e.isPropertySignature(B) || e.isBindingElement(B) || e.isSetAccessor(B) || e.isGetAccessor(B) || e.isConstructSignatureDeclaration(B) || e.isCallSignatureDeclaration(B) || e.isMethodDeclaration(B) || e.isMethodSignature(B) || e.isFunctionDeclaration(B) || e.isParameter(B) || e.isTypeParameterDeclaration(B) || e.isExpressionWithTypeArguments(B) || e.isImportEqualsDeclaration(B) || e.isTypeAliasDeclaration(B) || e.isConstructorDeclaration(B) || e.isIndexSignatureDeclaration(B) || e.isPropertyAccessExpression(B) || e.isJSDocTypeAlias(B);
            }
            e.canProduceDiagnostics = a;
            function C(B) {
              if (e.isSetAccessor(B) || e.isGetAccessor(B)) return E;
              return e.isMethodSignature(B) || e.isMethodDeclaration(B) ? le : w(B);
              function E(p) {
                var m = Q(p);
                return m !== void 0 ? { diagnosticMessage: m, errorNode: B, typeName: B.name } : void 0;
              }
              function Q(p) {
                return e.isStatic(B) ? p.errorModuleName ? p.accessibility === 2 ? e.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1 : B.parent.kind === 257 ? p.errorModuleName ? p.accessibility === 2 ? e.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_private_name_1 : p.errorModuleName ? e.Diagnostics.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Property_0_of_exported_interface_has_or_is_using_private_name_1;
              }
              function le(p) {
                var m = N(p);
                return m !== void 0 ? { diagnosticMessage: m, errorNode: B, typeName: B.name } : void 0;
              }
              function N(p) {
                return e.isStatic(B) ? p.errorModuleName ? p.accessibility === 2 ? e.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_private_name_1 : B.parent.kind === 257 ? p.errorModuleName ? p.accessibility === 2 ? e.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_private_name_1 : p.errorModuleName ? e.Diagnostics.Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Method_0_of_exported_interface_has_or_is_using_private_name_1;
              }
            }
            e.createGetSymbolAccessibilityDiagnosticForNodeName = C;
            function w(B) {
              if (e.isVariableDeclaration(B) || e.isPropertyDeclaration(B) || e.isPropertySignature(B) || e.isPropertyAccessExpression(B) || e.isBindingElement(B) || e.isConstructorDeclaration(B)) return Q;
              return e.isSetAccessor(B) || e.isGetAccessor(B) ? le : e.isConstructSignatureDeclaration(B) || e.isCallSignatureDeclaration(B) || e.isMethodDeclaration(B) || e.isMethodSignature(B) || e.isFunctionDeclaration(B) || e.isIndexSignatureDeclaration(B) ? N : e.isParameter(B) ? e.isParameterPropertyDeclaration(B, B.parent) && e.hasSyntacticModifier(B.parent, 8) ? Q : p : e.isTypeParameterDeclaration(B) ? G : e.isExpressionWithTypeArguments(B) ? oe : e.isImportEqualsDeclaration(B) ? f : e.isTypeAliasDeclaration(B) || e.isJSDocTypeAlias(B) ? T : e.Debug.assertNever(B, "Attempted to set a declaration diagnostic context for unhandled node kind: ".concat(e.SyntaxKind[B.kind]));
              function E(K) {
                if (B.kind === 254 || B.kind === 203) return K.errorModuleName ? K.accessibility === 2 ? e.Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e.Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Exported_variable_0_has_or_is_using_private_name_1;
                if (B.kind === 167 || B.kind === 206 || B.kind === 166 || B.kind === 164 && e.hasSyntacticModifier(B.parent, 8)) return e.isStatic(B) ? K.errorModuleName ? K.accessibility === 2 ? e.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1 : B.parent.kind === 257 || B.kind === 164 ? K.errorModuleName ? K.accessibility === 2 ? e.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_private_name_1 : K.errorModuleName ? e.Diagnostics.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Property_0_of_exported_interface_has_or_is_using_private_name_1;
              }
              function Q(K) {
                var b = E(K);
                return b !== void 0 ? { diagnosticMessage: b, errorNode: B, typeName: B.name } : void 0;
              }
              function le(K) {
                var b;
                return B.kind === 173 ? e.isStatic(B) ? b = K.errorModuleName ? e.Diagnostics.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1 : b = K.errorModuleName ? e.Diagnostics.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1 : e.isStatic(B) ? b = K.errorModuleName ? K.accessibility === 2 ? e.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1 : b = K.errorModuleName ? K.accessibility === 2 ? e.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1, { diagnosticMessage: b, errorNode: B.name, typeName: B.name };
              }
              function N(K) {
                var b;
                switch (B.kind) {
                  case 175:
                    b = K.errorModuleName ? e.Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : e.Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0;
                    break;
                  case 174:
                    b = K.errorModuleName ? e.Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : e.Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0;
                    break;
                  case 176:
                    b = K.errorModuleName ? e.Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : e.Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0;
                    break;
                  case 169:
                  case 168:
                    e.isStatic(B) ? b = K.errorModuleName ? K.accessibility === 2 ? e.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : e.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1 : e.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0 : B.parent.kind === 257 ? b = K.errorModuleName ? K.accessibility === 2 ? e.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : e.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1 : e.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0 : b = K.errorModuleName ? e.Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : e.Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0;
                    break;
                  case 256:
                    b = K.errorModuleName ? K.accessibility === 2 ? e.Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : e.Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1 : e.Diagnostics.Return_type_of_exported_function_has_or_is_using_private_name_0;
                    break;
                  default:
                    return e.Debug.fail("This is unknown kind for signature: " + B.kind);
                }
                return { diagnosticMessage: b, errorNode: B.name || B };
              }
              function p(K) {
                var b = m(K);
                return b !== void 0 ? { diagnosticMessage: b, errorNode: B, typeName: B.name } : void 0;
              }
              function m(K) {
                switch (B.parent.kind) {
                  case 171:
                    return K.errorModuleName ? K.accessibility === 2 ? e.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1;
                  case 175:
                  case 180:
                    return K.errorModuleName ? e.Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;
                  case 174:
                    return K.errorModuleName ? e.Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;
                  case 176:
                    return K.errorModuleName ? e.Diagnostics.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1;
                  case 169:
                  case 168:
                    return e.isStatic(B.parent) ? K.errorModuleName ? K.accessibility === 2 ? e.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1 : B.parent.parent.kind === 257 ? K.errorModuleName ? K.accessibility === 2 ? e.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1 : K.errorModuleName ? e.Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;
                  case 256:
                  case 179:
                    return K.errorModuleName ? K.accessibility === 2 ? e.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_private_name_1;
                  case 173:
                  case 172:
                    return K.errorModuleName ? K.accessibility === 2 ? e.Diagnostics.Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e.Diagnostics.Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2 : e.Diagnostics.Parameter_0_of_accessor_has_or_is_using_private_name_1;
                  default:
                    return e.Debug.fail("Unknown parent for parameter: ".concat(e.SyntaxKind[B.parent.kind]));
                }
              }
              function G() {
                var K;
                switch (B.parent.kind) {
                  case 257:
                    K = e.Diagnostics.Type_parameter_0_of_exported_class_has_or_is_using_private_name_1;
                    break;
                  case 258:
                    K = e.Diagnostics.Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1;
                    break;
                  case 195:
                    K = e.Diagnostics.Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1;
                    break;
                  case 180:
                  case 175:
                    K = e.Diagnostics.Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;
                    break;
                  case 174:
                    K = e.Diagnostics.Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;
                    break;
                  case 169:
                  case 168:
                    e.isStatic(B.parent) ? K = e.Diagnostics.Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1 : B.parent.parent.kind === 257 ? K = e.Diagnostics.Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1 : K = e.Diagnostics.Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;
                    break;
                  case 179:
                  case 256:
                    K = e.Diagnostics.Type_parameter_0_of_exported_function_has_or_is_using_private_name_1;
                    break;
                  case 259:
                    K = e.Diagnostics.Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1;
                    break;
                  default:
                    return e.Debug.fail("This is unknown parent for type parameter: " + B.parent.kind);
                }
                return { diagnosticMessage: K, errorNode: B, typeName: B.name };
              }
              function oe() {
                var K;
                return e.isClassDeclaration(B.parent.parent) ? K = e.isHeritageClause(B.parent) && B.parent.token === 117 ? e.Diagnostics.Implements_clause_of_exported_class_0_has_or_is_using_private_name_1 : B.parent.parent.name ? e.Diagnostics.extends_clause_of_exported_class_0_has_or_is_using_private_name_1 : e.Diagnostics.extends_clause_of_exported_class_has_or_is_using_private_name_0 : K = e.Diagnostics.extends_clause_of_exported_interface_0_has_or_is_using_private_name_1, { diagnosticMessage: K, errorNode: B, typeName: e.getNameOfDeclaration(B.parent.parent) };
              }
              function f() {
                return { diagnosticMessage: e.Diagnostics.Import_declaration_0_is_using_private_name_1, errorNode: B, typeName: B.name };
              }
              function T(K) {
                return { diagnosticMessage: K.errorModuleName ? e.Diagnostics.Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2 : e.Diagnostics.Exported_type_alias_0_has_or_is_using_private_name_1, errorNode: e.isJSDocTypeAlias(B) ? e.Debug.checkDefined(B.typeExpression) : B.type, typeName: e.isJSDocTypeAlias(B) ? e.getNameOfDeclaration(B) : B.name };
              }
            }
            e.createGetSymbolAccessibilityDiagnosticForNode = w;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(f, T, K) {
              var b = f.getCompilerOptions(), se = e.transformNodes(T, f, e.factory, b, K ? [K] : e.filter(f.getSourceFiles(), e.isSourceFileNotJson), [E], false);
              return se.diagnostics;
            }
            e.getDeclarationDiagnostics = a;
            function C(f, T) {
              var K = T.text.substring(f.pos, f.end);
              return e.stringContains(K, "@internal");
            }
            function w(f, T) {
              var K = e.getParseTreeNode(f);
              if (K && K.kind === 164) {
                var b = K.parent.parameters.indexOf(K), se = b > 0 ? K.parent.parameters[b - 1] : void 0, J = T.text, ie = se ? e.concatenate(e.getTrailingCommentRanges(J, e.skipTrivia(J, se.end + 1, false, true)), e.getLeadingCommentRanges(J, f.pos)) : e.getTrailingCommentRanges(J, e.skipTrivia(J, f.pos, false, true));
                return ie && ie.length && C(e.last(ie), T);
              }
              var R = K && e.getLeadingCommentRangesOfNode(K, T);
              return !!e.forEach(R, function(q) {
                return C(q, T);
              });
            }
            e.isInternalDeclaration = w;
            var B = 531469;
            function E(f) {
              var T = function() {
                return e.Debug.fail("Diagnostic emitted without context");
              }, K = T, b = true, se = false, J = false, ie = false, R = false, q, O, ve, ee, he, F, x = f.factory, X = f.getEmitHost(), $ = { trackSymbol: fe, reportInaccessibleThisError: Fe, reportInaccessibleUniqueSymbolError: ue, reportCyclicStructureError: We, reportPrivateInBaseOfClassExpression: g, reportLikelyUnsafeImportRequiredError: Z, reportTruncationError: Be, moduleResolverHost: X, trackReferencedAmbientModule: l, trackExternalModuleSymbolOfImportTypeNode: D, reportNonlocalAugmentation: ge, reportNonSerializableProperty: Re }, A, y, V, L, P, k, Y = f.getEmitResolver(), U = f.getCompilerOptions(), j = U.noResolve, H = U.stripInternal;
              return Ee;
              function I(_r) {
                if (!!_r) {
                  O = O || new e.Set();
                  for (var pi = 0, ae = _r; pi < ae.length; pi++) {
                    var Xe = ae[pi];
                    O.add(Xe);
                  }
                }
              }
              function l(_r, pi) {
                var ae = Y.getTypeReferenceDirectivesForSymbol(pi, 67108863);
                if (e.length(ae)) return I(ae);
                var Xe = e.getSourceFileOfNode(_r);
                L.set(e.getOriginalNodeId(Xe), Xe);
              }
              function d(_r) {
                if (_r.accessibility === 0) {
                  if (_r && _r.aliasesToMakeVisible) if (!ve) ve = _r.aliasesToMakeVisible;
                  else for (var pi = 0, ae = _r.aliasesToMakeVisible; pi < ae.length; pi++) {
                    var Xe = ae[pi];
                    e.pushIfUnique(ve, Xe);
                  }
                } else {
                  var Jr = K(_r);
                  if (Jr) return Jr.typeName ? f.addDiagnostic(e.createDiagnosticForNode(_r.errorNode || Jr.errorNode, Jr.diagnosticMessage, e.getTextOfNode(Jr.typeName), _r.errorSymbolName, _r.errorModuleName)) : f.addDiagnostic(e.createDiagnosticForNode(_r.errorNode || Jr.errorNode, Jr.diagnosticMessage, _r.errorSymbolName, _r.errorModuleName)), true;
                }
                return false;
              }
              function D(_r) {
                se || (F || (F = [])).push(_r);
              }
              function fe(_r, pi, ae) {
                if (_r.flags & 262144) return false;
                var Xe = d(Y.isSymbolAccessible(_r, pi, ae, true));
                return I(Y.getTypeReferenceDirectivesForSymbol(_r, ae)), Xe;
              }
              function g(_r) {
                (A || y) && f.addDiagnostic(e.createDiagnosticForNode(A || y, e.Diagnostics.Property_0_of_exported_class_expression_may_not_be_private_or_protected, _r));
              }
              function ne() {
                return A ? e.declarationNameToString(A) : y && e.getNameOfDeclaration(y) ? e.declarationNameToString(e.getNameOfDeclaration(y)) : y && e.isExportAssignment(y) ? y.isExportEquals ? "export=" : "default" : "(Missing)";
              }
              function ue() {
                (A || y) && f.addDiagnostic(e.createDiagnosticForNode(A || y, e.Diagnostics.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary, ne(), "unique symbol"));
              }
              function We() {
                (A || y) && f.addDiagnostic(e.createDiagnosticForNode(A || y, e.Diagnostics.The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialized_A_type_annotation_is_necessary, ne()));
              }
              function Fe() {
                (A || y) && f.addDiagnostic(e.createDiagnosticForNode(A || y, e.Diagnostics.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary, ne(), "this"));
              }
              function Z(_r) {
                (A || y) && f.addDiagnostic(e.createDiagnosticForNode(A || y, e.Diagnostics.The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary, ne(), _r));
              }
              function Be() {
                (A || y) && f.addDiagnostic(e.createDiagnosticForNode(A || y, e.Diagnostics.The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_type_annotation_is_needed));
              }
              function ge(_r, pi, ae) {
                var Xe, Jr = (Xe = pi.declarations) === null || Xe === void 0 ? void 0 : Xe.find(function(Wr) {
                  return e.getSourceFileOfNode(Wr) === _r;
                }), ti = e.filter(ae.declarations, function(Wr) {
                  return e.getSourceFileOfNode(Wr) !== _r;
                });
                if (ti) for (var Ze = 0, Sr = ti; Ze < Sr.length; Ze++) {
                  var zr = Sr[Ze];
                  f.addDiagnostic(e.addRelatedInfo(e.createDiagnosticForNode(zr, e.Diagnostics.Declaration_augments_declaration_in_another_file_This_cannot_be_serialized), e.createDiagnosticForNode(Jr, e.Diagnostics.This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_file)));
                }
              }
              function Re(_r) {
                (A || y) && f.addDiagnostic(e.createDiagnosticForNode(A || y, e.Diagnostics.The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized, _r));
              }
              function ze(_r, pi) {
                var ae = K;
                K = function(Jr) {
                  return Jr.errorNode && e.canProduceDiagnostics(Jr.errorNode) ? e.createGetSymbolAccessibilityDiagnosticForNode(Jr.errorNode)(Jr) : { diagnosticMessage: Jr.errorModuleName ? e.Diagnostics.Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotation_may_unblock_declaration_emit : e.Diagnostics.Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_declaration_emit, errorNode: Jr.errorNode || _r };
                };
                var Xe = Y.getDeclarationStatementsForSourceFile(_r, B, $, pi);
                return K = ae, Xe;
              }
              function Ee(_r) {
                if (_r.kind === 305 && _r.isDeclarationFile) return _r;
                if (_r.kind === 306) {
                  se = true, L = new e.Map(), P = new e.Map();
                  var pi = false, ae = x.createBundle(e.map(_r.sourceFiles, function(Oe) {
                    if (!Oe.isDeclarationFile) {
                      if (pi = pi || Oe.hasNoDefaultLib, V = Oe, q = Oe, ve = void 0, he = false, ee = new e.Map(), K = T, ie = false, R = false, He(Oe, L), rr(Oe, P), e.isExternalOrCommonJsModule(Oe) || e.isJsonSourceFile(Oe)) {
                        J = false, b = false;
                        var nr = e.isSourceFileJS(Oe) ? x.createNodeArray(ze(Oe, true)) : e.visitNodes(Oe.statements, Ur), Mr = x.updateSourceFile(Oe, [x.createModuleDeclaration([], [x.createModifier(135)], x.createStringLiteral(e.getResolvedExternalModuleName(f.getEmitHost(), Oe)), x.createModuleBlock(e.setTextRange(x.createNodeArray(yr(nr)), Oe.statements)))], true, [], [], false, []);
                        return Mr;
                      }
                      b = true;
                      var Pe = e.isSourceFileJS(Oe) ? x.createNodeArray(ze(Oe)) : e.visitNodes(Oe.statements, Ur);
                      return x.updateSourceFile(Oe, yr(Pe), true, [], [], false, []);
                    }
                  }), e.mapDefined(_r.prepends, function(Oe) {
                    if (Oe.kind === 308) {
                      var nr = e.createUnparsedSourceFile(Oe, "dts", H);
                      return pi = pi || !!nr.hasNoDefaultLib, He(nr, L), I(e.map(nr.typeReferenceDirectives, function(Mr) {
                        return [Mr.fileName, Mr.resolutionMode];
                      })), rr(nr, P), nr;
                    }
                    return Oe;
                  }));
                  ae.syntheticFileReferences = [], ae.syntheticTypeReferences = vr(), ae.syntheticLibReferences = xe(), ae.hasNoDefaultLib = pi;
                  var Xe = e.getDirectoryPath(e.normalizeSlashes(e.getOutputPathsFor(_r, X, true).declarationFilePath)), Jr = Ar(ae.syntheticFileReferences, Xe);
                  return L.forEach(Jr), ae;
                }
                b = true, ie = false, R = false, q = _r, V = _r, K = T, se = false, J = false, he = false, ve = void 0, ee = new e.Map(), O = void 0, L = He(V, new e.Map()), P = rr(V, new e.Map());
                var ti = [], Ze = e.getDirectoryPath(e.normalizeSlashes(e.getOutputPathsFor(_r, X, true).declarationFilePath)), Sr = Ar(ti, Ze), zr;
                if (e.isSourceFileJS(V)) zr = x.createNodeArray(ze(_r)), L.forEach(Sr), k = e.filter(zr, e.isAnyImportSyntax);
                else {
                  var Wr = e.visitNodes(_r.statements, Ur);
                  zr = e.setTextRange(x.createNodeArray(yr(Wr)), _r.statements), L.forEach(Sr), k = e.filter(zr, e.isAnyImportSyntax), e.isExternalModule(_r) && (!J || ie && !R) && (zr = e.setTextRange(x.createNodeArray(Ve(Ve([], zr, true), [e.createEmptyExports(x)], false)), zr));
                }
                var Je = x.updateSourceFile(_r, zr, true, ti, vr(), _r.hasNoDefaultLib, xe());
                return Je.exportedModulesFromDeclarationEmit = F, Je;
                function xe() {
                  return e.map(e.arrayFrom(P.keys()), function(Oe) {
                    return { fileName: Oe, pos: -1, end: -1 };
                  });
                }
                function vr() {
                  return O ? e.mapDefined(e.arrayFrom(O.keys()), mr) : [];
                }
                function mr(Oe) {
                  var nr = Oe[0], Mr = Oe[1];
                  if (k) for (var Pe = 0, Ue = k; Pe < Ue.length; Pe++) {
                    var fr = Ue[Pe];
                    if (e.isImportEqualsDeclaration(fr) && e.isExternalModuleReference(fr.moduleReference)) {
                      var De = fr.moduleReference.expression;
                      if (e.isStringLiteralLike(De) && De.text === nr) return;
                    } else if (e.isImportDeclaration(fr) && e.isStringLiteral(fr.moduleSpecifier) && fr.moduleSpecifier.text === nr) return;
                  }
                  return Ke({ fileName: nr, pos: -1, end: -1 }, Mr ? { resolutionMode: Mr } : void 0);
                }
                function Ar(Oe, nr) {
                  return function(Mr) {
                    var Pe;
                    if (Mr.isDeclarationFile) Pe = Mr.fileName;
                    else {
                      if (se && e.contains(_r.sourceFiles, Mr)) return;
                      var Ue = e.getOutputPathsFor(Mr, X, true);
                      Pe = Ue.declarationFilePath || Ue.jsFilePath || Mr.fileName;
                    }
                    if (Pe) {
                      var fr = e.moduleSpecifiers.getModuleSpecifier(U, V, e.toPath(nr, X.getCurrentDirectory(), X.getCanonicalFileName), e.toPath(Pe, X.getCurrentDirectory(), X.getCanonicalFileName), X);
                      if (!e.pathIsRelative(fr)) {
                        I([[fr, void 0]]);
                        return;
                      }
                      var De = e.getRelativePathToDirectoryOrUrl(nr, Pe, X.getCurrentDirectory(), X.getCanonicalFileName, false);
                      if (e.startsWith(De, "./") && e.hasExtension(De) && (De = De.substring(2)), e.startsWith(De, "node_modules/") || e.pathContainsNodeModules(De)) return;
                      Oe.push({ pos: -1, end: -1, fileName: De });
                    }
                  };
                }
              }
              function He(_r, pi) {
                return j || !e.isUnparsedSource(_r) && e.isSourceFileJS(_r) || e.forEach(_r.referencedFiles, function(ae) {
                  var Xe = X.getSourceFileFromReference(_r, ae);
                  Xe && pi.set(e.getOriginalNodeId(Xe), Xe);
                }), pi;
              }
              function rr(_r, pi) {
                return e.forEach(_r.libReferenceDirectives, function(ae) {
                  var Xe = X.getLibFileFromReference(ae);
                  Xe && pi.set(e.toFileNameLowerCase(ae.fileName), true);
                }), pi;
              }
              function Ie(_r) {
                if (_r.kind === 79) return _r;
                return _r.kind === 202 ? x.updateArrayBindingPattern(_r, e.visitNodes(_r.elements, pi)) : x.updateObjectBindingPattern(_r, e.visitNodes(_r.elements, pi));
                function pi(ae) {
                  return ae.kind === 227 ? ae : x.updateBindingElement(ae, ae.dotDotDotToken, ae.propertyName, Ie(ae.name), we(ae) ? ae.initializer : void 0);
                }
              }
              function _e(_r, pi, ae) {
                var Xe;
                he || (Xe = K, K = e.createGetSymbolAccessibilityDiagnosticForNode(_r));
                var Jr = x.updateParameterDeclaration(_r, void 0, le(_r, pi), _r.dotDotDotToken, Ie(_r.name), Y.isOptionalParameter(_r) ? _r.questionToken || x.createToken(57) : void 0, ye(_r, ae || _r.type, true), de(_r));
                return he || (K = Xe), Jr;
              }
              function we(_r) {
                return m(_r) && Y.isLiteralConstDeclaration(e.getParseTreeNode(_r));
              }
              function de(_r) {
                if (we(_r)) return Y.createLiteralConstValue(e.getParseTreeNode(_r), $);
              }
              function ye(_r, pi, ae) {
                if (!ae && e.hasEffectiveModifier(_r, 8) || we(_r)) return;
                var Xe = _r.kind === 164 && (Y.isRequiredInitializedParameter(_r) || Y.isOptionalUninitializedParameterProperty(_r));
                if (pi && !Xe) return e.visitNode(pi, Ir);
                if (!e.getParseTreeNode(_r)) return pi ? e.visitNode(pi, Ir) : x.createKeywordTypeNode(130);
                if (_r.kind === 173) return x.createKeywordTypeNode(130);
                A = _r.name;
                var Jr;
                if (he || (Jr = K, K = e.createGetSymbolAccessibilityDiagnosticForNode(_r)), _r.kind === 254 || _r.kind === 203) return ti(Y.createTypeOfDeclaration(_r, q, B, $));
                if (_r.kind === 164 || _r.kind === 167 || _r.kind === 166) return _r.initializer ? ti(Y.createTypeOfDeclaration(_r, q, B, $, Xe) || Y.createTypeOfExpression(_r.initializer, q, B, $)) : ti(Y.createTypeOfDeclaration(_r, q, B, $, Xe));
                return ti(Y.createReturnTypeOfSignatureDeclaration(_r, q, B, $));
                function ti(Ze) {
                  return A = void 0, he || (K = Jr), Ze || x.createKeywordTypeNode(130);
                }
              }
              function Ae(_r) {
                switch (_r = e.getParseTreeNode(_r), _r.kind) {
                  case 256:
                  case 261:
                  case 258:
                  case 257:
                  case 259:
                  case 260:
                    return !Y.isDeclarationVisible(_r);
                  case 254:
                    return !ir(_r);
                  case 265:
                  case 266:
                  case 272:
                  case 271:
                    return false;
                  case 170:
                    return true;
                }
                return false;
              }
              function er(_r) {
                var pi;
                if (_r.body) return true;
                var ae = (pi = _r.symbol.declarations) === null || pi === void 0 ? void 0 : pi.filter(function(Xe) {
                  return e.isFunctionDeclaration(Xe) && !Xe.body;
                });
                return !ae || ae.indexOf(_r) === ae.length - 1;
              }
              function ir(_r) {
                return e.isOmittedExpression(_r) ? false : e.isBindingPattern(_r.name) ? e.some(_r.name.elements, ir) : Y.isDeclarationVisible(_r);
              }
              function Cr(_r, pi, ae) {
                if (!e.hasEffectiveModifier(_r, 8)) {
                  var Xe = e.map(pi, function(Jr) {
                    return _e(Jr, ae);
                  });
                  if (!!Xe) return x.createNodeArray(Xe, pi.hasTrailingComma);
                }
              }
              function Ye(_r, pi) {
                var ae;
                if (!pi) {
                  var Xe = e.getThisParameter(_r);
                  Xe && (ae = [_e(Xe)]);
                }
                if (e.isSetAccessorDeclaration(_r)) {
                  var Jr = void 0;
                  if (!pi) {
                    var ti = e.getSetAccessorValueParameter(_r);
                    if (ti) {
                      var Ze = Wt(_r, Y.getAllAccessorDeclarations(_r));
                      Jr = _e(ti, void 0, Ze);
                    }
                  }
                  Jr || (Jr = x.createParameterDeclaration(void 0, void 0, void 0, "value")), ae = e.append(ae, Jr);
                }
                return x.createNodeArray(ae || e.emptyArray);
              }
              function Br(_r, pi) {
                return e.hasEffectiveModifier(_r, 8) ? void 0 : e.visitNodes(pi, Ir);
              }
              function Er(_r) {
                return e.isSourceFile(_r) || e.isTypeAliasDeclaration(_r) || e.isModuleDeclaration(_r) || e.isClassDeclaration(_r) || e.isInterfaceDeclaration(_r) || e.isFunctionLike(_r) || e.isIndexSignatureDeclaration(_r) || e.isMappedTypeNode(_r);
              }
              function Ne(_r, pi) {
                var ae = Y.isEntityNameVisible(_r, pi);
                d(ae), I(Y.getTypeReferenceDirectivesForEntityName(_r));
              }
              function n(_r, pi) {
                return e.hasJSDocNodes(_r) && e.hasJSDocNodes(pi) && (_r.jsDoc = pi.jsDoc), e.setCommentRange(_r, e.getCommentRange(pi));
              }
              function lr(_r, pi) {
                if (!!pi) {
                  if (J = J || _r.kind !== 261 && _r.kind !== 200, e.isStringLiteralLike(pi)) if (se) {
                    var ae = e.getExternalModuleNameFromDeclaration(f.getEmitHost(), Y, _r);
                    if (ae) return x.createStringLiteral(ae);
                  } else {
                    var Xe = Y.getSymbolOfExternalModuleSpecifier(pi);
                    Xe && (F || (F = [])).push(Xe);
                  }
                  return pi;
                }
              }
              function be(_r) {
                if (!!Y.isDeclarationVisible(_r)) if (_r.moduleReference.kind === 277) {
                  var pi = e.getExternalModuleImportEqualsDeclarationExpression(_r);
                  return x.updateImportEqualsDeclaration(_r, void 0, _r.modifiers, _r.isTypeOnly, _r.name, x.updateExternalModuleReference(_r.moduleReference, lr(_r, pi)));
                } else {
                  var ae = K;
                  return K = e.createGetSymbolAccessibilityDiagnosticForNode(_r), Ne(_r.moduleReference, q), K = ae, _r;
                }
              }
              function Ge(_r) {
                if (!_r.importClause) return x.updateImportDeclaration(_r, void 0, _r.modifiers, _r.importClause, lr(_r, _r.moduleSpecifier), ur(_r.assertClause));
                var pi = _r.importClause && _r.importClause.name && Y.isDeclarationVisible(_r.importClause) ? _r.importClause.name : void 0;
                if (!_r.importClause.namedBindings) return pi && x.updateImportDeclaration(_r, void 0, _r.modifiers, x.updateImportClause(_r.importClause, _r.importClause.isTypeOnly, pi, void 0), lr(_r, _r.moduleSpecifier), ur(_r.assertClause));
                if (_r.importClause.namedBindings.kind === 268) {
                  var ae = Y.isDeclarationVisible(_r.importClause.namedBindings) ? _r.importClause.namedBindings : void 0;
                  return pi || ae ? x.updateImportDeclaration(_r, void 0, _r.modifiers, x.updateImportClause(_r.importClause, _r.importClause.isTypeOnly, pi, ae), lr(_r, _r.moduleSpecifier), ur(_r.assertClause)) : void 0;
                }
                var Xe = e.mapDefined(_r.importClause.namedBindings.elements, function(Jr) {
                  return Y.isDeclarationVisible(Jr) ? Jr : void 0;
                });
                if (Xe && Xe.length || pi) return x.updateImportDeclaration(_r, void 0, _r.modifiers, x.updateImportClause(_r.importClause, _r.importClause.isTypeOnly, pi, Xe && Xe.length ? x.updateNamedImports(_r.importClause.namedBindings, Xe) : void 0), lr(_r, _r.moduleSpecifier), ur(_r.assertClause));
                if (Y.isImportRequiredByAugmentation(_r)) return x.updateImportDeclaration(_r, void 0, _r.modifiers, void 0, lr(_r, _r.moduleSpecifier), ur(_r.assertClause));
              }
              function ur(_r) {
                var pi = e.getResolutionModeOverrideForClause(_r);
                if (pi !== void 0) return e.isNightly() || f.addDiagnostic(e.createDiagnosticForNode(_r, e.Diagnostics.Resolution_mode_assertions_are_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next)), _r;
              }
              function yr(_r) {
                for (; e.length(ve); ) {
                  var pi = ve.shift();
                  if (!e.isLateVisibilityPaintedStatement(pi)) return e.Debug.fail("Late replaced statement was found which is not handled by the declaration transformer!: ".concat(e.SyntaxKind ? e.SyntaxKind[pi.kind] : pi.kind));
                  var ae = b;
                  b = pi.parent && e.isSourceFile(pi.parent) && !(e.isExternalModule(pi.parent) && se);
                  var Xe = mi(pi);
                  b = ae, ee.set(e.getOriginalNodeId(pi), Xe);
                }
                return e.visitNodes(_r, Jr);
                function Jr(ti) {
                  if (e.isLateVisibilityPaintedStatement(ti)) {
                    var Ze = e.getOriginalNodeId(ti);
                    if (ee.has(Ze)) {
                      var Sr = ee.get(Ze);
                      return ee.delete(Ze), Sr && ((e.isArray(Sr) ? e.some(Sr, e.needsScopeMarker) : e.needsScopeMarker(Sr)) && (ie = true), e.isSourceFile(ti.parent) && (e.isArray(Sr) ? e.some(Sr, e.isExternalModuleIndicator) : e.isExternalModuleIndicator(Sr)) && (J = true)), Sr;
                    }
                  }
                  return ti;
                }
              }
              function Ir(_r) {
                if (Di(_r) || e.isDeclaration(_r) && (Ae(_r) || e.hasDynamicName(_r) && !Y.isLateBound(e.getParseTreeNode(_r))) || e.isFunctionLike(_r) && Y.isImplementationOfOverload(_r) || e.isSemicolonClassElement(_r)) return;
                var pi;
                Er(_r) && (pi = q, q = _r);
                var ae = K, Xe = e.canProduceDiagnostics(_r), Jr = he, ti = (_r.kind === 182 || _r.kind === 195) && _r.parent.kind !== 259;
                if ((e.isMethodDeclaration(_r) || e.isMethodSignature(_r)) && e.hasEffectiveModifier(_r, 8)) return _r.symbol && _r.symbol.declarations && _r.symbol.declarations[0] !== _r ? void 0 : Oe(x.createPropertyDeclaration(void 0, et(_r), _r.name, void 0, void 0, void 0));
                if (Xe && !he && (K = e.createGetSymbolAccessibilityDiagnosticForNode(_r)), e.isTypeQueryNode(_r) && Ne(_r.exprName, q), ti && (he = true), oe(_r)) switch (_r.kind) {
                  case 228: {
                    (e.isEntityName(_r.expression) || e.isEntityNameExpression(_r.expression)) && Ne(_r.expression, q);
                    var Ze = e.visitEachChild(_r, Ir, f);
                    return Oe(x.updateExpressionWithTypeArguments(Ze, Ze.expression, Ze.typeArguments));
                  }
                  case 178: {
                    Ne(_r.typeName, q);
                    var Ze = e.visitEachChild(_r, Ir, f);
                    return Oe(x.updateTypeReferenceNode(Ze, Ze.typeName, Ze.typeArguments));
                  }
                  case 175:
                    return Oe(x.updateConstructSignature(_r, Br(_r, _r.typeParameters), Cr(_r, _r.parameters), ye(_r, _r.type)));
                  case 171: {
                    var Sr = x.createConstructorDeclaration(void 0, et(_r), Cr(_r, _r.parameters, 0), void 0);
                    return Oe(Sr);
                  }
                  case 169: {
                    if (e.isPrivateIdentifier(_r.name)) return Oe(void 0);
                    var zr = x.createMethodDeclaration(void 0, et(_r), void 0, _r.name, _r.questionToken, Br(_r, _r.typeParameters), Cr(_r, _r.parameters), ye(_r, _r.type), void 0);
                    return Oe(zr);
                  }
                  case 172: {
                    if (e.isPrivateIdentifier(_r.name)) return Oe(void 0);
                    var Wr = Wt(_r, Y.getAllAccessorDeclarations(_r));
                    return Oe(x.updateGetAccessorDeclaration(_r, void 0, et(_r), _r.name, Ye(_r, e.hasEffectiveModifier(_r, 8)), ye(_r, Wr), void 0));
                  }
                  case 173:
                    return e.isPrivateIdentifier(_r.name) ? Oe(void 0) : Oe(x.updateSetAccessorDeclaration(_r, void 0, et(_r), _r.name, Ye(_r, e.hasEffectiveModifier(_r, 8)), void 0));
                  case 167:
                    return e.isPrivateIdentifier(_r.name) ? Oe(void 0) : Oe(x.updatePropertyDeclaration(_r, void 0, et(_r), _r.name, _r.questionToken, ye(_r, _r.type), de(_r)));
                  case 166:
                    return e.isPrivateIdentifier(_r.name) ? Oe(void 0) : Oe(x.updatePropertySignature(_r, et(_r), _r.name, _r.questionToken, ye(_r, _r.type)));
                  case 168:
                    return e.isPrivateIdentifier(_r.name) ? Oe(void 0) : Oe(x.updateMethodSignature(_r, et(_r), _r.name, _r.questionToken, Br(_r, _r.typeParameters), Cr(_r, _r.parameters), ye(_r, _r.type)));
                  case 174:
                    return Oe(x.updateCallSignature(_r, Br(_r, _r.typeParameters), Cr(_r, _r.parameters), ye(_r, _r.type)));
                  case 176:
                    return Oe(x.updateIndexSignature(_r, void 0, et(_r), Cr(_r, _r.parameters), e.visitNode(_r.type, Ir) || x.createKeywordTypeNode(130)));
                  case 254:
                    return e.isBindingPattern(_r.name) ? or(_r.name) : (ti = true, he = true, Oe(x.updateVariableDeclaration(_r, _r.name, void 0, ye(_r, _r.type), de(_r))));
                  case 163:
                    return wr(_r) && (_r.default || _r.constraint) ? Oe(x.updateTypeParameterDeclaration(_r, _r.modifiers, _r.name, void 0, void 0)) : Oe(e.visitEachChild(_r, Ir, f));
                  case 189: {
                    var Je = e.visitNode(_r.checkType, Ir), xe = e.visitNode(_r.extendsType, Ir), vr = q;
                    q = _r.trueType;
                    var mr = e.visitNode(_r.trueType, Ir);
                    q = vr;
                    var Ar = e.visitNode(_r.falseType, Ir);
                    return Oe(x.updateConditionalTypeNode(_r, Je, xe, mr, Ar));
                  }
                  case 179:
                    return Oe(x.updateFunctionTypeNode(_r, e.visitNodes(_r.typeParameters, Ir), Cr(_r, _r.parameters), e.visitNode(_r.type, Ir)));
                  case 180:
                    return Oe(x.updateConstructorTypeNode(_r, et(_r), e.visitNodes(_r.typeParameters, Ir), Cr(_r, _r.parameters), e.visitNode(_r.type, Ir)));
                  case 200:
                    return e.isLiteralImportTypeNode(_r) ? Oe(x.updateImportTypeNode(_r, x.updateLiteralTypeNode(_r.argument, lr(_r, _r.argument.literal)), _r.assertions, _r.qualifier, e.visitNodes(_r.typeArguments, Ir, e.isTypeNode), _r.isTypeOf)) : Oe(_r);
                  default:
                    e.Debug.assertNever(_r, "Attempted to process unhandled node kind: ".concat(e.SyntaxKind[_r.kind]));
                }
                return e.isTupleTypeNode(_r) && e.getLineAndCharacterOfPosition(V, _r.pos).line === e.getLineAndCharacterOfPosition(V, _r.end).line && e.setEmitFlags(_r, 1), Oe(e.visitEachChild(_r, Ir, f));
                function Oe(nr) {
                  return nr && Xe && e.hasDynamicName(_r) && si(_r), Er(_r) && (q = pi), Xe && !he && (K = ae), ti && (he = Jr), nr === _r ? nr : nr && e.setOriginalNode(n(nr, _r), _r);
                }
              }
              function wr(_r) {
                return _r.parent.kind === 169 && e.hasEffectiveModifier(_r.parent, 8);
              }
              function Ur(_r) {
                if (!!G(_r) && !Di(_r)) {
                  switch (_r.kind) {
                    case 272:
                      return e.isSourceFile(_r.parent) && (J = true), R = true, x.updateExportDeclaration(_r, void 0, _r.modifiers, _r.isTypeOnly, _r.exportClause, lr(_r, _r.moduleSpecifier), e.getResolutionModeOverrideForClause(_r.assertClause) ? _r.assertClause : void 0);
                    case 271: {
                      if (e.isSourceFile(_r.parent) && (J = true), R = true, _r.expression.kind === 79) return _r;
                      var pi = x.createUniqueName("_default", 16);
                      K = function() {
                        return { diagnosticMessage: e.Diagnostics.Default_export_of_the_module_has_or_is_using_private_name_0, errorNode: _r };
                      }, y = _r;
                      var ae = x.createVariableDeclaration(pi, void 0, Y.createTypeOfExpression(_r.expression, _r, B, $), void 0);
                      y = void 0;
                      var Xe = x.createVariableStatement(b ? [x.createModifier(135)] : [], x.createVariableDeclarationList([ae], 2));
                      return n(Xe, _r), e.removeAllComments(_r), [Xe, x.updateExportAssignment(_r, _r.decorators, _r.modifiers, pi)];
                    }
                  }
                  var Jr = mi(_r);
                  return ee.set(e.getOriginalNodeId(_r), Jr), _r;
                }
              }
              function ii(_r) {
                if (e.isImportEqualsDeclaration(_r) || e.hasEffectiveModifier(_r, 512) || !e.canHaveModifiers(_r)) return _r;
                var pi = x.createModifiersFromModifierFlags(e.getEffectiveModifierFlags(_r) & 125950);
                return x.updateModifiers(_r, pi);
              }
              function mi(_r) {
                if (ve) for (; e.orderedRemoveItem(ve, _r); ) ;
                if (Di(_r)) return;
                switch (_r.kind) {
                  case 265:
                    return be(_r);
                  case 266:
                    return Ge(_r);
                }
                if (e.isDeclaration(_r) && Ae(_r) || e.isFunctionLike(_r) && Y.isImplementationOfOverload(_r)) return;
                var pi;
                Er(_r) && (pi = q, q = _r);
                var ae = e.canProduceDiagnostics(_r), Xe = K;
                ae && (K = e.createGetSymbolAccessibilityDiagnosticForNode(_r));
                var Jr = b;
                switch (_r.kind) {
                  case 259:
                    return Ii(x.updateTypeAliasDeclaration(_r, void 0, et(_r), _r.name, e.visitNodes(_r.typeParameters, Ir, e.isTypeParameterDeclaration), e.visitNode(_r.type, Ir, e.isTypeNode)));
                  case 258:
                    return Ii(x.updateInterfaceDeclaration(_r, void 0, et(_r), _r.name, Br(_r, _r.typeParameters), Zt(_r.heritageClauses), e.visitNodes(_r.members, Ir)));
                  case 256: {
                    var ti = Ii(x.updateFunctionDeclaration(_r, void 0, et(_r), void 0, _r.name, Br(_r, _r.typeParameters), Cr(_r, _r.parameters), ye(_r, _r.type), void 0));
                    if (ti && Y.isExpandoFunctionDeclaration(_r) && er(_r)) {
                      var Ze = Y.getPropertiesOfContainerFunction(_r), Sr = e.parseNodeFactory.createModuleDeclaration(void 0, void 0, ti.name || x.createIdentifier("_default"), x.createModuleBlock([]), 16);
                      e.setParent(Sr, q), Sr.locals = e.createSymbolTable(Ze), Sr.symbol = Ze[0].parent;
                      var zr = [], Wr = e.mapDefined(Ze, function(Ki) {
                        if (!(!Ki.valueDeclaration || !e.isPropertyAccessExpression(Ki.valueDeclaration))) {
                          K = e.createGetSymbolAccessibilityDiagnosticForNode(Ki.valueDeclaration);
                          var Fi = Y.createTypeOfDeclaration(Ki.valueDeclaration, Sr, B, $);
                          K = Xe;
                          var ui = e.unescapeLeadingUnderscores(Ki.escapedName), Bt = e.isStringANonContextualKeyword(ui), wt = Bt ? x.getGeneratedNameForNode(Ki.valueDeclaration) : x.createIdentifier(ui);
                          Bt && zr.push([wt, ui]);
                          var na = x.createVariableDeclaration(wt, void 0, Fi, void 0);
                          return x.createVariableStatement(Bt ? void 0 : [x.createToken(93)], x.createVariableDeclarationList([na]));
                        }
                      });
                      zr.length ? Wr.push(x.createExportDeclaration(void 0, void 0, false, x.createNamedExports(e.map(zr, function(Ki) {
                        var Fi = Ki[0], ui = Ki[1];
                        return x.createExportSpecifier(false, Fi, ui);
                      })))) : Wr = e.mapDefined(Wr, function(Ki) {
                        return x.updateModifiers(Ki, 0);
                      });
                      var Je = x.createModuleDeclaration(void 0, et(_r), _r.name, x.createModuleBlock(Wr), 16);
                      if (!e.hasEffectiveModifier(ti, 512)) return [ti, Je];
                      var xe = x.createModifiersFromModifierFlags(e.getEffectiveModifierFlags(ti) & -514 | 2), vr = x.updateFunctionDeclaration(ti, void 0, xe, void 0, ti.name, ti.typeParameters, ti.parameters, ti.type, void 0), mr = x.updateModuleDeclaration(Je, void 0, xe, Je.name, Je.body), Ar = x.createExportAssignment(void 0, void 0, false, Je.name);
                      return e.isSourceFile(_r.parent) && (J = true), R = true, [vr, mr, Ar];
                    } else return ti;
                  }
                  case 261: {
                    b = false;
                    var Oe = _r.body;
                    if (Oe && Oe.kind === 262) {
                      var nr = ie, Mr = R;
                      R = false, ie = false;
                      var Pe = e.visitNodes(Oe.statements, Ur), Ue = yr(Pe);
                      _r.flags & 16777216 && (ie = false), !e.isGlobalScopeAugmentation(_r) && !Xi(Ue) && !R && (ie ? Ue = x.createNodeArray(Ve(Ve([], Ue, true), [e.createEmptyExports(x)], false)) : Ue = e.visitNodes(Ue, ii));
                      var fr = x.updateModuleBlock(Oe, Ue);
                      b = Jr, ie = nr, R = Mr;
                      var De = et(_r);
                      return Ii(x.updateModuleDeclaration(_r, void 0, De, e.isExternalModuleAugmentation(_r) ? lr(_r, _r.name) : _r.name, fr));
                    } else {
                      b = Jr;
                      var De = et(_r);
                      b = false, e.visitNode(Oe, Ur);
                      var gr = e.getOriginalNodeId(Oe), fr = ee.get(gr);
                      return ee.delete(gr), Ii(x.updateModuleDeclaration(_r, void 0, De, _r.name, fr));
                    }
                  }
                  case 257: {
                    A = _r.name, y = _r;
                    var xe = x.createNodeArray(et(_r)), Vr = Br(_r, _r.typeParameters), Tr = e.getFirstConstructorWithBody(_r), vi = void 0;
                    if (Tr) {
                      var Ui = K;
                      vi = e.compact(e.flatMap(Tr.parameters, function(Fi) {
                        if (!e.hasSyntacticModifier(Fi, 16476) || Di(Fi)) return;
                        if (K = e.createGetSymbolAccessibilityDiagnosticForNode(Fi), Fi.name.kind === 79) return n(x.createPropertyDeclaration(void 0, et(Fi), Fi.name, Fi.questionToken, ye(Fi, Fi.type), de(Fi)), Fi);
                        return ui(Fi.name);
                        function ui(Bt) {
                          for (var wt, na = 0, Ai = Bt.elements; na < Ai.length; na++) {
                            var Oi = Ai[na];
                            e.isOmittedExpression(Oi) || (e.isBindingPattern(Oi.name) && (wt = e.concatenate(wt, ui(Oi.name))), wt = wt || [], wt.push(x.createPropertyDeclaration(void 0, et(Fi), Oi.name, void 0, ye(Oi, void 0), void 0)));
                          }
                          return wt;
                        }
                      })), K = Ui;
                    }
                    var Yi = e.some(_r.members, function(Fi) {
                      return !!Fi.name && e.isPrivateIdentifier(Fi.name);
                    }), Wi = Yi ? [x.createPropertyDeclaration(void 0, void 0, x.createPrivateIdentifier("#private"), void 0, void 0, void 0)] : void 0, ct = e.concatenate(e.concatenate(Wi, vi), e.visitNodes(_r.members, Ir)), Li = x.createNodeArray(ct), nt = e.getEffectiveBaseTypeNode(_r);
                    if (nt && !e.isEntityNameExpression(nt.expression) && nt.expression.kind !== 104) {
                      var Mt = _r.name ? e.unescapeLeadingUnderscores(_r.name.escapedText) : "default", xt = x.createUniqueName("".concat(Mt, "_base"), 16);
                      K = function() {
                        return { diagnosticMessage: e.Diagnostics.extends_clause_of_exported_class_0_has_or_is_using_private_name_1, errorNode: nt, typeName: _r.name };
                      };
                      var ut = x.createVariableDeclaration(xt, void 0, Y.createTypeOfExpression(nt.expression, _r, B, $), void 0), Dt = x.createVariableStatement(b ? [x.createModifier(135)] : [], x.createVariableDeclarationList([ut], 2)), Rt = x.createNodeArray(e.map(_r.heritageClauses, function(Fi) {
                        if (Fi.token === 94) {
                          var ui = K;
                          K = e.createGetSymbolAccessibilityDiagnosticForNode(Fi.types[0]);
                          var Bt = x.updateHeritageClause(Fi, e.map(Fi.types, function(wt) {
                            return x.updateExpressionWithTypeArguments(wt, xt, e.visitNodes(wt.typeArguments, Ir));
                          }));
                          return K = ui, Bt;
                        }
                        return x.updateHeritageClause(Fi, e.visitNodes(x.createNodeArray(e.filter(Fi.types, function(wt) {
                          return e.isEntityNameExpression(wt.expression) || wt.expression.kind === 104;
                        })), Ir));
                      }));
                      return [Dt, Ii(x.updateClassDeclaration(_r, void 0, xe, _r.name, Vr, Rt, Li))];
                    } else {
                      var Rt = Zt(_r.heritageClauses);
                      return Ii(x.updateClassDeclaration(_r, void 0, xe, _r.name, Vr, Rt, Li));
                    }
                  }
                  case 237:
                    return Ii(pe(_r));
                  case 260:
                    return Ii(x.updateEnumDeclaration(_r, void 0, x.createNodeArray(et(_r)), _r.name, x.createNodeArray(e.mapDefined(_r.members, function(Ki) {
                      if (!Di(Ki)) {
                        var Fi = Y.getConstantValue(Ki);
                        return n(x.updateEnumMember(Ki, Ki.name, Fi !== void 0 ? typeof Fi == "string" ? x.createStringLiteral(Fi) : x.createNumericLiteral(Fi) : void 0), Ki);
                      }
                    }))));
                }
                return e.Debug.assertNever(_r, "Unhandled top-level node in declaration emit: ".concat(e.SyntaxKind[_r.kind]));
                function Ii(Ki) {
                  return Er(_r) && (q = pi), ae && (K = Xe), _r.kind === 261 && (b = Jr), Ki === _r ? Ki : (y = void 0, A = void 0, Ki && e.setOriginalNode(n(Ki, _r), _r));
                }
              }
              function pe(_r) {
                if (!!e.forEach(_r.declarationList.declarations, ir)) {
                  var pi = e.visitNodes(_r.declarationList.declarations, Ir);
                  if (!!e.length(pi)) return x.updateVariableStatement(_r, x.createNodeArray(et(_r)), x.updateVariableDeclarationList(_r.declarationList, pi));
                }
              }
              function or(_r) {
                return e.flatten(e.mapDefined(_r.elements, function(pi) {
                  return qr(pi);
                }));
              }
              function qr(_r) {
                if (_r.kind !== 227 && _r.name) return ir(_r) ? e.isBindingPattern(_r.name) ? or(_r.name) : x.createVariableDeclaration(_r.name, void 0, ye(_r, void 0), void 0) : void 0;
              }
              function si(_r) {
                var pi;
                he || (pi = K, K = e.createGetSymbolAccessibilityDiagnosticForNodeName(_r)), A = _r.name, e.Debug.assert(Y.isLateBound(e.getParseTreeNode(_r)));
                var ae = _r, Xe = ae.name.expression;
                Ne(Xe, q), he || (K = pi), A = void 0;
              }
              function Di(_r) {
                return !!H && !!_r && w(_r, V);
              }
              function wi(_r) {
                return e.isExportAssignment(_r) || e.isExportDeclaration(_r);
              }
              function Xi(_r) {
                return e.some(_r, wi);
              }
              function et(_r) {
                var pi = e.getEffectiveModifierFlags(_r), ae = Gi(_r);
                return pi === ae ? _r.modifiers : x.createModifiersFromModifierFlags(ae);
              }
              function Gi(_r) {
                var pi = 109307, ae = b && !Q(_r) ? 2 : 0, Xe = _r.parent.kind === 305;
                return (!Xe || se && Xe && e.isExternalModule(_r.parent)) && (pi ^= 2, ae = 0), N(_r, pi, ae);
              }
              function Wt(_r, pi) {
                var ae = p(_r);
                return !ae && _r !== pi.firstAccessor && (ae = p(pi.firstAccessor), K = e.createGetSymbolAccessibilityDiagnosticForNode(pi.firstAccessor)), !ae && pi.secondAccessor && _r !== pi.secondAccessor && (ae = p(pi.secondAccessor), K = e.createGetSymbolAccessibilityDiagnosticForNode(pi.secondAccessor)), ae;
              }
              function Zt(_r) {
                return x.createNodeArray(e.filter(e.map(_r, function(pi) {
                  return x.updateHeritageClause(pi, e.visitNodes(x.createNodeArray(e.filter(pi.types, function(ae) {
                    return e.isEntityNameExpression(ae.expression) || pi.token === 94 && ae.expression.kind === 104;
                  })), Ir));
                }), function(pi) {
                  return pi.types && !!pi.types.length;
                }));
              }
            }
            e.transformDeclarations = E;
            function Q(f) {
              return f.kind === 258;
            }
            function le(f, T, K) {
              return e.factory.createModifiersFromModifierFlags(N(f, T, K));
            }
            function N(f, T, K) {
              T === void 0 && (T = 125947), K === void 0 && (K = 0);
              var b = e.getEffectiveModifierFlags(f) & T | K;
              return b & 512 && !(b & 1) && (b ^= 1), b & 512 && b & 2 && (b ^= 2), b;
            }
            function p(f) {
              if (f) return f.kind === 172 ? f.type : f.parameters.length > 0 ? f.parameters[0].type : void 0;
            }
            function m(f) {
              switch (f.kind) {
                case 167:
                case 166:
                  return !e.hasEffectiveModifier(f, 8);
                case 164:
                case 254:
                  return true;
              }
              return false;
            }
            function G(f) {
              switch (f.kind) {
                case 256:
                case 261:
                case 265:
                case 258:
                case 257:
                case 259:
                case 260:
                case 237:
                case 266:
                case 272:
                case 271:
                  return true;
              }
              return false;
            }
            function oe(f) {
              switch (f.kind) {
                case 175:
                case 171:
                case 169:
                case 172:
                case 173:
                case 167:
                case 166:
                case 168:
                case 174:
                case 176:
                case 254:
                case 163:
                case 228:
                case 178:
                case 189:
                case 179:
                case 180:
                case 200:
                  return true;
              }
              return false;
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(T) {
              switch (T) {
                case e.ModuleKind.ESNext:
                case e.ModuleKind.ES2022:
                case e.ModuleKind.ES2020:
                case e.ModuleKind.ES2015:
                  return e.transformECMAScriptModule;
                case e.ModuleKind.System:
                  return e.transformSystemModule;
                case e.ModuleKind.Node16:
                case e.ModuleKind.NodeNext:
                  return e.transformNodeModule;
                default:
                  return e.transformModule;
              }
            }
            var C;
            (function(T) {
              T[T.Uninitialized = 0] = "Uninitialized", T[T.Initialized = 1] = "Initialized", T[T.Completed = 2] = "Completed", T[T.Disposed = 3] = "Disposed";
            })(C || (C = {}));
            var w;
            (function(T) {
              T[T.Substitution = 1] = "Substitution", T[T.EmitNotifications = 2] = "EmitNotifications";
            })(w || (w = {})), e.noTransformers = { scriptTransformers: e.emptyArray, declarationTransformers: e.emptyArray };
            function B(T, K, b) {
              return { scriptTransformers: E(T, K, b), declarationTransformers: Q(K) };
            }
            e.getTransformers = B;
            function E(T, K, b) {
              if (b) return e.emptyArray;
              var se = e.getEmitScriptTarget(T), J = e.getEmitModuleKind(T), ie = [];
              return e.addRange(ie, K && e.map(K.before, p)), ie.push(e.transformTypeScript), ie.push(e.transformClassFields), e.getJSXTransformEnabled(T) && ie.push(e.transformJsx), se < 99 && ie.push(e.transformESNext), se < 8 && ie.push(e.transformES2021), se < 7 && ie.push(e.transformES2020), se < 6 && ie.push(e.transformES2019), se < 5 && ie.push(e.transformES2018), se < 4 && ie.push(e.transformES2017), se < 3 && ie.push(e.transformES2016), se < 2 && (ie.push(e.transformES2015), ie.push(e.transformGenerators)), ie.push(a(J)), se < 1 && ie.push(e.transformES5), e.addRange(ie, K && e.map(K.after, p)), ie;
            }
            function Q(T) {
              var K = [];
              return K.push(e.transformDeclarations), e.addRange(K, T && e.map(T.afterDeclarations, m)), K;
            }
            function le(T) {
              return function(K) {
                return e.isBundle(K) ? T.transformBundle(K) : T.transformSourceFile(K);
              };
            }
            function N(T, K) {
              return function(b) {
                var se = T(b);
                return typeof se == "function" ? K(b, se) : le(se);
              };
            }
            function p(T) {
              return N(T, e.chainBundle);
            }
            function m(T) {
              return N(T, function(K, b) {
                return b;
              });
            }
            function G(T, K) {
              return K;
            }
            e.noEmitSubstitution = G;
            function oe(T, K, b) {
              b(T, K);
            }
            e.noEmitNotification = oe;
            function f(T, K, b, se, J, ie, R) {
              for (var q = new Array(355), O, ve, ee, he = 0, F = [], x = [], X = [], $ = [], A = 0, y = false, V = [], L = 0, P, k, Y = G, U = oe, j = 0, H = [], I = { factory: b, getCompilerOptions: function() {
                return se;
              }, getEmitResolver: function() {
                return T;
              }, getEmitHost: function() {
                return K;
              }, getEmitHelperFactory: e.memoize(function() {
                return e.createEmitHelperFactory(I);
              }), startLexicalEnvironment: _e, suspendLexicalEnvironment: we, resumeLexicalEnvironment: de, endLexicalEnvironment: ye, setLexicalEnvironmentFlags: Ae, getLexicalEnvironmentFlags: er, hoistVariableDeclaration: He, hoistFunctionDeclaration: rr, addInitializationStatement: Ie, startBlockScope: ir, endBlockScope: Cr, addBlockScopedVariable: Ye, requestEmitHelper: Br, readEmitHelpers: Er, enableSubstitution: Z, enableEmitNotification: Re, isSubstitutionEnabled: Be, isEmitNotificationEnabled: ze, get onSubstituteNode() {
                return Y;
              }, set onSubstituteNode(n) {
                e.Debug.assert(j < 1, "Cannot modify transformation hooks after initialization has completed."), e.Debug.assert(n !== void 0, "Value must not be 'undefined'"), Y = n;
              }, get onEmitNode() {
                return U;
              }, set onEmitNode(n) {
                e.Debug.assert(j < 1, "Cannot modify transformation hooks after initialization has completed."), e.Debug.assert(n !== void 0, "Value must not be 'undefined'"), U = n;
              }, addDiagnostic: function(n) {
                H.push(n);
              } }, l = 0, d = J; l < d.length; l++) {
                var D = d[l];
                e.disposeEmitNodes(e.getSourceFileOfNode(e.getParseTreeNode(D)));
              }
              e.performance.mark("beforeTransform");
              var fe = ie.map(function(n) {
                return n(I);
              }), g = function(n) {
                for (var lr = 0, be = fe; lr < be.length; lr++) {
                  var Ge = be[lr];
                  n = Ge(n);
                }
                return n;
              };
              j = 1;
              for (var ne = [], ue = 0, We = J; ue < We.length; ue++) {
                var D = We[ue];
                e.tracing === null || e.tracing === void 0 || e.tracing.push("emit", "transformNodes", D.kind === 305 ? { path: D.path } : { kind: D.kind, pos: D.pos, end: D.end }), ne.push((R ? g : Fe)(D)), e.tracing === null || e.tracing === void 0 || e.tracing.pop();
              }
              return j = 2, e.performance.mark("afterTransform"), e.performance.measure("transformTime", "beforeTransform", "afterTransform"), { transformed: ne, substituteNode: ge, emitNodeWithNotification: Ee, isEmitNotificationEnabled: ze, dispose: Ne, diagnostics: H };
              function Fe(n) {
                return n && (!e.isSourceFile(n) || !n.isDeclarationFile) ? g(n) : n;
              }
              function Z(n) {
                e.Debug.assert(j < 2, "Cannot modify the transformation context after transformation has completed."), q[n] |= 1;
              }
              function Be(n) {
                return (q[n.kind] & 1) !== 0 && (e.getEmitFlags(n) & 4) === 0;
              }
              function ge(n, lr) {
                return e.Debug.assert(j < 3, "Cannot substitute a node after the result is disposed."), lr && Be(lr) && Y(n, lr) || lr;
              }
              function Re(n) {
                e.Debug.assert(j < 2, "Cannot modify the transformation context after transformation has completed."), q[n] |= 2;
              }
              function ze(n) {
                return (q[n.kind] & 2) !== 0 || (e.getEmitFlags(n) & 2) !== 0;
              }
              function Ee(n, lr, be) {
                e.Debug.assert(j < 3, "Cannot invoke TransformationResult callbacks after the result is disposed."), lr && (ze(lr) ? U(n, lr, be) : be(n, lr));
              }
              function He(n) {
                e.Debug.assert(j > 0, "Cannot modify the lexical environment during initialization."), e.Debug.assert(j < 2, "Cannot modify the lexical environment after transformation has completed.");
                var lr = e.setEmitFlags(b.createVariableDeclaration(n), 64);
                O ? O.push(lr) : O = [lr], he & 1 && (he |= 2);
              }
              function rr(n) {
                e.Debug.assert(j > 0, "Cannot modify the lexical environment during initialization."), e.Debug.assert(j < 2, "Cannot modify the lexical environment after transformation has completed."), e.setEmitFlags(n, 1048576), ve ? ve.push(n) : ve = [n];
              }
              function Ie(n) {
                e.Debug.assert(j > 0, "Cannot modify the lexical environment during initialization."), e.Debug.assert(j < 2, "Cannot modify the lexical environment after transformation has completed."), e.setEmitFlags(n, 1048576), ee ? ee.push(n) : ee = [n];
              }
              function _e() {
                e.Debug.assert(j > 0, "Cannot modify the lexical environment during initialization."), e.Debug.assert(j < 2, "Cannot modify the lexical environment after transformation has completed."), e.Debug.assert(!y, "Lexical environment is suspended."), F[A] = O, x[A] = ve, X[A] = ee, $[A] = he, A++, O = void 0, ve = void 0, ee = void 0, he = 0;
              }
              function we() {
                e.Debug.assert(j > 0, "Cannot modify the lexical environment during initialization."), e.Debug.assert(j < 2, "Cannot modify the lexical environment after transformation has completed."), e.Debug.assert(!y, "Lexical environment is already suspended."), y = true;
              }
              function de() {
                e.Debug.assert(j > 0, "Cannot modify the lexical environment during initialization."), e.Debug.assert(j < 2, "Cannot modify the lexical environment after transformation has completed."), e.Debug.assert(y, "Lexical environment is not suspended."), y = false;
              }
              function ye() {
                e.Debug.assert(j > 0, "Cannot modify the lexical environment during initialization."), e.Debug.assert(j < 2, "Cannot modify the lexical environment after transformation has completed."), e.Debug.assert(!y, "Lexical environment is suspended.");
                var n;
                if (O || ve || ee) {
                  if (ve && (n = Ve([], ve, true)), O) {
                    var lr = b.createVariableStatement(void 0, b.createVariableDeclarationList(O));
                    e.setEmitFlags(lr, 1048576), n ? n.push(lr) : n = [lr];
                  }
                  ee && (n ? n = Ve(Ve([], n, true), ee, true) : n = Ve([], ee, true));
                }
                return A--, O = F[A], ve = x[A], ee = X[A], he = $[A], A === 0 && (F = [], x = [], X = [], $ = []), n;
              }
              function Ae(n, lr) {
                he = lr ? he | n : he & ~n;
              }
              function er() {
                return he;
              }
              function ir() {
                e.Debug.assert(j > 0, "Cannot start a block scope during initialization."), e.Debug.assert(j < 2, "Cannot start a block scope after transformation has completed."), V[L] = P, L++, P = void 0;
              }
              function Cr() {
                e.Debug.assert(j > 0, "Cannot end a block scope during initialization."), e.Debug.assert(j < 2, "Cannot end a block scope after transformation has completed.");
                var n = e.some(P) ? [b.createVariableStatement(void 0, b.createVariableDeclarationList(P.map(function(lr) {
                  return b.createVariableDeclaration(lr);
                }), 1))] : void 0;
                return L--, P = V[L], L === 0 && (V = []), n;
              }
              function Ye(n) {
                e.Debug.assert(L > 0, "Cannot add a block scoped variable outside of an iteration body."), (P || (P = [])).push(n);
              }
              function Br(n) {
                if (e.Debug.assert(j > 0, "Cannot modify the transformation context during initialization."), e.Debug.assert(j < 2, "Cannot modify the transformation context after transformation has completed."), e.Debug.assert(!n.scoped, "Cannot request a scoped emit helper."), n.dependencies) for (var lr = 0, be = n.dependencies; lr < be.length; lr++) {
                  var Ge = be[lr];
                  Br(Ge);
                }
                k = e.append(k, n);
              }
              function Er() {
                e.Debug.assert(j > 0, "Cannot modify the transformation context during initialization."), e.Debug.assert(j < 2, "Cannot modify the transformation context after transformation has completed.");
                var n = k;
                return k = void 0, n;
              }
              function Ne() {
                if (j < 3) {
                  for (var n = 0, lr = J; n < lr.length; n++) {
                    var be = lr[n];
                    e.disposeEmitNodes(e.getSourceFileOfNode(e.getParseTreeNode(be)));
                  }
                  O = void 0, F = void 0, ve = void 0, x = void 0, Y = void 0, U = void 0, k = void 0, j = 3;
                }
              }
            }
            e.transformNodes = f, e.nullTransformationContext = { factory: e.factory, getCompilerOptions: function() {
              return {};
            }, getEmitResolver: e.notImplemented, getEmitHost: e.notImplemented, getEmitHelperFactory: e.notImplemented, startLexicalEnvironment: e.noop, resumeLexicalEnvironment: e.noop, suspendLexicalEnvironment: e.noop, endLexicalEnvironment: e.returnUndefined, setLexicalEnvironmentFlags: e.noop, getLexicalEnvironmentFlags: function() {
              return 0;
            }, hoistVariableDeclaration: e.noop, hoistFunctionDeclaration: e.noop, addInitializationStatement: e.noop, startBlockScope: e.noop, endBlockScope: e.returnUndefined, addBlockScopedVariable: e.noop, requestEmitHelper: e.noop, readEmitHelpers: e.notImplemented, enableSubstitution: e.noop, enableEmitNotification: e.noop, isSubstitutionEnabled: e.notImplemented, isEmitNotificationEnabled: e.notImplemented, onSubstituteNode: G, onEmitNode: oe, addDiagnostic: e.noop };
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a = x();
            function C(k) {
              return e.fileExtensionIs(k, ".tsbuildinfo");
            }
            e.isBuildInfoFile = C;
            function w(k, Y, U, j, H, I) {
              j === void 0 && (j = false);
              var l = e.isArray(U) ? U : e.getSourceFilesToEmit(k, U, j), d = k.getCompilerOptions();
              if (e.outFile(d)) {
                var D = k.getPrependNodes();
                if (l.length || D.length) {
                  var fe = e.factory.createBundle(l, D), g = Y(Q(fe, k, j), fe);
                  if (g) return g;
                }
              } else {
                if (!H) for (var ne = 0, ue = l; ne < ue.length; ne++) {
                  var We = ue[ne], g = Y(Q(We, k, j), We);
                  if (g) return g;
                }
                if (I) {
                  var Fe = B(d);
                  if (Fe) return Y({ buildInfoPath: Fe }, void 0);
                }
              }
            }
            e.forEachEmittedFile = w;
            function B(k) {
              var Y = k.configFilePath;
              if (!!e.isIncrementalCompilation(k)) {
                if (k.tsBuildInfoFile) return k.tsBuildInfoFile;
                var U = e.outFile(k), j;
                if (U) j = e.removeFileExtension(U);
                else {
                  if (!Y) return;
                  var H = e.removeFileExtension(Y);
                  j = k.outDir ? k.rootDir ? e.resolvePath(k.outDir, e.getRelativePathFromDirectory(k.rootDir, H, true)) : e.combinePaths(k.outDir, e.getBaseFileName(H)) : H;
                }
                return j + ".tsbuildinfo";
              }
            }
            e.getTsBuildInfoEmitOutputFilePath = B;
            function E(k, Y) {
              var U = e.outFile(k), j = k.emitDeclarationOnly ? void 0 : U, H = j && le(j, k), I = Y || e.getEmitDeclarations(k) ? e.removeFileExtension(U) + ".d.ts" : void 0, l = I && e.getAreDeclarationMapsEnabled(k) ? I + ".map" : void 0, d = B(k);
              return { jsFilePath: j, sourceMapFilePath: H, declarationFilePath: I, declarationMapPath: l, buildInfoPath: d };
            }
            e.getOutputPathsForBundle = E;
            function Q(k, Y, U) {
              var j = Y.getCompilerOptions();
              if (k.kind === 306) return E(j, U);
              var H = e.getOwnEmitOutputFilePath(k.fileName, Y, N(k.fileName, j)), I = e.isJsonSourceFile(k), l = I && e.comparePaths(k.fileName, H, Y.getCurrentDirectory(), !Y.useCaseSensitiveFileNames()) === 0, d = j.emitDeclarationOnly || l ? void 0 : H, D = !d || e.isJsonSourceFile(k) ? void 0 : le(d, j), fe = U || e.getEmitDeclarations(j) && !I ? e.getDeclarationEmitOutputFilePath(k.fileName, Y) : void 0, g = fe && e.getAreDeclarationMapsEnabled(j) ? fe + ".map" : void 0;
              return { jsFilePath: d, sourceMapFilePath: D, declarationFilePath: fe, declarationMapPath: g, buildInfoPath: void 0 };
            }
            e.getOutputPathsFor = Q;
            function le(k, Y) {
              return Y.sourceMap && !Y.inlineSourceMap ? k + ".map" : void 0;
            }
            function N(k, Y) {
              return e.fileExtensionIs(k, ".json") ? ".json" : Y.jsx === 1 && e.fileExtensionIsOneOf(k, [".jsx", ".tsx"]) ? ".jsx" : e.fileExtensionIsOneOf(k, [".mts", ".mjs"]) ? ".mjs" : e.fileExtensionIsOneOf(k, [".cts", ".cjs"]) ? ".cjs" : ".js";
            }
            e.getOutputExtension = N;
            function p(k, Y, U, j, H) {
              return j ? e.resolvePath(j, e.getRelativePathFromDirectory(H ? H() : b(Y, U), k, U)) : k;
            }
            function m(k, Y, U, j) {
              return e.changeExtension(p(k, Y, U, Y.options.declarationDir || Y.options.outDir, j), e.getDeclarationEmitExtensionForPath(k));
            }
            e.getOutputDeclarationFileName = m;
            function G(k, Y, U, j) {
              if (!Y.options.emitDeclarationOnly) {
                var H = e.fileExtensionIs(k, ".json"), I = e.changeExtension(p(k, Y, U, Y.options.outDir, j), N(k, Y.options));
                return !H || e.comparePaths(k, I, e.Debug.checkDefined(Y.options.configFilePath), U) !== 0 ? I : void 0;
              }
            }
            function oe() {
              var k;
              return { addOutput: Y, getOutputs: U };
              function Y(j) {
                j && (k || (k = [])).push(j);
              }
              function U() {
                return k || e.emptyArray;
              }
            }
            function f(k, Y) {
              var U = E(k.options, false), j = U.jsFilePath, H = U.sourceMapFilePath, I = U.declarationFilePath, l = U.declarationMapPath, d = U.buildInfoPath;
              Y(j), Y(H), Y(I), Y(l), Y(d);
            }
            function T(k, Y, U, j, H) {
              if (!e.isDeclarationFileName(Y)) {
                var I = G(Y, k, U, H);
                if (j(I), !e.fileExtensionIs(Y, ".json") && (I && k.options.sourceMap && j("".concat(I, ".map")), e.getEmitDeclarations(k.options))) {
                  var l = m(Y, k, U, H);
                  j(l), k.options.declarationMap && j("".concat(l, ".map"));
                }
              }
            }
            function K(k, Y, U, j, H) {
              var I;
              return k.rootDir ? (I = e.getNormalizedAbsolutePath(k.rootDir, U), H == null || H(k.rootDir)) : k.composite && k.configFilePath ? (I = e.getDirectoryPath(e.normalizeSlashes(k.configFilePath)), H == null || H(I)) : I = e.computeCommonSourceDirectoryOfFilenames(Y(), U, j), I && I[I.length - 1] !== e.directorySeparator && (I += e.directorySeparator), I;
            }
            e.getCommonSourceDirectory = K;
            function b(k, Y) {
              var U = k.options, j = k.fileNames;
              return K(U, function() {
                return e.filter(j, function(H) {
                  return !(U.noEmitForJsFiles && e.fileExtensionIsOneOf(H, e.supportedJSExtensionsFlat)) && !e.isDeclarationFileName(H);
                });
              }, e.getDirectoryPath(e.normalizeSlashes(e.Debug.checkDefined(U.configFilePath))), e.createGetCanonicalFileName(!Y));
            }
            e.getCommonSourceDirectoryOfConfig = b;
            function se(k, Y) {
              var U = oe(), j = U.addOutput, H = U.getOutputs;
              if (e.outFile(k.options)) f(k, j);
              else {
                for (var I = e.memoize(function() {
                  return b(k, Y);
                }), l = 0, d = k.fileNames; l < d.length; l++) {
                  var D = d[l];
                  T(k, D, Y, j, I);
                }
                j(B(k.options));
              }
              return H();
            }
            e.getAllProjectOutputs = se;
            function J(k, Y, U) {
              Y = e.normalizePath(Y), e.Debug.assert(e.contains(k.fileNames, Y), "Expected fileName to be present in command line");
              var j = oe(), H = j.addOutput, I = j.getOutputs;
              return e.outFile(k.options) ? f(k, H) : T(k, Y, U, H), I();
            }
            e.getOutputFileNames = J;
            function ie(k, Y) {
              if (e.outFile(k.options)) {
                var U = E(k.options, false).jsFilePath;
                return e.Debug.checkDefined(U, "project ".concat(k.options.configFilePath, " expected to have at least one output"));
              }
              for (var j = e.memoize(function() {
                return b(k, Y);
              }), H = 0, I = k.fileNames; H < I.length; H++) {
                var l = I[H];
                if (!e.isDeclarationFileName(l)) {
                  var U = G(l, k, Y, j);
                  if (U) return U;
                  if (!e.fileExtensionIs(l, ".json") && e.getEmitDeclarations(k.options)) return m(l, k, Y, j);
                }
              }
              var d = B(k.options);
              return d || e.Debug.fail("project ".concat(k.options.configFilePath, " expected to have at least one output"));
            }
            e.getFirstProjectOutput = ie;
            function R(k, Y, U, j, H, I, l) {
              var d = j.scriptTransformers, D = j.declarationTransformers, fe = Y.getCompilerOptions(), g = fe.sourceMap || fe.inlineSourceMap || e.getAreDeclarationMapsEnabled(fe) ? [] : void 0, ne = fe.listEmittedFiles ? [] : void 0, ue = e.createDiagnosticCollection(), We = e.getNewLineCharacter(fe, function() {
                return Y.getNewLine();
              }), Fe = e.createTextWriter(We), Z = e.performance.createTimer("printTime", "beforePrint", "afterPrint"), Be = Z.enter, ge = Z.exit, Re, ze = false, Ee;
              return Be(), w(Y, He, e.getSourceFilesToEmit(Y, U, l), l, I, !U), ge(), { emitSkipped: ze, diagnostics: ue.getDiagnostics(), emittedFiles: ne, sourceMaps: g, exportedModulesFromDeclarationEmit: Ee };
              function He(Cr, Ye) {
                var Br = Cr.jsFilePath, Er = Cr.sourceMapFilePath, Ne = Cr.declarationFilePath, n = Cr.declarationMapPath, lr = Cr.buildInfoPath, be;
                lr && Ye && e.isBundle(Ye) && (be = e.getDirectoryPath(e.getNormalizedAbsolutePath(lr, Y.getCurrentDirectory())), Re = { commonSourceDirectory: Ge(Y.getCommonSourceDirectory()), sourceFiles: Ye.sourceFiles.map(function(ur) {
                  return Ge(e.getNormalizedAbsolutePath(ur.fileName, Y.getCurrentDirectory()));
                }) }), e.tracing === null || e.tracing === void 0 || e.tracing.push("emit", "emitJsFileOrBundle", { jsFilePath: Br }), Ie(Ye, Br, Er, Ge), e.tracing === null || e.tracing === void 0 || e.tracing.pop(), e.tracing === null || e.tracing === void 0 || e.tracing.push("emit", "emitDeclarationFileOrBundle", { declarationFilePath: Ne }), _e(Ye, Ne, n, Ge), e.tracing === null || e.tracing === void 0 || e.tracing.pop(), e.tracing === null || e.tracing === void 0 || e.tracing.push("emit", "emitBuildInfo", { buildInfoPath: lr }), rr(Re, lr), e.tracing === null || e.tracing === void 0 || e.tracing.pop(), !ze && ne && (H || (Br && ne.push(Br), Er && ne.push(Er), lr && ne.push(lr)), Ne && ne.push(Ne), n && ne.push(n));
                function Ge(ur) {
                  return e.ensurePathIsNonModuleName(e.getRelativePathFromDirectory(be, ur, Y.getCanonicalFileName));
                }
              }
              function rr(Cr, Ye) {
                if (!(!Ye || U || ze)) {
                  var Br = Y.getProgramBuildInfo();
                  if (Y.isEmitBlocked(Ye)) {
                    ze = true;
                    return;
                  }
                  var Er = e.version;
                  e.writeFile(Y, ue, Ye, q({ bundle: Cr, program: Br, version: Er }), false);
                }
              }
              function Ie(Cr, Ye, Br, Er) {
                if (!(!Cr || H || !Ye)) {
                  if (Ye && Y.isEmitBlocked(Ye) || fe.noEmit) {
                    ze = true;
                    return;
                  }
                  var Ne = e.transformNodes(k, Y, e.factory, fe, [Cr], d, false), n = { removeComments: fe.removeComments, newLine: fe.newLine, noEmitHelpers: fe.noEmitHelpers, module: fe.module, target: fe.target, sourceMap: fe.sourceMap, inlineSourceMap: fe.inlineSourceMap, inlineSources: fe.inlineSources, extendedDiagnostics: fe.extendedDiagnostics, writeBundleFileInfo: !!Re, relativeToBuildInfo: Er }, lr = F(n, { hasGlobalName: k.hasGlobalName, onEmitNode: Ne.emitNodeWithNotification, isEmitNotificationEnabled: Ne.isEmitNotificationEnabled, substituteNode: Ne.substituteNode });
                  e.Debug.assert(Ne.transformed.length === 1, "Should only see one output from the transform"), de(Ye, Br, Ne.transformed[0], lr, fe), Ne.dispose(), Re && (Re.js = lr.bundleFileInfo);
                }
              }
              function _e(Cr, Ye, Br, Er) {
                if (!!Cr) {
                  if (!Ye) {
                    (H || fe.emitDeclarationOnly) && (ze = true);
                    return;
                  }
                  var Ne = e.isSourceFile(Cr) ? [Cr] : Cr.sourceFiles, n = l ? Ne : e.filter(Ne, e.isSourceFileNotJson), lr = e.outFile(fe) ? [e.factory.createBundle(n, e.isSourceFile(Cr) ? void 0 : Cr.prepends)] : n;
                  H && !e.getEmitDeclarations(fe) && n.forEach(we);
                  var be = e.transformNodes(k, Y, e.factory, fe, lr, D, false);
                  if (e.length(be.diagnostics)) for (var Ge = 0, ur = be.diagnostics; Ge < ur.length; Ge++) {
                    var yr = ur[Ge];
                    ue.add(yr);
                  }
                  var Ir = { removeComments: fe.removeComments, newLine: fe.newLine, noEmitHelpers: true, module: fe.module, target: fe.target, sourceMap: fe.sourceMap, inlineSourceMap: fe.inlineSourceMap, extendedDiagnostics: fe.extendedDiagnostics, onlyPrintJsDocStyle: true, writeBundleFileInfo: !!Re, recordInternalSection: !!Re, relativeToBuildInfo: Er }, wr = F(Ir, { hasGlobalName: k.hasGlobalName, onEmitNode: be.emitNodeWithNotification, isEmitNotificationEnabled: be.isEmitNotificationEnabled, substituteNode: be.substituteNode }), Ur = !!be.diagnostics && !!be.diagnostics.length || !!Y.isEmitBlocked(Ye) || !!fe.noEmit;
                  if (ze = ze || Ur, (!Ur || l) && (e.Debug.assert(be.transformed.length === 1, "Should only see one output from the decl transform"), de(Ye, Br, be.transformed[0], wr, { sourceMap: !l && fe.declarationMap, sourceRoot: fe.sourceRoot, mapRoot: fe.mapRoot, extendedDiagnostics: fe.extendedDiagnostics }), l && be.transformed[0].kind === 305)) {
                    var ii = be.transformed[0];
                    Ee = ii.exportedModulesFromDeclarationEmit;
                  }
                  be.dispose(), Re && (Re.dts = wr.bundleFileInfo);
                }
              }
              function we(Cr) {
                if (e.isExportAssignment(Cr)) {
                  Cr.expression.kind === 79 && k.collectLinkedAliases(Cr.expression, true);
                  return;
                } else if (e.isExportSpecifier(Cr)) {
                  k.collectLinkedAliases(Cr.propertyName || Cr.name, true);
                  return;
                }
                e.forEachChild(Cr, we);
              }
              function de(Cr, Ye, Br, Er, Ne) {
                var n = Br.kind === 306 ? Br : void 0, lr = Br.kind === 305 ? Br : void 0, be = n ? n.sourceFiles : [lr], Ge;
                ye(Ne, Br) && (Ge = e.createSourceMapGenerator(Y, e.getBaseFileName(e.normalizeSlashes(Cr)), Ae(Ne), er(Ne, Cr, lr), Ne)), n ? Er.writeBundle(n, Fe, Ge) : Er.writeFile(lr, Fe, Ge);
                var ur;
                if (Ge) {
                  g && g.push({ inputSourceFileNames: Ge.getSources(), sourceMap: Ge.toJSON() });
                  var yr = ir(Ne, Ge, Cr, Ye, lr);
                  if (yr && (Fe.isAtStartOfLine() || Fe.rawWrite(We), ur = Fe.getTextPos(), Fe.writeComment("//# ".concat("sourceMappingURL", "=").concat(yr))), Ye) {
                    var Ir = Ge.toString();
                    e.writeFile(Y, ue, Ye, Ir, false, be);
                  }
                } else Fe.writeLine();
                e.writeFile(Y, ue, Cr, Fe.getText(), !!fe.emitBOM, be, { sourceMapUrlPos: ur }), Fe.clear();
              }
              function ye(Cr, Ye) {
                return (Cr.sourceMap || Cr.inlineSourceMap) && (Ye.kind !== 305 || !e.fileExtensionIs(Ye.fileName, ".json"));
              }
              function Ae(Cr) {
                var Ye = e.normalizeSlashes(Cr.sourceRoot || "");
                return Ye && e.ensureTrailingDirectorySeparator(Ye);
              }
              function er(Cr, Ye, Br) {
                if (Cr.sourceRoot) return Y.getCommonSourceDirectory();
                if (Cr.mapRoot) {
                  var Er = e.normalizeSlashes(Cr.mapRoot);
                  return Br && (Er = e.getDirectoryPath(e.getSourceFilePathInNewDir(Br.fileName, Y, Er))), e.getRootLength(Er) === 0 && (Er = e.combinePaths(Y.getCommonSourceDirectory(), Er)), Er;
                }
                return e.getDirectoryPath(e.normalizePath(Ye));
              }
              function ir(Cr, Ye, Br, Er, Ne) {
                if (Cr.inlineSourceMap) {
                  var n = Ye.toString(), lr = e.base64encode(e.sys, n);
                  return "data:application/json;base64,".concat(lr);
                }
                var be = e.getBaseFileName(e.normalizeSlashes(e.Debug.checkDefined(Er)));
                if (Cr.mapRoot) {
                  var Ge = e.normalizeSlashes(Cr.mapRoot);
                  return Ne && (Ge = e.getDirectoryPath(e.getSourceFilePathInNewDir(Ne.fileName, Y, Ge))), e.getRootLength(Ge) === 0 ? (Ge = e.combinePaths(Y.getCommonSourceDirectory(), Ge), encodeURI(e.getRelativePathToDirectoryOrUrl(e.getDirectoryPath(e.normalizePath(Br)), e.combinePaths(Ge, be), Y.getCurrentDirectory(), Y.getCanonicalFileName, true))) : encodeURI(e.combinePaths(Ge, be));
                }
                return encodeURI(be);
              }
            }
            e.emitFiles = R;
            function q(k) {
              return JSON.stringify(k);
            }
            e.getBuildInfoText = q;
            function O(k) {
              return JSON.parse(k);
            }
            e.getBuildInfo = O, e.notImplementedResolver = { hasGlobalName: e.notImplemented, getReferencedExportContainer: e.notImplemented, getReferencedImportDeclaration: e.notImplemented, getReferencedDeclarationWithCollidingName: e.notImplemented, isDeclarationWithCollidingName: e.notImplemented, isValueAliasDeclaration: e.notImplemented, isReferencedAliasDeclaration: e.notImplemented, isTopLevelValueImportEqualsWithEntityName: e.notImplemented, getNodeCheckFlags: e.notImplemented, isDeclarationVisible: e.notImplemented, isLateBound: function(k) {
              return false;
            }, collectLinkedAliases: e.notImplemented, isImplementationOfOverload: e.notImplemented, isRequiredInitializedParameter: e.notImplemented, isOptionalUninitializedParameterProperty: e.notImplemented, isExpandoFunctionDeclaration: e.notImplemented, getPropertiesOfContainerFunction: e.notImplemented, createTypeOfDeclaration: e.notImplemented, createReturnTypeOfSignatureDeclaration: e.notImplemented, createTypeOfExpression: e.notImplemented, createLiteralConstValue: e.notImplemented, isSymbolAccessible: e.notImplemented, isEntityNameVisible: e.notImplemented, getConstantValue: e.notImplemented, getReferencedValueDeclaration: e.notImplemented, getTypeReferenceSerializationKind: e.notImplemented, isOptionalParameter: e.notImplemented, moduleExportsSomeValue: e.notImplemented, isArgumentsLocalBinding: e.notImplemented, getExternalModuleFileFromDeclaration: e.notImplemented, getTypeReferenceDirectivesForEntityName: e.notImplemented, getTypeReferenceDirectivesForSymbol: e.notImplemented, isLiteralConstDeclaration: e.notImplemented, getJsxFactoryEntity: e.notImplemented, getJsxFragmentFactoryEntity: e.notImplemented, getAllAccessorDeclarations: e.notImplemented, getSymbolOfExternalModuleSpecifier: e.notImplemented, isBindingCapturedByNode: e.notImplemented, getDeclarationStatementsForSourceFile: e.notImplemented, isImportRequiredByAugmentation: e.notImplemented };
            function ve(k, Y, U) {
              var j, H = e.Debug.checkDefined(k.js), I = ((j = H.sources) === null || j === void 0 ? void 0 : j.prologues) && e.arrayToMap(H.sources.prologues, function(l) {
                return l.file;
              });
              return k.sourceFiles.map(function(l, d) {
                var D, fe, g = I == null ? void 0 : I.get(d), ne = g == null ? void 0 : g.directives.map(function(Fe) {
                  var Z = e.setTextRange(e.factory.createStringLiteral(Fe.expression.text), Fe.expression), Be = e.setTextRange(e.factory.createExpressionStatement(Z), Fe);
                  return e.setParent(Z, Be), Be;
                }), ue = e.factory.createToken(1), We = e.factory.createSourceFile(ne != null ? ne : [], ue, 0);
                return We.fileName = e.getRelativePathFromDirectory(U.getCurrentDirectory(), e.getNormalizedAbsolutePath(l, Y), !U.useCaseSensitiveFileNames()), We.text = (D = g == null ? void 0 : g.text) !== null && D !== void 0 ? D : "", e.setTextRangePosWidth(We, 0, (fe = g == null ? void 0 : g.text.length) !== null && fe !== void 0 ? fe : 0), e.setEachParent(We.statements, We), e.setTextRangePosWidth(ue, We.end, 0), e.setParent(ue, We), We;
              });
            }
            function ee(k, Y, U, j) {
              var H = E(k.options, false), I = H.buildInfoPath, l = H.jsFilePath, d = H.sourceMapFilePath, D = H.declarationFilePath, fe = H.declarationMapPath, g = Y.readFile(e.Debug.checkDefined(I));
              if (!g) return I;
              var ne = Y.readFile(e.Debug.checkDefined(l));
              if (!ne) return l;
              var ue = d && Y.readFile(d);
              if (d && !ue || k.options.inlineSourceMap) return d || "inline sourcemap decoding";
              var We = D && Y.readFile(D);
              if (D && !We) return D;
              var Fe = fe && Y.readFile(fe);
              if (fe && !Fe || k.options.inlineSourceMap) return fe || "inline sourcemap decoding";
              var Z = O(g);
              if (!Z.bundle || !Z.bundle.js || We && !Z.bundle.dts) return I;
              var Be = e.getDirectoryPath(e.getNormalizedAbsolutePath(I, Y.getCurrentDirectory())), ge = e.createInputFiles(ne, We, d, ue, fe, Fe, l, D, I, Z, true), Re = [], ze = e.createPrependNodes(k.projectReferences, U, function(rr) {
                return Y.readFile(rr);
              }), Ee = ve(Z.bundle, Be, Y), He = { getPrependNodes: e.memoize(function() {
                return Ve(Ve([], ze, true), [ge], false);
              }), getCanonicalFileName: Y.getCanonicalFileName, getCommonSourceDirectory: function() {
                return e.getNormalizedAbsolutePath(Z.bundle.commonSourceDirectory, Be);
              }, getCompilerOptions: function() {
                return k.options;
              }, getCurrentDirectory: function() {
                return Y.getCurrentDirectory();
              }, getNewLine: function() {
                return Y.getNewLine();
              }, getSourceFile: e.returnUndefined, getSourceFileByPath: e.returnUndefined, getSourceFiles: function() {
                return Ee;
              }, getLibFileFromReference: e.notImplemented, isSourceFileFromExternalLibrary: e.returnFalse, getResolvedProjectReferenceToRedirect: e.returnUndefined, getProjectReferenceRedirect: e.returnUndefined, isSourceOfProjectReferenceRedirect: e.returnFalse, writeFile: function(rr, Ie, _e) {
                switch (rr) {
                  case l:
                    if (ne === Ie) return;
                    break;
                  case d:
                    if (ue === Ie) return;
                    break;
                  case I:
                    var we = O(Ie);
                    we.program = Z.program;
                    var de = Z.bundle, ye = de.js, Ae = de.dts, er = de.sourceFiles;
                    we.bundle.js.sources = ye.sources, Ae && (we.bundle.dts.sources = Ae.sources), we.bundle.sourceFiles = er, Re.push({ name: rr, text: q(we), writeByteOrderMark: _e });
                    return;
                  case D:
                    if (We === Ie) return;
                    break;
                  case fe:
                    if (Fe === Ie) return;
                    break;
                  default:
                    e.Debug.fail("Unexpected path: ".concat(rr));
                }
                Re.push({ name: rr, text: Ie, writeByteOrderMark: _e });
              }, isEmitBlocked: e.returnFalse, readFile: function(rr) {
                return Y.readFile(rr);
              }, fileExists: function(rr) {
                return Y.fileExists(rr);
              }, useCaseSensitiveFileNames: function() {
                return Y.useCaseSensitiveFileNames();
              }, getProgramBuildInfo: e.returnUndefined, getSourceFileFromReference: e.returnUndefined, redirectTargetsMap: e.createMultiMap(), getFileIncludeReasons: e.notImplemented };
              return R(e.notImplementedResolver, He, void 0, e.getTransformers(k.options, j)), Re;
            }
            e.emitUsingBuildInfo = ee;
            var he;
            (function(k) {
              k[k.Notification = 0] = "Notification", k[k.Substitution = 1] = "Substitution", k[k.Comments = 2] = "Comments", k[k.SourceMaps = 3] = "SourceMaps", k[k.Emit = 4] = "Emit";
            })(he || (he = {}));
            function F(k, Y) {
              k === void 0 && (k = {}), Y === void 0 && (Y = {});
              var U = Y.hasGlobalName, j = Y.onEmitNode, H = j === void 0 ? e.noEmitNotification : j, I = Y.isEmitNotificationEnabled, l = Y.substituteNode, d = l === void 0 ? e.noEmitSubstitution : l, D = Y.onBeforeEmitNode, fe = Y.onAfterEmitNode, g = Y.onBeforeEmitNodeArray, ne = Y.onAfterEmitNodeArray, ue = Y.onBeforeEmitToken, We = Y.onAfterEmitToken, Fe = !!k.extendedDiagnostics, Z = e.getNewLineCharacter(k), Be = e.getEmitModuleKind(k), ge = new e.Map(), Re, ze, Ee, He, rr, Ie, _e, we, de = k.preserveSourceNewlines, ye, Ae, er, ir = B_, Cr, Ye = k.writeBundleFileInfo ? { sections: [] } : void 0, Br = Ye ? e.Debug.checkDefined(k.relativeToBuildInfo) : void 0, Er = k.recordInternalSection, Ne = 0, n = "text", lr = true, be, Ge, ur = -1, yr, Ir = -1, wr = -1, Ur = -1, ii = -1, mi, pe, or = false, qr = !!k.removeComments, si, Di, wi = e.performance.createTimerIf(Fe, "commentTime", "beforeComment", "afterComment"), Xi = wi.enter, et = wi.exit, Gi = e.factory.parenthesizer, Wt = { select: function(v) {
                return v === 0 ? Gi.parenthesizeLeadingTypeArgument : void 0;
              } }, Zt = pt();
              return fr(), { printNode: _r, printList: pi, printFile: Xe, printBundle: ae, writeNode: ti, writeList: Ze, writeFile: Ar, writeBundle: vr, bundleFileInfo: Ye };
              function _r(v, sr, fi) {
                switch (v) {
                  case 0:
                    e.Debug.assert(e.isSourceFile(sr), "Expected a SourceFile node.");
                    break;
                  case 2:
                    e.Debug.assert(e.isIdentifier(sr), "Expected an Identifier node.");
                    break;
                  case 1:
                    e.Debug.assert(e.isExpression(sr), "Expected an Expression node.");
                    break;
                }
                switch (sr.kind) {
                  case 305:
                    return Xe(sr);
                  case 306:
                    return ae(sr);
                  case 307:
                    return Jr(sr);
                }
                return ti(v, sr, fi, Oe()), nr();
              }
              function pi(v, sr, fi) {
                return Ze(v, sr, fi, Oe()), nr();
              }
              function ae(v) {
                return vr(v, Oe(), void 0), nr();
              }
              function Xe(v) {
                return Ar(v, Oe(), void 0), nr();
              }
              function Jr(v) {
                return mr(v, Oe()), nr();
              }
              function ti(v, sr, fi, zi) {
                var Sa = Ae;
                Ue(zi, void 0), Mr(v, sr, fi), fr(), Ae = Sa;
              }
              function Ze(v, sr, fi, zi) {
                var Sa = Ae;
                Ue(zi, void 0), fi && Pe(fi), Zn(void 0, sr, v), fr(), Ae = Sa;
              }
              function Sr() {
                return Ae.getTextPosWithWriteLine ? Ae.getTextPosWithWriteLine() : Ae.getTextPos();
              }
              function zr(v, sr, fi) {
                var zi = e.lastOrUndefined(Ye.sections);
                zi && zi.kind === fi ? zi.end = sr : Ye.sections.push({ pos: v, end: sr, kind: fi });
              }
              function Wr(v) {
                if (Er && Ye && Re && (e.isDeclaration(v) || e.isVariableStatement(v)) && e.isInternalDeclaration(v, Re) && n !== "internal") {
                  var sr = n;
                  return xe(Ae.getTextPos()), Ne = Sr(), n = "internal", sr;
                }
              }
              function Je(v) {
                v && (xe(Ae.getTextPos()), Ne = Sr(), n = v);
              }
              function xe(v) {
                return Ne < v ? (zr(Ne, v, n), true) : false;
              }
              function vr(v, sr, fi) {
                var zi;
                Cr = false;
                var Sa = Ae;
                Ue(sr, fi), f_(v), L_(v), Fi(v), Cp(v);
                for (var da = 0, Ha = v.prepends; da < Ha.length; da++) {
                  var ta = Ha[da];
                  bs();
                  var nn = Ae.getTextPos(), Wo = Ye && Ye.sections;
                  if (Wo && (Ye.sections = []), Mr(4, ta, void 0), Ye) {
                    var Lo = Ye.sections;
                    Ye.sections = Wo, ta.oldFileOfCurrentEmit ? (zi = Ye.sections).push.apply(zi, Lo) : (Lo.forEach(function(lu) {
                      return e.Debug.assert(e.isBundleFileTextLike(lu));
                    }), Ye.sections.push({ pos: nn, end: Ae.getTextPos(), kind: "prepend", data: Br(ta.fileName), texts: Lo }));
                  }
                }
                Ne = Sr();
                for (var oc = 0, uu = v.sourceFiles; oc < uu.length; oc++) {
                  var is = uu[oc];
                  Mr(0, is, is);
                }
                if (Ye && v.sourceFiles.length) {
                  var au = Ae.getTextPos();
                  if (xe(au)) {
                    var Ou = l_(v);
                    Ou && (Ye.sources || (Ye.sources = {}), Ye.sources.prologues = Ou);
                    var sf = Ki(v);
                    sf && (Ye.sources || (Ye.sources = {}), Ye.sources.helpers = sf);
                  }
                }
                fr(), Ae = Sa;
              }
              function mr(v, sr) {
                var fi = Ae;
                Ue(sr, void 0), Mr(4, v, void 0), fr(), Ae = fi;
              }
              function Ar(v, sr, fi) {
                Cr = true;
                var zi = Ae;
                Ue(sr, fi), f_(v), L_(v), Mr(0, v, v), fr(), Ae = zi;
              }
              function Oe() {
                return er || (er = e.createTextWriter(Z));
              }
              function nr() {
                var v = er.getText();
                return er.clear(), v;
              }
              function Mr(v, sr, fi) {
                fi && Pe(fi), Wi(v, sr, void 0);
              }
              function Pe(v) {
                Re = v, mi = void 0, pe = void 0, v && wu(v);
              }
              function Ue(v, sr) {
                v && k.omitTrailingSemicolon && (v = e.getTrailingSemicolonDeferringWriter(v)), Ae = v, be = sr, lr = !Ae || !be;
              }
              function fr() {
                ze = [], Ee = [], He = new e.Set(), rr = [], Ie = 0, _e = [], Re = void 0, mi = void 0, pe = void 0, Ue(void 0, void 0);
              }
              function De() {
                return mi || (mi = e.getLineStarts(e.Debug.checkDefined(Re)));
              }
              function gr(v, sr) {
                if (v !== void 0) {
                  var fi = Wr(v);
                  Wi(4, v, sr), Je(fi);
                }
              }
              function Vr(v) {
                v !== void 0 && Wi(2, v, void 0);
              }
              function Tr(v, sr) {
                v !== void 0 && Wi(1, v, sr);
              }
              function vi(v) {
                Wi(e.isStringLiteral(v) ? 6 : 4, v);
              }
              function Ui(v) {
                de && e.getEmitFlags(v) & 134217728 && (de = false);
              }
              function Yi(v) {
                de = v;
              }
              function Wi(v, sr, fi) {
                Di = fi;
                var zi = nt(0, v, sr);
                zi(v, sr), Di = void 0;
              }
              function ct(v) {
                return !qr && !e.isSourceFile(v);
              }
              function Li(v) {
                return !lr && !e.isSourceFile(v) && !e.isInJsonFile(v) && !e.isUnparsedSource(v) && !e.isUnparsedPrepend(v);
              }
              function nt(v, sr, fi) {
                switch (v) {
                  case 0:
                    if (H !== e.noEmitNotification && (!I || I(fi))) return xt;
                  case 1:
                    if (d !== e.noEmitSubstitution && (si = d(sr, fi) || fi) !== fi) return Di && (si = Di(si)), Ii;
                  case 2:
                    if (ct(fi)) return xf;
                  case 3:
                    if (Li(fi)) return hd;
                  case 4:
                    return ut;
                  default:
                    return e.Debug.assertNever(v);
                }
              }
              function Mt(v, sr, fi) {
                return nt(v + 1, sr, fi);
              }
              function xt(v, sr) {
                var fi = Mt(0, v, sr);
                H(v, sr, fi);
              }
              function ut(v, sr) {
                if (D == null || D(sr), de) {
                  var fi = de;
                  Ui(sr), Dt(v, sr), Yi(fi);
                } else Dt(v, sr);
                fe == null || fe(sr), Di = void 0;
              }
              function Dt(v, sr, fi) {
                if (fi === void 0 && (fi = true), fi) {
                  var zi = e.getSnippetElement(sr);
                  if (zi) return Vi(v, sr, zi);
                }
                if (v === 0) return yf(e.cast(sr, e.isSourceFile));
                if (v === 2) return ba(e.cast(sr, e.isIdentifier));
                if (v === 6) return wt(e.cast(sr, e.isStringLiteral), true);
                if (v === 3) return Rt(e.cast(sr, e.isTypeParameterDeclaration));
                if (v === 5) return e.Debug.assertNode(sr, e.isEmptyStatement), su(true);
                if (v === 4) {
                  switch (sr.kind) {
                    case 15:
                    case 16:
                    case 17:
                      return wt(sr, false);
                    case 79:
                      return ba(sr);
                    case 80:
                      return $a(sr);
                    case 161:
                      return Qa(sr);
                    case 162:
                      return Dn(sr);
                    case 163:
                      return ka(sr);
                    case 164:
                      return Ba(sr);
                    case 165:
                      return pn(sr);
                    case 166:
                      return Cn(sr);
                    case 167:
                      return Bi(sr);
                    case 168:
                      return kn(sr);
                    case 169:
                      return xn(sr);
                    case 170:
                      return Kn(sr);
                    case 171:
                      return Pn(sr);
                    case 172:
                    case 173:
                      return eo(sr);
                    case 174:
                      return Rn(sr);
                    case 175:
                      return Da(sr);
                    case 176:
                      return bo(sr);
                    case 177:
                      return Wn(sr);
                    case 178:
                      return to(sr);
                    case 179:
                      return Co(sr);
                    case 180:
                      return Pr(sr);
                    case 181:
                      return xi(sr);
                    case 182:
                      return St(sr);
                    case 183:
                      return pa(sr);
                    case 184:
                      return Jn(sr);
                    case 185:
                      return Gr(sr);
                    case 187:
                      return S(sr);
                    case 188:
                      return Ce(sr);
                    case 189:
                      return qe(sr);
                    case 190:
                      return br(sr);
                    case 191:
                      return Zr(sr);
                    case 228:
                      return fo(sr);
                    case 192:
                      return Si();
                    case 193:
                      return Pi(sr);
                    case 194:
                      return Qi(sr);
                    case 195:
                      return Ct(sr);
                    case 196:
                      return sa(sr);
                    case 197:
                      return Qe(sr);
                    case 198:
                      return en(sr);
                    case 199:
                      return Ro(sr);
                    case 200:
                      return Wa(sr);
                    case 201:
                      return qn(sr);
                    case 202:
                      return mo(sr);
                    case 203:
                      return So(sr);
                    case 233:
                      return Ao(sr);
                    case 234:
                      return En();
                    case 235:
                      return Ms(sr);
                    case 237:
                      return xc(sr);
                    case 236:
                      return su(false);
                    case 238:
                      return tl(sr);
                    case 239:
                      return Zc(sr);
                    case 240:
                      return al(sr);
                    case 241:
                      return Jo(sr);
                    case 242:
                      return eu(sr);
                    case 243:
                      return Ws(sr);
                    case 244:
                      return pu(sr);
                    case 245:
                      return Ql(sr);
                    case 246:
                      return xl(sr);
                    case 247:
                      return Ei(sr);
                    case 248:
                      return tt(sr);
                    case 249:
                      return kt(sr);
                    case 250:
                      return bt(sr);
                    case 251:
                      return ia(sr);
                    case 252:
                      return Xt(sr);
                    case 253:
                      return Za(sr);
                    case 254:
                      return bn(sr);
                    case 255:
                      return _a(sr);
                    case 256:
                      return qa(sr);
                    case 257:
                      return Or(sr);
                    case 258:
                      return dt(sr);
                    case 259:
                      return la(sr);
                    case 260:
                      return wa(sr);
                    case 261:
                      return On(sr);
                    case 262:
                      return No(sr);
                    case 263:
                      return jo(sr);
                    case 264:
                      return vf(sr);
                    case 265:
                      return po(sr);
                    case 266:
                      return $n(sr);
                    case 267:
                      return Ho(sr);
                    case 268:
                      return Zo(sr);
                    case 274:
                      return P_(sr);
                    case 269:
                      return Es(sr);
                    case 270:
                      return yc(sr);
                    case 271:
                      return Xr(sr);
                    case 272:
                      return Ls(sr);
                    case 273:
                      return El(sr);
                    case 275:
                      return vp(sr);
                    case 293:
                      return Ic(sr);
                    case 294:
                      return zu(sr);
                    case 276:
                      return;
                    case 277:
                      return yp(sr);
                    case 11:
                      return hp(sr);
                    case 280:
                    case 283:
                      return c_(sr);
                    case 281:
                    case 284:
                      return gu(sr);
                    case 285:
                      return sd(sr);
                    case 286:
                      return Dp(sr);
                    case 287:
                      return Aa(sr);
                    case 288:
                      return cd(sr);
                    case 289:
                      return nl(sr);
                    case 290:
                      return hc(sr);
                    case 291:
                      return u_(sr);
                    case 292:
                      return Jf(sr);
                    case 296:
                      return w_(sr);
                    case 297:
                      return ud(sr);
                    case 298:
                      return ku(sr);
                    case 299:
                      return ld(sr);
                    case 300:
                      return Ai(sr);
                    case 307:
                    case 301:
                      return na(sr);
                    case 302:
                    case 303:
                      return Oi(sr);
                    case 304:
                      return ji(sr);
                    case 305:
                      return yf(sr);
                    case 306:
                      return e.Debug.fail("Bundles should be printed using printBundle");
                    case 308:
                      return e.Debug.fail("InputFiles should not be printed");
                    case 309:
                      return ru(sr);
                    case 310:
                      return Tp(sr);
                    case 312:
                      return Gt("*");
                    case 313:
                      return Gt("?");
                    case 314:
                      return Oo(sr);
                    case 315:
                      return no(sr);
                    case 316:
                      return $o(sr);
                    case 317:
                      return Ko(sr);
                    case 186:
                    case 318:
                      return dn(sr);
                    case 319:
                      return;
                    case 320:
                      return fd(sr);
                    case 322:
                      return xp(sr);
                    case 323:
                      return M_(sr);
                    case 327:
                    case 332:
                    case 337:
                      return pd(sr);
                    case 328:
                    case 329:
                      return _d(sr);
                    case 330:
                    case 331:
                      return;
                    case 333:
                    case 334:
                    case 335:
                    case 336:
                      return;
                    case 338:
                      return F_(sr);
                    case 340:
                    case 347:
                      return Ep(sr);
                    case 339:
                    case 341:
                    case 342:
                    case 343:
                      return bp(sr);
                    case 344:
                      return jf(sr);
                    case 345:
                      return O_(sr);
                    case 346:
                      return Sp(sr);
                    case 349:
                    case 353:
                    case 352:
                      return;
                  }
                  if (e.isExpression(sr) && (v = 1, d !== e.noEmitSubstitution)) {
                    var Sa = d(v, sr) || sr;
                    Sa !== sr && (sr = Sa, Di && (sr = Di(sr)));
                  }
                }
                if (v === 1) switch (sr.kind) {
                  case 8:
                  case 9:
                    return Bt(sr);
                  case 10:
                  case 13:
                  case 14:
                    return wt(sr, false);
                  case 79:
                    return ba(sr);
                  case 80:
                    return $a(sr);
                  case 204:
                    return Go(sr);
                  case 205:
                    return ys(sr);
                  case 206:
                    return Pc(sr);
                  case 207:
                    return Kc(sr);
                  case 208:
                    return Xs(sr);
                  case 209:
                    return pc(sr);
                  case 210:
                    return hs(sr);
                  case 211:
                    return tc(sr);
                  case 212:
                    return ps(sr);
                  case 213:
                    return Qs(sr);
                  case 214:
                    return js(sr);
                  case 215:
                    return Ji(sr);
                  case 216:
                    return ce(sr);
                  case 217:
                    return Rr(sr);
                  case 218:
                    return yi(sr);
                  case 219:
                    return qi(sr);
                  case 220:
                    return Hr(sr);
                  case 221:
                    return Zt(sr);
                  case 222:
                    return Pt(sr);
                  case 223:
                    return ga(sr);
                  case 224:
                    return ua(sr);
                  case 225:
                    return Xn(sr);
                  case 226:
                    return jr(sr);
                  case 227:
                    return;
                  case 229:
                    return xs(sr);
                  case 230:
                    return Fo(sr);
                  case 228:
                    return fo(sr);
                  case 231:
                    return ko(sr);
                  case 232:
                    return e.Debug.fail("SyntheticExpression should never be printed.");
                  case 278:
                    return Yl(sr);
                  case 279:
                    return Bf(sr);
                  case 282:
                    return Cl(sr);
                  case 348:
                    return e.Debug.fail("SyntaxList should not be printed");
                  case 349:
                    return;
                  case 350:
                    return gd(sr);
                  case 351:
                    return hf(sr);
                  case 352:
                  case 353:
                    return;
                  case 354:
                    return e.Debug.fail("SyntheticReferenceExpression should not be printed");
                }
                if (e.isKeyword(sr.kind)) return Pl(sr, vn);
                if (e.isTokenKind(sr.kind)) return Pl(sr, Gt);
                e.Debug.fail("Unhandled SyntaxKind: ".concat(e.Debug.formatSyntaxKind(sr.kind), "."));
              }
              function Rt(v) {
                gr(v.name), Ut(), vn("in"), Ut(), gr(v.constraint);
              }
              function Ii(v, sr) {
                var fi = Mt(1, v, sr);
                e.Debug.assertIsDefined(si), sr = si, si = void 0, fi(v, sr);
              }
              function Ki(v) {
                var sr;
                if (!(Be === e.ModuleKind.None || k.noEmitHelpers)) {
                  for (var fi = new e.Map(), zi = 0, Sa = v.sourceFiles; zi < Sa.length; zi++) {
                    var da = Sa[zi], Ha = e.getExternalHelpersModuleName(da) !== void 0, ta = ui(da);
                    if (!!ta) for (var nn = 0, Wo = ta; nn < Wo.length; nn++) {
                      var Lo = Wo[nn];
                      !Lo.scoped && !Ha && !fi.get(Lo.name) && (fi.set(Lo.name, true), (sr || (sr = [])).push(Lo.name));
                    }
                  }
                  return sr;
                }
              }
              function Fi(v) {
                var sr = false, fi = v.kind === 306 ? v : void 0;
                if (!(fi && Be === e.ModuleKind.None)) {
                  for (var zi = fi ? fi.prepends.length : 0, Sa = fi ? fi.sourceFiles.length + zi : 1, da = 0; da < Sa; da++) {
                    var Ha = fi ? da < zi ? fi.prepends[da] : fi.sourceFiles[da - zi] : v, ta = e.isSourceFile(Ha) ? Ha : e.isUnparsedSource(Ha) ? void 0 : Re, nn = k.noEmitHelpers || !!ta && e.hasRecordedExternalHelpers(ta), Wo = (e.isSourceFile(Ha) || e.isUnparsedSource(Ha)) && !Cr, Lo = e.isUnparsedSource(Ha) ? Ha.helpers : ui(Ha);
                    if (Lo) for (var oc = 0, uu = Lo; oc < uu.length; oc++) {
                      var is = uu[oc];
                      if (is.scoped) {
                        if (fi) continue;
                      } else {
                        if (nn) continue;
                        if (Wo) {
                          if (ge.get(is.name)) continue;
                          ge.set(is.name, true);
                        }
                      }
                      var au = Sr();
                      typeof is.text == "string" ? ul(is.text) : ul(is.text(Tf)), Ye && Ye.sections.push({ pos: au, end: Ae.getTextPos(), kind: "emitHelpers", data: is.name }), sr = true;
                    }
                  }
                  return sr;
                }
              }
              function ui(v) {
                var sr = e.getEmitHelpers(v);
                return sr && e.stableSort(sr, e.compareEmitHelpers);
              }
              function Bt(v) {
                wt(v, false);
              }
              function wt(v, sr) {
                var fi = Pu(v, k.neverAsciiEscape, sr);
                (k.sourceMap || k.inlineSourceMap) && (v.kind === 10 || e.isTemplateLiteralKind(v.kind)) ? d_(fi) : Gc(fi);
              }
              function na(v) {
                for (var sr = 0, fi = v.texts; sr < fi.length; sr++) {
                  var zi = fi[sr];
                  bs(), gr(zi);
                }
              }
              function Ai(v) {
                Ae.rawWrite(v.parent.text.substring(v.pos, v.end));
              }
              function Oi(v) {
                var sr = Sr();
                Ai(v), Ye && zr(sr, Ae.getTextPos(), v.kind === 302 ? "text" : "internal");
              }
              function ji(v) {
                var sr = Sr();
                if (Ai(v), Ye) {
                  var fi = e.clone(v.section);
                  fi.pos = sr, fi.end = Ae.getTextPos(), Ye.sections.push(fi);
                }
              }
              function Vi(v, sr, fi) {
                switch (fi.kind) {
                  case 1:
                    at(v, sr, fi);
                    break;
                  case 0:
                    At(v, sr, fi);
                    break;
                }
              }
              function at(v, sr, fi) {
                bf("${".concat(fi.order, ":")), Dt(v, sr, false), bf("}");
              }
              function At(v, sr, fi) {
                e.Debug.assert(sr.kind === 236, "A tab stop cannot be attached to a node of kind ".concat(e.Debug.formatSyntaxKind(sr.kind), ".")), e.Debug.assert(v !== 5, "A tab stop cannot be attached to an embedded statement."), bf("$".concat(fi.order));
              }
              function ba(v) {
                var sr = v.symbol ? vu : ir;
                sr(dc(v, false), v.symbol), Zn(v, v.typeArguments, 53776);
              }
              function $a(v) {
                var sr = v.symbol ? vu : ir;
                sr(dc(v, false), v.symbol);
              }
              function Qa(v) {
                ai(v.left), Gt("."), gr(v.right);
              }
              function ai(v) {
                v.kind === 79 ? Tr(v) : gr(v);
              }
              function Dn(v) {
                Gt("["), Tr(v.expression, Gi.parenthesizeExpressionOfComputedPropertyName), Gt("]");
              }
              function ka(v) {
                ks(v, v.modifiers), gr(v.name), v.constraint && (Ut(), vn("extends"), Ut(), gr(v.constraint)), v.default && (Ut(), Nl("="), Ut(), gr(v.default));
              }
              function Ba(v) {
                wc(v, v.decorators), ks(v, v.modifiers), gr(v.dotDotDotToken), md(v.name, cl), gr(v.questionToken), v.parent && v.parent.kind === 317 && !v.name ? gr(v.type) : Wu(v.type), Zl(v.initializer, v.type ? v.type.end : v.questionToken ? v.questionToken.end : v.name ? v.name.end : v.modifiers ? v.modifiers.end : v.decorators ? v.decorators.end : v.pos, v, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function pn(v) {
                Gt("@"), Tr(v.expression, Gi.parenthesizeLeftSideOfAccess);
              }
              function Cn(v) {
                wc(v, v.decorators), ks(v, v.modifiers), md(v.name, Ds), gr(v.questionToken), Wu(v.type), As();
              }
              function Bi(v) {
                wc(v, v.decorators), ks(v, v.modifiers), gr(v.name), gr(v.questionToken), gr(v.exclamationToken), Wu(v.type), Zl(v.initializer, v.type ? v.type.end : v.questionToken ? v.questionToken.end : v.name.end, v), As();
              }
              function kn(v) {
                wl(v), wc(v, v.decorators), ks(v, v.modifiers), gr(v.name), gr(v.questionToken), Vu(v, v.typeParameters), ef(v, v.parameters), Wu(v.type), As(), Iu(v);
              }
              function xn(v) {
                wc(v, v.decorators), ks(v, v.modifiers), gr(v.asteriskToken), gr(v.name), gr(v.questionToken), jn(v, Mo);
              }
              function Kn(v) {
                wc(v, v.decorators), ks(v, v.modifiers), vn("static"), gs(v.body);
              }
              function Pn(v) {
                ks(v, v.modifiers), vn("constructor"), jn(v, Mo);
              }
              function eo(v) {
                wc(v, v.decorators), ks(v, v.modifiers), vn(v.kind === 172 ? "get" : "set"), Ut(), gr(v.name), jn(v, Mo);
              }
              function Rn(v) {
                wl(v), wc(v, v.decorators), ks(v, v.modifiers), Vu(v, v.typeParameters), ef(v, v.parameters), Wu(v.type), As(), Iu(v);
              }
              function Da(v) {
                wl(v), wc(v, v.decorators), ks(v, v.modifiers), vn("new"), Ut(), Vu(v, v.typeParameters), ef(v, v.parameters), Wu(v.type), As(), Iu(v);
              }
              function bo(v) {
                wc(v, v.decorators), ks(v, v.modifiers), Df(v, v.parameters), Wu(v.type), As();
              }
              function Ro(v) {
                gr(v.type), gr(v.literal);
              }
              function En() {
                As();
              }
              function Wn(v) {
                v.assertsModifier && (gr(v.assertsModifier), Ut()), gr(v.parameterName), v.type && (Ut(), vn("is"), Ut(), gr(v.type));
              }
              function to(v) {
                gr(v.typeName), qu(v, v.typeArguments);
              }
              function Co(v) {
                wl(v), Vu(v, v.typeParameters), p_(v, v.parameters), Ut(), Gt("=>"), Ut(), gr(v.type), Iu(v);
              }
              function Ko(v) {
                vn("function"), ef(v, v.parameters), Gt(":"), gr(v.type);
              }
              function Oo(v) {
                Gt("?"), gr(v.type);
              }
              function no(v) {
                Gt("!"), gr(v.type);
              }
              function $o(v) {
                gr(v.type), Gt("=");
              }
              function Pr(v) {
                wl(v), ks(v, v.modifiers), vn("new"), Ut(), Vu(v, v.typeParameters), ef(v, v.parameters), Ut(), Gt("=>"), Ut(), gr(v.type), Iu(v);
              }
              function xi(v) {
                vn("typeof"), Ut(), gr(v.exprName), qu(v, v.typeArguments);
              }
              function St(v) {
                Gt("{");
                var sr = e.getEmitFlags(v) & 1 ? 768 : 32897;
                Zn(v, v.members, sr | 524288), Gt("}");
              }
              function pa(v) {
                gr(v.elementType, Gi.parenthesizeNonArrayTypeOfPostfixType), Gt("["), Gt("]");
              }
              function dn(v) {
                Gt("..."), gr(v.type);
              }
              function Jn(v) {
                Ya(22, v.pos, Gt, v);
                var sr = e.getEmitFlags(v) & 1 ? 528 : 657;
                Zn(v, v.elements, sr | 524288, Gi.parenthesizeElementTypeOfTupleType), Ya(23, v.elements.end, Gt, v);
              }
              function Qe(v) {
                gr(v.dotDotDotToken), gr(v.name), gr(v.questionToken), Ya(58, v.name.end, Gt, v), Ut(), gr(v.type);
              }
              function Gr(v) {
                gr(v.type, Gi.parenthesizeTypeOfOptionalType), Gt("?");
              }
              function S(v) {
                Zn(v, v.types, 516, Gi.parenthesizeConstituentTypeOfUnionType);
              }
              function Ce(v) {
                Zn(v, v.types, 520, Gi.parenthesizeConstituentTypeOfIntersectionType);
              }
              function qe(v) {
                gr(v.checkType, Gi.parenthesizeCheckTypeOfConditionalType), Ut(), vn("extends"), Ut(), gr(v.extendsType, Gi.parenthesizeExtendsTypeOfConditionalType), Ut(), Gt("?"), Ut(), gr(v.trueType), Ut(), Gt(":"), Ut(), gr(v.falseType);
              }
              function br(v) {
                vn("infer"), Ut(), gr(v.typeParameter);
              }
              function Zr(v) {
                Gt("("), gr(v.type), Gt(")");
              }
              function Si() {
                vn("this");
              }
              function Pi(v) {
                Il(v.operator, vn), Ut();
                var sr = v.operator === 145 ? Gi.parenthesizeOperandOfReadonlyTypeOperator : Gi.parenthesizeOperandOfTypeOperator;
                gr(v.type, sr);
              }
              function Qi(v) {
                gr(v.objectType, Gi.parenthesizeNonArrayTypeOfPostfixType), Gt("["), gr(v.indexType), Gt("]");
              }
              function Ct(v) {
                var sr = e.getEmitFlags(v);
                Gt("{"), sr & 1 ? Ut() : (bs(), Dc()), v.readonlyToken && (gr(v.readonlyToken), v.readonlyToken.kind !== 145 && vn("readonly"), Ut()), Gt("["), Wi(3, v.typeParameter), v.nameType && (Ut(), vn("as"), Ut(), gr(v.nameType)), Gt("]"), v.questionToken && (gr(v.questionToken), v.questionToken.kind !== 57 && Gt("?")), Gt(":"), Ut(), gr(v.type), As(), sr & 1 ? Ut() : (bs(), Cc()), Zn(v, v.members, 2), Gt("}");
              }
              function sa(v) {
                Tr(v.literal);
              }
              function en(v) {
                gr(v.head), Zn(v, v.templateSpans, 262144);
              }
              function Wa(v) {
                if (v.isTypeOf && (vn("typeof"), Ut()), vn("import"), Gt("("), gr(v.argument), v.assertions) {
                  Gt(","), Ut(), Gt("{"), Ut(), vn("assert"), Gt(":"), Ut();
                  var sr = v.assertions.assertClause.elements;
                  Zn(v.assertions.assertClause, sr, 526226), Ut(), Gt("}");
                }
                Gt(")"), v.qualifier && (Gt("."), gr(v.qualifier)), qu(v, v.typeArguments);
              }
              function qn(v) {
                Gt("{"), Zn(v, v.elements, 525136), Gt("}");
              }
              function mo(v) {
                Gt("["), Zn(v, v.elements, 524880), Gt("]");
              }
              function So(v) {
                gr(v.dotDotDotToken), v.propertyName && (gr(v.propertyName), Gt(":"), Ut()), gr(v.name), Zl(v.initializer, v.name.end, v, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function Go(v) {
                var sr = v.elements, fi = v.multiLine ? 65536 : 0;
                os(v, sr, 8914 | fi, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function ys(v) {
                e.forEach(v.properties, Ys);
                var sr = e.getEmitFlags(v) & 65536;
                sr && Dc();
                var fi = v.multiLine ? 65536 : 0, zi = Re && Re.languageVersion >= 1 && !e.isJsonSourceFile(Re) ? 64 : 0;
                Zn(v, v.properties, 526226 | zi | fi), sr && Cc();
              }
              function Pc(v) {
                Tr(v.expression, Gi.parenthesizeLeftSideOfAccess);
                var sr = v.questionDotToken || e.setTextRangePosEnd(e.factory.createToken(24), v.expression.end, v.name.pos), fi = iu(v, v.expression, sr), zi = iu(v, sr, v.name);
                Nu(fi, false);
                var Sa = sr.kind !== 28 && Vc(v.expression) && !Ae.hasTrailingComment() && !Ae.hasTrailingWhitespace();
                Sa && Gt("."), v.questionDotToken ? gr(sr) : Ya(sr.kind, v.expression.end, Gt, v), Nu(zi, false), gr(v.name), Us(fi, zi);
              }
              function Vc(v) {
                if (v = e.skipPartiallyEmittedExpressions(v), e.isNumericLiteral(v)) {
                  var sr = Pu(v, true, false);
                  return !v.numericLiteralFlags && !e.stringContains(sr, e.tokenToString(24));
                } else if (e.isAccessExpression(v)) {
                  var fi = e.getConstantValue(v);
                  return typeof fi == "number" && isFinite(fi) && Math.floor(fi) === fi;
                }
              }
              function Kc(v) {
                Tr(v.expression, Gi.parenthesizeLeftSideOfAccess), gr(v.questionDotToken), Ya(22, v.expression.end, Gt, v), Tr(v.argumentExpression), Ya(23, v.argumentExpression.end, Gt, v);
              }
              function Xs(v) {
                var sr = e.getEmitFlags(v) & 536870912;
                sr && (Gt("("), d_("0"), Gt(","), Ut()), Tr(v.expression, Gi.parenthesizeLeftSideOfAccess), sr && Gt(")"), gr(v.questionDotToken), qu(v, v.typeArguments), os(v, v.arguments, 2576, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function pc(v) {
                Ya(103, v.pos, vn, v), Ut(), Tr(v.expression, Gi.parenthesizeExpressionOfNew), qu(v, v.typeArguments), os(v, v.arguments, 18960, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function hs(v) {
                var sr = e.getEmitFlags(v) & 536870912;
                sr && (Gt("("), d_("0"), Gt(","), Ut()), Tr(v.tag, Gi.parenthesizeLeftSideOfAccess), sr && Gt(")"), qu(v, v.typeArguments), Ut(), Tr(v.template);
              }
              function tc(v) {
                Gt("<"), gr(v.type), Gt(">"), Tr(v.expression, Gi.parenthesizeOperandOfPrefixUnary);
              }
              function ps(v) {
                var sr = Ya(20, v.pos, Gt, v), fi = J_(v.expression, v);
                Tr(v.expression, void 0), j_(v.expression, v), Us(fi), Ya(21, v.expression ? v.expression.end : sr, Gt, v);
              }
              function Qs(v) {
                Ku(v.name), rn(v);
              }
              function js(v) {
                wc(v, v.decorators), ks(v, v.modifiers), jn(v, ds);
              }
              function ds(v) {
                Vu(v, v.typeParameters), p_(v, v.parameters), Wu(v.type), Ut(), gr(v.equalsGreaterThanToken);
              }
              function Ji(v) {
                Ya(89, v.pos, vn, v), Ut(), Tr(v.expression, Gi.parenthesizeOperandOfPrefixUnary);
              }
              function ce(v) {
                Ya(112, v.pos, vn, v), Ut(), Tr(v.expression, Gi.parenthesizeOperandOfPrefixUnary);
              }
              function Rr(v) {
                Ya(114, v.pos, vn, v), Ut(), Tr(v.expression, Gi.parenthesizeOperandOfPrefixUnary);
              }
              function yi(v) {
                Ya(132, v.pos, vn, v), Ut(), Tr(v.expression, Gi.parenthesizeOperandOfPrefixUnary);
              }
              function qi(v) {
                Il(v.operator, Nl), je(v) && Ut(), Tr(v.operand, Gi.parenthesizeOperandOfPrefixUnary);
              }
              function je(v) {
                var sr = v.operand;
                return sr.kind === 219 && (v.operator === 39 && (sr.operator === 39 || sr.operator === 45) || v.operator === 40 && (sr.operator === 40 || sr.operator === 46));
              }
              function Hr(v) {
                Tr(v.operand, Gi.parenthesizeOperandOfPostfixUnary), Il(v.operator, Nl);
              }
              function pt() {
                return e.createBinaryExpressionTrampoline(v, sr, fi, zi, Sa, void 0);
                function v(Ha, ta) {
                  if (ta) {
                    ta.stackIndex++, ta.preserveSourceNewlinesStack[ta.stackIndex] = de, ta.containerPosStack[ta.stackIndex] = wr, ta.containerEndStack[ta.stackIndex] = Ur, ta.declarationListContainerEndStack[ta.stackIndex] = ii;
                    var nn = ta.shouldEmitCommentsStack[ta.stackIndex] = ct(Ha), Wo = ta.shouldEmitSourceMapsStack[ta.stackIndex] = Li(Ha);
                    D == null || D(Ha), nn && z_(Ha), Wo && v_(Ha), Ui(Ha);
                  } else ta = { stackIndex: 0, preserveSourceNewlinesStack: [void 0], containerPosStack: [-1], containerEndStack: [-1], declarationListContainerEndStack: [-1], shouldEmitCommentsStack: [false], shouldEmitSourceMapsStack: [false] };
                  return ta;
                }
                function sr(Ha, ta, nn) {
                  return da(Ha, nn, "left");
                }
                function fi(Ha, ta, nn) {
                  var Wo = Ha.kind !== 27, Lo = iu(nn, nn.left, Ha), oc = iu(nn, Ha, nn.right);
                  Nu(Lo, Wo), Vf(Ha.pos), Pl(Ha, Ha.kind === 101 ? vn : Nl), af(Ha.end, true), Nu(oc, true);
                }
                function zi(Ha, ta, nn) {
                  return da(Ha, nn, "right");
                }
                function Sa(Ha, ta) {
                  var nn = iu(Ha, Ha.left, Ha.operatorToken), Wo = iu(Ha, Ha.operatorToken, Ha.right);
                  if (Us(nn, Wo), ta.stackIndex > 0) {
                    var Lo = ta.preserveSourceNewlinesStack[ta.stackIndex], oc = ta.containerPosStack[ta.stackIndex], uu = ta.containerEndStack[ta.stackIndex], is = ta.declarationListContainerEndStack[ta.stackIndex], au = ta.shouldEmitCommentsStack[ta.stackIndex], Ou = ta.shouldEmitSourceMapsStack[ta.stackIndex];
                    Yi(Lo), Ou && Bp(Ha), au && Oc(Ha, oc, uu, is), fe == null || fe(Ha), ta.stackIndex--;
                  }
                }
                function da(Ha, ta, nn) {
                  var Wo = nn === "left" ? Gi.getParenthesizeLeftSideOfBinaryForOperator(ta.operatorToken.kind) : Gi.getParenthesizeRightSideOfBinaryForOperator(ta.operatorToken.kind), Lo = nt(0, 1, Ha);
                  if (Lo === Ii && (e.Debug.assertIsDefined(si), Ha = Wo(e.cast(si, e.isExpression)), Lo = Mt(1, 1, Ha), si = void 0), (Lo === xf || Lo === hd || Lo === ut) && e.isBinaryExpression(Ha)) return Ha;
                  Di = Wo, Lo(1, Ha);
                }
              }
              function Pt(v) {
                var sr = iu(v, v.condition, v.questionToken), fi = iu(v, v.questionToken, v.whenTrue), zi = iu(v, v.whenTrue, v.colonToken), Sa = iu(v, v.colonToken, v.whenFalse);
                Tr(v.condition, Gi.parenthesizeConditionOfConditionalExpression), Nu(sr, true), gr(v.questionToken), Nu(fi, true), Tr(v.whenTrue, Gi.parenthesizeBranchOfConditionalExpression), Us(sr, fi), Nu(zi, true), gr(v.colonToken), Nu(Sa, true), Tr(v.whenFalse, Gi.parenthesizeBranchOfConditionalExpression), Us(zi, Sa);
              }
              function ga(v) {
                gr(v.head), Zn(v, v.templateSpans, 262144);
              }
              function ua(v) {
                Ya(125, v.pos, vn, v), gr(v.asteriskToken), __(v.expression && Kr(v.expression), _i);
              }
              function Xn(v) {
                Ya(25, v.pos, Gt, v), Tr(v.expression, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function jr(v) {
                Ku(v.name), ki(v);
              }
              function fo(v) {
                Tr(v.expression, Gi.parenthesizeLeftSideOfAccess), qu(v, v.typeArguments);
              }
              function xs(v) {
                Tr(v.expression, void 0), v.type && (Ut(), vn("as"), Ut(), gr(v.type));
              }
              function Fo(v) {
                Tr(v.expression, Gi.parenthesizeLeftSideOfAccess), Nl("!");
              }
              function ko(v) {
                ac(v.keywordToken, v.pos, Gt), Gt("."), gr(v.name);
              }
              function Ao(v) {
                Tr(v.expression), gr(v.literal);
              }
              function Ms(v) {
                Bs(v, !v.multiLine && vd(v));
              }
              function Bs(v, sr) {
                Ya(18, v.pos, Gt, v);
                var fi = sr || e.getEmitFlags(v) & 1 ? 768 : 129;
                Zn(v, v.statements, fi), Ya(19, v.statements.end, Gt, v, !!(fi & 1));
              }
              function xc(v) {
                ks(v, v.modifiers), gr(v.declarationList), As();
              }
              function su(v) {
                v ? Gt(";") : As();
              }
              function tl(v) {
                Tr(v.expression, Gi.parenthesizeExpressionOfExpressionStatement), (!Re || !e.isJsonSourceFile(Re) || e.nodeIsSynthesized(v.expression)) && As();
              }
              function Zc(v) {
                var sr = Ya(99, v.pos, vn, v);
                Ut(), Ya(20, sr, Gt, v), Tr(v.expression), Ya(21, v.expression.end, Gt, v), Al(v, v.thenStatement), v.elseStatement && (zf(v, v.thenStatement, v.elseStatement), Ya(91, v.thenStatement.end, vn, v), v.elseStatement.kind === 239 ? (Ut(), gr(v.elseStatement)) : Al(v, v.elseStatement));
              }
              function Rf(v, sr) {
                var fi = Ya(115, sr, vn, v);
                Ut(), Ya(20, fi, Gt, v), Tr(v.expression), Ya(21, v.expression.end, Gt, v);
              }
              function al(v) {
                Ya(90, v.pos, vn, v), Al(v, v.statement), e.isBlock(v.statement) && !de ? Ut() : zf(v, v.statement, v.expression), Rf(v, v.statement.end), As();
              }
              function Jo(v) {
                Rf(v, v.pos), Al(v, v.statement);
              }
              function eu(v) {
                var sr = Ya(97, v.pos, vn, v);
                Ut();
                var fi = Ya(20, sr, Gt, v);
                Uu(v.initializer), fi = Ya(26, v.initializer ? v.initializer.end : fi, Gt, v), __(v.condition), fi = Ya(26, v.condition ? v.condition.end : fi, Gt, v), __(v.incrementor), Ya(21, v.incrementor ? v.incrementor.end : fi, Gt, v), Al(v, v.statement);
              }
              function Ws(v) {
                var sr = Ya(97, v.pos, vn, v);
                Ut(), Ya(20, sr, Gt, v), Uu(v.initializer), Ut(), Ya(101, v.initializer.end, vn, v), Ut(), Tr(v.expression), Ya(21, v.expression.end, Gt, v), Al(v, v.statement);
              }
              function pu(v) {
                var sr = Ya(97, v.pos, vn, v);
                Ut(), zd(v.awaitModifier), Ya(20, sr, Gt, v), Uu(v.initializer), Ut(), Ya(160, v.initializer.end, vn, v), Ut(), Tr(v.expression), Ya(21, v.expression.end, Gt, v), Al(v, v.statement);
              }
              function Uu(v) {
                v !== void 0 && (v.kind === 255 ? gr(v) : Tr(v));
              }
              function Ql(v) {
                Ya(86, v.pos, vn, v), kl(v.label), As();
              }
              function xl(v) {
                Ya(81, v.pos, vn, v), kl(v.label), As();
              }
              function Ya(v, sr, fi, zi, Sa) {
                var da = e.getParseTreeNode(zi), Ha = da && da.kind === zi.kind, ta = sr;
                if (Ha && Re && (sr = e.skipTrivia(Re.text, sr)), Ha && zi.pos !== ta) {
                  var nn = Sa && Re && !e.positionsAreOnSameLine(ta, sr, Re);
                  nn && Dc(), Vf(ta), nn && Cc();
                }
                if (sr = Il(v, fi, sr), Ha && zi.end !== sr) {
                  var Wo = zi.kind === 288;
                  af(sr, !Wo, Wo);
                }
                return sr;
              }
              function du(v) {
                return v.kind === 2 || !!v.hasTrailingNewLine;
              }
              function vc(v) {
                return Re ? e.some(e.getLeadingCommentRanges(Re.text, v.pos), du) || e.some(e.getSyntheticLeadingComments(v), du) ? true : e.isPartiallyEmittedExpression(v) ? v.pos !== v.expression.pos && e.some(e.getTrailingCommentRanges(Re.text, v.expression.pos), du) ? true : vc(v.expression) : false : false;
              }
              function Kr(v) {
                if (!qr && e.isPartiallyEmittedExpression(v) && vc(v)) {
                  var sr = e.getParseTreeNode(v);
                  if (sr && e.isParenthesizedExpression(sr)) {
                    var fi = e.factory.createParenthesizedExpression(v.expression);
                    return e.setOriginalNode(fi, v), e.setTextRange(fi, sr), fi;
                  }
                  return e.factory.createParenthesizedExpression(v);
                }
                return v;
              }
              function _i(v) {
                return Kr(Gi.parenthesizeExpressionForDisallowedComma(v));
              }
              function Ei(v) {
                Ya(105, v.pos, vn, v), __(v.expression && Kr(v.expression), Kr), As();
              }
              function tt(v) {
                var sr = Ya(116, v.pos, vn, v);
                Ut(), Ya(20, sr, Gt, v), Tr(v.expression), Ya(21, v.expression.end, Gt, v), Al(v, v.statement);
              }
              function kt(v) {
                var sr = Ya(107, v.pos, vn, v);
                Ut(), Ya(20, sr, Gt, v), Tr(v.expression), Ya(21, v.expression.end, Gt, v), Ut(), gr(v.caseBlock);
              }
              function bt(v) {
                gr(v.label), Ya(58, v.label.end, Gt, v), Ut(), gr(v.statement);
              }
              function ia(v) {
                Ya(109, v.pos, vn, v), __(Kr(v.expression), Kr), As();
              }
              function Xt(v) {
                Ya(111, v.pos, vn, v), Ut(), gr(v.tryBlock), v.catchClause && (zf(v, v.tryBlock, v.catchClause), gr(v.catchClause)), v.finallyBlock && (zf(v, v.catchClause || v.tryBlock, v.finallyBlock), Ya(96, (v.catchClause || v.tryBlock).end, vn, v), Ut(), gr(v.finallyBlock));
              }
              function Za(v) {
                ac(87, v.pos, vn), As();
              }
              function bn(v) {
                var sr, fi, zi, Sa, da;
                gr(v.name), gr(v.exclamationToken), Wu(v.type), Zl(v.initializer, (da = (fi = (sr = v.type) === null || sr === void 0 ? void 0 : sr.end) !== null && fi !== void 0 ? fi : (Sa = (zi = v.name.emitNode) === null || zi === void 0 ? void 0 : zi.typeNode) === null || Sa === void 0 ? void 0 : Sa.end) !== null && da !== void 0 ? da : v.name.end, v, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function _a(v) {
                vn(e.isLet(v) ? "let" : e.isVarConst(v) ? "const" : "var"), Ut(), Zn(v, v.declarations, 528);
              }
              function qa(v) {
                rn(v);
              }
              function rn(v) {
                wc(v, v.decorators), ks(v, v.modifiers), vn("function"), gr(v.asteriskToken), Ut(), Vr(v.name), jn(v, Mo);
              }
              function jn(v, sr) {
                var fi = v.body;
                if (fi) if (e.isBlock(fi)) {
                  var zi = e.getEmitFlags(v) & 65536;
                  zi && Dc(), wl(v), e.forEach(v.parameters, Et), Et(v.body), sr(v), gs(fi), Iu(v), zi && Cc();
                } else sr(v), Ut(), Tr(fi, Gi.parenthesizeConciseBodyOfArrowFunction);
                else sr(v), As();
              }
              function Mo(v) {
                Vu(v, v.typeParameters), ef(v, v.parameters), Wu(v.type);
              }
              function ho(v) {
                if (e.getEmitFlags(v) & 1) return true;
                if (v.multiLine || !e.nodeIsSynthesized(v) && Re && !e.rangeIsOnSingleLine(v, Re) || Ap(v, v.statements, 2) || Sf(v, v.statements, 2)) return false;
                for (var sr, fi = 0, zi = v.statements; fi < zi.length; fi++) {
                  var Sa = zi[fi];
                  if (Wf(sr, Sa, 2) > 0) return false;
                  sr = Sa;
                }
                return true;
              }
              function gs(v) {
                D == null || D(v), Ut(), Gt("{"), Dc();
                var sr = ho(v) ? Se : hr;
                Mp(v, v.statements, sr), Cc(), ac(19, v.statements.end, Gt, v), fe == null || fe(v);
              }
              function Se(v) {
                hr(v, true);
              }
              function hr(v, sr) {
                var fi = $l(v.statements), zi = Ae.getTextPos();
                Fi(v), fi === 0 && zi === Ae.getTextPos() && sr ? (Cc(), Zn(v, v.statements, 768), Dc()) : Zn(v, v.statements, 1, void 0, fi);
              }
              function Or(v) {
                ki(v);
              }
              function ki(v) {
                e.forEach(v.members, Ys), wc(v, v.decorators), ks(v, v.modifiers), vn("class"), v.name && (Ut(), Vr(v.name));
                var sr = e.getEmitFlags(v) & 65536;
                sr && Dc(), Vu(v, v.typeParameters), Zn(v, v.heritageClauses, 0), Ut(), Gt("{"), Zn(v, v.members, 129), Gt("}"), sr && Cc();
              }
              function dt(v) {
                wc(v, v.decorators), ks(v, v.modifiers), vn("interface"), Ut(), gr(v.name), Vu(v, v.typeParameters), Zn(v, v.heritageClauses, 512), Ut(), Gt("{"), Zn(v, v.members, 129), Gt("}");
              }
              function la(v) {
                wc(v, v.decorators), ks(v, v.modifiers), vn("type"), Ut(), gr(v.name), Vu(v, v.typeParameters), Ut(), Gt("="), Ut(), gr(v.type), As();
              }
              function wa(v) {
                ks(v, v.modifiers), vn("enum"), Ut(), gr(v.name), Ut(), Gt("{"), Zn(v, v.members, 145), Gt("}");
              }
              function On(v) {
                ks(v, v.modifiers), ~v.flags & 1024 && (vn(v.flags & 16 ? "namespace" : "module"), Ut()), gr(v.name);
                var sr = v.body;
                if (!sr) return As();
                for (; sr && e.isModuleDeclaration(sr); ) Gt("."), gr(sr.name), sr = sr.body;
                Ut(), gr(sr);
              }
              function No(v) {
                wl(v), e.forEach(v.statements, Et), Bs(v, vd(v)), Iu(v);
              }
              function jo(v) {
                Ya(18, v.pos, Gt, v), Zn(v, v.clauses, 129), Ya(19, v.clauses.end, Gt, v, true);
              }
              function po(v) {
                ks(v, v.modifiers), Ya(100, v.modifiers ? v.modifiers.end : v.pos, vn, v), Ut(), v.isTypeOnly && (Ya(152, v.pos, vn, v), Ut()), gr(v.name), Ut(), Ya(63, v.name.end, Gt, v), Ut(), Gn(v.moduleReference), As();
              }
              function Gn(v) {
                v.kind === 79 ? Tr(v) : gr(v);
              }
              function $n(v) {
                ks(v, v.modifiers), Ya(100, v.modifiers ? v.modifiers.end : v.pos, vn, v), Ut(), v.importClause && (gr(v.importClause), Ut(), Ya(156, v.importClause.end, vn, v), Ut()), Tr(v.moduleSpecifier), v.assertClause && kl(v.assertClause), As();
              }
              function Ho(v) {
                v.isTypeOnly && (Ya(152, v.pos, vn, v), Ut()), gr(v.name), v.name && v.namedBindings && (Ya(27, v.name.end, Gt, v), Ut()), gr(v.namedBindings);
              }
              function Zo(v) {
                var sr = Ya(41, v.pos, Gt, v);
                Ut(), Ya(127, sr, vn, v), Ut(), gr(v.name);
              }
              function Es(v) {
                oo(v);
              }
              function yc(v) {
                I_(v);
              }
              function Xr(v) {
                var sr = Ya(93, v.pos, vn, v);
                Ut(), v.isExportEquals ? Ya(63, sr, Nl, v) : Ya(88, sr, vn, v), Ut(), Tr(v.expression, v.isExportEquals ? Gi.getParenthesizeRightSideOfBinaryForOperator(63) : Gi.parenthesizeExpressionOfExportDefault), As();
              }
              function Ls(v) {
                var sr = Ya(93, v.pos, vn, v);
                if (Ut(), v.isTypeOnly && (sr = Ya(152, sr, vn, v), Ut()), v.exportClause ? gr(v.exportClause) : sr = Ya(41, sr, Gt, v), v.moduleSpecifier) {
                  Ut();
                  var fi = v.exportClause ? v.exportClause.end : sr;
                  Ya(156, fi, vn, v), Ut(), Tr(v.moduleSpecifier);
                }
                v.assertClause && kl(v.assertClause), As();
              }
              function Ic(v) {
                Ya(129, v.pos, vn, v), Ut();
                var sr = v.elements;
                Zn(v, sr, 526226);
              }
              function zu(v) {
                gr(v.name), Gt(":"), Ut();
                var sr = v.value;
                if ((e.getEmitFlags(sr) & 512) === 0) {
                  var fi = e.getCommentRange(sr);
                  af(fi.pos);
                }
                gr(sr);
              }
              function vf(v) {
                var sr = Ya(93, v.pos, vn, v);
                Ut(), sr = Ya(127, sr, vn, v), Ut(), sr = Ya(142, sr, vn, v), Ut(), gr(v.name), As();
              }
              function P_(v) {
                var sr = Ya(41, v.pos, Gt, v);
                Ut(), Ya(127, sr, vn, v), Ut(), gr(v.name);
              }
              function El(v) {
                oo(v);
              }
              function vp(v) {
                I_(v);
              }
              function oo(v) {
                Gt("{"), Zn(v, v.elements, 525136), Gt("}");
              }
              function I_(v) {
                v.isTypeOnly && (vn("type"), Ut()), v.propertyName && (gr(v.propertyName), Ut(), Ya(127, v.propertyName.end, vn, v), Ut()), gr(v.name);
              }
              function yp(v) {
                vn("require"), Gt("("), Tr(v.expression), Gt(")");
              }
              function Yl(v) {
                gr(v.openingElement), Zn(v, v.children, 262144), gr(v.closingElement);
              }
              function Bf(v) {
                Gt("<"), ns(v.tagName), qu(v, v.typeArguments), Ut(), gr(v.attributes), Gt("/>");
              }
              function Cl(v) {
                gr(v.openingFragment), Zn(v, v.children, 262144), gr(v.closingFragment);
              }
              function c_(v) {
                if (Gt("<"), e.isJsxOpeningElement(v)) {
                  var sr = J_(v.tagName, v);
                  ns(v.tagName), qu(v, v.typeArguments), v.attributes.properties && v.attributes.properties.length > 0 && Ut(), gr(v.attributes), j_(v.attributes, v), Us(sr);
                }
                Gt(">");
              }
              function hp(v) {
                Ae.writeLiteral(v.text);
              }
              function gu(v) {
                Gt("</"), e.isJsxClosingElement(v) && ns(v.tagName), Gt(">");
              }
              function Dp(v) {
                Zn(v, v.properties, 262656);
              }
              function sd(v) {
                gr(v.name), R_("=", Gt, v.initializer, vi);
              }
              function Aa(v) {
                Gt("{..."), Tr(v.expression), Gt("}");
              }
              function va(v) {
                var sr = false;
                return e.forEachTrailingCommentRange((Re == null ? void 0 : Re.text) || "", v + 1, function() {
                  return sr = true;
                }), sr;
              }
              function Cu(v) {
                var sr = false;
                return e.forEachLeadingCommentRange((Re == null ? void 0 : Re.text) || "", v + 1, function() {
                  return sr = true;
                }), sr;
              }
              function qs(v) {
                return va(v) || Cu(v);
              }
              function cd(v) {
                var sr;
                if (v.expression || !qr && !e.nodeIsSynthesized(v) && qs(v.pos)) {
                  var fi = Re && !e.nodeIsSynthesized(v) && e.getLineAndCharacterOfPosition(Re, v.pos).line !== e.getLineAndCharacterOfPosition(Re, v.end).line;
                  fi && Ae.increaseIndent();
                  var zi = Ya(18, v.pos, Gt, v);
                  gr(v.dotDotDotToken), Tr(v.expression), Ya(19, ((sr = v.expression) === null || sr === void 0 ? void 0 : sr.end) || zi, Gt, v), fi && Ae.decreaseIndent();
                }
              }
              function ns(v) {
                v.kind === 79 ? Tr(v) : gr(v);
              }
              function nl(v) {
                Ya(82, v.pos, vn, v), Ut(), Tr(v.expression, Gi.parenthesizeExpressionForDisallowedComma), es(v, v.statements, v.expression.end);
              }
              function hc(v) {
                var sr = Ya(88, v.pos, vn, v);
                es(v, v.statements, sr);
              }
              function es(v, sr, fi) {
                var zi = sr.length === 1 && (!Re || e.nodeIsSynthesized(v) || e.nodeIsSynthesized(sr[0]) || e.rangeStartPositionsAreOnSameLine(v, sr[0], Re)), Sa = 163969;
                zi ? (ac(58, fi, Gt, v), Ut(), Sa &= -130) : Ya(58, fi, Gt, v), Zn(v, sr, Sa);
              }
              function u_(v) {
                Ut(), Il(v.token, vn), Ut(), Zn(v, v.types, 528);
              }
              function Jf(v) {
                var sr = Ya(83, v.pos, vn, v);
                Ut(), v.variableDeclaration && (Ya(20, sr, Gt, v), gr(v.variableDeclaration), Ya(21, v.variableDeclaration.end, Gt, v), Ut()), gr(v.block);
              }
              function w_(v) {
                gr(v.name), Gt(":"), Ut();
                var sr = v.initializer;
                if ((e.getEmitFlags(sr) & 512) === 0) {
                  var fi = e.getCommentRange(sr);
                  af(fi.pos);
                }
                Tr(sr, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function ud(v) {
                gr(v.name), v.objectAssignmentInitializer && (Ut(), Gt("="), Ut(), Tr(v.objectAssignmentInitializer, Gi.parenthesizeExpressionForDisallowedComma));
              }
              function ku(v) {
                v.expression && (Ya(25, v.pos, Gt, v), Tr(v.expression, Gi.parenthesizeExpressionForDisallowedComma));
              }
              function ld(v) {
                gr(v.name), Zl(v.initializer, v.name.end, v, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function fd(v) {
                if (ir("/**"), v.comment) {
                  var sr = e.getTextOfJSDocComment(v.comment);
                  if (sr) for (var fi = sr.split(/\r\n?|\n/g), zi = 0, Sa = fi; zi < Sa.length; zi++) {
                    var da = Sa[zi];
                    bs(), Ut(), Gt("*"), Ut(), ir(da);
                  }
                }
                v.tags && (v.tags.length === 1 && v.tags[0].kind === 343 && !v.comment ? (Ut(), gr(v.tags[0])) : Zn(v, v.tags, 33)), Ut(), ir("*/");
              }
              function bp(v) {
                ol(v.tagName), ru(v.typeExpression), Au(v.comment);
              }
              function Sp(v) {
                ol(v.tagName), gr(v.name), Au(v.comment);
              }
              function Tp(v) {
                Ut(), Gt("{"), gr(v.name), Gt("}");
              }
              function _d(v) {
                ol(v.tagName), Ut(), Gt("{"), gr(v.class), Gt("}"), Au(v.comment);
              }
              function jf(v) {
                ol(v.tagName), ru(v.constraint), Ut(), Zn(v, v.typeParameters, 528), Au(v.comment);
              }
              function O_(v) {
                ol(v.tagName), v.typeExpression && (v.typeExpression.kind === 309 ? ru(v.typeExpression) : (Ut(), Gt("{"), ir("Object"), v.typeExpression.isArrayType && (Gt("["), Gt("]")), Gt("}"))), v.fullName && (Ut(), gr(v.fullName)), Au(v.comment), v.typeExpression && v.typeExpression.kind === 322 && xp(v.typeExpression);
              }
              function F_(v) {
                ol(v.tagName), v.name && (Ut(), gr(v.name)), Au(v.comment), M_(v.typeExpression);
              }
              function pd(v) {
                ol(v.tagName), Au(v.comment);
              }
              function xp(v) {
                Zn(v, e.factory.createNodeArray(v.jsDocPropertyTags), 33);
              }
              function M_(v) {
                v.typeParameters && Zn(v, e.factory.createNodeArray(v.typeParameters), 33), v.parameters && Zn(v, e.factory.createNodeArray(v.parameters), 33), v.type && (bs(), Ut(), Gt("*"), Ut(), gr(v.type));
              }
              function Ep(v) {
                ol(v.tagName), ru(v.typeExpression), Ut(), v.isBracketed && Gt("["), gr(v.name), v.isBracketed && Gt("]"), Au(v.comment);
              }
              function ol(v) {
                Gt("@"), gr(v);
              }
              function Au(v) {
                var sr = e.getTextOfJSDocComment(v);
                sr && (Ut(), ir(sr));
              }
              function ru(v) {
                v && (Ut(), Gt("{"), gr(v.type), Gt("}"));
              }
              function yf(v) {
                bs();
                var sr = v.statements, fi = sr.length === 0 || !e.isPrologueDirective(sr[0]) || e.nodeIsSynthesized(sr[0]);
                if (fi) {
                  Mp(v, sr, mu);
                  return;
                }
                mu(v);
              }
              function Cp(v) {
                kp(!!v.hasNoDefaultLib, v.syntheticFileReferences || [], v.syntheticTypeReferences || [], v.syntheticLibReferences || []);
                for (var sr = 0, fi = v.prepends; sr < fi.length; sr++) {
                  var zi = fi[sr];
                  if (e.isUnparsedSource(zi) && zi.syntheticReferences) for (var Sa = 0, da = zi.syntheticReferences; Sa < da.length; Sa++) {
                    var Ha = da[Sa];
                    gr(Ha), bs();
                  }
                }
              }
              function dd(v) {
                v.isDeclarationFile && kp(v.hasNoDefaultLib, v.referencedFiles, v.typeReferenceDirectives, v.libReferenceDirectives);
              }
              function kp(v, sr, fi, zi) {
                if (v) {
                  var Sa = Ae.getTextPos();
                  rf('/// <reference no-default-lib="true"/>'), Ye && Ye.sections.push({ pos: Sa, end: Ae.getTextPos(), kind: "no-default-lib" }), bs();
                }
                if (Re && Re.moduleName && (rf('/// <amd-module name="'.concat(Re.moduleName, '" />')), bs()), Re && Re.amdDependencies) for (var da = 0, Ha = Re.amdDependencies; da < Ha.length; da++) {
                  var ta = Ha[da];
                  ta.name ? rf('/// <amd-dependency name="'.concat(ta.name, '" path="').concat(ta.path, '" />')) : rf('/// <amd-dependency path="'.concat(ta.path, '" />')), bs();
                }
                for (var nn = 0, Wo = sr; nn < Wo.length; nn++) {
                  var Lo = Wo[nn], Sa = Ae.getTextPos();
                  rf('/// <reference path="'.concat(Lo.fileName, '" />')), Ye && Ye.sections.push({ pos: Sa, end: Ae.getTextPos(), kind: "reference", data: Lo.fileName }), bs();
                }
                for (var oc = 0, uu = fi; oc < uu.length; oc++) {
                  var Lo = uu[oc], Sa = Ae.getTextPos(), is = Lo.resolutionMode && Lo.resolutionMode !== (Re == null ? void 0 : Re.impliedNodeFormat) ? 'resolution-mode="'.concat(Lo.resolutionMode === e.ModuleKind.ESNext ? "import" : "require", '"') : "";
                  rf('/// <reference types="'.concat(Lo.fileName, '" ').concat(is, "/>")), Ye && Ye.sections.push({ pos: Sa, end: Ae.getTextPos(), kind: Lo.resolutionMode ? Lo.resolutionMode === e.ModuleKind.ESNext ? "type-import" : "type-require" : "type", data: Lo.fileName }), bs();
                }
                for (var au = 0, Ou = zi; au < Ou.length; au++) {
                  var Lo = Ou[au], Sa = Ae.getTextPos();
                  rf('/// <reference lib="'.concat(Lo.fileName, '" />')), Ye && Ye.sections.push({ pos: Sa, end: Ae.getTextPos(), kind: "lib", data: Lo.fileName }), bs();
                }
              }
              function mu(v) {
                var sr = v.statements;
                wl(v), e.forEach(v.statements, Et), Fi(v);
                var fi = e.findIndex(sr, function(zi) {
                  return !e.isPrologueDirective(zi);
                });
                dd(v), Zn(v, sr, 1, void 0, fi === -1 ? sr.length : fi), Iu(v);
              }
              function gd(v) {
                var sr = e.getEmitFlags(v);
                !(sr & 512) && v.pos !== v.expression.pos && af(v.expression.pos), Tr(v.expression), !(sr & 1024) && v.end !== v.expression.end && Vf(v.expression.end);
              }
              function hf(v) {
                os(v, v.elements, 528, void 0);
              }
              function $l(v, sr, fi, zi) {
                for (var Sa = !!sr, da = 0; da < v.length; da++) {
                  var Ha = v[da];
                  if (e.isPrologueDirective(Ha)) {
                    var ta = fi ? !fi.has(Ha.expression.text) : true;
                    if (ta) {
                      Sa && (Sa = false, Pe(sr)), bs();
                      var nn = Ae.getTextPos();
                      gr(Ha), zi && Ye && Ye.sections.push({ pos: nn, end: Ae.getTextPos(), kind: "prologue", data: Ha.expression.text }), fi && fi.add(Ha.expression.text);
                    }
                  } else return da;
                }
                return v.length;
              }
              function Uf(v, sr) {
                for (var fi = 0, zi = v; fi < zi.length; fi++) {
                  var Sa = zi[fi];
                  if (!sr.has(Sa.data)) {
                    bs();
                    var da = Ae.getTextPos();
                    gr(Sa), Ye && Ye.sections.push({ pos: da, end: Ae.getTextPos(), kind: "prologue", data: Sa.data }), sr && sr.add(Sa.data);
                  }
                }
              }
              function L_(v) {
                if (e.isSourceFile(v)) $l(v.statements, v);
                else {
                  for (var sr = new e.Set(), fi = 0, zi = v.prepends; fi < zi.length; fi++) {
                    var Sa = zi[fi];
                    Uf(Sa.prologues, sr);
                  }
                  for (var da = 0, Ha = v.sourceFiles; da < Ha.length; da++) {
                    var ta = Ha[da];
                    $l(ta.statements, ta, sr, true);
                  }
                  Pe(void 0);
                }
              }
              function l_(v) {
                for (var sr = new e.Set(), fi, zi = 0; zi < v.sourceFiles.length; zi++) {
                  for (var Sa = v.sourceFiles[zi], da = void 0, Ha = 0, ta = 0, nn = Sa.statements; ta < nn.length; ta++) {
                    var Wo = nn[ta];
                    if (!e.isPrologueDirective(Wo)) break;
                    sr.has(Wo.expression.text) || (sr.add(Wo.expression.text), (da || (da = [])).push({ pos: Wo.pos, end: Wo.end, expression: { pos: Wo.expression.pos, end: Wo.expression.end, text: Wo.expression.text } }), Ha = Ha < Wo.end ? Wo.end : Ha);
                  }
                  da && (fi || (fi = [])).push({ file: zi, text: Sa.text.substring(0, Ha), directives: da });
                }
                return fi;
              }
              function f_(v) {
                if (e.isSourceFile(v) || e.isUnparsedSource(v)) {
                  var sr = e.getShebang(v.text);
                  if (sr) return rf(sr), bs(), true;
                } else {
                  for (var fi = 0, zi = v.prepends; fi < zi.length; fi++) {
                    var Sa = zi[fi];
                    if (e.Debug.assertNode(Sa, e.isUnparsedSource), f_(Sa)) return true;
                  }
                  for (var da = 0, Ha = v.sourceFiles; da < Ha.length; da++) {
                    var ta = Ha[da];
                    if (f_(ta)) return true;
                  }
                }
              }
              function md(v, sr) {
                if (!!v) {
                  var fi = ir;
                  ir = sr, gr(v), ir = fi;
                }
              }
              function ks(v, sr) {
                sr && sr.length && (Zn(v, sr, 262656), Ut());
              }
              function Wu(v) {
                v && (Gt(":"), Ut(), gr(v));
              }
              function Zl(v, sr, fi, zi) {
                v && (Ut(), Ya(63, sr, Nl, fi), Ut(), Tr(v, zi));
              }
              function R_(v, sr, fi, zi) {
                fi && (sr(v), zi(fi));
              }
              function kl(v) {
                v && (Ut(), gr(v));
              }
              function __(v, sr) {
                v && (Ut(), Tr(v, sr));
              }
              function zd(v) {
                v && (gr(v), Ut());
              }
              function Al(v, sr) {
                e.isBlock(sr) || e.getEmitFlags(v) & 1 ? (Ut(), gr(sr)) : (bs(), Dc(), e.isEmptyStatement(sr) ? Wi(5, sr) : gr(sr), Cc());
              }
              function wc(v, sr) {
                Zn(v, sr, 2146305);
              }
              function qu(v, sr) {
                Zn(v, sr, 53776, Wt);
              }
              function Vu(v, sr) {
                if (e.isFunctionLike(v) && v.typeArguments) return qu(v, v.typeArguments);
                Zn(v, sr, 53776);
              }
              function ef(v, sr) {
                Zn(v, sr, 2576);
              }
              function sl(v, sr) {
                var fi = e.singleOrUndefined(sr);
                return fi && fi.pos === v.pos && e.isArrowFunction(v) && !v.type && !e.some(v.decorators) && !e.some(v.modifiers) && !e.some(v.typeParameters) && !e.some(fi.decorators) && !e.some(fi.modifiers) && !fi.dotDotDotToken && !fi.questionToken && !fi.type && !fi.initializer && e.isIdentifier(fi.name);
              }
              function p_(v, sr) {
                sl(v, sr) ? Zn(v, sr, 528) : ef(v, sr);
              }
              function Df(v, sr) {
                Zn(v, sr, 8848);
              }
              function Ec(v) {
                switch (v & 60) {
                  case 0:
                    break;
                  case 16:
                    Gt(",");
                    break;
                  case 4:
                    Ut(), Gt("|");
                    break;
                  case 32:
                    Ut(), Gt("*"), Ut();
                    break;
                  case 8:
                    Ut(), Gt("&");
                    break;
                }
              }
              function Zn(v, sr, fi, zi, Sa, da) {
                Ps(gr, v, sr, fi, zi, Sa, da);
              }
              function os(v, sr, fi, zi, Sa, da) {
                Ps(Tr, v, sr, fi, zi, Sa, da);
              }
              function Ps(v, sr, fi, zi, Sa, da, Ha) {
                da === void 0 && (da = 0), Ha === void 0 && (Ha = fi ? fi.length - da : 0);
                var ta = fi === void 0;
                if (!(ta && zi & 16384)) {
                  var nn = fi === void 0 || da >= fi.length || Ha === 0;
                  if (nn && zi & 32768) {
                    g && g(fi), ne && ne(fi);
                    return;
                  }
                  if (zi & 15360 && (Gt(X(zi)), nn && fi && af(fi.pos, true)), g && g(fi), nn) zi & 1 && !(de && (!sr || Re && e.rangeIsOnSingleLine(sr, Re))) ? bs() : zi & 256 && !(zi & 524288) && Ut();
                  else {
                    e.Debug.type(fi);
                    var Wo = (zi & 262144) === 0, Lo = Wo, oc = Ap(sr, fi, zi);
                    oc ? (bs(oc), Lo = false) : zi & 256 && Ut(), zi & 128 && Dc();
                    for (var uu = P(v, Sa), is = void 0, au = void 0, Ou = false, sf = 0; sf < Ha; sf++) {
                      var lu = fi[da + sf];
                      if (zi & 32) bs(), Ec(zi);
                      else if (is) {
                        zi & 60 && is.end !== (sr ? sr.end : -1) && Vf(is.end), Ec(zi), Je(au);
                        var cf = Wf(is, lu, zi);
                        cf > 0 ? ((zi & 131) === 0 && (Dc(), Ou = true), bs(cf), Lo = false) : is && zi & 512 && Ut();
                      }
                      if (au = Wr(lu), Lo) {
                        var uf = e.getCommentRange(lu);
                        af(uf.pos);
                      } else Lo = Wo;
                      ye = lu.pos, uu(lu, v, Sa, sf), Ou && (Cc(), Ou = false), is = lu;
                    }
                    var K_ = is ? e.getEmitFlags(is) : 0, Jp = qr || !!(K_ & 1024), Hf = (fi == null ? void 0 : fi.hasTrailingComma) && zi & 64 && zi & 16;
                    Hf && (is && !Jp ? Ya(27, is.end, Gt, is) : Gt(",")), is && (sr ? sr.end : -1) !== is.end && zi & 60 && !Jp && Vf(Hf && (fi == null ? void 0 : fi.end) ? fi.end : is.end), zi & 128 && Cc(), Je(au);
                    var kc = Sf(sr, fi, zi);
                    kc ? bs(kc) : zi & 2097408 && Ut();
                  }
                  ne && ne(fi), zi & 15360 && (nn && fi && Vf(fi.end), Gt($(zi)));
                }
              }
              function d_(v) {
                Ae.writeLiteral(v);
              }
              function Gc(v) {
                Ae.writeStringLiteral(v);
              }
              function B_(v) {
                Ae.write(v);
              }
              function vu(v, sr) {
                Ae.writeSymbol(v, sr);
              }
              function Gt(v) {
                Ae.writePunctuation(v);
              }
              function As() {
                Ae.writeTrailingSemicolon(";");
              }
              function vn(v) {
                Ae.writeKeyword(v);
              }
              function Nl(v) {
                Ae.writeOperator(v);
              }
              function cl(v) {
                Ae.writeParameter(v);
              }
              function rf(v) {
                Ae.writeComment(v);
              }
              function Ut() {
                Ae.writeSpace(" ");
              }
              function Ds(v) {
                Ae.writeProperty(v);
              }
              function bf(v) {
                Ae.nonEscapingWrite ? Ae.nonEscapingWrite(v) : Ae.write(v);
              }
              function bs(v) {
                v === void 0 && (v = 1);
                for (var sr = 0; sr < v; sr++) Ae.writeLine(sr > 0);
              }
              function Dc() {
                Ae.increaseIndent();
              }
              function Cc() {
                Ae.decreaseIndent();
              }
              function ac(v, sr, fi, zi) {
                return lr ? Il(v, fi, sr) : of(zi, v, fi, sr, Il);
              }
              function Pl(v, sr) {
                ue && ue(v), sr(e.tokenToString(v.kind)), We && We(v);
              }
              function Il(v, sr, fi) {
                var zi = e.tokenToString(v);
                return sr(zi), fi < 0 ? fi : fi + zi.length;
              }
              function zf(v, sr, fi) {
                if (e.getEmitFlags(v) & 1) Ut();
                else if (de) {
                  var zi = iu(v, sr, fi);
                  zi ? bs(zi) : Ut();
                } else bs();
              }
              function ul(v) {
                for (var sr = v.split(/\r\n?|\n/g), fi = e.guessIndentation(sr), zi = 0, Sa = sr; zi < Sa.length; zi++) {
                  var da = Sa[zi], Ha = fi ? da.slice(fi) : da;
                  Ha.length && (bs(), ir(Ha));
                }
              }
              function Nu(v, sr) {
                v ? (Dc(), bs(v)) : sr && Ut();
              }
              function Us(v, sr) {
                v && Cc(), sr && Cc();
              }
              function Ap(v, sr, fi) {
                if (fi & 2 || de) {
                  if (fi & 65536) return 1;
                  var zi = sr[0];
                  if (zi === void 0) return !v || Re && e.rangeIsOnSingleLine(v, Re) ? 0 : 1;
                  if (zi.pos === ye || zi.kind === 11) return 0;
                  if (Re && v && !e.positionIsSynthesized(v.pos) && !e.nodeIsSynthesized(zi) && (!zi.parent || e.getOriginalNode(zi.parent) === e.getOriginalNode(v))) return de ? ll(function(Sa) {
                    return e.getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter(zi.pos, v.pos, Re, Sa);
                  }) : e.rangeStartPositionsAreOnSameLine(v, zi, Re) ? 0 : 1;
                  if (U_(zi, fi)) return 1;
                }
                return fi & 1 ? 1 : 0;
              }
              function Wf(v, sr, fi) {
                if (fi & 2 || de) {
                  if (v === void 0 || sr === void 0 || sr.kind === 11) return 0;
                  if (Re && !e.nodeIsSynthesized(v) && !e.nodeIsSynthesized(sr)) return de && Lp(v, sr) ? ll(function(zi) {
                    return e.getLinesBetweenRangeEndAndRangeStart(v, sr, Re, zi);
                  }) : !de && Gu(v, sr) ? e.rangeEndIsOnSameLineAsRangeStart(v, sr, Re) ? 0 : 1 : fi & 65536 ? 1 : 0;
                  if (U_(v, fi) || U_(sr, fi)) return 1;
                } else if (e.getStartsOnNewLine(sr)) return 1;
                return fi & 1 ? 1 : 0;
              }
              function Sf(v, sr, fi) {
                if (fi & 2 || de) {
                  if (fi & 65536) return 1;
                  var zi = e.lastOrUndefined(sr);
                  if (zi === void 0) return !v || Re && e.rangeIsOnSingleLine(v, Re) ? 0 : 1;
                  if (Re && v && !e.positionIsSynthesized(v.pos) && !e.nodeIsSynthesized(zi) && (!zi.parent || zi.parent === v)) {
                    if (de) {
                      var Sa = e.isNodeArray(sr) && !e.positionIsSynthesized(sr.end) ? sr.end : zi.end;
                      return ll(function(da) {
                        return e.getLinesBetweenPositionAndNextNonWhitespaceCharacter(Sa, v.end, Re, da);
                      });
                    }
                    return e.rangeEndPositionsAreOnSameLine(v, zi, Re) ? 0 : 1;
                  }
                  if (U_(zi, fi)) return 1;
                }
                return fi & 1 && !(fi & 131072) ? 1 : 0;
              }
              function ll(v) {
                e.Debug.assert(!!de);
                var sr = v(true);
                return sr === 0 ? v(false) : sr;
              }
              function J_(v, sr) {
                var fi = de && Ap(sr, [v], 0);
                return fi && Nu(fi, false), !!fi;
              }
              function j_(v, sr) {
                var fi = de && Sf(sr, [v], 0);
                fi && bs(fi);
              }
              function U_(v, sr) {
                if (e.nodeIsSynthesized(v)) {
                  var fi = e.getStartsOnNewLine(v);
                  return fi === void 0 ? (sr & 65536) !== 0 : fi;
                }
                return (sr & 65536) !== 0;
              }
              function iu(v, sr, fi) {
                return e.getEmitFlags(v) & 131072 ? 0 : (v = qf(v), sr = qf(sr), fi = qf(fi), e.getStartsOnNewLine(fi) ? 1 : Re && !e.nodeIsSynthesized(v) && !e.nodeIsSynthesized(sr) && !e.nodeIsSynthesized(fi) ? de ? ll(function(zi) {
                  return e.getLinesBetweenRangeEndAndRangeStart(sr, fi, Re, zi);
                }) : e.rangeEndIsOnSameLineAsRangeStart(sr, fi, Re) ? 0 : 1 : 0);
              }
              function vd(v) {
                return v.statements.length === 0 && (!Re || e.rangeEndIsOnSameLineAsRangeStart(v, v, Re));
              }
              function qf(v) {
                for (; v.kind === 212 && e.nodeIsSynthesized(v); ) v = v.expression;
                return v;
              }
              function dc(v, sr) {
                if (e.isGeneratedIdentifier(v)) return Np(v);
                if (e.isStringLiteral(v) && v.textSourceNode) return dc(v.textSourceNode, sr);
                var fi = Re, zi = !!fi && !!v.parent && !e.nodeIsSynthesized(v);
                if (e.isMemberName(v)) {
                  if (!zi || e.getSourceFileOfNode(v) !== e.getOriginalNode(fi)) return e.idText(v);
                } else if (e.Debug.assertNode(v, e.isLiteralExpression), !zi) return v.text;
                return e.getSourceTextOfNodeFromSourceFile(fi, v, sr);
              }
              function Pu(v, sr, fi) {
                if (v.kind === 10 && v.textSourceNode) {
                  var zi = v.textSourceNode;
                  if (e.isIdentifier(zi) || e.isNumericLiteral(zi)) {
                    var Sa = e.isNumericLiteral(zi) ? zi.text : dc(zi);
                    return fi ? '"'.concat(e.escapeJsxAttributeString(Sa), '"') : sr || e.getEmitFlags(v) & 16777216 ? '"'.concat(e.escapeString(Sa), '"') : '"'.concat(e.escapeNonAsciiString(Sa), '"');
                  } else return Pu(zi, sr, fi);
                }
                var da = (sr ? 1 : 0) | (fi ? 2 : 0) | (k.terminateUnterminatedLiterals ? 4 : 0) | (k.target && k.target === 99 ? 8 : 0);
                return e.getLiteralText(v, Re, da);
              }
              function wl(v) {
                v && e.getEmitFlags(v) & 524288 || (rr.push(Ie), Ie = 0, _e.push(we));
              }
              function Iu(v) {
                v && e.getEmitFlags(v) & 524288 || (Ie = rr.pop(), we = _e.pop());
              }
              function so(v) {
                (!we || we === e.lastOrUndefined(_e)) && (we = new e.Set()), we.add(v);
              }
              function Et(v) {
                if (!!v) switch (v.kind) {
                  case 235:
                    e.forEach(v.statements, Et);
                    break;
                  case 250:
                  case 248:
                  case 240:
                  case 241:
                    Et(v.statement);
                    break;
                  case 239:
                    Et(v.thenStatement), Et(v.elseStatement);
                    break;
                  case 242:
                  case 244:
                  case 243:
                    Et(v.initializer), Et(v.statement);
                    break;
                  case 249:
                    Et(v.caseBlock);
                    break;
                  case 263:
                    e.forEach(v.clauses, Et);
                    break;
                  case 289:
                  case 290:
                    e.forEach(v.statements, Et);
                    break;
                  case 252:
                    Et(v.tryBlock), Et(v.catchClause), Et(v.finallyBlock);
                    break;
                  case 292:
                    Et(v.variableDeclaration), Et(v.block);
                    break;
                  case 237:
                    Et(v.declarationList);
                    break;
                  case 255:
                    e.forEach(v.declarations, Et);
                    break;
                  case 254:
                  case 164:
                  case 203:
                  case 257:
                    Ku(v.name);
                    break;
                  case 256:
                    Ku(v.name), e.getEmitFlags(v) & 524288 && (e.forEach(v.parameters, Et), Et(v.body));
                    break;
                  case 201:
                  case 202:
                    e.forEach(v.elements, Et);
                    break;
                  case 266:
                    Et(v.importClause);
                    break;
                  case 267:
                    Ku(v.name), Et(v.namedBindings);
                    break;
                  case 268:
                    Ku(v.name);
                    break;
                  case 274:
                    Ku(v.name);
                    break;
                  case 269:
                    e.forEach(v.elements, Et);
                    break;
                  case 270:
                    Ku(v.propertyName || v.name);
                    break;
                }
              }
              function Ys(v) {
                if (!!v) switch (v.kind) {
                  case 296:
                  case 297:
                  case 167:
                  case 169:
                  case 172:
                  case 173:
                    Ku(v.name);
                    break;
                }
              }
              function Ku(v) {
                v && (e.isGeneratedIdentifier(v) ? Np(v) : e.isBindingPattern(v) && Et(v));
              }
              function Np(v) {
                if ((v.autoGenerateFlags & 7) === 4) return Pp(tf(v), v.autoGenerateFlags);
                var sr = v.autoGenerateId;
                return Ee[sr] || (Ee[sr] = Ol(v));
              }
              function Pp(v, sr) {
                var fi = e.getNodeId(v);
                return ze[fi] || (ze[fi] = Hc(v, sr));
              }
              function nc(v) {
                return fl(v) && !He.has(v) && !(we && we.has(v));
              }
              function fl(v) {
                return Re ? e.isFileLevelUniqueName(Re, v, U) : true;
              }
              function _l(v, sr) {
                for (var fi = sr; e.isNodeDescendantOf(fi, sr); fi = fi.nextContainer) if (fi.locals) {
                  var zi = fi.locals.get(e.escapeLeadingUnderscores(v));
                  if (zi && zi.flags & 3257279) return false;
                }
                return true;
              }
              function cu(v, sr) {
                if (v && !(Ie & v)) {
                  var fi = v === 268435456 ? "_i" : "_n";
                  if (nc(fi)) return Ie |= v, sr && so(fi), fi;
                }
                for (; ; ) {
                  var zi = Ie & 268435455;
                  if (Ie++, zi !== 8 && zi !== 13) {
                    var fi = zi < 26 ? "_" + String.fromCharCode(97 + zi) : "_" + (zi - 26);
                    if (nc(fi)) return sr && so(fi), fi;
                  }
                }
              }
              function gc(v, sr, fi, zi) {
                if (sr === void 0 && (sr = nc), fi && sr(v)) return zi ? so(v) : He.add(v), v;
                v.charCodeAt(v.length - 1) !== 95 && (v += "_");
                for (var Sa = 1; ; ) {
                  var da = v + Sa;
                  if (sr(da)) return zi ? so(da) : He.add(da), da;
                  Sa++;
                }
              }
              function Tf(v) {
                return gc(v, fl, true);
              }
              function mc(v) {
                var sr = dc(v.name);
                return _l(sr, v) ? sr : gc(sr);
              }
              function Ip(v) {
                var sr = e.getExternalModuleName(v), fi = e.isStringLiteral(sr) ? e.makeIdentifierFromModuleName(sr.text) : "module";
                return gc(fi);
              }
              function ms() {
                return gc("default");
              }
              function tu() {
                return gc("class");
              }
              function wp(v) {
                return e.isIdentifier(v.name) ? Pp(v.name) : cu(0);
              }
              function Hc(v, sr) {
                switch (v.kind) {
                  case 79:
                    return gc(dc(v), nc, !!(sr & 16), !!(sr & 8));
                  case 261:
                  case 260:
                    return mc(v);
                  case 266:
                  case 272:
                    return Ip(v);
                  case 256:
                  case 257:
                  case 271:
                    return ms();
                  case 226:
                    return tu();
                  case 169:
                  case 172:
                  case 173:
                    return wp(v);
                  case 162:
                    return cu(0, true);
                  default:
                    return cu(0);
                }
              }
              function Ol(v) {
                switch (v.autoGenerateFlags & 7) {
                  case 1:
                    return cu(0, !!(v.autoGenerateFlags & 8));
                  case 2:
                    return cu(268435456, !!(v.autoGenerateFlags & 8));
                  case 3:
                    return gc(e.idText(v), v.autoGenerateFlags & 32 ? fl : nc, !!(v.autoGenerateFlags & 16), !!(v.autoGenerateFlags & 8));
                }
                return e.Debug.fail("Unsupported GeneratedIdentifierKind.");
              }
              function tf(v) {
                for (var sr = v.autoGenerateId, fi = v, zi = fi.original; zi && (fi = zi, !(e.isIdentifier(fi) && !!(fi.autoGenerateFlags & 4) && fi.autoGenerateId !== sr)); ) zi = fi.original;
                return fi;
              }
              function xf(v, sr) {
                var fi = Mt(2, v, sr), zi = wr, Sa = Ur, da = ii;
                z_(sr), fi(v, sr), Oc(sr, zi, Sa, da);
              }
              function z_(v) {
                var sr = e.getEmitFlags(v), fi = e.getCommentRange(v);
                rs(v, sr, fi.pos, fi.end), sr & 2048 && (qr = true);
              }
              function Oc(v, sr, fi, zi) {
                var Sa = e.getEmitFlags(v), da = e.getCommentRange(v);
                Sa & 2048 && (qr = false), Op(v, Sa, da.pos, da.end, sr, fi, zi);
                var Ha = e.getTypeNode(v);
                Ha && Op(v, Sa, Ha.pos, Ha.end, sr, fi, zi);
              }
              function rs(v, sr, fi, zi) {
                Xi(), or = false;
                var Sa = fi < 0 || (sr & 512) !== 0 || v.kind === 11, da = zi < 0 || (sr & 1024) !== 0 || v.kind === 11;
                (fi > 0 || zi > 0) && fi !== zi && (Sa || Cf(fi, v.kind !== 349), (!Sa || fi >= 0 && (sr & 512) !== 0) && (wr = fi), (!da || zi >= 0 && (sr & 1024) !== 0) && (Ur = zi, v.kind === 255 && (ii = zi))), e.forEach(e.getSyntheticLeadingComments(v), Ef), et();
              }
              function Op(v, sr, fi, zi, Sa, da, Ha) {
                Xi();
                var ta = zi < 0 || (sr & 1024) !== 0 || v.kind === 11;
                e.forEach(e.getSyntheticTrailingComments(v), Fl), (fi > 0 || zi > 0) && fi !== zi && (wr = Sa, Ur = da, ii = Ha, !ta && v.kind !== 349 && Fc(zi)), et();
              }
              function Ef(v) {
                (v.hasLeadingNewline || v.kind === 2) && Ae.writeLine(), pl(v), v.hasTrailingNewLine || v.kind === 2 ? Ae.writeLine() : Ae.writeSpace(" ");
              }
              function Fl(v) {
                Ae.isAtStartOfLine() || Ae.writeSpace(" "), pl(v), v.hasTrailingNewLine && Ae.writeLine();
              }
              function pl(v) {
                var sr = Fp(v), fi = v.kind === 3 ? e.computeLineStarts(sr) : void 0;
                e.writeCommentRange(sr, fi, Ae, 0, sr.length, Z);
              }
              function Fp(v) {
                return v.kind === 3 ? "/*".concat(v.text, "*/") : "//".concat(v.text);
              }
              function Mp(v, sr, fi) {
                Xi();
                var zi = sr.pos, Sa = sr.end, da = e.getEmitFlags(v), Ha = zi < 0 || (da & 512) !== 0, ta = qr || Sa < 0 || (da & 1024) !== 0;
                Ha || Rp(sr), et(), da & 2048 && !qr ? (qr = true, fi(v), qr = false) : fi(v), Xi(), ta || (Cf(sr.end, true), or && !Ae.isAtStartOfLine() && Ae.writeLine()), et();
              }
              function Gu(v, sr) {
                return v = e.getOriginalNode(v), v.parent && v.parent === e.getOriginalNode(sr).parent;
              }
              function Lp(v, sr) {
                if (sr.pos < v.end) return false;
                v = e.getOriginalNode(v), sr = e.getOriginalNode(sr);
                var fi = v.parent;
                if (!fi || fi !== sr.parent) return false;
                var zi = e.getContainingNodeArray(v), Sa = zi == null ? void 0 : zi.indexOf(v);
                return Sa !== void 0 && Sa > -1 && zi.indexOf(sr) === Sa + 1;
              }
              function Cf(v, sr) {
                or = false, sr ? v === 0 && (Re == null ? void 0 : Re.isDeclarationFile) ? Ot(v, g_) : Ot(v, gl) : v === 0 && Ot(v, W_);
              }
              function W_(v, sr, fi, zi, Sa) {
                m_(v, sr) && gl(v, sr, fi, zi, Sa);
              }
              function g_(v, sr, fi, zi, Sa) {
                m_(v, sr) || gl(v, sr, fi, zi, Sa);
              }
              function dl(v, sr) {
                return k.onlyPrintJsDocStyle ? e.isJSDocLikeText(v, sr) || e.isPinnedComment(v, sr) : true;
              }
              function gl(v, sr, fi, zi, Sa) {
                !Re || !dl(Re.text, v) || (or || (e.emitNewLineBeforeLeadingCommentOfPosition(De(), Ae, Sa, v), or = true), Xc(v), e.writeCommentRange(Re.text, De(), Ae, v, sr, Z), Xc(sr), zi ? Ae.writeLine() : fi === 3 && Ae.writeSpace(" "));
              }
              function Vf(v) {
                qr || v === -1 || Cf(v, true);
              }
              function Fc(v) {
                nf(v, Hu);
              }
              function Hu(v, sr, fi, zi) {
                !Re || !dl(Re.text, v) || (Ae.isAtStartOfLine() || Ae.writeSpace(" "), Xc(v), e.writeCommentRange(Re.text, De(), Ae, v, sr, Z), Xc(sr), zi && Ae.writeLine());
              }
              function af(v, sr, fi) {
                qr || (Xi(), nf(v, sr ? Hu : fi ? tn : Ml), et());
              }
              function tn(v, sr, fi) {
                !Re || (Xc(v), e.writeCommentRange(Re.text, De(), Ae, v, sr, Z), Xc(sr), fi === 2 && Ae.writeLine());
              }
              function Ml(v, sr, fi, zi) {
                !Re || (Xc(v), e.writeCommentRange(Re.text, De(), Ae, v, sr, Z), Xc(sr), zi ? Ae.writeLine() : Ae.writeSpace(" "));
              }
              function Ot(v, sr) {
                Re && (wr === -1 || v !== wr) && (q_(v) ? Kf(sr) : e.forEachLeadingCommentRange(Re.text, v, sr, v));
              }
              function nf(v, sr) {
                Re && (Ur === -1 || v !== Ur && v !== ii) && e.forEachTrailingCommentRange(Re.text, v, sr);
              }
              function q_(v) {
                return pe !== void 0 && e.last(pe).nodePos === v;
              }
              function Kf(v) {
                if (!!Re) {
                  var sr = e.last(pe).detachedCommentEndPos;
                  pe.length - 1 ? pe.pop() : pe = void 0, e.forEachLeadingCommentRange(Re.text, sr, v, sr);
                }
              }
              function Rp(v) {
                var sr = Re && e.emitDetachedComments(Re.text, De(), Ae, yd, v, Z, qr);
                sr && (pe ? pe.push(sr) : pe = [sr]);
              }
              function yd(v, sr, fi, zi, Sa, da) {
                !Re || !dl(Re.text, zi) || (Xc(zi), e.writeCommentRange(v, sr, fi, zi, Sa, da), Xc(Sa));
              }
              function m_(v, sr) {
                return !!Re && e.isRecognizedTripleSlashComment(Re.text, v, sr);
              }
              function Ll(v) {
                return v.parsedSourceMap === void 0 && v.sourceMapText !== void 0 && (v.parsedSourceMap = e.tryParseRawSourceMap(v.sourceMapText) || false), v.parsedSourceMap || void 0;
              }
              function hd(v, sr) {
                var fi = Mt(3, v, sr);
                v_(sr), fi(v, sr), Bp(sr);
              }
              function v_(v) {
                var sr = e.getEmitFlags(v), fi = e.getSourceMapRange(v);
                if (e.isUnparsedNode(v)) {
                  e.Debug.assertIsDefined(v.parent, "UnparsedNodes must have parent pointers");
                  var zi = Ll(v.parent);
                  zi && be && be.appendSourceMap(Ae.getLine(), Ae.getColumn(), zi, v.parent.sourceMapPath, v.parent.getLineAndCharacterOfPosition(v.pos), v.parent.getLineAndCharacterOfPosition(v.end));
                } else {
                  var Sa = fi.source || Ge;
                  v.kind !== 349 && (sr & 16) === 0 && fi.pos >= 0 && Gf(fi.source || Ge, Xu(Sa, fi.pos)), sr & 64 && (lr = true);
                }
              }
              function Bp(v) {
                var sr = e.getEmitFlags(v), fi = e.getSourceMapRange(v);
                e.isUnparsedNode(v) || (sr & 64 && (lr = false), v.kind !== 349 && (sr & 32) === 0 && fi.end >= 0 && Gf(fi.source || Ge, fi.end));
              }
              function Xu(v, sr) {
                return v.skipTrivia ? v.skipTrivia(sr) : e.skipTrivia(v.text, sr);
              }
              function Xc(v) {
                if (!(lr || e.positionIsSynthesized(v) || yu(Ge))) {
                  var sr = e.getLineAndCharacterOfPosition(Ge, v), fi = sr.line, zi = sr.character;
                  be.addMapping(Ae.getLine(), Ae.getColumn(), ur, fi, zi, void 0);
                }
              }
              function Gf(v, sr) {
                if (v !== Ge) {
                  var fi = Ge, zi = ur;
                  wu(v), Xc(sr), V_(fi, zi);
                } else Xc(sr);
              }
              function of(v, sr, fi, zi, Sa) {
                if (lr || v && e.isInJsonFile(v)) return Sa(sr, fi, zi);
                var da = v && v.emitNode, Ha = da && da.flags || 0, ta = da && da.tokenSourceMapRanges && da.tokenSourceMapRanges[sr], nn = ta && ta.source || Ge;
                return zi = Xu(nn, ta ? ta.pos : zi), (Ha & 128) === 0 && zi >= 0 && Gf(nn, zi), zi = Sa(sr, fi, zi), ta && (zi = ta.end), (Ha & 256) === 0 && zi >= 0 && Gf(nn, zi), zi;
              }
              function wu(v) {
                if (!lr) {
                  if (Ge = v, v === yr) {
                    ur = Ir;
                    return;
                  }
                  yu(v) || (ur = be.addSource(v.fileName), k.inlineSources && be.setSourceContent(ur, v.text), yr = v, Ir = ur);
                }
              }
              function V_(v, sr) {
                Ge = v, ur = sr;
              }
              function yu(v) {
                return e.fileExtensionIs(v.fileName, ".json");
              }
            }
            e.createPrinter = F;
            function x() {
              var k = [];
              return k[1024] = ["{", "}"], k[2048] = ["(", ")"], k[4096] = ["<", ">"], k[8192] = ["[", "]"], k;
            }
            function X(k) {
              return a[k & 15360][0];
            }
            function $(k) {
              return a[k & 15360][1];
            }
            var A;
            (function(k) {
              k[k.Auto = 0] = "Auto", k[k.CountMask = 268435455] = "CountMask", k[k._i = 268435456] = "_i";
            })(A || (A = {}));
            function y(k, Y, U, j) {
              Y(k);
            }
            function V(k, Y, U, j) {
              Y(k, U.select(j));
            }
            function L(k, Y, U, j) {
              Y(k, U);
            }
            function P(k, Y) {
              return k.length === 1 ? y : typeof Y == "object" ? V : L;
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(b, se, J) {
              if (!b.getDirectories || !b.readDirectory) return;
              var ie = new e.Map(), R = e.createGetCanonicalFileName(J);
              return { useCaseSensitiveFileNames: J, fileExists: y, readFile: function(l, d) {
                return b.readFile(l, d);
              }, directoryExists: b.directoryExists && V, getDirectories: P, readDirectory: k, createDirectory: b.createDirectory && L, writeFile: b.writeFile && A, addOrDeleteFileOrDirectory: U, addOrDeleteFile: j, clearCache: I, realpath: b.realpath && Y };
              function q(l) {
                return e.toPath(l, se, R);
              }
              function O(l) {
                return ie.get(e.ensureTrailingDirectorySeparator(l));
              }
              function ve(l) {
                return O(e.getDirectoryPath(l));
              }
              function ee(l) {
                return e.getBaseFileName(e.normalizePath(l));
              }
              function he(l, d) {
                var D;
                if (!b.realpath || e.ensureTrailingDirectorySeparator(q(b.realpath(l))) === d) {
                  var fe = { files: e.map(b.readDirectory(l, void 0, void 0, ["*.*"]), ee) || [], directories: b.getDirectories(l) || [] };
                  return ie.set(e.ensureTrailingDirectorySeparator(d), fe), fe;
                }
                if (!((D = b.directoryExists) === null || D === void 0) && D.call(b, l)) return ie.set(d, false), false;
              }
              function F(l, d) {
                d = e.ensureTrailingDirectorySeparator(d);
                var D = O(d);
                if (D) return D;
                try {
                  return he(l, d);
                } catch {
                  e.Debug.assert(!ie.has(e.ensureTrailingDirectorySeparator(d)));
                  return;
                }
              }
              function x(l, d) {
                return R(l) === R(d);
              }
              function X(l, d) {
                return e.some(l, function(D) {
                  return x(D, d);
                });
              }
              function $(l, d, D) {
                if (X(l, d)) {
                  if (!D) return e.filterMutate(l, function(fe) {
                    return !x(fe, d);
                  });
                } else if (D) return l.push(d);
              }
              function A(l, d, D) {
                var fe = q(l), g = ve(fe);
                return g && H(g, ee(l), true), b.writeFile(l, d, D);
              }
              function y(l) {
                var d = q(l), D = ve(d);
                return D && X(D.files, ee(l)) || b.fileExists(l);
              }
              function V(l) {
                var d = q(l);
                return ie.has(e.ensureTrailingDirectorySeparator(d)) || b.directoryExists(l);
              }
              function L(l) {
                var d = q(l), D = ve(d), fe = ee(l);
                D && $(D.directories, fe, true), b.createDirectory(l);
              }
              function P(l) {
                var d = q(l), D = F(l, d);
                return D ? D.directories.slice() : b.getDirectories(l);
              }
              function k(l, d, D, fe, g) {
                var ne = q(l), ue = F(l, ne), We;
                if (ue !== void 0) return e.matchFiles(l, d, D, fe, J, se, g, Fe, Y);
                return b.readDirectory(l, d, D, fe, g);
                function Fe(Be) {
                  var ge = q(Be);
                  if (ge === ne) return ue || Z(Be, ge);
                  var Re = F(Be, ge);
                  return Re !== void 0 ? Re || Z(Be, ge) : e.emptyFileSystemEntries;
                }
                function Z(Be, ge) {
                  if (We && ge === ne) return We;
                  var Re = { files: e.map(b.readDirectory(Be, void 0, void 0, ["*.*"]), ee) || e.emptyArray, directories: b.getDirectories(Be) || e.emptyArray };
                  return ge === ne && (We = Re), Re;
                }
              }
              function Y(l) {
                return b.realpath ? b.realpath(l) : l;
              }
              function U(l, d) {
                var D = O(d);
                if (D !== void 0) {
                  I();
                  return;
                }
                var fe = ve(d);
                if (!!fe) {
                  if (!b.directoryExists) {
                    I();
                    return;
                  }
                  var g = ee(l), ne = { fileExists: b.fileExists(d), directoryExists: b.directoryExists(d) };
                  return ne.directoryExists || X(fe.directories, g) ? I() : H(fe, g, ne.fileExists), ne;
                }
              }
              function j(l, d, D) {
                if (D !== e.FileWatcherEventKind.Changed) {
                  var fe = ve(d);
                  fe && H(fe, ee(l), D === e.FileWatcherEventKind.Created);
                }
              }
              function H(l, d, D) {
                $(l.files, d, D);
              }
              function I() {
                ie.clear();
              }
            }
            e.createCachedDirectoryStructureHost = a;
            var C;
            (function(b) {
              b[b.None = 0] = "None", b[b.Partial = 1] = "Partial", b[b.Full = 2] = "Full";
            })(C = e.ConfigFileProgramReloadLevel || (e.ConfigFileProgramReloadLevel = {}));
            function w(b, se, J, ie, R) {
              var q, O = e.arrayToMap(((q = se == null ? void 0 : se.configFile) === null || q === void 0 ? void 0 : q.extendedSourceFiles) || e.emptyArray, R);
              J.forEach(function(ve, ee) {
                O.has(ee) || (ve.projects.delete(b), ve.close());
              }), O.forEach(function(ve, ee) {
                var he = J.get(ee);
                he ? he.projects.add(b) : J.set(ee, { projects: new e.Set([b]), watcher: ie(ve, ee), close: function() {
                  var F = J.get(ee);
                  !F || F.projects.size !== 0 || (F.watcher.close(), J.delete(ee));
                } });
              });
            }
            e.updateSharedExtendedConfigFileWatcher = w;
            function B(b, se) {
              se.forEach(function(J) {
                J.projects.delete(b) && J.close();
              });
            }
            e.clearSharedExtendedConfigFileWatcher = B;
            function E(b, se, J) {
              !b.delete(se) || b.forEach(function(ie, R) {
                var q, O = ie.extendedResult;
                !((q = O.extendedSourceFiles) === null || q === void 0) && q.some(function(ve) {
                  return J(ve) === se;
                }) && E(b, R, J);
              });
            }
            e.cleanExtendedConfigCache = E;
            function Q(b, se, J) {
              var ie = new e.Map(b);
              e.mutateMap(se, ie, { createNewValue: J, onDeleteValue: e.closeFileWatcher });
            }
            e.updatePackageJsonWatch = Q;
            function le(b, se, J) {
              var ie = b.getMissingFilePaths(), R = e.arrayToMap(ie, e.identity, e.returnTrue);
              e.mutateMap(se, R, { createNewValue: J, onDeleteValue: e.closeFileWatcher });
            }
            e.updateMissingFilePathsWatch = le;
            function N(b, se, J) {
              e.mutateMap(b, se, { createNewValue: ie, onDeleteValue: K, onExistingValue: R });
              function ie(q, O) {
                return { watcher: J(q, O), flags: O };
              }
              function R(q, O, ve) {
                q.flags !== O && (q.watcher.close(), b.set(ve, ie(ve, O)));
              }
            }
            e.updateWatchingWildcardDirectories = N;
            function p(b) {
              var se = b.watchedDirPath, J = b.fileOrDirectory, ie = b.fileOrDirectoryPath, R = b.configFileName, q = b.options, O = b.program, ve = b.extraFileExtensions, ee = b.currentDirectory, he = b.useCaseSensitiveFileNames, F = b.writeLog, x = b.toPath, X = e.removeIgnoredPath(ie);
              if (!X) return F("Project: ".concat(R, " Detected ignored path: ").concat(J)), true;
              if (ie = X, ie === se) return false;
              if (e.hasExtension(ie) && !e.isSupportedSourceFileName(J, q, ve)) return F("Project: ".concat(R, " Detected file add/remove of non supported extension: ").concat(J)), true;
              if (e.isExcludedFile(J, q.configFile.configFileSpecs, e.getNormalizedAbsolutePath(e.getDirectoryPath(R), ee), he, ee)) return F("Project: ".concat(R, " Detected excluded file: ").concat(J)), true;
              if (!O || e.outFile(q) || q.outDir) return false;
              if (e.isDeclarationFileName(ie)) {
                if (q.declarationDir) return false;
              } else if (!e.fileExtensionIsOneOf(ie, e.supportedJSExtensionsFlat)) return false;
              var $ = e.removeFileExtension(ie), A = e.isArray(O) ? void 0 : m(O) ? O.getProgramOrUndefined() : O, y = !A && !e.isArray(O) ? O : void 0;
              if (V($ + ".ts") || V($ + ".tsx")) return F("Project: ".concat(R, " Detected output file: ").concat(J)), true;
              return false;
              function V(L) {
                return A ? !!A.getSourceFileByPath(L) : y ? y.getState().fileInfos.has(L) : !!e.find(O, function(P) {
                  return x(P) === L;
                });
              }
            }
            e.isIgnoredFileFromWildCardWatching = p;
            function m(b) {
              return !!b.getState;
            }
            function G(b, se) {
              return b ? b.isEmittedFile(se) : false;
            }
            e.isEmittedFileOfProgram = G;
            var oe;
            (function(b) {
              b[b.None = 0] = "None", b[b.TriggerOnly = 1] = "TriggerOnly", b[b.Verbose = 2] = "Verbose";
            })(oe = e.WatchLogLevel || (e.WatchLogLevel = {}));
            function f(b, se, J, ie) {
              e.setSysLog(se === oe.Verbose ? J : e.noop);
              var R = { watchFile: function(y, V, L, P) {
                return b.watchFile(y, V, L, P);
              }, watchDirectory: function(y, V, L, P) {
                return b.watchDirectory(y, V, (L & 1) !== 0, P);
              } }, q = se !== oe.None ? { watchFile: $("watchFile"), watchDirectory: $("watchDirectory") } : void 0, O = se === oe.Verbose ? { watchFile: x, watchDirectory: X } : q || R, ve = se === oe.Verbose ? F : e.returnNoopFileWatcher;
              return { watchFile: ee("watchFile"), watchDirectory: ee("watchDirectory") };
              function ee(y) {
                return function(V, L, P, k, Y, U) {
                  var j;
                  return e.matchesExclude(V, y === "watchFile" ? k == null ? void 0 : k.excludeFiles : k == null ? void 0 : k.excludeDirectories, he(), ((j = b.getCurrentDirectory) === null || j === void 0 ? void 0 : j.call(b)) || "") ? ve(V, P, k, Y, U) : O[y].call(void 0, V, L, P, k, Y, U);
                };
              }
              function he() {
                return typeof b.useCaseSensitiveFileNames == "boolean" ? b.useCaseSensitiveFileNames : b.useCaseSensitiveFileNames();
              }
              function F(y, V, L, P, k) {
                return J("ExcludeWatcher:: Added:: ".concat(A(y, V, L, P, k, ie))), { close: function() {
                  return J("ExcludeWatcher:: Close:: ".concat(A(y, V, L, P, k, ie)));
                } };
              }
              function x(y, V, L, P, k, Y) {
                J("FileWatcher:: Added:: ".concat(A(y, L, P, k, Y, ie)));
                var U = q.watchFile(y, V, L, P, k, Y);
                return { close: function() {
                  J("FileWatcher:: Close:: ".concat(A(y, L, P, k, Y, ie))), U.close();
                } };
              }
              function X(y, V, L, P, k, Y) {
                var U = "DirectoryWatcher:: Added:: ".concat(A(y, L, P, k, Y, ie));
                J(U);
                var j = e.timestamp(), H = q.watchDirectory(y, V, L, P, k, Y), I = e.timestamp() - j;
                return J("Elapsed:: ".concat(I, "ms ").concat(U)), { close: function() {
                  var l = "DirectoryWatcher:: Close:: ".concat(A(y, L, P, k, Y, ie));
                  J(l);
                  var d = e.timestamp();
                  H.close();
                  var D = e.timestamp() - d;
                  J("Elapsed:: ".concat(D, "ms ").concat(l));
                } };
              }
              function $(y) {
                return function(V, L, P, k, Y, U) {
                  return R[y].call(void 0, V, function() {
                    for (var j = [], H = 0; H < arguments.length; H++) j[H] = arguments[H];
                    var I = "".concat(y === "watchFile" ? "FileWatcher" : "DirectoryWatcher", ":: Triggered with ").concat(j[0], " ").concat(j[1] !== void 0 ? j[1] : "", ":: ").concat(A(V, P, k, Y, U, ie));
                    J(I);
                    var l = e.timestamp();
                    L.call.apply(L, Ve([void 0], j, false));
                    var d = e.timestamp() - l;
                    J("Elapsed:: ".concat(d, "ms ").concat(I));
                  }, P, k, Y, U);
                };
              }
              function A(y, V, L, P, k, Y) {
                return "WatchInfo: ".concat(y, " ").concat(V, " ").concat(JSON.stringify(L), " ").concat(Y ? Y(P, k) : k === void 0 ? P : "".concat(P, " ").concat(k));
              }
            }
            e.getWatchFactory = f;
            function T(b) {
              var se = b == null ? void 0 : b.fallbackPolling;
              return { watchFile: se !== void 0 ? se : e.WatchFileKind.PriorityPollingInterval };
            }
            e.getFallbackOptions = T;
            function K(b) {
              b.watcher.close();
            }
            e.closeFileWatcherOf = K;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(Z, Be, ge) {
              return ge === void 0 && (ge = "tsconfig.json"), e.forEachAncestorDirectory(Z, function(Re) {
                var ze = e.combinePaths(Re, ge);
                return Be(ze) ? ze : void 0;
              });
            }
            e.findConfigFile = a;
            function C(Z, Be) {
              var ge = e.getDirectoryPath(Be), Re = e.isRootedDiskPath(Z) ? Z : e.combinePaths(ge, Z);
              return e.normalizePath(Re);
            }
            e.resolveTripleslashReference = C;
            function w(Z, Be, ge) {
              var Re, ze = e.forEach(Z, function(Ee) {
                var He = e.getNormalizedPathComponents(Ee, Be);
                if (He.pop(), !Re) {
                  Re = He;
                  return;
                }
                for (var rr = Math.min(Re.length, He.length), Ie = 0; Ie < rr; Ie++) if (ge(Re[Ie]) !== ge(He[Ie])) {
                  if (Ie === 0) return true;
                  Re.length = Ie;
                  break;
                }
                He.length < Re.length && (Re.length = He.length);
              });
              return ze ? "" : Re ? e.getPathFromPathComponents(Re) : Be;
            }
            e.computeCommonSourceDirectoryOfFilenames = w;
            function B(Z, Be) {
              return E(Z, Be);
            }
            e.createCompilerHost = B;
            function E(Z, Be, ge) {
              ge === void 0 && (ge = e.sys);
              var Re = new e.Map(), ze = e.createGetCanonicalFileName(ge.useCaseSensitiveFileNames), Ee = e.maybeBind(ge, ge.createHash) || e.generateDjb2Hash;
              function He(ir, Cr, Ye) {
                var Br;
                try {
                  e.performance.mark("beforeIORead"), Br = er.readFile(ir), e.performance.mark("afterIORead"), e.performance.measure("I/O Read", "beforeIORead", "afterIORead");
                } catch (Er) {
                  Ye && Ye(Er.message), Br = "";
                }
                return Br !== void 0 ? e.createSourceFile(ir, Br, Cr, Be) : void 0;
              }
              function rr(ir) {
                return Re.has(ir) ? true : (er.directoryExists || ge.directoryExists)(ir) ? (Re.set(ir, true), true) : false;
              }
              function Ie(ir, Cr, Ye, Br) {
                try {
                  e.performance.mark("beforeIOWrite"), e.writeFileEnsuringDirectories(ir, Cr, Ye, function(Er, Ne, n) {
                    return we(Er, Ne, n);
                  }, function(Er) {
                    return (er.createDirectory || ge.createDirectory)(Er);
                  }, function(Er) {
                    return rr(Er);
                  }), e.performance.mark("afterIOWrite"), e.performance.measure("I/O Write", "beforeIOWrite", "afterIOWrite");
                } catch (Er) {
                  Br && Br(Er.message);
                }
              }
              var _e;
              function we(ir, Cr, Ye) {
                if (!e.isWatchSet(Z) || !ge.getModifiedTime) {
                  ge.writeFile(ir, Cr, Ye);
                  return;
                }
                _e || (_e = new e.Map());
                var Br = Ee(Cr), Er = ge.getModifiedTime(ir);
                if (Er) {
                  var Ne = _e.get(ir);
                  if (Ne && Ne.byteOrderMark === Ye && Ne.hash === Br && Ne.mtime.getTime() === Er.getTime()) return;
                }
                ge.writeFile(ir, Cr, Ye);
                var n = ge.getModifiedTime(ir) || e.missingFileModifiedTime;
                _e.set(ir, { hash: Br, byteOrderMark: Ye, mtime: n });
              }
              function de() {
                return e.getDirectoryPath(e.normalizePath(ge.getExecutingFilePath()));
              }
              var ye = e.getNewLineCharacter(Z, function() {
                return ge.newLine;
              }), Ae = ge.realpath && function(ir) {
                return ge.realpath(ir);
              }, er = { getSourceFile: He, getDefaultLibLocation: de, getDefaultLibFileName: function(ir) {
                return e.combinePaths(de(), e.getDefaultLibFileName(ir));
              }, writeFile: Ie, getCurrentDirectory: e.memoize(function() {
                return ge.getCurrentDirectory();
              }), useCaseSensitiveFileNames: function() {
                return ge.useCaseSensitiveFileNames;
              }, getCanonicalFileName: ze, getNewLine: function() {
                return ye;
              }, fileExists: function(ir) {
                return ge.fileExists(ir);
              }, readFile: function(ir) {
                return ge.readFile(ir);
              }, trace: function(ir) {
                return ge.write(ir + ye);
              }, directoryExists: function(ir) {
                return ge.directoryExists(ir);
              }, getEnvironmentVariable: function(ir) {
                return ge.getEnvironmentVariable ? ge.getEnvironmentVariable(ir) : "";
              }, getDirectories: function(ir) {
                return ge.getDirectories(ir);
              }, realpath: Ae, readDirectory: function(ir, Cr, Ye, Br, Er) {
                return ge.readDirectory(ir, Cr, Ye, Br, Er);
              }, createDirectory: function(ir) {
                return ge.createDirectory(ir);
              }, createHash: e.maybeBind(ge, ge.createHash) };
              return er;
            }
            e.createCompilerHostWorker = E;
            function Q(Z, Be, ge) {
              var Re = Z.readFile, ze = Z.fileExists, Ee = Z.directoryExists, He = Z.createDirectory, rr = Z.writeFile, Ie = new e.Map(), _e = new e.Map(), we = new e.Map(), de = new e.Map(), ye = function(ir) {
                var Cr = Be(ir), Ye = Ie.get(Cr);
                return Ye !== void 0 ? Ye !== false ? Ye : void 0 : Ae(Cr, ir);
              }, Ae = function(ir, Cr) {
                var Ye = Re.call(Z, Cr);
                return Ie.set(ir, Ye !== void 0 ? Ye : false), Ye;
              };
              Z.readFile = function(ir) {
                var Cr = Be(ir), Ye = Ie.get(Cr);
                return Ye !== void 0 ? Ye !== false ? Ye : void 0 : !e.fileExtensionIs(ir, ".json") && !e.isBuildInfoFile(ir) ? Re.call(Z, ir) : Ae(Cr, ir);
              };
              var er = ge ? function(ir, Cr, Ye, Br) {
                var Er = Be(ir), Ne = de.get(Er);
                if (Ne) return Ne;
                var n = ge(ir, Cr, Ye, Br);
                return n && (e.isDeclarationFileName(ir) || e.fileExtensionIs(ir, ".json")) && de.set(Er, n), n;
              } : void 0;
              return Z.fileExists = function(ir) {
                var Cr = Be(ir), Ye = _e.get(Cr);
                if (Ye !== void 0) return Ye;
                var Br = ze.call(Z, ir);
                return _e.set(Cr, !!Br), Br;
              }, rr && (Z.writeFile = function(ir, Cr) {
                for (var Ye = [], Br = 2; Br < arguments.length; Br++) Ye[Br - 2] = arguments[Br];
                var Er = Be(ir);
                _e.delete(Er);
                var Ne = Ie.get(Er);
                if (Ne !== void 0 && Ne !== Cr) Ie.delete(Er), de.delete(Er);
                else if (er) {
                  var n = de.get(Er);
                  n && n.text !== Cr && de.delete(Er);
                }
                rr.call.apply(rr, Ve([Z, ir, Cr], Ye, false));
              }), Ee && He && (Z.directoryExists = function(ir) {
                var Cr = Be(ir), Ye = we.get(Cr);
                if (Ye !== void 0) return Ye;
                var Br = Ee.call(Z, ir);
                return we.set(Cr, !!Br), Br;
              }, Z.createDirectory = function(ir) {
                var Cr = Be(ir);
                we.delete(Cr), He.call(Z, ir);
              }), { originalReadFile: Re, originalFileExists: ze, originalDirectoryExists: Ee, originalCreateDirectory: He, originalWriteFile: rr, getSourceFileWithCache: er, readFileWithCache: ye };
            }
            e.changeCompilerHostLikeToUseCache = Q;
            function le(Z, Be, ge) {
              var Re;
              return Re = e.addRange(Re, Z.getConfigFileParsingDiagnostics()), Re = e.addRange(Re, Z.getOptionsDiagnostics(ge)), Re = e.addRange(Re, Z.getSyntacticDiagnostics(Be, ge)), Re = e.addRange(Re, Z.getGlobalDiagnostics(ge)), Re = e.addRange(Re, Z.getSemanticDiagnostics(Be, ge)), e.getEmitDeclarations(Z.getCompilerOptions()) && (Re = e.addRange(Re, Z.getDeclarationDiagnostics(Be, ge))), e.sortAndDeduplicateDiagnostics(Re || e.emptyArray);
            }
            e.getPreEmitDiagnostics = le;
            function N(Z, Be) {
              for (var ge = "", Re = 0, ze = Z; Re < ze.length; Re++) {
                var Ee = ze[Re];
                ge += p(Ee, Be);
              }
              return ge;
            }
            e.formatDiagnostics = N;
            function p(Z, Be) {
              var ge = "".concat(e.diagnosticCategoryName(Z), " TS").concat(Z.code, ": ").concat(O(Z.messageText, Be.getNewLine())).concat(Be.getNewLine());
              if (Z.file) {
                var Re = e.getLineAndCharacterOfPosition(Z.file, Z.start), ze = Re.line, Ee = Re.character, He = Z.file.fileName, rr = e.convertToRelativePath(He, Be.getCurrentDirectory(), function(Ie) {
                  return Be.getCanonicalFileName(Ie);
                });
                return "".concat(rr, "(").concat(ze + 1, ",").concat(Ee + 1, "): ") + ge;
              }
              return ge;
            }
            e.formatDiagnostic = p;
            var m;
            (function(Z) {
              Z.Grey = "\x1B[90m", Z.Red = "\x1B[91m", Z.Yellow = "\x1B[93m", Z.Blue = "\x1B[94m", Z.Cyan = "\x1B[96m";
            })(m = e.ForegroundColorEscapeSequences || (e.ForegroundColorEscapeSequences = {}));
            var G = "\x1B[7m", oe = " ", f = "\x1B[0m", T = "...", K = "  ", b = "    ";
            function se(Z) {
              switch (Z) {
                case e.DiagnosticCategory.Error:
                  return m.Red;
                case e.DiagnosticCategory.Warning:
                  return m.Yellow;
                case e.DiagnosticCategory.Suggestion:
                  return e.Debug.fail("Should never get an Info diagnostic on the command line.");
                case e.DiagnosticCategory.Message:
                  return m.Blue;
              }
            }
            function J(Z, Be) {
              return Be + Z + f;
            }
            e.formatColorAndReset = J;
            function ie(Z, Be, ge, Re, ze, Ee) {
              var He = e.getLineAndCharacterOfPosition(Z, Be), rr = He.line, Ie = He.character, _e = e.getLineAndCharacterOfPosition(Z, Be + ge), we = _e.line, de = _e.character, ye = e.getLineAndCharacterOfPosition(Z, Z.text.length).line, Ae = we - rr >= 4, er = (we + 1 + "").length;
              Ae && (er = Math.max(T.length, er));
              for (var ir = "", Cr = rr; Cr <= we; Cr++) {
                ir += Ee.getNewLine(), Ae && rr + 1 < Cr && Cr < we - 1 && (ir += Re + J(e.padLeft(T, er), G) + oe + Ee.getNewLine(), Cr = we - 1);
                var Ye = e.getPositionOfLineAndCharacter(Z, Cr, 0), Br = Cr < ye ? e.getPositionOfLineAndCharacter(Z, Cr + 1, 0) : Z.text.length, Er = Z.text.slice(Ye, Br);
                if (Er = e.trimStringEnd(Er), Er = Er.replace(/\t/g, " "), ir += Re + J(e.padLeft(Cr + 1 + "", er), G) + oe, ir += Er + Ee.getNewLine(), ir += Re + J(e.padLeft("", er), G) + oe, ir += ze, Cr === rr) {
                  var Ne = Cr === we ? de : void 0;
                  ir += Er.slice(0, Ie).replace(/\S/g, " "), ir += Er.slice(Ie, Ne).replace(/./g, "~");
                } else Cr === we ? ir += Er.slice(0, de).replace(/./g, "~") : ir += Er.replace(/./g, "~");
                ir += f;
              }
              return ir;
            }
            function R(Z, Be, ge, Re) {
              Re === void 0 && (Re = J);
              var ze = e.getLineAndCharacterOfPosition(Z, Be), Ee = ze.line, He = ze.character, rr = ge ? e.convertToRelativePath(Z.fileName, ge.getCurrentDirectory(), function(_e) {
                return ge.getCanonicalFileName(_e);
              }) : Z.fileName, Ie = "";
              return Ie += Re(rr, m.Cyan), Ie += ":", Ie += Re("".concat(Ee + 1), m.Yellow), Ie += ":", Ie += Re("".concat(He + 1), m.Yellow), Ie;
            }
            e.formatLocation = R;
            function q(Z, Be) {
              for (var ge = "", Re = 0, ze = Z; Re < ze.length; Re++) {
                var Ee = ze[Re];
                if (Ee.file) {
                  var He = Ee.file, rr = Ee.start;
                  ge += R(He, rr, Be), ge += " - ";
                }
                if (ge += J(e.diagnosticCategoryName(Ee), se(Ee.category)), ge += J(" TS".concat(Ee.code, ": "), m.Grey), ge += O(Ee.messageText, Be.getNewLine()), Ee.file && (ge += Be.getNewLine(), ge += ie(Ee.file, Ee.start, Ee.length, "", se(Ee.category), Be)), Ee.relatedInformation) {
                  ge += Be.getNewLine();
                  for (var Ie = 0, _e = Ee.relatedInformation; Ie < _e.length; Ie++) {
                    var we = _e[Ie], He = we.file, rr = we.start, de = we.length, ye = we.messageText;
                    He && (ge += Be.getNewLine(), ge += K + R(He, rr, Be), ge += ie(He, rr, de, b, m.Cyan, Be)), ge += Be.getNewLine(), ge += b + O(ye, Be.getNewLine());
                  }
                }
                ge += Be.getNewLine();
              }
              return ge;
            }
            e.formatDiagnosticsWithColorAndContext = q;
            function O(Z, Be, ge) {
              if (ge === void 0 && (ge = 0), e.isString(Z)) return Z;
              if (Z === void 0) return "";
              var Re = "";
              if (ge) {
                Re += Be;
                for (var ze = 0; ze < ge; ze++) Re += "  ";
              }
              if (Re += Z.messageText, ge++, Z.next) for (var Ee = 0, He = Z.next; Ee < He.length; Ee++) {
                var rr = He[Ee];
                Re += O(rr, Be, ge);
              }
              return Re;
            }
            e.flattenDiagnosticMessageText = O;
            function ve(Z, Be, ge, Re, ze) {
              if (Z.length === 0) return [];
              for (var Ee = [], He = new e.Map(), rr = 0, Ie = Z; rr < Ie.length; rr++) {
                var _e = Ie[rr], we = void 0, de = ee(_e, Re), ye = e.isString(_e) ? _e : _e.fileName.toLowerCase(), Ae = de !== void 0 ? "".concat(de, "|").concat(ye) : ye;
                He.has(Ae) ? we = He.get(Ae) : He.set(Ae, we = ze(ye, Be, ge, de)), Ee.push(we);
              }
              return Ee;
            }
            e.loadWithTypeDirectiveCache = ve;
            function ee(Z, Be) {
              return (e.isString(Z) ? Be : Z.resolutionMode) || Be;
            }
            e.getModeForFileReference = ee;
            function he(Z, Be) {
              if (Z.impliedNodeFormat !== void 0) return x(Z, Fe(Z, Be));
            }
            e.getModeForResolutionAtIndex = he;
            function F(Z) {
              var Be;
              return e.isExportDeclaration(Z) ? Z.isTypeOnly : !!(!((Be = Z.importClause) === null || Be === void 0) && Be.isTypeOnly);
            }
            e.isExclusivelyTypeOnlyImportOrExport = F;
            function x(Z, Be) {
              var ge, Re;
              if (Z.impliedNodeFormat !== void 0) {
                if (e.isImportDeclaration(Be.parent) || e.isExportDeclaration(Be.parent)) {
                  var ze = F(Be.parent);
                  if (ze) {
                    var Ee = X(Be.parent.assertClause);
                    if (Ee) return Ee;
                  }
                }
                if (Be.parent.parent && e.isImportTypeNode(Be.parent.parent)) {
                  var Ee = X((ge = Be.parent.parent.assertions) === null || ge === void 0 ? void 0 : ge.assertClause);
                  if (Ee) return Ee;
                }
                if (Z.impliedNodeFormat !== e.ModuleKind.ESNext) return e.isImportCall(e.walkUpParenthesizedExpressions(Be.parent)) ? e.ModuleKind.ESNext : e.ModuleKind.CommonJS;
                var He = (Re = e.walkUpParenthesizedExpressions(Be.parent)) === null || Re === void 0 ? void 0 : Re.parent;
                return He && e.isImportEqualsDeclaration(He) ? e.ModuleKind.CommonJS : e.ModuleKind.ESNext;
              }
            }
            e.getModeForUsageLocation = x;
            function X(Z, Be) {
              if (!!Z) {
                if (e.length(Z.elements) !== 1) {
                  Be == null || Be(Z, e.Diagnostics.Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require);
                  return;
                }
                var ge = Z.elements[0];
                if (!!e.isStringLiteralLike(ge.name)) {
                  if (ge.name.text !== "resolution-mode") {
                    Be == null || Be(ge.name, e.Diagnostics.resolution_mode_is_the_only_valid_key_for_type_import_assertions);
                    return;
                  }
                  if (!!e.isStringLiteralLike(ge.value)) {
                    if (ge.value.text !== "import" && ge.value.text !== "require") {
                      Be == null || Be(ge.value, e.Diagnostics.resolution_mode_should_be_either_require_or_import);
                      return;
                    }
                    return ge.value.text === "import" ? e.ModuleKind.ESNext : e.ModuleKind.CommonJS;
                  }
                }
              }
            }
            e.getResolutionModeOverrideForClause = X;
            function $(Z, Be, ge, Re, ze) {
              if (Z.length === 0) return [];
              for (var Ee = [], He = new e.Map(), rr = 0, Ie = 0, _e = Z; Ie < _e.length; Ie++) {
                var we = _e[Ie], de = void 0, ye = he(Be, rr);
                rr++;
                var Ae = ye !== void 0 ? "".concat(ye, "|").concat(we) : we;
                He.has(Ae) ? de = He.get(Ae) : He.set(Ae, de = ze(we, ye, ge, Re)), Ee.push(de);
              }
              return Ee;
            }
            e.loadWithModeAwareCache = $;
            function A(Z, Be) {
              return y(void 0, Z, function(ge, Re) {
                return ge && Be(ge, Re);
              });
            }
            e.forEachResolvedProjectReference = A;
            function y(Z, Be, ge, Re) {
              var ze;
              return Ee(Z, Be, void 0);
              function Ee(He, rr, Ie) {
                if (Re) {
                  var _e = Re(He, Ie);
                  if (_e) return _e;
                }
                return e.forEach(rr, function(we, de) {
                  if (!(we && (ze == null ? void 0 : ze.has(we.sourceFile.path)))) {
                    var ye = ge(we, Ie, de);
                    return ye || !we ? ye : ((ze || (ze = new e.Set())).add(we.sourceFile.path), Ee(we.commandLine.projectReferences, we.references, we));
                  }
                });
              }
            }
            e.inferredTypesContainingFile = "__inferred type names__.ts";
            function V(Z) {
              switch (Z == null ? void 0 : Z.kind) {
                case e.FileIncludeKind.Import:
                case e.FileIncludeKind.ReferenceFile:
                case e.FileIncludeKind.TypeReferenceDirective:
                case e.FileIncludeKind.LibReferenceDirective:
                  return true;
                default:
                  return false;
              }
            }
            e.isReferencedFile = V;
            function L(Z) {
              return Z.pos !== void 0;
            }
            e.isReferenceFileLocation = L;
            function P(Z, Be) {
              var ge, Re, ze, Ee, He, rr, Ie, _e = e.Debug.checkDefined(Z(Be.file)), we = Be.kind, de = Be.index, ye, Ae, er, ir;
              switch (we) {
                case e.FileIncludeKind.Import:
                  var Cr = Fe(_e, de);
                  if (er = (He = (Ee = _e.resolvedModules) === null || Ee === void 0 ? void 0 : Ee.get(Cr.text, he(_e, de))) === null || He === void 0 ? void 0 : He.packageId, Cr.pos === -1) return { file: _e, packageId: er, text: Cr.text };
                  ye = e.skipTrivia(_e.text, Cr.pos), Ae = Cr.end;
                  break;
                case e.FileIncludeKind.ReferenceFile:
                  ge = _e.referencedFiles[de], ye = ge.pos, Ae = ge.end;
                  break;
                case e.FileIncludeKind.TypeReferenceDirective:
                  Re = _e.typeReferenceDirectives[de], ye = Re.pos, Ae = Re.end, ir = Re.resolutionMode, er = (Ie = (rr = _e.resolvedTypeReferenceDirectiveNames) === null || rr === void 0 ? void 0 : rr.get(e.toFileNameLowerCase(_e.typeReferenceDirectives[de].fileName), ir || _e.impliedNodeFormat)) === null || Ie === void 0 ? void 0 : Ie.packageId;
                  break;
                case e.FileIncludeKind.LibReferenceDirective:
                  ze = _e.libReferenceDirectives[de], ye = ze.pos, Ae = ze.end;
                  break;
                default:
                  return e.Debug.assertNever(we);
              }
              return { file: _e, pos: ye, end: Ae, packageId: er };
            }
            e.getReferencedFileLocation = P;
            function k(Z, Be, ge, Re, ze, Ee, He, rr, Ie) {
              if (!Z || (He == null ? void 0 : He()) || !e.arrayIsEqualTo(Z.getRootFileNames(), Be)) return false;
              var _e;
              if (!e.arrayIsEqualTo(Z.getProjectReferences(), Ie, Ae) || Z.getSourceFiles().some(de) || Z.getMissingFilePaths().some(ze)) return false;
              var we = Z.getCompilerOptions();
              if (!e.compareDataObjects(we, ge)) return false;
              if (we.configFile && ge.configFile) return we.configFile.text === ge.configFile.text;
              return true;
              function de(ir) {
                return !ye(ir) || Ee(ir.path);
              }
              function ye(ir) {
                return ir.version === Re(ir.resolvedPath, ir.fileName);
              }
              function Ae(ir, Cr, Ye) {
                return e.projectReferenceIsEqualTo(ir, Cr) && er(Z.getResolvedProjectReferences()[Ye], ir);
              }
              function er(ir, Cr) {
                if (ir) {
                  if (e.contains(_e, ir)) return true;
                  var Ye = ne(Cr), Br = rr(Ye);
                  return !Br || ir.commandLine.options.configFile !== Br.options.configFile || !e.arrayIsEqualTo(ir.commandLine.fileNames, Br.fileNames) ? false : ((_e || (_e = [])).push(ir), !e.forEach(ir.references, function(Ne, n) {
                    return !er(Ne, ir.commandLine.projectReferences[n]);
                  }));
                }
                var Er = ne(Cr);
                return !rr(Er);
              }
            }
            e.isProgramUptoDate = k;
            function Y(Z) {
              return Z.options.configFile ? Ve(Ve([], Z.options.configFile.parseDiagnostics, true), Z.errors, true) : Z.errors;
            }
            e.getConfigFileParsingDiagnostics = Y;
            function U(Z, Be, ge, Re) {
              switch (e.getEmitModuleResolutionKind(Re)) {
                case e.ModuleResolutionKind.Node16:
                case e.ModuleResolutionKind.NodeNext:
                  return e.fileExtensionIsOneOf(Z, [".d.mts", ".mts", ".mjs"]) ? e.ModuleKind.ESNext : e.fileExtensionIsOneOf(Z, [".d.cts", ".cts", ".cjs"]) ? e.ModuleKind.CommonJS : e.fileExtensionIsOneOf(Z, [".d.ts", ".ts", ".tsx", ".js", ".jsx"]) ? ze() : void 0;
                default:
                  return;
              }
              function ze() {
                var Ee = e.getPackageScopeForPath(Z, Be, ge, Re);
                return (Ee == null ? void 0 : Ee.packageJsonContent.type) === "module" ? e.ModuleKind.ESNext : e.ModuleKind.CommonJS;
              }
            }
            e.getImpliedNodeFormatForFile = U, e.plainJSErrors = new e.Set([e.Diagnostics.Cannot_redeclare_block_scoped_variable_0.code, e.Diagnostics.A_module_cannot_have_multiple_default_exports.code, e.Diagnostics.Another_export_default_is_here.code, e.Diagnostics.The_first_export_default_is_here.code, e.Diagnostics.Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module.code, e.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode.code, e.Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here.code, e.Diagnostics.constructor_is_a_reserved_word.code, e.Diagnostics.delete_cannot_be_called_on_an_identifier_in_strict_mode.code, e.Diagnostics.Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode.code, e.Diagnostics.Invalid_use_of_0_Modules_are_automatically_in_strict_mode.code, e.Diagnostics.Invalid_use_of_0_in_strict_mode.code, e.Diagnostics.A_label_is_not_allowed_here.code, e.Diagnostics.Octal_literals_are_not_allowed_in_strict_mode.code, e.Diagnostics.with_statements_are_not_allowed_in_strict_mode.code, e.Diagnostics.A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement.code, e.Diagnostics.A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement.code, e.Diagnostics.A_class_declaration_without_the_default_modifier_must_have_a_name.code, e.Diagnostics.A_class_member_cannot_have_the_0_keyword.code, e.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name.code, e.Diagnostics.A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement.code, e.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement.code, e.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement.code, e.Diagnostics.A_default_clause_cannot_appear_more_than_once_in_a_switch_statement.code, e.Diagnostics.A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration.code, e.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context.code, e.Diagnostics.A_destructuring_declaration_must_have_an_initializer.code, e.Diagnostics.A_get_accessor_cannot_have_parameters.code, e.Diagnostics.A_rest_element_cannot_contain_a_binding_pattern.code, e.Diagnostics.A_rest_element_cannot_have_a_property_name.code, e.Diagnostics.A_rest_element_cannot_have_an_initializer.code, e.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern.code, e.Diagnostics.A_rest_parameter_cannot_have_an_initializer.code, e.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list.code, e.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma.code, e.Diagnostics.A_return_statement_cannot_be_used_inside_a_class_static_block.code, e.Diagnostics.A_set_accessor_cannot_have_rest_parameter.code, e.Diagnostics.A_set_accessor_must_have_exactly_one_parameter.code, e.Diagnostics.An_export_declaration_can_only_be_used_at_the_top_level_of_a_module.code, e.Diagnostics.An_export_declaration_cannot_have_modifiers.code, e.Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module.code, e.Diagnostics.An_import_declaration_cannot_have_modifiers.code, e.Diagnostics.An_object_member_cannot_be_declared_optional.code, e.Diagnostics.Argument_of_dynamic_import_cannot_be_spread_element.code, e.Diagnostics.Cannot_assign_to_private_method_0_Private_methods_are_not_writable.code, e.Diagnostics.Cannot_redeclare_identifier_0_in_catch_clause.code, e.Diagnostics.Catch_clause_variable_cannot_have_an_initializer.code, e.Diagnostics.Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator.code, e.Diagnostics.Classes_can_only_extend_a_single_class.code, e.Diagnostics.Classes_may_not_have_a_field_named_constructor.code, e.Diagnostics.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern.code, e.Diagnostics.Duplicate_label_0.code, e.Diagnostics.Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_assertion_as_arguments.code, e.Diagnostics.For_await_loops_cannot_be_used_inside_a_class_static_block.code, e.Diagnostics.JSX_attributes_must_only_be_assigned_a_non_empty_expression.code, e.Diagnostics.JSX_elements_cannot_have_multiple_attributes_with_the_same_name.code, e.Diagnostics.JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array.code, e.Diagnostics.JSX_property_access_expressions_cannot_include_JSX_namespace_names.code, e.Diagnostics.Jump_target_cannot_cross_function_boundary.code, e.Diagnostics.Line_terminator_not_permitted_before_arrow.code, e.Diagnostics.Modifiers_cannot_appear_here.code, e.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement.code, e.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement.code, e.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies.code, e.Diagnostics.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression.code, e.Diagnostics.Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier.code, e.Diagnostics.Tagged_template_expressions_are_not_permitted_in_an_optional_chain.code, e.Diagnostics.The_left_hand_side_of_a_for_of_statement_may_not_be_async.code, e.Diagnostics.The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer.code, e.Diagnostics.The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer.code, e.Diagnostics.Trailing_comma_not_allowed.code, e.Diagnostics.Variable_declaration_list_cannot_be_empty.code, e.Diagnostics._0_and_1_operations_cannot_be_mixed_without_parentheses.code, e.Diagnostics._0_expected.code, e.Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2.code, e.Diagnostics._0_list_cannot_be_empty.code, e.Diagnostics._0_modifier_already_seen.code, e.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration.code, e.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element.code, e.Diagnostics._0_modifier_cannot_appear_on_a_parameter.code, e.Diagnostics._0_modifier_cannot_appear_on_class_elements_of_this_kind.code, e.Diagnostics._0_modifier_cannot_be_used_here.code, e.Diagnostics._0_modifier_must_precede_1_modifier.code, e.Diagnostics.const_declarations_can_only_be_declared_inside_a_block.code, e.Diagnostics.const_declarations_must_be_initialized.code, e.Diagnostics.extends_clause_already_seen.code, e.Diagnostics.let_declarations_can_only_be_declared_inside_a_block.code, e.Diagnostics.let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations.code]);
            function j(Z, Be) {
              return Z ? e.optionsHaveChanges(Z.getCompilerOptions(), Be, e.sourceFileAffectingCompilerOptions) : false;
            }
            function H(Z, Be, ge, Re, ze) {
              return { rootNames: Z, options: Be, host: ge, oldProgram: Re, configFileParsingDiagnostics: ze };
            }
            function I(Z, Be, ge, Re, ze) {
              var Ee, He, rr, Ie, _e = e.isArray(Z) ? H(Z, Be, ge, Re, ze) : Z, we = _e.rootNames, de = _e.options, ye = _e.configFileParsingDiagnostics, Ae = _e.projectReferences, er = _e.oldProgram, ir, Cr, Ye, Br, Er, Ne, n, lr = new e.Map(), be = e.createMultiMap(), Ge = {}, ur = {}, yr = e.createModeAwareCache(), Ir, wr = typeof de.maxNodeModuleJsDepth == "number" ? de.maxNodeModuleJsDepth : 0, Ur = 0, ii = new e.Map(), mi = new e.Map();
              e.tracing === null || e.tracing === void 0 || e.tracing.push("program", "createProgram", { configFilePath: de.configFilePath, rootDir: de.rootDir }, true), e.performance.mark("beforeProgram");
              var pe = _e.host || B(de), or = fe(pe), qr = de.noLib, si = e.memoize(function() {
                return pe.getDefaultLibFileName(de);
              }), Di = pe.getDefaultLibLocation ? pe.getDefaultLibLocation() : e.getDirectoryPath(si()), wi = e.createDiagnosticCollection(), Xi = pe.getCurrentDirectory(), et = e.getSupportedExtensions(de), Gi = e.getSupportedExtensionsWithJsonIfResolveJsonModule(de, et), Wt = new e.Map(), Zt, _r, pi, ae, Xe = pe.hasInvalidatedResolution || e.returnFalse;
              if (pe.resolveModuleNames) ae = function(Kr, _i, Ei, tt, kt) {
                return pe.resolveModuleNames(e.Debug.checkEachDefined(Kr), Ei, tt, kt, de, _i).map(function(bt) {
                  if (!bt || bt.extension !== void 0) return bt;
                  var ia = e.clone(bt);
                  return ia.extension = e.extensionFromPath(bt.resolvedFileName), ia;
                });
              }, _r = (Ee = pe.getModuleResolutionCache) === null || Ee === void 0 ? void 0 : Ee.call(pe);
              else {
                _r = e.createModuleResolutionCache(Xi, ua, de);
                var Jr = function(Kr, _i, Ei, tt) {
                  return e.resolveModuleName(Kr, Ei, de, pe, _r, tt, _i).resolvedModule;
                };
                ae = function(Kr, _i, Ei, tt, kt) {
                  return $(e.Debug.checkEachDefined(Kr), _i, Ei, kt, Jr);
                };
              }
              var ti;
              if (pe.resolveTypeReferenceDirectives) ti = function(Kr, _i, Ei, tt) {
                return pe.resolveTypeReferenceDirectives(e.Debug.checkEachDefined(Kr), _i, Ei, de, tt);
              };
              else {
                pi = e.createTypeReferenceDirectiveResolutionCache(Xi, ua, void 0, _r == null ? void 0 : _r.getPackageJsonInfoCache());
                var Ze = function(Kr, _i, Ei, tt) {
                  return e.resolveTypeReferenceDirective(Kr, _i, de, pe, Ei, pi, tt).resolvedTypeReferenceDirective;
                };
                ti = function(Kr, _i, Ei, tt) {
                  return ve(e.Debug.checkEachDefined(Kr), _i, Ei, tt, Ze);
                };
              }
              var Sr = new e.Map(), zr = new e.Map(), Wr = e.createMultiMap(), Je = false, xe = new e.Map(), vr, mr = pe.useCaseSensitiveFileNames() ? new e.Map() : void 0, Ar, Oe, nr, Mr, Pe = !!(!((He = pe.useSourceOfProjectReferenceRedirect) === null || He === void 0) && He.call(pe)) && !de.disableSourceOfProjectReferenceRedirect, Ue = l({ compilerHost: pe, getSymlinkCache: vc, useSourceOfProjectReferenceRedirect: Pe, toPath: Vi, getResolvedProjectReferences: Ba, getSourceOfProjectReferenceRedirect: ce, forEachResolvedProjectReference: Ji }), fr = Ue.onProgramCreateComplete, De = Ue.fileExists, gr = Ue.directoryExists, Vr = pe.readFile.bind(pe);
              e.tracing === null || e.tracing === void 0 || e.tracing.push("program", "shouldProgramCreateNewSourceFiles", { hasOldProgram: !!er });
              var Tr = j(er, de);
              e.tracing === null || e.tracing === void 0 || e.tracing.pop();
              var vi;
              if (e.tracing === null || e.tracing === void 0 || e.tracing.push("program", "tryReuseStructureFromOldProgram", {}), vi = Qa(), e.tracing === null || e.tracing === void 0 || e.tracing.pop(), vi !== 2) {
                ir = [], Cr = [], Ae && (Ar || (Ar = Ae.map(fo)), we.length && (Ar == null || Ar.forEach(function(Kr, _i) {
                  if (!!Kr) {
                    var Ei = e.outFile(Kr.commandLine.options);
                    if (Pe) {
                      if (Ei || e.getEmitModuleKind(Kr.commandLine.options) === e.ModuleKind.None) for (var tt = 0, kt = Kr.commandLine.fileNames; tt < kt.length; tt++) {
                        var bt = kt[tt];
                        ys(bt, { kind: e.FileIncludeKind.SourceFromProjectReference, index: _i });
                      }
                    } else if (Ei) ys(e.changeExtension(Ei, ".d.ts"), { kind: e.FileIncludeKind.OutputFromProjectReference, index: _i });
                    else if (e.getEmitModuleKind(Kr.commandLine.options) === e.ModuleKind.None) for (var ia = e.memoize(function() {
                      return e.getCommonSourceDirectoryOfConfig(Kr.commandLine, !pe.useCaseSensitiveFileNames());
                    }), Xt = 0, Za = Kr.commandLine.fileNames; Xt < Za.length; Xt++) {
                      var bt = Za[Xt];
                      !e.isDeclarationFileName(bt) && !e.fileExtensionIs(bt, ".json") && ys(e.getOutputDeclarationFileName(bt, Kr.commandLine, !pe.useCaseSensitiveFileNames(), ia), { kind: e.FileIncludeKind.OutputFromProjectReference, index: _i });
                    }
                  }
                }))), e.tracing === null || e.tracing === void 0 || e.tracing.push("program", "processRootFiles", { count: we.length }), e.forEach(we, function(Kr, _i) {
                  return Qi(Kr, false, false, { kind: e.FileIncludeKind.RootFile, index: _i });
                }), e.tracing === null || e.tracing === void 0 || e.tracing.pop();
                var Ui = we.length ? e.getAutomaticTypeDirectiveNames(de, pe) : e.emptyArray;
                if (Ui.length) {
                  e.tracing === null || e.tracing === void 0 || e.tracing.push("program", "processTypeReferences", { count: Ui.length });
                  for (var Yi = de.configFilePath ? e.getDirectoryPath(de.configFilePath) : pe.getCurrentDirectory(), Wi = e.combinePaths(Yi, e.inferredTypesContainingFile), ct = Bt(Ui, Wi), Li = 0; Li < Ui.length; Li++) Hr(Ui[Li], void 0, ct[Li], { kind: e.FileIncludeKind.AutomaticTypeDirectiveFile, typeReference: Ui[Li], packageId: (rr = ct[Li]) === null || rr === void 0 ? void 0 : rr.packageId });
                  e.tracing === null || e.tracing === void 0 || e.tracing.pop();
                }
                if (we.length && !qr) {
                  var nt = si();
                  !de.lib && nt ? Qi(nt, true, false, { kind: e.FileIncludeKind.LibFile }) : e.forEach(de.lib, function(Kr, _i) {
                    Qi(Pt(Kr), true, false, { kind: e.FileIncludeKind.LibFile, index: _i });
                  });
                }
                vr = e.arrayFrom(e.mapDefinedIterator(xe.entries(), function(Kr) {
                  var _i = Kr[0], Ei = Kr[1];
                  return Ei === void 0 ? _i : void 0;
                })), Ye = e.stableSort(ir, Ai).concat(Cr), ir = void 0, Cr = void 0;
              }
              if (e.Debug.assert(!!vr), er && pe.onReleaseOldSourceFile) {
                for (var Mt = er.getSourceFiles(), xt = 0, ut = Mt; xt < ut.length; xt++) {
                  var Dt = ut[xt], Rt = Da(Dt.resolvedPath);
                  (Tr || !Rt || Dt.resolvedPath === Dt.path && Rt.resolvedPath !== Dt.path) && pe.onReleaseOldSourceFile(Dt, er.getCompilerOptions(), !!Da(Dt.path));
                }
                pe.getParsedCommandLine || er.forEachResolvedProjectReference(function(Kr) {
                  yi(Kr.sourceFile.path) || pe.onReleaseOldSourceFile(Kr.sourceFile, er.getCompilerOptions(), false);
                });
              }
              er && pe.onReleaseParsedCommandLine && y(er.getProjectReferences(), er.getResolvedProjectReferences(), function(Kr, _i, Ei) {
                var tt = (_i == null ? void 0 : _i.commandLine.projectReferences[Ei]) || er.getProjectReferences()[Ei], kt = ne(tt);
                Oe != null && Oe.has(Vi(kt)) || pe.onReleaseParsedCommandLine(kt, Kr, er.getCompilerOptions());
              }), pi = void 0, er = void 0;
              var Ii = { getRootFileNames: function() {
                return we;
              }, getSourceFile: Rn, getSourceFileByPath: Da, getSourceFiles: function() {
                return Ye;
              }, getMissingFilePaths: function() {
                return vr;
              }, getModuleResolutionCache: function() {
                return _r;
              }, getFilesByNameMap: function() {
                return xe;
              }, getCompilerOptions: function() {
                return de;
              }, getSyntacticDiagnostics: Ro, getOptionsDiagnostics: br, getGlobalDiagnostics: Si, getSemanticDiagnostics: En, getCachedSemanticDiagnostics: Wn, getSuggestionDiagnostics: dn, getDeclarationDiagnostics: Ko, getBindAndCheckDiagnostics: to, getProgramDiagnostics: Co, getTypeChecker: xn, getClassifiableNames: At, getCommonSourceDirectory: at, emit: Kn, getCurrentDirectory: function() {
                return Xi;
              }, getNodeCount: function() {
                return xn().getNodeCount();
              }, getIdentifierCount: function() {
                return xn().getIdentifierCount();
              }, getSymbolCount: function() {
                return xn().getSymbolCount();
              }, getTypeCount: function() {
                return xn().getTypeCount();
              }, getInstantiationCount: function() {
                return xn().getInstantiationCount();
              }, getRelationCacheSizes: function() {
                return xn().getRelationCacheSizes();
              }, getFileProcessingDiagnostics: function() {
                return Ir;
              }, getResolvedTypeReferenceDirectives: function() {
                return yr;
              }, isSourceFileFromExternalLibrary: Bi, isSourceFileDefaultLibrary: kn, getSourceFileFromReference: mo, getLibFileFromReference: qn, sourceFileToPackageName: zr, redirectTargetsMap: Wr, usesUriStyleNodeCoreModules: Je, isEmittedFile: Ya, getConfigFileParsingDiagnostics: Pi, getResolvedModuleWithFailedLookupLocationsFromCache: ji, getProjectReferences: pn, getResolvedProjectReferences: Ba, getProjectReferenceRedirect: ps, getResolvedProjectReferenceToRedirect: ds, getResolvedProjectReferenceByPath: yi, forEachResolvedProjectReference: Ji, isSourceOfProjectReferenceRedirect: Rr, emitBuildInfo: ka, fileExists: De, readFile: Vr, directoryExists: gr, getSymlinkCache: vc, realpath: (Ie = pe.realpath) === null || Ie === void 0 ? void 0 : Ie.bind(pe), useCaseSensitiveFileNames: function() {
                return pe.useCaseSensitiveFileNames();
              }, getFileIncludeReasons: function() {
                return be;
              }, structureIsReused: vi, writeFile: Dn };
              return fr(), Ir == null || Ir.forEach(function(Kr) {
                switch (Kr.kind) {
                  case 1:
                    return wi.add(Fo(Kr.file && Da(Kr.file), Kr.fileProcessingReason, Kr.diagnostic, Kr.args || e.emptyArray));
                  case 0:
                    var _i = P(Da, Kr.reason), Ei = _i.file, tt = _i.pos, kt = _i.end;
                    return wi.add(e.createFileDiagnostic.apply(void 0, Ve([Ei, e.Debug.checkDefined(tt), e.Debug.checkDefined(kt) - tt, Kr.diagnostic], Kr.args || e.emptyArray, false)));
                  default:
                    e.Debug.assertNever(Kr);
                }
              }), xs(), e.performance.mark("afterProgram"), e.performance.measure("Program", "beforeProgram", "afterProgram"), e.tracing === null || e.tracing === void 0 || e.tracing.pop(), Ii;
              function Ki(Kr) {
                if (!!Kr) for (var _i = 0, Ei = Kr; _i < Ei.length; _i++) {
                  var tt = Ei[_i];
                  wi.add(tt);
                }
              }
              function Fi(Kr, _i) {
                var Ei;
                if (!!_r) for (var tt = e.getNormalizedAbsolutePath(_i.originalFileName, Xi), kt = e.isString(_i) ? void 0 : _i.impliedNodeFormat, bt = e.getDirectoryPath(tt), ia = wt(_i), Xt = 0, Za = 0, bn = Kr; Za < bn.length; Za++) {
                  var _a = bn[Za], qa = typeof _a == "string" ? he(_i, Xt) : ee(_a, kt), rn = typeof _a == "string" ? _a : _a.fileName;
                  if (Xt++, !e.isExternalModuleNameRelative(rn)) {
                    var jn = (Ei = _r.getOrCreateCacheForModuleName(rn, qa, ia).get(bt)) === null || Ei === void 0 ? void 0 : Ei.resolutionDiagnostics;
                    Ki(jn);
                  }
                }
              }
              function ui(Kr, _i, Ei) {
                if (!Kr.length) return e.emptyArray;
                var tt = e.getNormalizedAbsolutePath(_i.originalFileName, Xi), kt = wt(_i);
                e.tracing === null || e.tracing === void 0 || e.tracing.push("program", "resolveModuleNamesWorker", { containingFileName: tt }), e.performance.mark("beforeResolveModule");
                var bt = ae(Kr, _i, tt, Ei, kt);
                return e.performance.mark("afterResolveModule"), e.performance.measure("ResolveModule", "beforeResolveModule", "afterResolveModule"), e.tracing === null || e.tracing === void 0 || e.tracing.pop(), Fi(Kr, _i), bt;
              }
              function Bt(Kr, _i) {
                if (!Kr.length) return [];
                var Ei = e.isString(_i) ? _i : e.getNormalizedAbsolutePath(_i.originalFileName, Xi), tt = e.isString(_i) ? void 0 : wt(_i), kt = e.isString(_i) ? void 0 : _i.impliedNodeFormat;
                e.tracing === null || e.tracing === void 0 || e.tracing.push("program", "resolveTypeReferenceDirectiveNamesWorker", { containingFileName: Ei }), e.performance.mark("beforeResolveTypeReference");
                var bt = ti(Kr, Ei, tt, kt);
                return e.performance.mark("afterResolveTypeReference"), e.performance.measure("ResolveTypeReference", "beforeResolveTypeReference", "afterResolveTypeReference"), e.tracing === null || e.tracing === void 0 || e.tracing.pop(), bt;
              }
              function wt(Kr) {
                var _i = ds(Kr.originalFileName);
                if (_i || !e.isDeclarationFileName(Kr.originalFileName)) return _i;
                var Ei = na(Kr.path);
                if (Ei) return Ei;
                if (!(!pe.realpath || !de.preserveSymlinks || !e.stringContains(Kr.originalFileName, e.nodeModulesPathPart))) {
                  var tt = Vi(pe.realpath(Kr.originalFileName));
                  return tt === Kr.path ? void 0 : na(tt);
                }
              }
              function na(Kr) {
                var _i = ce(Kr);
                if (e.isString(_i)) return ds(_i);
                if (!!_i) return Ji(function(Ei) {
                  var tt = e.outFile(Ei.commandLine.options);
                  if (!!tt) return Vi(tt) === Kr ? Ei : void 0;
                });
              }
              function Ai(Kr, _i) {
                return e.compareValues(Oi(Kr), Oi(_i));
              }
              function Oi(Kr) {
                if (e.containsPath(Di, Kr.fileName, false)) {
                  var _i = e.getBaseFileName(Kr.fileName);
                  if (_i === "lib.d.ts" || _i === "lib.es6.d.ts") return 0;
                  var Ei = e.removeSuffix(e.removePrefix(_i, "lib."), ".d.ts"), tt = e.libs.indexOf(Ei);
                  if (tt !== -1) return tt + 1;
                }
                return e.libs.length + 2;
              }
              function ji(Kr, _i, Ei) {
                return _r && e.resolveModuleNameFromCache(Kr, _i, _r, Ei);
              }
              function Vi(Kr) {
                return e.toPath(Kr, Xi, ua);
              }
              function at() {
                if (Er === void 0) {
                  var Kr = e.filter(Ye, function(_i) {
                    return e.sourceFileMayBeEmitted(_i, Ii);
                  });
                  Er = e.getCommonSourceDirectory(de, function() {
                    return e.mapDefined(Kr, function(_i) {
                      return _i.isDeclarationFile ? void 0 : _i.fileName;
                    });
                  }, Xi, ua, function(_i) {
                    return jr(Kr, _i);
                  });
                }
                return Er;
              }
              function At() {
                var Kr;
                if (!n) {
                  xn(), n = new e.Set();
                  for (var _i = 0, Ei = Ye; _i < Ei.length; _i++) {
                    var tt = Ei[_i];
                    (Kr = tt.classifiableNames) === null || Kr === void 0 || Kr.forEach(function(kt) {
                      return n.add(kt);
                    });
                  }
                }
                return n;
              }
              function ba(Kr, _i) {
                if (vi === 0 && !_i.ambientModuleNames.length) return ui(Kr, _i, void 0);
                var Ei = er && er.getSourceFile(_i.fileName);
                if (Ei !== _i && _i.resolvedModules) {
                  for (var tt = [], kt = 0, bt = 0, ia = Kr; bt < ia.length; bt++) {
                    var Xt = ia[bt], Za = _i.resolvedModules.get(Xt, he(_i, kt));
                    kt++, tt.push(Za);
                  }
                  return tt;
                }
                for (var bn, _a, qa, rn = {}, kt = 0; kt < Kr.length; kt++) {
                  var Xt = Kr[kt];
                  if (_i === Ei && !Xe(Ei.path)) {
                    var jn = e.getResolvedModule(Ei, Xt, he(Ei, kt));
                    if (jn) {
                      e.isTraceEnabled(de, pe) && e.trace(pe, jn.packageId ? e.Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3 : e.Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2, Xt, e.getNormalizedAbsolutePath(_i.originalFileName, Xi), jn.resolvedFileName, jn.packageId && e.packageIdToString(jn.packageId)), (_a || (_a = new Array(Kr.length)))[kt] = jn, (qa || (qa = [])).push(Xt);
                      continue;
                    }
                  }
                  var Mo = false;
                  e.contains(_i.ambientModuleNames, Xt) ? (Mo = true, e.isTraceEnabled(de, pe) && e.trace(pe, e.Diagnostics.Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1, Xt, e.getNormalizedAbsolutePath(_i.originalFileName, Xi))) : Mo = Se(Xt, kt), Mo ? (_a || (_a = new Array(Kr.length)))[kt] = rn : (bn || (bn = [])).push(Xt);
                }
                var ho = bn && bn.length ? ui(bn, _i, qa) : e.emptyArray;
                if (!_a) return e.Debug.assert(ho.length === Kr.length), ho;
                for (var gs = 0, kt = 0; kt < _a.length; kt++) _a[kt] ? _a[kt] === rn && (_a[kt] = void 0) : (_a[kt] = ho[gs], gs++);
                return e.Debug.assert(gs === ho.length), _a;
                function Se(hr, Or) {
                  if (Or >= e.length(Ei == null ? void 0 : Ei.imports) + e.length(Ei == null ? void 0 : Ei.moduleAugmentations)) return false;
                  var ki = e.getResolvedModule(Ei, hr, Ei && he(Ei, Or)), dt = ki && er.getSourceFile(ki.resolvedFileName);
                  if (ki && dt) return false;
                  var la = lr.get(hr);
                  return la ? (e.isTraceEnabled(de, pe) && e.trace(pe, e.Diagnostics.Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified, hr, la), true) : false;
                }
              }
              function $a() {
                return !y(er.getProjectReferences(), er.getResolvedProjectReferences(), function(Kr, _i, Ei) {
                  var tt = (_i ? _i.commandLine.projectReferences : Ae)[Ei], kt = fo(tt);
                  return Kr ? !kt || kt.sourceFile !== Kr.sourceFile || !e.arrayIsEqualTo(Kr.commandLine.fileNames, kt.commandLine.fileNames) : kt !== void 0;
                }, function(Kr, _i) {
                  var Ei = _i ? yi(_i.sourceFile.path).commandLine.projectReferences : Ae;
                  return !e.arrayIsEqualTo(Kr, Ei, e.projectReferenceIsEqualTo);
                });
              }
              function Qa() {
                var Kr;
                if (!er) return 0;
                var _i = er.getCompilerOptions();
                if (e.changesAffectModuleResolution(_i, de)) return 0;
                var Ei = er.getRootFileNames();
                if (!e.arrayIsEqualTo(Ei, we) || !$a()) return 0;
                Ae && (Ar = Ae.map(fo));
                var tt = [], kt = [];
                if (vi = 2, er.getMissingFilePaths().some(function(Ls) {
                  return pe.fileExists(Ls);
                })) return 0;
                var bt = er.getSourceFiles(), ia;
                (function(Ls) {
                  Ls[Ls.Exists = 0] = "Exists", Ls[Ls.Modified = 1] = "Modified";
                })(ia || (ia = {}));
                for (var Xt = new e.Map(), Za = 0, bn = bt; Za < bn.length; Za++) {
                  var _a = bn[Za], qa = pe.getSourceFileByPath ? pe.getSourceFileByPath(_a.fileName, _a.resolvedPath, Xs(_a.fileName, _r, pe, de), void 0, Tr) : pe.getSourceFile(_a.fileName, Xs(_a.fileName, _r, pe, de), void 0, Tr);
                  if (!qa) return 0;
                  e.Debug.assert(!qa.redirectInfo, "Host should not return a redirect source file from `getSourceFile`");
                  var rn = void 0;
                  if (_a.redirectInfo) {
                    if (qa !== _a.redirectInfo.unredirected) return 0;
                    rn = false, qa = _a;
                  } else if (er.redirectTargetsMap.has(_a.path)) {
                    if (qa !== _a) return 0;
                    rn = false;
                  } else rn = qa !== _a;
                  qa.path = _a.path, qa.originalFileName = _a.originalFileName, qa.resolvedPath = _a.resolvedPath, qa.fileName = _a.fileName;
                  var jn = er.sourceFileToPackageName.get(_a.path);
                  if (jn !== void 0) {
                    var Mo = Xt.get(jn), ho = rn ? 1 : 0;
                    if (Mo !== void 0 && ho === 1 || Mo === 1) return 0;
                    Xt.set(jn, ho);
                  }
                  rn ? (e.arrayIsEqualTo(_a.libReferenceDirectives, qa.libReferenceDirectives, Ct) || (vi = 1), _a.hasNoDefaultLib !== qa.hasNoDefaultLib && (vi = 1), e.arrayIsEqualTo(_a.referencedFiles, qa.referencedFiles, Ct) || (vi = 1), Wa(qa), e.arrayIsEqualTo(_a.imports, qa.imports, sa) || (vi = 1), e.arrayIsEqualTo(_a.moduleAugmentations, qa.moduleAugmentations, sa) || (vi = 1), (_a.flags & 6291456) !== (qa.flags & 6291456) && (vi = 1), e.arrayIsEqualTo(_a.typeReferenceDirectives, qa.typeReferenceDirectives, Ct) || (vi = 1), kt.push({ oldFile: _a, newFile: qa })) : Xe(_a.path) && (vi = 1, kt.push({ oldFile: _a, newFile: qa })), tt.push(qa);
                }
                if (vi !== 2) return vi;
                for (var gs = kt.map(function(Ls) {
                  return Ls.oldFile;
                }), Se = 0, hr = bt; Se < hr.length; Se++) {
                  var Or = hr[Se];
                  if (!e.contains(gs, Or)) for (var ki = 0, dt = Or.ambientModuleNames; ki < dt.length; ki++) {
                    var la = dt[ki];
                    lr.set(la, Or.fileName);
                  }
                }
                for (var wa = 0, On = kt; wa < On.length; wa++) {
                  var No = On[wa], _a = No.oldFile, qa = No.newFile, jo = We(qa), po = ba(jo, qa), Gn = e.hasChangesInResolutions(jo, po, _a.resolvedModules, _a, e.moduleResolutionIsEqualTo);
                  Gn ? (vi = 1, qa.resolvedModules = e.zipToModeAwareCache(qa, jo, po)) : qa.resolvedModules = _a.resolvedModules;
                  var $n = qa.typeReferenceDirectives, Ho = Bt($n, qa), Zo = e.hasChangesInResolutions($n, Ho, _a.resolvedTypeReferenceDirectiveNames, _a, e.typeDirectiveIsEqualTo);
                  Zo ? (vi = 1, qa.resolvedTypeReferenceDirectiveNames = e.zipToModeAwareCache(qa, $n, Ho)) : qa.resolvedTypeReferenceDirectiveNames = _a.resolvedTypeReferenceDirectiveNames;
                }
                if (vi !== 2) return vi;
                if (e.changesAffectingProgramStructure(_i, de) || ((Kr = pe.hasChangedAutomaticTypeDirectiveNames) === null || Kr === void 0 ? void 0 : Kr.call(pe))) return 1;
                vr = er.getMissingFilePaths(), e.Debug.assert(tt.length === er.getSourceFiles().length);
                for (var Es = 0, yc = tt; Es < yc.length; Es++) {
                  var qa = yc[Es];
                  xe.set(qa.path, qa);
                }
                var Xr = er.getFilesByNameMap();
                return Xr.forEach(function(Ls, Ic) {
                  if (!Ls) {
                    xe.set(Ic, Ls);
                    return;
                  }
                  if (Ls.path === Ic) {
                    er.isSourceFileFromExternalLibrary(Ls) && mi.set(Ls.path, true);
                    return;
                  }
                  xe.set(Ic, xe.get(Ls.path));
                }), Ye = tt, be = er.getFileIncludeReasons(), Ir = er.getFileProcessingDiagnostics(), yr = er.getResolvedTypeReferenceDirectives(), zr = er.sourceFileToPackageName, Wr = er.redirectTargetsMap, Je = er.usesUriStyleNodeCoreModules, 2;
              }
              function ai(Kr) {
                return { getPrependNodes: Cn, getCanonicalFileName: ua, getCommonSourceDirectory: Ii.getCommonSourceDirectory, getCompilerOptions: Ii.getCompilerOptions, getCurrentDirectory: function() {
                  return Xi;
                }, getNewLine: function() {
                  return pe.getNewLine();
                }, getSourceFile: Ii.getSourceFile, getSourceFileByPath: Ii.getSourceFileByPath, getSourceFiles: Ii.getSourceFiles, getLibFileFromReference: Ii.getLibFileFromReference, isSourceFileFromExternalLibrary: Bi, getResolvedProjectReferenceToRedirect: ds, getProjectReferenceRedirect: ps, isSourceOfProjectReferenceRedirect: Rr, getSymlinkCache: vc, writeFile: Kr || Dn, isEmitBlocked: Pn, readFile: function(_i) {
                  return pe.readFile(_i);
                }, fileExists: function(_i) {
                  var Ei = Vi(_i);
                  return Da(Ei) ? true : e.contains(vr, Ei) ? false : pe.fileExists(_i);
                }, useCaseSensitiveFileNames: function() {
                  return pe.useCaseSensitiveFileNames();
                }, getProgramBuildInfo: function() {
                  return Ii.getProgramBuildInfo && Ii.getProgramBuildInfo();
                }, getSourceFileFromReference: function(_i, Ei) {
                  return Ii.getSourceFileFromReference(_i, Ei);
                }, redirectTargetsMap: Wr, getFileIncludeReasons: Ii.getFileIncludeReasons };
              }
              function Dn(Kr, _i, Ei, tt, kt, bt) {
                pe.writeFile(Kr, _i, Ei, tt, kt, bt);
              }
              function ka(Kr) {
                e.Debug.assert(!e.outFile(de)), e.tracing === null || e.tracing === void 0 || e.tracing.push("emit", "emitBuildInfo", {}, true), e.performance.mark("beforeEmit");
                var _i = e.emitFiles(e.notImplementedResolver, ai(Kr), void 0, e.noTransformers, false, true);
                return e.performance.mark("afterEmit"), e.performance.measure("Emit", "beforeEmit", "afterEmit"), e.tracing === null || e.tracing === void 0 || e.tracing.pop(), _i;
              }
              function Ba() {
                return Ar;
              }
              function pn() {
                return Ae;
              }
              function Cn() {
                return g(Ae, function(Kr, _i) {
                  var Ei;
                  return (Ei = Ar[_i]) === null || Ei === void 0 ? void 0 : Ei.commandLine;
                }, function(Kr) {
                  var _i = Vi(Kr), Ei = Da(_i);
                  return Ei ? Ei.text : xe.has(_i) ? void 0 : pe.readFile(_i);
                });
              }
              function Bi(Kr) {
                return !!mi.get(Kr.path);
              }
              function kn(Kr) {
                if (!Kr.isDeclarationFile) return false;
                if (Kr.hasNoDefaultLib) return true;
                if (!de.noLib) return false;
                var _i = pe.useCaseSensitiveFileNames() ? e.equateStringsCaseSensitive : e.equateStringsCaseInsensitive;
                return de.lib ? e.some(de.lib, function(Ei) {
                  return _i(Kr.fileName, Pt(Ei));
                }) : _i(Kr.fileName, si());
              }
              function xn() {
                return Ne || (Ne = e.createTypeChecker(Ii));
              }
              function Kn(Kr, _i, Ei, tt, kt, bt) {
                e.tracing === null || e.tracing === void 0 || e.tracing.push("emit", "emit", { path: Kr == null ? void 0 : Kr.path }, true);
                var ia = no(function() {
                  return eo(Ii, Kr, _i, Ei, tt, kt, bt);
                });
                return e.tracing === null || e.tracing === void 0 || e.tracing.pop(), ia;
              }
              function Pn(Kr) {
                return Wt.has(Vi(Kr));
              }
              function eo(Kr, _i, Ei, tt, kt, bt, ia) {
                if (!ia) {
                  var Xt = d(Kr, _i, Ei, tt);
                  if (Xt) return Xt;
                }
                var Za = xn().getEmitResolver(e.outFile(de) ? void 0 : _i, tt);
                e.performance.mark("beforeEmit");
                var bn = e.emitFiles(Za, ai(Ei), _i, e.getTransformers(de, bt, kt), kt, false, ia);
                return e.performance.mark("afterEmit"), e.performance.measure("Emit", "beforeEmit", "afterEmit"), bn;
              }
              function Rn(Kr) {
                return Da(Vi(Kr));
              }
              function Da(Kr) {
                return xe.get(Kr) || void 0;
              }
              function bo(Kr, _i, Ei) {
                return Kr ? _i(Kr, Ei) : e.sortAndDeduplicateDiagnostics(e.flatMap(Ii.getSourceFiles(), function(tt) {
                  return Ei && Ei.throwIfCancellationRequested(), _i(tt, Ei);
                }));
              }
              function Ro(Kr, _i) {
                return bo(Kr, Oo, _i);
              }
              function En(Kr, _i) {
                return bo(Kr, $o, _i);
              }
              function Wn(Kr) {
                var _i;
                return Kr ? (_i = Ge.perFile) === null || _i === void 0 ? void 0 : _i.get(Kr.path) : Ge.allDiagnostics;
              }
              function to(Kr, _i) {
                return Pr(Kr, _i);
              }
              function Co(Kr) {
                var _i;
                if (e.skipTypeChecking(Kr, de, Ii)) return e.emptyArray;
                var Ei = wi.getDiagnostics(Kr.fileName);
                return !((_i = Kr.commentDirectives) === null || _i === void 0) && _i.length ? pa(Kr, Kr.commentDirectives, Ei).diagnostics : Ei;
              }
              function Ko(Kr, _i) {
                var Ei = Ii.getCompilerOptions();
                return !Kr || e.outFile(Ei) ? Gr(Kr, _i) : bo(Kr, qe, _i);
              }
              function Oo(Kr) {
                return e.isSourceFileJS(Kr) ? (Kr.additionalSyntacticDiagnostics || (Kr.additionalSyntacticDiagnostics = Qe(Kr)), e.concatenate(Kr.additionalSyntacticDiagnostics, Kr.parseDiagnostics)) : Kr.parseDiagnostics;
              }
              function no(Kr) {
                try {
                  return Kr();
                } catch (_i) {
                  throw _i instanceof e.OperationCanceledException && (Ne = void 0), _i;
                }
              }
              function $o(Kr, _i) {
                return e.concatenate(D(Pr(Kr, _i), de), Co(Kr));
              }
              function Pr(Kr, _i) {
                return Ce(Kr, _i, Ge, xi);
              }
              function xi(Kr, _i) {
                return no(function() {
                  if (e.skipTypeChecking(Kr, de, Ii)) return e.emptyArray;
                  var Ei = xn();
                  e.Debug.assert(!!Kr.bindDiagnostics);
                  var tt = Kr.scriptKind === 1 || Kr.scriptKind === 2, kt = tt && e.isCheckJsEnabledForFile(Kr, de), bt = e.isPlainJsFile(Kr, de.checkJs), ia = !!Kr.checkJsDirective && Kr.checkJsDirective.enabled === false, Xt = !ia && (Kr.scriptKind === 3 || Kr.scriptKind === 4 || Kr.scriptKind === 5 || bt || kt || Kr.scriptKind === 7), Za = Xt ? Kr.bindDiagnostics : e.emptyArray, bn = Xt ? Ei.getDiagnostics(Kr, _i) : e.emptyArray;
                  return bt && (Za = e.filter(Za, function(_a) {
                    return e.plainJSErrors.has(_a.code);
                  }), bn = e.filter(bn, function(_a) {
                    return e.plainJSErrors.has(_a.code);
                  })), St(Kr, Xt && !bt, Za, bn, kt ? Kr.jsDocDiagnostics : void 0);
                });
              }
              function St(Kr, _i) {
                for (var Ei, tt = [], kt = 2; kt < arguments.length; kt++) tt[kt - 2] = arguments[kt];
                var bt = e.flatten(tt);
                if (!_i || !(!((Ei = Kr.commentDirectives) === null || Ei === void 0) && Ei.length)) return bt;
                for (var ia = pa(Kr, Kr.commentDirectives, bt), Xt = ia.diagnostics, Za = ia.directives, bn = 0, _a = Za.getUnusedExpectations(); bn < _a.length; bn++) {
                  var qa = _a[bn];
                  Xt.push(e.createDiagnosticForRange(Kr, qa.range, e.Diagnostics.Unused_ts_expect_error_directive));
                }
                return Xt;
              }
              function pa(Kr, _i, Ei) {
                var tt = e.createCommentDirectivesMap(Kr, _i), kt = Ei.filter(function(bt) {
                  return Jn(bt, tt) === -1;
                });
                return { diagnostics: kt, directives: tt };
              }
              function dn(Kr, _i) {
                return no(function() {
                  return xn().getSuggestionDiagnostics(Kr, _i);
                });
              }
              function Jn(Kr, _i) {
                var Ei = Kr.file, tt = Kr.start;
                if (!Ei) return -1;
                for (var kt = e.getLineStarts(Ei), bt = e.computeLineAndCharacterOfPosition(kt, tt).line - 1; bt >= 0; ) {
                  if (_i.markUsed(bt)) return bt;
                  var ia = Ei.text.slice(kt[bt], kt[bt + 1]).trim();
                  if (ia !== "" && !/^(\s*)\/\/(.*)$/.test(ia)) return -1;
                  bt--;
                }
                return -1;
              }
              function Qe(Kr) {
                return no(function() {
                  var _i = [];
                  return Ei(Kr, Kr), e.forEachChildRecursively(Kr, Ei, tt), _i;
                  function Ei(Xt, Za) {
                    switch (Za.kind) {
                      case 164:
                      case 167:
                      case 169:
                        if (Za.questionToken === Xt) return _i.push(ia(Xt, e.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, "?")), "skip";
                      case 168:
                      case 171:
                      case 172:
                      case 173:
                      case 213:
                      case 256:
                      case 214:
                      case 254:
                        if (Za.type === Xt) return _i.push(ia(Xt, e.Diagnostics.Type_annotations_can_only_be_used_in_TypeScript_files)), "skip";
                    }
                    switch (Xt.kind) {
                      case 267:
                        if (Xt.isTypeOnly) return _i.push(ia(Za, e.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, "import type")), "skip";
                        break;
                      case 272:
                        if (Xt.isTypeOnly) return _i.push(ia(Xt, e.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, "export type")), "skip";
                        break;
                      case 270:
                      case 275:
                        if (Xt.isTypeOnly) return _i.push(ia(Xt, e.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, e.isImportSpecifier(Xt) ? "import...type" : "export...type")), "skip";
                        break;
                      case 265:
                        return _i.push(ia(Xt, e.Diagnostics.import_can_only_be_used_in_TypeScript_files)), "skip";
                      case 271:
                        if (Xt.isExportEquals) return _i.push(ia(Xt, e.Diagnostics.export_can_only_be_used_in_TypeScript_files)), "skip";
                        break;
                      case 291:
                        var bn = Xt;
                        if (bn.token === 117) return _i.push(ia(Xt, e.Diagnostics.implements_clauses_can_only_be_used_in_TypeScript_files)), "skip";
                        break;
                      case 258:
                        var _a = e.tokenToString(118);
                        return e.Debug.assertIsDefined(_a), _i.push(ia(Xt, e.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, _a)), "skip";
                      case 261:
                        var qa = Xt.flags & 16 ? e.tokenToString(142) : e.tokenToString(141);
                        return e.Debug.assertIsDefined(qa), _i.push(ia(Xt, e.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, qa)), "skip";
                      case 259:
                        return _i.push(ia(Xt, e.Diagnostics.Type_aliases_can_only_be_used_in_TypeScript_files)), "skip";
                      case 260:
                        var rn = e.Debug.checkDefined(e.tokenToString(92));
                        return _i.push(ia(Xt, e.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, rn)), "skip";
                      case 230:
                        return _i.push(ia(Xt, e.Diagnostics.Non_null_assertions_can_only_be_used_in_TypeScript_files)), "skip";
                      case 229:
                        return _i.push(ia(Xt.type, e.Diagnostics.Type_assertion_expressions_can_only_be_used_in_TypeScript_files)), "skip";
                      case 211:
                        e.Debug.fail();
                    }
                  }
                  function tt(Xt, Za) {
                    switch (Za.decorators === Xt && !de.experimentalDecorators && _i.push(ia(Za, e.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning)), Za.kind) {
                      case 257:
                      case 226:
                      case 169:
                      case 171:
                      case 172:
                      case 173:
                      case 213:
                      case 256:
                      case 214:
                        if (Xt === Za.typeParameters) return _i.push(bt(Xt, e.Diagnostics.Type_parameter_declarations_can_only_be_used_in_TypeScript_files)), "skip";
                      case 237:
                        if (Xt === Za.modifiers) return kt(Za.modifiers, Za.kind === 237), "skip";
                        break;
                      case 167:
                        if (Xt === Za.modifiers) {
                          for (var bn = 0, _a = Xt; bn < _a.length; bn++) {
                            var qa = _a[bn];
                            qa.kind !== 124 && _i.push(ia(qa, e.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, e.tokenToString(qa.kind)));
                          }
                          return "skip";
                        }
                        break;
                      case 164:
                        if (Xt === Za.modifiers) return _i.push(bt(Xt, e.Diagnostics.Parameter_modifiers_can_only_be_used_in_TypeScript_files)), "skip";
                        break;
                      case 208:
                      case 209:
                      case 228:
                      case 279:
                      case 280:
                      case 210:
                        if (Xt === Za.typeArguments) return _i.push(bt(Xt, e.Diagnostics.Type_arguments_can_only_be_used_in_TypeScript_files)), "skip";
                        break;
                    }
                  }
                  function kt(Xt, Za) {
                    for (var bn = 0, _a = Xt; bn < _a.length; bn++) {
                      var qa = _a[bn];
                      switch (qa.kind) {
                        case 85:
                          if (Za) continue;
                        case 123:
                        case 121:
                        case 122:
                        case 145:
                        case 135:
                        case 126:
                        case 159:
                        case 101:
                        case 144:
                          _i.push(ia(qa, e.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, e.tokenToString(qa.kind)));
                          break;
                        case 124:
                        case 93:
                        case 88:
                      }
                    }
                  }
                  function bt(Xt, Za, bn, _a, qa) {
                    var rn = Xt.pos;
                    return e.createFileDiagnostic(Kr, rn, Xt.end - rn, Za, bn, _a, qa);
                  }
                  function ia(Xt, Za, bn, _a, qa) {
                    return e.createDiagnosticForNodeInSourceFile(Kr, Xt, Za, bn, _a, qa);
                  }
                });
              }
              function Gr(Kr, _i) {
                return Ce(Kr, _i, ur, S);
              }
              function S(Kr, _i) {
                return no(function() {
                  var Ei = xn().getEmitResolver(Kr, _i);
                  return e.getDeclarationDiagnostics(ai(e.noop), Ei, Kr) || e.emptyArray;
                });
              }
              function Ce(Kr, _i, Ei, tt) {
                var kt, bt = Kr ? (kt = Ei.perFile) === null || kt === void 0 ? void 0 : kt.get(Kr.path) : Ei.allDiagnostics;
                if (bt) return bt;
                var ia = tt(Kr, _i);
                return Kr ? (Ei.perFile || (Ei.perFile = new e.Map())).set(Kr.path, ia) : Ei.allDiagnostics = ia, ia;
              }
              function qe(Kr, _i) {
                return Kr.isDeclarationFile ? [] : Gr(Kr, _i);
              }
              function br() {
                return e.sortAndDeduplicateDiagnostics(e.concatenate(wi.getGlobalDiagnostics(), Zr()));
              }
              function Zr() {
                if (!de.configFile) return e.emptyArray;
                var Kr = wi.getDiagnostics(de.configFile.fileName);
                return Ji(function(_i) {
                  Kr = e.concatenate(Kr, wi.getDiagnostics(_i.sourceFile.fileName));
                }), Kr;
              }
              function Si() {
                return we.length ? e.sortAndDeduplicateDiagnostics(xn().getGlobalDiagnostics().slice()) : e.emptyArray;
              }
              function Pi() {
                return ye || e.emptyArray;
              }
              function Qi(Kr, _i, Ei, tt) {
                Go(e.normalizePath(Kr), _i, Ei, void 0, tt);
              }
              function Ct(Kr, _i) {
                return Kr.fileName === _i.fileName;
              }
              function sa(Kr, _i) {
                return Kr.kind === 79 ? _i.kind === 79 && Kr.escapedText === _i.escapedText : _i.kind === 10 && Kr.text === _i.text;
              }
              function en(Kr, _i) {
                var Ei = e.factory.createStringLiteral(Kr), tt = e.factory.createImportDeclaration(void 0, void 0, void 0, Ei, void 0);
                return e.addEmitFlags(tt, 67108864), e.setParent(Ei, tt), e.setParent(tt, _i), Ei.flags &= -9, tt.flags &= -9, Ei;
              }
              function Wa(Kr) {
                if (Kr.imports) return;
                var _i = e.isSourceFileJS(Kr), Ei = e.isExternalModule(Kr), tt, kt, bt;
                if ((de.isolatedModules || Ei) && !Kr.isDeclarationFile) {
                  de.importHelpers && (tt = [en(e.externalHelpersModuleNameText, Kr)]);
                  var ia = e.getJSXRuntimeImport(e.getJSXImplicitImportBase(de, Kr), de);
                  ia && (tt || (tt = [])).push(en(ia, Kr));
                }
                for (var Xt = 0, Za = Kr.statements; Xt < Za.length; Xt++) {
                  var bn = Za[Xt];
                  _a(bn, false);
                }
                (Kr.flags & 2097152 || _i) && qa(Kr), Kr.imports = tt || e.emptyArray, Kr.moduleAugmentations = kt || e.emptyArray, Kr.ambientModuleNames = bt || e.emptyArray;
                return;
                function _a(jn, Mo) {
                  if (e.isAnyImportOrReExport(jn)) {
                    var ho = e.getExternalModuleName(jn);
                    ho && e.isStringLiteral(ho) && ho.text && (!Mo || !e.isExternalModuleNameRelative(ho.text)) && (e.setParentRecursive(jn, false), tt = e.append(tt, ho), !Je && Ur === 0 && !Kr.isDeclarationFile && (Je = e.startsWith(ho.text, "node:")));
                  } else if (e.isModuleDeclaration(jn) && e.isAmbientModule(jn) && (Mo || e.hasSyntacticModifier(jn, 2) || Kr.isDeclarationFile)) {
                    jn.name.parent = jn;
                    var gs = e.getTextOfIdentifierOrLiteral(jn.name);
                    if (Ei || Mo && !e.isExternalModuleNameRelative(gs)) (kt || (kt = [])).push(jn.name);
                    else if (!Mo) {
                      Kr.isDeclarationFile && (bt || (bt = [])).push(gs);
                      var Se = jn.body;
                      if (Se) for (var hr = 0, Or = Se.statements; hr < Or.length; hr++) {
                        var ki = Or[hr];
                        _a(ki, true);
                      }
                    }
                  }
                }
                function qa(jn) {
                  for (var Mo = /import|require/g; Mo.exec(jn.text) !== null; ) {
                    var ho = rn(jn, Mo.lastIndex);
                    _i && e.isRequireCall(ho, true) || e.isImportCall(ho) && ho.arguments.length >= 1 && e.isStringLiteralLike(ho.arguments[0]) ? (e.setParentRecursive(ho, false), tt = e.append(tt, ho.arguments[0])) : e.isLiteralImportTypeNode(ho) && (e.setParentRecursive(ho, false), tt = e.append(tt, ho.argument.literal));
                  }
                }
                function rn(jn, Mo) {
                  for (var ho = jn, gs = function(hr) {
                    if (hr.pos <= Mo && (Mo < hr.end || Mo === hr.end && hr.kind === 1)) return hr;
                  }; ; ) {
                    var Se = _i && e.hasJSDocNodes(ho) && e.forEach(ho.jsDoc, gs) || e.forEachChild(ho, gs);
                    if (!Se) return ho;
                    ho = Se;
                  }
                }
              }
              function qn(Kr) {
                var _i = e.toFileNameLowerCase(Kr.fileName), Ei = e.libMap.get(_i);
                if (Ei) return Rn(Pt(Ei));
              }
              function mo(Kr, _i) {
                return So(C(_i.fileName, Kr.fileName), Rn);
              }
              function So(Kr, _i, Ei, tt) {
                if (e.hasExtension(Kr)) {
                  var kt = pe.getCanonicalFileName(Kr);
                  if (!de.allowNonTsExtensions && !e.forEach(e.flatten(Gi), function(bn) {
                    return e.fileExtensionIs(kt, bn);
                  })) {
                    Ei && (e.hasJSFileExtension(kt) ? Ei(e.Diagnostics.File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option, Kr) : Ei(e.Diagnostics.File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1, Kr, "'" + e.flatten(et).join("', '") + "'"));
                    return;
                  }
                  var bt = _i(Kr);
                  if (Ei) if (bt) V(tt) && kt === pe.getCanonicalFileName(Da(tt.file).fileName) && Ei(e.Diagnostics.A_file_cannot_have_a_reference_to_itself);
                  else {
                    var ia = ps(Kr);
                    ia ? Ei(e.Diagnostics.Output_file_0_has_not_been_built_from_source_file_1, ia, Kr) : Ei(e.Diagnostics.File_0_not_found, Kr);
                  }
                  return bt;
                } else {
                  var Xt = de.allowNonTsExtensions && _i(Kr);
                  if (Xt) return Xt;
                  if (Ei && de.allowNonTsExtensions) {
                    Ei(e.Diagnostics.File_0_not_found, Kr);
                    return;
                  }
                  var Za = e.forEach(et[0], function(bn) {
                    return _i(Kr + bn);
                  });
                  return Ei && !Za && Ei(e.Diagnostics.Could_not_resolve_the_path_0_with_the_extensions_Colon_1, Kr, "'" + e.flatten(et).join("', '") + "'"), Za;
                }
              }
              function Go(Kr, _i, Ei, tt, kt) {
                So(Kr, function(bt) {
                  return Kc(bt, _i, Ei, kt, tt);
                }, function(bt) {
                  for (var ia = [], Xt = 1; Xt < arguments.length; Xt++) ia[Xt - 1] = arguments[Xt];
                  return ko(void 0, kt, bt, ia);
                }, kt);
              }
              function ys(Kr, _i) {
                return Go(Kr, false, false, void 0, _i);
              }
              function Pc(Kr, _i, Ei) {
                var tt = !V(Ei) && e.some(be.get(_i.path), V);
                tt ? ko(_i, Ei, e.Diagnostics.Already_included_file_name_0_differs_from_file_name_1_only_in_casing, [_i.fileName, Kr]) : ko(_i, Ei, e.Diagnostics.File_name_0_differs_from_already_included_file_name_1_only_in_casing, [Kr, _i.fileName]);
              }
              function Vc(Kr, _i, Ei, tt, kt, bt) {
                var ia = Object.create(Kr);
                return ia.fileName = Ei, ia.path = tt, ia.resolvedPath = kt, ia.originalFileName = bt, ia.redirectInfo = { redirectTarget: Kr, unredirected: _i }, mi.set(tt, Ur > 0), Object.defineProperties(ia, { id: { get: function() {
                  return this.redirectInfo.redirectTarget.id;
                }, set: function(Xt) {
                  this.redirectInfo.redirectTarget.id = Xt;
                } }, symbol: { get: function() {
                  return this.redirectInfo.redirectTarget.symbol;
                }, set: function(Xt) {
                  this.redirectInfo.redirectTarget.symbol = Xt;
                } } }), ia;
              }
              function Kc(Kr, _i, Ei, tt, kt) {
                e.tracing === null || e.tracing === void 0 || e.tracing.push("program", "findSourceFile", { fileName: Kr, isDefaultLib: _i || void 0, fileIncludeKind: e.FileIncludeKind[tt.kind] });
                var bt = pc(Kr, _i, Ei, tt, kt);
                return e.tracing === null || e.tracing === void 0 || e.tracing.pop(), bt;
              }
              function Xs(Kr, _i, Ei, tt) {
                var kt = U(Vi(Kr), _i == null ? void 0 : _i.getPackageJsonInfoCache(), Ei, tt);
                return { languageVersion: e.getEmitScriptTarget(tt), impliedNodeFormat: kt, setExternalModuleIndicator: e.getSetExternalModuleIndicator(tt) };
              }
              function pc(Kr, _i, Ei, tt, kt) {
                var bt = Vi(Kr);
                if (Pe) {
                  var ia = ce(bt);
                  if (!ia && pe.realpath && de.preserveSymlinks && e.isDeclarationFileName(Kr) && e.stringContains(Kr, e.nodeModulesPathPart)) {
                    var Xt = Vi(pe.realpath(Kr));
                    Xt !== bt && (ia = ce(Xt));
                  }
                  if (ia) {
                    var Za = e.isString(ia) ? Kc(ia, _i, Ei, tt, kt) : void 0;
                    return Za && tc(Za, bt, void 0), Za;
                  }
                }
                var bn = Kr;
                if (xe.has(bt)) {
                  var _a = xe.get(bt);
                  if (hs(_a || void 0, tt), _a && de.forceConsistentCasingInFileNames) {
                    var qa = _a.fileName, rn = Vi(qa) !== Vi(Kr);
                    rn && (Kr = ps(Kr) || Kr);
                    var jn = e.getNormalizedAbsolutePathWithoutRoot(qa, Xi), Mo = e.getNormalizedAbsolutePathWithoutRoot(Kr, Xi);
                    jn !== Mo && Pc(Kr, _a, tt);
                  }
                  return _a && mi.get(_a.path) && Ur === 0 ? (mi.set(_a.path, false), de.noResolve || (qi(_a, _i), je(_a)), de.noLib || ga(_a), ii.set(_a.path, false), Xn(_a)) : _a && ii.get(_a.path) && Ur < wr && (ii.set(_a.path, false), Xn(_a)), _a || void 0;
                }
                var ho;
                if (V(tt) && !Pe) {
                  var gs = Qs(Kr);
                  if (gs) {
                    if (e.outFile(gs.commandLine.options)) return;
                    var Se = js(gs, Kr);
                    Kr = Se, ho = Vi(Se);
                  }
                }
                var hr = pe.getSourceFile(Kr, Xs(Kr, _r, pe, de), function(On) {
                  return ko(void 0, tt, e.Diagnostics.Cannot_read_file_0_Colon_1, [Kr, On]);
                }, Tr);
                if (kt) {
                  var Or = e.packageIdToString(kt), ki = Sr.get(Or);
                  if (ki) {
                    var dt = Vc(ki, hr, Kr, bt, Vi(Kr), bn);
                    return Wr.add(ki.path, Kr), tc(dt, bt, ho), hs(dt, tt), zr.set(bt, e.packageIdToPackageName(kt)), Cr.push(dt), dt;
                  } else hr && (Sr.set(Or, hr), zr.set(bt, e.packageIdToPackageName(kt)));
                }
                if (tc(hr, bt, ho), hr) {
                  if (mi.set(bt, Ur > 0), hr.fileName = Kr, hr.path = bt, hr.resolvedPath = Vi(Kr), hr.originalFileName = bn, hs(hr, tt), pe.useCaseSensitiveFileNames()) {
                    var la = e.toFileNameLowerCase(bt), wa = mr.get(la);
                    wa ? Pc(Kr, wa, tt) : mr.set(la, hr);
                  }
                  qr = qr || hr.hasNoDefaultLib && !Ei, de.noResolve || (qi(hr, _i), je(hr)), de.noLib || ga(hr), Xn(hr), _i ? ir.push(hr) : Cr.push(hr);
                }
                return hr;
              }
              function hs(Kr, _i) {
                Kr && be.add(Kr.path, _i);
              }
              function tc(Kr, _i, Ei) {
                Ei ? (xe.set(Ei, Kr), xe.set(_i, Kr || false)) : xe.set(_i, Kr);
              }
              function ps(Kr) {
                var _i = Qs(Kr);
                return _i && js(_i, Kr);
              }
              function Qs(Kr) {
                if (!(!Ar || !Ar.length || e.isDeclarationFileName(Kr) || e.fileExtensionIs(Kr, ".json"))) return ds(Kr);
              }
              function js(Kr, _i) {
                var Ei = e.outFile(Kr.commandLine.options);
                return Ei ? e.changeExtension(Ei, ".d.ts") : e.getOutputDeclarationFileName(_i, Kr.commandLine, !pe.useCaseSensitiveFileNames());
              }
              function ds(Kr) {
                nr === void 0 && (nr = new e.Map(), Ji(function(Ei) {
                  Vi(de.configFilePath) !== Ei.sourceFile.path && Ei.commandLine.fileNames.forEach(function(tt) {
                    return nr.set(Vi(tt), Ei.sourceFile.path);
                  });
                }));
                var _i = nr.get(Vi(Kr));
                return _i && yi(_i);
              }
              function Ji(Kr) {
                return e.forEachResolvedProjectReference(Ar, Kr);
              }
              function ce(Kr) {
                if (!!e.isDeclarationFileName(Kr)) return Mr === void 0 && (Mr = new e.Map(), Ji(function(_i) {
                  var Ei = e.outFile(_i.commandLine.options);
                  if (Ei) {
                    var tt = e.changeExtension(Ei, ".d.ts");
                    Mr.set(Vi(tt), true);
                  } else {
                    var kt = e.memoize(function() {
                      return e.getCommonSourceDirectoryOfConfig(_i.commandLine, !pe.useCaseSensitiveFileNames());
                    });
                    e.forEach(_i.commandLine.fileNames, function(bt) {
                      if (!e.isDeclarationFileName(bt) && !e.fileExtensionIs(bt, ".json")) {
                        var ia = e.getOutputDeclarationFileName(bt, _i.commandLine, !pe.useCaseSensitiveFileNames(), kt);
                        Mr.set(Vi(ia), bt);
                      }
                    });
                  }
                })), Mr.get(Kr);
              }
              function Rr(Kr) {
                return Pe && !!ds(Kr);
              }
              function yi(Kr) {
                if (!!Oe) return Oe.get(Kr) || void 0;
              }
              function qi(Kr, _i) {
                e.forEach(Kr.referencedFiles, function(Ei, tt) {
                  Go(C(Ei.fileName, Kr.fileName), _i, false, void 0, { kind: e.FileIncludeKind.ReferenceFile, file: Kr.path, index: tt });
                });
              }
              function je(Kr) {
                var _i = Kr.typeReferenceDirectives;
                if (!!_i) for (var Ei = Bt(_i, Kr), tt = 0; tt < _i.length; tt++) {
                  var kt = Kr.typeReferenceDirectives[tt], bt = Ei[tt], ia = e.toFileNameLowerCase(kt.fileName);
                  e.setResolvedTypeReferenceDirective(Kr, ia, bt);
                  var Xt = kt.resolutionMode || Kr.impliedNodeFormat;
                  Xt && e.getEmitModuleResolutionKind(de) !== e.ModuleResolutionKind.Node16 && e.getEmitModuleResolutionKind(de) !== e.ModuleResolutionKind.NodeNext && wi.add(e.createDiagnosticForRange(Kr, kt, e.Diagnostics.Resolution_modes_are_only_supported_when_moduleResolution_is_node16_or_nodenext)), Hr(ia, Xt, bt, { kind: e.FileIncludeKind.TypeReferenceDirective, file: Kr.path, index: tt });
                }
              }
              function Hr(Kr, _i, Ei, tt) {
                e.tracing === null || e.tracing === void 0 || e.tracing.push("program", "processTypeReferenceDirective", { directive: Kr, hasResolved: !!ba, refKind: tt.kind, refPath: V(tt) ? tt.file : void 0 }), pt(Kr, _i, Ei, tt), e.tracing === null || e.tracing === void 0 || e.tracing.pop();
              }
              function pt(Kr, _i, Ei, tt) {
                var kt = yr.get(Kr, _i);
                if (!(kt && kt.primary)) {
                  var bt = true;
                  if (Ei) {
                    if (Ei.isExternalLibraryImport && Ur++, Ei.primary) Go(Ei.resolvedFileName, false, false, Ei.packageId, tt);
                    else if (kt) {
                      if (Ei.resolvedFileName !== kt.resolvedFileName) {
                        var ia = pe.readFile(Ei.resolvedFileName), Xt = Rn(kt.resolvedFileName);
                        ia !== Xt.text && ko(Xt, tt, e.Diagnostics.Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict, [Kr, Ei.resolvedFileName, kt.resolvedFileName]);
                      }
                      bt = false;
                    } else Go(Ei.resolvedFileName, false, false, Ei.packageId, tt);
                    Ei.isExternalLibraryImport && Ur--;
                  } else ko(void 0, tt, e.Diagnostics.Cannot_find_type_definition_file_for_0, [Kr]);
                  bt && yr.set(Kr, _i, Ei);
                }
              }
              function Pt(Kr) {
                for (var _i = Kr.split("."), Ei = _i[1], tt = 2; _i[tt] && _i[tt] !== "d"; ) Ei += (tt === 2 ? "/" : "-") + _i[tt], tt++;
                var kt = e.combinePaths(Xi, "__lib_node_modules_lookup_".concat(Kr, "__.ts")), bt = e.resolveModuleName("@typescript/lib-" + Ei, kt, { moduleResolution: e.ModuleResolutionKind.NodeJs }, pe, _r);
                return bt != null && bt.resolvedModule ? bt.resolvedModule.resolvedFileName : e.combinePaths(Di, Kr);
              }
              function ga(Kr) {
                e.forEach(Kr.libReferenceDirectives, function(_i, Ei) {
                  var tt = e.toFileNameLowerCase(_i.fileName), kt = e.libMap.get(tt);
                  if (kt) Qi(Pt(kt), true, true, { kind: e.FileIncludeKind.LibReferenceDirective, file: Kr.path, index: Ei });
                  else {
                    var bt = e.removeSuffix(e.removePrefix(tt, "lib."), ".d.ts"), ia = e.getSpellingSuggestion(bt, e.libs, e.identity), Xt = ia ? e.Diagnostics.Cannot_find_lib_definition_for_0_Did_you_mean_1 : e.Diagnostics.Cannot_find_lib_definition_for_0;
                    (Ir || (Ir = [])).push({ kind: 0, reason: { kind: e.FileIncludeKind.LibReferenceDirective, file: Kr.path, index: Ei }, diagnostic: Xt, args: [tt, ia] });
                  }
                });
              }
              function ua(Kr) {
                return pe.getCanonicalFileName(Kr);
              }
              function Xn(Kr) {
                var _i;
                if (Wa(Kr), Kr.imports.length || Kr.moduleAugmentations.length) {
                  var Ei = We(Kr), tt = ba(Ei, Kr);
                  e.Debug.assert(tt.length === Ei.length);
                  for (var kt = (Pe ? (_i = wt(Kr)) === null || _i === void 0 ? void 0 : _i.commandLine.options : void 0) || de, bt = 0; bt < Ei.length; bt++) {
                    var ia = tt[bt];
                    if (e.setResolvedModule(Kr, Ei[bt], ia, he(Kr, bt)), !!ia) {
                      var Xt = ia.isExternalLibraryImport, Za = !e.resolutionExtensionIsTSOrJson(ia.extension), bn = Xt && Za, _a = ia.resolvedFileName;
                      Xt && Ur++;
                      var qa = bn && Ur > wr, rn = _a && !ue(kt, ia) && !kt.noResolve && bt < Kr.imports.length && !qa && !(Za && !e.getAllowJSCompilerOption(kt)) && (e.isInJSFile(Kr.imports[bt]) || !(Kr.imports[bt].flags & 8388608));
                      qa ? ii.set(Kr.path, true) : rn && Kc(_a, false, false, { kind: e.FileIncludeKind.Import, file: Kr.path, index: bt }, ia.packageId), Xt && Ur--;
                    }
                  }
                } else Kr.resolvedModules = void 0;
              }
              function jr(Kr, _i) {
                for (var Ei = true, tt = pe.getCanonicalFileName(e.getNormalizedAbsolutePath(_i, Xi)), kt = 0, bt = Kr; kt < bt.length; kt++) {
                  var ia = bt[kt];
                  if (!ia.isDeclarationFile) {
                    var Xt = pe.getCanonicalFileName(e.getNormalizedAbsolutePath(ia.fileName, Xi));
                    Xt.indexOf(tt) !== 0 && (Ao(ia, e.Diagnostics.File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files, [ia.fileName, _i]), Ei = false);
                  }
                }
                return Ei;
              }
              function fo(Kr) {
                Oe || (Oe = new e.Map());
                var _i = ne(Kr), Ei = Vi(_i), tt = Oe.get(Ei);
                if (tt !== void 0) return tt || void 0;
                var kt, bt;
                if (pe.getParsedCommandLine) {
                  if (kt = pe.getParsedCommandLine(_i), !kt) {
                    tc(void 0, Ei, void 0), Oe.set(Ei, false);
                    return;
                  }
                  bt = e.Debug.checkDefined(kt.options.configFile), e.Debug.assert(!bt.path || bt.path === Ei), tc(bt, Ei, void 0);
                } else {
                  var ia = e.getNormalizedAbsolutePath(e.getDirectoryPath(_i), pe.getCurrentDirectory());
                  if (bt = pe.getSourceFile(_i, 100), tc(bt, Ei, void 0), bt === void 0) {
                    Oe.set(Ei, false);
                    return;
                  }
                  kt = e.parseJsonSourceFileConfigFileContent(bt, or, ia, void 0, _i);
                }
                bt.fileName = _i, bt.path = Ei, bt.resolvedPath = Ei, bt.originalFileName = _i;
                var Xt = { commandLine: kt, sourceFile: bt };
                return Oe.set(Ei, Xt), kt.projectReferences && (Xt.references = kt.projectReferences.map(fo)), Xt;
              }
              function xs() {
                de.strictPropertyInitialization && !e.getStrictOptionValue(de, "strictNullChecks") && Jo(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "strictPropertyInitialization", "strictNullChecks"), de.exactOptionalPropertyTypes && !e.getStrictOptionValue(de, "strictNullChecks") && Jo(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "exactOptionalPropertyTypes", "strictNullChecks"), de.isolatedModules && (de.out && Jo(e.Diagnostics.Option_0_cannot_be_specified_with_option_1, "out", "isolatedModules"), de.outFile && Jo(e.Diagnostics.Option_0_cannot_be_specified_with_option_1, "outFile", "isolatedModules")), de.inlineSourceMap && (de.sourceMap && Jo(e.Diagnostics.Option_0_cannot_be_specified_with_option_1, "sourceMap", "inlineSourceMap"), de.mapRoot && Jo(e.Diagnostics.Option_0_cannot_be_specified_with_option_1, "mapRoot", "inlineSourceMap")), de.composite && (de.declaration === false && Jo(e.Diagnostics.Composite_projects_may_not_disable_declaration_emit, "declaration"), de.incremental === false && Jo(e.Diagnostics.Composite_projects_may_not_disable_incremental_compilation, "declaration"));
                var Kr = e.outFile(de);
                if (de.tsBuildInfoFile ? e.isIncrementalCompilation(de) || Jo(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "tsBuildInfoFile", "incremental", "composite") : de.incremental && !Kr && !de.configFilePath && wi.add(e.createCompilerDiagnostic(e.Diagnostics.Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified)), Bs(), de.composite) for (var _i = new e.Set(we.map(Vi)), Ei = 0, tt = Ye; Ei < tt.length; Ei++) {
                  var kt = tt[Ei];
                  e.sourceFileMayBeEmitted(kt, Ii) && !_i.has(kt.path) && Ao(kt, e.Diagnostics.File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_include_pattern, [kt.fileName, de.configFilePath || ""]);
                }
                if (de.paths) {
                  for (var bt in de.paths) if (!!e.hasProperty(de.paths, bt)) if (e.hasZeroOrOneAsteriskCharacter(bt) || su(true, bt, e.Diagnostics.Pattern_0_can_have_at_most_one_Asterisk_character, bt), e.isArray(de.paths[bt])) {
                    var ia = de.paths[bt].length;
                    ia === 0 && su(false, bt, e.Diagnostics.Substitutions_for_pattern_0_shouldn_t_be_an_empty_array, bt);
                    for (var Xt = 0; Xt < ia; Xt++) {
                      var Za = de.paths[bt][Xt], bn = typeof Za;
                      bn === "string" ? (e.hasZeroOrOneAsteriskCharacter(Za) || xc(bt, Xt, e.Diagnostics.Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character, Za, bt), !de.baseUrl && !e.pathIsRelative(Za) && !e.pathIsAbsolute(Za) && xc(bt, Xt, e.Diagnostics.Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash)) : xc(bt, Xt, e.Diagnostics.Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2, Za, bt, bn);
                    }
                  } else su(false, bt, e.Diagnostics.Substitutions_for_pattern_0_should_be_an_array, bt);
                }
                !de.sourceMap && !de.inlineSourceMap && (de.inlineSources && Jo(e.Diagnostics.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided, "inlineSources"), de.sourceRoot && Jo(e.Diagnostics.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided, "sourceRoot")), de.out && de.outFile && Jo(e.Diagnostics.Option_0_cannot_be_specified_with_option_1, "out", "outFile"), de.mapRoot && !(de.sourceMap || de.declarationMap) && Jo(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "mapRoot", "sourceMap", "declarationMap"), de.declarationDir && (e.getEmitDeclarations(de) || Jo(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "declarationDir", "declaration", "composite"), Kr && Jo(e.Diagnostics.Option_0_cannot_be_specified_with_option_1, "declarationDir", de.out ? "out" : "outFile")), de.declarationMap && !e.getEmitDeclarations(de) && Jo(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "declarationMap", "declaration", "composite"), de.lib && de.noLib && Jo(e.Diagnostics.Option_0_cannot_be_specified_with_option_1, "lib", "noLib"), de.noImplicitUseStrict && e.getStrictOptionValue(de, "alwaysStrict") && Jo(e.Diagnostics.Option_0_cannot_be_specified_with_option_1, "noImplicitUseStrict", "alwaysStrict");
                var _a = e.getEmitScriptTarget(de), qa = e.find(Ye, function(hr) {
                  return e.isExternalModule(hr) && !hr.isDeclarationFile;
                });
                if (de.isolatedModules) {
                  de.module === e.ModuleKind.None && _a < 2 && Jo(e.Diagnostics.Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher, "isolatedModules", "target"), de.preserveConstEnums === false && Jo(e.Diagnostics.Option_preserveConstEnums_cannot_be_disabled_when_isolatedModules_is_enabled, "preserveConstEnums", "isolatedModules");
                  var rn = e.find(Ye, function(hr) {
                    return !e.isExternalModule(hr) && !e.isSourceFileJS(hr) && !hr.isDeclarationFile && hr.scriptKind !== 6;
                  });
                  if (rn) {
                    var jn = e.getErrorSpanForNode(rn, rn);
                    wi.add(e.createFileDiagnostic(rn, jn.start, jn.length, e.Diagnostics._0_cannot_be_compiled_under_isolatedModules_because_it_is_considered_a_global_script_file_Add_an_import_export_or_an_empty_export_statement_to_make_it_a_module, e.getBaseFileName(rn.fileName)));
                  }
                } else if (qa && _a < 2 && de.module === e.ModuleKind.None) {
                  var jn = e.getErrorSpanForNode(qa, typeof qa.externalModuleIndicator == "boolean" ? qa : qa.externalModuleIndicator);
                  wi.add(e.createFileDiagnostic(qa, jn.start, jn.length, e.Diagnostics.Cannot_use_imports_exports_or_module_augmentations_when_module_is_none));
                }
                if (Kr && !de.emitDeclarationOnly) {
                  if (de.module && !(de.module === e.ModuleKind.AMD || de.module === e.ModuleKind.System)) Jo(e.Diagnostics.Only_amd_and_system_modules_are_supported_alongside_0, de.out ? "out" : "outFile", "module");
                  else if (de.module === void 0 && qa) {
                    var jn = e.getErrorSpanForNode(qa, typeof qa.externalModuleIndicator == "boolean" ? qa : qa.externalModuleIndicator);
                    wi.add(e.createFileDiagnostic(qa, jn.start, jn.length, e.Diagnostics.Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system, de.out ? "out" : "outFile"));
                  }
                }
                if (de.resolveJsonModule && (e.getEmitModuleResolutionKind(de) !== e.ModuleResolutionKind.NodeJs && e.getEmitModuleResolutionKind(de) !== e.ModuleResolutionKind.Node16 && e.getEmitModuleResolutionKind(de) !== e.ModuleResolutionKind.NodeNext ? Jo(e.Diagnostics.Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy, "resolveJsonModule") : e.hasJsonModuleEmitEnabled(de) || Jo(e.Diagnostics.Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_esNext, "resolveJsonModule", "module")), de.outDir || de.rootDir || de.sourceRoot || de.mapRoot) {
                  var Mo = at();
                  de.outDir && Mo === "" && Ye.some(function(hr) {
                    return e.getRootLength(hr.fileName) > 1;
                  }) && Jo(e.Diagnostics.Cannot_find_the_common_subdirectory_path_for_the_input_files, "outDir");
                }
                if (de.useDefineForClassFields && _a === 0 && Jo(e.Diagnostics.Option_0_cannot_be_specified_when_option_target_is_ES3, "useDefineForClassFields"), de.checkJs && !e.getAllowJSCompilerOption(de) && wi.add(e.createCompilerDiagnostic(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "checkJs", "allowJs")), de.emitDeclarationOnly && (e.getEmitDeclarations(de) || Jo(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "emitDeclarationOnly", "declaration", "composite"), de.noEmit && Jo(e.Diagnostics.Option_0_cannot_be_specified_with_option_1, "emitDeclarationOnly", "noEmit")), de.emitDecoratorMetadata && !de.experimentalDecorators && Jo(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "emitDecoratorMetadata", "experimentalDecorators"), de.jsxFactory ? (de.reactNamespace && Jo(e.Diagnostics.Option_0_cannot_be_specified_with_option_1, "reactNamespace", "jsxFactory"), (de.jsx === 4 || de.jsx === 5) && Jo(e.Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "jsxFactory", e.inverseJsxOptionMap.get("" + de.jsx)), e.parseIsolatedEntityName(de.jsxFactory, _a) || eu("jsxFactory", e.Diagnostics.Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name, de.jsxFactory)) : de.reactNamespace && !e.isIdentifierText(de.reactNamespace, _a) && eu("reactNamespace", e.Diagnostics.Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier, de.reactNamespace), de.jsxFragmentFactory && (de.jsxFactory || Jo(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "jsxFragmentFactory", "jsxFactory"), (de.jsx === 4 || de.jsx === 5) && Jo(e.Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "jsxFragmentFactory", e.inverseJsxOptionMap.get("" + de.jsx)), e.parseIsolatedEntityName(de.jsxFragmentFactory, _a) || eu("jsxFragmentFactory", e.Diagnostics.Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name, de.jsxFragmentFactory)), de.reactNamespace && (de.jsx === 4 || de.jsx === 5) && Jo(e.Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "reactNamespace", e.inverseJsxOptionMap.get("" + de.jsx)), de.jsxImportSource && de.jsx === 2 && Jo(e.Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "jsxImportSource", e.inverseJsxOptionMap.get("" + de.jsx)), de.preserveValueImports && e.getEmitModuleKind(de) < e.ModuleKind.ES2015 && eu("importsNotUsedAsValues", e.Diagnostics.Option_preserveValueImports_can_only_be_used_when_module_is_set_to_es2015_or_later), !de.noEmit && !de.suppressOutputPathCheck) {
                  var ho = ai(), gs = new e.Set();
                  e.forEachEmittedFile(ho, function(hr) {
                    de.emitDeclarationOnly || Se(hr.jsFilePath, gs), Se(hr.declarationFilePath, gs);
                  });
                }
                function Se(hr, Or) {
                  if (hr) {
                    var ki = Vi(hr);
                    if (xe.has(ki)) {
                      var dt = void 0;
                      de.configFilePath || (dt = e.chainDiagnosticMessages(void 0, e.Diagnostics.Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig)), dt = e.chainDiagnosticMessages(dt, e.Diagnostics.Cannot_write_file_0_because_it_would_overwrite_input_file, hr), xl(hr, e.createCompilerDiagnosticFromMessageChain(dt));
                    }
                    var la = pe.useCaseSensitiveFileNames() ? ki : e.toFileNameLowerCase(ki);
                    Or.has(la) ? xl(hr, e.createCompilerDiagnostic(e.Diagnostics.Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files, hr)) : Or.add(la);
                  }
                }
              }
              function Fo(Kr, _i, Ei, tt) {
                var kt, bt, ia, Xt = V(_i) ? _i : void 0;
                Kr && ((kt = be.get(Kr.path)) === null || kt === void 0 || kt.forEach(rn)), _i && rn(_i), Xt && (bt == null ? void 0 : bt.length) === 1 && (bt = void 0);
                var Za = Xt && P(Da, Xt), bn = bt && e.chainDiagnosticMessages(bt, e.Diagnostics.The_file_is_in_the_program_because_Colon), _a = Kr && e.explainIfFileIsRedirect(Kr), qa = e.chainDiagnosticMessages.apply(void 0, Ve([_a ? bn ? Ve([bn], _a, true) : _a : bn, Ei], tt || e.emptyArray, false));
                return Za && L(Za) ? e.createFileDiagnosticFromMessageChain(Za.file, Za.pos, Za.end - Za.pos, qa, ia) : e.createCompilerDiagnosticFromMessageChain(qa, ia);
                function rn(jn) {
                  (bt || (bt = [])).push(e.fileIncludeReasonToDiagnostics(Ii, jn)), !Xt && V(jn) ? Xt = jn : Xt !== jn && (ia = e.append(ia, Ms(jn))), jn === _i && (_i = void 0);
                }
              }
              function ko(Kr, _i, Ei, tt) {
                (Ir || (Ir = [])).push({ kind: 1, file: Kr && Kr.path, fileProcessingReason: _i, diagnostic: Ei, args: tt });
              }
              function Ao(Kr, _i, Ei) {
                wi.add(Fo(Kr, void 0, _i, Ei));
              }
              function Ms(Kr) {
                if (V(Kr)) {
                  var _i = P(Da, Kr), Ei;
                  switch (Kr.kind) {
                    case e.FileIncludeKind.Import:
                      Ei = e.Diagnostics.File_is_included_via_import_here;
                      break;
                    case e.FileIncludeKind.ReferenceFile:
                      Ei = e.Diagnostics.File_is_included_via_reference_here;
                      break;
                    case e.FileIncludeKind.TypeReferenceDirective:
                      Ei = e.Diagnostics.File_is_included_via_type_library_reference_here;
                      break;
                    case e.FileIncludeKind.LibReferenceDirective:
                      Ei = e.Diagnostics.File_is_included_via_library_reference_here;
                      break;
                    default:
                      e.Debug.assertNever(Kr);
                  }
                  return L(_i) ? e.createFileDiagnostic(_i.file, _i.pos, _i.end - _i.pos, Ei) : void 0;
                }
                if (!!de.configFile) {
                  var tt, kt;
                  switch (Kr.kind) {
                    case e.FileIncludeKind.RootFile:
                      if (!de.configFile.configFileSpecs) return;
                      var bt = e.getNormalizedAbsolutePath(we[Kr.index], Xi), ia = e.getMatchedFileSpec(Ii, bt);
                      if (ia) {
                        tt = e.getTsConfigPropArrayElementValue(de.configFile, "files", ia), kt = e.Diagnostics.File_is_matched_by_files_list_specified_here;
                        break;
                      }
                      var Xt = e.getMatchedIncludeSpec(Ii, bt);
                      if (!Xt) return;
                      tt = e.getTsConfigPropArrayElementValue(de.configFile, "include", Xt), kt = e.Diagnostics.File_is_matched_by_include_pattern_specified_here;
                      break;
                    case e.FileIncludeKind.SourceFromProjectReference:
                    case e.FileIncludeKind.OutputFromProjectReference:
                      var Za = e.Debug.checkDefined(Ar == null ? void 0 : Ar[Kr.index]), bn = y(Ae, Ar, function(Mo, ho, gs) {
                        return Mo === Za ? { sourceFile: (ho == null ? void 0 : ho.sourceFile) || de.configFile, index: gs } : void 0;
                      });
                      if (!bn) return;
                      var _a = bn.sourceFile, qa = bn.index, rn = e.firstDefined(e.getTsConfigPropArray(_a, "references"), function(Mo) {
                        return e.isArrayLiteralExpression(Mo.initializer) ? Mo.initializer : void 0;
                      });
                      return rn && rn.elements.length > qa ? e.createDiagnosticForNodeInSourceFile(_a, rn.elements[qa], Kr.kind === e.FileIncludeKind.OutputFromProjectReference ? e.Diagnostics.File_is_output_from_referenced_project_specified_here : e.Diagnostics.File_is_source_from_referenced_project_specified_here) : void 0;
                    case e.FileIncludeKind.AutomaticTypeDirectiveFile:
                      if (!de.types) return;
                      tt = al("types", Kr.typeReference), kt = e.Diagnostics.File_is_entry_point_of_type_library_specified_here;
                      break;
                    case e.FileIncludeKind.LibFile:
                      if (Kr.index !== void 0) {
                        tt = al("lib", de.lib[Kr.index]), kt = e.Diagnostics.File_is_library_specified_here;
                        break;
                      }
                      var jn = e.forEachEntry(e.targetOptionDeclaration.type, function(Mo, ho) {
                        return Mo === e.getEmitScriptTarget(de) ? ho : void 0;
                      });
                      tt = jn ? Rf("target", jn) : void 0, kt = e.Diagnostics.File_is_default_library_for_target_specified_here;
                      break;
                    default:
                      e.Debug.assertNever(Kr);
                  }
                  return tt && e.createDiagnosticForNodeInSourceFile(de.configFile, tt, kt);
                }
              }
              function Bs() {
                var Kr = de.suppressOutputPathCheck ? void 0 : e.getTsBuildInfoEmitOutputFilePath(de);
                y(Ae, Ar, function(_i, Ei, tt) {
                  var kt = (Ei ? Ei.commandLine.projectReferences : Ae)[tt], bt = Ei && Ei.sourceFile;
                  if (!_i) {
                    Ws(bt, tt, e.Diagnostics.File_0_not_found, kt.path);
                    return;
                  }
                  var ia = _i.commandLine.options;
                  if (!ia.composite || ia.noEmit) {
                    var Xt = Ei ? Ei.commandLine.fileNames : we;
                    Xt.length && (ia.composite || Ws(bt, tt, e.Diagnostics.Referenced_project_0_must_have_setting_composite_Colon_true, kt.path), ia.noEmit && Ws(bt, tt, e.Diagnostics.Referenced_project_0_may_not_disable_emit, kt.path));
                  }
                  if (kt.prepend) {
                    var Za = e.outFile(ia);
                    Za ? pe.fileExists(Za) || Ws(bt, tt, e.Diagnostics.Output_file_0_from_project_1_does_not_exist, Za, kt.path) : Ws(bt, tt, e.Diagnostics.Cannot_prepend_project_0_because_it_does_not_have_outFile_set, kt.path);
                  }
                  !Ei && Kr && Kr === e.getTsBuildInfoEmitOutputFilePath(ia) && (Ws(bt, tt, e.Diagnostics.Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1, Kr, kt.path), Wt.set(Vi(Kr), true));
                });
              }
              function xc(Kr, _i, Ei, tt, kt, bt) {
                for (var ia = true, Xt = Zc(), Za = 0, bn = Xt; Za < bn.length; Za++) {
                  var _a = bn[Za];
                  if (e.isObjectLiteralExpression(_a.initializer)) for (var qa = 0, rn = e.getPropertyAssignment(_a.initializer, Kr); qa < rn.length; qa++) {
                    var jn = rn[qa], Mo = jn.initializer;
                    e.isArrayLiteralExpression(Mo) && Mo.elements.length > _i && (wi.add(e.createDiagnosticForNodeInSourceFile(de.configFile, Mo.elements[_i], Ei, tt, kt, bt)), ia = false);
                  }
                }
                ia && wi.add(e.createCompilerDiagnostic(Ei, tt, kt, bt));
              }
              function su(Kr, _i, Ei, tt) {
                for (var kt = true, bt = Zc(), ia = 0, Xt = bt; ia < Xt.length; ia++) {
                  var Za = Xt[ia];
                  e.isObjectLiteralExpression(Za.initializer) && Ql(Za.initializer, Kr, _i, void 0, Ei, tt) && (kt = false);
                }
                kt && wi.add(e.createCompilerDiagnostic(Ei, tt));
              }
              function tl(Kr) {
                var _i = Uu();
                return _i && e.getPropertyAssignment(_i, Kr);
              }
              function Zc() {
                return tl("paths") || e.emptyArray;
              }
              function Rf(Kr, _i) {
                var Ei = tl(Kr);
                return Ei && e.firstDefined(Ei, function(tt) {
                  return e.isStringLiteral(tt.initializer) && tt.initializer.text === _i ? tt.initializer : void 0;
                });
              }
              function al(Kr, _i) {
                var Ei = Uu();
                return Ei && e.getPropertyArrayElementValue(Ei, Kr, _i);
              }
              function Jo(Kr, _i, Ei, tt) {
                pu(true, _i, Ei, Kr, _i, Ei, tt);
              }
              function eu(Kr, _i, Ei, tt) {
                pu(false, Kr, void 0, _i, Ei, tt);
              }
              function Ws(Kr, _i, Ei, tt, kt) {
                var bt = e.firstDefined(e.getTsConfigPropArray(Kr || de.configFile, "references"), function(ia) {
                  return e.isArrayLiteralExpression(ia.initializer) ? ia.initializer : void 0;
                });
                bt && bt.elements.length > _i ? wi.add(e.createDiagnosticForNodeInSourceFile(Kr || de.configFile, bt.elements[_i], Ei, tt, kt)) : wi.add(e.createCompilerDiagnostic(Ei, tt, kt));
              }
              function pu(Kr, _i, Ei, tt, kt, bt, ia) {
                var Xt = Uu(), Za = !Xt || !Ql(Xt, Kr, _i, Ei, tt, kt, bt, ia);
                Za && wi.add(e.createCompilerDiagnostic(tt, kt, bt, ia));
              }
              function Uu() {
                if (Zt === void 0) {
                  Zt = false;
                  var Kr = e.getTsConfigObjectLiteralExpression(de.configFile);
                  if (Kr) for (var _i = 0, Ei = e.getPropertyAssignment(Kr, "compilerOptions"); _i < Ei.length; _i++) {
                    var tt = Ei[_i];
                    if (e.isObjectLiteralExpression(tt.initializer)) {
                      Zt = tt.initializer;
                      break;
                    }
                  }
                }
                return Zt || void 0;
              }
              function Ql(Kr, _i, Ei, tt, kt, bt, ia, Xt) {
                for (var Za = e.getPropertyAssignment(Kr, Ei, tt), bn = 0, _a = Za; bn < _a.length; bn++) {
                  var qa = _a[bn];
                  wi.add(e.createDiagnosticForNodeInSourceFile(de.configFile, _i ? qa.name : qa.initializer, kt, bt, ia, Xt));
                }
                return !!Za.length;
              }
              function xl(Kr, _i) {
                Wt.set(Vi(Kr), true), wi.add(_i);
              }
              function Ya(Kr) {
                if (de.noEmit) return false;
                var _i = Vi(Kr);
                if (Da(_i)) return false;
                var Ei = e.outFile(de);
                if (Ei) return du(_i, Ei) || du(_i, e.removeFileExtension(Ei) + ".d.ts");
                if (de.declarationDir && e.containsPath(de.declarationDir, _i, Xi, !pe.useCaseSensitiveFileNames())) return true;
                if (de.outDir) return e.containsPath(de.outDir, _i, Xi, !pe.useCaseSensitiveFileNames());
                if (e.fileExtensionIsOneOf(_i, e.supportedJSExtensionsFlat) || e.isDeclarationFileName(_i)) {
                  var tt = e.removeFileExtension(_i);
                  return !!Da(tt + ".ts") || !!Da(tt + ".tsx");
                }
                return false;
              }
              function du(Kr, _i) {
                return e.comparePaths(Kr, _i, Xi, !pe.useCaseSensitiveFileNames()) === 0;
              }
              function vc() {
                return pe.getSymlinkCache ? pe.getSymlinkCache() : (Br || (Br = e.createSymlinkCache(Xi, ua)), Ye && yr && !Br.hasProcessedResolutions() && Br.setSymlinksFromResolutions(Ye, yr), Br);
              }
            }
            e.createProgram = I;
            function l(Z) {
              var Be, ge = Z.compilerHost.fileExists, Re = Z.compilerHost.directoryExists, ze = Z.compilerHost.getDirectories, Ee = Z.compilerHost.realpath;
              if (!Z.useSourceOfProjectReferenceRedirect) return { onProgramCreateComplete: e.noop, fileExists: Ie };
              Z.compilerHost.fileExists = Ie;
              var He;
              return Re && (He = Z.compilerHost.directoryExists = function(Ae) {
                return Re.call(Z.compilerHost, Ae) ? (de(Ae), true) : Z.getResolvedProjectReferences() ? (Be || (Be = new e.Set(), Z.forEachResolvedProjectReference(function(er) {
                  var ir = e.outFile(er.commandLine.options);
                  if (ir) Be.add(e.getDirectoryPath(Z.toPath(ir)));
                  else {
                    var Cr = er.commandLine.options.declarationDir || er.commandLine.options.outDir;
                    Cr && Be.add(Z.toPath(Cr));
                  }
                })), ye(Ae, false)) : false;
              }), ze && (Z.compilerHost.getDirectories = function(Ae) {
                return !Z.getResolvedProjectReferences() || Re && Re.call(Z.compilerHost, Ae) ? ze.call(Z.compilerHost, Ae) : [];
              }), Ee && (Z.compilerHost.realpath = function(Ae) {
                var er;
                return ((er = Z.getSymlinkCache().getSymlinkedFiles()) === null || er === void 0 ? void 0 : er.get(Z.toPath(Ae))) || Ee.call(Z.compilerHost, Ae);
              }), { onProgramCreateComplete: rr, fileExists: Ie, directoryExists: He };
              function rr() {
                Z.compilerHost.fileExists = ge, Z.compilerHost.directoryExists = Re, Z.compilerHost.getDirectories = ze;
              }
              function Ie(Ae) {
                return ge.call(Z.compilerHost, Ae) ? true : !Z.getResolvedProjectReferences() || !e.isDeclarationFileName(Ae) ? false : ye(Ae, true);
              }
              function _e(Ae) {
                var er = Z.getSourceOfProjectReferenceRedirect(Z.toPath(Ae));
                return er !== void 0 ? e.isString(er) ? ge.call(Z.compilerHost, er) : true : void 0;
              }
              function we(Ae) {
                var er = Z.toPath(Ae), ir = "".concat(er).concat(e.directorySeparator);
                return e.forEachKey(Be, function(Cr) {
                  return er === Cr || e.startsWith(Cr, ir) || e.startsWith(er, "".concat(Cr, "/"));
                });
              }
              function de(Ae) {
                var er;
                if (!(!Z.getResolvedProjectReferences() || e.containsIgnoredPath(Ae)) && !(!Ee || !e.stringContains(Ae, e.nodeModulesPathPart))) {
                  var ir = Z.getSymlinkCache(), Cr = e.ensureTrailingDirectorySeparator(Z.toPath(Ae));
                  if (!(!((er = ir.getSymlinkedDirectories()) === null || er === void 0) && er.has(Cr))) {
                    var Ye = e.normalizePath(Ee.call(Z.compilerHost, Ae)), Br;
                    if (Ye === Ae || (Br = e.ensureTrailingDirectorySeparator(Z.toPath(Ye))) === Cr) {
                      ir.setSymlinkedDirectory(Cr, false);
                      return;
                    }
                    ir.setSymlinkedDirectory(Ae, { real: e.ensureTrailingDirectorySeparator(Ye), realPath: Br });
                  }
                }
              }
              function ye(Ae, er) {
                var ir, Cr = er ? function(n) {
                  return _e(n);
                } : function(n) {
                  return we(n);
                }, Ye = Cr(Ae);
                if (Ye !== void 0) return Ye;
                var Br = Z.getSymlinkCache(), Er = Br.getSymlinkedDirectories();
                if (!Er) return false;
                var Ne = Z.toPath(Ae);
                return e.stringContains(Ne, e.nodeModulesPathPart) ? er && ((ir = Br.getSymlinkedFiles()) === null || ir === void 0 ? void 0 : ir.has(Ne)) ? true : e.firstDefinedIterator(Er.entries(), function(n) {
                  var lr = n[0], be = n[1];
                  if (!(!be || !e.startsWith(Ne, lr))) {
                    var Ge = Cr(Ne.replace(lr, be.realPath));
                    if (er && Ge) {
                      var ur = e.getNormalizedAbsolutePath(Ae, Z.compilerHost.getCurrentDirectory());
                      Br.setSymlinkedFile(Ne, "".concat(be.real).concat(ur.replace(new RegExp(lr, "i"), "")));
                    }
                    return Ge;
                  }
                }) || false : false;
              }
            }
            e.emitSkippedWithNoDiagnostics = { diagnostics: e.emptyArray, sourceMaps: void 0, emittedFiles: void 0, emitSkipped: true };
            function d(Z, Be, ge, Re) {
              var ze = Z.getCompilerOptions();
              if (ze.noEmit) return Z.getSemanticDiagnostics(Be, Re), Be || e.outFile(ze) ? e.emitSkippedWithNoDiagnostics : Z.emitBuildInfo(ge, Re);
              if (!!ze.noEmitOnError) {
                var Ee = Ve(Ve(Ve(Ve([], Z.getOptionsDiagnostics(Re), true), Z.getSyntacticDiagnostics(Be, Re), true), Z.getGlobalDiagnostics(Re), true), Z.getSemanticDiagnostics(Be, Re), true);
                if (Ee.length === 0 && e.getEmitDeclarations(Z.getCompilerOptions()) && (Ee = Z.getDeclarationDiagnostics(void 0, Re)), !!Ee.length) {
                  var He;
                  if (!Be && !e.outFile(ze)) {
                    var rr = Z.emitBuildInfo(ge, Re);
                    rr.diagnostics && (Ee = Ve(Ve([], Ee, true), rr.diagnostics, true)), He = rr.emittedFiles;
                  }
                  return { diagnostics: Ee, sourceMaps: void 0, emittedFiles: He, emitSkipped: true };
                }
              }
            }
            e.handleNoEmitOptions = d;
            function D(Z, Be) {
              return e.filter(Z, function(ge) {
                return !ge.skippedOn || !Be[ge.skippedOn];
              });
            }
            e.filterSemanticDiagnostics = D;
            function fe(Z, Be) {
              return Be === void 0 && (Be = Z), { fileExists: function(ge) {
                return Be.fileExists(ge);
              }, readDirectory: function(ge, Re, ze, Ee, He) {
                return e.Debug.assertIsDefined(Be.readDirectory, "'CompilerHost.readDirectory' must be implemented to correctly process 'projectReferences'"), Be.readDirectory(ge, Re, ze, Ee, He);
              }, readFile: function(ge) {
                return Be.readFile(ge);
              }, useCaseSensitiveFileNames: Z.useCaseSensitiveFileNames(), getCurrentDirectory: function() {
                return Z.getCurrentDirectory();
              }, onUnRecoverableConfigFileDiagnostic: Z.onUnRecoverableConfigFileDiagnostic || e.returnUndefined, trace: Z.trace ? function(ge) {
                return Z.trace(ge);
              } : void 0 };
            }
            e.parseConfigHostFromCompilerHostLike = fe;
            function g(Z, Be, ge) {
              if (!Z) return e.emptyArray;
              for (var Re, ze = 0; ze < Z.length; ze++) {
                var Ee = Z[ze], He = Be(Ee, ze);
                if (Ee.prepend && He && He.options) {
                  var rr = e.outFile(He.options);
                  if (!rr) continue;
                  var Ie = e.getOutputPathsForBundle(He.options, true), _e = Ie.jsFilePath, we = Ie.sourceMapFilePath, de = Ie.declarationFilePath, ye = Ie.declarationMapPath, Ae = Ie.buildInfoPath, er = e.createInputFiles(ge, _e, we, de, ye, Ae);
                  (Re || (Re = [])).push(er);
                }
              }
              return Re || e.emptyArray;
            }
            e.createPrependNodes = g;
            function ne(Z, Be) {
              var ge = Be || Z;
              return e.resolveConfigFileProjectName(ge.path);
            }
            e.resolveProjectReferencePath = ne;
            function ue(Z, Be) {
              var ge = Be.extension;
              switch (ge) {
                case ".ts":
                case ".d.ts":
                  return;
                case ".tsx":
                  return Re();
                case ".jsx":
                  return Re() || ze();
                case ".js":
                  return ze();
                case ".json":
                  return Ee();
              }
              function Re() {
                return Z.jsx ? void 0 : e.Diagnostics.Module_0_was_resolved_to_1_but_jsx_is_not_set;
              }
              function ze() {
                return e.getAllowJSCompilerOption(Z) || !e.getStrictOptionValue(Z, "noImplicitAny") ? void 0 : e.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type;
              }
              function Ee() {
                return Z.resolveJsonModule ? void 0 : e.Diagnostics.Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used;
              }
            }
            e.getResolutionDiagnostic = ue;
            function We(Z) {
              for (var Be = Z.imports, ge = Z.moduleAugmentations, Re = Be.map(function(rr) {
                return rr.text;
              }), ze = 0, Ee = ge; ze < Ee.length; ze++) {
                var He = Ee[ze];
                He.kind === 10 && Re.push(He.text);
              }
              return Re;
            }
            function Fe(Z, Be) {
              var ge = Z.imports, Re = Z.moduleAugmentations;
              if (Be < ge.length) return ge[Be];
              for (var ze = ge.length, Ee = 0, He = Re; Ee < He.length; Ee++) {
                var rr = He[Ee];
                if (rr.kind === 10) {
                  if (Be === ze) return rr;
                  ze++;
                }
              }
              e.Debug.fail("should never ask for module name at index higher than possible module name");
            }
            e.getModuleNameStringLiteralAt = Fe;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(w, B, E, Q, le, N) {
              var p = [], m = w.emit(B, T, Q, E, le, N), G = m.emitSkipped, oe = m.diagnostics, f = m.exportedModulesFromDeclarationEmit;
              return { outputFiles: p, emitSkipped: G, diagnostics: oe, exportedModulesFromDeclarationEmit: f };
              function T(K, b, se) {
                p.push({ name: K, writeByteOrderMark: se, text: b });
              }
            }
            e.getFileEmitOutput = a;
            var C;
            (function(w) {
              function B() {
                function A(y, V, L) {
                  var P = { clone: function() {
                    return A(new e.Map(y), new e.Map(V), L && new e.Set(L));
                  }, forEach: function(k) {
                    return y.forEach(k);
                  }, getKeys: function(k) {
                    return V.get(k);
                  }, getValues: function(k) {
                    return y.get(k);
                  }, hasKey: function(k) {
                    return y.has(k);
                  }, keys: function() {
                    return y.keys();
                  }, deletedKeys: function() {
                    return L;
                  }, deleteKey: function(k) {
                    (L || (L = new e.Set())).add(k);
                    var Y = y.get(k);
                    return Y ? (Y.forEach(function(U) {
                      return Q(V, U, k);
                    }), y.delete(k), true) : false;
                  }, set: function(k, Y) {
                    L == null || L.delete(k);
                    var U = y.get(k);
                    return y.set(k, Y), U == null || U.forEach(function(j) {
                      Y.has(j) || Q(V, j, k);
                    }), Y.forEach(function(j) {
                      U != null && U.has(j) || E(V, j, k);
                    }), P;
                  }, clear: function() {
                    y.clear(), V.clear(), L == null || L.clear();
                  } };
                  return P;
                }
                return A(new e.Map(), new e.Map(), void 0);
              }
              w.createManyToManyPathMap = B;
              function E(A, y, V) {
                var L = A.get(y);
                L || (L = new e.Set(), A.set(y, L)), L.add(V);
              }
              function Q(A, y, V) {
                var L = A.get(y);
                return L != null && L.delete(V) ? (L.size || A.delete(y), true) : false;
              }
              function le(A) {
                return e.mapDefined(A.declarations, function(y) {
                  var V;
                  return (V = e.getSourceFileOfNode(y)) === null || V === void 0 ? void 0 : V.resolvedPath;
                });
              }
              function N(A, y) {
                var V = A.getSymbolAtLocation(y);
                return V && le(V);
              }
              function p(A, y, V, L) {
                return e.toPath(A.getProjectReferenceRedirect(y) || y, V, L);
              }
              function m(A, y, V) {
                var L;
                if (y.imports && y.imports.length > 0) for (var P = A.getTypeChecker(), k = 0, Y = y.imports; k < Y.length; k++) {
                  var U = Y[k], j = N(P, U);
                  j == null || j.forEach(ge);
                }
                var H = e.getDirectoryPath(y.resolvedPath);
                if (y.referencedFiles && y.referencedFiles.length > 0) for (var I = 0, l = y.referencedFiles; I < l.length; I++) {
                  var d = l[I], D = p(A, d.fileName, H, V);
                  ge(D);
                }
                if (y.resolvedTypeReferenceDirectiveNames && y.resolvedTypeReferenceDirectiveNames.forEach(function(Re) {
                  if (!!Re) {
                    var ze = Re.resolvedFileName, Ee = p(A, ze, H, V);
                    ge(Ee);
                  }
                }), y.moduleAugmentations.length) for (var P = A.getTypeChecker(), fe = 0, g = y.moduleAugmentations; fe < g.length; fe++) {
                  var ne = g[fe];
                  if (!!e.isStringLiteral(ne)) {
                    var ue = P.getSymbolAtLocation(ne);
                    !ue || Be(ue);
                  }
                }
                for (var We = 0, Fe = A.getTypeChecker().getAmbientModules(); We < Fe.length; We++) {
                  var Z = Fe[We];
                  Z.declarations && Z.declarations.length > 1 && Be(Z);
                }
                return L;
                function Be(Re) {
                  if (!!Re.declarations) for (var ze = 0, Ee = Re.declarations; ze < Ee.length; ze++) {
                    var He = Ee[ze], rr = e.getSourceFileOfNode(He);
                    rr && rr !== y && ge(rr.resolvedPath);
                  }
                }
                function ge(Re) {
                  (L || (L = new e.Set())).add(Re);
                }
              }
              function G(A, y) {
                return y && !y.referencedMap == !A;
              }
              w.canReuseOldState = G;
              function oe(A, y, V, L) {
                var P = new e.Map(), k = A.getCompilerOptions().module !== e.ModuleKind.None ? B() : void 0, Y = k ? B() : void 0, U = new e.Set(), j = G(k, V);
                A.getTypeChecker();
                for (var H = 0, I = A.getSourceFiles(); H < I.length; H++) {
                  var l = I[H], d = e.Debug.checkDefined(l.version, "Program intended to be used with Builder should have source files with versions set"), D = j ? V.fileInfos.get(l.resolvedPath) : void 0;
                  if (k) {
                    var fe = m(A, l, y);
                    if (fe && k.set(l.resolvedPath, fe), j) {
                      var g = V.exportedModulesMap.getValues(l.resolvedPath);
                      g && Y.set(l.resolvedPath, g);
                    }
                  }
                  P.set(l.resolvedPath, { version: d, signature: D && D.signature, affectsGlobalScope: F(l) || void 0, impliedFormat: l.impliedNodeFormat });
                }
                return { fileInfos: P, referencedMap: k, exportedModulesMap: Y, hasCalledUpdateShapeSignature: U, useFileVersionAsSignature: !L && !j };
              }
              w.create = oe;
              function f(A) {
                A.allFilesExcludingDefaultLibraryFile = void 0, A.allFileNames = void 0;
              }
              w.releaseCache = f;
              function T(A) {
                var y, V;
                return { fileInfos: new e.Map(A.fileInfos), referencedMap: (y = A.referencedMap) === null || y === void 0 ? void 0 : y.clone(), exportedModulesMap: (V = A.exportedModulesMap) === null || V === void 0 ? void 0 : V.clone(), hasCalledUpdateShapeSignature: new e.Set(A.hasCalledUpdateShapeSignature), useFileVersionAsSignature: A.useFileVersionAsSignature };
              }
              w.clone = T;
              function K(A, y, V, L, P, k, Y) {
                var U = k || new e.Map(), j = y.getSourceFileByPath(V);
                if (!j) return e.emptyArray;
                if (!J(A, y, j, U, L, P, Y)) return [j];
                var H = (A.referencedMap ? $ : X)(A, y, j, U, L, P, Y);
                return k || b(A, U), H;
              }
              w.getFilesAffectedBy = K;
              function b(A, y) {
                y.forEach(function(V, L) {
                  return se(A, V, L);
                });
              }
              w.updateSignaturesFromCache = b;
              function se(A, y, V) {
                A.fileInfos.get(V).signature = y, A.hasCalledUpdateShapeSignature.add(V);
              }
              w.updateSignatureOfFile = se;
              function J(A, y, V, L, P, k, Y, U) {
                if (U === void 0 && (U = A.useFileVersionAsSignature), e.Debug.assert(!!V), e.Debug.assert(!Y || !!A.exportedModulesMap, "Compute visible to outside map only if visibleToOutsideReferencedMap present in the state"), A.hasCalledUpdateShapeSignature.has(V.resolvedPath) || L.has(V.resolvedPath)) return false;
                var j = A.fileInfos.get(V.resolvedPath);
                if (!j) return e.Debug.fail();
                var H = j.signature, I;
                if (!V.isDeclarationFile && !U) {
                  var l = a(y, V, true, P, void 0, true), d = e.firstOrUndefined(l.outputFiles);
                  d && (e.Debug.assert(e.isDeclarationFileName(d.name), "File extension for signature expected to be dts", function() {
                    return "Found: ".concat(e.getAnyExtensionFromPath(d.name), " for ").concat(d.name, ":: All output files: ").concat(JSON.stringify(l.outputFiles.map(function(fe) {
                      return fe.name;
                    })));
                  }), I = (k || e.generateDjb2Hash)(d.text), Y && I !== H && ie(V, l.exportedModulesFromDeclarationEmit, Y));
                }
                if (I === void 0 && (I = V.version, Y && I !== H)) {
                  var D = A.referencedMap ? A.referencedMap.getValues(V.resolvedPath) : void 0;
                  D ? Y.set(V.resolvedPath, D) : Y.deleteKey(V.resolvedPath);
                }
                return L.set(V.resolvedPath, I), I !== H;
              }
              w.updateShapeSignature = J;
              function ie(A, y, V) {
                if (!y) {
                  V.deleteKey(A.resolvedPath);
                  return;
                }
                var L;
                y.forEach(function(k) {
                  return P(le(k));
                }), L ? V.set(A.resolvedPath, L) : V.deleteKey(A.resolvedPath);
                function P(k) {
                  k != null && k.length && (L || (L = new e.Set()), k.forEach(function(Y) {
                    return L.add(Y);
                  }));
                }
              }
              w.updateExportedModules = ie;
              function R(A, y) {
                var V;
                y && (e.Debug.assert(!!A.exportedModulesMap), (V = y.deletedKeys()) === null || V === void 0 || V.forEach(function(L) {
                  return A.exportedModulesMap.deleteKey(L);
                }), y.forEach(function(L, P) {
                  return A.exportedModulesMap.set(P, L);
                }));
              }
              w.updateExportedFilesMapFromCache = R;
              function q(A, y, V) {
                var L = y.getCompilerOptions();
                if (e.outFile(L) || !A.referencedMap || F(V)) return O(A, y);
                for (var P = new e.Set(), k = [V.resolvedPath]; k.length; ) {
                  var Y = k.pop();
                  if (!P.has(Y)) {
                    P.add(Y);
                    var U = A.referencedMap.getValues(Y);
                    if (U) for (var j = U.keys(), H = j.next(); !H.done; H = j.next()) k.push(H.value);
                  }
                }
                return e.arrayFrom(e.mapDefinedIterator(P.keys(), function(I) {
                  var l, d;
                  return (d = (l = y.getSourceFileByPath(I)) === null || l === void 0 ? void 0 : l.fileName) !== null && d !== void 0 ? d : I;
                }));
              }
              w.getAllDependencies = q;
              function O(A, y) {
                if (!A.allFileNames) {
                  var V = y.getSourceFiles();
                  A.allFileNames = V === e.emptyArray ? e.emptyArray : V.map(function(L) {
                    return L.fileName;
                  });
                }
                return A.allFileNames;
              }
              function ve(A, y) {
                var V = A.referencedMap.getKeys(y);
                return V ? e.arrayFrom(V.keys()) : [];
              }
              w.getReferencedByPaths = ve;
              function ee(A) {
                for (var y = 0, V = A.statements; y < V.length; y++) {
                  var L = V[y];
                  if (!e.isModuleWithStringLiteralName(L)) return false;
                }
                return true;
              }
              function he(A) {
                return e.some(A.moduleAugmentations, function(y) {
                  return e.isGlobalScopeAugmentation(y.parent);
                });
              }
              function F(A) {
                return he(A) || !e.isExternalOrCommonJsModule(A) && !e.isJsonSourceFile(A) && !ee(A);
              }
              function x(A, y, V) {
                if (A.allFilesExcludingDefaultLibraryFile) return A.allFilesExcludingDefaultLibraryFile;
                var L;
                V && U(V);
                for (var P = 0, k = y.getSourceFiles(); P < k.length; P++) {
                  var Y = k[P];
                  Y !== V && U(Y);
                }
                return A.allFilesExcludingDefaultLibraryFile = L || e.emptyArray, A.allFilesExcludingDefaultLibraryFile;
                function U(j) {
                  y.isSourceFileDefaultLibrary(j) || (L || (L = [])).push(j);
                }
              }
              w.getAllFilesExcludingDefaultLibraryFile = x;
              function X(A, y, V) {
                var L = y.getCompilerOptions();
                return L && e.outFile(L) ? [V] : x(A, y, V);
              }
              function $(A, y, V, L, P, k, Y) {
                if (F(V)) return x(A, y, V);
                var U = y.getCompilerOptions();
                if (U && (U.isolatedModules || e.outFile(U))) return [V];
                var j = new e.Map();
                j.set(V.resolvedPath, V);
                for (var H = ve(A, V.resolvedPath); H.length > 0; ) {
                  var I = H.pop();
                  if (!j.has(I)) {
                    var l = y.getSourceFileByPath(I);
                    j.set(I, l), l && J(A, y, l, L, P, k, Y) && H.push.apply(H, ve(A, l.resolvedPath));
                  }
                }
                return e.arrayFrom(e.mapDefinedIterator(j.values(), function(d) {
                  return d;
                }));
              }
            })(C = e.BuilderState || (e.BuilderState = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(j) {
              j[j.DtsOnly = 0] = "DtsOnly", j[j.Full = 1] = "Full";
            })(a = e.BuilderFileEmit || (e.BuilderFileEmit = {}));
            function C(j, H) {
              return j === H || j !== void 0 && H !== void 0 && j.size === H.size && !e.forEachKey(j, function(I) {
                return !H.has(I);
              });
            }
            function w(j, H, I, l) {
              var d = e.BuilderState.create(j, H, I, l);
              d.program = j;
              var D = j.getCompilerOptions();
              d.compilerOptions = D, e.outFile(D) || (d.semanticDiagnosticsPerFile = new e.Map()), d.changedFilesSet = new e.Set();
              var fe = e.BuilderState.canReuseOldState(d.referencedMap, I), g = fe ? I.compilerOptions : void 0, ne = fe && I.semanticDiagnosticsPerFile && !!d.semanticDiagnosticsPerFile && !e.compilerOptionsAffectSemanticDiagnostics(D, g);
              if (fe) {
                if (!I.currentChangedFilePath) {
                  var ue = I.currentAffectedFilesSignatures;
                  e.Debug.assert(!I.affectedFiles && (!ue || !ue.size), "Cannot reuse if only few affected files of currentChangedFile were iterated");
                }
                var We = I.changedFilesSet;
                ne && e.Debug.assert(!We || !e.forEachKey(We, function(Re) {
                  return I.semanticDiagnosticsPerFile.has(Re);
                }), "Semantic diagnostics shouldnt be available for changed files"), We == null || We.forEach(function(Re) {
                  return d.changedFilesSet.add(Re);
                }), !e.outFile(D) && I.affectedFilesPendingEmit && (d.affectedFilesPendingEmit = I.affectedFilesPendingEmit.slice(), d.affectedFilesPendingEmitKind = I.affectedFilesPendingEmitKind && new e.Map(I.affectedFilesPendingEmitKind), d.affectedFilesPendingEmitIndex = I.affectedFilesPendingEmitIndex, d.seenAffectedFiles = new e.Set());
              }
              var Fe = d.referencedMap, Z = fe ? I.referencedMap : void 0, Be = ne && !D.skipLibCheck == !g.skipLibCheck, ge = Be && !D.skipDefaultLibCheck == !g.skipDefaultLibCheck;
              return d.fileInfos.forEach(function(Re, ze) {
                var Ee, He;
                if (!fe || !(Ee = I.fileInfos.get(ze)) || Ee.version !== Re.version || !C(He = Fe && Fe.getValues(ze), Z && Z.getValues(ze)) || He && e.forEachKey(He, function(_e) {
                  return !d.fileInfos.has(_e) && I.fileInfos.has(_e);
                })) d.changedFilesSet.add(ze);
                else if (ne) {
                  var rr = j.getSourceFileByPath(ze);
                  if (rr.isDeclarationFile && !Be || rr.hasNoDefaultLib && !ge) return;
                  var Ie = I.semanticDiagnosticsPerFile.get(ze);
                  Ie && (d.semanticDiagnosticsPerFile.set(ze, I.hasReusableDiagnostic ? B(Ie, j, H) : Ie), d.semanticDiagnosticsFromOldState || (d.semanticDiagnosticsFromOldState = new e.Set()), d.semanticDiagnosticsFromOldState.add(ze));
                }
              }), fe && e.forEachEntry(I.fileInfos, function(Re, ze) {
                return Re.affectsGlobalScope && !d.fileInfos.has(ze);
              }) ? e.BuilderState.getAllFilesExcludingDefaultLibraryFile(d, j, void 0).forEach(function(Re) {
                return d.changedFilesSet.add(Re.resolvedPath);
              }) : g && !e.outFile(D) && e.compilerOptionsAffectEmit(D, g) && (j.getSourceFiles().forEach(function(Re) {
                return P(d, Re.resolvedPath, 1);
              }), e.Debug.assert(!d.seenAffectedFiles || !d.seenAffectedFiles.size), d.seenAffectedFiles = d.seenAffectedFiles || new e.Set()), fe && e.forEachEntry(I.fileInfos, function(Re, ze) {
                d.fileInfos.has(ze) && d.fileInfos.get(ze).impliedFormat !== Re.impliedFormat && d.changedFilesSet.add(ze);
              }), d.buildInfoEmitPending = !!d.changedFilesSet.size, d;
            }
            function B(j, H, I) {
              if (!j.length) return e.emptyArray;
              var l = e.getDirectoryPath(e.getNormalizedAbsolutePath(e.getTsBuildInfoEmitOutputFilePath(H.getCompilerOptions()), H.getCurrentDirectory()));
              return j.map(function(D) {
                var fe = E(D, H, d);
                fe.reportsUnnecessary = D.reportsUnnecessary, fe.reportsDeprecated = D.reportDeprecated, fe.source = D.source, fe.skippedOn = D.skippedOn;
                var g = D.relatedInformation;
                return fe.relatedInformation = g ? g.length ? g.map(function(ne) {
                  return E(ne, H, d);
                }) : [] : void 0, fe;
              });
              function d(D) {
                return e.toPath(D, l, I);
              }
            }
            function E(j, H, I) {
              var l = j.file;
              return Ke(Ke({}, j), { file: l ? H.getSourceFileByPath(I(l)) : void 0 });
            }
            function Q(j) {
              e.BuilderState.releaseCache(j), j.program = void 0;
            }
            function le(j) {
              var H, I = e.BuilderState.clone(j);
              return I.semanticDiagnosticsPerFile = j.semanticDiagnosticsPerFile && new e.Map(j.semanticDiagnosticsPerFile), I.changedFilesSet = new e.Set(j.changedFilesSet), I.affectedFiles = j.affectedFiles, I.affectedFilesIndex = j.affectedFilesIndex, I.currentChangedFilePath = j.currentChangedFilePath, I.currentAffectedFilesSignatures = j.currentAffectedFilesSignatures && new e.Map(j.currentAffectedFilesSignatures), I.currentAffectedFilesExportedModulesMap = (H = j.currentAffectedFilesExportedModulesMap) === null || H === void 0 ? void 0 : H.clone(), I.seenAffectedFiles = j.seenAffectedFiles && new e.Set(j.seenAffectedFiles), I.cleanedDiagnosticsOfLibFiles = j.cleanedDiagnosticsOfLibFiles, I.semanticDiagnosticsFromOldState = j.semanticDiagnosticsFromOldState && new e.Set(j.semanticDiagnosticsFromOldState), I.program = j.program, I.compilerOptions = j.compilerOptions, I.affectedFilesPendingEmit = j.affectedFilesPendingEmit && j.affectedFilesPendingEmit.slice(), I.affectedFilesPendingEmitKind = j.affectedFilesPendingEmitKind && new e.Map(j.affectedFilesPendingEmitKind), I.affectedFilesPendingEmitIndex = j.affectedFilesPendingEmitIndex, I.seenEmittedFiles = j.seenEmittedFiles && new e.Map(j.seenEmittedFiles), I.programEmitComplete = j.programEmitComplete, I;
            }
            function N(j, H) {
              e.Debug.assert(!H || !j.affectedFiles || j.affectedFiles[j.affectedFilesIndex - 1] !== H || !j.semanticDiagnosticsPerFile.has(H.resolvedPath));
            }
            function p(j, H, I, l) {
              for (var d; ; ) {
                var D = j.affectedFiles;
                if (D) {
                  for (var fe = j.seenAffectedFiles, g = j.affectedFilesIndex; g < D.length; ) {
                    var ne = D[g];
                    if (!fe.has(ne.resolvedPath)) return j.affectedFilesIndex = g, f(j, ne, H, I, l), ne;
                    g++;
                  }
                  j.changedFilesSet.delete(j.currentChangedFilePath), j.currentChangedFilePath = void 0, e.BuilderState.updateSignaturesFromCache(j, j.currentAffectedFilesSignatures), j.currentAffectedFilesSignatures.clear(), e.BuilderState.updateExportedFilesMapFromCache(j, j.currentAffectedFilesExportedModulesMap), (d = j.currentAffectedFilesExportedModulesMap) === null || d === void 0 || d.clear(), j.affectedFiles = void 0;
                }
                var ue = j.changedFilesSet.keys().next();
                if (ue.done) return;
                var We = e.Debug.checkDefined(j.program), Fe = We.getCompilerOptions();
                if (e.outFile(Fe)) return e.Debug.assert(!j.semanticDiagnosticsPerFile), We;
                j.currentAffectedFilesSignatures || (j.currentAffectedFilesSignatures = new e.Map()), j.exportedModulesMap && (j.currentAffectedFilesExportedModulesMap || (j.currentAffectedFilesExportedModulesMap = e.BuilderState.createManyToManyPathMap())), j.affectedFiles = e.BuilderState.getFilesAffectedBy(j, We, ue.value, H, I, j.currentAffectedFilesSignatures, j.currentAffectedFilesExportedModulesMap), j.currentChangedFilePath = ue.value, j.affectedFilesIndex = 0, j.seenAffectedFiles || (j.seenAffectedFiles = new e.Set());
              }
            }
            function m(j) {
              j.affectedFilesPendingEmit = void 0, j.affectedFilesPendingEmitKind = void 0, j.affectedFilesPendingEmitIndex = void 0;
            }
            function G(j) {
              var H = j.affectedFilesPendingEmit;
              if (H) {
                for (var I = j.seenEmittedFiles || (j.seenEmittedFiles = new e.Map()), l = j.affectedFilesPendingEmitIndex; l < H.length; l++) {
                  var d = e.Debug.checkDefined(j.program).getSourceFileByPath(H[l]);
                  if (d) {
                    var D = I.get(d.resolvedPath), fe = e.Debug.checkDefined(e.Debug.checkDefined(j.affectedFilesPendingEmitKind).get(d.resolvedPath));
                    if (D === void 0 || D < fe) return j.affectedFilesPendingEmitIndex = l, { affectedFile: d, emitKind: fe };
                  }
                }
                m(j);
              }
            }
            function oe(j) {
              if (!j.cleanedDiagnosticsOfLibFiles) {
                j.cleanedDiagnosticsOfLibFiles = true;
                var H = e.Debug.checkDefined(j.program), I = H.getCompilerOptions();
                e.forEach(H.getSourceFiles(), function(l) {
                  return H.isSourceFileDefaultLibrary(l) && !e.skipTypeChecking(l, I, H) && K(j, l.resolvedPath);
                });
              }
            }
            function f(j, H, I, l, d) {
              var D;
              if (K(j, H.resolvedPath), j.allFilesExcludingDefaultLibraryFile === j.affectedFiles) {
                oe(j), e.BuilderState.updateShapeSignature(j, e.Debug.checkDefined(j.program), H, e.Debug.checkDefined(j.currentAffectedFilesSignatures), I, l, j.currentAffectedFilesExportedModulesMap);
                return;
              }
              e.Debug.assert(j.hasCalledUpdateShapeSignature.has(H.resolvedPath) || ((D = j.currentAffectedFilesSignatures) === null || D === void 0 ? void 0 : D.has(H.resolvedPath)), "Signature not updated for affected file: ".concat(H.fileName)), !j.compilerOptions.assumeChangesOnlyAffectDirectDependencies && ie(j, H, I, l, d);
            }
            function T(j, H, I, l, d) {
              if (K(j, H), !j.changedFilesSet.has(H)) {
                var D = e.Debug.checkDefined(j.program), fe = D.getSourceFileByPath(H);
                fe && (e.BuilderState.updateShapeSignature(j, D, fe, e.Debug.checkDefined(j.currentAffectedFilesSignatures), I, l, j.currentAffectedFilesExportedModulesMap, !d.disableUseFileVersionAsSignature), e.getEmitDeclarations(j.compilerOptions) && P(j, H, 0));
              }
            }
            function K(j, H) {
              return j.semanticDiagnosticsFromOldState ? (j.semanticDiagnosticsFromOldState.delete(H), j.semanticDiagnosticsPerFile.delete(H), !j.semanticDiagnosticsFromOldState.size) : true;
            }
            function b(j, H) {
              var I = e.Debug.checkDefined(j.currentAffectedFilesSignatures).get(H), l = e.Debug.checkDefined(j.fileInfos.get(H)).signature;
              return I !== l;
            }
            function se(j, H, I) {
              var l = j.currentAffectedFilesExportedModulesMap.getKeys(H), d = l && e.forEachKey(l, I);
              return d || (l = j.exportedModulesMap.getKeys(H), l && e.forEachKey(l, function(D) {
                var fe;
                return !j.currentAffectedFilesExportedModulesMap.hasKey(D) && !(!((fe = j.currentAffectedFilesExportedModulesMap.deletedKeys()) === null || fe === void 0) && fe.has(D)) ? I(D) : void 0;
              }));
            }
            function J(j, H, I, l, d) {
              var D;
              return !((D = j.fileInfos.get(H)) === null || D === void 0) && D.affectsGlobalScope ? (e.BuilderState.getAllFilesExcludingDefaultLibraryFile(j, j.program, void 0).forEach(function(fe) {
                return T(j, fe.resolvedPath, I, l, d);
              }), oe(j), true) : false;
            }
            function ie(j, H, I, l, d) {
              if (!(!j.exportedModulesMap || !j.changedFilesSet.has(H.resolvedPath)) && !!b(j, H.resolvedPath)) {
                if (j.compilerOptions.isolatedModules) {
                  var D = new e.Map();
                  D.set(H.resolvedPath, true);
                  for (var fe = e.BuilderState.getReferencedByPaths(j, H.resolvedPath); fe.length > 0; ) {
                    var g = fe.pop();
                    if (!D.has(g)) {
                      if (D.set(g, true), J(j, g, I, l, d)) return;
                      if (T(j, g, I, l, d), b(j, g)) {
                        var ne = e.Debug.checkDefined(j.program).getSourceFileByPath(g);
                        fe.push.apply(fe, e.BuilderState.getReferencedByPaths(j, ne.resolvedPath));
                      }
                    }
                  }
                }
                e.Debug.assert(!!j.currentAffectedFilesExportedModulesMap);
                var ue = new e.Set();
                se(j, H.resolvedPath, function(We) {
                  if (J(j, We, I, l, d)) return true;
                  var Fe = j.referencedMap.getKeys(We);
                  return Fe && e.forEachKey(Fe, function(Z) {
                    return R(j, Z, ue, I, l, d);
                  });
                });
              }
            }
            function R(j, H, I, l, d, D) {
              var fe;
              if (!!e.tryAddToSet(I, H)) {
                if (J(j, H, l, d, D)) return true;
                T(j, H, l, d, D), e.Debug.assert(!!j.currentAffectedFilesExportedModulesMap), se(j, H, function(g) {
                  return R(j, g, I, l, d, D);
                }), (fe = j.referencedMap.getKeys(H)) === null || fe === void 0 || fe.forEach(function(g) {
                  return !I.has(g) && T(j, g, l, d, D);
                });
              }
            }
            function q(j, H, I, l, d) {
              d ? j.buildInfoEmitPending = false : H === j.program ? (j.changedFilesSet.clear(), j.programEmitComplete = true) : (j.seenAffectedFiles.add(H.resolvedPath), I !== void 0 && (j.seenEmittedFiles || (j.seenEmittedFiles = new e.Map())).set(H.resolvedPath, I), l ? (j.affectedFilesPendingEmitIndex++, j.buildInfoEmitPending = true) : j.affectedFilesIndex++);
            }
            function O(j, H, I) {
              return q(j, I), { result: H, affected: I };
            }
            function ve(j, H, I, l, d, D) {
              return q(j, I, l, d, D), { result: H, affected: I };
            }
            function ee(j, H, I) {
              return e.concatenate(he(j, H, I), e.Debug.checkDefined(j.program).getProgramDiagnostics(H));
            }
            function he(j, H, I) {
              var l = H.resolvedPath;
              if (j.semanticDiagnosticsPerFile) {
                var d = j.semanticDiagnosticsPerFile.get(l);
                if (d) return e.filterSemanticDiagnostics(d, j.compilerOptions);
              }
              var D = e.Debug.checkDefined(j.program).getBindAndCheckDiagnostics(H, I);
              return j.semanticDiagnosticsPerFile && j.semanticDiagnosticsPerFile.set(l, D), e.filterSemanticDiagnostics(D, j.compilerOptions);
            }
            function F(j, H) {
              if (e.outFile(j.compilerOptions)) return;
              var I = e.Debug.checkDefined(j.program).getCurrentDirectory(), l = e.getDirectoryPath(e.getNormalizedAbsolutePath(e.getTsBuildInfoEmitOutputFilePath(j.compilerOptions), I)), d = [], D = new e.Map(), fe, g, ne = e.arrayFrom(j.fileInfos.entries(), function(Ae) {
                var er = Ae[0], ir = Ae[1], Cr = de(er);
                e.Debug.assert(d[Cr - 1] === we(er));
                var Ye = j.currentAffectedFilesSignatures && j.currentAffectedFilesSignatures.get(er), Br = Ye != null ? Ye : ir.signature;
                return ir.version === Br ? ir.affectsGlobalScope || ir.impliedFormat ? { version: ir.version, signature: void 0, affectsGlobalScope: ir.affectsGlobalScope, impliedFormat: ir.impliedFormat } : ir.version : Br !== void 0 ? Ye === void 0 ? ir : { version: ir.version, signature: Ye, affectsGlobalScope: ir.affectsGlobalScope, impliedFormat: ir.impliedFormat } : { version: ir.version, signature: false, affectsGlobalScope: ir.affectsGlobalScope, impliedFormat: ir.impliedFormat };
              }), ue;
              j.referencedMap && (ue = e.arrayFrom(j.referencedMap.keys()).sort(e.compareStringsCaseSensitive).map(function(Ae) {
                return [de(Ae), ye(j.referencedMap.getValues(Ae))];
              }));
              var We;
              j.exportedModulesMap && (We = e.mapDefined(e.arrayFrom(j.exportedModulesMap.keys()).sort(e.compareStringsCaseSensitive), function(Ae) {
                var er;
                if (j.currentAffectedFilesExportedModulesMap) {
                  if (!((er = j.currentAffectedFilesExportedModulesMap.deletedKeys()) === null || er === void 0) && er.has(Ae)) return;
                  var ir = j.currentAffectedFilesExportedModulesMap.getValues(Ae);
                  if (ir) return [de(Ae), ye(ir)];
                }
                return [de(Ae), ye(j.exportedModulesMap.getValues(Ae))];
              }));
              var Fe;
              if (j.semanticDiagnosticsPerFile) for (var Z = 0, Be = e.arrayFrom(j.semanticDiagnosticsPerFile.keys()).sort(e.compareStringsCaseSensitive); Z < Be.length; Z++) {
                var ge = Be[Z], Re = j.semanticDiagnosticsPerFile.get(ge);
                (Fe || (Fe = [])).push(Re.length ? [de(ge), j.hasReusableDiagnostic ? Re : $(Re, we)] : de(ge));
              }
              var ze;
              if (j.affectedFilesPendingEmit) for (var Ee = new e.Set(), He = 0, rr = j.affectedFilesPendingEmit.slice(j.affectedFilesPendingEmitIndex).sort(e.compareStringsCaseSensitive); He < rr.length; He++) {
                var Ie = rr[He];
                e.tryAddToSet(Ee, Ie) && (ze || (ze = [])).push([de(Ie), j.affectedFilesPendingEmitKind.get(Ie)]);
              }
              return { fileNames: d, fileInfos: ne, options: x(j.compilerOptions, _e), fileIdsList: fe, referencedMap: ue, exportedModulesMap: We, semanticDiagnosticsPerFile: Fe, affectedFilesPendingEmit: ze };
              function _e(Ae) {
                return we(e.getNormalizedAbsolutePath(Ae, I));
              }
              function we(Ae) {
                return e.ensurePathIsNonModuleName(e.getRelativePathFromDirectory(l, Ae, H));
              }
              function de(Ae) {
                var er = D.get(Ae);
                return er === void 0 && (d.push(we(Ae)), D.set(Ae, er = d.length)), er;
              }
              function ye(Ae) {
                var er = e.arrayFrom(Ae.keys(), de).sort(e.compareValues), ir = er.join(), Cr = g == null ? void 0 : g.get(ir);
                return Cr === void 0 && ((fe || (fe = [])).push(er), (g || (g = new e.Map())).set(ir, Cr = fe.length)), Cr;
              }
            }
            function x(j, H) {
              for (var I, l = e.getOptionsNameMap().optionsNameMap, d = 0, D = e.getOwnKeys(j).sort(e.compareStringsCaseSensitive); d < D.length; d++) {
                var fe = D[d], g = fe.toLowerCase(), ne = l.get(g);
                ((ne == null ? void 0 : ne.affectsEmit) || (ne == null ? void 0 : ne.affectsSemanticDiagnostics) || g === "strict" || g === "skiplibcheck" || g === "skipdefaultlibcheck") && ((I || (I = {}))[fe] = X(ne, j[fe], H));
              }
              return I;
            }
            function X(j, H, I) {
              if (j) {
                if (j.type === "list") {
                  var l = H;
                  if (j.element.isFilePath && l.length) return l.map(I);
                } else if (j.isFilePath) return I(H);
              }
              return H;
            }
            function $(j, H) {
              return e.Debug.assert(!!j.length), j.map(function(I) {
                var l = A(I, H);
                l.reportsUnnecessary = I.reportsUnnecessary, l.reportDeprecated = I.reportsDeprecated, l.source = I.source, l.skippedOn = I.skippedOn;
                var d = I.relatedInformation;
                return l.relatedInformation = d ? d.length ? d.map(function(D) {
                  return A(D, H);
                }) : [] : void 0, l;
              });
            }
            function A(j, H) {
              var I = j.file;
              return Ke(Ke({}, j), { file: I ? H(I.resolvedPath) : void 0 });
            }
            var y;
            (function(j) {
              j[j.SemanticDiagnosticsBuilderProgram = 0] = "SemanticDiagnosticsBuilderProgram", j[j.EmitAndSemanticDiagnosticsBuilderProgram = 1] = "EmitAndSemanticDiagnosticsBuilderProgram";
            })(y = e.BuilderProgramKind || (e.BuilderProgramKind = {}));
            function V(j, H, I, l, d, D) {
              var fe, g, ne;
              return j === void 0 ? (e.Debug.assert(H === void 0), fe = I, ne = l, e.Debug.assert(!!ne), g = ne.getProgram()) : e.isArray(j) ? (ne = l, g = e.createProgram({ rootNames: j, options: H, host: I, oldProgram: ne && ne.getProgramOrUndefined(), configFileParsingDiagnostics: d, projectReferences: D }), fe = I) : (g = j, fe = H, ne = I, d = l), { host: fe, newProgram: g, oldProgram: ne, configFileParsingDiagnostics: d || e.emptyArray };
            }
            e.getBuilderCreationParameters = V;
            function L(j, H) {
              var I = H.newProgram, l = H.host, d = H.oldProgram, D = H.configFileParsingDiagnostics, fe = d && d.getState();
              if (fe && I === fe.program && D === I.getConfigFileParsingDiagnostics()) return I = void 0, fe = void 0, d;
              var g = e.createGetCanonicalFileName(l.useCaseSensitiveFileNames()), ne = e.maybeBind(l, l.createHash), ue = w(I, g, fe, l.disableUseFileVersionAsSignature), We;
              I.getProgramBuildInfo = function() {
                return F(ue, g);
              }, I = void 0, d = void 0, fe = void 0;
              var Fe = function() {
                return ue;
              }, Z = U(Fe, D);
              return Z.getState = Fe, Z.backupState = function() {
                e.Debug.assert(We === void 0), We = le(ue);
              }, Z.restoreState = function() {
                ue = e.Debug.checkDefined(We), We = void 0;
              }, Z.getAllDependencies = function(rr) {
                return e.BuilderState.getAllDependencies(ue, e.Debug.checkDefined(ue.program), rr);
              }, Z.getSemanticDiagnostics = He, Z.emit = ze, Z.releaseProgram = function() {
                Q(ue), We = void 0;
              }, j === y.SemanticDiagnosticsBuilderProgram ? Z.getSemanticDiagnosticsOfNextAffectedFile = Ee : j === y.EmitAndSemanticDiagnosticsBuilderProgram ? (Z.getSemanticDiagnosticsOfNextAffectedFile = Ee, Z.emitNextAffectedFile = ge, Z.emitBuildInfo = Be) : e.notImplemented(), Z;
              function Be(rr, Ie) {
                if (ue.buildInfoEmitPending) {
                  var _e = e.Debug.checkDefined(ue.program).emitBuildInfo(rr || e.maybeBind(l, l.writeFile), Ie);
                  return ue.buildInfoEmitPending = false, _e;
                }
                return e.emitSkippedWithNoDiagnostics;
              }
              function ge(rr, Ie, _e, we) {
                var de = p(ue, Ie, ne, l), ye = 1, Ae = false;
                if (!de) if (e.outFile(ue.compilerOptions)) {
                  var Cr = e.Debug.checkDefined(ue.program);
                  if (ue.programEmitComplete) return;
                  de = Cr;
                } else {
                  var er = G(ue);
                  if (!er) {
                    if (!ue.buildInfoEmitPending) return;
                    var ir = e.Debug.checkDefined(ue.program);
                    return ve(ue, ir.emitBuildInfo(rr || e.maybeBind(l, l.writeFile), Ie), ir, 1, false, true);
                  }
                  de = er.affectedFile, ye = er.emitKind, Ae = true;
                }
                return ve(ue, e.Debug.checkDefined(ue.program).emit(de === ue.program ? void 0 : de, de !== ue.program && e.getEmitDeclarations(ue.compilerOptions) && !we ? Re(rr) : rr || e.maybeBind(l, l.writeFile), Ie, _e || ye === 0, we), de, ye, Ae);
              }
              function Re(rr) {
                return function(Ie, _e, we, de, ye, Ae) {
                  var er;
                  if (e.isDeclarationFileName(Ie)) {
                    e.Debug.assert((ye == null ? void 0 : ye.length) === 1);
                    var ir = ye[0], Cr = ue.fileInfos.get(ir.resolvedPath), Ye = ((er = ue.currentAffectedFilesSignatures) === null || er === void 0 ? void 0 : er.get(ir.resolvedPath)) || Cr.signature;
                    if (Ye === ir.version) {
                      var Br = (ne || e.generateDjb2Hash)((Ae == null ? void 0 : Ae.sourceMapUrlPos) !== void 0 ? _e.substring(0, Ae.sourceMapUrlPos) : _e);
                      Br !== ir.version && (l.storeFilesChangingSignatureDuringEmit && (ue.filesChangingSignature || (ue.filesChangingSignature = new e.Set())).add(ir.resolvedPath), ue.exportedModulesMap && e.BuilderState.updateExportedModules(ir, ir.exportedModulesFromDeclarationEmit, ue.currentAffectedFilesExportedModulesMap || (ue.currentAffectedFilesExportedModulesMap = e.BuilderState.createManyToManyPathMap())), ue.affectedFiles && ue.affectedFilesIndex < ue.affectedFiles.length ? ue.currentAffectedFilesSignatures.set(ir.resolvedPath, Br) : (Cr.signature = Br, ue.exportedModulesMap && e.BuilderState.updateExportedFilesMapFromCache(ue, ue.currentAffectedFilesExportedModulesMap)));
                    }
                  }
                  rr ? rr(Ie, _e, we, de, ye, Ae) : l.writeFile ? l.writeFile(Ie, _e, we, de, ye, Ae) : ue.program.writeFile(Ie, _e, we, de, ye, Ae);
                };
              }
              function ze(rr, Ie, _e, we, de) {
                var ye;
                j === y.EmitAndSemanticDiagnosticsBuilderProgram && N(ue, rr);
                var Ae = e.handleNoEmitOptions(Z, rr, Ie, _e);
                if (Ae) return Ae;
                if (!rr) if (j === y.EmitAndSemanticDiagnosticsBuilderProgram) {
                  for (var er = [], ir = false, Cr = void 0, Ye = [], Br = void 0; Br = ge(Ie, _e, we, de); ) ir = ir || Br.result.emitSkipped, Cr = e.addRange(Cr, Br.result.diagnostics), Ye = e.addRange(Ye, Br.result.emittedFiles), er = e.addRange(er, Br.result.sourceMaps);
                  return { emitSkipped: ir, diagnostics: Cr || e.emptyArray, emittedFiles: Ye, sourceMaps: er };
                } else !((ye = ue.affectedFilesPendingEmitKind) === null || ye === void 0) && ye.size && (e.Debug.assert(j === y.SemanticDiagnosticsBuilderProgram), (!we || e.every(ue.affectedFilesPendingEmit, function(Er, Ne) {
                  return Ne < ue.affectedFilesPendingEmitIndex || ue.affectedFilesPendingEmitKind.get(Er) === 0;
                })) && m(ue));
                return e.Debug.checkDefined(ue.program).emit(rr, !e.outFile(ue.compilerOptions) && e.getEmitDeclarations(ue.compilerOptions) && !de ? Re(Ie) : Ie || e.maybeBind(l, l.writeFile), _e, we, de);
              }
              function Ee(rr, Ie) {
                for (; ; ) {
                  var _e = p(ue, rr, ne, l);
                  if (_e) {
                    if (_e === ue.program) return O(ue, ue.program.getSemanticDiagnostics(void 0, rr), _e);
                  } else return;
                  if ((j === y.EmitAndSemanticDiagnosticsBuilderProgram || ue.compilerOptions.noEmit || ue.compilerOptions.noEmitOnError) && P(ue, _e.resolvedPath, 1), Ie && Ie(_e)) {
                    q(ue, _e);
                    continue;
                  }
                  return O(ue, ee(ue, _e, rr), _e);
                }
              }
              function He(rr, Ie) {
                N(ue, rr);
                var _e = e.Debug.checkDefined(ue.program).getCompilerOptions();
                if (e.outFile(_e)) return e.Debug.assert(!ue.semanticDiagnosticsPerFile), e.Debug.checkDefined(ue.program).getSemanticDiagnostics(rr, Ie);
                if (rr) return ee(ue, rr, Ie);
                for (; Ee(Ie); ) ;
                for (var we, de = 0, ye = e.Debug.checkDefined(ue.program).getSourceFiles(); de < ye.length; de++) {
                  var Ae = ye[de];
                  we = e.addRange(we, ee(ue, Ae, Ie));
                }
                return we || e.emptyArray;
              }
            }
            e.createBuilderProgram = L;
            function P(j, H, I) {
              j.affectedFilesPendingEmit || (j.affectedFilesPendingEmit = []), j.affectedFilesPendingEmitKind || (j.affectedFilesPendingEmitKind = new e.Map());
              var l = j.affectedFilesPendingEmitKind.get(H);
              j.affectedFilesPendingEmit.push(H), j.affectedFilesPendingEmitKind.set(H, l || I), j.affectedFilesPendingEmitIndex === void 0 && (j.affectedFilesPendingEmitIndex = 0);
            }
            function k(j) {
              return e.isString(j) ? { version: j, signature: j, affectsGlobalScope: void 0, impliedFormat: void 0 } : e.isString(j.signature) ? j : { version: j.version, signature: j.signature === false ? void 0 : j.version, affectsGlobalScope: j.affectsGlobalScope, impliedFormat: j.impliedFormat };
            }
            e.toBuilderStateFileInfo = k;
            function Y(j, H, I) {
              var l, d = e.getDirectoryPath(e.getNormalizedAbsolutePath(H, I.getCurrentDirectory())), D = e.createGetCanonicalFileName(I.useCaseSensitiveFileNames()), fe = j.fileNames.map(We), g = (l = j.fileIdsList) === null || l === void 0 ? void 0 : l.map(function(Re) {
                return new e.Set(Re.map(Z));
              }), ne = new e.Map();
              j.fileInfos.forEach(function(Re, ze) {
                return ne.set(Z(ze + 1), k(Re));
              });
              var ue = { fileInfos: ne, compilerOptions: j.options ? e.convertToOptionsWithAbsolutePaths(j.options, Fe) : {}, referencedMap: ge(j.referencedMap), exportedModulesMap: ge(j.exportedModulesMap), semanticDiagnosticsPerFile: j.semanticDiagnosticsPerFile && e.arrayToMap(j.semanticDiagnosticsPerFile, function(Re) {
                return Z(e.isNumber(Re) ? Re : Re[0]);
              }, function(Re) {
                return e.isNumber(Re) ? e.emptyArray : Re[1];
              }), hasReusableDiagnostic: true, affectedFilesPendingEmit: e.map(j.affectedFilesPendingEmit, function(Re) {
                return Z(Re[0]);
              }), affectedFilesPendingEmitKind: j.affectedFilesPendingEmit && e.arrayToMap(j.affectedFilesPendingEmit, function(Re) {
                return Z(Re[0]);
              }, function(Re) {
                return Re[1];
              }), affectedFilesPendingEmitIndex: j.affectedFilesPendingEmit && 0 };
              return { getState: function() {
                return ue;
              }, backupState: e.noop, restoreState: e.noop, getProgram: e.notImplemented, getProgramOrUndefined: e.returnUndefined, releaseProgram: e.noop, getCompilerOptions: function() {
                return ue.compilerOptions;
              }, getSourceFile: e.notImplemented, getSourceFiles: e.notImplemented, getOptionsDiagnostics: e.notImplemented, getGlobalDiagnostics: e.notImplemented, getConfigFileParsingDiagnostics: e.notImplemented, getSyntacticDiagnostics: e.notImplemented, getDeclarationDiagnostics: e.notImplemented, getSemanticDiagnostics: e.notImplemented, emit: e.notImplemented, getAllDependencies: e.notImplemented, getCurrentDirectory: e.notImplemented, emitNextAffectedFile: e.notImplemented, getSemanticDiagnosticsOfNextAffectedFile: e.notImplemented, emitBuildInfo: e.notImplemented, close: e.noop };
              function We(Re) {
                return e.toPath(Re, d, D);
              }
              function Fe(Re) {
                return e.getNormalizedAbsolutePath(Re, d);
              }
              function Z(Re) {
                return fe[Re - 1];
              }
              function Be(Re) {
                return g[Re - 1];
              }
              function ge(Re) {
                if (!!Re) {
                  var ze = e.BuilderState.createManyToManyPathMap();
                  return Re.forEach(function(Ee) {
                    var He = Ee[0], rr = Ee[1];
                    return ze.set(Z(He), Be(rr));
                  }), ze;
                }
              }
            }
            e.createBuildProgramUsingProgramBuildInfo = Y;
            function U(j, H) {
              return { getState: e.notImplemented, backupState: e.noop, restoreState: e.noop, getProgram: I, getProgramOrUndefined: function() {
                return j().program;
              }, releaseProgram: function() {
                return j().program = void 0;
              }, getCompilerOptions: function() {
                return j().compilerOptions;
              }, getSourceFile: function(l) {
                return I().getSourceFile(l);
              }, getSourceFiles: function() {
                return I().getSourceFiles();
              }, getOptionsDiagnostics: function(l) {
                return I().getOptionsDiagnostics(l);
              }, getGlobalDiagnostics: function(l) {
                return I().getGlobalDiagnostics(l);
              }, getConfigFileParsingDiagnostics: function() {
                return H;
              }, getSyntacticDiagnostics: function(l, d) {
                return I().getSyntacticDiagnostics(l, d);
              }, getDeclarationDiagnostics: function(l, d) {
                return I().getDeclarationDiagnostics(l, d);
              }, getSemanticDiagnostics: function(l, d) {
                return I().getSemanticDiagnostics(l, d);
              }, emit: function(l, d, D, fe, g) {
                return I().emit(l, d, D, fe, g);
              }, emitBuildInfo: function(l, d) {
                return I().emitBuildInfo(l, d);
              }, getAllDependencies: e.notImplemented, getCurrentDirectory: function() {
                return I().getCurrentDirectory();
              }, close: e.noop };
              function I() {
                return e.Debug.checkDefined(j().program);
              }
            }
            e.createRedirectedBuilderProgram = U;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(B, E, Q, le, N, p) {
              return e.createBuilderProgram(e.BuilderProgramKind.SemanticDiagnosticsBuilderProgram, e.getBuilderCreationParameters(B, E, Q, le, N, p));
            }
            e.createSemanticDiagnosticsBuilderProgram = a;
            function C(B, E, Q, le, N, p) {
              return e.createBuilderProgram(e.BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram, e.getBuilderCreationParameters(B, E, Q, le, N, p));
            }
            e.createEmitAndSemanticDiagnosticsBuilderProgram = C;
            function w(B, E, Q, le, N, p) {
              var m = e.getBuilderCreationParameters(B, E, Q, le, N, p), G = m.newProgram, oe = m.configFileParsingDiagnostics;
              return e.createRedirectedBuilderProgram(function() {
                return { program: G, compilerOptions: G.getCompilerOptions() };
              }, oe);
            }
            e.createAbstractBuilder = w;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(E) {
              return e.endsWith(E, "/node_modules/.staging") ? e.removeSuffix(E, "/.staging") : e.some(e.ignoredPaths, function(Q) {
                return e.stringContains(E, Q);
              }) ? void 0 : E;
            }
            e.removeIgnoredPath = a;
            function C(E) {
              var Q = e.getRootLength(E);
              if (E.length === Q) return false;
              var le = E.indexOf(e.directorySeparator, Q);
              if (le === -1) return false;
              var N = E.substring(Q, le + 1), p = Q > 1 || E.charCodeAt(0) !== 47;
              if (p && E.search(/[a-zA-Z]:/) !== 0 && N.search(/[a-zA-z]\$\//) === 0) {
                if (le = E.indexOf(e.directorySeparator, le + 1), le === -1) return false;
                N = E.substring(Q + N.length, le + 1);
              }
              if (p && N.search(/users\//i) !== 0) return true;
              for (var m = le + 1, G = 2; G > 0; G--) if (m = E.indexOf(e.directorySeparator, m) + 1, m === 0) return false;
              return true;
            }
            e.canWatchDirectory = C;
            function w(E, Q, le) {
              var N, p, m, G = e.createMultiMap(), oe = [], f = e.createMultiMap(), T = false, K, b, se, J = e.memoize(function() {
                return E.getCurrentDirectory();
              }), ie = E.getCachedDirectoryStructureHost(), R = new e.Map(), q = e.createCacheWithRedirects(), O = e.createCacheWithRedirects(), ve = e.createModuleResolutionCache(J(), E.getCanonicalFileName, void 0, q, O), ee = new e.Map(), he = e.createCacheWithRedirects(), F = e.createTypeReferenceDirectiveResolutionCache(J(), E.getCanonicalFileName, void 0, ve.getPackageJsonInfoCache(), he), x = [".ts", ".tsx", ".js", ".jsx", ".json"], X = new e.Map(), $ = new e.Map(), A = Q && e.removeTrailingDirectorySeparator(e.getNormalizedAbsolutePath(Q, J())), y = A && E.toPath(A), V = y !== void 0 ? y.split(e.directorySeparator).length : 0, L = new e.Map();
              return { getModuleResolutionCache: function() {
                return ve;
              }, startRecordingFilesWithChangedResolutions: j, finishRecordingFilesWithChangedResolutions: H, startCachingPerDirectoryResolution: d, finishCachingPerDirectoryResolution: D, resolveModuleNames: We, getResolvedModuleWithFailedLookupLocationsFromCache: Fe, resolveTypeReferenceDirectives: ue, removeResolutionsFromProjectReferenceRedirects: ye, removeResolutionsOfFile: Ae, hasChangedAutomaticTypeDirectiveNames: function() {
                return T;
              }, invalidateResolutionOfFile: ir, invalidateResolutionsOfFailedLookupLocations: Br, setFilesWithInvalidatedNonRelativeUnresolvedImports: Cr, createHasInvalidatedResolution: l, isFileWithInvalidatedNonRelativeUnresolvedImports: I, updateTypeRootsWatch: be, closeTypeRootsWatch: Ne, clear: U };
              function P(ur) {
                return ur.resolvedModule;
              }
              function k(ur) {
                return ur.resolvedTypeReferenceDirective;
              }
              function Y(ur, yr) {
                return ur === void 0 || yr.length <= ur.length ? false : e.startsWith(yr, ur) && yr[ur.length] === e.directorySeparator;
              }
              function U() {
                e.clearMap($, e.closeFileWatcherOf), X.clear(), G.clear(), Ne(), R.clear(), ee.clear(), f.clear(), oe.length = 0, K = void 0, b = void 0, se = void 0, d(), T = false;
              }
              function j() {
                N = [];
              }
              function H() {
                var ur = N;
                return N = void 0, ur;
              }
              function I(ur) {
                if (!m) return false;
                var yr = m.get(ur);
                return !!yr && !!yr.length;
              }
              function l(ur) {
                if (Br(), ur) return p = void 0, e.returnTrue;
                var yr = p;
                return p = void 0, function(Ir) {
                  return !!yr && yr.has(Ir) || I(Ir);
                };
              }
              function d() {
                ve.clear(), F.clear(), G.forEach(He), G.clear();
              }
              function D() {
                m = void 0, d(), $.forEach(function(ur, yr) {
                  ur.refCount === 0 && ($.delete(yr), ur.watcher.close());
                }), T = false;
              }
              function fe(ur, yr, Ir, wr, Ur, ii, mi) {
                var pe, or = e.resolveModuleName(ur, yr, Ir, wr, ve, Ur, mi);
                if (!E.getGlobalCache) return or;
                var qr = E.getGlobalCache();
                if (qr !== void 0 && !e.isExternalModuleNameRelative(ur) && !(or.resolvedModule && e.extensionIsTS(or.resolvedModule.extension))) {
                  var si = e.loadModuleFromGlobalCache(e.Debug.checkDefined(E.globalCacheResolutionModuleName)(ur), E.projectName, Ir, wr, qr, ve), Di = si.resolvedModule, wi = si.failedLookupLocations;
                  if (Di) return or.resolvedModule = Di, (pe = or.failedLookupLocations).push.apply(pe, wi), or;
                }
                return or;
              }
              function g(ur, yr, Ir, wr, Ur, ii, mi) {
                return e.resolveTypeReferenceDirective(ur, yr, Ir, wr, Ur, F, mi);
              }
              function ne(ur) {
                var yr, Ir, wr, Ur = ur.names, ii = ur.containingFile, mi = ur.redirectedReference, pe = ur.cache, or = ur.perDirectoryCacheWithRedirects, qr = ur.loader, si = ur.getResolutionWithResolvedFileName, Di = ur.shouldRetryResolution, wi = ur.reusedNames, Xi = ur.logChanges, et = ur.containingSourceFile, Gi = ur.containingSourceFileMode, Wt = E.toPath(ii), Zt = pe.get(Wt) || pe.set(Wt, e.createModeAwareCache()).get(Wt), _r = e.getDirectoryPath(Wt), pi = or.getOrCreateMapOfCacheRedirects(mi), ae = pi.get(_r);
                ae || (ae = e.createModeAwareCache(), pi.set(_r, ae));
                for (var Xe = [], Jr = E.getCompilationSettings(), ti = Xi && I(Wt), Ze = E.getCurrentProgram(), Sr = Ze && Ze.getResolvedProjectReferenceToRedirect(ii), zr = Sr ? !mi || mi.sourceFile.path !== Sr.sourceFile.path : !!mi, Wr = e.createModeAwareCache(), Je = 0, xe = 0, vr = Ur; xe < vr.length; xe++) {
                  var mr = vr[xe], Ar = e.isString(mr) ? mr : mr.fileName.toLowerCase(), Oe = e.isString(mr) ? et ? e.getModeForResolutionAtIndex(et, Je) : void 0 : e.getModeForFileReference(mr, Gi);
                  Je++;
                  var nr = Zt.get(Ar, Oe);
                  if (!Wr.has(Ar, Oe) && zr || !nr || nr.isInvalidated || ti && !e.isExternalModuleNameRelative(Ar) && Di(nr)) {
                    var Mr = nr, Pe = ae.get(Ar, Oe);
                    if (Pe) {
                      nr = Pe;
                      var Ue = ((yr = E.getCompilerHost) === null || yr === void 0 ? void 0 : yr.call(E)) || E;
                      if (e.isTraceEnabled(Jr, Ue)) {
                        var fr = si(nr);
                        e.trace(Ue, qr === fe ? fr != null && fr.resolvedFileName ? fr.packagetId ? e.Diagnostics.Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4 : e.Diagnostics.Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3 : e.Diagnostics.Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_not_resolved : fr != null && fr.resolvedFileName ? fr.packagetId ? e.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4 : e.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3 : e.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_not_resolved, Ar, ii, e.getDirectoryPath(ii), fr == null ? void 0 : fr.resolvedFileName, (fr == null ? void 0 : fr.packagetId) && e.packageIdToString(fr.packagetId));
                      }
                    } else nr = qr(Ar, ii, Jr, ((Ir = E.getCompilerHost) === null || Ir === void 0 ? void 0 : Ir.call(E)) || E, mi, et, Oe), ae.set(Ar, Oe, nr), E.onDiscoveredSymlink && B(nr) && E.onDiscoveredSymlink();
                    Zt.set(Ar, Oe, nr), ze(Ar, nr, Wt, si), Mr && Ie(Mr, Wt, si), Xi && N && !De(Mr, nr) && (N.push(Wt), Xi = false);
                  } else {
                    var Ue = ((wr = E.getCompilerHost) === null || wr === void 0 ? void 0 : wr.call(E)) || E;
                    if (e.isTraceEnabled(Jr, Ue) && !Wr.has(Ar, Oe)) {
                      var fr = si(nr);
                      e.trace(Ue, qr === fe ? fr != null && fr.resolvedFileName ? fr.packagetId ? e.Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3 : e.Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2 : e.Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved : fr != null && fr.resolvedFileName ? fr.packagetId ? e.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3 : e.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2 : e.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved, Ar, ii, fr == null ? void 0 : fr.resolvedFileName, (fr == null ? void 0 : fr.packagetId) && e.packageIdToString(fr.packagetId));
                    }
                  }
                  e.Debug.assert(nr !== void 0 && !nr.isInvalidated), Wr.set(Ar, Oe, true), Xe.push(si(nr));
                }
                return Zt.forEach(function(gr, Vr, Tr) {
                  !Wr.has(Vr, Tr) && !e.contains(wi, Vr) && (Ie(gr, Wt, si), Zt.delete(Vr, Tr));
                }), Xe;
                function De(gr, Vr) {
                  if (gr === Vr) return true;
                  if (!gr || !Vr) return false;
                  var Tr = si(gr), vi = si(Vr);
                  return Tr === vi ? true : !Tr || !vi ? false : Tr.resolvedFileName === vi.resolvedFileName;
                }
              }
              function ue(ur, yr, Ir, wr) {
                return ne({ names: ur, containingFile: yr, redirectedReference: Ir, cache: ee, perDirectoryCacheWithRedirects: he, loader: g, getResolutionWithResolvedFileName: k, shouldRetryResolution: function(Ur) {
                  return Ur.resolvedTypeReferenceDirective === void 0;
                }, containingSourceFileMode: wr });
              }
              function We(ur, yr, Ir, wr, Ur) {
                return ne({ names: ur, containingFile: yr, redirectedReference: wr, cache: R, perDirectoryCacheWithRedirects: q, loader: fe, getResolutionWithResolvedFileName: P, shouldRetryResolution: function(ii) {
                  return !ii.resolvedModule || !e.resolutionExtensionIsTSOrJson(ii.resolvedModule.extension);
                }, reusedNames: Ir, logChanges: le, containingSourceFile: Ur });
              }
              function Fe(ur, yr, Ir) {
                var wr = R.get(E.toPath(yr));
                if (!!wr) return wr.get(ur, Ir);
              }
              function Z(ur) {
                return e.endsWith(ur, "/node_modules/@types");
              }
              function Be(ur, yr) {
                if (Y(y, yr)) {
                  ur = e.isRootedDiskPath(ur) ? e.normalizePath(ur) : e.getNormalizedAbsolutePath(ur, J());
                  var Ir = yr.split(e.directorySeparator), wr = ur.split(e.directorySeparator);
                  return e.Debug.assert(wr.length === Ir.length, "FailedLookup: ".concat(ur, " failedLookupLocationPath: ").concat(yr)), Ir.length > V + 1 ? { dir: wr.slice(0, V + 1).join(e.directorySeparator), dirPath: Ir.slice(0, V + 1).join(e.directorySeparator) } : { dir: A, dirPath: y, nonRecursive: false };
                }
                return ge(e.getDirectoryPath(e.getNormalizedAbsolutePath(ur, J())), e.getDirectoryPath(yr));
              }
              function ge(ur, yr) {
                for (; e.pathContainsNodeModules(yr); ) ur = e.getDirectoryPath(ur), yr = e.getDirectoryPath(yr);
                if (e.isNodeModulesDirectory(yr)) return C(e.getDirectoryPath(yr)) ? { dir: ur, dirPath: yr } : void 0;
                var Ir = true, wr, Ur;
                if (y !== void 0) for (; !Y(yr, y); ) {
                  var ii = e.getDirectoryPath(yr);
                  if (ii === yr) break;
                  Ir = false, wr = yr, Ur = ur, yr = ii, ur = e.getDirectoryPath(ur);
                }
                return C(yr) ? { dir: Ur || ur, dirPath: wr || yr, nonRecursive: Ir } : void 0;
              }
              function Re(ur) {
                return e.fileExtensionIsOneOf(ur, x);
              }
              function ze(ur, yr, Ir, wr) {
                if (yr.refCount) yr.refCount++, e.Debug.assertIsDefined(yr.files);
                else {
                  yr.refCount = 1, e.Debug.assert(e.length(yr.files) === 0), e.isExternalModuleNameRelative(ur) ? Ee(yr) : G.add(ur, yr);
                  var Ur = wr(yr);
                  Ur && Ur.resolvedFileName && f.add(E.toPath(Ur.resolvedFileName), yr);
                }
                (yr.files || (yr.files = [])).push(Ir);
              }
              function Ee(ur) {
                e.Debug.assert(!!ur.refCount);
                var yr = ur.failedLookupLocations;
                if (!!yr.length) {
                  oe.push(ur);
                  for (var Ir = false, wr = 0, Ur = yr; wr < Ur.length; wr++) {
                    var ii = Ur[wr], mi = E.toPath(ii), pe = Be(ii, mi);
                    if (pe) {
                      var or = pe.dir, qr = pe.dirPath, si = pe.nonRecursive;
                      if (!Re(mi)) {
                        var Di = X.get(mi) || 0;
                        X.set(mi, Di + 1);
                      }
                      qr === y ? (e.Debug.assert(!si), Ir = true) : rr(or, qr, si);
                    }
                  }
                  Ir && rr(A, y, true);
                }
              }
              function He(ur, yr) {
                var Ir = E.getCurrentProgram();
                (!Ir || !Ir.getTypeChecker().tryFindAmbientModuleWithoutAugmentations(yr)) && ur.forEach(Ee);
              }
              function rr(ur, yr, Ir) {
                var wr = $.get(yr);
                wr ? (e.Debug.assert(!!Ir == !!wr.nonRecursive), wr.refCount++) : $.set(yr, { watcher: we(ur, yr, Ir), refCount: 1, nonRecursive: Ir });
              }
              function Ie(ur, yr, Ir) {
                if (e.unorderedRemoveItem(e.Debug.checkDefined(ur.files), yr), ur.refCount--, !ur.refCount) {
                  var wr = Ir(ur);
                  if (wr && wr.resolvedFileName && f.remove(E.toPath(wr.resolvedFileName), ur), !!e.unorderedRemoveItem(oe, ur)) {
                    for (var Ur = ur.failedLookupLocations, ii = false, mi = 0, pe = Ur; mi < pe.length; mi++) {
                      var or = pe[mi], qr = E.toPath(or), si = Be(or, qr);
                      if (si) {
                        var Di = si.dirPath, wi = X.get(qr);
                        wi && (wi === 1 ? X.delete(qr) : (e.Debug.assert(wi > 1), X.set(qr, wi - 1))), Di === y ? ii = true : _e(Di);
                      }
                    }
                    ii && _e(y);
                  }
                }
              }
              function _e(ur) {
                var yr = $.get(ur);
                yr.refCount--;
              }
              function we(ur, yr, Ir) {
                return E.watchDirectoryOfFailedLookupLocation(ur, function(wr) {
                  var Ur = E.toPath(wr);
                  ie && ie.addOrDeleteFileOrDirectory(wr, Ur), Ye(Ur, yr === Ur);
                }, Ir ? 0 : 1);
              }
              function de(ur, yr, Ir) {
                var wr = ur.get(yr);
                wr && (wr.forEach(function(Ur) {
                  return Ie(Ur, yr, Ir);
                }), ur.delete(yr));
              }
              function ye(ur) {
                if (!!e.fileExtensionIs(ur, ".json")) {
                  var yr = E.getCurrentProgram();
                  if (!!yr) {
                    var Ir = yr.getResolvedProjectReferenceByPath(ur);
                    !Ir || Ir.commandLine.fileNames.forEach(function(wr) {
                      return Ae(E.toPath(wr));
                    });
                  }
                }
              }
              function Ae(ur) {
                de(R, ur, P), de(ee, ur, k);
              }
              function er(ur, yr) {
                if (!ur) return false;
                for (var Ir = false, wr = 0, Ur = ur; wr < Ur.length; wr++) {
                  var ii = Ur[wr];
                  if (!(ii.isInvalidated || !yr(ii))) {
                    ii.isInvalidated = Ir = true;
                    for (var mi = 0, pe = e.Debug.checkDefined(ii.files); mi < pe.length; mi++) {
                      var or = pe[mi];
                      (p || (p = new e.Set())).add(or), T = T || e.endsWith(or, e.inferredTypesContainingFile);
                    }
                  }
                }
                return Ir;
              }
              function ir(ur) {
                Ae(ur);
                var yr = T;
                er(f.get(ur), e.returnTrue) && T && !yr && E.onChangedAutomaticTypeDirectiveNames();
              }
              function Cr(ur) {
                e.Debug.assert(m === ur || m === void 0), m = ur;
              }
              function Ye(ur, yr) {
                if (yr) (se || (se = [])).push(ur);
                else {
                  var Ir = a(ur);
                  if (!Ir || (ur = Ir, E.fileIsOpen(ur))) return false;
                  var wr = e.getDirectoryPath(ur);
                  if (Z(ur) || e.isNodeModulesDirectory(ur) || Z(wr) || e.isNodeModulesDirectory(wr)) (K || (K = [])).push(ur), (b || (b = new e.Set())).add(ur);
                  else {
                    if (!Re(ur) && !X.has(ur) || e.isEmittedFileOfProgram(E.getCurrentProgram(), ur)) return false;
                    (K || (K = [])).push(ur);
                    var Ur = e.parseNodeModuleFromPath(ur);
                    Ur && (b || (b = new e.Set())).add(Ur);
                  }
                }
                E.scheduleInvalidateResolutionsOfFailedLookupLocations();
              }
              function Br() {
                if (!K && !b && !se) return false;
                var ur = er(oe, Er);
                return K = void 0, b = void 0, se = void 0, ur;
              }
              function Er(ur) {
                return ur.failedLookupLocations.some(function(yr) {
                  var Ir = E.toPath(yr);
                  return e.contains(K, Ir) || e.firstDefinedIterator((b == null ? void 0 : b.keys()) || e.emptyIterator, function(wr) {
                    return e.startsWith(Ir, wr) ? true : void 0;
                  }) || (se == null ? void 0 : se.some(function(wr) {
                    return Y(wr, Ir);
                  }));
                });
              }
              function Ne() {
                e.clearMap(L, e.closeFileWatcher);
              }
              function n(ur, yr) {
                if (Y(y, yr)) return y;
                var Ir = ge(ur, yr);
                return Ir && $.has(Ir.dirPath) ? Ir.dirPath : void 0;
              }
              function lr(ur, yr) {
                return E.watchTypeRootsDirectory(yr, function(Ir) {
                  var wr = E.toPath(Ir);
                  ie && ie.addOrDeleteFileOrDirectory(Ir, wr), T = true, E.onChangedAutomaticTypeDirectiveNames();
                  var Ur = n(yr, ur);
                  Ur && Ye(wr, Ur === wr);
                }, 1);
              }
              function be() {
                var ur = E.getCompilationSettings();
                if (ur.types) {
                  Ne();
                  return;
                }
                var yr = e.getEffectiveTypeRoots(ur, { directoryExists: Ge, getCurrentDirectory: J });
                yr ? e.mutateMap(L, e.arrayToMap(yr, function(Ir) {
                  return E.toPath(Ir);
                }), { createNewValue: lr, onDeleteValue: e.closeFileWatcher }) : Ne();
              }
              function Ge(ur) {
                var yr = e.getDirectoryPath(e.getDirectoryPath(ur)), Ir = E.toPath(yr);
                return Ir === y || C(Ir);
              }
            }
            e.createResolutionCache = w;
            function B(E) {
              var Q, le;
              return !!(((Q = E.resolvedModule) === null || Q === void 0 ? void 0 : Q.originalPath) || ((le = E.resolvedTypeReferenceDirective) === null || le === void 0 ? void 0 : le.originalPath));
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w;
              (function(I) {
                I[I.Relative = 0] = "Relative", I[I.NonRelative = 1] = "NonRelative", I[I.Shortest = 2] = "Shortest", I[I.ExternalNonRelative = 3] = "ExternalNonRelative";
              })(w || (w = {}));
              var B;
              (function(I) {
                I[I.Minimal = 0] = "Minimal", I[I.Index = 1] = "Index", I[I.JsExtension = 2] = "JsExtension";
              })(B || (B = {}));
              function E(I, l, d, D) {
                var fe = l.importModuleSpecifierPreference, g = l.importModuleSpecifierEnding;
                return { relativePreference: fe === "relative" ? 0 : fe === "non-relative" ? 1 : fe === "project-relative" ? 3 : 2, ending: ne() };
                function ne() {
                  switch (g) {
                    case "minimal":
                      return 0;
                    case "index":
                      return 1;
                    case "js":
                      return 2;
                    default:
                      return q(D) || le(d, D.path, I) ? 2 : e.getEmitModuleResolutionKind(d) !== e.ModuleResolutionKind.NodeJs ? 1 : 0;
                  }
                }
              }
              function Q(I, l, d, D) {
                return { relativePreference: e.isExternalModuleNameRelative(l) ? 0 : 1, ending: e.hasJSFileExtension(l) || le(I, d, D) ? 2 : e.getEmitModuleResolutionKind(I) !== e.ModuleResolutionKind.NodeJs || e.endsWith(l, "index") ? 1 : 0 };
              }
              function le(I, l, d) {
                var D;
                return e.getEmitModuleResolutionKind(I) !== e.ModuleResolutionKind.Node16 && e.getEmitModuleResolutionKind(I) !== e.ModuleResolutionKind.NodeNext ? false : e.getImpliedNodeFormatForFile(l, (D = d.getPackageJsonInfoCache) === null || D === void 0 ? void 0 : D.call(d), N(d), I) !== e.ModuleKind.CommonJS;
              }
              function N(I) {
                var l;
                return { fileExists: I.fileExists, readFile: e.Debug.checkDefined(I.readFile), directoryExists: I.directoryExists, getCurrentDirectory: I.getCurrentDirectory, realpath: I.realpath, useCaseSensitiveFileNames: (l = I.useCaseSensitiveFileNames) === null || l === void 0 ? void 0 : l.call(I) };
              }
              function p(I, l, d, D, fe, g, ne) {
                ne === void 0 && (ne = {});
                var ue = oe(I, l, d, D, fe, Q(I, g, d, fe), {}, ne);
                if (ue !== g) return ue;
              }
              C.updateModuleSpecifier = p;
              function m(I, l, d, D, fe, g) {
                return g === void 0 && (g = {}), oe(I, l, d, D, fe, E(fe, {}, I, l), {}, g);
              }
              C.getModuleSpecifier = m;
              function G(I, l, d, D, fe, g) {
                g === void 0 && (g = {});
                var ne = J(l.path, D), ue = he(l.path, d, D, fe, g);
                return e.firstDefined(ue, function(We) {
                  return V(We, ne, l, D, I, fe, true, g.overrideImportMode);
                });
              }
              C.getNodeModulesPackageName = G;
              function oe(I, l, d, D, fe, g, ne, ue) {
                ue === void 0 && (ue = {});
                var We = J(d, fe), Fe = he(d, D, fe, ne, ue);
                return e.firstDefined(Fe, function(Z) {
                  return V(Z, We, l, fe, I, ne, void 0, ue.overrideImportMode);
                }) || ie(D, We, I, fe, g);
              }
              function f(I, l, d, D, fe) {
                return fe === void 0 && (fe = {}), T(I, l, d, D, fe)[0];
              }
              C.tryGetModuleSpecifiersFromCache = f;
              function T(I, l, d, D, fe) {
                var g;
                fe === void 0 && (fe = {});
                var ne = e.getSourceFileOfModule(I);
                if (!ne) return e.emptyArray;
                var ue = (g = d.getModuleSpecifierCache) === null || g === void 0 ? void 0 : g.call(d), We = ue == null ? void 0 : ue.get(l.path, ne.path, D, fe);
                return [We == null ? void 0 : We.moduleSpecifiers, ne, We == null ? void 0 : We.modulePaths, ue];
              }
              function K(I, l, d, D, fe, g, ne) {
                return ne === void 0 && (ne = {}), b(I, l, d, D, fe, g, ne).moduleSpecifiers;
              }
              C.getModuleSpecifiers = K;
              function b(I, l, d, D, fe, g, ne) {
                ne === void 0 && (ne = {});
                var ue = false, We = x(I, l);
                if (We) return { moduleSpecifiers: [We], computedWithoutCache: ue };
                var Fe = T(I, D, fe, g, ne), Z = Fe[0], Be = Fe[1], ge = Fe[2], Re = Fe[3];
                if (Z) return { moduleSpecifiers: Z, computedWithoutCache: ue };
                if (!Be) return { moduleSpecifiers: e.emptyArray, computedWithoutCache: ue };
                ue = true, ge || (ge = F(D.path, Be.originalFileName, fe));
                var ze = se(ge, d, D, fe, g, ne);
                return Re == null || Re.set(D.path, Be.path, g, ne, ge, ze), { moduleSpecifiers: ze, computedWithoutCache: ue };
              }
              C.getModuleSpecifiersWithCacheInfo = b;
              function se(I, l, d, D, fe, g) {
                g === void 0 && (g = {});
                var ne = J(d.path, D), ue = E(D, fe, l, d), We = e.forEach(I, function(_e) {
                  return e.forEach(D.getFileIncludeReasons().get(e.toPath(_e.path, D.getCurrentDirectory(), ne.getCanonicalFileName)), function(we) {
                    if (!(we.kind !== e.FileIncludeKind.Import || we.file !== d.path) && !(d.impliedNodeFormat && d.impliedNodeFormat !== e.getModeForResolutionAtIndex(d, we.index))) {
                      var de = e.getModuleNameStringLiteralAt(d, we.index).text;
                      return ue.relativePreference !== 1 || !e.pathIsRelative(de) ? de : void 0;
                    }
                  });
                });
                if (We) {
                  var Fe = [We];
                  return Fe;
                }
                for (var Z = e.some(I, function(_e) {
                  return _e.isInNodeModules;
                }), Be, ge, Re, ze = 0, Ee = I; ze < Ee.length; ze++) {
                  var He = Ee[ze], rr = V(He, ne, d, D, l, fe, void 0, g.overrideImportMode);
                  if (Be = e.append(Be, rr), rr && He.isRedirect) return Be;
                  if (!rr && !He.isRedirect) {
                    var Ie = ie(He.path, ne, l, D, ue);
                    e.pathIsBareSpecifier(Ie) ? ge = e.append(ge, Ie) : (!Z || He.isInNodeModules) && (Re = e.append(Re, Ie));
                  }
                }
                return ge != null && ge.length ? ge : Be != null && Be.length ? Be : e.Debug.checkDefined(Re);
              }
              function J(I, l) {
                var d = e.createGetCanonicalFileName(l.useCaseSensitiveFileNames ? l.useCaseSensitiveFileNames() : true), D = e.getDirectoryPath(I);
                return { getCanonicalFileName: d, importingSourceFileName: I, sourceDirectory: D };
              }
              function ie(I, l, d, D, fe) {
                var g = fe.ending, ne = fe.relativePreference, ue = d.baseUrl, We = d.paths, Fe = d.rootDirs, Z = l.sourceDirectory, Be = l.getCanonicalFileName, ge = Fe && y(Fe, I, Z, Be, g, d) || k(e.ensurePathIsNonModuleName(e.getRelativePathFromDirectory(Z, I, Be)), g, d);
                if (!ue && !We || ne === 0) return ge;
                var Re = e.getNormalizedAbsolutePath(e.getPathsBasePath(d, D) || ue, D.getCurrentDirectory()), ze = j(I, Re, Be);
                if (!ze) return ge;
                var Ee = k(ze, g, d), He = We && X(e.removeFileExtension(ze), Ee, We), rr = He === void 0 && ue !== void 0 ? Ee : He;
                if (!rr) return ge;
                if (ne === 1) return rr;
                if (ne === 3) {
                  var Ie = d.configFilePath ? e.toPath(e.getDirectoryPath(d.configFilePath), D.getCurrentDirectory(), l.getCanonicalFileName) : l.getCanonicalFileName(D.getCurrentDirectory()), _e = e.toPath(I, Ie, Be), we = e.startsWith(Z, Ie), de = e.startsWith(_e, Ie);
                  if (we && !de || !we && de) return rr;
                  var ye = ve(D, e.getDirectoryPath(_e)), Ae = ve(D, Z);
                  return Ae !== ye ? rr : ge;
                }
                return ne !== 2 && e.Debug.assertNever(ne), H(rr) || R(ge) < R(rr) ? ge : rr;
              }
              function R(I) {
                for (var l = 0, d = e.startsWith(I, "./") ? 2 : 0; d < I.length; d++) I.charCodeAt(d) === 47 && l++;
                return l;
              }
              C.countPathComponents = R;
              function q(I) {
                var l = I.imports;
                return e.firstDefined(l, function(d) {
                  var D = d.text;
                  return e.pathIsRelative(D) ? e.hasJSFileExtension(D) : void 0;
                }) || false;
              }
              function O(I, l) {
                return e.compareBooleans(l.isRedirect, I.isRedirect) || e.compareNumberOfDirectorySeparators(I.path, l.path);
              }
              function ve(I, l) {
                return I.getNearestAncestorDirectoryWithPackageJson ? I.getNearestAncestorDirectoryWithPackageJson(l) : !!e.forEachAncestorDirectory(l, function(d) {
                  return I.fileExists(e.combinePaths(d, "package.json")) ? true : void 0;
                });
              }
              function ee(I, l, d, D, fe) {
                var g, ne = e.hostGetCanonicalFileName(d), ue = d.getCurrentDirectory(), We = d.isSourceOfProjectReferenceRedirect(l) ? d.getProjectReferenceRedirect(l) : void 0, Fe = e.toPath(l, ue, ne), Z = d.redirectTargetsMap.get(Fe) || e.emptyArray, Be = Ve(Ve(Ve([], We ? [We] : e.emptyArray, true), [l], false), Z, true), ge = Be.map(function(Ie) {
                  return e.getNormalizedAbsolutePath(Ie, ue);
                }), Re = !e.every(ge, e.containsIgnoredPath);
                if (!D) {
                  var ze = e.forEach(ge, function(Ie) {
                    return !(Re && e.containsIgnoredPath(Ie)) && fe(Ie, We === Ie);
                  });
                  if (ze) return ze;
                }
                var Ee = (g = d.getSymlinkCache) === null || g === void 0 ? void 0 : g.call(d).getSymlinkedDirectoriesByRealpath(), He = e.getNormalizedAbsolutePath(l, ue), rr = Ee && e.forEachAncestorDirectory(e.getDirectoryPath(He), function(Ie) {
                  var _e = Ee.get(e.ensureTrailingDirectorySeparator(e.toPath(Ie, ue, ne)));
                  if (!!_e) return e.startsWithDirectory(I, Ie, ne) ? false : e.forEach(ge, function(we) {
                    if (!!e.startsWithDirectory(we, Ie, ne)) for (var de = e.getRelativePathFromDirectory(Ie, we, ne), ye = 0, Ae = _e; ye < Ae.length; ye++) {
                      var er = Ae[ye], ir = e.resolvePath(er, de), Cr = fe(ir, we === We);
                      if (Re = true, Cr) return Cr;
                    }
                  });
                });
                return rr || (D ? e.forEach(ge, function(Ie) {
                  return Re && e.containsIgnoredPath(Ie) ? void 0 : fe(Ie, Ie === We);
                }) : void 0);
              }
              C.forEachFileNameOfModule = ee;
              function he(I, l, d, D, fe) {
                var g;
                fe === void 0 && (fe = {});
                var ne = e.toPath(l, d.getCurrentDirectory(), e.hostGetCanonicalFileName(d)), ue = (g = d.getModuleSpecifierCache) === null || g === void 0 ? void 0 : g.call(d);
                if (ue) {
                  var We = ue.get(I, ne, D, fe);
                  if (We != null && We.modulePaths) return We.modulePaths;
                }
                var Fe = F(I, l, d);
                return ue && ue.setModulePaths(I, ne, D, fe, Fe), Fe;
              }
              function F(I, l, d) {
                var D = e.hostGetCanonicalFileName(d), fe = new e.Map(), g = false;
                ee(I, l, d, true, function(ge, Re) {
                  var ze = e.pathContainsNodeModules(ge);
                  fe.set(ge, { path: D(ge), isRedirect: Re, isInNodeModules: ze }), g = g || ze;
                });
                for (var ne = [], ue = function(ge) {
                  var Re = e.ensureTrailingDirectorySeparator(ge), ze;
                  fe.forEach(function(He, rr) {
                    var Ie = He.path, _e = He.isRedirect, we = He.isInNodeModules;
                    e.startsWith(Ie, Re) && ((ze || (ze = [])).push({ path: rr, isRedirect: _e, isInNodeModules: we }), fe.delete(rr));
                  }), ze && (ze.length > 1 && ze.sort(O), ne.push.apply(ne, ze));
                  var Ee = e.getDirectoryPath(ge);
                  if (Ee === ge) return We = ge, "break";
                  ge = Ee, We = ge;
                }, We, Fe = e.getDirectoryPath(I); fe.size !== 0; ) {
                  var Z = ue(Fe);
                  if (Fe = We, Z === "break") break;
                }
                if (fe.size) {
                  var Be = e.arrayFrom(fe.values());
                  Be.length > 1 && Be.sort(O), ne.push.apply(ne, Be);
                }
                return ne;
              }
              function x(I, l) {
                var d, D = (d = I.declarations) === null || d === void 0 ? void 0 : d.find(function(ne) {
                  return e.isNonGlobalAmbientModule(ne) && (!e.isExternalModuleAugmentation(ne) || !e.isExternalModuleNameRelative(e.getTextOfIdentifierOrLiteral(ne.name)));
                });
                if (D) return D.name.text;
                var fe = e.mapDefined(I.declarations, function(ne) {
                  var ue, We, Fe, Z;
                  if (!e.isModuleDeclaration(ne)) return;
                  var Be = Ee(ne);
                  if (!(((ue = Be == null ? void 0 : Be.parent) === null || ue === void 0 ? void 0 : ue.parent) && e.isModuleBlock(Be.parent) && e.isAmbientModule(Be.parent.parent) && e.isSourceFile(Be.parent.parent.parent))) return;
                  var ge = (Z = (Fe = (We = Be.parent.parent.symbol.exports) === null || We === void 0 ? void 0 : We.get("export=")) === null || Fe === void 0 ? void 0 : Fe.valueDeclaration) === null || Z === void 0 ? void 0 : Z.expression;
                  if (!ge) return;
                  var Re = l.getSymbolAtLocation(ge);
                  if (!Re) return;
                  var ze = (Re == null ? void 0 : Re.flags) & 2097152 ? l.getAliasedSymbol(Re) : Re;
                  if (ze === ne.symbol) return Be.parent.parent;
                  function Ee(He) {
                    for (; He.flags & 4; ) He = He.parent;
                    return He;
                  }
                }), g = fe[0];
                if (g) return g.name.text;
              }
              function X(I, l, d) {
                for (var D in d) for (var fe = 0, g = d[D]; fe < g.length; fe++) {
                  var ne = g[fe], ue = e.removeFileExtension(e.normalizePath(ne)), We = ue.indexOf("*");
                  if (We !== -1) {
                    var Fe = ue.substr(0, We), Z = ue.substr(We + 1);
                    if (l.length >= Fe.length + Z.length && e.startsWith(l, Fe) && e.endsWith(l, Z) || !Z && l === e.removeTrailingDirectorySeparator(Fe)) {
                      var Be = l.substr(Fe.length, l.length - Z.length - Fe.length);
                      return D.replace("*", Be);
                    }
                  } else if (ue === l || ue === I) return D;
                }
              }
              var $;
              (function(I) {
                I[I.Exact = 0] = "Exact", I[I.Directory = 1] = "Directory", I[I.Pattern = 2] = "Pattern";
              })($ || ($ = {}));
              function A(I, l, d, D, fe, g, ne) {
                if (ne === void 0 && (ne = 0), typeof fe == "string") {
                  var ue = e.getNormalizedAbsolutePath(e.combinePaths(d, fe), void 0), We = e.hasTSFileExtension(l) ? e.removeFileExtension(l) + U(l, I) : void 0;
                  switch (ne) {
                    case 0:
                      if (e.comparePaths(l, ue) === 0 || We && e.comparePaths(We, ue) === 0) return { moduleFileToTry: D };
                      break;
                    case 1:
                      if (e.containsPath(ue, l)) {
                        var Fe = e.getRelativePathFromDirectory(ue, l, false);
                        return { moduleFileToTry: e.getNormalizedAbsolutePath(e.combinePaths(e.combinePaths(D, fe), Fe), void 0) };
                      }
                      break;
                    case 2:
                      var Z = ue.indexOf("*"), Be = ue.slice(0, Z), ge = ue.slice(Z + 1);
                      if (e.startsWith(l, Be) && e.endsWith(l, ge)) {
                        var Re = l.slice(Be.length, l.length - ge.length);
                        return { moduleFileToTry: D.replace("*", Re) };
                      }
                      if (We && e.startsWith(We, Be) && e.endsWith(We, ge)) {
                        var Re = We.slice(Be.length, We.length - ge.length);
                        return { moduleFileToTry: D.replace("*", Re) };
                      }
                      break;
                  }
                } else {
                  if (Array.isArray(fe)) return e.forEach(fe, function(_e) {
                    return A(I, l, d, D, _e, g);
                  });
                  if (typeof fe == "object" && fe !== null) {
                    if (e.allKeysStartWithDot(fe)) return e.forEach(e.getOwnKeys(fe), function(_e) {
                      var we = e.getNormalizedAbsolutePath(e.combinePaths(D, _e), void 0), de = e.endsWith(_e, "/") ? 1 : e.stringContains(_e, "*") ? 2 : 0;
                      return A(I, l, d, we, fe[_e], g, de);
                    });
                    for (var ze = 0, Ee = e.getOwnKeys(fe); ze < Ee.length; ze++) {
                      var He = Ee[ze];
                      if (He === "default" || g.indexOf(He) >= 0 || e.isApplicableVersionedTypesKey(g, He)) {
                        var rr = fe[He], Ie = A(I, l, d, D, rr, g);
                        if (Ie) return Ie;
                      }
                    }
                  }
                }
              }
              function y(I, l, d, D, fe, g) {
                var ne = P(l, I, D);
                if (ne !== void 0) {
                  var ue = P(d, I, D), We = ue !== void 0 ? e.ensurePathIsNonModuleName(e.getRelativePathFromDirectory(ue, ne, D)) : ne;
                  return e.getEmitModuleResolutionKind(g) === e.ModuleResolutionKind.NodeJs ? k(We, fe, g) : e.removeFileExtension(We);
                }
              }
              function V(I, l, d, D, fe, g, ne, ue) {
                var We = I.path, Fe = I.isRedirect, Z = l.getCanonicalFileName, Be = l.sourceDirectory;
                if (!D.fileExists || !D.readFile) return;
                var ge = e.getNodeModulePathParts(We);
                if (!ge) return;
                var Re = We, ze = false;
                if (!ne) for (var Ee = E(D, g, fe, d), He = ge.packageRootIndex, rr = void 0; ; ) {
                  var Ie = Ye(He), _e = Ie.moduleFileToTry, we = Ie.packageRootPath, de = Ie.blockedByExports, ye = Ie.verbatimFromExports;
                  if (e.getEmitModuleResolutionKind(fe) !== e.ModuleResolutionKind.Classic) {
                    if (de) return;
                    if (ye) return _e;
                  }
                  if (we) {
                    Re = we, ze = true;
                    break;
                  }
                  if (rr || (rr = _e), He = We.indexOf(e.directorySeparator, He + 1), He === -1) {
                    Re = k(rr, Ee.ending, fe, D);
                    break;
                  }
                }
                if (Fe && !ze) return;
                var Ae = D.getGlobalTypingsCacheLocation && D.getGlobalTypingsCacheLocation(), er = Z(Re.substring(0, ge.topLevelNodeModulesIndex));
                if (!(e.startsWith(Be, er) || Ae && e.startsWith(Z(Ae), er))) return;
                var ir = Re.substring(ge.topLevelPackageNameIndex + 1), Cr = e.getPackageNameFromTypesPackageName(ir);
                return e.getEmitModuleResolutionKind(fe) === e.ModuleResolutionKind.Classic && Cr === ir ? void 0 : Cr;
                function Ye(Br) {
                  var Er, Ne, n = We.substring(0, Br), lr = e.combinePaths(n, "package.json"), be = We, Ge = (Ne = (Er = D.getPackageJsonInfoCache) === null || Er === void 0 ? void 0 : Er.call(D)) === null || Ne === void 0 ? void 0 : Ne.getPackageJsonInfo(lr);
                  if (typeof Ge == "object" || Ge === void 0 && D.fileExists(lr)) {
                    var ur = (Ge == null ? void 0 : Ge.packageJsonContent) || JSON.parse(D.readFile(lr));
                    if (e.getEmitModuleResolutionKind(fe) === e.ModuleResolutionKind.Node16 || e.getEmitModuleResolutionKind(fe) === e.ModuleResolutionKind.NodeNext) {
                      var yr = ["node", ue || d.impliedNodeFormat === e.ModuleKind.ESNext ? "import" : "require", "types"], Ir = ur.exports && typeof ur.name == "string" ? A(fe, We, n, e.getPackageNameFromTypesPackageName(ur.name), ur.exports, yr) : void 0;
                      if (Ir) {
                        var wr = e.hasTSFileExtension(Ir.moduleFileToTry) ? { moduleFileToTry: e.removeFileExtension(Ir.moduleFileToTry) + U(Ir.moduleFileToTry, fe) } : Ir;
                        return Ke(Ke({}, wr), { verbatimFromExports: true });
                      }
                      if (ur.exports) return { moduleFileToTry: We, blockedByExports: true };
                    }
                    var Ur = ur.typesVersions ? e.getPackageJsonTypesVersionsPaths(ur.typesVersions) : void 0;
                    if (Ur) {
                      var ii = We.slice(n.length + 1), mi = X(e.removeFileExtension(ii), k(ii, 0, fe), Ur.paths);
                      mi !== void 0 && (be = e.combinePaths(n, mi));
                    }
                    var pe = ur.typings || ur.types || ur.main || "index.js";
                    if (e.isString(pe)) {
                      var or = e.toPath(pe, n, Z);
                      if (e.removeFileExtension(or) === e.removeFileExtension(Z(be))) return { packageRootPath: n, moduleFileToTry: be };
                    }
                  } else {
                    var qr = Z(be.substring(ge.packageRootIndex + 1));
                    if (qr === "index.d.ts" || qr === "index.js" || qr === "index.ts" || qr === "index.tsx") return { moduleFileToTry: be, packageRootPath: n };
                  }
                  return { moduleFileToTry: be };
                }
              }
              function L(I, l) {
                if (!!I.fileExists) for (var d = e.flatten(e.getSupportedExtensions({ allowJs: true }, [{ extension: "node", isMixedContent: false }, { extension: "json", isMixedContent: false, scriptKind: 6 }])), D = 0, fe = d; D < fe.length; D++) {
                  var g = fe[D], ne = l + g;
                  if (I.fileExists(ne)) return ne;
                }
              }
              function P(I, l, d) {
                return e.firstDefined(l, function(D) {
                  var fe = j(I, D, d);
                  return fe !== void 0 && H(fe) ? void 0 : fe;
                });
              }
              function k(I, l, d, D) {
                if (e.fileExtensionIsOneOf(I, [".json", ".mjs", ".cjs"])) return I;
                var fe = e.removeFileExtension(I);
                if (I === fe) return I;
                if (e.fileExtensionIsOneOf(I, [".d.mts", ".mts", ".d.cts", ".cts"])) return fe + Y(I, d);
                switch (l) {
                  case 0:
                    var g = e.removeSuffix(fe, "/index");
                    return D && g !== fe && L(D, g) ? fe : g;
                  case 1:
                    return fe;
                  case 2:
                    return fe + Y(I, d);
                  default:
                    return e.Debug.assertNever(l);
                }
              }
              function Y(I, l) {
                var d;
                return (d = U(I, l)) !== null && d !== void 0 ? d : e.Debug.fail("Extension ".concat(e.extensionFromPath(I), " is unsupported:: FileName:: ").concat(I));
              }
              function U(I, l) {
                var d = e.tryGetExtensionFromPath(I);
                switch (d) {
                  case ".ts":
                  case ".d.ts":
                    return ".js";
                  case ".tsx":
                    return l.jsx === 1 ? ".jsx" : ".js";
                  case ".js":
                  case ".jsx":
                  case ".json":
                    return d;
                  case ".d.mts":
                  case ".mts":
                  case ".mjs":
                    return ".mjs";
                  case ".d.cts":
                  case ".cts":
                  case ".cjs":
                    return ".cjs";
                  default:
                    return;
                }
              }
              C.tryGetJSExtensionForFile = U;
              function j(I, l, d) {
                var D = e.getRelativePathToDirectoryOrUrl(l, I, l, d, false);
                return e.isRootedDiskPath(D) ? void 0 : D;
              }
              function H(I) {
                return e.startsWith(I, "..");
              }
            })(a = e.moduleSpecifiers || (e.moduleSpecifiers = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a = e.sys ? { getCurrentDirectory: function() {
              return e.sys.getCurrentDirectory();
            }, getNewLine: function() {
              return e.sys.newLine;
            }, getCanonicalFileName: e.createGetCanonicalFileName(e.sys.useCaseSensitiveFileNames) } : void 0;
            function C(P, k) {
              var Y = P === e.sys && a ? a : { getCurrentDirectory: function() {
                return P.getCurrentDirectory();
              }, getNewLine: function() {
                return P.newLine;
              }, getCanonicalFileName: e.createGetCanonicalFileName(P.useCaseSensitiveFileNames) };
              if (!k) return function(j) {
                return P.write(e.formatDiagnostic(j, Y));
              };
              var U = new Array(1);
              return function(j) {
                U[0] = j, P.write(e.formatDiagnosticsWithColorAndContext(U, Y) + Y.getNewLine()), U[0] = void 0;
              };
            }
            e.createDiagnosticReporter = C;
            function w(P, k, Y) {
              return P.clearScreen && !Y.preserveWatchOutput && !Y.extendedDiagnostics && !Y.diagnostics && e.contains(e.screenStartingMessageCodes, k.code) ? (P.clearScreen(), true) : false;
            }
            e.screenStartingMessageCodes = [e.Diagnostics.Starting_compilation_in_watch_mode.code, e.Diagnostics.File_change_detected_Starting_incremental_compilation.code];
            function B(P, k) {
              return e.contains(e.screenStartingMessageCodes, P.code) ? k + k : k;
            }
            function E(P) {
              return P.now ? P.now().toLocaleTimeString("en-US", { timeZone: "UTC" }) : (/* @__PURE__ */ new Date()).toLocaleTimeString();
            }
            e.getLocaleTimeString = E;
            function Q(P, k) {
              return k ? function(Y, U, j) {
                w(P, Y, j);
                var H = "[".concat(e.formatColorAndReset(E(P), e.ForegroundColorEscapeSequences.Grey), "] ");
                H += "".concat(e.flattenDiagnosticMessageText(Y.messageText, P.newLine)).concat(U + U), P.write(H);
              } : function(Y, U, j) {
                var H = "";
                w(P, Y, j) || (H += U), H += "".concat(E(P), " - "), H += "".concat(e.flattenDiagnosticMessageText(Y.messageText, P.newLine)).concat(B(Y, U)), P.write(H);
              };
            }
            e.createWatchStatusReporter = Q;
            function le(P, k, Y, U, j, H) {
              var I = j;
              I.onUnRecoverableConfigFileDiagnostic = function(d) {
                return A(j, H, d);
              };
              var l = e.getParsedCommandLineOfConfigFile(P, k, I, Y, U);
              return I.onUnRecoverableConfigFileDiagnostic = void 0, l;
            }
            e.parseConfigFileWithSystem = le;
            function N(P) {
              return e.countWhere(P, function(k) {
                return k.category === e.DiagnosticCategory.Error;
              });
            }
            e.getErrorCountForSummary = N;
            function p(P) {
              var k = e.filter(P, function(Y) {
                return Y.category === e.DiagnosticCategory.Error;
              }).map(function(Y) {
                if (Y.file !== void 0) return "".concat(Y.file.fileName);
              });
              return k.map(function(Y) {
                var U = e.find(P, function(H) {
                  return H.file !== void 0 && H.file.fileName === Y;
                });
                if (U !== void 0) {
                  var j = e.getLineAndCharacterOfPosition(U.file, U.start).line;
                  return { fileName: Y, line: j + 1 };
                }
              });
            }
            e.getFilesInErrorForSummary = p;
            function m(P) {
              return P === 1 ? e.Diagnostics.Found_1_error_Watching_for_file_changes : e.Diagnostics.Found_0_errors_Watching_for_file_changes;
            }
            e.getWatchErrorSummaryDiagnosticMessage = m;
            function G(P, k) {
              var Y = e.formatColorAndReset(":" + P.line, e.ForegroundColorEscapeSequences.Grey);
              return e.pathIsAbsolute(P.fileName) && e.pathIsAbsolute(k) ? e.getRelativePathFromDirectory(k, P.fileName, false) + Y : P.fileName + Y;
            }
            function oe(P, k, Y, U) {
              if (P === 0) return "";
              var j = k.filter(function(D) {
                return D !== void 0;
              }), H = j.map(function(D) {
                return "".concat(D.fileName, ":").concat(D.line);
              }).filter(function(D, fe, g) {
                return g.indexOf(D) === fe;
              }), I = j[0] && G(j[0], U.getCurrentDirectory()), l = P === 1 ? e.createCompilerDiagnostic(k[0] !== void 0 ? e.Diagnostics.Found_1_error_in_1 : e.Diagnostics.Found_1_error, P, I) : e.createCompilerDiagnostic(H.length === 0 ? e.Diagnostics.Found_0_errors : H.length === 1 ? e.Diagnostics.Found_0_errors_in_the_same_file_starting_at_Colon_1 : e.Diagnostics.Found_0_errors_in_1_files, P, H.length === 1 ? I : H.length), d = H.length > 1 ? f(j, U) : "";
              return "".concat(Y).concat(e.flattenDiagnosticMessageText(l.messageText, Y)).concat(Y).concat(Y).concat(d);
            }
            e.getErrorSummaryText = oe;
            function f(P, k) {
              var Y = P.filter(function(g, ne, ue) {
                return ne === ue.findIndex(function(We) {
                  return (We == null ? void 0 : We.fileName) === (g == null ? void 0 : g.fileName);
                });
              });
              if (Y.length === 0) return "";
              var U = function(g) {
                return Math.log(g) * Math.LOG10E + 1;
              }, j = Y.map(function(g) {
                return [g, e.countWhere(P, function(ne) {
                  return ne.fileName === g.fileName;
                })];
              }), H = j.reduce(function(g, ne) {
                return Math.max(g, ne[1] || 0);
              }, 0), I = e.Diagnostics.Errors_Files.message, l = I.split(" ")[0].length, d = Math.max(l, U(H)), D = Math.max(U(H) - l, 0), fe = "";
              return fe += " ".repeat(D) + I + `
`, j.forEach(function(g) {
                var ne = g[0], ue = g[1], We = Math.log(ue) * Math.LOG10E + 1 | 0, Fe = We < d ? " ".repeat(d - We) : "", Z = G(ne, k.getCurrentDirectory());
                fe += "".concat(Fe).concat(ue, "  ").concat(Z, `
`);
              }), fe;
            }
            function T(P) {
              return !!P.getState;
            }
            e.isBuilderProgram = T;
            function K(P, k) {
              var Y = P.getCompilerOptions();
              Y.explainFiles ? b(T(P) ? P.getProgram() : P, k) : (Y.listFiles || Y.listFilesOnly) && e.forEach(P.getSourceFiles(), function(U) {
                k(U.fileName);
              });
            }
            e.listFiles = K;
            function b(P, k) {
              for (var Y, U, j = P.getFileIncludeReasons(), H = e.createGetCanonicalFileName(P.useCaseSensitiveFileNames()), I = function(fe) {
                return e.convertToRelativePath(fe, P.getCurrentDirectory(), H);
              }, l = 0, d = P.getSourceFiles(); l < d.length; l++) {
                var D = d[l];
                k("".concat(q(D, I))), (Y = j.get(D.path)) === null || Y === void 0 || Y.forEach(function(fe) {
                  return k("  ".concat(R(P, fe, I).messageText));
                }), (U = se(D, I)) === null || U === void 0 || U.forEach(function(fe) {
                  return k("  ".concat(fe.messageText));
                });
              }
            }
            e.explainFiles = b;
            function se(P, k) {
              var Y;
              return P.path !== P.resolvedPath && (Y || (Y = [])).push(e.chainDiagnosticMessages(void 0, e.Diagnostics.File_is_output_of_project_reference_source_0, q(P.originalFileName, k))), P.redirectInfo && (Y || (Y = [])).push(e.chainDiagnosticMessages(void 0, e.Diagnostics.File_redirects_to_file_0, q(P.redirectInfo.redirectTarget, k))), Y;
            }
            e.explainIfFileIsRedirect = se;
            function J(P, k) {
              var Y, U = P.getCompilerOptions().configFile;
              if (!!(!((Y = U == null ? void 0 : U.configFileSpecs) === null || Y === void 0) && Y.validatedFilesSpec)) {
                var j = e.createGetCanonicalFileName(P.useCaseSensitiveFileNames()), H = j(k), I = e.getDirectoryPath(e.getNormalizedAbsolutePath(U.fileName, P.getCurrentDirectory()));
                return e.find(U.configFileSpecs.validatedFilesSpec, function(l) {
                  return j(e.getNormalizedAbsolutePath(l, I)) === H;
                });
              }
            }
            e.getMatchedFileSpec = J;
            function ie(P, k) {
              var Y, U, j = P.getCompilerOptions().configFile;
              if (!!(!((Y = j == null ? void 0 : j.configFileSpecs) === null || Y === void 0) && Y.validatedIncludeSpecs)) {
                var H = e.fileExtensionIs(k, ".json"), I = e.getDirectoryPath(e.getNormalizedAbsolutePath(j.fileName, P.getCurrentDirectory())), l = P.useCaseSensitiveFileNames();
                return e.find((U = j == null ? void 0 : j.configFileSpecs) === null || U === void 0 ? void 0 : U.validatedIncludeSpecs, function(d) {
                  if (H && !e.endsWith(d, ".json")) return false;
                  var D = e.getPatternFromSpec(d, I, "files");
                  return !!D && e.getRegexFromPattern("(".concat(D, ")$"), l).test(k);
                });
              }
            }
            e.getMatchedIncludeSpec = ie;
            function R(P, k, Y) {
              var U, j, H = P.getCompilerOptions();
              if (e.isReferencedFile(k)) {
                var I = e.getReferencedFileLocation(function(Fe) {
                  return P.getSourceFileByPath(Fe);
                }, k), l = e.isReferenceFileLocation(I) ? I.file.text.substring(I.pos, I.end) : '"'.concat(I.text, '"'), d = void 0;
                switch (e.Debug.assert(e.isReferenceFileLocation(I) || k.kind === e.FileIncludeKind.Import, "Only synthetic references are imports"), k.kind) {
                  case e.FileIncludeKind.Import:
                    e.isReferenceFileLocation(I) ? d = I.packageId ? e.Diagnostics.Imported_via_0_from_file_1_with_packageId_2 : e.Diagnostics.Imported_via_0_from_file_1 : I.text === e.externalHelpersModuleNameText ? d = I.packageId ? e.Diagnostics.Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions : e.Diagnostics.Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions : d = I.packageId ? e.Diagnostics.Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions : e.Diagnostics.Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions;
                    break;
                  case e.FileIncludeKind.ReferenceFile:
                    e.Debug.assert(!I.packageId), d = e.Diagnostics.Referenced_via_0_from_file_1;
                    break;
                  case e.FileIncludeKind.TypeReferenceDirective:
                    d = I.packageId ? e.Diagnostics.Type_library_referenced_via_0_from_file_1_with_packageId_2 : e.Diagnostics.Type_library_referenced_via_0_from_file_1;
                    break;
                  case e.FileIncludeKind.LibReferenceDirective:
                    e.Debug.assert(!I.packageId), d = e.Diagnostics.Library_referenced_via_0_from_file_1;
                    break;
                  default:
                    e.Debug.assertNever(k);
                }
                return e.chainDiagnosticMessages(void 0, d, l, q(I.file, Y), I.packageId && e.packageIdToString(I.packageId));
              }
              switch (k.kind) {
                case e.FileIncludeKind.RootFile:
                  if (!(!((U = H.configFile) === null || U === void 0) && U.configFileSpecs)) return e.chainDiagnosticMessages(void 0, e.Diagnostics.Root_file_specified_for_compilation);
                  var D = e.getNormalizedAbsolutePath(P.getRootFileNames()[k.index], P.getCurrentDirectory()), fe = J(P, D);
                  if (fe) return e.chainDiagnosticMessages(void 0, e.Diagnostics.Part_of_files_list_in_tsconfig_json);
                  var g = ie(P, D);
                  return g ? e.chainDiagnosticMessages(void 0, e.Diagnostics.Matched_by_include_pattern_0_in_1, g, q(H.configFile, Y)) : e.chainDiagnosticMessages(void 0, e.Diagnostics.Root_file_specified_for_compilation);
                case e.FileIncludeKind.SourceFromProjectReference:
                case e.FileIncludeKind.OutputFromProjectReference:
                  var ne = k.kind === e.FileIncludeKind.OutputFromProjectReference, ue = e.Debug.checkDefined((j = P.getResolvedProjectReferences()) === null || j === void 0 ? void 0 : j[k.index]);
                  return e.chainDiagnosticMessages(void 0, e.outFile(H) ? ne ? e.Diagnostics.Output_from_referenced_project_0_included_because_1_specified : e.Diagnostics.Source_from_referenced_project_0_included_because_1_specified : ne ? e.Diagnostics.Output_from_referenced_project_0_included_because_module_is_specified_as_none : e.Diagnostics.Source_from_referenced_project_0_included_because_module_is_specified_as_none, q(ue.sourceFile.fileName, Y), H.outFile ? "--outFile" : "--out");
                case e.FileIncludeKind.AutomaticTypeDirectiveFile:
                  return e.chainDiagnosticMessages(void 0, H.types ? k.packageId ? e.Diagnostics.Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1 : e.Diagnostics.Entry_point_of_type_library_0_specified_in_compilerOptions : k.packageId ? e.Diagnostics.Entry_point_for_implicit_type_library_0_with_packageId_1 : e.Diagnostics.Entry_point_for_implicit_type_library_0, k.typeReference, k.packageId && e.packageIdToString(k.packageId));
                case e.FileIncludeKind.LibFile:
                  if (k.index !== void 0) return e.chainDiagnosticMessages(void 0, e.Diagnostics.Library_0_specified_in_compilerOptions, H.lib[k.index]);
                  var We = e.forEachEntry(e.targetOptionDeclaration.type, function(Fe, Z) {
                    return Fe === e.getEmitScriptTarget(H) ? Z : void 0;
                  });
                  return e.chainDiagnosticMessages(void 0, We ? e.Diagnostics.Default_library_for_target_0 : e.Diagnostics.Default_library, We);
                default:
                  e.Debug.assertNever(k);
              }
            }
            e.fileIncludeReasonToDiagnostics = R;
            function q(P, k) {
              var Y = e.isString(P) ? P : P.fileName;
              return k ? k(Y) : Y;
            }
            function O(P, k, Y, U, j, H, I, l) {
              var d = !!P.getCompilerOptions().listFilesOnly, D = P.getConfigFileParsingDiagnostics().slice(), fe = D.length;
              e.addRange(D, P.getSyntacticDiagnostics(void 0, H)), D.length === fe && (e.addRange(D, P.getOptionsDiagnostics(H)), d || (e.addRange(D, P.getGlobalDiagnostics(H)), D.length === fe && e.addRange(D, P.getSemanticDiagnostics(void 0, H))));
              var g = d ? { emitSkipped: true, diagnostics: e.emptyArray } : P.emit(void 0, j, H, I, l), ne = g.emittedFiles, ue = g.diagnostics;
              e.addRange(D, ue);
              var We = e.sortAndDeduplicateDiagnostics(D);
              if (We.forEach(k), Y) {
                var Fe = P.getCurrentDirectory();
                e.forEach(ne, function(Z) {
                  var Be = e.getNormalizedAbsolutePath(Z, Fe);
                  Y("TSFILE: ".concat(Be));
                }), K(P, Y);
              }
              return U && U(N(We), p(We)), { emitResult: g, diagnostics: We };
            }
            e.emitFilesAndReportErrors = O;
            function ve(P, k, Y, U, j, H, I, l) {
              var d = O(P, k, Y, U, j, H, I, l), D = d.emitResult, fe = d.diagnostics;
              return D.emitSkipped && fe.length > 0 ? e.ExitStatus.DiagnosticsPresent_OutputsSkipped : fe.length > 0 ? e.ExitStatus.DiagnosticsPresent_OutputsGenerated : e.ExitStatus.Success;
            }
            e.emitFilesAndReportErrorsAndGetExitStatus = ve, e.noopFileWatcher = { close: e.noop }, e.returnNoopFileWatcher = function() {
              return e.noopFileWatcher;
            };
            function ee(P, k) {
              P === void 0 && (P = e.sys);
              var Y = k || Q(P);
              return { onWatchStatusChange: Y, watchFile: e.maybeBind(P, P.watchFile) || e.returnNoopFileWatcher, watchDirectory: e.maybeBind(P, P.watchDirectory) || e.returnNoopFileWatcher, setTimeout: e.maybeBind(P, P.setTimeout) || e.noop, clearTimeout: e.maybeBind(P, P.clearTimeout) || e.noop };
            }
            e.createWatchHost = ee, e.WatchType = { ConfigFile: "Config file", ExtendedConfigFile: "Extended config file", SourceFile: "Source file", MissingFile: "Missing file", WildcardDirectory: "Wild card directory", FailedLookupLocations: "Failed Lookup Locations", TypeRoots: "Type roots", ConfigFileOfReferencedProject: "Config file of referened project", ExtendedConfigOfReferencedProject: "Extended config file of referenced project", WildcardDirectoryOfReferencedProject: "Wild card directory of referenced project", PackageJson: "package.json file" };
            function he(P, k) {
              var Y = P.trace ? k.extendedDiagnostics ? e.WatchLogLevel.Verbose : k.diagnostics ? e.WatchLogLevel.TriggerOnly : e.WatchLogLevel.None : e.WatchLogLevel.None, U = Y !== e.WatchLogLevel.None ? function(H) {
                return P.trace(H);
              } : e.noop, j = e.getWatchFactory(P, Y, U);
              return j.writeLog = U, j;
            }
            e.createWatchFactory = he;
            function F(P, k, Y) {
              Y === void 0 && (Y = P);
              var U = P.useCaseSensitiveFileNames(), j = e.memoize(function() {
                return P.getNewLine();
              });
              return { getSourceFile: function(I, l, d) {
                var D;
                try {
                  e.performance.mark("beforeIORead"), D = P.readFile(I, k().charset), e.performance.mark("afterIORead"), e.performance.measure("I/O Read", "beforeIORead", "afterIORead");
                } catch (fe) {
                  d && d(fe.message), D = "";
                }
                return D !== void 0 ? e.createSourceFile(I, D, l) : void 0;
              }, getDefaultLibLocation: e.maybeBind(P, P.getDefaultLibLocation), getDefaultLibFileName: function(I) {
                return P.getDefaultLibFileName(I);
              }, writeFile: H, getCurrentDirectory: e.memoize(function() {
                return P.getCurrentDirectory();
              }), useCaseSensitiveFileNames: function() {
                return U;
              }, getCanonicalFileName: e.createGetCanonicalFileName(U), getNewLine: function() {
                return e.getNewLineCharacter(k(), j);
              }, fileExists: function(I) {
                return P.fileExists(I);
              }, readFile: function(I) {
                return P.readFile(I);
              }, trace: e.maybeBind(P, P.trace), directoryExists: e.maybeBind(Y, Y.directoryExists), getDirectories: e.maybeBind(Y, Y.getDirectories), realpath: e.maybeBind(P, P.realpath), getEnvironmentVariable: e.maybeBind(P, P.getEnvironmentVariable) || function() {
                return "";
              }, createHash: e.maybeBind(P, P.createHash), readDirectory: e.maybeBind(P, P.readDirectory), disableUseFileVersionAsSignature: P.disableUseFileVersionAsSignature, storeFilesChangingSignatureDuringEmit: P.storeFilesChangingSignatureDuringEmit };
              function H(I, l, d, D) {
                try {
                  e.performance.mark("beforeIOWrite"), e.writeFileEnsuringDirectories(I, l, d, function(fe, g, ne) {
                    return P.writeFile(fe, g, ne);
                  }, function(fe) {
                    return P.createDirectory(fe);
                  }, function(fe) {
                    return P.directoryExists(fe);
                  }), e.performance.mark("afterIOWrite"), e.performance.measure("I/O Write", "beforeIOWrite", "afterIOWrite");
                } catch (fe) {
                  D && D(fe.message);
                }
              }
            }
            e.createCompilerHostFromProgramHost = F;
            function x(P, k) {
              var Y = P.getSourceFile, U = e.maybeBind(k, k.createHash) || e.generateDjb2Hash;
              P.getSourceFile = function() {
                for (var j = [], H = 0; H < arguments.length; H++) j[H] = arguments[H];
                var I = Y.call.apply(Y, Ve([P], j, false));
                return I && (I.version = U(I.text)), I;
              };
            }
            e.setGetSourceFileAsHashVersioned = x;
            function X(P, k) {
              var Y = e.memoize(function() {
                return e.getDirectoryPath(e.normalizePath(P.getExecutingFilePath()));
              });
              return { useCaseSensitiveFileNames: function() {
                return P.useCaseSensitiveFileNames;
              }, getNewLine: function() {
                return P.newLine;
              }, getCurrentDirectory: e.memoize(function() {
                return P.getCurrentDirectory();
              }), getDefaultLibLocation: Y, getDefaultLibFileName: function(U) {
                return e.combinePaths(Y(), e.getDefaultLibFileName(U));
              }, fileExists: function(U) {
                return P.fileExists(U);
              }, readFile: function(U, j) {
                return P.readFile(U, j);
              }, directoryExists: function(U) {
                return P.directoryExists(U);
              }, getDirectories: function(U) {
                return P.getDirectories(U);
              }, readDirectory: function(U, j, H, I, l) {
                return P.readDirectory(U, j, H, I, l);
              }, realpath: e.maybeBind(P, P.realpath), getEnvironmentVariable: e.maybeBind(P, P.getEnvironmentVariable), trace: function(U) {
                return P.write(U + P.newLine);
              }, createDirectory: function(U) {
                return P.createDirectory(U);
              }, writeFile: function(U, j, H) {
                return P.writeFile(U, j, H);
              }, createHash: e.maybeBind(P, P.createHash), createProgram: k || e.createEmitAndSemanticDiagnosticsBuilderProgram, disableUseFileVersionAsSignature: P.disableUseFileVersionAsSignature, storeFilesChangingSignatureDuringEmit: P.storeFilesChangingSignatureDuringEmit };
            }
            e.createProgramHost = X;
            function $(P, k, Y, U) {
              P === void 0 && (P = e.sys);
              var j = function(I) {
                return P.write(I + P.newLine);
              }, H = X(P, k);
              return e.copyProperties(H, ee(P, U)), H.afterProgramCreate = function(I) {
                var l = I.getCompilerOptions(), d = e.getNewLineCharacter(l, function() {
                  return P.newLine;
                });
                O(I, Y, j, function(D) {
                  return H.onWatchStatusChange(e.createCompilerDiagnostic(m(D), D), d, l, D);
                });
              }, H;
            }
            function A(P, k, Y) {
              k(Y), P.exit(e.ExitStatus.DiagnosticsPresent_OutputsSkipped);
            }
            function y(P) {
              var k = P.configFileName, Y = P.optionsToExtend, U = P.watchOptionsToExtend, j = P.extraFileExtensions, H = P.system, I = P.createProgram, l = P.reportDiagnostic, d = P.reportWatchStatus, D = l || C(H), fe = $(H, I, D, d);
              return fe.onUnRecoverableConfigFileDiagnostic = function(g) {
                return A(H, D, g);
              }, fe.configFileName = k, fe.optionsToExtend = Y, fe.watchOptionsToExtend = U, fe.extraFileExtensions = j, fe;
            }
            e.createWatchCompilerHostOfConfigFile = y;
            function V(P) {
              var k = P.rootFiles, Y = P.options, U = P.watchOptions, j = P.projectReferences, H = P.system, I = P.createProgram, l = P.reportDiagnostic, d = P.reportWatchStatus, D = $(H, I, l || C(H), d);
              return D.rootFiles = k, D.options = Y, D.watchOptions = U, D.projectReferences = j, D;
            }
            e.createWatchCompilerHostOfFilesAndCompilerOptions = V;
            function L(P) {
              var k = P.system || e.sys, Y = P.host || (P.host = e.createIncrementalCompilerHost(P.options, k)), U = e.createIncrementalProgram(P), j = ve(U, P.reportDiagnostic || C(k), function(H) {
                return Y.trace && Y.trace(H);
              }, P.reportErrorSummary || P.options.pretty ? function(H, I) {
                return k.write(oe(H, I, k.newLine, Y));
              } : void 0);
              return P.afterProgramEmitAndDiagnostics && P.afterProgramEmitAndDiagnostics(U), j;
            }
            e.performIncrementalCompilation = L;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(Q, le) {
              if (!e.outFile(Q)) {
                var N = e.getTsBuildInfoEmitOutputFilePath(Q);
                if (!!N) {
                  var p = le.readFile(N);
                  if (!!p) {
                    var m = e.getBuildInfo(p);
                    if (m.version === e.version && !!m.program) return e.createBuildProgramUsingProgramBuildInfo(m.program, N, le);
                  }
                }
              }
            }
            e.readBuilderProgram = a;
            function C(Q, le) {
              le === void 0 && (le = e.sys);
              var N = e.createCompilerHostWorker(Q, void 0, le);
              return N.createHash = e.maybeBind(le, le.createHash), N.disableUseFileVersionAsSignature = le.disableUseFileVersionAsSignature, N.storeFilesChangingSignatureDuringEmit = le.storeFilesChangingSignatureDuringEmit, e.setGetSourceFileAsHashVersioned(N, le), e.changeCompilerHostLikeToUseCache(N, function(p) {
                return e.toPath(p, N.getCurrentDirectory(), N.getCanonicalFileName);
              }), N;
            }
            e.createIncrementalCompilerHost = C;
            function w(Q) {
              var le = Q.rootNames, N = Q.options, p = Q.configFileParsingDiagnostics, m = Q.projectReferences, G = Q.host, oe = Q.createProgram;
              G = G || C(N), oe = oe || e.createEmitAndSemanticDiagnosticsBuilderProgram;
              var f = a(N, G);
              return oe(le, N, G, f, p, m);
            }
            e.createIncrementalProgram = w;
            function B(Q, le, N, p, m, G, oe, f) {
              return e.isArray(Q) ? e.createWatchCompilerHostOfFilesAndCompilerOptions({ rootFiles: Q, options: le, watchOptions: f, projectReferences: oe, system: N, createProgram: p, reportDiagnostic: m, reportWatchStatus: G }) : e.createWatchCompilerHostOfConfigFile({ configFileName: Q, optionsToExtend: le, watchOptionsToExtend: oe, extraFileExtensions: f, system: N, createProgram: p, reportDiagnostic: m, reportWatchStatus: G });
            }
            e.createWatchCompilerHost = B;
            function E(Q) {
              var le, N, p, m, G, oe, f, T, K, b = Q.extendedConfigCache, se = false, J = false, ie = new e.Map(), R, q = false, O = Q.useCaseSensitiveFileNames(), ve = Q.getCurrentDirectory(), ee = Q.configFileName, he = Q.optionsToExtend, F = he === void 0 ? {} : he, x = Q.watchOptionsToExtend, X = Q.extraFileExtensions, $ = Q.createProgram, A = Q.rootFiles, y = Q.options, V = Q.watchOptions, L = Q.projectReferences, P, k, Y = false, U = false, j = ee === void 0 ? void 0 : e.createCachedDirectoryStructureHost(Q, ve, O), H = j || Q, I = e.parseConfigHostFromCompilerHostLike(Q, H), l = Ie();
              ee && Q.configFileParsingResult && (Ur(Q.configFileParsingResult), l = Ie()), Ye(e.Diagnostics.Starting_compilation_in_watch_mode), ee && !Q.configFileParsingResult && (l = e.getNewLineCharacter(F, function() {
                return Q.getNewLine();
              }), e.Debug.assert(!A), wr(), l = Ie());
              var d = e.createWatchFactory(Q, y), D = d.watchFile, fe = d.watchDirectory, g = d.writeLog, ne = e.createGetCanonicalFileName(O);
              g("Current directory: ".concat(ve, " CaseSensitiveFileNames: ").concat(O));
              var ue;
              ee && (ue = D(ee, be, e.PollingInterval.High, V, e.WatchType.ConfigFile));
              var We = e.createCompilerHostFromProgramHost(Q, function() {
                return y;
              }, H);
              e.setGetSourceFileAsHashVersioned(We, Q);
              var Fe = We.getSourceFile;
              We.getSourceFile = function(pi) {
                for (var ae = [], Xe = 1; Xe < arguments.length; Xe++) ae[Xe - 1] = arguments[Xe];
                return Ae.apply(void 0, Ve([pi, _e(pi)], ae, false));
              }, We.getSourceFileByPath = Ae, We.getNewLine = function() {
                return l;
              }, We.fileExists = ye, We.onReleaseOldSourceFile = Cr, We.onReleaseParsedCommandLine = pe, We.toPath = _e, We.getCompilationSettings = function() {
                return y;
              }, We.useSourceOfProjectReferenceRedirect = e.maybeBind(Q, Q.useSourceOfProjectReferenceRedirect), We.watchDirectoryOfFailedLookupLocation = function(pi, ae, Xe) {
                return fe(pi, ae, Xe, V, e.WatchType.FailedLookupLocations);
              }, We.watchTypeRootsDirectory = function(pi, ae, Xe) {
                return fe(pi, ae, Xe, V, e.WatchType.TypeRoots);
              }, We.getCachedDirectoryStructureHost = function() {
                return j;
              }, We.scheduleInvalidateResolutionsOfFailedLookupLocations = Ne, We.onInvalidatedResolution = lr, We.onChangedAutomaticTypeDirectiveNames = lr, We.fileIsOpen = e.returnFalse, We.getCurrentProgram = ze, We.writeLog = g, We.getParsedCommandLine = ii;
              var Z = e.createResolutionCache(We, ee ? e.getDirectoryPath(e.getNormalizedAbsolutePath(ee, ve)) : ve, false);
              We.resolveModuleNames = Q.resolveModuleNames ? function() {
                for (var pi = [], ae = 0; ae < arguments.length; ae++) pi[ae] = arguments[ae];
                return Q.resolveModuleNames.apply(Q, pi);
              } : function(pi, ae, Xe, Jr, ti, Ze) {
                return Z.resolveModuleNames(pi, ae, Xe, Jr, Ze);
              }, We.resolveTypeReferenceDirectives = Q.resolveTypeReferenceDirectives ? function() {
                for (var pi = [], ae = 0; ae < arguments.length; ae++) pi[ae] = arguments[ae];
                return Q.resolveTypeReferenceDirectives.apply(Q, pi);
              } : function(pi, ae, Xe, Jr, ti) {
                return Z.resolveTypeReferenceDirectives(pi, ae, Xe, ti);
              };
              var Be = !!Q.resolveModuleNames || !!Q.resolveTypeReferenceDirectives;
              return le = a(y, We), Ee(), Gi(), ee && Zt(_e(ee), y, V, e.WatchType.ExtendedConfigFile), ee ? { getCurrentProgram: Re, getProgram: ur, close: ge } : { getCurrentProgram: Re, getProgram: ur, updateRootFileNames: rr, close: ge };
              function ge() {
                Er(), Z.clear(), e.clearMap(ie, function(pi) {
                  pi && pi.fileWatcher && (pi.fileWatcher.close(), pi.fileWatcher = void 0);
                }), ue && (ue.close(), ue = void 0), b == null || b.clear(), b = void 0, K && (e.clearMap(K, e.closeFileWatcherOf), K = void 0), G && (e.clearMap(G, e.closeFileWatcherOf), G = void 0), p && (e.clearMap(p, e.closeFileWatcher), p = void 0), T && (e.clearMap(T, function(pi) {
                  var ae;
                  (ae = pi.watcher) === null || ae === void 0 || ae.close(), pi.watcher = void 0, pi.watchedDirectories && e.clearMap(pi.watchedDirectories, e.closeFileWatcherOf), pi.watchedDirectories = void 0;
                }), T = void 0), m && (e.clearMap(m, e.closeFileWatcher), m = void 0);
              }
              function Re() {
                return le;
              }
              function ze() {
                return le && le.getProgramOrUndefined();
              }
              function Ee() {
                g("Synchronizing program"), Er();
                var pi = Re();
                q && (l = Ie(), pi && (se || e.changesAffectModuleResolution(pi.getCompilerOptions(), y)) && Z.clear());
                var ae = Z.createHasInvalidatedResolution(Be || se);
                return e.isProgramUptoDate(ze(), A, y, ir, ye, ae, Br, ii, L) ? U && (J && Ye(e.Diagnostics.File_change_detected_Starting_incremental_compilation), le = $(void 0, void 0, We, le, k, L), U = false) : (J && Ye(e.Diagnostics.File_change_detected_Starting_incremental_compilation), He(ae)), se = false, J = false, Q.afterProgramCreate && pi !== le && Q.afterProgramCreate(le), le;
              }
              function He(pi) {
                g("CreatingProgramWith::"), g("  roots: ".concat(JSON.stringify(A))), g("  options: ".concat(JSON.stringify(y))), L && g("  projectReferences: ".concat(JSON.stringify(L)));
                var ae = q || !ze();
                q = false, U = false, Z.startCachingPerDirectoryResolution(), We.hasInvalidatedResolution = pi, We.hasChangedAutomaticTypeDirectiveNames = Br, le = $(A, y, We, le, k, L);
                var Xe = e.map(Z.getModuleResolutionCache().getPackageJsonInfoCache().entries(), function(Sr) {
                  var zr = Sr[0], Wr = Sr[1];
                  return [We.realpath ? _e(We.realpath(zr)) : zr, Wr];
                });
                if (Z.finishCachingPerDirectoryResolution(), e.updateMissingFilePathsWatch(le.getProgram(), p || (p = new e.Map()), Di), e.updatePackageJsonWatch(Xe, m || (m = new e.Map()), wi), ae && Z.updateTypeRootsWatch(), R) {
                  for (var Jr = 0, ti = R; Jr < ti.length; Jr++) {
                    var Ze = ti[Jr];
                    p.has(Ze) || ie.delete(Ze);
                  }
                  R = void 0;
                }
              }
              function rr(pi) {
                e.Debug.assert(!ee, "Cannot update root file names with config file watch mode"), A = pi, lr();
              }
              function Ie() {
                return e.getNewLineCharacter(y || F, function() {
                  return Q.getNewLine();
                });
              }
              function _e(pi) {
                return e.toPath(pi, ve, ne);
              }
              function we(pi) {
                return typeof pi == "boolean";
              }
              function de(pi) {
                return typeof pi.version == "boolean";
              }
              function ye(pi) {
                var ae = _e(pi);
                return we(ie.get(ae)) ? false : H.fileExists(pi);
              }
              function Ae(pi, ae, Xe, Jr, ti) {
                var Ze = ie.get(ae);
                if (!we(Ze)) {
                  if (Ze === void 0 || ti || de(Ze)) {
                    var Sr = Fe(pi, Xe, Jr);
                    if (Ze) Sr ? (Ze.sourceFile = Sr, Ze.version = Sr.version, Ze.fileWatcher || (Ze.fileWatcher = or(ae, pi, qr, e.PollingInterval.Low, V, e.WatchType.SourceFile))) : (Ze.fileWatcher && Ze.fileWatcher.close(), ie.set(ae, false));
                    else if (Sr) {
                      var zr = or(ae, pi, qr, e.PollingInterval.Low, V, e.WatchType.SourceFile);
                      ie.set(ae, { sourceFile: Sr, version: Sr.version, fileWatcher: zr });
                    } else ie.set(ae, false);
                    return Sr && (Sr.impliedNodeFormat = e.getImpliedNodeFormatForFile(ae, Z.getModuleResolutionCache().getPackageJsonInfoCache(), We, We.getCompilationSettings())), Sr;
                  }
                  return Ze.sourceFile;
                }
              }
              function er(pi) {
                var ae = ie.get(pi);
                ae !== void 0 && (we(ae) ? ie.set(pi, { version: false }) : ae.version = false);
              }
              function ir(pi) {
                var ae = ie.get(pi);
                return !ae || !ae.version ? void 0 : ae.version;
              }
              function Cr(pi, ae, Xe) {
                var Jr = ie.get(pi.resolvedPath);
                Jr !== void 0 && (we(Jr) ? (R || (R = [])).push(pi.path) : Jr.sourceFile === pi && (Jr.fileWatcher && Jr.fileWatcher.close(), ie.delete(pi.resolvedPath), Xe || Z.removeResolutionsOfFile(pi.path)));
              }
              function Ye(pi) {
                Q.onWatchStatusChange && Q.onWatchStatusChange(e.createCompilerDiagnostic(pi), l, y || F);
              }
              function Br() {
                return Z.hasChangedAutomaticTypeDirectiveNames();
              }
              function Er() {
                return f ? (Q.clearTimeout(f), f = void 0, true) : false;
              }
              function Ne() {
                if (!Q.setTimeout || !Q.clearTimeout) return Z.invalidateResolutionsOfFailedLookupLocations();
                var pi = Er();
                g("Scheduling invalidateFailedLookup".concat(pi ? ", Cancelled earlier one" : "")), f = Q.setTimeout(n, 250);
              }
              function n() {
                f = void 0, Z.invalidateResolutionsOfFailedLookupLocations() && lr();
              }
              function lr() {
                !Q.setTimeout || !Q.clearTimeout || (oe && Q.clearTimeout(oe), g("Scheduling update"), oe = Q.setTimeout(Ge, 250));
              }
              function be() {
                e.Debug.assert(!!ee), N = e.ConfigFileProgramReloadLevel.Full, lr();
              }
              function Ge() {
                oe = void 0, J = true, ur();
              }
              function ur() {
                switch (N) {
                  case e.ConfigFileProgramReloadLevel.Partial:
                    e.perfLogger.logStartUpdateProgram("PartialConfigReload"), yr();
                    break;
                  case e.ConfigFileProgramReloadLevel.Full:
                    e.perfLogger.logStartUpdateProgram("FullConfigReload"), Ir();
                    break;
                  default:
                    e.perfLogger.logStartUpdateProgram("SynchronizeProgram"), Ee();
                    break;
                }
                return e.perfLogger.logStopUpdateProgram("Done"), Re();
              }
              function yr() {
                g("Reloading new file names and options"), A = e.getFileNamesFromConfigSpecs(y.configFile.configFileSpecs, e.getNormalizedAbsolutePath(e.getDirectoryPath(ee), ve), y, I, X), e.updateErrorForNoInputFiles(A, e.getNormalizedAbsolutePath(ee, ve), y.configFile.configFileSpecs, k, Y) && (U = true), Ee();
              }
              function Ir() {
                g("Reloading config file: ".concat(ee)), N = e.ConfigFileProgramReloadLevel.None, j && j.clearCache(), wr(), q = true, Ee(), Gi(), Zt(_e(ee), y, V, e.WatchType.ExtendedConfigFile);
              }
              function wr() {
                Ur(e.getParsedCommandLineOfConfigFile(ee, F, I, b || (b = new e.Map()), x, X));
              }
              function Ur(pi) {
                A = pi.fileNames, y = pi.options, V = pi.watchOptions, L = pi.projectReferences, P = pi.wildcardDirectories, k = e.getConfigFileParsingDiagnostics(pi).slice(), Y = e.canJsonReportNoInputFiles(pi.raw), U = true;
              }
              function ii(pi) {
                var ae = _e(pi), Xe = T == null ? void 0 : T.get(ae);
                if (Xe) {
                  if (!Xe.reloadLevel) return Xe.parsedCommandLine;
                  if (Xe.parsedCommandLine && Xe.reloadLevel === e.ConfigFileProgramReloadLevel.Partial && !Q.getParsedCommandLine) {
                    g("Reloading new file names and options");
                    var Jr = e.getFileNamesFromConfigSpecs(Xe.parsedCommandLine.options.configFile.configFileSpecs, e.getNormalizedAbsolutePath(e.getDirectoryPath(pi), ve), y, I);
                    return Xe.parsedCommandLine = Ke(Ke({}, Xe.parsedCommandLine), { fileNames: Jr }), Xe.reloadLevel = void 0, Xe.parsedCommandLine;
                  }
                }
                g("Loading config file: ".concat(pi));
                var ti = Q.getParsedCommandLine ? Q.getParsedCommandLine(pi) : mi(pi);
                return Xe ? (Xe.parsedCommandLine = ti, Xe.reloadLevel = void 0) : (T || (T = new e.Map())).set(ae, Xe = { parsedCommandLine: ti }), _r(pi, ae, Xe), ti;
              }
              function mi(pi) {
                var ae = I.onUnRecoverableConfigFileDiagnostic;
                I.onUnRecoverableConfigFileDiagnostic = e.noop;
                var Xe = e.getParsedCommandLineOfConfigFile(pi, void 0, I, b || (b = new e.Map()), x);
                return I.onUnRecoverableConfigFileDiagnostic = ae, Xe;
              }
              function pe(pi) {
                var ae, Xe = _e(pi), Jr = T == null ? void 0 : T.get(Xe);
                !Jr || (T.delete(Xe), Jr.watchedDirectories && e.clearMap(Jr.watchedDirectories, e.closeFileWatcherOf), (ae = Jr.watcher) === null || ae === void 0 || ae.close(), e.clearSharedExtendedConfigFileWatcher(Xe, K));
              }
              function or(pi, ae, Xe, Jr, ti, Ze) {
                return D(ae, function(Sr, zr) {
                  return Xe(Sr, zr, pi);
                }, Jr, ti, Ze);
              }
              function qr(pi, ae, Xe) {
                si(pi, Xe, ae), ae === e.FileWatcherEventKind.Deleted && ie.has(Xe) && Z.invalidateResolutionOfFile(Xe), er(Xe), lr();
              }
              function si(pi, ae, Xe) {
                j && j.addOrDeleteFile(pi, ae, Xe);
              }
              function Di(pi) {
                return T != null && T.has(pi) ? e.noopFileWatcher : or(pi, pi, et, e.PollingInterval.Medium, V, e.WatchType.MissingFile);
              }
              function wi(pi) {
                return ie.has(pi) ? e.noopFileWatcher : or(pi, pi, Xi, e.PollingInterval.High, V, e.WatchType.PackageJson);
              }
              function Xi(pi, ae, Xe) {
                si(pi, Xe, ae), N = e.ConfigFileProgramReloadLevel.Full, se = true, lr();
              }
              function et(pi, ae, Xe) {
                si(pi, Xe, ae), ae === e.FileWatcherEventKind.Created && p.has(Xe) && (p.get(Xe).close(), p.delete(Xe), er(Xe), lr());
              }
              function Gi() {
                P ? e.updateWatchingWildcardDirectories(G || (G = new e.Map()), new e.Map(e.getEntries(P)), Wt) : G && e.clearMap(G, e.closeFileWatcherOf);
              }
              function Wt(pi, ae) {
                return fe(pi, function(Xe) {
                  e.Debug.assert(!!ee);
                  var Jr = _e(Xe);
                  j && j.addOrDeleteFileOrDirectory(Xe, Jr), er(Jr), !e.isIgnoredFileFromWildCardWatching({ watchedDirPath: _e(pi), fileOrDirectory: Xe, fileOrDirectoryPath: Jr, configFileName: ee, extraFileExtensions: X, options: y, program: Re() || A, currentDirectory: ve, useCaseSensitiveFileNames: O, writeLog: g, toPath: _e }) && N !== e.ConfigFileProgramReloadLevel.Full && (N = e.ConfigFileProgramReloadLevel.Partial, lr());
                }, ae, V, e.WatchType.WildcardDirectory);
              }
              function Zt(pi, ae, Xe, Jr) {
                e.updateSharedExtendedConfigFileWatcher(pi, ae, K || (K = new e.Map()), function(ti, Ze) {
                  return D(ti, function(Sr, zr) {
                    var Wr;
                    si(ti, Ze, zr), b && e.cleanExtendedConfigCache(b, Ze, _e);
                    var Je = (Wr = K.get(Ze)) === null || Wr === void 0 ? void 0 : Wr.projects;
                    !(Je != null && Je.size) || Je.forEach(function(xe) {
                      if (_e(ee) === xe) N = e.ConfigFileProgramReloadLevel.Full;
                      else {
                        var vr = T == null ? void 0 : T.get(xe);
                        vr && (vr.reloadLevel = e.ConfigFileProgramReloadLevel.Full), Z.removeResolutionsFromProjectReferenceRedirects(xe);
                      }
                      lr();
                    });
                  }, e.PollingInterval.High, Xe, Jr);
                }, _e);
              }
              function _r(pi, ae, Xe) {
                var Jr, ti, Ze, Sr, zr;
                Xe.watcher || (Xe.watcher = D(pi, function(Wr, Je) {
                  si(pi, ae, Je);
                  var xe = T == null ? void 0 : T.get(ae);
                  xe && (xe.reloadLevel = e.ConfigFileProgramReloadLevel.Full), Z.removeResolutionsFromProjectReferenceRedirects(ae), lr();
                }, e.PollingInterval.High, ((Jr = Xe.parsedCommandLine) === null || Jr === void 0 ? void 0 : Jr.watchOptions) || V, e.WatchType.ConfigFileOfReferencedProject)), !((ti = Xe.parsedCommandLine) === null || ti === void 0) && ti.wildcardDirectories ? e.updateWatchingWildcardDirectories(Xe.watchedDirectories || (Xe.watchedDirectories = new e.Map()), new e.Map(e.getEntries((Ze = Xe.parsedCommandLine) === null || Ze === void 0 ? void 0 : Ze.wildcardDirectories)), function(Wr, Je) {
                  var xe;
                  return fe(Wr, function(vr) {
                    var mr = _e(vr);
                    j && j.addOrDeleteFileOrDirectory(vr, mr), er(mr);
                    var Ar = T == null ? void 0 : T.get(ae);
                    !(Ar != null && Ar.parsedCommandLine) || e.isIgnoredFileFromWildCardWatching({ watchedDirPath: _e(Wr), fileOrDirectory: vr, fileOrDirectoryPath: mr, configFileName: pi, options: Ar.parsedCommandLine.options, program: Ar.parsedCommandLine.fileNames, currentDirectory: ve, useCaseSensitiveFileNames: O, writeLog: g, toPath: _e }) || Ar.reloadLevel !== e.ConfigFileProgramReloadLevel.Full && (Ar.reloadLevel = e.ConfigFileProgramReloadLevel.Partial, lr());
                  }, Je, ((xe = Xe.parsedCommandLine) === null || xe === void 0 ? void 0 : xe.watchOptions) || V, e.WatchType.WildcardDirectoryOfReferencedProject);
                }) : Xe.watchedDirectories && (e.clearMap(Xe.watchedDirectories, e.closeFileWatcherOf), Xe.watchedDirectories = void 0), Zt(ae, (Sr = Xe.parsedCommandLine) === null || Sr === void 0 ? void 0 : Sr.options, ((zr = Xe.parsedCommandLine) === null || zr === void 0 ? void 0 : zr.watchOptions) || V, e.WatchType.ExtendedConfigOfReferencedProject);
              }
            }
            e.createWatchProgram = E;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(w) {
              w[w.Unbuildable = 0] = "Unbuildable", w[w.UpToDate = 1] = "UpToDate", w[w.UpToDateWithUpstreamTypes = 2] = "UpToDateWithUpstreamTypes", w[w.OutOfDateWithPrepend = 3] = "OutOfDateWithPrepend", w[w.OutputMissing = 4] = "OutputMissing", w[w.OutOfDateWithSelf = 5] = "OutOfDateWithSelf", w[w.OutOfDateWithUpstream = 6] = "OutOfDateWithUpstream", w[w.UpstreamOutOfDate = 7] = "UpstreamOutOfDate", w[w.UpstreamBlocked = 8] = "UpstreamBlocked", w[w.ComputingUpstream = 9] = "ComputingUpstream", w[w.TsVersionOutputOfDate = 10] = "TsVersionOutputOfDate", w[w.ContainerOnly = 11] = "ContainerOnly";
            })(a = e.UpToDateStatusType || (e.UpToDateStatusType = {}));
            function C(w) {
              return e.fileExtensionIs(w, ".json") ? w : e.combinePaths(w, "tsconfig.json");
            }
            e.resolveConfigFileProjectName = C;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a = /* @__PURE__ */ new Date(-864e13), C = /* @__PURE__ */ new Date(864e13), w;
            (function(be) {
              be[be.None = 0] = "None", be[be.Success = 1] = "Success", be[be.DeclarationOutputUnchanged = 2] = "DeclarationOutputUnchanged", be[be.ConfigFileErrors = 4] = "ConfigFileErrors", be[be.SyntaxErrors = 8] = "SyntaxErrors", be[be.TypeErrors = 16] = "TypeErrors", be[be.DeclarationEmitErrors = 32] = "DeclarationEmitErrors", be[be.EmitErrors = 64] = "EmitErrors", be[be.AnyErrors = 124] = "AnyErrors";
            })(w || (w = {}));
            function B(be, Ge, ur) {
              var yr = be.get(Ge), Ir;
              return yr || (Ir = ur(), be.set(Ge, Ir)), yr || Ir;
            }
            function E(be, Ge) {
              return B(be, Ge, function() {
                return new e.Map();
              });
            }
            function Q(be, Ge) {
              return Ge > be ? Ge : be;
            }
            function le(be) {
              return !!be && !!be.buildOrder;
            }
            e.isCircularBuildOrder = le;
            function N(be) {
              return le(be) ? be.buildOrder : be;
            }
            e.getBuildOrderFromAnyBuildOrder = N;
            function p(be, Ge) {
              return function(ur) {
                var yr = Ge ? "[".concat(e.formatColorAndReset(e.getLocaleTimeString(be), e.ForegroundColorEscapeSequences.Grey), "] ") : "".concat(e.getLocaleTimeString(be), " - ");
                yr += "".concat(e.flattenDiagnosticMessageText(ur.messageText, be.newLine)).concat(be.newLine + be.newLine), be.write(yr);
              };
            }
            e.createBuilderStatusReporter = p;
            function m(be, Ge, ur, yr) {
              var Ir = e.createProgramHost(be, Ge);
              return Ir.getModifiedTime = be.getModifiedTime ? function(wr) {
                return be.getModifiedTime(wr);
              } : e.returnUndefined, Ir.setModifiedTime = be.setModifiedTime ? function(wr, Ur) {
                return be.setModifiedTime(wr, Ur);
              } : e.noop, Ir.deleteFile = be.deleteFile ? function(wr) {
                return be.deleteFile(wr);
              } : e.noop, Ir.reportDiagnostic = ur || e.createDiagnosticReporter(be), Ir.reportSolutionBuilderStatus = yr || p(be), Ir.now = e.maybeBind(be, be.now), Ir;
            }
            function G(be, Ge, ur, yr, Ir) {
              be === void 0 && (be = e.sys);
              var wr = m(be, Ge, ur, yr);
              return wr.reportErrorSummary = Ir, wr;
            }
            e.createSolutionBuilderHost = G;
            function oe(be, Ge, ur, yr, Ir) {
              be === void 0 && (be = e.sys);
              var wr = m(be, Ge, ur, yr), Ur = e.createWatchHost(be, Ir);
              return e.copyProperties(wr, Ur), wr;
            }
            e.createSolutionBuilderWithWatchHost = oe;
            function f(be) {
              var Ge = {};
              return e.commonOptionsWithBuild.forEach(function(ur) {
                e.hasProperty(be, ur.name) && (Ge[ur.name] = be[ur.name]);
              }), Ge;
            }
            function T(be, Ge, ur) {
              return ye(false, be, Ge, ur);
            }
            e.createSolutionBuilder = T;
            function K(be, Ge, ur, yr) {
              return ye(true, be, Ge, ur, yr);
            }
            e.createSolutionBuilderWithWatch = K;
            function b(be, Ge, ur, yr, Ir) {
              var wr = Ge, Ur = Ge, ii = wr.getCurrentDirectory(), mi = e.createGetCanonicalFileName(wr.useCaseSensitiveFileNames()), pe = f(yr), or = e.createCompilerHostFromProgramHost(wr, function() {
                return Zt.projectCompilerOptions;
              });
              e.setGetSourceFileAsHashVersioned(or, wr), or.getParsedCommandLine = function(_r) {
                return q(Zt, _r, J(Zt, _r));
              }, or.resolveModuleNames = e.maybeBind(wr, wr.resolveModuleNames), or.resolveTypeReferenceDirectives = e.maybeBind(wr, wr.resolveTypeReferenceDirectives);
              var qr = or.resolveModuleNames ? void 0 : e.createModuleResolutionCache(ii, mi), si = or.resolveTypeReferenceDirectives ? void 0 : e.createTypeReferenceDirectiveResolutionCache(ii, mi, void 0, qr == null ? void 0 : qr.getPackageJsonInfoCache());
              if (!or.resolveModuleNames) {
                var Di = function(_r, pi, ae, Xe) {
                  return e.resolveModuleName(_r, ae, Zt.projectCompilerOptions, or, qr, Xe, pi).resolvedModule;
                };
                or.resolveModuleNames = function(_r, pi, ae, Xe, Jr, ti) {
                  return e.loadWithModeAwareCache(e.Debug.checkEachDefined(_r), e.Debug.checkDefined(ti), pi, Xe, Di);
                }, or.getModuleResolutionCache = function() {
                  return qr;
                };
              }
              if (!or.resolveTypeReferenceDirectives) {
                var wi = function(_r, pi, ae, Xe) {
                  return e.resolveTypeReferenceDirective(_r, pi, Zt.projectCompilerOptions, or, ae, Zt.typeReferenceDirectiveResolutionCache, Xe).resolvedTypeReferenceDirective;
                };
                or.resolveTypeReferenceDirectives = function(_r, pi, ae, Xe, Jr) {
                  return e.loadWithTypeDirectiveCache(e.Debug.checkEachDefined(_r), pi, ae, Jr, wi);
                };
              }
              var Xi = e.createWatchFactory(Ur, yr), et = Xi.watchFile, Gi = Xi.watchDirectory, Wt = Xi.writeLog, Zt = { host: wr, hostWithWatch: Ur, currentDirectory: ii, getCanonicalFileName: mi, parseConfigFileHost: e.parseConfigHostFromCompilerHostLike(wr), write: e.maybeBind(wr, wr.trace), options: yr, baseCompilerOptions: pe, rootNames: ur, baseWatchOptions: Ir, resolvedConfigFilePaths: new e.Map(), configFileCache: new e.Map(), projectStatus: new e.Map(), buildInfoChecked: new e.Map(), extendedConfigCache: new e.Map(), builderPrograms: new e.Map(), diagnostics: new e.Map(), projectPendingBuild: new e.Map(), projectErrorsReported: new e.Map(), compilerHost: or, moduleResolutionCache: qr, typeReferenceDirectiveResolutionCache: si, buildOrder: void 0, readFileWithCache: function(_r) {
                return wr.readFile(_r);
              }, projectCompilerOptions: pe, cache: void 0, allProjectBuildPending: true, needsSummary: true, watchAllProjectsPending: be, currentInvalidatedProject: void 0, watch: be, allWatchedWildcardDirectories: new e.Map(), allWatchedInputFiles: new e.Map(), allWatchedConfigFiles: new e.Map(), allWatchedExtendedConfigFiles: new e.Map(), allWatchedPackageJsonFiles: new e.Map(), lastCachedPackageJsonLookups: new e.Map(), timerToBuildInvalidatedProject: void 0, reportFileChangeDetected: false, watchFile: et, watchDirectory: Gi, writeLog: Wt };
              return Zt;
            }
            function se(be, Ge) {
              return e.toPath(Ge, be.currentDirectory, be.getCanonicalFileName);
            }
            function J(be, Ge) {
              var ur = be.resolvedConfigFilePaths, yr = ur.get(Ge);
              if (yr !== void 0) return yr;
              var Ir = se(be, Ge);
              return ur.set(Ge, Ir), Ir;
            }
            function ie(be) {
              return !!be.options;
            }
            function R(be, Ge) {
              var ur = be.configFileCache.get(Ge);
              return ur && ie(ur) ? ur : void 0;
            }
            function q(be, Ge, ur) {
              var yr = be.configFileCache, Ir = yr.get(ur);
              if (Ir) return ie(Ir) ? Ir : void 0;
              var wr, Ur = be.parseConfigFileHost, ii = be.baseCompilerOptions, mi = be.baseWatchOptions, pe = be.extendedConfigCache, or = be.host, qr;
              return or.getParsedCommandLine ? (qr = or.getParsedCommandLine(Ge), qr || (wr = e.createCompilerDiagnostic(e.Diagnostics.File_0_not_found, Ge))) : (Ur.onUnRecoverableConfigFileDiagnostic = function(si) {
                return wr = si;
              }, qr = e.getParsedCommandLineOfConfigFile(Ge, ii, Ur, pe, mi), Ur.onUnRecoverableConfigFileDiagnostic = e.noop), yr.set(ur, qr || wr), qr;
            }
            function O(be, Ge) {
              return e.resolveConfigFileProjectName(e.resolvePath(be.currentDirectory, Ge));
            }
            function ve(be, Ge) {
              for (var ur = new e.Map(), yr = new e.Map(), Ir = [], wr, Ur, ii = 0, mi = Ge; ii < mi.length; ii++) {
                var pe = mi[ii];
                or(pe);
              }
              return Ur ? { buildOrder: wr || e.emptyArray, circularDiagnostics: Ur } : wr || e.emptyArray;
              function or(qr, si) {
                var Di = J(be, qr);
                if (!yr.has(Di)) {
                  if (ur.has(Di)) {
                    si || (Ur || (Ur = [])).push(e.createCompilerDiagnostic(e.Diagnostics.Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0, Ir.join(`\r
`)));
                    return;
                  }
                  ur.set(Di, true), Ir.push(qr);
                  var wi = q(be, qr, Di);
                  if (wi && wi.projectReferences) for (var Xi = 0, et = wi.projectReferences; Xi < et.length; Xi++) {
                    var Gi = et[Xi], Wt = O(be, Gi.path);
                    or(Wt, si || Gi.circular);
                  }
                  Ir.pop(), yr.set(Di, true), (wr || (wr = [])).push(qr);
                }
              }
            }
            function ee(be) {
              return be.buildOrder || he(be);
            }
            function he(be) {
              var Ge = ve(be, be.rootNames.map(function(Ir) {
                return O(be, Ir);
              }));
              be.resolvedConfigFilePaths.clear();
              var ur = new e.Map(N(Ge).map(function(Ir) {
                return [J(be, Ir), true];
              })), yr = { onDeleteValue: e.noop };
              return e.mutateMapSkippingNewValues(be.configFileCache, ur, yr), e.mutateMapSkippingNewValues(be.projectStatus, ur, yr), e.mutateMapSkippingNewValues(be.buildInfoChecked, ur, yr), e.mutateMapSkippingNewValues(be.builderPrograms, ur, yr), e.mutateMapSkippingNewValues(be.diagnostics, ur, yr), e.mutateMapSkippingNewValues(be.projectPendingBuild, ur, yr), e.mutateMapSkippingNewValues(be.projectErrorsReported, ur, yr), be.watch && (e.mutateMapSkippingNewValues(be.allWatchedConfigFiles, ur, { onDeleteValue: e.closeFileWatcher }), be.allWatchedExtendedConfigFiles.forEach(function(Ir) {
                Ir.projects.forEach(function(wr) {
                  ur.has(wr) || Ir.projects.delete(wr);
                }), Ir.close();
              }), e.mutateMapSkippingNewValues(be.allWatchedWildcardDirectories, ur, { onDeleteValue: function(Ir) {
                return Ir.forEach(e.closeFileWatcherOf);
              } }), e.mutateMapSkippingNewValues(be.allWatchedInputFiles, ur, { onDeleteValue: function(Ir) {
                return Ir.forEach(e.closeFileWatcher);
              } }), e.mutateMapSkippingNewValues(be.allWatchedPackageJsonFiles, ur, { onDeleteValue: function(Ir) {
                return Ir.forEach(e.closeFileWatcher);
              } })), be.buildOrder = Ge;
            }
            function F(be, Ge, ur) {
              var yr = Ge && O(be, Ge), Ir = ee(be);
              if (le(Ir)) return Ir;
              if (yr) {
                var wr = J(be, yr), Ur = e.findIndex(Ir, function(mi) {
                  return J(be, mi) === wr;
                });
                if (Ur === -1) return;
              }
              var ii = yr ? ve(be, [yr]) : Ir;
              return e.Debug.assert(!le(ii)), e.Debug.assert(!ur || yr !== void 0), e.Debug.assert(!ur || ii[ii.length - 1] === yr), ur ? ii.slice(0, ii.length - 1) : ii;
            }
            function x(be) {
              be.cache && X(be);
              var Ge = be.compilerHost, ur = be.host, yr = be.readFileWithCache, Ir = Ge.getSourceFile, wr = e.changeCompilerHostLikeToUseCache(ur, function(Di) {
                return se(be, Di);
              }, function() {
                for (var Di = [], wi = 0; wi < arguments.length; wi++) Di[wi] = arguments[wi];
                return Ir.call.apply(Ir, Ve([Ge], Di, false));
              }), Ur = wr.originalReadFile, ii = wr.originalFileExists, mi = wr.originalDirectoryExists, pe = wr.originalCreateDirectory, or = wr.originalWriteFile, qr = wr.getSourceFileWithCache, si = wr.readFileWithCache;
              be.readFileWithCache = si, Ge.getSourceFile = qr, be.cache = { originalReadFile: Ur, originalFileExists: ii, originalDirectoryExists: mi, originalCreateDirectory: pe, originalWriteFile: or, originalReadFileWithCache: yr, originalGetSourceFile: Ir };
            }
            function X(be) {
              if (!!be.cache) {
                var Ge = be.cache, ur = be.host, yr = be.compilerHost, Ir = be.extendedConfigCache, wr = be.moduleResolutionCache, Ur = be.typeReferenceDirectiveResolutionCache;
                ur.readFile = Ge.originalReadFile, ur.fileExists = Ge.originalFileExists, ur.directoryExists = Ge.originalDirectoryExists, ur.createDirectory = Ge.originalCreateDirectory, ur.writeFile = Ge.originalWriteFile, yr.getSourceFile = Ge.originalGetSourceFile, be.readFileWithCache = Ge.originalReadFileWithCache, Ir.clear(), wr == null || wr.clear(), Ur == null || Ur.clear(), be.cache = void 0;
              }
            }
            function $(be, Ge) {
              be.projectStatus.delete(Ge), be.diagnostics.delete(Ge);
            }
            function A(be, Ge, ur) {
              var yr = be.projectPendingBuild, Ir = yr.get(Ge);
              (Ir === void 0 || Ir < ur) && yr.set(Ge, ur);
            }
            function y(be, Ge) {
              if (!!be.allProjectBuildPending) {
                be.allProjectBuildPending = false, be.options.watch && ir(be, e.Diagnostics.Starting_compilation_in_watch_mode), x(be);
                var ur = N(ee(be));
                ur.forEach(function(yr) {
                  return be.projectPendingBuild.set(J(be, yr), e.ConfigFileProgramReloadLevel.None);
                }), Ge && Ge.throwIfCancellationRequested();
              }
            }
            var V;
            (function(be) {
              be[be.Build = 0] = "Build", be[be.UpdateBundle = 1] = "UpdateBundle", be[be.UpdateOutputFileStamps = 2] = "UpdateOutputFileStamps";
            })(V = e.InvalidatedProjectKind || (e.InvalidatedProjectKind = {}));
            function L(be, Ge) {
              return be.projectPendingBuild.delete(Ge), be.currentInvalidatedProject = void 0, be.diagnostics.has(Ge) ? e.ExitStatus.DiagnosticsPresent_OutputsSkipped : e.ExitStatus.Success;
            }
            function P(be, Ge, ur, yr, Ir) {
              var wr = true;
              return { kind: V.UpdateOutputFileStamps, project: Ge, projectPath: ur, buildOrder: Ir, getCompilerOptions: function() {
                return yr.options;
              }, getCurrentDirectory: function() {
                return be.currentDirectory;
              }, updateOutputFileStatmps: function() {
                ue(be, yr, ur), wr = false;
              }, done: function() {
                return wr && ue(be, yr, ur), L(be, ur);
              } };
            }
            var k;
            (function(be) {
              be[be.CreateProgram = 0] = "CreateProgram", be[be.SyntaxDiagnostics = 1] = "SyntaxDiagnostics", be[be.SemanticDiagnostics = 2] = "SemanticDiagnostics", be[be.Emit = 3] = "Emit", be[be.EmitBundle = 4] = "EmitBundle", be[be.EmitBuildInfo = 5] = "EmitBuildInfo", be[be.BuildInvalidatedProjectOfBundle = 6] = "BuildInvalidatedProjectOfBundle", be[be.QueueReferencingProjects = 7] = "QueueReferencingProjects", be[be.Done = 8] = "Done";
            })(k || (k = {}));
            function Y(be, Ge, ur, yr, Ir, wr, Ur) {
              var ii = be === V.Build ? k.CreateProgram : k.EmitBundle, mi, pe, or;
              return be === V.Build ? { kind: be, project: ur, projectPath: yr, buildOrder: Ur, getCompilerOptions: function() {
                return wr.options;
              }, getCurrentDirectory: function() {
                return Ge.currentDirectory;
              }, getBuilderProgram: function() {
                return si(e.identity);
              }, getProgram: function() {
                return si(function(Xe) {
                  return Xe.getProgramOrUndefined();
                });
              }, getSourceFile: function(Xe) {
                return si(function(Jr) {
                  return Jr.getSourceFile(Xe);
                });
              }, getSourceFiles: function() {
                return Di(function(Xe) {
                  return Xe.getSourceFiles();
                });
              }, getOptionsDiagnostics: function(Xe) {
                return Di(function(Jr) {
                  return Jr.getOptionsDiagnostics(Xe);
                });
              }, getGlobalDiagnostics: function(Xe) {
                return Di(function(Jr) {
                  return Jr.getGlobalDiagnostics(Xe);
                });
              }, getConfigFileParsingDiagnostics: function() {
                return Di(function(Xe) {
                  return Xe.getConfigFileParsingDiagnostics();
                });
              }, getSyntacticDiagnostics: function(Xe, Jr) {
                return Di(function(ti) {
                  return ti.getSyntacticDiagnostics(Xe, Jr);
                });
              }, getAllDependencies: function(Xe) {
                return Di(function(Jr) {
                  return Jr.getAllDependencies(Xe);
                });
              }, getSemanticDiagnostics: function(Xe, Jr) {
                return Di(function(ti) {
                  return ti.getSemanticDiagnostics(Xe, Jr);
                });
              }, getSemanticDiagnosticsOfNextAffectedFile: function(Xe, Jr) {
                return si(function(ti) {
                  return ti.getSemanticDiagnosticsOfNextAffectedFile && ti.getSemanticDiagnosticsOfNextAffectedFile(Xe, Jr);
                });
              }, emit: function(Xe, Jr, ti, Ze, Sr) {
                if (Xe || Ze) return si(function(zr) {
                  var Wr, Je;
                  return zr.emit(Xe, Jr, ti, Ze, Sr || ((Je = (Wr = Ge.host).getCustomTransformers) === null || Je === void 0 ? void 0 : Je.call(Wr, ur)));
                });
                if (ae(k.SemanticDiagnostics, ti), ii === k.EmitBuildInfo) return Zt(Jr, ti);
                if (ii === k.Emit) return Wt(Jr, ti, Sr);
              }, done: qr } : { kind: be, project: ur, projectPath: yr, buildOrder: Ur, getCompilerOptions: function() {
                return wr.options;
              }, getCurrentDirectory: function() {
                return Ge.currentDirectory;
              }, emit: function(Xe, Jr) {
                return ii !== k.EmitBundle ? or : pi(Xe, Jr);
              }, done: qr };
              function qr(Xe, Jr, ti) {
                return ae(k.Done, Xe, Jr, ti), L(Ge, yr);
              }
              function si(Xe) {
                return ae(k.CreateProgram), mi && Xe(mi);
              }
              function Di(Xe) {
                return si(Xe) || e.emptyArray;
              }
              function wi() {
                var Xe, Jr;
                if (e.Debug.assert(mi === void 0), Ge.options.dry) {
                  er(Ge, e.Diagnostics.A_non_dry_build_would_build_project_0, ur), pe = w.Success, ii = k.QueueReferencingProjects;
                  return;
                }
                if (Ge.options.verbose && er(Ge, e.Diagnostics.Building_project_0, ur), wr.fileNames.length === 0) {
                  Ye(Ge, yr, e.getConfigFileParsingDiagnostics(wr)), pe = w.None, ii = k.QueueReferencingProjects;
                  return;
                }
                var ti = Ge.host, Ze = Ge.compilerHost;
                Ge.projectCompilerOptions = wr.options, (Xe = Ge.moduleResolutionCache) === null || Xe === void 0 || Xe.update(wr.options), (Jr = Ge.typeReferenceDirectiveResolutionCache) === null || Jr === void 0 || Jr.update(wr.options), mi = ti.createProgram(wr.fileNames, wr.options, Ze, I(Ge, yr, wr), e.getConfigFileParsingDiagnostics(wr), wr.projectReferences), Ge.watch && (Ge.lastCachedPackageJsonLookups.set(yr, Ge.moduleResolutionCache && e.map(Ge.moduleResolutionCache.getPackageJsonInfoCache().entries(), function(Sr) {
                  var zr = Sr[0], Wr = Sr[1];
                  return [Ge.host.realpath && Wr ? se(Ge, Ge.host.realpath(zr)) : zr, Wr];
                })), Ge.builderPrograms.set(yr, mi)), ii++;
              }
              function Xi(Xe, Jr, ti) {
                var Ze;
                Xe.length ? (Ze = d(Ge, yr, mi, wr, Xe, Jr, ti), pe = Ze.buildResult, ii = Ze.step) : ii++;
              }
              function et(Xe) {
                e.Debug.assertIsDefined(mi), Xi(Ve(Ve(Ve(Ve([], mi.getConfigFileParsingDiagnostics(), true), mi.getOptionsDiagnostics(Xe), true), mi.getGlobalDiagnostics(Xe), true), mi.getSyntacticDiagnostics(void 0, Xe), true), w.SyntaxErrors, "Syntactic");
              }
              function Gi(Xe) {
                Xi(e.Debug.checkDefined(mi).getSemanticDiagnostics(void 0, Xe), w.TypeErrors, "Semantic");
              }
              function Wt(Xe, Jr, ti) {
                var Ze, Sr, zr;
                e.Debug.assertIsDefined(mi), e.Debug.assert(ii === k.Emit), mi.backupState();
                var Wr, Je = function(fr) {
                  return (Wr || (Wr = [])).push(fr);
                }, xe = [], vr = e.emitFilesAndReportErrors(mi, Je, void 0, void 0, function(fr, De, gr) {
                  return xe.push({ name: fr, text: De, writeByteOrderMark: gr });
                }, Jr, false, ti || ((zr = (Sr = Ge.host).getCustomTransformers) === null || zr === void 0 ? void 0 : zr.call(Sr, ur))).emitResult;
                if (Wr) return mi.restoreState(), Ze = d(Ge, yr, mi, wr, Wr, w.DeclarationEmitErrors, "Declaration file"), pe = Ze.buildResult, ii = Ze.step, { emitSkipped: true, diagnostics: vr.diagnostics };
                var mr = Ge.host, Ar = Ge.compilerHost, Oe = w.DeclarationOutputUnchanged, nr = a, Mr = false, Pe = e.createDiagnosticCollection(), Ue = new e.Map();
                return xe.forEach(function(fr) {
                  var De = fr.name, gr = fr.text, Vr = fr.writeByteOrderMark, Tr;
                  !Mr && e.isDeclarationFileName(De) && (mr.fileExists(De) && Ge.readFileWithCache(De) === gr ? Tr = mr.getModifiedTime(De) : (Oe &= ~w.DeclarationOutputUnchanged, Mr = true)), Ue.set(se(Ge, De), De), e.writeFile(Xe ? { writeFile: Xe } : Ar, Pe, De, gr, Vr), Tr !== void 0 && (nr = Q(Tr, nr));
                }), _r(Pe, Ue, nr, Mr, xe.length ? xe[0].name : e.getFirstProjectOutput(wr, !mr.useCaseSensitiveFileNames()), Oe), vr;
              }
              function Zt(Xe, Jr) {
                e.Debug.assertIsDefined(mi), e.Debug.assert(ii === k.EmitBuildInfo);
                var ti = mi.emitBuildInfo(Xe, Jr);
                return ti.diagnostics.length && (Cr(Ge, ti.diagnostics), Ge.diagnostics.set(yr, Ve(Ve([], Ge.diagnostics.get(yr), true), ti.diagnostics, true)), pe = w.EmitErrors & pe), ti.emittedFiles && Ge.write && ti.emittedFiles.forEach(function(Ze) {
                  return H(Ge, wr, Ze);
                }), l(Ge, mi, wr), ii = k.QueueReferencingProjects, ti;
              }
              function _r(Xe, Jr, ti, Ze, Sr, zr) {
                var Wr, Je = Xe.getDiagnostics();
                if (Je.length) return Wr = d(Ge, yr, mi, wr, Je, w.EmitErrors, "Emit"), pe = Wr.buildResult, ii = Wr.step, Je;
                Ge.write && Jr.forEach(function(vr) {
                  return H(Ge, wr, vr);
                });
                var xe = ne(Ge, wr, ti, e.Diagnostics.Updating_unchanged_output_timestamps_of_project_0, Jr);
                return Ge.diagnostics.delete(yr), Ge.projectStatus.set(yr, { type: e.UpToDateStatusType.UpToDate, newestDeclarationFileContentChangedTime: Ze ? C : xe, oldestOutputFileName: Sr }), l(Ge, mi, wr), ii = k.QueueReferencingProjects, pe = zr, Je;
              }
              function pi(Xe, Jr) {
                var ti, Ze;
                if (e.Debug.assert(be === V.UpdateBundle), Ge.options.dry) {
                  er(Ge, e.Diagnostics.A_non_dry_build_would_update_output_of_project_0, ur), pe = w.Success, ii = k.QueueReferencingProjects;
                  return;
                }
                Ge.options.verbose && er(Ge, e.Diagnostics.Updating_output_of_project_0, ur);
                var Sr = Ge.compilerHost;
                Ge.projectCompilerOptions = wr.options;
                var zr = e.emitUsingBuildInfo(wr, Sr, function(vr) {
                  var mr = O(Ge, vr.path);
                  return q(Ge, mr, J(Ge, mr));
                }, Jr || ((Ze = (ti = Ge.host).getCustomTransformers) === null || Ze === void 0 ? void 0 : Ze.call(ti, ur)));
                if (e.isString(zr)) return er(Ge, e.Diagnostics.Cannot_update_output_of_project_0_because_there_was_error_reading_file_1, ur, Ae(Ge, zr)), ii = k.BuildInvalidatedProjectOfBundle, or = Y(V.Build, Ge, ur, yr, Ir, wr, Ur);
                e.Debug.assert(!!zr.length);
                var Wr = e.createDiagnosticCollection(), Je = new e.Map();
                zr.forEach(function(vr) {
                  var mr = vr.name, Ar = vr.text, Oe = vr.writeByteOrderMark;
                  Je.set(se(Ge, mr), mr), e.writeFile(Xe ? { writeFile: Xe } : Sr, Wr, mr, Ar, Oe);
                });
                var xe = _r(Wr, Je, a, false, zr[0].name, w.DeclarationOutputUnchanged);
                return { emitSkipped: false, diagnostics: xe };
              }
              function ae(Xe, Jr, ti, Ze) {
                for (; ii <= Xe && ii < k.Done; ) {
                  var Sr = ii;
                  switch (ii) {
                    case k.CreateProgram:
                      wi();
                      break;
                    case k.SyntaxDiagnostics:
                      et(Jr);
                      break;
                    case k.SemanticDiagnostics:
                      Gi(Jr);
                      break;
                    case k.Emit:
                      Wt(ti, Jr, Ze);
                      break;
                    case k.EmitBuildInfo:
                      Zt(ti, Jr);
                      break;
                    case k.EmitBundle:
                      pi(ti, Ze);
                      break;
                    case k.BuildInvalidatedProjectOfBundle:
                      e.Debug.checkDefined(or).done(Jr, ti, Ze), ii = k.Done;
                      break;
                    case k.QueueReferencingProjects:
                      We(Ge, ur, yr, Ir, wr, Ur, e.Debug.checkDefined(pe)), ii++;
                      break;
                    case k.Done:
                    default:
                      e.assertType(ii);
                  }
                  e.Debug.assert(ii > Sr);
                }
              }
            }
            function U(be, Ge, ur) {
              var yr = be.options;
              return Ge.type !== e.UpToDateStatusType.OutOfDateWithPrepend || yr.force ? true : ur.fileNames.length === 0 || !!e.getConfigFileParsingDiagnostics(ur).length || !e.isIncrementalCompilation(ur.options);
            }
            function j(be, Ge, ur) {
              if (!!be.projectPendingBuild.size && !le(Ge)) {
                if (be.currentInvalidatedProject) return e.arrayIsEqualTo(be.currentInvalidatedProject.buildOrder, Ge) ? be.currentInvalidatedProject : void 0;
                for (var yr = be.options, Ir = be.projectPendingBuild, wr = 0; wr < Ge.length; wr++) {
                  var Ur = Ge[wr], ii = J(be, Ur), mi = be.projectPendingBuild.get(ii);
                  if (mi !== void 0) {
                    ur && (ur = false, Ne(be, Ge));
                    var pe = q(be, Ur, ii);
                    if (!pe) {
                      Br(be, ii), Ir.delete(ii);
                      continue;
                    }
                    mi === e.ConfigFileProgramReloadLevel.Full ? (Ee(be, Ur, ii, pe), He(be, ii, pe), rr(be, Ur, ii, pe), Ie(be, Ur, ii, pe), _e(be, Ur, ii, pe)) : mi === e.ConfigFileProgramReloadLevel.Partial && (pe.fileNames = e.getFileNamesFromConfigSpecs(pe.options.configFile.configFileSpecs, e.getDirectoryPath(Ur), pe.options, be.parseConfigFileHost), e.updateErrorForNoInputFiles(pe.fileNames, Ur, pe.options.configFile.configFileSpecs, pe.errors, e.canJsonReportNoInputFiles(pe.raw)), Ie(be, Ur, ii, pe), _e(be, Ur, ii, pe));
                    var or = g(be, pe, ii);
                    if (lr(be, Ur, or), !yr.force) {
                      if (or.type === e.UpToDateStatusType.UpToDate) {
                        Ye(be, ii, e.getConfigFileParsingDiagnostics(pe)), Ir.delete(ii), yr.dry && er(be, e.Diagnostics.Project_0_is_up_to_date, Ur);
                        continue;
                      }
                      if (or.type === e.UpToDateStatusType.UpToDateWithUpstreamTypes) return Ye(be, ii, e.getConfigFileParsingDiagnostics(pe)), P(be, Ur, ii, pe, Ge);
                    }
                    if (or.type === e.UpToDateStatusType.UpstreamBlocked) {
                      Ye(be, ii, e.getConfigFileParsingDiagnostics(pe)), Ir.delete(ii), yr.verbose && er(be, or.upstreamProjectBlocked ? e.Diagnostics.Skipping_build_of_project_0_because_its_dependency_1_was_not_built : e.Diagnostics.Skipping_build_of_project_0_because_its_dependency_1_has_errors, Ur, or.upstreamProjectName);
                      continue;
                    }
                    if (or.type === e.UpToDateStatusType.ContainerOnly) {
                      Ye(be, ii, e.getConfigFileParsingDiagnostics(pe)), Ir.delete(ii);
                      continue;
                    }
                    return Y(U(be, or, pe) ? V.Build : V.UpdateBundle, be, Ur, ii, wr, pe, Ge);
                  }
                }
              }
            }
            function H(be, Ge, ur) {
              var yr = be.write;
              yr && Ge.options.listEmittedFiles && yr("TSFILE: ".concat(ur));
            }
            function I(be, Ge, ur) {
              var yr = be.options, Ir = be.builderPrograms, wr = be.compilerHost;
              if (!yr.force) {
                var Ur = Ir.get(Ge);
                return Ur || e.readBuilderProgram(ur.options, wr);
              }
            }
            function l(be, Ge, ur) {
              Ge ? (Ge && be.write && e.listFiles(Ge, be.write), be.host.afterProgramEmitAndDiagnostics && be.host.afterProgramEmitAndDiagnostics(Ge), Ge.releaseProgram()) : be.host.afterEmitBundle && be.host.afterEmitBundle(ur), be.projectCompilerOptions = be.baseCompilerOptions;
            }
            function d(be, Ge, ur, yr, Ir, wr, Ur) {
              var ii = !(wr & w.SyntaxErrors) && ur && !e.outFile(ur.getCompilerOptions());
              return Ye(be, Ge, Ir), be.projectStatus.set(Ge, { type: e.UpToDateStatusType.Unbuildable, reason: "".concat(Ur, " errors") }), ii ? { buildResult: wr, step: k.EmitBuildInfo } : (l(be, ur, yr), { buildResult: wr, step: k.QueueReferencingProjects });
            }
            function D(be, Ge, ur, yr) {
              var Ir = e.getModifiedTime(be.host, Ge);
              if (ur < Ir) return { type: e.UpToDateStatusType.OutOfDateWithSelf, outOfDateOutputFileName: yr, newerInputFileName: Ge };
            }
            function fe(be, Ge, ur) {
              for (var yr = !!be.options.force, Ir = void 0, wr = a, Ur = be.host, ii = 0, mi = Ge.fileNames; ii < mi.length; ii++) {
                var pe = mi[ii];
                if (!Ur.fileExists(pe)) return { type: e.UpToDateStatusType.Unbuildable, reason: "".concat(pe, " does not exist") };
                if (!yr) {
                  var or = e.getModifiedTime(Ur, pe);
                  or > wr && (Ir = pe, wr = or);
                }
              }
              if (!Ge.fileNames.length && !e.canJsonReportNoInputFiles(Ge.raw)) return { type: e.UpToDateStatusType.ContainerOnly };
              var qr = e.getAllProjectOutputs(Ge, !Ur.useCaseSensitiveFileNames()), si = "(none)", Di = C, wi = "(none)", Xi = a, et, Gi = a, Wt = false;
              if (!yr) for (var Zt = 0, _r = qr; Zt < _r.length; Zt++) {
                var pi = _r[Zt];
                if (!Ur.fileExists(pi)) {
                  et = pi;
                  break;
                }
                var ae = e.getModifiedTime(Ur, pi);
                if (ae < Di && (Di = ae, si = pi), ae < wr) {
                  Wt = true;
                  break;
                }
                if (ae > Xi && (Xi = ae, wi = pi), e.isDeclarationFileName(pi)) {
                  var Xe = e.getModifiedTime(Ur, pi);
                  Gi = Q(Gi, Xe);
                }
              }
              var Jr = false, ti = false, Ze;
              if (Ge.projectReferences) {
                be.projectStatus.set(ur, { type: e.UpToDateStatusType.ComputingUpstream });
                for (var Sr = 0, zr = Ge.projectReferences; Sr < zr.length; Sr++) {
                  var Wr = zr[Sr];
                  ti = ti || !!Wr.prepend;
                  var Je = e.resolveProjectReferencePath(Wr), xe = J(be, Je), vr = g(be, q(be, Je, xe), xe);
                  if (!(vr.type === e.UpToDateStatusType.ComputingUpstream || vr.type === e.UpToDateStatusType.ContainerOnly)) {
                    if (vr.type === e.UpToDateStatusType.Unbuildable || vr.type === e.UpToDateStatusType.UpstreamBlocked) return { type: e.UpToDateStatusType.UpstreamBlocked, upstreamProjectName: Wr.path, upstreamProjectBlocked: vr.type === e.UpToDateStatusType.UpstreamBlocked };
                    if (vr.type !== e.UpToDateStatusType.UpToDate) return { type: e.UpToDateStatusType.UpstreamOutOfDate, upstreamProjectName: Wr.path };
                    if (!yr && !et) {
                      if (vr.newestInputFileTime && vr.newestInputFileTime <= Di) continue;
                      if (vr.newestDeclarationFileContentChangedTime && vr.newestDeclarationFileContentChangedTime <= Di) {
                        Jr = true, Ze = Wr.path;
                        continue;
                      }
                      return e.Debug.assert(si !== void 0, "Should have an oldest output filename here"), { type: e.UpToDateStatusType.OutOfDateWithUpstream, outOfDateOutputFileName: si, newerProjectName: Wr.path };
                    }
                  }
                }
              }
              if (et !== void 0) return { type: e.UpToDateStatusType.OutputMissing, missingOutputFileName: et };
              if (Wt) return { type: e.UpToDateStatusType.OutOfDateWithSelf, outOfDateOutputFileName: si, newerInputFileName: Ir };
              var mr = D(be, Ge.options.configFilePath, Di, si);
              if (mr) return mr;
              var Ar = e.forEach(Ge.options.configFile.extendedSourceFiles || e.emptyArray, function(Ue) {
                return D(be, Ue, Di, si);
              });
              if (Ar) return Ar;
              var Oe = e.forEach(be.lastCachedPackageJsonLookups.get(ur) || e.emptyArray, function(Ue) {
                var fr = Ue[0];
                return D(be, fr, Di, si);
              });
              if (Oe) return Oe;
              if (!yr && !be.buildInfoChecked.has(ur)) {
                be.buildInfoChecked.set(ur, true);
                var nr = e.getTsBuildInfoEmitOutputFilePath(Ge.options);
                if (nr) {
                  var Mr = be.readFileWithCache(nr), Pe = Mr && e.getBuildInfo(Mr);
                  if (Pe && (Pe.bundle || Pe.program) && Pe.version !== e.version) return { type: e.UpToDateStatusType.TsVersionOutputOfDate, version: Pe.version };
                }
              }
              return ti && Jr ? { type: e.UpToDateStatusType.OutOfDateWithPrepend, outOfDateOutputFileName: si, newerProjectName: Ze } : { type: Jr ? e.UpToDateStatusType.UpToDateWithUpstreamTypes : e.UpToDateStatusType.UpToDate, newestDeclarationFileContentChangedTime: Gi, newestInputFileTime: wr, newestOutputFileTime: Xi, newestInputFileName: Ir, newestOutputFileName: wi, oldestOutputFileName: si };
            }
            function g(be, Ge, ur) {
              if (Ge === void 0) return { type: e.UpToDateStatusType.Unbuildable, reason: "File deleted mid-build" };
              var yr = be.projectStatus.get(ur);
              if (yr !== void 0) return yr;
              var Ir = fe(be, Ge, ur);
              return be.projectStatus.set(ur, Ir), Ir;
            }
            function ne(be, Ge, ur, yr, Ir) {
              if (Ge.options.noEmit) return ur;
              var wr = be.host, Ur = e.getAllProjectOutputs(Ge, !wr.useCaseSensitiveFileNames());
              if (!Ir || Ur.length !== Ir.size) for (var ii = !!be.options.verbose, mi = wr.now ? wr.now() : /* @__PURE__ */ new Date(), pe = 0, or = Ur; pe < or.length; pe++) {
                var qr = or[pe];
                Ir && Ir.has(se(be, qr)) || (ii && (ii = false, er(be, yr, Ge.options.configFilePath)), e.isDeclarationFileName(qr) && (ur = Q(ur, e.getModifiedTime(wr, qr))), wr.setModifiedTime(qr, mi));
              }
              return ur;
            }
            function ue(be, Ge, ur) {
              if (be.options.dry) return er(be, e.Diagnostics.A_non_dry_build_would_update_timestamps_for_output_of_project_0, Ge.options.configFilePath);
              var yr = ne(be, Ge, a, e.Diagnostics.Updating_output_timestamps_of_project_0);
              be.projectStatus.set(ur, { type: e.UpToDateStatusType.UpToDate, newestDeclarationFileContentChangedTime: yr, oldestOutputFileName: e.getFirstProjectOutput(Ge, !be.host.useCaseSensitiveFileNames()) });
            }
            function We(be, Ge, ur, yr, Ir, wr, Ur) {
              if (!(Ur & w.AnyErrors) && !!Ir.options.composite) for (var ii = yr + 1; ii < wr.length; ii++) {
                var mi = wr[ii], pe = J(be, mi);
                if (!be.projectPendingBuild.has(pe)) {
                  var or = q(be, mi, pe);
                  if (!(!or || !or.projectReferences)) for (var qr = 0, si = or.projectReferences; qr < si.length; qr++) {
                    var Di = si[qr], wi = O(be, Di.path);
                    if (J(be, wi) === ur) {
                      var Xi = be.projectStatus.get(pe);
                      if (Xi) switch (Xi.type) {
                        case e.UpToDateStatusType.UpToDate:
                          if (Ur & w.DeclarationOutputUnchanged) {
                            Di.prepend ? be.projectStatus.set(pe, { type: e.UpToDateStatusType.OutOfDateWithPrepend, outOfDateOutputFileName: Xi.oldestOutputFileName, newerProjectName: Ge }) : Xi.type = e.UpToDateStatusType.UpToDateWithUpstreamTypes;
                            break;
                          }
                        case e.UpToDateStatusType.UpToDateWithUpstreamTypes:
                        case e.UpToDateStatusType.OutOfDateWithPrepend:
                          Ur & w.DeclarationOutputUnchanged || be.projectStatus.set(pe, { type: e.UpToDateStatusType.OutOfDateWithUpstream, outOfDateOutputFileName: Xi.type === e.UpToDateStatusType.OutOfDateWithPrepend ? Xi.outOfDateOutputFileName : Xi.oldestOutputFileName, newerProjectName: Ge });
                          break;
                        case e.UpToDateStatusType.UpstreamBlocked:
                          J(be, O(be, Xi.upstreamProjectName)) === ur && $(be, pe);
                          break;
                      }
                      A(be, pe, e.ConfigFileProgramReloadLevel.None);
                      break;
                    }
                  }
                }
              }
            }
            function Fe(be, Ge, ur, yr, Ir, wr) {
              var Ur = F(be, Ge, wr);
              if (!Ur) return e.ExitStatus.InvalidProject_OutputsSkipped;
              y(be, ur);
              for (var ii = true, mi = 0; ; ) {
                var pe = j(be, Ur, ii);
                if (!pe) break;
                ii = false, pe.done(ur, yr, Ir == null ? void 0 : Ir(pe.project)), be.diagnostics.has(pe.projectPath) || mi++;
              }
              return X(be), Er(be, Ur), we(be, Ur), le(Ur) ? e.ExitStatus.ProjectReferenceCycle_OutputsSkipped : Ur.some(function(or) {
                return be.diagnostics.has(J(be, or));
              }) ? mi ? e.ExitStatus.DiagnosticsPresent_OutputsGenerated : e.ExitStatus.DiagnosticsPresent_OutputsSkipped : e.ExitStatus.Success;
            }
            function Z(be, Ge, ur) {
              var yr = F(be, Ge, ur);
              if (!yr) return e.ExitStatus.InvalidProject_OutputsSkipped;
              if (le(yr)) return Cr(be, yr.circularDiagnostics), e.ExitStatus.ProjectReferenceCycle_OutputsSkipped;
              for (var Ir = be.options, wr = be.host, Ur = Ir.dry ? [] : void 0, ii = 0, mi = yr; ii < mi.length; ii++) {
                var pe = mi[ii], or = J(be, pe), qr = q(be, pe, or);
                if (qr === void 0) {
                  Br(be, or);
                  continue;
                }
                var si = e.getAllProjectOutputs(qr, !wr.useCaseSensitiveFileNames());
                if (!!si.length) for (var Di = new e.Set(qr.fileNames.map(function(Gi) {
                  return se(be, Gi);
                })), wi = 0, Xi = si; wi < Xi.length; wi++) {
                  var et = Xi[wi];
                  Di.has(se(be, et)) || wr.fileExists(et) && (Ur ? Ur.push(et) : (wr.deleteFile(et), Be(be, or, e.ConfigFileProgramReloadLevel.None)));
                }
              }
              return Ur && er(be, e.Diagnostics.A_non_dry_build_would_delete_the_following_files_Colon_0, Ur.map(function(Gi) {
                return `\r
 * `.concat(Gi);
              }).join("")), e.ExitStatus.Success;
            }
            function Be(be, Ge, ur) {
              be.host.getParsedCommandLine && ur === e.ConfigFileProgramReloadLevel.Partial && (ur = e.ConfigFileProgramReloadLevel.Full), ur === e.ConfigFileProgramReloadLevel.Full && (be.configFileCache.delete(Ge), be.buildOrder = void 0), be.needsSummary = true, $(be, Ge), A(be, Ge, ur), x(be);
            }
            function ge(be, Ge, ur) {
              be.reportFileChangeDetected = true, Be(be, Ge, ur), Re(be);
            }
            function Re(be) {
              var Ge = be.hostWithWatch;
              !Ge.setTimeout || !Ge.clearTimeout || (be.timerToBuildInvalidatedProject && Ge.clearTimeout(be.timerToBuildInvalidatedProject), be.timerToBuildInvalidatedProject = Ge.setTimeout(ze, 250, be));
            }
            function ze(be) {
              be.timerToBuildInvalidatedProject = void 0, be.reportFileChangeDetected && (be.reportFileChangeDetected = false, be.projectErrorsReported.clear(), ir(be, e.Diagnostics.File_change_detected_Starting_incremental_compilation));
              var Ge = ee(be), ur = j(be, Ge, false);
              if (ur && (ur.done(), be.projectPendingBuild.size)) {
                be.watch && !be.timerToBuildInvalidatedProject && Re(be);
                return;
              }
              X(be), Er(be, Ge);
            }
            function Ee(be, Ge, ur, yr) {
              !be.watch || be.allWatchedConfigFiles.has(ur) || be.allWatchedConfigFiles.set(ur, be.watchFile(Ge, function() {
                ge(be, ur, e.ConfigFileProgramReloadLevel.Full);
              }, e.PollingInterval.High, yr == null ? void 0 : yr.watchOptions, e.WatchType.ConfigFile, Ge));
            }
            function He(be, Ge, ur) {
              e.updateSharedExtendedConfigFileWatcher(Ge, ur == null ? void 0 : ur.options, be.allWatchedExtendedConfigFiles, function(yr, Ir) {
                return be.watchFile(yr, function() {
                  var wr;
                  return (wr = be.allWatchedExtendedConfigFiles.get(Ir)) === null || wr === void 0 ? void 0 : wr.projects.forEach(function(Ur) {
                    return ge(be, Ur, e.ConfigFileProgramReloadLevel.Full);
                  });
                }, e.PollingInterval.High, ur == null ? void 0 : ur.watchOptions, e.WatchType.ExtendedConfigFile);
              }, function(yr) {
                return se(be, yr);
              });
            }
            function rr(be, Ge, ur, yr) {
              !be.watch || e.updateWatchingWildcardDirectories(E(be.allWatchedWildcardDirectories, ur), new e.Map(e.getEntries(yr.wildcardDirectories)), function(Ir, wr) {
                return be.watchDirectory(Ir, function(Ur) {
                  var ii;
                  e.isIgnoredFileFromWildCardWatching({ watchedDirPath: se(be, Ir), fileOrDirectory: Ur, fileOrDirectoryPath: se(be, Ur), configFileName: Ge, currentDirectory: be.currentDirectory, options: yr.options, program: be.builderPrograms.get(ur) || ((ii = R(be, ur)) === null || ii === void 0 ? void 0 : ii.fileNames), useCaseSensitiveFileNames: be.parseConfigFileHost.useCaseSensitiveFileNames, writeLog: function(mi) {
                    return be.writeLog(mi);
                  }, toPath: function(mi) {
                    return se(be, mi);
                  } }) || ge(be, ur, e.ConfigFileProgramReloadLevel.Partial);
                }, wr, yr == null ? void 0 : yr.watchOptions, e.WatchType.WildcardDirectory, Ge);
              });
            }
            function Ie(be, Ge, ur, yr) {
              !be.watch || e.mutateMap(E(be.allWatchedInputFiles, ur), e.arrayToMap(yr.fileNames, function(Ir) {
                return se(be, Ir);
              }), { createNewValue: function(Ir, wr) {
                return be.watchFile(wr, function() {
                  return ge(be, ur, e.ConfigFileProgramReloadLevel.None);
                }, e.PollingInterval.Low, yr == null ? void 0 : yr.watchOptions, e.WatchType.SourceFile, Ge);
              }, onDeleteValue: e.closeFileWatcher });
            }
            function _e(be, Ge, ur, yr) {
              !be.watch || !be.lastCachedPackageJsonLookups || e.mutateMap(E(be.allWatchedPackageJsonFiles, ur), new e.Map(be.lastCachedPackageJsonLookups.get(ur)), { createNewValue: function(Ir, wr) {
                return be.watchFile(Ir, function() {
                  return ge(be, ur, e.ConfigFileProgramReloadLevel.None);
                }, e.PollingInterval.High, yr == null ? void 0 : yr.watchOptions, e.WatchType.PackageJson, Ge);
              }, onDeleteValue: e.closeFileWatcher });
            }
            function we(be, Ge) {
              if (!!be.watchAllProjectsPending) {
                be.watchAllProjectsPending = false;
                for (var ur = 0, yr = N(Ge); ur < yr.length; ur++) {
                  var Ir = yr[ur], wr = J(be, Ir), Ur = q(be, Ir, wr);
                  Ee(be, Ir, wr, Ur), He(be, wr, Ur), Ur && (rr(be, Ir, wr, Ur), Ie(be, Ir, wr, Ur), _e(be, Ir, wr, Ur));
                }
              }
            }
            function de(be) {
              e.clearMap(be.allWatchedConfigFiles, e.closeFileWatcher), e.clearMap(be.allWatchedExtendedConfigFiles, e.closeFileWatcherOf), e.clearMap(be.allWatchedWildcardDirectories, function(Ge) {
                return e.clearMap(Ge, e.closeFileWatcherOf);
              }), e.clearMap(be.allWatchedInputFiles, function(Ge) {
                return e.clearMap(Ge, e.closeFileWatcher);
              }), e.clearMap(be.allWatchedPackageJsonFiles, function(Ge) {
                return e.clearMap(Ge, e.closeFileWatcher);
              });
            }
            function ye(be, Ge, ur, yr, Ir) {
              var wr = b(be, Ge, ur, yr, Ir);
              return { build: function(Ur, ii, mi, pe) {
                return Fe(wr, Ur, ii, mi, pe);
              }, clean: function(Ur) {
                return Z(wr, Ur);
              }, buildReferences: function(Ur, ii, mi, pe) {
                return Fe(wr, Ur, ii, mi, pe, true);
              }, cleanReferences: function(Ur) {
                return Z(wr, Ur, true);
              }, getNextInvalidatedProject: function(Ur) {
                return y(wr, Ur), j(wr, ee(wr), false);
              }, getBuildOrder: function() {
                return ee(wr);
              }, getUpToDateStatusOfProject: function(Ur) {
                var ii = O(wr, Ur), mi = J(wr, ii);
                return g(wr, q(wr, ii, mi), mi);
              }, invalidateProject: function(Ur, ii) {
                return Be(wr, Ur, ii || e.ConfigFileProgramReloadLevel.None);
              }, buildNextInvalidatedProject: function() {
                return ze(wr);
              }, getAllParsedConfigs: function() {
                return e.arrayFrom(e.mapDefinedIterator(wr.configFileCache.values(), function(Ur) {
                  return ie(Ur) ? Ur : void 0;
                }));
              }, close: function() {
                return de(wr);
              } };
            }
            function Ae(be, Ge) {
              return e.convertToRelativePath(Ge, be.currentDirectory, function(ur) {
                return be.getCanonicalFileName(ur);
              });
            }
            function er(be, Ge) {
              for (var ur = [], yr = 2; yr < arguments.length; yr++) ur[yr - 2] = arguments[yr];
              be.host.reportSolutionBuilderStatus(e.createCompilerDiagnostic.apply(void 0, Ve([Ge], ur, false)));
            }
            function ir(be, Ge) {
              for (var ur, yr, Ir = [], wr = 2; wr < arguments.length; wr++) Ir[wr - 2] = arguments[wr];
              (yr = (ur = be.hostWithWatch).onWatchStatusChange) === null || yr === void 0 || yr.call(ur, e.createCompilerDiagnostic.apply(void 0, Ve([Ge], Ir, false)), be.host.getNewLine(), be.baseCompilerOptions);
            }
            function Cr(be, Ge) {
              var ur = be.host;
              Ge.forEach(function(yr) {
                return ur.reportDiagnostic(yr);
              });
            }
            function Ye(be, Ge, ur) {
              Cr(be, ur), be.projectErrorsReported.set(Ge, true), ur.length && be.diagnostics.set(Ge, ur);
            }
            function Br(be, Ge) {
              Ye(be, Ge, [be.configFileCache.get(Ge)]);
            }
            function Er(be, Ge) {
              if (!!be.needsSummary) {
                be.needsSummary = false;
                var ur = be.watch || !!be.host.reportErrorSummary, yr = be.diagnostics, Ir = 0, wr = [];
                le(Ge) ? (Ne(be, Ge.buildOrder), Cr(be, Ge.circularDiagnostics), ur && (Ir += e.getErrorCountForSummary(Ge.circularDiagnostics)), ur && (wr = Ve(Ve([], wr, true), e.getFilesInErrorForSummary(Ge.circularDiagnostics), true))) : (Ge.forEach(function(Ur) {
                  var ii = J(be, Ur);
                  be.projectErrorsReported.has(ii) || Cr(be, yr.get(ii) || e.emptyArray);
                }), ur && yr.forEach(function(Ur) {
                  return Ir += e.getErrorCountForSummary(Ur);
                }), ur && yr.forEach(function(Ur) {
                  return Ve(Ve([], wr, true), e.getFilesInErrorForSummary(Ur), true);
                })), be.watch ? ir(be, e.getWatchErrorSummaryDiagnosticMessage(Ir), Ir) : be.host.reportErrorSummary && be.host.reportErrorSummary(Ir, wr);
              }
            }
            function Ne(be, Ge) {
              be.options.verbose && er(be, e.Diagnostics.Projects_in_this_build_Colon_0, Ge.map(function(ur) {
                return `\r
    * ` + Ae(be, ur);
              }).join(""));
            }
            function n(be, Ge, ur) {
              if (be.options.force && (ur.type === e.UpToDateStatusType.UpToDate || ur.type === e.UpToDateStatusType.UpToDateWithUpstreamTypes)) return er(be, e.Diagnostics.Project_0_is_being_forcibly_rebuilt, Ae(be, Ge));
              switch (ur.type) {
                case e.UpToDateStatusType.OutOfDateWithSelf:
                  return er(be, e.Diagnostics.Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2, Ae(be, Ge), Ae(be, ur.outOfDateOutputFileName), Ae(be, ur.newerInputFileName));
                case e.UpToDateStatusType.OutOfDateWithUpstream:
                  return er(be, e.Diagnostics.Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2, Ae(be, Ge), Ae(be, ur.outOfDateOutputFileName), Ae(be, ur.newerProjectName));
                case e.UpToDateStatusType.OutputMissing:
                  return er(be, e.Diagnostics.Project_0_is_out_of_date_because_output_file_1_does_not_exist, Ae(be, Ge), Ae(be, ur.missingOutputFileName));
                case e.UpToDateStatusType.UpToDate:
                  if (ur.newestInputFileTime !== void 0) return er(be, e.Diagnostics.Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2, Ae(be, Ge), Ae(be, ur.newestInputFileName || ""), Ae(be, ur.oldestOutputFileName || ""));
                  break;
                case e.UpToDateStatusType.OutOfDateWithPrepend:
                  return er(be, e.Diagnostics.Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed, Ae(be, Ge), Ae(be, ur.newerProjectName));
                case e.UpToDateStatusType.UpToDateWithUpstreamTypes:
                  return er(be, e.Diagnostics.Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies, Ae(be, Ge));
                case e.UpToDateStatusType.UpstreamOutOfDate:
                  return er(be, e.Diagnostics.Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date, Ae(be, Ge), Ae(be, ur.upstreamProjectName));
                case e.UpToDateStatusType.UpstreamBlocked:
                  return er(be, ur.upstreamProjectBlocked ? e.Diagnostics.Project_0_can_t_be_built_because_its_dependency_1_was_not_built : e.Diagnostics.Project_0_can_t_be_built_because_its_dependency_1_has_errors, Ae(be, Ge), Ae(be, ur.upstreamProjectName));
                case e.UpToDateStatusType.Unbuildable:
                  return er(be, e.Diagnostics.Failed_to_parse_file_0_Colon_1, Ae(be, Ge), ur.reason);
                case e.UpToDateStatusType.TsVersionOutputOfDate:
                  return er(be, e.Diagnostics.Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2, Ae(be, Ge), ur.version, e.version);
                case e.UpToDateStatusType.ContainerOnly:
                case e.UpToDateStatusType.ComputingUpstream:
                  break;
                default:
                  e.assertType(ur);
              }
            }
            function lr(be, Ge, ur) {
              be.options.verbose && n(be, Ge, ur);
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              C.ActionSet = "action::set", C.ActionInvalidate = "action::invalidate", C.ActionPackageInstalled = "action::packageInstalled", C.EventTypesRegistry = "event::typesRegistry", C.EventBeginInstallTypes = "event::beginInstallTypes", C.EventEndInstallTypes = "event::endInstallTypes", C.EventInitializationFailed = "event::initializationFailed";
              var w;
              (function(le) {
                le.GlobalCacheLocation = "--globalTypingsCacheLocation", le.LogFile = "--logFile", le.EnableTelemetry = "--enableTelemetry", le.TypingSafeListLocation = "--typingSafeListLocation", le.TypesMapLocation = "--typesMapLocation", le.NpmLocation = "--npmLocation", le.ValidateDefaultNpmLocation = "--validateDefaultNpmLocation";
              })(w = C.Arguments || (C.Arguments = {}));
              function B(le) {
                return e.sys.args.indexOf(le) >= 0;
              }
              C.hasArgument = B;
              function E(le) {
                var N = e.sys.args.indexOf(le);
                return N >= 0 && N < e.sys.args.length - 1 ? e.sys.args[N + 1] : void 0;
              }
              C.findArgument = E;
              function Q() {
                var le = /* @__PURE__ */ new Date();
                return "".concat(e.padLeft(le.getHours().toString(), 2, "0"), ":").concat(e.padLeft(le.getMinutes().toString(), 2, "0"), ":").concat(e.padLeft(le.getSeconds().toString(), 2, "0"), ".").concat(e.padLeft(le.getMilliseconds().toString(), 3, "0"));
              }
              C.nowString = Q;
            })(a = e.server || (e.server = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w(K, b) {
                var se = new e.Version(e.getProperty(b, "ts".concat(e.versionMajorMinor)) || e.getProperty(b, "latest"));
                return se.compareTo(K.version) <= 0;
              }
              C.isTypingUpToDate = w;
              var B = ["assert", "assert/strict", "async_hooks", "buffer", "child_process", "cluster", "console", "constants", "crypto", "dgram", "diagnostics_channel", "dns", "dns/promises", "domain", "events", "fs", "fs/promises", "http", "https", "http2", "inspector", "module", "net", "os", "path", "perf_hooks", "process", "punycode", "querystring", "readline", "repl", "stream", "stream/promises", "string_decoder", "timers", "timers/promises", "tls", "trace_events", "tty", "url", "util", "util/types", "v8", "vm", "wasi", "worker_threads", "zlib"];
              C.prefixedNodeCoreModuleList = B.map(function(K) {
                return "node:".concat(K);
              }), C.nodeCoreModuleList = Ve(Ve([], B, true), C.prefixedNodeCoreModuleList, true), C.nodeCoreModules = new e.Set(C.nodeCoreModuleList);
              function E(K) {
                return C.nodeCoreModules.has(K) ? "node" : K;
              }
              C.nonRelativeModuleNameForTypingCache = E;
              function Q(K, b) {
                var se = e.readConfigFile(b, function(J) {
                  return K.readFile(J);
                });
                return new e.Map(e.getEntries(se.config));
              }
              C.loadSafeList = Q;
              function le(K, b) {
                var se = e.readConfigFile(b, function(J) {
                  return K.readFile(J);
                });
                if (se.config) return new e.Map(e.getEntries(se.config.simpleMap));
              }
              C.loadTypesMap = le;
              function N(K, b, se, J, ie, R, q, O, ve) {
                if (!q || !q.enable) return { cachedTypingPaths: [], newTypingNames: [], filesToWatch: [] };
                var ee = new e.Map();
                se = e.mapDefined(se, function(I) {
                  var l = e.normalizePath(I);
                  if (e.hasJSFileExtension(l)) return l;
                });
                var he = [];
                q.include && U(q.include, "Explicitly included types");
                var F = q.exclude || [], x = new e.Set(se.map(e.getDirectoryPath));
                if (x.add(J), x.forEach(function(I) {
                  j(I, "bower.json", "bower_components", he), j(I, "package.json", "node_modules", he);
                }), q.disableFilenameBasedTypeAcquisition || H(se), O) {
                  var X = e.deduplicate(O.map(E), e.equateStringsCaseSensitive, e.compareStringsCaseSensitive);
                  U(X, "Inferred typings from unresolved imports");
                }
                R.forEach(function(I, l) {
                  var d = ve.get(l);
                  ee.has(l) && ee.get(l) === void 0 && d !== void 0 && w(I, d) && ee.set(l, I.typingLocation);
                });
                for (var $ = 0, A = F; $ < A.length; $++) {
                  var y = A[$], V = ee.delete(y);
                  V && b && b("Typing for ".concat(y, " is in exclude list, will be ignored."));
                }
                var L = [], P = [];
                ee.forEach(function(I, l) {
                  I !== void 0 ? P.push(I) : L.push(l);
                });
                var k = { cachedTypingPaths: P, newTypingNames: L, filesToWatch: he };
                return b && b("Result: ".concat(JSON.stringify(k))), k;
                function Y(I) {
                  ee.has(I) || ee.set(I, void 0);
                }
                function U(I, l) {
                  b && b("".concat(l, ": ").concat(JSON.stringify(I))), e.forEach(I, Y);
                }
                function j(I, l, d, D) {
                  var fe = e.combinePaths(I, l), g, ne;
                  K.fileExists(fe) && (D.push(fe), g = e.readConfigFile(fe, function(Ie) {
                    return K.readFile(Ie);
                  }).config, ne = e.flatMap([g.dependencies, g.devDependencies, g.optionalDependencies, g.peerDependencies], e.getOwnKeys), U(ne, "Typing names in '".concat(fe, "' dependencies")));
                  var ue = e.combinePaths(I, d);
                  if (D.push(ue), !!K.directoryExists(ue)) {
                    var We = [], Fe = ne ? ne.map(function(Ie) {
                      return e.combinePaths(ue, Ie, l);
                    }) : K.readDirectory(ue, [".json"], void 0, void 0, 3).filter(function(Ie) {
                      if (e.getBaseFileName(Ie) !== l) return false;
                      var _e = e.getPathComponents(e.normalizePath(Ie)), we = _e[_e.length - 3][0] === "@";
                      return we && _e[_e.length - 4].toLowerCase() === d || !we && _e[_e.length - 3].toLowerCase() === d;
                    });
                    b && b("Searching for typing names in ".concat(ue, "; all files: ").concat(JSON.stringify(Fe)));
                    for (var Z = 0, Be = Fe; Z < Be.length; Z++) {
                      var ge = Be[Z], Re = e.normalizePath(ge), ze = e.readConfigFile(Re, function(Ie) {
                        return K.readFile(Ie);
                      }), Ee = ze.config;
                      if (!!Ee.name) {
                        var He = Ee.types || Ee.typings;
                        if (He) {
                          var rr = e.getNormalizedAbsolutePath(He, e.getDirectoryPath(Re));
                          K.fileExists(rr) ? (b && b("    Package '".concat(Ee.name, "' provides its own types.")), ee.set(Ee.name, rr)) : b && b("    Package '".concat(Ee.name, "' provides its own types but they are missing."));
                        } else We.push(Ee.name);
                      }
                    }
                    U(We, "    Found package names");
                  }
                }
                function H(I) {
                  var l = e.mapDefined(I, function(D) {
                    if (!!e.hasJSFileExtension(D)) {
                      var fe = e.removeFileExtension(e.getBaseFileName(D.toLowerCase())), g = e.removeMinAndVersionNumbers(fe);
                      return ie.get(g);
                    }
                  });
                  l.length && U(l, "Inferred typings from file names");
                  var d = e.some(I, function(D) {
                    return e.fileExtensionIs(D, ".jsx");
                  });
                  d && (b && b("Inferred 'react' typings due to presence of '.jsx' extension"), Y("react"));
                }
              }
              C.discoverTypings = N;
              var p;
              (function(K) {
                K[K.Ok = 0] = "Ok", K[K.EmptyName = 1] = "EmptyName", K[K.NameTooLong = 2] = "NameTooLong", K[K.NameStartsWithDot = 3] = "NameStartsWithDot", K[K.NameStartsWithUnderscore = 4] = "NameStartsWithUnderscore", K[K.NameContainsNonURISafeCharacters = 5] = "NameContainsNonURISafeCharacters";
              })(p = C.NameValidationResult || (C.NameValidationResult = {}));
              var m = 214;
              function G(K) {
                return oe(K, true);
              }
              C.validatePackageName = G;
              function oe(K, b) {
                if (!K) return 1;
                if (K.length > m) return 2;
                if (K.charCodeAt(0) === 46) return 3;
                if (K.charCodeAt(0) === 95) return 4;
                if (b) {
                  var se = /^@([^/]+)\/([^/]+)$/.exec(K);
                  if (se) {
                    var J = oe(se[1], false);
                    if (J !== 0) return { name: se[1], isScopeName: true, result: J };
                    var ie = oe(se[2], false);
                    return ie !== 0 ? { name: se[2], isScopeName: false, result: ie } : 0;
                  }
                }
                return encodeURIComponent(K) !== K ? 5 : 0;
              }
              function f(K, b) {
                return typeof K == "object" ? T(b, K.result, K.name, K.isScopeName) : T(b, K, b, false);
              }
              C.renderPackageNameValidationFailure = f;
              function T(K, b, se, J) {
                var ie = J ? "Scope" : "Package";
                switch (b) {
                  case 1:
                    return "'".concat(K, "':: ").concat(ie, " name '").concat(se, "' cannot be empty");
                  case 2:
                    return "'".concat(K, "':: ").concat(ie, " name '").concat(se, "' should be less than ").concat(m, " characters");
                  case 3:
                    return "'".concat(K, "':: ").concat(ie, " name '").concat(se, "' cannot start with '.'");
                  case 4:
                    return "'".concat(K, "':: ").concat(ie, " name '").concat(se, "' cannot start with '_'");
                  case 5:
                    return "'".concat(K, "':: ").concat(ie, " name '").concat(se, "' contains non URI safe characters");
                  case 0:
                    return e.Debug.fail();
                  default:
                    throw e.Debug.assertNever(b);
                }
              }
            })(a = e.JsTyping || (e.JsTyping = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(O) {
              var ve = function() {
                function he(F) {
                  this.text = F;
                }
                return he.prototype.getText = function(F, x) {
                  return F === 0 && x === this.text.length ? this.text : this.text.substring(F, x);
                }, he.prototype.getLength = function() {
                  return this.text.length;
                }, he.prototype.getChangeRange = function() {
                }, he;
              }();
              function ee(he) {
                return new ve(he);
              }
              O.fromString = ee;
            })(a = e.ScriptSnapshot || (e.ScriptSnapshot = {}));
            var C;
            (function(O) {
              O[O.Dependencies = 1] = "Dependencies", O[O.DevDependencies = 2] = "DevDependencies", O[O.PeerDependencies = 4] = "PeerDependencies", O[O.OptionalDependencies = 8] = "OptionalDependencies", O[O.All = 15] = "All";
            })(C = e.PackageJsonDependencyGroup || (e.PackageJsonDependencyGroup = {}));
            var w;
            (function(O) {
              O[O.Off = 0] = "Off", O[O.On = 1] = "On", O[O.Auto = 2] = "Auto";
            })(w = e.PackageJsonAutoImportPreference || (e.PackageJsonAutoImportPreference = {}));
            var B;
            (function(O) {
              O[O.Semantic = 0] = "Semantic", O[O.PartialSemantic = 1] = "PartialSemantic", O[O.Syntactic = 2] = "Syntactic";
            })(B = e.LanguageServiceMode || (e.LanguageServiceMode = {})), e.emptyOptions = {};
            var E;
            (function(O) {
              O.Original = "original", O.TwentyTwenty = "2020";
            })(E = e.SemanticClassificationFormat || (e.SemanticClassificationFormat = {}));
            var Q;
            (function(O) {
              O[O.Invoked = 1] = "Invoked", O[O.TriggerCharacter = 2] = "TriggerCharacter", O[O.TriggerForIncompleteCompletions = 3] = "TriggerForIncompleteCompletions";
            })(Q = e.CompletionTriggerKind || (e.CompletionTriggerKind = {}));
            var le;
            (function(O) {
              O.Type = "Type", O.Parameter = "Parameter", O.Enum = "Enum";
            })(le = e.InlayHintKind || (e.InlayHintKind = {}));
            var N;
            (function(O) {
              O.none = "none", O.definition = "definition", O.reference = "reference", O.writtenReference = "writtenReference";
            })(N = e.HighlightSpanKind || (e.HighlightSpanKind = {}));
            var p;
            (function(O) {
              O[O.None = 0] = "None", O[O.Block = 1] = "Block", O[O.Smart = 2] = "Smart";
            })(p = e.IndentStyle || (e.IndentStyle = {}));
            var m;
            (function(O) {
              O.Ignore = "ignore", O.Insert = "insert", O.Remove = "remove";
            })(m = e.SemicolonPreference || (e.SemicolonPreference = {}));
            function G(O) {
              return { indentSize: 4, tabSize: 4, newLineCharacter: O || `
`, convertTabsToSpaces: true, indentStyle: p.Smart, insertSpaceAfterConstructor: false, insertSpaceAfterCommaDelimiter: true, insertSpaceAfterSemicolonInForStatements: true, insertSpaceBeforeAndAfterBinaryOperators: true, insertSpaceAfterKeywordsInControlFlowStatements: true, insertSpaceAfterFunctionKeywordForAnonymousFunctions: false, insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis: false, insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets: false, insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces: true, insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces: false, insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces: false, insertSpaceBeforeFunctionParenthesis: false, placeOpenBraceOnNewLineForFunctions: false, placeOpenBraceOnNewLineForControlBlocks: false, semicolons: m.Ignore, trimTrailingWhitespace: true };
            }
            e.getDefaultFormatCodeSettings = G, e.testFormatSettings = G(`
`);
            var oe;
            (function(O) {
              O[O.aliasName = 0] = "aliasName", O[O.className = 1] = "className", O[O.enumName = 2] = "enumName", O[O.fieldName = 3] = "fieldName", O[O.interfaceName = 4] = "interfaceName", O[O.keyword = 5] = "keyword", O[O.lineBreak = 6] = "lineBreak", O[O.numericLiteral = 7] = "numericLiteral", O[O.stringLiteral = 8] = "stringLiteral", O[O.localName = 9] = "localName", O[O.methodName = 10] = "methodName", O[O.moduleName = 11] = "moduleName", O[O.operator = 12] = "operator", O[O.parameterName = 13] = "parameterName", O[O.propertyName = 14] = "propertyName", O[O.punctuation = 15] = "punctuation", O[O.space = 16] = "space", O[O.text = 17] = "text", O[O.typeParameterName = 18] = "typeParameterName", O[O.enumMemberName = 19] = "enumMemberName", O[O.functionName = 20] = "functionName", O[O.regularExpressionLiteral = 21] = "regularExpressionLiteral", O[O.link = 22] = "link", O[O.linkName = 23] = "linkName", O[O.linkText = 24] = "linkText";
            })(oe = e.SymbolDisplayPartKind || (e.SymbolDisplayPartKind = {}));
            var f;
            (function(O) {
              O[O.None = 0] = "None", O[O.MayIncludeAutoImports = 1] = "MayIncludeAutoImports", O[O.IsImportStatementCompletion = 2] = "IsImportStatementCompletion", O[O.IsContinuation = 4] = "IsContinuation", O[O.ResolvedModuleSpecifiers = 8] = "ResolvedModuleSpecifiers", O[O.ResolvedModuleSpecifiersBeyondLimit = 16] = "ResolvedModuleSpecifiersBeyondLimit", O[O.MayIncludeMethodSnippets = 32] = "MayIncludeMethodSnippets";
            })(f = e.CompletionInfoFlags || (e.CompletionInfoFlags = {}));
            var T;
            (function(O) {
              O.Comment = "comment", O.Region = "region", O.Code = "code", O.Imports = "imports";
            })(T = e.OutliningSpanKind || (e.OutliningSpanKind = {}));
            var K;
            (function(O) {
              O[O.JavaScript = 0] = "JavaScript", O[O.SourceMap = 1] = "SourceMap", O[O.Declaration = 2] = "Declaration";
            })(K = e.OutputFileType || (e.OutputFileType = {}));
            var b;
            (function(O) {
              O[O.None = 0] = "None", O[O.InMultiLineCommentTrivia = 1] = "InMultiLineCommentTrivia", O[O.InSingleQuoteStringLiteral = 2] = "InSingleQuoteStringLiteral", O[O.InDoubleQuoteStringLiteral = 3] = "InDoubleQuoteStringLiteral", O[O.InTemplateHeadOrNoSubstitutionTemplate = 4] = "InTemplateHeadOrNoSubstitutionTemplate", O[O.InTemplateMiddleOrTail = 5] = "InTemplateMiddleOrTail", O[O.InTemplateSubstitutionPosition = 6] = "InTemplateSubstitutionPosition";
            })(b = e.EndOfLineState || (e.EndOfLineState = {}));
            var se;
            (function(O) {
              O[O.Punctuation = 0] = "Punctuation", O[O.Keyword = 1] = "Keyword", O[O.Operator = 2] = "Operator", O[O.Comment = 3] = "Comment", O[O.Whitespace = 4] = "Whitespace", O[O.Identifier = 5] = "Identifier", O[O.NumberLiteral = 6] = "NumberLiteral", O[O.BigIntLiteral = 7] = "BigIntLiteral", O[O.StringLiteral = 8] = "StringLiteral", O[O.RegExpLiteral = 9] = "RegExpLiteral";
            })(se = e.TokenClass || (e.TokenClass = {}));
            var J;
            (function(O) {
              O.unknown = "", O.warning = "warning", O.keyword = "keyword", O.scriptElement = "script", O.moduleElement = "module", O.classElement = "class", O.localClassElement = "local class", O.interfaceElement = "interface", O.typeElement = "type", O.enumElement = "enum", O.enumMemberElement = "enum member", O.variableElement = "var", O.localVariableElement = "local var", O.functionElement = "function", O.localFunctionElement = "local function", O.memberFunctionElement = "method", O.memberGetAccessorElement = "getter", O.memberSetAccessorElement = "setter", O.memberVariableElement = "property", O.constructorImplementationElement = "constructor", O.callSignatureElement = "call", O.indexSignatureElement = "index", O.constructSignatureElement = "construct", O.parameterElement = "parameter", O.typeParameterElement = "type parameter", O.primitiveType = "primitive type", O.label = "label", O.alias = "alias", O.constElement = "const", O.letElement = "let", O.directory = "directory", O.externalModuleName = "external module name", O.jsxAttribute = "JSX attribute", O.string = "string", O.link = "link", O.linkName = "link name", O.linkText = "link text";
            })(J = e.ScriptElementKind || (e.ScriptElementKind = {}));
            var ie;
            (function(O) {
              O.none = "", O.publicMemberModifier = "public", O.privateMemberModifier = "private", O.protectedMemberModifier = "protected", O.exportedModifier = "export", O.ambientModifier = "declare", O.staticModifier = "static", O.abstractModifier = "abstract", O.optionalModifier = "optional", O.deprecatedModifier = "deprecated", O.dtsModifier = ".d.ts", O.tsModifier = ".ts", O.tsxModifier = ".tsx", O.jsModifier = ".js", O.jsxModifier = ".jsx", O.jsonModifier = ".json", O.dmtsModifier = ".d.mts", O.mtsModifier = ".mts", O.mjsModifier = ".mjs", O.dctsModifier = ".d.cts", O.ctsModifier = ".cts", O.cjsModifier = ".cjs";
            })(ie = e.ScriptElementKindModifier || (e.ScriptElementKindModifier = {}));
            var R;
            (function(O) {
              O.comment = "comment", O.identifier = "identifier", O.keyword = "keyword", O.numericLiteral = "number", O.bigintLiteral = "bigint", O.operator = "operator", O.stringLiteral = "string", O.whiteSpace = "whitespace", O.text = "text", O.punctuation = "punctuation", O.className = "class name", O.enumName = "enum name", O.interfaceName = "interface name", O.moduleName = "module name", O.typeParameterName = "type parameter name", O.typeAliasName = "type alias name", O.parameterName = "parameter name", O.docCommentTagName = "doc comment tag name", O.jsxOpenTagName = "jsx open tag name", O.jsxCloseTagName = "jsx close tag name", O.jsxSelfClosingTagName = "jsx self closing tag name", O.jsxAttribute = "jsx attribute", O.jsxText = "jsx text", O.jsxAttributeStringLiteralValue = "jsx attribute string literal value";
            })(R = e.ClassificationTypeNames || (e.ClassificationTypeNames = {}));
            var q;
            (function(O) {
              O[O.comment = 1] = "comment", O[O.identifier = 2] = "identifier", O[O.keyword = 3] = "keyword", O[O.numericLiteral = 4] = "numericLiteral", O[O.operator = 5] = "operator", O[O.stringLiteral = 6] = "stringLiteral", O[O.regularExpressionLiteral = 7] = "regularExpressionLiteral", O[O.whiteSpace = 8] = "whiteSpace", O[O.text = 9] = "text", O[O.punctuation = 10] = "punctuation", O[O.className = 11] = "className", O[O.enumName = 12] = "enumName", O[O.interfaceName = 13] = "interfaceName", O[O.moduleName = 14] = "moduleName", O[O.typeParameterName = 15] = "typeParameterName", O[O.typeAliasName = 16] = "typeAliasName", O[O.parameterName = 17] = "parameterName", O[O.docCommentTagName = 18] = "docCommentTagName", O[O.jsxOpenTagName = 19] = "jsxOpenTagName", O[O.jsxCloseTagName = 20] = "jsxCloseTagName", O[O.jsxSelfClosingTagName = 21] = "jsxSelfClosingTagName", O[O.jsxAttribute = 22] = "jsxAttribute", O[O.jsxText = 23] = "jsxText", O[O.jsxAttributeStringLiteralValue = 24] = "jsxAttributeStringLiteralValue", O[O.bigintLiteral = 25] = "bigintLiteral";
            })(q = e.ClassificationType || (e.ClassificationType = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            e.scanner = e.createScanner(99, true);
            var a;
            (function(Se) {
              Se[Se.None = 0] = "None", Se[Se.Value = 1] = "Value", Se[Se.Type = 2] = "Type", Se[Se.Namespace = 4] = "Namespace", Se[Se.All = 7] = "All";
            })(a = e.SemanticMeaning || (e.SemanticMeaning = {}));
            function C(Se) {
              switch (Se.kind) {
                case 254:
                  return e.isInJSFile(Se) && e.getJSDocEnumTag(Se) ? 7 : 1;
                case 164:
                case 203:
                case 167:
                case 166:
                case 296:
                case 297:
                case 169:
                case 168:
                case 171:
                case 172:
                case 173:
                case 256:
                case 213:
                case 214:
                case 292:
                case 285:
                  return 1;
                case 163:
                case 258:
                case 259:
                case 182:
                  return 2;
                case 345:
                  return Se.name === void 0 ? 3 : 2;
                case 299:
                case 257:
                  return 3;
                case 261:
                  return e.isAmbientModule(Se) || e.getModuleInstanceState(Se) === 1 ? 5 : 4;
                case 260:
                case 269:
                case 270:
                case 265:
                case 266:
                case 271:
                case 272:
                  return 7;
                case 305:
                  return 5;
              }
              return 7;
            }
            e.getMeaningFromDeclaration = C;
            function w(Se) {
              Se = Br(Se);
              var hr = Se.parent;
              return Se.kind === 305 ? 1 : e.isExportAssignment(hr) || e.isExportSpecifier(hr) || e.isExternalModuleReference(hr) || e.isImportSpecifier(hr) || e.isImportClause(hr) || e.isImportEqualsDeclaration(hr) && Se === hr.name ? 7 : E(Se) ? B(Se) : e.isDeclarationName(Se) ? C(hr) : e.isEntityName(Se) && e.findAncestor(Se, e.or(e.isJSDocNameReference, e.isJSDocLinkLike, e.isJSDocMemberName)) ? 7 : p(Se) ? 2 : Q(Se) ? 4 : e.isTypeParameterDeclaration(hr) ? (e.Debug.assert(e.isJSDocTemplateTag(hr.parent)), 2) : e.isLiteralTypeNode(hr) ? 3 : 1;
            }
            e.getMeaningFromLocation = w;
            function B(Se) {
              var hr = Se.kind === 161 ? Se : e.isQualifiedName(Se.parent) && Se.parent.right === Se ? Se.parent : void 0;
              return hr && hr.parent.kind === 265 ? 7 : 4;
            }
            function E(Se) {
              for (; Se.parent.kind === 161; ) Se = Se.parent;
              return e.isInternalModuleImportEqualsDeclaration(Se.parent) && Se.parent.moduleReference === Se;
            }
            e.isInRightSideOfInternalImportEqualsDeclaration = E;
            function Q(Se) {
              return le(Se) || N(Se);
            }
            function le(Se) {
              var hr = Se, Or = true;
              if (hr.parent.kind === 161) {
                for (; hr.parent && hr.parent.kind === 161; ) hr = hr.parent;
                Or = hr.right === Se;
              }
              return hr.parent.kind === 178 && !Or;
            }
            function N(Se) {
              var hr = Se, Or = true;
              if (hr.parent.kind === 206) {
                for (; hr.parent && hr.parent.kind === 206; ) hr = hr.parent;
                Or = hr.name === Se;
              }
              if (!Or && hr.parent.kind === 228 && hr.parent.parent.kind === 291) {
                var ki = hr.parent.parent.parent;
                return ki.kind === 257 && hr.parent.parent.token === 117 || ki.kind === 258 && hr.parent.parent.token === 94;
              }
              return false;
            }
            function p(Se) {
              switch (e.isRightSideOfQualifiedNameOrPropertyAccess(Se) && (Se = Se.parent), Se.kind) {
                case 108:
                  return !e.isExpressionNode(Se);
                case 192:
                  return true;
              }
              switch (Se.parent.kind) {
                case 178:
                  return true;
                case 200:
                  return !Se.parent.isTypeOf;
                case 228:
                  return e.isPartOfTypeNode(Se.parent);
              }
              return false;
            }
            function m(Se, hr, Or) {
              return hr === void 0 && (hr = false), Or === void 0 && (Or = false), ie(Se, e.isCallExpression, b, hr, Or);
            }
            e.isCallExpressionTarget = m;
            function G(Se, hr, Or) {
              return hr === void 0 && (hr = false), Or === void 0 && (Or = false), ie(Se, e.isNewExpression, b, hr, Or);
            }
            e.isNewExpressionTarget = G;
            function oe(Se, hr, Or) {
              return hr === void 0 && (hr = false), Or === void 0 && (Or = false), ie(Se, e.isCallOrNewExpression, b, hr, Or);
            }
            e.isCallOrNewExpressionTarget = oe;
            function f(Se, hr, Or) {
              return hr === void 0 && (hr = false), Or === void 0 && (Or = false), ie(Se, e.isTaggedTemplateExpression, se, hr, Or);
            }
            e.isTaggedTemplateTag = f;
            function T(Se, hr, Or) {
              return hr === void 0 && (hr = false), Or === void 0 && (Or = false), ie(Se, e.isDecorator, b, hr, Or);
            }
            e.isDecoratorTarget = T;
            function K(Se, hr, Or) {
              return hr === void 0 && (hr = false), Or === void 0 && (Or = false), ie(Se, e.isJsxOpeningLikeElement, J, hr, Or);
            }
            e.isJsxOpeningLikeElementTagName = K;
            function b(Se) {
              return Se.expression;
            }
            function se(Se) {
              return Se.tag;
            }
            function J(Se) {
              return Se.tagName;
            }
            function ie(Se, hr, Or, ki, dt) {
              var la = ki ? q(Se) : R(Se);
              return dt && (la = e.skipOuterExpressions(la)), !!la && !!la.parent && hr(la.parent) && Or(la.parent) === la;
            }
            function R(Se) {
              return $(Se) ? Se.parent : Se;
            }
            e.climbPastPropertyAccess = R;
            function q(Se) {
              return $(Se) || A(Se) ? Se.parent : Se;
            }
            e.climbPastPropertyOrElementAccess = q;
            function O(Se, hr) {
              for (; Se; ) {
                if (Se.kind === 250 && Se.label.escapedText === hr) return Se.label;
                Se = Se.parent;
              }
            }
            e.getTargetLabel = O;
            function ve(Se, hr) {
              return e.isPropertyAccessExpression(Se.expression) ? Se.expression.name.text === hr : false;
            }
            e.hasPropertyAccessExpressionWithName = ve;
            function ee(Se) {
              var hr;
              return e.isIdentifier(Se) && ((hr = e.tryCast(Se.parent, e.isBreakOrContinueStatement)) === null || hr === void 0 ? void 0 : hr.label) === Se;
            }
            e.isJumpStatementTarget = ee;
            function he(Se) {
              var hr;
              return e.isIdentifier(Se) && ((hr = e.tryCast(Se.parent, e.isLabeledStatement)) === null || hr === void 0 ? void 0 : hr.label) === Se;
            }
            e.isLabelOfLabeledStatement = he;
            function F(Se) {
              return he(Se) || ee(Se);
            }
            e.isLabelName = F;
            function x(Se) {
              var hr;
              return ((hr = e.tryCast(Se.parent, e.isJSDocTag)) === null || hr === void 0 ? void 0 : hr.tagName) === Se;
            }
            e.isTagName = x;
            function X(Se) {
              var hr;
              return ((hr = e.tryCast(Se.parent, e.isQualifiedName)) === null || hr === void 0 ? void 0 : hr.right) === Se;
            }
            e.isRightSideOfQualifiedName = X;
            function $(Se) {
              var hr;
              return ((hr = e.tryCast(Se.parent, e.isPropertyAccessExpression)) === null || hr === void 0 ? void 0 : hr.name) === Se;
            }
            e.isRightSideOfPropertyAccess = $;
            function A(Se) {
              var hr;
              return ((hr = e.tryCast(Se.parent, e.isElementAccessExpression)) === null || hr === void 0 ? void 0 : hr.argumentExpression) === Se;
            }
            e.isArgumentExpressionOfElementAccess = A;
            function y(Se) {
              var hr;
              return ((hr = e.tryCast(Se.parent, e.isModuleDeclaration)) === null || hr === void 0 ? void 0 : hr.name) === Se;
            }
            e.isNameOfModuleDeclaration = y;
            function V(Se) {
              var hr;
              return e.isIdentifier(Se) && ((hr = e.tryCast(Se.parent, e.isFunctionLike)) === null || hr === void 0 ? void 0 : hr.name) === Se;
            }
            e.isNameOfFunctionDeclaration = V;
            function L(Se) {
              switch (Se.parent.kind) {
                case 167:
                case 166:
                case 296:
                case 299:
                case 169:
                case 168:
                case 172:
                case 173:
                case 261:
                  return e.getNameOfDeclaration(Se.parent) === Se;
                case 207:
                  return Se.parent.argumentExpression === Se;
                case 162:
                  return true;
                case 196:
                  return Se.parent.parent.kind === 194;
                default:
                  return false;
              }
            }
            e.isLiteralNameOfPropertyDeclarationOrIndexAccess = L;
            function P(Se) {
              return e.isExternalModuleImportEqualsDeclaration(Se.parent.parent) && e.getExternalModuleImportEqualsDeclarationExpression(Se.parent.parent) === Se;
            }
            e.isExpressionOfExternalModuleImportEqualsDeclaration = P;
            function k(Se) {
              for (e.isJSDocTypeAlias(Se) && (Se = Se.parent.parent); ; ) {
                if (Se = Se.parent, !Se) return;
                switch (Se.kind) {
                  case 305:
                  case 169:
                  case 168:
                  case 256:
                  case 213:
                  case 172:
                  case 173:
                  case 257:
                  case 258:
                  case 260:
                  case 261:
                    return Se;
                }
              }
            }
            e.getContainerNode = k;
            function Y(Se) {
              switch (Se.kind) {
                case 305:
                  return e.isExternalModule(Se) ? "module" : "script";
                case 261:
                  return "module";
                case 257:
                case 226:
                  return "class";
                case 258:
                  return "interface";
                case 259:
                case 338:
                case 345:
                  return "type";
                case 260:
                  return "enum";
                case 254:
                  return wa(Se);
                case 203:
                  return wa(e.getRootDeclaration(Se));
                case 214:
                case 256:
                case 213:
                  return "function";
                case 172:
                  return "getter";
                case 173:
                  return "setter";
                case 169:
                case 168:
                  return "method";
                case 296:
                  var hr = Se.initializer;
                  return e.isFunctionLike(hr) ? "method" : "property";
                case 167:
                case 166:
                case 297:
                case 298:
                  return "property";
                case 176:
                  return "index";
                case 175:
                  return "construct";
                case 174:
                  return "call";
                case 171:
                case 170:
                  return "constructor";
                case 163:
                  return "type parameter";
                case 299:
                  return "enum member";
                case 164:
                  return e.hasSyntacticModifier(Se, 16476) ? "property" : "parameter";
                case 265:
                case 270:
                case 275:
                case 268:
                case 274:
                  return "alias";
                case 221:
                  var Or = e.getAssignmentDeclarationKind(Se), ki = Se.right;
                  switch (Or) {
                    case 7:
                    case 8:
                    case 9:
                    case 0:
                      return "";
                    case 1:
                    case 2:
                      var dt = Y(ki);
                      return dt === "" ? "const" : dt;
                    case 3:
                      return e.isFunctionExpression(ki) ? "method" : "property";
                    case 4:
                      return "property";
                    case 5:
                      return e.isFunctionExpression(ki) ? "method" : "property";
                    case 6:
                      return "local class";
                    default:
                      return e.assertType(Or), "";
                  }
                case 79:
                  return e.isImportClause(Se.parent) ? "alias" : "";
                case 271:
                  var la = Y(Se.expression);
                  return la === "" ? "const" : la;
                default:
                  return "";
              }
              function wa(On) {
                return e.isVarConst(On) ? "const" : e.isLet(On) ? "let" : "var";
              }
            }
            e.getNodeKind = Y;
            function U(Se) {
              switch (Se.kind) {
                case 108:
                  return true;
                case 79:
                  return e.identifierIsThisKeyword(Se) && Se.parent.kind === 164;
                default:
                  return false;
              }
            }
            e.isThis = U;
            var j = /^\/\/\/\s*</;
            function H(Se, hr) {
              var Or = e.getLineStarts(hr), ki = hr.getLineAndCharacterOfPosition(Se).line;
              return Or[ki];
            }
            e.getLineStartPositionForPosition = H;
            function I(Se, hr) {
              return fe(Se.pos, Se.end, hr);
            }
            e.rangeContainsRange = I;
            function l(Se, hr) {
              return D(Se, hr.pos) && D(Se, hr.end);
            }
            e.rangeContainsRangeExclusive = l;
            function d(Se, hr) {
              return Se.pos <= hr && hr <= Se.end;
            }
            e.rangeContainsPosition = d;
            function D(Se, hr) {
              return Se.pos < hr && hr < Se.end;
            }
            e.rangeContainsPositionExclusive = D;
            function fe(Se, hr, Or) {
              return Se <= Or.pos && hr >= Or.end;
            }
            e.startEndContainsRange = fe;
            function g(Se, hr, Or) {
              return Se.pos <= hr && Se.end >= Or;
            }
            e.rangeContainsStartEnd = g;
            function ne(Se, hr, Or) {
              return We(Se.pos, Se.end, hr, Or);
            }
            e.rangeOverlapsWithStartEnd = ne;
            function ue(Se, hr, Or, ki) {
              return We(Se.getStart(hr), Se.end, Or, ki);
            }
            e.nodeOverlapsWithStartEnd = ue;
            function We(Se, hr, Or, ki) {
              var dt = Math.max(Se, Or), la = Math.min(hr, ki);
              return dt < la;
            }
            e.startEndOverlapsWithStartEnd = We;
            function Fe(Se, hr, Or) {
              return e.Debug.assert(Se.pos <= hr), hr < Se.end || !Z(Se, Or);
            }
            e.positionBelongsToNode = Fe;
            function Z(Se, hr) {
              if (Se === void 0 || e.nodeIsMissing(Se)) return false;
              switch (Se.kind) {
                case 257:
                case 258:
                case 260:
                case 205:
                case 201:
                case 182:
                case 235:
                case 262:
                case 263:
                case 269:
                case 273:
                  return Be(Se, 19, hr);
                case 292:
                  return Z(Se.block, hr);
                case 209:
                  if (!Se.arguments) return true;
                case 208:
                case 212:
                case 191:
                  return Be(Se, 21, hr);
                case 179:
                case 180:
                  return Z(Se.type, hr);
                case 171:
                case 172:
                case 173:
                case 256:
                case 213:
                case 169:
                case 168:
                case 175:
                case 174:
                case 214:
                  return Se.body ? Z(Se.body, hr) : Se.type ? Z(Se.type, hr) : Re(Se, 21, hr);
                case 261:
                  return !!Se.body && Z(Se.body, hr);
                case 239:
                  return Se.elseStatement ? Z(Se.elseStatement, hr) : Z(Se.thenStatement, hr);
                case 238:
                  return Z(Se.expression, hr) || Re(Se, 26, hr);
                case 204:
                case 202:
                case 207:
                case 162:
                case 184:
                  return Be(Se, 23, hr);
                case 176:
                  return Se.type ? Z(Se.type, hr) : Re(Se, 23, hr);
                case 289:
                case 290:
                  return false;
                case 242:
                case 243:
                case 244:
                case 241:
                  return Z(Se.statement, hr);
                case 240:
                  return Re(Se, 115, hr) ? Be(Se, 21, hr) : Z(Se.statement, hr);
                case 181:
                  return Z(Se.exprName, hr);
                case 216:
                case 215:
                case 217:
                case 224:
                case 225:
                  var Or = Se;
                  return Z(Or.expression, hr);
                case 210:
                  return Z(Se.template, hr);
                case 223:
                  var ki = e.lastOrUndefined(Se.templateSpans);
                  return Z(ki, hr);
                case 233:
                  return e.nodeIsPresent(Se.literal);
                case 272:
                case 266:
                  return e.nodeIsPresent(Se.moduleSpecifier);
                case 219:
                  return Z(Se.operand, hr);
                case 221:
                  return Z(Se.right, hr);
                case 222:
                  return Z(Se.whenFalse, hr);
                default:
                  return true;
              }
            }
            function Be(Se, hr, Or) {
              var ki = Se.getChildren(Or);
              if (ki.length) {
                var dt = e.last(ki);
                if (dt.kind === hr) return true;
                if (dt.kind === 26 && ki.length !== 1) return ki[ki.length - 2].kind === hr;
              }
              return false;
            }
            function ge(Se) {
              var hr = Ee(Se);
              if (!!hr) {
                var Or = hr.getChildren(), ki = e.indexOfNode(Or, Se);
                return { listItemIndex: ki, list: hr };
              }
            }
            e.findListItemInfo = ge;
            function Re(Se, hr, Or) {
              return !!ze(Se, hr, Or);
            }
            e.hasChildOfKind = Re;
            function ze(Se, hr, Or) {
              return e.find(Se.getChildren(Or), function(ki) {
                return ki.kind === hr;
              });
            }
            e.findChildOfKind = ze;
            function Ee(Se) {
              var hr = e.find(Se.parent.getChildren(), function(Or) {
                return e.isSyntaxList(Or) && I(Or, Se);
              });
              return e.Debug.assert(!hr || e.contains(hr.getChildren(), Se)), hr;
            }
            e.findContainingList = Ee;
            function He(Se) {
              return Se.kind === 88;
            }
            function rr(Se) {
              return Se.kind === 84;
            }
            function Ie(Se) {
              return Se.kind === 98;
            }
            function _e(Se) {
              if (e.isNamedDeclaration(Se)) return Se.name;
              if (e.isClassDeclaration(Se)) {
                var hr = Se.modifiers && e.find(Se.modifiers, He);
                if (hr) return hr;
              }
              if (e.isClassExpression(Se)) {
                var Or = e.find(Se.getChildren(), rr);
                if (Or) return Or;
              }
            }
            function we(Se) {
              if (e.isNamedDeclaration(Se)) return Se.name;
              if (e.isFunctionDeclaration(Se)) {
                var hr = e.find(Se.modifiers, He);
                if (hr) return hr;
              }
              if (e.isFunctionExpression(Se)) {
                var Or = e.find(Se.getChildren(), Ie);
                if (Or) return Or;
              }
            }
            function de(Se) {
              var hr;
              return e.findAncestor(Se, function(Or) {
                return e.isTypeNode(Or) && (hr = Or), !e.isQualifiedName(Or.parent) && !e.isTypeNode(Or.parent) && !e.isTypeElement(Or.parent);
              }), hr;
            }
            function ye(Se, hr) {
              var Or = yi(Se, hr);
              if (Or) return Or;
              var ki = de(Se);
              return ki && hr.getTypeAtLocation(ki);
            }
            e.getContextualTypeFromParentOrAncestorTypeNode = ye;
            function Ae(Se, hr) {
              if (!hr) switch (Se.kind) {
                case 257:
                case 226:
                  return _e(Se);
                case 256:
                case 213:
                  return we(Se);
              }
              if (e.isNamedDeclaration(Se)) return Se.name;
            }
            function er(Se, hr) {
              if (Se.importClause) {
                if (Se.importClause.name && Se.importClause.namedBindings) return;
                if (Se.importClause.name) return Se.importClause.name;
                if (Se.importClause.namedBindings) {
                  if (e.isNamedImports(Se.importClause.namedBindings)) {
                    var Or = e.singleOrUndefined(Se.importClause.namedBindings.elements);
                    return Or ? Or.name : void 0;
                  } else if (e.isNamespaceImport(Se.importClause.namedBindings)) return Se.importClause.namedBindings.name;
                }
              }
              if (!hr) return Se.moduleSpecifier;
            }
            function ir(Se, hr) {
              if (Se.exportClause) {
                if (e.isNamedExports(Se.exportClause)) {
                  var Or = e.singleOrUndefined(Se.exportClause.elements);
                  return Or ? Se.exportClause.elements[0].name : void 0;
                } else if (e.isNamespaceExport(Se.exportClause)) return Se.exportClause.name;
              }
              if (!hr) return Se.moduleSpecifier;
            }
            function Cr(Se) {
              if (Se.types.length === 1) return Se.types[0].expression;
            }
            function Ye(Se, hr) {
              var Or = Se.parent;
              if (e.isModifier(Se) && (hr || Se.kind !== 88) ? e.contains(Or.modifiers, Se) : Se.kind === 84 ? e.isClassDeclaration(Or) || e.isClassExpression(Se) : Se.kind === 98 ? e.isFunctionDeclaration(Or) || e.isFunctionExpression(Se) : Se.kind === 118 ? e.isInterfaceDeclaration(Or) : Se.kind === 92 ? e.isEnumDeclaration(Or) : Se.kind === 152 ? e.isTypeAliasDeclaration(Or) : Se.kind === 142 || Se.kind === 141 ? e.isModuleDeclaration(Or) : Se.kind === 100 ? e.isImportEqualsDeclaration(Or) : Se.kind === 136 ? e.isGetAccessorDeclaration(Or) : Se.kind === 149 && e.isSetAccessorDeclaration(Or)) {
                var ki = Ae(Or, hr);
                if (ki) return ki;
              }
              if ((Se.kind === 113 || Se.kind === 85 || Se.kind === 119) && e.isVariableDeclarationList(Or) && Or.declarations.length === 1) {
                var dt = Or.declarations[0];
                if (e.isIdentifier(dt.name)) return dt.name;
              }
              if (Se.kind === 152) {
                if (e.isImportClause(Or) && Or.isTypeOnly) {
                  var ki = er(Or.parent, hr);
                  if (ki) return ki;
                }
                if (e.isExportDeclaration(Or) && Or.isTypeOnly) {
                  var ki = ir(Or, hr);
                  if (ki) return ki;
                }
              }
              if (Se.kind === 127) {
                if (e.isImportSpecifier(Or) && Or.propertyName || e.isExportSpecifier(Or) && Or.propertyName || e.isNamespaceImport(Or) || e.isNamespaceExport(Or)) return Or.name;
                if (e.isExportDeclaration(Or) && Or.exportClause && e.isNamespaceExport(Or.exportClause)) return Or.exportClause.name;
              }
              if (Se.kind === 100 && e.isImportDeclaration(Or)) {
                var ki = er(Or, hr);
                if (ki) return ki;
              }
              if (Se.kind === 93) {
                if (e.isExportDeclaration(Or)) {
                  var ki = ir(Or, hr);
                  if (ki) return ki;
                }
                if (e.isExportAssignment(Or)) return e.skipOuterExpressions(Or.expression);
              }
              if (Se.kind === 146 && e.isExternalModuleReference(Or)) return Or.expression;
              if (Se.kind === 156 && (e.isImportDeclaration(Or) || e.isExportDeclaration(Or)) && Or.moduleSpecifier) return Or.moduleSpecifier;
              if ((Se.kind === 94 || Se.kind === 117) && e.isHeritageClause(Or) && Or.token === Se.kind) {
                var ki = Cr(Or);
                if (ki) return ki;
              }
              if (Se.kind === 94) {
                if (e.isTypeParameterDeclaration(Or) && Or.constraint && e.isTypeReferenceNode(Or.constraint)) return Or.constraint.typeName;
                if (e.isConditionalTypeNode(Or) && e.isTypeReferenceNode(Or.extendsType)) return Or.extendsType.typeName;
              }
              if (Se.kind === 137 && e.isInferTypeNode(Or)) return Or.typeParameter.name;
              if (Se.kind === 101 && e.isTypeParameterDeclaration(Or) && e.isMappedTypeNode(Or.parent)) return Or.name;
              if (Se.kind === 140 && e.isTypeOperatorNode(Or) && Or.operator === 140 && e.isTypeReferenceNode(Or.type)) return Or.type.typeName;
              if (Se.kind === 145 && e.isTypeOperatorNode(Or) && Or.operator === 145 && e.isArrayTypeNode(Or.type) && e.isTypeReferenceNode(Or.type.elementType)) return Or.type.elementType.typeName;
              if (!hr) {
                if ((Se.kind === 103 && e.isNewExpression(Or) || Se.kind === 114 && e.isVoidExpression(Or) || Se.kind === 112 && e.isTypeOfExpression(Or) || Se.kind === 132 && e.isAwaitExpression(Or) || Se.kind === 125 && e.isYieldExpression(Or) || Se.kind === 89 && e.isDeleteExpression(Or)) && Or.expression) return e.skipOuterExpressions(Or.expression);
                if ((Se.kind === 101 || Se.kind === 102) && e.isBinaryExpression(Or) && Or.operatorToken === Se) return e.skipOuterExpressions(Or.right);
                if (Se.kind === 127 && e.isAsExpression(Or) && e.isTypeReferenceNode(Or.type)) return Or.type.typeName;
                if (Se.kind === 101 && e.isForInStatement(Or) || Se.kind === 160 && e.isForOfStatement(Or)) return e.skipOuterExpressions(Or.expression);
              }
              return Se;
            }
            function Br(Se) {
              return Ye(Se, false);
            }
            e.getAdjustedReferenceLocation = Br;
            function Er(Se) {
              return Ye(Se, true);
            }
            e.getAdjustedRenameLocation = Er;
            function Ne(Se, hr) {
              return n(Se, hr, function(Or) {
                return e.isPropertyNameLiteral(Or) || e.isKeyword(Or.kind) || e.isPrivateIdentifier(Or);
              });
            }
            e.getTouchingPropertyName = Ne;
            function n(Se, hr, Or) {
              return be(Se, hr, false, Or, false);
            }
            e.getTouchingToken = n;
            function lr(Se, hr) {
              return be(Se, hr, true, void 0, false);
            }
            e.getTokenAtPosition = lr;
            function be(Se, hr, Or, ki, dt) {
              var la = Se, wa, On = function() {
                var po = la.getChildren(Se), Gn = e.binarySearchKey(po, hr, function($n, Ho) {
                  return Ho;
                }, function($n, Ho) {
                  var Zo = Or ? po[$n].getFullStart() : po[$n].getStart(Se, true);
                  return Zo > hr ? 1 : jo(po[$n]) ? po[$n - 1] && jo(po[$n - 1]) ? 1 : 0 : ki && Zo === hr && po[$n - 1] && po[$n - 1].getEnd() === hr && jo(po[$n - 1]) ? 1 : -1;
                });
                return wa ? { value: wa } : Gn >= 0 && po[Gn] ? (la = po[Gn], "continue-outer") : { value: la };
              };
              e: for (; ; ) {
                var No = On();
                if (typeof No == "object") return No.value;
                switch (No) {
                  case "continue-outer":
                    continue e;
                }
              }
              function jo(po) {
                var Gn = Or ? po.getFullStart() : po.getStart(Se, true);
                if (Gn > hr) return false;
                var $n = po.getEnd();
                if (hr < $n || hr === $n && (po.kind === 1 || dt)) return true;
                if (ki && $n === hr) {
                  var Ho = Ir(hr, Se, po);
                  if (Ho && ki(Ho)) return wa = Ho, true;
                }
                return false;
              }
            }
            function Ge(Se, hr) {
              for (var Or = lr(Se, hr); or(Or); ) {
                var ki = yr(Or, Or.parent, Se);
                if (!ki) return;
                Or = ki;
              }
              return Or;
            }
            e.findFirstNonJsxWhitespaceToken = Ge;
            function ur(Se, hr) {
              var Or = lr(Se, hr);
              return e.isToken(Or) && hr > Or.getStart(Se) && hr < Or.getEnd() ? Or : Ir(hr, Se);
            }
            e.findTokenOnLeftOfPosition = ur;
            function yr(Se, hr, Or) {
              return ki(hr);
              function ki(dt) {
                return e.isToken(dt) && dt.pos === Se.end ? dt : e.firstDefined(dt.getChildren(Or), function(la) {
                  var wa = la.pos <= Se.pos && la.end > Se.end || la.pos === Se.end;
                  return wa && pi(la, Or) ? ki(la) : void 0;
                });
              }
            }
            e.findNextToken = yr;
            function Ir(Se, hr, Or, ki) {
              var dt = la(Or || hr);
              return e.Debug.assert(!(dt && or(dt))), dt;
              function la(wa) {
                if (wr(wa) && wa.kind !== 1) return wa;
                var On = wa.getChildren(hr), No = e.binarySearchKey(On, Se, function(Zo, Es) {
                  return Es;
                }, function(Zo, Es) {
                  return Se < On[Zo].end ? !On[Zo - 1] || Se >= On[Zo - 1].end ? 0 : 1 : -1;
                });
                if (No >= 0 && On[No]) {
                  var jo = On[No];
                  if (Se < jo.end) {
                    var po = jo.getStart(hr, !ki), Gn = po >= Se || !pi(jo, hr) || or(jo);
                    if (Gn) {
                      var $n = ii(On, No, hr, wa.kind);
                      return $n && Ur($n, hr);
                    } else return la(jo);
                  }
                }
                e.Debug.assert(Or !== void 0 || wa.kind === 305 || wa.kind === 1 || e.isJSDocCommentContainingNode(wa));
                var Ho = ii(On, On.length, hr, wa.kind);
                return Ho && Ur(Ho, hr);
              }
            }
            e.findPrecedingToken = Ir;
            function wr(Se) {
              return e.isToken(Se) && !or(Se);
            }
            function Ur(Se, hr) {
              if (wr(Se)) return Se;
              var Or = Se.getChildren(hr);
              if (Or.length === 0) return Se;
              var ki = ii(Or, Or.length, hr, Se.kind);
              return ki && Ur(ki, hr);
            }
            function ii(Se, hr, Or, ki) {
              for (var dt = hr - 1; dt >= 0; dt--) {
                var la = Se[dt];
                if (or(la)) dt === 0 && (ki === 11 || ki === 279) && e.Debug.fail("`JsxText` tokens should not be the first child of `JsxElement | JsxSelfClosingElement`");
                else if (pi(Se[dt], Or)) return Se[dt];
              }
            }
            function mi(Se, hr, Or) {
              if (Or === void 0 && (Or = Ir(hr, Se)), Or && e.isStringTextContainingNode(Or)) {
                var ki = Or.getStart(Se), dt = Or.getEnd();
                if (ki < hr && hr < dt) return true;
                if (hr === dt) return !!Or.isUnterminated;
              }
              return false;
            }
            e.isInString = mi;
            function pe(Se, hr) {
              var Or = lr(Se, hr);
              return Or ? !!(Or.kind === 11 || Or.kind === 29 && Or.parent.kind === 11 || Or.kind === 29 && Or.parent.kind === 288 || Or && Or.kind === 19 && Or.parent.kind === 288 || Or.kind === 29 && Or.parent.kind === 281) : false;
            }
            e.isInsideJsxElementOrAttribute = pe;
            function or(Se) {
              return e.isJsxText(Se) && Se.containsOnlyTriviaWhiteSpaces;
            }
            function qr(Se, hr) {
              var Or = lr(Se, hr);
              return e.isTemplateLiteralKind(Or.kind) && hr > Or.getStart(Se);
            }
            e.isInTemplateString = qr;
            function si(Se, hr) {
              var Or = lr(Se, hr);
              return !!(e.isJsxText(Or) || Or.kind === 18 && e.isJsxExpression(Or.parent) && e.isJsxElement(Or.parent.parent) || Or.kind === 29 && e.isJsxOpeningLikeElement(Or.parent) && e.isJsxElement(Or.parent.parent));
            }
            e.isInJSXText = si;
            function Di(Se, hr) {
              function Or(ki) {
                for (; ki; ) if (ki.kind >= 279 && ki.kind <= 288 || ki.kind === 11 || ki.kind === 29 || ki.kind === 31 || ki.kind === 79 || ki.kind === 19 || ki.kind === 18 || ki.kind === 43) ki = ki.parent;
                else if (ki.kind === 278) {
                  if (hr > ki.getStart(Se)) return true;
                  ki = ki.parent;
                } else return false;
                return false;
              }
              return Or(lr(Se, hr));
            }
            e.isInsideJsxElement = Di;
            function wi(Se, hr, Or) {
              var ki = e.tokenToString(Se.kind), dt = e.tokenToString(hr), la = Se.getFullStart(), wa = Or.text.lastIndexOf(dt, la);
              if (wa !== -1) {
                if (Or.text.lastIndexOf(ki, la - 1) < wa) {
                  var On = Ir(wa + 1, Or);
                  if (On && On.kind === hr) return On;
                }
                for (var No = Se.kind, jo = 0; ; ) {
                  var po = Ir(Se.getFullStart(), Or);
                  if (!po) return;
                  if (Se = po, Se.kind === hr) {
                    if (jo === 0) return Se;
                    jo--;
                  } else Se.kind === No && jo++;
                }
              }
            }
            e.findPrecedingMatchingToken = wi;
            function Xi(Se, hr, Or) {
              return hr ? Se.getNonNullableType() : Or ? Se.getNonOptionalType() : Se;
            }
            e.removeOptionality = Xi;
            function et(Se, hr, Or) {
              var ki = Wt(Se, hr);
              return ki !== void 0 && (e.isPartOfTypeNode(ki.called) || Gi(ki.called, ki.nTypeArguments, Or).length !== 0 || et(ki.called, hr, Or));
            }
            e.isPossiblyTypeArgumentPosition = et;
            function Gi(Se, hr, Or) {
              var ki = Or.getTypeAtLocation(Se);
              e.isOptionalChain(Se.parent) && (ki = Xi(ki, e.isOptionalChainRoot(Se.parent), true));
              var dt = e.isNewExpression(Se.parent) ? ki.getConstructSignatures() : ki.getCallSignatures();
              return dt.filter(function(la) {
                return !!la.typeParameters && la.typeParameters.length >= hr;
              });
            }
            e.getPossibleGenericSignatures = Gi;
            function Wt(Se, hr) {
              if (hr.text.lastIndexOf("<", Se ? Se.pos : hr.text.length) !== -1) for (var Or = Se, ki = 0, dt = 0; Or; ) {
                switch (Or.kind) {
                  case 29:
                    if (Or = Ir(Or.getFullStart(), hr), Or && Or.kind === 28 && (Or = Ir(Or.getFullStart(), hr)), !Or || !e.isIdentifier(Or)) return;
                    if (!ki) return e.isDeclarationName(Or) ? void 0 : { called: Or, nTypeArguments: dt };
                    ki--;
                    break;
                  case 49:
                    ki = 3;
                    break;
                  case 48:
                    ki = 2;
                    break;
                  case 31:
                    ki++;
                    break;
                  case 19:
                    if (Or = wi(Or, 18, hr), !Or) return;
                    break;
                  case 21:
                    if (Or = wi(Or, 20, hr), !Or) return;
                    break;
                  case 23:
                    if (Or = wi(Or, 22, hr), !Or) return;
                    break;
                  case 27:
                    dt++;
                    break;
                  case 38:
                  case 79:
                  case 10:
                  case 8:
                  case 9:
                  case 110:
                  case 95:
                  case 112:
                  case 94:
                  case 140:
                  case 24:
                  case 51:
                  case 57:
                  case 58:
                    break;
                  default:
                    if (e.isTypeNode(Or)) break;
                    return;
                }
                Or = Ir(Or.getFullStart(), hr);
              }
            }
            e.getPossibleTypeArgumentsInfo = Wt;
            function Zt(Se, hr, Or) {
              return e.formatting.getRangeOfEnclosingComment(Se, hr, void 0, Or);
            }
            e.isInComment = Zt;
            function _r(Se, hr) {
              var Or = lr(Se, hr);
              return !!e.findAncestor(Or, e.isJSDoc);
            }
            e.hasDocComment = _r;
            function pi(Se, hr) {
              return Se.kind === 1 ? !!Se.jsDoc : Se.getWidth(hr) !== 0;
            }
            function ae(Se, hr) {
              hr === void 0 && (hr = 0);
              var Or = [], ki = e.isDeclaration(Se) ? e.getCombinedNodeFlagsAlwaysIncludeJSDoc(Se) & ~hr : 0;
              return ki & 8 && Or.push("private"), ki & 16 && Or.push("protected"), ki & 4 && Or.push("public"), (ki & 32 || e.isClassStaticBlockDeclaration(Se)) && Or.push("static"), ki & 128 && Or.push("abstract"), ki & 1 && Or.push("export"), ki & 8192 && Or.push("deprecated"), Se.flags & 16777216 && Or.push("declare"), Se.kind === 271 && Or.push("export"), Or.length > 0 ? Or.join(",") : "";
            }
            e.getNodeModifiers = ae;
            function Xe(Se) {
              if (Se.kind === 178 || Se.kind === 208) return Se.typeArguments;
              if (e.isFunctionLike(Se) || Se.kind === 257 || Se.kind === 258) return Se.typeParameters;
            }
            e.getTypeArgumentOrTypeParameterList = Xe;
            function Jr(Se) {
              return Se === 2 || Se === 3;
            }
            e.isComment = Jr;
            function ti(Se) {
              return !!(Se === 10 || Se === 13 || e.isTemplateLiteralKind(Se));
            }
            e.isStringOrRegularExpressionOrTemplateLiteral = ti;
            function Ze(Se) {
              return 18 <= Se && Se <= 78;
            }
            e.isPunctuation = Ze;
            function Sr(Se, hr, Or) {
              return e.isTemplateLiteralKind(Se.kind) && Se.getStart(Or) < hr && hr < Se.end || !!Se.isUnterminated && hr === Se.end;
            }
            e.isInsideTemplateLiteral = Sr;
            function zr(Se) {
              switch (Se) {
                case 123:
                case 121:
                case 122:
                  return true;
              }
              return false;
            }
            e.isAccessibilityModifier = zr;
            function Wr(Se) {
              var hr = e.clone(Se);
              return e.setConfigFileInOptions(hr, Se && Se.configFile), hr;
            }
            e.cloneCompilerOptions = Wr;
            function Je(Se) {
              return !!((Se.kind === 204 || Se.kind === 205) && (Se.parent.kind === 221 && Se.parent.left === Se && Se.parent.operatorToken.kind === 63 || Se.parent.kind === 244 && Se.parent.initializer === Se || Je(Se.parent.kind === 296 ? Se.parent.parent : Se.parent)));
            }
            e.isArrayLiteralOrObjectLiteralDestructuringPattern = Je;
            function xe(Se, hr) {
              return mr(Se, hr, true);
            }
            e.isInReferenceComment = xe;
            function vr(Se, hr) {
              return mr(Se, hr, false);
            }
            e.isInNonReferenceComment = vr;
            function mr(Se, hr, Or) {
              var ki = Zt(Se, hr, void 0);
              return !!ki && Or === j.test(Se.text.substring(ki.pos, ki.end));
            }
            function Ar(Se) {
              if (!!Se) switch (Se.kind) {
                case 10:
                case 14:
                  return nr(Se);
                default:
                  return Oe(Se);
              }
            }
            e.getReplacementSpanForContextToken = Ar;
            function Oe(Se, hr, Or) {
              return e.createTextSpanFromBounds(Se.getStart(hr), (Or || Se).getEnd());
            }
            e.createTextSpanFromNode = Oe;
            function nr(Se) {
              if (!Se.isUnterminated) return e.createTextSpanFromBounds(Se.getStart() + 1, Se.getEnd() - 1);
            }
            e.createTextSpanFromStringLiteralLikeContent = nr;
            function Mr(Se, hr) {
              return e.createRange(Se.getStart(hr), Se.end);
            }
            e.createTextRangeFromNode = Mr;
            function Pe(Se) {
              return e.createTextSpanFromBounds(Se.pos, Se.end);
            }
            e.createTextSpanFromRange = Pe;
            function Ue(Se) {
              return e.createRange(Se.start, Se.start + Se.length);
            }
            e.createTextRangeFromSpan = Ue;
            function fr(Se, hr, Or) {
              return De(e.createTextSpan(Se, hr), Or);
            }
            e.createTextChangeFromStartLength = fr;
            function De(Se, hr) {
              return { span: Se, newText: hr };
            }
            e.createTextChange = De, e.typeKeywords = [130, 128, 158, 133, 95, 137, 140, 143, 104, 147, 148, 145, 150, 151, 110, 114, 153, 154, 155];
            function gr(Se) {
              return e.contains(e.typeKeywords, Se);
            }
            e.isTypeKeyword = gr;
            function Vr(Se) {
              return Se.kind === 152;
            }
            e.isTypeKeywordToken = Vr;
            function Tr(Se) {
              return Vr(Se) || e.isIdentifier(Se) && Se.text === "type";
            }
            e.isTypeKeywordTokenOrIdentifier = Tr;
            function vi(Se) {
              return !!(Se.flags & 1536) && Se.name.charCodeAt(0) === 34;
            }
            e.isExternalModuleSymbol = vi;
            function Ui() {
              var Se = [];
              return function(hr) {
                var Or = e.getNodeId(hr);
                return !Se[Or] && (Se[Or] = true);
              };
            }
            e.nodeSeenTracker = Ui;
            function Yi(Se) {
              return Se.getText(0, Se.getLength());
            }
            e.getSnapshotText = Yi;
            function Wi(Se, hr) {
              for (var Or = "", ki = 0; ki < hr; ki++) Or += Se;
              return Or;
            }
            e.repeatString = Wi;
            function ct(Se) {
              return Se.isTypeParameter() && Se.getConstraint() || Se;
            }
            e.skipConstraint = ct;
            function Li(Se) {
              return Se.kind === 162 ? e.isStringOrNumericLiteralLike(Se.expression) ? Se.expression.text : void 0 : e.isPrivateIdentifier(Se) ? e.idText(Se) : e.getTextOfIdentifierOrLiteral(Se);
            }
            e.getNameFromPropertyName = Li;
            function nt(Se) {
              return Se.getSourceFiles().some(function(hr) {
                return !hr.isDeclarationFile && !Se.isSourceFileFromExternalLibrary(hr) && !!(hr.externalModuleIndicator || hr.commonJsModuleIndicator);
              });
            }
            e.programContainsModules = nt;
            function Mt(Se) {
              return Se.getSourceFiles().some(function(hr) {
                return !hr.isDeclarationFile && !Se.isSourceFileFromExternalLibrary(hr) && !!hr.externalModuleIndicator;
              });
            }
            e.programContainsEsModules = Mt;
            function xt(Se) {
              return !!Se.module || e.getEmitScriptTarget(Se) >= 2 || !!Se.noEmit;
            }
            e.compilerOptionsIndicateEsModules = xt;
            function ut(Se, hr) {
              return { fileExists: function(Or) {
                return Se.fileExists(Or);
              }, getCurrentDirectory: function() {
                return hr.getCurrentDirectory();
              }, readFile: e.maybeBind(hr, hr.readFile), useCaseSensitiveFileNames: e.maybeBind(hr, hr.useCaseSensitiveFileNames), getSymlinkCache: e.maybeBind(hr, hr.getSymlinkCache) || Se.getSymlinkCache, getModuleSpecifierCache: e.maybeBind(hr, hr.getModuleSpecifierCache), getPackageJsonInfoCache: function() {
                var Or;
                return (Or = Se.getModuleResolutionCache()) === null || Or === void 0 ? void 0 : Or.getPackageJsonInfoCache();
              }, getGlobalTypingsCacheLocation: e.maybeBind(hr, hr.getGlobalTypingsCacheLocation), redirectTargetsMap: Se.redirectTargetsMap, getProjectReferenceRedirect: function(Or) {
                return Se.getProjectReferenceRedirect(Or);
              }, isSourceOfProjectReferenceRedirect: function(Or) {
                return Se.isSourceOfProjectReferenceRedirect(Or);
              }, getNearestAncestorDirectoryWithPackageJson: e.maybeBind(hr, hr.getNearestAncestorDirectoryWithPackageJson), getFileIncludeReasons: function() {
                return Se.getFileIncludeReasons();
              } };
            }
            e.createModuleSpecifierResolutionHost = ut;
            function Dt(Se, hr) {
              return Ke(Ke({}, ut(Se, hr)), { getCommonSourceDirectory: function() {
                return Se.getCommonSourceDirectory();
              } });
            }
            e.getModuleSpecifierResolverHost = Dt;
            function Rt(Se) {
              return Se >= e.ModuleResolutionKind.Node16 && Se <= e.ModuleResolutionKind.NodeNext;
            }
            e.moduleResolutionRespectsExports = Rt;
            function Ii(Se) {
              return Se === e.ModuleResolutionKind.NodeJs || Se >= e.ModuleResolutionKind.Node16 && Se <= e.ModuleResolutionKind.NodeNext;
            }
            e.moduleResolutionUsesNodeModules = Ii;
            function Ki(Se, hr, Or, ki) {
              return Se || hr && hr.length ? Fi(Se, hr, Or, ki) : void 0;
            }
            e.makeImportIfNecessary = Ki;
            function Fi(Se, hr, Or, ki, dt) {
              return e.factory.createImportDeclaration(void 0, void 0, Se || hr ? e.factory.createImportClause(!!dt, Se, hr && hr.length ? e.factory.createNamedImports(hr) : void 0) : void 0, typeof Or == "string" ? ui(Or, ki) : Or, void 0);
            }
            e.makeImport = Fi;
            function ui(Se, hr) {
              return e.factory.createStringLiteral(Se, hr === 0);
            }
            e.makeStringLiteral = ui;
            var Bt;
            (function(Se) {
              Se[Se.Single = 0] = "Single", Se[Se.Double = 1] = "Double";
            })(Bt = e.QuotePreference || (e.QuotePreference = {}));
            function wt(Se, hr) {
              return e.isStringDoubleQuoted(Se, hr) ? 1 : 0;
            }
            e.quotePreferenceFromString = wt;
            function na(Se, hr) {
              if (hr.quotePreference && hr.quotePreference !== "auto") return hr.quotePreference === "single" ? 0 : 1;
              var Or = Se.imports && e.find(Se.imports, function(ki) {
                return e.isStringLiteral(ki) && !e.nodeIsSynthesized(ki.parent);
              });
              return Or ? wt(Or, Se) : 1;
            }
            e.getQuotePreference = na;
            function Ai(Se) {
              switch (Se) {
                case 0:
                  return "'";
                case 1:
                  return '"';
                default:
                  return e.Debug.assertNever(Se);
              }
            }
            e.getQuoteFromPreference = Ai;
            function Oi(Se) {
              var hr = ji(Se);
              return hr === void 0 ? void 0 : e.unescapeLeadingUnderscores(hr);
            }
            e.symbolNameNoDefault = Oi;
            function ji(Se) {
              return Se.escapedName !== "default" ? Se.escapedName : e.firstDefined(Se.declarations, function(hr) {
                var Or = e.getNameOfDeclaration(hr);
                return Or && Or.kind === 79 ? Or.escapedText : void 0;
              });
            }
            e.symbolEscapedNameNoDefault = ji;
            function Vi(Se) {
              return e.isStringLiteralLike(Se) && (e.isExternalModuleReference(Se.parent) || e.isImportDeclaration(Se.parent) || e.isRequireCall(Se.parent, false) && Se.parent.arguments[0] === Se || e.isImportCall(Se.parent) && Se.parent.arguments[0] === Se);
            }
            e.isModuleSpecifierLike = Vi;
            function at(Se) {
              return e.isBindingElement(Se) && e.isObjectBindingPattern(Se.parent) && e.isIdentifier(Se.name) && !Se.propertyName;
            }
            e.isObjectBindingElementWithoutPropertyName = at;
            function At(Se, hr) {
              var Or = Se.getTypeAtLocation(hr.parent);
              return Or && Se.getPropertyOfType(Or, hr.name.text);
            }
            e.getPropertySymbolFromBindingElement = At;
            function ba(Se, hr, Or) {
              if (!!Se) for (; Se.parent; ) {
                if (e.isSourceFile(Se.parent) || !$a(Or, Se.parent, hr)) return Se;
                Se = Se.parent;
              }
            }
            e.getParentNodeInSpan = ba;
            function $a(Se, hr, Or) {
              return e.textSpanContainsPosition(Se, hr.getStart(Or)) && hr.getEnd() <= e.textSpanEnd(Se);
            }
            function Qa(Se, hr) {
              return Se.modifiers && e.find(Se.modifiers, function(Or) {
                return Or.kind === hr;
              });
            }
            e.findModifier = Qa;
            function ai(Se, hr, Or, ki) {
              var dt = e.isArray(Or) ? Or[0] : Or, la = dt.kind === 237 ? e.isRequireVariableStatement : e.isAnyImportSyntax, wa = e.filter(hr.statements, la), On = e.isArray(Or) ? e.stableSort(Or, e.OrganizeImports.compareImportsOrRequireStatements) : [Or];
              if (!wa.length) Se.insertNodesAtTopOfFile(hr, On, ki);
              else if (wa && e.OrganizeImports.importsAreSorted(wa)) for (var No = 0, jo = On; No < jo.length; No++) {
                var po = jo[No], Gn = e.OrganizeImports.getImportDeclarationInsertionIndex(wa, po);
                if (Gn === 0) {
                  var $n = wa[0] === hr.statements[0] ? { leadingTriviaOption: e.textChanges.LeadingTriviaOption.Exclude } : {};
                  Se.insertNodeBefore(hr, wa[0], po, false, $n);
                } else {
                  var Ho = wa[Gn - 1];
                  Se.insertNodeAfter(hr, Ho, po);
                }
              }
              else {
                var Zo = e.lastOrUndefined(wa);
                Zo ? Se.insertNodesAfter(hr, Zo, On) : Se.insertNodesAtTopOfFile(hr, On, ki);
              }
            }
            e.insertImports = ai;
            function Dn(Se, hr) {
              return e.Debug.assert(Se.isTypeOnly), e.cast(Se.getChildAt(0, hr), Vr);
            }
            e.getTypeKeywordOfTypeOnlyImport = Dn;
            function ka(Se, hr) {
              return !!Se && !!hr && Se.start === hr.start && Se.length === hr.length;
            }
            e.textSpansEqual = ka;
            function Ba(Se, hr) {
              return Se.fileName === hr.fileName && ka(Se.textSpan, hr.textSpan);
            }
            e.documentSpansEqual = Ba;
            function pn(Se, hr) {
              if (Se) {
                for (var Or = 0; Or < Se.length; Or++) if (Se.indexOf(Se[Or]) === Or) {
                  var ki = hr(Se[Or], Or);
                  if (ki) return ki;
                }
              }
            }
            e.forEachUnique = pn;
            function Cn(Se, hr, Or) {
              for (var ki = hr; ki < Or; ki++) if (!e.isWhiteSpaceLike(Se.charCodeAt(ki))) return false;
              return true;
            }
            e.isTextWhiteSpaceLike = Cn;
            function Bi(Se) {
              var hr = Se.declarations ? e.firstOrUndefined(Se.declarations) : void 0;
              return !!e.findAncestor(hr, function(Or) {
                return e.isParameter(Or) ? true : e.isBindingElement(Or) || e.isObjectBindingPattern(Or) || e.isArrayBindingPattern(Or) ? false : "quit";
              });
            }
            e.isFirstDeclarationOfSymbolParameter = Bi;
            var kn = xn();
            function xn() {
              var Se = e.defaultMaximumTruncationLength * 10, hr, Or, ki, dt;
              po();
              var la = function(Gn) {
                return On(Gn, e.SymbolDisplayPartKind.text);
              };
              return { displayParts: function() {
                var Gn = hr.length && hr[hr.length - 1].text;
                return dt > Se && Gn && Gn !== "..." && (e.isWhiteSpaceLike(Gn.charCodeAt(Gn.length - 1)) || hr.push(Pn(" ", e.SymbolDisplayPartKind.space)), hr.push(Pn("...", e.SymbolDisplayPartKind.punctuation))), hr;
              }, writeKeyword: function(Gn) {
                return On(Gn, e.SymbolDisplayPartKind.keyword);
              }, writeOperator: function(Gn) {
                return On(Gn, e.SymbolDisplayPartKind.operator);
              }, writePunctuation: function(Gn) {
                return On(Gn, e.SymbolDisplayPartKind.punctuation);
              }, writeTrailingSemicolon: function(Gn) {
                return On(Gn, e.SymbolDisplayPartKind.punctuation);
              }, writeSpace: function(Gn) {
                return On(Gn, e.SymbolDisplayPartKind.space);
              }, writeStringLiteral: function(Gn) {
                return On(Gn, e.SymbolDisplayPartKind.stringLiteral);
              }, writeParameter: function(Gn) {
                return On(Gn, e.SymbolDisplayPartKind.parameterName);
              }, writeProperty: function(Gn) {
                return On(Gn, e.SymbolDisplayPartKind.propertyName);
              }, writeLiteral: function(Gn) {
                return On(Gn, e.SymbolDisplayPartKind.stringLiteral);
              }, writeSymbol: No, writeLine: jo, write: la, writeComment: la, getText: function() {
                return "";
              }, getTextPos: function() {
                return 0;
              }, getColumn: function() {
                return 0;
              }, getLine: function() {
                return 0;
              }, isAtStartOfLine: function() {
                return false;
              }, hasTrailingWhitespace: function() {
                return false;
              }, hasTrailingComment: function() {
                return false;
              }, rawWrite: e.notImplemented, getIndent: function() {
                return ki;
              }, increaseIndent: function() {
                ki++;
              }, decreaseIndent: function() {
                ki--;
              }, clear: po, trackSymbol: function() {
                return false;
              }, reportInaccessibleThisError: e.noop, reportInaccessibleUniqueSymbolError: e.noop, reportPrivateInBaseOfClassExpression: e.noop };
              function wa() {
                if (!(dt > Se) && Or) {
                  var Gn = e.getIndentString(ki);
                  Gn && (dt += Gn.length, hr.push(Pn(Gn, e.SymbolDisplayPartKind.space))), Or = false;
                }
              }
              function On(Gn, $n) {
                dt > Se || (wa(), dt += Gn.length, hr.push(Pn(Gn, $n)));
              }
              function No(Gn, $n) {
                dt > Se || (wa(), dt += Gn.length, hr.push(Kn(Gn, $n)));
              }
              function jo() {
                dt > Se || (dt += 1, hr.push(Jn()), Or = true);
              }
              function po() {
                hr = [], Or = true, ki = 0, dt = 0;
              }
            }
            function Kn(Se, hr) {
              return Pn(Se, Or(hr));
              function Or(ki) {
                var dt = ki.flags;
                return dt & 3 ? Bi(ki) ? e.SymbolDisplayPartKind.parameterName : e.SymbolDisplayPartKind.localName : dt & 4 || dt & 32768 || dt & 65536 ? e.SymbolDisplayPartKind.propertyName : dt & 8 ? e.SymbolDisplayPartKind.enumMemberName : dt & 16 ? e.SymbolDisplayPartKind.functionName : dt & 32 ? e.SymbolDisplayPartKind.className : dt & 64 ? e.SymbolDisplayPartKind.interfaceName : dt & 384 ? e.SymbolDisplayPartKind.enumName : dt & 1536 ? e.SymbolDisplayPartKind.moduleName : dt & 8192 ? e.SymbolDisplayPartKind.methodName : dt & 262144 ? e.SymbolDisplayPartKind.typeParameterName : dt & 524288 || dt & 2097152 ? e.SymbolDisplayPartKind.aliasName : e.SymbolDisplayPartKind.text;
              }
            }
            e.symbolPart = Kn;
            function Pn(Se, hr) {
              return { text: Se, kind: e.SymbolDisplayPartKind[hr] };
            }
            e.displayPart = Pn;
            function eo() {
              return Pn(" ", e.SymbolDisplayPartKind.space);
            }
            e.spacePart = eo;
            function Rn(Se) {
              return Pn(e.tokenToString(Se), e.SymbolDisplayPartKind.keyword);
            }
            e.keywordPart = Rn;
            function Da(Se) {
              return Pn(e.tokenToString(Se), e.SymbolDisplayPartKind.punctuation);
            }
            e.punctuationPart = Da;
            function bo(Se) {
              return Pn(e.tokenToString(Se), e.SymbolDisplayPartKind.operator);
            }
            e.operatorPart = bo;
            function Ro(Se) {
              return Pn(Se, e.SymbolDisplayPartKind.parameterName);
            }
            e.parameterNamePart = Ro;
            function En(Se) {
              return Pn(Se, e.SymbolDisplayPartKind.propertyName);
            }
            e.propertyNamePart = En;
            function Wn(Se) {
              var hr = e.stringToToken(Se);
              return hr === void 0 ? to(Se) : Rn(hr);
            }
            e.textOrKeywordPart = Wn;
            function to(Se) {
              return Pn(Se, e.SymbolDisplayPartKind.text);
            }
            e.textPart = to;
            function Co(Se) {
              return Pn(Se, e.SymbolDisplayPartKind.aliasName);
            }
            e.typeAliasNamePart = Co;
            function Ko(Se) {
              return Pn(Se, e.SymbolDisplayPartKind.typeParameterName);
            }
            e.typeParameterNamePart = Ko;
            function Oo(Se) {
              return Pn(Se, e.SymbolDisplayPartKind.linkText);
            }
            e.linkTextPart = Oo;
            function no(Se, hr) {
              return { text: Se, kind: e.SymbolDisplayPartKind[e.SymbolDisplayPartKind.linkName], target: { fileName: e.getSourceFileOfNode(hr).fileName, textSpan: Oe(hr) } };
            }
            e.linkNamePart = no;
            function $o(Se) {
              return Pn(Se, e.SymbolDisplayPartKind.link);
            }
            e.linkPart = $o;
            function Pr(Se, hr) {
              var Or, ki = e.isJSDocLink(Se) ? "link" : e.isJSDocLinkCode(Se) ? "linkcode" : "linkplain", dt = [$o("{@".concat(ki, " "))];
              if (!Se.name) Se.text && dt.push(Oo(Se.text));
              else {
                var la = hr == null ? void 0 : hr.getSymbolAtLocation(Se.name), wa = St(Se.text), On = e.getTextOfNode(Se.name) + Se.text.slice(0, wa), No = xi(Se.text.slice(wa)), jo = (la == null ? void 0 : la.valueDeclaration) || ((Or = la == null ? void 0 : la.declarations) === null || Or === void 0 ? void 0 : Or[0]);
                jo ? (dt.push(no(On, jo)), No && dt.push(Oo(No))) : dt.push(Oo(On + (wa || No.indexOf("://") === 0 ? "" : " ") + No));
              }
              return dt.push($o("}")), dt;
            }
            e.buildLinkParts = Pr;
            function xi(Se) {
              var hr = 0;
              if (Se.charCodeAt(hr++) === 124) {
                for (; hr < Se.length && Se.charCodeAt(hr) === 32; ) hr++;
                return Se.slice(hr);
              }
              return Se;
            }
            function St(Se) {
              if (Se.indexOf("()") === 0) return 2;
              if (Se[0] !== "<") return 0;
              for (var hr = 0, Or = 0; Or < Se.length; ) if (Se[Or] === "<" && hr++, Se[Or] === ">" && hr--, Or++, !hr) return Or;
              return 0;
            }
            var pa = `\r
`;
            function dn(Se, hr) {
              var Or;
              return (hr == null ? void 0 : hr.newLineCharacter) || ((Or = Se.getNewLine) === null || Or === void 0 ? void 0 : Or.call(Se)) || pa;
            }
            e.getNewLineOrDefaultFromHost = dn;
            function Jn() {
              return Pn(`
`, e.SymbolDisplayPartKind.lineBreak);
            }
            e.lineBreakPart = Jn;
            function Qe(Se) {
              try {
                return Se(kn), kn.displayParts();
              } finally {
                kn.clear();
              }
            }
            e.mapToDisplayParts = Qe;
            function Gr(Se, hr, Or, ki) {
              return ki === void 0 && (ki = 0), Qe(function(dt) {
                Se.writeType(hr, Or, ki | 1024 | 16384, dt);
              });
            }
            e.typeToDisplayParts = Gr;
            function S(Se, hr, Or, ki, dt) {
              return dt === void 0 && (dt = 0), Qe(function(la) {
                Se.writeSymbol(hr, Or, ki, dt | 8, la);
              });
            }
            e.symbolToDisplayParts = S;
            function Ce(Se, hr, Or, ki) {
              return ki === void 0 && (ki = 0), ki |= 25632, Qe(function(dt) {
                Se.writeSignature(hr, Or, ki, void 0, dt);
              });
            }
            e.signatureToDisplayParts = Ce;
            function qe(Se, hr) {
              var Or = hr.getSourceFile();
              return Qe(function(ki) {
                var dt = e.createPrinter({ removeComments: true, omitTrailingSemicolon: true });
                dt.writeNode(4, Se, Or, ki);
              });
            }
            e.nodeToDisplayParts = qe;
            function br(Se) {
              return !!Se.parent && e.isImportOrExportSpecifier(Se.parent) && Se.parent.propertyName === Se;
            }
            e.isImportOrExportSpecifierName = br;
            function Zr(Se, hr) {
              return e.ensureScriptKind(Se, hr.getScriptKind && hr.getScriptKind(Se));
            }
            e.getScriptKind = Zr;
            function Si(Se, hr) {
              for (var Or = Se; Qi(Or) || Pi(Or) && Or.target; ) Pi(Or) && Or.target ? Or = Or.target : Or = e.skipAlias(Or, hr);
              return Or;
            }
            e.getSymbolTarget = Si;
            function Pi(Se) {
              return (Se.flags & 33554432) !== 0;
            }
            function Qi(Se) {
              return (Se.flags & 2097152) !== 0;
            }
            function Ct(Se, hr) {
              return e.getSymbolId(e.skipAlias(Se, hr));
            }
            e.getUniqueSymbolId = Ct;
            function sa(Se, hr) {
              for (; e.isWhiteSpaceLike(Se.charCodeAt(hr)); ) hr += 1;
              return hr;
            }
            e.getFirstNonSpaceCharacterPosition = sa;
            function en(Se, hr) {
              for (; hr > -1 && e.isWhiteSpaceSingleLine(Se.charCodeAt(hr)); ) hr -= 1;
              return hr + 1;
            }
            e.getPrecedingNonSpaceCharacterPosition = en;
            function Wa(Se, hr) {
              hr === void 0 && (hr = true);
              var Or = Se && mo(Se);
              return Or && !hr && ys(Or), Or;
            }
            e.getSynthesizedDeepClone = Wa;
            function qn(Se, hr, Or) {
              var ki = Or(Se);
              return ki ? e.setOriginalNode(ki, Se) : ki = mo(Se, Or), ki && !hr && ys(ki), ki;
            }
            e.getSynthesizedDeepCloneWithReplacements = qn;
            function mo(Se, hr) {
              var Or = hr ? function(wa) {
                return qn(wa, true, hr);
              } : Wa, ki = hr ? function(wa) {
                return wa && Go(wa, true, hr);
              } : function(wa) {
                return wa && So(wa);
              }, dt = e.visitEachChild(Se, Or, e.nullTransformationContext, ki, Or);
              if (dt === Se) {
                var la = e.isStringLiteral(Se) ? e.setOriginalNode(e.factory.createStringLiteralFromNode(Se), Se) : e.isNumericLiteral(Se) ? e.setOriginalNode(e.factory.createNumericLiteral(Se.text, Se.numericLiteralFlags), Se) : e.factory.cloneNode(Se);
                return e.setTextRange(la, Se);
              }
              return dt.parent = void 0, dt;
            }
            function So(Se, hr) {
              return hr === void 0 && (hr = true), Se && e.factory.createNodeArray(Se.map(function(Or) {
                return Wa(Or, hr);
              }), Se.hasTrailingComma);
            }
            e.getSynthesizedDeepClones = So;
            function Go(Se, hr, Or) {
              return e.factory.createNodeArray(Se.map(function(ki) {
                return qn(ki, hr, Or);
              }), Se.hasTrailingComma);
            }
            e.getSynthesizedDeepClonesWithReplacements = Go;
            function ys(Se) {
              Pc(Se), Vc(Se);
            }
            e.suppressLeadingAndTrailingTrivia = ys;
            function Pc(Se) {
              pc(Se, 512, hs);
            }
            e.suppressLeadingTrivia = Pc;
            function Vc(Se) {
              pc(Se, 1024, e.getLastChild);
            }
            e.suppressTrailingTrivia = Vc;
            function Kc(Se, hr) {
              var Or = Se.getSourceFile(), ki = Or.text;
              Xs(Se, ki) ? Qs(Se, hr, Or) : ds(Se, hr, Or), js(Se, hr, Or);
            }
            e.copyComments = Kc;
            function Xs(Se, hr) {
              for (var Or = Se.getFullStart(), ki = Se.getStart(), dt = Or; dt < ki; dt++) if (hr.charCodeAt(dt) === 10) return true;
              return false;
            }
            function pc(Se, hr, Or) {
              e.addEmitFlags(Se, hr);
              var ki = Or(Se);
              ki && pc(ki, hr, Or);
            }
            function hs(Se) {
              return Se.forEachChild(function(hr) {
                return hr;
              });
            }
            function tc(Se, hr) {
              for (var Or = Se, ki = 1; !e.isFileLevelUniqueName(hr, Or); ki++) Or = "".concat(Se, "_").concat(ki);
              return Or;
            }
            e.getUniqueName = tc;
            function ps(Se, hr, Or, ki) {
              for (var dt = 0, la = -1, wa = 0, On = Se; wa < On.length; wa++) {
                var No = On[wa], jo = No.fileName, po = No.textChanges;
                e.Debug.assert(jo === hr);
                for (var Gn = 0, $n = po; Gn < $n.length; Gn++) {
                  var Ho = $n[Gn], Zo = Ho.span, Es = Ho.newText, yc = ce(Es, Or);
                  if (yc !== -1 && (la = Zo.start + dt + yc, !ki)) return la;
                  dt += Es.length - Zo.length;
                }
              }
              return e.Debug.assert(ki), e.Debug.assert(la >= 0), la;
            }
            e.getRenameLocation = ps;
            function Qs(Se, hr, Or, ki, dt) {
              e.forEachLeadingCommentRange(Or.text, Se.pos, Ji(hr, Or, ki, dt, e.addSyntheticLeadingComment));
            }
            e.copyLeadingComments = Qs;
            function js(Se, hr, Or, ki, dt) {
              e.forEachTrailingCommentRange(Or.text, Se.end, Ji(hr, Or, ki, dt, e.addSyntheticTrailingComment));
            }
            e.copyTrailingComments = js;
            function ds(Se, hr, Or, ki, dt) {
              e.forEachTrailingCommentRange(Or.text, Se.pos, Ji(hr, Or, ki, dt, e.addSyntheticLeadingComment));
            }
            e.copyTrailingAsLeadingComments = ds;
            function Ji(Se, hr, Or, ki, dt) {
              return function(la, wa, On, No) {
                On === 3 ? (la += 2, wa -= 2) : la += 2, dt(Se, Or || On, hr.text.slice(la, wa), ki !== void 0 ? ki : No);
              };
            }
            function ce(Se, hr) {
              if (e.startsWith(Se, hr)) return 0;
              var Or = Se.indexOf(" " + hr);
              return Or === -1 && (Or = Se.indexOf("." + hr)), Or === -1 && (Or = Se.indexOf('"' + hr)), Or === -1 ? -1 : Or + 1;
            }
            function Rr(Se) {
              return e.isBinaryExpression(Se) && Se.operatorToken.kind === 27 || e.isObjectLiteralExpression(Se) || e.isAsExpression(Se) && e.isObjectLiteralExpression(Se.expression);
            }
            e.needsParentheses = Rr;
            function yi(Se, hr) {
              var Or = Se.parent;
              switch (Or.kind) {
                case 209:
                  return hr.getContextualType(Or);
                case 221: {
                  var ki = Or, dt = ki.left, la = ki.operatorToken, wa = ki.right;
                  return je(la.kind) ? hr.getTypeAtLocation(Se === wa ? dt : wa) : hr.getContextualType(Se);
                }
                case 289:
                  return Or.expression === Se ? Pt(Or, hr) : void 0;
                default:
                  return hr.getContextualType(Se);
              }
            }
            e.getContextualTypeFromParent = yi;
            function qi(Se, hr, Or) {
              var ki = na(Se, hr), dt = JSON.stringify(Or);
              return ki === 0 ? "'".concat(e.stripQuotes(dt).replace(/'/g, "\\'").replace(/\\"/g, '"'), "'") : dt;
            }
            e.quote = qi;
            function je(Se) {
              switch (Se) {
                case 36:
                case 34:
                case 37:
                case 35:
                  return true;
                default:
                  return false;
              }
            }
            e.isEqualityOperatorKind = je;
            function Hr(Se) {
              switch (Se.kind) {
                case 10:
                case 14:
                case 223:
                case 210:
                  return true;
                default:
                  return false;
              }
            }
            e.isStringLiteralOrTemplate = Hr;
            function pt(Se) {
              return !!Se.getStringIndexType() || !!Se.getNumberIndexType();
            }
            e.hasIndexSignature = pt;
            function Pt(Se, hr) {
              return hr.getTypeAtLocation(Se.parent.parent.expression);
            }
            e.getSwitchedType = Pt, e.ANONYMOUS = "anonymous function";
            function ga(Se, hr, Or, ki) {
              var dt = Or.getTypeChecker(), la = true, wa = function() {
                return la = false;
              }, On = dt.typeToTypeNode(Se, hr, 1, { trackSymbol: function(No, jo, po) {
                return la = la && dt.isSymbolAccessible(No, jo, po, false).accessibility === 0, !la;
              }, reportInaccessibleThisError: wa, reportPrivateInBaseOfClassExpression: wa, reportInaccessibleUniqueSymbolError: wa, moduleResolverHost: Dt(Or, ki) });
              return la ? On : void 0;
            }
            e.getTypeNodeIfAccessible = ga;
            function ua(Se) {
              return Se === 174 || Se === 175 || Se === 176 || Se === 166 || Se === 168;
            }
            function Xn(Se) {
              return Se === 256 || Se === 171 || Se === 169 || Se === 172 || Se === 173;
            }
            function jr(Se) {
              return Se === 261;
            }
            function fo(Se) {
              return Se === 237 || Se === 238 || Se === 240 || Se === 245 || Se === 246 || Se === 247 || Se === 251 || Se === 253 || Se === 167 || Se === 259 || Se === 266 || Se === 265 || Se === 272 || Se === 264 || Se === 271;
            }
            e.syntaxRequiresTrailingSemicolonOrASI = fo, e.syntaxMayBeASICandidate = e.or(ua, Xn, jr, fo);
            function xs(Se, hr) {
              var Or = Se.getLastToken(hr);
              if (Or && Or.kind === 26) return false;
              if (ua(Se.kind)) {
                if (Or && Or.kind === 27) return false;
              } else if (jr(Se.kind)) {
                var ki = e.last(Se.getChildren(hr));
                if (ki && e.isModuleBlock(ki)) return false;
              } else if (Xn(Se.kind)) {
                var ki = e.last(Se.getChildren(hr));
                if (ki && e.isFunctionBlock(ki)) return false;
              } else if (!fo(Se.kind)) return false;
              if (Se.kind === 240) return true;
              var dt = e.findAncestor(Se, function(No) {
                return !No.parent;
              }), la = yr(Se, dt, hr);
              if (!la || la.kind === 19) return true;
              var wa = hr.getLineAndCharacterOfPosition(Se.getEnd()).line, On = hr.getLineAndCharacterOfPosition(la.getStart(hr)).line;
              return wa !== On;
            }
            function Fo(Se, hr, Or) {
              var ki = e.findAncestor(hr, function(dt) {
                return dt.end !== Se ? "quit" : e.syntaxMayBeASICandidate(dt.kind);
              });
              return !!ki && xs(ki, Or);
            }
            e.positionIsASICandidate = Fo;
            function ko(Se) {
              var hr = 0, Or = 0, ki = 5;
              return e.forEachChild(Se, function dt(la) {
                if (fo(la.kind)) {
                  var wa = la.getLastToken(Se);
                  (wa == null ? void 0 : wa.kind) === 26 ? hr++ : Or++;
                } else if (ua(la.kind)) {
                  var wa = la.getLastToken(Se);
                  if ((wa == null ? void 0 : wa.kind) === 26) hr++;
                  else if (wa && wa.kind !== 27) {
                    var On = e.getLineAndCharacterOfPosition(Se, wa.getStart(Se)).line, No = e.getLineAndCharacterOfPosition(Se, e.getSpanOfTokenAtPosition(Se, wa.end).start).line;
                    On !== No && Or++;
                  }
                }
                return hr + Or >= ki ? true : e.forEachChild(la, dt);
              }), hr === 0 && Or <= 1 ? true : hr / Or > 1 / ki;
            }
            e.probablyUsesSemicolons = ko;
            function Ao(Se, hr) {
              return tl(Se, Se.getDirectories, hr) || [];
            }
            e.tryGetDirectories = Ao;
            function Ms(Se, hr, Or, ki, dt) {
              return tl(Se, Se.readDirectory, hr, Or, ki, dt) || e.emptyArray;
            }
            e.tryReadDirectory = Ms;
            function Bs(Se, hr) {
              return tl(Se, Se.fileExists, hr);
            }
            e.tryFileExists = Bs;
            function xc(Se, hr) {
              return su(function() {
                return e.directoryProbablyExists(hr, Se);
              }) || false;
            }
            e.tryDirectoryExists = xc;
            function su(Se) {
              try {
                return Se();
              } catch {
                return;
              }
            }
            e.tryAndIgnoreErrors = su;
            function tl(Se, hr) {
              for (var Or = [], ki = 2; ki < arguments.length; ki++) Or[ki - 2] = arguments[ki];
              return su(function() {
                return hr && hr.apply(Se, Or);
              });
            }
            e.tryIOAndConsumeErrors = tl;
            function Zc(Se, hr, Or) {
              var ki = [];
              return e.forEachAncestorDirectory(Se, function(dt) {
                if (dt === Or) return true;
                var la = e.combinePaths(dt, "package.json");
                Bs(hr, la) && ki.push(la);
              }), ki;
            }
            e.findPackageJsons = Zc;
            function Rf(Se, hr) {
              var Or;
              return e.forEachAncestorDirectory(Se, function(ki) {
                if (ki === "node_modules" || (Or = e.findConfigFile(ki, function(dt) {
                  return Bs(hr, dt);
                }, "package.json"), Or)) return true;
              }), Or;
            }
            e.findPackageJson = Rf;
            function al(Se, hr) {
              if (!hr.fileExists) return [];
              var Or = [];
              return e.forEachAncestorDirectory(e.getDirectoryPath(Se), function(ki) {
                var dt = e.combinePaths(ki, "package.json");
                if (hr.fileExists(dt)) {
                  var la = Jo(dt, hr);
                  la && Or.push(la);
                }
              }), Or;
            }
            e.getPackageJsonsVisibleToFile = al;
            function Jo(Se, hr) {
              if (!hr.readFile) return;
              var Or = ["dependencies", "devDependencies", "optionalDependencies", "peerDependencies"], ki = hr.readFile(Se) || "", dt = Ws(ki), la = {};
              if (dt) for (var wa = 0, On = Or; wa < On.length; wa++) {
                var No = On[wa], jo = dt[No];
                if (!!jo) {
                  var po = new e.Map();
                  for (var Gn in jo) po.set(Gn, jo[Gn]);
                  la[No] = po;
                }
              }
              var $n = [[1, la.dependencies], [2, la.devDependencies], [8, la.optionalDependencies], [4, la.peerDependencies]];
              return Ke(Ke({}, la), { parseable: !!dt, fileName: Se, get: Ho, has: function(Zo, Es) {
                return !!Ho(Zo, Es);
              } });
              function Ho(Zo, Es) {
                Es === void 0 && (Es = 15);
                for (var yc = 0, Xr = $n; yc < Xr.length; yc++) {
                  var Ls = Xr[yc], Ic = Ls[0], zu = Ls[1];
                  if (zu && Es & Ic) {
                    var vf = zu.get(Zo);
                    if (vf !== void 0) return vf;
                  }
                }
              }
            }
            e.createPackageJsonInfo = Jo;
            function eu(Se, hr, Or) {
              var ki = (Or.getPackageJsonsVisibleToFile && Or.getPackageJsonsVisibleToFile(Se.fileName) || al(Se.fileName, Or)).filter(function($n) {
                return $n.parseable;
              }), dt;
              return { allowsImportingAmbientModule: wa, allowsImportingSourceFile: On, allowsImportingSpecifier: No };
              function la($n) {
                for (var Ho = Gn($n), Zo = 0, Es = ki; Zo < Es.length; Zo++) {
                  var yc = Es[Zo];
                  if (yc.has(Ho) || yc.has(e.getTypesPackageName(Ho))) return true;
                }
                return false;
              }
              function wa($n, Ho) {
                if (!ki.length || !$n.valueDeclaration) return true;
                var Zo = $n.valueDeclaration.getSourceFile(), Es = po(Zo.fileName, Ho);
                if (typeof Es > "u") return true;
                var yc = e.stripQuotes($n.getName());
                return jo(yc) ? true : la(Es) || la(yc);
              }
              function On($n, Ho) {
                if (!ki.length) return true;
                var Zo = po($n.fileName, Ho);
                return Zo ? la(Zo) : true;
              }
              function No($n) {
                return !ki.length || jo($n) || e.pathIsRelative($n) || e.isRootedDiskPath($n) ? true : la($n);
              }
              function jo($n) {
                return !!(e.isSourceFileJS(Se) && e.JsTyping.nodeCoreModules.has($n) && (dt === void 0 && (dt = pu(Se)), dt));
              }
              function po($n, Ho) {
                if (!!e.stringContains($n, "node_modules")) {
                  var Zo = e.moduleSpecifiers.getNodeModulesPackageName(Or.getCompilationSettings(), Se, $n, Ho, hr);
                  if (!!Zo && !e.pathIsRelative(Zo) && !e.isRootedDiskPath(Zo)) return Gn(Zo);
                }
              }
              function Gn($n) {
                var Ho = e.getPathComponents(e.getPackageNameFromTypesPackageName($n)).slice(1);
                return e.startsWith(Ho[0], "@") ? "".concat(Ho[0], "/").concat(Ho[1]) : Ho[0];
              }
            }
            e.createPackageJsonImportFilter = eu;
            function Ws(Se) {
              try {
                return JSON.parse(Se);
              } catch {
                return;
              }
            }
            function pu(Se) {
              return e.some(Se.imports, function(hr) {
                var Or = hr.text;
                return e.JsTyping.nodeCoreModules.has(Or);
              });
            }
            e.consumesNodeCoreModules = pu;
            function Uu(Se) {
              return e.contains(e.getPathComponents(Se), "node_modules");
            }
            e.isInsideNodeModules = Uu;
            function Ql(Se) {
              return Se.file !== void 0 && Se.start !== void 0 && Se.length !== void 0;
            }
            e.isDiagnosticWithLocation = Ql;
            function xl(Se, hr) {
              var Or = Oe(Se), ki = e.binarySearchKey(hr, Or, e.identity, e.compareTextSpans);
              if (ki >= 0) {
                var dt = hr[ki];
                return e.Debug.assertEqual(dt.file, Se.getSourceFile(), "Diagnostics proided to 'findDiagnosticForNode' must be from a single SourceFile"), e.cast(dt, Ql);
              }
            }
            e.findDiagnosticForNode = xl;
            function Ya(Se, hr) {
              var Or, ki = e.binarySearchKey(hr, Se.start, function(On) {
                return On.start;
              }, e.compareValues);
              for (ki < 0 && (ki = ~ki); ((Or = hr[ki - 1]) === null || Or === void 0 ? void 0 : Or.start) === Se.start; ) ki--;
              for (var dt = [], la = e.textSpanEnd(Se); ; ) {
                var wa = e.tryCast(hr[ki], Ql);
                if (!wa || wa.start > la) break;
                e.textSpanContainsTextSpan(Se, wa) && dt.push(wa), ki++;
              }
              return dt;
            }
            e.getDiagnosticsWithinSpan = Ya;
            function du(Se) {
              var hr = Se.startPosition, Or = Se.endPosition;
              return e.createTextSpanFromBounds(hr, Or === void 0 ? hr : Or);
            }
            e.getRefactorContextSpan = du;
            function vc(Se, hr) {
              var Or = lr(Se, hr.start), ki = e.findAncestor(Or, function(dt) {
                return dt.getStart(Se) < hr.start || dt.getEnd() > e.textSpanEnd(hr) ? "quit" : e.isExpression(dt) && ka(hr, Oe(dt, Se));
              });
              return ki;
            }
            e.getFixableErrorSpanExpression = vc;
            function Kr(Se, hr, Or) {
              return Or === void 0 && (Or = e.identity), Se ? e.isArray(Se) ? Or(e.map(Se, hr)) : hr(Se, 0) : void 0;
            }
            e.mapOneOrMany = Kr;
            function _i(Se) {
              return e.isArray(Se) ? e.first(Se) : Se;
            }
            e.firstOrOnly = _i;
            function Ei(Se, hr) {
              if (kt(Se)) {
                var Or = bt(Se);
                if (Or) return Or;
                var ki = e.codefix.moduleSymbolToValidIdentifier(ia(Se), hr, false), dt = e.codefix.moduleSymbolToValidIdentifier(ia(Se), hr, true);
                return ki === dt ? ki : [ki, dt];
              }
              return Se.name;
            }
            e.getNamesForExportedSymbol = Ei;
            function tt(Se, hr, Or) {
              return kt(Se) ? bt(Se) || e.codefix.moduleSymbolToValidIdentifier(ia(Se), hr, !!Or) : Se.name;
            }
            e.getNameForExportedSymbol = tt;
            function kt(Se) {
              return !(Se.flags & 33554432) && (Se.escapedName === "export=" || Se.escapedName === "default");
            }
            function bt(Se) {
              return e.firstDefined(Se.declarations, function(hr) {
                var Or;
                return e.isExportAssignment(hr) ? (Or = e.tryCast(e.skipOuterExpressions(hr.expression), e.isIdentifier)) === null || Or === void 0 ? void 0 : Or.text : void 0;
              });
            }
            function ia(Se) {
              var hr;
              return e.Debug.checkDefined(Se.parent, "Symbol parent was undefined. Flags: ".concat(e.Debug.formatSymbolFlags(Se.flags), ". ") + "Declarations: ".concat((hr = Se.declarations) === null || hr === void 0 ? void 0 : hr.map(function(Or) {
                var ki = e.Debug.formatSyntaxKind(Or.kind), dt = e.isInJSFile(Or), la = Or.expression;
                return (dt ? "[JS]" : "") + ki + (la ? " (expression: ".concat(e.Debug.formatSyntaxKind(la.kind), ")") : "");
              }).join(", "), "."));
            }
            function Xt(Se, hr, Or) {
              var ki = hr.length;
              if (ki + Or > Se.length) return false;
              for (var dt = 0; dt < ki; dt++) if (hr.charCodeAt(dt) !== Se.charCodeAt(dt + Or)) return false;
              return true;
            }
            e.stringContainsAt = Xt;
            function Za(Se) {
              return Se.charCodeAt(0) === 95;
            }
            e.startsWithUnderscore = Za;
            function bn(Se) {
              return !_a(Se);
            }
            e.isGlobalDeclaration = bn;
            function _a(Se) {
              var hr = Se.getSourceFile();
              return !hr.externalModuleIndicator && !hr.commonJsModuleIndicator ? false : e.isInJSFile(Se) || !e.findAncestor(Se, e.isGlobalScopeAugmentation);
            }
            e.isNonGlobalDeclaration = _a;
            function qa(Se) {
              return !!(e.getCombinedNodeFlagsAlwaysIncludeJSDoc(Se) & 8192);
            }
            e.isDeprecatedDeclaration = qa;
            function rn(Se, hr) {
              var Or = e.firstDefined(Se.imports, function(ki) {
                if (e.JsTyping.nodeCoreModules.has(ki.text)) return e.startsWith(ki.text, "node:");
              });
              return Or != null ? Or : hr.usesUriStyleNodeCoreModules;
            }
            e.shouldUseUriStyleNodeCoreModules = rn;
            function jn(Se) {
              return Se === `
` ? 1 : 0;
            }
            e.getNewLineKind = jn;
            function Mo(Se) {
              return e.isArray(Se) ? e.formatStringFromArgs(e.getLocaleSpecificMessage(Se[0]), Se.slice(1)) : e.getLocaleSpecificMessage(Se);
            }
            e.diagnosticToString = Mo;
            function ho(Se, hr) {
              var Or = Se.options, ki = !Or.semicolons || Or.semicolons === e.SemicolonPreference.Ignore, dt = Or.semicolons === e.SemicolonPreference.Remove || ki && !ko(hr);
              return Ke(Ke({}, Or), { semicolons: dt ? e.SemicolonPreference.Remove : e.SemicolonPreference.Ignore });
            }
            e.getFormatCodeSettingsForWriting = ho;
            function gs(Se) {
              return Se === 2 || Se === 3;
            }
            e.jsxModeNeedsExplicitImport = gs;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(T) {
              T[T.Named = 0] = "Named", T[T.Default = 1] = "Default", T[T.Namespace = 2] = "Namespace", T[T.CommonJS = 3] = "CommonJS";
            })(a = e.ImportKind || (e.ImportKind = {}));
            var C;
            (function(T) {
              T[T.Named = 0] = "Named", T[T.Default = 1] = "Default", T[T.ExportEquals = 2] = "ExportEquals", T[T.UMD = 3] = "UMD";
            })(C = e.ExportKind || (e.ExportKind = {}));
            function w(T) {
              var K = 1, b = e.createMultiMap(), se = new e.Map(), J = new e.Map(), ie, R = { isUsableByFile: function(x) {
                return x === ie;
              }, isEmpty: function() {
                return !b.size;
              }, clear: function() {
                b.clear(), se.clear(), ie = void 0;
              }, add: function(x, X, $, A, y, V, L, P) {
                x !== ie && (R.clear(), ie = x);
                var k;
                if (y) {
                  var Y = e.getNodeModulePathParts(y.fileName);
                  if (Y) {
                    var U = Y.topLevelNodeModulesIndex, j = Y.topLevelPackageNameIndex, H = Y.packageRootIndex;
                    if (k = e.unmangleScopedPackageName(e.getPackageNameFromTypesPackageName(y.fileName.substring(j + 1, H))), e.startsWith(x, y.path.substring(0, U))) {
                      var I = J.get(k), l = y.fileName.substring(0, j + 1);
                      if (I) {
                        var d = I.indexOf(e.nodeModulesPathPart);
                        U > d && J.set(k, l);
                      } else J.set(k, l);
                    }
                  }
                }
                var D = V === 1, fe = D && e.getLocalSymbolForExportDefault(X) || X, g = V === 0 || e.isExternalModuleSymbol(fe) ? e.unescapeLeadingUnderscores($) : e.getNamesForExportedSymbol(fe, void 0), ne = typeof g == "string" ? g : g[0], ue = typeof g == "string" ? void 0 : g[1], We = e.stripQuotes(A.name), Fe = K++, Z = e.skipAlias(X, P), Be = X.flags & 33554432 ? void 0 : X, ge = A.flags & 33554432 ? void 0 : A;
                (!Be || !ge) && se.set(Fe, [X, A]), b.add(O(ne, X, e.isExternalModuleNameRelative(We) ? void 0 : We, P), { id: Fe, symbolTableKey: $, symbolName: ne, capitalizedSymbolName: ue, moduleName: We, moduleFile: y, moduleFileName: y == null ? void 0 : y.fileName, packageName: k, exportKind: V, targetFlags: Z.flags, isFromPackageJson: L, symbol: Be, moduleSymbol: ge });
              }, get: function(x, X) {
                if (x === ie) {
                  var $ = b.get(X);
                  return $ == null ? void 0 : $.map(q);
                }
              }, search: function(x, X, $, A) {
                x === ie && b.forEach(function(y, V) {
                  var L = ve(V), P = L.symbolName, k = L.ambientModuleName, Y = X && y[0].capitalizedSymbolName || P;
                  if ($(Y, y[0].targetFlags)) {
                    var U = y.map(q), j = U.filter(function(H, I) {
                      return F(H, y[I].packageName);
                    });
                    j.length && A(j, Y, !!k, V);
                  }
                });
              }, releaseSymbols: function() {
                se.clear();
              }, onFileChanged: function(x, X, $) {
                return ee(x) && ee(X) ? false : ie && ie !== X.path || $ && e.consumesNodeCoreModules(x) !== e.consumesNodeCoreModules(X) || !e.arrayIsEqualTo(x.moduleAugmentations, X.moduleAugmentations) || !he(x, X) ? (R.clear(), true) : (ie = X.path, false);
              } };
              return e.Debug.isDebugging && Object.defineProperty(R, "__cache", { get: function() {
                return b;
              } }), R;
              function q(x) {
                if (x.symbol && x.moduleSymbol) return x;
                var X = x.id, $ = x.exportKind, A = x.targetFlags, y = x.isFromPackageJson, V = x.moduleFileName, L = se.get(X) || e.emptyArray, P = L[0], k = L[1];
                if (P && k) return { symbol: P, moduleSymbol: k, moduleFileName: V, exportKind: $, targetFlags: A, isFromPackageJson: y };
                var Y = (y ? T.getPackageJsonAutoImportProvider() : T.getCurrentProgram()).getTypeChecker(), U = x.moduleSymbol || k || e.Debug.checkDefined(x.moduleFile ? Y.getMergedSymbol(x.moduleFile.symbol) : Y.tryFindAmbientModule(x.moduleName)), j = x.symbol || P || e.Debug.checkDefined($ === 2 ? Y.resolveExternalModuleSymbol(U) : Y.tryGetMemberInModuleExportsAndProperties(e.unescapeLeadingUnderscores(x.symbolTableKey), U), "Could not find symbol '".concat(x.symbolName, "' by key '").concat(x.symbolTableKey, "' in module ").concat(U.name));
                return se.set(X, [j, U]), { symbol: j, moduleSymbol: U, moduleFileName: V, exportKind: $, targetFlags: A, isFromPackageJson: y };
              }
              function O(x, X, $, A) {
                var y = $ || "";
                return "".concat(x, "|").concat(e.getSymbolId(e.skipAlias(X, A)), "|").concat(y);
              }
              function ve(x) {
                var X = x.substring(0, x.indexOf("|")), $ = x.substring(x.lastIndexOf("|") + 1), A = $ === "" ? void 0 : $;
                return { symbolName: X, ambientModuleName: A };
              }
              function ee(x) {
                return !x.commonJsModuleIndicator && !x.externalModuleIndicator && !x.moduleAugmentations && !x.ambientModuleNames;
              }
              function he(x, X) {
                if (!e.arrayIsEqualTo(x.ambientModuleNames, X.ambientModuleNames)) return false;
                for (var $ = -1, A = -1, y = function(Y) {
                  var U = function(j) {
                    return e.isNonGlobalAmbientModule(j) && j.name.text === Y;
                  };
                  if ($ = e.findIndex(x.statements, U, $ + 1), A = e.findIndex(X.statements, U, A + 1), x.statements[$] !== X.statements[A]) return { value: false };
                }, V = 0, L = X.ambientModuleNames; V < L.length; V++) {
                  var P = L[V], k = y(P);
                  if (typeof k == "object") return k.value;
                }
                return true;
              }
              function F(x, X) {
                if (!X || !x.moduleFileName) return true;
                var $ = T.getGlobalTypingsCacheLocation();
                if ($ && e.startsWith(x.moduleFileName, $)) return true;
                var A = J.get(X);
                return !A || e.startsWith(x.moduleFileName, A);
              }
            }
            e.createCacheableExportInfoMap = w;
            function B(T, K, b, se, J, ie, R) {
              var q;
              if (K === b) return false;
              var O = R == null ? void 0 : R.get(K.path, b.path, se, {});
              if ((O == null ? void 0 : O.isBlockedByPackageJsonDependencies) !== void 0) return !O.isBlockedByPackageJsonDependencies;
              var ve = e.hostGetCanonicalFileName(ie), ee = (q = ie.getGlobalTypingsCacheLocation) === null || q === void 0 ? void 0 : q.call(ie), he = !!e.moduleSpecifiers.forEachFileNameOfModule(K.fileName, b.fileName, ie, false, function(x) {
                var X = T.getSourceFile(x);
                return (X === b || !X) && E(K.fileName, x, ve, ee);
              });
              if (J) {
                var F = he && J.allowsImportingSourceFile(b, ie);
                return R == null || R.setBlockedByPackageJsonDependencies(K.path, b.path, se, {}, !F), F;
              }
              return he;
            }
            e.isImportableFile = B;
            function E(T, K, b, se) {
              var J = e.forEachAncestorDirectory(K, function(R) {
                return e.getBaseFileName(R) === "node_modules" ? R : void 0;
              }), ie = J && e.getDirectoryPath(b(J));
              return ie === void 0 || e.startsWith(b(T), ie) || !!se && e.startsWith(b(se), ie);
            }
            function Q(T, K, b, se) {
              var J, ie;
              le(T.getTypeChecker(), T.getSourceFiles(), function(O, ve) {
                return se(O, ve, T, false);
              });
              var R = b && ((J = K.getPackageJsonAutoImportProvider) === null || J === void 0 ? void 0 : J.call(K));
              if (R) {
                var q = e.timestamp();
                le(R.getTypeChecker(), R.getSourceFiles(), function(O, ve) {
                  return se(O, ve, R, true);
                }), (ie = K.log) === null || ie === void 0 || ie.call(K, "forEachExternalModuleToImportFrom autoImportProvider: ".concat(e.timestamp() - q));
              }
            }
            e.forEachExternalModuleToImportFrom = Q;
            function le(T, K, b) {
              for (var se = 0, J = T.getAmbientModules(); se < J.length; se++) {
                var ie = J[se];
                e.stringContains(ie.name, "*") || b(ie, void 0);
              }
              for (var R = 0, q = K; R < q.length; R++) {
                var O = q[R];
                e.isExternalOrCommonJsModule(O) && b(T.getMergedSymbol(O.symbol), O);
              }
            }
            function N(T, K, b, se) {
              var J, ie, R, q, O, ve = e.timestamp();
              (J = K.getPackageJsonAutoImportProvider) === null || J === void 0 || J.call(K);
              var ee = ((ie = K.getCachedExportInfoMap) === null || ie === void 0 ? void 0 : ie.call(K)) || w({ getCurrentProgram: function() {
                return b;
              }, getPackageJsonAutoImportProvider: function() {
                var x;
                return (x = K.getPackageJsonAutoImportProvider) === null || x === void 0 ? void 0 : x.call(K);
              }, getGlobalTypingsCacheLocation: function() {
                var x;
                return (x = K.getGlobalTypingsCacheLocation) === null || x === void 0 ? void 0 : x.call(K);
              } });
              if (ee.isUsableByFile(T.path)) return (R = K.log) === null || R === void 0 || R.call(K, "getExportInfoMap: cache hit"), ee;
              (q = K.log) === null || q === void 0 || q.call(K, "getExportInfoMap: cache miss or empty; calculating new results");
              var he = b.getCompilerOptions(), F = 0;
              try {
                Q(b, K, true, function(x, X, $, A) {
                  ++F % 100 === 0 && (se == null || se.throwIfCancellationRequested());
                  var y = new e.Map(), V = $.getTypeChecker(), L = p(x, V, he);
                  L && m(L.symbol, V) && ee.add(T.path, L.symbol, L.exportKind === 1 ? "default" : "export=", x, X, L.exportKind, A, V), V.forEachExportAndPropertyOfModule(x, function(P, k) {
                    P !== (L == null ? void 0 : L.symbol) && m(P, V) && e.addToSeen(y, k) && ee.add(T.path, P, k, x, X, 0, A, V);
                  });
                });
              } catch (x) {
                throw ee.clear(), x;
              }
              return (O = K.log) === null || O === void 0 || O.call(K, "getExportInfoMap: done in ".concat(e.timestamp() - ve, " ms")), ee;
            }
            e.getExportInfoMap = N;
            function p(T, K, b) {
              var se = G(T, K);
              if (!!se) {
                var J = se.symbol, ie = se.exportKind, R = oe(J, K, b);
                return R && Ke({ symbol: J, exportKind: ie }, R);
              }
            }
            e.getDefaultLikeExportInfo = p;
            function m(T, K) {
              return !K.isUndefinedSymbol(T) && !K.isUnknownSymbol(T) && !e.isKnownSymbol(T) && !e.isPrivateIdentifierSymbol(T);
            }
            function G(T, K) {
              var b = K.resolveExternalModuleSymbol(T);
              if (b !== T) return { symbol: b, exportKind: 2 };
              var se = K.tryGetMemberInModuleExports("default", T);
              if (se) return { symbol: se, exportKind: 1 };
            }
            function oe(T, K, b) {
              var se = e.getLocalSymbolForExportDefault(T);
              if (se) return { symbolForMeaning: se, name: se.name };
              var J = f(T);
              if (J !== void 0) return { symbolForMeaning: T, name: J };
              if (T.flags & 2097152) {
                var ie = K.getImmediateAliasedSymbol(T);
                if (ie && ie.parent) return oe(ie, K, b);
              }
              return T.escapedName !== "default" && T.escapedName !== "export=" ? { symbolForMeaning: T, name: T.getName() } : { symbolForMeaning: T, name: e.getNameForExportedSymbol(T, b.target) };
            }
            function f(T) {
              return T.declarations && e.firstDefined(T.declarations, function(K) {
                var b;
                if (e.isExportAssignment(K)) return (b = e.tryCast(e.skipOuterExpressions(K.expression), e.isIdentifier)) === null || b === void 0 ? void 0 : b.text;
                if (e.isExportSpecifier(K)) return e.Debug.assert(K.name.text === "default", "Expected the specifier to be a default export"), K.propertyName && K.propertyName.text;
              });
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a() {
              var q = e.createScanner(99, false);
              function O(ee, he, F) {
                return E(ve(ee, he, F), ee);
              }
              function ve(ee, he, F) {
                var x = 0, X = 0, $ = [], A = N(he), y = A.prefix, V = A.pushTemplate;
                ee = y + ee;
                var L = y.length;
                V && $.push(15), q.setText(ee);
                var P = 0, k = [], Y = 0;
                do {
                  x = q.scan(), e.isTrivia(x) || (H(), X = x);
                  var U = q.getTextPos();
                  if (B(q.getTokenPos(), U, L, G(x), k), U >= ee.length) {
                    var j = w(q, x, e.lastOrUndefined($));
                    j !== void 0 && (P = j);
                  }
                } while (x !== 1);
                function H() {
                  switch (x) {
                    case 43:
                    case 68:
                      !C[X] && q.reScanSlashToken() === 13 && (x = 13);
                      break;
                    case 29:
                      X === 79 && Y++;
                      break;
                    case 31:
                      Y > 0 && Y--;
                      break;
                    case 130:
                    case 150:
                    case 147:
                    case 133:
                    case 151:
                      Y > 0 && !F && (x = 79);
                      break;
                    case 15:
                      $.push(x);
                      break;
                    case 18:
                      $.length > 0 && $.push(x);
                      break;
                    case 19:
                      if ($.length > 0) {
                        var I = e.lastOrUndefined($);
                        I === 15 ? (x = q.reScanTemplateToken(false), x === 17 ? $.pop() : e.Debug.assertEqual(x, 16, "Should have been a template middle.")) : (e.Debug.assertEqual(I, 18, "Should have been an open brace"), $.pop());
                      }
                      break;
                    default:
                      if (!e.isKeyword(x)) break;
                      (X === 24 || e.isKeyword(X) && e.isKeyword(x) && !le(X, x)) && (x = 79);
                  }
                }
                return { endOfLineState: P, spans: k };
              }
              return { getClassificationsForLine: O, getEncodedLexicalClassifications: ve };
            }
            e.createClassifier = a;
            var C = e.arrayToNumericMap([79, 10, 8, 9, 13, 108, 45, 46, 21, 23, 19, 110, 95], function(q) {
              return q;
            }, function() {
              return true;
            });
            function w(q, O, ve) {
              switch (O) {
                case 10: {
                  if (!q.isUnterminated()) return;
                  for (var ee = q.getTokenText(), he = ee.length - 1, F = 0; ee.charCodeAt(he - F) === 92; ) F++;
                  return (F & 1) === 0 ? void 0 : ee.charCodeAt(0) === 34 ? 3 : 2;
                }
                case 3:
                  return q.isUnterminated() ? 1 : void 0;
                default:
                  if (e.isTemplateLiteralKind(O)) {
                    if (!q.isUnterminated()) return;
                    switch (O) {
                      case 17:
                        return 5;
                      case 14:
                        return 4;
                      default:
                        return e.Debug.fail("Only 'NoSubstitutionTemplateLiteral's and 'TemplateTail's can be unterminated; got SyntaxKind #" + O);
                    }
                  }
                  return ve === 15 ? 6 : void 0;
              }
            }
            function B(q, O, ve, ee, he) {
              if (ee !== 8) {
                q === 0 && ve > 0 && (q += ve);
                var F = O - q;
                F > 0 && he.push(q - ve, F, ee);
              }
            }
            function E(q, O) {
              for (var ve = [], ee = q.spans, he = 0, F = 0; F < ee.length; F += 3) {
                var x = ee[F], X = ee[F + 1], $ = ee[F + 2];
                if (he >= 0) {
                  var A = x - he;
                  A > 0 && ve.push({ length: A, classification: e.TokenClass.Whitespace });
                }
                ve.push({ length: X, classification: Q($) }), he = x + X;
              }
              var y = O.length - he;
              return y > 0 && ve.push({ length: y, classification: e.TokenClass.Whitespace }), { entries: ve, finalLexState: q.endOfLineState };
            }
            function Q(q) {
              switch (q) {
                case 1:
                  return e.TokenClass.Comment;
                case 3:
                  return e.TokenClass.Keyword;
                case 4:
                  return e.TokenClass.NumberLiteral;
                case 25:
                  return e.TokenClass.BigIntLiteral;
                case 5:
                  return e.TokenClass.Operator;
                case 6:
                  return e.TokenClass.StringLiteral;
                case 8:
                  return e.TokenClass.Whitespace;
                case 10:
                  return e.TokenClass.Punctuation;
                case 2:
                case 11:
                case 12:
                case 13:
                case 14:
                case 15:
                case 16:
                case 9:
                case 17:
                  return e.TokenClass.Identifier;
                default:
                  return;
              }
            }
            function le(q, O) {
              if (!e.isAccessibilityModifier(q)) return true;
              switch (O) {
                case 136:
                case 149:
                case 134:
                case 124:
                  return true;
                default:
                  return false;
              }
            }
            function N(q) {
              switch (q) {
                case 3:
                  return { prefix: `"\\
` };
                case 2:
                  return { prefix: `'\\
` };
                case 1:
                  return { prefix: `/*
` };
                case 4:
                  return { prefix: "`\n" };
                case 5:
                  return { prefix: `}
`, pushTemplate: true };
                case 6:
                  return { prefix: "", pushTemplate: true };
                case 0:
                  return { prefix: "" };
                default:
                  return e.Debug.assertNever(q);
              }
            }
            function p(q) {
              switch (q) {
                case 41:
                case 43:
                case 44:
                case 39:
                case 40:
                case 47:
                case 48:
                case 49:
                case 29:
                case 31:
                case 32:
                case 33:
                case 102:
                case 101:
                case 127:
                case 34:
                case 35:
                case 36:
                case 37:
                case 50:
                case 52:
                case 51:
                case 55:
                case 56:
                case 74:
                case 73:
                case 78:
                case 70:
                case 71:
                case 72:
                case 64:
                case 65:
                case 66:
                case 68:
                case 69:
                case 63:
                case 27:
                case 60:
                case 75:
                case 76:
                case 77:
                  return true;
                default:
                  return false;
              }
            }
            function m(q) {
              switch (q) {
                case 39:
                case 40:
                case 54:
                case 53:
                case 45:
                case 46:
                  return true;
                default:
                  return false;
              }
            }
            function G(q) {
              if (e.isKeyword(q)) return 3;
              if (p(q) || m(q)) return 5;
              if (q >= 18 && q <= 78) return 10;
              switch (q) {
                case 8:
                  return 4;
                case 9:
                  return 25;
                case 10:
                  return 6;
                case 13:
                  return 7;
                case 7:
                case 3:
                case 2:
                  return 1;
                case 5:
                case 4:
                  return 8;
                case 79:
                default:
                  return e.isTemplateLiteralKind(q) ? 6 : 2;
              }
            }
            function oe(q, O, ve, ee, he) {
              return J(T(q, O, ve, ee, he));
            }
            e.getSemanticClassifications = oe;
            function f(q, O) {
              switch (O) {
                case 261:
                case 257:
                case 258:
                case 256:
                case 226:
                case 213:
                case 214:
                  q.throwIfCancellationRequested();
              }
            }
            function T(q, O, ve, ee, he) {
              var F = [];
              return ve.forEachChild(function X($) {
                if (!(!$ || !e.textSpanIntersectsWith(he, $.pos, $.getFullWidth()))) {
                  if (f(O, $.kind), e.isIdentifier($) && !e.nodeIsMissing($) && ee.has($.escapedText)) {
                    var A = q.getSymbolAtLocation($), y = A && K(A, e.getMeaningFromLocation($), q);
                    y && x($.getStart(ve), $.getEnd(), y);
                  }
                  $.forEachChild(X);
                }
              }), { spans: F, endOfLineState: 0 };
              function x(X, $, A) {
                var y = $ - X;
                e.Debug.assert(y > 0, "Classification had non-positive length of ".concat(y)), F.push(X), F.push(y), F.push(A);
              }
            }
            e.getEncodedSemanticClassifications = T;
            function K(q, O, ve) {
              var ee = q.getFlags();
              if ((ee & 2885600) !== 0) return ee & 32 ? 11 : ee & 384 ? 12 : ee & 524288 ? 16 : ee & 1536 ? O & 4 || O & 1 && b(q) ? 14 : void 0 : ee & 2097152 ? K(ve.getAliasedSymbol(q), O, ve) : O & 2 ? ee & 64 ? 13 : ee & 262144 ? 15 : void 0 : void 0;
            }
            function b(q) {
              return e.some(q.declarations, function(O) {
                return e.isModuleDeclaration(O) && e.getModuleInstanceState(O) === 1;
              });
            }
            function se(q) {
              switch (q) {
                case 1:
                  return "comment";
                case 2:
                  return "identifier";
                case 3:
                  return "keyword";
                case 4:
                  return "number";
                case 25:
                  return "bigint";
                case 5:
                  return "operator";
                case 6:
                  return "string";
                case 8:
                  return "whitespace";
                case 9:
                  return "text";
                case 10:
                  return "punctuation";
                case 11:
                  return "class name";
                case 12:
                  return "enum name";
                case 13:
                  return "interface name";
                case 14:
                  return "module name";
                case 15:
                  return "type parameter name";
                case 16:
                  return "type alias name";
                case 17:
                  return "parameter name";
                case 18:
                  return "doc comment tag name";
                case 19:
                  return "jsx open tag name";
                case 20:
                  return "jsx close tag name";
                case 21:
                  return "jsx self closing tag name";
                case 22:
                  return "jsx attribute";
                case 23:
                  return "jsx text";
                case 24:
                  return "jsx attribute string literal value";
                default:
                  return;
              }
            }
            function J(q) {
              e.Debug.assert(q.spans.length % 3 === 0);
              for (var O = q.spans, ve = [], ee = 0; ee < O.length; ee += 3) ve.push({ textSpan: e.createTextSpan(O[ee], O[ee + 1]), classificationType: se(O[ee + 2]) });
              return ve;
            }
            function ie(q, O, ve) {
              return J(R(q, O, ve));
            }
            e.getSyntacticClassifications = ie;
            function R(q, O, ve) {
              var ee = ve.start, he = ve.length, F = e.createScanner(99, false, O.languageVariant, O.text), x = e.createScanner(99, false, O.languageVariant, O.text), X = [];
              return l(O), { spans: X, endOfLineState: 0 };
              function $(d, D, fe) {
                X.push(d), X.push(D), X.push(fe);
              }
              function A(d) {
                for (F.setTextPos(d.pos); ; ) {
                  var D = F.getTextPos();
                  if (!e.couldStartTrivia(O.text, D)) return D;
                  var fe = F.scan(), g = F.getTextPos(), ne = g - D;
                  if (!e.isTrivia(fe)) return D;
                  switch (fe) {
                    case 4:
                    case 5:
                      continue;
                    case 2:
                    case 3:
                      y(d, fe, D, ne), F.setTextPos(g);
                      continue;
                    case 7:
                      var ue = O.text, We = ue.charCodeAt(D);
                      if (We === 60 || We === 62) {
                        $(D, ne, 1);
                        continue;
                      }
                      e.Debug.assert(We === 124 || We === 61), Y(ue, D, g);
                      break;
                    case 6:
                      break;
                    default:
                      e.Debug.assertNever(fe);
                  }
                }
              }
              function y(d, D, fe, g) {
                if (D === 3) {
                  var ne = e.parseIsolatedJSDocComment(O.text, fe, g);
                  if (ne && ne.jsDoc) {
                    e.setParent(ne.jsDoc, d), L(ne.jsDoc);
                    return;
                  }
                } else if (D === 2 && P(fe, g)) return;
                V(fe, g);
              }
              function V(d, D) {
                $(d, D, 1);
              }
              function L(d) {
                var D, fe, g, ne, ue, We, Fe, Z = d.pos;
                if (d.tags) for (var Be = 0, ge = d.tags; Be < ge.length; Be++) {
                  var Re = ge[Be];
                  Re.pos !== Z && V(Z, Re.pos - Z), $(Re.pos, 1, 10), $(Re.tagName.pos, Re.tagName.end - Re.tagName.pos, 18), Z = Re.tagName.end;
                  var ze = Re.tagName.end;
                  switch (Re.kind) {
                    case 340:
                      var Ee = Re;
                      Ie(Ee), ze = Ee.isNameFirst && ((D = Ee.typeExpression) === null || D === void 0 ? void 0 : D.end) || Ee.name.end;
                      break;
                    case 347:
                      var He = Re;
                      ze = He.isNameFirst && ((fe = He.typeExpression) === null || fe === void 0 ? void 0 : fe.end) || He.name.end;
                      break;
                    case 344:
                      k(Re), Z = Re.end, ze = Re.typeParameters.end;
                      break;
                    case 345:
                      var rr = Re;
                      ze = ((g = rr.typeExpression) === null || g === void 0 ? void 0 : g.kind) === 309 && ((ne = rr.fullName) === null || ne === void 0 ? void 0 : ne.end) || ((ue = rr.typeExpression) === null || ue === void 0 ? void 0 : ue.end) || ze;
                      break;
                    case 338:
                      ze = Re.typeExpression.end;
                      break;
                    case 343:
                      l(Re.typeExpression), Z = Re.end, ze = Re.typeExpression.end;
                      break;
                    case 342:
                    case 339:
                      ze = Re.typeExpression.end;
                      break;
                    case 341:
                      l(Re.typeExpression), Z = Re.end, ze = ((We = Re.typeExpression) === null || We === void 0 ? void 0 : We.end) || ze;
                      break;
                    case 346:
                      ze = ((Fe = Re.name) === null || Fe === void 0 ? void 0 : Fe.end) || ze;
                      break;
                    case 328:
                    case 329:
                      ze = Re.class.end;
                      break;
                  }
                  typeof Re.comment == "object" ? V(Re.comment.pos, Re.comment.end - Re.comment.pos) : typeof Re.comment == "string" && V(ze, Re.end - ze);
                }
                Z !== d.end && V(Z, d.end - Z);
                return;
                function Ie(_e) {
                  _e.isNameFirst && (V(Z, _e.name.pos - Z), $(_e.name.pos, _e.name.end - _e.name.pos, 17), Z = _e.name.end), _e.typeExpression && (V(Z, _e.typeExpression.pos - Z), l(_e.typeExpression), Z = _e.typeExpression.end), _e.isNameFirst || (V(Z, _e.name.pos - Z), $(_e.name.pos, _e.name.end - _e.name.pos, 17), Z = _e.name.end);
                }
              }
              function P(d, D) {
                var fe = /^(\/\/\/\s*)(<)(?:(\S+)((?:[^/]|\/[^>])*)(\/>)?)?/im, g = /(\s)(\S+)(\s*)(=)(\s*)('[^']+'|"[^"]+")/img, ne = O.text.substr(d, D), ue = fe.exec(ne);
                if (!ue || !ue[3] || !(ue[3] in e.commentPragmas)) return false;
                var We = d;
                V(We, ue[1].length), We += ue[1].length, $(We, ue[2].length, 10), We += ue[2].length, $(We, ue[3].length, 21), We += ue[3].length;
                for (var Fe = ue[4], Z = We; ; ) {
                  var Be = g.exec(Fe);
                  if (!Be) break;
                  var ge = We + Be.index + Be[1].length;
                  ge > Z && (V(Z, ge - Z), Z = ge), $(Z, Be[2].length, 22), Z += Be[2].length, Be[3].length && (V(Z, Be[3].length), Z += Be[3].length), $(Z, Be[4].length, 5), Z += Be[4].length, Be[5].length && (V(Z, Be[5].length), Z += Be[5].length), $(Z, Be[6].length, 24), Z += Be[6].length;
                }
                We += ue[4].length, We > Z && V(Z, We - Z), ue[5] && ($(We, ue[5].length, 10), We += ue[5].length);
                var Re = d + D;
                return We < Re && V(We, Re - We), true;
              }
              function k(d) {
                for (var D = 0, fe = d.getChildren(); D < fe.length; D++) {
                  var g = fe[D];
                  l(g);
                }
              }
              function Y(d, D, fe) {
                var g;
                for (g = D; g < fe && !e.isLineBreak(d.charCodeAt(g)); g++) ;
                for ($(D, g - D, 1), x.setTextPos(g); x.getTextPos() < fe; ) U();
              }
              function U() {
                var d = x.getTextPos(), D = x.scan(), fe = x.getTextPos(), g = I(D);
                g && $(d, fe - d, g);
              }
              function j(d) {
                if (e.isJSDoc(d) || e.nodeIsMissing(d)) return true;
                var D = H(d);
                if (!e.isToken(d) && d.kind !== 11 && D === void 0) return false;
                var fe = d.kind === 11 ? d.pos : A(d), g = d.end - fe;
                if (e.Debug.assert(g >= 0), g > 0) {
                  var ne = D || I(d.kind, d);
                  ne && $(fe, g, ne);
                }
                return true;
              }
              function H(d) {
                switch (d.parent && d.parent.kind) {
                  case 280:
                    if (d.parent.tagName === d) return 19;
                    break;
                  case 281:
                    if (d.parent.tagName === d) return 20;
                    break;
                  case 279:
                    if (d.parent.tagName === d) return 21;
                    break;
                  case 285:
                    if (d.parent.name === d) return 22;
                    break;
                }
              }
              function I(d, D) {
                if (e.isKeyword(d)) return 3;
                if ((d === 29 || d === 31) && D && e.getTypeArgumentOrTypeParameterList(D.parent)) return 10;
                if (e.isPunctuation(d)) {
                  if (D) {
                    var fe = D.parent;
                    if (d === 63 && (fe.kind === 254 || fe.kind === 167 || fe.kind === 164 || fe.kind === 285) || fe.kind === 221 || fe.kind === 219 || fe.kind === 220 || fe.kind === 222) return 5;
                  }
                  return 10;
                } else {
                  if (d === 8) return 4;
                  if (d === 9) return 25;
                  if (d === 10) return D && D.parent.kind === 285 ? 24 : 6;
                  if (d === 13) return 6;
                  if (e.isTemplateLiteralKind(d)) return 6;
                  if (d === 11) return 23;
                  if (d === 79) {
                    if (D) {
                      switch (D.parent.kind) {
                        case 257:
                          return D.parent.name === D ? 11 : void 0;
                        case 163:
                          return D.parent.name === D ? 15 : void 0;
                        case 258:
                          return D.parent.name === D ? 13 : void 0;
                        case 260:
                          return D.parent.name === D ? 12 : void 0;
                        case 261:
                          return D.parent.name === D ? 14 : void 0;
                        case 164:
                          return D.parent.name === D ? e.isThisIdentifier(D) ? 3 : 17 : void 0;
                      }
                      if (e.isConstTypeReference(D.parent)) return 3;
                    }
                    return 2;
                  }
                }
              }
              function l(d) {
                if (!!d && e.decodedTextSpanIntersectsWith(ee, he, d.pos, d.getFullWidth())) {
                  f(q, d.kind);
                  for (var D = 0, fe = d.getChildren(O); D < fe.length; D++) {
                    var g = fe[D];
                    j(g) || l(g);
                  }
                }
              }
            }
            e.getEncodedSyntacticClassifications = R;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E;
                (function(R) {
                  R[R.typeOffset = 8] = "typeOffset", R[R.modifierMask = 255] = "modifierMask";
                })(E = B.TokenEncodingConsts || (B.TokenEncodingConsts = {}));
                var Q;
                (function(R) {
                  R[R.class = 0] = "class", R[R.enum = 1] = "enum", R[R.interface = 2] = "interface", R[R.namespace = 3] = "namespace", R[R.typeParameter = 4] = "typeParameter", R[R.type = 5] = "type", R[R.parameter = 6] = "parameter", R[R.variable = 7] = "variable", R[R.enumMember = 8] = "enumMember", R[R.property = 9] = "property", R[R.function = 10] = "function", R[R.member = 11] = "member";
                })(Q = B.TokenType || (B.TokenType = {}));
                var le;
                (function(R) {
                  R[R.declaration = 0] = "declaration", R[R.static = 1] = "static", R[R.async = 2] = "async", R[R.readonly = 3] = "readonly", R[R.defaultLibrary = 4] = "defaultLibrary", R[R.local = 5] = "local";
                })(le = B.TokenModifier || (B.TokenModifier = {}));
                function N(R, q, O, ve) {
                  var ee = p(R, q, O, ve);
                  e.Debug.assert(ee.spans.length % 3 === 0);
                  for (var he = ee.spans, F = [], x = 0; x < he.length; x += 3) F.push({ textSpan: e.createTextSpan(he[x], he[x + 1]), classificationType: he[x + 2] });
                  return F;
                }
                B.getSemanticClassifications = N;
                function p(R, q, O, ve) {
                  return { spans: m(R, O, ve, q), endOfLineState: 0 };
                }
                B.getEncodedSemanticClassifications = p;
                function m(R, q, O, ve) {
                  var ee = [], he = function(F, x, X) {
                    ee.push(F.getStart(q), F.getWidth(q), (x + 1 << 8) + X);
                  };
                  return R && q && G(R, q, O, he, ve), ee;
                }
                function G(R, q, O, ve, ee) {
                  var he = R.getTypeChecker(), F = false;
                  function x(X) {
                    switch (X.kind) {
                      case 261:
                      case 257:
                      case 258:
                      case 256:
                      case 226:
                      case 213:
                      case 214:
                        ee.throwIfCancellationRequested();
                    }
                    if (!(!X || !e.textSpanIntersectsWith(O, X.pos, X.getFullWidth()) || X.getFullWidth() === 0)) {
                      var $ = F;
                      if ((e.isJsxElement(X) || e.isJsxSelfClosingElement(X)) && (F = true), e.isJsxExpression(X) && (F = false), e.isIdentifier(X) && !F && !b(X) && !e.isInfinityOrNaNString(X.escapedText)) {
                        var A = he.getSymbolAtLocation(X);
                        if (A) {
                          A.flags & 2097152 && (A = he.getAliasedSymbol(A));
                          var y = oe(A, e.getMeaningFromLocation(X));
                          if (y !== void 0) {
                            var V = 0;
                            if (X.parent) {
                              var L = e.isBindingElement(X.parent) || ie.get(X.parent.kind) === y;
                              L && X.parent.name === X && (V = 1 << 0);
                            }
                            y === 6 && J(X) && (y = 9), y = f(he, X, y);
                            var P = A.valueDeclaration;
                            if (P) {
                              var k = e.getCombinedModifierFlags(P), Y = e.getCombinedNodeFlags(P);
                              k & 32 && (V |= 1 << 1), k & 256 && (V |= 1 << 2), y !== 0 && y !== 2 && (k & 64 || Y & 2 || A.getFlags() & 8) && (V |= 1 << 3), (y === 7 || y === 10) && T(P, q) && (V |= 1 << 5), R.isSourceFileDefaultLibrary(P.getSourceFile()) && (V |= 1 << 4);
                            } else A.declarations && A.declarations.some(function(U) {
                              return R.isSourceFileDefaultLibrary(U.getSourceFile());
                            }) && (V |= 1 << 4);
                            ve(X, y, V);
                          }
                        }
                      }
                      e.forEachChild(X, x), F = $;
                    }
                  }
                  x(q);
                }
                function oe(R, q) {
                  var O = R.getFlags();
                  if (O & 32) return 0;
                  if (O & 384) return 1;
                  if (O & 524288) return 5;
                  if (O & 64) {
                    if (q & 2) return 2;
                  } else if (O & 262144) return 4;
                  var ve = R.valueDeclaration || R.declarations && R.declarations[0];
                  return ve && e.isBindingElement(ve) && (ve = K(ve)), ve && ie.get(ve.kind);
                }
                function f(R, q, O) {
                  if (O === 7 || O === 9 || O === 6) {
                    var ve = R.getTypeAtLocation(q);
                    if (ve) {
                      var ee = function(he) {
                        return he(ve) || ve.isUnion() && ve.types.some(he);
                      };
                      if (O !== 6 && ee(function(he) {
                        return he.getConstructSignatures().length > 0;
                      })) return 0;
                      if (ee(function(he) {
                        return he.getCallSignatures().length > 0;
                      }) && !ee(function(he) {
                        return he.getProperties().length > 0;
                      }) || se(q)) return O === 9 ? 11 : 10;
                    }
                  }
                  return O;
                }
                function T(R, q) {
                  return e.isBindingElement(R) && (R = K(R)), e.isVariableDeclaration(R) ? (!e.isSourceFile(R.parent.parent.parent) || e.isCatchClause(R.parent)) && R.getSourceFile() === q : e.isFunctionDeclaration(R) ? !e.isSourceFile(R.parent) && R.getSourceFile() === q : false;
                }
                function K(R) {
                  for (; ; ) if (e.isBindingElement(R.parent.parent)) R = R.parent.parent;
                  else return R.parent.parent;
                }
                function b(R) {
                  var q = R.parent;
                  return q && (e.isImportClause(q) || e.isImportSpecifier(q) || e.isNamespaceImport(q));
                }
                function se(R) {
                  for (; J(R); ) R = R.parent;
                  return e.isCallExpression(R.parent) && R.parent.expression === R;
                }
                function J(R) {
                  return e.isQualifiedName(R.parent) && R.parent.right === R || e.isPropertyAccessExpression(R.parent) && R.parent.name === R;
                }
                var ie = new e.Map([[254, 7], [164, 6], [167, 9], [261, 3], [260, 1], [299, 8], [257, 0], [169, 11], [256, 10], [213, 10], [168, 11], [172, 9], [173, 9], [166, 9], [258, 2], [259, 5], [163, 4], [296, 9], [297, 9]]);
              })(w = C.v2020 || (C.v2020 = {}));
            })(a = e.classifier || (e.classifier = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                function E(Z, Be, ge, Re, ze, Ee, He, rr) {
                  if (e.isInReferenceComment(Z, Be)) {
                    var Ie = l(Z, Be, Re, ze);
                    return Ie && p(Ie);
                  }
                  if (e.isInString(Z, Be, ge)) {
                    if (!ge || !e.isStringLiteralLike(ge)) return;
                    var Ie = oe(Z, ge, Be, Ee.getTypeChecker(), Re, ze, rr);
                    return Q(Ie, ge, Z, ze, Ee, He, Re, rr);
                  }
                }
                B.getStringLiteralCompletions = E;
                function Q(Z, Be, ge, Re, ze, Ee, He, rr) {
                  if (Z !== void 0) {
                    var Ie = e.createTextSpanFromStringLiteralLikeContent(Be);
                    switch (Z.kind) {
                      case 0:
                        return p(Z.paths);
                      case 1: {
                        var _e = e.createSortedArray();
                        return C.getCompletionEntriesFromSymbols(Z.symbols, _e, Be, Be, ge, ge, Re, ze, 99, Ee, 4, rr, He, void 0), { isGlobalCompletion: false, isMemberCompletion: true, isNewIdentifierLocation: Z.hasIndexSignature, optionalReplacementSpan: Ie, entries: _e };
                      }
                      case 2: {
                        var _e = Z.types.map(function(de) {
                          return { name: de.value, kindModifiers: "", kind: "string", sortText: C.SortText.LocationPriority, replacementSpan: e.getReplacementSpanForContextToken(Be) };
                        });
                        return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: Z.isNewIdentifier, optionalReplacementSpan: Ie, entries: _e };
                      }
                      default:
                        return e.Debug.assertNever(Z);
                    }
                  }
                }
                function le(Z, Be, ge, Re, ze, Ee, He, rr, Ie) {
                  if (!(!Re || !e.isStringLiteralLike(Re))) {
                    var _e = oe(Be, Re, ge, ze, Ee, He, Ie);
                    return _e && N(Z, Re, _e, Be, ze, rr);
                  }
                }
                B.getStringLiteralCompletionDetails = le;
                function N(Z, Be, ge, Re, ze, Ee) {
                  switch (ge.kind) {
                    case 0: {
                      var He = e.find(ge.paths, function(rr) {
                        return rr.name === Z;
                      });
                      return He && C.createCompletionDetails(Z, m(He.extension), He.kind, [e.textPart(Z)]);
                    }
                    case 1: {
                      var He = e.find(ge.symbols, function(Ie) {
                        return Ie.name === Z;
                      });
                      return He && C.createCompletionDetailsForSymbol(He, ze, Re, Be, Ee);
                    }
                    case 2:
                      return e.find(ge.types, function(rr) {
                        return rr.value === Z;
                      }) ? C.createCompletionDetails(Z, "", "type", [e.textPart(Z)]) : void 0;
                    default:
                      return e.Debug.assertNever(ge);
                  }
                }
                function p(Z) {
                  var Be = false, ge = true, Re = Z.map(function(ze) {
                    var Ee = ze.name, He = ze.kind, rr = ze.span, Ie = ze.extension;
                    return { name: Ee, kind: He, kindModifiers: m(Ie), sortText: C.SortText.LocationPriority, replacementSpan: rr };
                  });
                  return { isGlobalCompletion: Be, isMemberCompletion: false, isNewIdentifierLocation: ge, entries: Re };
                }
                function m(Z) {
                  switch (Z) {
                    case ".d.ts":
                      return ".d.ts";
                    case ".js":
                      return ".js";
                    case ".json":
                      return ".json";
                    case ".jsx":
                      return ".jsx";
                    case ".ts":
                      return ".ts";
                    case ".tsx":
                      return ".tsx";
                    case ".d.mts":
                      return ".d.mts";
                    case ".mjs":
                      return ".mjs";
                    case ".mts":
                      return ".mts";
                    case ".d.cts":
                      return ".d.cts";
                    case ".cjs":
                      return ".cjs";
                    case ".cts":
                      return ".cts";
                    case ".tsbuildinfo":
                      return e.Debug.fail("Extension ".concat(".tsbuildinfo", " is unsupported."));
                    case void 0:
                      return "";
                    default:
                      return e.Debug.assertNever(Z);
                  }
                }
                var G;
                (function(Z) {
                  Z[Z.Paths = 0] = "Paths", Z[Z.Properties = 1] = "Properties", Z[Z.Types = 2] = "Types";
                })(G || (G = {}));
                function oe(Z, Be, ge, Re, ze, Ee, He) {
                  var rr = f(Be.parent);
                  switch (rr.kind) {
                    case 196: {
                      var Ie = f(rr.parent);
                      switch (Ie.kind) {
                        case 178: {
                          var _e = Ie, we = e.findAncestor(rr, function(n) {
                            return n.parent === _e;
                          });
                          return we ? { kind: 2, types: J(Re.getTypeArgumentConstraint(we)), isNewIdentifier: false } : void 0;
                        }
                        case 194:
                          var de = Ie, ye = de.indexType, Ae = de.objectType;
                          return e.rangeContainsPosition(ye, ge) ? b(Re.getTypeFromTypeNode(Ae)) : void 0;
                        case 200:
                          return { kind: 0, paths: O(Z, Be, ze, Ee, Re, He) };
                        case 187: {
                          if (!e.isTypeReferenceNode(Ie.parent)) return;
                          var er = T(Ie, rr), ir = J(Re.getTypeArgumentConstraint(Ie)).filter(function(n) {
                            return !e.contains(er, n.value);
                          });
                          return { kind: 2, types: ir, isNewIdentifier: false };
                        }
                        default:
                          return;
                      }
                    }
                    case 296:
                      return e.isObjectLiteralExpression(rr.parent) && rr.name === Be ? se(Re, rr.parent) : Ne();
                    case 207: {
                      var Cr = rr, Ye = Cr.expression, Br = Cr.argumentExpression;
                      return Be === e.skipParentheses(Br) ? b(Re.getTypeAtLocation(Ye)) : void 0;
                    }
                    case 208:
                    case 209:
                    case 285:
                      if (!Fe(Be) && !e.isImportCall(rr)) {
                        var Er = e.SignatureHelp.getArgumentInfoForCompletions(rr.kind === 285 ? rr.parent : Be, ge, Z);
                        return Er ? K(Er.invocation, Be, Er, Re) : Ne();
                      }
                    case 266:
                    case 272:
                    case 277:
                      return { kind: 0, paths: O(Z, Be, ze, Ee, Re, He) };
                    default:
                      return Ne();
                  }
                  function Ne() {
                    return { kind: 2, types: J(e.getContextualTypeFromParent(Be, Re)), isNewIdentifier: false };
                  }
                }
                function f(Z) {
                  switch (Z.kind) {
                    case 191:
                      return e.walkUpParenthesizedTypes(Z);
                    case 212:
                      return e.walkUpParenthesizedExpressions(Z);
                    default:
                      return Z;
                  }
                }
                function T(Z, Be) {
                  return e.mapDefined(Z.types, function(ge) {
                    return ge !== Be && e.isLiteralTypeNode(ge) && e.isStringLiteral(ge.literal) ? ge.literal.text : void 0;
                  });
                }
                function K(Z, Be, ge, Re) {
                  var ze = false, Ee = new e.Map(), He = [], rr = e.isJsxOpeningLikeElement(Z) ? e.Debug.checkDefined(e.findAncestor(Be.parent, e.isJsxAttribute)) : Be;
                  Re.getResolvedSignatureForStringLiteralCompletions(Z, rr, He);
                  var Ie = e.flatMap(He, function(_e) {
                    if (!(!e.signatureHasRestParameter(_e) && ge.argumentCount > _e.parameters.length)) {
                      var we = _e.getTypeParameterAtPosition(ge.argumentIndex);
                      if (e.isJsxOpeningLikeElement(Z)) {
                        var de = Re.getTypeOfPropertyOfType(we, rr.name.text);
                        de && (we = de);
                      }
                      return ze = ze || !!(we.flags & 4), J(we, Ee);
                    }
                  });
                  return { kind: 2, types: Ie, isNewIdentifier: ze };
                }
                function b(Z) {
                  return Z && { kind: 1, symbols: e.filter(Z.getApparentProperties(), function(Be) {
                    return !(Be.valueDeclaration && e.isPrivateIdentifierClassElementDeclaration(Be.valueDeclaration));
                  }), hasIndexSignature: e.hasIndexSignature(Z) };
                }
                function se(Z, Be) {
                  var ge = Z.getContextualType(Be);
                  if (!!ge) {
                    var Re = Z.getContextualType(Be, 4), ze = C.getPropertiesForObjectExpression(ge, Re, Be, Z);
                    return { kind: 1, symbols: ze, hasIndexSignature: e.hasIndexSignature(ge) };
                  }
                }
                function J(Z, Be) {
                  return Be === void 0 && (Be = new e.Map()), Z ? (Z = e.skipConstraint(Z), Z.isUnion() ? e.flatMap(Z.types, function(ge) {
                    return J(ge, Be);
                  }) : Z.isStringLiteral() && !(Z.flags & 1024) && e.addToSeen(Be, Z.value) ? [Z] : e.emptyArray) : e.emptyArray;
                }
                function ie(Z, Be, ge) {
                  return { name: Z, kind: Be, extension: ge };
                }
                function R(Z) {
                  return ie(Z, "directory", void 0);
                }
                function q(Z, Be, ge) {
                  var Re = fe(Z, Be), ze = Z.length === 0 ? void 0 : e.createTextSpan(Be, Z.length);
                  return ge.map(function(Ee) {
                    var He = Ee.name, rr = Ee.kind, Ie = Ee.extension;
                    return Math.max(He.indexOf(e.directorySeparator), He.indexOf(e.altDirectorySeparator)) !== -1 ? { name: He, kind: rr, extension: Ie, span: ze } : { name: He, kind: rr, extension: Ie, span: Re };
                  });
                }
                function O(Z, Be, ge, Re, ze, Ee) {
                  return q(Be.text, Be.getStart(Z) + 1, ve(Z, Be, ge, Re, ze, Ee));
                }
                function ve(Z, Be, ge, Re, ze, Ee) {
                  var He = e.normalizeSlashes(Be.text), rr = Z.path, Ie = e.getDirectoryPath(rr);
                  return g(He) || !ge.baseUrl && (e.isRootedDiskPath(He) || e.isUrl(He)) ? he(He, Ie, ge, Re, rr, _e()) : P(He, Ie, ge, Re, ze);
                  function _e() {
                    var we = e.isStringLiteralLike(Be) ? e.getModeForUsageLocation(Z, Be) : void 0;
                    return Ee.importModuleSpecifierEnding === "js" || we === e.ModuleKind.ESNext ? 2 : 0;
                  }
                }
                function ee(Z, Be) {
                  return Be === void 0 && (Be = 0), { extensions: e.flatten(X(Z)), includeExtensionsOption: Be };
                }
                function he(Z, Be, ge, Re, ze, Ee) {
                  var He = ee(ge, Ee);
                  return ge.rootDirs ? A(ge.rootDirs, Z, Be, He, ge, Re, ze) : V(Z, Be, He, Re, ze);
                }
                function F(Z) {
                  return e.getEmitModuleResolutionKind(Z) === e.ModuleResolutionKind.NodeJs || e.getEmitModuleResolutionKind(Z) === e.ModuleResolutionKind.Node16 || e.getEmitModuleResolutionKind(Z) === e.ModuleResolutionKind.NodeNext;
                }
                function x(Z) {
                  return e.getEmitModuleResolutionKind(Z) === e.ModuleResolutionKind.Node16 || e.getEmitModuleResolutionKind(Z) === e.ModuleResolutionKind.NodeNext;
                }
                function X(Z) {
                  var Be = e.getSupportedExtensions(Z);
                  return F(Z) ? e.getSupportedExtensionsWithJsonIfResolveJsonModule(Z, Be) : Be;
                }
                function $(Z, Be, ge, Re) {
                  Z = Z.map(function(Ee) {
                    return e.normalizePath(e.isRootedDiskPath(Ee) ? Ee : e.combinePaths(Be, Ee));
                  });
                  var ze = e.firstDefined(Z, function(Ee) {
                    return e.containsPath(Ee, ge, Be, Re) ? ge.substr(Ee.length) : void 0;
                  });
                  return e.deduplicate(Ve(Ve([], Z.map(function(Ee) {
                    return e.combinePaths(Ee, ze);
                  }), true), [ge], false), e.equateStringsCaseSensitive, e.compareStringsCaseSensitive);
                }
                function A(Z, Be, ge, Re, ze, Ee, He) {
                  var rr = ze.project || Ee.getCurrentDirectory(), Ie = !(Ee.useCaseSensitiveFileNames && Ee.useCaseSensitiveFileNames()), _e = $(Z, rr, ge, Ie);
                  return e.flatMap(_e, function(we) {
                    return V(Be, we, Re, Ee, He);
                  });
                }
                var y;
                (function(Z) {
                  Z[Z.Exclude = 0] = "Exclude", Z[Z.Include = 1] = "Include", Z[Z.ModuleSpecifierCompletion = 2] = "ModuleSpecifierCompletion";
                })(y || (y = {}));
                function V(Z, Be, ge, Re, ze, Ee) {
                  var He = ge.extensions, rr = ge.includeExtensionsOption;
                  Ee === void 0 && (Ee = []), Z === void 0 && (Z = ""), Z = e.normalizeSlashes(Z), e.hasTrailingDirectorySeparator(Z) || (Z = e.getDirectoryPath(Z)), Z === "" && (Z = "." + e.directorySeparator), Z = e.ensureTrailingDirectorySeparator(Z);
                  var Ie = e.resolvePath(Be, Z), _e = e.hasTrailingDirectorySeparator(Ie) ? Ie : e.getDirectoryPath(Ie), we = !(Re.useCaseSensitiveFileNames && Re.useCaseSensitiveFileNames());
                  if (!e.tryDirectoryExists(Re, _e)) return Ee;
                  var de = e.tryReadDirectory(Re, _e, He, void 0, ["./*"]);
                  if (de) {
                    for (var ye = new e.Map(), Ae = 0, er = de; Ae < er.length; Ae++) {
                      var ir = er[Ae];
                      if (ir = e.normalizePath(ir), !(ze && e.comparePaths(ir, ze, Be, we) === 0)) {
                        var Cr = void 0, Ye = e.moduleSpecifiers.tryGetJSExtensionForFile(ir, Re.getCompilationSettings());
                        rr === 0 && !e.fileExtensionIsOneOf(ir, [".json", ".mts", ".cts", ".d.mts", ".d.cts", ".mjs", ".cjs"]) ? (Cr = e.removeFileExtension(e.getBaseFileName(ir)), ye.set(Cr, e.tryGetExtensionFromPath(ir))) : (e.fileExtensionIsOneOf(ir, [".mts", ".cts", ".d.mts", ".d.cts", ".mjs", ".cjs"]) || rr === 2) && Ye ? (Cr = e.changeExtension(e.getBaseFileName(ir), Ye), ye.set(Cr, Ye)) : (Cr = e.getBaseFileName(ir), ye.set(Cr, e.tryGetExtensionFromPath(ir)));
                      }
                    }
                    ye.forEach(function(Ur, ii) {
                      Ee.push(ie(ii, "script", Ur));
                    });
                  }
                  var Br = e.tryGetDirectories(Re, _e);
                  if (Br) for (var Er = 0, Ne = Br; Er < Ne.length; Er++) {
                    var n = Ne[Er], lr = e.getBaseFileName(e.normalizePath(n));
                    lr !== "@types" && Ee.push(R(lr));
                  }
                  var be = e.findPackageJson(_e, Re);
                  if (be) {
                    var Ge = e.readJson(be, Re), ur = Ge.typesVersions;
                    if (typeof ur == "object") {
                      var yr = e.getPackageJsonTypesVersionsPaths(ur), Ir = yr && yr.paths, wr = Ie.slice(e.ensureTrailingDirectorySeparator(_e).length);
                      Ir && L(Ee, wr, _e, He, Ir, Re);
                    }
                  }
                  return Ee;
                }
                function L(Z, Be, ge, Re, ze, Ee) {
                  for (var He in ze) if (!!e.hasProperty(ze, He)) {
                    var rr = ze[He];
                    if (rr) for (var Ie = function(ir, Cr, Ye) {
                      Z.some(function(Br) {
                        return Br.name === ir;
                      }) || Z.push(ie(ir, Cr, Ye));
                    }, _e = 0, we = Y(He, rr, Be, ge, Re, Ee); _e < we.length; _e++) {
                      var de = we[_e], ye = de.name, Ae = de.kind, er = de.extension;
                      Ie(ye, Ae, er);
                    }
                  }
                }
                function P(Z, Be, ge, Re, ze) {
                  var Ee = ge.baseUrl, He = ge.paths, rr = [], Ie = ee(ge);
                  if (Ee) {
                    var _e = ge.project || Re.getCurrentDirectory(), we = e.normalizePath(e.combinePaths(_e, Ee));
                    V(Z, we, Ie, Re, void 0, rr), He && L(rr, Z, we, Ie.extensions, He, Re);
                  }
                  for (var de = k(Z), ye = 0, Ae = I(Z, de, ze); ye < Ae.length; ye++) {
                    var er = Ae[ye];
                    rr.push(ie(er, "external module name", void 0));
                  }
                  if (d(Re, ge, Be, de, Ie, rr), F(ge)) {
                    var ir = false;
                    if (de === void 0) for (var Cr = function(lr) {
                      rr.some(function(be) {
                        return be.name === lr;
                      }) || (ir = true, rr.push(ie(lr, "external module name", void 0)));
                    }, Ye = 0, Br = D(Re, Be); Ye < Br.length; Ye++) {
                      var Er = Br[Ye];
                      Cr(Er);
                    }
                    if (!ir) {
                      var Ne = function(lr) {
                        var be = e.combinePaths(lr, "node_modules");
                        e.tryDirectoryExists(Re, be) && V(Z, be, Ie, Re, void 0, rr);
                      };
                      if (de && x(ge)) {
                        var n = Ne;
                        Ne = function(lr) {
                          var be = e.getPathComponents(Z);
                          be.shift();
                          var Ge = be.shift();
                          if (!Ge) return n(lr);
                          if (e.startsWith(Ge, "@")) {
                            var ur = be.shift();
                            if (!ur) return n(lr);
                            Ge = e.combinePaths(Ge, ur);
                          }
                          var yr = e.combinePaths(lr, "node_modules", Ge, "package.json");
                          if (e.tryFileExists(Re, yr)) {
                            var Ir = e.readJson(yr, Re), wr = Ir.exports;
                            if (wr) {
                              if (typeof wr != "object" || wr === null) return;
                              var Ur = e.getOwnKeys(wr), ii = be.join("/"), mi = e.mapDefined(Ur, function(pe) {
                                if (pe !== "." && !!e.startsWith(pe, "./")) {
                                  var or = pe.substring(2);
                                  if (!!e.startsWith(or, ii)) return e.stringContains(or, "*") ? or.slice(0, or.indexOf("*")) : or;
                                }
                              });
                              e.forEach(mi, function(pe) {
                                pe && rr.push(ie(pe, "external module name", void 0));
                              });
                              return;
                            }
                          }
                          return n(lr);
                        };
                      }
                      e.forEachAncestorDirectory(Be, Ne);
                    }
                  }
                  return rr;
                }
                function k(Z) {
                  return We(Z) ? e.hasTrailingDirectorySeparator(Z) ? Z : e.getDirectoryPath(Z) : void 0;
                }
                function Y(Z, Be, ge, Re, ze, Ee) {
                  if (!e.endsWith(Z, "*")) return e.stringContains(Z, "*") ? e.emptyArray : Ie(Z);
                  var He = Z.slice(0, Z.length - 1), rr = e.tryRemovePrefix(ge, He);
                  return rr === void 0 ? Ie(He) : e.flatMap(Be, function(_e) {
                    return U(rr, Re, _e, ze, Ee);
                  });
                  function Ie(_e) {
                    return e.startsWith(_e, ge) ? [R(_e)] : e.emptyArray;
                  }
                }
                function U(Z, Be, ge, Re, ze) {
                  if (!ze.readDirectory) return;
                  var Ee = e.tryParsePattern(ge);
                  if (Ee === void 0 || e.isString(Ee)) return;
                  var He = e.resolvePath(Ee.prefix), rr = e.hasTrailingDirectorySeparator(Ee.prefix) ? He : e.getDirectoryPath(He), Ie = e.hasTrailingDirectorySeparator(Ee.prefix) ? "" : e.getBaseFileName(He), _e = We(Z), we = _e ? e.hasTrailingDirectorySeparator(Z) ? Z : e.getDirectoryPath(Z) : void 0, de = _e ? e.combinePaths(rr, Ie + we) : rr, ye = e.normalizePath(Ee.suffix), Ae = e.normalizePath(e.combinePaths(Be, de)), er = _e ? Ae : e.ensureTrailingDirectorySeparator(Ae) + Ie, ir = ye ? "**/*" : "./*", Cr = e.mapDefined(e.tryReadDirectory(ze, Ae, Re, void 0, [ir]), function(Er) {
                    var Ne = e.tryGetExtensionFromPath(Er), n = Br(Er);
                    return n === void 0 ? void 0 : ie(e.removeFileExtension(n), "script", Ne);
                  }), Ye = e.mapDefined(e.tryGetDirectories(ze, Ae).map(function(Er) {
                    return e.combinePaths(Ae, Er);
                  }), function(Er) {
                    var Ne = Br(Er);
                    return Ne === void 0 ? void 0 : R(Ne);
                  });
                  return Ve(Ve([], Cr, true), Ye, true);
                  function Br(Er) {
                    var Ne = j(e.normalizePath(Er), er, ye);
                    return Ne === void 0 ? void 0 : H(Ne);
                  }
                }
                function j(Z, Be, ge) {
                  return e.startsWith(Z, Be) && e.endsWith(Z, ge) ? Z.slice(Be.length, Z.length - ge.length) : void 0;
                }
                function H(Z) {
                  return Z[0] === e.directorySeparator ? Z.slice(1) : Z;
                }
                function I(Z, Be, ge) {
                  var Re = ge.getAmbientModules().map(function(He) {
                    return e.stripQuotes(He.name);
                  }), ze = Re.filter(function(He) {
                    return e.startsWith(He, Z);
                  });
                  if (Be !== void 0) {
                    var Ee = e.ensureTrailingDirectorySeparator(Be);
                    return ze.map(function(He) {
                      return e.removePrefix(He, Ee);
                    });
                  }
                  return ze;
                }
                function l(Z, Be, ge, Re) {
                  var ze = e.getTokenAtPosition(Z, Be), Ee = e.getLeadingCommentRanges(Z.text, ze.pos), He = Ee && e.find(Ee, function(er) {
                    return Be >= er.pos && Be <= er.end;
                  });
                  if (!!He) {
                    var rr = Z.text.slice(He.pos, Be), Ie = ne.exec(rr);
                    if (!!Ie) {
                      var _e = Ie[1], we = Ie[2], de = Ie[3], ye = e.getDirectoryPath(Z.path), Ae = we === "path" ? V(de, ye, ee(ge, 1), Re, Z.path) : we === "types" ? d(Re, ge, ye, k(de), ee(ge)) : e.Debug.fail();
                      return q(de, He.pos + _e.length, Ae);
                    }
                  }
                }
                function d(Z, Be, ge, Re, ze, Ee) {
                  Ee === void 0 && (Ee = []);
                  for (var He = new e.Map(), rr = e.tryAndIgnoreErrors(function() {
                    return e.getEffectiveTypeRoots(Be, Z);
                  }) || e.emptyArray, Ie = 0, _e = rr; Ie < _e.length; Ie++) {
                    var we = _e[Ie];
                    ir(we);
                  }
                  for (var de = 0, ye = e.findPackageJsons(ge, Z); de < ye.length; de++) {
                    var Ae = ye[de], er = e.combinePaths(e.getDirectoryPath(Ae), "node_modules/@types");
                    ir(er);
                  }
                  return Ee;
                  function ir(Cr) {
                    if (!!e.tryDirectoryExists(Z, Cr)) for (var Ye = 0, Br = e.tryGetDirectories(Z, Cr); Ye < Br.length; Ye++) {
                      var Er = Br[Ye], Ne = e.unmangleScopedPackageName(Er);
                      if (!(Be.types && !e.contains(Be.types, Ne))) if (Re === void 0) He.has(Ne) || (Ee.push(ie(Ne, "external module name", void 0)), He.set(Ne, true));
                      else {
                        var n = e.combinePaths(Cr, Er), lr = e.tryRemoveDirectoryPrefix(Re, Ne, e.hostGetCanonicalFileName(Z));
                        lr !== void 0 && V(lr, n, ze, Z, void 0, Ee);
                      }
                    }
                  }
                }
                function D(Z, Be) {
                  if (!Z.readFile || !Z.fileExists) return e.emptyArray;
                  for (var ge = [], Re = 0, ze = e.findPackageJsons(Be, Z); Re < ze.length; Re++) for (var Ee = ze[Re], He = e.readJson(Ee, Z), rr = 0, Ie = ue; rr < Ie.length; rr++) {
                    var _e = Ie[rr], we = He[_e];
                    if (!!we) for (var de in we) we.hasOwnProperty(de) && !e.startsWith(de, "@types/") && ge.push(de);
                  }
                  return ge;
                }
                function fe(Z, Be) {
                  var ge = Math.max(Z.lastIndexOf(e.directorySeparator), Z.lastIndexOf(e.altDirectorySeparator)), Re = ge !== -1 ? ge + 1 : 0, ze = Z.length - Re;
                  return ze === 0 || e.isIdentifierText(Z.substr(Re, ze), 99) ? void 0 : e.createTextSpan(Be + Re, ze);
                }
                function g(Z) {
                  if (Z && Z.length >= 2 && Z.charCodeAt(0) === 46) {
                    var Be = Z.length >= 3 && Z.charCodeAt(1) === 46 ? 2 : 1, ge = Z.charCodeAt(Be);
                    return ge === 47 || ge === 92;
                  }
                  return false;
                }
                var ne = /^(\/\/\/\s*<reference\s+(path|types)\s*=\s*(?:'|"))([^\3"]*)$/, ue = ["dependencies", "devDependencies", "peerDependencies", "optionalDependencies"];
                function We(Z) {
                  return e.stringContains(Z, e.directorySeparator);
                }
                function Fe(Z) {
                  return e.isCallExpression(Z.parent) && e.firstOrUndefined(Z.parent.arguments) === Z && e.isIdentifier(Z.parent.expression) && Z.parent.expression.escapedText === "require";
                }
              })(w = C.StringCompletions || (C.StringCompletions = {}));
            })(a = e.Completions || (e.Completions = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              C.moduleSpecifierResolutionLimit = 100, C.moduleSpecifierResolutionCacheAttemptLimit = 1e3, C.SortText = { LocalDeclarationPriority: "10", LocationPriority: "11", OptionalMember: "12", MemberDeclaredBySpreadAssignment: "13", SuggestedClassMembers: "14", GlobalsOrKeywords: "15", AutoImportSuggestions: "16", ClassMemberSnippets: "17", JavascriptIdentifiers: "18", Deprecated: function(xe) {
                return "z" + xe;
              }, ObjectLiteralProperty: function(xe, vr) {
                return "".concat(xe, "\0").concat(vr, "\0");
              }, SortBelow: function(xe) {
                return xe + "1";
              } };
              var w;
              (function(xe) {
                xe.ThisProperty = "ThisProperty/", xe.ClassMemberSnippet = "ClassMemberSnippet/", xe.TypeOnlyAlias = "TypeOnlyAlias/", xe.ObjectLiteralMethodSnippet = "ObjectLiteralMethodSnippet/";
              })(w = C.CompletionSource || (C.CompletionSource = {}));
              var B;
              (function(xe) {
                xe[xe.ThisType = 1] = "ThisType", xe[xe.SymbolMember = 2] = "SymbolMember", xe[xe.Export = 4] = "Export", xe[xe.Promise = 8] = "Promise", xe[xe.Nullable = 16] = "Nullable", xe[xe.ResolvedExport = 32] = "ResolvedExport", xe[xe.TypeOnlyAlias = 64] = "TypeOnlyAlias", xe[xe.ObjectLiteralMethod = 128] = "ObjectLiteralMethod", xe[xe.SymbolMemberNoExport = 2] = "SymbolMemberNoExport", xe[xe.SymbolMemberExport = 6] = "SymbolMemberExport";
              })(B || (B = {}));
              function E(xe) {
                return !!(xe.kind & 1);
              }
              function Q(xe) {
                return !!(xe.kind & 2);
              }
              function le(xe) {
                return !!(xe && xe.kind & 4);
              }
              function N(xe) {
                return !!(xe && xe.kind === 32);
              }
              function p(xe) {
                return le(xe) || N(xe);
              }
              function m(xe) {
                return (le(xe) || N(xe)) && !!xe.isFromPackageJson;
              }
              function G(xe) {
                return !!(xe.kind & 8);
              }
              function oe(xe) {
                return !!(xe.kind & 16);
              }
              function f(xe) {
                return !!(xe && xe.kind & 64);
              }
              function T(xe) {
                return !!(xe && xe.kind & 128);
              }
              var K;
              (function(xe) {
                xe[xe.None = 0] = "None", xe[xe.All = 1] = "All", xe[xe.ClassElementKeywords = 2] = "ClassElementKeywords", xe[xe.InterfaceElementKeywords = 3] = "InterfaceElementKeywords", xe[xe.ConstructorParameterKeywords = 4] = "ConstructorParameterKeywords", xe[xe.FunctionLikeBodyKeywords = 5] = "FunctionLikeBodyKeywords", xe[xe.TypeAssertionKeywords = 6] = "TypeAssertionKeywords", xe[xe.TypeKeywords = 7] = "TypeKeywords", xe[xe.TypeKeyword = 8] = "TypeKeyword", xe[xe.Last = 8] = "Last";
              })(K || (K = {}));
              var b;
              (function(xe) {
                xe[xe.Continue = 0] = "Continue", xe[xe.Success = 1] = "Success", xe[xe.Fail = 2] = "Fail";
              })(b || (b = {}));
              function se(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue) {
                var fr, De, gr, Vr = e.timestamp(), Tr = e.createPackageJsonImportFilter(Ar, nr, vr), vi = Mr || e.moduleResolutionRespectsExports(e.getEmitModuleResolutionKind(mr.getCompilerOptions())), Ui = false, Yi = 0, Wi = 0, ct = 0, Li = 0, nt = Ue({ tryResolve: xt, skippedAny: function() {
                  return Ui;
                }, resolvedAny: function() {
                  return Wi > 0;
                }, resolvedBeyondLimit: function() {
                  return Wi > C.moduleSpecifierResolutionLimit;
                } }), Mt = Li ? " (".concat((ct / Li * 100).toFixed(1), "% hit rate)") : "";
                return (fr = vr.log) === null || fr === void 0 || fr.call(vr, "".concat(xe, ": resolved ").concat(Wi, " module specifiers, plus ").concat(Yi, " ambient and ").concat(ct, " from cache").concat(Mt)), (De = vr.log) === null || De === void 0 || De.call(vr, "".concat(xe, ": response is ").concat(Ui ? "incomplete" : "complete")), (gr = vr.log) === null || gr === void 0 || gr.call(vr, "".concat(xe, ": ").concat(e.timestamp() - Vr)), nt;
                function xt(ut, Dt, Rt) {
                  if (Rt) {
                    var Ii = e.codefix.getModuleSpecifierForBestExportInfo(ut, Dt, Oe, Pe, Ar, mr, vr, nr);
                    return Ii && Yi++, Ii || "failed";
                  }
                  var Ki = vi || nr.allowIncompleteCompletions && Wi < C.moduleSpecifierResolutionLimit, Fi = !Ki && nr.allowIncompleteCompletions && Li < C.moduleSpecifierResolutionCacheAttemptLimit, ui = Ki || Fi ? e.codefix.getModuleSpecifierForBestExportInfo(ut, Dt, Oe, Pe, Ar, mr, vr, nr, Tr, Fi) : void 0;
                  return (!Ki && !Fi || Fi && !ui) && (Ui = true), Wi += (ui == null ? void 0 : ui.computedWithoutCacheCount) || 0, ct += ut.length - ((ui == null ? void 0 : ui.computedWithoutCacheCount) || 0), Fi && Li++, ui || (vi ? "failed" : "skipped");
                }
              }
              function J(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue, fr) {
                var De, gr = Ye(Oe, Ar).previousToken;
                if (!(Mr && !e.isInString(Ar, Oe, gr) && !et(Ar, Mr, gr, Oe))) {
                  if (Mr === " ") return nr.includeCompletionsForImportStatements && nr.includeCompletionsWithInsertText ? { isGlobalCompletion: true, isMemberCompletion: false, isNewIdentifierLocation: true, isIncomplete: true, entries: [] } : void 0;
                  var Vr = vr.getCompilerOptions(), Tr = nr.allowIncompleteCompletions ? (De = xe.getIncompleteCompletionsCache) === null || De === void 0 ? void 0 : De.call(xe) : void 0;
                  if (Tr && Pe === 3 && gr && e.isIdentifier(gr)) {
                    var vi = q(Tr, Ar, gr, vr, xe, nr, Ue);
                    if (vi) return vi;
                  } else Tr == null || Tr.clear();
                  var Ui = C.StringCompletions.getStringLiteralCompletions(Ar, Oe, gr, Vr, xe, vr, mr, nr);
                  if (Ui) return Ui;
                  if (gr && e.isBreakOrContinueStatement(gr.parent) && (gr.kind === 81 || gr.kind === 86 || gr.kind === 79)) return Z(gr.parent);
                  var Yi = ir(vr, mr, Ar, Vr, Oe, nr, void 0, xe, fr, Ue);
                  if (!!Yi) switch (Yi.kind) {
                    case 0:
                      var Wi = X(Ar, xe, vr, Vr, mr, Yi, nr, fr, Oe);
                      return Wi != null && Wi.isIncomplete && (Tr == null || Tr.set(Wi)), Wi;
                    case 1:
                      return O(e.JsDoc.getJSDocTagNameCompletions());
                    case 2:
                      return O(e.JsDoc.getJSDocTagCompletions());
                    case 3:
                      return O(e.JsDoc.getJSDocParameterNameCompletions(Yi.tag));
                    case 4:
                      return ee(Yi.keywordCompletions, Yi.isNewIdentifierLocation);
                    default:
                      return e.Debug.assertNever(Yi);
                  }
                }
              }
              C.getCompletionsAtPosition = J;
              function ie(xe, vr) {
                var mr, Ar, Oe = e.compareStringsCaseSensitiveUI(xe.sortText, vr.sortText);
                return Oe === 0 && (Oe = e.compareStringsCaseSensitiveUI(xe.name, vr.name)), Oe === 0 && ((mr = xe.data) === null || mr === void 0 ? void 0 : mr.moduleSpecifier) && ((Ar = vr.data) === null || Ar === void 0 ? void 0 : Ar.moduleSpecifier) && (Oe = e.compareNumberOfDirectorySeparators(xe.data.moduleSpecifier, vr.data.moduleSpecifier)), Oe === 0 ? -1 : Oe;
              }
              function R(xe) {
                return !!(xe != null && xe.moduleSpecifier);
              }
              function q(xe, vr, mr, Ar, Oe, nr, Mr) {
                var Pe = xe.get();
                if (!!Pe) {
                  var Ue = mr.text.toLowerCase(), fr = e.getExportInfoMap(vr, Oe, Ar, Mr), De = se("continuePreviousIncompleteResponse", Oe, Ar, vr, mr.getStart(), nr, false, e.isValidTypeOnlyAliasUseSite(mr), function(gr) {
                    var Vr = e.mapDefined(Pe.entries, function(Tr) {
                      var vi;
                      if (!Tr.hasAction || !Tr.source || !Tr.data || R(Tr.data)) return Tr;
                      if (!!Wr(Tr.name, Ue)) {
                        var Ui = e.Debug.checkDefined(Br(Tr.name, Tr.data, Ar, Oe)).origin, Yi = fr.get(vr.path, Tr.data.exportMapKey), Wi = Yi && gr.tryResolve(Yi, Tr.name, !e.isExternalModuleNameRelative(e.stripQuotes(Ui.moduleSymbol.name)));
                        if (Wi === "skipped") return Tr;
                        if (!Wi || Wi === "failed") {
                          (vi = Oe.log) === null || vi === void 0 || vi.call(Oe, "Unexpected failure resolving auto import for '".concat(Tr.name, "' from '").concat(Tr.source, "'"));
                          return;
                        }
                        var ct = Ke(Ke({}, Ui), { kind: 32, moduleSpecifier: Wi.moduleSpecifier });
                        return Tr.data = D(ct), Tr.source = We(ct), Tr.sourceDisplay = [e.textPart(ct.moduleSpecifier)], Tr;
                      }
                    });
                    return gr.skippedAny() || (Pe.isIncomplete = void 0), Vr;
                  });
                  return Pe.entries = De, Pe.flags = (Pe.flags || 0) | 4, Pe;
                }
              }
              function O(xe) {
                return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: false, entries: xe };
              }
              function ve(xe) {
                return { name: e.tokenToString(xe), kind: "keyword", kindModifiers: "", sortText: C.SortText.GlobalsOrKeywords };
              }
              function ee(xe, vr) {
                return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: vr, entries: xe.slice() };
              }
              function he(xe, vr, mr) {
                return { kind: 4, keywordCompletions: lr(xe, vr), isNewIdentifierLocation: mr };
              }
              function F(xe) {
                switch (xe) {
                  case 152:
                    return 8;
                  default:
                    e.Debug.fail("Unknown mapping from SyntaxKind to KeywordCompletionFilters");
                }
              }
              function x(xe) {
                return (xe == null ? void 0 : xe.kind) === 79 ? e.createTextSpanFromNode(xe) : void 0;
              }
              function X(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue) {
                var fr = nr.symbols, De = nr.contextToken, gr = nr.completionKind, Vr = nr.isInSnippetScope, Tr = nr.isNewIdentifierLocation, vi = nr.location, Ui = nr.propertyAccessToConvert, Yi = nr.keywordFilters, Wi = nr.literals, ct = nr.symbolToOriginInfoMap, Li = nr.recommendedCompletion, nt = nr.isJsxInitializer, Mt = nr.isTypeOnlyLocation, xt = nr.isJsxIdentifierExpected, ut = nr.isRightOfOpenTag, Dt = nr.importCompletionNode, Rt = nr.insideJsDocTagTypeExpression, Ii = nr.symbolToSortTextMap, Ki = nr.hasUnresolvedAutoImports;
                if (e.getLanguageVariant(xe.scriptKind) === 1) {
                  var Fi = y(vi, xe);
                  if (Fi) return Fi;
                }
                var ui = e.createSortedArray();
                if ($(xe, Ar)) {
                  var Bt = Fe(fr, ui, void 0, De, vi, xe, vr, mr, e.getEmitScriptTarget(Ar), Oe, gr, Mr, Ar, Pe, Mt, Ui, xt, nt, Dt, Li, ct, Ii, xt, ut);
                  V(xe, vi.pos, Bt, e.getEmitScriptTarget(Ar), ui);
                } else {
                  if (!Tr && (!fr || fr.length === 0) && Yi === 0) return;
                  Fe(fr, ui, void 0, De, vi, xe, vr, mr, e.getEmitScriptTarget(Ar), Oe, gr, Mr, Ar, Pe, Mt, Ui, xt, nt, Dt, Li, ct, Ii, xt, ut);
                }
                if (Yi !== 0) for (var wt = new e.Set(ui.map(function(Qa) {
                  return Qa.name;
                })), na = 0, Ai = lr(Yi, !Rt && e.isSourceFileJS(xe)); na < Ai.length; na++) {
                  var Oi = Ai[na];
                  (Mt && e.isTypeKeyword(e.stringToToken(Oi.name)) || !wt.has(Oi.name)) && e.insertSorted(ui, Oi, ie, true);
                }
                for (var ji = new e.Set(ui.map(function(Qa) {
                  return Qa.name;
                })), Vi = 0, at = Ur(De, Ue); Vi < at.length; Vi++) {
                  var Oi = at[Vi];
                  ji.has(Oi.name) || e.insertSorted(ui, Oi, ie, true);
                }
                for (var At = 0, ba = Wi; At < ba.length; At++) {
                  var $a = ba[At];
                  e.insertSorted(ui, P(xe, Mr, $a), ie, true);
                }
                return { flags: nr.flags, isGlobalCompletion: Vr, isIncomplete: Mr.allowIncompleteCompletions && Ki ? true : void 0, isMemberCompletion: A(gr), isNewIdentifierLocation: Tr, optionalReplacementSpan: x(vi), entries: ui };
              }
              function $(xe, vr) {
                return e.isSourceFileJS(xe) && !e.isCheckJsEnabledForFile(xe, vr);
              }
              function A(xe) {
                switch (xe) {
                  case 0:
                  case 3:
                  case 2:
                    return true;
                  default:
                    return false;
                }
              }
              function y(xe, vr) {
                var mr = e.findAncestor(xe, function(fr) {
                  switch (fr.kind) {
                    case 281:
                      return true;
                    case 43:
                    case 31:
                    case 79:
                    case 206:
                      return false;
                    default:
                      return "quit";
                  }
                });
                if (mr) {
                  var Ar = !!e.findChildOfKind(mr, 31, vr), Oe = mr.parent.openingElement.tagName, nr = Oe.getText(vr), Mr = nr + (Ar ? "" : ">"), Pe = e.createTextSpanFromNode(mr.tagName), Ue = { name: Mr, kind: "class", kindModifiers: void 0, sortText: C.SortText.LocationPriority };
                  return { isGlobalCompletion: false, isMemberCompletion: true, isNewIdentifierLocation: false, optionalReplacementSpan: Pe, entries: [Ue] };
                }
              }
              function V(xe, vr, mr, Ar, Oe) {
                e.getNameTable(xe).forEach(function(nr, Mr) {
                  if (nr !== vr) {
                    var Pe = e.unescapeLeadingUnderscores(Mr);
                    !mr.has(Pe) && e.isIdentifierText(Pe, Ar) && (mr.add(Pe), e.insertSorted(Oe, { name: Pe, kind: "warning", kindModifiers: "", sortText: C.SortText.JavascriptIdentifiers, isFromUncheckedFile: true }, ie));
                  }
                });
              }
              function L(xe, vr, mr) {
                return typeof mr == "object" ? e.pseudoBigIntToString(mr) + "n" : e.isString(mr) ? e.quote(xe, vr, mr) : JSON.stringify(mr);
              }
              function P(xe, vr, mr) {
                return { name: L(xe, vr, mr), kind: "string", kindModifiers: "", sortText: C.SortText.LocationPriority };
              }
              function k(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue, fr, De, gr, Vr, Tr, vi, Ui, Yi, Wi, ct, Li, nt, Mt) {
                var xt, ut, Dt, Rt = e.getReplacementSpanForContextToken(mr), Ii, Ki, Fi = We(De), ui, Bt, wt, na = Pe.getTypeChecker(), Ai = De && oe(De), Oi = De && Q(De) || fr;
                if (De && E(De)) Dt = fr ? "this".concat(Ai ? "?." : "", "[").concat(ne(nr, Wi, Ue), "]") : "this".concat(Ai ? "?." : ".").concat(Ue);
                else if ((Oi || Ai) && Vr) {
                  Dt = Oi ? fr ? "[".concat(ne(nr, Wi, Ue), "]") : "[".concat(Ue, "]") : Ue, (Ai || Vr.questionDotToken) && (Dt = "?.".concat(Dt));
                  var ji = e.findChildOfKind(Vr, 24, nr) || e.findChildOfKind(Vr, 28, nr);
                  if (!ji) return;
                  var Vi = e.startsWith(Ue, Vr.name.text) ? Vr.name.end : ji.end;
                  Rt = e.createTextSpanFromBounds(ji.getStart(nr), Vi);
                }
                if (Tr && (Dt === void 0 && (Dt = Ue), Dt = "{".concat(Dt, "}"), typeof Tr != "boolean" && (Rt = e.createTextSpanFromNode(Tr, nr))), De && G(De) && Vr) {
                  Dt === void 0 && (Dt = Ue);
                  var at = e.findPrecedingToken(Vr.pos, nr), At = "";
                  at && e.positionIsASICandidate(at.end, at.parent, nr) && (At = ";"), At += "(await ".concat(Vr.expression.getText(), ")"), Dt = fr ? "".concat(At).concat(Dt) : "".concat(At).concat(Ai ? "?." : ".").concat(Dt), Rt = e.createTextSpanFromBounds(Vr.getStart(nr), Vr.end);
                }
                if (N(De) && (ui = [e.textPart(De.moduleSpecifier)], vi && (xt = g(Ue, vi, Ar, De, Ui, Yi, Wi), Dt = xt.insertText, Rt = xt.replacementSpan, Ki = Wi.includeCompletionsWithSnippetText ? true : void 0)), (De == null ? void 0 : De.kind) === 64 && (Bt = true), Wi.includeCompletionsWithClassMemberSnippets && Wi.includeCompletionsWithInsertText && ct === 3 && Y(xe, Oe)) {
                  var ba = void 0;
                  ut = U(Mr, Pe, Yi, Wi, Ue, xe, Oe, Ar, Li), Dt = ut.insertText, Ki = ut.isSnippet, ba = ut.importAdder, Rt = ut.replacementSpan, vr = C.SortText.ClassMemberSnippets, ba != null && ba.hasFixes() && (Bt = true, Fi = w.ClassMemberSnippet);
                }
                if (De && T(De) && (Dt = De.insertText, Ki = De.isSnippet, wt = De.labelDetails, Wi.useLabelDetailsInCompletionEntries || (Ue = Ue + wt.detail, wt = void 0), Fi = w.ObjectLiteralMethodSnippet, vr = C.SortText.SortBelow(vr)), nt && !Mt && Wi.includeCompletionsWithSnippetText && Wi.jsxAttributeCompletionStyle && Wi.jsxAttributeCompletionStyle !== "none") {
                  var $a = Wi.jsxAttributeCompletionStyle === "braces", Qa = na.getTypeOfSymbolAtLocation(xe, Oe);
                  Wi.jsxAttributeCompletionStyle === "auto" && !(Qa.flags & 528) && !(Qa.flags & 1048576 && e.find(Qa.types, function(ai) {
                    return !!(ai.flags & 528);
                  })) && (Qa.flags & 402653316 || Qa.flags & 1048576 && e.every(Qa.types, function(ai) {
                    return !!(ai.flags & 402686084);
                  }) ? (Dt = "".concat(e.escapeSnippetText(Ue), "=").concat(e.quote(nr, Wi, "$1")), Ki = true) : $a = true), $a && (Dt = "".concat(e.escapeSnippetText(Ue), "={$1}"), Ki = true);
                }
                if (!(Dt !== void 0 && !Wi.includeCompletionsWithInsertText)) return (le(De) || N(De)) && (Ii = D(De), Bt = !vi), { name: Ue, kind: e.SymbolDisplay.getSymbolKind(na, xe, Oe), kindModifiers: e.SymbolDisplay.getSymbolModifiers(na, xe), sortText: vr, source: Fi, hasAction: Bt ? true : void 0, isRecommended: ue(xe, gr, na) || void 0, insertText: Dt, replacementSpan: Rt, sourceDisplay: ui, labelDetails: wt, isSnippet: Ki, isPackageJsonImport: m(De) || void 0, isImportStatementCompletion: !!vi || void 0, data: Ii };
              }
              function Y(xe, vr) {
                if (e.isInJSFile(vr)) return false;
                var mr = 106500;
                return !!(xe.flags & mr) && (e.isClassLike(vr) || vr.parent && vr.parent.parent && e.isClassElement(vr.parent) && vr === vr.parent.name && e.isClassLike(vr.parent.parent) || vr.parent && e.isSyntaxList(vr) && e.isClassLike(vr.parent));
              }
              function U(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue) {
                var fr = e.findAncestor(Mr, e.isClassLike);
                if (!fr) return { insertText: Oe };
                var De, gr, Vr = Oe, Tr = vr.getTypeChecker(), vi = Mr.getSourceFile(), Ui = d({ removeComments: true, module: mr.module, target: mr.target, omitTrailingSemicolon: false, newLine: e.getNewLineKind(e.getNewLineCharacter(mr, e.maybeBind(xe, xe.getNewLine))) }), Yi = e.codefix.createImportAdder(vi, vr, Ar, xe), Wi;
                if (Ar.includeCompletionsWithSnippetText) {
                  De = true;
                  var ct = e.factory.createEmptyStatement();
                  Wi = e.factory.createBlock([ct], true), e.setSnippetElement(ct, { kind: 0, order: 0 });
                } else Wi = e.factory.createBlock([], true);
                var Li = 0, nt = j(Pe), Mt = nt.modifiers, xt = nt.span, ut = !!(Mt & 128), Dt = [];
                if (e.codefix.addNewNodeForMemberSymbol(nr, fr, vi, { program: vr, host: xe }, Ar, Yi, function(Ii) {
                  var Ki = 0;
                  ut && (Ki |= 128), e.isClassElement(Ii) && Tr.getMemberOverrideModifierStatus(fr, Ii) === 1 && (Ki |= 16384), Dt.length || (Li = Ii.modifierFlagsCache | Ki | Mt), Ii = e.factory.updateModifiers(Ii, Li), Dt.push(Ii);
                }, Wi, 2, ut), Dt.length) {
                  var Rt = 131073;
                  gr = xt, Ue ? Vr = Ui.printAndFormatSnippetList(Rt, e.factory.createNodeArray(Dt), vi, Ue) : Vr = Ui.printSnippetList(Rt, e.factory.createNodeArray(Dt), vi);
                }
                return { insertText: Vr, isSnippet: De, importAdder: Yi, replacementSpan: gr };
              }
              function j(xe) {
                if (!xe) return { modifiers: 0 };
                var vr = 0, mr, Ar;
                return (Ar = H(xe)) && (vr |= e.modifierToFlag(Ar), mr = e.createTextSpanFromNode(xe)), e.isPropertyDeclaration(xe.parent) && (vr |= e.modifiersToFlags(xe.parent.modifiers), mr = e.createTextSpanFromNode(xe.parent)), { modifiers: vr, span: mr };
              }
              function H(xe) {
                if (e.isModifier(xe)) return xe.kind;
                if (e.isIdentifier(xe) && xe.originalKeywordKind && e.isModifierKind(xe.originalKeywordKind)) return xe.originalKeywordKind;
              }
              function I(xe, vr, mr, Ar, Oe, nr, Mr, Pe) {
                var Ue = Mr.includeCompletionsWithSnippetText || void 0, fr = vr, De = mr.getSourceFile(), gr = l(xe, mr, De, Ar, Oe, Mr);
                if (!!gr) {
                  var Vr = d({ removeComments: true, module: nr.module, target: nr.target, omitTrailingSemicolon: false, newLine: e.getNewLineKind(e.getNewLineCharacter(nr, e.maybeBind(Oe, Oe.getNewLine))) });
                  Pe ? fr = Vr.printAndFormatSnippetList(80, e.factory.createNodeArray([gr], true), De, Pe) : fr = Vr.printSnippetList(80, e.factory.createNodeArray([gr], true), De);
                  var Tr = e.createPrinter({ removeComments: true, module: nr.module, target: nr.target, omitTrailingSemicolon: true }), vi = e.factory.createMethodSignature(void 0, "", gr.questionToken, gr.typeParameters, gr.parameters, gr.type), Ui = { detail: Tr.printNode(4, vi, De) };
                  return { isSnippet: Ue, insertText: fr, labelDetails: Ui };
                }
              }
              function l(xe, vr, mr, Ar, Oe, nr) {
                var Mr = xe.getDeclarations();
                if (!!(Mr && Mr.length)) {
                  var Pe = Ar.getTypeChecker(), Ue = Mr[0], fr = e.getSynthesizedDeepClone(e.getNameOfDeclaration(Ue), false), De = Pe.getWidenedType(Pe.getTypeOfSymbolAtLocation(xe, vr)), gr = e.getQuotePreference(mr, nr), Vr = gr === 0 ? 268435456 : void 0;
                  switch (Ue.kind) {
                    case 166:
                    case 167:
                    case 168:
                    case 169: {
                      var Tr = De.flags & 1048576 && De.types.length < 10 ? Pe.getUnionType(De.types, 2) : De;
                      if (Tr.flags & 1048576) {
                        var vi = e.filter(Tr.types, function(nt) {
                          return Pe.getSignaturesOfType(nt, 0).length > 0;
                        });
                        if (vi.length === 1) Tr = vi[0];
                        else return;
                      }
                      var Ui = Pe.getSignaturesOfType(Tr, 0);
                      if (Ui.length !== 1) return;
                      var Yi = Pe.typeToTypeNode(Tr, vr, Vr, e.codefix.getNoopSymbolTrackerWithResolver({ program: Ar, host: Oe }));
                      if (!Yi || !e.isFunctionTypeNode(Yi)) return;
                      var Wi = void 0;
                      if (nr.includeCompletionsWithSnippetText) {
                        var ct = e.factory.createEmptyStatement();
                        Wi = e.factory.createBlock([ct], true), e.setSnippetElement(ct, { kind: 0, order: 0 });
                      } else Wi = e.factory.createBlock([], true);
                      var Li = Yi.parameters.map(function(nt) {
                        return e.factory.createParameterDeclaration(void 0, void 0, nt.dotDotDotToken, nt.name, nt.questionToken, void 0, nt.initializer);
                      });
                      return e.factory.createMethodDeclaration(void 0, void 0, void 0, fr, void 0, void 0, Li, void 0, Wi);
                    }
                    default:
                      return;
                  }
                }
              }
              function d(xe) {
                var vr, mr = e.textChanges.createWriter(e.getNewLineCharacter(xe)), Ar = e.createPrinter(xe, mr), Oe = Ke(Ke({}, mr), { write: function(fr) {
                  return nr(fr, function() {
                    return mr.write(fr);
                  });
                }, nonEscapingWrite: mr.write, writeLiteral: function(fr) {
                  return nr(fr, function() {
                    return mr.writeLiteral(fr);
                  });
                }, writeStringLiteral: function(fr) {
                  return nr(fr, function() {
                    return mr.writeStringLiteral(fr);
                  });
                }, writeSymbol: function(fr, De) {
                  return nr(fr, function() {
                    return mr.writeSymbol(fr, De);
                  });
                }, writeParameter: function(fr) {
                  return nr(fr, function() {
                    return mr.writeParameter(fr);
                  });
                }, writeComment: function(fr) {
                  return nr(fr, function() {
                    return mr.writeComment(fr);
                  });
                }, writeProperty: function(fr) {
                  return nr(fr, function() {
                    return mr.writeProperty(fr);
                  });
                } });
                return { printSnippetList: Mr, printAndFormatSnippetList: Ue };
                function nr(fr, De) {
                  var gr = e.escapeSnippetText(fr);
                  if (gr !== fr) {
                    var Vr = mr.getTextPos();
                    De();
                    var Tr = mr.getTextPos();
                    vr = e.append(vr || (vr = []), { newText: gr, span: { start: Vr, length: Tr - Vr } });
                  } else De();
                }
                function Mr(fr, De, gr) {
                  var Vr = Pe(fr, De, gr);
                  return vr ? e.textChanges.applyChanges(Vr, vr) : Vr;
                }
                function Pe(fr, De, gr) {
                  return vr = void 0, Oe.clear(), Ar.writeList(fr, De, gr, Oe), Oe.getText();
                }
                function Ue(fr, De, gr, Vr) {
                  var Tr = { text: Pe(fr, De, gr), getLineAndCharacterOfPosition: function(Wi) {
                    return e.getLineAndCharacterOfPosition(this, Wi);
                  } }, vi = e.getFormatCodeSettingsForWriting(Vr, gr), Ui = e.flatMap(De, function(Wi) {
                    var ct = e.textChanges.assignPositionsToNode(Wi);
                    return e.formatting.formatNodeGivenIndentation(ct, Tr, gr.languageVariant, 0, 0, Ke(Ke({}, Vr), { options: vi }));
                  }), Yi = vr ? e.stableSort(e.concatenate(Ui, vr), function(Wi, ct) {
                    return e.compareTextSpans(Wi.span, ct.span);
                  }) : Ui;
                  return e.textChanges.applyChanges(Tr.text, Yi);
                }
              }
              function D(xe) {
                var vr = xe.fileName ? void 0 : e.stripQuotes(xe.moduleSymbol.name), mr = xe.isFromPackageJson ? true : void 0;
                if (N(xe)) {
                  var Ar = { exportName: xe.exportName, moduleSpecifier: xe.moduleSpecifier, ambientModuleName: vr, fileName: xe.fileName, isPackageJsonImport: mr };
                  return Ar;
                }
                var Oe = { exportName: xe.exportName, exportMapKey: xe.exportMapKey, fileName: xe.fileName, ambientModuleName: xe.fileName ? void 0 : e.stripQuotes(xe.moduleSymbol.name), isPackageJsonImport: xe.isFromPackageJson ? true : void 0 };
                return Oe;
              }
              function fe(xe, vr, mr) {
                var Ar = xe.exportName === "default", Oe = !!xe.isPackageJsonImport;
                if (R(xe)) {
                  var nr = { kind: 32, exportName: xe.exportName, moduleSpecifier: xe.moduleSpecifier, symbolName: vr, fileName: xe.fileName, moduleSymbol: mr, isDefaultExport: Ar, isFromPackageJson: Oe };
                  return nr;
                }
                var Mr = { kind: 4, exportName: xe.exportName, exportMapKey: xe.exportMapKey, symbolName: vr, fileName: xe.fileName, moduleSymbol: mr, isDefaultExport: Ar, isFromPackageJson: Oe };
                return Mr;
              }
              function g(xe, vr, mr, Ar, Oe, nr, Mr) {
                var Pe, Ue, fr, De = vr.getSourceFile(), gr = e.createTextSpanFromNode(e.findAncestor(vr, e.or(e.isImportDeclaration, e.isImportEqualsDeclaration)) || vr, De), Vr = e.quote(De, Mr, Ar.moduleSpecifier), Tr = Ar.isDefaultExport ? 1 : Ar.exportName === "export=" ? 2 : 0, vi = Mr.includeCompletionsWithSnippetText ? "$1" : "", Ui = e.codefix.getImportKind(De, Tr, nr, true), Yi = ((Ue = (Pe = e.tryCast(vr, e.isImportDeclaration)) === null || Pe === void 0 ? void 0 : Pe.importClause) === null || Ue === void 0 ? void 0 : Ue.isTypeOnly) || ((fr = e.tryCast(vr, e.isImportEqualsDeclaration)) === null || fr === void 0 ? void 0 : fr.isTypeOnly), Wi = ae(vr, mr), ct = Yi ? " ".concat(e.tokenToString(152), " ") : " ", Li = Wi ? "".concat(e.tokenToString(152), " ") : "", nt = Oe ? ";" : "";
                switch (Ui) {
                  case 3:
                    return { replacementSpan: gr, insertText: "import".concat(ct).concat(e.escapeSnippetText(xe)).concat(vi, " = require(").concat(Vr, ")").concat(nt) };
                  case 1:
                    return { replacementSpan: gr, insertText: "import".concat(ct).concat(e.escapeSnippetText(xe)).concat(vi, " from ").concat(Vr).concat(nt) };
                  case 2:
                    return { replacementSpan: gr, insertText: "import".concat(ct, "* as ").concat(e.escapeSnippetText(xe), " from ").concat(Vr).concat(nt) };
                  case 0:
                    return { replacementSpan: gr, insertText: "import".concat(ct, "{ ").concat(Li).concat(e.escapeSnippetText(xe)).concat(vi, " } from ").concat(Vr).concat(nt) };
                }
              }
              function ne(xe, vr, mr) {
                return /^\d+$/.test(mr) ? mr : e.quote(xe, vr, mr);
              }
              function ue(xe, vr, mr) {
                return xe === vr || !!(xe.flags & 1048576) && mr.getExportSymbolOfSymbol(xe) === vr;
              }
              function We(xe) {
                if (le(xe)) return e.stripQuotes(xe.moduleSymbol.name);
                if (N(xe)) return xe.moduleSpecifier;
                if ((xe == null ? void 0 : xe.kind) === 1) return w.ThisProperty;
                if ((xe == null ? void 0 : xe.kind) === 64) return w.TypeOnlyAlias;
              }
              function Fe(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue, fr, De, gr, Vr, Tr, vi, Ui, Yi, Wi, ct, Li, nt, Mt, xt, ut) {
                for (var Dt, Rt = e.timestamp(), Ii = ti(Oe), Ki = e.probablyUsesSemicolons(nr), Fi = Pe.getTypeChecker(), ui = new e.Map(), Bt = 0; Bt < xe.length; Bt++) {
                  var wt = xe[Bt], na = nt == null ? void 0 : nt[Bt], Ai = Er(wt, Ue, na, De, !!Yi);
                  if (!(!Ai || ui.get(Ai.name) && (!na || !T(na)) || De === 1 && Mt && !$a(wt, Mt))) {
                    var Oi = Ai.name, ji = Ai.needsConvertPropertyAccess, Vi = (Dt = Mt == null ? void 0 : Mt[e.getSymbolId(wt)]) !== null && Dt !== void 0 ? Dt : C.SortText.LocationPriority, at = zr(wt, Fi) ? C.SortText.Deprecated(Vi) : Vi, At = k(wt, at, mr, Ar, Oe, nr, Mr, Pe, Oi, ji, na, Li, Ui, Wi, ct, Ki, Vr, gr, De, Tr, xt, ut);
                    if (!!At) {
                      var ba = (!na || f(na)) && !(wt.parent === void 0 && !e.some(wt.declarations, function(Qa) {
                        return Qa.getSourceFile() === Oe.getSourceFile();
                      }));
                      ui.set(Oi, ba), e.insertSorted(vr, At, ie, true);
                    }
                  }
                }
                return fr("getCompletionsAtPosition: getCompletionEntriesFromSymbols: " + (e.timestamp() - Rt)), { has: function(Qa) {
                  return ui.has(Qa);
                }, add: function(Qa) {
                  return ui.set(Qa, true);
                } };
                function $a(Qa, ai) {
                  var Dn = Qa.flags;
                  if (!e.isSourceFile(Oe)) {
                    if (e.isExportAssignment(Oe.parent)) return true;
                    if (Ii && Qa.valueDeclaration === Ii) return false;
                    var ka = e.skipAlias(Qa, Fi);
                    if (!!nr.externalModuleIndicator && !Vr.allowUmdGlobalAccess && ai[e.getSymbolId(Qa)] === C.SortText.GlobalsOrKeywords && (ai[e.getSymbolId(ka)] === C.SortText.AutoImportSuggestions || ai[e.getSymbolId(ka)] === C.SortText.LocationPriority)) return false;
                    if (Dn |= e.getCombinedLocalAndExportSymbolFlags(ka), e.isInRightSideOfInternalImportEqualsDeclaration(Oe)) return !!(Dn & 1920);
                    if (vi) return Sr(Qa, Fi);
                  }
                  return !!(Dn & 111551);
                }
              }
              C.getCompletionEntriesFromSymbols = Fe;
              function Z(xe) {
                var vr = Be(xe);
                if (vr.length) return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: false, entries: vr };
              }
              function Be(xe) {
                for (var vr = [], mr = new e.Map(), Ar = xe; Ar && !e.isFunctionLike(Ar); ) {
                  if (e.isLabeledStatement(Ar)) {
                    var Oe = Ar.label.text;
                    mr.has(Oe) || (mr.set(Oe, true), vr.push({ name: Oe, kindModifiers: "", kind: "label", sortText: C.SortText.LocationPriority }));
                  }
                  Ar = Ar.parent;
                }
                return vr;
              }
              function ge(xe, vr, mr, Ar, Oe, nr, Mr) {
                if (Oe.data) {
                  var Pe = Br(Oe.name, Oe.data, xe, nr);
                  if (Pe) {
                    var Ue = Ye(Ar, mr), fr = Ue.contextToken, De = Ue.previousToken;
                    return { type: "symbol", symbol: Pe.symbol, location: e.getTouchingPropertyName(mr, Ar), previousToken: De, contextToken: fr, isJsxInitializer: false, isTypeOnlyLocation: false, origin: Pe.origin };
                  }
                }
                var gr = xe.getCompilerOptions(), Vr = ir(xe, vr, mr, gr, Ar, { includeCompletionsForModuleExports: true, includeCompletionsWithInsertText: true }, Oe, nr, void 0);
                if (!Vr) return { type: "none" };
                if (Vr.kind !== 0) return { type: "request", request: Vr };
                var Tr = Vr.symbols, vi = Vr.literals, Ui = Vr.location, Yi = Vr.completionKind, Wi = Vr.symbolToOriginInfoMap, ct = Vr.contextToken, Li = Vr.previousToken, nt = Vr.isJsxInitializer, Mt = Vr.isTypeOnlyLocation, xt = e.find(vi, function(ut) {
                  return L(mr, Mr, ut) === Oe.name;
                });
                return xt !== void 0 ? { type: "literal", literal: xt } : e.firstDefined(Tr, function(ut, Dt) {
                  var Rt = Wi[Dt], Ii = Er(ut, e.getEmitScriptTarget(gr), Rt, Yi, Vr.isJsxIdentifierExpected);
                  return Ii && Ii.name === Oe.name && (Oe.source === w.ClassMemberSnippet && ut.flags & 106500 || Oe.source === w.ObjectLiteralMethodSnippet && ut.flags & 8196 || We(Rt) === Oe.source) ? { type: "symbol", symbol: ut, location: Ui, origin: Rt, contextToken: ct, previousToken: Li, isJsxInitializer: nt, isTypeOnlyLocation: Mt } : void 0;
                }) || { type: "none" };
              }
              function Re(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue) {
                var fr = xe.getTypeChecker(), De = xe.getCompilerOptions(), gr = Oe.name, Vr = Oe.source, Tr = Oe.data, vi = e.findPrecedingToken(Ar, mr);
                if (e.isInString(mr, Ar, vi)) return C.StringCompletions.getStringLiteralCompletionDetails(gr, mr, Ar, vi, fr, De, nr, Ue, Pe);
                var Ui = ge(xe, vr, mr, Ar, Oe, nr, Pe);
                switch (Ui.type) {
                  case "request": {
                    var Yi = Ui.request;
                    switch (Yi.kind) {
                      case 1:
                        return e.JsDoc.getJSDocTagNameCompletionDetails(gr);
                      case 2:
                        return e.JsDoc.getJSDocTagCompletionDetails(gr);
                      case 3:
                        return e.JsDoc.getJSDocParameterNameCompletionDetails(gr);
                      case 4:
                        return e.some(Yi.keywordCompletions, function(Ii) {
                          return Ii.name === gr;
                        }) ? ze(gr, "keyword", e.SymbolDisplayPartKind.keyword) : void 0;
                      default:
                        return e.Debug.assertNever(Yi);
                    }
                  }
                  case "symbol": {
                    var Wi = Ui.symbol, ct = Ui.location, Li = Ui.contextToken, nt = Ui.origin, Mt = Ui.previousToken, xt = rr(gr, ct, Li, nt, Wi, xe, nr, De, mr, Ar, Mt, Mr, Pe, Tr, Vr), ut = xt.codeActions, Dt = xt.sourceDisplay;
                    return Ee(Wi, fr, mr, ct, Ue, ut, Dt);
                  }
                  case "literal": {
                    var Rt = Ui.literal;
                    return ze(L(mr, Pe, Rt), "string", typeof Rt == "string" ? e.SymbolDisplayPartKind.stringLiteral : e.SymbolDisplayPartKind.numericLiteral);
                  }
                  case "none":
                    return n().some(function(Ii) {
                      return Ii.name === gr;
                    }) ? ze(gr, "keyword", e.SymbolDisplayPartKind.keyword) : void 0;
                  default:
                    e.Debug.assertNever(Ui);
                }
              }
              C.getCompletionEntryDetails = Re;
              function ze(xe, vr, mr) {
                return He(xe, "", vr, [e.displayPart(xe, mr)]);
              }
              function Ee(xe, vr, mr, Ar, Oe, nr, Mr) {
                var Pe = vr.runWithCancellationToken(Oe, function(Vr) {
                  return e.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(Vr, xe, mr, Ar, Ar, 7);
                }), Ue = Pe.displayParts, fr = Pe.documentation, De = Pe.symbolKind, gr = Pe.tags;
                return He(xe.name, e.SymbolDisplay.getSymbolModifiers(vr, xe), De, Ue, fr, gr, nr, Mr);
              }
              C.createCompletionDetailsForSymbol = Ee;
              function He(xe, vr, mr, Ar, Oe, nr, Mr, Pe) {
                return { name: xe, kindModifiers: vr, kind: mr, displayParts: Ar, documentation: Oe, tags: nr, codeActions: Mr, source: Pe, sourceDisplay: Pe };
              }
              C.createCompletionDetails = He;
              function rr(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue, fr, De, gr, Vr, Tr, vi) {
                if (Tr != null && Tr.moduleSpecifier && De && pi(mr || De).replacementNode) return { codeActions: void 0, sourceDisplay: [e.textPart(Tr.moduleSpecifier)] };
                if (vi === w.ClassMemberSnippet) {
                  var Ui = U(Mr, nr, Pe, Vr, xe, Oe, vr, mr, gr).importAdder;
                  if (Ui) {
                    var Yi = e.textChanges.ChangeTracker.with({ host: Mr, formatContext: gr, preferences: Vr }, Ui.writeFixes);
                    return { sourceDisplay: void 0, codeActions: [{ changes: Yi, description: e.diagnosticToString([e.Diagnostics.Includes_imports_of_types_referenced_by_0, xe]) }] };
                  }
                }
                if (f(Ar)) {
                  var Wi = e.codefix.getPromoteTypeOnlyCompletionAction(Ue, Ar.declaration.name, nr, Mr, gr, Vr);
                  return e.Debug.assertIsDefined(Wi, "Expected to have a code action for promoting type-only alias"), { codeActions: [Wi], sourceDisplay: void 0 };
                }
                if (!Ar || !(le(Ar) || N(Ar))) return { codeActions: void 0, sourceDisplay: void 0 };
                var ct = Ar.isFromPackageJson ? Mr.getPackageJsonAutoImportProvider().getTypeChecker() : nr.getTypeChecker(), Li = Ar.moduleSymbol, nt = ct.getMergedSymbol(e.skipAlias(Oe.exportSymbol || Oe, ct)), Mt = (mr == null ? void 0 : mr.kind) === 29 && e.isJsxOpeningLikeElement(mr.parent), xt = e.codefix.getImportCompletionAction(nt, Li, Ue, e.getNameForExportedSymbol(Oe, e.getEmitScriptTarget(Pe), Mt), Mt, Mr, nr, gr, De && e.isIdentifier(De) ? De.getStart(Ue) : fr, Vr), ut = xt.moduleSpecifier, Dt = xt.codeAction;
                return e.Debug.assert(!(Tr != null && Tr.moduleSpecifier) || ut === Tr.moduleSpecifier), { sourceDisplay: [e.textPart(ut)], codeActions: [Dt] };
              }
              function Ie(xe, vr, mr, Ar, Oe, nr, Mr) {
                var Pe = ge(xe, vr, mr, Ar, Oe, nr, Mr);
                return Pe.type === "symbol" ? Pe.symbol : void 0;
              }
              C.getCompletionEntrySymbol = Ie;
              var _e;
              (function(xe) {
                xe[xe.Data = 0] = "Data", xe[xe.JsDocTagName = 1] = "JsDocTagName", xe[xe.JsDocTag = 2] = "JsDocTag", xe[xe.JsDocParameterName = 3] = "JsDocParameterName", xe[xe.Keywords = 4] = "Keywords";
              })(_e || (_e = {}));
              var we;
              (function(xe) {
                xe[xe.ObjectPropertyDeclaration = 0] = "ObjectPropertyDeclaration", xe[xe.Global = 1] = "Global", xe[xe.PropertyAccess = 2] = "PropertyAccess", xe[xe.MemberLike = 3] = "MemberLike", xe[xe.String = 4] = "String", xe[xe.None = 5] = "None";
              })(we = C.CompletionKind || (C.CompletionKind = {}));
              function de(xe, vr, mr) {
                return e.firstDefined(vr && (vr.isUnion() ? vr.types : [vr]), function(Ar) {
                  var Oe = Ar && Ar.symbol;
                  return Oe && Oe.flags & 424 && !e.isAbstractConstructorSymbol(Oe) ? Ae(Oe, xe, mr) : void 0;
                });
              }
              function ye(xe, vr, mr, Ar) {
                var Oe = xe.parent;
                switch (xe.kind) {
                  case 79:
                    return e.getContextualTypeFromParent(xe, Ar);
                  case 63:
                    switch (Oe.kind) {
                      case 254:
                        return Ar.getContextualType(Oe.initializer);
                      case 221:
                        return Ar.getTypeAtLocation(Oe.left);
                      case 285:
                        return Ar.getContextualTypeForJsxAttribute(Oe);
                      default:
                        return;
                    }
                  case 103:
                    return Ar.getContextualType(Oe);
                  case 82:
                    var nr = e.tryCast(Oe, e.isCaseClause);
                    return nr ? e.getSwitchedType(nr, Ar) : void 0;
                  case 18:
                    return e.isJsxExpression(Oe) && !e.isJsxElement(Oe.parent) && !e.isJsxFragment(Oe.parent) ? Ar.getContextualTypeForJsxAttribute(Oe.parent) : void 0;
                  default:
                    var Mr = e.SignatureHelp.getArgumentInfoForCompletions(xe, vr, mr);
                    return Mr ? Ar.getContextualTypeForArgumentAtIndex(Mr.invocation, Mr.argumentIndex + (xe.kind === 27 ? 1 : 0)) : e.isEqualityOperatorKind(xe.kind) && e.isBinaryExpression(Oe) && e.isEqualityOperatorKind(Oe.operatorToken.kind) ? Ar.getTypeAtLocation(Oe.left) : Ar.getContextualType(xe);
                }
              }
              function Ae(xe, vr, mr) {
                var Ar = mr.getAccessibleSymbolChain(xe, vr, 67108863, false);
                return Ar ? e.first(Ar) : xe.parent && (er(xe.parent) ? xe : Ae(xe.parent, vr, mr));
              }
              function er(xe) {
                var vr;
                return !!(!((vr = xe.declarations) === null || vr === void 0) && vr.some(function(mr) {
                  return mr.kind === 305;
                }));
              }
              function ir(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue, fr) {
                var De = xe.getTypeChecker(), gr = $(mr, Ar), Vr = e.timestamp(), Tr = e.getTokenAtPosition(mr, Oe);
                vr("getCompletionData: Get current token: " + (e.timestamp() - Vr)), Vr = e.timestamp();
                var vi = e.isInComment(mr, Oe, Tr);
                vr("getCompletionData: Is inside comment: " + (e.timestamp() - Vr));
                var Ui = false, Yi = false;
                if (vi) {
                  if (e.hasDocComment(mr, Oe)) {
                    if (mr.text.charCodeAt(Oe - 1) === 64) return { kind: 1 };
                    var Wi = e.getLineStartPositionForPosition(Oe, mr);
                    if (!/[^\*|\s(/)]/.test(mr.text.substring(Wi, Oe))) return { kind: 2 };
                  }
                  var ct = ii(Tr, Oe);
                  if (ct) {
                    if (ct.tagName.pos <= Oe && Oe <= ct.tagName.end) return { kind: 1 };
                    var Li = bo(ct);
                    if (Li && (Tr = e.getTokenAtPosition(mr, Oe), (!Tr || !e.isDeclarationName(Tr) && (Tr.parent.kind !== 347 || Tr.parent.name !== Tr)) && (Ui = ds(Li))), !Ui && e.isJSDocParameterTag(ct) && (e.nodeIsMissing(ct.name) || ct.name.pos <= Oe && Oe <= ct.name.end)) return { kind: 3, tag: ct };
                  }
                  if (!Ui) {
                    vr("Returning an empty list because completion was inside a regular comment or plain text part of a JsDoc comment.");
                    return;
                  }
                }
                Vr = e.timestamp();
                var nt = !Ui && e.isSourceFileJS(mr), Mt = Ye(Oe, mr), xt = Mt.previousToken, ut = Mt.contextToken;
                vr("getCompletionData: Get previous token: " + (e.timestamp() - Vr));
                var Dt = Tr, Rt, Ii = false, Ki = false, Fi = false, ui = false, Bt = false, wt = false, na, Ai = e.getTouchingPropertyName(mr, Oe), Oi = 0, ji = false, Vi = 0;
                if (ut) {
                  var at = pi(ut);
                  if (ji = at.isNewIdentifierLocation, at.keywordCompletion) {
                    if (at.isKeywordOnlyCompletion) return { kind: 4, keywordCompletions: [ve(at.keywordCompletion)], isNewIdentifierLocation: ji };
                    Oi = F(at.keywordCompletion);
                  }
                  if (at.replacementNode && nr.includeCompletionsForImportStatements && nr.includeCompletionsWithInsertText && (na = at.replacementNode, Vi |= 2), !na && qe(ut)) return vr("Returning an empty list because completion was requested in an invalid position."), Oi ? he(Oi, nt, Zr()) : void 0;
                  var At = ut.parent;
                  if (ut.kind === 24 || ut.kind === 28) switch (Ii = ut.kind === 24, Ki = ut.kind === 28, At.kind) {
                    case 206:
                      Rt = At, Dt = Rt.expression;
                      var ba = e.getLeftmostAccessExpression(Rt);
                      if (e.nodeIsMissing(ba) || (e.isCallExpression(Dt) || e.isFunctionLike(Dt)) && Dt.end === ut.pos && Dt.getChildCount(mr) && e.last(Dt.getChildren(mr)).kind !== 21) return;
                      break;
                    case 161:
                      Dt = At.left;
                      break;
                    case 261:
                      Dt = At.name;
                      break;
                    case 200:
                      Dt = At;
                      break;
                    case 231:
                      Dt = At.getFirstToken(mr), e.Debug.assert(Dt.kind === 100 || Dt.kind === 103);
                      break;
                    default:
                      return;
                  }
                  else if (!na && mr.languageVariant === 1) {
                    if (At && At.kind === 206 && (ut = At, At = At.parent), Tr.parent === Ai) switch (Tr.kind) {
                      case 31:
                        (Tr.parent.kind === 278 || Tr.parent.kind === 280) && (Ai = Tr);
                        break;
                      case 43:
                        Tr.parent.kind === 279 && (Ai = Tr);
                        break;
                    }
                    switch (At.kind) {
                      case 281:
                        ut.kind === 43 && (ui = true, Ai = ut);
                        break;
                      case 221:
                        if (!Gi(At)) break;
                      case 279:
                      case 278:
                      case 280:
                        wt = true, ut.kind === 29 && (Fi = true, Ai = ut);
                        break;
                      case 288:
                      case 287:
                        xt.kind === 19 && Tr.kind === 31 && (wt = true);
                        break;
                      case 285:
                        if (At.initializer === xt && xt.end < Oe) {
                          wt = true;
                          break;
                        }
                        switch (xt.kind) {
                          case 63:
                            Bt = true;
                            break;
                          case 79:
                            wt = true, At !== xt.parent && !At.initializer && e.findChildOfKind(At, 63, mr) && (Bt = xt);
                        }
                        break;
                    }
                  }
                }
                var $a = e.timestamp(), Qa = 5, ai = false, Dn = false, ka = [], Ba = [], pn = [], Cn = new e.Map(), Bi = St(), kn = e.memoizeOne(function(Ji) {
                  return e.createModuleSpecifierResolutionHost(Ji ? Pe.getPackageJsonAutoImportProvider() : xe, Pe);
                });
                if (Ii || Ki) Ro();
                else if (Fi) ka = De.getJsxIntrinsicTagNamesAt(Ai), e.Debug.assertEachIsDefined(ka, "getJsxIntrinsicTagNames() should all be defined"), Co(), Qa = 1, Oi = 0;
                else if (ui) {
                  var xn = ut.parent.parent.openingElement.tagName, Kn = De.getSymbolAtLocation(xn);
                  Kn && (ka = [Kn]), Qa = 1, Oi = 0;
                } else if (!Co()) return Oi ? he(Oi, nt, ji) : void 0;
                vr("getCompletionData: Semantic work: " + (e.timestamp() - $a));
                var Pn = xt && ye(xt, Oe, mr, De), eo = e.mapDefined(Pn && (Pn.isUnion() ? Pn.types : [Pn]), function(Ji) {
                  return Ji.isLiteral() && !(Ji.flags & 1024) ? Ji.value : void 0;
                }), Rn = xt && Pn && de(xt, Pn, De);
                return { kind: 0, symbols: ka, completionKind: Qa, isInSnippetScope: Yi, propertyAccessToConvert: Rt, isNewIdentifierLocation: ji, location: Ai, keywordFilters: Oi, literals: eo, symbolToOriginInfoMap: Ba, recommendedCompletion: Rn, previousToken: xt, contextToken: ut, isJsxInitializer: Bt, insideJsDocTagTypeExpression: Ui, symbolToSortTextMap: pn, isTypeOnlyLocation: Bi, isJsxIdentifierExpected: wt, isRightOfOpenTag: Fi, importCompletionNode: na, hasUnresolvedAutoImports: Dn, flags: Vi };
                function Da(Ji) {
                  switch (Ji.kind) {
                    case 340:
                    case 347:
                    case 341:
                    case 343:
                    case 345:
                      return true;
                    case 344:
                      return !!Ji.constraint;
                    default:
                      return false;
                  }
                }
                function bo(Ji) {
                  if (Da(Ji)) {
                    var ce = e.isJSDocTemplateTag(Ji) ? Ji.constraint : Ji.typeExpression;
                    return ce && ce.kind === 309 ? ce : void 0;
                  }
                }
                function Ro() {
                  Qa = 2;
                  var Ji = e.isLiteralImportTypeNode(Dt), ce = Ui || Ji && !Dt.isTypeOf || e.isPartOfTypeNode(Dt.parent) || e.isPossiblyTypeArgumentPosition(ut, mr, De), Rr = e.isInRightSideOfInternalImportEqualsDeclaration(Dt);
                  if (e.isEntityName(Dt) || Ji || e.isPropertyAccessExpression(Dt)) {
                    var yi = e.isModuleDeclaration(Dt.parent);
                    yi && (ji = true);
                    var qi = De.getSymbolAtLocation(Dt);
                    if (qi && (qi = e.skipAlias(qi, De), qi.flags & 1920)) {
                      var je = De.getExportsOfModule(qi);
                      e.Debug.assertEachIsDefined(je, "getExportsOfModule() should all be defined");
                      for (var Hr = function(Fo) {
                        return De.isValidPropertyAccess(Ji ? Dt : Dt.parent, Fo.name);
                      }, pt = function(Fo) {
                        return Sr(Fo, De);
                      }, Pt = yi ? function(Fo) {
                        var ko;
                        return !!(Fo.flags & 1920) && !(!((ko = Fo.declarations) === null || ko === void 0) && ko.every(function(Ao) {
                          return Ao.parent === Dt.parent;
                        }));
                      } : Rr ? function(Fo) {
                        return pt(Fo) || Hr(Fo);
                      } : ce ? pt : Hr, ga = 0, ua = je; ga < ua.length; ga++) {
                        var Xn = ua[ga];
                        Pt(Xn) && ka.push(Xn);
                      }
                      if (!ce && qi.declarations && qi.declarations.some(function(Fo) {
                        return Fo.kind !== 305 && Fo.kind !== 261 && Fo.kind !== 260;
                      })) {
                        var jr = De.getTypeOfSymbolAtLocation(qi, Dt).getNonOptionalType(), fo = false;
                        if (jr.isNullableType()) {
                          var xs = Ii && !Ki && nr.includeAutomaticOptionalChainCompletions !== false;
                          (xs || Ki) && (jr = jr.getNonNullableType(), xs && (fo = true));
                        }
                        En(jr, !!(Dt.flags & 32768), fo);
                      }
                      return;
                    }
                  }
                  if (!ce) {
                    De.tryGetThisTypeAt(Dt, false);
                    var jr = De.getTypeAtLocation(Dt).getNonOptionalType(), fo = false;
                    if (jr.isNullableType()) {
                      var xs = Ii && !Ki && nr.includeAutomaticOptionalChainCompletions !== false;
                      (xs || Ki) && (jr = jr.getNonNullableType(), xs && (fo = true));
                    }
                    En(jr, !!(Dt.flags & 32768), fo);
                  }
                }
                function En(Ji, ce, Rr) {
                  ji = !!Ji.getStringIndexType(), Ki && e.some(Ji.getCallSignatures()) && (ji = true);
                  var yi = Dt.kind === 200 ? Dt : Dt.parent;
                  if (gr) ka.push.apply(ka, e.filter(qr(Ji, De), function(ua) {
                    return De.isValidPropertyAccessForCompletions(yi, Ji, ua);
                  }));
                  else for (var qi = 0, je = Ji.getApparentProperties(); qi < je.length; qi++) {
                    var Hr = je[qi];
                    De.isValidPropertyAccessForCompletions(yi, Ji, Hr) && Wn(Hr, false, Rr);
                  }
                  if (ce && nr.includeCompletionsWithInsertText) {
                    var pt = De.getPromisedTypeOfPromise(Ji);
                    if (pt) for (var Pt = 0, ga = pt.getApparentProperties(); Pt < ga.length; Pt++) {
                      var Hr = ga[Pt];
                      De.isValidPropertyAccessForCompletions(yi, pt, Hr) && Wn(Hr, true, Rr);
                    }
                  }
                }
                function Wn(Ji, ce, Rr) {
                  var yi, qi = e.firstDefined(Ji.declarations, function(ko) {
                    return e.tryCast(e.getNameOfDeclaration(ko), e.isComputedPropertyName);
                  });
                  if (qi) {
                    var je = to(qi.expression), Hr = je && De.getSymbolAtLocation(je), pt = Hr && Ae(Hr, ut, De);
                    if (pt && e.addToSeen(Cn, e.getSymbolId(pt))) {
                      var Pt = ka.length;
                      ka.push(pt);
                      var ga = pt.parent;
                      if (!ga || !e.isExternalModuleSymbol(ga) || De.tryGetMemberInModuleExportsAndProperties(pt.name, ga) !== pt) Ba[Pt] = { kind: Fo(2) };
                      else {
                        var ua = e.isExternalModuleNameRelative(e.stripQuotes(ga.name)) ? (yi = e.getSourceFileOfModule(ga)) === null || yi === void 0 ? void 0 : yi.fileName : void 0, Xn = (e.codefix.getModuleSpecifierForBestExportInfo([{ exportKind: 0, moduleFileName: ua, isFromPackageJson: false, moduleSymbol: ga, symbol: pt, targetFlags: e.skipAlias(pt, De).flags }], pt.name, Oe, e.isValidTypeOnlyAliasUseSite(Ai), mr, xe, Pe, nr) || {}).moduleSpecifier;
                        if (Xn) {
                          var jr = { kind: Fo(6), moduleSymbol: ga, isDefaultExport: false, symbolName: pt.name, exportName: pt.name, fileName: ua, moduleSpecifier: Xn };
                          Ba[Pt] = jr;
                        }
                      }
                    } else nr.includeCompletionsWithInsertText && (xs(Ji), fo(Ji), ka.push(Ji));
                  } else xs(Ji), fo(Ji), ka.push(Ji);
                  function fo(ko) {
                    Zt(ko) && (pn[e.getSymbolId(ko)] = C.SortText.LocalDeclarationPriority);
                  }
                  function xs(ko) {
                    nr.includeCompletionsWithInsertText && (ce && e.addToSeen(Cn, e.getSymbolId(ko)) ? Ba[ka.length] = { kind: Fo(8) } : Rr && (Ba[ka.length] = { kind: 16 }));
                  }
                  function Fo(ko) {
                    return Rr ? ko | 16 : ko;
                  }
                }
                function to(Ji) {
                  return e.isIdentifier(Ji) ? Ji : e.isPropertyAccessExpression(Ji) ? to(Ji.expression) : void 0;
                }
                function Co() {
                  var Ji = Pi() || Qi() || no() || Ct() || sa() || Ko() || en() || Oo() || ($o(), 1);
                  return Ji === 1;
                }
                function Ko() {
                  return qn(ut) ? (Qa = 5, ji = true, Oi = 4, 1) : 0;
                }
                function Oo() {
                  var Ji = So(ut), ce = Ji && De.getContextualType(Ji.attributes);
                  if (!ce) return 0;
                  var Rr = Ji && De.getContextualType(Ji.attributes, 4);
                  return ka = e.concatenate(ka, js(mi(ce, Rr, Ji.attributes, De), Ji.attributes.properties)), hs(), Qa = 3, ji = false, 1;
                }
                function no() {
                  return na ? (ji = true, Jn(), 1) : 0;
                }
                function $o() {
                  Oi = mo(ut) ? 5 : 1, Qa = 1, ji = Zr(), xt !== ut && e.Debug.assert(!!xt, "Expected 'contextToken' to be defined when different from 'previousToken'.");
                  var Ji = xt !== ut ? xt.getStart() : Oe, ce = Ce(ut, Ji, mr) || mr;
                  Yi = xi(ce);
                  var Rr = (Bi ? 0 : 111551) | 788968 | 1920 | 2097152, yi = xt && !e.isValidTypeOnlyAliasUseSite(xt);
                  ka = e.concatenate(ka, De.getSymbolsInScope(ce, Rr)), e.Debug.assertEachIsDefined(ka, "getSymbolsInScope() should all be defined");
                  for (var qi = 0; qi < ka.length; qi++) {
                    var je = ka[qi];
                    if (!De.isArgumentsSymbol(je) && !e.some(je.declarations, function(Xn) {
                      return Xn.getSourceFile() === mr;
                    }) && (pn[e.getSymbolId(je)] = C.SortText.GlobalsOrKeywords), yi && !(je.flags & 111551)) {
                      var Hr = je.declarations && e.find(je.declarations, e.isTypeOnlyImportOrExportDeclaration);
                      if (Hr) {
                        var pt = { kind: 64, declaration: Hr };
                        Ba[qi] = pt;
                      }
                    }
                  }
                  if (nr.includeCompletionsWithInsertText && ce.kind !== 305) {
                    var Pt = De.tryGetThisTypeAt(ce, false);
                    if (Pt && !Wt(Pt, mr, De)) for (var ga = 0, ua = qr(Pt, De); ga < ua.length; ga++) {
                      var je = ua[ga];
                      Ba[ka.length] = { kind: 1 }, ka.push(je), pn[e.getSymbolId(je)] = C.SortText.SuggestedClassMembers;
                    }
                  }
                  Jn(), Bi && (Oi = ut && e.isAssertionExpression(ut.parent) ? 6 : 7);
                }
                function Pr() {
                  return na ? true : ai || !nr.includeCompletionsForModuleExports ? false : mr.externalModuleIndicator || mr.commonJsModuleIndicator || e.compilerOptionsIndicateEsModules(xe.getCompilerOptions()) ? true : e.programContainsModules(xe);
                }
                function xi(Ji) {
                  switch (Ji.kind) {
                    case 305:
                    case 223:
                    case 288:
                    case 235:
                      return true;
                    default:
                      return e.isStatement(Ji);
                  }
                }
                function St() {
                  return Ui || !!na && e.isTypeOnlyImportOrExportDeclaration(Ai.parent) || !pa(ut) && (e.isPossiblyTypeArgumentPosition(ut, mr, De) || e.isPartOfTypeNode(Ai) || dn(ut));
                }
                function pa(Ji) {
                  return Ji && (Ji.kind === 112 && (Ji.parent.kind === 181 || e.isTypeOfExpression(Ji.parent)) || Ji.kind === 128 && Ji.parent.kind === 177);
                }
                function dn(Ji) {
                  if (Ji) {
                    var ce = Ji.parent.kind;
                    switch (Ji.kind) {
                      case 58:
                        return ce === 167 || ce === 166 || ce === 164 || ce === 254 || e.isFunctionLikeKind(ce);
                      case 63:
                        return ce === 259;
                      case 127:
                        return ce === 229;
                      case 29:
                        return ce === 178 || ce === 211;
                      case 94:
                        return ce === 163;
                    }
                  }
                  return false;
                }
                function Jn() {
                  var Ji, ce;
                  if (!Pr() || (e.Debug.assert(!(Mr != null && Mr.data), "Should not run 'collectAutoImports' when faster path is available via `data`"), Mr && !Mr.source)) return;
                  Vi |= 1;
                  var Rr = xt === ut && na && ae(na, ut), yi = Rr ? "" : xt && e.isIdentifier(xt) ? xt.text.toLowerCase() : "", qi = (Ji = Pe.getModuleSpecifierCache) === null || Ji === void 0 ? void 0 : Ji.call(Pe), je = e.getExportInfoMap(mr, Pe, xe, fr), Hr = (ce = Pe.getPackageJsonAutoImportProvider) === null || ce === void 0 ? void 0 : ce.call(Pe), pt = Mr ? void 0 : e.createPackageJsonImportFilter(mr, nr, Pe);
                  se("collectAutoImports", Pe, xe, mr, Oe, nr, !!na, e.isValidTypeOnlyAliasUseSite(Ai), function(ga) {
                    je.search(mr.path, Fi, function(ua, Xn) {
                      if (!e.isIdentifierText(ua, e.getEmitScriptTarget(Pe.getCompilationSettings())) || !Mr && e.isStringANonContextualKeyword(ua) || !Bi && !na && !(Xn & 111551) || Bi && !(Xn & 790504)) return false;
                      var jr = ua.charCodeAt(0);
                      return Fi && (jr < 65 || jr > 90) ? false : Mr ? true : Wr(ua, yi);
                    }, function(ua, Xn, jr, fo) {
                      var xs;
                      if (!(Mr && !e.some(ua, function(su) {
                        return Mr.source === e.stripQuotes(su.moduleSymbol.name);
                      }))) {
                        var Fo = e.find(ua, Pt);
                        if (!!Fo) {
                          var ko = ga.tryResolve(ua, Xn, jr) || {};
                          if (ko !== "failed") {
                            var Ao = Fo, Ms;
                            ko !== "skipped" && (xs = ko.exportInfo, Ao = xs === void 0 ? Fo : xs, Ms = ko.moduleSpecifier);
                            var Bs = Ao.exportKind === 1, xc = Bs && e.getLocalSymbolForExportDefault(Ao.symbol) || Ao.symbol;
                            Qe(xc, { kind: Ms ? 32 : 4, moduleSpecifier: Ms, symbolName: Xn, exportMapKey: fo, exportName: Ao.exportKind === 2 ? "export=" : Ao.symbol.name, fileName: Ao.moduleFileName, isDefaultExport: Bs, moduleSymbol: Ao.moduleSymbol, isFromPackageJson: Ao.isFromPackageJson });
                          }
                        }
                      }
                    }), Dn = ga.skippedAny(), Vi |= ga.resolvedAny() ? 8 : 0, Vi |= ga.resolvedBeyondLimit() ? 16 : 0;
                  });
                  function Pt(ga) {
                    var ua = e.tryCast(ga.moduleSymbol.valueDeclaration, e.isSourceFile);
                    if (!ua) {
                      var Xn = e.stripQuotes(ga.moduleSymbol.name);
                      return e.JsTyping.nodeCoreModules.has(Xn) && e.startsWith(Xn, "node:") !== e.shouldUseUriStyleNodeCoreModules(mr, xe) ? false : pt ? pt.allowsImportingAmbientModule(ga.moduleSymbol, kn(ga.isFromPackageJson)) : true;
                    }
                    return e.isImportableFile(ga.isFromPackageJson ? Hr : xe, mr, ua, nr, pt, kn(ga.isFromPackageJson), qi);
                  }
                }
                function Qe(Ji, ce) {
                  var Rr = e.getSymbolId(Ji);
                  pn[Rr] !== C.SortText.GlobalsOrKeywords && (Ba[ka.length] = ce, pn[Rr] = na ? C.SortText.LocationPriority : C.SortText.AutoImportSuggestions, ka.push(Ji));
                }
                function Gr(Ji, ce) {
                  e.isInJSFile(Ai) || Ji.forEach(function(Rr) {
                    if (!!S(Rr)) {
                      var yi = Er(Rr, e.getEmitScriptTarget(Ar), void 0, 0, false);
                      if (!!yi) {
                        var qi = yi.name, je = I(Rr, qi, ce, xe, Pe, Ar, nr, Ue);
                        if (!!je) {
                          var Hr = Ke({ kind: 128 }, je);
                          Vi |= 32, Ba[ka.length] = Hr, ka.push(Rr);
                        }
                      }
                    }
                  });
                }
                function S(Ji) {
                  return !!(Ji.flags & 8196);
                }
                function Ce(Ji, ce, Rr) {
                  for (var yi = Ji; yi && !e.positionBelongsToNode(yi, ce, Rr); ) yi = yi.parent;
                  return yi;
                }
                function qe(Ji) {
                  var ce = e.timestamp(), Rr = Si(Ji) || Go(Ji) || Vc(Ji) || br(Ji) || e.isBigIntLiteral(Ji);
                  return vr("getCompletionsAtPosition: isCompletionListBlocker: " + (e.timestamp() - ce)), Rr;
                }
                function br(Ji) {
                  if (Ji.kind === 11) return true;
                  if (Ji.kind === 31 && Ji.parent) {
                    if (Ai === Ji.parent && (Ai.kind === 280 || Ai.kind === 279)) return false;
                    if (Ji.parent.kind === 280) return Ai.parent.kind !== 280;
                    if (Ji.parent.kind === 281 || Ji.parent.kind === 279) return !!Ji.parent.parent && Ji.parent.parent.kind === 278;
                  }
                  return false;
                }
                function Zr() {
                  if (ut) {
                    var Ji = ut.parent.kind, ce = wr(ut);
                    switch (ce) {
                      case 27:
                        return Ji === 208 || Ji === 171 || Ji === 209 || Ji === 204 || Ji === 221 || Ji === 179 || Ji === 205;
                      case 20:
                        return Ji === 208 || Ji === 171 || Ji === 209 || Ji === 212 || Ji === 191;
                      case 22:
                        return Ji === 204 || Ji === 176 || Ji === 162;
                      case 141:
                      case 142:
                      case 100:
                        return true;
                      case 24:
                        return Ji === 261;
                      case 18:
                        return Ji === 257 || Ji === 205;
                      case 63:
                        return Ji === 254 || Ji === 221;
                      case 15:
                        return Ji === 223;
                      case 16:
                        return Ji === 233;
                      case 131:
                        return Ji === 169 || Ji === 297;
                      case 41:
                        return Ji === 169;
                    }
                    if (yr(ce)) return true;
                  }
                  return false;
                }
                function Si(Ji) {
                  return (e.isRegularExpressionLiteral(Ji) || e.isStringTextContainingNode(Ji)) && (e.rangeContainsPositionExclusive(e.createTextRangeFromSpan(e.createTextSpanFromNode(Ji)), Oe) || Oe === Ji.end && (!!Ji.isUnterminated || e.isRegularExpressionLiteral(Ji)));
                }
                function Pi() {
                  var Ji = Di(ut);
                  if (!Ji) return 0;
                  var ce = e.isIntersectionTypeNode(Ji.parent) ? Ji.parent : void 0, Rr = ce || Ji, yi = wi(Rr, De);
                  if (!yi) return 0;
                  var qi = De.getTypeFromTypeNode(Rr), je = qr(yi, De), Hr = qr(qi, De), pt = new e.Set();
                  return Hr.forEach(function(Pt) {
                    return pt.add(Pt.escapedName);
                  }), ka = e.concatenate(ka, e.filter(je, function(Pt) {
                    return !pt.has(Pt.escapedName);
                  })), Qa = 0, ji = true, 1;
                }
                function Qi() {
                  var Ji = ka.length, ce = Cr(ut);
                  if (!ce) return 0;
                  Qa = 0;
                  var Rr, yi;
                  if (ce.kind === 205) {
                    var qi = _r(ce, De);
                    if (qi === void 0) return ce.flags & 33554432 ? 2 : (ai = true, 0);
                    var je = De.getContextualType(ce, 4), Hr = (je || qi).getStringIndexType(), pt = (je || qi).getNumberIndexType();
                    if (ji = !!Hr || !!pt, Rr = mi(qi, je, ce, De), yi = ce.properties, Rr.length === 0 && !pt) return ai = true, 0;
                  } else {
                    e.Debug.assert(ce.kind === 201), ji = false;
                    var Pt = e.getRootDeclaration(ce.parent);
                    if (!e.isVariableLike(Pt)) return e.Debug.fail("Root declaration is not variable-like.");
                    var ga = e.hasInitializer(Pt) || !!e.getEffectiveTypeAnnotationNode(Pt) || Pt.parent.parent.kind === 244;
                    if (!ga && Pt.kind === 164 && (e.isExpression(Pt.parent) ? ga = !!De.getContextualType(Pt.parent) : (Pt.parent.kind === 169 || Pt.parent.kind === 173) && (ga = e.isExpression(Pt.parent.parent) && !!De.getContextualType(Pt.parent.parent))), ga) {
                      var ua = De.getTypeAtLocation(ce);
                      if (!ua) return 2;
                      Rr = De.getPropertiesOfType(ua).filter(function(jr) {
                        return De.isPropertyAccessible(ce, false, false, ua, jr);
                      }), yi = ce.elements;
                    }
                  }
                  if (Rr && Rr.length > 0) {
                    var Xn = Xs(Rr, e.Debug.checkDefined(yi));
                    ka = e.concatenate(ka, Xn), hs(), ce.kind === 205 && nr.includeCompletionsWithObjectLiteralMethodSnippets && nr.includeCompletionsWithInsertText && (ps(Ji), Gr(Xn, ce));
                  }
                  return 1;
                }
                function Ct() {
                  if (!ut) return 0;
                  var Ji = ut.kind === 18 || ut.kind === 27 ? e.tryCast(ut.parent, e.isNamedImportsOrExports) : e.isTypeKeywordTokenOrIdentifier(ut) ? e.tryCast(ut.parent.parent, e.isNamedImportsOrExports) : void 0;
                  if (!Ji) return 0;
                  e.isTypeKeywordTokenOrIdentifier(ut) || (Oi = 8);
                  var ce = (Ji.kind === 269 ? Ji.parent.parent : Ji.parent).moduleSpecifier;
                  if (!ce) return ji = true, Ji.kind === 269 ? 2 : 0;
                  var Rr = De.getSymbolAtLocation(ce);
                  if (!Rr) return ji = true, 2;
                  Qa = 3, ji = false;
                  var yi = De.getExportsAndPropertiesOfModule(Rr), qi = new e.Set(Ji.elements.filter(function(Hr) {
                    return !ds(Hr);
                  }).map(function(Hr) {
                    return (Hr.propertyName || Hr.name).escapedText;
                  })), je = yi.filter(function(Hr) {
                    return Hr.escapedName !== "default" && !qi.has(Hr.escapedName);
                  });
                  return ka = e.concatenate(ka, je), je.length || (Oi = 0), 1;
                }
                function sa() {
                  var Ji, ce = ut && (ut.kind === 18 || ut.kind === 27) ? e.tryCast(ut.parent, e.isNamedExports) : void 0;
                  if (!ce) return 0;
                  var Rr = e.findAncestor(ce, e.or(e.isSourceFile, e.isModuleDeclaration));
                  return Qa = 5, ji = false, (Ji = Rr.locals) === null || Ji === void 0 || Ji.forEach(function(yi, qi) {
                    var je, Hr;
                    ka.push(yi), !((Hr = (je = Rr.symbol) === null || je === void 0 ? void 0 : je.exports) === null || Hr === void 0) && Hr.has(qi) && (pn[e.getSymbolId(yi)] = C.SortText.OptionalMember);
                  }), 1;
                }
                function en() {
                  var Ji = si(mr, ut, Ai, Oe);
                  if (!Ji) return 0;
                  if (Qa = 3, ji = true, Oi = ut.kind === 41 ? 0 : e.isClassLike(Ji) ? 2 : 3, !e.isClassLike(Ji)) return 1;
                  var ce = ut.kind === 26 ? ut.parent.parent : ut.parent, Rr = e.isClassElement(ce) ? e.getEffectiveModifierFlags(ce) : 0;
                  if (ut.kind === 79 && !ds(ut)) switch (ut.getText()) {
                    case "private":
                      Rr = Rr | 8;
                      break;
                    case "static":
                      Rr = Rr | 32;
                      break;
                    case "override":
                      Rr = Rr | 16384;
                      break;
                  }
                  if (e.isClassStaticBlockDeclaration(ce) && (Rr |= 32), !(Rr & 8)) {
                    var yi = e.isClassLike(Ji) && Rr & 16384 ? e.singleElementArray(e.getEffectiveBaseTypeNode(Ji)) : e.getAllSuperTypeNodes(Ji), qi = e.flatMap(yi, function(je) {
                      var Hr = De.getTypeAtLocation(je);
                      return Rr & 32 ? (Hr == null ? void 0 : Hr.symbol) && De.getPropertiesOfType(De.getTypeOfSymbolAtLocation(Hr.symbol, Ji)) : Hr && De.getPropertiesOfType(Hr);
                    });
                    ka = e.concatenate(ka, Qs(qi, Ji.members, Rr));
                  }
                  return 1;
                }
                function Wa(Ji) {
                  return !!Ji.parent && e.isParameter(Ji.parent) && e.isConstructorDeclaration(Ji.parent.parent) && (e.isParameterPropertyModifier(Ji.kind) || e.isDeclarationName(Ji));
                }
                function qn(Ji) {
                  if (Ji) {
                    var ce = Ji.parent;
                    switch (Ji.kind) {
                      case 20:
                      case 27:
                        return e.isConstructorDeclaration(Ji.parent) ? Ji.parent : void 0;
                      default:
                        if (Wa(Ji)) return ce.parent;
                    }
                  }
                }
                function mo(Ji) {
                  if (Ji) {
                    var ce, Rr = e.findAncestor(Ji.parent, function(yi) {
                      return e.isClassLike(yi) ? "quit" : e.isFunctionLikeDeclaration(yi) && ce === yi.body ? true : (ce = yi, false);
                    });
                    return Rr && Rr;
                  }
                }
                function So(Ji) {
                  if (Ji) {
                    var ce = Ji.parent;
                    switch (Ji.kind) {
                      case 31:
                      case 30:
                      case 43:
                      case 79:
                      case 206:
                      case 286:
                      case 285:
                      case 287:
                        if (ce && (ce.kind === 279 || ce.kind === 280)) {
                          if (Ji.kind === 31) {
                            var Rr = e.findPrecedingToken(Ji.pos, mr, void 0);
                            if (!ce.typeArguments || Rr && Rr.kind === 43) break;
                          }
                          return ce;
                        } else if (ce.kind === 285) return ce.parent.parent;
                        break;
                      case 10:
                        if (ce && (ce.kind === 285 || ce.kind === 287)) return ce.parent.parent;
                        break;
                      case 19:
                        if (ce && ce.kind === 288 && ce.parent && ce.parent.kind === 285) return ce.parent.parent.parent;
                        if (ce && ce.kind === 287) return ce.parent.parent;
                        break;
                    }
                  }
                }
                function Go(Ji) {
                  var ce = Ji.parent, Rr = ce.kind;
                  switch (Ji.kind) {
                    case 27:
                      return Rr === 254 || Kc(Ji) || Rr === 237 || Rr === 260 || Pc(Rr) || Rr === 258 || Rr === 202 || Rr === 259 || e.isClassLike(ce) && !!ce.typeParameters && ce.typeParameters.end >= Ji.pos;
                    case 24:
                      return Rr === 202;
                    case 58:
                      return Rr === 203;
                    case 22:
                      return Rr === 202;
                    case 20:
                      return Rr === 292 || Pc(Rr);
                    case 18:
                      return Rr === 260;
                    case 29:
                      return Rr === 257 || Rr === 226 || Rr === 258 || Rr === 259 || e.isFunctionLikeKind(Rr);
                    case 124:
                      return Rr === 167 && !e.isClassLike(ce.parent);
                    case 25:
                      return Rr === 164 || !!ce.parent && ce.parent.kind === 202;
                    case 123:
                    case 121:
                    case 122:
                      return Rr === 164 && !e.isConstructorDeclaration(ce.parent);
                    case 127:
                      return Rr === 270 || Rr === 275 || Rr === 268;
                    case 136:
                    case 149:
                      return !Xi(Ji);
                    case 79:
                      if (Rr === 270 && Ji === ce.name && Ji.text === "type") return false;
                      break;
                    case 84:
                    case 92:
                    case 118:
                    case 98:
                    case 113:
                    case 100:
                    case 119:
                    case 85:
                    case 137:
                      return true;
                    case 152:
                      return Rr !== 270;
                    case 41:
                      return e.isFunctionLike(Ji.parent) && !e.isMethodDeclaration(Ji.parent);
                  }
                  if (yr(wr(Ji)) && Xi(Ji) || Wa(Ji) && (!e.isIdentifier(Ji) || e.isParameterPropertyModifier(wr(Ji)) || ds(Ji))) return false;
                  switch (wr(Ji)) {
                    case 126:
                    case 84:
                    case 85:
                    case 135:
                    case 92:
                    case 98:
                    case 118:
                    case 119:
                    case 121:
                    case 122:
                    case 123:
                    case 124:
                    case 113:
                      return true;
                    case 131:
                      return e.isPropertyDeclaration(Ji.parent);
                  }
                  var yi = e.findAncestor(Ji.parent, e.isClassLike);
                  if (yi && Ji === xt && ys(Ji, Oe)) return false;
                  var qi = e.getAncestor(Ji.parent, 167);
                  if (qi && Ji !== xt && e.isClassLike(xt.parent.parent) && Oe <= xt.end) {
                    if (ys(Ji, xt.end)) return false;
                    if (Ji.kind !== 63 && (e.isInitializedProperty(qi) || e.hasType(qi))) return true;
                  }
                  return e.isDeclarationName(Ji) && !e.isShorthandPropertyAssignment(Ji.parent) && !e.isJsxAttribute(Ji.parent) && !(e.isClassLike(Ji.parent) && (Ji !== xt || Oe > xt.end));
                }
                function ys(Ji, ce) {
                  return Ji.kind !== 63 && (Ji.kind === 26 || !e.positionsAreOnSameLine(Ji.end, ce, mr));
                }
                function Pc(Ji) {
                  return e.isFunctionLikeKind(Ji) && Ji !== 171;
                }
                function Vc(Ji) {
                  if (Ji.kind === 8) {
                    var ce = Ji.getFullText();
                    return ce.charAt(ce.length - 1) === ".";
                  }
                  return false;
                }
                function Kc(Ji) {
                  return Ji.parent.kind === 255 && !e.isPossiblyTypeArgumentPosition(Ji, mr, De);
                }
                function Xs(Ji, ce) {
                  if (ce.length === 0) return Ji;
                  for (var Rr = new e.Set(), yi = new e.Set(), qi = 0, je = ce; qi < je.length; qi++) {
                    var Hr = je[qi];
                    if (!(Hr.kind !== 296 && Hr.kind !== 297 && Hr.kind !== 203 && Hr.kind !== 169 && Hr.kind !== 172 && Hr.kind !== 173 && Hr.kind !== 298) && !ds(Hr)) {
                      var pt = void 0;
                      if (e.isSpreadAssignment(Hr)) pc(Hr, Rr);
                      else if (e.isBindingElement(Hr) && Hr.propertyName) Hr.propertyName.kind === 79 && (pt = Hr.propertyName.escapedText);
                      else {
                        var Pt = e.getNameOfDeclaration(Hr);
                        pt = Pt && e.isPropertyNameLiteral(Pt) ? e.getEscapedTextOfIdentifierOrLiteral(Pt) : void 0;
                      }
                      pt !== void 0 && yi.add(pt);
                    }
                  }
                  var ga = Ji.filter(function(ua) {
                    return !yi.has(ua.escapedName);
                  });
                  return tc(Rr, ga), ga;
                }
                function pc(Ji, ce) {
                  var Rr = Ji.expression, yi = De.getSymbolAtLocation(Rr), qi = yi && De.getTypeOfSymbolAtLocation(yi, Rr), je = qi && qi.properties;
                  je && je.forEach(function(Hr) {
                    ce.add(Hr.name);
                  });
                }
                function hs() {
                  ka.forEach(function(Ji) {
                    var ce;
                    if (Ji.flags & 16777216) {
                      var Rr = e.getSymbolId(Ji);
                      pn[Rr] = (ce = pn[Rr]) !== null && ce !== void 0 ? ce : C.SortText.OptionalMember;
                    }
                  });
                }
                function tc(Ji, ce) {
                  if (Ji.size !== 0) for (var Rr = 0, yi = ce; Rr < yi.length; Rr++) {
                    var qi = yi[Rr];
                    Ji.has(qi.name) && (pn[e.getSymbolId(qi)] = C.SortText.MemberDeclaredBySpreadAssignment);
                  }
                }
                function ps(Ji) {
                  for (var ce, Rr = Ji; Rr < ka.length; Rr++) {
                    var yi = ka[Rr], qi = e.getSymbolId(yi), je = Ba == null ? void 0 : Ba[Rr], Hr = e.getEmitScriptTarget(Ar), pt = Er(yi, Hr, je, 0, false);
                    if (pt) {
                      var Pt = (ce = pn[qi]) !== null && ce !== void 0 ? ce : C.SortText.LocationPriority, ga = pt.name;
                      pn[qi] = C.SortText.ObjectLiteralProperty(Pt, ga);
                    }
                  }
                }
                function Qs(Ji, ce, Rr) {
                  for (var yi = new e.Set(), qi = 0, je = ce; qi < je.length; qi++) {
                    var Hr = je[qi];
                    if (!(Hr.kind !== 167 && Hr.kind !== 169 && Hr.kind !== 172 && Hr.kind !== 173) && !ds(Hr) && !e.hasEffectiveModifier(Hr, 8) && e.isStatic(Hr) === !!(Rr & 32)) {
                      var pt = e.getPropertyNameForPropertyNameNode(Hr.name);
                      pt && yi.add(pt);
                    }
                  }
                  return Ji.filter(function(Pt) {
                    return !yi.has(Pt.escapedName) && !!Pt.declarations && !(e.getDeclarationModifierFlagsFromSymbol(Pt) & 8) && !(Pt.valueDeclaration && e.isPrivateIdentifierClassElementDeclaration(Pt.valueDeclaration));
                  });
                }
                function js(Ji, ce) {
                  for (var Rr = new e.Set(), yi = new e.Set(), qi = 0, je = ce; qi < je.length; qi++) {
                    var Hr = je[qi];
                    ds(Hr) || (Hr.kind === 285 ? Rr.add(Hr.name.escapedText) : e.isJsxSpreadAttribute(Hr) && pc(Hr, yi));
                  }
                  var pt = Ji.filter(function(Pt) {
                    return !Rr.has(Pt.escapedName);
                  });
                  return tc(yi, pt), pt;
                }
                function ds(Ji) {
                  return Ji.getStart(mr) <= Oe && Oe <= Ji.getEnd();
                }
              }
              function Cr(xe) {
                if (xe) {
                  var vr = xe.parent;
                  switch (xe.kind) {
                    case 18:
                    case 27:
                      if (e.isObjectLiteralExpression(vr) || e.isObjectBindingPattern(vr)) return vr;
                      break;
                    case 41:
                      return e.isMethodDeclaration(vr) ? e.tryCast(vr.parent, e.isObjectLiteralExpression) : void 0;
                    case 79:
                      return xe.text === "async" && e.isShorthandPropertyAssignment(xe.parent) ? xe.parent.parent : void 0;
                  }
                }
              }
              function Ye(xe, vr) {
                var mr = e.findPrecedingToken(xe, vr);
                if (mr && xe <= mr.end && (e.isMemberName(mr) || e.isKeyword(mr.kind))) {
                  var Ar = e.findPrecedingToken(mr.getFullStart(), vr, void 0);
                  return { contextToken: Ar, previousToken: mr };
                }
                return { contextToken: mr, previousToken: mr };
              }
              function Br(xe, vr, mr, Ar) {
                var Oe = vr.isPackageJsonImport ? Ar.getPackageJsonAutoImportProvider() : mr, nr = Oe.getTypeChecker(), Mr = vr.ambientModuleName ? nr.tryFindAmbientModule(vr.ambientModuleName) : vr.fileName ? nr.getMergedSymbol(e.Debug.checkDefined(Oe.getSourceFile(vr.fileName)).symbol) : void 0;
                if (!!Mr) {
                  var Pe = vr.exportName === "export=" ? nr.resolveExternalModuleSymbol(Mr) : nr.tryGetMemberInModuleExportsAndProperties(vr.exportName, Mr);
                  if (!!Pe) {
                    var Ue = vr.exportName === "default";
                    return Pe = Ue && e.getLocalSymbolForExportDefault(Pe) || Pe, { symbol: Pe, origin: fe(vr, xe, Mr) };
                  }
                }
              }
              function Er(xe, vr, mr, Ar, Oe) {
                var nr = p(mr) ? mr.symbolName : xe.name;
                if (!(nr === void 0 || xe.flags & 1536 && e.isSingleOrDoubleQuote(nr.charCodeAt(0)) || e.isKnownSymbol(xe))) {
                  var Mr = { name: nr, needsConvertPropertyAccess: false };
                  if (e.isIdentifierText(nr, vr, Oe ? 1 : 0) || xe.valueDeclaration && e.isPrivateIdentifierClassElementDeclaration(xe.valueDeclaration)) return Mr;
                  switch (Ar) {
                    case 3:
                      return;
                    case 0:
                      return { name: JSON.stringify(nr), needsConvertPropertyAccess: false };
                    case 2:
                    case 1:
                      return nr.charCodeAt(0) === 32 ? void 0 : { name: nr, needsConvertPropertyAccess: true };
                    case 5:
                    case 4:
                      return Mr;
                    default:
                      e.Debug.assertNever(Ar);
                  }
                }
              }
              var Ne = [], n = e.memoize(function() {
                for (var xe = [], vr = 81; vr <= 160; vr++) xe.push({ name: e.tokenToString(vr), kind: "keyword", kindModifiers: "", sortText: C.SortText.GlobalsOrKeywords });
                return xe;
              });
              function lr(xe, vr) {
                if (!vr) return be(xe);
                var mr = xe + 8 + 1;
                return Ne[mr] || (Ne[mr] = be(xe).filter(function(Ar) {
                  return !Ge(e.stringToToken(Ar.name));
                }));
              }
              function be(xe) {
                return Ne[xe] || (Ne[xe] = n().filter(function(vr) {
                  var mr = e.stringToToken(vr.name);
                  switch (xe) {
                    case 0:
                      return false;
                    case 1:
                      return Ir(mr) || mr === 135 || mr === 141 || mr === 152 || mr === 142 || mr === 126 || e.isTypeKeyword(mr) && mr !== 153;
                    case 5:
                      return Ir(mr);
                    case 2:
                      return yr(mr);
                    case 3:
                      return ur(mr);
                    case 4:
                      return e.isParameterPropertyModifier(mr);
                    case 6:
                      return e.isTypeKeyword(mr) || mr === 85;
                    case 7:
                      return e.isTypeKeyword(mr);
                    case 8:
                      return mr === 152;
                    default:
                      return e.Debug.assertNever(xe);
                  }
                }));
              }
              function Ge(xe) {
                switch (xe) {
                  case 126:
                  case 130:
                  case 158:
                  case 133:
                  case 135:
                  case 92:
                  case 157:
                  case 117:
                  case 137:
                  case 118:
                  case 139:
                  case 140:
                  case 141:
                  case 142:
                  case 143:
                  case 147:
                  case 148:
                  case 159:
                  case 121:
                  case 122:
                  case 123:
                  case 145:
                  case 150:
                  case 151:
                  case 152:
                  case 154:
                  case 155:
                    return true;
                  default:
                    return false;
                }
              }
              function ur(xe) {
                return xe === 145;
              }
              function yr(xe) {
                switch (xe) {
                  case 126:
                  case 134:
                  case 136:
                  case 149:
                  case 131:
                  case 135:
                  case 159:
                    return true;
                  default:
                    return e.isClassMemberModifier(xe);
                }
              }
              function Ir(xe) {
                return xe === 131 || xe === 132 || xe === 127 || !e.isContextualKeyword(xe) && !yr(xe);
              }
              function wr(xe) {
                return e.isIdentifier(xe) ? xe.originalKeywordKind || 0 : xe.kind;
              }
              function Ur(xe, vr) {
                var mr = [];
                if (xe) {
                  var Ar = xe.getSourceFile(), Oe = xe.parent, nr = Ar.getLineAndCharacterOfPosition(xe.end).line, Mr = Ar.getLineAndCharacterOfPosition(vr).line;
                  (e.isImportDeclaration(Oe) || e.isExportDeclaration(Oe) && Oe.moduleSpecifier) && xe === Oe.moduleSpecifier && nr === Mr && mr.push({ name: e.tokenToString(129), kind: "keyword", kindModifiers: "", sortText: C.SortText.GlobalsOrKeywords });
                }
                return mr;
              }
              function ii(xe, vr) {
                return e.findAncestor(xe, function(mr) {
                  return e.isJSDocTag(mr) && e.rangeContainsPosition(mr, vr) ? true : e.isJSDoc(mr) ? "quit" : false;
                });
              }
              function mi(xe, vr, mr, Ar) {
                var Oe = vr && vr !== xe, nr = Oe && !(vr.flags & 3) ? Ar.getUnionType([xe, vr]) : xe, Mr = pe(nr, mr, Ar);
                return nr.isClass() && or(Mr) ? [] : Oe ? e.filter(Mr, Pe) : Mr;
                function Pe(Ue) {
                  return e.length(Ue.declarations) ? e.some(Ue.declarations, function(fr) {
                    return fr.parent !== mr;
                  }) : true;
                }
              }
              C.getPropertiesForObjectExpression = mi;
              function pe(xe, vr, mr) {
                return xe.isUnion() ? mr.getAllPossiblePropertiesOfTypes(e.filter(xe.types, function(Ar) {
                  return !(Ar.flags & 131068 || mr.isArrayLikeType(Ar) || mr.isTypeInvalidDueToUnionDiscriminant(Ar, vr) || e.typeHasCallOrConstructSignatures(Ar, mr) || Ar.isClass() && or(Ar.getApparentProperties()));
                })) : xe.getApparentProperties();
              }
              function or(xe) {
                return e.some(xe, function(vr) {
                  return !!(e.getDeclarationModifierFlagsFromSymbol(vr) & 24);
                });
              }
              function qr(xe, vr) {
                return xe.isUnion() ? e.Debug.checkEachDefined(vr.getAllPossiblePropertiesOfTypes(xe.types), "getAllPossiblePropertiesOfTypes() should all be defined") : e.Debug.checkEachDefined(xe.getApparentProperties(), "getApparentProperties() should all be defined");
              }
              function si(xe, vr, mr, Ar) {
                switch (mr.kind) {
                  case 348:
                    return e.tryCast(mr.parent, e.isObjectTypeDeclaration);
                  case 1:
                    var Oe = e.tryCast(e.lastOrUndefined(e.cast(mr.parent, e.isSourceFile).statements), e.isObjectTypeDeclaration);
                    if (Oe && !e.findChildOfKind(Oe, 19, xe)) return Oe;
                    break;
                  case 79: {
                    if (e.isPropertyDeclaration(mr.parent) && mr.parent.initializer === mr) return;
                    if (Xi(mr)) return e.findAncestor(mr, e.isObjectTypeDeclaration);
                  }
                }
                if (!!vr) {
                  if (mr.kind === 134 || e.isIdentifier(vr) && e.isPropertyDeclaration(vr.parent) && e.isClassLike(mr)) return e.findAncestor(vr, e.isClassLike);
                  switch (vr.kind) {
                    case 63:
                      return;
                    case 26:
                    case 19:
                      return Xi(mr) && mr.parent.name === mr ? mr.parent.parent : e.tryCast(mr, e.isObjectTypeDeclaration);
                    case 18:
                    case 27:
                      return e.tryCast(vr.parent, e.isObjectTypeDeclaration);
                    default:
                      if (!Xi(vr)) return e.getLineAndCharacterOfPosition(xe, vr.getEnd()).line !== e.getLineAndCharacterOfPosition(xe, Ar).line && e.isObjectTypeDeclaration(mr) ? mr : void 0;
                      var nr = e.isClassLike(vr.parent.parent) ? yr : ur;
                      return nr(vr.kind) || vr.kind === 41 || e.isIdentifier(vr) && nr(e.stringToToken(vr.text)) ? vr.parent.parent : void 0;
                  }
                }
              }
              function Di(xe) {
                if (!!xe) {
                  var vr = xe.parent;
                  switch (xe.kind) {
                    case 18:
                      if (e.isTypeLiteralNode(vr)) return vr;
                      break;
                    case 26:
                    case 27:
                    case 79:
                      if (vr.kind === 166 && e.isTypeLiteralNode(vr.parent)) return vr.parent;
                      break;
                  }
                }
              }
              function wi(xe, vr) {
                if (!!xe) {
                  if (e.isTypeNode(xe) && e.isTypeReferenceType(xe.parent)) return vr.getTypeArgumentConstraint(xe);
                  var mr = wi(xe.parent, vr);
                  if (!!mr) switch (xe.kind) {
                    case 166:
                      return vr.getTypeOfPropertyOfContextualType(mr, xe.symbol.escapedName);
                    case 188:
                    case 182:
                    case 187:
                      return mr;
                  }
                }
              }
              function Xi(xe) {
                return xe.parent && e.isClassOrTypeElement(xe.parent) && e.isObjectTypeDeclaration(xe.parent.parent);
              }
              function et(xe, vr, mr, Ar) {
                switch (vr) {
                  case ".":
                  case "@":
                    return true;
                  case '"':
                  case "'":
                  case "`":
                    return !!mr && e.isStringLiteralOrTemplate(mr) && Ar === mr.getStart(xe) + 1;
                  case "#":
                    return !!mr && e.isPrivateIdentifier(mr) && !!e.getContainingClass(mr);
                  case "<":
                    return !!mr && mr.kind === 29 && (!e.isBinaryExpression(mr.parent) || Gi(mr.parent));
                  case "/":
                    return !!mr && (e.isStringLiteralLike(mr) ? !!e.tryGetImportFromModuleSpecifier(mr) : mr.kind === 43 && e.isJsxClosingElement(mr.parent));
                  case " ":
                    return !!mr && e.isImportKeyword(mr) && mr.parent.kind === 305;
                  default:
                    return e.Debug.assertNever(vr);
                }
              }
              function Gi(xe) {
                var vr = xe.left;
                return e.nodeIsMissing(vr);
              }
              function Wt(xe, vr, mr) {
                var Ar = mr.resolveName("self", void 0, 111551, false);
                if (Ar && mr.getTypeOfSymbolAtLocation(Ar, vr) === xe) return true;
                var Oe = mr.resolveName("global", void 0, 111551, false);
                if (Oe && mr.getTypeOfSymbolAtLocation(Oe, vr) === xe) return true;
                var nr = mr.resolveName("globalThis", void 0, 111551, false);
                return !!(nr && mr.getTypeOfSymbolAtLocation(nr, vr) === xe);
              }
              function Zt(xe) {
                return !!(xe.valueDeclaration && e.getEffectiveModifierFlags(xe.valueDeclaration) & 32 && e.isClassLike(xe.valueDeclaration.parent));
              }
              function _r(xe, vr) {
                var mr = vr.getContextualType(xe);
                if (mr) return mr;
                var Ar = e.walkUpParenthesizedExpressions(xe.parent);
                if (e.isBinaryExpression(Ar) && Ar.operatorToken.kind === 63 && xe === Ar.left) return vr.getTypeAtLocation(Ar);
                if (e.isExpression(Ar)) return vr.getContextualType(Ar);
              }
              function pi(xe) {
                var vr, mr = false, Ar = Oe();
                return { isKeywordOnlyCompletion: mr, keywordCompletion: vr, isNewIdentifierLocation: !!(Ar || vr === 152), replacementNode: Ar && e.rangeIsOnSingleLine(Ar, Ar.getSourceFile()) ? Ar : void 0 };
                function Oe() {
                  var nr = xe.parent;
                  if (e.isImportEqualsDeclaration(nr)) return vr = xe.kind === 152 ? void 0 : 152, Jr(nr.moduleReference) ? nr : void 0;
                  if (ae(nr, xe) && Xe(nr.parent)) return nr;
                  if (e.isNamedImports(nr) || e.isNamespaceImport(nr)) {
                    if (!nr.parent.isTypeOnly && (xe.kind === 18 || xe.kind === 100 || xe.kind === 27) && (vr = 152), Xe(nr)) if (xe.kind === 19 || xe.kind === 79) mr = true, vr = 156;
                    else return nr.parent.parent;
                    return;
                  }
                  if (e.isImportKeyword(xe) && e.isSourceFile(nr)) return vr = 152, xe;
                  if (e.isImportKeyword(xe) && e.isImportDeclaration(nr)) return vr = 152, Jr(nr.moduleSpecifier) ? nr : void 0;
                }
              }
              function ae(xe, vr) {
                return e.isImportSpecifier(xe) && (xe.isTypeOnly || vr === xe.name && e.isTypeKeywordTokenOrIdentifier(vr));
              }
              function Xe(xe) {
                return Jr(xe.parent.parent.moduleSpecifier) && (e.isNamespaceImport(xe) || xe.elements.length < 2) && !xe.parent.name;
              }
              function Jr(xe) {
                var vr;
                return e.nodeIsMissing(xe) ? true : !(!((vr = e.tryCast(e.isExternalModuleReference(xe) ? xe.expression : xe, e.isStringLiteralLike)) === null || vr === void 0) && vr.text);
              }
              function ti(xe) {
                var vr = e.findAncestor(xe, function(mr) {
                  return e.isFunctionBlock(mr) || Ze(mr) || e.isBindingPattern(mr) ? "quit" : e.isVariableDeclaration(mr);
                });
                return vr;
              }
              function Ze(xe) {
                return xe.parent && e.isArrowFunction(xe.parent) && xe.parent.body === xe;
              }
              function Sr(xe, vr, mr) {
                return mr === void 0 && (mr = new e.Map()), Ar(xe) || Ar(e.skipAlias(xe.exportSymbol || xe, vr));
                function Ar(Oe) {
                  return !!(Oe.flags & 788968) || vr.isUnknownSymbol(Oe) || !!(Oe.flags & 1536) && e.addToSeen(mr, e.getSymbolId(Oe)) && vr.getExportsOfModule(Oe).some(function(nr) {
                    return Sr(nr, vr, mr);
                  });
                }
              }
              function zr(xe, vr) {
                var mr = e.skipAlias(xe, vr).declarations;
                return !!e.length(mr) && e.every(mr, e.isDeprecatedDeclaration);
              }
              function Wr(xe, vr) {
                if (vr.length === 0) return true;
                for (var mr = false, Ar, Oe = 0, nr = xe.length, Mr = 0; Mr < nr; Mr++) {
                  var Pe = xe.charCodeAt(Mr), Ue = vr.charCodeAt(Oe);
                  if ((Pe === Ue || Pe === Je(Ue)) && (mr || (mr = Ar === void 0 || 97 <= Ar && Ar <= 122 && 65 <= Pe && Pe <= 90 || Ar === 95 && Pe !== 95), mr && Oe++, Oe === vr.length)) return true;
                  Ar = Pe;
                }
                return false;
              }
              function Je(xe) {
                return 97 <= xe && xe <= 122 ? xe - 32 : xe;
              }
            })(a = e.Completions || (e.Completions = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w($, A, y, V, L) {
                var P = e.getTouchingPropertyName(y, V);
                if (P.parent && (e.isJsxOpeningElement(P.parent) && P.parent.tagName === P || e.isJsxClosingElement(P.parent))) {
                  var k = P.parent.parent, Y = k.openingElement, U = k.closingElement, j = [Y, U].map(function(H) {
                    var I = H.tagName;
                    return B(I, y);
                  });
                  return [{ fileName: y.fileName, highlightSpans: j }];
                }
                return E(V, P, $, A, L) || Q(P, y);
              }
              C.getDocumentHighlights = w;
              function B($, A) {
                return { fileName: A.fileName, textSpan: e.createTextSpanFromNode($, A), kind: "none" };
              }
              function E($, A, y, V, L) {
                var P = new e.Set(L.map(function(j) {
                  return j.fileName;
                })), k = e.FindAllReferences.getReferenceEntriesForNode($, A, y, L, V, void 0, P);
                if (!!k) {
                  var Y = e.arrayToMultiMap(k.map(e.FindAllReferences.toHighlightSpan), function(j) {
                    return j.fileName;
                  }, function(j) {
                    return j.span;
                  }), U = e.createGetCanonicalFileName(y.useCaseSensitiveFileNames());
                  return e.mapDefined(e.arrayFrom(Y.entries()), function(j) {
                    var H = j[0], I = j[1];
                    if (!P.has(H)) {
                      if (!y.redirectTargetsMap.has(e.toPath(H, y.getCurrentDirectory(), U))) return;
                      var l = y.getSourceFile(H), d = e.find(L, function(D) {
                        return !!D.redirectInfo && D.redirectInfo.redirectTarget === l;
                      });
                      H = d.fileName, e.Debug.assert(P.has(H));
                    }
                    return { fileName: H, highlightSpans: I };
                  });
                }
              }
              function Q($, A) {
                var y = le($, A);
                return y && [{ fileName: A.fileName, highlightSpans: y }];
              }
              function le($, A) {
                switch ($.kind) {
                  case 99:
                  case 91:
                    return e.isIfStatement($.parent) ? F($.parent, A) : void 0;
                  case 105:
                    return L($.parent, e.isReturnStatement, O);
                  case 109:
                    return L($.parent, e.isThrowStatement, q);
                  case 111:
                  case 83:
                  case 96:
                    var y = $.kind === 83 ? $.parent.parent : $.parent;
                    return L(y, e.isTryStatement, R);
                  case 107:
                    return L($.parent, e.isSwitchStatement, ie);
                  case 82:
                  case 88:
                    return e.isDefaultClause($.parent) || e.isCaseClause($.parent) ? L($.parent.parent.parent, e.isSwitchStatement, ie) : void 0;
                  case 81:
                  case 86:
                    return L($.parent, e.isBreakOrContinueStatement, J);
                  case 97:
                  case 115:
                  case 90:
                    return L($.parent, function(k) {
                      return e.isIterationStatement(k, true);
                    }, se);
                  case 134:
                    return V(e.isConstructorDeclaration, [134]);
                  case 136:
                  case 149:
                    return V(e.isAccessor, [136, 149]);
                  case 132:
                    return L($.parent, e.isAwaitExpression, ve);
                  case 131:
                    return P(ve($));
                  case 125:
                    return P(ee($));
                  case 101:
                    return;
                  default:
                    return e.isModifierKind($.kind) && (e.isDeclaration($.parent) || e.isVariableStatement($.parent)) ? P(T($.kind, $.parent)) : void 0;
                }
                function V(k, Y) {
                  return L($.parent, k, function(U) {
                    return e.mapDefined(U.symbol.declarations, function(j) {
                      return k(j) ? e.find(j.getChildren(A), function(H) {
                        return e.contains(Y, H.kind);
                      }) : void 0;
                    });
                  });
                }
                function L(k, Y, U) {
                  return Y(k) ? P(U(k, A)) : void 0;
                }
                function P(k) {
                  return k && k.map(function(Y) {
                    return B(Y, A);
                  });
                }
              }
              function N($) {
                return e.isThrowStatement($) ? [$] : e.isTryStatement($) ? e.concatenate($.catchClause ? N($.catchClause) : $.tryBlock && N($.tryBlock), $.finallyBlock && N($.finallyBlock)) : e.isFunctionLike($) ? void 0 : G($, N);
              }
              function p($) {
                for (var A = $; A.parent; ) {
                  var y = A.parent;
                  if (e.isFunctionBlock(y) || y.kind === 305) return y;
                  if (e.isTryStatement(y) && y.tryBlock === A && y.catchClause) return A;
                  A = y;
                }
              }
              function m($) {
                return e.isBreakOrContinueStatement($) ? [$] : e.isFunctionLike($) ? void 0 : G($, m);
              }
              function G($, A) {
                var y = [];
                return $.forEachChild(function(V) {
                  var L = A(V);
                  L !== void 0 && y.push.apply(y, e.toArray(L));
                }), y;
              }
              function oe($, A) {
                var y = f(A);
                return !!y && y === $;
              }
              function f($) {
                return e.findAncestor($, function(A) {
                  switch (A.kind) {
                    case 249:
                      if ($.kind === 245) return false;
                    case 242:
                    case 243:
                    case 244:
                    case 241:
                    case 240:
                      return !$.label || X(A, $.label.escapedText);
                    default:
                      return e.isFunctionLike(A) && "quit";
                  }
                });
              }
              function T($, A) {
                return e.mapDefined(K(A, e.modifierToFlag($)), function(y) {
                  return e.findModifier(y, $);
                });
              }
              function K($, A) {
                var y = $.parent;
                switch (y.kind) {
                  case 262:
                  case 305:
                  case 235:
                  case 289:
                  case 290:
                    return A & 128 && e.isClassDeclaration($) ? Ve(Ve([], $.members, true), [$], false) : y.statements;
                  case 171:
                  case 169:
                  case 256:
                    return Ve(Ve([], y.parameters, true), e.isClassLike(y.parent) ? y.parent.members : [], true);
                  case 257:
                  case 226:
                  case 258:
                  case 182:
                    var V = y.members;
                    if (A & 92) {
                      var L = e.find(y.members, e.isConstructorDeclaration);
                      if (L) return Ve(Ve([], V, true), L.parameters, true);
                    } else if (A & 128) return Ve(Ve([], V, true), [y], false);
                    return V;
                  case 205:
                    return;
                  default:
                    e.Debug.assertNever(y, "Invalid container kind.");
                }
              }
              function b($, A) {
                for (var y = [], V = 2; V < arguments.length; V++) y[V - 2] = arguments[V];
                return A && e.contains(y, A.kind) ? ($.push(A), true) : false;
              }
              function se($) {
                var A = [];
                if (b(A, $.getFirstToken(), 97, 115, 90) && $.kind === 240) for (var y = $.getChildren(), V = y.length - 1; V >= 0 && !b(A, y[V], 115); V--) ;
                return e.forEach(m($.statement), function(L) {
                  oe($, L) && b(A, L.getFirstToken(), 81, 86);
                }), A;
              }
              function J($) {
                var A = f($);
                if (A) switch (A.kind) {
                  case 242:
                  case 243:
                  case 244:
                  case 240:
                  case 241:
                    return se(A);
                  case 249:
                    return ie(A);
                }
              }
              function ie($) {
                var A = [];
                return b(A, $.getFirstToken(), 107), e.forEach($.caseBlock.clauses, function(y) {
                  b(A, y.getFirstToken(), 82, 88), e.forEach(m(y), function(V) {
                    oe($, V) && b(A, V.getFirstToken(), 81);
                  });
                }), A;
              }
              function R($, A) {
                var y = [];
                if (b(y, $.getFirstToken(), 111), $.catchClause && b(y, $.catchClause.getFirstToken(), 83), $.finallyBlock) {
                  var V = e.findChildOfKind($, 96, A);
                  b(y, V, 96);
                }
                return y;
              }
              function q($, A) {
                var y = p($);
                if (!!y) {
                  var V = [];
                  return e.forEach(N(y), function(L) {
                    V.push(e.findChildOfKind(L, 109, A));
                  }), e.isFunctionBlock(y) && e.forEachReturnStatement(y, function(L) {
                    V.push(e.findChildOfKind(L, 105, A));
                  }), V;
                }
              }
              function O($, A) {
                var y = e.getContainingFunction($);
                if (!!y) {
                  var V = [];
                  return e.forEachReturnStatement(e.cast(y.body, e.isBlock), function(L) {
                    V.push(e.findChildOfKind(L, 105, A));
                  }), e.forEach(N(y.body), function(L) {
                    V.push(e.findChildOfKind(L, 109, A));
                  }), V;
                }
              }
              function ve($) {
                var A = e.getContainingFunction($);
                if (!!A) {
                  var y = [];
                  return A.modifiers && A.modifiers.forEach(function(V) {
                    b(y, V, 131);
                  }), e.forEachChild(A, function(V) {
                    he(V, function(L) {
                      e.isAwaitExpression(L) && b(y, L.getFirstToken(), 132);
                    });
                  }), y;
                }
              }
              function ee($) {
                var A = e.getContainingFunction($);
                if (!!A) {
                  var y = [];
                  return e.forEachChild(A, function(V) {
                    he(V, function(L) {
                      e.isYieldExpression(L) && b(y, L.getFirstToken(), 125);
                    });
                  }), y;
                }
              }
              function he($, A) {
                A($), !e.isFunctionLike($) && !e.isClassLike($) && !e.isInterfaceDeclaration($) && !e.isModuleDeclaration($) && !e.isTypeAliasDeclaration($) && !e.isTypeNode($) && e.forEachChild($, function(y) {
                  return he(y, A);
                });
              }
              function F($, A) {
                for (var y = x($, A), V = [], L = 0; L < y.length; L++) {
                  if (y[L].kind === 91 && L < y.length - 1) {
                    for (var P = y[L], k = y[L + 1], Y = true, U = k.getStart(A) - 1; U >= P.end; U--) if (!e.isWhiteSpaceSingleLine(A.text.charCodeAt(U))) {
                      Y = false;
                      break;
                    }
                    if (Y) {
                      V.push({ fileName: A.fileName, textSpan: e.createTextSpanFromBounds(P.getStart(), k.end), kind: "reference" }), L++;
                      continue;
                    }
                  }
                  V.push(B(y[L], A));
                }
                return V;
              }
              function x($, A) {
                for (var y = []; e.isIfStatement($.parent) && $.parent.elseStatement === $; ) $ = $.parent;
                for (; ; ) {
                  var V = $.getChildren(A);
                  b(y, V[0], 99);
                  for (var L = V.length - 1; L >= 0 && !b(y, V[L], 91); L--) ;
                  if (!$.elseStatement || !e.isIfStatement($.elseStatement)) break;
                  $ = $.elseStatement;
                }
                return y;
              }
              function X($, A) {
                return !!e.findAncestor($.parent, function(y) {
                  return e.isLabeledStatement(y) ? y.label.escapedText === A : "quit";
                });
              }
            })(a = e.DocumentHighlights || (e.DocumentHighlights = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(Q) {
              return !!Q.sourceFile;
            }
            function C(Q, le) {
              return w(Q, le);
            }
            e.createDocumentRegistry = C;
            function w(Q, le, N) {
              le === void 0 && (le = "");
              var p = new e.Map(), m = e.createGetCanonicalFileName(!!Q);
              function G() {
                var O = e.arrayFrom(p.keys()).filter(function(ve) {
                  return ve && ve.charAt(0) === "_";
                }).map(function(ve) {
                  var ee = p.get(ve), he = [];
                  return ee.forEach(function(F, x) {
                    a(F) ? he.push({ name: x, scriptKind: F.sourceFile.scriptKind, refCount: F.languageServiceRefCount }) : F.forEach(function(X, $) {
                      return he.push({ name: x, scriptKind: $, refCount: X.languageServiceRefCount });
                    });
                  }), he.sort(function(F, x) {
                    return x.refCount - F.refCount;
                  }), { bucket: ve, sourceFiles: he };
                });
                return JSON.stringify(O, void 0, 2);
              }
              function oe(O) {
                return typeof O.getCompilationSettings == "function" ? O.getCompilationSettings() : O;
              }
              function f(O, ve, ee, he, F) {
                var x = e.toPath(O, le, m), X = E(oe(ve));
                return T(O, x, ve, X, ee, he, F);
              }
              function T(O, ve, ee, he, F, x, X) {
                return J(O, ve, ee, he, F, x, true, X);
              }
              function K(O, ve, ee, he, F) {
                var x = e.toPath(O, le, m), X = E(oe(ve));
                return b(O, x, ve, X, ee, he, F);
              }
              function b(O, ve, ee, he, F, x, X) {
                return J(O, ve, oe(ee), he, F, x, false, X);
              }
              function se(O, ve) {
                var ee = a(O) ? O : O.get(e.Debug.checkDefined(ve, "If there are more than one scriptKind's for same document the scriptKind should be provided"));
                return e.Debug.assert(ve === void 0 || !ee || ee.sourceFile.scriptKind === ve, "Script kind should match provided ScriptKind:".concat(ve, " and sourceFile.scriptKind: ").concat(ee == null ? void 0 : ee.sourceFile.scriptKind, ", !entry: ").concat(!ee)), ee;
              }
              function J(O, ve, ee, he, F, x, X, $) {
                var A, y, V, L;
                $ = e.ensureScriptKind(O, $);
                var P = oe(ee), k = ee === P ? void 0 : ee, Y = $ === 6 ? 100 : e.getEmitScriptTarget(P), U = { languageVersion: Y, impliedNodeFormat: k && e.getImpliedNodeFormatForFile(ve, (L = (V = (y = (A = k.getCompilerHost) === null || A === void 0 ? void 0 : A.call(k)) === null || y === void 0 ? void 0 : y.getModuleResolutionCache) === null || V === void 0 ? void 0 : V.call(y)) === null || L === void 0 ? void 0 : L.getPackageJsonInfoCache(), k, P), setExternalModuleIndicator: e.getSetExternalModuleIndicator(P) }, j = p.size, H = e.getOrUpdate(p, he, function() {
                  return new e.Map();
                });
                if (e.tracing) {
                  p.size > j && e.tracing.instant("session", "createdDocumentRegistryBucket", { configFilePath: P.configFilePath, key: he });
                  var I = !e.isDeclarationFileName(ve) && e.forEachEntry(p, function(g, ne) {
                    return ne !== he && g.has(ve) && ne;
                  });
                  I && e.tracing.instant("session", "documentRegistryBucketOverlap", { path: ve, key1: I, key2: he });
                }
                var l = H.get(ve), d = l && se(l, $);
                if (!d && N) {
                  var D = N.getDocument(he, ve);
                  D && (e.Debug.assert(X), d = { sourceFile: D, languageServiceRefCount: 0 }, fe());
                }
                if (d) d.sourceFile.version !== x && (d.sourceFile = e.updateLanguageServiceSourceFile(d.sourceFile, F, x, F.getChangeRange(d.sourceFile.scriptSnapshot)), N && N.setDocument(he, ve, d.sourceFile)), X && d.languageServiceRefCount++;
                else {
                  var D = e.createLanguageServiceSourceFile(O, F, U, x, false, $);
                  N && N.setDocument(he, ve, D), d = { sourceFile: D, languageServiceRefCount: 1 }, fe();
                }
                return e.Debug.assert(d.languageServiceRefCount !== 0), d.sourceFile;
                function fe() {
                  if (!l) H.set(ve, d);
                  else if (a(l)) {
                    var g = new e.Map();
                    g.set(l.sourceFile.scriptKind, l), g.set($, d), H.set(ve, g);
                  } else l.set($, d);
                }
              }
              function ie(O, ve, ee) {
                var he = e.toPath(O, le, m), F = E(ve);
                return R(he, F, ee);
              }
              function R(O, ve, ee) {
                var he = e.Debug.checkDefined(p.get(ve)), F = he.get(O), x = se(F, ee);
                x.languageServiceRefCount--, e.Debug.assert(x.languageServiceRefCount >= 0), x.languageServiceRefCount === 0 && (a(F) ? he.delete(O) : (F.delete(ee), F.size === 1 && he.set(O, e.firstDefinedIterator(F.values(), e.identity))));
              }
              function q(O, ve) {
                return e.arrayFrom(p.entries(), function(ee) {
                  var he = ee[0], F = ee[1], x = F.get(O), X = x && se(x, ve);
                  return [he, X && X.languageServiceRefCount];
                });
              }
              return { acquireDocument: f, acquireDocumentWithKey: T, updateDocument: K, updateDocumentWithKey: b, releaseDocument: ie, releaseDocumentWithKey: R, getLanguageServiceRefCounts: q, reportStats: G, getKeyForCompilationSettings: E };
            }
            e.createDocumentRegistryInternal = w;
            function B(Q) {
              var le;
              if (Q === null || typeof Q != "object") return "" + Q;
              if (e.isArray(Q)) return "[".concat((le = e.map(Q, function(m) {
                return B(m);
              })) === null || le === void 0 ? void 0 : le.join(","), "]");
              var N = "{";
              for (var p in Q) e.hasOwnProperty.call(Q, p) && (N += "".concat(p, ": ").concat(B(Q[p])));
              return N + "}";
            }
            function E(Q) {
              return e.sourceFileAffectingCompilerOptions.map(function(le) {
                return B(e.getCompilerOptionValue(Q, le));
              }).join("|") + (Q.pathsBasePath ? "|".concat(Q.pathsBasePath) : void 0);
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w(ve, ee, he, F) {
                var x = m(ve, he, F);
                return function(X, $, A) {
                  var y = Q(ve, ee, x, $, he, F), V = y.directImports, L = y.indirectUsers;
                  return Ke({ indirectUsers: L }, le(V, X, $.exportKind, he, A));
                };
              }
              C.createImportTracker = w;
              var B;
              (function(ve) {
                ve[ve.Named = 0] = "Named", ve[ve.Default = 1] = "Default", ve[ve.ExportEquals = 2] = "ExportEquals";
              })(B = C.ExportKind || (C.ExportKind = {}));
              var E;
              (function(ve) {
                ve[ve.Import = 0] = "Import", ve[ve.Export = 1] = "Export";
              })(E = C.ImportExport || (C.ImportExport = {}));
              function Q(ve, ee, he, F, x, X) {
                var $ = F.exportingModuleSymbol, A = F.exportKind, y = e.nodeSeenTracker(), V = e.nodeSeenTracker(), L = [], P = !!$.globalExports, k = P ? void 0 : [];
                return U($), { directImports: L, indirectUsers: Y() };
                function Y() {
                  if (P) return ve;
                  if ($.declarations) for (var D = 0, fe = $.declarations; D < fe.length; D++) {
                    var g = fe[D];
                    e.isExternalModuleAugmentation(g) && ee.has(g.getSourceFile().fileName) && l(g);
                  }
                  return k.map(e.getSourceFileOfNode);
                }
                function U(D) {
                  var fe = d(D);
                  if (fe) for (var g = 0, ne = fe; g < ne.length; g++) {
                    var ue = ne[g];
                    if (!!y(ue)) switch (X && X.throwIfCancellationRequested(), ue.kind) {
                      case 208:
                        if (e.isImportCall(ue)) {
                          j(ue);
                          break;
                        }
                        if (!P) {
                          var We = ue.parent;
                          if (A === 2 && We.kind === 254) {
                            var Fe = We.name;
                            if (Fe.kind === 79) {
                              L.push(Fe);
                              break;
                            }
                          }
                        }
                        break;
                      case 79:
                        break;
                      case 265:
                        I(ue, ue.name, e.hasSyntacticModifier(ue, 1), false);
                        break;
                      case 266:
                        L.push(ue);
                        var Z = ue.importClause && ue.importClause.namedBindings;
                        Z && Z.kind === 268 ? I(ue, Z.name, false, true) : !P && e.isDefaultImport(ue) && l(R(ue));
                        break;
                      case 272:
                        ue.exportClause ? ue.exportClause.kind === 274 ? l(R(ue), true) : L.push(ue) : U(ie(ue, x));
                        break;
                      case 200:
                        ue.isTypeOf && !ue.qualifier && H(ue) && l(ue.getSourceFile(), true), L.push(ue);
                        break;
                      default:
                        e.Debug.failBadSyntaxKind(ue, "Unexpected import kind.");
                    }
                  }
                }
                function j(D) {
                  var fe = e.findAncestor(D, q) || D.getSourceFile();
                  l(fe, !!H(D, true));
                }
                function H(D, fe) {
                  return fe === void 0 && (fe = false), e.findAncestor(D, function(g) {
                    return fe && q(g) ? "quit" : e.some(g.modifiers, function(ne) {
                      return ne.kind === 93;
                    });
                  });
                }
                function I(D, fe, g, ne) {
                  if (A === 2) ne || L.push(D);
                  else if (!P) {
                    var ue = R(D);
                    e.Debug.assert(ue.kind === 305 || ue.kind === 261), g || N(ue, fe, x) ? l(ue, true) : l(ue);
                  }
                }
                function l(D, fe) {
                  fe === void 0 && (fe = false), e.Debug.assert(!P);
                  var g = V(D);
                  if (!!g && (k.push(D), !!fe)) {
                    var ne = x.getMergedSymbol(D.symbol);
                    if (!!ne) {
                      e.Debug.assert(!!(ne.flags & 1536));
                      var ue = d(ne);
                      if (ue) for (var We = 0, Fe = ue; We < Fe.length; We++) {
                        var Z = Fe[We];
                        e.isImportTypeNode(Z) || l(R(Z), true);
                      }
                    }
                  }
                }
                function d(D) {
                  return he.get(e.getSymbolId(D).toString());
                }
              }
              function le(ve, ee, he, F, x) {
                var X = [], $ = [];
                function A(j, H) {
                  X.push([j, H]);
                }
                if (ve) for (var y = 0, V = ve; y < V.length; y++) {
                  var L = V[y];
                  P(L);
                }
                return { importSearches: X, singleReferences: $ };
                function P(j) {
                  if (j.kind === 265) {
                    O(j) && k(j.name);
                    return;
                  }
                  if (j.kind === 79) {
                    k(j);
                    return;
                  }
                  if (j.kind === 200) {
                    if (j.qualifier) {
                      var H = e.getFirstIdentifier(j.qualifier);
                      H.escapedText === e.symbolName(ee) && $.push(H);
                    } else he === 2 && $.push(j.argument.literal);
                    return;
                  }
                  if (j.moduleSpecifier.kind === 10) {
                    if (j.kind === 272) {
                      j.exportClause && e.isNamedExports(j.exportClause) && Y(j.exportClause);
                      return;
                    }
                    var I = j.importClause || { name: void 0, namedBindings: void 0 }, l = I.name, d = I.namedBindings;
                    if (d) switch (d.kind) {
                      case 268:
                        k(d.name);
                        break;
                      case 269:
                        (he === 0 || he === 1) && Y(d);
                        break;
                      default:
                        e.Debug.assertNever(d);
                    }
                    if (l && (he === 1 || he === 2) && (!x || l.escapedText === e.symbolEscapedNameNoDefault(ee))) {
                      var D = F.getSymbolAtLocation(l);
                      A(l, D);
                    }
                  }
                }
                function k(j) {
                  he === 2 && (!x || U(j.escapedText)) && A(j, F.getSymbolAtLocation(j));
                }
                function Y(j) {
                  if (!!j) for (var H = 0, I = j.elements; H < I.length; H++) {
                    var l = I[H], d = l.name, D = l.propertyName;
                    if (!!U((D || d).escapedText)) if (D) $.push(D), (!x || d.escapedText === ee.escapedName) && A(d, F.getSymbolAtLocation(d));
                    else {
                      var fe = l.kind === 275 && l.propertyName ? F.getExportSpecifierLocalTargetSymbol(l) : F.getSymbolAtLocation(d);
                      A(d, fe);
                    }
                  }
                }
                function U(j) {
                  return j === ee.escapedName || he !== 0 && j === "default";
                }
              }
              function N(ve, ee, he) {
                var F = he.getSymbolAtLocation(ee);
                return !!G(ve, function(x) {
                  if (!!e.isExportDeclaration(x)) {
                    var X = x.exportClause, $ = x.moduleSpecifier;
                    return !$ && X && e.isNamedExports(X) && X.elements.some(function(A) {
                      return he.getExportSpecifierLocalTargetSymbol(A) === F;
                    });
                  }
                });
              }
              function p(ve, ee, he) {
                for (var F = [], x = ve.getTypeChecker(), X = 0, $ = ee; X < $.length; X++) {
                  var A = $[X], y = he.valueDeclaration;
                  if ((y == null ? void 0 : y.kind) === 305) {
                    for (var V = 0, L = A.referencedFiles; V < L.length; V++) {
                      var P = L[V];
                      ve.getSourceFileFromReference(A, P) === y && F.push({ kind: "reference", referencingFile: A, ref: P });
                    }
                    for (var k = 0, Y = A.typeReferenceDirectives; k < Y.length; k++) {
                      var P = Y[k], U = ve.getResolvedTypeReferenceDirectives().get(P.fileName, P.resolutionMode || A.impliedNodeFormat);
                      U !== void 0 && U.resolvedFileName === y.fileName && F.push({ kind: "reference", referencingFile: A, ref: P });
                    }
                  }
                  oe(A, function(j, H) {
                    var I = x.getSymbolAtLocation(H);
                    I === he && F.push({ kind: "import", literal: H });
                  });
                }
                return F;
              }
              C.findModuleReferences = p;
              function m(ve, ee, he) {
                for (var F = new e.Map(), x = 0, X = ve; x < X.length; x++) {
                  var $ = X[x];
                  he && he.throwIfCancellationRequested(), oe($, function(A, y) {
                    var V = ee.getSymbolAtLocation(y);
                    if (V) {
                      var L = e.getSymbolId(V).toString(), P = F.get(L);
                      P || F.set(L, P = []), P.push(A);
                    }
                  });
                }
                return F;
              }
              function G(ve, ee) {
                return e.forEach(ve.kind === 305 ? ve.statements : ve.body.statements, function(he) {
                  return ee(he) || q(he) && e.forEach(he.body && he.body.statements, ee);
                });
              }
              function oe(ve, ee) {
                if (ve.externalModuleIndicator || ve.imports !== void 0) for (var he = 0, F = ve.imports; he < F.length; he++) {
                  var x = F[he];
                  ee(e.importFromModuleSpecifier(x), x);
                }
                else G(ve, function(X) {
                  switch (X.kind) {
                    case 272:
                    case 266: {
                      var $ = X;
                      $.moduleSpecifier && e.isStringLiteral($.moduleSpecifier) && ee($, $.moduleSpecifier);
                      break;
                    }
                    case 265: {
                      var $ = X;
                      O($) && ee($, $.moduleReference.expression);
                      break;
                    }
                  }
                });
              }
              function f(ve, ee, he, F) {
                return F ? x() : x() || X();
                function x() {
                  var y, V = ve.parent, L = V.parent;
                  if (ee.exportSymbol) return V.kind === 206 ? ((y = ee.declarations) === null || y === void 0 ? void 0 : y.some(function(j) {
                    return j === V;
                  })) && e.isBinaryExpression(L) ? U(L, false) : void 0 : $(ee.exportSymbol, A(V));
                  var P = K(V, ve);
                  if (P && e.hasSyntacticModifier(P, 1)) if (e.isImportEqualsDeclaration(P) && P.moduleReference === ve) {
                    if (F) return;
                    var k = he.getSymbolAtLocation(P.name);
                    return { kind: 0, symbol: k };
                  } else return $(ee, A(P));
                  else {
                    if (e.isNamespaceExport(V)) return $(ee, 0);
                    if (e.isExportAssignment(V)) return Y(V);
                    if (e.isExportAssignment(L)) return Y(L);
                    if (e.isBinaryExpression(V)) return U(V, true);
                    if (e.isBinaryExpression(L)) return U(L, true);
                    if (e.isJSDocTypedefTag(V)) return $(ee, 0);
                  }
                  function Y(j) {
                    if (!!j.symbol.parent) {
                      var H = j.isExportEquals ? 2 : 1;
                      return { kind: 1, symbol: ee, exportInfo: { exportingModuleSymbol: j.symbol.parent, exportKind: H } };
                    }
                  }
                  function U(j, H) {
                    var I;
                    switch (e.getAssignmentDeclarationKind(j)) {
                      case 1:
                        I = 0;
                        break;
                      case 2:
                        I = 2;
                        break;
                      default:
                        return;
                    }
                    var l = H ? he.getSymbolAtLocation(e.getNameOfAccessExpression(e.cast(j.left, e.isAccessExpression))) : ee;
                    return l && $(l, I);
                  }
                }
                function X() {
                  var y = b(ve);
                  if (!!y) {
                    var V = he.getImmediateAliasedSymbol(ee);
                    if (!!V) {
                      V = J(V, he), V.escapedName === "export=" && (V = T(V, he));
                      var L = e.symbolEscapedNameNoDefault(V);
                      if (L === void 0 || L === "default" || L === ee.escapedName) return { kind: 0, symbol: V };
                    }
                  }
                }
                function $(y, V) {
                  var L = se(y, V, he);
                  return L && { kind: 1, symbol: y, exportInfo: L };
                }
                function A(y) {
                  return e.hasSyntacticModifier(y, 512) ? 1 : 0;
                }
              }
              C.getImportOrExportSymbol = f;
              function T(ve, ee) {
                if (ve.flags & 2097152) return e.Debug.checkDefined(ee.getImmediateAliasedSymbol(ve));
                var he = e.Debug.checkDefined(ve.valueDeclaration);
                return e.isExportAssignment(he) ? e.Debug.checkDefined(he.expression.symbol) : e.isBinaryExpression(he) ? e.Debug.checkDefined(he.right.symbol) : e.isSourceFile(he) ? e.Debug.checkDefined(he.symbol) : e.Debug.fail();
              }
              function K(ve, ee) {
                var he = e.isVariableDeclaration(ve) ? ve : e.isBindingElement(ve) ? e.walkUpBindingElementsAndPatterns(ve) : void 0;
                return he ? ve.name !== ee || e.isCatchClause(he.parent) ? void 0 : e.isVariableStatement(he.parent.parent) ? he.parent.parent : void 0 : ve;
              }
              function b(ve) {
                var ee = ve.parent;
                switch (ee.kind) {
                  case 265:
                    return ee.name === ve && O(ee);
                  case 270:
                    return !ee.propertyName;
                  case 267:
                  case 268:
                    return e.Debug.assert(ee.name === ve), true;
                  case 203:
                    return e.isInJSFile(ve) && e.isVariableDeclarationInitializedToBareOrAccessedRequire(ee);
                  default:
                    return false;
                }
              }
              function se(ve, ee, he) {
                var F = ve.parent;
                if (!!F) {
                  var x = he.getMergedSymbol(F);
                  return e.isExternalModuleSymbol(x) ? { exportingModuleSymbol: x, exportKind: ee } : void 0;
                }
              }
              C.getExportInfo = se;
              function J(ve, ee) {
                if (ve.declarations) for (var he = 0, F = ve.declarations; he < F.length; he++) {
                  var x = F[he];
                  if (e.isExportSpecifier(x) && !x.propertyName && !x.parent.parent.moduleSpecifier) return ee.getExportSpecifierLocalTargetSymbol(x);
                  if (e.isPropertyAccessExpression(x) && e.isModuleExportsAccessExpression(x.expression) && !e.isPrivateIdentifier(x.name)) return ee.getSymbolAtLocation(x);
                  if (e.isShorthandPropertyAssignment(x) && e.isBinaryExpression(x.parent.parent) && e.getAssignmentDeclarationKind(x.parent.parent) === 2) return ee.getExportSpecifierLocalTargetSymbol(x.name);
                }
                return ve;
              }
              function ie(ve, ee) {
                return ee.getMergedSymbol(R(ve).symbol);
              }
              function R(ve) {
                if (ve.kind === 208) return ve.getSourceFile();
                var ee = ve.parent;
                return ee.kind === 305 ? ee : (e.Debug.assert(ee.kind === 262), e.cast(ee.parent, q));
              }
              function q(ve) {
                return ve.kind === 261 && ve.name.kind === 10;
              }
              function O(ve) {
                return ve.moduleReference.kind === 277 && ve.moduleReference.expression.kind === 10;
              }
            })(a = e.FindAllReferences || (e.FindAllReferences = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w;
              (function(k) {
                k[k.Symbol = 0] = "Symbol", k[k.Label = 1] = "Label", k[k.Keyword = 2] = "Keyword", k[k.This = 3] = "This", k[k.String = 4] = "String", k[k.TripleSlashReference = 5] = "TripleSlashReference";
              })(w = C.DefinitionKind || (C.DefinitionKind = {}));
              var B;
              (function(k) {
                k[k.Span = 0] = "Span", k[k.Node = 1] = "Node", k[k.StringLiteral = 2] = "StringLiteral", k[k.SearchedLocalFoundProperty = 3] = "SearchedLocalFoundProperty", k[k.SearchedPropertyFoundLocal = 4] = "SearchedPropertyFoundLocal";
              })(B = C.EntryKind || (C.EntryKind = {}));
              function E(k, Y) {
                return Y === void 0 && (Y = 1), { kind: Y, node: k.name || k, context: le(k) };
              }
              C.nodeEntry = E;
              function Q(k) {
                return k && k.kind === void 0;
              }
              C.isContextWithStartAndEndNode = Q;
              function le(k) {
                if (e.isDeclaration(k)) return N(k);
                if (!!k.parent) {
                  if (!e.isDeclaration(k.parent) && !e.isExportAssignment(k.parent)) {
                    if (e.isInJSFile(k)) {
                      var Y = e.isBinaryExpression(k.parent) ? k.parent : e.isAccessExpression(k.parent) && e.isBinaryExpression(k.parent.parent) && k.parent.parent.left === k.parent ? k.parent.parent : void 0;
                      if (Y && e.getAssignmentDeclarationKind(Y) !== 0) return N(Y);
                    }
                    if (e.isJsxOpeningElement(k.parent) || e.isJsxClosingElement(k.parent)) return k.parent.parent;
                    if (e.isJsxSelfClosingElement(k.parent) || e.isLabeledStatement(k.parent) || e.isBreakOrContinueStatement(k.parent)) return k.parent;
                    if (e.isStringLiteralLike(k)) {
                      var U = e.tryGetImportFromModuleSpecifier(k);
                      if (U) {
                        var j = e.findAncestor(U, function(I) {
                          return e.isDeclaration(I) || e.isStatement(I) || e.isJSDocTag(I);
                        });
                        return e.isDeclaration(j) ? N(j) : j;
                      }
                    }
                    var H = e.findAncestor(k, e.isComputedPropertyName);
                    return H ? N(H.parent) : void 0;
                  }
                  if (k.parent.name === k || e.isConstructorDeclaration(k.parent) || e.isExportAssignment(k.parent) || (e.isImportOrExportSpecifier(k.parent) || e.isBindingElement(k.parent)) && k.parent.propertyName === k || k.kind === 88 && e.hasSyntacticModifier(k.parent, 513)) return N(k.parent);
                }
              }
              function N(k) {
                if (!!k) switch (k.kind) {
                  case 254:
                    return !e.isVariableDeclarationList(k.parent) || k.parent.declarations.length !== 1 ? k : e.isVariableStatement(k.parent.parent) ? k.parent.parent : e.isForInOrOfStatement(k.parent.parent) ? N(k.parent.parent) : k.parent;
                  case 203:
                    return N(k.parent.parent);
                  case 270:
                    return k.parent.parent.parent;
                  case 275:
                  case 268:
                    return k.parent.parent;
                  case 267:
                  case 274:
                    return k.parent;
                  case 221:
                    return e.isExpressionStatement(k.parent) ? k.parent : k;
                  case 244:
                  case 243:
                    return { start: k.initializer, end: k.expression };
                  case 296:
                  case 297:
                    return e.isArrayLiteralOrObjectLiteralDestructuringPattern(k.parent) ? N(e.findAncestor(k.parent, function(Y) {
                      return e.isBinaryExpression(Y) || e.isForInOrOfStatement(Y);
                    })) : k;
                  default:
                    return k;
                }
              }
              C.getContextNode = N;
              function p(k, Y, U) {
                if (!!U) {
                  var j = Q(U) ? $(U.start, Y, U.end) : $(U, Y);
                  return j.start !== k.start || j.length !== k.length ? { contextSpan: j } : void 0;
                }
              }
              C.toContextSpan = p;
              var m;
              (function(k) {
                k[k.Other = 0] = "Other", k[k.References = 1] = "References", k[k.Rename = 2] = "Rename";
              })(m = C.FindReferencesUse || (C.FindReferencesUse = {}));
              function G(k, Y, U, j, H) {
                var I = e.getTouchingPropertyName(j, H), l = { use: 1 }, d = P.getReferencedSymbolsForNode(H, I, k, U, Y, l), D = k.getTypeChecker(), fe = P.getAdjustedNode(I, l), g = oe(fe) ? D.getSymbolAtLocation(fe) : void 0;
                return !d || !d.length ? void 0 : e.mapDefined(d, function(ne) {
                  var ue = ne.definition, We = ne.references;
                  return ue && { definition: D.runWithCancellationToken(Y, function(Fe) {
                    return J(ue, Fe, I);
                  }), references: We.map(function(Fe) {
                    return O(Fe, g);
                  }) };
                });
              }
              C.findReferencedSymbols = G;
              function oe(k) {
                return k.kind === 88 || !!e.getDeclarationFromName(k) || e.isLiteralComputedPropertyDeclarationName(k) || k.kind === 134 && e.isConstructorDeclaration(k.parent);
              }
              function f(k, Y, U, j, H) {
                var I = e.getTouchingPropertyName(j, H), l, d = T(k, Y, U, I, H);
                if (I.parent.kind === 206 || I.parent.kind === 203 || I.parent.kind === 207 || I.kind === 106) l = d && Ve([], d, true);
                else for (var D = d && Ve([], d, true), fe = new e.Map(); D && D.length; ) {
                  var g = D.shift();
                  if (!!e.addToSeen(fe, e.getNodeId(g.node))) {
                    l = e.append(l, g);
                    var ne = T(k, Y, U, g.node, g.node.pos);
                    ne && D.push.apply(D, ne);
                  }
                }
                var ue = k.getTypeChecker();
                return e.map(l, function(We) {
                  return F(We, ue);
                });
              }
              C.getImplementationsAtPosition = f;
              function T(k, Y, U, j, H) {
                if (j.kind !== 305) {
                  var I = k.getTypeChecker();
                  if (j.parent.kind === 297) {
                    var l = [];
                    return P.getReferenceEntriesForShorthandPropertyAssignment(j, I, function(D) {
                      return l.push(E(D));
                    }), l;
                  } else if (j.kind === 106 || e.isSuperProperty(j.parent)) {
                    var d = I.getSymbolAtLocation(j);
                    return d.valueDeclaration && [E(d.valueDeclaration)];
                  } else return b(H, j, k, U, Y, { implementations: true, use: 1 });
                }
              }
              function K(k, Y, U, j, H, I, l) {
                return e.map(se(P.getReferencedSymbolsForNode(H, j, k, U, Y, I)), function(d) {
                  return l(d, j, k.getTypeChecker());
                });
              }
              C.findReferenceOrRenameEntries = K;
              function b(k, Y, U, j, H, I, l) {
                return I === void 0 && (I = {}), l === void 0 && (l = new e.Set(j.map(function(d) {
                  return d.fileName;
                }))), se(P.getReferencedSymbolsForNode(k, Y, U, j, H, I, l));
              }
              C.getReferenceEntriesForNode = b;
              function se(k) {
                return k && e.flatMap(k, function(Y) {
                  return Y.references;
                });
              }
              function J(k, Y, U) {
                var j = function() {
                  switch (k.type) {
                    case 0: {
                      var g = k.symbol, ne = R(g, Y, U), ue = ne.displayParts, We = ne.kind, Fe = ue.map(function(ze) {
                        return ze.text;
                      }).join(""), Z = g.declarations && e.firstOrUndefined(g.declarations), Be = Z ? e.getNameOfDeclaration(Z) || Z : U;
                      return Ke(Ke({}, ie(Be)), { name: Fe, kind: We, displayParts: ue, context: N(Z) });
                    }
                    case 1: {
                      var Be = k.node;
                      return Ke(Ke({}, ie(Be)), { name: Be.text, kind: "label", displayParts: [e.displayPart(Be.text, e.SymbolDisplayPartKind.text)] });
                    }
                    case 2: {
                      var Be = k.node, ge = e.tokenToString(Be.kind);
                      return Ke(Ke({}, ie(Be)), { name: ge, kind: "keyword", displayParts: [{ text: ge, kind: "keyword" }] });
                    }
                    case 3: {
                      var Be = k.node, g = Y.getSymbolAtLocation(Be), Re = g && e.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(Y, g, Be.getSourceFile(), e.getContainerNode(Be), Be).displayParts || [e.textPart("this")];
                      return Ke(Ke({}, ie(Be)), { name: "this", kind: "var", displayParts: Re });
                    }
                    case 4: {
                      var Be = k.node;
                      return Ke(Ke({}, ie(Be)), { name: Be.text, kind: "var", displayParts: [e.displayPart(e.getTextOfNode(Be), e.SymbolDisplayPartKind.stringLiteral)] });
                    }
                    case 5:
                      return { textSpan: e.createTextSpanFromRange(k.reference), sourceFile: k.file, name: k.reference.fileName, kind: "string", displayParts: [e.displayPart('"'.concat(k.reference.fileName, '"'), e.SymbolDisplayPartKind.stringLiteral)] };
                    default:
                      return e.Debug.assertNever(k);
                  }
                }(), H = j.sourceFile, I = j.textSpan, l = j.name, d = j.kind, D = j.displayParts, fe = j.context;
                return Ke({ containerKind: "", containerName: "", fileName: H.fileName, kind: d, name: l, textSpan: I, displayParts: D }, p(I, H, fe));
              }
              function ie(k) {
                var Y = k.getSourceFile();
                return { sourceFile: Y, textSpan: $(e.isComputedPropertyName(k) ? k.expression : k, Y) };
              }
              function R(k, Y, U) {
                var j = P.getIntersectingMeaningFromDeclarations(U, k), H = k.declarations && e.firstOrUndefined(k.declarations) || U, I = e.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(Y, k, H.getSourceFile(), H, H, j), l = I.displayParts, d = I.symbolKind;
                return { displayParts: l, kind: d };
              }
              function q(k, Y, U, j) {
                return Ke(Ke({}, ee(k)), j && he(k, Y, U));
              }
              C.toRenameLocation = q;
              function O(k, Y) {
                var U = ve(k);
                return Y ? Ke(Ke({}, U), { isDefinition: k.kind !== 0 && V(k.node, Y) }) : U;
              }
              function ve(k) {
                var Y = ee(k);
                if (k.kind === 0) return Ke(Ke({}, Y), { isWriteAccess: false });
                var U = k.kind, j = k.node;
                return Ke(Ke({}, Y), { isWriteAccess: y(j), isInString: U === 2 ? true : void 0 });
              }
              C.toReferenceEntry = ve;
              function ee(k) {
                if (k.kind === 0) return { textSpan: k.textSpan, fileName: k.fileName };
                var Y = k.node.getSourceFile(), U = $(k.node, Y);
                return Ke({ textSpan: U, fileName: Y.fileName }, p(U, Y, k.context));
              }
              function he(k, Y, U) {
                if (k.kind !== 0 && e.isIdentifier(Y)) {
                  var j = k.node, H = k.kind, I = j.parent, l = Y.text, d = e.isShorthandPropertyAssignment(I);
                  if (d || e.isObjectBindingElementWithoutPropertyName(I) && I.name === j && I.dotDotDotToken === void 0) {
                    var D = { prefixText: l + ": " }, fe = { suffixText: ": " + l };
                    if (H === 3) return D;
                    if (H === 4) return fe;
                    if (d) {
                      var g = I.parent;
                      return e.isObjectLiteralExpression(g) && e.isBinaryExpression(g.parent) && e.isModuleExportsAccessExpression(g.parent.left) ? D : fe;
                    } else return D;
                  } else if (e.isImportSpecifier(I) && !I.propertyName) {
                    var ne = e.isExportSpecifier(Y.parent) ? U.getExportSpecifierLocalTargetSymbol(Y.parent) : U.getSymbolAtLocation(Y);
                    return e.contains(ne.declarations, I) ? { prefixText: l + " as " } : e.emptyOptions;
                  } else if (e.isExportSpecifier(I) && !I.propertyName) return Y === k.node || U.getSymbolAtLocation(Y) === U.getSymbolAtLocation(k.node) ? { prefixText: l + " as " } : { suffixText: " as " + l };
                }
                return e.emptyOptions;
              }
              function F(k, Y) {
                var U = ee(k);
                if (k.kind !== 0) {
                  var j = k.node;
                  return Ke(Ke({}, U), x(j, Y));
                } else return Ke(Ke({}, U), { kind: "", displayParts: [] });
              }
              function x(k, Y) {
                var U = Y.getSymbolAtLocation(e.isDeclaration(k) && k.name ? k.name : k);
                return U ? R(U, Y, k) : k.kind === 205 ? { kind: "interface", displayParts: [e.punctuationPart(20), e.textPart("object literal"), e.punctuationPart(21)] } : k.kind === 226 ? { kind: "local class", displayParts: [e.punctuationPart(20), e.textPart("anonymous local class"), e.punctuationPart(21)] } : { kind: e.getNodeKind(k), displayParts: [] };
              }
              function X(k) {
                var Y = ee(k);
                if (k.kind === 0) return { fileName: Y.fileName, span: { textSpan: Y.textSpan, kind: "reference" } };
                var U = y(k.node), j = Ke({ textSpan: Y.textSpan, kind: U ? "writtenReference" : "reference", isInString: k.kind === 2 ? true : void 0 }, Y.contextSpan && { contextSpan: Y.contextSpan });
                return { fileName: Y.fileName, span: j };
              }
              C.toHighlightSpan = X;
              function $(k, Y, U) {
                var j = k.getStart(Y), H = (U || k).getEnd();
                return e.isStringLiteralLike(k) && H - j > 2 && (e.Debug.assert(U === void 0), j += 1, H -= 1), e.createTextSpanFromBounds(j, H);
              }
              function A(k) {
                return k.kind === 0 ? k.textSpan : $(k.node, k.node.getSourceFile());
              }
              C.getTextSpanOfEntry = A;
              function y(k) {
                var Y = e.getDeclarationFromName(k);
                return !!Y && L(Y) || k.kind === 88 || e.isWriteAccess(k);
              }
              function V(k, Y) {
                var U;
                if (!Y) return false;
                var j = e.getDeclarationFromName(k) || (k.kind === 88 ? k.parent : e.isLiteralComputedPropertyDeclarationName(k) || k.kind === 134 && e.isConstructorDeclaration(k.parent) ? k.parent.parent : void 0), H = j && e.isBinaryExpression(j) ? j.left : void 0;
                return !!(j && ((U = Y.declarations) === null || U === void 0 ? void 0 : U.some(function(I) {
                  return I === j || I === H;
                })));
              }
              function L(k) {
                if (k.flags & 16777216) return true;
                switch (k.kind) {
                  case 221:
                  case 203:
                  case 257:
                  case 226:
                  case 88:
                  case 260:
                  case 299:
                  case 275:
                  case 267:
                  case 265:
                  case 270:
                  case 258:
                  case 338:
                  case 345:
                  case 285:
                  case 261:
                  case 264:
                  case 268:
                  case 274:
                  case 164:
                  case 297:
                  case 259:
                  case 163:
                    return true;
                  case 296:
                    return !e.isArrayLiteralOrObjectLiteralDestructuringPattern(k.parent);
                  case 256:
                  case 213:
                  case 171:
                  case 169:
                  case 172:
                  case 173:
                    return !!k.body;
                  case 254:
                  case 167:
                    return !!k.initializer || e.isCatchClause(k.parent);
                  case 168:
                  case 166:
                  case 347:
                  case 340:
                    return false;
                  default:
                    return e.Debug.failBadSyntaxKind(k);
                }
              }
              var P;
              (function(k) {
                function Y(Oe, nr, Mr, Pe, Ue, fr, De) {
                  var gr, Vr;
                  if (fr === void 0 && (fr = {}), De === void 0 && (De = new e.Set(Pe.map(function(Rt) {
                    return Rt.fileName;
                  }))), nr = U(nr, fr), e.isSourceFile(nr)) {
                    var Tr = e.GoToDefinition.getReferenceAtPosition(nr, Oe, Mr);
                    if (!(Tr != null && Tr.file)) return;
                    var vi = Mr.getTypeChecker().getMergedSymbol(Tr.file.symbol);
                    if (vi) return fe(Mr, vi, false, Pe, De);
                    var Ui = Mr.getFileIncludeReasons();
                    return Ui ? [{ definition: { type: 5, reference: Tr.reference, file: nr }, references: H(Tr.file, Ui, Mr) || e.emptyArray }] : void 0;
                  }
                  if (!fr.implementations) {
                    var Yi = ne(nr, Pe, Ue);
                    if (Yi) return Yi;
                  }
                  var Wi = Mr.getTypeChecker(), ct = Wi.getSymbolAtLocation(e.isConstructorDeclaration(nr) && nr.parent.name || nr);
                  if (!ct) {
                    if (!fr.implementations && e.isStringLiteralLike(nr)) {
                      if (e.isModuleSpecifierLike(nr)) {
                        var Ui = Mr.getFileIncludeReasons(), Li = (Vr = (gr = nr.getSourceFile().resolvedModules) === null || gr === void 0 ? void 0 : gr.get(nr.text, e.getModeForUsageLocation(nr.getSourceFile(), nr))) === null || Vr === void 0 ? void 0 : Vr.resolvedFileName, nt = Li ? Mr.getSourceFile(Li) : void 0;
                        if (nt) return [{ definition: { type: 4, node: nr }, references: H(nt, Ui, Mr) || e.emptyArray }];
                      }
                      return ae(nr, Pe, Wi, Ue);
                    }
                    return;
                  }
                  if (ct.escapedName === "export=") return fe(Mr, ct.parent, false, Pe, De);
                  var Mt = l(ct, Mr, Pe, Ue, fr, De);
                  if (Mt && !(ct.flags & 33554432)) return Mt;
                  var xt = I(nr, ct, Wi), ut = xt && l(xt, Mr, Pe, Ue, fr, De), Dt = ue(ct, nr, Pe, De, Wi, Ue, fr);
                  return d(Mr, Mt, Dt, ut);
                }
                k.getReferencedSymbolsForNode = Y;
                function U(Oe, nr) {
                  return nr.use === 1 ? Oe = e.getAdjustedReferenceLocation(Oe) : nr.use === 2 && (Oe = e.getAdjustedRenameLocation(Oe)), Oe;
                }
                k.getAdjustedNode = U;
                function j(Oe, nr, Mr, Pe) {
                  var Ue, fr;
                  Pe === void 0 && (Pe = new e.Set(Mr.map(function(Tr) {
                    return Tr.fileName;
                  })));
                  var De = (Ue = nr.getSourceFile(Oe)) === null || Ue === void 0 ? void 0 : Ue.symbol;
                  if (De) return ((fr = fe(nr, De, false, Mr, Pe)[0]) === null || fr === void 0 ? void 0 : fr.references) || e.emptyArray;
                  var gr = nr.getFileIncludeReasons(), Vr = nr.getSourceFile(Oe);
                  return Vr && gr && H(Vr, gr, nr) || e.emptyArray;
                }
                k.getReferencesForFileName = j;
                function H(Oe, nr, Mr) {
                  for (var Pe, Ue = nr.get(Oe.path) || e.emptyArray, fr = 0, De = Ue; fr < De.length; fr++) {
                    var gr = De[fr];
                    if (e.isReferencedFile(gr)) {
                      var Vr = Mr.getSourceFileByPath(gr.file), Tr = e.getReferencedFileLocation(Mr.getSourceFileByPath, gr);
                      e.isReferenceFileLocation(Tr) && (Pe = e.append(Pe, { kind: 0, fileName: Vr.fileName, textSpan: e.createTextSpanFromRange(Tr) }));
                    }
                  }
                  return Pe;
                }
                function I(Oe, nr, Mr) {
                  if (Oe.parent && e.isNamespaceExportDeclaration(Oe.parent)) {
                    var Pe = Mr.getAliasedSymbol(nr), Ue = Mr.getMergedSymbol(Pe);
                    if (Pe !== Ue) return Ue;
                  }
                }
                function l(Oe, nr, Mr, Pe, Ue, fr) {
                  var De = Oe.flags & 1536 && Oe.declarations && e.find(Oe.declarations, e.isSourceFile);
                  if (!!De) {
                    var gr = Oe.exports.get("export="), Vr = fe(nr, Oe, !!gr, Mr, fr);
                    if (!gr || !fr.has(De.fileName)) return Vr;
                    var Tr = nr.getTypeChecker();
                    return Oe = e.skipAlias(gr, Tr), d(nr, Vr, ue(Oe, void 0, Mr, fr, Tr, Pe, Ue));
                  }
                }
                function d(Oe) {
                  for (var nr = [], Mr = 1; Mr < arguments.length; Mr++) nr[Mr - 1] = arguments[Mr];
                  for (var Pe, Ue = 0, fr = nr; Ue < fr.length; Ue++) {
                    var De = fr[Ue];
                    if (!(!De || !De.length)) {
                      if (!Pe) {
                        Pe = De;
                        continue;
                      }
                      for (var gr = function(Ui) {
                        if (!Ui.definition || Ui.definition.type !== 0) return Pe.push(Ui), "continue";
                        var Yi = Ui.definition.symbol, Wi = e.findIndex(Pe, function(Li) {
                          return !!Li.definition && Li.definition.type === 0 && Li.definition.symbol === Yi;
                        });
                        if (Wi === -1) return Pe.push(Ui), "continue";
                        var ct = Pe[Wi];
                        Pe[Wi] = { definition: ct.definition, references: ct.references.concat(Ui.references).sort(function(Li, nt) {
                          var Mt = D(Oe, Li), xt = D(Oe, nt);
                          if (Mt !== xt) return e.compareValues(Mt, xt);
                          var ut = A(Li), Dt = A(nt);
                          return ut.start !== Dt.start ? e.compareValues(ut.start, Dt.start) : e.compareValues(ut.length, Dt.length);
                        }) };
                      }, Vr = 0, Tr = De; Vr < Tr.length; Vr++) {
                        var vi = Tr[Vr];
                        gr(vi);
                      }
                    }
                  }
                  return Pe;
                }
                function D(Oe, nr) {
                  var Mr = nr.kind === 0 ? Oe.getSourceFile(nr.fileName) : nr.node.getSourceFile();
                  return Oe.getSourceFiles().indexOf(Mr);
                }
                function fe(Oe, nr, Mr, Pe, Ue) {
                  e.Debug.assert(!!nr.valueDeclaration);
                  var fr = e.mapDefined(C.findModuleReferences(Oe, Pe, nr), function(ct) {
                    if (ct.kind === "import") {
                      var Li = ct.literal.parent;
                      if (e.isLiteralTypeNode(Li)) {
                        var nt = e.cast(Li.parent, e.isImportTypeNode);
                        if (Mr && !nt.qualifier) return;
                      }
                      return E(ct.literal);
                    } else return { kind: 0, fileName: ct.referencingFile.fileName, textSpan: e.createTextSpanFromRange(ct.ref) };
                  });
                  if (nr.declarations) for (var De = 0, gr = nr.declarations; De < gr.length; De++) {
                    var Vr = gr[De];
                    switch (Vr.kind) {
                      case 305:
                        break;
                      case 261:
                        Ue.has(Vr.getSourceFile().fileName) && fr.push(E(Vr.name));
                        break;
                      default:
                        e.Debug.assert(!!(nr.flags & 33554432), "Expected a module symbol to be declared by a SourceFile or ModuleDeclaration.");
                    }
                  }
                  var Tr = nr.exports.get("export=");
                  if (Tr != null && Tr.declarations) for (var vi = 0, Ui = Tr.declarations; vi < Ui.length; vi++) {
                    var Vr = Ui[vi], Yi = Vr.getSourceFile();
                    if (Ue.has(Yi.fileName)) {
                      var Wi = e.isBinaryExpression(Vr) && e.isPropertyAccessExpression(Vr.left) ? Vr.left.expression : e.isExportAssignment(Vr) ? e.Debug.checkDefined(e.findChildOfKind(Vr, 93, Yi)) : e.getNameOfDeclaration(Vr) || Vr;
                      fr.push(E(Wi));
                    }
                  }
                  return fr.length ? [{ definition: { type: 0, symbol: nr }, references: fr }] : e.emptyArray;
                }
                function g(Oe) {
                  return Oe.kind === 145 && e.isTypeOperatorNode(Oe.parent) && Oe.parent.operator === 145;
                }
                function ne(Oe, nr, Mr) {
                  if (e.isTypeKeyword(Oe.kind)) return Oe.kind === 114 && e.isVoidExpression(Oe.parent) || Oe.kind === 145 && !g(Oe) ? void 0 : Ne(nr, Oe.kind, Mr, Oe.kind === 145 ? g : void 0);
                  if (e.isImportMeta(Oe.parent) && Oe.parent.name === Oe) return Er(nr, Mr);
                  if (e.isStaticModifier(Oe) && e.isClassStaticBlockDeclaration(Oe.parent)) return [{ definition: { type: 2, node: Oe }, references: [E(Oe)] }];
                  if (e.isJumpStatementTarget(Oe)) {
                    var Pe = e.getTargetLabel(Oe.parent, Oe.text);
                    return Pe && Ye(Pe.parent, Pe);
                  } else if (e.isLabelOfLabeledStatement(Oe)) return Ye(Oe.parent, Oe);
                  if (e.isThis(Oe)) return pi(Oe, nr, Mr);
                  if (Oe.kind === 106) return Zt(Oe);
                }
                function ue(Oe, nr, Mr, Pe, Ue, fr, De) {
                  var gr = nr && Z(Oe, nr, Ue, !Ar(De)) || Oe, Vr = nr ? zr(nr, gr) : 7, Tr = [], vi = new Re(Mr, Pe, nr ? Fe(nr) : 0, Ue, fr, Vr, De, Tr), Ui = !Ar(De) || !gr.declarations ? void 0 : e.find(gr.declarations, e.isExportSpecifier);
                  if (Ui) ur(Ui.name, gr, Ui, vi.createSearch(nr, Oe, void 0), vi, true, true);
                  else if (nr && nr.kind === 88 && gr.escapedName === "default" && gr.parent) ii(nr, gr, vi), ze(nr, gr, { exportingModuleSymbol: gr.parent, exportKind: 1 }, vi);
                  else {
                    var Yi = vi.createSearch(nr, gr, void 0, { allSearchSymbols: nr ? Xe(gr, nr, Ue, De.use === 2, !!De.providePrefixAndSuffixTextForRename, !!De.implementations) : [gr] });
                    We(gr, vi, Yi);
                  }
                  return Tr;
                }
                function We(Oe, nr, Mr) {
                  var Pe = we(Oe);
                  if (Pe) lr(Pe, Pe.getSourceFile(), Mr, nr, !(e.isSourceFile(Pe) && !e.contains(nr.sourceFiles, Pe)));
                  else for (var Ue = 0, fr = nr.sourceFiles; Ue < fr.length; Ue++) {
                    var De = fr[Ue];
                    nr.cancellationToken.throwIfCancellationRequested(), Ie(De, Mr, nr);
                  }
                }
                function Fe(Oe) {
                  switch (Oe.kind) {
                    case 171:
                    case 134:
                      return 1;
                    case 79:
                      if (e.isClassLike(Oe.parent)) return e.Debug.assert(Oe.parent.name === Oe), 2;
                    default:
                      return 0;
                  }
                }
                function Z(Oe, nr, Mr, Pe) {
                  var Ue = nr.parent;
                  return e.isExportSpecifier(Ue) && Pe ? yr(nr, Oe, Ue, Mr) : e.firstDefined(Oe.declarations, function(fr) {
                    if (!fr.parent) {
                      if (Oe.flags & 33554432) return;
                      e.Debug.fail("Unexpected symbol at ".concat(e.Debug.formatSyntaxKind(nr.kind), ": ").concat(e.Debug.formatSymbol(Oe)));
                    }
                    return e.isTypeLiteralNode(fr.parent) && e.isUnionTypeNode(fr.parent.parent) ? Mr.getPropertyOfType(Mr.getTypeFromTypeNode(fr.parent.parent), Oe.name) : void 0;
                  });
                }
                var Be;
                (function(Oe) {
                  Oe[Oe.None = 0] = "None", Oe[Oe.Constructor = 1] = "Constructor", Oe[Oe.Class = 2] = "Class";
                })(Be || (Be = {}));
                function ge(Oe) {
                  if (!!(Oe.flags & 33555968)) {
                    var nr = Oe.declarations && e.find(Oe.declarations, function(Mr) {
                      return !e.isSourceFile(Mr) && !e.isModuleDeclaration(Mr);
                    });
                    return nr && nr.symbol;
                  }
                }
                var Re = function() {
                  function Oe(nr, Mr, Pe, Ue, fr, De, gr, Vr) {
                    this.sourceFiles = nr, this.sourceFilesSet = Mr, this.specialSearchKind = Pe, this.checker = Ue, this.cancellationToken = fr, this.searchMeaning = De, this.options = gr, this.result = Vr, this.inheritsFromCache = new e.Map(), this.markSeenContainingTypeReference = e.nodeSeenTracker(), this.markSeenReExportRHS = e.nodeSeenTracker(), this.symbolIdToReferences = [], this.sourceFileToSeenSymbols = [];
                  }
                  return Oe.prototype.includesSourceFile = function(nr) {
                    return this.sourceFilesSet.has(nr.fileName);
                  }, Oe.prototype.getImportSearches = function(nr, Mr) {
                    return this.importTracker || (this.importTracker = C.createImportTracker(this.sourceFiles, this.sourceFilesSet, this.checker, this.cancellationToken)), this.importTracker(nr, Mr, this.options.use === 2);
                  }, Oe.prototype.createSearch = function(nr, Mr, Pe, Ue) {
                    Ue === void 0 && (Ue = {});
                    var fr = Ue.text, De = fr === void 0 ? e.stripQuotes(e.symbolName(e.getLocalSymbolForExportDefault(Mr) || ge(Mr) || Mr)) : fr, gr = Ue.allSearchSymbols, Vr = gr === void 0 ? [Mr] : gr, Tr = e.escapeLeadingUnderscores(De), vi = this.options.implementations && nr ? mr(nr, Mr, this.checker) : void 0;
                    return { symbol: Mr, comingFrom: Pe, text: De, escapedText: Tr, parents: vi, allSearchSymbols: Vr, includes: function(Ui) {
                      return e.contains(Vr, Ui);
                    } };
                  }, Oe.prototype.referenceAdder = function(nr) {
                    var Mr = e.getSymbolId(nr), Pe = this.symbolIdToReferences[Mr];
                    return Pe || (Pe = this.symbolIdToReferences[Mr] = [], this.result.push({ definition: { type: 0, symbol: nr }, references: Pe })), function(Ue, fr) {
                      return Pe.push(E(Ue, fr));
                    };
                  }, Oe.prototype.addStringOrCommentReference = function(nr, Mr) {
                    this.result.push({ definition: void 0, references: [{ kind: 0, fileName: nr, textSpan: Mr }] });
                  }, Oe.prototype.markSearchedSymbols = function(nr, Mr) {
                    for (var Pe = e.getNodeId(nr), Ue = this.sourceFileToSeenSymbols[Pe] || (this.sourceFileToSeenSymbols[Pe] = new e.Set()), fr = false, De = 0, gr = Mr; De < gr.length; De++) {
                      var Vr = gr[De];
                      fr = e.tryAddToSet(Ue, e.getSymbolId(Vr)) || fr;
                    }
                    return fr;
                  }, Oe;
                }();
                function ze(Oe, nr, Mr, Pe) {
                  var Ue = Pe.getImportSearches(nr, Mr), fr = Ue.importSearches, De = Ue.singleReferences, gr = Ue.indirectUsers;
                  if (De.length) for (var Vr = Pe.referenceAdder(nr), Tr = 0, vi = De; Tr < vi.length; Tr++) {
                    var Ui = vi[Tr];
                    He(Ui, Pe) && Vr(Ui);
                  }
                  for (var Yi = 0, Wi = fr; Yi < Wi.length; Yi++) {
                    var ct = Wi[Yi], Li = ct[0], nt = ct[1];
                    n(Li.getSourceFile(), Pe.createSearch(Li, nt, 1), Pe);
                  }
                  if (gr.length) {
                    var Mt = void 0;
                    switch (Mr.exportKind) {
                      case 0:
                        Mt = Pe.createSearch(Oe, nr, 1);
                        break;
                      case 1:
                        Mt = Pe.options.use === 2 ? void 0 : Pe.createSearch(Oe, nr, 1, { text: "default" });
                        break;
                      case 2:
                        break;
                    }
                    if (Mt) for (var xt = 0, ut = gr; xt < ut.length; xt++) {
                      var Dt = ut[xt];
                      Ie(Dt, Mt, Pe);
                    }
                  }
                }
                function Ee(Oe, nr, Mr, Pe, Ue, fr, De, gr) {
                  for (var Vr = C.createImportTracker(Oe, new e.Set(Oe.map(function(wt) {
                    return wt.fileName;
                  })), nr, Mr), Tr = Vr(Pe, { exportKind: De ? 1 : 0, exportingModuleSymbol: Ue }, false), vi = Tr.importSearches, Ui = Tr.indirectUsers, Yi = Tr.singleReferences, Wi = 0, ct = vi; Wi < ct.length; Wi++) {
                    var Li = ct[Wi][0];
                    gr(Li);
                  }
                  for (var nt = 0, Mt = Yi; nt < Mt.length; nt++) {
                    var xt = Mt[nt];
                    e.isIdentifier(xt) && e.isImportTypeNode(xt.parent) && gr(xt);
                  }
                  for (var ut = 0, Dt = Ui; ut < Dt.length; ut++) for (var Rt = Dt[ut], Ii = 0, Ki = ir(Rt, De ? "default" : fr); Ii < Ki.length; Ii++) {
                    var Fi = Ki[Ii], ui = nr.getSymbolAtLocation(Fi), Bt = e.some(ui == null ? void 0 : ui.declarations, function(wt) {
                      return !!e.tryCast(wt, e.isExportAssignment);
                    });
                    e.isIdentifier(Fi) && !e.isImportOrExportSpecifier(Fi.parent) && (ui === Pe || Bt) && gr(Fi);
                  }
                }
                k.eachExportReference = Ee;
                function He(Oe, nr) {
                  return be(Oe, nr) ? nr.options.use !== 2 ? true : e.isIdentifier(Oe) ? !(e.isImportOrExportSpecifier(Oe.parent) && Oe.escapedText === "default") : false : false;
                }
                function rr(Oe, nr) {
                  if (!!Oe.declarations) for (var Mr = 0, Pe = Oe.declarations; Mr < Pe.length; Mr++) {
                    var Ue = Pe[Mr], fr = Ue.getSourceFile();
                    n(fr, nr.createSearch(Ue, Oe, 0), nr, nr.includesSourceFile(fr));
                  }
                }
                function Ie(Oe, nr, Mr) {
                  e.getNameTable(Oe).get(nr.escapedText) !== void 0 && n(Oe, nr, Mr);
                }
                function _e(Oe, nr) {
                  return e.isArrayLiteralOrObjectLiteralDestructuringPattern(Oe.parent.parent) ? nr.getPropertySymbolOfDestructuringAssignment(Oe) : void 0;
                }
                function we(Oe) {
                  var nr = Oe.declarations, Mr = Oe.flags, Pe = Oe.parent, Ue = Oe.valueDeclaration;
                  if (Ue && (Ue.kind === 213 || Ue.kind === 226)) return Ue;
                  if (!!nr) {
                    if (Mr & 8196) {
                      var fr = e.find(nr, function(Wi) {
                        return e.hasEffectiveModifier(Wi, 8) || e.isPrivateIdentifierClassElementDeclaration(Wi);
                      });
                      return fr ? e.getAncestor(fr, 257) : void 0;
                    }
                    if (!nr.some(e.isObjectBindingElementWithoutPropertyName)) {
                      var De = Pe && !(Oe.flags & 262144);
                      if (!(De && !(e.isExternalModuleSymbol(Pe) && !Pe.globalExports))) {
                        for (var gr, Vr = 0, Tr = nr; Vr < Tr.length; Vr++) {
                          var vi = Tr[Vr], Ui = e.getContainerNode(vi);
                          if (gr && gr !== Ui || !Ui || Ui.kind === 305 && !e.isExternalOrCommonJsModule(Ui)) return;
                          if (gr = Ui, e.isFunctionExpression(gr)) for (var Yi = void 0; Yi = e.getNextJSDocCommentLocation(gr); ) gr = Yi;
                        }
                        return De ? gr.getSourceFile() : gr;
                      }
                    }
                  }
                }
                function de(Oe, nr, Mr, Pe) {
                  return Pe === void 0 && (Pe = Mr), ye(Oe, nr, Mr, function() {
                    return true;
                  }, Pe) || false;
                }
                k.isSymbolReferencedInFile = de;
                function ye(Oe, nr, Mr, Pe, Ue) {
                  Ue === void 0 && (Ue = Mr);
                  var fr = e.isParameterPropertyDeclaration(Oe.parent, Oe.parent.parent) ? e.first(nr.getSymbolsOfParameterPropertyDeclaration(Oe.parent, Oe.text)) : nr.getSymbolAtLocation(Oe);
                  if (!!fr) for (var De = 0, gr = ir(Mr, fr.name, Ue); De < gr.length; De++) {
                    var Vr = gr[De];
                    if (!(!e.isIdentifier(Vr) || Vr === Oe || Vr.escapedText !== Oe.escapedText)) {
                      var Tr = nr.getSymbolAtLocation(Vr);
                      if (Tr === fr || nr.getShorthandAssignmentValueSymbol(Vr.parent) === fr || e.isExportSpecifier(Vr.parent) && yr(Vr, Tr, Vr.parent, nr) === fr) {
                        var vi = Pe(Vr);
                        if (vi) return vi;
                      }
                    }
                  }
                }
                k.eachSymbolReferenceInFile = ye;
                function Ae(Oe, nr) {
                  var Mr = e.filter(ir(nr, Oe), function(Ue) {
                    return !!e.getDeclarationFromName(Ue);
                  });
                  return Mr.reduce(function(Ue, fr) {
                    var De = Pe(fr);
                    return !e.some(Ue.declarationNames) || De === Ue.depth ? (Ue.declarationNames.push(fr), Ue.depth = De) : De < Ue.depth && (Ue.declarationNames = [fr], Ue.depth = De), Ue;
                  }, { depth: 1 / 0, declarationNames: [] }).declarationNames;
                  function Pe(Ue) {
                    for (var fr = 0; Ue; ) Ue = e.getContainerNode(Ue), fr++;
                    return fr;
                  }
                }
                k.getTopMostDeclarationNamesInFile = Ae;
                function er(Oe, nr, Mr, Pe) {
                  if (!Oe.name || !e.isIdentifier(Oe.name)) return false;
                  for (var Ue = e.Debug.checkDefined(Mr.getSymbolAtLocation(Oe.name)), fr = 0, De = nr; fr < De.length; fr++) for (var gr = De[fr], Vr = 0, Tr = ir(gr, Ue.name); Vr < Tr.length; Vr++) {
                    var vi = Tr[Vr];
                    if (!(!e.isIdentifier(vi) || vi === Oe.name || vi.escapedText !== Oe.name.escapedText)) {
                      var Ui = e.climbPastPropertyAccess(vi), Yi = e.isCallExpression(Ui.parent) && Ui.parent.expression === Ui ? Ui.parent : void 0, Wi = Mr.getSymbolAtLocation(vi);
                      if (Wi && Mr.getRootSymbols(Wi).some(function(ct) {
                        return ct === Ue;
                      }) && Pe(vi, Yi)) return true;
                    }
                  }
                  return false;
                }
                k.someSignatureUsage = er;
                function ir(Oe, nr, Mr) {
                  return Mr === void 0 && (Mr = Oe), Cr(Oe, nr, Mr).map(function(Pe) {
                    return e.getTouchingPropertyName(Oe, Pe);
                  });
                }
                function Cr(Oe, nr, Mr) {
                  Mr === void 0 && (Mr = Oe);
                  var Pe = [];
                  if (!nr || !nr.length) return Pe;
                  for (var Ue = Oe.text, fr = Ue.length, De = nr.length, gr = Ue.indexOf(nr, Mr.pos); gr >= 0 && !(gr > Mr.end); ) {
                    var Vr = gr + De;
                    (gr === 0 || !e.isIdentifierPart(Ue.charCodeAt(gr - 1), 99)) && (Vr === fr || !e.isIdentifierPart(Ue.charCodeAt(Vr), 99)) && Pe.push(gr), gr = Ue.indexOf(nr, gr + De + 1);
                  }
                  return Pe;
                }
                function Ye(Oe, nr) {
                  var Mr = Oe.getSourceFile(), Pe = nr.text, Ue = e.mapDefined(ir(Mr, Pe, Oe), function(fr) {
                    return fr === nr || e.isJumpStatementTarget(fr) && e.getTargetLabel(fr, Pe) === nr ? E(fr) : void 0;
                  });
                  return [{ definition: { type: 1, node: nr }, references: Ue }];
                }
                function Br(Oe, nr) {
                  switch (Oe.kind) {
                    case 80:
                      if (e.isJSDocMemberName(Oe.parent)) return true;
                    case 79:
                      return Oe.text.length === nr.length;
                    case 14:
                    case 10: {
                      var Mr = Oe;
                      return (e.isLiteralNameOfPropertyDeclarationOrIndexAccess(Mr) || e.isNameOfModuleDeclaration(Oe) || e.isExpressionOfExternalModuleImportEqualsDeclaration(Oe) || e.isCallExpression(Oe.parent) && e.isBindableObjectDefinePropertyCall(Oe.parent) && Oe.parent.arguments[1] === Oe) && Mr.text.length === nr.length;
                    }
                    case 8:
                      return e.isLiteralNameOfPropertyDeclarationOrIndexAccess(Oe) && Oe.text.length === nr.length;
                    case 88:
                      return nr.length === 7;
                    default:
                      return false;
                  }
                }
                function Er(Oe, nr) {
                  var Mr = e.flatMap(Oe, function(Pe) {
                    return nr.throwIfCancellationRequested(), e.mapDefined(ir(Pe, "meta", Pe), function(Ue) {
                      var fr = Ue.parent;
                      if (e.isImportMeta(fr)) return E(fr);
                    });
                  });
                  return Mr.length ? [{ definition: { type: 2, node: Mr[0].node }, references: Mr }] : void 0;
                }
                function Ne(Oe, nr, Mr, Pe) {
                  var Ue = e.flatMap(Oe, function(fr) {
                    return Mr.throwIfCancellationRequested(), e.mapDefined(ir(fr, e.tokenToString(nr), fr), function(De) {
                      if (De.kind === nr && (!Pe || Pe(De))) return E(De);
                    });
                  });
                  return Ue.length ? [{ definition: { type: 2, node: Ue[0].node }, references: Ue }] : void 0;
                }
                function n(Oe, nr, Mr, Pe) {
                  return Pe === void 0 && (Pe = true), Mr.cancellationToken.throwIfCancellationRequested(), lr(Oe, Oe, nr, Mr, Pe);
                }
                function lr(Oe, nr, Mr, Pe, Ue) {
                  if (!!Pe.markSearchedSymbols(nr, Mr.allSearchSymbols)) for (var fr = 0, De = Cr(nr, Mr.text, Oe); fr < De.length; fr++) {
                    var gr = De[fr];
                    Ge(nr, gr, Mr, Pe, Ue);
                  }
                }
                function be(Oe, nr) {
                  return !!(e.getMeaningFromLocation(Oe) & nr.searchMeaning);
                }
                function Ge(Oe, nr, Mr, Pe, Ue) {
                  var fr = e.getTouchingPropertyName(Oe, nr);
                  if (!Br(fr, Mr.text)) {
                    !Pe.options.implementations && (Pe.options.findInStrings && e.isInString(Oe, nr) || Pe.options.findInComments && e.isInNonReferenceComment(Oe, nr)) && Pe.addStringOrCommentReference(Oe.fileName, e.createTextSpan(nr, Mr.text.length));
                    return;
                  }
                  if (!!be(fr, Pe)) {
                    var De = Pe.checker.getSymbolAtLocation(fr);
                    if (!!De) {
                      var gr = fr.parent;
                      if (!(e.isImportSpecifier(gr) && gr.propertyName === fr)) {
                        if (e.isExportSpecifier(gr)) {
                          e.Debug.assert(fr.kind === 79), ur(fr, De, gr, Mr, Pe, Ue);
                          return;
                        }
                        var Vr = Sr(Mr, De, fr, Pe);
                        if (!Vr) {
                          Ur(De, Mr, Pe);
                          return;
                        }
                        switch (Pe.specialSearchKind) {
                          case 0:
                            Ue && ii(fr, Vr, Pe);
                            break;
                          case 1:
                            mi(fr, Oe, Mr, Pe);
                            break;
                          case 2:
                            pe(fr, Mr, Pe);
                            break;
                          default:
                            e.Debug.assertNever(Pe.specialSearchKind);
                        }
                        e.isInJSFile(fr) && fr.parent.kind === 203 && e.isVariableDeclarationInitializedToBareOrAccessedRequire(fr.parent) && (De = fr.parent.symbol, !De) || wr(fr, De, Mr, Pe);
                      }
                    }
                  }
                }
                function ur(Oe, nr, Mr, Pe, Ue, fr, De) {
                  e.Debug.assert(!De || !!Ue.options.providePrefixAndSuffixTextForRename, "If alwaysGetReferences is true, then prefix/suffix text must be enabled");
                  var gr = Mr.parent, Vr = Mr.propertyName, Tr = Mr.name, vi = gr.parent, Ui = yr(Oe, nr, Mr, Ue.checker);
                  if (!De && !Pe.includes(Ui)) return;
                  if (Vr ? Oe === Vr ? (vi.moduleSpecifier || Mt(), fr && Ue.options.use !== 2 && Ue.markSeenReExportRHS(Tr) && ii(Tr, e.Debug.checkDefined(Mr.symbol), Ue)) : Ue.markSeenReExportRHS(Oe) && Mt() : Ue.options.use === 2 && Tr.escapedText === "default" || Mt(), !Ar(Ue.options) || De) {
                    var Yi = Oe.originalKeywordKind === 88 || Mr.name.originalKeywordKind === 88, Wi = Yi ? 1 : 0, ct = e.Debug.checkDefined(Mr.symbol), Li = C.getExportInfo(ct, Wi, Ue.checker);
                    Li && ze(Oe, ct, Li, Ue);
                  }
                  if (Pe.comingFrom !== 1 && vi.moduleSpecifier && !Vr && !Ar(Ue.options)) {
                    var nt = Ue.checker.getExportSpecifierLocalTargetSymbol(Mr);
                    nt && rr(nt, Ue);
                  }
                  function Mt() {
                    fr && ii(Oe, Ui, Ue);
                  }
                }
                function yr(Oe, nr, Mr, Pe) {
                  return Ir(Oe, Mr) && Pe.getExportSpecifierLocalTargetSymbol(Mr) || nr;
                }
                function Ir(Oe, nr) {
                  var Mr = nr.parent, Pe = nr.propertyName, Ue = nr.name;
                  return e.Debug.assert(Pe === Oe || Ue === Oe), Pe ? Pe === Oe : !Mr.parent.moduleSpecifier;
                }
                function wr(Oe, nr, Mr, Pe) {
                  var Ue = C.getImportOrExportSymbol(Oe, nr, Pe.checker, Mr.comingFrom === 1);
                  if (!!Ue) {
                    var fr = Ue.symbol;
                    Ue.kind === 0 ? Ar(Pe.options) || rr(fr, Pe) : ze(Oe, fr, Ue.exportInfo, Pe);
                  }
                }
                function Ur(Oe, nr, Mr) {
                  var Pe = Oe.flags, Ue = Oe.valueDeclaration, fr = Mr.checker.getShorthandAssignmentValueSymbol(Ue), De = Ue && e.getNameOfDeclaration(Ue);
                  !(Pe & 33554432) && De && nr.includes(fr) && ii(De, fr, Mr);
                }
                function ii(Oe, nr, Mr) {
                  var Pe = "kind" in nr ? nr : { kind: void 0, symbol: nr }, Ue = Pe.kind, fr = Pe.symbol;
                  if (!(Mr.options.use === 2 && Oe.kind === 88)) {
                    var De = Mr.referenceAdder(fr);
                    Mr.options.implementations ? Xi(Oe, De, Mr) : De(Oe, Ue);
                  }
                }
                function mi(Oe, nr, Mr, Pe) {
                  e.isNewExpressionTarget(Oe) && ii(Oe, Mr.symbol, Pe);
                  var Ue = function() {
                    return Pe.referenceAdder(Mr.symbol);
                  };
                  if (e.isClassLike(Oe.parent)) e.Debug.assert(Oe.kind === 88 || Oe.parent.name === Oe), or(Mr.symbol, nr, Ue());
                  else {
                    var fr = vr(Oe);
                    fr && (si(fr, Ue()), wi(fr, Pe));
                  }
                }
                function pe(Oe, nr, Mr) {
                  ii(Oe, nr.symbol, Mr);
                  var Pe = Oe.parent;
                  if (!(Mr.options.use === 2 || !e.isClassLike(Pe))) {
                    e.Debug.assert(Pe.name === Oe);
                    for (var Ue = Mr.referenceAdder(nr.symbol), fr = 0, De = Pe.members; fr < De.length; fr++) {
                      var gr = De[fr];
                      !(e.isMethodOrAccessor(gr) && e.isStatic(gr)) || gr.body && gr.body.forEachChild(function Vr(Tr) {
                        Tr.kind === 108 ? Ue(Tr) : !e.isFunctionLike(Tr) && !e.isClassLike(Tr) && Tr.forEachChild(Vr);
                      });
                    }
                  }
                }
                function or(Oe, nr, Mr) {
                  var Pe = qr(Oe);
                  if (Pe && Pe.declarations) for (var Ue = 0, fr = Pe.declarations; Ue < fr.length; Ue++) {
                    var De = fr[Ue], gr = e.findChildOfKind(De, 134, nr);
                    e.Debug.assert(De.kind === 171 && !!gr), Mr(gr);
                  }
                  Oe.exports && Oe.exports.forEach(function(Vr) {
                    var Tr = Vr.valueDeclaration;
                    if (Tr && Tr.kind === 169) {
                      var vi = Tr.body;
                      vi && xe(vi, 108, function(Ui) {
                        e.isNewExpressionTarget(Ui) && Mr(Ui);
                      });
                    }
                  });
                }
                function qr(Oe) {
                  return Oe.members && Oe.members.get("__constructor");
                }
                function si(Oe, nr) {
                  var Mr = qr(Oe.symbol);
                  if (!!(Mr && Mr.declarations)) for (var Pe = 0, Ue = Mr.declarations; Pe < Ue.length; Pe++) {
                    var fr = Ue[Pe];
                    e.Debug.assert(fr.kind === 171);
                    var De = fr.body;
                    De && xe(De, 106, function(gr) {
                      e.isCallExpressionTarget(gr) && nr(gr);
                    });
                  }
                }
                function Di(Oe) {
                  return !!qr(Oe.symbol);
                }
                function wi(Oe, nr) {
                  if (!Di(Oe)) {
                    var Mr = Oe.symbol, Pe = nr.createSearch(void 0, Mr, void 0);
                    We(Mr, nr, Pe);
                  }
                }
                function Xi(Oe, nr, Mr) {
                  if (e.isDeclarationName(Oe) && Wr(Oe.parent)) {
                    nr(Oe);
                    return;
                  }
                  if (Oe.kind !== 79) return;
                  Oe.parent.kind === 297 && Je(Oe, Mr.checker, nr);
                  var Pe = et(Oe);
                  if (Pe) {
                    nr(Pe);
                    return;
                  }
                  var Ue = e.findAncestor(Oe, function(Vr) {
                    return !e.isQualifiedName(Vr.parent) && !e.isTypeNode(Vr.parent) && !e.isTypeElement(Vr.parent);
                  }), fr = Ue.parent;
                  if (e.hasType(fr) && fr.type === Ue && Mr.markSeenContainingTypeReference(fr)) if (e.hasInitializer(fr)) gr(fr.initializer);
                  else if (e.isFunctionLike(fr) && fr.body) {
                    var De = fr.body;
                    De.kind === 235 ? e.forEachReturnStatement(De, function(Vr) {
                      Vr.expression && gr(Vr.expression);
                    }) : gr(De);
                  } else e.isAssertionExpression(fr) && gr(fr.expression);
                  function gr(Vr) {
                    Gi(Vr) && nr(Vr);
                  }
                }
                function et(Oe) {
                  return e.isIdentifier(Oe) || e.isPropertyAccessExpression(Oe) ? et(Oe.parent) : e.isExpressionWithTypeArguments(Oe) ? e.tryCast(Oe.parent.parent, e.isClassLike) : void 0;
                }
                function Gi(Oe) {
                  switch (Oe.kind) {
                    case 212:
                      return Gi(Oe.expression);
                    case 214:
                    case 213:
                    case 205:
                    case 226:
                    case 204:
                      return true;
                    default:
                      return false;
                  }
                }
                function Wt(Oe, nr, Mr, Pe) {
                  if (Oe === nr) return true;
                  var Ue = e.getSymbolId(Oe) + "," + e.getSymbolId(nr), fr = Mr.get(Ue);
                  if (fr !== void 0) return fr;
                  Mr.set(Ue, false);
                  var De = !!Oe.declarations && Oe.declarations.some(function(gr) {
                    return e.getAllSuperTypeNodes(gr).some(function(Vr) {
                      var Tr = Pe.getTypeAtLocation(Vr);
                      return !!Tr && !!Tr.symbol && Wt(Tr.symbol, nr, Mr, Pe);
                    });
                  });
                  return Mr.set(Ue, De), De;
                }
                function Zt(Oe) {
                  var nr = e.getSuperContainer(Oe, false);
                  if (!!nr) {
                    var Mr = 32;
                    switch (nr.kind) {
                      case 167:
                      case 166:
                      case 169:
                      case 168:
                      case 171:
                      case 172:
                      case 173:
                        Mr &= e.getSyntacticModifierFlags(nr), nr = nr.parent;
                        break;
                      default:
                        return;
                    }
                    var Pe = nr.getSourceFile(), Ue = e.mapDefined(ir(Pe, "super", nr), function(fr) {
                      if (fr.kind === 106) {
                        var De = e.getSuperContainer(fr, false);
                        return De && e.isStatic(De) === !!Mr && De.parent.symbol === nr.symbol ? E(fr) : void 0;
                      }
                    });
                    return [{ definition: { type: 0, symbol: nr.symbol }, references: Ue }];
                  }
                }
                function _r(Oe) {
                  return Oe.kind === 79 && Oe.parent.kind === 164 && Oe.parent.name === Oe;
                }
                function pi(Oe, nr, Mr) {
                  var Pe = e.getThisContainer(Oe, false), Ue = 32;
                  switch (Pe.kind) {
                    case 169:
                    case 168:
                      if (e.isObjectLiteralMethod(Pe)) {
                        Ue &= e.getSyntacticModifierFlags(Pe), Pe = Pe.parent;
                        break;
                      }
                    case 167:
                    case 166:
                    case 171:
                    case 172:
                    case 173:
                      Ue &= e.getSyntacticModifierFlags(Pe), Pe = Pe.parent;
                      break;
                    case 305:
                      if (e.isExternalModule(Pe) || _r(Oe)) return;
                    case 256:
                    case 213:
                      break;
                    default:
                      return;
                  }
                  var fr = e.flatMap(Pe.kind === 305 ? nr : [Pe.getSourceFile()], function(gr) {
                    return Mr.throwIfCancellationRequested(), ir(gr, "this", e.isSourceFile(Pe) ? gr : Pe).filter(function(Vr) {
                      if (!e.isThis(Vr)) return false;
                      var Tr = e.getThisContainer(Vr, false);
                      switch (Pe.kind) {
                        case 213:
                        case 256:
                          return Pe.symbol === Tr.symbol;
                        case 169:
                        case 168:
                          return e.isObjectLiteralMethod(Pe) && Pe.symbol === Tr.symbol;
                        case 226:
                        case 257:
                        case 205:
                          return Tr.parent && Pe.symbol === Tr.parent.symbol && e.isStatic(Tr) === !!Ue;
                        case 305:
                          return Tr.kind === 305 && !e.isExternalModule(Tr) && !_r(Vr);
                      }
                    });
                  }).map(function(gr) {
                    return E(gr);
                  }), De = e.firstDefined(fr, function(gr) {
                    return e.isParameter(gr.node.parent) ? gr.node : void 0;
                  });
                  return [{ definition: { type: 3, node: De || Oe }, references: fr }];
                }
                function ae(Oe, nr, Mr, Pe) {
                  var Ue = e.getContextualTypeFromParentOrAncestorTypeNode(Oe, Mr), fr = e.flatMap(nr, function(De) {
                    return Pe.throwIfCancellationRequested(), e.mapDefined(ir(De, Oe.text), function(gr) {
                      if (e.isStringLiteralLike(gr) && gr.text === Oe.text) if (Ue) {
                        var Vr = e.getContextualTypeFromParentOrAncestorTypeNode(gr, Mr);
                        if (Ue !== Mr.getStringType() && Ue === Vr) return E(gr, 2);
                      } else return e.isNoSubstitutionTemplateLiteral(gr) && !e.rangeIsOnSingleLine(gr, De) ? void 0 : E(gr, 2);
                    });
                  });
                  return [{ definition: { type: 4, node: Oe }, references: fr }];
                }
                function Xe(Oe, nr, Mr, Pe, Ue, fr) {
                  var De = [];
                  return Jr(Oe, nr, Mr, Pe, !(Pe && Ue), function(gr, Vr, Tr) {
                    Tr && Ze(Oe) !== Ze(Tr) && (Tr = void 0), De.push(Tr || Vr || gr);
                  }, function() {
                    return !fr;
                  }), De;
                }
                function Jr(Oe, nr, Mr, Pe, Ue, fr, De) {
                  var gr = e.getContainingObjectLiteralElement(nr);
                  if (gr) {
                    var Vr = Mr.getShorthandAssignmentValueSymbol(nr.parent);
                    if (Vr && Pe) return fr(Vr, void 0, void 0, 3);
                    var Tr = Mr.getContextualType(gr.parent), vi = Tr && e.firstDefined(e.getPropertySymbolsFromContextualType(gr, Mr, Tr, true), function(ui) {
                      return Ki(ui, 4);
                    });
                    if (vi) return vi;
                    var Ui = _e(nr, Mr), Yi = Ui && fr(Ui, void 0, void 0, 4);
                    if (Yi) return Yi;
                    var Wi = Vr && fr(Vr, void 0, void 0, 3);
                    if (Wi) return Wi;
                  }
                  var ct = I(nr, Oe, Mr);
                  if (ct) {
                    var Li = fr(ct, void 0, void 0, 1);
                    if (Li) return Li;
                  }
                  var nt = Ki(Oe);
                  if (nt) return nt;
                  if (Oe.valueDeclaration && e.isParameterPropertyDeclaration(Oe.valueDeclaration, Oe.valueDeclaration.parent)) {
                    var Mt = Mr.getSymbolsOfParameterPropertyDeclaration(e.cast(Oe.valueDeclaration, e.isParameter), Oe.name);
                    return e.Debug.assert(Mt.length === 2 && !!(Mt[0].flags & 1) && !!(Mt[1].flags & 4)), Ki(Oe.flags & 1 ? Mt[1] : Mt[0]);
                  }
                  var xt = e.getDeclarationOfKind(Oe, 275);
                  if (!Pe || xt && !xt.propertyName) {
                    var ut = xt && Mr.getExportSpecifierLocalTargetSymbol(xt);
                    if (ut) {
                      var Dt = fr(ut, void 0, void 0, 1);
                      if (Dt) return Dt;
                    }
                  }
                  if (!Pe) {
                    var Rt = void 0;
                    return Ue ? Rt = e.isObjectBindingElementWithoutPropertyName(nr.parent) ? e.getPropertySymbolFromBindingElement(Mr, nr.parent) : void 0 : Rt = Fi(Oe, Mr), Rt && Ki(Rt, 4);
                  }
                  e.Debug.assert(Pe);
                  var Ii = Ue;
                  if (Ii) {
                    var Rt = Fi(Oe, Mr);
                    return Rt && Ki(Rt, 4);
                  }
                  function Ki(ui, Bt) {
                    return e.firstDefined(Mr.getRootSymbols(ui), function(wt) {
                      return fr(ui, wt, void 0, Bt) || (wt.parent && wt.parent.flags & 96 && De(wt) ? ti(wt.parent, wt.name, Mr, function(na) {
                        return fr(ui, wt, na, Bt);
                      }) : void 0);
                    });
                  }
                  function Fi(ui, Bt) {
                    var wt = e.getDeclarationOfKind(ui, 203);
                    if (wt && e.isObjectBindingElementWithoutPropertyName(wt)) return e.getPropertySymbolFromBindingElement(Bt, wt);
                  }
                }
                function ti(Oe, nr, Mr, Pe) {
                  var Ue = new e.Map();
                  return fr(Oe);
                  function fr(De) {
                    if (!(!(De.flags & 96) || !e.addToSeen(Ue, e.getSymbolId(De)))) return e.firstDefined(De.declarations, function(gr) {
                      return e.firstDefined(e.getAllSuperTypeNodes(gr), function(Vr) {
                        var Tr = Mr.getTypeAtLocation(Vr), vi = Tr && Tr.symbol && Mr.getPropertyOfType(Tr, nr);
                        return Tr && vi && (e.firstDefined(Mr.getRootSymbols(vi), Pe) || fr(Tr.symbol));
                      });
                    });
                  }
                }
                function Ze(Oe) {
                  if (!Oe.valueDeclaration) return false;
                  var nr = e.getEffectiveModifierFlags(Oe.valueDeclaration);
                  return !!(nr & 32);
                }
                function Sr(Oe, nr, Mr, Pe) {
                  var Ue = Pe.checker;
                  return Jr(nr, Mr, Ue, false, Pe.options.use !== 2 || !!Pe.options.providePrefixAndSuffixTextForRename, function(fr, De, gr, Vr) {
                    return gr && Ze(nr) !== Ze(gr) && (gr = void 0), Oe.includes(gr || De || fr) ? { symbol: De && !(e.getCheckFlags(fr) & 6) ? De : fr, kind: Vr } : void 0;
                  }, function(fr) {
                    return !(Oe.parents && !Oe.parents.some(function(De) {
                      return Wt(fr.parent, De, Pe.inheritsFromCache, Ue);
                    }));
                  });
                }
                function zr(Oe, nr) {
                  var Mr = e.getMeaningFromLocation(Oe), Pe = nr.declarations;
                  if (Pe) {
                    var Ue = void 0;
                    do {
                      Ue = Mr;
                      for (var fr = 0, De = Pe; fr < De.length; fr++) {
                        var gr = De[fr], Vr = e.getMeaningFromDeclaration(gr);
                        Vr & Mr && (Mr |= Vr);
                      }
                    } while (Mr !== Ue);
                  }
                  return Mr;
                }
                k.getIntersectingMeaningFromDeclarations = zr;
                function Wr(Oe) {
                  return Oe.flags & 16777216 ? !(e.isInterfaceDeclaration(Oe) || e.isTypeAliasDeclaration(Oe)) : e.isVariableLike(Oe) ? e.hasInitializer(Oe) : e.isFunctionLikeDeclaration(Oe) ? !!Oe.body : e.isClassLike(Oe) || e.isModuleOrEnumDeclaration(Oe);
                }
                function Je(Oe, nr, Mr) {
                  var Pe = nr.getSymbolAtLocation(Oe), Ue = nr.getShorthandAssignmentValueSymbol(Pe.valueDeclaration);
                  if (Ue) for (var fr = 0, De = Ue.getDeclarations(); fr < De.length; fr++) {
                    var gr = De[fr];
                    e.getMeaningFromDeclaration(gr) & 1 && Mr(gr);
                  }
                }
                k.getReferenceEntriesForShorthandPropertyAssignment = Je;
                function xe(Oe, nr, Mr) {
                  e.forEachChild(Oe, function(Pe) {
                    Pe.kind === nr && Mr(Pe), xe(Pe, nr, Mr);
                  });
                }
                function vr(Oe) {
                  return e.tryGetClassExtendingExpressionWithTypeArguments(e.climbPastPropertyAccess(Oe).parent);
                }
                function mr(Oe, nr, Mr) {
                  var Pe = e.isRightSideOfPropertyAccess(Oe) ? Oe.parent : void 0, Ue = Pe && Mr.getTypeAtLocation(Pe.expression), fr = e.mapDefined(Ue && (Ue.isUnionOrIntersection() ? Ue.types : Ue.symbol === nr.parent ? void 0 : [Ue]), function(De) {
                    return De.symbol && De.symbol.flags & 96 ? De.symbol : void 0;
                  });
                  return fr.length === 0 ? void 0 : fr;
                }
                function Ar(Oe) {
                  return Oe.use === 2 && Oe.providePrefixAndSuffixTextForRename;
                }
              })(P = C.Core || (C.Core = {}));
            })(a = e.FindAllReferences || (e.FindAllReferences = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w(L) {
                return (e.isFunctionExpression(L) || e.isClassExpression(L)) && e.isNamedDeclaration(L);
              }
              function B(L) {
                return (e.isFunctionExpression(L) || e.isArrowFunction(L) || e.isClassExpression(L)) && e.isVariableDeclaration(L.parent) && L === L.parent.initializer && e.isIdentifier(L.parent.name) && !!(e.getCombinedNodeFlags(L.parent) & 2);
              }
              function E(L) {
                return e.isSourceFile(L) || e.isModuleDeclaration(L) || e.isFunctionDeclaration(L) || e.isFunctionExpression(L) || e.isClassDeclaration(L) || e.isClassExpression(L) || e.isClassStaticBlockDeclaration(L) || e.isMethodDeclaration(L) || e.isMethodSignature(L) || e.isGetAccessorDeclaration(L) || e.isSetAccessorDeclaration(L);
              }
              function Q(L) {
                return e.isSourceFile(L) || e.isModuleDeclaration(L) && e.isIdentifier(L.name) || e.isFunctionDeclaration(L) || e.isClassDeclaration(L) || e.isClassStaticBlockDeclaration(L) || e.isMethodDeclaration(L) || e.isMethodSignature(L) || e.isGetAccessorDeclaration(L) || e.isSetAccessorDeclaration(L) || w(L) || B(L);
              }
              function le(L) {
                return e.isSourceFile(L) ? L : e.isNamedDeclaration(L) ? L.name : B(L) ? L.parent.name : e.Debug.checkDefined(L.modifiers && e.find(L.modifiers, N));
              }
              function N(L) {
                return L.kind === 88;
              }
              function p(L, P) {
                var k = le(P);
                return k && L.getSymbolAtLocation(k);
              }
              function m(L, P) {
                if (e.isSourceFile(P)) return { text: P.fileName, pos: 0, end: 0 };
                if ((e.isFunctionDeclaration(P) || e.isClassDeclaration(P)) && !e.isNamedDeclaration(P)) {
                  var k = P.modifiers && e.find(P.modifiers, N);
                  if (k) return { text: "default", pos: k.getStart(), end: k.getEnd() };
                }
                if (e.isClassStaticBlockDeclaration(P)) {
                  var Y = P.getSourceFile(), U = e.skipTrivia(Y.text, e.moveRangePastModifiers(P).pos), j = U + 6, H = L.getTypeChecker(), I = H.getSymbolAtLocation(P.parent), l = I ? "".concat(H.symbolToString(I, P.parent), " ") : "";
                  return { text: "".concat(l, "static {}"), pos: U, end: j };
                }
                var d = B(P) ? P.parent.name : e.Debug.checkDefined(e.getNameOfDeclaration(P), "Expected call hierarchy item to have a name"), D = e.isIdentifier(d) ? e.idText(d) : e.isStringOrNumericLiteralLike(d) ? d.text : e.isComputedPropertyName(d) && e.isStringOrNumericLiteralLike(d.expression) ? d.expression.text : void 0;
                if (D === void 0) {
                  var H = L.getTypeChecker(), I = H.getSymbolAtLocation(d);
                  I && (D = H.symbolToString(I, P));
                }
                if (D === void 0) {
                  var fe = e.createPrinter({ removeComments: true, omitTrailingSemicolon: true });
                  D = e.usingSingleLineStringWriter(function(g) {
                    return fe.writeNode(4, P, P.getSourceFile(), g);
                  });
                }
                return { text: D, pos: d.getStart(), end: d.getEnd() };
              }
              function G(L) {
                var P, k;
                if (B(L)) return e.isModuleBlock(L.parent.parent.parent.parent) && e.isIdentifier(L.parent.parent.parent.parent.parent.name) ? L.parent.parent.parent.parent.parent.name.getText() : void 0;
                switch (L.kind) {
                  case 172:
                  case 173:
                  case 169:
                    return L.parent.kind === 205 ? (P = e.getAssignedName(L.parent)) === null || P === void 0 ? void 0 : P.getText() : (k = e.getNameOfDeclaration(L.parent)) === null || k === void 0 ? void 0 : k.getText();
                  case 256:
                  case 257:
                  case 261:
                    if (e.isModuleBlock(L.parent) && e.isIdentifier(L.parent.parent.name)) return L.parent.parent.name.getText();
                }
              }
              function oe(L, P) {
                if (P.body) return P;
                if (e.isConstructorDeclaration(P)) return e.getFirstConstructorWithBody(P.parent);
                if (e.isFunctionDeclaration(P) || e.isMethodDeclaration(P)) {
                  var k = p(L, P);
                  return k && k.valueDeclaration && e.isFunctionLikeDeclaration(k.valueDeclaration) && k.valueDeclaration.body ? k.valueDeclaration : void 0;
                }
                return P;
              }
              function f(L, P) {
                var k = p(L, P), Y;
                if (k && k.declarations) {
                  var U = e.indicesOf(k.declarations), j = e.map(k.declarations, function(fe) {
                    return { file: fe.getSourceFile().fileName, pos: fe.pos };
                  });
                  U.sort(function(fe, g) {
                    return e.compareStringsCaseSensitive(j[fe].file, j[g].file) || j[fe].pos - j[g].pos;
                  });
                  for (var H = e.map(U, function(fe) {
                    return k.declarations[fe];
                  }), I = void 0, l = 0, d = H; l < d.length; l++) {
                    var D = d[l];
                    Q(D) && ((!I || I.parent !== D.parent || I.end !== D.pos) && (Y = e.append(Y, D)), I = D);
                  }
                }
                return Y;
              }
              function T(L, P) {
                var k, Y, U;
                return e.isClassStaticBlockDeclaration(P) ? P : e.isFunctionLikeDeclaration(P) ? (Y = (k = oe(L, P)) !== null && k !== void 0 ? k : f(L, P)) !== null && Y !== void 0 ? Y : P : (U = f(L, P)) !== null && U !== void 0 ? U : P;
              }
              function K(L, P) {
                for (var k = L.getTypeChecker(), Y = false; ; ) {
                  if (Q(P)) return T(k, P);
                  if (E(P)) {
                    var U = e.findAncestor(P, Q);
                    return U && T(k, U);
                  }
                  if (e.isDeclarationName(P)) {
                    if (Q(P.parent)) return T(k, P.parent);
                    if (E(P.parent)) {
                      var U = e.findAncestor(P.parent, Q);
                      return U && T(k, U);
                    }
                    return e.isVariableDeclaration(P.parent) && P.parent.initializer && B(P.parent.initializer) ? P.parent.initializer : void 0;
                  }
                  if (e.isConstructorDeclaration(P)) return Q(P.parent) ? P.parent : void 0;
                  if (P.kind === 124 && e.isClassStaticBlockDeclaration(P.parent)) {
                    P = P.parent;
                    continue;
                  }
                  if (e.isVariableDeclaration(P) && P.initializer && B(P.initializer)) return P.initializer;
                  if (!Y) {
                    var j = k.getSymbolAtLocation(P);
                    if (j && (j.flags & 2097152 && (j = k.getAliasedSymbol(j)), j.valueDeclaration)) {
                      Y = true, P = j.valueDeclaration;
                      continue;
                    }
                  }
                  return;
                }
              }
              C.resolveCallHierarchyDeclaration = K;
              function b(L, P) {
                var k = P.getSourceFile(), Y = m(L, P), U = G(P), j = e.getNodeKind(P), H = e.getNodeModifiers(P), I = e.createTextSpanFromBounds(e.skipTrivia(k.text, P.getFullStart(), false, true), P.getEnd()), l = e.createTextSpanFromBounds(Y.pos, Y.end);
                return { file: k.fileName, kind: j, kindModifiers: H, name: Y.text, containerName: U, span: I, selectionSpan: l };
              }
              C.createCallHierarchyItem = b;
              function se(L) {
                return L !== void 0;
              }
              function J(L) {
                if (L.kind === 1) {
                  var P = L.node;
                  if (e.isCallOrNewExpressionTarget(P, true, true) || e.isTaggedTemplateTag(P, true, true) || e.isDecoratorTarget(P, true, true) || e.isJsxOpeningLikeElementTagName(P, true, true) || e.isRightSideOfPropertyAccess(P) || e.isArgumentExpressionOfElementAccess(P)) {
                    var k = P.getSourceFile(), Y = e.findAncestor(P, Q) || k;
                    return { declaration: Y, range: e.createTextRangeFromNode(P, k) };
                  }
                }
              }
              function ie(L) {
                return e.getNodeId(L.declaration);
              }
              function R(L, P) {
                return { from: L, fromSpans: P };
              }
              function q(L, P) {
                return R(b(L, P[0].declaration), e.map(P, function(k) {
                  return e.createTextSpanFromRange(k.range);
                }));
              }
              function O(L, P, k) {
                if (e.isSourceFile(P) || e.isModuleDeclaration(P) || e.isClassStaticBlockDeclaration(P)) return [];
                var Y = le(P), U = e.filter(e.FindAllReferences.findReferenceOrRenameEntries(L, k, L.getSourceFiles(), Y, 0, { use: 1 }, J), se);
                return U ? e.group(U, ie, function(j) {
                  return q(L, j);
                }) : [];
              }
              C.getIncomingCalls = O;
              function ve(L, P) {
                function k(U) {
                  var j = e.isTaggedTemplateExpression(U) ? U.tag : e.isJsxOpeningLikeElement(U) ? U.tagName : e.isAccessExpression(U) || e.isClassStaticBlockDeclaration(U) ? U : U.expression, H = K(L, j);
                  if (H) {
                    var I = e.createTextRangeFromNode(j, U.getSourceFile());
                    if (e.isArray(H)) for (var l = 0, d = H; l < d.length; l++) {
                      var D = d[l];
                      P.push({ declaration: D, range: I });
                    }
                    else P.push({ declaration: H, range: I });
                  }
                }
                function Y(U) {
                  if (!!U && !(U.flags & 16777216)) {
                    if (Q(U)) {
                      if (e.isClassLike(U)) for (var j = 0, H = U.members; j < H.length; j++) {
                        var I = H[j];
                        I.name && e.isComputedPropertyName(I.name) && Y(I.name.expression);
                      }
                      return;
                    }
                    switch (U.kind) {
                      case 79:
                      case 265:
                      case 266:
                      case 272:
                      case 258:
                      case 259:
                        return;
                      case 170:
                        k(U);
                        return;
                      case 211:
                      case 229:
                        Y(U.expression);
                        return;
                      case 254:
                      case 164:
                        Y(U.name), Y(U.initializer);
                        return;
                      case 208:
                        k(U), Y(U.expression), e.forEach(U.arguments, Y);
                        return;
                      case 209:
                        k(U), Y(U.expression), e.forEach(U.arguments, Y);
                        return;
                      case 210:
                        k(U), Y(U.tag), Y(U.template);
                        return;
                      case 280:
                      case 279:
                        k(U), Y(U.tagName), Y(U.attributes);
                        return;
                      case 165:
                        k(U), Y(U.expression);
                        return;
                      case 206:
                      case 207:
                        k(U), e.forEachChild(U, Y);
                        break;
                    }
                    e.isPartOfTypeNode(U) || e.forEachChild(U, Y);
                  }
                }
                return Y;
              }
              function ee(L, P) {
                e.forEach(L.statements, P);
              }
              function he(L, P) {
                !e.hasSyntacticModifier(L, 2) && L.body && e.isModuleBlock(L.body) && e.forEach(L.body.statements, P);
              }
              function F(L, P, k) {
                var Y = oe(L, P);
                Y && (e.forEach(Y.parameters, k), k(Y.body));
              }
              function x(L, P) {
                P(L.body);
              }
              function X(L, P) {
                e.forEach(L.decorators, P);
                var k = e.getClassExtendsHeritageElement(L);
                k && P(k.expression);
                for (var Y = 0, U = L.members; Y < U.length; Y++) {
                  var j = U[Y];
                  e.forEach(j.decorators, P), e.isPropertyDeclaration(j) ? P(j.initializer) : e.isConstructorDeclaration(j) && j.body ? (e.forEach(j.parameters, P), P(j.body)) : e.isClassStaticBlockDeclaration(j) && P(j);
                }
              }
              function $(L, P) {
                var k = [], Y = ve(L, k);
                switch (P.kind) {
                  case 305:
                    ee(P, Y);
                    break;
                  case 261:
                    he(P, Y);
                    break;
                  case 256:
                  case 213:
                  case 214:
                  case 169:
                  case 172:
                  case 173:
                    F(L.getTypeChecker(), P, Y);
                    break;
                  case 257:
                  case 226:
                    X(P, Y);
                    break;
                  case 170:
                    x(P, Y);
                    break;
                  default:
                    e.Debug.assertNever(P);
                }
                return k;
              }
              function A(L, P) {
                return { to: L, fromSpans: P };
              }
              function y(L, P) {
                return A(b(L, P[0].declaration), e.map(P, function(k) {
                  return e.createTextSpanFromRange(k.range);
                }));
              }
              function V(L, P) {
                return P.flags & 16777216 || e.isMethodSignature(P) ? [] : e.group($(L, P), ie, function(k) {
                  return y(L, k);
                });
              }
              C.getOutgoingCalls = V;
            })(a = e.CallHierarchy || (e.CallHierarchy = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(f, T, K, b, se, J, ie) {
              var R = e.hostUsesCaseSensitiveFileNames(b), q = e.createGetCanonicalFileName(R), O = C(T, K, q, ie), ve = C(K, T, q, ie);
              return e.textChanges.ChangeTracker.with({ host: b, formatContext: se, preferences: J }, function(ee) {
                B(f, ee, O, T, K, b.getCurrentDirectory(), R), E(f, ee, O, ve, b, q);
              });
            }
            e.getEditsForFileRename = a;
            function C(f, T, K, b) {
              var se = K(f);
              return function(ie) {
                var R = b && b.tryGetSourcePosition({ fileName: ie, pos: 0 }), q = J(R ? R.fileName : ie);
                return R ? q === void 0 ? void 0 : w(R.fileName, q, ie, K) : q;
              };
              function J(ie) {
                if (K(ie) === se) return T;
                var R = e.tryRemoveDirectoryPrefix(ie, se, K);
                return R === void 0 ? void 0 : T + "/" + R;
              }
            }
            e.getPathUpdater = C;
            function w(f, T, K, b) {
              var se = e.getRelativePathFromFile(f, T, b);
              return le(e.getDirectoryPath(K), se);
            }
            function B(f, T, K, b, se, J, ie) {
              var R = f.getCompilerOptions().configFile;
              if (!R) return;
              var q = e.getDirectoryPath(R.fileName), O = e.getTsConfigObjectLiteralExpression(R);
              if (!O) return;
              oe(O, function(F, x) {
                switch (x) {
                  case "files":
                  case "include":
                  case "exclude": {
                    var X = ve(F);
                    if (X || x !== "include" || !e.isArrayLiteralExpression(F.initializer)) return;
                    var $ = e.mapDefined(F.initializer.elements, function(y) {
                      return e.isStringLiteral(y) ? y.text : void 0;
                    });
                    if ($.length === 0) return;
                    var A = e.getFileMatcherPatterns(q, [], $, ie, J);
                    e.getRegexFromPattern(e.Debug.checkDefined(A.includeFilePattern), ie).test(b) && !e.getRegexFromPattern(e.Debug.checkDefined(A.includeFilePattern), ie).test(se) && T.insertNodeAfter(R, e.last(F.initializer.elements), e.factory.createStringLiteral(he(se)));
                    return;
                  }
                  case "compilerOptions":
                    oe(F.initializer, function(y, V) {
                      var L = e.getOptionFromName(V);
                      L && (L.isFilePath || L.type === "list" && L.element.isFilePath) ? ve(y) : V === "paths" && oe(y.initializer, function(P) {
                        if (!!e.isArrayLiteralExpression(P.initializer)) for (var k = 0, Y = P.initializer.elements; k < Y.length; k++) {
                          var U = Y[k];
                          ee(U);
                        }
                      });
                    });
                    return;
                }
              });
              function ve(F) {
                for (var x = e.isArrayLiteralExpression(F.initializer) ? F.initializer.elements : [F.initializer], X = false, $ = 0, A = x; $ < A.length; $++) {
                  var y = A[$];
                  X = ee(y) || X;
                }
                return X;
              }
              function ee(F) {
                if (!e.isStringLiteral(F)) return false;
                var x = le(q, F.text), X = K(x);
                return X !== void 0 ? (T.replaceRangeWithText(R, G(F, R), he(X)), true) : false;
              }
              function he(F) {
                return e.getRelativePathFromDirectory(q, F, !ie);
              }
            }
            function E(f, T, K, b, se, J) {
              for (var ie = f.getSourceFiles(), R = function(ee) {
                var he = K(ee.fileName), F = he != null ? he : ee.fileName, x = e.getDirectoryPath(F), X = b(ee.fileName), $ = X || ee.fileName, A = e.getDirectoryPath($), y = he !== void 0 || X !== void 0;
                m(ee, T, function(V) {
                  if (!!e.pathIsRelative(V)) {
                    var L = le(A, V), P = K(L);
                    return P === void 0 ? void 0 : e.ensurePathIsNonModuleName(e.getRelativePathFromDirectory(x, P, J));
                  }
                }, function(V) {
                  var L = f.getTypeChecker().getSymbolAtLocation(V);
                  if (!((L == null ? void 0 : L.declarations) && L.declarations.some(function(k) {
                    return e.isAmbientModule(k);
                  }))) {
                    var P = X !== void 0 ? p(V, e.resolveModuleName(V.text, $, f.getCompilerOptions(), se), K, ie) : N(L, V, ee, f, se, K);
                    return P !== void 0 && (P.updated || y && e.pathIsRelative(V.text)) ? e.moduleSpecifiers.updateModuleSpecifier(f.getCompilerOptions(), ee, J(F), P.newFileName, e.createModuleSpecifierResolutionHost(f, se), V.text) : void 0;
                  }
                });
              }, q = 0, O = ie; q < O.length; q++) {
                var ve = O[q];
                R(ve);
              }
            }
            function Q(f, T) {
              return e.normalizePath(e.combinePaths(f, T));
            }
            function le(f, T) {
              return e.ensurePathIsNonModuleName(Q(f, T));
            }
            function N(f, T, K, b, se, J) {
              if (f) {
                var ie = e.find(f.declarations, e.isSourceFile).fileName, R = J(ie);
                return R === void 0 ? { newFileName: ie, updated: false } : { newFileName: R, updated: true };
              } else {
                var q = e.getModeForUsageLocation(K, T), O = se.resolveModuleNames ? se.getResolvedModuleWithFailedLookupLocationsFromCache && se.getResolvedModuleWithFailedLookupLocationsFromCache(T.text, K.fileName, q) : b.getResolvedModuleWithFailedLookupLocationsFromCache(T.text, K.fileName, q);
                return p(T, O, J, b.getSourceFiles());
              }
            }
            function p(f, T, K, b) {
              if (!T) return;
              if (T.resolvedModule) {
                var se = q(T.resolvedModule.resolvedFileName);
                if (se) return se;
              }
              var J = e.forEach(T.failedLookupLocations, ie) || e.pathIsRelative(f.text) && e.forEach(T.failedLookupLocations, R);
              if (J) return J;
              return T.resolvedModule && { newFileName: T.resolvedModule.resolvedFileName, updated: false };
              function ie(O) {
                var ve = K(O);
                return ve && e.find(b, function(ee) {
                  return ee.fileName === ve;
                }) ? R(O) : void 0;
              }
              function R(O) {
                return e.endsWith(O, "/package.json") ? void 0 : q(O);
              }
              function q(O) {
                var ve = K(O);
                return ve && { newFileName: ve, updated: true };
              }
            }
            function m(f, T, K, b) {
              for (var se = 0, J = f.referencedFiles || e.emptyArray; se < J.length; se++) {
                var ie = J[se], R = K(ie.fileName);
                R !== void 0 && R !== f.text.slice(ie.pos, ie.end) && T.replaceRangeWithText(f, ie, R);
              }
              for (var q = 0, O = f.imports; q < O.length; q++) {
                var ve = O[q], R = b(ve);
                R !== void 0 && R !== ve.text && T.replaceRangeWithText(f, G(ve, f), R);
              }
            }
            function G(f, T) {
              return e.createRange(f.getStart(T) + 1, f.end - 1);
            }
            function oe(f, T) {
              if (!!e.isObjectLiteralExpression(f)) for (var K = 0, b = f.properties; K < b.length; K++) {
                var se = b[K];
                e.isPropertyAssignment(se) && e.isStringLiteral(se.name) && T(se, se.name.text);
              }
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w(F, x, X, $, A) {
                var y, V, L = le(x, X, F), P = L && [O(L.reference.fileName, L.fileName, L.unverified)] || e.emptyArray;
                if (L != null && L.file) return P;
                var k = e.getTouchingPropertyName(x, X);
                if (k !== x) {
                  var Y = k.parent, U = F.getTypeChecker();
                  if (k.kind === 159 || e.isJSDocOverrideTag(k) && e.rangeContainsPosition(k.tagName, X)) return Q(U, k) || e.emptyArray;
                  if (e.isJumpStatementTarget(k)) {
                    var j = e.getTargetLabel(k.parent, k.text);
                    return j ? [J(U, j, "label", k.text, void 0)] : void 0;
                  }
                  if (e.isStaticModifier(k) && e.isClassStaticBlockDeclaration(k.parent)) {
                    var H = k.parent.parent, I = f(H, U, A), l = I.symbol, d = I.failedAliasResolution, D = e.filter(H.members, e.isClassStaticBlockDeclaration), fe = l ? U.symbolToString(l, H) : "", g = k.getSourceFile();
                    return e.map(D, function(we) {
                      var de = e.moveRangePastModifiers(we).pos;
                      return de = e.skipTrivia(g.text, de), J(U, we, "constructor", "static {}", fe, false, d, { start: de, length: 6 });
                    });
                  }
                  var ne = f(k, U, A), ue = ne.symbol, We = ne.failedAliasResolution, Fe = k;
                  if ($ && We) {
                    var Z = e.forEach(Ve([k], (ue == null ? void 0 : ue.declarations) || e.emptyArray, true), function(we) {
                      return e.findAncestor(we, e.isAnyImportOrBareOrAccessedRequire);
                    }), Be = Z && e.tryGetModuleSpecifierFromDeclaration(Z);
                    Be && (y = f(Be, U, A), ue = y.symbol, We = y.failedAliasResolution, Fe = Be);
                  }
                  if (!ue && e.isModuleSpecifierLike(Fe)) {
                    var ge = (V = x.resolvedModules) === null || V === void 0 ? void 0 : V.get(Fe.text, e.getModeForUsageLocation(x, Fe));
                    if (ge) return [{ name: Fe.text, fileName: ge.resolvedFileName, containerName: void 0, containerKind: void 0, kind: "script", textSpan: e.createTextSpan(0, 0), failedAliasResolution: We, isAmbient: e.isDeclarationFileName(ge.resolvedFileName), unverified: Fe !== k }];
                  }
                  if (!ue) return e.concatenate(P, oe(k, U));
                  if (!($ && e.every(ue.declarations, function(we) {
                    return we.getSourceFile().fileName === x.fileName;
                  }))) {
                    var Re = ee(U, k);
                    if (Re && !(e.isJsxOpeningLikeElement(k.parent) && he(Re))) {
                      var ze = R(U, Re, We);
                      if (U.getRootSymbols(ue).some(function(we) {
                        return B(we, Re);
                      })) return [ze];
                      var Ee = b(U, ue, k, We, Re) || e.emptyArray;
                      return k.kind === 106 ? Ve([ze], Ee, true) : Ve(Ve([], Ee, true), [ze], false);
                    }
                    if (k.parent.kind === 297) {
                      var He = U.getShorthandAssignmentValueSymbol(ue.valueDeclaration), rr = He != null && He.declarations ? He.declarations.map(function(we) {
                        return se(we, U, He, k, false, We);
                      }) : e.emptyArray;
                      return e.concatenate(rr, E(U, k) || e.emptyArray);
                    }
                    if (e.isPropertyName(k) && e.isBindingElement(Y) && e.isObjectBindingPattern(Y.parent) && k === (Y.propertyName || Y.name)) {
                      var Ie = e.getNameFromPropertyName(k), _e = U.getTypeAtLocation(Y.parent);
                      return Ie === void 0 ? e.emptyArray : e.flatMap(_e.isUnion() ? _e.types : [_e], function(we) {
                        var de = we.getProperty(Ie);
                        return de && b(U, de, k);
                      });
                    }
                    return e.concatenate(P, E(U, k) || b(U, ue, k, We));
                  }
                }
              }
              C.getDefinitionAtPosition = w;
              function B(F, x) {
                return F === x.symbol || F === x.symbol.parent || e.isAssignmentExpression(x.parent) || !e.isCallLikeExpression(x.parent) && F === x.parent.symbol;
              }
              function E(F, x) {
                var X = e.getContainingObjectLiteralElement(x);
                if (X) {
                  var $ = X && F.getContextualType(X.parent);
                  if ($) return e.flatMap(e.getPropertySymbolsFromContextualType(X, F, $, false), function(A) {
                    return b(F, A, x);
                  });
                }
              }
              function Q(F, x) {
                var X = e.findAncestor(x, e.isClassElement);
                if (!!(X && X.name)) {
                  var $ = e.findAncestor(X, e.isClassLike);
                  if (!!$) {
                    var A = e.getEffectiveBaseTypeNode($), y = A ? F.getTypeAtLocation(A) : void 0;
                    if (!!y) {
                      var V = e.unescapeLeadingUnderscores(e.getTextOfPropertyName(X.name)), L = e.hasStaticModifier(X) ? F.getPropertyOfType(F.getTypeOfSymbolAtLocation(y.symbol, $), V) : F.getPropertyOfType(y, V);
                      if (!!L) return b(F, L, x);
                    }
                  }
                }
              }
              function le(F, x, X) {
                var $, A, y = q(F.referencedFiles, x);
                if (y) {
                  var V = X.getSourceFileFromReference(F, y);
                  return V && { reference: y, fileName: V.fileName, file: V, unverified: false };
                }
                var L = q(F.typeReferenceDirectives, x);
                if (L) {
                  var P = X.getResolvedTypeReferenceDirectives().get(L.fileName, L.resolutionMode || F.impliedNodeFormat), V = P && X.getSourceFile(P.resolvedFileName);
                  return V && { reference: L, fileName: V.fileName, file: V, unverified: false };
                }
                var k = q(F.libReferenceDirectives, x);
                if (k) {
                  var V = X.getLibFileFromReference(k);
                  return V && { reference: k, fileName: V.fileName, file: V, unverified: false };
                }
                if (!(($ = F.resolvedModules) === null || $ === void 0) && $.size()) {
                  var Y = e.getTouchingToken(F, x);
                  if (e.isModuleSpecifierLike(Y) && e.isExternalModuleNameRelative(Y.text) && F.resolvedModules.has(Y.text, e.getModeForUsageLocation(F, Y))) {
                    var U = (A = F.resolvedModules.get(Y.text, e.getModeForUsageLocation(F, Y))) === null || A === void 0 ? void 0 : A.resolvedFileName, j = U || e.resolvePath(e.getDirectoryPath(F.fileName), Y.text);
                    return { file: X.getSourceFile(j), fileName: j, reference: { pos: Y.getStart(), end: Y.getEnd(), fileName: Y.text }, unverified: !U };
                  }
                }
              }
              C.getReferenceAtPosition = le;
              function N(F, x, X) {
                var $ = e.getTouchingPropertyName(x, X);
                if ($ !== x) {
                  if (e.isImportMeta($.parent) && $.parent.name === $) return p(F.getTypeAtLocation($.parent), F, $.parent, false);
                  var A = f($, F, false), y = A.symbol, V = A.failedAliasResolution;
                  if (!!y) {
                    var L = F.getTypeOfSymbolAtLocation(y, $), P = m(y, L, F), k = P && p(P, F, $, V), Y = k && k.length !== 0 ? k : p(L, F, $, V);
                    return Y.length ? Y : !(y.flags & 111551) && y.flags & 788968 ? b(F, e.skipAlias(y, F), $, V) : void 0;
                  }
                }
              }
              C.getTypeDefinitionAtPosition = N;
              function p(F, x, X, $) {
                return e.flatMap(F.isUnion() && !(F.flags & 32) ? F.types : [F], function(A) {
                  return A.symbol && b(x, A.symbol, X, $);
                });
              }
              function m(F, x, X) {
                if (x.symbol === F || F.valueDeclaration && x.symbol && e.isVariableDeclaration(F.valueDeclaration) && F.valueDeclaration.initializer === x.symbol.valueDeclaration) {
                  var $ = x.getCallSignatures();
                  if ($.length === 1) return X.getReturnTypeOfSignature(e.first($));
                }
              }
              function G(F, x, X) {
                var $ = w(F, x, X);
                if (!(!$ || $.length === 0)) {
                  var A = q(x.referencedFiles, X) || q(x.typeReferenceDirectives, X) || q(x.libReferenceDirectives, X);
                  if (A) return { definitions: $, textSpan: e.createTextSpanFromRange(A) };
                  var y = e.getTouchingPropertyName(x, X), V = e.createTextSpan(y.getStart(), y.getWidth());
                  return { definitions: $, textSpan: V };
                }
              }
              C.getDefinitionAndBoundSpan = G;
              function oe(F, x) {
                return e.mapDefined(x.getIndexInfosAtLocation(F), function(X) {
                  return X.declaration && R(x, X.declaration);
                });
              }
              function f(F, x, X) {
                var $ = x.getSymbolAtLocation(F), A = false;
                if (($ == null ? void 0 : $.declarations) && $.flags & 2097152 && !X && T(F, $.declarations[0])) {
                  var y = x.getAliasedSymbol($);
                  if (y.declarations) return { symbol: y };
                  A = true;
                }
                return { symbol: $, failedAliasResolution: A };
              }
              function T(F, x) {
                return F.kind !== 79 ? false : F.parent === x ? true : x.kind !== 268;
              }
              function K(F) {
                if (!e.isAssignmentDeclaration(F)) return false;
                var x = e.findAncestor(F, function(X) {
                  return e.isAssignmentExpression(X) ? true : e.isAssignmentDeclaration(X) ? false : "quit";
                });
                return !!x && e.getAssignmentDeclarationKind(x) === 5;
              }
              function b(F, x, X, $, A) {
                var y = e.filter(x.declarations, function(U) {
                  return U !== A;
                }), V = e.filter(y, function(U) {
                  return !K(U);
                }), L = e.some(V) ? V : y;
                return P() || k() || e.map(L, function(U) {
                  return se(U, F, x, X, false, $);
                });
                function P() {
                  if (x.flags & 32 && !(x.flags & 19) && (e.isNewExpressionTarget(X) || X.kind === 134)) {
                    var U = e.find(y, e.isClassLike) || e.Debug.fail("Expected declaration to have at least one class-like declaration");
                    return Y(U.members, true);
                  }
                }
                function k() {
                  return e.isCallOrNewExpressionTarget(X) || e.isNameOfFunctionDeclaration(X) ? Y(y, false) : void 0;
                }
                function Y(U, j) {
                  if (!!U) {
                    var H = U.filter(j ? e.isConstructorDeclaration : e.isFunctionLike), I = H.filter(function(l) {
                      return !!l.body;
                    });
                    return H.length ? I.length !== 0 ? I.map(function(l) {
                      return se(l, F, x, X);
                    }) : [se(e.last(H), F, x, X, false, $)] : void 0;
                  }
                }
              }
              function se(F, x, X, $, A, y) {
                var V = x.symbolToString(X), L = e.SymbolDisplay.getSymbolKind(x, X, $), P = X.parent ? x.symbolToString(X.parent, $) : "";
                return J(x, F, L, V, P, A, y);
              }
              C.createDefinitionInfo = se;
              function J(F, x, X, $, A, y, V, L) {
                var P = x.getSourceFile();
                if (!L) {
                  var k = e.getNameOfDeclaration(x) || x;
                  L = e.createTextSpanFromNode(k, P);
                }
                return Ke(Ke({ fileName: P.fileName, textSpan: L, kind: X, name: $, containerKind: void 0, containerName: A }, e.FindAllReferences.toContextSpan(L, P, e.FindAllReferences.getContextNode(x))), { isLocal: !ie(F, x), isAmbient: !!(x.flags & 16777216), unverified: y, failedAliasResolution: V });
              }
              function ie(F, x) {
                if (F.isDeclarationVisible(x)) return true;
                if (!x.parent) return false;
                if (e.hasInitializer(x.parent) && x.parent.initializer === x) return ie(F, x.parent);
                switch (x.kind) {
                  case 167:
                  case 172:
                  case 173:
                  case 169:
                    if (e.hasEffectiveModifier(x, 8)) return false;
                  case 171:
                  case 296:
                  case 297:
                  case 205:
                  case 226:
                  case 214:
                  case 213:
                    return ie(F, x.parent);
                  default:
                    return false;
                }
              }
              function R(F, x, X) {
                return se(x, F, x.symbol, x, false, X);
              }
              function q(F, x) {
                return e.find(F, function(X) {
                  return e.textRangeContainsPositionInclusive(X, x);
                });
              }
              C.findReferenceInPosition = q;
              function O(F, x, X) {
                return { fileName: x, textSpan: e.createTextSpanFromBounds(0, 0), kind: "script", name: F, containerName: void 0, containerKind: void 0, unverified: X };
              }
              function ve(F) {
                var x = e.findAncestor(F, function($) {
                  return !e.isRightSideOfPropertyAccess($);
                }), X = x == null ? void 0 : x.parent;
                return X && e.isCallLikeExpression(X) && e.getInvokedExpression(X) === x ? X : void 0;
              }
              function ee(F, x) {
                var X = ve(x), $ = X && F.getResolvedSignature(X);
                return e.tryCast($ && $.declaration, function(A) {
                  return e.isFunctionLike(A) && !e.isFunctionTypeNode(A);
                });
              }
              function he(F) {
                switch (F.kind) {
                  case 171:
                  case 180:
                  case 175:
                    return true;
                  default:
                    return false;
                }
              }
            })(a = e.GoToDefinition || (e.GoToDefinition = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = ["abstract", "access", "alias", "argument", "async", "augments", "author", "borrows", "callback", "class", "classdesc", "constant", "constructor", "constructs", "copyright", "default", "deprecated", "description", "emits", "enum", "event", "example", "exports", "extends", "external", "field", "file", "fileoverview", "fires", "function", "generator", "global", "hideconstructor", "host", "ignore", "implements", "inheritdoc", "inner", "instance", "interface", "kind", "lends", "license", "link", "listens", "member", "memberof", "method", "mixes", "module", "name", "namespace", "override", "package", "param", "private", "property", "protected", "public", "readonly", "requires", "returns", "see", "since", "static", "summary", "template", "this", "throws", "todo", "tutorial", "type", "typedef", "var", "variation", "version", "virtual", "yields"], B, E;
              function Q(F, x) {
                var X = [];
                return e.forEachUnique(F, function($) {
                  for (var A = 0, y = N($); A < y.length; A++) {
                    var V = y[A];
                    if (!(V.comment === void 0 || e.isJSDoc(V) && $.kind !== 345 && $.kind !== 338 && V.tags && V.tags.some(function(P) {
                      return P.kind === 345 || P.kind === 338;
                    }) && !V.tags.some(function(P) {
                      return P.kind === 340 || P.kind === 341;
                    }))) {
                      var L = m(V.comment, x);
                      e.contains(X, L, le) || X.push(L);
                    }
                  }
                }), e.flatten(e.intersperse(X, [e.lineBreakPart()]));
              }
              C.getJsDocCommentsFromDeclarations = Q;
              function le(F, x) {
                return e.arraysEqual(F, x, function(X, $) {
                  return X.kind === $.kind && X.text === $.text;
                });
              }
              function N(F) {
                switch (F.kind) {
                  case 340:
                  case 347:
                    return [F];
                  case 338:
                  case 345:
                    return [F, F.parent];
                  default:
                    return e.getJSDocCommentsAndTags(F);
                }
              }
              function p(F, x) {
                var X = [];
                return e.forEachUnique(F, function($) {
                  var A = e.getJSDocTags($);
                  if (!(A.some(function(P) {
                    return P.kind === 345 || P.kind === 338;
                  }) && !A.some(function(P) {
                    return P.kind === 340 || P.kind === 341;
                  }))) for (var y = 0, V = A; y < V.length; y++) {
                    var L = V[y];
                    X.push({ name: L.tagName.text, text: G(L, x) });
                  }
                }), X;
              }
              C.getJsDocTagsFromDeclarations = p;
              function m(F, x) {
                return typeof F == "string" ? [e.textPart(F)] : e.flatMap(F, function(X) {
                  return X.kind === 321 ? [e.textPart(X.text)] : e.buildLinkParts(X, x);
                });
              }
              function G(F, x) {
                var X = F.comment, $ = F.kind, A = oe($);
                switch ($) {
                  case 329:
                    return k(F.class);
                  case 328:
                    return k(F.class);
                  case 344:
                    var y = F, V = [];
                    if (y.constraint && V.push(e.textPart(y.constraint.getText())), e.length(y.typeParameters)) {
                      e.length(V) && V.push(e.spacePart());
                      var L = y.typeParameters[y.typeParameters.length - 1];
                      e.forEach(y.typeParameters, function(U) {
                        V.push(A(U.getText())), L !== U && V.push.apply(V, [e.punctuationPart(27), e.spacePart()]);
                      });
                    }
                    return X && V.push.apply(V, Ve([e.spacePart()], m(X, x), true)), V;
                  case 343:
                    return k(F.typeExpression);
                  case 345:
                  case 338:
                  case 347:
                  case 340:
                  case 346:
                    var P = F.name;
                    return P ? k(P) : X === void 0 ? void 0 : m(X, x);
                  default:
                    return X === void 0 ? void 0 : m(X, x);
                }
                function k(U) {
                  return Y(U.getText());
                }
                function Y(U) {
                  return X ? U.match(/^https?$/) ? Ve([e.textPart(U)], m(X, x), true) : Ve([A(U), e.spacePart()], m(X, x), true) : [e.textPart(U)];
                }
              }
              function oe(F) {
                switch (F) {
                  case 340:
                    return e.parameterNamePart;
                  case 347:
                    return e.propertyNamePart;
                  case 344:
                    return e.typeParameterNamePart;
                  case 345:
                  case 338:
                    return e.typeAliasNamePart;
                  default:
                    return e.textPart;
                }
              }
              function f() {
                return B || (B = e.map(w, function(F) {
                  return { name: F, kind: "keyword", kindModifiers: "", sortText: e.Completions.SortText.LocationPriority };
                }));
              }
              C.getJSDocTagNameCompletions = f, C.getJSDocTagNameCompletionDetails = K;
              function T() {
                return E || (E = e.map(w, function(F) {
                  return { name: "@".concat(F), kind: "keyword", kindModifiers: "", sortText: e.Completions.SortText.LocationPriority };
                }));
              }
              C.getJSDocTagCompletions = T;
              function K(F) {
                return { name: F, kind: "", kindModifiers: "", displayParts: [e.textPart(F)], documentation: e.emptyArray, tags: void 0, codeActions: void 0 };
              }
              C.getJSDocTagCompletionDetails = K;
              function b(F) {
                if (!e.isIdentifier(F.name)) return e.emptyArray;
                var x = F.name.text, X = F.parent, $ = X.parent;
                return e.isFunctionLike($) ? e.mapDefined($.parameters, function(A) {
                  if (!!e.isIdentifier(A.name)) {
                    var y = A.name.text;
                    if (!(X.tags.some(function(V) {
                      return V !== F && e.isJSDocParameterTag(V) && e.isIdentifier(V.name) && V.name.escapedText === y;
                    }) || x !== void 0 && !e.startsWith(y, x))) return { name: y, kind: "parameter", kindModifiers: "", sortText: e.Completions.SortText.LocationPriority };
                  }
                }) : [];
              }
              C.getJSDocParameterNameCompletions = b;
              function se(F) {
                return { name: F, kind: "parameter", kindModifiers: "", displayParts: [e.textPart(F)], documentation: e.emptyArray, tags: void 0, codeActions: void 0 };
              }
              C.getJSDocParameterNameCompletionDetails = se;
              function J(F, x, X, $) {
                var A = e.getTokenAtPosition(x, X), y = e.findAncestor(A, e.isJSDoc);
                if (!(y && (y.comment !== void 0 || e.length(y.tags)))) {
                  var V = A.getStart(x);
                  if (!(!y && V < X)) {
                    var L = O(A, $);
                    if (!!L) {
                      var P = L.commentOwner, k = L.parameters, Y = L.hasReturn, U = e.hasJSDocNodes(P) && P.jsDoc ? e.lastOrUndefined(P.jsDoc) : void 0;
                      if (!(P.getStart(x) < X || U && U !== y)) {
                        var j = ie(x, X), H = e.hasJSFileExtension(x.fileName), I = (k ? R(k || [], H, j, F) : "") + (Y ? q(j, F) : ""), l = "/**", d = " */";
                        if (I) {
                          var D = l + F + j + " * ", fe = V === X ? F + j : "", g = D + F + I + j + d + fe;
                          return { newText: g, caretOffset: D.length };
                        }
                        return { newText: l + d, caretOffset: 3 };
                      }
                    }
                  }
                }
              }
              C.getDocCommentTemplateAtPosition = J;
              function ie(F, x) {
                for (var X = F.text, $ = e.getLineStartPositionForPosition(x, F), A = $; A <= x && e.isWhiteSpaceSingleLine(X.charCodeAt(A)); A++) ;
                return X.slice($, A);
              }
              function R(F, x, X, $) {
                return F.map(function(A, y) {
                  var V = A.name, L = A.dotDotDotToken, P = V.kind === 79 ? V.text : "param" + y, k = x ? L ? "{...any} " : "{any} " : "";
                  return "".concat(X, " * @param ").concat(k).concat(P).concat($);
                }).join("");
              }
              function q(F, x) {
                return "".concat(F, " * @returns").concat(x);
              }
              function O(F, x) {
                return e.forEachAncestor(F, function(X) {
                  return ve(X, x);
                });
              }
              function ve(F, x) {
                switch (F.kind) {
                  case 256:
                  case 213:
                  case 169:
                  case 171:
                  case 168:
                  case 214:
                    var X = F;
                    return { commentOwner: F, parameters: X.parameters, hasReturn: ee(X, x) };
                  case 296:
                    return ve(F.initializer, x);
                  case 257:
                  case 258:
                  case 166:
                  case 260:
                  case 299:
                  case 259:
                    return { commentOwner: F };
                  case 237: {
                    var $ = F, A = $.declarationList.declarations, y = A.length === 1 && A[0].initializer ? he(A[0].initializer) : void 0;
                    return y ? { commentOwner: F, parameters: y.parameters, hasReturn: ee(y, x) } : { commentOwner: F };
                  }
                  case 305:
                    return "quit";
                  case 261:
                    return F.parent.kind === 261 ? void 0 : { commentOwner: F };
                  case 238:
                    return ve(F.expression, x);
                  case 221: {
                    var V = F;
                    return e.getAssignmentDeclarationKind(V) === 0 ? "quit" : e.isFunctionLike(V.right) ? { commentOwner: F, parameters: V.right.parameters, hasReturn: ee(V.right, x) } : { commentOwner: F };
                  }
                  case 167:
                    var L = F.initializer;
                    if (L && (e.isFunctionExpression(L) || e.isArrowFunction(L))) return { commentOwner: F, parameters: L.parameters, hasReturn: ee(L, x) };
                }
              }
              function ee(F, x) {
                return !!(x != null && x.generateReturnInDocTemplate) && (e.isArrowFunction(F) && e.isExpression(F.body) || e.isFunctionLikeDeclaration(F) && F.body && e.isBlock(F.body) && !!e.forEachReturnStatement(F.body, function(X) {
                  return X;
                }));
              }
              function he(F) {
                for (; F.kind === 212; ) F = F.expression;
                switch (F.kind) {
                  case 213:
                  case 214:
                    return F;
                  case 226:
                    return e.find(F.members, e.isConstructorDeclaration);
                }
              }
            })(a = e.JsDoc || (e.JsDoc = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w(oe, f, T, K, b, se) {
                var J = e.createPatternMatcher(K);
                if (!J) return e.emptyArray;
                for (var ie = [], R = function(ee) {
                  if (T.throwIfCancellationRequested(), se && ee.isDeclarationFile) return "continue";
                  ee.getNamedDeclarations().forEach(function(he, F) {
                    B(J, F, he, f, ee.fileName, ie);
                  });
                }, q = 0, O = oe; q < O.length; q++) {
                  var ve = O[q];
                  R(ve);
                }
                return ie.sort(m), (b === void 0 ? ie : ie.slice(0, b)).map(G);
              }
              C.getNavigateToItems = w;
              function B(oe, f, T, K, b, se) {
                var J = oe.getMatchForLastSegmentOfPattern(f);
                if (!!J) for (var ie = 0, R = T; ie < R.length; ie++) {
                  var q = R[ie];
                  if (!!E(q, K)) if (oe.patternContainsDots) {
                    var O = oe.getFullMatch(p(q), f);
                    O && se.push({ name: f, fileName: b, matchKind: O.kind, isCaseSensitive: O.isCaseSensitive, declaration: q });
                  } else se.push({ name: f, fileName: b, matchKind: J.kind, isCaseSensitive: J.isCaseSensitive, declaration: q });
                }
              }
              function E(oe, f) {
                switch (oe.kind) {
                  case 267:
                  case 270:
                  case 265:
                    var T = f.getSymbolAtLocation(oe.name), K = f.getAliasedSymbol(T);
                    return T.escapedName !== K.escapedName;
                  default:
                    return true;
                }
              }
              function Q(oe, f) {
                var T = e.getNameOfDeclaration(oe);
                return !!T && (N(T, f) || T.kind === 162 && le(T.expression, f));
              }
              function le(oe, f) {
                return N(oe, f) || e.isPropertyAccessExpression(oe) && (f.push(oe.name.text), true) && le(oe.expression, f);
              }
              function N(oe, f) {
                return e.isPropertyNameLiteral(oe) && (f.push(e.getTextOfIdentifierOrLiteral(oe)), true);
              }
              function p(oe) {
                var f = [], T = e.getNameOfDeclaration(oe);
                if (T && T.kind === 162 && !le(T.expression, f)) return e.emptyArray;
                f.shift();
                for (var K = e.getContainerNode(oe); K; ) {
                  if (!Q(K, f)) return e.emptyArray;
                  K = e.getContainerNode(K);
                }
                return f.reverse();
              }
              function m(oe, f) {
                return e.compareValues(oe.matchKind, f.matchKind) || e.compareStringsCaseSensitiveUI(oe.name, f.name);
              }
              function G(oe) {
                var f = oe.declaration, T = e.getContainerNode(f), K = T && e.getNameOfDeclaration(T);
                return { name: oe.name, kind: e.getNodeKind(f), kindModifiers: e.getNodeModifiers(f), matchKind: e.PatternMatchKind[oe.matchKind], isCaseSensitive: oe.isCaseSensitive, fileName: oe.fileName, textSpan: e.createTextSpanFromNode(f), containerName: K ? K.text : "", containerKind: K ? e.getNodeKind(T) : "" };
              }
            })(a = e.NavigateTo || (e.NavigateTo = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w, B = /\s+/g, E = 150, Q, le, N = [], p, m = [], G, oe = [];
              function f(Ie, _e) {
                Q = _e, le = Ie;
                try {
                  return e.map(fe(ie(Ie)), ne);
                } finally {
                  K();
                }
              }
              C.getNavigationBarItems = f;
              function T(Ie, _e) {
                Q = _e, le = Ie;
                try {
                  return g(ie(Ie));
                } finally {
                  K();
                }
              }
              C.getNavigationTree = T;
              function K() {
                le = void 0, Q = void 0, N = [], p = void 0, oe = [];
              }
              function b(Ie) {
                return rr(Ie.getText(le));
              }
              function se(Ie) {
                return Ie.node.kind;
              }
              function J(Ie, _e) {
                Ie.children ? Ie.children.push(_e) : Ie.children = [_e];
              }
              function ie(Ie) {
                e.Debug.assert(!N.length);
                var _e = { node: Ie, name: void 0, additionalNodes: void 0, parent: void 0, children: void 0, indent: 0 };
                p = _e;
                for (var we = 0, de = Ie.statements; we < de.length; we++) {
                  var ye = de[we];
                  A(ye);
                }
                return F(), e.Debug.assert(!p && !N.length), _e;
              }
              function R(Ie, _e) {
                J(p, q(Ie, _e));
              }
              function q(Ie, _e) {
                return { node: Ie, name: _e || (e.isDeclaration(Ie) || e.isExpression(Ie) ? e.getNameOfDeclaration(Ie) : void 0), additionalNodes: void 0, parent: p, children: void 0, indent: p.indent + 1 };
              }
              function O(Ie) {
                G || (G = new e.Map()), G.set(Ie, true);
              }
              function ve(Ie) {
                for (var _e = 0; _e < Ie; _e++) F();
              }
              function ee(Ie, _e) {
                for (var we = []; !e.isPropertyNameLiteral(_e); ) {
                  var de = e.getNameOrArgument(_e), ye = e.getElementOrPropertyAccessName(_e);
                  _e = _e.expression, !(ye === "prototype" || e.isPrivateIdentifier(de)) && we.push(de);
                }
                we.push(_e);
                for (var Ae = we.length - 1; Ae > 0; Ae--) {
                  var de = we[Ae];
                  he(Ie, de);
                }
                return [we.length - 1, we[0]];
              }
              function he(Ie, _e) {
                var we = q(Ie, _e);
                J(p, we), N.push(p), m.push(G), G = void 0, p = we;
              }
              function F() {
                p.children && (y(p.children, p), I(p.children)), p = N.pop(), G = m.pop();
              }
              function x(Ie, _e, we) {
                he(Ie, we), A(_e), F();
              }
              function X(Ie) {
                Ie.initializer && He(Ie.initializer) ? (he(Ie), e.forEachChild(Ie.initializer, A), F()) : x(Ie, Ie.initializer);
              }
              function $(Ie) {
                return !e.hasDynamicName(Ie) || Ie.kind !== 221 && e.isPropertyAccessExpression(Ie.name.expression) && e.isIdentifier(Ie.name.expression.expression) && e.idText(Ie.name.expression.expression) === "Symbol";
              }
              function A(Ie) {
                var _e;
                if (Q.throwIfCancellationRequested(), !(!Ie || e.isToken(Ie))) switch (Ie.kind) {
                  case 171:
                    var we = Ie;
                    x(we, we.body);
                    for (var de = 0, ye = we.parameters; de < ye.length; de++) {
                      var Ae = ye[de];
                      e.isParameterPropertyDeclaration(Ae, we) && R(Ae);
                    }
                    break;
                  case 169:
                  case 172:
                  case 173:
                  case 168:
                    $(Ie) && x(Ie, Ie.body);
                    break;
                  case 167:
                    $(Ie) && X(Ie);
                    break;
                  case 166:
                    $(Ie) && R(Ie);
                    break;
                  case 267:
                    var er = Ie;
                    er.name && R(er.name);
                    var ir = er.namedBindings;
                    if (ir) if (ir.kind === 268) R(ir);
                    else for (var Cr = 0, Ye = ir.elements; Cr < Ye.length; Cr++) {
                      var Br = Ye[Cr];
                      R(Br);
                    }
                    break;
                  case 297:
                    x(Ie, Ie.name);
                    break;
                  case 298:
                    var Er = Ie.expression;
                    e.isIdentifier(Er) ? R(Ie, Er) : R(Ie);
                    break;
                  case 203:
                  case 296:
                  case 254: {
                    var Ne = Ie;
                    e.isBindingPattern(Ne.name) ? A(Ne.name) : X(Ne);
                    break;
                  }
                  case 256:
                    var n = Ie.name;
                    n && e.isIdentifier(n) && O(n.text), x(Ie, Ie.body);
                    break;
                  case 214:
                  case 213:
                    x(Ie, Ie.body);
                    break;
                  case 260:
                    he(Ie);
                    for (var lr = 0, be = Ie.members; lr < be.length; lr++) {
                      var Ge = be[lr];
                      Be(Ge) || R(Ge);
                    }
                    F();
                    break;
                  case 257:
                  case 226:
                  case 258:
                    he(Ie);
                    for (var ur = 0, yr = Ie.members; ur < yr.length; ur++) {
                      var Ge = yr[ur];
                      A(Ge);
                    }
                    F();
                    break;
                  case 261:
                    x(Ie, Z(Ie).body);
                    break;
                  case 271: {
                    var Ir = Ie.expression, Ne = e.isObjectLiteralExpression(Ir) || e.isCallExpression(Ir) ? Ir : e.isArrowFunction(Ir) || e.isFunctionExpression(Ir) ? Ir.body : void 0;
                    Ne ? (he(Ie), A(Ne), F()) : R(Ie);
                    break;
                  }
                  case 275:
                  case 265:
                  case 176:
                  case 174:
                  case 175:
                  case 259:
                    R(Ie);
                    break;
                  case 208:
                  case 221: {
                    var wr = e.getAssignmentDeclarationKind(Ie);
                    switch (wr) {
                      case 1:
                      case 2:
                        x(Ie, Ie.right);
                        return;
                      case 6:
                      case 3: {
                        var Ur = Ie, ii = Ur.left, mi = wr === 3 ? ii.expression : ii, pe = 0, or = void 0;
                        e.isIdentifier(mi.expression) ? (O(mi.expression.text), or = mi.expression) : (_e = ee(Ur, mi.expression), pe = _e[0], or = _e[1]), wr === 6 ? e.isObjectLiteralExpression(Ur.right) && Ur.right.properties.length > 0 && (he(Ur, or), e.forEachChild(Ur.right, A), F()) : e.isFunctionExpression(Ur.right) || e.isArrowFunction(Ur.right) ? x(Ie, Ur.right, or) : (he(Ur, or), x(Ie, Ur.right, ii.name), F()), ve(pe);
                        return;
                      }
                      case 7:
                      case 9: {
                        var qr = Ie, or = wr === 7 ? qr.arguments[0] : qr.arguments[0].expression, si = qr.arguments[1], Di = ee(Ie, or), pe = Di[0], wi = Di[1];
                        he(Ie, wi), he(Ie, e.setTextRange(e.factory.createIdentifier(si.text), si)), A(Ie.arguments[2]), F(), F(), ve(pe);
                        return;
                      }
                      case 5: {
                        var Ur = Ie, ii = Ur.left, Xi = ii.expression;
                        if (e.isIdentifier(Xi) && e.getElementOrPropertyAccessName(ii) !== "prototype" && G && G.has(Xi.text)) {
                          e.isFunctionExpression(Ur.right) || e.isArrowFunction(Ur.right) ? x(Ie, Ur.right, Xi) : e.isBindableStaticAccessExpression(ii) && (he(Ur, Xi), x(Ur.left, Ur.right, e.getNameOrArgument(ii)), F());
                          return;
                        }
                        break;
                      }
                      case 4:
                      case 0:
                      case 8:
                        break;
                      default:
                        e.Debug.assertNever(wr);
                    }
                  }
                  default:
                    e.hasJSDocNodes(Ie) && e.forEach(Ie.jsDoc, function(et) {
                      e.forEach(et.tags, function(Gi) {
                        e.isJSDocTypeAlias(Gi) && R(Gi);
                      });
                    }), e.forEachChild(Ie, A);
                }
              }
              function y(Ie, _e) {
                var we = new e.Map();
                e.filterMutate(Ie, function(de, ye) {
                  var Ae = de.name || e.getNameOfDeclaration(de.node), er = Ae && b(Ae);
                  if (!er) return true;
                  var ir = we.get(er);
                  if (!ir) return we.set(er, de), true;
                  if (ir instanceof Array) {
                    for (var Cr = 0, Ye = ir; Cr < Ye.length; Cr++) {
                      var Br = Ye[Cr];
                      if (P(Br, de, ye, _e)) return false;
                    }
                    return ir.push(de), true;
                  } else {
                    var Br = ir;
                    return P(Br, de, ye, _e) ? false : (we.set(er, [Br, de]), true);
                  }
                });
              }
              var V = (w = {}, w[5] = true, w[3] = true, w[7] = true, w[9] = true, w[0] = false, w[1] = false, w[2] = false, w[8] = false, w[6] = true, w[4] = false, w);
              function L(Ie, _e, we, de) {
                function ye(Ne) {
                  return e.isFunctionExpression(Ne) || e.isFunctionDeclaration(Ne) || e.isVariableDeclaration(Ne);
                }
                var Ae = e.isBinaryExpression(_e.node) || e.isCallExpression(_e.node) ? e.getAssignmentDeclarationKind(_e.node) : 0, er = e.isBinaryExpression(Ie.node) || e.isCallExpression(Ie.node) ? e.getAssignmentDeclarationKind(Ie.node) : 0;
                if (V[Ae] && V[er] || ye(Ie.node) && V[Ae] || ye(_e.node) && V[er] || e.isClassDeclaration(Ie.node) && Y(Ie.node) && V[Ae] || e.isClassDeclaration(_e.node) && V[er] || e.isClassDeclaration(Ie.node) && Y(Ie.node) && ye(_e.node) || e.isClassDeclaration(_e.node) && ye(Ie.node) && Y(Ie.node)) {
                  var ir = Ie.additionalNodes && e.lastOrUndefined(Ie.additionalNodes) || Ie.node;
                  if (!e.isClassDeclaration(Ie.node) && !e.isClassDeclaration(_e.node) || ye(Ie.node) || ye(_e.node)) {
                    var Cr = ye(Ie.node) ? Ie.node : ye(_e.node) ? _e.node : void 0;
                    if (Cr !== void 0) {
                      var Ye = e.setTextRange(e.factory.createConstructorDeclaration(void 0, void 0, [], void 0), Cr), Br = q(Ye);
                      Br.indent = Ie.indent + 1, Br.children = Ie.node === Cr ? Ie.children : _e.children, Ie.children = Ie.node === Cr ? e.concatenate([Br], _e.children || [_e]) : e.concatenate(Ie.children || [Ke({}, Ie)], [Br]);
                    } else (Ie.children || _e.children) && (Ie.children = e.concatenate(Ie.children || [Ke({}, Ie)], _e.children || [_e]), Ie.children && (y(Ie.children, Ie), I(Ie.children)));
                    ir = Ie.node = e.setTextRange(e.factory.createClassDeclaration(void 0, void 0, Ie.name || e.factory.createIdentifier("__class__"), void 0, void 0, []), Ie.node);
                  } else Ie.children = e.concatenate(Ie.children, _e.children), Ie.children && y(Ie.children, Ie);
                  var Er = _e.node;
                  return de.children[we - 1].node.end === ir.end ? e.setTextRange(ir, { pos: ir.pos, end: Er.end }) : (Ie.additionalNodes || (Ie.additionalNodes = []), Ie.additionalNodes.push(e.setTextRange(e.factory.createClassDeclaration(void 0, void 0, Ie.name || e.factory.createIdentifier("__class__"), void 0, void 0, []), _e.node))), true;
                }
                return Ae !== 0;
              }
              function P(Ie, _e, we, de) {
                return L(Ie, _e, we, de) ? true : k(Ie.node, _e.node, de) ? (H(Ie, _e), true) : false;
              }
              function k(Ie, _e, we) {
                if (Ie.kind !== _e.kind || Ie.parent !== _e.parent && !(U(Ie, we) && U(_e, we))) return false;
                switch (Ie.kind) {
                  case 167:
                  case 169:
                  case 172:
                  case 173:
                    return e.isStatic(Ie) === e.isStatic(_e);
                  case 261:
                    return j(Ie, _e) && Fe(Ie) === Fe(_e);
                  default:
                    return true;
                }
              }
              function Y(Ie) {
                return !!(Ie.flags & 8);
              }
              function U(Ie, _e) {
                var we = e.isModuleBlock(Ie.parent) ? Ie.parent.parent : Ie.parent;
                return we === _e.node || e.contains(_e.additionalNodes, we);
              }
              function j(Ie, _e) {
                return !Ie.body || !_e.body ? Ie.body === _e.body : Ie.body.kind === _e.body.kind && (Ie.body.kind !== 261 || j(Ie.body, _e.body));
              }
              function H(Ie, _e) {
                var we;
                Ie.additionalNodes = Ie.additionalNodes || [], Ie.additionalNodes.push(_e.node), _e.additionalNodes && (we = Ie.additionalNodes).push.apply(we, _e.additionalNodes), Ie.children = e.concatenate(Ie.children, _e.children), Ie.children && (y(Ie.children, Ie), I(Ie.children));
              }
              function I(Ie) {
                Ie.sort(l);
              }
              function l(Ie, _e) {
                return e.compareStringsCaseSensitiveUI(d(Ie.node), d(_e.node)) || e.compareValues(se(Ie), se(_e));
              }
              function d(Ie) {
                if (Ie.kind === 261) return We(Ie);
                var _e = e.getNameOfDeclaration(Ie);
                if (_e && e.isPropertyName(_e)) {
                  var we = e.getPropertyNameForPropertyNameNode(_e);
                  return we && e.unescapeLeadingUnderscores(we);
                }
                switch (Ie.kind) {
                  case 213:
                  case 214:
                  case 226:
                    return ze(Ie);
                  default:
                    return;
                }
              }
              function D(Ie, _e) {
                if (Ie.kind === 261) return rr(We(Ie));
                if (_e) {
                  var we = e.isIdentifier(_e) ? _e.text : e.isElementAccessExpression(_e) ? "[".concat(b(_e.argumentExpression), "]") : b(_e);
                  if (we.length > 0) return rr(we);
                }
                switch (Ie.kind) {
                  case 305:
                    var de = Ie;
                    return e.isExternalModule(de) ? '"'.concat(e.escapeString(e.getBaseFileName(e.removeFileExtension(e.normalizePath(de.fileName)))), '"') : "<global>";
                  case 271:
                    return e.isExportAssignment(Ie) && Ie.isExportEquals ? "export=" : "default";
                  case 214:
                  case 256:
                  case 213:
                  case 257:
                  case 226:
                    return e.getSyntacticModifierFlags(Ie) & 512 ? "default" : ze(Ie);
                  case 171:
                    return "constructor";
                  case 175:
                    return "new()";
                  case 174:
                    return "()";
                  case 176:
                    return "[]";
                  default:
                    return "<unknown>";
                }
              }
              function fe(Ie) {
                var _e = [];
                function we(ye) {
                  if (de(ye) && (_e.push(ye), ye.children)) for (var Ae = 0, er = ye.children; Ae < er.length; Ae++) {
                    var ir = er[Ae];
                    we(ir);
                  }
                }
                return we(Ie), _e;
                function de(ye) {
                  if (ye.children) return true;
                  switch (se(ye)) {
                    case 257:
                    case 226:
                    case 260:
                    case 258:
                    case 261:
                    case 305:
                    case 259:
                    case 345:
                    case 338:
                      return true;
                    case 214:
                    case 256:
                    case 213:
                      return Ae(ye);
                    default:
                      return false;
                  }
                  function Ae(er) {
                    if (!er.node.body) return false;
                    switch (se(er.parent)) {
                      case 262:
                      case 305:
                      case 169:
                      case 171:
                        return true;
                      default:
                        return false;
                    }
                  }
                }
              }
              function g(Ie) {
                return { text: D(Ie.node, Ie.name), kind: e.getNodeKind(Ie.node), kindModifiers: Re(Ie.node), spans: ue(Ie), nameSpan: Ie.name && ge(Ie.name), childItems: e.map(Ie.children, g) };
              }
              function ne(Ie) {
                return { text: D(Ie.node, Ie.name), kind: e.getNodeKind(Ie.node), kindModifiers: Re(Ie.node), spans: ue(Ie), childItems: e.map(Ie.children, _e) || oe, indent: Ie.indent, bolded: false, grayed: false };
                function _e(we) {
                  return { text: D(we.node, we.name), kind: e.getNodeKind(we.node), kindModifiers: e.getNodeModifiers(we.node), spans: ue(we), childItems: oe, indent: 0, bolded: false, grayed: false };
                }
              }
              function ue(Ie) {
                var _e = [ge(Ie.node)];
                if (Ie.additionalNodes) for (var we = 0, de = Ie.additionalNodes; we < de.length; we++) {
                  var ye = de[we];
                  _e.push(ge(ye));
                }
                return _e;
              }
              function We(Ie) {
                return e.isAmbientModule(Ie) ? e.getTextOfNode(Ie.name) : Fe(Ie);
              }
              function Fe(Ie) {
                for (var _e = [e.getTextOfIdentifierOrLiteral(Ie.name)]; Ie.body && Ie.body.kind === 261; ) Ie = Ie.body, _e.push(e.getTextOfIdentifierOrLiteral(Ie.name));
                return _e.join(".");
              }
              function Z(Ie) {
                return Ie.body && e.isModuleDeclaration(Ie.body) ? Z(Ie.body) : Ie;
              }
              function Be(Ie) {
                return !Ie.name || Ie.name.kind === 162;
              }
              function ge(Ie) {
                return Ie.kind === 305 ? e.createTextSpanFromRange(Ie) : e.createTextSpanFromNode(Ie, le);
              }
              function Re(Ie) {
                return Ie.parent && Ie.parent.kind === 254 && (Ie = Ie.parent), e.getNodeModifiers(Ie);
              }
              function ze(Ie) {
                var _e = Ie.parent;
                if (Ie.name && e.getFullWidth(Ie.name) > 0) return rr(e.declarationNameToString(Ie.name));
                if (e.isVariableDeclaration(_e)) return rr(e.declarationNameToString(_e.name));
                if (e.isBinaryExpression(_e) && _e.operatorToken.kind === 63) return b(_e.left).replace(B, "");
                if (e.isPropertyAssignment(_e)) return b(_e.name);
                if (e.getSyntacticModifierFlags(Ie) & 512) return "default";
                if (e.isClassLike(Ie)) return "<class>";
                if (e.isCallExpression(_e)) {
                  var we = Ee(_e.expression);
                  if (we !== void 0) {
                    if (we = rr(we), we.length > E) return "".concat(we, " callback");
                    var de = rr(e.mapDefined(_e.arguments, function(ye) {
                      return e.isStringLiteralLike(ye) ? ye.getText(le) : void 0;
                    }).join(", "));
                    return "".concat(we, "(").concat(de, ") callback");
                  }
                }
                return "<function>";
              }
              function Ee(Ie) {
                if (e.isIdentifier(Ie)) return Ie.text;
                if (e.isPropertyAccessExpression(Ie)) {
                  var _e = Ee(Ie.expression), we = Ie.name.text;
                  return _e === void 0 ? we : "".concat(_e, ".").concat(we);
                } else return;
              }
              function He(Ie) {
                switch (Ie.kind) {
                  case 214:
                  case 213:
                  case 226:
                    return true;
                  default:
                    return false;
                }
              }
              function rr(Ie) {
                return Ie = Ie.length > E ? Ie.substring(0, E) + "..." : Ie, Ie.replace(/\\?(\r?\n|\r|\u2028|\u2029)/g, "");
              }
            })(a = e.NavigationBar || (e.NavigationBar = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w(x, X, $, A, y, V) {
                var L = e.textChanges.ChangeTracker.fromContext({ host: $, formatContext: X, preferences: y }), P = function(D) {
                  return e.stableSort(p(Q(D, x, A, V)), function(fe, g) {
                    return O(fe, g);
                  });
                }, k = B(x, x.statements.filter(e.isImportDeclaration));
                k.forEach(function(D) {
                  return d(D, P);
                });
                var Y = x.statements.filter(e.isExportDeclaration);
                d(Y, G);
                for (var U = 0, j = x.statements.filter(e.isAmbientModule); U < j.length; U++) {
                  var H = j[U];
                  if (!!H.body) {
                    var I = B(x, H.body.statements.filter(e.isImportDeclaration));
                    I.forEach(function(D) {
                      return d(D, P);
                    });
                    var l = H.body.statements.filter(e.isExportDeclaration);
                    d(l, G);
                  }
                }
                return L.getChanges();
                function d(D, fe) {
                  if (e.length(D) !== 0) {
                    e.suppressLeadingTrivia(D[0]);
                    var g = e.group(D, function(Z) {
                      return N(Z.moduleSpecifier);
                    }), ne = e.stableSort(g, function(Z, Be) {
                      return K(Z[0].moduleSpecifier, Be[0].moduleSpecifier);
                    }), ue = e.flatMap(ne, function(Z) {
                      return N(Z[0].moduleSpecifier) ? fe(Z) : Z;
                    });
                    if (ue.length === 0) L.deleteNodes(x, D, { trailingTriviaOption: e.textChanges.TrailingTriviaOption.Include }, true);
                    else {
                      var We = { leadingTriviaOption: e.textChanges.LeadingTriviaOption.Exclude, trailingTriviaOption: e.textChanges.TrailingTriviaOption.Include, suffix: e.getNewLineOrDefaultFromHost($, X.options) };
                      L.replaceNodeWithNodes(x, D[0], ue, We);
                      var Fe = L.nodeHasTrailingComment(x, D[0], We);
                      L.deleteNodes(x, D.slice(1), { trailingTriviaOption: e.textChanges.TrailingTriviaOption.Include }, Fe);
                    }
                  }
                }
              }
              C.organizeImports = w;
              function B(x, X) {
                for (var $ = e.createScanner(x.languageVersion, false, x.languageVariant), A = [], y = 0, V = 0, L = X; V < L.length; V++) {
                  var P = L[V];
                  E(x, P, $) && y++, A[y] || (A[y] = []), A[y].push(P);
                }
                return A;
              }
              function E(x, X, $) {
                var A = X.getFullStart(), y = X.getStart();
                $.setText(x.text, A, y - A);
                for (var V = 0; $.getTokenPos() < y; ) {
                  var L = $.scan();
                  if (L === 4 && (V++, V >= 2)) return true;
                }
                return false;
              }
              function Q(x, X, $, A) {
                if (A) return x;
                for (var y = $.getTypeChecker(), V = $.getCompilerOptions(), L = y.getJsxNamespace(X), P = y.getJsxFragmentFactory(X), k = !!(X.transformFlags & 2), Y = [], U = 0, j = x; U < j.length; U++) {
                  var H = j[U], I = H.importClause, l = H.moduleSpecifier;
                  if (!I) {
                    Y.push(H);
                    continue;
                  }
                  var d = I.name, D = I.namedBindings;
                  if (d && !g(d) && (d = void 0), D) if (e.isNamespaceImport(D)) g(D.name) || (D = void 0);
                  else {
                    var fe = D.elements.filter(function(ne) {
                      return g(ne.name);
                    });
                    fe.length < D.elements.length && (D = fe.length ? e.factory.updateNamedImports(D, fe) : void 0);
                  }
                  d || D ? Y.push(oe(H, d, D)) : le(X, l) && (X.isDeclarationFile ? Y.push(e.factory.createImportDeclaration(H.decorators, H.modifiers, void 0, l, void 0)) : Y.push(H));
                }
                return Y;
                function g(ne) {
                  return k && (ne.text === L || P && ne.text === P) && e.jsxModeNeedsExplicitImport(V.jsx) || e.FindAllReferences.Core.isSymbolReferencedInFile(ne, y, X);
                }
              }
              function le(x, X) {
                var $ = e.isStringLiteral(X) && X.text;
                return e.isString($) && e.some(x.moduleAugmentations, function(A) {
                  return e.isStringLiteral(A) && A.text === $;
                });
              }
              function N(x) {
                return x !== void 0 && e.isStringLiteralLike(x) ? x.text : void 0;
              }
              function p(x) {
                var X;
                if (x.length === 0) return x;
                var $ = m(x), A = $.importWithoutClause, y = $.typeOnlyImports, V = $.regularImports, L = [];
                A && L.push(A);
                for (var P = 0, k = [V, y]; P < k.length; P++) {
                  var Y = k[P], U = Y === y, j = Y.defaultImports, H = Y.namespaceImports, I = Y.namedImports;
                  if (!U && j.length === 1 && H.length === 1 && I.length === 0) {
                    var l = j[0];
                    L.push(oe(l, l.importClause.name, H[0].importClause.namedBindings));
                    continue;
                  }
                  for (var d = e.stableSort(H, function(Re, ze) {
                    return b(Re.importClause.namedBindings.name, ze.importClause.namedBindings.name);
                  }), D = 0, fe = d; D < fe.length; D++) {
                    var g = fe[D];
                    L.push(oe(g, void 0, g.importClause.namedBindings));
                  }
                  if (!(j.length === 0 && I.length === 0)) {
                    var ne = void 0, ue = [];
                    if (j.length === 1) ne = j[0].importClause.name;
                    else for (var We = 0, Fe = j; We < Fe.length; We++) {
                      var l = Fe[We];
                      ue.push(e.factory.createImportSpecifier(false, e.factory.createIdentifier("default"), l.importClause.name));
                    }
                    ue.push.apply(ue, he(I));
                    var Z = f(ue), Be = j.length > 0 ? j[0] : I[0], ge = Z.length === 0 ? ne ? void 0 : e.factory.createNamedImports(e.emptyArray) : I.length === 0 ? e.factory.createNamedImports(Z) : e.factory.updateNamedImports(I[0].importClause.namedBindings, Z);
                    U && ne && ge ? (L.push(oe(Be, ne, void 0)), L.push(oe((X = I[0]) !== null && X !== void 0 ? X : Be, void 0, ge))) : L.push(oe(Be, ne, ge));
                  }
                }
                return L;
              }
              C.coalesceImports = p;
              function m(x) {
                for (var X, $ = { defaultImports: [], namespaceImports: [], namedImports: [] }, A = { defaultImports: [], namespaceImports: [], namedImports: [] }, y = 0, V = x; y < V.length; y++) {
                  var L = V[y];
                  if (L.importClause === void 0) {
                    X = X || L;
                    continue;
                  }
                  var P = L.importClause.isTypeOnly ? $ : A, k = L.importClause, Y = k.name, U = k.namedBindings;
                  Y && P.defaultImports.push(L), U && (e.isNamespaceImport(U) ? P.namespaceImports.push(L) : P.namedImports.push(L));
                }
                return { importWithoutClause: X, typeOnlyImports: $, regularImports: A };
              }
              function G(x) {
                if (x.length === 0) return x;
                var X = H(x), $ = X.exportWithoutClause, A = X.namedExports, y = X.typeOnlyExports, V = [];
                $ && V.push($);
                for (var L = 0, P = [A, y]; L < P.length; L++) {
                  var k = P[L];
                  if (k.length !== 0) {
                    var Y = [];
                    Y.push.apply(Y, e.flatMap(k, function(I) {
                      return I.exportClause && e.isNamedExports(I.exportClause) ? I.exportClause.elements : e.emptyArray;
                    }));
                    var U = f(Y), j = k[0];
                    V.push(e.factory.updateExportDeclaration(j, j.decorators, j.modifiers, j.isTypeOnly, j.exportClause && (e.isNamedExports(j.exportClause) ? e.factory.updateNamedExports(j.exportClause, U) : e.factory.updateNamespaceExport(j.exportClause, j.exportClause.name)), j.moduleSpecifier, j.assertClause));
                  }
                }
                return V;
                function H(I) {
                  for (var l, d = [], D = [], fe = 0, g = I; fe < g.length; fe++) {
                    var ne = g[fe];
                    ne.exportClause === void 0 ? l = l || ne : ne.isTypeOnly ? D.push(ne) : d.push(ne);
                  }
                  return { exportWithoutClause: l, namedExports: d, typeOnlyExports: D };
                }
              }
              C.coalesceExports = G;
              function oe(x, X, $) {
                return e.factory.updateImportDeclaration(x, x.decorators, x.modifiers, e.factory.updateImportClause(x.importClause, x.importClause.isTypeOnly, X, $), x.moduleSpecifier, x.assertClause);
              }
              function f(x) {
                return e.stableSort(x, T);
              }
              function T(x, X) {
                return e.compareBooleans(x.isTypeOnly, X.isTypeOnly) || b(x.propertyName || x.name, X.propertyName || X.name) || b(x.name, X.name);
              }
              C.compareImportOrExportSpecifiers = T;
              function K(x, X) {
                var $ = x === void 0 ? void 0 : N(x), A = X === void 0 ? void 0 : N(X);
                return e.compareBooleans($ === void 0, A === void 0) || e.compareBooleans(e.isExternalModuleNameRelative($), e.isExternalModuleNameRelative(A)) || e.compareStringsCaseInsensitive($, A);
              }
              C.compareModuleSpecifiers = K;
              function b(x, X) {
                return e.compareStringsCaseInsensitive(x.text, X.text);
              }
              function se(x) {
                var X;
                switch (x.kind) {
                  case 265:
                    return (X = e.tryCast(x.moduleReference, e.isExternalModuleReference)) === null || X === void 0 ? void 0 : X.expression;
                  case 266:
                    return x.moduleSpecifier;
                  case 237:
                    return x.declarationList.declarations[0].initializer.arguments[0];
                }
              }
              function J(x) {
                return e.arrayIsSorted(x, O);
              }
              C.importsAreSorted = J;
              function ie(x) {
                return e.arrayIsSorted(x, T);
              }
              C.importSpecifiersAreSorted = ie;
              function R(x, X) {
                var $ = e.binarySearch(x, X, e.identity, O);
                return $ < 0 ? ~$ : $;
              }
              C.getImportDeclarationInsertionIndex = R;
              function q(x, X) {
                var $ = e.binarySearch(x, X, e.identity, T);
                return $ < 0 ? ~$ : $;
              }
              C.getImportSpecifierInsertionIndex = q;
              function O(x, X) {
                return K(se(x), se(X)) || ve(x, X);
              }
              C.compareImportsOrRequireStatements = O;
              function ve(x, X) {
                return e.compareValues(ee(x), ee(X));
              }
              function ee(x) {
                var X;
                switch (x.kind) {
                  case 266:
                    return x.importClause ? x.importClause.isTypeOnly ? 1 : ((X = x.importClause.namedBindings) === null || X === void 0 ? void 0 : X.kind) === 268 ? 2 : x.importClause.name ? 3 : 4 : 0;
                  case 265:
                    return 5;
                  case 237:
                    return 6;
                }
              }
              function he(x) {
                return e.flatMap(x, function(X) {
                  return e.map(F(X), function($) {
                    return $.name && $.propertyName && $.name.escapedText === $.propertyName.escapedText ? e.factory.updateImportSpecifier($, $.isTypeOnly, void 0, $.name) : $;
                  });
                });
              }
              function F(x) {
                var X;
                return ((X = x.importClause) === null || X === void 0 ? void 0 : X.namedBindings) && e.isNamedImports(x.importClause.namedBindings) ? x.importClause.namedBindings.elements : void 0;
              }
            })(a = e.OrganizeImports || (e.OrganizeImports = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w(b, se) {
                var J = [];
                return B(b, se, J), E(b, J), J.sort(function(ie, R) {
                  return ie.textSpan.start - R.textSpan.start;
                });
              }
              C.collectElements = w;
              function B(b, se, J) {
                for (var ie = 40, R = 0, q = Ve(Ve([], b.statements, true), [b.endOfFileToken], false), O = q.length; R < O; ) {
                  for (; R < O && !e.isAnyImportSyntax(q[R]); ) he(q[R]), R++;
                  if (R === O) break;
                  for (var ve = R; R < O && e.isAnyImportSyntax(q[R]); ) p(q[R], b, se, J), R++;
                  var ee = R - 1;
                  ee !== ve && J.push(m(e.findChildOfKind(q[ve], 100, b).getStart(b), q[ee].getEnd(), "imports"));
                }
                function he(F) {
                  var x;
                  if (ie !== 0) {
                    se.throwIfCancellationRequested(), (e.isDeclaration(F) || e.isVariableStatement(F) || e.isReturnStatement(F) || e.isCallOrNewExpression(F) || F.kind === 1) && p(F, b, se, J), e.isFunctionLike(F) && e.isBinaryExpression(F.parent) && e.isPropertyAccessExpression(F.parent.left) && p(F.parent.left, b, se, J), (e.isBlock(F) || e.isModuleBlock(F)) && N(F.statements.end, b, se, J), (e.isClassLike(F) || e.isInterfaceDeclaration(F)) && N(F.members.end, b, se, J);
                    var X = G(F, b);
                    X && J.push(X), ie--, e.isCallExpression(F) ? (ie++, he(F.expression), ie--, F.arguments.forEach(he), (x = F.typeArguments) === null || x === void 0 || x.forEach(he)) : e.isIfStatement(F) && F.elseStatement && e.isIfStatement(F.elseStatement) ? (he(F.expression), he(F.thenStatement), ie++, he(F.elseStatement), ie--) : F.forEachChild(he), ie++;
                  }
                }
              }
              function E(b, se) {
                for (var J = [], ie = b.getLineStarts(), R = 0, q = ie; R < q.length; R++) {
                  var O = q[R], ve = b.getLineEndOfPosition(O), ee = b.text.substring(O, ve), he = le(ee);
                  if (!(!he || e.isInComment(b, O))) if (he[1]) {
                    var x = J.pop();
                    x && (x.textSpan.length = ve - x.textSpan.start, x.hintSpan.length = ve - x.textSpan.start, se.push(x));
                  } else {
                    var F = e.createTextSpanFromBounds(b.text.indexOf("//", O), ve);
                    J.push(T(F, "region", F, false, he[2] || "#region"));
                  }
                }
              }
              var Q = /^#(end)?region(?:\s+(.*))?(?:\r)?$/;
              function le(b) {
                return b = e.trimStringStart(b), e.startsWith(b, "//") ? (b = e.trimString(b.slice(2)), Q.exec(b)) : null;
              }
              function N(b, se, J, ie) {
                var R = e.getLeadingCommentRanges(se.text, b);
                if (!R) return;
                for (var q = -1, O = -1, ve = 0, ee = se.getFullText(), he = 0, F = R; he < F.length; he++) {
                  var x = F[he], X = x.kind, $ = x.pos, A = x.end;
                  switch (J.throwIfCancellationRequested(), X) {
                    case 2:
                      var y = ee.slice($, A);
                      if (le(y)) {
                        V(), ve = 0;
                        break;
                      }
                      ve === 0 && (q = $), O = A, ve++;
                      break;
                    case 3:
                      V(), ie.push(m($, A, "comment")), ve = 0;
                      break;
                    default:
                      e.Debug.assertNever(X);
                  }
                }
                V();
                function V() {
                  ve > 1 && ie.push(m(q, O, "comment"));
                }
              }
              function p(b, se, J, ie) {
                e.isJsxText(b) || N(b.pos, se, J, ie);
              }
              function m(b, se, J) {
                return T(e.createTextSpanFromBounds(b, se), J);
              }
              function G(b, se) {
                switch (b.kind) {
                  case 235:
                    if (e.isFunctionLike(b.parent)) return oe(b.parent, b, se);
                    switch (b.parent.kind) {
                      case 240:
                      case 243:
                      case 244:
                      case 242:
                      case 239:
                      case 241:
                      case 248:
                      case 292:
                        return x(b.parent);
                      case 252:
                        var J = b.parent;
                        if (J.tryBlock === b) return x(b.parent);
                        if (J.finallyBlock === b) {
                          var ie = e.findChildOfKind(J, 96, se);
                          if (ie) return x(ie);
                        }
                      default:
                        return T(e.createTextSpanFromNode(b, se), "code");
                    }
                  case 262:
                    return x(b.parent);
                  case 257:
                  case 226:
                  case 258:
                  case 260:
                  case 263:
                  case 182:
                  case 201:
                    return x(b);
                  case 184:
                    return x(b, false, !e.isTupleTypeNode(b.parent), 22);
                  case 289:
                  case 290:
                    return X(b.statements);
                  case 205:
                    return F(b);
                  case 204:
                    return F(b, 22);
                  case 278:
                    return O(b);
                  case 282:
                    return ve(b);
                  case 279:
                  case 280:
                    return ee(b.attributes);
                  case 223:
                  case 14:
                    return he(b);
                  case 202:
                    return x(b, false, !e.isBindingElement(b.parent), 22);
                  case 214:
                    return q(b);
                  case 208:
                    return R(b);
                  case 212:
                    return $(b);
                }
                function R(A) {
                  if (!!A.arguments.length) {
                    var y = e.findChildOfKind(A, 20, se), V = e.findChildOfKind(A, 21, se);
                    if (!(!y || !V || e.positionsAreOnSameLine(y.pos, V.pos, se))) return f(y, V, A, se, false, true);
                  }
                }
                function q(A) {
                  if (!(e.isBlock(A.body) || e.isParenthesizedExpression(A.body) || e.positionsAreOnSameLine(A.body.getFullStart(), A.body.getEnd(), se))) {
                    var y = e.createTextSpanFromBounds(A.body.getFullStart(), A.body.getEnd());
                    return T(y, "code", e.createTextSpanFromNode(A));
                  }
                }
                function O(A) {
                  var y = e.createTextSpanFromBounds(A.openingElement.getStart(se), A.closingElement.getEnd()), V = A.openingElement.tagName.getText(se), L = "<" + V + ">...</" + V + ">";
                  return T(y, "code", y, false, L);
                }
                function ve(A) {
                  var y = e.createTextSpanFromBounds(A.openingFragment.getStart(se), A.closingFragment.getEnd()), V = "<>...</>";
                  return T(y, "code", y, false, V);
                }
                function ee(A) {
                  if (A.properties.length !== 0) return m(A.getStart(se), A.getEnd(), "code");
                }
                function he(A) {
                  if (!(A.kind === 14 && A.text.length === 0)) return m(A.getStart(se), A.getEnd(), "code");
                }
                function F(A, y) {
                  return y === void 0 && (y = 18), x(A, false, !e.isArrayLiteralExpression(A.parent) && !e.isCallExpression(A.parent), y);
                }
                function x(A, y, V, L, P) {
                  y === void 0 && (y = false), V === void 0 && (V = true), L === void 0 && (L = 18), P === void 0 && (P = L === 18 ? 19 : 23);
                  var k = e.findChildOfKind(b, L, se), Y = e.findChildOfKind(b, P, se);
                  return k && Y && f(k, Y, A, se, y, V);
                }
                function X(A) {
                  return A.length ? T(e.createTextSpanFromRange(A), "code") : void 0;
                }
                function $(A) {
                  if (!e.positionsAreOnSameLine(A.getStart(), A.getEnd(), se)) {
                    var y = e.createTextSpanFromBounds(A.getStart(), A.getEnd());
                    return T(y, "code", e.createTextSpanFromNode(A));
                  }
                }
              }
              function oe(b, se, J) {
                var ie = K(b, se, J), R = e.findChildOfKind(se, 19, J);
                return ie && R && f(ie, R, b, J, b.kind !== 214);
              }
              function f(b, se, J, ie, R, q) {
                R === void 0 && (R = false), q === void 0 && (q = true);
                var O = e.createTextSpanFromBounds(q ? b.getFullStart() : b.getStart(ie), se.getEnd());
                return T(O, "code", e.createTextSpanFromNode(J, ie), R);
              }
              function T(b, se, J, ie, R) {
                return J === void 0 && (J = b), ie === void 0 && (ie = false), R === void 0 && (R = "..."), { textSpan: b, kind: se, hintSpan: J, bannerText: R, autoCollapse: ie };
              }
              function K(b, se, J) {
                if (e.isNodeArrayMultiLine(b.parameters, J)) {
                  var ie = e.findChildOfKind(b, 20, J);
                  if (ie) return ie;
                }
                return e.findChildOfKind(se, 18, J);
              }
            })(a = e.OutliningElementsCollector || (e.OutliningElementsCollector = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(y) {
              y[y.exact = 0] = "exact", y[y.prefix = 1] = "prefix", y[y.substring = 2] = "substring", y[y.camelCase = 3] = "camelCase";
            })(a = e.PatternMatchKind || (e.PatternMatchKind = {}));
            function C(y, V) {
              return { kind: y, isCaseSensitive: V };
            }
            function w(y) {
              var V = new e.Map(), L = y.trim().split(".").map(function(P) {
                return f(P.trim());
              });
              if (!L.some(function(P) {
                return !P.subWordTextChunks.length;
              })) return { getFullMatch: function(P, k) {
                return B(P, k, L, V);
              }, getMatchForLastSegmentOfPattern: function(P) {
                return le(P, e.last(L), V);
              }, patternContainsDots: L.length > 1 };
            }
            e.createPatternMatcher = w;
            function B(y, V, L, P) {
              var k = le(V, e.last(L), P);
              if (!!k && !(L.length - 1 > y.length)) {
                for (var Y, U = L.length - 2, j = y.length - 1; U >= 0; U -= 1, j -= 1) Y = N(Y, le(y[j], L[U], P));
                return Y;
              }
            }
            function E(y, V) {
              var L = V.get(y);
              return L || V.set(y, L = ve(y)), L;
            }
            function Q(y, V, L) {
              var P = b(y, V.textLowerCase);
              if (P === 0) return C(V.text.length === y.length ? a.exact : a.prefix, e.startsWith(y, V.text));
              if (V.isLowerCase) {
                if (P === -1) return;
                for (var k = E(y, L), Y = 0, U = k; Y < U.length; Y++) {
                  var j = U[Y];
                  if (m(y, j, V.text, true)) return C(a.substring, m(y, j, V.text, false));
                }
                if (V.text.length < y.length && T(y.charCodeAt(P))) return C(a.substring, false);
              } else {
                if (y.indexOf(V.text) > 0) return C(a.substring, true);
                if (V.characterSpans.length > 0) {
                  var H = E(y, L), I = oe(y, H, V, false) ? true : oe(y, H, V, true) ? false : void 0;
                  if (I !== void 0) return C(a.camelCase, I);
                }
              }
            }
            function le(y, V, L) {
              if (A(V.totalTextChunk.text, function(I) {
                return I !== 32 && I !== 42;
              })) {
                var P = Q(y, V.totalTextChunk, L);
                if (P) return P;
              }
              for (var k = V.subWordTextChunks, Y, U = 0, j = k; U < j.length; U++) {
                var H = j[U];
                Y = N(Y, Q(y, H, L));
              }
              return Y;
            }
            function N(y, V) {
              return e.min(y, V, p);
            }
            function p(y, V) {
              return y === void 0 ? 1 : V === void 0 ? -1 : e.compareValues(y.kind, V.kind) || e.compareBooleans(!y.isCaseSensitive, !V.isCaseSensitive);
            }
            function m(y, V, L, P, k) {
              return k === void 0 && (k = { start: 0, length: L.length }), k.length <= V.length && $(0, k.length, function(Y) {
                return G(L.charCodeAt(k.start + Y), y.charCodeAt(V.start + Y), P);
              });
            }
            function G(y, V, L) {
              return L ? se(y) === se(V) : y === V;
            }
            function oe(y, V, L, P) {
              for (var k = L.characterSpans, Y = 0, U = 0, j, H; ; ) {
                if (U === k.length) return true;
                if (Y === V.length) return false;
                for (var I = V[Y], l = false; U < k.length; U++) {
                  var d = k[U];
                  if (l && (!T(L.text.charCodeAt(k[U - 1].start)) || !T(L.text.charCodeAt(k[U].start))) || !m(y, I, L.text, P, d)) break;
                  l = true, j = j === void 0 ? Y : j, H = H === void 0 ? true : H, I = e.createTextSpan(I.start + d.length, I.length - d.length);
                }
                !l && H !== void 0 && (H = false), Y++;
              }
            }
            function f(y) {
              return { totalTextChunk: q(y), subWordTextChunks: R(y) };
            }
            function T(y) {
              if (y >= 65 && y <= 90) return true;
              if (y < 127 || !e.isUnicodeIdentifierStart(y, 99)) return false;
              var V = String.fromCharCode(y);
              return V === V.toUpperCase();
            }
            function K(y) {
              if (y >= 97 && y <= 122) return true;
              if (y < 127 || !e.isUnicodeIdentifierStart(y, 99)) return false;
              var V = String.fromCharCode(y);
              return V === V.toLowerCase();
            }
            function b(y, V) {
              for (var L = y.length - V.length, P = function(U) {
                if (A(V, function(j, H) {
                  return se(y.charCodeAt(H + U)) === j;
                })) return { value: U };
              }, k = 0; k <= L; k++) {
                var Y = P(k);
                if (typeof Y == "object") return Y.value;
              }
              return -1;
            }
            function se(y) {
              return y >= 65 && y <= 90 ? 97 + (y - 65) : y < 127 ? y : String.fromCharCode(y).toLowerCase().charCodeAt(0);
            }
            function J(y) {
              return y >= 48 && y <= 57;
            }
            function ie(y) {
              return T(y) || K(y) || J(y) || y === 95 || y === 36;
            }
            function R(y) {
              for (var V = [], L = 0, P = 0, k = 0; k < y.length; k++) {
                var Y = y.charCodeAt(k);
                ie(Y) ? (P === 0 && (L = k), P++) : P > 0 && (V.push(q(y.substr(L, P))), P = 0);
              }
              return P > 0 && V.push(q(y.substr(L, P))), V;
            }
            function q(y) {
              var V = y.toLowerCase();
              return { text: y, textLowerCase: V, isLowerCase: y === V, characterSpans: O(y) };
            }
            function O(y) {
              return ee(y, false);
            }
            e.breakIntoCharacterSpans = O;
            function ve(y) {
              return ee(y, true);
            }
            e.breakIntoWordSpans = ve;
            function ee(y, V) {
              for (var L = [], P = 0, k = 1; k < y.length; k++) {
                var Y = J(y.charCodeAt(k - 1)), U = J(y.charCodeAt(k)), j = X(y, V, k), H = V && x(y, k, P);
                (he(y.charCodeAt(k - 1)) || he(y.charCodeAt(k)) || Y !== U || j || H) && (F(y, P, k) || L.push(e.createTextSpan(P, k - P)), P = k);
              }
              return F(y, P, y.length) || L.push(e.createTextSpan(P, y.length - P)), L;
            }
            function he(y) {
              switch (y) {
                case 33:
                case 34:
                case 35:
                case 37:
                case 38:
                case 39:
                case 40:
                case 41:
                case 42:
                case 44:
                case 45:
                case 46:
                case 47:
                case 58:
                case 59:
                case 63:
                case 64:
                case 91:
                case 92:
                case 93:
                case 95:
                case 123:
                case 125:
                  return true;
              }
              return false;
            }
            function F(y, V, L) {
              return A(y, function(P) {
                return he(P) && P !== 95;
              }, V, L);
            }
            function x(y, V, L) {
              return V !== L && V + 1 < y.length && T(y.charCodeAt(V)) && K(y.charCodeAt(V + 1)) && A(y, T, L, V);
            }
            function X(y, V, L) {
              var P = T(y.charCodeAt(L - 1)), k = T(y.charCodeAt(L));
              return k && (!V || !P);
            }
            function $(y, V, L) {
              for (var P = y; P < V; P++) if (!L(P)) return false;
              return true;
            }
            function A(y, V, L, P) {
              return L === void 0 && (L = 0), P === void 0 && (P = y.length), $(L, P, function(k) {
                return V(y.charCodeAt(k), k);
              });
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(C, w, B) {
              w === void 0 && (w = true), B === void 0 && (B = false);
              var E = { languageVersion: 1, pragmas: void 0, checkJsDirective: void 0, referencedFiles: [], typeReferenceDirectives: [], libReferenceDirectives: [], amdDependencies: [], hasNoDefaultLib: void 0, moduleName: void 0 }, Q = [], le, N, p, m = 0, G = false;
              function oe() {
                return N = p, p = e.scanner.scan(), p === 18 ? m++ : p === 19 && m--, p;
              }
              function f() {
                var $ = e.scanner.getTokenValue(), A = e.scanner.getTokenPos();
                return { fileName: $, pos: A, end: A + $.length };
              }
              function T() {
                le || (le = []), le.push({ ref: f(), depth: m });
              }
              function K() {
                Q.push(f()), b();
              }
              function b() {
                m === 0 && (G = true);
              }
              function se() {
                var $ = e.scanner.getToken();
                return $ === 135 ? ($ = oe(), $ === 141 && ($ = oe(), $ === 10 && T()), true) : false;
              }
              function J() {
                if (N === 24) return false;
                var $ = e.scanner.getToken();
                if ($ === 100) {
                  if ($ = oe(), $ === 20) {
                    if ($ = oe(), $ === 10 || $ === 14) return K(), true;
                  } else {
                    if ($ === 10) return K(), true;
                    if ($ === 152) {
                      var A = e.scanner.lookAhead(function() {
                        var y = e.scanner.scan();
                        return y !== 156 && (y === 41 || y === 18 || y === 79 || e.isKeyword(y));
                      });
                      A && ($ = oe());
                    }
                    if ($ === 79 || e.isKeyword($)) if ($ = oe(), $ === 156) {
                      if ($ = oe(), $ === 10) return K(), true;
                    } else if ($ === 63) {
                      if (R(true)) return true;
                    } else if ($ === 27) $ = oe();
                    else return true;
                    if ($ === 18) {
                      for ($ = oe(); $ !== 19 && $ !== 1; ) $ = oe();
                      $ === 19 && ($ = oe(), $ === 156 && ($ = oe(), $ === 10 && K()));
                    } else $ === 41 && ($ = oe(), $ === 127 && ($ = oe(), ($ === 79 || e.isKeyword($)) && ($ = oe(), $ === 156 && ($ = oe(), $ === 10 && K()))));
                  }
                  return true;
                }
                return false;
              }
              function ie() {
                var $ = e.scanner.getToken();
                if ($ === 93) {
                  if (b(), $ = oe(), $ === 152) {
                    var A = e.scanner.lookAhead(function() {
                      var y = e.scanner.scan();
                      return y === 41 || y === 18;
                    });
                    A && ($ = oe());
                  }
                  if ($ === 18) {
                    for ($ = oe(); $ !== 19 && $ !== 1; ) $ = oe();
                    $ === 19 && ($ = oe(), $ === 156 && ($ = oe(), $ === 10 && K()));
                  } else if ($ === 41) $ = oe(), $ === 156 && ($ = oe(), $ === 10 && K());
                  else if ($ === 100) {
                    if ($ = oe(), $ === 152) {
                      var A = e.scanner.lookAhead(function() {
                        var V = e.scanner.scan();
                        return V === 79 || e.isKeyword(V);
                      });
                      A && ($ = oe());
                    }
                    if (($ === 79 || e.isKeyword($)) && ($ = oe(), $ === 63 && R(true))) return true;
                  }
                  return true;
                }
                return false;
              }
              function R($, A) {
                A === void 0 && (A = false);
                var y = $ ? oe() : e.scanner.getToken();
                return y === 146 ? (y = oe(), y === 20 && (y = oe(), (y === 10 || A && y === 14) && K()), true) : false;
              }
              function q() {
                var $ = e.scanner.getToken();
                if ($ === 79 && e.scanner.getTokenValue() === "define") {
                  if ($ = oe(), $ !== 20) return true;
                  if ($ = oe(), $ === 10 || $ === 14) if ($ = oe(), $ === 27) $ = oe();
                  else return true;
                  if ($ !== 22) return true;
                  for ($ = oe(); $ !== 23 && $ !== 1; ) ($ === 10 || $ === 14) && K(), $ = oe();
                  return true;
                }
                return false;
              }
              function O() {
                for (e.scanner.setText(C), oe(); e.scanner.getToken() !== 1; ) {
                  if (e.scanner.getToken() === 15) {
                    var $ = [e.scanner.getToken()], A = e.scanner.scan();
                    e: for (; e.length($); ) {
                      switch (A) {
                        case 1:
                          break e;
                        case 100:
                          J();
                          break;
                        case 15:
                          $.push(A);
                          break;
                        case 18:
                          e.length($) && $.push(A);
                          break;
                        case 19:
                          e.length($) && (e.lastOrUndefined($) === 15 ? e.scanner.reScanTemplateToken(false) === 17 && $.pop() : $.pop());
                          break;
                      }
                      A = e.scanner.scan();
                    }
                    oe();
                  }
                  se() || J() || ie() || B && (R(false, true) || q()) || oe();
                }
                e.scanner.setText(void 0);
              }
              if (w && O(), e.processCommentPragmas(E, C), e.processPragmasIntoFields(E, e.noop), G) {
                if (le) for (var ve = 0, ee = le; ve < ee.length; ve++) {
                  var he = ee[ve];
                  Q.push(he.ref);
                }
                return { referencedFiles: E.referencedFiles, typeReferenceDirectives: E.typeReferenceDirectives, libReferenceDirectives: E.libReferenceDirectives, importedFiles: Q, isLibFile: !!E.hasNoDefaultLib, ambientExternalModules: void 0 };
              } else {
                var F = void 0;
                if (le) for (var x = 0, X = le; x < X.length; x++) {
                  var he = X[x];
                  he.depth === 0 ? (F || (F = []), F.push(he.ref.fileName)) : Q.push(he.ref);
                }
                return { referencedFiles: E.referencedFiles, typeReferenceDirectives: E.typeReferenceDirectives, libReferenceDirectives: E.libReferenceDirectives, importedFiles: Q, isLibFile: !!E.hasNoDefaultLib, ambientExternalModules: F };
              }
            }
            e.preProcessFile = a;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w(G, oe, f, T) {
                var K = e.getAdjustedRenameLocation(e.getTouchingPropertyName(oe, f));
                if (m(K)) {
                  var b = B(K, G.getTypeChecker(), oe, G, T);
                  if (b) return b;
                }
                return N(e.Diagnostics.You_cannot_rename_this_element);
              }
              C.getRenameInfo = w;
              function B(G, oe, f, T, K) {
                var b = oe.getSymbolAtLocation(G);
                if (!b) {
                  if (e.isStringLiteralLike(G)) {
                    var se = e.getContextualTypeFromParentOrAncestorTypeNode(G, oe);
                    if (se && (se.flags & 128 || se.flags & 1048576 && e.every(se.types, function(ee) {
                      return !!(ee.flags & 128);
                    }))) return le(G.text, G.text, "string", "", G, f);
                  } else if (e.isLabelName(G)) {
                    var J = e.getTextOfNode(G);
                    return le(J, J, "label", "", G, f);
                  }
                  return;
                }
                var ie = b.declarations;
                if (!(!ie || ie.length === 0)) {
                  if (ie.some(function(ee) {
                    return E(T, ee);
                  })) return N(e.Diagnostics.You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library);
                  if (!(e.isIdentifier(G) && G.originalKeywordKind === 88 && b.parent && b.parent.flags & 1536)) {
                    if (e.isStringLiteralLike(G) && e.tryGetImportFromModuleSpecifier(G)) return K && K.allowRenameOfImportPath ? Q(G, f, b) : void 0;
                    var R = e.SymbolDisplay.getSymbolKind(oe, b, G), q = e.isImportOrExportSpecifierName(G) || e.isStringOrNumericLiteralLike(G) && G.parent.kind === 162 ? e.stripQuotes(e.getTextOfIdentifierOrLiteral(G)) : void 0, O = q || oe.symbolToString(b), ve = q || oe.getFullyQualifiedName(b);
                    return le(O, ve, R, e.SymbolDisplay.getSymbolModifiers(oe, b), G, f);
                  }
                }
              }
              function E(G, oe) {
                var f = oe.getSourceFile();
                return G.isSourceFileDefaultLibrary(f) && e.fileExtensionIs(f.fileName, ".d.ts");
              }
              function Q(G, oe, f) {
                if (!e.isExternalModuleNameRelative(G.text)) return N(e.Diagnostics.You_cannot_rename_a_module_via_a_global_import);
                var T = f.declarations && e.find(f.declarations, e.isSourceFile);
                if (!!T) {
                  var K = e.endsWith(G.text, "/index") || e.endsWith(G.text, "/index.js") ? void 0 : e.tryRemoveSuffix(e.removeFileExtension(T.fileName), "/index"), b = K === void 0 ? T.fileName : K, se = K === void 0 ? "module" : "directory", J = G.text.lastIndexOf("/") + 1, ie = e.createTextSpan(G.getStart(oe) + 1 + J, G.text.length - J);
                  return { canRename: true, fileToRename: b, kind: se, displayName: b, fullDisplayName: b, kindModifiers: "", triggerSpan: ie };
                }
              }
              function le(G, oe, f, T, K, b) {
                return { canRename: true, fileToRename: void 0, kind: f, displayName: G, fullDisplayName: oe, kindModifiers: T, triggerSpan: p(K, b) };
              }
              function N(G) {
                return { canRename: false, localizedErrorMessage: e.getLocaleSpecificMessage(G) };
              }
              function p(G, oe) {
                var f = G.getStart(oe), T = G.getWidth(oe);
                return e.isStringLiteralLike(G) && (f += 1, T -= 2), e.createTextSpan(f, T);
              }
              function m(G) {
                switch (G.kind) {
                  case 79:
                  case 80:
                  case 10:
                  case 14:
                  case 108:
                    return true;
                  case 8:
                    return e.isLiteralNameOfPropertyDeclarationOrIndexAccess(G);
                  default:
                    return false;
                }
              }
              C.nodeIsEligibleForRename = m;
            })(a = e.Rename || (e.Rename = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w(f, T) {
                var K, b = { textSpan: e.createTextSpanFromBounds(T.getFullStart(), T.getEnd()) }, se = T;
                e: for (; ; ) {
                  var J = Q(se);
                  if (!J.length) break;
                  for (var ie = 0; ie < J.length; ie++) {
                    var R = J[ie - 1], q = J[ie], O = J[ie + 1];
                    if (e.getTokenPosOfNode(q, T, true) > f) break e;
                    var ve = e.singleOrUndefined(e.getTrailingCommentRanges(T.text, q.end));
                    if (ve && ve.kind === 2 && A(ve.pos, ve.end), B(T, f, q)) {
                      if (e.isBlock(q) || e.isTemplateSpan(q) || e.isTemplateHead(q) || e.isTemplateTail(q) || R && e.isTemplateHead(R) || e.isVariableDeclarationList(q) && e.isVariableStatement(se) || e.isSyntaxList(q) && e.isVariableDeclarationList(se) || e.isVariableDeclaration(q) && e.isSyntaxList(se) && J.length === 1 || e.isJSDocTypeExpression(q) || e.isJSDocSignature(q) || e.isJSDocTypeLiteral(q)) {
                        se = q;
                        break;
                      }
                      if (e.isTemplateSpan(se) && O && e.isTemplateMiddleOrTemplateTail(O)) {
                        var ee = q.getFullStart() - 2, he = O.getStart() + 1;
                        $(ee, he);
                      }
                      var F = e.isSyntaxList(q) && m(R) && G(O) && !e.positionsAreOnSameLine(R.getStart(), O.getStart(), T), x = F ? R.getEnd() : q.getStart(), X = F ? O.getStart() : oe(T, q);
                      e.hasJSDocNodes(q) && ((K = q.jsDoc) === null || K === void 0 ? void 0 : K.length) && $(e.first(q.jsDoc).getStart(), X), $(x, X), (e.isStringLiteral(q) || e.isTemplateLiteral(q)) && $(x + 1, X - 1), se = q;
                      break;
                    }
                    if (ie === J.length - 1) break e;
                  }
                }
                return b;
                function $(y, V) {
                  if (y !== V) {
                    var L = e.createTextSpanFromBounds(y, V);
                    (!b || !e.textSpansEqual(L, b.textSpan) && e.textSpanIntersectsWithPosition(L, f)) && (b = Ke({ textSpan: L }, b && { parent: b }));
                  }
                }
                function A(y, V) {
                  $(y, V);
                  for (var L = y; T.text.charCodeAt(L) === 47; ) L++;
                  $(L, V);
                }
              }
              C.getSmartSelectionRange = w;
              function B(f, T, K) {
                if (e.Debug.assert(K.pos <= T), T < K.end) return true;
                var b = K.getEnd();
                return b === T ? e.getTouchingPropertyName(f, T).pos < K.end : false;
              }
              var E = e.or(e.isImportDeclaration, e.isImportEqualsDeclaration);
              function Q(f) {
                if (e.isSourceFile(f)) return le(f.getChildAt(0).getChildren(), E);
                if (e.isMappedTypeNode(f)) {
                  var T = f.getChildren(), K = T[0], b = T.slice(1), se = e.Debug.checkDefined(b.pop());
                  e.Debug.assertEqual(K.kind, 18), e.Debug.assertEqual(se.kind, 19);
                  var J = le(b, function(O) {
                    return O === f.readonlyToken || O.kind === 145 || O === f.questionToken || O.kind === 57;
                  }), ie = le(J, function(O) {
                    var ve = O.kind;
                    return ve === 22 || ve === 163 || ve === 23;
                  });
                  return [K, p(N(ie, function(O) {
                    var ve = O.kind;
                    return ve === 58;
                  })), se];
                }
                if (e.isPropertySignature(f)) {
                  var b = le(f.getChildren(), function(ve) {
                    return ve === f.name || e.contains(f.modifiers, ve);
                  });
                  return N(b, function(ve) {
                    var ee = ve.kind;
                    return ee === 58;
                  });
                }
                if (e.isParameter(f)) {
                  var R = le(f.getChildren(), function(O) {
                    return O === f.dotDotDotToken || O === f.name;
                  }), q = le(R, function(O) {
                    return O === R[0] || O === f.questionToken;
                  });
                  return N(q, function(O) {
                    var ve = O.kind;
                    return ve === 63;
                  });
                }
                return e.isBindingElement(f) ? N(f.getChildren(), function(O) {
                  var ve = O.kind;
                  return ve === 63;
                }) : f.getChildren();
              }
              function le(f, T) {
                for (var K = [], b, se = 0, J = f; se < J.length; se++) {
                  var ie = J[se];
                  T(ie) ? (b = b || [], b.push(ie)) : (b && (K.push(p(b)), b = void 0), K.push(ie));
                }
                return b && K.push(p(b)), K;
              }
              function N(f, T, K) {
                if (K === void 0 && (K = true), f.length < 2) return f;
                var b = e.findIndex(f, T);
                if (b === -1) return f;
                var se = f.slice(0, b), J = f[b], ie = e.last(f), R = K && ie.kind === 26, q = f.slice(b + 1, R ? f.length - 1 : void 0), O = e.compact([se.length ? p(se) : void 0, J, q.length ? p(q) : void 0]);
                return R ? O.concat(ie) : O;
              }
              function p(f) {
                return e.Debug.assertGreaterThanOrEqual(f.length, 1), e.setTextRangePosEnd(e.parseNodeFactory.createSyntaxList(f), f[0].pos, e.last(f).end);
              }
              function m(f) {
                var T = f && f.kind;
                return T === 18 || T === 22 || T === 20 || T === 280;
              }
              function G(f) {
                var T = f && f.kind;
                return T === 19 || T === 23 || T === 21 || T === 281;
              }
              function oe(f, T) {
                switch (T.kind) {
                  case 340:
                  case 338:
                  case 347:
                  case 345:
                  case 342:
                    return f.getLineEndOfPosition(T.getStart());
                  default:
                    return T.getEnd();
                }
              }
            })(a = e.SmartSelectionRange || (e.SmartSelectionRange = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w;
              (function(l) {
                l[l.Call = 0] = "Call", l[l.TypeArgs = 1] = "TypeArgs", l[l.Contextual = 2] = "Contextual";
              })(w || (w = {}));
              function B(l, d, D, fe, g) {
                var ne = l.getTypeChecker(), ue = e.findTokenOnLeftOfPosition(d, D);
                if (!!ue) {
                  var We = !!fe && fe.kind === "characterTyped";
                  if (!(We && (e.isInString(d, D, ue) || e.isInComment(d, D)))) {
                    var Fe = !!fe && fe.kind === "invoked", Z = F(ue, D, d, ne, Fe);
                    if (!!Z) {
                      g.throwIfCancellationRequested();
                      var Be = Q(Z, ne, d, ue, We);
                      return g.throwIfCancellationRequested(), Be ? ne.runWithCancellationToken(g, function(ge) {
                        return Be.kind === 0 ? y(Be.candidates, Be.resolvedSignature, Z, d, ge) : V(Be.symbol, Z, d, ge);
                      }) : e.isSourceFileJS(d) ? N(Z, l, g) : void 0;
                    }
                  }
                }
              }
              C.getSignatureHelpItems = B;
              var E;
              (function(l) {
                l[l.Candidate = 0] = "Candidate", l[l.Type = 1] = "Type";
              })(E || (E = {}));
              function Q(l, d, D, fe, g) {
                var ne = l.invocation, ue = l.argumentCount;
                switch (ne.kind) {
                  case 0: {
                    if (g && !le(fe, ne.node, D)) return;
                    var We = [], Fe = d.getResolvedSignatureForSignatureHelp(ne.node, We, ue);
                    return We.length === 0 ? void 0 : { kind: 0, candidates: We, resolvedSignature: Fe };
                  }
                  case 1: {
                    var Z = ne.called;
                    if (g && !p(fe, D, e.isIdentifier(Z) ? Z.parent : Z)) return;
                    var We = e.getPossibleGenericSignatures(Z, ue, d);
                    if (We.length !== 0) return { kind: 0, candidates: We, resolvedSignature: e.first(We) };
                    var Be = d.getSymbolAtLocation(Z);
                    return Be && { kind: 1, symbol: Be };
                  }
                  case 2:
                    return { kind: 0, candidates: [ne.signature], resolvedSignature: ne.signature };
                  default:
                    return e.Debug.assertNever(ne);
                }
              }
              function le(l, d, D) {
                if (!e.isCallOrNewExpression(d)) return false;
                var fe = d.getChildren(D);
                switch (l.kind) {
                  case 20:
                    return e.contains(fe, l);
                  case 27: {
                    var g = e.findContainingList(l);
                    return !!g && e.contains(fe, g);
                  }
                  case 29:
                    return p(l, D, d.expression);
                  default:
                    return false;
                }
              }
              function N(l, d, D) {
                if (l.invocation.kind !== 2) {
                  var fe = X(l.invocation), g = e.isPropertyAccessExpression(fe) ? fe.name.text : void 0, ne = d.getTypeChecker();
                  return g === void 0 ? void 0 : e.firstDefined(d.getSourceFiles(), function(ue) {
                    return e.firstDefined(ue.getNamedDeclarations().get(g), function(We) {
                      var Fe = We.symbol && ne.getTypeOfSymbolAtLocation(We.symbol, We), Z = Fe && Fe.getCallSignatures();
                      if (Z && Z.length) return ne.runWithCancellationToken(D, function(Be) {
                        return y(Z, Z[0], l, ue, Be, true);
                      });
                    });
                  });
                }
              }
              function p(l, d, D) {
                for (var fe = l.getFullStart(), g = l.parent; g; ) {
                  var ne = e.findPrecedingToken(fe, d, g, true);
                  if (ne) return e.rangeContainsRange(D, ne);
                  g = g.parent;
                }
                return e.Debug.fail("Could not find preceding token");
              }
              function m(l, d, D) {
                var fe = f(l, d, D);
                return !fe || fe.isTypeParameterList || fe.invocation.kind !== 0 ? void 0 : { invocation: fe.invocation.node, argumentCount: fe.argumentCount, argumentIndex: fe.argumentIndex };
              }
              C.getArgumentInfoForCompletions = m;
              function G(l, d, D) {
                var fe = oe(l, D);
                if (!!fe) {
                  var g = fe.list, ne = fe.argumentIndex, ue = q(g, e.isInString(D, d, l));
                  ne !== 0 && e.Debug.assertLessThan(ne, ue);
                  var We = ee(g, D);
                  return { list: g, argumentIndex: ne, argumentCount: ue, argumentsSpan: We };
                }
              }
              function oe(l, d) {
                if (l.kind === 29 || l.kind === 20) return { list: x(l.parent, l, d), argumentIndex: 0 };
                var D = e.findContainingList(l);
                return D && { list: D, argumentIndex: R(D, l) };
              }
              function f(l, d, D) {
                var fe = l.parent;
                if (e.isCallOrNewExpression(fe)) {
                  var g = fe, ne = G(l, d, D);
                  if (!ne) return;
                  var ue = ne.list, We = ne.argumentIndex, Fe = ne.argumentCount, Z = ne.argumentsSpan, Be = !!fe.typeArguments && fe.typeArguments.pos === ue.pos;
                  return { isTypeParameterList: Be, invocation: { kind: 0, node: g }, argumentsSpan: Z, argumentIndex: We, argumentCount: Fe };
                } else {
                  if (e.isNoSubstitutionTemplateLiteral(l) && e.isTaggedTemplateExpression(fe)) return e.isInsideTemplateLiteral(l, d, D) ? ve(fe, 0, D) : void 0;
                  if (e.isTemplateHead(l) && fe.parent.kind === 210) {
                    var ge = fe, Re = ge.parent;
                    e.Debug.assert(ge.kind === 223);
                    var We = e.isInsideTemplateLiteral(l, d, D) ? 0 : 1;
                    return ve(Re, We, D);
                  } else if (e.isTemplateSpan(fe) && e.isTaggedTemplateExpression(fe.parent.parent)) {
                    var ze = fe, Re = fe.parent.parent;
                    if (e.isTemplateTail(l) && !e.isInsideTemplateLiteral(l, d, D)) return;
                    var Ee = ze.parent.templateSpans.indexOf(ze), We = O(Ee, l, d, D);
                    return ve(Re, We, D);
                  } else if (e.isJsxOpeningLikeElement(fe)) {
                    var He = fe.attributes.pos, rr = e.skipTrivia(D.text, fe.attributes.end, false);
                    return { isTypeParameterList: false, invocation: { kind: 0, node: fe }, argumentsSpan: e.createTextSpan(He, rr - He), argumentIndex: 0, argumentCount: 1 };
                  } else {
                    var Ie = e.getPossibleTypeArgumentsInfo(l, D);
                    if (Ie) {
                      var _e = Ie.called, we = Ie.nTypeArguments, g = { kind: 1, called: _e }, Z = e.createTextSpanFromBounds(_e.getStart(D), l.end);
                      return { isTypeParameterList: true, invocation: g, argumentsSpan: Z, argumentIndex: we, argumentCount: we + 1 };
                    }
                    return;
                  }
                }
              }
              function T(l, d, D, fe) {
                return se(l, d, D, fe) || f(l, d, D);
              }
              function K(l) {
                return e.isBinaryExpression(l.parent) ? K(l.parent) : l;
              }
              function b(l) {
                return e.isBinaryExpression(l.left) ? b(l.left) + 1 : 2;
              }
              function se(l, d, D, fe) {
                var g = J(l, D, d, fe);
                if (!!g) {
                  var ne = g.contextualType, ue = g.argumentIndex, We = g.argumentCount, Fe = g.argumentsSpan, Z = ne.getNonNullableType(), Be = Z.symbol;
                  if (Be !== void 0) {
                    var ge = e.lastOrUndefined(Z.getCallSignatures());
                    if (ge !== void 0) {
                      var Re = { kind: 2, signature: ge, node: l, symbol: ie(Be) };
                      return { isTypeParameterList: false, invocation: Re, argumentsSpan: Fe, argumentIndex: ue, argumentCount: We };
                    }
                  }
                }
              }
              function J(l, d, D, fe) {
                if (!(l.kind !== 20 && l.kind !== 27)) {
                  var g = l.parent;
                  switch (g.kind) {
                    case 212:
                    case 169:
                    case 213:
                    case 214:
                      var ne = G(l, D, d);
                      if (!ne) return;
                      var ue = ne.argumentIndex, We = ne.argumentCount, Fe = ne.argumentsSpan, Z = e.isMethodDeclaration(g) ? fe.getContextualTypeForObjectLiteralElement(g) : fe.getContextualType(g);
                      return Z && { contextualType: Z, argumentIndex: ue, argumentCount: We, argumentsSpan: Fe };
                    case 221: {
                      var Be = K(g), ge = fe.getContextualType(Be), Re = l.kind === 20 ? 0 : b(g) - 1, ze = b(Be);
                      return ge && { contextualType: ge, argumentIndex: Re, argumentCount: ze, argumentsSpan: e.createTextSpanFromNode(g) };
                    }
                    default:
                      return;
                  }
                }
              }
              function ie(l) {
                return l.name === "__type" && e.firstDefined(l.declarations, function(d) {
                  return e.isFunctionTypeNode(d) ? d.parent.symbol : void 0;
                }) || l;
              }
              function R(l, d) {
                for (var D = 0, fe = 0, g = l.getChildren(); fe < g.length; fe++) {
                  var ne = g[fe];
                  if (ne === d) break;
                  ne.kind !== 27 && D++;
                }
                return D;
              }
              function q(l, d) {
                var D = l.getChildren(), fe = e.countWhere(D, function(g) {
                  return g.kind !== 27;
                });
                return !d && D.length > 0 && e.last(D).kind === 27 && fe++, fe;
              }
              function O(l, d, D, fe) {
                return e.Debug.assert(D >= d.getStart(), "Assumed 'position' could not occur before node."), e.isTemplateLiteralToken(d) ? e.isInsideTemplateLiteral(d, D, fe) ? 0 : l + 2 : l + 1;
              }
              function ve(l, d, D) {
                var fe = e.isNoSubstitutionTemplateLiteral(l.template) ? 1 : l.template.templateSpans.length + 1;
                return d !== 0 && e.Debug.assertLessThan(d, fe), { isTypeParameterList: false, invocation: { kind: 0, node: l }, argumentsSpan: he(l, D), argumentIndex: d, argumentCount: fe };
              }
              function ee(l, d) {
                var D = l.getFullStart(), fe = e.skipTrivia(d.text, l.getEnd(), false);
                return e.createTextSpan(D, fe - D);
              }
              function he(l, d) {
                var D = l.template, fe = D.getStart(), g = D.getEnd();
                if (D.kind === 223) {
                  var ne = e.last(D.templateSpans);
                  ne.literal.getFullWidth() === 0 && (g = e.skipTrivia(d.text, g, false));
                }
                return e.createTextSpan(fe, g - fe);
              }
              function F(l, d, D, fe, g) {
                for (var ne = function(Fe) {
                  e.Debug.assert(e.rangeContainsRange(Fe.parent, Fe), "Not a subspan", function() {
                    return "Child: ".concat(e.Debug.formatSyntaxKind(Fe.kind), ", parent: ").concat(e.Debug.formatSyntaxKind(Fe.parent.kind));
                  });
                  var Z = T(Fe, d, D, fe);
                  if (Z) return { value: Z };
                }, ue = l; !e.isSourceFile(ue) && (g || !e.isBlock(ue)); ue = ue.parent) {
                  var We = ne(ue);
                  if (typeof We == "object") return We.value;
                }
              }
              function x(l, d, D) {
                var fe = l.getChildren(D), g = fe.indexOf(d);
                return e.Debug.assert(g >= 0 && fe.length > g + 1), fe[g + 1];
              }
              function X(l) {
                return l.kind === 0 ? e.getInvokedExpression(l.node) : l.called;
              }
              function $(l) {
                return l.kind === 0 ? l.node : l.kind === 1 ? l.called : l.node;
              }
              var A = 70246400;
              function y(l, d, D, fe, g, ne) {
                var ue, We = D.isTypeParameterList, Fe = D.argumentCount, Z = D.argumentsSpan, Be = D.invocation, ge = D.argumentIndex, Re = $(Be), ze = Be.kind === 2 ? Be.symbol : g.getSymbolAtLocation(X(Be)) || ne && ((ue = d.declaration) === null || ue === void 0 ? void 0 : ue.symbol), Ee = ze ? e.symbolToDisplayParts(g, ze, ne ? fe : void 0, void 0) : e.emptyArray, He = e.map(l, function(Br) {
                  return k(Br, Ee, We, g, Re, fe);
                });
                ge !== 0 && e.Debug.assertLessThan(ge, Fe);
                for (var rr = 0, Ie = 0, _e = 0; _e < He.length; _e++) {
                  var we = He[_e];
                  if (l[_e] === d && (rr = Ie, we.length > 1)) for (var de = 0, ye = 0, Ae = we; ye < Ae.length; ye++) {
                    var er = Ae[ye];
                    if (er.isVariadic || er.parameters.length >= Fe) {
                      rr = Ie + de;
                      break;
                    }
                    de++;
                  }
                  Ie += we.length;
                }
                e.Debug.assert(rr !== -1);
                var ir = { items: e.flatMapToMutable(He, e.identity), applicableSpan: Z, selectedItemIndex: rr, argumentIndex: ge, argumentCount: Fe }, Cr = ir.items[rr];
                if (Cr.isVariadic) {
                  var Ye = e.findIndex(Cr.parameters, function(Br) {
                    return !!Br.isRest;
                  });
                  -1 < Ye && Ye < Cr.parameters.length - 1 ? ir.argumentIndex = Cr.parameters.length : ir.argumentIndex = Math.min(ir.argumentIndex, Cr.parameters.length - 1);
                }
                return ir;
              }
              function V(l, d, D, fe) {
                var g = d.argumentCount, ne = d.argumentsSpan, ue = d.invocation, We = d.argumentIndex, Fe = fe.getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(l);
                if (!!Fe) {
                  var Z = [L(l, Fe, fe, $(ue), D)];
                  return { items: Z, applicableSpan: ne, selectedItemIndex: 0, argumentIndex: We, argumentCount: g };
                }
              }
              function L(l, d, D, fe, g) {
                var ne = e.symbolToDisplayParts(D, l), ue = e.createPrinter({ removeComments: true }), We = d.map(function(ge) {
                  return I(ge, D, fe, g, ue);
                }), Fe = l.getDocumentationComment(D), Z = l.getJsDocTags(D), Be = Ve(Ve([], ne, true), [e.punctuationPart(29)], false);
                return { isVariadic: false, prefixDisplayParts: Be, suffixDisplayParts: [e.punctuationPart(31)], separatorDisplayParts: P, parameters: We, documentation: Fe, tags: Z };
              }
              var P = [e.punctuationPart(27), e.spacePart()];
              function k(l, d, D, fe, g, ne) {
                var ue = (D ? U : j)(l, fe, g, ne);
                return e.map(ue, function(We) {
                  var Fe = We.isVariadic, Z = We.parameters, Be = We.prefix, ge = We.suffix, Re = Ve(Ve([], d, true), Be, true), ze = Ve(Ve([], ge, true), Y(l, g, fe), true), Ee = l.getDocumentationComment(fe), He = l.getJsDocTags();
                  return { isVariadic: Fe, prefixDisplayParts: Re, suffixDisplayParts: ze, separatorDisplayParts: P, parameters: Z, documentation: Ee, tags: He };
                });
              }
              function Y(l, d, D) {
                return e.mapToDisplayParts(function(fe) {
                  fe.writePunctuation(":"), fe.writeSpace(" ");
                  var g = D.getTypePredicateOfSignature(l);
                  g ? D.writeTypePredicate(g, d, void 0, fe) : D.writeType(D.getReturnTypeOfSignature(l), d, void 0, fe);
                });
              }
              function U(l, d, D, fe) {
                var g = (l.target || l).typeParameters, ne = e.createPrinter({ removeComments: true }), ue = (g || e.emptyArray).map(function(Fe) {
                  return I(Fe, d, D, fe, ne);
                }), We = l.thisParameter ? [d.symbolToParameterDeclaration(l.thisParameter, D, A)] : [];
                return d.getExpandedParameters(l).map(function(Fe) {
                  var Z = e.factory.createNodeArray(Ve(Ve([], We, true), e.map(Fe, function(ge) {
                    return d.symbolToParameterDeclaration(ge, D, A);
                  }), true)), Be = e.mapToDisplayParts(function(ge) {
                    ne.writeList(2576, Z, fe, ge);
                  });
                  return { isVariadic: false, parameters: ue, prefix: [e.punctuationPart(29)], suffix: Ve([e.punctuationPart(31)], Be, true) };
                });
              }
              function j(l, d, D, fe) {
                var g = e.createPrinter({ removeComments: true }), ne = e.mapToDisplayParts(function(Fe) {
                  if (l.typeParameters && l.typeParameters.length) {
                    var Z = e.factory.createNodeArray(l.typeParameters.map(function(Be) {
                      return d.typeParameterToDeclaration(Be, D, A);
                    }));
                    g.writeList(53776, Z, fe, Fe);
                  }
                }), ue = d.getExpandedParameters(l), We = d.hasEffectiveRestParameter(l) ? ue.length === 1 ? function(Fe) {
                  return true;
                } : function(Fe) {
                  return !!(Fe.length && Fe[Fe.length - 1].checkFlags & 32768);
                } : function(Fe) {
                  return false;
                };
                return ue.map(function(Fe) {
                  return { isVariadic: We(Fe), parameters: Fe.map(function(Z) {
                    return H(Z, d, D, fe, g);
                  }), prefix: Ve(Ve([], ne, true), [e.punctuationPart(20)], false), suffix: [e.punctuationPart(21)] };
                });
              }
              function H(l, d, D, fe, g) {
                var ne = e.mapToDisplayParts(function(Fe) {
                  var Z = d.symbolToParameterDeclaration(l, D, A);
                  g.writeNode(4, Z, fe, Fe);
                }), ue = d.isOptionalParameter(l.valueDeclaration), We = !!(l.checkFlags & 32768);
                return { name: l.name, documentation: l.getDocumentationComment(d), displayParts: ne, isOptional: ue, isRest: We };
              }
              function I(l, d, D, fe, g) {
                var ne = e.mapToDisplayParts(function(ue) {
                  var We = d.typeParameterToDeclaration(l, D, A);
                  g.writeNode(4, We, fe, ue);
                });
                return { name: l.symbol.name, documentation: l.symbol.getDocumentationComment(d), displayParts: ne, isOptional: false, isRest: false };
              }
            })(a = e.SignatureHelp || (e.SignatureHelp = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = 30, B = function(N) {
                return new RegExp("^\\s?/\\*\\*?\\s?".concat(N, "\\s?\\*\\/\\s?$"));
              };
              function E(N) {
                return N.includeInlayParameterNameHints === "literals" || N.includeInlayParameterNameHints === "all";
              }
              function Q(N) {
                return N.includeInlayParameterNameHints === "literals";
              }
              function le(N) {
                var p = N.file, m = N.program, G = N.span, oe = N.cancellationToken, f = N.preferences, T = p.text, K = m.getCompilerOptions(), b = m.getTypeChecker(), se = [];
                return J(p), se;
                function J(U) {
                  if (!(!U || U.getFullWidth() === 0)) {
                    switch (U.kind) {
                      case 261:
                      case 257:
                      case 258:
                      case 256:
                      case 226:
                      case 213:
                      case 169:
                      case 214:
                        oe.throwIfCancellationRequested();
                    }
                    if (!!e.textSpanIntersectsWith(G, U.pos, U.getFullWidth()) && !e.isTypeNode(U)) return f.includeInlayVariableTypeHints && e.isVariableDeclaration(U) || f.includeInlayPropertyDeclarationTypeHints && e.isPropertyDeclaration(U) ? he(U) : f.includeInlayEnumMemberValueHints && e.isEnumMember(U) ? ve(U) : E(f) && (e.isCallExpression(U) || e.isNewExpression(U)) ? F(U) : (f.includeInlayFunctionParameterTypeHints && e.isFunctionLikeDeclaration(U) && e.hasContextSensitiveParameters(U) && V(U), f.includeInlayFunctionLikeReturnTypeHints && ie(U) && A(U)), e.forEachChild(U, J);
                  }
                }
                function ie(U) {
                  return e.isArrowFunction(U) || e.isFunctionExpression(U) || e.isFunctionDeclaration(U) || e.isMethodDeclaration(U) || e.isGetAccessorDeclaration(U);
                }
                function R(U, j, H) {
                  se.push({ text: "".concat(H ? "..." : "").concat(P(U, w), ":"), position: j, kind: "Parameter", whitespaceAfter: true });
                }
                function q(U, j) {
                  se.push({ text: ": ".concat(P(U, w)), position: j, kind: "Type", whitespaceBefore: true });
                }
                function O(U, j) {
                  se.push({ text: "= ".concat(P(U, w)), position: j, kind: "Enum", whitespaceBefore: true });
                }
                function ve(U) {
                  if (!U.initializer) {
                    var j = b.getConstantValue(U);
                    j !== void 0 && O(j.toString(), U.end);
                  }
                }
                function ee(U) {
                  return U.symbol && U.symbol.flags & 1536;
                }
                function he(U) {
                  if (!(!U.initializer || e.isBindingPattern(U.name))) {
                    var j = e.getEffectiveTypeAnnotationNode(U);
                    if (!j) {
                      var H = b.getTypeAtLocation(U);
                      if (!ee(H)) {
                        var I = k(H);
                        I && q(I, U.name.end);
                      }
                    }
                  }
                }
                function F(U) {
                  var j = U.arguments;
                  if (!(!j || !j.length)) {
                    var H = [], I = b.getResolvedSignatureForSignatureHelp(U, H);
                    if (!(!I || !H.length)) for (var l = 0; l < j.length; ++l) {
                      var d = j[l], D = e.skipParentheses(d);
                      if (!(Q(f) && !$(D))) {
                        var fe = b.getParameterIdentifierNameAtPosition(I, l);
                        if (fe) {
                          var g = fe[0], ne = fe[1], ue = f.includeInlayParameterNameHintsWhenArgumentMatchesName || !x(D, g);
                          if (!ue && !ne) continue;
                          var We = e.unescapeLeadingUnderscores(g);
                          if (X(D, We)) continue;
                          R(We, d.getStart(), ne);
                        }
                      }
                    }
                  }
                }
                function x(U, j) {
                  return e.isIdentifier(U) ? U.text === j : e.isPropertyAccessExpression(U) ? U.name.text === j : false;
                }
                function X(U, j) {
                  if (!e.isIdentifierText(j, K.target, e.getLanguageVariant(p.scriptKind))) return false;
                  var H = e.getLeadingCommentRanges(T, U.pos);
                  if (!(H != null && H.length)) return false;
                  var I = B(j);
                  return e.some(H, function(l) {
                    return I.test(T.substring(l.pos, l.end));
                  });
                }
                function $(U) {
                  switch (U.kind) {
                    case 219: {
                      var j = U.operand;
                      return e.isLiteralExpression(j) || e.isIdentifier(j) && e.isInfinityOrNaNString(j.escapedText);
                    }
                    case 110:
                    case 95:
                    case 104:
                    case 14:
                    case 223:
                      return true;
                    case 79: {
                      var H = U.escapedText;
                      return Y(H) || e.isInfinityOrNaNString(H);
                    }
                  }
                  return e.isLiteralExpression(U);
                }
                function A(U) {
                  if (!(e.isArrowFunction(U) && !e.findChildOfKind(U, 20, p))) {
                    var j = e.getEffectiveReturnTypeNode(U);
                    if (!(j || !U.body)) {
                      var H = b.getSignatureFromDeclaration(U);
                      if (!!H) {
                        var I = b.getReturnTypeOfSignature(H);
                        if (!ee(I)) {
                          var l = k(I);
                          !l || q(l, y(U));
                        }
                      }
                    }
                  }
                }
                function y(U) {
                  var j = e.findChildOfKind(U, 21, p);
                  return j ? j.end : U.parameters.end;
                }
                function V(U) {
                  var j = b.getSignatureFromDeclaration(U);
                  if (!!j) for (var H = 0; H < U.parameters.length && H < j.parameters.length; ++H) {
                    var I = U.parameters[H], l = e.getEffectiveTypeAnnotationNode(I);
                    if (!l) {
                      var d = L(j.parameters[H]);
                      !d || q(d, I.questionToken ? I.questionToken.end : I.name.end);
                    }
                  }
                }
                function L(U) {
                  var j = U.valueDeclaration;
                  if (!(!j || !e.isParameter(j))) {
                    var H = b.getTypeOfSymbolAtLocation(U, j);
                    if (!ee(H)) return k(H);
                  }
                }
                function P(U, j) {
                  return U.length > j ? U.substr(0, j - 3) + "..." : U;
                }
                function k(U) {
                  var j = 71286784, H = { removeComments: true }, I = e.createPrinter(H);
                  return e.usingSingleLineStringWriter(function(l) {
                    var d = b.typeToTypeNode(U, void 0, j, l);
                    e.Debug.assertIsDefined(d, "should always get typenode"), I.writeNode(4, d, p, l);
                  });
                }
                function Y(U) {
                  return U === "undefined";
                }
              }
              C.provideInlayHints = le;
            })(a = e.InlayHints || (e.InlayHints = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a = /^data:(?:application\/json(?:;charset=[uU][tT][fF]-8);base64,([A-Za-z0-9+\/=]+)$)?/;
            function C(Q) {
              var le = e.createGetCanonicalFileName(Q.useCaseSensitiveFileNames()), N = Q.getCurrentDirectory(), p = new e.Map(), m = new e.Map();
              return { tryGetSourcePosition: f, tryGetGeneratedPosition: T, toLineColumnOffset: J, clearCache: ie };
              function G(R) {
                return e.toPath(R, N, le);
              }
              function oe(R, q) {
                var O = G(R), ve = m.get(O);
                if (ve) return ve;
                var ee;
                if (Q.getDocumentPositionMapper) ee = Q.getDocumentPositionMapper(R, q);
                else if (Q.readFile) {
                  var he = se(R);
                  ee = he && e.getDocumentPositionMapper({ getSourceFileLike: se, getCanonicalFileName: le, log: function(F) {
                    return Q.log(F);
                  } }, R, e.getLineInfo(he.text, e.getLineStarts(he)), function(F) {
                    return !Q.fileExists || Q.fileExists(F) ? Q.readFile(F) : void 0;
                  });
                }
                return m.set(O, ee || e.identitySourceMapConsumer), ee || e.identitySourceMapConsumer;
              }
              function f(R) {
                if (!!e.isDeclarationFileName(R.fileName)) {
                  var q = K(R.fileName);
                  if (!!q) {
                    var O = oe(R.fileName).getSourcePosition(R);
                    return !O || O === R ? void 0 : f(O) || O;
                  }
                }
              }
              function T(R) {
                if (!e.isDeclarationFileName(R.fileName)) {
                  var q = K(R.fileName);
                  if (!!q) {
                    var O = Q.getProgram();
                    if (!O.isSourceOfProjectReferenceRedirect(q.fileName)) {
                      var ve = O.getCompilerOptions(), ee = e.outFile(ve), he = ee ? e.removeFileExtension(ee) + ".d.ts" : e.getDeclarationEmitOutputFilePathWorker(R.fileName, O.getCompilerOptions(), N, O.getCommonSourceDirectory(), le);
                      if (he !== void 0) {
                        var F = oe(he, R.fileName).getGeneratedPosition(R);
                        return F === R ? void 0 : F;
                      }
                    }
                  }
                }
              }
              function K(R) {
                var q = Q.getProgram();
                if (!!q) {
                  var O = G(R), ve = q.getSourceFileByPath(O);
                  return ve && ve.resolvedPath === O ? ve : void 0;
                }
              }
              function b(R) {
                var q = G(R), O = p.get(q);
                if (O !== void 0) return O || void 0;
                if (!Q.readFile || Q.fileExists && !Q.fileExists(q)) {
                  p.set(q, false);
                  return;
                }
                var ve = Q.readFile(q), ee = ve ? E(ve) : false;
                return p.set(q, ee), ee || void 0;
              }
              function se(R) {
                return Q.getSourceFileLike ? Q.getSourceFileLike(R) : K(R) || b(R);
              }
              function J(R, q) {
                var O = se(R);
                return O.getLineAndCharacterOfPosition(q);
              }
              function ie() {
                p.clear(), m.clear();
              }
            }
            e.getSourceMapper = C;
            function w(Q, le, N, p) {
              var m = e.tryGetSourceMappingURL(N);
              if (m) {
                var G = a.exec(m);
                if (G) {
                  if (G[1]) {
                    var oe = G[1];
                    return B(Q, e.base64decode(e.sys, oe), le);
                  }
                  m = void 0;
                }
              }
              var f = [];
              m && f.push(m), f.push(le + ".map");
              for (var T = m && e.getNormalizedAbsolutePath(m, e.getDirectoryPath(le)), K = 0, b = f; K < b.length; K++) {
                var se = b[K], J = e.getNormalizedAbsolutePath(se, e.getDirectoryPath(le)), ie = p(J, T);
                if (e.isString(ie)) return B(Q, ie, J);
                if (ie !== void 0) return ie || void 0;
              }
            }
            e.getDocumentPositionMapper = w;
            function B(Q, le, N) {
              var p = e.tryParseRawSourceMap(le);
              if (!(!p || !p.sources || !p.file || !p.mappings) && !(p.sourcesContent && p.sourcesContent.some(e.isString))) return e.createDocumentPositionMapper(Q, p, N);
            }
            function E(Q, le) {
              return { text: Q, lineMap: le, getLineAndCharacterOfPosition: function(N) {
                return e.computeLineAndCharacterOfPosition(e.getLineStarts(this), N);
              } };
            }
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a = new e.Map();
            function C(ie, R, q) {
              R.getSemanticDiagnostics(ie, q);
              var O = [], ve = R.getTypeChecker(), ee = ie.impliedNodeFormat === e.ModuleKind.CommonJS || e.fileExtensionIsOneOf(ie.fileName, [".cts", ".cjs"]);
              !ee && ie.commonJsModuleIndicator && (e.programContainsEsModules(R) || e.compilerOptionsIndicateEsModules(R.getCompilerOptions())) && w(ie) && O.push(e.createDiagnosticForNode(p(ie.commonJsModuleIndicator), e.Diagnostics.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module));
              var he = e.isSourceFileJS(ie);
              if (a.clear(), L(ie), e.getAllowSyntheticDefaultImports(R.getCompilerOptions())) for (var F = 0, x = ie.imports; F < x.length; F++) {
                var X = x[F], $ = e.importFromModuleSpecifier(X), A = E($);
                if (!!A) {
                  var y = e.getResolvedModule(ie, X.text, e.getModeForUsageLocation(ie, X)), V = y && R.getSourceFile(y.resolvedFileName);
                  V && V.externalModuleIndicator && V.externalModuleIndicator !== true && e.isExportAssignment(V.externalModuleIndicator) && V.externalModuleIndicator.isExportEquals && O.push(e.createDiagnosticForNode(A, e.Diagnostics.Import_may_be_converted_to_a_default_import));
                }
              }
              return e.addRange(O, ie.bindSuggestionDiagnostics), e.addRange(O, R.getSuggestionDiagnostics(ie, q)), O.sort(function(P, k) {
                return P.start - k.start;
              });
              function L(P) {
                if (he) se(P, ve) && O.push(e.createDiagnosticForNode(e.isVariableDeclaration(P.parent) ? P.parent.name : P, e.Diagnostics.This_constructor_function_may_be_converted_to_a_class_declaration));
                else {
                  if (e.isVariableStatement(P) && P.parent === ie && P.declarationList.flags & 2 && P.declarationList.declarations.length === 1) {
                    var k = P.declarationList.declarations[0].initializer;
                    k && e.isRequireCall(k, true) && O.push(e.createDiagnosticForNode(k, e.Diagnostics.require_call_may_be_converted_to_an_import));
                  }
                  e.codefix.parameterShouldGetTypeFromJSDoc(P) && O.push(e.createDiagnosticForNode(P.name || P, e.Diagnostics.JSDoc_types_may_be_moved_to_TypeScript_types));
                }
                J(P) && Q(P, ve, O), P.forEachChild(L);
              }
            }
            e.computeSuggestionDiagnostics = C;
            function w(ie) {
              return ie.statements.some(function(R) {
                switch (R.kind) {
                  case 237:
                    return R.declarationList.declarations.some(function(ve) {
                      return !!ve.initializer && e.isRequireCall(B(ve.initializer), true);
                    });
                  case 238: {
                    var q = R.expression;
                    if (!e.isBinaryExpression(q)) return e.isRequireCall(q, true);
                    var O = e.getAssignmentDeclarationKind(q);
                    return O === 1 || O === 2;
                  }
                  default:
                    return false;
                }
              });
            }
            function B(ie) {
              return e.isPropertyAccessExpression(ie) ? B(ie.expression) : ie;
            }
            function E(ie) {
              switch (ie.kind) {
                case 266:
                  var R = ie.importClause, q = ie.moduleSpecifier;
                  return R && !R.name && R.namedBindings && R.namedBindings.kind === 268 && e.isStringLiteral(q) ? R.namedBindings.name : void 0;
                case 265:
                  return ie.name;
                default:
                  return;
              }
            }
            function Q(ie, R, q) {
              le(ie, R) && !a.has(b(ie)) && q.push(e.createDiagnosticForNode(!ie.name && e.isVariableDeclaration(ie.parent) && e.isIdentifier(ie.parent.name) ? ie.parent.name : ie, e.Diagnostics.This_may_be_converted_to_an_async_function));
            }
            function le(ie, R) {
              return !e.isAsyncFunction(ie) && ie.body && e.isBlock(ie.body) && m(ie.body, R) && N(ie, R);
            }
            function N(ie, R) {
              var q = R.getSignatureFromDeclaration(ie), O = q ? R.getReturnTypeOfSignature(q) : void 0;
              return !!O && !!R.getPromisedTypeOfPromise(O);
            }
            e.returnsPromise = N;
            function p(ie) {
              return e.isBinaryExpression(ie) ? ie.left : ie;
            }
            function m(ie, R) {
              return !!e.forEachReturnStatement(ie, function(q) {
                return G(q, R);
              });
            }
            function G(ie, R) {
              return e.isReturnStatement(ie) && !!ie.expression && oe(ie.expression, R);
            }
            e.isReturnStatementWithFixablePromiseHandler = G;
            function oe(ie, R) {
              if (!f(ie) || !T(ie) || !ie.arguments.every(function(O) {
                return K(O, R);
              })) return false;
              for (var q = ie.expression.expression; f(q) || e.isPropertyAccessExpression(q); ) if (e.isCallExpression(q)) {
                if (!T(q) || !q.arguments.every(function(O) {
                  return K(O, R);
                })) return false;
                q = q.expression.expression;
              } else q = q.expression;
              return true;
            }
            e.isFixablePromiseHandler = oe;
            function f(ie) {
              return e.isCallExpression(ie) && (e.hasPropertyAccessExpressionWithName(ie, "then") || e.hasPropertyAccessExpressionWithName(ie, "catch") || e.hasPropertyAccessExpressionWithName(ie, "finally"));
            }
            function T(ie) {
              var R = ie.expression.name.text, q = R === "then" ? 2 : R === "catch" || R === "finally" ? 1 : 0;
              return ie.arguments.length > q ? false : ie.arguments.length < q ? true : q === 1 || e.some(ie.arguments, function(O) {
                return O.kind === 104 || e.isIdentifier(O) && O.text === "undefined";
              });
            }
            function K(ie, R) {
              switch (ie.kind) {
                case 256:
                case 213:
                  var q = e.getFunctionFlags(ie);
                  if (q & 1) return false;
                case 214:
                  a.set(b(ie), true);
                case 104:
                  return true;
                case 79:
                case 206: {
                  var O = R.getSymbolAtLocation(ie);
                  return O ? R.isUndefinedSymbol(O) || e.some(e.skipAlias(O, R).declarations, function(ve) {
                    return e.isFunctionLike(ve) || e.hasInitializer(ve) && !!ve.initializer && e.isFunctionLike(ve.initializer);
                  }) : false;
                }
                default:
                  return false;
              }
            }
            function b(ie) {
              return "".concat(ie.pos.toString(), ":").concat(ie.end.toString());
            }
            function se(ie, R) {
              var q, O, ve, ee;
              if (ie.kind === 213) {
                if (e.isVariableDeclaration(ie.parent) && ((q = ie.symbol.members) === null || q === void 0 ? void 0 : q.size)) return true;
                var he = R.getSymbolOfExpando(ie, false);
                return !!(he && (((O = he.exports) === null || O === void 0 ? void 0 : O.size) || ((ve = he.members) === null || ve === void 0 ? void 0 : ve.size)));
              }
              return ie.kind === 256 ? !!(!((ee = ie.symbol.members) === null || ee === void 0) && ee.size) : false;
            }
            function J(ie) {
              switch (ie.kind) {
                case 256:
                case 169:
                case 213:
                case 214:
                  return true;
                default:
                  return false;
              }
            }
            e.canBeConvertedToAsync = J;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = 70246400;
              function B(m, G, oe) {
                var f = E(m, G, oe);
                if (f !== "") return f;
                var T = e.getCombinedLocalAndExportSymbolFlags(G);
                return T & 32 ? e.getDeclarationOfKind(G, 226) ? "local class" : "class" : T & 384 ? "enum" : T & 524288 ? "type" : T & 64 ? "interface" : T & 262144 ? "type parameter" : T & 8 ? "enum member" : T & 2097152 ? "alias" : T & 1536 ? "module" : f;
              }
              C.getSymbolKind = B;
              function E(m, G, oe) {
                var f = m.getRootSymbols(G);
                if (f.length === 1 && e.first(f).flags & 8192 && m.getTypeOfSymbolAtLocation(G, oe).getNonNullableType().getCallSignatures().length !== 0) return "method";
                if (m.isUndefinedSymbol(G)) return "var";
                if (m.isArgumentsSymbol(G)) return "local var";
                if (oe.kind === 108 && e.isExpression(oe) || e.isThisInTypeQuery(oe)) return "parameter";
                var T = e.getCombinedLocalAndExportSymbolFlags(G);
                if (T & 3) return e.isFirstDeclarationOfSymbolParameter(G) ? "parameter" : G.valueDeclaration && e.isVarConst(G.valueDeclaration) ? "const" : e.forEach(G.declarations, e.isLet) ? "let" : p(G) ? "local var" : "var";
                if (T & 16) return p(G) ? "local function" : "function";
                if (T & 32768) return "getter";
                if (T & 65536) return "setter";
                if (T & 8192) return "method";
                if (T & 16384) return "constructor";
                if (T & 4) {
                  if (T & 33554432 && G.checkFlags & 6) {
                    var K = e.forEach(m.getRootSymbols(G), function(se) {
                      var J = se.getFlags();
                      if (J & 98311) return "property";
                    });
                    if (!K) {
                      var b = m.getTypeOfSymbolAtLocation(G, oe);
                      return b.getCallSignatures().length ? "method" : "property";
                    }
                    return K;
                  }
                  return "property";
                }
                return "";
              }
              function Q(m) {
                if (m.declarations && m.declarations.length) {
                  var G = m.declarations, oe = G[0], f = G.slice(1), T = e.length(f) && e.isDeprecatedDeclaration(oe) && e.some(f, function(b) {
                    return !e.isDeprecatedDeclaration(b);
                  }) ? 8192 : 0, K = e.getNodeModifiers(oe, T);
                  if (K) return K.split(",");
                }
                return [];
              }
              function le(m, G) {
                if (!G) return "";
                var oe = new e.Set(Q(G));
                if (G.flags & 2097152) {
                  var f = m.getAliasedSymbol(G);
                  f !== G && e.forEach(Q(f), function(T) {
                    oe.add(T);
                  });
                }
                return G.flags & 16777216 && oe.add("optional"), oe.size > 0 ? e.arrayFrom(oe.values()).join(",") : "";
              }
              C.getSymbolModifiers = le;
              function N(m, G, oe, f, T, K, b) {
                var se;
                K === void 0 && (K = e.getMeaningFromLocation(T));
                var J = [], ie = [], R = [], q = e.getCombinedLocalAndExportSymbolFlags(G), O = K & 1 ? E(m, G, T) : "", ve = false, ee = T.kind === 108 && e.isInExpressionContext(T) || e.isThisInTypeQuery(T), he, F, x, X, $ = false;
                if (T.kind === 108 && !ee) return { displayParts: [e.keywordPart(108)], documentation: [], symbolKind: "primitive type", tags: void 0 };
                if (O !== "" || q & 32 || q & 2097152) {
                  if (O === "getter" || O === "setter") {
                    var A = e.find(G.declarations, function(er) {
                      return er.name === T;
                    });
                    if (A) switch (A.kind) {
                      case 172:
                        O = "getter";
                        break;
                      case 173:
                        O = "setter";
                        break;
                      default:
                        e.Debug.assertNever(A);
                    }
                    else O = "property";
                  }
                  var y = void 0;
                  if (he = ee ? m.getTypeAtLocation(T) : m.getTypeOfSymbolAtLocation(G, T), T.parent && T.parent.kind === 206) {
                    var V = T.parent.name;
                    (V === T || V && V.getFullWidth() === 0) && (T = T.parent);
                  }
                  var L = void 0;
                  if (e.isCallOrNewExpression(T) ? L = T : (e.isCallExpressionTarget(T) || e.isNewExpressionTarget(T) || T.parent && (e.isJsxOpeningLikeElement(T.parent) || e.isTaggedTemplateExpression(T.parent)) && e.isFunctionLike(G.valueDeclaration)) && (L = T.parent), L) {
                    y = m.getResolvedSignature(L);
                    var P = L.kind === 209 || e.isCallExpression(L) && L.expression.kind === 106, k = P ? he.getConstructSignatures() : he.getCallSignatures();
                    if (y && !e.contains(k, y.target) && !e.contains(k, y) && (y = k.length ? k[0] : void 0), y) {
                      switch (P && q & 32 ? (O = "constructor", we(he.symbol, O)) : q & 2097152 ? (O = "alias", de(O), J.push(e.spacePart()), P && (y.flags & 4 && (J.push(e.keywordPart(126)), J.push(e.spacePart())), J.push(e.keywordPart(103)), J.push(e.spacePart())), _e(G)) : we(G, O), O) {
                        case "JSX attribute":
                        case "property":
                        case "var":
                        case "const":
                        case "let":
                        case "parameter":
                        case "local var":
                          J.push(e.punctuationPart(58)), J.push(e.spacePart()), !(e.getObjectFlags(he) & 16) && he.symbol && (e.addRange(J, e.symbolToDisplayParts(m, he.symbol, f, void 0, 5)), J.push(e.lineBreakPart())), P && (y.flags & 4 && (J.push(e.keywordPart(126)), J.push(e.spacePart())), J.push(e.keywordPart(103)), J.push(e.spacePart())), ye(y, k, 262144);
                          break;
                        default:
                          ye(y, k);
                      }
                      ve = true, $ = k.length > 1;
                    }
                  } else if (e.isNameOfFunctionDeclaration(T) && !(q & 98304) || T.kind === 134 && T.parent.kind === 171) {
                    var Y = T.parent, U = G.declarations && e.find(G.declarations, function(er) {
                      return er === (T.kind === 134 ? Y.parent : Y);
                    });
                    if (U) {
                      var k = Y.kind === 171 ? he.getNonNullableType().getConstructSignatures() : he.getNonNullableType().getCallSignatures();
                      m.isImplementationOfOverload(Y) ? y = k[0] : y = m.getSignatureFromDeclaration(Y), Y.kind === 171 ? (O = "constructor", we(he.symbol, O)) : we(Y.kind === 174 && !(he.symbol.flags & 2048 || he.symbol.flags & 4096) ? he.symbol : G, O), y && ye(y, k), ve = true, $ = k.length > 1;
                    }
                  }
                }
                if (q & 32 && !ve && !ee && (rr(), e.getDeclarationOfKind(G, 226) ? de("local class") : J.push(e.keywordPart(84)), J.push(e.spacePart()), _e(G), Ae(G, oe)), q & 64 && K & 2 && (He(), J.push(e.keywordPart(118)), J.push(e.spacePart()), _e(G), Ae(G, oe)), q & 524288 && K & 2 && (He(), J.push(e.keywordPart(152)), J.push(e.spacePart()), _e(G), Ae(G, oe), J.push(e.spacePart()), J.push(e.operatorPart(63)), J.push(e.spacePart()), e.addRange(J, e.typeToDisplayParts(m, e.isConstTypeReference(T.parent) ? m.getTypeAtLocation(T.parent) : m.getDeclaredTypeOfSymbol(G), f, 8388608))), q & 384 && (He(), e.some(G.declarations, function(er) {
                  return e.isEnumDeclaration(er) && e.isEnumConst(er);
                }) && (J.push(e.keywordPart(85)), J.push(e.spacePart())), J.push(e.keywordPart(92)), J.push(e.spacePart()), _e(G)), q & 1536 && !ee) {
                  He();
                  var A = e.getDeclarationOfKind(G, 261), j = A && A.name && A.name.kind === 79;
                  J.push(e.keywordPart(j ? 142 : 141)), J.push(e.spacePart()), _e(G);
                }
                if (q & 262144 && K & 2) if (He(), J.push(e.punctuationPart(20)), J.push(e.textPart("type parameter")), J.push(e.punctuationPart(21)), J.push(e.spacePart()), _e(G), G.parent) Ie(), _e(G.parent, f), Ae(G.parent, f);
                else {
                  var H = e.getDeclarationOfKind(G, 163);
                  if (H === void 0) return e.Debug.fail();
                  var A = H.parent;
                  if (A) if (e.isFunctionLikeKind(A.kind)) {
                    Ie();
                    var y = m.getSignatureFromDeclaration(A);
                    A.kind === 175 ? (J.push(e.keywordPart(103)), J.push(e.spacePart())) : A.kind !== 174 && A.name && _e(A.symbol), e.addRange(J, e.signatureToDisplayParts(m, y, oe, 32));
                  } else A.kind === 259 && (Ie(), J.push(e.keywordPart(152)), J.push(e.spacePart()), _e(A.symbol), Ae(A.symbol, oe));
                }
                if (q & 8) {
                  O = "enum member", we(G, "enum member");
                  var A = (se = G.declarations) === null || se === void 0 ? void 0 : se[0];
                  if ((A == null ? void 0 : A.kind) === 299) {
                    var I = m.getConstantValue(A);
                    I !== void 0 && (J.push(e.spacePart()), J.push(e.operatorPart(63)), J.push(e.spacePart()), J.push(e.displayPart(e.getTextOfConstantValue(I), typeof I == "number" ? e.SymbolDisplayPartKind.numericLiteral : e.SymbolDisplayPartKind.stringLiteral)));
                  }
                }
                if (G.flags & 2097152) {
                  if (He(), !ve) {
                    var l = m.getAliasedSymbol(G);
                    if (l !== G && l.declarations && l.declarations.length > 0) {
                      var d = l.declarations[0], D = e.getNameOfDeclaration(d);
                      if (D) {
                        var fe = e.isModuleWithStringLiteralName(d) && e.hasSyntacticModifier(d, 2), g = G.name !== "default" && !fe, ne = N(m, l, e.getSourceFileOfNode(d), d, D, K, g ? G : l);
                        J.push.apply(J, ne.displayParts), J.push(e.lineBreakPart()), x = ne.documentation, X = ne.tags;
                      } else x = l.getContextualDocumentationComment(d, m), X = l.getJsDocTags(m);
                    }
                  }
                  if (G.declarations) switch (G.declarations[0].kind) {
                    case 264:
                      J.push(e.keywordPart(93)), J.push(e.spacePart()), J.push(e.keywordPart(142));
                      break;
                    case 271:
                      J.push(e.keywordPart(93)), J.push(e.spacePart()), J.push(e.keywordPart(G.declarations[0].isExportEquals ? 63 : 88));
                      break;
                    case 275:
                      J.push(e.keywordPart(93));
                      break;
                    default:
                      J.push(e.keywordPart(100));
                  }
                  J.push(e.spacePart()), _e(G), e.forEach(G.declarations, function(er) {
                    if (er.kind === 265) {
                      var ir = er;
                      if (e.isExternalModuleImportEqualsDeclaration(ir)) J.push(e.spacePart()), J.push(e.operatorPart(63)), J.push(e.spacePart()), J.push(e.keywordPart(146)), J.push(e.punctuationPart(20)), J.push(e.displayPart(e.getTextOfNode(e.getExternalModuleImportEqualsDeclarationExpression(ir)), e.SymbolDisplayPartKind.stringLiteral)), J.push(e.punctuationPart(21));
                      else {
                        var Cr = m.getSymbolAtLocation(ir.moduleReference);
                        Cr && (J.push(e.spacePart()), J.push(e.operatorPart(63)), J.push(e.spacePart()), _e(Cr, f));
                      }
                      return true;
                    }
                  });
                }
                if (!ve) if (O !== "") {
                  if (he) {
                    if (ee ? (He(), J.push(e.keywordPart(108))) : we(G, O), O === "property" || O === "getter" || O === "setter" || O === "JSX attribute" || q & 3 || O === "local var" || ee) {
                      if (J.push(e.punctuationPart(58)), J.push(e.spacePart()), he.symbol && he.symbol.flags & 262144) {
                        var ue = e.mapToDisplayParts(function(er) {
                          var ir = m.typeParameterToDeclaration(he, f, w);
                          Ee().writeNode(4, ir, e.getSourceFileOfNode(e.getParseTreeNode(f)), er);
                        });
                        e.addRange(J, ue);
                      } else e.addRange(J, e.typeToDisplayParts(m, he, f));
                      if (G.target && G.target.tupleLabelDeclaration) {
                        var We = G.target.tupleLabelDeclaration;
                        e.Debug.assertNode(We.name, e.isIdentifier), J.push(e.spacePart()), J.push(e.punctuationPart(20)), J.push(e.textPart(e.idText(We.name))), J.push(e.punctuationPart(21));
                      }
                    } else if (q & 16 || q & 8192 || q & 16384 || q & 131072 || q & 98304 || O === "method") {
                      var k = he.getNonNullableType().getCallSignatures();
                      k.length && (ye(k[0], k), $ = k.length > 1);
                    }
                  }
                } else O = B(m, G, T);
                if (ie.length === 0 && !$ && (ie = G.getContextualDocumentationComment(f, m)), ie.length === 0 && q & 4 && G.parent && G.declarations && e.forEach(G.parent.declarations, function(er) {
                  return er.kind === 305;
                })) for (var Fe = 0, Z = G.declarations; Fe < Z.length; Fe++) {
                  var A = Z[Fe];
                  if (!(!A.parent || A.parent.kind !== 221)) {
                    var Be = m.getSymbolAtLocation(A.parent.right);
                    if (!!Be && (ie = Be.getDocumentationComment(m), R = Be.getJsDocTags(m), ie.length > 0)) break;
                  }
                }
                if (ie.length === 0 && e.isIdentifier(T) && G.valueDeclaration && e.isBindingElement(G.valueDeclaration)) {
                  var A = G.valueDeclaration, ge = A.parent;
                  if (e.isIdentifier(A.name) && e.isObjectBindingPattern(ge)) {
                    var Re = e.getTextOfIdentifierOrLiteral(A.name), ze = m.getTypeAtLocation(ge);
                    ie = e.firstDefined(ze.isUnion() ? ze.types : [ze], function(ir) {
                      var Cr = ir.getProperty(Re);
                      return Cr ? Cr.getDocumentationComment(m) : void 0;
                    }) || e.emptyArray;
                  }
                }
                return R.length === 0 && !$ && (R = G.getContextualJsDocTags(f, m)), ie.length === 0 && x && (ie = x), R.length === 0 && X && (R = X), { displayParts: J, documentation: ie, symbolKind: O, tags: R.length === 0 ? void 0 : R };
                function Ee() {
                  return F || (F = e.createPrinter({ removeComments: true })), F;
                }
                function He() {
                  J.length && J.push(e.lineBreakPart()), rr();
                }
                function rr() {
                  b && (de("alias"), J.push(e.spacePart()));
                }
                function Ie() {
                  J.push(e.spacePart()), J.push(e.keywordPart(101)), J.push(e.spacePart());
                }
                function _e(er, ir) {
                  b && er === G && (er = b);
                  var Cr = e.symbolToDisplayParts(m, er, ir || oe, void 0, 7);
                  e.addRange(J, Cr), G.flags & 16777216 && J.push(e.punctuationPart(57));
                }
                function we(er, ir) {
                  He(), ir && (de(ir), er && !e.some(er.declarations, function(Cr) {
                    return e.isArrowFunction(Cr) || (e.isFunctionExpression(Cr) || e.isClassExpression(Cr)) && !Cr.name;
                  }) && (J.push(e.spacePart()), _e(er)));
                }
                function de(er) {
                  switch (er) {
                    case "var":
                    case "function":
                    case "let":
                    case "const":
                    case "constructor":
                      J.push(e.textOrKeywordPart(er));
                      return;
                    default:
                      J.push(e.punctuationPart(20)), J.push(e.textOrKeywordPart(er)), J.push(e.punctuationPart(21));
                      return;
                  }
                }
                function ye(er, ir, Cr) {
                  Cr === void 0 && (Cr = 0), e.addRange(J, e.signatureToDisplayParts(m, er, f, Cr | 32)), ir.length > 1 && (J.push(e.spacePart()), J.push(e.punctuationPart(20)), J.push(e.operatorPart(39)), J.push(e.displayPart((ir.length - 1).toString(), e.SymbolDisplayPartKind.numericLiteral)), J.push(e.spacePart()), J.push(e.textPart(ir.length === 2 ? "overload" : "overloads")), J.push(e.punctuationPart(21))), ie = er.getDocumentationComment(m), R = er.getJsDocTags(), ir.length > 1 && ie.length === 0 && R.length === 0 && (ie = ir[0].getDocumentationComment(m), R = ir[0].getJsDocTags());
                }
                function Ae(er, ir) {
                  var Cr = e.mapToDisplayParts(function(Ye) {
                    var Br = m.symbolToTypeParameterDeclarations(er, ir, w);
                    Ee().writeList(53776, Br, e.getSourceFileOfNode(e.getParseTreeNode(ir)), Ye);
                  });
                  e.addRange(J, Cr);
                }
              }
              C.getSymbolDisplayPartsDocumentationAndSymbolKind = N;
              function p(m) {
                return m.parent ? false : e.forEach(m.declarations, function(G) {
                  if (G.kind === 213) return true;
                  if (G.kind !== 254 && G.kind !== 256) return false;
                  for (var oe = G.parent; !e.isFunctionBlock(oe); oe = oe.parent) if (oe.kind === 305 || oe.kind === 262) return false;
                  return true;
                });
              }
            })(a = e.SymbolDisplay || (e.SymbolDisplay = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(E, Q) {
              var le = [], N = Q.compilerOptions ? B(Q.compilerOptions, le) : {}, p = e.getDefaultCompilerOptions();
              for (var m in p) e.hasProperty(p, m) && N[m] === void 0 && (N[m] = p[m]);
              for (var G = 0, oe = e.transpileOptionValueCompilerOptions; G < oe.length; G++) {
                var f = oe[G];
                N[f.name] = f.transpileOptionValue;
              }
              N.suppressOutputPathCheck = true, N.allowNonTsExtensions = true;
              var T = e.getNewLineCharacter(N), K = { getSourceFile: function(q) {
                return q === e.normalizePath(b) ? se : void 0;
              }, writeFile: function(q, O) {
                e.fileExtensionIs(q, ".map") ? (e.Debug.assertEqual(ie, void 0, "Unexpected multiple source map outputs, file:", q), ie = O) : (e.Debug.assertEqual(J, void 0, "Unexpected multiple outputs, file:", q), J = O);
              }, getDefaultLibFileName: function() {
                return "lib.d.ts";
              }, useCaseSensitiveFileNames: function() {
                return false;
              }, getCanonicalFileName: function(q) {
                return q;
              }, getCurrentDirectory: function() {
                return "";
              }, getNewLine: function() {
                return T;
              }, fileExists: function(q) {
                return q === b;
              }, readFile: function() {
                return "";
              }, directoryExists: function() {
                return true;
              }, getDirectories: function() {
                return [];
              } }, b = Q.fileName || (Q.compilerOptions && Q.compilerOptions.jsx ? "module.tsx" : "module.ts"), se = e.createSourceFile(b, E, { languageVersion: e.getEmitScriptTarget(N), impliedNodeFormat: e.getImpliedNodeFormatForFile(e.toPath(b, "", K.getCanonicalFileName), void 0, K, N), setExternalModuleIndicator: e.getSetExternalModuleIndicator(N) });
              Q.moduleName && (se.moduleName = Q.moduleName), Q.renamedDependencies && (se.renamedDependencies = new e.Map(e.getEntries(Q.renamedDependencies)));
              var J, ie, R = e.createProgram([b], N, K);
              return Q.reportDiagnostics && (e.addRange(le, R.getSyntacticDiagnostics(se)), e.addRange(le, R.getOptionsDiagnostics())), R.emit(void 0, void 0, void 0, void 0, Q.transformers), J === void 0 ? e.Debug.fail("Output generation failed") : { outputText: J, diagnostics: le, sourceMapText: ie };
            }
            e.transpileModule = a;
            function C(E, Q, le, N, p) {
              var m = a(E, { compilerOptions: Q, fileName: le, reportDiagnostics: !!N, moduleName: p });
              return e.addRange(N, m.diagnostics), m.outputText;
            }
            e.transpile = C;
            var w;
            function B(E, Q) {
              w = w || e.filter(e.optionDeclarations, function(G) {
                return typeof G.type == "object" && !e.forEachEntry(G.type, function(oe) {
                  return typeof oe != "number";
                });
              }), E = e.cloneCompilerOptions(E);
              for (var le = function(G) {
                if (!e.hasProperty(E, G.name)) return "continue";
                var oe = E[G.name];
                e.isString(oe) ? E[G.name] = e.parseCustomTypeOption(G, oe, Q) : e.forEachEntry(G.type, function(f) {
                  return f === oe;
                }) || Q.push(e.createCompilerDiagnosticForInvalidCustomType(G));
              }, N = 0, p = w; N < p.length; N++) {
                var m = p[N];
                le(m);
              }
              return E;
            }
            e.fixupCompilerOptions = B;
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w;
              (function(E) {
                E[E.FormatDocument = 0] = "FormatDocument", E[E.FormatSelection = 1] = "FormatSelection", E[E.FormatOnEnter = 2] = "FormatOnEnter", E[E.FormatOnSemicolon = 3] = "FormatOnSemicolon", E[E.FormatOnOpeningCurlyBrace = 4] = "FormatOnOpeningCurlyBrace", E[E.FormatOnClosingCurlyBrace = 5] = "FormatOnClosingCurlyBrace";
              })(w = C.FormattingRequestKind || (C.FormattingRequestKind = {}));
              var B = function() {
                function E(Q, le, N) {
                  this.sourceFile = Q, this.formattingRequestKind = le, this.options = N;
                }
                return E.prototype.updateContext = function(Q, le, N, p, m) {
                  this.currentTokenSpan = e.Debug.checkDefined(Q), this.currentTokenParent = e.Debug.checkDefined(le), this.nextTokenSpan = e.Debug.checkDefined(N), this.nextTokenParent = e.Debug.checkDefined(p), this.contextNode = e.Debug.checkDefined(m), this.contextNodeAllOnSameLine = void 0, this.nextNodeAllOnSameLine = void 0, this.tokensAreOnSameLine = void 0, this.contextNodeBlockIsOnOneLine = void 0, this.nextNodeBlockIsOnOneLine = void 0;
                }, E.prototype.ContextNodeAllOnSameLine = function() {
                  return this.contextNodeAllOnSameLine === void 0 && (this.contextNodeAllOnSameLine = this.NodeIsOnOneLine(this.contextNode)), this.contextNodeAllOnSameLine;
                }, E.prototype.NextNodeAllOnSameLine = function() {
                  return this.nextNodeAllOnSameLine === void 0 && (this.nextNodeAllOnSameLine = this.NodeIsOnOneLine(this.nextTokenParent)), this.nextNodeAllOnSameLine;
                }, E.prototype.TokensAreOnSameLine = function() {
                  if (this.tokensAreOnSameLine === void 0) {
                    var Q = this.sourceFile.getLineAndCharacterOfPosition(this.currentTokenSpan.pos).line, le = this.sourceFile.getLineAndCharacterOfPosition(this.nextTokenSpan.pos).line;
                    this.tokensAreOnSameLine = Q === le;
                  }
                  return this.tokensAreOnSameLine;
                }, E.prototype.ContextNodeBlockIsOnOneLine = function() {
                  return this.contextNodeBlockIsOnOneLine === void 0 && (this.contextNodeBlockIsOnOneLine = this.BlockIsOnOneLine(this.contextNode)), this.contextNodeBlockIsOnOneLine;
                }, E.prototype.NextNodeBlockIsOnOneLine = function() {
                  return this.nextNodeBlockIsOnOneLine === void 0 && (this.nextNodeBlockIsOnOneLine = this.BlockIsOnOneLine(this.nextTokenParent)), this.nextNodeBlockIsOnOneLine;
                }, E.prototype.NodeIsOnOneLine = function(Q) {
                  var le = this.sourceFile.getLineAndCharacterOfPosition(Q.getStart(this.sourceFile)).line, N = this.sourceFile.getLineAndCharacterOfPosition(Q.getEnd()).line;
                  return le === N;
                }, E.prototype.BlockIsOnOneLine = function(Q) {
                  var le = e.findChildOfKind(Q, 18, this.sourceFile), N = e.findChildOfKind(Q, 19, this.sourceFile);
                  if (le && N) {
                    var p = this.sourceFile.getLineAndCharacterOfPosition(le.getEnd()).line, m = this.sourceFile.getLineAndCharacterOfPosition(N.getStart(this.sourceFile)).line;
                    return p === m;
                  }
                  return false;
                }, E;
              }();
              C.FormattingContext = B;
            })(a = e.formatting || (e.formatting = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = e.createScanner(99, false, 0), B = e.createScanner(99, false, 1), E;
              (function(le) {
                le[le.Scan = 0] = "Scan", le[le.RescanGreaterThanToken = 1] = "RescanGreaterThanToken", le[le.RescanSlashToken = 2] = "RescanSlashToken", le[le.RescanTemplateToken = 3] = "RescanTemplateToken", le[le.RescanJsxIdentifier = 4] = "RescanJsxIdentifier", le[le.RescanJsxText = 5] = "RescanJsxText", le[le.RescanJsxAttributeValue = 6] = "RescanJsxAttributeValue";
              })(E || (E = {}));
              function Q(le, N, p, m, G) {
                var oe = N === 1 ? B : w;
                oe.setText(le), oe.setTextPos(p);
                var f = true, T, K, b, se, J, ie = G({ advance: R, readTokenInfo: X, readEOFTokenRange: A, isOnToken: y, isOnEOF: V, getCurrentLeadingTrivia: function() {
                  return T;
                }, lastTrailingTriviaWasNewLine: function() {
                  return f;
                }, skipToEndOf: P, skipToStartOf: k, getStartPos: function() {
                  var Y;
                  return (Y = J == null ? void 0 : J.token.pos) !== null && Y !== void 0 ? Y : oe.getTokenPos();
                } });
                return J = void 0, oe.setText(void 0), ie;
                function R() {
                  J = void 0;
                  var Y = oe.getStartPos() !== p;
                  Y ? f = !!K && e.last(K).kind === 4 : oe.scan(), T = void 0, K = void 0;
                  for (var U = oe.getStartPos(); U < m; ) {
                    var j = oe.getToken();
                    if (!e.isTrivia(j)) break;
                    oe.scan();
                    var H = { pos: U, end: oe.getStartPos(), kind: j };
                    U = oe.getStartPos(), T = e.append(T, H);
                  }
                  b = oe.getStartPos();
                }
                function q(Y) {
                  switch (Y.kind) {
                    case 33:
                    case 71:
                    case 72:
                    case 49:
                    case 48:
                      return true;
                  }
                  return false;
                }
                function O(Y) {
                  if (Y.parent) switch (Y.parent.kind) {
                    case 285:
                    case 280:
                    case 281:
                    case 279:
                      return e.isKeyword(Y.kind) || Y.kind === 79;
                  }
                  return false;
                }
                function ve(Y) {
                  return e.isJsxText(Y);
                }
                function ee(Y) {
                  return Y.kind === 13;
                }
                function he(Y) {
                  return Y.kind === 16 || Y.kind === 17;
                }
                function F(Y) {
                  return Y.parent && e.isJsxAttribute(Y.parent) && Y.parent.initializer === Y;
                }
                function x(Y) {
                  return Y === 43 || Y === 68;
                }
                function X(Y) {
                  e.Debug.assert(y());
                  var U = q(Y) ? 1 : ee(Y) ? 2 : he(Y) ? 3 : O(Y) ? 4 : ve(Y) ? 5 : F(Y) ? 6 : 0;
                  if (J && U === se) return L(J, Y);
                  oe.getStartPos() !== b && (e.Debug.assert(J !== void 0), oe.setTextPos(b), oe.scan());
                  var j = $(Y, U), H = C.createTextRangeWithKind(oe.getStartPos(), oe.getTextPos(), j);
                  for (K && (K = void 0); oe.getStartPos() < m && (j = oe.scan(), !!e.isTrivia(j)); ) {
                    var I = C.createTextRangeWithKind(oe.getStartPos(), oe.getTextPos(), j);
                    if (K || (K = []), K.push(I), j === 4) {
                      oe.scan();
                      break;
                    }
                  }
                  return J = { leadingTrivia: T, trailingTrivia: K, token: H }, L(J, Y);
                }
                function $(Y, U) {
                  var j = oe.getToken();
                  switch (se = 0, U) {
                    case 1:
                      if (j === 31) {
                        se = 1;
                        var H = oe.reScanGreaterToken();
                        return e.Debug.assert(Y.kind === H), H;
                      }
                      break;
                    case 2:
                      if (x(j)) {
                        se = 2;
                        var H = oe.reScanSlashToken();
                        return e.Debug.assert(Y.kind === H), H;
                      }
                      break;
                    case 3:
                      if (j === 19) return se = 3, oe.reScanTemplateToken(false);
                      break;
                    case 4:
                      return se = 4, oe.scanJsxIdentifier();
                    case 5:
                      return se = 5, oe.reScanJsxToken(false);
                    case 6:
                      return se = 6, oe.reScanJsxAttributeValue();
                    case 0:
                      break;
                    default:
                      e.Debug.assertNever(U);
                  }
                  return j;
                }
                function A() {
                  return e.Debug.assert(V()), C.createTextRangeWithKind(oe.getStartPos(), oe.getTextPos(), 1);
                }
                function y() {
                  var Y = J ? J.token.kind : oe.getToken();
                  return Y !== 1 && !e.isTrivia(Y);
                }
                function V() {
                  var Y = J ? J.token.kind : oe.getToken();
                  return Y === 1;
                }
                function L(Y, U) {
                  return e.isToken(U) && Y.token.kind !== U.kind && (Y.token.kind = U.kind), Y;
                }
                function P(Y) {
                  oe.setTextPos(Y.end), b = oe.getStartPos(), se = void 0, J = void 0, f = false, T = void 0, K = void 0;
                }
                function k(Y) {
                  oe.setTextPos(Y.pos), b = oe.getStartPos(), se = void 0, J = void 0, f = false, T = void 0, K = void 0;
                }
              }
              C.getFormattingScanner = Q;
            })(a = e.formatting || (e.formatting = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              C.anyContext = e.emptyArray;
              var w;
              (function(E) {
                E[E.StopProcessingSpaceActions = 1] = "StopProcessingSpaceActions", E[E.StopProcessingTokenActions = 2] = "StopProcessingTokenActions", E[E.InsertSpace = 4] = "InsertSpace", E[E.InsertNewLine = 8] = "InsertNewLine", E[E.DeleteSpace = 16] = "DeleteSpace", E[E.DeleteToken = 32] = "DeleteToken", E[E.InsertTrailingSemicolon = 64] = "InsertTrailingSemicolon", E[E.StopAction = 3] = "StopAction", E[E.ModifySpaceAction = 28] = "ModifySpaceAction", E[E.ModifyTokenAction = 96] = "ModifyTokenAction";
              })(w = C.RuleAction || (C.RuleAction = {}));
              var B;
              (function(E) {
                E[E.None = 0] = "None", E[E.CanDeleteNewLines = 1] = "CanDeleteNewLines";
              })(B = C.RuleFlags || (C.RuleFlags = {}));
            })(a = e.formatting || (e.formatting = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w() {
                for (var Ne = [], n = 0; n <= 160; n++) n !== 1 && Ne.push(n);
                function lr() {
                  for (var _r = [], pi = 0; pi < arguments.length; pi++) _r[pi] = arguments[pi];
                  return { tokens: Ne.filter(function(ae) {
                    return !_r.some(function(Xe) {
                      return Xe === ae;
                    });
                  }), isSpecific: false };
                }
                var be = { tokens: Ne, isSpecific: false }, Ge = E(Ve(Ve([], Ne, true), [3], false)), ur = E(Ve(Ve([], Ne, true), [1], false)), yr = le(81, 160), Ir = le(29, 78), wr = [101, 102, 160, 127, 139], Ur = [45, 46, 54, 53], ii = [8, 9, 79, 20, 22, 18, 108, 103], mi = [79, 20, 108, 103], pe = [79, 21, 23, 103], or = [79, 20, 108, 103], qr = [79, 21, 23, 103], si = [2, 3], Di = Ve([79], e.typeKeywords, true), wi = Ge, Xi = E([79, 3, 84, 93, 100]), et = E([21, 3, 90, 111, 96, 91]), Gi = [B("IgnoreBeforeComment", be, si, C.anyContext, 1), B("IgnoreAfterLineComment", 2, be, C.anyContext, 1), B("NotSpaceBeforeColon", be, 58, [g, se, J], 16), B("SpaceAfterColon", 58, be, [g, se], 4), B("NoSpaceBeforeQuestionMark", be, 57, [g, se, J], 16), B("SpaceAfterQuestionMarkInConditionalOperator", 57, be, [g, R], 4), B("NoSpaceAfterQuestionMark", 57, be, [g], 16), B("NoSpaceBeforeDot", be, [24, 28], [g], 16), B("NoSpaceAfterDot", [24, 28], be, [g], 16), B("NoSpaceBetweenImportParenInImportType", 100, 20, [g, fe], 16), B("NoSpaceAfterUnaryPrefixOperator", Ur, ii, [g, se], 16), B("NoSpaceAfterUnaryPreincrementOperator", 45, mi, [g], 16), B("NoSpaceAfterUnaryPredecrementOperator", 46, or, [g], 16), B("NoSpaceBeforeUnaryPostincrementOperator", pe, 45, [g, Cr], 16), B("NoSpaceBeforeUnaryPostdecrementOperator", qr, 46, [g, Cr], 16), B("SpaceAfterPostincrementWhenFollowedByAdd", 45, 39, [g, b], 4), B("SpaceAfterAddWhenFollowedByUnaryPlus", 39, 39, [g, b], 4), B("SpaceAfterAddWhenFollowedByPreincrement", 39, 45, [g, b], 4), B("SpaceAfterPostdecrementWhenFollowedBySubtract", 46, 40, [g, b], 4), B("SpaceAfterSubtractWhenFollowedByUnaryMinus", 40, 40, [g, b], 4), B("SpaceAfterSubtractWhenFollowedByPredecrement", 40, 46, [g, b], 4), B("NoSpaceAfterCloseBrace", 19, [27, 26], [g], 16), B("NewLineBeforeCloseBraceInBlockContext", Ge, 19, [ee], 8), B("SpaceAfterCloseBrace", 19, lr(21), [g, P], 4), B("SpaceBetweenCloseBraceAndElse", 19, 91, [g], 4), B("SpaceBetweenCloseBraceAndWhile", 19, 115, [g], 4), B("NoSpaceBetweenEmptyBraceBrackets", 18, 19, [g, Y], 16), B("SpaceAfterConditionalClosingParen", 21, 22, [k], 4), B("NoSpaceBetweenFunctionKeywordAndStar", 98, 41, [y], 16), B("SpaceAfterStarInGeneratorDeclaration", 41, 79, [y], 4), B("SpaceAfterFunctionInFuncDecl", 98, be, [$], 4), B("NewLineAfterOpenBraceInBlockContext", 18, be, [ee], 8), B("SpaceAfterGetSetInMember", [136, 149], 79, [$], 4), B("NoSpaceBetweenYieldKeywordAndStar", 125, 41, [g, er], 16), B("SpaceBetweenYieldOrYieldStarAndOperand", [125, 41], be, [g, er], 4), B("NoSpaceBetweenReturnAndSemicolon", 105, 26, [g], 16), B("SpaceAfterCertainKeywords", [113, 109, 103, 89, 105, 112, 132], be, [g], 4), B("SpaceAfterLetConstInVariableDeclaration", [119, 85], be, [g, Ee], 4), B("NoSpaceBeforeOpenParenInFuncCall", be, 20, [g, H, I], 16), B("SpaceBeforeBinaryKeywordOperator", be, wr, [g, b], 4), B("SpaceAfterBinaryKeywordOperator", wr, be, [g, b], 4), B("SpaceAfterVoidOperator", 114, be, [g, Ae], 4), B("SpaceBetweenAsyncAndOpenParen", 131, 20, [D, g], 4), B("SpaceBetweenAsyncAndFunctionKeyword", 131, [98, 79], [g], 4), B("NoSpaceBetweenTagAndTemplateString", [79, 21], [14, 15], [g], 16), B("SpaceBeforeJsxAttribute", be, 79, [Fe, g], 4), B("SpaceBeforeSlashInJsxOpeningElement", be, 43, [Be, g], 4), B("NoSpaceBeforeGreaterThanTokenInJsxOpeningElement", 43, 31, [Be, g], 16), B("NoSpaceBeforeEqualInJsxAttribute", be, 63, [Z, g], 16), B("NoSpaceAfterEqualInJsxAttribute", 63, be, [Z, g], 16), B("NoSpaceAfterModuleImport", [141, 146], 20, [g], 16), B("SpaceAfterCertainTypeScriptKeywords", [126, 84, 135, 88, 92, 93, 94, 136, 117, 100, 118, 141, 142, 121, 123, 122, 145, 149, 124, 152, 156, 140, 137], be, [g], 4), B("SpaceBeforeCertainTypeScriptKeywords", be, [94, 117, 156], [g], 4), B("SpaceAfterModuleName", 10, 18, [rr], 4), B("SpaceBeforeArrow", be, 38, [g], 4), B("SpaceAfterArrow", 38, be, [g], 4), B("NoSpaceAfterEllipsis", 25, 79, [g], 16), B("NoSpaceAfterOptionalParameters", 57, [21, 27], [g, se], 16), B("NoSpaceBetweenEmptyInterfaceBraceBrackets", 18, 19, [g, Ie], 16), B("NoSpaceBeforeOpenAngularBracket", Di, 29, [g, de], 16), B("NoSpaceBetweenCloseParenAndAngularBracket", 21, 29, [g, de], 16), B("NoSpaceAfterOpenAngularBracket", 29, be, [g, de], 16), B("NoSpaceBeforeCloseAngularBracket", be, 31, [g, de], 16), B("NoSpaceAfterCloseAngularBracket", 31, [20, 22, 31, 27], [g, de, A], 16), B("SpaceBeforeAt", [21, 79], 59, [g], 4), B("NoSpaceAfterAt", 59, be, [g], 16), B("SpaceAfterDecorator", be, [126, 79, 93, 88, 84, 124, 123, 121, 122, 136, 149, 22, 41], [Re], 4), B("NoSpaceBeforeNonNullAssertionOperator", be, 53, [g, ir], 16), B("NoSpaceAfterNewKeywordOnConstructorSignature", 103, 20, [g, _e], 16), B("SpaceLessThanAndNonJSXTypeAnnotation", 29, 29, [g], 4)], Wt = [B("SpaceAfterConstructor", 134, 20, [p("insertSpaceAfterConstructor"), g], 4), B("NoSpaceAfterConstructor", 134, 20, [G("insertSpaceAfterConstructor"), g], 16), B("SpaceAfterComma", 27, be, [p("insertSpaceAfterCommaDelimiter"), g, ue, l, d], 4), B("NoSpaceAfterComma", 27, be, [G("insertSpaceAfterCommaDelimiter"), g, ue], 16), B("SpaceAfterAnonymousFunctionKeyword", [98, 41], 20, [p("insertSpaceAfterFunctionKeywordForAnonymousFunctions"), $], 4), B("NoSpaceAfterAnonymousFunctionKeyword", [98, 41], 20, [G("insertSpaceAfterFunctionKeywordForAnonymousFunctions"), $], 16), B("SpaceAfterKeywordInControl", yr, 20, [p("insertSpaceAfterKeywordsInControlFlowStatements"), k], 4), B("NoSpaceAfterKeywordInControl", yr, 20, [G("insertSpaceAfterKeywordsInControlFlowStatements"), k], 16), B("SpaceAfterOpenParen", 20, be, [p("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), g], 4), B("SpaceBeforeCloseParen", be, 21, [p("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), g], 4), B("SpaceBetweenOpenParens", 20, 20, [p("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), g], 4), B("NoSpaceBetweenParens", 20, 21, [g], 16), B("NoSpaceAfterOpenParen", 20, be, [G("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), g], 16), B("NoSpaceBeforeCloseParen", be, 21, [G("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), g], 16), B("SpaceAfterOpenBracket", 22, be, [p("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), g], 4), B("SpaceBeforeCloseBracket", be, 23, [p("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), g], 4), B("NoSpaceBetweenBrackets", 22, 23, [g], 16), B("NoSpaceAfterOpenBracket", 22, be, [G("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), g], 16), B("NoSpaceBeforeCloseBracket", be, 23, [G("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), g], 16), B("SpaceAfterOpenBrace", 18, be, [f("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), O], 4), B("SpaceBeforeCloseBrace", be, 19, [f("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), O], 4), B("NoSpaceBetweenEmptyBraceBrackets", 18, 19, [g, Y], 16), B("NoSpaceAfterOpenBrace", 18, be, [m("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), g], 16), B("NoSpaceBeforeCloseBrace", be, 19, [m("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), g], 16), B("SpaceBetweenEmptyBraceBrackets", 18, 19, [p("insertSpaceAfterOpeningAndBeforeClosingEmptyBraces")], 4), B("NoSpaceBetweenEmptyBraceBrackets", 18, 19, [m("insertSpaceAfterOpeningAndBeforeClosingEmptyBraces"), g], 16), B("SpaceAfterTemplateHeadAndMiddle", [15, 16], be, [p("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), ne], 4, 1), B("SpaceBeforeTemplateMiddleAndTail", be, [16, 17], [p("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), g], 4), B("NoSpaceAfterTemplateHeadAndMiddle", [15, 16], be, [G("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), ne], 16, 1), B("NoSpaceBeforeTemplateMiddleAndTail", be, [16, 17], [G("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), g], 16), B("SpaceAfterOpenBraceInJsxExpression", 18, be, [p("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), g, We], 4), B("SpaceBeforeCloseBraceInJsxExpression", be, 19, [p("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), g, We], 4), B("NoSpaceAfterOpenBraceInJsxExpression", 18, be, [G("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), g, We], 16), B("NoSpaceBeforeCloseBraceInJsxExpression", be, 19, [G("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), g, We], 16), B("SpaceAfterSemicolonInFor", 26, be, [p("insertSpaceAfterSemicolonInForStatements"), g, T], 4), B("NoSpaceAfterSemicolonInFor", 26, be, [G("insertSpaceAfterSemicolonInForStatements"), g, T], 16), B("SpaceBeforeBinaryOperator", be, Ir, [p("insertSpaceBeforeAndAfterBinaryOperators"), g, b], 4), B("SpaceAfterBinaryOperator", Ir, be, [p("insertSpaceBeforeAndAfterBinaryOperators"), g, b], 4), B("NoSpaceBeforeBinaryOperator", be, Ir, [G("insertSpaceBeforeAndAfterBinaryOperators"), g, b], 16), B("NoSpaceAfterBinaryOperator", Ir, be, [G("insertSpaceBeforeAndAfterBinaryOperators"), g, b], 16), B("SpaceBeforeOpenParenInFuncDecl", be, 20, [p("insertSpaceBeforeFunctionParenthesis"), g, $], 4), B("NoSpaceBeforeOpenParenInFuncDecl", be, 20, [G("insertSpaceBeforeFunctionParenthesis"), g, $], 16), B("NewLineBeforeOpenBraceInControl", et, 18, [p("placeOpenBraceOnNewLineForControlBlocks"), k, ve], 8, 1), B("NewLineBeforeOpenBraceInFunction", wi, 18, [p("placeOpenBraceOnNewLineForFunctions"), $, ve], 8, 1), B("NewLineBeforeOpenBraceInTypeScriptDeclWithBlock", Xi, 18, [p("placeOpenBraceOnNewLineForFunctions"), V, ve], 8, 1), B("SpaceAfterTypeAssertion", 31, be, [p("insertSpaceAfterTypeAssertion"), g, ye], 4), B("NoSpaceAfterTypeAssertion", 31, be, [G("insertSpaceAfterTypeAssertion"), g, ye], 16), B("SpaceBeforeTypeAnnotation", be, [57, 58], [p("insertSpaceBeforeTypeAnnotation"), g, ie], 4), B("NoSpaceBeforeTypeAnnotation", be, [57, 58], [G("insertSpaceBeforeTypeAnnotation"), g, ie], 16), B("NoOptionalSemicolon", 26, ur, [N("semicolons", e.SemicolonPreference.Remove), Br], 32), B("OptionalSemicolon", be, ur, [N("semicolons", e.SemicolonPreference.Insert), Er], 64)], Zt = [B("NoSpaceBeforeSemicolon", be, 26, [g], 16), B("SpaceBeforeOpenBraceInControl", et, 18, [oe("placeOpenBraceOnNewLineForControlBlocks"), k, He, q], 4, 1), B("SpaceBeforeOpenBraceInFunction", wi, 18, [oe("placeOpenBraceOnNewLineForFunctions"), $, x, He, q], 4, 1), B("SpaceBeforeOpenBraceInTypeScriptDeclWithBlock", Xi, 18, [oe("placeOpenBraceOnNewLineForFunctions"), V, He, q], 4, 1), B("NoSpaceBeforeComma", be, 27, [g], 16), B("NoSpaceBeforeOpenBracket", lr(131, 82), 22, [g], 16), B("NoSpaceAfterCloseBracket", 23, be, [g, ge], 16), B("SpaceAfterSemicolon", 26, be, [g], 4), B("SpaceBetweenForAndAwaitKeyword", 97, 132, [g], 4), B("SpaceBetweenStatements", [21, 90, 91, 82], be, [g, ue, K], 4), B("SpaceAfterTryCatchFinally", [111, 83, 96], 18, [g], 4)];
                return Ve(Ve(Ve([], Gi, true), Wt, true), Zt, true);
              }
              C.getAllRules = w;
              function B(Ne, n, lr, be, Ge, ur) {
                return ur === void 0 && (ur = 0), { leftTokenRange: Q(n), rightTokenRange: Q(lr), rule: { debugName: Ne, context: be, action: Ge, flags: ur } };
              }
              function E(Ne) {
                return { tokens: Ne, isSpecific: true };
              }
              function Q(Ne) {
                return typeof Ne == "number" ? E([Ne]) : e.isArray(Ne) ? E(Ne) : Ne;
              }
              function le(Ne, n, lr) {
                lr === void 0 && (lr = []);
                for (var be = [], Ge = Ne; Ge <= n; Ge++) e.contains(lr, Ge) || be.push(Ge);
                return E(be);
              }
              function N(Ne, n) {
                return function(lr) {
                  return lr.options && lr.options[Ne] === n;
                };
              }
              function p(Ne) {
                return function(n) {
                  return n.options && n.options.hasOwnProperty(Ne) && !!n.options[Ne];
                };
              }
              function m(Ne) {
                return function(n) {
                  return n.options && n.options.hasOwnProperty(Ne) && !n.options[Ne];
                };
              }
              function G(Ne) {
                return function(n) {
                  return !n.options || !n.options.hasOwnProperty(Ne) || !n.options[Ne];
                };
              }
              function oe(Ne) {
                return function(n) {
                  return !n.options || !n.options.hasOwnProperty(Ne) || !n.options[Ne] || n.TokensAreOnSameLine();
                };
              }
              function f(Ne) {
                return function(n) {
                  return !n.options || !n.options.hasOwnProperty(Ne) || !!n.options[Ne];
                };
              }
              function T(Ne) {
                return Ne.contextNode.kind === 242;
              }
              function K(Ne) {
                return !T(Ne);
              }
              function b(Ne) {
                switch (Ne.contextNode.kind) {
                  case 221:
                    return Ne.contextNode.operatorToken.kind !== 27;
                  case 222:
                  case 189:
                  case 229:
                  case 275:
                  case 270:
                  case 177:
                  case 187:
                  case 188:
                    return true;
                  case 203:
                  case 259:
                  case 265:
                  case 271:
                  case 254:
                  case 164:
                  case 299:
                  case 167:
                  case 166:
                    return Ne.currentTokenSpan.kind === 63 || Ne.nextTokenSpan.kind === 63;
                  case 243:
                  case 163:
                    return Ne.currentTokenSpan.kind === 101 || Ne.nextTokenSpan.kind === 101 || Ne.currentTokenSpan.kind === 63 || Ne.nextTokenSpan.kind === 63;
                  case 244:
                    return Ne.currentTokenSpan.kind === 160 || Ne.nextTokenSpan.kind === 160;
                }
                return false;
              }
              function se(Ne) {
                return !b(Ne);
              }
              function J(Ne) {
                return !ie(Ne);
              }
              function ie(Ne) {
                var n = Ne.contextNode.kind;
                return n === 167 || n === 166 || n === 164 || n === 254 || e.isFunctionLikeKind(n);
              }
              function R(Ne) {
                return Ne.contextNode.kind === 222 || Ne.contextNode.kind === 189;
              }
              function q(Ne) {
                return Ne.TokensAreOnSameLine() || x(Ne);
              }
              function O(Ne) {
                return Ne.contextNode.kind === 201 || Ne.contextNode.kind === 195 || he(Ne);
              }
              function ve(Ne) {
                return x(Ne) && !(Ne.NextNodeAllOnSameLine() || Ne.NextNodeBlockIsOnOneLine());
              }
              function ee(Ne) {
                return F(Ne) && !(Ne.ContextNodeAllOnSameLine() || Ne.ContextNodeBlockIsOnOneLine());
              }
              function he(Ne) {
                return F(Ne) && (Ne.ContextNodeAllOnSameLine() || Ne.ContextNodeBlockIsOnOneLine());
              }
              function F(Ne) {
                return X(Ne.contextNode);
              }
              function x(Ne) {
                return X(Ne.nextTokenParent);
              }
              function X(Ne) {
                if (L(Ne)) return true;
                switch (Ne.kind) {
                  case 235:
                  case 263:
                  case 205:
                  case 262:
                    return true;
                }
                return false;
              }
              function $(Ne) {
                switch (Ne.contextNode.kind) {
                  case 256:
                  case 169:
                  case 168:
                  case 172:
                  case 173:
                  case 174:
                  case 213:
                  case 171:
                  case 214:
                  case 258:
                    return true;
                }
                return false;
              }
              function A(Ne) {
                return !$(Ne);
              }
              function y(Ne) {
                return Ne.contextNode.kind === 256 || Ne.contextNode.kind === 213;
              }
              function V(Ne) {
                return L(Ne.contextNode);
              }
              function L(Ne) {
                switch (Ne.kind) {
                  case 257:
                  case 226:
                  case 258:
                  case 260:
                  case 182:
                  case 261:
                  case 272:
                  case 273:
                  case 266:
                  case 269:
                    return true;
                }
                return false;
              }
              function P(Ne) {
                switch (Ne.currentTokenParent.kind) {
                  case 257:
                  case 261:
                  case 260:
                  case 292:
                  case 262:
                  case 249:
                    return true;
                  case 235: {
                    var n = Ne.currentTokenParent.parent;
                    if (!n || n.kind !== 214 && n.kind !== 213) return true;
                  }
                }
                return false;
              }
              function k(Ne) {
                switch (Ne.contextNode.kind) {
                  case 239:
                  case 249:
                  case 242:
                  case 243:
                  case 244:
                  case 241:
                  case 252:
                  case 240:
                  case 248:
                  case 292:
                    return true;
                  default:
                    return false;
                }
              }
              function Y(Ne) {
                return Ne.contextNode.kind === 205;
              }
              function U(Ne) {
                return Ne.contextNode.kind === 208;
              }
              function j(Ne) {
                return Ne.contextNode.kind === 209;
              }
              function H(Ne) {
                return U(Ne) || j(Ne);
              }
              function I(Ne) {
                return Ne.currentTokenSpan.kind !== 27;
              }
              function l(Ne) {
                return Ne.nextTokenSpan.kind !== 23;
              }
              function d(Ne) {
                return Ne.nextTokenSpan.kind !== 21;
              }
              function D(Ne) {
                return Ne.contextNode.kind === 214;
              }
              function fe(Ne) {
                return Ne.contextNode.kind === 200;
              }
              function g(Ne) {
                return Ne.TokensAreOnSameLine() && Ne.contextNode.kind !== 11;
              }
              function ne(Ne) {
                return Ne.contextNode.kind !== 11;
              }
              function ue(Ne) {
                return Ne.contextNode.kind !== 278 && Ne.contextNode.kind !== 282;
              }
              function We(Ne) {
                return Ne.contextNode.kind === 288 || Ne.contextNode.kind === 287;
              }
              function Fe(Ne) {
                return Ne.nextTokenParent.kind === 285;
              }
              function Z(Ne) {
                return Ne.contextNode.kind === 285;
              }
              function Be(Ne) {
                return Ne.contextNode.kind === 279;
              }
              function ge(Ne) {
                return !$(Ne) && !x(Ne);
              }
              function Re(Ne) {
                return Ne.TokensAreOnSameLine() && !!Ne.contextNode.decorators && ze(Ne.currentTokenParent) && !ze(Ne.nextTokenParent);
              }
              function ze(Ne) {
                for (; e.isExpressionNode(Ne); ) Ne = Ne.parent;
                return Ne.kind === 165;
              }
              function Ee(Ne) {
                return Ne.currentTokenParent.kind === 255 && Ne.currentTokenParent.getStart(Ne.sourceFile) === Ne.currentTokenSpan.pos;
              }
              function He(Ne) {
                return Ne.formattingRequestKind !== 2;
              }
              function rr(Ne) {
                return Ne.contextNode.kind === 261;
              }
              function Ie(Ne) {
                return Ne.contextNode.kind === 182;
              }
              function _e(Ne) {
                return Ne.contextNode.kind === 175;
              }
              function we(Ne, n) {
                if (Ne.kind !== 29 && Ne.kind !== 31) return false;
                switch (n.kind) {
                  case 178:
                  case 211:
                  case 259:
                  case 257:
                  case 226:
                  case 258:
                  case 256:
                  case 213:
                  case 214:
                  case 169:
                  case 168:
                  case 174:
                  case 175:
                  case 208:
                  case 209:
                  case 228:
                    return true;
                  default:
                    return false;
                }
              }
              function de(Ne) {
                return we(Ne.currentTokenSpan, Ne.currentTokenParent) || we(Ne.nextTokenSpan, Ne.nextTokenParent);
              }
              function ye(Ne) {
                return Ne.contextNode.kind === 211;
              }
              function Ae(Ne) {
                return Ne.currentTokenSpan.kind === 114 && Ne.currentTokenParent.kind === 217;
              }
              function er(Ne) {
                return Ne.contextNode.kind === 224 && Ne.contextNode.expression !== void 0;
              }
              function ir(Ne) {
                return Ne.contextNode.kind === 230;
              }
              function Cr(Ne) {
                return !Ye(Ne);
              }
              function Ye(Ne) {
                switch (Ne.contextNode.kind) {
                  case 239:
                  case 242:
                  case 243:
                  case 244:
                  case 240:
                  case 241:
                    return true;
                  default:
                    return false;
                }
              }
              function Br(Ne) {
                var n = Ne.nextTokenSpan.kind, lr = Ne.nextTokenSpan.pos;
                if (e.isTrivia(n)) {
                  var be = Ne.nextTokenParent === Ne.currentTokenParent ? e.findNextToken(Ne.currentTokenParent, e.findAncestor(Ne.currentTokenParent, function(yr) {
                    return !yr.parent;
                  }), Ne.sourceFile) : Ne.nextTokenParent.getFirstToken(Ne.sourceFile);
                  if (!be) return true;
                  n = be.kind, lr = be.getStart(Ne.sourceFile);
                }
                var Ge = Ne.sourceFile.getLineAndCharacterOfPosition(Ne.currentTokenSpan.pos).line, ur = Ne.sourceFile.getLineAndCharacterOfPosition(lr).line;
                return Ge === ur ? n === 19 || n === 1 : n === 234 || n === 26 ? false : Ne.contextNode.kind === 258 || Ne.contextNode.kind === 259 ? !e.isPropertySignature(Ne.currentTokenParent) || !!Ne.currentTokenParent.type || n !== 20 : e.isPropertyDeclaration(Ne.currentTokenParent) ? !Ne.currentTokenParent.initializer : Ne.currentTokenParent.kind !== 242 && Ne.currentTokenParent.kind !== 236 && Ne.currentTokenParent.kind !== 234 && n !== 22 && n !== 20 && n !== 39 && n !== 40 && n !== 43 && n !== 13 && n !== 27 && n !== 223 && n !== 15 && n !== 14 && n !== 24;
              }
              function Er(Ne) {
                return e.positionIsASICandidate(Ne.currentTokenSpan.end, Ne.currentTokenParent, Ne.sourceFile);
              }
            })(a = e.formatting || (e.formatting = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w(se, J) {
                return { options: se, getRules: E(), host: J };
              }
              C.getFormatContext = w;
              var B;
              function E() {
                return B === void 0 && (B = le(C.getAllRules())), B;
              }
              function Q(se) {
                var J = 0;
                return se & 1 && (J |= 28), se & 2 && (J |= 96), se & 28 && (J |= 28), se & 96 && (J |= 96), J;
              }
              function le(se) {
                var J = N(se);
                return function(ie) {
                  var R = J[p(ie.currentTokenSpan.kind, ie.nextTokenSpan.kind)];
                  if (R) {
                    for (var q = [], O = 0, ve = 0, ee = R; ve < ee.length; ve++) {
                      var he = ee[ve], F = ~Q(O);
                      he.action & F && e.every(he.context, function(x) {
                        return x(ie);
                      }) && (q.push(he), O |= he.action);
                    }
                    if (q.length) return q;
                  }
                };
              }
              function N(se) {
                for (var J = new Array(oe * oe), ie = new Array(J.length), R = 0, q = se; R < q.length; R++) for (var O = q[R], ve = O.leftTokenRange.isSpecific && O.rightTokenRange.isSpecific, ee = 0, he = O.leftTokenRange.tokens; ee < he.length; ee++) for (var F = he[ee], x = 0, X = O.rightTokenRange.tokens; x < X.length; x++) {
                  var $ = X[x], A = p(F, $), y = J[A];
                  y === void 0 && (y = J[A] = []), T(y, O.rule, ve, ie, A);
                }
                return J;
              }
              function p(se, J) {
                return e.Debug.assert(se <= 160 && J <= 160, "Must compute formatting context from tokens"), se * oe + J;
              }
              var m = 5, G = 31, oe = 160 + 1, f;
              (function(se) {
                se[se.StopRulesSpecific = 0] = "StopRulesSpecific", se[se.StopRulesAny = m * 1] = "StopRulesAny", se[se.ContextRulesSpecific = m * 2] = "ContextRulesSpecific", se[se.ContextRulesAny = m * 3] = "ContextRulesAny", se[se.NoContextRulesSpecific = m * 4] = "NoContextRulesSpecific", se[se.NoContextRulesAny = m * 5] = "NoContextRulesAny";
              })(f || (f = {}));
              function T(se, J, ie, R, q) {
                var O = J.action & 3 ? ie ? f.StopRulesSpecific : f.StopRulesAny : J.context !== C.anyContext ? ie ? f.ContextRulesSpecific : f.ContextRulesAny : ie ? f.NoContextRulesSpecific : f.NoContextRulesAny, ve = R[q] || 0;
                se.splice(K(ve, O), 0, J), R[q] = b(ve, O);
              }
              function K(se, J) {
                for (var ie = 0, R = 0; R <= J; R += m) ie += se & G, se >>= m;
                return ie;
              }
              function b(se, J) {
                var ie = (se >> J & G) + 1;
                return e.Debug.assert((ie & G) === ie, "Adding more rules into the sub-bucket than allowed. Maximum allowed is 32 rules."), se & ~(G << J) | ie << J;
              }
            })(a = e.formatting || (e.formatting = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w(A, y, V) {
                var L = { pos: A, end: y, kind: V };
                return e.Debug.isDebugging && Object.defineProperty(L, "__debugKind", { get: function() {
                  return e.Debug.formatSyntaxKind(V);
                } }), L;
              }
              C.createTextRangeWithKind = w;
              var B;
              (function(A) {
                A[A.Unknown = -1] = "Unknown";
              })(B || (B = {}));
              function E(A, y, V) {
                var L = y.getLineAndCharacterOfPosition(A).line;
                if (L === 0) return [];
                for (var P = e.getEndLinePosition(L, y); e.isWhiteSpaceSingleLine(y.text.charCodeAt(P)); ) P--;
                e.isLineBreak(y.text.charCodeAt(P)) && P--;
                var k = { pos: e.getStartPositionOfLine(L - 1, y), end: P + 1 };
                return R(k, y, V, 2);
              }
              C.formatOnEnter = E;
              function Q(A, y, V) {
                var L = G(A, 26, y);
                return ie(oe(L), y, V, 3);
              }
              C.formatOnSemicolon = Q;
              function le(A, y, V) {
                var L = G(A, 18, y);
                if (!L) return [];
                var P = L.parent, k = oe(P), Y = { pos: e.getLineStartPositionForPosition(k.getStart(y), y), end: A };
                return R(Y, y, V, 4);
              }
              C.formatOnOpeningCurly = le;
              function N(A, y, V) {
                var L = G(A, 19, y);
                return ie(oe(L), y, V, 5);
              }
              C.formatOnClosingCurly = N;
              function p(A, y) {
                var V = { pos: 0, end: A.text.length };
                return R(V, A, y, 0);
              }
              C.formatDocument = p;
              function m(A, y, V, L) {
                var P = { pos: e.getLineStartPositionForPosition(A, V), end: y };
                return R(P, V, L, 1);
              }
              C.formatSelection = m;
              function G(A, y, V) {
                var L = e.findPrecedingToken(A, V);
                return L && L.kind === y && A === L.getEnd() ? L : void 0;
              }
              function oe(A) {
                for (var y = A; y && y.parent && y.parent.end === A.end && !f(y.parent, y); ) y = y.parent;
                return y;
              }
              function f(A, y) {
                switch (A.kind) {
                  case 257:
                  case 258:
                    return e.rangeContainsRange(A.members, y);
                  case 261:
                    var V = A.body;
                    return !!V && V.kind === 262 && e.rangeContainsRange(V.statements, y);
                  case 305:
                  case 235:
                  case 262:
                    return e.rangeContainsRange(A.statements, y);
                  case 292:
                    return e.rangeContainsRange(A.block.statements, y);
                }
                return false;
              }
              function T(A, y) {
                return V(y);
                function V(L) {
                  var P = e.forEachChild(L, function(Y) {
                    return e.startEndContainsRange(Y.getStart(y), Y.end, A) && Y;
                  });
                  if (P) {
                    var k = V(P);
                    if (k) return k;
                  }
                  return L;
                }
              }
              function K(A, y) {
                if (!A.length) return P;
                var V = A.filter(function(k) {
                  return e.rangeOverlapsWithStartEnd(y, k.start, k.start + k.length);
                }).sort(function(k, Y) {
                  return k.start - Y.start;
                });
                if (!V.length) return P;
                var L = 0;
                return function(k) {
                  for (; ; ) {
                    if (L >= V.length) return false;
                    var Y = V[L];
                    if (k.end <= Y.start) return false;
                    if (e.startEndOverlapsWithStartEnd(k.pos, k.end, Y.start, Y.start + Y.length)) return true;
                    L++;
                  }
                };
                function P() {
                  return false;
                }
              }
              function b(A, y, V) {
                var L = A.getStart(V);
                if (L === y.pos && A.end === y.end) return L;
                var P = e.findPrecedingToken(y.pos, V);
                return !P || P.end >= y.pos ? A.pos : P.end;
              }
              function se(A, y, V) {
                for (var L = -1, P; A; ) {
                  var k = V.getLineAndCharacterOfPosition(A.getStart(V)).line;
                  if (L !== -1 && k !== L) break;
                  if (C.SmartIndenter.shouldIndentChildNode(y, A, P, V)) return y.indentSize;
                  L = k, P = A, A = A.parent;
                }
                return 0;
              }
              function J(A, y, V, L, P, k) {
                var Y = { pos: A.pos, end: A.end };
                return C.getFormattingScanner(y.text, V, Y.pos, Y.end, function(U) {
                  return q(Y, A, L, P, U, k, 1, function(j) {
                    return false;
                  }, y);
                });
              }
              C.formatNodeGivenIndentation = J;
              function ie(A, y, V, L) {
                if (!A) return [];
                var P = { pos: e.getLineStartPositionForPosition(A.getStart(y), y), end: A.end };
                return R(P, y, V, L);
              }
              function R(A, y, V, L) {
                var P = T(A, y);
                return C.getFormattingScanner(y.text, y.languageVariant, b(P, A, y), A.end, function(k) {
                  return q(A, P, C.SmartIndenter.getIndentationForNode(P, A, y, V.options), se(P, V.options, y), k, V, L, K(y.parseDiagnostics, A), y);
                });
              }
              function q(A, y, V, L, P, k, Y, U, j) {
                var H, I = k.options, l = k.getRules, d = k.host, D = new C.FormattingContext(j, Y, I), fe, g, ne, ue, We = -1, Fe = [];
                if (P.advance(), P.isOnToken()) {
                  var Z = j.getLineAndCharacterOfPosition(y.getStart(j)).line, Be = Z;
                  y.decorators && (Be = j.getLineAndCharacterOfPosition(e.getNonDecoratorTokenPosOfNode(y, j)).line), we(y, y, Z, Be, V, L);
                }
                if (!P.isOnToken()) {
                  var ge = C.SmartIndenter.nodeWillIndentChild(I, y, void 0, j, false) ? V + I.indentSize : V, Re = P.getCurrentLeadingTrivia();
                  Re && (de(Re, ge, false, function(Ir) {
                    return Ae(Ir, j.getLineAndCharacterOfPosition(Ir.pos), y, y, void 0);
                  }), I.trimTrailingWhitespace !== false && n(Re));
                }
                if (fe && P.getStartPos() >= A.end) {
                  var ze = P.isOnEOF() ? P.readEOFTokenRange() : P.isOnToken() ? P.readTokenInfo(y).token : void 0;
                  if (ze) {
                    var Ee = ((H = e.findPrecedingToken(ze.end, j, y)) === null || H === void 0 ? void 0 : H.parent) || g;
                    er(ze, j.getLineAndCharacterOfPosition(ze.pos).line, Ee, fe, ne, g, Ee, void 0);
                  }
                }
                return Fe;
                function He(Ir, wr, Ur, ii, mi) {
                  if (e.rangeOverlapsWithStartEnd(ii, Ir, wr) || e.rangeContainsStartEnd(ii, Ir, wr)) {
                    if (mi !== -1) return mi;
                  } else {
                    var pe = j.getLineAndCharacterOfPosition(Ir).line, or = e.getLineStartPositionForPosition(Ir, j), qr = C.SmartIndenter.findFirstNonWhitespaceColumn(or, Ir, j, I);
                    if (pe !== Ur || Ir === qr) {
                      var si = C.SmartIndenter.getBaseIndentation(I);
                      return si > qr ? si : qr;
                    }
                  }
                  return -1;
                }
                function rr(Ir, wr, Ur, ii, mi, pe) {
                  var or = C.SmartIndenter.shouldIndentChildNode(I, Ir) ? I.indentSize : 0;
                  return pe === wr ? { indentation: wr === ue ? We : mi.getIndentation(), delta: Math.min(I.indentSize, mi.getDelta(Ir) + or) } : Ur === -1 ? Ir.kind === 20 && wr === ue ? { indentation: We, delta: mi.getDelta(Ir) } : C.SmartIndenter.childStartsOnTheSameLineWithElseInIfStatement(ii, Ir, wr, j) || C.SmartIndenter.childIsUnindentedBranchOfConditionalExpression(ii, Ir, wr, j) || C.SmartIndenter.argumentStartsOnSameLineAsPreviousArgument(ii, Ir, wr, j) ? { indentation: mi.getIndentation(), delta: or } : { indentation: mi.getIndentation() + mi.getDelta(Ir), delta: or } : { indentation: Ur, delta: or };
                }
                function Ie(Ir) {
                  if (Ir.modifiers && Ir.modifiers.length) return Ir.modifiers[0].kind;
                  switch (Ir.kind) {
                    case 257:
                      return 84;
                    case 258:
                      return 118;
                    case 256:
                      return 98;
                    case 260:
                      return 260;
                    case 172:
                      return 136;
                    case 173:
                      return 149;
                    case 169:
                      if (Ir.asteriskToken) return 41;
                    case 167:
                    case 164:
                      var wr = e.getNameOfDeclaration(Ir);
                      if (wr) return wr.kind;
                  }
                }
                function _e(Ir, wr, Ur, ii) {
                  return { getIndentationForComment: function(or, qr, si) {
                    switch (or) {
                      case 19:
                      case 23:
                      case 21:
                        return Ur + pe(si);
                    }
                    return qr !== -1 ? qr : Ur;
                  }, getIndentationForToken: function(or, qr, si, Di) {
                    return !Di && mi(or, qr, si) ? Ur + pe(si) : Ur;
                  }, getIndentation: function() {
                    return Ur;
                  }, getDelta: pe, recomputeIndentation: function(or, qr) {
                    C.SmartIndenter.shouldIndentChildNode(I, qr, Ir, j) && (Ur += or ? I.indentSize : -I.indentSize, ii = C.SmartIndenter.shouldIndentChildNode(I, Ir) ? I.indentSize : 0);
                  } };
                  function mi(or, qr, si) {
                    switch (qr) {
                      case 18:
                      case 19:
                      case 21:
                      case 91:
                      case 115:
                      case 59:
                        return false;
                      case 43:
                      case 31:
                        switch (si.kind) {
                          case 280:
                          case 281:
                          case 279:
                          case 228:
                            return false;
                        }
                        break;
                      case 22:
                      case 23:
                        if (si.kind !== 195) return false;
                        break;
                    }
                    return wr !== or && !(Ir.decorators && qr === Ie(Ir));
                  }
                  function pe(or) {
                    return C.SmartIndenter.nodeWillIndentChild(I, Ir, or, j, true) ? ii : 0;
                  }
                }
                function we(Ir, wr, Ur, ii, mi, pe) {
                  if (!e.rangeOverlapsWithStartEnd(A, Ir.getStart(j), Ir.getEnd())) return;
                  var or = _e(Ir, Ur, mi, pe), qr = wr;
                  for (e.forEachChild(Ir, function(et) {
                    Di(et, -1, Ir, or, Ur, ii, false);
                  }, function(et) {
                    wi(et, Ir, Ur, or);
                  }); P.isOnToken() && P.getStartPos() < A.end; ) {
                    var si = P.readTokenInfo(Ir);
                    if (si.token.end > Math.min(Ir.end, A.end)) break;
                    Xi(si, Ir, or, Ir);
                  }
                  function Di(et, Gi, Wt, Zt, _r, pi, ae, Xe) {
                    if (e.nodeIsMissing(et)) return Gi;
                    var Jr = et.getStart(j), ti = j.getLineAndCharacterOfPosition(Jr).line, Ze = ti;
                    et.decorators && (Ze = j.getLineAndCharacterOfPosition(e.getNonDecoratorTokenPosOfNode(et, j)).line);
                    var Sr = -1;
                    if (ae && e.rangeContainsRange(A, Wt) && (Sr = He(Jr, et.end, _r, A, Gi), Sr !== -1 && (Gi = Sr)), !e.rangeOverlapsWithStartEnd(A, et.pos, et.end)) return et.end < A.pos && P.skipToEndOf(et), Gi;
                    if (et.getFullWidth() === 0) return Gi;
                    for (; P.isOnToken() && P.getStartPos() < A.end; ) {
                      var zr = P.readTokenInfo(Ir);
                      if (zr.token.end > A.end) return Gi;
                      if (zr.token.end > Jr) {
                        zr.token.pos > Jr && P.skipToStartOf(et);
                        break;
                      }
                      Xi(zr, Ir, Zt, Ir);
                    }
                    if (!P.isOnToken() || P.getStartPos() >= A.end) return Gi;
                    if (e.isToken(et)) {
                      var zr = P.readTokenInfo(et);
                      if (et.kind !== 11) return e.Debug.assert(zr.token.end === et.end, "Token end is child end"), Xi(zr, Ir, Zt, et), Gi;
                    }
                    var Wr = et.kind === 165 ? ti : pi, Je = rr(et, ti, Sr, Ir, Zt, Wr);
                    return we(et, qr, ti, Ze, Je.indentation, Je.delta), qr = Ir, Xe && Wt.kind === 204 && Gi === -1 && (Gi = Je.indentation), Gi;
                  }
                  function wi(et, Gi, Wt, Zt) {
                    e.Debug.assert(e.isNodeArray(et));
                    var _r = ee(Gi, et), pi = Zt, ae = Wt;
                    if (!e.rangeOverlapsWithStartEnd(A, et.pos, et.end)) {
                      et.end < A.pos && P.skipToEndOf(et);
                      return;
                    }
                    if (_r !== 0) for (; P.isOnToken() && P.getStartPos() < A.end; ) {
                      var Xe = P.readTokenInfo(Gi);
                      if (Xe.token.end > et.pos) break;
                      if (Xe.token.kind === _r) {
                        ae = j.getLineAndCharacterOfPosition(Xe.token.pos).line, Xi(Xe, Gi, Zt, Gi);
                        var Jr = void 0;
                        if (We !== -1) Jr = We;
                        else {
                          var ti = e.getLineStartPositionForPosition(Xe.token.pos, j);
                          Jr = C.SmartIndenter.findFirstNonWhitespaceColumn(ti, Xe.token.pos, j, I);
                        }
                        pi = _e(Gi, Wt, Jr, I.indentSize);
                      } else Xi(Xe, Gi, Zt, Gi);
                    }
                    for (var Ze = -1, Sr = 0; Sr < et.length; Sr++) {
                      var zr = et[Sr];
                      Ze = Di(zr, Ze, Ir, pi, ae, ae, true, Sr === 0);
                    }
                    var Wr = he(_r);
                    if (Wr !== 0 && P.isOnToken() && P.getStartPos() < A.end) {
                      var Xe = P.readTokenInfo(Gi);
                      if (Xe.token.kind === 27 && e.isCallLikeExpression(Gi)) {
                        var Je = j.getLineAndCharacterOfPosition(Xe.token.pos).line;
                        ae !== Je && (P.advance(), Xe = P.isOnToken() ? P.readTokenInfo(Gi) : void 0);
                      }
                      Xe && Xe.token.kind === Wr && e.rangeContainsRange(Gi, Xe.token) && Xi(Xe, Gi, pi, Gi, true);
                    }
                  }
                  function Xi(et, Gi, Wt, Zt, _r) {
                    e.Debug.assert(e.rangeContainsRange(Gi, et.token));
                    var pi = P.lastTrailingTriviaWasNewLine(), ae = false;
                    et.leadingTrivia && ye(et.leadingTrivia, Gi, qr, Wt);
                    var Xe = 0, Jr = e.rangeContainsRange(A, et.token), ti = j.getLineAndCharacterOfPosition(et.token.pos);
                    if (Jr) {
                      var Ze = U(et.token), Sr = fe;
                      if (Xe = Ae(et.token, ti, Gi, qr, Wt), !Ze) if (Xe === 0) {
                        var zr = Sr && j.getLineAndCharacterOfPosition(Sr.end).line;
                        ae = pi && ti.line !== zr;
                      } else ae = Xe === 1;
                    }
                    if (et.trailingTrivia && ye(et.trailingTrivia, Gi, qr, Wt), ae) {
                      var Wr = Jr && !U(et.token) ? Wt.getIndentationForToken(ti.line, et.token.kind, Zt, !!_r) : -1, Je = true;
                      if (et.leadingTrivia) {
                        var xe = Wt.getIndentationForComment(et.token.kind, Wr, Zt);
                        Je = de(et.leadingTrivia, xe, Je, function(vr) {
                          return ir(vr.pos, xe, false);
                        });
                      }
                      Wr !== -1 && Je && (ir(et.token.pos, Wr, Xe === 1), ue = ti.line, We = Wr);
                    }
                    P.advance(), qr = Gi;
                  }
                }
                function de(Ir, wr, Ur, ii) {
                  for (var mi = 0, pe = Ir; mi < pe.length; mi++) {
                    var or = pe[mi], qr = e.rangeContainsRange(A, or);
                    switch (or.kind) {
                      case 3:
                        qr && Br(or, wr, !Ur), Ur = false;
                        break;
                      case 2:
                        Ur && qr && ii(or), Ur = false;
                        break;
                      case 4:
                        Ur = true;
                        break;
                    }
                  }
                  return Ur;
                }
                function ye(Ir, wr, Ur, ii) {
                  for (var mi = 0, pe = Ir; mi < pe.length; mi++) {
                    var or = pe[mi];
                    if (e.isComment(or.kind) && e.rangeContainsRange(A, or)) {
                      var qr = j.getLineAndCharacterOfPosition(or.pos);
                      Ae(or, qr, wr, Ur, ii);
                    }
                  }
                }
                function Ae(Ir, wr, Ur, ii, mi) {
                  var pe = U(Ir), or = 0;
                  if (!pe) if (fe) or = er(Ir, wr.line, Ur, fe, ne, g, ii, mi);
                  else {
                    var qr = j.getLineAndCharacterOfPosition(A.pos);
                    Er(qr.line, wr.line);
                  }
                  return fe = Ir, g = Ur, ne = wr.line, or;
                }
                function er(Ir, wr, Ur, ii, mi, pe, or, qr) {
                  D.updateContext(ii, pe, Ir, Ur, or);
                  var si = l(D), Di = D.options.trimTrailingWhitespace !== false, wi = 0;
                  return si ? e.forEachRight(si, function(Xi) {
                    if (wi = yr(Xi, ii, mi, Ir, wr), qr) switch (wi) {
                      case 2:
                        Ur.getStart(j) === Ir.pos && qr.recomputeIndentation(false, or);
                        break;
                      case 1:
                        Ur.getStart(j) === Ir.pos && qr.recomputeIndentation(true, or);
                        break;
                      default:
                        e.Debug.assert(wi === 0);
                    }
                    Di = Di && !(Xi.action & 16) && Xi.flags !== 1;
                  }) : Di = Di && Ir.kind !== 1, wr !== mi && Di && Er(mi, wr, ii), wi;
                }
                function ir(Ir, wr, Ur) {
                  var ii = $(wr, I);
                  if (Ur) Ge(Ir, 0, ii);
                  else {
                    var mi = j.getLineAndCharacterOfPosition(Ir), pe = e.getStartPositionOfLine(mi.line, j);
                    (wr !== Cr(pe, mi.character) || Ye(ii, pe)) && Ge(pe, mi.character, ii);
                  }
                }
                function Cr(Ir, wr) {
                  for (var Ur = 0, ii = 0; ii < wr; ii++) j.text.charCodeAt(Ir + ii) === 9 ? Ur += I.tabSize - Ur % I.tabSize : Ur++;
                  return Ur;
                }
                function Ye(Ir, wr) {
                  return Ir !== j.text.substr(wr, Ir.length);
                }
                function Br(Ir, wr, Ur, ii) {
                  ii === void 0 && (ii = true);
                  var mi = j.getLineAndCharacterOfPosition(Ir.pos).line, pe = j.getLineAndCharacterOfPosition(Ir.end).line;
                  if (mi === pe) {
                    Ur || ir(Ir.pos, wr, false);
                    return;
                  }
                  for (var or = [], qr = Ir.pos, si = mi; si < pe; si++) {
                    var Di = e.getEndLinePosition(si, j);
                    or.push({ pos: qr, end: Di }), qr = e.getStartPositionOfLine(si + 1, j);
                  }
                  if (ii && or.push({ pos: qr, end: Ir.end }), or.length !== 0) {
                    var wi = e.getStartPositionOfLine(mi, j), Xi = C.SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(wi, or[0].pos, j, I), et = 0;
                    Ur && (et = 1, mi++);
                    for (var Gi = wr - Xi.column, Wt = et; Wt < or.length; Wt++, mi++) {
                      var Zt = e.getStartPositionOfLine(mi, j), _r = Wt === 0 ? Xi : C.SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(or[Wt].pos, or[Wt].end, j, I), pi = _r.column + Gi;
                      if (pi > 0) {
                        var ae = $(pi, I);
                        Ge(Zt, _r.character, ae);
                      } else be(Zt, _r.character);
                    }
                  }
                }
                function Er(Ir, wr, Ur) {
                  for (var ii = Ir; ii < wr; ii++) {
                    var mi = e.getStartPositionOfLine(ii, j), pe = e.getEndLinePosition(ii, j);
                    if (!(Ur && (e.isComment(Ur.kind) || e.isStringOrRegularExpressionOrTemplateLiteral(Ur.kind)) && Ur.pos <= pe && Ur.end > pe)) {
                      var or = Ne(mi, pe);
                      or !== -1 && (e.Debug.assert(or === mi || !e.isWhiteSpaceSingleLine(j.text.charCodeAt(or - 1))), be(or, pe + 1 - or));
                    }
                  }
                }
                function Ne(Ir, wr) {
                  for (var Ur = wr; Ur >= Ir && e.isWhiteSpaceSingleLine(j.text.charCodeAt(Ur)); ) Ur--;
                  return Ur !== wr ? Ur + 1 : -1;
                }
                function n(Ir) {
                  for (var wr = fe ? fe.end : A.pos, Ur = 0, ii = Ir; Ur < ii.length; Ur++) {
                    var mi = ii[Ur];
                    e.isComment(mi.kind) && (wr < mi.pos && lr(wr, mi.pos - 1, fe), wr = mi.end + 1);
                  }
                  wr < A.end && lr(wr, A.end, fe);
                }
                function lr(Ir, wr, Ur) {
                  var ii = j.getLineAndCharacterOfPosition(Ir).line, mi = j.getLineAndCharacterOfPosition(wr).line;
                  Er(ii, mi + 1, Ur);
                }
                function be(Ir, wr) {
                  wr && Fe.push(e.createTextChangeFromStartLength(Ir, wr, ""));
                }
                function Ge(Ir, wr, Ur) {
                  (wr || Ur) && Fe.push(e.createTextChangeFromStartLength(Ir, wr, Ur));
                }
                function ur(Ir, wr) {
                  wr && Fe.push(e.createTextChangeFromStartLength(Ir, 0, wr));
                }
                function yr(Ir, wr, Ur, ii, mi) {
                  var pe = mi !== Ur;
                  switch (Ir.action) {
                    case 1:
                      return 0;
                    case 16:
                      if (wr.end !== ii.pos) return be(wr.end, ii.pos - wr.end), pe ? 2 : 0;
                      break;
                    case 32:
                      be(wr.pos, wr.end - wr.pos);
                      break;
                    case 8:
                      if (Ir.flags !== 1 && Ur !== mi) return 0;
                      var or = mi - Ur;
                      if (or !== 1) return Ge(wr.end, ii.pos - wr.end, e.getNewLineOrDefaultFromHost(d, I)), pe ? 0 : 1;
                      break;
                    case 4:
                      if (Ir.flags !== 1 && Ur !== mi) return 0;
                      var qr = ii.pos - wr.end;
                      if (qr !== 1 || j.text.charCodeAt(wr.end) !== 32) return Ge(wr.end, ii.pos - wr.end, " "), pe ? 2 : 0;
                      break;
                    case 64:
                      ur(wr.end, ";");
                  }
                  return 0;
                }
              }
              var O;
              (function(A) {
                A[A.None = 0] = "None", A[A.LineAdded = 1] = "LineAdded", A[A.LineRemoved = 2] = "LineRemoved";
              })(O || (O = {}));
              function ve(A, y, V, L) {
                L === void 0 && (L = e.getTokenAtPosition(A, y));
                var P = e.findAncestor(L, e.isJSDoc);
                P && (L = P.parent);
                var k = L.getStart(A);
                if (!(k <= y && y < L.getEnd())) {
                  V = V === null ? void 0 : V === void 0 ? e.findPrecedingToken(y, A) : V;
                  var Y = V && e.getTrailingCommentRanges(A.text, V.end), U = e.getLeadingCommentRangesOfNode(L, A), j = e.concatenate(Y, U);
                  return j && e.find(j, function(H) {
                    return e.rangeContainsPositionExclusive(H, y) || y === H.end && (H.kind === 2 || y === A.getFullWidth());
                  });
                }
              }
              C.getRangeOfEnclosingComment = ve;
              function ee(A, y) {
                switch (A.kind) {
                  case 171:
                  case 256:
                  case 213:
                  case 169:
                  case 168:
                  case 214:
                    if (A.typeParameters === y) return 29;
                    if (A.parameters === y) return 20;
                    break;
                  case 208:
                  case 209:
                    if (A.typeArguments === y) return 29;
                    if (A.arguments === y) return 20;
                    break;
                  case 178:
                    if (A.typeArguments === y) return 29;
                    break;
                  case 182:
                    return 18;
                }
                return 0;
              }
              function he(A) {
                switch (A) {
                  case 20:
                    return 21;
                  case 29:
                    return 31;
                  case 18:
                    return 19;
                }
                return 0;
              }
              var F, x, X;
              function $(A, y) {
                var V = !F || F.tabSize !== y.tabSize || F.indentSize !== y.indentSize;
                if (V && (F = { tabSize: y.tabSize, indentSize: y.indentSize }, x = X = void 0), y.convertTabsToSpaces) {
                  var Y = void 0, U = Math.floor(A / y.indentSize), j = A % y.indentSize;
                  return X || (X = []), X[U] === void 0 ? (Y = e.repeatString(" ", y.indentSize * U), X[U] = Y) : Y = X[U], j ? Y + e.repeatString(" ", j) : Y;
                } else {
                  var L = Math.floor(A / y.tabSize), P = A - L * y.tabSize, k = void 0;
                  return x || (x = []), x[L] === void 0 ? x[L] = k = e.repeatString("	", L) : k = x[L], P ? k + e.repeatString(" ", P) : k;
                }
              }
              C.getIndentationString = $;
            })(a = e.formatting || (e.formatting = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E;
                (function(U) {
                  U[U.Unknown = -1] = "Unknown";
                })(E || (E = {}));
                function Q(U, j, H, I) {
                  if (I === void 0 && (I = false), U > j.text.length) return G(H);
                  if (H.indentStyle === e.IndentStyle.None) return 0;
                  var l = e.findPrecedingToken(U, j, void 0, true), d = C.getRangeOfEnclosingComment(j, U, l || null);
                  if (d && d.kind === 3) return le(j, U, H, d);
                  if (!l) return G(H);
                  var D = e.isStringOrRegularExpressionOrTemplateLiteral(l.kind);
                  if (D && l.getStart(j) <= U && U < l.end) return 0;
                  var fe = j.getLineAndCharacterOfPosition(U).line, g = e.getTokenAtPosition(j, U), ne = g.kind === 18 && g.parent.kind === 205;
                  if (H.indentStyle === e.IndentStyle.Block || ne) return N(j, U, H);
                  if (l.kind === 27 && l.parent.kind !== 221) {
                    var ue = T(l, j, H);
                    if (ue !== -1) return ue;
                  }
                  var We = ee(U, l.parent, j);
                  if (We && !e.rangeContainsRange(We, l)) {
                    var Fe = [213, 214].indexOf(g.parent.kind) !== -1, Z = Fe ? 0 : H.indentSize;
                    return x(We, j, H) + Z;
                  }
                  return p(j, U, l, fe, I, H);
                }
                B.getIndentation = Q;
                function le(U, j, H, I) {
                  var l = e.getLineAndCharacterOfPosition(U, j).line - 1, d = e.getLineAndCharacterOfPosition(U, I.pos).line;
                  if (e.Debug.assert(d >= 0), l <= d) return V(e.getStartPositionOfLine(d, U), j, U, H);
                  var D = e.getStartPositionOfLine(l, U), fe = y(D, j, U, H), g = fe.column, ne = fe.character;
                  if (g === 0) return g;
                  var ue = U.text.charCodeAt(D + ne);
                  return ue === 42 ? g - 1 : g;
                }
                function N(U, j, H) {
                  for (var I = j; I > 0; ) {
                    var l = U.text.charCodeAt(I);
                    if (!e.isWhiteSpaceLike(l)) break;
                    I--;
                  }
                  var d = e.getLineStartPositionForPosition(I, U);
                  return V(d, I, U, H);
                }
                function p(U, j, H, I, l, d) {
                  for (var D, fe = H; fe; ) {
                    if (e.positionBelongsToNode(fe, j, U) && k(d, fe, D, U, true)) {
                      var g = J(fe, U), ne = se(H, fe, I, U), ue = ne !== 0 ? l && ne === 2 ? d.indentSize : 0 : I !== g.line ? d.indentSize : 0;
                      return oe(fe, g, void 0, ue, U, true, d);
                    }
                    var We = X(fe, U, d, true);
                    if (We !== -1) return We;
                    D = fe, fe = fe.parent;
                  }
                  return G(d);
                }
                function m(U, j, H, I) {
                  var l = H.getLineAndCharacterOfPosition(U.getStart(H));
                  return oe(U, l, j, 0, H, false, I);
                }
                B.getIndentationForNode = m;
                function G(U) {
                  return U.baseIndentSize || 0;
                }
                B.getBaseIndentation = G;
                function oe(U, j, H, I, l, d, D) {
                  for (var fe, g = U.parent; g; ) {
                    var ne = true;
                    if (H) {
                      var ue = U.getStart(l);
                      ne = ue < H.pos || ue > H.end;
                    }
                    var We = f(g, U, l), Fe = We.line === j.line || R(g, U, j.line, l);
                    if (ne) {
                      var Z = (fe = ve(U, l)) === null || fe === void 0 ? void 0 : fe[0], Be = !!Z && J(Z, l).line > We.line, ge = X(U, l, D, Be);
                      if (ge !== -1 || (ge = K(U, g, j, Fe, l, D), ge !== -1)) return ge + I;
                    }
                    k(D, g, U, l, d) && !Fe && (I += D.indentSize);
                    var Re = ie(g, U, j.line, l);
                    U = g, g = U.parent, j = Re ? l.getLineAndCharacterOfPosition(U.getStart(l)) : We;
                  }
                  return I + G(D);
                }
                function f(U, j, H) {
                  var I = ve(j, H), l = I ? I.pos : U.getStart(H);
                  return H.getLineAndCharacterOfPosition(l);
                }
                function T(U, j, H) {
                  var I = e.findListItemInfo(U);
                  return I && I.listItemIndex > 0 ? $(I.list.getChildren(), I.listItemIndex - 1, j, H) : -1;
                }
                function K(U, j, H, I, l, d) {
                  var D = (e.isDeclaration(U) || e.isStatementButNotDeclaration(U)) && (j.kind === 305 || !I);
                  return D ? A(H, l, d) : -1;
                }
                var b;
                (function(U) {
                  U[U.Unknown = 0] = "Unknown", U[U.OpenBrace = 1] = "OpenBrace", U[U.CloseBrace = 2] = "CloseBrace";
                })(b || (b = {}));
                function se(U, j, H, I) {
                  var l = e.findNextToken(U, j, I);
                  if (!l) return 0;
                  if (l.kind === 18) return 1;
                  if (l.kind === 19) {
                    var d = J(l, I).line;
                    return H === d ? 2 : 0;
                  }
                  return 0;
                }
                function J(U, j) {
                  return j.getLineAndCharacterOfPosition(U.getStart(j));
                }
                function ie(U, j, H, I) {
                  if (!(e.isCallExpression(U) && e.contains(U.arguments, j))) return false;
                  var l = U.expression.getEnd(), d = e.getLineAndCharacterOfPosition(I, l).line;
                  return d === H;
                }
                B.isArgumentAndStartLineOverlapsExpressionBeingCalled = ie;
                function R(U, j, H, I) {
                  if (U.kind === 239 && U.elseStatement === j) {
                    var l = e.findChildOfKind(U, 91, I);
                    e.Debug.assert(l !== void 0);
                    var d = J(l, I).line;
                    return d === H;
                  }
                  return false;
                }
                B.childStartsOnTheSameLineWithElseInIfStatement = R;
                function q(U, j, H, I) {
                  if (e.isConditionalExpression(U) && (j === U.whenTrue || j === U.whenFalse)) {
                    var l = e.getLineAndCharacterOfPosition(I, U.condition.end).line;
                    if (j === U.whenTrue) return H === l;
                    var d = J(U.whenTrue, I).line, D = e.getLineAndCharacterOfPosition(I, U.whenTrue.end).line;
                    return l === d && D === H;
                  }
                  return false;
                }
                B.childIsUnindentedBranchOfConditionalExpression = q;
                function O(U, j, H, I) {
                  if (e.isCallOrNewExpression(U)) {
                    if (!U.arguments) return false;
                    var l = e.find(U.arguments, function(g) {
                      return g.pos === j.pos;
                    });
                    if (!l) return false;
                    var d = U.arguments.indexOf(l);
                    if (d === 0) return false;
                    var D = U.arguments[d - 1], fe = e.getLineAndCharacterOfPosition(I, D.getEnd()).line;
                    if (H === fe) return true;
                  }
                  return false;
                }
                B.argumentStartsOnSameLineAsPreviousArgument = O;
                function ve(U, j) {
                  return U.parent && he(U.getStart(j), U.getEnd(), U.parent, j);
                }
                B.getContainingList = ve;
                function ee(U, j, H) {
                  return j && he(U, U, j, H);
                }
                function he(U, j, H, I) {
                  switch (H.kind) {
                    case 178:
                      return l(H.typeArguments);
                    case 205:
                      return l(H.properties);
                    case 204:
                      return l(H.elements);
                    case 182:
                      return l(H.members);
                    case 256:
                    case 213:
                    case 214:
                    case 169:
                    case 168:
                    case 174:
                    case 171:
                    case 180:
                    case 175:
                      return l(H.typeParameters) || l(H.parameters);
                    case 172:
                      return l(H.parameters);
                    case 257:
                    case 226:
                    case 258:
                    case 259:
                    case 344:
                      return l(H.typeParameters);
                    case 209:
                    case 208:
                      return l(H.typeArguments) || l(H.arguments);
                    case 255:
                      return l(H.declarations);
                    case 269:
                    case 273:
                      return l(H.elements);
                    case 201:
                    case 202:
                      return l(H.elements);
                  }
                  function l(d) {
                    return d && e.rangeContainsStartEnd(F(H, d, I), U, j) ? d : void 0;
                  }
                }
                function F(U, j, H) {
                  for (var I = U.getChildren(H), l = 1; l < I.length - 1; l++) if (I[l].pos === j.pos && I[l].end === j.end) return { pos: I[l - 1].end, end: I[l + 1].getStart(H) };
                  return j;
                }
                function x(U, j, H) {
                  return U ? A(j.getLineAndCharacterOfPosition(U.pos), j, H) : -1;
                }
                function X(U, j, H, I) {
                  if (U.parent && U.parent.kind === 255) return -1;
                  var l = ve(U, j);
                  if (l) {
                    var d = l.indexOf(U);
                    if (d !== -1) {
                      var D = $(l, d, j, H);
                      if (D !== -1) return D;
                    }
                    return x(l, j, H) + (I ? H.indentSize : 0);
                  }
                  return -1;
                }
                function $(U, j, H, I) {
                  e.Debug.assert(j >= 0 && j < U.length);
                  for (var l = U[j], d = J(l, H), D = j - 1; D >= 0; D--) if (U[D].kind !== 27) {
                    var fe = H.getLineAndCharacterOfPosition(U[D].end).line;
                    if (fe !== d.line) return A(d, H, I);
                    d = J(U[D], H);
                  }
                  return -1;
                }
                function A(U, j, H) {
                  var I = j.getPositionOfLineAndCharacter(U.line, 0);
                  return V(I, I + U.character, j, H);
                }
                function y(U, j, H, I) {
                  for (var l = 0, d = 0, D = U; D < j; D++) {
                    var fe = H.text.charCodeAt(D);
                    if (!e.isWhiteSpaceSingleLine(fe)) break;
                    fe === 9 ? d += I.tabSize + d % I.tabSize : d++, l++;
                  }
                  return { column: d, character: l };
                }
                B.findFirstNonWhitespaceCharacterAndColumn = y;
                function V(U, j, H, I) {
                  return y(U, j, H, I).column;
                }
                B.findFirstNonWhitespaceColumn = V;
                function L(U, j, H, I, l) {
                  var d = H ? H.kind : 0;
                  switch (j.kind) {
                    case 238:
                    case 257:
                    case 226:
                    case 258:
                    case 260:
                    case 259:
                    case 204:
                    case 235:
                    case 262:
                    case 205:
                    case 182:
                    case 195:
                    case 184:
                    case 263:
                    case 290:
                    case 289:
                    case 212:
                    case 206:
                    case 208:
                    case 209:
                    case 237:
                    case 271:
                    case 247:
                    case 222:
                    case 202:
                    case 201:
                    case 280:
                    case 283:
                    case 279:
                    case 288:
                    case 168:
                    case 174:
                    case 175:
                    case 164:
                    case 179:
                    case 180:
                    case 191:
                    case 210:
                    case 218:
                    case 273:
                    case 269:
                    case 275:
                    case 270:
                    case 167:
                      return true;
                    case 254:
                    case 296:
                    case 221:
                      if (!U.indentMultiLineObjectLiteralBeginningOnBlankLine && I && d === 205) return Y(I, H);
                      if (j.kind === 221 && I && H && d === 278) {
                        var D = I.getLineAndCharacterOfPosition(e.skipTrivia(I.text, j.pos)).line, fe = I.getLineAndCharacterOfPosition(e.skipTrivia(I.text, H.pos)).line;
                        return D !== fe;
                      }
                      if (j.kind !== 221) return true;
                      break;
                    case 240:
                    case 241:
                    case 243:
                    case 244:
                    case 242:
                    case 239:
                    case 256:
                    case 213:
                    case 169:
                    case 171:
                    case 172:
                    case 173:
                      return d !== 235;
                    case 214:
                      return I && d === 212 ? Y(I, H) : d !== 235;
                    case 272:
                      return d !== 273;
                    case 266:
                      return d !== 267 || !!H.namedBindings && H.namedBindings.kind !== 269;
                    case 278:
                      return d !== 281;
                    case 282:
                      return d !== 284;
                    case 188:
                    case 187:
                      if (d === 182 || d === 184) return false;
                      break;
                  }
                  return l;
                }
                B.nodeWillIndentChild = L;
                function P(U, j) {
                  switch (U) {
                    case 247:
                    case 251:
                    case 245:
                    case 246:
                      return j.kind !== 235;
                    default:
                      return false;
                  }
                }
                function k(U, j, H, I, l) {
                  return l === void 0 && (l = false), L(U, j, H, I, false) && !(l && H && P(H.kind, j));
                }
                B.shouldIndentChildNode = k;
                function Y(U, j) {
                  var H = e.skipTrivia(U.text, j.pos), I = U.getLineAndCharacterOfPosition(H).line, l = U.getLineAndCharacterOfPosition(j.end).line;
                  return I === l;
                }
              })(w = C.SmartIndenter || (C.SmartIndenter = {}));
            })(a = e.formatting || (e.formatting = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w(H) {
                var I = H.__pos;
                return e.Debug.assert(typeof I == "number"), I;
              }
              function B(H, I) {
                e.Debug.assert(typeof I == "number"), H.__pos = I;
              }
              function E(H) {
                var I = H.__end;
                return e.Debug.assert(typeof I == "number"), I;
              }
              function Q(H, I) {
                e.Debug.assert(typeof I == "number"), H.__end = I;
              }
              var le;
              (function(H) {
                H[H.Exclude = 0] = "Exclude", H[H.IncludeAll = 1] = "IncludeAll", H[H.JSDoc = 2] = "JSDoc", H[H.StartLine = 3] = "StartLine";
              })(le = C.LeadingTriviaOption || (C.LeadingTriviaOption = {}));
              var N;
              (function(H) {
                H[H.Exclude = 0] = "Exclude", H[H.ExcludeWhitespace = 1] = "ExcludeWhitespace", H[H.Include = 2] = "Include";
              })(N = C.TrailingTriviaOption || (C.TrailingTriviaOption = {}));
              function p(H, I) {
                return e.skipTrivia(H, I, false, true);
              }
              function m(H, I) {
                for (var l = I; l < H.length; ) {
                  var d = H.charCodeAt(l);
                  if (e.isWhiteSpaceSingleLine(d)) {
                    l++;
                    continue;
                  }
                  return d === 47;
                }
                return false;
              }
              var G = { leadingTriviaOption: le.Exclude, trailingTriviaOption: N.Exclude }, oe;
              (function(H) {
                H[H.Remove = 0] = "Remove", H[H.ReplaceWithSingleNode = 1] = "ReplaceWithSingleNode", H[H.ReplaceWithMultipleNodes = 2] = "ReplaceWithMultipleNodes", H[H.Text = 3] = "Text";
              })(oe || (oe = {}));
              function f(H, I, l, d) {
                return { pos: T(H, I, d), end: b(H, l, d) };
              }
              function T(H, I, l, d) {
                var D, fe;
                d === void 0 && (d = false);
                var g = l.leadingTriviaOption;
                if (g === le.Exclude) return I.getStart(H);
                if (g === le.StartLine) {
                  var ne = I.getStart(H), ue = e.getLineStartPositionForPosition(ne, H);
                  return e.rangeContainsPosition(I, ue) ? ue : ne;
                }
                if (g === le.JSDoc) {
                  var We = e.getJSDocCommentRanges(I, H.text);
                  if (We != null && We.length) return e.getLineStartPositionForPosition(We[0].pos, H);
                }
                var Fe = I.getFullStart(), Z = I.getStart(H);
                if (Fe === Z) return Z;
                var Be = e.getLineStartPositionForPosition(Fe, H), ge = e.getLineStartPositionForPosition(Z, H);
                if (ge === Be) return g === le.IncludeAll ? Fe : Z;
                if (d) {
                  var Re = ((D = e.getLeadingCommentRanges(H.text, Fe)) === null || D === void 0 ? void 0 : D[0]) || ((fe = e.getTrailingCommentRanges(H.text, Fe)) === null || fe === void 0 ? void 0 : fe[0]);
                  if (Re) return e.skipTrivia(H.text, Re.end, true, true);
                }
                var ze = Fe > 0 ? 1 : 0, Ee = e.getStartPositionOfLine(e.getLineOfLocalPosition(H, Be) + ze, H);
                return Ee = p(H.text, Ee), e.getStartPositionOfLine(e.getLineOfLocalPosition(H, Ee), H);
              }
              function K(H, I, l) {
                var d = I.end, D = l.trailingTriviaOption;
                if (D === N.Include) {
                  var fe = e.getTrailingCommentRanges(H.text, d);
                  if (fe) for (var g = e.getLineOfLocalPosition(H, I.end), ne = 0, ue = fe; ne < ue.length; ne++) {
                    var We = ue[ne];
                    if (We.kind === 2 || e.getLineOfLocalPosition(H, We.pos) > g) break;
                    var Fe = e.getLineOfLocalPosition(H, We.end);
                    if (Fe > g) return e.skipTrivia(H.text, We.end, true, true);
                  }
                }
              }
              function b(H, I, l) {
                var d, D = I.end, fe = l.trailingTriviaOption;
                if (fe === N.Exclude) return D;
                if (fe === N.ExcludeWhitespace) {
                  var g = e.concatenate(e.getTrailingCommentRanges(H.text, D), e.getLeadingCommentRanges(H.text, D)), ne = (d = g == null ? void 0 : g[g.length - 1]) === null || d === void 0 ? void 0 : d.end;
                  return ne || D;
                }
                var ue = K(H, I, l);
                if (ue) return ue;
                var We = e.skipTrivia(H.text, D, true);
                return We !== D && (fe === N.Include || e.isLineBreak(H.text.charCodeAt(We - 1))) ? We : D;
              }
              function se(H, I) {
                return !!I && !!H.parent && (I.kind === 27 || I.kind === 26 && H.parent.kind === 205);
              }
              function J(H) {
                return e.isFunctionExpression(H) || e.isFunctionDeclaration(H);
              }
              C.isThisTypeAnnotatable = J;
              var ie = function() {
                function H(I, l) {
                  this.newLineCharacter = I, this.formatContext = l, this.changes = [], this.newFiles = [], this.classesWithNodesInsertedAtStart = new e.Map(), this.deletedNodes = [];
                }
                return H.fromContext = function(I) {
                  return new H(e.getNewLineOrDefaultFromHost(I.host, I.formatContext.options), I.formatContext);
                }, H.with = function(I, l) {
                  var d = H.fromContext(I);
                  return l(d), d.getChanges();
                }, H.prototype.pushRaw = function(I, l) {
                  e.Debug.assertEqual(I.fileName, l.fileName);
                  for (var d = 0, D = l.textChanges; d < D.length; d++) {
                    var fe = D[d];
                    this.changes.push({ kind: oe.Text, sourceFile: I, text: fe.newText, range: e.createTextRangeFromSpan(fe.span) });
                  }
                }, H.prototype.deleteRange = function(I, l) {
                  this.changes.push({ kind: oe.Remove, sourceFile: I, range: l });
                }, H.prototype.delete = function(I, l) {
                  this.deletedNodes.push({ sourceFile: I, node: l });
                }, H.prototype.deleteNode = function(I, l, d) {
                  d === void 0 && (d = { leadingTriviaOption: le.IncludeAll }), this.deleteRange(I, f(I, l, l, d));
                }, H.prototype.deleteNodes = function(I, l, d, D) {
                  d === void 0 && (d = { leadingTriviaOption: le.IncludeAll });
                  for (var fe = 0, g = l; fe < g.length; fe++) {
                    var ne = g[fe], ue = T(I, ne, d, D), We = b(I, ne, d);
                    this.deleteRange(I, { pos: ue, end: We }), D = !!K(I, ne, d);
                  }
                }, H.prototype.deleteModifier = function(I, l) {
                  this.deleteRange(I, { pos: l.getStart(I), end: e.skipTrivia(I.text, l.end, true) });
                }, H.prototype.deleteNodeRange = function(I, l, d, D) {
                  D === void 0 && (D = { leadingTriviaOption: le.IncludeAll });
                  var fe = T(I, l, D), g = b(I, d, D);
                  this.deleteRange(I, { pos: fe, end: g });
                }, H.prototype.deleteNodeRangeExcludingEnd = function(I, l, d, D) {
                  D === void 0 && (D = { leadingTriviaOption: le.IncludeAll });
                  var fe = T(I, l, D), g = d === void 0 ? I.text.length : T(I, d, D);
                  this.deleteRange(I, { pos: fe, end: g });
                }, H.prototype.replaceRange = function(I, l, d, D) {
                  D === void 0 && (D = {}), this.changes.push({ kind: oe.ReplaceWithSingleNode, sourceFile: I, range: l, options: D, node: d });
                }, H.prototype.replaceNode = function(I, l, d, D) {
                  D === void 0 && (D = G), this.replaceRange(I, f(I, l, l, D), d, D);
                }, H.prototype.replaceNodeRange = function(I, l, d, D, fe) {
                  fe === void 0 && (fe = G), this.replaceRange(I, f(I, l, d, fe), D, fe);
                }, H.prototype.replaceRangeWithNodes = function(I, l, d, D) {
                  D === void 0 && (D = {}), this.changes.push({ kind: oe.ReplaceWithMultipleNodes, sourceFile: I, range: l, options: D, nodes: d });
                }, H.prototype.replaceNodeWithNodes = function(I, l, d, D) {
                  D === void 0 && (D = G), this.replaceRangeWithNodes(I, f(I, l, l, D), d, D);
                }, H.prototype.replaceNodeWithText = function(I, l, d) {
                  this.replaceRangeWithText(I, f(I, l, l, G), d);
                }, H.prototype.replaceNodeRangeWithNodes = function(I, l, d, D, fe) {
                  fe === void 0 && (fe = G), this.replaceRangeWithNodes(I, f(I, l, d, fe), D, fe);
                }, H.prototype.nodeHasTrailingComment = function(I, l, d) {
                  return d === void 0 && (d = G), !!K(I, l, d);
                }, H.prototype.nextCommaToken = function(I, l) {
                  var d = e.findNextToken(l, l.parent, I);
                  return d && d.kind === 27 ? d : void 0;
                }, H.prototype.replacePropertyAssignment = function(I, l, d) {
                  var D = this.nextCommaToken(I, l) ? "" : "," + this.newLineCharacter;
                  this.replaceNode(I, l, d, { suffix: D });
                }, H.prototype.insertNodeAt = function(I, l, d, D) {
                  D === void 0 && (D = {}), this.replaceRange(I, e.createRange(l), d, D);
                }, H.prototype.insertNodesAt = function(I, l, d, D) {
                  D === void 0 && (D = {}), this.replaceRangeWithNodes(I, e.createRange(l), d, D);
                }, H.prototype.insertNodeAtTopOfFile = function(I, l, d) {
                  this.insertAtTopOfFile(I, l, d);
                }, H.prototype.insertNodesAtTopOfFile = function(I, l, d) {
                  this.insertAtTopOfFile(I, l, d);
                }, H.prototype.insertAtTopOfFile = function(I, l, d) {
                  var D = L(I), fe = { prefix: D === 0 ? void 0 : this.newLineCharacter, suffix: (e.isLineBreak(I.text.charCodeAt(D)) ? "" : this.newLineCharacter) + (d ? this.newLineCharacter : "") };
                  e.isArray(l) ? this.insertNodesAt(I, D, l, fe) : this.insertNodeAt(I, D, l, fe);
                }, H.prototype.insertFirstParameter = function(I, l, d) {
                  var D = e.firstOrUndefined(l);
                  D ? this.insertNodeBefore(I, D, d) : this.insertNodeAt(I, l.pos, d);
                }, H.prototype.insertNodeBefore = function(I, l, d, D, fe) {
                  D === void 0 && (D = false), fe === void 0 && (fe = {}), this.insertNodeAt(I, T(I, l, fe), d, this.getOptionsForInsertNodeBefore(l, d, D));
                }, H.prototype.insertModifierAt = function(I, l, d, D) {
                  D === void 0 && (D = {}), this.insertNodeAt(I, l, e.factory.createToken(d), D);
                }, H.prototype.insertModifierBefore = function(I, l, d) {
                  return this.insertModifierAt(I, d.getStart(I), l, { suffix: " " });
                }, H.prototype.insertCommentBeforeLine = function(I, l, d, D) {
                  var fe = e.getStartPositionOfLine(l, I), g = e.getFirstNonSpaceCharacterPosition(I.text, fe), ne = P(I, g), ue = e.getTouchingToken(I, ne ? g : d), We = I.text.slice(fe, g), Fe = "".concat(ne ? "" : this.newLineCharacter, "//").concat(D).concat(this.newLineCharacter).concat(We);
                  this.insertText(I, ue.getStart(I), Fe);
                }, H.prototype.insertJsdocCommentBefore = function(I, l, d) {
                  var D = l.getStart(I);
                  if (l.jsDoc) for (var fe = 0, g = l.jsDoc; fe < g.length; fe++) {
                    var ne = g[fe];
                    this.deleteRange(I, { pos: e.getLineStartPositionForPosition(ne.getStart(I), I), end: b(I, ne, {}) });
                  }
                  var ue = e.getPrecedingNonSpaceCharacterPosition(I.text, D - 1), We = I.text.slice(ue, D);
                  this.insertNodeAt(I, D, d, { suffix: this.newLineCharacter + We });
                }, H.prototype.createJSDocText = function(I, l) {
                  var d = e.flatMap(l.jsDoc, function(fe) {
                    return e.isString(fe.comment) ? e.factory.createJSDocText(fe.comment) : fe.comment;
                  }), D = e.singleOrUndefined(l.jsDoc);
                  return D && e.positionsAreOnSameLine(D.pos, D.end, I) && e.length(d) === 0 ? void 0 : e.factory.createNodeArray(e.intersperse(d, e.factory.createJSDocText(`
`)));
                }, H.prototype.replaceJSDocComment = function(I, l, d) {
                  this.insertJsdocCommentBefore(I, R(l), e.factory.createJSDocComment(this.createJSDocText(I, l), e.factory.createNodeArray(d)));
                }, H.prototype.addJSDocTags = function(I, l, d) {
                  var D = e.flatMapToMutable(l.jsDoc, function(g) {
                    return g.tags;
                  }), fe = d.filter(function(g) {
                    return !D.some(function(ne, ue) {
                      var We = q(ne, g);
                      return We && (D[ue] = We), !!We;
                    });
                  });
                  this.replaceJSDocComment(I, l, Ve(Ve([], D, true), fe, true));
                }, H.prototype.filterJSDocTags = function(I, l, d) {
                  this.replaceJSDocComment(I, l, e.filter(e.flatMapToMutable(l.jsDoc, function(D) {
                    return D.tags;
                  }), d));
                }, H.prototype.replaceRangeWithText = function(I, l, d) {
                  this.changes.push({ kind: oe.Text, sourceFile: I, range: l, text: d });
                }, H.prototype.insertText = function(I, l, d) {
                  this.replaceRangeWithText(I, e.createRange(l), d);
                }, H.prototype.tryInsertTypeAnnotation = function(I, l, d) {
                  var D, fe;
                  if (e.isFunctionLike(l)) {
                    if (fe = e.findChildOfKind(l, 21, I), !fe) {
                      if (!e.isArrowFunction(l)) return false;
                      fe = e.first(l.parameters);
                    }
                  } else fe = (D = l.kind === 254 ? l.exclamationToken : l.questionToken) !== null && D !== void 0 ? D : l.name;
                  return this.insertNodeAt(I, fe.end, d, { prefix: ": " }), true;
                }, H.prototype.tryInsertThisTypeAnnotation = function(I, l, d) {
                  var D = e.findChildOfKind(l, 20, I).getStart(I) + 1, fe = l.parameters.length ? ", " : "";
                  this.insertNodeAt(I, D, d, { prefix: "this: ", suffix: fe });
                }, H.prototype.insertTypeParameters = function(I, l, d) {
                  var D = (e.findChildOfKind(l, 20, I) || e.first(l.parameters)).getStart(I);
                  this.insertNodesAt(I, D, d, { prefix: "<", suffix: ">", joiner: ", " });
                }, H.prototype.getOptionsForInsertNodeBefore = function(I, l, d) {
                  return e.isStatement(I) || e.isClassElement(I) ? { suffix: d ? this.newLineCharacter + this.newLineCharacter : this.newLineCharacter } : e.isVariableDeclaration(I) ? { suffix: ", " } : e.isParameter(I) ? e.isParameter(l) ? { suffix: ", " } : {} : e.isStringLiteral(I) && e.isImportDeclaration(I.parent) || e.isNamedImports(I) ? { suffix: ", " } : e.isImportSpecifier(I) ? { suffix: "," + (d ? this.newLineCharacter : " ") } : e.Debug.failBadSyntaxKind(I);
                }, H.prototype.insertNodeAtConstructorStart = function(I, l, d) {
                  var D = e.firstOrUndefined(l.body.statements);
                  !D || !l.body.multiLine ? this.replaceConstructorBody(I, l, Ve([d], l.body.statements, true)) : this.insertNodeBefore(I, D, d);
                }, H.prototype.insertNodeAtConstructorStartAfterSuperCall = function(I, l, d) {
                  var D = e.find(l.body.statements, function(fe) {
                    return e.isExpressionStatement(fe) && e.isSuperCall(fe.expression);
                  });
                  !D || !l.body.multiLine ? this.replaceConstructorBody(I, l, Ve(Ve([], l.body.statements, true), [d], false)) : this.insertNodeAfter(I, D, d);
                }, H.prototype.insertNodeAtConstructorEnd = function(I, l, d) {
                  var D = e.lastOrUndefined(l.body.statements);
                  !D || !l.body.multiLine ? this.replaceConstructorBody(I, l, Ve(Ve([], l.body.statements, true), [d], false)) : this.insertNodeAfter(I, D, d);
                }, H.prototype.replaceConstructorBody = function(I, l, d) {
                  this.replaceNode(I, l.body, e.factory.createBlock(d, true));
                }, H.prototype.insertNodeAtEndOfScope = function(I, l, d) {
                  var D = T(I, l.getLastToken(), {});
                  this.insertNodeAt(I, D, d, { prefix: e.isLineBreak(I.text.charCodeAt(l.getLastToken().pos)) ? this.newLineCharacter : this.newLineCharacter + this.newLineCharacter, suffix: this.newLineCharacter });
                }, H.prototype.insertMemberAtStart = function(I, l, d) {
                  this.insertNodeAtStartWorker(I, l, d);
                }, H.prototype.insertNodeAtObjectStart = function(I, l, d) {
                  this.insertNodeAtStartWorker(I, l, d);
                }, H.prototype.insertNodeAtStartWorker = function(I, l, d) {
                  var D, fe = (D = this.guessIndentationFromExistingMembers(I, l)) !== null && D !== void 0 ? D : this.computeIndentationForNewMember(I, l);
                  this.insertNodeAt(I, ee(l).pos, d, this.getInsertNodeAtStartInsertOptions(I, l, fe));
                }, H.prototype.guessIndentationFromExistingMembers = function(I, l) {
                  for (var d, D = l, fe = 0, g = ee(l); fe < g.length; fe++) {
                    var ne = g[fe];
                    if (e.rangeStartPositionsAreOnSameLine(D, ne, I)) return;
                    var ue = ne.getStart(I), We = e.formatting.SmartIndenter.findFirstNonWhitespaceColumn(e.getLineStartPositionForPosition(ue, I), ue, I, this.formatContext.options);
                    if (d === void 0) d = We;
                    else if (We !== d) return;
                    D = ne;
                  }
                  return d;
                }, H.prototype.computeIndentationForNewMember = function(I, l) {
                  var d, D = l.getStart(I);
                  return e.formatting.SmartIndenter.findFirstNonWhitespaceColumn(e.getLineStartPositionForPosition(D, I), D, I, this.formatContext.options) + ((d = this.formatContext.options.indentSize) !== null && d !== void 0 ? d : 4);
                }, H.prototype.getInsertNodeAtStartInsertOptions = function(I, l, d) {
                  var D = ee(l), fe = D.length === 0, g = e.addToSeen(this.classesWithNodesInsertedAtStart, e.getNodeId(l), { node: l, sourceFile: I }), ne = e.isObjectLiteralExpression(l) && (!e.isJsonSourceFile(I) || !fe), ue = e.isObjectLiteralExpression(l) && e.isJsonSourceFile(I) && fe && !g;
                  return { indentation: d, prefix: (ue ? "," : "") + this.newLineCharacter, suffix: ne ? "," : "" };
                }, H.prototype.insertNodeAfterComma = function(I, l, d) {
                  var D = this.insertNodeAfterWorker(I, this.nextCommaToken(I, l) || l, d);
                  this.insertNodeAt(I, D, d, this.getInsertNodeAfterOptions(I, l));
                }, H.prototype.insertNodeAfter = function(I, l, d) {
                  var D = this.insertNodeAfterWorker(I, l, d);
                  this.insertNodeAt(I, D, d, this.getInsertNodeAfterOptions(I, l));
                }, H.prototype.insertNodeAtEndOfList = function(I, l, d) {
                  this.insertNodeAt(I, l.end, d, { prefix: ", " });
                }, H.prototype.insertNodesAfter = function(I, l, d) {
                  var D = this.insertNodeAfterWorker(I, l, e.first(d));
                  this.insertNodesAt(I, D, d, this.getInsertNodeAfterOptions(I, l));
                }, H.prototype.insertNodeAfterWorker = function(I, l, d) {
                  k(l, d) && I.text.charCodeAt(l.end - 1) !== 59 && this.replaceRange(I, e.createRange(l.end), e.factory.createToken(26));
                  var D = b(I, l, {});
                  return D;
                }, H.prototype.getInsertNodeAfterOptions = function(I, l) {
                  var d = this.getInsertNodeAfterOptionsWorker(l);
                  return Ke(Ke({}, d), { prefix: l.end === I.end && e.isStatement(l) ? d.prefix ? `
`.concat(d.prefix) : `
` : d.prefix });
                }, H.prototype.getInsertNodeAfterOptionsWorker = function(I) {
                  switch (I.kind) {
                    case 257:
                    case 261:
                      return { prefix: this.newLineCharacter, suffix: this.newLineCharacter };
                    case 254:
                    case 10:
                    case 79:
                      return { prefix: ", " };
                    case 296:
                      return { suffix: "," + this.newLineCharacter };
                    case 93:
                      return { prefix: " " };
                    case 164:
                      return {};
                    default:
                      return e.Debug.assert(e.isStatement(I) || e.isClassOrTypeElement(I)), { suffix: this.newLineCharacter };
                  }
                }, H.prototype.insertName = function(I, l, d) {
                  if (e.Debug.assert(!l.name), l.kind === 214) {
                    var D = e.findChildOfKind(l, 38, I), fe = e.findChildOfKind(l, 20, I);
                    fe ? (this.insertNodesAt(I, fe.getStart(I), [e.factory.createToken(98), e.factory.createIdentifier(d)], { joiner: " " }), U(this, I, D)) : (this.insertText(I, e.first(l.parameters).getStart(I), "function ".concat(d, "(")), this.replaceRange(I, D, e.factory.createToken(21))), l.body.kind !== 235 && (this.insertNodesAt(I, l.body.getStart(I), [e.factory.createToken(18), e.factory.createToken(105)], { joiner: " ", suffix: " " }), this.insertNodesAt(I, l.body.end, [e.factory.createToken(26), e.factory.createToken(19)], { joiner: " " }));
                  } else {
                    var g = e.findChildOfKind(l, l.kind === 213 ? 98 : 84, I).end;
                    this.insertNodeAt(I, g, e.factory.createIdentifier(d), { prefix: " " });
                  }
                }, H.prototype.insertExportModifier = function(I, l) {
                  this.insertText(I, l.getStart(I), "export ");
                }, H.prototype.insertImportSpecifierAtIndex = function(I, l, d, D) {
                  var fe = d.elements[D - 1];
                  fe ? this.insertNodeInListAfter(I, fe, l) : this.insertNodeBefore(I, d.elements[0], l, !e.positionsAreOnSameLine(d.elements[0].getStart(), d.parent.parent.getStart(), I));
                }, H.prototype.insertNodeInListAfter = function(I, l, d, D) {
                  if (D === void 0 && (D = e.formatting.SmartIndenter.getContainingList(l, I)), !D) {
                    e.Debug.fail("node is not a list element");
                    return;
                  }
                  var fe = e.indexOfNode(D, l);
                  if (!(fe < 0)) {
                    var g = l.getEnd();
                    if (fe !== D.length - 1) {
                      var ne = e.getTokenAtPosition(I, l.end);
                      if (ne && se(l, ne)) {
                        var ue = D[fe + 1], We = p(I.text, ue.getFullStart()), Fe = "".concat(e.tokenToString(ne.kind)).concat(I.text.substring(ne.end, We));
                        this.insertNodesAt(I, We, [d], { suffix: Fe });
                      }
                    } else {
                      var Z = l.getStart(I), Be = e.getLineStartPositionForPosition(Z, I), ge = void 0, Re = false;
                      if (D.length === 1) ge = 27;
                      else {
                        var ze = e.findPrecedingToken(l.pos, I);
                        ge = se(l, ze) ? ze.kind : 27;
                        var Ee = e.getLineStartPositionForPosition(D[fe - 1].getStart(I), I);
                        Re = Ee !== Be;
                      }
                      if (m(I.text, l.end) && (Re = true), Re) {
                        this.replaceRange(I, e.createRange(g), e.factory.createToken(ge));
                        for (var He = e.formatting.SmartIndenter.findFirstNonWhitespaceColumn(Be, Z, I, this.formatContext.options), rr = e.skipTrivia(I.text, g, true, false); rr !== g && e.isLineBreak(I.text.charCodeAt(rr - 1)); ) rr--;
                        this.replaceRange(I, e.createRange(rr), d, { indentation: He, prefix: this.newLineCharacter });
                      } else this.replaceRange(I, e.createRange(g), d, { prefix: "".concat(e.tokenToString(ge), " ") });
                    }
                  }
                }, H.prototype.parenthesizeExpression = function(I, l) {
                  this.replaceRange(I, e.rangeOfNode(l), e.factory.createParenthesizedExpression(l));
                }, H.prototype.finishClassesWithNodesInsertedAtStart = function() {
                  var I = this;
                  this.classesWithNodesInsertedAtStart.forEach(function(l) {
                    var d = l.node, D = l.sourceFile, fe = ve(d, D), g = fe[0], ne = fe[1];
                    if (g !== void 0 && ne !== void 0) {
                      var ue = ee(d).length === 0, We = e.positionsAreOnSameLine(g, ne, D);
                      ue && We && g !== ne - 1 && I.deleteRange(D, e.createRange(g, ne - 1)), We && I.insertText(D, ne - 1, I.newLineCharacter);
                    }
                  });
                }, H.prototype.finishDeleteDeclarations = function() {
                  for (var I = this, l = new e.Set(), d = function(Fe, Z) {
                    D.deletedNodes.some(function(Be) {
                      return Be.sourceFile === Fe && e.rangeContainsRangeExclusive(Be.node, Z);
                    }) || (e.isArray(Z) ? D.deleteRange(Fe, e.rangeOfTypeParameters(Fe, Z)) : Y.deleteDeclaration(D, l, Fe, Z));
                  }, D = this, fe = 0, g = this.deletedNodes; fe < g.length; fe++) {
                    var ne = g[fe], ue = ne.sourceFile, We = ne.node;
                    d(ue, We);
                  }
                  l.forEach(function(Fe) {
                    var Z = Fe.getSourceFile(), Be = e.formatting.SmartIndenter.getContainingList(Fe, Z);
                    if (Fe === e.last(Be)) {
                      var ge = e.findLastIndex(Be, function(Re) {
                        return !l.has(Re);
                      }, Be.length - 2);
                      ge !== -1 && I.deleteRange(Z, { pos: Be[ge].end, end: O(Z, Be[ge + 1]) });
                    }
                  });
                }, H.prototype.getChanges = function(I) {
                  this.finishDeleteDeclarations(), this.finishClassesWithNodesInsertedAtStart();
                  for (var l = F.getTextChangesFromChanges(this.changes, this.newLineCharacter, this.formatContext, I), d = 0, D = this.newFiles; d < D.length; d++) {
                    var fe = D[d], g = fe.oldFile, ne = fe.fileName, ue = fe.statements;
                    l.push(F.newFileChanges(g, ne, ue, this.newLineCharacter, this.formatContext));
                  }
                  return l;
                }, H.prototype.createNewFile = function(I, l, d) {
                  this.newFiles.push({ oldFile: I, fileName: l, statements: d });
                }, H;
              }();
              C.ChangeTracker = ie;
              function R(H) {
                if (H.kind !== 214) return H;
                var I = H.parent.kind === 167 ? H.parent : H.parent.parent;
                return I.jsDoc = H.jsDoc, I.jsDocCache = H.jsDocCache, I;
              }
              function q(H, I) {
                if (H.kind === I.kind) switch (H.kind) {
                  case 340: {
                    var l = H, d = I;
                    return e.isIdentifier(l.name) && e.isIdentifier(d.name) && l.name.escapedText === d.name.escapedText ? e.factory.createJSDocParameterTag(void 0, d.name, false, d.typeExpression, d.isNameFirst, l.comment) : void 0;
                  }
                  case 341:
                    return e.factory.createJSDocReturnTag(void 0, I.typeExpression, H.comment);
                  case 343:
                    return e.factory.createJSDocTypeTag(void 0, I.typeExpression, H.comment);
                }
              }
              function O(H, I) {
                return e.skipTrivia(H.text, T(H, I, { leadingTriviaOption: le.IncludeAll }), false, true);
              }
              function ve(H, I) {
                var l = e.findChildOfKind(H, 18, I), d = e.findChildOfKind(H, 19, I);
                return [l == null ? void 0 : l.end, d == null ? void 0 : d.end];
              }
              function ee(H) {
                return e.isObjectLiteralExpression(H) ? H.properties : H.members;
              }
              function he(H, I, l, d) {
                return F.newFileChangesWorker(void 0, I, H, l, d);
              }
              C.getNewFileText = he;
              var F;
              (function(H) {
                function I(ne, ue, We, Fe) {
                  return e.mapDefined(e.group(ne, function(Z) {
                    return Z.sourceFile.path;
                  }), function(Z) {
                    for (var Be = Z[0].sourceFile, ge = e.stableSort(Z, function(He, rr) {
                      return He.range.pos - rr.range.pos || He.range.end - rr.range.end;
                    }), Re = function(He) {
                      e.Debug.assert(ge[He].range.end <= ge[He + 1].range.pos, "Changes overlap", function() {
                        return "".concat(JSON.stringify(ge[He].range), " and ").concat(JSON.stringify(ge[He + 1].range));
                      });
                    }, ze = 0; ze < ge.length - 1; ze++) Re(ze);
                    var Ee = e.mapDefined(ge, function(He) {
                      var rr = e.createTextSpanFromRange(He.range), Ie = D(He, Be, ue, We, Fe);
                      if (!(rr.length === Ie.length && e.stringContainsAt(Be.text, Ie, rr.start))) return e.createTextChange(rr, Ie);
                    });
                    return Ee.length > 0 ? { fileName: Be.fileName, textChanges: Ee } : void 0;
                  });
                }
                H.getTextChangesFromChanges = I;
                function l(ne, ue, We, Fe, Z) {
                  var Be = d(ne, e.getScriptKindFromFileName(ue), We, Fe, Z);
                  return { fileName: ue, textChanges: [e.createTextChange(e.createTextSpan(0, 0), Be)], isNewFile: true };
                }
                H.newFileChanges = l;
                function d(ne, ue, We, Fe, Z) {
                  var Be = We.map(function(ze) {
                    return ze === 4 ? "" : g(ze, ne, Fe).text;
                  }).join(Fe), ge = e.createSourceFile("any file name", Be, 99, true, ue), Re = e.formatting.formatDocument(ge, Z);
                  return x(Be, Re) + Fe;
                }
                H.newFileChangesWorker = d;
                function D(ne, ue, We, Fe, Z) {
                  var Be;
                  if (ne.kind === oe.Remove) return "";
                  if (ne.kind === oe.Text) return ne.text;
                  var ge = ne.options, Re = ge === void 0 ? {} : ge, ze = ne.range.pos, Ee = function(Ie) {
                    return fe(Ie, ue, ze, Re, We, Fe, Z);
                  }, He = ne.kind === oe.ReplaceWithMultipleNodes ? ne.nodes.map(function(Ie) {
                    return e.removeSuffix(Ee(Ie), We);
                  }).join(((Be = ne.options) === null || Be === void 0 ? void 0 : Be.joiner) || We) : Ee(ne.node), rr = Re.indentation !== void 0 || e.getLineStartPositionForPosition(ze, ue) === ze ? He : He.replace(/^\s+/, "");
                  return (Re.prefix || "") + rr + (!Re.suffix || e.endsWith(rr, Re.suffix) ? "" : Re.suffix);
                }
                function fe(ne, ue, We, Fe, Z, Be, ge) {
                  var Re = Fe.indentation, ze = Fe.prefix, Ee = Fe.delta, He = g(ne, ue, Z), rr = He.node, Ie = He.text;
                  ge && ge(rr, Ie);
                  var _e = e.getFormatCodeSettingsForWriting(Be, ue), we = Re !== void 0 ? Re : e.formatting.SmartIndenter.getIndentation(We, ue, _e, ze === Z || e.getLineStartPositionForPosition(We, ue) === We);
                  Ee === void 0 && (Ee = e.formatting.SmartIndenter.shouldIndentChildNode(_e, ne) && _e.indentSize || 0);
                  var de = { text: Ie, getLineAndCharacterOfPosition: function(Ae) {
                    return e.getLineAndCharacterOfPosition(this, Ae);
                  } }, ye = e.formatting.formatNodeGivenIndentation(rr, de, ue.languageVariant, we, Ee, Ke(Ke({}, Be), { options: _e }));
                  return x(Ie, ye);
                }
                function g(ne, ue, We) {
                  var Fe = V(We), Z = e.getNewLineKind(We);
                  return e.createPrinter({ newLine: Z, neverAsciiEscape: true, preserveSourceNewlines: true, terminateUnterminatedLiterals: true }, Fe).writeNode(4, ne, ue, Fe), { text: Fe.getText(), node: A(ne) };
                }
                H.getNonformattedText = g;
              })(F || (F = {}));
              function x(H, I) {
                for (var l = I.length - 1; l >= 0; l--) {
                  var d = I[l], D = d.span, fe = d.newText;
                  H = "".concat(H.substring(0, D.start)).concat(fe).concat(H.substring(e.textSpanEnd(D)));
                }
                return H;
              }
              C.applyChanges = x;
              function X(H) {
                return e.skipTrivia(H, 0) === H.length;
              }
              var $ = Ke(Ke({}, e.nullTransformationContext), { factory: e.createNodeFactory(e.nullTransformationContext.factory.flags | 1, e.nullTransformationContext.factory.baseFactory) });
              function A(H) {
                var I = e.visitEachChild(H, A, $, y, A), l = e.nodeIsSynthesized(I) ? I : Object.create(I);
                return e.setTextRangePosEnd(l, w(H), E(H)), l;
              }
              C.assignPositionsToNode = A;
              function y(H, I, l, d, D) {
                var fe = e.visitNodes(H, I, l, d, D);
                if (!fe) return fe;
                var g = fe === H ? e.factory.createNodeArray(fe.slice(0)) : fe;
                return e.setTextRangePosEnd(g, w(H), E(H)), g;
              }
              function V(H) {
                var I = 0, l = e.createTextWriter(H), d = function(lr) {
                  lr && B(lr, I);
                }, D = function(lr) {
                  lr && Q(lr, I);
                }, fe = function(lr) {
                  lr && B(lr, I);
                }, g = function(lr) {
                  lr && Q(lr, I);
                }, ne = function(lr) {
                  lr && B(lr, I);
                }, ue = function(lr) {
                  lr && Q(lr, I);
                };
                function We(lr, be) {
                  if (be || !X(lr)) {
                    I = l.getTextPos();
                    for (var Ge = 0; e.isWhiteSpaceLike(lr.charCodeAt(lr.length - Ge - 1)); ) Ge++;
                    I -= Ge;
                  }
                }
                function Fe(lr) {
                  l.write(lr), We(lr, false);
                }
                function Z(lr) {
                  l.writeComment(lr);
                }
                function Be(lr) {
                  l.writeKeyword(lr), We(lr, false);
                }
                function ge(lr) {
                  l.writeOperator(lr), We(lr, false);
                }
                function Re(lr) {
                  l.writePunctuation(lr), We(lr, false);
                }
                function ze(lr) {
                  l.writeTrailingSemicolon(lr), We(lr, false);
                }
                function Ee(lr) {
                  l.writeParameter(lr), We(lr, false);
                }
                function He(lr) {
                  l.writeProperty(lr), We(lr, false);
                }
                function rr(lr) {
                  l.writeSpace(lr), We(lr, false);
                }
                function Ie(lr) {
                  l.writeStringLiteral(lr), We(lr, false);
                }
                function _e(lr, be) {
                  l.writeSymbol(lr, be), We(lr, false);
                }
                function we(lr) {
                  l.writeLine(lr);
                }
                function de() {
                  l.increaseIndent();
                }
                function ye() {
                  l.decreaseIndent();
                }
                function Ae() {
                  return l.getText();
                }
                function er(lr) {
                  l.rawWrite(lr), We(lr, false);
                }
                function ir(lr) {
                  l.writeLiteral(lr), We(lr, true);
                }
                function Cr() {
                  return l.getTextPos();
                }
                function Ye() {
                  return l.getLine();
                }
                function Br() {
                  return l.getColumn();
                }
                function Er() {
                  return l.getIndent();
                }
                function Ne() {
                  return l.isAtStartOfLine();
                }
                function n() {
                  l.clear(), I = 0;
                }
                return { onBeforeEmitNode: d, onAfterEmitNode: D, onBeforeEmitNodeArray: fe, onAfterEmitNodeArray: g, onBeforeEmitToken: ne, onAfterEmitToken: ue, write: Fe, writeComment: Z, writeKeyword: Be, writeOperator: ge, writePunctuation: Re, writeTrailingSemicolon: ze, writeParameter: Ee, writeProperty: He, writeSpace: rr, writeStringLiteral: Ie, writeSymbol: _e, writeLine: we, increaseIndent: de, decreaseIndent: ye, getText: Ae, rawWrite: er, writeLiteral: ir, getTextPos: Cr, getLine: Ye, getColumn: Br, getIndent: Er, isAtStartOfLine: Ne, hasTrailingComment: function() {
                  return l.hasTrailingComment();
                }, hasTrailingWhitespace: function() {
                  return l.hasTrailingWhitespace();
                }, clear: n };
              }
              C.createWriter = V;
              function L(H) {
                for (var I, l = 0, d = H.statements; l < d.length; l++) {
                  var D = d[l];
                  if (e.isPrologueDirective(D)) I = D;
                  else break;
                }
                var fe = 0, g = H.text;
                if (I) return fe = I.end, He(), fe;
                var ne = e.getShebang(g);
                ne !== void 0 && (fe = ne.length, He());
                var ue = e.getLeadingCommentRanges(g, fe);
                if (!ue) return fe;
                for (var We, Fe, Z = 0, Be = ue; Z < Be.length; Z++) {
                  var ge = Be[Z];
                  if (ge.kind === 3) {
                    if (e.isPinnedComment(g, ge.pos)) {
                      We = { range: ge, pinnedOrTripleSlash: true };
                      continue;
                    }
                  } else if (e.isRecognizedTripleSlashComment(g, ge.pos, ge.end)) {
                    We = { range: ge, pinnedOrTripleSlash: true };
                    continue;
                  }
                  if (We) {
                    if (We.pinnedOrTripleSlash) break;
                    var Re = H.getLineAndCharacterOfPosition(ge.pos).line, ze = H.getLineAndCharacterOfPosition(We.range.end).line;
                    if (Re >= ze + 2) break;
                  }
                  if (H.statements.length) {
                    Fe === void 0 && (Fe = H.getLineAndCharacterOfPosition(H.statements[0].getStart()).line);
                    var Ee = H.getLineAndCharacterOfPosition(ge.end).line;
                    if (Fe < Ee + 2) break;
                  }
                  We = { range: ge, pinnedOrTripleSlash: false };
                }
                return We && (fe = We.range.end, He()), fe;
                function He() {
                  if (fe < g.length) {
                    var rr = g.charCodeAt(fe);
                    e.isLineBreak(rr) && (fe++, fe < g.length && rr === 13 && g.charCodeAt(fe) === 10 && fe++);
                  }
                }
              }
              function P(H, I) {
                return !e.isInComment(H, I) && !e.isInString(H, I) && !e.isInTemplateString(H, I) && !e.isInJSXText(H, I);
              }
              C.isValidLocationToAddComment = P;
              function k(H, I) {
                return (e.isPropertySignature(H) || e.isPropertyDeclaration(H)) && e.isClassOrTypeElement(I) && I.name.kind === 162 || e.isStatementButNotDeclaration(H) && e.isStatementButNotDeclaration(I);
              }
              var Y;
              (function(H) {
                function I(fe, g, ne, ue) {
                  switch (ue.kind) {
                    case 164: {
                      var We = ue.parent;
                      e.isArrowFunction(We) && We.parameters.length === 1 && !e.findChildOfKind(We, 20, ne) ? fe.replaceNodeWithText(ne, ue, "()") : j(fe, g, ne, ue);
                      break;
                    }
                    case 266:
                    case 265:
                      var Fe = ne.imports.length && ue === e.first(ne.imports).parent || ue === e.find(ne.statements, e.isAnyImportSyntax);
                      U(fe, ne, ue, { leadingTriviaOption: Fe ? le.Exclude : e.hasJSDocNodes(ue) ? le.JSDoc : le.StartLine });
                      break;
                    case 203:
                      var Z = ue.parent, Be = Z.kind === 202 && ue !== e.last(Z.elements);
                      Be ? U(fe, ne, ue) : j(fe, g, ne, ue);
                      break;
                    case 254:
                      D(fe, g, ne, ue);
                      break;
                    case 163:
                      j(fe, g, ne, ue);
                      break;
                    case 270:
                      var ge = ue.parent;
                      ge.elements.length === 1 ? d(fe, ne, ge) : j(fe, g, ne, ue);
                      break;
                    case 268:
                      d(fe, ne, ue);
                      break;
                    case 26:
                      U(fe, ne, ue, { trailingTriviaOption: N.Exclude });
                      break;
                    case 98:
                      U(fe, ne, ue, { leadingTriviaOption: le.Exclude });
                      break;
                    case 257:
                    case 256:
                      U(fe, ne, ue, { leadingTriviaOption: e.hasJSDocNodes(ue) ? le.JSDoc : le.StartLine });
                      break;
                    default:
                      ue.parent ? e.isImportClause(ue.parent) && ue.parent.name === ue ? l(fe, ne, ue.parent) : e.isCallExpression(ue.parent) && e.contains(ue.parent.arguments, ue) ? j(fe, g, ne, ue) : U(fe, ne, ue) : U(fe, ne, ue);
                  }
                }
                H.deleteDeclaration = I;
                function l(fe, g, ne) {
                  if (!ne.namedBindings) U(fe, g, ne.parent);
                  else {
                    var ue = ne.name.getStart(g), We = e.getTokenAtPosition(g, ne.name.end);
                    if (We && We.kind === 27) {
                      var Fe = e.skipTrivia(g.text, We.end, false, true);
                      fe.deleteRange(g, { pos: ue, end: Fe });
                    } else U(fe, g, ne.name);
                  }
                }
                function d(fe, g, ne) {
                  if (ne.parent.name) {
                    var ue = e.Debug.checkDefined(e.getTokenAtPosition(g, ne.pos - 1));
                    fe.deleteRange(g, { pos: ue.getStart(g), end: ne.end });
                  } else {
                    var We = e.getAncestor(ne, 266);
                    U(fe, g, We);
                  }
                }
                function D(fe, g, ne, ue) {
                  var We = ue.parent;
                  if (We.kind === 292) {
                    fe.deleteNodeRange(ne, e.findChildOfKind(We, 20, ne), e.findChildOfKind(We, 21, ne));
                    return;
                  }
                  if (We.declarations.length !== 1) {
                    j(fe, g, ne, ue);
                    return;
                  }
                  var Fe = We.parent;
                  switch (Fe.kind) {
                    case 244:
                    case 243:
                      fe.replaceNode(ne, ue, e.factory.createObjectLiteralExpression());
                      break;
                    case 242:
                      U(fe, ne, We);
                      break;
                    case 237:
                      U(fe, ne, Fe, { leadingTriviaOption: e.hasJSDocNodes(Fe) ? le.JSDoc : le.StartLine });
                      break;
                    default:
                      e.Debug.assertNever(Fe);
                  }
                }
              })(Y || (Y = {}));
              function U(H, I, l, d) {
                d === void 0 && (d = { leadingTriviaOption: le.IncludeAll });
                var D = T(I, l, d), fe = b(I, l, d);
                H.deleteRange(I, { pos: D, end: fe });
              }
              C.deleteNode = U;
              function j(H, I, l, d) {
                var D = e.Debug.checkDefined(e.formatting.SmartIndenter.getContainingList(d, l)), fe = e.indexOfNode(D, d);
                if (e.Debug.assert(fe !== -1), D.length === 1) {
                  U(H, l, d);
                  return;
                }
                e.Debug.assert(!I.has(d), "Deleting a node twice"), I.add(d), H.deleteRange(l, { pos: O(l, d), end: fe === D.length - 1 ? b(l, d, {}) : O(l, D[fe + 1]) });
              }
            })(a = e.textChanges || (e.textChanges = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = e.createMultiMap(), B = new e.Map();
              function E(ie, R, q) {
                return N(ie, e.diagnosticToString(q), R, void 0, void 0);
              }
              C.createCodeFixActionWithoutFixAll = E;
              function Q(ie, R, q, O, ve, ee) {
                return N(ie, e.diagnosticToString(q), R, O, e.diagnosticToString(ve), ee);
              }
              C.createCodeFixAction = Q;
              function le(ie, R, q, O, ve, ee) {
                return N(ie, e.diagnosticToString(q), R, O, ve && e.diagnosticToString(ve), ee);
              }
              C.createCodeFixActionMaybeFixAll = le;
              function N(ie, R, q, O, ve, ee) {
                return { fixName: ie, description: R, changes: q, fixId: O, fixAllDescription: ve, commands: ee ? [ee] : void 0 };
              }
              function p(ie) {
                for (var R = 0, q = ie.errorCodes; R < q.length; R++) {
                  var O = q[R];
                  w.add(String(O), ie);
                }
                if (ie.fixIds) for (var ve = 0, ee = ie.fixIds; ve < ee.length; ve++) {
                  var he = ee[ve];
                  e.Debug.assert(!B.has(he)), B.set(he, ie);
                }
              }
              C.registerCodeFix = p;
              function m() {
                return e.arrayFrom(w.keys());
              }
              C.getSupportedErrorCodes = m;
              function G(ie, R) {
                for (var q = ie.errorCodes, O = 0, ve = 0, ee = R; ve < ee.length; ve++) {
                  var he = ee[ve];
                  if (e.contains(q, he.code) && O++, O > 1) break;
                }
                var F = O < 2;
                return function(x) {
                  var X = x.fixId, $ = x.fixAllDescription, A = pr(x, ["fixId", "fixAllDescription"]);
                  return F ? A : Ke(Ke({}, A), { fixId: X, fixAllDescription: $ });
                };
              }
              function oe(ie) {
                var R = J(ie), q = w.get(String(ie.errorCode));
                return e.flatMap(q, function(O) {
                  return e.map(O.getCodeActions(ie), G(O, R));
                });
              }
              C.getFixes = oe;
              function f(ie) {
                return B.get(e.cast(ie.fixId, e.isString)).getAllCodeActions(ie);
              }
              C.getAllFixes = f;
              function T(ie, R) {
                return { changes: ie, commands: R };
              }
              C.createCombinedCodeActions = T;
              function K(ie, R) {
                return { fileName: ie, textChanges: R };
              }
              C.createFileTextChanges = K;
              function b(ie, R, q) {
                var O = [], ve = e.textChanges.ChangeTracker.with(ie, function(ee) {
                  return se(ie, R, function(he) {
                    return q(ee, he, O);
                  });
                });
                return T(ve, O.length === 0 ? void 0 : O);
              }
              C.codeFixAll = b;
              function se(ie, R, q) {
                for (var O = 0, ve = J(ie); O < ve.length; O++) {
                  var ee = ve[O];
                  e.contains(R, ee.code) && q(ee);
                }
              }
              C.eachDiagnostic = se;
              function J(ie) {
                var R = ie.program, q = ie.sourceFile, O = ie.cancellationToken;
                return Ve(Ve(Ve([], R.getSemanticDiagnostics(q, O), true), R.getSyntacticDiagnostics(q, O), true), e.computeSuggestionDiagnostics(q, R, O), true);
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = new e.Map();
              function B(le, N) {
                w.set(le, N);
              }
              C.registerRefactor = B;
              function E(le) {
                return e.arrayFrom(e.flatMapIterator(w.values(), function(N) {
                  var p;
                  return le.cancellationToken && le.cancellationToken.isCancellationRequested() || !(!((p = N.kinds) === null || p === void 0) && p.some(function(m) {
                    return C.refactorKindBeginsWith(m, le.kind);
                  })) ? void 0 : N.getAvailableActions(le);
                }));
              }
              C.getApplicableRefactors = E;
              function Q(le, N, p) {
                var m = w.get(N);
                return m && m.getEditsForAction(le, p);
              }
              C.getEditsForRefactor = Q;
            })(a = e.refactor || (e.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "addConvertToUnknownForNonOverlappingTypes", B = [e.Diagnostics.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(N) {
                var p = Q(N.sourceFile, N.span.start);
                if (p !== void 0) {
                  var m = e.textChanges.ChangeTracker.with(N, function(G) {
                    return E(G, N.sourceFile, p);
                  });
                  return [C.createCodeFixAction(w, m, e.Diagnostics.Add_unknown_conversion_for_non_overlapping_types, w, e.Diagnostics.Add_unknown_to_all_conversions_of_non_overlapping_types)];
                }
              }, fixIds: [w], getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  var m = Q(p.file, p.start);
                  m && E(N, p.file, m);
                });
              } });
              function E(le, N, p) {
                var m = e.isAsExpression(p) ? e.factory.createAsExpression(p.expression, e.factory.createKeywordTypeNode(155)) : e.factory.createTypeAssertion(e.factory.createKeywordTypeNode(155), p.expression);
                le.replaceNode(N, p.expression, m);
              }
              function Q(le, N) {
                if (!e.isInJSFile(le)) return e.findAncestor(e.getTokenAtPosition(le, N), function(p) {
                  return e.isAsExpression(p) || e.isTypeAssertionExpression(p);
                });
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              C.registerCodeFix({ errorCodes: [e.Diagnostics.await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code, e.Diagnostics.for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code], getCodeActions: function(B) {
                var E = B.sourceFile, Q = e.textChanges.ChangeTracker.with(B, function(le) {
                  var N = e.factory.createExportDeclaration(void 0, void 0, false, e.factory.createNamedExports([]), void 0);
                  le.insertNodeAtEndOfScope(E, E, N);
                });
                return [C.createCodeFixActionWithoutFixAll("addEmptyExportDeclaration", Q, e.Diagnostics.Add_export_to_make_this_file_into_a_module)];
              } });
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "addMissingAsync", B = [e.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code, e.Diagnostics.Type_0_is_not_assignable_to_type_1.code, e.Diagnostics.Type_0_is_not_comparable_to_type_1.code];
              C.registerCodeFix({ fixIds: [w], errorCodes: B, getCodeActions: function(m) {
                var G = m.sourceFile, oe = m.errorCode, f = m.cancellationToken, T = m.program, K = m.span, b = e.find(T.getTypeChecker().getDiagnostics(G, f), N(K, oe)), se = b && b.relatedInformation && e.find(b.relatedInformation, function(R) {
                  return R.code === e.Diagnostics.Did_you_mean_to_mark_this_function_as_async.code;
                }), J = le(G, se);
                if (!!J) {
                  var ie = function(R) {
                    return e.textChanges.ChangeTracker.with(m, R);
                  };
                  return [E(m, J, ie)];
                }
              }, getAllCodeActions: function(p) {
                var m = p.sourceFile, G = new e.Set();
                return C.codeFixAll(p, B, function(oe, f) {
                  var T = f.relatedInformation && e.find(f.relatedInformation, function(se) {
                    return se.code === e.Diagnostics.Did_you_mean_to_mark_this_function_as_async.code;
                  }), K = le(m, T);
                  if (!!K) {
                    var b = function(se) {
                      return se(oe), [];
                    };
                    return E(p, K, b, G);
                  }
                });
              } });
              function E(p, m, G, oe) {
                var f = G(function(T) {
                  return Q(T, p.sourceFile, m, oe);
                });
                return C.createCodeFixAction(w, f, e.Diagnostics.Add_async_modifier_to_containing_function, w, e.Diagnostics.Add_all_missing_async_modifiers);
              }
              function Q(p, m, G, oe) {
                if (!(oe && oe.has(e.getNodeId(G)))) {
                  oe == null || oe.add(e.getNodeId(G));
                  var f = e.factory.updateModifiers(e.getSynthesizedDeepClone(G, true), e.factory.createNodeArray(e.factory.createModifiersFromModifierFlags(e.getSyntacticModifierFlags(G) | 256)));
                  p.replaceNode(m, G, f);
                }
              }
              function le(p, m) {
                if (!!m) {
                  var G = e.getTokenAtPosition(p, m.start), oe = e.findAncestor(G, function(f) {
                    return f.getStart(p) < m.start || f.getEnd() > e.textSpanEnd(m) ? "quit" : (e.isArrowFunction(f) || e.isMethodDeclaration(f) || e.isFunctionExpression(f) || e.isFunctionDeclaration(f)) && e.textSpansEqual(m, e.createTextSpanFromNode(f, p));
                  });
                  return oe;
                }
              }
              function N(p, m) {
                return function(G) {
                  var oe = G.start, f = G.length, T = G.relatedInformation, K = G.code;
                  return e.isNumber(oe) && e.isNumber(f) && e.textSpansEqual({ start: oe, length: f }, p) && K === m && !!T && e.some(T, function(b) {
                    return b.code === e.Diagnostics.Did_you_mean_to_mark_this_function_as_async.code;
                  });
                };
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "addMissingAwait", B = e.Diagnostics.Property_0_does_not_exist_on_type_1.code, E = [e.Diagnostics.This_expression_is_not_callable.code, e.Diagnostics.This_expression_is_not_constructable.code], Q = Ve([e.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type.code, e.Diagnostics.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type.code, e.Diagnostics.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type.code, e.Diagnostics.Operator_0_cannot_be_applied_to_type_1.code, e.Diagnostics.Operator_0_cannot_be_applied_to_types_1_and_2.code, e.Diagnostics.This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap.code, e.Diagnostics.This_condition_will_always_return_true_since_this_0_is_always_defined.code, e.Diagnostics.Type_0_is_not_an_array_type.code, e.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type.code, e.Diagnostics.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher.code, e.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator.code, e.Diagnostics.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator.code, e.Diagnostics.Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator.code, e.Diagnostics.Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator.code, e.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code, B], E, true);
              C.registerCodeFix({ fixIds: [w], errorCodes: Q, getCodeActions: function(J) {
                var ie = J.sourceFile, R = J.errorCode, q = J.span, O = J.cancellationToken, ve = J.program, ee = le(ie, R, q, O, ve);
                if (!!ee) {
                  var he = J.program.getTypeChecker(), F = function(x) {
                    return e.textChanges.ChangeTracker.with(J, x);
                  };
                  return e.compact([N(J, ee, R, he, F), p(J, ee, R, he, F)]);
                }
              }, getAllCodeActions: function(se) {
                var J = se.sourceFile, ie = se.program, R = se.cancellationToken, q = se.program.getTypeChecker(), O = new e.Set();
                return C.codeFixAll(se, Q, function(ve, ee) {
                  var he = le(J, ee.code, ee, R, ie);
                  if (!!he) {
                    var F = function(x) {
                      return x(ve), [];
                    };
                    return N(se, he, ee.code, q, F, O) || p(se, he, ee.code, q, F, O);
                  }
                });
              } });
              function le(se, J, ie, R, q) {
                var O = e.getFixableErrorSpanExpression(se, ie);
                return O && m(se, J, ie, R, q) && T(O) ? O : void 0;
              }
              function N(se, J, ie, R, q, O) {
                var ve = se.sourceFile, ee = se.program, he = se.cancellationToken, F = G(J, ve, he, ee, R);
                if (F) {
                  var x = q(function(X) {
                    e.forEach(F.initializers, function($) {
                      var A = $.expression;
                      return K(X, ie, ve, R, A, O);
                    }), O && F.needsSecondPassForFixAll && K(X, ie, ve, R, J, O);
                  });
                  return C.createCodeFixActionWithoutFixAll("addMissingAwaitToInitializer", x, F.initializers.length === 1 ? [e.Diagnostics.Add_await_to_initializer_for_0, F.initializers[0].declarationSymbol.name] : e.Diagnostics.Add_await_to_initializers);
                }
              }
              function p(se, J, ie, R, q, O) {
                var ve = q(function(ee) {
                  return K(ee, ie, se.sourceFile, R, J, O);
                });
                return C.createCodeFixAction(w, ve, e.Diagnostics.Add_await, w, e.Diagnostics.Fix_all_expressions_possibly_missing_await);
              }
              function m(se, J, ie, R, q) {
                var O = q.getTypeChecker(), ve = O.getDiagnostics(se, R);
                return e.some(ve, function(ee) {
                  var he = ee.start, F = ee.length, x = ee.relatedInformation, X = ee.code;
                  return e.isNumber(he) && e.isNumber(F) && e.textSpansEqual({ start: he, length: F }, ie) && X === J && !!x && e.some(x, function($) {
                    return $.code === e.Diagnostics.Did_you_forget_to_use_await.code;
                  });
                });
              }
              function G(se, J, ie, R, q) {
                var O = oe(se, q);
                if (!!O) {
                  for (var ve = O.isCompleteFix, ee, he = function($) {
                    var A = q.getSymbolAtLocation($);
                    if (!A) return "continue";
                    var y = e.tryCast(A.valueDeclaration, e.isVariableDeclaration), V = y && e.tryCast(y.name, e.isIdentifier), L = e.getAncestor(y, 237);
                    if (!y || !L || y.type || !y.initializer || L.getSourceFile() !== J || e.hasSyntacticModifier(L, 1) || !V || !T(y.initializer)) return ve = false, "continue";
                    var P = R.getSemanticDiagnostics(J, ie), k = e.FindAllReferences.Core.eachSymbolReferenceInFile(V, q, J, function(Y) {
                      return $ !== Y && !f(Y, P, J, q);
                    });
                    if (k) return ve = false, "continue";
                    (ee || (ee = [])).push({ expression: y.initializer, declarationSymbol: A });
                  }, F = 0, x = O.identifiers; F < x.length; F++) {
                    var X = x[F];
                    he(X);
                  }
                  return ee && { initializers: ee, needsSecondPassForFixAll: !ve };
                }
              }
              function oe(se, J) {
                if (e.isPropertyAccessExpression(se.parent) && e.isIdentifier(se.parent.expression)) return { identifiers: [se.parent.expression], isCompleteFix: true };
                if (e.isIdentifier(se)) return { identifiers: [se], isCompleteFix: true };
                if (e.isBinaryExpression(se)) {
                  for (var ie = void 0, R = true, q = 0, O = [se.left, se.right]; q < O.length; q++) {
                    var ve = O[q], ee = J.getTypeAtLocation(ve);
                    if (J.getPromisedTypeOfPromise(ee)) {
                      if (!e.isIdentifier(ve)) {
                        R = false;
                        continue;
                      }
                      (ie || (ie = [])).push(ve);
                    }
                  }
                  return ie && { identifiers: ie, isCompleteFix: R };
                }
              }
              function f(se, J, ie, R) {
                var q = e.isPropertyAccessExpression(se.parent) ? se.parent.name : e.isBinaryExpression(se.parent) ? se.parent : se, O = e.find(J, function(ve) {
                  return ve.start === q.getStart(ie) && ve.start + ve.length === q.getEnd();
                });
                return O && e.contains(Q, O.code) || R.getTypeAtLocation(q).flags & 1;
              }
              function T(se) {
                return se.kind & 32768 || !!e.findAncestor(se, function(J) {
                  return J.parent && e.isArrowFunction(J.parent) && J.parent.body === J || e.isBlock(J) && (J.parent.kind === 256 || J.parent.kind === 213 || J.parent.kind === 214 || J.parent.kind === 169);
                });
              }
              function K(se, J, ie, R, q, O) {
                if (e.isBinaryExpression(q)) for (var ve = 0, ee = [q.left, q.right]; ve < ee.length; ve++) {
                  var he = ee[ve];
                  if (O && e.isIdentifier(he)) {
                    var F = R.getSymbolAtLocation(he);
                    if (F && O.has(e.getSymbolId(F))) continue;
                  }
                  var x = R.getTypeAtLocation(he), X = R.getPromisedTypeOfPromise(x) ? e.factory.createAwaitExpression(he) : he;
                  se.replaceNode(ie, he, X);
                }
                else if (J === B && e.isPropertyAccessExpression(q.parent)) {
                  if (O && e.isIdentifier(q.parent.expression)) {
                    var F = R.getSymbolAtLocation(q.parent.expression);
                    if (F && O.has(e.getSymbolId(F))) return;
                  }
                  se.replaceNode(ie, q.parent.expression, e.factory.createParenthesizedExpression(e.factory.createAwaitExpression(q.parent.expression))), b(se, q.parent.expression, ie);
                } else if (e.contains(E, J) && e.isCallOrNewExpression(q.parent)) {
                  if (O && e.isIdentifier(q)) {
                    var F = R.getSymbolAtLocation(q);
                    if (F && O.has(e.getSymbolId(F))) return;
                  }
                  se.replaceNode(ie, q, e.factory.createParenthesizedExpression(e.factory.createAwaitExpression(q))), b(se, q, ie);
                } else {
                  if (O && e.isVariableDeclaration(q.parent) && e.isIdentifier(q.parent.name)) {
                    var F = R.getSymbolAtLocation(q.parent.name);
                    if (F && !e.tryAddToSet(O, e.getSymbolId(F))) return;
                  }
                  se.replaceNode(ie, q, e.factory.createAwaitExpression(q));
                }
              }
              function b(se, J, ie) {
                var R = e.findPrecedingToken(J.pos, ie);
                R && e.positionIsASICandidate(R.end, R.parent, ie) && se.insertText(ie, J.getStart(ie), ";");
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "addMissingConst", B = [e.Diagnostics.Cannot_find_name_0.code, e.Diagnostics.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(oe) {
                var f = e.textChanges.ChangeTracker.with(oe, function(T) {
                  return E(T, oe.sourceFile, oe.span.start, oe.program);
                });
                if (f.length > 0) return [C.createCodeFixAction(w, f, e.Diagnostics.Add_const_to_unresolved_variable, w, e.Diagnostics.Add_const_to_all_unresolved_variables)];
              }, fixIds: [w], getAllCodeActions: function(G) {
                var oe = new e.Set();
                return C.codeFixAll(G, B, function(f, T) {
                  return E(f, T.file, T.start, G.program, oe);
                });
              } });
              function E(G, oe, f, T, K) {
                var b = e.getTokenAtPosition(oe, f), se = e.findAncestor(b, function(O) {
                  return e.isForInOrOfStatement(O.parent) ? O.parent.initializer === O : le(O) ? false : "quit";
                });
                if (se) return Q(G, se, oe, K);
                var J = b.parent;
                if (e.isBinaryExpression(J) && J.operatorToken.kind === 63 && e.isExpressionStatement(J.parent)) return Q(G, b, oe, K);
                if (e.isArrayLiteralExpression(J)) {
                  var ie = T.getTypeChecker();
                  return e.every(J.elements, function(O) {
                    return N(O, ie);
                  }) ? Q(G, J, oe, K) : void 0;
                }
                var R = e.findAncestor(b, function(O) {
                  return e.isExpressionStatement(O.parent) ? true : p(O) ? false : "quit";
                });
                if (R) {
                  var q = T.getTypeChecker();
                  return m(R, q) ? Q(G, R, oe, K) : void 0;
                }
              }
              function Q(G, oe, f, T) {
                (!T || e.tryAddToSet(T, oe)) && G.insertModifierBefore(f, 85, oe);
              }
              function le(G) {
                switch (G.kind) {
                  case 79:
                  case 204:
                  case 205:
                  case 296:
                  case 297:
                    return true;
                  default:
                    return false;
                }
              }
              function N(G, oe) {
                var f = e.isIdentifier(G) ? G : e.isAssignmentExpression(G, true) && e.isIdentifier(G.left) ? G.left : void 0;
                return !!f && !oe.getSymbolAtLocation(f);
              }
              function p(G) {
                switch (G.kind) {
                  case 79:
                  case 221:
                  case 27:
                    return true;
                  default:
                    return false;
                }
              }
              function m(G, oe) {
                return e.isBinaryExpression(G) ? G.operatorToken.kind === 27 ? e.every([G.left, G.right], function(f) {
                  return m(f, oe);
                }) : G.operatorToken.kind === 63 && e.isIdentifier(G.left) && !oe.getSymbolAtLocation(G.left) : false;
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "addMissingDeclareProperty", B = [e.Diagnostics.Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = e.textChanges.ChangeTracker.with(le, function(p) {
                  return E(p, le.sourceFile, le.span.start);
                });
                if (N.length > 0) return [C.createCodeFixAction(w, N, e.Diagnostics.Prefix_with_declare, w, e.Diagnostics.Prefix_all_incorrect_property_declarations_with_declare)];
              }, fixIds: [w], getAllCodeActions: function(Q) {
                var le = new e.Set();
                return C.codeFixAll(Q, B, function(N, p) {
                  return E(N, p.file, p.start, le);
                });
              } });
              function E(Q, le, N, p) {
                var m = e.getTokenAtPosition(le, N);
                if (!!e.isIdentifier(m)) {
                  var G = m.parent;
                  G.kind === 167 && (!p || e.tryAddToSet(p, G)) && Q.insertModifierBefore(le, 135, G);
                }
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "addMissingInvocationForDecorator", B = [e.Diagnostics._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = e.textChanges.ChangeTracker.with(le, function(p) {
                  return E(p, le.sourceFile, le.span.start);
                });
                return [C.createCodeFixAction(w, N, e.Diagnostics.Call_decorator_expression, w, e.Diagnostics.Add_to_all_uncalled_decorators)];
              }, fixIds: [w], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, B, function(le, N) {
                  return E(le, N.file, N.start);
                });
              } });
              function E(Q, le, N) {
                var p = e.getTokenAtPosition(le, N), m = e.findAncestor(p, e.isDecorator);
                e.Debug.assert(!!m, "Expected position to be owned by a decorator.");
                var G = e.factory.createCallExpression(m.expression, void 0, void 0);
                Q.replaceNode(le, m.expression, G);
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "addNameToNamelessParameter", B = [e.Diagnostics.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = e.textChanges.ChangeTracker.with(le, function(p) {
                  return E(p, le.sourceFile, le.span.start);
                });
                return [C.createCodeFixAction(w, N, e.Diagnostics.Add_parameter_name, w, e.Diagnostics.Add_names_to_all_parameters_without_names)];
              }, fixIds: [w], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, B, function(le, N) {
                  return E(le, N.file, N.start);
                });
              } });
              function E(Q, le, N) {
                var p = e.getTokenAtPosition(le, N), m = p.parent;
                if (!e.isParameter(m)) return e.Debug.fail("Tried to add a parameter name to a non-parameter: " + e.Debug.formatSyntaxKind(p.kind));
                var G = m.parent.parameters.indexOf(m);
                e.Debug.assert(!m.type, "Tried to add a parameter name to a parameter that already had one."), e.Debug.assert(G > -1, "Parameter not found in parent parameter list.");
                var oe = e.factory.createTypeReferenceNode(m.name, void 0), f = e.factory.createParameterDeclaration(void 0, m.modifiers, m.dotDotDotToken, "arg" + G, m.questionToken, m.dotDotDotToken ? e.factory.createArrayTypeNode(oe) : oe, m.initializer);
                Q.replaceNode(le, m, f);
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "addOptionalPropertyUndefined", B = [e.Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target.code, e.Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code, e.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(p) {
                var m = p.program.getTypeChecker(), G = E(p.sourceFile, p.span, m);
                if (!!G.length) {
                  var oe = e.textChanges.ChangeTracker.with(p, function(f) {
                    return N(f, G);
                  });
                  return [C.createCodeFixActionWithoutFixAll(w, oe, e.Diagnostics.Add_undefined_to_optional_property_type)];
                }
              }, fixIds: [w] });
              function E(p, m, G) {
                var oe, f, T = le(e.getFixableErrorSpanExpression(p, m), G);
                if (!T) return e.emptyArray;
                var K = T.source, b = T.target, se = Q(K, b, G) ? G.getTypeAtLocation(b.expression) : G.getTypeAtLocation(b);
                return !((f = (oe = se.symbol) === null || oe === void 0 ? void 0 : oe.declarations) === null || f === void 0) && f.some(function(J) {
                  return e.getSourceFileOfNode(J).fileName.match(/\.d\.ts$/);
                }) ? e.emptyArray : G.getExactOptionalProperties(se);
              }
              function Q(p, m, G) {
                return e.isPropertyAccessExpression(m) && !!G.getExactOptionalProperties(G.getTypeAtLocation(m.expression)).length && G.getTypeAtLocation(p) === G.getUndefinedType();
              }
              function le(p, m) {
                var G;
                if (p) {
                  if (e.isBinaryExpression(p.parent) && p.parent.operatorToken.kind === 63) return { source: p.parent.right, target: p.parent.left };
                  if (e.isVariableDeclaration(p.parent) && p.parent.initializer) return { source: p.parent.initializer, target: p.parent.name };
                  if (e.isCallExpression(p.parent)) {
                    var oe = m.getSymbolAtLocation(p.parent.expression);
                    if (!(oe != null && oe.valueDeclaration) || !e.isFunctionLikeKind(oe.valueDeclaration.kind) || !e.isExpression(p)) return;
                    var f = p.parent.arguments.indexOf(p);
                    if (f === -1) return;
                    var T = oe.valueDeclaration.parameters[f].name;
                    if (e.isIdentifier(T)) return { source: p, target: T };
                  } else if (e.isPropertyAssignment(p.parent) && e.isIdentifier(p.parent.name) || e.isShorthandPropertyAssignment(p.parent)) {
                    var K = le(p.parent.parent, m);
                    if (!K) return;
                    var b = m.getPropertyOfType(m.getTypeAtLocation(K.target), p.parent.name.text), se = (G = b == null ? void 0 : b.declarations) === null || G === void 0 ? void 0 : G[0];
                    return se ? { source: e.isPropertyAssignment(p.parent) ? p.parent.initializer : p.parent.name, target: se } : void 0;
                  }
                } else return;
              }
              function N(p, m) {
                for (var G = 0, oe = m; G < oe.length; G++) {
                  var f = oe[G], T = f.valueDeclaration;
                  if (T && (e.isPropertySignature(T) || e.isPropertyDeclaration(T)) && T.type) {
                    var K = e.factory.createUnionTypeNode(Ve(Ve([], T.type.kind === 187 ? T.type.types : [T.type], true), [e.factory.createTypeReferenceNode("undefined")], false));
                    p.replaceNode(T.getSourceFile(), T.type, K);
                  }
                }
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "annotateWithTypeFromJSDoc", B = [e.Diagnostics.JSDoc_types_may_be_moved_to_TypeScript_types.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(J) {
                var ie = E(J.sourceFile, J.span.start);
                if (!!ie) {
                  var R = e.textChanges.ChangeTracker.with(J, function(q) {
                    return N(q, J.sourceFile, ie);
                  });
                  return [C.createCodeFixAction(w, R, e.Diagnostics.Annotate_with_type_from_JSDoc, w, e.Diagnostics.Annotate_everything_with_types_from_JSDoc)];
                }
              }, fixIds: [w], getAllCodeActions: function(J) {
                return C.codeFixAll(J, B, function(ie, R) {
                  var q = E(R.file, R.start);
                  q && N(ie, R.file, q);
                });
              } });
              function E(J, ie) {
                var R = e.getTokenAtPosition(J, ie);
                return e.tryCast(e.isParameter(R.parent) ? R.parent.parent : R.parent, Q);
              }
              function Q(J) {
                return p(J) && le(J);
              }
              C.parameterShouldGetTypeFromJSDoc = Q;
              function le(J) {
                return e.isFunctionLikeDeclaration(J) ? J.parameters.some(le) || !J.type && !!e.getJSDocReturnType(J) : !J.type && !!e.getJSDocType(J);
              }
              function N(J, ie, R) {
                if (e.isFunctionLikeDeclaration(R) && (e.getJSDocReturnType(R) || R.parameters.some(function($) {
                  return !!e.getJSDocType($);
                }))) {
                  if (!R.typeParameters) {
                    var q = e.getJSDocTypeParameterDeclarations(R);
                    q.length && J.insertTypeParameters(ie, R, q);
                  }
                  var O = e.isArrowFunction(R) && !e.findChildOfKind(R, 20, ie);
                  O && J.insertNodeBefore(ie, e.first(R.parameters), e.factory.createToken(20));
                  for (var ve = 0, ee = R.parameters; ve < ee.length; ve++) {
                    var he = ee[ve];
                    if (!he.type) {
                      var F = e.getJSDocType(he);
                      F && J.tryInsertTypeAnnotation(ie, he, m(F));
                    }
                  }
                  if (O && J.insertNodeAfter(ie, e.last(R.parameters), e.factory.createToken(21)), !R.type) {
                    var x = e.getJSDocReturnType(R);
                    x && J.tryInsertTypeAnnotation(ie, R, m(x));
                  }
                } else {
                  var X = e.Debug.checkDefined(e.getJSDocType(R), "A JSDocType for this declaration should exist");
                  e.Debug.assert(!R.type, "The JSDocType decl should have a type"), J.tryInsertTypeAnnotation(ie, R, m(X));
                }
              }
              function p(J) {
                return e.isFunctionLikeDeclaration(J) || J.kind === 254 || J.kind === 166 || J.kind === 167;
              }
              function m(J) {
                switch (J.kind) {
                  case 312:
                  case 313:
                    return e.factory.createTypeReferenceNode("any", e.emptyArray);
                  case 316:
                    return G(J);
                  case 315:
                    return m(J.type);
                  case 314:
                    return oe(J);
                  case 318:
                    return f(J);
                  case 317:
                    return T(J);
                  case 178:
                    return b(J);
                  default:
                    var ie = e.visitEachChild(J, m, e.nullTransformationContext);
                    return e.setEmitFlags(ie, 1), ie;
                }
              }
              function G(J) {
                return e.factory.createUnionTypeNode([e.visitNode(J.type, m), e.factory.createTypeReferenceNode("undefined", e.emptyArray)]);
              }
              function oe(J) {
                return e.factory.createUnionTypeNode([e.visitNode(J.type, m), e.factory.createTypeReferenceNode("null", e.emptyArray)]);
              }
              function f(J) {
                return e.factory.createArrayTypeNode(e.visitNode(J.type, m));
              }
              function T(J) {
                var ie;
                return e.factory.createFunctionTypeNode(e.emptyArray, J.parameters.map(K), (ie = J.type) !== null && ie !== void 0 ? ie : e.factory.createKeywordTypeNode(130));
              }
              function K(J) {
                var ie = J.parent.parameters.indexOf(J), R = J.type.kind === 318 && ie === J.parent.parameters.length - 1, q = J.name || (R ? "rest" : "arg" + ie), O = R ? e.factory.createToken(25) : J.dotDotDotToken;
                return e.factory.createParameterDeclaration(J.decorators, J.modifiers, O, q, J.questionToken, e.visitNode(J.type, m), J.initializer);
              }
              function b(J) {
                var ie = J.typeName, R = J.typeArguments;
                if (e.isIdentifier(J.typeName)) {
                  if (e.isJSDocIndexSignature(J)) return se(J);
                  var q = J.typeName.text;
                  switch (J.typeName.text) {
                    case "String":
                    case "Boolean":
                    case "Object":
                    case "Number":
                      q = q.toLowerCase();
                      break;
                    case "array":
                    case "date":
                    case "promise":
                      q = q[0].toUpperCase() + q.slice(1);
                      break;
                  }
                  ie = e.factory.createIdentifier(q), (q === "Array" || q === "Promise") && !J.typeArguments ? R = e.factory.createNodeArray([e.factory.createTypeReferenceNode("any", e.emptyArray)]) : R = e.visitNodes(J.typeArguments, m);
                }
                return e.factory.createTypeReferenceNode(ie, R);
              }
              function se(J) {
                var ie = e.factory.createParameterDeclaration(void 0, void 0, void 0, J.typeArguments[0].kind === 147 ? "n" : "s", void 0, e.factory.createTypeReferenceNode(J.typeArguments[0].kind === 147 ? "number" : "string", []), void 0), R = e.factory.createTypeLiteralNode([e.factory.createIndexSignature(void 0, void 0, [ie], J.typeArguments[1])]);
                return e.setEmitFlags(R, 1), R;
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "convertFunctionToEs6Class", B = [e.Diagnostics.This_constructor_function_may_be_converted_to_a_class_declaration.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(p) {
                var m = e.textChanges.ChangeTracker.with(p, function(G) {
                  return E(G, p.sourceFile, p.span.start, p.program.getTypeChecker(), p.preferences, p.program.getCompilerOptions());
                });
                return [C.createCodeFixAction(w, m, e.Diagnostics.Convert_function_to_an_ES2015_class, w, e.Diagnostics.Convert_all_constructor_functions_to_classes)];
              }, fixIds: [w], getAllCodeActions: function(p) {
                return C.codeFixAll(p, B, function(m, G) {
                  return E(m, G.file, G.start, p.program.getTypeChecker(), p.preferences, p.program.getCompilerOptions());
                });
              } });
              function E(p, m, G, oe, f, T) {
                var K = oe.getSymbolAtLocation(e.getTokenAtPosition(m, G));
                if (!K || !K.valueDeclaration || !(K.flags & 19)) return;
                var b = K.valueDeclaration;
                if (e.isFunctionDeclaration(b)) p.replaceNode(m, b, q(b));
                else if (e.isVariableDeclaration(b)) {
                  var se = R(b);
                  if (!se) return;
                  var J = b.parent.parent;
                  e.isVariableDeclarationList(b.parent) && b.parent.declarations.length > 1 ? (p.delete(m, b), p.insertNodeAfter(m, J, se)) : p.replaceNode(m, J, se);
                }
                function ie(O) {
                  var ve = [];
                  return O.exports && O.exports.forEach(function(F) {
                    if (F.name === "prototype" && F.declarations) {
                      var x = F.declarations[0];
                      if (F.declarations.length === 1 && e.isPropertyAccessExpression(x) && e.isBinaryExpression(x.parent) && x.parent.operatorToken.kind === 63 && e.isObjectLiteralExpression(x.parent.right)) {
                        var X = x.parent.right;
                        he(X.symbol, void 0, ve);
                      }
                    } else he(F, [e.factory.createToken(124)], ve);
                  }), O.members && O.members.forEach(function(F, x) {
                    var X, $, A, y;
                    if (x === "constructor" && F.valueDeclaration) {
                      var V = (y = (A = ($ = (X = O.exports) === null || X === void 0 ? void 0 : X.get("prototype")) === null || $ === void 0 ? void 0 : $.declarations) === null || A === void 0 ? void 0 : A[0]) === null || y === void 0 ? void 0 : y.parent;
                      V && e.isBinaryExpression(V) && e.isObjectLiteralExpression(V.right) && e.some(V.right.properties, le) || p.delete(m, F.valueDeclaration.parent);
                      return;
                    }
                    he(F, void 0, ve);
                  }), ve;
                  function ee(F, x) {
                    return e.isAccessExpression(F) ? e.isPropertyAccessExpression(F) && le(F) ? true : e.isFunctionLike(x) : e.every(F.properties, function(X) {
                      return !!(e.isMethodDeclaration(X) || e.isGetOrSetAccessorDeclaration(X) || e.isPropertyAssignment(X) && e.isFunctionExpression(X.initializer) && !!X.name || le(X));
                    });
                  }
                  function he(F, x, X) {
                    if (!(F.flags & 8192) && !(F.flags & 4096)) return;
                    var $ = F.valueDeclaration, A = $.parent, y = A.right;
                    if (!ee($, y) || e.some(X, function(H) {
                      var I = e.getNameOfDeclaration(H);
                      return !!(I && e.isIdentifier(I) && e.idText(I) === e.symbolName(F));
                    })) return;
                    var V = A.parent && A.parent.kind === 238 ? A.parent : A;
                    if (p.delete(m, V), !y) {
                      X.push(e.factory.createPropertyDeclaration([], x, F.name, void 0, void 0, void 0));
                      return;
                    }
                    if (e.isAccessExpression($) && (e.isFunctionExpression(y) || e.isArrowFunction(y))) {
                      var L = e.getQuotePreference(m, f), P = N($, T, L);
                      P && Y(X, y, P);
                      return;
                    } else if (e.isObjectLiteralExpression(y)) {
                      e.forEach(y.properties, function(H) {
                        (e.isMethodDeclaration(H) || e.isGetOrSetAccessorDeclaration(H)) && X.push(H), e.isPropertyAssignment(H) && e.isFunctionExpression(H.initializer) && Y(X, H.initializer, H.name), le(H);
                      });
                      return;
                    } else {
                      if (e.isSourceFileJS(m) || !e.isPropertyAccessExpression($)) return;
                      var k = e.factory.createPropertyDeclaration(void 0, x, $.name, void 0, void 0, y);
                      e.copyLeadingComments(A.parent, k, m), X.push(k);
                      return;
                    }
                    function Y(H, I, l) {
                      return e.isFunctionExpression(I) ? U(H, I, l) : j(H, I, l);
                    }
                    function U(H, I, l) {
                      var d = e.concatenate(x, Q(I, 131)), D = e.factory.createMethodDeclaration(void 0, d, void 0, l, void 0, void 0, I.parameters, void 0, I.body);
                      e.copyLeadingComments(A, D, m), H.push(D);
                    }
                    function j(H, I, l) {
                      var d = I.body, D;
                      d.kind === 235 ? D = d : D = e.factory.createBlock([e.factory.createReturnStatement(d)]);
                      var fe = e.concatenate(x, Q(I, 131)), g = e.factory.createMethodDeclaration(void 0, fe, void 0, l, void 0, void 0, I.parameters, void 0, D);
                      e.copyLeadingComments(A, g, m), H.push(g);
                    }
                  }
                }
                function R(O) {
                  var ve = O.initializer;
                  if (!(!ve || !e.isFunctionExpression(ve) || !e.isIdentifier(O.name))) {
                    var ee = ie(O.symbol);
                    ve.body && ee.unshift(e.factory.createConstructorDeclaration(void 0, void 0, ve.parameters, ve.body));
                    var he = Q(O.parent.parent, 93), F = e.factory.createClassDeclaration(void 0, he, O.name, void 0, void 0, ee);
                    return F;
                  }
                }
                function q(O) {
                  var ve = ie(K);
                  O.body && ve.unshift(e.factory.createConstructorDeclaration(void 0, void 0, O.parameters, O.body));
                  var ee = Q(O, 93), he = e.factory.createClassDeclaration(void 0, ee, O.name, void 0, void 0, ve);
                  return he;
                }
              }
              function Q(p, m) {
                return e.filter(p.modifiers, function(G) {
                  return G.kind === m;
                });
              }
              function le(p) {
                return p.name ? !!(e.isIdentifier(p.name) && p.name.text === "constructor") : false;
              }
              function N(p, m, G) {
                if (e.isPropertyAccessExpression(p)) return p.name;
                var oe = p.argumentExpression;
                if (e.isNumericLiteral(oe)) return oe;
                if (e.isStringLiteralLike(oe)) return e.isIdentifierText(oe.text, e.getEmitScriptTarget(m)) ? e.factory.createIdentifier(oe.text) : e.isNoSubstitutionTemplateLiteral(oe) ? e.factory.createStringLiteral(oe.text, G === 0) : oe;
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "convertToAsyncFunction", B = [e.Diagnostics.This_may_be_converted_to_an_async_function.code], E = true;
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(g) {
                E = true;
                var ne = e.textChanges.ChangeTracker.with(g, function(ue) {
                  return le(ue, g.sourceFile, g.span.start, g.program.getTypeChecker());
                });
                return E ? [C.createCodeFixAction(w, ne, e.Diagnostics.Convert_to_async_function, w, e.Diagnostics.Convert_all_to_async_functions)] : [];
              }, fixIds: [w], getAllCodeActions: function(g) {
                return C.codeFixAll(g, B, function(ne, ue) {
                  return le(ne, ue.file, ue.start, g.program.getTypeChecker());
                });
              } });
              var Q;
              (function(g) {
                g[g.Identifier = 0] = "Identifier", g[g.BindingPattern = 1] = "BindingPattern";
              })(Q || (Q = {}));
              function le(g, ne, ue, We) {
                var Fe = e.getTokenAtPosition(ne, ue), Z;
                if (e.isIdentifier(Fe) && e.isVariableDeclaration(Fe.parent) && Fe.parent.initializer && e.isFunctionLikeDeclaration(Fe.parent.initializer) ? Z = Fe.parent.initializer : Z = e.tryCast(e.getContainingFunction(e.getTokenAtPosition(ne, ue)), e.canBeConvertedToAsync), !!Z) {
                  var Be = new e.Map(), ge = e.isInJSFile(Z), Re = p(Z, We), ze = T(Z, We, Be);
                  if (!!e.returnsPromise(ze, We)) {
                    var Ee = ze.body && e.isBlock(ze.body) ? N(ze.body, We) : e.emptyArray, He = { checker: We, synthNamesMap: Be, setOfExpressionsToReturn: Re, isInJSFile: ge };
                    if (!!Ee.length) {
                      var rr = Z.modifiers ? Z.modifiers.end : Z.decorators ? e.skipTrivia(ne.text, Z.decorators.end) : Z.getStart(ne), Ie = Z.modifiers ? { prefix: " " } : { suffix: " " };
                      g.insertModifierAt(ne, rr, 131, Ie);
                      for (var _e = function(er) {
                        if (e.forEachChild(er, function ir(Cr) {
                          if (e.isCallExpression(Cr)) {
                            var Ye = J(Cr, Cr, He, false);
                            if (b()) return true;
                            g.replaceNodeWithNodes(ne, er, Ye);
                          } else if (!e.isFunctionLike(Cr) && (e.forEachChild(Cr, ir), b())) return true;
                        }), b()) return { value: void 0 };
                      }, we = 0, de = Ee; we < de.length; we++) {
                        var ye = de[we], Ae = _e(ye);
                        if (typeof Ae == "object") return Ae.value;
                      }
                    }
                  }
                }
              }
              function N(g, ne) {
                var ue = [];
                return e.forEachReturnStatement(g, function(We) {
                  e.isReturnStatementWithFixablePromiseHandler(We, ne) && ue.push(We);
                }), ue;
              }
              function p(g, ne) {
                if (!g.body) return new e.Set();
                var ue = new e.Set();
                return e.forEachChild(g.body, function We(Fe) {
                  m(Fe, ne, "then") ? (ue.add(e.getNodeId(Fe)), e.forEach(Fe.arguments, We)) : m(Fe, ne, "catch") || m(Fe, ne, "finally") ? (ue.add(e.getNodeId(Fe)), e.forEachChild(Fe, We)) : f(Fe, ne) ? ue.add(e.getNodeId(Fe)) : e.forEachChild(Fe, We);
                }), ue;
              }
              function m(g, ne, ue) {
                if (!e.isCallExpression(g)) return false;
                var We = e.hasPropertyAccessExpressionWithName(g, ue), Fe = We && ne.getTypeAtLocation(g);
                return !!(Fe && ne.getPromisedTypeOfPromise(Fe));
              }
              function G(g, ne) {
                return (e.getObjectFlags(g) & 4) !== 0 && g.target === ne;
              }
              function oe(g, ne, ue) {
                if (g.expression.name.escapedText !== "finally") {
                  var We = ue.getTypeAtLocation(g.expression.expression);
                  if (G(We, ue.getPromiseType()) || G(We, ue.getPromiseLikeType())) if (g.expression.name.escapedText === "then") {
                    if (ne === e.elementAt(g.arguments, 0)) return e.elementAt(g.typeArguments, 0);
                    if (ne === e.elementAt(g.arguments, 1)) return e.elementAt(g.typeArguments, 1);
                  } else return e.elementAt(g.typeArguments, 0);
                }
              }
              function f(g, ne) {
                return e.isExpression(g) ? !!ne.getPromisedTypeOfPromise(ne.getTypeAtLocation(g)) : false;
              }
              function T(g, ne, ue) {
                var We = new e.Map(), Fe = e.createMultiMap();
                return e.forEachChild(g, function Z(Be) {
                  if (!e.isIdentifier(Be)) {
                    e.forEachChild(Be, Z);
                    return;
                  }
                  var ge = ne.getSymbolAtLocation(Be);
                  if (ge) {
                    var Re = ne.getTypeAtLocation(Be), ze = y(Re, ne), Ee = e.getSymbolId(ge).toString();
                    if (ze && !e.isParameter(Be.parent) && !e.isFunctionLikeDeclaration(Be.parent) && !ue.has(Ee)) {
                      var He = e.firstOrUndefined(ze.parameters), rr = (He == null ? void 0 : He.valueDeclaration) && e.isParameter(He.valueDeclaration) && e.tryCast(He.valueDeclaration.name, e.isIdentifier) || e.factory.createUniqueName("result", 16), Ie = K(rr, Fe);
                      ue.set(Ee, Ie), Fe.add(rr.text, ge);
                    } else if (Be.parent && (e.isParameter(Be.parent) || e.isVariableDeclaration(Be.parent) || e.isBindingElement(Be.parent))) {
                      var _e = Be.text, we = Fe.get(_e);
                      if (we && we.some(function(Ae) {
                        return Ae !== ge;
                      })) {
                        var de = K(Be, Fe);
                        We.set(Ee, de.identifier), ue.set(Ee, de), Fe.add(_e, ge);
                      } else {
                        var ye = e.getSynthesizedDeepClone(Be);
                        ue.set(Ee, Y(ye)), Fe.add(_e, ge);
                      }
                    }
                  }
                }), e.getSynthesizedDeepCloneWithReplacements(g, true, function(Z) {
                  if (e.isBindingElement(Z) && e.isIdentifier(Z.name) && e.isObjectBindingPattern(Z.parent)) {
                    var Be = ne.getSymbolAtLocation(Z.name), ge = Be && We.get(String(e.getSymbolId(Be)));
                    if (ge && ge.text !== (Z.name || Z.propertyName).getText()) return e.factory.createBindingElement(Z.dotDotDotToken, Z.propertyName || Z.name, ge, Z.initializer);
                  } else if (e.isIdentifier(Z)) {
                    var Be = ne.getSymbolAtLocation(Z), ge = Be && We.get(String(e.getSymbolId(Be)));
                    if (ge) return e.factory.createIdentifier(ge.text);
                  }
                });
              }
              function K(g, ne) {
                var ue = (ne.get(g.text) || e.emptyArray).length, We = ue === 0 ? g : e.factory.createIdentifier(g.text + "_" + ue);
                return Y(We);
              }
              function b() {
                return !E;
              }
              function se() {
                return E = false, e.emptyArray;
              }
              function J(g, ne, ue, We, Fe) {
                if (m(ne, ue.checker, "then")) return he(ne, e.elementAt(ne.arguments, 0), e.elementAt(ne.arguments, 1), ue, We, Fe);
                if (m(ne, ue.checker, "catch")) return ee(ne, e.elementAt(ne.arguments, 0), ue, We, Fe);
                if (m(ne, ue.checker, "finally")) return ve(ne, e.elementAt(ne.arguments, 0), ue, We, Fe);
                if (e.isPropertyAccessExpression(ne)) return J(g, ne.expression, ue, We, Fe);
                var Z = ue.checker.getTypeAtLocation(ne);
                return Z && ue.checker.getPromisedTypeOfPromise(Z) ? (e.Debug.assertNode(e.getOriginalNode(ne).parent, e.isPropertyAccessExpression), F(g, ne, ue, We, Fe)) : se();
              }
              function ie(g, ne) {
                var ue = g.checker;
                if (ne.kind === 104) return true;
                if (e.isIdentifier(ne) && !e.isGeneratedIdentifier(ne) && e.idText(ne) === "undefined") {
                  var We = ue.getSymbolAtLocation(ne);
                  return !We || ue.isUndefinedSymbol(We);
                }
                return false;
              }
              function R(g) {
                var ne = e.factory.createUniqueName(g.identifier.text, 16);
                return Y(ne);
              }
              function q(g, ne, ue) {
                var We;
                return ue && !fe(g, ne) && (d(ue) ? (We = ue, ne.synthNamesMap.forEach(function(Fe, Z) {
                  if (Fe.identifier.text === ue.identifier.text) {
                    var Be = R(ue);
                    ne.synthNamesMap.set(Z, Be);
                  }
                })) : We = Y(e.factory.createUniqueName("result", 16), ue.types), l(We)), We;
              }
              function O(g, ne, ue, We, Fe) {
                var Z = [], Be;
                if (We && !fe(g, ne)) {
                  Be = e.getSynthesizedDeepClone(l(We));
                  var ge = We.types, Re = ne.checker.getUnionType(ge, 2), ze = ne.isInJSFile ? void 0 : ne.checker.typeToTypeNode(Re, void 0, void 0), Ee = [e.factory.createVariableDeclaration(Be, void 0, ze)], He = e.factory.createVariableStatement(void 0, e.factory.createVariableDeclarationList(Ee, 1));
                  Z.push(He);
                }
                return Z.push(ue), Fe && Be && D(Fe) && Z.push(e.factory.createVariableStatement(void 0, e.factory.createVariableDeclarationList([e.factory.createVariableDeclaration(e.getSynthesizedDeepClone(I(Fe)), void 0, void 0, Be)], 2))), Z;
              }
              function ve(g, ne, ue, We, Fe) {
                if (!ne || ie(ue, ne)) return J(g, g.expression.expression, ue, We, Fe);
                var Z = q(g, ue, Fe), Be = J(g, g.expression.expression, ue, true, Z);
                if (b()) return se();
                var ge = $(ne, We, void 0, void 0, g, ue);
                if (b()) return se();
                var Re = e.factory.createBlock(Be), ze = e.factory.createBlock(ge), Ee = e.factory.createTryStatement(Re, void 0, ze);
                return O(g, ue, Ee, Z, Fe);
              }
              function ee(g, ne, ue, We, Fe) {
                if (!ne || ie(ue, ne)) return J(g, g.expression.expression, ue, We, Fe);
                var Z = P(ne, ue), Be = q(g, ue, Fe), ge = J(g, g.expression.expression, ue, true, Be);
                if (b()) return se();
                var Re = $(ne, We, Be, Z, g, ue);
                if (b()) return se();
                var ze = e.factory.createBlock(ge), Ee = e.factory.createCatchClause(Z && e.getSynthesizedDeepClone(H(Z)), e.factory.createBlock(Re)), He = e.factory.createTryStatement(ze, Ee, void 0);
                return O(g, ue, He, Be, Fe);
              }
              function he(g, ne, ue, We, Fe, Z) {
                if (!ne || ie(We, ne)) return ee(g, ue, We, Fe, Z);
                if (ue && !ie(We, ue)) return se();
                var Be = P(ne, We), ge = J(g.expression.expression, g.expression.expression, We, true, Be);
                if (b()) return se();
                var Re = $(ne, Fe, Z, Be, g, We);
                return b() ? se() : e.concatenate(ge, Re);
              }
              function F(g, ne, ue, We, Fe) {
                if (fe(g, ue)) {
                  var Z = e.getSynthesizedDeepClone(ne);
                  return We && (Z = e.factory.createAwaitExpression(Z)), [e.factory.createReturnStatement(Z)];
                }
                return x(Fe, e.factory.createAwaitExpression(ne), void 0);
              }
              function x(g, ne, ue) {
                return !g || k(g) ? [e.factory.createExpressionStatement(ne)] : d(g) && g.hasBeenDeclared ? [e.factory.createExpressionStatement(e.factory.createAssignment(e.getSynthesizedDeepClone(j(g)), ne))] : [e.factory.createVariableStatement(void 0, e.factory.createVariableDeclarationList([e.factory.createVariableDeclaration(e.getSynthesizedDeepClone(H(g)), void 0, ue, ne)], 2))];
              }
              function X(g, ne) {
                if (ne && g) {
                  var ue = e.factory.createUniqueName("result", 16);
                  return Ve(Ve([], x(Y(ue), g, ne), true), [e.factory.createReturnStatement(ue)], false);
                }
                return [e.factory.createReturnStatement(g)];
              }
              function $(g, ne, ue, We, Fe, Z) {
                var Be;
                switch (g.kind) {
                  case 104:
                    break;
                  case 206:
                  case 79:
                    if (!We) break;
                    var ge = e.factory.createCallExpression(e.getSynthesizedDeepClone(g), void 0, d(We) ? [j(We)] : []);
                    if (fe(Fe, Z)) return X(ge, oe(Fe, g, Z.checker));
                    var Re = Z.checker.getTypeAtLocation(g), ze = Z.checker.getSignaturesOfType(Re, 0);
                    if (!ze.length) return se();
                    var Ee = ze[0].getReturnType(), He = x(ue, e.factory.createAwaitExpression(ge), oe(Fe, g, Z.checker));
                    return ue && ue.types.push(Z.checker.getAwaitedType(Ee) || Ee), He;
                  case 213:
                  case 214: {
                    var rr = g.body, Ie = (Be = y(Z.checker.getTypeAtLocation(g), Z.checker)) === null || Be === void 0 ? void 0 : Be.getReturnType();
                    if (e.isBlock(rr)) {
                      for (var _e = [], we = false, de = 0, ye = rr.statements; de < ye.length; de++) {
                        var Ae = ye[de];
                        if (e.isReturnStatement(Ae)) if (we = true, e.isReturnStatementWithFixablePromiseHandler(Ae, Z.checker)) _e = _e.concat(L(Z, Ae, ne, ue));
                        else {
                          var er = Ie && Ae.expression ? A(Z.checker, Ie, Ae.expression) : Ae.expression;
                          _e.push.apply(_e, X(er, oe(Fe, g, Z.checker)));
                        }
                        else {
                          if (ne && e.forEachReturnStatement(Ae, e.returnTrue)) return se();
                          _e.push(Ae);
                        }
                      }
                      return fe(Fe, Z) ? _e.map(function(Ye) {
                        return e.getSynthesizedDeepClone(Ye);
                      }) : V(_e, ue, Z, we);
                    } else {
                      var ir = e.isFixablePromiseHandler(rr, Z.checker) ? L(Z, e.factory.createReturnStatement(rr), ne, ue) : e.emptyArray;
                      if (ir.length > 0) return ir;
                      if (Ie) {
                        var er = A(Z.checker, Ie, rr);
                        if (fe(Fe, Z)) return X(er, oe(Fe, g, Z.checker));
                        var Cr = x(ue, er, void 0);
                        return ue && ue.types.push(Z.checker.getAwaitedType(Ie) || Ie), Cr;
                      } else return se();
                    }
                  }
                  default:
                    return se();
                }
                return e.emptyArray;
              }
              function A(g, ne, ue) {
                var We = e.getSynthesizedDeepClone(ue);
                return g.getPromisedTypeOfPromise(ne) ? e.factory.createAwaitExpression(We) : We;
              }
              function y(g, ne) {
                var ue = ne.getSignaturesOfType(g, 0);
                return e.lastOrUndefined(ue);
              }
              function V(g, ne, ue, We) {
                for (var Fe = [], Z = 0, Be = g; Z < Be.length; Z++) {
                  var ge = Be[Z];
                  if (e.isReturnStatement(ge)) {
                    if (ge.expression) {
                      var Re = f(ge.expression, ue.checker) ? e.factory.createAwaitExpression(ge.expression) : ge.expression;
                      ne === void 0 ? Fe.push(e.factory.createExpressionStatement(Re)) : d(ne) && ne.hasBeenDeclared ? Fe.push(e.factory.createExpressionStatement(e.factory.createAssignment(j(ne), Re))) : Fe.push(e.factory.createVariableStatement(void 0, e.factory.createVariableDeclarationList([e.factory.createVariableDeclaration(H(ne), void 0, void 0, Re)], 2)));
                    }
                  } else Fe.push(e.getSynthesizedDeepClone(ge));
                }
                return !We && ne !== void 0 && Fe.push(e.factory.createVariableStatement(void 0, e.factory.createVariableDeclarationList([e.factory.createVariableDeclaration(H(ne), void 0, void 0, e.factory.createIdentifier("undefined"))], 2))), Fe;
              }
              function L(g, ne, ue, We) {
                var Fe = [];
                return e.forEachChild(ne, function Z(Be) {
                  if (e.isCallExpression(Be)) {
                    var ge = J(Be, Be, g, ue, We);
                    if (Fe = Fe.concat(ge), Fe.length > 0) return;
                  } else e.isFunctionLike(Be) || e.forEachChild(Be, Z);
                }), Fe;
              }
              function P(g, ne) {
                var ue = [], We;
                if (e.isFunctionLikeDeclaration(g)) {
                  if (g.parameters.length > 0) {
                    var Fe = g.parameters[0].name;
                    We = Z(Fe);
                  }
                } else e.isIdentifier(g) ? We = Be(g) : e.isPropertyAccessExpression(g) && e.isIdentifier(g.name) && (We = Be(g.name));
                if (!We || "identifier" in We && We.identifier.text === "undefined") return;
                return We;
                function Z(ze) {
                  if (e.isIdentifier(ze)) return Be(ze);
                  var Ee = e.flatMap(ze.elements, function(He) {
                    return e.isOmittedExpression(He) ? [] : [Z(He.name)];
                  });
                  return U(ze, Ee);
                }
                function Be(ze) {
                  var Ee = Re(ze), He = ge(Ee);
                  if (!He) return Y(ze, ue);
                  var rr = ne.synthNamesMap.get(e.getSymbolId(He).toString());
                  return rr || Y(ze, ue);
                }
                function ge(ze) {
                  return ze.symbol ? ze.symbol : ne.checker.getSymbolAtLocation(ze);
                }
                function Re(ze) {
                  return ze.original ? ze.original : ze;
                }
              }
              function k(g) {
                return g ? d(g) ? !g.identifier.text : e.every(g.elements, k) : true;
              }
              function Y(g, ne) {
                return ne === void 0 && (ne = []), { kind: 0, identifier: g, types: ne, hasBeenDeclared: false, hasBeenReferenced: false };
              }
              function U(g, ne, ue) {
                return ne === void 0 && (ne = e.emptyArray), ue === void 0 && (ue = []), { kind: 1, bindingPattern: g, elements: ne, types: ue };
              }
              function j(g) {
                return g.hasBeenReferenced = true, g.identifier;
              }
              function H(g) {
                return d(g) ? l(g) : I(g);
              }
              function I(g) {
                for (var ne = 0, ue = g.elements; ne < ue.length; ne++) {
                  var We = ue[ne];
                  H(We);
                }
                return g.bindingPattern;
              }
              function l(g) {
                return g.hasBeenDeclared = true, g.identifier;
              }
              function d(g) {
                return g.kind === 0;
              }
              function D(g) {
                return g.kind === 1;
              }
              function fe(g, ne) {
                return !!g.original && ne.setOfExpressionsToReturn.has(e.getNodeId(g.original));
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              C.registerCodeFix({ errorCodes: [e.Diagnostics.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module.code], getCodeActions: function(L) {
                var P = L.sourceFile, k = L.program, Y = L.preferences, U = e.textChanges.ChangeTracker.with(L, function(j) {
                  var H = B(P, k.getTypeChecker(), j, e.getEmitScriptTarget(k.getCompilerOptions()), e.getQuotePreference(P, Y));
                  if (H) for (var I = 0, l = k.getSourceFiles(); I < l.length; I++) {
                    var d = l[I];
                    w(d, P, j, e.getQuotePreference(d, Y));
                  }
                });
                return [C.createCodeFixActionWithoutFixAll("convertToEsModule", U, e.Diagnostics.Convert_to_ES_module)];
              } });
              function w(L, P, k, Y) {
                for (var U = 0, j = L.imports; U < j.length; U++) {
                  var H = j[U], I = e.getResolvedModule(L, H.text, e.getModeForUsageLocation(L, H));
                  if (!(!I || I.resolvedFileName !== P.fileName)) {
                    var l = e.importFromModuleSpecifier(H);
                    switch (l.kind) {
                      case 265:
                        k.replaceNode(L, l, e.makeImport(l.name, void 0, H, Y));
                        break;
                      case 208:
                        e.isRequireCall(l, false) && k.replaceNode(L, l, e.factory.createPropertyAccessExpression(e.getSynthesizedDeepClone(l), "default"));
                        break;
                    }
                  }
                }
              }
              function B(L, P, k, Y, U) {
                var j = { original: ve(L), additional: new e.Set() }, H = E(L, P, j);
                Q(L, H, k);
                for (var I = false, l, d = 0, D = e.filter(L.statements, e.isVariableStatement); d < D.length; d++) {
                  var fe = D[d], g = p(L, fe, k, P, j, Y, U);
                  g && e.copyEntries(g, l != null ? l : l = new e.Map());
                }
                for (var ne = 0, ue = e.filter(L.statements, function(Fe) {
                  return !e.isVariableStatement(Fe);
                }); ne < ue.length; ne++) {
                  var fe = ue[ne], We = N(L, fe, P, k, j, Y, H, l, U);
                  I = I || We;
                }
                return l == null || l.forEach(function(Fe, Z) {
                  k.replaceNode(L, Z, Fe);
                }), I;
              }
              function E(L, P, k) {
                var Y = new e.Map();
                return le(L, function(U) {
                  var j = U.name, H = j.text, I = j.originalKeywordKind;
                  !Y.has(H) && (I !== void 0 && e.isNonContextualKeyword(I) || P.resolveName(H, U, 111551, true)) && Y.set(H, O("_".concat(H), k));
                }), Y;
              }
              function Q(L, P, k) {
                le(L, function(Y, U) {
                  if (!U) {
                    var j = Y.name.text;
                    k.replaceNode(L, Y, e.factory.createIdentifier(P.get(j) || j));
                  }
                });
              }
              function le(L, P) {
                L.forEachChild(function k(Y) {
                  if (e.isPropertyAccessExpression(Y) && e.isExportsOrModuleExportsOrAlias(L, Y.expression) && e.isIdentifier(Y.name)) {
                    var U = Y.parent;
                    P(Y, e.isBinaryExpression(U) && U.left === Y && U.operatorToken.kind === 63);
                  }
                  Y.forEachChild(k);
                });
              }
              function N(L, P, k, Y, U, j, H, I, l) {
                switch (P.kind) {
                  case 237:
                    return p(L, P, Y, k, U, j, l), false;
                  case 238: {
                    var d = P.expression;
                    switch (d.kind) {
                      case 208:
                        return e.isRequireCall(d, true) && Y.replaceNode(L, P, e.makeImport(void 0, void 0, d.arguments[0], l)), false;
                      case 221: {
                        var D = d.operatorToken;
                        return D.kind === 63 && G(L, k, d, Y, H, I);
                      }
                    }
                  }
                  default:
                    return false;
                }
              }
              function p(L, P, k, Y, U, j, H) {
                var I = P.declarationList, l = false, d = e.map(I.declarations, function(fe) {
                  var g = fe.name, ne = fe.initializer;
                  if (ne) {
                    if (e.isExportsOrModuleExportsOrAlias(L, ne)) return l = true, V([]);
                    if (e.isRequireCall(ne, true)) return l = true, R(g, ne.arguments[0], Y, U, j, H);
                    if (e.isPropertyAccessExpression(ne) && e.isRequireCall(ne.expression, true)) return l = true, m(g, ne.name.text, ne.expression.arguments[0], U, H);
                  }
                  return V([e.factory.createVariableStatement(void 0, e.factory.createVariableDeclarationList([fe], I.flags))]);
                });
                if (l) {
                  k.replaceNodeWithNodes(L, P, e.flatMap(d, function(fe) {
                    return fe.newImports;
                  }));
                  var D;
                  return e.forEach(d, function(fe) {
                    fe.useSitesToUnqualify && e.copyEntries(fe.useSitesToUnqualify, D != null ? D : D = new e.Map());
                  }), D;
                }
              }
              function m(L, P, k, Y, U) {
                switch (L.kind) {
                  case 201:
                  case 202: {
                    var j = O(P, Y);
                    return V([X(j, P, k, U), A(void 0, L, e.factory.createIdentifier(j))]);
                  }
                  case 79:
                    return V([X(L.text, P, k, U)]);
                  default:
                    return e.Debug.assertNever(L, "Convert to ES module got invalid syntax form ".concat(L.kind));
                }
              }
              function G(L, P, k, Y, U, j) {
                var H = k.left, I = k.right;
                if (!e.isPropertyAccessExpression(H)) return false;
                if (e.isExportsOrModuleExportsOrAlias(L, H)) if (e.isExportsOrModuleExportsOrAlias(L, I)) Y.delete(L, k.parent);
                else {
                  var l = e.isObjectLiteralExpression(I) ? oe(I, j) : e.isRequireCall(I, true) ? T(I.arguments[0], P) : void 0;
                  return l ? (Y.replaceNodeWithNodes(L, k.parent, l[0]), l[1]) : (Y.replaceRangeWithText(L, e.createRange(H.getStart(L), I.pos), "export default"), true);
                }
                else e.isExportsOrModuleExportsOrAlias(L, H.expression) && f(L, k, Y, U);
                return false;
              }
              function oe(L, P) {
                var k = e.mapAllOrFail(L.properties, function(Y) {
                  switch (Y.kind) {
                    case 172:
                    case 173:
                    case 297:
                    case 298:
                      return;
                    case 296:
                      return e.isIdentifier(Y.name) ? J(Y.name.text, Y.initializer, P) : void 0;
                    case 169:
                      return e.isIdentifier(Y.name) ? F(Y.name.text, [e.factory.createToken(93)], Y, P) : void 0;
                    default:
                      e.Debug.assertNever(Y, "Convert to ES6 got invalid prop kind ".concat(Y.kind));
                  }
                });
                return k && [k, false];
              }
              function f(L, P, k, Y) {
                var U = P.left.name.text, j = Y.get(U);
                if (j !== void 0) {
                  var H = [A(void 0, j, P.right), y([e.factory.createExportSpecifier(false, j, U)])];
                  k.replaceNodeWithNodes(L, P.parent, H);
                } else se(P, L, k);
              }
              function T(L, P) {
                var k = L.text, Y = P.getSymbolAtLocation(L), U = Y ? Y.exports : e.emptyMap;
                return U.has("export=") ? [[b(k)], true] : U.has("default") ? U.size > 1 ? [[K(k), b(k)], true] : [[b(k)], true] : [[K(k)], false];
              }
              function K(L) {
                return y(void 0, L);
              }
              function b(L) {
                return y([e.factory.createExportSpecifier(false, void 0, "default")], L);
              }
              function se(L, P, k) {
                var Y = L.left, U = L.right, j = L.parent, H = Y.name.text;
                if ((e.isFunctionExpression(U) || e.isArrowFunction(U) || e.isClassExpression(U)) && (!U.name || U.name.text === H)) {
                  k.replaceRange(P, { pos: Y.getStart(P), end: U.getStart(P) }, e.factory.createToken(93), { suffix: " " }), U.name || k.insertName(P, U, H);
                  var I = e.findChildOfKind(j, 26, P);
                  I && k.delete(P, I);
                } else k.replaceNodeRangeWithNodes(P, Y.expression, e.findChildOfKind(Y, 24, P), [e.factory.createToken(93), e.factory.createToken(85)], { joiner: " ", suffix: " " });
              }
              function J(L, P, k) {
                var Y = [e.factory.createToken(93)];
                switch (P.kind) {
                  case 213: {
                    var U = P.name;
                    if (U && U.text !== L) return j();
                  }
                  case 214:
                    return F(L, Y, P, k);
                  case 226:
                    return x(L, Y, P, k);
                  default:
                    return j();
                }
                function j() {
                  return A(Y, e.factory.createIdentifier(L), ie(P, k));
                }
              }
              function ie(L, P) {
                if (!P || !e.some(e.arrayFrom(P.keys()), function(Y) {
                  return e.rangeContainsRange(L, Y);
                })) return L;
                return e.isArray(L) ? e.getSynthesizedDeepClonesWithReplacements(L, true, k) : e.getSynthesizedDeepCloneWithReplacements(L, true, k);
                function k(Y) {
                  if (Y.kind === 206) {
                    var U = P.get(Y);
                    return P.delete(Y), U;
                  }
                }
              }
              function R(L, P, k, Y, U, j) {
                switch (L.kind) {
                  case 201: {
                    var H = e.mapAllOrFail(L.elements, function(l) {
                      return l.dotDotDotToken || l.initializer || l.propertyName && !e.isIdentifier(l.propertyName) || !e.isIdentifier(l.name) ? void 0 : $(l.propertyName && l.propertyName.text, l.name.text);
                    });
                    if (H) return V([e.makeImport(void 0, H, P, j)]);
                  }
                  case 202: {
                    var I = O(C.moduleSpecifierToValidIdentifier(P.text, U), Y);
                    return V([e.makeImport(e.factory.createIdentifier(I), void 0, P, j), A(void 0, e.getSynthesizedDeepClone(L), e.factory.createIdentifier(I))]);
                  }
                  case 79:
                    return q(L, P, k, Y, j);
                  default:
                    return e.Debug.assertNever(L, "Convert to ES module got invalid name kind ".concat(L.kind));
                }
              }
              function q(L, P, k, Y, U) {
                for (var j = k.getSymbolAtLocation(L), H = new e.Map(), I = false, l, d = 0, D = Y.original.get(L.text); d < D.length; d++) {
                  var fe = D[d];
                  if (!(k.getSymbolAtLocation(fe) !== j || fe === L)) {
                    var g = fe.parent;
                    if (e.isPropertyAccessExpression(g)) {
                      var ne = g.name.text;
                      if (ne === "default") {
                        I = true;
                        var ue = fe.getText();
                        (l != null ? l : l = new e.Map()).set(g, e.factory.createIdentifier(ue));
                      } else {
                        e.Debug.assert(g.expression === fe, "Didn't expect expression === use");
                        var We = H.get(ne);
                        We === void 0 && (We = O(ne, Y), H.set(ne, We)), (l != null ? l : l = new e.Map()).set(g, e.factory.createIdentifier(We));
                      }
                    } else I = true;
                  }
                }
                var Fe = H.size === 0 ? void 0 : e.arrayFrom(e.mapIterator(H.entries(), function(Z) {
                  var Be = Z[0], ge = Z[1];
                  return e.factory.createImportSpecifier(false, Be === ge ? void 0 : e.factory.createIdentifier(Be), e.factory.createIdentifier(ge));
                }));
                return Fe || (I = true), V([e.makeImport(I ? e.getSynthesizedDeepClone(L) : void 0, Fe, P, U)], l);
              }
              function O(L, P) {
                for (; P.original.has(L) || P.additional.has(L); ) L = "_".concat(L);
                return P.additional.add(L), L;
              }
              function ve(L) {
                var P = e.createMultiMap();
                return ee(L, function(k) {
                  return P.add(k.text, k);
                }), P;
              }
              function ee(L, P) {
                e.isIdentifier(L) && he(L) && P(L), L.forEachChild(function(k) {
                  return ee(k, P);
                });
              }
              function he(L) {
                var P = L.parent;
                switch (P.kind) {
                  case 206:
                    return P.name !== L;
                  case 203:
                    return P.propertyName !== L;
                  case 270:
                    return P.propertyName !== L;
                  default:
                    return true;
                }
              }
              function F(L, P, k, Y) {
                return e.factory.createFunctionDeclaration(e.getSynthesizedDeepClones(k.decorators), e.concatenate(P, e.getSynthesizedDeepClones(k.modifiers)), e.getSynthesizedDeepClone(k.asteriskToken), L, e.getSynthesizedDeepClones(k.typeParameters), e.getSynthesizedDeepClones(k.parameters), e.getSynthesizedDeepClone(k.type), e.factory.converters.convertToFunctionBlock(ie(k.body, Y)));
              }
              function x(L, P, k, Y) {
                return e.factory.createClassDeclaration(e.getSynthesizedDeepClones(k.decorators), e.concatenate(P, e.getSynthesizedDeepClones(k.modifiers)), L, e.getSynthesizedDeepClones(k.typeParameters), e.getSynthesizedDeepClones(k.heritageClauses), ie(k.members, Y));
              }
              function X(L, P, k, Y) {
                return P === "default" ? e.makeImport(e.factory.createIdentifier(L), void 0, k, Y) : e.makeImport(void 0, [$(P, L)], k, Y);
              }
              function $(L, P) {
                return e.factory.createImportSpecifier(false, L !== void 0 && L !== P ? e.factory.createIdentifier(L) : void 0, e.factory.createIdentifier(P));
              }
              function A(L, P, k) {
                return e.factory.createVariableStatement(L, e.factory.createVariableDeclarationList([e.factory.createVariableDeclaration(P, void 0, void 0, k)], 2));
              }
              function y(L, P) {
                return e.factory.createExportDeclaration(void 0, void 0, false, L && e.factory.createNamedExports(L), P === void 0 ? void 0 : e.factory.createStringLiteral(P));
              }
              function V(L, P) {
                return { newImports: L, useSitesToUnqualify: P };
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "correctQualifiedNameToIndexedAccessType", B = [e.Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = E(le.sourceFile, le.span.start);
                if (!!N) {
                  var p = e.textChanges.ChangeTracker.with(le, function(G) {
                    return Q(G, le.sourceFile, N);
                  }), m = "".concat(N.left.text, '["').concat(N.right.text, '"]');
                  return [C.createCodeFixAction(w, p, [e.Diagnostics.Rewrite_as_the_indexed_access_type_0, m], w, e.Diagnostics.Rewrite_all_as_indexed_access_types)];
                }
              }, fixIds: [w], getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  var m = E(p.file, p.start);
                  m && Q(N, p.file, m);
                });
              } });
              function E(le, N) {
                var p = e.findAncestor(e.getTokenAtPosition(le, N), e.isQualifiedName);
                return e.Debug.assert(!!p, "Expected position to be owned by a qualified name."), e.isIdentifier(p.left) ? p : void 0;
              }
              function Q(le, N, p) {
                var m = p.right.text, G = e.factory.createIndexedAccessTypeNode(e.factory.createTypeReferenceNode(p.left, void 0), e.factory.createLiteralTypeNode(e.factory.createStringLiteral(m)));
                le.replaceNode(N, p, G);
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = [e.Diagnostics.Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type.code], B = "convertToTypeOnlyExport";
              C.registerCodeFix({ errorCodes: w, getCodeActions: function(p) {
                var m = e.textChanges.ChangeTracker.with(p, function(G) {
                  return Q(G, E(p.span, p.sourceFile), p);
                });
                if (m.length) return [C.createCodeFixAction(B, m, e.Diagnostics.Convert_to_type_only_export, B, e.Diagnostics.Convert_all_re_exported_types_to_type_only_exports)];
              }, fixIds: [B], getAllCodeActions: function(p) {
                var m = new e.Map();
                return C.codeFixAll(p, w, function(G, oe) {
                  var f = E(oe, p.sourceFile);
                  f && e.addToSeen(m, e.getNodeId(f.parent.parent)) && Q(G, f, p);
                });
              } });
              function E(N, p) {
                return e.tryCast(e.getTokenAtPosition(p, N.start).parent, e.isExportSpecifier);
              }
              function Q(N, p, m) {
                if (!!p) {
                  var G = p.parent, oe = G.parent, f = le(p, m);
                  if (f.length === G.elements.length) N.insertModifierBefore(m.sourceFile, 152, G);
                  else {
                    var T = e.factory.updateExportDeclaration(oe, oe.decorators, oe.modifiers, false, e.factory.updateNamedExports(G, e.filter(G.elements, function(b) {
                      return !e.contains(f, b);
                    })), oe.moduleSpecifier, void 0), K = e.factory.createExportDeclaration(void 0, void 0, true, e.factory.createNamedExports(f), oe.moduleSpecifier, void 0);
                    N.replaceNode(m.sourceFile, oe, T, { leadingTriviaOption: e.textChanges.LeadingTriviaOption.IncludeAll, trailingTriviaOption: e.textChanges.TrailingTriviaOption.Exclude }), N.insertNodeAfter(m.sourceFile, oe, K);
                  }
                }
              }
              function le(N, p) {
                var m = N.parent;
                if (m.elements.length === 1) return m.elements;
                var G = e.getDiagnosticsWithinSpan(e.createTextSpanFromNode(m), p.program.getSemanticDiagnostics(p.sourceFile, p.cancellationToken));
                return e.filter(m.elements, function(oe) {
                  var f;
                  return oe === N || ((f = e.findDiagnosticForNode(oe, G)) === null || f === void 0 ? void 0 : f.code) === w[0];
                });
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = [e.Diagnostics.This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error.code], B = "convertToTypeOnlyImport";
              C.registerCodeFix({ errorCodes: w, getCodeActions: function(N) {
                var p = e.textChanges.ChangeTracker.with(N, function(m) {
                  var G = E(N.span, N.sourceFile);
                  Q(m, G, N);
                });
                if (p.length) return [C.createCodeFixAction(B, p, e.Diagnostics.Convert_to_type_only_import, B, e.Diagnostics.Convert_all_imports_not_used_as_a_value_to_type_only_imports)];
              }, fixIds: [B], getAllCodeActions: function(N) {
                return C.codeFixAll(N, w, function(p, m) {
                  var G = E(m, N.sourceFile);
                  Q(p, G, N);
                });
              } });
              function E(le, N) {
                return e.tryCast(e.getTokenAtPosition(N, le.start).parent, e.isImportDeclaration);
              }
              function Q(le, N, p) {
                if (!!(N != null && N.importClause)) {
                  var m = N.importClause;
                  le.insertText(p.sourceFile, N.getStart() + 6, " type"), m.name && m.namedBindings && (le.deleteNodeRangeExcludingEnd(p.sourceFile, m.name, N.importClause.namedBindings), le.insertNodeBefore(p.sourceFile, N, e.factory.updateImportDeclaration(N, void 0, void 0, e.factory.createImportClause(true, m.name, void 0), N.moduleSpecifier, void 0)));
                }
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "convertLiteralTypeToMappedType", B = [e.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(N) {
                var p = N.sourceFile, m = N.span, G = E(p, m.start);
                if (!!G) {
                  var oe = G.name, f = G.constraint, T = e.textChanges.ChangeTracker.with(N, function(K) {
                    return Q(K, p, G);
                  });
                  return [C.createCodeFixAction(w, T, [e.Diagnostics.Convert_0_to_1_in_0, f, oe], w, e.Diagnostics.Convert_all_type_literals_to_mapped_type)];
                }
              }, fixIds: [w], getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  var m = E(p.file, p.start);
                  m && Q(N, p.file, m);
                });
              } });
              function E(le, N) {
                var p = e.getTokenAtPosition(le, N);
                if (e.isIdentifier(p)) {
                  var m = e.cast(p.parent.parent, e.isPropertySignature), G = p.getText(le);
                  return { container: e.cast(m.parent, e.isTypeLiteralNode), typeNode: m.type, constraint: G, name: G === "K" ? "P" : "K" };
                }
              }
              function Q(le, N, p) {
                var m = p.container, G = p.typeNode, oe = p.constraint, f = p.name;
                le.replaceNode(N, m, e.factory.createMappedTypeNode(void 0, e.factory.createTypeParameterDeclaration(void 0, f, e.factory.createTypeReferenceNode(oe)), void 0, void 0, G, void 0));
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = [e.Diagnostics.Class_0_incorrectly_implements_interface_1.code, e.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code], B = "fixClassIncorrectlyImplementsInterface";
              C.registerCodeFix({ errorCodes: w, getCodeActions: function(p) {
                var m = p.sourceFile, G = p.span, oe = E(m, G.start);
                return e.mapDefined(e.getEffectiveImplementsTypeNodes(oe), function(f) {
                  var T = e.textChanges.ChangeTracker.with(p, function(K) {
                    return le(p, f, m, oe, K, p.preferences);
                  });
                  return T.length === 0 ? void 0 : C.createCodeFixAction(B, T, [e.Diagnostics.Implement_interface_0, f.getText(m)], B, e.Diagnostics.Implement_all_unimplemented_interfaces);
                });
              }, fixIds: [B], getAllCodeActions: function(p) {
                var m = new e.Map();
                return C.codeFixAll(p, w, function(G, oe) {
                  var f = E(oe.file, oe.start);
                  if (e.addToSeen(m, e.getNodeId(f))) for (var T = 0, K = e.getEffectiveImplementsTypeNodes(f); T < K.length; T++) {
                    var b = K[T];
                    le(p, b, oe.file, f, G, p.preferences);
                  }
                });
              } });
              function E(p, m) {
                return e.Debug.checkDefined(e.getContainingClass(e.getTokenAtPosition(p, m)), "There should be a containing class");
              }
              function Q(p) {
                return !p.valueDeclaration || !(e.getEffectiveModifierFlags(p.valueDeclaration) & 8);
              }
              function le(p, m, G, oe, f, T) {
                var K = p.program.getTypeChecker(), b = N(oe, K), se = K.getTypeAtLocation(m), J = K.getPropertiesOfType(se), ie = J.filter(e.and(Q, function(he) {
                  return !b.has(he.escapedName);
                })), R = K.getTypeAtLocation(oe), q = e.find(oe.members, function(he) {
                  return e.isConstructorDeclaration(he);
                });
                R.getNumberIndexType() || ve(se, 1), R.getStringIndexType() || ve(se, 0);
                var O = C.createImportAdder(G, p.program, T, p.host);
                C.createMissingMemberNodes(oe, ie, G, p, T, O, function(he) {
                  return ee(G, oe, he);
                }), O.writeFixes(f);
                function ve(he, F) {
                  var x = K.getIndexInfoOfType(he, F);
                  x && ee(G, oe, K.indexInfoToIndexSignatureDeclaration(x, oe, void 0, C.getNoopSymbolTrackerWithResolver(p)));
                }
                function ee(he, F, x) {
                  q ? f.insertNodeAfter(he, q, x) : f.insertMemberAtStart(he, F, x);
                }
              }
              function N(p, m) {
                var G = e.getEffectiveBaseTypeNode(p);
                if (!G) return e.createSymbolTable();
                var oe = m.getTypeAtLocation(G), f = m.getPropertiesOfType(oe);
                return e.createSymbolTable(f.filter(Q));
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              C.importFixName = "import";
              var w = "fixMissingImport", B = [e.Diagnostics.Cannot_find_name_0.code, e.Diagnostics.Cannot_find_name_0_Did_you_mean_1.code, e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code, e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code, e.Diagnostics.Cannot_find_namespace_0.code, e.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code, e.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here.code, e.Diagnostics.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer.code, e.Diagnostics._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(_e) {
                var we = _e.errorCode, de = _e.preferences, ye = _e.sourceFile, Ae = _e.span, er = _e.program, ir = x(_e, we, Ae.start, true);
                if (!!ir) {
                  var Cr = ir.fixes, Ye = ir.symbolName, Br = ir.errorIdentifierText, Er = e.getQuotePreference(ye, de);
                  return Cr.map(function(Ne) {
                    return fe(_e, ye, Ye, Ne, Ye !== Br, Er, er.getCompilerOptions());
                  });
                }
              }, fixIds: [w], getAllCodeActions: function(_e) {
                var we = _e.sourceFile, de = _e.program, ye = _e.preferences, Ae = _e.host, er = Q(we, de, true, ye, Ae);
                return C.eachDiagnostic(_e, B, function(ir) {
                  return er.addImportFromDiagnostic(ir, _e);
                }), C.createCombinedCodeActions(e.textChanges.ChangeTracker.with(_e, er.writeFixes));
              } });
              function E(_e, we, de, ye) {
                return Q(_e, we, false, de, ye);
              }
              C.createImportAdder = E;
              function Q(_e, we, de, ye, Ae) {
                var er = we.getCompilerOptions(), ir = [], Cr = [], Ye = new e.Map(), Br = new e.Map();
                return { addImportFromDiagnostic: Er, addImportFromExportedSymbol: Ne, writeFixes: lr, hasFixes: be };
                function Er(Ge, ur) {
                  var yr = x(ur, Ge.code, Ge.start, de);
                  !yr || !yr.fixes.length || n(yr);
                }
                function Ne(Ge, ur) {
                  var yr = e.Debug.checkDefined(Ge.parent), Ir = e.getNameForExportedSymbol(Ge, e.getEmitScriptTarget(er)), wr = we.getTypeChecker(), Ur = wr.getMergedSymbol(e.skipAlias(Ge, wr)), ii = T(_e, Ur, yr, Ir, false, Ae, we, ye, de), mi = ve(_e, we), pe = G(_e, ii, yr, we, void 0, !!ur, mi, Ae, ye);
                  pe && n({ fixes: [pe], symbolName: Ir, errorIdentifierText: void 0 });
                }
                function n(Ge) {
                  var ur, yr, Ir = Ge.fixes, wr = Ge.symbolName, Ur = e.first(Ir);
                  switch (Ur.kind) {
                    case 0:
                      ir.push(Ur);
                      break;
                    case 1:
                      Cr.push(Ur);
                      break;
                    case 2: {
                      var ii = Ur.importClauseOrBindingPattern, mi = Ur.importKind, pe = Ur.addAsTypeOnly, or = String(e.getNodeId(ii)), qr = Ye.get(or);
                      if (qr || Ye.set(or, qr = { importClauseOrBindingPattern: ii, defaultImport: void 0, namedImports: new e.Map() }), mi === 0) {
                        var si = qr == null ? void 0 : qr.namedImports.get(wr);
                        qr.namedImports.set(wr, Xi(si, pe));
                      } else e.Debug.assert(qr.defaultImport === void 0 || qr.defaultImport.name === wr, "(Add to Existing) Default import should be missing or match symbolName"), qr.defaultImport = { name: wr, addAsTypeOnly: Xi((ur = qr.defaultImport) === null || ur === void 0 ? void 0 : ur.addAsTypeOnly, pe) };
                      break;
                    }
                    case 3: {
                      var Di = Ur.moduleSpecifier, mi = Ur.importKind, wi = Ur.useRequire, pe = Ur.addAsTypeOnly, qr = et(Di, mi, wi, pe);
                      switch (e.Debug.assert(qr.useRequire === wi, "(Add new) Tried to add an `import` and a `require` for the same module"), mi) {
                        case 1:
                          e.Debug.assert(qr.defaultImport === void 0 || qr.defaultImport.name === wr, "(Add new) Default import should be missing or match symbolName"), qr.defaultImport = { name: wr, addAsTypeOnly: Xi((yr = qr.defaultImport) === null || yr === void 0 ? void 0 : yr.addAsTypeOnly, pe) };
                          break;
                        case 0:
                          var si = (qr.namedImports || (qr.namedImports = new e.Map())).get(wr);
                          qr.namedImports.set(wr, Xi(si, pe));
                          break;
                        case 3:
                        case 2:
                          e.Debug.assert(qr.namespaceLikeImport === void 0 || qr.namespaceLikeImport.name === wr, "Namespacelike import shoudl be missing or match symbolName"), qr.namespaceLikeImport = { importKind: mi, name: wr, addAsTypeOnly: pe };
                          break;
                      }
                      break;
                    }
                    case 4:
                      break;
                    default:
                      e.Debug.assertNever(Ur, "fix wasn't never - got kind ".concat(Ur.kind));
                  }
                  function Xi(Wt, Zt) {
                    return Math.max(Wt != null ? Wt : 0, Zt);
                  }
                  function et(Wt, Zt, _r, pi) {
                    var ae = Gi(Wt, true), Xe = Gi(Wt, false), Jr = Br.get(ae), ti = Br.get(Xe), Ze = { defaultImport: void 0, namedImports: void 0, namespaceLikeImport: void 0, useRequire: _r };
                    return Zt === 1 && pi === 2 ? Jr || (Br.set(ae, Ze), Ze) : pi === 1 && (Jr || ti) ? Jr || ti : ti || (Br.set(Xe, Ze), Ze);
                  }
                  function Gi(Wt, Zt) {
                    return "".concat(Zt ? 1 : 0, "|").concat(Wt);
                  }
                }
                function lr(Ge) {
                  for (var ur = e.getQuotePreference(_e, ye), yr = 0, Ir = ir; yr < Ir.length; yr++) {
                    var wr = Ir[yr];
                    Fe(Ge, _e, wr);
                  }
                  for (var Ur = 0, ii = Cr; Ur < ii.length; Ur++) {
                    var wr = ii[Ur];
                    Z(Ge, _e, wr, ur);
                  }
                  Ye.forEach(function(pe) {
                    var or = pe.importClauseOrBindingPattern, qr = pe.defaultImport, si = pe.namedImports;
                    We(Ge, _e, or, qr, e.arrayFrom(si.entries(), function(Di) {
                      var wi = Di[0], Xi = Di[1];
                      return { addAsTypeOnly: Xi, name: wi };
                    }), er);
                  });
                  var mi;
                  Br.forEach(function(pe, or) {
                    var qr = pe.useRequire, si = pe.defaultImport, Di = pe.namedImports, wi = pe.namespaceLikeImport, Xi = or.slice(2), et = qr ? ze : Re, Gi = et(Xi, ur, si, Di && e.arrayFrom(Di.entries(), function(Wt) {
                      var Zt = Wt[0], _r = Wt[1];
                      return { addAsTypeOnly: _r, name: Zt };
                    }), wi);
                    mi = e.combine(mi, Gi);
                  }), mi && e.insertImports(Ge, _e, mi, true);
                }
                function be() {
                  return ir.length > 0 || Cr.length > 0 || Ye.size > 0 || Br.size > 0;
                }
              }
              var le;
              (function(_e) {
                _e[_e.UseNamespace = 0] = "UseNamespace", _e[_e.JsdocTypeImport = 1] = "JsdocTypeImport", _e[_e.AddToExisting = 2] = "AddToExisting", _e[_e.AddNew = 3] = "AddNew", _e[_e.PromoteTypeOnly = 4] = "PromoteTypeOnly";
              })(le || (le = {}));
              var N;
              (function(_e) {
                _e[_e.Allowed = 1] = "Allowed", _e[_e.Required = 2] = "Required", _e[_e.NotAllowed = 4] = "NotAllowed";
              })(N || (N = {}));
              function p(_e, we, de, ye, Ae, er, ir, Cr, Ye, Br) {
                var Er = ir.getCompilerOptions(), Ne = e.pathIsBareSpecifier(e.stripQuotes(we.name)) ? [f(_e, we, ir, er)] : T(de, _e, we, ye, Ae, er, ir, Br, true), n = ve(de, ir), lr = e.isValidTypeOnlyAliasUseSite(e.getTokenAtPosition(de, Ye)), be = e.Debug.checkDefined(G(de, Ne, we, ir, { symbolName: ye, position: Ye }, lr, n, er, Br));
                return { moduleSpecifier: be.moduleSpecifier, codeAction: oe(fe({ host: er, formatContext: Cr, preferences: Br }, de, ye, be, false, e.getQuotePreference(de, Br), Er)) };
              }
              C.getImportCompletionAction = p;
              function m(_e, we, de, ye, Ae, er) {
                var ir = de.getCompilerOptions(), Cr = I(_e, de.getTypeChecker(), we, ir), Ye = H(_e, we, Cr, de), Br = Cr !== we.text;
                return Ye && oe(fe({ host: ye, formatContext: Ae, preferences: er }, _e, Cr, Ye, Br, 1, ir));
              }
              C.getPromoteTypeOnlyCompletionAction = m;
              function G(_e, we, de, ye, Ae, er, ir, Cr, Ye) {
                e.Debug.assert(we.some(function(Er) {
                  return Er.moduleSymbol === de || Er.symbol.parent === de;
                }), "Some exportInfo should match the specified moduleSymbol");
                var Br = e.createPackageJsonImportFilter(_e, Ye, Cr);
                return $(b(we, Ae, er, ir, ye, _e, Cr, Ye).fixes, _e, ye, Br, Cr);
              }
              function oe(_e) {
                var we = _e.description, de = _e.changes, ye = _e.commands;
                return { description: we, changes: de, commands: ye };
              }
              function f(_e, we, de, ye) {
                var Ae, er, ir = de.getCompilerOptions(), Cr = Br(de.getTypeChecker(), false);
                if (Cr) return Cr;
                var Ye = (er = (Ae = ye.getPackageJsonAutoImportProvider) === null || Ae === void 0 ? void 0 : Ae.call(ye)) === null || er === void 0 ? void 0 : er.getTypeChecker();
                return e.Debug.checkDefined(Ye && Br(Ye, true), "Could not find symbol in specified module for code actions");
                function Br(Er, Ne) {
                  var n = e.getDefaultLikeExportInfo(we, Er, ir);
                  if (n && e.skipAlias(n.symbol, Er) === _e) return { symbol: n.symbol, moduleSymbol: we, moduleFileName: void 0, exportKind: n.exportKind, targetFlags: e.skipAlias(_e, Er).flags, isFromPackageJson: Ne };
                  var lr = Er.tryGetMemberInModuleExportsAndProperties(_e.name, we);
                  if (lr && e.skipAlias(lr, Er) === _e) return { symbol: lr, moduleSymbol: we, moduleFileName: void 0, exportKind: 0, targetFlags: e.skipAlias(_e, Er).flags, isFromPackageJson: Ne };
                }
              }
              function T(_e, we, de, ye, Ae, er, ir, Cr, Ye) {
                var Br = [], Er = ir.getCompilerOptions(), Ne = e.memoizeOne(function(lr) {
                  return e.createModuleSpecifierResolutionHost(lr ? er.getPackageJsonAutoImportProvider() : ir, er);
                });
                return e.forEachExternalModuleToImportFrom(ir, er, Ye, function(lr, be, Ge, ur) {
                  var yr = Ge.getTypeChecker();
                  if (!(be && lr !== de && e.startsWith(_e.fileName, e.getDirectoryPath(be.fileName)))) {
                    var Ir = e.getDefaultLikeExportInfo(lr, yr, Er);
                    Ir && (Ir.name === ye || rr(lr, e.getEmitScriptTarget(Er), Ae) === ye) && e.skipAlias(Ir.symbol, yr) === we && n(Ge, be, ur) && Br.push({ symbol: Ir.symbol, moduleSymbol: lr, moduleFileName: be == null ? void 0 : be.fileName, exportKind: Ir.exportKind, targetFlags: e.skipAlias(Ir.symbol, yr).flags, isFromPackageJson: ur });
                    for (var wr = 0, Ur = yr.getExportsAndPropertiesOfModule(lr); wr < Ur.length; wr++) {
                      var ii = Ur[wr];
                      ii.name === ye && yr.getMergedSymbol(e.skipAlias(ii, yr)) === we && n(Ge, be, ur) && Br.push({ symbol: ii, moduleSymbol: lr, moduleFileName: be == null ? void 0 : be.fileName, exportKind: 0, targetFlags: e.skipAlias(ii, yr).flags, isFromPackageJson: ur });
                    }
                  }
                }), Br;
                function n(lr, be, Ge) {
                  var ur;
                  return !be || e.isImportableFile(lr, _e, be, Cr, void 0, Ne(Ge), (ur = er.getModuleSpecifierCache) === null || ur === void 0 ? void 0 : ur.call(er));
                }
              }
              function K(_e, we, de, ye, Ae, er, ir, Cr, Ye, Br) {
                var Er = b(_e, { symbolName: we, position: de }, ye, false, er, Ae, ir, Cr, Br), Ne = Er.fixes, n = Er.computedWithoutCacheCount, lr = $(Ne, Ae, er, Ye || e.createPackageJsonImportFilter(Ae, Cr, ir), ir);
                return lr && Ke(Ke({}, lr), { computedWithoutCacheCount: n });
              }
              C.getModuleSpecifierForBestExportInfo = K;
              function b(_e, we, de, ye, Ae, er, ir, Cr, Ye) {
                var Br = Ae.getTypeChecker(), Er = e.flatMap(_e, function(yr) {
                  return O(yr, Br, er, Ae.getCompilerOptions());
                }), Ne = we && se(Er, we.symbolName, we.position, Br), n = q(Er, de, Br, Ae.getCompilerOptions());
                if (n) return { computedWithoutCacheCount: 0, fixes: Ve(Ve([], Ne ? [Ne] : e.emptyArray, true), [n], false) };
                var lr = he(_e, Er, Ae, er, we == null ? void 0 : we.position, de, ye, ir, Cr, Ye), be = lr.fixes, Ge = lr.computedWithoutCacheCount, ur = Ge === void 0 ? 0 : Ge;
                return { computedWithoutCacheCount: ur, fixes: Ve(Ve([], Ne ? [Ne] : e.emptyArray, true), be, true) };
              }
              function se(_e, we, de, ye) {
                return e.firstDefined(_e, function(Ae) {
                  var er, ir = Ae.declaration, Cr = ie(ir), Ye = (er = e.tryGetModuleSpecifierFromDeclaration(ir)) === null || er === void 0 ? void 0 : er.text;
                  if (Cr && Ye) {
                    var Br = J(ir, ye);
                    if (Br && Br.exports.has(e.escapeLeadingUnderscores(we))) return { kind: 0, namespacePrefix: Cr, position: de, moduleSpecifier: Ye };
                  }
                });
              }
              function J(_e, we) {
                var de;
                switch (_e.kind) {
                  case 254:
                    return we.resolveExternalModuleName(_e.initializer.arguments[0]);
                  case 265:
                    return we.getAliasedSymbol(_e.symbol);
                  case 266:
                    var ye = e.tryCast((de = _e.importClause) === null || de === void 0 ? void 0 : de.namedBindings, e.isNamespaceImport);
                    return ye && we.getAliasedSymbol(ye.symbol);
                  default:
                    return e.Debug.assertNever(_e);
                }
              }
              function ie(_e) {
                var we, de, ye;
                switch (_e.kind) {
                  case 254:
                    return (we = e.tryCast(_e.name, e.isIdentifier)) === null || we === void 0 ? void 0 : we.text;
                  case 265:
                    return _e.name.text;
                  case 266:
                    return (ye = e.tryCast((de = _e.importClause) === null || de === void 0 ? void 0 : de.namedBindings, e.isNamespaceImport)) === null || ye === void 0 ? void 0 : ye.name.text;
                  default:
                    return e.Debug.assertNever(_e);
                }
              }
              function R(_e, we, de, ye, Ae, er) {
                return _e ? we && er.importsNotUsedAsValues === 2 || er.isolatedModules && er.preserveValueImports && (!(ye & 111551) || !!Ae.getTypeOnlyAliasDeclaration(de)) ? 2 : 1 : 4;
              }
              function q(_e, we, de, ye) {
                return e.firstDefined(_e, function(Ae) {
                  var er = Ae.declaration, ir = Ae.importKind, Cr = Ae.symbol, Ye = Ae.targetFlags;
                  if (!(ir === 3 || ir === 2 || er.kind === 265)) {
                    if (er.kind === 254) return (ir === 0 || ir === 1) && er.name.kind === 201 ? { kind: 2, importClauseOrBindingPattern: er.name, importKind: ir, moduleSpecifier: er.initializer.arguments[0].text, addAsTypeOnly: 4 } : void 0;
                    var Br = er.importClause;
                    if (!(!Br || !e.isStringLiteralLike(er.moduleSpecifier))) {
                      var Er = Br.name, Ne = Br.namedBindings;
                      if (!(Br.isTypeOnly && !(ir === 0 && Ne))) {
                        var n = R(we, false, Cr, Ye, de, ye);
                        if (!(ir === 1 && (Er || n === 2 && Ne)) && !(ir === 0 && (Ne == null ? void 0 : Ne.kind) === 268)) return { kind: 2, importClauseOrBindingPattern: Br, importKind: ir, moduleSpecifier: er.moduleSpecifier.text, addAsTypeOnly: n };
                      }
                    }
                  }
                });
              }
              function O(_e, we, de, ye) {
                var Ae = _e.moduleSymbol, er = _e.exportKind, ir = _e.targetFlags, Cr = _e.symbol;
                if (!(ir & 111551) && e.isSourceFileJS(de)) return e.emptyArray;
                var Ye = Y(de, er, ye);
                return e.mapDefined(de.imports, function(Br) {
                  var Er = e.importFromModuleSpecifier(Br);
                  if (e.isVariableDeclarationInitializedToRequire(Er.parent)) return we.resolveExternalModuleName(Br) === Ae ? { declaration: Er.parent, importKind: Ye, symbol: Cr, targetFlags: ir } : void 0;
                  if (Er.kind === 266 || Er.kind === 265) return we.getSymbolAtLocation(Br) === Ae ? { declaration: Er, importKind: Ye, symbol: Cr, targetFlags: ir } : void 0;
                });
              }
              function ve(_e, we) {
                if (!e.isSourceFileJS(_e)) return false;
                if (_e.commonJsModuleIndicator && !_e.externalModuleIndicator) return true;
                if (_e.externalModuleIndicator && !_e.commonJsModuleIndicator) return false;
                var de = we.getCompilerOptions();
                if (de.configFile) return e.getEmitModuleKind(de) < e.ModuleKind.ES2015;
                for (var ye = 0, Ae = we.getSourceFiles(); ye < Ae.length; ye++) {
                  var er = Ae[ye];
                  if (!(er === _e || !e.isSourceFileJS(er) || we.isSourceFileFromExternalLibrary(er))) {
                    if (er.commonJsModuleIndicator && !er.externalModuleIndicator) return true;
                    if (er.externalModuleIndicator && !er.commonJsModuleIndicator) return false;
                  }
                }
                return true;
              }
              function ee(_e, we, de, ye, Ae, er, ir, Cr, Ye) {
                var Br = e.isSourceFileJS(we), Er = _e.getCompilerOptions(), Ne = e.createModuleSpecifierResolutionHost(_e, ir), n = e.memoizeOne(function(yr) {
                  return yr ? ir.getPackageJsonAutoImportProvider().getTypeChecker() : _e.getTypeChecker();
                }), lr = e.moduleResolutionUsesNodeModules(e.getEmitModuleResolutionKind(Er)), be = Ye ? function(yr) {
                  return { moduleSpecifiers: e.moduleSpecifiers.tryGetModuleSpecifiersFromCache(yr, we, Ne, Cr), computedWithoutCache: false };
                } : function(yr, Ir) {
                  return e.moduleSpecifiers.getModuleSpecifiersWithCacheInfo(yr, Ir, Er, we, Ne, Cr);
                }, Ge = 0, ur = e.flatMap(er, function(yr, Ir) {
                  var wr = n(yr.isFromPackageJson), Ur = be(yr.moduleSymbol, wr), ii = Ur.computedWithoutCache, mi = Ur.moduleSpecifiers, pe = !!(yr.targetFlags & 111551), or = R(ye, true, yr.symbol, yr.targetFlags, wr, Er);
                  return Ge += ii ? 1 : 0, e.mapDefined(mi, function(qr) {
                    return lr && e.pathContainsNodeModules(qr) ? void 0 : !pe && Br && de !== void 0 ? { kind: 1, moduleSpecifier: qr, position: de, exportInfo: yr, isReExport: Ir > 0 } : { kind: 3, moduleSpecifier: qr, importKind: Y(we, yr.exportKind, Er), useRequire: Ae, addAsTypeOnly: or, exportInfo: yr, isReExport: Ir > 0 };
                  });
                });
                return { computedWithoutCacheCount: Ge, fixes: ur };
              }
              function he(_e, we, de, ye, Ae, er, ir, Cr, Ye, Br) {
                var Er = e.firstDefined(we, function(Ne) {
                  return F(Ne, er, ir, de.getTypeChecker(), de.getCompilerOptions());
                });
                return Er ? { fixes: [Er] } : ee(de, ye, Ae, er, ir, _e, Cr, Ye, Br);
              }
              function F(_e, we, de, ye, Ae) {
                var er, ir = _e.declaration, Cr = _e.importKind, Ye = _e.symbol, Br = _e.targetFlags, Er = (er = e.tryGetModuleSpecifierFromDeclaration(ir)) === null || er === void 0 ? void 0 : er.text;
                if (Er) {
                  var Ne = de ? 4 : R(we, true, Ye, Br, ye, Ae);
                  return { kind: 3, moduleSpecifier: Er, importKind: Cr, addAsTypeOnly: Ne, useRequire: de };
                }
              }
              function x(_e, we, de, ye) {
                var Ae = e.getTokenAtPosition(_e.sourceFile, de), er;
                if (we === e.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code) er = P(_e, Ae);
                else if (e.isIdentifier(Ae)) if (we === e.Diagnostics._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type.code) {
                  var ir = I(_e.sourceFile, _e.program.getTypeChecker(), Ae, _e.program.getCompilerOptions()), Cr = H(_e.sourceFile, Ae, ir, _e.program);
                  return Cr && { fixes: [Cr], symbolName: ir, errorIdentifierText: Ae.text };
                } else er = j(_e, Ae, ye);
                else return;
                var Ye = e.createPackageJsonImportFilter(_e.sourceFile, _e.preferences, _e.host);
                return er && Ke(Ke({}, er), { fixes: X(er.fixes, _e.sourceFile, _e.program, Ye, _e.host) });
              }
              function X(_e, we, de, ye, Ae) {
                var er = function(ir) {
                  return e.toPath(ir, Ae.getCurrentDirectory(), e.hostGetCanonicalFileName(Ae));
                };
                return e.sort(_e, function(ir, Cr) {
                  return e.compareValues(ir.kind, Cr.kind) || A(ir, Cr, we, de, ye.allowsImportingSpecifier, er);
                });
              }
              function $(_e, we, de, ye, Ae) {
                if (!!e.some(_e)) return _e[0].kind === 0 || _e[0].kind === 2 ? _e[0] : _e.reduce(function(er, ir) {
                  return A(ir, er, we, de, ye.allowsImportingSpecifier, function(Cr) {
                    return e.toPath(Cr, Ae.getCurrentDirectory(), e.hostGetCanonicalFileName(Ae));
                  }) === -1 ? ir : er;
                });
              }
              function A(_e, we, de, ye, Ae, er) {
                return _e.kind !== 0 && we.kind !== 0 ? e.compareBooleans(Ae(we.moduleSpecifier), Ae(_e.moduleSpecifier)) || L(_e.moduleSpecifier, we.moduleSpecifier, de, ye) || e.compareBooleans(y(_e, de, ye.getCompilerOptions(), er), y(we, de, ye.getCompilerOptions(), er)) || e.compareNumberOfDirectorySeparators(_e.moduleSpecifier, we.moduleSpecifier) : 0;
              }
              function y(_e, we, de, ye) {
                var Ae;
                if (_e.isReExport && ((Ae = _e.exportInfo) === null || Ae === void 0 ? void 0 : Ae.moduleFileName) && e.getEmitModuleResolutionKind(de) === e.ModuleResolutionKind.NodeJs && V(_e.exportInfo.moduleFileName)) {
                  var er = ye(e.getDirectoryPath(_e.exportInfo.moduleFileName));
                  return e.startsWith(we.path, er);
                }
                return false;
              }
              function V(_e) {
                return e.getBaseFileName(_e, [".js", ".jsx", ".d.ts", ".ts", ".tsx"], true) === "index";
              }
              function L(_e, we, de, ye) {
                return e.startsWith(_e, "node:") && !e.startsWith(we, "node:") ? e.shouldUseUriStyleNodeCoreModules(de, ye) ? -1 : 1 : e.startsWith(we, "node:") && !e.startsWith(_e, "node:") ? e.shouldUseUriStyleNodeCoreModules(de, ye) ? 1 : -1 : 0;
              }
              function P(_e, we) {
                var de, ye = _e.sourceFile, Ae = _e.program, er = _e.host, ir = _e.preferences, Cr = Ae.getTypeChecker(), Ye = k(we, Cr);
                if (!!Ye) {
                  var Br = Cr.getAliasedSymbol(Ye), Er = Ye.name, Ne = [{ symbol: Ye, moduleSymbol: Br, moduleFileName: void 0, exportKind: 3, targetFlags: Br.flags, isFromPackageJson: false }], n = ve(ye, Ae), lr = e.isIdentifier(we) ? we.getStart(ye) : void 0, be = b(Ne, lr ? { position: lr, symbolName: Er } : void 0, false, n, Ae, ye, er, ir).fixes;
                  return { fixes: be, symbolName: Er, errorIdentifierText: (de = e.tryCast(we, e.isIdentifier)) === null || de === void 0 ? void 0 : de.text };
                }
              }
              function k(_e, we) {
                var de = e.isIdentifier(_e) ? we.getSymbolAtLocation(_e) : void 0;
                if (e.isUMDExportSymbol(de)) return de;
                var ye = _e.parent;
                return e.isJsxOpeningLikeElement(ye) && ye.tagName === _e || e.isJsxOpeningFragment(ye) ? e.tryCast(we.resolveName(we.getJsxNamespace(ye), e.isJsxOpeningLikeElement(ye) ? _e : ye, 111551, false), e.isUMDExportSymbol) : void 0;
              }
              function Y(_e, we, de, ye) {
                switch (we) {
                  case 0:
                    return 0;
                  case 1:
                    return 1;
                  case 2:
                    return D(_e, de, !!ye);
                  case 3:
                    return U(_e, de, !!ye);
                  default:
                    return e.Debug.assertNever(we);
                }
              }
              C.getImportKind = Y;
              function U(_e, we, de) {
                if (e.getAllowSyntheticDefaultImports(we)) return 1;
                var ye = e.getEmitModuleKind(we);
                switch (ye) {
                  case e.ModuleKind.AMD:
                  case e.ModuleKind.CommonJS:
                  case e.ModuleKind.UMD:
                    return e.isInJSFile(_e) && (e.isExternalModule(_e) || de) ? 2 : 3;
                  case e.ModuleKind.System:
                  case e.ModuleKind.ES2015:
                  case e.ModuleKind.ES2020:
                  case e.ModuleKind.ES2022:
                  case e.ModuleKind.ESNext:
                  case e.ModuleKind.None:
                    return 2;
                  case e.ModuleKind.Node16:
                  case e.ModuleKind.NodeNext:
                    return _e.impliedNodeFormat === e.ModuleKind.ESNext ? 2 : 3;
                  default:
                    return e.Debug.assertNever(ye, "Unexpected moduleKind ".concat(ye));
                }
              }
              function j(_e, we, de) {
                var ye = _e.sourceFile, Ae = _e.program, er = _e.cancellationToken, ir = _e.host, Cr = _e.preferences, Ye = Ae.getTypeChecker(), Br = Ae.getCompilerOptions(), Er = I(ye, Ye, we, Br);
                if (Er !== "default") {
                  var Ne = e.isValidTypeOnlyAliasUseSite(we), n = ve(ye, Ae), lr = d(Er, e.isJSXTagName(we), e.getMeaningFromLocation(we), er, ye, Ae, de, ir, Cr), be = e.arrayFrom(e.flatMapIterator(lr.entries(), function(Ge) {
                    var ur = Ge[0], yr = Ge[1];
                    return b(yr, { symbolName: Er, position: we.getStart(ye) }, Ne, n, Ae, ye, ir, Cr).fixes;
                  }));
                  return { fixes: be, symbolName: Er, errorIdentifierText: we.text };
                }
              }
              function H(_e, we, de, ye) {
                var Ae = ye.getTypeChecker(), er = Ae.resolveName(de, we, 111551, true);
                if (!!er) {
                  var ir = Ae.getTypeOnlyAliasDeclaration(er);
                  if (!(!ir || e.getSourceFileOfNode(ir) !== _e)) return { kind: 4, typeOnlyAliasDeclaration: ir };
                }
              }
              function I(_e, we, de, ye) {
                var Ae = de.parent;
                if ((e.isJsxOpeningLikeElement(Ae) || e.isJsxClosingElement(Ae)) && Ae.tagName === de && e.jsxModeNeedsExplicitImport(ye.jsx)) {
                  var er = we.getJsxNamespace(_e);
                  if (l(er, de, we)) return er;
                }
                return de.text;
              }
              function l(_e, we, de) {
                if (e.isIntrinsicJsxName(we.text)) return true;
                var ye = de.resolveName(_e, we, 111551, true);
                return !ye || e.some(ye.declarations, e.isTypeOnlyImportOrExportDeclaration) && !(ye.flags & 111551);
              }
              function d(_e, we, de, ye, Ae, er, ir, Cr, Ye) {
                var Br, Er = e.createMultiMap(), Ne = e.createPackageJsonImportFilter(Ae, Ye, Cr), n = (Br = Cr.getModuleSpecifierCache) === null || Br === void 0 ? void 0 : Br.call(Cr), lr = e.memoizeOne(function(Ge) {
                  return e.createModuleSpecifierResolutionHost(Ge ? Cr.getPackageJsonAutoImportProvider() : er, Cr);
                });
                function be(Ge, ur, yr, Ir, wr, Ur) {
                  var ii = lr(Ur);
                  if (ur && e.isImportableFile(wr, Ae, ur, Ye, Ne, ii, n) || !ur && Ne.allowsImportingAmbientModule(Ge, ii)) {
                    var mi = wr.getTypeChecker();
                    Er.add(e.getUniqueSymbolId(yr, mi).toString(), { symbol: yr, moduleSymbol: Ge, moduleFileName: ur == null ? void 0 : ur.fileName, exportKind: Ir, targetFlags: e.skipAlias(yr, mi).flags, isFromPackageJson: Ur });
                  }
                }
                return e.forEachExternalModuleToImportFrom(er, Cr, ir, function(Ge, ur, yr, Ir) {
                  var wr = yr.getTypeChecker();
                  ye.throwIfCancellationRequested();
                  var Ur = yr.getCompilerOptions(), ii = e.getDefaultLikeExportInfo(Ge, wr, Ur);
                  ii && (ii.name === _e || rr(Ge, e.getEmitScriptTarget(Ur), we) === _e) && He(ii.symbolForMeaning, de) && be(Ge, ur, ii.symbol, ii.exportKind, yr, Ir);
                  var mi = wr.tryGetMemberInModuleExportsAndProperties(_e, Ge);
                  mi && He(mi, de) && be(Ge, ur, mi, 0, yr, Ir);
                }), Er;
              }
              function D(_e, we, de) {
                var ye = e.getAllowSyntheticDefaultImports(we), Ae = e.isInJSFile(_e);
                if (!Ae && e.getEmitModuleKind(we) >= e.ModuleKind.ES2015) return ye ? 1 : 2;
                if (Ae) return e.isExternalModule(_e) || de ? ye ? 1 : 2 : 3;
                for (var er = 0, ir = _e.statements; er < ir.length; er++) {
                  var Cr = ir[er];
                  if (e.isImportEqualsDeclaration(Cr) && !e.nodeIsMissing(Cr.moduleReference)) return 3;
                }
                return ye ? 1 : 3;
              }
              function fe(_e, we, de, ye, Ae, er, ir) {
                var Cr, Ye = e.textChanges.ChangeTracker.with(_e, function(Br) {
                  Cr = g(Br, we, de, ye, Ae, er, ir);
                });
                return C.createCodeFixAction(C.importFixName, Ye, Cr, w, e.Diagnostics.Add_all_missing_imports);
              }
              function g(_e, we, de, ye, Ae, er, ir) {
                switch (ye.kind) {
                  case 0:
                    return Fe(_e, we, ye), [e.Diagnostics.Change_0_to_1, de, "".concat(ye.namespacePrefix, ".").concat(de)];
                  case 1:
                    return Z(_e, we, ye, er), [e.Diagnostics.Change_0_to_1, de, Be(ye.moduleSpecifier, er) + de];
                  case 2: {
                    var Cr = ye.importClauseOrBindingPattern, Ye = ye.importKind, Br = ye.addAsTypeOnly, Er = ye.moduleSpecifier;
                    We(_e, we, Cr, Ye === 1 ? { name: de, addAsTypeOnly: Br } : void 0, Ye === 0 ? [{ name: de, addAsTypeOnly: Br }] : e.emptyArray, ir);
                    var Ne = e.stripQuotes(Er);
                    return Ae ? [e.Diagnostics.Import_0_from_1, de, Ne] : [e.Diagnostics.Update_import_from_0, Ne];
                  }
                  case 3: {
                    var Ye = ye.importKind, Er = ye.moduleSpecifier, Br = ye.addAsTypeOnly, n = ye.useRequire, lr = n ? ze : Re, be = Ye === 1 ? { name: de, addAsTypeOnly: Br } : void 0, Ge = Ye === 0 ? [{ name: de, addAsTypeOnly: Br }] : void 0, ur = Ye === 2 || Ye === 3 ? { importKind: Ye, name: de, addAsTypeOnly: Br } : void 0;
                    return e.insertImports(_e, we, lr(Er, er, be, Ge, ur), true), Ae ? [e.Diagnostics.Import_0_from_1, de, Er] : [e.Diagnostics.Add_import_from_0, Er];
                  }
                  case 4: {
                    var yr = ye.typeOnlyAliasDeclaration, Ir = ue(_e, yr, ir, we);
                    return Ir.kind === 270 ? [e.Diagnostics.Remove_type_from_import_of_0_from_1, de, ne(Ir.parent.parent)] : [e.Diagnostics.Remove_type_from_import_declaration_from_0, ne(Ir)];
                  }
                  default:
                    return e.Debug.assertNever(ye, "Unexpected fix kind ".concat(ye.kind));
                }
              }
              function ne(_e) {
                var we, de;
                return _e.kind === 265 ? ((de = e.tryCast((we = e.tryCast(_e.moduleReference, e.isExternalModuleReference)) === null || we === void 0 ? void 0 : we.expression, e.isStringLiteralLike)) === null || de === void 0 ? void 0 : de.text) || _e.moduleReference.getText() : e.cast(_e.parent.moduleSpecifier, e.isStringLiteral).text;
              }
              function ue(_e, we, de, ye) {
                var Ae = de.preserveValueImports && de.isolatedModules;
                switch (we.kind) {
                  case 270:
                    if (we.isTypeOnly) {
                      if (we.parent.elements.length > 1 && e.OrganizeImports.importSpecifiersAreSorted(we.parent.elements)) {
                        _e.delete(ye, we);
                        var er = e.factory.updateImportSpecifier(we, false, we.propertyName, we.name), ir = e.OrganizeImports.getImportSpecifierInsertionIndex(we.parent.elements, er);
                        _e.insertImportSpecifierAtIndex(ye, er, we.parent, ir);
                      } else _e.deleteRange(ye, we.getFirstToken());
                      return we;
                    } else return e.Debug.assert(we.parent.parent.isTypeOnly), Cr(we.parent.parent), we.parent.parent;
                  case 267:
                    return Cr(we), we;
                  case 268:
                    return Cr(we.parent), we.parent;
                  case 265:
                    return _e.deleteRange(ye, we.getChildAt(1)), we;
                  default:
                    e.Debug.failBadSyntaxKind(we);
                }
                function Cr(Ye) {
                  if (_e.delete(ye, e.getTypeKeywordOfTypeOnlyImport(Ye, ye)), Ae) {
                    var Br = e.tryCast(Ye.namedBindings, e.isNamedImports);
                    if (Br && Br.elements.length > 1) {
                      e.OrganizeImports.importSpecifiersAreSorted(Br.elements) && we.kind === 270 && Br.elements.indexOf(we) !== 0 && (_e.delete(ye, we), _e.insertImportSpecifierAtIndex(ye, we, Br, 0));
                      for (var Er = 0, Ne = Br.elements; Er < Ne.length; Er++) {
                        var n = Ne[Er];
                        n !== we && !n.isTypeOnly && _e.insertModifierBefore(ye, 152, n);
                      }
                    }
                  }
                }
              }
              function We(_e, we, de, ye, Ae, er) {
                var ir;
                if (de.kind === 201) {
                  ye && pe(de, ye.name, "default");
                  for (var Cr = 0, Ye = Ae; Cr < Ye.length; Cr++) {
                    var Br = Ye[Cr];
                    pe(de, Br.name, void 0);
                  }
                  return;
                }
                var Er = de.isTypeOnly && e.some(Ve([ye], Ae, true), function(or) {
                  return (or == null ? void 0 : or.addAsTypeOnly) === 4;
                }), Ne = de.namedBindings && ((ir = e.tryCast(de.namedBindings, e.isNamedImports)) === null || ir === void 0 ? void 0 : ir.elements), n = Er && er.preserveValueImports && er.isolatedModules;
                if (ye && (e.Debug.assert(!de.name, "Cannot add a default import to an import clause that already has one"), _e.insertNodeAt(we, de.getStart(we), e.factory.createIdentifier(ye.name), { suffix: ", " })), Ae.length) {
                  var lr = e.stableSort(Ae.map(function(or) {
                    return e.factory.createImportSpecifier((!de.isTypeOnly || Er) && ge(or), void 0, e.factory.createIdentifier(or.name));
                  }), e.OrganizeImports.compareImportOrExportSpecifiers);
                  if ((Ne == null ? void 0 : Ne.length) && e.OrganizeImports.importSpecifiersAreSorted(Ne)) for (var be = 0, Ge = lr; be < Ge.length; be++) {
                    var ur = Ge[be], yr = n && !ur.isTypeOnly ? 0 : e.OrganizeImports.getImportSpecifierInsertionIndex(Ne, ur);
                    _e.insertImportSpecifierAtIndex(we, ur, de.namedBindings, yr);
                  }
                  else if (Ne != null && Ne.length) for (var Ir = 0, wr = lr; Ir < wr.length; Ir++) {
                    var ur = wr[Ir];
                    _e.insertNodeInListAfter(we, e.last(Ne), ur, Ne);
                  }
                  else if (lr.length) {
                    var Ur = e.factory.createNamedImports(lr);
                    de.namedBindings ? _e.replaceNode(we, de.namedBindings, Ur) : _e.insertNodeAfter(we, e.Debug.checkDefined(de.name, "Import clause must have either named imports or a default import"), Ur);
                  }
                }
                if (Er && (_e.delete(we, e.getTypeKeywordOfTypeOnlyImport(de, we)), n && Ne)) for (var ii = 0, mi = Ne; ii < mi.length; ii++) {
                  var Br = mi[ii];
                  _e.insertModifierBefore(we, 152, Br);
                }
                function pe(or, qr, si) {
                  var Di = e.factory.createBindingElement(void 0, si, qr);
                  or.elements.length ? _e.insertNodeInListAfter(we, e.last(or.elements), Di) : _e.replaceNode(we, or, e.factory.createObjectBindingPattern([Di]));
                }
              }
              function Fe(_e, we, de) {
                var ye = de.namespacePrefix, Ae = de.position;
                _e.insertText(we, Ae, ye + ".");
              }
              function Z(_e, we, de, ye) {
                var Ae = de.moduleSpecifier, er = de.position;
                _e.insertText(we, er, Be(Ae, ye));
              }
              function Be(_e, we) {
                var de = e.getQuoteFromPreference(we);
                return "import(".concat(de).concat(_e).concat(de, ").");
              }
              function ge(_e) {
                var we = _e.addAsTypeOnly;
                return we === 2;
              }
              function Re(_e, we, de, ye, Ae) {
                var er = e.makeStringLiteral(_e, we), ir;
                if (de !== void 0 || (ye == null ? void 0 : ye.length)) {
                  var Cr = (!de || ge(de)) && e.every(ye, ge);
                  ir = e.combine(ir, e.makeImport(de && e.factory.createIdentifier(de.name), ye == null ? void 0 : ye.map(function(Br) {
                    var Er = Br.addAsTypeOnly, Ne = Br.name;
                    return e.factory.createImportSpecifier(!Cr && Er === 2, void 0, e.factory.createIdentifier(Ne));
                  }), _e, we, Cr));
                }
                if (Ae) {
                  var Ye = Ae.importKind === 3 ? e.factory.createImportEqualsDeclaration(void 0, void 0, ge(Ae), e.factory.createIdentifier(Ae.name), e.factory.createExternalModuleReference(er)) : e.factory.createImportDeclaration(void 0, void 0, e.factory.createImportClause(ge(Ae), void 0, e.factory.createNamespaceImport(e.factory.createIdentifier(Ae.name))), er, void 0);
                  ir = e.combine(ir, Ye);
                }
                return e.Debug.checkDefined(ir);
              }
              function ze(_e, we, de, ye, Ae) {
                var er = e.makeStringLiteral(_e, we), ir;
                if (de || (ye == null ? void 0 : ye.length)) {
                  var Cr = (ye == null ? void 0 : ye.map(function(Br) {
                    var Er = Br.name;
                    return e.factory.createBindingElement(void 0, void 0, Er);
                  })) || [];
                  de && Cr.unshift(e.factory.createBindingElement(void 0, "default", de.name));
                  var Ye = Ee(e.factory.createObjectBindingPattern(Cr), er);
                  ir = e.combine(ir, Ye);
                }
                if (Ae) {
                  var Ye = Ee(Ae.name, er);
                  ir = e.combine(ir, Ye);
                }
                return e.Debug.checkDefined(ir);
              }
              function Ee(_e, we) {
                return e.factory.createVariableStatement(void 0, e.factory.createVariableDeclarationList([e.factory.createVariableDeclaration(typeof _e == "string" ? e.factory.createIdentifier(_e) : _e, void 0, void 0, e.factory.createCallExpression(e.factory.createIdentifier("require"), void 0, [we]))], 2));
              }
              function He(_e, we) {
                var de = _e.declarations;
                return e.some(de, function(ye) {
                  return !!(e.getMeaningFromDeclaration(ye) & we);
                });
              }
              function rr(_e, we, de) {
                return Ie(e.removeFileExtension(e.stripQuotes(_e.name)), we, de);
              }
              C.moduleSymbolToValidIdentifier = rr;
              function Ie(_e, we, de) {
                var ye = e.getBaseFileName(e.removeSuffix(_e, "/index")), Ae = "", er = true, ir = ye.charCodeAt(0);
                e.isIdentifierStart(ir, we) ? (Ae += String.fromCharCode(ir), de && (Ae = Ae.toUpperCase())) : er = false;
                for (var Cr = 1; Cr < ye.length; Cr++) {
                  var Ye = ye.charCodeAt(Cr), Br = e.isIdentifierPart(Ye, we);
                  if (Br) {
                    var Er = String.fromCharCode(Ye);
                    er || (Er = Er.toUpperCase()), Ae += Er;
                  }
                  er = Br;
                }
                return e.isStringANonContextualKeyword(Ae) ? "_".concat(Ae) : Ae || "_";
              }
              C.moduleSpecifierToValidIdentifier = Ie;
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w, B = "fixOverrideModifier", E = "fixAddOverrideModifier", Q = "fixRemoveOverrideModifier", le = [e.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code, e.Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code, e.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code, e.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code, e.Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code, e.Diagnostics.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code, e.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code, e.Diagnostics.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code, e.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code], N = (w = {}, w[e.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code] = { descriptions: e.Diagnostics.Add_override_modifier, fixId: E, fixAllDescriptions: e.Diagnostics.Add_all_missing_override_modifiers }, w[e.Diagnostics.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code] = { descriptions: e.Diagnostics.Add_override_modifier, fixId: E, fixAllDescriptions: e.Diagnostics.Add_all_missing_override_modifiers }, w[e.Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code] = { descriptions: e.Diagnostics.Remove_override_modifier, fixId: Q, fixAllDescriptions: e.Diagnostics.Remove_all_unnecessary_override_modifiers }, w[e.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code] = { descriptions: e.Diagnostics.Remove_override_modifier, fixId: Q, fixAllDescriptions: e.Diagnostics.Remove_override_modifier }, w[e.Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code] = { descriptions: e.Diagnostics.Add_override_modifier, fixId: E, fixAllDescriptions: e.Diagnostics.Add_all_missing_override_modifiers }, w[e.Diagnostics.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code] = { descriptions: e.Diagnostics.Add_override_modifier, fixId: E, fixAllDescriptions: e.Diagnostics.Add_all_missing_override_modifiers }, w[e.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code] = { descriptions: e.Diagnostics.Add_override_modifier, fixId: E, fixAllDescriptions: e.Diagnostics.Remove_all_unnecessary_override_modifiers }, w[e.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code] = { descriptions: e.Diagnostics.Remove_override_modifier, fixId: Q, fixAllDescriptions: e.Diagnostics.Remove_all_unnecessary_override_modifiers }, w[e.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code] = { descriptions: e.Diagnostics.Remove_override_modifier, fixId: Q, fixAllDescriptions: e.Diagnostics.Remove_all_unnecessary_override_modifiers }, w);
              C.registerCodeFix({ errorCodes: le, getCodeActions: function(K) {
                var b = K.errorCode, se = K.span, J = N[b];
                if (!J) return e.emptyArray;
                var ie = J.descriptions, R = J.fixId, q = J.fixAllDescriptions, O = e.textChanges.ChangeTracker.with(K, function(ve) {
                  return p(ve, K, b, se.start);
                });
                return [C.createCodeFixActionMaybeFixAll(B, O, ie, R, q)];
              }, fixIds: [B, E, Q], getAllCodeActions: function(T) {
                return C.codeFixAll(T, le, function(K, b) {
                  var se = b.code, J = b.start, ie = N[se];
                  !ie || ie.fixId !== T.fixId || p(K, T, se, J);
                });
              } });
              function p(T, K, b, se) {
                switch (b) {
                  case e.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code:
                  case e.Diagnostics.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code:
                  case e.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code:
                  case e.Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code:
                  case e.Diagnostics.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code:
                    return m(T, K.sourceFile, se);
                  case e.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code:
                  case e.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code:
                  case e.Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code:
                  case e.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code:
                    return G(T, K.sourceFile, se);
                  default:
                    e.Debug.fail("Unexpected error code: " + b);
                }
              }
              function m(T, K, b) {
                var se = f(K, b);
                if (e.isSourceFileJS(K)) {
                  T.addJSDocTags(K, se, [e.factory.createJSDocOverrideTag(e.factory.createIdentifier("override"))]);
                  return;
                }
                var J = se.modifiers || e.emptyArray, ie = e.find(J, e.isStaticModifier), R = e.find(J, e.isAbstractModifier), q = e.find(J, function(ee) {
                  return e.isAccessibilityModifier(ee.kind);
                }), O = R ? R.end : ie ? ie.end : q ? q.end : se.decorators ? e.skipTrivia(K.text, se.decorators.end) : se.getStart(K), ve = q || ie || R ? { prefix: " " } : { suffix: " " };
                T.insertModifierAt(K, O, 159, ve);
              }
              function G(T, K, b) {
                var se = f(K, b);
                if (e.isSourceFileJS(K)) {
                  T.filterJSDocTags(K, se, e.not(e.isJSDocOverrideTag));
                  return;
                }
                var J = se.modifiers && e.find(se.modifiers, function(ie) {
                  return ie.kind === 159;
                });
                e.Debug.assertIsDefined(J), T.deleteModifier(K, J);
              }
              function oe(T) {
                switch (T.kind) {
                  case 171:
                  case 167:
                  case 169:
                  case 172:
                  case 173:
                    return true;
                  case 164:
                    return e.isParameterPropertyDeclaration(T, T.parent);
                  default:
                    return false;
                }
              }
              function f(T, K) {
                var b = e.getTokenAtPosition(T, K), se = e.findAncestor(b, function(J) {
                  return e.isClassLike(J) ? "quit" : oe(J);
                });
                return e.Debug.assert(se && oe(se)), se;
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixNoPropertyAccessFromIndexSignature", B = [e.Diagnostics.Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0.code];
              C.registerCodeFix({ errorCodes: B, fixIds: [w], getCodeActions: function(le) {
                var N = le.sourceFile, p = le.span, m = le.preferences, G = Q(N, p.start), oe = e.textChanges.ChangeTracker.with(le, function(f) {
                  return E(f, le.sourceFile, G, m);
                });
                return [C.createCodeFixAction(w, oe, [e.Diagnostics.Use_element_access_for_0, G.name.text], w, e.Diagnostics.Use_element_access_for_all_undeclared_properties)];
              }, getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  return E(N, p.file, Q(p.file, p.start), le.preferences);
                });
              } });
              function E(le, N, p, m) {
                var G = e.getQuotePreference(N, m), oe = e.factory.createStringLiteral(p.name.text, G === 0);
                le.replaceNode(N, p, e.isPropertyAccessChain(p) ? e.factory.createElementAccessChain(p.expression, p.questionDotToken, oe) : e.factory.createElementAccessExpression(p.expression, oe));
              }
              function Q(le, N) {
                return e.cast(e.getTokenAtPosition(le, N).parent, e.isPropertyAccessExpression);
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixImplicitThis", B = [e.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = le.sourceFile, p = le.program, m = le.span, G, oe = e.textChanges.ChangeTracker.with(le, function(f) {
                  G = E(f, N, m.start, p.getTypeChecker());
                });
                return G ? [C.createCodeFixAction(w, oe, G, w, e.Diagnostics.Fix_all_implicit_this_errors)] : e.emptyArray;
              }, fixIds: [w], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, B, function(le, N) {
                  E(le, N.file, N.start, Q.program.getTypeChecker());
                });
              } });
              function E(Q, le, N, p) {
                var m = e.getTokenAtPosition(le, N);
                if (!!e.isThis(m)) {
                  var G = e.getThisContainer(m, false);
                  if (!(!e.isFunctionDeclaration(G) && !e.isFunctionExpression(G)) && !e.isSourceFile(e.getThisContainer(G, false))) {
                    var oe = e.Debug.checkDefined(e.findChildOfKind(G, 98, le)), f = G.name, T = e.Debug.checkDefined(G.body);
                    return e.isFunctionExpression(G) ? f && e.FindAllReferences.Core.isSymbolReferencedInFile(f, p, le, T) ? void 0 : (Q.delete(le, oe), f && Q.delete(le, f), Q.insertText(le, T.pos, " =>"), [e.Diagnostics.Convert_function_expression_0_to_arrow_function, f ? f.text : e.ANONYMOUS]) : (Q.replaceNode(le, oe, e.factory.createToken(85)), Q.insertText(le, f.end, " = "), Q.insertText(le, T.pos, " =>"), [e.Diagnostics.Convert_function_declaration_0_to_arrow_function, f.text]);
                  }
                }
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixIncorrectNamedTupleSyntax", B = [e.Diagnostics.A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type.code, e.Diagnostics.A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(N) {
                var p = N.sourceFile, m = N.span, G = E(p, m.start), oe = e.textChanges.ChangeTracker.with(N, function(f) {
                  return Q(f, p, G);
                });
                return [C.createCodeFixAction(w, oe, e.Diagnostics.Move_labeled_tuple_element_modifiers_to_labels, w, e.Diagnostics.Move_labeled_tuple_element_modifiers_to_labels)];
              }, fixIds: [w] });
              function E(le, N) {
                var p = e.getTokenAtPosition(le, N);
                return e.findAncestor(p, function(m) {
                  return m.kind === 197;
                });
              }
              function Q(le, N, p) {
                if (!!p) {
                  for (var m = p.type, G = false, oe = false; m.kind === 185 || m.kind === 186 || m.kind === 191; ) m.kind === 185 ? G = true : m.kind === 186 && (oe = true), m = m.type;
                  var f = e.factory.updateNamedTupleMember(p, p.dotDotDotToken || (oe ? e.factory.createToken(25) : void 0), p.name, p.questionToken || (G ? e.factory.createToken(57) : void 0), m);
                  f !== p && le.replaceNode(N, p, f);
                }
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixSpelling", B = [e.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code, e.Diagnostics.Property_0_may_not_exist_on_type_1_Did_you_mean_2.code, e.Diagnostics.Cannot_find_name_0_Did_you_mean_1.code, e.Diagnostics.Could_not_find_name_0_Did_you_mean_1.code, e.Diagnostics.Cannot_find_namespace_0_Did_you_mean_1.code, e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code, e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code, e.Diagnostics._0_has_no_exported_member_named_1_Did_you_mean_2.code, e.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1.code, e.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1.code, e.Diagnostics.No_overload_matches_this_call.code, e.Diagnostics.Type_0_is_not_assignable_to_type_1.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(p) {
                var m = p.sourceFile, G = p.errorCode, oe = E(m, p.span.start, p, G);
                if (!!oe) {
                  var f = oe.node, T = oe.suggestedSymbol, K = e.getEmitScriptTarget(p.host.getCompilationSettings()), b = e.textChanges.ChangeTracker.with(p, function(se) {
                    return Q(se, m, f, T, K);
                  });
                  return [C.createCodeFixAction("spelling", b, [e.Diagnostics.Change_spelling_to_0, e.symbolName(T)], w, e.Diagnostics.Fix_all_detected_spelling_errors)];
                }
              }, fixIds: [w], getAllCodeActions: function(p) {
                return C.codeFixAll(p, B, function(m, G) {
                  var oe = E(G.file, G.start, p, G.code), f = e.getEmitScriptTarget(p.host.getCompilationSettings());
                  oe && Q(m, p.sourceFile, oe.node, oe.suggestedSymbol, f);
                });
              } });
              function E(p, m, G, oe) {
                var f = e.getTokenAtPosition(p, m), T = f.parent;
                if (!((oe === e.Diagnostics.No_overload_matches_this_call.code || oe === e.Diagnostics.Type_0_is_not_assignable_to_type_1.code) && !e.isJsxAttribute(T))) {
                  var K = G.program.getTypeChecker(), b;
                  if (e.isPropertyAccessExpression(T) && T.name === f) {
                    e.Debug.assert(e.isMemberName(f), "Expected an identifier for spelling (property access)");
                    var se = K.getTypeAtLocation(T.expression);
                    T.flags & 32 && (se = K.getNonNullableType(se)), b = K.getSuggestedSymbolForNonexistentProperty(f, se);
                  } else if (e.isBinaryExpression(T) && T.operatorToken.kind === 101 && T.left === f && e.isPrivateIdentifier(f)) {
                    var J = K.getTypeAtLocation(T.right);
                    b = K.getSuggestedSymbolForNonexistentProperty(f, J);
                  } else if (e.isQualifiedName(T) && T.right === f) {
                    var ie = K.getSymbolAtLocation(T.left);
                    ie && ie.flags & 1536 && (b = K.getSuggestedSymbolForNonexistentModule(T.right, ie));
                  } else if (e.isImportSpecifier(T) && T.name === f) {
                    e.Debug.assertNode(f, e.isIdentifier, "Expected an identifier for spelling (import)");
                    var R = e.findAncestor(f, e.isImportDeclaration), q = N(p, G, R);
                    q && q.symbol && (b = K.getSuggestedSymbolForNonexistentModule(f, q.symbol));
                  } else if (e.isJsxAttribute(T) && T.name === f) {
                    e.Debug.assertNode(f, e.isIdentifier, "Expected an identifier for JSX attribute");
                    var O = e.findAncestor(f, e.isJsxOpeningLikeElement), ve = K.getContextualTypeForArgumentAtIndex(O, 0);
                    b = K.getSuggestedSymbolForNonexistentJSXAttribute(f, ve);
                  } else if (e.hasSyntacticModifier(T, 16384) && e.isClassElement(T) && T.name === f) {
                    var ee = e.findAncestor(f, e.isClassLike), he = ee ? e.getEffectiveBaseTypeNode(ee) : void 0, F = he ? K.getTypeAtLocation(he) : void 0;
                    F && (b = K.getSuggestedSymbolForNonexistentClassMember(e.getTextOfNode(f), F));
                  } else {
                    var x = e.getMeaningFromLocation(f), X = e.getTextOfNode(f);
                    e.Debug.assert(X !== void 0, "name should be defined"), b = K.getSuggestedSymbolForNonexistentSymbol(f, X, le(x));
                  }
                  return b === void 0 ? void 0 : { node: f, suggestedSymbol: b };
                }
              }
              function Q(p, m, G, oe, f) {
                var T = e.symbolName(oe);
                if (!e.isIdentifierText(T, f) && e.isPropertyAccessExpression(G.parent)) {
                  var K = oe.valueDeclaration;
                  K && e.isNamedDeclaration(K) && e.isPrivateIdentifier(K.name) ? p.replaceNode(m, G, e.factory.createIdentifier(T)) : p.replaceNode(m, G.parent, e.factory.createElementAccessExpression(G.parent.expression, e.factory.createStringLiteral(T)));
                } else p.replaceNode(m, G, e.factory.createIdentifier(T));
              }
              function le(p) {
                var m = 0;
                return p & 4 && (m |= 1920), p & 2 && (m |= 788968), p & 1 && (m |= 111551), m;
              }
              function N(p, m, G) {
                if (!(!G || !e.isStringLiteralLike(G.moduleSpecifier))) {
                  var oe = e.getResolvedModule(p, G.moduleSpecifier.text, e.getModeForUsageLocation(p, G.moduleSpecifier));
                  if (!!oe) return m.program.getSourceFile(oe.resolvedFileName);
                }
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "returnValueCorrect", B = "fixAddReturnStatement", E = "fixRemoveBracesFromArrowFunctionBody", Q = "fixWrapTheBlockWithParen", le = [e.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value.code, e.Diagnostics.Type_0_is_not_assignable_to_type_1.code, e.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code], N;
              (function(R) {
                R[R.MissingReturnStatement = 0] = "MissingReturnStatement", R[R.MissingParentheses = 1] = "MissingParentheses";
              })(N || (N = {})), C.registerCodeFix({ errorCodes: le, fixIds: [B, E, Q], getCodeActions: function(q) {
                var O = q.program, ve = q.sourceFile, ee = q.span.start, he = q.errorCode, F = oe(O.getTypeChecker(), ve, ee, he);
                if (!!F) return F.kind === N.MissingReturnStatement ? e.append([se(q, F.expression, F.statement)], e.isArrowFunction(F.declaration) ? J(q, F.declaration, F.expression, F.commentSource) : void 0) : [ie(q, F.declaration, F.expression)];
              }, getAllCodeActions: function(R) {
                return C.codeFixAll(R, le, function(q, O) {
                  var ve = oe(R.program.getTypeChecker(), O.file, O.start, O.code);
                  if (!!ve) switch (R.fixId) {
                    case B:
                      T(q, O.file, ve.expression, ve.statement);
                      break;
                    case E:
                      if (!e.isArrowFunction(ve.declaration)) return;
                      K(q, O.file, ve.declaration, ve.expression, ve.commentSource, false);
                      break;
                    case Q:
                      if (!e.isArrowFunction(ve.declaration)) return;
                      b(q, O.file, ve.declaration, ve.expression);
                      break;
                    default:
                      e.Debug.fail(JSON.stringify(R.fixId));
                  }
                });
              } });
              function p(R, q, O) {
                var ve = R.createSymbol(4, q.escapedText);
                ve.type = R.getTypeAtLocation(O);
                var ee = e.createSymbolTable([ve]);
                return R.createAnonymousType(void 0, ee, [], [], []);
              }
              function m(R, q, O, ve) {
                if (!(!q.body || !e.isBlock(q.body) || e.length(q.body.statements) !== 1)) {
                  var ee = e.first(q.body.statements);
                  if (e.isExpressionStatement(ee) && G(R, q, R.getTypeAtLocation(ee.expression), O, ve)) return { declaration: q, kind: N.MissingReturnStatement, expression: ee.expression, statement: ee, commentSource: ee.expression };
                  if (e.isLabeledStatement(ee) && e.isExpressionStatement(ee.statement)) {
                    var he = e.factory.createObjectLiteralExpression([e.factory.createPropertyAssignment(ee.label, ee.statement.expression)]), F = p(R, ee.label, ee.statement.expression);
                    if (G(R, q, F, O, ve)) return e.isArrowFunction(q) ? { declaration: q, kind: N.MissingParentheses, expression: he, statement: ee, commentSource: ee.statement.expression } : { declaration: q, kind: N.MissingReturnStatement, expression: he, statement: ee, commentSource: ee.statement.expression };
                  } else if (e.isBlock(ee) && e.length(ee.statements) === 1) {
                    var x = e.first(ee.statements);
                    if (e.isLabeledStatement(x) && e.isExpressionStatement(x.statement)) {
                      var he = e.factory.createObjectLiteralExpression([e.factory.createPropertyAssignment(x.label, x.statement.expression)]), F = p(R, x.label, x.statement.expression);
                      if (G(R, q, F, O, ve)) return { declaration: q, kind: N.MissingReturnStatement, expression: he, statement: ee, commentSource: x };
                    }
                  }
                }
              }
              function G(R, q, O, ve, ee) {
                if (ee) {
                  var he = R.getSignatureFromDeclaration(q);
                  if (he) {
                    e.hasSyntacticModifier(q, 256) && (O = R.createPromiseType(O));
                    var F = R.createSignature(q, he.typeParameters, he.thisParameter, he.parameters, O, void 0, he.minArgumentCount, he.flags);
                    O = R.createAnonymousType(void 0, e.createSymbolTable(), [F], [], []);
                  } else O = R.getAnyType();
                }
                return R.isTypeAssignableTo(O, ve);
              }
              function oe(R, q, O, ve) {
                var ee = e.getTokenAtPosition(q, O);
                if (!!ee.parent) {
                  var he = e.findAncestor(ee.parent, e.isFunctionLikeDeclaration);
                  switch (ve) {
                    case e.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value.code:
                      return !he || !he.body || !he.type || !e.rangeContainsRange(he.type, ee) ? void 0 : m(R, he, R.getTypeFromTypeNode(he.type), false);
                    case e.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code:
                      if (!he || !e.isCallExpression(he.parent) || !he.body) return;
                      var F = he.parent.arguments.indexOf(he), x = R.getContextualTypeForArgumentAtIndex(he.parent, F);
                      return x ? m(R, he, x, true) : void 0;
                    case e.Diagnostics.Type_0_is_not_assignable_to_type_1.code:
                      if (!e.isDeclarationName(ee) || !e.isVariableLike(ee.parent) && !e.isJsxAttribute(ee.parent)) return;
                      var X = f(ee.parent);
                      return !X || !e.isFunctionLikeDeclaration(X) || !X.body ? void 0 : m(R, X, R.getTypeAtLocation(ee.parent), true);
                  }
                }
              }
              function f(R) {
                switch (R.kind) {
                  case 254:
                  case 164:
                  case 203:
                  case 167:
                  case 296:
                    return R.initializer;
                  case 285:
                    return R.initializer && (e.isJsxExpression(R.initializer) ? R.initializer.expression : void 0);
                  case 297:
                  case 166:
                  case 299:
                  case 347:
                  case 340:
                    return;
                }
              }
              function T(R, q, O, ve) {
                e.suppressLeadingAndTrailingTrivia(O);
                var ee = e.probablyUsesSemicolons(q);
                R.replaceNode(q, ve, e.factory.createReturnStatement(O), { leadingTriviaOption: e.textChanges.LeadingTriviaOption.Exclude, trailingTriviaOption: e.textChanges.TrailingTriviaOption.Exclude, suffix: ee ? ";" : void 0 });
              }
              function K(R, q, O, ve, ee, he) {
                var F = he || e.needsParentheses(ve) ? e.factory.createParenthesizedExpression(ve) : ve;
                e.suppressLeadingAndTrailingTrivia(ee), e.copyComments(ee, F), R.replaceNode(q, O.body, F);
              }
              function b(R, q, O, ve) {
                R.replaceNode(q, O.body, e.factory.createParenthesizedExpression(ve));
              }
              function se(R, q, O) {
                var ve = e.textChanges.ChangeTracker.with(R, function(ee) {
                  return T(ee, R.sourceFile, q, O);
                });
                return C.createCodeFixAction(w, ve, e.Diagnostics.Add_a_return_statement, B, e.Diagnostics.Add_all_missing_return_statement);
              }
              function J(R, q, O, ve) {
                var ee = e.textChanges.ChangeTracker.with(R, function(he) {
                  return K(he, R.sourceFile, q, O, ve, false);
                });
                return C.createCodeFixAction(w, ee, e.Diagnostics.Remove_braces_from_arrow_function_body, E, e.Diagnostics.Remove_braces_from_all_arrow_function_bodies_with_relevant_issues);
              }
              function ie(R, q, O) {
                var ve = e.textChanges.ChangeTracker.with(R, function(ee) {
                  return b(ee, R.sourceFile, q, O);
                });
                return C.createCodeFixAction(w, ve, e.Diagnostics.Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal, Q, e.Diagnostics.Wrap_all_object_literal_with_parentheses);
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixMissingMember", B = "fixMissingProperties", E = "fixMissingAttributes", Q = "fixMissingFunctionDeclaration", le = [e.Diagnostics.Property_0_does_not_exist_on_type_1.code, e.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code, e.Diagnostics.Property_0_is_missing_in_type_1_but_required_in_type_2.code, e.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2.code, e.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more.code, e.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code, e.Diagnostics.Cannot_find_name_0.code];
              C.registerCodeFix({ errorCodes: le, getCodeActions: function(y) {
                var V = y.program.getTypeChecker(), L = p(y.sourceFile, y.span.start, y.errorCode, V, y.program);
                if (!!L) {
                  if (L.kind === 3) {
                    var P = e.textChanges.ChangeTracker.with(y, function(k) {
                      return he(k, y, L);
                    });
                    return [C.createCodeFixAction(B, P, e.Diagnostics.Add_missing_properties, B, e.Diagnostics.Add_all_missing_properties)];
                  }
                  if (L.kind === 4) {
                    var P = e.textChanges.ChangeTracker.with(y, function(Y) {
                      return ee(Y, y, L);
                    });
                    return [C.createCodeFixAction(E, P, e.Diagnostics.Add_missing_attributes, E, e.Diagnostics.Add_all_missing_attributes)];
                  }
                  if (L.kind === 2) {
                    var P = e.textChanges.ChangeTracker.with(y, function(Y) {
                      return ve(Y, y, L);
                    });
                    return [C.createCodeFixAction(Q, P, [e.Diagnostics.Add_missing_function_declaration_0, L.token.text], Q, e.Diagnostics.Add_all_missing_function_declarations)];
                  }
                  if (L.kind === 1) {
                    var P = e.textChanges.ChangeTracker.with(y, function(Y) {
                      return O(Y, y.program.getTypeChecker(), L);
                    });
                    return [C.createCodeFixAction(w, P, [e.Diagnostics.Add_missing_enum_member_0, L.token.text], w, e.Diagnostics.Add_all_missing_members)];
                  }
                  return e.concatenate(R(y, L), G(y, L));
                }
              }, fixIds: [w, Q, B, E], getAllCodeActions: function(y) {
                var V = y.program, L = y.fixId, P = V.getTypeChecker(), k = new e.Map(), Y = new e.Map();
                return C.createCombinedCodeActions(e.textChanges.ChangeTracker.with(y, function(U) {
                  C.eachDiagnostic(y, le, function(j) {
                    var H = p(j.file, j.start, j.code, P, y.program);
                    if (!(!H || !e.addToSeen(k, e.getNodeId(H.parentDeclaration) + "#" + H.token.text))) {
                      if (L === Q && H.kind === 2) ve(U, y, H);
                      else if (L === B && H.kind === 3) he(U, y, H);
                      else if (L === E && H.kind === 4) ee(U, y, H);
                      else if (H.kind === 1 && O(U, P, H), H.kind === 0) {
                        var I = H.parentDeclaration, l = H.token, d = e.getOrUpdate(Y, I, function() {
                          return [];
                        });
                        d.some(function(D) {
                          return D.token.text === l.text;
                        }) || d.push(H);
                      }
                    }
                  }), Y.forEach(function(j, H) {
                    for (var I = e.isTypeLiteralNode(H) ? void 0 : C.getAllSupers(H, P), l = function(g) {
                      if (I != null && I.some(function(Re) {
                        var ze = Y.get(Re);
                        return !!ze && ze.some(function(Ee) {
                          var He = Ee.token;
                          return He.text === g.token.text;
                        });
                      })) return "continue";
                      var ne = g.parentDeclaration, ue = g.declSourceFile, We = g.modifierFlags, Fe = g.token, Z = g.call, Be = g.isJSFile;
                      if (Z && !e.isPrivateIdentifier(Fe)) q(y, U, Z, Fe, We & 32, ne, ue);
                      else if (Be && !e.isInterfaceDeclaration(ne) && !e.isTypeLiteralNode(ne)) f(U, ue, ne, Fe, !!(We & 32));
                      else {
                        var ge = b(P, ne, Fe);
                        se(U, ue, ne, Fe.text, ge, We & 32);
                      }
                    }, d = 0, D = j; d < D.length; d++) {
                      var fe = D[d];
                      l(fe);
                    }
                  });
                }));
              } });
              var N;
              (function(y) {
                y[y.TypeLikeDeclaration = 0] = "TypeLikeDeclaration", y[y.Enum = 1] = "Enum", y[y.Function = 2] = "Function", y[y.ObjectLiteral = 3] = "ObjectLiteral", y[y.JsxAttributes = 4] = "JsxAttributes";
              })(N || (N = {}));
              function p(y, V, L, P, k) {
                var Y = e.getTokenAtPosition(y, V), U = Y.parent;
                if (L === e.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code) {
                  if (!(Y.kind === 18 && e.isObjectLiteralExpression(U) && e.isCallExpression(U.parent))) return;
                  var j = e.findIndex(U.parent.arguments, function(rr) {
                    return rr === U;
                  });
                  if (j < 0) return;
                  var H = e.singleOrUndefined(P.getSignaturesOfType(P.getTypeAtLocation(U.parent.expression), 0));
                  if (!(H && H.declaration && H.parameters[j])) return;
                  var I = H.parameters[j].valueDeclaration;
                  if (!(I && e.isParameter(I) && e.isIdentifier(I.name))) return;
                  var l = e.arrayFrom(P.getUnmatchedProperties(P.getTypeAtLocation(U), P.getParameterType(H, j), false, false));
                  return e.length(l) ? { kind: 3, token: I.name, properties: l, parentDeclaration: U } : void 0;
                }
                if (!!e.isMemberName(Y)) {
                  if (e.isIdentifier(Y) && e.hasInitializer(U) && U.initializer && e.isObjectLiteralExpression(U.initializer)) {
                    var l = e.arrayFrom(P.getUnmatchedProperties(P.getTypeAtLocation(U.initializer), P.getTypeAtLocation(Y), false, false));
                    return e.length(l) ? { kind: 3, token: Y, properties: l, parentDeclaration: U.initializer } : void 0;
                  }
                  if (e.isIdentifier(Y) && e.isJsxOpeningLikeElement(Y.parent)) {
                    var d = e.getEmitScriptTarget(k.getCompilerOptions()), D = $(P, d, Y.parent);
                    return e.length(D) ? { kind: 4, token: Y, attributes: D, parentDeclaration: Y.parent } : void 0;
                  }
                  if (e.isIdentifier(Y) && e.isCallExpression(U)) return { kind: 2, token: Y, call: U, sourceFile: y, modifierFlags: 0, parentDeclaration: y };
                  if (!!e.isPropertyAccessExpression(U)) {
                    var fe = e.skipConstraint(P.getTypeAtLocation(U.expression)), g = fe.symbol;
                    if (!(!g || !g.declarations)) {
                      if (e.isIdentifier(Y) && e.isCallExpression(U.parent)) {
                        var ne = e.find(g.declarations, e.isModuleDeclaration), ue = ne == null ? void 0 : ne.getSourceFile();
                        if (ne && ue && !m(k, ue)) return { kind: 2, token: Y, call: U.parent, sourceFile: y, modifierFlags: 1, parentDeclaration: ne };
                        var We = e.find(g.declarations, e.isSourceFile);
                        if (y.commonJsModuleIndicator) return;
                        if (We && !m(k, We)) return { kind: 2, token: Y, call: U.parent, sourceFile: We, modifierFlags: 1, parentDeclaration: We };
                      }
                      var Fe = e.find(g.declarations, e.isClassLike);
                      if (!(!Fe && e.isPrivateIdentifier(Y))) {
                        var Z = Fe || e.find(g.declarations, function(rr) {
                          return e.isInterfaceDeclaration(rr) || e.isTypeLiteralNode(rr);
                        });
                        if (Z && !m(k, Z.getSourceFile())) {
                          var Be = !e.isTypeLiteralNode(Z) && (fe.target || fe) !== P.getDeclaredTypeOfSymbol(g);
                          if (Be && (e.isPrivateIdentifier(Y) || e.isInterfaceDeclaration(Z))) return;
                          var ge = Z.getSourceFile(), Re = e.isTypeLiteralNode(Z) ? 0 : (Be ? 32 : 0) | (e.startsWithUnderscore(Y.text) ? 8 : 0), ze = e.isSourceFileJS(ge), Ee = e.tryCast(U.parent, e.isCallExpression);
                          return { kind: 0, token: Y, call: Ee, modifierFlags: Re, parentDeclaration: Z, declSourceFile: ge, isJSFile: ze };
                        }
                        var He = e.find(g.declarations, e.isEnumDeclaration);
                        if (He && !e.isPrivateIdentifier(Y) && !m(k, He.getSourceFile())) return { kind: 1, token: Y, parentDeclaration: He };
                      }
                    }
                  }
                }
              }
              function m(y, V) {
                return y.isSourceFileFromExternalLibrary(V) || y.isSourceFileDefaultLibrary(V);
              }
              function G(y, V) {
                return V.isJSFile ? e.singleElementArray(oe(y, V)) : K(y, V);
              }
              function oe(y, V) {
                var L = V.parentDeclaration, P = V.declSourceFile, k = V.modifierFlags, Y = V.token;
                if (!(e.isInterfaceDeclaration(L) || e.isTypeLiteralNode(L))) {
                  var U = e.textChanges.ChangeTracker.with(y, function(H) {
                    return f(H, P, L, Y, !!(k & 32));
                  });
                  if (U.length !== 0) {
                    var j = k & 32 ? e.Diagnostics.Initialize_static_property_0 : e.isPrivateIdentifier(Y) ? e.Diagnostics.Declare_a_private_field_named_0 : e.Diagnostics.Initialize_property_0_in_the_constructor;
                    return C.createCodeFixAction(w, U, [j, Y.text], w, e.Diagnostics.Add_all_missing_members);
                  }
                }
              }
              function f(y, V, L, P, k) {
                var Y = P.text;
                if (k) {
                  if (L.kind === 226) return;
                  var U = L.name.getText(), j = T(e.factory.createIdentifier(U), Y);
                  y.insertNodeAfter(V, L, j);
                } else if (e.isPrivateIdentifier(P)) {
                  var H = e.factory.createPropertyDeclaration(void 0, void 0, Y, void 0, void 0, void 0), I = J(L);
                  I ? y.insertNodeAfter(V, I, H) : y.insertMemberAtStart(V, L, H);
                } else {
                  var l = e.getFirstConstructorWithBody(L);
                  if (!l) return;
                  var d = T(e.factory.createThis(), Y);
                  y.insertNodeAtConstructorEnd(V, l, d);
                }
              }
              function T(y, V) {
                return e.factory.createExpressionStatement(e.factory.createAssignment(e.factory.createPropertyAccessExpression(y, V), x()));
              }
              function K(y, V) {
                var L = V.parentDeclaration, P = V.declSourceFile, k = V.modifierFlags, Y = V.token, U = Y.text, j = k & 32, H = b(y.program.getTypeChecker(), L, Y), I = function(d) {
                  return e.textChanges.ChangeTracker.with(y, function(D) {
                    return se(D, P, L, U, H, d);
                  });
                }, l = [C.createCodeFixAction(w, I(k & 32), [j ? e.Diagnostics.Declare_static_property_0 : e.Diagnostics.Declare_property_0, U], w, e.Diagnostics.Add_all_missing_members)];
                return j || e.isPrivateIdentifier(Y) || (k & 8 && l.unshift(C.createCodeFixActionWithoutFixAll(w, I(8), [e.Diagnostics.Declare_private_property_0, U])), l.push(ie(y, P, L, Y.text, H))), l;
              }
              function b(y, V, L) {
                var P;
                if (L.parent.parent.kind === 221) {
                  var k = L.parent.parent, Y = L.parent === k.left ? k.right : k.left, U = y.getWidenedType(y.getBaseTypeOfLiteralType(y.getTypeAtLocation(Y)));
                  P = y.typeToTypeNode(U, V, 1);
                } else {
                  var j = y.getContextualType(L.parent);
                  P = j ? y.typeToTypeNode(j, void 0, 1) : void 0;
                }
                return P || e.factory.createKeywordTypeNode(130);
              }
              function se(y, V, L, P, k, Y) {
                var U = Y ? e.factory.createNodeArray(e.factory.createModifiersFromModifierFlags(Y)) : void 0, j = e.isClassLike(L) ? e.factory.createPropertyDeclaration(void 0, U, P, void 0, k, void 0) : e.factory.createPropertySignature(void 0, P, void 0, k), H = J(L);
                H ? y.insertNodeAfter(V, H, j) : y.insertMemberAtStart(V, L, j);
              }
              function J(y) {
                for (var V, L = 0, P = y.members; L < P.length; L++) {
                  var k = P[L];
                  if (!e.isPropertyDeclaration(k)) break;
                  V = k;
                }
                return V;
              }
              function ie(y, V, L, P, k) {
                var Y = e.factory.createKeywordTypeNode(150), U = e.factory.createParameterDeclaration(void 0, void 0, void 0, "x", void 0, Y, void 0), j = e.factory.createIndexSignature(void 0, void 0, [U], k), H = e.textChanges.ChangeTracker.with(y, function(I) {
                  return I.insertMemberAtStart(V, L, j);
                });
                return C.createCodeFixActionWithoutFixAll(w, H, [e.Diagnostics.Add_index_signature_for_property_0, P]);
              }
              function R(y, V) {
                var L = V.parentDeclaration, P = V.declSourceFile, k = V.modifierFlags, Y = V.token, U = V.call;
                if (U !== void 0 && !e.isPrivateIdentifier(Y)) {
                  var j = Y.text, H = function(l) {
                    return e.textChanges.ChangeTracker.with(y, function(d) {
                      return q(y, d, U, Y, l, L, P);
                    });
                  }, I = [C.createCodeFixAction(w, H(k & 32), [k & 32 ? e.Diagnostics.Declare_static_method_0 : e.Diagnostics.Declare_method_0, j], w, e.Diagnostics.Add_all_missing_members)];
                  return k & 8 && I.unshift(C.createCodeFixActionWithoutFixAll(w, H(8), [e.Diagnostics.Declare_private_method_0, j])), I;
                }
              }
              function q(y, V, L, P, k, Y, U) {
                var j = C.createImportAdder(U, y.program, y.preferences, y.host), H = e.isClassLike(Y) ? 169 : 168, I = C.createSignatureDeclarationFromCallExpression(H, y, j, L, P, k, Y), l = A(Y, L);
                l ? V.insertNodeAfter(U, l, I) : V.insertMemberAtStart(U, Y, I), j.writeFixes(V);
              }
              function O(y, V, L) {
                var P = L.token, k = L.parentDeclaration, Y = e.some(k.members, function(j) {
                  var H = V.getTypeAtLocation(j);
                  return !!(H && H.flags & 402653316);
                }), U = e.factory.createEnumMember(P, Y ? e.factory.createStringLiteral(P.text) : void 0);
                y.replaceNode(k.getSourceFile(), k, e.factory.updateEnumDeclaration(k, k.decorators, k.modifiers, k.name, e.concatenate(k.members, e.singleElementArray(U))), { leadingTriviaOption: e.textChanges.LeadingTriviaOption.IncludeAll, trailingTriviaOption: e.textChanges.TrailingTriviaOption.Exclude });
              }
              function ve(y, V, L) {
                var P = C.createImportAdder(V.sourceFile, V.program, V.preferences, V.host), k = C.createSignatureDeclarationFromCallExpression(256, V, P, L.call, e.idText(L.token), L.modifierFlags, L.parentDeclaration);
                y.insertNodeAtEndOfScope(L.sourceFile, L.parentDeclaration, k);
              }
              function ee(y, V, L) {
                var P = C.createImportAdder(V.sourceFile, V.program, V.preferences, V.host), k = e.getQuotePreference(V.sourceFile, V.preferences), Y = V.program.getTypeChecker(), U = L.parentDeclaration.attributes, j = e.some(U.properties, e.isJsxSpreadAttribute), H = e.map(L.attributes, function(d) {
                  var D = F(V, Y, P, k, Y.getTypeOfSymbol(d)), fe = e.factory.createIdentifier(d.name), g = e.factory.createJsxAttribute(fe, e.factory.createJsxExpression(void 0, D));
                  return e.setParent(fe, g), g;
                }), I = e.factory.createJsxAttributes(j ? Ve(Ve([], H, true), U.properties, true) : Ve(Ve([], U.properties, true), H, true)), l = { prefix: U.pos === U.end ? " " : void 0 };
                y.replaceNode(V.sourceFile, U, I, l);
              }
              function he(y, V, L) {
                var P = C.createImportAdder(V.sourceFile, V.program, V.preferences, V.host), k = e.getQuotePreference(V.sourceFile, V.preferences), Y = e.getEmitScriptTarget(V.program.getCompilerOptions()), U = V.program.getTypeChecker(), j = e.map(L.properties, function(I) {
                  var l = F(V, U, P, k, U.getTypeOfSymbol(I));
                  return e.factory.createPropertyAssignment(e.createPropertyNameNodeForIdentifierOrLiteral(I.name, Y, k === 0), l);
                }), H = { leadingTriviaOption: e.textChanges.LeadingTriviaOption.Exclude, trailingTriviaOption: e.textChanges.TrailingTriviaOption.Exclude, indentation: L.indentation };
                y.replaceNode(V.sourceFile, L.parentDeclaration, e.factory.createObjectLiteralExpression(Ve(Ve([], L.parentDeclaration.properties, true), j, true), true), H);
              }
              function F(y, V, L, P, k) {
                if (k.flags & 3) return x();
                if (k.flags & 134217732) return e.factory.createStringLiteral("", P === 0);
                if (k.flags & 8) return e.factory.createNumericLiteral(0);
                if (k.flags & 64) return e.factory.createBigIntLiteral("0n");
                if (k.flags & 16) return e.factory.createFalse();
                if (k.flags & 1056) {
                  var Y = k.symbol.exports ? e.firstOrUndefined(e.arrayFrom(k.symbol.exports.values())) : k.symbol, U = V.symbolToExpression(k.symbol.parent ? k.symbol.parent : k.symbol, 111551, void 0, void 0);
                  return Y === void 0 || U === void 0 ? e.factory.createNumericLiteral(0) : e.factory.createPropertyAccessExpression(U, V.symbolToString(Y));
                }
                if (k.flags & 256) return e.factory.createNumericLiteral(k.value);
                if (k.flags & 2048) return e.factory.createBigIntLiteral(k.value);
                if (k.flags & 128) return e.factory.createStringLiteral(k.value, P === 0);
                if (k.flags & 512) return k === V.getFalseType() || k === V.getFalseType(true) ? e.factory.createFalse() : e.factory.createTrue();
                if (k.flags & 65536) return e.factory.createNull();
                if (k.flags & 1048576) {
                  var j = e.firstDefined(k.types, function(g) {
                    return F(y, V, L, P, g);
                  });
                  return j != null ? j : x();
                }
                if (V.isArrayLikeType(k)) return e.factory.createArrayLiteralExpression();
                if (X(k)) {
                  var H = e.map(V.getPropertiesOfType(k), function(g) {
                    var ne = g.valueDeclaration ? F(y, V, L, P, V.getTypeAtLocation(g.valueDeclaration)) : x();
                    return e.factory.createPropertyAssignment(g.name, ne);
                  });
                  return e.factory.createObjectLiteralExpression(H, true);
                }
                if (e.getObjectFlags(k) & 16) {
                  var I = e.find(k.symbol.declarations || e.emptyArray, e.or(e.isFunctionTypeNode, e.isMethodSignature, e.isMethodDeclaration));
                  if (I === void 0) return x();
                  var l = V.getSignaturesOfType(k, 0);
                  if (l === void 0) return x();
                  var d = C.createSignatureDeclarationFromSignature(213, y, P, l[0], C.createStubbedBody(e.Diagnostics.Function_not_implemented.message, P), void 0, void 0, void 0, void 0, L);
                  return d != null ? d : x();
                }
                if (e.getObjectFlags(k) & 1) {
                  var D = e.getClassLikeDeclarationOfSymbol(k.symbol);
                  if (D === void 0 || e.hasAbstractModifier(D)) return x();
                  var fe = e.getFirstConstructorWithBody(D);
                  return fe && e.length(fe.parameters) ? x() : e.factory.createNewExpression(e.factory.createIdentifier(k.symbol.name), void 0, void 0);
                }
                return x();
              }
              function x() {
                return e.factory.createIdentifier("undefined");
              }
              function X(y) {
                return y.flags & 524288 && (e.getObjectFlags(y) & 128 || y.symbol && e.tryCast(e.singleOrUndefined(y.symbol.declarations), e.isTypeLiteralNode));
              }
              function $(y, V, L) {
                var P = y.getContextualType(L.attributes);
                if (P === void 0) return e.emptyArray;
                var k = P.getProperties();
                if (!e.length(k)) return e.emptyArray;
                for (var Y = new e.Set(), U = 0, j = L.attributes.properties; U < j.length; U++) {
                  var H = j[U];
                  if (e.isJsxAttribute(H) && Y.add(H.name.escapedText), e.isJsxSpreadAttribute(H)) for (var I = y.getTypeAtLocation(H.expression), l = 0, d = I.getProperties(); l < d.length; l++) {
                    var D = d[l];
                    Y.add(D.escapedName);
                  }
                }
                return e.filter(k, function(fe) {
                  return e.isIdentifierText(fe.name, V, 1) && !(fe.flags & 16777216 || e.getCheckFlags(fe) & 48 || Y.has(fe.escapedName));
                });
              }
              function A(y, V) {
                if (!e.isTypeLiteralNode(y)) {
                  var L = e.findAncestor(V, function(P) {
                    return e.isMethodDeclaration(P) || e.isConstructorDeclaration(P);
                  });
                  return L && L.parent === y ? L : void 0;
                }
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "addMissingNewOperator", B = [e.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = le.sourceFile, p = le.span, m = e.textChanges.ChangeTracker.with(le, function(G) {
                  return E(G, N, p);
                });
                return [C.createCodeFixAction(w, m, e.Diagnostics.Add_missing_new_operator_to_call, w, e.Diagnostics.Add_missing_new_operator_to_all_calls)];
              }, fixIds: [w], getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  return E(N, le.sourceFile, p);
                });
              } });
              function E(le, N, p) {
                var m = e.cast(Q(N, p), e.isCallExpression), G = e.factory.createNewExpression(m.expression, m.typeArguments, m.arguments);
                le.replaceNode(N, m, G);
              }
              function Q(le, N) {
                for (var p = e.getTokenAtPosition(le, N.start), m = e.textSpanEnd(N); p.end < m; ) p = p.parent;
                return p;
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixCannotFindModule", B = "installTypesPackage", E = e.Diagnostics.Cannot_find_module_0_or_its_corresponding_type_declarations.code, Q = [E, e.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type.code];
              C.registerCodeFix({ errorCodes: Q, getCodeActions: function(G) {
                var oe = G.host, f = G.sourceFile, T = G.span.start, K = N(f, T);
                if (K !== void 0) {
                  var b = p(K, oe, G.errorCode);
                  return b === void 0 ? [] : [C.createCodeFixAction(w, [], [e.Diagnostics.Install_0, b], B, e.Diagnostics.Install_all_missing_types_packages, le(f.fileName, b))];
                }
              }, fixIds: [B], getAllCodeActions: function(m) {
                return C.codeFixAll(m, Q, function(G, oe, f) {
                  var T = N(oe.file, oe.start);
                  if (T !== void 0) switch (m.fixId) {
                    case B: {
                      var K = p(T, m.host, oe.code);
                      K && f.push(le(oe.file.fileName, K));
                      break;
                    }
                    default:
                      e.Debug.fail("Bad fixId: ".concat(m.fixId));
                  }
                });
              } });
              function le(m, G) {
                return { type: "install package", file: m, packageName: G };
              }
              function N(m, G) {
                var oe = e.tryCast(e.getTokenAtPosition(m, G), e.isStringLiteral);
                if (!!oe) {
                  var f = oe.text, T = e.parsePackageName(f).packageName;
                  return e.isExternalModuleNameRelative(T) ? void 0 : T;
                }
              }
              function p(m, G, oe) {
                var f;
                return oe === E ? e.JsTyping.nodeCoreModules.has(m) ? "@types/node" : void 0 : !((f = G.isKnownTypesPackageName) === null || f === void 0) && f.call(G, m) ? e.getTypesPackageName(m) : void 0;
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = [e.Diagnostics.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2.code, e.Diagnostics.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1.code], B = "fixClassDoesntImplementInheritedAbstractMember";
              C.registerCodeFix({ errorCodes: w, getCodeActions: function(p) {
                var m = p.sourceFile, G = p.span, oe = e.textChanges.ChangeTracker.with(p, function(f) {
                  return Q(E(m, G.start), m, p, f, p.preferences);
                });
                return oe.length === 0 ? void 0 : [C.createCodeFixAction(B, oe, e.Diagnostics.Implement_inherited_abstract_class, B, e.Diagnostics.Implement_all_inherited_abstract_classes)];
              }, fixIds: [B], getAllCodeActions: function(p) {
                var m = new e.Map();
                return C.codeFixAll(p, w, function(G, oe) {
                  var f = E(oe.file, oe.start);
                  e.addToSeen(m, e.getNodeId(f)) && Q(f, p.sourceFile, p, G, p.preferences);
                });
              } });
              function E(N, p) {
                var m = e.getTokenAtPosition(N, p);
                return e.cast(m.parent, e.isClassLike);
              }
              function Q(N, p, m, G, oe) {
                var f = e.getEffectiveBaseTypeNode(N), T = m.program.getTypeChecker(), K = T.getTypeAtLocation(f), b = T.getPropertiesOfType(K).filter(le), se = C.createImportAdder(p, m.program, oe, m.host);
                C.createMissingMemberNodes(N, b, p, m, oe, se, function(J) {
                  return G.insertMemberAtStart(p, N, J);
                }), se.writeFixes(G);
              }
              function le(N) {
                var p = e.getSyntacticModifierFlags(e.first(N.getDeclarations()));
                return !(p & 8) && !!(p & 128);
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "classSuperMustPrecedeThisAccess", B = [e.Diagnostics.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(N) {
                var p = N.sourceFile, m = N.span, G = Q(p, m.start);
                if (!!G) {
                  var oe = G.constructor, f = G.superCall, T = e.textChanges.ChangeTracker.with(N, function(K) {
                    return E(K, p, oe, f);
                  });
                  return [C.createCodeFixAction(w, T, e.Diagnostics.Make_super_call_the_first_statement_in_the_constructor, w, e.Diagnostics.Make_all_super_calls_the_first_statement_in_their_constructor)];
                }
              }, fixIds: [w], getAllCodeActions: function(N) {
                var p = N.sourceFile, m = new e.Map();
                return C.codeFixAll(N, B, function(G, oe) {
                  var f = Q(oe.file, oe.start);
                  if (!!f) {
                    var T = f.constructor, K = f.superCall;
                    e.addToSeen(m, e.getNodeId(T.parent)) && E(G, p, T, K);
                  }
                });
              } });
              function E(N, p, m, G) {
                N.insertNodeAtConstructorStart(p, m, G), N.delete(p, G);
              }
              function Q(N, p) {
                var m = e.getTokenAtPosition(N, p);
                if (m.kind === 108) {
                  var G = e.getContainingFunction(m), oe = le(G.body);
                  return oe && !oe.expression.arguments.some(function(f) {
                    return e.isPropertyAccessExpression(f) && f.expression === m;
                  }) ? { constructor: G, superCall: oe } : void 0;
                }
              }
              function le(N) {
                return e.isExpressionStatement(N) && e.isSuperCall(N.expression) ? N : e.isFunctionLike(N) ? void 0 : e.forEachChild(N, le);
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "constructorForDerivedNeedSuperCall", B = [e.Diagnostics.Constructors_for_derived_classes_must_contain_a_super_call.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = le.sourceFile, p = le.span, m = E(N, p.start), G = e.textChanges.ChangeTracker.with(le, function(oe) {
                  return Q(oe, N, m);
                });
                return [C.createCodeFixAction(w, G, e.Diagnostics.Add_missing_super_call, w, e.Diagnostics.Add_all_missing_super_calls)];
              }, fixIds: [w], getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  return Q(N, le.sourceFile, E(p.file, p.start));
                });
              } });
              function E(le, N) {
                var p = e.getTokenAtPosition(le, N);
                return e.Debug.assert(e.isConstructorDeclaration(p.parent), "token should be at the constructor declaration"), p.parent;
              }
              function Q(le, N, p) {
                var m = e.factory.createExpressionStatement(e.factory.createCallExpression(e.factory.createSuper(), void 0, e.emptyArray));
                le.insertNodeAtConstructorStart(N, p, m);
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "enableExperimentalDecorators", B = [e.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = le.program.getCompilerOptions().configFile;
                if (N !== void 0) {
                  var p = e.textChanges.ChangeTracker.with(le, function(m) {
                    return E(m, N);
                  });
                  return [C.createCodeFixActionWithoutFixAll(w, p, e.Diagnostics.Enable_the_experimentalDecorators_option_in_your_configuration_file)];
                }
              }, fixIds: [w], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, B, function(le) {
                  var N = Q.program.getCompilerOptions().configFile;
                  N !== void 0 && E(le, N);
                });
              } });
              function E(Q, le) {
                C.setJsonCompilerOptionValue(Q, le, "experimentalDecorators", e.factory.createTrue());
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixEnableJsxFlag", B = [e.Diagnostics.Cannot_use_JSX_unless_the_jsx_flag_is_provided.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = le.program.getCompilerOptions().configFile;
                if (N !== void 0) {
                  var p = e.textChanges.ChangeTracker.with(le, function(m) {
                    return E(m, N);
                  });
                  return [C.createCodeFixActionWithoutFixAll(w, p, e.Diagnostics.Enable_the_jsx_flag_in_your_configuration_file)];
                }
              }, fixIds: [w], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, B, function(le) {
                  var N = Q.program.getCompilerOptions().configFile;
                  N !== void 0 && E(le, N);
                });
              } });
              function E(Q, le) {
                C.setJsonCompilerOptionValue(Q, le, "jsx", e.factory.createStringLiteral("react"));
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              C.registerCodeFix({ errorCodes: [e.Diagnostics.Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher.code, e.Diagnostics.Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher.code], getCodeActions: function(B) {
                var E = B.program.getCompilerOptions(), Q = E.configFile;
                if (Q !== void 0) {
                  var le = [], N = e.getEmitModuleKind(E), p = N >= e.ModuleKind.ES2015 && N < e.ModuleKind.ESNext;
                  if (p) {
                    var m = e.textChanges.ChangeTracker.with(B, function(f) {
                      C.setJsonCompilerOptionValue(f, Q, "module", e.factory.createStringLiteral("esnext"));
                    });
                    le.push(C.createCodeFixActionWithoutFixAll("fixModuleOption", m, [e.Diagnostics.Set_the_module_option_in_your_configuration_file_to_0, "esnext"]));
                  }
                  var G = e.getEmitScriptTarget(E), oe = G < 4 || G > 99;
                  if (oe) {
                    var m = e.textChanges.ChangeTracker.with(B, function(T) {
                      var K = e.getTsConfigObjectLiteralExpression(Q);
                      if (!!K) {
                        var b = [["target", e.factory.createStringLiteral("es2017")]];
                        N === e.ModuleKind.CommonJS && b.push(["module", e.factory.createStringLiteral("commonjs")]), C.setJsonCompilerOptionValues(T, Q, b);
                      }
                    });
                    le.push(C.createCodeFixActionWithoutFixAll("fixTargetOption", m, [e.Diagnostics.Set_the_target_option_in_your_configuration_file_to_0, "es2017"]));
                  }
                  return le.length ? le : void 0;
                }
              } });
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixPropertyAssignment", B = [e.Diagnostics.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern.code];
              C.registerCodeFix({ errorCodes: B, fixIds: [w], getCodeActions: function(le) {
                var N = le.sourceFile, p = le.span, m = Q(N, p.start), G = e.textChanges.ChangeTracker.with(le, function(oe) {
                  return E(oe, le.sourceFile, m);
                });
                return [C.createCodeFixAction(w, G, [e.Diagnostics.Change_0_to_1, "=", ":"], w, [e.Diagnostics.Switch_each_misused_0_to_1, "=", ":"])];
              }, getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  return E(N, p.file, Q(p.file, p.start));
                });
              } });
              function E(le, N, p) {
                le.replaceNode(N, p, e.factory.createPropertyAssignment(p.name, p.objectAssignmentInitializer));
              }
              function Q(le, N) {
                return e.cast(e.getTokenAtPosition(le, N).parent, e.isShorthandPropertyAssignment);
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "extendsInterfaceBecomesImplements", B = [e.Diagnostics.Cannot_extend_an_interface_0_Did_you_mean_implements.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = le.sourceFile, p = E(N, le.span.start);
                if (!!p) {
                  var m = p.extendsToken, G = p.heritageClauses, oe = e.textChanges.ChangeTracker.with(le, function(f) {
                    return Q(f, N, m, G);
                  });
                  return [C.createCodeFixAction(w, oe, e.Diagnostics.Change_extends_to_implements, w, e.Diagnostics.Change_all_extended_interfaces_to_implements)];
                }
              }, fixIds: [w], getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  var m = E(p.file, p.start);
                  m && Q(N, p.file, m.extendsToken, m.heritageClauses);
                });
              } });
              function E(le, N) {
                var p = e.getTokenAtPosition(le, N), m = e.getContainingClass(p).heritageClauses, G = m[0].getFirstToken();
                return G.kind === 94 ? { extendsToken: G, heritageClauses: m } : void 0;
              }
              function Q(le, N, p, m) {
                if (le.replaceNode(N, p, e.factory.createToken(117)), m.length === 2 && m[0].token === 94 && m[1].token === 117) {
                  var G = m[1].getFirstToken(), oe = G.getFullStart();
                  le.replaceRange(N, { pos: oe, end: oe }, e.factory.createToken(27));
                  for (var f = N.text, T = G.end; T < f.length && e.isWhiteSpaceSingleLine(f.charCodeAt(T)); ) T++;
                  le.deleteRange(N, { pos: G.getStart(), end: T });
                }
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "forgottenThisPropertyAccess", B = e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code, E = [e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code, e.Diagnostics.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression.code, B];
              C.registerCodeFix({ errorCodes: E, getCodeActions: function(N) {
                var p = N.sourceFile, m = Q(p, N.span.start, N.errorCode);
                if (!!m) {
                  var G = e.textChanges.ChangeTracker.with(N, function(oe) {
                    return le(oe, p, m);
                  });
                  return [C.createCodeFixAction(w, G, [e.Diagnostics.Add_0_to_unresolved_variable, m.className || "this"], w, e.Diagnostics.Add_qualifier_to_all_unresolved_variables_matching_a_member_name)];
                }
              }, fixIds: [w], getAllCodeActions: function(N) {
                return C.codeFixAll(N, E, function(p, m) {
                  var G = Q(m.file, m.start, m.code);
                  G && le(p, N.sourceFile, G);
                });
              } });
              function Q(N, p, m) {
                var G = e.getTokenAtPosition(N, p);
                if (e.isIdentifier(G) || e.isPrivateIdentifier(G)) return { node: G, className: m === B ? e.getContainingClass(G).name.text : void 0 };
              }
              function le(N, p, m) {
                var G = m.node, oe = m.className;
                e.suppressLeadingAndTrailingTrivia(G), N.replaceNode(p, G, e.factory.createPropertyAccessExpression(oe ? e.factory.createIdentifier(oe) : e.factory.createThis(), G));
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixInvalidJsxCharacters_expression", B = "fixInvalidJsxCharacters_htmlEntity", E = [e.Diagnostics.Unexpected_token_Did_you_mean_or_gt.code, e.Diagnostics.Unexpected_token_Did_you_mean_or_rbrace.code];
              C.registerCodeFix({ errorCodes: E, fixIds: [w, B], getCodeActions: function(p) {
                var m = p.sourceFile, G = p.preferences, oe = p.span, f = e.textChanges.ChangeTracker.with(p, function(K) {
                  return N(K, G, m, oe.start, false);
                }), T = e.textChanges.ChangeTracker.with(p, function(K) {
                  return N(K, G, m, oe.start, true);
                });
                return [C.createCodeFixAction(w, f, e.Diagnostics.Wrap_invalid_character_in_an_expression_container, w, e.Diagnostics.Wrap_all_invalid_characters_in_an_expression_container), C.createCodeFixAction(B, T, e.Diagnostics.Convert_invalid_character_to_its_html_entity_code, B, e.Diagnostics.Convert_all_invalid_characters_to_HTML_entity_code)];
              }, getAllCodeActions: function(p) {
                return C.codeFixAll(p, E, function(m, G) {
                  return N(m, p.preferences, G.file, G.start, p.fixId === B);
                });
              } });
              var Q = { ">": "&gt;", "}": "&rbrace;" };
              function le(p) {
                return e.hasProperty(Q, p);
              }
              function N(p, m, G, oe, f) {
                var T = G.getText()[oe];
                if (!!le(T)) {
                  var K = f ? Q[T] : "{".concat(e.quote(G, m, T), "}");
                  p.replaceRangeWithText(G, { pos: oe, end: oe + 1 }, K);
                }
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "deleteUnmatchedParameter", B = "renameUnmatchedParameter", E = [e.Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name.code];
              C.registerCodeFix({ fixIds: [w, B], errorCodes: E, getCodeActions: function(m) {
                var G = m.sourceFile, oe = m.span, f = [], T = N(G, oe.start);
                if (T) return e.append(f, Q(m, T)), e.append(f, le(m, T)), f;
              }, getAllCodeActions: function(m) {
                var G = new e.Map();
                return C.createCombinedCodeActions(e.textChanges.ChangeTracker.with(m, function(oe) {
                  C.eachDiagnostic(m, E, function(f) {
                    var T = f.file, K = f.start, b = N(T, K);
                    b && G.set(b.signature, e.append(G.get(b.signature), b.jsDocParameterTag));
                  }), G.forEach(function(f, T) {
                    if (m.fixId === w) {
                      var K = new e.Set(f);
                      oe.filterJSDocTags(T.getSourceFile(), T, function(b) {
                        return !K.has(b);
                      });
                    }
                  });
                }));
              } });
              function Q(p, m) {
                var G = m.name, oe = m.signature, f = m.jsDocParameterTag, T = e.textChanges.ChangeTracker.with(p, function(K) {
                  return K.filterJSDocTags(p.sourceFile, oe, function(b) {
                    return b !== f;
                  });
                });
                return C.createCodeFixAction(w, T, [e.Diagnostics.Delete_unused_param_tag_0, G.getText(p.sourceFile)], w, e.Diagnostics.Delete_all_unused_param_tags);
              }
              function le(p, m) {
                var G = m.name, oe = m.signature, f = m.jsDocParameterTag;
                if (!!e.length(oe.parameters)) {
                  for (var T = p.sourceFile, K = e.getJSDocTags(oe), b = new e.Set(), se = 0, J = K; se < J.length; se++) {
                    var ie = J[se];
                    e.isJSDocParameterTag(ie) && e.isIdentifier(ie.name) && b.add(ie.name.escapedText);
                  }
                  var R = e.firstDefined(oe.parameters, function(ve) {
                    return e.isIdentifier(ve.name) && !b.has(ve.name.escapedText) ? ve.name.getText(T) : void 0;
                  });
                  if (R !== void 0) {
                    var q = e.factory.updateJSDocParameterTag(f, f.tagName, e.factory.createIdentifier(R), f.isBracketed, f.typeExpression, f.isNameFirst, f.comment), O = e.textChanges.ChangeTracker.with(p, function(ve) {
                      return ve.replaceJSDocComment(T, oe, e.map(K, function(ee) {
                        return ee === f ? q : ee;
                      }));
                    });
                    return C.createCodeFixActionWithoutFixAll(B, O, [e.Diagnostics.Rename_param_tag_name_0_to_1, G.getText(T), R]);
                  }
                }
              }
              function N(p, m) {
                var G = e.getTokenAtPosition(p, m);
                if (G.parent && e.isJSDocParameterTag(G.parent) && e.isIdentifier(G.parent.name)) {
                  var oe = G.parent, f = e.getHostSignatureFromJSDoc(oe);
                  if (f) return { signature: f, name: G.parent.name, jsDocParameterTag: oe };
                }
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixUnreferenceableDecoratorMetadata", B = [e.Diagnostics.A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(N) {
                var p = E(N.sourceFile, N.program, N.span.start);
                if (!!p) {
                  var m = e.textChanges.ChangeTracker.with(N, function(f) {
                    return p.kind === 270 && le(f, N.sourceFile, p, N.program);
                  }), G = e.textChanges.ChangeTracker.with(N, function(f) {
                    return Q(f, N.sourceFile, p, N.program);
                  }), oe;
                  return m.length && (oe = e.append(oe, C.createCodeFixActionWithoutFixAll(w, m, e.Diagnostics.Convert_named_imports_to_namespace_import))), G.length && (oe = e.append(oe, C.createCodeFixActionWithoutFixAll(w, G, e.Diagnostics.Convert_to_type_only_import))), oe;
                }
              }, fixIds: [w] });
              function E(N, p, m) {
                var G = e.tryCast(e.getTokenAtPosition(N, m), e.isIdentifier);
                if (!(!G || G.parent.kind !== 178)) {
                  var oe = p.getTypeChecker(), f = oe.getSymbolAtLocation(G);
                  return e.find((f == null ? void 0 : f.declarations) || e.emptyArray, e.or(e.isImportClause, e.isImportSpecifier, e.isImportEqualsDeclaration));
                }
              }
              function Q(N, p, m, G) {
                if (m.kind === 265) {
                  N.insertModifierBefore(p, 152, m.name);
                  return;
                }
                var oe = m.kind === 267 ? m : m.parent.parent;
                if (!(oe.name && oe.namedBindings)) {
                  var f = G.getTypeChecker(), T = !!e.forEachImportClauseDeclaration(oe, function(K) {
                    if (e.skipAlias(K.symbol, f).flags & 111551) return true;
                  });
                  T || N.insertModifierBefore(p, 152, oe);
                }
              }
              function le(N, p, m, G) {
                e.refactor.doChangeNamedToNamespaceOrDefault(p, G, N, m.parent);
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "unusedIdentifier", B = "unusedIdentifier_prefix", E = "unusedIdentifier_delete", Q = "unusedIdentifier_deleteImports", le = "unusedIdentifier_infer", N = [e.Diagnostics._0_is_declared_but_its_value_is_never_read.code, e.Diagnostics._0_is_declared_but_never_used.code, e.Diagnostics.Property_0_is_declared_but_its_value_is_never_read.code, e.Diagnostics.All_imports_in_import_declaration_are_unused.code, e.Diagnostics.All_destructured_elements_are_unused.code, e.Diagnostics.All_variables_are_unused.code, e.Diagnostics.All_type_parameters_are_unused.code];
              C.registerCodeFix({ errorCodes: N, getCodeActions: function(x) {
                var X = x.errorCode, $ = x.sourceFile, A = x.program, y = x.cancellationToken, V = A.getTypeChecker(), L = A.getSourceFiles(), P = e.getTokenAtPosition($, x.span.start);
                if (e.isJSDocTemplateTag(P)) return [m(e.textChanges.ChangeTracker.with(x, function(D) {
                  return D.delete($, P);
                }), e.Diagnostics.Remove_template_tag)];
                if (P.kind === 29) {
                  var k = e.textChanges.ChangeTracker.with(x, function(D) {
                    return G(D, $, P);
                  });
                  return [m(k, e.Diagnostics.Remove_type_parameters)];
                }
                var Y = f(P);
                if (Y) {
                  var k = e.textChanges.ChangeTracker.with(x, function(fe) {
                    return fe.delete($, Y);
                  });
                  return [C.createCodeFixAction(w, k, [e.Diagnostics.Remove_import_from_0, e.showModuleSpecifier(Y)], Q, e.Diagnostics.Delete_all_unused_imports)];
                } else if (oe(P)) {
                  var U = e.textChanges.ChangeTracker.with(x, function(D) {
                    return ie($, P, D, V, L, A, y, false);
                  });
                  if (U.length) return [C.createCodeFixAction(w, U, [e.Diagnostics.Remove_unused_declaration_for_Colon_0, P.getText($)], Q, e.Diagnostics.Delete_all_unused_imports)];
                }
                if (e.isObjectBindingPattern(P.parent) || e.isArrayBindingPattern(P.parent)) {
                  if (e.isParameter(P.parent.parent)) {
                    var j = P.parent.elements, H = [j.length > 1 ? e.Diagnostics.Remove_unused_declarations_for_Colon_0 : e.Diagnostics.Remove_unused_declaration_for_Colon_0, e.map(j, function(D) {
                      return D.getText($);
                    }).join(", ")];
                    return [m(e.textChanges.ChangeTracker.with(x, function(D) {
                      return b(D, $, P.parent);
                    }), H)];
                  }
                  return [m(e.textChanges.ChangeTracker.with(x, function(D) {
                    return D.delete($, P.parent.parent);
                  }), e.Diagnostics.Remove_unused_destructuring_declaration)];
                }
                if (T($, P)) return [m(e.textChanges.ChangeTracker.with(x, function(D) {
                  return K(D, $, P.parent);
                }), e.Diagnostics.Remove_variable_statement)];
                var I = [];
                if (P.kind === 137) {
                  var k = e.textChanges.ChangeTracker.with(x, function(fe) {
                    return p(fe, $, P);
                  }), l = e.cast(P.parent, e.isInferTypeNode).typeParameter.name.text;
                  I.push(C.createCodeFixAction(w, k, [e.Diagnostics.Replace_infer_0_with_unknown, l], le, e.Diagnostics.Replace_all_unused_infer_with_unknown));
                } else {
                  var U = e.textChanges.ChangeTracker.with(x, function(fe) {
                    return ie($, P, fe, V, L, A, y, false);
                  });
                  if (U.length) {
                    var l = e.isComputedPropertyName(P.parent) ? P.parent : P;
                    I.push(m(U, [e.Diagnostics.Remove_unused_declaration_for_Colon_0, l.getText($)]));
                  }
                }
                var d = e.textChanges.ChangeTracker.with(x, function(D) {
                  return se(D, X, $, P);
                });
                return d.length && I.push(C.createCodeFixAction(w, d, [e.Diagnostics.Prefix_0_with_an_underscore, P.getText($)], B, e.Diagnostics.Prefix_all_unused_declarations_with_where_possible)), I;
              }, fixIds: [B, E, Q, le], getAllCodeActions: function(x) {
                var X = x.sourceFile, $ = x.program, A = x.cancellationToken, y = $.getTypeChecker(), V = $.getSourceFiles();
                return C.codeFixAll(x, N, function(L, P) {
                  var k = e.getTokenAtPosition(X, P.start);
                  switch (x.fixId) {
                    case B:
                      se(L, P.code, X, k);
                      break;
                    case Q: {
                      var Y = f(k);
                      Y ? L.delete(X, Y) : oe(k) && ie(X, k, L, y, V, $, A, true);
                      break;
                    }
                    case E: {
                      if (k.kind === 137 || oe(k)) break;
                      if (e.isJSDocTemplateTag(k)) L.delete(X, k);
                      else if (k.kind === 29) G(L, X, k);
                      else if (e.isObjectBindingPattern(k.parent)) {
                        if (k.parent.parent.initializer) break;
                        (!e.isParameter(k.parent.parent) || O(k.parent.parent, y, V)) && L.delete(X, k.parent.parent);
                      } else {
                        if (e.isArrayBindingPattern(k.parent.parent) && k.parent.parent.parent.initializer) break;
                        T(X, k) ? K(L, X, k.parent) : ie(X, k, L, y, V, $, A, true);
                      }
                      break;
                    }
                    case le:
                      k.kind === 137 && p(L, X, k);
                      break;
                    default:
                      e.Debug.fail(JSON.stringify(x.fixId));
                  }
                });
              } });
              function p(x, X, $) {
                x.replaceNode(X, $.parent, e.factory.createKeywordTypeNode(155));
              }
              function m(x, X) {
                return C.createCodeFixAction(w, x, X, E, e.Diagnostics.Delete_all_unused_declarations);
              }
              function G(x, X, $) {
                x.delete(X, e.Debug.checkDefined(e.cast($.parent, e.isDeclarationWithTypeParameterChildren).typeParameters, "The type parameter to delete should exist"));
              }
              function oe(x) {
                return x.kind === 100 || x.kind === 79 && (x.parent.kind === 270 || x.parent.kind === 267);
              }
              function f(x) {
                return x.kind === 100 ? e.tryCast(x.parent, e.isImportDeclaration) : void 0;
              }
              function T(x, X) {
                return e.isVariableDeclarationList(X.parent) && e.first(X.parent.getChildren(x)) === X;
              }
              function K(x, X, $) {
                x.delete(X, $.parent.kind === 237 ? $.parent : $);
              }
              function b(x, X, $) {
                e.forEach($.elements, function(A) {
                  return x.delete(X, A);
                });
              }
              function se(x, X, $, A) {
                X !== e.Diagnostics.Property_0_is_declared_but_its_value_is_never_read.code && (A.kind === 137 && (A = e.cast(A.parent, e.isInferTypeNode).typeParameter.name), e.isIdentifier(A) && J(A) && (x.replaceNode($, A, e.factory.createIdentifier("_".concat(A.text))), e.isParameter(A.parent) && e.getJSDocParameterTags(A.parent).forEach(function(y) {
                  e.isIdentifier(y.name) && x.replaceNode($, y.name, e.factory.createIdentifier("_".concat(y.name.text)));
                })));
              }
              function J(x) {
                switch (x.parent.kind) {
                  case 164:
                  case 163:
                    return true;
                  case 254: {
                    var X = x.parent;
                    switch (X.parent.parent.kind) {
                      case 244:
                      case 243:
                        return true;
                    }
                  }
                }
                return false;
              }
              function ie(x, X, $, A, y, V, L, P) {
                R(X, $, x, A, y, V, L, P), e.isIdentifier(X) && e.FindAllReferences.Core.eachSymbolReferenceInFile(X, A, x, function(k) {
                  e.isPropertyAccessExpression(k.parent) && k.parent.name === k && (k = k.parent), !P && F(k) && $.delete(x, k.parent.parent);
                });
              }
              function R(x, X, $, A, y, V, L, P) {
                var k = x.parent;
                if (e.isParameter(k)) q(X, $, k, A, y, V, L, P);
                else if (!(P && e.isIdentifier(x) && e.FindAllReferences.Core.isSymbolReferencedInFile(x, A, $))) {
                  var Y = e.isImportClause(k) ? x : e.isComputedPropertyName(k) ? k.parent : k;
                  e.Debug.assert(Y !== $, "should not delete whole source file"), X.delete($, Y);
                }
              }
              function q(x, X, $, A, y, V, L, P) {
                P === void 0 && (P = false), ve(A, X, $, y, V, L, P) && ($.modifiers && $.modifiers.length > 0 && (!e.isIdentifier($.name) || e.FindAllReferences.Core.isSymbolReferencedInFile($.name, A, X)) ? $.modifiers.forEach(function(k) {
                  return x.deleteModifier(X, k);
                }) : !$.initializer && O($, A, y) && x.delete(X, $));
              }
              function O(x, X, $) {
                var A = x.parent.parameters.indexOf(x);
                return !e.FindAllReferences.Core.someSignatureUsage(x.parent, $, X, function(y, V) {
                  return !V || V.arguments.length > A;
                });
              }
              function ve(x, X, $, A, y, V, L) {
                var P = $.parent;
                switch (P.kind) {
                  case 169:
                  case 171:
                    var k = P.parameters.indexOf($), Y = e.isMethodDeclaration(P) ? P.name : P, U = e.FindAllReferences.Core.getReferencedSymbolsForNode(P.pos, Y, y, A, V);
                    if (U) for (var j = 0, H = U; j < H.length; j++) for (var I = H[j], l = 0, d = I.references; l < d.length; l++) {
                      var D = d[l];
                      if (D.kind === 1) {
                        var fe = e.isSuperKeyword(D.node) && e.isCallExpression(D.node.parent) && D.node.parent.arguments.length > k, g = e.isPropertyAccessExpression(D.node.parent) && e.isSuperKeyword(D.node.parent.expression) && e.isCallExpression(D.node.parent.parent) && D.node.parent.parent.arguments.length > k, ne = (e.isMethodDeclaration(D.node.parent) || e.isMethodSignature(D.node.parent)) && D.node.parent !== $.parent && D.node.parent.parameters.length > k;
                        if (fe || g || ne) return false;
                      }
                    }
                    return true;
                  case 256:
                    return P.name && ee(x, X, P.name) ? he(P, $, L) : true;
                  case 213:
                  case 214:
                    return he(P, $, L);
                  case 173:
                    return false;
                  case 172:
                    return true;
                  default:
                    return e.Debug.failBadSyntaxKind(P);
                }
              }
              function ee(x, X, $) {
                return !!e.FindAllReferences.Core.eachSymbolReferenceInFile($, x, X, function(A) {
                  return e.isIdentifier(A) && e.isCallExpression(A.parent) && A.parent.arguments.indexOf(A) >= 0;
                });
              }
              function he(x, X, $) {
                var A = x.parameters, y = A.indexOf(X);
                return e.Debug.assert(y !== -1, "The parameter should already be in the list"), $ ? A.slice(y + 1).every(function(V) {
                  return e.isIdentifier(V.name) && !V.symbol.isReferenced;
                }) : y === A.length - 1;
              }
              function F(x) {
                return (e.isBinaryExpression(x.parent) && x.parent.left === x || (e.isPostfixUnaryExpression(x.parent) || e.isPrefixUnaryExpression(x.parent)) && x.parent.operand === x) && e.isExpressionStatement(x.parent.parent);
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixUnreachableCode", B = [e.Diagnostics.Unreachable_code_detected.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = le.program.getSyntacticDiagnostics(le.sourceFile, le.cancellationToken);
                if (!N.length) {
                  var p = e.textChanges.ChangeTracker.with(le, function(m) {
                    return E(m, le.sourceFile, le.span.start, le.span.length, le.errorCode);
                  });
                  return [C.createCodeFixAction(w, p, e.Diagnostics.Remove_unreachable_code, w, e.Diagnostics.Remove_all_unreachable_code)];
                }
              }, fixIds: [w], getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  return E(N, p.file, p.start, p.length, p.code);
                });
              } });
              function E(le, N, p, m, G) {
                var oe = e.getTokenAtPosition(N, p), f = e.findAncestor(oe, e.isStatement);
                if (f.getStart(N) !== oe.getStart(N)) {
                  var T = JSON.stringify({ statementKind: e.Debug.formatSyntaxKind(f.kind), tokenKind: e.Debug.formatSyntaxKind(oe.kind), errorCode: G, start: p, length: m });
                  e.Debug.fail("Token and statement should start at the same point. " + T);
                }
                var K = (e.isBlock(f.parent) ? f.parent : f).parent;
                if (!e.isBlock(f.parent) || f === e.first(f.parent.statements)) switch (K.kind) {
                  case 239:
                    if (K.elseStatement) {
                      if (e.isBlock(f.parent)) break;
                      le.replaceNode(N, f, e.factory.createBlock(e.emptyArray));
                      return;
                    }
                  case 241:
                  case 242:
                    le.delete(N, K);
                    return;
                }
                if (e.isBlock(f.parent)) {
                  var b = p + m, se = e.Debug.checkDefined(Q(e.sliceAfter(f.parent.statements, f), function(J) {
                    return J.pos < b;
                  }), "Some statement should be last");
                  le.deleteNodeRange(N, f, se);
                } else le.delete(N, f);
              }
              function Q(le, N) {
                for (var p, m = 0, G = le; m < G.length; m++) {
                  var oe = G[m];
                  if (!N(oe)) break;
                  p = oe;
                }
                return p;
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixUnusedLabel", B = [e.Diagnostics.Unused_label.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(Q) {
                var le = e.textChanges.ChangeTracker.with(Q, function(N) {
                  return E(N, Q.sourceFile, Q.span.start);
                });
                return [C.createCodeFixAction(w, le, e.Diagnostics.Remove_unused_label, w, e.Diagnostics.Remove_all_unused_labels)];
              }, fixIds: [w], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, B, function(le, N) {
                  return E(le, N.file, N.start);
                });
              } });
              function E(Q, le, N) {
                var p = e.getTokenAtPosition(le, N), m = e.cast(p.parent, e.isLabeledStatement), G = p.getStart(le), oe = m.statement.getStart(le), f = e.positionsAreOnSameLine(G, oe, le) ? oe : e.skipTrivia(le.text, e.findChildOfKind(m, 58, le).end, true);
                Q.deleteRange(le, { pos: G, end: f });
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixJSDocTypes_plain", B = "fixJSDocTypes_nullable", E = [e.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments.code];
              C.registerCodeFix({ errorCodes: E, getCodeActions: function(p) {
                var m = p.sourceFile, G = p.program.getTypeChecker(), oe = le(m, p.span.start, G);
                if (!oe) return;
                var f = oe.typeNode, T = oe.type, K = f.getText(m), b = [se(T, w, e.Diagnostics.Change_all_jsdoc_style_types_to_TypeScript)];
                return f.kind === 314 && b.push(se(G.getNullableType(T, 32768), B, e.Diagnostics.Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types)), b;
                function se(J, ie, R) {
                  var q = e.textChanges.ChangeTracker.with(p, function(O) {
                    return Q(O, m, f, J, G);
                  });
                  return C.createCodeFixAction("jdocTypes", q, [e.Diagnostics.Change_0_to_1, K, G.typeToString(J)], ie, R);
                }
              }, fixIds: [w, B], getAllCodeActions: function(p) {
                var m = p.fixId, G = p.program, oe = p.sourceFile, f = G.getTypeChecker();
                return C.codeFixAll(p, E, function(T, K) {
                  var b = le(K.file, K.start, f);
                  if (!!b) {
                    var se = b.typeNode, J = b.type, ie = se.kind === 314 && m === B ? f.getNullableType(J, 32768) : J;
                    Q(T, oe, se, ie, f);
                  }
                });
              } });
              function Q(p, m, G, oe, f) {
                p.replaceNode(m, G, f.typeToTypeNode(oe, G, void 0));
              }
              function le(p, m, G) {
                var oe = e.findAncestor(e.getTokenAtPosition(p, m), N), f = oe && oe.type;
                return f && { typeNode: f, type: G.getTypeFromTypeNode(f) };
              }
              function N(p) {
                switch (p.kind) {
                  case 229:
                  case 174:
                  case 175:
                  case 256:
                  case 172:
                  case 176:
                  case 195:
                  case 169:
                  case 168:
                  case 164:
                  case 167:
                  case 166:
                  case 173:
                  case 259:
                  case 211:
                  case 254:
                    return true;
                  default:
                    return false;
                }
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixMissingCallParentheses", B = [e.Diagnostics.This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead.code];
              C.registerCodeFix({ errorCodes: B, fixIds: [w], getCodeActions: function(le) {
                var N = le.sourceFile, p = le.span, m = Q(N, p.start);
                if (!!m) {
                  var G = e.textChanges.ChangeTracker.with(le, function(oe) {
                    return E(oe, le.sourceFile, m);
                  });
                  return [C.createCodeFixAction(w, G, e.Diagnostics.Add_missing_call_parentheses, w, e.Diagnostics.Add_all_missing_call_parentheses)];
                }
              }, getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  var m = Q(p.file, p.start);
                  m && E(N, p.file, m);
                });
              } });
              function E(le, N, p) {
                le.replaceNodeWithText(N, p, "".concat(p.text, "()"));
              }
              function Q(le, N) {
                var p = e.getTokenAtPosition(le, N);
                if (e.isPropertyAccessExpression(p.parent)) {
                  for (var m = p.parent; e.isPropertyAccessExpression(m.parent); ) m = m.parent;
                  return m.name;
                }
                if (e.isIdentifier(p)) return p;
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixAwaitInSyncFunction", B = [e.Diagnostics.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code, e.Diagnostics.for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code, e.Diagnostics.Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(N) {
                var p = N.sourceFile, m = N.span, G = Q(p, m.start);
                if (!!G) {
                  var oe = e.textChanges.ChangeTracker.with(N, function(f) {
                    return le(f, p, G);
                  });
                  return [C.createCodeFixAction(w, oe, e.Diagnostics.Add_async_modifier_to_containing_function, w, e.Diagnostics.Add_all_missing_async_modifiers)];
                }
              }, fixIds: [w], getAllCodeActions: function(p) {
                var m = new e.Map();
                return C.codeFixAll(p, B, function(G, oe) {
                  var f = Q(oe.file, oe.start);
                  !f || !e.addToSeen(m, e.getNodeId(f.insertBefore)) || le(G, p.sourceFile, f);
                });
              } });
              function E(N) {
                if (N.type) return N.type;
                if (e.isVariableDeclaration(N.parent) && N.parent.type && e.isFunctionTypeNode(N.parent.type)) return N.parent.type.type;
              }
              function Q(N, p) {
                var m = e.getTokenAtPosition(N, p), G = e.getContainingFunction(m);
                if (!!G) {
                  var oe;
                  switch (G.kind) {
                    case 169:
                      oe = G.name;
                      break;
                    case 256:
                    case 213:
                      oe = e.findChildOfKind(G, 98, N);
                      break;
                    case 214:
                      var f = G.typeParameters ? 29 : 20;
                      oe = e.findChildOfKind(G, f, N) || e.first(G.parameters);
                      break;
                    default:
                      return;
                  }
                  return oe && { insertBefore: oe, returnType: E(G) };
                }
              }
              function le(N, p, m) {
                var G = m.insertBefore, oe = m.returnType;
                if (oe) {
                  var f = e.getEntityNameFromTypeNode(oe);
                  (!f || f.kind !== 79 || f.text !== "Promise") && N.replaceNode(p, oe, e.factory.createTypeReferenceNode("Promise", e.factory.createNodeArray([oe])));
                }
                N.insertModifierBefore(p, 131, G);
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = [e.Diagnostics._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property.code, e.Diagnostics._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor.code], B = "fixPropertyOverrideAccessor";
              C.registerCodeFix({ errorCodes: w, getCodeActions: function(Q) {
                var le = E(Q.sourceFile, Q.span.start, Q.span.length, Q.errorCode, Q);
                if (le) return [C.createCodeFixAction(B, le, e.Diagnostics.Generate_get_and_set_accessors, B, e.Diagnostics.Generate_get_and_set_accessors_for_all_overriding_properties)];
              }, fixIds: [B], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, w, function(le, N) {
                  var p = E(N.file, N.start, N.length, N.code, Q);
                  if (p) for (var m = 0, G = p; m < G.length; m++) {
                    var oe = G[m];
                    le.pushRaw(Q.sourceFile, oe);
                  }
                });
              } });
              function E(Q, le, N, p, m) {
                var G, oe;
                if (p === e.Diagnostics._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property.code) G = le, oe = le + N;
                else if (p === e.Diagnostics._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor.code) {
                  var f = m.program.getTypeChecker(), T = e.getTokenAtPosition(Q, le).parent;
                  e.Debug.assert(e.isAccessor(T), "error span of fixPropertyOverrideAccessor should only be on an accessor");
                  var K = T.parent;
                  e.Debug.assert(e.isClassLike(K), "erroneous accessors should only be inside classes");
                  var b = e.singleOrUndefined(C.getAllSupers(K, f));
                  if (!b) return [];
                  var se = e.unescapeLeadingUnderscores(e.getTextOfPropertyName(T.name)), J = f.getPropertyOfType(f.getTypeAtLocation(b), se);
                  if (!J || !J.valueDeclaration) return [];
                  G = J.valueDeclaration.pos, oe = J.valueDeclaration.end, Q = e.getSourceFileOfNode(J.valueDeclaration);
                } else e.Debug.fail("fixPropertyOverrideAccessor codefix got unexpected error code " + p);
                return C.generateAccessorFromProperty(Q, m.program, G, oe, m, e.Diagnostics.Generate_get_and_set_accessors.message);
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "inferFromUsage", B = [e.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code, e.Diagnostics.Variable_0_implicitly_has_an_1_type.code, e.Diagnostics.Parameter_0_implicitly_has_an_1_type.code, e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code, e.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code, e.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code, e.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code, e.Diagnostics.Member_0_implicitly_has_an_1_type.code, e.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code, e.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code, e.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code, e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code, e.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code, e.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code, e.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code, e.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code, e.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(q) {
                var O = q.sourceFile, ve = q.program, ee = q.span.start, he = q.errorCode, F = q.cancellationToken, x = q.host, X = q.preferences, $ = e.getTokenAtPosition(O, ee), A, y = e.textChanges.ChangeTracker.with(q, function(L) {
                  A = le(L, O, $, he, ve, F, e.returnTrue, x, X);
                }), V = A && e.getNameOfDeclaration(A);
                return !V || y.length === 0 ? void 0 : [C.createCodeFixAction(w, y, [E(he, $), e.getTextOfNode(V)], w, e.Diagnostics.Infer_all_types_from_usage)];
              }, fixIds: [w], getAllCodeActions: function(q) {
                var O = q.sourceFile, ve = q.program, ee = q.cancellationToken, he = q.host, F = q.preferences, x = e.nodeSeenTracker();
                return C.codeFixAll(q, B, function(X, $) {
                  le(X, O, e.getTokenAtPosition($.file, $.start), $.code, ve, ee, x, he, F);
                });
              } });
              function E(q, O) {
                switch (q) {
                  case e.Diagnostics.Parameter_0_implicitly_has_an_1_type.code:
                  case e.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
                    return e.isSetAccessorDeclaration(e.getContainingFunction(O)) ? e.Diagnostics.Infer_type_of_0_from_usage : e.Diagnostics.Infer_parameter_types_from_usage;
                  case e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code:
                  case e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:
                    return e.Diagnostics.Infer_parameter_types_from_usage;
                  case e.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code:
                    return e.Diagnostics.Infer_this_type_of_0_from_usage;
                  default:
                    return e.Diagnostics.Infer_type_of_0_from_usage;
                }
              }
              function Q(q) {
                switch (q) {
                  case e.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code:
                    return e.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code;
                  case e.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
                    return e.Diagnostics.Variable_0_implicitly_has_an_1_type.code;
                  case e.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
                    return e.Diagnostics.Parameter_0_implicitly_has_an_1_type.code;
                  case e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:
                    return e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code;
                  case e.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code:
                    return e.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code;
                  case e.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code:
                    return e.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code;
                  case e.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code:
                    return e.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code;
                  case e.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
                    return e.Diagnostics.Member_0_implicitly_has_an_1_type.code;
                }
                return q;
              }
              function le(q, O, ve, ee, he, F, x, X, $) {
                if (!(!e.isParameterPropertyModifier(ve.kind) && ve.kind !== 79 && ve.kind !== 25 && ve.kind !== 108)) {
                  var A = ve.parent, y = C.createImportAdder(O, he, $, X);
                  switch (ee = Q(ee), ee) {
                    case e.Diagnostics.Member_0_implicitly_has_an_1_type.code:
                    case e.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code:
                      if (e.isVariableDeclaration(A) && x(A) || e.isPropertyDeclaration(A) || e.isPropertySignature(A)) return N(q, y, O, A, he, X, F), y.writeFixes(q), A;
                      if (e.isPropertyAccessExpression(A)) {
                        var V = se(A.name, he, F), L = e.getTypeNodeIfAccessible(V, A, he, X);
                        if (L) {
                          var P = e.factory.createJSDocTypeTag(void 0, e.factory.createJSDocTypeExpression(L), void 0);
                          q.addJSDocTags(O, e.cast(A.parent.parent, e.isExpressionStatement), [P]);
                        }
                        return y.writeFixes(q), A;
                      }
                      return;
                    case e.Diagnostics.Variable_0_implicitly_has_an_1_type.code: {
                      var k = he.getTypeChecker().getSymbolAtLocation(ve);
                      return k && k.valueDeclaration && e.isVariableDeclaration(k.valueDeclaration) && x(k.valueDeclaration) ? (N(q, y, e.getSourceFileOfNode(k.valueDeclaration), k.valueDeclaration, he, X, F), y.writeFixes(q), k.valueDeclaration) : void 0;
                    }
                  }
                  var Y = e.getContainingFunction(ve);
                  if (Y !== void 0) {
                    var U;
                    switch (ee) {
                      case e.Diagnostics.Parameter_0_implicitly_has_an_1_type.code:
                        if (e.isSetAccessorDeclaration(Y)) {
                          oe(q, y, O, Y, he, X, F), U = Y;
                          break;
                        }
                      case e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code:
                        if (x(Y)) {
                          var j = e.cast(A, e.isParameter);
                          p(q, y, O, j, Y, he, X, F), U = j;
                        }
                        break;
                      case e.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code:
                      case e.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code:
                        e.isGetAccessorDeclaration(Y) && e.isIdentifier(Y.name) && (f(q, y, O, Y, se(Y.name, he, F), he, X), U = Y);
                        break;
                      case e.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code:
                        e.isSetAccessorDeclaration(Y) && (oe(q, y, O, Y, he, X, F), U = Y);
                        break;
                      case e.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code:
                        e.textChanges.isThisTypeAnnotatable(Y) && x(Y) && (m(q, O, Y, he, X, F), U = Y);
                        break;
                      default:
                        return e.Debug.fail(String(ee));
                    }
                    return y.writeFixes(q), U;
                  }
                }
              }
              function N(q, O, ve, ee, he, F, x) {
                e.isIdentifier(ee.name) && f(q, O, ve, ee, se(ee.name, he, x), he, F);
              }
              function p(q, O, ve, ee, he, F, x, X) {
                if (!!e.isIdentifier(ee.name)) {
                  var $ = J(he, ve, F, X);
                  if (e.Debug.assert(he.parameters.length === $.length, "Parameter count and inference count should match"), e.isInJSFile(he)) K(q, ve, $, F, x);
                  else {
                    var A = e.isArrowFunction(he) && !e.findChildOfKind(he, 20, ve);
                    A && q.insertNodeBefore(ve, e.first(he.parameters), e.factory.createToken(20));
                    for (var y = 0, V = $; y < V.length; y++) {
                      var L = V[y], P = L.declaration, k = L.type;
                      P && !P.type && !P.initializer && f(q, O, ve, P, k, F, x);
                    }
                    A && q.insertNodeAfter(ve, e.last(he.parameters), e.factory.createToken(21));
                  }
                }
              }
              function m(q, O, ve, ee, he, F) {
                var x = ie(ve, O, ee, F);
                if (!(!x || !x.length)) {
                  var X = R(ee, x, F).thisParameter(), $ = e.getTypeNodeIfAccessible(X, ve, ee, he);
                  !$ || (e.isInJSFile(ve) ? G(q, O, ve, $) : q.tryInsertThisTypeAnnotation(O, ve, $));
                }
              }
              function G(q, O, ve, ee) {
                q.addJSDocTags(O, ve, [e.factory.createJSDocThisTag(void 0, e.factory.createJSDocTypeExpression(ee))]);
              }
              function oe(q, O, ve, ee, he, F, x) {
                var X = e.firstOrUndefined(ee.parameters);
                if (X && e.isIdentifier(ee.name) && e.isIdentifier(X.name)) {
                  var $ = se(ee.name, he, x);
                  $ === he.getTypeChecker().getAnyType() && ($ = se(X.name, he, x)), e.isInJSFile(ee) ? K(q, ve, [{ declaration: X, type: $ }], he, F) : f(q, O, ve, X, $, he, F);
                }
              }
              function f(q, O, ve, ee, he, F, x) {
                var X = e.getTypeNodeIfAccessible(he, ee, F, x);
                if (X) if (e.isInJSFile(ve) && ee.kind !== 166) {
                  var $ = e.isVariableDeclaration(ee) ? e.tryCast(ee.parent.parent, e.isVariableStatement) : ee;
                  if (!$) return;
                  var A = e.factory.createJSDocTypeExpression(X), y = e.isGetAccessorDeclaration(ee) ? e.factory.createJSDocReturnTag(void 0, A, void 0) : e.factory.createJSDocTypeTag(void 0, A, void 0);
                  q.addJSDocTags(ve, $, [y]);
                } else T(X, ee, ve, q, O, e.getEmitScriptTarget(F.getCompilerOptions())) || q.tryInsertTypeAnnotation(ve, ee, X);
              }
              function T(q, O, ve, ee, he, F) {
                var x = C.tryGetAutoImportableReferenceFromTypeNode(q, F);
                return x && ee.tryInsertTypeAnnotation(ve, O, x.typeNode) ? (e.forEach(x.symbols, function(X) {
                  return he.addImportFromExportedSymbol(X, true);
                }), true) : false;
              }
              function K(q, O, ve, ee, he) {
                var F = ve.length && ve[0].declaration.parent;
                if (!!F) {
                  var x = e.mapDefined(ve, function(A) {
                    var y = A.declaration;
                    if (!(y.initializer || e.getJSDocType(y) || !e.isIdentifier(y.name))) {
                      var V = A.type && e.getTypeNodeIfAccessible(A.type, y, ee, he);
                      if (V) {
                        var L = e.factory.cloneNode(y.name);
                        return e.setEmitFlags(L, 3584), { name: e.factory.cloneNode(y.name), param: y, isOptional: !!A.isOptional, typeNode: V };
                      }
                    }
                  });
                  if (!!x.length) if (e.isArrowFunction(F) || e.isFunctionExpression(F)) {
                    var X = e.isArrowFunction(F) && !e.findChildOfKind(F, 20, O);
                    X && q.insertNodeBefore(O, e.first(F.parameters), e.factory.createToken(20)), e.forEach(x, function(A) {
                      var y = A.typeNode, V = A.param, L = e.factory.createJSDocTypeTag(void 0, e.factory.createJSDocTypeExpression(y)), P = e.factory.createJSDocComment(void 0, [L]);
                      q.insertNodeAt(O, V.getStart(O), P, { suffix: " " });
                    }), X && q.insertNodeAfter(O, e.last(F.parameters), e.factory.createToken(21));
                  } else {
                    var $ = e.map(x, function(A) {
                      var y = A.name, V = A.typeNode, L = A.isOptional;
                      return e.factory.createJSDocParameterTag(void 0, y, !!L, e.factory.createJSDocTypeExpression(V), false, void 0);
                    });
                    q.addJSDocTags(O, F, $);
                  }
                }
              }
              function b(q, O, ve) {
                return e.mapDefined(e.FindAllReferences.getReferenceEntriesForNode(-1, q, O, O.getSourceFiles(), ve), function(ee) {
                  return ee.kind !== 0 ? e.tryCast(ee.node, e.isIdentifier) : void 0;
                });
              }
              function se(q, O, ve) {
                var ee = b(q, O, ve);
                return R(O, ee, ve).single();
              }
              function J(q, O, ve, ee) {
                var he = ie(q, O, ve, ee);
                return he && R(ve, he, ee).parameters(q) || q.parameters.map(function(F) {
                  return { declaration: F, type: e.isIdentifier(F.name) ? se(F.name, ve, ee) : ve.getTypeChecker().getAnyType() };
                });
              }
              function ie(q, O, ve, ee) {
                var he;
                switch (q.kind) {
                  case 171:
                    he = e.findChildOfKind(q, 134, O);
                    break;
                  case 214:
                  case 213:
                    var F = q.parent;
                    he = (e.isVariableDeclaration(F) || e.isPropertyDeclaration(F)) && e.isIdentifier(F.name) ? F.name : q.name;
                    break;
                  case 256:
                  case 169:
                  case 168:
                    he = q.name;
                    break;
                }
                if (!!he) return b(he, ve, ee);
              }
              function R(q, O, ve) {
                var ee = q.getTypeChecker(), he = { string: function() {
                  return ee.getStringType();
                }, number: function() {
                  return ee.getNumberType();
                }, Array: function(_e) {
                  return ee.createArrayType(_e);
                }, Promise: function(_e) {
                  return ee.createPromiseType(_e);
                } }, F = [ee.getStringType(), ee.getNumberType(), ee.createArrayType(ee.getAnyType()), ee.createPromiseType(ee.getAnyType())];
                return { single: $, parameters: A, thisParameter: y };
                function x() {
                  return { isNumber: void 0, isString: void 0, isNumberOrString: void 0, candidateTypes: void 0, properties: void 0, calls: void 0, constructs: void 0, numberIndex: void 0, stringIndex: void 0, candidateThisTypes: void 0, inferredTypes: void 0 };
                }
                function X(_e) {
                  for (var we = new e.Map(), de = 0, ye = _e; de < ye.length; de++) {
                    var Ae = ye[de];
                    Ae.properties && Ae.properties.forEach(function(ir, Cr) {
                      we.has(Cr) || we.set(Cr, []), we.get(Cr).push(ir);
                    });
                  }
                  var er = new e.Map();
                  return we.forEach(function(ir, Cr) {
                    er.set(Cr, X(ir));
                  }), { isNumber: _e.some(function(ir) {
                    return ir.isNumber;
                  }), isString: _e.some(function(ir) {
                    return ir.isString;
                  }), isNumberOrString: _e.some(function(ir) {
                    return ir.isNumberOrString;
                  }), candidateTypes: e.flatMap(_e, function(ir) {
                    return ir.candidateTypes;
                  }), properties: er, calls: e.flatMap(_e, function(ir) {
                    return ir.calls;
                  }), constructs: e.flatMap(_e, function(ir) {
                    return ir.constructs;
                  }), numberIndex: e.forEach(_e, function(ir) {
                    return ir.numberIndex;
                  }), stringIndex: e.forEach(_e, function(ir) {
                    return ir.stringIndex;
                  }), candidateThisTypes: e.flatMap(_e, function(ir) {
                    return ir.candidateThisTypes;
                  }), inferredTypes: void 0 };
                }
                function $() {
                  return ne(V(O));
                }
                function A(_e) {
                  if (!(O.length === 0 || !_e.parameters)) {
                    for (var we = x(), de = 0, ye = O; de < ye.length; de++) {
                      var Ae = ye[de];
                      ve.throwIfCancellationRequested(), L(Ae, we);
                    }
                    var er = Ve(Ve([], we.constructs || [], true), we.calls || [], true);
                    return _e.parameters.map(function(ir, Cr) {
                      for (var Ye = [], Br = e.isRestParameter(ir), Er = false, Ne = 0, n = er; Ne < n.length; Ne++) {
                        var lr = n[Ne];
                        if (lr.argumentTypes.length <= Cr) Er = e.isInJSFile(_e), Ye.push(ee.getUndefinedType());
                        else if (Br) for (var be = Cr; be < lr.argumentTypes.length; be++) Ye.push(ee.getBaseTypeOfLiteralType(lr.argumentTypes[be]));
                        else Ye.push(ee.getBaseTypeOfLiteralType(lr.argumentTypes[Cr]));
                      }
                      if (e.isIdentifier(ir.name)) {
                        var Ge = V(b(ir.name, q, ve));
                        Ye.push.apply(Ye, Br ? e.mapDefined(Ge, ee.getElementTypeOfArrayType) : Ge);
                      }
                      var ur = ne(Ye);
                      return { type: Br ? ee.createArrayType(ur) : ur, isOptional: Er && !Br, declaration: ir };
                    });
                  }
                }
                function y() {
                  for (var _e = x(), we = 0, de = O; we < de.length; we++) {
                    var ye = de[we];
                    ve.throwIfCancellationRequested(), L(ye, _e);
                  }
                  return ne(_e.candidateThisTypes || e.emptyArray);
                }
                function V(_e) {
                  for (var we = x(), de = 0, ye = _e; de < ye.length; de++) {
                    var Ae = ye[de];
                    ve.throwIfCancellationRequested(), L(Ae, we);
                  }
                  return We(we);
                }
                function L(_e, we) {
                  for (; e.isRightSideOfQualifiedNameOrPropertyAccess(_e); ) _e = _e.parent;
                  switch (_e.parent.kind) {
                    case 238:
                      k(_e, we);
                      break;
                    case 220:
                      we.isNumber = true;
                      break;
                    case 219:
                      Y(_e.parent, we);
                      break;
                    case 221:
                      U(_e, _e.parent, we);
                      break;
                    case 289:
                    case 290:
                      j(_e.parent, we);
                      break;
                    case 208:
                    case 209:
                      _e.parent.expression === _e ? H(_e.parent, we) : P(_e, we);
                      break;
                    case 206:
                      I(_e.parent, we);
                      break;
                    case 207:
                      l(_e.parent, _e, we);
                      break;
                    case 296:
                    case 297:
                      d(_e.parent, we);
                      break;
                    case 167:
                      D(_e.parent, we);
                      break;
                    case 254: {
                      var de = _e.parent, ye = de.name, Ae = de.initializer;
                      if (_e === ye) {
                        Ae && rr(we, ee.getTypeAtLocation(Ae));
                        break;
                      }
                    }
                    default:
                      return P(_e, we);
                  }
                }
                function P(_e, we) {
                  e.isExpressionNode(_e) && rr(we, ee.getContextualType(_e));
                }
                function k(_e, we) {
                  rr(we, e.isCallExpression(_e) ? ee.getVoidType() : ee.getAnyType());
                }
                function Y(_e, we) {
                  switch (_e.operator) {
                    case 45:
                    case 46:
                    case 40:
                    case 54:
                      we.isNumber = true;
                      break;
                    case 39:
                      we.isNumberOrString = true;
                      break;
                  }
                }
                function U(_e, we, de) {
                  switch (we.operatorToken.kind) {
                    case 42:
                    case 41:
                    case 43:
                    case 44:
                    case 47:
                    case 48:
                    case 49:
                    case 50:
                    case 51:
                    case 52:
                    case 65:
                    case 67:
                    case 66:
                    case 68:
                    case 69:
                    case 73:
                    case 74:
                    case 78:
                    case 70:
                    case 72:
                    case 71:
                    case 40:
                    case 29:
                    case 32:
                    case 31:
                    case 33:
                      var ye = ee.getTypeAtLocation(we.left === _e ? we.right : we.left);
                      ye.flags & 1056 ? rr(de, ye) : de.isNumber = true;
                      break;
                    case 64:
                    case 39:
                      var Ae = ee.getTypeAtLocation(we.left === _e ? we.right : we.left);
                      Ae.flags & 1056 ? rr(de, Ae) : Ae.flags & 296 ? de.isNumber = true : Ae.flags & 402653316 ? de.isString = true : Ae.flags & 1 || (de.isNumberOrString = true);
                      break;
                    case 63:
                    case 34:
                    case 36:
                    case 37:
                    case 35:
                      rr(de, ee.getTypeAtLocation(we.left === _e ? we.right : we.left));
                      break;
                    case 101:
                      _e === we.left && (de.isString = true);
                      break;
                    case 56:
                    case 60:
                      _e === we.left && (_e.parent.parent.kind === 254 || e.isAssignmentExpression(_e.parent.parent, true)) && rr(de, ee.getTypeAtLocation(we.right));
                      break;
                    case 55:
                    case 27:
                    case 102:
                      break;
                  }
                }
                function j(_e, we) {
                  rr(we, ee.getTypeAtLocation(_e.parent.parent.expression));
                }
                function H(_e, we) {
                  var de = { argumentTypes: [], return_: x() };
                  if (_e.arguments) for (var ye = 0, Ae = _e.arguments; ye < Ae.length; ye++) {
                    var er = Ae[ye];
                    de.argumentTypes.push(ee.getTypeAtLocation(er));
                  }
                  L(_e, de.return_), _e.kind === 208 ? (we.calls || (we.calls = [])).push(de) : (we.constructs || (we.constructs = [])).push(de);
                }
                function I(_e, we) {
                  var de = e.escapeLeadingUnderscores(_e.name.text);
                  we.properties || (we.properties = new e.Map());
                  var ye = we.properties.get(de) || x();
                  L(_e, ye), we.properties.set(de, ye);
                }
                function l(_e, we, de) {
                  if (we === _e.argumentExpression) {
                    de.isNumberOrString = true;
                    return;
                  } else {
                    var ye = ee.getTypeAtLocation(_e.argumentExpression), Ae = x();
                    L(_e, Ae), ye.flags & 296 ? de.numberIndex = Ae : de.stringIndex = Ae;
                  }
                }
                function d(_e, we) {
                  var de = e.isVariableDeclaration(_e.parent.parent) ? _e.parent.parent : _e.parent;
                  Ie(we, ee.getTypeAtLocation(de));
                }
                function D(_e, we) {
                  Ie(we, ee.getTypeAtLocation(_e.parent));
                }
                function fe(_e, we) {
                  for (var de = [], ye = 0, Ae = _e; ye < Ae.length; ye++) for (var er = Ae[ye], ir = 0, Cr = we; ir < Cr.length; ir++) {
                    var Ye = Cr[ir], Br = Ye.high, Er = Ye.low;
                    Br(er) && (e.Debug.assert(!Er(er), "Priority can't have both low and high"), de.push(Er));
                  }
                  return _e.filter(function(Ne) {
                    return de.every(function(n) {
                      return !n(Ne);
                    });
                  });
                }
                function g(_e) {
                  return ne(We(_e));
                }
                function ne(_e) {
                  if (!_e.length) return ee.getAnyType();
                  var we = ee.getUnionType([ee.getStringType(), ee.getNumberType()]), de = [{ high: function(er) {
                    return er === ee.getStringType() || er === ee.getNumberType();
                  }, low: function(er) {
                    return er === we;
                  } }, { high: function(er) {
                    return !(er.flags & 16385);
                  }, low: function(er) {
                    return !!(er.flags & 16385);
                  } }, { high: function(er) {
                    return !(er.flags & 114689) && !(e.getObjectFlags(er) & 16);
                  }, low: function(er) {
                    return !!(e.getObjectFlags(er) & 16);
                  } }], ye = fe(_e, de), Ae = ye.filter(function(er) {
                    return e.getObjectFlags(er) & 16;
                  });
                  return Ae.length && (ye = ye.filter(function(er) {
                    return !(e.getObjectFlags(er) & 16);
                  }), ye.push(ue(Ae))), ee.getWidenedType(ee.getUnionType(ye.map(ee.getBaseTypeOfLiteralType), 2));
                }
                function ue(_e) {
                  if (_e.length === 1) return _e[0];
                  for (var we = [], de = [], ye = [], Ae = [], er = false, ir = false, Cr = e.createMultiMap(), Ye = 0, Br = _e; Ye < Br.length; Ye++) {
                    for (var Er = Br[Ye], Ne = 0, n = ee.getPropertiesOfType(Er); Ne < n.length; Ne++) {
                      var lr = n[Ne];
                      Cr.add(lr.name, lr.valueDeclaration ? ee.getTypeOfSymbolAtLocation(lr, lr.valueDeclaration) : ee.getAnyType());
                    }
                    we.push.apply(we, ee.getSignaturesOfType(Er, 0)), de.push.apply(de, ee.getSignaturesOfType(Er, 1));
                    var be = ee.getIndexInfoOfType(Er, 0);
                    be && (ye.push(be.type), er = er || be.isReadonly);
                    var Ge = ee.getIndexInfoOfType(Er, 1);
                    Ge && (Ae.push(Ge.type), ir = ir || Ge.isReadonly);
                  }
                  var ur = e.mapEntries(Cr, function(Ir, wr) {
                    var Ur = wr.length < _e.length ? 16777216 : 0, ii = ee.createSymbol(4 | Ur, Ir);
                    return ii.type = ee.getUnionType(wr), [Ir, ii];
                  }), yr = [];
                  return ye.length && yr.push(ee.createIndexInfo(ee.getStringType(), ee.getUnionType(ye), er)), Ae.length && yr.push(ee.createIndexInfo(ee.getNumberType(), ee.getUnionType(Ae), ir)), ee.createAnonymousType(_e[0].symbol, ur, we, de, yr);
                }
                function We(_e) {
                  var we, de, ye, Ae = [];
                  _e.isNumber && Ae.push(ee.getNumberType()), _e.isString && Ae.push(ee.getStringType()), _e.isNumberOrString && Ae.push(ee.getUnionType([ee.getStringType(), ee.getNumberType()])), _e.numberIndex && Ae.push(ee.createArrayType(g(_e.numberIndex))), (((we = _e.properties) === null || we === void 0 ? void 0 : we.size) || ((de = _e.constructs) === null || de === void 0 ? void 0 : de.length) || _e.stringIndex) && Ae.push(Fe(_e));
                  var er = (_e.candidateTypes || []).map(function(Cr) {
                    return ee.getBaseTypeOfLiteralType(Cr);
                  }), ir = !((ye = _e.calls) === null || ye === void 0) && ye.length ? Fe(_e) : void 0;
                  return ir && er ? Ae.push(ee.getUnionType(Ve([ir], er, true), 2)) : (ir && Ae.push(ir), e.length(er) && Ae.push.apply(Ae, er)), Ae.push.apply(Ae, Z(_e)), Ae;
                }
                function Fe(_e) {
                  var we = new e.Map();
                  _e.properties && _e.properties.forEach(function(er, ir) {
                    var Cr = ee.createSymbol(4, ir);
                    Cr.type = g(er), we.set(ir, Cr);
                  });
                  var de = _e.calls ? [He(_e.calls)] : [], ye = _e.constructs ? [He(_e.constructs)] : [], Ae = _e.stringIndex ? [ee.createIndexInfo(ee.getStringType(), g(_e.stringIndex), false)] : [];
                  return ee.createAnonymousType(void 0, we, de, ye, Ae);
                }
                function Z(_e) {
                  if (!_e.properties || !_e.properties.size) return [];
                  var we = F.filter(function(de) {
                    return Be(de, _e);
                  });
                  return 0 < we.length && we.length < 3 ? we.map(function(de) {
                    return ge(de, _e);
                  }) : [];
                }
                function Be(_e, we) {
                  return we.properties ? !e.forEachEntry(we.properties, function(de, ye) {
                    var Ae = ee.getTypeOfPropertyOfType(_e, ye);
                    if (!Ae) return true;
                    if (de.calls) {
                      var er = ee.getSignaturesOfType(Ae, 0);
                      return !er.length || !ee.isTypeAssignableTo(Ae, Ee(de.calls));
                    } else return !ee.isTypeAssignableTo(Ae, g(de));
                  }) : false;
                }
                function ge(_e, we) {
                  if (!(e.getObjectFlags(_e) & 4) || !we.properties) return _e;
                  var de = _e.target, ye = e.singleOrUndefined(de.typeParameters);
                  if (!ye) return _e;
                  var Ae = [];
                  return we.properties.forEach(function(er, ir) {
                    var Cr = ee.getTypeOfPropertyOfType(de, ir);
                    e.Debug.assert(!!Cr, "generic should have all the properties of its reference."), Ae.push.apply(Ae, Re(Cr, g(er), ye));
                  }), he[_e.symbol.escapedName](ne(Ae));
                }
                function Re(_e, we, de) {
                  if (_e === de) return [we];
                  if (_e.flags & 3145728) return e.flatMap(_e.types, function(Br) {
                    return Re(Br, we, de);
                  });
                  if (e.getObjectFlags(_e) & 4 && e.getObjectFlags(we) & 4) {
                    var ye = ee.getTypeArguments(_e), Ae = ee.getTypeArguments(we), er = [];
                    if (ye && Ae) for (var ir = 0; ir < ye.length; ir++) Ae[ir] && er.push.apply(er, Re(ye[ir], Ae[ir], de));
                    return er;
                  }
                  var Cr = ee.getSignaturesOfType(_e, 0), Ye = ee.getSignaturesOfType(we, 0);
                  return Cr.length === 1 && Ye.length === 1 ? ze(Cr[0], Ye[0], de) : [];
                }
                function ze(_e, we, de) {
                  for (var ye = [], Ae = 0; Ae < _e.parameters.length; Ae++) {
                    var er = _e.parameters[Ae], ir = we.parameters[Ae], Cr = _e.declaration && e.isRestParameter(_e.declaration.parameters[Ae]);
                    if (!ir) break;
                    var Ye = er.valueDeclaration ? ee.getTypeOfSymbolAtLocation(er, er.valueDeclaration) : ee.getAnyType(), Br = Cr && ee.getElementTypeOfArrayType(Ye);
                    Br && (Ye = Br);
                    var Er = ir.type || (ir.valueDeclaration ? ee.getTypeOfSymbolAtLocation(ir, ir.valueDeclaration) : ee.getAnyType());
                    ye.push.apply(ye, Re(Ye, Er, de));
                  }
                  var Ne = ee.getReturnTypeOfSignature(_e), n = ee.getReturnTypeOfSignature(we);
                  return ye.push.apply(ye, Re(Ne, n, de)), ye;
                }
                function Ee(_e) {
                  return ee.createAnonymousType(void 0, e.createSymbolTable(), [He(_e)], e.emptyArray, e.emptyArray);
                }
                function He(_e) {
                  for (var we = [], de = Math.max.apply(Math, _e.map(function(ir) {
                    return ir.argumentTypes.length;
                  })), ye = function(ir) {
                    var Cr = ee.createSymbol(1, e.escapeLeadingUnderscores("arg".concat(ir)));
                    Cr.type = ne(_e.map(function(Ye) {
                      return Ye.argumentTypes[ir] || ee.getUndefinedType();
                    })), _e.some(function(Ye) {
                      return Ye.argumentTypes[ir] === void 0;
                    }) && (Cr.flags |= 16777216), we.push(Cr);
                  }, Ae = 0; Ae < de; Ae++) ye(Ae);
                  var er = g(X(_e.map(function(ir) {
                    return ir.return_;
                  })));
                  return ee.createSignature(void 0, void 0, void 0, we, er, void 0, de, 0);
                }
                function rr(_e, we) {
                  we && !(we.flags & 1) && !(we.flags & 131072) && (_e.candidateTypes || (_e.candidateTypes = [])).push(we);
                }
                function Ie(_e, we) {
                  we && !(we.flags & 1) && !(we.flags & 131072) && (_e.candidateThisTypes || (_e.candidateThisTypes = [])).push(we);
                }
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixReturnTypeInAsyncFunction", B = [e.Diagnostics.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0.code];
              C.registerCodeFix({ errorCodes: B, fixIds: [w], getCodeActions: function(N) {
                var p = N.sourceFile, m = N.program, G = N.span, oe = m.getTypeChecker(), f = E(p, m.getTypeChecker(), G.start);
                if (!!f) {
                  var T = f.returnTypeNode, K = f.returnType, b = f.promisedTypeNode, se = f.promisedType, J = e.textChanges.ChangeTracker.with(N, function(ie) {
                    return Q(ie, p, T, b);
                  });
                  return [C.createCodeFixAction(w, J, [e.Diagnostics.Replace_0_with_Promise_1, oe.typeToString(K), oe.typeToString(se)], w, e.Diagnostics.Fix_all_incorrect_return_type_of_an_async_functions)];
                }
              }, getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  var m = E(p.file, le.program.getTypeChecker(), p.start);
                  m && Q(N, p.file, m.returnTypeNode, m.promisedTypeNode);
                });
              } });
              function E(le, N, p) {
                if (!e.isInJSFile(le)) {
                  var m = e.getTokenAtPosition(le, p), G = e.findAncestor(m, e.isFunctionLikeDeclaration), oe = G == null ? void 0 : G.type;
                  if (!!oe) {
                    var f = N.getTypeFromTypeNode(oe), T = N.getAwaitedType(f) || N.getVoidType(), K = N.typeToTypeNode(T, oe, void 0);
                    if (K) return { returnTypeNode: oe, returnType: f, promisedTypeNode: K, promisedType: T };
                  }
                }
              }
              function Q(le, N, p, m) {
                le.replaceNode(N, p, e.factory.createTypeReferenceNode("Promise", [m]));
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "disableJsDiagnostics", B = "disableJsDiagnostics", E = e.mapDefined(Object.keys(e.Diagnostics), function(le) {
                var N = e.Diagnostics[le];
                return N.category === e.DiagnosticCategory.Error ? N.code : void 0;
              });
              C.registerCodeFix({ errorCodes: E, getCodeActions: function(N) {
                var p = N.sourceFile, m = N.program, G = N.span, oe = N.host, f = N.formatContext;
                if (!(!e.isInJSFile(p) || !e.isCheckJsEnabledForFile(p, m.getCompilerOptions()))) {
                  var T = p.checkJsDirective ? "" : e.getNewLineOrDefaultFromHost(oe, f.options), K = [C.createCodeFixActionWithoutFixAll(w, [C.createFileTextChanges(p.fileName, [e.createTextChange(p.checkJsDirective ? e.createTextSpanFromBounds(p.checkJsDirective.pos, p.checkJsDirective.end) : e.createTextSpan(0, 0), "// @ts-nocheck".concat(T))])], e.Diagnostics.Disable_checking_for_this_file)];
                  return e.textChanges.isValidLocationToAddComment(p, G.start) && K.unshift(C.createCodeFixAction(w, e.textChanges.ChangeTracker.with(N, function(b) {
                    return Q(b, p, G.start);
                  }), e.Diagnostics.Ignore_this_error_message, B, e.Diagnostics.Add_ts_ignore_to_all_error_messages)), K;
                }
              }, fixIds: [B], getAllCodeActions: function(le) {
                var N = new e.Set();
                return C.codeFixAll(le, E, function(p, m) {
                  e.textChanges.isValidLocationToAddComment(m.file, m.start) && Q(p, m.file, m.start, N);
                });
              } });
              function Q(le, N, p, m) {
                var G = e.getLineAndCharacterOfPosition(N, p).line;
                (!m || e.tryAddToSet(m, G)) && le.insertCommentBeforeLine(N, G, p, " @ts-ignore");
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w(ee, he, F, x, X, $, A) {
                for (var y = ee.symbol.members, V = 0, L = he; V < L.length; V++) {
                  var P = L[V];
                  y.has(P.escapedName) || Q(P, ee, F, x, X, $, A, void 0);
                }
              }
              C.createMissingMemberNodes = w;
              function B(ee) {
                return { trackSymbol: function() {
                  return false;
                }, moduleResolverHost: e.getModuleSpecifierResolverHost(ee.program, ee.host) };
              }
              C.getNoopSymbolTrackerWithResolver = B;
              var E;
              (function(ee) {
                ee[ee.Method = 1] = "Method", ee[ee.Property = 2] = "Property", ee[ee.All = 3] = "All";
              })(E = C.PreserveOptionalFlags || (C.PreserveOptionalFlags = {}));
              function Q(ee, he, F, x, X, $, A, y, V, L) {
                V === void 0 && (V = 3), L === void 0 && (L = false);
                var P = ee.getDeclarations();
                if (!(P && P.length)) return;
                var k = x.program.getTypeChecker(), Y = e.getEmitScriptTarget(x.program.getCompilerOptions()), U = P[0], j = e.getSynthesizedDeepClone(e.getNameOfDeclaration(U), false), H = b(e.getEffectiveModifierFlags(U)), I = H ? e.factory.createNodeArray([H]) : void 0, l = k.getWidenedType(k.getTypeOfSymbolAtLocation(ee, he)), d = !!(ee.flags & 16777216), D = !!(he.flags & 16777216) || L, fe = e.getQuotePreference(F, X);
                switch (U.kind) {
                  case 166:
                  case 167:
                    var g = fe === 0 ? 268435456 : void 0, ne = k.typeToTypeNode(l, he, g, B(x));
                    if ($) {
                      var ue = q(ne, Y);
                      ue && (ne = ue.typeNode, ve($, ue.symbols));
                    }
                    A(e.factory.createPropertyDeclaration(void 0, I, j, d && V & 2 ? e.factory.createToken(57) : void 0, ne, void 0));
                    break;
                  case 172:
                  case 173: {
                    var We = k.typeToTypeNode(l, he, void 0, B(x)), Fe = e.getAllAccessorDeclarations(P, U), Z = Fe.secondAccessor ? [Fe.firstAccessor, Fe.secondAccessor] : [Fe.firstAccessor];
                    if ($) {
                      var ue = q(We, Y);
                      ue && (We = ue.typeNode, ve($, ue.symbols));
                    }
                    for (var Be = 0, ge = Z; Be < ge.length; Be++) {
                      var Re = ge[Be];
                      if (e.isGetAccessorDeclaration(Re)) A(e.factory.createGetAccessorDeclaration(void 0, I, j, e.emptyArray, We, D ? void 0 : y || T(fe)));
                      else {
                        e.Debug.assertNode(Re, e.isSetAccessorDeclaration, "The counterpart to a getter should be a setter");
                        var ze = e.getSetAccessorValueParameter(Re), Ee = ze && e.isIdentifier(ze.name) ? e.idText(ze.name) : void 0;
                        A(e.factory.createSetAccessorDeclaration(void 0, I, j, m(1, [Ee], [We], 1, false), D ? void 0 : y || T(fe)));
                      }
                    }
                    break;
                  }
                  case 168:
                  case 169:
                    var He = k.getSignaturesOfType(l, 0);
                    if (!e.some(He)) break;
                    if (P.length === 1) {
                      e.Debug.assert(He.length === 1, "One declaration implies one signature");
                      var rr = He[0];
                      we(fe, rr, I, j, D ? void 0 : y || T(fe));
                      break;
                    }
                    for (var Ie = 0, _e = He; Ie < _e.length; Ie++) {
                      var rr = _e[Ie];
                      we(fe, rr, e.getSynthesizedDeepClones(I, false), e.getSynthesizedDeepClone(j, false));
                    }
                    if (!D) if (P.length > He.length) {
                      var rr = k.getSignatureFromDeclaration(P[P.length - 1]);
                      we(fe, rr, I, j, y || T(fe));
                    } else e.Debug.assert(P.length === He.length, "Declarations and signatures should match count"), A(G(k, x, he, He, j, d && !!(V & 1), I, fe, y));
                    break;
                }
                function we(de, ye, Ae, er, ir) {
                  var Cr = le(169, x, de, ye, ir, er, Ae, d && !!(V & 1), he, $);
                  Cr && A(Cr);
                }
              }
              C.addNewNodeForMemberSymbol = Q;
              function le(ee, he, F, x, X, $, A, y, V, L) {
                var P = he.program, k = P.getTypeChecker(), Y = e.getEmitScriptTarget(P.getCompilerOptions()), U = 524545 | (F === 0 ? 268435456 : 0), j = k.signatureToSignatureDeclaration(x, ee, V, U, B(he));
                if (!!j) {
                  var H = j.typeParameters, I = j.parameters, l = j.type;
                  if (L) {
                    if (H) {
                      var d = e.sameMap(H, function(ue) {
                        var We = ue.constraint, Fe = ue.default;
                        if (We) {
                          var Z = q(We, Y);
                          Z && (We = Z.typeNode, ve(L, Z.symbols));
                        }
                        if (Fe) {
                          var Z = q(Fe, Y);
                          Z && (Fe = Z.typeNode, ve(L, Z.symbols));
                        }
                        return e.factory.updateTypeParameterDeclaration(ue, ue.modifiers, ue.name, We, Fe);
                      });
                      H !== d && (H = e.setTextRange(e.factory.createNodeArray(d, H.hasTrailingComma), H));
                    }
                    var D = e.sameMap(I, function(ue) {
                      var We = q(ue.type, Y), Fe = ue.type;
                      return We && (Fe = We.typeNode, ve(L, We.symbols)), e.factory.updateParameterDeclaration(ue, ue.decorators, ue.modifiers, ue.dotDotDotToken, ue.name, ue.questionToken, Fe, ue.initializer);
                    });
                    if (I !== D && (I = e.setTextRange(e.factory.createNodeArray(D, I.hasTrailingComma), I)), l) {
                      var fe = q(l, Y);
                      fe && (l = fe.typeNode, ve(L, fe.symbols));
                    }
                  }
                  var g = y ? e.factory.createToken(57) : void 0, ne = j.asteriskToken;
                  if (e.isFunctionExpression(j)) return e.factory.updateFunctionExpression(j, A, j.asteriskToken, e.tryCast($, e.isIdentifier), H, I, l, X != null ? X : j.body);
                  if (e.isArrowFunction(j)) return e.factory.updateArrowFunction(j, A, H, I, l, j.equalsGreaterThanToken, X != null ? X : j.body);
                  if (e.isMethodDeclaration(j)) return e.factory.updateMethodDeclaration(j, void 0, A, ne, $ != null ? $ : e.factory.createIdentifier(""), g, H, I, l, X);
                }
              }
              C.createSignatureDeclarationFromSignature = le;
              function N(ee, he, F, x, X, $, A) {
                var y = e.getQuotePreference(he.sourceFile, he.preferences), V = e.getEmitScriptTarget(he.program.getCompilerOptions()), L = B(he), P = he.program.getTypeChecker(), k = e.isInJSFile(A), Y = x.typeArguments, U = x.arguments, j = x.parent, H = k ? void 0 : P.getContextualType(x), I = e.map(U, function(ue) {
                  return e.isIdentifier(ue) ? ue.text : e.isPropertyAccessExpression(ue) && e.isIdentifier(ue.name) ? ue.name.text : void 0;
                }), l = k ? [] : e.map(U, function(ue) {
                  return p(P, F, P.getBaseTypeOfLiteralType(P.getTypeAtLocation(ue)), A, V, void 0, L);
                }), d = $ ? e.factory.createNodeArray(e.factory.createModifiersFromModifierFlags($)) : void 0, D = e.isYieldExpression(j) ? e.factory.createToken(41) : void 0, fe = k || Y === void 0 ? void 0 : e.map(Y, function(ue, We) {
                  return e.factory.createTypeParameterDeclaration(void 0, 84 + Y.length - 1 <= 90 ? String.fromCharCode(84 + We) : "T".concat(We));
                }), g = m(U.length, I, l, void 0, k), ne = k || H === void 0 ? void 0 : P.typeToTypeNode(H, A, void 0, L);
                switch (ee) {
                  case 169:
                    return e.factory.createMethodDeclaration(void 0, d, D, X, void 0, fe, g, ne, T(y));
                  case 168:
                    return e.factory.createMethodSignature(d, X, void 0, fe, g, ne);
                  case 256:
                    return e.factory.createFunctionDeclaration(void 0, d, D, X, fe, g, ne, K(e.Diagnostics.Function_not_implemented.message, y));
                  default:
                    e.Debug.fail("Unexpected kind");
                }
              }
              C.createSignatureDeclarationFromCallExpression = N;
              function p(ee, he, F, x, X, $, A) {
                var y = ee.typeToTypeNode(F, x, $, A);
                if (y && e.isImportTypeNode(y)) {
                  var V = q(y, X);
                  V && (ve(he, V.symbols), y = V.typeNode);
                }
                return e.getSynthesizedDeepClone(y);
              }
              C.typeToAutoImportableTypeNode = p;
              function m(ee, he, F, x, X) {
                for (var $ = [], A = 0; A < ee; A++) {
                  var y = e.factory.createParameterDeclaration(void 0, void 0, void 0, he && he[A] || "arg".concat(A), x !== void 0 && A >= x ? e.factory.createToken(57) : void 0, X ? void 0 : F && F[A] || e.factory.createKeywordTypeNode(155), void 0);
                  $.push(y);
                }
                return $;
              }
              function G(ee, he, F, x, X, $, A, y, V) {
                for (var L = x[0], P = x[0].minArgumentCount, k = false, Y = 0, U = x; Y < U.length; Y++) {
                  var j = U[Y];
                  P = Math.min(j.minArgumentCount, P), e.signatureHasRestParameter(j) && (k = true), j.parameters.length >= L.parameters.length && (!e.signatureHasRestParameter(j) || e.signatureHasRestParameter(L)) && (L = j);
                }
                var H = L.parameters.length - (e.signatureHasRestParameter(L) ? 1 : 0), I = L.parameters.map(function(D) {
                  return D.name;
                }), l = m(H, I, void 0, P, false);
                if (k) {
                  var d = e.factory.createParameterDeclaration(void 0, void 0, e.factory.createToken(25), I[H] || "rest", H >= P ? e.factory.createToken(57) : void 0, e.factory.createArrayTypeNode(e.factory.createKeywordTypeNode(155)), void 0);
                  l.push(d);
                }
                return f(A, X, $, void 0, l, oe(x, ee, he, F), y, V);
              }
              function oe(ee, he, F, x) {
                if (e.length(ee)) {
                  var X = he.getUnionType(e.map(ee, he.getReturnTypeOfSignature));
                  return he.typeToTypeNode(X, x, void 0, B(F));
                }
              }
              function f(ee, he, F, x, X, $, A, y) {
                return e.factory.createMethodDeclaration(void 0, ee, void 0, he, F ? e.factory.createToken(57) : void 0, x, X, $, y || T(A));
              }
              function T(ee) {
                return K(e.Diagnostics.Method_not_implemented.message, ee);
              }
              function K(ee, he) {
                return e.factory.createBlock([e.factory.createThrowStatement(e.factory.createNewExpression(e.factory.createIdentifier("Error"), void 0, [e.factory.createStringLiteral(ee, he === 0)]))], true);
              }
              C.createStubbedBody = K;
              function b(ee) {
                if (ee & 4) return e.factory.createToken(123);
                if (ee & 16) return e.factory.createToken(122);
              }
              function se(ee, he, F) {
                var x = e.getTsConfigObjectLiteralExpression(he);
                if (!!x) {
                  var X = R(x, "compilerOptions");
                  if (X === void 0) {
                    ee.insertNodeAtObjectStart(he, x, ie("compilerOptions", e.factory.createObjectLiteralExpression(F.map(function(Y) {
                      var U = Y[0], j = Y[1];
                      return ie(U, j);
                    }), true)));
                    return;
                  }
                  var $ = X.initializer;
                  if (!!e.isObjectLiteralExpression($)) for (var A = 0, y = F; A < y.length; A++) {
                    var V = y[A], L = V[0], P = V[1], k = R($, L);
                    k === void 0 ? ee.insertNodeAtObjectStart(he, $, ie(L, P)) : ee.replaceNode(he, k.initializer, P);
                  }
                }
              }
              C.setJsonCompilerOptionValues = se;
              function J(ee, he, F, x) {
                se(ee, he, [[F, x]]);
              }
              C.setJsonCompilerOptionValue = J;
              function ie(ee, he) {
                return e.factory.createPropertyAssignment(e.factory.createStringLiteral(ee), he);
              }
              C.createJsonPropertyAssignment = ie;
              function R(ee, he) {
                return e.find(ee.properties, function(F) {
                  return e.isPropertyAssignment(F) && !!F.name && e.isStringLiteral(F.name) && F.name.text === he;
                });
              }
              C.findJsonProperty = R;
              function q(ee, he) {
                var F, x = e.visitNode(ee, X);
                if (F && x) return { typeNode: x, symbols: F };
                function X($) {
                  var A;
                  if (e.isLiteralImportTypeNode($) && $.qualifier) {
                    var y = e.getFirstIdentifier($.qualifier), V = e.getNameForExportedSymbol(y.symbol, he), L = V !== y.text ? O($.qualifier, e.factory.createIdentifier(V)) : $.qualifier;
                    F = e.append(F, y.symbol);
                    var P = (A = $.typeArguments) === null || A === void 0 ? void 0 : A.map(X);
                    return e.factory.createTypeReferenceNode(L, P);
                  }
                  return e.visitEachChild($, X, e.nullTransformationContext);
                }
              }
              C.tryGetAutoImportableReferenceFromTypeNode = q;
              function O(ee, he) {
                return ee.kind === 79 ? he : e.factory.createQualifiedName(O(ee.left, he), ee.right);
              }
              function ve(ee, he) {
                he.forEach(function(F) {
                  return ee.addImportFromExportedSymbol(F, true);
                });
              }
              C.importSymbols = ve;
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w(R, q, O, ve, ee, he) {
                var F = m(R, q, O, ve);
                if (!(!F || e.refactor.isRefactorErrorInfo(F))) {
                  var x = e.textChanges.ChangeTracker.fromContext(ee), X = F.isStatic, $ = F.isReadonly, A = F.fieldName, y = F.accessorName, V = F.originalName, L = F.type, P = F.container, k = F.declaration;
                  e.suppressLeadingAndTrailingTrivia(A), e.suppressLeadingAndTrailingTrivia(y), e.suppressLeadingAndTrailingTrivia(k), e.suppressLeadingAndTrailingTrivia(P);
                  var Y, U;
                  if (e.isClassLike(P)) {
                    var j = e.getEffectiveModifierFlags(k);
                    if (e.isSourceFileJS(R)) {
                      var H = e.createModifiers(j);
                      Y = H, U = H;
                    } else Y = e.createModifiers(N(j)), U = e.createModifiers(p(j));
                  }
                  K(x, R, k, L, A, U);
                  var I = G(A, y, L, Y, X, P);
                  if (e.suppressLeadingAndTrailingTrivia(I), b(x, R, I, k, P), $) {
                    var l = e.getFirstConstructorWithBody(P);
                    l && se(x, R, l, A.text, V);
                  } else {
                    var d = oe(A, y, L, Y, X, P);
                    e.suppressLeadingAndTrailingTrivia(d), b(x, R, d, k, P);
                  }
                  return x.getChanges();
                }
              }
              C.generateAccessorFromProperty = w;
              function B(R) {
                return e.isIdentifier(R) || e.isStringLiteral(R);
              }
              function E(R) {
                return e.isParameterPropertyDeclaration(R, R.parent) || e.isPropertyDeclaration(R) || e.isPropertyAssignment(R);
              }
              function Q(R, q) {
                return e.isIdentifier(q) ? e.factory.createIdentifier(R) : e.factory.createStringLiteral(R);
              }
              function le(R, q, O) {
                var ve = q ? O.name : e.factory.createThis();
                return e.isIdentifier(R) ? e.factory.createPropertyAccessExpression(ve, R) : e.factory.createElementAccessExpression(ve, e.factory.createStringLiteralFromNode(R));
              }
              function N(R) {
                return R &= -65, R &= -9, R & 16 || (R |= 4), R;
              }
              function p(R) {
                return R &= -5, R &= -17, R |= 8, R;
              }
              function m(R, q, O, ve, ee) {
                ee === void 0 && (ee = true);
                var he = e.getTokenAtPosition(R, O), F = O === ve && ee, x = e.findAncestor(he.parent, E), X = 124;
                if (!x || !(e.nodeOverlapsWithStartEnd(x.name, R, O, ve) || F)) return { error: e.getLocaleSpecificMessage(e.Diagnostics.Could_not_find_property_for_which_to_generate_accessor) };
                if (!B(x.name)) return { error: e.getLocaleSpecificMessage(e.Diagnostics.Name_is_not_valid) };
                if ((e.getEffectiveModifierFlags(x) | X) !== X) return { error: e.getLocaleSpecificMessage(e.Diagnostics.Can_only_convert_property_with_modifier) };
                var $ = x.name.text, A = e.startsWithUnderscore($), y = Q(A ? $ : e.getUniqueName("_".concat($), R), x.name), V = Q(A ? e.getUniqueName($.substring(1), R) : $, x.name);
                return { isStatic: e.hasStaticModifier(x), isReadonly: e.hasEffectiveReadonlyModifier(x), type: J(x, q), container: x.kind === 164 ? x.parent.parent : x.parent, originalName: x.name.text, declaration: x, fieldName: y, accessorName: V, renameAccessor: A };
              }
              C.getAccessorConvertiblePropertyAtPosition = m;
              function G(R, q, O, ve, ee, he) {
                return e.factory.createGetAccessorDeclaration(void 0, ve, q, void 0, O, e.factory.createBlock([e.factory.createReturnStatement(le(R, ee, he))], true));
              }
              function oe(R, q, O, ve, ee, he) {
                return e.factory.createSetAccessorDeclaration(void 0, ve, q, [e.factory.createParameterDeclaration(void 0, void 0, void 0, e.factory.createIdentifier("value"), void 0, O)], e.factory.createBlock([e.factory.createExpressionStatement(e.factory.createAssignment(le(R, ee, he), e.factory.createIdentifier("value")))], true));
              }
              function f(R, q, O, ve, ee, he) {
                var F = e.factory.updatePropertyDeclaration(O, O.decorators, he, ee, O.questionToken || O.exclamationToken, ve, O.initializer);
                R.replaceNode(q, O, F);
              }
              function T(R, q, O, ve) {
                var ee = e.factory.updatePropertyAssignment(O, ve, O.initializer);
                R.replacePropertyAssignment(q, O, ee);
              }
              function K(R, q, O, ve, ee, he) {
                e.isPropertyDeclaration(O) ? f(R, q, O, ve, ee, he) : e.isPropertyAssignment(O) ? T(R, q, O, ee) : R.replaceNode(q, O, e.factory.updateParameterDeclaration(O, O.decorators, he, O.dotDotDotToken, e.cast(ee, e.isIdentifier), O.questionToken, O.type, O.initializer));
              }
              function b(R, q, O, ve, ee) {
                e.isParameterPropertyDeclaration(ve, ve.parent) ? R.insertMemberAtStart(q, ee, O) : e.isPropertyAssignment(ve) ? R.insertNodeAfterComma(q, ve, O) : R.insertNodeAfter(q, ve, O);
              }
              function se(R, q, O, ve, ee) {
                !O.body || O.body.forEachChild(function he(F) {
                  e.isElementAccessExpression(F) && F.expression.kind === 108 && e.isStringLiteral(F.argumentExpression) && F.argumentExpression.text === ee && e.isWriteAccess(F) && R.replaceNode(q, F.argumentExpression, e.factory.createStringLiteral(ve)), e.isPropertyAccessExpression(F) && F.expression.kind === 108 && F.name.text === ee && e.isWriteAccess(F) && R.replaceNode(q, F.name, e.factory.createIdentifier(ve)), !e.isFunctionLike(F) && !e.isClassLike(F) && F.forEachChild(he);
                });
              }
              function J(R, q) {
                var O = e.getTypeAnnotationNode(R);
                if (e.isPropertyDeclaration(R) && O && R.questionToken) {
                  var ve = q.getTypeChecker(), ee = ve.getTypeFromTypeNode(O);
                  if (!ve.isTypeAssignableTo(ve.getUndefinedType(), ee)) {
                    var he = e.isUnionTypeNode(O) ? O.types : [O];
                    return e.factory.createUnionTypeNode(Ve(Ve([], he, true), [e.factory.createKeywordTypeNode(153)], false));
                  }
                }
                return O;
              }
              function ie(R, q) {
                for (var O = []; R; ) {
                  var ve = e.getClassExtendsHeritageElement(R), ee = ve && q.getSymbolAtLocation(ve.expression);
                  if (!ee) break;
                  var he = ee.flags & 2097152 ? q.getAliasedSymbol(ee) : ee, F = he.declarations && e.find(he.declarations, e.isClassLike);
                  if (!F) break;
                  O.push(F), R = F;
                }
                return O;
              }
              C.getAllSupers = ie;
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "invalidImportSyntax";
              function B(p, m) {
                var G = e.getSourceFileOfNode(m), oe = e.getNamespaceDeclarationNode(m), f = p.program.getCompilerOptions(), T = [];
                return T.push(E(p, G, m, e.makeImport(oe.name, void 0, m.moduleSpecifier, e.getQuotePreference(G, p.preferences)))), e.getEmitModuleKind(f) === e.ModuleKind.CommonJS && T.push(E(p, G, m, e.factory.createImportEqualsDeclaration(void 0, void 0, false, oe.name, e.factory.createExternalModuleReference(m.moduleSpecifier)))), T;
              }
              function E(p, m, G, oe) {
                var f = e.textChanges.ChangeTracker.with(p, function(T) {
                  return T.replaceNode(m, G, oe);
                });
                return C.createCodeFixActionWithoutFixAll(w, f, [e.Diagnostics.Replace_import_with_0, f[0].textChanges[0].newText]);
              }
              C.registerCodeFix({ errorCodes: [e.Diagnostics.This_expression_is_not_callable.code, e.Diagnostics.This_expression_is_not_constructable.code], getCodeActions: Q });
              function Q(p) {
                var m = p.sourceFile, G = e.Diagnostics.This_expression_is_not_callable.code === p.errorCode ? 208 : 209, oe = e.findAncestor(e.getTokenAtPosition(m, p.span.start), function(T) {
                  return T.kind === G;
                });
                if (!oe) return [];
                var f = oe.expression;
                return N(p, f);
              }
              C.registerCodeFix({ errorCodes: [e.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code, e.Diagnostics.Type_0_does_not_satisfy_the_constraint_1.code, e.Diagnostics.Type_0_is_not_assignable_to_type_1.code, e.Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated.code, e.Diagnostics.Type_predicate_0_is_not_assignable_to_1.code, e.Diagnostics.Property_0_of_type_1_is_not_assignable_to_2_index_type_3.code, e.Diagnostics._0_index_type_1_is_not_assignable_to_2_index_type_3.code, e.Diagnostics.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2.code, e.Diagnostics.Property_0_in_type_1_is_not_assignable_to_type_2.code, e.Diagnostics.Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property.code, e.Diagnostics.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1.code], getCodeActions: le });
              function le(p) {
                var m = p.sourceFile, G = e.findAncestor(e.getTokenAtPosition(m, p.span.start), function(oe) {
                  return oe.getStart() === p.span.start && oe.getEnd() === p.span.start + p.span.length;
                });
                return G ? N(p, G) : [];
              }
              function N(p, m) {
                var G = p.program.getTypeChecker().getTypeAtLocation(m);
                if (!(G.symbol && G.symbol.originatingImport)) return [];
                var oe = [], f = G.symbol.originatingImport;
                if (e.isImportCall(f) || e.addRange(oe, B(p, f)), e.isExpression(m) && !(e.isNamedDeclaration(m.parent) && m.parent.name === m)) {
                  var T = p.sourceFile, K = e.textChanges.ChangeTracker.with(p, function(b) {
                    return b.replaceNode(T, m, e.factory.createPropertyAccessExpression(m, "default"), {});
                  });
                  oe.push(C.createCodeFixActionWithoutFixAll(w, K, e.Diagnostics.Use_synthetic_default_member));
                }
                return oe;
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "strictClassInitialization", B = "addMissingPropertyDefiniteAssignmentAssertions", E = "addMissingPropertyUndefinedType", Q = "addMissingPropertyInitializer", le = [e.Diagnostics.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor.code];
              C.registerCodeFix({ errorCodes: le, getCodeActions: function(J) {
                var ie = N(J.sourceFile, J.span.start);
                if (!!ie) {
                  var R = [];
                  return e.append(R, G(J, ie)), e.append(R, p(J, ie)), e.append(R, f(J, ie)), R;
                }
              }, fixIds: [B, E, Q], getAllCodeActions: function(se) {
                return C.codeFixAll(se, le, function(J, ie) {
                  var R = N(ie.file, ie.start);
                  if (!!R) switch (se.fixId) {
                    case B:
                      m(J, ie.file, R.prop);
                      break;
                    case E:
                      oe(J, ie.file, R);
                      break;
                    case Q:
                      var q = se.program.getTypeChecker(), O = K(q, R.prop);
                      if (!O) return;
                      T(J, ie.file, R.prop, O);
                      break;
                    default:
                      e.Debug.fail(JSON.stringify(se.fixId));
                  }
                });
              } });
              function N(se, J) {
                var ie = e.getTokenAtPosition(se, J);
                if (e.isIdentifier(ie) && e.isPropertyDeclaration(ie.parent)) {
                  var R = e.getEffectiveTypeAnnotationNode(ie.parent);
                  if (R) return { type: R, prop: ie.parent, isJs: e.isInJSFile(ie.parent) };
                }
              }
              function p(se, J) {
                if (!J.isJs) {
                  var ie = e.textChanges.ChangeTracker.with(se, function(R) {
                    return m(R, se.sourceFile, J.prop);
                  });
                  return C.createCodeFixAction(w, ie, [e.Diagnostics.Add_definite_assignment_assertion_to_property_0, J.prop.getText()], B, e.Diagnostics.Add_definite_assignment_assertions_to_all_uninitialized_properties);
                }
              }
              function m(se, J, ie) {
                e.suppressLeadingAndTrailingTrivia(ie);
                var R = e.factory.updatePropertyDeclaration(ie, ie.decorators, ie.modifiers, ie.name, e.factory.createToken(53), ie.type, ie.initializer);
                se.replaceNode(J, ie, R);
              }
              function G(se, J) {
                var ie = e.textChanges.ChangeTracker.with(se, function(R) {
                  return oe(R, se.sourceFile, J);
                });
                return C.createCodeFixAction(w, ie, [e.Diagnostics.Add_undefined_type_to_property_0, J.prop.name.getText()], E, e.Diagnostics.Add_undefined_type_to_all_uninitialized_properties);
              }
              function oe(se, J, ie) {
                var R = e.factory.createKeywordTypeNode(153), q = e.isUnionTypeNode(ie.type) ? ie.type.types.concat(R) : [ie.type, R], O = e.factory.createUnionTypeNode(q);
                ie.isJs ? se.addJSDocTags(J, ie.prop, [e.factory.createJSDocTypeTag(void 0, e.factory.createJSDocTypeExpression(O))]) : se.replaceNode(J, ie.type, O);
              }
              function f(se, J) {
                if (!J.isJs) {
                  var ie = se.program.getTypeChecker(), R = K(ie, J.prop);
                  if (!!R) {
                    var q = e.textChanges.ChangeTracker.with(se, function(O) {
                      return T(O, se.sourceFile, J.prop, R);
                    });
                    return C.createCodeFixAction(w, q, [e.Diagnostics.Add_initializer_to_property_0, J.prop.name.getText()], Q, e.Diagnostics.Add_initializers_to_all_uninitialized_properties);
                  }
                }
              }
              function T(se, J, ie, R) {
                e.suppressLeadingAndTrailingTrivia(ie);
                var q = e.factory.updatePropertyDeclaration(ie, ie.decorators, ie.modifiers, ie.name, ie.questionToken, ie.type, R);
                se.replaceNode(J, ie, q);
              }
              function K(se, J) {
                return b(se, se.getTypeFromTypeNode(J.type));
              }
              function b(se, J) {
                if (J.flags & 512) return J === se.getFalseType() || J === se.getFalseType(true) ? e.factory.createFalse() : e.factory.createTrue();
                if (J.isStringLiteral()) return e.factory.createStringLiteral(J.value);
                if (J.isNumberLiteral()) return e.factory.createNumericLiteral(J.value);
                if (J.flags & 2048) return e.factory.createBigIntLiteral(J.value);
                if (J.isUnion()) return e.firstDefined(J.types, function(q) {
                  return b(se, q);
                });
                if (J.isClass()) {
                  var ie = e.getClassLikeDeclarationOfSymbol(J.symbol);
                  if (!ie || e.hasSyntacticModifier(ie, 128)) return;
                  var R = e.getFirstConstructorWithBody(ie);
                  return R && R.parameters.length ? void 0 : e.factory.createNewExpression(e.factory.createIdentifier(J.symbol.name), void 0, void 0);
                } else if (se.isArrayLikeType(J)) return e.factory.createArrayLiteralExpression();
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "requireInTs", B = [e.Diagnostics.require_call_may_be_converted_to_an_import.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(N) {
                var p = Q(N.sourceFile, N.program, N.span.start);
                if (!!p) {
                  var m = e.textChanges.ChangeTracker.with(N, function(G) {
                    return E(G, N.sourceFile, p);
                  });
                  return [C.createCodeFixAction(w, m, e.Diagnostics.Convert_require_to_import, w, e.Diagnostics.Convert_all_require_to_import)];
                }
              }, fixIds: [w], getAllCodeActions: function(N) {
                return C.codeFixAll(N, B, function(p, m) {
                  var G = Q(m.file, N.program, m.start);
                  G && E(p, N.sourceFile, G);
                });
              } });
              function E(N, p, m) {
                var G = m.allowSyntheticDefaults, oe = m.defaultImportName, f = m.namedImports, T = m.statement, K = m.required;
                N.replaceNode(p, T, oe && !G ? e.factory.createImportEqualsDeclaration(void 0, void 0, false, oe, e.factory.createExternalModuleReference(K)) : e.factory.createImportDeclaration(void 0, void 0, e.factory.createImportClause(false, oe, f), K, void 0));
              }
              function Q(N, p, m) {
                var G = e.getTokenAtPosition(N, m).parent;
                if (!e.isRequireCall(G, true)) throw e.Debug.failBadSyntaxKind(G);
                var oe = e.cast(G.parent, e.isVariableDeclaration), f = e.tryCast(oe.name, e.isIdentifier), T = e.isObjectBindingPattern(oe.name) ? le(oe.name) : void 0;
                if (f || T) return { allowSyntheticDefaults: e.getAllowSyntheticDefaultImports(p.getCompilerOptions()), defaultImportName: f, namedImports: T, statement: e.cast(oe.parent.parent, e.isVariableStatement), required: e.first(G.arguments) };
              }
              function le(N) {
                for (var p = [], m = 0, G = N.elements; m < G.length; m++) {
                  var oe = G[m];
                  if (!e.isIdentifier(oe.name) || oe.initializer) return;
                  p.push(e.factory.createImportSpecifier(false, e.tryCast(oe.propertyName, e.isIdentifier), oe.name));
                }
                if (p.length) return e.factory.createNamedImports(p);
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "useDefaultImport", B = [e.Diagnostics.Import_may_be_converted_to_a_default_import.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = le.sourceFile, p = le.span.start, m = E(N, p);
                if (!!m) {
                  var G = e.textChanges.ChangeTracker.with(le, function(oe) {
                    return Q(oe, N, m, le.preferences);
                  });
                  return [C.createCodeFixAction(w, G, e.Diagnostics.Convert_to_default_import, w, e.Diagnostics.Convert_all_to_default_imports)];
                }
              }, fixIds: [w], getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  var m = E(p.file, p.start);
                  m && Q(N, p.file, m, le.preferences);
                });
              } });
              function E(le, N) {
                var p = e.getTokenAtPosition(le, N);
                if (!!e.isIdentifier(p)) {
                  var m = p.parent;
                  if (e.isImportEqualsDeclaration(m) && e.isExternalModuleReference(m.moduleReference)) return { importNode: m, name: p, moduleSpecifier: m.moduleReference.expression };
                  if (e.isNamespaceImport(m)) {
                    var G = m.parent.parent;
                    return { importNode: G, name: p, moduleSpecifier: G.moduleSpecifier };
                  }
                }
              }
              function Q(le, N, p, m) {
                le.replaceNode(N, p.importNode, e.makeImport(p.name, void 0, p.moduleSpecifier, e.getQuotePreference(N, m)));
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "useBigintLiteral", B = [e.Diagnostics.Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = e.textChanges.ChangeTracker.with(le, function(p) {
                  return E(p, le.sourceFile, le.span);
                });
                if (N.length > 0) return [C.createCodeFixAction(w, N, e.Diagnostics.Convert_to_a_bigint_numeric_literal, w, e.Diagnostics.Convert_all_to_bigint_numeric_literals)];
              }, fixIds: [w], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, B, function(le, N) {
                  return E(le, N.file, N);
                });
              } });
              function E(Q, le, N) {
                var p = e.tryCast(e.getTokenAtPosition(le, N.start), e.isNumericLiteral);
                if (!!p) {
                  var m = p.getText(le) + "n";
                  Q.replaceNode(le, p, e.factory.createBigIntLiteral(m));
                }
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixAddModuleReferTypeMissingTypeof", B = w, E = [e.Diagnostics.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0.code];
              C.registerCodeFix({ errorCodes: E, getCodeActions: function(p) {
                var m = p.sourceFile, G = p.span, oe = Q(m, G.start), f = e.textChanges.ChangeTracker.with(p, function(T) {
                  return le(T, m, oe);
                });
                return [C.createCodeFixAction(B, f, e.Diagnostics.Add_missing_typeof, B, e.Diagnostics.Add_missing_typeof)];
              }, fixIds: [B], getAllCodeActions: function(N) {
                return C.codeFixAll(N, E, function(p, m) {
                  return le(p, N.sourceFile, Q(m.file, m.start));
                });
              } });
              function Q(N, p) {
                var m = e.getTokenAtPosition(N, p);
                return e.Debug.assert(m.kind === 100, "This token should be an ImportKeyword"), e.Debug.assert(m.parent.kind === 200, "Token parent should be an ImportType"), m.parent;
              }
              function le(N, p, m) {
                var G = e.factory.updateImportTypeNode(m, m.argument, m.qualifier, m.typeArguments, true);
                N.replaceNode(p, m, G);
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "wrapJsxInFragment", B = [e.Diagnostics.JSX_expressions_must_have_one_parent_element.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(p) {
                var m = p.sourceFile, G = p.span, oe = E(m, G.start);
                if (!!oe) {
                  var f = e.textChanges.ChangeTracker.with(p, function(T) {
                    return Q(T, m, oe);
                  });
                  return [C.createCodeFixAction(w, f, e.Diagnostics.Wrap_in_JSX_fragment, w, e.Diagnostics.Wrap_all_unparented_JSX_in_JSX_fragment)];
                }
              }, fixIds: [w], getAllCodeActions: function(N) {
                return C.codeFixAll(N, B, function(p, m) {
                  var G = E(N.sourceFile, m.start);
                  !G || Q(p, N.sourceFile, G);
                });
              } });
              function E(N, p) {
                var m = e.getTokenAtPosition(N, p), G = m.parent, oe = G.parent;
                if (!(!e.isBinaryExpression(oe) && (oe = oe.parent, !e.isBinaryExpression(oe))) && !!e.nodeIsMissing(oe.operatorToken)) return oe;
              }
              function Q(N, p, m) {
                var G = le(m);
                G && N.replaceNode(p, m, e.factory.createJsxFragment(e.factory.createJsxOpeningFragment(), G, e.factory.createJsxJsxClosingFragment()));
              }
              function le(N) {
                for (var p = [], m = N; ; ) if (e.isBinaryExpression(m) && e.nodeIsMissing(m.operatorToken) && m.operatorToken.kind === 27) {
                  if (p.push(m.left), e.isJsxChild(m.right)) return p.push(m.right), p;
                  if (e.isBinaryExpression(m.right)) {
                    m = m.right;
                    continue;
                  } else return;
                } else return;
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixConvertToMappedObjectType", B = [e.Diagnostics.An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(p) {
                var m = p.sourceFile, G = p.span, oe = E(m, G.start);
                if (!!oe) {
                  var f = e.textChanges.ChangeTracker.with(p, function(K) {
                    return le(K, m, oe);
                  }), T = e.idText(oe.container.name);
                  return [C.createCodeFixAction(w, f, [e.Diagnostics.Convert_0_to_mapped_object_type, T], w, [e.Diagnostics.Convert_0_to_mapped_object_type, T])];
                }
              }, fixIds: [w], getAllCodeActions: function(N) {
                return C.codeFixAll(N, B, function(p, m) {
                  var G = E(m.file, m.start);
                  G && le(p, m.file, G);
                });
              } });
              function E(N, p) {
                var m = e.getTokenAtPosition(N, p), G = e.tryCast(m.parent.parent, e.isIndexSignatureDeclaration);
                if (!!G) {
                  var oe = e.isInterfaceDeclaration(G.parent) ? G.parent : e.tryCast(G.parent.parent, e.isTypeAliasDeclaration);
                  if (!!oe) return { indexSignature: G, container: oe };
                }
              }
              function Q(N, p) {
                return e.factory.createTypeAliasDeclaration(N.decorators, N.modifiers, N.name, N.typeParameters, p);
              }
              function le(N, p, m) {
                var G = m.indexSignature, oe = m.container, f = e.isInterfaceDeclaration(oe) ? oe.members : oe.type.members, T = f.filter(function(ie) {
                  return !e.isIndexSignatureDeclaration(ie);
                }), K = e.first(G.parameters), b = e.factory.createTypeParameterDeclaration(void 0, e.cast(K.name, e.isIdentifier), K.type), se = e.factory.createMappedTypeNode(e.hasEffectiveReadonlyModifier(G) ? e.factory.createModifier(145) : void 0, b, void 0, G.questionToken, G.type, void 0), J = e.factory.createIntersectionTypeNode(Ve(Ve(Ve([], e.getAllSuperTypeNodes(oe), true), [se], false), T.length ? [e.factory.createTypeLiteralNode(T)] : e.emptyArray, true));
                N.replaceNode(p, oe, Q(oe, J));
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "removeAccidentalCallParentheses", B = [e.Diagnostics.This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(E) {
                var Q = e.findAncestor(e.getTokenAtPosition(E.sourceFile, E.span.start), e.isCallExpression);
                if (!!Q) {
                  var le = e.textChanges.ChangeTracker.with(E, function(N) {
                    N.deleteRange(E.sourceFile, { pos: Q.expression.end, end: Q.end });
                  });
                  return [C.createCodeFixActionWithoutFixAll(w, le, e.Diagnostics.Remove_parentheses)];
                }
              }, fixIds: [w] });
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "removeUnnecessaryAwait", B = [e.Diagnostics.await_has_no_effect_on_the_type_of_this_expression.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = e.textChanges.ChangeTracker.with(le, function(p) {
                  return E(p, le.sourceFile, le.span);
                });
                if (N.length > 0) return [C.createCodeFixAction(w, N, e.Diagnostics.Remove_unnecessary_await, w, e.Diagnostics.Remove_all_unnecessary_uses_of_await)];
              }, fixIds: [w], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, B, function(le, N) {
                  return E(le, N.file, N);
                });
              } });
              function E(Q, le, N) {
                var p = e.tryCast(e.getTokenAtPosition(le, N.start), function(K) {
                  return K.kind === 132;
                }), m = p && e.tryCast(p.parent, e.isAwaitExpression);
                if (!!m) {
                  var G = m, oe = e.isParenthesizedExpression(m.parent);
                  if (oe) {
                    var f = e.getLeftmostExpression(m.expression, false);
                    if (e.isIdentifier(f)) {
                      var T = e.findPrecedingToken(m.parent.pos, le);
                      T && T.kind !== 103 && (G = m.parent);
                    }
                  }
                  Q.replaceNode(le, G, m.expression);
                }
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = [e.Diagnostics.A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both.code], B = "splitTypeOnlyImport";
              C.registerCodeFix({ errorCodes: w, fixIds: [B], getCodeActions: function(N) {
                var p = e.textChanges.ChangeTracker.with(N, function(m) {
                  return Q(m, E(N.sourceFile, N.span), N);
                });
                if (p.length) return [C.createCodeFixAction(B, p, e.Diagnostics.Split_into_two_separate_import_declarations, B, e.Diagnostics.Split_all_invalid_type_only_imports)];
              }, getAllCodeActions: function(le) {
                return C.codeFixAll(le, w, function(N, p) {
                  Q(N, E(le.sourceFile, p), le);
                });
              } });
              function E(le, N) {
                return e.findAncestor(e.getTokenAtPosition(le, N.start), e.isImportDeclaration);
              }
              function Q(le, N, p) {
                if (!!N) {
                  var m = e.Debug.checkDefined(N.importClause);
                  le.replaceNode(p.sourceFile, N, e.factory.updateImportDeclaration(N, N.decorators, N.modifiers, e.factory.updateImportClause(m, m.isTypeOnly, m.name, void 0), N.moduleSpecifier, N.assertClause)), le.insertNodeAfter(p.sourceFile, N, e.factory.createImportDeclaration(void 0, void 0, e.factory.updateImportClause(m, m.isTypeOnly, void 0, m.namedBindings), N.moduleSpecifier, N.assertClause));
                }
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixConvertConstToLet", B = [e.Diagnostics.Cannot_assign_to_0_because_it_is_a_constant.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(N) {
                var p = N.sourceFile, m = N.span, G = N.program, oe = E(p, m.start, G);
                if (oe !== void 0) {
                  var f = e.textChanges.ChangeTracker.with(N, function(T) {
                    return Q(T, p, oe);
                  });
                  return [C.createCodeFixAction(w, f, e.Diagnostics.Convert_const_to_let, w, e.Diagnostics.Convert_const_to_let)];
                }
              }, fixIds: [w] });
              function E(le, N, p) {
                var m, G = p.getTypeChecker(), oe = G.getSymbolAtLocation(e.getTokenAtPosition(le, N)), f = e.tryCast((m = oe == null ? void 0 : oe.valueDeclaration) === null || m === void 0 ? void 0 : m.parent, e.isVariableDeclarationList);
                if (f !== void 0) {
                  var T = e.findChildOfKind(f, 85, le);
                  if (T !== void 0) return e.createRange(T.pos, T.end);
                }
              }
              function Q(le, N, p) {
                le.replaceRangeWithText(N, p, "let");
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "fixExpectedComma", B = e.Diagnostics._0_expected.code, E = [B];
              C.registerCodeFix({ errorCodes: E, getCodeActions: function(N) {
                var p = N.sourceFile, m = Q(p, N.span.start, N.errorCode);
                if (!!m) {
                  var G = e.textChanges.ChangeTracker.with(N, function(oe) {
                    return le(oe, p, m);
                  });
                  return [C.createCodeFixAction(w, G, [e.Diagnostics.Change_0_to_1, ";", ","], w, [e.Diagnostics.Change_0_to_1, ";", ","])];
                }
              }, fixIds: [w], getAllCodeActions: function(N) {
                return C.codeFixAll(N, E, function(p, m) {
                  var G = Q(m.file, m.start, m.code);
                  G && le(p, N.sourceFile, G);
                });
              } });
              function Q(N, p, m) {
                var G = e.getTokenAtPosition(N, p);
                return G.kind === 26 && G.parent && (e.isObjectLiteralExpression(G.parent) || e.isArrayLiteralExpression(G.parent)) ? { node: G } : void 0;
              }
              function le(N, p, m) {
                var G = m.node, oe = e.factory.createToken(27);
                N.replaceNode(p, G, oe);
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "addVoidToPromise", B = "addVoidToPromise", E = [e.Diagnostics.Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments.code, e.Diagnostics.Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise.code];
              C.registerCodeFix({ errorCodes: E, fixIds: [B], getCodeActions: function(N) {
                var p = e.textChanges.ChangeTracker.with(N, function(m) {
                  return Q(m, N.sourceFile, N.span, N.program);
                });
                if (p.length > 0) return [C.createCodeFixAction(w, p, e.Diagnostics.Add_void_to_Promise_resolved_without_a_value, B, e.Diagnostics.Add_void_to_all_Promises_resolved_without_a_value)];
              }, getAllCodeActions: function(N) {
                return C.codeFixAll(N, E, function(p, m) {
                  return Q(p, m.file, m, N.program, new e.Set());
                });
              } });
              function Q(N, p, m, G, oe) {
                var f = e.getTokenAtPosition(p, m.start);
                if (!(!e.isIdentifier(f) || !e.isCallExpression(f.parent) || f.parent.expression !== f || f.parent.arguments.length !== 0)) {
                  var T = G.getTypeChecker(), K = T.getSymbolAtLocation(f), b = K == null ? void 0 : K.valueDeclaration;
                  if (!(!b || !e.isParameter(b) || !e.isNewExpression(b.parent.parent)) && !(oe != null && oe.has(b))) {
                    oe == null || oe.add(b);
                    var se = le(b.parent.parent);
                    if (e.some(se)) {
                      var J = se[0], ie = !e.isUnionTypeNode(J) && !e.isParenthesizedTypeNode(J) && e.isParenthesizedTypeNode(e.factory.createUnionTypeNode([J, e.factory.createKeywordTypeNode(114)]).types[0]);
                      ie && N.insertText(p, J.pos, "("), N.insertText(p, J.end, ie ? ") | void" : " | void");
                    } else {
                      var R = T.getResolvedSignature(f.parent), q = R == null ? void 0 : R.parameters[0], O = q && T.getTypeOfSymbolAtLocation(q, b.parent.parent);
                      e.isInJSFile(b) ? (!O || O.flags & 3) && (N.insertText(p, b.parent.parent.end, ")"), N.insertText(p, e.skipTrivia(p.text, b.parent.parent.pos), "/** @type {Promise<void>} */(")) : (!O || O.flags & 2) && N.insertText(p, b.parent.parent.expression.end, "<void>");
                    }
                  }
                }
              }
              function le(N) {
                var p;
                if (e.isInJSFile(N)) {
                  if (e.isParenthesizedExpression(N.parent)) {
                    var m = (p = e.getJSDocTypeTag(N.parent)) === null || p === void 0 ? void 0 : p.typeExpression.type;
                    if (m && e.isTypeReferenceNode(m) && e.isIdentifier(m.typeName) && e.idText(m.typeName) === "Promise") return m.typeArguments;
                  }
                } else return N.typeArguments;
              }
            })(a = e.codefix || (e.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "Convert export", B = { name: "Convert default export to named export", description: e.Diagnostics.Convert_default_export_to_named_export.message, kind: "refactor.rewrite.export.named" }, E = { name: "Convert named export to default export", description: e.Diagnostics.Convert_named_export_to_default_export.message, kind: "refactor.rewrite.export.default" };
              C.registerRefactor(w, { kinds: [B.kind, E.kind], getAvailableActions: function(K) {
                var b = Q(K, K.triggerReason === "invoked");
                if (!b) return e.emptyArray;
                if (!C.isRefactorErrorInfo(b)) {
                  var se = b.wasDefault ? B : E;
                  return [{ name: w, description: se.description, actions: [se] }];
                }
                return K.preferences.provideRefactorNotApplicableReason ? [{ name: w, description: e.Diagnostics.Convert_default_export_to_named_export.message, actions: [Ke(Ke({}, B), { notApplicableReason: b.error }), Ke(Ke({}, E), { notApplicableReason: b.error })] }] : e.emptyArray;
              }, getEditsForAction: function(K, b) {
                e.Debug.assert(b === B.name || b === E.name, "Unexpected action name");
                var se = Q(K);
                e.Debug.assert(se && !C.isRefactorErrorInfo(se), "Expected applicable refactor info");
                var J = e.textChanges.ChangeTracker.with(K, function(ie) {
                  return le(K.file, K.program, se, ie, K.cancellationToken);
                });
                return { edits: J, renameFilename: void 0, renameLocation: void 0 };
              } });
              function Q(T, K) {
                K === void 0 && (K = true);
                var b = T.file, se = T.program, J = e.getRefactorContextSpan(T), ie = e.getTokenAtPosition(b, J.start), R = !!(ie.parent && e.getSyntacticModifierFlags(ie.parent) & 1) && K ? ie.parent : e.getParentNodeInSpan(ie, b, J);
                if (!R || !e.isSourceFile(R.parent) && !(e.isModuleBlock(R.parent) && e.isAmbientModule(R.parent.parent))) return { error: e.getLocaleSpecificMessage(e.Diagnostics.Could_not_find_export_statement) };
                var q = e.isSourceFile(R.parent) ? R.parent.symbol : R.parent.parent.symbol, O = e.getSyntacticModifierFlags(R) || (e.isExportAssignment(R) && !R.isExportEquals ? 513 : 0), ve = !!(O & 512);
                if (!(O & 1) || !ve && q.exports.has("default")) return { error: e.getLocaleSpecificMessage(e.Diagnostics.This_file_already_has_a_default_export) };
                var ee = se.getTypeChecker(), he = function($) {
                  return e.isIdentifier($) && ee.getSymbolAtLocation($) ? void 0 : { error: e.getLocaleSpecificMessage(e.Diagnostics.Can_only_convert_named_export) };
                };
                switch (R.kind) {
                  case 256:
                  case 257:
                  case 258:
                  case 260:
                  case 259:
                  case 261: {
                    var F = R;
                    return F.name ? he(F.name) || { exportNode: F, exportName: F.name, wasDefault: ve, exportingModuleSymbol: q } : void 0;
                  }
                  case 237: {
                    var x = R;
                    if (!(x.declarationList.flags & 2) || x.declarationList.declarations.length !== 1) return;
                    var X = e.first(x.declarationList.declarations);
                    return X.initializer ? (e.Debug.assert(!ve, "Can't have a default flag here"), he(X.name) || { exportNode: x, exportName: X.name, wasDefault: ve, exportingModuleSymbol: q }) : void 0;
                  }
                  case 271: {
                    var F = R;
                    return F.isExportEquals ? void 0 : he(F.expression) || { exportNode: F, exportName: F.expression, wasDefault: ve, exportingModuleSymbol: q };
                  }
                  default:
                    return;
                }
              }
              function le(T, K, b, se, J) {
                N(T, b, se, K.getTypeChecker()), p(K, b, se, J);
              }
              function N(T, K, b, se) {
                var J = K.wasDefault, ie = K.exportNode, R = K.exportName;
                if (J) if (e.isExportAssignment(ie) && !ie.isExportEquals) {
                  var q = ie.expression, O = f(q.text, q.text);
                  b.replaceNode(T, ie, e.factory.createExportDeclaration(void 0, void 0, false, e.factory.createNamedExports([O])));
                } else b.delete(T, e.Debug.checkDefined(e.findModifier(ie, 88), "Should find a default keyword in modifier list"));
                else {
                  var ve = e.Debug.checkDefined(e.findModifier(ie, 93), "Should find an export keyword in modifier list");
                  switch (ie.kind) {
                    case 256:
                    case 257:
                    case 258:
                      b.insertNodeAfter(T, ve, e.factory.createToken(88));
                      break;
                    case 237:
                      var ee = e.first(ie.declarationList.declarations);
                      if (!e.FindAllReferences.Core.isSymbolReferencedInFile(R, se, T) && !ee.type) {
                        b.replaceNode(T, ie, e.factory.createExportDefault(e.Debug.checkDefined(ee.initializer, "Initializer was previously known to be present")));
                        break;
                      }
                    case 260:
                    case 259:
                    case 261:
                      b.deleteModifier(T, ve), b.insertNodeAfter(T, ie, e.factory.createExportDefault(e.factory.createIdentifier(R.text)));
                      break;
                    default:
                      e.Debug.fail("Unexpected exportNode kind ".concat(ie.kind));
                  }
                }
              }
              function p(T, K, b, se) {
                var J = K.wasDefault, ie = K.exportName, R = K.exportingModuleSymbol, q = T.getTypeChecker(), O = e.Debug.checkDefined(q.getSymbolAtLocation(ie), "Export name should resolve to a symbol");
                e.FindAllReferences.Core.eachExportReference(T.getSourceFiles(), q, se, O, R, ie.text, J, function(ve) {
                  var ee = ve.getSourceFile();
                  J ? m(ee, ve, b, ie.text) : G(ee, ve, b);
                });
              }
              function m(T, K, b, se) {
                var J = K.parent;
                switch (J.kind) {
                  case 206:
                    b.replaceNode(T, K, e.factory.createIdentifier(se));
                    break;
                  case 270:
                  case 275: {
                    var ie = J;
                    b.replaceNode(T, ie, oe(se, ie.name.text));
                    break;
                  }
                  case 267: {
                    var R = J;
                    e.Debug.assert(R.name === K, "Import clause name should match provided ref");
                    var ie = oe(se, K.text), q = R.namedBindings;
                    if (!q) b.replaceNode(T, K, e.factory.createNamedImports([ie]));
                    else if (q.kind === 268) {
                      b.deleteRange(T, { pos: K.getStart(T), end: q.getStart(T) });
                      var O = e.isStringLiteral(R.parent.moduleSpecifier) ? e.quotePreferenceFromString(R.parent.moduleSpecifier, T) : 1, ve = e.makeImport(void 0, [oe(se, K.text)], R.parent.moduleSpecifier, O);
                      b.insertNodeAfter(T, R.parent, ve);
                    } else b.delete(T, K), b.insertNodeAtEndOfList(T, q.elements, ie);
                    break;
                  }
                  case 200:
                    var ee = J;
                    b.replaceNode(T, J, e.factory.createImportTypeNode(ee.argument, e.factory.createIdentifier(se), ee.typeArguments, ee.isTypeOf));
                    break;
                  default:
                    e.Debug.failBadSyntaxKind(J);
                }
              }
              function G(T, K, b) {
                var se = K.parent;
                switch (se.kind) {
                  case 206:
                    b.replaceNode(T, K, e.factory.createIdentifier("default"));
                    break;
                  case 270: {
                    var J = e.factory.createIdentifier(se.name.text);
                    se.parent.elements.length === 1 ? b.replaceNode(T, se.parent, J) : (b.delete(T, se), b.insertNodeBefore(T, se.parent, J));
                    break;
                  }
                  case 275: {
                    b.replaceNode(T, se, f("default", se.name.text));
                    break;
                  }
                  default:
                    e.Debug.assertNever(se, "Unexpected parent kind ".concat(se.kind));
                }
              }
              function oe(T, K) {
                return e.factory.createImportSpecifier(false, T === K ? void 0 : e.factory.createIdentifier(T), e.factory.createIdentifier(K));
              }
              function f(T, K) {
                return e.factory.createExportSpecifier(false, T === K ? void 0 : e.factory.createIdentifier(T), e.factory.createIdentifier(K));
              }
            })(a = e.refactor || (e.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w, B = "Convert import", E = (w = {}, w[0] = { name: "Convert namespace import to named imports", description: e.Diagnostics.Convert_namespace_import_to_named_imports.message, kind: "refactor.rewrite.import.named" }, w[2] = { name: "Convert named imports to namespace import", description: e.Diagnostics.Convert_named_imports_to_namespace_import.message, kind: "refactor.rewrite.import.namespace" }, w[1] = { name: "Convert named imports to default import", description: e.Diagnostics.Convert_named_imports_to_default_import.message, kind: "refactor.rewrite.import.default" }, w);
              C.registerRefactor(B, { kinds: e.getOwnValues(E).map(function(K) {
                return K.kind;
              }), getAvailableActions: function(b) {
                var se = Q(b, b.triggerReason === "invoked");
                if (!se) return e.emptyArray;
                if (!C.isRefactorErrorInfo(se)) {
                  var J = E[se.convertTo];
                  return [{ name: B, description: J.description, actions: [J] }];
                }
                return b.preferences.provideRefactorNotApplicableReason ? e.getOwnValues(E).map(function(ie) {
                  return { name: B, description: ie.description, actions: [Ke(Ke({}, ie), { notApplicableReason: se.error })] };
                }) : e.emptyArray;
              }, getEditsForAction: function(b, se) {
                e.Debug.assert(e.some(e.getOwnValues(E), function(R) {
                  return R.name === se;
                }), "Unexpected action name");
                var J = Q(b);
                e.Debug.assert(J && !C.isRefactorErrorInfo(J), "Expected applicable refactor info");
                var ie = e.textChanges.ChangeTracker.with(b, function(R) {
                  return N(b.file, b.program, R, J);
                });
                return { edits: ie, renameFilename: void 0, renameLocation: void 0 };
              } });
              function Q(K, b) {
                b === void 0 && (b = true);
                var se = K.file, J = e.getRefactorContextSpan(K), ie = e.getTokenAtPosition(se, J.start), R = b ? e.findAncestor(ie, e.isImportDeclaration) : e.getParentNodeInSpan(ie, se, J);
                if (!R || !e.isImportDeclaration(R)) return { error: "Selection is not an import declaration." };
                var q = J.start + J.length, O = e.findNextToken(R, R.parent, se);
                if (!(O && q > O.getStart())) {
                  var ve = R.importClause;
                  if (!ve) return { error: e.getLocaleSpecificMessage(e.Diagnostics.Could_not_find_import_clause) };
                  if (!ve.namedBindings) return { error: e.getLocaleSpecificMessage(e.Diagnostics.Could_not_find_namespace_import_or_named_imports) };
                  if (ve.namedBindings.kind === 268) return { convertTo: 0, import: ve.namedBindings };
                  var ee = le(K.program, ve);
                  return ee ? { convertTo: 1, import: ve.namedBindings } : { convertTo: 2, import: ve.namedBindings };
                }
              }
              function le(K, b) {
                return e.getAllowSyntheticDefaultImports(K.getCompilerOptions()) && f(b.parent.moduleSpecifier, K.getTypeChecker());
              }
              function N(K, b, se, J) {
                var ie = b.getTypeChecker();
                J.convertTo === 0 ? p(K, ie, se, J.import, e.getAllowSyntheticDefaultImports(b.getCompilerOptions())) : oe(K, b, se, J.import, J.convertTo === 1);
              }
              function p(K, b, se, J, ie) {
                var R = false, q = [], O = new e.Map();
                e.FindAllReferences.Core.eachSymbolReferenceInFile(J.name, b, K, function(y) {
                  if (!e.isPropertyAccessOrQualifiedName(y.parent)) R = true;
                  else {
                    var V = m(y.parent).text;
                    b.resolveName(V, y, 67108863, true) && O.set(V, true), e.Debug.assert(G(y.parent) === y, "Parent expression should match id"), q.push(y.parent);
                  }
                });
                for (var ve = new e.Map(), ee = 0, he = q; ee < he.length; ee++) {
                  var F = he[ee], x = m(F).text, X = ve.get(x);
                  X === void 0 && ve.set(x, X = O.has(x) ? e.getUniqueName(x, K) : x), se.replaceNode(K, F, e.factory.createIdentifier(X));
                }
                var $ = [];
                ve.forEach(function(y, V) {
                  $.push(e.factory.createImportSpecifier(false, y === V ? void 0 : e.factory.createIdentifier(V), e.factory.createIdentifier(y)));
                });
                var A = J.parent.parent;
                R && !ie ? se.insertNodeAfter(K, A, T(A, void 0, $)) : se.replaceNode(K, A, T(A, R ? e.factory.createIdentifier(J.name.text) : void 0, $));
              }
              function m(K) {
                return e.isPropertyAccessExpression(K) ? K.name : K.right;
              }
              function G(K) {
                return e.isPropertyAccessExpression(K) ? K.expression : K.left;
              }
              function oe(K, b, se, J, ie) {
                ie === void 0 && (ie = le(b, J.parent));
                var R = b.getTypeChecker(), q = J.parent.parent, O = q.moduleSpecifier, ve = new e.Set();
                J.elements.forEach(function(P) {
                  var k = R.getSymbolAtLocation(P.name);
                  k && ve.add(k);
                });
                var ee = O && e.isStringLiteral(O) ? e.codefix.moduleSpecifierToValidIdentifier(O.text, 99) : "module";
                function he(P) {
                  return !!e.FindAllReferences.Core.eachSymbolReferenceInFile(P.name, R, K, function(k) {
                    var Y = R.resolveName(ee, k, 67108863, true);
                    return Y ? ve.has(Y) ? e.isExportSpecifier(k.parent) : true : false;
                  });
                }
                for (var F = J.elements.some(he), x = F ? e.getUniqueName(ee, K) : ee, X = new e.Set(), $ = function(P) {
                  var k = (P.propertyName || P.name).text;
                  e.FindAllReferences.Core.eachSymbolReferenceInFile(P.name, R, K, function(Y) {
                    var U = e.factory.createPropertyAccessExpression(e.factory.createIdentifier(x), k);
                    e.isShorthandPropertyAssignment(Y.parent) ? se.replaceNode(K, Y.parent, e.factory.createPropertyAssignment(Y.text, U)) : e.isExportSpecifier(Y.parent) ? X.add(P) : se.replaceNode(K, Y, U);
                  });
                }, A = 0, y = J.elements; A < y.length; A++) {
                  var V = y[A];
                  $(V);
                }
                if (se.replaceNode(K, J, ie ? e.factory.createIdentifier(x) : e.factory.createNamespaceImport(e.factory.createIdentifier(x))), X.size) {
                  var L = e.arrayFrom(X.values()).map(function(P) {
                    return e.factory.createImportSpecifier(P.isTypeOnly, P.propertyName && e.factory.createIdentifier(P.propertyName.text), e.factory.createIdentifier(P.name.text));
                  });
                  se.insertNodeAfter(K, J.parent.parent, T(q, void 0, L));
                }
              }
              C.doChangeNamedToNamespaceOrDefault = oe;
              function f(K, b) {
                var se = b.resolveExternalModuleName(K);
                if (!se) return false;
                var J = b.resolveExternalModuleSymbol(se);
                return se !== J;
              }
              function T(K, b, se) {
                return e.factory.createImportDeclaration(void 0, void 0, e.factory.createImportClause(false, b, se && se.length ? e.factory.createNamedImports(se) : void 0), K.moduleSpecifier, void 0);
              }
            })(a = e.refactor || (e.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Convert to optional chain expression", Q = e.getLocaleSpecificMessage(e.Diagnostics.Convert_to_optional_chain_expression), le = { name: E, description: Q, kind: "refactor.rewrite.expression.optionalChain" };
                C.registerRefactor(E, { kinds: [le.kind], getEditsForAction: p, getAvailableActions: N });
                function N(F) {
                  var x = f(F, F.triggerReason === "invoked");
                  return x ? C.isRefactorErrorInfo(x) ? F.preferences.provideRefactorNotApplicableReason ? [{ name: E, description: Q, actions: [Ke(Ke({}, le), { notApplicableReason: x.error })] }] : e.emptyArray : [{ name: E, description: Q, actions: [le] }] : e.emptyArray;
                }
                function p(F, x) {
                  var X = f(F);
                  e.Debug.assert(X && !C.isRefactorErrorInfo(X), "Expected applicable refactor info");
                  var $ = e.textChanges.ChangeTracker.with(F, function(A) {
                    return he(F.file, F.program.getTypeChecker(), A, X, x);
                  });
                  return { edits: $, renameFilename: void 0, renameLocation: void 0 };
                }
                function m(F) {
                  return e.isBinaryExpression(F) || e.isConditionalExpression(F);
                }
                function G(F) {
                  return e.isExpressionStatement(F) || e.isReturnStatement(F) || e.isVariableStatement(F);
                }
                function oe(F) {
                  return m(F) || G(F);
                }
                function f(F, x) {
                  x === void 0 && (x = true);
                  var X = F.file, $ = F.program, A = e.getRefactorContextSpan(F), y = A.length === 0;
                  if (!(y && !x)) {
                    var V = e.getTokenAtPosition(X, A.start), L = e.findTokenOnLeftOfPosition(X, A.start + A.length), P = e.createTextSpanFromBounds(V.pos, L && L.end >= V.pos ? L.getEnd() : V.getEnd()), k = y ? q(V) : R(V, P), Y = k && oe(k) ? O(k) : void 0;
                    if (!Y) return { error: e.getLocaleSpecificMessage(e.Diagnostics.Could_not_find_convertible_access_expression) };
                    var U = $.getTypeChecker();
                    return e.isConditionalExpression(Y) ? T(Y, U) : K(Y);
                  }
                }
                function T(F, x) {
                  var X = F.condition, $ = ve(F.whenTrue);
                  if (!$ || x.isNullableType(x.getTypeAtLocation($))) return { error: e.getLocaleSpecificMessage(e.Diagnostics.Could_not_find_convertible_access_expression) };
                  if ((e.isPropertyAccessExpression(X) || e.isIdentifier(X)) && se(X, $.expression)) return { finalExpression: $, occurrences: [X], expression: F };
                  if (e.isBinaryExpression(X)) {
                    var A = b($.expression, X);
                    return A ? { finalExpression: $, occurrences: A, expression: F } : { error: e.getLocaleSpecificMessage(e.Diagnostics.Could_not_find_matching_access_expressions) };
                  }
                }
                function K(F) {
                  if (F.operatorToken.kind !== 55) return { error: e.getLocaleSpecificMessage(e.Diagnostics.Can_only_convert_logical_AND_access_chains) };
                  var x = ve(F.right);
                  if (!x) return { error: e.getLocaleSpecificMessage(e.Diagnostics.Could_not_find_convertible_access_expression) };
                  var X = b(x.expression, F.left);
                  return X ? { finalExpression: x, occurrences: X, expression: F } : { error: e.getLocaleSpecificMessage(e.Diagnostics.Could_not_find_matching_access_expressions) };
                }
                function b(F, x) {
                  for (var X = []; e.isBinaryExpression(x) && x.operatorToken.kind === 55; ) {
                    var $ = se(e.skipParentheses(F), e.skipParentheses(x.right));
                    if (!$) break;
                    X.push($), F = $, x = x.left;
                  }
                  var A = se(F, x);
                  return A && X.push(A), X.length > 0 ? X : void 0;
                }
                function se(F, x) {
                  if (!(!e.isIdentifier(x) && !e.isPropertyAccessExpression(x) && !e.isElementAccessExpression(x))) return J(F, x) ? x : void 0;
                }
                function J(F, x) {
                  for (; (e.isCallExpression(F) || e.isPropertyAccessExpression(F) || e.isElementAccessExpression(F)) && ie(F) !== ie(x); ) F = F.expression;
                  for (; e.isPropertyAccessExpression(F) && e.isPropertyAccessExpression(x) || e.isElementAccessExpression(F) && e.isElementAccessExpression(x); ) {
                    if (ie(F) !== ie(x)) return false;
                    F = F.expression, x = x.expression;
                  }
                  return e.isIdentifier(F) && e.isIdentifier(x) && F.getText() === x.getText();
                }
                function ie(F) {
                  if (e.isIdentifier(F) || e.isStringOrNumericLiteralLike(F)) return F.getText();
                  if (e.isPropertyAccessExpression(F)) return ie(F.name);
                  if (e.isElementAccessExpression(F)) return ie(F.argumentExpression);
                }
                function R(F, x) {
                  for (; F.parent; ) {
                    if (oe(F) && x.length !== 0 && F.end >= x.start + x.length) return F;
                    F = F.parent;
                  }
                }
                function q(F) {
                  for (; F.parent; ) {
                    if (oe(F) && !oe(F.parent)) return F;
                    F = F.parent;
                  }
                }
                function O(F) {
                  if (m(F)) return F;
                  if (e.isVariableStatement(F)) {
                    var x = e.getSingleVariableOfVariableStatement(F), X = x == null ? void 0 : x.initializer;
                    return X && m(X) ? X : void 0;
                  }
                  return F.expression && m(F.expression) ? F.expression : void 0;
                }
                function ve(F) {
                  if (F = e.skipParentheses(F), e.isBinaryExpression(F)) return ve(F.left);
                  if ((e.isPropertyAccessExpression(F) || e.isElementAccessExpression(F) || e.isCallExpression(F)) && !e.isOptionalChain(F)) return F;
                }
                function ee(F, x, X) {
                  if (e.isPropertyAccessExpression(x) || e.isElementAccessExpression(x) || e.isCallExpression(x)) {
                    var $ = ee(F, x.expression, X), A = X.length > 0 ? X[X.length - 1] : void 0, y = (A == null ? void 0 : A.getText()) === x.expression.getText();
                    if (y && X.pop(), e.isCallExpression(x)) return y ? e.factory.createCallChain($, e.factory.createToken(28), x.typeArguments, x.arguments) : e.factory.createCallChain($, x.questionDotToken, x.typeArguments, x.arguments);
                    if (e.isPropertyAccessExpression(x)) return y ? e.factory.createPropertyAccessChain($, e.factory.createToken(28), x.name) : e.factory.createPropertyAccessChain($, x.questionDotToken, x.name);
                    if (e.isElementAccessExpression(x)) return y ? e.factory.createElementAccessChain($, e.factory.createToken(28), x.argumentExpression) : e.factory.createElementAccessChain($, x.questionDotToken, x.argumentExpression);
                  }
                  return x;
                }
                function he(F, x, X, $, A) {
                  var y = $.finalExpression, V = $.occurrences, L = $.expression, P = V[V.length - 1], k = ee(x, y, V);
                  k && (e.isPropertyAccessExpression(k) || e.isElementAccessExpression(k) || e.isCallExpression(k)) && (e.isBinaryExpression(L) ? X.replaceNodeRange(F, P, y, k) : e.isConditionalExpression(L) && X.replaceNode(F, L, e.factory.createBinaryExpression(k, e.factory.createToken(60), L.whenFalse)));
                }
              })(w = C.convertToOptionalChainExpression || (C.convertToOptionalChainExpression = {}));
            })(a = e.refactor || (e.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Convert overload list to single signature", Q = e.Diagnostics.Convert_overload_list_to_single_signature.message, le = { name: E, description: Q, kind: "refactor.rewrite.function.overloadList" };
                C.registerRefactor(E, { kinds: [le.kind], getEditsForAction: p, getAvailableActions: N });
                function N(oe) {
                  var f = oe.file, T = oe.startPosition, K = oe.program, b = G(f, T, K);
                  return b ? [{ name: E, description: Q, actions: [le] }] : e.emptyArray;
                }
                function p(oe) {
                  var f = oe.file, T = oe.startPosition, K = oe.program, b = G(f, T, K);
                  if (!b) return;
                  var se = K.getTypeChecker(), J = b[b.length - 1], ie = J;
                  switch (J.kind) {
                    case 168: {
                      ie = e.factory.updateMethodSignature(J, J.modifiers, J.name, J.questionToken, J.typeParameters, q(b), J.type);
                      break;
                    }
                    case 169: {
                      ie = e.factory.updateMethodDeclaration(J, J.decorators, J.modifiers, J.asteriskToken, J.name, J.questionToken, J.typeParameters, q(b), J.type, J.body);
                      break;
                    }
                    case 174: {
                      ie = e.factory.updateCallSignature(J, J.typeParameters, q(b), J.type);
                      break;
                    }
                    case 171: {
                      ie = e.factory.updateConstructorDeclaration(J, J.decorators, J.modifiers, q(b), J.body);
                      break;
                    }
                    case 175: {
                      ie = e.factory.updateConstructSignature(J, J.typeParameters, q(b), J.type);
                      break;
                    }
                    case 256: {
                      ie = e.factory.updateFunctionDeclaration(J, J.decorators, J.modifiers, J.asteriskToken, J.name, J.typeParameters, q(b), J.type, J.body);
                      break;
                    }
                    default:
                      return e.Debug.failBadSyntaxKind(J, "Unhandled signature kind in overload list conversion refactoring");
                  }
                  if (ie === J) return;
                  var R = e.textChanges.ChangeTracker.with(oe, function(ee) {
                    ee.replaceNodeRange(f, b[0], b[b.length - 1], ie);
                  });
                  return { renameFilename: void 0, renameLocation: void 0, edits: R };
                  function q(ee) {
                    var he = ee[ee.length - 1];
                    return e.isFunctionLikeDeclaration(he) && he.body && (ee = ee.slice(0, ee.length - 1)), e.factory.createNodeArray([e.factory.createParameterDeclaration(void 0, void 0, e.factory.createToken(25), "args", void 0, e.factory.createUnionTypeNode(e.map(ee, O)))]);
                  }
                  function O(ee) {
                    var he = e.map(ee.parameters, ve);
                    return e.setEmitFlags(e.factory.createTupleTypeNode(he), e.some(he, function(F) {
                      return !!e.length(e.getSyntheticLeadingComments(F));
                    }) ? 0 : 1);
                  }
                  function ve(ee) {
                    e.Debug.assert(e.isIdentifier(ee.name));
                    var he = e.setTextRange(e.factory.createNamedTupleMember(ee.dotDotDotToken, ee.name, ee.questionToken, ee.type || e.factory.createKeywordTypeNode(130)), ee), F = ee.symbol && ee.symbol.getDocumentationComment(se);
                    if (F) {
                      var x = e.displayPartsToString(F);
                      x.length && e.setSyntheticLeadingComments(he, [{ text: `*
`.concat(x.split(`
`).map(function(X) {
                        return " * ".concat(X);
                      }).join(`
`), `
 `), kind: 3, pos: -1, end: -1, hasTrailingNewLine: true, hasLeadingNewline: true }]);
                    }
                    return he;
                  }
                }
                function m(oe) {
                  switch (oe.kind) {
                    case 168:
                    case 169:
                    case 174:
                    case 171:
                    case 175:
                    case 256:
                      return true;
                  }
                  return false;
                }
                function G(oe, f, T) {
                  var K = e.getTokenAtPosition(oe, f), b = e.findAncestor(K, m);
                  if (!!b) {
                    var se = T.getTypeChecker(), J = b.symbol;
                    if (!!J) {
                      var ie = J.declarations;
                      if (!(e.length(ie) <= 1) && !!e.every(ie, function(ee) {
                        return e.getSourceFileOfNode(ee) === oe;
                      }) && !!m(ie[0])) {
                        var R = ie[0].kind;
                        if (!!e.every(ie, function(ee) {
                          return ee.kind === R;
                        })) {
                          var q = ie;
                          if (!e.some(q, function(ee) {
                            return !!ee.typeParameters || e.some(ee.parameters, function(he) {
                              return !!he.decorators || !!he.modifiers || !e.isIdentifier(he.name);
                            });
                          })) {
                            var O = e.mapDefined(q, function(ee) {
                              return se.getSignatureFromDeclaration(ee);
                            });
                            if (e.length(O) === e.length(ie)) {
                              var ve = se.getReturnTypeOfSignature(O[0]);
                              if (!!e.every(O, function(ee) {
                                return se.getReturnTypeOfSignature(ee) === ve;
                              })) return q;
                            }
                          }
                        }
                      }
                    }
                  }
                }
              })(w = C.addOrRemoveBracesToArrowFunction || (C.addOrRemoveBracesToArrowFunction = {}));
            })(a = e.refactor || (e.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Extract Symbol", Q = { name: "Extract Constant", description: e.getLocaleSpecificMessage(e.Diagnostics.Extract_constant), kind: "refactor.extract.constant" }, le = { name: "Extract Function", description: e.getLocaleSpecificMessage(e.Diagnostics.Extract_function), kind: "refactor.extract.function" };
                C.registerRefactor(E, { kinds: [Q.kind, le.kind], getEditsForAction: p, getAvailableActions: N });
                function N(Fe) {
                  var Z = Fe.kind, Be = oe(Fe.file, e.getRefactorContextSpan(Fe), Fe.triggerReason === "invoked"), ge = Be.targetRange;
                  if (ge === void 0) {
                    if (!Be.errors || Be.errors.length === 0 || !Fe.preferences.provideRefactorNotApplicableReason) return e.emptyArray;
                    var Re = [];
                    return C.refactorKindBeginsWith(le.kind, Z) && Re.push({ name: E, description: le.description, actions: [Ke(Ke({}, le), { notApplicableReason: Ne(Be.errors) })] }), C.refactorKindBeginsWith(Q.kind, Z) && Re.push({ name: E, description: Q.description, actions: [Ke(Ke({}, Q), { notApplicableReason: Ne(Be.errors) })] }), Re;
                  }
                  var ze = ie(ge, Fe);
                  if (ze === void 0) return e.emptyArray;
                  for (var Ee = [], He = new e.Map(), rr, Ie = [], _e = new e.Map(), we, de = 0, ye = 0, Ae = ze; ye < Ae.length; ye++) {
                    var er = Ae[ye], ir = er.functionExtraction, Cr = er.constantExtraction, Ye = ir.description;
                    if (C.refactorKindBeginsWith(le.kind, Z) && (ir.errors.length === 0 ? He.has(Ye) || (He.set(Ye, true), Ee.push({ description: Ye, name: "function_scope_".concat(de), kind: le.kind })) : rr || (rr = { description: Ye, name: "function_scope_".concat(de), notApplicableReason: Ne(ir.errors), kind: le.kind })), C.refactorKindBeginsWith(Q.kind, Z)) if (Cr.errors.length === 0) {
                      var Br = Cr.description;
                      _e.has(Br) || (_e.set(Br, true), Ie.push({ description: Br, name: "constant_scope_".concat(de), kind: Q.kind }));
                    } else we || (we = { description: Ye, name: "constant_scope_".concat(de), notApplicableReason: Ne(Cr.errors), kind: Q.kind });
                    de++;
                  }
                  var Er = [];
                  return Ee.length ? Er.push({ name: E, description: e.getLocaleSpecificMessage(e.Diagnostics.Extract_function), actions: Ee }) : Fe.preferences.provideRefactorNotApplicableReason && rr && Er.push({ name: E, description: e.getLocaleSpecificMessage(e.Diagnostics.Extract_function), actions: [rr] }), Ie.length ? Er.push({ name: E, description: e.getLocaleSpecificMessage(e.Diagnostics.Extract_constant), actions: Ie }) : Fe.preferences.provideRefactorNotApplicableReason && we && Er.push({ name: E, description: e.getLocaleSpecificMessage(e.Diagnostics.Extract_constant), actions: [we] }), Er.length ? Er : e.emptyArray;
                  function Ne(n) {
                    var lr = n[0].messageText;
                    return typeof lr != "string" && (lr = lr.messageText), lr;
                  }
                }
                B.getRefactorActionsToExtractSymbol = N;
                function p(Fe, Z) {
                  var Be = oe(Fe.file, e.getRefactorContextSpan(Fe)), ge = Be.targetRange, Re = /^function_scope_(\d+)$/.exec(Z);
                  if (Re) {
                    var ze = +Re[1];
                    return e.Debug.assert(isFinite(ze), "Expected to parse a finite number from the function scope index"), se(ge, Fe, ze);
                  }
                  var Ee = /^constant_scope_(\d+)$/.exec(Z);
                  if (Ee) {
                    var ze = +Ee[1];
                    return e.Debug.assert(isFinite(ze), "Expected to parse a finite number from the constant scope index"), J(ge, Fe, ze);
                  }
                  e.Debug.fail("Unrecognized action name");
                }
                B.getRefactorEditsToExtractSymbol = p;
                var m;
                (function(Fe) {
                  function Z(Be) {
                    return { message: Be, code: 0, category: e.DiagnosticCategory.Message, key: Be };
                  }
                  Fe.cannotExtractRange = Z("Cannot extract range."), Fe.cannotExtractImport = Z("Cannot extract import statement."), Fe.cannotExtractSuper = Z("Cannot extract super call."), Fe.cannotExtractJSDoc = Z("Cannot extract JSDoc."), Fe.cannotExtractEmpty = Z("Cannot extract empty range."), Fe.expressionExpected = Z("expression expected."), Fe.uselessConstantType = Z("No reason to extract constant of type."), Fe.statementOrExpressionExpected = Z("Statement or expression expected."), Fe.cannotExtractRangeContainingConditionalBreakOrContinueStatements = Z("Cannot extract range containing conditional break or continue statements."), Fe.cannotExtractRangeContainingConditionalReturnStatement = Z("Cannot extract range containing conditional return statement."), Fe.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange = Z("Cannot extract range containing labeled break or continue with target outside of the range."), Fe.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators = Z("Cannot extract range containing writes to references located outside of the target range in generators."), Fe.typeWillNotBeVisibleInTheNewScope = Z("Type will not visible in the new scope."), Fe.functionWillNotBeVisibleInTheNewScope = Z("Function will not visible in the new scope."), Fe.cannotExtractIdentifier = Z("Select more than a single identifier."), Fe.cannotExtractExportedEntity = Z("Cannot extract exported declaration"), Fe.cannotWriteInExpression = Z("Cannot write back side-effects when extracting an expression"), Fe.cannotExtractReadonlyPropertyInitializerOutsideConstructor = Z("Cannot move initialization of read-only class property outside of the constructor"), Fe.cannotExtractAmbientBlock = Z("Cannot extract code from ambient contexts"), Fe.cannotAccessVariablesFromNestedScopes = Z("Cannot access variables from nested scopes"), Fe.cannotExtractToJSClass = Z("Cannot extract constant to a class scope in JS"), Fe.cannotExtractToExpressionArrowFunction = Z("Cannot extract constant to an arrow function without a block"), Fe.cannotExtractFunctionsContainingThisToMethod = Z("Cannot extract functions containing this to method");
                })(m = B.Messages || (B.Messages = {}));
                var G;
                (function(Fe) {
                  Fe[Fe.None = 0] = "None", Fe[Fe.HasReturn = 1] = "HasReturn", Fe[Fe.IsGenerator = 2] = "IsGenerator", Fe[Fe.IsAsyncFunction = 4] = "IsAsyncFunction", Fe[Fe.UsesThis = 8] = "UsesThis", Fe[Fe.UsesThisInFunction = 16] = "UsesThisInFunction", Fe[Fe.InStaticRegion = 32] = "InStaticRegion";
                })(G || (G = {}));
                function oe(Fe, Z, Be) {
                  Be === void 0 && (Be = true);
                  var ge = Z.length;
                  if (ge === 0 && !Be) return { errors: [e.createFileDiagnostic(Fe, Z.start, ge, m.cannotExtractEmpty)] };
                  var Re = ge === 0 && Be, ze = e.findFirstNonJsxWhitespaceToken(Fe, Z.start), Ee = e.findTokenOnLeftOfPosition(Fe, e.textSpanEnd(Z)), He = ze && Ee && Be ? f(ze, Ee, Fe) : Z, rr = Re ? fe(ze) : e.getParentNodeInSpan(ze, Fe, He), Ie = Re ? rr : e.getParentNodeInSpan(Ee, Fe, He), _e = [], we = G.None, de;
                  if (!rr || !Ie) return { errors: [e.createFileDiagnostic(Fe, Z.start, ge, m.cannotExtractRange)] };
                  if (rr.flags & 8388608) return { errors: [e.createFileDiagnostic(Fe, Z.start, ge, m.cannotExtractJSDoc)] };
                  if (rr.parent !== Ie.parent) return { errors: [e.createFileDiagnostic(Fe, Z.start, ge, m.cannotExtractRange)] };
                  if (rr !== Ie) {
                    if (!ne(rr.parent)) return { errors: [e.createFileDiagnostic(Fe, Z.start, ge, m.cannotExtractRange)] };
                    for (var ye = [], Ae = 0, er = rr.parent.statements; Ae < er.length; Ae++) {
                      var ir = er[Ae];
                      if (ir === rr || ye.length) {
                        var Cr = lr(ir);
                        if (Cr) return { errors: Cr };
                        ye.push(ir);
                      }
                      if (ir === Ie) break;
                    }
                    return ye.length ? { targetRange: { range: ye, facts: we, declarations: _e, thisNode: de } } : { errors: [e.createFileDiagnostic(Fe, Z.start, ge, m.cannotExtractRange)] };
                  }
                  if (e.isReturnStatement(rr) && !rr.expression) return { errors: [e.createFileDiagnostic(Fe, Z.start, ge, m.cannotExtractRange)] };
                  var Ye = Er(rr), Br = Ne(Ye) || lr(Ye);
                  if (Br) return { errors: Br };
                  return { targetRange: { range: T(Ye), facts: we, declarations: _e, thisNode: de } };
                  function Er(be) {
                    if (e.isReturnStatement(be)) {
                      if (be.expression) return be.expression;
                    } else if (e.isVariableStatement(be) || e.isVariableDeclarationList(be)) {
                      for (var Ge = e.isVariableStatement(be) ? be.declarationList.declarations : be.declarations, ur = 0, yr = void 0, Ir = 0, wr = Ge; Ir < wr.length; Ir++) {
                        var Ur = wr[Ir];
                        Ur.initializer && (ur++, yr = Ur.initializer);
                      }
                      if (ur === 1) return yr;
                    } else if (e.isVariableDeclaration(be) && be.initializer) return be.initializer;
                    return be;
                  }
                  function Ne(be) {
                    if (e.isIdentifier(e.isExpressionStatement(be) ? be.expression : be)) return [e.createDiagnosticForNode(be, m.cannotExtractIdentifier)];
                  }
                  function n(be, Ge) {
                    for (var ur = be; ur !== Ge; ) {
                      if (ur.kind === 167) {
                        e.isStatic(ur) && (we |= G.InStaticRegion);
                        break;
                      } else if (ur.kind === 164) {
                        var yr = e.getContainingFunction(ur);
                        yr.kind === 171 && (we |= G.InStaticRegion);
                        break;
                      } else ur.kind === 169 && e.isStatic(ur) && (we |= G.InStaticRegion);
                      ur = ur.parent;
                    }
                  }
                  function lr(be) {
                    var Ge;
                    if (function(mi) {
                      mi[mi.None = 0] = "None", mi[mi.Break = 1] = "Break", mi[mi.Continue = 2] = "Continue", mi[mi.Return = 4] = "Return";
                    }(Ge || (Ge = {})), e.Debug.assert(be.pos <= be.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809 (1)"), e.Debug.assert(!e.positionIsSynthesized(be.pos), "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809 (2)"), !e.isStatement(be) && !(e.isExpressionNode(be) && g(be)) && !We(be)) return [e.createDiagnosticForNode(be, m.statementOrExpressionExpected)];
                    if (be.flags & 16777216) return [e.createDiagnosticForNode(be, m.cannotExtractAmbientBlock)];
                    var ur = e.getContainingClass(be);
                    ur && n(be, ur);
                    var yr, Ir = 4, wr;
                    if (ii(be), we & G.UsesThis) {
                      var Ur = e.getThisContainer(be, false);
                      (Ur.kind === 256 || Ur.kind === 169 && Ur.parent.kind === 205 || Ur.kind === 213) && (we |= G.UsesThisInFunction);
                    }
                    return yr;
                    function ii(mi) {
                      if (yr) return true;
                      if (e.isDeclaration(mi)) {
                        var pe = mi.kind === 254 ? mi.parent.parent : mi;
                        if (e.hasSyntacticModifier(pe, 1)) return (yr || (yr = [])).push(e.createDiagnosticForNode(mi, m.cannotExtractExportedEntity)), true;
                        _e.push(mi.symbol);
                      }
                      switch (mi.kind) {
                        case 266:
                          return (yr || (yr = [])).push(e.createDiagnosticForNode(mi, m.cannotExtractImport)), true;
                        case 271:
                          return (yr || (yr = [])).push(e.createDiagnosticForNode(mi, m.cannotExtractExportedEntity)), true;
                        case 106:
                          if (mi.parent.kind === 208) {
                            var or = e.getContainingClass(mi);
                            if (or === void 0 || or.pos < Z.start || or.end >= Z.start + Z.length) return (yr || (yr = [])).push(e.createDiagnosticForNode(mi, m.cannotExtractSuper)), true;
                          } else we |= G.UsesThis, de = mi;
                          break;
                        case 214:
                          e.forEachChild(mi, function Di(wi) {
                            if (e.isThis(wi)) we |= G.UsesThis, de = mi;
                            else {
                              if (e.isClassLike(wi) || e.isFunctionLike(wi) && !e.isArrowFunction(wi)) return false;
                              e.forEachChild(wi, Di);
                            }
                          });
                        case 257:
                        case 256:
                          e.isSourceFile(mi.parent) && mi.parent.externalModuleIndicator === void 0 && (yr || (yr = [])).push(e.createDiagnosticForNode(mi, m.functionWillNotBeVisibleInTheNewScope));
                        case 226:
                        case 213:
                        case 169:
                        case 171:
                        case 172:
                        case 173:
                          return false;
                      }
                      var qr = Ir;
                      switch (mi.kind) {
                        case 239:
                          Ir = 0;
                          break;
                        case 252:
                          Ir = 0;
                          break;
                        case 235:
                          mi.parent && mi.parent.kind === 252 && mi.parent.finallyBlock === mi && (Ir = 4);
                          break;
                        case 290:
                        case 289:
                          Ir |= 1;
                          break;
                        default:
                          e.isIterationStatement(mi, false) && (Ir |= 3);
                          break;
                      }
                      switch (mi.kind) {
                        case 192:
                        case 108:
                          we |= G.UsesThis, de = mi;
                          break;
                        case 250: {
                          var si = mi.label;
                          (wr || (wr = [])).push(si.escapedText), e.forEachChild(mi, ii), wr.pop();
                          break;
                        }
                        case 246:
                        case 245: {
                          var si = mi.label;
                          si ? e.contains(wr, si.escapedText) || (yr || (yr = [])).push(e.createDiagnosticForNode(mi, m.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange)) : Ir & (mi.kind === 246 ? 1 : 2) || (yr || (yr = [])).push(e.createDiagnosticForNode(mi, m.cannotExtractRangeContainingConditionalBreakOrContinueStatements));
                          break;
                        }
                        case 218:
                          we |= G.IsAsyncFunction;
                          break;
                        case 224:
                          we |= G.IsGenerator;
                          break;
                        case 247:
                          Ir & 4 ? we |= G.HasReturn : (yr || (yr = [])).push(e.createDiagnosticForNode(mi, m.cannotExtractRangeContainingConditionalReturnStatement));
                          break;
                        default:
                          e.forEachChild(mi, ii);
                          break;
                      }
                      Ir = qr;
                    }
                  }
                }
                B.getRangeToExtract = oe;
                function f(Fe, Z, Be) {
                  var ge = Fe.getStart(Be), Re = Z.getEnd();
                  return Be.text.charCodeAt(Re) === 59 && Re++, { start: ge, length: Re - ge };
                }
                function T(Fe) {
                  if (e.isStatement(Fe)) return [Fe];
                  if (e.isExpressionNode(Fe)) return e.isExpressionStatement(Fe.parent) ? [Fe.parent] : Fe;
                  if (We(Fe)) return Fe;
                }
                function K(Fe) {
                  return e.isArrowFunction(Fe) ? e.isFunctionBody(Fe.body) : e.isFunctionLikeDeclaration(Fe) || e.isSourceFile(Fe) || e.isModuleBlock(Fe) || e.isClassLike(Fe);
                }
                function b(Fe) {
                  var Z = I(Fe.range) ? e.first(Fe.range) : Fe.range;
                  if (Fe.facts & G.UsesThis && !(Fe.facts & G.UsesThisInFunction)) {
                    var Be = e.getContainingClass(Z);
                    if (Be) {
                      var ge = e.findAncestor(Z, e.isFunctionLikeDeclaration);
                      return ge ? [ge, Be] : [Be];
                    }
                  }
                  for (var Re = []; ; ) if (Z = Z.parent, Z.kind === 164 && (Z = e.findAncestor(Z, function(ze) {
                    return e.isFunctionLikeDeclaration(ze);
                  }).parent), K(Z) && (Re.push(Z), Z.kind === 305)) return Re;
                }
                function se(Fe, Z, Be) {
                  var ge = R(Fe, Z), Re = ge.scopes, ze = ge.readsAndWrites, Ee = ze.target, He = ze.usagesPerScope, rr = ze.functionErrorsPerScope, Ie = ze.exposedVariableDeclarations;
                  return e.Debug.assert(!rr[Be].length, "The extraction went missing? How?"), Z.cancellationToken.throwIfCancellationRequested(), x(Ee, Re[Be], He[Be], Ie, Fe, Z);
                }
                function J(Fe, Z, Be) {
                  var ge = R(Fe, Z), Re = ge.scopes, ze = ge.readsAndWrites, Ee = ze.target, He = ze.usagesPerScope, rr = ze.constantErrorsPerScope, Ie = ze.exposedVariableDeclarations;
                  e.Debug.assert(!rr[Be].length, "The extraction went missing? How?"), e.Debug.assert(Ie.length === 0, "Extract constant accepted a range containing a variable declaration?"), Z.cancellationToken.throwIfCancellationRequested();
                  var _e = e.isExpression(Ee) ? Ee : Ee.statements[0].expression;
                  return X(_e, Re[Be], He[Be], Fe.facts, Z);
                }
                function ie(Fe, Z) {
                  var Be = R(Fe, Z), ge = Be.scopes, Re = Be.readsAndWrites, ze = Re.functionErrorsPerScope, Ee = Re.constantErrorsPerScope, He = ge.map(function(rr, Ie) {
                    var _e = q(rr), we = O(rr), de = e.isFunctionLikeDeclaration(rr) ? ve(rr) : e.isClassLike(rr) ? ee(rr) : he(rr), ye, Ae;
                    return de === 1 ? (ye = e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1_scope), [_e, "global"]), Ae = e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1_scope), [we, "global"])) : de === 0 ? (ye = e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1_scope), [_e, "module"]), Ae = e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1_scope), [we, "module"])) : (ye = e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1), [_e, de]), Ae = e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1), [we, de])), Ie === 0 && !e.isClassLike(rr) && (Ae = e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_enclosing_scope), [we])), { functionExtraction: { description: ye, errors: ze[Ie] }, constantExtraction: { description: Ae, errors: Ee[Ie] } };
                  });
                  return He;
                }
                function R(Fe, Z) {
                  var Be = Z.file, ge = b(Fe), Re = l(Fe, Be), ze = D(Fe, ge, Re, Be, Z.program.getTypeChecker(), Z.cancellationToken);
                  return { scopes: ge, readsAndWrites: ze };
                }
                function q(Fe) {
                  return e.isFunctionLikeDeclaration(Fe) ? "inner function" : e.isClassLike(Fe) ? "method" : "function";
                }
                function O(Fe) {
                  return e.isClassLike(Fe) ? "readonly field" : "constant";
                }
                function ve(Fe) {
                  switch (Fe.kind) {
                    case 171:
                      return "constructor";
                    case 213:
                    case 256:
                      return Fe.name ? "function '".concat(Fe.name.text, "'") : e.ANONYMOUS;
                    case 214:
                      return "arrow function";
                    case 169:
                      return "method '".concat(Fe.name.getText(), "'");
                    case 172:
                      return "'get ".concat(Fe.name.getText(), "'");
                    case 173:
                      return "'set ".concat(Fe.name.getText(), "'");
                    default:
                      throw e.Debug.assertNever(Fe, "Unexpected scope kind ".concat(Fe.kind));
                  }
                }
                function ee(Fe) {
                  return Fe.kind === 257 ? Fe.name ? "class '".concat(Fe.name.text, "'") : "anonymous class declaration" : Fe.name ? "class expression '".concat(Fe.name.text, "'") : "anonymous class expression";
                }
                function he(Fe) {
                  return Fe.kind === 262 ? "namespace '".concat(Fe.parent.name.getText(), "'") : Fe.externalModuleIndicator ? 0 : 1;
                }
                var F;
                (function(Fe) {
                  Fe[Fe.Module = 0] = "Module", Fe[Fe.Global = 1] = "Global";
                })(F || (F = {}));
                function x(Fe, Z, Be, ge, Re, ze) {
                  var Ee = Be.usages, He = Be.typeParameterUsages, rr = Be.substitutions, Ie = ze.program.getTypeChecker(), _e = e.getEmitScriptTarget(ze.program.getCompilerOptions()), we = e.codefix.createImportAdder(ze.file, ze.program, ze.preferences, ze.host), de = Z.getSourceFile(), ye = e.getUniqueName(e.isClassLike(Z) ? "newMethod" : "newFunction", de), Ae = e.isInJSFile(Z), er = e.factory.createIdentifier(ye), ir, Cr = [], Ye = [], Br;
                  Ee.forEach(function(xe, vr) {
                    var mr;
                    if (!Ae) {
                      var Ar = Ie.getTypeOfSymbolAtLocation(xe.symbol, xe.node);
                      Ar = Ie.getBaseTypeOfLiteralType(Ar), mr = e.codefix.typeToAutoImportableTypeNode(Ie, we, Ar, Z, _e, 1);
                    }
                    var Oe = e.factory.createParameterDeclaration(void 0, void 0, void 0, vr, void 0, mr);
                    Cr.push(Oe), xe.usage === 2 && (Br || (Br = [])).push(xe), Ye.push(e.factory.createIdentifier(vr));
                  });
                  var Er = e.arrayFrom(He.values()).map(function(xe) {
                    return { type: xe, declaration: A(xe) };
                  }), Ne = Er.sort(y), n = Ne.length === 0 ? void 0 : Ne.map(function(xe) {
                    return xe.declaration;
                  }), lr = n !== void 0 ? n.map(function(xe) {
                    return e.factory.createTypeReferenceNode(xe.name, void 0);
                  }) : void 0;
                  if (e.isExpression(Fe) && !Ae) {
                    var be = Ie.getContextualType(Fe);
                    ir = Ie.typeToTypeNode(be, Z, 1);
                  }
                  var Ge = L(Fe, ge, Br, rr, !!(Re.facts & G.HasReturn)), ur = Ge.body, yr = Ge.returnValueProperty;
                  e.suppressLeadingAndTrailingTrivia(ur);
                  var Ir, wr = !!(Re.facts & G.UsesThisInFunction);
                  if (e.isClassLike(Z)) {
                    var Ur = Ae ? [] : [e.factory.createModifier(121)];
                    Re.facts & G.InStaticRegion && Ur.push(e.factory.createModifier(124)), Re.facts & G.IsAsyncFunction && Ur.push(e.factory.createModifier(131)), Ir = e.factory.createMethodDeclaration(void 0, Ur.length ? Ur : void 0, Re.facts & G.IsGenerator ? e.factory.createToken(41) : void 0, er, void 0, n, Cr, ir, ur);
                  } else wr && Cr.unshift(e.factory.createParameterDeclaration(void 0, void 0, void 0, "this", void 0, Ie.typeToTypeNode(Ie.getTypeAtLocation(Re.thisNode), Z, 1), void 0)), Ir = e.factory.createFunctionDeclaration(void 0, Re.facts & G.IsAsyncFunction ? [e.factory.createToken(131)] : void 0, Re.facts & G.IsGenerator ? e.factory.createToken(41) : void 0, er, n, Cr, ir, ur);
                  var ii = e.textChanges.ChangeTracker.fromContext(ze), mi = (I(Re.range) ? e.last(Re.range) : Re.range).end, pe = Y(mi, Z);
                  pe ? ii.insertNodeBefore(ze.file, pe, Ir, true) : ii.insertNodeAtEndOfScope(ze.file, Z, Ir), we.writeFixes(ii);
                  var or = [], qr = V(Z, Re, ye);
                  wr && Ye.unshift(e.factory.createIdentifier("this"));
                  var si = e.factory.createCallExpression(wr ? e.factory.createPropertyAccessExpression(qr, "call") : qr, lr, Ye);
                  if (Re.facts & G.IsGenerator && (si = e.factory.createYieldExpression(e.factory.createToken(41), si)), Re.facts & G.IsAsyncFunction && (si = e.factory.createAwaitExpression(si)), ue(Fe) && (si = e.factory.createJsxExpression(void 0, si)), ge.length && !Br) if (e.Debug.assert(!yr, "Expected no returnValueProperty"), e.Debug.assert(!(Re.facts & G.HasReturn), "Expected RangeFacts.HasReturn flag to be unset"), ge.length === 1) {
                    var Di = ge[0];
                    or.push(e.factory.createVariableStatement(void 0, e.factory.createVariableDeclarationList([e.factory.createVariableDeclaration(e.getSynthesizedDeepClone(Di.name), void 0, e.getSynthesizedDeepClone(Di.type), si)], Di.parent.flags)));
                  } else {
                    for (var wi = [], Xi = [], et = ge[0].parent.flags, Gi = false, Wt = 0, Zt = ge; Wt < Zt.length; Wt++) {
                      var Di = Zt[Wt];
                      wi.push(e.factory.createBindingElement(void 0, void 0, e.getSynthesizedDeepClone(Di.name)));
                      var _r = Ie.typeToTypeNode(Ie.getBaseTypeOfLiteralType(Ie.getTypeAtLocation(Di)), Z, 1);
                      Xi.push(e.factory.createPropertySignature(void 0, Di.symbol.name, void 0, _r)), Gi = Gi || Di.type !== void 0, et = et & Di.parent.flags;
                    }
                    var pi = Gi ? e.factory.createTypeLiteralNode(Xi) : void 0;
                    pi && e.setEmitFlags(pi, 1), or.push(e.factory.createVariableStatement(void 0, e.factory.createVariableDeclarationList([e.factory.createVariableDeclaration(e.factory.createObjectBindingPattern(wi), void 0, pi, si)], et)));
                  }
                  else if (ge.length || Br) {
                    if (ge.length) for (var ae = 0, Xe = ge; ae < Xe.length; ae++) {
                      var Di = Xe[ae], Jr = Di.parent.flags;
                      Jr & 2 && (Jr = Jr & -3 | 1), or.push(e.factory.createVariableStatement(void 0, e.factory.createVariableDeclarationList([e.factory.createVariableDeclaration(Di.symbol.name, void 0, Je(Di.type))], Jr)));
                    }
                    yr && or.push(e.factory.createVariableStatement(void 0, e.factory.createVariableDeclarationList([e.factory.createVariableDeclaration(yr, void 0, Je(ir))], 1)));
                    var ti = H(ge, Br);
                    yr && ti.unshift(e.factory.createShorthandPropertyAssignment(yr)), ti.length === 1 ? (e.Debug.assert(!yr, "Shouldn't have returnValueProperty here"), or.push(e.factory.createExpressionStatement(e.factory.createAssignment(ti[0].name, si))), Re.facts & G.HasReturn && or.push(e.factory.createReturnStatement())) : (or.push(e.factory.createExpressionStatement(e.factory.createAssignment(e.factory.createObjectLiteralExpression(ti), si))), yr && or.push(e.factory.createReturnStatement(e.factory.createIdentifier(yr))));
                  } else Re.facts & G.HasReturn ? or.push(e.factory.createReturnStatement(si)) : I(Re.range) ? or.push(e.factory.createExpressionStatement(si)) : or.push(si);
                  I(Re.range) ? ii.replaceNodeRangeWithNodes(ze.file, e.first(Re.range), e.last(Re.range), or) : ii.replaceNodeWithNodes(ze.file, Re.range, or);
                  var Ze = ii.getChanges(), Sr = I(Re.range) ? e.first(Re.range) : Re.range, zr = Sr.getSourceFile().fileName, Wr = e.getRenameLocation(Ze, zr, ye, false);
                  return { renameFilename: zr, renameLocation: Wr, edits: Ze };
                  function Je(xe) {
                    if (xe !== void 0) {
                      for (var vr = e.getSynthesizedDeepClone(xe), mr = vr; e.isParenthesizedTypeNode(mr); ) mr = mr.type;
                      return e.isUnionTypeNode(mr) && e.find(mr.types, function(Ar) {
                        return Ar.kind === 153;
                      }) ? vr : e.factory.createUnionTypeNode([vr, e.factory.createKeywordTypeNode(153)]);
                    }
                  }
                }
                function X(Fe, Z, Be, ge, Re) {
                  var ze, Ee = Be.substitutions, He = Re.program.getTypeChecker(), rr = Z.getSourceFile(), Ie = e.isPropertyAccessExpression(Fe) && !e.isClassLike(Z) && !He.resolveName(Fe.name.text, Fe, 111551, false) && !e.isPrivateIdentifier(Fe.name) && !e.isKeyword(Fe.name.originalKeywordKind) ? Fe.name.text : e.getUniqueName(e.isClassLike(Z) ? "newProperty" : "newLocal", rr), _e = e.isInJSFile(Z), we = _e || !He.isContextSensitive(Fe) ? void 0 : He.typeToTypeNode(He.getContextualType(Fe), Z, 1), de = P(e.skipParentheses(Fe), Ee);
                  ze = Ge(we, de), we = ze.variableType, de = ze.initializer, e.suppressLeadingAndTrailingTrivia(de);
                  var ye = e.textChanges.ChangeTracker.fromContext(Re);
                  if (e.isClassLike(Z)) {
                    e.Debug.assert(!_e, "Cannot extract to a JS class");
                    var Ae = [];
                    Ae.push(e.factory.createModifier(121)), ge & G.InStaticRegion && Ae.push(e.factory.createModifier(124)), Ae.push(e.factory.createModifier(145));
                    var er = e.factory.createPropertyDeclaration(void 0, Ae, Ie, void 0, we, de), ir = e.factory.createPropertyAccessExpression(ge & G.InStaticRegion ? e.factory.createIdentifier(Z.name.getText()) : e.factory.createThis(), e.factory.createIdentifier(Ie));
                    ue(Fe) && (ir = e.factory.createJsxExpression(void 0, ir));
                    var Cr = Fe.pos, Ye = U(Cr, Z);
                    ye.insertNodeBefore(Re.file, Ye, er, true), ye.replaceNode(Re.file, Fe, ir);
                  } else {
                    var Br = e.factory.createVariableDeclaration(Ie, void 0, we, de), Er = $(Fe, Z);
                    if (Er) {
                      ye.insertNodeBefore(Re.file, Er, Br);
                      var ir = e.factory.createIdentifier(Ie);
                      ye.replaceNode(Re.file, Fe, ir);
                    } else if (Fe.parent.kind === 238 && Z === e.findAncestor(Fe, K)) {
                      var Ne = e.factory.createVariableStatement(void 0, e.factory.createVariableDeclarationList([Br], 2));
                      ye.replaceNode(Re.file, Fe.parent, Ne);
                    } else {
                      var Ne = e.factory.createVariableStatement(void 0, e.factory.createVariableDeclarationList([Br], 2)), Ye = j(Fe, Z);
                      if (Ye.pos === 0 ? ye.insertNodeAtTopOfFile(Re.file, Ne, false) : ye.insertNodeBefore(Re.file, Ye, Ne, false), Fe.parent.kind === 238) ye.delete(Re.file, Fe.parent);
                      else {
                        var ir = e.factory.createIdentifier(Ie);
                        ue(Fe) && (ir = e.factory.createJsxExpression(void 0, ir)), ye.replaceNode(Re.file, Fe, ir);
                      }
                    }
                  }
                  var n = ye.getChanges(), lr = Fe.getSourceFile().fileName, be = e.getRenameLocation(n, lr, Ie, true);
                  return { renameFilename: lr, renameLocation: be, edits: n };
                  function Ge(ur, yr) {
                    if (ur === void 0) return { variableType: ur, initializer: yr };
                    if (!e.isFunctionExpression(yr) && !e.isArrowFunction(yr) || !!yr.typeParameters) return { variableType: ur, initializer: yr };
                    var Ir = He.getTypeAtLocation(Fe), wr = e.singleOrUndefined(He.getSignaturesOfType(Ir, 0));
                    if (!wr) return { variableType: ur, initializer: yr };
                    if (wr.getTypeParameters()) return { variableType: ur, initializer: yr };
                    for (var Ur = [], ii = false, mi = 0, pe = yr.parameters; mi < pe.length; mi++) {
                      var or = pe[mi];
                      if (or.type) Ur.push(or);
                      else {
                        var qr = He.getTypeAtLocation(or);
                        qr === He.getAnyType() && (ii = true), Ur.push(e.factory.updateParameterDeclaration(or, or.decorators, or.modifiers, or.dotDotDotToken, or.name, or.questionToken, or.type || He.typeToTypeNode(qr, Z, 1), or.initializer));
                      }
                    }
                    if (ii) return { variableType: ur, initializer: yr };
                    if (ur = void 0, e.isArrowFunction(yr)) yr = e.factory.updateArrowFunction(yr, Fe.modifiers, yr.typeParameters, Ur, yr.type || He.typeToTypeNode(wr.getReturnType(), Z, 1), yr.equalsGreaterThanToken, yr.body);
                    else {
                      if (wr && !!wr.thisParameter) {
                        var si = e.firstOrUndefined(Ur);
                        if (!si || e.isIdentifier(si.name) && si.name.escapedText !== "this") {
                          var Di = He.getTypeOfSymbolAtLocation(wr.thisParameter, Fe);
                          Ur.splice(0, 0, e.factory.createParameterDeclaration(void 0, void 0, void 0, "this", void 0, He.typeToTypeNode(Di, Z, 1)));
                        }
                      }
                      yr = e.factory.updateFunctionExpression(yr, Fe.modifiers, yr.asteriskToken, yr.name, yr.typeParameters, Ur, yr.type || He.typeToTypeNode(wr.getReturnType(), Z, 1), yr.body);
                    }
                    return { variableType: ur, initializer: yr };
                  }
                }
                function $(Fe, Z) {
                  for (var Be; Fe !== void 0 && Fe !== Z; ) {
                    if (e.isVariableDeclaration(Fe) && Fe.initializer === Be && e.isVariableDeclarationList(Fe.parent) && Fe.parent.declarations.length > 1) return Fe;
                    Be = Fe, Fe = Fe.parent;
                  }
                }
                function A(Fe) {
                  var Z, Be = Fe.symbol;
                  if (Be && Be.declarations) for (var ge = 0, Re = Be.declarations; ge < Re.length; ge++) {
                    var ze = Re[ge];
                    (Z === void 0 || ze.pos < Z.pos) && (Z = ze);
                  }
                  return Z;
                }
                function y(Fe, Z) {
                  var Be = Fe.type, ge = Fe.declaration, Re = Z.type, ze = Z.declaration;
                  return e.compareProperties(ge, ze, "pos", e.compareValues) || e.compareStringsCaseSensitive(Be.symbol ? Be.symbol.getName() : "", Re.symbol ? Re.symbol.getName() : "") || e.compareValues(Be.id, Re.id);
                }
                function V(Fe, Z, Be) {
                  var ge = e.factory.createIdentifier(Be);
                  if (e.isClassLike(Fe)) {
                    var Re = Z.facts & G.InStaticRegion ? e.factory.createIdentifier(Fe.name.text) : e.factory.createThis();
                    return e.factory.createPropertyAccessExpression(Re, ge);
                  } else return ge;
                }
                function L(Fe, Z, Be, ge, Re) {
                  var ze = Be !== void 0 || Z.length > 0;
                  if (e.isBlock(Fe) && !ze && ge.size === 0) return { body: e.factory.createBlock(Fe.statements, true), returnValueProperty: void 0 };
                  var Ee, He = false, rr = e.factory.createNodeArray(e.isBlock(Fe) ? Fe.statements.slice(0) : [e.isStatement(Fe) ? Fe : e.factory.createReturnStatement(e.skipParentheses(Fe))]);
                  if (ze || ge.size) {
                    var Ie = e.visitNodes(rr, we).slice();
                    if (ze && !Re && e.isStatement(Fe)) {
                      var _e = H(Z, Be);
                      _e.length === 1 ? Ie.push(e.factory.createReturnStatement(_e[0].name)) : Ie.push(e.factory.createReturnStatement(e.factory.createObjectLiteralExpression(_e)));
                    }
                    return { body: e.factory.createBlock(Ie, true), returnValueProperty: Ee };
                  } else return { body: e.factory.createBlock(rr, true), returnValueProperty: void 0 };
                  function we(de) {
                    if (!He && e.isReturnStatement(de) && ze) {
                      var ye = H(Z, Be);
                      return de.expression && (Ee || (Ee = "__return"), ye.unshift(e.factory.createPropertyAssignment(Ee, e.visitNode(de.expression, we)))), ye.length === 1 ? e.factory.createReturnStatement(ye[0].name) : e.factory.createReturnStatement(e.factory.createObjectLiteralExpression(ye));
                    } else {
                      var Ae = He;
                      He = He || e.isFunctionLikeDeclaration(de) || e.isClassLike(de);
                      var er = ge.get(e.getNodeId(de).toString()), ir = er ? e.getSynthesizedDeepClone(er) : e.visitEachChild(de, we, e.nullTransformationContext);
                      return He = Ae, ir;
                    }
                  }
                }
                function P(Fe, Z) {
                  return Z.size ? Be(Fe) : Fe;
                  function Be(ge) {
                    var Re = Z.get(e.getNodeId(ge).toString());
                    return Re ? e.getSynthesizedDeepClone(Re) : e.visitEachChild(ge, Be, e.nullTransformationContext);
                  }
                }
                function k(Fe) {
                  if (e.isFunctionLikeDeclaration(Fe)) {
                    var Z = Fe.body;
                    if (e.isBlock(Z)) return Z.statements;
                  } else {
                    if (e.isModuleBlock(Fe) || e.isSourceFile(Fe)) return Fe.statements;
                    if (e.isClassLike(Fe)) return Fe.members;
                    e.assertType(Fe);
                  }
                  return e.emptyArray;
                }
                function Y(Fe, Z) {
                  return e.find(k(Z), function(Be) {
                    return Be.pos >= Fe && e.isFunctionLikeDeclaration(Be) && !e.isConstructorDeclaration(Be);
                  });
                }
                function U(Fe, Z) {
                  var Be = Z.members;
                  e.Debug.assert(Be.length > 0, "Found no members");
                  for (var ge, Re = true, ze = 0, Ee = Be; ze < Ee.length; ze++) {
                    var He = Ee[ze];
                    if (He.pos > Fe) return ge || Be[0];
                    if (Re && !e.isPropertyDeclaration(He)) {
                      if (ge !== void 0) return He;
                      Re = false;
                    }
                    ge = He;
                  }
                  return ge === void 0 ? e.Debug.fail() : ge;
                }
                function j(Fe, Z) {
                  e.Debug.assert(!e.isClassLike(Z));
                  for (var Be, ge = Fe; ge !== Z; ge = ge.parent) K(ge) && (Be = ge);
                  for (var ge = (Be || Fe).parent; ; ge = ge.parent) {
                    if (ne(ge)) {
                      for (var Re = void 0, ze = 0, Ee = ge.statements; ze < Ee.length; ze++) {
                        var He = Ee[ze];
                        if (He.pos > Fe.pos) break;
                        Re = He;
                      }
                      return !Re && e.isCaseClause(ge) ? (e.Debug.assert(e.isSwitchStatement(ge.parent.parent), "Grandparent isn't a switch statement"), ge.parent.parent) : e.Debug.checkDefined(Re, "prevStatement failed to get set");
                    }
                    e.Debug.assert(ge !== Z, "Didn't encounter a block-like before encountering scope");
                  }
                }
                function H(Fe, Z) {
                  var Be = e.map(Fe, function(Re) {
                    return e.factory.createShorthandPropertyAssignment(Re.symbol.name);
                  }), ge = e.map(Z, function(Re) {
                    return e.factory.createShorthandPropertyAssignment(Re.symbol.name);
                  });
                  return Be === void 0 ? ge : ge === void 0 ? Be : Be.concat(ge);
                }
                function I(Fe) {
                  return e.isArray(Fe);
                }
                function l(Fe, Z) {
                  return I(Fe.range) ? { pos: e.first(Fe.range).getStart(Z), end: e.last(Fe.range).getEnd() } : Fe.range;
                }
                var d;
                (function(Fe) {
                  Fe[Fe.Read = 1] = "Read", Fe[Fe.Write = 2] = "Write";
                })(d || (d = {}));
                function D(Fe, Z, Be, ge, Re, ze) {
                  var Ee = new e.Map(), He = [], rr = [], Ie = [], _e = [], we = [], de = new e.Map(), ye = [], Ae, er = I(Fe.range) ? Fe.range.length === 1 && e.isExpressionStatement(Fe.range[0]) ? Fe.range[0].expression : void 0 : Fe.range, ir;
                  if (er === void 0) {
                    var Cr = Fe.range, Ye = e.first(Cr).getStart(), Br = e.last(Cr).end;
                    ir = e.createFileDiagnostic(ge, Ye, Br - Ye, m.expressionExpected);
                  } else Re.getTypeAtLocation(er).flags & 147456 && (ir = e.createDiagnosticForNode(er, m.uselessConstantType));
                  for (var Er = 0, Ne = Z; Er < Ne.length; Er++) {
                    var n = Ne[Er];
                    He.push({ usages: new e.Map(), typeParameterUsages: new e.Map(), substitutions: new e.Map() }), rr.push(new e.Map()), Ie.push([]);
                    var lr = [];
                    ir && lr.push(ir), e.isClassLike(n) && e.isInJSFile(n) && lr.push(e.createDiagnosticForNode(n, m.cannotExtractToJSClass)), e.isArrowFunction(n) && !e.isBlock(n.body) && lr.push(e.createDiagnosticForNode(n, m.cannotExtractToExpressionArrowFunction)), _e.push(lr);
                  }
                  var be = new e.Map(), Ge = I(Fe.range) ? e.factory.createBlock(Fe.range) : Fe.range, ur = I(Fe.range) ? e.first(Fe.range) : Fe.range, yr = Xi(ur);
                  if (Gi(Ge), yr && !I(Fe.range) && !e.isJsxAttribute(Fe.range)) {
                    var Ir = Re.getContextualType(Fe.range);
                    et(Ir);
                  }
                  if (Ee.size > 0) {
                    for (var wr = new e.Map(), Ur = 0, ii = ur; ii !== void 0 && Ur < Z.length; ii = ii.parent) if (ii === Z[Ur] && (wr.forEach(function(Xe, Jr) {
                      He[Ur].typeParameterUsages.set(Jr, Xe);
                    }), Ur++), e.isDeclarationWithTypeParameters(ii)) for (var mi = 0, pe = e.getEffectiveTypeParameterDeclarations(ii); mi < pe.length; mi++) {
                      var or = pe[mi], qr = Re.getTypeAtLocation(or);
                      Ee.has(qr.id.toString()) && wr.set(qr.id.toString(), qr);
                    }
                    e.Debug.assert(Ur === Z.length, "Should have iterated all scopes");
                  }
                  if (we.length) {
                    var si = e.isBlockScope(Z[0], Z[0].parent) ? Z[0] : e.getEnclosingBlockScopeContainer(Z[0]);
                    e.forEachChild(si, _r);
                  }
                  for (var Di = function(Xe) {
                    var Jr = He[Xe];
                    if (Xe > 0 && (Jr.usages.size > 0 || Jr.typeParameterUsages.size > 0)) {
                      var ti = I(Fe.range) ? Fe.range[0] : Fe.range;
                      _e[Xe].push(e.createDiagnosticForNode(ti, m.cannotAccessVariablesFromNestedScopes));
                    }
                    Fe.facts & G.UsesThisInFunction && e.isClassLike(Z[Xe]) && Ie[Xe].push(e.createDiagnosticForNode(Fe.thisNode, m.cannotExtractFunctionsContainingThisToMethod));
                    var Ze = false, Sr;
                    if (He[Xe].usages.forEach(function(Wr) {
                      Wr.usage === 2 && (Ze = true, Wr.symbol.flags & 106500 && Wr.symbol.valueDeclaration && e.hasEffectiveModifier(Wr.symbol.valueDeclaration, 64) && (Sr = Wr.symbol.valueDeclaration));
                    }), e.Debug.assert(I(Fe.range) || ye.length === 0, "No variable declarations expected if something was extracted"), Ze && !I(Fe.range)) {
                      var zr = e.createDiagnosticForNode(Fe.range, m.cannotWriteInExpression);
                      Ie[Xe].push(zr), _e[Xe].push(zr);
                    } else if (Sr && Xe > 0) {
                      var zr = e.createDiagnosticForNode(Sr, m.cannotExtractReadonlyPropertyInitializerOutsideConstructor);
                      Ie[Xe].push(zr), _e[Xe].push(zr);
                    } else if (Ae) {
                      var zr = e.createDiagnosticForNode(Ae, m.cannotExtractExportedEntity);
                      Ie[Xe].push(zr), _e[Xe].push(zr);
                    }
                  }, wi = 0; wi < Z.length; wi++) Di(wi);
                  return { target: Ge, usagesPerScope: He, functionErrorsPerScope: Ie, constantErrorsPerScope: _e, exposedVariableDeclarations: ye };
                  function Xi(Xe) {
                    return !!e.findAncestor(Xe, function(Jr) {
                      return e.isDeclarationWithTypeParameters(Jr) && e.getEffectiveTypeParameterDeclarations(Jr).length !== 0;
                    });
                  }
                  function et(Xe) {
                    for (var Jr = Re.getSymbolWalker(function() {
                      return ze.throwIfCancellationRequested(), true;
                    }), ti = Jr.walkType(Xe).visitedTypes, Ze = 0, Sr = ti; Ze < Sr.length; Ze++) {
                      var zr = Sr[Ze];
                      zr.isTypeParameter() && Ee.set(zr.id.toString(), zr);
                    }
                  }
                  function Gi(Xe, Jr) {
                    if (Jr === void 0 && (Jr = 1), yr) {
                      var ti = Re.getTypeAtLocation(Xe);
                      et(ti);
                    }
                    if (e.isDeclaration(Xe) && Xe.symbol && we.push(Xe), e.isAssignmentExpression(Xe)) Gi(Xe.left, 2), Gi(Xe.right);
                    else if (e.isUnaryExpressionWithWrite(Xe)) Gi(Xe.operand, 2);
                    else if (e.isPropertyAccessExpression(Xe) || e.isElementAccessExpression(Xe)) e.forEachChild(Xe, Gi);
                    else if (e.isIdentifier(Xe)) {
                      if (!Xe.parent || e.isQualifiedName(Xe.parent) && Xe !== Xe.parent.left || e.isPropertyAccessExpression(Xe.parent) && Xe !== Xe.parent.expression) return;
                      Wt(Xe, Jr, e.isPartOfTypeNode(Xe));
                    } else e.forEachChild(Xe, Gi);
                  }
                  function Wt(Xe, Jr, ti) {
                    var Ze = Zt(Xe, Jr, ti);
                    if (Ze) for (var Sr = 0; Sr < Z.length; Sr++) {
                      var zr = rr[Sr].get(Ze);
                      zr && He[Sr].substitutions.set(e.getNodeId(Xe).toString(), zr);
                    }
                  }
                  function Zt(Xe, Jr, ti) {
                    var Ze = pi(Xe);
                    if (!!Ze) {
                      var Sr = e.getSymbolId(Ze).toString(), zr = be.get(Sr);
                      if (zr && zr >= Jr) return Sr;
                      if (be.set(Sr, Jr), zr) {
                        for (var Wr = 0, Je = He; Wr < Je.length; Wr++) {
                          var xe = Je[Wr], vr = xe.usages.get(Xe.text);
                          vr && xe.usages.set(Xe.text, { usage: Jr, symbol: Ze, node: Xe });
                        }
                        return Sr;
                      }
                      var mr = Ze.getDeclarations(), Ar = mr && e.find(mr, function(vi) {
                        return vi.getSourceFile() === ge;
                      });
                      if (!!Ar && !e.rangeContainsStartEnd(Be, Ar.getStart(), Ar.end)) {
                        if (Fe.facts & G.IsGenerator && Jr === 2) {
                          for (var Oe = e.createDiagnosticForNode(Xe, m.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators), nr = 0, Mr = Ie; nr < Mr.length; nr++) {
                            var Pe = Mr[nr];
                            Pe.push(Oe);
                          }
                          for (var Ue = 0, fr = _e; Ue < fr.length; Ue++) {
                            var Pe = fr[Ue];
                            Pe.push(Oe);
                          }
                        }
                        for (var De = 0; De < Z.length; De++) {
                          var gr = Z[De], Vr = Re.resolveName(Ze.name, gr, Ze.flags, false);
                          if (Vr !== Ze && !rr[De].has(Sr)) {
                            var Tr = ae(Ze.exportSymbol || Ze, gr, ti);
                            if (Tr) rr[De].set(Sr, Tr);
                            else if (ti) {
                              if (!(Ze.flags & 262144)) {
                                var Oe = e.createDiagnosticForNode(Xe, m.typeWillNotBeVisibleInTheNewScope);
                                Ie[De].push(Oe), _e[De].push(Oe);
                              }
                            } else He[De].usages.set(Xe.text, { usage: Jr, symbol: Ze, node: Xe });
                          }
                        }
                        return Sr;
                      }
                    }
                  }
                  function _r(Xe) {
                    if (!(Xe === Fe.range || I(Fe.range) && Fe.range.indexOf(Xe) >= 0)) {
                      var Jr = e.isIdentifier(Xe) ? pi(Xe) : Re.getSymbolAtLocation(Xe);
                      if (Jr) {
                        var ti = e.find(we, function(Sr) {
                          return Sr.symbol === Jr;
                        });
                        if (ti) if (e.isVariableDeclaration(ti)) {
                          var Ze = ti.symbol.id.toString();
                          de.has(Ze) || (ye.push(ti), de.set(Ze, true));
                        } else Ae = Ae || ti;
                      }
                      e.forEachChild(Xe, _r);
                    }
                  }
                  function pi(Xe) {
                    return Xe.parent && e.isShorthandPropertyAssignment(Xe.parent) && Xe.parent.name === Xe ? Re.getShorthandAssignmentValueSymbol(Xe.parent) : Re.getSymbolAtLocation(Xe);
                  }
                  function ae(Xe, Jr, ti) {
                    if (!!Xe) {
                      var Ze = Xe.getDeclarations();
                      if (Ze && Ze.some(function(zr) {
                        return zr.parent === Jr;
                      })) return e.factory.createIdentifier(Xe.name);
                      var Sr = ae(Xe.parent, Jr, ti);
                      if (Sr !== void 0) return ti ? e.factory.createQualifiedName(Sr, e.factory.createIdentifier(Xe.name)) : e.factory.createPropertyAccessExpression(Sr, Xe.name);
                    }
                  }
                }
                function fe(Fe) {
                  return e.findAncestor(Fe, function(Z) {
                    return Z.parent && g(Z) && !e.isBinaryExpression(Z.parent);
                  });
                }
                function g(Fe) {
                  var Z = Fe.parent;
                  switch (Z.kind) {
                    case 299:
                      return false;
                  }
                  switch (Fe.kind) {
                    case 10:
                      return Z.kind !== 266 && Z.kind !== 270;
                    case 225:
                    case 201:
                    case 203:
                      return false;
                    case 79:
                      return Z.kind !== 203 && Z.kind !== 270 && Z.kind !== 275;
                  }
                  return true;
                }
                function ne(Fe) {
                  switch (Fe.kind) {
                    case 235:
                    case 305:
                    case 262:
                    case 289:
                      return true;
                    default:
                      return false;
                  }
                }
                function ue(Fe) {
                  return We(Fe) || (e.isJsxElement(Fe) || e.isJsxSelfClosingElement(Fe) || e.isJsxFragment(Fe)) && (e.isJsxElement(Fe.parent) || e.isJsxFragment(Fe.parent));
                }
                function We(Fe) {
                  return e.isStringLiteral(Fe) && Fe.parent && e.isJsxAttribute(Fe.parent);
                }
              })(w = C.extractSymbol || (C.extractSymbol = {}));
            })(a = e.refactor || (e.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "Extract type", B = { name: "Extract to type alias", description: e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_type_alias), kind: "refactor.extract.type" }, E = { name: "Extract to interface", description: e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_interface), kind: "refactor.extract.interface" }, Q = { name: "Extract to typedef", description: e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_typedef), kind: "refactor.extract.typedef" };
              C.registerRefactor(w, { kinds: [B.kind, E.kind, Q.kind], getAvailableActions: function(K) {
                var b = le(K, K.triggerReason === "invoked");
                return b ? C.isRefactorErrorInfo(b) ? K.preferences.provideRefactorNotApplicableReason ? [{ name: w, description: e.getLocaleSpecificMessage(e.Diagnostics.Extract_type), actions: [Ke(Ke({}, Q), { notApplicableReason: b.error }), Ke(Ke({}, B), { notApplicableReason: b.error }), Ke(Ke({}, E), { notApplicableReason: b.error })] }] : e.emptyArray : [{ name: w, description: e.getLocaleSpecificMessage(e.Diagnostics.Extract_type), actions: b.isJS ? [Q] : e.append([B], b.typeElements && E) }] : e.emptyArray;
              }, getEditsForAction: function(K, b) {
                var se = K.file, J = le(K);
                e.Debug.assert(J && !C.isRefactorErrorInfo(J), "Expected to find a range to extract");
                var ie = e.getUniqueName("NewType", se), R = e.textChanges.ChangeTracker.with(K, function(ve) {
                  switch (b) {
                    case B.name:
                      return e.Debug.assert(!J.isJS, "Invalid actionName/JS combo"), G(ve, se, ie, J);
                    case Q.name:
                      return e.Debug.assert(J.isJS, "Invalid actionName/JS combo"), f(ve, se, ie, J);
                    case E.name:
                      return e.Debug.assert(!J.isJS && !!J.typeElements, "Invalid actionName/JS combo"), oe(ve, se, ie, J);
                    default:
                      e.Debug.fail("Unexpected action name");
                  }
                }), q = se.fileName, O = e.getRenameLocation(R, q, ie, false);
                return { edits: R, renameFilename: q, renameLocation: O };
              } });
              function le(T, K) {
                K === void 0 && (K = true);
                var b = T.file, se = T.startPosition, J = e.isSourceFileJS(b), ie = e.getTokenAtPosition(b, se), R = e.createTextRangeFromSpan(e.getRefactorContextSpan(T)), q = R.pos === R.end && K, O = e.findAncestor(ie, function(x) {
                  return x.parent && e.isTypeNode(x) && !p(R, x.parent, b) && (q || e.nodeOverlapsWithStartEnd(ie, b, R.pos, R.end));
                });
                if (!O || !e.isTypeNode(O)) return { error: e.getLocaleSpecificMessage(e.Diagnostics.Selection_is_not_a_valid_type_node) };
                var ve = T.program.getTypeChecker(), ee = e.Debug.checkDefined(e.findAncestor(O, e.isStatement), "Should find a statement"), he = m(ve, O, ee, b);
                if (!he) return { error: e.getLocaleSpecificMessage(e.Diagnostics.No_type_could_be_extracted_from_this_type_node) };
                var F = N(ve, O);
                return { isJS: J, selection: O, firstStatement: ee, typeParameters: he, typeElements: F };
              }
              function N(T, K) {
                if (!!K) if (e.isIntersectionTypeNode(K)) {
                  for (var b = [], se = new e.Map(), J = 0, ie = K.types; J < ie.length; J++) {
                    var R = ie[J], q = N(T, R);
                    if (!q || !q.every(function(O) {
                      return O.name && e.addToSeen(se, e.getNameFromPropertyName(O.name));
                    })) return;
                    e.addRange(b, q);
                  }
                  return b;
                } else {
                  if (e.isParenthesizedTypeNode(K)) return N(T, K.type);
                  if (e.isTypeLiteralNode(K)) return K.members;
                }
              }
              function p(T, K, b) {
                return e.rangeContainsStartEnd(T, e.skipTrivia(b.text, K.pos), K.end);
              }
              function m(T, K, b, se) {
                var J = [];
                return ie(K) ? void 0 : J;
                function ie(R) {
                  if (e.isTypeReferenceNode(R)) {
                    if (e.isIdentifier(R.typeName)) for (var q = R.typeName, O = T.resolveName(q.text, q, 262144, true), ve = 0, ee = (O == null ? void 0 : O.declarations) || e.emptyArray; ve < ee.length; ve++) {
                      var he = ee[ve];
                      if (e.isTypeParameterDeclaration(he) && he.getSourceFile() === se) {
                        if (he.name.escapedText === q.escapedText && p(he, K, se)) return true;
                        if (p(b, he, se) && !p(K, he, se)) {
                          e.pushIfUnique(J, he);
                          break;
                        }
                      }
                    }
                  } else if (e.isInferTypeNode(R)) {
                    var F = e.findAncestor(R, function(X) {
                      return e.isConditionalTypeNode(X) && p(X.extendsType, R, se);
                    });
                    if (!F || !p(K, F, se)) return true;
                  } else if (e.isTypePredicateNode(R) || e.isThisTypeNode(R)) {
                    var x = e.findAncestor(R.parent, e.isFunctionLike);
                    if (x && x.type && p(x.type, R, se) && !p(K, x, se)) return true;
                  } else if (e.isTypeQueryNode(R)) {
                    if (e.isIdentifier(R.exprName)) {
                      var O = T.resolveName(R.exprName.text, R.exprName, 111551, false);
                      if ((O == null ? void 0 : O.valueDeclaration) && p(b, O.valueDeclaration, se) && !p(K, O.valueDeclaration, se)) return true;
                    } else if (e.isThisIdentifier(R.exprName.left) && !p(K, R.parent, se)) return true;
                  }
                  return se && e.isTupleTypeNode(R) && e.getLineAndCharacterOfPosition(se, R.pos).line === e.getLineAndCharacterOfPosition(se, R.end).line && e.setEmitFlags(R, 1), e.forEachChild(R, ie);
                }
              }
              function G(T, K, b, se) {
                var J = se.firstStatement, ie = se.selection, R = se.typeParameters, q = e.factory.createTypeAliasDeclaration(void 0, void 0, b, R.map(function(O) {
                  return e.factory.updateTypeParameterDeclaration(O, O.modifiers, O.name, O.constraint, void 0);
                }), ie);
                T.insertNodeBefore(K, J, e.ignoreSourceNewlines(q), true), T.replaceNode(K, ie, e.factory.createTypeReferenceNode(b, R.map(function(O) {
                  return e.factory.createTypeReferenceNode(O.name, void 0);
                })), { leadingTriviaOption: e.textChanges.LeadingTriviaOption.Exclude, trailingTriviaOption: e.textChanges.TrailingTriviaOption.ExcludeWhitespace });
              }
              function oe(T, K, b, se) {
                var J, ie = se.firstStatement, R = se.selection, q = se.typeParameters, O = se.typeElements, ve = e.factory.createInterfaceDeclaration(void 0, void 0, b, q, void 0, O);
                e.setTextRange(ve, (J = O[0]) === null || J === void 0 ? void 0 : J.parent), T.insertNodeBefore(K, ie, e.ignoreSourceNewlines(ve), true), T.replaceNode(K, R, e.factory.createTypeReferenceNode(b, q.map(function(ee) {
                  return e.factory.createTypeReferenceNode(ee.name, void 0);
                })), { leadingTriviaOption: e.textChanges.LeadingTriviaOption.Exclude, trailingTriviaOption: e.textChanges.TrailingTriviaOption.ExcludeWhitespace });
              }
              function f(T, K, b, se) {
                var J = se.firstStatement, ie = se.selection, R = se.typeParameters;
                e.setEmitFlags(ie, 3584);
                var q = e.factory.createJSDocTypedefTag(e.factory.createIdentifier("typedef"), e.factory.createJSDocTypeExpression(ie), e.factory.createIdentifier(b)), O = [];
                e.forEach(R, function(ve) {
                  var ee = e.getEffectiveConstraintOfTypeParameter(ve), he = e.factory.createTypeParameterDeclaration(void 0, ve.name), F = e.factory.createJSDocTemplateTag(e.factory.createIdentifier("template"), ee && e.cast(ee, e.isJSDocTypeExpression), [he]);
                  O.push(F);
                }), T.insertNodeBefore(K, J, e.factory.createJSDocComment(void 0, e.factory.createNodeArray(e.concatenate(O, [q]))), true), T.replaceNode(K, ie, e.factory.createTypeReferenceNode(b, R.map(function(ve) {
                  return e.factory.createTypeReferenceNode(ve.name, void 0);
                })));
              }
            })(a = e.refactor || (e.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Generate 'get' and 'set' accessors", Q = e.Diagnostics.Generate_get_and_set_accessors.message, le = { name: E, description: Q, kind: "refactor.rewrite.property.generateAccessors" };
                C.registerRefactor(E, { kinds: [le.kind], getEditsForAction: function(p, m) {
                  if (!!p.endPosition) {
                    var G = e.codefix.getAccessorConvertiblePropertyAtPosition(p.file, p.program, p.startPosition, p.endPosition);
                    e.Debug.assert(G && !C.isRefactorErrorInfo(G), "Expected applicable refactor info");
                    var oe = e.codefix.generateAccessorFromProperty(p.file, p.program, p.startPosition, p.endPosition, p, m);
                    if (!!oe) {
                      var f = p.file.fileName, T = G.renameAccessor ? G.accessorName : G.fieldName, K = e.isIdentifier(T) ? 0 : -1, b = K + e.getRenameLocation(oe, f, T.text, e.isParameter(G.declaration));
                      return { renameFilename: f, renameLocation: b, edits: oe };
                    }
                  }
                }, getAvailableActions: function(N) {
                  if (!N.endPosition) return e.emptyArray;
                  var p = e.codefix.getAccessorConvertiblePropertyAtPosition(N.file, N.program, N.startPosition, N.endPosition, N.triggerReason === "invoked");
                  return p ? C.isRefactorErrorInfo(p) ? N.preferences.provideRefactorNotApplicableReason ? [{ name: E, description: Q, actions: [Ke(Ke({}, le), { notApplicableReason: p.error })] }] : e.emptyArray : [{ name: E, description: Q, actions: [le] }] : e.emptyArray;
                } });
              })(w = C.generateGetAccessorAndSetAccessor || (C.generateGetAccessorAndSetAccessor = {}));
            })(a = e.refactor || (e.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w(E) {
                return E.error !== void 0;
              }
              C.isRefactorErrorInfo = w;
              function B(E, Q) {
                return Q ? E.substr(0, Q.length) === Q : true;
              }
              C.refactorKindBeginsWith = B;
            })(a = e.refactor || (e.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w = "Move to a new file", B = e.getLocaleSpecificMessage(e.Diagnostics.Move_to_a_new_file), E = { name: w, description: B, kind: "refactor.move.newFile" };
              C.registerRefactor(w, { kinds: [E.kind], getAvailableActions: function(He) {
                var rr = N(He);
                return He.preferences.allowTextChangesInNewFiles && rr ? [{ name: w, description: B, actions: [E] }] : He.preferences.provideRefactorNotApplicableReason ? [{ name: w, description: B, actions: [Ke(Ke({}, E), { notApplicableReason: e.getLocaleSpecificMessage(e.Diagnostics.Selection_is_not_a_valid_statement_or_statements) })] }] : e.emptyArray;
              }, getEditsForAction: function(He, rr) {
                e.Debug.assert(rr === w, "Wrong refactor invoked");
                var Ie = e.Debug.checkDefined(N(He)), _e = e.textChanges.ChangeTracker.with(He, function(we) {
                  return le(He.file, He.program, Ie, we, He.host, He.preferences);
                });
                return { edits: _e, renameFilename: void 0, renameLocation: void 0 };
              } });
              function Q(Ee) {
                var He = Ee.file, rr = e.createTextRangeFromSpan(e.getRefactorContextSpan(Ee)), Ie = He.statements, _e = e.findIndex(Ie, function(ye) {
                  return ye.end > rr.pos;
                });
                if (_e !== -1) {
                  var we = Ie[_e];
                  if (e.isNamedDeclaration(we) && we.name && e.rangeContainsRange(we.name, rr)) return { toMove: [Ie[_e]], afterLast: Ie[_e + 1] };
                  if (!(rr.pos > we.getStart(He))) {
                    var de = e.findIndex(Ie, function(ye) {
                      return ye.end > rr.end;
                    }, _e);
                    if (!(de !== -1 && (de === 0 || Ie[de].getStart(He) < rr.end))) return { toMove: Ie.slice(_e, de === -1 ? Ie.length : de), afterLast: de === -1 ? void 0 : Ie[de] };
                  }
                }
              }
              function le(Ee, He, rr, Ie, _e, we) {
                var de = He.getTypeChecker(), ye = V(Ee, rr.all, de), Ae = e.getDirectoryPath(Ee.fileName), er = e.extensionFromPath(Ee.fileName), ir = A(y(ye.movedSymbols), er, Ae, _e), Cr = ir + er;
                Ie.createNewFile(Ee, e.combinePaths(Ae, Cr), oe(Ee, ye, Ie, rr, He, ir, we)), G(He, Ie, Ee.fileName, Cr, e.hostGetCanonicalFileName(_e));
              }
              function N(Ee) {
                var He = Q(Ee);
                if (He !== void 0) {
                  var rr = [], Ie = [], _e = He.toMove, we = He.afterLast;
                  return e.getRangesWhere(_e, p, function(de, ye) {
                    for (var Ae = de; Ae < ye; Ae++) rr.push(_e[Ae]);
                    Ie.push({ first: _e[de], afterLast: we });
                  }), rr.length === 0 ? void 0 : { all: rr, ranges: Ie };
                }
              }
              function p(Ee) {
                return !m(Ee) && !e.isPrologueDirective(Ee);
              }
              function m(Ee) {
                switch (Ee.kind) {
                  case 266:
                    return true;
                  case 265:
                    return !e.hasSyntacticModifier(Ee, 1);
                  case 237:
                    return Ee.declarationList.declarations.every(function(He) {
                      return !!He.initializer && e.isRequireCall(He.initializer, true);
                    });
                  default:
                    return false;
                }
              }
              function G(Ee, He, rr, Ie, _e) {
                var we = Ee.getCompilerOptions().configFile;
                if (!!we) {
                  var de = e.normalizePath(e.combinePaths(rr, "..", Ie)), ye = e.getRelativePathFromFile(we.fileName, de, _e), Ae = we.statements[0] && e.tryCast(we.statements[0].expression, e.isObjectLiteralExpression), er = Ae && e.find(Ae.properties, function(ir) {
                    return e.isPropertyAssignment(ir) && e.isStringLiteral(ir.name) && ir.name.text === "files";
                  });
                  er && e.isArrayLiteralExpression(er.initializer) && He.insertNodeInListAfter(we, e.last(er.initializer.elements), e.factory.createStringLiteral(ye), er.initializer.elements);
                }
              }
              function oe(Ee, He, rr, Ie, _e, we, de) {
                var ye = _e.getTypeChecker(), Ae = e.takeWhile(Ee.statements, e.isPrologueDirective);
                if (!Ee.externalModuleIndicator && !Ee.commonJsModuleIndicator) return f(Ee, Ie.ranges, rr), Ve(Ve([], Ae, true), Ie.all, true);
                var er = !!Ee.externalModuleIndicator, ir = e.getQuotePreference(Ee, de), Cr = q(He.oldFileImportsFromNewFile, we, er, ir);
                Cr && e.insertImports(rr, Ee, Cr, true), T(Ee, Ie.all, rr, He.unusedImportsFromOldFile, ye), f(Ee, Ie.ranges, rr), K(rr, _e, Ee, He.movedSymbols, we);
                var Ye = $(Ee, He.oldImportsNeededByNewFile, He.newFileImportsFromOldFile, rr, ye, er, ir), Br = he(Ee, Ie.all, He.oldFileImportsFromNewFile, er);
                return Ye.length && Br.length ? Ve(Ve(Ve(Ve([], Ae, true), Ye, true), [4], false), Br, true) : Ve(Ve(Ve([], Ae, true), Ye, true), Br, true);
              }
              function f(Ee, He, rr) {
                for (var Ie = 0, _e = He; Ie < _e.length; Ie++) {
                  var we = _e[Ie], de = we.first, ye = we.afterLast;
                  rr.deleteNodeRangeExcludingEnd(Ee, de, ye);
                }
              }
              function T(Ee, He, rr, Ie, _e) {
                for (var we = 0, de = Ee.statements; we < de.length; we++) {
                  var ye = de[we];
                  e.contains(He, ye) || R(ye, function(Ae) {
                    return F(Ee, Ae, rr, function(er) {
                      return Ie.has(_e.getSymbolAtLocation(er));
                    });
                  });
                }
              }
              function K(Ee, He, rr, Ie, _e) {
                for (var we = He.getTypeChecker(), de = function(ir) {
                  if (ir === rr) return "continue";
                  for (var Cr = function(Ne) {
                    R(Ne, function(n) {
                      if (we.getSymbolAtLocation(ie(n)) === rr.symbol) {
                        var lr = function(yr) {
                          var Ir = e.isBindingElement(yr.parent) ? e.getPropertySymbolFromBindingElement(we, yr.parent) : e.skipAlias(we.getSymbolAtLocation(yr), we);
                          return !!Ir && Ie.has(Ir);
                        };
                        F(ir, n, Ee, lr);
                        var be = e.combinePaths(e.getDirectoryPath(ie(n).text), _e), Ge = k(n, e.factory.createStringLiteral(be), lr);
                        Ge && Ee.insertNodeAfter(ir, Ne, Ge);
                        var ur = b(n);
                        ur && se(Ee, ir, we, Ie, _e, be, ur, n);
                      }
                    });
                  }, Ye = 0, Br = ir.statements; Ye < Br.length; Ye++) {
                    var Er = Br[Ye];
                    Cr(Er);
                  }
                }, ye = 0, Ae = He.getSourceFiles(); ye < Ae.length; ye++) {
                  var er = Ae[ye];
                  de(er);
                }
              }
              function b(Ee) {
                switch (Ee.kind) {
                  case 266:
                    return Ee.importClause && Ee.importClause.namedBindings && Ee.importClause.namedBindings.kind === 268 ? Ee.importClause.namedBindings.name : void 0;
                  case 265:
                    return Ee.name;
                  case 254:
                    return e.tryCast(Ee.name, e.isIdentifier);
                  default:
                    return e.Debug.assertNever(Ee, "Unexpected node kind ".concat(Ee.kind));
                }
              }
              function se(Ee, He, rr, Ie, _e, we, de, ye) {
                var Ae = e.codefix.moduleSpecifierToValidIdentifier(_e, 99), er = false, ir = [];
                if (e.FindAllReferences.Core.eachSymbolReferenceInFile(de, rr, He, function(Ne) {
                  !e.isPropertyAccessExpression(Ne.parent) || (er = er || !!rr.resolveName(Ae, Ne, 67108863, true), Ie.has(rr.getSymbolAtLocation(Ne.parent.name)) && ir.push(Ne));
                }), ir.length) {
                  for (var Cr = er ? e.getUniqueName(Ae, He) : Ae, Ye = 0, Br = ir; Ye < Br.length; Ye++) {
                    var Er = Br[Ye];
                    Ee.replaceNode(He, Er, e.factory.createIdentifier(Cr));
                  }
                  Ee.insertNodeAfter(He, ye, J(ye, _e, we));
                }
              }
              function J(Ee, He, rr) {
                var Ie = e.factory.createIdentifier(He), _e = e.factory.createStringLiteral(rr);
                switch (Ee.kind) {
                  case 266:
                    return e.factory.createImportDeclaration(void 0, void 0, e.factory.createImportClause(false, void 0, e.factory.createNamespaceImport(Ie)), _e, void 0);
                  case 265:
                    return e.factory.createImportEqualsDeclaration(void 0, void 0, false, Ie, e.factory.createExternalModuleReference(_e));
                  case 254:
                    return e.factory.createVariableDeclaration(Ie, void 0, void 0, ee(_e));
                  default:
                    return e.Debug.assertNever(Ee, "Unexpected node kind ".concat(Ee.kind));
                }
              }
              function ie(Ee) {
                return Ee.kind === 266 ? Ee.moduleSpecifier : Ee.kind === 265 ? Ee.moduleReference.expression : Ee.initializer.arguments[0];
              }
              function R(Ee, He) {
                if (e.isImportDeclaration(Ee)) e.isStringLiteral(Ee.moduleSpecifier) && He(Ee);
                else if (e.isImportEqualsDeclaration(Ee)) e.isExternalModuleReference(Ee.moduleReference) && e.isStringLiteralLike(Ee.moduleReference.expression) && He(Ee);
                else if (e.isVariableStatement(Ee)) for (var rr = 0, Ie = Ee.declarationList.declarations; rr < Ie.length; rr++) {
                  var _e = Ie[rr];
                  _e.initializer && e.isRequireCall(_e.initializer, true) && He(_e);
                }
              }
              function q(Ee, He, rr, Ie) {
                var _e, we = [];
                return Ee.forEach(function(de) {
                  de.escapedName === "default" ? _e = e.factory.createIdentifier(e.symbolNameNoDefault(de)) : we.push(de.name);
                }), O(_e, we, He, rr, Ie);
              }
              function O(Ee, He, rr, Ie, _e) {
                if (rr = e.ensurePathIsNonModuleName(rr), Ie) {
                  var we = He.map(function(ye) {
                    return e.factory.createImportSpecifier(false, void 0, e.factory.createIdentifier(ye));
                  });
                  return e.makeImportIfNecessary(Ee, we, rr, _e);
                } else {
                  e.Debug.assert(!Ee, "No default import should exist");
                  var de = He.map(function(ye) {
                    return e.factory.createBindingElement(void 0, void 0, ye);
                  });
                  return de.length ? ve(e.factory.createObjectBindingPattern(de), void 0, ee(e.factory.createStringLiteral(rr))) : void 0;
                }
              }
              function ve(Ee, He, rr, Ie) {
                return Ie === void 0 && (Ie = 2), e.factory.createVariableStatement(void 0, e.factory.createVariableDeclarationList([e.factory.createVariableDeclaration(Ee, void 0, He, rr)], Ie));
              }
              function ee(Ee) {
                return e.factory.createCallExpression(e.factory.createIdentifier("require"), void 0, [Ee]);
              }
              function he(Ee, He, rr, Ie) {
                return e.flatMap(He, function(_e) {
                  if (d(_e) && !Fe(Ee, _e, Ie) && fe(_e, function(de) {
                    return rr.has(e.Debug.checkDefined(de.symbol));
                  })) {
                    var we = Z(_e, Ie);
                    if (we) return we;
                  }
                  return _e;
                });
              }
              function F(Ee, He, rr, Ie) {
                switch (He.kind) {
                  case 266:
                    x(Ee, He, rr, Ie);
                    break;
                  case 265:
                    Ie(He.name) && rr.delete(Ee, He);
                    break;
                  case 254:
                    X(Ee, He, rr, Ie);
                    break;
                  default:
                    e.Debug.assertNever(He, "Unexpected import decl kind ".concat(He.kind));
                }
              }
              function x(Ee, He, rr, Ie) {
                if (!!He.importClause) {
                  var _e = He.importClause, we = _e.name, de = _e.namedBindings, ye = !we || Ie(we), Ae = !de || (de.kind === 268 ? Ie(de.name) : de.elements.length !== 0 && de.elements.every(function(Ye) {
                    return Ie(Ye.name);
                  }));
                  if (ye && Ae) rr.delete(Ee, He);
                  else if (we && ye && rr.delete(Ee, we), de) {
                    if (Ae) rr.replaceNode(Ee, He.importClause, e.factory.updateImportClause(He.importClause, He.importClause.isTypeOnly, we, void 0));
                    else if (de.kind === 269) for (var er = 0, ir = de.elements; er < ir.length; er++) {
                      var Cr = ir[er];
                      Ie(Cr.name) && rr.delete(Ee, Cr);
                    }
                  }
                }
              }
              function X(Ee, He, rr, Ie) {
                var _e = He.name;
                switch (_e.kind) {
                  case 79:
                    Ie(_e) && rr.delete(Ee, _e);
                    break;
                  case 202:
                    break;
                  case 201:
                    if (_e.elements.every(function(Ae) {
                      return e.isIdentifier(Ae.name) && Ie(Ae.name);
                    })) rr.delete(Ee, e.isVariableDeclarationList(He.parent) && He.parent.declarations.length === 1 ? He.parent.parent : He);
                    else for (var we = 0, de = _e.elements; we < de.length; we++) {
                      var ye = de[we];
                      e.isIdentifier(ye.name) && Ie(ye.name) && rr.delete(Ee, ye.name);
                    }
                    break;
                }
              }
              function $(Ee, He, rr, Ie, _e, we, de) {
                for (var ye = [], Ae = 0, er = Ee.statements; Ae < er.length; Ae++) {
                  var ir = er[Ae];
                  R(ir, function(Er) {
                    e.append(ye, k(Er, ie(Er), function(Ne) {
                      return He.has(_e.getSymbolAtLocation(Ne));
                    }));
                  });
                }
                var Cr, Ye = [], Br = e.nodeSeenTracker();
                return rr.forEach(function(Er) {
                  if (!!Er.declarations) for (var Ne = 0, n = Er.declarations; Ne < n.length; Ne++) {
                    var lr = n[Ne];
                    if (!!I(lr)) {
                      var be = ne(lr);
                      if (!!be) {
                        var Ge = ue(lr);
                        Br(Ge) && We(Ee, Ge, be, Ie, we), e.hasSyntacticModifier(lr, 512) ? Cr = be : Ye.push(be.text);
                      }
                    }
                  }
                }), e.append(ye, O(Cr, Ye, e.removeFileExtension(e.getBaseFileName(Ee.fileName)), we, de)), ye;
              }
              function A(Ee, He, rr, Ie) {
                for (var _e = Ee, we = 1; ; we++) {
                  var de = e.combinePaths(rr, _e + He);
                  if (!Ie.fileExists(de)) return _e;
                  _e = "".concat(Ee, ".").concat(we);
                }
              }
              function y(Ee) {
                return Ee.forEachEntry(e.symbolNameNoDefault) || "newFile";
              }
              function V(Ee, He, rr) {
                var Ie = new H(), _e = new H(), we = new H(), de = e.find(He, function(be) {
                  return !!(be.transformFlags & 2);
                }), ye = lr(de);
                ye && _e.add(ye);
                for (var Ae = 0, er = He; Ae < er.length; Ae++) {
                  var ir = er[Ae];
                  fe(ir, function(be) {
                    Ie.add(e.Debug.checkDefined(e.isExpressionStatement(be) ? rr.getSymbolAtLocation(be.expression.left) : be.symbol, "Need a symbol here"));
                  });
                }
                for (var Cr = 0, Ye = He; Cr < Ye.length; Cr++) {
                  var ir = Ye[Cr];
                  j(ir, rr, function(Ge) {
                    if (!!Ge.declarations) for (var ur = 0, yr = Ge.declarations; ur < yr.length; ur++) {
                      var Ir = yr[ur];
                      L(Ir) ? _e.add(Ge) : I(Ir) && l(Ir) === Ee && !Ie.has(Ge) && we.add(Ge);
                    }
                  });
                }
                for (var Br = _e.clone(), Er = new H(), Ne = 0, n = Ee.statements; Ne < n.length; Ne++) {
                  var ir = n[Ne];
                  e.contains(He, ir) || (ye && !!(ir.transformFlags & 2) && Br.delete(ye), j(ir, rr, function(Ge) {
                    Ie.has(Ge) && Er.add(Ge), Br.delete(Ge);
                  }));
                }
                return { movedSymbols: Ie, newFileImportsFromOldFile: we, oldFileImportsFromNewFile: Er, oldImportsNeededByNewFile: _e, unusedImportsFromOldFile: Br };
                function lr(be) {
                  if (be !== void 0) {
                    var Ge = rr.getJsxNamespace(be), ur = rr.resolveName(Ge, be, 1920, true);
                    return !!ur && e.some(ur.declarations, L) ? ur : void 0;
                  }
                }
              }
              function L(Ee) {
                switch (Ee.kind) {
                  case 265:
                  case 270:
                  case 267:
                  case 268:
                    return true;
                  case 254:
                    return P(Ee);
                  case 203:
                    return e.isVariableDeclaration(Ee.parent.parent) && P(Ee.parent.parent);
                  default:
                    return false;
                }
              }
              function P(Ee) {
                return e.isSourceFile(Ee.parent.parent.parent) && !!Ee.initializer && e.isRequireCall(Ee.initializer, true);
              }
              function k(Ee, He, rr) {
                switch (Ee.kind) {
                  case 266: {
                    var Ie = Ee.importClause;
                    if (!Ie) return;
                    var _e = Ie.name && rr(Ie.name) ? Ie.name : void 0, we = Ie.namedBindings && Y(Ie.namedBindings, rr);
                    return _e || we ? e.factory.createImportDeclaration(void 0, void 0, e.factory.createImportClause(false, _e, we), He, void 0) : void 0;
                  }
                  case 265:
                    return rr(Ee.name) ? Ee : void 0;
                  case 254: {
                    var de = U(Ee.name, rr);
                    return de ? ve(de, Ee.type, ee(He), Ee.parent.flags) : void 0;
                  }
                  default:
                    return e.Debug.assertNever(Ee, "Unexpected import kind ".concat(Ee.kind));
                }
              }
              function Y(Ee, He) {
                if (Ee.kind === 268) return He(Ee.name) ? Ee : void 0;
                var rr = Ee.elements.filter(function(Ie) {
                  return He(Ie.name);
                });
                return rr.length ? e.factory.createNamedImports(rr) : void 0;
              }
              function U(Ee, He) {
                switch (Ee.kind) {
                  case 79:
                    return He(Ee) ? Ee : void 0;
                  case 202:
                    return Ee;
                  case 201: {
                    var rr = Ee.elements.filter(function(Ie) {
                      return Ie.propertyName || !e.isIdentifier(Ie.name) || He(Ie.name);
                    });
                    return rr.length ? e.factory.createObjectBindingPattern(rr) : void 0;
                  }
                }
              }
              function j(Ee, He, rr) {
                Ee.forEachChild(function Ie(_e) {
                  if (e.isIdentifier(_e) && !e.isDeclarationName(_e)) {
                    var we = He.getSymbolAtLocation(_e);
                    we && rr(we);
                  } else _e.forEachChild(Ie);
                });
              }
              var H = function() {
                function Ee() {
                  this.map = new e.Map();
                }
                return Ee.prototype.add = function(He) {
                  this.map.set(String(e.getSymbolId(He)), He);
                }, Ee.prototype.has = function(He) {
                  return this.map.has(String(e.getSymbolId(He)));
                }, Ee.prototype.delete = function(He) {
                  this.map.delete(String(e.getSymbolId(He)));
                }, Ee.prototype.forEach = function(He) {
                  this.map.forEach(He);
                }, Ee.prototype.forEachEntry = function(He) {
                  return e.forEachEntry(this.map, He);
                }, Ee.prototype.clone = function() {
                  var He = new Ee();
                  return e.copyEntries(this.map, He.map), He;
                }, Ee;
              }();
              function I(Ee) {
                return D(Ee) && e.isSourceFile(Ee.parent) || e.isVariableDeclaration(Ee) && e.isSourceFile(Ee.parent.parent.parent);
              }
              function l(Ee) {
                return e.isVariableDeclaration(Ee) ? Ee.parent.parent.parent : Ee.parent;
              }
              function d(Ee) {
                return e.Debug.assert(e.isSourceFile(Ee.parent), "Node parent should be a SourceFile"), D(Ee) || e.isVariableStatement(Ee);
              }
              function D(Ee) {
                switch (Ee.kind) {
                  case 256:
                  case 257:
                  case 261:
                  case 260:
                  case 259:
                  case 258:
                  case 265:
                    return true;
                  default:
                    return false;
                }
              }
              function fe(Ee, He) {
                switch (Ee.kind) {
                  case 256:
                  case 257:
                  case 261:
                  case 260:
                  case 259:
                  case 258:
                  case 265:
                    return He(Ee);
                  case 237:
                    return e.firstDefined(Ee.declarationList.declarations, function(Ie) {
                      return g(Ie.name, He);
                    });
                  case 238: {
                    var rr = Ee.expression;
                    return e.isBinaryExpression(rr) && e.getAssignmentDeclarationKind(rr) === 1 ? He(Ee) : void 0;
                  }
                }
              }
              function g(Ee, He) {
                switch (Ee.kind) {
                  case 79:
                    return He(e.cast(Ee.parent, function(rr) {
                      return e.isVariableDeclaration(rr) || e.isBindingElement(rr);
                    }));
                  case 202:
                  case 201:
                    return e.firstDefined(Ee.elements, function(rr) {
                      return e.isOmittedExpression(rr) ? void 0 : g(rr.name, He);
                    });
                  default:
                    return e.Debug.assertNever(Ee, "Unexpected name kind ".concat(Ee.kind));
                }
              }
              function ne(Ee) {
                return e.isExpressionStatement(Ee) ? e.tryCast(Ee.expression.left.name, e.isIdentifier) : e.tryCast(Ee.name, e.isIdentifier);
              }
              function ue(Ee) {
                switch (Ee.kind) {
                  case 254:
                    return Ee.parent.parent;
                  case 203:
                    return ue(e.cast(Ee.parent.parent, function(He) {
                      return e.isVariableDeclaration(He) || e.isBindingElement(He);
                    }));
                  default:
                    return Ee;
                }
              }
              function We(Ee, He, rr, Ie, _e) {
                if (!Fe(Ee, He, _e, rr)) if (_e) e.isExpressionStatement(He) || Ie.insertExportModifier(Ee, He);
                else {
                  var we = Re(He);
                  we.length !== 0 && Ie.insertNodesAfter(Ee, He, we.map(ze));
                }
              }
              function Fe(Ee, He, rr, Ie) {
                var _e;
                return rr ? !e.isExpressionStatement(He) && e.hasSyntacticModifier(He, 1) || !!(Ie && ((_e = Ee.symbol.exports) === null || _e === void 0 ? void 0 : _e.has(Ie.escapedText))) : Re(He).some(function(we) {
                  return Ee.symbol.exports.has(e.escapeLeadingUnderscores(we));
                });
              }
              function Z(Ee, He) {
                return He ? [Be(Ee)] : ge(Ee);
              }
              function Be(Ee) {
                var He = e.concatenate([e.factory.createModifier(93)], Ee.modifiers);
                switch (Ee.kind) {
                  case 256:
                    return e.factory.updateFunctionDeclaration(Ee, Ee.decorators, He, Ee.asteriskToken, Ee.name, Ee.typeParameters, Ee.parameters, Ee.type, Ee.body);
                  case 257:
                    return e.factory.updateClassDeclaration(Ee, Ee.decorators, He, Ee.name, Ee.typeParameters, Ee.heritageClauses, Ee.members);
                  case 237:
                    return e.factory.updateVariableStatement(Ee, He, Ee.declarationList);
                  case 261:
                    return e.factory.updateModuleDeclaration(Ee, Ee.decorators, He, Ee.name, Ee.body);
                  case 260:
                    return e.factory.updateEnumDeclaration(Ee, Ee.decorators, He, Ee.name, Ee.members);
                  case 259:
                    return e.factory.updateTypeAliasDeclaration(Ee, Ee.decorators, He, Ee.name, Ee.typeParameters, Ee.type);
                  case 258:
                    return e.factory.updateInterfaceDeclaration(Ee, Ee.decorators, He, Ee.name, Ee.typeParameters, Ee.heritageClauses, Ee.members);
                  case 265:
                    return e.factory.updateImportEqualsDeclaration(Ee, Ee.decorators, He, Ee.isTypeOnly, Ee.name, Ee.moduleReference);
                  case 238:
                    return e.Debug.fail();
                  default:
                    return e.Debug.assertNever(Ee, "Unexpected declaration kind ".concat(Ee.kind));
                }
              }
              function ge(Ee) {
                return Ve([Ee], Re(Ee).map(ze), true);
              }
              function Re(Ee) {
                switch (Ee.kind) {
                  case 256:
                  case 257:
                    return [Ee.name.text];
                  case 237:
                    return e.mapDefined(Ee.declarationList.declarations, function(He) {
                      return e.isIdentifier(He.name) ? He.name.text : void 0;
                    });
                  case 261:
                  case 260:
                  case 259:
                  case 258:
                  case 265:
                    return e.emptyArray;
                  case 238:
                    return e.Debug.fail("Can't export an ExpressionStatement");
                  default:
                    return e.Debug.assertNever(Ee, "Unexpected decl kind ".concat(Ee.kind));
                }
              }
              function ze(Ee) {
                return e.factory.createExpressionStatement(e.factory.createBinaryExpression(e.factory.createPropertyAccessExpression(e.factory.createIdentifier("exports"), e.factory.createIdentifier(Ee)), 63, e.factory.createIdentifier(Ee)));
              }
            })(a = e.refactor || (e.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Add or remove braces in an arrow function", Q = e.Diagnostics.Add_or_remove_braces_in_an_arrow_function.message, le = { name: "Add braces to arrow function", description: e.Diagnostics.Add_braces_to_arrow_function.message, kind: "refactor.rewrite.arrow.braces.add" }, N = { name: "Remove braces from arrow function", description: e.Diagnostics.Remove_braces_from_arrow_function.message, kind: "refactor.rewrite.arrow.braces.remove" };
                C.registerRefactor(E, { kinds: [N.kind], getEditsForAction: m, getAvailableActions: p });
                function p(oe) {
                  var f = oe.file, T = oe.startPosition, K = oe.triggerReason, b = G(f, T, K === "invoked");
                  return b ? C.isRefactorErrorInfo(b) ? oe.preferences.provideRefactorNotApplicableReason ? [{ name: E, description: Q, actions: [Ke(Ke({}, le), { notApplicableReason: b.error }), Ke(Ke({}, N), { notApplicableReason: b.error })] }] : e.emptyArray : [{ name: E, description: Q, actions: [b.addBraces ? le : N] }] : e.emptyArray;
                }
                function m(oe, f) {
                  var T = oe.file, K = oe.startPosition, b = G(T, K);
                  e.Debug.assert(b && !C.isRefactorErrorInfo(b), "Expected applicable refactor info");
                  var se = b.expression, J = b.returnStatement, ie = b.func, R;
                  if (f === le.name) {
                    var q = e.factory.createReturnStatement(se);
                    R = e.factory.createBlock([q], true), e.copyLeadingComments(se, q, T, 3, true);
                  } else if (f === N.name && J) {
                    var O = se || e.factory.createVoidZero();
                    R = e.needsParentheses(O) ? e.factory.createParenthesizedExpression(O) : O, e.copyTrailingAsLeadingComments(J, R, T, 3, false), e.copyLeadingComments(J, R, T, 3, false), e.copyTrailingComments(J, R, T, 3, false);
                  } else e.Debug.fail("invalid action");
                  var ve = e.textChanges.ChangeTracker.with(oe, function(ee) {
                    ee.replaceNode(T, ie.body, R);
                  });
                  return { renameFilename: void 0, renameLocation: void 0, edits: ve };
                }
                function G(oe, f, T, K) {
                  T === void 0 && (T = true);
                  var b = e.getTokenAtPosition(oe, f), se = e.getContainingFunction(b);
                  if (!se) return { error: e.getLocaleSpecificMessage(e.Diagnostics.Could_not_find_a_containing_arrow_function) };
                  if (!e.isArrowFunction(se)) return { error: e.getLocaleSpecificMessage(e.Diagnostics.Containing_function_is_not_an_arrow_function) };
                  if (!(!e.rangeContainsRange(se, b) || e.rangeContainsRange(se.body, b) && !T)) {
                    if (C.refactorKindBeginsWith(le.kind, K) && e.isExpression(se.body)) return { func: se, addBraces: true, expression: se.body };
                    if (C.refactorKindBeginsWith(N.kind, K) && e.isBlock(se.body) && se.body.statements.length === 1) {
                      var J = e.first(se.body.statements);
                      if (e.isReturnStatement(J)) return { func: se, addBraces: false, expression: J.expression, returnStatement: J };
                    }
                  }
                }
              })(w = C.addOrRemoveBracesToArrowFunction || (C.addOrRemoveBracesToArrowFunction = {}));
            })(a = e.refactor || (e.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Convert parameters to destructured object", Q = 1, le = e.getLocaleSpecificMessage(e.Diagnostics.Convert_parameters_to_destructured_object), N = { name: E, description: le, kind: "refactor.rewrite.parameters.toDestructured" };
                C.registerRefactor(E, { kinds: [N.kind], getEditsForAction: m, getAvailableActions: p });
                function p(U) {
                  var j = U.file, H = U.startPosition, I = e.isSourceFileJS(j);
                  if (I) return e.emptyArray;
                  var l = ie(j, H, U.program.getTypeChecker());
                  return l ? [{ name: E, description: le, actions: [N] }] : e.emptyArray;
                }
                function m(U, j) {
                  e.Debug.assert(j === E, "Unexpected action name");
                  var H = U.file, I = U.startPosition, l = U.program, d = U.cancellationToken, D = U.host, fe = ie(H, I, l.getTypeChecker());
                  if (!(!fe || !d)) {
                    var g = oe(fe, l, d);
                    if (g.valid) {
                      var ne = e.textChanges.ChangeTracker.with(U, function(ue) {
                        return G(H, l, D, ue, fe, g);
                      });
                      return { renameFilename: void 0, renameLocation: void 0, edits: ne };
                    }
                    return { edits: [] };
                  }
                }
                function G(U, j, H, I, l, d) {
                  var D = d.signature, fe = e.map(L(l, j, H), function(ge) {
                    return e.getSynthesizedDeepClone(ge);
                  });
                  if (D) {
                    var g = e.map(L(D, j, H), function(ge) {
                      return e.getSynthesizedDeepClone(ge);
                    });
                    Be(D, g);
                  }
                  Be(l, fe);
                  for (var ne = e.sortAndDeduplicate(d.functionCalls, function(ge, Re) {
                    return e.compareValues(ge.pos, Re.pos);
                  }), ue = 0, We = ne; ue < We.length; ue++) {
                    var Fe = We[ue];
                    if (Fe.arguments && Fe.arguments.length) {
                      var Z = e.getSynthesizedDeepClone(V(l, Fe.arguments), true);
                      I.replaceNodeRange(e.getSourceFileOfNode(Fe), e.first(Fe.arguments), e.last(Fe.arguments), Z, { leadingTriviaOption: e.textChanges.LeadingTriviaOption.IncludeAll, trailingTriviaOption: e.textChanges.TrailingTriviaOption.Include });
                    }
                  }
                  function Be(ge, Re) {
                    I.replaceNodeRangeWithNodes(U, e.first(ge.parameters), e.last(ge.parameters), Re, { joiner: ", ", indentation: 0, leadingTriviaOption: e.textChanges.LeadingTriviaOption.IncludeAll, trailingTriviaOption: e.textChanges.TrailingTriviaOption.Include });
                  }
                }
                function oe(U, j, H) {
                  var I = Y(U), l = e.isConstructorDeclaration(U) ? k(U) : [], d = e.deduplicate(Ve(Ve([], I, true), l, true), e.equateValues), D = j.getTypeChecker(), fe = e.flatMap(d, function(We) {
                    return e.FindAllReferences.getReferenceEntriesForNode(-1, We, j, j.getSourceFiles(), H);
                  }), g = ne(fe);
                  return e.every(g.declarations, function(We) {
                    return e.contains(d, We);
                  }) || (g.valid = false), g;
                  function ne(We) {
                    for (var Fe = { accessExpressions: [], typeUsages: [] }, Z = { functionCalls: [], declarations: [], classReferences: Fe, valid: true }, Be = e.map(I, ue), ge = e.map(l, ue), Re = e.isConstructorDeclaration(U), ze = e.map(I, function(er) {
                      return f(er, D);
                    }), Ee = 0, He = We; Ee < He.length; Ee++) {
                      var rr = He[Ee];
                      if (rr.kind === 0) {
                        Z.valid = false;
                        continue;
                      }
                      if (e.contains(ze, ue(rr.node))) {
                        if (q(rr.node.parent)) {
                          Z.signature = rr.node.parent;
                          continue;
                        }
                        var Ie = b(rr);
                        if (Ie) {
                          Z.functionCalls.push(Ie);
                          continue;
                        }
                      }
                      var _e = f(rr.node, D);
                      if (_e && e.contains(ze, _e)) {
                        var we = K(rr);
                        if (we) {
                          Z.declarations.push(we);
                          continue;
                        }
                      }
                      if (e.contains(Be, ue(rr.node)) || e.isNewExpressionTarget(rr.node)) {
                        var de = T(rr);
                        if (de) continue;
                        var we = K(rr);
                        if (we) {
                          Z.declarations.push(we);
                          continue;
                        }
                        var Ie = b(rr);
                        if (Ie) {
                          Z.functionCalls.push(Ie);
                          continue;
                        }
                      }
                      if (Re && e.contains(ge, ue(rr.node))) {
                        var de = T(rr);
                        if (de) continue;
                        var we = K(rr);
                        if (we) {
                          Z.declarations.push(we);
                          continue;
                        }
                        var ye = se(rr);
                        if (ye) {
                          Fe.accessExpressions.push(ye);
                          continue;
                        }
                        if (e.isClassDeclaration(U.parent)) {
                          var Ae = J(rr);
                          if (Ae) {
                            Fe.typeUsages.push(Ae);
                            continue;
                          }
                        }
                      }
                      Z.valid = false;
                    }
                    return Z;
                  }
                  function ue(We) {
                    var Fe = D.getSymbolAtLocation(We);
                    return Fe && e.getSymbolTarget(Fe, D);
                  }
                }
                function f(U, j) {
                  var H = e.getContainingObjectLiteralElement(U);
                  if (H) {
                    var I = j.getContextualTypeForObjectLiteralElement(H), l = I == null ? void 0 : I.getSymbol();
                    if (l && !(e.getCheckFlags(l) & 6)) return l;
                  }
                }
                function T(U) {
                  var j = U.node;
                  if (e.isImportSpecifier(j.parent) || e.isImportClause(j.parent) || e.isImportEqualsDeclaration(j.parent) || e.isNamespaceImport(j.parent) || e.isExportSpecifier(j.parent) || e.isExportAssignment(j.parent)) return j;
                }
                function K(U) {
                  if (e.isDeclaration(U.node.parent)) return U.node;
                }
                function b(U) {
                  if (U.node.parent) {
                    var j = U.node, H = j.parent;
                    switch (H.kind) {
                      case 208:
                      case 209:
                        var I = e.tryCast(H, e.isCallOrNewExpression);
                        if (I && I.expression === j) return I;
                        break;
                      case 206:
                        var l = e.tryCast(H, e.isPropertyAccessExpression);
                        if (l && l.parent && l.name === j) {
                          var d = e.tryCast(l.parent, e.isCallOrNewExpression);
                          if (d && d.expression === l) return d;
                        }
                        break;
                      case 207:
                        var D = e.tryCast(H, e.isElementAccessExpression);
                        if (D && D.parent && D.argumentExpression === j) {
                          var fe = e.tryCast(D.parent, e.isCallOrNewExpression);
                          if (fe && fe.expression === D) return fe;
                        }
                        break;
                    }
                  }
                }
                function se(U) {
                  if (U.node.parent) {
                    var j = U.node, H = j.parent;
                    switch (H.kind) {
                      case 206:
                        var I = e.tryCast(H, e.isPropertyAccessExpression);
                        if (I && I.expression === j) return I;
                        break;
                      case 207:
                        var l = e.tryCast(H, e.isElementAccessExpression);
                        if (l && l.expression === j) return l;
                        break;
                    }
                  }
                }
                function J(U) {
                  var j = U.node;
                  if (e.getMeaningFromLocation(j) === 2 || e.isExpressionWithTypeArgumentsInClassExtendsClause(j.parent)) return j;
                }
                function ie(U, j, H) {
                  var I = e.getTouchingToken(U, j), l = e.getContainingFunctionDeclaration(I);
                  if (!R(I) && l && O(l, H) && e.rangeContainsRange(l, I) && !(l.body && e.rangeContainsRange(l.body, I))) return l;
                }
                function R(U) {
                  var j = e.findAncestor(U, e.isJSDocNode);
                  if (j) {
                    var H = e.findAncestor(j, function(I) {
                      return !e.isJSDocNode(I);
                    });
                    return !!H && e.isFunctionLikeDeclaration(H);
                  }
                  return false;
                }
                function q(U) {
                  return e.isMethodSignature(U) && (e.isInterfaceDeclaration(U.parent) || e.isTypeLiteralNode(U.parent));
                }
                function O(U, j) {
                  var H;
                  if (!he(U.parameters, j)) return false;
                  switch (U.kind) {
                    case 256:
                      return ee(U) && ve(U, j);
                    case 169:
                      if (e.isObjectLiteralExpression(U.parent)) {
                        var I = f(U.name, j);
                        return ((H = I == null ? void 0 : I.declarations) === null || H === void 0 ? void 0 : H.length) === 1 && ve(U, j);
                      }
                      return ve(U, j);
                    case 171:
                      return e.isClassDeclaration(U.parent) ? ee(U.parent) && ve(U, j) : x(U.parent.parent) && ve(U, j);
                    case 213:
                    case 214:
                      return x(U.parent);
                  }
                  return false;
                }
                function ve(U, j) {
                  return !!U.body && !j.isImplementationOfOverload(U);
                }
                function ee(U) {
                  if (!U.name) {
                    var j = e.findModifier(U, 88);
                    return !!j;
                  }
                  return true;
                }
                function he(U, j) {
                  return $(U) >= Q && e.every(U, function(H) {
                    return F(H, j);
                  });
                }
                function F(U, j) {
                  if (e.isRestParameter(U)) {
                    var H = j.getTypeAtLocation(U);
                    if (!j.isArrayType(H) && !j.isTupleType(H)) return false;
                  }
                  return !U.modifiers && !U.decorators && e.isIdentifier(U.name);
                }
                function x(U) {
                  return e.isVariableDeclaration(U) && e.isVarConst(U) && e.isIdentifier(U.name) && !U.type;
                }
                function X(U) {
                  return U.length > 0 && e.isThis(U[0].name);
                }
                function $(U) {
                  return X(U) ? U.length - 1 : U.length;
                }
                function A(U) {
                  return X(U) && (U = e.factory.createNodeArray(U.slice(1), U.hasTrailingComma)), U;
                }
                function y(U, j) {
                  return e.isIdentifier(j) && e.getTextOfIdentifierOrLiteral(j) === U ? e.factory.createShorthandPropertyAssignment(U) : e.factory.createPropertyAssignment(U, j);
                }
                function V(U, j) {
                  var H = A(U.parameters), I = e.isRestParameter(e.last(H)), l = I ? j.slice(0, H.length - 1) : j, d = e.map(l, function(ne, ue) {
                    var We = P(H[ue]), Fe = y(We, ne);
                    return e.suppressLeadingAndTrailingTrivia(Fe.name), e.isPropertyAssignment(Fe) && e.suppressLeadingAndTrailingTrivia(Fe.initializer), e.copyComments(ne, Fe), Fe;
                  });
                  if (I && j.length >= H.length) {
                    var D = j.slice(H.length - 1), fe = e.factory.createPropertyAssignment(P(e.last(H)), e.factory.createArrayLiteralExpression(D));
                    d.push(fe);
                  }
                  var g = e.factory.createObjectLiteralExpression(d, false);
                  return g;
                }
                function L(U, j, H) {
                  var I = j.getTypeChecker(), l = A(U.parameters), d = e.map(l, Fe), D = e.factory.createObjectBindingPattern(d), fe = Z(l), g;
                  e.every(l, Re) && (g = e.factory.createObjectLiteralExpression());
                  var ne = e.factory.createParameterDeclaration(void 0, void 0, void 0, D, void 0, fe, g);
                  if (X(U.parameters)) {
                    var ue = U.parameters[0], We = e.factory.createParameterDeclaration(void 0, void 0, void 0, ue.name, void 0, ue.type);
                    return e.suppressLeadingAndTrailingTrivia(We.name), e.copyComments(ue.name, We.name), ue.type && (e.suppressLeadingAndTrailingTrivia(We.type), e.copyComments(ue.type, We.type)), e.factory.createNodeArray([We, ne]);
                  }
                  return e.factory.createNodeArray([ne]);
                  function Fe(ze) {
                    var Ee = e.factory.createBindingElement(void 0, void 0, P(ze), e.isRestParameter(ze) && Re(ze) ? e.factory.createArrayLiteralExpression() : ze.initializer);
                    return e.suppressLeadingAndTrailingTrivia(Ee), ze.initializer && Ee.initializer && e.copyComments(ze.initializer, Ee.initializer), Ee;
                  }
                  function Z(ze) {
                    var Ee = e.map(ze, Be), He = e.addEmitFlags(e.factory.createTypeLiteralNode(Ee), 1);
                    return He;
                  }
                  function Be(ze) {
                    var Ee = ze.type;
                    !Ee && (ze.initializer || e.isRestParameter(ze)) && (Ee = ge(ze));
                    var He = e.factory.createPropertySignature(void 0, P(ze), Re(ze) ? e.factory.createToken(57) : ze.questionToken, Ee);
                    return e.suppressLeadingAndTrailingTrivia(He), e.copyComments(ze.name, He.name), ze.type && He.type && e.copyComments(ze.type, He.type), He;
                  }
                  function ge(ze) {
                    var Ee = I.getTypeAtLocation(ze);
                    return e.getTypeNodeIfAccessible(Ee, ze, j, H);
                  }
                  function Re(ze) {
                    if (e.isRestParameter(ze)) {
                      var Ee = I.getTypeAtLocation(ze);
                      return !I.isTupleType(Ee);
                    }
                    return I.isOptionalParameter(ze);
                  }
                }
                function P(U) {
                  return e.getTextOfIdentifierOrLiteral(U.name);
                }
                function k(U) {
                  switch (U.parent.kind) {
                    case 257:
                      var j = U.parent;
                      if (j.name) return [j.name];
                      var H = e.Debug.checkDefined(e.findModifier(j, 88), "Nameless class declaration should be a default export");
                      return [H];
                    case 226:
                      var I = U.parent, l = U.parent.parent, d = I.name;
                      return d ? [d, l.name] : [l.name];
                  }
                }
                function Y(U) {
                  switch (U.kind) {
                    case 256:
                      if (U.name) return [U.name];
                      var j = e.Debug.checkDefined(e.findModifier(U, 88), "Nameless function declaration should be a default export");
                      return [j];
                    case 169:
                      return [U.name];
                    case 171:
                      var H = e.Debug.checkDefined(e.findChildOfKind(U, 134, U.getSourceFile()), "Constructor declaration should have constructor keyword");
                      if (U.parent.kind === 226) {
                        var I = U.parent.parent;
                        return [I.name, H];
                      }
                      return [H];
                    case 214:
                      return [U.parent.name];
                    case 213:
                      return U.name ? [U.name, U.parent.name] : [U.parent.name];
                    default:
                      return e.Debug.assertNever(U, "Unexpected function declaration kind ".concat(U.kind));
                  }
                }
              })(w = C.convertParamsToDestructuredObject || (C.convertParamsToDestructuredObject = {}));
            })(a = e.refactor || (e.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Convert to template string", Q = e.getLocaleSpecificMessage(e.Diagnostics.Convert_to_template_string), le = { name: E, description: Q, kind: "refactor.rewrite.string" };
                C.registerRefactor(E, { kinds: [le.kind], getEditsForAction: m, getAvailableActions: N });
                function N(ve) {
                  var ee = ve.file, he = ve.startPosition, F = p(ee, he), x = f(F), X = { name: E, description: Q, actions: [] };
                  return e.isBinaryExpression(x) && T(x).isValidConcatenation ? (X.actions.push(le), [X]) : ve.preferences.provideRefactorNotApplicableReason ? (X.actions.push(Ke(Ke({}, le), { notApplicableReason: e.getLocaleSpecificMessage(e.Diagnostics.Can_only_convert_string_concatenation) })), [X]) : e.emptyArray;
                }
                function p(ve, ee) {
                  var he = e.getTokenAtPosition(ve, ee), F = f(he), x = !T(F).isValidConcatenation;
                  return x && e.isParenthesizedExpression(F.parent) && e.isBinaryExpression(F.parent.parent) ? F.parent.parent : he;
                }
                function m(ve, ee) {
                  var he = ve.file, F = ve.startPosition, x = p(he, F);
                  switch (ee) {
                    case Q:
                      return { edits: G(ve, x) };
                    default:
                      return e.Debug.fail("invalid action");
                  }
                }
                function G(ve, ee) {
                  var he = f(ee), F = ve.file, x = R(T(he), F), X = e.getTrailingCommentRanges(F.text, he.end);
                  if (X) {
                    var $ = X[X.length - 1], A = { pos: X[0].pos, end: $.end };
                    return e.textChanges.ChangeTracker.with(ve, function(y) {
                      y.deleteRange(F, A), y.replaceNode(F, he, x);
                    });
                  } else return e.textChanges.ChangeTracker.with(ve, function(y) {
                    return y.replaceNode(F, he, x);
                  });
                }
                function oe(ve) {
                  return ve.operatorToken.kind !== 63;
                }
                function f(ve) {
                  var ee = e.findAncestor(ve.parent, function(he) {
                    switch (he.kind) {
                      case 206:
                      case 207:
                        return false;
                      case 223:
                      case 221:
                        return !(e.isBinaryExpression(he.parent) && oe(he.parent));
                      default:
                        return "quit";
                    }
                  });
                  return ee || ve;
                }
                function T(ve) {
                  var ee = function(A) {
                    if (!e.isBinaryExpression(A)) return { nodes: [A], operators: [], validOperators: true, hasString: e.isStringLiteral(A) || e.isNoSubstitutionTemplateLiteral(A) };
                    var y = ee(A.left), V = y.nodes, L = y.operators, P = y.hasString, k = y.validOperators;
                    if (!(P || e.isStringLiteral(A.right) || e.isTemplateExpression(A.right))) return { nodes: [A], operators: [], hasString: false, validOperators: true };
                    var Y = A.operatorToken.kind === 39, U = k && Y;
                    return V.push(A.right), L.push(A.operatorToken), { nodes: V, operators: L, hasString: true, validOperators: U };
                  }, he = ee(ve), F = he.nodes, x = he.operators, X = he.validOperators, $ = he.hasString;
                  return { nodes: F, operators: x, isValidConcatenation: X && $ };
                }
                var K = function(ve, ee) {
                  return function(he, F) {
                    he < ve.length && e.copyTrailingComments(ve[he], F, ee, 3, false);
                  };
                }, b = function(ve, ee, he) {
                  return function(F, x) {
                    for (; F.length > 0; ) {
                      var X = F.shift();
                      e.copyTrailingComments(ve[X], x, ee, 3, false), he(X, x);
                    }
                  };
                };
                function se(ve) {
                  return ve.replace(/\\.|[$`]/g, function(ee) {
                    return ee[0] === "\\" ? ee : "\\" + ee;
                  });
                }
                function J(ve) {
                  var ee = e.isTemplateHead(ve) || e.isTemplateMiddle(ve) ? -2 : -1;
                  return e.getTextOfNode(ve).slice(1, ee);
                }
                function ie(ve, ee) {
                  for (var he = [], F = "", x = ""; ve < ee.length; ) {
                    var X = ee[ve];
                    if (e.isStringLiteralLike(X)) F += X.text, x += se(e.getTextOfNode(X).slice(1, -1)), he.push(ve), ve++;
                    else if (e.isTemplateExpression(X)) {
                      F += X.head.text, x += J(X.head);
                      break;
                    } else break;
                  }
                  return [ve, F, x, he];
                }
                function R(ve, ee) {
                  var he = ve.nodes, F = ve.operators, x = K(F, ee), X = b(he, ee, x), $ = ie(0, he), A = $[0], y = $[1], V = $[2], L = $[3];
                  if (A === he.length) {
                    var P = e.factory.createNoSubstitutionTemplateLiteral(y, V);
                    return X(L, P), P;
                  }
                  var k = [], Y = e.factory.createTemplateHead(y, V);
                  X(L, Y);
                  for (var U = function(I) {
                    var l = O(he[I]);
                    x(I, l);
                    var d = ie(I + 1, he), D = d[0], fe = d[1], g = d[2], ne = d[3];
                    I = D - 1;
                    var ue = I === he.length - 1;
                    if (e.isTemplateExpression(l)) {
                      var We = e.map(l.templateSpans, function(Z, Be) {
                        q(Z);
                        var ge = Be === l.templateSpans.length - 1, Re = Z.literal.text + (ge ? fe : ""), ze = J(Z.literal) + (ge ? g : "");
                        return e.factory.createTemplateSpan(Z.expression, ue && ge ? e.factory.createTemplateTail(Re, ze) : e.factory.createTemplateMiddle(Re, ze));
                      });
                      k.push.apply(k, We);
                    } else {
                      var Fe = ue ? e.factory.createTemplateTail(fe, g) : e.factory.createTemplateMiddle(fe, g);
                      X(ne, Fe), k.push(e.factory.createTemplateSpan(l, Fe));
                    }
                    j = I;
                  }, j, H = A; H < he.length; H++) U(H), H = j;
                  return e.factory.createTemplateExpression(Y, k);
                }
                function q(ve) {
                  var ee = ve.getSourceFile();
                  e.copyTrailingComments(ve, ve.expression, ee, 3, false), e.copyTrailingAsLeadingComments(ve.expression, ve.expression, ee, 3, false);
                }
                function O(ve) {
                  return e.isParenthesizedExpression(ve) && (q(ve), ve = ve.expression), ve;
                }
              })(w = C.convertStringOrTemplateLiteral || (C.convertStringOrTemplateLiteral = {}));
            })(a = e.refactor || (e.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Convert arrow function or function expression", Q = e.getLocaleSpecificMessage(e.Diagnostics.Convert_arrow_function_or_function_expression), le = { name: "Convert to anonymous function", description: e.getLocaleSpecificMessage(e.Diagnostics.Convert_to_anonymous_function), kind: "refactor.rewrite.function.anonymous" }, N = { name: "Convert to named function", description: e.getLocaleSpecificMessage(e.Diagnostics.Convert_to_named_function), kind: "refactor.rewrite.function.named" }, p = { name: "Convert to arrow function", description: e.getLocaleSpecificMessage(e.Diagnostics.Convert_to_arrow_function), kind: "refactor.rewrite.function.arrow" };
                C.registerRefactor(E, { kinds: [le.kind, N.kind, p.kind], getEditsForAction: G, getAvailableActions: m });
                function m(ve) {
                  var ee = ve.file, he = ve.startPosition, F = ve.program, x = ve.kind, X = f(ee, he, F);
                  if (!X) return e.emptyArray;
                  var $ = X.selectedVariableDeclaration, A = X.func, y = [], V = [];
                  if (C.refactorKindBeginsWith(N.kind, x)) {
                    var L = $ || e.isArrowFunction(A) && e.isVariableDeclaration(A.parent) ? void 0 : e.getLocaleSpecificMessage(e.Diagnostics.Could_not_convert_to_named_function);
                    L ? V.push(Ke(Ke({}, N), { notApplicableReason: L })) : y.push(N);
                  }
                  if (C.refactorKindBeginsWith(le.kind, x)) {
                    var L = !$ && e.isArrowFunction(A) ? void 0 : e.getLocaleSpecificMessage(e.Diagnostics.Could_not_convert_to_anonymous_function);
                    L ? V.push(Ke(Ke({}, le), { notApplicableReason: L })) : y.push(le);
                  }
                  if (C.refactorKindBeginsWith(p.kind, x)) {
                    var L = e.isFunctionExpression(A) ? void 0 : e.getLocaleSpecificMessage(e.Diagnostics.Could_not_convert_to_arrow_function);
                    L ? V.push(Ke(Ke({}, p), { notApplicableReason: L })) : y.push(p);
                  }
                  return [{ name: E, description: Q, actions: y.length === 0 && ve.preferences.provideRefactorNotApplicableReason ? V : y }];
                }
                function G(ve, ee) {
                  var he = ve.file, F = ve.startPosition, x = ve.program, X = f(he, F, x);
                  if (!!X) {
                    var $ = X.func, A = [];
                    switch (ee) {
                      case le.name:
                        A.push.apply(A, J(ve, $));
                        break;
                      case N.name:
                        var y = se($);
                        if (!y) return;
                        A.push.apply(A, ie(ve, $, y));
                        break;
                      case p.name:
                        if (!e.isFunctionExpression($)) return;
                        A.push.apply(A, R(ve, $));
                        break;
                      default:
                        return e.Debug.fail("invalid action");
                    }
                    return { renameFilename: void 0, renameLocation: void 0, edits: A };
                  }
                }
                function oe(ve) {
                  var ee = false;
                  return ve.forEachChild(function he(F) {
                    if (e.isThis(F)) {
                      ee = true;
                      return;
                    }
                    !e.isClassLike(F) && !e.isFunctionDeclaration(F) && !e.isFunctionExpression(F) && e.forEachChild(F, he);
                  }), ee;
                }
                function f(ve, ee, he) {
                  var F = e.getTokenAtPosition(ve, ee), x = he.getTypeChecker(), X = K(ve, x, F.parent);
                  if (X && !oe(X.body) && !x.containsArgumentsReference(X)) return { selectedVariableDeclaration: true, func: X };
                  var $ = e.getContainingFunction(F);
                  if ($ && (e.isFunctionExpression($) || e.isArrowFunction($)) && !e.rangeContainsRange($.body, F) && !oe($.body) && !x.containsArgumentsReference($)) return e.isFunctionExpression($) && O(ve, x, $) ? void 0 : { selectedVariableDeclaration: false, func: $ };
                }
                function T(ve) {
                  return e.isVariableDeclaration(ve) || e.isVariableDeclarationList(ve) && ve.declarations.length === 1;
                }
                function K(ve, ee, he) {
                  if (!!T(he)) {
                    var F = e.isVariableDeclaration(he) ? he : e.first(he.declarations), x = F.initializer;
                    if (x && (e.isArrowFunction(x) || e.isFunctionExpression(x) && !O(ve, ee, x))) return x;
                  }
                }
                function b(ve) {
                  if (e.isExpression(ve)) {
                    var ee = e.factory.createReturnStatement(ve), he = ve.getSourceFile();
                    return e.suppressLeadingAndTrailingTrivia(ee), e.copyTrailingAsLeadingComments(ve, ee, he, void 0, true), e.factory.createBlock([ee], true);
                  } else return ve;
                }
                function se(ve) {
                  var ee = ve.parent;
                  if (!(!e.isVariableDeclaration(ee) || !e.isVariableDeclarationInVariableStatement(ee))) {
                    var he = ee.parent, F = he.parent;
                    if (!(!e.isVariableDeclarationList(he) || !e.isVariableStatement(F) || !e.isIdentifier(ee.name))) return { variableDeclaration: ee, variableDeclarationList: he, statement: F, name: ee.name };
                  }
                }
                function J(ve, ee) {
                  var he = ve.file, F = b(ee.body), x = e.factory.createFunctionExpression(ee.modifiers, ee.asteriskToken, void 0, ee.typeParameters, ee.parameters, ee.type, F);
                  return e.textChanges.ChangeTracker.with(ve, function(X) {
                    return X.replaceNode(he, ee, x);
                  });
                }
                function ie(ve, ee, he) {
                  var F = ve.file, x = b(ee.body), X = he.variableDeclaration, $ = he.variableDeclarationList, A = he.statement, y = he.name;
                  e.suppressLeadingTrivia(A);
                  var V = e.getCombinedModifierFlags(X) & 1 | e.getEffectiveModifierFlags(ee), L = e.factory.createModifiersFromModifierFlags(V), P = e.factory.createFunctionDeclaration(ee.decorators, e.length(L) ? L : void 0, ee.asteriskToken, y, ee.typeParameters, ee.parameters, ee.type, x);
                  return $.declarations.length === 1 ? e.textChanges.ChangeTracker.with(ve, function(k) {
                    return k.replaceNode(F, A, P);
                  }) : e.textChanges.ChangeTracker.with(ve, function(k) {
                    k.delete(F, X), k.insertNodeAfter(F, A, P);
                  });
                }
                function R(ve, ee) {
                  var he = ve.file, F = ee.body.statements, x = F[0], X;
                  q(ee.body, x) ? (X = x.expression, e.suppressLeadingAndTrailingTrivia(X), e.copyComments(x, X)) : X = ee.body;
                  var $ = e.factory.createArrowFunction(ee.modifiers, ee.typeParameters, ee.parameters, ee.type, e.factory.createToken(38), X);
                  return e.textChanges.ChangeTracker.with(ve, function(A) {
                    return A.replaceNode(he, ee, $);
                  });
                }
                function q(ve, ee) {
                  return ve.statements.length === 1 && e.isReturnStatement(ee) && !!ee.expression;
                }
                function O(ve, ee, he) {
                  return !!he.name && e.FindAllReferences.Core.isSymbolReferencedInFile(he.name, ee, ve);
                }
              })(w = C.convertArrowFunctionOrFunctionExpression || (C.convertArrowFunctionOrFunctionExpression = {}));
            })(a = e.refactor || (e.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Infer function return type", Q = e.Diagnostics.Infer_function_return_type.message, le = { name: E, description: Q, kind: "refactor.rewrite.function.returnType" };
                C.registerRefactor(E, { kinds: [le.kind], getEditsForAction: N, getAvailableActions: p });
                function N(T) {
                  var K = G(T);
                  if (K && !C.isRefactorErrorInfo(K)) {
                    var b = e.textChanges.ChangeTracker.with(T, function(se) {
                      return m(T.file, se, K.declaration, K.returnTypeNode);
                    });
                    return { renameFilename: void 0, renameLocation: void 0, edits: b };
                  }
                }
                function p(T) {
                  var K = G(T);
                  return K ? C.isRefactorErrorInfo(K) ? T.preferences.provideRefactorNotApplicableReason ? [{ name: E, description: Q, actions: [Ke(Ke({}, le), { notApplicableReason: K.error })] }] : e.emptyArray : [{ name: E, description: Q, actions: [le] }] : e.emptyArray;
                }
                function m(T, K, b, se) {
                  var J = e.findChildOfKind(b, 21, T), ie = e.isArrowFunction(b) && J === void 0, R = ie ? e.first(b.parameters) : J;
                  R && (ie && (K.insertNodeBefore(T, R, e.factory.createToken(20)), K.insertNodeAfter(T, R, e.factory.createToken(21))), K.insertNodeAt(T, R.end, se, { prefix: ": " }));
                }
                function G(T) {
                  if (!(e.isInJSFile(T.file) || !C.refactorKindBeginsWith(le.kind, T.kind))) {
                    var K = e.getTokenAtPosition(T.file, T.startPosition), b = e.findAncestor(K, function(R) {
                      return e.isBlock(R) || R.parent && e.isArrowFunction(R.parent) && (R.kind === 38 || R.parent.body === R) ? "quit" : oe(R);
                    });
                    if (!b || !b.body || b.type) return { error: e.getLocaleSpecificMessage(e.Diagnostics.Return_type_must_be_inferred_from_a_function) };
                    var se = T.program.getTypeChecker(), J = f(se, b);
                    if (!J) return { error: e.getLocaleSpecificMessage(e.Diagnostics.Could_not_determine_function_return_type) };
                    var ie = se.typeToTypeNode(J, b, 1);
                    if (ie) return { declaration: b, returnTypeNode: ie };
                  }
                }
                function oe(T) {
                  switch (T.kind) {
                    case 256:
                    case 213:
                    case 214:
                    case 169:
                      return true;
                    default:
                      return false;
                  }
                }
                function f(T, K) {
                  if (T.isImplementationOfOverload(K)) {
                    var b = T.getTypeAtLocation(K).getCallSignatures();
                    if (b.length > 1) return T.getUnionType(e.mapDefined(b, function(J) {
                      return J.getReturnType();
                    }));
                  }
                  var se = T.getSignatureFromDeclaration(K);
                  if (se) return T.getReturnTypeOfSignature(se);
                }
              })(w = C.inferFunctionReturnType || (C.inferFunctionReturnType = {}));
            })(a = e.refactor || (e.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            e.servicesVersion = "0.8";
            function a(g, ne, ue, We) {
              var Fe = e.isNodeKind(g) ? new C(g, ne, ue) : g === 79 ? new p(79, ne, ue) : g === 80 ? new m(80, ne, ue) : new N(g, ne, ue);
              return Fe.parent = We, Fe.flags = We.flags & 50720768, Fe;
            }
            var C = function() {
              function g(ne, ue, We) {
                this.pos = ue, this.end = We, this.flags = 0, this.modifierFlagsCache = 0, this.transformFlags = 0, this.parent = void 0, this.kind = ne;
              }
              return g.prototype.assertHasRealPosition = function(ne) {
                e.Debug.assert(!e.positionIsSynthesized(this.pos) && !e.positionIsSynthesized(this.end), ne || "Node must have a real position for this operation");
              }, g.prototype.getSourceFile = function() {
                return e.getSourceFileOfNode(this);
              }, g.prototype.getStart = function(ne, ue) {
                return this.assertHasRealPosition(), e.getTokenPosOfNode(this, ne, ue);
              }, g.prototype.getFullStart = function() {
                return this.assertHasRealPosition(), this.pos;
              }, g.prototype.getEnd = function() {
                return this.assertHasRealPosition(), this.end;
              }, g.prototype.getWidth = function(ne) {
                return this.assertHasRealPosition(), this.getEnd() - this.getStart(ne);
              }, g.prototype.getFullWidth = function() {
                return this.assertHasRealPosition(), this.end - this.pos;
              }, g.prototype.getLeadingTriviaWidth = function(ne) {
                return this.assertHasRealPosition(), this.getStart(ne) - this.pos;
              }, g.prototype.getFullText = function(ne) {
                return this.assertHasRealPosition(), (ne || this.getSourceFile()).text.substring(this.pos, this.end);
              }, g.prototype.getText = function(ne) {
                return this.assertHasRealPosition(), ne || (ne = this.getSourceFile()), ne.text.substring(this.getStart(ne), this.getEnd());
              }, g.prototype.getChildCount = function(ne) {
                return this.getChildren(ne).length;
              }, g.prototype.getChildAt = function(ne, ue) {
                return this.getChildren(ue)[ne];
              }, g.prototype.getChildren = function(ne) {
                return this.assertHasRealPosition("Node without a real position cannot be scanned and thus has no token nodes - use forEachChild and collect the result if that's fine"), this._children || (this._children = w(this, ne));
              }, g.prototype.getFirstToken = function(ne) {
                this.assertHasRealPosition();
                var ue = this.getChildren(ne);
                if (!!ue.length) {
                  var We = e.find(ue, function(Fe) {
                    return Fe.kind < 309 || Fe.kind > 347;
                  });
                  return We.kind < 161 ? We : We.getFirstToken(ne);
                }
              }, g.prototype.getLastToken = function(ne) {
                this.assertHasRealPosition();
                var ue = this.getChildren(ne), We = e.lastOrUndefined(ue);
                if (!!We) return We.kind < 161 ? We : We.getLastToken(ne);
              }, g.prototype.forEachChild = function(ne, ue) {
                return e.forEachChild(this, ne, ue);
              }, g;
            }();
            function w(g, ne) {
              if (!e.isNodeKind(g.kind)) return e.emptyArray;
              var ue = [];
              if (e.isJSDocCommentContainingNode(g)) return g.forEachChild(function(Be) {
                ue.push(Be);
              }), ue;
              e.scanner.setText((ne || g.getSourceFile()).text);
              var We = g.pos, Fe = function(Be) {
                B(ue, We, Be.pos, g), ue.push(Be), We = Be.end;
              }, Z = function(Be) {
                B(ue, We, Be.pos, g), ue.push(E(Be, g)), We = Be.end;
              };
              return e.forEach(g.jsDoc, Fe), We = g.pos, g.forEachChild(Fe, Z), B(ue, We, g.end, g), e.scanner.setText(void 0), ue;
            }
            function B(g, ne, ue, We) {
              for (e.scanner.setTextPos(ne); ne < ue; ) {
                var Fe = e.scanner.scan(), Z = e.scanner.getTextPos();
                if (Z <= ue && (Fe === 79 && e.Debug.fail("Did not expect ".concat(e.Debug.formatSyntaxKind(We.kind), " to have an Identifier in its trivia")), g.push(a(Fe, ne, Z, We))), ne = Z, Fe === 1) break;
              }
            }
            function E(g, ne) {
              var ue = a(348, g.pos, g.end, ne);
              ue._children = [];
              for (var We = g.pos, Fe = 0, Z = g; Fe < Z.length; Fe++) {
                var Be = Z[Fe];
                B(ue._children, We, Be.pos, ne), ue._children.push(Be), We = Be.end;
              }
              return B(ue._children, We, g.end, ne), ue;
            }
            var Q = function() {
              function g(ne, ue) {
                this.pos = ne, this.end = ue, this.flags = 0, this.modifierFlagsCache = 0, this.transformFlags = 0, this.parent = void 0;
              }
              return g.prototype.getSourceFile = function() {
                return e.getSourceFileOfNode(this);
              }, g.prototype.getStart = function(ne, ue) {
                return e.getTokenPosOfNode(this, ne, ue);
              }, g.prototype.getFullStart = function() {
                return this.pos;
              }, g.prototype.getEnd = function() {
                return this.end;
              }, g.prototype.getWidth = function(ne) {
                return this.getEnd() - this.getStart(ne);
              }, g.prototype.getFullWidth = function() {
                return this.end - this.pos;
              }, g.prototype.getLeadingTriviaWidth = function(ne) {
                return this.getStart(ne) - this.pos;
              }, g.prototype.getFullText = function(ne) {
                return (ne || this.getSourceFile()).text.substring(this.pos, this.end);
              }, g.prototype.getText = function(ne) {
                return ne || (ne = this.getSourceFile()), ne.text.substring(this.getStart(ne), this.getEnd());
              }, g.prototype.getChildCount = function() {
                return this.getChildren().length;
              }, g.prototype.getChildAt = function(ne) {
                return this.getChildren()[ne];
              }, g.prototype.getChildren = function() {
                return this.kind === 1 && this.jsDoc || e.emptyArray;
              }, g.prototype.getFirstToken = function() {
              }, g.prototype.getLastToken = function() {
              }, g.prototype.forEachChild = function() {
              }, g;
            }(), le = function() {
              function g(ne, ue) {
                this.flags = ne, this.escapedName = ue;
              }
              return g.prototype.getFlags = function() {
                return this.flags;
              }, Object.defineProperty(g.prototype, "name", { get: function() {
                return e.symbolName(this);
              }, enumerable: false, configurable: true }), g.prototype.getEscapedName = function() {
                return this.escapedName;
              }, g.prototype.getName = function() {
                return this.name;
              }, g.prototype.getDeclarations = function() {
                return this.declarations;
              }, g.prototype.getDocumentationComment = function(ne) {
                if (!this.documentationComment) if (this.documentationComment = e.emptyArray, !this.declarations && this.target && this.target.tupleLabelDeclaration) {
                  var ue = this.target.tupleLabelDeclaration;
                  this.documentationComment = K([ue], ne);
                } else this.documentationComment = K(this.declarations, ne);
                return this.documentationComment;
              }, g.prototype.getContextualDocumentationComment = function(ne, ue) {
                switch (ne == null ? void 0 : ne.kind) {
                  case 172:
                    return this.contextualGetAccessorDocumentationComment || (this.contextualGetAccessorDocumentationComment = K(e.filter(this.declarations, e.isGetAccessor), ue)), this.contextualGetAccessorDocumentationComment;
                  case 173:
                    return this.contextualSetAccessorDocumentationComment || (this.contextualSetAccessorDocumentationComment = K(e.filter(this.declarations, e.isSetAccessor), ue)), this.contextualSetAccessorDocumentationComment;
                  default:
                    return this.getDocumentationComment(ue);
                }
              }, g.prototype.getJsDocTags = function(ne) {
                return this.tags === void 0 && (this.tags = T(this.declarations, ne)), this.tags;
              }, g.prototype.getContextualJsDocTags = function(ne, ue) {
                switch (ne == null ? void 0 : ne.kind) {
                  case 172:
                    return this.contextualGetAccessorTags || (this.contextualGetAccessorTags = T(e.filter(this.declarations, e.isGetAccessor), ue)), this.contextualGetAccessorTags;
                  case 173:
                    return this.contextualSetAccessorTags || (this.contextualSetAccessorTags = T(e.filter(this.declarations, e.isSetAccessor), ue)), this.contextualSetAccessorTags;
                  default:
                    return this.getJsDocTags(ue);
                }
              }, g;
            }(), N = function(g) {
              Lr(ne, g);
              function ne(ue, We, Fe) {
                var Z = g.call(this, We, Fe) || this;
                return Z.kind = ue, Z;
              }
              return ne;
            }(Q), p = function(g) {
              Lr(ne, g);
              function ne(ue, We, Fe) {
                var Z = g.call(this, We, Fe) || this;
                return Z.kind = 79, Z;
              }
              return Object.defineProperty(ne.prototype, "text", { get: function() {
                return e.idText(this);
              }, enumerable: false, configurable: true }), ne;
            }(Q);
            p.prototype.kind = 79;
            var m = function(g) {
              Lr(ne, g);
              function ne(ue, We, Fe) {
                return g.call(this, We, Fe) || this;
              }
              return Object.defineProperty(ne.prototype, "text", { get: function() {
                return e.idText(this);
              }, enumerable: false, configurable: true }), ne;
            }(Q);
            m.prototype.kind = 80;
            var G = function() {
              function g(ne, ue) {
                this.checker = ne, this.flags = ue;
              }
              return g.prototype.getFlags = function() {
                return this.flags;
              }, g.prototype.getSymbol = function() {
                return this.symbol;
              }, g.prototype.getProperties = function() {
                return this.checker.getPropertiesOfType(this);
              }, g.prototype.getProperty = function(ne) {
                return this.checker.getPropertyOfType(this, ne);
              }, g.prototype.getApparentProperties = function() {
                return this.checker.getAugmentedPropertiesOfType(this);
              }, g.prototype.getCallSignatures = function() {
                return this.checker.getSignaturesOfType(this, 0);
              }, g.prototype.getConstructSignatures = function() {
                return this.checker.getSignaturesOfType(this, 1);
              }, g.prototype.getStringIndexType = function() {
                return this.checker.getIndexTypeOfType(this, 0);
              }, g.prototype.getNumberIndexType = function() {
                return this.checker.getIndexTypeOfType(this, 1);
              }, g.prototype.getBaseTypes = function() {
                return this.isClassOrInterface() ? this.checker.getBaseTypes(this) : void 0;
              }, g.prototype.isNullableType = function() {
                return this.checker.isNullableType(this);
              }, g.prototype.getNonNullableType = function() {
                return this.checker.getNonNullableType(this);
              }, g.prototype.getNonOptionalType = function() {
                return this.checker.getNonOptionalType(this);
              }, g.prototype.getConstraint = function() {
                return this.checker.getBaseConstraintOfType(this);
              }, g.prototype.getDefault = function() {
                return this.checker.getDefaultFromTypeParameter(this);
              }, g.prototype.isUnion = function() {
                return !!(this.flags & 1048576);
              }, g.prototype.isIntersection = function() {
                return !!(this.flags & 2097152);
              }, g.prototype.isUnionOrIntersection = function() {
                return !!(this.flags & 3145728);
              }, g.prototype.isLiteral = function() {
                return !!(this.flags & 384);
              }, g.prototype.isStringLiteral = function() {
                return !!(this.flags & 128);
              }, g.prototype.isNumberLiteral = function() {
                return !!(this.flags & 256);
              }, g.prototype.isTypeParameter = function() {
                return !!(this.flags & 262144);
              }, g.prototype.isClassOrInterface = function() {
                return !!(e.getObjectFlags(this) & 3);
              }, g.prototype.isClass = function() {
                return !!(e.getObjectFlags(this) & 1);
              }, g.prototype.isIndexType = function() {
                return !!(this.flags & 4194304);
              }, Object.defineProperty(g.prototype, "typeArguments", { get: function() {
                if (e.getObjectFlags(this) & 4) return this.checker.getTypeArguments(this);
              }, enumerable: false, configurable: true }), g;
            }(), oe = function() {
              function g(ne, ue) {
                this.checker = ne, this.flags = ue;
              }
              return g.prototype.getDeclaration = function() {
                return this.declaration;
              }, g.prototype.getTypeParameters = function() {
                return this.typeParameters;
              }, g.prototype.getParameters = function() {
                return this.parameters;
              }, g.prototype.getReturnType = function() {
                return this.checker.getReturnTypeOfSignature(this);
              }, g.prototype.getTypeParameterAtPosition = function(ne) {
                var ue = this.checker.getParameterType(this, ne);
                if (ue.isIndexType() && e.isThisTypeParameter(ue.type)) {
                  var We = ue.type.getConstraint();
                  if (We) return this.checker.getIndexType(We);
                }
                return ue;
              }, g.prototype.getDocumentationComment = function() {
                return this.documentationComment || (this.documentationComment = K(e.singleElementArray(this.declaration), this.checker));
              }, g.prototype.getJsDocTags = function() {
                return this.jsDocTags || (this.jsDocTags = T(e.singleElementArray(this.declaration), this.checker));
              }, g;
            }();
            function f(g) {
              return e.getJSDocTags(g).some(function(ne) {
                return ne.tagName.text === "inheritDoc";
              });
            }
            function T(g, ne) {
              if (!g) return e.emptyArray;
              var ue = e.JsDoc.getJsDocTagsFromDeclarations(g, ne);
              if (ne && (ue.length === 0 || g.some(f))) for (var We = new e.Set(), Fe = function(Re) {
                var ze = b(ne, Re, function(Ee) {
                  var He;
                  if (!We.has(Ee)) return We.add(Ee), Re.kind === 172 || Re.kind === 173 ? Ee.getContextualJsDocTags(Re, ne) : ((He = Ee.declarations) === null || He === void 0 ? void 0 : He.length) === 1 ? Ee.getJsDocTags() : void 0;
                });
                ze && (ue = Ve(Ve([], ze, true), ue, true));
              }, Z = 0, Be = g; Z < Be.length; Z++) {
                var ge = Be[Z];
                Fe(ge);
              }
              return ue;
            }
            function K(g, ne) {
              if (!g) return e.emptyArray;
              var ue = e.JsDoc.getJsDocCommentsFromDeclarations(g, ne);
              if (ne && (ue.length === 0 || g.some(f))) for (var We = new e.Set(), Fe = function(Re) {
                var ze = b(ne, Re, function(Ee) {
                  if (!We.has(Ee)) return We.add(Ee), Re.kind === 172 || Re.kind === 173 ? Ee.getContextualDocumentationComment(Re, ne) : Ee.getDocumentationComment(ne);
                });
                ze && (ue = ue.length === 0 ? ze.slice() : ze.concat(e.lineBreakPart(), ue));
              }, Z = 0, Be = g; Z < Be.length; Z++) {
                var ge = Be[Z];
                Fe(ge);
              }
              return ue;
            }
            function b(g, ne, ue) {
              var We;
              if (!e.hasStaticModifier(ne)) {
                var Fe = ((We = ne.parent) === null || We === void 0 ? void 0 : We.kind) === 171 ? ne.parent.parent : ne.parent;
                if (!!Fe) return e.firstDefined(e.getAllSuperTypeNodes(Fe), function(Z) {
                  var Be = g.getPropertyOfType(g.getTypeAtLocation(Z), ne.symbol.name);
                  return Be ? ue(Be) : void 0;
                });
              }
            }
            var se = function(g) {
              Lr(ne, g);
              function ne(ue, We, Fe) {
                var Z = g.call(this, ue, We, Fe) || this;
                return Z.kind = 305, Z;
              }
              return ne.prototype.update = function(ue, We) {
                return e.updateSourceFile(this, ue, We);
              }, ne.prototype.getLineAndCharacterOfPosition = function(ue) {
                return e.getLineAndCharacterOfPosition(this, ue);
              }, ne.prototype.getLineStarts = function() {
                return e.getLineStarts(this);
              }, ne.prototype.getPositionOfLineAndCharacter = function(ue, We, Fe) {
                return e.computePositionOfLineAndCharacter(e.getLineStarts(this), ue, We, this.text, Fe);
              }, ne.prototype.getLineEndOfPosition = function(ue) {
                var We = this.getLineAndCharacterOfPosition(ue).line, Fe = this.getLineStarts(), Z;
                We + 1 >= Fe.length && (Z = this.getEnd()), Z || (Z = Fe[We + 1] - 1);
                var Be = this.getFullText();
                return Be[Z] === `
` && Be[Z - 1] === "\r" ? Z - 1 : Z;
              }, ne.prototype.getNamedDeclarations = function() {
                return this.namedDeclarations || (this.namedDeclarations = this.computeNamedDeclarations()), this.namedDeclarations;
              }, ne.prototype.computeNamedDeclarations = function() {
                var ue = e.createMultiMap();
                return this.forEachChild(Be), ue;
                function We(ge) {
                  var Re = Z(ge);
                  Re && ue.add(Re, ge);
                }
                function Fe(ge) {
                  var Re = ue.get(ge);
                  return Re || ue.set(ge, Re = []), Re;
                }
                function Z(ge) {
                  var Re = e.getNonAssignedNameOfDeclaration(ge);
                  return Re && (e.isComputedPropertyName(Re) && e.isPropertyAccessExpression(Re.expression) ? Re.expression.name.text : e.isPropertyName(Re) ? e.getNameFromPropertyName(Re) : void 0);
                }
                function Be(ge) {
                  switch (ge.kind) {
                    case 256:
                    case 213:
                    case 169:
                    case 168:
                      var Re = ge, ze = Z(Re);
                      if (ze) {
                        var Ee = Fe(ze), He = e.lastOrUndefined(Ee);
                        He && Re.parent === He.parent && Re.symbol === He.symbol ? Re.body && !He.body && (Ee[Ee.length - 1] = Re) : Ee.push(Re);
                      }
                      e.forEachChild(ge, Be);
                      break;
                    case 257:
                    case 226:
                    case 258:
                    case 259:
                    case 260:
                    case 261:
                    case 265:
                    case 275:
                    case 270:
                    case 267:
                    case 268:
                    case 172:
                    case 173:
                    case 182:
                      We(ge), e.forEachChild(ge, Be);
                      break;
                    case 164:
                      if (!e.hasSyntacticModifier(ge, 16476)) break;
                    case 254:
                    case 203: {
                      var rr = ge;
                      if (e.isBindingPattern(rr.name)) {
                        e.forEachChild(rr.name, Be);
                        break;
                      }
                      rr.initializer && Be(rr.initializer);
                    }
                    case 299:
                    case 167:
                    case 166:
                      We(ge);
                      break;
                    case 272:
                      var Ie = ge;
                      Ie.exportClause && (e.isNamedExports(Ie.exportClause) ? e.forEach(Ie.exportClause.elements, Be) : Be(Ie.exportClause.name));
                      break;
                    case 266:
                      var _e = ge.importClause;
                      _e && (_e.name && We(_e.name), _e.namedBindings && (_e.namedBindings.kind === 268 ? We(_e.namedBindings) : e.forEach(_e.namedBindings.elements, Be)));
                      break;
                    case 221:
                      e.getAssignmentDeclarationKind(ge) !== 0 && We(ge);
                    default:
                      e.forEachChild(ge, Be);
                  }
                }
              }, ne;
            }(C), J = function() {
              function g(ne, ue, We) {
                this.fileName = ne, this.text = ue, this.skipTrivia = We;
              }
              return g.prototype.getLineAndCharacterOfPosition = function(ne) {
                return e.getLineAndCharacterOfPosition(this, ne);
              }, g;
            }();
            function ie() {
              return { getNodeConstructor: function() {
                return C;
              }, getTokenConstructor: function() {
                return N;
              }, getIdentifierConstructor: function() {
                return p;
              }, getPrivateIdentifierConstructor: function() {
                return m;
              }, getSourceFileConstructor: function() {
                return se;
              }, getSymbolConstructor: function() {
                return le;
              }, getTypeConstructor: function() {
                return G;
              }, getSignatureConstructor: function() {
                return oe;
              }, getSourceMapSourceConstructor: function() {
                return J;
              } };
            }
            function R(g) {
              var ne = true;
              for (var ue in g) if (e.hasProperty(g, ue) && !q(ue)) {
                ne = false;
                break;
              }
              if (ne) return g;
              var We = {};
              for (var ue in g) if (e.hasProperty(g, ue)) {
                var Fe = q(ue) ? ue : ue.charAt(0).toLowerCase() + ue.substr(1);
                We[Fe] = g[ue];
              }
              return We;
            }
            e.toEditorSettings = R;
            function q(g) {
              return !g.length || g.charAt(0) === g.charAt(0).toLowerCase();
            }
            function O(g) {
              return g ? e.map(g, function(ne) {
                return ne.text;
              }).join("") : "";
            }
            e.displayPartsToString = O;
            function ve() {
              return { target: 1, jsx: 1 };
            }
            e.getDefaultCompilerOptions = ve;
            function ee() {
              return e.codefix.getSupportedErrorCodes();
            }
            e.getSupportedCodeFixes = ee;
            var he = function() {
              function g(ne, ue) {
                this.host = ne, this.currentDirectory = ne.getCurrentDirectory(), this.fileNameToEntry = new e.Map();
                var We = ne.getScriptFileNames();
                e.tracing === null || e.tracing === void 0 || e.tracing.push("session", "initializeHostCache", { count: We.length });
                for (var Fe = 0, Z = We; Fe < Z.length; Fe++) {
                  var Be = Z[Fe];
                  this.createEntry(Be, e.toPath(Be, this.currentDirectory, ue));
                }
                e.tracing === null || e.tracing === void 0 || e.tracing.pop();
              }
              return g.prototype.createEntry = function(ne, ue) {
                var We, Fe = this.host.getScriptSnapshot(ne);
                return Fe ? We = { hostFileName: ne, version: this.host.getScriptVersion(ne), scriptSnapshot: Fe, scriptKind: e.getScriptKind(ne, this.host) } : We = ne, this.fileNameToEntry.set(ue, We), We;
              }, g.prototype.getEntryByPath = function(ne) {
                return this.fileNameToEntry.get(ne);
              }, g.prototype.getHostFileInformation = function(ne) {
                var ue = this.fileNameToEntry.get(ne);
                return e.isString(ue) ? void 0 : ue;
              }, g.prototype.getOrCreateEntryByPath = function(ne, ue) {
                var We = this.getEntryByPath(ue) || this.createEntry(ne, ue);
                return e.isString(We) ? void 0 : We;
              }, g.prototype.getRootFileNames = function() {
                var ne = [];
                return this.fileNameToEntry.forEach(function(ue) {
                  e.isString(ue) ? ne.push(ue) : ne.push(ue.hostFileName);
                }), ne;
              }, g.prototype.getScriptSnapshot = function(ne) {
                var ue = this.getHostFileInformation(ne);
                return ue && ue.scriptSnapshot;
              }, g;
            }(), F = function() {
              function g(ne) {
                this.host = ne;
              }
              return g.prototype.getCurrentSourceFile = function(ne) {
                var ue, We, Fe, Z, Be, ge, Re, ze, Ee = this.host.getScriptSnapshot(ne);
                if (!Ee) throw new Error("Could not find file: '" + ne + "'.");
                var He = e.getScriptKind(ne, this.host), rr = this.host.getScriptVersion(ne), Ie;
                if (this.currentFileName !== ne) {
                  var _e = { languageVersion: 99, impliedNodeFormat: e.getImpliedNodeFormatForFile(e.toPath(ne, this.host.getCurrentDirectory(), ((Fe = (We = (ue = this.host).getCompilerHost) === null || We === void 0 ? void 0 : We.call(ue)) === null || Fe === void 0 ? void 0 : Fe.getCanonicalFileName) || e.hostGetCanonicalFileName(this.host)), (ze = (Re = (ge = (Be = (Z = this.host).getCompilerHost) === null || Be === void 0 ? void 0 : Be.call(Z)) === null || ge === void 0 ? void 0 : ge.getModuleResolutionCache) === null || Re === void 0 ? void 0 : Re.call(ge)) === null || ze === void 0 ? void 0 : ze.getPackageJsonInfoCache(), this.host, this.host.getCompilationSettings()), setExternalModuleIndicator: e.getSetExternalModuleIndicator(this.host.getCompilationSettings()) };
                  Ie = X(ne, Ee, _e, rr, true, He);
                } else if (this.currentFileVersion !== rr) {
                  var we = Ee.getChangeRange(this.currentFileScriptSnapshot);
                  Ie = $(this.currentSourceFile, Ee, rr, we);
                }
                return Ie && (this.currentFileVersion = rr, this.currentFileName = ne, this.currentFileScriptSnapshot = Ee, this.currentSourceFile = Ie), this.currentSourceFile;
              }, g;
            }();
            function x(g, ne, ue) {
              g.version = ue, g.scriptSnapshot = ne;
            }
            function X(g, ne, ue, We, Fe, Z) {
              var Be = e.createSourceFile(g, e.getSnapshotText(ne), ue, Fe, Z);
              return x(Be, ne, We), Be;
            }
            e.createLanguageServiceSourceFile = X;
            function $(g, ne, ue, We, Fe) {
              if (We && ue !== g.version) {
                var Z = void 0, Be = We.span.start !== 0 ? g.text.substr(0, We.span.start) : "", ge = e.textSpanEnd(We.span) !== g.text.length ? g.text.substr(e.textSpanEnd(We.span)) : "";
                if (We.newLength === 0) Z = Be && ge ? Be + ge : Be || ge;
                else {
                  var Re = ne.getText(We.span.start, We.span.start + We.newLength);
                  Z = Be && ge ? Be + Re + ge : Be ? Be + Re : Re + ge;
                }
                var ze = e.updateSourceFile(g, Z, We, Fe);
                return x(ze, ne, ue), ze.nameTable = void 0, g !== ze && g.scriptSnapshot && (g.scriptSnapshot.dispose && g.scriptSnapshot.dispose(), g.scriptSnapshot = void 0), ze;
              }
              var Ee = { languageVersion: g.languageVersion, impliedNodeFormat: g.impliedNodeFormat, setExternalModuleIndicator: g.setExternalModuleIndicator };
              return X(g.fileName, ne, Ee, ue, true, g.scriptKind);
            }
            e.updateLanguageServiceSourceFile = $;
            var A = { isCancellationRequested: e.returnFalse, throwIfCancellationRequested: e.noop }, y = function() {
              function g(ne) {
                this.cancellationToken = ne;
              }
              return g.prototype.isCancellationRequested = function() {
                return this.cancellationToken.isCancellationRequested();
              }, g.prototype.throwIfCancellationRequested = function() {
                if (this.isCancellationRequested()) throw e.tracing === null || e.tracing === void 0 || e.tracing.instant("session", "cancellationThrown", { kind: "CancellationTokenObject" }), new e.OperationCanceledException();
              }, g;
            }(), V = function() {
              function g(ne, ue) {
                ue === void 0 && (ue = 20), this.hostCancellationToken = ne, this.throttleWaitMilliseconds = ue, this.lastCancellationCheckTime = 0;
              }
              return g.prototype.isCancellationRequested = function() {
                var ne = e.timestamp(), ue = Math.abs(ne - this.lastCancellationCheckTime);
                return ue >= this.throttleWaitMilliseconds ? (this.lastCancellationCheckTime = ne, this.hostCancellationToken.isCancellationRequested()) : false;
              }, g.prototype.throwIfCancellationRequested = function() {
                if (this.isCancellationRequested()) throw e.tracing === null || e.tracing === void 0 || e.tracing.instant("session", "cancellationThrown", { kind: "ThrottledCancellationToken" }), new e.OperationCanceledException();
              }, g;
            }();
            e.ThrottledCancellationToken = V;
            var L = ["getSemanticDiagnostics", "getSuggestionDiagnostics", "getCompilerOptionsDiagnostics", "getSemanticClassifications", "getEncodedSemanticClassifications", "getCodeFixesAtPosition", "getCombinedCodeFix", "applyCodeActionCommand", "organizeImports", "getEditsForFileRename", "getEmitOutput", "getApplicableRefactors", "getEditsForRefactor", "prepareCallHierarchy", "provideCallHierarchyIncomingCalls", "provideCallHierarchyOutgoingCalls", "provideInlayHints"], P = Ve(Ve([], L, true), ["getCompletionsAtPosition", "getCompletionEntryDetails", "getCompletionEntrySymbol", "getSignatureHelpItems", "getQuickInfoAtPosition", "getDefinitionAtPosition", "getDefinitionAndBoundSpan", "getImplementationAtPosition", "getTypeDefinitionAtPosition", "getReferencesAtPosition", "findReferences", "getOccurrencesAtPosition", "getDocumentHighlights", "getNavigateToItems", "getRenameInfo", "findRenameLocations", "getApplicableRefactors"], false);
            function k(g, ne, ue) {
              var We, Fe;
              ne === void 0 && (ne = e.createDocumentRegistry(g.useCaseSensitiveFileNames && g.useCaseSensitiveFileNames(), g.getCurrentDirectory()));
              var Z;
              ue === void 0 ? Z = e.LanguageServiceMode.Semantic : typeof ue == "boolean" ? Z = ue ? e.LanguageServiceMode.Syntactic : e.LanguageServiceMode.Semantic : Z = ue;
              var Be = new F(g), ge, Re, ze = 0, Ee = g.getCancellationToken ? new y(g.getCancellationToken()) : A, He = g.getCurrentDirectory();
              e.maybeSetLocalizedDiagnosticMessages((Fe = g.getLocalizedDiagnosticMessages) === null || Fe === void 0 ? void 0 : Fe.bind(g));
              function rr(Ai) {
                g.log && g.log(Ai);
              }
              var Ie = e.hostUsesCaseSensitiveFileNames(g), _e = e.createGetCanonicalFileName(Ie), we = e.getSourceMapper({ useCaseSensitiveFileNames: function() {
                return Ie;
              }, getCurrentDirectory: function() {
                return He;
              }, getProgram: Ae, fileExists: e.maybeBind(g, g.fileExists), readFile: e.maybeBind(g, g.readFile), getDocumentPositionMapper: e.maybeBind(g, g.getDocumentPositionMapper), getSourceFileLike: e.maybeBind(g, g.getSourceFileLike), log: rr });
              function de(Ai) {
                var Oi = ge.getSourceFile(Ai);
                if (!Oi) {
                  var ji = new Error("Could not find source file: '".concat(Ai, "'."));
                  throw ji.ProgramFiles = ge.getSourceFiles().map(function(Vi) {
                    return Vi.fileName;
                  }), ji;
                }
                return Oi;
              }
              function ye() {
                var Ai, Oi, ji;
                if (e.Debug.assert(Z !== e.LanguageServiceMode.Syntactic), g.getProjectVersion) {
                  var Vi = g.getProjectVersion();
                  if (Vi) {
                    if (Re === Vi && !(!((Ai = g.hasChangedAutomaticTypeDirectiveNames) === null || Ai === void 0) && Ai.call(g))) return;
                    Re = Vi;
                  }
                }
                var at = g.getTypeRootsVersion ? g.getTypeRootsVersion() : 0;
                ze !== at && (rr("TypeRoots version has changed; provide new program"), ge = void 0, ze = at);
                var At = new he(g, _e), ba = At.getRootFileNames(), $a = g.getCompilationSettings() || ve(), Qa = g.hasInvalidatedResolution || e.returnFalse, ai = e.maybeBind(g, g.hasChangedAutomaticTypeDirectiveNames), Dn = (Oi = g.getProjectReferences) === null || Oi === void 0 ? void 0 : Oi.call(g), ka, Ba = { useCaseSensitiveFileNames: Ie, fileExists: Pn, readFile: eo, readDirectory: Rn, trace: e.maybeBind(g, g.trace), getCurrentDirectory: function() {
                  return He;
                }, onUnRecoverableConfigFileDiagnostic: e.noop };
                if (e.isProgramUptoDate(ge, ba, $a, function(En, Wn) {
                  return g.getScriptVersion(Wn);
                }, Pn, Qa, ai, kn, Dn)) return;
                var pn = { getSourceFile: bo, getSourceFileByPath: Ro, getCancellationToken: function() {
                  return Ee;
                }, getCanonicalFileName: _e, useCaseSensitiveFileNames: function() {
                  return Ie;
                }, getNewLine: function() {
                  return e.getNewLineCharacter($a, function() {
                    return e.getNewLineOrDefaultFromHost(g);
                  });
                }, getDefaultLibFileName: function(En) {
                  return g.getDefaultLibFileName(En);
                }, writeFile: e.noop, getCurrentDirectory: function() {
                  return He;
                }, fileExists: Pn, readFile: eo, getSymlinkCache: e.maybeBind(g, g.getSymlinkCache), realpath: e.maybeBind(g, g.realpath), directoryExists: function(En) {
                  return e.directoryProbablyExists(En, g);
                }, getDirectories: function(En) {
                  return g.getDirectories ? g.getDirectories(En) : [];
                }, readDirectory: Rn, onReleaseOldSourceFile: Da, onReleaseParsedCommandLine: Kn, hasInvalidatedResolution: Qa, hasChangedAutomaticTypeDirectiveNames: ai, trace: Ba.trace, resolveModuleNames: e.maybeBind(g, g.resolveModuleNames), getModuleResolutionCache: e.maybeBind(g, g.getModuleResolutionCache), resolveTypeReferenceDirectives: e.maybeBind(g, g.resolveTypeReferenceDirectives), useSourceOfProjectReferenceRedirect: e.maybeBind(g, g.useSourceOfProjectReferenceRedirect), getParsedCommandLine: kn };
                (ji = g.setCompilerHost) === null || ji === void 0 || ji.call(g, pn);
                var Cn = ne.getKeyForCompilationSettings($a), Bi = { rootNames: ba, options: $a, host: pn, oldProgram: ge, projectReferences: Dn };
                ge = e.createProgram(Bi), At = void 0, ka = void 0, we.clearCache(), ge.getTypeChecker();
                return;
                function kn(En) {
                  var Wn = e.toPath(En, He, _e), to = ka == null ? void 0 : ka.get(Wn);
                  if (to !== void 0) return to || void 0;
                  var Co = g.getParsedCommandLine ? g.getParsedCommandLine(En) : xn(En);
                  return (ka || (ka = new e.Map())).set(Wn, Co || false), Co;
                }
                function xn(En) {
                  var Wn = bo(En, 100);
                  if (!!Wn) return Wn.path = e.toPath(En, He, _e), Wn.resolvedPath = Wn.path, Wn.originalFileName = Wn.fileName, e.parseJsonSourceFileConfigFileContent(Wn, Ba, e.getNormalizedAbsolutePath(e.getDirectoryPath(En), He), void 0, e.getNormalizedAbsolutePath(En, He));
                }
                function Kn(En, Wn, to) {
                  var Co;
                  g.getParsedCommandLine ? (Co = g.onReleaseParsedCommandLine) === null || Co === void 0 || Co.call(g, En, Wn, to) : Wn && Da(Wn.sourceFile, to);
                }
                function Pn(En) {
                  var Wn = e.toPath(En, He, _e), to = At && At.getEntryByPath(Wn);
                  return to ? !e.isString(to) : !!g.fileExists && g.fileExists(En);
                }
                function eo(En) {
                  var Wn = e.toPath(En, He, _e), to = At && At.getEntryByPath(Wn);
                  return to ? e.isString(to) ? void 0 : e.getSnapshotText(to.scriptSnapshot) : g.readFile && g.readFile(En);
                }
                function Rn(En, Wn, to, Co, Ko) {
                  return e.Debug.checkDefined(g.readDirectory, "'LanguageServiceHost.readDirectory' must be implemented to correctly process 'projectReferences'"), g.readDirectory(En, Wn, to, Co, Ko);
                }
                function Da(En, Wn) {
                  var to = ne.getKeyForCompilationSettings(Wn);
                  ne.releaseDocumentWithKey(En.resolvedPath, to, En.scriptKind);
                }
                function bo(En, Wn, to, Co) {
                  return Ro(En, e.toPath(En, He, _e), Wn, to, Co);
                }
                function Ro(En, Wn, to, Co, Ko) {
                  e.Debug.assert(At !== void 0, "getOrCreateSourceFileByPath called after typical CompilerHost lifetime, check the callstack something with a reference to an old host.");
                  var Oo = At && At.getOrCreateEntryByPath(En, Wn);
                  if (!!Oo) {
                    if (!Ko) {
                      var no = ge && ge.getSourceFileByPath(Wn);
                      if (no) {
                        if (Oo.scriptKind === no.scriptKind) return ne.updateDocumentWithKey(En, Wn, g, Cn, Oo.scriptSnapshot, Oo.version, Oo.scriptKind);
                        ne.releaseDocumentWithKey(no.resolvedPath, ne.getKeyForCompilationSettings(ge.getCompilerOptions()), no.scriptKind);
                      }
                    }
                    return ne.acquireDocumentWithKey(En, Wn, g, Cn, Oo.scriptSnapshot, Oo.version, Oo.scriptKind);
                  }
                }
              }
              function Ae() {
                if (Z === e.LanguageServiceMode.Syntactic) {
                  e.Debug.assert(ge === void 0);
                  return;
                }
                return ye(), ge;
              }
              function er() {
                var Ai;
                return (Ai = g.getPackageJsonAutoImportProvider) === null || Ai === void 0 ? void 0 : Ai.call(g);
              }
              function ir() {
                ge = void 0;
              }
              function Cr() {
                if (ge) {
                  var Ai = ne.getKeyForCompilationSettings(ge.getCompilerOptions());
                  e.forEach(ge.getSourceFiles(), function(Oi) {
                    return ne.releaseDocumentWithKey(Oi.resolvedPath, Ai, Oi.scriptKind);
                  }), ge = void 0;
                }
                g = void 0;
              }
              function Ye(Ai) {
                return ye(), ge.getSyntacticDiagnostics(de(Ai), Ee).slice();
              }
              function Br(Ai) {
                ye();
                var Oi = de(Ai), ji = ge.getSemanticDiagnostics(Oi, Ee);
                if (!e.getEmitDeclarations(ge.getCompilerOptions())) return ji.slice();
                var Vi = ge.getDeclarationDiagnostics(Oi, Ee);
                return Ve(Ve([], ji, true), Vi, true);
              }
              function Er(Ai) {
                return ye(), e.computeSuggestionDiagnostics(de(Ai), ge, Ee);
              }
              function Ne() {
                return ye(), Ve(Ve([], ge.getOptionsDiagnostics(Ee), true), ge.getGlobalDiagnostics(Ee), true);
              }
              function n(Ai, Oi, ji, Vi) {
                ji === void 0 && (ji = e.emptyOptions);
                var at = Ke(Ke({}, e.identity(ji)), { includeCompletionsForModuleExports: ji.includeCompletionsForModuleExports || ji.includeExternalModuleExports, includeCompletionsWithInsertText: ji.includeCompletionsWithInsertText || ji.includeInsertTextCompletions });
                return ye(), e.Completions.getCompletionsAtPosition(g, ge, rr, de(Ai), Oi, at, ji.triggerCharacter, ji.triggerKind, Ee, Vi && e.formatting.getFormatContext(Vi, g));
              }
              function lr(Ai, Oi, ji, Vi, at, At, ba) {
                return At === void 0 && (At = e.emptyOptions), ye(), e.Completions.getCompletionEntryDetails(ge, rr, de(Ai), Oi, { name: ji, source: at, data: ba }, g, Vi && e.formatting.getFormatContext(Vi, g), At, Ee);
              }
              function be(Ai, Oi, ji, Vi, at) {
                return at === void 0 && (at = e.emptyOptions), ye(), e.Completions.getCompletionEntrySymbol(ge, rr, de(Ai), Oi, { name: ji, source: Vi }, g, at);
              }
              function Ge(Ai, Oi) {
                ye();
                var ji = de(Ai), Vi = e.getTouchingPropertyName(ji, Oi);
                if (Vi !== ji) {
                  var at = ge.getTypeChecker(), At = ur(Vi), ba = l(At, at);
                  if (!ba || at.isUnknownSymbol(ba)) {
                    var $a = yr(ji, At, Oi) ? at.getTypeAtLocation(At) : void 0;
                    return $a && { kind: "", kindModifiers: "", textSpan: e.createTextSpanFromNode(At, ji), displayParts: at.runWithCancellationToken(Ee, function(pn) {
                      return e.typeToDisplayParts(pn, $a, e.getContainerNode(At));
                    }), documentation: $a.symbol ? $a.symbol.getDocumentationComment(at) : void 0, tags: $a.symbol ? $a.symbol.getJsDocTags(at) : void 0 };
                  }
                  var Qa = at.runWithCancellationToken(Ee, function(pn) {
                    return e.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(pn, ba, ji, e.getContainerNode(At), At);
                  }), ai = Qa.symbolKind, Dn = Qa.displayParts, ka = Qa.documentation, Ba = Qa.tags;
                  return { kind: ai, kindModifiers: e.SymbolDisplay.getSymbolModifiers(at, ba), textSpan: e.createTextSpanFromNode(At, ji), displayParts: Dn, documentation: ka, tags: Ba };
                }
              }
              function ur(Ai) {
                return e.isNewExpression(Ai.parent) && Ai.pos === Ai.parent.pos ? Ai.parent.expression : e.isNamedTupleMember(Ai.parent) && Ai.pos === Ai.parent.pos || e.isImportMeta(Ai.parent) && Ai.parent.name === Ai ? Ai.parent : Ai;
              }
              function yr(Ai, Oi, ji) {
                switch (Oi.kind) {
                  case 79:
                    return !e.isLabelName(Oi) && !e.isTagName(Oi) && !e.isConstTypeReference(Oi.parent);
                  case 206:
                  case 161:
                    return !e.isInComment(Ai, ji);
                  case 108:
                  case 192:
                  case 106:
                  case 197:
                    return true;
                  case 231:
                    return e.isImportMeta(Oi);
                  default:
                    return false;
                }
              }
              function Ir(Ai, Oi, ji, Vi) {
                return ye(), e.GoToDefinition.getDefinitionAtPosition(ge, de(Ai), Oi, ji, Vi);
              }
              function wr(Ai, Oi) {
                return ye(), e.GoToDefinition.getDefinitionAndBoundSpan(ge, de(Ai), Oi);
              }
              function Ur(Ai, Oi) {
                return ye(), e.GoToDefinition.getTypeDefinitionAtPosition(ge.getTypeChecker(), de(Ai), Oi);
              }
              function ii(Ai, Oi) {
                return ye(), e.FindAllReferences.getImplementationsAtPosition(ge, Ee, ge.getSourceFiles(), de(Ai), Oi);
              }
              function mi(Ai, Oi) {
                return e.flatMap(pe(Ai, Oi, [Ai]), function(ji) {
                  return ji.highlightSpans.map(function(Vi) {
                    return Ke(Ke({ fileName: ji.fileName, textSpan: Vi.textSpan, isWriteAccess: Vi.kind === "writtenReference" }, Vi.isInString && { isInString: true }), Vi.contextSpan && { contextSpan: Vi.contextSpan });
                  });
                });
              }
              function pe(Ai, Oi, ji) {
                var Vi = e.normalizePath(Ai);
                e.Debug.assert(ji.some(function(ba) {
                  return e.normalizePath(ba) === Vi;
                })), ye();
                var at = e.mapDefined(ji, function(ba) {
                  return ge.getSourceFile(ba);
                }), At = de(Ai);
                return e.DocumentHighlights.getDocumentHighlights(ge, Ee, At, Oi, at);
              }
              function or(Ai, Oi, ji, Vi, at) {
                ye();
                var At = de(Ai), ba = e.getAdjustedRenameLocation(e.getTouchingPropertyName(At, Oi));
                if (!!e.Rename.nodeIsEligibleForRename(ba)) if (e.isIdentifier(ba) && (e.isJsxOpeningElement(ba.parent) || e.isJsxClosingElement(ba.parent)) && e.isIntrinsicJsxName(ba.escapedText)) {
                  var $a = ba.parent.parent, Qa = $a.openingElement, ai = $a.closingElement;
                  return [Qa, ai].map(function(Dn) {
                    var ka = e.createTextSpanFromNode(Dn.tagName, At);
                    return Ke({ fileName: At.fileName, textSpan: ka }, e.FindAllReferences.toContextSpan(ka, At, Dn.parent));
                  });
                } else return si(ba, Oi, { findInStrings: ji, findInComments: Vi, providePrefixAndSuffixTextForRename: at, use: 2 }, function(Dn, ka, Ba) {
                  return e.FindAllReferences.toRenameLocation(Dn, ka, Ba, at || false);
                });
              }
              function qr(Ai, Oi) {
                return ye(), si(e.getTouchingPropertyName(de(Ai), Oi), Oi, { use: 1 }, e.FindAllReferences.toReferenceEntry);
              }
              function si(Ai, Oi, ji, Vi) {
                ye();
                var at = ji && ji.use === 2 ? ge.getSourceFiles().filter(function(At) {
                  return !ge.isSourceFileDefaultLibrary(At);
                }) : ge.getSourceFiles();
                return e.FindAllReferences.findReferenceOrRenameEntries(ge, Ee, at, Ai, Oi, ji, Vi);
              }
              function Di(Ai, Oi) {
                return ye(), e.FindAllReferences.findReferencedSymbols(ge, Ee, ge.getSourceFiles(), de(Ai), Oi);
              }
              function wi(Ai) {
                return ye(), e.FindAllReferences.Core.getReferencesForFileName(Ai, ge, ge.getSourceFiles()).map(e.FindAllReferences.toReferenceEntry);
              }
              function Xi(Ai, Oi, ji, Vi) {
                Vi === void 0 && (Vi = false), ye();
                var at = ji ? [de(ji)] : ge.getSourceFiles();
                return e.NavigateTo.getNavigateToItems(at, ge.getTypeChecker(), Ee, Ai, Oi, Vi);
              }
              function et(Ai, Oi, ji) {
                ye();
                var Vi = de(Ai), at = g.getCustomTransformers && g.getCustomTransformers();
                return e.getFileEmitOutput(ge, Vi, !!Oi, Ee, at, ji);
              }
              function Gi(Ai, Oi, ji) {
                var Vi = ji === void 0 ? e.emptyOptions : ji, at = Vi.triggerReason;
                ye();
                var At = de(Ai);
                return e.SignatureHelp.getSignatureHelpItems(ge, At, Oi, at, Ee);
              }
              function Wt(Ai) {
                return Be.getCurrentSourceFile(Ai);
              }
              function Zt(Ai, Oi, ji) {
                var Vi = Be.getCurrentSourceFile(Ai), at = e.getTouchingPropertyName(Vi, Oi);
                if (at !== Vi) {
                  switch (at.kind) {
                    case 206:
                    case 161:
                    case 10:
                    case 95:
                    case 110:
                    case 104:
                    case 106:
                    case 108:
                    case 192:
                    case 79:
                      break;
                    default:
                      return;
                  }
                  for (var At = at; ; ) if (e.isRightSideOfPropertyAccess(At) || e.isRightSideOfQualifiedName(At)) At = At.parent;
                  else if (e.isNameOfModuleDeclaration(At)) if (At.parent.parent.kind === 261 && At.parent.parent.body === At.parent) At = At.parent.parent.name;
                  else break;
                  else break;
                  return e.createTextSpanFromBounds(At.getStart(), at.getEnd());
                }
              }
              function _r(Ai, Oi) {
                var ji = Be.getCurrentSourceFile(Ai);
                return e.BreakpointResolver.spanInSourceFileAtLocation(ji, Oi);
              }
              function pi(Ai) {
                return e.NavigationBar.getNavigationBarItems(Be.getCurrentSourceFile(Ai), Ee);
              }
              function ae(Ai) {
                return e.NavigationBar.getNavigationTree(Be.getCurrentSourceFile(Ai), Ee);
              }
              function Xe(Ai, Oi, ji) {
                ye();
                var Vi = ji || "original";
                return Vi === "2020" ? e.classifier.v2020.getSemanticClassifications(ge, Ee, de(Ai), Oi) : e.getSemanticClassifications(ge.getTypeChecker(), Ee, de(Ai), ge.getClassifiableNames(), Oi);
              }
              function Jr(Ai, Oi, ji) {
                ye();
                var Vi = ji || "original";
                return Vi === "original" ? e.getEncodedSemanticClassifications(ge.getTypeChecker(), Ee, de(Ai), ge.getClassifiableNames(), Oi) : e.classifier.v2020.getEncodedSemanticClassifications(ge, Ee, de(Ai), Oi);
              }
              function ti(Ai, Oi) {
                return e.getSyntacticClassifications(Ee, Be.getCurrentSourceFile(Ai), Oi);
              }
              function Ze(Ai, Oi) {
                return e.getEncodedSyntacticClassifications(Ee, Be.getCurrentSourceFile(Ai), Oi);
              }
              function Sr(Ai) {
                var Oi = Be.getCurrentSourceFile(Ai);
                return e.OutliningElementsCollector.collectElements(Oi, Ee);
              }
              var zr = new e.Map(e.getEntries((We = {}, We[18] = 19, We[20] = 21, We[22] = 23, We[31] = 29, We)));
              zr.forEach(function(Ai, Oi) {
                return zr.set(Ai.toString(), Number(Oi));
              });
              function Wr(Ai, Oi) {
                var ji = Be.getCurrentSourceFile(Ai), Vi = e.getTouchingToken(ji, Oi), at = Vi.getStart(ji) === Oi ? zr.get(Vi.kind.toString()) : void 0, At = at && e.findChildOfKind(Vi.parent, at, ji);
                return At ? [e.createTextSpanFromNode(Vi, ji), e.createTextSpanFromNode(At, ji)].sort(function(ba, $a) {
                  return ba.start - $a.start;
                }) : e.emptyArray;
              }
              function Je(Ai, Oi, ji) {
                var Vi = e.timestamp(), at = R(ji), At = Be.getCurrentSourceFile(Ai);
                rr("getIndentationAtPosition: getCurrentSourceFile: " + (e.timestamp() - Vi)), Vi = e.timestamp();
                var ba = e.formatting.SmartIndenter.getIndentation(Oi, At, at);
                return rr("getIndentationAtPosition: computeIndentation  : " + (e.timestamp() - Vi)), ba;
              }
              function xe(Ai, Oi, ji, Vi) {
                var at = Be.getCurrentSourceFile(Ai);
                return e.formatting.formatSelection(Oi, ji, at, e.formatting.getFormatContext(R(Vi), g));
              }
              function vr(Ai, Oi) {
                return e.formatting.formatDocument(Be.getCurrentSourceFile(Ai), e.formatting.getFormatContext(R(Oi), g));
              }
              function mr(Ai, Oi, ji, Vi) {
                var at = Be.getCurrentSourceFile(Ai), At = e.formatting.getFormatContext(R(Vi), g);
                if (!e.isInComment(at, Oi)) switch (ji) {
                  case "{":
                    return e.formatting.formatOnOpeningCurly(Oi, at, At);
                  case "}":
                    return e.formatting.formatOnClosingCurly(Oi, at, At);
                  case ";":
                    return e.formatting.formatOnSemicolon(Oi, at, At);
                  case `
`:
                    return e.formatting.formatOnEnter(Oi, at, At);
                }
                return [];
              }
              function Ar(Ai, Oi, ji, Vi, at, At) {
                At === void 0 && (At = e.emptyOptions), ye();
                var ba = de(Ai), $a = e.createTextSpanFromBounds(Oi, ji), Qa = e.formatting.getFormatContext(at, g);
                return e.flatMap(e.deduplicate(Vi, e.equateValues, e.compareValues), function(ai) {
                  return Ee.throwIfCancellationRequested(), e.codefix.getFixes({ errorCode: ai, sourceFile: ba, span: $a, program: ge, host: g, cancellationToken: Ee, formatContext: Qa, preferences: At });
                });
              }
              function Oe(Ai, Oi, ji, Vi) {
                Vi === void 0 && (Vi = e.emptyOptions), ye(), e.Debug.assert(Ai.type === "file");
                var at = de(Ai.fileName), At = e.formatting.getFormatContext(ji, g);
                return e.codefix.getAllFixes({ fixId: Oi, sourceFile: at, program: ge, host: g, cancellationToken: Ee, formatContext: At, preferences: Vi });
              }
              function nr(Ai, Oi, ji) {
                ji === void 0 && (ji = e.emptyOptions), ye(), e.Debug.assert(Ai.type === "file");
                var Vi = de(Ai.fileName), at = e.formatting.getFormatContext(Oi, g);
                return e.OrganizeImports.organizeImports(Vi, at, g, ge, ji, Ai.skipDestructiveCodeActions);
              }
              function Mr(Ai, Oi, ji, Vi) {
                return Vi === void 0 && (Vi = e.emptyOptions), e.getEditsForFileRename(Ae(), Ai, Oi, g, e.formatting.getFormatContext(ji, g), Vi, we);
              }
              function Pe(Ai, Oi) {
                var ji = typeof Ai == "string" ? Oi : Ai;
                return e.isArray(ji) ? Promise.all(ji.map(function(Vi) {
                  return Ue(Vi);
                })) : Ue(ji);
              }
              function Ue(Ai) {
                var Oi = function(ji) {
                  return e.toPath(ji, He, _e);
                };
                return e.Debug.assertEqual(Ai.type, "install package"), g.installPackage ? g.installPackage({ fileName: Oi(Ai.file), packageName: Ai.packageName }) : Promise.reject("Host does not implement `installPackage`");
              }
              function fr(Ai, Oi, ji) {
                return e.JsDoc.getDocCommentTemplateAtPosition(e.getNewLineOrDefaultFromHost(g), Be.getCurrentSourceFile(Ai), Oi, ji);
              }
              function De(Ai, Oi, ji) {
                if (ji === 60) return false;
                var Vi = Be.getCurrentSourceFile(Ai);
                if (e.isInString(Vi, Oi)) return false;
                if (e.isInsideJsxElementOrAttribute(Vi, Oi)) return ji === 123;
                if (e.isInTemplateString(Vi, Oi)) return false;
                switch (ji) {
                  case 39:
                  case 34:
                  case 96:
                    return !e.isInComment(Vi, Oi);
                }
                return true;
              }
              function gr(Ai, Oi) {
                var ji = Be.getCurrentSourceFile(Ai), Vi = e.findPrecedingToken(Oi, ji);
                if (!!Vi) {
                  var at = Vi.kind === 31 && e.isJsxOpeningElement(Vi.parent) ? Vi.parent.parent : e.isJsxText(Vi) && e.isJsxElement(Vi.parent) ? Vi.parent : void 0;
                  if (at && Wi(at)) return { newText: "</".concat(at.openingElement.tagName.getText(ji), ">") };
                  var At = Vi.kind === 31 && e.isJsxOpeningFragment(Vi.parent) ? Vi.parent.parent : e.isJsxText(Vi) && e.isJsxFragment(Vi.parent) ? Vi.parent : void 0;
                  if (At && ct(At)) return { newText: "</>" };
                }
              }
              function Vr(Ai, Oi) {
                return { lineStarts: Ai.getLineStarts(), firstLine: Ai.getLineAndCharacterOfPosition(Oi.pos).line, lastLine: Ai.getLineAndCharacterOfPosition(Oi.end).line };
              }
              function Tr(Ai, Oi, ji) {
                for (var Vi = Be.getCurrentSourceFile(Ai), at = [], At = Vr(Vi, Oi), ba = At.lineStarts, $a = At.firstLine, Qa = At.lastLine, ai = ji || false, Dn = Number.MAX_VALUE, ka = new e.Map(), Ba = new RegExp(/\S/), pn = e.isInsideJsxElement(Vi, ba[$a]), Cn = pn ? "{/*" : "//", Bi = $a; Bi <= Qa; Bi++) {
                  var kn = Vi.text.substring(ba[Bi], Vi.getLineEndOfPosition(ba[Bi])), xn = Ba.exec(kn);
                  xn && (Dn = Math.min(Dn, xn.index), ka.set(Bi.toString(), xn.index), kn.substr(xn.index, Cn.length) !== Cn && (ai = ji === void 0 || ji));
                }
                for (var Bi = $a; Bi <= Qa; Bi++) if (!($a !== Qa && ba[Bi] === Oi.end)) {
                  var Kn = ka.get(Bi.toString());
                  Kn !== void 0 && (pn ? at.push.apply(at, vi(Ai, { pos: ba[Bi] + Dn, end: Vi.getLineEndOfPosition(ba[Bi]) }, ai, pn)) : ai ? at.push({ newText: Cn, span: { length: 0, start: ba[Bi] + Dn } }) : Vi.text.substr(ba[Bi] + Kn, Cn.length) === Cn && at.push({ newText: "", span: { length: Cn.length, start: ba[Bi] + Kn } }));
                }
                return at;
              }
              function vi(Ai, Oi, ji, Vi) {
                for (var at, At = Be.getCurrentSourceFile(Ai), ba = [], $a = At.text, Qa = false, ai = ji || false, Dn = [], ka = Oi.pos, Ba = Vi !== void 0 ? Vi : e.isInsideJsxElement(At, ka), pn = Ba ? "{/*" : "/*", Cn = Ba ? "*/}" : "*/", Bi = Ba ? "\\{\\/\\*" : "\\/\\*", kn = Ba ? "\\*\\/\\}" : "\\*\\/"; ka <= Oi.end; ) {
                  var xn = $a.substr(ka, pn.length) === pn ? pn.length : 0, Kn = e.isInComment(At, ka + xn);
                  if (Kn) Ba && (Kn.pos--, Kn.end++), Dn.push(Kn.pos), Kn.kind === 3 && Dn.push(Kn.end), Qa = true, ka = Kn.end + 1;
                  else {
                    var Pn = $a.substring(ka, Oi.end).search("(".concat(Bi, ")|(").concat(kn, ")"));
                    ai = ji !== void 0 ? ji : ai || !e.isTextWhiteSpaceLike($a, ka, Pn === -1 ? Oi.end : ka + Pn), ka = Pn === -1 ? Oi.end + 1 : ka + Pn + Cn.length;
                  }
                }
                if (ai || !Qa) {
                  ((at = e.isInComment(At, Oi.pos)) === null || at === void 0 ? void 0 : at.kind) !== 2 && e.insertSorted(Dn, Oi.pos, e.compareValues), e.insertSorted(Dn, Oi.end, e.compareValues);
                  var eo = Dn[0];
                  $a.substr(eo, pn.length) !== pn && ba.push({ newText: pn, span: { length: 0, start: eo } });
                  for (var Rn = 1; Rn < Dn.length - 1; Rn++) $a.substr(Dn[Rn] - Cn.length, Cn.length) !== Cn && ba.push({ newText: Cn, span: { length: 0, start: Dn[Rn] } }), $a.substr(Dn[Rn], pn.length) !== pn && ba.push({ newText: pn, span: { length: 0, start: Dn[Rn] } });
                  ba.length % 2 !== 0 && ba.push({ newText: Cn, span: { length: 0, start: Dn[Dn.length - 1] } });
                } else for (var Da = 0, bo = Dn; Da < bo.length; Da++) {
                  var Ro = bo[Da], En = Ro - Cn.length > 0 ? Ro - Cn.length : 0, xn = $a.substr(En, Cn.length) === Cn ? Cn.length : 0;
                  ba.push({ newText: "", span: { length: pn.length, start: Ro - xn } });
                }
                return ba;
              }
              function Ui(Ai, Oi) {
                var ji = Be.getCurrentSourceFile(Ai), Vi = Vr(ji, Oi), at = Vi.firstLine, At = Vi.lastLine;
                return at === At && Oi.pos !== Oi.end ? vi(Ai, Oi, true) : Tr(Ai, Oi, true);
              }
              function Yi(Ai, Oi) {
                var ji = Be.getCurrentSourceFile(Ai), Vi = [], at = Oi.pos, At = Oi.end;
                at === At && (At += e.isInsideJsxElement(ji, at) ? 2 : 1);
                for (var ba = at; ba <= At; ba++) {
                  var $a = e.isInComment(ji, ba);
                  if ($a) {
                    switch ($a.kind) {
                      case 2:
                        Vi.push.apply(Vi, Tr(Ai, { end: $a.end, pos: $a.pos + 1 }, false));
                        break;
                      case 3:
                        Vi.push.apply(Vi, vi(Ai, { end: $a.end, pos: $a.pos + 1 }, false));
                    }
                    ba = $a.end + 1;
                  }
                }
                return Vi;
              }
              function Wi(Ai) {
                var Oi = Ai.openingElement, ji = Ai.closingElement, Vi = Ai.parent;
                return !e.tagNamesAreEquivalent(Oi.tagName, ji.tagName) || e.isJsxElement(Vi) && e.tagNamesAreEquivalent(Oi.tagName, Vi.openingElement.tagName) && Wi(Vi);
              }
              function ct(Ai) {
                var Oi = Ai.closingFragment, ji = Ai.parent;
                return !!(Oi.flags & 131072) || e.isJsxFragment(ji) && ct(ji);
              }
              function Li(Ai, Oi, ji) {
                var Vi = Be.getCurrentSourceFile(Ai), at = e.formatting.getRangeOfEnclosingComment(Vi, Oi);
                return at && (!ji || at.kind === 3) ? e.createTextSpanFromRange(at) : void 0;
              }
              function nt(Ai, Oi) {
                ye();
                var ji = de(Ai);
                Ee.throwIfCancellationRequested();
                var Vi = ji.text, at = [];
                if (Oi.length > 0 && !kn(ji.fileName)) for (var At = Cn(), ba = void 0; ba = At.exec(Vi); ) {
                  Ee.throwIfCancellationRequested();
                  var $a = 3;
                  e.Debug.assert(ba.length === Oi.length + $a);
                  var Qa = ba[1], ai = ba.index + Qa.length;
                  if (!!e.isInComment(ji, ai)) {
                    for (var Dn = void 0, ka = 0; ka < Oi.length; ka++) ba[ka + $a] && (Dn = Oi[ka]);
                    if (Dn === void 0) return e.Debug.fail();
                    if (!Bi(Vi.charCodeAt(ai + Dn.text.length))) {
                      var Ba = ba[2];
                      at.push({ descriptor: Dn, message: Ba, position: ai });
                    }
                  }
                }
                return at;
                function pn(xn) {
                  return xn.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
                }
                function Cn() {
                  var xn = /(?:\/\/+\s*)/.source, Kn = /(?:\/\*+\s*)/.source, Pn = /(?:^(?:\s|\*)*)/.source, eo = "(" + Pn + "|" + xn + "|" + Kn + ")", Rn = "(?:" + e.map(Oi, function(Wn) {
                    return "(" + pn(Wn.text) + ")";
                  }).join("|") + ")", Da = /(?:$|\*\/)/.source, bo = /(?:.*?)/.source, Ro = "(" + Rn + bo + ")", En = eo + Ro + Da;
                  return new RegExp(En, "gim");
                }
                function Bi(xn) {
                  return xn >= 97 && xn <= 122 || xn >= 65 && xn <= 90 || xn >= 48 && xn <= 57;
                }
                function kn(xn) {
                  return e.stringContains(xn, "/node_modules/");
                }
              }
              function Mt(Ai, Oi, ji) {
                return ye(), e.Rename.getRenameInfo(ge, de(Ai), Oi, ji);
              }
              function xt(Ai, Oi, ji, Vi, at, At) {
                var ba = typeof Oi == "number" ? [Oi, void 0] : [Oi.pos, Oi.end], $a = ba[0], Qa = ba[1];
                return { file: Ai, startPosition: $a, endPosition: Qa, program: Ae(), host: g, formatContext: e.formatting.getFormatContext(Vi, g), cancellationToken: Ee, preferences: ji, triggerReason: at, kind: At };
              }
              function ut(Ai, Oi, ji) {
                return { file: Ai, program: Ae(), host: g, span: Oi, preferences: ji, cancellationToken: Ee };
              }
              function Dt(Ai, Oi) {
                return e.SmartSelectionRange.getSmartSelectionRange(Oi, Be.getCurrentSourceFile(Ai));
              }
              function Rt(Ai, Oi, ji, Vi, at) {
                ji === void 0 && (ji = e.emptyOptions), ye();
                var At = de(Ai);
                return e.refactor.getApplicableRefactors(xt(At, Oi, ji, e.emptyOptions, Vi, at));
              }
              function Ii(Ai, Oi, ji, Vi, at, At) {
                At === void 0 && (At = e.emptyOptions), ye();
                var ba = de(Ai);
                return e.refactor.getEditsForRefactor(xt(ba, ji, At, Oi), Vi, at);
              }
              function Ki(Ai, Oi) {
                return Oi === 0 ? { line: 0, character: 0 } : we.toLineColumnOffset(Ai, Oi);
              }
              function Fi(Ai, Oi) {
                ye();
                var ji = e.CallHierarchy.resolveCallHierarchyDeclaration(ge, e.getTouchingPropertyName(de(Ai), Oi));
                return ji && e.mapOneOrMany(ji, function(Vi) {
                  return e.CallHierarchy.createCallHierarchyItem(ge, Vi);
                });
              }
              function ui(Ai, Oi) {
                ye();
                var ji = de(Ai), Vi = e.firstOrOnly(e.CallHierarchy.resolveCallHierarchyDeclaration(ge, Oi === 0 ? ji : e.getTouchingPropertyName(ji, Oi)));
                return Vi ? e.CallHierarchy.getIncomingCalls(ge, Vi, Ee) : [];
              }
              function Bt(Ai, Oi) {
                ye();
                var ji = de(Ai), Vi = e.firstOrOnly(e.CallHierarchy.resolveCallHierarchyDeclaration(ge, Oi === 0 ? ji : e.getTouchingPropertyName(ji, Oi)));
                return Vi ? e.CallHierarchy.getOutgoingCalls(ge, Vi) : [];
              }
              function wt(Ai, Oi, ji) {
                ji === void 0 && (ji = e.emptyOptions), ye();
                var Vi = de(Ai);
                return e.InlayHints.provideInlayHints(ut(Vi, Oi, ji));
              }
              var na = { dispose: Cr, cleanupSemanticCache: ir, getSyntacticDiagnostics: Ye, getSemanticDiagnostics: Br, getSuggestionDiagnostics: Er, getCompilerOptionsDiagnostics: Ne, getSyntacticClassifications: ti, getSemanticClassifications: Xe, getEncodedSyntacticClassifications: Ze, getEncodedSemanticClassifications: Jr, getCompletionsAtPosition: n, getCompletionEntryDetails: lr, getCompletionEntrySymbol: be, getSignatureHelpItems: Gi, getQuickInfoAtPosition: Ge, getDefinitionAtPosition: Ir, getDefinitionAndBoundSpan: wr, getImplementationAtPosition: ii, getTypeDefinitionAtPosition: Ur, getReferencesAtPosition: qr, findReferences: Di, getFileReferences: wi, getOccurrencesAtPosition: mi, getDocumentHighlights: pe, getNameOrDottedNameSpan: Zt, getBreakpointStatementAtPosition: _r, getNavigateToItems: Xi, getRenameInfo: Mt, getSmartSelectionRange: Dt, findRenameLocations: or, getNavigationBarItems: pi, getNavigationTree: ae, getOutliningSpans: Sr, getTodoComments: nt, getBraceMatchingAtPosition: Wr, getIndentationAtPosition: Je, getFormattingEditsForRange: xe, getFormattingEditsForDocument: vr, getFormattingEditsAfterKeystroke: mr, getDocCommentTemplateAtPosition: fr, isValidBraceCompletionAtPosition: De, getJsxClosingTagAtPosition: gr, getSpanOfEnclosingComment: Li, getCodeFixesAtPosition: Ar, getCombinedCodeFix: Oe, applyCodeActionCommand: Pe, organizeImports: nr, getEditsForFileRename: Mr, getEmitOutput: et, getNonBoundSourceFile: Wt, getProgram: Ae, getAutoImportProvider: er, getApplicableRefactors: Rt, getEditsForRefactor: Ii, toLineColumnOffset: Ki, getSourceMapper: function() {
                return we;
              }, clearSourceMapperCache: function() {
                return we.clearCache();
              }, prepareCallHierarchy: Fi, provideCallHierarchyIncomingCalls: ui, provideCallHierarchyOutgoingCalls: Bt, toggleLineComment: Tr, toggleMultilineComment: vi, commentSelection: Ui, uncommentSelection: Yi, provideInlayHints: wt };
              switch (Z) {
                case e.LanguageServiceMode.Semantic:
                  break;
                case e.LanguageServiceMode.PartialSemantic:
                  L.forEach(function(Ai) {
                    return na[Ai] = function() {
                      throw new Error("LanguageService Operation: ".concat(Ai, " not allowed in LanguageServiceMode.PartialSemantic"));
                    };
                  });
                  break;
                case e.LanguageServiceMode.Syntactic:
                  P.forEach(function(Ai) {
                    return na[Ai] = function() {
                      throw new Error("LanguageService Operation: ".concat(Ai, " not allowed in LanguageServiceMode.Syntactic"));
                    };
                  });
                  break;
                default:
                  e.Debug.assertNever(Z);
              }
              return na;
            }
            e.createLanguageService = k;
            function Y(g) {
              return g.nameTable || U(g), g.nameTable;
            }
            e.getNameTable = Y;
            function U(g) {
              var ne = g.nameTable = new e.Map();
              g.forEachChild(function ue(We) {
                if (e.isIdentifier(We) && !e.isTagName(We) && We.escapedText || e.isStringOrNumericLiteralLike(We) && j(We)) {
                  var Fe = e.getEscapedTextOfIdentifierOrLiteral(We);
                  ne.set(Fe, ne.get(Fe) === void 0 ? We.pos : -1);
                } else if (e.isPrivateIdentifier(We)) {
                  var Fe = We.escapedText;
                  ne.set(Fe, ne.get(Fe) === void 0 ? We.pos : -1);
                }
                if (e.forEachChild(We, ue), e.hasJSDocNodes(We)) for (var Z = 0, Be = We.jsDoc; Z < Be.length; Z++) {
                  var ge = Be[Z];
                  e.forEachChild(ge, ue);
                }
              });
            }
            function j(g) {
              return e.isDeclarationName(g) || g.parent.kind === 277 || D(g) || e.isLiteralComputedPropertyDeclarationName(g);
            }
            function H(g) {
              var ne = I(g);
              return ne && (e.isObjectLiteralExpression(ne.parent) || e.isJsxAttributes(ne.parent)) ? ne : void 0;
            }
            e.getContainingObjectLiteralElement = H;
            function I(g) {
              switch (g.kind) {
                case 10:
                case 14:
                case 8:
                  if (g.parent.kind === 162) return e.isObjectLiteralElement(g.parent.parent) ? g.parent.parent : void 0;
                case 79:
                  return e.isObjectLiteralElement(g.parent) && (g.parent.parent.kind === 205 || g.parent.parent.kind === 286) && g.parent.name === g ? g.parent : void 0;
              }
            }
            function l(g, ne) {
              var ue = H(g);
              if (ue) {
                var We = ne.getContextualType(ue.parent), Fe = We && d(ue, ne, We, false);
                if (Fe && Fe.length === 1) return e.first(Fe);
              }
              return ne.getSymbolAtLocation(g);
            }
            function d(g, ne, ue, We) {
              var Fe = e.getNameFromPropertyName(g.name);
              if (!Fe) return e.emptyArray;
              if (!ue.isUnion()) {
                var Z = ue.getProperty(Fe);
                return Z ? [Z] : e.emptyArray;
              }
              var Be = e.mapDefined(ue.types, function(ge) {
                return (e.isObjectLiteralExpression(g.parent) || e.isJsxAttributes(g.parent)) && ne.isTypeInvalidDueToUnionDiscriminant(ge, g.parent) ? void 0 : ge.getProperty(Fe);
              });
              if (We && (Be.length === 0 || Be.length === ue.types.length)) {
                var Z = ue.getProperty(Fe);
                if (Z) return [Z];
              }
              return Be.length === 0 ? e.mapDefined(ue.types, function(ge) {
                return ge.getProperty(Fe);
              }) : Be;
            }
            e.getPropertySymbolsFromContextualType = d;
            function D(g) {
              return g && g.parent && g.parent.kind === 207 && g.parent.argumentExpression === g;
            }
            function fe(g) {
              return "/prettier-security-dirname-placeholder" + e.directorySeparator + e.getDefaultLibFileName(g);
            }
            e.getDefaultLibFilePath = fe, e.setObjectAllocator(ie());
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            var a;
            (function(C) {
              function w(B, E) {
                if (B.isDeclarationFile) return;
                var Q = e.getTokenAtPosition(B, E), le = B.getLineAndCharacterOfPosition(E).line;
                if (B.getLineAndCharacterOfPosition(Q.getStart(B)).line > le) {
                  var N = e.findPrecedingToken(Q.pos, B);
                  if (!N || B.getLineAndCharacterOfPosition(N.getEnd()).line !== le) return;
                  Q = N;
                }
                if (Q.flags & 16777216) return;
                return K(Q);
                function p(b, se) {
                  var J = b.decorators ? e.skipTrivia(B.text, b.decorators.end) : b.getStart(B);
                  return e.createTextSpanFromBounds(J, (se || b).getEnd());
                }
                function m(b, se) {
                  return p(b, e.findNextToken(se, se.parent, B));
                }
                function G(b, se) {
                  return b && le === B.getLineAndCharacterOfPosition(b.getStart(B)).line ? K(b) : K(se);
                }
                function oe(b) {
                  return e.createTextSpanFromBounds(e.skipTrivia(B.text, b.pos), b.end);
                }
                function f(b) {
                  return K(e.findPrecedingToken(b.pos, B));
                }
                function T(b) {
                  return K(e.findNextToken(b, b.parent, B));
                }
                function K(b) {
                  if (b) {
                    var se = b.parent;
                    switch (b.kind) {
                      case 237:
                        return he(b.declarationList.declarations[0]);
                      case 254:
                      case 167:
                      case 166:
                        return he(b);
                      case 164:
                        return x(b);
                      case 256:
                      case 169:
                      case 168:
                      case 172:
                      case 173:
                      case 171:
                      case 213:
                      case 214:
                        return $(b);
                      case 235:
                        if (e.isFunctionBlock(b)) return A(b);
                      case 262:
                        return y(b);
                      case 292:
                        return y(b.block);
                      case 238:
                        return p(b.expression);
                      case 247:
                        return p(b.getChildAt(0), b.expression);
                      case 241:
                        return m(b, b.expression);
                      case 240:
                        return K(b.statement);
                      case 253:
                        return p(b.getChildAt(0));
                      case 239:
                        return m(b, b.expression);
                      case 250:
                        return K(b.statement);
                      case 246:
                      case 245:
                        return p(b.getChildAt(0), b.label);
                      case 242:
                        return L(b);
                      case 243:
                        return m(b, b.expression);
                      case 244:
                        return V(b);
                      case 249:
                        return m(b, b.expression);
                      case 289:
                      case 290:
                        return K(b.statements[0]);
                      case 252:
                        return y(b.tryBlock);
                      case 251:
                        return p(b, b.expression);
                      case 271:
                        return p(b, b.expression);
                      case 265:
                        return p(b, b.moduleReference);
                      case 266:
                        return p(b, b.moduleSpecifier);
                      case 272:
                        return p(b, b.moduleSpecifier);
                      case 261:
                        if (e.getModuleInstanceState(b) !== 1) return;
                      case 257:
                      case 260:
                      case 299:
                      case 203:
                        return p(b);
                      case 248:
                        return K(b.statement);
                      case 165:
                        return oe(se.decorators);
                      case 201:
                      case 202:
                        return P(b);
                      case 258:
                      case 259:
                        return;
                      case 26:
                      case 1:
                        return G(e.findPrecedingToken(b.pos, B));
                      case 27:
                        return f(b);
                      case 18:
                        return Y(b);
                      case 19:
                        return U(b);
                      case 23:
                        return j(b);
                      case 20:
                        return H(b);
                      case 21:
                        return I(b);
                      case 58:
                        return l(b);
                      case 31:
                      case 29:
                        return d(b);
                      case 115:
                        return D(b);
                      case 91:
                      case 83:
                      case 96:
                        return T(b);
                      case 160:
                        return fe(b);
                      default:
                        if (e.isArrayLiteralOrObjectLiteralDestructuringPattern(b)) return k(b);
                        if ((b.kind === 79 || b.kind === 225 || b.kind === 296 || b.kind === 297) && e.isArrayLiteralOrObjectLiteralDestructuringPattern(se)) return p(b);
                        if (b.kind === 221) {
                          var J = b, ie = J.left, R = J.operatorToken;
                          if (e.isArrayLiteralOrObjectLiteralDestructuringPattern(ie)) return k(ie);
                          if (R.kind === 63 && e.isArrayLiteralOrObjectLiteralDestructuringPattern(b.parent)) return p(b);
                          if (R.kind === 27) return K(ie);
                        }
                        if (e.isExpressionNode(b)) switch (se.kind) {
                          case 240:
                            return f(b);
                          case 165:
                            return K(b.parent);
                          case 242:
                          case 244:
                            return p(b);
                          case 221:
                            if (b.parent.operatorToken.kind === 27) return p(b);
                            break;
                          case 214:
                            if (b.parent.body === b) return p(b);
                            break;
                        }
                        switch (b.parent.kind) {
                          case 296:
                            if (b.parent.name === b && !e.isArrayLiteralOrObjectLiteralDestructuringPattern(b.parent.parent)) return K(b.parent.initializer);
                            break;
                          case 211:
                            if (b.parent.type === b) return T(b.parent.type);
                            break;
                          case 254:
                          case 164: {
                            var q = b.parent, O = q.initializer, ve = q.type;
                            if (O === b || ve === b || e.isAssignmentOperator(b.kind)) return f(b);
                            break;
                          }
                          case 221: {
                            var ie = b.parent.left;
                            if (e.isArrayLiteralOrObjectLiteralDestructuringPattern(ie) && b !== ie) return f(b);
                            break;
                          }
                          default:
                            if (e.isFunctionLike(b.parent) && b.parent.type === b) return f(b);
                        }
                        return K(b.parent);
                    }
                  }
                  function ee(g) {
                    return e.isVariableDeclarationList(g.parent) && g.parent.declarations[0] === g ? p(e.findPrecedingToken(g.pos, B, g.parent), g) : p(g);
                  }
                  function he(g) {
                    if (g.parent.parent.kind === 243) return K(g.parent.parent);
                    var ne = g.parent;
                    if (e.isBindingPattern(g.name)) return P(g.name);
                    if (g.initializer || e.hasSyntacticModifier(g, 1) || ne.parent.kind === 244) return ee(g);
                    if (e.isVariableDeclarationList(g.parent) && g.parent.declarations[0] !== g) return K(e.findPrecedingToken(g.pos, B, g.parent));
                  }
                  function F(g) {
                    return !!g.initializer || g.dotDotDotToken !== void 0 || e.hasSyntacticModifier(g, 12);
                  }
                  function x(g) {
                    if (e.isBindingPattern(g.name)) return P(g.name);
                    if (F(g)) return p(g);
                    var ne = g.parent, ue = ne.parameters.indexOf(g);
                    return e.Debug.assert(ue !== -1), ue !== 0 ? x(ne.parameters[ue - 1]) : K(ne.body);
                  }
                  function X(g) {
                    return e.hasSyntacticModifier(g, 1) || g.parent.kind === 257 && g.kind !== 171;
                  }
                  function $(g) {
                    if (!!g.body) return X(g) ? p(g) : K(g.body);
                  }
                  function A(g) {
                    var ne = g.statements.length ? g.statements[0] : g.getLastToken();
                    return X(g.parent) ? G(g.parent, ne) : K(ne);
                  }
                  function y(g) {
                    switch (g.parent.kind) {
                      case 261:
                        if (e.getModuleInstanceState(g.parent) !== 1) return;
                      case 241:
                      case 239:
                      case 243:
                        return G(g.parent, g.statements[0]);
                      case 242:
                      case 244:
                        return G(e.findPrecedingToken(g.pos, B, g.parent), g.statements[0]);
                    }
                    return K(g.statements[0]);
                  }
                  function V(g) {
                    if (g.initializer.kind === 255) {
                      var ne = g.initializer;
                      if (ne.declarations.length > 0) return K(ne.declarations[0]);
                    } else return K(g.initializer);
                  }
                  function L(g) {
                    if (g.initializer) return V(g);
                    if (g.condition) return p(g.condition);
                    if (g.incrementor) return p(g.incrementor);
                  }
                  function P(g) {
                    var ne = e.forEach(g.elements, function(ue) {
                      return ue.kind !== 227 ? ue : void 0;
                    });
                    return ne ? K(ne) : g.parent.kind === 203 ? p(g.parent) : ee(g.parent);
                  }
                  function k(g) {
                    e.Debug.assert(g.kind !== 202 && g.kind !== 201);
                    var ne = g.kind === 204 ? g.elements : g.properties, ue = e.forEach(ne, function(We) {
                      return We.kind !== 227 ? We : void 0;
                    });
                    return ue ? K(ue) : p(g.parent.kind === 221 ? g.parent : g);
                  }
                  function Y(g) {
                    switch (g.parent.kind) {
                      case 260:
                        var ne = g.parent;
                        return G(e.findPrecedingToken(g.pos, B, g.parent), ne.members.length ? ne.members[0] : ne.getLastToken(B));
                      case 257:
                        var ue = g.parent;
                        return G(e.findPrecedingToken(g.pos, B, g.parent), ue.members.length ? ue.members[0] : ue.getLastToken(B));
                      case 263:
                        return G(g.parent.parent, g.parent.clauses[0]);
                    }
                    return K(g.parent);
                  }
                  function U(g) {
                    switch (g.parent.kind) {
                      case 262:
                        if (e.getModuleInstanceState(g.parent.parent) !== 1) return;
                      case 260:
                      case 257:
                        return p(g);
                      case 235:
                        if (e.isFunctionBlock(g.parent)) return p(g);
                      case 292:
                        return K(e.lastOrUndefined(g.parent.statements));
                      case 263:
                        var ne = g.parent, ue = e.lastOrUndefined(ne.clauses);
                        return ue ? K(e.lastOrUndefined(ue.statements)) : void 0;
                      case 201:
                        var We = g.parent;
                        return K(e.lastOrUndefined(We.elements) || We);
                      default:
                        if (e.isArrayLiteralOrObjectLiteralDestructuringPattern(g.parent)) {
                          var Fe = g.parent;
                          return p(e.lastOrUndefined(Fe.properties) || Fe);
                        }
                        return K(g.parent);
                    }
                  }
                  function j(g) {
                    switch (g.parent.kind) {
                      case 202:
                        var ne = g.parent;
                        return p(e.lastOrUndefined(ne.elements) || ne);
                      default:
                        if (e.isArrayLiteralOrObjectLiteralDestructuringPattern(g.parent)) {
                          var ue = g.parent;
                          return p(e.lastOrUndefined(ue.elements) || ue);
                        }
                        return K(g.parent);
                    }
                  }
                  function H(g) {
                    return g.parent.kind === 240 || g.parent.kind === 208 || g.parent.kind === 209 ? f(g) : g.parent.kind === 212 ? T(g) : K(g.parent);
                  }
                  function I(g) {
                    switch (g.parent.kind) {
                      case 213:
                      case 256:
                      case 214:
                      case 169:
                      case 168:
                      case 172:
                      case 173:
                      case 171:
                      case 241:
                      case 240:
                      case 242:
                      case 244:
                      case 208:
                      case 209:
                      case 212:
                        return f(g);
                      default:
                        return K(g.parent);
                    }
                  }
                  function l(g) {
                    return e.isFunctionLike(g.parent) || g.parent.kind === 296 || g.parent.kind === 164 ? f(g) : K(g.parent);
                  }
                  function d(g) {
                    return g.parent.kind === 211 ? T(g) : K(g.parent);
                  }
                  function D(g) {
                    return g.parent.kind === 240 ? m(g, g.parent.expression) : K(g.parent);
                  }
                  function fe(g) {
                    return g.parent.kind === 244 ? T(g) : K(g.parent);
                  }
                }
              }
              C.spanInSourceFileAtLocation = w;
            })(a = e.BreakpointResolver || (e.BreakpointResolver = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e) {
            function a(C, w, B) {
              var E = [];
              B = e.fixupCompilerOptions(B, E);
              var Q = e.isArray(C) ? C : [C], le = e.transformNodes(void 0, void 0, e.factory, B, Q, w, true);
              return le.diagnostics = e.concatenate(le.diagnostics, E), le;
            }
            e.transform = a;
          })(ke || (ke = {}));
          var ar = /* @__PURE__ */ function() {
            return this;
          }(), ke;
          (function(e) {
            function a(m, G) {
              m && m.log("*INTERNAL ERROR* - Exception in typescript services: " + G.message);
            }
            var C = void 0, w = void 0;
            e.LanguageServiceShimHostAdapter = w;
            var B = void 0;
            e.CoreServicesShimHostAdapter = B;
            var E = void 0;
            e.realizeDiagnostics = void 0;
            var Q = void 0, le = void 0, N = void 0, p = void 0;
            e.TypeScriptServicesFactory = void 0;
          })(ke || (ke = {})), function() {
            return;
            try {
              Object.defineProperty(Object.prototype, "__magic__", { get: function() {
                return this;
              }, configurable: true }), __magic__.globalThis = __magic__, typeof globalThis > "u" && (window.globalThis = window), delete Object.prototype.__magic__;
            } catch {
              window.globalThis = window;
            }
          }(), typeof re < "u" && re.exports && (re.exports = ke);
          var ke;
          (function(e) {
            var a = { since: "4.0", warnAfter: "4.1", message: "Use the appropriate method on 'ts.factory' or the 'factory' supplied by your transformation context instead." };
            e.createNodeArray = e.Debug.deprecate(e.factory.createNodeArray, a), e.createNumericLiteral = e.Debug.deprecate(e.factory.createNumericLiteral, a), e.createBigIntLiteral = e.Debug.deprecate(e.factory.createBigIntLiteral, a), e.createStringLiteral = e.Debug.deprecate(e.factory.createStringLiteral, a), e.createStringLiteralFromNode = e.Debug.deprecate(e.factory.createStringLiteralFromNode, a), e.createRegularExpressionLiteral = e.Debug.deprecate(e.factory.createRegularExpressionLiteral, a), e.createLoopVariable = e.Debug.deprecate(e.factory.createLoopVariable, a), e.createUniqueName = e.Debug.deprecate(e.factory.createUniqueName, a), e.createPrivateIdentifier = e.Debug.deprecate(e.factory.createPrivateIdentifier, a), e.createSuper = e.Debug.deprecate(e.factory.createSuper, a), e.createThis = e.Debug.deprecate(e.factory.createThis, a), e.createNull = e.Debug.deprecate(e.factory.createNull, a), e.createTrue = e.Debug.deprecate(e.factory.createTrue, a), e.createFalse = e.Debug.deprecate(e.factory.createFalse, a), e.createModifier = e.Debug.deprecate(e.factory.createModifier, a), e.createModifiersFromModifierFlags = e.Debug.deprecate(e.factory.createModifiersFromModifierFlags, a), e.createQualifiedName = e.Debug.deprecate(e.factory.createQualifiedName, a), e.updateQualifiedName = e.Debug.deprecate(e.factory.updateQualifiedName, a), e.createComputedPropertyName = e.Debug.deprecate(e.factory.createComputedPropertyName, a), e.updateComputedPropertyName = e.Debug.deprecate(e.factory.updateComputedPropertyName, a), e.createTypeParameterDeclaration = e.Debug.deprecate(e.factory.createTypeParameterDeclaration, a), e.updateTypeParameterDeclaration = e.Debug.deprecate(e.factory.updateTypeParameterDeclaration, a), e.createParameter = e.Debug.deprecate(e.factory.createParameterDeclaration, a), e.updateParameter = e.Debug.deprecate(e.factory.updateParameterDeclaration, a), e.createDecorator = e.Debug.deprecate(e.factory.createDecorator, a), e.updateDecorator = e.Debug.deprecate(e.factory.updateDecorator, a), e.createProperty = e.Debug.deprecate(e.factory.createPropertyDeclaration, a), e.updateProperty = e.Debug.deprecate(e.factory.updatePropertyDeclaration, a), e.createMethod = e.Debug.deprecate(e.factory.createMethodDeclaration, a), e.updateMethod = e.Debug.deprecate(e.factory.updateMethodDeclaration, a), e.createConstructor = e.Debug.deprecate(e.factory.createConstructorDeclaration, a), e.updateConstructor = e.Debug.deprecate(e.factory.updateConstructorDeclaration, a), e.createGetAccessor = e.Debug.deprecate(e.factory.createGetAccessorDeclaration, a), e.updateGetAccessor = e.Debug.deprecate(e.factory.updateGetAccessorDeclaration, a), e.createSetAccessor = e.Debug.deprecate(e.factory.createSetAccessorDeclaration, a), e.updateSetAccessor = e.Debug.deprecate(e.factory.updateSetAccessorDeclaration, a), e.createCallSignature = e.Debug.deprecate(e.factory.createCallSignature, a), e.updateCallSignature = e.Debug.deprecate(e.factory.updateCallSignature, a), e.createConstructSignature = e.Debug.deprecate(e.factory.createConstructSignature, a), e.updateConstructSignature = e.Debug.deprecate(e.factory.updateConstructSignature, a), e.updateIndexSignature = e.Debug.deprecate(e.factory.updateIndexSignature, a), e.createKeywordTypeNode = e.Debug.deprecate(e.factory.createKeywordTypeNode, a), e.createTypePredicateNodeWithModifier = e.Debug.deprecate(e.factory.createTypePredicateNode, a), e.updateTypePredicateNodeWithModifier = e.Debug.deprecate(e.factory.updateTypePredicateNode, a), e.createTypeReferenceNode = e.Debug.deprecate(e.factory.createTypeReferenceNode, a), e.updateTypeReferenceNode = e.Debug.deprecate(e.factory.updateTypeReferenceNode, a), e.createFunctionTypeNode = e.Debug.deprecate(e.factory.createFunctionTypeNode, a), e.updateFunctionTypeNode = e.Debug.deprecate(e.factory.updateFunctionTypeNode, a), e.createConstructorTypeNode = e.Debug.deprecate(function(C, w, B) {
              return e.factory.createConstructorTypeNode(void 0, C, w, B);
            }, a), e.updateConstructorTypeNode = e.Debug.deprecate(function(C, w, B, E) {
              return e.factory.updateConstructorTypeNode(C, C.modifiers, w, B, E);
            }, a), e.createTypeQueryNode = e.Debug.deprecate(e.factory.createTypeQueryNode, a), e.updateTypeQueryNode = e.Debug.deprecate(e.factory.updateTypeQueryNode, a), e.createTypeLiteralNode = e.Debug.deprecate(e.factory.createTypeLiteralNode, a), e.updateTypeLiteralNode = e.Debug.deprecate(e.factory.updateTypeLiteralNode, a), e.createArrayTypeNode = e.Debug.deprecate(e.factory.createArrayTypeNode, a), e.updateArrayTypeNode = e.Debug.deprecate(e.factory.updateArrayTypeNode, a), e.createTupleTypeNode = e.Debug.deprecate(e.factory.createTupleTypeNode, a), e.updateTupleTypeNode = e.Debug.deprecate(e.factory.updateTupleTypeNode, a), e.createOptionalTypeNode = e.Debug.deprecate(e.factory.createOptionalTypeNode, a), e.updateOptionalTypeNode = e.Debug.deprecate(e.factory.updateOptionalTypeNode, a), e.createRestTypeNode = e.Debug.deprecate(e.factory.createRestTypeNode, a), e.updateRestTypeNode = e.Debug.deprecate(e.factory.updateRestTypeNode, a), e.createUnionTypeNode = e.Debug.deprecate(e.factory.createUnionTypeNode, a), e.updateUnionTypeNode = e.Debug.deprecate(e.factory.updateUnionTypeNode, a), e.createIntersectionTypeNode = e.Debug.deprecate(e.factory.createIntersectionTypeNode, a), e.updateIntersectionTypeNode = e.Debug.deprecate(e.factory.updateIntersectionTypeNode, a), e.createConditionalTypeNode = e.Debug.deprecate(e.factory.createConditionalTypeNode, a), e.updateConditionalTypeNode = e.Debug.deprecate(e.factory.updateConditionalTypeNode, a), e.createInferTypeNode = e.Debug.deprecate(e.factory.createInferTypeNode, a), e.updateInferTypeNode = e.Debug.deprecate(e.factory.updateInferTypeNode, a), e.createImportTypeNode = e.Debug.deprecate(e.factory.createImportTypeNode, a), e.updateImportTypeNode = e.Debug.deprecate(e.factory.updateImportTypeNode, a), e.createParenthesizedType = e.Debug.deprecate(e.factory.createParenthesizedType, a), e.updateParenthesizedType = e.Debug.deprecate(e.factory.updateParenthesizedType, a), e.createThisTypeNode = e.Debug.deprecate(e.factory.createThisTypeNode, a), e.updateTypeOperatorNode = e.Debug.deprecate(e.factory.updateTypeOperatorNode, a), e.createIndexedAccessTypeNode = e.Debug.deprecate(e.factory.createIndexedAccessTypeNode, a), e.updateIndexedAccessTypeNode = e.Debug.deprecate(e.factory.updateIndexedAccessTypeNode, a), e.createMappedTypeNode = e.Debug.deprecate(e.factory.createMappedTypeNode, a), e.updateMappedTypeNode = e.Debug.deprecate(e.factory.updateMappedTypeNode, a), e.createLiteralTypeNode = e.Debug.deprecate(e.factory.createLiteralTypeNode, a), e.updateLiteralTypeNode = e.Debug.deprecate(e.factory.updateLiteralTypeNode, a), e.createObjectBindingPattern = e.Debug.deprecate(e.factory.createObjectBindingPattern, a), e.updateObjectBindingPattern = e.Debug.deprecate(e.factory.updateObjectBindingPattern, a), e.createArrayBindingPattern = e.Debug.deprecate(e.factory.createArrayBindingPattern, a), e.updateArrayBindingPattern = e.Debug.deprecate(e.factory.updateArrayBindingPattern, a), e.createBindingElement = e.Debug.deprecate(e.factory.createBindingElement, a), e.updateBindingElement = e.Debug.deprecate(e.factory.updateBindingElement, a), e.createArrayLiteral = e.Debug.deprecate(e.factory.createArrayLiteralExpression, a), e.updateArrayLiteral = e.Debug.deprecate(e.factory.updateArrayLiteralExpression, a), e.createObjectLiteral = e.Debug.deprecate(e.factory.createObjectLiteralExpression, a), e.updateObjectLiteral = e.Debug.deprecate(e.factory.updateObjectLiteralExpression, a), e.createPropertyAccess = e.Debug.deprecate(e.factory.createPropertyAccessExpression, a), e.updatePropertyAccess = e.Debug.deprecate(e.factory.updatePropertyAccessExpression, a), e.createPropertyAccessChain = e.Debug.deprecate(e.factory.createPropertyAccessChain, a), e.updatePropertyAccessChain = e.Debug.deprecate(e.factory.updatePropertyAccessChain, a), e.createElementAccess = e.Debug.deprecate(e.factory.createElementAccessExpression, a), e.updateElementAccess = e.Debug.deprecate(e.factory.updateElementAccessExpression, a), e.createElementAccessChain = e.Debug.deprecate(e.factory.createElementAccessChain, a), e.updateElementAccessChain = e.Debug.deprecate(e.factory.updateElementAccessChain, a), e.createCall = e.Debug.deprecate(e.factory.createCallExpression, a), e.updateCall = e.Debug.deprecate(e.factory.updateCallExpression, a), e.createCallChain = e.Debug.deprecate(e.factory.createCallChain, a), e.updateCallChain = e.Debug.deprecate(e.factory.updateCallChain, a), e.createNew = e.Debug.deprecate(e.factory.createNewExpression, a), e.updateNew = e.Debug.deprecate(e.factory.updateNewExpression, a), e.createTypeAssertion = e.Debug.deprecate(e.factory.createTypeAssertion, a), e.updateTypeAssertion = e.Debug.deprecate(e.factory.updateTypeAssertion, a), e.createParen = e.Debug.deprecate(e.factory.createParenthesizedExpression, a), e.updateParen = e.Debug.deprecate(e.factory.updateParenthesizedExpression, a), e.createFunctionExpression = e.Debug.deprecate(e.factory.createFunctionExpression, a), e.updateFunctionExpression = e.Debug.deprecate(e.factory.updateFunctionExpression, a), e.createDelete = e.Debug.deprecate(e.factory.createDeleteExpression, a), e.updateDelete = e.Debug.deprecate(e.factory.updateDeleteExpression, a), e.createTypeOf = e.Debug.deprecate(e.factory.createTypeOfExpression, a), e.updateTypeOf = e.Debug.deprecate(e.factory.updateTypeOfExpression, a), e.createVoid = e.Debug.deprecate(e.factory.createVoidExpression, a), e.updateVoid = e.Debug.deprecate(e.factory.updateVoidExpression, a), e.createAwait = e.Debug.deprecate(e.factory.createAwaitExpression, a), e.updateAwait = e.Debug.deprecate(e.factory.updateAwaitExpression, a), e.createPrefix = e.Debug.deprecate(e.factory.createPrefixUnaryExpression, a), e.updatePrefix = e.Debug.deprecate(e.factory.updatePrefixUnaryExpression, a), e.createPostfix = e.Debug.deprecate(e.factory.createPostfixUnaryExpression, a), e.updatePostfix = e.Debug.deprecate(e.factory.updatePostfixUnaryExpression, a), e.createBinary = e.Debug.deprecate(e.factory.createBinaryExpression, a), e.updateConditional = e.Debug.deprecate(e.factory.updateConditionalExpression, a), e.createTemplateExpression = e.Debug.deprecate(e.factory.createTemplateExpression, a), e.updateTemplateExpression = e.Debug.deprecate(e.factory.updateTemplateExpression, a), e.createTemplateHead = e.Debug.deprecate(e.factory.createTemplateHead, a), e.createTemplateMiddle = e.Debug.deprecate(e.factory.createTemplateMiddle, a), e.createTemplateTail = e.Debug.deprecate(e.factory.createTemplateTail, a), e.createNoSubstitutionTemplateLiteral = e.Debug.deprecate(e.factory.createNoSubstitutionTemplateLiteral, a), e.updateYield = e.Debug.deprecate(e.factory.updateYieldExpression, a), e.createSpread = e.Debug.deprecate(e.factory.createSpreadElement, a), e.updateSpread = e.Debug.deprecate(e.factory.updateSpreadElement, a), e.createOmittedExpression = e.Debug.deprecate(e.factory.createOmittedExpression, a), e.createAsExpression = e.Debug.deprecate(e.factory.createAsExpression, a), e.updateAsExpression = e.Debug.deprecate(e.factory.updateAsExpression, a), e.createNonNullExpression = e.Debug.deprecate(e.factory.createNonNullExpression, a), e.updateNonNullExpression = e.Debug.deprecate(e.factory.updateNonNullExpression, a), e.createNonNullChain = e.Debug.deprecate(e.factory.createNonNullChain, a), e.updateNonNullChain = e.Debug.deprecate(e.factory.updateNonNullChain, a), e.createMetaProperty = e.Debug.deprecate(e.factory.createMetaProperty, a), e.updateMetaProperty = e.Debug.deprecate(e.factory.updateMetaProperty, a), e.createTemplateSpan = e.Debug.deprecate(e.factory.createTemplateSpan, a), e.updateTemplateSpan = e.Debug.deprecate(e.factory.updateTemplateSpan, a), e.createSemicolonClassElement = e.Debug.deprecate(e.factory.createSemicolonClassElement, a), e.createBlock = e.Debug.deprecate(e.factory.createBlock, a), e.updateBlock = e.Debug.deprecate(e.factory.updateBlock, a), e.createVariableStatement = e.Debug.deprecate(e.factory.createVariableStatement, a), e.updateVariableStatement = e.Debug.deprecate(e.factory.updateVariableStatement, a), e.createEmptyStatement = e.Debug.deprecate(e.factory.createEmptyStatement, a), e.createExpressionStatement = e.Debug.deprecate(e.factory.createExpressionStatement, a), e.updateExpressionStatement = e.Debug.deprecate(e.factory.updateExpressionStatement, a), e.createStatement = e.Debug.deprecate(e.factory.createExpressionStatement, a), e.updateStatement = e.Debug.deprecate(e.factory.updateExpressionStatement, a), e.createIf = e.Debug.deprecate(e.factory.createIfStatement, a), e.updateIf = e.Debug.deprecate(e.factory.updateIfStatement, a), e.createDo = e.Debug.deprecate(e.factory.createDoStatement, a), e.updateDo = e.Debug.deprecate(e.factory.updateDoStatement, a), e.createWhile = e.Debug.deprecate(e.factory.createWhileStatement, a), e.updateWhile = e.Debug.deprecate(e.factory.updateWhileStatement, a), e.createFor = e.Debug.deprecate(e.factory.createForStatement, a), e.updateFor = e.Debug.deprecate(e.factory.updateForStatement, a), e.createForIn = e.Debug.deprecate(e.factory.createForInStatement, a), e.updateForIn = e.Debug.deprecate(e.factory.updateForInStatement, a), e.createForOf = e.Debug.deprecate(e.factory.createForOfStatement, a), e.updateForOf = e.Debug.deprecate(e.factory.updateForOfStatement, a), e.createContinue = e.Debug.deprecate(e.factory.createContinueStatement, a), e.updateContinue = e.Debug.deprecate(e.factory.updateContinueStatement, a), e.createBreak = e.Debug.deprecate(e.factory.createBreakStatement, a), e.updateBreak = e.Debug.deprecate(e.factory.updateBreakStatement, a), e.createReturn = e.Debug.deprecate(e.factory.createReturnStatement, a), e.updateReturn = e.Debug.deprecate(e.factory.updateReturnStatement, a), e.createWith = e.Debug.deprecate(e.factory.createWithStatement, a), e.updateWith = e.Debug.deprecate(e.factory.updateWithStatement, a), e.createSwitch = e.Debug.deprecate(e.factory.createSwitchStatement, a), e.updateSwitch = e.Debug.deprecate(e.factory.updateSwitchStatement, a), e.createLabel = e.Debug.deprecate(e.factory.createLabeledStatement, a), e.updateLabel = e.Debug.deprecate(e.factory.updateLabeledStatement, a), e.createThrow = e.Debug.deprecate(e.factory.createThrowStatement, a), e.updateThrow = e.Debug.deprecate(e.factory.updateThrowStatement, a), e.createTry = e.Debug.deprecate(e.factory.createTryStatement, a), e.updateTry = e.Debug.deprecate(e.factory.updateTryStatement, a), e.createDebuggerStatement = e.Debug.deprecate(e.factory.createDebuggerStatement, a), e.createVariableDeclarationList = e.Debug.deprecate(e.factory.createVariableDeclarationList, a), e.updateVariableDeclarationList = e.Debug.deprecate(e.factory.updateVariableDeclarationList, a), e.createFunctionDeclaration = e.Debug.deprecate(e.factory.createFunctionDeclaration, a), e.updateFunctionDeclaration = e.Debug.deprecate(e.factory.updateFunctionDeclaration, a), e.createClassDeclaration = e.Debug.deprecate(e.factory.createClassDeclaration, a), e.updateClassDeclaration = e.Debug.deprecate(e.factory.updateClassDeclaration, a), e.createInterfaceDeclaration = e.Debug.deprecate(e.factory.createInterfaceDeclaration, a), e.updateInterfaceDeclaration = e.Debug.deprecate(e.factory.updateInterfaceDeclaration, a), e.createTypeAliasDeclaration = e.Debug.deprecate(e.factory.createTypeAliasDeclaration, a), e.updateTypeAliasDeclaration = e.Debug.deprecate(e.factory.updateTypeAliasDeclaration, a), e.createEnumDeclaration = e.Debug.deprecate(e.factory.createEnumDeclaration, a), e.updateEnumDeclaration = e.Debug.deprecate(e.factory.updateEnumDeclaration, a), e.createModuleDeclaration = e.Debug.deprecate(e.factory.createModuleDeclaration, a), e.updateModuleDeclaration = e.Debug.deprecate(e.factory.updateModuleDeclaration, a), e.createModuleBlock = e.Debug.deprecate(e.factory.createModuleBlock, a), e.updateModuleBlock = e.Debug.deprecate(e.factory.updateModuleBlock, a), e.createCaseBlock = e.Debug.deprecate(e.factory.createCaseBlock, a), e.updateCaseBlock = e.Debug.deprecate(e.factory.updateCaseBlock, a), e.createNamespaceExportDeclaration = e.Debug.deprecate(e.factory.createNamespaceExportDeclaration, a), e.updateNamespaceExportDeclaration = e.Debug.deprecate(e.factory.updateNamespaceExportDeclaration, a), e.createImportEqualsDeclaration = e.Debug.deprecate(e.factory.createImportEqualsDeclaration, a), e.updateImportEqualsDeclaration = e.Debug.deprecate(e.factory.updateImportEqualsDeclaration, a), e.createImportDeclaration = e.Debug.deprecate(e.factory.createImportDeclaration, a), e.updateImportDeclaration = e.Debug.deprecate(e.factory.updateImportDeclaration, a), e.createNamespaceImport = e.Debug.deprecate(e.factory.createNamespaceImport, a), e.updateNamespaceImport = e.Debug.deprecate(e.factory.updateNamespaceImport, a), e.createNamedImports = e.Debug.deprecate(e.factory.createNamedImports, a), e.updateNamedImports = e.Debug.deprecate(e.factory.updateNamedImports, a), e.createImportSpecifier = e.Debug.deprecate(e.factory.createImportSpecifier, a), e.updateImportSpecifier = e.Debug.deprecate(e.factory.updateImportSpecifier, a), e.createExportAssignment = e.Debug.deprecate(e.factory.createExportAssignment, a), e.updateExportAssignment = e.Debug.deprecate(e.factory.updateExportAssignment, a), e.createNamedExports = e.Debug.deprecate(e.factory.createNamedExports, a), e.updateNamedExports = e.Debug.deprecate(e.factory.updateNamedExports, a), e.createExportSpecifier = e.Debug.deprecate(e.factory.createExportSpecifier, a), e.updateExportSpecifier = e.Debug.deprecate(e.factory.updateExportSpecifier, a), e.createExternalModuleReference = e.Debug.deprecate(e.factory.createExternalModuleReference, a), e.updateExternalModuleReference = e.Debug.deprecate(e.factory.updateExternalModuleReference, a), e.createJSDocTypeExpression = e.Debug.deprecate(e.factory.createJSDocTypeExpression, a), e.createJSDocTypeTag = e.Debug.deprecate(e.factory.createJSDocTypeTag, a), e.createJSDocReturnTag = e.Debug.deprecate(e.factory.createJSDocReturnTag, a), e.createJSDocThisTag = e.Debug.deprecate(e.factory.createJSDocThisTag, a), e.createJSDocComment = e.Debug.deprecate(e.factory.createJSDocComment, a), e.createJSDocParameterTag = e.Debug.deprecate(e.factory.createJSDocParameterTag, a), e.createJSDocClassTag = e.Debug.deprecate(e.factory.createJSDocClassTag, a), e.createJSDocAugmentsTag = e.Debug.deprecate(e.factory.createJSDocAugmentsTag, a), e.createJSDocEnumTag = e.Debug.deprecate(e.factory.createJSDocEnumTag, a), e.createJSDocTemplateTag = e.Debug.deprecate(e.factory.createJSDocTemplateTag, a), e.createJSDocTypedefTag = e.Debug.deprecate(e.factory.createJSDocTypedefTag, a), e.createJSDocCallbackTag = e.Debug.deprecate(e.factory.createJSDocCallbackTag, a), e.createJSDocSignature = e.Debug.deprecate(e.factory.createJSDocSignature, a), e.createJSDocPropertyTag = e.Debug.deprecate(e.factory.createJSDocPropertyTag, a), e.createJSDocTypeLiteral = e.Debug.deprecate(e.factory.createJSDocTypeLiteral, a), e.createJSDocImplementsTag = e.Debug.deprecate(e.factory.createJSDocImplementsTag, a), e.createJSDocAuthorTag = e.Debug.deprecate(e.factory.createJSDocAuthorTag, a), e.createJSDocPublicTag = e.Debug.deprecate(e.factory.createJSDocPublicTag, a), e.createJSDocPrivateTag = e.Debug.deprecate(e.factory.createJSDocPrivateTag, a), e.createJSDocProtectedTag = e.Debug.deprecate(e.factory.createJSDocProtectedTag, a), e.createJSDocReadonlyTag = e.Debug.deprecate(e.factory.createJSDocReadonlyTag, a), e.createJSDocTag = e.Debug.deprecate(e.factory.createJSDocUnknownTag, a), e.createJsxElement = e.Debug.deprecate(e.factory.createJsxElement, a), e.updateJsxElement = e.Debug.deprecate(e.factory.updateJsxElement, a), e.createJsxSelfClosingElement = e.Debug.deprecate(e.factory.createJsxSelfClosingElement, a), e.updateJsxSelfClosingElement = e.Debug.deprecate(e.factory.updateJsxSelfClosingElement, a), e.createJsxOpeningElement = e.Debug.deprecate(e.factory.createJsxOpeningElement, a), e.updateJsxOpeningElement = e.Debug.deprecate(e.factory.updateJsxOpeningElement, a), e.createJsxClosingElement = e.Debug.deprecate(e.factory.createJsxClosingElement, a), e.updateJsxClosingElement = e.Debug.deprecate(e.factory.updateJsxClosingElement, a), e.createJsxFragment = e.Debug.deprecate(e.factory.createJsxFragment, a), e.createJsxText = e.Debug.deprecate(e.factory.createJsxText, a), e.updateJsxText = e.Debug.deprecate(e.factory.updateJsxText, a), e.createJsxOpeningFragment = e.Debug.deprecate(e.factory.createJsxOpeningFragment, a), e.createJsxJsxClosingFragment = e.Debug.deprecate(e.factory.createJsxJsxClosingFragment, a), e.updateJsxFragment = e.Debug.deprecate(e.factory.updateJsxFragment, a), e.createJsxAttribute = e.Debug.deprecate(e.factory.createJsxAttribute, a), e.updateJsxAttribute = e.Debug.deprecate(e.factory.updateJsxAttribute, a), e.createJsxAttributes = e.Debug.deprecate(e.factory.createJsxAttributes, a), e.updateJsxAttributes = e.Debug.deprecate(e.factory.updateJsxAttributes, a), e.createJsxSpreadAttribute = e.Debug.deprecate(e.factory.createJsxSpreadAttribute, a), e.updateJsxSpreadAttribute = e.Debug.deprecate(e.factory.updateJsxSpreadAttribute, a), e.createJsxExpression = e.Debug.deprecate(e.factory.createJsxExpression, a), e.updateJsxExpression = e.Debug.deprecate(e.factory.updateJsxExpression, a), e.createCaseClause = e.Debug.deprecate(e.factory.createCaseClause, a), e.updateCaseClause = e.Debug.deprecate(e.factory.updateCaseClause, a), e.createDefaultClause = e.Debug.deprecate(e.factory.createDefaultClause, a), e.updateDefaultClause = e.Debug.deprecate(e.factory.updateDefaultClause, a), e.createHeritageClause = e.Debug.deprecate(e.factory.createHeritageClause, a), e.updateHeritageClause = e.Debug.deprecate(e.factory.updateHeritageClause, a), e.createCatchClause = e.Debug.deprecate(e.factory.createCatchClause, a), e.updateCatchClause = e.Debug.deprecate(e.factory.updateCatchClause, a), e.createPropertyAssignment = e.Debug.deprecate(e.factory.createPropertyAssignment, a), e.updatePropertyAssignment = e.Debug.deprecate(e.factory.updatePropertyAssignment, a), e.createShorthandPropertyAssignment = e.Debug.deprecate(e.factory.createShorthandPropertyAssignment, a), e.updateShorthandPropertyAssignment = e.Debug.deprecate(e.factory.updateShorthandPropertyAssignment, a), e.createSpreadAssignment = e.Debug.deprecate(e.factory.createSpreadAssignment, a), e.updateSpreadAssignment = e.Debug.deprecate(e.factory.updateSpreadAssignment, a), e.createEnumMember = e.Debug.deprecate(e.factory.createEnumMember, a), e.updateEnumMember = e.Debug.deprecate(e.factory.updateEnumMember, a), e.updateSourceFileNode = e.Debug.deprecate(e.factory.updateSourceFile, a), e.createNotEmittedStatement = e.Debug.deprecate(e.factory.createNotEmittedStatement, a), e.createPartiallyEmittedExpression = e.Debug.deprecate(e.factory.createPartiallyEmittedExpression, a), e.updatePartiallyEmittedExpression = e.Debug.deprecate(e.factory.updatePartiallyEmittedExpression, a), e.createCommaList = e.Debug.deprecate(e.factory.createCommaListExpression, a), e.updateCommaList = e.Debug.deprecate(e.factory.updateCommaListExpression, a), e.createBundle = e.Debug.deprecate(e.factory.createBundle, a), e.updateBundle = e.Debug.deprecate(e.factory.updateBundle, a), e.createImmediatelyInvokedFunctionExpression = e.Debug.deprecate(e.factory.createImmediatelyInvokedFunctionExpression, a), e.createImmediatelyInvokedArrowFunction = e.Debug.deprecate(e.factory.createImmediatelyInvokedArrowFunction, a), e.createVoidZero = e.Debug.deprecate(e.factory.createVoidZero, a), e.createExportDefault = e.Debug.deprecate(e.factory.createExportDefault, a), e.createExternalModuleExport = e.Debug.deprecate(e.factory.createExternalModuleExport, a), e.createNamespaceExport = e.Debug.deprecate(e.factory.createNamespaceExport, a), e.updateNamespaceExport = e.Debug.deprecate(e.factory.updateNamespaceExport, a), e.createToken = e.Debug.deprecate(function(w) {
              return e.factory.createToken(w);
            }, a), e.createIdentifier = e.Debug.deprecate(function(w) {
              return e.factory.createIdentifier(w, void 0, void 0);
            }, a), e.createTempVariable = e.Debug.deprecate(function(w) {
              return e.factory.createTempVariable(w, void 0);
            }, a), e.getGeneratedNameForNode = e.Debug.deprecate(function(w) {
              return e.factory.getGeneratedNameForNode(w, void 0);
            }, a), e.createOptimisticUniqueName = e.Debug.deprecate(function(w) {
              return e.factory.createUniqueName(w, 16);
            }, a), e.createFileLevelUniqueName = e.Debug.deprecate(function(w) {
              return e.factory.createUniqueName(w, 48);
            }, a), e.createIndexSignature = e.Debug.deprecate(function(w, B, E, Q) {
              return e.factory.createIndexSignature(w, B, E, Q);
            }, a), e.createTypePredicateNode = e.Debug.deprecate(function(w, B) {
              return e.factory.createTypePredicateNode(void 0, w, B);
            }, a), e.updateTypePredicateNode = e.Debug.deprecate(function(w, B, E) {
              return e.factory.updateTypePredicateNode(w, void 0, B, E);
            }, a), e.createLiteral = e.Debug.deprecate(function(w) {
              return typeof w == "number" ? e.factory.createNumericLiteral(w) : typeof w == "object" && "base10Value" in w ? e.factory.createBigIntLiteral(w) : typeof w == "boolean" ? w ? e.factory.createTrue() : e.factory.createFalse() : typeof w == "string" ? e.factory.createStringLiteral(w, void 0) : e.factory.createStringLiteralFromNode(w);
            }, { since: "4.0", warnAfter: "4.1", message: "Use `factory.createStringLiteral`, `factory.createStringLiteralFromNode`, `factory.createNumericLiteral`, `factory.createBigIntLiteral`, `factory.createTrue`, `factory.createFalse`, or the factory supplied by your transformation context instead." }), e.createMethodSignature = e.Debug.deprecate(function(w, B, E, Q, le) {
              return e.factory.createMethodSignature(void 0, Q, le, w, B, E);
            }, a), e.updateMethodSignature = e.Debug.deprecate(function(w, B, E, Q, le, N) {
              return e.factory.updateMethodSignature(w, w.modifiers, le, N, B, E, Q);
            }, a), e.createTypeOperatorNode = e.Debug.deprecate(function(w, B) {
              var E;
              return B ? E = w : (B = w, E = 140), e.factory.createTypeOperatorNode(E, B);
            }, a), e.createTaggedTemplate = e.Debug.deprecate(function(w, B, E) {
              var Q;
              return E ? Q = B : E = B, e.factory.createTaggedTemplateExpression(w, Q, E);
            }, a), e.updateTaggedTemplate = e.Debug.deprecate(function(w, B, E, Q) {
              var le;
              return Q ? le = E : Q = E, e.factory.updateTaggedTemplateExpression(w, B, le, Q);
            }, a), e.updateBinary = e.Debug.deprecate(function(w, B, E, Q) {
              return Q === void 0 && (Q = w.operatorToken), typeof Q == "number" && (Q = Q === w.operatorToken.kind ? w.operatorToken : e.factory.createToken(Q)), e.factory.updateBinaryExpression(w, B, Q, E);
            }, a), e.createConditional = e.Debug.deprecate(function(w, B, E, Q, le) {
              return arguments.length === 5 ? e.factory.createConditionalExpression(w, B, E, Q, le) : arguments.length === 3 ? e.factory.createConditionalExpression(w, e.factory.createToken(57), B, e.factory.createToken(58), E) : e.Debug.fail("Argument count mismatch");
            }, a), e.createYield = e.Debug.deprecate(function(w, B) {
              var E;
              return B ? E = w : B = w, e.factory.createYieldExpression(E, B);
            }, a), e.createClassExpression = e.Debug.deprecate(function(w, B, E, Q, le) {
              return e.factory.createClassExpression(void 0, w, B, E, Q, le);
            }, a), e.updateClassExpression = e.Debug.deprecate(function(w, B, E, Q, le, N) {
              return e.factory.updateClassExpression(w, void 0, B, E, Q, le, N);
            }, a), e.createPropertySignature = e.Debug.deprecate(function(w, B, E, Q, le) {
              var N = e.factory.createPropertySignature(w, B, E, Q);
              return N.initializer = le, N;
            }, a), e.updatePropertySignature = e.Debug.deprecate(function(w, B, E, Q, le, N) {
              var p = e.factory.updatePropertySignature(w, B, E, Q, le);
              return w.initializer !== N && (p === w && (p = e.factory.cloneNode(w)), p.initializer = N), p;
            }, a), e.createExpressionWithTypeArguments = e.Debug.deprecate(function(w, B) {
              return e.factory.createExpressionWithTypeArguments(B, w);
            }, a), e.updateExpressionWithTypeArguments = e.Debug.deprecate(function(w, B, E) {
              return e.factory.updateExpressionWithTypeArguments(w, E, B);
            }, a), e.createArrowFunction = e.Debug.deprecate(function(w, B, E, Q, le, N) {
              return arguments.length === 6 ? e.factory.createArrowFunction(w, B, E, Q, le, N) : arguments.length === 5 ? e.factory.createArrowFunction(w, B, E, Q, void 0, le) : e.Debug.fail("Argument count mismatch");
            }, a), e.updateArrowFunction = e.Debug.deprecate(function(w, B, E, Q, le, N, p) {
              return arguments.length === 7 ? e.factory.updateArrowFunction(w, B, E, Q, le, N, p) : arguments.length === 6 ? e.factory.updateArrowFunction(w, B, E, Q, le, w.equalsGreaterThanToken, N) : e.Debug.fail("Argument count mismatch");
            }, a), e.createVariableDeclaration = e.Debug.deprecate(function(w, B, E, Q) {
              return arguments.length === 4 ? e.factory.createVariableDeclaration(w, B, E, Q) : arguments.length >= 1 && arguments.length <= 3 ? e.factory.createVariableDeclaration(w, void 0, B, E) : e.Debug.fail("Argument count mismatch");
            }, a), e.updateVariableDeclaration = e.Debug.deprecate(function(w, B, E, Q, le) {
              return arguments.length === 5 ? e.factory.updateVariableDeclaration(w, B, E, Q, le) : arguments.length === 4 ? e.factory.updateVariableDeclaration(w, B, w.exclamationToken, E, Q) : e.Debug.fail("Argument count mismatch");
            }, a), e.createImportClause = e.Debug.deprecate(function(w, B, E) {
              return E === void 0 && (E = false), e.factory.createImportClause(E, w, B);
            }, a), e.updateImportClause = e.Debug.deprecate(function(w, B, E, Q) {
              return e.factory.updateImportClause(w, Q, B, E);
            }, a), e.createExportDeclaration = e.Debug.deprecate(function(w, B, E, Q, le) {
              return le === void 0 && (le = false), e.factory.createExportDeclaration(w, B, le, E, Q);
            }, a), e.updateExportDeclaration = e.Debug.deprecate(function(w, B, E, Q, le, N) {
              return e.factory.updateExportDeclaration(w, B, E, N, Q, le, w.assertClause);
            }, a), e.createJSDocParamTag = e.Debug.deprecate(function(w, B, E, Q) {
              return e.factory.createJSDocParameterTag(void 0, w, B, E, false, Q ? e.factory.createNodeArray([e.factory.createJSDocText(Q)]) : void 0);
            }, a), e.createComma = e.Debug.deprecate(function(w, B) {
              return e.factory.createComma(w, B);
            }, a), e.createLessThan = e.Debug.deprecate(function(w, B) {
              return e.factory.createLessThan(w, B);
            }, a), e.createAssignment = e.Debug.deprecate(function(w, B) {
              return e.factory.createAssignment(w, B);
            }, a), e.createStrictEquality = e.Debug.deprecate(function(w, B) {
              return e.factory.createStrictEquality(w, B);
            }, a), e.createStrictInequality = e.Debug.deprecate(function(w, B) {
              return e.factory.createStrictInequality(w, B);
            }, a), e.createAdd = e.Debug.deprecate(function(w, B) {
              return e.factory.createAdd(w, B);
            }, a), e.createSubtract = e.Debug.deprecate(function(w, B) {
              return e.factory.createSubtract(w, B);
            }, a), e.createLogicalAnd = e.Debug.deprecate(function(w, B) {
              return e.factory.createLogicalAnd(w, B);
            }, a), e.createLogicalOr = e.Debug.deprecate(function(w, B) {
              return e.factory.createLogicalOr(w, B);
            }, a), e.createPostfixIncrement = e.Debug.deprecate(function(w) {
              return e.factory.createPostfixIncrement(w);
            }, a), e.createLogicalNot = e.Debug.deprecate(function(w) {
              return e.factory.createLogicalNot(w);
            }, a), e.createNode = e.Debug.deprecate(function(w, B, E) {
              return B === void 0 && (B = 0), E === void 0 && (E = 0), e.setTextRangePosEnd(w === 305 ? e.parseBaseNodeFactory.createBaseSourceFileNode(w) : w === 79 ? e.parseBaseNodeFactory.createBaseIdentifierNode(w) : w === 80 ? e.parseBaseNodeFactory.createBasePrivateIdentifierNode(w) : e.isNodeKind(w) ? e.parseBaseNodeFactory.createBaseNode(w) : e.parseBaseNodeFactory.createBaseTokenNode(w), B, E);
            }, { since: "4.0", warnAfter: "4.1", message: "Use an appropriate `factory` method instead." }), e.getMutableClone = e.Debug.deprecate(function(w) {
              var B = e.factory.cloneNode(w);
              return e.setTextRange(B, w), e.setParent(B, w.parent), B;
            }, { since: "4.0", warnAfter: "4.1", message: "Use an appropriate `factory.update...` method instead, use `setCommentRange` or `setSourceMapRange`, and avoid setting `parent`." }), e.isTypeAssertion = e.Debug.deprecate(function(w) {
              return w.kind === 211;
            }, { since: "4.0", warnAfter: "4.1", message: "Use `isTypeAssertionExpression` instead." }), e.isIdentifierOrPrivateIdentifier = e.Debug.deprecate(function(w) {
              return e.isMemberName(w);
            }, { since: "4.2", warnAfter: "4.3", message: "Use `isMemberName` instead." });
          })(ke || (ke = {}));
        } }), $4 = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/@typescript-eslint/types/dist/generated/ast-spec.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.AST_TOKEN_TYPES = M.AST_NODE_TYPES = void 0;
          var re;
          (function(Ke) {
            Ke.ArrayExpression = "ArrayExpression", Ke.ArrayPattern = "ArrayPattern", Ke.ArrowFunctionExpression = "ArrowFunctionExpression", Ke.AssignmentExpression = "AssignmentExpression", Ke.AssignmentPattern = "AssignmentPattern", Ke.AwaitExpression = "AwaitExpression", Ke.BinaryExpression = "BinaryExpression", Ke.BlockStatement = "BlockStatement", Ke.BreakStatement = "BreakStatement", Ke.CallExpression = "CallExpression", Ke.CatchClause = "CatchClause", Ke.ChainExpression = "ChainExpression", Ke.ClassBody = "ClassBody", Ke.ClassDeclaration = "ClassDeclaration", Ke.ClassExpression = "ClassExpression", Ke.ConditionalExpression = "ConditionalExpression", Ke.ContinueStatement = "ContinueStatement", Ke.DebuggerStatement = "DebuggerStatement", Ke.Decorator = "Decorator", Ke.DoWhileStatement = "DoWhileStatement", Ke.EmptyStatement = "EmptyStatement", Ke.ExportAllDeclaration = "ExportAllDeclaration", Ke.ExportDefaultDeclaration = "ExportDefaultDeclaration", Ke.ExportNamedDeclaration = "ExportNamedDeclaration", Ke.ExportSpecifier = "ExportSpecifier", Ke.ExpressionStatement = "ExpressionStatement", Ke.ForInStatement = "ForInStatement", Ke.ForOfStatement = "ForOfStatement", Ke.ForStatement = "ForStatement", Ke.FunctionDeclaration = "FunctionDeclaration", Ke.FunctionExpression = "FunctionExpression", Ke.Identifier = "Identifier", Ke.IfStatement = "IfStatement", Ke.ImportAttribute = "ImportAttribute", Ke.ImportDeclaration = "ImportDeclaration", Ke.ImportDefaultSpecifier = "ImportDefaultSpecifier", Ke.ImportExpression = "ImportExpression", Ke.ImportNamespaceSpecifier = "ImportNamespaceSpecifier", Ke.ImportSpecifier = "ImportSpecifier", Ke.JSXAttribute = "JSXAttribute", Ke.JSXClosingElement = "JSXClosingElement", Ke.JSXClosingFragment = "JSXClosingFragment", Ke.JSXElement = "JSXElement", Ke.JSXEmptyExpression = "JSXEmptyExpression", Ke.JSXExpressionContainer = "JSXExpressionContainer", Ke.JSXFragment = "JSXFragment", Ke.JSXIdentifier = "JSXIdentifier", Ke.JSXMemberExpression = "JSXMemberExpression", Ke.JSXNamespacedName = "JSXNamespacedName", Ke.JSXOpeningElement = "JSXOpeningElement", Ke.JSXOpeningFragment = "JSXOpeningFragment", Ke.JSXSpreadAttribute = "JSXSpreadAttribute", Ke.JSXSpreadChild = "JSXSpreadChild", Ke.JSXText = "JSXText", Ke.LabeledStatement = "LabeledStatement", Ke.Literal = "Literal", Ke.LogicalExpression = "LogicalExpression", Ke.MemberExpression = "MemberExpression", Ke.MetaProperty = "MetaProperty", Ke.MethodDefinition = "MethodDefinition", Ke.NewExpression = "NewExpression", Ke.ObjectExpression = "ObjectExpression", Ke.ObjectPattern = "ObjectPattern", Ke.PrivateIdentifier = "PrivateIdentifier", Ke.Program = "Program", Ke.Property = "Property", Ke.PropertyDefinition = "PropertyDefinition", Ke.RestElement = "RestElement", Ke.ReturnStatement = "ReturnStatement", Ke.SequenceExpression = "SequenceExpression", Ke.SpreadElement = "SpreadElement", Ke.StaticBlock = "StaticBlock", Ke.Super = "Super", Ke.SwitchCase = "SwitchCase", Ke.SwitchStatement = "SwitchStatement", Ke.TaggedTemplateExpression = "TaggedTemplateExpression", Ke.TemplateElement = "TemplateElement", Ke.TemplateLiteral = "TemplateLiteral", Ke.ThisExpression = "ThisExpression", Ke.ThrowStatement = "ThrowStatement", Ke.TryStatement = "TryStatement", Ke.UnaryExpression = "UnaryExpression", Ke.UpdateExpression = "UpdateExpression", Ke.VariableDeclaration = "VariableDeclaration", Ke.VariableDeclarator = "VariableDeclarator", Ke.WhileStatement = "WhileStatement", Ke.WithStatement = "WithStatement", Ke.YieldExpression = "YieldExpression", Ke.TSAbstractKeyword = "TSAbstractKeyword", Ke.TSAbstractMethodDefinition = "TSAbstractMethodDefinition", Ke.TSAbstractPropertyDefinition = "TSAbstractPropertyDefinition", Ke.TSAnyKeyword = "TSAnyKeyword", Ke.TSArrayType = "TSArrayType", Ke.TSAsExpression = "TSAsExpression", Ke.TSAsyncKeyword = "TSAsyncKeyword", Ke.TSBigIntKeyword = "TSBigIntKeyword", Ke.TSBooleanKeyword = "TSBooleanKeyword", Ke.TSCallSignatureDeclaration = "TSCallSignatureDeclaration", Ke.TSClassImplements = "TSClassImplements", Ke.TSConditionalType = "TSConditionalType", Ke.TSConstructorType = "TSConstructorType", Ke.TSConstructSignatureDeclaration = "TSConstructSignatureDeclaration", Ke.TSDeclareFunction = "TSDeclareFunction", Ke.TSDeclareKeyword = "TSDeclareKeyword", Ke.TSEmptyBodyFunctionExpression = "TSEmptyBodyFunctionExpression", Ke.TSEnumDeclaration = "TSEnumDeclaration", Ke.TSEnumMember = "TSEnumMember", Ke.TSExportAssignment = "TSExportAssignment", Ke.TSExportKeyword = "TSExportKeyword", Ke.TSExternalModuleReference = "TSExternalModuleReference", Ke.TSFunctionType = "TSFunctionType", Ke.TSInstantiationExpression = "TSInstantiationExpression", Ke.TSImportEqualsDeclaration = "TSImportEqualsDeclaration", Ke.TSImportType = "TSImportType", Ke.TSIndexedAccessType = "TSIndexedAccessType", Ke.TSIndexSignature = "TSIndexSignature", Ke.TSInferType = "TSInferType", Ke.TSInterfaceBody = "TSInterfaceBody", Ke.TSInterfaceDeclaration = "TSInterfaceDeclaration", Ke.TSInterfaceHeritage = "TSInterfaceHeritage", Ke.TSIntersectionType = "TSIntersectionType", Ke.TSIntrinsicKeyword = "TSIntrinsicKeyword", Ke.TSLiteralType = "TSLiteralType", Ke.TSMappedType = "TSMappedType", Ke.TSMethodSignature = "TSMethodSignature", Ke.TSModuleBlock = "TSModuleBlock", Ke.TSModuleDeclaration = "TSModuleDeclaration", Ke.TSNamedTupleMember = "TSNamedTupleMember", Ke.TSNamespaceExportDeclaration = "TSNamespaceExportDeclaration", Ke.TSNeverKeyword = "TSNeverKeyword", Ke.TSNonNullExpression = "TSNonNullExpression", Ke.TSNullKeyword = "TSNullKeyword", Ke.TSNumberKeyword = "TSNumberKeyword", Ke.TSObjectKeyword = "TSObjectKeyword", Ke.TSOptionalType = "TSOptionalType", Ke.TSParameterProperty = "TSParameterProperty", Ke.TSPrivateKeyword = "TSPrivateKeyword", Ke.TSPropertySignature = "TSPropertySignature", Ke.TSProtectedKeyword = "TSProtectedKeyword", Ke.TSPublicKeyword = "TSPublicKeyword", Ke.TSQualifiedName = "TSQualifiedName", Ke.TSReadonlyKeyword = "TSReadonlyKeyword", Ke.TSRestType = "TSRestType", Ke.TSStaticKeyword = "TSStaticKeyword", Ke.TSStringKeyword = "TSStringKeyword", Ke.TSSymbolKeyword = "TSSymbolKeyword", Ke.TSTemplateLiteralType = "TSTemplateLiteralType", Ke.TSThisType = "TSThisType", Ke.TSTupleType = "TSTupleType", Ke.TSTypeAliasDeclaration = "TSTypeAliasDeclaration", Ke.TSTypeAnnotation = "TSTypeAnnotation", Ke.TSTypeAssertion = "TSTypeAssertion", Ke.TSTypeLiteral = "TSTypeLiteral", Ke.TSTypeOperator = "TSTypeOperator", Ke.TSTypeParameter = "TSTypeParameter", Ke.TSTypeParameterDeclaration = "TSTypeParameterDeclaration", Ke.TSTypeParameterInstantiation = "TSTypeParameterInstantiation", Ke.TSTypePredicate = "TSTypePredicate", Ke.TSTypeQuery = "TSTypeQuery", Ke.TSTypeReference = "TSTypeReference", Ke.TSUndefinedKeyword = "TSUndefinedKeyword", Ke.TSUnionType = "TSUnionType", Ke.TSUnknownKeyword = "TSUnknownKeyword", Ke.TSVoidKeyword = "TSVoidKeyword";
          })(re = M.AST_NODE_TYPES || (M.AST_NODE_TYPES = {}));
          var Ve;
          (function(Ke) {
            Ke.Boolean = "Boolean", Ke.Identifier = "Identifier", Ke.JSXIdentifier = "JSXIdentifier", Ke.JSXText = "JSXText", Ke.Keyword = "Keyword", Ke.Null = "Null", Ke.Numeric = "Numeric", Ke.Punctuator = "Punctuator", Ke.RegularExpression = "RegularExpression", Ke.String = "String", Ke.Template = "Template", Ke.Block = "Block", Ke.Line = "Line";
          })(Ve = M.AST_TOKEN_TYPES || (M.AST_TOKEN_TYPES = {}));
        } }), DU = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/@typescript-eslint/types/dist/lib.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
        } }), bU = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/@typescript-eslint/types/dist/parser-options.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
        } }), SU = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/@typescript-eslint/types/dist/ts-estree.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(oi, kr, pr, Lr) {
            Lr === void 0 && (Lr = pr);
            var ar = Object.getOwnPropertyDescriptor(kr, pr);
            (!ar || ("get" in ar ? !kr.__esModule : ar.writable || ar.configurable)) && (ar = { enumerable: true, get: function() {
              return kr[pr];
            } }), Object.defineProperty(oi, Lr, ar);
          } : function(oi, kr, pr, Lr) {
            Lr === void 0 && (Lr = pr), oi[Lr] = kr[pr];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(oi, kr) {
            Object.defineProperty(oi, "default", { enumerable: true, value: kr });
          } : function(oi, kr) {
            oi.default = kr;
          }), Ke = M && M.__importStar || function(oi) {
            if (oi && oi.__esModule) return oi;
            var kr = {};
            if (oi != null) for (var pr in oi) pr !== "default" && Object.prototype.hasOwnProperty.call(oi, pr) && re(kr, oi, pr);
            return Ve(kr, oi), kr;
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.TSESTree = void 0, M.TSESTree = Ke($4());
        } }), Z4 = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/@typescript-eslint/types/dist/index.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(oi, kr, pr, Lr) {
            Lr === void 0 && (Lr = pr);
            var ar = Object.getOwnPropertyDescriptor(kr, pr);
            (!ar || ("get" in ar ? !kr.__esModule : ar.writable || ar.configurable)) && (ar = { enumerable: true, get: function() {
              return kr[pr];
            } }), Object.defineProperty(oi, Lr, ar);
          } : function(oi, kr, pr, Lr) {
            Lr === void 0 && (Lr = pr), oi[Lr] = kr[pr];
          }), Ve = M && M.__exportStar || function(oi, kr) {
            for (var pr in oi) pr !== "default" && !Object.prototype.hasOwnProperty.call(kr, pr) && re(kr, oi, pr);
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.AST_TOKEN_TYPES = M.AST_NODE_TYPES = void 0;
          var Ke = $4();
          Object.defineProperty(M, "AST_NODE_TYPES", { enumerable: true, get: function() {
            return Ke.AST_NODE_TYPES;
          } }), Object.defineProperty(M, "AST_TOKEN_TYPES", { enumerable: true, get: function() {
            return Ke.AST_TOKEN_TYPES;
          } }), Ve(DU(), M), Ve(bU(), M), Ve(SU(), M);
        } }), TU = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/ts-estree/ts-nodes.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
        } }), xU = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/ts-estree/estree-to-ts-node-types.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
          var re = Z4();
        } }), k1 = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/ts-estree/index.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(oi, kr, pr, Lr) {
            Lr === void 0 && (Lr = pr);
            var ar = Object.getOwnPropertyDescriptor(kr, pr);
            (!ar || ("get" in ar ? !kr.__esModule : ar.writable || ar.configurable)) && (ar = { enumerable: true, get: function() {
              return kr[pr];
            } }), Object.defineProperty(oi, Lr, ar);
          } : function(oi, kr, pr, Lr) {
            Lr === void 0 && (Lr = pr), oi[Lr] = kr[pr];
          }), Ve = M && M.__exportStar || function(oi, kr) {
            for (var pr in oi) pr !== "default" && !Object.prototype.hasOwnProperty.call(kr, pr) && re(kr, oi, pr);
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.TSESTree = M.AST_TOKEN_TYPES = M.AST_NODE_TYPES = void 0;
          var Ke = Z4();
          Object.defineProperty(M, "AST_NODE_TYPES", { enumerable: true, get: function() {
            return Ke.AST_NODE_TYPES;
          } }), Object.defineProperty(M, "AST_TOKEN_TYPES", { enumerable: true, get: function() {
            return Ke.AST_TOKEN_TYPES;
          } }), Object.defineProperty(M, "TSESTree", { enumerable: true, get: function() {
            return Ke.TSESTree;
          } }), Ve(TU(), M), Ve(xU(), M);
        } }), EU = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/jsx/xhtml-entities.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.xhtmlEntities = void 0, M.xhtmlEntities = { quot: '"', amp: "&", apos: "'", lt: "<", gt: ">", nbsp: "\xA0", iexcl: "\xA1", cent: "\xA2", pound: "\xA3", curren: "\xA4", yen: "\xA5", brvbar: "\xA6", sect: "\xA7", uml: "\xA8", copy: "\xA9", ordf: "\xAA", laquo: "\xAB", not: "\xAC", shy: "\xAD", reg: "\xAE", macr: "\xAF", deg: "\xB0", plusmn: "\xB1", sup2: "\xB2", sup3: "\xB3", acute: "\xB4", micro: "\xB5", para: "\xB6", middot: "\xB7", cedil: "\xB8", sup1: "\xB9", ordm: "\xBA", raquo: "\xBB", frac14: "\xBC", frac12: "\xBD", frac34: "\xBE", iquest: "\xBF", Agrave: "\xC0", Aacute: "\xC1", Acirc: "\xC2", Atilde: "\xC3", Auml: "\xC4", Aring: "\xC5", AElig: "\xC6", Ccedil: "\xC7", Egrave: "\xC8", Eacute: "\xC9", Ecirc: "\xCA", Euml: "\xCB", Igrave: "\xCC", Iacute: "\xCD", Icirc: "\xCE", Iuml: "\xCF", ETH: "\xD0", Ntilde: "\xD1", Ograve: "\xD2", Oacute: "\xD3", Ocirc: "\xD4", Otilde: "\xD5", Ouml: "\xD6", times: "\xD7", Oslash: "\xD8", Ugrave: "\xD9", Uacute: "\xDA", Ucirc: "\xDB", Uuml: "\xDC", Yacute: "\xDD", THORN: "\xDE", szlig: "\xDF", agrave: "\xE0", aacute: "\xE1", acirc: "\xE2", atilde: "\xE3", auml: "\xE4", aring: "\xE5", aelig: "\xE6", ccedil: "\xE7", egrave: "\xE8", eacute: "\xE9", ecirc: "\xEA", euml: "\xEB", igrave: "\xEC", iacute: "\xED", icirc: "\xEE", iuml: "\xEF", eth: "\xF0", ntilde: "\xF1", ograve: "\xF2", oacute: "\xF3", ocirc: "\xF4", otilde: "\xF5", ouml: "\xF6", divide: "\xF7", oslash: "\xF8", ugrave: "\xF9", uacute: "\xFA", ucirc: "\xFB", uuml: "\xFC", yacute: "\xFD", thorn: "\xFE", yuml: "\xFF", OElig: "\u0152", oelig: "\u0153", Scaron: "\u0160", scaron: "\u0161", Yuml: "\u0178", fnof: "\u0192", circ: "\u02C6", tilde: "\u02DC", Alpha: "\u0391", Beta: "\u0392", Gamma: "\u0393", Delta: "\u0394", Epsilon: "\u0395", Zeta: "\u0396", Eta: "\u0397", Theta: "\u0398", Iota: "\u0399", Kappa: "\u039A", Lambda: "\u039B", Mu: "\u039C", Nu: "\u039D", Xi: "\u039E", Omicron: "\u039F", Pi: "\u03A0", Rho: "\u03A1", Sigma: "\u03A3", Tau: "\u03A4", Upsilon: "\u03A5", Phi: "\u03A6", Chi: "\u03A7", Psi: "\u03A8", Omega: "\u03A9", alpha: "\u03B1", beta: "\u03B2", gamma: "\u03B3", delta: "\u03B4", epsilon: "\u03B5", zeta: "\u03B6", eta: "\u03B7", theta: "\u03B8", iota: "\u03B9", kappa: "\u03BA", lambda: "\u03BB", mu: "\u03BC", nu: "\u03BD", xi: "\u03BE", omicron: "\u03BF", pi: "\u03C0", rho: "\u03C1", sigmaf: "\u03C2", sigma: "\u03C3", tau: "\u03C4", upsilon: "\u03C5", phi: "\u03C6", chi: "\u03C7", psi: "\u03C8", omega: "\u03C9", thetasym: "\u03D1", upsih: "\u03D2", piv: "\u03D6", ensp: "\u2002", emsp: "\u2003", thinsp: "\u2009", zwnj: "\u200C", zwj: "\u200D", lrm: "\u200E", rlm: "\u200F", ndash: "\u2013", mdash: "\u2014", lsquo: "\u2018", rsquo: "\u2019", sbquo: "\u201A", ldquo: "\u201C", rdquo: "\u201D", bdquo: "\u201E", dagger: "\u2020", Dagger: "\u2021", bull: "\u2022", hellip: "\u2026", permil: "\u2030", prime: "\u2032", Prime: "\u2033", lsaquo: "\u2039", rsaquo: "\u203A", oline: "\u203E", frasl: "\u2044", euro: "\u20AC", image: "\u2111", weierp: "\u2118", real: "\u211C", trade: "\u2122", alefsym: "\u2135", larr: "\u2190", uarr: "\u2191", rarr: "\u2192", darr: "\u2193", harr: "\u2194", crarr: "\u21B5", lArr: "\u21D0", uArr: "\u21D1", rArr: "\u21D2", dArr: "\u21D3", hArr: "\u21D4", forall: "\u2200", part: "\u2202", exist: "\u2203", empty: "\u2205", nabla: "\u2207", isin: "\u2208", notin: "\u2209", ni: "\u220B", prod: "\u220F", sum: "\u2211", minus: "\u2212", lowast: "\u2217", radic: "\u221A", prop: "\u221D", infin: "\u221E", ang: "\u2220", and: "\u2227", or: "\u2228", cap: "\u2229", cup: "\u222A", int: "\u222B", there4: "\u2234", sim: "\u223C", cong: "\u2245", asymp: "\u2248", ne: "\u2260", equiv: "\u2261", le: "\u2264", ge: "\u2265", sub: "\u2282", sup: "\u2283", nsub: "\u2284", sube: "\u2286", supe: "\u2287", oplus: "\u2295", otimes: "\u2297", perp: "\u22A5", sdot: "\u22C5", lceil: "\u2308", rceil: "\u2309", lfloor: "\u230A", rfloor: "\u230B", lang: "\u2329", rang: "\u232A", loz: "\u25CA", spades: "\u2660", clubs: "\u2663", hearts: "\u2665", diams: "\u2666" };
        } }), A1 = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/node-utils.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(V, L, P, k) {
            k === void 0 && (k = P);
            var Y = Object.getOwnPropertyDescriptor(L, P);
            (!Y || ("get" in Y ? !L.__esModule : Y.writable || Y.configurable)) && (Y = { enumerable: true, get: function() {
              return L[P];
            } }), Object.defineProperty(V, k, Y);
          } : function(V, L, P, k) {
            k === void 0 && (k = P), V[k] = L[P];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(V, L) {
            Object.defineProperty(V, "default", { enumerable: true, value: L });
          } : function(V, L) {
            V.default = L;
          }), Ke = M && M.__importStar || function(V) {
            if (V && V.__esModule) return V;
            var L = {};
            if (V != null) for (var P in V) P !== "default" && Object.prototype.hasOwnProperty.call(V, P) && re(L, V, P);
            return Ve(L, V), L;
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.firstDefined = M.nodeHasTokens = M.createError = M.TSError = M.convertTokens = M.convertToken = M.getTokenType = M.isChildUnwrappableOptionalChain = M.isChainExpression = M.isOptional = M.isComputedProperty = M.unescapeStringLiteralText = M.hasJSXAncestor = M.findFirstMatchingAncestor = M.findNextToken = M.getTSNodeAccessibility = M.getDeclarationKind = M.isJSXToken = M.isToken = M.getRange = M.canContainDirective = M.getLocFor = M.getLineAndCharacterFor = M.getBinaryExpressionType = M.isJSDocComment = M.isComment = M.isComma = M.getLastModifier = M.hasModifier = M.isESTreeClassMember = M.getTextForTokenKind = M.isLogicalOperator = M.isAssignmentOperator = void 0;
          var oi = Ke(_u()), kr = k1(), pr = EU(), Lr = oi.SyntaxKind, ar = [Lr.BarBarToken, Lr.AmpersandAmpersandToken, Lr.QuestionQuestionToken];
          function ke(V) {
            return V.kind >= Lr.FirstAssignment && V.kind <= Lr.LastAssignment;
          }
          M.isAssignmentOperator = ke;
          function e(V) {
            return ar.includes(V.kind);
          }
          M.isLogicalOperator = e;
          function a(V) {
            return oi.tokenToString(V);
          }
          M.getTextForTokenKind = a;
          function C(V) {
            return V.kind !== Lr.SemicolonClassElement;
          }
          M.isESTreeClassMember = C;
          function w(V, L) {
            return !!L.modifiers && !!L.modifiers.length && L.modifiers.some((P) => P.kind === V);
          }
          M.hasModifier = w;
          function B(V) {
            return !!V.modifiers && !!V.modifiers.length && V.modifiers[V.modifiers.length - 1] || null;
          }
          M.getLastModifier = B;
          function E(V) {
            return V.kind === Lr.CommaToken;
          }
          M.isComma = E;
          function Q(V) {
            return V.kind === Lr.SingleLineCommentTrivia || V.kind === Lr.MultiLineCommentTrivia;
          }
          M.isComment = Q;
          function le(V) {
            return V.kind === Lr.JSDocComment;
          }
          M.isJSDocComment = le;
          function N(V) {
            return ke(V) ? kr.AST_NODE_TYPES.AssignmentExpression : e(V) ? kr.AST_NODE_TYPES.LogicalExpression : kr.AST_NODE_TYPES.BinaryExpression;
          }
          M.getBinaryExpressionType = N;
          function p(V, L) {
            let P = L.getLineAndCharacterOfPosition(V);
            return { line: P.line + 1, column: P.character };
          }
          M.getLineAndCharacterFor = p;
          function m(V, L, P) {
            return { start: p(V, P), end: p(L, P) };
          }
          M.getLocFor = m;
          function G(V) {
            if (V.kind === oi.SyntaxKind.Block) switch (V.parent.kind) {
              case oi.SyntaxKind.Constructor:
              case oi.SyntaxKind.GetAccessor:
              case oi.SyntaxKind.SetAccessor:
              case oi.SyntaxKind.ArrowFunction:
              case oi.SyntaxKind.FunctionExpression:
              case oi.SyntaxKind.FunctionDeclaration:
              case oi.SyntaxKind.MethodDeclaration:
                return true;
              default:
                return false;
            }
            return true;
          }
          M.canContainDirective = G;
          function oe(V, L) {
            return [V.getStart(L), V.getEnd()];
          }
          M.getRange = oe;
          function f(V) {
            return V.kind >= Lr.FirstToken && V.kind <= Lr.LastToken;
          }
          M.isToken = f;
          function T(V) {
            return V.kind >= Lr.JsxElement && V.kind <= Lr.JsxAttribute;
          }
          M.isJSXToken = T;
          function K(V) {
            return V.flags & oi.NodeFlags.Let ? "let" : V.flags & oi.NodeFlags.Const ? "const" : "var";
          }
          M.getDeclarationKind = K;
          function b(V) {
            let L = V.modifiers;
            if (!L) return null;
            for (let P of L) switch (P.kind) {
              case Lr.PublicKeyword:
                return "public";
              case Lr.ProtectedKeyword:
                return "protected";
              case Lr.PrivateKeyword:
                return "private";
              default:
                break;
            }
            return null;
          }
          M.getTSNodeAccessibility = b;
          function se(V, L, P) {
            return k(L);
            function k(Y) {
              return oi.isToken(Y) && Y.pos === V.end ? Y : y(Y.getChildren(P), (U) => (U.pos <= V.pos && U.end > V.end || U.pos === V.end) && A(U, P) ? k(U) : void 0);
            }
          }
          M.findNextToken = se;
          function J(V, L) {
            for (; V; ) {
              if (L(V)) return V;
              V = V.parent;
            }
          }
          M.findFirstMatchingAncestor = J;
          function ie(V) {
            return !!J(V, T);
          }
          M.hasJSXAncestor = ie;
          function R(V) {
            return V.replace(/&(?:#\d+|#x[\da-fA-F]+|[0-9a-zA-Z]+);/g, (L) => {
              let P = L.slice(1, -1);
              if (P[0] === "#") {
                let k = P[1] === "x" ? parseInt(P.slice(2), 16) : parseInt(P.slice(1), 10);
                return k > 1114111 ? L : String.fromCodePoint(k);
              }
              return pr.xhtmlEntities[P] || L;
            });
          }
          M.unescapeStringLiteralText = R;
          function q(V) {
            return V.kind === Lr.ComputedPropertyName;
          }
          M.isComputedProperty = q;
          function O(V) {
            return V.questionToken ? V.questionToken.kind === Lr.QuestionToken : false;
          }
          M.isOptional = O;
          function ve(V) {
            return V.type === kr.AST_NODE_TYPES.ChainExpression;
          }
          M.isChainExpression = ve;
          function ee(V, L) {
            return ve(L) && V.expression.kind !== oi.SyntaxKind.ParenthesizedExpression;
          }
          M.isChildUnwrappableOptionalChain = ee;
          function he(V) {
            if ("originalKeywordKind" in V && V.originalKeywordKind) return V.originalKeywordKind === Lr.NullKeyword ? kr.AST_TOKEN_TYPES.Null : V.originalKeywordKind >= Lr.FirstFutureReservedWord && V.originalKeywordKind <= Lr.LastKeyword ? kr.AST_TOKEN_TYPES.Identifier : kr.AST_TOKEN_TYPES.Keyword;
            if (V.kind >= Lr.FirstKeyword && V.kind <= Lr.LastFutureReservedWord) return V.kind === Lr.FalseKeyword || V.kind === Lr.TrueKeyword ? kr.AST_TOKEN_TYPES.Boolean : kr.AST_TOKEN_TYPES.Keyword;
            if (V.kind >= Lr.FirstPunctuation && V.kind <= Lr.LastPunctuation) return kr.AST_TOKEN_TYPES.Punctuator;
            if (V.kind >= Lr.NoSubstitutionTemplateLiteral && V.kind <= Lr.TemplateTail) return kr.AST_TOKEN_TYPES.Template;
            switch (V.kind) {
              case Lr.NumericLiteral:
                return kr.AST_TOKEN_TYPES.Numeric;
              case Lr.JsxText:
                return kr.AST_TOKEN_TYPES.JSXText;
              case Lr.StringLiteral:
                return V.parent && (V.parent.kind === Lr.JsxAttribute || V.parent.kind === Lr.JsxElement) ? kr.AST_TOKEN_TYPES.JSXText : kr.AST_TOKEN_TYPES.String;
              case Lr.RegularExpressionLiteral:
                return kr.AST_TOKEN_TYPES.RegularExpression;
              case Lr.Identifier:
              case Lr.ConstructorKeyword:
              case Lr.GetKeyword:
              case Lr.SetKeyword:
              default:
            }
            return V.parent && V.kind === Lr.Identifier && (T(V.parent) || V.parent.kind === Lr.PropertyAccessExpression && ie(V)) ? kr.AST_TOKEN_TYPES.JSXIdentifier : kr.AST_TOKEN_TYPES.Identifier;
          }
          M.getTokenType = he;
          function F(V, L) {
            let P = V.kind === Lr.JsxText ? V.getFullStart() : V.getStart(L), k = V.getEnd(), Y = L.text.slice(P, k), U = he(V);
            return U === kr.AST_TOKEN_TYPES.RegularExpression ? { type: U, value: Y, range: [P, k], loc: m(P, k, L), regex: { pattern: Y.slice(1, Y.lastIndexOf("/")), flags: Y.slice(Y.lastIndexOf("/") + 1) } } : { type: U, value: Y, range: [P, k], loc: m(P, k, L) };
          }
          M.convertToken = F;
          function x(V) {
            let L = [];
            function P(k) {
              if (!(Q(k) || le(k))) if (f(k) && k.kind !== Lr.EndOfFileToken) {
                let Y = F(k, V);
                Y && L.push(Y);
              } else k.getChildren(V).forEach(P);
            }
            return P(V), L;
          }
          M.convertTokens = x;
          var X = class extends Error {
            constructor(V, L, P, k, Y) {
              super(V), this.fileName = L, this.index = P, this.lineNumber = k, this.column = Y, Object.defineProperty(this, "name", { value: new.target.name, enumerable: false, configurable: true });
            }
          };
          M.TSError = X;
          function $(V, L, P) {
            let k = V.getLineAndCharacterOfPosition(L);
            return new X(P, V.fileName, L, k.line + 1, k.character);
          }
          M.createError = $;
          function A(V, L) {
            return V.kind === Lr.EndOfFileToken ? !!V.jsDoc : V.getWidth(L) !== 0;
          }
          M.nodeHasTokens = A;
          function y(V, L) {
            if (V !== void 0) for (let P = 0; P < V.length; P++) {
              let k = L(V[P], P);
              if (k !== void 0) return k;
            }
          }
          M.firstDefined = y;
        } }), CU = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/version-check.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(ar, ke, e, a) {
            a === void 0 && (a = e);
            var C = Object.getOwnPropertyDescriptor(ke, e);
            (!C || ("get" in C ? !ke.__esModule : C.writable || C.configurable)) && (C = { enumerable: true, get: function() {
              return ke[e];
            } }), Object.defineProperty(ar, a, C);
          } : function(ar, ke, e, a) {
            a === void 0 && (a = e), ar[a] = ke[e];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(ar, ke) {
            Object.defineProperty(ar, "default", { enumerable: true, value: ke });
          } : function(ar, ke) {
            ar.default = ke;
          }), Ke = M && M.__importStar || function(ar) {
            if (ar && ar.__esModule) return ar;
            var ke = {};
            if (ar != null) for (var e in ar) e !== "default" && Object.prototype.hasOwnProperty.call(ar, e) && re(ke, ar, e);
            return Ve(ke, ar), ke;
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.typescriptVersionIsAtLeast = void 0;
          var oi = Ke(QT()), kr = Ke(_u()), pr = ["3.7", "3.8", "3.9", "4.0"], Lr = {};
          M.typescriptVersionIsAtLeast = Lr;
          for (let ar of pr) Lr[ar] = true;
        } }), e3 = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/convert.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(a, C, w, B) {
            B === void 0 && (B = w);
            var E = Object.getOwnPropertyDescriptor(C, w);
            (!E || ("get" in E ? !C.__esModule : E.writable || E.configurable)) && (E = { enumerable: true, get: function() {
              return C[w];
            } }), Object.defineProperty(a, B, E);
          } : function(a, C, w, B) {
            B === void 0 && (B = w), a[B] = C[w];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(a, C) {
            Object.defineProperty(a, "default", { enumerable: true, value: C });
          } : function(a, C) {
            a.default = C;
          }), Ke = M && M.__importStar || function(a) {
            if (a && a.__esModule) return a;
            var C = {};
            if (a != null) for (var w in a) w !== "default" && Object.prototype.hasOwnProperty.call(a, w) && re(C, a, w);
            return Ve(C, a), C;
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.Converter = M.convertError = void 0;
          var oi = Ke(_u()), kr = A1(), pr = k1(), Lr = CU(), ar = oi.SyntaxKind;
          function ke(a) {
            return (0, kr.createError)(a.file, a.start, "message" in a && a.message || a.messageText);
          }
          M.convertError = ke;
          var e = class {
            constructor(a, C) {
              this.esTreeNodeToTSNodeMap = /* @__PURE__ */ new WeakMap(), this.tsNodeToESTreeNodeMap = /* @__PURE__ */ new WeakMap(), this.allowPattern = false, this.inTypeMode = false, this.ast = a, this.options = Object.assign({}, C);
            }
            getASTMaps() {
              return { esTreeNodeToTSNodeMap: this.esTreeNodeToTSNodeMap, tsNodeToESTreeNodeMap: this.tsNodeToESTreeNodeMap };
            }
            convertProgram() {
              return this.converter(this.ast);
            }
            converter(a, C, w, B) {
              if (!a) return null;
              let E = this.inTypeMode, Q = this.allowPattern;
              w !== void 0 && (this.inTypeMode = w), B !== void 0 && (this.allowPattern = B);
              let le = this.convertNode(a, C != null ? C : a.parent);
              return this.registerTSNodeInNodeMap(a, le), this.inTypeMode = E, this.allowPattern = Q, le;
            }
            fixExports(a, C) {
              if (a.modifiers && a.modifiers[0].kind === ar.ExportKeyword) {
                this.registerTSNodeInNodeMap(a, C);
                let w = a.modifiers[0], B = a.modifiers[1], E = B && B.kind === ar.DefaultKeyword, Q = E ? (0, kr.findNextToken)(B, this.ast, this.ast) : (0, kr.findNextToken)(w, this.ast, this.ast);
                if (C.range[0] = Q.getStart(this.ast), C.loc = (0, kr.getLocFor)(C.range[0], C.range[1], this.ast), E) return this.createNode(a, { type: pr.AST_NODE_TYPES.ExportDefaultDeclaration, declaration: C, range: [w.getStart(this.ast), C.range[1]], exportKind: "value" });
                {
                  let le = C.type === pr.AST_NODE_TYPES.TSInterfaceDeclaration || C.type === pr.AST_NODE_TYPES.TSTypeAliasDeclaration, N = "declare" in C && C.declare === true;
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ExportNamedDeclaration, declaration: C, specifiers: [], source: null, exportKind: le || N ? "type" : "value", range: [w.getStart(this.ast), C.range[1]], assertions: [] });
                }
              }
              return C;
            }
            registerTSNodeInNodeMap(a, C) {
              C && this.options.shouldPreserveNodeMaps && (this.tsNodeToESTreeNodeMap.has(a) || this.tsNodeToESTreeNodeMap.set(a, C));
            }
            convertPattern(a, C) {
              return this.converter(a, C, this.inTypeMode, true);
            }
            convertChild(a, C) {
              return this.converter(a, C, this.inTypeMode, false);
            }
            convertType(a, C) {
              return this.converter(a, C, true, false);
            }
            createNode(a, C) {
              let w = C;
              return w.range || (w.range = (0, kr.getRange)(a, this.ast)), w.loc || (w.loc = (0, kr.getLocFor)(w.range[0], w.range[1], this.ast)), w && this.options.shouldPreserveNodeMaps && this.esTreeNodeToTSNodeMap.set(w, a), w;
            }
            convertBindingNameWithTypeAnnotation(a, C, w) {
              let B = this.convertPattern(a);
              return C && (B.typeAnnotation = this.convertTypeAnnotation(C, w), this.fixParentLocation(B, B.typeAnnotation.range)), B;
            }
            convertTypeAnnotation(a, C) {
              let w = (C == null ? void 0 : C.kind) === ar.FunctionType || (C == null ? void 0 : C.kind) === ar.ConstructorType ? 2 : 1, B = a.getFullStart() - w, E = (0, kr.getLocFor)(B, a.end, this.ast);
              return { type: pr.AST_NODE_TYPES.TSTypeAnnotation, loc: E, range: [B, a.end], typeAnnotation: this.convertType(a) };
            }
            convertBodyExpressions(a, C) {
              let w = (0, kr.canContainDirective)(C);
              return a.map((B) => {
                let E = this.convertChild(B);
                if (w) if ((E == null ? void 0 : E.expression) && oi.isExpressionStatement(B) && oi.isStringLiteral(B.expression)) {
                  let Q = E.expression.raw;
                  return E.directive = Q.slice(1, -1), E;
                } else w = false;
                return E;
              }).filter((B) => B);
            }
            convertTypeArgumentsToTypeParameters(a, C) {
              let w = (0, kr.findNextToken)(a, this.ast, this.ast);
              return this.createNode(C, { type: pr.AST_NODE_TYPES.TSTypeParameterInstantiation, range: [a.pos - 1, w.end], params: a.map((B) => this.convertType(B)) });
            }
            convertTSTypeParametersToTypeParametersDeclaration(a) {
              let C = (0, kr.findNextToken)(a, this.ast, this.ast);
              return { type: pr.AST_NODE_TYPES.TSTypeParameterDeclaration, range: [a.pos - 1, C.end], loc: (0, kr.getLocFor)(a.pos - 1, C.end, this.ast), params: a.map((w) => this.convertType(w)) };
            }
            convertParameters(a) {
              return !a || !a.length ? [] : a.map((C) => {
                var w;
                let B = this.convertChild(C);
                return !((w = C.decorators) === null || w === void 0) && w.length && (B.decorators = C.decorators.map((E) => this.convertChild(E))), B;
              });
            }
            convertChainExpression(a, C) {
              let { child: w, isOptional: B } = (() => a.type === pr.AST_NODE_TYPES.MemberExpression ? { child: a.object, isOptional: a.optional } : a.type === pr.AST_NODE_TYPES.CallExpression ? { child: a.callee, isOptional: a.optional } : { child: a.expression, isOptional: false })(), E = (0, kr.isChildUnwrappableOptionalChain)(C, w);
              if (!E && !B) return a;
              if (E && (0, kr.isChainExpression)(w)) {
                let Q = w.expression;
                a.type === pr.AST_NODE_TYPES.MemberExpression ? a.object = Q : a.type === pr.AST_NODE_TYPES.CallExpression ? a.callee = Q : a.expression = Q;
              }
              return this.createNode(C, { type: pr.AST_NODE_TYPES.ChainExpression, expression: a });
            }
            deeplyCopy(a) {
              if (a.kind === oi.SyntaxKind.JSDocFunctionType) throw (0, kr.createError)(this.ast, a.pos, "JSDoc types can only be used inside documentation comments.");
              let C = "TS".concat(ar[a.kind]);
              if (this.options.errorOnUnknownASTType && !pr.AST_NODE_TYPES[C]) throw new Error('Unknown AST_NODE_TYPE: "'.concat(C, '"'));
              let w = this.createNode(a, { type: C });
              return "type" in a && (w.typeAnnotation = a.type && "kind" in a.type && oi.isTypeNode(a.type) ? this.convertTypeAnnotation(a.type, a) : null), "typeArguments" in a && (w.typeParameters = a.typeArguments && "pos" in a.typeArguments ? this.convertTypeArgumentsToTypeParameters(a.typeArguments, a) : null), "typeParameters" in a && (w.typeParameters = a.typeParameters && "pos" in a.typeParameters ? this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters) : null), "decorators" in a && a.decorators && a.decorators.length && (w.decorators = a.decorators.map((B) => this.convertChild(B))), Object.entries(a).filter((B) => {
                let [E] = B;
                return !/^(?:_children|kind|parent|pos|end|flags|modifierFlagsCache|jsDoc|type|typeArguments|typeParameters|decorators|transformFlags)$/.test(E);
              }).forEach((B) => {
                let [E, Q] = B;
                Array.isArray(Q) ? w[E] = Q.map((le) => this.convertChild(le)) : Q && typeof Q == "object" && Q.kind ? w[E] = this.convertChild(Q) : w[E] = Q;
              }), w;
            }
            convertJSXIdentifier(a) {
              let C = this.createNode(a, { type: pr.AST_NODE_TYPES.JSXIdentifier, name: a.getText() });
              return this.registerTSNodeInNodeMap(a, C), C;
            }
            convertJSXNamespaceOrIdentifier(a) {
              let C = a.getText(), w = C.indexOf(":");
              if (w > 0) {
                let B = (0, kr.getRange)(a, this.ast), E = this.createNode(a, { type: pr.AST_NODE_TYPES.JSXNamespacedName, namespace: this.createNode(a, { type: pr.AST_NODE_TYPES.JSXIdentifier, name: C.slice(0, w), range: [B[0], B[0] + w] }), name: this.createNode(a, { type: pr.AST_NODE_TYPES.JSXIdentifier, name: C.slice(w + 1), range: [B[0] + w + 1, B[1]] }), range: B });
                return this.registerTSNodeInNodeMap(a, E), E;
              }
              return this.convertJSXIdentifier(a);
            }
            convertJSXTagName(a, C) {
              let w;
              switch (a.kind) {
                case ar.PropertyAccessExpression:
                  if (a.name.kind === ar.PrivateIdentifier) throw new Error("Non-private identifier expected.");
                  w = this.createNode(a, { type: pr.AST_NODE_TYPES.JSXMemberExpression, object: this.convertJSXTagName(a.expression, C), property: this.convertJSXIdentifier(a.name) });
                  break;
                case ar.ThisKeyword:
                case ar.Identifier:
                default:
                  return this.convertJSXNamespaceOrIdentifier(a);
              }
              return this.registerTSNodeInNodeMap(a, w), w;
            }
            convertMethodSignature(a) {
              let C = this.createNode(a, { type: pr.AST_NODE_TYPES.TSMethodSignature, computed: (0, kr.isComputedProperty)(a.name), key: this.convertChild(a.name), params: this.convertParameters(a.parameters), kind: (() => {
                switch (a.kind) {
                  case ar.GetAccessor:
                    return "get";
                  case ar.SetAccessor:
                    return "set";
                  case ar.MethodSignature:
                    return "method";
                }
              })() });
              (0, kr.isOptional)(a) && (C.optional = true), a.type && (C.returnType = this.convertTypeAnnotation(a.type, a)), (0, kr.hasModifier)(ar.ReadonlyKeyword, a) && (C.readonly = true), a.typeParameters && (C.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters));
              let w = (0, kr.getTSNodeAccessibility)(a);
              return w && (C.accessibility = w), (0, kr.hasModifier)(ar.ExportKeyword, a) && (C.export = true), (0, kr.hasModifier)(ar.StaticKeyword, a) && (C.static = true), C;
            }
            convertAssertClasue(a) {
              return a === void 0 ? [] : a.elements.map((C) => this.convertChild(C));
            }
            applyModifiersToResult(a, C) {
              if (!C || !C.length) return;
              let w = [];
              for (let B of C) switch (B.kind) {
                case ar.ExportKeyword:
                case ar.DefaultKeyword:
                  break;
                case ar.ConstKeyword:
                  a.const = true;
                  break;
                case ar.DeclareKeyword:
                  a.declare = true;
                  break;
                default:
                  w.push(this.convertChild(B));
                  break;
              }
              w.length && (a.modifiers = w);
            }
            fixParentLocation(a, C) {
              C[0] < a.range[0] && (a.range[0] = C[0], a.loc.start = (0, kr.getLineAndCharacterFor)(a.range[0], this.ast)), C[1] > a.range[1] && (a.range[1] = C[1], a.loc.end = (0, kr.getLineAndCharacterFor)(a.range[1], this.ast));
            }
            assertModuleSpecifier(a, C) {
              var w;
              if (!C && a.moduleSpecifier == null) throw (0, kr.createError)(this.ast, a.pos, "Module specifier must be a string literal.");
              if (a.moduleSpecifier && ((w = a.moduleSpecifier) === null || w === void 0 ? void 0 : w.kind) !== ar.StringLiteral) throw (0, kr.createError)(this.ast, a.moduleSpecifier.pos, "Module specifier must be a string literal.");
            }
            convertNode(a, C) {
              var w, B, E, Q, le, N, p, m, G, oe;
              switch (a.kind) {
                case ar.SourceFile:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Program, body: this.convertBodyExpressions(a.statements, a), sourceType: a.externalModuleIndicator ? "module" : "script", range: [a.getStart(this.ast), a.endOfFileToken.end] });
                case ar.Block:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.BlockStatement, body: this.convertBodyExpressions(a.statements, a) });
                case ar.Identifier:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Identifier, name: a.text });
                case ar.PrivateIdentifier:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.PrivateIdentifier, name: a.text.slice(1) });
                case ar.WithStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.WithStatement, object: this.convertChild(a.expression), body: this.convertChild(a.statement) });
                case ar.ReturnStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ReturnStatement, argument: this.convertChild(a.expression) });
                case ar.LabeledStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.LabeledStatement, label: this.convertChild(a.label), body: this.convertChild(a.statement) });
                case ar.ContinueStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ContinueStatement, label: this.convertChild(a.label) });
                case ar.BreakStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.BreakStatement, label: this.convertChild(a.label) });
                case ar.IfStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.IfStatement, test: this.convertChild(a.expression), consequent: this.convertChild(a.thenStatement), alternate: this.convertChild(a.elseStatement) });
                case ar.SwitchStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.SwitchStatement, discriminant: this.convertChild(a.expression), cases: a.caseBlock.clauses.map((f) => this.convertChild(f)) });
                case ar.CaseClause:
                case ar.DefaultClause:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.SwitchCase, test: a.kind === ar.CaseClause ? this.convertChild(a.expression) : null, consequent: a.statements.map((f) => this.convertChild(f)) });
                case ar.ThrowStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ThrowStatement, argument: this.convertChild(a.expression) });
                case ar.TryStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TryStatement, block: this.convertChild(a.tryBlock), handler: this.convertChild(a.catchClause), finalizer: this.convertChild(a.finallyBlock) });
                case ar.CatchClause:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.CatchClause, param: a.variableDeclaration ? this.convertBindingNameWithTypeAnnotation(a.variableDeclaration.name, a.variableDeclaration.type) : null, body: this.convertChild(a.block) });
                case ar.WhileStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.WhileStatement, test: this.convertChild(a.expression), body: this.convertChild(a.statement) });
                case ar.DoStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.DoWhileStatement, test: this.convertChild(a.expression), body: this.convertChild(a.statement) });
                case ar.ForStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ForStatement, init: this.convertChild(a.initializer), test: this.convertChild(a.condition), update: this.convertChild(a.incrementor), body: this.convertChild(a.statement) });
                case ar.ForInStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ForInStatement, left: this.convertPattern(a.initializer), right: this.convertChild(a.expression), body: this.convertChild(a.statement) });
                case ar.ForOfStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ForOfStatement, left: this.convertPattern(a.initializer), right: this.convertChild(a.expression), body: this.convertChild(a.statement), await: Boolean(a.awaitModifier && a.awaitModifier.kind === ar.AwaitKeyword) });
                case ar.FunctionDeclaration: {
                  let f = (0, kr.hasModifier)(ar.DeclareKeyword, a), T = this.createNode(a, { type: f || !a.body ? pr.AST_NODE_TYPES.TSDeclareFunction : pr.AST_NODE_TYPES.FunctionDeclaration, id: this.convertChild(a.name), generator: !!a.asteriskToken, expression: false, async: (0, kr.hasModifier)(ar.AsyncKeyword, a), params: this.convertParameters(a.parameters), body: this.convertChild(a.body) || void 0 });
                  return a.type && (T.returnType = this.convertTypeAnnotation(a.type, a)), a.typeParameters && (T.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters)), f && (T.declare = true), this.fixExports(a, T);
                }
                case ar.VariableDeclaration: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.VariableDeclarator, id: this.convertBindingNameWithTypeAnnotation(a.name, a.type, a), init: this.convertChild(a.initializer) });
                  return a.exclamationToken && (f.definite = true), f;
                }
                case ar.VariableStatement: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.VariableDeclaration, declarations: a.declarationList.declarations.map((T) => this.convertChild(T)), kind: (0, kr.getDeclarationKind)(a.declarationList) });
                  return a.decorators && (f.decorators = a.decorators.map((T) => this.convertChild(T))), (0, kr.hasModifier)(ar.DeclareKeyword, a) && (f.declare = true), this.fixExports(a, f);
                }
                case ar.VariableDeclarationList:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.VariableDeclaration, declarations: a.declarations.map((f) => this.convertChild(f)), kind: (0, kr.getDeclarationKind)(a) });
                case ar.ExpressionStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ExpressionStatement, expression: this.convertChild(a.expression) });
                case ar.ThisKeyword:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ThisExpression });
                case ar.ArrayLiteralExpression:
                  return this.allowPattern ? this.createNode(a, { type: pr.AST_NODE_TYPES.ArrayPattern, elements: a.elements.map((f) => this.convertPattern(f)) }) : this.createNode(a, { type: pr.AST_NODE_TYPES.ArrayExpression, elements: a.elements.map((f) => this.convertChild(f)) });
                case ar.ObjectLiteralExpression:
                  return this.allowPattern ? this.createNode(a, { type: pr.AST_NODE_TYPES.ObjectPattern, properties: a.properties.map((f) => this.convertPattern(f)) }) : this.createNode(a, { type: pr.AST_NODE_TYPES.ObjectExpression, properties: a.properties.map((f) => this.convertChild(f)) });
                case ar.PropertyAssignment:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Property, key: this.convertChild(a.name), value: this.converter(a.initializer, a, this.inTypeMode, this.allowPattern), computed: (0, kr.isComputedProperty)(a.name), method: false, shorthand: false, kind: "init" });
                case ar.ShorthandPropertyAssignment:
                  return a.objectAssignmentInitializer ? this.createNode(a, { type: pr.AST_NODE_TYPES.Property, key: this.convertChild(a.name), value: this.createNode(a, { type: pr.AST_NODE_TYPES.AssignmentPattern, left: this.convertPattern(a.name), right: this.convertChild(a.objectAssignmentInitializer) }), computed: false, method: false, shorthand: true, kind: "init" }) : this.createNode(a, { type: pr.AST_NODE_TYPES.Property, key: this.convertChild(a.name), value: this.convertChild(a.name), computed: false, method: false, shorthand: true, kind: "init" });
                case ar.ComputedPropertyName:
                  return this.convertChild(a.expression);
                case ar.PropertyDeclaration: {
                  let f = (0, kr.hasModifier)(ar.AbstractKeyword, a), T = this.createNode(a, { type: f ? pr.AST_NODE_TYPES.TSAbstractPropertyDefinition : pr.AST_NODE_TYPES.PropertyDefinition, key: this.convertChild(a.name), value: f ? null : this.convertChild(a.initializer), computed: (0, kr.isComputedProperty)(a.name), static: (0, kr.hasModifier)(ar.StaticKeyword, a), readonly: (0, kr.hasModifier)(ar.ReadonlyKeyword, a) || void 0, declare: (0, kr.hasModifier)(ar.DeclareKeyword, a), override: (0, kr.hasModifier)(ar.OverrideKeyword, a) });
                  a.type && (T.typeAnnotation = this.convertTypeAnnotation(a.type, a)), a.decorators && (T.decorators = a.decorators.map((b) => this.convertChild(b)));
                  let K = (0, kr.getTSNodeAccessibility)(a);
                  return K && (T.accessibility = K), (a.name.kind === ar.Identifier || a.name.kind === ar.ComputedPropertyName || a.name.kind === ar.PrivateIdentifier) && a.questionToken && (T.optional = true), a.exclamationToken && (T.definite = true), T.key.type === pr.AST_NODE_TYPES.Literal && a.questionToken && (T.optional = true), T;
                }
                case ar.GetAccessor:
                case ar.SetAccessor:
                  if (a.parent.kind === ar.InterfaceDeclaration || a.parent.kind === ar.TypeLiteral) return this.convertMethodSignature(a);
                case ar.MethodDeclaration: {
                  let f = this.createNode(a, { type: a.body ? pr.AST_NODE_TYPES.FunctionExpression : pr.AST_NODE_TYPES.TSEmptyBodyFunctionExpression, id: null, generator: !!a.asteriskToken, expression: false, async: (0, kr.hasModifier)(ar.AsyncKeyword, a), body: this.convertChild(a.body), range: [a.parameters.pos - 1, a.end], params: [] });
                  a.type && (f.returnType = this.convertTypeAnnotation(a.type, a)), a.typeParameters && (f.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters), this.fixParentLocation(f, f.typeParameters.range));
                  let T;
                  if (C.kind === ar.ObjectLiteralExpression) f.params = a.parameters.map((K) => this.convertChild(K)), T = this.createNode(a, { type: pr.AST_NODE_TYPES.Property, key: this.convertChild(a.name), value: f, computed: (0, kr.isComputedProperty)(a.name), method: a.kind === ar.MethodDeclaration, shorthand: false, kind: "init" });
                  else {
                    f.params = this.convertParameters(a.parameters);
                    let K = (0, kr.hasModifier)(ar.AbstractKeyword, a) ? pr.AST_NODE_TYPES.TSAbstractMethodDefinition : pr.AST_NODE_TYPES.MethodDefinition;
                    T = this.createNode(a, { type: K, key: this.convertChild(a.name), value: f, computed: (0, kr.isComputedProperty)(a.name), static: (0, kr.hasModifier)(ar.StaticKeyword, a), kind: "method", override: (0, kr.hasModifier)(ar.OverrideKeyword, a) }), a.decorators && (T.decorators = a.decorators.map((se) => this.convertChild(se)));
                    let b = (0, kr.getTSNodeAccessibility)(a);
                    b && (T.accessibility = b);
                  }
                  return a.questionToken && (T.optional = true), a.kind === ar.GetAccessor ? T.kind = "get" : a.kind === ar.SetAccessor ? T.kind = "set" : !T.static && a.name.kind === ar.StringLiteral && a.name.text === "constructor" && T.type !== pr.AST_NODE_TYPES.Property && (T.kind = "constructor"), T;
                }
                case ar.Constructor: {
                  let f = (0, kr.getLastModifier)(a), T = f && (0, kr.findNextToken)(f, a, this.ast) || a.getFirstToken(), K = this.createNode(a, { type: a.body ? pr.AST_NODE_TYPES.FunctionExpression : pr.AST_NODE_TYPES.TSEmptyBodyFunctionExpression, id: null, params: this.convertParameters(a.parameters), generator: false, expression: false, async: false, body: this.convertChild(a.body), range: [a.parameters.pos - 1, a.end] });
                  a.typeParameters && (K.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters), this.fixParentLocation(K, K.typeParameters.range)), a.type && (K.returnType = this.convertTypeAnnotation(a.type, a));
                  let b = this.createNode(a, { type: pr.AST_NODE_TYPES.Identifier, name: "constructor", range: [T.getStart(this.ast), T.end] }), se = (0, kr.hasModifier)(ar.StaticKeyword, a), J = this.createNode(a, { type: (0, kr.hasModifier)(ar.AbstractKeyword, a) ? pr.AST_NODE_TYPES.TSAbstractMethodDefinition : pr.AST_NODE_TYPES.MethodDefinition, key: b, value: K, computed: false, static: se, kind: se ? "method" : "constructor", override: false }), ie = (0, kr.getTSNodeAccessibility)(a);
                  return ie && (J.accessibility = ie), J;
                }
                case ar.FunctionExpression: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.FunctionExpression, id: this.convertChild(a.name), generator: !!a.asteriskToken, params: this.convertParameters(a.parameters), body: this.convertChild(a.body), async: (0, kr.hasModifier)(ar.AsyncKeyword, a), expression: false });
                  return a.type && (f.returnType = this.convertTypeAnnotation(a.type, a)), a.typeParameters && (f.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters)), f;
                }
                case ar.SuperKeyword:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Super });
                case ar.ArrayBindingPattern:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ArrayPattern, elements: a.elements.map((f) => this.convertPattern(f)) });
                case ar.OmittedExpression:
                  return null;
                case ar.ObjectBindingPattern:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ObjectPattern, properties: a.elements.map((f) => this.convertPattern(f)) });
                case ar.BindingElement:
                  if (C.kind === ar.ArrayBindingPattern) {
                    let f = this.convertChild(a.name, C);
                    return a.initializer ? this.createNode(a, { type: pr.AST_NODE_TYPES.AssignmentPattern, left: f, right: this.convertChild(a.initializer) }) : a.dotDotDotToken ? this.createNode(a, { type: pr.AST_NODE_TYPES.RestElement, argument: f }) : f;
                  } else {
                    let f;
                    return a.dotDotDotToken ? f = this.createNode(a, { type: pr.AST_NODE_TYPES.RestElement, argument: this.convertChild((w = a.propertyName) !== null && w !== void 0 ? w : a.name) }) : f = this.createNode(a, { type: pr.AST_NODE_TYPES.Property, key: this.convertChild((B = a.propertyName) !== null && B !== void 0 ? B : a.name), value: this.convertChild(a.name), computed: Boolean(a.propertyName && a.propertyName.kind === ar.ComputedPropertyName), method: false, shorthand: !a.propertyName, kind: "init" }), a.initializer && (f.value = this.createNode(a, { type: pr.AST_NODE_TYPES.AssignmentPattern, left: this.convertChild(a.name), right: this.convertChild(a.initializer), range: [a.name.getStart(this.ast), a.initializer.end] })), f;
                  }
                case ar.ArrowFunction: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.ArrowFunctionExpression, generator: false, id: null, params: this.convertParameters(a.parameters), body: this.convertChild(a.body), async: (0, kr.hasModifier)(ar.AsyncKeyword, a), expression: a.body.kind !== ar.Block });
                  return a.type && (f.returnType = this.convertTypeAnnotation(a.type, a)), a.typeParameters && (f.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters)), f;
                }
                case ar.YieldExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.YieldExpression, delegate: !!a.asteriskToken, argument: this.convertChild(a.expression) });
                case ar.AwaitExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.AwaitExpression, argument: this.convertChild(a.expression) });
                case ar.NoSubstitutionTemplateLiteral:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TemplateLiteral, quasis: [this.createNode(a, { type: pr.AST_NODE_TYPES.TemplateElement, value: { raw: this.ast.text.slice(a.getStart(this.ast) + 1, a.end - 1), cooked: a.text }, tail: true })], expressions: [] });
                case ar.TemplateExpression: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.TemplateLiteral, quasis: [this.convertChild(a.head)], expressions: [] });
                  return a.templateSpans.forEach((T) => {
                    f.expressions.push(this.convertChild(T.expression)), f.quasis.push(this.convertChild(T.literal));
                  }), f;
                }
                case ar.TaggedTemplateExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TaggedTemplateExpression, typeParameters: a.typeArguments ? this.convertTypeArgumentsToTypeParameters(a.typeArguments, a) : void 0, tag: this.convertChild(a.tag), quasi: this.convertChild(a.template) });
                case ar.TemplateHead:
                case ar.TemplateMiddle:
                case ar.TemplateTail: {
                  let f = a.kind === ar.TemplateTail;
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TemplateElement, value: { raw: this.ast.text.slice(a.getStart(this.ast) + 1, a.end - (f ? 1 : 2)), cooked: a.text }, tail: f });
                }
                case ar.SpreadAssignment:
                case ar.SpreadElement:
                  return this.allowPattern ? this.createNode(a, { type: pr.AST_NODE_TYPES.RestElement, argument: this.convertPattern(a.expression) }) : this.createNode(a, { type: pr.AST_NODE_TYPES.SpreadElement, argument: this.convertChild(a.expression) });
                case ar.Parameter: {
                  let f, T;
                  return a.dotDotDotToken ? f = T = this.createNode(a, { type: pr.AST_NODE_TYPES.RestElement, argument: this.convertChild(a.name) }) : a.initializer ? (f = this.convertChild(a.name), T = this.createNode(a, { type: pr.AST_NODE_TYPES.AssignmentPattern, left: f, right: this.convertChild(a.initializer) }), a.modifiers && (T.range[0] = f.range[0], T.loc = (0, kr.getLocFor)(T.range[0], T.range[1], this.ast))) : f = T = this.convertChild(a.name, C), a.type && (f.typeAnnotation = this.convertTypeAnnotation(a.type, a), this.fixParentLocation(f, f.typeAnnotation.range)), a.questionToken && (a.questionToken.end > f.range[1] && (f.range[1] = a.questionToken.end, f.loc.end = (0, kr.getLineAndCharacterFor)(f.range[1], this.ast)), f.optional = true), a.modifiers ? this.createNode(a, { type: pr.AST_NODE_TYPES.TSParameterProperty, accessibility: (E = (0, kr.getTSNodeAccessibility)(a)) !== null && E !== void 0 ? E : void 0, readonly: (0, kr.hasModifier)(ar.ReadonlyKeyword, a) || void 0, static: (0, kr.hasModifier)(ar.StaticKeyword, a) || void 0, export: (0, kr.hasModifier)(ar.ExportKeyword, a) || void 0, override: (0, kr.hasModifier)(ar.OverrideKeyword, a) || void 0, parameter: T }) : T;
                }
                case ar.ClassDeclaration:
                case ar.ClassExpression: {
                  let f = (Q = a.heritageClauses) !== null && Q !== void 0 ? Q : [], T = a.kind === ar.ClassDeclaration ? pr.AST_NODE_TYPES.ClassDeclaration : pr.AST_NODE_TYPES.ClassExpression, K = f.find((ie) => ie.token === ar.ExtendsKeyword), b = f.find((ie) => ie.token === ar.ImplementsKeyword), se = this.createNode(a, { type: T, id: this.convertChild(a.name), body: this.createNode(a, { type: pr.AST_NODE_TYPES.ClassBody, body: [], range: [a.members.pos - 1, a.end] }), superClass: K != null && K.types[0] ? this.convertChild(K.types[0].expression) : null });
                  if (K) {
                    if (K.types.length > 1) throw (0, kr.createError)(this.ast, K.types[1].pos, "Classes can only extend a single class.");
                    !((le = K.types[0]) === null || le === void 0) && le.typeArguments && (se.superTypeParameters = this.convertTypeArgumentsToTypeParameters(K.types[0].typeArguments, K.types[0]));
                  }
                  a.typeParameters && (se.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters)), b && (se.implements = b.types.map((ie) => this.convertChild(ie))), (0, kr.hasModifier)(ar.AbstractKeyword, a) && (se.abstract = true), (0, kr.hasModifier)(ar.DeclareKeyword, a) && (se.declare = true), a.decorators && (se.decorators = a.decorators.map((ie) => this.convertChild(ie)));
                  let J = a.members.filter(kr.isESTreeClassMember);
                  return J.length && (se.body.body = J.map((ie) => this.convertChild(ie))), this.fixExports(a, se);
                }
                case ar.ModuleBlock:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSModuleBlock, body: this.convertBodyExpressions(a.statements, a) });
                case ar.ImportDeclaration: {
                  this.assertModuleSpecifier(a, false);
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.ImportDeclaration, source: this.convertChild(a.moduleSpecifier), specifiers: [], importKind: "value", assertions: this.convertAssertClasue(a.assertClause) });
                  if (a.importClause && (a.importClause.isTypeOnly && (f.importKind = "type"), a.importClause.name && f.specifiers.push(this.convertChild(a.importClause)), a.importClause.namedBindings)) switch (a.importClause.namedBindings.kind) {
                    case ar.NamespaceImport:
                      f.specifiers.push(this.convertChild(a.importClause.namedBindings));
                      break;
                    case ar.NamedImports:
                      f.specifiers = f.specifiers.concat(a.importClause.namedBindings.elements.map((T) => this.convertChild(T)));
                      break;
                  }
                  return f;
                }
                case ar.NamespaceImport:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ImportNamespaceSpecifier, local: this.convertChild(a.name) });
                case ar.ImportSpecifier:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ImportSpecifier, local: this.convertChild(a.name), imported: this.convertChild((N = a.propertyName) !== null && N !== void 0 ? N : a.name), importKind: a.isTypeOnly ? "type" : "value" });
                case ar.ImportClause: {
                  let f = this.convertChild(a.name);
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ImportDefaultSpecifier, local: f, range: f.range });
                }
                case ar.ExportDeclaration:
                  return ((p = a.exportClause) === null || p === void 0 ? void 0 : p.kind) === ar.NamedExports ? (this.assertModuleSpecifier(a, true), this.createNode(a, { type: pr.AST_NODE_TYPES.ExportNamedDeclaration, source: this.convertChild(a.moduleSpecifier), specifiers: a.exportClause.elements.map((f) => this.convertChild(f)), exportKind: a.isTypeOnly ? "type" : "value", declaration: null, assertions: this.convertAssertClasue(a.assertClause) })) : (this.assertModuleSpecifier(a, false), this.createNode(a, { type: pr.AST_NODE_TYPES.ExportAllDeclaration, source: this.convertChild(a.moduleSpecifier), exportKind: a.isTypeOnly ? "type" : "value", exported: a.exportClause && a.exportClause.kind === ar.NamespaceExport ? this.convertChild(a.exportClause.name) : null, assertions: this.convertAssertClasue(a.assertClause) }));
                case ar.ExportSpecifier:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ExportSpecifier, local: this.convertChild((m = a.propertyName) !== null && m !== void 0 ? m : a.name), exported: this.convertChild(a.name), exportKind: a.isTypeOnly ? "type" : "value" });
                case ar.ExportAssignment:
                  return a.isExportEquals ? this.createNode(a, { type: pr.AST_NODE_TYPES.TSExportAssignment, expression: this.convertChild(a.expression) }) : this.createNode(a, { type: pr.AST_NODE_TYPES.ExportDefaultDeclaration, declaration: this.convertChild(a.expression), exportKind: "value" });
                case ar.PrefixUnaryExpression:
                case ar.PostfixUnaryExpression: {
                  let f = (0, kr.getTextForTokenKind)(a.operator);
                  return f === "++" || f === "--" ? this.createNode(a, { type: pr.AST_NODE_TYPES.UpdateExpression, operator: f, prefix: a.kind === ar.PrefixUnaryExpression, argument: this.convertChild(a.operand) }) : this.createNode(a, { type: pr.AST_NODE_TYPES.UnaryExpression, operator: f, prefix: a.kind === ar.PrefixUnaryExpression, argument: this.convertChild(a.operand) });
                }
                case ar.DeleteExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.UnaryExpression, operator: "delete", prefix: true, argument: this.convertChild(a.expression) });
                case ar.VoidExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.UnaryExpression, operator: "void", prefix: true, argument: this.convertChild(a.expression) });
                case ar.TypeOfExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.UnaryExpression, operator: "typeof", prefix: true, argument: this.convertChild(a.expression) });
                case ar.TypeOperator:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSTypeOperator, operator: (0, kr.getTextForTokenKind)(a.operator), typeAnnotation: this.convertChild(a.type) });
                case ar.BinaryExpression:
                  if ((0, kr.isComma)(a.operatorToken)) {
                    let f = this.createNode(a, { type: pr.AST_NODE_TYPES.SequenceExpression, expressions: [] }), T = this.convertChild(a.left);
                    return T.type === pr.AST_NODE_TYPES.SequenceExpression && a.left.kind !== ar.ParenthesizedExpression ? f.expressions = f.expressions.concat(T.expressions) : f.expressions.push(T), f.expressions.push(this.convertChild(a.right)), f;
                  } else {
                    let f = (0, kr.getBinaryExpressionType)(a.operatorToken);
                    return this.allowPattern && f === pr.AST_NODE_TYPES.AssignmentExpression ? this.createNode(a, { type: pr.AST_NODE_TYPES.AssignmentPattern, left: this.convertPattern(a.left, a), right: this.convertChild(a.right) }) : this.createNode(a, { type: f, operator: (0, kr.getTextForTokenKind)(a.operatorToken.kind), left: this.converter(a.left, a, this.inTypeMode, f === pr.AST_NODE_TYPES.AssignmentExpression), right: this.convertChild(a.right) });
                  }
                case ar.PropertyAccessExpression: {
                  let f = this.convertChild(a.expression), T = this.convertChild(a.name), K = false, b = this.createNode(a, { type: pr.AST_NODE_TYPES.MemberExpression, object: f, property: T, computed: K, optional: a.questionDotToken !== void 0 });
                  return this.convertChainExpression(b, a);
                }
                case ar.ElementAccessExpression: {
                  let f = this.convertChild(a.expression), T = this.convertChild(a.argumentExpression), K = true, b = this.createNode(a, { type: pr.AST_NODE_TYPES.MemberExpression, object: f, property: T, computed: K, optional: a.questionDotToken !== void 0 });
                  return this.convertChainExpression(b, a);
                }
                case ar.CallExpression: {
                  if (a.expression.kind === ar.ImportKeyword) {
                    if (a.arguments.length !== 1 && a.arguments.length !== 2) throw (0, kr.createError)(this.ast, a.arguments.pos, "Dynamic import requires exactly one or two arguments.");
                    return this.createNode(a, { type: pr.AST_NODE_TYPES.ImportExpression, source: this.convertChild(a.arguments[0]), attributes: a.arguments[1] ? this.convertChild(a.arguments[1]) : null });
                  }
                  let f = this.convertChild(a.expression), T = a.arguments.map((b) => this.convertChild(b)), K = this.createNode(a, { type: pr.AST_NODE_TYPES.CallExpression, callee: f, arguments: T, optional: a.questionDotToken !== void 0 });
                  return a.typeArguments && (K.typeParameters = this.convertTypeArgumentsToTypeParameters(a.typeArguments, a)), this.convertChainExpression(K, a);
                }
                case ar.NewExpression: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.NewExpression, callee: this.convertChild(a.expression), arguments: a.arguments ? a.arguments.map((T) => this.convertChild(T)) : [] });
                  return a.typeArguments && (f.typeParameters = this.convertTypeArgumentsToTypeParameters(a.typeArguments, a)), f;
                }
                case ar.ConditionalExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ConditionalExpression, test: this.convertChild(a.condition), consequent: this.convertChild(a.whenTrue), alternate: this.convertChild(a.whenFalse) });
                case ar.MetaProperty:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.MetaProperty, meta: this.createNode(a.getFirstToken(), { type: pr.AST_NODE_TYPES.Identifier, name: (0, kr.getTextForTokenKind)(a.keywordToken) }), property: this.convertChild(a.name) });
                case ar.Decorator:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Decorator, expression: this.convertChild(a.expression) });
                case ar.StringLiteral:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Literal, value: C.kind === ar.JsxAttribute ? (0, kr.unescapeStringLiteralText)(a.text) : a.text, raw: a.getText() });
                case ar.NumericLiteral:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Literal, value: Number(a.text), raw: a.getText() });
                case ar.BigIntLiteral: {
                  let f = (0, kr.getRange)(a, this.ast), T = this.ast.text.slice(f[0], f[1]), K = T.slice(0, -1).replace(/_/g, ""), b = typeof BigInt < "u" ? BigInt(K) : null;
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Literal, raw: T, value: b, bigint: b === null ? K : String(b), range: f });
                }
                case ar.RegularExpressionLiteral: {
                  let f = a.text.slice(1, a.text.lastIndexOf("/")), T = a.text.slice(a.text.lastIndexOf("/") + 1), K = null;
                  try {
                    K = new RegExp(f, T);
                  } catch {
                    K = null;
                  }
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Literal, value: K, raw: a.text, regex: { pattern: f, flags: T } });
                }
                case ar.TrueKeyword:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Literal, value: true, raw: "true" });
                case ar.FalseKeyword:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Literal, value: false, raw: "false" });
                case ar.NullKeyword:
                  return !Lr.typescriptVersionIsAtLeast["4.0"] && this.inTypeMode ? this.createNode(a, { type: pr.AST_NODE_TYPES.TSNullKeyword }) : this.createNode(a, { type: pr.AST_NODE_TYPES.Literal, value: null, raw: "null" });
                case ar.EmptyStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.EmptyStatement });
                case ar.DebuggerStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.DebuggerStatement });
                case ar.JsxElement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXElement, openingElement: this.convertChild(a.openingElement), closingElement: this.convertChild(a.closingElement), children: a.children.map((f) => this.convertChild(f)) });
                case ar.JsxFragment:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXFragment, openingFragment: this.convertChild(a.openingFragment), closingFragment: this.convertChild(a.closingFragment), children: a.children.map((f) => this.convertChild(f)) });
                case ar.JsxSelfClosingElement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXElement, openingElement: this.createNode(a, { type: pr.AST_NODE_TYPES.JSXOpeningElement, typeParameters: a.typeArguments ? this.convertTypeArgumentsToTypeParameters(a.typeArguments, a) : void 0, selfClosing: true, name: this.convertJSXTagName(a.tagName, a), attributes: a.attributes.properties.map((f) => this.convertChild(f)), range: (0, kr.getRange)(a, this.ast) }), closingElement: null, children: [] });
                case ar.JsxOpeningElement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXOpeningElement, typeParameters: a.typeArguments ? this.convertTypeArgumentsToTypeParameters(a.typeArguments, a) : void 0, selfClosing: false, name: this.convertJSXTagName(a.tagName, a), attributes: a.attributes.properties.map((f) => this.convertChild(f)) });
                case ar.JsxClosingElement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXClosingElement, name: this.convertJSXTagName(a.tagName, a) });
                case ar.JsxOpeningFragment:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXOpeningFragment });
                case ar.JsxClosingFragment:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXClosingFragment });
                case ar.JsxExpression: {
                  let f = a.expression ? this.convertChild(a.expression) : this.createNode(a, { type: pr.AST_NODE_TYPES.JSXEmptyExpression, range: [a.getStart(this.ast) + 1, a.getEnd() - 1] });
                  return a.dotDotDotToken ? this.createNode(a, { type: pr.AST_NODE_TYPES.JSXSpreadChild, expression: f }) : this.createNode(a, { type: pr.AST_NODE_TYPES.JSXExpressionContainer, expression: f });
                }
                case ar.JsxAttribute:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXAttribute, name: this.convertJSXNamespaceOrIdentifier(a.name), value: this.convertChild(a.initializer) });
                case ar.JsxText: {
                  let f = a.getFullStart(), T = a.getEnd(), K = this.ast.text.slice(f, T);
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXText, value: (0, kr.unescapeStringLiteralText)(K), raw: K, range: [f, T] });
                }
                case ar.JsxSpreadAttribute:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXSpreadAttribute, argument: this.convertChild(a.expression) });
                case ar.QualifiedName:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSQualifiedName, left: this.convertChild(a.left), right: this.convertChild(a.right) });
                case ar.TypeReference:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSTypeReference, typeName: this.convertType(a.typeName), typeParameters: a.typeArguments ? this.convertTypeArgumentsToTypeParameters(a.typeArguments, a) : void 0 });
                case ar.TypeParameter:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSTypeParameter, name: this.convertType(a.name), constraint: a.constraint ? this.convertType(a.constraint) : void 0, default: a.default ? this.convertType(a.default) : void 0, in: (0, kr.hasModifier)(ar.InKeyword, a), out: (0, kr.hasModifier)(ar.OutKeyword, a) });
                case ar.ThisType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSThisType });
                case ar.AnyKeyword:
                case ar.BigIntKeyword:
                case ar.BooleanKeyword:
                case ar.NeverKeyword:
                case ar.NumberKeyword:
                case ar.ObjectKeyword:
                case ar.StringKeyword:
                case ar.SymbolKeyword:
                case ar.UnknownKeyword:
                case ar.VoidKeyword:
                case ar.UndefinedKeyword:
                case ar.IntrinsicKeyword:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES["TS".concat(ar[a.kind])] });
                case ar.NonNullExpression: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.TSNonNullExpression, expression: this.convertChild(a.expression) });
                  return this.convertChainExpression(f, a);
                }
                case ar.TypeLiteral:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSTypeLiteral, members: a.members.map((f) => this.convertChild(f)) });
                case ar.ArrayType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSArrayType, elementType: this.convertType(a.elementType) });
                case ar.IndexedAccessType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSIndexedAccessType, objectType: this.convertType(a.objectType), indexType: this.convertType(a.indexType) });
                case ar.ConditionalType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSConditionalType, checkType: this.convertType(a.checkType), extendsType: this.convertType(a.extendsType), trueType: this.convertType(a.trueType), falseType: this.convertType(a.falseType) });
                case ar.TypeQuery:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSTypeQuery, exprName: this.convertType(a.exprName), typeParameters: a.typeArguments && this.convertTypeArgumentsToTypeParameters(a.typeArguments, a) });
                case ar.MappedType: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.TSMappedType, typeParameter: this.convertType(a.typeParameter), nameType: (G = this.convertType(a.nameType)) !== null && G !== void 0 ? G : null });
                  return a.readonlyToken && (a.readonlyToken.kind === ar.ReadonlyKeyword ? f.readonly = true : f.readonly = (0, kr.getTextForTokenKind)(a.readonlyToken.kind)), a.questionToken && (a.questionToken.kind === ar.QuestionToken ? f.optional = true : f.optional = (0, kr.getTextForTokenKind)(a.questionToken.kind)), a.type && (f.typeAnnotation = this.convertType(a.type)), f;
                }
                case ar.ParenthesizedExpression:
                  return this.convertChild(a.expression, C);
                case ar.TypeAliasDeclaration: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.TSTypeAliasDeclaration, id: this.convertChild(a.name), typeAnnotation: this.convertType(a.type) });
                  return (0, kr.hasModifier)(ar.DeclareKeyword, a) && (f.declare = true), a.typeParameters && (f.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters)), this.fixExports(a, f);
                }
                case ar.MethodSignature:
                  return this.convertMethodSignature(a);
                case ar.PropertySignature: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.TSPropertySignature, optional: (0, kr.isOptional)(a) || void 0, computed: (0, kr.isComputedProperty)(a.name), key: this.convertChild(a.name), typeAnnotation: a.type ? this.convertTypeAnnotation(a.type, a) : void 0, initializer: this.convertChild(a.initializer) || void 0, readonly: (0, kr.hasModifier)(ar.ReadonlyKeyword, a) || void 0, static: (0, kr.hasModifier)(ar.StaticKeyword, a) || void 0, export: (0, kr.hasModifier)(ar.ExportKeyword, a) || void 0 }), T = (0, kr.getTSNodeAccessibility)(a);
                  return T && (f.accessibility = T), f;
                }
                case ar.IndexSignature: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.TSIndexSignature, parameters: a.parameters.map((K) => this.convertChild(K)) });
                  a.type && (f.typeAnnotation = this.convertTypeAnnotation(a.type, a)), (0, kr.hasModifier)(ar.ReadonlyKeyword, a) && (f.readonly = true);
                  let T = (0, kr.getTSNodeAccessibility)(a);
                  return T && (f.accessibility = T), (0, kr.hasModifier)(ar.ExportKeyword, a) && (f.export = true), (0, kr.hasModifier)(ar.StaticKeyword, a) && (f.static = true), f;
                }
                case ar.ConstructorType: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.TSConstructorType, params: this.convertParameters(a.parameters), abstract: (0, kr.hasModifier)(ar.AbstractKeyword, a) });
                  return a.type && (f.returnType = this.convertTypeAnnotation(a.type, a)), a.typeParameters && (f.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters)), f;
                }
                case ar.FunctionType:
                case ar.ConstructSignature:
                case ar.CallSignature: {
                  let f = a.kind === ar.ConstructSignature ? pr.AST_NODE_TYPES.TSConstructSignatureDeclaration : a.kind === ar.CallSignature ? pr.AST_NODE_TYPES.TSCallSignatureDeclaration : pr.AST_NODE_TYPES.TSFunctionType, T = this.createNode(a, { type: f, params: this.convertParameters(a.parameters) });
                  return a.type && (T.returnType = this.convertTypeAnnotation(a.type, a)), a.typeParameters && (T.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters)), T;
                }
                case ar.ExpressionWithTypeArguments: {
                  let f = C.kind, T = f === ar.InterfaceDeclaration ? pr.AST_NODE_TYPES.TSInterfaceHeritage : f === ar.HeritageClause ? pr.AST_NODE_TYPES.TSClassImplements : pr.AST_NODE_TYPES.TSInstantiationExpression, K = this.createNode(a, { type: T, expression: this.convertChild(a.expression) });
                  return a.typeArguments && (K.typeParameters = this.convertTypeArgumentsToTypeParameters(a.typeArguments, a)), K;
                }
                case ar.InterfaceDeclaration: {
                  let f = (oe = a.heritageClauses) !== null && oe !== void 0 ? oe : [], T = this.createNode(a, { type: pr.AST_NODE_TYPES.TSInterfaceDeclaration, body: this.createNode(a, { type: pr.AST_NODE_TYPES.TSInterfaceBody, body: a.members.map((K) => this.convertChild(K)), range: [a.members.pos - 1, a.end] }), id: this.convertChild(a.name) });
                  if (a.typeParameters && (T.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters)), f.length > 0) {
                    let K = [], b = [];
                    for (let se of f) if (se.token === ar.ExtendsKeyword) for (let J of se.types) K.push(this.convertChild(J, a));
                    else for (let J of se.types) b.push(this.convertChild(J, a));
                    K.length && (T.extends = K), b.length && (T.implements = b);
                  }
                  return (0, kr.hasModifier)(ar.AbstractKeyword, a) && (T.abstract = true), (0, kr.hasModifier)(ar.DeclareKeyword, a) && (T.declare = true), this.fixExports(a, T);
                }
                case ar.TypePredicate: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.TSTypePredicate, asserts: a.assertsModifier !== void 0, parameterName: this.convertChild(a.parameterName), typeAnnotation: null });
                  return a.type && (f.typeAnnotation = this.convertTypeAnnotation(a.type, a), f.typeAnnotation.loc = f.typeAnnotation.typeAnnotation.loc, f.typeAnnotation.range = f.typeAnnotation.typeAnnotation.range), f;
                }
                case ar.ImportType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSImportType, isTypeOf: !!a.isTypeOf, parameter: this.convertChild(a.argument), qualifier: this.convertChild(a.qualifier), typeParameters: a.typeArguments ? this.convertTypeArgumentsToTypeParameters(a.typeArguments, a) : null });
                case ar.EnumDeclaration: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.TSEnumDeclaration, id: this.convertChild(a.name), members: a.members.map((T) => this.convertChild(T)) });
                  return this.applyModifiersToResult(f, a.modifiers), this.fixExports(a, f);
                }
                case ar.EnumMember: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.TSEnumMember, id: this.convertChild(a.name) });
                  return a.initializer && (f.initializer = this.convertChild(a.initializer)), a.name.kind === oi.SyntaxKind.ComputedPropertyName && (f.computed = true), f;
                }
                case ar.ModuleDeclaration: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.TSModuleDeclaration, id: this.convertChild(a.name) });
                  return a.body && (f.body = this.convertChild(a.body)), this.applyModifiersToResult(f, a.modifiers), a.flags & oi.NodeFlags.GlobalAugmentation && (f.global = true), this.fixExports(a, f);
                }
                case ar.ParenthesizedType:
                  return this.convertType(a.type);
                case ar.UnionType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSUnionType, types: a.types.map((f) => this.convertType(f)) });
                case ar.IntersectionType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSIntersectionType, types: a.types.map((f) => this.convertType(f)) });
                case ar.AsExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSAsExpression, expression: this.convertChild(a.expression), typeAnnotation: this.convertType(a.type) });
                case ar.InferType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSInferType, typeParameter: this.convertType(a.typeParameter) });
                case ar.LiteralType:
                  return Lr.typescriptVersionIsAtLeast["4.0"] && a.literal.kind === ar.NullKeyword ? this.createNode(a.literal, { type: pr.AST_NODE_TYPES.TSNullKeyword }) : this.createNode(a, { type: pr.AST_NODE_TYPES.TSLiteralType, literal: this.convertType(a.literal) });
                case ar.TypeAssertionExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSTypeAssertion, typeAnnotation: this.convertType(a.type), expression: this.convertChild(a.expression) });
                case ar.ImportEqualsDeclaration:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSImportEqualsDeclaration, id: this.convertChild(a.name), moduleReference: this.convertChild(a.moduleReference), importKind: a.isTypeOnly ? "type" : "value", isExport: (0, kr.hasModifier)(ar.ExportKeyword, a) });
                case ar.ExternalModuleReference:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSExternalModuleReference, expression: this.convertChild(a.expression) });
                case ar.NamespaceExportDeclaration:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSNamespaceExportDeclaration, id: this.convertChild(a.name) });
                case ar.AbstractKeyword:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSAbstractKeyword });
                case ar.TupleType: {
                  let f = "elementTypes" in a ? a.elementTypes.map((T) => this.convertType(T)) : a.elements.map((T) => this.convertType(T));
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSTupleType, elementTypes: f });
                }
                case ar.NamedTupleMember: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.TSNamedTupleMember, elementType: this.convertType(a.type, a), label: this.convertChild(a.name, a), optional: a.questionToken != null });
                  return a.dotDotDotToken ? (f.range[0] = f.label.range[0], f.loc.start = f.label.loc.start, this.createNode(a, { type: pr.AST_NODE_TYPES.TSRestType, typeAnnotation: f })) : f;
                }
                case ar.OptionalType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSOptionalType, typeAnnotation: this.convertType(a.type) });
                case ar.RestType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSRestType, typeAnnotation: this.convertType(a.type) });
                case ar.TemplateLiteralType: {
                  let f = this.createNode(a, { type: pr.AST_NODE_TYPES.TSTemplateLiteralType, quasis: [this.convertChild(a.head)], types: [] });
                  return a.templateSpans.forEach((T) => {
                    f.types.push(this.convertChild(T.type)), f.quasis.push(this.convertChild(T.literal));
                  }), f;
                }
                case ar.ClassStaticBlockDeclaration:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.StaticBlock, body: this.convertBodyExpressions(a.body.statements, a) });
                case ar.AssertEntry:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ImportAttribute, key: this.convertChild(a.name), value: this.convertChild(a.value) });
                default:
                  return this.deeplyCopy(a);
              }
            }
          };
          M.Converter = e;
        } }), Ud = {};
        h1(Ud, { __assign: () => v1, __asyncDelegator: () => JU, __asyncGenerator: () => BU, __asyncValues: () => jU, __await: () => Xy, __awaiter: () => wU, __classPrivateFieldGet: () => qU, __classPrivateFieldSet: () => VU, __createBinding: () => FU, __decorate: () => NU, __exportStar: () => MU, __extends: () => kU, __generator: () => OU, __importDefault: () => WU, __importStar: () => zU, __makeTemplateObject: () => UU, __metadata: () => IU, __param: () => PU, __read: () => r3, __rest: () => AU, __spread: () => LU, __spreadArrays: () => RU, __values: () => UT });
        function kU(M, re) {
          m1(M, re);
          function Ve() {
            this.constructor = M;
          }
          M.prototype = re === null ? Object.create(re) : (Ve.prototype = re.prototype, new Ve());
        }
        function AU(M, re) {
          var Ve = {};
          for (var Ke in M) Object.prototype.hasOwnProperty.call(M, Ke) && re.indexOf(Ke) < 0 && (Ve[Ke] = M[Ke]);
          if (M != null && typeof Object.getOwnPropertySymbols == "function") for (var oi = 0, Ke = Object.getOwnPropertySymbols(M); oi < Ke.length; oi++) re.indexOf(Ke[oi]) < 0 && Object.prototype.propertyIsEnumerable.call(M, Ke[oi]) && (Ve[Ke[oi]] = M[Ke[oi]]);
          return Ve;
        }
        function NU(M, re, Ve, Ke) {
          var oi = arguments.length, kr = oi < 3 ? re : Ke === null ? Ke = Object.getOwnPropertyDescriptor(re, Ve) : Ke, pr;
          if (typeof Reflect == "object" && typeof Reflect.decorate == "function") kr = Reflect.decorate(M, re, Ve, Ke);
          else for (var Lr = M.length - 1; Lr >= 0; Lr--) (pr = M[Lr]) && (kr = (oi < 3 ? pr(kr) : oi > 3 ? pr(re, Ve, kr) : pr(re, Ve)) || kr);
          return oi > 3 && kr && Object.defineProperty(re, Ve, kr), kr;
        }
        function PU(M, re) {
          return function(Ve, Ke) {
            re(Ve, Ke, M);
          };
        }
        function IU(M, re) {
          if (typeof Reflect == "object" && typeof Reflect.metadata == "function") return Reflect.metadata(M, re);
        }
        function wU(M, re, Ve, Ke) {
          function oi(kr) {
            return kr instanceof Ve ? kr : new Ve(function(pr) {
              pr(kr);
            });
          }
          return new (Ve || (Ve = Promise))(function(kr, pr) {
            function Lr(e) {
              try {
                ke(Ke.next(e));
              } catch (a) {
                pr(a);
              }
            }
            function ar(e) {
              try {
                ke(Ke.throw(e));
              } catch (a) {
                pr(a);
              }
            }
            function ke(e) {
              e.done ? kr(e.value) : oi(e.value).then(Lr, ar);
            }
            ke((Ke = Ke.apply(M, re || [])).next());
          });
        }
        function OU(M, re) {
          var Ve = { label: 0, sent: function() {
            if (kr[0] & 1) throw kr[1];
            return kr[1];
          }, trys: [], ops: [] }, Ke, oi, kr, pr;
          return pr = { next: Lr(0), throw: Lr(1), return: Lr(2) }, typeof Symbol == "function" && (pr[Symbol.iterator] = function() {
            return this;
          }), pr;
          function Lr(ke) {
            return function(e) {
              return ar([ke, e]);
            };
          }
          function ar(ke) {
            if (Ke) throw new TypeError("Generator is already executing.");
            for (; Ve; ) try {
              if (Ke = 1, oi && (kr = ke[0] & 2 ? oi.return : ke[0] ? oi.throw || ((kr = oi.return) && kr.call(oi), 0) : oi.next) && !(kr = kr.call(oi, ke[1])).done) return kr;
              switch (oi = 0, kr && (ke = [ke[0] & 2, kr.value]), ke[0]) {
                case 0:
                case 1:
                  kr = ke;
                  break;
                case 4:
                  return Ve.label++, { value: ke[1], done: false };
                case 5:
                  Ve.label++, oi = ke[1], ke = [0];
                  continue;
                case 7:
                  ke = Ve.ops.pop(), Ve.trys.pop();
                  continue;
                default:
                  if (kr = Ve.trys, !(kr = kr.length > 0 && kr[kr.length - 1]) && (ke[0] === 6 || ke[0] === 2)) {
                    Ve = 0;
                    continue;
                  }
                  if (ke[0] === 3 && (!kr || ke[1] > kr[0] && ke[1] < kr[3])) {
                    Ve.label = ke[1];
                    break;
                  }
                  if (ke[0] === 6 && Ve.label < kr[1]) {
                    Ve.label = kr[1], kr = ke;
                    break;
                  }
                  if (kr && Ve.label < kr[2]) {
                    Ve.label = kr[2], Ve.ops.push(ke);
                    break;
                  }
                  kr[2] && Ve.ops.pop(), Ve.trys.pop();
                  continue;
              }
              ke = re.call(M, Ve);
            } catch (e) {
              ke = [6, e], oi = 0;
            } finally {
              Ke = kr = 0;
            }
            if (ke[0] & 5) throw ke[1];
            return { value: ke[0] ? ke[1] : void 0, done: true };
          }
        }
        function FU(M, re, Ve, Ke) {
          Ke === void 0 && (Ke = Ve), M[Ke] = re[Ve];
        }
        function MU(M, re) {
          for (var Ve in M) Ve !== "default" && !re.hasOwnProperty(Ve) && (re[Ve] = M[Ve]);
        }
        function UT(M) {
          var re = typeof Symbol == "function" && Symbol.iterator, Ve = re && M[re], Ke = 0;
          if (Ve) return Ve.call(M);
          if (M && typeof M.length == "number") return { next: function() {
            return M && Ke >= M.length && (M = void 0), { value: M && M[Ke++], done: !M };
          } };
          throw new TypeError(re ? "Object is not iterable." : "Symbol.iterator is not defined.");
        }
        function r3(M, re) {
          var Ve = typeof Symbol == "function" && M[Symbol.iterator];
          if (!Ve) return M;
          var Ke = Ve.call(M), oi, kr = [], pr;
          try {
            for (; (re === void 0 || re-- > 0) && !(oi = Ke.next()).done; ) kr.push(oi.value);
          } catch (Lr) {
            pr = { error: Lr };
          } finally {
            try {
              oi && !oi.done && (Ve = Ke.return) && Ve.call(Ke);
            } finally {
              if (pr) throw pr.error;
            }
          }
          return kr;
        }
        function LU() {
          for (var M = [], re = 0; re < arguments.length; re++) M = M.concat(r3(arguments[re]));
          return M;
        }
        function RU() {
          for (var M = 0, re = 0, Ve = arguments.length; re < Ve; re++) M += arguments[re].length;
          for (var Ke = Array(M), oi = 0, re = 0; re < Ve; re++) for (var kr = arguments[re], pr = 0, Lr = kr.length; pr < Lr; pr++, oi++) Ke[oi] = kr[pr];
          return Ke;
        }
        function Xy(M) {
          return this instanceof Xy ? (this.v = M, this) : new Xy(M);
        }
        function BU(M, re, Ve) {
          if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
          var Ke = Ve.apply(M, re || []), oi, kr = [];
          return oi = {}, pr("next"), pr("throw"), pr("return"), oi[Symbol.asyncIterator] = function() {
            return this;
          }, oi;
          function pr(C) {
            Ke[C] && (oi[C] = function(w) {
              return new Promise(function(B, E) {
                kr.push([C, w, B, E]) > 1 || Lr(C, w);
              });
            });
          }
          function Lr(C, w) {
            try {
              ar(Ke[C](w));
            } catch (B) {
              a(kr[0][3], B);
            }
          }
          function ar(C) {
            C.value instanceof Xy ? Promise.resolve(C.value.v).then(ke, e) : a(kr[0][2], C);
          }
          function ke(C) {
            Lr("next", C);
          }
          function e(C) {
            Lr("throw", C);
          }
          function a(C, w) {
            C(w), kr.shift(), kr.length && Lr(kr[0][0], kr[0][1]);
          }
        }
        function JU(M) {
          var re, Ve;
          return re = {}, Ke("next"), Ke("throw", function(oi) {
            throw oi;
          }), Ke("return"), re[Symbol.iterator] = function() {
            return this;
          }, re;
          function Ke(oi, kr) {
            re[oi] = M[oi] ? function(pr) {
              return (Ve = !Ve) ? { value: Xy(M[oi](pr)), done: oi === "return" } : kr ? kr(pr) : pr;
            } : kr;
          }
        }
        function jU(M) {
          if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
          var re = M[Symbol.asyncIterator], Ve;
          return re ? re.call(M) : (M = typeof UT == "function" ? UT(M) : M[Symbol.iterator](), Ve = {}, Ke("next"), Ke("throw"), Ke("return"), Ve[Symbol.asyncIterator] = function() {
            return this;
          }, Ve);
          function Ke(kr) {
            Ve[kr] = M[kr] && function(pr) {
              return new Promise(function(Lr, ar) {
                pr = M[kr](pr), oi(Lr, ar, pr.done, pr.value);
              });
            };
          }
          function oi(kr, pr, Lr, ar) {
            Promise.resolve(ar).then(function(ke) {
              kr({ value: ke, done: Lr });
            }, pr);
          }
        }
        function UU(M, re) {
          return Object.defineProperty ? Object.defineProperty(M, "raw", { value: re }) : M.raw = re, M;
        }
        function zU(M) {
          if (M && M.__esModule) return M;
          var re = {};
          if (M != null) for (var Ve in M) Object.hasOwnProperty.call(M, Ve) && (re[Ve] = M[Ve]);
          return re.default = M, re;
        }
        function WU(M) {
          return M && M.__esModule ? M : { default: M };
        }
        function qU(M, re) {
          if (!re.has(M)) throw new TypeError("attempted to get private field on non-instance");
          return re.get(M);
        }
        function VU(M, re, Ve) {
          if (!re.has(M)) throw new TypeError("attempted to set private field on non-instance");
          return re.set(M, Ve), Ve;
        }
        var m1, v1, ug = Qy({ "node_modules/tslib/tslib.es6.js"() {
          Ea(), m1 = function(M, re) {
            return m1 = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(Ve, Ke) {
              Ve.__proto__ = Ke;
            } || function(Ve, Ke) {
              for (var oi in Ke) Ke.hasOwnProperty(oi) && (Ve[oi] = Ke[oi]);
            }, m1(M, re);
          }, v1 = function() {
            return v1 = Object.assign || function(re) {
              for (var Ve, Ke = 1, oi = arguments.length; Ke < oi; Ke++) {
                Ve = arguments[Ke];
                for (var kr in Ve) Object.prototype.hasOwnProperty.call(Ve, kr) && (re[kr] = Ve[kr]);
              }
              return re;
            }, v1.apply(this, arguments);
          };
        } }), KU = Oa({ "node_modules/tsutils/typeguard/2.8/node.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.isExpressionStatement = M.isExpression = M.isExportSpecifier = M.isExportDeclaration = M.isExportAssignment = M.isEnumMember = M.isEnumDeclaration = M.isEntityNameExpression = M.isEntityName = M.isEmptyStatement = M.isElementAccessExpression = M.isDoStatement = M.isDeleteExpression = M.isDefaultClause = M.isDecorator = M.isDebuggerStatement = M.isComputedPropertyName = M.isContinueStatement = M.isConstructSignatureDeclaration = M.isConstructorTypeNode = M.isConstructorDeclaration = M.isConditionalTypeNode = M.isConditionalExpression = M.isCommaListExpression = M.isClassLikeDeclaration = M.isClassExpression = M.isClassDeclaration = M.isCatchClause = M.isCaseOrDefaultClause = M.isCaseClause = M.isCaseBlock = M.isCallSignatureDeclaration = M.isCallLikeExpression = M.isCallExpression = M.isBreakStatement = M.isBreakOrContinueStatement = M.isBooleanLiteral = M.isBlockLike = M.isBlock = M.isBindingPattern = M.isBindingElement = M.isBinaryExpression = M.isAwaitExpression = M.isAssertionExpression = M.isAsExpression = M.isArrowFunction = M.isArrayTypeNode = M.isArrayLiteralExpression = M.isArrayBindingPattern = M.isAccessorDeclaration = void 0, M.isNamespaceImport = M.isNamespaceDeclaration = M.isNamedImports = M.isNamedExports = M.isModuleDeclaration = M.isModuleBlock = M.isMethodSignature = M.isMethodDeclaration = M.isMetaProperty = M.isMappedTypeNode = M.isLiteralTypeNode = M.isLiteralExpression = M.isLabeledStatement = M.isJsxText = M.isJsxSpreadAttribute = M.isJsxSelfClosingElement = M.isJsxOpeningLikeElement = M.isJsxOpeningFragment = M.isJsxOpeningElement = M.isJsxFragment = M.isJsxExpression = M.isJsxElement = M.isJsxClosingFragment = M.isJsxClosingElement = M.isJsxAttributes = M.isJsxAttributeLike = M.isJsxAttribute = M.isJsDoc = M.isIterationStatement = M.isIntersectionTypeNode = M.isInterfaceDeclaration = M.isInferTypeNode = M.isIndexSignatureDeclaration = M.isIndexedAccessTypeNode = M.isImportSpecifier = M.isImportEqualsDeclaration = M.isImportDeclaration = M.isImportClause = M.isIfStatement = M.isIdentifier = M.isGetAccessorDeclaration = M.isFunctionTypeNode = M.isFunctionExpression = M.isFunctionDeclaration = M.isForStatement = M.isForOfStatement = M.isForInOrOfStatement = M.isForInStatement = M.isExternalModuleReference = M.isExpressionWithTypeArguments = void 0, M.isVariableStatement = M.isVariableDeclaration = M.isUnionTypeNode = M.isTypeQueryNode = M.isTypeReferenceNode = M.isTypePredicateNode = M.isTypeParameterDeclaration = M.isTypeOperatorNode = M.isTypeOfExpression = M.isTypeLiteralNode = M.isTypeAssertion = M.isTypeAliasDeclaration = M.isTupleTypeNode = M.isTryStatement = M.isThrowStatement = M.isTextualLiteral = M.isTemplateLiteral = M.isTemplateExpression = M.isTaggedTemplateExpression = M.isSyntaxList = M.isSwitchStatement = M.isStringLiteral = M.isSpreadElement = M.isSpreadAssignment = M.isSourceFile = M.isSignatureDeclaration = M.isShorthandPropertyAssignment = M.isSetAccessorDeclaration = M.isReturnStatement = M.isRegularExpressionLiteral = M.isQualifiedName = M.isPropertySignature = M.isPropertyDeclaration = M.isPropertyAssignment = M.isPropertyAccessExpression = M.isPrefixUnaryExpression = M.isPostfixUnaryExpression = M.isParenthesizedTypeNode = M.isParenthesizedExpression = M.isParameterDeclaration = M.isOmittedExpression = M.isObjectLiteralExpression = M.isObjectBindingPattern = M.isNumericOrStringLikeLiteral = M.isNumericLiteral = M.isNullLiteral = M.isNoSubstitutionTemplateLiteral = M.isNonNullExpression = M.isNewExpression = M.isNamespaceExportDeclaration = void 0, M.isWithStatement = M.isWhileStatement = M.isVoidExpression = M.isVariableDeclarationList = void 0;
          var re = _u();
          function Ve(ai) {
            return ai.kind === re.SyntaxKind.GetAccessor || ai.kind === re.SyntaxKind.SetAccessor;
          }
          M.isAccessorDeclaration = Ve;
          function Ke(ai) {
            return ai.kind === re.SyntaxKind.ArrayBindingPattern;
          }
          M.isArrayBindingPattern = Ke;
          function oi(ai) {
            return ai.kind === re.SyntaxKind.ArrayLiteralExpression;
          }
          M.isArrayLiteralExpression = oi;
          function kr(ai) {
            return ai.kind === re.SyntaxKind.ArrayType;
          }
          M.isArrayTypeNode = kr;
          function pr(ai) {
            return ai.kind === re.SyntaxKind.ArrowFunction;
          }
          M.isArrowFunction = pr;
          function Lr(ai) {
            return ai.kind === re.SyntaxKind.AsExpression;
          }
          M.isAsExpression = Lr;
          function ar(ai) {
            return ai.kind === re.SyntaxKind.AsExpression || ai.kind === re.SyntaxKind.TypeAssertionExpression;
          }
          M.isAssertionExpression = ar;
          function ke(ai) {
            return ai.kind === re.SyntaxKind.AwaitExpression;
          }
          M.isAwaitExpression = ke;
          function e(ai) {
            return ai.kind === re.SyntaxKind.BinaryExpression;
          }
          M.isBinaryExpression = e;
          function a(ai) {
            return ai.kind === re.SyntaxKind.BindingElement;
          }
          M.isBindingElement = a;
          function C(ai) {
            return ai.kind === re.SyntaxKind.ArrayBindingPattern || ai.kind === re.SyntaxKind.ObjectBindingPattern;
          }
          M.isBindingPattern = C;
          function w(ai) {
            return ai.kind === re.SyntaxKind.Block;
          }
          M.isBlock = w;
          function B(ai) {
            return ai.statements !== void 0;
          }
          M.isBlockLike = B;
          function E(ai) {
            return ai.kind === re.SyntaxKind.TrueKeyword || ai.kind === re.SyntaxKind.FalseKeyword;
          }
          M.isBooleanLiteral = E;
          function Q(ai) {
            return ai.kind === re.SyntaxKind.BreakStatement || ai.kind === re.SyntaxKind.ContinueStatement;
          }
          M.isBreakOrContinueStatement = Q;
          function le(ai) {
            return ai.kind === re.SyntaxKind.BreakStatement;
          }
          M.isBreakStatement = le;
          function N(ai) {
            return ai.kind === re.SyntaxKind.CallExpression;
          }
          M.isCallExpression = N;
          function p(ai) {
            switch (ai.kind) {
              case re.SyntaxKind.CallExpression:
              case re.SyntaxKind.Decorator:
              case re.SyntaxKind.JsxOpeningElement:
              case re.SyntaxKind.JsxSelfClosingElement:
              case re.SyntaxKind.NewExpression:
              case re.SyntaxKind.TaggedTemplateExpression:
                return true;
              default:
                return false;
            }
          }
          M.isCallLikeExpression = p;
          function m(ai) {
            return ai.kind === re.SyntaxKind.CallSignature;
          }
          M.isCallSignatureDeclaration = m;
          function G(ai) {
            return ai.kind === re.SyntaxKind.CaseBlock;
          }
          M.isCaseBlock = G;
          function oe(ai) {
            return ai.kind === re.SyntaxKind.CaseClause;
          }
          M.isCaseClause = oe;
          function f(ai) {
            return ai.kind === re.SyntaxKind.CaseClause || ai.kind === re.SyntaxKind.DefaultClause;
          }
          M.isCaseOrDefaultClause = f;
          function T(ai) {
            return ai.kind === re.SyntaxKind.CatchClause;
          }
          M.isCatchClause = T;
          function K(ai) {
            return ai.kind === re.SyntaxKind.ClassDeclaration;
          }
          M.isClassDeclaration = K;
          function b(ai) {
            return ai.kind === re.SyntaxKind.ClassExpression;
          }
          M.isClassExpression = b;
          function se(ai) {
            return ai.kind === re.SyntaxKind.ClassDeclaration || ai.kind === re.SyntaxKind.ClassExpression;
          }
          M.isClassLikeDeclaration = se;
          function J(ai) {
            return ai.kind === re.SyntaxKind.CommaListExpression;
          }
          M.isCommaListExpression = J;
          function ie(ai) {
            return ai.kind === re.SyntaxKind.ConditionalExpression;
          }
          M.isConditionalExpression = ie;
          function R(ai) {
            return ai.kind === re.SyntaxKind.ConditionalType;
          }
          M.isConditionalTypeNode = R;
          function q(ai) {
            return ai.kind === re.SyntaxKind.Constructor;
          }
          M.isConstructorDeclaration = q;
          function O(ai) {
            return ai.kind === re.SyntaxKind.ConstructorType;
          }
          M.isConstructorTypeNode = O;
          function ve(ai) {
            return ai.kind === re.SyntaxKind.ConstructSignature;
          }
          M.isConstructSignatureDeclaration = ve;
          function ee(ai) {
            return ai.kind === re.SyntaxKind.ContinueStatement;
          }
          M.isContinueStatement = ee;
          function he(ai) {
            return ai.kind === re.SyntaxKind.ComputedPropertyName;
          }
          M.isComputedPropertyName = he;
          function F(ai) {
            return ai.kind === re.SyntaxKind.DebuggerStatement;
          }
          M.isDebuggerStatement = F;
          function x(ai) {
            return ai.kind === re.SyntaxKind.Decorator;
          }
          M.isDecorator = x;
          function X(ai) {
            return ai.kind === re.SyntaxKind.DefaultClause;
          }
          M.isDefaultClause = X;
          function $(ai) {
            return ai.kind === re.SyntaxKind.DeleteExpression;
          }
          M.isDeleteExpression = $;
          function A(ai) {
            return ai.kind === re.SyntaxKind.DoStatement;
          }
          M.isDoStatement = A;
          function y(ai) {
            return ai.kind === re.SyntaxKind.ElementAccessExpression;
          }
          M.isElementAccessExpression = y;
          function V(ai) {
            return ai.kind === re.SyntaxKind.EmptyStatement;
          }
          M.isEmptyStatement = V;
          function L(ai) {
            return ai.kind === re.SyntaxKind.Identifier || Pe(ai);
          }
          M.isEntityName = L;
          function P(ai) {
            return ai.kind === re.SyntaxKind.Identifier || Ar(ai) && P(ai.expression);
          }
          M.isEntityNameExpression = P;
          function k(ai) {
            return ai.kind === re.SyntaxKind.EnumDeclaration;
          }
          M.isEnumDeclaration = k;
          function Y(ai) {
            return ai.kind === re.SyntaxKind.EnumMember;
          }
          M.isEnumMember = Y;
          function U(ai) {
            return ai.kind === re.SyntaxKind.ExportAssignment;
          }
          M.isExportAssignment = U;
          function j(ai) {
            return ai.kind === re.SyntaxKind.ExportDeclaration;
          }
          M.isExportDeclaration = j;
          function H(ai) {
            return ai.kind === re.SyntaxKind.ExportSpecifier;
          }
          M.isExportSpecifier = H;
          function I(ai) {
            switch (ai.kind) {
              case re.SyntaxKind.ArrayLiteralExpression:
              case re.SyntaxKind.ArrowFunction:
              case re.SyntaxKind.AsExpression:
              case re.SyntaxKind.AwaitExpression:
              case re.SyntaxKind.BinaryExpression:
              case re.SyntaxKind.CallExpression:
              case re.SyntaxKind.ClassExpression:
              case re.SyntaxKind.CommaListExpression:
              case re.SyntaxKind.ConditionalExpression:
              case re.SyntaxKind.DeleteExpression:
              case re.SyntaxKind.ElementAccessExpression:
              case re.SyntaxKind.FalseKeyword:
              case re.SyntaxKind.FunctionExpression:
              case re.SyntaxKind.Identifier:
              case re.SyntaxKind.JsxElement:
              case re.SyntaxKind.JsxFragment:
              case re.SyntaxKind.JsxExpression:
              case re.SyntaxKind.JsxOpeningElement:
              case re.SyntaxKind.JsxOpeningFragment:
              case re.SyntaxKind.JsxSelfClosingElement:
              case re.SyntaxKind.MetaProperty:
              case re.SyntaxKind.NewExpression:
              case re.SyntaxKind.NonNullExpression:
              case re.SyntaxKind.NoSubstitutionTemplateLiteral:
              case re.SyntaxKind.NullKeyword:
              case re.SyntaxKind.NumericLiteral:
              case re.SyntaxKind.ObjectLiteralExpression:
              case re.SyntaxKind.OmittedExpression:
              case re.SyntaxKind.ParenthesizedExpression:
              case re.SyntaxKind.PostfixUnaryExpression:
              case re.SyntaxKind.PrefixUnaryExpression:
              case re.SyntaxKind.PropertyAccessExpression:
              case re.SyntaxKind.RegularExpressionLiteral:
              case re.SyntaxKind.SpreadElement:
              case re.SyntaxKind.StringLiteral:
              case re.SyntaxKind.SuperKeyword:
              case re.SyntaxKind.TaggedTemplateExpression:
              case re.SyntaxKind.TemplateExpression:
              case re.SyntaxKind.ThisKeyword:
              case re.SyntaxKind.TrueKeyword:
              case re.SyntaxKind.TypeAssertionExpression:
              case re.SyntaxKind.TypeOfExpression:
              case re.SyntaxKind.VoidExpression:
              case re.SyntaxKind.YieldExpression:
                return true;
              default:
                return false;
            }
          }
          M.isExpression = I;
          function l(ai) {
            return ai.kind === re.SyntaxKind.ExpressionStatement;
          }
          M.isExpressionStatement = l;
          function d(ai) {
            return ai.kind === re.SyntaxKind.ExpressionWithTypeArguments;
          }
          M.isExpressionWithTypeArguments = d;
          function D(ai) {
            return ai.kind === re.SyntaxKind.ExternalModuleReference;
          }
          M.isExternalModuleReference = D;
          function fe(ai) {
            return ai.kind === re.SyntaxKind.ForInStatement;
          }
          M.isForInStatement = fe;
          function g(ai) {
            return ai.kind === re.SyntaxKind.ForOfStatement || ai.kind === re.SyntaxKind.ForInStatement;
          }
          M.isForInOrOfStatement = g;
          function ne(ai) {
            return ai.kind === re.SyntaxKind.ForOfStatement;
          }
          M.isForOfStatement = ne;
          function ue(ai) {
            return ai.kind === re.SyntaxKind.ForStatement;
          }
          M.isForStatement = ue;
          function We(ai) {
            return ai.kind === re.SyntaxKind.FunctionDeclaration;
          }
          M.isFunctionDeclaration = We;
          function Fe(ai) {
            return ai.kind === re.SyntaxKind.FunctionExpression;
          }
          M.isFunctionExpression = Fe;
          function Z(ai) {
            return ai.kind === re.SyntaxKind.FunctionType;
          }
          M.isFunctionTypeNode = Z;
          function Be(ai) {
            return ai.kind === re.SyntaxKind.GetAccessor;
          }
          M.isGetAccessorDeclaration = Be;
          function ge(ai) {
            return ai.kind === re.SyntaxKind.Identifier;
          }
          M.isIdentifier = ge;
          function Re(ai) {
            return ai.kind === re.SyntaxKind.IfStatement;
          }
          M.isIfStatement = Re;
          function ze(ai) {
            return ai.kind === re.SyntaxKind.ImportClause;
          }
          M.isImportClause = ze;
          function Ee(ai) {
            return ai.kind === re.SyntaxKind.ImportDeclaration;
          }
          M.isImportDeclaration = Ee;
          function He(ai) {
            return ai.kind === re.SyntaxKind.ImportEqualsDeclaration;
          }
          M.isImportEqualsDeclaration = He;
          function rr(ai) {
            return ai.kind === re.SyntaxKind.ImportSpecifier;
          }
          M.isImportSpecifier = rr;
          function Ie(ai) {
            return ai.kind === re.SyntaxKind.IndexedAccessType;
          }
          M.isIndexedAccessTypeNode = Ie;
          function _e(ai) {
            return ai.kind === re.SyntaxKind.IndexSignature;
          }
          M.isIndexSignatureDeclaration = _e;
          function we(ai) {
            return ai.kind === re.SyntaxKind.InferType;
          }
          M.isInferTypeNode = we;
          function de(ai) {
            return ai.kind === re.SyntaxKind.InterfaceDeclaration;
          }
          M.isInterfaceDeclaration = de;
          function ye(ai) {
            return ai.kind === re.SyntaxKind.IntersectionType;
          }
          M.isIntersectionTypeNode = ye;
          function Ae(ai) {
            switch (ai.kind) {
              case re.SyntaxKind.ForStatement:
              case re.SyntaxKind.ForOfStatement:
              case re.SyntaxKind.ForInStatement:
              case re.SyntaxKind.WhileStatement:
              case re.SyntaxKind.DoStatement:
                return true;
              default:
                return false;
            }
          }
          M.isIterationStatement = Ae;
          function er(ai) {
            return ai.kind === re.SyntaxKind.JSDocComment;
          }
          M.isJsDoc = er;
          function ir(ai) {
            return ai.kind === re.SyntaxKind.JsxAttribute;
          }
          M.isJsxAttribute = ir;
          function Cr(ai) {
            return ai.kind === re.SyntaxKind.JsxAttribute || ai.kind === re.SyntaxKind.JsxSpreadAttribute;
          }
          M.isJsxAttributeLike = Cr;
          function Ye(ai) {
            return ai.kind === re.SyntaxKind.JsxAttributes;
          }
          M.isJsxAttributes = Ye;
          function Br(ai) {
            return ai.kind === re.SyntaxKind.JsxClosingElement;
          }
          M.isJsxClosingElement = Br;
          function Er(ai) {
            return ai.kind === re.SyntaxKind.JsxClosingFragment;
          }
          M.isJsxClosingFragment = Er;
          function Ne(ai) {
            return ai.kind === re.SyntaxKind.JsxElement;
          }
          M.isJsxElement = Ne;
          function n(ai) {
            return ai.kind === re.SyntaxKind.JsxExpression;
          }
          M.isJsxExpression = n;
          function lr(ai) {
            return ai.kind === re.SyntaxKind.JsxFragment;
          }
          M.isJsxFragment = lr;
          function be(ai) {
            return ai.kind === re.SyntaxKind.JsxOpeningElement;
          }
          M.isJsxOpeningElement = be;
          function Ge(ai) {
            return ai.kind === re.SyntaxKind.JsxOpeningFragment;
          }
          M.isJsxOpeningFragment = Ge;
          function ur(ai) {
            return ai.kind === re.SyntaxKind.JsxOpeningElement || ai.kind === re.SyntaxKind.JsxSelfClosingElement;
          }
          M.isJsxOpeningLikeElement = ur;
          function yr(ai) {
            return ai.kind === re.SyntaxKind.JsxSelfClosingElement;
          }
          M.isJsxSelfClosingElement = yr;
          function Ir(ai) {
            return ai.kind === re.SyntaxKind.JsxSpreadAttribute;
          }
          M.isJsxSpreadAttribute = Ir;
          function wr(ai) {
            return ai.kind === re.SyntaxKind.JsxText;
          }
          M.isJsxText = wr;
          function Ur(ai) {
            return ai.kind === re.SyntaxKind.LabeledStatement;
          }
          M.isLabeledStatement = Ur;
          function ii(ai) {
            return ai.kind >= re.SyntaxKind.FirstLiteralToken && ai.kind <= re.SyntaxKind.LastLiteralToken;
          }
          M.isLiteralExpression = ii;
          function mi(ai) {
            return ai.kind === re.SyntaxKind.LiteralType;
          }
          M.isLiteralTypeNode = mi;
          function pe(ai) {
            return ai.kind === re.SyntaxKind.MappedType;
          }
          M.isMappedTypeNode = pe;
          function or(ai) {
            return ai.kind === re.SyntaxKind.MetaProperty;
          }
          M.isMetaProperty = or;
          function qr(ai) {
            return ai.kind === re.SyntaxKind.MethodDeclaration;
          }
          M.isMethodDeclaration = qr;
          function si(ai) {
            return ai.kind === re.SyntaxKind.MethodSignature;
          }
          M.isMethodSignature = si;
          function Di(ai) {
            return ai.kind === re.SyntaxKind.ModuleBlock;
          }
          M.isModuleBlock = Di;
          function wi(ai) {
            return ai.kind === re.SyntaxKind.ModuleDeclaration;
          }
          M.isModuleDeclaration = wi;
          function Xi(ai) {
            return ai.kind === re.SyntaxKind.NamedExports;
          }
          M.isNamedExports = Xi;
          function et(ai) {
            return ai.kind === re.SyntaxKind.NamedImports;
          }
          M.isNamedImports = et;
          function Gi(ai) {
            return wi(ai) && ai.name.kind === re.SyntaxKind.Identifier && ai.body !== void 0 && (ai.body.kind === re.SyntaxKind.ModuleBlock || Gi(ai.body));
          }
          M.isNamespaceDeclaration = Gi;
          function Wt(ai) {
            return ai.kind === re.SyntaxKind.NamespaceImport;
          }
          M.isNamespaceImport = Wt;
          function Zt(ai) {
            return ai.kind === re.SyntaxKind.NamespaceExportDeclaration;
          }
          M.isNamespaceExportDeclaration = Zt;
          function _r(ai) {
            return ai.kind === re.SyntaxKind.NewExpression;
          }
          M.isNewExpression = _r;
          function pi(ai) {
            return ai.kind === re.SyntaxKind.NonNullExpression;
          }
          M.isNonNullExpression = pi;
          function ae(ai) {
            return ai.kind === re.SyntaxKind.NoSubstitutionTemplateLiteral;
          }
          M.isNoSubstitutionTemplateLiteral = ae;
          function Xe(ai) {
            return ai.kind === re.SyntaxKind.NullKeyword;
          }
          M.isNullLiteral = Xe;
          function Jr(ai) {
            return ai.kind === re.SyntaxKind.NumericLiteral;
          }
          M.isNumericLiteral = Jr;
          function ti(ai) {
            switch (ai.kind) {
              case re.SyntaxKind.StringLiteral:
              case re.SyntaxKind.NumericLiteral:
              case re.SyntaxKind.NoSubstitutionTemplateLiteral:
                return true;
              default:
                return false;
            }
          }
          M.isNumericOrStringLikeLiteral = ti;
          function Ze(ai) {
            return ai.kind === re.SyntaxKind.ObjectBindingPattern;
          }
          M.isObjectBindingPattern = Ze;
          function Sr(ai) {
            return ai.kind === re.SyntaxKind.ObjectLiteralExpression;
          }
          M.isObjectLiteralExpression = Sr;
          function zr(ai) {
            return ai.kind === re.SyntaxKind.OmittedExpression;
          }
          M.isOmittedExpression = zr;
          function Wr(ai) {
            return ai.kind === re.SyntaxKind.Parameter;
          }
          M.isParameterDeclaration = Wr;
          function Je(ai) {
            return ai.kind === re.SyntaxKind.ParenthesizedExpression;
          }
          M.isParenthesizedExpression = Je;
          function xe(ai) {
            return ai.kind === re.SyntaxKind.ParenthesizedType;
          }
          M.isParenthesizedTypeNode = xe;
          function vr(ai) {
            return ai.kind === re.SyntaxKind.PostfixUnaryExpression;
          }
          M.isPostfixUnaryExpression = vr;
          function mr(ai) {
            return ai.kind === re.SyntaxKind.PrefixUnaryExpression;
          }
          M.isPrefixUnaryExpression = mr;
          function Ar(ai) {
            return ai.kind === re.SyntaxKind.PropertyAccessExpression;
          }
          M.isPropertyAccessExpression = Ar;
          function Oe(ai) {
            return ai.kind === re.SyntaxKind.PropertyAssignment;
          }
          M.isPropertyAssignment = Oe;
          function nr(ai) {
            return ai.kind === re.SyntaxKind.PropertyDeclaration;
          }
          M.isPropertyDeclaration = nr;
          function Mr(ai) {
            return ai.kind === re.SyntaxKind.PropertySignature;
          }
          M.isPropertySignature = Mr;
          function Pe(ai) {
            return ai.kind === re.SyntaxKind.QualifiedName;
          }
          M.isQualifiedName = Pe;
          function Ue(ai) {
            return ai.kind === re.SyntaxKind.RegularExpressionLiteral;
          }
          M.isRegularExpressionLiteral = Ue;
          function fr(ai) {
            return ai.kind === re.SyntaxKind.ReturnStatement;
          }
          M.isReturnStatement = fr;
          function De(ai) {
            return ai.kind === re.SyntaxKind.SetAccessor;
          }
          M.isSetAccessorDeclaration = De;
          function gr(ai) {
            return ai.kind === re.SyntaxKind.ShorthandPropertyAssignment;
          }
          M.isShorthandPropertyAssignment = gr;
          function Vr(ai) {
            return ai.parameters !== void 0;
          }
          M.isSignatureDeclaration = Vr;
          function Tr(ai) {
            return ai.kind === re.SyntaxKind.SourceFile;
          }
          M.isSourceFile = Tr;
          function vi(ai) {
            return ai.kind === re.SyntaxKind.SpreadAssignment;
          }
          M.isSpreadAssignment = vi;
          function Ui(ai) {
            return ai.kind === re.SyntaxKind.SpreadElement;
          }
          M.isSpreadElement = Ui;
          function Yi(ai) {
            return ai.kind === re.SyntaxKind.StringLiteral;
          }
          M.isStringLiteral = Yi;
          function Wi(ai) {
            return ai.kind === re.SyntaxKind.SwitchStatement;
          }
          M.isSwitchStatement = Wi;
          function ct(ai) {
            return ai.kind === re.SyntaxKind.SyntaxList;
          }
          M.isSyntaxList = ct;
          function Li(ai) {
            return ai.kind === re.SyntaxKind.TaggedTemplateExpression;
          }
          M.isTaggedTemplateExpression = Li;
          function nt(ai) {
            return ai.kind === re.SyntaxKind.TemplateExpression;
          }
          M.isTemplateExpression = nt;
          function Mt(ai) {
            return ai.kind === re.SyntaxKind.TemplateExpression || ai.kind === re.SyntaxKind.NoSubstitutionTemplateLiteral;
          }
          M.isTemplateLiteral = Mt;
          function xt(ai) {
            return ai.kind === re.SyntaxKind.StringLiteral || ai.kind === re.SyntaxKind.NoSubstitutionTemplateLiteral;
          }
          M.isTextualLiteral = xt;
          function ut(ai) {
            return ai.kind === re.SyntaxKind.ThrowStatement;
          }
          M.isThrowStatement = ut;
          function Dt(ai) {
            return ai.kind === re.SyntaxKind.TryStatement;
          }
          M.isTryStatement = Dt;
          function Rt(ai) {
            return ai.kind === re.SyntaxKind.TupleType;
          }
          M.isTupleTypeNode = Rt;
          function Ii(ai) {
            return ai.kind === re.SyntaxKind.TypeAliasDeclaration;
          }
          M.isTypeAliasDeclaration = Ii;
          function Ki(ai) {
            return ai.kind === re.SyntaxKind.TypeAssertionExpression;
          }
          M.isTypeAssertion = Ki;
          function Fi(ai) {
            return ai.kind === re.SyntaxKind.TypeLiteral;
          }
          M.isTypeLiteralNode = Fi;
          function ui(ai) {
            return ai.kind === re.SyntaxKind.TypeOfExpression;
          }
          M.isTypeOfExpression = ui;
          function Bt(ai) {
            return ai.kind === re.SyntaxKind.TypeOperator;
          }
          M.isTypeOperatorNode = Bt;
          function wt(ai) {
            return ai.kind === re.SyntaxKind.TypeParameter;
          }
          M.isTypeParameterDeclaration = wt;
          function na(ai) {
            return ai.kind === re.SyntaxKind.TypePredicate;
          }
          M.isTypePredicateNode = na;
          function Ai(ai) {
            return ai.kind === re.SyntaxKind.TypeReference;
          }
          M.isTypeReferenceNode = Ai;
          function Oi(ai) {
            return ai.kind === re.SyntaxKind.TypeQuery;
          }
          M.isTypeQueryNode = Oi;
          function ji(ai) {
            return ai.kind === re.SyntaxKind.UnionType;
          }
          M.isUnionTypeNode = ji;
          function Vi(ai) {
            return ai.kind === re.SyntaxKind.VariableDeclaration;
          }
          M.isVariableDeclaration = Vi;
          function at(ai) {
            return ai.kind === re.SyntaxKind.VariableStatement;
          }
          M.isVariableStatement = at;
          function At(ai) {
            return ai.kind === re.SyntaxKind.VariableDeclarationList;
          }
          M.isVariableDeclarationList = At;
          function ba(ai) {
            return ai.kind === re.SyntaxKind.VoidExpression;
          }
          M.isVoidExpression = ba;
          function $a(ai) {
            return ai.kind === re.SyntaxKind.WhileStatement;
          }
          M.isWhileStatement = $a;
          function Qa(ai) {
            return ai.kind === re.SyntaxKind.WithStatement;
          }
          M.isWithStatement = Qa;
        } }), GU = Oa({ "node_modules/tsutils/typeguard/2.9/node.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.isImportTypeNode = void 0;
          var re = (ug(), mp(Ud));
          re.__exportStar(KU(), M);
          var Ve = _u();
          function Ke(oi) {
            return oi.kind === Ve.SyntaxKind.ImportType;
          }
          M.isImportTypeNode = Ke;
        } }), HU = Oa({ "node_modules/tsutils/typeguard/3.0/node.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.isSyntheticExpression = M.isRestTypeNode = M.isOptionalTypeNode = void 0;
          var re = (ug(), mp(Ud));
          re.__exportStar(GU(), M);
          var Ve = _u();
          function Ke(pr) {
            return pr.kind === Ve.SyntaxKind.OptionalType;
          }
          M.isOptionalTypeNode = Ke;
          function oi(pr) {
            return pr.kind === Ve.SyntaxKind.RestType;
          }
          M.isRestTypeNode = oi;
          function kr(pr) {
            return pr.kind === Ve.SyntaxKind.SyntheticExpression;
          }
          M.isSyntheticExpression = kr;
        } }), i3 = Oa({ "node_modules/tsutils/typeguard/3.2/node.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.isBigIntLiteral = void 0;
          var re = (ug(), mp(Ud));
          re.__exportStar(HU(), M);
          var Ve = _u();
          function Ke(oi) {
            return oi.kind === Ve.SyntaxKind.BigIntLiteral;
          }
          M.isBigIntLiteral = Ke;
        } }), t3 = Oa({ "node_modules/tsutils/typeguard/node.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
          var re = (ug(), mp(Ud));
          re.__exportStar(i3(), M);
        } }), XU = Oa({ "node_modules/tsutils/typeguard/2.8/type.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.isUniqueESSymbolType = M.isUnionType = M.isUnionOrIntersectionType = M.isTypeVariable = M.isTypeReference = M.isTypeParameter = M.isSubstitutionType = M.isObjectType = M.isLiteralType = M.isIntersectionType = M.isInterfaceType = M.isInstantiableType = M.isIndexedAccessype = M.isIndexedAccessType = M.isGenericType = M.isEnumType = M.isConditionalType = void 0;
          var re = _u();
          function Ve(p) {
            return (p.flags & re.TypeFlags.Conditional) !== 0;
          }
          M.isConditionalType = Ve;
          function Ke(p) {
            return (p.flags & re.TypeFlags.Enum) !== 0;
          }
          M.isEnumType = Ke;
          function oi(p) {
            return (p.flags & re.TypeFlags.Object) !== 0 && (p.objectFlags & re.ObjectFlags.ClassOrInterface) !== 0 && (p.objectFlags & re.ObjectFlags.Reference) !== 0;
          }
          M.isGenericType = oi;
          function kr(p) {
            return (p.flags & re.TypeFlags.IndexedAccess) !== 0;
          }
          M.isIndexedAccessType = kr;
          function pr(p) {
            return (p.flags & re.TypeFlags.Index) !== 0;
          }
          M.isIndexedAccessype = pr;
          function Lr(p) {
            return (p.flags & re.TypeFlags.Instantiable) !== 0;
          }
          M.isInstantiableType = Lr;
          function ar(p) {
            return (p.flags & re.TypeFlags.Object) !== 0 && (p.objectFlags & re.ObjectFlags.ClassOrInterface) !== 0;
          }
          M.isInterfaceType = ar;
          function ke(p) {
            return (p.flags & re.TypeFlags.Intersection) !== 0;
          }
          M.isIntersectionType = ke;
          function e(p) {
            return (p.flags & (re.TypeFlags.StringOrNumberLiteral | re.TypeFlags.BigIntLiteral)) !== 0;
          }
          M.isLiteralType = e;
          function a(p) {
            return (p.flags & re.TypeFlags.Object) !== 0;
          }
          M.isObjectType = a;
          function C(p) {
            return (p.flags & re.TypeFlags.Substitution) !== 0;
          }
          M.isSubstitutionType = C;
          function w(p) {
            return (p.flags & re.TypeFlags.TypeParameter) !== 0;
          }
          M.isTypeParameter = w;
          function B(p) {
            return (p.flags & re.TypeFlags.Object) !== 0 && (p.objectFlags & re.ObjectFlags.Reference) !== 0;
          }
          M.isTypeReference = B;
          function E(p) {
            return (p.flags & re.TypeFlags.TypeVariable) !== 0;
          }
          M.isTypeVariable = E;
          function Q(p) {
            return (p.flags & re.TypeFlags.UnionOrIntersection) !== 0;
          }
          M.isUnionOrIntersectionType = Q;
          function le(p) {
            return (p.flags & re.TypeFlags.Union) !== 0;
          }
          M.isUnionType = le;
          function N(p) {
            return (p.flags & re.TypeFlags.UniqueESSymbol) !== 0;
          }
          M.isUniqueESSymbolType = N;
        } }), D4 = Oa({ "node_modules/tsutils/typeguard/2.9/type.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
          var re = (ug(), mp(Ud));
          re.__exportStar(XU(), M);
        } }), QU = Oa({ "node_modules/tsutils/typeguard/3.0/type.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.isTupleTypeReference = M.isTupleType = void 0;
          var re = (ug(), mp(Ud));
          re.__exportStar(D4(), M);
          var Ve = _u(), Ke = D4();
          function oi(pr) {
            return (pr.flags & Ve.TypeFlags.Object && pr.objectFlags & Ve.ObjectFlags.Tuple) !== 0;
          }
          M.isTupleType = oi;
          function kr(pr) {
            return Ke.isTypeReference(pr) && oi(pr.target);
          }
          M.isTupleTypeReference = kr;
        } }), a3 = Oa({ "node_modules/tsutils/typeguard/3.2/type.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
          var re = (ug(), mp(Ud));
          re.__exportStar(QU(), M);
        } }), YU = Oa({ "node_modules/tsutils/typeguard/3.2/index.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
          var re = (ug(), mp(Ud));
          re.__exportStar(i3(), M), re.__exportStar(a3(), M);
        } }), $U = Oa({ "node_modules/tsutils/typeguard/type.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
          var re = (ug(), mp(Ud));
          re.__exportStar(a3(), M);
        } }), ZU = Oa({ "node_modules/tsutils/util/type.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.getBaseClassMemberOfClassElement = M.getIteratorYieldResultFromIteratorResult = M.getInstanceTypeOfClassLikeDeclaration = M.getConstructorTypeOfClassLikeDeclaration = M.getSymbolOfClassLikeDeclaration = M.getPropertyNameFromType = M.symbolHasReadonlyDeclaration = M.isPropertyReadonlyInType = M.getWellKnownSymbolPropertyOfType = M.getPropertyOfType = M.isBooleanLiteralType = M.isFalsyType = M.isThenableType = M.someTypePart = M.intersectionTypeParts = M.unionTypeParts = M.getCallSignaturesOfType = M.isTypeAssignableToString = M.isTypeAssignableToNumber = M.isOptionalChainingUndefinedMarkerType = M.removeOptionalChainingUndefinedMarkerType = M.removeOptionalityFromType = M.isEmptyObjectType = void 0;
          var re = _u(), Ve = $U(), Ke = n3(), oi = t3();
          function kr(F) {
            if (Ve.isObjectType(F) && F.objectFlags & re.ObjectFlags.Anonymous && F.getProperties().length === 0 && F.getCallSignatures().length === 0 && F.getConstructSignatures().length === 0 && F.getStringIndexType() === void 0 && F.getNumberIndexType() === void 0) {
              let x = F.getBaseTypes();
              return x === void 0 || x.every(kr);
            }
            return false;
          }
          M.isEmptyObjectType = kr;
          function pr(F, x) {
            if (!Lr(x, re.TypeFlags.Undefined)) return x;
            let X = Lr(x, re.TypeFlags.Null);
            return x = F.getNonNullableType(x), X ? F.getNullableType(x, re.TypeFlags.Null) : x;
          }
          M.removeOptionalityFromType = pr;
          function Lr(F, x) {
            for (let X of B(F)) if (Ke.isTypeFlagSet(X, x)) return true;
            return false;
          }
          function ar(F, x) {
            if (!Ve.isUnionType(x)) return ke(F, x) ? x.getNonNullableType() : x;
            let X = 0, $ = false;
            for (let A of x.types) ke(F, A) ? $ = true : X |= A.flags;
            return $ ? F.getNullableType(x.getNonNullableType(), X) : x;
          }
          M.removeOptionalChainingUndefinedMarkerType = ar;
          function ke(F, x) {
            return Ke.isTypeFlagSet(x, re.TypeFlags.Undefined) && F.getNullableType(x.getNonNullableType(), re.TypeFlags.Undefined) !== x;
          }
          M.isOptionalChainingUndefinedMarkerType = ke;
          function e(F, x) {
            return C(F, x, re.TypeFlags.NumberLike);
          }
          M.isTypeAssignableToNumber = e;
          function a(F, x) {
            return C(F, x, re.TypeFlags.StringLike);
          }
          M.isTypeAssignableToString = a;
          function C(F, x, X) {
            X |= re.TypeFlags.Any;
            let $;
            return function A(y) {
              if (Ve.isTypeParameter(y) && y.symbol !== void 0 && y.symbol.declarations !== void 0) {
                if ($ === void 0) $ = /* @__PURE__ */ new Set([y]);
                else if (!$.has(y)) $.add(y);
                else return false;
                let V = y.symbol.declarations[0];
                return V.constraint === void 0 ? true : A(F.getTypeFromTypeNode(V.constraint));
              }
              return Ve.isUnionType(y) ? y.types.every(A) : Ve.isIntersectionType(y) ? y.types.some(A) : Ke.isTypeFlagSet(y, X);
            }(x);
          }
          function w(F) {
            if (Ve.isUnionType(F)) {
              let x = [];
              for (let X of F.types) x.push(...w(X));
              return x;
            }
            if (Ve.isIntersectionType(F)) {
              let x;
              for (let X of F.types) {
                let $ = w(X);
                if ($.length !== 0) {
                  if (x !== void 0) return [];
                  x = $;
                }
              }
              return x === void 0 ? [] : x;
            }
            return F.getCallSignatures();
          }
          M.getCallSignaturesOfType = w;
          function B(F) {
            return Ve.isUnionType(F) ? F.types : [F];
          }
          M.unionTypeParts = B;
          function E(F) {
            return Ve.isIntersectionType(F) ? F.types : [F];
          }
          M.intersectionTypeParts = E;
          function Q(F, x, X) {
            return x(F) ? F.types.some(X) : X(F);
          }
          M.someTypePart = Q;
          function le(F, x) {
            let X = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : F.getTypeAtLocation(x);
            for (let $ of B(F.getApparentType(X))) {
              let A = $.getProperty("then");
              if (A === void 0) continue;
              let y = F.getTypeOfSymbolAtLocation(A, x);
              for (let V of B(y)) for (let L of V.getCallSignatures()) if (L.parameters.length !== 0 && N(F, L.parameters[0], x)) return true;
            }
            return false;
          }
          M.isThenableType = le;
          function N(F, x, X) {
            let $ = F.getApparentType(F.getTypeOfSymbolAtLocation(x, X));
            if (x.valueDeclaration.dotDotDotToken && ($ = $.getNumberIndexType(), $ === void 0)) return false;
            for (let A of B($)) if (A.getCallSignatures().length !== 0) return true;
            return false;
          }
          function p(F) {
            return F.flags & (re.TypeFlags.Undefined | re.TypeFlags.Null | re.TypeFlags.Void) ? true : Ve.isLiteralType(F) ? !F.value : m(F, false);
          }
          M.isFalsyType = p;
          function m(F, x) {
            return Ke.isTypeFlagSet(F, re.TypeFlags.BooleanLiteral) && F.intrinsicName === (x ? "true" : "false");
          }
          M.isBooleanLiteralType = m;
          function G(F, x) {
            return x.startsWith("__") ? F.getProperties().find((X) => X.escapedName === x) : F.getProperty(x);
          }
          M.getPropertyOfType = G;
          function oe(F, x, X) {
            let $ = "__@" + x;
            for (let A of F.getProperties()) {
              if (!A.name.startsWith($)) continue;
              let y = X.getApparentType(X.getTypeAtLocation(A.valueDeclaration.name.expression)).symbol;
              if (A.escapedName === f(X, y, x)) return A;
            }
          }
          M.getWellKnownSymbolPropertyOfType = oe;
          function f(F, x, X) {
            let $ = x && F.getTypeOfSymbolAtLocation(x, x.valueDeclaration).getProperty(X), A = $ && F.getTypeOfSymbolAtLocation($, $.valueDeclaration);
            return A && Ve.isUniqueESSymbolType(A) ? A.escapedName : "__@" + X;
          }
          function T(F, x, X) {
            let $ = false, A = false;
            for (let y of B(F)) if (G(y, x) === void 0) {
              let V = (Ke.isNumericPropertyName(x) ? X.getIndexInfoOfType(y, re.IndexKind.Number) : void 0) || X.getIndexInfoOfType(y, re.IndexKind.String);
              if (V !== void 0 && V.isReadonly) {
                if ($) return true;
                A = true;
              }
            } else {
              if (A || K(y, x, X)) return true;
              $ = true;
            }
            return false;
          }
          M.isPropertyReadonlyInType = T;
          function K(F, x, X) {
            return Q(F, Ve.isIntersectionType, ($) => {
              let A = G($, x);
              if (A === void 0) return false;
              if (A.flags & re.SymbolFlags.Transient) {
                if (/^(?:[1-9]\d*|0)$/.test(x) && Ve.isTupleTypeReference($)) return $.target.readonly;
                switch (b($, x, X)) {
                  case true:
                    return true;
                  case false:
                    return false;
                  default:
                }
              }
              return Ke.isSymbolFlagSet(A, re.SymbolFlags.ValueModule) || se(A, X);
            });
          }
          function b(F, x, X) {
            if (!Ve.isObjectType(F) || !Ke.isObjectFlagSet(F, re.ObjectFlags.Mapped)) return;
            let $ = F.symbol.declarations[0];
            return $.readonlyToken !== void 0 && !/^__@[^@]+$/.test(x) ? $.readonlyToken.kind !== re.SyntaxKind.MinusToken : T(F.modifiersType, x, X);
          }
          function se(F, x) {
            return (F.flags & re.SymbolFlags.Accessor) === re.SymbolFlags.GetAccessor || F.declarations !== void 0 && F.declarations.some((X) => Ke.isModifierFlagSet(X, re.ModifierFlags.Readonly) || oi.isVariableDeclaration(X) && Ke.isNodeFlagSet(X.parent, re.NodeFlags.Const) || oi.isCallExpression(X) && Ke.isReadonlyAssignmentDeclaration(X, x) || oi.isEnumMember(X) || (oi.isPropertyAssignment(X) || oi.isShorthandPropertyAssignment(X)) && Ke.isInConstContext(X.parent));
          }
          M.symbolHasReadonlyDeclaration = se;
          function J(F) {
            if (F.flags & (re.TypeFlags.StringLiteral | re.TypeFlags.NumberLiteral)) {
              let x = String(F.value);
              return { displayName: x, symbolName: re.escapeLeadingUnderscores(x) };
            }
            if (Ve.isUniqueESSymbolType(F)) return { displayName: "[".concat(F.symbol ? "".concat(ie(F.symbol) ? "Symbol." : "").concat(F.symbol.name) : F.escapedName.replace(/^__@|@\d+$/g, ""), "]"), symbolName: F.escapedName };
          }
          M.getPropertyNameFromType = J;
          function ie(F) {
            return Ke.isSymbolFlagSet(F, re.SymbolFlags.Property) && F.valueDeclaration !== void 0 && oi.isInterfaceDeclaration(F.valueDeclaration.parent) && F.valueDeclaration.parent.name.text === "SymbolConstructor" && R(F.valueDeclaration.parent);
          }
          function R(F) {
            return Ke.isNodeFlagSet(F.parent, re.NodeFlags.GlobalAugmentation) || oi.isSourceFile(F.parent) && !re.isExternalModule(F.parent);
          }
          function q(F, x) {
            var X;
            return x.getSymbolAtLocation((X = F.name) !== null && X !== void 0 ? X : Ke.getChildOfKind(F, re.SyntaxKind.ClassKeyword));
          }
          M.getSymbolOfClassLikeDeclaration = q;
          function O(F, x) {
            return F.kind === re.SyntaxKind.ClassExpression ? x.getTypeAtLocation(F) : x.getTypeOfSymbolAtLocation(q(F, x), F);
          }
          M.getConstructorTypeOfClassLikeDeclaration = O;
          function ve(F, x) {
            return F.kind === re.SyntaxKind.ClassDeclaration ? x.getTypeAtLocation(F) : x.getDeclaredTypeOfSymbol(q(F, x));
          }
          M.getInstanceTypeOfClassLikeDeclaration = ve;
          function ee(F, x, X) {
            return Ve.isUnionType(F) && F.types.find(($) => {
              let A = $.getProperty("done");
              return A !== void 0 && m(pr(X, X.getTypeOfSymbolAtLocation(A, x)), false);
            }) || F;
          }
          M.getIteratorYieldResultFromIteratorResult = ee;
          function he(F, x) {
            if (!oi.isClassLikeDeclaration(F.parent)) return;
            let X = Ke.getBaseOfClassLikeExpression(F.parent);
            if (X === void 0) return;
            let $ = Ke.getSingleLateBoundPropertyNameOfPropertyName(F.name, x);
            if ($ === void 0) return;
            let A = x.getTypeAtLocation(Ke.hasModifier(F.modifiers, re.SyntaxKind.StaticKeyword) ? X.expression : X);
            return G(A, $.symbolName);
          }
          M.getBaseClassMemberOfClassElement = he;
        } }), n3 = Oa({ "node_modules/tsutils/util/util.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.isValidIdentifier = M.getLineBreakStyle = M.getLineRanges = M.forEachComment = M.forEachTokenWithTrivia = M.forEachToken = M.isFunctionWithBody = M.hasOwnThisReference = M.isBlockScopeBoundary = M.isFunctionScopeBoundary = M.isTypeScopeBoundary = M.isScopeBoundary = M.ScopeBoundarySelector = M.ScopeBoundary = M.isInSingleStatementContext = M.isBlockScopedDeclarationStatement = M.isBlockScopedVariableDeclaration = M.isBlockScopedVariableDeclarationList = M.getVariableDeclarationKind = M.VariableDeclarationKind = M.forEachDeclaredVariable = M.forEachDestructuringIdentifier = M.getPropertyName = M.getWrappedNodeAtPosition = M.getAstNodeAtPosition = M.commentText = M.isPositionInComment = M.getCommentAtPosition = M.getTokenAtPosition = M.getNextToken = M.getPreviousToken = M.getNextStatement = M.getPreviousStatement = M.isModifierFlagSet = M.isObjectFlagSet = M.isSymbolFlagSet = M.isTypeFlagSet = M.isNodeFlagSet = M.hasAccessModifier = M.isParameterProperty = M.hasModifier = M.getModifier = M.isThisParameter = M.isKeywordKind = M.isJsDocKind = M.isTypeNodeKind = M.isAssignmentKind = M.isNodeKind = M.isTokenKind = M.getChildOfKind = void 0, M.getBaseOfClassLikeExpression = M.hasExhaustiveCaseClauses = M.formatPseudoBigInt = M.unwrapParentheses = M.getSingleLateBoundPropertyNameOfPropertyName = M.getLateBoundPropertyNamesOfPropertyName = M.getLateBoundPropertyNames = M.getPropertyNameOfWellKnownSymbol = M.isWellKnownSymbolLiterally = M.isBindableObjectDefinePropertyCall = M.isReadonlyAssignmentDeclaration = M.isInConstContext = M.isConstAssertion = M.getTsCheckDirective = M.getCheckJsDirective = M.isAmbientModule = M.isCompilerOptionEnabled = M.isStrictCompilerOptionEnabled = M.getIIFE = M.isAmbientModuleBlock = M.isStatementInAmbientContext = M.findImportLikeNodes = M.findImports = M.ImportKind = M.parseJsDocOfNode = M.getJsDoc = M.canHaveJsDoc = M.isReassignmentTarget = M.getAccessKind = M.AccessKind = M.isExpressionValueUsed = M.getDeclarationOfBindingElement = M.hasSideEffects = M.SideEffectOptions = M.isSameLine = M.isNumericPropertyName = M.isValidJsxIdentifier = M.isValidNumericLiteral = M.isValidPropertyName = M.isValidPropertyAccess = void 0;
          var re = _u(), Ve = t3(), Ke = YU(), oi = ZU();
          function kr(ae, Xe, Jr) {
            for (let ti of ae.getChildren(Jr)) if (ti.kind === Xe) return ti;
          }
          M.getChildOfKind = kr;
          function pr(ae) {
            return ae >= re.SyntaxKind.FirstToken && ae <= re.SyntaxKind.LastToken;
          }
          M.isTokenKind = pr;
          function Lr(ae) {
            return ae >= re.SyntaxKind.FirstNode;
          }
          M.isNodeKind = Lr;
          function ar(ae) {
            return ae >= re.SyntaxKind.FirstAssignment && ae <= re.SyntaxKind.LastAssignment;
          }
          M.isAssignmentKind = ar;
          function ke(ae) {
            return ae >= re.SyntaxKind.FirstTypeNode && ae <= re.SyntaxKind.LastTypeNode;
          }
          M.isTypeNodeKind = ke;
          function e(ae) {
            return ae >= re.SyntaxKind.FirstJSDocNode && ae <= re.SyntaxKind.LastJSDocNode;
          }
          M.isJsDocKind = e;
          function a(ae) {
            return ae >= re.SyntaxKind.FirstKeyword && ae <= re.SyntaxKind.LastKeyword;
          }
          M.isKeywordKind = a;
          function C(ae) {
            return ae.name.kind === re.SyntaxKind.Identifier && ae.name.originalKeywordKind === re.SyntaxKind.ThisKeyword;
          }
          M.isThisParameter = C;
          function w(ae, Xe) {
            if (ae.modifiers !== void 0) {
              for (let Jr of ae.modifiers) if (Jr.kind === Xe) return Jr;
            }
          }
          M.getModifier = w;
          function B(ae) {
            if (ae === void 0) return false;
            for (var Xe = arguments.length, Jr = new Array(Xe > 1 ? Xe - 1 : 0), ti = 1; ti < Xe; ti++) Jr[ti - 1] = arguments[ti];
            for (let Ze of ae) if (Jr.includes(Ze.kind)) return true;
            return false;
          }
          M.hasModifier = B;
          function E(ae) {
            return B(ae.modifiers, re.SyntaxKind.PublicKeyword, re.SyntaxKind.ProtectedKeyword, re.SyntaxKind.PrivateKeyword, re.SyntaxKind.ReadonlyKeyword);
          }
          M.isParameterProperty = E;
          function Q(ae) {
            return p(ae, re.ModifierFlags.AccessibilityModifier);
          }
          M.hasAccessModifier = Q;
          function le(ae, Xe) {
            return (ae.flags & Xe) !== 0;
          }
          M.isNodeFlagSet = le, M.isTypeFlagSet = le, M.isSymbolFlagSet = le;
          function N(ae, Xe) {
            return (ae.objectFlags & Xe) !== 0;
          }
          M.isObjectFlagSet = N;
          function p(ae, Xe) {
            return (re.getCombinedModifierFlags(ae) & Xe) !== 0;
          }
          M.isModifierFlagSet = p;
          function m(ae) {
            let Xe = ae.parent;
            if (Ve.isBlockLike(Xe)) {
              let Jr = Xe.statements.indexOf(ae);
              if (Jr > 0) return Xe.statements[Jr - 1];
            }
          }
          M.getPreviousStatement = m;
          function G(ae) {
            let Xe = ae.parent;
            if (Ve.isBlockLike(Xe)) {
              let Jr = Xe.statements.indexOf(ae);
              if (Jr < Xe.statements.length) return Xe.statements[Jr + 1];
            }
          }
          M.getNextStatement = G;
          function oe(ae, Xe) {
            let { pos: Jr } = ae;
            if (Jr !== 0) {
              do
                ae = ae.parent;
              while (ae.pos === Jr);
              return K(ae, Jr - 1, Xe != null ? Xe : ae.getSourceFile(), false);
            }
          }
          M.getPreviousToken = oe;
          function f(ae, Xe) {
            if (ae.kind === re.SyntaxKind.SourceFile || ae.kind === re.SyntaxKind.EndOfFileToken) return;
            let Jr = ae.end;
            for (ae = ae.parent; ae.end === Jr; ) {
              if (ae.parent === void 0) return ae.endOfFileToken;
              ae = ae.parent;
            }
            return K(ae, Jr, Xe != null ? Xe : ae.getSourceFile(), false);
          }
          M.getNextToken = f;
          function T(ae, Xe, Jr, ti) {
            if (!(Xe < ae.pos || Xe >= ae.end)) return pr(ae.kind) ? ae : K(ae, Xe, Jr != null ? Jr : ae.getSourceFile(), ti === true);
          }
          M.getTokenAtPosition = T;
          function K(ae, Xe, Jr, ti) {
            if (!ti && (ae = R(ae, Xe), pr(ae.kind))) return ae;
            e: for (; ; ) {
              for (let Ze of ae.getChildren(Jr)) if (Ze.end > Xe && (ti || Ze.kind !== re.SyntaxKind.JSDocComment)) {
                if (pr(Ze.kind)) return Ze;
                ae = Ze;
                continue e;
              }
              return;
            }
          }
          function b(ae, Xe) {
            let Jr = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : ae, ti = T(Jr, Xe, ae);
            if (ti === void 0 || ti.kind === re.SyntaxKind.JsxText || Xe >= ti.end - (re.tokenToString(ti.kind) || "").length) return;
            let Ze = ti.pos === 0 ? (re.getShebang(ae.text) || "").length : ti.pos;
            return Ze !== 0 && re.forEachTrailingCommentRange(ae.text, Ze, se, Xe) || re.forEachLeadingCommentRange(ae.text, Ze, se, Xe);
          }
          M.getCommentAtPosition = b;
          function se(ae, Xe, Jr, ti, Ze) {
            return Ze >= ae && Ze < Xe ? { pos: ae, end: Xe, kind: Jr } : void 0;
          }
          function J(ae, Xe, Jr) {
            return b(ae, Xe, Jr) !== void 0;
          }
          M.isPositionInComment = J;
          function ie(ae, Xe) {
            return ae.substring(Xe.pos + 2, Xe.kind === re.SyntaxKind.SingleLineCommentTrivia ? Xe.end : Xe.end - 2);
          }
          M.commentText = ie;
          function R(ae, Xe) {
            if (!(ae.pos > Xe || ae.end <= Xe)) {
              for (; Lr(ae.kind); ) {
                let Jr = re.forEachChild(ae, (ti) => ti.pos <= Xe && ti.end > Xe ? ti : void 0);
                if (Jr === void 0) break;
                ae = Jr;
              }
              return ae;
            }
          }
          M.getAstNodeAtPosition = R;
          function q(ae, Xe) {
            if (ae.node.pos > Xe || ae.node.end <= Xe) return;
            e: for (; ; ) {
              for (let Jr of ae.children) {
                if (Jr.node.pos > Xe) return ae;
                if (Jr.node.end > Xe) {
                  ae = Jr;
                  continue e;
                }
              }
              return ae;
            }
          }
          M.getWrappedNodeAtPosition = q;
          function O(ae) {
            if (ae.kind === re.SyntaxKind.ComputedPropertyName) {
              let Xe = Gi(ae.expression);
              if (Ve.isPrefixUnaryExpression(Xe)) {
                let Jr = false;
                switch (Xe.operator) {
                  case re.SyntaxKind.MinusToken:
                    Jr = true;
                  case re.SyntaxKind.PlusToken:
                    return Ve.isNumericLiteral(Xe.operand) ? "".concat(Jr ? "-" : "").concat(Xe.operand.text) : Ke.isBigIntLiteral(Xe.operand) ? "".concat(Jr ? "-" : "").concat(Xe.operand.text.slice(0, -1)) : void 0;
                  default:
                    return;
                }
              }
              return Ke.isBigIntLiteral(Xe) ? Xe.text.slice(0, -1) : Ve.isNumericOrStringLikeLiteral(Xe) ? Xe.text : void 0;
            }
            return ae.kind === re.SyntaxKind.PrivateIdentifier ? void 0 : ae.text;
          }
          M.getPropertyName = O;
          function ve(ae, Xe) {
            for (let Jr of ae.elements) {
              if (Jr.kind !== re.SyntaxKind.BindingElement) continue;
              let ti;
              if (Jr.name.kind === re.SyntaxKind.Identifier ? ti = Xe(Jr) : ti = ve(Jr.name, Xe), ti) return ti;
            }
          }
          M.forEachDestructuringIdentifier = ve;
          function ee(ae, Xe) {
            for (let Jr of ae.declarations) {
              let ti;
              if (Jr.name.kind === re.SyntaxKind.Identifier ? ti = Xe(Jr) : ti = ve(Jr.name, Xe), ti) return ti;
            }
          }
          M.forEachDeclaredVariable = ee;
          var he;
          (function(ae) {
            ae[ae.Var = 0] = "Var", ae[ae.Let = 1] = "Let", ae[ae.Const = 2] = "Const";
          })(he = M.VariableDeclarationKind || (M.VariableDeclarationKind = {}));
          function F(ae) {
            return ae.flags & re.NodeFlags.Let ? 1 : ae.flags & re.NodeFlags.Const ? 2 : 0;
          }
          M.getVariableDeclarationKind = F;
          function x(ae) {
            return (ae.flags & re.NodeFlags.BlockScoped) !== 0;
          }
          M.isBlockScopedVariableDeclarationList = x;
          function X(ae) {
            let Xe = ae.parent;
            return Xe.kind === re.SyntaxKind.CatchClause || x(Xe);
          }
          M.isBlockScopedVariableDeclaration = X;
          function $(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.VariableStatement:
                return x(ae.declarationList);
              case re.SyntaxKind.ClassDeclaration:
              case re.SyntaxKind.EnumDeclaration:
              case re.SyntaxKind.InterfaceDeclaration:
              case re.SyntaxKind.TypeAliasDeclaration:
                return true;
              default:
                return false;
            }
          }
          M.isBlockScopedDeclarationStatement = $;
          function A(ae) {
            switch (ae.parent.kind) {
              case re.SyntaxKind.ForStatement:
              case re.SyntaxKind.ForInStatement:
              case re.SyntaxKind.ForOfStatement:
              case re.SyntaxKind.WhileStatement:
              case re.SyntaxKind.DoStatement:
              case re.SyntaxKind.IfStatement:
              case re.SyntaxKind.WithStatement:
              case re.SyntaxKind.LabeledStatement:
                return true;
              default:
                return false;
            }
          }
          M.isInSingleStatementContext = A;
          var y;
          (function(ae) {
            ae[ae.None = 0] = "None", ae[ae.Function = 1] = "Function", ae[ae.Block = 2] = "Block", ae[ae.Type = 4] = "Type", ae[ae.ConditionalType = 8] = "ConditionalType";
          })(y = M.ScopeBoundary || (M.ScopeBoundary = {}));
          var V;
          (function(ae) {
            ae[ae.Function = 1] = "Function", ae[ae.Block = 3] = "Block", ae[ae.Type = 7] = "Type", ae[ae.InferType = 8] = "InferType";
          })(V = M.ScopeBoundarySelector || (M.ScopeBoundarySelector = {}));
          function L(ae) {
            return k(ae) || Y(ae) || P(ae);
          }
          M.isScopeBoundary = L;
          function P(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.InterfaceDeclaration:
              case re.SyntaxKind.TypeAliasDeclaration:
              case re.SyntaxKind.MappedType:
                return 4;
              case re.SyntaxKind.ConditionalType:
                return 8;
              default:
                return 0;
            }
          }
          M.isTypeScopeBoundary = P;
          function k(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.FunctionExpression:
              case re.SyntaxKind.ArrowFunction:
              case re.SyntaxKind.Constructor:
              case re.SyntaxKind.ModuleDeclaration:
              case re.SyntaxKind.ClassDeclaration:
              case re.SyntaxKind.ClassExpression:
              case re.SyntaxKind.EnumDeclaration:
              case re.SyntaxKind.MethodDeclaration:
              case re.SyntaxKind.FunctionDeclaration:
              case re.SyntaxKind.GetAccessor:
              case re.SyntaxKind.SetAccessor:
              case re.SyntaxKind.MethodSignature:
              case re.SyntaxKind.CallSignature:
              case re.SyntaxKind.ConstructSignature:
              case re.SyntaxKind.ConstructorType:
              case re.SyntaxKind.FunctionType:
                return 1;
              case re.SyntaxKind.SourceFile:
                return re.isExternalModule(ae) ? 1 : 0;
              default:
                return 0;
            }
          }
          M.isFunctionScopeBoundary = k;
          function Y(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.Block:
                let Xe = ae.parent;
                return Xe.kind !== re.SyntaxKind.CatchClause && (Xe.kind === re.SyntaxKind.SourceFile || !k(Xe)) ? 2 : 0;
              case re.SyntaxKind.ForStatement:
              case re.SyntaxKind.ForInStatement:
              case re.SyntaxKind.ForOfStatement:
              case re.SyntaxKind.CaseBlock:
              case re.SyntaxKind.CatchClause:
              case re.SyntaxKind.WithStatement:
                return 2;
              default:
                return 0;
            }
          }
          M.isBlockScopeBoundary = Y;
          function U(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.ClassDeclaration:
              case re.SyntaxKind.ClassExpression:
              case re.SyntaxKind.FunctionExpression:
                return true;
              case re.SyntaxKind.FunctionDeclaration:
                return ae.body !== void 0;
              case re.SyntaxKind.MethodDeclaration:
              case re.SyntaxKind.GetAccessor:
              case re.SyntaxKind.SetAccessor:
                return ae.parent.kind === re.SyntaxKind.ObjectLiteralExpression;
              default:
                return false;
            }
          }
          M.hasOwnThisReference = U;
          function j(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.GetAccessor:
              case re.SyntaxKind.SetAccessor:
              case re.SyntaxKind.FunctionDeclaration:
              case re.SyntaxKind.MethodDeclaration:
              case re.SyntaxKind.Constructor:
                return ae.body !== void 0;
              case re.SyntaxKind.FunctionExpression:
              case re.SyntaxKind.ArrowFunction:
                return true;
              default:
                return false;
            }
          }
          M.isFunctionWithBody = j;
          function H(ae, Xe) {
            let Jr = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : ae.getSourceFile(), ti = [];
            for (; ; ) {
              if (pr(ae.kind)) Xe(ae);
              else if (ae.kind !== re.SyntaxKind.JSDocComment) {
                let Ze = ae.getChildren(Jr);
                if (Ze.length === 1) {
                  ae = Ze[0];
                  continue;
                }
                for (let Sr = Ze.length - 1; Sr >= 0; --Sr) ti.push(Ze[Sr]);
              }
              if (ti.length === 0) break;
              ae = ti.pop();
            }
          }
          M.forEachToken = H;
          function I(ae, Xe) {
            let Jr = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : ae.getSourceFile(), ti = Jr.text, Ze = re.createScanner(Jr.languageVersion, false, Jr.languageVariant, ti);
            return H(ae, (Sr) => {
              let zr = Sr.kind === re.SyntaxKind.JsxText || Sr.pos === Sr.end ? Sr.pos : Sr.getStart(Jr);
              if (zr !== Sr.pos) {
                Ze.setTextPos(Sr.pos);
                let Wr = Ze.scan(), Je = Ze.getTokenPos();
                for (; Je < zr; ) {
                  let xe = Ze.getTextPos();
                  if (Xe(ti, Wr, { pos: Je, end: xe }, Sr.parent), xe === zr) break;
                  Wr = Ze.scan(), Je = Ze.getTokenPos();
                }
              }
              return Xe(ti, Sr.kind, { end: Sr.end, pos: zr }, Sr.parent);
            }, Jr);
          }
          M.forEachTokenWithTrivia = I;
          function l(ae, Xe) {
            let Jr = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : ae.getSourceFile(), ti = Jr.text, Ze = Jr.languageVariant !== re.LanguageVariant.JSX;
            return H(ae, (zr) => {
              if (zr.pos !== zr.end && (zr.kind !== re.SyntaxKind.JsxText && re.forEachLeadingCommentRange(ti, zr.pos === 0 ? (re.getShebang(ti) || "").length : zr.pos, Sr), Ze || d(zr))) return re.forEachTrailingCommentRange(ti, zr.end, Sr);
            }, Jr);
            function Sr(zr, Wr, Je) {
              Xe(ti, { pos: zr, end: Wr, kind: Je });
            }
          }
          M.forEachComment = l;
          function d(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.CloseBraceToken:
                return ae.parent.kind !== re.SyntaxKind.JsxExpression || !D(ae.parent.parent);
              case re.SyntaxKind.GreaterThanToken:
                switch (ae.parent.kind) {
                  case re.SyntaxKind.JsxOpeningElement:
                    return ae.end !== ae.parent.end;
                  case re.SyntaxKind.JsxOpeningFragment:
                    return false;
                  case re.SyntaxKind.JsxSelfClosingElement:
                    return ae.end !== ae.parent.end || !D(ae.parent.parent);
                  case re.SyntaxKind.JsxClosingElement:
                  case re.SyntaxKind.JsxClosingFragment:
                    return !D(ae.parent.parent.parent);
                }
            }
            return true;
          }
          function D(ae) {
            return ae.kind === re.SyntaxKind.JsxElement || ae.kind === re.SyntaxKind.JsxFragment;
          }
          function fe(ae) {
            let Xe = ae.getLineStarts(), Jr = [], ti = Xe.length, Ze = ae.text, Sr = 0;
            for (let zr = 1; zr < ti; ++zr) {
              let Wr = Xe[zr], Je = Wr;
              for (; Je > Sr && re.isLineBreak(Ze.charCodeAt(Je - 1)); --Je) ;
              Jr.push({ pos: Sr, end: Wr, contentLength: Je - Sr }), Sr = Wr;
            }
            return Jr.push({ pos: Sr, end: ae.end, contentLength: ae.end - Sr }), Jr;
          }
          M.getLineRanges = fe;
          function g(ae) {
            let Xe = ae.getLineStarts();
            return Xe.length === 1 || Xe[1] < 2 || ae.text[Xe[1] - 2] !== "\r" ? `
` : `\r
`;
          }
          M.getLineBreakStyle = g;
          var ne;
          function ue(ae, Xe) {
            return ne === void 0 ? ne = re.createScanner(Xe, false, void 0, ae) : (ne.setScriptTarget(Xe), ne.setText(ae)), ne.scan(), ne;
          }
          function We(ae) {
            let Xe = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : re.ScriptTarget.Latest, Jr = ue(ae, Xe);
            return Jr.isIdentifier() && Jr.getTextPos() === ae.length && Jr.getTokenPos() === 0;
          }
          M.isValidIdentifier = We;
          function Fe(ae) {
            return ae >= 65536 ? 2 : 1;
          }
          function Z(ae) {
            let Xe = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : re.ScriptTarget.Latest;
            if (ae.length === 0) return false;
            let Jr = ae.codePointAt(0);
            if (!re.isIdentifierStart(Jr, Xe)) return false;
            for (let ti = Fe(Jr); ti < ae.length; ti += Fe(Jr)) if (Jr = ae.codePointAt(ti), !re.isIdentifierPart(Jr, Xe)) return false;
            return true;
          }
          M.isValidPropertyAccess = Z;
          function Be(ae) {
            let Xe = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : re.ScriptTarget.Latest;
            if (Z(ae, Xe)) return true;
            let Jr = ue(ae, Xe);
            return Jr.getTextPos() === ae.length && Jr.getToken() === re.SyntaxKind.NumericLiteral && Jr.getTokenValue() === ae;
          }
          M.isValidPropertyName = Be;
          function ge(ae) {
            let Xe = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : re.ScriptTarget.Latest, Jr = ue(ae, Xe);
            return Jr.getToken() === re.SyntaxKind.NumericLiteral && Jr.getTextPos() === ae.length && Jr.getTokenPos() === 0;
          }
          M.isValidNumericLiteral = ge;
          function Re(ae) {
            let Xe = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : re.ScriptTarget.Latest;
            if (ae.length === 0) return false;
            let Jr = false, ti = ae.codePointAt(0);
            if (!re.isIdentifierStart(ti, Xe)) return false;
            for (let Ze = Fe(ti); Ze < ae.length; Ze += Fe(ti)) if (ti = ae.codePointAt(Ze), !re.isIdentifierPart(ti, Xe) && ti !== 45) if (!Jr && ti === 58 && Ze + Fe(ti) !== ae.length) Jr = true;
            else return false;
            return true;
          }
          M.isValidJsxIdentifier = Re;
          function ze(ae) {
            return String(+ae) === ae;
          }
          M.isNumericPropertyName = ze;
          function Ee(ae, Xe, Jr) {
            return re.getLineAndCharacterOfPosition(ae, Xe).line === re.getLineAndCharacterOfPosition(ae, Jr).line;
          }
          M.isSameLine = Ee;
          var He;
          (function(ae) {
            ae[ae.None = 0] = "None", ae[ae.TaggedTemplate = 1] = "TaggedTemplate", ae[ae.Constructor = 2] = "Constructor", ae[ae.JsxElement = 4] = "JsxElement";
          })(He = M.SideEffectOptions || (M.SideEffectOptions = {}));
          function rr(ae, Xe) {
            var Jr, ti;
            let Ze = [];
            for (; ; ) {
              switch (ae.kind) {
                case re.SyntaxKind.CallExpression:
                case re.SyntaxKind.PostfixUnaryExpression:
                case re.SyntaxKind.AwaitExpression:
                case re.SyntaxKind.YieldExpression:
                case re.SyntaxKind.DeleteExpression:
                  return true;
                case re.SyntaxKind.TypeAssertionExpression:
                case re.SyntaxKind.AsExpression:
                case re.SyntaxKind.ParenthesizedExpression:
                case re.SyntaxKind.NonNullExpression:
                case re.SyntaxKind.VoidExpression:
                case re.SyntaxKind.TypeOfExpression:
                case re.SyntaxKind.PropertyAccessExpression:
                case re.SyntaxKind.SpreadElement:
                case re.SyntaxKind.PartiallyEmittedExpression:
                  ae = ae.expression;
                  continue;
                case re.SyntaxKind.BinaryExpression:
                  if (ar(ae.operatorToken.kind)) return true;
                  Ze.push(ae.right), ae = ae.left;
                  continue;
                case re.SyntaxKind.PrefixUnaryExpression:
                  switch (ae.operator) {
                    case re.SyntaxKind.PlusPlusToken:
                    case re.SyntaxKind.MinusMinusToken:
                      return true;
                    default:
                      ae = ae.operand;
                      continue;
                  }
                case re.SyntaxKind.ElementAccessExpression:
                  ae.argumentExpression !== void 0 && Ze.push(ae.argumentExpression), ae = ae.expression;
                  continue;
                case re.SyntaxKind.ConditionalExpression:
                  Ze.push(ae.whenTrue, ae.whenFalse), ae = ae.condition;
                  continue;
                case re.SyntaxKind.NewExpression:
                  if (Xe & 2) return true;
                  ae.arguments !== void 0 && Ze.push(...ae.arguments), ae = ae.expression;
                  continue;
                case re.SyntaxKind.TaggedTemplateExpression:
                  if (Xe & 1) return true;
                  if (Ze.push(ae.tag), ae = ae.template, ae.kind === re.SyntaxKind.NoSubstitutionTemplateLiteral) break;
                case re.SyntaxKind.TemplateExpression:
                  for (let Sr of ae.templateSpans) Ze.push(Sr.expression);
                  break;
                case re.SyntaxKind.ClassExpression: {
                  if (ae.decorators !== void 0) return true;
                  for (let zr of ae.members) {
                    if (zr.decorators !== void 0) return true;
                    if (!B(zr.modifiers, re.SyntaxKind.DeclareKeyword)) if (((Jr = zr.name) === null || Jr === void 0 ? void 0 : Jr.kind) === re.SyntaxKind.ComputedPropertyName && Ze.push(zr.name.expression), Ve.isMethodDeclaration(zr)) {
                      for (let Wr of zr.parameters) if (Wr.decorators !== void 0) return true;
                    } else Ve.isPropertyDeclaration(zr) && zr.initializer !== void 0 && B(zr.modifiers, re.SyntaxKind.StaticKeyword) && Ze.push(zr.initializer);
                  }
                  let Sr = pi(ae);
                  if (Sr === void 0) break;
                  ae = Sr.expression;
                  continue;
                }
                case re.SyntaxKind.ArrayLiteralExpression:
                  Ze.push(...ae.elements);
                  break;
                case re.SyntaxKind.ObjectLiteralExpression:
                  for (let Sr of ae.properties) switch (((ti = Sr.name) === null || ti === void 0 ? void 0 : ti.kind) === re.SyntaxKind.ComputedPropertyName && Ze.push(Sr.name.expression), Sr.kind) {
                    case re.SyntaxKind.PropertyAssignment:
                      Ze.push(Sr.initializer);
                      break;
                    case re.SyntaxKind.SpreadAssignment:
                      Ze.push(Sr.expression);
                  }
                  break;
                case re.SyntaxKind.JsxExpression:
                  if (ae.expression === void 0) break;
                  ae = ae.expression;
                  continue;
                case re.SyntaxKind.JsxElement:
                case re.SyntaxKind.JsxFragment:
                  for (let Sr of ae.children) Sr.kind !== re.SyntaxKind.JsxText && Ze.push(Sr);
                  if (ae.kind === re.SyntaxKind.JsxFragment) break;
                  ae = ae.openingElement;
                case re.SyntaxKind.JsxSelfClosingElement:
                case re.SyntaxKind.JsxOpeningElement:
                  if (Xe & 4) return true;
                  for (let Sr of ae.attributes.properties) Sr.kind === re.SyntaxKind.JsxSpreadAttribute ? Ze.push(Sr.expression) : Sr.initializer !== void 0 && Ze.push(Sr.initializer);
                  break;
                case re.SyntaxKind.CommaListExpression:
                  Ze.push(...ae.elements);
              }
              if (Ze.length === 0) return false;
              ae = Ze.pop();
            }
          }
          M.hasSideEffects = rr;
          function Ie(ae) {
            let Xe = ae.parent.parent;
            for (; Xe.kind === re.SyntaxKind.BindingElement; ) Xe = Xe.parent.parent;
            return Xe;
          }
          M.getDeclarationOfBindingElement = Ie;
          function _e(ae) {
            for (; ; ) {
              let Xe = ae.parent;
              switch (Xe.kind) {
                case re.SyntaxKind.CallExpression:
                case re.SyntaxKind.NewExpression:
                case re.SyntaxKind.ElementAccessExpression:
                case re.SyntaxKind.WhileStatement:
                case re.SyntaxKind.DoStatement:
                case re.SyntaxKind.WithStatement:
                case re.SyntaxKind.ThrowStatement:
                case re.SyntaxKind.ReturnStatement:
                case re.SyntaxKind.JsxExpression:
                case re.SyntaxKind.JsxSpreadAttribute:
                case re.SyntaxKind.JsxElement:
                case re.SyntaxKind.JsxFragment:
                case re.SyntaxKind.JsxSelfClosingElement:
                case re.SyntaxKind.ComputedPropertyName:
                case re.SyntaxKind.ArrowFunction:
                case re.SyntaxKind.ExportSpecifier:
                case re.SyntaxKind.ExportAssignment:
                case re.SyntaxKind.ImportDeclaration:
                case re.SyntaxKind.ExternalModuleReference:
                case re.SyntaxKind.Decorator:
                case re.SyntaxKind.TaggedTemplateExpression:
                case re.SyntaxKind.TemplateSpan:
                case re.SyntaxKind.ExpressionWithTypeArguments:
                case re.SyntaxKind.TypeOfExpression:
                case re.SyntaxKind.AwaitExpression:
                case re.SyntaxKind.YieldExpression:
                case re.SyntaxKind.LiteralType:
                case re.SyntaxKind.JsxAttributes:
                case re.SyntaxKind.JsxOpeningElement:
                case re.SyntaxKind.JsxClosingElement:
                case re.SyntaxKind.IfStatement:
                case re.SyntaxKind.CaseClause:
                case re.SyntaxKind.SwitchStatement:
                  return true;
                case re.SyntaxKind.PropertyAccessExpression:
                  return Xe.expression === ae;
                case re.SyntaxKind.QualifiedName:
                  return Xe.left === ae;
                case re.SyntaxKind.ShorthandPropertyAssignment:
                  return Xe.objectAssignmentInitializer === ae || !we(Xe);
                case re.SyntaxKind.PropertyAssignment:
                  return Xe.initializer === ae && !we(Xe);
                case re.SyntaxKind.SpreadAssignment:
                case re.SyntaxKind.SpreadElement:
                case re.SyntaxKind.ArrayLiteralExpression:
                  return !we(Xe);
                case re.SyntaxKind.ParenthesizedExpression:
                case re.SyntaxKind.AsExpression:
                case re.SyntaxKind.TypeAssertionExpression:
                case re.SyntaxKind.PostfixUnaryExpression:
                case re.SyntaxKind.PrefixUnaryExpression:
                case re.SyntaxKind.NonNullExpression:
                  ae = Xe;
                  continue;
                case re.SyntaxKind.ForStatement:
                  return Xe.condition === ae;
                case re.SyntaxKind.ForInStatement:
                case re.SyntaxKind.ForOfStatement:
                  return Xe.expression === ae;
                case re.SyntaxKind.ConditionalExpression:
                  if (Xe.condition === ae) return true;
                  ae = Xe;
                  break;
                case re.SyntaxKind.PropertyDeclaration:
                case re.SyntaxKind.BindingElement:
                case re.SyntaxKind.VariableDeclaration:
                case re.SyntaxKind.Parameter:
                case re.SyntaxKind.EnumMember:
                  return Xe.initializer === ae;
                case re.SyntaxKind.ImportEqualsDeclaration:
                  return Xe.moduleReference === ae;
                case re.SyntaxKind.CommaListExpression:
                  if (Xe.elements[Xe.elements.length - 1] !== ae) return false;
                  ae = Xe;
                  break;
                case re.SyntaxKind.BinaryExpression:
                  if (Xe.right === ae) {
                    if (Xe.operatorToken.kind === re.SyntaxKind.CommaToken) {
                      ae = Xe;
                      break;
                    }
                    return true;
                  }
                  switch (Xe.operatorToken.kind) {
                    case re.SyntaxKind.CommaToken:
                    case re.SyntaxKind.EqualsToken:
                      return false;
                    case re.SyntaxKind.EqualsEqualsEqualsToken:
                    case re.SyntaxKind.EqualsEqualsToken:
                    case re.SyntaxKind.ExclamationEqualsEqualsToken:
                    case re.SyntaxKind.ExclamationEqualsToken:
                    case re.SyntaxKind.InstanceOfKeyword:
                    case re.SyntaxKind.PlusToken:
                    case re.SyntaxKind.MinusToken:
                    case re.SyntaxKind.AsteriskToken:
                    case re.SyntaxKind.SlashToken:
                    case re.SyntaxKind.PercentToken:
                    case re.SyntaxKind.AsteriskAsteriskToken:
                    case re.SyntaxKind.GreaterThanToken:
                    case re.SyntaxKind.GreaterThanGreaterThanToken:
                    case re.SyntaxKind.GreaterThanGreaterThanGreaterThanToken:
                    case re.SyntaxKind.GreaterThanEqualsToken:
                    case re.SyntaxKind.LessThanToken:
                    case re.SyntaxKind.LessThanLessThanToken:
                    case re.SyntaxKind.LessThanEqualsToken:
                    case re.SyntaxKind.AmpersandToken:
                    case re.SyntaxKind.BarToken:
                    case re.SyntaxKind.CaretToken:
                    case re.SyntaxKind.BarBarToken:
                    case re.SyntaxKind.AmpersandAmpersandToken:
                    case re.SyntaxKind.QuestionQuestionToken:
                    case re.SyntaxKind.InKeyword:
                    case re.SyntaxKind.QuestionQuestionEqualsToken:
                    case re.SyntaxKind.AmpersandAmpersandEqualsToken:
                    case re.SyntaxKind.BarBarEqualsToken:
                      return true;
                    default:
                      ae = Xe;
                  }
                  break;
                default:
                  return false;
              }
            }
          }
          M.isExpressionValueUsed = _e;
          function we(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.ShorthandPropertyAssignment:
                if (ae.objectAssignmentInitializer !== void 0) return true;
              case re.SyntaxKind.PropertyAssignment:
              case re.SyntaxKind.SpreadAssignment:
                ae = ae.parent;
                break;
              case re.SyntaxKind.SpreadElement:
                if (ae.parent.kind !== re.SyntaxKind.ArrayLiteralExpression) return false;
                ae = ae.parent;
            }
            for (; ; ) switch (ae.parent.kind) {
              case re.SyntaxKind.BinaryExpression:
                return ae.parent.left === ae && ae.parent.operatorToken.kind === re.SyntaxKind.EqualsToken;
              case re.SyntaxKind.ForOfStatement:
                return ae.parent.initializer === ae;
              case re.SyntaxKind.ArrayLiteralExpression:
              case re.SyntaxKind.ObjectLiteralExpression:
                ae = ae.parent;
                break;
              case re.SyntaxKind.SpreadAssignment:
              case re.SyntaxKind.PropertyAssignment:
                ae = ae.parent.parent;
                break;
              case re.SyntaxKind.SpreadElement:
                if (ae.parent.parent.kind !== re.SyntaxKind.ArrayLiteralExpression) return false;
                ae = ae.parent.parent;
                break;
              default:
                return false;
            }
          }
          var de;
          (function(ae) {
            ae[ae.None = 0] = "None", ae[ae.Read = 1] = "Read", ae[ae.Write = 2] = "Write", ae[ae.Delete = 4] = "Delete", ae[ae.ReadWrite = 3] = "ReadWrite", ae[ae.Modification = 6] = "Modification";
          })(de = M.AccessKind || (M.AccessKind = {}));
          function ye(ae) {
            let Xe = ae.parent;
            switch (Xe.kind) {
              case re.SyntaxKind.DeleteExpression:
                return 4;
              case re.SyntaxKind.PostfixUnaryExpression:
                return 3;
              case re.SyntaxKind.PrefixUnaryExpression:
                return Xe.operator === re.SyntaxKind.PlusPlusToken || Xe.operator === re.SyntaxKind.MinusMinusToken ? 3 : 1;
              case re.SyntaxKind.BinaryExpression:
                return Xe.right === ae ? 1 : ar(Xe.operatorToken.kind) ? Xe.operatorToken.kind === re.SyntaxKind.EqualsToken ? 2 : 3 : 1;
              case re.SyntaxKind.ShorthandPropertyAssignment:
                return Xe.objectAssignmentInitializer === ae ? 1 : we(Xe) ? 2 : 1;
              case re.SyntaxKind.PropertyAssignment:
                return Xe.name === ae ? 0 : we(Xe) ? 2 : 1;
              case re.SyntaxKind.ArrayLiteralExpression:
              case re.SyntaxKind.SpreadElement:
              case re.SyntaxKind.SpreadAssignment:
                return we(Xe) ? 2 : 1;
              case re.SyntaxKind.ParenthesizedExpression:
              case re.SyntaxKind.NonNullExpression:
              case re.SyntaxKind.TypeAssertionExpression:
              case re.SyntaxKind.AsExpression:
                return ye(Xe);
              case re.SyntaxKind.ForOfStatement:
              case re.SyntaxKind.ForInStatement:
                return Xe.initializer === ae ? 2 : 1;
              case re.SyntaxKind.ExpressionWithTypeArguments:
                return Xe.parent.token === re.SyntaxKind.ExtendsKeyword && Xe.parent.parent.kind !== re.SyntaxKind.InterfaceDeclaration ? 1 : 0;
              case re.SyntaxKind.ComputedPropertyName:
              case re.SyntaxKind.ExpressionStatement:
              case re.SyntaxKind.TypeOfExpression:
              case re.SyntaxKind.ElementAccessExpression:
              case re.SyntaxKind.ForStatement:
              case re.SyntaxKind.IfStatement:
              case re.SyntaxKind.DoStatement:
              case re.SyntaxKind.WhileStatement:
              case re.SyntaxKind.SwitchStatement:
              case re.SyntaxKind.WithStatement:
              case re.SyntaxKind.ThrowStatement:
              case re.SyntaxKind.CallExpression:
              case re.SyntaxKind.NewExpression:
              case re.SyntaxKind.TaggedTemplateExpression:
              case re.SyntaxKind.JsxExpression:
              case re.SyntaxKind.Decorator:
              case re.SyntaxKind.TemplateSpan:
              case re.SyntaxKind.JsxOpeningElement:
              case re.SyntaxKind.JsxSelfClosingElement:
              case re.SyntaxKind.JsxSpreadAttribute:
              case re.SyntaxKind.VoidExpression:
              case re.SyntaxKind.ReturnStatement:
              case re.SyntaxKind.AwaitExpression:
              case re.SyntaxKind.YieldExpression:
              case re.SyntaxKind.ConditionalExpression:
              case re.SyntaxKind.CaseClause:
              case re.SyntaxKind.JsxElement:
                return 1;
              case re.SyntaxKind.ArrowFunction:
                return Xe.body === ae ? 1 : 2;
              case re.SyntaxKind.PropertyDeclaration:
              case re.SyntaxKind.VariableDeclaration:
              case re.SyntaxKind.Parameter:
              case re.SyntaxKind.EnumMember:
              case re.SyntaxKind.BindingElement:
              case re.SyntaxKind.JsxAttribute:
                return Xe.initializer === ae ? 1 : 0;
              case re.SyntaxKind.PropertyAccessExpression:
                return Xe.expression === ae ? 1 : 0;
              case re.SyntaxKind.ExportAssignment:
                return Xe.isExportEquals ? 1 : 0;
            }
            return 0;
          }
          M.getAccessKind = ye;
          function Ae(ae) {
            return (ye(ae) & 2) !== 0;
          }
          M.isReassignmentTarget = Ae;
          function er(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.Parameter:
              case re.SyntaxKind.CallSignature:
              case re.SyntaxKind.ConstructSignature:
              case re.SyntaxKind.MethodSignature:
              case re.SyntaxKind.PropertySignature:
              case re.SyntaxKind.ArrowFunction:
              case re.SyntaxKind.ParenthesizedExpression:
              case re.SyntaxKind.SpreadAssignment:
              case re.SyntaxKind.ShorthandPropertyAssignment:
              case re.SyntaxKind.PropertyAssignment:
              case re.SyntaxKind.FunctionExpression:
              case re.SyntaxKind.LabeledStatement:
              case re.SyntaxKind.ExpressionStatement:
              case re.SyntaxKind.VariableStatement:
              case re.SyntaxKind.FunctionDeclaration:
              case re.SyntaxKind.Constructor:
              case re.SyntaxKind.MethodDeclaration:
              case re.SyntaxKind.PropertyDeclaration:
              case re.SyntaxKind.GetAccessor:
              case re.SyntaxKind.SetAccessor:
              case re.SyntaxKind.ClassDeclaration:
              case re.SyntaxKind.ClassExpression:
              case re.SyntaxKind.InterfaceDeclaration:
              case re.SyntaxKind.TypeAliasDeclaration:
              case re.SyntaxKind.EnumMember:
              case re.SyntaxKind.EnumDeclaration:
              case re.SyntaxKind.ModuleDeclaration:
              case re.SyntaxKind.ImportEqualsDeclaration:
              case re.SyntaxKind.ImportDeclaration:
              case re.SyntaxKind.NamespaceExportDeclaration:
              case re.SyntaxKind.ExportAssignment:
              case re.SyntaxKind.IndexSignature:
              case re.SyntaxKind.FunctionType:
              case re.SyntaxKind.ConstructorType:
              case re.SyntaxKind.JSDocFunctionType:
              case re.SyntaxKind.ExportDeclaration:
              case re.SyntaxKind.NamedTupleMember:
              case re.SyntaxKind.EndOfFileToken:
                return true;
              default:
                return false;
            }
          }
          M.canHaveJsDoc = er;
          function ir(ae, Xe) {
            let Jr = [];
            for (let ti of ae.getChildren(Xe)) {
              if (!Ve.isJsDoc(ti)) break;
              Jr.push(ti);
            }
            return Jr;
          }
          M.getJsDoc = ir;
          function Cr(ae, Xe) {
            let Jr = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : ae.getSourceFile();
            if (er(ae) && ae.kind !== re.SyntaxKind.EndOfFileToken) {
              let ti = ir(ae, Jr);
              if (ti.length !== 0 || !Xe) return ti;
            }
            return Ye(ae, ae.getStart(Jr), Jr, Xe);
          }
          M.parseJsDocOfNode = Cr;
          function Ye(ae, Xe, Jr, ti) {
            let Ze = re[ti && Ee(Jr, ae.pos, Xe) ? "forEachTrailingCommentRange" : "forEachLeadingCommentRange"](Jr.text, ae.pos, (vr, mr, Ar) => Ar === re.SyntaxKind.MultiLineCommentTrivia && Jr.text[vr + 2] === "*" ? { pos: vr } : void 0);
            if (Ze === void 0) return [];
            let Sr = Ze.pos, zr = Jr.text.slice(Sr, Xe), Wr = re.createSourceFile("jsdoc.ts", "".concat(zr, "var a;"), Jr.languageVersion), Je = ir(Wr.statements[0], Wr);
            for (let vr of Je) xe(vr, ae);
            return Je;
            function xe(vr, mr) {
              return vr.pos += Sr, vr.end += Sr, vr.parent = mr, re.forEachChild(vr, (Ar) => xe(Ar, vr), (Ar) => {
                Ar.pos += Sr, Ar.end += Sr;
                for (let Oe of Ar) xe(Oe, vr);
              });
            }
          }
          var Br;
          (function(ae) {
            ae[ae.ImportDeclaration = 1] = "ImportDeclaration", ae[ae.ImportEquals = 2] = "ImportEquals", ae[ae.ExportFrom = 4] = "ExportFrom", ae[ae.DynamicImport = 8] = "DynamicImport", ae[ae.Require = 16] = "Require", ae[ae.ImportType = 32] = "ImportType", ae[ae.All = 63] = "All", ae[ae.AllImports = 59] = "AllImports", ae[ae.AllStaticImports = 3] = "AllStaticImports", ae[ae.AllImportExpressions = 24] = "AllImportExpressions", ae[ae.AllRequireLike = 18] = "AllRequireLike", ae[ae.AllNestedImports = 56] = "AllNestedImports", ae[ae.AllTopLevelImports = 7] = "AllTopLevelImports";
          })(Br = M.ImportKind || (M.ImportKind = {}));
          function Er(ae, Xe) {
            let Jr = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : true, ti = [];
            for (let Sr of Ne(ae, Xe, Jr)) switch (Sr.kind) {
              case re.SyntaxKind.ImportDeclaration:
                Ze(Sr.moduleSpecifier);
                break;
              case re.SyntaxKind.ImportEqualsDeclaration:
                Ze(Sr.moduleReference.expression);
                break;
              case re.SyntaxKind.ExportDeclaration:
                Ze(Sr.moduleSpecifier);
                break;
              case re.SyntaxKind.CallExpression:
                Ze(Sr.arguments[0]);
                break;
              case re.SyntaxKind.ImportType:
                Ve.isLiteralTypeNode(Sr.argument) && Ze(Sr.argument.literal);
                break;
              default:
                throw new Error("unexpected node");
            }
            return ti;
            function Ze(Sr) {
              Ve.isTextualLiteral(Sr) && ti.push(Sr);
            }
          }
          M.findImports = Er;
          function Ne(ae, Xe) {
            let Jr = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : true;
            return new n(ae, Xe, Jr).find();
          }
          M.findImportLikeNodes = Ne;
          var n = class {
            constructor(ae, Xe, Jr) {
              this._sourceFile = ae, this._options = Xe, this._ignoreFileName = Jr, this._result = [];
            }
            find() {
              return this._sourceFile.isDeclarationFile && (this._options &= -25), this._options & 7 && this._findImports(this._sourceFile.statements), this._options & 56 && this._findNestedImports(), this._result;
            }
            _findImports(ae) {
              for (let Xe of ae) Ve.isImportDeclaration(Xe) ? this._options & 1 && this._result.push(Xe) : Ve.isImportEqualsDeclaration(Xe) ? this._options & 2 && Xe.moduleReference.kind === re.SyntaxKind.ExternalModuleReference && this._result.push(Xe) : Ve.isExportDeclaration(Xe) ? Xe.moduleSpecifier !== void 0 && this._options & 4 && this._result.push(Xe) : Ve.isModuleDeclaration(Xe) && this._findImportsInModule(Xe);
            }
            _findImportsInModule(ae) {
              if (ae.body !== void 0) {
                if (ae.body.kind === re.SyntaxKind.ModuleDeclaration) return this._findImportsInModule(ae.body);
                this._findImports(ae.body.statements);
              }
            }
            _findNestedImports() {
              let ae = this._ignoreFileName || (this._sourceFile.flags & re.NodeFlags.JavaScriptFile) !== 0, Xe, Jr;
              if ((this._options & 56) === 16) {
                if (!ae) return;
                Xe = /\brequire\s*[</(]/g, Jr = false;
              } else this._options & 16 && ae ? (Xe = /\b(?:import|require)\s*[</(]/g, Jr = (this._options & 32) !== 0) : (Xe = /\bimport\s*[</(]/g, Jr = ae && (this._options & 32) !== 0);
              for (let ti = Xe.exec(this._sourceFile.text); ti !== null; ti = Xe.exec(this._sourceFile.text)) {
                let Ze = K(this._sourceFile, ti.index, this._sourceFile, ti[0][0] === "i" && Jr);
                if (Ze.kind === re.SyntaxKind.ImportKeyword) {
                  if (Ze.end - 6 !== ti.index) continue;
                  switch (Ze.parent.kind) {
                    case re.SyntaxKind.ImportType:
                      this._result.push(Ze.parent);
                      break;
                    case re.SyntaxKind.CallExpression:
                      Ze.parent.arguments.length > 1 && this._result.push(Ze.parent);
                  }
                } else Ze.kind === re.SyntaxKind.Identifier && Ze.end - 7 === ti.index && Ze.parent.kind === re.SyntaxKind.CallExpression && Ze.parent.expression === Ze && Ze.parent.arguments.length === 1 && this._result.push(Ze.parent);
              }
            }
          };
          function lr(ae) {
            for (; ae.flags & re.NodeFlags.NestedNamespace; ) ae = ae.parent;
            return B(ae.modifiers, re.SyntaxKind.DeclareKeyword) || be(ae.parent);
          }
          M.isStatementInAmbientContext = lr;
          function be(ae) {
            for (; ae.kind === re.SyntaxKind.ModuleBlock; ) {
              do
                ae = ae.parent;
              while (ae.flags & re.NodeFlags.NestedNamespace);
              if (B(ae.modifiers, re.SyntaxKind.DeclareKeyword)) return true;
              ae = ae.parent;
            }
            return false;
          }
          M.isAmbientModuleBlock = be;
          function Ge(ae) {
            let Xe = ae.parent;
            for (; Xe.kind === re.SyntaxKind.ParenthesizedExpression; ) Xe = Xe.parent;
            return Ve.isCallExpression(Xe) && ae.end <= Xe.expression.end ? Xe : void 0;
          }
          M.getIIFE = Ge;
          function ur(ae, Xe) {
            return (ae.strict ? ae[Xe] !== false : ae[Xe] === true) && (Xe !== "strictPropertyInitialization" || ur(ae, "strictNullChecks"));
          }
          M.isStrictCompilerOptionEnabled = ur;
          function yr(ae, Xe) {
            switch (Xe) {
              case "stripInternal":
              case "declarationMap":
              case "emitDeclarationOnly":
                return ae[Xe] === true && yr(ae, "declaration");
              case "declaration":
                return ae.declaration || yr(ae, "composite");
              case "incremental":
                return ae.incremental === void 0 ? yr(ae, "composite") : ae.incremental;
              case "skipDefaultLibCheck":
                return ae.skipDefaultLibCheck || yr(ae, "skipLibCheck");
              case "suppressImplicitAnyIndexErrors":
                return ae.suppressImplicitAnyIndexErrors === true && yr(ae, "noImplicitAny");
              case "allowSyntheticDefaultImports":
                return ae.allowSyntheticDefaultImports !== void 0 ? ae.allowSyntheticDefaultImports : yr(ae, "esModuleInterop") || ae.module === re.ModuleKind.System;
              case "noUncheckedIndexedAccess":
                return ae.noUncheckedIndexedAccess === true && yr(ae, "strictNullChecks");
              case "allowJs":
                return ae.allowJs === void 0 ? yr(ae, "checkJs") : ae.allowJs;
              case "noImplicitAny":
              case "noImplicitThis":
              case "strictNullChecks":
              case "strictFunctionTypes":
              case "strictPropertyInitialization":
              case "alwaysStrict":
              case "strictBindCallApply":
                return ur(ae, Xe);
            }
            return ae[Xe] === true;
          }
          M.isCompilerOptionEnabled = yr;
          function Ir(ae) {
            return ae.name.kind === re.SyntaxKind.StringLiteral || (ae.flags & re.NodeFlags.GlobalAugmentation) !== 0;
          }
          M.isAmbientModule = Ir;
          function wr(ae) {
            return Ur(ae);
          }
          M.getCheckJsDirective = wr;
          function Ur(ae) {
            let Xe;
            return re.forEachLeadingCommentRange(ae, (re.getShebang(ae) || "").length, (Jr, ti, Ze) => {
              if (Ze === re.SyntaxKind.SingleLineCommentTrivia) {
                let Sr = ae.slice(Jr, ti), zr = /^\/{2,3}\s*@ts-(no)?check(?:\s|$)/i.exec(Sr);
                zr !== null && (Xe = { pos: Jr, end: ti, enabled: zr[1] === void 0 });
              }
            }), Xe;
          }
          M.getTsCheckDirective = Ur;
          function ii(ae) {
            return Ve.isTypeReferenceNode(ae.type) && ae.type.typeName.kind === re.SyntaxKind.Identifier && ae.type.typeName.escapedText === "const";
          }
          M.isConstAssertion = ii;
          function mi(ae) {
            let Xe = ae;
            for (; ; ) {
              let Jr = Xe.parent;
              e: switch (Jr.kind) {
                case re.SyntaxKind.TypeAssertionExpression:
                case re.SyntaxKind.AsExpression:
                  return ii(Jr);
                case re.SyntaxKind.PrefixUnaryExpression:
                  if (Xe.kind !== re.SyntaxKind.NumericLiteral) return false;
                  switch (Jr.operator) {
                    case re.SyntaxKind.PlusToken:
                    case re.SyntaxKind.MinusToken:
                      Xe = Jr;
                      break e;
                    default:
                      return false;
                  }
                case re.SyntaxKind.PropertyAssignment:
                  if (Jr.initializer !== Xe) return false;
                  Xe = Jr.parent;
                  break;
                case re.SyntaxKind.ShorthandPropertyAssignment:
                  Xe = Jr.parent;
                  break;
                case re.SyntaxKind.ParenthesizedExpression:
                case re.SyntaxKind.ArrayLiteralExpression:
                case re.SyntaxKind.ObjectLiteralExpression:
                case re.SyntaxKind.TemplateExpression:
                  Xe = Jr;
                  break;
                default:
                  return false;
              }
            }
          }
          M.isInConstContext = mi;
          function pe(ae, Xe) {
            if (!or(ae)) return false;
            let Jr = Xe.getTypeAtLocation(ae.arguments[2]);
            if (Jr.getProperty("value") === void 0) return Jr.getProperty("set") === void 0;
            let ti = Jr.getProperty("writable");
            if (ti === void 0) return false;
            let Ze = ti.valueDeclaration !== void 0 && Ve.isPropertyAssignment(ti.valueDeclaration) ? Xe.getTypeAtLocation(ti.valueDeclaration.initializer) : Xe.getTypeOfSymbolAtLocation(ti, ae.arguments[2]);
            return oi.isBooleanLiteralType(Ze, false);
          }
          M.isReadonlyAssignmentDeclaration = pe;
          function or(ae) {
            return ae.arguments.length === 3 && Ve.isEntityNameExpression(ae.arguments[0]) && Ve.isNumericOrStringLikeLiteral(ae.arguments[1]) && Ve.isPropertyAccessExpression(ae.expression) && ae.expression.name.escapedText === "defineProperty" && Ve.isIdentifier(ae.expression.expression) && ae.expression.expression.escapedText === "Object";
          }
          M.isBindableObjectDefinePropertyCall = or;
          function qr(ae) {
            return re.isPropertyAccessExpression(ae) && re.isIdentifier(ae.expression) && ae.expression.escapedText === "Symbol";
          }
          M.isWellKnownSymbolLiterally = qr;
          function si(ae) {
            return { displayName: "[Symbol.".concat(ae.name.text, "]"), symbolName: "__@" + ae.name.text };
          }
          M.getPropertyNameOfWellKnownSymbol = si;
          var Di = ((ae) => {
            let [Xe, Jr] = ae;
            return Xe < "4" || Xe === "4" && Jr < "3";
          })(re.versionMajorMinor.split("."));
          function wi(ae, Xe) {
            let Jr = { known: true, names: [] };
            if (ae = Gi(ae), Di && qr(ae)) Jr.names.push(si(ae));
            else {
              let ti = Xe.getTypeAtLocation(ae);
              for (let Ze of oi.unionTypeParts(Xe.getBaseConstraintOfType(ti) || ti)) {
                let Sr = oi.getPropertyNameFromType(Ze);
                Sr ? Jr.names.push(Sr) : Jr.known = false;
              }
            }
            return Jr;
          }
          M.getLateBoundPropertyNames = wi;
          function Xi(ae, Xe) {
            let Jr = O(ae);
            return Jr !== void 0 ? { known: true, names: [{ displayName: Jr, symbolName: re.escapeLeadingUnderscores(Jr) }] } : ae.kind === re.SyntaxKind.PrivateIdentifier ? { known: true, names: [{ displayName: ae.text, symbolName: Xe.getSymbolAtLocation(ae).escapedName }] } : wi(ae.expression, Xe);
          }
          M.getLateBoundPropertyNamesOfPropertyName = Xi;
          function et(ae, Xe) {
            let Jr = O(ae);
            if (Jr !== void 0) return { displayName: Jr, symbolName: re.escapeLeadingUnderscores(Jr) };
            if (ae.kind === re.SyntaxKind.PrivateIdentifier) return { displayName: ae.text, symbolName: Xe.getSymbolAtLocation(ae).escapedName };
            let { expression: ti } = ae;
            return Di && qr(ti) ? si(ti) : oi.getPropertyNameFromType(Xe.getTypeAtLocation(ti));
          }
          M.getSingleLateBoundPropertyNameOfPropertyName = et;
          function Gi(ae) {
            for (; ae.kind === re.SyntaxKind.ParenthesizedExpression; ) ae = ae.expression;
            return ae;
          }
          M.unwrapParentheses = Gi;
          function Wt(ae) {
            return "".concat(ae.negative ? "-" : "").concat(ae.base10Value, "n");
          }
          M.formatPseudoBigInt = Wt;
          function Zt(ae, Xe) {
            let Jr = ae.caseBlock.clauses.filter(Ve.isCaseClause);
            if (Jr.length === 0) return false;
            let ti = oi.unionTypeParts(Xe.getTypeAtLocation(ae.expression));
            if (ti.length > Jr.length) return false;
            let Ze = new Set(ti.map(_r));
            if (Ze.has(void 0)) return false;
            let Sr = /* @__PURE__ */ new Set();
            for (let zr of Jr) {
              let Wr = Xe.getTypeAtLocation(zr.expression);
              if (M.isTypeFlagSet(Wr, re.TypeFlags.Never)) continue;
              let Je = _r(Wr);
              if (Ze.has(Je)) Sr.add(Je);
              else if (Je !== "null" && Je !== "undefined") return false;
            }
            return Ze.size === Sr.size;
          }
          M.hasExhaustiveCaseClauses = Zt;
          function _r(ae) {
            if (M.isTypeFlagSet(ae, re.TypeFlags.Null)) return "null";
            if (M.isTypeFlagSet(ae, re.TypeFlags.Undefined)) return "undefined";
            if (M.isTypeFlagSet(ae, re.TypeFlags.NumberLiteral)) return "".concat(M.isTypeFlagSet(ae, re.TypeFlags.EnumLiteral) ? "enum:" : "").concat(ae.value);
            if (M.isTypeFlagSet(ae, re.TypeFlags.StringLiteral)) return "".concat(M.isTypeFlagSet(ae, re.TypeFlags.EnumLiteral) ? "enum:" : "", "string:").concat(ae.value);
            if (M.isTypeFlagSet(ae, re.TypeFlags.BigIntLiteral)) return Wt(ae.value);
            if (Ke.isUniqueESSymbolType(ae)) return ae.escapedName;
            if (oi.isBooleanLiteralType(ae, true)) return "true";
            if (oi.isBooleanLiteralType(ae, false)) return "false";
          }
          function pi(ae) {
            var Xe;
            if (((Xe = ae.heritageClauses) === null || Xe === void 0 ? void 0 : Xe[0].token) === re.SyntaxKind.ExtendsKeyword) return ae.heritageClauses[0].types[0];
          }
          M.getBaseOfClassLikeExpression = pi;
        } }), ez = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/convert-comments.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(ke, e, a, C) {
            C === void 0 && (C = a);
            var w = Object.getOwnPropertyDescriptor(e, a);
            (!w || ("get" in w ? !e.__esModule : w.writable || w.configurable)) && (w = { enumerable: true, get: function() {
              return e[a];
            } }), Object.defineProperty(ke, C, w);
          } : function(ke, e, a, C) {
            C === void 0 && (C = a), ke[C] = e[a];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(ke, e) {
            Object.defineProperty(ke, "default", { enumerable: true, value: e });
          } : function(ke, e) {
            ke.default = e;
          }), Ke = M && M.__importStar || function(ke) {
            if (ke && ke.__esModule) return ke;
            var e = {};
            if (ke != null) for (var a in ke) a !== "default" && Object.prototype.hasOwnProperty.call(ke, a) && re(e, ke, a);
            return Ve(e, ke), e;
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.convertComments = void 0;
          var oi = Ke(_u()), kr = n3(), pr = A1(), Lr = k1();
          function ar(ke, e) {
            let a = [];
            return (0, kr.forEachComment)(ke, (C, w) => {
              let B = w.kind == oi.SyntaxKind.SingleLineCommentTrivia ? Lr.AST_TOKEN_TYPES.Line : Lr.AST_TOKEN_TYPES.Block, E = [w.pos, w.end], Q = (0, pr.getLocFor)(E[0], E[1], ke), le = E[0] + 2, N = w.kind === oi.SyntaxKind.SingleLineCommentTrivia ? E[1] - le : E[1] - le - 2;
              a.push({ type: B, value: e.slice(le, le + N), range: E, loc: Q });
            }, ke), a;
          }
          M.convertComments = ar;
        } }), o3 = Oa({ "node_modules/eslint-visitor-keys/dist/eslint-visitor-keys.cjs"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
          var re = { AssignmentExpression: ["left", "right"], AssignmentPattern: ["left", "right"], ArrayExpression: ["elements"], ArrayPattern: ["elements"], ArrowFunctionExpression: ["params", "body"], AwaitExpression: ["argument"], BlockStatement: ["body"], BinaryExpression: ["left", "right"], BreakStatement: ["label"], CallExpression: ["callee", "arguments"], CatchClause: ["param", "body"], ChainExpression: ["expression"], ClassBody: ["body"], ClassDeclaration: ["id", "superClass", "body"], ClassExpression: ["id", "superClass", "body"], ConditionalExpression: ["test", "consequent", "alternate"], ContinueStatement: ["label"], DebuggerStatement: [], DoWhileStatement: ["body", "test"], EmptyStatement: [], ExportAllDeclaration: ["exported", "source"], ExportDefaultDeclaration: ["declaration"], ExportNamedDeclaration: ["declaration", "specifiers", "source"], ExportSpecifier: ["exported", "local"], ExpressionStatement: ["expression"], ExperimentalRestProperty: ["argument"], ExperimentalSpreadProperty: ["argument"], ForStatement: ["init", "test", "update", "body"], ForInStatement: ["left", "right", "body"], ForOfStatement: ["left", "right", "body"], FunctionDeclaration: ["id", "params", "body"], FunctionExpression: ["id", "params", "body"], Identifier: [], IfStatement: ["test", "consequent", "alternate"], ImportDeclaration: ["specifiers", "source"], ImportDefaultSpecifier: ["local"], ImportExpression: ["source"], ImportNamespaceSpecifier: ["local"], ImportSpecifier: ["imported", "local"], JSXAttribute: ["name", "value"], JSXClosingElement: ["name"], JSXElement: ["openingElement", "children", "closingElement"], JSXEmptyExpression: [], JSXExpressionContainer: ["expression"], JSXIdentifier: [], JSXMemberExpression: ["object", "property"], JSXNamespacedName: ["namespace", "name"], JSXOpeningElement: ["name", "attributes"], JSXSpreadAttribute: ["argument"], JSXText: [], JSXFragment: ["openingFragment", "children", "closingFragment"], JSXClosingFragment: [], JSXOpeningFragment: [], Literal: [], LabeledStatement: ["label", "body"], LogicalExpression: ["left", "right"], MemberExpression: ["object", "property"], MetaProperty: ["meta", "property"], MethodDefinition: ["key", "value"], NewExpression: ["callee", "arguments"], ObjectExpression: ["properties"], ObjectPattern: ["properties"], PrivateIdentifier: [], Program: ["body"], Property: ["key", "value"], PropertyDefinition: ["key", "value"], RestElement: ["argument"], ReturnStatement: ["argument"], SequenceExpression: ["expressions"], SpreadElement: ["argument"], StaticBlock: ["body"], Super: [], SwitchStatement: ["discriminant", "cases"], SwitchCase: ["test", "consequent"], TaggedTemplateExpression: ["tag", "quasi"], TemplateElement: [], TemplateLiteral: ["quasis", "expressions"], ThisExpression: [], ThrowStatement: ["argument"], TryStatement: ["block", "handler", "finalizer"], UnaryExpression: ["argument"], UpdateExpression: ["argument"], VariableDeclaration: ["declarations"], VariableDeclarator: ["id", "init"], WhileStatement: ["test", "body"], WithStatement: ["object", "body"], YieldExpression: ["argument"] }, Ve = Object.keys(re);
          for (let Lr of Ve) Object.freeze(re[Lr]);
          Object.freeze(re);
          var Ke = /* @__PURE__ */ new Set(["parent", "leadingComments", "trailingComments"]);
          function oi(Lr) {
            return !Ke.has(Lr) && Lr[0] !== "_";
          }
          function kr(Lr) {
            return Object.keys(Lr).filter(oi);
          }
          function pr(Lr) {
            let ar = Object.assign({}, re);
            for (let ke of Object.keys(Lr)) if (Object.prototype.hasOwnProperty.call(ar, ke)) {
              let e = new Set(Lr[ke]);
              for (let a of ar[ke]) e.add(a);
              ar[ke] = Object.freeze(Array.from(e));
            } else ar[ke] = Object.freeze(Array.from(Lr[ke]));
            return Object.freeze(ar);
          }
          M.KEYS = re, M.getKeys = kr, M.unionWith = pr;
        } }), rz = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/@typescript-eslint/visitor-keys/dist/get-keys.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.getKeys = void 0;
          var re = o3(), Ve = re.getKeys;
          M.getKeys = Ve;
        } }), iz = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/@typescript-eslint/visitor-keys/dist/visitor-keys.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(Lr, ar, ke, e) {
            e === void 0 && (e = ke);
            var a = Object.getOwnPropertyDescriptor(ar, ke);
            (!a || ("get" in a ? !ar.__esModule : a.writable || a.configurable)) && (a = { enumerable: true, get: function() {
              return ar[ke];
            } }), Object.defineProperty(Lr, e, a);
          } : function(Lr, ar, ke, e) {
            e === void 0 && (e = ke), Lr[e] = ar[ke];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(Lr, ar) {
            Object.defineProperty(Lr, "default", { enumerable: true, value: ar });
          } : function(Lr, ar) {
            Lr.default = ar;
          }), Ke = M && M.__importStar || function(Lr) {
            if (Lr && Lr.__esModule) return Lr;
            var ar = {};
            if (Lr != null) for (var ke in Lr) ke !== "default" && Object.prototype.hasOwnProperty.call(Lr, ke) && re(ar, Lr, ke);
            return Ve(ar, Lr), ar;
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.visitorKeys = void 0;
          var oi = Ke(o3()), kr = { ImportAttribute: ["key", "value"], ArrayPattern: ["decorators", "elements", "typeAnnotation"], ArrowFunctionExpression: ["typeParameters", "params", "returnType", "body"], AssignmentPattern: ["decorators", "left", "right", "typeAnnotation"], CallExpression: ["callee", "typeParameters", "arguments"], ClassDeclaration: ["decorators", "id", "typeParameters", "superClass", "superTypeParameters", "implements", "body"], ClassExpression: ["decorators", "id", "typeParameters", "superClass", "superTypeParameters", "implements", "body"], ExportAllDeclaration: ["exported", "source", "assertions"], ExportNamedDeclaration: ["declaration", "specifiers", "source", "assertions"], FunctionDeclaration: ["id", "typeParameters", "params", "returnType", "body"], FunctionExpression: ["id", "typeParameters", "params", "returnType", "body"], Identifier: ["decorators", "typeAnnotation"], ImportDeclaration: ["specifiers", "source", "assertions"], ImportExpression: ["source", "attributes"], MethodDefinition: ["decorators", "key", "value", "typeParameters"], NewExpression: ["callee", "typeParameters", "arguments"], ObjectPattern: ["decorators", "properties", "typeAnnotation"], PropertyDefinition: ["decorators", "key", "typeAnnotation", "value"], RestElement: ["decorators", "argument", "typeAnnotation"], TaggedTemplateExpression: ["tag", "typeParameters", "quasi"], StaticBlock: ["body"], JSXOpeningElement: ["name", "typeParameters", "attributes"], JSXClosingFragment: [], JSXOpeningFragment: [], JSXSpreadChild: ["expression"], Decorator: ["expression"], TSAbstractKeyword: [], TSAbstractMethodDefinition: ["key", "value"], TSAbstractPropertyDefinition: ["decorators", "key", "typeAnnotation"], TSAnyKeyword: [], TSArrayType: ["elementType"], TSAsExpression: ["expression", "typeAnnotation"], TSAsyncKeyword: [], TSBigIntKeyword: [], TSBooleanKeyword: [], TSCallSignatureDeclaration: ["typeParameters", "params", "returnType"], TSClassImplements: ["expression", "typeParameters"], TSConditionalType: ["checkType", "extendsType", "trueType", "falseType"], TSConstructorType: ["typeParameters", "params", "returnType"], TSConstructSignatureDeclaration: ["typeParameters", "params", "returnType"], TSDeclareFunction: ["id", "typeParameters", "params", "returnType", "body"], TSDeclareKeyword: [], TSEmptyBodyFunctionExpression: ["id", "typeParameters", "params", "returnType"], TSEnumDeclaration: ["id", "members"], TSEnumMember: ["id", "initializer"], TSExportAssignment: ["expression"], TSExportKeyword: [], TSExternalModuleReference: ["expression"], TSFunctionType: ["typeParameters", "params", "returnType"], TSImportEqualsDeclaration: ["id", "moduleReference"], TSImportType: ["parameter", "qualifier", "typeParameters"], TSIndexedAccessType: ["indexType", "objectType"], TSIndexSignature: ["parameters", "typeAnnotation"], TSInferType: ["typeParameter"], TSInstantiationExpression: ["expression", "typeParameters"], TSInterfaceBody: ["body"], TSInterfaceDeclaration: ["id", "typeParameters", "extends", "body"], TSInterfaceHeritage: ["expression", "typeParameters"], TSIntersectionType: ["types"], TSIntrinsicKeyword: [], TSLiteralType: ["literal"], TSMappedType: ["nameType", "typeParameter", "typeAnnotation"], TSMethodSignature: ["typeParameters", "key", "params", "returnType"], TSModuleBlock: ["body"], TSModuleDeclaration: ["id", "body"], TSNamedTupleMember: ["label", "elementType"], TSNamespaceExportDeclaration: ["id"], TSNeverKeyword: [], TSNonNullExpression: ["expression"], TSNullKeyword: [], TSNumberKeyword: [], TSObjectKeyword: [], TSOptionalType: ["typeAnnotation"], TSParameterProperty: ["decorators", "parameter"], TSPrivateKeyword: [], TSPropertySignature: ["typeAnnotation", "key", "initializer"], TSProtectedKeyword: [], TSPublicKeyword: [], TSQualifiedName: ["left", "right"], TSReadonlyKeyword: [], TSRestType: ["typeAnnotation"], TSStaticKeyword: [], TSStringKeyword: [], TSSymbolKeyword: [], TSTemplateLiteralType: ["quasis", "types"], TSThisType: [], TSTupleType: ["elementTypes"], TSTypeAliasDeclaration: ["id", "typeParameters", "typeAnnotation"], TSTypeAnnotation: ["typeAnnotation"], TSTypeAssertion: ["typeAnnotation", "expression"], TSTypeLiteral: ["members"], TSTypeOperator: ["typeAnnotation"], TSTypeParameter: ["name", "constraint", "default"], TSTypeParameterDeclaration: ["params"], TSTypeParameterInstantiation: ["params"], TSTypePredicate: ["typeAnnotation", "parameterName"], TSTypeQuery: ["exprName"], TSTypeReference: ["typeName", "typeParameters"], TSUndefinedKeyword: [], TSUnionType: ["types"], TSUnknownKeyword: [], TSVoidKeyword: [] }, pr = oi.unionWith(kr);
          M.visitorKeys = pr;
        } }), s3 = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/@typescript-eslint/visitor-keys/dist/index.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.visitorKeys = M.getKeys = void 0;
          var re = rz();
          Object.defineProperty(M, "getKeys", { enumerable: true, get: function() {
            return re.getKeys;
          } });
          var Ve = iz();
          Object.defineProperty(M, "visitorKeys", { enumerable: true, get: function() {
            return Ve.visitorKeys;
          } });
        } }), c3 = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/simple-traverse.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.simpleTraverse = void 0;
          var re = s3();
          function Ve(pr) {
            return pr !== null && typeof pr == "object" && typeof pr.type == "string";
          }
          function Ke(pr, Lr) {
            let ar = pr[Lr.type];
            return ar != null ? ar : [];
          }
          var oi = class {
            constructor(pr) {
              let Lr = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              this.allVisitorKeys = re.visitorKeys, this.selectors = pr, this.setParentPointers = Lr;
            }
            traverse(pr, Lr) {
              if (!Ve(pr)) return;
              this.setParentPointers && (pr.parent = Lr), "enter" in this.selectors ? this.selectors.enter(pr, Lr) : pr.type in this.selectors && this.selectors[pr.type](pr, Lr);
              let ar = Ke(this.allVisitorKeys, pr);
              if (!(ar.length < 1)) for (let ke of ar) {
                let e = pr[ke];
                if (Array.isArray(e)) for (let a of e) this.traverse(a, pr);
                else this.traverse(e, pr);
              }
            }
          };
          function kr(pr, Lr) {
            let ar = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
            new oi(Lr, ar).traverse(pr, void 0);
          }
          M.simpleTraverse = kr;
        } }), tz = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/ast-converter.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.astConverter = void 0;
          var re = e3(), Ve = ez(), Ke = A1(), oi = c3();
          function kr(pr, Lr, ar) {
            let { parseDiagnostics: ke } = pr;
            if (ke.length) throw (0, re.convertError)(ke[0]);
            let e = new re.Converter(pr, { errorOnUnknownASTType: Lr.errorOnUnknownASTType || false, shouldPreserveNodeMaps: ar }), a = e.convertProgram();
            (!Lr.range || !Lr.loc) && (0, oi.simpleTraverse)(a, { enter: (w) => {
              Lr.range || delete w.range, Lr.loc || delete w.loc;
            } }), Lr.tokens && (a.tokens = (0, Ke.convertTokens)(pr)), Lr.comment && (a.comments = (0, Ve.convertComments)(pr, Lr.code));
            let C = e.getASTMaps();
            return { estree: a, astMaps: C };
          }
          M.astConverter = kr;
        } }), Mv = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/create-program/shared.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(p, m, G, oe) {
            oe === void 0 && (oe = G);
            var f = Object.getOwnPropertyDescriptor(m, G);
            (!f || ("get" in f ? !m.__esModule : f.writable || f.configurable)) && (f = { enumerable: true, get: function() {
              return m[G];
            } }), Object.defineProperty(p, oe, f);
          } : function(p, m, G, oe) {
            oe === void 0 && (oe = G), p[oe] = m[G];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(p, m) {
            Object.defineProperty(p, "default", { enumerable: true, value: m });
          } : function(p, m) {
            p.default = m;
          }), Ke = M && M.__importStar || function(p) {
            if (p && p.__esModule) return p;
            var m = {};
            if (p != null) for (var G in p) G !== "default" && Object.prototype.hasOwnProperty.call(p, G) && re(m, p, G);
            return Ve(m, p), m;
          }, oi = M && M.__importDefault || function(p) {
            return p && p.__esModule ? p : { default: p };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.getModuleResolver = M.getAstFromProgram = M.getCanonicalFileName = M.ensureAbsolutePath = M.createDefaultCompilerOptionsFromExtra = M.canonicalDirname = M.CORE_COMPILER_OPTIONS = void 0;
          var kr = oi(Fv()), pr = Ke(_u()), Lr = { noEmit: true, noUnusedLocals: true, noUnusedParameters: true };
          M.CORE_COMPILER_OPTIONS = Lr;
          var ar = Object.assign(Object.assign({}, Lr), { allowNonTsExtensions: true, allowJs: true, checkJs: true });
          function ke(p) {
            return p.debugLevel.has("typescript") ? Object.assign(Object.assign({}, ar), { extendedDiagnostics: true }) : ar;
          }
          M.createDefaultCompilerOptionsFromExtra = ke;
          var e = pr.sys !== void 0 ? pr.sys.useCaseSensitiveFileNames : true, a = e ? (p) => p : (p) => p.toLowerCase();
          function C(p) {
            let m = kr.default.normalize(p);
            return m.endsWith(kr.default.sep) && (m = m.slice(0, -1)), a(m);
          }
          M.getCanonicalFileName = C;
          function w(p, m) {
            return kr.default.isAbsolute(p) ? p : kr.default.join(m.tsconfigRootDir || "/prettier-security-dirname-placeholder", p);
          }
          M.ensureAbsolutePath = w;
          function B(p) {
            return kr.default.dirname(p);
          }
          M.canonicalDirname = B;
          var E = [pr.Extension.Dts, pr.Extension.Dcts, pr.Extension.Dmts];
          function Q(p) {
            var m;
            return p ? (m = E.find((G) => p.endsWith(G))) !== null && m !== void 0 ? m : kr.default.extname(p) : null;
          }
          function le(p, m) {
            let G = p.getSourceFile(m.filePath), oe = Q(m.filePath), f = Q(G == null ? void 0 : G.fileName);
            if (oe === f) return G && { ast: G, program: p };
          }
          M.getAstFromProgram = le;
          function N(p) {
            let m;
            try {
              throw new Error("Dynamic require is not supported");
            } catch {
              let oe = ["Could not find the provided parserOptions.moduleResolver.", "Hint: use an absolute path if you are not in control over where the ESLint instance runs."];
              throw new Error(oe.join(`
`));
            }
            return m;
          }
          M.getModuleResolver = N;
        } }), az = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/create-program/createDefaultProgram.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(a, C, w, B) {
            B === void 0 && (B = w);
            var E = Object.getOwnPropertyDescriptor(C, w);
            (!E || ("get" in E ? !C.__esModule : E.writable || E.configurable)) && (E = { enumerable: true, get: function() {
              return C[w];
            } }), Object.defineProperty(a, B, E);
          } : function(a, C, w, B) {
            B === void 0 && (B = w), a[B] = C[w];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(a, C) {
            Object.defineProperty(a, "default", { enumerable: true, value: C });
          } : function(a, C) {
            a.default = C;
          }), Ke = M && M.__importStar || function(a) {
            if (a && a.__esModule) return a;
            var C = {};
            if (a != null) for (var w in a) w !== "default" && Object.prototype.hasOwnProperty.call(a, w) && re(C, a, w);
            return Ve(C, a), C;
          }, oi = M && M.__importDefault || function(a) {
            return a && a.__esModule ? a : { default: a };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.createDefaultProgram = void 0;
          var kr = oi(wm()), pr = oi(Fv()), Lr = Ke(_u()), ar = Mv(), ke = (0, kr.default)("typescript-eslint:typescript-estree:createDefaultProgram");
          function e(a, C) {
            if (ke("Getting default program for: %s", C.filePath || "unnamed file"), !C.projects || C.projects.length !== 1) return;
            let w = C.projects[0], B = Lr.getParsedCommandLineOfConfigFile(w, (0, ar.createDefaultCompilerOptionsFromExtra)(C), Object.assign(Object.assign({}, Lr.sys), { onUnRecoverableConfigFileDiagnostic: () => {
            } }));
            if (!B) return;
            let E = Lr.createCompilerHost(B.options, true);
            C.moduleResolver && (E.resolveModuleNames = (0, ar.getModuleResolver)(C.moduleResolver).resolveModuleNames);
            let Q = E.readFile;
            E.readFile = (p) => pr.default.normalize(p) === pr.default.normalize(C.filePath) ? a : Q(p);
            let le = Lr.createProgram([C.filePath], B.options, E), N = le.getSourceFile(C.filePath);
            return N && { ast: N, program: le };
          }
          M.createDefaultProgram = e;
        } }), rx = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/create-program/getScriptKind.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(ke, e, a, C) {
            C === void 0 && (C = a);
            var w = Object.getOwnPropertyDescriptor(e, a);
            (!w || ("get" in w ? !e.__esModule : w.writable || w.configurable)) && (w = { enumerable: true, get: function() {
              return e[a];
            } }), Object.defineProperty(ke, C, w);
          } : function(ke, e, a, C) {
            C === void 0 && (C = a), ke[C] = e[a];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(ke, e) {
            Object.defineProperty(ke, "default", { enumerable: true, value: e });
          } : function(ke, e) {
            ke.default = e;
          }), Ke = M && M.__importStar || function(ke) {
            if (ke && ke.__esModule) return ke;
            var e = {};
            if (ke != null) for (var a in ke) a !== "default" && Object.prototype.hasOwnProperty.call(ke, a) && re(e, ke, a);
            return Ve(e, ke), e;
          }, oi = M && M.__importDefault || function(ke) {
            return ke && ke.__esModule ? ke : { default: ke };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.getLanguageVariant = M.getScriptKind = void 0;
          var kr = oi(Fv()), pr = Ke(_u());
          function Lr(ke, e) {
            switch (kr.default.extname(ke).toLowerCase()) {
              case pr.Extension.Js:
              case pr.Extension.Cjs:
              case pr.Extension.Mjs:
                return pr.ScriptKind.JS;
              case pr.Extension.Jsx:
                return pr.ScriptKind.JSX;
              case pr.Extension.Ts:
              case pr.Extension.Cts:
              case pr.Extension.Mts:
                return pr.ScriptKind.TS;
              case pr.Extension.Tsx:
                return pr.ScriptKind.TSX;
              case pr.Extension.Json:
                return pr.ScriptKind.JSON;
              default:
                return e ? pr.ScriptKind.TSX : pr.ScriptKind.TS;
            }
          }
          M.getScriptKind = Lr;
          function ar(ke) {
            switch (ke) {
              case pr.ScriptKind.TSX:
              case pr.ScriptKind.JSX:
              case pr.ScriptKind.JS:
              case pr.ScriptKind.JSON:
                return pr.LanguageVariant.JSX;
              default:
                return pr.LanguageVariant.Standard;
            }
          }
          M.getLanguageVariant = ar;
        } }), nz = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/create-program/createIsolatedProgram.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(a, C, w, B) {
            B === void 0 && (B = w);
            var E = Object.getOwnPropertyDescriptor(C, w);
            (!E || ("get" in E ? !C.__esModule : E.writable || E.configurable)) && (E = { enumerable: true, get: function() {
              return C[w];
            } }), Object.defineProperty(a, B, E);
          } : function(a, C, w, B) {
            B === void 0 && (B = w), a[B] = C[w];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(a, C) {
            Object.defineProperty(a, "default", { enumerable: true, value: C });
          } : function(a, C) {
            a.default = C;
          }), Ke = M && M.__importStar || function(a) {
            if (a && a.__esModule) return a;
            var C = {};
            if (a != null) for (var w in a) w !== "default" && Object.prototype.hasOwnProperty.call(a, w) && re(C, a, w);
            return Ve(C, a), C;
          }, oi = M && M.__importDefault || function(a) {
            return a && a.__esModule ? a : { default: a };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.createIsolatedProgram = void 0;
          var kr = oi(wm()), pr = Ke(_u()), Lr = Mv(), ar = rx(), ke = (0, kr.default)("typescript-eslint:typescript-estree:createIsolatedProgram");
          function e(a, C) {
            ke("Getting isolated program in %s mode for: %s", C.jsx ? "TSX" : "TS", C.filePath);
            let w = { fileExists() {
              return true;
            }, getCanonicalFileName() {
              return C.filePath;
            }, getCurrentDirectory() {
              return "";
            }, getDirectories() {
              return [];
            }, getDefaultLibFileName() {
              return "lib.d.ts";
            }, getNewLine() {
              return `
`;
            }, getSourceFile(Q) {
              return pr.createSourceFile(Q, a, pr.ScriptTarget.Latest, true, (0, ar.getScriptKind)(C.filePath, C.jsx));
            }, readFile() {
            }, useCaseSensitiveFileNames() {
              return true;
            }, writeFile() {
              return null;
            } }, B = pr.createProgram([C.filePath], Object.assign({ noResolve: true, target: pr.ScriptTarget.Latest, jsx: C.jsx ? pr.JsxEmit.Preserve : void 0 }, (0, Lr.createDefaultCompilerOptionsFromExtra)(C)), w), E = B.getSourceFile(C.filePath);
            if (!E) throw new Error("Expected an ast to be returned for the single-file isolated program.");
            return { ast: E, program: B };
          }
          M.createIsolatedProgram = e;
        } }), u3 = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/create-program/createWatchProgram.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(J, ie, R, q) {
            q === void 0 && (q = R);
            var O = Object.getOwnPropertyDescriptor(ie, R);
            (!O || ("get" in O ? !ie.__esModule : O.writable || O.configurable)) && (O = { enumerable: true, get: function() {
              return ie[R];
            } }), Object.defineProperty(J, q, O);
          } : function(J, ie, R, q) {
            q === void 0 && (q = R), J[q] = ie[R];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(J, ie) {
            Object.defineProperty(J, "default", { enumerable: true, value: ie });
          } : function(J, ie) {
            J.default = ie;
          }), Ke = M && M.__importStar || function(J) {
            if (J && J.__esModule) return J;
            var ie = {};
            if (J != null) for (var R in J) R !== "default" && Object.prototype.hasOwnProperty.call(J, R) && re(ie, J, R);
            return Ve(ie, J), ie;
          }, oi = M && M.__importDefault || function(J) {
            return J && J.__esModule ? J : { default: J };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.getProgramsForProjects = M.createWatchProgram = M.clearWatchCaches = void 0;
          var kr = oi(wm()), pr = oi(ex()), Lr = oi(QT()), ar = Ke(_u()), ke = Mv(), e = (0, kr.default)("typescript-eslint:typescript-estree:createWatchProgram"), a = /* @__PURE__ */ new Map(), C = /* @__PURE__ */ new Map(), w = /* @__PURE__ */ new Map(), B = /* @__PURE__ */ new Map(), E = /* @__PURE__ */ new Map(), Q = /* @__PURE__ */ new Map();
          function le() {
            a.clear(), C.clear(), w.clear(), Q.clear(), B.clear(), E.clear();
          }
          M.clearWatchCaches = le;
          function N(J) {
            return (ie, R) => {
              let q = (0, ke.getCanonicalFileName)(ie), O = (() => {
                let ve = J.get(q);
                return ve || (ve = /* @__PURE__ */ new Set(), J.set(q, ve)), ve;
              })();
              return O.add(R), { close: () => {
                O.delete(R);
              } };
            };
          }
          var p = { code: "", filePath: "" };
          function m(J) {
            throw new Error(ar.flattenDiagnosticMessageText(J.messageText, ar.sys.newLine));
          }
          function G(J) {
            var ie;
            return !((ie = ar.sys) === null || ie === void 0) && ie.createHash ? ar.sys.createHash(J) : J;
          }
          function oe(J, ie, R) {
            let q = R.EXPERIMENTAL_useSourceOfProjectReferenceRedirect ? new Set(ie.getSourceFiles().map((O) => (0, ke.getCanonicalFileName)(O.fileName))) : new Set(ie.getRootFileNames().map((O) => (0, ke.getCanonicalFileName)(O)));
            return B.set(J, q), q;
          }
          function f(J, ie, R) {
            let q = (0, ke.getCanonicalFileName)(ie), O = [];
            p.code = J, p.filePath = q;
            let ve = C.get(q), ee = G(J);
            Q.get(q) !== ee && ve && ve.size > 0 && ve.forEach((he) => he(q, ar.FileWatcherEventKind.Changed));
            for (let [he, F] of a.entries()) {
              let x = B.get(he), X = null;
              if (x || (X = F.getProgram().getProgram(), x = oe(he, X, R)), x.has(q)) return e("Found existing program for file. %s", q), X = X != null ? X : F.getProgram().getProgram(), X.getTypeChecker(), [X];
            }
            e("File did not belong to any existing programs, moving to create/update. %s", q);
            for (let he of R.projects) {
              let F = a.get(he);
              if (F) {
                let A = se(F, q, he);
                if (!A) continue;
                if (A.getTypeChecker(), oe(he, A, R).has(q)) return e("Found updated program for file. %s", q), [A];
                O.push(A);
                continue;
              }
              let x = K(he, R);
              a.set(he, x);
              let X = x.getProgram().getProgram();
              if (X.getTypeChecker(), oe(he, X, R).has(q)) return e("Found program for file. %s", q), [X];
              O.push(X);
            }
            return O;
          }
          M.getProgramsForProjects = f;
          var T = Lr.default.satisfies(ar.version, ">=3.9.0-beta", { includePrerelease: true });
          function K(J, ie) {
            e("Creating watch program for %s.", J);
            let R = ar.createWatchCompilerHost(J, (0, ke.createDefaultCompilerOptionsFromExtra)(ie), ar.sys, ar.createAbstractBuilder, m, () => {
            });
            ie.moduleResolver && (R.resolveModuleNames = (0, ke.getModuleResolver)(ie.moduleResolver).resolveModuleNames);
            let q = R.readFile;
            R.readFile = (he, F) => {
              let x = (0, ke.getCanonicalFileName)(he), X = x === p.filePath ? p.code : q(x, F);
              return X !== void 0 && Q.set(x, G(X)), X;
            }, R.onUnRecoverableConfigFileDiagnostic = m, R.afterProgramCreate = (he) => {
              let F = he.getConfigFileParsingDiagnostics().filter((x) => x.category === ar.DiagnosticCategory.Error && x.code !== 18003);
              F.length > 0 && m(F[0]);
            }, R.watchFile = N(C), R.watchDirectory = N(w);
            let O = R.onCachedDirectoryStructureHostCreate;
            R.onCachedDirectoryStructureHostCreate = (he) => {
              let F = he.readDirectory;
              he.readDirectory = (x, X, $, A, y) => F(x, X ? X.concat(ie.extraFileExtensions) : void 0, $, A, y), O(he);
            }, R.extraFileExtensions = ie.extraFileExtensions.map((he) => ({ extension: he, isMixedContent: true, scriptKind: ar.ScriptKind.Deferred })), R.trace = e, R.useSourceOfProjectReferenceRedirect = () => ie.EXPERIMENTAL_useSourceOfProjectReferenceRedirect;
            let ve;
            T ? (R.setTimeout = void 0, R.clearTimeout = void 0) : (e("Running without timeout fix"), R.setTimeout = function(he, F) {
              for (var x = arguments.length, X = new Array(x > 2 ? x - 2 : 0), $ = 2; $ < x; $++) X[$ - 2] = arguments[$];
              return ve = he.bind(void 0, ...X), ve;
            }, R.clearTimeout = () => {
              ve = void 0;
            });
            let ee = ar.createWatchProgram(R);
            if (!T) {
              let he = ee.getProgram;
              ee.getProgram = () => (ve && ve(), ve = void 0, he.call(ee));
            }
            return ee;
          }
          M.createWatchProgram = K;
          function b(J) {
            let R = pr.default.statSync(J).mtimeMs, q = E.get(J);
            return E.set(J, R), q === void 0 ? false : Math.abs(q - R) > Number.EPSILON;
          }
          function se(J, ie, R) {
            let q = J.getProgram().getProgram();
            if (Eu.env.TSESTREE_NO_INVALIDATION === "true") return q;
            b(R) && (e("tsconfig has changed - triggering program update. %s", R), C.get(R).forEach((A) => A(R, ar.FileWatcherEventKind.Changed)), B.delete(R));
            let O = q.getSourceFile(ie);
            if (O) return q;
            e("File was not found in program - triggering folder update. %s", ie);
            let ve = (0, ke.canonicalDirname)(ie), ee = null, he = ve, F = false;
            for (; ee !== he; ) {
              ee = he;
              let A = w.get(ee);
              A && (A.forEach((y) => {
                ve !== ee && y(ve, ar.FileWatcherEventKind.Changed), y(ee, ar.FileWatcherEventKind.Changed);
              }), F = true), he = (0, ke.canonicalDirname)(ee);
            }
            if (!F) return e("No callback found for file, not part of this program. %s", ie), null;
            if (B.delete(R), q = J.getProgram().getProgram(), O = q.getSourceFile(ie), O) return q;
            e("File was still not found in program after directory update - checking file deletions. %s", ie);
            let X = q.getRootFileNames().find((A) => !pr.default.existsSync(A));
            if (!X) return null;
            let $ = C.get((0, ke.getCanonicalFileName)(X));
            return $ ? (e("Marking file as deleted. %s", X), $.forEach((A) => A(X, ar.FileWatcherEventKind.Deleted)), B.delete(R), q = J.getProgram().getProgram(), O = q.getSourceFile(ie), O ? q : (e("File was still not found in program after deletion check, assuming it is not part of this program. %s", ie), null)) : (e("Could not find watch callbacks for root file. %s", X), q);
          }
        } }), oz = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/create-program/createProjectProgram.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(B, E, Q, le) {
            le === void 0 && (le = Q);
            var N = Object.getOwnPropertyDescriptor(E, Q);
            (!N || ("get" in N ? !E.__esModule : N.writable || N.configurable)) && (N = { enumerable: true, get: function() {
              return E[Q];
            } }), Object.defineProperty(B, le, N);
          } : function(B, E, Q, le) {
            le === void 0 && (le = Q), B[le] = E[Q];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(B, E) {
            Object.defineProperty(B, "default", { enumerable: true, value: E });
          } : function(B, E) {
            B.default = E;
          }), Ke = M && M.__importStar || function(B) {
            if (B && B.__esModule) return B;
            var E = {};
            if (B != null) for (var Q in B) Q !== "default" && Object.prototype.hasOwnProperty.call(B, Q) && re(E, B, Q);
            return Ve(E, B), E;
          }, oi = M && M.__importDefault || function(B) {
            return B && B.__esModule ? B : { default: B };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.createProjectProgram = void 0;
          var kr = oi(wm()), pr = oi(Fv()), Lr = Ke(_u()), ar = u3(), ke = A1(), e = Mv(), a = (0, kr.default)("typescript-eslint:typescript-estree:createProjectProgram"), C = [Lr.Extension.Ts, Lr.Extension.Tsx, Lr.Extension.Js, Lr.Extension.Jsx, Lr.Extension.Mjs, Lr.Extension.Mts, Lr.Extension.Cjs, Lr.Extension.Cts];
          function w(B, E, Q) {
            a("Creating project program for: %s", Q.filePath);
            let le = (0, ke.firstDefined)((0, ar.getProgramsForProjects)(B, Q.filePath, Q), (N) => (0, e.getAstFromProgram)(N, Q));
            if (!le && !E) {
              let N = ['"parserOptions.project" has been set for @typescript-eslint/parser.', "The file does not match your project config: ".concat(pr.default.relative(Q.tsconfigRootDir || "/prettier-security-dirname-placeholder", Q.filePath), ".")], p = false, m = Q.extraFileExtensions || [];
              m.forEach((oe) => {
                oe.startsWith(".") || N.push('Found unexpected extension "'.concat(oe, '" specified with the "extraFileExtensions" option. Did you mean ".').concat(oe, '"?')), C.includes(oe) && N.push('You unnecessarily included the extension "'.concat(oe, '" with the "extraFileExtensions" option. This extension is already handled by the parser by default.'));
              });
              let G = pr.default.extname(Q.filePath);
              if (!C.includes(G)) {
                let oe = "The extension for the file (".concat(G, ") is non-standard");
                m.length > 0 ? m.includes(G) || (N.push("".concat(oe, '. It should be added to your existing "parserOptions.extraFileExtensions".')), p = true) : (N.push("".concat(oe, '. You should add "parserOptions.extraFileExtensions" to your config.')), p = true);
              }
              throw p || N.push("The file must be included in at least one of the projects provided."), new Error(N.join(`
`));
            }
            return le;
          }
          M.createProjectProgram = w;
        } }), sz = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/create-program/createSourceFile.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(e, a, C, w) {
            w === void 0 && (w = C);
            var B = Object.getOwnPropertyDescriptor(a, C);
            (!B || ("get" in B ? !a.__esModule : B.writable || B.configurable)) && (B = { enumerable: true, get: function() {
              return a[C];
            } }), Object.defineProperty(e, w, B);
          } : function(e, a, C, w) {
            w === void 0 && (w = C), e[w] = a[C];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(e, a) {
            Object.defineProperty(e, "default", { enumerable: true, value: a });
          } : function(e, a) {
            e.default = a;
          }), Ke = M && M.__importStar || function(e) {
            if (e && e.__esModule) return e;
            var a = {};
            if (e != null) for (var C in e) C !== "default" && Object.prototype.hasOwnProperty.call(e, C) && re(a, e, C);
            return Ve(a, e), a;
          }, oi = M && M.__importDefault || function(e) {
            return e && e.__esModule ? e : { default: e };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.createSourceFile = void 0;
          var kr = oi(wm()), pr = Ke(_u()), Lr = rx(), ar = (0, kr.default)("typescript-eslint:typescript-estree:createSourceFile");
          function ke(e, a) {
            return ar("Getting AST without type information in %s mode for: %s", a.jsx ? "TSX" : "TS", a.filePath), pr.createSourceFile(a.filePath, e, pr.ScriptTarget.Latest, true, (0, Lr.getScriptKind)(a.filePath, a.jsx));
          }
          M.createSourceFile = ke;
        } }), cz = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/semantic-or-syntactic-errors.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.getFirstSemanticOrSyntacticError = void 0;
          var re = _u();
          function Ve(kr, pr) {
            try {
              let Lr = Ke(kr.getSyntacticDiagnostics(pr));
              if (Lr.length) return oi(Lr[0]);
              let ar = Ke(kr.getSemanticDiagnostics(pr));
              return ar.length ? oi(ar[0]) : void 0;
            } catch (Lr) {
              console.warn('Warning From TSC: "'.concat(Lr.message));
              return;
            }
          }
          M.getFirstSemanticOrSyntacticError = Ve;
          function Ke(kr) {
            return kr.filter((pr) => {
              switch (pr.code) {
                case 1013:
                case 1014:
                case 1044:
                case 1045:
                case 1048:
                case 1049:
                case 1070:
                case 1071:
                case 1085:
                case 1090:
                case 1096:
                case 1097:
                case 1098:
                case 1099:
                case 1117:
                case 1121:
                case 1123:
                case 1141:
                case 1162:
                case 1164:
                case 1172:
                case 1173:
                case 1175:
                case 1176:
                case 1190:
                case 1196:
                case 1200:
                case 1206:
                case 1211:
                case 1242:
                case 1246:
                case 1255:
                case 1308:
                case 2364:
                case 2369:
                case 2452:
                case 2462:
                case 8017:
                case 17012:
                case 17013:
                  return true;
              }
              return false;
            });
          }
          function oi(kr) {
            return Object.assign(Object.assign({}, kr), { message: (0, re.flattenDiagnosticMessageText)(kr.messageText, re.sys.newLine) });
          }
        } }), l3 = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/create-program/useProvidedPrograms.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(B, E, Q, le) {
            le === void 0 && (le = Q);
            var N = Object.getOwnPropertyDescriptor(E, Q);
            (!N || ("get" in N ? !E.__esModule : N.writable || N.configurable)) && (N = { enumerable: true, get: function() {
              return E[Q];
            } }), Object.defineProperty(B, le, N);
          } : function(B, E, Q, le) {
            le === void 0 && (le = Q), B[le] = E[Q];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(B, E) {
            Object.defineProperty(B, "default", { enumerable: true, value: E });
          } : function(B, E) {
            B.default = E;
          }), Ke = M && M.__importStar || function(B) {
            if (B && B.__esModule) return B;
            var E = {};
            if (B != null) for (var Q in B) Q !== "default" && Object.prototype.hasOwnProperty.call(B, Q) && re(E, B, Q);
            return Ve(E, B), E;
          }, oi = M && M.__importDefault || function(B) {
            return B && B.__esModule ? B : { default: B };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.createProgramFromConfigFile = M.useProvidedPrograms = void 0;
          var kr = oi(wm()), pr = Ke(ex()), Lr = Ke(Fv()), ar = Ke(_u()), ke = Mv(), e = (0, kr.default)("typescript-eslint:typescript-estree:useProvidedProgram");
          function a(B, E) {
            e("Retrieving ast for %s from provided program instance(s)", E.filePath);
            let Q;
            for (let le of B) if (Q = (0, ke.getAstFromProgram)(le, E), Q) break;
            if (!Q) {
              let le = Lr.relative(E.tsconfigRootDir || "/prettier-security-dirname-placeholder", E.filePath), N = ['"parserOptions.programs" has been provided for @typescript-eslint/parser.', "The file was not found in any of the provided program instance(s): ".concat(le)];
              throw new Error(N.join(`
`));
            }
            return Q.program.getTypeChecker(), Q;
          }
          M.useProvidedPrograms = a;
          function C(B, E) {
            if (ar.sys === void 0) throw new Error("`createProgramFromConfigFile` is only supported in a Node-like environment.");
            let le = ar.getParsedCommandLineOfConfigFile(B, ke.CORE_COMPILER_OPTIONS, { onUnRecoverableConfigFileDiagnostic: (p) => {
              throw new Error(w([p]));
            }, fileExists: pr.existsSync, getCurrentDirectory: () => E && Lr.resolve(E) || "/prettier-security-dirname-placeholder", readDirectory: ar.sys.readDirectory, readFile: (p) => pr.readFileSync(p, "utf-8"), useCaseSensitiveFileNames: ar.sys.useCaseSensitiveFileNames });
            if (le.errors.length) throw new Error(w(le.errors));
            let N = ar.createCompilerHost(le.options, true);
            return ar.createProgram(le.fileNames, le.options, N);
          }
          M.createProgramFromConfigFile = C;
          function w(B) {
            return ar.formatDiagnostics(B, { getCanonicalFileName: (E) => E, getCurrentDirectory: Eu.cwd, getNewLine: () => `
` });
          }
        } }), uz = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/parser.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(y, V, L, P) {
            P === void 0 && (P = L);
            var k = Object.getOwnPropertyDescriptor(V, L);
            (!k || ("get" in k ? !V.__esModule : k.writable || k.configurable)) && (k = { enumerable: true, get: function() {
              return V[L];
            } }), Object.defineProperty(y, P, k);
          } : function(y, V, L, P) {
            P === void 0 && (P = L), y[P] = V[L];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(y, V) {
            Object.defineProperty(y, "default", { enumerable: true, value: V });
          } : function(y, V) {
            y.default = V;
          }), Ke = M && M.__importStar || function(y) {
            if (y && y.__esModule) return y;
            var V = {};
            if (y != null) for (var L in y) L !== "default" && Object.prototype.hasOwnProperty.call(y, L) && re(V, y, L);
            return Ve(V, y), V;
          }, oi = M && M.__importDefault || function(y) {
            return y && y.__esModule ? y : { default: y };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.clearParseAndGenerateServicesCalls = M.clearProgramCache = M.parseWithNodeMaps = M.parseAndGenerateServices = M.parse = void 0;
          var kr = oi(wm()), pr = oi(Vj()), Lr = oi(QT()), ar = Fv(), ke = Ke(_u()), e = tz(), a = e3(), C = az(), w = nz(), B = oz(), E = sz(), Q = cz(), le = Mv(), N = l3(), p = (0, kr.default)("typescript-eslint:typescript-estree:parser"), m = ">=3.3.1 <4.8.0", G = [], oe = ke.version, f = Lr.default.satisfies(oe, [m].concat(G).join(" || ")), T, K = false, b = /* @__PURE__ */ new Map();
          function se() {
            b.clear();
          }
          M.clearProgramCache = se;
          function J(y) {
            return typeof y != "string" ? String(y) : y;
          }
          function ie(y, V, L, P) {
            return V && (0, N.useProvidedPrograms)(V, T) || L && (0, B.createProjectProgram)(y, P, T) || L && P && (0, C.createDefaultProgram)(y, T) || (0, w.createIsolatedProgram)(y, T);
          }
          function R() {
            let { jsx: y } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
            return y ? "estree.tsx" : "estree.ts";
          }
          function q() {
            T = { code: "", comment: false, comments: [], createDefaultProgram: false, debugLevel: /* @__PURE__ */ new Set(), errorOnTypeScriptSyntacticAndSemanticIssues: false, errorOnUnknownASTType: false, EXPERIMENTAL_useSourceOfProjectReferenceRedirect: false, extraFileExtensions: [], filePath: R(), jsx: false, loc: false, log: console.log, preserveNodeMaps: true, programs: null, projects: [], range: false, strict: false, tokens: null, tsconfigRootDir: "/prettier-security-dirname-placeholder", singleRun: false, moduleResolver: "" };
          }
          function O(y) {
            var V;
            if (y.debugLevel === true ? T.debugLevel = /* @__PURE__ */ new Set(["typescript-eslint"]) : Array.isArray(y.debugLevel) && (T.debugLevel = new Set(y.debugLevel)), T.debugLevel.size > 0) {
              let L = [];
              T.debugLevel.has("typescript-eslint") && L.push("typescript-eslint:*"), (T.debugLevel.has("eslint") || kr.default.enabled("eslint:*,-eslint:code-path")) && L.push("eslint:*,-eslint:code-path"), kr.default.enable(L.join(","));
            }
            if (T.range = typeof y.range == "boolean" && y.range, T.loc = typeof y.loc == "boolean" && y.loc, typeof y.tokens == "boolean" && y.tokens && (T.tokens = []), typeof y.comment == "boolean" && y.comment && (T.comment = true, T.comments = []), typeof y.jsx != "boolean" ? T.jsx = false : T.jsx = y.jsx, typeof y.filePath == "string" && y.filePath !== "<input>" ? T.filePath = y.filePath : T.filePath = R(T), typeof y.errorOnUnknownASTType == "boolean" && y.errorOnUnknownASTType && (T.errorOnUnknownASTType = true), typeof y.loggerFn == "function" ? T.log = y.loggerFn : y.loggerFn === false && (T.log = () => {
            }), typeof y.tsconfigRootDir == "string" && (T.tsconfigRootDir = y.tsconfigRootDir), T.filePath = (0, le.ensureAbsolutePath)(T.filePath, T), Array.isArray(y.programs)) {
              if (!y.programs.length) throw new Error("You have set parserOptions.programs to an empty array. This will cause all files to not be found in existing programs. Either provide one or more existing TypeScript Program instances in the array, or remove the parserOptions.programs setting.");
              T.programs = y.programs, p("parserOptions.programs was provided, so parserOptions.project will be ignored.");
            }
            if (!T.programs) {
              let L = ((V = y.projectFolderIgnoreList) !== null && V !== void 0 ? V : ["**/node_modules/**"]).reduce((P, k) => (typeof k == "string" && P.push(k), P), []).map((P) => P.startsWith("!") ? P : "!".concat(P));
              T.projects = [];
            }
            Array.isArray(y.extraFileExtensions) && y.extraFileExtensions.every((L) => typeof L == "string") && (T.extraFileExtensions = y.extraFileExtensions), typeof y.preserveNodeMaps == "boolean" && (T.preserveNodeMaps = y.preserveNodeMaps), T.createDefaultProgram = typeof y.createDefaultProgram == "boolean" && y.createDefaultProgram, T.EXPERIMENTAL_useSourceOfProjectReferenceRedirect = typeof y.EXPERIMENTAL_useSourceOfProjectReferenceRedirect == "boolean" && y.EXPERIMENTAL_useSourceOfProjectReferenceRedirect, typeof y.moduleResolver == "string" && (T.moduleResolver = y.moduleResolver);
          }
          function ve() {
            var y;
            if (!f && !K) {
              if (typeof Eu > "u" ? false : (y = Eu.stdout) === null || y === void 0 ? void 0 : y.isTTY) {
                let L = "=============", P = [L, "WARNING: You are currently running a version of TypeScript which is not officially supported by @typescript-eslint/typescript-estree.", "You may find that it works just fine, or you may not.", "SUPPORTED TYPESCRIPT VERSIONS: ".concat(m), "YOUR TYPESCRIPT VERSION: ".concat(oe), "Please only submit bug reports when using the officially supported version.", L];
                T.log(P.join(`

`));
              }
              K = true;
            }
          }
          function ee(y) {
            if (Eu.env.TSESTREE_SINGLE_RUN === "false") {
              T.singleRun = false;
              return;
            }
            if (Eu.env.TSESTREE_SINGLE_RUN === "true") {
              T.singleRun = true;
              return;
            }
            if (y != null && y.allowAutomaticSingleRunInference && (Eu.env.CI === "true" || Eu.argv[1].endsWith((0, ar.normalize)("node_modules/.bin/eslint")))) {
              T.singleRun = true;
              return;
            }
            T.singleRun = false;
          }
          function he(y, V) {
            let { ast: L } = F(y, V, false);
            return L;
          }
          M.parse = he;
          function F(y, V, L) {
            if (q(), V != null && V.errorOnTypeScriptSyntacticAndSemanticIssues) throw new Error('"errorOnTypeScriptSyntacticAndSemanticIssues" is only supported for parseAndGenerateServices()');
            y = J(y), T.code = y, typeof V < "u" && O(V), ve(), ee(V);
            let P = (0, E.createSourceFile)(y, T), { estree: k, astMaps: Y } = (0, e.astConverter)(P, T, L);
            return { ast: k, esTreeNodeToTSNodeMap: Y.esTreeNodeToTSNodeMap, tsNodeToESTreeNodeMap: Y.tsNodeToESTreeNodeMap };
          }
          function x(y, V) {
            return F(y, V, true);
          }
          M.parseWithNodeMaps = x;
          var X = {};
          function $() {
            X = {};
          }
          M.clearParseAndGenerateServicesCalls = $;
          function A(y, V) {
            var L;
            q(), y = J(y), T.code = y, typeof V < "u" && (O(V), typeof V.errorOnTypeScriptSyntacticAndSemanticIssues == "boolean" && V.errorOnTypeScriptSyntacticAndSemanticIssues && (T.errorOnTypeScriptSyntacticAndSemanticIssues = true)), ve(), ee(V), T.singleRun && !T.programs && ((L = T.projects) === null || L === void 0 ? void 0 : L.length) > 0 && (T.programs = { *[Symbol.iterator]() {
              for (let I of T.projects) {
                let l = b.get(I);
                if (l) yield l;
                else {
                  p("Detected single-run/CLI usage, creating Program once ahead of time for project: %s", I);
                  let d = (0, N.createProgramFromConfigFile)(I);
                  b.set(I, d), yield d;
                }
              }
            } });
            let P = T.programs != null || T.projects && T.projects.length > 0, k, Y;
            if (T.singleRun && V.filePath && (X[V.filePath] = (X[V.filePath] || 0) + 1), T.singleRun && V.filePath && X[V.filePath] > 1) {
              let I = (0, w.createIsolatedProgram)(y, T);
              k = I.ast, Y = I.program;
            } else {
              let I = ie(y, T.programs, P, T.createDefaultProgram);
              k = I.ast, Y = I.program;
            }
            let U = typeof T.preserveNodeMaps == "boolean" ? T.preserveNodeMaps : true, { estree: j, astMaps: H } = (0, e.astConverter)(k, T, U);
            if (Y && T.errorOnTypeScriptSyntacticAndSemanticIssues) {
              let I = (0, Q.getFirstSemanticOrSyntacticError)(Y, k);
              if (I) throw (0, a.convertError)(I);
            }
            return { ast: j, services: { hasFullTypeInformation: P, program: Y, esTreeNodeToTSNodeMap: H.esTreeNodeToTSNodeMap, tsNodeToESTreeNodeMap: H.tsNodeToESTreeNodeMap } };
          }
          M.parseAndGenerateServices = A;
        } }), lz = Oa({ "node_modules/@typescript-eslint/typescript-estree/package.json"(M, re) {
          re.exports = { name: "@typescript-eslint/typescript-estree", version: "5.27.0", description: "A parser that converts TypeScript source code into an ESTree compatible form", main: "dist/index.js", types: "dist/index.d.ts", files: ["dist", "README.md", "LICENSE"], engines: { node: "^12.22.0 || ^14.17.0 || >=16.0.0" }, repository: { type: "git", url: "https://github.com/typescript-eslint/typescript-eslint.git", directory: "packages/typescript-estree" }, bugs: { url: "https://github.com/typescript-eslint/typescript-eslint/issues" }, license: "BSD-2-Clause", keywords: ["ast", "estree", "ecmascript", "javascript", "typescript", "parser", "syntax"], scripts: { build: "tsc -b tsconfig.build.json", postbuild: "downlevel-dts dist _ts3.4/dist", clean: "tsc -b tsconfig.build.json --clean", postclean: "rimraf dist && rimraf _ts3.4 && rimraf coverage", format: 'prettier --write "./**/*.{ts,mts,cts,tsx,js,mjs,cjs,jsx,json,md,css}" --ignore-path ../../.prettierignore', lint: "eslint . --ignore-path='../../.eslintignore'", test: "jest --coverage", typecheck: "tsc -p tsconfig.json --noEmit" }, dependencies: { "@typescript-eslint/types": "5.27.0", "@typescript-eslint/visitor-keys": "5.27.0", debug: "^4.3.4", globby: "^11.1.0", "is-glob": "^4.0.3", semver: "^7.3.7", tsutils: "^3.21.0" }, devDependencies: { "@babel/code-frame": "*", "@babel/parser": "*", "@types/babel__code-frame": "*", "@types/debug": "*", "@types/glob": "*", "@types/is-glob": "*", "@types/semver": "*", "@types/tmp": "*", "@typescript-eslint/shared-fixtures": "5.27.0", glob: "*", "jest-specific-snapshot": "*", "make-dir": "*", tmp: "*", typescript: "*" }, peerDependenciesMeta: { typescript: { optional: true } }, funding: { type: "opencollective", url: "https://opencollective.com/typescript-eslint" }, typesVersions: { "<3.8": { "*": ["_ts3.4/*"] } }, gitHead: "e0db364b94158437f041db3597101d0c8b30d8bc" };
        } }), fz = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/index.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(ar, ke, e, a) {
            a === void 0 && (a = e);
            var C = Object.getOwnPropertyDescriptor(ke, e);
            (!C || ("get" in C ? !ke.__esModule : C.writable || C.configurable)) && (C = { enumerable: true, get: function() {
              return ke[e];
            } }), Object.defineProperty(ar, a, C);
          } : function(ar, ke, e, a) {
            a === void 0 && (a = e), ar[a] = ke[e];
          }), Ve = M && M.__exportStar || function(ar, ke) {
            for (var e in ar) e !== "default" && !Object.prototype.hasOwnProperty.call(ke, e) && re(ke, ar, e);
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.version = M.visitorKeys = M.createProgram = M.clearCaches = M.simpleTraverse = M.clearProgramCache = M.parseWithNodeMaps = M.parseAndGenerateServices = M.parse = void 0;
          var Ke = uz();
          Object.defineProperty(M, "parse", { enumerable: true, get: function() {
            return Ke.parse;
          } }), Object.defineProperty(M, "parseAndGenerateServices", { enumerable: true, get: function() {
            return Ke.parseAndGenerateServices;
          } }), Object.defineProperty(M, "parseWithNodeMaps", { enumerable: true, get: function() {
            return Ke.parseWithNodeMaps;
          } }), Object.defineProperty(M, "clearProgramCache", { enumerable: true, get: function() {
            return Ke.clearProgramCache;
          } });
          var oi = c3();
          Object.defineProperty(M, "simpleTraverse", { enumerable: true, get: function() {
            return oi.simpleTraverse;
          } }), Ve(k1(), M);
          var kr = u3();
          Object.defineProperty(M, "clearCaches", { enumerable: true, get: function() {
            return kr.clearWatchCaches;
          } });
          var pr = l3();
          Object.defineProperty(M, "createProgram", { enumerable: true, get: function() {
            return pr.createProgramFromConfigFile;
          } }), Ve(rx(), M);
          var Lr = s3();
          Object.defineProperty(M, "visitorKeys", { enumerable: true, get: function() {
            return Lr.visitorKeys;
          } }), M.version = lz().version;
        } });
        Ea();
        var _z = S4(), pz = Tj(), dz = Fj(), gz = Mj(), mz = Uj(), b4 = { loc: true, range: true, comment: true, jsx: true, tokens: true, loggerFn: false, project: [] };
        function vz(M) {
          let { message: re, lineNumber: Ve, column: Ke } = M;
          return typeof Ve != "number" ? M : _z(re, { start: { line: Ve, column: Ke + 1 } });
        }
        function yz(M, re) {
          let Ve = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, Ke = gz(M), oi = hz(M), { parseWithNodeMaps: kr } = fz(), { result: pr, error: Lr } = pz(() => kr(Ke, Object.assign(Object.assign({}, b4), {}, { jsx: oi })), () => kr(Ke, Object.assign(Object.assign({}, b4), {}, { jsx: !oi })));
          if (!pr) throw vz(Lr);
          return Ve.originalText = M, Ve.tsParseResult = pr, mz(pr.ast, Ve);
        }
        function hz(M) {
          return new RegExp(["(?:^[^\"'`]*</)", "|", "(?:^[^/]{2}.*/>)"].join(""), "m").test(M);
        }
        f3.exports = { parsers: { typescript: dz(yz) } };
      });
      return Dz();
    });
  }
});

// ../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-angular.js
var require_parser_angular = __commonJS({
  "../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-angular.js"(exports2, module2) {
    "use strict";
    (function(e) {
      if (typeof exports2 == "object" && typeof module2 == "object") module2.exports = e();
      else if (typeof define == "function" && define.amd) define(e);
      else {
        var i = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i.prettierPlugins = i.prettierPlugins || {}, i.prettierPlugins.angular = e();
      }
    })(function() {
      "use strict";
      var un = (e, t) => () => (t || e((t = { exports: {} }).exports, t), t.exports);
      var Mn = un((jn, on) => {
        var ze = Object.defineProperty, hn = Object.getOwnPropertyDescriptor, He = Object.getOwnPropertyNames, ln = Object.prototype.hasOwnProperty, Y = (e, t) => function() {
          return e && (t = (0, e[He(e)[0]])(e = 0)), t;
        }, q = (e, t) => function() {
          return t || (0, e[He(e)[0]])((t = { exports: {} }).exports, t), t.exports;
        }, Xe = (e, t) => {
          for (var n in t) ze(e, n, { get: t[n], enumerable: true });
        }, pn = (e, t, n, r) => {
          if (t && typeof t == "object" || typeof t == "function") for (let s of He(t)) !ln.call(e, s) && s !== n && ze(e, s, { get: () => t[s], enumerable: !(r = hn(t, s)) || r.enumerable });
          return e;
        }, be = (e) => pn(ze({}, "__esModule", { value: true }), e), L = Y({ "<define:process>"() {
        } }), dn = q({ "src/utils/is-non-empty-array.js"(e, t) {
          "use strict";
          L();
          function n(r) {
            return Array.isArray(r) && r.length > 0;
          }
          t.exports = n;
        } }), fn = q({ "src/language-js/loc.js"(e, t) {
          "use strict";
          L();
          var n = dn();
          function r(h, P) {
            let { ignoreDecorators: p } = P || {};
            if (!p) {
              let x = h.declaration && h.declaration.decorators || h.decorators;
              if (n(x)) return r(x[0]);
            }
            return h.range ? h.range[0] : h.start;
          }
          function s(h) {
            return h.range ? h.range[1] : h.end;
          }
          function a(h, P) {
            let p = r(h);
            return Number.isInteger(p) && p === r(P);
          }
          function i(h, P) {
            let p = s(h);
            return Number.isInteger(p) && p === s(P);
          }
          function l(h, P) {
            return a(h, P) && i(h, P);
          }
          t.exports = { locStart: r, locEnd: s, hasSameLocStart: a, hasSameLoc: l };
        } }), gn = q({ "node_modules/angular-estree-parser/node_modules/lines-and-columns/build/index.js"(e) {
          "use strict";
          L(), e.__esModule = true, e.LinesAndColumns = void 0;
          var t = `
`, n = "\r", r = function() {
            function s(a) {
              this.string = a;
              for (var i = [0], l = 0; l < a.length; ) switch (a[l]) {
                case t:
                  l += t.length, i.push(l);
                  break;
                case n:
                  l += n.length, a[l] === t && (l += t.length), i.push(l);
                  break;
                default:
                  l++;
                  break;
              }
              this.offsets = i;
            }
            return s.prototype.locationForIndex = function(a) {
              if (a < 0 || a > this.string.length) return null;
              for (var i = 0, l = this.offsets; l[i + 1] <= a; ) i++;
              var h = a - l[i];
              return { line: i, column: h };
            }, s.prototype.indexForLocation = function(a) {
              var i = a.line, l = a.column;
              return i < 0 || i >= this.offsets.length || l < 0 || l > this.lengthOfLine(i) ? null : this.offsets[i] + l;
            }, s.prototype.lengthOfLine = function(a) {
              var i = this.offsets[a], l = a === this.offsets.length - 1 ? this.string.length : this.offsets[a + 1];
              return l - i;
            }, s;
          }();
          e.LinesAndColumns = r, e.default = r;
        } }), vn = q({ "node_modules/angular-estree-parser/lib/context.js"(e) {
          "use strict";
          L(), Object.defineProperty(e, "__esModule", { value: true }), e.Context = void 0;
          var t = gn(), n = class {
            constructor(s) {
              this.text = s, this.locator = new r(this.text);
            }
          };
          e.Context = n;
          var r = class {
            constructor(s) {
              this._lineAndColumn = new t.default(s);
            }
            locationForIndex(s) {
              let { line: a, column: i } = this._lineAndColumn.locationForIndex(s);
              return { line: a + 1, column: i };
            }
          };
        } }), Je = {};
        Xe(Je, { AST: () => k, ASTWithName: () => W, ASTWithSource: () => G, AbsoluteSourceSpan: () => U, AstMemoryEfficientTransformer: () => Ct, AstTransformer: () => Pt, Binary: () => K, BindingPipe: () => fe, BoundElementProperty: () => It, Chain: () => oe, Conditional: () => ce, EmptyExpr: () => M, ExpressionBinding: () => Ze, FunctionCall: () => Pe, ImplicitReceiver: () => Oe, Interpolation: () => me, KeyedRead: () => le, KeyedWrite: () => de, LiteralArray: () => ge, LiteralMap: () => ve, LiteralPrimitive: () => B, MethodCall: () => ye, NonNullAssert: () => Se, ParseSpan: () => V, ParsedEvent: () => At, ParsedProperty: () => Et, ParsedPropertyType: () => se, ParsedVariable: () => _t, ParserError: () => ae, PrefixNot: () => xe, PropertyRead: () => re, PropertyWrite: () => ue, Quote: () => Le, RecursiveAstVisitor: () => et, SafeKeyedRead: () => pe, SafeMethodCall: () => we, SafePropertyRead: () => he, ThisReceiver: () => Ye, Unary: () => F, VariableBinding: () => Re });
        var ae, V, k, W, Le, M, Oe, Ye, oe, ce, re, ue, he, le, pe, de, fe, B, ge, ve, me, K, F, xe, Se, ye, we, Pe, U, G, Re, Ze, et, Pt, Ct, Et, se, At, _t, It, tt = Y({ "node_modules/@angular/compiler/esm2015/src/expression_parser/ast.js"() {
          L(), ae = class {
            constructor(e, t, n, r) {
              this.input = t, this.errLocation = n, this.ctxLocation = r, this.message = "Parser Error: ".concat(e, " ").concat(n, " [").concat(t, "] in ").concat(r);
            }
          }, V = class {
            constructor(e, t) {
              this.start = e, this.end = t;
            }
            toAbsolute(e) {
              return new U(e + this.start, e + this.end);
            }
          }, k = class {
            constructor(e, t) {
              this.span = e, this.sourceSpan = t;
            }
            toString() {
              return "AST";
            }
          }, W = class extends k {
            constructor(e, t, n) {
              super(e, t), this.nameSpan = n;
            }
          }, Le = class extends k {
            constructor(e, t, n, r, s) {
              super(e, t), this.prefix = n, this.uninterpretedExpression = r, this.location = s;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitQuote(this, t);
            }
            toString() {
              return "Quote";
            }
          }, M = class extends k {
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
            }
          }, Oe = class extends k {
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitImplicitReceiver(this, t);
            }
          }, Ye = class extends Oe {
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              var n;
              return (n = e.visitThisReceiver) === null || n === void 0 ? void 0 : n.call(e, this, t);
            }
          }, oe = class extends k {
            constructor(e, t, n) {
              super(e, t), this.expressions = n;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitChain(this, t);
            }
          }, ce = class extends k {
            constructor(e, t, n, r, s) {
              super(e, t), this.condition = n, this.trueExp = r, this.falseExp = s;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitConditional(this, t);
            }
          }, re = class extends W {
            constructor(e, t, n, r, s) {
              super(e, t, n), this.receiver = r, this.name = s;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitPropertyRead(this, t);
            }
          }, ue = class extends W {
            constructor(e, t, n, r, s, a) {
              super(e, t, n), this.receiver = r, this.name = s, this.value = a;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitPropertyWrite(this, t);
            }
          }, he = class extends W {
            constructor(e, t, n, r, s) {
              super(e, t, n), this.receiver = r, this.name = s;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitSafePropertyRead(this, t);
            }
          }, le = class extends k {
            constructor(e, t, n, r) {
              super(e, t), this.receiver = n, this.key = r;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitKeyedRead(this, t);
            }
          }, pe = class extends k {
            constructor(e, t, n, r) {
              super(e, t), this.receiver = n, this.key = r;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitSafeKeyedRead(this, t);
            }
          }, de = class extends k {
            constructor(e, t, n, r, s) {
              super(e, t), this.receiver = n, this.key = r, this.value = s;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitKeyedWrite(this, t);
            }
          }, fe = class extends W {
            constructor(e, t, n, r, s, a) {
              super(e, t, a), this.exp = n, this.name = r, this.args = s;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitPipe(this, t);
            }
          }, B = class extends k {
            constructor(e, t, n) {
              super(e, t), this.value = n;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitLiteralPrimitive(this, t);
            }
          }, ge = class extends k {
            constructor(e, t, n) {
              super(e, t), this.expressions = n;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitLiteralArray(this, t);
            }
          }, ve = class extends k {
            constructor(e, t, n, r) {
              super(e, t), this.keys = n, this.values = r;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitLiteralMap(this, t);
            }
          }, me = class extends k {
            constructor(e, t, n, r) {
              super(e, t), this.strings = n, this.expressions = r;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitInterpolation(this, t);
            }
          }, K = class extends k {
            constructor(e, t, n, r, s) {
              super(e, t), this.operation = n, this.left = r, this.right = s;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitBinary(this, t);
            }
          }, F = class extends K {
            constructor(e, t, n, r, s, a, i) {
              super(e, t, s, a, i), this.operator = n, this.expr = r;
            }
            static createMinus(e, t, n) {
              return new F(e, t, "-", n, "-", new B(e, t, 0), n);
            }
            static createPlus(e, t, n) {
              return new F(e, t, "+", n, "-", n, new B(e, t, 0));
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitUnary !== void 0 ? e.visitUnary(this, t) : e.visitBinary(this, t);
            }
          }, xe = class extends k {
            constructor(e, t, n) {
              super(e, t), this.expression = n;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitPrefixNot(this, t);
            }
          }, Se = class extends k {
            constructor(e, t, n) {
              super(e, t), this.expression = n;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitNonNullAssert(this, t);
            }
          }, ye = class extends W {
            constructor(e, t, n, r, s, a, i) {
              super(e, t, n), this.receiver = r, this.name = s, this.args = a, this.argumentSpan = i;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitMethodCall(this, t);
            }
          }, we = class extends W {
            constructor(e, t, n, r, s, a, i) {
              super(e, t, n), this.receiver = r, this.name = s, this.args = a, this.argumentSpan = i;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitSafeMethodCall(this, t);
            }
          }, Pe = class extends k {
            constructor(e, t, n, r) {
              super(e, t), this.target = n, this.args = r;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitFunctionCall(this, t);
            }
          }, U = class {
            constructor(e, t) {
              this.start = e, this.end = t;
            }
          }, G = class extends k {
            constructor(e, t, n, r, s) {
              super(new V(0, t === null ? 0 : t.length), new U(r, t === null ? r : r + t.length)), this.ast = e, this.source = t, this.location = n, this.errors = s;
            }
            visit(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e.visitASTWithSource ? e.visitASTWithSource(this, t) : this.ast.visit(e, t);
            }
            toString() {
              return "".concat(this.source, " in ").concat(this.location);
            }
          }, Re = class {
            constructor(e, t, n) {
              this.sourceSpan = e, this.key = t, this.value = n;
            }
          }, Ze = class {
            constructor(e, t, n) {
              this.sourceSpan = e, this.key = t, this.value = n;
            }
          }, et = class {
            visit(e, t) {
              e.visit(this, t);
            }
            visitUnary(e, t) {
              this.visit(e.expr, t);
            }
            visitBinary(e, t) {
              this.visit(e.left, t), this.visit(e.right, t);
            }
            visitChain(e, t) {
              this.visitAll(e.expressions, t);
            }
            visitConditional(e, t) {
              this.visit(e.condition, t), this.visit(e.trueExp, t), this.visit(e.falseExp, t);
            }
            visitPipe(e, t) {
              this.visit(e.exp, t), this.visitAll(e.args, t);
            }
            visitFunctionCall(e, t) {
              e.target && this.visit(e.target, t), this.visitAll(e.args, t);
            }
            visitImplicitReceiver(e, t) {
            }
            visitThisReceiver(e, t) {
            }
            visitInterpolation(e, t) {
              this.visitAll(e.expressions, t);
            }
            visitKeyedRead(e, t) {
              this.visit(e.receiver, t), this.visit(e.key, t);
            }
            visitKeyedWrite(e, t) {
              this.visit(e.receiver, t), this.visit(e.key, t), this.visit(e.value, t);
            }
            visitLiteralArray(e, t) {
              this.visitAll(e.expressions, t);
            }
            visitLiteralMap(e, t) {
              this.visitAll(e.values, t);
            }
            visitLiteralPrimitive(e, t) {
            }
            visitMethodCall(e, t) {
              this.visit(e.receiver, t), this.visitAll(e.args, t);
            }
            visitPrefixNot(e, t) {
              this.visit(e.expression, t);
            }
            visitNonNullAssert(e, t) {
              this.visit(e.expression, t);
            }
            visitPropertyRead(e, t) {
              this.visit(e.receiver, t);
            }
            visitPropertyWrite(e, t) {
              this.visit(e.receiver, t), this.visit(e.value, t);
            }
            visitSafePropertyRead(e, t) {
              this.visit(e.receiver, t);
            }
            visitSafeMethodCall(e, t) {
              this.visit(e.receiver, t), this.visitAll(e.args, t);
            }
            visitSafeKeyedRead(e, t) {
              this.visit(e.receiver, t), this.visit(e.key, t);
            }
            visitQuote(e, t) {
            }
            visitAll(e, t) {
              for (let n of e) this.visit(n, t);
            }
          }, Pt = class {
            visitImplicitReceiver(e, t) {
              return e;
            }
            visitThisReceiver(e, t) {
              return e;
            }
            visitInterpolation(e, t) {
              return new me(e.span, e.sourceSpan, e.strings, this.visitAll(e.expressions));
            }
            visitLiteralPrimitive(e, t) {
              return new B(e.span, e.sourceSpan, e.value);
            }
            visitPropertyRead(e, t) {
              return new re(e.span, e.sourceSpan, e.nameSpan, e.receiver.visit(this), e.name);
            }
            visitPropertyWrite(e, t) {
              return new ue(e.span, e.sourceSpan, e.nameSpan, e.receiver.visit(this), e.name, e.value.visit(this));
            }
            visitSafePropertyRead(e, t) {
              return new he(e.span, e.sourceSpan, e.nameSpan, e.receiver.visit(this), e.name);
            }
            visitMethodCall(e, t) {
              return new ye(e.span, e.sourceSpan, e.nameSpan, e.receiver.visit(this), e.name, this.visitAll(e.args), e.argumentSpan);
            }
            visitSafeMethodCall(e, t) {
              return new we(e.span, e.sourceSpan, e.nameSpan, e.receiver.visit(this), e.name, this.visitAll(e.args), e.argumentSpan);
            }
            visitFunctionCall(e, t) {
              return new Pe(e.span, e.sourceSpan, e.target.visit(this), this.visitAll(e.args));
            }
            visitLiteralArray(e, t) {
              return new ge(e.span, e.sourceSpan, this.visitAll(e.expressions));
            }
            visitLiteralMap(e, t) {
              return new ve(e.span, e.sourceSpan, e.keys, this.visitAll(e.values));
            }
            visitUnary(e, t) {
              switch (e.operator) {
                case "+":
                  return F.createPlus(e.span, e.sourceSpan, e.expr.visit(this));
                case "-":
                  return F.createMinus(e.span, e.sourceSpan, e.expr.visit(this));
                default:
                  throw new Error("Unknown unary operator ".concat(e.operator));
              }
            }
            visitBinary(e, t) {
              return new K(e.span, e.sourceSpan, e.operation, e.left.visit(this), e.right.visit(this));
            }
            visitPrefixNot(e, t) {
              return new xe(e.span, e.sourceSpan, e.expression.visit(this));
            }
            visitNonNullAssert(e, t) {
              return new Se(e.span, e.sourceSpan, e.expression.visit(this));
            }
            visitConditional(e, t) {
              return new ce(e.span, e.sourceSpan, e.condition.visit(this), e.trueExp.visit(this), e.falseExp.visit(this));
            }
            visitPipe(e, t) {
              return new fe(e.span, e.sourceSpan, e.exp.visit(this), e.name, this.visitAll(e.args), e.nameSpan);
            }
            visitKeyedRead(e, t) {
              return new le(e.span, e.sourceSpan, e.receiver.visit(this), e.key.visit(this));
            }
            visitKeyedWrite(e, t) {
              return new de(e.span, e.sourceSpan, e.receiver.visit(this), e.key.visit(this), e.value.visit(this));
            }
            visitAll(e) {
              let t = [];
              for (let n = 0; n < e.length; ++n) t[n] = e[n].visit(this);
              return t;
            }
            visitChain(e, t) {
              return new oe(e.span, e.sourceSpan, this.visitAll(e.expressions));
            }
            visitQuote(e, t) {
              return new Le(e.span, e.sourceSpan, e.prefix, e.uninterpretedExpression, e.location);
            }
            visitSafeKeyedRead(e, t) {
              return new pe(e.span, e.sourceSpan, e.receiver.visit(this), e.key.visit(this));
            }
          }, Ct = class {
            visitImplicitReceiver(e, t) {
              return e;
            }
            visitThisReceiver(e, t) {
              return e;
            }
            visitInterpolation(e, t) {
              let n = this.visitAll(e.expressions);
              return n !== e.expressions ? new me(e.span, e.sourceSpan, e.strings, n) : e;
            }
            visitLiteralPrimitive(e, t) {
              return e;
            }
            visitPropertyRead(e, t) {
              let n = e.receiver.visit(this);
              return n !== e.receiver ? new re(e.span, e.sourceSpan, e.nameSpan, n, e.name) : e;
            }
            visitPropertyWrite(e, t) {
              let n = e.receiver.visit(this), r = e.value.visit(this);
              return n !== e.receiver || r !== e.value ? new ue(e.span, e.sourceSpan, e.nameSpan, n, e.name, r) : e;
            }
            visitSafePropertyRead(e, t) {
              let n = e.receiver.visit(this);
              return n !== e.receiver ? new he(e.span, e.sourceSpan, e.nameSpan, n, e.name) : e;
            }
            visitMethodCall(e, t) {
              let n = e.receiver.visit(this), r = this.visitAll(e.args);
              return n !== e.receiver || r !== e.args ? new ye(e.span, e.sourceSpan, e.nameSpan, n, e.name, r, e.argumentSpan) : e;
            }
            visitSafeMethodCall(e, t) {
              let n = e.receiver.visit(this), r = this.visitAll(e.args);
              return n !== e.receiver || r !== e.args ? new we(e.span, e.sourceSpan, e.nameSpan, n, e.name, r, e.argumentSpan) : e;
            }
            visitFunctionCall(e, t) {
              let n = e.target && e.target.visit(this), r = this.visitAll(e.args);
              return n !== e.target || r !== e.args ? new Pe(e.span, e.sourceSpan, n, r) : e;
            }
            visitLiteralArray(e, t) {
              let n = this.visitAll(e.expressions);
              return n !== e.expressions ? new ge(e.span, e.sourceSpan, n) : e;
            }
            visitLiteralMap(e, t) {
              let n = this.visitAll(e.values);
              return n !== e.values ? new ve(e.span, e.sourceSpan, e.keys, n) : e;
            }
            visitUnary(e, t) {
              let n = e.expr.visit(this);
              if (n !== e.expr) switch (e.operator) {
                case "+":
                  return F.createPlus(e.span, e.sourceSpan, n);
                case "-":
                  return F.createMinus(e.span, e.sourceSpan, n);
                default:
                  throw new Error("Unknown unary operator ".concat(e.operator));
              }
              return e;
            }
            visitBinary(e, t) {
              let n = e.left.visit(this), r = e.right.visit(this);
              return n !== e.left || r !== e.right ? new K(e.span, e.sourceSpan, e.operation, n, r) : e;
            }
            visitPrefixNot(e, t) {
              let n = e.expression.visit(this);
              return n !== e.expression ? new xe(e.span, e.sourceSpan, n) : e;
            }
            visitNonNullAssert(e, t) {
              let n = e.expression.visit(this);
              return n !== e.expression ? new Se(e.span, e.sourceSpan, n) : e;
            }
            visitConditional(e, t) {
              let n = e.condition.visit(this), r = e.trueExp.visit(this), s = e.falseExp.visit(this);
              return n !== e.condition || r !== e.trueExp || s !== e.falseExp ? new ce(e.span, e.sourceSpan, n, r, s) : e;
            }
            visitPipe(e, t) {
              let n = e.exp.visit(this), r = this.visitAll(e.args);
              return n !== e.exp || r !== e.args ? new fe(e.span, e.sourceSpan, n, e.name, r, e.nameSpan) : e;
            }
            visitKeyedRead(e, t) {
              let n = e.receiver.visit(this), r = e.key.visit(this);
              return n !== e.receiver || r !== e.key ? new le(e.span, e.sourceSpan, n, r) : e;
            }
            visitKeyedWrite(e, t) {
              let n = e.receiver.visit(this), r = e.key.visit(this), s = e.value.visit(this);
              return n !== e.receiver || r !== e.key || s !== e.value ? new de(e.span, e.sourceSpan, n, r, s) : e;
            }
            visitAll(e) {
              let t = [], n = false;
              for (let r = 0; r < e.length; ++r) {
                let s = e[r], a = s.visit(this);
                t[r] = a, n = n || a !== s;
              }
              return n ? t : e;
            }
            visitChain(e, t) {
              let n = this.visitAll(e.expressions);
              return n !== e.expressions ? new oe(e.span, e.sourceSpan, n) : e;
            }
            visitQuote(e, t) {
              return e;
            }
            visitSafeKeyedRead(e, t) {
              let n = e.receiver.visit(this), r = e.key.visit(this);
              return n !== e.receiver || r !== e.key ? new pe(e.span, e.sourceSpan, n, r) : e;
            }
          }, Et = class {
            constructor(e, t, n, r, s, a) {
              this.name = e, this.expression = t, this.type = n, this.sourceSpan = r, this.keySpan = s, this.valueSpan = a, this.isLiteral = this.type === se.LITERAL_ATTR, this.isAnimation = this.type === se.ANIMATION;
            }
          }, function(e) {
            e[e.DEFAULT = 0] = "DEFAULT", e[e.LITERAL_ATTR = 1] = "LITERAL_ATTR", e[e.ANIMATION = 2] = "ANIMATION";
          }(se || (se = {})), At = class {
            constructor(e, t, n, r, s, a, i) {
              this.name = e, this.targetOrPhase = t, this.type = n, this.handler = r, this.sourceSpan = s, this.handlerSpan = a, this.keySpan = i;
            }
          }, _t = class {
            constructor(e, t, n, r, s) {
              this.name = e, this.value = t, this.sourceSpan = n, this.keySpan = r, this.valueSpan = s;
            }
          }, It = class {
            constructor(e, t, n, r, s, a, i, l) {
              this.name = e, this.type = t, this.securityContext = n, this.value = r, this.unit = s, this.sourceSpan = a, this.keySpan = i, this.valueSpan = l;
            }
          };
        } });
        function mn(e) {
          return e >= nt && e <= rt || e == dt;
        }
        function Q(e) {
          return $t <= e && e <= jt;
        }
        function xn(e) {
          return e >= lt && e <= pt || e >= ut && e <= ht;
        }
        function mt(e) {
          return e === at || e === st || e === Xt;
        }
        var Ce, nt, Ot, kt, Nt, bt, rt, Lt, st, Rt, it, Tt, je, at, Ee, z2, Bt, ot, ee, ct, H, Te, X, te, Kt, ie, Mt, Fe, $t, jt, ut, Ft, ht, Ae, Ut, ne, Wt, Ke, lt, Gt, Vt, qt, Qt, Dt, zt, Ht, pt, Be, Ue, _e, dt, Xt, Jt = Y({ "node_modules/@angular/compiler/esm2015/src/chars.js"() {
          L(), Ce = 0, nt = 9, Ot = 10, kt = 11, Nt = 12, bt = 13, rt = 32, Lt = 33, st = 34, Rt = 35, it = 36, Tt = 37, je = 38, at = 39, Ee = 40, z2 = 41, Bt = 42, ot = 43, ee = 44, ct = 45, H = 46, Te = 47, X = 58, te = 59, Kt = 60, ie = 61, Mt = 62, Fe = 63, $t = 48, jt = 57, ut = 65, Ft = 69, ht = 90, Ae = 91, Ut = 92, ne = 93, Wt = 94, Ke = 95, lt = 97, Gt = 101, Vt = 102, qt = 110, Qt = 114, Dt = 116, zt = 117, Ht = 118, pt = 122, Be = 123, Ue = 124, _e = 125, dt = 160, Xt = 96;
        } }), Yt = {};
        Xe(Yt, { EOF: () => Ie, Lexer: () => en, Token: () => $, TokenType: () => S, isIdentifier: () => Zt });
        function xt(e, t, n) {
          return new $(e, t, S.Character, n, String.fromCharCode(n));
        }
        function Sn(e, t, n) {
          return new $(e, t, S.Identifier, 0, n);
        }
        function yn(e, t, n) {
          return new $(e, t, S.PrivateIdentifier, 0, n);
        }
        function wn(e, t, n) {
          return new $(e, t, S.Keyword, 0, n);
        }
        function Me(e, t, n) {
          return new $(e, t, S.Operator, 0, n);
        }
        function Pn(e, t, n) {
          return new $(e, t, S.String, 0, n);
        }
        function Cn(e, t, n) {
          return new $(e, t, S.Number, n, "");
        }
        function En(e, t, n) {
          return new $(e, t, S.Error, 0, n);
        }
        function We(e) {
          return lt <= e && e <= pt || ut <= e && e <= ht || e == Ke || e == it;
        }
        function Zt(e) {
          if (e.length == 0) return false;
          let t = new Ve(e);
          if (!We(t.peek)) return false;
          for (t.advance(); t.peek !== Ce; ) {
            if (!Ge(t.peek)) return false;
            t.advance();
          }
          return true;
        }
        function Ge(e) {
          return xn(e) || Q(e) || e == Ke || e == it;
        }
        function An(e) {
          return e == Gt || e == Ft;
        }
        function _n(e) {
          return e == ct || e == ot;
        }
        function In(e) {
          switch (e) {
            case qt:
              return Ot;
            case Vt:
              return Nt;
            case Qt:
              return bt;
            case Dt:
              return nt;
            case Ht:
              return kt;
            default:
              return e;
          }
        }
        function On(e) {
          let t = parseInt(e);
          if (isNaN(t)) throw new Error("Invalid integer literal when parsing " + e);
          return t;
        }
        var S, St, en, $, Ie, Ve, tn = Y({ "node_modules/@angular/compiler/esm2015/src/expression_parser/lexer.js"() {
          L(), Jt(), function(e) {
            e[e.Character = 0] = "Character", e[e.Identifier = 1] = "Identifier", e[e.PrivateIdentifier = 2] = "PrivateIdentifier", e[e.Keyword = 3] = "Keyword", e[e.String = 4] = "String", e[e.Operator = 5] = "Operator", e[e.Number = 6] = "Number", e[e.Error = 7] = "Error";
          }(S || (S = {})), St = ["var", "let", "as", "null", "undefined", "true", "false", "if", "else", "this"], en = class {
            tokenize(e) {
              let t = new Ve(e), n = [], r = t.scanToken();
              for (; r != null; ) n.push(r), r = t.scanToken();
              return n;
            }
          }, $ = class {
            constructor(e, t, n, r, s) {
              this.index = e, this.end = t, this.type = n, this.numValue = r, this.strValue = s;
            }
            isCharacter(e) {
              return this.type == S.Character && this.numValue == e;
            }
            isNumber() {
              return this.type == S.Number;
            }
            isString() {
              return this.type == S.String;
            }
            isOperator(e) {
              return this.type == S.Operator && this.strValue == e;
            }
            isIdentifier() {
              return this.type == S.Identifier;
            }
            isPrivateIdentifier() {
              return this.type == S.PrivateIdentifier;
            }
            isKeyword() {
              return this.type == S.Keyword;
            }
            isKeywordLet() {
              return this.type == S.Keyword && this.strValue == "let";
            }
            isKeywordAs() {
              return this.type == S.Keyword && this.strValue == "as";
            }
            isKeywordNull() {
              return this.type == S.Keyword && this.strValue == "null";
            }
            isKeywordUndefined() {
              return this.type == S.Keyword && this.strValue == "undefined";
            }
            isKeywordTrue() {
              return this.type == S.Keyword && this.strValue == "true";
            }
            isKeywordFalse() {
              return this.type == S.Keyword && this.strValue == "false";
            }
            isKeywordThis() {
              return this.type == S.Keyword && this.strValue == "this";
            }
            isError() {
              return this.type == S.Error;
            }
            toNumber() {
              return this.type == S.Number ? this.numValue : -1;
            }
            toString() {
              switch (this.type) {
                case S.Character:
                case S.Identifier:
                case S.Keyword:
                case S.Operator:
                case S.PrivateIdentifier:
                case S.String:
                case S.Error:
                  return this.strValue;
                case S.Number:
                  return this.numValue.toString();
                default:
                  return null;
              }
            }
          }, Ie = new $(-1, -1, S.Character, 0, ""), Ve = class {
            constructor(e) {
              this.input = e, this.peek = 0, this.index = -1, this.length = e.length, this.advance();
            }
            advance() {
              this.peek = ++this.index >= this.length ? Ce : this.input.charCodeAt(this.index);
            }
            scanToken() {
              let e = this.input, t = this.length, n = this.peek, r = this.index;
              for (; n <= rt; ) if (++r >= t) {
                n = Ce;
                break;
              } else n = e.charCodeAt(r);
              if (this.peek = n, this.index = r, r >= t) return null;
              if (We(n)) return this.scanIdentifier();
              if (Q(n)) return this.scanNumber(r);
              let s = r;
              switch (n) {
                case H:
                  return this.advance(), Q(this.peek) ? this.scanNumber(s) : xt(s, this.index, H);
                case Ee:
                case z2:
                case Be:
                case _e:
                case Ae:
                case ne:
                case ee:
                case X:
                case te:
                  return this.scanCharacter(s, n);
                case at:
                case st:
                  return this.scanString();
                case Rt:
                  return this.scanPrivateIdentifier();
                case ot:
                case ct:
                case Bt:
                case Te:
                case Tt:
                case Wt:
                  return this.scanOperator(s, String.fromCharCode(n));
                case Fe:
                  return this.scanQuestion(s);
                case Kt:
                case Mt:
                  return this.scanComplexOperator(s, String.fromCharCode(n), ie, "=");
                case Lt:
                case ie:
                  return this.scanComplexOperator(s, String.fromCharCode(n), ie, "=", ie, "=");
                case je:
                  return this.scanComplexOperator(s, "&", je, "&");
                case Ue:
                  return this.scanComplexOperator(s, "|", Ue, "|");
                case dt:
                  for (; mn(this.peek); ) this.advance();
                  return this.scanToken();
              }
              return this.advance(), this.error("Unexpected character [".concat(String.fromCharCode(n), "]"), 0);
            }
            scanCharacter(e, t) {
              return this.advance(), xt(e, this.index, t);
            }
            scanOperator(e, t) {
              return this.advance(), Me(e, this.index, t);
            }
            scanComplexOperator(e, t, n, r, s, a) {
              this.advance();
              let i = t;
              return this.peek == n && (this.advance(), i += r), s != null && this.peek == s && (this.advance(), i += a), Me(e, this.index, i);
            }
            scanIdentifier() {
              let e = this.index;
              for (this.advance(); Ge(this.peek); ) this.advance();
              let t = this.input.substring(e, this.index);
              return St.indexOf(t) > -1 ? wn(e, this.index, t) : Sn(e, this.index, t);
            }
            scanPrivateIdentifier() {
              let e = this.index;
              if (this.advance(), !We(this.peek)) return this.error("Invalid character [#]", -1);
              for (; Ge(this.peek); ) this.advance();
              let t = this.input.substring(e, this.index);
              return yn(e, this.index, t);
            }
            scanNumber(e) {
              let t = this.index === e, n = false;
              for (this.advance(); ; ) {
                if (!Q(this.peek)) if (this.peek === Ke) {
                  if (!Q(this.input.charCodeAt(this.index - 1)) || !Q(this.input.charCodeAt(this.index + 1))) return this.error("Invalid numeric separator", 0);
                  n = true;
                } else if (this.peek === H) t = false;
                else if (An(this.peek)) {
                  if (this.advance(), _n(this.peek) && this.advance(), !Q(this.peek)) return this.error("Invalid exponent", -1);
                  t = false;
                } else break;
                this.advance();
              }
              let r = this.input.substring(e, this.index);
              n && (r = r.replace(/_/g, ""));
              let s = t ? On(r) : parseFloat(r);
              return Cn(e, this.index, s);
            }
            scanString() {
              let e = this.index, t = this.peek;
              this.advance();
              let n = "", r = this.index, s = this.input;
              for (; this.peek != t; ) if (this.peek == Ut) {
                n += s.substring(r, this.index), this.advance();
                let i;
                if (this.peek = this.peek, this.peek == zt) {
                  let l = s.substring(this.index + 1, this.index + 5);
                  if (/^[0-9a-f]+$/i.test(l)) i = parseInt(l, 16);
                  else return this.error("Invalid unicode escape [\\u".concat(l, "]"), 0);
                  for (let h = 0; h < 5; h++) this.advance();
                } else i = In(this.peek), this.advance();
                n += String.fromCharCode(i), r = this.index;
              } else {
                if (this.peek == Ce) return this.error("Unterminated quote", 0);
                this.advance();
              }
              let a = s.substring(r, this.index);
              return this.advance(), Pn(e, this.index, n + a);
            }
            scanQuestion(e) {
              this.advance();
              let t = "?";
              return (this.peek === Fe || this.peek === H) && (t += this.peek === H ? "." : "?", this.advance()), Me(e, this.index, t);
            }
            error(e, t) {
              let n = this.index + t;
              return En(n, this.index, "Lexer Error: ".concat(e, " at column ").concat(n, " in expression [").concat(this.input, "]"));
            }
          };
        } });
        function kn(e, t) {
          if (t != null && !(Array.isArray(t) && t.length == 2)) throw new Error("Expected '".concat(e, "' to be an array, [start, end]."));
          if (t != null) {
            let n = t[0], r = t[1];
            nn.forEach((s) => {
              if (s.test(n) || s.test(r)) throw new Error("['".concat(n, "', '").concat(r, "'] contains unusable interpolation symbol."));
            });
          }
        }
        var nn, Nn = Y({ "node_modules/@angular/compiler/esm2015/src/assertions.js"() {
          L(), nn = [/^\s*$/, /[<>]/, /^[{}]$/, /&(#|[a-z])/i, /^\/\//];
        } }), $e, J, bn = Y({ "node_modules/@angular/compiler/esm2015/src/ml_parser/interpolation_config.js"() {
          L(), Nn(), $e = class {
            constructor(e, t) {
              this.start = e, this.end = t;
            }
            static fromArray(e) {
              return e ? (kn("interpolation", e), new $e(e[0], e[1])) : J;
            }
          }, J = new $e("{{", "}}");
        } }), rn = {};
        Xe(rn, { IvyParser: () => sn, Parser: () => De, SplitInterpolation: () => qe, TemplateBindingParseResult: () => Qe, _ParseAST: () => D });
        var qe, Qe, De, sn, Z, D, yt, wt, Ln = Y({ "node_modules/@angular/compiler/esm2015/src/expression_parser/parser.js"() {
          L(), Jt(), bn(), tt(), tn(), qe = class {
            constructor(e, t, n) {
              this.strings = e, this.expressions = t, this.offsets = n;
            }
          }, Qe = class {
            constructor(e, t, n) {
              this.templateBindings = e, this.warnings = t, this.errors = n;
            }
          }, De = class {
            constructor(e) {
              this._lexer = e, this.errors = [], this.simpleExpressionChecker = yt;
            }
            parseAction(e, t, n) {
              let r = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : J;
              this._checkNoInterpolation(e, t, r);
              let s = this._stripComments(e), a = this._lexer.tokenize(this._stripComments(e)), i = new D(e, t, n, a, s.length, true, this.errors, e.length - s.length).parseChain();
              return new G(i, e, t, n, this.errors);
            }
            parseBinding(e, t, n) {
              let r = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : J, s = this._parseBindingAst(e, t, n, r);
              return new G(s, e, t, n, this.errors);
            }
            checkSimpleExpression(e) {
              let t = new this.simpleExpressionChecker();
              return e.visit(t), t.errors;
            }
            parseSimpleBinding(e, t, n) {
              let r = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : J, s = this._parseBindingAst(e, t, n, r), a = this.checkSimpleExpression(s);
              return a.length > 0 && this._reportError("Host binding expression cannot contain ".concat(a.join(" ")), e, t), new G(s, e, t, n, this.errors);
            }
            _reportError(e, t, n, r) {
              this.errors.push(new ae(e, t, n, r));
            }
            _parseBindingAst(e, t, n, r) {
              let s = this._parseQuote(e, t, n);
              if (s != null) return s;
              this._checkNoInterpolation(e, t, r);
              let a = this._stripComments(e), i = this._lexer.tokenize(a);
              return new D(e, t, n, i, a.length, false, this.errors, e.length - a.length).parseChain();
            }
            _parseQuote(e, t, n) {
              if (e == null) return null;
              let r = e.indexOf(":");
              if (r == -1) return null;
              let s = e.substring(0, r).trim();
              if (!Zt(s)) return null;
              let a = e.substring(r + 1), i = new V(0, e.length);
              return new Le(i, i.toAbsolute(n), s, a, t);
            }
            parseTemplateBindings(e, t, n, r, s) {
              let a = this._lexer.tokenize(t);
              return new D(t, n, s, a, t.length, false, this.errors, 0).parseTemplateBindings({ source: e, span: new U(r, r + e.length) });
            }
            parseInterpolation(e, t, n) {
              let r = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : J, { strings: s, expressions: a, offsets: i } = this.splitInterpolation(e, t, r);
              if (a.length === 0) return null;
              let l = [];
              for (let h = 0; h < a.length; ++h) {
                let P = a[h].text, p = this._stripComments(P), x = this._lexer.tokenize(p), A = new D(e, t, n, x, p.length, false, this.errors, i[h] + (P.length - p.length)).parseChain();
                l.push(A);
              }
              return this.createInterpolationAst(s.map((h) => h.text), l, e, t, n);
            }
            parseInterpolationExpression(e, t, n) {
              let r = this._stripComments(e), s = this._lexer.tokenize(r), a = new D(e, t, n, s, r.length, false, this.errors, 0).parseChain(), i = ["", ""];
              return this.createInterpolationAst(i, [a], e, t, n);
            }
            createInterpolationAst(e, t, n, r, s) {
              let a = new V(0, n.length), i = new me(a, a.toAbsolute(s), e, t);
              return new G(i, n, r, s, this.errors);
            }
            splitInterpolation(e, t) {
              let n = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : J, r = [], s = [], a = [], i = 0, l = false, h = false, { start: P, end: p } = n;
              for (; i < e.length; ) if (l) {
                let x = i, A = x + P.length, b = this._getInterpolationEndIndex(e, p, A);
                if (b === -1) {
                  l = false, h = true;
                  break;
                }
                let _ = b + p.length, R = e.substring(A, b);
                R.trim().length === 0 && this._reportError("Blank expressions are not allowed in interpolated strings", e, "at column ".concat(i, " in"), t), s.push({ text: R, start: x, end: _ }), a.push(A), i = _, l = false;
              } else {
                let x = i;
                i = e.indexOf(P, i), i === -1 && (i = e.length);
                let A = e.substring(x, i);
                r.push({ text: A, start: x, end: i }), l = true;
              }
              if (!l) if (h) {
                let x = r[r.length - 1];
                x.text += e.substring(i), x.end = e.length;
              } else r.push({ text: e.substring(i), start: i, end: e.length });
              return new qe(r, s, a);
            }
            wrapLiteralPrimitive(e, t, n) {
              let r = new V(0, e == null ? 0 : e.length);
              return new G(new B(r, r.toAbsolute(n), e), e, t, n, this.errors);
            }
            _stripComments(e) {
              let t = this._commentStart(e);
              return t != null ? e.substring(0, t).trim() : e;
            }
            _commentStart(e) {
              let t = null;
              for (let n = 0; n < e.length - 1; n++) {
                let r = e.charCodeAt(n), s = e.charCodeAt(n + 1);
                if (r === Te && s == Te && t == null) return n;
                t === r ? t = null : t == null && mt(r) && (t = r);
              }
              return null;
            }
            _checkNoInterpolation(e, t, n) {
              let { start: r, end: s } = n, a = -1, i = -1;
              for (let l of this._forEachUnquotedChar(e, 0)) if (a === -1) e.startsWith(r) && (a = l);
              else if (i = this._getInterpolationEndIndex(e, s, l), i > -1) break;
              a > -1 && i > -1 && this._reportError("Got interpolation (".concat(r).concat(s, ") where expression was expected"), e, "at column ".concat(a, " in"), t);
            }
            _getInterpolationEndIndex(e, t, n) {
              for (let r of this._forEachUnquotedChar(e, n)) {
                if (e.startsWith(t, r)) return r;
                if (e.startsWith("//", r)) return e.indexOf(t, r);
              }
              return -1;
            }
            *_forEachUnquotedChar(e, t) {
              let n = null, r = 0;
              for (let s = t; s < e.length; s++) {
                let a = e[s];
                mt(e.charCodeAt(s)) && (n === null || n === a) && r % 2 === 0 ? n = n === null ? a : null : n === null && (yield s), r = a === "\\" ? r + 1 : 0;
              }
            }
          }, sn = class extends De {
            constructor() {
              super(...arguments), this.simpleExpressionChecker = wt;
            }
          }, function(e) {
            e[e.None = 0] = "None", e[e.Writable = 1] = "Writable";
          }(Z || (Z = {})), D = class {
            constructor(e, t, n, r, s, a, i, l) {
              this.input = e, this.location = t, this.absoluteOffset = n, this.tokens = r, this.inputLength = s, this.parseAction = a, this.errors = i, this.offset = l, this.rparensExpected = 0, this.rbracketsExpected = 0, this.rbracesExpected = 0, this.context = Z.None, this.sourceSpanCache = /* @__PURE__ */ new Map(), this.index = 0;
            }
            peek(e) {
              let t = this.index + e;
              return t < this.tokens.length ? this.tokens[t] : Ie;
            }
            get next() {
              return this.peek(0);
            }
            get atEOF() {
              return this.index >= this.tokens.length;
            }
            get inputIndex() {
              return this.atEOF ? this.currentEndIndex : this.next.index + this.offset;
            }
            get currentEndIndex() {
              return this.index > 0 ? this.peek(-1).end + this.offset : this.tokens.length === 0 ? this.inputLength + this.offset : this.next.index + this.offset;
            }
            get currentAbsoluteOffset() {
              return this.absoluteOffset + this.inputIndex;
            }
            span(e, t) {
              let n = this.currentEndIndex;
              if (t !== void 0 && t > this.currentEndIndex && (n = t), e > n) {
                let r = n;
                n = e, e = r;
              }
              return new V(e, n);
            }
            sourceSpan(e, t) {
              let n = "".concat(e, "@").concat(this.inputIndex, ":").concat(t);
              return this.sourceSpanCache.has(n) || this.sourceSpanCache.set(n, this.span(e, t).toAbsolute(this.absoluteOffset)), this.sourceSpanCache.get(n);
            }
            advance() {
              this.index++;
            }
            withContext(e, t) {
              this.context |= e;
              let n = t();
              return this.context ^= e, n;
            }
            consumeOptionalCharacter(e) {
              return this.next.isCharacter(e) ? (this.advance(), true) : false;
            }
            peekKeywordLet() {
              return this.next.isKeywordLet();
            }
            peekKeywordAs() {
              return this.next.isKeywordAs();
            }
            expectCharacter(e) {
              this.consumeOptionalCharacter(e) || this.error("Missing expected ".concat(String.fromCharCode(e)));
            }
            consumeOptionalOperator(e) {
              return this.next.isOperator(e) ? (this.advance(), true) : false;
            }
            expectOperator(e) {
              this.consumeOptionalOperator(e) || this.error("Missing expected operator ".concat(e));
            }
            prettyPrintToken(e) {
              return e === Ie ? "end of input" : "token ".concat(e);
            }
            expectIdentifierOrKeyword() {
              let e = this.next;
              return !e.isIdentifier() && !e.isKeyword() ? (e.isPrivateIdentifier() ? this._reportErrorForPrivateIdentifier(e, "expected identifier or keyword") : this.error("Unexpected ".concat(this.prettyPrintToken(e), ", expected identifier or keyword")), null) : (this.advance(), e.toString());
            }
            expectIdentifierOrKeywordOrString() {
              let e = this.next;
              return !e.isIdentifier() && !e.isKeyword() && !e.isString() ? (e.isPrivateIdentifier() ? this._reportErrorForPrivateIdentifier(e, "expected identifier, keyword or string") : this.error("Unexpected ".concat(this.prettyPrintToken(e), ", expected identifier, keyword, or string")), "") : (this.advance(), e.toString());
            }
            parseChain() {
              let e = [], t = this.inputIndex;
              for (; this.index < this.tokens.length; ) {
                let n = this.parsePipe();
                if (e.push(n), this.consumeOptionalCharacter(te)) for (this.parseAction || this.error("Binding expression cannot contain chained expression"); this.consumeOptionalCharacter(te); ) ;
                else this.index < this.tokens.length && this.error("Unexpected token '".concat(this.next, "'"));
              }
              if (e.length == 0) {
                let n = this.offset, r = this.offset + this.inputLength;
                return new M(this.span(n, r), this.sourceSpan(n, r));
              }
              return e.length == 1 ? e[0] : new oe(this.span(t), this.sourceSpan(t), e);
            }
            parsePipe() {
              let e = this.inputIndex, t = this.parseExpression();
              if (this.consumeOptionalOperator("|")) {
                this.parseAction && this.error("Cannot have a pipe in an action expression");
                do {
                  let n = this.inputIndex, r = this.expectIdentifierOrKeyword(), s, a;
                  r !== null ? s = this.sourceSpan(n) : (r = "", a = this.next.index !== -1 ? this.next.index : this.inputLength + this.offset, s = new V(a, a).toAbsolute(this.absoluteOffset));
                  let i = [];
                  for (; this.consumeOptionalCharacter(X); ) i.push(this.parseExpression());
                  t = new fe(this.span(e), this.sourceSpan(e, a), t, r, i, s);
                } while (this.consumeOptionalOperator("|"));
              }
              return t;
            }
            parseExpression() {
              return this.parseConditional();
            }
            parseConditional() {
              let e = this.inputIndex, t = this.parseLogicalOr();
              if (this.consumeOptionalOperator("?")) {
                let n = this.parsePipe(), r;
                if (this.consumeOptionalCharacter(X)) r = this.parsePipe();
                else {
                  let s = this.inputIndex, a = this.input.substring(e, s);
                  this.error("Conditional expression ".concat(a, " requires all 3 expressions")), r = new M(this.span(e), this.sourceSpan(e));
                }
                return new ce(this.span(e), this.sourceSpan(e), t, n, r);
              } else return t;
            }
            parseLogicalOr() {
              let e = this.inputIndex, t = this.parseLogicalAnd();
              for (; this.consumeOptionalOperator("||"); ) {
                let n = this.parseLogicalAnd();
                t = new K(this.span(e), this.sourceSpan(e), "||", t, n);
              }
              return t;
            }
            parseLogicalAnd() {
              let e = this.inputIndex, t = this.parseNullishCoalescing();
              for (; this.consumeOptionalOperator("&&"); ) {
                let n = this.parseNullishCoalescing();
                t = new K(this.span(e), this.sourceSpan(e), "&&", t, n);
              }
              return t;
            }
            parseNullishCoalescing() {
              let e = this.inputIndex, t = this.parseEquality();
              for (; this.consumeOptionalOperator("??"); ) {
                let n = this.parseEquality();
                t = new K(this.span(e), this.sourceSpan(e), "??", t, n);
              }
              return t;
            }
            parseEquality() {
              let e = this.inputIndex, t = this.parseRelational();
              for (; this.next.type == S.Operator; ) {
                let n = this.next.strValue;
                switch (n) {
                  case "==":
                  case "===":
                  case "!=":
                  case "!==":
                    this.advance();
                    let r = this.parseRelational();
                    t = new K(this.span(e), this.sourceSpan(e), n, t, r);
                    continue;
                }
                break;
              }
              return t;
            }
            parseRelational() {
              let e = this.inputIndex, t = this.parseAdditive();
              for (; this.next.type == S.Operator; ) {
                let n = this.next.strValue;
                switch (n) {
                  case "<":
                  case ">":
                  case "<=":
                  case ">=":
                    this.advance();
                    let r = this.parseAdditive();
                    t = new K(this.span(e), this.sourceSpan(e), n, t, r);
                    continue;
                }
                break;
              }
              return t;
            }
            parseAdditive() {
              let e = this.inputIndex, t = this.parseMultiplicative();
              for (; this.next.type == S.Operator; ) {
                let n = this.next.strValue;
                switch (n) {
                  case "+":
                  case "-":
                    this.advance();
                    let r = this.parseMultiplicative();
                    t = new K(this.span(e), this.sourceSpan(e), n, t, r);
                    continue;
                }
                break;
              }
              return t;
            }
            parseMultiplicative() {
              let e = this.inputIndex, t = this.parsePrefix();
              for (; this.next.type == S.Operator; ) {
                let n = this.next.strValue;
                switch (n) {
                  case "*":
                  case "%":
                  case "/":
                    this.advance();
                    let r = this.parsePrefix();
                    t = new K(this.span(e), this.sourceSpan(e), n, t, r);
                    continue;
                }
                break;
              }
              return t;
            }
            parsePrefix() {
              if (this.next.type == S.Operator) {
                let e = this.inputIndex, t = this.next.strValue, n;
                switch (t) {
                  case "+":
                    return this.advance(), n = this.parsePrefix(), F.createPlus(this.span(e), this.sourceSpan(e), n);
                  case "-":
                    return this.advance(), n = this.parsePrefix(), F.createMinus(this.span(e), this.sourceSpan(e), n);
                  case "!":
                    return this.advance(), n = this.parsePrefix(), new xe(this.span(e), this.sourceSpan(e), n);
                }
              }
              return this.parseCallChain();
            }
            parseCallChain() {
              let e = this.inputIndex, t = this.parsePrimary();
              for (; ; ) if (this.consumeOptionalCharacter(H)) t = this.parseAccessMemberOrMethodCall(t, e, false);
              else if (this.consumeOptionalOperator("?.")) t = this.consumeOptionalCharacter(Ae) ? this.parseKeyedReadOrWrite(t, e, true) : this.parseAccessMemberOrMethodCall(t, e, true);
              else if (this.consumeOptionalCharacter(Ae)) t = this.parseKeyedReadOrWrite(t, e, false);
              else if (this.consumeOptionalCharacter(Ee)) {
                this.rparensExpected++;
                let n = this.parseCallArguments();
                this.rparensExpected--, this.expectCharacter(z2), t = new Pe(this.span(e), this.sourceSpan(e), t, n);
              } else if (this.consumeOptionalOperator("!")) t = new Se(this.span(e), this.sourceSpan(e), t);
              else return t;
            }
            parsePrimary() {
              let e = this.inputIndex;
              if (this.consumeOptionalCharacter(Ee)) {
                this.rparensExpected++;
                let t = this.parsePipe();
                return this.rparensExpected--, this.expectCharacter(z2), t;
              } else {
                if (this.next.isKeywordNull()) return this.advance(), new B(this.span(e), this.sourceSpan(e), null);
                if (this.next.isKeywordUndefined()) return this.advance(), new B(this.span(e), this.sourceSpan(e), void 0);
                if (this.next.isKeywordTrue()) return this.advance(), new B(this.span(e), this.sourceSpan(e), true);
                if (this.next.isKeywordFalse()) return this.advance(), new B(this.span(e), this.sourceSpan(e), false);
                if (this.next.isKeywordThis()) return this.advance(), new Ye(this.span(e), this.sourceSpan(e));
                if (this.consumeOptionalCharacter(Ae)) {
                  this.rbracketsExpected++;
                  let t = this.parseExpressionList(ne);
                  return this.rbracketsExpected--, this.expectCharacter(ne), new ge(this.span(e), this.sourceSpan(e), t);
                } else {
                  if (this.next.isCharacter(Be)) return this.parseLiteralMap();
                  if (this.next.isIdentifier()) return this.parseAccessMemberOrMethodCall(new Oe(this.span(e), this.sourceSpan(e)), e, false);
                  if (this.next.isNumber()) {
                    let t = this.next.toNumber();
                    return this.advance(), new B(this.span(e), this.sourceSpan(e), t);
                  } else if (this.next.isString()) {
                    let t = this.next.toString();
                    return this.advance(), new B(this.span(e), this.sourceSpan(e), t);
                  } else return this.next.isPrivateIdentifier() ? (this._reportErrorForPrivateIdentifier(this.next, null), new M(this.span(e), this.sourceSpan(e))) : this.index >= this.tokens.length ? (this.error("Unexpected end of expression: ".concat(this.input)), new M(this.span(e), this.sourceSpan(e))) : (this.error("Unexpected token ".concat(this.next)), new M(this.span(e), this.sourceSpan(e)));
                }
              }
            }
            parseExpressionList(e) {
              let t = [];
              do
                if (!this.next.isCharacter(e)) t.push(this.parsePipe());
                else break;
              while (this.consumeOptionalCharacter(ee));
              return t;
            }
            parseLiteralMap() {
              let e = [], t = [], n = this.inputIndex;
              if (this.expectCharacter(Be), !this.consumeOptionalCharacter(_e)) {
                this.rbracesExpected++;
                do {
                  let r = this.inputIndex, s = this.next.isString(), a = this.expectIdentifierOrKeywordOrString();
                  if (e.push({ key: a, quoted: s }), s) this.expectCharacter(X), t.push(this.parsePipe());
                  else if (this.consumeOptionalCharacter(X)) t.push(this.parsePipe());
                  else {
                    let i = this.span(r), l = this.sourceSpan(r);
                    t.push(new re(i, l, l, new Oe(i, l), a));
                  }
                } while (this.consumeOptionalCharacter(ee));
                this.rbracesExpected--, this.expectCharacter(_e);
              }
              return new ve(this.span(n), this.sourceSpan(n), e, t);
            }
            parseAccessMemberOrMethodCall(e, t, n) {
              let r = this.inputIndex, s = this.withContext(Z.Writable, () => {
                var i;
                let l = (i = this.expectIdentifierOrKeyword()) !== null && i !== void 0 ? i : "";
                return l.length === 0 && this.error("Expected identifier for property access", e.span.end), l;
              }), a = this.sourceSpan(r);
              if (this.consumeOptionalCharacter(Ee)) {
                let i = this.inputIndex;
                this.rparensExpected++;
                let l = this.parseCallArguments(), h = this.span(i, this.inputIndex).toAbsolute(this.absoluteOffset);
                this.expectCharacter(z2), this.rparensExpected--;
                let P = this.span(t), p = this.sourceSpan(t);
                return n ? new we(P, p, a, e, s, l, h) : new ye(P, p, a, e, s, l, h);
              } else {
                if (n) return this.consumeOptionalOperator("=") ? (this.error("The '?.' operator cannot be used in the assignment"), new M(this.span(t), this.sourceSpan(t))) : new he(this.span(t), this.sourceSpan(t), a, e, s);
                if (this.consumeOptionalOperator("=")) {
                  if (!this.parseAction) return this.error("Bindings cannot contain assignments"), new M(this.span(t), this.sourceSpan(t));
                  let i = this.parseConditional();
                  return new ue(this.span(t), this.sourceSpan(t), a, e, s, i);
                } else return new re(this.span(t), this.sourceSpan(t), a, e, s);
              }
            }
            parseCallArguments() {
              if (this.next.isCharacter(z2)) return [];
              let e = [];
              do
                e.push(this.parsePipe());
              while (this.consumeOptionalCharacter(ee));
              return e;
            }
            expectTemplateBindingKey() {
              let e = "", t = false, n = this.currentAbsoluteOffset;
              do
                e += this.expectIdentifierOrKeywordOrString(), t = this.consumeOptionalOperator("-"), t && (e += "-");
              while (t);
              return { source: e, span: new U(n, n + e.length) };
            }
            parseTemplateBindings(e) {
              let t = [];
              for (t.push(...this.parseDirectiveKeywordBindings(e)); this.index < this.tokens.length; ) {
                let n = this.parseLetBinding();
                if (n) t.push(n);
                else {
                  let r = this.expectTemplateBindingKey(), s = this.parseAsBinding(r);
                  s ? t.push(s) : (r.source = e.source + r.source.charAt(0).toUpperCase() + r.source.substring(1), t.push(...this.parseDirectiveKeywordBindings(r)));
                }
                this.consumeStatementTerminator();
              }
              return new Qe(t, [], this.errors);
            }
            parseKeyedReadOrWrite(e, t, n) {
              return this.withContext(Z.Writable, () => {
                this.rbracketsExpected++;
                let r = this.parsePipe();
                if (r instanceof M && this.error("Key access cannot be empty"), this.rbracketsExpected--, this.expectCharacter(ne), this.consumeOptionalOperator("=")) if (n) this.error("The '?.' operator cannot be used in the assignment");
                else {
                  let s = this.parseConditional();
                  return new de(this.span(t), this.sourceSpan(t), e, r, s);
                }
                else return n ? new pe(this.span(t), this.sourceSpan(t), e, r) : new le(this.span(t), this.sourceSpan(t), e, r);
                return new M(this.span(t), this.sourceSpan(t));
              });
            }
            parseDirectiveKeywordBindings(e) {
              let t = [];
              this.consumeOptionalCharacter(X);
              let n = this.getDirectiveBoundTarget(), r = this.currentAbsoluteOffset, s = this.parseAsBinding(e);
              s || (this.consumeStatementTerminator(), r = this.currentAbsoluteOffset);
              let a = new U(e.span.start, r);
              return t.push(new Ze(a, e, n)), s && t.push(s), t;
            }
            getDirectiveBoundTarget() {
              if (this.next === Ie || this.peekKeywordAs() || this.peekKeywordLet()) return null;
              let e = this.parsePipe(), { start: t, end: n } = e.span, r = this.input.substring(t, n);
              return new G(e, r, this.location, this.absoluteOffset + t, this.errors);
            }
            parseAsBinding(e) {
              if (!this.peekKeywordAs()) return null;
              this.advance();
              let t = this.expectTemplateBindingKey();
              this.consumeStatementTerminator();
              let n = new U(e.span.start, this.currentAbsoluteOffset);
              return new Re(n, t, e);
            }
            parseLetBinding() {
              if (!this.peekKeywordLet()) return null;
              let e = this.currentAbsoluteOffset;
              this.advance();
              let t = this.expectTemplateBindingKey(), n = null;
              this.consumeOptionalOperator("=") && (n = this.expectTemplateBindingKey()), this.consumeStatementTerminator();
              let r = new U(e, this.currentAbsoluteOffset);
              return new Re(r, t, n);
            }
            consumeStatementTerminator() {
              this.consumeOptionalCharacter(te) || this.consumeOptionalCharacter(ee);
            }
            error(e) {
              let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              this.errors.push(new ae(e, this.input, this.locationText(t), this.location)), this.skip();
            }
            locationText() {
              let e = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null;
              return e == null && (e = this.index), e < this.tokens.length ? "at column ".concat(this.tokens[e].index + 1, " in") : "at the end of the expression";
            }
            _reportErrorForPrivateIdentifier(e, t) {
              let n = "Private identifiers are not supported. Unexpected private identifier: ".concat(e);
              t !== null && (n += ", ".concat(t)), this.error(n);
            }
            skip() {
              let e = this.next;
              for (; this.index < this.tokens.length && !e.isCharacter(te) && !e.isOperator("|") && (this.rparensExpected <= 0 || !e.isCharacter(z2)) && (this.rbracesExpected <= 0 || !e.isCharacter(_e)) && (this.rbracketsExpected <= 0 || !e.isCharacter(ne)) && (!(this.context & Z.Writable) || !e.isOperator("=")); ) this.next.isError() && this.errors.push(new ae(this.next.toString(), this.input, this.locationText(), this.location)), this.advance(), e = this.next;
            }
          }, yt = class {
            constructor() {
              this.errors = [];
            }
            visitImplicitReceiver(e, t) {
            }
            visitThisReceiver(e, t) {
            }
            visitInterpolation(e, t) {
            }
            visitLiteralPrimitive(e, t) {
            }
            visitPropertyRead(e, t) {
            }
            visitPropertyWrite(e, t) {
            }
            visitSafePropertyRead(e, t) {
            }
            visitMethodCall(e, t) {
            }
            visitSafeMethodCall(e, t) {
            }
            visitFunctionCall(e, t) {
            }
            visitLiteralArray(e, t) {
              this.visitAll(e.expressions, t);
            }
            visitLiteralMap(e, t) {
              this.visitAll(e.values, t);
            }
            visitUnary(e, t) {
            }
            visitBinary(e, t) {
            }
            visitPrefixNot(e, t) {
            }
            visitNonNullAssert(e, t) {
            }
            visitConditional(e, t) {
            }
            visitPipe(e, t) {
              this.errors.push("pipes");
            }
            visitKeyedRead(e, t) {
            }
            visitKeyedWrite(e, t) {
            }
            visitAll(e, t) {
              return e.map((n) => n.visit(this, t));
            }
            visitChain(e, t) {
            }
            visitQuote(e, t) {
            }
            visitSafeKeyedRead(e, t) {
            }
          }, wt = class extends et {
            constructor() {
              super(...arguments), this.errors = [];
            }
            visitPipe() {
              this.errors.push("pipes");
            }
          };
        } }), ft = q({ "node_modules/angular-estree-parser/lib/utils.js"(e) {
          "use strict";
          L(), Object.defineProperty(e, "__esModule", { value: true }), e.getLast = e.toLowerCamelCase = e.findBackChar = e.findFrontChar = e.fitSpans = e.getNgType = e.parseNgInterpolation = e.parseNgTemplateBindings = e.parseNgAction = e.parseNgSimpleBinding = e.parseNgBinding = e.NG_PARSE_TEMPLATE_BINDINGS_FAKE_PREFIX = void 0;
          var t = (tt(), be(Je)), n = (tn(), be(Yt)), r = (Ln(), be(rn)), s = "angular-estree-parser";
          e.NG_PARSE_TEMPLATE_BINDINGS_FAKE_PREFIX = "NgEstreeParser";
          var a = 0, i = [s, a];
          function l() {
            return new r.Parser(new n.Lexer());
          }
          function h(o, d) {
            let y = l(), { astInput: C, comments: E } = T(o, y), { ast: I, errors: j } = d(C, y);
            return R(j), { ast: I, comments: E };
          }
          function P(o) {
            return h(o, (d, y) => y.parseBinding(d, ...i));
          }
          e.parseNgBinding = P;
          function p(o) {
            return h(o, (d, y) => y.parseSimpleBinding(d, ...i));
          }
          e.parseNgSimpleBinding = p;
          function x(o) {
            return h(o, (d, y) => y.parseAction(d, ...i));
          }
          e.parseNgAction = x;
          function A(o) {
            let d = l(), { templateBindings: y, errors: C } = d.parseTemplateBindings(e.NG_PARSE_TEMPLATE_BINDINGS_FAKE_PREFIX, o, s, a, a);
            return R(C), y;
          }
          e.parseNgTemplateBindings = A;
          function b(o) {
            let d = l(), { astInput: y, comments: C } = T(o, d), E = "{{", I = "}}", { ast: j, errors: cn } = d.parseInterpolation(E + y + I, ...i);
            R(cn);
            let gt = j.expressions[0], vt = /* @__PURE__ */ new Set();
            return _(gt, (ke) => {
              vt.has(ke) || (ke.start -= E.length, ke.end -= E.length, vt.add(ke));
            }), { ast: gt, comments: C };
          }
          e.parseNgInterpolation = b;
          function _(o, d) {
            if (!(!o || typeof o != "object")) {
              if (Array.isArray(o)) return o.forEach((y) => _(y, d));
              for (let y of Object.keys(o)) {
                let C = o[y];
                y === "span" ? d(C) : _(C, d);
              }
            }
          }
          function R(o) {
            if (o.length !== 0) {
              let [{ message: d }] = o;
              throw new SyntaxError(d.replace(/^Parser Error: | at column \d+ in [^]*$/g, ""));
            }
          }
          function T(o, d) {
            let y = d._commentStart(o);
            return y === null ? { astInput: o, comments: [] } : { astInput: o.slice(0, y), comments: [{ type: "Comment", value: o.slice(y + 2), span: { start: y, end: o.length } }] };
          }
          function O(o) {
            return t.Unary && o instanceof t.Unary ? "Unary" : o instanceof t.Binary ? "Binary" : o instanceof t.BindingPipe ? "BindingPipe" : o instanceof t.Chain ? "Chain" : o instanceof t.Conditional ? "Conditional" : o instanceof t.EmptyExpr ? "EmptyExpr" : o instanceof t.FunctionCall ? "FunctionCall" : o instanceof t.ImplicitReceiver ? "ImplicitReceiver" : o instanceof t.KeyedRead ? "KeyedRead" : o instanceof t.KeyedWrite ? "KeyedWrite" : o instanceof t.LiteralArray ? "LiteralArray" : o instanceof t.LiteralMap ? "LiteralMap" : o instanceof t.LiteralPrimitive ? "LiteralPrimitive" : o instanceof t.MethodCall ? "MethodCall" : o instanceof t.NonNullAssert ? "NonNullAssert" : o instanceof t.PrefixNot ? "PrefixNot" : o instanceof t.PropertyRead ? "PropertyRead" : o instanceof t.PropertyWrite ? "PropertyWrite" : o instanceof t.Quote ? "Quote" : o instanceof t.SafeMethodCall ? "SafeMethodCall" : o instanceof t.SafePropertyRead ? "SafePropertyRead" : o.type;
          }
          e.getNgType = O;
          function N(o, d) {
            let { start: y, end: C } = o, E = y, I = C;
            for (; I !== E && /\s/.test(d[I - 1]); ) I--;
            for (; E !== I && /\s/.test(d[E]); ) E++;
            return { start: E, end: I };
          }
          function c(o, d) {
            let { start: y, end: C } = o, E = y, I = C;
            for (; I !== d.length && /\s/.test(d[I]); ) I++;
            for (; E !== 0 && /\s/.test(d[E - 1]); ) E--;
            return { start: E, end: I };
          }
          function g(o, d) {
            return d[o.start - 1] === "(" && d[o.end] === ")" ? { start: o.start - 1, end: o.end + 1 } : o;
          }
          function u(o, d, y) {
            let C = 0, E = { start: o.start, end: o.end };
            for (; ; ) {
              let I = c(E, d), j = g(I, d);
              if (I.start === j.start && I.end === j.end) break;
              E.start = j.start, E.end = j.end, C++;
            }
            return { hasParens: (y ? C - 1 : C) !== 0, outerSpan: N(y ? { start: E.start + 1, end: E.end - 1 } : E, d), innerSpan: N(o, d) };
          }
          e.fitSpans = u;
          function v(o, d, y) {
            let C = d;
            for (; !o.test(y[C]); ) if (--C < 0) throw new Error("Cannot find front char ".concat(o, " from index ").concat(d, " in ").concat(JSON.stringify(y)));
            return C;
          }
          e.findFrontChar = v;
          function m(o, d, y) {
            let C = d;
            for (; !o.test(y[C]); ) if (++C >= y.length) throw new Error("Cannot find back char ".concat(o, " from index ").concat(d, " in ").concat(JSON.stringify(y)));
            return C;
          }
          e.findBackChar = m;
          function f(o) {
            return o.slice(0, 1).toLowerCase() + o.slice(1);
          }
          e.toLowerCamelCase = f;
          function w(o) {
            return o.length === 0 ? void 0 : o[o.length - 1];
          }
          e.getLast = w;
        } }), an = q({ "node_modules/angular-estree-parser/lib/transform.js"(e) {
          "use strict";
          L(), Object.defineProperty(e, "__esModule", { value: true }), e.transformSpan = e.transform = void 0;
          var t = ft(), n = function(s, a) {
            let i = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, l = t.getNgType(s);
            switch (l) {
              case "Unary": {
                let { operator: c, expr: g } = s, u = h(g);
                return p("UnaryExpression", { prefix: true, argument: u, operator: c }, s.span, { hasParentParens: i });
              }
              case "Binary": {
                let { left: c, operation: g, right: u } = s, v = u.span.start === u.span.end, m = c.span.start === c.span.end;
                if (v || m) {
                  let o = c.span.start === c.span.end ? h(u) : h(c);
                  return p("UnaryExpression", { prefix: true, argument: o, operator: v ? "+" : "-" }, { start: s.span.start, end: N(o) }, { hasParentParens: i });
                }
                let f = h(c), w = h(u);
                return p(g === "&&" || g === "||" ? "LogicalExpression" : "BinaryExpression", { left: f, right: w, operator: g }, { start: O(f), end: N(w) }, { hasParentParens: i });
              }
              case "BindingPipe": {
                let { exp: c, name: g, args: u } = s, v = h(c), m = b(/\S/, b(/\|/, N(v)) + 1), f = p("Identifier", { name: g }, { start: m, end: m + g.length }), w = u.map(h);
                return p("NGPipeExpression", { left: v, right: f, arguments: w }, { start: O(v), end: N(w.length === 0 ? f : t.getLast(w)) }, { hasParentParens: i });
              }
              case "Chain": {
                let { expressions: c } = s;
                return p("NGChainedExpression", { expressions: c.map(h) }, s.span, { hasParentParens: i });
              }
              case "Comment": {
                let { value: c } = s;
                return p("CommentLine", { value: c }, s.span, { processSpan: false });
              }
              case "Conditional": {
                let { condition: c, trueExp: g, falseExp: u } = s, v = h(c), m = h(g), f = h(u);
                return p("ConditionalExpression", { test: v, consequent: m, alternate: f }, { start: O(v), end: N(f) }, { hasParentParens: i });
              }
              case "EmptyExpr":
                return p("NGEmptyExpression", {}, s.span, { hasParentParens: i });
              case "FunctionCall": {
                let { target: c, args: g } = s, u = g.length === 1 ? [P(g[0])] : g.map(h), v = h(c);
                return p("CallExpression", { callee: v, arguments: u }, { start: O(v), end: s.span.end }, { hasParentParens: i });
              }
              case "ImplicitReceiver":
                return p("ThisExpression", {}, s.span, { hasParentParens: i });
              case "KeyedRead": {
                let { key: c } = s, g = Object.prototype.hasOwnProperty.call(s, "receiver") ? s.receiver : s.obj, u = h(c);
                return x(g, u, { computed: true, optional: false }, { end: s.span.end, hasParentParens: i });
              }
              case "LiteralArray": {
                let { expressions: c } = s;
                return p("ArrayExpression", { elements: c.map(h) }, s.span, { hasParentParens: i });
              }
              case "LiteralMap": {
                let { keys: c, values: g } = s, u = g.map((m) => h(m)), v = c.map((m, f) => {
                  let { key: w, quoted: o } = m, d = u[f], y = b(/\S/, f === 0 ? s.span.start + 1 : b(/,/, N(u[f - 1])) + 1), C = A(/\S/, A(/:/, O(d) - 1) - 1) + 1, E = { start: y, end: C }, I = o ? p("StringLiteral", { value: w }, E) : p("Identifier", { name: w }, E), j = I.end < I.start;
                  return p("ObjectProperty", { key: I, value: d, method: false, shorthand: j, computed: false }, { start: O(I), end: N(d) });
                });
                return p("ObjectExpression", { properties: v }, s.span, { hasParentParens: i });
              }
              case "LiteralPrimitive": {
                let { value: c } = s;
                switch (typeof c) {
                  case "boolean":
                    return p("BooleanLiteral", { value: c }, s.span, { hasParentParens: i });
                  case "number":
                    return p("NumericLiteral", { value: c }, s.span, { hasParentParens: i });
                  case "object":
                    return p("NullLiteral", {}, s.span, { hasParentParens: i });
                  case "string":
                    return p("StringLiteral", { value: c }, s.span, { hasParentParens: i });
                  case "undefined":
                    return p("Identifier", { name: "undefined" }, s.span, { hasParentParens: i });
                  default:
                    throw new Error("Unexpected LiteralPrimitive value type ".concat(typeof c));
                }
              }
              case "MethodCall":
              case "SafeMethodCall": {
                let c = l === "SafeMethodCall", { receiver: g, name: u, args: v } = s, m = v.length === 1 ? [P(v[0])] : v.map(h), f = A(/\S/, A(/\(/, (m.length === 0 ? A(/\)/, s.span.end - 1) : O(m[0])) - 1) - 1) + 1, w = p("Identifier", { name: u }, { start: f - u.length, end: f }), o = x(g, w, { computed: false, optional: c }), d = R(o);
                return p(c || d ? "OptionalCallExpression" : "CallExpression", { callee: o, arguments: m }, { start: O(o), end: s.span.end }, { hasParentParens: i });
              }
              case "NonNullAssert": {
                let { expression: c } = s, g = h(c);
                return p("TSNonNullExpression", { expression: g }, { start: O(g), end: s.span.end }, { hasParentParens: i });
              }
              case "PrefixNot": {
                let { expression: c } = s, g = h(c);
                return p("UnaryExpression", { prefix: true, operator: "!", argument: g }, { start: s.span.start, end: N(g) }, { hasParentParens: i });
              }
              case "PropertyRead":
              case "SafePropertyRead": {
                let c = l === "SafePropertyRead", { receiver: g, name: u } = s, v = A(/\S/, s.span.end - 1) + 1, m = p("Identifier", { name: u }, { start: v - u.length, end: v }, _(g) ? { hasParentParens: i } : {});
                return x(g, m, { computed: false, optional: c }, { hasParentParens: i });
              }
              case "KeyedWrite": {
                let { key: c, value: g } = s, u = Object.prototype.hasOwnProperty.call(s, "receiver") ? s.receiver : s.obj, v = h(c), m = h(g), f = x(u, v, { computed: true, optional: false }, { end: b(/\]/, N(v)) + 1 });
                return p("AssignmentExpression", { left: f, operator: "=", right: m }, { start: O(f), end: N(m) }, { hasParentParens: i });
              }
              case "PropertyWrite": {
                let { receiver: c, name: g, value: u } = s, v = h(u), m = A(/\S/, A(/=/, O(v) - 1) - 1) + 1, f = p("Identifier", { name: g }, { start: m - g.length, end: m }), w = x(c, f, { computed: false, optional: false });
                return p("AssignmentExpression", { left: w, operator: "=", right: v }, { start: O(w), end: N(v) }, { hasParentParens: i });
              }
              case "Quote": {
                let { prefix: c, uninterpretedExpression: g } = s;
                return p("NGQuotedExpression", { prefix: c, value: g }, s.span, { hasParentParens: i });
              }
              default:
                throw new Error("Unexpected node ".concat(l));
            }
            function h(c) {
              return e.transform(c, a);
            }
            function P(c) {
              return e.transform(c, a, true);
            }
            function p(c, g, u) {
              let { processSpan: v = true, hasParentParens: m = false } = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : {}, f = Object.assign(Object.assign({ type: c }, r(u, a, v, m)), g);
              switch (c) {
                case "Identifier": {
                  let w = f;
                  w.loc.identifierName = w.name;
                  break;
                }
                case "NumericLiteral": {
                  let w = f;
                  w.extra = Object.assign(Object.assign({}, w.extra), { raw: a.text.slice(w.start, w.end), rawValue: w.value });
                  break;
                }
                case "StringLiteral": {
                  let w = f;
                  w.extra = Object.assign(Object.assign({}, w.extra), { raw: a.text.slice(w.start, w.end), rawValue: w.value });
                  break;
                }
              }
              return f;
            }
            function x(c, g, u) {
              let { end: v = N(g), hasParentParens: m = false } = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : {};
              if (_(c) || c.span.start === g.start) return g;
              let f = h(c), w = R(f);
              return p(u.optional || w ? "OptionalMemberExpression" : "MemberExpression", Object.assign({ object: f, property: g, computed: u.computed }, u.optional ? { optional: true } : w ? { optional: false } : null), { start: O(f), end: v }, { hasParentParens: m });
            }
            function A(c, g) {
              return t.findFrontChar(c, g, a.text);
            }
            function b(c, g) {
              return t.findBackChar(c, g, a.text);
            }
            function _(c) {
              return c.span.start >= c.span.end || /^\s+$/.test(a.text.slice(c.span.start, c.span.end));
            }
            function R(c) {
              return (c.type === "OptionalCallExpression" || c.type === "OptionalMemberExpression") && !T(c);
            }
            function T(c) {
              return c.extra && c.extra.parenthesized;
            }
            function O(c) {
              return T(c) ? c.extra.parenStart : c.start;
            }
            function N(c) {
              return T(c) ? c.extra.parenEnd : c.end;
            }
          };
          e.transform = n;
          function r(s, a) {
            let i = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, l = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
            if (!i) {
              let { start: x, end: A } = s;
              return { start: x, end: A, loc: { start: a.locator.locationForIndex(x), end: a.locator.locationForIndex(A) } };
            }
            let { outerSpan: h, innerSpan: P, hasParens: p } = t.fitSpans(s, a.text, l);
            return Object.assign({ start: P.start, end: P.end, loc: { start: a.locator.locationForIndex(P.start), end: a.locator.locationForIndex(P.end) } }, p && { extra: { parenthesized: true, parenStart: h.start, parenEnd: h.end } });
          }
          e.transformSpan = r;
        } }), Rn = q({ "node_modules/angular-estree-parser/lib/transform-microsyntax.js"(e) {
          "use strict";
          L(), Object.defineProperty(e, "__esModule", { value: true }), e.transformTemplateBindings = void 0;
          var t = (tt(), be(Je)), n = an(), r = ft();
          function s(a, i) {
            a.forEach(N);
            let [l] = a, { key: h } = l, P = i.text.slice(l.sourceSpan.start, l.sourceSpan.end).trim().length === 0 ? a.slice(1) : a, p = [], x = null;
            for (let u = 0; u < P.length; u++) {
              let v = P[u];
              if (x && T(x) && O(v) && v.value && v.value.source === x.key.source) {
                let m = _("NGMicrosyntaxKey", { name: v.key.source }, v.key.span), f = (d, y) => Object.assign(Object.assign({}, d), n.transformSpan({ start: d.start, end: y }, i)), w = (d) => Object.assign(Object.assign({}, f(d, m.end)), { alias: m }), o = p.pop();
                if (o.type === "NGMicrosyntaxExpression") p.push(w(o));
                else if (o.type === "NGMicrosyntaxKeyedExpression") {
                  let d = w(o.expression);
                  p.push(f(Object.assign(Object.assign({}, o), { expression: d }), d.end));
                } else throw new Error("Unexpected type ".concat(o.type));
              } else p.push(A(v, u));
              x = v;
            }
            return _("NGMicrosyntax", { body: p }, p.length === 0 ? a[0].sourceSpan : { start: p[0].start, end: p[p.length - 1].end });
            function A(u, v) {
              if (T(u)) {
                let { key: m, value: f } = u;
                return f ? v === 0 ? _("NGMicrosyntaxExpression", { expression: b(f.ast), alias: null }, f.sourceSpan) : _("NGMicrosyntaxKeyedExpression", { key: _("NGMicrosyntaxKey", { name: R(m.source) }, m.span), expression: _("NGMicrosyntaxExpression", { expression: b(f.ast), alias: null }, f.sourceSpan) }, { start: m.span.start, end: f.sourceSpan.end }) : _("NGMicrosyntaxKey", { name: R(m.source) }, m.span);
              } else {
                let { key: m, sourceSpan: f } = u;
                if (/^let\s$/.test(i.text.slice(f.start, f.start + 4))) {
                  let { value: o } = u;
                  return _("NGMicrosyntaxLet", { key: _("NGMicrosyntaxKey", { name: m.source }, m.span), value: o ? _("NGMicrosyntaxKey", { name: o.source }, o.span) : null }, { start: f.start, end: o ? o.span.end : m.span.end });
                } else {
                  let o = g(u);
                  return _("NGMicrosyntaxAs", { key: _("NGMicrosyntaxKey", { name: o.source }, o.span), alias: _("NGMicrosyntaxKey", { name: m.source }, m.span) }, { start: o.span.start, end: m.span.end });
                }
              }
            }
            function b(u) {
              return n.transform(u, i);
            }
            function _(u, v, m) {
              let f = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true;
              return Object.assign(Object.assign({ type: u }, n.transformSpan(m, i, f)), v);
            }
            function R(u) {
              return r.toLowerCamelCase(u.slice(h.source.length));
            }
            function T(u) {
              return u instanceof t.ExpressionBinding;
            }
            function O(u) {
              return u instanceof t.VariableBinding;
            }
            function N(u) {
              c(u.key.span), O(u) && u.value && c(u.value.span);
            }
            function c(u) {
              if (i.text[u.start] !== '"' && i.text[u.start] !== "'") return;
              let v = i.text[u.start], m = false;
              for (let f = u.start + 1; f < i.text.length; f++) switch (i.text[f]) {
                case v:
                  if (!m) {
                    u.end = f + 1;
                    return;
                  }
                default:
                  m = false;
                  break;
                case "\\":
                  m = !m;
                  break;
              }
            }
            function g(u) {
              if (!u.value || u.value.source !== r.NG_PARSE_TEMPLATE_BINDINGS_FAKE_PREFIX) return u.value;
              let v = r.findBackChar(/\S/, u.sourceSpan.start, i.text);
              return { source: "$implicit", span: { start: v, end: v } };
            }
          }
          e.transformTemplateBindings = s;
        } }), Tn = q({ "node_modules/angular-estree-parser/lib/index.js"(e) {
          "use strict";
          L(), Object.defineProperty(e, "__esModule", { value: true }), e.parseTemplateBindings = e.parseAction = e.parseInterpolation = e.parseSimpleBinding = e.parseBinding = void 0;
          var t = vn(), n = an(), r = Rn(), s = ft();
          function a(x, A) {
            let { ast: b, comments: _ } = A(x), R = new t.Context(x), T = (N) => n.transform(N, R), O = T(b);
            return O.comments = _.map(T), O;
          }
          function i(x) {
            return a(x, s.parseNgBinding);
          }
          e.parseBinding = i;
          function l(x) {
            return a(x, s.parseNgSimpleBinding);
          }
          e.parseSimpleBinding = l;
          function h(x) {
            return a(x, s.parseNgInterpolation);
          }
          e.parseInterpolation = h;
          function P(x) {
            return a(x, s.parseNgAction);
          }
          e.parseAction = P;
          function p(x) {
            return r.transformTemplateBindings(s.parseNgTemplateBindings(x), new t.Context(x));
          }
          e.parseTemplateBindings = p;
        } });
        L();
        var { locStart: Bn, locEnd: Kn } = fn();
        function Ne(e) {
          return { astFormat: "estree", parse: (n, r, s) => {
            let a = Tn(), i = e(n, a);
            return { type: "NGRoot", node: s.parser === "__ng_action" && i.type !== "NGChainedExpression" ? Object.assign(Object.assign({}, i), {}, { type: "NGChainedExpression", expressions: [i] }) : i };
          }, locStart: Bn, locEnd: Kn };
        }
        on.exports = { parsers: { __ng_action: Ne((e, t) => t.parseAction(e)), __ng_binding: Ne((e, t) => t.parseBinding(e)), __ng_interpolation: Ne((e, t) => t.parseInterpolation(e)), __ng_directive: Ne((e, t) => t.parseTemplateBindings(e)) } };
      });
      return Mn();
    });
  }
});

// ../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-espree.js
var require_parser_espree = __commonJS({
  "../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-espree.js"(exports2, module2) {
    "use strict";
    (function(e) {
      if (typeof exports2 == "object" && typeof module2 == "object") module2.exports = e();
      else if (typeof define == "function" && define.amd) define(e);
      else {
        var i = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i.prettierPlugins = i.prettierPlugins || {}, i.prettierPlugins.espree = e();
      }
    })(function() {
      "use strict";
      var S = (n, o) => () => (o || n((o = { exports: {} }).exports, o), o.exports);
      var $ = S((Dh, qr) => {
        var Ze = function(n) {
          return n && n.Math == Math && n;
        };
        qr.exports = Ze(typeof globalThis == "object" && globalThis) || Ze(typeof window == "object" && window) || Ze(typeof self == "object" && self) || Ze(typeof global == "object" && global) || /* @__PURE__ */ function() {
          return this;
        }() || Function("return this")();
      });
      var ye = S((Oh, Mr) => {
        Mr.exports = function(n) {
          try {
            return !!n();
          } catch {
            return true;
          }
        };
      });
      var _e = S((Lh, Ur) => {
        var tn = ye();
        Ur.exports = !tn(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      });
      var Ct = S((Vh, zr) => {
        var rn = ye();
        zr.exports = !rn(function() {
          var n = function() {
          }.bind();
          return typeof n != "function" || n.hasOwnProperty("prototype");
        });
      });
      var et = S((Rh, Wr) => {
        var sn = Ct(), $e = Function.prototype.call;
        Wr.exports = sn ? $e.bind($e) : function() {
          return $e.apply($e, arguments);
        };
      });
      var Hr = S((Xr) => {
        "use strict";
        var Gr = {}.propertyIsEnumerable, Kr = Object.getOwnPropertyDescriptor, an = Kr && !Gr.call({ 1: 2 }, 1);
        Xr.f = an ? function(o) {
          var u = Kr(this, o);
          return !!u && u.enumerable;
        } : Gr;
      });
      var Et = S((qh, Jr) => {
        Jr.exports = function(n, o) {
          return { enumerable: !(n & 1), configurable: !(n & 2), writable: !(n & 4), value: o };
        };
      });
      var ce = S((Mh, Zr) => {
        var Yr = Ct(), Qr = Function.prototype, nn = Qr.bind, bt = Qr.call, on = Yr && nn.bind(bt, bt);
        Zr.exports = Yr ? function(n) {
          return n && on(n);
        } : function(n) {
          return n && function() {
            return bt.apply(n, arguments);
          };
        };
      });
      var ti = S((Uh, ei) => {
        var $r = ce(), un = $r({}.toString), hn = $r("".slice);
        ei.exports = function(n) {
          return hn(un(n), 8, -1);
        };
      });
      var ii = S((zh, ri) => {
        var ln = $(), cn = ce(), pn = ye(), fn = ti(), _t = ln.Object, dn = cn("".split);
        ri.exports = pn(function() {
          return !_t("z").propertyIsEnumerable(0);
        }) ? function(n) {
          return fn(n) == "String" ? dn(n, "") : _t(n);
        } : _t;
      });
      var St = S((Wh, si) => {
        var mn = $(), vn = mn.TypeError;
        si.exports = function(n) {
          if (n == null) throw vn("Can't call method on " + n);
          return n;
        };
      });
      var tt = S((Gh, ai) => {
        var gn = ii(), xn = St();
        ai.exports = function(n) {
          return gn(xn(n));
        };
      });
      var pe = S((Kh, ni) => {
        ni.exports = function(n) {
          return typeof n == "function";
        };
      });
      var Ie = S((Xh, oi) => {
        var yn = pe();
        oi.exports = function(n) {
          return typeof n == "object" ? n !== null : yn(n);
        };
      });
      var rt = S((Hh, ui) => {
        var wt = $(), An = pe(), Cn = function(n) {
          return An(n) ? n : void 0;
        };
        ui.exports = function(n, o) {
          return arguments.length < 2 ? Cn(wt[n]) : wt[n] && wt[n][o];
        };
      });
      var li = S((Jh, hi) => {
        var En = ce();
        hi.exports = En({}.isPrototypeOf);
      });
      var pi = S((Yh, ci) => {
        var bn = rt();
        ci.exports = bn("navigator", "userAgent") || "";
      });
      var yi = S((Qh, xi) => {
        var gi = $(), kt = pi(), fi = gi.process, di = gi.Deno, mi = fi && fi.versions || di && di.version, vi = mi && mi.v8, he, it;
        vi && (he = vi.split("."), it = he[0] > 0 && he[0] < 4 ? 1 : +(he[0] + he[1]));
        !it && kt && (he = kt.match(/Edge\/(\d+)/), (!he || he[1] >= 74) && (he = kt.match(/Chrome\/(\d+)/), he && (it = +he[1])));
        xi.exports = it;
      });
      var Ft = S((Zh, Ci) => {
        var Ai = yi(), _n = ye();
        Ci.exports = !!Object.getOwnPropertySymbols && !_n(function() {
          var n = Symbol();
          return !String(n) || !(Object(n) instanceof Symbol) || !Symbol.sham && Ai && Ai < 41;
        });
      });
      var Bt = S(($h, Ei) => {
        var Sn = Ft();
        Ei.exports = Sn && !Symbol.sham && typeof Symbol.iterator == "symbol";
      });
      var Tt = S((el, bi) => {
        var wn = $(), kn = rt(), Fn = pe(), Bn = li(), Tn = Bt(), In = wn.Object;
        bi.exports = Tn ? function(n) {
          return typeof n == "symbol";
        } : function(n) {
          var o = kn("Symbol");
          return Fn(o) && Bn(o.prototype, In(n));
        };
      });
      var Si = S((tl, _i) => {
        var Pn = $(), Nn = Pn.String;
        _i.exports = function(n) {
          try {
            return Nn(n);
          } catch {
            return "Object";
          }
        };
      });
      var ki = S((rl, wi) => {
        var Dn = $(), On = pe(), Ln = Si(), Vn = Dn.TypeError;
        wi.exports = function(n) {
          if (On(n)) return n;
          throw Vn(Ln(n) + " is not a function");
        };
      });
      var Bi = S((il, Fi) => {
        var Rn = ki();
        Fi.exports = function(n, o) {
          var u = n[o];
          return u == null ? void 0 : Rn(u);
        };
      });
      var Ii = S((sl, Ti) => {
        var jn = $(), It = et(), Pt = pe(), Nt = Ie(), qn = jn.TypeError;
        Ti.exports = function(n, o) {
          var u, l;
          if (o === "string" && Pt(u = n.toString) && !Nt(l = It(u, n)) || Pt(u = n.valueOf) && !Nt(l = It(u, n)) || o !== "string" && Pt(u = n.toString) && !Nt(l = It(u, n))) return l;
          throw qn("Can't convert object to primitive value");
        };
      });
      var Ni = S((al, Pi) => {
        Pi.exports = false;
      });
      var st = S((nl, Oi) => {
        var Di = $(), Mn = Object.defineProperty;
        Oi.exports = function(n, o) {
          try {
            Mn(Di, n, { value: o, configurable: true, writable: true });
          } catch {
            Di[n] = o;
          }
          return o;
        };
      });
      var at = S((ol, Vi) => {
        var Un = $(), zn = st(), Li = "__core-js_shared__", Wn = Un[Li] || zn(Li, {});
        Vi.exports = Wn;
      });
      var Dt = S((ul, ji) => {
        var Gn = Ni(), Ri = at();
        (ji.exports = function(n, o) {
          return Ri[n] || (Ri[n] = o !== void 0 ? o : {});
        })("versions", []).push({ version: "3.22.2", mode: Gn ? "pure" : "global", copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)", license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE", source: "https://github.com/zloirock/core-js" });
      });
      var Mi = S((hl, qi) => {
        var Kn = $(), Xn = St(), Hn = Kn.Object;
        qi.exports = function(n) {
          return Hn(Xn(n));
        };
      });
      var Ae = S((ll, Ui) => {
        var Jn = ce(), Yn = Mi(), Qn = Jn({}.hasOwnProperty);
        Ui.exports = Object.hasOwn || function(o, u) {
          return Qn(Yn(o), u);
        };
      });
      var Ot = S((cl, zi) => {
        var Zn = ce(), $n = 0, eo = Math.random(), to = Zn(1 .toString);
        zi.exports = function(n) {
          return "Symbol(" + (n === void 0 ? "" : n) + ")_" + to(++$n + eo, 36);
        };
      });
      var Ji = S((pl, Hi) => {
        var ro = $(), io = Dt(), Wi = Ae(), so = Ot(), Gi = Ft(), Xi = Bt(), Pe = io("wks"), Se = ro.Symbol, Ki = Se && Se.for, ao = Xi ? Se : Se && Se.withoutSetter || so;
        Hi.exports = function(n) {
          if (!Wi(Pe, n) || !(Gi || typeof Pe[n] == "string")) {
            var o = "Symbol." + n;
            Gi && Wi(Se, n) ? Pe[n] = Se[n] : Xi && Ki ? Pe[n] = Ki(o) : Pe[n] = ao(o);
          }
          return Pe[n];
        };
      });
      var $i = S((fl, Zi) => {
        var no = $(), oo = et(), Yi = Ie(), Qi = Tt(), uo = Bi(), ho = Ii(), lo = Ji(), co = no.TypeError, po = lo("toPrimitive");
        Zi.exports = function(n, o) {
          if (!Yi(n) || Qi(n)) return n;
          var u = uo(n, po), l;
          if (u) {
            if (o === void 0 && (o = "default"), l = oo(u, n, o), !Yi(l) || Qi(l)) return l;
            throw co("Can't convert object to primitive value");
          }
          return o === void 0 && (o = "number"), ho(n, o);
        };
      });
      var Lt = S((dl, es) => {
        var fo = $i(), mo = Tt();
        es.exports = function(n) {
          var o = fo(n, "string");
          return mo(o) ? o : o + "";
        };
      });
      var is = S((ml, rs) => {
        var vo = $(), ts = Ie(), Vt = vo.document, go = ts(Vt) && ts(Vt.createElement);
        rs.exports = function(n) {
          return go ? Vt.createElement(n) : {};
        };
      });
      var Rt = S((vl, ss) => {
        var xo = _e(), yo = ye(), Ao = is();
        ss.exports = !xo && !yo(function() {
          return Object.defineProperty(Ao("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      });
      var jt = S((ns) => {
        var Co = _e(), Eo = et(), bo = Hr(), _o = Et(), So = tt(), wo = Lt(), ko = Ae(), Fo = Rt(), as = Object.getOwnPropertyDescriptor;
        ns.f = Co ? as : function(o, u) {
          if (o = So(o), u = wo(u), Fo) try {
            return as(o, u);
          } catch {
          }
          if (ko(o, u)) return _o(!Eo(bo.f, o, u), o[u]);
        };
      });
      var us = S((xl, os) => {
        var Bo = _e(), To = ye();
        os.exports = Bo && To(function() {
          return Object.defineProperty(function() {
          }, "prototype", { value: 42, writable: false }).prototype != 42;
        });
      });
      var qt = S((yl, ls) => {
        var hs = $(), Io = Ie(), Po = hs.String, No = hs.TypeError;
        ls.exports = function(n) {
          if (Io(n)) return n;
          throw No(Po(n) + " is not an object");
        };
      });
      var Gt = S((ps) => {
        var Do = $(), Oo = _e(), Lo = Rt(), Vo = us(), nt = qt(), cs = Lt(), Ro = Do.TypeError, Mt = Object.defineProperty, jo = Object.getOwnPropertyDescriptor, Ut = "enumerable", zt = "configurable", Wt = "writable";
        ps.f = Oo ? Vo ? function(o, u, l) {
          if (nt(o), u = cs(u), nt(l), typeof o == "function" && u === "prototype" && "value" in l && Wt in l && !l[Wt]) {
            var m = jo(o, u);
            m && m[Wt] && (o[u] = l.value, l = { configurable: zt in l ? l[zt] : m[zt], enumerable: Ut in l ? l[Ut] : m[Ut], writable: false });
          }
          return Mt(o, u, l);
        } : Mt : function(o, u, l) {
          if (nt(o), u = cs(u), nt(l), Lo) try {
            return Mt(o, u, l);
          } catch {
          }
          if ("get" in l || "set" in l) throw Ro("Accessors not supported");
          return "value" in l && (o[u] = l.value), o;
        };
      });
      var ot = S((Cl, fs) => {
        var qo = _e(), Mo = Gt(), Uo = Et();
        fs.exports = qo ? function(n, o, u) {
          return Mo.f(n, o, Uo(1, u));
        } : function(n, o, u) {
          return n[o] = u, n;
        };
      });
      var Xt = S((El, ds) => {
        var zo = ce(), Wo = pe(), Kt = at(), Go = zo(Function.toString);
        Wo(Kt.inspectSource) || (Kt.inspectSource = function(n) {
          return Go(n);
        });
        ds.exports = Kt.inspectSource;
      });
      var gs = S((bl, vs) => {
        var Ko = $(), Xo = pe(), Ho = Xt(), ms = Ko.WeakMap;
        vs.exports = Xo(ms) && /native code/.test(Ho(ms));
      });
      var As = S((_l, ys) => {
        var Jo = Dt(), Yo = Ot(), xs = Jo("keys");
        ys.exports = function(n) {
          return xs[n] || (xs[n] = Yo(n));
        };
      });
      var Ht = S((Sl, Cs) => {
        Cs.exports = {};
      });
      var ks = S((wl, ws) => {
        var Qo = gs(), Ss = $(), Jt = ce(), Zo = Ie(), $o = ot(), Yt = Ae(), Qt = at(), eu = As(), tu = Ht(), Es = "Object already initialized", $t = Ss.TypeError, ru = Ss.WeakMap, ut, qe, ht, iu = function(n) {
          return ht(n) ? qe(n) : ut(n, {});
        }, su = function(n) {
          return function(o) {
            var u;
            if (!Zo(o) || (u = qe(o)).type !== n) throw $t("Incompatible receiver, " + n + " required");
            return u;
          };
        };
        Qo || Qt.state ? (Ce = Qt.state || (Qt.state = new ru()), bs = Jt(Ce.get), Zt = Jt(Ce.has), _s = Jt(Ce.set), ut = function(n, o) {
          if (Zt(Ce, n)) throw new $t(Es);
          return o.facade = n, _s(Ce, n, o), o;
        }, qe = function(n) {
          return bs(Ce, n) || {};
        }, ht = function(n) {
          return Zt(Ce, n);
        }) : (we = eu("state"), tu[we] = true, ut = function(n, o) {
          if (Yt(n, we)) throw new $t(Es);
          return o.facade = n, $o(n, we, o), o;
        }, qe = function(n) {
          return Yt(n, we) ? n[we] : {};
        }, ht = function(n) {
          return Yt(n, we);
        });
        var Ce, bs, Zt, _s, we;
        ws.exports = { set: ut, get: qe, has: ht, enforce: iu, getterFor: su };
      });
      var Ts = S((kl, Bs) => {
        var er = _e(), au = Ae(), Fs = Function.prototype, nu = er && Object.getOwnPropertyDescriptor, tr = au(Fs, "name"), ou = tr && function() {
        }.name === "something", uu = tr && (!er || er && nu(Fs, "name").configurable);
        Bs.exports = { EXISTS: tr, PROPER: ou, CONFIGURABLE: uu };
      });
      var Os = S((Fl, Ds) => {
        var hu = $(), Is = pe(), lu = Ae(), Ps = ot(), cu = st(), pu = Xt(), Ns = ks(), fu = Ts().CONFIGURABLE, du = Ns.get, mu = Ns.enforce, vu = String(String).split("String");
        (Ds.exports = function(n, o, u, l) {
          var m = l ? !!l.unsafe : false, E = l ? !!l.enumerable : false, y = l ? !!l.noTargetGet : false, A = l && l.name !== void 0 ? l.name : o, b;
          if (Is(u) && (String(A).slice(0, 7) === "Symbol(" && (A = "[" + String(A).replace(/^Symbol\(([^)]*)\)/, "$1") + "]"), (!lu(u, "name") || fu && u.name !== A) && Ps(u, "name", A), b = mu(u), b.source || (b.source = vu.join(typeof A == "string" ? A : ""))), n === hu) {
            E ? n[o] = u : cu(o, u);
            return;
          } else m ? !y && n[o] && (E = true) : delete n[o];
          E ? n[o] = u : Ps(n, o, u);
        })(Function.prototype, "toString", function() {
          return Is(this) && du(this).source || pu(this);
        });
      });
      var rr = S((Bl, Ls) => {
        var gu = Math.ceil, xu = Math.floor;
        Ls.exports = function(n) {
          var o = +n;
          return o !== o || o === 0 ? 0 : (o > 0 ? xu : gu)(o);
        };
      });
      var Rs = S((Tl, Vs) => {
        var yu = rr(), Au = Math.max, Cu = Math.min;
        Vs.exports = function(n, o) {
          var u = yu(n);
          return u < 0 ? Au(u + o, 0) : Cu(u, o);
        };
      });
      var qs = S((Il, js) => {
        var Eu = rr(), bu = Math.min;
        js.exports = function(n) {
          return n > 0 ? bu(Eu(n), 9007199254740991) : 0;
        };
      });
      var Us = S((Pl, Ms) => {
        var _u = qs();
        Ms.exports = function(n) {
          return _u(n.length);
        };
      });
      var Gs = S((Nl, Ws) => {
        var Su = tt(), wu = Rs(), ku = Us(), zs = function(n) {
          return function(o, u, l) {
            var m = Su(o), E = ku(m), y = wu(l, E), A;
            if (n && u != u) {
              for (; E > y; ) if (A = m[y++], A != A) return true;
            } else for (; E > y; y++) if ((n || y in m) && m[y] === u) return n || y || 0;
            return !n && -1;
          };
        };
        Ws.exports = { includes: zs(true), indexOf: zs(false) };
      });
      var Hs = S((Dl, Xs) => {
        var Fu = ce(), ir = Ae(), Bu = tt(), Tu = Gs().indexOf, Iu = Ht(), Ks = Fu([].push);
        Xs.exports = function(n, o) {
          var u = Bu(n), l = 0, m = [], E;
          for (E in u) !ir(Iu, E) && ir(u, E) && Ks(m, E);
          for (; o.length > l; ) ir(u, E = o[l++]) && (~Tu(m, E) || Ks(m, E));
          return m;
        };
      });
      var Ys = S((Ol, Js) => {
        Js.exports = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
      });
      var Zs = S((Qs) => {
        var Pu = Hs(), Nu = Ys(), Du = Nu.concat("length", "prototype");
        Qs.f = Object.getOwnPropertyNames || function(o) {
          return Pu(o, Du);
        };
      });
      var ea = S(($s) => {
        $s.f = Object.getOwnPropertySymbols;
      });
      var ra = S((Rl, ta) => {
        var Ou = rt(), Lu = ce(), Vu = Zs(), Ru = ea(), ju = qt(), qu = Lu([].concat);
        ta.exports = Ou("Reflect", "ownKeys") || function(o) {
          var u = Vu.f(ju(o)), l = Ru.f;
          return l ? qu(u, l(o)) : u;
        };
      });
      var aa = S((jl, sa) => {
        var ia = Ae(), Mu = ra(), Uu = jt(), zu = Gt();
        sa.exports = function(n, o, u) {
          for (var l = Mu(o), m = zu.f, E = Uu.f, y = 0; y < l.length; y++) {
            var A = l[y];
            !ia(n, A) && !(u && ia(u, A)) && m(n, A, E(o, A));
          }
        };
      });
      var oa = S((ql, na) => {
        var Wu = ye(), Gu = pe(), Ku = /#|\.prototype\./, Me = function(n, o) {
          var u = Hu[Xu(n)];
          return u == Yu ? true : u == Ju ? false : Gu(o) ? Wu(o) : !!o;
        }, Xu = Me.normalize = function(n) {
          return String(n).replace(Ku, ".").toLowerCase();
        }, Hu = Me.data = {}, Ju = Me.NATIVE = "N", Yu = Me.POLYFILL = "P";
        na.exports = Me;
      });
      var ha = S((Ml, ua) => {
        var sr = $(), Qu = jt().f, Zu = ot(), $u = Os(), eh = st(), th = aa(), rh = oa();
        ua.exports = function(n, o) {
          var u = n.target, l = n.global, m = n.stat, E, y, A, b, g, V;
          if (l ? y = sr : m ? y = sr[u] || eh(u, {}) : y = (sr[u] || {}).prototype, y) for (A in o) {
            if (g = o[A], n.noTargetGet ? (V = Qu(y, A), b = V && V.value) : b = y[A], E = rh(l ? A : u + (m ? "." : "#") + A, n.forced), !E && b !== void 0) {
              if (typeof g == typeof b) continue;
              th(g, b);
            }
            (n.sham || b && b.sham) && Zu(g, "sham", true), $u(y, A, g, n);
          }
        };
      });
      var la = S(() => {
        var ih = ha(), sh = $();
        ih({ global: true }, { globalThis: sh });
      });
      var ca = S(() => {
        la();
      });
      var Ph = S((Xl, Na) => {
        ca();
        var ur = Object.defineProperty, ah = Object.getOwnPropertyDescriptor, hr = Object.getOwnPropertyNames, nh = Object.prototype.hasOwnProperty, pa = (n, o) => function() {
          return n && (o = (0, n[hr(n)[0]])(n = 0)), o;
        }, Y = (n, o) => function() {
          return o || (0, n[hr(n)[0]])((o = { exports: {} }).exports, o), o.exports;
        }, oh = (n, o) => {
          for (var u in o) ur(n, u, { get: o[u], enumerable: true });
        }, uh = (n, o, u, l) => {
          if (o && typeof o == "object" || typeof o == "function") for (let m of hr(o)) !nh.call(n, m) && m !== u && ur(n, m, { get: () => o[m], enumerable: !(l = ah(o, m)) || l.enumerable });
          return n;
        }, hh = (n) => uh(ur({}, "__esModule", { value: true }), n), J = pa({ "<define:process>"() {
        } }), lr = Y({ "src/common/parser-create-error.js"(n, o) {
          "use strict";
          J();
          function u(l, m) {
            let E = new SyntaxError(l + " (" + m.start.line + ":" + m.start.column + ")");
            return E.loc = m, E;
          }
          o.exports = u;
        } }), fa = Y({ "src/utils/try-combinations.js"(n, o) {
          "use strict";
          J();
          function u() {
            let l;
            for (var m = arguments.length, E = new Array(m), y = 0; y < m; y++) E[y] = arguments[y];
            for (let [A, b] of E.entries()) try {
              return { result: b() };
            } catch (g) {
              A === 0 && (l = g);
            }
            return { error: l };
          }
          o.exports = u;
        } }), da = {};
        oh(da, { EOL: () => or, arch: () => lh, cpus: () => Ca, default: () => wa, endianness: () => ma, freemem: () => ya, getNetworkInterfaces: () => Sa, hostname: () => va, loadavg: () => ga, networkInterfaces: () => _a, platform: () => ch, release: () => ba, tmpDir: () => ar, tmpdir: () => nr, totalmem: () => Aa, type: () => Ea, uptime: () => xa });
        function ma() {
          if (typeof lt > "u") {
            var n = new ArrayBuffer(2), o = new Uint8Array(n), u = new Uint16Array(n);
            if (o[0] = 1, o[1] = 2, u[0] === 258) lt = "BE";
            else if (u[0] === 513) lt = "LE";
            else throw new Error("unable to figure out endianess");
          }
          return lt;
        }
        function va() {
          return typeof globalThis.location < "u" ? globalThis.location.hostname : "";
        }
        function ga() {
          return [];
        }
        function xa() {
          return 0;
        }
        function ya() {
          return Number.MAX_VALUE;
        }
        function Aa() {
          return Number.MAX_VALUE;
        }
        function Ca() {
          return [];
        }
        function Ea() {
          return "Browser";
        }
        function ba() {
          return typeof globalThis.navigator < "u" ? globalThis.navigator.appVersion : "";
        }
        function _a() {
        }
        function Sa() {
        }
        function lh() {
          return "javascript";
        }
        function ch() {
          return "browser";
        }
        function ar() {
          return "/tmp";
        }
        var lt, nr, or, wa, ph = pa({ "node-modules-polyfills:os"() {
          J(), nr = ar, or = `
`, wa = { EOL: or, tmpdir: nr, tmpDir: ar, networkInterfaces: _a, getNetworkInterfaces: Sa, release: ba, type: Ea, cpus: Ca, totalmem: Aa, freemem: ya, uptime: xa, loadavg: ga, hostname: va, endianness: ma };
        } }), fh = Y({ "node-modules-polyfills-commonjs:os"(n, o) {
          J();
          var u = (ph(), hh(da));
          if (u && u.default) {
            o.exports = u.default;
            for (let l in u) o.exports[l] = u[l];
          } else u && (o.exports = u);
        } }), dh = Y({ "node_modules/detect-newline/index.js"(n, o) {
          "use strict";
          J();
          var u = (l) => {
            if (typeof l != "string") throw new TypeError("Expected a string");
            let m = l.match(/(?:\r?\n)/g) || [];
            if (m.length === 0) return;
            let E = m.filter((A) => A === `\r
`).length, y = m.length - E;
            return E > y ? `\r
` : `
`;
          };
          o.exports = u, o.exports.graceful = (l) => typeof l == "string" && u(l) || `
`;
        } }), mh = Y({ "node_modules/jest-docblock/build/index.js"(n) {
          "use strict";
          J(), Object.defineProperty(n, "__esModule", { value: true }), n.extract = T, n.parse = q, n.parseWithComments = B, n.print = I, n.strip = v;
          function o() {
            let C = fh();
            return o = function() {
              return C;
            }, C;
          }
          function u() {
            let C = l(dh());
            return u = function() {
              return C;
            }, C;
          }
          function l(C) {
            return C && C.__esModule ? C : { default: C };
          }
          var m = /\*\/$/, E = /^\/\*\*/, y = /^\s*(\/\*\*?(.|\r?\n)*?\*\/)/, A = /(^|\s+)\/\/([^\r\n]*)/g, b = /^(\r?\n)+/, g = /(?:^|\r?\n) *(@[^\r\n]*?) *\r?\n *(?![^@\r\n]*\/\/[^]*)([^@\r\n\s][^@\r\n]+?) *\r?\n/g, V = /(?:^|\r?\n) *@(\S+) *([^\r\n]*)/g, R = /(\r?\n|^) *\* ?/g, N = [];
          function T(C) {
            let H = C.match(y);
            return H ? H[0].trimLeft() : "";
          }
          function v(C) {
            let H = C.match(y);
            return H && H[0] ? C.substring(H[0].length) : C;
          }
          function q(C) {
            return B(C).pragmas;
          }
          function B(C) {
            let H = (0, u().default)(C) || o().EOL;
            C = C.replace(E, "").replace(m, "").replace(R, "$1");
            let L = "";
            for (; L !== C; ) L = C, C = C.replace(g, "".concat(H, "$1 $2").concat(H));
            C = C.replace(b, "").trimRight();
            let i = /* @__PURE__ */ Object.create(null), _ = C.replace(V, "").replace(b, "").trimRight(), P;
            for (; P = V.exec(C); ) {
              let M = P[2].replace(A, "");
              typeof i[P[1]] == "string" || Array.isArray(i[P[1]]) ? i[P[1]] = N.concat(i[P[1]], M) : i[P[1]] = M;
            }
            return { comments: _, pragmas: i };
          }
          function I(C) {
            let { comments: H = "", pragmas: L = {} } = C, i = (0, u().default)(H) || o().EOL, _ = "/**", P = " *", M = " */", ee = Object.keys(L), ae = ee.map((ie) => k(ie, L[ie])).reduce((ie, Ne) => ie.concat(Ne), []).map((ie) => P + " " + ie + i).join("");
            if (!H) {
              if (ee.length === 0) return "";
              if (ee.length === 1 && !Array.isArray(L[ee[0]])) {
                let ie = L[ee[0]];
                return "".concat(_, " ").concat(k(ee[0], ie)[0]).concat(M);
              }
            }
            let te = H.split(i).map((ie) => "".concat(P, " ").concat(ie)).join(i) + i;
            return _ + i + (H ? te : "") + (H && ee.length ? P + i : "") + ae + M;
          }
          function k(C, H) {
            return N.concat(H).map((L) => "@".concat(C, " ").concat(L).trim());
          }
        } }), vh = Y({ "src/common/end-of-line.js"(n, o) {
          "use strict";
          J();
          function u(y) {
            let A = y.indexOf("\r");
            return A >= 0 ? y.charAt(A + 1) === `
` ? "crlf" : "cr" : "lf";
          }
          function l(y) {
            switch (y) {
              case "cr":
                return "\r";
              case "crlf":
                return `\r
`;
              default:
                return `
`;
            }
          }
          function m(y, A) {
            let b;
            switch (A) {
              case `
`:
                b = /\n/g;
                break;
              case "\r":
                b = /\r/g;
                break;
              case `\r
`:
                b = /\r\n/g;
                break;
              default:
                throw new Error('Unexpected "eol" '.concat(JSON.stringify(A), "."));
            }
            let g = y.match(b);
            return g ? g.length : 0;
          }
          function E(y) {
            return y.replace(/\r\n?/g, `
`);
          }
          o.exports = { guessEndOfLine: u, convertEndOfLineToChars: l, countEndOfLineChars: m, normalizeEndOfLine: E };
        } }), gh = Y({ "src/language-js/utils/get-shebang.js"(n, o) {
          "use strict";
          J();
          function u(l) {
            if (!l.startsWith("#!")) return "";
            let m = l.indexOf(`
`);
            return m === -1 ? l : l.slice(0, m);
          }
          o.exports = u;
        } }), xh = Y({ "src/language-js/pragma.js"(n, o) {
          "use strict";
          J();
          var { parseWithComments: u, strip: l, extract: m, print: E } = mh(), { normalizeEndOfLine: y } = vh(), A = gh();
          function b(R) {
            let N = A(R);
            N && (R = R.slice(N.length + 1));
            let T = m(R), { pragmas: v, comments: q } = u(T);
            return { shebang: N, text: R, pragmas: v, comments: q };
          }
          function g(R) {
            let N = Object.keys(b(R).pragmas);
            return N.includes("prettier") || N.includes("format");
          }
          function V(R) {
            let { shebang: N, text: T, pragmas: v, comments: q } = b(R), B = l(T), I = E({ pragmas: Object.assign({ format: "" }, v), comments: q.trimStart() });
            return (N ? "".concat(N, `
`) : "") + y(I) + (B.startsWith(`
`) ? `
` : `

`) + B;
          }
          o.exports = { hasPragma: g, insertPragma: V };
        } }), yh = Y({ "src/utils/is-non-empty-array.js"(n, o) {
          "use strict";
          J();
          function u(l) {
            return Array.isArray(l) && l.length > 0;
          }
          o.exports = u;
        } }), ka = Y({ "src/language-js/loc.js"(n, o) {
          "use strict";
          J();
          var u = yh();
          function l(b, g) {
            let { ignoreDecorators: V } = g || {};
            if (!V) {
              let R = b.declaration && b.declaration.decorators || b.decorators;
              if (u(R)) return l(R[0]);
            }
            return b.range ? b.range[0] : b.start;
          }
          function m(b) {
            return b.range ? b.range[1] : b.end;
          }
          function E(b, g) {
            let V = l(b);
            return Number.isInteger(V) && V === l(g);
          }
          function y(b, g) {
            let V = m(b);
            return Number.isInteger(V) && V === m(g);
          }
          function A(b, g) {
            return E(b, g) && y(b, g);
          }
          o.exports = { locStart: l, locEnd: m, hasSameLocStart: E, hasSameLoc: A };
        } }), Fa = Y({ "src/language-js/parse/utils/create-parser.js"(n, o) {
          "use strict";
          J();
          var { hasPragma: u } = xh(), { locStart: l, locEnd: m } = ka();
          function E(y) {
            return y = typeof y == "function" ? { parse: y } : y, Object.assign({ astFormat: "estree", hasPragma: u, locStart: l, locEnd: m }, y);
          }
          o.exports = E;
        } }), Ah = Y({ "src/language-js/utils/is-ts-keyword-type.js"(n, o) {
          "use strict";
          J();
          function u(l) {
            let { type: m } = l;
            return m.startsWith("TS") && m.endsWith("Keyword");
          }
          o.exports = u;
        } }), Ch = Y({ "src/language-js/utils/is-block-comment.js"(n, o) {
          "use strict";
          J();
          var u = /* @__PURE__ */ new Set(["Block", "CommentBlock", "MultiLine"]), l = (m) => u.has(m == null ? void 0 : m.type);
          o.exports = l;
        } }), Eh = Y({ "src/language-js/utils/is-type-cast-comment.js"(n, o) {
          "use strict";
          J();
          var u = Ch();
          function l(m) {
            return u(m) && m.value[0] === "*" && /@type\b/.test(m.value);
          }
          o.exports = l;
        } }), bh = Y({ "src/utils/get-last.js"(n, o) {
          "use strict";
          J();
          var u = (l) => l[l.length - 1];
          o.exports = u;
        } }), Ba = Y({ "src/language-js/parse/postprocess/visit-node.js"(n, o) {
          "use strict";
          J();
          function u(l, m) {
            if (Array.isArray(l)) {
              for (let E = 0; E < l.length; E++) l[E] = u(l[E], m);
              return l;
            }
            if (l && typeof l == "object" && typeof l.type == "string") {
              let E = Object.keys(l);
              for (let y = 0; y < E.length; y++) l[E[y]] = u(l[E[y]], m);
              return m(l) || l;
            }
            return l;
          }
          o.exports = u;
        } }), Ta = Y({ "src/language-js/parse/postprocess/throw-syntax-error.js"(n, o) {
          "use strict";
          J();
          var u = lr();
          function l(m, E) {
            let { start: y, end: A } = m.loc;
            throw u(E, { start: { line: y.line, column: y.column + 1 }, end: { line: A.line, column: A.column + 1 } });
          }
          o.exports = l;
        } }), _h = Y({ "src/language-js/parse/postprocess/typescript.js"(n, o) {
          "use strict";
          J();
          var u = Ba(), l = Ta();
          function m(A, b, g) {
            let V = A.decorators;
            if (!Array.isArray(V)) return;
            let R = b.decorators;
            (!Array.isArray(R) || R.length !== V.length || V.some((N) => {
              let T = g.get(N);
              return !T || !R.includes(T);
            })) && l(b, "Leading decorators must be attached to a class declaration");
          }
          function E(A, b) {
            A.kind !== 167 || A.modifiers && !A.modifiers.some((R) => R.kind === 126) || A.initializer && b.value === null && l(b, "Abstract property cannot have an initializer");
          }
          function y(A, b) {
            let { esTreeNodeToTSNodeMap: g, tsNodeToESTreeNodeMap: V } = b.tsParseResult;
            u(A, (R) => {
              let N = g.get(R);
              if (!N) return;
              let T = V.get(N);
              T === R && (m(N, T, V), E(N, T));
            });
          }
          o.exports = { throwErrorForInvalidNodes: y };
        } }), Ia = Y({ "src/language-js/parse/postprocess/index.js"(n, o) {
          "use strict";
          J();
          var { locStart: u, locEnd: l } = ka(), m = Ah(), E = Eh(), y = bh(), A = Ba(), { throwErrorForInvalidNodes: b } = _h(), g = Ta();
          function V(v, q) {
            if (q.parser === "typescript" && /@|abstract/.test(q.originalText) && b(v, q), q.parser !== "typescript" && q.parser !== "flow" && q.parser !== "acorn" && q.parser !== "espree" && q.parser !== "meriyah") {
              let I = /* @__PURE__ */ new Set();
              v = A(v, (k) => {
                k.leadingComments && k.leadingComments.some(E) && I.add(u(k));
              }), v = A(v, (k) => {
                if (k.type === "ParenthesizedExpression") {
                  let { expression: C } = k;
                  if (C.type === "TypeCastExpression") return C.range = k.range, C;
                  let H = u(k);
                  if (!I.has(H)) return C.extra = Object.assign(Object.assign({}, C.extra), {}, { parenthesized: true }), C;
                }
              });
            }
            return v = A(v, (I) => {
              switch (I.type) {
                case "ChainExpression":
                  return R(I.expression);
                case "LogicalExpression": {
                  if (N(I)) return T(I);
                  break;
                }
                case "VariableDeclaration": {
                  let k = y(I.declarations);
                  k && k.init && B(I, k);
                  break;
                }
                case "TSParenthesizedType":
                  return m(I.typeAnnotation) || I.typeAnnotation.type === "TSThisType" || (I.typeAnnotation.range = [u(I), l(I)]), I.typeAnnotation;
                case "TSTypeParameter":
                  if (typeof I.name == "string") {
                    let k = u(I);
                    I.name = { type: "Identifier", name: I.name, range: [k, k + I.name.length] };
                  }
                  break;
                case "ObjectExpression":
                  if (q.parser === "typescript") {
                    let k = I.properties.find((C) => C.type === "Property" && C.value.type === "TSEmptyBodyFunctionExpression");
                    k && g(k.value, "Unexpected token.");
                  }
                  break;
                case "SequenceExpression": {
                  let k = y(I.expressions);
                  I.range = [u(I), Math.min(l(k), l(I))];
                  break;
                }
                case "TopicReference":
                  q.__isUsingHackPipeline = true;
                  break;
                case "ExportAllDeclaration": {
                  let { exported: k } = I;
                  if (q.parser === "meriyah" && k && k.type === "Identifier") {
                    let C = q.originalText.slice(u(k), l(k));
                    (C.startsWith('"') || C.startsWith("'")) && (I.exported = Object.assign(Object.assign({}, I.exported), {}, { type: "Literal", value: I.exported.name, raw: C }));
                  }
                  break;
                }
              }
            }), v;
            function B(I, k) {
              q.originalText[l(k)] !== ";" && (I.range = [u(I), l(k)]);
            }
          }
          function R(v) {
            switch (v.type) {
              case "CallExpression":
                v.type = "OptionalCallExpression", v.callee = R(v.callee);
                break;
              case "MemberExpression":
                v.type = "OptionalMemberExpression", v.object = R(v.object);
                break;
              case "TSNonNullExpression":
                v.expression = R(v.expression);
                break;
            }
            return v;
          }
          function N(v) {
            return v.type === "LogicalExpression" && v.right.type === "LogicalExpression" && v.operator === v.right.operator;
          }
          function T(v) {
            return N(v) ? T({ type: "LogicalExpression", operator: v.operator, left: T({ type: "LogicalExpression", operator: v.operator, left: v.left, right: v.right.left, range: [u(v.left), l(v.right.left)] }), right: v.right.right, range: [u(v), l(v)] }) : v;
          }
          o.exports = V;
        } }), ct = Y({ "node_modules/acorn/dist/acorn.js"(n, o) {
          J(), function(u, l) {
            typeof n == "object" && typeof o < "u" ? l(n) : typeof define == "function" && define.amd ? define(["exports"], l) : (u = typeof globalThis < "u" ? globalThis : u || self, l(u.acorn = {}));
          }(n, function(u) {
            "use strict";
            var l = { 3: "abstract boolean byte char class double enum export extends final float goto implements import int interface long native package private protected public short static super synchronized throws transient volatile", 5: "class enum extends super const export import", 6: "enum", strict: "implements interface let package private protected public static yield", strictBind: "eval arguments" }, m = "break case catch continue debugger default do else finally for function if return switch throw try var while with null true false instanceof typeof void delete new in this", E = { 5: m, "5module": m + " export import", 6: m + " const class extends export import super" }, y = /^in(stanceof)?$/, A = "\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BF\u31F0-\u31FF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC", b = "\u200C\u200D\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u0898-\u089F\u08CA-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B55-\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3C\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D81-\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EBC\u0EC8-\u0ECD\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u180F-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1ABF-\u1ACE\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DFF\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA82C\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F", g = new RegExp("[" + A + "]"), V = new RegExp("[" + A + b + "]");
            A = b = null;
            var R = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 85, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 190, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1070, 4050, 582, 8634, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 46, 2, 18, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 482, 44, 11, 6, 17, 0, 322, 29, 19, 43, 1269, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4152, 8, 221, 3, 5761, 15, 7472, 3104, 541, 1507, 4938], N = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 370, 1, 154, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 161, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 19306, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 262, 6, 10, 9, 357, 0, 62, 13, 1495, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];
            function T(e, t) {
              for (var r = 65536, s = 0; s < t.length; s += 2) {
                if (r += t[s], r > e) return false;
                if (r += t[s + 1], r >= e) return true;
              }
            }
            function v(e, t) {
              return e < 65 ? e === 36 : e < 91 ? true : e < 97 ? e === 95 : e < 123 ? true : e <= 65535 ? e >= 170 && g.test(String.fromCharCode(e)) : t === false ? false : T(e, R);
            }
            function q(e, t) {
              return e < 48 ? e === 36 : e < 58 ? true : e < 65 ? false : e < 91 ? true : e < 97 ? e === 95 : e < 123 ? true : e <= 65535 ? e >= 170 && V.test(String.fromCharCode(e)) : t === false ? false : T(e, R) || T(e, N);
            }
            var B = function(t, r) {
              r === void 0 && (r = {}), this.label = t, this.keyword = r.keyword, this.beforeExpr = !!r.beforeExpr, this.startsExpr = !!r.startsExpr, this.isLoop = !!r.isLoop, this.isAssign = !!r.isAssign, this.prefix = !!r.prefix, this.postfix = !!r.postfix, this.binop = r.binop || null, this.updateContext = null;
            };
            function I(e, t) {
              return new B(e, { beforeExpr: true, binop: t });
            }
            var k = { beforeExpr: true }, C = { startsExpr: true }, H = {};
            function L(e, t) {
              return t === void 0 && (t = {}), t.keyword = e, H[e] = new B(e, t);
            }
            var i = { num: new B("num", C), regexp: new B("regexp", C), string: new B("string", C), name: new B("name", C), privateId: new B("privateId", C), eof: new B("eof"), bracketL: new B("[", { beforeExpr: true, startsExpr: true }), bracketR: new B("]"), braceL: new B("{", { beforeExpr: true, startsExpr: true }), braceR: new B("}"), parenL: new B("(", { beforeExpr: true, startsExpr: true }), parenR: new B(")"), comma: new B(",", k), semi: new B(";", k), colon: new B(":", k), dot: new B("."), question: new B("?", k), questionDot: new B("?."), arrow: new B("=>", k), template: new B("template"), invalidTemplate: new B("invalidTemplate"), ellipsis: new B("...", k), backQuote: new B("`", C), dollarBraceL: new B("${", { beforeExpr: true, startsExpr: true }), eq: new B("=", { beforeExpr: true, isAssign: true }), assign: new B("_=", { beforeExpr: true, isAssign: true }), incDec: new B("++/--", { prefix: true, postfix: true, startsExpr: true }), prefix: new B("!/~", { beforeExpr: true, prefix: true, startsExpr: true }), logicalOR: I("||", 1), logicalAND: I("&&", 2), bitwiseOR: I("|", 3), bitwiseXOR: I("^", 4), bitwiseAND: I("&", 5), equality: I("==/!=/===/!==", 6), relational: I("</>/<=/>=", 7), bitShift: I("<</>>/>>>", 8), plusMin: new B("+/-", { beforeExpr: true, binop: 9, prefix: true, startsExpr: true }), modulo: I("%", 10), star: I("*", 10), slash: I("/", 10), starstar: new B("**", { beforeExpr: true }), coalesce: I("??", 1), _break: L("break"), _case: L("case", k), _catch: L("catch"), _continue: L("continue"), _debugger: L("debugger"), _default: L("default", k), _do: L("do", { isLoop: true, beforeExpr: true }), _else: L("else", k), _finally: L("finally"), _for: L("for", { isLoop: true }), _function: L("function", C), _if: L("if"), _return: L("return", k), _switch: L("switch"), _throw: L("throw", k), _try: L("try"), _var: L("var"), _const: L("const"), _while: L("while", { isLoop: true }), _with: L("with"), _new: L("new", { beforeExpr: true, startsExpr: true }), _this: L("this", C), _super: L("super", C), _class: L("class", C), _extends: L("extends", k), _export: L("export"), _import: L("import", C), _null: L("null", C), _true: L("true", C), _false: L("false", C), _in: L("in", { beforeExpr: true, binop: 7 }), _instanceof: L("instanceof", { beforeExpr: true, binop: 7 }), _typeof: L("typeof", { beforeExpr: true, prefix: true, startsExpr: true }), _void: L("void", { beforeExpr: true, prefix: true, startsExpr: true }), _delete: L("delete", { beforeExpr: true, prefix: true, startsExpr: true }) }, _ = /\r\n?|\n|\u2028|\u2029/, P = new RegExp(_.source, "g");
            function M(e) {
              return e === 10 || e === 13 || e === 8232 || e === 8233;
            }
            function ee(e, t, r) {
              r === void 0 && (r = e.length);
              for (var s = t; s < r; s++) {
                var a = e.charCodeAt(s);
                if (M(a)) return s < r - 1 && a === 13 && e.charCodeAt(s + 1) === 10 ? s + 2 : s + 1;
              }
              return -1;
            }
            var ae = /[\u1680\u2000-\u200a\u202f\u205f\u3000\ufeff]/, te = /(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g, ie = Object.prototype, Ne = ie.hasOwnProperty, p = ie.toString, D = Object.hasOwn || function(e, t) {
              return Ne.call(e, t);
            }, w = Array.isArray || function(e) {
              return p.call(e) === "[object Array]";
            };
            function f(e) {
              return new RegExp("^(?:" + e.replace(/ /g, "|") + ")$");
            }
            var F = /(?:[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])/, K = function(t, r) {
              this.line = t, this.column = r;
            };
            K.prototype.offset = function(t) {
              return new K(this.line, this.column + t);
            };
            var X = function(t, r, s) {
              this.start = r, this.end = s, t.sourceFile !== null && (this.source = t.sourceFile);
            };
            function oe(e, t) {
              for (var r = 1, s = 0; ; ) {
                var a = ee(e, s, t);
                if (a < 0) return new K(r, t - s);
                ++r, s = a;
              }
            }
            var me = { ecmaVersion: null, sourceType: "script", onInsertedSemicolon: null, onTrailingComma: null, allowReserved: null, allowReturnOutsideFunction: false, allowImportExportEverywhere: false, allowAwaitOutsideFunction: null, allowSuperOutsideMethod: null, allowHashBang: false, locations: false, onToken: null, onComment: null, ranges: false, program: null, sourceFile: null, directSourceFile: null, preserveParens: false }, ve = false;
            function pt(e) {
              var t = {};
              for (var r in me) t[r] = e && D(e, r) ? e[r] : me[r];
              if (t.ecmaVersion === "latest" ? t.ecmaVersion = 1e8 : t.ecmaVersion == null ? (!ve && typeof console == "object" && console.warn && (ve = true, console.warn(`Since Acorn 8.0.0, options.ecmaVersion is required.
Defaulting to 2020, but this will stop working in the future.`)), t.ecmaVersion = 11) : t.ecmaVersion >= 2015 && (t.ecmaVersion -= 2009), t.allowReserved == null && (t.allowReserved = t.ecmaVersion < 5), w(t.onToken)) {
                var s = t.onToken;
                t.onToken = function(a) {
                  return s.push(a);
                };
              }
              return w(t.onComment) && (t.onComment = ft(t, t.onComment)), t;
            }
            function ft(e, t) {
              return function(r, s, a, h, c, d) {
                var x = { type: r ? "Block" : "Line", value: s, start: a, end: h };
                e.locations && (x.loc = new X(this, c, d)), e.ranges && (x.range = [a, h]), t.push(x);
              };
            }
            var Ee = 1, ge = 2, De = 4, Ue = 8, cr = 16, pr = 32, dt = 64, fr = 128, Oe = 256, mt = Ee | ge | Oe;
            function vt(e, t) {
              return ge | (e ? De : 0) | (t ? Ue : 0);
            }
            var ze = 0, gt = 1, fe = 2, dr = 3, mr = 4, vr = 5, Z = function(t, r, s) {
              this.options = t = pt(t), this.sourceFile = t.sourceFile, this.keywords = f(E[t.ecmaVersion >= 6 ? 6 : t.sourceType === "module" ? "5module" : 5]);
              var a = "";
              t.allowReserved !== true && (a = l[t.ecmaVersion >= 6 ? 6 : t.ecmaVersion === 5 ? 5 : 3], t.sourceType === "module" && (a += " await")), this.reservedWords = f(a);
              var h = (a ? a + " " : "") + l.strict;
              this.reservedWordsStrict = f(h), this.reservedWordsStrictBind = f(h + " " + l.strictBind), this.input = String(r), this.containsEsc = false, s ? (this.pos = s, this.lineStart = this.input.lastIndexOf(`
`, s - 1) + 1, this.curLine = this.input.slice(0, this.lineStart).split(_).length) : (this.pos = this.lineStart = 0, this.curLine = 1), this.type = i.eof, this.value = null, this.start = this.end = this.pos, this.startLoc = this.endLoc = this.curPosition(), this.lastTokEndLoc = this.lastTokStartLoc = null, this.lastTokStart = this.lastTokEnd = this.pos, this.context = this.initialContext(), this.exprAllowed = true, this.inModule = t.sourceType === "module", this.strict = this.inModule || this.strictDirective(this.pos), this.potentialArrowAt = -1, this.potentialArrowInForAwait = false, this.yieldPos = this.awaitPos = this.awaitIdentPos = 0, this.labels = [], this.undefinedExports = /* @__PURE__ */ Object.create(null), this.pos === 0 && t.allowHashBang && this.input.slice(0, 2) === "#!" && this.skipLineComment(2), this.scopeStack = [], this.enterScope(Ee), this.regexpState = null, this.privateNameStack = [];
            }, le = { inFunction: { configurable: true }, inGenerator: { configurable: true }, inAsync: { configurable: true }, canAwait: { configurable: true }, allowSuper: { configurable: true }, allowDirectSuper: { configurable: true }, treatFunctionsAsVar: { configurable: true }, allowNewDotTarget: { configurable: true }, inClassStaticBlock: { configurable: true } };
            Z.prototype.parse = function() {
              var t = this.options.program || this.startNode();
              return this.nextToken(), this.parseTopLevel(t);
            }, le.inFunction.get = function() {
              return (this.currentVarScope().flags & ge) > 0;
            }, le.inGenerator.get = function() {
              return (this.currentVarScope().flags & Ue) > 0 && !this.currentVarScope().inClassFieldInit;
            }, le.inAsync.get = function() {
              return (this.currentVarScope().flags & De) > 0 && !this.currentVarScope().inClassFieldInit;
            }, le.canAwait.get = function() {
              for (var e = this.scopeStack.length - 1; e >= 0; e--) {
                var t = this.scopeStack[e];
                if (t.inClassFieldInit || t.flags & Oe) return false;
                if (t.flags & ge) return (t.flags & De) > 0;
              }
              return this.inModule && this.options.ecmaVersion >= 13 || this.options.allowAwaitOutsideFunction;
            }, le.allowSuper.get = function() {
              var e = this.currentThisScope(), t = e.flags, r = e.inClassFieldInit;
              return (t & dt) > 0 || r || this.options.allowSuperOutsideMethod;
            }, le.allowDirectSuper.get = function() {
              return (this.currentThisScope().flags & fr) > 0;
            }, le.treatFunctionsAsVar.get = function() {
              return this.treatFunctionsAsVarInScope(this.currentScope());
            }, le.allowNewDotTarget.get = function() {
              var e = this.currentThisScope(), t = e.flags, r = e.inClassFieldInit;
              return (t & (ge | Oe)) > 0 || r;
            }, le.inClassStaticBlock.get = function() {
              return (this.currentVarScope().flags & Oe) > 0;
            }, Z.extend = function() {
              for (var t = [], r = arguments.length; r--; ) t[r] = arguments[r];
              for (var s = this, a = 0; a < t.length; a++) s = t[a](s);
              return s;
            }, Z.parse = function(t, r) {
              return new this(r, t).parse();
            }, Z.parseExpressionAt = function(t, r, s) {
              var a = new this(s, t, r);
              return a.nextToken(), a.parseExpression();
            }, Z.tokenizer = function(t, r) {
              return new this(r, t);
            }, Object.defineProperties(Z.prototype, le);
            var se = Z.prototype, Da = /^(?:'((?:\\.|[^'\\])*?)'|"((?:\\.|[^"\\])*?)")/;
            se.strictDirective = function(e) {
              for (; ; ) {
                te.lastIndex = e, e += te.exec(this.input)[0].length;
                var t = Da.exec(this.input.slice(e));
                if (!t) return false;
                if ((t[1] || t[2]) === "use strict") {
                  te.lastIndex = e + t[0].length;
                  var r = te.exec(this.input), s = r.index + r[0].length, a = this.input.charAt(s);
                  return a === ";" || a === "}" || _.test(r[0]) && !(/[(`.[+\-/*%<>=,?^&]/.test(a) || a === "!" && this.input.charAt(s + 1) === "=");
                }
                e += t[0].length, te.lastIndex = e, e += te.exec(this.input)[0].length, this.input[e] === ";" && e++;
              }
            }, se.eat = function(e) {
              return this.type === e ? (this.next(), true) : false;
            }, se.isContextual = function(e) {
              return this.type === i.name && this.value === e && !this.containsEsc;
            }, se.eatContextual = function(e) {
              return this.isContextual(e) ? (this.next(), true) : false;
            }, se.expectContextual = function(e) {
              this.eatContextual(e) || this.unexpected();
            }, se.canInsertSemicolon = function() {
              return this.type === i.eof || this.type === i.braceR || _.test(this.input.slice(this.lastTokEnd, this.start));
            }, se.insertSemicolon = function() {
              if (this.canInsertSemicolon()) return this.options.onInsertedSemicolon && this.options.onInsertedSemicolon(this.lastTokEnd, this.lastTokEndLoc), true;
            }, se.semicolon = function() {
              !this.eat(i.semi) && !this.insertSemicolon() && this.unexpected();
            }, se.afterTrailingComma = function(e, t) {
              if (this.type === e) return this.options.onTrailingComma && this.options.onTrailingComma(this.lastTokStart, this.lastTokStartLoc), t || this.next(), true;
            }, se.expect = function(e) {
              this.eat(e) || this.unexpected();
            }, se.unexpected = function(e) {
              this.raise(e != null ? e : this.start, "Unexpected token");
            };
            function We() {
              this.shorthandAssign = this.trailingComma = this.parenthesizedAssign = this.parenthesizedBind = this.doubleProto = -1;
            }
            se.checkPatternErrors = function(e, t) {
              if (!!e) {
                e.trailingComma > -1 && this.raiseRecoverable(e.trailingComma, "Comma is not permitted after the rest element");
                var r = t ? e.parenthesizedAssign : e.parenthesizedBind;
                r > -1 && this.raiseRecoverable(r, "Parenthesized pattern");
              }
            }, se.checkExpressionErrors = function(e, t) {
              if (!e) return false;
              var r = e.shorthandAssign, s = e.doubleProto;
              if (!t) return r >= 0 || s >= 0;
              r >= 0 && this.raise(r, "Shorthand property assignments are valid only in destructuring patterns"), s >= 0 && this.raiseRecoverable(s, "Redefinition of __proto__ property");
            }, se.checkYieldAwaitInDefaultParams = function() {
              this.yieldPos && (!this.awaitPos || this.yieldPos < this.awaitPos) && this.raise(this.yieldPos, "Yield expression cannot be a default value"), this.awaitPos && this.raise(this.awaitPos, "Await expression cannot be a default value");
            }, se.isSimpleAssignTarget = function(e) {
              return e.type === "ParenthesizedExpression" ? this.isSimpleAssignTarget(e.expression) : e.type === "Identifier" || e.type === "MemberExpression";
            };
            var j = Z.prototype;
            j.parseTopLevel = function(e) {
              var t = /* @__PURE__ */ Object.create(null);
              for (e.body || (e.body = []); this.type !== i.eof; ) {
                var r = this.parseStatement(null, true, t);
                e.body.push(r);
              }
              if (this.inModule) for (var s = 0, a = Object.keys(this.undefinedExports); s < a.length; s += 1) {
                var h = a[s];
                this.raiseRecoverable(this.undefinedExports[h].start, "Export '" + h + "' is not defined");
              }
              return this.adaptDirectivePrologue(e.body), this.next(), e.sourceType = this.options.sourceType, this.finishNode(e, "Program");
            };
            var xt = { kind: "loop" }, Oa = { kind: "switch" };
            j.isLet = function(e) {
              if (this.options.ecmaVersion < 6 || !this.isContextual("let")) return false;
              te.lastIndex = this.pos;
              var t = te.exec(this.input), r = this.pos + t[0].length, s = this.input.charCodeAt(r);
              if (s === 91 || s === 92 || s > 55295 && s < 56320) return true;
              if (e) return false;
              if (s === 123) return true;
              if (v(s, true)) {
                for (var a = r + 1; q(s = this.input.charCodeAt(a), true); ) ++a;
                if (s === 92 || s > 55295 && s < 56320) return true;
                var h = this.input.slice(r, a);
                if (!y.test(h)) return true;
              }
              return false;
            }, j.isAsyncFunction = function() {
              if (this.options.ecmaVersion < 8 || !this.isContextual("async")) return false;
              te.lastIndex = this.pos;
              var e = te.exec(this.input), t = this.pos + e[0].length, r;
              return !_.test(this.input.slice(this.pos, t)) && this.input.slice(t, t + 8) === "function" && (t + 8 === this.input.length || !(q(r = this.input.charCodeAt(t + 8)) || r > 55295 && r < 56320));
            }, j.parseStatement = function(e, t, r) {
              var s = this.type, a = this.startNode(), h;
              switch (this.isLet(e) && (s = i._var, h = "let"), s) {
                case i._break:
                case i._continue:
                  return this.parseBreakContinueStatement(a, s.keyword);
                case i._debugger:
                  return this.parseDebuggerStatement(a);
                case i._do:
                  return this.parseDoStatement(a);
                case i._for:
                  return this.parseForStatement(a);
                case i._function:
                  return e && (this.strict || e !== "if" && e !== "label") && this.options.ecmaVersion >= 6 && this.unexpected(), this.parseFunctionStatement(a, false, !e);
                case i._class:
                  return e && this.unexpected(), this.parseClass(a, true);
                case i._if:
                  return this.parseIfStatement(a);
                case i._return:
                  return this.parseReturnStatement(a);
                case i._switch:
                  return this.parseSwitchStatement(a);
                case i._throw:
                  return this.parseThrowStatement(a);
                case i._try:
                  return this.parseTryStatement(a);
                case i._const:
                case i._var:
                  return h = h || this.value, e && h !== "var" && this.unexpected(), this.parseVarStatement(a, h);
                case i._while:
                  return this.parseWhileStatement(a);
                case i._with:
                  return this.parseWithStatement(a);
                case i.braceL:
                  return this.parseBlock(true, a);
                case i.semi:
                  return this.parseEmptyStatement(a);
                case i._export:
                case i._import:
                  if (this.options.ecmaVersion > 10 && s === i._import) {
                    te.lastIndex = this.pos;
                    var c = te.exec(this.input), d = this.pos + c[0].length, x = this.input.charCodeAt(d);
                    if (x === 40 || x === 46) return this.parseExpressionStatement(a, this.parseExpression());
                  }
                  return this.options.allowImportExportEverywhere || (t || this.raise(this.start, "'import' and 'export' may only appear at the top level"), this.inModule || this.raise(this.start, "'import' and 'export' may appear only with 'sourceType: module'")), s === i._import ? this.parseImport(a) : this.parseExport(a, r);
                default:
                  if (this.isAsyncFunction()) return e && this.unexpected(), this.next(), this.parseFunctionStatement(a, true, !e);
                  var U = this.value, W = this.parseExpression();
                  return s === i.name && W.type === "Identifier" && this.eat(i.colon) ? this.parseLabeledStatement(a, U, W, e) : this.parseExpressionStatement(a, W);
              }
            }, j.parseBreakContinueStatement = function(e, t) {
              var r = t === "break";
              this.next(), this.eat(i.semi) || this.insertSemicolon() ? e.label = null : this.type !== i.name ? this.unexpected() : (e.label = this.parseIdent(), this.semicolon());
              for (var s = 0; s < this.labels.length; ++s) {
                var a = this.labels[s];
                if ((e.label == null || a.name === e.label.name) && (a.kind != null && (r || a.kind === "loop") || e.label && r)) break;
              }
              return s === this.labels.length && this.raise(e.start, "Unsyntactic " + t), this.finishNode(e, r ? "BreakStatement" : "ContinueStatement");
            }, j.parseDebuggerStatement = function(e) {
              return this.next(), this.semicolon(), this.finishNode(e, "DebuggerStatement");
            }, j.parseDoStatement = function(e) {
              return this.next(), this.labels.push(xt), e.body = this.parseStatement("do"), this.labels.pop(), this.expect(i._while), e.test = this.parseParenExpression(), this.options.ecmaVersion >= 6 ? this.eat(i.semi) : this.semicolon(), this.finishNode(e, "DoWhileStatement");
            }, j.parseForStatement = function(e) {
              this.next();
              var t = this.options.ecmaVersion >= 9 && this.canAwait && this.eatContextual("await") ? this.lastTokStart : -1;
              if (this.labels.push(xt), this.enterScope(0), this.expect(i.parenL), this.type === i.semi) return t > -1 && this.unexpected(t), this.parseFor(e, null);
              var r = this.isLet();
              if (this.type === i._var || this.type === i._const || r) {
                var s = this.startNode(), a = r ? "let" : this.value;
                return this.next(), this.parseVar(s, true, a), this.finishNode(s, "VariableDeclaration"), (this.type === i._in || this.options.ecmaVersion >= 6 && this.isContextual("of")) && s.declarations.length === 1 ? (this.options.ecmaVersion >= 9 && (this.type === i._in ? t > -1 && this.unexpected(t) : e.await = t > -1), this.parseForIn(e, s)) : (t > -1 && this.unexpected(t), this.parseFor(e, s));
              }
              var h = this.isContextual("let"), c = false, d = new We(), x = this.parseExpression(t > -1 ? "await" : true, d);
              return this.type === i._in || (c = this.options.ecmaVersion >= 6 && this.isContextual("of")) ? (this.options.ecmaVersion >= 9 && (this.type === i._in ? t > -1 && this.unexpected(t) : e.await = t > -1), h && c && this.raise(x.start, "The left-hand side of a for-of loop may not start with 'let'."), this.toAssignable(x, false, d), this.checkLValPattern(x), this.parseForIn(e, x)) : (this.checkExpressionErrors(d, true), t > -1 && this.unexpected(t), this.parseFor(e, x));
            }, j.parseFunctionStatement = function(e, t, r) {
              return this.next(), this.parseFunction(e, Le | (r ? 0 : yt), false, t);
            }, j.parseIfStatement = function(e) {
              return this.next(), e.test = this.parseParenExpression(), e.consequent = this.parseStatement("if"), e.alternate = this.eat(i._else) ? this.parseStatement("if") : null, this.finishNode(e, "IfStatement");
            }, j.parseReturnStatement = function(e) {
              return !this.inFunction && !this.options.allowReturnOutsideFunction && this.raise(this.start, "'return' outside of function"), this.next(), this.eat(i.semi) || this.insertSemicolon() ? e.argument = null : (e.argument = this.parseExpression(), this.semicolon()), this.finishNode(e, "ReturnStatement");
            }, j.parseSwitchStatement = function(e) {
              this.next(), e.discriminant = this.parseParenExpression(), e.cases = [], this.expect(i.braceL), this.labels.push(Oa), this.enterScope(0);
              for (var t, r = false; this.type !== i.braceR; ) if (this.type === i._case || this.type === i._default) {
                var s = this.type === i._case;
                t && this.finishNode(t, "SwitchCase"), e.cases.push(t = this.startNode()), t.consequent = [], this.next(), s ? t.test = this.parseExpression() : (r && this.raiseRecoverable(this.lastTokStart, "Multiple default clauses"), r = true, t.test = null), this.expect(i.colon);
              } else t || this.unexpected(), t.consequent.push(this.parseStatement(null));
              return this.exitScope(), t && this.finishNode(t, "SwitchCase"), this.next(), this.labels.pop(), this.finishNode(e, "SwitchStatement");
            }, j.parseThrowStatement = function(e) {
              return this.next(), _.test(this.input.slice(this.lastTokEnd, this.start)) && this.raise(this.lastTokEnd, "Illegal newline after throw"), e.argument = this.parseExpression(), this.semicolon(), this.finishNode(e, "ThrowStatement");
            };
            var La = [];
            j.parseTryStatement = function(e) {
              if (this.next(), e.block = this.parseBlock(), e.handler = null, this.type === i._catch) {
                var t = this.startNode();
                if (this.next(), this.eat(i.parenL)) {
                  t.param = this.parseBindingAtom();
                  var r = t.param.type === "Identifier";
                  this.enterScope(r ? pr : 0), this.checkLValPattern(t.param, r ? mr : fe), this.expect(i.parenR);
                } else this.options.ecmaVersion < 10 && this.unexpected(), t.param = null, this.enterScope(0);
                t.body = this.parseBlock(false), this.exitScope(), e.handler = this.finishNode(t, "CatchClause");
              }
              return e.finalizer = this.eat(i._finally) ? this.parseBlock() : null, !e.handler && !e.finalizer && this.raise(e.start, "Missing catch or finally clause"), this.finishNode(e, "TryStatement");
            }, j.parseVarStatement = function(e, t) {
              return this.next(), this.parseVar(e, false, t), this.semicolon(), this.finishNode(e, "VariableDeclaration");
            }, j.parseWhileStatement = function(e) {
              return this.next(), e.test = this.parseParenExpression(), this.labels.push(xt), e.body = this.parseStatement("while"), this.labels.pop(), this.finishNode(e, "WhileStatement");
            }, j.parseWithStatement = function(e) {
              return this.strict && this.raise(this.start, "'with' in strict mode"), this.next(), e.object = this.parseParenExpression(), e.body = this.parseStatement("with"), this.finishNode(e, "WithStatement");
            }, j.parseEmptyStatement = function(e) {
              return this.next(), this.finishNode(e, "EmptyStatement");
            }, j.parseLabeledStatement = function(e, t, r, s) {
              for (var a = 0, h = this.labels; a < h.length; a += 1) {
                var c = h[a];
                c.name === t && this.raise(r.start, "Label '" + t + "' is already declared");
              }
              for (var d = this.type.isLoop ? "loop" : this.type === i._switch ? "switch" : null, x = this.labels.length - 1; x >= 0; x--) {
                var U = this.labels[x];
                if (U.statementStart === e.start) U.statementStart = this.start, U.kind = d;
                else break;
              }
              return this.labels.push({ name: t, kind: d, statementStart: this.start }), e.body = this.parseStatement(s ? s.indexOf("label") === -1 ? s + "label" : s : "label"), this.labels.pop(), e.label = r, this.finishNode(e, "LabeledStatement");
            }, j.parseExpressionStatement = function(e, t) {
              return e.expression = t, this.semicolon(), this.finishNode(e, "ExpressionStatement");
            }, j.parseBlock = function(e, t, r) {
              for (e === void 0 && (e = true), t === void 0 && (t = this.startNode()), t.body = [], this.expect(i.braceL), e && this.enterScope(0); this.type !== i.braceR; ) {
                var s = this.parseStatement(null);
                t.body.push(s);
              }
              return r && (this.strict = false), this.next(), e && this.exitScope(), this.finishNode(t, "BlockStatement");
            }, j.parseFor = function(e, t) {
              return e.init = t, this.expect(i.semi), e.test = this.type === i.semi ? null : this.parseExpression(), this.expect(i.semi), e.update = this.type === i.parenR ? null : this.parseExpression(), this.expect(i.parenR), e.body = this.parseStatement("for"), this.exitScope(), this.labels.pop(), this.finishNode(e, "ForStatement");
            }, j.parseForIn = function(e, t) {
              var r = this.type === i._in;
              return this.next(), t.type === "VariableDeclaration" && t.declarations[0].init != null && (!r || this.options.ecmaVersion < 8 || this.strict || t.kind !== "var" || t.declarations[0].id.type !== "Identifier") && this.raise(t.start, (r ? "for-in" : "for-of") + " loop variable declaration may not have an initializer"), e.left = t, e.right = r ? this.parseExpression() : this.parseMaybeAssign(), this.expect(i.parenR), e.body = this.parseStatement("for"), this.exitScope(), this.labels.pop(), this.finishNode(e, r ? "ForInStatement" : "ForOfStatement");
            }, j.parseVar = function(e, t, r) {
              for (e.declarations = [], e.kind = r; ; ) {
                var s = this.startNode();
                if (this.parseVarId(s, r), this.eat(i.eq) ? s.init = this.parseMaybeAssign(t) : r === "const" && !(this.type === i._in || this.options.ecmaVersion >= 6 && this.isContextual("of")) ? this.unexpected() : s.id.type !== "Identifier" && !(t && (this.type === i._in || this.isContextual("of"))) ? this.raise(this.lastTokEnd, "Complex binding patterns require an initialization value") : s.init = null, e.declarations.push(this.finishNode(s, "VariableDeclarator")), !this.eat(i.comma)) break;
              }
              return e;
            }, j.parseVarId = function(e, t) {
              e.id = this.parseBindingAtom(), this.checkLValPattern(e.id, t === "var" ? gt : fe, false);
            };
            var Le = 1, yt = 2, gr = 4;
            j.parseFunction = function(e, t, r, s, a) {
              this.initFunction(e), (this.options.ecmaVersion >= 9 || this.options.ecmaVersion >= 6 && !s) && (this.type === i.star && t & yt && this.unexpected(), e.generator = this.eat(i.star)), this.options.ecmaVersion >= 8 && (e.async = !!s), t & Le && (e.id = t & gr && this.type !== i.name ? null : this.parseIdent(), e.id && !(t & yt) && this.checkLValSimple(e.id, this.strict || e.generator || e.async ? this.treatFunctionsAsVar ? gt : fe : dr));
              var h = this.yieldPos, c = this.awaitPos, d = this.awaitIdentPos;
              return this.yieldPos = 0, this.awaitPos = 0, this.awaitIdentPos = 0, this.enterScope(vt(e.async, e.generator)), t & Le || (e.id = this.type === i.name ? this.parseIdent() : null), this.parseFunctionParams(e), this.parseFunctionBody(e, r, false, a), this.yieldPos = h, this.awaitPos = c, this.awaitIdentPos = d, this.finishNode(e, t & Le ? "FunctionDeclaration" : "FunctionExpression");
            }, j.parseFunctionParams = function(e) {
              this.expect(i.parenL), e.params = this.parseBindingList(i.parenR, false, this.options.ecmaVersion >= 8), this.checkYieldAwaitInDefaultParams();
            }, j.parseClass = function(e, t) {
              this.next();
              var r = this.strict;
              this.strict = true, this.parseClassId(e, t), this.parseClassSuper(e);
              var s = this.enterClassBody(), a = this.startNode(), h = false;
              for (a.body = [], this.expect(i.braceL); this.type !== i.braceR; ) {
                var c = this.parseClassElement(e.superClass !== null);
                c && (a.body.push(c), c.type === "MethodDefinition" && c.kind === "constructor" ? (h && this.raise(c.start, "Duplicate constructor in the same class"), h = true) : c.key && c.key.type === "PrivateIdentifier" && Va(s, c) && this.raiseRecoverable(c.key.start, "Identifier '#" + c.key.name + "' has already been declared"));
              }
              return this.strict = r, this.next(), e.body = this.finishNode(a, "ClassBody"), this.exitClassBody(), this.finishNode(e, t ? "ClassDeclaration" : "ClassExpression");
            }, j.parseClassElement = function(e) {
              if (this.eat(i.semi)) return null;
              var t = this.options.ecmaVersion, r = this.startNode(), s = "", a = false, h = false, c = "method", d = false;
              if (this.eatContextual("static")) {
                if (t >= 13 && this.eat(i.braceL)) return this.parseClassStaticBlock(r), r;
                this.isClassElementNameStart() || this.type === i.star ? d = true : s = "static";
              }
              if (r.static = d, !s && t >= 8 && this.eatContextual("async") && ((this.isClassElementNameStart() || this.type === i.star) && !this.canInsertSemicolon() ? h = true : s = "async"), !s && (t >= 9 || !h) && this.eat(i.star) && (a = true), !s && !h && !a) {
                var x = this.value;
                (this.eatContextual("get") || this.eatContextual("set")) && (this.isClassElementNameStart() ? c = x : s = x);
              }
              if (s ? (r.computed = false, r.key = this.startNodeAt(this.lastTokStart, this.lastTokStartLoc), r.key.name = s, this.finishNode(r.key, "Identifier")) : this.parseClassElementName(r), t < 13 || this.type === i.parenL || c !== "method" || a || h) {
                var U = !r.static && Ge(r, "constructor"), W = U && e;
                U && c !== "method" && this.raise(r.key.start, "Constructor can't have get/set modifier"), r.kind = U ? "constructor" : c, this.parseClassMethod(r, a, h, W);
              } else this.parseClassField(r);
              return r;
            }, j.isClassElementNameStart = function() {
              return this.type === i.name || this.type === i.privateId || this.type === i.num || this.type === i.string || this.type === i.bracketL || this.type.keyword;
            }, j.parseClassElementName = function(e) {
              this.type === i.privateId ? (this.value === "constructor" && this.raise(this.start, "Classes can't have an element named '#constructor'"), e.computed = false, e.key = this.parsePrivateIdent()) : this.parsePropertyName(e);
            }, j.parseClassMethod = function(e, t, r, s) {
              var a = e.key;
              e.kind === "constructor" ? (t && this.raise(a.start, "Constructor can't be a generator"), r && this.raise(a.start, "Constructor can't be an async method")) : e.static && Ge(e, "prototype") && this.raise(a.start, "Classes may not have a static property named prototype");
              var h = e.value = this.parseMethod(t, r, s);
              return e.kind === "get" && h.params.length !== 0 && this.raiseRecoverable(h.start, "getter should have no params"), e.kind === "set" && h.params.length !== 1 && this.raiseRecoverable(h.start, "setter should have exactly one param"), e.kind === "set" && h.params[0].type === "RestElement" && this.raiseRecoverable(h.params[0].start, "Setter cannot use rest params"), this.finishNode(e, "MethodDefinition");
            }, j.parseClassField = function(e) {
              if (Ge(e, "constructor") ? this.raise(e.key.start, "Classes can't have a field named 'constructor'") : e.static && Ge(e, "prototype") && this.raise(e.key.start, "Classes can't have a static field named 'prototype'"), this.eat(i.eq)) {
                var t = this.currentThisScope(), r = t.inClassFieldInit;
                t.inClassFieldInit = true, e.value = this.parseMaybeAssign(), t.inClassFieldInit = r;
              } else e.value = null;
              return this.semicolon(), this.finishNode(e, "PropertyDefinition");
            }, j.parseClassStaticBlock = function(e) {
              e.body = [];
              var t = this.labels;
              for (this.labels = [], this.enterScope(Oe | dt); this.type !== i.braceR; ) {
                var r = this.parseStatement(null);
                e.body.push(r);
              }
              return this.next(), this.exitScope(), this.labels = t, this.finishNode(e, "StaticBlock");
            }, j.parseClassId = function(e, t) {
              this.type === i.name ? (e.id = this.parseIdent(), t && this.checkLValSimple(e.id, fe, false)) : (t === true && this.unexpected(), e.id = null);
            }, j.parseClassSuper = function(e) {
              e.superClass = this.eat(i._extends) ? this.parseExprSubscripts(false) : null;
            }, j.enterClassBody = function() {
              var e = { declared: /* @__PURE__ */ Object.create(null), used: [] };
              return this.privateNameStack.push(e), e.declared;
            }, j.exitClassBody = function() {
              for (var e = this.privateNameStack.pop(), t = e.declared, r = e.used, s = this.privateNameStack.length, a = s === 0 ? null : this.privateNameStack[s - 1], h = 0; h < r.length; ++h) {
                var c = r[h];
                D(t, c.name) || (a ? a.used.push(c) : this.raiseRecoverable(c.start, "Private field '#" + c.name + "' must be declared in an enclosing class"));
              }
            };
            function Va(e, t) {
              var r = t.key.name, s = e[r], a = "true";
              return t.type === "MethodDefinition" && (t.kind === "get" || t.kind === "set") && (a = (t.static ? "s" : "i") + t.kind), s === "iget" && a === "iset" || s === "iset" && a === "iget" || s === "sget" && a === "sset" || s === "sset" && a === "sget" ? (e[r] = "true", false) : s ? true : (e[r] = a, false);
            }
            function Ge(e, t) {
              var r = e.computed, s = e.key;
              return !r && (s.type === "Identifier" && s.name === t || s.type === "Literal" && s.value === t);
            }
            j.parseExport = function(e, t) {
              if (this.next(), this.eat(i.star)) return this.options.ecmaVersion >= 11 && (this.eatContextual("as") ? (e.exported = this.parseModuleExportName(), this.checkExport(t, e.exported.name, this.lastTokStart)) : e.exported = null), this.expectContextual("from"), this.type !== i.string && this.unexpected(), e.source = this.parseExprAtom(), this.semicolon(), this.finishNode(e, "ExportAllDeclaration");
              if (this.eat(i._default)) {
                this.checkExport(t, "default", this.lastTokStart);
                var r;
                if (this.type === i._function || (r = this.isAsyncFunction())) {
                  var s = this.startNode();
                  this.next(), r && this.next(), e.declaration = this.parseFunction(s, Le | gr, false, r);
                } else if (this.type === i._class) {
                  var a = this.startNode();
                  e.declaration = this.parseClass(a, "nullableID");
                } else e.declaration = this.parseMaybeAssign(), this.semicolon();
                return this.finishNode(e, "ExportDefaultDeclaration");
              }
              if (this.shouldParseExportStatement()) e.declaration = this.parseStatement(null), e.declaration.type === "VariableDeclaration" ? this.checkVariableExport(t, e.declaration.declarations) : this.checkExport(t, e.declaration.id.name, e.declaration.id.start), e.specifiers = [], e.source = null;
              else {
                if (e.declaration = null, e.specifiers = this.parseExportSpecifiers(t), this.eatContextual("from")) this.type !== i.string && this.unexpected(), e.source = this.parseExprAtom();
                else {
                  for (var h = 0, c = e.specifiers; h < c.length; h += 1) {
                    var d = c[h];
                    this.checkUnreserved(d.local), this.checkLocalExport(d.local), d.local.type === "Literal" && this.raise(d.local.start, "A string literal cannot be used as an exported binding without `from`.");
                  }
                  e.source = null;
                }
                this.semicolon();
              }
              return this.finishNode(e, "ExportNamedDeclaration");
            }, j.checkExport = function(e, t, r) {
              !e || (D(e, t) && this.raiseRecoverable(r, "Duplicate export '" + t + "'"), e[t] = true);
            }, j.checkPatternExport = function(e, t) {
              var r = t.type;
              if (r === "Identifier") this.checkExport(e, t.name, t.start);
              else if (r === "ObjectPattern") for (var s = 0, a = t.properties; s < a.length; s += 1) {
                var h = a[s];
                this.checkPatternExport(e, h);
              }
              else if (r === "ArrayPattern") for (var c = 0, d = t.elements; c < d.length; c += 1) {
                var x = d[c];
                x && this.checkPatternExport(e, x);
              }
              else r === "Property" ? this.checkPatternExport(e, t.value) : r === "AssignmentPattern" ? this.checkPatternExport(e, t.left) : r === "RestElement" ? this.checkPatternExport(e, t.argument) : r === "ParenthesizedExpression" && this.checkPatternExport(e, t.expression);
            }, j.checkVariableExport = function(e, t) {
              if (!!e) for (var r = 0, s = t; r < s.length; r += 1) {
                var a = s[r];
                this.checkPatternExport(e, a.id);
              }
            }, j.shouldParseExportStatement = function() {
              return this.type.keyword === "var" || this.type.keyword === "const" || this.type.keyword === "class" || this.type.keyword === "function" || this.isLet() || this.isAsyncFunction();
            }, j.parseExportSpecifiers = function(e) {
              var t = [], r = true;
              for (this.expect(i.braceL); !this.eat(i.braceR); ) {
                if (r) r = false;
                else if (this.expect(i.comma), this.afterTrailingComma(i.braceR)) break;
                var s = this.startNode();
                s.local = this.parseModuleExportName(), s.exported = this.eatContextual("as") ? this.parseModuleExportName() : s.local, this.checkExport(e, s.exported[s.exported.type === "Identifier" ? "name" : "value"], s.exported.start), t.push(this.finishNode(s, "ExportSpecifier"));
              }
              return t;
            }, j.parseImport = function(e) {
              return this.next(), this.type === i.string ? (e.specifiers = La, e.source = this.parseExprAtom()) : (e.specifiers = this.parseImportSpecifiers(), this.expectContextual("from"), e.source = this.type === i.string ? this.parseExprAtom() : this.unexpected()), this.semicolon(), this.finishNode(e, "ImportDeclaration");
            }, j.parseImportSpecifiers = function() {
              var e = [], t = true;
              if (this.type === i.name) {
                var r = this.startNode();
                if (r.local = this.parseIdent(), this.checkLValSimple(r.local, fe), e.push(this.finishNode(r, "ImportDefaultSpecifier")), !this.eat(i.comma)) return e;
              }
              if (this.type === i.star) {
                var s = this.startNode();
                return this.next(), this.expectContextual("as"), s.local = this.parseIdent(), this.checkLValSimple(s.local, fe), e.push(this.finishNode(s, "ImportNamespaceSpecifier")), e;
              }
              for (this.expect(i.braceL); !this.eat(i.braceR); ) {
                if (t) t = false;
                else if (this.expect(i.comma), this.afterTrailingComma(i.braceR)) break;
                var a = this.startNode();
                a.imported = this.parseModuleExportName(), this.eatContextual("as") ? a.local = this.parseIdent() : (this.checkUnreserved(a.imported), a.local = a.imported), this.checkLValSimple(a.local, fe), e.push(this.finishNode(a, "ImportSpecifier"));
              }
              return e;
            }, j.parseModuleExportName = function() {
              if (this.options.ecmaVersion >= 13 && this.type === i.string) {
                var e = this.parseLiteral(this.value);
                return F.test(e.value) && this.raise(e.start, "An export name cannot include a lone surrogate."), e;
              }
              return this.parseIdent(true);
            }, j.adaptDirectivePrologue = function(e) {
              for (var t = 0; t < e.length && this.isDirectiveCandidate(e[t]); ++t) e[t].directive = e[t].expression.raw.slice(1, -1);
            }, j.isDirectiveCandidate = function(e) {
              return e.type === "ExpressionStatement" && e.expression.type === "Literal" && typeof e.expression.value == "string" && (this.input[e.start] === '"' || this.input[e.start] === "'");
            };
            var ue = Z.prototype;
            ue.toAssignable = function(e, t, r) {
              if (this.options.ecmaVersion >= 6 && e) switch (e.type) {
                case "Identifier":
                  this.inAsync && e.name === "await" && this.raise(e.start, "Cannot use 'await' as identifier inside an async function");
                  break;
                case "ObjectPattern":
                case "ArrayPattern":
                case "AssignmentPattern":
                case "RestElement":
                  break;
                case "ObjectExpression":
                  e.type = "ObjectPattern", r && this.checkPatternErrors(r, true);
                  for (var s = 0, a = e.properties; s < a.length; s += 1) {
                    var h = a[s];
                    this.toAssignable(h, t), h.type === "RestElement" && (h.argument.type === "ArrayPattern" || h.argument.type === "ObjectPattern") && this.raise(h.argument.start, "Unexpected token");
                  }
                  break;
                case "Property":
                  e.kind !== "init" && this.raise(e.key.start, "Object pattern can't contain getter or setter"), this.toAssignable(e.value, t);
                  break;
                case "ArrayExpression":
                  e.type = "ArrayPattern", r && this.checkPatternErrors(r, true), this.toAssignableList(e.elements, t);
                  break;
                case "SpreadElement":
                  e.type = "RestElement", this.toAssignable(e.argument, t), e.argument.type === "AssignmentPattern" && this.raise(e.argument.start, "Rest elements cannot have a default value");
                  break;
                case "AssignmentExpression":
                  e.operator !== "=" && this.raise(e.left.end, "Only '=' operator can be used for specifying default value."), e.type = "AssignmentPattern", delete e.operator, this.toAssignable(e.left, t);
                  break;
                case "ParenthesizedExpression":
                  this.toAssignable(e.expression, t, r);
                  break;
                case "ChainExpression":
                  this.raiseRecoverable(e.start, "Optional chaining cannot appear in left-hand side");
                  break;
                case "MemberExpression":
                  if (!t) break;
                default:
                  this.raise(e.start, "Assigning to rvalue");
              }
              else r && this.checkPatternErrors(r, true);
              return e;
            }, ue.toAssignableList = function(e, t) {
              for (var r = e.length, s = 0; s < r; s++) {
                var a = e[s];
                a && this.toAssignable(a, t);
              }
              if (r) {
                var h = e[r - 1];
                this.options.ecmaVersion === 6 && t && h && h.type === "RestElement" && h.argument.type !== "Identifier" && this.unexpected(h.argument.start);
              }
              return e;
            }, ue.parseSpread = function(e) {
              var t = this.startNode();
              return this.next(), t.argument = this.parseMaybeAssign(false, e), this.finishNode(t, "SpreadElement");
            }, ue.parseRestBinding = function() {
              var e = this.startNode();
              return this.next(), this.options.ecmaVersion === 6 && this.type !== i.name && this.unexpected(), e.argument = this.parseBindingAtom(), this.finishNode(e, "RestElement");
            }, ue.parseBindingAtom = function() {
              if (this.options.ecmaVersion >= 6) switch (this.type) {
                case i.bracketL:
                  var e = this.startNode();
                  return this.next(), e.elements = this.parseBindingList(i.bracketR, true, true), this.finishNode(e, "ArrayPattern");
                case i.braceL:
                  return this.parseObj(true);
              }
              return this.parseIdent();
            }, ue.parseBindingList = function(e, t, r) {
              for (var s = [], a = true; !this.eat(e); ) if (a ? a = false : this.expect(i.comma), t && this.type === i.comma) s.push(null);
              else {
                if (r && this.afterTrailingComma(e)) break;
                if (this.type === i.ellipsis) {
                  var h = this.parseRestBinding();
                  this.parseBindingListItem(h), s.push(h), this.type === i.comma && this.raise(this.start, "Comma is not permitted after the rest element"), this.expect(e);
                  break;
                } else {
                  var c = this.parseMaybeDefault(this.start, this.startLoc);
                  this.parseBindingListItem(c), s.push(c);
                }
              }
              return s;
            }, ue.parseBindingListItem = function(e) {
              return e;
            }, ue.parseMaybeDefault = function(e, t, r) {
              if (r = r || this.parseBindingAtom(), this.options.ecmaVersion < 6 || !this.eat(i.eq)) return r;
              var s = this.startNodeAt(e, t);
              return s.left = r, s.right = this.parseMaybeAssign(), this.finishNode(s, "AssignmentPattern");
            }, ue.checkLValSimple = function(e, t, r) {
              t === void 0 && (t = ze);
              var s = t !== ze;
              switch (e.type) {
                case "Identifier":
                  this.strict && this.reservedWordsStrictBind.test(e.name) && this.raiseRecoverable(e.start, (s ? "Binding " : "Assigning to ") + e.name + " in strict mode"), s && (t === fe && e.name === "let" && this.raiseRecoverable(e.start, "let is disallowed as a lexically bound name"), r && (D(r, e.name) && this.raiseRecoverable(e.start, "Argument name clash"), r[e.name] = true), t !== vr && this.declareName(e.name, t, e.start));
                  break;
                case "ChainExpression":
                  this.raiseRecoverable(e.start, "Optional chaining cannot appear in left-hand side");
                  break;
                case "MemberExpression":
                  s && this.raiseRecoverable(e.start, "Binding member expression");
                  break;
                case "ParenthesizedExpression":
                  return s && this.raiseRecoverable(e.start, "Binding parenthesized expression"), this.checkLValSimple(e.expression, t, r);
                default:
                  this.raise(e.start, (s ? "Binding" : "Assigning to") + " rvalue");
              }
            }, ue.checkLValPattern = function(e, t, r) {
              switch (t === void 0 && (t = ze), e.type) {
                case "ObjectPattern":
                  for (var s = 0, a = e.properties; s < a.length; s += 1) {
                    var h = a[s];
                    this.checkLValInnerPattern(h, t, r);
                  }
                  break;
                case "ArrayPattern":
                  for (var c = 0, d = e.elements; c < d.length; c += 1) {
                    var x = d[c];
                    x && this.checkLValInnerPattern(x, t, r);
                  }
                  break;
                default:
                  this.checkLValSimple(e, t, r);
              }
            }, ue.checkLValInnerPattern = function(e, t, r) {
              switch (t === void 0 && (t = ze), e.type) {
                case "Property":
                  this.checkLValInnerPattern(e.value, t, r);
                  break;
                case "AssignmentPattern":
                  this.checkLValPattern(e.left, t, r);
                  break;
                case "RestElement":
                  this.checkLValPattern(e.argument, t, r);
                  break;
                default:
                  this.checkLValPattern(e, t, r);
              }
            };
            var ne = function(t, r, s, a, h) {
              this.token = t, this.isExpr = !!r, this.preserveSpace = !!s, this.override = a, this.generator = !!h;
            }, Q = { b_stat: new ne("{", false), b_expr: new ne("{", true), b_tmpl: new ne("${", false), p_stat: new ne("(", false), p_expr: new ne("(", true), q_tmpl: new ne("`", true, true, function(e) {
              return e.tryReadTemplateToken();
            }), f_stat: new ne("function", false), f_expr: new ne("function", true), f_expr_gen: new ne("function", true, false, null, true), f_gen: new ne("function", false, false, null, true) }, ke = Z.prototype;
            ke.initialContext = function() {
              return [Q.b_stat];
            }, ke.curContext = function() {
              return this.context[this.context.length - 1];
            }, ke.braceIsBlock = function(e) {
              var t = this.curContext();
              return t === Q.f_expr || t === Q.f_stat ? true : e === i.colon && (t === Q.b_stat || t === Q.b_expr) ? !t.isExpr : e === i._return || e === i.name && this.exprAllowed ? _.test(this.input.slice(this.lastTokEnd, this.start)) : e === i._else || e === i.semi || e === i.eof || e === i.parenR || e === i.arrow ? true : e === i.braceL ? t === Q.b_stat : e === i._var || e === i._const || e === i.name ? false : !this.exprAllowed;
            }, ke.inGeneratorContext = function() {
              for (var e = this.context.length - 1; e >= 1; e--) {
                var t = this.context[e];
                if (t.token === "function") return t.generator;
              }
              return false;
            }, ke.updateContext = function(e) {
              var t, r = this.type;
              r.keyword && e === i.dot ? this.exprAllowed = false : (t = r.updateContext) ? t.call(this, e) : this.exprAllowed = r.beforeExpr;
            }, ke.overrideContext = function(e) {
              this.curContext() !== e && (this.context[this.context.length - 1] = e);
            }, i.parenR.updateContext = i.braceR.updateContext = function() {
              if (this.context.length === 1) {
                this.exprAllowed = true;
                return;
              }
              var e = this.context.pop();
              e === Q.b_stat && this.curContext().token === "function" && (e = this.context.pop()), this.exprAllowed = !e.isExpr;
            }, i.braceL.updateContext = function(e) {
              this.context.push(this.braceIsBlock(e) ? Q.b_stat : Q.b_expr), this.exprAllowed = true;
            }, i.dollarBraceL.updateContext = function() {
              this.context.push(Q.b_tmpl), this.exprAllowed = true;
            }, i.parenL.updateContext = function(e) {
              var t = e === i._if || e === i._for || e === i._with || e === i._while;
              this.context.push(t ? Q.p_stat : Q.p_expr), this.exprAllowed = true;
            }, i.incDec.updateContext = function() {
            }, i._function.updateContext = i._class.updateContext = function(e) {
              e.beforeExpr && e !== i._else && !(e === i.semi && this.curContext() !== Q.p_stat) && !(e === i._return && _.test(this.input.slice(this.lastTokEnd, this.start))) && !((e === i.colon || e === i.braceL) && this.curContext() === Q.b_stat) ? this.context.push(Q.f_expr) : this.context.push(Q.f_stat), this.exprAllowed = false;
            }, i.backQuote.updateContext = function() {
              this.curContext() === Q.q_tmpl ? this.context.pop() : this.context.push(Q.q_tmpl), this.exprAllowed = false;
            }, i.star.updateContext = function(e) {
              if (e === i._function) {
                var t = this.context.length - 1;
                this.context[t] === Q.f_expr ? this.context[t] = Q.f_expr_gen : this.context[t] = Q.f_gen;
              }
              this.exprAllowed = true;
            }, i.name.updateContext = function(e) {
              var t = false;
              this.options.ecmaVersion >= 6 && e !== i.dot && (this.value === "of" && !this.exprAllowed || this.value === "yield" && this.inGeneratorContext()) && (t = true), this.exprAllowed = t;
            };
            var z2 = Z.prototype;
            z2.checkPropClash = function(e, t, r) {
              if (!(this.options.ecmaVersion >= 9 && e.type === "SpreadElement") && !(this.options.ecmaVersion >= 6 && (e.computed || e.method || e.shorthand))) {
                var s = e.key, a;
                switch (s.type) {
                  case "Identifier":
                    a = s.name;
                    break;
                  case "Literal":
                    a = String(s.value);
                    break;
                  default:
                    return;
                }
                var h = e.kind;
                if (this.options.ecmaVersion >= 6) {
                  a === "__proto__" && h === "init" && (t.proto && (r ? r.doubleProto < 0 && (r.doubleProto = s.start) : this.raiseRecoverable(s.start, "Redefinition of __proto__ property")), t.proto = true);
                  return;
                }
                a = "$" + a;
                var c = t[a];
                if (c) {
                  var d;
                  h === "init" ? d = this.strict && c.init || c.get || c.set : d = c.init || c[h], d && this.raiseRecoverable(s.start, "Redefinition of property");
                } else c = t[a] = { init: false, get: false, set: false };
                c[h] = true;
              }
            }, z2.parseExpression = function(e, t) {
              var r = this.start, s = this.startLoc, a = this.parseMaybeAssign(e, t);
              if (this.type === i.comma) {
                var h = this.startNodeAt(r, s);
                for (h.expressions = [a]; this.eat(i.comma); ) h.expressions.push(this.parseMaybeAssign(e, t));
                return this.finishNode(h, "SequenceExpression");
              }
              return a;
            }, z2.parseMaybeAssign = function(e, t, r) {
              if (this.isContextual("yield")) {
                if (this.inGenerator) return this.parseYield(e);
                this.exprAllowed = false;
              }
              var s = false, a = -1, h = -1, c = -1;
              t ? (a = t.parenthesizedAssign, h = t.trailingComma, c = t.doubleProto, t.parenthesizedAssign = t.trailingComma = -1) : (t = new We(), s = true);
              var d = this.start, x = this.startLoc;
              (this.type === i.parenL || this.type === i.name) && (this.potentialArrowAt = this.start, this.potentialArrowInForAwait = e === "await");
              var U = this.parseMaybeConditional(e, t);
              if (r && (U = r.call(this, U, d, x)), this.type.isAssign) {
                var W = this.startNodeAt(d, x);
                return W.operator = this.value, this.type === i.eq && (U = this.toAssignable(U, false, t)), s || (t.parenthesizedAssign = t.trailingComma = t.doubleProto = -1), t.shorthandAssign >= U.start && (t.shorthandAssign = -1), this.type === i.eq ? this.checkLValPattern(U) : this.checkLValSimple(U), W.left = U, this.next(), W.right = this.parseMaybeAssign(e), c > -1 && (t.doubleProto = c), this.finishNode(W, "AssignmentExpression");
              } else s && this.checkExpressionErrors(t, true);
              return a > -1 && (t.parenthesizedAssign = a), h > -1 && (t.trailingComma = h), U;
            }, z2.parseMaybeConditional = function(e, t) {
              var r = this.start, s = this.startLoc, a = this.parseExprOps(e, t);
              if (this.checkExpressionErrors(t)) return a;
              if (this.eat(i.question)) {
                var h = this.startNodeAt(r, s);
                return h.test = a, h.consequent = this.parseMaybeAssign(), this.expect(i.colon), h.alternate = this.parseMaybeAssign(e), this.finishNode(h, "ConditionalExpression");
              }
              return a;
            }, z2.parseExprOps = function(e, t) {
              var r = this.start, s = this.startLoc, a = this.parseMaybeUnary(t, false, false, e);
              return this.checkExpressionErrors(t) || a.start === r && a.type === "ArrowFunctionExpression" ? a : this.parseExprOp(a, r, s, -1, e);
            }, z2.parseExprOp = function(e, t, r, s, a) {
              var h = this.type.binop;
              if (h != null && (!a || this.type !== i._in) && h > s) {
                var c = this.type === i.logicalOR || this.type === i.logicalAND, d = this.type === i.coalesce;
                d && (h = i.logicalAND.binop);
                var x = this.value;
                this.next();
                var U = this.start, W = this.startLoc, re = this.parseExprOp(this.parseMaybeUnary(null, false, false, a), U, W, h, a), be = this.buildBinary(t, r, e, re, x, c || d);
                return (c && this.type === i.coalesce || d && (this.type === i.logicalOR || this.type === i.logicalAND)) && this.raiseRecoverable(this.start, "Logical expressions and coalesce expressions cannot be mixed. Wrap either by parentheses"), this.parseExprOp(be, t, r, s, a);
              }
              return e;
            }, z2.buildBinary = function(e, t, r, s, a, h) {
              s.type === "PrivateIdentifier" && this.raise(s.start, "Private identifier can only be left side of binary expression");
              var c = this.startNodeAt(e, t);
              return c.left = r, c.operator = a, c.right = s, this.finishNode(c, h ? "LogicalExpression" : "BinaryExpression");
            }, z2.parseMaybeUnary = function(e, t, r, s) {
              var a = this.start, h = this.startLoc, c;
              if (this.isContextual("await") && this.canAwait) c = this.parseAwait(s), t = true;
              else if (this.type.prefix) {
                var d = this.startNode(), x = this.type === i.incDec;
                d.operator = this.value, d.prefix = true, this.next(), d.argument = this.parseMaybeUnary(null, true, x, s), this.checkExpressionErrors(e, true), x ? this.checkLValSimple(d.argument) : this.strict && d.operator === "delete" && d.argument.type === "Identifier" ? this.raiseRecoverable(d.start, "Deleting local variable in strict mode") : d.operator === "delete" && xr(d.argument) ? this.raiseRecoverable(d.start, "Private fields can not be deleted") : t = true, c = this.finishNode(d, x ? "UpdateExpression" : "UnaryExpression");
              } else if (!t && this.type === i.privateId) (s || this.privateNameStack.length === 0) && this.unexpected(), c = this.parsePrivateIdent(), this.type !== i._in && this.unexpected();
              else {
                if (c = this.parseExprSubscripts(e, s), this.checkExpressionErrors(e)) return c;
                for (; this.type.postfix && !this.canInsertSemicolon(); ) {
                  var U = this.startNodeAt(a, h);
                  U.operator = this.value, U.prefix = false, U.argument = c, this.checkLValSimple(c), this.next(), c = this.finishNode(U, "UpdateExpression");
                }
              }
              if (!r && this.eat(i.starstar)) if (t) this.unexpected(this.lastTokStart);
              else return this.buildBinary(a, h, c, this.parseMaybeUnary(null, false, false, s), "**", false);
              else return c;
            };
            function xr(e) {
              return e.type === "MemberExpression" && e.property.type === "PrivateIdentifier" || e.type === "ChainExpression" && xr(e.expression);
            }
            z2.parseExprSubscripts = function(e, t) {
              var r = this.start, s = this.startLoc, a = this.parseExprAtom(e, t);
              if (a.type === "ArrowFunctionExpression" && this.input.slice(this.lastTokStart, this.lastTokEnd) !== ")") return a;
              var h = this.parseSubscripts(a, r, s, false, t);
              return e && h.type === "MemberExpression" && (e.parenthesizedAssign >= h.start && (e.parenthesizedAssign = -1), e.parenthesizedBind >= h.start && (e.parenthesizedBind = -1), e.trailingComma >= h.start && (e.trailingComma = -1)), h;
            }, z2.parseSubscripts = function(e, t, r, s, a) {
              for (var h = this.options.ecmaVersion >= 8 && e.type === "Identifier" && e.name === "async" && this.lastTokEnd === e.end && !this.canInsertSemicolon() && e.end - e.start === 5 && this.potentialArrowAt === e.start, c = false; ; ) {
                var d = this.parseSubscript(e, t, r, s, h, c, a);
                if (d.optional && (c = true), d === e || d.type === "ArrowFunctionExpression") {
                  if (c) {
                    var x = this.startNodeAt(t, r);
                    x.expression = d, d = this.finishNode(x, "ChainExpression");
                  }
                  return d;
                }
                e = d;
              }
            }, z2.parseSubscript = function(e, t, r, s, a, h, c) {
              var d = this.options.ecmaVersion >= 11, x = d && this.eat(i.questionDot);
              s && x && this.raise(this.lastTokStart, "Optional chaining cannot appear in the callee of new expressions");
              var U = this.eat(i.bracketL);
              if (U || x && this.type !== i.parenL && this.type !== i.backQuote || this.eat(i.dot)) {
                var W = this.startNodeAt(t, r);
                W.object = e, U ? (W.property = this.parseExpression(), this.expect(i.bracketR)) : this.type === i.privateId && e.type !== "Super" ? W.property = this.parsePrivateIdent() : W.property = this.parseIdent(this.options.allowReserved !== "never"), W.computed = !!U, d && (W.optional = x), e = this.finishNode(W, "MemberExpression");
              } else if (!s && this.eat(i.parenL)) {
                var re = new We(), be = this.yieldPos, je = this.awaitPos, Fe = this.awaitIdentPos;
                this.yieldPos = 0, this.awaitPos = 0, this.awaitIdentPos = 0;
                var Qe = this.parseExprList(i.parenR, this.options.ecmaVersion >= 8, false, re);
                if (a && !x && !this.canInsertSemicolon() && this.eat(i.arrow)) return this.checkPatternErrors(re, false), this.checkYieldAwaitInDefaultParams(), this.awaitIdentPos > 0 && this.raise(this.awaitIdentPos, "Cannot use 'await' as identifier inside an async function"), this.yieldPos = be, this.awaitPos = je, this.awaitIdentPos = Fe, this.parseArrowExpression(this.startNodeAt(t, r), Qe, true, c);
                this.checkExpressionErrors(re, true), this.yieldPos = be || this.yieldPos, this.awaitPos = je || this.awaitPos, this.awaitIdentPos = Fe || this.awaitIdentPos;
                var Be = this.startNodeAt(t, r);
                Be.callee = e, Be.arguments = Qe, d && (Be.optional = x), e = this.finishNode(Be, "CallExpression");
              } else if (this.type === i.backQuote) {
                (x || h) && this.raise(this.start, "Optional chaining cannot appear in the tag of tagged template expressions");
                var Te = this.startNodeAt(t, r);
                Te.tag = e, Te.quasi = this.parseTemplate({ isTagged: true }), e = this.finishNode(Te, "TaggedTemplateExpression");
              }
              return e;
            }, z2.parseExprAtom = function(e, t) {
              this.type === i.slash && this.readRegexp();
              var r, s = this.potentialArrowAt === this.start;
              switch (this.type) {
                case i._super:
                  return this.allowSuper || this.raise(this.start, "'super' keyword outside a method"), r = this.startNode(), this.next(), this.type === i.parenL && !this.allowDirectSuper && this.raise(r.start, "super() call outside constructor of a subclass"), this.type !== i.dot && this.type !== i.bracketL && this.type !== i.parenL && this.unexpected(), this.finishNode(r, "Super");
                case i._this:
                  return r = this.startNode(), this.next(), this.finishNode(r, "ThisExpression");
                case i.name:
                  var a = this.start, h = this.startLoc, c = this.containsEsc, d = this.parseIdent(false);
                  if (this.options.ecmaVersion >= 8 && !c && d.name === "async" && !this.canInsertSemicolon() && this.eat(i._function)) return this.overrideContext(Q.f_expr), this.parseFunction(this.startNodeAt(a, h), 0, false, true, t);
                  if (s && !this.canInsertSemicolon()) {
                    if (this.eat(i.arrow)) return this.parseArrowExpression(this.startNodeAt(a, h), [d], false, t);
                    if (this.options.ecmaVersion >= 8 && d.name === "async" && this.type === i.name && !c && (!this.potentialArrowInForAwait || this.value !== "of" || this.containsEsc)) return d = this.parseIdent(false), (this.canInsertSemicolon() || !this.eat(i.arrow)) && this.unexpected(), this.parseArrowExpression(this.startNodeAt(a, h), [d], true, t);
                  }
                  return d;
                case i.regexp:
                  var x = this.value;
                  return r = this.parseLiteral(x.value), r.regex = { pattern: x.pattern, flags: x.flags }, r;
                case i.num:
                case i.string:
                  return this.parseLiteral(this.value);
                case i._null:
                case i._true:
                case i._false:
                  return r = this.startNode(), r.value = this.type === i._null ? null : this.type === i._true, r.raw = this.type.keyword, this.next(), this.finishNode(r, "Literal");
                case i.parenL:
                  var U = this.start, W = this.parseParenAndDistinguishExpression(s, t);
                  return e && (e.parenthesizedAssign < 0 && !this.isSimpleAssignTarget(W) && (e.parenthesizedAssign = U), e.parenthesizedBind < 0 && (e.parenthesizedBind = U)), W;
                case i.bracketL:
                  return r = this.startNode(), this.next(), r.elements = this.parseExprList(i.bracketR, true, true, e), this.finishNode(r, "ArrayExpression");
                case i.braceL:
                  return this.overrideContext(Q.b_expr), this.parseObj(false, e);
                case i._function:
                  return r = this.startNode(), this.next(), this.parseFunction(r, 0);
                case i._class:
                  return this.parseClass(this.startNode(), false);
                case i._new:
                  return this.parseNew();
                case i.backQuote:
                  return this.parseTemplate();
                case i._import:
                  return this.options.ecmaVersion >= 11 ? this.parseExprImport() : this.unexpected();
                default:
                  this.unexpected();
              }
            }, z2.parseExprImport = function() {
              var e = this.startNode();
              this.containsEsc && this.raiseRecoverable(this.start, "Escape sequence in keyword import");
              var t = this.parseIdent(true);
              switch (this.type) {
                case i.parenL:
                  return this.parseDynamicImport(e);
                case i.dot:
                  return e.meta = t, this.parseImportMeta(e);
                default:
                  this.unexpected();
              }
            }, z2.parseDynamicImport = function(e) {
              if (this.next(), e.source = this.parseMaybeAssign(), !this.eat(i.parenR)) {
                var t = this.start;
                this.eat(i.comma) && this.eat(i.parenR) ? this.raiseRecoverable(t, "Trailing comma is not allowed in import()") : this.unexpected(t);
              }
              return this.finishNode(e, "ImportExpression");
            }, z2.parseImportMeta = function(e) {
              this.next();
              var t = this.containsEsc;
              return e.property = this.parseIdent(true), e.property.name !== "meta" && this.raiseRecoverable(e.property.start, "The only valid meta property for import is 'import.meta'"), t && this.raiseRecoverable(e.start, "'import.meta' must not contain escaped characters"), this.options.sourceType !== "module" && !this.options.allowImportExportEverywhere && this.raiseRecoverable(e.start, "Cannot use 'import.meta' outside a module"), this.finishNode(e, "MetaProperty");
            }, z2.parseLiteral = function(e) {
              var t = this.startNode();
              return t.value = e, t.raw = this.input.slice(this.start, this.end), t.raw.charCodeAt(t.raw.length - 1) === 110 && (t.bigint = t.raw.slice(0, -1).replace(/_/g, "")), this.next(), this.finishNode(t, "Literal");
            }, z2.parseParenExpression = function() {
              this.expect(i.parenL);
              var e = this.parseExpression();
              return this.expect(i.parenR), e;
            }, z2.parseParenAndDistinguishExpression = function(e, t) {
              var r = this.start, s = this.startLoc, a, h = this.options.ecmaVersion >= 8;
              if (this.options.ecmaVersion >= 6) {
                this.next();
                var c = this.start, d = this.startLoc, x = [], U = true, W = false, re = new We(), be = this.yieldPos, je = this.awaitPos, Fe;
                for (this.yieldPos = 0, this.awaitPos = 0; this.type !== i.parenR; ) if (U ? U = false : this.expect(i.comma), h && this.afterTrailingComma(i.parenR, true)) {
                  W = true;
                  break;
                } else if (this.type === i.ellipsis) {
                  Fe = this.start, x.push(this.parseParenItem(this.parseRestBinding())), this.type === i.comma && this.raise(this.start, "Comma is not permitted after the rest element");
                  break;
                } else x.push(this.parseMaybeAssign(false, re, this.parseParenItem));
                var Qe = this.lastTokEnd, Be = this.lastTokEndLoc;
                if (this.expect(i.parenR), e && !this.canInsertSemicolon() && this.eat(i.arrow)) return this.checkPatternErrors(re, false), this.checkYieldAwaitInDefaultParams(), this.yieldPos = be, this.awaitPos = je, this.parseParenArrowList(r, s, x, t);
                (!x.length || W) && this.unexpected(this.lastTokStart), Fe && this.unexpected(Fe), this.checkExpressionErrors(re, true), this.yieldPos = be || this.yieldPos, this.awaitPos = je || this.awaitPos, x.length > 1 ? (a = this.startNodeAt(c, d), a.expressions = x, this.finishNodeAt(a, "SequenceExpression", Qe, Be)) : a = x[0];
              } else a = this.parseParenExpression();
              if (this.options.preserveParens) {
                var Te = this.startNodeAt(r, s);
                return Te.expression = a, this.finishNode(Te, "ParenthesizedExpression");
              } else return a;
            }, z2.parseParenItem = function(e) {
              return e;
            }, z2.parseParenArrowList = function(e, t, r, s) {
              return this.parseArrowExpression(this.startNodeAt(e, t), r, false, s);
            };
            var Ra = [];
            z2.parseNew = function() {
              this.containsEsc && this.raiseRecoverable(this.start, "Escape sequence in keyword new");
              var e = this.startNode(), t = this.parseIdent(true);
              if (this.options.ecmaVersion >= 6 && this.eat(i.dot)) {
                e.meta = t;
                var r = this.containsEsc;
                return e.property = this.parseIdent(true), e.property.name !== "target" && this.raiseRecoverable(e.property.start, "The only valid meta property for new is 'new.target'"), r && this.raiseRecoverable(e.start, "'new.target' must not contain escaped characters"), this.allowNewDotTarget || this.raiseRecoverable(e.start, "'new.target' can only be used in functions and class static block"), this.finishNode(e, "MetaProperty");
              }
              var s = this.start, a = this.startLoc, h = this.type === i._import;
              return e.callee = this.parseSubscripts(this.parseExprAtom(), s, a, true, false), h && e.callee.type === "ImportExpression" && this.raise(s, "Cannot use new with import()"), this.eat(i.parenL) ? e.arguments = this.parseExprList(i.parenR, this.options.ecmaVersion >= 8, false) : e.arguments = Ra, this.finishNode(e, "NewExpression");
            }, z2.parseTemplateElement = function(e) {
              var t = e.isTagged, r = this.startNode();
              return this.type === i.invalidTemplate ? (t || this.raiseRecoverable(this.start, "Bad escape sequence in untagged template literal"), r.value = { raw: this.value, cooked: null }) : r.value = { raw: this.input.slice(this.start, this.end).replace(/\r\n?/g, `
`), cooked: this.value }, this.next(), r.tail = this.type === i.backQuote, this.finishNode(r, "TemplateElement");
            }, z2.parseTemplate = function(e) {
              e === void 0 && (e = {});
              var t = e.isTagged;
              t === void 0 && (t = false);
              var r = this.startNode();
              this.next(), r.expressions = [];
              var s = this.parseTemplateElement({ isTagged: t });
              for (r.quasis = [s]; !s.tail; ) this.type === i.eof && this.raise(this.pos, "Unterminated template literal"), this.expect(i.dollarBraceL), r.expressions.push(this.parseExpression()), this.expect(i.braceR), r.quasis.push(s = this.parseTemplateElement({ isTagged: t }));
              return this.next(), this.finishNode(r, "TemplateLiteral");
            }, z2.isAsyncProp = function(e) {
              return !e.computed && e.key.type === "Identifier" && e.key.name === "async" && (this.type === i.name || this.type === i.num || this.type === i.string || this.type === i.bracketL || this.type.keyword || this.options.ecmaVersion >= 9 && this.type === i.star) && !_.test(this.input.slice(this.lastTokEnd, this.start));
            }, z2.parseObj = function(e, t) {
              var r = this.startNode(), s = true, a = {};
              for (r.properties = [], this.next(); !this.eat(i.braceR); ) {
                if (s) s = false;
                else if (this.expect(i.comma), this.options.ecmaVersion >= 5 && this.afterTrailingComma(i.braceR)) break;
                var h = this.parseProperty(e, t);
                e || this.checkPropClash(h, a, t), r.properties.push(h);
              }
              return this.finishNode(r, e ? "ObjectPattern" : "ObjectExpression");
            }, z2.parseProperty = function(e, t) {
              var r = this.startNode(), s, a, h, c;
              if (this.options.ecmaVersion >= 9 && this.eat(i.ellipsis)) return e ? (r.argument = this.parseIdent(false), this.type === i.comma && this.raise(this.start, "Comma is not permitted after the rest element"), this.finishNode(r, "RestElement")) : (this.type === i.parenL && t && (t.parenthesizedAssign < 0 && (t.parenthesizedAssign = this.start), t.parenthesizedBind < 0 && (t.parenthesizedBind = this.start)), r.argument = this.parseMaybeAssign(false, t), this.type === i.comma && t && t.trailingComma < 0 && (t.trailingComma = this.start), this.finishNode(r, "SpreadElement"));
              this.options.ecmaVersion >= 6 && (r.method = false, r.shorthand = false, (e || t) && (h = this.start, c = this.startLoc), e || (s = this.eat(i.star)));
              var d = this.containsEsc;
              return this.parsePropertyName(r), !e && !d && this.options.ecmaVersion >= 8 && !s && this.isAsyncProp(r) ? (a = true, s = this.options.ecmaVersion >= 9 && this.eat(i.star), this.parsePropertyName(r, t)) : a = false, this.parsePropertyValue(r, e, s, a, h, c, t, d), this.finishNode(r, "Property");
            }, z2.parsePropertyValue = function(e, t, r, s, a, h, c, d) {
              if ((r || s) && this.type === i.colon && this.unexpected(), this.eat(i.colon)) e.value = t ? this.parseMaybeDefault(this.start, this.startLoc) : this.parseMaybeAssign(false, c), e.kind = "init";
              else if (this.options.ecmaVersion >= 6 && this.type === i.parenL) t && this.unexpected(), e.kind = "init", e.method = true, e.value = this.parseMethod(r, s);
              else if (!t && !d && this.options.ecmaVersion >= 5 && !e.computed && e.key.type === "Identifier" && (e.key.name === "get" || e.key.name === "set") && this.type !== i.comma && this.type !== i.braceR && this.type !== i.eq) {
                (r || s) && this.unexpected(), e.kind = e.key.name, this.parsePropertyName(e), e.value = this.parseMethod(false);
                var x = e.kind === "get" ? 0 : 1;
                if (e.value.params.length !== x) {
                  var U = e.value.start;
                  e.kind === "get" ? this.raiseRecoverable(U, "getter should have no params") : this.raiseRecoverable(U, "setter should have exactly one param");
                } else e.kind === "set" && e.value.params[0].type === "RestElement" && this.raiseRecoverable(e.value.params[0].start, "Setter cannot use rest params");
              } else this.options.ecmaVersion >= 6 && !e.computed && e.key.type === "Identifier" ? ((r || s) && this.unexpected(), this.checkUnreserved(e.key), e.key.name === "await" && !this.awaitIdentPos && (this.awaitIdentPos = a), e.kind = "init", t ? e.value = this.parseMaybeDefault(a, h, this.copyNode(e.key)) : this.type === i.eq && c ? (c.shorthandAssign < 0 && (c.shorthandAssign = this.start), e.value = this.parseMaybeDefault(a, h, this.copyNode(e.key))) : e.value = this.copyNode(e.key), e.shorthand = true) : this.unexpected();
            }, z2.parsePropertyName = function(e) {
              if (this.options.ecmaVersion >= 6) {
                if (this.eat(i.bracketL)) return e.computed = true, e.key = this.parseMaybeAssign(), this.expect(i.bracketR), e.key;
                e.computed = false;
              }
              return e.key = this.type === i.num || this.type === i.string ? this.parseExprAtom() : this.parseIdent(this.options.allowReserved !== "never");
            }, z2.initFunction = function(e) {
              e.id = null, this.options.ecmaVersion >= 6 && (e.generator = e.expression = false), this.options.ecmaVersion >= 8 && (e.async = false);
            }, z2.parseMethod = function(e, t, r) {
              var s = this.startNode(), a = this.yieldPos, h = this.awaitPos, c = this.awaitIdentPos;
              return this.initFunction(s), this.options.ecmaVersion >= 6 && (s.generator = e), this.options.ecmaVersion >= 8 && (s.async = !!t), this.yieldPos = 0, this.awaitPos = 0, this.awaitIdentPos = 0, this.enterScope(vt(t, s.generator) | dt | (r ? fr : 0)), this.expect(i.parenL), s.params = this.parseBindingList(i.parenR, false, this.options.ecmaVersion >= 8), this.checkYieldAwaitInDefaultParams(), this.parseFunctionBody(s, false, true, false), this.yieldPos = a, this.awaitPos = h, this.awaitIdentPos = c, this.finishNode(s, "FunctionExpression");
            }, z2.parseArrowExpression = function(e, t, r, s) {
              var a = this.yieldPos, h = this.awaitPos, c = this.awaitIdentPos;
              return this.enterScope(vt(r, false) | cr), this.initFunction(e), this.options.ecmaVersion >= 8 && (e.async = !!r), this.yieldPos = 0, this.awaitPos = 0, this.awaitIdentPos = 0, e.params = this.toAssignableList(t, true), this.parseFunctionBody(e, true, false, s), this.yieldPos = a, this.awaitPos = h, this.awaitIdentPos = c, this.finishNode(e, "ArrowFunctionExpression");
            }, z2.parseFunctionBody = function(e, t, r, s) {
              var a = t && this.type !== i.braceL, h = this.strict, c = false;
              if (a) e.body = this.parseMaybeAssign(s), e.expression = true, this.checkParams(e, false);
              else {
                var d = this.options.ecmaVersion >= 7 && !this.isSimpleParamList(e.params);
                (!h || d) && (c = this.strictDirective(this.end), c && d && this.raiseRecoverable(e.start, "Illegal 'use strict' directive in function with non-simple parameter list"));
                var x = this.labels;
                this.labels = [], c && (this.strict = true), this.checkParams(e, !h && !c && !t && !r && this.isSimpleParamList(e.params)), this.strict && e.id && this.checkLValSimple(e.id, vr), e.body = this.parseBlock(false, void 0, c && !h), e.expression = false, this.adaptDirectivePrologue(e.body.body), this.labels = x;
              }
              this.exitScope();
            }, z2.isSimpleParamList = function(e) {
              for (var t = 0, r = e; t < r.length; t += 1) {
                var s = r[t];
                if (s.type !== "Identifier") return false;
              }
              return true;
            }, z2.checkParams = function(e, t) {
              for (var r = /* @__PURE__ */ Object.create(null), s = 0, a = e.params; s < a.length; s += 1) {
                var h = a[s];
                this.checkLValInnerPattern(h, gt, t ? null : r);
              }
            }, z2.parseExprList = function(e, t, r, s) {
              for (var a = [], h = true; !this.eat(e); ) {
                if (h) h = false;
                else if (this.expect(i.comma), t && this.afterTrailingComma(e)) break;
                var c = void 0;
                r && this.type === i.comma ? c = null : this.type === i.ellipsis ? (c = this.parseSpread(s), s && this.type === i.comma && s.trailingComma < 0 && (s.trailingComma = this.start)) : c = this.parseMaybeAssign(false, s), a.push(c);
              }
              return a;
            }, z2.checkUnreserved = function(e) {
              var t = e.start, r = e.end, s = e.name;
              if (this.inGenerator && s === "yield" && this.raiseRecoverable(t, "Cannot use 'yield' as identifier inside a generator"), this.inAsync && s === "await" && this.raiseRecoverable(t, "Cannot use 'await' as identifier inside an async function"), this.currentThisScope().inClassFieldInit && s === "arguments" && this.raiseRecoverable(t, "Cannot use 'arguments' in class field initializer"), this.inClassStaticBlock && (s === "arguments" || s === "await") && this.raise(t, "Cannot use " + s + " in class static initialization block"), this.keywords.test(s) && this.raise(t, "Unexpected keyword '" + s + "'"), !(this.options.ecmaVersion < 6 && this.input.slice(t, r).indexOf("\\") !== -1)) {
                var a = this.strict ? this.reservedWordsStrict : this.reservedWords;
                a.test(s) && (!this.inAsync && s === "await" && this.raiseRecoverable(t, "Cannot use keyword 'await' outside an async function"), this.raiseRecoverable(t, "The keyword '" + s + "' is reserved"));
              }
            }, z2.parseIdent = function(e, t) {
              var r = this.startNode();
              return this.type === i.name ? r.name = this.value : this.type.keyword ? (r.name = this.type.keyword, (r.name === "class" || r.name === "function") && (this.lastTokEnd !== this.lastTokStart + 1 || this.input.charCodeAt(this.lastTokStart) !== 46) && this.context.pop()) : this.unexpected(), this.next(!!e), this.finishNode(r, "Identifier"), e || (this.checkUnreserved(r), r.name === "await" && !this.awaitIdentPos && (this.awaitIdentPos = r.start)), r;
            }, z2.parsePrivateIdent = function() {
              var e = this.startNode();
              return this.type === i.privateId ? e.name = this.value : this.unexpected(), this.next(), this.finishNode(e, "PrivateIdentifier"), this.privateNameStack.length === 0 ? this.raise(e.start, "Private field '#" + e.name + "' must be declared in an enclosing class") : this.privateNameStack[this.privateNameStack.length - 1].used.push(e), e;
            }, z2.parseYield = function(e) {
              this.yieldPos || (this.yieldPos = this.start);
              var t = this.startNode();
              return this.next(), this.type === i.semi || this.canInsertSemicolon() || this.type !== i.star && !this.type.startsExpr ? (t.delegate = false, t.argument = null) : (t.delegate = this.eat(i.star), t.argument = this.parseMaybeAssign(e)), this.finishNode(t, "YieldExpression");
            }, z2.parseAwait = function(e) {
              this.awaitPos || (this.awaitPos = this.start);
              var t = this.startNode();
              return this.next(), t.argument = this.parseMaybeUnary(null, true, false, e), this.finishNode(t, "AwaitExpression");
            };
            var Ke = Z.prototype;
            Ke.raise = function(e, t) {
              var r = oe(this.input, e);
              t += " (" + r.line + ":" + r.column + ")";
              var s = new SyntaxError(t);
              throw s.pos = e, s.loc = r, s.raisedAt = this.pos, s;
            }, Ke.raiseRecoverable = Ke.raise, Ke.curPosition = function() {
              if (this.options.locations) return new K(this.curLine, this.pos - this.lineStart);
            };
            var xe = Z.prototype, ja = function(t) {
              this.flags = t, this.var = [], this.lexical = [], this.functions = [], this.inClassFieldInit = false;
            };
            xe.enterScope = function(e) {
              this.scopeStack.push(new ja(e));
            }, xe.exitScope = function() {
              this.scopeStack.pop();
            }, xe.treatFunctionsAsVarInScope = function(e) {
              return e.flags & ge || !this.inModule && e.flags & Ee;
            }, xe.declareName = function(e, t, r) {
              var s = false;
              if (t === fe) {
                var a = this.currentScope();
                s = a.lexical.indexOf(e) > -1 || a.functions.indexOf(e) > -1 || a.var.indexOf(e) > -1, a.lexical.push(e), this.inModule && a.flags & Ee && delete this.undefinedExports[e];
              } else if (t === mr) {
                var h = this.currentScope();
                h.lexical.push(e);
              } else if (t === dr) {
                var c = this.currentScope();
                this.treatFunctionsAsVar ? s = c.lexical.indexOf(e) > -1 : s = c.lexical.indexOf(e) > -1 || c.var.indexOf(e) > -1, c.functions.push(e);
              } else for (var d = this.scopeStack.length - 1; d >= 0; --d) {
                var x = this.scopeStack[d];
                if (x.lexical.indexOf(e) > -1 && !(x.flags & pr && x.lexical[0] === e) || !this.treatFunctionsAsVarInScope(x) && x.functions.indexOf(e) > -1) {
                  s = true;
                  break;
                }
                if (x.var.push(e), this.inModule && x.flags & Ee && delete this.undefinedExports[e], x.flags & mt) break;
              }
              s && this.raiseRecoverable(r, "Identifier '" + e + "' has already been declared");
            }, xe.checkLocalExport = function(e) {
              this.scopeStack[0].lexical.indexOf(e.name) === -1 && this.scopeStack[0].var.indexOf(e.name) === -1 && (this.undefinedExports[e.name] = e);
            }, xe.currentScope = function() {
              return this.scopeStack[this.scopeStack.length - 1];
            }, xe.currentVarScope = function() {
              for (var e = this.scopeStack.length - 1; ; e--) {
                var t = this.scopeStack[e];
                if (t.flags & mt) return t;
              }
            }, xe.currentThisScope = function() {
              for (var e = this.scopeStack.length - 1; ; e--) {
                var t = this.scopeStack[e];
                if (t.flags & mt && !(t.flags & cr)) return t;
              }
            };
            var Ve = function(t, r, s) {
              this.type = "", this.start = r, this.end = 0, t.options.locations && (this.loc = new X(t, s)), t.options.directSourceFile && (this.sourceFile = t.options.directSourceFile), t.options.ranges && (this.range = [r, 0]);
            }, Re = Z.prototype;
            Re.startNode = function() {
              return new Ve(this, this.start, this.startLoc);
            }, Re.startNodeAt = function(e, t) {
              return new Ve(this, e, t);
            };
            function yr(e, t, r, s) {
              return e.type = t, e.end = r, this.options.locations && (e.loc.end = s), this.options.ranges && (e.range[1] = r), e;
            }
            Re.finishNode = function(e, t) {
              return yr.call(this, e, t, this.lastTokEnd, this.lastTokEndLoc);
            }, Re.finishNodeAt = function(e, t, r, s) {
              return yr.call(this, e, t, r, s);
            }, Re.copyNode = function(e) {
              var t = new Ve(this, e.start, this.startLoc);
              for (var r in e) t[r] = e[r];
              return t;
            };
            var Ar = "ASCII ASCII_Hex_Digit AHex Alphabetic Alpha Any Assigned Bidi_Control Bidi_C Bidi_Mirrored Bidi_M Case_Ignorable CI Cased Changes_When_Casefolded CWCF Changes_When_Casemapped CWCM Changes_When_Lowercased CWL Changes_When_NFKC_Casefolded CWKCF Changes_When_Titlecased CWT Changes_When_Uppercased CWU Dash Default_Ignorable_Code_Point DI Deprecated Dep Diacritic Dia Emoji Emoji_Component Emoji_Modifier Emoji_Modifier_Base Emoji_Presentation Extender Ext Grapheme_Base Gr_Base Grapheme_Extend Gr_Ext Hex_Digit Hex IDS_Binary_Operator IDSB IDS_Trinary_Operator IDST ID_Continue IDC ID_Start IDS Ideographic Ideo Join_Control Join_C Logical_Order_Exception LOE Lowercase Lower Math Noncharacter_Code_Point NChar Pattern_Syntax Pat_Syn Pattern_White_Space Pat_WS Quotation_Mark QMark Radical Regional_Indicator RI Sentence_Terminal STerm Soft_Dotted SD Terminal_Punctuation Term Unified_Ideograph UIdeo Uppercase Upper Variation_Selector VS White_Space space XID_Continue XIDC XID_Start XIDS", Cr = Ar + " Extended_Pictographic", Er = Cr, br = Er + " EBase EComp EMod EPres ExtPict", qa = br, Ma = { 9: Ar, 10: Cr, 11: Er, 12: br, 13: qa }, _r = "Cased_Letter LC Close_Punctuation Pe Connector_Punctuation Pc Control Cc cntrl Currency_Symbol Sc Dash_Punctuation Pd Decimal_Number Nd digit Enclosing_Mark Me Final_Punctuation Pf Format Cf Initial_Punctuation Pi Letter L Letter_Number Nl Line_Separator Zl Lowercase_Letter Ll Mark M Combining_Mark Math_Symbol Sm Modifier_Letter Lm Modifier_Symbol Sk Nonspacing_Mark Mn Number N Open_Punctuation Ps Other C Other_Letter Lo Other_Number No Other_Punctuation Po Other_Symbol So Paragraph_Separator Zp Private_Use Co Punctuation P punct Separator Z Space_Separator Zs Spacing_Mark Mc Surrogate Cs Symbol S Titlecase_Letter Lt Unassigned Cn Uppercase_Letter Lu", Sr = "Adlam Adlm Ahom Anatolian_Hieroglyphs Hluw Arabic Arab Armenian Armn Avestan Avst Balinese Bali Bamum Bamu Bassa_Vah Bass Batak Batk Bengali Beng Bhaiksuki Bhks Bopomofo Bopo Brahmi Brah Braille Brai Buginese Bugi Buhid Buhd Canadian_Aboriginal Cans Carian Cari Caucasian_Albanian Aghb Chakma Cakm Cham Cham Cherokee Cher Common Zyyy Coptic Copt Qaac Cuneiform Xsux Cypriot Cprt Cyrillic Cyrl Deseret Dsrt Devanagari Deva Duployan Dupl Egyptian_Hieroglyphs Egyp Elbasan Elba Ethiopic Ethi Georgian Geor Glagolitic Glag Gothic Goth Grantha Gran Greek Grek Gujarati Gujr Gurmukhi Guru Han Hani Hangul Hang Hanunoo Hano Hatran Hatr Hebrew Hebr Hiragana Hira Imperial_Aramaic Armi Inherited Zinh Qaai Inscriptional_Pahlavi Phli Inscriptional_Parthian Prti Javanese Java Kaithi Kthi Kannada Knda Katakana Kana Kayah_Li Kali Kharoshthi Khar Khmer Khmr Khojki Khoj Khudawadi Sind Lao Laoo Latin Latn Lepcha Lepc Limbu Limb Linear_A Lina Linear_B Linb Lisu Lisu Lycian Lyci Lydian Lydi Mahajani Mahj Malayalam Mlym Mandaic Mand Manichaean Mani Marchen Marc Masaram_Gondi Gonm Meetei_Mayek Mtei Mende_Kikakui Mend Meroitic_Cursive Merc Meroitic_Hieroglyphs Mero Miao Plrd Modi Mongolian Mong Mro Mroo Multani Mult Myanmar Mymr Nabataean Nbat New_Tai_Lue Talu Newa Newa Nko Nkoo Nushu Nshu Ogham Ogam Ol_Chiki Olck Old_Hungarian Hung Old_Italic Ital Old_North_Arabian Narb Old_Permic Perm Old_Persian Xpeo Old_South_Arabian Sarb Old_Turkic Orkh Oriya Orya Osage Osge Osmanya Osma Pahawh_Hmong Hmng Palmyrene Palm Pau_Cin_Hau Pauc Phags_Pa Phag Phoenician Phnx Psalter_Pahlavi Phlp Rejang Rjng Runic Runr Samaritan Samr Saurashtra Saur Sharada Shrd Shavian Shaw Siddham Sidd SignWriting Sgnw Sinhala Sinh Sora_Sompeng Sora Soyombo Soyo Sundanese Sund Syloti_Nagri Sylo Syriac Syrc Tagalog Tglg Tagbanwa Tagb Tai_Le Tale Tai_Tham Lana Tai_Viet Tavt Takri Takr Tamil Taml Tangut Tang Telugu Telu Thaana Thaa Thai Thai Tibetan Tibt Tifinagh Tfng Tirhuta Tirh Ugaritic Ugar Vai Vaii Warang_Citi Wara Yi Yiii Zanabazar_Square Zanb", wr = Sr + " Dogra Dogr Gunjala_Gondi Gong Hanifi_Rohingya Rohg Makasar Maka Medefaidrin Medf Old_Sogdian Sogo Sogdian Sogd", kr = wr + " Elymaic Elym Nandinagari Nand Nyiakeng_Puachue_Hmong Hmnp Wancho Wcho", Fr = kr + " Chorasmian Chrs Diak Dives_Akuru Khitan_Small_Script Kits Yezi Yezidi", Ua = Fr + " Cypro_Minoan Cpmn Old_Uyghur Ougr Tangsa Tnsa Toto Vithkuqi Vith", za = { 9: Sr, 10: wr, 11: kr, 12: Fr, 13: Ua }, Br = {};
            function Wa(e) {
              var t = Br[e] = { binary: f(Ma[e] + " " + _r), nonBinary: { General_Category: f(_r), Script: f(za[e]) } };
              t.nonBinary.Script_Extensions = t.nonBinary.Script, t.nonBinary.gc = t.nonBinary.General_Category, t.nonBinary.sc = t.nonBinary.Script, t.nonBinary.scx = t.nonBinary.Script_Extensions;
            }
            for (var At = 0, Tr = [9, 10, 11, 12, 13]; At < Tr.length; At += 1) {
              var Ga = Tr[At];
              Wa(Ga);
            }
            var O = Z.prototype, de = function(t) {
              this.parser = t, this.validFlags = "gim" + (t.options.ecmaVersion >= 6 ? "uy" : "") + (t.options.ecmaVersion >= 9 ? "s" : "") + (t.options.ecmaVersion >= 13 ? "d" : ""), this.unicodeProperties = Br[t.options.ecmaVersion >= 13 ? 13 : t.options.ecmaVersion], this.source = "", this.flags = "", this.start = 0, this.switchU = false, this.switchN = false, this.pos = 0, this.lastIntValue = 0, this.lastStringValue = "", this.lastAssertionIsQuantifiable = false, this.numCapturingParens = 0, this.maxBackReference = 0, this.groupNames = [], this.backReferenceNames = [];
            };
            de.prototype.reset = function(t, r, s) {
              var a = s.indexOf("u") !== -1;
              this.start = t | 0, this.source = r + "", this.flags = s, this.switchU = a && this.parser.options.ecmaVersion >= 6, this.switchN = a && this.parser.options.ecmaVersion >= 9;
            }, de.prototype.raise = function(t) {
              this.parser.raiseRecoverable(this.start, "Invalid regular expression: /" + this.source + "/: " + t);
            }, de.prototype.at = function(t, r) {
              r === void 0 && (r = false);
              var s = this.source, a = s.length;
              if (t >= a) return -1;
              var h = s.charCodeAt(t);
              if (!(r || this.switchU) || h <= 55295 || h >= 57344 || t + 1 >= a) return h;
              var c = s.charCodeAt(t + 1);
              return c >= 56320 && c <= 57343 ? (h << 10) + c - 56613888 : h;
            }, de.prototype.nextIndex = function(t, r) {
              r === void 0 && (r = false);
              var s = this.source, a = s.length;
              if (t >= a) return a;
              var h = s.charCodeAt(t), c;
              return !(r || this.switchU) || h <= 55295 || h >= 57344 || t + 1 >= a || (c = s.charCodeAt(t + 1)) < 56320 || c > 57343 ? t + 1 : t + 2;
            }, de.prototype.current = function(t) {
              return t === void 0 && (t = false), this.at(this.pos, t);
            }, de.prototype.lookahead = function(t) {
              return t === void 0 && (t = false), this.at(this.nextIndex(this.pos, t), t);
            }, de.prototype.advance = function(t) {
              t === void 0 && (t = false), this.pos = this.nextIndex(this.pos, t);
            }, de.prototype.eat = function(t, r) {
              return r === void 0 && (r = false), this.current(r) === t ? (this.advance(r), true) : false;
            };
            function Xe(e) {
              return e <= 65535 ? String.fromCharCode(e) : (e -= 65536, String.fromCharCode((e >> 10) + 55296, (e & 1023) + 56320));
            }
            O.validateRegExpFlags = function(e) {
              for (var t = e.validFlags, r = e.flags, s = 0; s < r.length; s++) {
                var a = r.charAt(s);
                t.indexOf(a) === -1 && this.raise(e.start, "Invalid regular expression flag"), r.indexOf(a, s + 1) > -1 && this.raise(e.start, "Duplicate regular expression flag");
              }
            }, O.validateRegExpPattern = function(e) {
              this.regexp_pattern(e), !e.switchN && this.options.ecmaVersion >= 9 && e.groupNames.length > 0 && (e.switchN = true, this.regexp_pattern(e));
            }, O.regexp_pattern = function(e) {
              e.pos = 0, e.lastIntValue = 0, e.lastStringValue = "", e.lastAssertionIsQuantifiable = false, e.numCapturingParens = 0, e.maxBackReference = 0, e.groupNames.length = 0, e.backReferenceNames.length = 0, this.regexp_disjunction(e), e.pos !== e.source.length && (e.eat(41) && e.raise("Unmatched ')'"), (e.eat(93) || e.eat(125)) && e.raise("Lone quantifier brackets")), e.maxBackReference > e.numCapturingParens && e.raise("Invalid escape");
              for (var t = 0, r = e.backReferenceNames; t < r.length; t += 1) {
                var s = r[t];
                e.groupNames.indexOf(s) === -1 && e.raise("Invalid named capture referenced");
              }
            }, O.regexp_disjunction = function(e) {
              for (this.regexp_alternative(e); e.eat(124); ) this.regexp_alternative(e);
              this.regexp_eatQuantifier(e, true) && e.raise("Nothing to repeat"), e.eat(123) && e.raise("Lone quantifier brackets");
            }, O.regexp_alternative = function(e) {
              for (; e.pos < e.source.length && this.regexp_eatTerm(e); ) ;
            }, O.regexp_eatTerm = function(e) {
              return this.regexp_eatAssertion(e) ? (e.lastAssertionIsQuantifiable && this.regexp_eatQuantifier(e) && e.switchU && e.raise("Invalid quantifier"), true) : (e.switchU ? this.regexp_eatAtom(e) : this.regexp_eatExtendedAtom(e)) ? (this.regexp_eatQuantifier(e), true) : false;
            }, O.regexp_eatAssertion = function(e) {
              var t = e.pos;
              if (e.lastAssertionIsQuantifiable = false, e.eat(94) || e.eat(36)) return true;
              if (e.eat(92)) {
                if (e.eat(66) || e.eat(98)) return true;
                e.pos = t;
              }
              if (e.eat(40) && e.eat(63)) {
                var r = false;
                if (this.options.ecmaVersion >= 9 && (r = e.eat(60)), e.eat(61) || e.eat(33)) return this.regexp_disjunction(e), e.eat(41) || e.raise("Unterminated group"), e.lastAssertionIsQuantifiable = !r, true;
              }
              return e.pos = t, false;
            }, O.regexp_eatQuantifier = function(e, t) {
              return t === void 0 && (t = false), this.regexp_eatQuantifierPrefix(e, t) ? (e.eat(63), true) : false;
            }, O.regexp_eatQuantifierPrefix = function(e, t) {
              return e.eat(42) || e.eat(43) || e.eat(63) || this.regexp_eatBracedQuantifier(e, t);
            }, O.regexp_eatBracedQuantifier = function(e, t) {
              var r = e.pos;
              if (e.eat(123)) {
                var s = 0, a = -1;
                if (this.regexp_eatDecimalDigits(e) && (s = e.lastIntValue, e.eat(44) && this.regexp_eatDecimalDigits(e) && (a = e.lastIntValue), e.eat(125))) return a !== -1 && a < s && !t && e.raise("numbers out of order in {} quantifier"), true;
                e.switchU && !t && e.raise("Incomplete quantifier"), e.pos = r;
              }
              return false;
            }, O.regexp_eatAtom = function(e) {
              return this.regexp_eatPatternCharacters(e) || e.eat(46) || this.regexp_eatReverseSolidusAtomEscape(e) || this.regexp_eatCharacterClass(e) || this.regexp_eatUncapturingGroup(e) || this.regexp_eatCapturingGroup(e);
            }, O.regexp_eatReverseSolidusAtomEscape = function(e) {
              var t = e.pos;
              if (e.eat(92)) {
                if (this.regexp_eatAtomEscape(e)) return true;
                e.pos = t;
              }
              return false;
            }, O.regexp_eatUncapturingGroup = function(e) {
              var t = e.pos;
              if (e.eat(40)) {
                if (e.eat(63) && e.eat(58)) {
                  if (this.regexp_disjunction(e), e.eat(41)) return true;
                  e.raise("Unterminated group");
                }
                e.pos = t;
              }
              return false;
            }, O.regexp_eatCapturingGroup = function(e) {
              if (e.eat(40)) {
                if (this.options.ecmaVersion >= 9 ? this.regexp_groupSpecifier(e) : e.current() === 63 && e.raise("Invalid group"), this.regexp_disjunction(e), e.eat(41)) return e.numCapturingParens += 1, true;
                e.raise("Unterminated group");
              }
              return false;
            }, O.regexp_eatExtendedAtom = function(e) {
              return e.eat(46) || this.regexp_eatReverseSolidusAtomEscape(e) || this.regexp_eatCharacterClass(e) || this.regexp_eatUncapturingGroup(e) || this.regexp_eatCapturingGroup(e) || this.regexp_eatInvalidBracedQuantifier(e) || this.regexp_eatExtendedPatternCharacter(e);
            }, O.regexp_eatInvalidBracedQuantifier = function(e) {
              return this.regexp_eatBracedQuantifier(e, true) && e.raise("Nothing to repeat"), false;
            }, O.regexp_eatSyntaxCharacter = function(e) {
              var t = e.current();
              return Ir(t) ? (e.lastIntValue = t, e.advance(), true) : false;
            };
            function Ir(e) {
              return e === 36 || e >= 40 && e <= 43 || e === 46 || e === 63 || e >= 91 && e <= 94 || e >= 123 && e <= 125;
            }
            O.regexp_eatPatternCharacters = function(e) {
              for (var t = e.pos, r = 0; (r = e.current()) !== -1 && !Ir(r); ) e.advance();
              return e.pos !== t;
            }, O.regexp_eatExtendedPatternCharacter = function(e) {
              var t = e.current();
              return t !== -1 && t !== 36 && !(t >= 40 && t <= 43) && t !== 46 && t !== 63 && t !== 91 && t !== 94 && t !== 124 ? (e.advance(), true) : false;
            }, O.regexp_groupSpecifier = function(e) {
              if (e.eat(63)) {
                if (this.regexp_eatGroupName(e)) {
                  e.groupNames.indexOf(e.lastStringValue) !== -1 && e.raise("Duplicate capture group name"), e.groupNames.push(e.lastStringValue);
                  return;
                }
                e.raise("Invalid group");
              }
            }, O.regexp_eatGroupName = function(e) {
              if (e.lastStringValue = "", e.eat(60)) {
                if (this.regexp_eatRegExpIdentifierName(e) && e.eat(62)) return true;
                e.raise("Invalid capture group name");
              }
              return false;
            }, O.regexp_eatRegExpIdentifierName = function(e) {
              if (e.lastStringValue = "", this.regexp_eatRegExpIdentifierStart(e)) {
                for (e.lastStringValue += Xe(e.lastIntValue); this.regexp_eatRegExpIdentifierPart(e); ) e.lastStringValue += Xe(e.lastIntValue);
                return true;
              }
              return false;
            }, O.regexp_eatRegExpIdentifierStart = function(e) {
              var t = e.pos, r = this.options.ecmaVersion >= 11, s = e.current(r);
              return e.advance(r), s === 92 && this.regexp_eatRegExpUnicodeEscapeSequence(e, r) && (s = e.lastIntValue), Ka(s) ? (e.lastIntValue = s, true) : (e.pos = t, false);
            };
            function Ka(e) {
              return v(e, true) || e === 36 || e === 95;
            }
            O.regexp_eatRegExpIdentifierPart = function(e) {
              var t = e.pos, r = this.options.ecmaVersion >= 11, s = e.current(r);
              return e.advance(r), s === 92 && this.regexp_eatRegExpUnicodeEscapeSequence(e, r) && (s = e.lastIntValue), Xa(s) ? (e.lastIntValue = s, true) : (e.pos = t, false);
            };
            function Xa(e) {
              return q(e, true) || e === 36 || e === 95 || e === 8204 || e === 8205;
            }
            O.regexp_eatAtomEscape = function(e) {
              return this.regexp_eatBackReference(e) || this.regexp_eatCharacterClassEscape(e) || this.regexp_eatCharacterEscape(e) || e.switchN && this.regexp_eatKGroupName(e) ? true : (e.switchU && (e.current() === 99 && e.raise("Invalid unicode escape"), e.raise("Invalid escape")), false);
            }, O.regexp_eatBackReference = function(e) {
              var t = e.pos;
              if (this.regexp_eatDecimalEscape(e)) {
                var r = e.lastIntValue;
                if (e.switchU) return r > e.maxBackReference && (e.maxBackReference = r), true;
                if (r <= e.numCapturingParens) return true;
                e.pos = t;
              }
              return false;
            }, O.regexp_eatKGroupName = function(e) {
              if (e.eat(107)) {
                if (this.regexp_eatGroupName(e)) return e.backReferenceNames.push(e.lastStringValue), true;
                e.raise("Invalid named reference");
              }
              return false;
            }, O.regexp_eatCharacterEscape = function(e) {
              return this.regexp_eatControlEscape(e) || this.regexp_eatCControlLetter(e) || this.regexp_eatZero(e) || this.regexp_eatHexEscapeSequence(e) || this.regexp_eatRegExpUnicodeEscapeSequence(e, false) || !e.switchU && this.regexp_eatLegacyOctalEscapeSequence(e) || this.regexp_eatIdentityEscape(e);
            }, O.regexp_eatCControlLetter = function(e) {
              var t = e.pos;
              if (e.eat(99)) {
                if (this.regexp_eatControlLetter(e)) return true;
                e.pos = t;
              }
              return false;
            }, O.regexp_eatZero = function(e) {
              return e.current() === 48 && !He(e.lookahead()) ? (e.lastIntValue = 0, e.advance(), true) : false;
            }, O.regexp_eatControlEscape = function(e) {
              var t = e.current();
              return t === 116 ? (e.lastIntValue = 9, e.advance(), true) : t === 110 ? (e.lastIntValue = 10, e.advance(), true) : t === 118 ? (e.lastIntValue = 11, e.advance(), true) : t === 102 ? (e.lastIntValue = 12, e.advance(), true) : t === 114 ? (e.lastIntValue = 13, e.advance(), true) : false;
            }, O.regexp_eatControlLetter = function(e) {
              var t = e.current();
              return Pr(t) ? (e.lastIntValue = t % 32, e.advance(), true) : false;
            };
            function Pr(e) {
              return e >= 65 && e <= 90 || e >= 97 && e <= 122;
            }
            O.regexp_eatRegExpUnicodeEscapeSequence = function(e, t) {
              t === void 0 && (t = false);
              var r = e.pos, s = t || e.switchU;
              if (e.eat(117)) {
                if (this.regexp_eatFixedHexDigits(e, 4)) {
                  var a = e.lastIntValue;
                  if (s && a >= 55296 && a <= 56319) {
                    var h = e.pos;
                    if (e.eat(92) && e.eat(117) && this.regexp_eatFixedHexDigits(e, 4)) {
                      var c = e.lastIntValue;
                      if (c >= 56320 && c <= 57343) return e.lastIntValue = (a - 55296) * 1024 + (c - 56320) + 65536, true;
                    }
                    e.pos = h, e.lastIntValue = a;
                  }
                  return true;
                }
                if (s && e.eat(123) && this.regexp_eatHexDigits(e) && e.eat(125) && Ha(e.lastIntValue)) return true;
                s && e.raise("Invalid unicode escape"), e.pos = r;
              }
              return false;
            };
            function Ha(e) {
              return e >= 0 && e <= 1114111;
            }
            O.regexp_eatIdentityEscape = function(e) {
              if (e.switchU) return this.regexp_eatSyntaxCharacter(e) ? true : e.eat(47) ? (e.lastIntValue = 47, true) : false;
              var t = e.current();
              return t !== 99 && (!e.switchN || t !== 107) ? (e.lastIntValue = t, e.advance(), true) : false;
            }, O.regexp_eatDecimalEscape = function(e) {
              e.lastIntValue = 0;
              var t = e.current();
              if (t >= 49 && t <= 57) {
                do
                  e.lastIntValue = 10 * e.lastIntValue + (t - 48), e.advance();
                while ((t = e.current()) >= 48 && t <= 57);
                return true;
              }
              return false;
            }, O.regexp_eatCharacterClassEscape = function(e) {
              var t = e.current();
              if (Ja(t)) return e.lastIntValue = -1, e.advance(), true;
              if (e.switchU && this.options.ecmaVersion >= 9 && (t === 80 || t === 112)) {
                if (e.lastIntValue = -1, e.advance(), e.eat(123) && this.regexp_eatUnicodePropertyValueExpression(e) && e.eat(125)) return true;
                e.raise("Invalid property name");
              }
              return false;
            };
            function Ja(e) {
              return e === 100 || e === 68 || e === 115 || e === 83 || e === 119 || e === 87;
            }
            O.regexp_eatUnicodePropertyValueExpression = function(e) {
              var t = e.pos;
              if (this.regexp_eatUnicodePropertyName(e) && e.eat(61)) {
                var r = e.lastStringValue;
                if (this.regexp_eatUnicodePropertyValue(e)) {
                  var s = e.lastStringValue;
                  return this.regexp_validateUnicodePropertyNameAndValue(e, r, s), true;
                }
              }
              if (e.pos = t, this.regexp_eatLoneUnicodePropertyNameOrValue(e)) {
                var a = e.lastStringValue;
                return this.regexp_validateUnicodePropertyNameOrValue(e, a), true;
              }
              return false;
            }, O.regexp_validateUnicodePropertyNameAndValue = function(e, t, r) {
              D(e.unicodeProperties.nonBinary, t) || e.raise("Invalid property name"), e.unicodeProperties.nonBinary[t].test(r) || e.raise("Invalid property value");
            }, O.regexp_validateUnicodePropertyNameOrValue = function(e, t) {
              e.unicodeProperties.binary.test(t) || e.raise("Invalid property name");
            }, O.regexp_eatUnicodePropertyName = function(e) {
              var t = 0;
              for (e.lastStringValue = ""; Nr(t = e.current()); ) e.lastStringValue += Xe(t), e.advance();
              return e.lastStringValue !== "";
            };
            function Nr(e) {
              return Pr(e) || e === 95;
            }
            O.regexp_eatUnicodePropertyValue = function(e) {
              var t = 0;
              for (e.lastStringValue = ""; Ya(t = e.current()); ) e.lastStringValue += Xe(t), e.advance();
              return e.lastStringValue !== "";
            };
            function Ya(e) {
              return Nr(e) || He(e);
            }
            O.regexp_eatLoneUnicodePropertyNameOrValue = function(e) {
              return this.regexp_eatUnicodePropertyValue(e);
            }, O.regexp_eatCharacterClass = function(e) {
              if (e.eat(91)) {
                if (e.eat(94), this.regexp_classRanges(e), e.eat(93)) return true;
                e.raise("Unterminated character class");
              }
              return false;
            }, O.regexp_classRanges = function(e) {
              for (; this.regexp_eatClassAtom(e); ) {
                var t = e.lastIntValue;
                if (e.eat(45) && this.regexp_eatClassAtom(e)) {
                  var r = e.lastIntValue;
                  e.switchU && (t === -1 || r === -1) && e.raise("Invalid character class"), t !== -1 && r !== -1 && t > r && e.raise("Range out of order in character class");
                }
              }
            }, O.regexp_eatClassAtom = function(e) {
              var t = e.pos;
              if (e.eat(92)) {
                if (this.regexp_eatClassEscape(e)) return true;
                if (e.switchU) {
                  var r = e.current();
                  (r === 99 || Lr(r)) && e.raise("Invalid class escape"), e.raise("Invalid escape");
                }
                e.pos = t;
              }
              var s = e.current();
              return s !== 93 ? (e.lastIntValue = s, e.advance(), true) : false;
            }, O.regexp_eatClassEscape = function(e) {
              var t = e.pos;
              if (e.eat(98)) return e.lastIntValue = 8, true;
              if (e.switchU && e.eat(45)) return e.lastIntValue = 45, true;
              if (!e.switchU && e.eat(99)) {
                if (this.regexp_eatClassControlLetter(e)) return true;
                e.pos = t;
              }
              return this.regexp_eatCharacterClassEscape(e) || this.regexp_eatCharacterEscape(e);
            }, O.regexp_eatClassControlLetter = function(e) {
              var t = e.current();
              return He(t) || t === 95 ? (e.lastIntValue = t % 32, e.advance(), true) : false;
            }, O.regexp_eatHexEscapeSequence = function(e) {
              var t = e.pos;
              if (e.eat(120)) {
                if (this.regexp_eatFixedHexDigits(e, 2)) return true;
                e.switchU && e.raise("Invalid escape"), e.pos = t;
              }
              return false;
            }, O.regexp_eatDecimalDigits = function(e) {
              var t = e.pos, r = 0;
              for (e.lastIntValue = 0; He(r = e.current()); ) e.lastIntValue = 10 * e.lastIntValue + (r - 48), e.advance();
              return e.pos !== t;
            };
            function He(e) {
              return e >= 48 && e <= 57;
            }
            O.regexp_eatHexDigits = function(e) {
              var t = e.pos, r = 0;
              for (e.lastIntValue = 0; Dr(r = e.current()); ) e.lastIntValue = 16 * e.lastIntValue + Or(r), e.advance();
              return e.pos !== t;
            };
            function Dr(e) {
              return e >= 48 && e <= 57 || e >= 65 && e <= 70 || e >= 97 && e <= 102;
            }
            function Or(e) {
              return e >= 65 && e <= 70 ? 10 + (e - 65) : e >= 97 && e <= 102 ? 10 + (e - 97) : e - 48;
            }
            O.regexp_eatLegacyOctalEscapeSequence = function(e) {
              if (this.regexp_eatOctalDigit(e)) {
                var t = e.lastIntValue;
                if (this.regexp_eatOctalDigit(e)) {
                  var r = e.lastIntValue;
                  t <= 3 && this.regexp_eatOctalDigit(e) ? e.lastIntValue = t * 64 + r * 8 + e.lastIntValue : e.lastIntValue = t * 8 + r;
                } else e.lastIntValue = t;
                return true;
              }
              return false;
            }, O.regexp_eatOctalDigit = function(e) {
              var t = e.current();
              return Lr(t) ? (e.lastIntValue = t - 48, e.advance(), true) : (e.lastIntValue = 0, false);
            };
            function Lr(e) {
              return e >= 48 && e <= 55;
            }
            O.regexp_eatFixedHexDigits = function(e, t) {
              var r = e.pos;
              e.lastIntValue = 0;
              for (var s = 0; s < t; ++s) {
                var a = e.current();
                if (!Dr(a)) return e.pos = r, false;
                e.lastIntValue = 16 * e.lastIntValue + Or(a), e.advance();
              }
              return true;
            };
            var Je = function(t) {
              this.type = t.type, this.value = t.value, this.start = t.start, this.end = t.end, t.options.locations && (this.loc = new X(t, t.startLoc, t.endLoc)), t.options.ranges && (this.range = [t.start, t.end]);
            }, G = Z.prototype;
            G.next = function(e) {
              !e && this.type.keyword && this.containsEsc && this.raiseRecoverable(this.start, "Escape sequence in keyword " + this.type.keyword), this.options.onToken && this.options.onToken(new Je(this)), this.lastTokEnd = this.end, this.lastTokStart = this.start, this.lastTokEndLoc = this.endLoc, this.lastTokStartLoc = this.startLoc, this.nextToken();
            }, G.getToken = function() {
              return this.next(), new Je(this);
            }, typeof Symbol < "u" && (G[Symbol.iterator] = function() {
              var e = this;
              return { next: function() {
                var t = e.getToken();
                return { done: t.type === i.eof, value: t };
              } };
            }), G.nextToken = function() {
              var e = this.curContext();
              if ((!e || !e.preserveSpace) && this.skipSpace(), this.start = this.pos, this.options.locations && (this.startLoc = this.curPosition()), this.pos >= this.input.length) return this.finishToken(i.eof);
              if (e.override) return e.override(this);
              this.readToken(this.fullCharCodeAtPos());
            }, G.readToken = function(e) {
              return v(e, this.options.ecmaVersion >= 6) || e === 92 ? this.readWord() : this.getTokenFromCode(e);
            }, G.fullCharCodeAtPos = function() {
              var e = this.input.charCodeAt(this.pos);
              if (e <= 55295 || e >= 56320) return e;
              var t = this.input.charCodeAt(this.pos + 1);
              return t <= 56319 || t >= 57344 ? e : (e << 10) + t - 56613888;
            }, G.skipBlockComment = function() {
              var e = this.options.onComment && this.curPosition(), t = this.pos, r = this.input.indexOf("*/", this.pos += 2);
              if (r === -1 && this.raise(this.pos - 2, "Unterminated comment"), this.pos = r + 2, this.options.locations) for (var s = void 0, a = t; (s = ee(this.input, a, this.pos)) > -1; ) ++this.curLine, a = this.lineStart = s;
              this.options.onComment && this.options.onComment(true, this.input.slice(t + 2, r), t, this.pos, e, this.curPosition());
            }, G.skipLineComment = function(e) {
              for (var t = this.pos, r = this.options.onComment && this.curPosition(), s = this.input.charCodeAt(this.pos += e); this.pos < this.input.length && !M(s); ) s = this.input.charCodeAt(++this.pos);
              this.options.onComment && this.options.onComment(false, this.input.slice(t + e, this.pos), t, this.pos, r, this.curPosition());
            }, G.skipSpace = function() {
              e: for (; this.pos < this.input.length; ) {
                var e = this.input.charCodeAt(this.pos);
                switch (e) {
                  case 32:
                  case 160:
                    ++this.pos;
                    break;
                  case 13:
                    this.input.charCodeAt(this.pos + 1) === 10 && ++this.pos;
                  case 10:
                  case 8232:
                  case 8233:
                    ++this.pos, this.options.locations && (++this.curLine, this.lineStart = this.pos);
                    break;
                  case 47:
                    switch (this.input.charCodeAt(this.pos + 1)) {
                      case 42:
                        this.skipBlockComment();
                        break;
                      case 47:
                        this.skipLineComment(2);
                        break;
                      default:
                        break e;
                    }
                    break;
                  default:
                    if (e > 8 && e < 14 || e >= 5760 && ae.test(String.fromCharCode(e))) ++this.pos;
                    else break e;
                }
              }
            }, G.finishToken = function(e, t) {
              this.end = this.pos, this.options.locations && (this.endLoc = this.curPosition());
              var r = this.type;
              this.type = e, this.value = t, this.updateContext(r);
            }, G.readToken_dot = function() {
              var e = this.input.charCodeAt(this.pos + 1);
              if (e >= 48 && e <= 57) return this.readNumber(true);
              var t = this.input.charCodeAt(this.pos + 2);
              return this.options.ecmaVersion >= 6 && e === 46 && t === 46 ? (this.pos += 3, this.finishToken(i.ellipsis)) : (++this.pos, this.finishToken(i.dot));
            }, G.readToken_slash = function() {
              var e = this.input.charCodeAt(this.pos + 1);
              return this.exprAllowed ? (++this.pos, this.readRegexp()) : e === 61 ? this.finishOp(i.assign, 2) : this.finishOp(i.slash, 1);
            }, G.readToken_mult_modulo_exp = function(e) {
              var t = this.input.charCodeAt(this.pos + 1), r = 1, s = e === 42 ? i.star : i.modulo;
              return this.options.ecmaVersion >= 7 && e === 42 && t === 42 && (++r, s = i.starstar, t = this.input.charCodeAt(this.pos + 2)), t === 61 ? this.finishOp(i.assign, r + 1) : this.finishOp(s, r);
            }, G.readToken_pipe_amp = function(e) {
              var t = this.input.charCodeAt(this.pos + 1);
              if (t === e) {
                if (this.options.ecmaVersion >= 12) {
                  var r = this.input.charCodeAt(this.pos + 2);
                  if (r === 61) return this.finishOp(i.assign, 3);
                }
                return this.finishOp(e === 124 ? i.logicalOR : i.logicalAND, 2);
              }
              return t === 61 ? this.finishOp(i.assign, 2) : this.finishOp(e === 124 ? i.bitwiseOR : i.bitwiseAND, 1);
            }, G.readToken_caret = function() {
              var e = this.input.charCodeAt(this.pos + 1);
              return e === 61 ? this.finishOp(i.assign, 2) : this.finishOp(i.bitwiseXOR, 1);
            }, G.readToken_plus_min = function(e) {
              var t = this.input.charCodeAt(this.pos + 1);
              return t === e ? t === 45 && !this.inModule && this.input.charCodeAt(this.pos + 2) === 62 && (this.lastTokEnd === 0 || _.test(this.input.slice(this.lastTokEnd, this.pos))) ? (this.skipLineComment(3), this.skipSpace(), this.nextToken()) : this.finishOp(i.incDec, 2) : t === 61 ? this.finishOp(i.assign, 2) : this.finishOp(i.plusMin, 1);
            }, G.readToken_lt_gt = function(e) {
              var t = this.input.charCodeAt(this.pos + 1), r = 1;
              return t === e ? (r = e === 62 && this.input.charCodeAt(this.pos + 2) === 62 ? 3 : 2, this.input.charCodeAt(this.pos + r) === 61 ? this.finishOp(i.assign, r + 1) : this.finishOp(i.bitShift, r)) : t === 33 && e === 60 && !this.inModule && this.input.charCodeAt(this.pos + 2) === 45 && this.input.charCodeAt(this.pos + 3) === 45 ? (this.skipLineComment(4), this.skipSpace(), this.nextToken()) : (t === 61 && (r = 2), this.finishOp(i.relational, r));
            }, G.readToken_eq_excl = function(e) {
              var t = this.input.charCodeAt(this.pos + 1);
              return t === 61 ? this.finishOp(i.equality, this.input.charCodeAt(this.pos + 2) === 61 ? 3 : 2) : e === 61 && t === 62 && this.options.ecmaVersion >= 6 ? (this.pos += 2, this.finishToken(i.arrow)) : this.finishOp(e === 61 ? i.eq : i.prefix, 1);
            }, G.readToken_question = function() {
              var e = this.options.ecmaVersion;
              if (e >= 11) {
                var t = this.input.charCodeAt(this.pos + 1);
                if (t === 46) {
                  var r = this.input.charCodeAt(this.pos + 2);
                  if (r < 48 || r > 57) return this.finishOp(i.questionDot, 2);
                }
                if (t === 63) {
                  if (e >= 12) {
                    var s = this.input.charCodeAt(this.pos + 2);
                    if (s === 61) return this.finishOp(i.assign, 3);
                  }
                  return this.finishOp(i.coalesce, 2);
                }
              }
              return this.finishOp(i.question, 1);
            }, G.readToken_numberSign = function() {
              var e = this.options.ecmaVersion, t = 35;
              if (e >= 13 && (++this.pos, t = this.fullCharCodeAtPos(), v(t, true) || t === 92)) return this.finishToken(i.privateId, this.readWord1());
              this.raise(this.pos, "Unexpected character '" + Ye(t) + "'");
            }, G.getTokenFromCode = function(e) {
              switch (e) {
                case 46:
                  return this.readToken_dot();
                case 40:
                  return ++this.pos, this.finishToken(i.parenL);
                case 41:
                  return ++this.pos, this.finishToken(i.parenR);
                case 59:
                  return ++this.pos, this.finishToken(i.semi);
                case 44:
                  return ++this.pos, this.finishToken(i.comma);
                case 91:
                  return ++this.pos, this.finishToken(i.bracketL);
                case 93:
                  return ++this.pos, this.finishToken(i.bracketR);
                case 123:
                  return ++this.pos, this.finishToken(i.braceL);
                case 125:
                  return ++this.pos, this.finishToken(i.braceR);
                case 58:
                  return ++this.pos, this.finishToken(i.colon);
                case 96:
                  if (this.options.ecmaVersion < 6) break;
                  return ++this.pos, this.finishToken(i.backQuote);
                case 48:
                  var t = this.input.charCodeAt(this.pos + 1);
                  if (t === 120 || t === 88) return this.readRadixNumber(16);
                  if (this.options.ecmaVersion >= 6) {
                    if (t === 111 || t === 79) return this.readRadixNumber(8);
                    if (t === 98 || t === 66) return this.readRadixNumber(2);
                  }
                case 49:
                case 50:
                case 51:
                case 52:
                case 53:
                case 54:
                case 55:
                case 56:
                case 57:
                  return this.readNumber(false);
                case 34:
                case 39:
                  return this.readString(e);
                case 47:
                  return this.readToken_slash();
                case 37:
                case 42:
                  return this.readToken_mult_modulo_exp(e);
                case 124:
                case 38:
                  return this.readToken_pipe_amp(e);
                case 94:
                  return this.readToken_caret();
                case 43:
                case 45:
                  return this.readToken_plus_min(e);
                case 60:
                case 62:
                  return this.readToken_lt_gt(e);
                case 61:
                case 33:
                  return this.readToken_eq_excl(e);
                case 63:
                  return this.readToken_question();
                case 126:
                  return this.finishOp(i.prefix, 1);
                case 35:
                  return this.readToken_numberSign();
              }
              this.raise(this.pos, "Unexpected character '" + Ye(e) + "'");
            }, G.finishOp = function(e, t) {
              var r = this.input.slice(this.pos, this.pos + t);
              return this.pos += t, this.finishToken(e, r);
            }, G.readRegexp = function() {
              for (var e, t, r = this.pos; ; ) {
                this.pos >= this.input.length && this.raise(r, "Unterminated regular expression");
                var s = this.input.charAt(this.pos);
                if (_.test(s) && this.raise(r, "Unterminated regular expression"), e) e = false;
                else {
                  if (s === "[") t = true;
                  else if (s === "]" && t) t = false;
                  else if (s === "/" && !t) break;
                  e = s === "\\";
                }
                ++this.pos;
              }
              var a = this.input.slice(r, this.pos);
              ++this.pos;
              var h = this.pos, c = this.readWord1();
              this.containsEsc && this.unexpected(h);
              var d = this.regexpState || (this.regexpState = new de(this));
              d.reset(r, a, c), this.validateRegExpFlags(d), this.validateRegExpPattern(d);
              var x = null;
              try {
                x = new RegExp(a, c);
              } catch {
              }
              return this.finishToken(i.regexp, { pattern: a, flags: c, value: x });
            }, G.readInt = function(e, t, r) {
              for (var s = this.options.ecmaVersion >= 12 && t === void 0, a = r && this.input.charCodeAt(this.pos) === 48, h = this.pos, c = 0, d = 0, x = 0, U = t == null ? 1 / 0 : t; x < U; ++x, ++this.pos) {
                var W = this.input.charCodeAt(this.pos), re = void 0;
                if (s && W === 95) {
                  a && this.raiseRecoverable(this.pos, "Numeric separator is not allowed in legacy octal numeric literals"), d === 95 && this.raiseRecoverable(this.pos, "Numeric separator must be exactly one underscore"), x === 0 && this.raiseRecoverable(this.pos, "Numeric separator is not allowed at the first of digits"), d = W;
                  continue;
                }
                if (W >= 97 ? re = W - 97 + 10 : W >= 65 ? re = W - 65 + 10 : W >= 48 && W <= 57 ? re = W - 48 : re = 1 / 0, re >= e) break;
                d = W, c = c * e + re;
              }
              return s && d === 95 && this.raiseRecoverable(this.pos - 1, "Numeric separator is not allowed at the last of digits"), this.pos === h || t != null && this.pos - h !== t ? null : c;
            };
            function Qa(e, t) {
              return t ? parseInt(e, 8) : parseFloat(e.replace(/_/g, ""));
            }
            function Vr(e) {
              return typeof BigInt != "function" ? null : BigInt(e.replace(/_/g, ""));
            }
            G.readRadixNumber = function(e) {
              var t = this.pos;
              this.pos += 2;
              var r = this.readInt(e);
              return r == null && this.raise(this.start + 2, "Expected number in radix " + e), this.options.ecmaVersion >= 11 && this.input.charCodeAt(this.pos) === 110 ? (r = Vr(this.input.slice(t, this.pos)), ++this.pos) : v(this.fullCharCodeAtPos()) && this.raise(this.pos, "Identifier directly after number"), this.finishToken(i.num, r);
            }, G.readNumber = function(e) {
              var t = this.pos;
              !e && this.readInt(10, void 0, true) === null && this.raise(t, "Invalid number");
              var r = this.pos - t >= 2 && this.input.charCodeAt(t) === 48;
              r && this.strict && this.raise(t, "Invalid number");
              var s = this.input.charCodeAt(this.pos);
              if (!r && !e && this.options.ecmaVersion >= 11 && s === 110) {
                var a = Vr(this.input.slice(t, this.pos));
                return ++this.pos, v(this.fullCharCodeAtPos()) && this.raise(this.pos, "Identifier directly after number"), this.finishToken(i.num, a);
              }
              r && /[89]/.test(this.input.slice(t, this.pos)) && (r = false), s === 46 && !r && (++this.pos, this.readInt(10), s = this.input.charCodeAt(this.pos)), (s === 69 || s === 101) && !r && (s = this.input.charCodeAt(++this.pos), (s === 43 || s === 45) && ++this.pos, this.readInt(10) === null && this.raise(t, "Invalid number")), v(this.fullCharCodeAtPos()) && this.raise(this.pos, "Identifier directly after number");
              var h = Qa(this.input.slice(t, this.pos), r);
              return this.finishToken(i.num, h);
            }, G.readCodePoint = function() {
              var e = this.input.charCodeAt(this.pos), t;
              if (e === 123) {
                this.options.ecmaVersion < 6 && this.unexpected();
                var r = ++this.pos;
                t = this.readHexChar(this.input.indexOf("}", this.pos) - this.pos), ++this.pos, t > 1114111 && this.invalidStringToken(r, "Code point out of bounds");
              } else t = this.readHexChar(4);
              return t;
            };
            function Ye(e) {
              return e <= 65535 ? String.fromCharCode(e) : (e -= 65536, String.fromCharCode((e >> 10) + 55296, (e & 1023) + 56320));
            }
            G.readString = function(e) {
              for (var t = "", r = ++this.pos; ; ) {
                this.pos >= this.input.length && this.raise(this.start, "Unterminated string constant");
                var s = this.input.charCodeAt(this.pos);
                if (s === e) break;
                s === 92 ? (t += this.input.slice(r, this.pos), t += this.readEscapedChar(false), r = this.pos) : s === 8232 || s === 8233 ? (this.options.ecmaVersion < 10 && this.raise(this.start, "Unterminated string constant"), ++this.pos, this.options.locations && (this.curLine++, this.lineStart = this.pos)) : (M(s) && this.raise(this.start, "Unterminated string constant"), ++this.pos);
              }
              return t += this.input.slice(r, this.pos++), this.finishToken(i.string, t);
            };
            var Rr = {};
            G.tryReadTemplateToken = function() {
              this.inTemplateElement = true;
              try {
                this.readTmplToken();
              } catch (e) {
                if (e === Rr) this.readInvalidTemplateToken();
                else throw e;
              }
              this.inTemplateElement = false;
            }, G.invalidStringToken = function(e, t) {
              if (this.inTemplateElement && this.options.ecmaVersion >= 9) throw Rr;
              this.raise(e, t);
            }, G.readTmplToken = function() {
              for (var e = "", t = this.pos; ; ) {
                this.pos >= this.input.length && this.raise(this.start, "Unterminated template");
                var r = this.input.charCodeAt(this.pos);
                if (r === 96 || r === 36 && this.input.charCodeAt(this.pos + 1) === 123) return this.pos === this.start && (this.type === i.template || this.type === i.invalidTemplate) ? r === 36 ? (this.pos += 2, this.finishToken(i.dollarBraceL)) : (++this.pos, this.finishToken(i.backQuote)) : (e += this.input.slice(t, this.pos), this.finishToken(i.template, e));
                if (r === 92) e += this.input.slice(t, this.pos), e += this.readEscapedChar(true), t = this.pos;
                else if (M(r)) {
                  switch (e += this.input.slice(t, this.pos), ++this.pos, r) {
                    case 13:
                      this.input.charCodeAt(this.pos) === 10 && ++this.pos;
                    case 10:
                      e += `
`;
                      break;
                    default:
                      e += String.fromCharCode(r);
                      break;
                  }
                  this.options.locations && (++this.curLine, this.lineStart = this.pos), t = this.pos;
                } else ++this.pos;
              }
            }, G.readInvalidTemplateToken = function() {
              for (; this.pos < this.input.length; this.pos++) switch (this.input[this.pos]) {
                case "\\":
                  ++this.pos;
                  break;
                case "$":
                  if (this.input[this.pos + 1] !== "{") break;
                case "`":
                  return this.finishToken(i.invalidTemplate, this.input.slice(this.start, this.pos));
              }
              this.raise(this.start, "Unterminated template");
            }, G.readEscapedChar = function(e) {
              var t = this.input.charCodeAt(++this.pos);
              switch (++this.pos, t) {
                case 110:
                  return `
`;
                case 114:
                  return "\r";
                case 120:
                  return String.fromCharCode(this.readHexChar(2));
                case 117:
                  return Ye(this.readCodePoint());
                case 116:
                  return "	";
                case 98:
                  return "\b";
                case 118:
                  return "\v";
                case 102:
                  return "\f";
                case 13:
                  this.input.charCodeAt(this.pos) === 10 && ++this.pos;
                case 10:
                  return this.options.locations && (this.lineStart = this.pos, ++this.curLine), "";
                case 56:
                case 57:
                  if (this.strict && this.invalidStringToken(this.pos - 1, "Invalid escape sequence"), e) {
                    var r = this.pos - 1;
                    return this.invalidStringToken(r, "Invalid escape sequence in template string"), null;
                  }
                default:
                  if (t >= 48 && t <= 55) {
                    var s = this.input.substr(this.pos - 1, 3).match(/^[0-7]+/)[0], a = parseInt(s, 8);
                    return a > 255 && (s = s.slice(0, -1), a = parseInt(s, 8)), this.pos += s.length - 1, t = this.input.charCodeAt(this.pos), (s !== "0" || t === 56 || t === 57) && (this.strict || e) && this.invalidStringToken(this.pos - 1 - s.length, e ? "Octal literal in template string" : "Octal literal in strict mode"), String.fromCharCode(a);
                  }
                  return M(t) ? "" : String.fromCharCode(t);
              }
            }, G.readHexChar = function(e) {
              var t = this.pos, r = this.readInt(16, e);
              return r === null && this.invalidStringToken(t, "Bad character escape sequence"), r;
            }, G.readWord1 = function() {
              this.containsEsc = false;
              for (var e = "", t = true, r = this.pos, s = this.options.ecmaVersion >= 6; this.pos < this.input.length; ) {
                var a = this.fullCharCodeAtPos();
                if (q(a, s)) this.pos += a <= 65535 ? 1 : 2;
                else if (a === 92) {
                  this.containsEsc = true, e += this.input.slice(r, this.pos);
                  var h = this.pos;
                  this.input.charCodeAt(++this.pos) !== 117 && this.invalidStringToken(this.pos, "Expecting Unicode escape sequence \\uXXXX"), ++this.pos;
                  var c = this.readCodePoint();
                  (t ? v : q)(c, s) || this.invalidStringToken(h, "Invalid Unicode escape"), e += Ye(c), r = this.pos;
                } else break;
                t = false;
              }
              return e + this.input.slice(r, this.pos);
            }, G.readWord = function() {
              var e = this.readWord1(), t = i.name;
              return this.keywords.test(e) && (t = H[e]), this.finishToken(t, e);
            };
            var jr = "8.7.0";
            Z.acorn = { Parser: Z, version: jr, defaultOptions: me, Position: K, SourceLocation: X, getLineInfo: oe, Node: Ve, TokenType: B, tokTypes: i, keywordTypes: H, TokContext: ne, tokContexts: Q, isIdentifierChar: q, isIdentifierStart: v, Token: Je, isNewLine: M, lineBreak: _, lineBreakG: P, nonASCIIwhitespace: ae };
            function Za(e, t) {
              return Z.parse(e, t);
            }
            function $a(e, t, r) {
              return Z.parseExpressionAt(e, t, r);
            }
            function en(e, t) {
              return Z.tokenizer(e, t);
            }
            u.Node = Ve, u.Parser = Z, u.Position = K, u.SourceLocation = X, u.TokContext = ne, u.Token = Je, u.TokenType = B, u.defaultOptions = me, u.getLineInfo = oe, u.isIdentifierChar = q, u.isIdentifierStart = v, u.isNewLine = M, u.keywordTypes = H, u.lineBreak = _, u.lineBreakG = P, u.nonASCIIwhitespace = ae, u.parse = Za, u.parseExpressionAt = $a, u.tokContexts = Q, u.tokTypes = i, u.tokenizer = en, u.version = jr, Object.defineProperty(u, "__esModule", { value: true });
          });
        } }), Sh = Y({ "node_modules/acorn-jsx/xhtml.js"(n, o) {
          J(), o.exports = { quot: '"', amp: "&", apos: "'", lt: "<", gt: ">", nbsp: "\xA0", iexcl: "\xA1", cent: "\xA2", pound: "\xA3", curren: "\xA4", yen: "\xA5", brvbar: "\xA6", sect: "\xA7", uml: "\xA8", copy: "\xA9", ordf: "\xAA", laquo: "\xAB", not: "\xAC", shy: "\xAD", reg: "\xAE", macr: "\xAF", deg: "\xB0", plusmn: "\xB1", sup2: "\xB2", sup3: "\xB3", acute: "\xB4", micro: "\xB5", para: "\xB6", middot: "\xB7", cedil: "\xB8", sup1: "\xB9", ordm: "\xBA", raquo: "\xBB", frac14: "\xBC", frac12: "\xBD", frac34: "\xBE", iquest: "\xBF", Agrave: "\xC0", Aacute: "\xC1", Acirc: "\xC2", Atilde: "\xC3", Auml: "\xC4", Aring: "\xC5", AElig: "\xC6", Ccedil: "\xC7", Egrave: "\xC8", Eacute: "\xC9", Ecirc: "\xCA", Euml: "\xCB", Igrave: "\xCC", Iacute: "\xCD", Icirc: "\xCE", Iuml: "\xCF", ETH: "\xD0", Ntilde: "\xD1", Ograve: "\xD2", Oacute: "\xD3", Ocirc: "\xD4", Otilde: "\xD5", Ouml: "\xD6", times: "\xD7", Oslash: "\xD8", Ugrave: "\xD9", Uacute: "\xDA", Ucirc: "\xDB", Uuml: "\xDC", Yacute: "\xDD", THORN: "\xDE", szlig: "\xDF", agrave: "\xE0", aacute: "\xE1", acirc: "\xE2", atilde: "\xE3", auml: "\xE4", aring: "\xE5", aelig: "\xE6", ccedil: "\xE7", egrave: "\xE8", eacute: "\xE9", ecirc: "\xEA", euml: "\xEB", igrave: "\xEC", iacute: "\xED", icirc: "\xEE", iuml: "\xEF", eth: "\xF0", ntilde: "\xF1", ograve: "\xF2", oacute: "\xF3", ocirc: "\xF4", otilde: "\xF5", ouml: "\xF6", divide: "\xF7", oslash: "\xF8", ugrave: "\xF9", uacute: "\xFA", ucirc: "\xFB", uuml: "\xFC", yacute: "\xFD", thorn: "\xFE", yuml: "\xFF", OElig: "\u0152", oelig: "\u0153", Scaron: "\u0160", scaron: "\u0161", Yuml: "\u0178", fnof: "\u0192", circ: "\u02C6", tilde: "\u02DC", Alpha: "\u0391", Beta: "\u0392", Gamma: "\u0393", Delta: "\u0394", Epsilon: "\u0395", Zeta: "\u0396", Eta: "\u0397", Theta: "\u0398", Iota: "\u0399", Kappa: "\u039A", Lambda: "\u039B", Mu: "\u039C", Nu: "\u039D", Xi: "\u039E", Omicron: "\u039F", Pi: "\u03A0", Rho: "\u03A1", Sigma: "\u03A3", Tau: "\u03A4", Upsilon: "\u03A5", Phi: "\u03A6", Chi: "\u03A7", Psi: "\u03A8", Omega: "\u03A9", alpha: "\u03B1", beta: "\u03B2", gamma: "\u03B3", delta: "\u03B4", epsilon: "\u03B5", zeta: "\u03B6", eta: "\u03B7", theta: "\u03B8", iota: "\u03B9", kappa: "\u03BA", lambda: "\u03BB", mu: "\u03BC", nu: "\u03BD", xi: "\u03BE", omicron: "\u03BF", pi: "\u03C0", rho: "\u03C1", sigmaf: "\u03C2", sigma: "\u03C3", tau: "\u03C4", upsilon: "\u03C5", phi: "\u03C6", chi: "\u03C7", psi: "\u03C8", omega: "\u03C9", thetasym: "\u03D1", upsih: "\u03D2", piv: "\u03D6", ensp: "\u2002", emsp: "\u2003", thinsp: "\u2009", zwnj: "\u200C", zwj: "\u200D", lrm: "\u200E", rlm: "\u200F", ndash: "\u2013", mdash: "\u2014", lsquo: "\u2018", rsquo: "\u2019", sbquo: "\u201A", ldquo: "\u201C", rdquo: "\u201D", bdquo: "\u201E", dagger: "\u2020", Dagger: "\u2021", bull: "\u2022", hellip: "\u2026", permil: "\u2030", prime: "\u2032", Prime: "\u2033", lsaquo: "\u2039", rsaquo: "\u203A", oline: "\u203E", frasl: "\u2044", euro: "\u20AC", image: "\u2111", weierp: "\u2118", real: "\u211C", trade: "\u2122", alefsym: "\u2135", larr: "\u2190", uarr: "\u2191", rarr: "\u2192", darr: "\u2193", harr: "\u2194", crarr: "\u21B5", lArr: "\u21D0", uArr: "\u21D1", rArr: "\u21D2", dArr: "\u21D3", hArr: "\u21D4", forall: "\u2200", part: "\u2202", exist: "\u2203", empty: "\u2205", nabla: "\u2207", isin: "\u2208", notin: "\u2209", ni: "\u220B", prod: "\u220F", sum: "\u2211", minus: "\u2212", lowast: "\u2217", radic: "\u221A", prop: "\u221D", infin: "\u221E", ang: "\u2220", and: "\u2227", or: "\u2228", cap: "\u2229", cup: "\u222A", int: "\u222B", there4: "\u2234", sim: "\u223C", cong: "\u2245", asymp: "\u2248", ne: "\u2260", equiv: "\u2261", le: "\u2264", ge: "\u2265", sub: "\u2282", sup: "\u2283", nsub: "\u2284", sube: "\u2286", supe: "\u2287", oplus: "\u2295", otimes: "\u2297", perp: "\u22A5", sdot: "\u22C5", lceil: "\u2308", rceil: "\u2309", lfloor: "\u230A", rfloor: "\u230B", lang: "\u2329", rang: "\u232A", loz: "\u25CA", spades: "\u2660", clubs: "\u2663", hearts: "\u2665", diams: "\u2666" };
        } }), Pa = Y({ "node_modules/acorn-jsx/index.js"(n, o) {
          "use strict";
          J();
          var u = Sh(), l = /^[\da-fA-F]+$/, m = /^\d+$/, E = /* @__PURE__ */ new WeakMap();
          function y(g) {
            g = g.Parser.acorn || g;
            let V = E.get(g);
            if (!V) {
              let R = g.tokTypes, N = g.TokContext, T = g.TokenType, v = new N("<tag", false), q = new N("</tag", false), B = new N("<tag>...</tag>", true, true), I = { tc_oTag: v, tc_cTag: q, tc_expr: B }, k = { jsxName: new T("jsxName"), jsxText: new T("jsxText", { beforeExpr: true }), jsxTagStart: new T("jsxTagStart", { startsExpr: true }), jsxTagEnd: new T("jsxTagEnd") };
              k.jsxTagStart.updateContext = function() {
                this.context.push(B), this.context.push(v), this.exprAllowed = false;
              }, k.jsxTagEnd.updateContext = function(C) {
                let H = this.context.pop();
                H === v && C === R.slash || H === q ? (this.context.pop(), this.exprAllowed = this.curContext() === B) : this.exprAllowed = true;
              }, V = { tokContexts: I, tokTypes: k }, E.set(g, V);
            }
            return V;
          }
          function A(g) {
            if (!g) return g;
            if (g.type === "JSXIdentifier") return g.name;
            if (g.type === "JSXNamespacedName") return g.namespace.name + ":" + g.name.name;
            if (g.type === "JSXMemberExpression") return A(g.object) + "." + A(g.property);
          }
          o.exports = function(g) {
            return g = g || {}, function(V) {
              return b({ allowNamespaces: g.allowNamespaces !== false, allowNamespacedObjects: !!g.allowNamespacedObjects }, V);
            };
          }, Object.defineProperty(o.exports, "tokTypes", { get: function() {
            return y(ct()).tokTypes;
          }, configurable: true, enumerable: true });
          function b(g, V) {
            let R = V.acorn || ct(), N = y(R), T = R.tokTypes, v = N.tokTypes, q = R.tokContexts, B = N.tokContexts.tc_oTag, I = N.tokContexts.tc_cTag, k = N.tokContexts.tc_expr, C = R.isNewLine, H = R.isIdentifierStart, L = R.isIdentifierChar;
            return class extends V {
              static get acornJsx() {
                return N;
              }
              jsx_readToken() {
                let i = "", _ = this.pos;
                for (; ; ) {
                  this.pos >= this.input.length && this.raise(this.start, "Unterminated JSX contents");
                  let P = this.input.charCodeAt(this.pos);
                  switch (P) {
                    case 60:
                    case 123:
                      return this.pos === this.start ? P === 60 && this.exprAllowed ? (++this.pos, this.finishToken(v.jsxTagStart)) : this.getTokenFromCode(P) : (i += this.input.slice(_, this.pos), this.finishToken(v.jsxText, i));
                    case 38:
                      i += this.input.slice(_, this.pos), i += this.jsx_readEntity(), _ = this.pos;
                      break;
                    case 62:
                    case 125:
                      this.raise(this.pos, "Unexpected token `" + this.input[this.pos] + "`. Did you mean `" + (P === 62 ? "&gt;" : "&rbrace;") + '` or `{"' + this.input[this.pos] + '"}`?');
                    default:
                      C(P) ? (i += this.input.slice(_, this.pos), i += this.jsx_readNewLine(true), _ = this.pos) : ++this.pos;
                  }
                }
              }
              jsx_readNewLine(i) {
                let _ = this.input.charCodeAt(this.pos), P;
                return ++this.pos, _ === 13 && this.input.charCodeAt(this.pos) === 10 ? (++this.pos, P = i ? `
` : `\r
`) : P = String.fromCharCode(_), this.options.locations && (++this.curLine, this.lineStart = this.pos), P;
              }
              jsx_readString(i) {
                let _ = "", P = ++this.pos;
                for (; ; ) {
                  this.pos >= this.input.length && this.raise(this.start, "Unterminated string constant");
                  let M = this.input.charCodeAt(this.pos);
                  if (M === i) break;
                  M === 38 ? (_ += this.input.slice(P, this.pos), _ += this.jsx_readEntity(), P = this.pos) : C(M) ? (_ += this.input.slice(P, this.pos), _ += this.jsx_readNewLine(false), P = this.pos) : ++this.pos;
                }
                return _ += this.input.slice(P, this.pos++), this.finishToken(T.string, _);
              }
              jsx_readEntity() {
                let i = "", _ = 0, P, M = this.input[this.pos];
                M !== "&" && this.raise(this.pos, "Entity must start with an ampersand");
                let ee = ++this.pos;
                for (; this.pos < this.input.length && _++ < 10; ) {
                  if (M = this.input[this.pos++], M === ";") {
                    i[0] === "#" ? i[1] === "x" ? (i = i.substr(2), l.test(i) && (P = String.fromCharCode(parseInt(i, 16)))) : (i = i.substr(1), m.test(i) && (P = String.fromCharCode(parseInt(i, 10)))) : P = u[i];
                    break;
                  }
                  i += M;
                }
                return P || (this.pos = ee, "&");
              }
              jsx_readWord() {
                let i, _ = this.pos;
                do
                  i = this.input.charCodeAt(++this.pos);
                while (L(i) || i === 45);
                return this.finishToken(v.jsxName, this.input.slice(_, this.pos));
              }
              jsx_parseIdentifier() {
                let i = this.startNode();
                return this.type === v.jsxName ? i.name = this.value : this.type.keyword ? i.name = this.type.keyword : this.unexpected(), this.next(), this.finishNode(i, "JSXIdentifier");
              }
              jsx_parseNamespacedName() {
                let i = this.start, _ = this.startLoc, P = this.jsx_parseIdentifier();
                if (!g.allowNamespaces || !this.eat(T.colon)) return P;
                var M = this.startNodeAt(i, _);
                return M.namespace = P, M.name = this.jsx_parseIdentifier(), this.finishNode(M, "JSXNamespacedName");
              }
              jsx_parseElementName() {
                if (this.type === v.jsxTagEnd) return "";
                let i = this.start, _ = this.startLoc, P = this.jsx_parseNamespacedName();
                for (this.type === T.dot && P.type === "JSXNamespacedName" && !g.allowNamespacedObjects && this.unexpected(); this.eat(T.dot); ) {
                  let M = this.startNodeAt(i, _);
                  M.object = P, M.property = this.jsx_parseIdentifier(), P = this.finishNode(M, "JSXMemberExpression");
                }
                return P;
              }
              jsx_parseAttributeValue() {
                switch (this.type) {
                  case T.braceL:
                    let i = this.jsx_parseExpressionContainer();
                    return i.expression.type === "JSXEmptyExpression" && this.raise(i.start, "JSX attributes must only be assigned a non-empty expression"), i;
                  case v.jsxTagStart:
                  case T.string:
                    return this.parseExprAtom();
                  default:
                    this.raise(this.start, "JSX value should be either an expression or a quoted JSX text");
                }
              }
              jsx_parseEmptyExpression() {
                let i = this.startNodeAt(this.lastTokEnd, this.lastTokEndLoc);
                return this.finishNodeAt(i, "JSXEmptyExpression", this.start, this.startLoc);
              }
              jsx_parseExpressionContainer() {
                let i = this.startNode();
                return this.next(), i.expression = this.type === T.braceR ? this.jsx_parseEmptyExpression() : this.parseExpression(), this.expect(T.braceR), this.finishNode(i, "JSXExpressionContainer");
              }
              jsx_parseAttribute() {
                let i = this.startNode();
                return this.eat(T.braceL) ? (this.expect(T.ellipsis), i.argument = this.parseMaybeAssign(), this.expect(T.braceR), this.finishNode(i, "JSXSpreadAttribute")) : (i.name = this.jsx_parseNamespacedName(), i.value = this.eat(T.eq) ? this.jsx_parseAttributeValue() : null, this.finishNode(i, "JSXAttribute"));
              }
              jsx_parseOpeningElementAt(i, _) {
                let P = this.startNodeAt(i, _);
                P.attributes = [];
                let M = this.jsx_parseElementName();
                for (M && (P.name = M); this.type !== T.slash && this.type !== v.jsxTagEnd; ) P.attributes.push(this.jsx_parseAttribute());
                return P.selfClosing = this.eat(T.slash), this.expect(v.jsxTagEnd), this.finishNode(P, M ? "JSXOpeningElement" : "JSXOpeningFragment");
              }
              jsx_parseClosingElementAt(i, _) {
                let P = this.startNodeAt(i, _), M = this.jsx_parseElementName();
                return M && (P.name = M), this.expect(v.jsxTagEnd), this.finishNode(P, M ? "JSXClosingElement" : "JSXClosingFragment");
              }
              jsx_parseElementAt(i, _) {
                let P = this.startNodeAt(i, _), M = [], ee = this.jsx_parseOpeningElementAt(i, _), ae = null;
                if (!ee.selfClosing) {
                  e: for (; ; ) switch (this.type) {
                    case v.jsxTagStart:
                      if (i = this.start, _ = this.startLoc, this.next(), this.eat(T.slash)) {
                        ae = this.jsx_parseClosingElementAt(i, _);
                        break e;
                      }
                      M.push(this.jsx_parseElementAt(i, _));
                      break;
                    case v.jsxText:
                      M.push(this.parseExprAtom());
                      break;
                    case T.braceL:
                      M.push(this.jsx_parseExpressionContainer());
                      break;
                    default:
                      this.unexpected();
                  }
                  A(ae.name) !== A(ee.name) && this.raise(ae.start, "Expected corresponding JSX closing tag for <" + A(ee.name) + ">");
                }
                let te = ee.name ? "Element" : "Fragment";
                return P["opening" + te] = ee, P["closing" + te] = ae, P.children = M, this.type === T.relational && this.value === "<" && this.raise(this.start, "Adjacent JSX elements must be wrapped in an enclosing tag"), this.finishNode(P, "JSX" + te);
              }
              jsx_parseText() {
                let i = this.parseLiteral(this.value);
                return i.type = "JSXText", i;
              }
              jsx_parseElement() {
                let i = this.start, _ = this.startLoc;
                return this.next(), this.jsx_parseElementAt(i, _);
              }
              parseExprAtom(i) {
                return this.type === v.jsxText ? this.jsx_parseText() : this.type === v.jsxTagStart ? this.jsx_parseElement() : super.parseExprAtom(i);
              }
              readToken(i) {
                let _ = this.curContext();
                if (_ === k) return this.jsx_readToken();
                if (_ === B || _ === I) {
                  if (H(i)) return this.jsx_readWord();
                  if (i == 62) return ++this.pos, this.finishToken(v.jsxTagEnd);
                  if ((i === 34 || i === 39) && _ == B) return this.jsx_readString(i);
                }
                return i === 60 && this.exprAllowed && this.input.charCodeAt(this.pos + 1) !== 33 ? (++this.pos, this.finishToken(v.jsxTagStart)) : super.readToken(i);
              }
              updateContext(i) {
                if (this.type == T.braceL) {
                  var _ = this.curContext();
                  _ == B ? this.context.push(q.b_expr) : _ == k ? this.context.push(q.b_tmpl) : super.updateContext(i), this.exprAllowed = true;
                } else if (this.type === T.slash && i === v.jsxTagStart) this.context.length -= 2, this.context.push(I), this.exprAllowed = false;
                else return super.updateContext(i);
              }
            };
          }
        } }), wh = Y({ "src/language-js/parse/acorn.js"(n, o) {
          "use strict";
          J();
          var u = lr(), l = fa(), m = Fa(), E = Ia(), y = { ecmaVersion: "latest", sourceType: "module", allowReserved: true, allowReturnOutsideFunction: true, allowImportExportEverywhere: true, allowAwaitOutsideFunction: true, allowSuperOutsideMethod: true, allowHashBang: true, locations: true, ranges: true };
          function A(N) {
            let { message: T, loc: v } = N;
            if (!v) return N;
            let { line: q, column: B } = v;
            return u(T.replace(/ \(\d+:\d+\)$/, ""), { start: { line: q, column: B + 1 } });
          }
          var b, g = () => {
            if (!b) {
              let { Parser: N } = ct(), T = Pa();
              b = N.extend(T());
            }
            return b;
          };
          function V(N, T) {
            let v = g(), q = [], B = [], I = v.parse(N, Object.assign(Object.assign({}, y), {}, { sourceType: T, onComment: q, onToken: B }));
            return I.comments = q, I.tokens = B, I;
          }
          function R(N, T) {
            let v = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, { result: q, error: B } = l(() => V(N, "module"), () => V(N, "script"));
            if (!q) throw A(B);
            return v.originalText = N, E(q, v);
          }
          o.exports = m(R);
        } }), kh = Y({ "src/language-js/parse/utils/replace-hashbang.js"(n, o) {
          "use strict";
          J();
          function u(l) {
            return l.charAt(0) === "#" && l.charAt(1) === "!" ? "//" + l.slice(2) : l;
          }
          o.exports = u;
        } }), Fh = Y({ "node_modules/espree/dist/espree.cjs"(n) {
          "use strict";
          J(), Object.defineProperty(n, "__esModule", { value: true });
          var o = ct(), u = Pa(), l;
          function m(p) {
            return p && typeof p == "object" && "default" in p ? p : { default: p };
          }
          function E(p) {
            if (p && p.__esModule) return p;
            var D = /* @__PURE__ */ Object.create(null);
            return p && Object.keys(p).forEach(function(w) {
              if (w !== "default") {
                var f = Object.getOwnPropertyDescriptor(p, w);
                Object.defineProperty(D, w, f.get ? f : { enumerable: true, get: function() {
                  return p[w];
                } });
              }
            }), D.default = p, Object.freeze(D);
          }
          var y = E(o), A = m(u), b = E(l), g = { Boolean: "Boolean", EOF: "<end>", Identifier: "Identifier", PrivateIdentifier: "PrivateIdentifier", Keyword: "Keyword", Null: "Null", Numeric: "Numeric", Punctuator: "Punctuator", String: "String", RegularExpression: "RegularExpression", Template: "Template", JSXIdentifier: "JSXIdentifier", JSXText: "JSXText" };
          function V(p, D) {
            let w = p[0], f = p[p.length - 1], F = { type: g.Template, value: D.slice(w.start, f.end) };
            return w.loc && (F.loc = { start: w.loc.start, end: f.loc.end }), w.range && (F.start = w.range[0], F.end = f.range[1], F.range = [F.start, F.end]), F;
          }
          function R(p, D) {
            this._acornTokTypes = p, this._tokens = [], this._curlyBrace = null, this._code = D;
          }
          R.prototype = { constructor: R, translate(p, D) {
            let w = p.type, f = this._acornTokTypes;
            if (w === f.name) p.type = g.Identifier, p.value === "static" && (p.type = g.Keyword), D.ecmaVersion > 5 && (p.value === "yield" || p.value === "let") && (p.type = g.Keyword);
            else if (w === f.privateId) p.type = g.PrivateIdentifier;
            else if (w === f.semi || w === f.comma || w === f.parenL || w === f.parenR || w === f.braceL || w === f.braceR || w === f.dot || w === f.bracketL || w === f.colon || w === f.question || w === f.bracketR || w === f.ellipsis || w === f.arrow || w === f.jsxTagStart || w === f.incDec || w === f.starstar || w === f.jsxTagEnd || w === f.prefix || w === f.questionDot || w.binop && !w.keyword || w.isAssign) p.type = g.Punctuator, p.value = this._code.slice(p.start, p.end);
            else if (w === f.jsxName) p.type = g.JSXIdentifier;
            else if (w.label === "jsxText" || w === f.jsxAttrValueToken) p.type = g.JSXText;
            else if (w.keyword) w.keyword === "true" || w.keyword === "false" ? p.type = g.Boolean : w.keyword === "null" ? p.type = g.Null : p.type = g.Keyword;
            else if (w === f.num) p.type = g.Numeric, p.value = this._code.slice(p.start, p.end);
            else if (w === f.string) D.jsxAttrValueToken ? (D.jsxAttrValueToken = false, p.type = g.JSXText) : p.type = g.String, p.value = this._code.slice(p.start, p.end);
            else if (w === f.regexp) {
              p.type = g.RegularExpression;
              let F = p.value;
              p.regex = { flags: F.flags, pattern: F.pattern }, p.value = "/".concat(F.pattern, "/").concat(F.flags);
            }
            return p;
          }, onToken(p, D) {
            let w = this, f = this._acornTokTypes, F = D.tokens, K = this._tokens;
            function X() {
              F.push(V(w._tokens, w._code)), w._tokens = [];
            }
            if (p.type === f.eof) {
              this._curlyBrace && F.push(this.translate(this._curlyBrace, D));
              return;
            }
            if (p.type === f.backQuote) {
              this._curlyBrace && (F.push(this.translate(this._curlyBrace, D)), this._curlyBrace = null), K.push(p), K.length > 1 && X();
              return;
            }
            if (p.type === f.dollarBraceL) {
              K.push(p), X();
              return;
            }
            if (p.type === f.braceR) {
              this._curlyBrace && F.push(this.translate(this._curlyBrace, D)), this._curlyBrace = p;
              return;
            }
            if (p.type === f.template || p.type === f.invalidTemplate) {
              this._curlyBrace && (K.push(this._curlyBrace), this._curlyBrace = null), K.push(p);
              return;
            }
            this._curlyBrace && (F.push(this.translate(this._curlyBrace, D)), this._curlyBrace = null), F.push(this.translate(p, D));
          } };
          var N = [3, 5, 6, 7, 8, 9, 10, 11, 12, 13];
          function T() {
            return N[N.length - 1];
          }
          function v() {
            return [...N];
          }
          function q() {
            let p = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 5, D = p === "latest" ? T() : p;
            if (typeof D != "number") throw new Error('ecmaVersion must be a number or "latest". Received value of type '.concat(typeof p, " instead."));
            if (D >= 2015 && (D -= 2009), !N.includes(D)) throw new Error("Invalid ecmaVersion.");
            return D;
          }
          function B() {
            let p = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : "script";
            if (p === "script" || p === "module") return p;
            if (p === "commonjs") return "script";
            throw new Error("Invalid sourceType.");
          }
          function I(p) {
            let D = q(p.ecmaVersion), w = B(p.sourceType), f = p.range === true, F = p.loc === true;
            if (D !== 3 && p.allowReserved) throw new Error("`allowReserved` is only supported when ecmaVersion is 3");
            if (typeof p.allowReserved < "u" && typeof p.allowReserved != "boolean") throw new Error("`allowReserved`, when present, must be `true` or `false`");
            let K = D === 3 ? p.allowReserved || "never" : false, X = p.ecmaFeatures || {}, oe = p.sourceType === "commonjs" || Boolean(X.globalReturn);
            if (w === "module" && D < 6) throw new Error("sourceType 'module' is not supported when ecmaVersion < 2015. Consider adding `{ ecmaVersion: 2015 }` to the parser options.");
            return Object.assign({}, p, { ecmaVersion: D, sourceType: w, ranges: f, locations: F, allowReserved: K, allowReturnOutsideFunction: oe });
          }
          var k = Symbol("espree's internal state"), C = Symbol("espree's esprimaFinishNode");
          function H(p, D, w, f, F, K) {
            let X = { type: p ? "Block" : "Line", value: D };
            return typeof w == "number" && (X.start = w, X.end = f, X.range = [w, f]), typeof F == "object" && (X.loc = { start: F, end: K }), X;
          }
          var L = () => (p) => {
            let D = Object.assign({}, p.acorn.tokTypes);
            return p.acornJsx && Object.assign(D, p.acornJsx.tokTypes), class extends p {
              constructor(f, F) {
                (typeof f != "object" || f === null) && (f = {}), typeof F != "string" && !(F instanceof String) && (F = String(F));
                let K = f.sourceType, X = I(f), oe = X.ecmaFeatures || {}, me = X.tokens === true ? new R(D, F) : null;
                super({ ecmaVersion: X.ecmaVersion, sourceType: X.sourceType, ranges: X.ranges, locations: X.locations, allowReserved: X.allowReserved, allowReturnOutsideFunction: X.allowReturnOutsideFunction, onToken: (ve) => {
                  me && me.onToken(ve, this[k]), ve.type !== D.eof && (this[k].lastToken = ve);
                }, onComment: (ve, pt, ft, Ee, ge, De) => {
                  if (this[k].comments) {
                    let Ue = H(ve, pt, ft, Ee, ge, De);
                    this[k].comments.push(Ue);
                  }
                } }, F), this[k] = { originalSourceType: K || X.sourceType, tokens: me ? [] : null, comments: X.comment === true ? [] : null, impliedStrict: oe.impliedStrict === true && this.options.ecmaVersion >= 5, ecmaVersion: this.options.ecmaVersion, jsxAttrValueToken: false, lastToken: null, templateElements: [] };
              }
              tokenize() {
                do
                  this.next();
                while (this.type !== D.eof);
                this.next();
                let f = this[k], F = f.tokens;
                return f.comments && (F.comments = f.comments), F;
              }
              finishNode() {
                let f = super.finishNode(...arguments);
                return this[C](f);
              }
              finishNodeAt() {
                let f = super.finishNodeAt(...arguments);
                return this[C](f);
              }
              parse() {
                let f = this[k], F = super.parse();
                if (F.sourceType = f.originalSourceType, f.comments && (F.comments = f.comments), f.tokens && (F.tokens = f.tokens), F.body.length) {
                  let [K] = F.body;
                  F.range && (F.range[0] = K.range[0]), F.loc && (F.loc.start = K.loc.start), F.start = K.start;
                }
                return f.lastToken && (F.range && (F.range[1] = f.lastToken.range[1]), F.loc && (F.loc.end = f.lastToken.loc.end), F.end = f.lastToken.end), this[k].templateElements.forEach((K) => {
                  let oe = K.tail ? 1 : 2;
                  K.start += -1, K.end += oe, K.range && (K.range[0] += -1, K.range[1] += oe), K.loc && (K.loc.start.column += -1, K.loc.end.column += oe);
                }), F;
              }
              parseTopLevel(f) {
                return this[k].impliedStrict && (this.strict = true), super.parseTopLevel(f);
              }
              raise(f, F) {
                let K = p.acorn.getLineInfo(this.input, f), X = new SyntaxError(F);
                throw X.index = f, X.lineNumber = K.line, X.column = K.column + 1, X;
              }
              raiseRecoverable(f, F) {
                this.raise(f, F);
              }
              unexpected(f) {
                let F = "Unexpected token";
                if (f != null) {
                  if (this.pos = f, this.options.locations) for (; this.pos < this.lineStart; ) this.lineStart = this.input.lastIndexOf(`
`, this.lineStart - 2) + 1, --this.curLine;
                  this.nextToken();
                }
                this.end > this.start && (F += " ".concat(this.input.slice(this.start, this.end))), this.raise(this.start, F);
              }
              jsx_readString(f) {
                let F = super.jsx_readString(f);
                return this.type === D.string && (this[k].jsxAttrValueToken = true), F;
              }
              [C](f) {
                return f.type === "TemplateElement" && this[k].templateElements.push(f), f.type.includes("Function") && !f.generator && (f.generator = false), f;
              }
            };
          }, i = "9.3.1", _ = { _regular: null, _jsx: null, get regular() {
            return this._regular === null && (this._regular = y.Parser.extend(L())), this._regular;
          }, get jsx() {
            return this._jsx === null && (this._jsx = y.Parser.extend(A.default(), L())), this._jsx;
          }, get(p) {
            return Boolean(p && p.ecmaFeatures && p.ecmaFeatures.jsx) ? this.jsx : this.regular;
          } };
          function P(p, D) {
            let w = _.get(D);
            return (!D || D.tokens !== true) && (D = Object.assign({}, D, { tokens: true })), new w(D, p).tokenize();
          }
          function M(p, D) {
            let w = _.get(D);
            return new w(D, p).parse();
          }
          var ee = i, ae = function() {
            return b.KEYS;
          }(), te = void 0, ie = T(), Ne = v();
          n.Syntax = te, n.VisitorKeys = ae, n.latestEcmaVersion = ie, n.parse = M, n.supportedEcmaVersions = Ne, n.tokenize = P, n.version = ee;
        } }), Bh = Y({ "src/language-js/parse/espree.js"(n, o) {
          "use strict";
          J();
          var u = lr(), l = fa(), m = Fa(), E = kh(), y = Ia(), A = { ecmaVersion: "latest", range: true, loc: true, comment: true, tokens: true, sourceType: "module", ecmaFeatures: { jsx: true, globalReturn: true, impliedStrict: false } };
          function b(V) {
            let { message: R, lineNumber: N, column: T } = V;
            return typeof N != "number" ? V : u(R, { start: { line: N, column: T } });
          }
          function g(V, R) {
            let N = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, { parse: T } = Fh(), v = E(V), { result: q, error: B } = l(() => T(v, Object.assign(Object.assign({}, A), {}, { sourceType: "module" })), () => T(v, Object.assign(Object.assign({}, A), {}, { sourceType: "script" })));
            if (!q) throw b(B);
            return N.originalText = V, y(q, N);
          }
          o.exports = m(g);
        } });
        J();
        var Th = wh(), Ih = Bh();
        Na.exports = { parsers: { acorn: Th, espree: Ih } };
      });
      return Ph();
    });
  }
});

// ../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-meriyah.js
var require_parser_meriyah = __commonJS({
  "../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-meriyah.js"(exports2, module2) {
    "use strict";
    (function(e) {
      if (typeof exports2 == "object" && typeof module2 == "object") module2.exports = e();
      else if (typeof define == "function" && define.amd) define(e);
      else {
        var i = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i.prettierPlugins = i.prettierPlugins || {}, i.prettierPlugins.meriyah = e();
      }
    })(function() {
      "use strict";
      var F = (d, m) => () => (m || d((m = { exports: {} }).exports, m), m.exports);
      var i2 = F((E3, Ce) => {
        var A1 = function(d) {
          return d && d.Math == Math && d;
        };
        Ce.exports = A1(typeof globalThis == "object" && globalThis) || A1(typeof window == "object" && window) || A1(typeof self == "object" && self) || A1(typeof global == "object" && global) || /* @__PURE__ */ function() {
          return this;
        }() || Function("return this")();
      });
      var L2 = F((D3, we) => {
        we.exports = function(d) {
          try {
            return !!d();
          } catch {
            return true;
          }
        };
      });
      var J2 = F((C3, qe) => {
        var Ut = L2();
        qe.exports = !Ut(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      });
      var x1 = F((w3, Be) => {
        var Jt = L2();
        Be.exports = !Jt(function() {
          var d = function() {
          }.bind();
          return typeof d != "function" || d.hasOwnProperty("prototype");
        });
      });
      var P1 = F((q3, Se) => {
        var Xt = x1(), y1 = Function.prototype.call;
        Se.exports = Xt ? y1.bind(y1) : function() {
          return y1.apply(y1, arguments);
        };
      });
      var Oe = F((Le) => {
        "use strict";
        var Fe = {}.propertyIsEnumerable, Te = Object.getOwnPropertyDescriptor, zt = Te && !Fe.call({ 1: 2 }, 1);
        Le.f = zt ? function(m) {
          var k = Te(this, m);
          return !!k && k.enumerable;
        } : Fe;
      });
      var p1 = F((S3, Ie) => {
        Ie.exports = function(d, m) {
          return { enumerable: !(d & 1), configurable: !(d & 2), writable: !(d & 4), value: m };
        };
      });
      var D2 = F((F3, Ve) => {
        var Re = x1(), Ne = Function.prototype, Ht = Ne.bind, uu = Ne.call, Kt = Re && Ht.bind(uu, uu);
        Ve.exports = Re ? function(d) {
          return d && Kt(d);
        } : function(d) {
          return d && function() {
            return uu.apply(d, arguments);
          };
        };
      });
      var Me = F((T3, _e) => {
        var je = D2(), Wt = je({}.toString), Yt = je("".slice);
        _e.exports = function(d) {
          return Yt(Wt(d), 8, -1);
        };
      });
      var Je = F((L3, Ue) => {
        var $t = i2(), Zt = D2(), Qt = L2(), Gt = Me(), eu = $t.Object, xt = Zt("".split);
        Ue.exports = Qt(function() {
          return !eu("z").propertyIsEnumerable(0);
        }) ? function(d) {
          return Gt(d) == "String" ? xt(d, "") : eu(d);
        } : eu;
      });
      var iu = F((O3, Xe) => {
        var pt = i2(), uo = pt.TypeError;
        Xe.exports = function(d) {
          if (d == null) throw uo("Can't call method on " + d);
          return d;
        };
      });
      var E1 = F((I3, ze) => {
        var eo = Je(), io = iu();
        ze.exports = function(d) {
          return eo(io(d));
        };
      });
      var C2 = F((R3, He) => {
        He.exports = function(d) {
          return typeof d == "function";
        };
      });
      var Z2 = F((N3, Ke) => {
        var no = C2();
        Ke.exports = function(d) {
          return typeof d == "object" ? d !== null : no(d);
        };
      });
      var D1 = F((V3, We) => {
        var nu = i2(), to = C2(), oo = function(d) {
          return to(d) ? d : void 0;
        };
        We.exports = function(d, m) {
          return arguments.length < 2 ? oo(nu[d]) : nu[d] && nu[d][m];
        };
      });
      var $e = F((j3, Ye) => {
        var lo = D2();
        Ye.exports = lo({}.isPrototypeOf);
      });
      var Qe = F((_3, Ze) => {
        var fo = D1();
        Ze.exports = fo("navigator", "userAgent") || "";
      });
      var ni = F((M3, ii) => {
        var ei = i2(), tu = Qe(), Ge = ei.process, xe = ei.Deno, pe = Ge && Ge.versions || xe && xe.version, ui = pe && pe.v8, P2, C1;
        ui && (P2 = ui.split("."), C1 = P2[0] > 0 && P2[0] < 4 ? 1 : +(P2[0] + P2[1]));
        !C1 && tu && (P2 = tu.match(/Edge\/(\d+)/), (!P2 || P2[1] >= 74) && (P2 = tu.match(/Chrome\/(\d+)/), P2 && (C1 = +P2[1])));
        ii.exports = C1;
      });
      var ou = F((U3, oi) => {
        var ti = ni(), co = L2();
        oi.exports = !!Object.getOwnPropertySymbols && !co(function() {
          var d = Symbol();
          return !String(d) || !(Object(d) instanceof Symbol) || !Symbol.sham && ti && ti < 41;
        });
      });
      var lu = F((J3, li) => {
        var so = ou();
        li.exports = so && !Symbol.sham && typeof Symbol.iterator == "symbol";
      });
      var fu = F((X3, fi) => {
        var ao = i2(), go = D1(), ho = C2(), mo = $e(), bo = lu(), ko = ao.Object;
        fi.exports = bo ? function(d) {
          return typeof d == "symbol";
        } : function(d) {
          var m = go("Symbol");
          return ho(m) && mo(m.prototype, ko(d));
        };
      });
      var si = F((z3, ci) => {
        var ro = i2(), vo = ro.String;
        ci.exports = function(d) {
          try {
            return vo(d);
          } catch {
            return "Object";
          }
        };
      });
      var di = F((H3, ai) => {
        var Ao = i2(), yo = C2(), Po = si(), Eo = Ao.TypeError;
        ai.exports = function(d) {
          if (yo(d)) return d;
          throw Eo(Po(d) + " is not a function");
        };
      });
      var hi = F((K3, gi) => {
        var Do = di();
        gi.exports = function(d, m) {
          var k = d[m];
          return k == null ? void 0 : Do(k);
        };
      });
      var bi = F((W3, mi) => {
        var Co = i2(), cu = P1(), su = C2(), au = Z2(), wo = Co.TypeError;
        mi.exports = function(d, m) {
          var k, f;
          if (m === "string" && su(k = d.toString) && !au(f = cu(k, d)) || su(k = d.valueOf) && !au(f = cu(k, d)) || m !== "string" && su(k = d.toString) && !au(f = cu(k, d))) return f;
          throw wo("Can't convert object to primitive value");
        };
      });
      var ri = F((Y3, ki) => {
        ki.exports = false;
      });
      var w1 = F(($3, Ai) => {
        var vi = i2(), qo = Object.defineProperty;
        Ai.exports = function(d, m) {
          try {
            qo(vi, d, { value: m, configurable: true, writable: true });
          } catch {
            vi[d] = m;
          }
          return m;
        };
      });
      var q1 = F((Z3, Pi) => {
        var Bo = i2(), So = w1(), yi = "__core-js_shared__", Fo = Bo[yi] || So(yi, {});
        Pi.exports = Fo;
      });
      var du = F((Q3, Di) => {
        var To = ri(), Ei = q1();
        (Di.exports = function(d, m) {
          return Ei[d] || (Ei[d] = m !== void 0 ? m : {});
        })("versions", []).push({ version: "3.22.2", mode: To ? "pure" : "global", copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)", license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE", source: "https://github.com/zloirock/core-js" });
      });
      var wi = F((G3, Ci) => {
        var Lo = i2(), Oo = iu(), Io = Lo.Object;
        Ci.exports = function(d) {
          return Io(Oo(d));
        };
      });
      var O2 = F((x3, qi) => {
        var Ro = D2(), No = wi(), Vo = Ro({}.hasOwnProperty);
        qi.exports = Object.hasOwn || function(m, k) {
          return Vo(No(m), k);
        };
      });
      var gu = F((p3, Bi) => {
        var jo = D2(), _o = 0, Mo = Math.random(), Uo = jo(1 .toString);
        Bi.exports = function(d) {
          return "Symbol(" + (d === void 0 ? "" : d) + ")_" + Uo(++_o + Mo, 36);
        };
      });
      var Ii = F((u6, Oi) => {
        var Jo = i2(), Xo = du(), Si = O2(), zo = gu(), Fi = ou(), Li = lu(), Q2 = Xo("wks"), X2 = Jo.Symbol, Ti = X2 && X2.for, Ho = Li ? X2 : X2 && X2.withoutSetter || zo;
        Oi.exports = function(d) {
          if (!Si(Q2, d) || !(Fi || typeof Q2[d] == "string")) {
            var m = "Symbol." + d;
            Fi && Si(X2, d) ? Q2[d] = X2[d] : Li && Ti ? Q2[d] = Ti(m) : Q2[d] = Ho(m);
          }
          return Q2[d];
        };
      });
      var ji = F((e6, Vi) => {
        var Ko = i2(), Wo = P1(), Ri = Z2(), Ni = fu(), Yo = hi(), $o = bi(), Zo = Ii(), Qo = Ko.TypeError, Go = Zo("toPrimitive");
        Vi.exports = function(d, m) {
          if (!Ri(d) || Ni(d)) return d;
          var k = Yo(d, Go), f;
          if (k) {
            if (m === void 0 && (m = "default"), f = Wo(k, d, m), !Ri(f) || Ni(f)) return f;
            throw Qo("Can't convert object to primitive value");
          }
          return m === void 0 && (m = "number"), $o(d, m);
        };
      });
      var hu = F((i6, _i) => {
        var xo = ji(), po = fu();
        _i.exports = function(d) {
          var m = xo(d, "string");
          return po(m) ? m : m + "";
        };
      });
      var Ji = F((n6, Ui) => {
        var ul = i2(), Mi = Z2(), mu = ul.document, el = Mi(mu) && Mi(mu.createElement);
        Ui.exports = function(d) {
          return el ? mu.createElement(d) : {};
        };
      });
      var bu = F((t6, Xi) => {
        var il = J2(), nl = L2(), tl = Ji();
        Xi.exports = !il && !nl(function() {
          return Object.defineProperty(tl("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      });
      var ku = F((Hi) => {
        var ol = J2(), ll = P1(), fl = Oe(), cl = p1(), sl = E1(), al = hu(), dl = O2(), gl = bu(), zi = Object.getOwnPropertyDescriptor;
        Hi.f = ol ? zi : function(m, k) {
          if (m = sl(m), k = al(k), gl) try {
            return zi(m, k);
          } catch {
          }
          if (dl(m, k)) return cl(!ll(fl.f, m, k), m[k]);
        };
      });
      var Wi = F((l6, Ki) => {
        var hl = J2(), ml = L2();
        Ki.exports = hl && ml(function() {
          return Object.defineProperty(function() {
          }, "prototype", { value: 42, writable: false }).prototype != 42;
        });
      });
      var ru = F((f6, $i) => {
        var Yi = i2(), bl = Z2(), kl = Yi.String, rl = Yi.TypeError;
        $i.exports = function(d) {
          if (bl(d)) return d;
          throw rl(kl(d) + " is not an object");
        };
      });
      var Eu = F((Qi) => {
        var vl = i2(), Al = J2(), yl = bu(), Pl = Wi(), B1 = ru(), Zi = hu(), El = vl.TypeError, vu = Object.defineProperty, Dl = Object.getOwnPropertyDescriptor, Au = "enumerable", yu = "configurable", Pu = "writable";
        Qi.f = Al ? Pl ? function(m, k, f) {
          if (B1(m), k = Zi(k), B1(f), typeof m == "function" && k === "prototype" && "value" in f && Pu in f && !f[Pu]) {
            var P = Dl(m, k);
            P && P[Pu] && (m[k] = f.value, f = { configurable: yu in f ? f[yu] : P[yu], enumerable: Au in f ? f[Au] : P[Au], writable: false });
          }
          return vu(m, k, f);
        } : vu : function(m, k, f) {
          if (B1(m), k = Zi(k), B1(f), yl) try {
            return vu(m, k, f);
          } catch {
          }
          if ("get" in f || "set" in f) throw El("Accessors not supported");
          return "value" in f && (m[k] = f.value), m;
        };
      });
      var S1 = F((s6, Gi) => {
        var Cl = J2(), wl = Eu(), ql = p1();
        Gi.exports = Cl ? function(d, m, k) {
          return wl.f(d, m, ql(1, k));
        } : function(d, m, k) {
          return d[m] = k, d;
        };
      });
      var Cu = F((a6, xi) => {
        var Bl = D2(), Sl = C2(), Du = q1(), Fl = Bl(Function.toString);
        Sl(Du.inspectSource) || (Du.inspectSource = function(d) {
          return Fl(d);
        });
        xi.exports = Du.inspectSource;
      });
      var en = F((d6, un) => {
        var Tl = i2(), Ll = C2(), Ol = Cu(), pi = Tl.WeakMap;
        un.exports = Ll(pi) && /native code/.test(Ol(pi));
      });
      var on = F((g6, tn) => {
        var Il = du(), Rl = gu(), nn = Il("keys");
        tn.exports = function(d) {
          return nn[d] || (nn[d] = Rl(d));
        };
      });
      var wu = F((h6, ln) => {
        ln.exports = {};
      });
      var gn = F((m6, dn) => {
        var Nl = en(), an = i2(), qu = D2(), Vl = Z2(), jl = S1(), Bu = O2(), Su = q1(), _l = on(), Ml = wu(), fn = "Object already initialized", Tu = an.TypeError, Ul = an.WeakMap, F1, e1, T1, Jl = function(d) {
          return T1(d) ? e1(d) : F1(d, {});
        }, Xl = function(d) {
          return function(m) {
            var k;
            if (!Vl(m) || (k = e1(m)).type !== d) throw Tu("Incompatible receiver, " + d + " required");
            return k;
          };
        };
        Nl || Su.state ? (I2 = Su.state || (Su.state = new Ul()), cn = qu(I2.get), Fu = qu(I2.has), sn = qu(I2.set), F1 = function(d, m) {
          if (Fu(I2, d)) throw new Tu(fn);
          return m.facade = d, sn(I2, d, m), m;
        }, e1 = function(d) {
          return cn(I2, d) || {};
        }, T1 = function(d) {
          return Fu(I2, d);
        }) : (z2 = _l("state"), Ml[z2] = true, F1 = function(d, m) {
          if (Bu(d, z2)) throw new Tu(fn);
          return m.facade = d, jl(d, z2, m), m;
        }, e1 = function(d) {
          return Bu(d, z2) ? d[z2] : {};
        }, T1 = function(d) {
          return Bu(d, z2);
        });
        var I2, cn, Fu, sn, z2;
        dn.exports = { set: F1, get: e1, has: T1, enforce: Jl, getterFor: Xl };
      });
      var bn = F((b6, mn) => {
        var Lu = J2(), zl = O2(), hn = Function.prototype, Hl = Lu && Object.getOwnPropertyDescriptor, Ou = zl(hn, "name"), Kl = Ou && function() {
        }.name === "something", Wl = Ou && (!Lu || Lu && Hl(hn, "name").configurable);
        mn.exports = { EXISTS: Ou, PROPER: Kl, CONFIGURABLE: Wl };
      });
      var yn = F((k6, An) => {
        var Yl = i2(), kn = C2(), $l = O2(), rn = S1(), Zl = w1(), Ql = Cu(), vn = gn(), Gl = bn().CONFIGURABLE, xl = vn.get, pl = vn.enforce, u4 = String(String).split("String");
        (An.exports = function(d, m, k, f) {
          var P = f ? !!f.unsafe : false, S = f ? !!f.enumerable : false, q = f ? !!f.noTargetGet : false, T = f && f.name !== void 0 ? f.name : m, r;
          if (kn(k) && (String(T).slice(0, 7) === "Symbol(" && (T = "[" + String(T).replace(/^Symbol\(([^)]*)\)/, "$1") + "]"), (!$l(k, "name") || Gl && k.name !== T) && rn(k, "name", T), r = pl(k), r.source || (r.source = u4.join(typeof T == "string" ? T : ""))), d === Yl) {
            S ? d[m] = k : Zl(m, k);
            return;
          } else P ? !q && d[m] && (S = true) : delete d[m];
          S ? d[m] = k : rn(d, m, k);
        })(Function.prototype, "toString", function() {
          return kn(this) && xl(this).source || Ql(this);
        });
      });
      var Iu = F((r6, Pn) => {
        var e4 = Math.ceil, i4 = Math.floor;
        Pn.exports = function(d) {
          var m = +d;
          return m !== m || m === 0 ? 0 : (m > 0 ? i4 : e4)(m);
        };
      });
      var Dn = F((v6, En) => {
        var n4 = Iu(), t4 = Math.max, o4 = Math.min;
        En.exports = function(d, m) {
          var k = n4(d);
          return k < 0 ? t4(k + m, 0) : o4(k, m);
        };
      });
      var wn = F((A6, Cn) => {
        var l4 = Iu(), f4 = Math.min;
        Cn.exports = function(d) {
          return d > 0 ? f4(l4(d), 9007199254740991) : 0;
        };
      });
      var Bn = F((y6, qn) => {
        var c4 = wn();
        qn.exports = function(d) {
          return c4(d.length);
        };
      });
      var Tn = F((P6, Fn) => {
        var s4 = E1(), a4 = Dn(), d4 = Bn(), Sn = function(d) {
          return function(m, k, f) {
            var P = s4(m), S = d4(P), q = a4(f, S), T;
            if (d && k != k) {
              for (; S > q; ) if (T = P[q++], T != T) return true;
            } else for (; S > q; q++) if ((d || q in P) && P[q] === k) return d || q || 0;
            return !d && -1;
          };
        };
        Fn.exports = { includes: Sn(true), indexOf: Sn(false) };
      });
      var In = F((E6, On) => {
        var g4 = D2(), Ru = O2(), h4 = E1(), m4 = Tn().indexOf, b4 = wu(), Ln = g4([].push);
        On.exports = function(d, m) {
          var k = h4(d), f = 0, P = [], S;
          for (S in k) !Ru(b4, S) && Ru(k, S) && Ln(P, S);
          for (; m.length > f; ) Ru(k, S = m[f++]) && (~m4(P, S) || Ln(P, S));
          return P;
        };
      });
      var Nn = F((D6, Rn) => {
        Rn.exports = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
      });
      var jn = F((Vn) => {
        var k4 = In(), r4 = Nn(), v4 = r4.concat("length", "prototype");
        Vn.f = Object.getOwnPropertyNames || function(m) {
          return k4(m, v4);
        };
      });
      var Mn = F((_n) => {
        _n.f = Object.getOwnPropertySymbols;
      });
      var Jn = F((q6, Un) => {
        var A4 = D1(), y4 = D2(), P4 = jn(), E4 = Mn(), D4 = ru(), C4 = y4([].concat);
        Un.exports = A4("Reflect", "ownKeys") || function(m) {
          var k = P4.f(D4(m)), f = E4.f;
          return f ? C4(k, f(m)) : k;
        };
      });
      var Hn = F((B6, zn) => {
        var Xn = O2(), w4 = Jn(), q4 = ku(), B4 = Eu();
        zn.exports = function(d, m, k) {
          for (var f = w4(m), P = B4.f, S = q4.f, q = 0; q < f.length; q++) {
            var T = f[q];
            !Xn(d, T) && !(k && Xn(k, T)) && P(d, T, S(m, T));
          }
        };
      });
      var Wn = F((S6, Kn) => {
        var S4 = L2(), F4 = C2(), T4 = /#|\.prototype\./, i1 = function(d, m) {
          var k = O4[L4(d)];
          return k == R4 ? true : k == I4 ? false : F4(m) ? S4(m) : !!m;
        }, L4 = i1.normalize = function(d) {
          return String(d).replace(T4, ".").toLowerCase();
        }, O4 = i1.data = {}, I4 = i1.NATIVE = "N", R4 = i1.POLYFILL = "P";
        Kn.exports = i1;
      });
      var $n = F((F6, Yn) => {
        var Nu = i2(), N4 = ku().f, V4 = S1(), j4 = yn(), _4 = w1(), M4 = Hn(), U4 = Wn();
        Yn.exports = function(d, m) {
          var k = d.target, f = d.global, P = d.stat, S, q, T, r, K, Y;
          if (f ? q = Nu : P ? q = Nu[k] || _4(k, {}) : q = (Nu[k] || {}).prototype, q) for (T in m) {
            if (K = m[T], d.noTargetGet ? (Y = N4(q, T), r = Y && Y.value) : r = q[T], S = U4(f ? T : k + (P ? "." : "#") + T, d.forced), !S && r !== void 0) {
              if (typeof K == typeof r) continue;
              M4(K, r);
            }
            (d.sham || r && r.sham) && V4(K, "sham", true), j4(q, T, K, d);
          }
        };
      });
      var Zn = F(() => {
        var J4 = $n(), X4 = i2();
        J4({ global: true }, { globalThis: X4 });
      });
      var Qn = F(() => {
        Zn();
      });
      var y3 = F((R6, k0) => {
        Qn();
        var Mu = Object.defineProperty, z4 = Object.getOwnPropertyDescriptor, Uu = Object.getOwnPropertyNames, H4 = Object.prototype.hasOwnProperty, xn = (d, m) => function() {
          return d && (m = (0, d[Uu(d)[0]])(d = 0)), m;
        }, l2 = (d, m) => function() {
          return m || (0, d[Uu(d)[0]])((m = { exports: {} }).exports, m), m.exports;
        }, K4 = (d, m) => {
          for (var k in m) Mu(d, k, { get: m[k], enumerable: true });
        }, W4 = (d, m, k, f) => {
          if (m && typeof m == "object" || typeof m == "function") for (let P of Uu(m)) !H4.call(d, P) && P !== k && Mu(d, P, { get: () => m[P], enumerable: !(f = z4(m, P)) || f.enumerable });
          return d;
        }, Y4 = (d) => W4(Mu({}, "__esModule", { value: true }), d), n2 = xn({ "<define:process>"() {
        } }), pn = l2({ "src/common/parser-create-error.js"(d, m) {
          "use strict";
          n2();
          function k(f, P) {
            let S = new SyntaxError(f + " (" + P.start.line + ":" + P.start.column + ")");
            return S.loc = P, S;
          }
          m.exports = k;
        } }), $4 = l2({ "src/utils/try-combinations.js"(d, m) {
          "use strict";
          n2();
          function k() {
            let f;
            for (var P = arguments.length, S = new Array(P), q = 0; q < P; q++) S[q] = arguments[q];
            for (let [T, r] of S.entries()) try {
              return { result: r() };
            } catch (K) {
              T === 0 && (f = K);
            }
            return { error: f };
          }
          m.exports = k;
        } }), u0 = {};
        K4(u0, { EOL: () => _u, arch: () => Z4, cpus: () => f0, default: () => g0, endianness: () => e0, freemem: () => o0, getNetworkInterfaces: () => d0, hostname: () => i0, loadavg: () => n0, networkInterfaces: () => a0, platform: () => Q4, release: () => s0, tmpDir: () => Vu, tmpdir: () => ju, totalmem: () => l0, type: () => c0, uptime: () => t0 });
        function e0() {
          if (typeof L1 > "u") {
            var d = new ArrayBuffer(2), m = new Uint8Array(d), k = new Uint16Array(d);
            if (m[0] = 1, m[1] = 2, k[0] === 258) L1 = "BE";
            else if (k[0] === 513) L1 = "LE";
            else throw new Error("unable to figure out endianess");
          }
          return L1;
        }
        function i0() {
          return typeof globalThis.location < "u" ? globalThis.location.hostname : "";
        }
        function n0() {
          return [];
        }
        function t0() {
          return 0;
        }
        function o0() {
          return Number.MAX_VALUE;
        }
        function l0() {
          return Number.MAX_VALUE;
        }
        function f0() {
          return [];
        }
        function c0() {
          return "Browser";
        }
        function s0() {
          return typeof globalThis.navigator < "u" ? globalThis.navigator.appVersion : "";
        }
        function a0() {
        }
        function d0() {
        }
        function Z4() {
          return "javascript";
        }
        function Q4() {
          return "browser";
        }
        function Vu() {
          return "/tmp";
        }
        var L1, ju, _u, g0, G4 = xn({ "node-modules-polyfills:os"() {
          n2(), ju = Vu, _u = `
`, g0 = { EOL: _u, tmpdir: ju, tmpDir: Vu, networkInterfaces: a0, getNetworkInterfaces: d0, release: s0, type: c0, cpus: f0, totalmem: l0, freemem: o0, uptime: t0, loadavg: n0, hostname: i0, endianness: e0 };
        } }), x4 = l2({ "node-modules-polyfills-commonjs:os"(d, m) {
          n2();
          var k = (G4(), Y4(u0));
          if (k && k.default) {
            m.exports = k.default;
            for (let f in k) m.exports[f] = k[f];
          } else k && (m.exports = k);
        } }), p4 = l2({ "node_modules/detect-newline/index.js"(d, m) {
          "use strict";
          n2();
          var k = (f) => {
            if (typeof f != "string") throw new TypeError("Expected a string");
            let P = f.match(/(?:\r?\n)/g) || [];
            if (P.length === 0) return;
            let S = P.filter((T) => T === `\r
`).length, q = P.length - S;
            return S > q ? `\r
` : `
`;
          };
          m.exports = k, m.exports.graceful = (f) => typeof f == "string" && k(f) || `
`;
        } }), u3 = l2({ "node_modules/jest-docblock/build/index.js"(d) {
          "use strict";
          n2(), Object.defineProperty(d, "__esModule", { value: true }), d.extract = Z, d.parse = t2, d.parseWithComments = V, d.print = J, d.strip = L;
          function m() {
            let I = x4();
            return m = function() {
              return I;
            }, I;
          }
          function k() {
            let I = f(p4());
            return k = function() {
              return I;
            }, I;
          }
          function f(I) {
            return I && I.__esModule ? I : { default: I };
          }
          var P = /\*\/$/, S = /^\/\*\*/, q = /^\s*(\/\*\*?(.|\r?\n)*?\*\/)/, T = /(^|\s+)\/\/([^\r\n]*)/g, r = /^(\r?\n)+/, K = /(?:^|\r?\n) *(@[^\r\n]*?) *\r?\n *(?![^@\r\n]*\/\/[^]*)([^@\r\n\s][^@\r\n]+?) *\r?\n/g, Y = /(?:^|\r?\n) *@(\S+) *([^\r\n]*)/g, X = /(\r?\n|^) *\* ?/g, p = [];
          function Z(I) {
            let u2 = I.match(q);
            return u2 ? u2[0].trimLeft() : "";
          }
          function L(I) {
            let u2 = I.match(q);
            return u2 && u2[0] ? I.substring(u2[0].length) : I;
          }
          function t2(I) {
            return V(I).pragmas;
          }
          function V(I) {
            let u2 = (0, k().default)(I) || m().EOL;
            I = I.replace(S, "").replace(P, "").replace(X, "$1");
            let m2 = "";
            for (; m2 !== I; ) m2 = I, I = I.replace(K, "".concat(u2, "$1 $2").concat(u2));
            I = I.replace(r, "").trimRight();
            let c2 = /* @__PURE__ */ Object.create(null), R2 = I.replace(Y, "").replace(r, "").trimRight(), s2;
            for (; s2 = Y.exec(I); ) {
              let N2 = s2[2].replace(T, "");
              typeof c2[s2[1]] == "string" || Array.isArray(c2[s2[1]]) ? c2[s2[1]] = p.concat(c2[s2[1]], N2) : c2[s2[1]] = N2;
            }
            return { comments: R2, pragmas: c2 };
          }
          function J(I) {
            let { comments: u2 = "", pragmas: m2 = {} } = I, c2 = (0, k().default)(u2) || m().EOL, R2 = "/**", s2 = " *", N2 = " */", w2 = Object.keys(m2), O1 = w2.map((g2) => H(g2, m2[g2])).reduce((g2, n1) => g2.concat(n1), []).map((g2) => s2 + " " + g2 + c2).join("");
            if (!u2) {
              if (w2.length === 0) return "";
              if (w2.length === 1 && !Array.isArray(m2[w2[0]])) {
                let g2 = m2[w2[0]];
                return "".concat(R2, " ").concat(H(w2[0], g2)[0]).concat(N2);
              }
            }
            let I1 = u2.split(c2).map((g2) => "".concat(s2, " ").concat(g2)).join(c2) + c2;
            return R2 + c2 + (u2 ? I1 : "") + (u2 && w2.length ? s2 + c2 : "") + O1 + N2;
          }
          function H(I, u2) {
            return p.concat(u2).map((m2) => "@".concat(I, " ").concat(m2).trim());
          }
        } }), e3 = l2({ "src/common/end-of-line.js"(d, m) {
          "use strict";
          n2();
          function k(q) {
            let T = q.indexOf("\r");
            return T >= 0 ? q.charAt(T + 1) === `
` ? "crlf" : "cr" : "lf";
          }
          function f(q) {
            switch (q) {
              case "cr":
                return "\r";
              case "crlf":
                return `\r
`;
              default:
                return `
`;
            }
          }
          function P(q, T) {
            let r;
            switch (T) {
              case `
`:
                r = /\n/g;
                break;
              case "\r":
                r = /\r/g;
                break;
              case `\r
`:
                r = /\r\n/g;
                break;
              default:
                throw new Error('Unexpected "eol" '.concat(JSON.stringify(T), "."));
            }
            let K = q.match(r);
            return K ? K.length : 0;
          }
          function S(q) {
            return q.replace(/\r\n?/g, `
`);
          }
          m.exports = { guessEndOfLine: k, convertEndOfLineToChars: f, countEndOfLineChars: P, normalizeEndOfLine: S };
        } }), i3 = l2({ "src/language-js/utils/get-shebang.js"(d, m) {
          "use strict";
          n2();
          function k(f) {
            if (!f.startsWith("#!")) return "";
            let P = f.indexOf(`
`);
            return P === -1 ? f : f.slice(0, P);
          }
          m.exports = k;
        } }), n3 = l2({ "src/language-js/pragma.js"(d, m) {
          "use strict";
          n2();
          var { parseWithComments: k, strip: f, extract: P, print: S } = u3(), { normalizeEndOfLine: q } = e3(), T = i3();
          function r(X) {
            let p = T(X);
            p && (X = X.slice(p.length + 1));
            let Z = P(X), { pragmas: L, comments: t2 } = k(Z);
            return { shebang: p, text: X, pragmas: L, comments: t2 };
          }
          function K(X) {
            let p = Object.keys(r(X).pragmas);
            return p.includes("prettier") || p.includes("format");
          }
          function Y(X) {
            let { shebang: p, text: Z, pragmas: L, comments: t2 } = r(X), V = f(Z), J = S({ pragmas: Object.assign({ format: "" }, L), comments: t2.trimStart() });
            return (p ? "".concat(p, `
`) : "") + q(J) + (V.startsWith(`
`) ? `
` : `

`) + V;
          }
          m.exports = { hasPragma: K, insertPragma: Y };
        } }), t3 = l2({ "src/utils/is-non-empty-array.js"(d, m) {
          "use strict";
          n2();
          function k(f) {
            return Array.isArray(f) && f.length > 0;
          }
          m.exports = k;
        } }), h0 = l2({ "src/language-js/loc.js"(d, m) {
          "use strict";
          n2();
          var k = t3();
          function f(r, K) {
            let { ignoreDecorators: Y } = K || {};
            if (!Y) {
              let X = r.declaration && r.declaration.decorators || r.decorators;
              if (k(X)) return f(X[0]);
            }
            return r.range ? r.range[0] : r.start;
          }
          function P(r) {
            return r.range ? r.range[1] : r.end;
          }
          function S(r, K) {
            let Y = f(r);
            return Number.isInteger(Y) && Y === f(K);
          }
          function q(r, K) {
            let Y = P(r);
            return Number.isInteger(Y) && Y === P(K);
          }
          function T(r, K) {
            return S(r, K) && q(r, K);
          }
          m.exports = { locStart: f, locEnd: P, hasSameLocStart: S, hasSameLoc: T };
        } }), o3 = l2({ "src/language-js/parse/utils/create-parser.js"(d, m) {
          "use strict";
          n2();
          var { hasPragma: k } = n3(), { locStart: f, locEnd: P } = h0();
          function S(q) {
            return q = typeof q == "function" ? { parse: q } : q, Object.assign({ astFormat: "estree", hasPragma: k, locStart: f, locEnd: P }, q);
          }
          m.exports = S;
        } }), l3 = l2({ "src/language-js/utils/is-ts-keyword-type.js"(d, m) {
          "use strict";
          n2();
          function k(f) {
            let { type: P } = f;
            return P.startsWith("TS") && P.endsWith("Keyword");
          }
          m.exports = k;
        } }), f3 = l2({ "src/language-js/utils/is-block-comment.js"(d, m) {
          "use strict";
          n2();
          var k = /* @__PURE__ */ new Set(["Block", "CommentBlock", "MultiLine"]), f = (P) => k.has(P == null ? void 0 : P.type);
          m.exports = f;
        } }), c3 = l2({ "src/language-js/utils/is-type-cast-comment.js"(d, m) {
          "use strict";
          n2();
          var k = f3();
          function f(P) {
            return k(P) && P.value[0] === "*" && /@type\b/.test(P.value);
          }
          m.exports = f;
        } }), s3 = l2({ "src/utils/get-last.js"(d, m) {
          "use strict";
          n2();
          var k = (f) => f[f.length - 1];
          m.exports = k;
        } }), m0 = l2({ "src/language-js/parse/postprocess/visit-node.js"(d, m) {
          "use strict";
          n2();
          function k(f, P) {
            if (Array.isArray(f)) {
              for (let S = 0; S < f.length; S++) f[S] = k(f[S], P);
              return f;
            }
            if (f && typeof f == "object" && typeof f.type == "string") {
              let S = Object.keys(f);
              for (let q = 0; q < S.length; q++) f[S[q]] = k(f[S[q]], P);
              return P(f) || f;
            }
            return f;
          }
          m.exports = k;
        } }), b0 = l2({ "src/language-js/parse/postprocess/throw-syntax-error.js"(d, m) {
          "use strict";
          n2();
          var k = pn();
          function f(P, S) {
            let { start: q, end: T } = P.loc;
            throw k(S, { start: { line: q.line, column: q.column + 1 }, end: { line: T.line, column: T.column + 1 } });
          }
          m.exports = f;
        } }), a3 = l2({ "src/language-js/parse/postprocess/typescript.js"(d, m) {
          "use strict";
          n2();
          var k = m0(), f = b0();
          function P(T, r, K) {
            let Y = T.decorators;
            if (!Array.isArray(Y)) return;
            let X = r.decorators;
            (!Array.isArray(X) || X.length !== Y.length || Y.some((p) => {
              let Z = K.get(p);
              return !Z || !X.includes(Z);
            })) && f(r, "Leading decorators must be attached to a class declaration");
          }
          function S(T, r) {
            T.kind !== 167 || T.modifiers && !T.modifiers.some((X) => X.kind === 126) || T.initializer && r.value === null && f(r, "Abstract property cannot have an initializer");
          }
          function q(T, r) {
            let { esTreeNodeToTSNodeMap: K, tsNodeToESTreeNodeMap: Y } = r.tsParseResult;
            k(T, (X) => {
              let p = K.get(X);
              if (!p) return;
              let Z = Y.get(p);
              Z === X && (P(p, Z, Y), S(p, Z));
            });
          }
          m.exports = { throwErrorForInvalidNodes: q };
        } }), d3 = l2({ "src/language-js/parse/postprocess/index.js"(d, m) {
          "use strict";
          n2();
          var { locStart: k, locEnd: f } = h0(), P = l3(), S = c3(), q = s3(), T = m0(), { throwErrorForInvalidNodes: r } = a3(), K = b0();
          function Y(L, t2) {
            if (t2.parser === "typescript" && /@|abstract/.test(t2.originalText) && r(L, t2), t2.parser !== "typescript" && t2.parser !== "flow" && t2.parser !== "acorn" && t2.parser !== "espree" && t2.parser !== "meriyah") {
              let J = /* @__PURE__ */ new Set();
              L = T(L, (H) => {
                H.leadingComments && H.leadingComments.some(S) && J.add(k(H));
              }), L = T(L, (H) => {
                if (H.type === "ParenthesizedExpression") {
                  let { expression: I } = H;
                  if (I.type === "TypeCastExpression") return I.range = H.range, I;
                  let u2 = k(H);
                  if (!J.has(u2)) return I.extra = Object.assign(Object.assign({}, I.extra), {}, { parenthesized: true }), I;
                }
              });
            }
            return L = T(L, (J) => {
              switch (J.type) {
                case "ChainExpression":
                  return X(J.expression);
                case "LogicalExpression": {
                  if (p(J)) return Z(J);
                  break;
                }
                case "VariableDeclaration": {
                  let H = q(J.declarations);
                  H && H.init && V(J, H);
                  break;
                }
                case "TSParenthesizedType":
                  return P(J.typeAnnotation) || J.typeAnnotation.type === "TSThisType" || (J.typeAnnotation.range = [k(J), f(J)]), J.typeAnnotation;
                case "TSTypeParameter":
                  if (typeof J.name == "string") {
                    let H = k(J);
                    J.name = { type: "Identifier", name: J.name, range: [H, H + J.name.length] };
                  }
                  break;
                case "ObjectExpression":
                  if (t2.parser === "typescript") {
                    let H = J.properties.find((I) => I.type === "Property" && I.value.type === "TSEmptyBodyFunctionExpression");
                    H && K(H.value, "Unexpected token.");
                  }
                  break;
                case "SequenceExpression": {
                  let H = q(J.expressions);
                  J.range = [k(J), Math.min(f(H), f(J))];
                  break;
                }
                case "TopicReference":
                  t2.__isUsingHackPipeline = true;
                  break;
                case "ExportAllDeclaration": {
                  let { exported: H } = J;
                  if (t2.parser === "meriyah" && H && H.type === "Identifier") {
                    let I = t2.originalText.slice(k(H), f(H));
                    (I.startsWith('"') || I.startsWith("'")) && (J.exported = Object.assign(Object.assign({}, J.exported), {}, { type: "Literal", value: J.exported.name, raw: I }));
                  }
                  break;
                }
              }
            }), L;
            function V(J, H) {
              t2.originalText[f(H)] !== ";" && (J.range = [k(J), f(H)]);
            }
          }
          function X(L) {
            switch (L.type) {
              case "CallExpression":
                L.type = "OptionalCallExpression", L.callee = X(L.callee);
                break;
              case "MemberExpression":
                L.type = "OptionalMemberExpression", L.object = X(L.object);
                break;
              case "TSNonNullExpression":
                L.expression = X(L.expression);
                break;
            }
            return L;
          }
          function p(L) {
            return L.type === "LogicalExpression" && L.right.type === "LogicalExpression" && L.operator === L.right.operator;
          }
          function Z(L) {
            return p(L) ? Z({ type: "LogicalExpression", operator: L.operator, left: Z({ type: "LogicalExpression", operator: L.operator, left: L.left, right: L.right.left, range: [k(L.left), f(L.right.left)] }), right: L.right.right, range: [k(L), f(L)] }) : L;
          }
          m.exports = Y;
        } }), g3 = l2({ "node_modules/meriyah/dist/meriyah.cjs"(d) {
          "use strict";
          n2(), Object.defineProperty(d, "__esModule", { value: true });
          var m = { [0]: "Unexpected token", [28]: "Unexpected token: '%0'", [1]: "Octal escape sequences are not allowed in strict mode", [2]: "Octal escape sequences are not allowed in template strings", [3]: "Unexpected token `#`", [4]: "Illegal Unicode escape sequence", [5]: "Invalid code point %0", [6]: "Invalid hexadecimal escape sequence", [8]: "Octal literals are not allowed in strict mode", [7]: "Decimal integer literals with a leading zero are forbidden in strict mode", [9]: "Expected number in radix %0", [145]: "Invalid left-hand side assignment to a destructible right-hand side", [10]: "Non-number found after exponent indicator", [11]: "Invalid BigIntLiteral", [12]: "No identifiers allowed directly after numeric literal", [13]: "Escapes \\8 or \\9 are not syntactically valid escapes", [14]: "Unterminated string literal", [15]: "Unterminated template literal", [16]: "Multiline comment was not closed properly", [17]: "The identifier contained dynamic unicode escape that was not closed", [18]: "Illegal character '%0'", [19]: "Missing hexadecimal digits", [20]: "Invalid implicit octal", [21]: "Invalid line break in string literal", [22]: "Only unicode escapes are legal in identifier names", [23]: "Expected '%0'", [24]: "Invalid left-hand side in assignment", [25]: "Invalid left-hand side in async arrow", [26]: 'Calls to super must be in the "constructor" method of a class expression or class declaration that has a superclass', [27]: "Member access on super must be in a method", [29]: "Await expression not allowed in formal parameter", [30]: "Yield expression not allowed in formal parameter", [92]: "Unexpected token: 'escaped keyword'", [31]: "Unary expressions as the left operand of an exponentiation expression must be disambiguated with parentheses", [119]: "Async functions can only be declared at the top level or inside a block", [32]: "Unterminated regular expression", [33]: "Unexpected regular expression flag", [34]: "Duplicate regular expression flag '%0'", [35]: "%0 functions must have exactly %1 argument%2", [36]: "Setter function argument must not be a rest parameter", [37]: "%0 declaration must have a name in this context", [38]: "Function name may not contain any reserved words or be eval or arguments in strict mode", [39]: "The rest operator is missing an argument", [40]: "A getter cannot be a generator", [41]: "A computed property name must be followed by a colon or paren", [130]: "Object literal keys that are strings or numbers must be a method or have a colon", [43]: "Found `* async x(){}` but this should be `async * x(){}`", [42]: "Getters and setters can not be generators", [44]: "'%0' can not be generator method", [45]: "No line break is allowed after '=>'", [46]: "The left-hand side of the arrow can only be destructed through assignment", [47]: "The binding declaration is not destructible", [48]: "Async arrow can not be followed by new expression", [49]: "Classes may not have a static property named 'prototype'", [50]: "Class constructor may not be a %0", [51]: "Duplicate constructor method in class", [52]: "Invalid increment/decrement operand", [53]: "Invalid use of `new` keyword on an increment/decrement expression", [54]: "`=>` is an invalid assignment target", [55]: "Rest element may not have a trailing comma", [56]: "Missing initializer in %0 declaration", [57]: "'for-%0' loop head declarations can not have an initializer", [58]: "Invalid left-hand side in for-%0 loop: Must have a single binding", [59]: "Invalid shorthand property initializer", [60]: "Property name __proto__ appears more than once in object literal", [61]: "Let is disallowed as a lexically bound name", [62]: "Invalid use of '%0' inside new expression", [63]: "Illegal 'use strict' directive in function with non-simple parameter list", [64]: 'Identifier "let" disallowed as left-hand side expression in strict mode', [65]: "Illegal continue statement", [66]: "Illegal break statement", [67]: "Cannot have `let[...]` as a var name in strict mode", [68]: "Invalid destructuring assignment target", [69]: "Rest parameter may not have a default initializer", [70]: "The rest argument must the be last parameter", [71]: "Invalid rest argument", [73]: "In strict mode code, functions can only be declared at top level or inside a block", [74]: "In non-strict mode code, functions can only be declared at top level, inside a block, or as the body of an if statement", [75]: "Without web compatibility enabled functions can not be declared at top level, inside a block, or as the body of an if statement", [76]: "Class declaration can't appear in single-statement context", [77]: "Invalid left-hand side in for-%0", [78]: "Invalid assignment in for-%0", [79]: "for await (... of ...) is only valid in async functions and async generators", [80]: "The first token after the template expression should be a continuation of the template", [82]: "`let` declaration not allowed here and `let` cannot be a regular var name in strict mode", [81]: "`let \n [` is a restricted production at the start of a statement", [83]: "Catch clause requires exactly one parameter, not more (and no trailing comma)", [84]: "Catch clause parameter does not support default values", [85]: "Missing catch or finally after try", [86]: "More than one default clause in switch statement", [87]: "Illegal newline after throw", [88]: "Strict mode code may not include a with statement", [89]: "Illegal return statement", [90]: "The left hand side of the for-header binding declaration is not destructible", [91]: "new.target only allowed within functions", [93]: "'#' not followed by identifier", [99]: "Invalid keyword", [98]: "Can not use 'let' as a class name", [97]: "'A lexical declaration can't define a 'let' binding", [96]: "Can not use `let` as variable name in strict mode", [94]: "'%0' may not be used as an identifier in this context", [95]: "Await is only valid in async functions", [100]: "The %0 keyword can only be used with the module goal", [101]: "Unicode codepoint must not be greater than 0x10FFFF", [102]: "%0 source must be string", [103]: "Only a identifier can be used to indicate alias", [104]: "Only '*' or '{...}' can be imported after default", [105]: "Trailing decorator may be followed by method", [106]: "Decorators can't be used with a constructor", [108]: "HTML comments are only allowed with web compatibility (Annex B)", [109]: "The identifier 'let' must not be in expression position in strict mode", [110]: "Cannot assign to `eval` and `arguments` in strict mode", [111]: "The left-hand side of a for-of loop may not start with 'let'", [112]: "Block body arrows can not be immediately invoked without a group", [113]: "Block body arrows can not be immediately accessed without a group", [114]: "Unexpected strict mode reserved word", [115]: "Unexpected eval or arguments in strict mode", [116]: "Decorators must not be followed by a semicolon", [117]: "Calling delete on expression not allowed in strict mode", [118]: "Pattern can not have a tail", [120]: "Can not have a `yield` expression on the left side of a ternary", [121]: "An arrow function can not have a postfix update operator", [122]: "Invalid object literal key character after generator star", [123]: "Private fields can not be deleted", [125]: "Classes may not have a field called constructor", [124]: "Classes may not have a private element named constructor", [126]: "A class field initializer may not contain arguments", [127]: "Generators can only be declared at the top level or inside a block", [128]: "Async methods are a restricted production and cannot have a newline following it", [129]: "Unexpected character after object literal property name", [131]: "Invalid key token", [132]: "Label '%0' has already been declared", [133]: "continue statement must be nested within an iteration statement", [134]: "Undefined label '%0'", [135]: "Trailing comma is disallowed inside import(...) arguments", [136]: "import() requires exactly one argument", [137]: "Cannot use new with import(...)", [138]: "... is not allowed in import()", [139]: "Expected '=>'", [140]: "Duplicate binding '%0'", [141]: "Cannot export a duplicate name '%0'", [144]: "Duplicate %0 for-binding", [142]: "Exported binding '%0' needs to refer to a top-level declared variable", [143]: "Unexpected private field", [147]: "Numeric separators are not allowed at the end of numeric literals", [146]: "Only one underscore is allowed as numeric separator", [148]: "JSX value should be either an expression or a quoted JSX text", [149]: "Expected corresponding JSX closing tag for %0", [150]: "Adjacent JSX elements must be wrapped in an enclosing tag", [151]: "JSX attributes must only be assigned a non-empty 'expression'", [152]: "'%0' has already been declared", [153]: "'%0' shadowed a catch clause binding", [154]: "Dot property must be an identifier", [155]: "Encountered invalid input after spread/rest argument", [156]: "Catch without try", [157]: "Finally without try", [158]: "Expected corresponding closing tag for JSX fragment", [159]: "Coalescing and logical operators used together in the same expression must be disambiguated with parentheses", [160]: "Invalid tagged template on optional chain", [161]: "Invalid optional chain from super property", [162]: "Invalid optional chain from new expression", [163]: 'Cannot use "import.meta" outside a module', [164]: "Leading decorators must be attached to a class declaration" }, k = class extends SyntaxError {
            constructor(u, e, i, n) {
              for (var t = arguments.length, o = new Array(t > 4 ? t - 4 : 0), l = 4; l < t; l++) o[l - 4] = arguments[l];
              let c = "[" + e + ":" + i + "]: " + m[n].replace(/%(\d+)/g, (s, h) => o[h]);
              super("".concat(c)), this.index = u, this.line = e, this.column = i, this.description = c, this.loc = { line: e, column: i };
            }
          };
          function f(u, e) {
            for (var i = arguments.length, n = new Array(i > 2 ? i - 2 : 0), t = 2; t < i; t++) n[t - 2] = arguments[t];
            throw new k(u.index, u.line, u.column, e, ...n);
          }
          function P(u) {
            throw new k(u.index, u.line, u.column, u.type, u.params);
          }
          function S(u, e, i, n) {
            for (var t = arguments.length, o = new Array(t > 4 ? t - 4 : 0), l = 4; l < t; l++) o[l - 4] = arguments[l];
            throw new k(u, e, i, n, ...o);
          }
          function q(u, e, i, n) {
            throw new k(u, e, i, n);
          }
          var T = ((u, e) => {
            let i = new Uint32Array(104448), n = 0, t = 0;
            for (; n < 3540; ) {
              let o = u[n++];
              if (o < 0) t -= o;
              else {
                let l = u[n++];
                o & 2 && (l = e[l]), o & 1 ? i.fill(l, t, t += u[n++]) : i[t++] = l;
              }
            }
            return i;
          })([-1, 2, 24, 2, 25, 2, 5, -1, 0, 77595648, 3, 44, 2, 3, 0, 14, 2, 57, 2, 58, 3, 0, 3, 0, 3168796671, 0, 4294956992, 2, 1, 2, 0, 2, 59, 3, 0, 4, 0, 4294966523, 3, 0, 4, 2, 16, 2, 60, 2, 0, 0, 4294836735, 0, 3221225471, 0, 4294901942, 2, 61, 0, 134152192, 3, 0, 2, 0, 4294951935, 3, 0, 2, 0, 2683305983, 0, 2684354047, 2, 17, 2, 0, 0, 4294961151, 3, 0, 2, 2, 19, 2, 0, 0, 608174079, 2, 0, 2, 131, 2, 6, 2, 56, -1, 2, 37, 0, 4294443263, 2, 1, 3, 0, 3, 0, 4294901711, 2, 39, 0, 4089839103, 0, 2961209759, 0, 1342439375, 0, 4294543342, 0, 3547201023, 0, 1577204103, 0, 4194240, 0, 4294688750, 2, 2, 0, 80831, 0, 4261478351, 0, 4294549486, 2, 2, 0, 2967484831, 0, 196559, 0, 3594373100, 0, 3288319768, 0, 8469959, 2, 194, 2, 3, 0, 3825204735, 0, 123747807, 0, 65487, 0, 4294828015, 0, 4092591615, 0, 1080049119, 0, 458703, 2, 3, 2, 0, 0, 2163244511, 0, 4227923919, 0, 4236247022, 2, 66, 0, 4284449919, 0, 851904, 2, 4, 2, 11, 0, 67076095, -1, 2, 67, 0, 1073741743, 0, 4093591391, -1, 0, 50331649, 0, 3265266687, 2, 32, 0, 4294844415, 0, 4278190047, 2, 18, 2, 129, -1, 3, 0, 2, 2, 21, 2, 0, 2, 9, 2, 0, 2, 14, 2, 15, 3, 0, 10, 2, 69, 2, 0, 2, 70, 2, 71, 2, 72, 2, 0, 2, 73, 2, 0, 2, 10, 0, 261632, 2, 23, 3, 0, 2, 2, 12, 2, 4, 3, 0, 18, 2, 74, 2, 5, 3, 0, 2, 2, 75, 0, 2088959, 2, 27, 2, 8, 0, 909311, 3, 0, 2, 0, 814743551, 2, 41, 0, 67057664, 3, 0, 2, 2, 40, 2, 0, 2, 28, 2, 0, 2, 29, 2, 7, 0, 268374015, 2, 26, 2, 49, 2, 0, 2, 76, 0, 134153215, -1, 2, 6, 2, 0, 2, 7, 0, 2684354559, 0, 67044351, 0, 3221160064, 0, 1, -1, 3, 0, 2, 2, 42, 0, 1046528, 3, 0, 3, 2, 8, 2, 0, 2, 51, 0, 4294960127, 2, 9, 2, 38, 2, 10, 0, 4294377472, 2, 11, 3, 0, 7, 0, 4227858431, 3, 0, 8, 2, 12, 2, 0, 2, 78, 2, 9, 2, 0, 2, 79, 2, 80, 2, 81, -1, 2, 124, 0, 1048577, 2, 82, 2, 13, -1, 2, 13, 0, 131042, 2, 83, 2, 84, 2, 85, 2, 0, 2, 33, -83, 2, 0, 2, 53, 2, 7, 3, 0, 4, 0, 1046559, 2, 0, 2, 14, 2, 0, 0, 2147516671, 2, 20, 3, 86, 2, 2, 0, -16, 2, 87, 0, 524222462, 2, 4, 2, 0, 0, 4269801471, 2, 4, 2, 0, 2, 15, 2, 77, 2, 16, 3, 0, 2, 2, 47, 2, 0, -1, 2, 17, -16, 3, 0, 206, -2, 3, 0, 655, 2, 18, 3, 0, 36, 2, 68, -1, 2, 17, 2, 9, 3, 0, 8, 2, 89, 2, 121, 2, 0, 0, 3220242431, 3, 0, 3, 2, 19, 2, 90, 2, 91, 3, 0, 2, 2, 92, 2, 0, 2, 93, 2, 94, 2, 0, 0, 4351, 2, 0, 2, 8, 3, 0, 2, 0, 67043391, 0, 3909091327, 2, 0, 2, 22, 2, 8, 2, 18, 3, 0, 2, 0, 67076097, 2, 7, 2, 0, 2, 20, 0, 67059711, 0, 4236247039, 3, 0, 2, 0, 939524103, 0, 8191999, 2, 97, 2, 98, 2, 15, 2, 21, 3, 0, 3, 0, 67057663, 3, 0, 349, 2, 99, 2, 100, 2, 6, -264, 3, 0, 11, 2, 22, 3, 0, 2, 2, 31, -1, 0, 3774349439, 2, 101, 2, 102, 3, 0, 2, 2, 19, 2, 103, 3, 0, 10, 2, 9, 2, 17, 2, 0, 2, 45, 2, 0, 2, 30, 2, 104, 2, 23, 0, 1638399, 2, 172, 2, 105, 3, 0, 3, 2, 18, 2, 24, 2, 25, 2, 5, 2, 26, 2, 0, 2, 7, 2, 106, -1, 2, 107, 2, 108, 2, 109, -1, 3, 0, 3, 2, 11, -2, 2, 0, 2, 27, -3, 2, 150, -4, 2, 18, 2, 0, 2, 35, 0, 1, 2, 0, 2, 62, 2, 28, 2, 11, 2, 9, 2, 0, 2, 110, -1, 3, 0, 4, 2, 9, 2, 21, 2, 111, 2, 6, 2, 0, 2, 112, 2, 0, 2, 48, -4, 3, 0, 9, 2, 20, 2, 29, 2, 30, -4, 2, 113, 2, 114, 2, 29, 2, 20, 2, 7, -2, 2, 115, 2, 29, 2, 31, -2, 2, 0, 2, 116, -2, 0, 4277137519, 0, 2269118463, -1, 3, 18, 2, -1, 2, 32, 2, 36, 2, 0, 3, 29, 2, 2, 34, 2, 19, -3, 3, 0, 2, 2, 33, -1, 2, 0, 2, 34, 2, 0, 2, 34, 2, 0, 2, 46, -10, 2, 0, 0, 203775, -2, 2, 18, 2, 43, 2, 35, -2, 2, 17, 2, 117, 2, 20, 3, 0, 2, 2, 36, 0, 2147549120, 2, 0, 2, 11, 2, 17, 2, 135, 2, 0, 2, 37, 2, 52, 0, 5242879, 3, 0, 2, 0, 402644511, -1, 2, 120, 0, 1090519039, -2, 2, 122, 2, 38, 2, 0, 0, 67045375, 2, 39, 0, 4226678271, 0, 3766565279, 0, 2039759, -4, 3, 0, 2, 0, 3288270847, 0, 3, 3, 0, 2, 0, 67043519, -5, 2, 0, 0, 4282384383, 0, 1056964609, -1, 3, 0, 2, 0, 67043345, -1, 2, 0, 2, 40, 2, 41, -1, 2, 10, 2, 42, -6, 2, 0, 2, 11, -3, 3, 0, 2, 0, 2147484671, 2, 125, 0, 4190109695, 2, 50, -2, 2, 126, 0, 4244635647, 0, 27, 2, 0, 2, 7, 2, 43, 2, 0, 2, 63, -1, 2, 0, 2, 40, -8, 2, 54, 2, 44, 0, 67043329, 2, 127, 2, 45, 0, 8388351, -2, 2, 128, 0, 3028287487, 2, 46, 2, 130, 0, 33259519, 2, 41, -9, 2, 20, -5, 2, 64, -2, 3, 0, 28, 2, 31, -3, 3, 0, 3, 2, 47, 3, 0, 6, 2, 48, -85, 3, 0, 33, 2, 47, -126, 3, 0, 18, 2, 36, -269, 3, 0, 17, 2, 40, 2, 7, 2, 41, -2, 2, 17, 2, 49, 2, 0, 2, 20, 2, 50, 2, 132, 2, 23, -21, 3, 0, 2, -4, 3, 0, 2, 0, 4294936575, 2, 0, 0, 4294934783, -2, 0, 196635, 3, 0, 191, 2, 51, 3, 0, 38, 2, 29, -1, 2, 33, -279, 3, 0, 8, 2, 7, -1, 2, 133, 2, 52, 3, 0, 11, 2, 6, -72, 3, 0, 3, 2, 134, 0, 1677656575, -166, 0, 4161266656, 0, 4071, 0, 15360, -4, 0, 28, -13, 3, 0, 2, 2, 37, 2, 0, 2, 136, 2, 137, 2, 55, 2, 0, 2, 138, 2, 139, 2, 140, 3, 0, 10, 2, 141, 2, 142, 2, 15, 3, 37, 2, 3, 53, 2, 3, 54, 2, 0, 4294954999, 2, 0, -16, 2, 0, 2, 88, 2, 0, 0, 2105343, 0, 4160749584, 0, 65534, -42, 0, 4194303871, 0, 2011, -6, 2, 0, 0, 1073684479, 0, 17407, -11, 2, 0, 2, 31, -40, 3, 0, 6, 0, 8323103, -1, 3, 0, 2, 2, 42, -37, 2, 55, 2, 144, 2, 145, 2, 146, 2, 147, 2, 148, -105, 2, 24, -32, 3, 0, 1334, 2, 9, -1, 3, 0, 129, 2, 27, 3, 0, 6, 2, 9, 3, 0, 180, 2, 149, 3, 0, 233, 0, 1, -96, 3, 0, 16, 2, 9, -47, 3, 0, 154, 2, 56, -22381, 3, 0, 7, 2, 23, -6130, 3, 5, 2, -1, 0, 69207040, 3, 44, 2, 3, 0, 14, 2, 57, 2, 58, -3, 0, 3168731136, 0, 4294956864, 2, 1, 2, 0, 2, 59, 3, 0, 4, 0, 4294966275, 3, 0, 4, 2, 16, 2, 60, 2, 0, 2, 33, -1, 2, 17, 2, 61, -1, 2, 0, 2, 56, 0, 4294885376, 3, 0, 2, 0, 3145727, 0, 2617294944, 0, 4294770688, 2, 23, 2, 62, 3, 0, 2, 0, 131135, 2, 95, 0, 70256639, 0, 71303167, 0, 272, 2, 40, 2, 56, -1, 2, 37, 2, 30, -1, 2, 96, 2, 63, 0, 4278255616, 0, 4294836227, 0, 4294549473, 0, 600178175, 0, 2952806400, 0, 268632067, 0, 4294543328, 0, 57540095, 0, 1577058304, 0, 1835008, 0, 4294688736, 2, 65, 2, 64, 0, 33554435, 2, 123, 2, 65, 2, 151, 0, 131075, 0, 3594373096, 0, 67094296, 2, 64, -1, 0, 4294828e3, 0, 603979263, 2, 160, 0, 3, 0, 4294828001, 0, 602930687, 2, 183, 0, 393219, 0, 4294828016, 0, 671088639, 0, 2154840064, 0, 4227858435, 0, 4236247008, 2, 66, 2, 36, -1, 2, 4, 0, 917503, 2, 36, -1, 2, 67, 0, 537788335, 0, 4026531935, -1, 0, 1, -1, 2, 32, 2, 68, 0, 7936, -3, 2, 0, 0, 2147485695, 0, 1010761728, 0, 4292984930, 0, 16387, 2, 0, 2, 14, 2, 15, 3, 0, 10, 2, 69, 2, 0, 2, 70, 2, 71, 2, 72, 2, 0, 2, 73, 2, 0, 2, 11, -1, 2, 23, 3, 0, 2, 2, 12, 2, 4, 3, 0, 18, 2, 74, 2, 5, 3, 0, 2, 2, 75, 0, 253951, 3, 19, 2, 0, 122879, 2, 0, 2, 8, 0, 276824064, -2, 3, 0, 2, 2, 40, 2, 0, 0, 4294903295, 2, 0, 2, 29, 2, 7, -1, 2, 17, 2, 49, 2, 0, 2, 76, 2, 41, -1, 2, 20, 2, 0, 2, 27, -2, 0, 128, -2, 2, 77, 2, 8, 0, 4064, -1, 2, 119, 0, 4227907585, 2, 0, 2, 118, 2, 0, 2, 48, 2, 173, 2, 9, 2, 38, 2, 10, -1, 0, 74440192, 3, 0, 6, -2, 3, 0, 8, 2, 12, 2, 0, 2, 78, 2, 9, 2, 0, 2, 79, 2, 80, 2, 81, -3, 2, 82, 2, 13, -3, 2, 83, 2, 84, 2, 85, 2, 0, 2, 33, -83, 2, 0, 2, 53, 2, 7, 3, 0, 4, 0, 817183, 2, 0, 2, 14, 2, 0, 0, 33023, 2, 20, 3, 86, 2, -17, 2, 87, 0, 524157950, 2, 4, 2, 0, 2, 88, 2, 4, 2, 0, 2, 15, 2, 77, 2, 16, 3, 0, 2, 2, 47, 2, 0, -1, 2, 17, -16, 3, 0, 206, -2, 3, 0, 655, 2, 18, 3, 0, 36, 2, 68, -1, 2, 17, 2, 9, 3, 0, 8, 2, 89, 0, 3072, 2, 0, 0, 2147516415, 2, 9, 3, 0, 2, 2, 23, 2, 90, 2, 91, 3, 0, 2, 2, 92, 2, 0, 2, 93, 2, 94, 0, 4294965179, 0, 7, 2, 0, 2, 8, 2, 91, 2, 8, -1, 0, 1761345536, 2, 95, 0, 4294901823, 2, 36, 2, 18, 2, 96, 2, 34, 2, 166, 0, 2080440287, 2, 0, 2, 33, 2, 143, 0, 3296722943, 2, 0, 0, 1046675455, 0, 939524101, 0, 1837055, 2, 97, 2, 98, 2, 15, 2, 21, 3, 0, 3, 0, 7, 3, 0, 349, 2, 99, 2, 100, 2, 6, -264, 3, 0, 11, 2, 22, 3, 0, 2, 2, 31, -1, 0, 2700607615, 2, 101, 2, 102, 3, 0, 2, 2, 19, 2, 103, 3, 0, 10, 2, 9, 2, 17, 2, 0, 2, 45, 2, 0, 2, 30, 2, 104, -3, 2, 105, 3, 0, 3, 2, 18, -1, 3, 5, 2, 2, 26, 2, 0, 2, 7, 2, 106, -1, 2, 107, 2, 108, 2, 109, -1, 3, 0, 3, 2, 11, -2, 2, 0, 2, 27, -8, 2, 18, 2, 0, 2, 35, -1, 2, 0, 2, 62, 2, 28, 2, 29, 2, 9, 2, 0, 2, 110, -1, 3, 0, 4, 2, 9, 2, 17, 2, 111, 2, 6, 2, 0, 2, 112, 2, 0, 2, 48, -4, 3, 0, 9, 2, 20, 2, 29, 2, 30, -4, 2, 113, 2, 114, 2, 29, 2, 20, 2, 7, -2, 2, 115, 2, 29, 2, 31, -2, 2, 0, 2, 116, -2, 0, 4277075969, 2, 29, -1, 3, 18, 2, -1, 2, 32, 2, 117, 2, 0, 3, 29, 2, 2, 34, 2, 19, -3, 3, 0, 2, 2, 33, -1, 2, 0, 2, 34, 2, 0, 2, 34, 2, 0, 2, 48, -10, 2, 0, 0, 197631, -2, 2, 18, 2, 43, 2, 118, -2, 2, 17, 2, 117, 2, 20, 2, 119, 2, 51, -2, 2, 119, 2, 23, 2, 17, 2, 33, 2, 119, 2, 36, 0, 4294901904, 0, 4718591, 2, 119, 2, 34, 0, 335544350, -1, 2, 120, 2, 121, -2, 2, 122, 2, 38, 2, 7, -1, 2, 123, 2, 65, 0, 3758161920, 0, 3, -4, 2, 0, 2, 27, 0, 2147485568, 0, 3, 2, 0, 2, 23, 0, 176, -5, 2, 0, 2, 47, 2, 186, -1, 2, 0, 2, 23, 2, 197, -1, 2, 0, 0, 16779263, -2, 2, 11, -7, 2, 0, 2, 121, -3, 3, 0, 2, 2, 124, 2, 125, 0, 2147549183, 0, 2, -2, 2, 126, 2, 35, 0, 10, 0, 4294965249, 0, 67633151, 0, 4026597376, 2, 0, 0, 536871935, -1, 2, 0, 2, 40, -8, 2, 54, 2, 47, 0, 1, 2, 127, 2, 23, -3, 2, 128, 2, 35, 2, 129, 2, 130, 0, 16778239, -10, 2, 34, -5, 2, 64, -2, 3, 0, 28, 2, 31, -3, 3, 0, 3, 2, 47, 3, 0, 6, 2, 48, -85, 3, 0, 33, 2, 47, -126, 3, 0, 18, 2, 36, -269, 3, 0, 17, 2, 40, 2, 7, -3, 2, 17, 2, 131, 2, 0, 2, 23, 2, 48, 2, 132, 2, 23, -21, 3, 0, 2, -4, 3, 0, 2, 0, 67583, -1, 2, 103, -2, 0, 11, 3, 0, 191, 2, 51, 3, 0, 38, 2, 29, -1, 2, 33, -279, 3, 0, 8, 2, 7, -1, 2, 133, 2, 52, 3, 0, 11, 2, 6, -72, 3, 0, 3, 2, 134, 2, 135, -187, 3, 0, 2, 2, 37, 2, 0, 2, 136, 2, 137, 2, 55, 2, 0, 2, 138, 2, 139, 2, 140, 3, 0, 10, 2, 141, 2, 142, 2, 15, 3, 37, 2, 3, 53, 2, 3, 54, 2, 2, 143, -73, 2, 0, 0, 1065361407, 0, 16384, -11, 2, 0, 2, 121, -40, 3, 0, 6, 2, 117, -1, 3, 0, 2, 0, 2063, -37, 2, 55, 2, 144, 2, 145, 2, 146, 2, 147, 2, 148, -138, 3, 0, 1334, 2, 9, -1, 3, 0, 129, 2, 27, 3, 0, 6, 2, 9, 3, 0, 180, 2, 149, 3, 0, 233, 0, 1, -96, 3, 0, 16, 2, 9, -47, 3, 0, 154, 2, 56, -28517, 2, 0, 0, 1, -1, 2, 124, 2, 0, 0, 8193, -21, 2, 193, 0, 10255, 0, 4, -11, 2, 64, 2, 171, -1, 0, 71680, -1, 2, 161, 0, 4292900864, 0, 805306431, -5, 2, 150, -1, 2, 157, -1, 0, 6144, -2, 2, 127, -1, 2, 154, -1, 0, 2147532800, 2, 151, 2, 165, 2, 0, 2, 164, 0, 524032, 0, 4, -4, 2, 190, 0, 205128192, 0, 1333757536, 0, 2147483696, 0, 423953, 0, 747766272, 0, 2717763192, 0, 4286578751, 0, 278545, 2, 152, 0, 4294886464, 0, 33292336, 0, 417809, 2, 152, 0, 1327482464, 0, 4278190128, 0, 700594195, 0, 1006647527, 0, 4286497336, 0, 4160749631, 2, 153, 0, 469762560, 0, 4171219488, 0, 8323120, 2, 153, 0, 202375680, 0, 3214918176, 0, 4294508592, 2, 153, -1, 0, 983584, 0, 48, 0, 58720273, 0, 3489923072, 0, 10517376, 0, 4293066815, 0, 1, 0, 2013265920, 2, 177, 2, 0, 0, 2089, 0, 3221225552, 0, 201375904, 2, 0, -2, 0, 256, 0, 122880, 0, 16777216, 2, 150, 0, 4160757760, 2, 0, -6, 2, 167, -11, 0, 3263218176, -1, 0, 49664, 0, 2160197632, 0, 8388802, -1, 0, 12713984, -1, 2, 154, 2, 159, 2, 178, -2, 2, 162, -20, 0, 3758096385, -2, 2, 155, 0, 4292878336, 2, 90, 2, 169, 0, 4294057984, -2, 2, 163, 2, 156, 2, 175, -2, 2, 155, -1, 2, 182, -1, 2, 170, 2, 124, 0, 4026593280, 0, 14, 0, 4292919296, -1, 2, 158, 0, 939588608, -1, 0, 805306368, -1, 2, 124, 0, 1610612736, 2, 156, 2, 157, 2, 4, 2, 0, -2, 2, 158, 2, 159, -3, 0, 267386880, -1, 2, 160, 0, 7168, -1, 0, 65024, 2, 154, 2, 161, 2, 179, -7, 2, 168, -8, 2, 162, -1, 0, 1426112704, 2, 163, -1, 2, 164, 0, 271581216, 0, 2149777408, 2, 23, 2, 161, 2, 124, 0, 851967, 2, 180, -1, 2, 23, 2, 181, -4, 2, 158, -20, 2, 195, 2, 165, -56, 0, 3145728, 2, 185, -4, 2, 166, 2, 124, -4, 0, 32505856, -1, 2, 167, -1, 0, 2147385088, 2, 90, 1, 2155905152, 2, -3, 2, 103, 2, 0, 2, 168, -2, 2, 169, -6, 2, 170, 0, 4026597375, 0, 1, -1, 0, 1, -1, 2, 171, -3, 2, 117, 2, 64, -2, 2, 166, -2, 2, 176, 2, 124, -878, 2, 159, -36, 2, 172, -1, 2, 201, -10, 2, 188, -5, 2, 174, -6, 0, 4294965251, 2, 27, -1, 2, 173, -1, 2, 174, -2, 0, 4227874752, -3, 0, 2146435072, 2, 159, -2, 0, 1006649344, 2, 124, -1, 2, 90, 0, 201375744, -3, 0, 134217720, 2, 90, 0, 4286677377, 0, 32896, -1, 2, 158, -3, 2, 175, -349, 2, 176, 0, 1920, 2, 177, 3, 0, 264, -11, 2, 157, -2, 2, 178, 2, 0, 0, 520617856, 0, 2692743168, 0, 36, -3, 0, 524284, -11, 2, 23, -1, 2, 187, -1, 2, 184, 0, 3221291007, 2, 178, -1, 2, 202, 0, 2158720, -3, 2, 159, 0, 1, -4, 2, 124, 0, 3808625411, 0, 3489628288, 2, 200, 0, 1207959680, 0, 3221274624, 2, 0, -3, 2, 179, 0, 120, 0, 7340032, -2, 2, 180, 2, 4, 2, 23, 2, 163, 3, 0, 4, 2, 159, -1, 2, 181, 2, 177, -1, 0, 8176, 2, 182, 2, 179, 2, 183, -1, 0, 4290773232, 2, 0, -4, 2, 163, 2, 189, 0, 15728640, 2, 177, -1, 2, 161, -1, 0, 4294934512, 3, 0, 4, -9, 2, 90, 2, 170, 2, 184, 3, 0, 4, 0, 704, 0, 1849688064, 2, 185, -1, 2, 124, 0, 4294901887, 2, 0, 0, 130547712, 0, 1879048192, 2, 199, 3, 0, 2, -1, 2, 186, 2, 187, -1, 0, 17829776, 0, 2025848832, 0, 4261477888, -2, 2, 0, -1, 0, 4286580608, -1, 0, 29360128, 2, 192, 0, 16252928, 0, 3791388672, 2, 38, 3, 0, 2, -2, 2, 196, 2, 0, -1, 2, 103, -1, 0, 66584576, -1, 2, 191, 3, 0, 9, 2, 124, -1, 0, 4294755328, 3, 0, 2, -1, 2, 161, 2, 178, 3, 0, 2, 2, 23, 2, 188, 2, 90, -2, 0, 245760, 0, 2147418112, -1, 2, 150, 2, 203, 0, 4227923456, -1, 2, 164, 2, 161, 2, 90, -3, 0, 4292870145, 0, 262144, 2, 124, 3, 0, 2, 0, 1073758848, 2, 189, -1, 0, 4227921920, 2, 190, 0, 68289024, 0, 528402016, 0, 4292927536, 3, 0, 4, -2, 0, 268435456, 2, 91, -2, 2, 191, 3, 0, 5, -1, 2, 192, 2, 163, 2, 0, -2, 0, 4227923936, 2, 62, -1, 2, 155, 2, 95, 2, 0, 2, 154, 2, 158, 3, 0, 6, -1, 2, 177, 3, 0, 3, -2, 0, 2146959360, 0, 9440640, 0, 104857600, 0, 4227923840, 3, 0, 2, 0, 768, 2, 193, 2, 77, -2, 2, 161, -2, 2, 119, -1, 2, 155, 3, 0, 8, 0, 512, 0, 8388608, 2, 194, 2, 172, 2, 187, 0, 4286578944, 3, 0, 2, 0, 1152, 0, 1266679808, 2, 191, 0, 576, 0, 4261707776, 2, 95, 3, 0, 9, 2, 155, 3, 0, 5, 2, 16, -1, 0, 2147221504, -28, 2, 178, 3, 0, 3, -3, 0, 4292902912, -6, 2, 96, 3, 0, 85, -33, 0, 4294934528, 3, 0, 126, -18, 2, 195, 3, 0, 269, -17, 2, 155, 2, 124, 2, 198, 3, 0, 2, 2, 23, 0, 4290822144, -2, 0, 67174336, 0, 520093700, 2, 17, 3, 0, 21, -2, 2, 179, 3, 0, 3, -2, 0, 30720, -1, 0, 32512, 3, 0, 2, 0, 4294770656, -191, 2, 174, -38, 2, 170, 2, 0, 2, 196, 3, 0, 279, -8, 2, 124, 2, 0, 0, 4294508543, 0, 65295, -11, 2, 177, 3, 0, 72, -3, 0, 3758159872, 0, 201391616, 3, 0, 155, -7, 2, 170, -1, 0, 384, -1, 0, 133693440, -3, 2, 196, -2, 2, 26, 3, 0, 4, 2, 169, -2, 2, 90, 2, 155, 3, 0, 4, -2, 2, 164, -1, 2, 150, 0, 335552923, 2, 197, -1, 0, 538974272, 0, 2214592512, 0, 132e3, -10, 0, 192, -8, 0, 12288, -21, 0, 134213632, 0, 4294901761, 3, 0, 42, 0, 100663424, 0, 4294965284, 3, 0, 6, -1, 0, 3221282816, 2, 198, 3, 0, 11, -1, 2, 199, 3, 0, 40, -6, 0, 4286578784, 2, 0, -2, 0, 1006694400, 3, 0, 24, 2, 35, -1, 2, 94, 3, 0, 2, 0, 1, 2, 163, 3, 0, 6, 2, 197, 0, 4110942569, 0, 1432950139, 0, 2701658217, 0, 4026532864, 0, 4026532881, 2, 0, 2, 45, 3, 0, 8, -1, 2, 158, -2, 2, 169, 0, 98304, 0, 65537, 2, 170, -5, 0, 4294950912, 2, 0, 2, 118, 0, 65528, 2, 177, 0, 4294770176, 2, 26, 3, 0, 4, -30, 2, 174, 0, 3758153728, -3, 2, 169, -2, 2, 155, 2, 188, 2, 158, -1, 2, 191, -1, 2, 161, 0, 4294754304, 3, 0, 2, -3, 0, 33554432, -2, 2, 200, -3, 2, 169, 0, 4175478784, 2, 201, 0, 4286643712, 0, 4286644216, 2, 0, -4, 2, 202, -1, 2, 165, 0, 4227923967, 3, 0, 32, -1334, 2, 163, 2, 0, -129, 2, 94, -6, 2, 163, -180, 2, 203, -233, 2, 4, 3, 0, 96, -16, 2, 163, 3, 0, 47, -154, 2, 165, 3, 0, 22381, -7, 2, 17, 3, 0, 6128], [4294967295, 4294967291, 4092460543, 4294828031, 4294967294, 134217726, 268435455, 2147483647, 1048575, 1073741823, 3892314111, 134217727, 1061158911, 536805376, 4294910143, 4160749567, 4294901759, 4294901760, 536870911, 262143, 8388607, 4294902783, 4294918143, 65535, 67043328, 2281701374, 4294967232, 2097151, 4294903807, 4194303, 255, 67108863, 4294967039, 511, 524287, 131071, 127, 4292870143, 4294902271, 4294549487, 33554431, 1023, 67047423, 4294901888, 4286578687, 4294770687, 67043583, 32767, 15, 2047999, 67043343, 16777215, 4294902e3, 4294934527, 4294966783, 4294967279, 2047, 262083, 20511, 4290772991, 41943039, 493567, 4294959104, 603979775, 65536, 602799615, 805044223, 4294965206, 8191, 1031749119, 4294917631, 2134769663, 4286578493, 4282253311, 4294942719, 33540095, 4294905855, 4294967264, 2868854591, 1608515583, 265232348, 534519807, 2147614720, 1060109444, 4093640016, 17376, 2139062143, 224, 4169138175, 4294909951, 4286578688, 4294967292, 4294965759, 2044, 4292870144, 4294966272, 4294967280, 8289918, 4294934399, 4294901775, 4294965375, 1602223615, 4294967259, 4294443008, 268369920, 4292804608, 486341884, 4294963199, 3087007615, 1073692671, 4128527, 4279238655, 4294902015, 4294966591, 2445279231, 3670015, 3238002687, 31, 63, 4294967288, 4294705151, 4095, 3221208447, 4294549472, 2147483648, 4285526655, 4294966527, 4294705152, 4294966143, 64, 4294966719, 16383, 3774873592, 458752, 536807423, 67043839, 3758096383, 3959414372, 3755993023, 2080374783, 4294835295, 4294967103, 4160749565, 4087, 184024726, 2862017156, 1593309078, 268434431, 268434414, 4294901763, 536870912, 2952790016, 202506752, 139264, 402653184, 4261412864, 4227922944, 49152, 61440, 3758096384, 117440512, 65280, 3233808384, 3221225472, 2097152, 4294965248, 32768, 57152, 67108864, 4293918720, 4290772992, 25165824, 57344, 4227915776, 4278190080, 4227907584, 65520, 4026531840, 4227858432, 4160749568, 3758129152, 4294836224, 63488, 1073741824, 4294967040, 4194304, 251658240, 196608, 4294963200, 64512, 417808, 4227923712, 12582912, 50331648, 65472, 4294967168, 4294966784, 16, 4294917120, 2080374784, 4096, 65408, 524288, 65532]);
          function r(u) {
            return u.column++, u.currentChar = u.source.charCodeAt(++u.index);
          }
          function K(u, e) {
            if ((e & 64512) !== 55296) return 0;
            let i = u.source.charCodeAt(u.index + 1);
            return (i & 64512) !== 56320 ? 0 : (e = u.currentChar = 65536 + ((e & 1023) << 10) + (i & 1023), (T[(e >>> 5) + 0] >>> e & 31 & 1) === 0 && f(u, 18, Z(e)), u.index++, u.column++, 1);
          }
          function Y(u, e) {
            u.currentChar = u.source.charCodeAt(++u.index), u.flags |= 1, (e & 4) === 0 && (u.column = 0, u.line++);
          }
          function X(u) {
            u.flags |= 1, u.currentChar = u.source.charCodeAt(++u.index), u.column = 0, u.line++;
          }
          function p(u) {
            return u === 160 || u === 65279 || u === 133 || u === 5760 || u >= 8192 && u <= 8203 || u === 8239 || u === 8287 || u === 12288 || u === 8201 || u === 65519;
          }
          function Z(u) {
            return u <= 65535 ? String.fromCharCode(u) : String.fromCharCode(u >>> 10) + String.fromCharCode(u & 1023);
          }
          function L(u) {
            return u < 65 ? u - 48 : u - 65 + 10 & 15;
          }
          function t2(u) {
            switch (u) {
              case 134283266:
                return "NumericLiteral";
              case 134283267:
                return "StringLiteral";
              case 86021:
              case 86022:
                return "BooleanLiteral";
              case 86023:
                return "NullLiteral";
              case 65540:
                return "RegularExpression";
              case 67174408:
              case 67174409:
              case 132:
                return "TemplateLiteral";
              default:
                return (u & 143360) === 143360 ? "Identifier" : (u & 4096) === 4096 ? "Keyword" : "Punctuator";
            }
          }
          var V = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1032, 0, 0, 2056, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8192, 0, 3, 0, 0, 8192, 0, 0, 0, 256, 0, 33024, 0, 0, 242, 242, 114, 114, 114, 114, 114, 114, 594, 594, 0, 0, 16384, 0, 0, 0, 0, 67, 67, 67, 67, 67, 67, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 0, 1, 0, 0, 4099, 0, 71, 71, 71, 71, 71, 71, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 16384, 0, 0, 0, 0], J = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0], H = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0];
          function I(u) {
            return u <= 127 ? J[u] : T[(u >>> 5) + 34816] >>> u & 31 & 1;
          }
          function u2(u) {
            return u <= 127 ? H[u] : T[(u >>> 5) + 0] >>> u & 31 & 1 || u === 8204 || u === 8205;
          }
          var m2 = ["SingleLine", "MultiLine", "HTMLOpen", "HTMLClose", "HashbangComment"];
          function c2(u) {
            let e = u.source;
            u.currentChar === 35 && e.charCodeAt(u.index + 1) === 33 && (r(u), r(u), s2(u, e, 0, 4, u.tokenPos, u.linePos, u.colPos));
          }
          function R2(u, e, i, n, t, o, l, c) {
            return n & 2048 && f(u, 0), s2(u, e, i, t, o, l, c);
          }
          function s2(u, e, i, n, t, o, l) {
            let { index: c } = u;
            for (u.tokenPos = u.index, u.linePos = u.line, u.colPos = u.column; u.index < u.end; ) {
              if (V[u.currentChar] & 8) {
                let s = u.currentChar === 13;
                X(u), s && u.index < u.end && u.currentChar === 10 && (u.currentChar = e.charCodeAt(++u.index));
                break;
              } else if ((u.currentChar ^ 8232) <= 1) {
                X(u);
                break;
              }
              r(u), u.tokenPos = u.index, u.linePos = u.line, u.colPos = u.column;
            }
            if (u.onComment) {
              let s = { start: { line: o, column: l }, end: { line: u.linePos, column: u.colPos } };
              u.onComment(m2[n & 255], e.slice(c, u.tokenPos), t, u.tokenPos, s);
            }
            return i | 1;
          }
          function N2(u, e, i) {
            let { index: n } = u;
            for (; u.index < u.end; ) if (u.currentChar < 43) {
              let t = false;
              for (; u.currentChar === 42; ) if (t || (i &= -5, t = true), r(u) === 47) {
                if (r(u), u.onComment) {
                  let o = { start: { line: u.linePos, column: u.colPos }, end: { line: u.line, column: u.column } };
                  u.onComment(m2[1], e.slice(n, u.index - 2), n - 2, u.index, o);
                }
                return u.tokenPos = u.index, u.linePos = u.line, u.colPos = u.column, i;
              }
              if (t) continue;
              V[u.currentChar] & 8 ? u.currentChar === 13 ? (i |= 5, X(u)) : (Y(u, i), i = i & -5 | 1) : r(u);
            } else (u.currentChar ^ 8232) <= 1 ? (i = i & -5 | 1, X(u)) : (i &= -5, r(u));
            f(u, 16);
          }
          function w2(u, e) {
            let i = u.index, n = 0;
            u: for (; ; ) {
              let b = u.currentChar;
              if (r(u), n & 1) n &= -2;
              else switch (b) {
                case 47:
                  if (n) break;
                  break u;
                case 92:
                  n |= 1;
                  break;
                case 91:
                  n |= 2;
                  break;
                case 93:
                  n &= 1;
                  break;
                case 13:
                case 10:
                case 8232:
                case 8233:
                  f(u, 32);
              }
              if (u.index >= u.source.length) return f(u, 32);
            }
            let t = u.index - 1, o = 0, l = u.currentChar, { index: c } = u;
            for (; u2(l); ) {
              switch (l) {
                case 103:
                  o & 2 && f(u, 34, "g"), o |= 2;
                  break;
                case 105:
                  o & 1 && f(u, 34, "i"), o |= 1;
                  break;
                case 109:
                  o & 4 && f(u, 34, "m"), o |= 4;
                  break;
                case 117:
                  o & 16 && f(u, 34, "g"), o |= 16;
                  break;
                case 121:
                  o & 8 && f(u, 34, "y"), o |= 8;
                  break;
                case 115:
                  o & 32 && f(u, 34, "s"), o |= 32;
                  break;
                default:
                  f(u, 33);
              }
              l = r(u);
            }
            let s = u.source.slice(c, u.index), h = u.source.slice(i, t);
            return u.tokenRegExp = { pattern: h, flags: s }, e & 512 && (u.tokenRaw = u.source.slice(u.tokenPos, u.index)), u.tokenValue = O1(u, h, s), 65540;
          }
          function O1(u, e, i) {
            try {
              return new RegExp(e, i);
            } catch {
              f(u, 32);
            }
          }
          function I1(u, e, i) {
            let { index: n } = u, t = "", o = r(u), l = u.index;
            for (; (V[o] & 8) === 0; ) {
              if (o === i) return t += u.source.slice(l, u.index), r(u), e & 512 && (u.tokenRaw = u.source.slice(n, u.index)), u.tokenValue = t, 134283267;
              if ((o & 8) === 8 && o === 92) {
                if (t += u.source.slice(l, u.index), o = r(u), o < 127 || o === 8232 || o === 8233) {
                  let c = g2(u, e, o);
                  c >= 0 ? t += Z(c) : n1(u, c, 0);
                } else t += Z(o);
                l = u.index + 1;
              }
              u.index >= u.end && f(u, 14), o = r(u);
            }
            f(u, 14);
          }
          function g2(u, e, i) {
            switch (i) {
              case 98:
                return 8;
              case 102:
                return 12;
              case 114:
                return 13;
              case 110:
                return 10;
              case 116:
                return 9;
              case 118:
                return 11;
              case 13:
                if (u.index < u.end) {
                  let n = u.source.charCodeAt(u.index + 1);
                  n === 10 && (u.index = u.index + 1, u.currentChar = n);
                }
              case 10:
              case 8232:
              case 8233:
                return u.column = -1, u.line++, -1;
              case 48:
              case 49:
              case 50:
              case 51: {
                let n = i - 48, t = u.index + 1, o = u.column + 1;
                if (t < u.end) {
                  let l = u.source.charCodeAt(t);
                  if ((V[l] & 32) === 0) {
                    if ((n !== 0 || V[l] & 512) && e & 1024) return -2;
                  } else {
                    if (e & 1024) return -2;
                    if (u.currentChar = l, n = n << 3 | l - 48, t++, o++, t < u.end) {
                      let c = u.source.charCodeAt(t);
                      V[c] & 32 && (u.currentChar = c, n = n << 3 | c - 48, t++, o++);
                    }
                    u.flags |= 64, u.index = t - 1, u.column = o - 1;
                  }
                }
                return n;
              }
              case 52:
              case 53:
              case 54:
              case 55: {
                if (e & 1024) return -2;
                let n = i - 48, t = u.index + 1, o = u.column + 1;
                if (t < u.end) {
                  let l = u.source.charCodeAt(t);
                  V[l] & 32 && (n = n << 3 | l - 48, u.currentChar = l, u.index = t, u.column = o);
                }
                return u.flags |= 64, n;
              }
              case 120: {
                let n = r(u);
                if ((V[n] & 64) === 0) return -4;
                let t = L(n), o = r(u);
                if ((V[o] & 64) === 0) return -4;
                let l = L(o);
                return t << 4 | l;
              }
              case 117: {
                let n = r(u);
                if (u.currentChar === 123) {
                  let t = 0;
                  for (; (V[r(u)] & 64) !== 0; ) if (t = t << 4 | L(u.currentChar), t > 1114111) return -5;
                  return u.currentChar < 1 || u.currentChar !== 125 ? -4 : t;
                } else {
                  if ((V[n] & 64) === 0) return -4;
                  let t = u.source.charCodeAt(u.index + 1);
                  if ((V[t] & 64) === 0) return -4;
                  let o = u.source.charCodeAt(u.index + 2);
                  if ((V[o] & 64) === 0) return -4;
                  let l = u.source.charCodeAt(u.index + 3);
                  return (V[l] & 64) === 0 ? -4 : (u.index += 3, u.column += 3, u.currentChar = u.source.charCodeAt(u.index), L(n) << 12 | L(t) << 8 | L(o) << 4 | L(l));
                }
              }
              case 56:
              case 57:
                if ((e & 256) === 0) return -3;
              default:
                return i;
            }
          }
          function n1(u, e, i) {
            switch (e) {
              case -1:
                return;
              case -2:
                f(u, i ? 2 : 1);
              case -3:
                f(u, 13);
              case -4:
                f(u, 6);
              case -5:
                f(u, 101);
            }
          }
          function Ju(u, e) {
            let { index: i } = u, n = 67174409, t = "", o = r(u);
            for (; o !== 96; ) {
              if (o === 36 && u.source.charCodeAt(u.index + 1) === 123) {
                r(u), n = 67174408;
                break;
              } else if ((o & 8) === 8 && o === 92) if (o = r(u), o > 126) t += Z(o);
              else {
                let l = g2(u, e | 1024, o);
                if (l >= 0) t += Z(l);
                else if (l !== -1 && e & 65536) {
                  t = void 0, o = r0(u, o), o < 0 && (n = 67174408);
                  break;
                } else n1(u, l, 1);
              }
              else u.index < u.end && o === 13 && u.source.charCodeAt(u.index) === 10 && (t += Z(o), u.currentChar = u.source.charCodeAt(++u.index)), ((o & 83) < 3 && o === 10 || (o ^ 8232) <= 1) && (u.column = -1, u.line++), t += Z(o);
              u.index >= u.end && f(u, 15), o = r(u);
            }
            return r(u), u.tokenValue = t, u.tokenRaw = u.source.slice(i + 1, u.index - (n === 67174409 ? 1 : 2)), n;
          }
          function r0(u, e) {
            for (; e !== 96; ) {
              switch (e) {
                case 36: {
                  let i = u.index + 1;
                  if (i < u.end && u.source.charCodeAt(i) === 123) return u.index = i, u.column++, -e;
                  break;
                }
                case 10:
                case 8232:
                case 8233:
                  u.column = -1, u.line++;
              }
              u.index >= u.end && f(u, 15), e = r(u);
            }
            return e;
          }
          function v0(u, e) {
            return u.index >= u.end && f(u, 0), u.index--, u.column--, Ju(u, e);
          }
          function Xu(u, e, i) {
            let n = u.currentChar, t = 0, o = 9, l = i & 64 ? 0 : 1, c = 0, s = 0;
            if (i & 64) t = "." + t1(u, n), n = u.currentChar, n === 110 && f(u, 11);
            else {
              if (n === 48) if (n = r(u), (n | 32) === 120) {
                for (i = 136, n = r(u); V[n] & 4160; ) {
                  if (n === 95) {
                    s || f(u, 146), s = 0, n = r(u);
                    continue;
                  }
                  s = 1, t = t * 16 + L(n), c++, n = r(u);
                }
                (c < 1 || !s) && f(u, c < 1 ? 19 : 147);
              } else if ((n | 32) === 111) {
                for (i = 132, n = r(u); V[n] & 4128; ) {
                  if (n === 95) {
                    s || f(u, 146), s = 0, n = r(u);
                    continue;
                  }
                  s = 1, t = t * 8 + (n - 48), c++, n = r(u);
                }
                (c < 1 || !s) && f(u, c < 1 ? 0 : 147);
              } else if ((n | 32) === 98) {
                for (i = 130, n = r(u); V[n] & 4224; ) {
                  if (n === 95) {
                    s || f(u, 146), s = 0, n = r(u);
                    continue;
                  }
                  s = 1, t = t * 2 + (n - 48), c++, n = r(u);
                }
                (c < 1 || !s) && f(u, c < 1 ? 0 : 147);
              } else if (V[n] & 32) for (e & 1024 && f(u, 1), i = 1; V[n] & 16; ) {
                if (V[n] & 512) {
                  i = 32, l = 0;
                  break;
                }
                t = t * 8 + (n - 48), n = r(u);
              }
              else V[n] & 512 ? (e & 1024 && f(u, 1), u.flags |= 64, i = 32) : n === 95 && f(u, 0);
              if (i & 48) {
                if (l) {
                  for (; o >= 0 && V[n] & 4112; ) {
                    if (n === 95) {
                      n = r(u), (n === 95 || i & 32) && q(u.index, u.line, u.index + 1, 146), s = 1;
                      continue;
                    }
                    s = 0, t = 10 * t + (n - 48), n = r(u), --o;
                  }
                  if (s && q(u.index, u.line, u.index + 1, 147), o >= 0 && !I(n) && n !== 46) return u.tokenValue = t, e & 512 && (u.tokenRaw = u.source.slice(u.tokenPos, u.index)), 134283266;
                }
                t += t1(u, n), n = u.currentChar, n === 46 && (r(u) === 95 && f(u, 0), i = 64, t += "." + t1(u, u.currentChar), n = u.currentChar);
              }
            }
            let h = u.index, b = 0;
            if (n === 110 && i & 128) b = 1, n = r(u);
            else if ((n | 32) === 101) {
              n = r(u), V[n] & 256 && (n = r(u));
              let { index: g } = u;
              (V[n] & 16) < 1 && f(u, 10), t += u.source.substring(h, g) + t1(u, n), n = u.currentChar;
            }
            return (u.index < u.end && V[n] & 16 || I(n)) && f(u, 12), b ? (u.tokenRaw = u.source.slice(u.tokenPos, u.index), u.tokenValue = BigInt(t), 134283389) : (u.tokenValue = i & 15 ? t : i & 32 ? parseFloat(u.source.substring(u.tokenPos, u.index)) : +t, e & 512 && (u.tokenRaw = u.source.slice(u.tokenPos, u.index)), 134283266);
          }
          function t1(u, e) {
            let i = 0, n = u.index, t = "";
            for (; V[e] & 4112; ) {
              if (e === 95) {
                let { index: o } = u;
                e = r(u), e === 95 && q(u.index, u.line, u.index + 1, 146), i = 1, t += u.source.substring(n, o), n = u.index;
                continue;
              }
              i = 0, e = r(u);
            }
            return i && q(u.index, u.line, u.index + 1, 147), t + u.source.substring(n, u.index);
          }
          var G = ["end of source", "identifier", "number", "string", "regular expression", "false", "true", "null", "template continuation", "template tail", "=>", "(", "{", ".", "...", "}", ")", ";", ",", "[", "]", ":", "?", "'", '"', "</", "/>", "++", "--", "=", "<<=", ">>=", ">>>=", "**=", "+=", "-=", "*=", "/=", "%=", "^=", "|=", "&=", "||=", "&&=", "??=", "typeof", "delete", "void", "!", "~", "+", "-", "in", "instanceof", "*", "%", "/", "**", "&&", "||", "===", "!==", "==", "!=", "<=", ">=", "<", ">", "<<", ">>", ">>>", "&", "|", "^", "var", "let", "const", "break", "case", "catch", "class", "continue", "debugger", "default", "do", "else", "export", "extends", "finally", "for", "function", "if", "import", "new", "return", "super", "switch", "this", "throw", "try", "while", "with", "implements", "interface", "package", "private", "protected", "public", "static", "yield", "as", "async", "await", "constructor", "get", "set", "from", "of", "enum", "eval", "arguments", "escaped keyword", "escaped future reserved keyword", "reserved if strict", "#", "BigIntLiteral", "??", "?.", "WhiteSpace", "Illegal", "LineTerminator", "PrivateField", "Template", "@", "target", "meta", "LineFeed", "Escaped", "JSXText"], zu = Object.create(null, { this: { value: 86113 }, function: { value: 86106 }, if: { value: 20571 }, return: { value: 20574 }, var: { value: 86090 }, else: { value: 20565 }, for: { value: 20569 }, new: { value: 86109 }, in: { value: 8738868 }, typeof: { value: 16863277 }, while: { value: 20580 }, case: { value: 20558 }, break: { value: 20557 }, try: { value: 20579 }, catch: { value: 20559 }, delete: { value: 16863278 }, throw: { value: 86114 }, switch: { value: 86112 }, continue: { value: 20561 }, default: { value: 20563 }, instanceof: { value: 8476725 }, do: { value: 20564 }, void: { value: 16863279 }, finally: { value: 20568 }, async: { value: 209007 }, await: { value: 209008 }, class: { value: 86096 }, const: { value: 86092 }, constructor: { value: 12401 }, debugger: { value: 20562 }, export: { value: 20566 }, extends: { value: 20567 }, false: { value: 86021 }, from: { value: 12404 }, get: { value: 12402 }, implements: { value: 36966 }, import: { value: 86108 }, interface: { value: 36967 }, let: { value: 241739 }, null: { value: 86023 }, of: { value: 274549 }, package: { value: 36968 }, private: { value: 36969 }, protected: { value: 36970 }, public: { value: 36971 }, set: { value: 12403 }, static: { value: 36972 }, super: { value: 86111 }, true: { value: 86022 }, with: { value: 20581 }, yield: { value: 241773 }, enum: { value: 86134 }, eval: { value: 537079927 }, as: { value: 77934 }, arguments: { value: 537079928 }, target: { value: 143494 }, meta: { value: 143495 } });
          function Hu(u, e, i) {
            for (; H[r(u)]; ) ;
            return u.tokenValue = u.source.slice(u.tokenPos, u.index), u.currentChar !== 92 && u.currentChar < 126 ? zu[u.tokenValue] || 208897 : R1(u, e, 0, i);
          }
          function A0(u, e) {
            let i = Ku(u);
            return u2(i) || f(u, 4), u.tokenValue = Z(i), R1(u, e, 1, V[i] & 4);
          }
          function R1(u, e, i, n) {
            let t = u.index;
            for (; u.index < u.end; ) if (u.currentChar === 92) {
              u.tokenValue += u.source.slice(t, u.index), i = 1;
              let l = Ku(u);
              u2(l) || f(u, 4), n = n && V[l] & 4, u.tokenValue += Z(l), t = u.index;
            } else if (u2(u.currentChar) || K(u, u.currentChar)) r(u);
            else break;
            u.index <= u.end && (u.tokenValue += u.source.slice(t, u.index));
            let o = u.tokenValue.length;
            if (n && o >= 2 && o <= 11) {
              let l = zu[u.tokenValue];
              return l === void 0 ? 208897 : i ? e & 1024 ? l === 209008 && (e & 4196352) === 0 ? l : l === 36972 || (l & 36864) === 36864 ? 122 : 121 : e & 1073741824 && (e & 8192) === 0 && (l & 20480) === 20480 ? l : l === 241773 ? e & 1073741824 ? 143483 : e & 2097152 ? 121 : l : l === 209007 && e & 1073741824 ? 143483 : (l & 36864) === 36864 || l === 209008 && (e & 4194304) === 0 ? l : 121 : l;
            }
            return 208897;
          }
          function y0(u) {
            return I(r(u)) || f(u, 93), 131;
          }
          function Ku(u) {
            return u.source.charCodeAt(u.index + 1) !== 117 && f(u, 4), u.currentChar = u.source.charCodeAt(u.index += 2), P0(u);
          }
          function P0(u) {
            let e = 0, i = u.currentChar;
            if (i === 123) {
              let l = u.index - 2;
              for (; V[r(u)] & 64; ) e = e << 4 | L(u.currentChar), e > 1114111 && q(l, u.line, u.index + 1, 101);
              return u.currentChar !== 125 && q(l, u.line, u.index - 1, 6), r(u), e;
            }
            (V[i] & 64) === 0 && f(u, 6);
            let n = u.source.charCodeAt(u.index + 1);
            (V[n] & 64) === 0 && f(u, 6);
            let t = u.source.charCodeAt(u.index + 2);
            (V[t] & 64) === 0 && f(u, 6);
            let o = u.source.charCodeAt(u.index + 3);
            return (V[o] & 64) === 0 && f(u, 6), e = L(i) << 12 | L(n) << 8 | L(t) << 4 | L(o), u.currentChar = u.source.charCodeAt(u.index += 4), e;
          }
          var Wu = [129, 129, 129, 129, 129, 129, 129, 129, 129, 128, 136, 128, 128, 130, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 128, 16842800, 134283267, 131, 208897, 8457015, 8455751, 134283267, 67174411, 16, 8457014, 25233970, 18, 25233971, 67108877, 8457016, 134283266, 134283266, 134283266, 134283266, 134283266, 134283266, 134283266, 134283266, 134283266, 134283266, 21, 1074790417, 8456258, 1077936157, 8456259, 22, 133, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 69271571, 137, 20, 8455497, 208897, 132, 4096, 4096, 4096, 4096, 4096, 4096, 4096, 208897, 4096, 208897, 208897, 4096, 208897, 4096, 208897, 4096, 208897, 4096, 4096, 4096, 208897, 4096, 4096, 208897, 4096, 4096, 2162700, 8455240, 1074790415, 16842801, 129];
          function E(u, e) {
            if (u.flags = (u.flags | 1) ^ 1, u.startPos = u.index, u.startColumn = u.column, u.startLine = u.line, u.token = Yu(u, e, 0), u.onToken && u.token !== 1048576) {
              let i = { start: { line: u.linePos, column: u.colPos }, end: { line: u.line, column: u.column } };
              u.onToken(t2(u.token), u.tokenPos, u.index, i);
            }
          }
          function Yu(u, e, i) {
            let n = u.index === 0, t = u.source, o = u.index, l = u.line, c = u.column;
            for (; u.index < u.end; ) {
              u.tokenPos = u.index, u.colPos = u.column, u.linePos = u.line;
              let s = u.currentChar;
              if (s <= 126) {
                let h = Wu[s];
                switch (h) {
                  case 67174411:
                  case 16:
                  case 2162700:
                  case 1074790415:
                  case 69271571:
                  case 20:
                  case 21:
                  case 1074790417:
                  case 18:
                  case 16842801:
                  case 133:
                  case 129:
                    return r(u), h;
                  case 208897:
                    return Hu(u, e, 0);
                  case 4096:
                    return Hu(u, e, 1);
                  case 134283266:
                    return Xu(u, e, 144);
                  case 134283267:
                    return I1(u, e, s);
                  case 132:
                    return Ju(u, e);
                  case 137:
                    return A0(u, e);
                  case 131:
                    return y0(u);
                  case 128:
                    r(u);
                    break;
                  case 130:
                    i |= 5, X(u);
                    break;
                  case 136:
                    Y(u, i), i = i & -5 | 1;
                    break;
                  case 8456258:
                    let b = r(u);
                    if (u.index < u.end) {
                      if (b === 60) return u.index < u.end && r(u) === 61 ? (r(u), 4194334) : 8456516;
                      if (b === 61) return r(u), 8456256;
                      if (b === 33) {
                        let a = u.index + 1;
                        if (a + 1 < u.end && t.charCodeAt(a) === 45 && t.charCodeAt(a + 1) == 45) {
                          u.column += 3, u.currentChar = t.charCodeAt(u.index += 3), i = R2(u, t, i, e, 2, u.tokenPos, u.linePos, u.colPos), o = u.tokenPos, l = u.linePos, c = u.colPos;
                          continue;
                        }
                        return 8456258;
                      }
                      if (b === 47) {
                        if ((e & 16) < 1) return 8456258;
                        let a = u.index + 1;
                        if (a < u.end && (b = t.charCodeAt(a), b === 42 || b === 47)) break;
                        return r(u), 25;
                      }
                    }
                    return 8456258;
                  case 1077936157: {
                    r(u);
                    let a = u.currentChar;
                    return a === 61 ? r(u) === 61 ? (r(u), 8455996) : 8455998 : a === 62 ? (r(u), 10) : 1077936157;
                  }
                  case 16842800:
                    return r(u) !== 61 ? 16842800 : r(u) !== 61 ? 8455999 : (r(u), 8455997);
                  case 8457015:
                    return r(u) !== 61 ? 8457015 : (r(u), 4194342);
                  case 8457014: {
                    if (r(u), u.index >= u.end) return 8457014;
                    let a = u.currentChar;
                    return a === 61 ? (r(u), 4194340) : a !== 42 ? 8457014 : r(u) !== 61 ? 8457273 : (r(u), 4194337);
                  }
                  case 8455497:
                    return r(u) !== 61 ? 8455497 : (r(u), 4194343);
                  case 25233970: {
                    r(u);
                    let a = u.currentChar;
                    return a === 43 ? (r(u), 33619995) : a === 61 ? (r(u), 4194338) : 25233970;
                  }
                  case 25233971: {
                    r(u);
                    let a = u.currentChar;
                    if (a === 45) {
                      if (r(u), (i & 1 || n) && u.currentChar === 62) {
                        (e & 256) === 0 && f(u, 108), r(u), i = R2(u, t, i, e, 3, o, l, c), o = u.tokenPos, l = u.linePos, c = u.colPos;
                        continue;
                      }
                      return 33619996;
                    }
                    return a === 61 ? (r(u), 4194339) : 25233971;
                  }
                  case 8457016: {
                    if (r(u), u.index < u.end) {
                      let a = u.currentChar;
                      if (a === 47) {
                        r(u), i = s2(u, t, i, 0, u.tokenPos, u.linePos, u.colPos), o = u.tokenPos, l = u.linePos, c = u.colPos;
                        continue;
                      }
                      if (a === 42) {
                        r(u), i = N2(u, t, i), o = u.tokenPos, l = u.linePos, c = u.colPos;
                        continue;
                      }
                      if (e & 32768) return w2(u, e);
                      if (a === 61) return r(u), 4259877;
                    }
                    return 8457016;
                  }
                  case 67108877:
                    let g = r(u);
                    if (g >= 48 && g <= 57) return Xu(u, e, 80);
                    if (g === 46) {
                      let a = u.index + 1;
                      if (a < u.end && t.charCodeAt(a) === 46) return u.column += 2, u.currentChar = t.charCodeAt(u.index += 2), 14;
                    }
                    return 67108877;
                  case 8455240: {
                    r(u);
                    let a = u.currentChar;
                    return a === 124 ? (r(u), u.currentChar === 61 ? (r(u), 4194346) : 8979003) : a === 61 ? (r(u), 4194344) : 8455240;
                  }
                  case 8456259: {
                    r(u);
                    let a = u.currentChar;
                    if (a === 61) return r(u), 8456257;
                    if (a !== 62) return 8456259;
                    if (r(u), u.index < u.end) {
                      let A = u.currentChar;
                      if (A === 62) return r(u) === 61 ? (r(u), 4194336) : 8456518;
                      if (A === 61) return r(u), 4194335;
                    }
                    return 8456517;
                  }
                  case 8455751: {
                    r(u);
                    let a = u.currentChar;
                    return a === 38 ? (r(u), u.currentChar === 61 ? (r(u), 4194347) : 8979258) : a === 61 ? (r(u), 4194345) : 8455751;
                  }
                  case 22: {
                    let a = r(u);
                    if (a === 63) return r(u), u.currentChar === 61 ? (r(u), 4194348) : 276889982;
                    if (a === 46) {
                      let A = u.index + 1;
                      if (A < u.end && (a = t.charCodeAt(A), !(a >= 48 && a <= 57))) return r(u), 67108991;
                    }
                    return 22;
                  }
                }
              } else {
                if ((s ^ 8232) <= 1) {
                  i = i & -5 | 1, X(u);
                  continue;
                }
                if ((s & 64512) === 55296 || (T[(s >>> 5) + 34816] >>> s & 31 & 1) !== 0) return (s & 64512) === 56320 && (s = (s & 1023) << 10 | s & 1023 | 65536, (T[(s >>> 5) + 0] >>> s & 31 & 1) === 0 && f(u, 18, Z(s)), u.index++, u.currentChar = s), u.column++, u.tokenValue = "", R1(u, e, 0, 0);
                if (p(s)) {
                  r(u);
                  continue;
                }
                f(u, 18, Z(s));
              }
            }
            return 1048576;
          }
          var E0 = { AElig: "\xC6", AMP: "&", Aacute: "\xC1", Abreve: "\u0102", Acirc: "\xC2", Acy: "\u0410", Afr: "\u{1D504}", Agrave: "\xC0", Alpha: "\u0391", Amacr: "\u0100", And: "\u2A53", Aogon: "\u0104", Aopf: "\u{1D538}", ApplyFunction: "\u2061", Aring: "\xC5", Ascr: "\u{1D49C}", Assign: "\u2254", Atilde: "\xC3", Auml: "\xC4", Backslash: "\u2216", Barv: "\u2AE7", Barwed: "\u2306", Bcy: "\u0411", Because: "\u2235", Bernoullis: "\u212C", Beta: "\u0392", Bfr: "\u{1D505}", Bopf: "\u{1D539}", Breve: "\u02D8", Bscr: "\u212C", Bumpeq: "\u224E", CHcy: "\u0427", COPY: "\xA9", Cacute: "\u0106", Cap: "\u22D2", CapitalDifferentialD: "\u2145", Cayleys: "\u212D", Ccaron: "\u010C", Ccedil: "\xC7", Ccirc: "\u0108", Cconint: "\u2230", Cdot: "\u010A", Cedilla: "\xB8", CenterDot: "\xB7", Cfr: "\u212D", Chi: "\u03A7", CircleDot: "\u2299", CircleMinus: "\u2296", CirclePlus: "\u2295", CircleTimes: "\u2297", ClockwiseContourIntegral: "\u2232", CloseCurlyDoubleQuote: "\u201D", CloseCurlyQuote: "\u2019", Colon: "\u2237", Colone: "\u2A74", Congruent: "\u2261", Conint: "\u222F", ContourIntegral: "\u222E", Copf: "\u2102", Coproduct: "\u2210", CounterClockwiseContourIntegral: "\u2233", Cross: "\u2A2F", Cscr: "\u{1D49E}", Cup: "\u22D3", CupCap: "\u224D", DD: "\u2145", DDotrahd: "\u2911", DJcy: "\u0402", DScy: "\u0405", DZcy: "\u040F", Dagger: "\u2021", Darr: "\u21A1", Dashv: "\u2AE4", Dcaron: "\u010E", Dcy: "\u0414", Del: "\u2207", Delta: "\u0394", Dfr: "\u{1D507}", DiacriticalAcute: "\xB4", DiacriticalDot: "\u02D9", DiacriticalDoubleAcute: "\u02DD", DiacriticalGrave: "`", DiacriticalTilde: "\u02DC", Diamond: "\u22C4", DifferentialD: "\u2146", Dopf: "\u{1D53B}", Dot: "\xA8", DotDot: "\u20DC", DotEqual: "\u2250", DoubleContourIntegral: "\u222F", DoubleDot: "\xA8", DoubleDownArrow: "\u21D3", DoubleLeftArrow: "\u21D0", DoubleLeftRightArrow: "\u21D4", DoubleLeftTee: "\u2AE4", DoubleLongLeftArrow: "\u27F8", DoubleLongLeftRightArrow: "\u27FA", DoubleLongRightArrow: "\u27F9", DoubleRightArrow: "\u21D2", DoubleRightTee: "\u22A8", DoubleUpArrow: "\u21D1", DoubleUpDownArrow: "\u21D5", DoubleVerticalBar: "\u2225", DownArrow: "\u2193", DownArrowBar: "\u2913", DownArrowUpArrow: "\u21F5", DownBreve: "\u0311", DownLeftRightVector: "\u2950", DownLeftTeeVector: "\u295E", DownLeftVector: "\u21BD", DownLeftVectorBar: "\u2956", DownRightTeeVector: "\u295F", DownRightVector: "\u21C1", DownRightVectorBar: "\u2957", DownTee: "\u22A4", DownTeeArrow: "\u21A7", Downarrow: "\u21D3", Dscr: "\u{1D49F}", Dstrok: "\u0110", ENG: "\u014A", ETH: "\xD0", Eacute: "\xC9", Ecaron: "\u011A", Ecirc: "\xCA", Ecy: "\u042D", Edot: "\u0116", Efr: "\u{1D508}", Egrave: "\xC8", Element: "\u2208", Emacr: "\u0112", EmptySmallSquare: "\u25FB", EmptyVerySmallSquare: "\u25AB", Eogon: "\u0118", Eopf: "\u{1D53C}", Epsilon: "\u0395", Equal: "\u2A75", EqualTilde: "\u2242", Equilibrium: "\u21CC", Escr: "\u2130", Esim: "\u2A73", Eta: "\u0397", Euml: "\xCB", Exists: "\u2203", ExponentialE: "\u2147", Fcy: "\u0424", Ffr: "\u{1D509}", FilledSmallSquare: "\u25FC", FilledVerySmallSquare: "\u25AA", Fopf: "\u{1D53D}", ForAll: "\u2200", Fouriertrf: "\u2131", Fscr: "\u2131", GJcy: "\u0403", GT: ">", Gamma: "\u0393", Gammad: "\u03DC", Gbreve: "\u011E", Gcedil: "\u0122", Gcirc: "\u011C", Gcy: "\u0413", Gdot: "\u0120", Gfr: "\u{1D50A}", Gg: "\u22D9", Gopf: "\u{1D53E}", GreaterEqual: "\u2265", GreaterEqualLess: "\u22DB", GreaterFullEqual: "\u2267", GreaterGreater: "\u2AA2", GreaterLess: "\u2277", GreaterSlantEqual: "\u2A7E", GreaterTilde: "\u2273", Gscr: "\u{1D4A2}", Gt: "\u226B", HARDcy: "\u042A", Hacek: "\u02C7", Hat: "^", Hcirc: "\u0124", Hfr: "\u210C", HilbertSpace: "\u210B", Hopf: "\u210D", HorizontalLine: "\u2500", Hscr: "\u210B", Hstrok: "\u0126", HumpDownHump: "\u224E", HumpEqual: "\u224F", IEcy: "\u0415", IJlig: "\u0132", IOcy: "\u0401", Iacute: "\xCD", Icirc: "\xCE", Icy: "\u0418", Idot: "\u0130", Ifr: "\u2111", Igrave: "\xCC", Im: "\u2111", Imacr: "\u012A", ImaginaryI: "\u2148", Implies: "\u21D2", Int: "\u222C", Integral: "\u222B", Intersection: "\u22C2", InvisibleComma: "\u2063", InvisibleTimes: "\u2062", Iogon: "\u012E", Iopf: "\u{1D540}", Iota: "\u0399", Iscr: "\u2110", Itilde: "\u0128", Iukcy: "\u0406", Iuml: "\xCF", Jcirc: "\u0134", Jcy: "\u0419", Jfr: "\u{1D50D}", Jopf: "\u{1D541}", Jscr: "\u{1D4A5}", Jsercy: "\u0408", Jukcy: "\u0404", KHcy: "\u0425", KJcy: "\u040C", Kappa: "\u039A", Kcedil: "\u0136", Kcy: "\u041A", Kfr: "\u{1D50E}", Kopf: "\u{1D542}", Kscr: "\u{1D4A6}", LJcy: "\u0409", LT: "<", Lacute: "\u0139", Lambda: "\u039B", Lang: "\u27EA", Laplacetrf: "\u2112", Larr: "\u219E", Lcaron: "\u013D", Lcedil: "\u013B", Lcy: "\u041B", LeftAngleBracket: "\u27E8", LeftArrow: "\u2190", LeftArrowBar: "\u21E4", LeftArrowRightArrow: "\u21C6", LeftCeiling: "\u2308", LeftDoubleBracket: "\u27E6", LeftDownTeeVector: "\u2961", LeftDownVector: "\u21C3", LeftDownVectorBar: "\u2959", LeftFloor: "\u230A", LeftRightArrow: "\u2194", LeftRightVector: "\u294E", LeftTee: "\u22A3", LeftTeeArrow: "\u21A4", LeftTeeVector: "\u295A", LeftTriangle: "\u22B2", LeftTriangleBar: "\u29CF", LeftTriangleEqual: "\u22B4", LeftUpDownVector: "\u2951", LeftUpTeeVector: "\u2960", LeftUpVector: "\u21BF", LeftUpVectorBar: "\u2958", LeftVector: "\u21BC", LeftVectorBar: "\u2952", Leftarrow: "\u21D0", Leftrightarrow: "\u21D4", LessEqualGreater: "\u22DA", LessFullEqual: "\u2266", LessGreater: "\u2276", LessLess: "\u2AA1", LessSlantEqual: "\u2A7D", LessTilde: "\u2272", Lfr: "\u{1D50F}", Ll: "\u22D8", Lleftarrow: "\u21DA", Lmidot: "\u013F", LongLeftArrow: "\u27F5", LongLeftRightArrow: "\u27F7", LongRightArrow: "\u27F6", Longleftarrow: "\u27F8", Longleftrightarrow: "\u27FA", Longrightarrow: "\u27F9", Lopf: "\u{1D543}", LowerLeftArrow: "\u2199", LowerRightArrow: "\u2198", Lscr: "\u2112", Lsh: "\u21B0", Lstrok: "\u0141", Lt: "\u226A", Map: "\u2905", Mcy: "\u041C", MediumSpace: "\u205F", Mellintrf: "\u2133", Mfr: "\u{1D510}", MinusPlus: "\u2213", Mopf: "\u{1D544}", Mscr: "\u2133", Mu: "\u039C", NJcy: "\u040A", Nacute: "\u0143", Ncaron: "\u0147", Ncedil: "\u0145", Ncy: "\u041D", NegativeMediumSpace: "\u200B", NegativeThickSpace: "\u200B", NegativeThinSpace: "\u200B", NegativeVeryThinSpace: "\u200B", NestedGreaterGreater: "\u226B", NestedLessLess: "\u226A", NewLine: `
`, Nfr: "\u{1D511}", NoBreak: "\u2060", NonBreakingSpace: "\xA0", Nopf: "\u2115", Not: "\u2AEC", NotCongruent: "\u2262", NotCupCap: "\u226D", NotDoubleVerticalBar: "\u2226", NotElement: "\u2209", NotEqual: "\u2260", NotEqualTilde: "\u2242\u0338", NotExists: "\u2204", NotGreater: "\u226F", NotGreaterEqual: "\u2271", NotGreaterFullEqual: "\u2267\u0338", NotGreaterGreater: "\u226B\u0338", NotGreaterLess: "\u2279", NotGreaterSlantEqual: "\u2A7E\u0338", NotGreaterTilde: "\u2275", NotHumpDownHump: "\u224E\u0338", NotHumpEqual: "\u224F\u0338", NotLeftTriangle: "\u22EA", NotLeftTriangleBar: "\u29CF\u0338", NotLeftTriangleEqual: "\u22EC", NotLess: "\u226E", NotLessEqual: "\u2270", NotLessGreater: "\u2278", NotLessLess: "\u226A\u0338", NotLessSlantEqual: "\u2A7D\u0338", NotLessTilde: "\u2274", NotNestedGreaterGreater: "\u2AA2\u0338", NotNestedLessLess: "\u2AA1\u0338", NotPrecedes: "\u2280", NotPrecedesEqual: "\u2AAF\u0338", NotPrecedesSlantEqual: "\u22E0", NotReverseElement: "\u220C", NotRightTriangle: "\u22EB", NotRightTriangleBar: "\u29D0\u0338", NotRightTriangleEqual: "\u22ED", NotSquareSubset: "\u228F\u0338", NotSquareSubsetEqual: "\u22E2", NotSquareSuperset: "\u2290\u0338", NotSquareSupersetEqual: "\u22E3", NotSubset: "\u2282\u20D2", NotSubsetEqual: "\u2288", NotSucceeds: "\u2281", NotSucceedsEqual: "\u2AB0\u0338", NotSucceedsSlantEqual: "\u22E1", NotSucceedsTilde: "\u227F\u0338", NotSuperset: "\u2283\u20D2", NotSupersetEqual: "\u2289", NotTilde: "\u2241", NotTildeEqual: "\u2244", NotTildeFullEqual: "\u2247", NotTildeTilde: "\u2249", NotVerticalBar: "\u2224", Nscr: "\u{1D4A9}", Ntilde: "\xD1", Nu: "\u039D", OElig: "\u0152", Oacute: "\xD3", Ocirc: "\xD4", Ocy: "\u041E", Odblac: "\u0150", Ofr: "\u{1D512}", Ograve: "\xD2", Omacr: "\u014C", Omega: "\u03A9", Omicron: "\u039F", Oopf: "\u{1D546}", OpenCurlyDoubleQuote: "\u201C", OpenCurlyQuote: "\u2018", Or: "\u2A54", Oscr: "\u{1D4AA}", Oslash: "\xD8", Otilde: "\xD5", Otimes: "\u2A37", Ouml: "\xD6", OverBar: "\u203E", OverBrace: "\u23DE", OverBracket: "\u23B4", OverParenthesis: "\u23DC", PartialD: "\u2202", Pcy: "\u041F", Pfr: "\u{1D513}", Phi: "\u03A6", Pi: "\u03A0", PlusMinus: "\xB1", Poincareplane: "\u210C", Popf: "\u2119", Pr: "\u2ABB", Precedes: "\u227A", PrecedesEqual: "\u2AAF", PrecedesSlantEqual: "\u227C", PrecedesTilde: "\u227E", Prime: "\u2033", Product: "\u220F", Proportion: "\u2237", Proportional: "\u221D", Pscr: "\u{1D4AB}", Psi: "\u03A8", QUOT: '"', Qfr: "\u{1D514}", Qopf: "\u211A", Qscr: "\u{1D4AC}", RBarr: "\u2910", REG: "\xAE", Racute: "\u0154", Rang: "\u27EB", Rarr: "\u21A0", Rarrtl: "\u2916", Rcaron: "\u0158", Rcedil: "\u0156", Rcy: "\u0420", Re: "\u211C", ReverseElement: "\u220B", ReverseEquilibrium: "\u21CB", ReverseUpEquilibrium: "\u296F", Rfr: "\u211C", Rho: "\u03A1", RightAngleBracket: "\u27E9", RightArrow: "\u2192", RightArrowBar: "\u21E5", RightArrowLeftArrow: "\u21C4", RightCeiling: "\u2309", RightDoubleBracket: "\u27E7", RightDownTeeVector: "\u295D", RightDownVector: "\u21C2", RightDownVectorBar: "\u2955", RightFloor: "\u230B", RightTee: "\u22A2", RightTeeArrow: "\u21A6", RightTeeVector: "\u295B", RightTriangle: "\u22B3", RightTriangleBar: "\u29D0", RightTriangleEqual: "\u22B5", RightUpDownVector: "\u294F", RightUpTeeVector: "\u295C", RightUpVector: "\u21BE", RightUpVectorBar: "\u2954", RightVector: "\u21C0", RightVectorBar: "\u2953", Rightarrow: "\u21D2", Ropf: "\u211D", RoundImplies: "\u2970", Rrightarrow: "\u21DB", Rscr: "\u211B", Rsh: "\u21B1", RuleDelayed: "\u29F4", SHCHcy: "\u0429", SHcy: "\u0428", SOFTcy: "\u042C", Sacute: "\u015A", Sc: "\u2ABC", Scaron: "\u0160", Scedil: "\u015E", Scirc: "\u015C", Scy: "\u0421", Sfr: "\u{1D516}", ShortDownArrow: "\u2193", ShortLeftArrow: "\u2190", ShortRightArrow: "\u2192", ShortUpArrow: "\u2191", Sigma: "\u03A3", SmallCircle: "\u2218", Sopf: "\u{1D54A}", Sqrt: "\u221A", Square: "\u25A1", SquareIntersection: "\u2293", SquareSubset: "\u228F", SquareSubsetEqual: "\u2291", SquareSuperset: "\u2290", SquareSupersetEqual: "\u2292", SquareUnion: "\u2294", Sscr: "\u{1D4AE}", Star: "\u22C6", Sub: "\u22D0", Subset: "\u22D0", SubsetEqual: "\u2286", Succeeds: "\u227B", SucceedsEqual: "\u2AB0", SucceedsSlantEqual: "\u227D", SucceedsTilde: "\u227F", SuchThat: "\u220B", Sum: "\u2211", Sup: "\u22D1", Superset: "\u2283", SupersetEqual: "\u2287", Supset: "\u22D1", THORN: "\xDE", TRADE: "\u2122", TSHcy: "\u040B", TScy: "\u0426", Tab: "	", Tau: "\u03A4", Tcaron: "\u0164", Tcedil: "\u0162", Tcy: "\u0422", Tfr: "\u{1D517}", Therefore: "\u2234", Theta: "\u0398", ThickSpace: "\u205F\u200A", ThinSpace: "\u2009", Tilde: "\u223C", TildeEqual: "\u2243", TildeFullEqual: "\u2245", TildeTilde: "\u2248", Topf: "\u{1D54B}", TripleDot: "\u20DB", Tscr: "\u{1D4AF}", Tstrok: "\u0166", Uacute: "\xDA", Uarr: "\u219F", Uarrocir: "\u2949", Ubrcy: "\u040E", Ubreve: "\u016C", Ucirc: "\xDB", Ucy: "\u0423", Udblac: "\u0170", Ufr: "\u{1D518}", Ugrave: "\xD9", Umacr: "\u016A", UnderBar: "_", UnderBrace: "\u23DF", UnderBracket: "\u23B5", UnderParenthesis: "\u23DD", Union: "\u22C3", UnionPlus: "\u228E", Uogon: "\u0172", Uopf: "\u{1D54C}", UpArrow: "\u2191", UpArrowBar: "\u2912", UpArrowDownArrow: "\u21C5", UpDownArrow: "\u2195", UpEquilibrium: "\u296E", UpTee: "\u22A5", UpTeeArrow: "\u21A5", Uparrow: "\u21D1", Updownarrow: "\u21D5", UpperLeftArrow: "\u2196", UpperRightArrow: "\u2197", Upsi: "\u03D2", Upsilon: "\u03A5", Uring: "\u016E", Uscr: "\u{1D4B0}", Utilde: "\u0168", Uuml: "\xDC", VDash: "\u22AB", Vbar: "\u2AEB", Vcy: "\u0412", Vdash: "\u22A9", Vdashl: "\u2AE6", Vee: "\u22C1", Verbar: "\u2016", Vert: "\u2016", VerticalBar: "\u2223", VerticalLine: "|", VerticalSeparator: "\u2758", VerticalTilde: "\u2240", VeryThinSpace: "\u200A", Vfr: "\u{1D519}", Vopf: "\u{1D54D}", Vscr: "\u{1D4B1}", Vvdash: "\u22AA", Wcirc: "\u0174", Wedge: "\u22C0", Wfr: "\u{1D51A}", Wopf: "\u{1D54E}", Wscr: "\u{1D4B2}", Xfr: "\u{1D51B}", Xi: "\u039E", Xopf: "\u{1D54F}", Xscr: "\u{1D4B3}", YAcy: "\u042F", YIcy: "\u0407", YUcy: "\u042E", Yacute: "\xDD", Ycirc: "\u0176", Ycy: "\u042B", Yfr: "\u{1D51C}", Yopf: "\u{1D550}", Yscr: "\u{1D4B4}", Yuml: "\u0178", ZHcy: "\u0416", Zacute: "\u0179", Zcaron: "\u017D", Zcy: "\u0417", Zdot: "\u017B", ZeroWidthSpace: "\u200B", Zeta: "\u0396", Zfr: "\u2128", Zopf: "\u2124", Zscr: "\u{1D4B5}", aacute: "\xE1", abreve: "\u0103", ac: "\u223E", acE: "\u223E\u0333", acd: "\u223F", acirc: "\xE2", acute: "\xB4", acy: "\u0430", aelig: "\xE6", af: "\u2061", afr: "\u{1D51E}", agrave: "\xE0", alefsym: "\u2135", aleph: "\u2135", alpha: "\u03B1", amacr: "\u0101", amalg: "\u2A3F", amp: "&", and: "\u2227", andand: "\u2A55", andd: "\u2A5C", andslope: "\u2A58", andv: "\u2A5A", ang: "\u2220", ange: "\u29A4", angle: "\u2220", angmsd: "\u2221", angmsdaa: "\u29A8", angmsdab: "\u29A9", angmsdac: "\u29AA", angmsdad: "\u29AB", angmsdae: "\u29AC", angmsdaf: "\u29AD", angmsdag: "\u29AE", angmsdah: "\u29AF", angrt: "\u221F", angrtvb: "\u22BE", angrtvbd: "\u299D", angsph: "\u2222", angst: "\xC5", angzarr: "\u237C", aogon: "\u0105", aopf: "\u{1D552}", ap: "\u2248", apE: "\u2A70", apacir: "\u2A6F", ape: "\u224A", apid: "\u224B", apos: "'", approx: "\u2248", approxeq: "\u224A", aring: "\xE5", ascr: "\u{1D4B6}", ast: "*", asymp: "\u2248", asympeq: "\u224D", atilde: "\xE3", auml: "\xE4", awconint: "\u2233", awint: "\u2A11", bNot: "\u2AED", backcong: "\u224C", backepsilon: "\u03F6", backprime: "\u2035", backsim: "\u223D", backsimeq: "\u22CD", barvee: "\u22BD", barwed: "\u2305", barwedge: "\u2305", bbrk: "\u23B5", bbrktbrk: "\u23B6", bcong: "\u224C", bcy: "\u0431", bdquo: "\u201E", becaus: "\u2235", because: "\u2235", bemptyv: "\u29B0", bepsi: "\u03F6", bernou: "\u212C", beta: "\u03B2", beth: "\u2136", between: "\u226C", bfr: "\u{1D51F}", bigcap: "\u22C2", bigcirc: "\u25EF", bigcup: "\u22C3", bigodot: "\u2A00", bigoplus: "\u2A01", bigotimes: "\u2A02", bigsqcup: "\u2A06", bigstar: "\u2605", bigtriangledown: "\u25BD", bigtriangleup: "\u25B3", biguplus: "\u2A04", bigvee: "\u22C1", bigwedge: "\u22C0", bkarow: "\u290D", blacklozenge: "\u29EB", blacksquare: "\u25AA", blacktriangle: "\u25B4", blacktriangledown: "\u25BE", blacktriangleleft: "\u25C2", blacktriangleright: "\u25B8", blank: "\u2423", blk12: "\u2592", blk14: "\u2591", blk34: "\u2593", block: "\u2588", bne: "=\u20E5", bnequiv: "\u2261\u20E5", bnot: "\u2310", bopf: "\u{1D553}", bot: "\u22A5", bottom: "\u22A5", bowtie: "\u22C8", boxDL: "\u2557", boxDR: "\u2554", boxDl: "\u2556", boxDr: "\u2553", boxH: "\u2550", boxHD: "\u2566", boxHU: "\u2569", boxHd: "\u2564", boxHu: "\u2567", boxUL: "\u255D", boxUR: "\u255A", boxUl: "\u255C", boxUr: "\u2559", boxV: "\u2551", boxVH: "\u256C", boxVL: "\u2563", boxVR: "\u2560", boxVh: "\u256B", boxVl: "\u2562", boxVr: "\u255F", boxbox: "\u29C9", boxdL: "\u2555", boxdR: "\u2552", boxdl: "\u2510", boxdr: "\u250C", boxh: "\u2500", boxhD: "\u2565", boxhU: "\u2568", boxhd: "\u252C", boxhu: "\u2534", boxminus: "\u229F", boxplus: "\u229E", boxtimes: "\u22A0", boxuL: "\u255B", boxuR: "\u2558", boxul: "\u2518", boxur: "\u2514", boxv: "\u2502", boxvH: "\u256A", boxvL: "\u2561", boxvR: "\u255E", boxvh: "\u253C", boxvl: "\u2524", boxvr: "\u251C", bprime: "\u2035", breve: "\u02D8", brvbar: "\xA6", bscr: "\u{1D4B7}", bsemi: "\u204F", bsim: "\u223D", bsime: "\u22CD", bsol: "\\", bsolb: "\u29C5", bsolhsub: "\u27C8", bull: "\u2022", bullet: "\u2022", bump: "\u224E", bumpE: "\u2AAE", bumpe: "\u224F", bumpeq: "\u224F", cacute: "\u0107", cap: "\u2229", capand: "\u2A44", capbrcup: "\u2A49", capcap: "\u2A4B", capcup: "\u2A47", capdot: "\u2A40", caps: "\u2229\uFE00", caret: "\u2041", caron: "\u02C7", ccaps: "\u2A4D", ccaron: "\u010D", ccedil: "\xE7", ccirc: "\u0109", ccups: "\u2A4C", ccupssm: "\u2A50", cdot: "\u010B", cedil: "\xB8", cemptyv: "\u29B2", cent: "\xA2", centerdot: "\xB7", cfr: "\u{1D520}", chcy: "\u0447", check: "\u2713", checkmark: "\u2713", chi: "\u03C7", cir: "\u25CB", cirE: "\u29C3", circ: "\u02C6", circeq: "\u2257", circlearrowleft: "\u21BA", circlearrowright: "\u21BB", circledR: "\xAE", circledS: "\u24C8", circledast: "\u229B", circledcirc: "\u229A", circleddash: "\u229D", cire: "\u2257", cirfnint: "\u2A10", cirmid: "\u2AEF", cirscir: "\u29C2", clubs: "\u2663", clubsuit: "\u2663", colon: ":", colone: "\u2254", coloneq: "\u2254", comma: ",", commat: "@", comp: "\u2201", compfn: "\u2218", complement: "\u2201", complexes: "\u2102", cong: "\u2245", congdot: "\u2A6D", conint: "\u222E", copf: "\u{1D554}", coprod: "\u2210", copy: "\xA9", copysr: "\u2117", crarr: "\u21B5", cross: "\u2717", cscr: "\u{1D4B8}", csub: "\u2ACF", csube: "\u2AD1", csup: "\u2AD0", csupe: "\u2AD2", ctdot: "\u22EF", cudarrl: "\u2938", cudarrr: "\u2935", cuepr: "\u22DE", cuesc: "\u22DF", cularr: "\u21B6", cularrp: "\u293D", cup: "\u222A", cupbrcap: "\u2A48", cupcap: "\u2A46", cupcup: "\u2A4A", cupdot: "\u228D", cupor: "\u2A45", cups: "\u222A\uFE00", curarr: "\u21B7", curarrm: "\u293C", curlyeqprec: "\u22DE", curlyeqsucc: "\u22DF", curlyvee: "\u22CE", curlywedge: "\u22CF", curren: "\xA4", curvearrowleft: "\u21B6", curvearrowright: "\u21B7", cuvee: "\u22CE", cuwed: "\u22CF", cwconint: "\u2232", cwint: "\u2231", cylcty: "\u232D", dArr: "\u21D3", dHar: "\u2965", dagger: "\u2020", daleth: "\u2138", darr: "\u2193", dash: "\u2010", dashv: "\u22A3", dbkarow: "\u290F", dblac: "\u02DD", dcaron: "\u010F", dcy: "\u0434", dd: "\u2146", ddagger: "\u2021", ddarr: "\u21CA", ddotseq: "\u2A77", deg: "\xB0", delta: "\u03B4", demptyv: "\u29B1", dfisht: "\u297F", dfr: "\u{1D521}", dharl: "\u21C3", dharr: "\u21C2", diam: "\u22C4", diamond: "\u22C4", diamondsuit: "\u2666", diams: "\u2666", die: "\xA8", digamma: "\u03DD", disin: "\u22F2", div: "\xF7", divide: "\xF7", divideontimes: "\u22C7", divonx: "\u22C7", djcy: "\u0452", dlcorn: "\u231E", dlcrop: "\u230D", dollar: "$", dopf: "\u{1D555}", dot: "\u02D9", doteq: "\u2250", doteqdot: "\u2251", dotminus: "\u2238", dotplus: "\u2214", dotsquare: "\u22A1", doublebarwedge: "\u2306", downarrow: "\u2193", downdownarrows: "\u21CA", downharpoonleft: "\u21C3", downharpoonright: "\u21C2", drbkarow: "\u2910", drcorn: "\u231F", drcrop: "\u230C", dscr: "\u{1D4B9}", dscy: "\u0455", dsol: "\u29F6", dstrok: "\u0111", dtdot: "\u22F1", dtri: "\u25BF", dtrif: "\u25BE", duarr: "\u21F5", duhar: "\u296F", dwangle: "\u29A6", dzcy: "\u045F", dzigrarr: "\u27FF", eDDot: "\u2A77", eDot: "\u2251", eacute: "\xE9", easter: "\u2A6E", ecaron: "\u011B", ecir: "\u2256", ecirc: "\xEA", ecolon: "\u2255", ecy: "\u044D", edot: "\u0117", ee: "\u2147", efDot: "\u2252", efr: "\u{1D522}", eg: "\u2A9A", egrave: "\xE8", egs: "\u2A96", egsdot: "\u2A98", el: "\u2A99", elinters: "\u23E7", ell: "\u2113", els: "\u2A95", elsdot: "\u2A97", emacr: "\u0113", empty: "\u2205", emptyset: "\u2205", emptyv: "\u2205", emsp13: "\u2004", emsp14: "\u2005", emsp: "\u2003", eng: "\u014B", ensp: "\u2002", eogon: "\u0119", eopf: "\u{1D556}", epar: "\u22D5", eparsl: "\u29E3", eplus: "\u2A71", epsi: "\u03B5", epsilon: "\u03B5", epsiv: "\u03F5", eqcirc: "\u2256", eqcolon: "\u2255", eqsim: "\u2242", eqslantgtr: "\u2A96", eqslantless: "\u2A95", equals: "=", equest: "\u225F", equiv: "\u2261", equivDD: "\u2A78", eqvparsl: "\u29E5", erDot: "\u2253", erarr: "\u2971", escr: "\u212F", esdot: "\u2250", esim: "\u2242", eta: "\u03B7", eth: "\xF0", euml: "\xEB", euro: "\u20AC", excl: "!", exist: "\u2203", expectation: "\u2130", exponentiale: "\u2147", fallingdotseq: "\u2252", fcy: "\u0444", female: "\u2640", ffilig: "\uFB03", fflig: "\uFB00", ffllig: "\uFB04", ffr: "\u{1D523}", filig: "\uFB01", fjlig: "fj", flat: "\u266D", fllig: "\uFB02", fltns: "\u25B1", fnof: "\u0192", fopf: "\u{1D557}", forall: "\u2200", fork: "\u22D4", forkv: "\u2AD9", fpartint: "\u2A0D", frac12: "\xBD", frac13: "\u2153", frac14: "\xBC", frac15: "\u2155", frac16: "\u2159", frac18: "\u215B", frac23: "\u2154", frac25: "\u2156", frac34: "\xBE", frac35: "\u2157", frac38: "\u215C", frac45: "\u2158", frac56: "\u215A", frac58: "\u215D", frac78: "\u215E", frasl: "\u2044", frown: "\u2322", fscr: "\u{1D4BB}", gE: "\u2267", gEl: "\u2A8C", gacute: "\u01F5", gamma: "\u03B3", gammad: "\u03DD", gap: "\u2A86", gbreve: "\u011F", gcirc: "\u011D", gcy: "\u0433", gdot: "\u0121", ge: "\u2265", gel: "\u22DB", geq: "\u2265", geqq: "\u2267", geqslant: "\u2A7E", ges: "\u2A7E", gescc: "\u2AA9", gesdot: "\u2A80", gesdoto: "\u2A82", gesdotol: "\u2A84", gesl: "\u22DB\uFE00", gesles: "\u2A94", gfr: "\u{1D524}", gg: "\u226B", ggg: "\u22D9", gimel: "\u2137", gjcy: "\u0453", gl: "\u2277", glE: "\u2A92", gla: "\u2AA5", glj: "\u2AA4", gnE: "\u2269", gnap: "\u2A8A", gnapprox: "\u2A8A", gne: "\u2A88", gneq: "\u2A88", gneqq: "\u2269", gnsim: "\u22E7", gopf: "\u{1D558}", grave: "`", gscr: "\u210A", gsim: "\u2273", gsime: "\u2A8E", gsiml: "\u2A90", gt: ">", gtcc: "\u2AA7", gtcir: "\u2A7A", gtdot: "\u22D7", gtlPar: "\u2995", gtquest: "\u2A7C", gtrapprox: "\u2A86", gtrarr: "\u2978", gtrdot: "\u22D7", gtreqless: "\u22DB", gtreqqless: "\u2A8C", gtrless: "\u2277", gtrsim: "\u2273", gvertneqq: "\u2269\uFE00", gvnE: "\u2269\uFE00", hArr: "\u21D4", hairsp: "\u200A", half: "\xBD", hamilt: "\u210B", hardcy: "\u044A", harr: "\u2194", harrcir: "\u2948", harrw: "\u21AD", hbar: "\u210F", hcirc: "\u0125", hearts: "\u2665", heartsuit: "\u2665", hellip: "\u2026", hercon: "\u22B9", hfr: "\u{1D525}", hksearow: "\u2925", hkswarow: "\u2926", hoarr: "\u21FF", homtht: "\u223B", hookleftarrow: "\u21A9", hookrightarrow: "\u21AA", hopf: "\u{1D559}", horbar: "\u2015", hscr: "\u{1D4BD}", hslash: "\u210F", hstrok: "\u0127", hybull: "\u2043", hyphen: "\u2010", iacute: "\xED", ic: "\u2063", icirc: "\xEE", icy: "\u0438", iecy: "\u0435", iexcl: "\xA1", iff: "\u21D4", ifr: "\u{1D526}", igrave: "\xEC", ii: "\u2148", iiiint: "\u2A0C", iiint: "\u222D", iinfin: "\u29DC", iiota: "\u2129", ijlig: "\u0133", imacr: "\u012B", image: "\u2111", imagline: "\u2110", imagpart: "\u2111", imath: "\u0131", imof: "\u22B7", imped: "\u01B5", in: "\u2208", incare: "\u2105", infin: "\u221E", infintie: "\u29DD", inodot: "\u0131", int: "\u222B", intcal: "\u22BA", integers: "\u2124", intercal: "\u22BA", intlarhk: "\u2A17", intprod: "\u2A3C", iocy: "\u0451", iogon: "\u012F", iopf: "\u{1D55A}", iota: "\u03B9", iprod: "\u2A3C", iquest: "\xBF", iscr: "\u{1D4BE}", isin: "\u2208", isinE: "\u22F9", isindot: "\u22F5", isins: "\u22F4", isinsv: "\u22F3", isinv: "\u2208", it: "\u2062", itilde: "\u0129", iukcy: "\u0456", iuml: "\xEF", jcirc: "\u0135", jcy: "\u0439", jfr: "\u{1D527}", jmath: "\u0237", jopf: "\u{1D55B}", jscr: "\u{1D4BF}", jsercy: "\u0458", jukcy: "\u0454", kappa: "\u03BA", kappav: "\u03F0", kcedil: "\u0137", kcy: "\u043A", kfr: "\u{1D528}", kgreen: "\u0138", khcy: "\u0445", kjcy: "\u045C", kopf: "\u{1D55C}", kscr: "\u{1D4C0}", lAarr: "\u21DA", lArr: "\u21D0", lAtail: "\u291B", lBarr: "\u290E", lE: "\u2266", lEg: "\u2A8B", lHar: "\u2962", lacute: "\u013A", laemptyv: "\u29B4", lagran: "\u2112", lambda: "\u03BB", lang: "\u27E8", langd: "\u2991", langle: "\u27E8", lap: "\u2A85", laquo: "\xAB", larr: "\u2190", larrb: "\u21E4", larrbfs: "\u291F", larrfs: "\u291D", larrhk: "\u21A9", larrlp: "\u21AB", larrpl: "\u2939", larrsim: "\u2973", larrtl: "\u21A2", lat: "\u2AAB", latail: "\u2919", late: "\u2AAD", lates: "\u2AAD\uFE00", lbarr: "\u290C", lbbrk: "\u2772", lbrace: "{", lbrack: "[", lbrke: "\u298B", lbrksld: "\u298F", lbrkslu: "\u298D", lcaron: "\u013E", lcedil: "\u013C", lceil: "\u2308", lcub: "{", lcy: "\u043B", ldca: "\u2936", ldquo: "\u201C", ldquor: "\u201E", ldrdhar: "\u2967", ldrushar: "\u294B", ldsh: "\u21B2", le: "\u2264", leftarrow: "\u2190", leftarrowtail: "\u21A2", leftharpoondown: "\u21BD", leftharpoonup: "\u21BC", leftleftarrows: "\u21C7", leftrightarrow: "\u2194", leftrightarrows: "\u21C6", leftrightharpoons: "\u21CB", leftrightsquigarrow: "\u21AD", leftthreetimes: "\u22CB", leg: "\u22DA", leq: "\u2264", leqq: "\u2266", leqslant: "\u2A7D", les: "\u2A7D", lescc: "\u2AA8", lesdot: "\u2A7F", lesdoto: "\u2A81", lesdotor: "\u2A83", lesg: "\u22DA\uFE00", lesges: "\u2A93", lessapprox: "\u2A85", lessdot: "\u22D6", lesseqgtr: "\u22DA", lesseqqgtr: "\u2A8B", lessgtr: "\u2276", lesssim: "\u2272", lfisht: "\u297C", lfloor: "\u230A", lfr: "\u{1D529}", lg: "\u2276", lgE: "\u2A91", lhard: "\u21BD", lharu: "\u21BC", lharul: "\u296A", lhblk: "\u2584", ljcy: "\u0459", ll: "\u226A", llarr: "\u21C7", llcorner: "\u231E", llhard: "\u296B", lltri: "\u25FA", lmidot: "\u0140", lmoust: "\u23B0", lmoustache: "\u23B0", lnE: "\u2268", lnap: "\u2A89", lnapprox: "\u2A89", lne: "\u2A87", lneq: "\u2A87", lneqq: "\u2268", lnsim: "\u22E6", loang: "\u27EC", loarr: "\u21FD", lobrk: "\u27E6", longleftarrow: "\u27F5", longleftrightarrow: "\u27F7", longmapsto: "\u27FC", longrightarrow: "\u27F6", looparrowleft: "\u21AB", looparrowright: "\u21AC", lopar: "\u2985", lopf: "\u{1D55D}", loplus: "\u2A2D", lotimes: "\u2A34", lowast: "\u2217", lowbar: "_", loz: "\u25CA", lozenge: "\u25CA", lozf: "\u29EB", lpar: "(", lparlt: "\u2993", lrarr: "\u21C6", lrcorner: "\u231F", lrhar: "\u21CB", lrhard: "\u296D", lrm: "\u200E", lrtri: "\u22BF", lsaquo: "\u2039", lscr: "\u{1D4C1}", lsh: "\u21B0", lsim: "\u2272", lsime: "\u2A8D", lsimg: "\u2A8F", lsqb: "[", lsquo: "\u2018", lsquor: "\u201A", lstrok: "\u0142", lt: "<", ltcc: "\u2AA6", ltcir: "\u2A79", ltdot: "\u22D6", lthree: "\u22CB", ltimes: "\u22C9", ltlarr: "\u2976", ltquest: "\u2A7B", ltrPar: "\u2996", ltri: "\u25C3", ltrie: "\u22B4", ltrif: "\u25C2", lurdshar: "\u294A", luruhar: "\u2966", lvertneqq: "\u2268\uFE00", lvnE: "\u2268\uFE00", mDDot: "\u223A", macr: "\xAF", male: "\u2642", malt: "\u2720", maltese: "\u2720", map: "\u21A6", mapsto: "\u21A6", mapstodown: "\u21A7", mapstoleft: "\u21A4", mapstoup: "\u21A5", marker: "\u25AE", mcomma: "\u2A29", mcy: "\u043C", mdash: "\u2014", measuredangle: "\u2221", mfr: "\u{1D52A}", mho: "\u2127", micro: "\xB5", mid: "\u2223", midast: "*", midcir: "\u2AF0", middot: "\xB7", minus: "\u2212", minusb: "\u229F", minusd: "\u2238", minusdu: "\u2A2A", mlcp: "\u2ADB", mldr: "\u2026", mnplus: "\u2213", models: "\u22A7", mopf: "\u{1D55E}", mp: "\u2213", mscr: "\u{1D4C2}", mstpos: "\u223E", mu: "\u03BC", multimap: "\u22B8", mumap: "\u22B8", nGg: "\u22D9\u0338", nGt: "\u226B\u20D2", nGtv: "\u226B\u0338", nLeftarrow: "\u21CD", nLeftrightarrow: "\u21CE", nLl: "\u22D8\u0338", nLt: "\u226A\u20D2", nLtv: "\u226A\u0338", nRightarrow: "\u21CF", nVDash: "\u22AF", nVdash: "\u22AE", nabla: "\u2207", nacute: "\u0144", nang: "\u2220\u20D2", nap: "\u2249", napE: "\u2A70\u0338", napid: "\u224B\u0338", napos: "\u0149", napprox: "\u2249", natur: "\u266E", natural: "\u266E", naturals: "\u2115", nbsp: "\xA0", nbump: "\u224E\u0338", nbumpe: "\u224F\u0338", ncap: "\u2A43", ncaron: "\u0148", ncedil: "\u0146", ncong: "\u2247", ncongdot: "\u2A6D\u0338", ncup: "\u2A42", ncy: "\u043D", ndash: "\u2013", ne: "\u2260", neArr: "\u21D7", nearhk: "\u2924", nearr: "\u2197", nearrow: "\u2197", nedot: "\u2250\u0338", nequiv: "\u2262", nesear: "\u2928", nesim: "\u2242\u0338", nexist: "\u2204", nexists: "\u2204", nfr: "\u{1D52B}", ngE: "\u2267\u0338", nge: "\u2271", ngeq: "\u2271", ngeqq: "\u2267\u0338", ngeqslant: "\u2A7E\u0338", nges: "\u2A7E\u0338", ngsim: "\u2275", ngt: "\u226F", ngtr: "\u226F", nhArr: "\u21CE", nharr: "\u21AE", nhpar: "\u2AF2", ni: "\u220B", nis: "\u22FC", nisd: "\u22FA", niv: "\u220B", njcy: "\u045A", nlArr: "\u21CD", nlE: "\u2266\u0338", nlarr: "\u219A", nldr: "\u2025", nle: "\u2270", nleftarrow: "\u219A", nleftrightarrow: "\u21AE", nleq: "\u2270", nleqq: "\u2266\u0338", nleqslant: "\u2A7D\u0338", nles: "\u2A7D\u0338", nless: "\u226E", nlsim: "\u2274", nlt: "\u226E", nltri: "\u22EA", nltrie: "\u22EC", nmid: "\u2224", nopf: "\u{1D55F}", not: "\xAC", notin: "\u2209", notinE: "\u22F9\u0338", notindot: "\u22F5\u0338", notinva: "\u2209", notinvb: "\u22F7", notinvc: "\u22F6", notni: "\u220C", notniva: "\u220C", notnivb: "\u22FE", notnivc: "\u22FD", npar: "\u2226", nparallel: "\u2226", nparsl: "\u2AFD\u20E5", npart: "\u2202\u0338", npolint: "\u2A14", npr: "\u2280", nprcue: "\u22E0", npre: "\u2AAF\u0338", nprec: "\u2280", npreceq: "\u2AAF\u0338", nrArr: "\u21CF", nrarr: "\u219B", nrarrc: "\u2933\u0338", nrarrw: "\u219D\u0338", nrightarrow: "\u219B", nrtri: "\u22EB", nrtrie: "\u22ED", nsc: "\u2281", nsccue: "\u22E1", nsce: "\u2AB0\u0338", nscr: "\u{1D4C3}", nshortmid: "\u2224", nshortparallel: "\u2226", nsim: "\u2241", nsime: "\u2244", nsimeq: "\u2244", nsmid: "\u2224", nspar: "\u2226", nsqsube: "\u22E2", nsqsupe: "\u22E3", nsub: "\u2284", nsubE: "\u2AC5\u0338", nsube: "\u2288", nsubset: "\u2282\u20D2", nsubseteq: "\u2288", nsubseteqq: "\u2AC5\u0338", nsucc: "\u2281", nsucceq: "\u2AB0\u0338", nsup: "\u2285", nsupE: "\u2AC6\u0338", nsupe: "\u2289", nsupset: "\u2283\u20D2", nsupseteq: "\u2289", nsupseteqq: "\u2AC6\u0338", ntgl: "\u2279", ntilde: "\xF1", ntlg: "\u2278", ntriangleleft: "\u22EA", ntrianglelefteq: "\u22EC", ntriangleright: "\u22EB", ntrianglerighteq: "\u22ED", nu: "\u03BD", num: "#", numero: "\u2116", numsp: "\u2007", nvDash: "\u22AD", nvHarr: "\u2904", nvap: "\u224D\u20D2", nvdash: "\u22AC", nvge: "\u2265\u20D2", nvgt: ">\u20D2", nvinfin: "\u29DE", nvlArr: "\u2902", nvle: "\u2264\u20D2", nvlt: "<\u20D2", nvltrie: "\u22B4\u20D2", nvrArr: "\u2903", nvrtrie: "\u22B5\u20D2", nvsim: "\u223C\u20D2", nwArr: "\u21D6", nwarhk: "\u2923", nwarr: "\u2196", nwarrow: "\u2196", nwnear: "\u2927", oS: "\u24C8", oacute: "\xF3", oast: "\u229B", ocir: "\u229A", ocirc: "\xF4", ocy: "\u043E", odash: "\u229D", odblac: "\u0151", odiv: "\u2A38", odot: "\u2299", odsold: "\u29BC", oelig: "\u0153", ofcir: "\u29BF", ofr: "\u{1D52C}", ogon: "\u02DB", ograve: "\xF2", ogt: "\u29C1", ohbar: "\u29B5", ohm: "\u03A9", oint: "\u222E", olarr: "\u21BA", olcir: "\u29BE", olcross: "\u29BB", oline: "\u203E", olt: "\u29C0", omacr: "\u014D", omega: "\u03C9", omicron: "\u03BF", omid: "\u29B6", ominus: "\u2296", oopf: "\u{1D560}", opar: "\u29B7", operp: "\u29B9", oplus: "\u2295", or: "\u2228", orarr: "\u21BB", ord: "\u2A5D", order: "\u2134", orderof: "\u2134", ordf: "\xAA", ordm: "\xBA", origof: "\u22B6", oror: "\u2A56", orslope: "\u2A57", orv: "\u2A5B", oscr: "\u2134", oslash: "\xF8", osol: "\u2298", otilde: "\xF5", otimes: "\u2297", otimesas: "\u2A36", ouml: "\xF6", ovbar: "\u233D", par: "\u2225", para: "\xB6", parallel: "\u2225", parsim: "\u2AF3", parsl: "\u2AFD", part: "\u2202", pcy: "\u043F", percnt: "%", period: ".", permil: "\u2030", perp: "\u22A5", pertenk: "\u2031", pfr: "\u{1D52D}", phi: "\u03C6", phiv: "\u03D5", phmmat: "\u2133", phone: "\u260E", pi: "\u03C0", pitchfork: "\u22D4", piv: "\u03D6", planck: "\u210F", planckh: "\u210E", plankv: "\u210F", plus: "+", plusacir: "\u2A23", plusb: "\u229E", pluscir: "\u2A22", plusdo: "\u2214", plusdu: "\u2A25", pluse: "\u2A72", plusmn: "\xB1", plussim: "\u2A26", plustwo: "\u2A27", pm: "\xB1", pointint: "\u2A15", popf: "\u{1D561}", pound: "\xA3", pr: "\u227A", prE: "\u2AB3", prap: "\u2AB7", prcue: "\u227C", pre: "\u2AAF", prec: "\u227A", precapprox: "\u2AB7", preccurlyeq: "\u227C", preceq: "\u2AAF", precnapprox: "\u2AB9", precneqq: "\u2AB5", precnsim: "\u22E8", precsim: "\u227E", prime: "\u2032", primes: "\u2119", prnE: "\u2AB5", prnap: "\u2AB9", prnsim: "\u22E8", prod: "\u220F", profalar: "\u232E", profline: "\u2312", profsurf: "\u2313", prop: "\u221D", propto: "\u221D", prsim: "\u227E", prurel: "\u22B0", pscr: "\u{1D4C5}", psi: "\u03C8", puncsp: "\u2008", qfr: "\u{1D52E}", qint: "\u2A0C", qopf: "\u{1D562}", qprime: "\u2057", qscr: "\u{1D4C6}", quaternions: "\u210D", quatint: "\u2A16", quest: "?", questeq: "\u225F", quot: '"', rAarr: "\u21DB", rArr: "\u21D2", rAtail: "\u291C", rBarr: "\u290F", rHar: "\u2964", race: "\u223D\u0331", racute: "\u0155", radic: "\u221A", raemptyv: "\u29B3", rang: "\u27E9", rangd: "\u2992", range: "\u29A5", rangle: "\u27E9", raquo: "\xBB", rarr: "\u2192", rarrap: "\u2975", rarrb: "\u21E5", rarrbfs: "\u2920", rarrc: "\u2933", rarrfs: "\u291E", rarrhk: "\u21AA", rarrlp: "\u21AC", rarrpl: "\u2945", rarrsim: "\u2974", rarrtl: "\u21A3", rarrw: "\u219D", ratail: "\u291A", ratio: "\u2236", rationals: "\u211A", rbarr: "\u290D", rbbrk: "\u2773", rbrace: "}", rbrack: "]", rbrke: "\u298C", rbrksld: "\u298E", rbrkslu: "\u2990", rcaron: "\u0159", rcedil: "\u0157", rceil: "\u2309", rcub: "}", rcy: "\u0440", rdca: "\u2937", rdldhar: "\u2969", rdquo: "\u201D", rdquor: "\u201D", rdsh: "\u21B3", real: "\u211C", realine: "\u211B", realpart: "\u211C", reals: "\u211D", rect: "\u25AD", reg: "\xAE", rfisht: "\u297D", rfloor: "\u230B", rfr: "\u{1D52F}", rhard: "\u21C1", rharu: "\u21C0", rharul: "\u296C", rho: "\u03C1", rhov: "\u03F1", rightarrow: "\u2192", rightarrowtail: "\u21A3", rightharpoondown: "\u21C1", rightharpoonup: "\u21C0", rightleftarrows: "\u21C4", rightleftharpoons: "\u21CC", rightrightarrows: "\u21C9", rightsquigarrow: "\u219D", rightthreetimes: "\u22CC", ring: "\u02DA", risingdotseq: "\u2253", rlarr: "\u21C4", rlhar: "\u21CC", rlm: "\u200F", rmoust: "\u23B1", rmoustache: "\u23B1", rnmid: "\u2AEE", roang: "\u27ED", roarr: "\u21FE", robrk: "\u27E7", ropar: "\u2986", ropf: "\u{1D563}", roplus: "\u2A2E", rotimes: "\u2A35", rpar: ")", rpargt: "\u2994", rppolint: "\u2A12", rrarr: "\u21C9", rsaquo: "\u203A", rscr: "\u{1D4C7}", rsh: "\u21B1", rsqb: "]", rsquo: "\u2019", rsquor: "\u2019", rthree: "\u22CC", rtimes: "\u22CA", rtri: "\u25B9", rtrie: "\u22B5", rtrif: "\u25B8", rtriltri: "\u29CE", ruluhar: "\u2968", rx: "\u211E", sacute: "\u015B", sbquo: "\u201A", sc: "\u227B", scE: "\u2AB4", scap: "\u2AB8", scaron: "\u0161", sccue: "\u227D", sce: "\u2AB0", scedil: "\u015F", scirc: "\u015D", scnE: "\u2AB6", scnap: "\u2ABA", scnsim: "\u22E9", scpolint: "\u2A13", scsim: "\u227F", scy: "\u0441", sdot: "\u22C5", sdotb: "\u22A1", sdote: "\u2A66", seArr: "\u21D8", searhk: "\u2925", searr: "\u2198", searrow: "\u2198", sect: "\xA7", semi: ";", seswar: "\u2929", setminus: "\u2216", setmn: "\u2216", sext: "\u2736", sfr: "\u{1D530}", sfrown: "\u2322", sharp: "\u266F", shchcy: "\u0449", shcy: "\u0448", shortmid: "\u2223", shortparallel: "\u2225", shy: "\xAD", sigma: "\u03C3", sigmaf: "\u03C2", sigmav: "\u03C2", sim: "\u223C", simdot: "\u2A6A", sime: "\u2243", simeq: "\u2243", simg: "\u2A9E", simgE: "\u2AA0", siml: "\u2A9D", simlE: "\u2A9F", simne: "\u2246", simplus: "\u2A24", simrarr: "\u2972", slarr: "\u2190", smallsetminus: "\u2216", smashp: "\u2A33", smeparsl: "\u29E4", smid: "\u2223", smile: "\u2323", smt: "\u2AAA", smte: "\u2AAC", smtes: "\u2AAC\uFE00", softcy: "\u044C", sol: "/", solb: "\u29C4", solbar: "\u233F", sopf: "\u{1D564}", spades: "\u2660", spadesuit: "\u2660", spar: "\u2225", sqcap: "\u2293", sqcaps: "\u2293\uFE00", sqcup: "\u2294", sqcups: "\u2294\uFE00", sqsub: "\u228F", sqsube: "\u2291", sqsubset: "\u228F", sqsubseteq: "\u2291", sqsup: "\u2290", sqsupe: "\u2292", sqsupset: "\u2290", sqsupseteq: "\u2292", squ: "\u25A1", square: "\u25A1", squarf: "\u25AA", squf: "\u25AA", srarr: "\u2192", sscr: "\u{1D4C8}", ssetmn: "\u2216", ssmile: "\u2323", sstarf: "\u22C6", star: "\u2606", starf: "\u2605", straightepsilon: "\u03F5", straightphi: "\u03D5", strns: "\xAF", sub: "\u2282", subE: "\u2AC5", subdot: "\u2ABD", sube: "\u2286", subedot: "\u2AC3", submult: "\u2AC1", subnE: "\u2ACB", subne: "\u228A", subplus: "\u2ABF", subrarr: "\u2979", subset: "\u2282", subseteq: "\u2286", subseteqq: "\u2AC5", subsetneq: "\u228A", subsetneqq: "\u2ACB", subsim: "\u2AC7", subsub: "\u2AD5", subsup: "\u2AD3", succ: "\u227B", succapprox: "\u2AB8", succcurlyeq: "\u227D", succeq: "\u2AB0", succnapprox: "\u2ABA", succneqq: "\u2AB6", succnsim: "\u22E9", succsim: "\u227F", sum: "\u2211", sung: "\u266A", sup1: "\xB9", sup2: "\xB2", sup3: "\xB3", sup: "\u2283", supE: "\u2AC6", supdot: "\u2ABE", supdsub: "\u2AD8", supe: "\u2287", supedot: "\u2AC4", suphsol: "\u27C9", suphsub: "\u2AD7", suplarr: "\u297B", supmult: "\u2AC2", supnE: "\u2ACC", supne: "\u228B", supplus: "\u2AC0", supset: "\u2283", supseteq: "\u2287", supseteqq: "\u2AC6", supsetneq: "\u228B", supsetneqq: "\u2ACC", supsim: "\u2AC8", supsub: "\u2AD4", supsup: "\u2AD6", swArr: "\u21D9", swarhk: "\u2926", swarr: "\u2199", swarrow: "\u2199", swnwar: "\u292A", szlig: "\xDF", target: "\u2316", tau: "\u03C4", tbrk: "\u23B4", tcaron: "\u0165", tcedil: "\u0163", tcy: "\u0442", tdot: "\u20DB", telrec: "\u2315", tfr: "\u{1D531}", there4: "\u2234", therefore: "\u2234", theta: "\u03B8", thetasym: "\u03D1", thetav: "\u03D1", thickapprox: "\u2248", thicksim: "\u223C", thinsp: "\u2009", thkap: "\u2248", thksim: "\u223C", thorn: "\xFE", tilde: "\u02DC", times: "\xD7", timesb: "\u22A0", timesbar: "\u2A31", timesd: "\u2A30", tint: "\u222D", toea: "\u2928", top: "\u22A4", topbot: "\u2336", topcir: "\u2AF1", topf: "\u{1D565}", topfork: "\u2ADA", tosa: "\u2929", tprime: "\u2034", trade: "\u2122", triangle: "\u25B5", triangledown: "\u25BF", triangleleft: "\u25C3", trianglelefteq: "\u22B4", triangleq: "\u225C", triangleright: "\u25B9", trianglerighteq: "\u22B5", tridot: "\u25EC", trie: "\u225C", triminus: "\u2A3A", triplus: "\u2A39", trisb: "\u29CD", tritime: "\u2A3B", trpezium: "\u23E2", tscr: "\u{1D4C9}", tscy: "\u0446", tshcy: "\u045B", tstrok: "\u0167", twixt: "\u226C", twoheadleftarrow: "\u219E", twoheadrightarrow: "\u21A0", uArr: "\u21D1", uHar: "\u2963", uacute: "\xFA", uarr: "\u2191", ubrcy: "\u045E", ubreve: "\u016D", ucirc: "\xFB", ucy: "\u0443", udarr: "\u21C5", udblac: "\u0171", udhar: "\u296E", ufisht: "\u297E", ufr: "\u{1D532}", ugrave: "\xF9", uharl: "\u21BF", uharr: "\u21BE", uhblk: "\u2580", ulcorn: "\u231C", ulcorner: "\u231C", ulcrop: "\u230F", ultri: "\u25F8", umacr: "\u016B", uml: "\xA8", uogon: "\u0173", uopf: "\u{1D566}", uparrow: "\u2191", updownarrow: "\u2195", upharpoonleft: "\u21BF", upharpoonright: "\u21BE", uplus: "\u228E", upsi: "\u03C5", upsih: "\u03D2", upsilon: "\u03C5", upuparrows: "\u21C8", urcorn: "\u231D", urcorner: "\u231D", urcrop: "\u230E", uring: "\u016F", urtri: "\u25F9", uscr: "\u{1D4CA}", utdot: "\u22F0", utilde: "\u0169", utri: "\u25B5", utrif: "\u25B4", uuarr: "\u21C8", uuml: "\xFC", uwangle: "\u29A7", vArr: "\u21D5", vBar: "\u2AE8", vBarv: "\u2AE9", vDash: "\u22A8", vangrt: "\u299C", varepsilon: "\u03F5", varkappa: "\u03F0", varnothing: "\u2205", varphi: "\u03D5", varpi: "\u03D6", varpropto: "\u221D", varr: "\u2195", varrho: "\u03F1", varsigma: "\u03C2", varsubsetneq: "\u228A\uFE00", varsubsetneqq: "\u2ACB\uFE00", varsupsetneq: "\u228B\uFE00", varsupsetneqq: "\u2ACC\uFE00", vartheta: "\u03D1", vartriangleleft: "\u22B2", vartriangleright: "\u22B3", vcy: "\u0432", vdash: "\u22A2", vee: "\u2228", veebar: "\u22BB", veeeq: "\u225A", vellip: "\u22EE", verbar: "|", vert: "|", vfr: "\u{1D533}", vltri: "\u22B2", vnsub: "\u2282\u20D2", vnsup: "\u2283\u20D2", vopf: "\u{1D567}", vprop: "\u221D", vrtri: "\u22B3", vscr: "\u{1D4CB}", vsubnE: "\u2ACB\uFE00", vsubne: "\u228A\uFE00", vsupnE: "\u2ACC\uFE00", vsupne: "\u228B\uFE00", vzigzag: "\u299A", wcirc: "\u0175", wedbar: "\u2A5F", wedge: "\u2227", wedgeq: "\u2259", weierp: "\u2118", wfr: "\u{1D534}", wopf: "\u{1D568}", wp: "\u2118", wr: "\u2240", wreath: "\u2240", wscr: "\u{1D4CC}", xcap: "\u22C2", xcirc: "\u25EF", xcup: "\u22C3", xdtri: "\u25BD", xfr: "\u{1D535}", xhArr: "\u27FA", xharr: "\u27F7", xi: "\u03BE", xlArr: "\u27F8", xlarr: "\u27F5", xmap: "\u27FC", xnis: "\u22FB", xodot: "\u2A00", xopf: "\u{1D569}", xoplus: "\u2A01", xotime: "\u2A02", xrArr: "\u27F9", xrarr: "\u27F6", xscr: "\u{1D4CD}", xsqcup: "\u2A06", xuplus: "\u2A04", xutri: "\u25B3", xvee: "\u22C1", xwedge: "\u22C0", yacute: "\xFD", yacy: "\u044F", ycirc: "\u0177", ycy: "\u044B", yen: "\xA5", yfr: "\u{1D536}", yicy: "\u0457", yopf: "\u{1D56A}", yscr: "\u{1D4CE}", yucy: "\u044E", yuml: "\xFF", zacute: "\u017A", zcaron: "\u017E", zcy: "\u0437", zdot: "\u017C", zeetrf: "\u2128", zeta: "\u03B6", zfr: "\u{1D537}", zhcy: "\u0436", zigrarr: "\u21DD", zopf: "\u{1D56B}", zscr: "\u{1D4CF}", zwj: "\u200D", zwnj: "\u200C" }, $u = { 0: 65533, 128: 8364, 130: 8218, 131: 402, 132: 8222, 133: 8230, 134: 8224, 135: 8225, 136: 710, 137: 8240, 138: 352, 139: 8249, 140: 338, 142: 381, 145: 8216, 146: 8217, 147: 8220, 148: 8221, 149: 8226, 150: 8211, 151: 8212, 152: 732, 153: 8482, 154: 353, 155: 8250, 156: 339, 158: 382, 159: 376 };
          function D0(u) {
            return u.replace(/&(?:[a-zA-Z]+|#[xX][\da-fA-F]+|#\d+);/g, (e) => {
              if (e.charAt(1) === "#") {
                let i = e.charAt(2), n = i === "X" || i === "x" ? parseInt(e.slice(3), 16) : parseInt(e.slice(2), 10);
                return C0(n);
              }
              return E0[e.slice(1, -1)] || e;
            });
          }
          function C0(u) {
            return u >= 55296 && u <= 57343 || u > 1114111 ? "\uFFFD" : (u in $u && (u = $u[u]), String.fromCodePoint(u));
          }
          function w0(u, e) {
            return u.startPos = u.tokenPos = u.index, u.startColumn = u.colPos = u.column, u.startLine = u.linePos = u.line, u.token = V[u.currentChar] & 8192 ? q0(u, e) : Yu(u, e, 0), u.token;
          }
          function q0(u, e) {
            let i = u.currentChar, n = r(u), t = u.index;
            for (; n !== i; ) u.index >= u.end && f(u, 14), n = r(u);
            return n !== i && f(u, 14), u.tokenValue = u.source.slice(t, u.index), r(u), e & 512 && (u.tokenRaw = u.source.slice(u.tokenPos, u.index)), 134283267;
          }
          function V2(u, e) {
            if (u.startPos = u.tokenPos = u.index, u.startColumn = u.colPos = u.column, u.startLine = u.linePos = u.line, u.index >= u.end) return u.token = 1048576;
            switch (Wu[u.source.charCodeAt(u.index)]) {
              case 8456258: {
                r(u), u.currentChar === 47 ? (r(u), u.token = 25) : u.token = 8456258;
                break;
              }
              case 2162700: {
                r(u), u.token = 2162700;
                break;
              }
              default: {
                let n = 0;
                for (; u.index < u.end; ) {
                  let o = V[u.source.charCodeAt(u.index)];
                  if (o & 1024 ? (n |= 5, X(u)) : o & 2048 ? (Y(u, n), n = n & -5 | 1) : r(u), V[u.currentChar] & 16384) break;
                }
                let t = u.source.slice(u.tokenPos, u.index);
                e & 512 && (u.tokenRaw = t), u.tokenValue = D0(t), u.token = 138;
              }
            }
            return u.token;
          }
          function N1(u) {
            if ((u.token & 143360) === 143360) {
              let { index: e } = u, i = u.currentChar;
              for (; V[i] & 32770; ) i = r(u);
              u.tokenValue += u.source.slice(e, u.index);
            }
            return u.token = 208897, u.token;
          }
          function d2(u, e, i) {
            (u.flags & 1) === 0 && (u.token & 1048576) !== 1048576 && !i && f(u, 28, G[u.token & 255]), U(u, e, 1074790417);
          }
          function Zu(u, e, i, n) {
            return e - i < 13 && n === "use strict" && ((u.token & 1048576) === 1048576 || u.flags & 1) ? 1 : 0;
          }
          function V1(u, e, i) {
            return u.token !== i ? 0 : (E(u, e), 1);
          }
          function U(u, e, i) {
            return u.token !== i ? false : (E(u, e), true);
          }
          function w(u, e, i) {
            u.token !== i && f(u, 23, G[i & 255]), E(u, e);
          }
          function v2(u, e) {
            switch (e.type) {
              case "ArrayExpression":
                e.type = "ArrayPattern";
                let i = e.elements;
                for (let t = 0, o = i.length; t < o; ++t) {
                  let l = i[t];
                  l && v2(u, l);
                }
                return;
              case "ObjectExpression":
                e.type = "ObjectPattern";
                let n = e.properties;
                for (let t = 0, o = n.length; t < o; ++t) v2(u, n[t]);
                return;
              case "AssignmentExpression":
                e.type = "AssignmentPattern", e.operator !== "=" && f(u, 68), delete e.operator, v2(u, e.left);
                return;
              case "Property":
                v2(u, e.value);
                return;
              case "SpreadElement":
                e.type = "RestElement", v2(u, e.argument);
            }
          }
          function o1(u, e, i, n, t) {
            e & 1024 && ((n & 36864) === 36864 && f(u, 114), !t && (n & 537079808) === 537079808 && f(u, 115)), (n & 20480) === 20480 && f(u, 99), i & 24 && n === 241739 && f(u, 97), e & 4196352 && n === 209008 && f(u, 95), e & 2098176 && n === 241773 && f(u, 94, "yield");
          }
          function Qu(u, e, i) {
            e & 1024 && ((i & 36864) === 36864 && f(u, 114), (i & 537079808) === 537079808 && f(u, 115), i === 122 && f(u, 92), i === 121 && f(u, 92)), (i & 20480) === 20480 && f(u, 99), e & 4196352 && i === 209008 && f(u, 95), e & 2098176 && i === 241773 && f(u, 94, "yield");
          }
          function Gu(u, e, i) {
            return i === 209008 && (e & 4196352 && f(u, 95), u.destructible |= 128), i === 241773 && e & 2097152 && f(u, 94, "yield"), (i & 20480) === 20480 || (i & 36864) === 36864 || i == 122;
          }
          function B0(u) {
            return u.property ? u.property.type === "PrivateIdentifier" : false;
          }
          function xu(u, e, i, n) {
            for (; e; ) {
              if (e["$" + i]) return n && f(u, 133), 1;
              n && e.loop && (n = 0), e = e.$;
            }
            return 0;
          }
          function S0(u, e, i) {
            let n = e;
            for (; n; ) n["$" + i] && f(u, 132, i), n = n.$;
            e["$" + i] = 1;
          }
          function v(u, e, i, n, t, o) {
            return e & 2 && (o.start = i, o.end = u.startPos, o.range = [i, u.startPos]), e & 4 && (o.loc = { start: { line: n, column: t }, end: { line: u.startLine, column: u.startColumn } }, u.sourceFile && (o.loc.source = u.sourceFile)), o;
          }
          function l1(u) {
            switch (u.type) {
              case "JSXIdentifier":
                return u.name;
              case "JSXNamespacedName":
                return u.namespace + ":" + u.name;
              case "JSXMemberExpression":
                return l1(u.object) + "." + l1(u.property);
            }
          }
          function f1(u, e, i) {
            let n = o2(j2(), 1024);
            return B2(u, e, n, i, 1, 0), n;
          }
          function j1(u, e) {
            let { index: i, line: n, column: t } = u;
            for (var o = arguments.length, l = new Array(o > 2 ? o - 2 : 0), c = 2; c < o; c++) l[c - 2] = arguments[c];
            return { type: e, params: l, index: i, line: n, column: t };
          }
          function j2() {
            return { parent: void 0, type: 2 };
          }
          function o2(u, e) {
            return { parent: u, type: e, scopeError: void 0 };
          }
          function q2(u, e, i, n, t, o) {
            t & 4 ? pu(u, e, i, n, t) : B2(u, e, i, n, t, o), o & 64 && _2(u, n);
          }
          function B2(u, e, i, n, t, o) {
            let l = i["#" + n];
            l && (l & 2) === 0 && (t & 1 ? i.scopeError = j1(u, 140, n) : e & 256 && l & 64 && o & 2 || f(u, 140, n)), i.type & 128 && i.parent["#" + n] && (i.parent["#" + n] & 2) === 0 && f(u, 140, n), i.type & 1024 && l && (l & 2) === 0 && t & 1 && (i.scopeError = j1(u, 140, n)), i.type & 64 && i.parent["#" + n] & 768 && f(u, 153, n), i["#" + n] = t;
          }
          function pu(u, e, i, n, t) {
            let o = i;
            for (; o && (o.type & 256) === 0; ) {
              let l = o["#" + n];
              l & 248 && (e & 256 && (e & 1024) === 0 && (t & 128 && l & 68 || l & 128 && t & 68) || f(u, 140, n)), o === i && l & 1 && t & 1 && (o.scopeError = j1(u, 140, n)), l & 768 && ((l & 512) === 0 || (e & 256) === 0 || e & 1024) && f(u, 140, n), o["#" + n] = t, o = o.parent;
            }
          }
          function _2(u, e) {
            u.exportedNames !== void 0 && e !== "" && (u.exportedNames["#" + e] && f(u, 141, e), u.exportedNames["#" + e] = 1);
          }
          function F0(u, e) {
            u.exportedBindings !== void 0 && e !== "" && (u.exportedBindings["#" + e] = 1);
          }
          function T0(u, e) {
            return function(i, n, t, o, l) {
              let c = { type: i, value: n };
              u & 2 && (c.start = t, c.end = o, c.range = [t, o]), u & 4 && (c.loc = l), e.push(c);
            };
          }
          function L0(u, e) {
            return function(i, n, t, o) {
              let l = { token: i };
              u & 2 && (l.start = n, l.end = t, l.range = [n, t]), u & 4 && (l.loc = o), e.push(l);
            };
          }
          function _1(u, e) {
            return u & 2098176 ? u & 2048 && e === 209008 || u & 2097152 && e === 241773 ? false : (e & 143360) === 143360 || (e & 12288) === 12288 : (e & 143360) === 143360 || (e & 12288) === 12288 || (e & 36864) === 36864;
          }
          function M1(u, e, i, n) {
            (i & 537079808) === 537079808 && (e & 1024 && f(u, 115), n && (u.flags |= 512)), _1(e, i) || f(u, 0);
          }
          function O0(u, e, i, n) {
            return { source: u, flags: 0, index: 0, line: 1, column: 0, startPos: 0, end: u.length, tokenPos: 0, startColumn: 0, colPos: 0, linePos: 1, startLine: 1, sourceFile: e, tokenValue: "", token: 1048576, tokenRaw: "", tokenRegExp: void 0, currentChar: u.charCodeAt(0), exportedNames: [], exportedBindings: [], assignable: 1, destructible: 0, onComment: i, onToken: n, leadingDecorators: [] };
          }
          function U1(u, e, i) {
            let n = "", t, o;
            e != null && (e.module && (i |= 3072), e.next && (i |= 1), e.loc && (i |= 4), e.ranges && (i |= 2), e.uniqueKeyInPattern && (i |= -2147483648), e.lexical && (i |= 64), e.webcompat && (i |= 256), e.directives && (i |= 520), e.globalReturn && (i |= 32), e.raw && (i |= 512), e.preserveParens && (i |= 128), e.impliedStrict && (i |= 1024), e.jsx && (i |= 16), e.identifierPattern && (i |= 268435456), e.specDeviation && (i |= 536870912), e.source && (n = e.source), e.onComment != null && (t = Array.isArray(e.onComment) ? T0(i, e.onComment) : e.onComment), e.onToken != null && (o = Array.isArray(e.onToken) ? L0(i, e.onToken) : e.onToken));
            let l = O0(u, n, t, o);
            i & 1 && c2(l);
            let c = i & 64 ? j2() : void 0, s = [], h = "script";
            if (i & 2048) {
              if (h = "module", s = R0(l, i | 8192, c), c) for (let g in l.exportedBindings) g[0] === "#" && !c[g] && f(l, 142, g.slice(1));
            } else s = I0(l, i | 8192, c);
            let b = { type: "Program", sourceType: h, body: s };
            return i & 2 && (b.start = 0, b.end = u.length, b.range = [0, u.length]), i & 4 && (b.loc = { start: { line: 1, column: 0 }, end: { line: l.line, column: l.column } }, l.sourceFile && (b.loc.source = n)), b;
          }
          function I0(u, e, i) {
            E(u, e | 32768 | 1073741824);
            let n = [];
            for (; u.token === 134283267; ) {
              let { index: t, tokenPos: o, tokenValue: l, linePos: c, colPos: s, token: h } = u, b = a2(u, e);
              Zu(u, t, o, l) && (e |= 1024), n.push(X1(u, e, b, h, o, c, s));
            }
            for (; u.token !== 1048576; ) n.push(G2(u, e, i, 4, {}));
            return n;
          }
          function R0(u, e, i) {
            E(u, e | 32768);
            let n = [];
            if (e & 8) for (; u.token === 134283267; ) {
              let { tokenPos: t, linePos: o, colPos: l, token: c } = u;
              n.push(X1(u, e, a2(u, e), c, t, o, l));
            }
            for (; u.token !== 1048576; ) n.push(N0(u, e, i));
            return n;
          }
          function N0(u, e, i) {
            u.leadingDecorators = b1(u, e);
            let n;
            switch (u.token) {
              case 20566:
                n = ut(u, e, i);
                break;
              case 86108:
                n = x0(u, e, i);
                break;
              default:
                n = G2(u, e, i, 4, {});
            }
            return u.leadingDecorators.length && f(u, 164), n;
          }
          function G2(u, e, i, n, t) {
            let o = u.tokenPos, l = u.linePos, c = u.colPos;
            switch (u.token) {
              case 86106:
                return T2(u, e, i, n, 1, 0, 0, o, l, c);
              case 133:
              case 86096:
                return Z1(u, e, i, 0, o, l, c);
              case 86092:
                return z1(u, e, i, 16, 0, o, l, c);
              case 241739:
                return Q0(u, e, i, n, o, l, c);
              case 20566:
                f(u, 100, "export");
              case 86108:
                switch (E(u, e), u.token) {
                  case 67174411:
                    return ce(u, e, o, l, c);
                  case 67108877:
                    return fe(u, e, o, l, c);
                  default:
                    f(u, 100, "import");
                }
              case 209007:
                return ue(u, e, i, n, t, 1, o, l, c);
              default:
                return x2(u, e, i, n, t, 1, o, l, c);
            }
          }
          function x2(u, e, i, n, t, o, l, c, s) {
            switch (u.token) {
              case 86090:
                return ie(u, e, i, 0, l, c, s);
              case 20574:
                return j0(u, e, l, c, s);
              case 20571:
                return U0(u, e, i, t, l, c, s);
              case 20569:
                return G0(u, e, i, t, l, c, s);
              case 20564:
                return Z0(u, e, i, t, l, c, s);
              case 20580:
                return X0(u, e, i, t, l, c, s);
              case 86112:
                return J0(u, e, i, t, l, c, s);
              case 1074790417:
                return _0(u, e, l, c, s);
              case 2162700:
                return c1(u, e, i && o2(i, 2), t, l, c, s);
              case 86114:
                return M0(u, e, l, c, s);
              case 20557:
                return H0(u, e, t, l, c, s);
              case 20561:
                return z0(u, e, t, l, c, s);
              case 20579:
                return Y0(u, e, i, t, l, c, s);
              case 20581:
                return K0(u, e, i, t, l, c, s);
              case 20562:
                return W0(u, e, l, c, s);
              case 209007:
                return ue(u, e, i, n, t, 0, l, c, s);
              case 20559:
                f(u, 156);
              case 20568:
                f(u, 157);
              case 86106:
                f(u, e & 1024 ? 73 : (e & 256) < 1 ? 75 : 74);
              case 86096:
                f(u, 76);
              default:
                return V0(u, e, i, n, t, o, l, c, s);
            }
          }
          function V0(u, e, i, n, t, o, l, c, s) {
            let { tokenValue: h, token: b } = u, g;
            switch (b) {
              case 241739:
                g = z2(u, e, 0), e & 1024 && f(u, 82), u.token === 69271571 && f(u, 81);
                break;
              default:
                g = h22(u, e, 2, 0, 1, 0, 0, 1, u.tokenPos, u.linePos, u.colPos);
            }
            return b & 143360 && u.token === 21 ? J1(u, e, i, n, t, h, g, b, o, l, c, s) : (g = W(u, e, g, 0, 0, l, c, s), g = x(u, e, 0, 0, l, c, s, g), u.token === 18 && (g = S2(u, e, 0, l, c, s, g)), H2(u, e, g, l, c, s));
          }
          function c1(u, e, i, n, t, o, l) {
            let c = [];
            for (w(u, e | 32768, 2162700); u.token !== 1074790415; ) c.push(G2(u, e, i, 2, { $: n }));
            return w(u, e | 32768, 1074790415), v(u, e, t, o, l, { type: "BlockStatement", body: c });
          }
          function j0(u, e, i, n, t) {
            (e & 32) < 1 && e & 8192 && f(u, 89), E(u, e | 32768);
            let o = u.flags & 1 || u.token & 1048576 ? null : f2(u, e, 0, 1, u.tokenPos, u.linePos, u.colPos);
            return d2(u, e | 32768), v(u, e, i, n, t, { type: "ReturnStatement", argument: o });
          }
          function H2(u, e, i, n, t, o) {
            return d2(u, e | 32768), v(u, e, n, t, o, { type: "ExpressionStatement", expression: i });
          }
          function J1(u, e, i, n, t, o, l, c, s, h, b, g) {
            o1(u, e, 0, c, 1), S0(u, t, o), E(u, e | 32768);
            let a = s && (e & 1024) < 1 && e & 256 && u.token === 86106 ? T2(u, e, o2(i, 2), n, 0, 0, 0, u.tokenPos, u.linePos, u.colPos) : x2(u, e, i, n, t, s, u.tokenPos, u.linePos, u.colPos);
            return v(u, e, h, b, g, { type: "LabeledStatement", label: l, body: a });
          }
          function ue(u, e, i, n, t, o, l, c, s) {
            let { token: h, tokenValue: b } = u, g = z2(u, e, 0);
            if (u.token === 21) return J1(u, e, i, n, t, b, g, h, 1, l, c, s);
            let a = u.flags & 1;
            if (!a) {
              if (u.token === 86106) return o || f(u, 119), T2(u, e, i, n, 1, 0, 1, l, c, s);
              if ((u.token & 143360) === 143360) return g = ke(u, e, 1, l, c, s), u.token === 18 && (g = S2(u, e, 0, l, c, s, g)), H2(u, e, g, l, c, s);
            }
            return u.token === 67174411 ? g = $1(u, e, g, 1, 1, 0, a, l, c, s) : (u.token === 10 && (M1(u, e, h, 1), g = g1(u, e, u.tokenValue, g, 0, 1, 0, l, c, s)), u.assignable = 1), g = W(u, e, g, 0, 0, l, c, s), u.token === 18 && (g = S2(u, e, 0, l, c, s, g)), g = x(u, e, 0, 0, l, c, s, g), u.assignable = 1, H2(u, e, g, l, c, s);
          }
          function X1(u, e, i, n, t, o, l) {
            return n !== 1074790417 && (u.assignable = 2, i = W(u, e, i, 0, 0, t, o, l), u.token !== 1074790417 && (i = x(u, e, 0, 0, t, o, l, i), u.token === 18 && (i = S2(u, e, 0, t, o, l, i))), d2(u, e | 32768)), e & 8 && i.type === "Literal" && typeof i.value == "string" ? v(u, e, t, o, l, { type: "ExpressionStatement", expression: i, directive: i.raw.slice(1, -1) }) : v(u, e, t, o, l, { type: "ExpressionStatement", expression: i });
          }
          function _0(u, e, i, n, t) {
            return E(u, e | 32768), v(u, e, i, n, t, { type: "EmptyStatement" });
          }
          function M0(u, e, i, n, t) {
            E(u, e | 32768), u.flags & 1 && f(u, 87);
            let o = f2(u, e, 0, 1, u.tokenPos, u.linePos, u.colPos);
            return d2(u, e | 32768), v(u, e, i, n, t, { type: "ThrowStatement", argument: o });
          }
          function U0(u, e, i, n, t, o, l) {
            E(u, e), w(u, e | 32768, 67174411), u.assignable = 1;
            let c = f2(u, e, 0, 1, u.tokenPos, u.line, u.colPos);
            w(u, e | 32768, 16);
            let s = ee(u, e, i, n, u.tokenPos, u.linePos, u.colPos), h = null;
            return u.token === 20565 && (E(u, e | 32768), h = ee(u, e, i, n, u.tokenPos, u.linePos, u.colPos)), v(u, e, t, o, l, { type: "IfStatement", test: c, consequent: s, alternate: h });
          }
          function ee(u, e, i, n, t, o, l) {
            return e & 1024 || (e & 256) < 1 || u.token !== 86106 ? x2(u, e, i, 0, { $: n }, 0, u.tokenPos, u.linePos, u.colPos) : T2(u, e, o2(i, 2), 0, 0, 0, 0, t, o, l);
          }
          function J0(u, e, i, n, t, o, l) {
            E(u, e), w(u, e | 32768, 67174411);
            let c = f2(u, e, 0, 1, u.tokenPos, u.linePos, u.colPos);
            w(u, e, 16), w(u, e, 2162700);
            let s = [], h = 0;
            for (i && (i = o2(i, 8)); u.token !== 1074790415; ) {
              let { tokenPos: b, linePos: g, colPos: a } = u, A = null, C = [];
              for (U(u, e | 32768, 20558) ? A = f2(u, e, 0, 1, u.tokenPos, u.linePos, u.colPos) : (w(u, e | 32768, 20563), h && f(u, 86), h = 1), w(u, e | 32768, 21); u.token !== 20558 && u.token !== 1074790415 && u.token !== 20563; ) C.push(G2(u, e | 4096, i, 2, { $: n }));
              s.push(v(u, e, b, g, a, { type: "SwitchCase", test: A, consequent: C }));
            }
            return w(u, e | 32768, 1074790415), v(u, e, t, o, l, { type: "SwitchStatement", discriminant: c, cases: s });
          }
          function X0(u, e, i, n, t, o, l) {
            E(u, e), w(u, e | 32768, 67174411);
            let c = f2(u, e, 0, 1, u.tokenPos, u.linePos, u.colPos);
            w(u, e | 32768, 16);
            let s = p2(u, e, i, n);
            return v(u, e, t, o, l, { type: "WhileStatement", test: c, body: s });
          }
          function p2(u, e, i, n) {
            return x2(u, (e | 134217728) ^ 134217728 | 131072, i, 0, { loop: 1, $: n }, 0, u.tokenPos, u.linePos, u.colPos);
          }
          function z0(u, e, i, n, t, o) {
            (e & 131072) < 1 && f(u, 65), E(u, e);
            let l = null;
            if ((u.flags & 1) < 1 && u.token & 143360) {
              let { tokenValue: c } = u;
              l = z2(u, e | 32768, 0), xu(u, i, c, 1) || f(u, 134, c);
            }
            return d2(u, e | 32768), v(u, e, n, t, o, { type: "ContinueStatement", label: l });
          }
          function H0(u, e, i, n, t, o) {
            E(u, e | 32768);
            let l = null;
            if ((u.flags & 1) < 1 && u.token & 143360) {
              let { tokenValue: c } = u;
              l = z2(u, e | 32768, 0), xu(u, i, c, 0) || f(u, 134, c);
            } else (e & 135168) < 1 && f(u, 66);
            return d2(u, e | 32768), v(u, e, n, t, o, { type: "BreakStatement", label: l });
          }
          function K0(u, e, i, n, t, o, l) {
            E(u, e), e & 1024 && f(u, 88), w(u, e | 32768, 67174411);
            let c = f2(u, e, 0, 1, u.tokenPos, u.linePos, u.colPos);
            w(u, e | 32768, 16);
            let s = x2(u, e, i, 2, n, 0, u.tokenPos, u.linePos, u.colPos);
            return v(u, e, t, o, l, { type: "WithStatement", object: c, body: s });
          }
          function W0(u, e, i, n, t) {
            return E(u, e | 32768), d2(u, e | 32768), v(u, e, i, n, t, { type: "DebuggerStatement" });
          }
          function Y0(u, e, i, n, t, o, l) {
            E(u, e | 32768);
            let c = i ? o2(i, 32) : void 0, s = c1(u, e, c, { $: n }, u.tokenPos, u.linePos, u.colPos), { tokenPos: h, linePos: b, colPos: g } = u, a = U(u, e | 32768, 20559) ? $0(u, e, i, n, h, b, g) : null, A = null;
            if (u.token === 20568) {
              E(u, e | 32768);
              let C = c ? o2(i, 4) : void 0;
              A = c1(u, e, C, { $: n }, u.tokenPos, u.linePos, u.colPos);
            }
            return !a && !A && f(u, 85), v(u, e, t, o, l, { type: "TryStatement", block: s, handler: a, finalizer: A });
          }
          function $0(u, e, i, n, t, o, l) {
            let c = null, s = i;
            U(u, e, 67174411) && (i && (i = o2(i, 4)), c = Ae(u, e, i, (u.token & 2097152) === 2097152 ? 256 : 512, 0, u.tokenPos, u.linePos, u.colPos), u.token === 18 ? f(u, 83) : u.token === 1077936157 && f(u, 84), w(u, e | 32768, 16), i && (s = o2(i, 64)));
            let h = c1(u, e, s, { $: n }, u.tokenPos, u.linePos, u.colPos);
            return v(u, e, t, o, l, { type: "CatchClause", param: c, body: h });
          }
          function Z0(u, e, i, n, t, o, l) {
            E(u, e | 32768);
            let c = p2(u, e, i, n);
            w(u, e, 20580), w(u, e | 32768, 67174411);
            let s = f2(u, e, 0, 1, u.tokenPos, u.linePos, u.colPos);
            return w(u, e | 32768, 16), U(u, e, 1074790417), v(u, e, t, o, l, { type: "DoWhileStatement", body: c, test: s });
          }
          function Q0(u, e, i, n, t, o, l) {
            let { token: c, tokenValue: s } = u, h = z2(u, e, 0);
            if (u.token & 2240512) {
              let b = K2(u, e, i, 8, 0);
              return d2(u, e | 32768), v(u, e, t, o, l, { type: "VariableDeclaration", kind: "let", declarations: b });
            }
            if (u.assignable = 1, e & 1024 && f(u, 82), u.token === 21) return J1(u, e, i, n, {}, s, h, c, 0, t, o, l);
            if (u.token === 10) {
              let b;
              e & 64 && (b = f1(u, e, s)), u.flags = (u.flags | 128) ^ 128, h = u1(u, e, b, [h], 0, t, o, l);
            } else h = W(u, e, h, 0, 0, t, o, l), h = x(u, e, 0, 0, t, o, l, h);
            return u.token === 18 && (h = S2(u, e, 0, t, o, l, h)), H2(u, e, h, t, o, l);
          }
          function z1(u, e, i, n, t, o, l, c) {
            E(u, e);
            let s = K2(u, e, i, n, t);
            return d2(u, e | 32768), v(u, e, o, l, c, { type: "VariableDeclaration", kind: n & 8 ? "let" : "const", declarations: s });
          }
          function ie(u, e, i, n, t, o, l) {
            E(u, e);
            let c = K2(u, e, i, 4, n);
            return d2(u, e | 32768), v(u, e, t, o, l, { type: "VariableDeclaration", kind: "var", declarations: c });
          }
          function K2(u, e, i, n, t) {
            let o = 1, l = [ne(u, e, i, n, t)];
            for (; U(u, e, 18); ) o++, l.push(ne(u, e, i, n, t));
            return o > 1 && t & 32 && u.token & 262144 && f(u, 58, G[u.token & 255]), l;
          }
          function ne(u, e, i, n, t) {
            let { token: o, tokenPos: l, linePos: c, colPos: s } = u, h = null, b = Ae(u, e, i, n, t, l, c, s);
            return u.token === 1077936157 ? (E(u, e | 32768), h = Q(u, e, 1, 0, 0, u.tokenPos, u.linePos, u.colPos), (t & 32 || (o & 2097152) < 1) && (u.token === 274549 || u.token === 8738868 && (o & 2097152 || (n & 4) < 1 || e & 1024)) && S(l, u.line, u.index - 3, 57, u.token === 274549 ? "of" : "in")) : (n & 16 || (o & 2097152) > 0) && (u.token & 262144) !== 262144 && f(u, 56, n & 16 ? "const" : "destructuring"), v(u, e, l, c, s, { type: "VariableDeclarator", id: b, init: h });
          }
          function G0(u, e, i, n, t, o, l) {
            E(u, e);
            let c = (e & 4194304) > 0 && U(u, e, 209008);
            w(u, e | 32768, 67174411), i && (i = o2(i, 1));
            let s = null, h = null, b = 0, g = null, a = u.token === 86090 || u.token === 241739 || u.token === 86092, A, { token: C, tokenPos: D, linePos: B, colPos: O } = u;
            if (a ? C === 241739 ? (g = z2(u, e, 0), u.token & 2240512 ? (u.token === 8738868 ? e & 1024 && f(u, 64) : g = v(u, e, D, B, O, { type: "VariableDeclaration", kind: "let", declarations: K2(u, e | 134217728, i, 8, 32) }), u.assignable = 1) : e & 1024 ? f(u, 64) : (a = false, u.assignable = 1, g = W(u, e, g, 0, 0, D, B, O), u.token === 274549 && f(u, 111))) : (E(u, e), g = v(u, e, D, B, O, C === 86090 ? { type: "VariableDeclaration", kind: "var", declarations: K2(u, e | 134217728, i, 4, 32) } : { type: "VariableDeclaration", kind: "const", declarations: K2(u, e | 134217728, i, 16, 32) }), u.assignable = 1) : C === 1074790417 ? c && f(u, 79) : (C & 2097152) === 2097152 ? (g = C === 2162700 ? r2(u, e, void 0, 1, 0, 0, 2, 32, D, B, O) : k2(u, e, void 0, 1, 0, 0, 2, 32, D, B, O), b = u.destructible, e & 256 && b & 64 && f(u, 60), u.assignable = b & 16 ? 2 : 1, g = W(u, e | 134217728, g, 0, 0, u.tokenPos, u.linePos, u.colPos)) : g = b2(u, e | 134217728, 1, 0, 1, D, B, O), (u.token & 262144) === 262144) {
              if (u.token === 274549) {
                u.assignable & 2 && f(u, 77, c ? "await" : "of"), v2(u, g), E(u, e | 32768), A = Q(u, e, 1, 0, 0, u.tokenPos, u.linePos, u.colPos), w(u, e | 32768, 16);
                let R = p2(u, e, i, n);
                return v(u, e, t, o, l, { type: "ForOfStatement", left: g, right: A, body: R, await: c });
              }
              u.assignable & 2 && f(u, 77, "in"), v2(u, g), E(u, e | 32768), c && f(u, 79), A = f2(u, e, 0, 1, u.tokenPos, u.linePos, u.colPos), w(u, e | 32768, 16);
              let e2 = p2(u, e, i, n);
              return v(u, e, t, o, l, { type: "ForInStatement", body: e2, left: g, right: A });
            }
            c && f(u, 79), a || (b & 8 && u.token !== 1077936157 && f(u, 77, "loop"), g = x(u, e | 134217728, 0, 0, D, B, O, g)), u.token === 18 && (g = S2(u, e, 0, u.tokenPos, u.linePos, u.colPos, g)), w(u, e | 32768, 1074790417), u.token !== 1074790417 && (s = f2(u, e, 0, 1, u.tokenPos, u.linePos, u.colPos)), w(u, e | 32768, 1074790417), u.token !== 16 && (h = f2(u, e, 0, 1, u.tokenPos, u.linePos, u.colPos)), w(u, e | 32768, 16);
            let j = p2(u, e, i, n);
            return v(u, e, t, o, l, { type: "ForStatement", init: g, test: s, update: h, body: j });
          }
          function te(u, e, i) {
            return _1(e, u.token) || f(u, 114), (u.token & 537079808) === 537079808 && f(u, 115), i && B2(u, e, i, u.tokenValue, 8, 0), z2(u, e, 0);
          }
          function x0(u, e, i) {
            let n = u.tokenPos, t = u.linePos, o = u.colPos;
            E(u, e);
            let l = null, { tokenPos: c, linePos: s, colPos: h } = u, b = [];
            if (u.token === 134283267) l = a2(u, e);
            else {
              if (u.token & 143360) {
                let g = te(u, e, i);
                if (b = [v(u, e, c, s, h, { type: "ImportDefaultSpecifier", local: g })], U(u, e, 18)) switch (u.token) {
                  case 8457014:
                    b.push(oe(u, e, i));
                    break;
                  case 2162700:
                    le(u, e, i, b);
                    break;
                  default:
                    f(u, 104);
                }
              } else switch (u.token) {
                case 8457014:
                  b = [oe(u, e, i)];
                  break;
                case 2162700:
                  le(u, e, i, b);
                  break;
                case 67174411:
                  return ce(u, e, n, t, o);
                case 67108877:
                  return fe(u, e, n, t, o);
                default:
                  f(u, 28, G[u.token & 255]);
              }
              l = p0(u, e);
            }
            return d2(u, e | 32768), v(u, e, n, t, o, { type: "ImportDeclaration", specifiers: b, source: l });
          }
          function oe(u, e, i) {
            let { tokenPos: n, linePos: t, colPos: o } = u;
            return E(u, e), w(u, e, 77934), (u.token & 134217728) === 134217728 && S(n, u.line, u.index, 28, G[u.token & 255]), v(u, e, n, t, o, { type: "ImportNamespaceSpecifier", local: te(u, e, i) });
          }
          function p0(u, e) {
            return U(u, e, 12404), u.token !== 134283267 && f(u, 102, "Import"), a2(u, e);
          }
          function le(u, e, i, n) {
            for (E(u, e); u.token & 143360; ) {
              let { token: t, tokenValue: o, tokenPos: l, linePos: c, colPos: s } = u, h = z2(u, e, 0), b;
              U(u, e, 77934) ? ((u.token & 134217728) === 134217728 || u.token === 18 ? f(u, 103) : o1(u, e, 16, u.token, 0), o = u.tokenValue, b = z2(u, e, 0)) : (o1(u, e, 16, t, 0), b = h), i && B2(u, e, i, o, 8, 0), n.push(v(u, e, l, c, s, { type: "ImportSpecifier", local: b, imported: h })), u.token !== 1074790415 && w(u, e, 18);
            }
            return w(u, e, 1074790415), n;
          }
          function fe(u, e, i, n, t) {
            let o = ae(u, e, v(u, e, i, n, t, { type: "Identifier", name: "import" }), i, n, t);
            return o = W(u, e, o, 0, 0, i, n, t), o = x(u, e, 0, 0, i, n, t, o), H2(u, e, o, i, n, t);
          }
          function ce(u, e, i, n, t) {
            let o = de(u, e, 0, i, n, t);
            return o = W(u, e, o, 0, 0, i, n, t), H2(u, e, o, i, n, t);
          }
          function ut(u, e, i) {
            let n = u.tokenPos, t = u.linePos, o = u.colPos;
            E(u, e | 32768);
            let l = [], c = null, s = null, h;
            if (U(u, e | 32768, 20563)) {
              switch (u.token) {
                case 86106: {
                  c = T2(u, e, i, 4, 1, 1, 0, u.tokenPos, u.linePos, u.colPos);
                  break;
                }
                case 133:
                case 86096:
                  c = Z1(u, e, i, 1, u.tokenPos, u.linePos, u.colPos);
                  break;
                case 209007:
                  let { tokenPos: b, linePos: g, colPos: a } = u;
                  c = z2(u, e, 0);
                  let { flags: A } = u;
                  (A & 1) < 1 && (u.token === 86106 ? c = T2(u, e, i, 4, 1, 1, 1, b, g, a) : u.token === 67174411 ? (c = $1(u, e, c, 1, 1, 0, A, b, g, a), c = W(u, e, c, 0, 0, b, g, a), c = x(u, e, 0, 0, b, g, a, c)) : u.token & 143360 && (i && (i = f1(u, e, u.tokenValue)), c = z2(u, e, 0), c = u1(u, e, i, [c], 1, b, g, a)));
                  break;
                default:
                  c = Q(u, e, 1, 0, 0, u.tokenPos, u.linePos, u.colPos), d2(u, e | 32768);
              }
              return i && _2(u, "default"), v(u, e, n, t, o, { type: "ExportDefaultDeclaration", declaration: c });
            }
            switch (u.token) {
              case 8457014: {
                E(u, e);
                let A = null;
                return U(u, e, 77934) && (i && _2(u, u.tokenValue), A = z2(u, e, 0)), w(u, e, 12404), u.token !== 134283267 && f(u, 102, "Export"), s = a2(u, e), d2(u, e | 32768), v(u, e, n, t, o, { type: "ExportAllDeclaration", source: s, exported: A });
              }
              case 2162700: {
                E(u, e);
                let A = [], C = [];
                for (; u.token & 143360; ) {
                  let { tokenPos: D, tokenValue: B, linePos: O, colPos: j } = u, e2 = z2(u, e, 0), R;
                  u.token === 77934 ? (E(u, e), (u.token & 134217728) === 134217728 && f(u, 103), i && (A.push(u.tokenValue), C.push(B)), R = z2(u, e, 0)) : (i && (A.push(u.tokenValue), C.push(u.tokenValue)), R = e2), l.push(v(u, e, D, O, j, { type: "ExportSpecifier", local: e2, exported: R })), u.token !== 1074790415 && w(u, e, 18);
                }
                if (w(u, e, 1074790415), U(u, e, 12404)) u.token !== 134283267 && f(u, 102, "Export"), s = a2(u, e);
                else if (i) {
                  let D = 0, B = A.length;
                  for (; D < B; D++) _2(u, A[D]);
                  for (D = 0, B = C.length; D < B; D++) F0(u, C[D]);
                }
                d2(u, e | 32768);
                break;
              }
              case 86096:
                c = Z1(u, e, i, 2, u.tokenPos, u.linePos, u.colPos);
                break;
              case 86106:
                c = T2(u, e, i, 4, 1, 2, 0, u.tokenPos, u.linePos, u.colPos);
                break;
              case 241739:
                c = z1(u, e, i, 8, 64, u.tokenPos, u.linePos, u.colPos);
                break;
              case 86092:
                c = z1(u, e, i, 16, 64, u.tokenPos, u.linePos, u.colPos);
                break;
              case 86090:
                c = ie(u, e, i, 64, u.tokenPos, u.linePos, u.colPos);
                break;
              case 209007:
                let { tokenPos: b, linePos: g, colPos: a } = u;
                if (E(u, e), (u.flags & 1) < 1 && u.token === 86106) {
                  c = T2(u, e, i, 4, 1, 2, 1, b, g, a), i && (h = c.id ? c.id.name : "", _2(u, h));
                  break;
                }
              default:
                f(u, 28, G[u.token & 255]);
            }
            return v(u, e, n, t, o, { type: "ExportNamedDeclaration", declaration: c, specifiers: l, source: s });
          }
          function Q(u, e, i, n, t, o, l, c) {
            let s = h22(u, e, 2, 0, i, n, t, 1, o, l, c);
            return s = W(u, e, s, t, 0, o, l, c), x(u, e, t, 0, o, l, c, s);
          }
          function S2(u, e, i, n, t, o, l) {
            let c = [l];
            for (; U(u, e | 32768, 18); ) c.push(Q(u, e, 1, 0, i, u.tokenPos, u.linePos, u.colPos));
            return v(u, e, n, t, o, { type: "SequenceExpression", expressions: c });
          }
          function f2(u, e, i, n, t, o, l) {
            let c = Q(u, e, n, 0, i, t, o, l);
            return u.token === 18 ? S2(u, e, i, t, o, l, c) : c;
          }
          function x(u, e, i, n, t, o, l, c) {
            let { token: s } = u;
            if ((s & 4194304) === 4194304) {
              u.assignable & 2 && f(u, 24), (!n && s === 1077936157 && c.type === "ArrayExpression" || c.type === "ObjectExpression") && v2(u, c), E(u, e | 32768);
              let h = Q(u, e, 1, 1, i, u.tokenPos, u.linePos, u.colPos);
              return u.assignable = 2, v(u, e, t, o, l, n ? { type: "AssignmentPattern", left: c, right: h } : { type: "AssignmentExpression", left: c, operator: G[s & 255], right: h });
            }
            return (s & 8454144) === 8454144 && (c = F2(u, e, i, t, o, l, 4, s, c)), U(u, e | 32768, 22) && (c = M2(u, e, c, t, o, l)), c;
          }
          function s1(u, e, i, n, t, o, l, c) {
            let { token: s } = u;
            E(u, e | 32768);
            let h = Q(u, e, 1, 1, i, u.tokenPos, u.linePos, u.colPos);
            return c = v(u, e, t, o, l, n ? { type: "AssignmentPattern", left: c, right: h } : { type: "AssignmentExpression", left: c, operator: G[s & 255], right: h }), u.assignable = 2, c;
          }
          function M2(u, e, i, n, t, o) {
            let l = Q(u, (e | 134217728) ^ 134217728, 1, 0, 0, u.tokenPos, u.linePos, u.colPos);
            w(u, e | 32768, 21), u.assignable = 1;
            let c = Q(u, e, 1, 0, 0, u.tokenPos, u.linePos, u.colPos);
            return u.assignable = 2, v(u, e, n, t, o, { type: "ConditionalExpression", test: i, consequent: l, alternate: c });
          }
          function F2(u, e, i, n, t, o, l, c, s) {
            let h = -((e & 134217728) > 0) & 8738868, b, g;
            for (u.assignable = 2; u.token & 8454144 && (b = u.token, g = b & 3840, (b & 524288 && c & 268435456 || c & 524288 && b & 268435456) && f(u, 159), !(g + ((b === 8457273) << 8) - ((h === b) << 12) <= l)); ) E(u, e | 32768), s = v(u, e, n, t, o, { type: b & 524288 || b & 268435456 ? "LogicalExpression" : "BinaryExpression", left: s, right: F2(u, e, i, u.tokenPos, u.linePos, u.colPos, g, b, b2(u, e, 0, i, 1, u.tokenPos, u.linePos, u.colPos)), operator: G[b & 255] });
            return u.token === 1077936157 && f(u, 24), s;
          }
          function et(u, e, i, n, t, o, l) {
            i || f(u, 0);
            let c = u.token;
            E(u, e | 32768);
            let s = b2(u, e, 0, l, 1, u.tokenPos, u.linePos, u.colPos);
            return u.token === 8457273 && f(u, 31), e & 1024 && c === 16863278 && (s.type === "Identifier" ? f(u, 117) : B0(s) && f(u, 123)), u.assignable = 2, v(u, e, n, t, o, { type: "UnaryExpression", operator: G[c & 255], argument: s, prefix: true });
          }
          function it(u, e, i, n, t, o, l, c, s, h) {
            let { token: b } = u, g = z2(u, e, o), { flags: a } = u;
            if ((a & 1) < 1) {
              if (u.token === 86106) return he(u, e, 1, i, c, s, h);
              if ((u.token & 143360) === 143360) return n || f(u, 0), ke(u, e, t, c, s, h);
            }
            return !l && u.token === 67174411 ? $1(u, e, g, t, 1, 0, a, c, s, h) : u.token === 10 ? (M1(u, e, b, 1), l && f(u, 48), g1(u, e, u.tokenValue, g, l, t, 0, c, s, h)) : g;
          }
          function nt(u, e, i, n, t, o, l) {
            if (i && (u.destructible |= 256), e & 2097152) {
              E(u, e | 32768), e & 8388608 && f(u, 30), n || f(u, 24), u.token === 22 && f(u, 120);
              let c = null, s = false;
              return (u.flags & 1) < 1 && (s = U(u, e | 32768, 8457014), (u.token & 77824 || s) && (c = Q(u, e, 1, 0, 0, u.tokenPos, u.linePos, u.colPos))), u.assignable = 2, v(u, e, t, o, l, { type: "YieldExpression", argument: c, delegate: s });
            }
            return e & 1024 && f(u, 94, "yield"), Y1(u, e, t, o, l);
          }
          function tt(u, e, i, n, t, o, l) {
            if (n && (u.destructible |= 128), e & 4194304 || e & 2048 && e & 8192) {
              i && f(u, 0), e & 8388608 && S(u.index, u.line, u.index, 29), E(u, e | 32768);
              let c = b2(u, e, 0, 0, 1, u.tokenPos, u.linePos, u.colPos);
              return u.token === 8457273 && f(u, 31), u.assignable = 2, v(u, e, t, o, l, { type: "AwaitExpression", argument: c });
            }
            return e & 2048 && f(u, 95), Y1(u, e, t, o, l);
          }
          function a1(u, e, i, n, t, o) {
            let { tokenPos: l, linePos: c, colPos: s } = u;
            w(u, e | 32768, 2162700);
            let h = [], b = e;
            if (u.token !== 1074790415) {
              for (; u.token === 134283267; ) {
                let { index: g, tokenPos: a, tokenValue: A, token: C } = u, D = a2(u, e);
                Zu(u, g, a, A) && (e |= 1024, u.flags & 128 && S(u.index, u.line, u.tokenPos, 63), u.flags & 64 && S(u.index, u.line, u.tokenPos, 8)), h.push(X1(u, e, D, C, a, u.linePos, u.colPos));
              }
              e & 1024 && (t && ((t & 537079808) === 537079808 && f(u, 115), (t & 36864) === 36864 && f(u, 38)), u.flags & 512 && f(u, 115), u.flags & 256 && f(u, 114)), e & 64 && i && o !== void 0 && (b & 1024) < 1 && (e & 8192) < 1 && P(o);
            }
            for (u.flags = (u.flags | 512 | 256 | 64) ^ 832, u.destructible = (u.destructible | 256) ^ 256; u.token !== 1074790415; ) h.push(G2(u, e, i, 4, {}));
            return w(u, n & 24 ? e | 32768 : e, 1074790415), u.flags &= -193, u.token === 1077936157 && f(u, 24), v(u, e, l, c, s, { type: "BlockStatement", body: h });
          }
          function ot(u, e, i, n, t) {
            switch (E(u, e), u.token) {
              case 67108991:
                f(u, 161);
              case 67174411: {
                (e & 524288) < 1 && f(u, 26), e & 16384 && f(u, 27), u.assignable = 2;
                break;
              }
              case 69271571:
              case 67108877: {
                (e & 262144) < 1 && f(u, 27), e & 16384 && f(u, 27), u.assignable = 1;
                break;
              }
              default:
                f(u, 28, "super");
            }
            return v(u, e, i, n, t, { type: "Super" });
          }
          function b2(u, e, i, n, t, o, l, c) {
            let s = h22(u, e, 2, 0, i, 0, n, t, o, l, c);
            return W(u, e, s, n, 0, o, l, c);
          }
          function lt(u, e, i, n, t, o) {
            u.assignable & 2 && f(u, 52);
            let { token: l } = u;
            return E(u, e), u.assignable = 2, v(u, e, n, t, o, { type: "UpdateExpression", argument: i, operator: G[l & 255], prefix: false });
          }
          function W(u, e, i, n, t, o, l, c) {
            if ((u.token & 33619968) === 33619968 && (u.flags & 1) < 1) i = lt(u, e, i, o, l, c);
            else if ((u.token & 67108864) === 67108864) {
              switch (e = (e | 134217728) ^ 134217728, u.token) {
                case 67108877: {
                  E(u, (e | 1073741824 | 8192) ^ 8192), u.assignable = 1;
                  let s = se(u, e);
                  i = v(u, e, o, l, c, { type: "MemberExpression", object: i, computed: false, property: s });
                  break;
                }
                case 69271571: {
                  let s = false;
                  (u.flags & 2048) === 2048 && (s = true, u.flags = (u.flags | 2048) ^ 2048), E(u, e | 32768);
                  let { tokenPos: h, linePos: b, colPos: g } = u, a = f2(u, e, n, 1, h, b, g);
                  w(u, e, 20), u.assignable = 1, i = v(u, e, o, l, c, { type: "MemberExpression", object: i, computed: true, property: a }), s && (u.flags |= 2048);
                  break;
                }
                case 67174411: {
                  if ((u.flags & 1024) === 1024) return u.flags = (u.flags | 1024) ^ 1024, i;
                  let s = false;
                  (u.flags & 2048) === 2048 && (s = true, u.flags = (u.flags | 2048) ^ 2048);
                  let h = W1(u, e, n);
                  u.assignable = 2, i = v(u, e, o, l, c, { type: "CallExpression", callee: i, arguments: h }), s && (u.flags |= 2048);
                  break;
                }
                case 67108991: {
                  E(u, (e | 1073741824 | 8192) ^ 8192), u.flags |= 2048, u.assignable = 2, i = ft(u, e, i, o, l, c);
                  break;
                }
                default:
                  (u.flags & 2048) === 2048 && f(u, 160), u.assignable = 2, i = v(u, e, o, l, c, { type: "TaggedTemplateExpression", tag: i, quasi: u.token === 67174408 ? K1(u, e | 65536) : H1(u, e, u.tokenPos, u.linePos, u.colPos) });
              }
              i = W(u, e, i, 0, 1, o, l, c);
            }
            return t === 0 && (u.flags & 2048) === 2048 && (u.flags = (u.flags | 2048) ^ 2048, i = v(u, e, o, l, c, { type: "ChainExpression", expression: i })), i;
          }
          function ft(u, e, i, n, t, o) {
            let l = false, c;
            if ((u.token === 69271571 || u.token === 67174411) && (u.flags & 2048) === 2048 && (l = true, u.flags = (u.flags | 2048) ^ 2048), u.token === 69271571) {
              E(u, e | 32768);
              let { tokenPos: s, linePos: h, colPos: b } = u, g = f2(u, e, 0, 1, s, h, b);
              w(u, e, 20), u.assignable = 2, c = v(u, e, n, t, o, { type: "MemberExpression", object: i, computed: true, optional: true, property: g });
            } else if (u.token === 67174411) {
              let s = W1(u, e, 0);
              u.assignable = 2, c = v(u, e, n, t, o, { type: "CallExpression", callee: i, arguments: s, optional: true });
            } else {
              (u.token & 143360) < 1 && f(u, 154);
              let s = z2(u, e, 0);
              u.assignable = 2, c = v(u, e, n, t, o, { type: "MemberExpression", object: i, computed: false, optional: true, property: s });
            }
            return l && (u.flags |= 2048), c;
          }
          function se(u, e) {
            return (u.token & 143360) < 1 && u.token !== 131 && f(u, 154), e & 1 && u.token === 131 ? k1(u, e, u.tokenPos, u.linePos, u.colPos) : z2(u, e, 0);
          }
          function ct(u, e, i, n, t, o, l) {
            i && f(u, 53), n || f(u, 0);
            let { token: c } = u;
            E(u, e | 32768);
            let s = b2(u, e, 0, 0, 1, u.tokenPos, u.linePos, u.colPos);
            return u.assignable & 2 && f(u, 52), u.assignable = 2, v(u, e, t, o, l, { type: "UpdateExpression", argument: s, operator: G[c & 255], prefix: true });
          }
          function h22(u, e, i, n, t, o, l, c, s, h, b) {
            if ((u.token & 143360) === 143360) {
              switch (u.token) {
                case 209008:
                  return tt(u, e, n, l, s, h, b);
                case 241773:
                  return nt(u, e, l, t, s, h, b);
                case 209007:
                  return it(u, e, l, c, t, o, n, s, h, b);
              }
              let { token: g, tokenValue: a } = u, A = z2(u, e | 65536, o);
              return u.token === 10 ? (c || f(u, 0), M1(u, e, g, 1), g1(u, e, a, A, n, t, 0, s, h, b)) : (e & 16384 && g === 537079928 && f(u, 126), g === 241739 && (e & 1024 && f(u, 109), i & 24 && f(u, 97)), u.assignable = e & 1024 && (g & 537079808) === 537079808 ? 2 : 1, A);
            }
            if ((u.token & 134217728) === 134217728) return a2(u, e);
            switch (u.token) {
              case 33619995:
              case 33619996:
                return ct(u, e, n, c, s, h, b);
              case 16863278:
              case 16842800:
              case 16842801:
              case 25233970:
              case 25233971:
              case 16863277:
              case 16863279:
                return et(u, e, c, s, h, b, l);
              case 86106:
                return he(u, e, 0, l, s, h, b);
              case 2162700:
                return mt(u, e, t ? 0 : 1, l, s, h, b);
              case 69271571:
                return ht(u, e, t ? 0 : 1, l, s, h, b);
              case 67174411:
                return kt(u, e, t, 1, 0, s, h, b);
              case 86021:
              case 86022:
              case 86023:
                return dt(u, e, s, h, b);
              case 86113:
                return gt(u, e);
              case 65540:
                return At(u, e, s, h, b);
              case 133:
              case 86096:
                return yt(u, e, l, s, h, b);
              case 86111:
                return ot(u, e, s, h, b);
              case 67174409:
                return H1(u, e, s, h, b);
              case 67174408:
                return K1(u, e);
              case 86109:
                return rt(u, e, l, s, h, b);
              case 134283389:
                return ge(u, e, s, h, b);
              case 131:
                return k1(u, e, s, h, b);
              case 86108:
                return st(u, e, n, l, s, h, b);
              case 8456258:
                if (e & 16) return G1(u, e, 1, s, h, b);
              default:
                if (_1(e, u.token)) return Y1(u, e, s, h, b);
                f(u, 28, G[u.token & 255]);
            }
          }
          function st(u, e, i, n, t, o, l) {
            let c = z2(u, e, 0);
            return u.token === 67108877 ? ae(u, e, c, t, o, l) : (i && f(u, 137), c = de(u, e, n, t, o, l), u.assignable = 2, W(u, e, c, n, 0, t, o, l));
          }
          function ae(u, e, i, n, t, o) {
            return (e & 2048) === 0 && f(u, 163), E(u, e), u.token !== 143495 && u.tokenValue !== "meta" && f(u, 28, G[u.token & 255]), u.assignable = 2, v(u, e, n, t, o, { type: "MetaProperty", meta: i, property: z2(u, e, 0) });
          }
          function de(u, e, i, n, t, o) {
            w(u, e | 32768, 67174411), u.token === 14 && f(u, 138);
            let l = Q(u, e, 1, 0, i, u.tokenPos, u.linePos, u.colPos);
            return w(u, e, 16), v(u, e, n, t, o, { type: "ImportExpression", source: l });
          }
          function ge(u, e, i, n, t) {
            let { tokenRaw: o, tokenValue: l } = u;
            return E(u, e), u.assignable = 2, v(u, e, i, n, t, e & 512 ? { type: "Literal", value: l, bigint: o.slice(0, -1), raw: o } : { type: "Literal", value: l, bigint: o.slice(0, -1) });
          }
          function H1(u, e, i, n, t) {
            u.assignable = 2;
            let { tokenValue: o, tokenRaw: l, tokenPos: c, linePos: s, colPos: h } = u;
            w(u, e, 67174409);
            let b = [d1(u, e, o, l, c, s, h, true)];
            return v(u, e, i, n, t, { type: "TemplateLiteral", expressions: [], quasis: b });
          }
          function K1(u, e) {
            e = (e | 134217728) ^ 134217728;
            let { tokenValue: i, tokenRaw: n, tokenPos: t, linePos: o, colPos: l } = u;
            w(u, e | 32768, 67174408);
            let c = [d1(u, e, i, n, t, o, l, false)], s = [f2(u, e, 0, 1, u.tokenPos, u.linePos, u.colPos)];
            for (u.token !== 1074790415 && f(u, 80); (u.token = v0(u, e)) !== 67174409; ) {
              let { tokenValue: h, tokenRaw: b, tokenPos: g, linePos: a, colPos: A } = u;
              w(u, e | 32768, 67174408), c.push(d1(u, e, h, b, g, a, A, false)), s.push(f2(u, e, 0, 1, u.tokenPos, u.linePos, u.colPos)), u.token !== 1074790415 && f(u, 80);
            }
            {
              let { tokenValue: h, tokenRaw: b, tokenPos: g, linePos: a, colPos: A } = u;
              w(u, e, 67174409), c.push(d1(u, e, h, b, g, a, A, true));
            }
            return v(u, e, t, o, l, { type: "TemplateLiteral", expressions: s, quasis: c });
          }
          function d1(u, e, i, n, t, o, l, c) {
            let s = v(u, e, t, o, l, { type: "TemplateElement", value: { cooked: i, raw: n }, tail: c }), h = c ? 1 : 2;
            return e & 2 && (s.start += 1, s.range[0] += 1, s.end -= h, s.range[1] -= h), e & 4 && (s.loc.start.column += 1, s.loc.end.column -= h), s;
          }
          function at(u, e, i, n, t) {
            e = (e | 134217728) ^ 134217728, w(u, e | 32768, 14);
            let o = Q(u, e, 1, 0, 0, u.tokenPos, u.linePos, u.colPos);
            return u.assignable = 1, v(u, e, i, n, t, { type: "SpreadElement", argument: o });
          }
          function W1(u, e, i) {
            E(u, e | 32768);
            let n = [];
            if (u.token === 16) return E(u, e), n;
            for (; u.token !== 16 && (u.token === 14 ? n.push(at(u, e, u.tokenPos, u.linePos, u.colPos)) : n.push(Q(u, e, 1, 0, i, u.tokenPos, u.linePos, u.colPos)), !(u.token !== 18 || (E(u, e | 32768), u.token === 16))); ) ;
            return w(u, e, 16), n;
          }
          function z2(u, e, i) {
            let { tokenValue: n, tokenPos: t, linePos: o, colPos: l } = u;
            return E(u, e), v(u, e, t, o, l, e & 268435456 ? { type: "Identifier", name: n, pattern: i === 1 } : { type: "Identifier", name: n });
          }
          function a2(u, e) {
            let { tokenValue: i, tokenRaw: n, tokenPos: t, linePos: o, colPos: l } = u;
            return u.token === 134283389 ? ge(u, e, t, o, l) : (E(u, e), u.assignable = 2, v(u, e, t, o, l, e & 512 ? { type: "Literal", value: i, raw: n } : { type: "Literal", value: i }));
          }
          function dt(u, e, i, n, t) {
            let o = G[u.token & 255], l = u.token === 86023 ? null : o === "true";
            return E(u, e), u.assignable = 2, v(u, e, i, n, t, e & 512 ? { type: "Literal", value: l, raw: o } : { type: "Literal", value: l });
          }
          function gt(u, e) {
            let { tokenPos: i, linePos: n, colPos: t } = u;
            return E(u, e), u.assignable = 2, v(u, e, i, n, t, { type: "ThisExpression" });
          }
          function T2(u, e, i, n, t, o, l, c, s, h) {
            E(u, e | 32768);
            let b = t ? V1(u, e, 8457014) : 0, g = null, a, A = i ? j2() : void 0;
            if (u.token === 67174411) (o & 1) < 1 && f(u, 37, "Function");
            else {
              let B = n & 4 && ((e & 8192) < 1 || (e & 2048) < 1) ? 4 : 64;
              Qu(u, e | (e & 3072) << 11, u.token), i && (B & 4 ? pu(u, e, i, u.tokenValue, B) : B2(u, e, i, u.tokenValue, B, n), A = o2(A, 256), o && o & 2 && _2(u, u.tokenValue)), a = u.token, u.token & 143360 ? g = z2(u, e, 0) : f(u, 28, G[u.token & 255]);
            }
            e = (e | 32243712) ^ 32243712 | 67108864 | l * 2 + b << 21 | (b ? 0 : 1073741824), i && (A = o2(A, 512));
            let C = be(u, e | 8388608, A, 0, 1), D = a1(u, (e | 8192 | 4096 | 131072) ^ 143360, i ? o2(A, 128) : A, 8, a, i ? A.scopeError : void 0);
            return v(u, e, c, s, h, { type: "FunctionDeclaration", id: g, params: C, body: D, async: l === 1, generator: b === 1 });
          }
          function he(u, e, i, n, t, o, l) {
            E(u, e | 32768);
            let c = V1(u, e, 8457014), s = i * 2 + c << 21, h = null, b, g = e & 64 ? j2() : void 0;
            (u.token & 176128) > 0 && (Qu(u, (e | 32243712) ^ 32243712 | s, u.token), g && (g = o2(g, 256)), b = u.token, h = z2(u, e, 0)), e = (e | 32243712) ^ 32243712 | 67108864 | s | (c ? 0 : 1073741824), g && (g = o2(g, 512));
            let a = be(u, e | 8388608, g, n, 1), A = a1(u, e & -134377473, g && o2(g, 128), 0, b, void 0);
            return u.assignable = 2, v(u, e, t, o, l, { type: "FunctionExpression", id: h, params: a, body: A, async: i === 1, generator: c === 1 });
          }
          function ht(u, e, i, n, t, o, l) {
            let c = k2(u, e, void 0, i, n, 0, 2, 0, t, o, l);
            return e & 256 && u.destructible & 64 && f(u, 60), u.destructible & 8 && f(u, 59), c;
          }
          function k2(u, e, i, n, t, o, l, c, s, h, b) {
            E(u, e | 32768);
            let g = [], a = 0;
            for (e = (e | 134217728) ^ 134217728; u.token !== 20; ) if (U(u, e | 32768, 18)) g.push(null);
            else {
              let C, { token: D, tokenPos: B, linePos: O, colPos: j, tokenValue: e2 } = u;
              if (D & 143360) if (C = h22(u, e, l, 0, 1, 0, t, 1, B, O, j), u.token === 1077936157) {
                u.assignable & 2 && f(u, 24), E(u, e | 32768), i && q2(u, e, i, e2, l, c);
                let R = Q(u, e, 1, 1, t, u.tokenPos, u.linePos, u.colPos);
                C = v(u, e, B, O, j, o ? { type: "AssignmentPattern", left: C, right: R } : { type: "AssignmentExpression", operator: "=", left: C, right: R }), a |= u.destructible & 256 ? 256 : 0 | u.destructible & 128 ? 128 : 0;
              } else u.token === 18 || u.token === 20 ? (u.assignable & 2 ? a |= 16 : i && q2(u, e, i, e2, l, c), a |= u.destructible & 256 ? 256 : 0 | u.destructible & 128 ? 128 : 0) : (a |= l & 1 ? 32 : (l & 2) < 1 ? 16 : 0, C = W(u, e, C, t, 0, B, O, j), u.token !== 18 && u.token !== 20 ? (u.token !== 1077936157 && (a |= 16), C = x(u, e, t, o, B, O, j, C)) : u.token !== 1077936157 && (a |= u.assignable & 2 ? 16 : 32));
              else D & 2097152 ? (C = u.token === 2162700 ? r2(u, e, i, 0, t, o, l, c, B, O, j) : k2(u, e, i, 0, t, o, l, c, B, O, j), a |= u.destructible, u.assignable = u.destructible & 16 ? 2 : 1, u.token === 18 || u.token === 20 ? u.assignable & 2 && (a |= 16) : u.destructible & 8 ? f(u, 68) : (C = W(u, e, C, t, 0, B, O, j), a = u.assignable & 2 ? 16 : 0, u.token !== 18 && u.token !== 20 ? C = x(u, e, t, o, B, O, j, C) : u.token !== 1077936157 && (a |= u.assignable & 2 ? 16 : 32))) : D === 14 ? (C = W2(u, e, i, 20, l, c, 0, t, o, B, O, j), a |= u.destructible, u.token !== 18 && u.token !== 20 && f(u, 28, G[u.token & 255])) : (C = b2(u, e, 1, 0, 1, B, O, j), u.token !== 18 && u.token !== 20 ? (C = x(u, e, t, o, B, O, j, C), (l & 3) < 1 && D === 67174411 && (a |= 16)) : u.assignable & 2 ? a |= 16 : D === 67174411 && (a |= u.assignable & 1 && l & 3 ? 32 : 16));
              if (g.push(C), U(u, e | 32768, 18)) {
                if (u.token === 20) break;
              } else break;
            }
            w(u, e, 20);
            let A = v(u, e, s, h, b, { type: o ? "ArrayPattern" : "ArrayExpression", elements: g });
            return !n && u.token & 4194304 ? me(u, e, a, t, o, s, h, b, A) : (u.destructible = a, A);
          }
          function me(u, e, i, n, t, o, l, c, s) {
            u.token !== 1077936157 && f(u, 24), E(u, e | 32768), i & 16 && f(u, 24), t || v2(u, s);
            let { tokenPos: h, linePos: b, colPos: g } = u, a = Q(u, e, 1, 1, n, h, b, g);
            return u.destructible = (i | 64 | 8) ^ 72 | (u.destructible & 128 ? 128 : 0) | (u.destructible & 256 ? 256 : 0), v(u, e, o, l, c, t ? { type: "AssignmentPattern", left: s, right: a } : { type: "AssignmentExpression", left: s, operator: "=", right: a });
          }
          function W2(u, e, i, n, t, o, l, c, s, h, b, g) {
            E(u, e | 32768);
            let a = null, A = 0, { token: C, tokenValue: D, tokenPos: B, linePos: O, colPos: j } = u;
            if (C & 143360) u.assignable = 1, a = h22(u, e, t, 0, 1, 0, c, 1, B, O, j), C = u.token, a = W(u, e, a, c, 0, B, O, j), u.token !== 18 && u.token !== n && (u.assignable & 2 && u.token === 1077936157 && f(u, 68), A |= 16, a = x(u, e, c, s, B, O, j, a)), u.assignable & 2 ? A |= 16 : C === n || C === 18 ? i && q2(u, e, i, D, t, o) : A |= 32, A |= u.destructible & 128 ? 128 : 0;
            else if (C === n) f(u, 39);
            else if (C & 2097152) a = u.token === 2162700 ? r2(u, e, i, 1, c, s, t, o, B, O, j) : k2(u, e, i, 1, c, s, t, o, B, O, j), C = u.token, C !== 1077936157 && C !== n && C !== 18 ? (u.destructible & 8 && f(u, 68), a = W(u, e, a, c, 0, B, O, j), A |= u.assignable & 2 ? 16 : 0, (u.token & 4194304) === 4194304 ? (u.token !== 1077936157 && (A |= 16), a = x(u, e, c, s, B, O, j, a)) : ((u.token & 8454144) === 8454144 && (a = F2(u, e, 1, B, O, j, 4, C, a)), U(u, e | 32768, 22) && (a = M2(u, e, a, B, O, j)), A |= u.assignable & 2 ? 16 : 32)) : A |= n === 1074790415 && C !== 1077936157 ? 16 : u.destructible;
            else {
              A |= 32, a = b2(u, e, 1, c, 1, u.tokenPos, u.linePos, u.colPos);
              let { token: e2, tokenPos: R, linePos: $, colPos: y } = u;
              return e2 === 1077936157 && e2 !== n && e2 !== 18 ? (u.assignable & 2 && f(u, 24), a = x(u, e, c, s, R, $, y, a), A |= 16) : (e2 === 18 ? A |= 16 : e2 !== n && (a = x(u, e, c, s, R, $, y, a)), A |= u.assignable & 1 ? 32 : 16), u.destructible = A, u.token !== n && u.token !== 18 && f(u, 155), v(u, e, h, b, g, { type: s ? "RestElement" : "SpreadElement", argument: a });
            }
            if (u.token !== n) if (t & 1 && (A |= l ? 16 : 32), U(u, e | 32768, 1077936157)) {
              A & 16 && f(u, 24), v2(u, a);
              let e2 = Q(u, e, 1, 1, c, u.tokenPos, u.linePos, u.colPos);
              a = v(u, e, B, O, j, s ? { type: "AssignmentPattern", left: a, right: e2 } : { type: "AssignmentExpression", left: a, operator: "=", right: e2 }), A = 16;
            } else A |= 16;
            return u.destructible = A, v(u, e, h, b, g, { type: s ? "RestElement" : "SpreadElement", argument: a });
          }
          function A2(u, e, i, n, t, o, l) {
            let c = (i & 64) < 1 ? 31981568 : 14680064;
            e = (e | c) ^ c | (i & 88) << 18 | 100925440;
            let s = e & 64 ? o2(j2(), 512) : void 0, h = bt(u, e | 8388608, s, i, 1, n);
            s && (s = o2(s, 128));
            let b = a1(u, e & -134230017, s, 0, void 0, void 0);
            return v(u, e, t, o, l, { type: "FunctionExpression", params: h, body: b, async: (i & 16) > 0, generator: (i & 8) > 0, id: null });
          }
          function mt(u, e, i, n, t, o, l) {
            let c = r2(u, e, void 0, i, n, 0, 2, 0, t, o, l);
            return e & 256 && u.destructible & 64 && f(u, 60), u.destructible & 8 && f(u, 59), c;
          }
          function r2(u, e, i, n, t, o, l, c, s, h, b) {
            E(u, e);
            let g = [], a = 0, A = 0;
            for (e = (e | 134217728) ^ 134217728; u.token !== 1074790415; ) {
              let { token: D, tokenValue: B, linePos: O, colPos: j, tokenPos: e2 } = u;
              if (D === 14) g.push(W2(u, e, i, 1074790415, l, c, 0, t, o, e2, O, j));
              else {
                let R = 0, $ = null, y, y2 = u.token;
                if (u.token & 143360 || u.token === 121) if ($ = z2(u, e, 0), u.token === 18 || u.token === 1074790415 || u.token === 1077936157) if (R |= 4, e & 1024 && (D & 537079808) === 537079808 ? a |= 16 : o1(u, e, l, D, 0), i && q2(u, e, i, B, l, c), U(u, e | 32768, 1077936157)) {
                  a |= 8;
                  let N = Q(u, e, 1, 1, t, u.tokenPos, u.linePos, u.colPos);
                  a |= u.destructible & 256 ? 256 : 0 | u.destructible & 128 ? 128 : 0, y = v(u, e, e2, O, j, { type: "AssignmentPattern", left: e & -2147483648 ? Object.assign({}, $) : $, right: N });
                } else a |= (D === 209008 ? 128 : 0) | (D === 121 ? 16 : 0), y = e & -2147483648 ? Object.assign({}, $) : $;
                else if (U(u, e | 32768, 21)) {
                  let { tokenPos: N, linePos: M, colPos: _ } = u;
                  if (B === "__proto__" && A++, u.token & 143360) {
                    let U2 = u.token, $2 = u.tokenValue;
                    a |= y2 === 121 ? 16 : 0, y = h22(u, e, l, 0, 1, 0, t, 1, N, M, _);
                    let { token: E2 } = u;
                    y = W(u, e, y, t, 0, N, M, _), u.token === 18 || u.token === 1074790415 ? E2 === 1077936157 || E2 === 1074790415 || E2 === 18 ? (a |= u.destructible & 128 ? 128 : 0, u.assignable & 2 ? a |= 16 : i && (U2 & 143360) === 143360 && q2(u, e, i, $2, l, c)) : a |= u.assignable & 1 ? 32 : 16 : (u.token & 4194304) === 4194304 ? (u.assignable & 2 ? a |= 16 : E2 !== 1077936157 ? a |= 32 : i && q2(u, e, i, $2, l, c), y = x(u, e, t, o, N, M, _, y)) : (a |= 16, (u.token & 8454144) === 8454144 && (y = F2(u, e, 1, N, M, _, 4, E2, y)), U(u, e | 32768, 22) && (y = M2(u, e, y, N, M, _)));
                  } else (u.token & 2097152) === 2097152 ? (y = u.token === 69271571 ? k2(u, e, i, 0, t, o, l, c, N, M, _) : r2(u, e, i, 0, t, o, l, c, N, M, _), a = u.destructible, u.assignable = a & 16 ? 2 : 1, u.token === 18 || u.token === 1074790415 ? u.assignable & 2 && (a |= 16) : u.destructible & 8 ? f(u, 68) : (y = W(u, e, y, t, 0, N, M, _), a = u.assignable & 2 ? 16 : 0, (u.token & 4194304) === 4194304 ? y = s1(u, e, t, o, N, M, _, y) : ((u.token & 8454144) === 8454144 && (y = F2(u, e, 1, N, M, _, 4, D, y)), U(u, e | 32768, 22) && (y = M2(u, e, y, N, M, _)), a |= u.assignable & 2 ? 16 : 32))) : (y = b2(u, e, 1, t, 1, N, M, _), a |= u.assignable & 1 ? 32 : 16, u.token === 18 || u.token === 1074790415 ? u.assignable & 2 && (a |= 16) : (y = W(u, e, y, t, 0, N, M, _), a = u.assignable & 2 ? 16 : 0, u.token !== 18 && D !== 1074790415 && (u.token !== 1077936157 && (a |= 16), y = x(u, e, t, o, N, M, _, y))));
                } else u.token === 69271571 ? (a |= 16, D === 209007 && (R |= 16), R |= (D === 12402 ? 256 : D === 12403 ? 512 : 1) | 2, $ = Y2(u, e, t), a |= u.assignable, y = A2(u, e, R, t, u.tokenPos, u.linePos, u.colPos)) : u.token & 143360 ? (a |= 16, D === 121 && f(u, 92), D === 209007 && (u.flags & 1 && f(u, 128), R |= 16), $ = z2(u, e, 0), R |= D === 12402 ? 256 : D === 12403 ? 512 : 1, y = A2(u, e, R, t, u.tokenPos, u.linePos, u.colPos)) : u.token === 67174411 ? (a |= 16, R |= 1, y = A2(u, e, R, t, u.tokenPos, u.linePos, u.colPos)) : u.token === 8457014 ? (a |= 16, D === 12402 || D === 12403 ? f(u, 40) : D === 143483 && f(u, 92), E(u, e), R |= 9 | (D === 209007 ? 16 : 0), u.token & 143360 ? $ = z2(u, e, 0) : (u.token & 134217728) === 134217728 ? $ = a2(u, e) : u.token === 69271571 ? (R |= 2, $ = Y2(u, e, t), a |= u.assignable) : f(u, 28, G[u.token & 255]), y = A2(u, e, R, t, u.tokenPos, u.linePos, u.colPos)) : (u.token & 134217728) === 134217728 ? (D === 209007 && (R |= 16), R |= D === 12402 ? 256 : D === 12403 ? 512 : 1, a |= 16, $ = a2(u, e), y = A2(u, e, R, t, u.tokenPos, u.linePos, u.colPos)) : f(u, 129);
                else if ((u.token & 134217728) === 134217728) if ($ = a2(u, e), u.token === 21) {
                  w(u, e | 32768, 21);
                  let { tokenPos: N, linePos: M, colPos: _ } = u;
                  if (B === "__proto__" && A++, u.token & 143360) {
                    y = h22(u, e, l, 0, 1, 0, t, 1, N, M, _);
                    let { token: U2, tokenValue: $2 } = u;
                    y = W(u, e, y, t, 0, N, M, _), u.token === 18 || u.token === 1074790415 ? U2 === 1077936157 || U2 === 1074790415 || U2 === 18 ? u.assignable & 2 ? a |= 16 : i && q2(u, e, i, $2, l, c) : a |= u.assignable & 1 ? 32 : 16 : u.token === 1077936157 ? (u.assignable & 2 && (a |= 16), y = x(u, e, t, o, N, M, _, y)) : (a |= 16, y = x(u, e, t, o, N, M, _, y));
                  } else (u.token & 2097152) === 2097152 ? (y = u.token === 69271571 ? k2(u, e, i, 0, t, o, l, c, N, M, _) : r2(u, e, i, 0, t, o, l, c, N, M, _), a = u.destructible, u.assignable = a & 16 ? 2 : 1, u.token === 18 || u.token === 1074790415 ? u.assignable & 2 && (a |= 16) : (u.destructible & 8) !== 8 && (y = W(u, e, y, t, 0, N, M, _), a = u.assignable & 2 ? 16 : 0, (u.token & 4194304) === 4194304 ? y = s1(u, e, t, o, N, M, _, y) : ((u.token & 8454144) === 8454144 && (y = F2(u, e, 1, N, M, _, 4, D, y)), U(u, e | 32768, 22) && (y = M2(u, e, y, N, M, _)), a |= u.assignable & 2 ? 16 : 32))) : (y = b2(u, e, 1, 0, 1, N, M, _), a |= u.assignable & 1 ? 32 : 16, u.token === 18 || u.token === 1074790415 ? u.assignable & 2 && (a |= 16) : (y = W(u, e, y, t, 0, N, M, _), a = u.assignable & 1 ? 0 : 16, u.token !== 18 && u.token !== 1074790415 && (u.token !== 1077936157 && (a |= 16), y = x(u, e, t, o, N, M, _, y))));
                } else u.token === 67174411 ? (R |= 1, y = A2(u, e, R, t, u.tokenPos, u.linePos, u.colPos), a = u.assignable | 16) : f(u, 130);
                else if (u.token === 69271571) if ($ = Y2(u, e, t), a |= u.destructible & 256 ? 256 : 0, R |= 2, u.token === 21) {
                  E(u, e | 32768);
                  let { tokenPos: N, linePos: M, colPos: _, tokenValue: U2, token: $2 } = u;
                  if (u.token & 143360) {
                    y = h22(u, e, l, 0, 1, 0, t, 1, N, M, _);
                    let { token: E2 } = u;
                    y = W(u, e, y, t, 0, N, M, _), (u.token & 4194304) === 4194304 ? (a |= u.assignable & 2 ? 16 : E2 === 1077936157 ? 0 : 32, y = s1(u, e, t, o, N, M, _, y)) : u.token === 18 || u.token === 1074790415 ? E2 === 1077936157 || E2 === 1074790415 || E2 === 18 ? u.assignable & 2 ? a |= 16 : i && ($2 & 143360) === 143360 && q2(u, e, i, U2, l, c) : a |= u.assignable & 1 ? 32 : 16 : (a |= 16, y = x(u, e, t, o, N, M, _, y));
                  } else (u.token & 2097152) === 2097152 ? (y = u.token === 69271571 ? k2(u, e, i, 0, t, o, l, c, N, M, _) : r2(u, e, i, 0, t, o, l, c, N, M, _), a = u.destructible, u.assignable = a & 16 ? 2 : 1, u.token === 18 || u.token === 1074790415 ? u.assignable & 2 && (a |= 16) : a & 8 ? f(u, 59) : (y = W(u, e, y, t, 0, N, M, _), a = u.assignable & 2 ? a | 16 : 0, (u.token & 4194304) === 4194304 ? (u.token !== 1077936157 && (a |= 16), y = s1(u, e, t, o, N, M, _, y)) : ((u.token & 8454144) === 8454144 && (y = F2(u, e, 1, N, M, _, 4, D, y)), U(u, e | 32768, 22) && (y = M2(u, e, y, N, M, _)), a |= u.assignable & 2 ? 16 : 32))) : (y = b2(u, e, 1, 0, 1, N, M, _), a |= u.assignable & 1 ? 32 : 16, u.token === 18 || u.token === 1074790415 ? u.assignable & 2 && (a |= 16) : (y = W(u, e, y, t, 0, N, M, _), a = u.assignable & 1 ? 0 : 16, u.token !== 18 && u.token !== 1074790415 && (u.token !== 1077936157 && (a |= 16), y = x(u, e, t, o, N, M, _, y))));
                } else u.token === 67174411 ? (R |= 1, y = A2(u, e, R, t, u.tokenPos, O, j), a = 16) : f(u, 41);
                else if (D === 8457014) if (w(u, e | 32768, 8457014), R |= 8, u.token & 143360) {
                  let { token: N, line: M, index: _ } = u;
                  $ = z2(u, e, 0), R |= 1, u.token === 67174411 ? (a |= 16, y = A2(u, e, R, t, u.tokenPos, u.linePos, u.colPos)) : S(_, M, _, N === 209007 ? 43 : N === 12402 || u.token === 12403 ? 42 : 44, G[N & 255]);
                } else (u.token & 134217728) === 134217728 ? (a |= 16, $ = a2(u, e), R |= 1, y = A2(u, e, R, t, e2, O, j)) : u.token === 69271571 ? (a |= 16, R |= 3, $ = Y2(u, e, t), y = A2(u, e, R, t, u.tokenPos, u.linePos, u.colPos)) : f(u, 122);
                else f(u, 28, G[D & 255]);
                a |= u.destructible & 128 ? 128 : 0, u.destructible = a, g.push(v(u, e, e2, O, j, { type: "Property", key: $, value: y, kind: R & 768 ? R & 512 ? "set" : "get" : "init", computed: (R & 2) > 0, method: (R & 1) > 0, shorthand: (R & 4) > 0 }));
              }
              if (a |= u.destructible, u.token !== 18) break;
              E(u, e);
            }
            w(u, e, 1074790415), A > 1 && (a |= 64);
            let C = v(u, e, s, h, b, { type: o ? "ObjectPattern" : "ObjectExpression", properties: g });
            return !n && u.token & 4194304 ? me(u, e, a, t, o, s, h, b, C) : (u.destructible = a, C);
          }
          function bt(u, e, i, n, t, o) {
            w(u, e, 67174411);
            let l = [];
            if (u.flags = (u.flags | 128) ^ 128, u.token === 16) return n & 512 && f(u, 35, "Setter", "one", ""), E(u, e), l;
            n & 256 && f(u, 35, "Getter", "no", "s"), n & 512 && u.token === 14 && f(u, 36), e = (e | 134217728) ^ 134217728;
            let c = 0, s = 0;
            for (; u.token !== 18; ) {
              let h = null, { tokenPos: b, linePos: g, colPos: a } = u;
              if (u.token & 143360 ? ((e & 1024) < 1 && ((u.token & 36864) === 36864 && (u.flags |= 256), (u.token & 537079808) === 537079808 && (u.flags |= 512)), h = Q1(u, e, i, n | 1, 0, b, g, a)) : (u.token === 2162700 ? h = r2(u, e, i, 1, o, 1, t, 0, b, g, a) : u.token === 69271571 ? h = k2(u, e, i, 1, o, 1, t, 0, b, g, a) : u.token === 14 && (h = W2(u, e, i, 16, t, 0, 0, o, 1, b, g, a)), s = 1, u.destructible & 48 && f(u, 47)), u.token === 1077936157) {
                E(u, e | 32768), s = 1;
                let A = Q(u, e, 1, 1, 0, u.tokenPos, u.linePos, u.colPos);
                h = v(u, e, b, g, a, { type: "AssignmentPattern", left: h, right: A });
              }
              if (c++, l.push(h), !U(u, e, 18) || u.token === 16) break;
            }
            return n & 512 && c !== 1 && f(u, 35, "Setter", "one", ""), i && i.scopeError !== void 0 && P(i.scopeError), s && (u.flags |= 128), w(u, e, 16), l;
          }
          function Y2(u, e, i) {
            E(u, e | 32768);
            let n = Q(u, (e | 134217728) ^ 134217728, 1, 0, i, u.tokenPos, u.linePos, u.colPos);
            return w(u, e, 20), n;
          }
          function kt(u, e, i, n, t, o, l, c) {
            u.flags = (u.flags | 128) ^ 128;
            let { tokenPos: s, linePos: h, colPos: b } = u;
            E(u, e | 32768 | 1073741824);
            let g = e & 64 ? o2(j2(), 1024) : void 0;
            if (e = (e | 134217728) ^ 134217728, U(u, e, 16)) return h1(u, e, g, [], i, 0, o, l, c);
            let a = 0;
            u.destructible &= -385;
            let A, C = [], D = 0, B = 0, { tokenPos: O, linePos: j, colPos: e2 } = u;
            for (u.assignable = 1; u.token !== 16; ) {
              let { token: R, tokenPos: $, linePos: y, colPos: y2 } = u;
              if (R & 143360) g && B2(u, e, g, u.tokenValue, 1, 0), A = h22(u, e, n, 0, 1, 0, 1, 1, $, y, y2), u.token === 16 || u.token === 18 ? u.assignable & 2 ? (a |= 16, B = 1) : ((R & 537079808) === 537079808 || (R & 36864) === 36864) && (B = 1) : (u.token === 1077936157 ? B = 1 : a |= 16, A = W(u, e, A, 1, 0, $, y, y2), u.token !== 16 && u.token !== 18 && (A = x(u, e, 1, 0, $, y, y2, A)));
              else if ((R & 2097152) === 2097152) A = R === 2162700 ? r2(u, e | 1073741824, g, 0, 1, 0, n, t, $, y, y2) : k2(u, e | 1073741824, g, 0, 1, 0, n, t, $, y, y2), a |= u.destructible, B = 1, u.assignable = 2, u.token !== 16 && u.token !== 18 && (a & 8 && f(u, 118), A = W(u, e, A, 0, 0, $, y, y2), a |= 16, u.token !== 16 && u.token !== 18 && (A = x(u, e, 0, 0, $, y, y2, A)));
              else if (R === 14) {
                A = W2(u, e, g, 16, n, t, 0, 1, 0, $, y, y2), u.destructible & 16 && f(u, 71), B = 1, D && (u.token === 16 || u.token === 18) && C.push(A), a |= 8;
                break;
              } else {
                if (a |= 16, A = Q(u, e, 1, 0, 1, $, y, y2), D && (u.token === 16 || u.token === 18) && C.push(A), u.token === 18 && (D || (D = 1, C = [A])), D) {
                  for (; U(u, e | 32768, 18); ) C.push(Q(u, e, 1, 0, 1, u.tokenPos, u.linePos, u.colPos));
                  u.assignable = 2, A = v(u, e, O, j, e2, { type: "SequenceExpression", expressions: C });
                }
                return w(u, e, 16), u.destructible = a, A;
              }
              if (D && (u.token === 16 || u.token === 18) && C.push(A), !U(u, e | 32768, 18)) break;
              if (D || (D = 1, C = [A]), u.token === 16) {
                a |= 8;
                break;
              }
            }
            return D && (u.assignable = 2, A = v(u, e, O, j, e2, { type: "SequenceExpression", expressions: C })), w(u, e, 16), a & 16 && a & 8 && f(u, 145), a |= u.destructible & 256 ? 256 : 0 | u.destructible & 128 ? 128 : 0, u.token === 10 ? (a & 48 && f(u, 46), e & 4196352 && a & 128 && f(u, 29), e & 2098176 && a & 256 && f(u, 30), B && (u.flags |= 128), h1(u, e, g, D ? C : [A], i, 0, o, l, c)) : (a & 8 && f(u, 139), u.destructible = (u.destructible | 256) ^ 256 | a, e & 128 ? v(u, e, s, h, b, { type: "ParenthesizedExpression", expression: A }) : A);
          }
          function Y1(u, e, i, n, t) {
            let { tokenValue: o } = u, l = z2(u, e, 0);
            if (u.assignable = 1, u.token === 10) {
              let c;
              return e & 64 && (c = f1(u, e, o)), u.flags = (u.flags | 128) ^ 128, u1(u, e, c, [l], 0, i, n, t);
            }
            return l;
          }
          function g1(u, e, i, n, t, o, l, c, s, h) {
            o || f(u, 54), t && f(u, 48), u.flags &= -129;
            let b = e & 64 ? f1(u, e, i) : void 0;
            return u1(u, e, b, [n], l, c, s, h);
          }
          function h1(u, e, i, n, t, o, l, c, s) {
            t || f(u, 54);
            for (let h = 0; h < n.length; ++h) v2(u, n[h]);
            return u1(u, e, i, n, o, l, c, s);
          }
          function u1(u, e, i, n, t, o, l, c) {
            u.flags & 1 && f(u, 45), w(u, e | 32768, 10), e = (e | 15728640) ^ 15728640 | t << 22;
            let s = u.token !== 2162700, h;
            if (i && i.scopeError !== void 0 && P(i.scopeError), s) h = Q(u, e, 1, 0, 0, u.tokenPos, u.linePos, u.colPos);
            else {
              switch (i && (i = o2(i, 128)), h = a1(u, (e | 134221824 | 8192 | 16384) ^ 134246400, i, 16, void 0, void 0), u.token) {
                case 69271571:
                  (u.flags & 1) < 1 && f(u, 112);
                  break;
                case 67108877:
                case 67174409:
                case 22:
                  f(u, 113);
                case 67174411:
                  (u.flags & 1) < 1 && f(u, 112), u.flags |= 1024;
                  break;
              }
              (u.token & 8454144) === 8454144 && (u.flags & 1) < 1 && f(u, 28, G[u.token & 255]), (u.token & 33619968) === 33619968 && f(u, 121);
            }
            return u.assignable = 2, v(u, e, o, l, c, { type: "ArrowFunctionExpression", params: n, body: h, async: t === 1, expression: s });
          }
          function be(u, e, i, n, t) {
            w(u, e, 67174411), u.flags = (u.flags | 128) ^ 128;
            let o = [];
            if (U(u, e, 16)) return o;
            e = (e | 134217728) ^ 134217728;
            let l = 0;
            for (; u.token !== 18; ) {
              let c, { tokenPos: s, linePos: h, colPos: b } = u;
              if (u.token & 143360 ? ((e & 1024) < 1 && ((u.token & 36864) === 36864 && (u.flags |= 256), (u.token & 537079808) === 537079808 && (u.flags |= 512)), c = Q1(u, e, i, t | 1, 0, s, h, b)) : (u.token === 2162700 ? c = r2(u, e, i, 1, n, 1, t, 0, s, h, b) : u.token === 69271571 ? c = k2(u, e, i, 1, n, 1, t, 0, s, h, b) : u.token === 14 ? c = W2(u, e, i, 16, t, 0, 0, n, 1, s, h, b) : f(u, 28, G[u.token & 255]), l = 1, u.destructible & 48 && f(u, 47)), u.token === 1077936157) {
                E(u, e | 32768), l = 1;
                let g = Q(u, e, 1, 1, n, u.tokenPos, u.linePos, u.colPos);
                c = v(u, e, s, h, b, { type: "AssignmentPattern", left: c, right: g });
              }
              if (o.push(c), !U(u, e, 18) || u.token === 16) break;
            }
            return l && (u.flags |= 128), i && (l || e & 1024) && i.scopeError !== void 0 && P(i.scopeError), w(u, e, 16), o;
          }
          function m1(u, e, i, n, t, o, l) {
            let { token: c } = u;
            if (c & 67108864) {
              if (c === 67108877) {
                E(u, e | 1073741824), u.assignable = 1;
                let s = se(u, e);
                return m1(u, e, v(u, e, t, o, l, { type: "MemberExpression", object: i, computed: false, property: s }), 0, t, o, l);
              } else if (c === 69271571) {
                E(u, e | 32768);
                let { tokenPos: s, linePos: h, colPos: b } = u, g = f2(u, e, n, 1, s, h, b);
                return w(u, e, 20), u.assignable = 1, m1(u, e, v(u, e, t, o, l, { type: "MemberExpression", object: i, computed: true, property: g }), 0, t, o, l);
              } else if (c === 67174408 || c === 67174409) return u.assignable = 2, m1(u, e, v(u, e, t, o, l, { type: "TaggedTemplateExpression", tag: i, quasi: u.token === 67174408 ? K1(u, e | 65536) : H1(u, e, u.tokenPos, u.linePos, u.colPos) }), 0, t, o, l);
            }
            return i;
          }
          function rt(u, e, i, n, t, o) {
            let l = z2(u, e | 32768, 0), { tokenPos: c, linePos: s, colPos: h } = u;
            if (U(u, e, 67108877)) {
              if (e & 67108864 && u.token === 143494) return u.assignable = 2, vt(u, e, l, n, t, o);
              f(u, 91);
            }
            u.assignable = 2, (u.token & 16842752) === 16842752 && f(u, 62, G[u.token & 255]);
            let b = h22(u, e, 2, 1, 0, 0, i, 1, c, s, h);
            e = (e | 134217728) ^ 134217728, u.token === 67108991 && f(u, 162);
            let g = m1(u, e, b, i, c, s, h);
            return u.assignable = 2, v(u, e, n, t, o, { type: "NewExpression", callee: g, arguments: u.token === 67174411 ? W1(u, e, i) : [] });
          }
          function vt(u, e, i, n, t, o) {
            let l = z2(u, e, 0);
            return v(u, e, n, t, o, { type: "MetaProperty", meta: i, property: l });
          }
          function ke(u, e, i, n, t, o) {
            return u.token === 209008 && f(u, 29), e & 2098176 && u.token === 241773 && f(u, 30), (u.token & 537079808) === 537079808 && (u.flags |= 512), g1(u, e, u.tokenValue, z2(u, e, 0), 0, i, 1, n, t, o);
          }
          function $1(u, e, i, n, t, o, l, c, s, h) {
            E(u, e | 32768);
            let b = e & 64 ? o2(j2(), 1024) : void 0;
            if (e = (e | 134217728) ^ 134217728, U(u, e, 16)) return u.token === 10 ? (l & 1 && f(u, 45), h1(u, e, b, [], n, 1, c, s, h)) : v(u, e, c, s, h, { type: "CallExpression", callee: i, arguments: [] });
            let g = 0, a = null, A = 0;
            u.destructible = (u.destructible | 256 | 128) ^ 384;
            let C = [];
            for (; u.token !== 16; ) {
              let { token: D, tokenPos: B, linePos: O, colPos: j } = u;
              if (D & 143360) b && B2(u, e, b, u.tokenValue, t, 0), a = h22(u, e, t, 0, 1, 0, 1, 1, B, O, j), u.token === 16 || u.token === 18 ? u.assignable & 2 ? (g |= 16, A = 1) : (D & 537079808) === 537079808 ? u.flags |= 512 : (D & 36864) === 36864 && (u.flags |= 256) : (u.token === 1077936157 ? A = 1 : g |= 16, a = W(u, e, a, 1, 0, B, O, j), u.token !== 16 && u.token !== 18 && (a = x(u, e, 1, 0, B, O, j, a)));
              else if (D & 2097152) a = D === 2162700 ? r2(u, e, b, 0, 1, 0, t, o, B, O, j) : k2(u, e, b, 0, 1, 0, t, o, B, O, j), g |= u.destructible, A = 1, u.token !== 16 && u.token !== 18 && (g & 8 && f(u, 118), a = W(u, e, a, 0, 0, B, O, j), g |= 16, (u.token & 8454144) === 8454144 && (a = F2(u, e, 1, c, s, h, 4, D, a)), U(u, e | 32768, 22) && (a = M2(u, e, a, c, s, h)));
              else if (D === 14) a = W2(u, e, b, 16, t, o, 1, 1, 0, B, O, j), g |= (u.token === 16 ? 0 : 16) | u.destructible, A = 1;
              else {
                for (a = Q(u, e, 1, 0, 0, B, O, j), g = u.assignable, C.push(a); U(u, e | 32768, 18); ) C.push(Q(u, e, 1, 0, 0, B, O, j));
                return g |= u.assignable, w(u, e, 16), u.destructible = g | 16, u.assignable = 2, v(u, e, c, s, h, { type: "CallExpression", callee: i, arguments: C });
              }
              if (C.push(a), !U(u, e | 32768, 18)) break;
            }
            return w(u, e, 16), g |= u.destructible & 256 ? 256 : 0 | u.destructible & 128 ? 128 : 0, u.token === 10 ? (g & 48 && f(u, 25), (u.flags & 1 || l & 1) && f(u, 45), g & 128 && f(u, 29), e & 2098176 && g & 256 && f(u, 30), A && (u.flags |= 128), h1(u, e, b, C, n, 1, c, s, h)) : (g & 8 && f(u, 59), u.assignable = 2, v(u, e, c, s, h, { type: "CallExpression", callee: i, arguments: C }));
          }
          function At(u, e, i, n, t) {
            let { tokenRaw: o, tokenRegExp: l, tokenValue: c } = u;
            return E(u, e), u.assignable = 2, e & 512 ? v(u, e, i, n, t, { type: "Literal", value: c, regex: l, raw: o }) : v(u, e, i, n, t, { type: "Literal", value: c, regex: l });
          }
          function Z1(u, e, i, n, t, o, l) {
            e = (e | 16777216 | 1024) ^ 16777216;
            let c = b1(u, e);
            c.length && (t = u.tokenPos, o = u.linePos, l = u.colPos), u.leadingDecorators.length && (u.leadingDecorators.push(...c), c = u.leadingDecorators, u.leadingDecorators = []), E(u, e);
            let s = null, h = null, { tokenValue: b } = u;
            u.token & 4096 && u.token !== 20567 ? (Gu(u, e, u.token) && f(u, 114), (u.token & 537079808) === 537079808 && f(u, 115), i && (B2(u, e, i, b, 32, 0), n && n & 2 && _2(u, b)), s = z2(u, e, 0)) : (n & 1) < 1 && f(u, 37, "Class");
            let g = e;
            U(u, e | 32768, 20567) ? (h = b2(u, e, 0, 0, 0, u.tokenPos, u.linePos, u.colPos), g |= 524288) : g = (g | 524288) ^ 524288;
            let a = re(u, g, e, i, 2, 8, 0);
            return v(u, e, t, o, l, e & 1 ? { type: "ClassDeclaration", id: s, superClass: h, decorators: c, body: a } : { type: "ClassDeclaration", id: s, superClass: h, body: a });
          }
          function yt(u, e, i, n, t, o) {
            let l = null, c = null;
            e = (e | 1024 | 16777216) ^ 16777216;
            let s = b1(u, e);
            s.length && (n = u.tokenPos, t = u.linePos, o = u.colPos), E(u, e), u.token & 4096 && u.token !== 20567 && (Gu(u, e, u.token) && f(u, 114), (u.token & 537079808) === 537079808 && f(u, 115), l = z2(u, e, 0));
            let h = e;
            U(u, e | 32768, 20567) ? (c = b2(u, e, 0, i, 0, u.tokenPos, u.linePos, u.colPos), h |= 524288) : h = (h | 524288) ^ 524288;
            let b = re(u, h, e, void 0, 2, 0, i);
            return u.assignable = 2, v(u, e, n, t, o, e & 1 ? { type: "ClassExpression", id: l, superClass: c, decorators: s, body: b } : { type: "ClassExpression", id: l, superClass: c, body: b });
          }
          function b1(u, e) {
            let i = [];
            if (e & 1) for (; u.token === 133; ) i.push(Pt(u, e, u.tokenPos, u.linePos, u.colPos));
            return i;
          }
          function Pt(u, e, i, n, t) {
            E(u, e | 32768);
            let o = h22(u, e, 2, 0, 1, 0, 0, 1, i, n, t);
            return o = W(u, e, o, 0, 0, i, n, t), v(u, e, i, n, t, { type: "Decorator", expression: o });
          }
          function re(u, e, i, n, t, o, l) {
            let { tokenPos: c, linePos: s, colPos: h } = u;
            w(u, e | 32768, 2162700), e = (e | 134217728) ^ 134217728, u.flags = (u.flags | 32) ^ 32;
            let b = [], g;
            for (; u.token !== 1074790415; ) {
              let a = 0;
              if (g = b1(u, e), a = g.length, a > 0 && u.tokenValue === "constructor" && f(u, 106), u.token === 1074790415 && f(u, 105), U(u, e, 1074790417)) {
                a > 0 && f(u, 116);
                continue;
              }
              b.push(ve(u, e, n, i, t, g, 0, l, u.tokenPos, u.linePos, u.colPos));
            }
            return w(u, o & 8 ? e | 32768 : e, 1074790415), v(u, e, c, s, h, { type: "ClassBody", body: b });
          }
          function ve(u, e, i, n, t, o, l, c, s, h, b) {
            let g = l ? 32 : 0, a = null, { token: A, tokenPos: C, linePos: D, colPos: B } = u;
            if (A & 176128) switch (a = z2(u, e, 0), A) {
              case 36972:
                if (!l && u.token !== 67174411) return ve(u, e, i, n, t, o, 1, c, s, h, b);
                break;
              case 209007:
                if (u.token !== 67174411 && (u.flags & 1) < 1) {
                  if (e & 1 && (u.token & 1073741824) === 1073741824) return r1(u, e, a, g, o, C, D, B);
                  g |= 16 | (V1(u, e, 8457014) ? 8 : 0);
                }
                break;
              case 12402:
                if (u.token !== 67174411) {
                  if (e & 1 && (u.token & 1073741824) === 1073741824) return r1(u, e, a, g, o, C, D, B);
                  g |= 256;
                }
                break;
              case 12403:
                if (u.token !== 67174411) {
                  if (e & 1 && (u.token & 1073741824) === 1073741824) return r1(u, e, a, g, o, C, D, B);
                  g |= 512;
                }
                break;
            }
            else A === 69271571 ? (g |= 2, a = Y2(u, n, c)) : (A & 134217728) === 134217728 ? a = a2(u, e) : A === 8457014 ? (g |= 8, E(u, e)) : e & 1 && u.token === 131 ? (g |= 4096, a = k1(u, e | 16384, C, D, B)) : e & 1 && (u.token & 1073741824) === 1073741824 ? g |= 128 : A === 122 ? (a = z2(u, e, 0), u.token !== 67174411 && f(u, 28, G[u.token & 255])) : f(u, 28, G[u.token & 255]);
            if (g & 792 && (u.token & 143360 ? a = z2(u, e, 0) : (u.token & 134217728) === 134217728 ? a = a2(u, e) : u.token === 69271571 ? (g |= 2, a = Y2(u, e, 0)) : u.token === 122 ? a = z2(u, e, 0) : e & 1 && u.token === 131 ? (g |= 4096, a = k1(u, e, C, D, B)) : f(u, 131)), (g & 2) < 1 && (u.tokenValue === "constructor" ? ((u.token & 1073741824) === 1073741824 ? f(u, 125) : (g & 32) < 1 && u.token === 67174411 && (g & 920 ? f(u, 50, "accessor") : (e & 524288) < 1 && (u.flags & 32 ? f(u, 51) : u.flags |= 32)), g |= 64) : (g & 4096) < 1 && g & 824 && u.tokenValue === "prototype" && f(u, 49)), e & 1 && u.token !== 67174411) return r1(u, e, a, g, o, C, D, B);
            let O = A2(u, e, g, c, u.tokenPos, u.linePos, u.colPos);
            return v(u, e, s, h, b, e & 1 ? { type: "MethodDefinition", kind: (g & 32) < 1 && g & 64 ? "constructor" : g & 256 ? "get" : g & 512 ? "set" : "method", static: (g & 32) > 0, computed: (g & 2) > 0, key: a, decorators: o, value: O } : { type: "MethodDefinition", kind: (g & 32) < 1 && g & 64 ? "constructor" : g & 256 ? "get" : g & 512 ? "set" : "method", static: (g & 32) > 0, computed: (g & 2) > 0, key: a, value: O });
          }
          function k1(u, e, i, n, t) {
            E(u, e);
            let { tokenValue: o } = u;
            return o === "constructor" && f(u, 124), E(u, e), v(u, e, i, n, t, { type: "PrivateIdentifier", name: o });
          }
          function r1(u, e, i, n, t, o, l, c) {
            let s = null;
            if (n & 8 && f(u, 0), u.token === 1077936157) {
              E(u, e | 32768);
              let { tokenPos: h, linePos: b, colPos: g } = u;
              u.token === 537079928 && f(u, 115), s = h22(u, e | 16384, 2, 0, 1, 0, 0, 1, h, b, g), (u.token & 1073741824) !== 1073741824 && (s = W(u, e | 16384, s, 0, 0, h, b, g), s = x(u, e | 16384, 0, 0, h, b, g, s), u.token === 18 && (s = S2(u, e, 0, o, l, c, s)));
            }
            return v(u, e, o, l, c, { type: "PropertyDefinition", key: i, value: s, static: (n & 32) > 0, computed: (n & 2) > 0, decorators: t });
          }
          function Ae(u, e, i, n, t, o, l, c) {
            if (u.token & 143360) return Q1(u, e, i, n, t, o, l, c);
            (u.token & 2097152) !== 2097152 && f(u, 28, G[u.token & 255]);
            let s = u.token === 69271571 ? k2(u, e, i, 1, 0, 1, n, t, o, l, c) : r2(u, e, i, 1, 0, 1, n, t, o, l, c);
            return u.destructible & 16 && f(u, 47), u.destructible & 32 && f(u, 47), s;
          }
          function Q1(u, e, i, n, t, o, l, c) {
            let { tokenValue: s, token: h } = u;
            return e & 1024 && ((h & 537079808) === 537079808 ? f(u, 115) : (h & 36864) === 36864 && f(u, 114)), (h & 20480) === 20480 && f(u, 99), e & 2099200 && h === 241773 && f(u, 30), h === 241739 && n & 24 && f(u, 97), e & 4196352 && h === 209008 && f(u, 95), E(u, e), i && q2(u, e, i, s, n, t), v(u, e, o, l, c, { type: "Identifier", name: s });
          }
          function G1(u, e, i, n, t, o) {
            if (E(u, e), u.token === 8456259) return v(u, e, n, t, o, { type: "JSXFragment", openingFragment: Et(u, e, n, t, o), children: ye(u, e), closingFragment: Ct(u, e, i, u.tokenPos, u.linePos, u.colPos) });
            let l = null, c = [], s = Bt(u, e, i, n, t, o);
            if (!s.selfClosing) {
              c = ye(u, e), l = Dt(u, e, i, u.tokenPos, u.linePos, u.colPos);
              let h = l1(l.name);
              l1(s.name) !== h && f(u, 149, h);
            }
            return v(u, e, n, t, o, { type: "JSXElement", children: c, openingElement: s, closingElement: l });
          }
          function Et(u, e, i, n, t) {
            return V2(u, e), v(u, e, i, n, t, { type: "JSXOpeningFragment" });
          }
          function Dt(u, e, i, n, t, o) {
            w(u, e, 25);
            let l = Pe(u, e, u.tokenPos, u.linePos, u.colPos);
            return i ? w(u, e, 8456259) : u.token = V2(u, e), v(u, e, n, t, o, { type: "JSXClosingElement", name: l });
          }
          function Ct(u, e, i, n, t, o) {
            return w(u, e, 25), w(u, e, 8456259), v(u, e, n, t, o, { type: "JSXClosingFragment" });
          }
          function ye(u, e) {
            let i = [];
            for (; u.token !== 25; ) u.index = u.tokenPos = u.startPos, u.column = u.colPos = u.startColumn, u.line = u.linePos = u.startLine, V2(u, e), i.push(wt(u, e, u.tokenPos, u.linePos, u.colPos));
            return i;
          }
          function wt(u, e, i, n, t) {
            if (u.token === 138) return qt(u, e, i, n, t);
            if (u.token === 2162700) return De(u, e, 0, 0, i, n, t);
            if (u.token === 8456258) return G1(u, e, 0, i, n, t);
            f(u, 0);
          }
          function qt(u, e, i, n, t) {
            V2(u, e);
            let o = { type: "JSXText", value: u.tokenValue };
            return e & 512 && (o.raw = u.tokenRaw), v(u, e, i, n, t, o);
          }
          function Bt(u, e, i, n, t, o) {
            (u.token & 143360) !== 143360 && (u.token & 4096) !== 4096 && f(u, 0);
            let l = Pe(u, e, u.tokenPos, u.linePos, u.colPos), c = Ft(u, e), s = u.token === 8457016;
            return u.token === 8456259 ? V2(u, e) : (w(u, e, 8457016), i ? w(u, e, 8456259) : V2(u, e)), v(u, e, n, t, o, { type: "JSXOpeningElement", name: l, attributes: c, selfClosing: s });
          }
          function Pe(u, e, i, n, t) {
            N1(u);
            let o = v1(u, e, i, n, t);
            if (u.token === 21) return Ee(u, e, o, i, n, t);
            for (; U(u, e, 67108877); ) N1(u), o = St(u, e, o, i, n, t);
            return o;
          }
          function St(u, e, i, n, t, o) {
            let l = v1(u, e, u.tokenPos, u.linePos, u.colPos);
            return v(u, e, n, t, o, { type: "JSXMemberExpression", object: i, property: l });
          }
          function Ft(u, e) {
            let i = [];
            for (; u.token !== 8457016 && u.token !== 8456259 && u.token !== 1048576; ) i.push(Lt(u, e, u.tokenPos, u.linePos, u.colPos));
            return i;
          }
          function Tt(u, e, i, n, t) {
            E(u, e), w(u, e, 14);
            let o = Q(u, e, 1, 0, 0, u.tokenPos, u.linePos, u.colPos);
            return w(u, e, 1074790415), v(u, e, i, n, t, { type: "JSXSpreadAttribute", argument: o });
          }
          function Lt(u, e, i, n, t) {
            if (u.token === 2162700) return Tt(u, e, i, n, t);
            N1(u);
            let o = null, l = v1(u, e, i, n, t);
            if (u.token === 21 && (l = Ee(u, e, l, i, n, t)), u.token === 1077936157) {
              let c = w0(u, e), { tokenPos: s, linePos: h, colPos: b } = u;
              switch (c) {
                case 134283267:
                  o = a2(u, e);
                  break;
                case 8456258:
                  o = G1(u, e, 1, s, h, b);
                  break;
                case 2162700:
                  o = De(u, e, 1, 1, s, h, b);
                  break;
                default:
                  f(u, 148);
              }
            }
            return v(u, e, i, n, t, { type: "JSXAttribute", value: o, name: l });
          }
          function Ee(u, e, i, n, t, o) {
            w(u, e, 21);
            let l = v1(u, e, u.tokenPos, u.linePos, u.colPos);
            return v(u, e, n, t, o, { type: "JSXNamespacedName", namespace: i, name: l });
          }
          function De(u, e, i, n, t, o, l) {
            E(u, e | 32768);
            let { tokenPos: c, linePos: s, colPos: h } = u;
            if (u.token === 14) return Ot(u, e, c, s, h);
            let b = null;
            return u.token === 1074790415 ? (n && f(u, 151), b = It(u, e, u.startPos, u.startLine, u.startColumn)) : b = Q(u, e, 1, 0, 0, c, s, h), i ? w(u, e, 1074790415) : V2(u, e), v(u, e, t, o, l, { type: "JSXExpressionContainer", expression: b });
          }
          function Ot(u, e, i, n, t) {
            w(u, e, 14);
            let o = Q(u, e, 1, 0, 0, u.tokenPos, u.linePos, u.colPos);
            return w(u, e, 1074790415), v(u, e, i, n, t, { type: "JSXSpreadChild", expression: o });
          }
          function It(u, e, i, n, t) {
            return u.startPos = u.tokenPos, u.startLine = u.linePos, u.startColumn = u.colPos, v(u, e, i, n, t, { type: "JSXEmptyExpression" });
          }
          function v1(u, e, i, n, t) {
            let { tokenValue: o } = u;
            return E(u, e), v(u, e, i, n, t, { type: "JSXIdentifier", name: o });
          }
          var Rt = Object.freeze({ __proto__: null }), Nt = "4.2.1", Vt = Nt;
          function jt(u, e) {
            return U1(u, e, 0);
          }
          function _t(u, e) {
            return U1(u, e, 3072);
          }
          function Mt(u, e) {
            return U1(u, e, 0);
          }
          d.ESTree = Rt, d.parse = Mt, d.parseModule = _t, d.parseScript = jt, d.version = Vt;
        } });
        n2();
        var h3 = pn(), m3 = $4(), b3 = o3(), k3 = d3(), r3 = { module: true, next: true, ranges: true, webcompat: true, loc: true, raw: true, directives: true, globalReturn: true, impliedStrict: false, preserveParens: false, lexical: false, identifierPattern: false, jsx: true, specDeviation: true, uniqueKeyInPattern: false };
        function Gn(d, m) {
          let { parse: k } = g3(), f = [], P = [], S = k(d, Object.assign(Object.assign({}, r3), {}, { module: m, onComment: f, onToken: P }));
          return S.comments = f, S.tokens = P, S;
        }
        function v3(d) {
          let { message: m, line: k, column: f } = d, P = (m.match(/^\[(?<line>\d+):(?<column>\d+)]: (?<message>.*)$/) || {}).groups;
          return P && (m = P.message, typeof k != "number" && (k = Number(P.line), f = Number(P.column))), typeof k != "number" ? d : h3(m, { start: { line: k, column: f } });
        }
        function A3(d, m) {
          let k = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, { result: f, error: P } = m3(() => Gn(d, true), () => Gn(d, false));
          if (!f) throw v3(P);
          return k.originalText = d, k3(f, k);
        }
        k0.exports = { parsers: { meriyah: b3(A3) } };
      });
      return y3();
    });
  }
});

// ../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-postcss.js
var require_parser_postcss = __commonJS({
  "../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-postcss.js"(exports2, module2) {
    "use strict";
    (function(e) {
      if (typeof exports2 == "object" && typeof module2 == "object") module2.exports = e();
      else if (typeof define == "function" && define.amd) define(e);
      else {
        var i = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i.prettierPlugins = i.prettierPlugins || {}, i.prettierPlugins.postcss = e();
      }
    })(function() {
      "use strict";
      var V = (e, n) => () => (n || e((n = { exports: {} }).exports, n), n.exports);
      var ee = V((pp, Ut) => {
        var er = function(e) {
          return e && e.Math == Math && e;
        };
        Ut.exports = er(typeof globalThis == "object" && globalThis) || er(typeof window == "object" && window) || er(typeof self == "object" && self) || er(typeof global == "object" && global) || /* @__PURE__ */ function() {
          return this;
        }() || Function("return this")();
      });
      var ke = V((hp, Wt) => {
        Wt.exports = function(e) {
          try {
            return !!e();
          } catch {
            return true;
          }
        };
      });
      var Te = V((dp, $t) => {
        var fa = ke();
        $t.exports = !fa(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      });
      var Sr = V((vp, Vt) => {
        var pa = ke();
        Vt.exports = !pa(function() {
          var e = function() {
          }.bind();
          return typeof e != "function" || e.hasOwnProperty("prototype");
        });
      });
      var tr = V((mp, Gt) => {
        var ha = Sr(), rr = Function.prototype.call;
        Gt.exports = ha ? rr.bind(rr) : function() {
          return rr.apply(rr, arguments);
        };
      });
      var Qt = V((Kt) => {
        "use strict";
        var Ht = {}.propertyIsEnumerable, Jt = Object.getOwnPropertyDescriptor, da = Jt && !Ht.call({ 1: 2 }, 1);
        Kt.f = da ? function(n) {
          var i = Jt(this, n);
          return !!i && i.enumerable;
        } : Ht;
      });
      var Or = V((yp, Yt) => {
        Yt.exports = function(e, n) {
          return { enumerable: !(e & 1), configurable: !(e & 2), writable: !(e & 4), value: n };
        };
      });
      var de = V((wp, en) => {
        var Xt = Sr(), Zt = Function.prototype, va = Zt.bind, Tr = Zt.call, ma = Xt && va.bind(Tr, Tr);
        en.exports = Xt ? function(e) {
          return e && ma(e);
        } : function(e) {
          return e && function() {
            return Tr.apply(e, arguments);
          };
        };
      });
      var nn = V((_p, tn) => {
        var rn = de(), ga = rn({}.toString), ya = rn("".slice);
        tn.exports = function(e) {
          return ya(ga(e), 8, -1);
        };
      });
      var on = V((bp, sn) => {
        var wa = ee(), _a = de(), ba = ke(), xa = nn(), Er = wa.Object, ka = _a("".split);
        sn.exports = ba(function() {
          return !Er("z").propertyIsEnumerable(0);
        }) ? function(e) {
          return xa(e) == "String" ? ka(e, "") : Er(e);
        } : Er;
      });
      var qr = V((xp, an) => {
        var Sa = ee(), Oa = Sa.TypeError;
        an.exports = function(e) {
          if (e == null) throw Oa("Can't call method on " + e);
          return e;
        };
      });
      var nr = V((kp, un) => {
        var Ta = on(), Ea = qr();
        un.exports = function(e) {
          return Ta(Ea(e));
        };
      });
      var ve = V((Sp, cn) => {
        cn.exports = function(e) {
          return typeof e == "function";
        };
      });
      var Me = V((Op, ln) => {
        var qa = ve();
        ln.exports = function(e) {
          return typeof e == "object" ? e !== null : qa(e);
        };
      });
      var ir = V((Tp, fn) => {
        var Ar = ee(), Aa = ve(), Pa = function(e) {
          return Aa(e) ? e : void 0;
        };
        fn.exports = function(e, n) {
          return arguments.length < 2 ? Pa(Ar[e]) : Ar[e] && Ar[e][n];
        };
      });
      var hn = V((Ep, pn) => {
        var Ra = de();
        pn.exports = Ra({}.isPrototypeOf);
      });
      var vn = V((qp, dn) => {
        var Ia = ir();
        dn.exports = Ia("navigator", "userAgent") || "";
      });
      var xn = V((Ap, bn) => {
        var _n = ee(), Pr = vn(), mn = _n.process, gn = _n.Deno, yn = mn && mn.versions || gn && gn.version, wn = yn && yn.v8, he, sr;
        wn && (he = wn.split("."), sr = he[0] > 0 && he[0] < 4 ? 1 : +(he[0] + he[1]));
        !sr && Pr && (he = Pr.match(/Edge\/(\d+)/), (!he || he[1] >= 74) && (he = Pr.match(/Chrome\/(\d+)/), he && (sr = +he[1])));
        bn.exports = sr;
      });
      var Rr = V((Pp, Sn) => {
        var kn = xn(), Ca = ke();
        Sn.exports = !!Object.getOwnPropertySymbols && !Ca(function() {
          var e = Symbol();
          return !String(e) || !(Object(e) instanceof Symbol) || !Symbol.sham && kn && kn < 41;
        });
      });
      var Ir = V((Rp, On) => {
        var Na = Rr();
        On.exports = Na && !Symbol.sham && typeof Symbol.iterator == "symbol";
      });
      var Cr = V((Ip, Tn) => {
        var ja = ee(), Ma = ir(), Da = ve(), La = hn(), za = Ir(), Ba = ja.Object;
        Tn.exports = za ? function(e) {
          return typeof e == "symbol";
        } : function(e) {
          var n = Ma("Symbol");
          return Da(n) && La(n.prototype, Ba(e));
        };
      });
      var qn = V((Cp, En) => {
        var Fa = ee(), Ua = Fa.String;
        En.exports = function(e) {
          try {
            return Ua(e);
          } catch {
            return "Object";
          }
        };
      });
      var Pn = V((Np, An) => {
        var Wa = ee(), $a = ve(), Va = qn(), Ga = Wa.TypeError;
        An.exports = function(e) {
          if ($a(e)) return e;
          throw Ga(Va(e) + " is not a function");
        };
      });
      var In = V((jp, Rn) => {
        var Ha = Pn();
        Rn.exports = function(e, n) {
          var i = e[n];
          return i == null ? void 0 : Ha(i);
        };
      });
      var Nn = V((Mp, Cn) => {
        var Ja = ee(), Nr = tr(), jr = ve(), Mr = Me(), Ka = Ja.TypeError;
        Cn.exports = function(e, n) {
          var i, a;
          if (n === "string" && jr(i = e.toString) && !Mr(a = Nr(i, e)) || jr(i = e.valueOf) && !Mr(a = Nr(i, e)) || n !== "string" && jr(i = e.toString) && !Mr(a = Nr(i, e))) return a;
          throw Ka("Can't convert object to primitive value");
        };
      });
      var Mn = V((Dp, jn) => {
        jn.exports = false;
      });
      var or = V((Lp, Ln) => {
        var Dn = ee(), Qa = Object.defineProperty;
        Ln.exports = function(e, n) {
          try {
            Qa(Dn, e, { value: n, configurable: true, writable: true });
          } catch {
            Dn[e] = n;
          }
          return n;
        };
      });
      var ar = V((zp, Bn) => {
        var Ya = ee(), Xa = or(), zn = "__core-js_shared__", Za = Ya[zn] || Xa(zn, {});
        Bn.exports = Za;
      });
      var Dr = V((Bp, Un) => {
        var eu = Mn(), Fn = ar();
        (Un.exports = function(e, n) {
          return Fn[e] || (Fn[e] = n !== void 0 ? n : {});
        })("versions", []).push({ version: "3.22.2", mode: eu ? "pure" : "global", copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)", license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE", source: "https://github.com/zloirock/core-js" });
      });
      var $n = V((Fp, Wn) => {
        var ru = ee(), tu = qr(), nu = ru.Object;
        Wn.exports = function(e) {
          return nu(tu(e));
        };
      });
      var Se = V((Up, Vn) => {
        var iu = de(), su = $n(), ou = iu({}.hasOwnProperty);
        Vn.exports = Object.hasOwn || function(n, i) {
          return ou(su(n), i);
        };
      });
      var Lr = V((Wp, Gn) => {
        var au = de(), uu = 0, cu = Math.random(), lu = au(1 .toString);
        Gn.exports = function(e) {
          return "Symbol(" + (e === void 0 ? "" : e) + ")_" + lu(++uu + cu, 36);
        };
      });
      var Xn = V(($p, Yn) => {
        var fu = ee(), pu = Dr(), Hn = Se(), hu = Lr(), Jn = Rr(), Qn = Ir(), De = pu("wks"), Ee = fu.Symbol, Kn = Ee && Ee.for, du = Qn ? Ee : Ee && Ee.withoutSetter || hu;
        Yn.exports = function(e) {
          if (!Hn(De, e) || !(Jn || typeof De[e] == "string")) {
            var n = "Symbol." + e;
            Jn && Hn(Ee, e) ? De[e] = Ee[e] : Qn && Kn ? De[e] = Kn(n) : De[e] = du(n);
          }
          return De[e];
        };
      });
      var ti = V((Vp, ri) => {
        var vu = ee(), mu = tr(), Zn = Me(), ei = Cr(), gu = In(), yu = Nn(), wu = Xn(), _u = vu.TypeError, bu = wu("toPrimitive");
        ri.exports = function(e, n) {
          if (!Zn(e) || ei(e)) return e;
          var i = gu(e, bu), a;
          if (i) {
            if (n === void 0 && (n = "default"), a = mu(i, e, n), !Zn(a) || ei(a)) return a;
            throw _u("Can't convert object to primitive value");
          }
          return n === void 0 && (n = "number"), yu(e, n);
        };
      });
      var zr = V((Gp, ni) => {
        var xu = ti(), ku = Cr();
        ni.exports = function(e) {
          var n = xu(e, "string");
          return ku(n) ? n : n + "";
        };
      });
      var oi = V((Hp, si) => {
        var Su = ee(), ii = Me(), Br = Su.document, Ou = ii(Br) && ii(Br.createElement);
        si.exports = function(e) {
          return Ou ? Br.createElement(e) : {};
        };
      });
      var Fr = V((Jp, ai) => {
        var Tu = Te(), Eu = ke(), qu = oi();
        ai.exports = !Tu && !Eu(function() {
          return Object.defineProperty(qu("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      });
      var Ur = V((ci) => {
        var Au = Te(), Pu = tr(), Ru = Qt(), Iu = Or(), Cu = nr(), Nu = zr(), ju = Se(), Mu = Fr(), ui = Object.getOwnPropertyDescriptor;
        ci.f = Au ? ui : function(n, i) {
          if (n = Cu(n), i = Nu(i), Mu) try {
            return ui(n, i);
          } catch {
          }
          if (ju(n, i)) return Iu(!Pu(Ru.f, n, i), n[i]);
        };
      });
      var fi = V((Qp, li) => {
        var Du = Te(), Lu = ke();
        li.exports = Du && Lu(function() {
          return Object.defineProperty(function() {
          }, "prototype", { value: 42, writable: false }).prototype != 42;
        });
      });
      var Wr = V((Yp, hi) => {
        var pi = ee(), zu = Me(), Bu = pi.String, Fu = pi.TypeError;
        hi.exports = function(e) {
          if (zu(e)) return e;
          throw Fu(Bu(e) + " is not an object");
        };
      });
      var Jr = V((vi) => {
        var Uu = ee(), Wu = Te(), $u = Fr(), Vu = fi(), ur = Wr(), di = zr(), Gu = Uu.TypeError, $r = Object.defineProperty, Hu = Object.getOwnPropertyDescriptor, Vr = "enumerable", Gr = "configurable", Hr = "writable";
        vi.f = Wu ? Vu ? function(n, i, a) {
          if (ur(n), i = di(i), ur(a), typeof n == "function" && i === "prototype" && "value" in a && Hr in a && !a[Hr]) {
            var o = Hu(n, i);
            o && o[Hr] && (n[i] = a.value, a = { configurable: Gr in a ? a[Gr] : o[Gr], enumerable: Vr in a ? a[Vr] : o[Vr], writable: false });
          }
          return $r(n, i, a);
        } : $r : function(n, i, a) {
          if (ur(n), i = di(i), ur(a), $u) try {
            return $r(n, i, a);
          } catch {
          }
          if ("get" in a || "set" in a) throw Gu("Accessors not supported");
          return "value" in a && (n[i] = a.value), n;
        };
      });
      var cr = V((Zp, mi) => {
        var Ju = Te(), Ku = Jr(), Qu = Or();
        mi.exports = Ju ? function(e, n, i) {
          return Ku.f(e, n, Qu(1, i));
        } : function(e, n, i) {
          return e[n] = i, e;
        };
      });
      var Qr = V((eh, gi) => {
        var Yu = de(), Xu = ve(), Kr = ar(), Zu = Yu(Function.toString);
        Xu(Kr.inspectSource) || (Kr.inspectSource = function(e) {
          return Zu(e);
        });
        gi.exports = Kr.inspectSource;
      });
      var _i = V((rh, wi) => {
        var ec = ee(), rc = ve(), tc = Qr(), yi = ec.WeakMap;
        wi.exports = rc(yi) && /native code/.test(tc(yi));
      });
      var ki = V((th, xi) => {
        var nc = Dr(), ic = Lr(), bi = nc("keys");
        xi.exports = function(e) {
          return bi[e] || (bi[e] = ic(e));
        };
      });
      var Yr = V((nh, Si) => {
        Si.exports = {};
      });
      var Pi = V((ih, Ai) => {
        var sc = _i(), qi = ee(), Xr = de(), oc = Me(), ac = cr(), Zr = Se(), et = ar(), uc = ki(), cc = Yr(), Oi = "Object already initialized", tt = qi.TypeError, lc = qi.WeakMap, lr, Fe, fr, fc = function(e) {
          return fr(e) ? Fe(e) : lr(e, {});
        }, pc = function(e) {
          return function(n) {
            var i;
            if (!oc(n) || (i = Fe(n)).type !== e) throw tt("Incompatible receiver, " + e + " required");
            return i;
          };
        };
        sc || et.state ? (Oe = et.state || (et.state = new lc()), Ti = Xr(Oe.get), rt = Xr(Oe.has), Ei = Xr(Oe.set), lr = function(e, n) {
          if (rt(Oe, e)) throw new tt(Oi);
          return n.facade = e, Ei(Oe, e, n), n;
        }, Fe = function(e) {
          return Ti(Oe, e) || {};
        }, fr = function(e) {
          return rt(Oe, e);
        }) : (qe = uc("state"), cc[qe] = true, lr = function(e, n) {
          if (Zr(e, qe)) throw new tt(Oi);
          return n.facade = e, ac(e, qe, n), n;
        }, Fe = function(e) {
          return Zr(e, qe) ? e[qe] : {};
        }, fr = function(e) {
          return Zr(e, qe);
        });
        var Oe, Ti, rt, Ei, qe;
        Ai.exports = { set: lr, get: Fe, has: fr, enforce: fc, getterFor: pc };
      });
      var Ci = V((sh, Ii) => {
        var nt = Te(), hc = Se(), Ri = Function.prototype, dc = nt && Object.getOwnPropertyDescriptor, it = hc(Ri, "name"), vc = it && function() {
        }.name === "something", mc = it && (!nt || nt && dc(Ri, "name").configurable);
        Ii.exports = { EXISTS: it, PROPER: vc, CONFIGURABLE: mc };
      });
      var Li = V((oh, Di) => {
        var gc = ee(), Ni = ve(), yc = Se(), ji = cr(), wc = or(), _c = Qr(), Mi = Pi(), bc = Ci().CONFIGURABLE, xc = Mi.get, kc = Mi.enforce, Sc = String(String).split("String");
        (Di.exports = function(e, n, i, a) {
          var o = a ? !!a.unsafe : false, f = a ? !!a.enumerable : false, p = a ? !!a.noTargetGet : false, h = a && a.name !== void 0 ? a.name : n, g;
          if (Ni(i) && (String(h).slice(0, 7) === "Symbol(" && (h = "[" + String(h).replace(/^Symbol\(([^)]*)\)/, "$1") + "]"), (!yc(i, "name") || bc && i.name !== h) && ji(i, "name", h), g = kc(i), g.source || (g.source = Sc.join(typeof h == "string" ? h : ""))), e === gc) {
            f ? e[n] = i : wc(n, i);
            return;
          } else o ? !p && e[n] && (f = true) : delete e[n];
          f ? e[n] = i : ji(e, n, i);
        })(Function.prototype, "toString", function() {
          return Ni(this) && xc(this).source || _c(this);
        });
      });
      var st = V((ah, zi) => {
        var Oc = Math.ceil, Tc = Math.floor;
        zi.exports = function(e) {
          var n = +e;
          return n !== n || n === 0 ? 0 : (n > 0 ? Tc : Oc)(n);
        };
      });
      var Fi = V((uh, Bi) => {
        var Ec = st(), qc = Math.max, Ac = Math.min;
        Bi.exports = function(e, n) {
          var i = Ec(e);
          return i < 0 ? qc(i + n, 0) : Ac(i, n);
        };
      });
      var Wi = V((ch, Ui) => {
        var Pc = st(), Rc = Math.min;
        Ui.exports = function(e) {
          return e > 0 ? Rc(Pc(e), 9007199254740991) : 0;
        };
      });
      var Vi = V((lh, $i) => {
        var Ic = Wi();
        $i.exports = function(e) {
          return Ic(e.length);
        };
      });
      var Ji = V((fh, Hi) => {
        var Cc = nr(), Nc = Fi(), jc = Vi(), Gi = function(e) {
          return function(n, i, a) {
            var o = Cc(n), f = jc(o), p = Nc(a, f), h;
            if (e && i != i) {
              for (; f > p; ) if (h = o[p++], h != h) return true;
            } else for (; f > p; p++) if ((e || p in o) && o[p] === i) return e || p || 0;
            return !e && -1;
          };
        };
        Hi.exports = { includes: Gi(true), indexOf: Gi(false) };
      });
      var Yi = V((ph, Qi) => {
        var Mc = de(), ot = Se(), Dc = nr(), Lc = Ji().indexOf, zc = Yr(), Ki = Mc([].push);
        Qi.exports = function(e, n) {
          var i = Dc(e), a = 0, o = [], f;
          for (f in i) !ot(zc, f) && ot(i, f) && Ki(o, f);
          for (; n.length > a; ) ot(i, f = n[a++]) && (~Lc(o, f) || Ki(o, f));
          return o;
        };
      });
      var Zi = V((hh, Xi) => {
        Xi.exports = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
      });
      var rs = V((es) => {
        var Bc = Yi(), Fc = Zi(), Uc = Fc.concat("length", "prototype");
        es.f = Object.getOwnPropertyNames || function(n) {
          return Bc(n, Uc);
        };
      });
      var ns = V((ts) => {
        ts.f = Object.getOwnPropertySymbols;
      });
      var ss = V((mh, is) => {
        var Wc = ir(), $c = de(), Vc = rs(), Gc = ns(), Hc = Wr(), Jc = $c([].concat);
        is.exports = Wc("Reflect", "ownKeys") || function(n) {
          var i = Vc.f(Hc(n)), a = Gc.f;
          return a ? Jc(i, a(n)) : i;
        };
      });
      var us = V((gh, as) => {
        var os = Se(), Kc = ss(), Qc = Ur(), Yc = Jr();
        as.exports = function(e, n, i) {
          for (var a = Kc(n), o = Yc.f, f = Qc.f, p = 0; p < a.length; p++) {
            var h = a[p];
            !os(e, h) && !(i && os(i, h)) && o(e, h, f(n, h));
          }
        };
      });
      var ls = V((yh, cs) => {
        var Xc = ke(), Zc = ve(), el = /#|\.prototype\./, Ue = function(e, n) {
          var i = tl[rl(e)];
          return i == il ? true : i == nl ? false : Zc(n) ? Xc(n) : !!n;
        }, rl = Ue.normalize = function(e) {
          return String(e).replace(el, ".").toLowerCase();
        }, tl = Ue.data = {}, nl = Ue.NATIVE = "N", il = Ue.POLYFILL = "P";
        cs.exports = Ue;
      });
      var ps = V((wh, fs) => {
        var at = ee(), sl = Ur().f, ol = cr(), al = Li(), ul = or(), cl = us(), ll = ls();
        fs.exports = function(e, n) {
          var i = e.target, a = e.global, o = e.stat, f, p, h, g, c, t;
          if (a ? p = at : o ? p = at[i] || ul(i, {}) : p = (at[i] || {}).prototype, p) for (h in n) {
            if (c = n[h], e.noTargetGet ? (t = sl(p, h), g = t && t.value) : g = p[h], f = ll(a ? h : i + (o ? "." : "#") + h, e.forced), !f && g !== void 0) {
              if (typeof c == typeof g) continue;
              cl(c, g);
            }
            (e.sham || g && g.sham) && ol(c, "sham", true), al(p, h, c, e);
          }
        };
      });
      var hs = V(() => {
        var fl = ps(), pl = ee();
        fl({ global: true }, { globalThis: pl });
      });
      var ds = V(() => {
        hs();
      });
      var lp = V((Ph, la) => {
        ds();
        var kt = Object.defineProperty, hl = Object.getOwnPropertyDescriptor, St = Object.getOwnPropertyNames, dl = Object.prototype.hasOwnProperty, Le = (e, n) => function() {
          return e && (n = (0, e[St(e)[0]])(e = 0)), n;
        }, R = (e, n) => function() {
          return n || (0, e[St(e)[0]])((n = { exports: {} }).exports, n), n.exports;
        }, Ot = (e, n) => {
          for (var i in n) kt(e, i, { get: n[i], enumerable: true });
        }, vl = (e, n, i, a) => {
          if (n && typeof n == "object" || typeof n == "function") for (let o of St(n)) !dl.call(e, o) && o !== i && kt(e, o, { get: () => n[o], enumerable: !(a = hl(n, o)) || a.enumerable });
          return e;
        }, Tt = (e) => vl(kt({}, "__esModule", { value: true }), e), A = Le({ "<define:process>"() {
        } }), ml = R({ "src/common/parser-create-error.js"(e, n) {
          "use strict";
          A();
          function i(a, o) {
            let f = new SyntaxError(a + " (" + o.start.line + ":" + o.start.column + ")");
            return f.loc = o, f;
          }
          n.exports = i;
        } }), Cs = R({ "src/utils/get-last.js"(e, n) {
          "use strict";
          A();
          var i = (a) => a[a.length - 1];
          n.exports = i;
        } }), Ns = R({ "src/utils/front-matter/parse.js"(e, n) {
          "use strict";
          A();
          var i = new RegExp("^(?<startDelimiter>-{3}|\\+{3})(?<language>[^\\n]*)\\n(?:|(?<value>.*?)\\n)(?<endDelimiter>\\k<startDelimiter>|\\.{3})[^\\S\\n]*(?:\\n|$)", "s");
          function a(o) {
            let f = o.match(i);
            if (!f) return { content: o };
            let { startDelimiter: p, language: h, value: g = "", endDelimiter: c } = f.groups, t = h.trim() || "yaml";
            if (p === "+++" && (t = "toml"), t !== "yaml" && p !== c) return { content: o };
            let [r] = f;
            return { frontMatter: { type: "front-matter", lang: t, value: g, startDelimiter: p, endDelimiter: c, raw: r.replace(/\n$/, "") }, content: r.replace(/[^\n]/g, " ") + o.slice(r.length) };
          }
          n.exports = a;
        } }), js = {};
        Ot(js, { EOL: () => gt, arch: () => gl, cpus: () => Us, default: () => Hs, endianness: () => Ms, freemem: () => Bs, getNetworkInterfaces: () => Gs, hostname: () => Ds, loadavg: () => Ls, networkInterfaces: () => Vs, platform: () => yl, release: () => $s, tmpDir: () => vt, tmpdir: () => mt, totalmem: () => Fs, type: () => Ws, uptime: () => zs });
        function Ms() {
          if (typeof pr > "u") {
            var e = new ArrayBuffer(2), n = new Uint8Array(e), i = new Uint16Array(e);
            if (n[0] = 1, n[1] = 2, i[0] === 258) pr = "BE";
            else if (i[0] === 513) pr = "LE";
            else throw new Error("unable to figure out endianess");
          }
          return pr;
        }
        function Ds() {
          return typeof globalThis.location < "u" ? globalThis.location.hostname : "";
        }
        function Ls() {
          return [];
        }
        function zs() {
          return 0;
        }
        function Bs() {
          return Number.MAX_VALUE;
        }
        function Fs() {
          return Number.MAX_VALUE;
        }
        function Us() {
          return [];
        }
        function Ws() {
          return "Browser";
        }
        function $s() {
          return typeof globalThis.navigator < "u" ? globalThis.navigator.appVersion : "";
        }
        function Vs() {
        }
        function Gs() {
        }
        function gl() {
          return "javascript";
        }
        function yl() {
          return "browser";
        }
        function vt() {
          return "/tmp";
        }
        var pr, mt, gt, Hs, wl = Le({ "node-modules-polyfills:os"() {
          A(), mt = vt, gt = `
`, Hs = { EOL: gt, tmpdir: mt, tmpDir: vt, networkInterfaces: Vs, getNetworkInterfaces: Gs, release: $s, type: Ws, cpus: Us, totalmem: Fs, freemem: Bs, uptime: zs, loadavg: Ls, hostname: Ds, endianness: Ms };
        } }), _l = R({ "node-modules-polyfills-commonjs:os"(e, n) {
          A();
          var i = (wl(), Tt(js));
          if (i && i.default) {
            n.exports = i.default;
            for (let a in i) n.exports[a] = i[a];
          } else i && (n.exports = i);
        } }), bl = R({ "node_modules/detect-newline/index.js"(e, n) {
          "use strict";
          A();
          var i = (a) => {
            if (typeof a != "string") throw new TypeError("Expected a string");
            let o = a.match(/(?:\r?\n)/g) || [];
            if (o.length === 0) return;
            let f = o.filter((h) => h === `\r
`).length, p = o.length - f;
            return f > p ? `\r
` : `
`;
          };
          n.exports = i, n.exports.graceful = (a) => typeof a == "string" && i(a) || `
`;
        } }), xl = R({ "node_modules/jest-docblock/build/index.js"(e) {
          "use strict";
          A(), Object.defineProperty(e, "__esModule", { value: true }), e.extract = s, e.parse = m, e.parseWithComments = v, e.print = y, e.strip = l;
          function n() {
            let d = _l();
            return n = function() {
              return d;
            }, d;
          }
          function i() {
            let d = a(bl());
            return i = function() {
              return d;
            }, d;
          }
          function a(d) {
            return d && d.__esModule ? d : { default: d };
          }
          var o = /\*\/$/, f = /^\/\*\*/, p = /^\s*(\/\*\*?(.|\r?\n)*?\*\/)/, h = /(^|\s+)\/\/([^\r\n]*)/g, g = /^(\r?\n)+/, c = /(?:^|\r?\n) *(@[^\r\n]*?) *\r?\n *(?![^@\r\n]*\/\/[^]*)([^@\r\n\s][^@\r\n]+?) *\r?\n/g, t = /(?:^|\r?\n) *@(\S+) *([^\r\n]*)/g, r = /(\r?\n|^) *\* ?/g, u = [];
          function s(d) {
            let _ = d.match(p);
            return _ ? _[0].trimLeft() : "";
          }
          function l(d) {
            let _ = d.match(p);
            return _ && _[0] ? d.substring(_[0].length) : d;
          }
          function m(d) {
            return v(d).pragmas;
          }
          function v(d) {
            let _ = (0, i().default)(d) || n().EOL;
            d = d.replace(f, "").replace(o, "").replace(r, "$1");
            let S = "";
            for (; S !== d; ) S = d, d = d.replace(c, "".concat(_, "$1 $2").concat(_));
            d = d.replace(g, "").trimRight();
            let x = /* @__PURE__ */ Object.create(null), N = d.replace(t, "").replace(g, "").trimRight(), P;
            for (; P = t.exec(d); ) {
              let W = P[2].replace(h, "");
              typeof x[P[1]] == "string" || Array.isArray(x[P[1]]) ? x[P[1]] = u.concat(x[P[1]], W) : x[P[1]] = W;
            }
            return { comments: N, pragmas: x };
          }
          function y(d) {
            let { comments: _ = "", pragmas: S = {} } = d, x = (0, i().default)(_) || n().EOL, N = "/**", P = " *", W = " */", U = Object.keys(S), H = U.map(($) => w($, S[$])).reduce(($, B) => $.concat(B), []).map(($) => P + " " + $ + x).join("");
            if (!_) {
              if (U.length === 0) return "";
              if (U.length === 1 && !Array.isArray(S[U[0]])) {
                let $ = S[U[0]];
                return "".concat(N, " ").concat(w(U[0], $)[0]).concat(W);
              }
            }
            let D = _.split(x).map(($) => "".concat(P, " ").concat($)).join(x) + x;
            return N + x + (_ ? D : "") + (_ && U.length ? P + x : "") + H + W;
          }
          function w(d, _) {
            return u.concat(_).map((S) => "@".concat(d, " ").concat(S).trim());
          }
        } }), kl = R({ "src/common/end-of-line.js"(e, n) {
          "use strict";
          A();
          function i(p) {
            let h = p.indexOf("\r");
            return h >= 0 ? p.charAt(h + 1) === `
` ? "crlf" : "cr" : "lf";
          }
          function a(p) {
            switch (p) {
              case "cr":
                return "\r";
              case "crlf":
                return `\r
`;
              default:
                return `
`;
            }
          }
          function o(p, h) {
            let g;
            switch (h) {
              case `
`:
                g = /\n/g;
                break;
              case "\r":
                g = /\r/g;
                break;
              case `\r
`:
                g = /\r\n/g;
                break;
              default:
                throw new Error('Unexpected "eol" '.concat(JSON.stringify(h), "."));
            }
            let c = p.match(g);
            return c ? c.length : 0;
          }
          function f(p) {
            return p.replace(/\r\n?/g, `
`);
          }
          n.exports = { guessEndOfLine: i, convertEndOfLineToChars: a, countEndOfLineChars: o, normalizeEndOfLine: f };
        } }), Sl = R({ "src/language-js/utils/get-shebang.js"(e, n) {
          "use strict";
          A();
          function i(a) {
            if (!a.startsWith("#!")) return "";
            let o = a.indexOf(`
`);
            return o === -1 ? a : a.slice(0, o);
          }
          n.exports = i;
        } }), Ol = R({ "src/language-js/pragma.js"(e, n) {
          "use strict";
          A();
          var { parseWithComments: i, strip: a, extract: o, print: f } = xl(), { normalizeEndOfLine: p } = kl(), h = Sl();
          function g(r) {
            let u = h(r);
            u && (r = r.slice(u.length + 1));
            let s = o(r), { pragmas: l, comments: m } = i(s);
            return { shebang: u, text: r, pragmas: l, comments: m };
          }
          function c(r) {
            let u = Object.keys(g(r).pragmas);
            return u.includes("prettier") || u.includes("format");
          }
          function t(r) {
            let { shebang: u, text: s, pragmas: l, comments: m } = g(r), v = a(s), y = f({ pragmas: Object.assign({ format: "" }, l), comments: m.trimStart() });
            return (u ? "".concat(u, `
`) : "") + p(y) + (v.startsWith(`
`) ? `
` : `

`) + v;
          }
          n.exports = { hasPragma: c, insertPragma: t };
        } }), Tl = R({ "src/language-css/pragma.js"(e, n) {
          "use strict";
          A();
          var i = Ol(), a = Ns();
          function o(p) {
            return i.hasPragma(a(p).content);
          }
          function f(p) {
            let { frontMatter: h, content: g } = a(p);
            return (h ? h.raw + `

` : "") + i.insertPragma(g);
          }
          n.exports = { hasPragma: o, insertPragma: f };
        } }), El = R({ "src/utils/text/skip.js"(e, n) {
          "use strict";
          A();
          function i(h) {
            return (g, c, t) => {
              let r = t && t.backwards;
              if (c === false) return false;
              let { length: u } = g, s = c;
              for (; s >= 0 && s < u; ) {
                let l = g.charAt(s);
                if (h instanceof RegExp) {
                  if (!h.test(l)) return s;
                } else if (!h.includes(l)) return s;
                r ? s-- : s++;
              }
              return s === -1 || s === u ? s : false;
            };
          }
          var a = i(/\s/), o = i(" 	"), f = i(",; 	"), p = i(/[^\n\r]/);
          n.exports = { skipWhitespace: a, skipSpaces: o, skipToLineEnd: f, skipEverythingButNewLine: p };
        } }), ql = R({ "src/utils/line-column-to-index.js"(e, n) {
          "use strict";
          A(), n.exports = function(i, a) {
            let o = 0;
            for (let f = 0; f < i.line - 1; ++f) o = a.indexOf(`
`, o) + 1;
            return o + i.column;
          };
        } }), Js = R({ "src/language-css/loc.js"(e, n) {
          "use strict";
          A();
          var { skipEverythingButNewLine: i } = El(), a = Cs(), o = ql();
          function f(s, l) {
            return typeof s.sourceIndex == "number" ? s.sourceIndex : s.source ? o(s.source.start, l) - 1 : null;
          }
          function p(s, l) {
            if (s.type === "css-comment" && s.inline) return i(l, s.source.startOffset);
            let m = s.nodes && a(s.nodes);
            return m && s.source && !s.source.end && (s = m), s.source && s.source.end ? o(s.source.end, l) : null;
          }
          function h(s, l) {
            s.source && (s.source.startOffset = f(s, l), s.source.endOffset = p(s, l));
            for (let m in s) {
              let v = s[m];
              m === "source" || !v || typeof v != "object" || (v.type === "value-root" || v.type === "value-unknown" ? g(v, c(s), v.text || v.value) : h(v, l));
            }
          }
          function g(s, l, m) {
            s.source && (s.source.startOffset = f(s, m) + l, s.source.endOffset = p(s, m) + l);
            for (let v in s) {
              let y = s[v];
              v === "source" || !y || typeof y != "object" || g(y, l, m);
            }
          }
          function c(s) {
            let l = s.source.startOffset;
            return typeof s.prop == "string" && (l += s.prop.length), s.type === "css-atrule" && typeof s.name == "string" && (l += 1 + s.name.length + s.raws.afterName.match(/^\s*:?\s*/)[0].length), s.type !== "css-atrule" && s.raws && typeof s.raws.between == "string" && (l += s.raws.between.length), l;
          }
          function t(s) {
            let l = "initial", m = "initial", v, y = false, w = [];
            for (let d = 0; d < s.length; d++) {
              let _ = s[d];
              switch (l) {
                case "initial":
                  if (_ === "'") {
                    l = "single-quotes";
                    continue;
                  }
                  if (_ === '"') {
                    l = "double-quotes";
                    continue;
                  }
                  if ((_ === "u" || _ === "U") && s.slice(d, d + 4).toLowerCase() === "url(") {
                    l = "url", d += 3;
                    continue;
                  }
                  if (_ === "*" && s[d - 1] === "/") {
                    l = "comment-block";
                    continue;
                  }
                  if (_ === "/" && s[d - 1] === "/") {
                    l = "comment-inline", v = d - 1;
                    continue;
                  }
                  continue;
                case "single-quotes":
                  if (_ === "'" && s[d - 1] !== "\\" && (l = m, m = "initial"), _ === `
` || _ === "\r") return s;
                  continue;
                case "double-quotes":
                  if (_ === '"' && s[d - 1] !== "\\" && (l = m, m = "initial"), _ === `
` || _ === "\r") return s;
                  continue;
                case "url":
                  if (_ === ")" && (l = "initial"), _ === `
` || _ === "\r") return s;
                  if (_ === "'") {
                    l = "single-quotes", m = "url";
                    continue;
                  }
                  if (_ === '"') {
                    l = "double-quotes", m = "url";
                    continue;
                  }
                  continue;
                case "comment-block":
                  _ === "/" && s[d - 1] === "*" && (l = "initial");
                  continue;
                case "comment-inline":
                  (_ === '"' || _ === "'" || _ === "*") && (y = true), (_ === `
` || _ === "\r") && (y && w.push([v, d]), l = "initial", y = false);
                  continue;
              }
            }
            for (let [d, _] of w) s = s.slice(0, d) + s.slice(d, _).replace(/["'*]/g, " ") + s.slice(_);
            return s;
          }
          function r(s) {
            return s.source.startOffset;
          }
          function u(s) {
            return s.source.endOffset;
          }
          n.exports = { locStart: r, locEnd: u, calculateLoc: h, replaceQuotesInInlineComments: t };
        } }), Al = R({ "src/utils/is-non-empty-array.js"(e, n) {
          "use strict";
          A();
          function i(a) {
            return Array.isArray(a) && a.length > 0;
          }
          n.exports = i;
        } }), Pl = R({ "src/language-css/utils/has-scss-interpolation.js"(e, n) {
          "use strict";
          A();
          var i = Al();
          function a(o) {
            if (i(o)) {
              for (let f = o.length - 1; f > 0; f--) if (o[f].type === "word" && o[f].value === "{" && o[f - 1].type === "word" && o[f - 1].value.endsWith("#")) return true;
            }
            return false;
          }
          n.exports = a;
        } }), Rl = R({ "src/language-css/utils/has-string-or-function.js"(e, n) {
          "use strict";
          A();
          function i(a) {
            return a.some((o) => o.type === "string" || o.type === "func");
          }
          n.exports = i;
        } }), Il = R({ "src/language-css/utils/is-less-parser.js"(e, n) {
          "use strict";
          A();
          function i(a) {
            return a.parser === "css" || a.parser === "less";
          }
          n.exports = i;
        } }), Cl = R({ "src/language-css/utils/is-scss.js"(e, n) {
          "use strict";
          A();
          function i(a, o) {
            return a === "less" || a === "scss" ? a === "scss" : /(?:\w\s*:\s*[^:}]+|#){|@import[^\n]+(?:url|,)/.test(o);
          }
          n.exports = i;
        } }), Nl = R({ "src/language-css/utils/is-scss-nested-property-node.js"(e, n) {
          "use strict";
          A();
          function i(a) {
            return a.selector ? a.selector.replace(/\/\*.*?\*\//, "").replace(/\/\/.*\n/, "").trim().endsWith(":") : false;
          }
          n.exports = i;
        } }), jl = R({ "src/language-css/utils/is-scss-variable.js"(e, n) {
          "use strict";
          A();
          function i(a) {
            return Boolean((a == null ? void 0 : a.type) === "word" && a.value.startsWith("$"));
          }
          n.exports = i;
        } }), Ml = R({ "src/language-css/utils/stringify-node.js"(e, n) {
          "use strict";
          A();
          function i(a) {
            var o, f, p;
            if (a.groups) {
              var h, g, c;
              let y = ((h = a.open) === null || h === void 0 ? void 0 : h.value) || "", w = a.groups.map((_) => i(_)).join(((g = a.groups[0]) === null || g === void 0 ? void 0 : g.type) === "comma_group" ? "," : ""), d = ((c = a.close) === null || c === void 0 ? void 0 : c.value) || "";
              return y + w + d;
            }
            let t = ((o = a.raws) === null || o === void 0 ? void 0 : o.before) || "", r = ((f = a.raws) === null || f === void 0 ? void 0 : f.quote) || "", u = a.type === "atword" ? "@" : "", s = a.value || "", l = a.unit || "", m = a.group ? i(a.group) : "", v = ((p = a.raws) === null || p === void 0 ? void 0 : p.after) || "";
            return t + r + u + s + r + l + m + v;
          }
          n.exports = i;
        } }), Dl = R({ "src/language-css/utils/is-module-rule-name.js"(e, n) {
          "use strict";
          A();
          var i = /* @__PURE__ */ new Set(["import", "use", "forward"]);
          function a(o) {
            return i.has(o);
          }
          n.exports = a;
        } }), we = R({ "node_modules/postcss-values-parser/lib/node.js"(e, n) {
          "use strict";
          A();
          var i = function(a, o) {
            let f = new a.constructor();
            for (let p in a) {
              if (!a.hasOwnProperty(p)) continue;
              let h = a[p], g = typeof h;
              p === "parent" && g === "object" ? o && (f[p] = o) : p === "source" ? f[p] = h : h instanceof Array ? f[p] = h.map((c) => i(c, f)) : p !== "before" && p !== "after" && p !== "between" && p !== "semicolon" && (g === "object" && h !== null && (h = i(h)), f[p] = h);
            }
            return f;
          };
          n.exports = class {
            constructor(o) {
              o = o || {}, this.raws = { before: "", after: "" };
              for (let f in o) this[f] = o[f];
            }
            remove() {
              return this.parent && this.parent.removeChild(this), this.parent = void 0, this;
            }
            toString() {
              return [this.raws.before, String(this.value), this.raws.after].join("");
            }
            clone(o) {
              o = o || {};
              let f = i(this);
              for (let p in o) f[p] = o[p];
              return f;
            }
            cloneBefore(o) {
              o = o || {};
              let f = this.clone(o);
              return this.parent.insertBefore(this, f), f;
            }
            cloneAfter(o) {
              o = o || {};
              let f = this.clone(o);
              return this.parent.insertAfter(this, f), f;
            }
            replaceWith() {
              let o = Array.prototype.slice.call(arguments);
              if (this.parent) {
                for (let f of o) this.parent.insertBefore(this, f);
                this.remove();
              }
              return this;
            }
            moveTo(o) {
              return this.cleanRaws(this.root() === o.root()), this.remove(), o.append(this), this;
            }
            moveBefore(o) {
              return this.cleanRaws(this.root() === o.root()), this.remove(), o.parent.insertBefore(o, this), this;
            }
            moveAfter(o) {
              return this.cleanRaws(this.root() === o.root()), this.remove(), o.parent.insertAfter(o, this), this;
            }
            next() {
              let o = this.parent.index(this);
              return this.parent.nodes[o + 1];
            }
            prev() {
              let o = this.parent.index(this);
              return this.parent.nodes[o - 1];
            }
            toJSON() {
              let o = {};
              for (let f in this) {
                if (!this.hasOwnProperty(f) || f === "parent") continue;
                let p = this[f];
                p instanceof Array ? o[f] = p.map((h) => typeof h == "object" && h.toJSON ? h.toJSON() : h) : typeof p == "object" && p.toJSON ? o[f] = p.toJSON() : o[f] = p;
              }
              return o;
            }
            root() {
              let o = this;
              for (; o.parent; ) o = o.parent;
              return o;
            }
            cleanRaws(o) {
              delete this.raws.before, delete this.raws.after, o || delete this.raws.between;
            }
            positionInside(o) {
              let f = this.toString(), p = this.source.start.column, h = this.source.start.line;
              for (let g = 0; g < o; g++) f[g] === `
` ? (p = 1, h += 1) : p += 1;
              return { line: h, column: p };
            }
            positionBy(o) {
              let f = this.source.start;
              if (Object(o).index) f = this.positionInside(o.index);
              else if (Object(o).word) {
                let p = this.toString().indexOf(o.word);
                p !== -1 && (f = this.positionInside(p));
              }
              return f;
            }
          };
        } }), ue = R({ "node_modules/postcss-values-parser/lib/container.js"(e, n) {
          "use strict";
          A();
          var i = we(), a = class extends i {
            constructor(o) {
              super(o), this.nodes || (this.nodes = []);
            }
            push(o) {
              return o.parent = this, this.nodes.push(o), this;
            }
            each(o) {
              this.lastEach || (this.lastEach = 0), this.indexes || (this.indexes = {}), this.lastEach += 1;
              let f = this.lastEach, p, h;
              if (this.indexes[f] = 0, !!this.nodes) {
                for (; this.indexes[f] < this.nodes.length && (p = this.indexes[f], h = o(this.nodes[p], p), h !== false); ) this.indexes[f] += 1;
                return delete this.indexes[f], h;
              }
            }
            walk(o) {
              return this.each((f, p) => {
                let h = o(f, p);
                return h !== false && f.walk && (h = f.walk(o)), h;
              });
            }
            walkType(o, f) {
              if (!o || !f) throw new Error("Parameters {type} and {callback} are required.");
              let p = typeof o == "function";
              return this.walk((h, g) => {
                if (p && h instanceof o || !p && h.type === o) return f.call(this, h, g);
              });
            }
            append(o) {
              return o.parent = this, this.nodes.push(o), this;
            }
            prepend(o) {
              return o.parent = this, this.nodes.unshift(o), this;
            }
            cleanRaws(o) {
              if (super.cleanRaws(o), this.nodes) for (let f of this.nodes) f.cleanRaws(o);
            }
            insertAfter(o, f) {
              let p = this.index(o), h;
              this.nodes.splice(p + 1, 0, f);
              for (let g in this.indexes) h = this.indexes[g], p <= h && (this.indexes[g] = h + this.nodes.length);
              return this;
            }
            insertBefore(o, f) {
              let p = this.index(o), h;
              this.nodes.splice(p, 0, f);
              for (let g in this.indexes) h = this.indexes[g], p <= h && (this.indexes[g] = h + this.nodes.length);
              return this;
            }
            removeChild(o) {
              o = this.index(o), this.nodes[o].parent = void 0, this.nodes.splice(o, 1);
              let f;
              for (let p in this.indexes) f = this.indexes[p], f >= o && (this.indexes[p] = f - 1);
              return this;
            }
            removeAll() {
              for (let o of this.nodes) o.parent = void 0;
              return this.nodes = [], this;
            }
            every(o) {
              return this.nodes.every(o);
            }
            some(o) {
              return this.nodes.some(o);
            }
            index(o) {
              return typeof o == "number" ? o : this.nodes.indexOf(o);
            }
            get first() {
              if (!!this.nodes) return this.nodes[0];
            }
            get last() {
              if (!!this.nodes) return this.nodes[this.nodes.length - 1];
            }
            toString() {
              let o = this.nodes.map(String).join("");
              return this.value && (o = this.value + o), this.raws.before && (o = this.raws.before + o), this.raws.after && (o += this.raws.after), o;
            }
          };
          a.registerWalker = (o) => {
            let f = "walk" + o.name;
            f.lastIndexOf("s") !== f.length - 1 && (f += "s"), !a.prototype[f] && (a.prototype[f] = function(p) {
              return this.walkType(o, p);
            });
          }, n.exports = a;
        } }), Ll = R({ "node_modules/postcss-values-parser/lib/root.js"(e, n) {
          "use strict";
          A();
          var i = ue();
          n.exports = class extends i {
            constructor(o) {
              super(o), this.type = "root";
            }
          };
        } }), Ks = R({ "node_modules/postcss-values-parser/lib/value.js"(e, n) {
          "use strict";
          A();
          var i = ue();
          n.exports = class extends i {
            constructor(o) {
              super(o), this.type = "value", this.unbalanced = 0;
            }
          };
        } }), Qs = R({ "node_modules/postcss-values-parser/lib/atword.js"(e, n) {
          "use strict";
          A();
          var i = ue(), a = class extends i {
            constructor(o) {
              super(o), this.type = "atword";
            }
            toString() {
              let o = this.quoted ? this.raws.quote : "";
              return [this.raws.before, "@", String.prototype.toString.call(this.value), this.raws.after].join("");
            }
          };
          i.registerWalker(a), n.exports = a;
        } }), Ys = R({ "node_modules/postcss-values-parser/lib/colon.js"(e, n) {
          "use strict";
          A();
          var i = ue(), a = we(), o = class extends a {
            constructor(f) {
              super(f), this.type = "colon";
            }
          };
          i.registerWalker(o), n.exports = o;
        } }), Xs = R({ "node_modules/postcss-values-parser/lib/comma.js"(e, n) {
          "use strict";
          A();
          var i = ue(), a = we(), o = class extends a {
            constructor(f) {
              super(f), this.type = "comma";
            }
          };
          i.registerWalker(o), n.exports = o;
        } }), Zs = R({ "node_modules/postcss-values-parser/lib/comment.js"(e, n) {
          "use strict";
          A();
          var i = ue(), a = we(), o = class extends a {
            constructor(f) {
              super(f), this.type = "comment", this.inline = Object(f).inline || false;
            }
            toString() {
              return [this.raws.before, this.inline ? "//" : "/*", String(this.value), this.inline ? "" : "*/", this.raws.after].join("");
            }
          };
          i.registerWalker(o), n.exports = o;
        } }), eo = R({ "node_modules/postcss-values-parser/lib/function.js"(e, n) {
          "use strict";
          A();
          var i = ue(), a = class extends i {
            constructor(o) {
              super(o), this.type = "func", this.unbalanced = -1;
            }
          };
          i.registerWalker(a), n.exports = a;
        } }), ro = R({ "node_modules/postcss-values-parser/lib/number.js"(e, n) {
          "use strict";
          A();
          var i = ue(), a = we(), o = class extends a {
            constructor(f) {
              super(f), this.type = "number", this.unit = Object(f).unit || "";
            }
            toString() {
              return [this.raws.before, String(this.value), this.unit, this.raws.after].join("");
            }
          };
          i.registerWalker(o), n.exports = o;
        } }), to = R({ "node_modules/postcss-values-parser/lib/operator.js"(e, n) {
          "use strict";
          A();
          var i = ue(), a = we(), o = class extends a {
            constructor(f) {
              super(f), this.type = "operator";
            }
          };
          i.registerWalker(o), n.exports = o;
        } }), no = R({ "node_modules/postcss-values-parser/lib/paren.js"(e, n) {
          "use strict";
          A();
          var i = ue(), a = we(), o = class extends a {
            constructor(f) {
              super(f), this.type = "paren", this.parenType = "";
            }
          };
          i.registerWalker(o), n.exports = o;
        } }), io = R({ "node_modules/postcss-values-parser/lib/string.js"(e, n) {
          "use strict";
          A();
          var i = ue(), a = we(), o = class extends a {
            constructor(f) {
              super(f), this.type = "string";
            }
            toString() {
              let f = this.quoted ? this.raws.quote : "";
              return [this.raws.before, f, this.value + "", f, this.raws.after].join("");
            }
          };
          i.registerWalker(o), n.exports = o;
        } }), so = R({ "node_modules/postcss-values-parser/lib/word.js"(e, n) {
          "use strict";
          A();
          var i = ue(), a = we(), o = class extends a {
            constructor(f) {
              super(f), this.type = "word";
            }
          };
          i.registerWalker(o), n.exports = o;
        } }), oo = R({ "node_modules/postcss-values-parser/lib/unicode-range.js"(e, n) {
          "use strict";
          A();
          var i = ue(), a = we(), o = class extends a {
            constructor(f) {
              super(f), this.type = "unicode-range";
            }
          };
          i.registerWalker(o), n.exports = o;
        } });
        function ao() {
          throw new Error("setTimeout has not been defined");
        }
        function uo() {
          throw new Error("clearTimeout has not been defined");
        }
        function co(e) {
          if (be === setTimeout) return setTimeout(e, 0);
          if ((be === ao || !be) && setTimeout) return be = setTimeout, setTimeout(e, 0);
          try {
            return be(e, 0);
          } catch {
            try {
              return be.call(null, e, 0);
            } catch {
              return be.call(this, e, 0);
            }
          }
        }
        function zl(e) {
          if (xe === clearTimeout) return clearTimeout(e);
          if ((xe === uo || !xe) && clearTimeout) return xe = clearTimeout, clearTimeout(e);
          try {
            return xe(e);
          } catch {
            try {
              return xe.call(null, e);
            } catch {
              return xe.call(this, e);
            }
          }
        }
        function Bl() {
          !Ne || !Ce || (Ne = false, Ce.length ? me = Ce.concat(me) : $e = -1, me.length && lo());
        }
        function lo() {
          if (!Ne) {
            var e = co(Bl);
            Ne = true;
            for (var n = me.length; n; ) {
              for (Ce = me, me = []; ++$e < n; ) Ce && Ce[$e].run();
              $e = -1, n = me.length;
            }
            Ce = null, Ne = false, zl(e);
          }
        }
        function Fl(e) {
          var n = new Array(arguments.length - 1);
          if (arguments.length > 1) for (var i = 1; i < arguments.length; i++) n[i - 1] = arguments[i];
          me.push(new fo(e, n)), me.length === 1 && !Ne && co(lo);
        }
        function fo(e, n) {
          this.fun = e, this.array = n;
        }
        function Ae() {
        }
        function Ul(e) {
          throw new Error("process.binding is not supported");
        }
        function Wl() {
          return "/";
        }
        function $l(e) {
          throw new Error("process.chdir is not supported");
        }
        function Vl() {
          return 0;
        }
        function Gl(e) {
          var n = po.call(Re) * 1e-3, i = Math.floor(n), a = Math.floor(n % 1 * 1e9);
          return e && (i = i - e[0], a = a - e[1], a < 0 && (i--, a += 1e9)), [i, a];
        }
        function Hl() {
          var e = /* @__PURE__ */ new Date(), n = e - ho;
          return n / 1e3;
        }
        var be, xe, me, Ne, Ce, $e, vs, ms, gs, ys, ws, _s, bs, xs, ks, Ss, Os, Ts, Es, qs, As, Ps, Re, po, ho, Rs, Ve, Jl = Le({ "node-modules-polyfills:process"() {
          A(), be = ao, xe = uo, typeof globalThis.setTimeout == "function" && (be = setTimeout), typeof globalThis.clearTimeout == "function" && (xe = clearTimeout), me = [], Ne = false, $e = -1, fo.prototype.run = function() {
            this.fun.apply(null, this.array);
          }, vs = "browser", ms = "browser", gs = true, ys = {}, ws = [], _s = "", bs = {}, xs = {}, ks = {}, Ss = Ae, Os = Ae, Ts = Ae, Es = Ae, qs = Ae, As = Ae, Ps = Ae, Re = globalThis.performance || {}, po = Re.now || Re.mozNow || Re.msNow || Re.oNow || Re.webkitNow || function() {
            return (/* @__PURE__ */ new Date()).getTime();
          }, ho = /* @__PURE__ */ new Date(), Rs = { nextTick: Fl, title: vs, browser: gs, env: ys, argv: ws, version: _s, versions: bs, on: Ss, addListener: Os, once: Ts, off: Es, removeListener: qs, removeAllListeners: As, emit: Ps, binding: Ul, cwd: Wl, chdir: $l, umask: Vl, hrtime: Gl, platform: ms, release: xs, config: ks, uptime: Hl }, Ve = Rs;
        } }), ut, Et, Kl = Le({ "node_modules/rollup-plugin-node-polyfills/polyfills/inherits.js"() {
          A(), typeof Object.create == "function" ? ut = function(n, i) {
            n.super_ = i, n.prototype = Object.create(i.prototype, { constructor: { value: n, enumerable: false, writable: true, configurable: true } });
          } : ut = function(n, i) {
            n.super_ = i;
            var a = function() {
            };
            a.prototype = i.prototype, n.prototype = new a(), n.prototype.constructor = n;
          }, Et = ut;
        } }), vo = {};
        Ot(vo, { _extend: () => It, debuglog: () => mo, default: () => Oo, deprecate: () => qt, format: () => gr, inherits: () => Et, inspect: () => ye, isArray: () => At, isBoolean: () => yr, isBuffer: () => _o, isDate: () => vr, isError: () => He, isFunction: () => Je, isNull: () => Ke, isNullOrUndefined: () => go, isNumber: () => Pt, isObject: () => je, isPrimitive: () => wo, isRegExp: () => Ge, isString: () => Qe, isSymbol: () => yo, isUndefined: () => ge, log: () => bo });
        function gr(e) {
          if (!Qe(e)) {
            for (var n = [], i = 0; i < arguments.length; i++) n.push(ye(arguments[i]));
            return n.join(" ");
          }
          for (var i = 1, a = arguments, o = a.length, f = String(e).replace(ko, function(h) {
            if (h === "%%") return "%";
            if (i >= o) return h;
            switch (h) {
              case "%s":
                return String(a[i++]);
              case "%d":
                return Number(a[i++]);
              case "%j":
                try {
                  return JSON.stringify(a[i++]);
                } catch {
                  return "[Circular]";
                }
              default:
                return h;
            }
          }), p = a[i]; i < o; p = a[++i]) Ke(p) || !je(p) ? f += " " + p : f += " " + ye(p);
          return f;
        }
        function qt(e, n) {
          if (ge(globalThis.process)) return function() {
            return qt(e, n).apply(this, arguments);
          };
          if (Ve.noDeprecation === true) return e;
          var i = false;
          function a() {
            if (!i) {
              if (Ve.throwDeprecation) throw new Error(n);
              Ve.traceDeprecation ? console.trace(n) : console.error(n), i = true;
            }
            return e.apply(this, arguments);
          }
          return a;
        }
        function mo(e) {
          if (ge(ft) && (ft = Ve.env.NODE_DEBUG || ""), e = e.toUpperCase(), !We[e]) if (new RegExp("\\b" + e + "\\b", "i").test(ft)) {
            var n = 0;
            We[e] = function() {
              var i = gr.apply(null, arguments);
              console.error("%s %d: %s", e, n, i);
            };
          } else We[e] = function() {
          };
          return We[e];
        }
        function ye(e, n) {
          var i = { seen: [], stylize: Yl };
          return arguments.length >= 3 && (i.depth = arguments[2]), arguments.length >= 4 && (i.colors = arguments[3]), yr(n) ? i.showHidden = n : n && It(i, n), ge(i.showHidden) && (i.showHidden = false), ge(i.depth) && (i.depth = 2), ge(i.colors) && (i.colors = false), ge(i.customInspect) && (i.customInspect = true), i.colors && (i.stylize = Ql), dr(i, e, i.depth);
        }
        function Ql(e, n) {
          var i = ye.styles[n];
          return i ? "\x1B[" + ye.colors[i][0] + "m" + e + "\x1B[" + ye.colors[i][1] + "m" : e;
        }
        function Yl(e, n) {
          return e;
        }
        function Xl(e) {
          var n = {};
          return e.forEach(function(i, a) {
            n[i] = true;
          }), n;
        }
        function dr(e, n, i) {
          if (e.customInspect && n && Je(n.inspect) && n.inspect !== ye && !(n.constructor && n.constructor.prototype === n)) {
            var a = n.inspect(i, e);
            return Qe(a) || (a = dr(e, a, i)), a;
          }
          var o = Zl(e, n);
          if (o) return o;
          var f = Object.keys(n), p = Xl(f);
          if (e.showHidden && (f = Object.getOwnPropertyNames(n)), He(n) && (f.indexOf("message") >= 0 || f.indexOf("description") >= 0)) return ct(n);
          if (f.length === 0) {
            if (Je(n)) {
              var h = n.name ? ": " + n.name : "";
              return e.stylize("[Function" + h + "]", "special");
            }
            if (Ge(n)) return e.stylize(RegExp.prototype.toString.call(n), "regexp");
            if (vr(n)) return e.stylize(Date.prototype.toString.call(n), "date");
            if (He(n)) return ct(n);
          }
          var g = "", c = false, t = ["{", "}"];
          if (At(n) && (c = true, t = ["[", "]"]), Je(n)) {
            var r = n.name ? ": " + n.name : "";
            g = " [Function" + r + "]";
          }
          if (Ge(n) && (g = " " + RegExp.prototype.toString.call(n)), vr(n) && (g = " " + Date.prototype.toUTCString.call(n)), He(n) && (g = " " + ct(n)), f.length === 0 && (!c || n.length == 0)) return t[0] + g + t[1];
          if (i < 0) return Ge(n) ? e.stylize(RegExp.prototype.toString.call(n), "regexp") : e.stylize("[Object]", "special");
          e.seen.push(n);
          var u;
          return c ? u = ef(e, n, i, p, f) : u = f.map(function(s) {
            return yt(e, n, i, p, s, c);
          }), e.seen.pop(), rf(u, g, t);
        }
        function Zl(e, n) {
          if (ge(n)) return e.stylize("undefined", "undefined");
          if (Qe(n)) {
            var i = "'" + JSON.stringify(n).replace(/^"|"$/g, "").replace(/'/g, "\\'").replace(/\\"/g, '"') + "'";
            return e.stylize(i, "string");
          }
          if (Pt(n)) return e.stylize("" + n, "number");
          if (yr(n)) return e.stylize("" + n, "boolean");
          if (Ke(n)) return e.stylize("null", "null");
        }
        function ct(e) {
          return "[" + Error.prototype.toString.call(e) + "]";
        }
        function ef(e, n, i, a, o) {
          for (var f = [], p = 0, h = n.length; p < h; ++p) xo(n, String(p)) ? f.push(yt(e, n, i, a, String(p), true)) : f.push("");
          return o.forEach(function(g) {
            g.match(/^\d+$/) || f.push(yt(e, n, i, a, g, true));
          }), f;
        }
        function yt(e, n, i, a, o, f) {
          var p, h, g;
          if (g = Object.getOwnPropertyDescriptor(n, o) || { value: n[o] }, g.get ? g.set ? h = e.stylize("[Getter/Setter]", "special") : h = e.stylize("[Getter]", "special") : g.set && (h = e.stylize("[Setter]", "special")), xo(a, o) || (p = "[" + o + "]"), h || (e.seen.indexOf(g.value) < 0 ? (Ke(i) ? h = dr(e, g.value, null) : h = dr(e, g.value, i - 1), h.indexOf(`
`) > -1 && (f ? h = h.split(`
`).map(function(c) {
            return "  " + c;
          }).join(`
`).substr(2) : h = `
` + h.split(`
`).map(function(c) {
            return "   " + c;
          }).join(`
`))) : h = e.stylize("[Circular]", "special")), ge(p)) {
            if (f && o.match(/^\d+$/)) return h;
            p = JSON.stringify("" + o), p.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/) ? (p = p.substr(1, p.length - 2), p = e.stylize(p, "name")) : (p = p.replace(/'/g, "\\'").replace(/\\"/g, '"').replace(/(^"|"$)/g, "'"), p = e.stylize(p, "string"));
          }
          return p + ": " + h;
        }
        function rf(e, n, i) {
          var a = 0, o = e.reduce(function(f, p) {
            return a++, p.indexOf(`
`) >= 0 && a++, f + p.replace(/\u001b\[\d\d?m/g, "").length + 1;
          }, 0);
          return o > 60 ? i[0] + (n === "" ? "" : n + `
 `) + " " + e.join(`,
  `) + " " + i[1] : i[0] + n + " " + e.join(", ") + " " + i[1];
        }
        function At(e) {
          return Array.isArray(e);
        }
        function yr(e) {
          return typeof e == "boolean";
        }
        function Ke(e) {
          return e === null;
        }
        function go(e) {
          return e == null;
        }
        function Pt(e) {
          return typeof e == "number";
        }
        function Qe(e) {
          return typeof e == "string";
        }
        function yo(e) {
          return typeof e == "symbol";
        }
        function ge(e) {
          return e === void 0;
        }
        function Ge(e) {
          return je(e) && Rt(e) === "[object RegExp]";
        }
        function je(e) {
          return typeof e == "object" && e !== null;
        }
        function vr(e) {
          return je(e) && Rt(e) === "[object Date]";
        }
        function He(e) {
          return je(e) && (Rt(e) === "[object Error]" || e instanceof Error);
        }
        function Je(e) {
          return typeof e == "function";
        }
        function wo(e) {
          return e === null || typeof e == "boolean" || typeof e == "number" || typeof e == "string" || typeof e == "symbol" || typeof e > "u";
        }
        function _o(e) {
          return Buffer.isBuffer(e);
        }
        function Rt(e) {
          return Object.prototype.toString.call(e);
        }
        function lt(e) {
          return e < 10 ? "0" + e.toString(10) : e.toString(10);
        }
        function tf() {
          var e = /* @__PURE__ */ new Date(), n = [lt(e.getHours()), lt(e.getMinutes()), lt(e.getSeconds())].join(":");
          return [e.getDate(), So[e.getMonth()], n].join(" ");
        }
        function bo() {
          console.log("%s - %s", tf(), gr.apply(null, arguments));
        }
        function It(e, n) {
          if (!n || !je(n)) return e;
          for (var i = Object.keys(n), a = i.length; a--; ) e[i[a]] = n[i[a]];
          return e;
        }
        function xo(e, n) {
          return Object.prototype.hasOwnProperty.call(e, n);
        }
        var ko, We, ft, So, Oo, nf = Le({ "node-modules-polyfills:util"() {
          A(), Jl(), Kl(), ko = /%[sdj%]/g, We = {}, ye.colors = { bold: [1, 22], italic: [3, 23], underline: [4, 24], inverse: [7, 27], white: [37, 39], grey: [90, 39], black: [30, 39], blue: [34, 39], cyan: [36, 39], green: [32, 39], magenta: [35, 39], red: [31, 39], yellow: [33, 39] }, ye.styles = { special: "cyan", number: "yellow", boolean: "yellow", undefined: "grey", null: "bold", string: "green", date: "magenta", regexp: "red" }, So = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"], Oo = { inherits: Et, _extend: It, log: bo, isBuffer: _o, isPrimitive: wo, isFunction: Je, isError: He, isDate: vr, isObject: je, isRegExp: Ge, isUndefined: ge, isSymbol: yo, isString: Qe, isNumber: Pt, isNullOrUndefined: go, isNull: Ke, isBoolean: yr, isArray: At, inspect: ye, deprecate: qt, format: gr, debuglog: mo };
        } }), sf = R({ "node-modules-polyfills-commonjs:util"(e, n) {
          A();
          var i = (nf(), Tt(vo));
          if (i && i.default) {
            n.exports = i.default;
            for (let a in i) n.exports[a] = i[a];
          } else i && (n.exports = i);
        } }), of = R({ "node_modules/postcss-values-parser/lib/errors/TokenizeError.js"(e, n) {
          "use strict";
          A();
          var i = class extends Error {
            constructor(a) {
              super(a), this.name = this.constructor.name, this.message = a || "An error ocurred while tokzenizing.", typeof Error.captureStackTrace == "function" ? Error.captureStackTrace(this, this.constructor) : this.stack = new Error(a).stack;
            }
          };
          n.exports = i;
        } }), af = R({ "node_modules/postcss-values-parser/lib/tokenize.js"(e, n) {
          "use strict";
          A();
          var i = "{".charCodeAt(0), a = "}".charCodeAt(0), o = "(".charCodeAt(0), f = ")".charCodeAt(0), p = "'".charCodeAt(0), h = '"'.charCodeAt(0), g = "\\".charCodeAt(0), c = "/".charCodeAt(0), t = ".".charCodeAt(0), r = ",".charCodeAt(0), u = ":".charCodeAt(0), s = "*".charCodeAt(0), l = "-".charCodeAt(0), m = "+".charCodeAt(0), v = "#".charCodeAt(0), y = `
`.charCodeAt(0), w = " ".charCodeAt(0), d = "\f".charCodeAt(0), _ = "	".charCodeAt(0), S = "\r".charCodeAt(0), x = "@".charCodeAt(0), N = "e".charCodeAt(0), P = "E".charCodeAt(0), W = "0".charCodeAt(0), U = "9".charCodeAt(0), H = "u".charCodeAt(0), D = "U".charCodeAt(0), $ = /[ \n\t\r\{\(\)'"\\;,/]/g, B = /[ \n\t\r\(\)\{\}\*:;@!&'"\+\|~>,\[\]\\]|\/(?=\*)/g, O = /[ \n\t\r\(\)\{\}\*:;@!&'"\-\+\|~>,\[\]\\]|\//g, j = /^[a-z0-9]/i, C = /^[a-f0-9?\-]/i, I = sf(), X = of();
          n.exports = function(Q, K) {
            K = K || {};
            let J = [], M = Q.valueOf(), Y = M.length, G = -1, E = 1, k = 0, b = 0, L = null, q, T, F, z2, re, ne, ce, fe, te, ie, ae, se;
            function le(Ze) {
              let _e = I.format("Unclosed %s at line: %d, column: %d, token: %d", Ze, E, k - G, k);
              throw new X(_e);
            }
            function pe() {
              let Ze = I.format("Syntax error at line: %d, column: %d, token: %d", E, k - G, k);
              throw new X(Ze);
            }
            for (; k < Y; ) {
              switch (q = M.charCodeAt(k), q === y && (G = k, E += 1), q) {
                case y:
                case w:
                case _:
                case S:
                case d:
                  T = k;
                  do
                    T += 1, q = M.charCodeAt(T), q === y && (G = T, E += 1);
                  while (q === w || q === y || q === _ || q === S || q === d);
                  J.push(["space", M.slice(k, T), E, k - G, E, T - G, k]), k = T - 1;
                  break;
                case u:
                  T = k + 1, J.push(["colon", M.slice(k, T), E, k - G, E, T - G, k]), k = T - 1;
                  break;
                case r:
                  T = k + 1, J.push(["comma", M.slice(k, T), E, k - G, E, T - G, k]), k = T - 1;
                  break;
                case i:
                  J.push(["{", "{", E, k - G, E, T - G, k]);
                  break;
                case a:
                  J.push(["}", "}", E, k - G, E, T - G, k]);
                  break;
                case o:
                  b++, L = !L && b === 1 && J.length > 0 && J[J.length - 1][0] === "word" && J[J.length - 1][1] === "url", J.push(["(", "(", E, k - G, E, T - G, k]);
                  break;
                case f:
                  b--, L = L && b > 0, J.push([")", ")", E, k - G, E, T - G, k]);
                  break;
                case p:
                case h:
                  F = q === p ? "'" : '"', T = k;
                  do
                    for (ie = false, T = M.indexOf(F, T + 1), T === -1 && le("quote", F), ae = T; M.charCodeAt(ae - 1) === g; ) ae -= 1, ie = !ie;
                  while (ie);
                  J.push(["string", M.slice(k, T + 1), E, k - G, E, T - G, k]), k = T;
                  break;
                case x:
                  $.lastIndex = k + 1, $.test(M), $.lastIndex === 0 ? T = M.length - 1 : T = $.lastIndex - 2, J.push(["atword", M.slice(k, T + 1), E, k - G, E, T - G, k]), k = T;
                  break;
                case g:
                  T = k, q = M.charCodeAt(T + 1), ce && q !== c && q !== w && q !== y && q !== _ && q !== S && q !== d && (T += 1), J.push(["word", M.slice(k, T + 1), E, k - G, E, T - G, k]), k = T;
                  break;
                case m:
                case l:
                case s:
                  T = k + 1, se = M.slice(k + 1, T + 1);
                  let Ze = M.slice(k - 1, k);
                  if (q === l && se.charCodeAt(0) === l) {
                    T++, J.push(["word", M.slice(k, T), E, k - G, E, T - G, k]), k = T - 1;
                    break;
                  }
                  J.push(["operator", M.slice(k, T), E, k - G, E, T - G, k]), k = T - 1;
                  break;
                default:
                  if (q === c && (M.charCodeAt(k + 1) === s || K.loose && !L && M.charCodeAt(k + 1) === c)) {
                    if (M.charCodeAt(k + 1) === s) T = M.indexOf("*/", k + 2) + 1, T === 0 && le("comment", "*/");
                    else {
                      let Be = M.indexOf(`
`, k + 2);
                      T = Be !== -1 ? Be - 1 : Y;
                    }
                    ne = M.slice(k, T + 1), z2 = ne.split(`
`), re = z2.length - 1, re > 0 ? (fe = E + re, te = T - z2[re].length) : (fe = E, te = G), J.push(["comment", ne, E, k - G, fe, T - te, k]), G = te, E = fe, k = T;
                  } else if (q === v && !j.test(M.slice(k + 1, k + 2))) T = k + 1, J.push(["#", M.slice(k, T), E, k - G, E, T - G, k]), k = T - 1;
                  else if ((q === H || q === D) && M.charCodeAt(k + 1) === m) {
                    T = k + 2;
                    do
                      T += 1, q = M.charCodeAt(T);
                    while (T < Y && C.test(M.slice(T, T + 1)));
                    J.push(["unicoderange", M.slice(k, T), E, k - G, E, T - G, k]), k = T - 1;
                  } else if (q === c) T = k + 1, J.push(["operator", M.slice(k, T), E, k - G, E, T - G, k]), k = T - 1;
                  else {
                    let _e = B;
                    if (q >= W && q <= U && (_e = O), _e.lastIndex = k + 1, _e.test(M), _e.lastIndex === 0 ? T = M.length - 1 : T = _e.lastIndex - 2, _e === O || q === t) {
                      let Be = M.charCodeAt(T), Bt = M.charCodeAt(T + 1), Ft = M.charCodeAt(T + 2);
                      (Be === N || Be === P) && (Bt === l || Bt === m) && Ft >= W && Ft <= U && (O.lastIndex = T + 2, O.test(M), O.lastIndex === 0 ? T = M.length - 1 : T = O.lastIndex - 2);
                    }
                    J.push(["word", M.slice(k, T + 1), E, k - G, E, T - G, k]), k = T;
                  }
                  break;
              }
              k++;
            }
            return J;
          };
        } }), To = R({ "node_modules/flatten/index.js"(e, n) {
          A(), n.exports = function(a, o) {
            if (o = typeof o == "number" ? o : 1 / 0, !o) return Array.isArray(a) ? a.map(function(p) {
              return p;
            }) : a;
            return f(a, 1);
            function f(p, h) {
              return p.reduce(function(g, c) {
                return Array.isArray(c) && h < o ? g.concat(f(c, h + 1)) : g.concat(c);
              }, []);
            }
          };
        } }), Eo = R({ "node_modules/indexes-of/index.js"(e, n) {
          A(), n.exports = function(i, a) {
            for (var o = -1, f = []; (o = i.indexOf(a, o + 1)) !== -1; ) f.push(o);
            return f;
          };
        } }), qo = R({ "node_modules/uniq/uniq.js"(e, n) {
          "use strict";
          A();
          function i(f, p) {
            for (var h = 1, g = f.length, c = f[0], t = f[0], r = 1; r < g; ++r) if (t = c, c = f[r], p(c, t)) {
              if (r === h) {
                h++;
                continue;
              }
              f[h++] = c;
            }
            return f.length = h, f;
          }
          function a(f) {
            for (var p = 1, h = f.length, g = f[0], c = f[0], t = 1; t < h; ++t, c = g) if (c = g, g = f[t], g !== c) {
              if (t === p) {
                p++;
                continue;
              }
              f[p++] = g;
            }
            return f.length = p, f;
          }
          function o(f, p, h) {
            return f.length === 0 ? f : p ? (h || f.sort(p), i(f, p)) : (h || f.sort(), a(f));
          }
          n.exports = o;
        } }), uf = R({ "node_modules/postcss-values-parser/lib/errors/ParserError.js"(e, n) {
          "use strict";
          A();
          var i = class extends Error {
            constructor(a) {
              super(a), this.name = this.constructor.name, this.message = a || "An error ocurred while parsing.", typeof Error.captureStackTrace == "function" ? Error.captureStackTrace(this, this.constructor) : this.stack = new Error(a).stack;
            }
          };
          n.exports = i;
        } }), cf = R({ "node_modules/postcss-values-parser/lib/parser.js"(e, n) {
          "use strict";
          A();
          var i = Ll(), a = Ks(), o = Qs(), f = Ys(), p = Xs(), h = Zs(), g = eo(), c = ro(), t = to(), r = no(), u = io(), s = so(), l = oo(), m = af(), v = To(), y = Eo(), w = qo(), d = uf();
          function _(S) {
            return S.sort((x, N) => x - N);
          }
          n.exports = class {
            constructor(x, N) {
              let P = { loose: false };
              this.cache = [], this.input = x, this.options = Object.assign({}, P, N), this.position = 0, this.unbalanced = 0, this.root = new i();
              let W = new a();
              this.root.append(W), this.current = W, this.tokens = m(x, this.options);
            }
            parse() {
              return this.loop();
            }
            colon() {
              let x = this.currToken;
              this.newNode(new f({ value: x[1], source: { start: { line: x[2], column: x[3] }, end: { line: x[4], column: x[5] } }, sourceIndex: x[6] })), this.position++;
            }
            comma() {
              let x = this.currToken;
              this.newNode(new p({ value: x[1], source: { start: { line: x[2], column: x[3] }, end: { line: x[4], column: x[5] } }, sourceIndex: x[6] })), this.position++;
            }
            comment() {
              let x = false, N = this.currToken[1].replace(/\/\*|\*\//g, ""), P;
              this.options.loose && N.startsWith("//") && (N = N.substring(2), x = true), P = new h({ value: N, inline: x, source: { start: { line: this.currToken[2], column: this.currToken[3] }, end: { line: this.currToken[4], column: this.currToken[5] } }, sourceIndex: this.currToken[6] }), this.newNode(P), this.position++;
            }
            error(x, N) {
              throw new d(x + " at line: ".concat(N[2], ", column ").concat(N[3]));
            }
            loop() {
              for (; this.position < this.tokens.length; ) this.parseTokens();
              return !this.current.last && this.spaces ? this.current.raws.before += this.spaces : this.spaces && (this.current.last.raws.after += this.spaces), this.spaces = "", this.root;
            }
            operator() {
              let x = this.currToken[1], N;
              if (x === "+" || x === "-") {
                if (this.options.loose || this.position > 0 && (this.current.type === "func" && this.current.value === "calc" ? this.prevToken[0] !== "space" && this.prevToken[0] !== "(" ? this.error("Syntax Error", this.currToken) : this.nextToken[0] !== "space" && this.nextToken[0] !== "word" ? this.error("Syntax Error", this.currToken) : this.nextToken[0] === "word" && this.current.last.type !== "operator" && this.current.last.value !== "(" && this.error("Syntax Error", this.currToken) : (this.nextToken[0] === "space" || this.nextToken[0] === "operator" || this.prevToken[0] === "operator") && this.error("Syntax Error", this.currToken)), this.options.loose) {
                  if ((!this.current.nodes.length || this.current.last && this.current.last.type === "operator") && this.nextToken[0] === "word") return this.word();
                } else if (this.nextToken[0] === "word") return this.word();
              }
              return N = new t({ value: this.currToken[1], source: { start: { line: this.currToken[2], column: this.currToken[3] }, end: { line: this.currToken[2], column: this.currToken[3] } }, sourceIndex: this.currToken[4] }), this.position++, this.newNode(N);
            }
            parseTokens() {
              switch (this.currToken[0]) {
                case "space":
                  this.space();
                  break;
                case "colon":
                  this.colon();
                  break;
                case "comma":
                  this.comma();
                  break;
                case "comment":
                  this.comment();
                  break;
                case "(":
                  this.parenOpen();
                  break;
                case ")":
                  this.parenClose();
                  break;
                case "atword":
                case "word":
                  this.word();
                  break;
                case "operator":
                  this.operator();
                  break;
                case "string":
                  this.string();
                  break;
                case "unicoderange":
                  this.unicodeRange();
                  break;
                default:
                  this.word();
                  break;
              }
            }
            parenOpen() {
              let x = 1, N = this.position + 1, P = this.currToken, W;
              for (; N < this.tokens.length && x; ) {
                let U = this.tokens[N];
                U[0] === "(" && x++, U[0] === ")" && x--, N++;
              }
              if (x && this.error("Expected closing parenthesis", P), W = this.current.last, W && W.type === "func" && W.unbalanced < 0 && (W.unbalanced = 0, this.current = W), this.current.unbalanced++, this.newNode(new r({ value: P[1], source: { start: { line: P[2], column: P[3] }, end: { line: P[4], column: P[5] } }, sourceIndex: P[6] })), this.position++, this.current.type === "func" && this.current.unbalanced && this.current.value === "url" && this.currToken[0] !== "string" && this.currToken[0] !== ")" && !this.options.loose) {
                let U = this.nextToken, H = this.currToken[1], D = { line: this.currToken[2], column: this.currToken[3] };
                for (; U && U[0] !== ")" && this.current.unbalanced; ) this.position++, H += this.currToken[1], U = this.nextToken;
                this.position !== this.tokens.length - 1 && (this.position++, this.newNode(new s({ value: H, source: { start: D, end: { line: this.currToken[4], column: this.currToken[5] } }, sourceIndex: this.currToken[6] })));
              }
            }
            parenClose() {
              let x = this.currToken;
              this.newNode(new r({ value: x[1], source: { start: { line: x[2], column: x[3] }, end: { line: x[4], column: x[5] } }, sourceIndex: x[6] })), this.position++, !(this.position >= this.tokens.length - 1 && !this.current.unbalanced) && (this.current.unbalanced--, this.current.unbalanced < 0 && this.error("Expected opening parenthesis", x), !this.current.unbalanced && this.cache.length && (this.current = this.cache.pop()));
            }
            space() {
              let x = this.currToken;
              this.position === this.tokens.length - 1 || this.nextToken[0] === "," || this.nextToken[0] === ")" ? (this.current.last.raws.after += x[1], this.position++) : (this.spaces = x[1], this.position++);
            }
            unicodeRange() {
              let x = this.currToken;
              this.newNode(new l({ value: x[1], source: { start: { line: x[2], column: x[3] }, end: { line: x[4], column: x[5] } }, sourceIndex: x[6] })), this.position++;
            }
            splitWord() {
              let x = this.nextToken, N = this.currToken[1], P = /^[\+\-]?((\d+(\.\d*)?)|(\.\d+))([eE][\+\-]?\d+)?/, W = /^(?!\#([a-z0-9]+))[\#\{\}]/gi, U, H;
              if (!W.test(N)) for (; x && x[0] === "word"; ) this.position++, N += this.currToken[1], x = this.nextToken;
              U = y(N, "@"), H = _(w(v([[0], U]))), H.forEach((D, $) => {
                let B = H[$ + 1] || N.length, O = N.slice(D, B), j;
                if (~U.indexOf(D)) j = new o({ value: O.slice(1), source: { start: { line: this.currToken[2], column: this.currToken[3] + D }, end: { line: this.currToken[4], column: this.currToken[3] + (B - 1) } }, sourceIndex: this.currToken[6] + H[$] });
                else if (P.test(this.currToken[1])) {
                  let C = O.replace(P, "");
                  j = new c({ value: O.replace(C, ""), source: { start: { line: this.currToken[2], column: this.currToken[3] + D }, end: { line: this.currToken[4], column: this.currToken[3] + (B - 1) } }, sourceIndex: this.currToken[6] + H[$], unit: C });
                } else j = new (x && x[0] === "(" ? g : s)({ value: O, source: { start: { line: this.currToken[2], column: this.currToken[3] + D }, end: { line: this.currToken[4], column: this.currToken[3] + (B - 1) } }, sourceIndex: this.currToken[6] + H[$] }), j.type === "word" ? (j.isHex = /^#(.+)/.test(O), j.isColor = /^#([0-9a-f]{3}|[0-9a-f]{4}|[0-9a-f]{6}|[0-9a-f]{8})$/i.test(O)) : this.cache.push(this.current);
                this.newNode(j);
              }), this.position++;
            }
            string() {
              let x = this.currToken, N = this.currToken[1], P = /^(\"|\')/, W = P.test(N), U = "", H;
              W && (U = N.match(P)[0], N = N.slice(1, N.length - 1)), H = new u({ value: N, source: { start: { line: x[2], column: x[3] }, end: { line: x[4], column: x[5] } }, sourceIndex: x[6], quoted: W }), H.raws.quote = U, this.newNode(H), this.position++;
            }
            word() {
              return this.splitWord();
            }
            newNode(x) {
              return this.spaces && (x.raws.before += this.spaces, this.spaces = ""), this.current.append(x);
            }
            get currToken() {
              return this.tokens[this.position];
            }
            get nextToken() {
              return this.tokens[this.position + 1];
            }
            get prevToken() {
              return this.tokens[this.position - 1];
            }
          };
        } }), lf = R({ "node_modules/postcss-values-parser/lib/index.js"(e, n) {
          "use strict";
          A();
          var i = cf(), a = Qs(), o = Ys(), f = Xs(), p = Zs(), h = eo(), g = ro(), c = to(), t = no(), r = io(), u = oo(), s = Ks(), l = so(), m = function(v, y) {
            return new i(v, y);
          };
          m.atword = function(v) {
            return new a(v);
          }, m.colon = function(v) {
            return new o(Object.assign({ value: ":" }, v));
          }, m.comma = function(v) {
            return new f(Object.assign({ value: "," }, v));
          }, m.comment = function(v) {
            return new p(v);
          }, m.func = function(v) {
            return new h(v);
          }, m.number = function(v) {
            return new g(v);
          }, m.operator = function(v) {
            return new c(v);
          }, m.paren = function(v) {
            return new t(Object.assign({ value: "(" }, v));
          }, m.string = function(v) {
            return new r(Object.assign({ quote: "'" }, v));
          }, m.value = function(v) {
            return new s(v);
          }, m.word = function(v) {
            return new l(v);
          }, m.unicodeRange = function(v) {
            return new u(v);
          }, n.exports = m;
        } }), ze = R({ "node_modules/postcss-selector-parser/dist/selectors/node.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(p) {
            return typeof p;
          } : function(p) {
            return p && typeof Symbol == "function" && p.constructor === Symbol && p !== Symbol.prototype ? "symbol" : typeof p;
          };
          function a(p, h) {
            if (!(p instanceof h)) throw new TypeError("Cannot call a class as a function");
          }
          var o = function p(h, g) {
            if ((typeof h > "u" ? "undefined" : i(h)) !== "object") return h;
            var c = new h.constructor();
            for (var t in h) if (!!h.hasOwnProperty(t)) {
              var r = h[t], u = typeof r > "u" ? "undefined" : i(r);
              t === "parent" && u === "object" ? g && (c[t] = g) : r instanceof Array ? c[t] = r.map(function(s) {
                return p(s, c);
              }) : c[t] = p(r, c);
            }
            return c;
          }, f = function() {
            function p() {
              var h = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
              a(this, p);
              for (var g in h) this[g] = h[g];
              var c = h.spaces;
              c = c === void 0 ? {} : c;
              var t = c.before, r = t === void 0 ? "" : t, u = c.after, s = u === void 0 ? "" : u;
              this.spaces = { before: r, after: s };
            }
            return p.prototype.remove = function() {
              return this.parent && this.parent.removeChild(this), this.parent = void 0, this;
            }, p.prototype.replaceWith = function() {
              if (this.parent) {
                for (var g in arguments) this.parent.insertBefore(this, arguments[g]);
                this.remove();
              }
              return this;
            }, p.prototype.next = function() {
              return this.parent.at(this.parent.index(this) + 1);
            }, p.prototype.prev = function() {
              return this.parent.at(this.parent.index(this) - 1);
            }, p.prototype.clone = function() {
              var g = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, c = o(this);
              for (var t in g) c[t] = g[t];
              return c;
            }, p.prototype.toString = function() {
              return [this.spaces.before, String(this.value), this.spaces.after].join("");
            }, p;
          }();
          e.default = f, n.exports = e.default;
        } }), oe = R({ "node_modules/postcss-selector-parser/dist/selectors/types.js"(e) {
          "use strict";
          A(), e.__esModule = true;
          var n = e.TAG = "tag", i = e.STRING = "string", a = e.SELECTOR = "selector", o = e.ROOT = "root", f = e.PSEUDO = "pseudo", p = e.NESTING = "nesting", h = e.ID = "id", g = e.COMMENT = "comment", c = e.COMBINATOR = "combinator", t = e.CLASS = "class", r = e.ATTRIBUTE = "attribute", u = e.UNIVERSAL = "universal";
        } }), Ct = R({ "node_modules/postcss-selector-parser/dist/selectors/container.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = /* @__PURE__ */ function() {
            function s(l, m) {
              for (var v = 0; v < m.length; v++) {
                var y = m[v];
                y.enumerable = y.enumerable || false, y.configurable = true, "value" in y && (y.writable = true), Object.defineProperty(l, y.key, y);
              }
            }
            return function(l, m, v) {
              return m && s(l.prototype, m), v && s(l, v), l;
            };
          }(), a = ze(), o = g(a), f = oe(), p = h(f);
          function h(s) {
            if (s && s.__esModule) return s;
            var l = {};
            if (s != null) for (var m in s) Object.prototype.hasOwnProperty.call(s, m) && (l[m] = s[m]);
            return l.default = s, l;
          }
          function g(s) {
            return s && s.__esModule ? s : { default: s };
          }
          function c(s, l) {
            if (!(s instanceof l)) throw new TypeError("Cannot call a class as a function");
          }
          function t(s, l) {
            if (!s) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return l && (typeof l == "object" || typeof l == "function") ? l : s;
          }
          function r(s, l) {
            if (typeof l != "function" && l !== null) throw new TypeError("Super expression must either be null or a function, not " + typeof l);
            s.prototype = Object.create(l && l.prototype, { constructor: { value: s, enumerable: false, writable: true, configurable: true } }), l && (Object.setPrototypeOf ? Object.setPrototypeOf(s, l) : s.__proto__ = l);
          }
          var u = function(s) {
            r(l, s);
            function l(m) {
              c(this, l);
              var v = t(this, s.call(this, m));
              return v.nodes || (v.nodes = []), v;
            }
            return l.prototype.append = function(v) {
              return v.parent = this, this.nodes.push(v), this;
            }, l.prototype.prepend = function(v) {
              return v.parent = this, this.nodes.unshift(v), this;
            }, l.prototype.at = function(v) {
              return this.nodes[v];
            }, l.prototype.index = function(v) {
              return typeof v == "number" ? v : this.nodes.indexOf(v);
            }, l.prototype.removeChild = function(v) {
              v = this.index(v), this.at(v).parent = void 0, this.nodes.splice(v, 1);
              var y = void 0;
              for (var w in this.indexes) y = this.indexes[w], y >= v && (this.indexes[w] = y - 1);
              return this;
            }, l.prototype.removeAll = function() {
              for (var w = this.nodes, v = Array.isArray(w), y = 0, w = v ? w : w[Symbol.iterator](); ; ) {
                var d;
                if (v) {
                  if (y >= w.length) break;
                  d = w[y++];
                } else {
                  if (y = w.next(), y.done) break;
                  d = y.value;
                }
                var _ = d;
                _.parent = void 0;
              }
              return this.nodes = [], this;
            }, l.prototype.empty = function() {
              return this.removeAll();
            }, l.prototype.insertAfter = function(v, y) {
              var w = this.index(v);
              this.nodes.splice(w + 1, 0, y);
              var d = void 0;
              for (var _ in this.indexes) d = this.indexes[_], w <= d && (this.indexes[_] = d + this.nodes.length);
              return this;
            }, l.prototype.insertBefore = function(v, y) {
              var w = this.index(v);
              this.nodes.splice(w, 0, y);
              var d = void 0;
              for (var _ in this.indexes) d = this.indexes[_], w <= d && (this.indexes[_] = d + this.nodes.length);
              return this;
            }, l.prototype.each = function(v) {
              this.lastEach || (this.lastEach = 0), this.indexes || (this.indexes = {}), this.lastEach++;
              var y = this.lastEach;
              if (this.indexes[y] = 0, !!this.length) {
                for (var w = void 0, d = void 0; this.indexes[y] < this.length && (w = this.indexes[y], d = v(this.at(w), w), d !== false); ) this.indexes[y] += 1;
                if (delete this.indexes[y], d === false) return false;
              }
            }, l.prototype.walk = function(v) {
              return this.each(function(y, w) {
                var d = v(y, w);
                if (d !== false && y.length && (d = y.walk(v)), d === false) return false;
              });
            }, l.prototype.walkAttributes = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.ATTRIBUTE) return v.call(y, w);
              });
            }, l.prototype.walkClasses = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.CLASS) return v.call(y, w);
              });
            }, l.prototype.walkCombinators = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.COMBINATOR) return v.call(y, w);
              });
            }, l.prototype.walkComments = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.COMMENT) return v.call(y, w);
              });
            }, l.prototype.walkIds = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.ID) return v.call(y, w);
              });
            }, l.prototype.walkNesting = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.NESTING) return v.call(y, w);
              });
            }, l.prototype.walkPseudos = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.PSEUDO) return v.call(y, w);
              });
            }, l.prototype.walkTags = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.TAG) return v.call(y, w);
              });
            }, l.prototype.walkUniversals = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.UNIVERSAL) return v.call(y, w);
              });
            }, l.prototype.split = function(v) {
              var y = this, w = [];
              return this.reduce(function(d, _, S) {
                var x = v.call(y, _);
                return w.push(_), x ? (d.push(w), w = []) : S === y.length - 1 && d.push(w), d;
              }, []);
            }, l.prototype.map = function(v) {
              return this.nodes.map(v);
            }, l.prototype.reduce = function(v, y) {
              return this.nodes.reduce(v, y);
            }, l.prototype.every = function(v) {
              return this.nodes.every(v);
            }, l.prototype.some = function(v) {
              return this.nodes.some(v);
            }, l.prototype.filter = function(v) {
              return this.nodes.filter(v);
            }, l.prototype.sort = function(v) {
              return this.nodes.sort(v);
            }, l.prototype.toString = function() {
              return this.map(String).join("");
            }, i(l, [{ key: "first", get: function() {
              return this.at(0);
            } }, { key: "last", get: function() {
              return this.at(this.length - 1);
            } }, { key: "length", get: function() {
              return this.nodes.length;
            } }]), l;
          }(o.default);
          e.default = u, n.exports = e.default;
        } }), Ao = R({ "node_modules/postcss-selector-parser/dist/selectors/root.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = Ct(), a = f(i), o = oe();
          function f(t) {
            return t && t.__esModule ? t : { default: t };
          }
          function p(t, r) {
            if (!(t instanceof r)) throw new TypeError("Cannot call a class as a function");
          }
          function h(t, r) {
            if (!t) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r && (typeof r == "object" || typeof r == "function") ? r : t;
          }
          function g(t, r) {
            if (typeof r != "function" && r !== null) throw new TypeError("Super expression must either be null or a function, not " + typeof r);
            t.prototype = Object.create(r && r.prototype, { constructor: { value: t, enumerable: false, writable: true, configurable: true } }), r && (Object.setPrototypeOf ? Object.setPrototypeOf(t, r) : t.__proto__ = r);
          }
          var c = function(t) {
            g(r, t);
            function r(u) {
              p(this, r);
              var s = h(this, t.call(this, u));
              return s.type = o.ROOT, s;
            }
            return r.prototype.toString = function() {
              var s = this.reduce(function(l, m) {
                var v = String(m);
                return v ? l + v + "," : "";
              }, "").slice(0, -1);
              return this.trailingComma ? s + "," : s;
            }, r;
          }(a.default);
          e.default = c, n.exports = e.default;
        } }), Po = R({ "node_modules/postcss-selector-parser/dist/selectors/selector.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = Ct(), a = f(i), o = oe();
          function f(t) {
            return t && t.__esModule ? t : { default: t };
          }
          function p(t, r) {
            if (!(t instanceof r)) throw new TypeError("Cannot call a class as a function");
          }
          function h(t, r) {
            if (!t) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r && (typeof r == "object" || typeof r == "function") ? r : t;
          }
          function g(t, r) {
            if (typeof r != "function" && r !== null) throw new TypeError("Super expression must either be null or a function, not " + typeof r);
            t.prototype = Object.create(r && r.prototype, { constructor: { value: t, enumerable: false, writable: true, configurable: true } }), r && (Object.setPrototypeOf ? Object.setPrototypeOf(t, r) : t.__proto__ = r);
          }
          var c = function(t) {
            g(r, t);
            function r(u) {
              p(this, r);
              var s = h(this, t.call(this, u));
              return s.type = o.SELECTOR, s;
            }
            return r;
          }(a.default);
          e.default = c, n.exports = e.default;
        } }), Ye = R({ "node_modules/postcss-selector-parser/dist/selectors/namespace.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = /* @__PURE__ */ function() {
            function t(r, u) {
              for (var s = 0; s < u.length; s++) {
                var l = u[s];
                l.enumerable = l.enumerable || false, l.configurable = true, "value" in l && (l.writable = true), Object.defineProperty(r, l.key, l);
              }
            }
            return function(r, u, s) {
              return u && t(r.prototype, u), s && t(r, s), r;
            };
          }(), a = ze(), o = f(a);
          function f(t) {
            return t && t.__esModule ? t : { default: t };
          }
          function p(t, r) {
            if (!(t instanceof r)) throw new TypeError("Cannot call a class as a function");
          }
          function h(t, r) {
            if (!t) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r && (typeof r == "object" || typeof r == "function") ? r : t;
          }
          function g(t, r) {
            if (typeof r != "function" && r !== null) throw new TypeError("Super expression must either be null or a function, not " + typeof r);
            t.prototype = Object.create(r && r.prototype, { constructor: { value: t, enumerable: false, writable: true, configurable: true } }), r && (Object.setPrototypeOf ? Object.setPrototypeOf(t, r) : t.__proto__ = r);
          }
          var c = function(t) {
            g(r, t);
            function r() {
              return p(this, r), h(this, t.apply(this, arguments));
            }
            return r.prototype.toString = function() {
              return [this.spaces.before, this.ns, String(this.value), this.spaces.after].join("");
            }, i(r, [{ key: "ns", get: function() {
              var s = this.namespace;
              return s ? (typeof s == "string" ? s : "") + "|" : "";
            } }]), r;
          }(o.default);
          e.default = c, n.exports = e.default;
        } }), Ro = R({ "node_modules/postcss-selector-parser/dist/selectors/className.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = Ye(), a = f(i), o = oe();
          function f(t) {
            return t && t.__esModule ? t : { default: t };
          }
          function p(t, r) {
            if (!(t instanceof r)) throw new TypeError("Cannot call a class as a function");
          }
          function h(t, r) {
            if (!t) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r && (typeof r == "object" || typeof r == "function") ? r : t;
          }
          function g(t, r) {
            if (typeof r != "function" && r !== null) throw new TypeError("Super expression must either be null or a function, not " + typeof r);
            t.prototype = Object.create(r && r.prototype, { constructor: { value: t, enumerable: false, writable: true, configurable: true } }), r && (Object.setPrototypeOf ? Object.setPrototypeOf(t, r) : t.__proto__ = r);
          }
          var c = function(t) {
            g(r, t);
            function r(u) {
              p(this, r);
              var s = h(this, t.call(this, u));
              return s.type = o.CLASS, s;
            }
            return r.prototype.toString = function() {
              return [this.spaces.before, this.ns, String("." + this.value), this.spaces.after].join("");
            }, r;
          }(a.default);
          e.default = c, n.exports = e.default;
        } }), Io = R({ "node_modules/postcss-selector-parser/dist/selectors/comment.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = ze(), a = f(i), o = oe();
          function f(t) {
            return t && t.__esModule ? t : { default: t };
          }
          function p(t, r) {
            if (!(t instanceof r)) throw new TypeError("Cannot call a class as a function");
          }
          function h(t, r) {
            if (!t) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r && (typeof r == "object" || typeof r == "function") ? r : t;
          }
          function g(t, r) {
            if (typeof r != "function" && r !== null) throw new TypeError("Super expression must either be null or a function, not " + typeof r);
            t.prototype = Object.create(r && r.prototype, { constructor: { value: t, enumerable: false, writable: true, configurable: true } }), r && (Object.setPrototypeOf ? Object.setPrototypeOf(t, r) : t.__proto__ = r);
          }
          var c = function(t) {
            g(r, t);
            function r(u) {
              p(this, r);
              var s = h(this, t.call(this, u));
              return s.type = o.COMMENT, s;
            }
            return r;
          }(a.default);
          e.default = c, n.exports = e.default;
        } }), Co = R({ "node_modules/postcss-selector-parser/dist/selectors/id.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = Ye(), a = f(i), o = oe();
          function f(t) {
            return t && t.__esModule ? t : { default: t };
          }
          function p(t, r) {
            if (!(t instanceof r)) throw new TypeError("Cannot call a class as a function");
          }
          function h(t, r) {
            if (!t) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r && (typeof r == "object" || typeof r == "function") ? r : t;
          }
          function g(t, r) {
            if (typeof r != "function" && r !== null) throw new TypeError("Super expression must either be null or a function, not " + typeof r);
            t.prototype = Object.create(r && r.prototype, { constructor: { value: t, enumerable: false, writable: true, configurable: true } }), r && (Object.setPrototypeOf ? Object.setPrototypeOf(t, r) : t.__proto__ = r);
          }
          var c = function(t) {
            g(r, t);
            function r(u) {
              p(this, r);
              var s = h(this, t.call(this, u));
              return s.type = o.ID, s;
            }
            return r.prototype.toString = function() {
              return [this.spaces.before, this.ns, String("#" + this.value), this.spaces.after].join("");
            }, r;
          }(a.default);
          e.default = c, n.exports = e.default;
        } }), No = R({ "node_modules/postcss-selector-parser/dist/selectors/tag.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = Ye(), a = f(i), o = oe();
          function f(t) {
            return t && t.__esModule ? t : { default: t };
          }
          function p(t, r) {
            if (!(t instanceof r)) throw new TypeError("Cannot call a class as a function");
          }
          function h(t, r) {
            if (!t) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r && (typeof r == "object" || typeof r == "function") ? r : t;
          }
          function g(t, r) {
            if (typeof r != "function" && r !== null) throw new TypeError("Super expression must either be null or a function, not " + typeof r);
            t.prototype = Object.create(r && r.prototype, { constructor: { value: t, enumerable: false, writable: true, configurable: true } }), r && (Object.setPrototypeOf ? Object.setPrototypeOf(t, r) : t.__proto__ = r);
          }
          var c = function(t) {
            g(r, t);
            function r(u) {
              p(this, r);
              var s = h(this, t.call(this, u));
              return s.type = o.TAG, s;
            }
            return r;
          }(a.default);
          e.default = c, n.exports = e.default;
        } }), jo = R({ "node_modules/postcss-selector-parser/dist/selectors/string.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = ze(), a = f(i), o = oe();
          function f(t) {
            return t && t.__esModule ? t : { default: t };
          }
          function p(t, r) {
            if (!(t instanceof r)) throw new TypeError("Cannot call a class as a function");
          }
          function h(t, r) {
            if (!t) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r && (typeof r == "object" || typeof r == "function") ? r : t;
          }
          function g(t, r) {
            if (typeof r != "function" && r !== null) throw new TypeError("Super expression must either be null or a function, not " + typeof r);
            t.prototype = Object.create(r && r.prototype, { constructor: { value: t, enumerable: false, writable: true, configurable: true } }), r && (Object.setPrototypeOf ? Object.setPrototypeOf(t, r) : t.__proto__ = r);
          }
          var c = function(t) {
            g(r, t);
            function r(u) {
              p(this, r);
              var s = h(this, t.call(this, u));
              return s.type = o.STRING, s;
            }
            return r;
          }(a.default);
          e.default = c, n.exports = e.default;
        } }), Mo = R({ "node_modules/postcss-selector-parser/dist/selectors/pseudo.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = Ct(), a = f(i), o = oe();
          function f(t) {
            return t && t.__esModule ? t : { default: t };
          }
          function p(t, r) {
            if (!(t instanceof r)) throw new TypeError("Cannot call a class as a function");
          }
          function h(t, r) {
            if (!t) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r && (typeof r == "object" || typeof r == "function") ? r : t;
          }
          function g(t, r) {
            if (typeof r != "function" && r !== null) throw new TypeError("Super expression must either be null or a function, not " + typeof r);
            t.prototype = Object.create(r && r.prototype, { constructor: { value: t, enumerable: false, writable: true, configurable: true } }), r && (Object.setPrototypeOf ? Object.setPrototypeOf(t, r) : t.__proto__ = r);
          }
          var c = function(t) {
            g(r, t);
            function r(u) {
              p(this, r);
              var s = h(this, t.call(this, u));
              return s.type = o.PSEUDO, s;
            }
            return r.prototype.toString = function() {
              var s = this.length ? "(" + this.map(String).join(",") + ")" : "";
              return [this.spaces.before, String(this.value), s, this.spaces.after].join("");
            }, r;
          }(a.default);
          e.default = c, n.exports = e.default;
        } }), Do = R({ "node_modules/postcss-selector-parser/dist/selectors/attribute.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = Ye(), a = f(i), o = oe();
          function f(t) {
            return t && t.__esModule ? t : { default: t };
          }
          function p(t, r) {
            if (!(t instanceof r)) throw new TypeError("Cannot call a class as a function");
          }
          function h(t, r) {
            if (!t) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r && (typeof r == "object" || typeof r == "function") ? r : t;
          }
          function g(t, r) {
            if (typeof r != "function" && r !== null) throw new TypeError("Super expression must either be null or a function, not " + typeof r);
            t.prototype = Object.create(r && r.prototype, { constructor: { value: t, enumerable: false, writable: true, configurable: true } }), r && (Object.setPrototypeOf ? Object.setPrototypeOf(t, r) : t.__proto__ = r);
          }
          var c = function(t) {
            g(r, t);
            function r(u) {
              p(this, r);
              var s = h(this, t.call(this, u));
              return s.type = o.ATTRIBUTE, s.raws = {}, s;
            }
            return r.prototype.toString = function() {
              var s = [this.spaces.before, "[", this.ns, this.attribute];
              return this.operator && s.push(this.operator), this.value && s.push(this.value), this.raws.insensitive ? s.push(this.raws.insensitive) : this.insensitive && s.push(" i"), s.push("]"), s.concat(this.spaces.after).join("");
            }, r;
          }(a.default);
          e.default = c, n.exports = e.default;
        } }), Lo = R({ "node_modules/postcss-selector-parser/dist/selectors/universal.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = Ye(), a = f(i), o = oe();
          function f(t) {
            return t && t.__esModule ? t : { default: t };
          }
          function p(t, r) {
            if (!(t instanceof r)) throw new TypeError("Cannot call a class as a function");
          }
          function h(t, r) {
            if (!t) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r && (typeof r == "object" || typeof r == "function") ? r : t;
          }
          function g(t, r) {
            if (typeof r != "function" && r !== null) throw new TypeError("Super expression must either be null or a function, not " + typeof r);
            t.prototype = Object.create(r && r.prototype, { constructor: { value: t, enumerable: false, writable: true, configurable: true } }), r && (Object.setPrototypeOf ? Object.setPrototypeOf(t, r) : t.__proto__ = r);
          }
          var c = function(t) {
            g(r, t);
            function r(u) {
              p(this, r);
              var s = h(this, t.call(this, u));
              return s.type = o.UNIVERSAL, s.value = "*", s;
            }
            return r;
          }(a.default);
          e.default = c, n.exports = e.default;
        } }), zo = R({ "node_modules/postcss-selector-parser/dist/selectors/combinator.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = ze(), a = f(i), o = oe();
          function f(t) {
            return t && t.__esModule ? t : { default: t };
          }
          function p(t, r) {
            if (!(t instanceof r)) throw new TypeError("Cannot call a class as a function");
          }
          function h(t, r) {
            if (!t) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r && (typeof r == "object" || typeof r == "function") ? r : t;
          }
          function g(t, r) {
            if (typeof r != "function" && r !== null) throw new TypeError("Super expression must either be null or a function, not " + typeof r);
            t.prototype = Object.create(r && r.prototype, { constructor: { value: t, enumerable: false, writable: true, configurable: true } }), r && (Object.setPrototypeOf ? Object.setPrototypeOf(t, r) : t.__proto__ = r);
          }
          var c = function(t) {
            g(r, t);
            function r(u) {
              p(this, r);
              var s = h(this, t.call(this, u));
              return s.type = o.COMBINATOR, s;
            }
            return r;
          }(a.default);
          e.default = c, n.exports = e.default;
        } }), Bo = R({ "node_modules/postcss-selector-parser/dist/selectors/nesting.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = ze(), a = f(i), o = oe();
          function f(t) {
            return t && t.__esModule ? t : { default: t };
          }
          function p(t, r) {
            if (!(t instanceof r)) throw new TypeError("Cannot call a class as a function");
          }
          function h(t, r) {
            if (!t) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r && (typeof r == "object" || typeof r == "function") ? r : t;
          }
          function g(t, r) {
            if (typeof r != "function" && r !== null) throw new TypeError("Super expression must either be null or a function, not " + typeof r);
            t.prototype = Object.create(r && r.prototype, { constructor: { value: t, enumerable: false, writable: true, configurable: true } }), r && (Object.setPrototypeOf ? Object.setPrototypeOf(t, r) : t.__proto__ = r);
          }
          var c = function(t) {
            g(r, t);
            function r(u) {
              p(this, r);
              var s = h(this, t.call(this, u));
              return s.type = o.NESTING, s.value = "&", s;
            }
            return r;
          }(a.default);
          e.default = c, n.exports = e.default;
        } }), ff = R({ "node_modules/postcss-selector-parser/dist/sortAscending.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = i;
          function i(a) {
            return a.sort(function(o, f) {
              return o - f;
            });
          }
          n.exports = e.default;
        } }), pf = R({ "node_modules/postcss-selector-parser/dist/tokenize.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = H;
          var i = 39, a = 34, o = 92, f = 47, p = 10, h = 32, g = 12, c = 9, t = 13, r = 43, u = 62, s = 126, l = 124, m = 44, v = 40, y = 41, w = 91, d = 93, _ = 59, S = 42, x = 58, N = 38, P = 64, W = /[ \n\t\r\{\(\)'"\\;/]/g, U = /[ \n\t\r\(\)\*:;@!&'"\+\|~>,\[\]\\]|\/(?=\*)/g;
          function H(D) {
            for (var $ = [], B = D.css.valueOf(), O = void 0, j = void 0, C = void 0, I = void 0, X = void 0, Z = void 0, Q = void 0, K = void 0, J = void 0, M = void 0, Y = void 0, G = B.length, E = -1, k = 1, b = 0, L = function(T, F) {
              if (D.safe) B += F, j = B.length - 1;
              else throw D.error("Unclosed " + T, k, b - E, b);
            }; b < G; ) {
              switch (O = B.charCodeAt(b), O === p && (E = b, k += 1), O) {
                case p:
                case h:
                case c:
                case t:
                case g:
                  j = b;
                  do
                    j += 1, O = B.charCodeAt(j), O === p && (E = j, k += 1);
                  while (O === h || O === p || O === c || O === t || O === g);
                  $.push(["space", B.slice(b, j), k, b - E, b]), b = j - 1;
                  break;
                case r:
                case u:
                case s:
                case l:
                  j = b;
                  do
                    j += 1, O = B.charCodeAt(j);
                  while (O === r || O === u || O === s || O === l);
                  $.push(["combinator", B.slice(b, j), k, b - E, b]), b = j - 1;
                  break;
                case S:
                  $.push(["*", "*", k, b - E, b]);
                  break;
                case N:
                  $.push(["&", "&", k, b - E, b]);
                  break;
                case m:
                  $.push([",", ",", k, b - E, b]);
                  break;
                case w:
                  $.push(["[", "[", k, b - E, b]);
                  break;
                case d:
                  $.push(["]", "]", k, b - E, b]);
                  break;
                case x:
                  $.push([":", ":", k, b - E, b]);
                  break;
                case _:
                  $.push([";", ";", k, b - E, b]);
                  break;
                case v:
                  $.push(["(", "(", k, b - E, b]);
                  break;
                case y:
                  $.push([")", ")", k, b - E, b]);
                  break;
                case i:
                case a:
                  C = O === i ? "'" : '"', j = b;
                  do
                    for (M = false, j = B.indexOf(C, j + 1), j === -1 && L("quote", C), Y = j; B.charCodeAt(Y - 1) === o; ) Y -= 1, M = !M;
                  while (M);
                  $.push(["string", B.slice(b, j + 1), k, b - E, k, j - E, b]), b = j;
                  break;
                case P:
                  W.lastIndex = b + 1, W.test(B), W.lastIndex === 0 ? j = B.length - 1 : j = W.lastIndex - 2, $.push(["at-word", B.slice(b, j + 1), k, b - E, k, j - E, b]), b = j;
                  break;
                case o:
                  for (j = b, Q = true; B.charCodeAt(j + 1) === o; ) j += 1, Q = !Q;
                  O = B.charCodeAt(j + 1), Q && O !== f && O !== h && O !== p && O !== c && O !== t && O !== g && (j += 1), $.push(["word", B.slice(b, j + 1), k, b - E, k, j - E, b]), b = j;
                  break;
                default:
                  O === f && B.charCodeAt(b + 1) === S ? (j = B.indexOf("*/", b + 2) + 1, j === 0 && L("comment", "*/"), Z = B.slice(b, j + 1), I = Z.split(`
`), X = I.length - 1, X > 0 ? (K = k + X, J = j - I[X].length) : (K = k, J = E), $.push(["comment", Z, k, b - E, K, j - J, b]), E = J, k = K, b = j) : (U.lastIndex = b + 1, U.test(B), U.lastIndex === 0 ? j = B.length - 1 : j = U.lastIndex - 2, $.push(["word", B.slice(b, j + 1), k, b - E, k, j - E, b]), b = j);
                  break;
              }
              b++;
            }
            return $;
          }
          n.exports = e.default;
        } }), hf = R({ "node_modules/postcss-selector-parser/dist/parser.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = /* @__PURE__ */ function() {
            function E(k, b) {
              for (var L = 0; L < b.length; L++) {
                var q = b[L];
                q.enumerable = q.enumerable || false, q.configurable = true, "value" in q && (q.writable = true), Object.defineProperty(k, q.key, q);
              }
            }
            return function(k, b, L) {
              return b && E(k.prototype, b), L && E(k, L), k;
            };
          }(), a = To(), o = M(a), f = Eo(), p = M(f), h = qo(), g = M(h), c = Ao(), t = M(c), r = Po(), u = M(r), s = Ro(), l = M(s), m = Io(), v = M(m), y = Co(), w = M(y), d = No(), _ = M(d), S = jo(), x = M(S), N = Mo(), P = M(N), W = Do(), U = M(W), H = Lo(), D = M(H), $ = zo(), B = M($), O = Bo(), j = M(O), C = ff(), I = M(C), X = pf(), Z = M(X), Q = oe(), K = J(Q);
          function J(E) {
            if (E && E.__esModule) return E;
            var k = {};
            if (E != null) for (var b in E) Object.prototype.hasOwnProperty.call(E, b) && (k[b] = E[b]);
            return k.default = E, k;
          }
          function M(E) {
            return E && E.__esModule ? E : { default: E };
          }
          function Y(E, k) {
            if (!(E instanceof k)) throw new TypeError("Cannot call a class as a function");
          }
          var G = function() {
            function E(k) {
              Y(this, E), this.input = k, this.lossy = k.options.lossless === false, this.position = 0, this.root = new t.default();
              var b = new u.default();
              return this.root.append(b), this.current = b, this.lossy ? this.tokens = (0, Z.default)({ safe: k.safe, css: k.css.trim() }) : this.tokens = (0, Z.default)(k), this.loop();
            }
            return E.prototype.attribute = function() {
              var b = "", L = void 0, q = this.currToken;
              for (this.position++; this.position < this.tokens.length && this.currToken[0] !== "]"; ) b += this.tokens[this.position][1], this.position++;
              this.position === this.tokens.length && !~b.indexOf("]") && this.error("Expected a closing square bracket.");
              var T = b.split(/((?:[*~^$|]?=))([^]*)/), F = T[0].split(/(\|)/g), z2 = { operator: T[1], value: T[2], source: { start: { line: q[2], column: q[3] }, end: { line: this.currToken[2], column: this.currToken[3] } }, sourceIndex: q[4] };
              if (F.length > 1 ? (F[0] === "" && (F[0] = true), z2.attribute = this.parseValue(F[2]), z2.namespace = this.parseNamespace(F[0])) : z2.attribute = this.parseValue(T[0]), L = new U.default(z2), T[2]) {
                var re = T[2].split(/(\s+i\s*?)$/), ne = re[0].trim();
                L.value = this.lossy ? ne : re[0], re[1] && (L.insensitive = true, this.lossy || (L.raws.insensitive = re[1])), L.quoted = ne[0] === "'" || ne[0] === '"', L.raws.unquoted = L.quoted ? ne.slice(1, -1) : ne;
              }
              this.newNode(L), this.position++;
            }, E.prototype.combinator = function() {
              if (this.currToken[1] === "|") return this.namespace();
              for (var b = new B.default({ value: "", source: { start: { line: this.currToken[2], column: this.currToken[3] }, end: { line: this.currToken[2], column: this.currToken[3] } }, sourceIndex: this.currToken[4] }); this.position < this.tokens.length && this.currToken && (this.currToken[0] === "space" || this.currToken[0] === "combinator"); ) this.nextToken && this.nextToken[0] === "combinator" ? (b.spaces.before = this.parseSpace(this.currToken[1]), b.source.start.line = this.nextToken[2], b.source.start.column = this.nextToken[3], b.source.end.column = this.nextToken[3], b.source.end.line = this.nextToken[2], b.sourceIndex = this.nextToken[4]) : this.prevToken && this.prevToken[0] === "combinator" ? b.spaces.after = this.parseSpace(this.currToken[1]) : this.currToken[0] === "combinator" ? b.value = this.currToken[1] : this.currToken[0] === "space" && (b.value = this.parseSpace(this.currToken[1], " ")), this.position++;
              return this.newNode(b);
            }, E.prototype.comma = function() {
              if (this.position === this.tokens.length - 1) {
                this.root.trailingComma = true, this.position++;
                return;
              }
              var b = new u.default();
              this.current.parent.append(b), this.current = b, this.position++;
            }, E.prototype.comment = function() {
              var b = new v.default({ value: this.currToken[1], source: { start: { line: this.currToken[2], column: this.currToken[3] }, end: { line: this.currToken[4], column: this.currToken[5] } }, sourceIndex: this.currToken[6] });
              this.newNode(b), this.position++;
            }, E.prototype.error = function(b) {
              throw new this.input.error(b);
            }, E.prototype.missingBackslash = function() {
              return this.error("Expected a backslash preceding the semicolon.");
            }, E.prototype.missingParenthesis = function() {
              return this.error("Expected opening parenthesis.");
            }, E.prototype.missingSquareBracket = function() {
              return this.error("Expected opening square bracket.");
            }, E.prototype.namespace = function() {
              var b = this.prevToken && this.prevToken[1] || true;
              if (this.nextToken[0] === "word") return this.position++, this.word(b);
              if (this.nextToken[0] === "*") return this.position++, this.universal(b);
            }, E.prototype.nesting = function() {
              this.newNode(new j.default({ value: this.currToken[1], source: { start: { line: this.currToken[2], column: this.currToken[3] }, end: { line: this.currToken[2], column: this.currToken[3] } }, sourceIndex: this.currToken[4] })), this.position++;
            }, E.prototype.parentheses = function() {
              var b = this.current.last;
              if (b && b.type === K.PSEUDO) {
                var L = new u.default(), q = this.current;
                b.append(L), this.current = L;
                var T = 1;
                for (this.position++; this.position < this.tokens.length && T; ) this.currToken[0] === "(" && T++, this.currToken[0] === ")" && T--, T ? this.parse() : (L.parent.source.end.line = this.currToken[2], L.parent.source.end.column = this.currToken[3], this.position++);
                T && this.error("Expected closing parenthesis."), this.current = q;
              } else {
                var F = 1;
                for (this.position++, b.value += "("; this.position < this.tokens.length && F; ) this.currToken[0] === "(" && F++, this.currToken[0] === ")" && F--, b.value += this.parseParenthesisToken(this.currToken), this.position++;
                F && this.error("Expected closing parenthesis.");
              }
            }, E.prototype.pseudo = function() {
              for (var b = this, L = "", q = this.currToken; this.currToken && this.currToken[0] === ":"; ) L += this.currToken[1], this.position++;
              if (!this.currToken) return this.error("Expected pseudo-class or pseudo-element");
              if (this.currToken[0] === "word") {
                var T = void 0;
                this.splitWord(false, function(F, z2) {
                  L += F, T = new P.default({ value: L, source: { start: { line: q[2], column: q[3] }, end: { line: b.currToken[4], column: b.currToken[5] } }, sourceIndex: q[4] }), b.newNode(T), z2 > 1 && b.nextToken && b.nextToken[0] === "(" && b.error("Misplaced parenthesis.");
                });
              } else this.error('Unexpected "' + this.currToken[0] + '" found.');
            }, E.prototype.space = function() {
              var b = this.currToken;
              this.position === 0 || this.prevToken[0] === "," || this.prevToken[0] === "(" ? (this.spaces = this.parseSpace(b[1]), this.position++) : this.position === this.tokens.length - 1 || this.nextToken[0] === "," || this.nextToken[0] === ")" ? (this.current.last.spaces.after = this.parseSpace(b[1]), this.position++) : this.combinator();
            }, E.prototype.string = function() {
              var b = this.currToken;
              this.newNode(new x.default({ value: this.currToken[1], source: { start: { line: b[2], column: b[3] }, end: { line: b[4], column: b[5] } }, sourceIndex: b[6] })), this.position++;
            }, E.prototype.universal = function(b) {
              var L = this.nextToken;
              if (L && L[1] === "|") return this.position++, this.namespace();
              this.newNode(new D.default({ value: this.currToken[1], source: { start: { line: this.currToken[2], column: this.currToken[3] }, end: { line: this.currToken[2], column: this.currToken[3] } }, sourceIndex: this.currToken[4] }), b), this.position++;
            }, E.prototype.splitWord = function(b, L) {
              for (var q = this, T = this.nextToken, F = this.currToken[1]; T && T[0] === "word"; ) {
                this.position++;
                var z2 = this.currToken[1];
                if (F += z2, z2.lastIndexOf("\\") === z2.length - 1) {
                  var re = this.nextToken;
                  re && re[0] === "space" && (F += this.parseSpace(re[1], " "), this.position++);
                }
                T = this.nextToken;
              }
              var ne = (0, p.default)(F, "."), ce = (0, p.default)(F, "#"), fe = (0, p.default)(F, "#{");
              fe.length && (ce = ce.filter(function(ie) {
                return !~fe.indexOf(ie);
              }));
              var te = (0, I.default)((0, g.default)((0, o.default)([[0], ne, ce])));
              te.forEach(function(ie, ae) {
                var se = te[ae + 1] || F.length, le = F.slice(ie, se);
                if (ae === 0 && L) return L.call(q, le, te.length);
                var pe = void 0;
                ~ne.indexOf(ie) ? pe = new l.default({ value: le.slice(1), source: { start: { line: q.currToken[2], column: q.currToken[3] + ie }, end: { line: q.currToken[4], column: q.currToken[3] + (se - 1) } }, sourceIndex: q.currToken[6] + te[ae] }) : ~ce.indexOf(ie) ? pe = new w.default({ value: le.slice(1), source: { start: { line: q.currToken[2], column: q.currToken[3] + ie }, end: { line: q.currToken[4], column: q.currToken[3] + (se - 1) } }, sourceIndex: q.currToken[6] + te[ae] }) : pe = new _.default({ value: le, source: { start: { line: q.currToken[2], column: q.currToken[3] + ie }, end: { line: q.currToken[4], column: q.currToken[3] + (se - 1) } }, sourceIndex: q.currToken[6] + te[ae] }), q.newNode(pe, b);
              }), this.position++;
            }, E.prototype.word = function(b) {
              var L = this.nextToken;
              return L && L[1] === "|" ? (this.position++, this.namespace()) : this.splitWord(b);
            }, E.prototype.loop = function() {
              for (; this.position < this.tokens.length; ) this.parse(true);
              return this.root;
            }, E.prototype.parse = function(b) {
              switch (this.currToken[0]) {
                case "space":
                  this.space();
                  break;
                case "comment":
                  this.comment();
                  break;
                case "(":
                  this.parentheses();
                  break;
                case ")":
                  b && this.missingParenthesis();
                  break;
                case "[":
                  this.attribute();
                  break;
                case "]":
                  this.missingSquareBracket();
                  break;
                case "at-word":
                case "word":
                  this.word();
                  break;
                case ":":
                  this.pseudo();
                  break;
                case ";":
                  this.missingBackslash();
                  break;
                case ",":
                  this.comma();
                  break;
                case "*":
                  this.universal();
                  break;
                case "&":
                  this.nesting();
                  break;
                case "combinator":
                  this.combinator();
                  break;
                case "string":
                  this.string();
                  break;
              }
            }, E.prototype.parseNamespace = function(b) {
              if (this.lossy && typeof b == "string") {
                var L = b.trim();
                return L.length ? L : true;
              }
              return b;
            }, E.prototype.parseSpace = function(b, L) {
              return this.lossy ? L || "" : b;
            }, E.prototype.parseValue = function(b) {
              return this.lossy && b && typeof b == "string" ? b.trim() : b;
            }, E.prototype.parseParenthesisToken = function(b) {
              return this.lossy ? b[0] === "space" ? this.parseSpace(b[1], " ") : this.parseValue(b[1]) : b[1];
            }, E.prototype.newNode = function(b, L) {
              return L && (b.namespace = this.parseNamespace(L)), this.spaces && (b.spaces.before = this.spaces, this.spaces = ""), this.current.append(b);
            }, i(E, [{ key: "currToken", get: function() {
              return this.tokens[this.position];
            } }, { key: "nextToken", get: function() {
              return this.tokens[this.position + 1];
            } }, { key: "prevToken", get: function() {
              return this.tokens[this.position - 1];
            } }]), E;
          }();
          e.default = G, n.exports = e.default;
        } }), df = R({ "node_modules/postcss-selector-parser/dist/processor.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = /* @__PURE__ */ function() {
            function g(c, t) {
              for (var r = 0; r < t.length; r++) {
                var u = t[r];
                u.enumerable = u.enumerable || false, u.configurable = true, "value" in u && (u.writable = true), Object.defineProperty(c, u.key, u);
              }
            }
            return function(c, t, r) {
              return t && g(c.prototype, t), r && g(c, r), c;
            };
          }(), a = hf(), o = f(a);
          function f(g) {
            return g && g.__esModule ? g : { default: g };
          }
          function p(g, c) {
            if (!(g instanceof c)) throw new TypeError("Cannot call a class as a function");
          }
          var h = function() {
            function g(c) {
              return p(this, g), this.func = c || function() {
              }, this;
            }
            return g.prototype.process = function(t) {
              var r = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, u = new o.default({ css: t, error: function(l) {
                throw new Error(l);
              }, options: r });
              return this.res = u, this.func(u), this;
            }, i(g, [{ key: "result", get: function() {
              return String(this.res);
            } }]), g;
          }();
          e.default = h, n.exports = e.default;
        } }), vf = R({ "node_modules/postcss-selector-parser/dist/index.js"(e, n) {
          "use strict";
          A(), e.__esModule = true;
          var i = df(), a = O(i), o = Do(), f = O(o), p = Ro(), h = O(p), g = zo(), c = O(g), t = Io(), r = O(t), u = Co(), s = O(u), l = Bo(), m = O(l), v = Mo(), y = O(v), w = Ao(), d = O(w), _ = Po(), S = O(_), x = jo(), N = O(x), P = No(), W = O(P), U = Lo(), H = O(U), D = oe(), $ = B(D);
          function B(C) {
            if (C && C.__esModule) return C;
            var I = {};
            if (C != null) for (var X in C) Object.prototype.hasOwnProperty.call(C, X) && (I[X] = C[X]);
            return I.default = C, I;
          }
          function O(C) {
            return C && C.__esModule ? C : { default: C };
          }
          var j = function(I) {
            return new a.default(I);
          };
          j.attribute = function(C) {
            return new f.default(C);
          }, j.className = function(C) {
            return new h.default(C);
          }, j.combinator = function(C) {
            return new c.default(C);
          }, j.comment = function(C) {
            return new r.default(C);
          }, j.id = function(C) {
            return new s.default(C);
          }, j.nesting = function(C) {
            return new m.default(C);
          }, j.pseudo = function(C) {
            return new y.default(C);
          }, j.root = function(C) {
            return new d.default(C);
          }, j.selector = function(C) {
            return new S.default(C);
          }, j.string = function(C) {
            return new N.default(C);
          }, j.tag = function(C) {
            return new W.default(C);
          }, j.universal = function(C) {
            return new H.default(C);
          }, Object.keys($).forEach(function(C) {
            C !== "__esModule" && (j[C] = $[C]);
          }), e.default = j, n.exports = e.default;
        } }), Fo = R({ "node_modules/postcss-media-query-parser/dist/nodes/Node.js"(e) {
          "use strict";
          A(), Object.defineProperty(e, "__esModule", { value: true });
          function n(i) {
            this.after = i.after, this.before = i.before, this.type = i.type, this.value = i.value, this.sourceIndex = i.sourceIndex;
          }
          e.default = n;
        } }), Uo = R({ "node_modules/postcss-media-query-parser/dist/nodes/Container.js"(e) {
          "use strict";
          A(), Object.defineProperty(e, "__esModule", { value: true });
          var n = Fo(), i = a(n);
          function a(f) {
            return f && f.__esModule ? f : { default: f };
          }
          function o(f) {
            var p = this;
            this.constructor(f), this.nodes = f.nodes, this.after === void 0 && (this.after = this.nodes.length > 0 ? this.nodes[this.nodes.length - 1].after : ""), this.before === void 0 && (this.before = this.nodes.length > 0 ? this.nodes[0].before : ""), this.sourceIndex === void 0 && (this.sourceIndex = this.before.length), this.nodes.forEach(function(h) {
              h.parent = p;
            });
          }
          o.prototype = Object.create(i.default.prototype), o.constructor = i.default, o.prototype.walk = function(p, h) {
            for (var g = typeof p == "string" || p instanceof RegExp, c = g ? h : p, t = typeof p == "string" ? new RegExp(p) : p, r = 0; r < this.nodes.length; r++) {
              var u = this.nodes[r], s = g ? t.test(u.type) : true;
              if (s && c && c(u, r, this.nodes) === false || u.nodes && u.walk(p, h) === false) return false;
            }
            return true;
          }, o.prototype.each = function() {
            for (var p = arguments.length <= 0 || arguments[0] === void 0 ? function() {
            } : arguments[0], h = 0; h < this.nodes.length; h++) {
              var g = this.nodes[h];
              if (p(g, h, this.nodes) === false) return false;
            }
            return true;
          }, e.default = o;
        } }), mf = R({ "node_modules/postcss-media-query-parser/dist/parsers.js"(e) {
          "use strict";
          A(), Object.defineProperty(e, "__esModule", { value: true }), e.parseMediaFeature = p, e.parseMediaQuery = h, e.parseMediaList = g;
          var n = Fo(), i = f(n), a = Uo(), o = f(a);
          function f(c) {
            return c && c.__esModule ? c : { default: c };
          }
          function p(c) {
            var t = arguments.length <= 1 || arguments[1] === void 0 ? 0 : arguments[1], r = [{ mode: "normal", character: null }], u = [], s = 0, l = "", m = null, v = null, y = t, w = c;
            c[0] === "(" && c[c.length - 1] === ")" && (w = c.substring(1, c.length - 1), y++);
            for (var d = 0; d < w.length; d++) {
              var _ = w[d];
              if ((_ === "'" || _ === '"') && (r[s].isCalculationEnabled === true ? (r.push({ mode: "string", isCalculationEnabled: false, character: _ }), s++) : r[s].mode === "string" && r[s].character === _ && w[d - 1] !== "\\" && (r.pop(), s--)), _ === "{" ? (r.push({ mode: "interpolation", isCalculationEnabled: true }), s++) : _ === "}" && (r.pop(), s--), r[s].mode === "normal" && _ === ":") {
                var S = w.substring(d + 1);
                v = { type: "value", before: /^(\s*)/.exec(S)[1], after: /(\s*)$/.exec(S)[1], value: S.trim() }, v.sourceIndex = v.before.length + d + 1 + y, m = { type: "colon", sourceIndex: d + y, after: v.before, value: ":" };
                break;
              }
              l += _;
            }
            return l = { type: "media-feature", before: /^(\s*)/.exec(l)[1], after: /(\s*)$/.exec(l)[1], value: l.trim() }, l.sourceIndex = l.before.length + y, u.push(l), m !== null && (m.before = l.after, u.push(m)), v !== null && u.push(v), u;
          }
          function h(c) {
            var t = arguments.length <= 1 || arguments[1] === void 0 ? 0 : arguments[1], r = [], u = 0, s = false, l = void 0;
            function m() {
              return { before: "", after: "", value: "" };
            }
            l = m();
            for (var v = 0; v < c.length; v++) {
              var y = c[v];
              s ? (l.value += y, (y === "{" || y === "(") && u++, (y === ")" || y === "}") && u--) : y.search(/\s/) !== -1 ? l.before += y : (y === "(" && (l.type = "media-feature-expression", u++), l.value = y, l.sourceIndex = t + v, s = true), s && u === 0 && (y === ")" || v === c.length - 1 || c[v + 1].search(/\s/) !== -1) && (["not", "only", "and"].indexOf(l.value) !== -1 && (l.type = "keyword"), l.type === "media-feature-expression" && (l.nodes = p(l.value, l.sourceIndex)), r.push(Array.isArray(l.nodes) ? new o.default(l) : new i.default(l)), l = m(), s = false);
            }
            for (var w = 0; w < r.length; w++) if (l = r[w], w > 0 && (r[w - 1].after = l.before), l.type === void 0) {
              if (w > 0) {
                if (r[w - 1].type === "media-feature-expression") {
                  l.type = "keyword";
                  continue;
                }
                if (r[w - 1].value === "not" || r[w - 1].value === "only") {
                  l.type = "media-type";
                  continue;
                }
                if (r[w - 1].value === "and") {
                  l.type = "media-feature-expression";
                  continue;
                }
                r[w - 1].type === "media-type" && (r[w + 1] ? l.type = r[w + 1].type === "media-feature-expression" ? "keyword" : "media-feature-expression" : l.type = "media-feature-expression");
              }
              if (w === 0) {
                if (!r[w + 1]) {
                  l.type = "media-type";
                  continue;
                }
                if (r[w + 1] && (r[w + 1].type === "media-feature-expression" || r[w + 1].type === "keyword")) {
                  l.type = "media-type";
                  continue;
                }
                if (r[w + 2]) {
                  if (r[w + 2].type === "media-feature-expression") {
                    l.type = "media-type", r[w + 1].type = "keyword";
                    continue;
                  }
                  if (r[w + 2].type === "keyword") {
                    l.type = "keyword", r[w + 1].type = "media-type";
                    continue;
                  }
                }
                if (r[w + 3] && r[w + 3].type === "media-feature-expression") {
                  l.type = "keyword", r[w + 1].type = "media-type", r[w + 2].type = "keyword";
                  continue;
                }
              }
            }
            return r;
          }
          function g(c) {
            var t = [], r = 0, u = 0, s = /^(\s*)url\s*\(/.exec(c);
            if (s !== null) {
              for (var l = s[0].length, m = 1; m > 0; ) {
                var v = c[l];
                v === "(" && m++, v === ")" && m--, l++;
              }
              t.unshift(new i.default({ type: "url", value: c.substring(0, l).trim(), sourceIndex: s[1].length, before: s[1], after: /^(\s*)/.exec(c.substring(l))[1] })), r = l;
            }
            for (var y = r; y < c.length; y++) {
              var w = c[y];
              if (w === "(" && u++, w === ")" && u--, u === 0 && w === ",") {
                var d = c.substring(r, y), _ = /^(\s*)/.exec(d)[1];
                t.push(new o.default({ type: "media-query", value: d.trim(), sourceIndex: r + _.length, nodes: h(d, r), before: _, after: /(\s*)$/.exec(d)[1] })), r = y + 1;
              }
            }
            var S = c.substring(r), x = /^(\s*)/.exec(S)[1];
            return t.push(new o.default({ type: "media-query", value: S.trim(), sourceIndex: r + x.length, nodes: h(S, r), before: x, after: /(\s*)$/.exec(S)[1] })), t;
          }
        } }), gf = R({ "node_modules/postcss-media-query-parser/dist/index.js"(e) {
          "use strict";
          A(), Object.defineProperty(e, "__esModule", { value: true }), e.default = f;
          var n = Uo(), i = o(n), a = mf();
          function o(p) {
            return p && p.__esModule ? p : { default: p };
          }
          function f(p) {
            return new i.default({ nodes: (0, a.parseMediaList)(p), type: "media-query-list", value: p.trim() });
          }
        } }), Wo = {};
        Ot(Wo, { basename: () => Jo, default: () => Qo, delimiter: () => _t, dirname: () => Ho, extname: () => Ko, isAbsolute: () => jt, join: () => Vo, normalize: () => Nt, relative: () => Go, resolve: () => mr, sep: () => wt });
        function $o(e, n) {
          for (var i = 0, a = e.length - 1; a >= 0; a--) {
            var o = e[a];
            o === "." ? e.splice(a, 1) : o === ".." ? (e.splice(a, 1), i++) : i && (e.splice(a, 1), i--);
          }
          if (n) for (; i--; i) e.unshift("..");
          return e;
        }
        function mr() {
          for (var e = "", n = false, i = arguments.length - 1; i >= -1 && !n; i--) {
            var a = i >= 0 ? arguments[i] : "/";
            if (typeof a != "string") throw new TypeError("Arguments to path.resolve must be strings");
            if (!a) continue;
            e = a + "/" + e, n = a.charAt(0) === "/";
          }
          return e = $o(Mt(e.split("/"), function(o) {
            return !!o;
          }), !n).join("/"), (n ? "/" : "") + e || ".";
        }
        function Nt(e) {
          var n = jt(e), i = Yo(e, -1) === "/";
          return e = $o(Mt(e.split("/"), function(a) {
            return !!a;
          }), !n).join("/"), !e && !n && (e = "."), e && i && (e += "/"), (n ? "/" : "") + e;
        }
        function jt(e) {
          return e.charAt(0) === "/";
        }
        function Vo() {
          var e = Array.prototype.slice.call(arguments, 0);
          return Nt(Mt(e, function(n, i) {
            if (typeof n != "string") throw new TypeError("Arguments to path.join must be strings");
            return n;
          }).join("/"));
        }
        function Go(e, n) {
          e = mr(e).substr(1), n = mr(n).substr(1);
          function i(c) {
            for (var t = 0; t < c.length && c[t] === ""; t++) ;
            for (var r = c.length - 1; r >= 0 && c[r] === ""; r--) ;
            return t > r ? [] : c.slice(t, r - t + 1);
          }
          for (var a = i(e.split("/")), o = i(n.split("/")), f = Math.min(a.length, o.length), p = f, h = 0; h < f; h++) if (a[h] !== o[h]) {
            p = h;
            break;
          }
          for (var g = [], h = p; h < a.length; h++) g.push("..");
          return g = g.concat(o.slice(p)), g.join("/");
        }
        function Ho(e) {
          var n = wr(e), i = n[0], a = n[1];
          return !i && !a ? "." : (a && (a = a.substr(0, a.length - 1)), i + a);
        }
        function Jo(e, n) {
          var i = wr(e)[2];
          return n && i.substr(-1 * n.length) === n && (i = i.substr(0, i.length - n.length)), i;
        }
        function Ko(e) {
          return wr(e)[3];
        }
        function Mt(e, n) {
          if (e.filter) return e.filter(n);
          for (var i = [], a = 0; a < e.length; a++) n(e[a], a, e) && i.push(e[a]);
          return i;
        }
        var Is, wr, wt, _t, Qo, Yo, yf = Le({ "node-modules-polyfills:path"() {
          A(), Is = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/, wr = function(e) {
            return Is.exec(e).slice(1);
          }, wt = "/", _t = ":", Qo = { extname: Ko, basename: Jo, dirname: Ho, sep: wt, delimiter: _t, relative: Go, join: Vo, isAbsolute: jt, normalize: Nt, resolve: mr }, Yo = "ab".substr(-1) === "b" ? function(e, n, i) {
            return e.substr(n, i);
          } : function(e, n, i) {
            return n < 0 && (n = e.length + n), e.substr(n, i);
          };
        } }), wf = R({ "node-modules-polyfills-commonjs:path"(e, n) {
          A();
          var i = (yf(), Tt(Wo));
          if (i && i.default) {
            n.exports = i.default;
            for (let a in i) n.exports[a] = i[a];
          } else i && (n.exports = i);
        } }), _f = R({ "node_modules/picocolors/picocolors.browser.js"(e, n) {
          A();
          var i = String, a = function() {
            return { isColorSupported: false, reset: i, bold: i, dim: i, italic: i, underline: i, inverse: i, hidden: i, strikethrough: i, black: i, red: i, green: i, yellow: i, blue: i, magenta: i, cyan: i, white: i, gray: i, bgBlack: i, bgRed: i, bgGreen: i, bgYellow: i, bgBlue: i, bgMagenta: i, bgCyan: i, bgWhite: i };
          };
          n.exports = a(), n.exports.createColors = a;
        } }), bf = R({ "(disabled):node_modules/postcss/lib/terminal-highlight"() {
          A();
        } }), Xo = R({ "node_modules/postcss/lib/css-syntax-error.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = o(_f()), a = o(bf());
          function o(m) {
            return m && m.__esModule ? m : { default: m };
          }
          function f(m) {
            if (m === void 0) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return m;
          }
          function p(m, v) {
            m.prototype = Object.create(v.prototype), m.prototype.constructor = m, m.__proto__ = v;
          }
          function h(m) {
            var v = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
            return h = function(w) {
              if (w === null || !t(w)) return w;
              if (typeof w != "function") throw new TypeError("Super expression must either be null or a function");
              if (typeof v < "u") {
                if (v.has(w)) return v.get(w);
                v.set(w, d);
              }
              function d() {
                return g(w, arguments, u(this).constructor);
              }
              return d.prototype = Object.create(w.prototype, { constructor: { value: d, enumerable: false, writable: true, configurable: true } }), r(d, w);
            }, h(m);
          }
          function g(m, v, y) {
            return c() ? g = Reflect.construct : g = function(d, _, S) {
              var x = [null];
              x.push.apply(x, _);
              var N = Function.bind.apply(d, x), P = new N();
              return S && r(P, S.prototype), P;
            }, g.apply(null, arguments);
          }
          function c() {
            if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham) return false;
            if (typeof Proxy == "function") return true;
            try {
              return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
              })), true;
            } catch {
              return false;
            }
          }
          function t(m) {
            return Function.toString.call(m).indexOf("[native code]") !== -1;
          }
          function r(m, v) {
            return r = Object.setPrototypeOf || function(w, d) {
              return w.__proto__ = d, w;
            }, r(m, v);
          }
          function u(m) {
            return u = Object.setPrototypeOf ? Object.getPrototypeOf : function(y) {
              return y.__proto__ || Object.getPrototypeOf(y);
            }, u(m);
          }
          var s = function(m) {
            p(v, m);
            function v(w, d, _, S, x, N) {
              var P;
              return P = m.call(this, w) || this, P.name = "CssSyntaxError", P.reason = w, x && (P.file = x), S && (P.source = S), N && (P.plugin = N), typeof d < "u" && typeof _ < "u" && (P.line = d, P.column = _), P.setMessage(), Error.captureStackTrace && Error.captureStackTrace(f(P), v), P;
            }
            var y = v.prototype;
            return y.setMessage = function() {
              this.message = this.plugin ? this.plugin + ": " : "", this.message += this.file ? this.file : "<css input>", typeof this.line < "u" && (this.message += ":" + this.line + ":" + this.column), this.message += ": " + this.reason;
            }, y.showSourceCode = function(d) {
              var _ = this;
              if (!this.source) return "";
              var S = this.source;
              a.default && (typeof d > "u" && (d = i.default.isColorSupported), d && (S = (0, a.default)(S)));
              var x = S.split(/\r?\n/), N = Math.max(this.line - 3, 0), P = Math.min(this.line + 2, x.length), W = String(P).length;
              function U(D) {
                return d && i.default.red ? i.default.red(i.default.bold(D)) : D;
              }
              function H(D) {
                return d && i.default.gray ? i.default.gray(D) : D;
              }
              return x.slice(N, P).map(function(D, $) {
                var B = N + 1 + $, O = " " + (" " + B).slice(-W) + " | ";
                if (B === _.line) {
                  var j = H(O.replace(/\d/g, " ")) + D.slice(0, _.column - 1).replace(/[^\t]/g, " ");
                  return U(">") + H(O) + D + `
 ` + j + U("^");
                }
                return " " + H(O) + D;
              }).join(`
`);
            }, y.toString = function() {
              var d = this.showSourceCode();
              return d && (d = `

` + d + `
`), this.name + ": " + this.message + d;
            }, v;
          }(h(Error)), l = s;
          e.default = l, n.exports = e.default;
        } }), xf = R({ "node_modules/postcss/lib/previous-map.js"(e, n) {
          A(), n.exports = class {
          };
        } }), _r = R({ "node_modules/postcss/lib/input.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = f(wf()), a = f(Xo()), o = f(xf());
          function f(r) {
            return r && r.__esModule ? r : { default: r };
          }
          function p(r, u) {
            for (var s = 0; s < u.length; s++) {
              var l = u[s];
              l.enumerable = l.enumerable || false, l.configurable = true, "value" in l && (l.writable = true), Object.defineProperty(r, l.key, l);
            }
          }
          function h(r, u, s) {
            return u && p(r.prototype, u), s && p(r, s), r;
          }
          var g = 0, c = function() {
            function r(s, l) {
              if (l === void 0 && (l = {}), s === null || typeof s > "u" || typeof s == "object" && !s.toString) throw new Error("PostCSS received " + s + " instead of CSS string");
              this.css = s.toString(), this.css[0] === "\uFEFF" || this.css[0] === "\uFFFE" ? (this.hasBOM = true, this.css = this.css.slice(1)) : this.hasBOM = false, l.from && (/^\w+:\/\//.test(l.from) || i.default.isAbsolute(l.from) ? this.file = l.from : this.file = i.default.resolve(l.from));
              var m = new o.default(this.css, l);
              if (m.text) {
                this.map = m;
                var v = m.consumer().file;
                !this.file && v && (this.file = this.mapResolve(v));
              }
              this.file || (g += 1, this.id = "<input css " + g + ">"), this.map && (this.map.file = this.from);
            }
            var u = r.prototype;
            return u.error = function(l, m, v, y) {
              y === void 0 && (y = {});
              var w, d = this.origin(m, v);
              return d ? w = new a.default(l, d.line, d.column, d.source, d.file, y.plugin) : w = new a.default(l, m, v, this.css, this.file, y.plugin), w.input = { line: m, column: v, source: this.css }, this.file && (w.input.file = this.file), w;
            }, u.origin = function(l, m) {
              if (!this.map) return false;
              var v = this.map.consumer(), y = v.originalPositionFor({ line: l, column: m });
              if (!y.source) return false;
              var w = { file: this.mapResolve(y.source), line: y.line, column: y.column }, d = v.sourceContentFor(y.source);
              return d && (w.source = d), w;
            }, u.mapResolve = function(l) {
              return /^\w+:\/\//.test(l) ? l : i.default.resolve(this.map.consumer().sourceRoot || ".", l);
            }, h(r, [{ key: "from", get: function() {
              return this.file || this.id;
            } }]), r;
          }(), t = c;
          e.default = t, n.exports = e.default;
        } }), br = R({ "node_modules/postcss/lib/stringifier.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = { colon: ": ", indent: "    ", beforeDecl: `
`, beforeRule: `
`, beforeOpen: " ", beforeClose: `
`, beforeComment: `
`, after: `
`, emptyBody: "", commentLeft: " ", commentRight: " ", semicolon: false };
          function a(p) {
            return p[0].toUpperCase() + p.slice(1);
          }
          var o = function() {
            function p(g) {
              this.builder = g;
            }
            var h = p.prototype;
            return h.stringify = function(c, t) {
              this[c.type](c, t);
            }, h.root = function(c) {
              this.body(c), c.raws.after && this.builder(c.raws.after);
            }, h.comment = function(c) {
              var t = this.raw(c, "left", "commentLeft"), r = this.raw(c, "right", "commentRight");
              this.builder("/*" + t + c.text + r + "*/", c);
            }, h.decl = function(c, t) {
              var r = this.raw(c, "between", "colon"), u = c.prop + r + this.rawValue(c, "value");
              c.important && (u += c.raws.important || " !important"), t && (u += ";"), this.builder(u, c);
            }, h.rule = function(c) {
              this.block(c, this.rawValue(c, "selector")), c.raws.ownSemicolon && this.builder(c.raws.ownSemicolon, c, "end");
            }, h.atrule = function(c, t) {
              var r = "@" + c.name, u = c.params ? this.rawValue(c, "params") : "";
              if (typeof c.raws.afterName < "u" ? r += c.raws.afterName : u && (r += " "), c.nodes) this.block(c, r + u);
              else {
                var s = (c.raws.between || "") + (t ? ";" : "");
                this.builder(r + u + s, c);
              }
            }, h.body = function(c) {
              for (var t = c.nodes.length - 1; t > 0 && c.nodes[t].type === "comment"; ) t -= 1;
              for (var r = this.raw(c, "semicolon"), u = 0; u < c.nodes.length; u++) {
                var s = c.nodes[u], l = this.raw(s, "before");
                l && this.builder(l), this.stringify(s, t !== u || r);
              }
            }, h.block = function(c, t) {
              var r = this.raw(c, "between", "beforeOpen");
              this.builder(t + r + "{", c, "start");
              var u;
              c.nodes && c.nodes.length ? (this.body(c), u = this.raw(c, "after")) : u = this.raw(c, "after", "emptyBody"), u && this.builder(u), this.builder("}", c, "end");
            }, h.raw = function(c, t, r) {
              var u;
              if (r || (r = t), t && (u = c.raws[t], typeof u < "u")) return u;
              var s = c.parent;
              if (r === "before" && (!s || s.type === "root" && s.first === c)) return "";
              if (!s) return i[r];
              var l = c.root();
              if (l.rawCache || (l.rawCache = {}), typeof l.rawCache[r] < "u") return l.rawCache[r];
              if (r === "before" || r === "after") return this.beforeAfter(c, r);
              var m = "raw" + a(r);
              return this[m] ? u = this[m](l, c) : l.walk(function(v) {
                if (u = v.raws[t], typeof u < "u") return false;
              }), typeof u > "u" && (u = i[r]), l.rawCache[r] = u, u;
            }, h.rawSemicolon = function(c) {
              var t;
              return c.walk(function(r) {
                if (r.nodes && r.nodes.length && r.last.type === "decl" && (t = r.raws.semicolon, typeof t < "u")) return false;
              }), t;
            }, h.rawEmptyBody = function(c) {
              var t;
              return c.walk(function(r) {
                if (r.nodes && r.nodes.length === 0 && (t = r.raws.after, typeof t < "u")) return false;
              }), t;
            }, h.rawIndent = function(c) {
              if (c.raws.indent) return c.raws.indent;
              var t;
              return c.walk(function(r) {
                var u = r.parent;
                if (u && u !== c && u.parent && u.parent === c && typeof r.raws.before < "u") {
                  var s = r.raws.before.split(`
`);
                  return t = s[s.length - 1], t = t.replace(/[^\s]/g, ""), false;
                }
              }), t;
            }, h.rawBeforeComment = function(c, t) {
              var r;
              return c.walkComments(function(u) {
                if (typeof u.raws.before < "u") return r = u.raws.before, r.indexOf(`
`) !== -1 && (r = r.replace(/[^\n]+$/, "")), false;
              }), typeof r > "u" ? r = this.raw(t, null, "beforeDecl") : r && (r = r.replace(/[^\s]/g, "")), r;
            }, h.rawBeforeDecl = function(c, t) {
              var r;
              return c.walkDecls(function(u) {
                if (typeof u.raws.before < "u") return r = u.raws.before, r.indexOf(`
`) !== -1 && (r = r.replace(/[^\n]+$/, "")), false;
              }), typeof r > "u" ? r = this.raw(t, null, "beforeRule") : r && (r = r.replace(/[^\s]/g, "")), r;
            }, h.rawBeforeRule = function(c) {
              var t;
              return c.walk(function(r) {
                if (r.nodes && (r.parent !== c || c.first !== r) && typeof r.raws.before < "u") return t = r.raws.before, t.indexOf(`
`) !== -1 && (t = t.replace(/[^\n]+$/, "")), false;
              }), t && (t = t.replace(/[^\s]/g, "")), t;
            }, h.rawBeforeClose = function(c) {
              var t;
              return c.walk(function(r) {
                if (r.nodes && r.nodes.length > 0 && typeof r.raws.after < "u") return t = r.raws.after, t.indexOf(`
`) !== -1 && (t = t.replace(/[^\n]+$/, "")), false;
              }), t && (t = t.replace(/[^\s]/g, "")), t;
            }, h.rawBeforeOpen = function(c) {
              var t;
              return c.walk(function(r) {
                if (r.type !== "decl" && (t = r.raws.between, typeof t < "u")) return false;
              }), t;
            }, h.rawColon = function(c) {
              var t;
              return c.walkDecls(function(r) {
                if (typeof r.raws.between < "u") return t = r.raws.between.replace(/[^\s:]/g, ""), false;
              }), t;
            }, h.beforeAfter = function(c, t) {
              var r;
              c.type === "decl" ? r = this.raw(c, null, "beforeDecl") : c.type === "comment" ? r = this.raw(c, null, "beforeComment") : t === "before" ? r = this.raw(c, null, "beforeRule") : r = this.raw(c, null, "beforeClose");
              for (var u = c.parent, s = 0; u && u.type !== "root"; ) s += 1, u = u.parent;
              if (r.indexOf(`
`) !== -1) {
                var l = this.raw(c, null, "indent");
                if (l.length) for (var m = 0; m < s; m++) r += l;
              }
              return r;
            }, h.rawValue = function(c, t) {
              var r = c[t], u = c.raws[t];
              return u && u.value === r ? u.raw : r;
            }, p;
          }(), f = o;
          e.default = f, n.exports = e.default;
        } }), Zo = R({ "node_modules/postcss/lib/stringify.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = a(br());
          function a(p) {
            return p && p.__esModule ? p : { default: p };
          }
          function o(p, h) {
            var g = new i.default(h);
            g.stringify(p);
          }
          var f = o;
          e.default = f, n.exports = e.default;
        } }), Dt = R({ "node_modules/postcss/lib/node.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = f(Xo()), a = f(br()), o = f(Zo());
          function f(c) {
            return c && c.__esModule ? c : { default: c };
          }
          function p(c, t) {
            var r = new c.constructor();
            for (var u in c) if (!!c.hasOwnProperty(u)) {
              var s = c[u], l = typeof s;
              u === "parent" && l === "object" ? t && (r[u] = t) : u === "source" ? r[u] = s : s instanceof Array ? r[u] = s.map(function(m) {
                return p(m, r);
              }) : (l === "object" && s !== null && (s = p(s)), r[u] = s);
            }
            return r;
          }
          var h = function() {
            function c(r) {
              r === void 0 && (r = {}), this.raws = {};
              for (var u in r) this[u] = r[u];
            }
            var t = c.prototype;
            return t.error = function(u, s) {
              if (s === void 0 && (s = {}), this.source) {
                var l = this.positionBy(s);
                return this.source.input.error(u, l.line, l.column, s);
              }
              return new i.default(u);
            }, t.warn = function(u, s, l) {
              var m = { node: this };
              for (var v in l) m[v] = l[v];
              return u.warn(s, m);
            }, t.remove = function() {
              return this.parent && this.parent.removeChild(this), this.parent = void 0, this;
            }, t.toString = function(u) {
              u === void 0 && (u = o.default), u.stringify && (u = u.stringify);
              var s = "";
              return u(this, function(l) {
                s += l;
              }), s;
            }, t.clone = function(u) {
              u === void 0 && (u = {});
              var s = p(this);
              for (var l in u) s[l] = u[l];
              return s;
            }, t.cloneBefore = function(u) {
              u === void 0 && (u = {});
              var s = this.clone(u);
              return this.parent.insertBefore(this, s), s;
            }, t.cloneAfter = function(u) {
              u === void 0 && (u = {});
              var s = this.clone(u);
              return this.parent.insertAfter(this, s), s;
            }, t.replaceWith = function() {
              if (this.parent) {
                for (var u = arguments.length, s = new Array(u), l = 0; l < u; l++) s[l] = arguments[l];
                for (var m = 0, v = s; m < v.length; m++) {
                  var y = v[m];
                  this.parent.insertBefore(this, y);
                }
                this.remove();
              }
              return this;
            }, t.next = function() {
              if (!!this.parent) {
                var u = this.parent.index(this);
                return this.parent.nodes[u + 1];
              }
            }, t.prev = function() {
              if (!!this.parent) {
                var u = this.parent.index(this);
                return this.parent.nodes[u - 1];
              }
            }, t.before = function(u) {
              return this.parent.insertBefore(this, u), this;
            }, t.after = function(u) {
              return this.parent.insertAfter(this, u), this;
            }, t.toJSON = function() {
              var u = {};
              for (var s in this) if (!!this.hasOwnProperty(s) && s !== "parent") {
                var l = this[s];
                l instanceof Array ? u[s] = l.map(function(m) {
                  return typeof m == "object" && m.toJSON ? m.toJSON() : m;
                }) : typeof l == "object" && l.toJSON ? u[s] = l.toJSON() : u[s] = l;
              }
              return u;
            }, t.raw = function(u, s) {
              var l = new a.default();
              return l.raw(this, u, s);
            }, t.root = function() {
              for (var u = this; u.parent; ) u = u.parent;
              return u;
            }, t.cleanRaws = function(u) {
              delete this.raws.before, delete this.raws.after, u || delete this.raws.between;
            }, t.positionInside = function(u) {
              for (var s = this.toString(), l = this.source.start.column, m = this.source.start.line, v = 0; v < u; v++) s[v] === `
` ? (l = 1, m += 1) : l += 1;
              return { line: m, column: l };
            }, t.positionBy = function(u) {
              var s = this.source.start;
              if (u.index) s = this.positionInside(u.index);
              else if (u.word) {
                var l = this.toString().indexOf(u.word);
                l !== -1 && (s = this.positionInside(l));
              }
              return s;
            }, c;
          }(), g = h;
          e.default = g, n.exports = e.default;
        } }), xr = R({ "node_modules/postcss/lib/comment.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = a(Dt());
          function a(h) {
            return h && h.__esModule ? h : { default: h };
          }
          function o(h, g) {
            h.prototype = Object.create(g.prototype), h.prototype.constructor = h, h.__proto__ = g;
          }
          var f = function(h) {
            o(g, h);
            function g(c) {
              var t;
              return t = h.call(this, c) || this, t.type = "comment", t;
            }
            return g;
          }(i.default), p = f;
          e.default = p, n.exports = e.default;
        } }), ea = R({ "node_modules/postcss/lib/declaration.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = a(Dt());
          function a(h) {
            return h && h.__esModule ? h : { default: h };
          }
          function o(h, g) {
            h.prototype = Object.create(g.prototype), h.prototype.constructor = h, h.__proto__ = g;
          }
          var f = function(h) {
            o(g, h);
            function g(c) {
              var t;
              return t = h.call(this, c) || this, t.type = "decl", t;
            }
            return g;
          }(i.default), p = f;
          e.default = p, n.exports = e.default;
        } }), Lt = R({ "node_modules/postcss/lib/tokenize.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = W;
          var i = "'".charCodeAt(0), a = '"'.charCodeAt(0), o = "\\".charCodeAt(0), f = "/".charCodeAt(0), p = `
`.charCodeAt(0), h = " ".charCodeAt(0), g = "\f".charCodeAt(0), c = "	".charCodeAt(0), t = "\r".charCodeAt(0), r = "[".charCodeAt(0), u = "]".charCodeAt(0), s = "(".charCodeAt(0), l = ")".charCodeAt(0), m = "{".charCodeAt(0), v = "}".charCodeAt(0), y = ";".charCodeAt(0), w = "*".charCodeAt(0), d = ":".charCodeAt(0), _ = "@".charCodeAt(0), S = /[ \n\t\r\f{}()'"\\;/[\]#]/g, x = /[ \n\t\r\f(){}:;@!'"\\\][#]|\/(?=\*)/g, N = /.[\\/("'\n]/, P = /[a-f0-9]/i;
          function W(U, H) {
            H === void 0 && (H = {});
            var D = U.css.valueOf(), $ = H.ignoreErrors, B, O, j, C, I, X, Z, Q, K, J, M, Y, G, E, k = D.length, b = -1, L = 1, q = 0, T = [], F = [];
            function z2() {
              return q;
            }
            function re(te) {
              throw U.error("Unclosed " + te, L, q - b);
            }
            function ne() {
              return F.length === 0 && q >= k;
            }
            function ce(te) {
              if (F.length) return F.pop();
              if (!(q >= k)) {
                var ie = te ? te.ignoreUnclosed : false;
                switch (B = D.charCodeAt(q), (B === p || B === g || B === t && D.charCodeAt(q + 1) !== p) && (b = q, L += 1), B) {
                  case p:
                  case h:
                  case c:
                  case t:
                  case g:
                    O = q;
                    do
                      O += 1, B = D.charCodeAt(O), B === p && (b = O, L += 1);
                    while (B === h || B === p || B === c || B === t || B === g);
                    E = ["space", D.slice(q, O)], q = O - 1;
                    break;
                  case r:
                  case u:
                  case m:
                  case v:
                  case d:
                  case y:
                  case l:
                    var ae = String.fromCharCode(B);
                    E = [ae, ae, L, q - b];
                    break;
                  case s:
                    if (Y = T.length ? T.pop()[1] : "", G = D.charCodeAt(q + 1), Y === "url" && G !== i && G !== a && G !== h && G !== p && G !== c && G !== g && G !== t) {
                      O = q;
                      do {
                        if (J = false, O = D.indexOf(")", O + 1), O === -1) if ($ || ie) {
                          O = q;
                          break;
                        } else re("bracket");
                        for (M = O; D.charCodeAt(M - 1) === o; ) M -= 1, J = !J;
                      } while (J);
                      E = ["brackets", D.slice(q, O + 1), L, q - b, L, O - b], q = O;
                    } else O = D.indexOf(")", q + 1), X = D.slice(q, O + 1), O === -1 || N.test(X) ? E = ["(", "(", L, q - b] : (E = ["brackets", X, L, q - b, L, O - b], q = O);
                    break;
                  case i:
                  case a:
                    j = B === i ? "'" : '"', O = q;
                    do {
                      if (J = false, O = D.indexOf(j, O + 1), O === -1) if ($ || ie) {
                        O = q + 1;
                        break;
                      } else re("string");
                      for (M = O; D.charCodeAt(M - 1) === o; ) M -= 1, J = !J;
                    } while (J);
                    X = D.slice(q, O + 1), C = X.split(`
`), I = C.length - 1, I > 0 ? (Q = L + I, K = O - C[I].length) : (Q = L, K = b), E = ["string", D.slice(q, O + 1), L, q - b, Q, O - K], b = K, L = Q, q = O;
                    break;
                  case _:
                    S.lastIndex = q + 1, S.test(D), S.lastIndex === 0 ? O = D.length - 1 : O = S.lastIndex - 2, E = ["at-word", D.slice(q, O + 1), L, q - b, L, O - b], q = O;
                    break;
                  case o:
                    for (O = q, Z = true; D.charCodeAt(O + 1) === o; ) O += 1, Z = !Z;
                    if (B = D.charCodeAt(O + 1), Z && B !== f && B !== h && B !== p && B !== c && B !== t && B !== g && (O += 1, P.test(D.charAt(O)))) {
                      for (; P.test(D.charAt(O + 1)); ) O += 1;
                      D.charCodeAt(O + 1) === h && (O += 1);
                    }
                    E = ["word", D.slice(q, O + 1), L, q - b, L, O - b], q = O;
                    break;
                  default:
                    B === f && D.charCodeAt(q + 1) === w ? (O = D.indexOf("*/", q + 2) + 1, O === 0 && ($ || ie ? O = D.length : re("comment")), X = D.slice(q, O + 1), C = X.split(`
`), I = C.length - 1, I > 0 ? (Q = L + I, K = O - C[I].length) : (Q = L, K = b), E = ["comment", X, L, q - b, Q, O - K], b = K, L = Q, q = O) : (x.lastIndex = q + 1, x.test(D), x.lastIndex === 0 ? O = D.length - 1 : O = x.lastIndex - 2, E = ["word", D.slice(q, O + 1), L, q - b, L, O - b], T.push(E), q = O);
                    break;
                }
                return q++, E;
              }
            }
            function fe(te) {
              F.push(te);
            }
            return { back: fe, nextToken: ce, endOfFile: ne, position: z2 };
          }
          n.exports = e.default;
        } }), ra = R({ "node_modules/postcss/lib/parse.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = o(zt()), a = o(_r());
          function o(h) {
            return h && h.__esModule ? h : { default: h };
          }
          function f(h, g) {
            var c = new a.default(h, g), t = new i.default(c);
            try {
              t.parse();
            } catch (r) {
              throw r;
            }
            return t.root;
          }
          var p = f;
          e.default = p, n.exports = e.default;
        } }), kf = R({ "node_modules/postcss/lib/list.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = { split: function(f, p, h) {
            for (var g = [], c = "", t = false, r = 0, u = false, s = false, l = 0; l < f.length; l++) {
              var m = f[l];
              u ? s ? s = false : m === "\\" ? s = true : m === u && (u = false) : m === '"' || m === "'" ? u = m : m === "(" ? r += 1 : m === ")" ? r > 0 && (r -= 1) : r === 0 && p.indexOf(m) !== -1 && (t = true), t ? (c !== "" && g.push(c.trim()), c = "", t = false) : c += m;
            }
            return (h || c !== "") && g.push(c.trim()), g;
          }, space: function(f) {
            var p = [" ", `
`, "	"];
            return i.split(f, p);
          }, comma: function(f) {
            return i.split(f, [","], true);
          } }, a = i;
          e.default = a, n.exports = e.default;
        } }), ta = R({ "node_modules/postcss/lib/rule.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = o(kr()), a = o(kf());
          function o(t) {
            return t && t.__esModule ? t : { default: t };
          }
          function f(t, r) {
            for (var u = 0; u < r.length; u++) {
              var s = r[u];
              s.enumerable = s.enumerable || false, s.configurable = true, "value" in s && (s.writable = true), Object.defineProperty(t, s.key, s);
            }
          }
          function p(t, r, u) {
            return r && f(t.prototype, r), u && f(t, u), t;
          }
          function h(t, r) {
            t.prototype = Object.create(r.prototype), t.prototype.constructor = t, t.__proto__ = r;
          }
          var g = function(t) {
            h(r, t);
            function r(u) {
              var s;
              return s = t.call(this, u) || this, s.type = "rule", s.nodes || (s.nodes = []), s;
            }
            return p(r, [{ key: "selectors", get: function() {
              return a.default.comma(this.selector);
            }, set: function(s) {
              var l = this.selector ? this.selector.match(/,\s*/) : null, m = l ? l[0] : "," + this.raw("between", "beforeOpen");
              this.selector = s.join(m);
            } }]), r;
          }(i.default), c = g;
          e.default = c, n.exports = e.default;
        } }), kr = R({ "node_modules/postcss/lib/container.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = f(ea()), a = f(xr()), o = f(Dt());
          function f(m) {
            return m && m.__esModule ? m : { default: m };
          }
          function p(m, v) {
            var y;
            if (typeof Symbol > "u" || m[Symbol.iterator] == null) {
              if (Array.isArray(m) || (y = h(m)) || v && m && typeof m.length == "number") {
                y && (m = y);
                var w = 0;
                return function() {
                  return w >= m.length ? { done: true } : { done: false, value: m[w++] };
                };
              }
              throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }
            return y = m[Symbol.iterator](), y.next.bind(y);
          }
          function h(m, v) {
            if (!!m) {
              if (typeof m == "string") return g(m, v);
              var y = Object.prototype.toString.call(m).slice(8, -1);
              if (y === "Object" && m.constructor && (y = m.constructor.name), y === "Map" || y === "Set") return Array.from(m);
              if (y === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(y)) return g(m, v);
            }
          }
          function g(m, v) {
            (v == null || v > m.length) && (v = m.length);
            for (var y = 0, w = new Array(v); y < v; y++) w[y] = m[y];
            return w;
          }
          function c(m, v) {
            for (var y = 0; y < v.length; y++) {
              var w = v[y];
              w.enumerable = w.enumerable || false, w.configurable = true, "value" in w && (w.writable = true), Object.defineProperty(m, w.key, w);
            }
          }
          function t(m, v, y) {
            return v && c(m.prototype, v), y && c(m, y), m;
          }
          function r(m, v) {
            m.prototype = Object.create(v.prototype), m.prototype.constructor = m, m.__proto__ = v;
          }
          function u(m) {
            return m.map(function(v) {
              return v.nodes && (v.nodes = u(v.nodes)), delete v.source, v;
            });
          }
          var s = function(m) {
            r(v, m);
            function v() {
              return m.apply(this, arguments) || this;
            }
            var y = v.prototype;
            return y.push = function(d) {
              return d.parent = this, this.nodes.push(d), this;
            }, y.each = function(d) {
              this.lastEach || (this.lastEach = 0), this.indexes || (this.indexes = {}), this.lastEach += 1;
              var _ = this.lastEach;
              if (this.indexes[_] = 0, !!this.nodes) {
                for (var S, x; this.indexes[_] < this.nodes.length && (S = this.indexes[_], x = d(this.nodes[S], S), x !== false); ) this.indexes[_] += 1;
                return delete this.indexes[_], x;
              }
            }, y.walk = function(d) {
              return this.each(function(_, S) {
                var x;
                try {
                  x = d(_, S);
                } catch (P) {
                  if (P.postcssNode = _, P.stack && _.source && /\n\s{4}at /.test(P.stack)) {
                    var N = _.source;
                    P.stack = P.stack.replace(/\n\s{4}at /, "$&" + N.input.from + ":" + N.start.line + ":" + N.start.column + "$&");
                  }
                  throw P;
                }
                return x !== false && _.walk && (x = _.walk(d)), x;
              });
            }, y.walkDecls = function(d, _) {
              return _ ? d instanceof RegExp ? this.walk(function(S, x) {
                if (S.type === "decl" && d.test(S.prop)) return _(S, x);
              }) : this.walk(function(S, x) {
                if (S.type === "decl" && S.prop === d) return _(S, x);
              }) : (_ = d, this.walk(function(S, x) {
                if (S.type === "decl") return _(S, x);
              }));
            }, y.walkRules = function(d, _) {
              return _ ? d instanceof RegExp ? this.walk(function(S, x) {
                if (S.type === "rule" && d.test(S.selector)) return _(S, x);
              }) : this.walk(function(S, x) {
                if (S.type === "rule" && S.selector === d) return _(S, x);
              }) : (_ = d, this.walk(function(S, x) {
                if (S.type === "rule") return _(S, x);
              }));
            }, y.walkAtRules = function(d, _) {
              return _ ? d instanceof RegExp ? this.walk(function(S, x) {
                if (S.type === "atrule" && d.test(S.name)) return _(S, x);
              }) : this.walk(function(S, x) {
                if (S.type === "atrule" && S.name === d) return _(S, x);
              }) : (_ = d, this.walk(function(S, x) {
                if (S.type === "atrule") return _(S, x);
              }));
            }, y.walkComments = function(d) {
              return this.walk(function(_, S) {
                if (_.type === "comment") return d(_, S);
              });
            }, y.append = function() {
              for (var d = arguments.length, _ = new Array(d), S = 0; S < d; S++) _[S] = arguments[S];
              for (var x = 0, N = _; x < N.length; x++) for (var P = N[x], W = this.normalize(P, this.last), U = p(W), H; !(H = U()).done; ) {
                var D = H.value;
                this.nodes.push(D);
              }
              return this;
            }, y.prepend = function() {
              for (var d = arguments.length, _ = new Array(d), S = 0; S < d; S++) _[S] = arguments[S];
              _ = _.reverse();
              for (var x = p(_), N; !(N = x()).done; ) {
                for (var P = N.value, W = this.normalize(P, this.first, "prepend").reverse(), U = p(W), H; !(H = U()).done; ) {
                  var D = H.value;
                  this.nodes.unshift(D);
                }
                for (var $ in this.indexes) this.indexes[$] = this.indexes[$] + W.length;
              }
              return this;
            }, y.cleanRaws = function(d) {
              if (m.prototype.cleanRaws.call(this, d), this.nodes) for (var _ = p(this.nodes), S; !(S = _()).done; ) {
                var x = S.value;
                x.cleanRaws(d);
              }
            }, y.insertBefore = function(d, _) {
              d = this.index(d);
              for (var S = d === 0 ? "prepend" : false, x = this.normalize(_, this.nodes[d], S).reverse(), N = p(x), P; !(P = N()).done; ) {
                var W = P.value;
                this.nodes.splice(d, 0, W);
              }
              var U;
              for (var H in this.indexes) U = this.indexes[H], d <= U && (this.indexes[H] = U + x.length);
              return this;
            }, y.insertAfter = function(d, _) {
              d = this.index(d);
              for (var S = this.normalize(_, this.nodes[d]).reverse(), x = p(S), N; !(N = x()).done; ) {
                var P = N.value;
                this.nodes.splice(d + 1, 0, P);
              }
              var W;
              for (var U in this.indexes) W = this.indexes[U], d < W && (this.indexes[U] = W + S.length);
              return this;
            }, y.removeChild = function(d) {
              d = this.index(d), this.nodes[d].parent = void 0, this.nodes.splice(d, 1);
              var _;
              for (var S in this.indexes) _ = this.indexes[S], _ >= d && (this.indexes[S] = _ - 1);
              return this;
            }, y.removeAll = function() {
              for (var d = p(this.nodes), _; !(_ = d()).done; ) {
                var S = _.value;
                S.parent = void 0;
              }
              return this.nodes = [], this;
            }, y.replaceValues = function(d, _, S) {
              return S || (S = _, _ = {}), this.walkDecls(function(x) {
                _.props && _.props.indexOf(x.prop) === -1 || _.fast && x.value.indexOf(_.fast) === -1 || (x.value = x.value.replace(d, S));
              }), this;
            }, y.every = function(d) {
              return this.nodes.every(d);
            }, y.some = function(d) {
              return this.nodes.some(d);
            }, y.index = function(d) {
              return typeof d == "number" ? d : this.nodes.indexOf(d);
            }, y.normalize = function(d, _) {
              var S = this;
              if (typeof d == "string") {
                var x = ra();
                d = u(x(d).nodes);
              } else if (Array.isArray(d)) {
                d = d.slice(0);
                for (var N = p(d), P; !(P = N()).done; ) {
                  var W = P.value;
                  W.parent && W.parent.removeChild(W, "ignore");
                }
              } else if (d.type === "root") {
                d = d.nodes.slice(0);
                for (var U = p(d), H; !(H = U()).done; ) {
                  var D = H.value;
                  D.parent && D.parent.removeChild(D, "ignore");
                }
              } else if (d.type) d = [d];
              else if (d.prop) {
                if (typeof d.value > "u") throw new Error("Value field is missed in node creation");
                typeof d.value != "string" && (d.value = String(d.value)), d = [new i.default(d)];
              } else if (d.selector) {
                var $ = ta();
                d = [new $(d)];
              } else if (d.name) {
                var B = na();
                d = [new B(d)];
              } else if (d.text) d = [new a.default(d)];
              else throw new Error("Unknown node type in node creation");
              var O = d.map(function(j) {
                return j.parent && j.parent.removeChild(j), typeof j.raws.before > "u" && _ && typeof _.raws.before < "u" && (j.raws.before = _.raws.before.replace(/[^\s]/g, "")), j.parent = S, j;
              });
              return O;
            }, t(v, [{ key: "first", get: function() {
              if (!!this.nodes) return this.nodes[0];
            } }, { key: "last", get: function() {
              if (!!this.nodes) return this.nodes[this.nodes.length - 1];
            } }]), v;
          }(o.default), l = s;
          e.default = l, n.exports = e.default;
        } }), na = R({ "node_modules/postcss/lib/at-rule.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = a(kr());
          function a(h) {
            return h && h.__esModule ? h : { default: h };
          }
          function o(h, g) {
            h.prototype = Object.create(g.prototype), h.prototype.constructor = h, h.__proto__ = g;
          }
          var f = function(h) {
            o(g, h);
            function g(t) {
              var r;
              return r = h.call(this, t) || this, r.type = "atrule", r;
            }
            var c = g.prototype;
            return c.append = function() {
              var r;
              this.nodes || (this.nodes = []);
              for (var u = arguments.length, s = new Array(u), l = 0; l < u; l++) s[l] = arguments[l];
              return (r = h.prototype.append).call.apply(r, [this].concat(s));
            }, c.prepend = function() {
              var r;
              this.nodes || (this.nodes = []);
              for (var u = arguments.length, s = new Array(u), l = 0; l < u; l++) s[l] = arguments[l];
              return (r = h.prototype.prepend).call.apply(r, [this].concat(s));
            }, g;
          }(i.default), p = f;
          e.default = p, n.exports = e.default;
        } }), Sf = R({ "node_modules/postcss/lib/map-generator.js"(e, n) {
          A(), n.exports = class {
            generate() {
            }
          };
        } }), Of = R({ "node_modules/postcss/lib/warn-once.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = a;
          var i = {};
          function a(o) {
            i[o] || (i[o] = true, typeof console < "u" && console.warn && console.warn(o));
          }
          n.exports = e.default;
        } }), Tf = R({ "node_modules/postcss/lib/warning.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = function() {
            function o(p, h) {
              if (h === void 0 && (h = {}), this.type = "warning", this.text = p, h.node && h.node.source) {
                var g = h.node.positionBy(h);
                this.line = g.line, this.column = g.column;
              }
              for (var c in h) this[c] = h[c];
            }
            var f = o.prototype;
            return f.toString = function() {
              return this.node ? this.node.error(this.text, { plugin: this.plugin, index: this.index, word: this.word }).message : this.plugin ? this.plugin + ": " + this.text : this.text;
            }, o;
          }(), a = i;
          e.default = a, n.exports = e.default;
        } }), Ef = R({ "node_modules/postcss/lib/result.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = a(Tf());
          function a(g) {
            return g && g.__esModule ? g : { default: g };
          }
          function o(g, c) {
            for (var t = 0; t < c.length; t++) {
              var r = c[t];
              r.enumerable = r.enumerable || false, r.configurable = true, "value" in r && (r.writable = true), Object.defineProperty(g, r.key, r);
            }
          }
          function f(g, c, t) {
            return c && o(g.prototype, c), t && o(g, t), g;
          }
          var p = function() {
            function g(t, r, u) {
              this.processor = t, this.messages = [], this.root = r, this.opts = u, this.css = void 0, this.map = void 0;
            }
            var c = g.prototype;
            return c.toString = function() {
              return this.css;
            }, c.warn = function(r, u) {
              u === void 0 && (u = {}), u.plugin || this.lastPlugin && this.lastPlugin.postcssPlugin && (u.plugin = this.lastPlugin.postcssPlugin);
              var s = new i.default(r, u);
              return this.messages.push(s), s;
            }, c.warnings = function() {
              return this.messages.filter(function(r) {
                return r.type === "warning";
              });
            }, f(g, [{ key: "content", get: function() {
              return this.css;
            } }]), g;
          }(), h = p;
          e.default = h, n.exports = e.default;
        } }), ia = R({ "node_modules/postcss/lib/lazy-result.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = h(Sf()), a = h(Zo()), o = h(Of()), f = h(Ef()), p = h(ra());
          function h(v) {
            return v && v.__esModule ? v : { default: v };
          }
          function g(v, y) {
            var w;
            if (typeof Symbol > "u" || v[Symbol.iterator] == null) {
              if (Array.isArray(v) || (w = c(v)) || y && v && typeof v.length == "number") {
                w && (v = w);
                var d = 0;
                return function() {
                  return d >= v.length ? { done: true } : { done: false, value: v[d++] };
                };
              }
              throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }
            return w = v[Symbol.iterator](), w.next.bind(w);
          }
          function c(v, y) {
            if (!!v) {
              if (typeof v == "string") return t(v, y);
              var w = Object.prototype.toString.call(v).slice(8, -1);
              if (w === "Object" && v.constructor && (w = v.constructor.name), w === "Map" || w === "Set") return Array.from(v);
              if (w === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(w)) return t(v, y);
            }
          }
          function t(v, y) {
            (y == null || y > v.length) && (y = v.length);
            for (var w = 0, d = new Array(y); w < y; w++) d[w] = v[w];
            return d;
          }
          function r(v, y) {
            for (var w = 0; w < y.length; w++) {
              var d = y[w];
              d.enumerable = d.enumerable || false, d.configurable = true, "value" in d && (d.writable = true), Object.defineProperty(v, d.key, d);
            }
          }
          function u(v, y, w) {
            return y && r(v.prototype, y), w && r(v, w), v;
          }
          function s(v) {
            return typeof v == "object" && typeof v.then == "function";
          }
          var l = function() {
            function v(w, d, _) {
              this.stringified = false, this.processed = false;
              var S;
              if (typeof d == "object" && d !== null && d.type === "root") S = d;
              else if (d instanceof v || d instanceof f.default) S = d.root, d.map && (typeof _.map > "u" && (_.map = {}), _.map.inline || (_.map.inline = false), _.map.prev = d.map);
              else {
                var x = p.default;
                _.syntax && (x = _.syntax.parse), _.parser && (x = _.parser), x.parse && (x = x.parse);
                try {
                  S = x(d, _);
                } catch (N) {
                  this.error = N;
                }
              }
              this.result = new f.default(w, S, _);
            }
            var y = v.prototype;
            return y.warnings = function() {
              return this.sync().warnings();
            }, y.toString = function() {
              return this.css;
            }, y.then = function(d, _) {
              return this.async().then(d, _);
            }, y.catch = function(d) {
              return this.async().catch(d);
            }, y.finally = function(d) {
              return this.async().then(d, d);
            }, y.handleError = function(d, _) {
              try {
                if (this.error = d, d.name === "CssSyntaxError" && !d.plugin) d.plugin = _.postcssPlugin, d.setMessage();
                else if (_.postcssVersion && false) var S, x, N, P, W;
              } catch (U) {
                console && console.error && console.error(U);
              }
            }, y.asyncTick = function(d, _) {
              var S = this;
              if (this.plugin >= this.processor.plugins.length) return this.processed = true, d();
              try {
                var x = this.processor.plugins[this.plugin], N = this.run(x);
                this.plugin += 1, s(N) ? N.then(function() {
                  S.asyncTick(d, _);
                }).catch(function(P) {
                  S.handleError(P, x), S.processed = true, _(P);
                }) : this.asyncTick(d, _);
              } catch (P) {
                this.processed = true, _(P);
              }
            }, y.async = function() {
              var d = this;
              return this.processed ? new Promise(function(_, S) {
                d.error ? S(d.error) : _(d.stringify());
              }) : this.processing ? this.processing : (this.processing = new Promise(function(_, S) {
                if (d.error) return S(d.error);
                d.plugin = 0, d.asyncTick(_, S);
              }).then(function() {
                return d.processed = true, d.stringify();
              }), this.processing);
            }, y.sync = function() {
              if (this.processed) return this.result;
              if (this.processed = true, this.processing) throw new Error("Use process(css).then(cb) to work with async plugins");
              if (this.error) throw this.error;
              for (var d = g(this.result.processor.plugins), _; !(_ = d()).done; ) {
                var S = _.value, x = this.run(S);
                if (s(x)) throw new Error("Use process(css).then(cb) to work with async plugins");
              }
              return this.result;
            }, y.run = function(d) {
              this.result.lastPlugin = d;
              try {
                return d(this.result.root, this.result);
              } catch (_) {
                throw this.handleError(_, d), _;
              }
            }, y.stringify = function() {
              if (this.stringified) return this.result;
              this.stringified = true, this.sync();
              var d = this.result.opts, _ = a.default;
              d.syntax && (_ = d.syntax.stringify), d.stringifier && (_ = d.stringifier), _.stringify && (_ = _.stringify);
              var S = new i.default(_, this.result.root, this.result.opts), x = S.generate();
              return this.result.css = x[0], this.result.map = x[1], this.result;
            }, u(v, [{ key: "processor", get: function() {
              return this.result.processor;
            } }, { key: "opts", get: function() {
              return this.result.opts;
            } }, { key: "css", get: function() {
              return this.stringify().css;
            } }, { key: "content", get: function() {
              return this.stringify().content;
            } }, { key: "map", get: function() {
              return this.stringify().map;
            } }, { key: "root", get: function() {
              return this.sync().root;
            } }, { key: "messages", get: function() {
              return this.sync().messages;
            } }]), v;
          }(), m = l;
          e.default = m, n.exports = e.default;
        } }), qf = R({ "node_modules/postcss/lib/processor.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = a(ia());
          function a(c) {
            return c && c.__esModule ? c : { default: c };
          }
          function o(c, t) {
            var r;
            if (typeof Symbol > "u" || c[Symbol.iterator] == null) {
              if (Array.isArray(c) || (r = f(c)) || t && c && typeof c.length == "number") {
                r && (c = r);
                var u = 0;
                return function() {
                  return u >= c.length ? { done: true } : { done: false, value: c[u++] };
                };
              }
              throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }
            return r = c[Symbol.iterator](), r.next.bind(r);
          }
          function f(c, t) {
            if (!!c) {
              if (typeof c == "string") return p(c, t);
              var r = Object.prototype.toString.call(c).slice(8, -1);
              if (r === "Object" && c.constructor && (r = c.constructor.name), r === "Map" || r === "Set") return Array.from(c);
              if (r === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)) return p(c, t);
            }
          }
          function p(c, t) {
            (t == null || t > c.length) && (t = c.length);
            for (var r = 0, u = new Array(t); r < t; r++) u[r] = c[r];
            return u;
          }
          var h = function() {
            function c(r) {
              r === void 0 && (r = []), this.version = "7.0.39", this.plugins = this.normalize(r);
            }
            var t = c.prototype;
            return t.use = function(u) {
              return this.plugins = this.plugins.concat(this.normalize([u])), this;
            }, t.process = function(r) {
              function u(s) {
                return r.apply(this, arguments);
              }
              return u.toString = function() {
                return r.toString();
              }, u;
            }(function(r, u) {
              return u === void 0 && (u = {}), this.plugins.length === 0 && (u.parser, u.stringifier), new i.default(this, r, u);
            }), t.normalize = function(u) {
              for (var s = [], l = o(u), m; !(m = l()).done; ) {
                var v = m.value;
                if (v.postcss === true) {
                  var y = v();
                  throw new Error("PostCSS plugin " + y.postcssPlugin + ` requires PostCSS 8.
Migration guide for end-users:
https://github.com/postcss/postcss/wiki/PostCSS-8-for-end-users`);
                }
                if (v.postcss && (v = v.postcss), typeof v == "object" && Array.isArray(v.plugins)) s = s.concat(v.plugins);
                else if (typeof v == "function") s.push(v);
                else if (!(typeof v == "object" && (v.parse || v.stringify))) throw typeof v == "object" && v.postcssPlugin ? new Error("PostCSS plugin " + v.postcssPlugin + ` requires PostCSS 8.
Migration guide for end-users:
https://github.com/postcss/postcss/wiki/PostCSS-8-for-end-users`) : new Error(v + " is not a PostCSS plugin");
              }
              return s;
            }, c;
          }(), g = h;
          e.default = g, n.exports = e.default;
        } }), Af = R({ "node_modules/postcss/lib/root.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = a(kr());
          function a(t) {
            return t && t.__esModule ? t : { default: t };
          }
          function o(t, r) {
            var u;
            if (typeof Symbol > "u" || t[Symbol.iterator] == null) {
              if (Array.isArray(t) || (u = f(t)) || r && t && typeof t.length == "number") {
                u && (t = u);
                var s = 0;
                return function() {
                  return s >= t.length ? { done: true } : { done: false, value: t[s++] };
                };
              }
              throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }
            return u = t[Symbol.iterator](), u.next.bind(u);
          }
          function f(t, r) {
            if (!!t) {
              if (typeof t == "string") return p(t, r);
              var u = Object.prototype.toString.call(t).slice(8, -1);
              if (u === "Object" && t.constructor && (u = t.constructor.name), u === "Map" || u === "Set") return Array.from(t);
              if (u === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(u)) return p(t, r);
            }
          }
          function p(t, r) {
            (r == null || r > t.length) && (r = t.length);
            for (var u = 0, s = new Array(r); u < r; u++) s[u] = t[u];
            return s;
          }
          function h(t, r) {
            t.prototype = Object.create(r.prototype), t.prototype.constructor = t, t.__proto__ = r;
          }
          var g = function(t) {
            h(r, t);
            function r(s) {
              var l;
              return l = t.call(this, s) || this, l.type = "root", l.nodes || (l.nodes = []), l;
            }
            var u = r.prototype;
            return u.removeChild = function(l, m) {
              var v = this.index(l);
              return !m && v === 0 && this.nodes.length > 1 && (this.nodes[1].raws.before = this.nodes[v].raws.before), t.prototype.removeChild.call(this, l);
            }, u.normalize = function(l, m, v) {
              var y = t.prototype.normalize.call(this, l);
              if (m) {
                if (v === "prepend") this.nodes.length > 1 ? m.raws.before = this.nodes[1].raws.before : delete m.raws.before;
                else if (this.first !== m) for (var w = o(y), d; !(d = w()).done; ) {
                  var _ = d.value;
                  _.raws.before = m.raws.before;
                }
              }
              return y;
            }, u.toResult = function(l) {
              l === void 0 && (l = {});
              var m = ia(), v = qf(), y = new m(new v(), this, l);
              return y.stringify();
            }, r;
          }(i.default), c = g;
          e.default = c, n.exports = e.default;
        } }), zt = R({ "node_modules/postcss/lib/parser.js"(e, n) {
          "use strict";
          A(), e.__esModule = true, e.default = void 0;
          var i = g(ea()), a = g(Lt()), o = g(xr()), f = g(na()), p = g(Af()), h = g(ta());
          function g(t) {
            return t && t.__esModule ? t : { default: t };
          }
          var c = function() {
            function t(u) {
              this.input = u, this.root = new p.default(), this.current = this.root, this.spaces = "", this.semicolon = false, this.createTokenizer(), this.root.source = { input: u, start: { line: 1, column: 1 } };
            }
            var r = t.prototype;
            return r.createTokenizer = function() {
              this.tokenizer = (0, a.default)(this.input);
            }, r.parse = function() {
              for (var s; !this.tokenizer.endOfFile(); ) switch (s = this.tokenizer.nextToken(), s[0]) {
                case "space":
                  this.spaces += s[1];
                  break;
                case ";":
                  this.freeSemicolon(s);
                  break;
                case "}":
                  this.end(s);
                  break;
                case "comment":
                  this.comment(s);
                  break;
                case "at-word":
                  this.atrule(s);
                  break;
                case "{":
                  this.emptyRule(s);
                  break;
                default:
                  this.other(s);
                  break;
              }
              this.endFile();
            }, r.comment = function(s) {
              var l = new o.default();
              this.init(l, s[2], s[3]), l.source.end = { line: s[4], column: s[5] };
              var m = s[1].slice(2, -2);
              if (/^\s*$/.test(m)) l.text = "", l.raws.left = m, l.raws.right = "";
              else {
                var v = m.match(/^(\s*)([^]*[^\s])(\s*)$/);
                l.text = v[2], l.raws.left = v[1], l.raws.right = v[3];
              }
            }, r.emptyRule = function(s) {
              var l = new h.default();
              this.init(l, s[2], s[3]), l.selector = "", l.raws.between = "", this.current = l;
            }, r.other = function(s) {
              for (var l = false, m = null, v = false, y = null, w = [], d = [], _ = s; _; ) {
                if (m = _[0], d.push(_), m === "(" || m === "[") y || (y = _), w.push(m === "(" ? ")" : "]");
                else if (w.length === 0) if (m === ";") if (v) {
                  this.decl(d);
                  return;
                } else break;
                else if (m === "{") {
                  this.rule(d);
                  return;
                } else if (m === "}") {
                  this.tokenizer.back(d.pop()), l = true;
                  break;
                } else m === ":" && (v = true);
                else m === w[w.length - 1] && (w.pop(), w.length === 0 && (y = null));
                _ = this.tokenizer.nextToken();
              }
              if (this.tokenizer.endOfFile() && (l = true), w.length > 0 && this.unclosedBracket(y), l && v) {
                for (; d.length && (_ = d[d.length - 1][0], !(_ !== "space" && _ !== "comment")); ) this.tokenizer.back(d.pop());
                this.decl(d);
              } else this.unknownWord(d);
            }, r.rule = function(s) {
              s.pop();
              var l = new h.default();
              this.init(l, s[0][2], s[0][3]), l.raws.between = this.spacesAndCommentsFromEnd(s), this.raw(l, "selector", s), this.current = l;
            }, r.decl = function(s) {
              var l = new i.default();
              this.init(l);
              var m = s[s.length - 1];
              for (m[0] === ";" && (this.semicolon = true, s.pop()), m[4] ? l.source.end = { line: m[4], column: m[5] } : l.source.end = { line: m[2], column: m[3] }; s[0][0] !== "word"; ) s.length === 1 && this.unknownWord(s), l.raws.before += s.shift()[1];
              for (l.source.start = { line: s[0][2], column: s[0][3] }, l.prop = ""; s.length; ) {
                var v = s[0][0];
                if (v === ":" || v === "space" || v === "comment") break;
                l.prop += s.shift()[1];
              }
              l.raws.between = "";
              for (var y; s.length; ) if (y = s.shift(), y[0] === ":") {
                l.raws.between += y[1];
                break;
              } else y[0] === "word" && /\w/.test(y[1]) && this.unknownWord([y]), l.raws.between += y[1];
              (l.prop[0] === "_" || l.prop[0] === "*") && (l.raws.before += l.prop[0], l.prop = l.prop.slice(1)), l.raws.between += this.spacesAndCommentsFromStart(s), this.precheckMissedSemicolon(s);
              for (var w = s.length - 1; w > 0; w--) {
                if (y = s[w], y[1].toLowerCase() === "!important") {
                  l.important = true;
                  var d = this.stringFrom(s, w);
                  d = this.spacesFromEnd(s) + d, d !== " !important" && (l.raws.important = d);
                  break;
                } else if (y[1].toLowerCase() === "important") {
                  for (var _ = s.slice(0), S = "", x = w; x > 0; x--) {
                    var N = _[x][0];
                    if (S.trim().indexOf("!") === 0 && N !== "space") break;
                    S = _.pop()[1] + S;
                  }
                  S.trim().indexOf("!") === 0 && (l.important = true, l.raws.important = S, s = _);
                }
                if (y[0] !== "space" && y[0] !== "comment") break;
              }
              this.raw(l, "value", s), l.value.indexOf(":") !== -1 && this.checkMissedSemicolon(s);
            }, r.atrule = function(s) {
              var l = new f.default();
              l.name = s[1].slice(1), l.name === "" && this.unnamedAtrule(l, s), this.init(l, s[2], s[3]);
              for (var m, v, y = false, w = false, d = []; !this.tokenizer.endOfFile(); ) {
                if (s = this.tokenizer.nextToken(), s[0] === ";") {
                  l.source.end = { line: s[2], column: s[3] }, this.semicolon = true;
                  break;
                } else if (s[0] === "{") {
                  w = true;
                  break;
                } else if (s[0] === "}") {
                  if (d.length > 0) {
                    for (v = d.length - 1, m = d[v]; m && m[0] === "space"; ) m = d[--v];
                    m && (l.source.end = { line: m[4], column: m[5] });
                  }
                  this.end(s);
                  break;
                } else d.push(s);
                if (this.tokenizer.endOfFile()) {
                  y = true;
                  break;
                }
              }
              l.raws.between = this.spacesAndCommentsFromEnd(d), d.length ? (l.raws.afterName = this.spacesAndCommentsFromStart(d), this.raw(l, "params", d), y && (s = d[d.length - 1], l.source.end = { line: s[4], column: s[5] }, this.spaces = l.raws.between, l.raws.between = "")) : (l.raws.afterName = "", l.params = ""), w && (l.nodes = [], this.current = l);
            }, r.end = function(s) {
              this.current.nodes && this.current.nodes.length && (this.current.raws.semicolon = this.semicolon), this.semicolon = false, this.current.raws.after = (this.current.raws.after || "") + this.spaces, this.spaces = "", this.current.parent ? (this.current.source.end = { line: s[2], column: s[3] }, this.current = this.current.parent) : this.unexpectedClose(s);
            }, r.endFile = function() {
              this.current.parent && this.unclosedBlock(), this.current.nodes && this.current.nodes.length && (this.current.raws.semicolon = this.semicolon), this.current.raws.after = (this.current.raws.after || "") + this.spaces;
            }, r.freeSemicolon = function(s) {
              if (this.spaces += s[1], this.current.nodes) {
                var l = this.current.nodes[this.current.nodes.length - 1];
                l && l.type === "rule" && !l.raws.ownSemicolon && (l.raws.ownSemicolon = this.spaces, this.spaces = "");
              }
            }, r.init = function(s, l, m) {
              this.current.push(s), s.source = { start: { line: l, column: m }, input: this.input }, s.raws.before = this.spaces, this.spaces = "", s.type !== "comment" && (this.semicolon = false);
            }, r.raw = function(s, l, m) {
              for (var v, y, w = m.length, d = "", _ = true, S, x, N = /^([.|#])?([\w])+/i, P = 0; P < w; P += 1) {
                if (v = m[P], y = v[0], y === "comment" && s.type === "rule") {
                  x = m[P - 1], S = m[P + 1], x[0] !== "space" && S[0] !== "space" && N.test(x[1]) && N.test(S[1]) ? d += v[1] : _ = false;
                  continue;
                }
                y === "comment" || y === "space" && P === w - 1 ? _ = false : d += v[1];
              }
              if (!_) {
                var W = m.reduce(function(U, H) {
                  return U + H[1];
                }, "");
                s.raws[l] = { value: d, raw: W };
              }
              s[l] = d;
            }, r.spacesAndCommentsFromEnd = function(s) {
              for (var l, m = ""; s.length && (l = s[s.length - 1][0], !(l !== "space" && l !== "comment")); ) m = s.pop()[1] + m;
              return m;
            }, r.spacesAndCommentsFromStart = function(s) {
              for (var l, m = ""; s.length && (l = s[0][0], !(l !== "space" && l !== "comment")); ) m += s.shift()[1];
              return m;
            }, r.spacesFromEnd = function(s) {
              for (var l, m = ""; s.length && (l = s[s.length - 1][0], l === "space"); ) m = s.pop()[1] + m;
              return m;
            }, r.stringFrom = function(s, l) {
              for (var m = "", v = l; v < s.length; v++) m += s[v][1];
              return s.splice(l, s.length - l), m;
            }, r.colon = function(s) {
              for (var l = 0, m, v, y, w = 0; w < s.length; w++) {
                if (m = s[w], v = m[0], v === "(" && (l += 1), v === ")" && (l -= 1), l === 0 && v === ":") if (!y) this.doubleColon(m);
                else {
                  if (y[0] === "word" && y[1] === "progid") continue;
                  return w;
                }
                y = m;
              }
              return false;
            }, r.unclosedBracket = function(s) {
              throw this.input.error("Unclosed bracket", s[2], s[3]);
            }, r.unknownWord = function(s) {
              throw this.input.error("Unknown word", s[0][2], s[0][3]);
            }, r.unexpectedClose = function(s) {
              throw this.input.error("Unexpected }", s[2], s[3]);
            }, r.unclosedBlock = function() {
              var s = this.current.source.start;
              throw this.input.error("Unclosed block", s.line, s.column);
            }, r.doubleColon = function(s) {
              throw this.input.error("Double colon", s[2], s[3]);
            }, r.unnamedAtrule = function(s, l) {
              throw this.input.error("At-rule without name", l[2], l[3]);
            }, r.precheckMissedSemicolon = function() {
            }, r.checkMissedSemicolon = function(s) {
              var l = this.colon(s);
              if (l !== false) {
                for (var m = 0, v, y = l - 1; y >= 0 && (v = s[y], !(v[0] !== "space" && (m += 1, m === 2))); y--) ;
                throw this.input.error("Missed semicolon", v[2], v[3]);
              }
            }, t;
          }();
          e.default = c, n.exports = e.default;
        } }), Pf = R({ "node_modules/postcss-less/lib/nodes/inline-comment.js"(e, n) {
          A();
          var i = Lt(), a = _r();
          n.exports = { isInlineComment(o) {
            if (o[0] === "word" && o[1].slice(0, 2) === "//") {
              let f = o, p = [], h;
              for (; o; ) {
                if (/\r?\n/.test(o[1])) {
                  if (/['"].*\r?\n/.test(o[1])) {
                    p.push(o[1].substring(0, o[1].indexOf(`
`)));
                    let c = o[1].substring(o[1].indexOf(`
`));
                    c += this.input.css.valueOf().substring(this.tokenizer.position()), this.input = new a(c), this.tokenizer = i(this.input);
                  } else this.tokenizer.back(o);
                  break;
                }
                p.push(o[1]), h = o, o = this.tokenizer.nextToken({ ignoreUnclosed: true });
              }
              let g = ["comment", p.join(""), f[2], f[3], h[2], h[3]];
              return this.inlineComment(g), true;
            } else if (o[1] === "/") {
              let f = this.tokenizer.nextToken({ ignoreUnclosed: true });
              if (f[0] === "comment" && /^\/\*/.test(f[1])) return f[0] = "word", f[1] = f[1].slice(1), o[1] = "//", this.tokenizer.back(f), n.exports.isInlineComment.bind(this)(o);
            }
            return false;
          } };
        } }), Rf = R({ "node_modules/postcss-less/lib/nodes/interpolation.js"(e, n) {
          A(), n.exports = { interpolation(i) {
            let a = i, o = [i], f = ["word", "{", "}"];
            if (i = this.tokenizer.nextToken(), a[1].length > 1 || i[0] !== "{") return this.tokenizer.back(i), false;
            for (; i && f.includes(i[0]); ) o.push(i), i = this.tokenizer.nextToken();
            let p = o.map((r) => r[1]);
            [a] = o;
            let h = o.pop(), g = [a[2], a[3]], c = [h[4] || h[2], h[5] || h[3]], t = ["word", p.join("")].concat(g, c);
            return this.tokenizer.back(i), this.tokenizer.back(t), true;
          } };
        } }), If = R({ "node_modules/postcss-less/lib/nodes/mixin.js"(e, n) {
          A();
          var i = /^#[0-9a-fA-F]{6}$|^#[0-9a-fA-F]{3}$/, a = /\.[0-9]/, o = (f) => {
            let [, p] = f, [h] = p;
            return (h === "." || h === "#") && i.test(p) === false && a.test(p) === false;
          };
          n.exports = { isMixinToken: o };
        } }), Cf = R({ "node_modules/postcss-less/lib/nodes/import.js"(e, n) {
          A();
          var i = Lt(), a = /^url\((.+)\)/;
          n.exports = (o) => {
            let { name: f, params: p = "" } = o;
            if (f === "import" && p.length) {
              o.import = true;
              let h = i({ css: p });
              for (o.filename = p.replace(a, "$1"); !h.endOfFile(); ) {
                let [g, c] = h.nextToken();
                if (g === "word" && c === "url") return;
                if (g === "brackets") {
                  o.options = c, o.filename = p.replace(c, "").trim();
                  break;
                }
              }
            }
          };
        } }), Nf = R({ "node_modules/postcss-less/lib/nodes/variable.js"(e, n) {
          A();
          var i = /:$/, a = /^:(\s+)?/;
          n.exports = (o) => {
            let { name: f, params: p = "" } = o;
            if (o.name.slice(-1) === ":") {
              if (i.test(f)) {
                let [h] = f.match(i);
                o.name = f.replace(h, ""), o.raws.afterName = h + (o.raws.afterName || ""), o.variable = true, o.value = o.params;
              }
              if (a.test(p)) {
                let [h] = p.match(a);
                o.value = p.replace(h, ""), o.raws.afterName = (o.raws.afterName || "") + h, o.variable = true;
              }
            }
          };
        } }), jf = R({ "node_modules/postcss-less/lib/LessParser.js"(e, n) {
          A();
          var i = xr(), a = zt(), { isInlineComment: o } = Pf(), { interpolation: f } = Rf(), { isMixinToken: p } = If(), h = Cf(), g = Nf(), c = /(!\s*important)$/i;
          n.exports = class extends a {
            constructor() {
              super(...arguments), this.lastNode = null;
            }
            atrule(r) {
              f.bind(this)(r) || (super.atrule(r), h(this.lastNode), g(this.lastNode));
            }
            decl() {
              super.decl(...arguments), /extend\(.+\)/i.test(this.lastNode.value) && (this.lastNode.extend = true);
            }
            each(r) {
              r[0][1] = " ".concat(r[0][1]);
              let u = r.findIndex((y) => y[0] === "("), s = r.reverse().find((y) => y[0] === ")"), l = r.reverse().indexOf(s), v = r.splice(u, l).map((y) => y[1]).join("");
              for (let y of r.reverse()) this.tokenizer.back(y);
              this.atrule(this.tokenizer.nextToken()), this.lastNode.function = true, this.lastNode.params = v;
            }
            init(r, u, s) {
              super.init(r, u, s), this.lastNode = r;
            }
            inlineComment(r) {
              let u = new i(), s = r[1].slice(2);
              if (this.init(u, r[2], r[3]), u.source.end = { line: r[4], column: r[5] }, u.inline = true, u.raws.begin = "//", /^\s*$/.test(s)) u.text = "", u.raws.left = s, u.raws.right = "";
              else {
                let l = s.match(/^(\s*)([^]*[^\s])(\s*)$/);
                [, u.raws.left, u.text, u.raws.right] = l;
              }
            }
            mixin(r) {
              let [u] = r, s = u[1].slice(0, 1), l = r.findIndex((d) => d[0] === "brackets"), m = r.findIndex((d) => d[0] === "("), v = "";
              if ((l < 0 || l > 3) && m > 0) {
                let d = r.reduce(($, B, O) => B[0] === ")" ? O : $), S = r.slice(m, d + m).map(($) => $[1]).join(""), [x] = r.slice(m), N = [x[2], x[3]], [P] = r.slice(d, d + 1), W = [P[2], P[3]], U = ["brackets", S].concat(N, W), H = r.slice(0, m), D = r.slice(d + 1);
                r = H, r.push(U), r = r.concat(D);
              }
              let y = [];
              for (let d of r) if ((d[1] === "!" || y.length) && y.push(d), d[1] === "important") break;
              if (y.length) {
                let [d] = y, _ = r.indexOf(d), S = y[y.length - 1], x = [d[2], d[3]], N = [S[4], S[5]], P = y.map((U) => U[1]).join(""), W = ["word", P].concat(x, N);
                r.splice(_, y.length, W);
              }
              let w = r.findIndex((d) => c.test(d[1]));
              w > 0 && ([, v] = r[w], r.splice(w, 1));
              for (let d of r.reverse()) this.tokenizer.back(d);
              this.atrule(this.tokenizer.nextToken()), this.lastNode.mixin = true, this.lastNode.raws.identifier = s, v && (this.lastNode.important = true, this.lastNode.raws.important = v);
            }
            other(r) {
              o.bind(this)(r) || super.other(r);
            }
            rule(r) {
              let u = r[r.length - 1], s = r[r.length - 2];
              if (s[0] === "at-word" && u[0] === "{" && (this.tokenizer.back(u), f.bind(this)(s))) {
                let m = this.tokenizer.nextToken();
                r = r.slice(0, r.length - 2).concat([m]);
                for (let v of r.reverse()) this.tokenizer.back(v);
                return;
              }
              super.rule(r), /:extend\(.+\)/i.test(this.lastNode.selector) && (this.lastNode.extend = true);
            }
            unknownWord(r) {
              let [u] = r;
              if (r[0][1] === "each" && r[1][0] === "(") {
                this.each(r);
                return;
              }
              if (p(u)) {
                this.mixin(r);
                return;
              }
              super.unknownWord(r);
            }
          };
        } }), Mf = R({ "node_modules/postcss-less/lib/LessStringifier.js"(e, n) {
          A();
          var i = br();
          n.exports = class extends i {
            atrule(o, f) {
              if (!o.mixin && !o.variable && !o.function) {
                super.atrule(o, f);
                return;
              }
              let p = o.function ? "" : o.raws.identifier || "@", h = "".concat(p).concat(o.name), g = o.params ? this.rawValue(o, "params") : "", c = o.raws.important || "";
              if (o.variable && (g = o.value), typeof o.raws.afterName < "u" ? h += o.raws.afterName : g && (h += " "), o.nodes) this.block(o, h + g + c);
              else {
                let t = (o.raws.between || "") + c + (f ? ";" : "");
                this.builder(h + g + t, o);
              }
            }
            comment(o) {
              if (o.inline) {
                let f = this.raw(o, "left", "commentLeft"), p = this.raw(o, "right", "commentRight");
                this.builder("//".concat(f).concat(o.text).concat(p), o);
              } else super.comment(o);
            }
          };
        } }), Df = R({ "node_modules/postcss-less/lib/index.js"(e, n) {
          A();
          var i = _r(), a = jf(), o = Mf();
          n.exports = { parse(f, p) {
            let h = new i(f, p), g = new a(h);
            return g.parse(), g.root;
          }, stringify(f, p) {
            new o(p).stringify(f);
          }, nodeToString(f) {
            let p = "";
            return n.exports.stringify(f, (h) => {
              p += h;
            }), p;
          } };
        } }), Lf = R({ "node_modules/postcss-scss/lib/scss-stringifier.js"(e, n) {
          "use strict";
          A();
          function i(f, p) {
            f.prototype = Object.create(p.prototype), f.prototype.constructor = f, f.__proto__ = p;
          }
          var a = br(), o = function(f) {
            i(p, f);
            function p() {
              return f.apply(this, arguments) || this;
            }
            var h = p.prototype;
            return h.comment = function(c) {
              var t = this.raw(c, "left", "commentLeft"), r = this.raw(c, "right", "commentRight");
              if (c.raws.inline) {
                var u = c.raws.text || c.text;
                this.builder("//" + t + u + r, c);
              } else this.builder("/*" + t + c.text + r + "*/", c);
            }, h.decl = function(c, t) {
              if (!c.isNested) f.prototype.decl.call(this, c, t);
              else {
                var r = this.raw(c, "between", "colon"), u = c.prop + r + this.rawValue(c, "value");
                c.important && (u += c.raws.important || " !important"), this.builder(u + "{", c, "start");
                var s;
                c.nodes && c.nodes.length ? (this.body(c), s = this.raw(c, "after")) : s = this.raw(c, "after", "emptyBody"), s && this.builder(s), this.builder("}", c, "end");
              }
            }, h.rawValue = function(c, t) {
              var r = c[t], u = c.raws[t];
              return u && u.value === r ? u.scss ? u.scss : u.raw : r;
            }, p;
          }(a);
          n.exports = o;
        } }), zf = R({ "node_modules/postcss-scss/lib/scss-stringify.js"(e, n) {
          "use strict";
          A();
          var i = Lf();
          n.exports = function(o, f) {
            var p = new i(f);
            p.stringify(o);
          };
        } }), Bf = R({ "node_modules/postcss-scss/lib/nested-declaration.js"(e, n) {
          "use strict";
          A();
          function i(f, p) {
            f.prototype = Object.create(p.prototype), f.prototype.constructor = f, f.__proto__ = p;
          }
          var a = kr(), o = function(f) {
            i(p, f);
            function p(h) {
              var g;
              return g = f.call(this, h) || this, g.type = "decl", g.isNested = true, g.nodes || (g.nodes = []), g;
            }
            return p;
          }(a);
          n.exports = o;
        } }), Ff = R({ "node_modules/postcss-scss/lib/scss-tokenize.js"(e, n) {
          "use strict";
          A();
          var i = "'".charCodeAt(0), a = '"'.charCodeAt(0), o = "\\".charCodeAt(0), f = "/".charCodeAt(0), p = `
`.charCodeAt(0), h = " ".charCodeAt(0), g = "\f".charCodeAt(0), c = "	".charCodeAt(0), t = "\r".charCodeAt(0), r = "[".charCodeAt(0), u = "]".charCodeAt(0), s = "(".charCodeAt(0), l = ")".charCodeAt(0), m = "{".charCodeAt(0), v = "}".charCodeAt(0), y = ";".charCodeAt(0), w = "*".charCodeAt(0), d = ":".charCodeAt(0), _ = "@".charCodeAt(0), S = ",".charCodeAt(0), x = "#".charCodeAt(0), N = /[ \n\t\r\f{}()'"\\;/[\]#]/g, P = /[ \n\t\r\f(){}:;@!'"\\\][#]|\/(?=\*)/g, W = /.[\\/("'\n]/, U = /[a-f0-9]/i, H = /[\r\f\n]/g;
          n.exports = function($, B) {
            B === void 0 && (B = {});
            var O = $.css.valueOf(), j = B.ignoreErrors, C, I, X, Z, Q, K, J, M, Y, G, E, k, b, L, q = O.length, T = -1, F = 1, z2 = 0, re = [], ne = [];
            function ce(se) {
              throw $.error("Unclosed " + se, F, z2 - T);
            }
            function fe() {
              return ne.length === 0 && z2 >= q;
            }
            function te() {
              for (var se = 1, le = false, pe = false; se > 0; ) I += 1, O.length <= I && ce("interpolation"), C = O.charCodeAt(I), k = O.charCodeAt(I + 1), le ? !pe && C === le ? (le = false, pe = false) : C === o ? pe = !G : pe && (pe = false) : C === i || C === a ? le = C : C === v ? se -= 1 : C === x && k === m && (se += 1);
            }
            function ie() {
              if (ne.length) return ne.pop();
              if (!(z2 >= q)) {
                switch (C = O.charCodeAt(z2), (C === p || C === g || C === t && O.charCodeAt(z2 + 1) !== p) && (T = z2, F += 1), C) {
                  case p:
                  case h:
                  case c:
                  case t:
                  case g:
                    I = z2;
                    do
                      I += 1, C = O.charCodeAt(I), C === p && (T = I, F += 1);
                    while (C === h || C === p || C === c || C === t || C === g);
                    b = ["space", O.slice(z2, I)], z2 = I - 1;
                    break;
                  case r:
                    b = ["[", "[", F, z2 - T];
                    break;
                  case u:
                    b = ["]", "]", F, z2 - T];
                    break;
                  case m:
                    b = ["{", "{", F, z2 - T];
                    break;
                  case v:
                    b = ["}", "}", F, z2 - T];
                    break;
                  case S:
                    b = ["word", ",", F, z2 - T, F, z2 - T + 1];
                    break;
                  case d:
                    b = [":", ":", F, z2 - T];
                    break;
                  case y:
                    b = [";", ";", F, z2 - T];
                    break;
                  case s:
                    if (E = re.length ? re.pop()[1] : "", k = O.charCodeAt(z2 + 1), E === "url" && k !== i && k !== a) {
                      for (L = 1, G = false, I = z2 + 1; I <= O.length - 1; ) {
                        if (k = O.charCodeAt(I), k === o) G = !G;
                        else if (k === s) L += 1;
                        else if (k === l && (L -= 1, L === 0)) break;
                        I += 1;
                      }
                      K = O.slice(z2, I + 1), Z = K.split(`
`), Q = Z.length - 1, Q > 0 ? (M = F + Q, Y = I - Z[Q].length) : (M = F, Y = T), b = ["brackets", K, F, z2 - T, M, I - Y], T = Y, F = M, z2 = I;
                    } else I = O.indexOf(")", z2 + 1), K = O.slice(z2, I + 1), I === -1 || W.test(K) ? b = ["(", "(", F, z2 - T] : (b = ["brackets", K, F, z2 - T, F, I - T], z2 = I);
                    break;
                  case l:
                    b = [")", ")", F, z2 - T];
                    break;
                  case i:
                  case a:
                    for (X = C, I = z2, G = false; I < q && (I++, I === q && ce("string"), C = O.charCodeAt(I), k = O.charCodeAt(I + 1), !(!G && C === X)); ) C === o ? G = !G : G ? G = false : C === x && k === m && te();
                    K = O.slice(z2, I + 1), Z = K.split(`
`), Q = Z.length - 1, Q > 0 ? (M = F + Q, Y = I - Z[Q].length) : (M = F, Y = T), b = ["string", O.slice(z2, I + 1), F, z2 - T, M, I - Y], T = Y, F = M, z2 = I;
                    break;
                  case _:
                    N.lastIndex = z2 + 1, N.test(O), N.lastIndex === 0 ? I = O.length - 1 : I = N.lastIndex - 2, b = ["at-word", O.slice(z2, I + 1), F, z2 - T, F, I - T], z2 = I;
                    break;
                  case o:
                    for (I = z2, J = true; O.charCodeAt(I + 1) === o; ) I += 1, J = !J;
                    if (C = O.charCodeAt(I + 1), J && C !== f && C !== h && C !== p && C !== c && C !== t && C !== g && (I += 1, U.test(O.charAt(I)))) {
                      for (; U.test(O.charAt(I + 1)); ) I += 1;
                      O.charCodeAt(I + 1) === h && (I += 1);
                    }
                    b = ["word", O.slice(z2, I + 1), F, z2 - T, F, I - T], z2 = I;
                    break;
                  default:
                    k = O.charCodeAt(z2 + 1), C === x && k === m ? (I = z2, te(), K = O.slice(z2, I + 1), Z = K.split(`
`), Q = Z.length - 1, Q > 0 ? (M = F + Q, Y = I - Z[Q].length) : (M = F, Y = T), b = ["word", K, F, z2 - T, M, I - Y], T = Y, F = M, z2 = I) : C === f && k === w ? (I = O.indexOf("*/", z2 + 2) + 1, I === 0 && (j ? I = O.length : ce("comment")), K = O.slice(z2, I + 1), Z = K.split(`
`), Q = Z.length - 1, Q > 0 ? (M = F + Q, Y = I - Z[Q].length) : (M = F, Y = T), b = ["comment", K, F, z2 - T, M, I - Y], T = Y, F = M, z2 = I) : C === f && k === f ? (H.lastIndex = z2 + 1, H.test(O), H.lastIndex === 0 ? I = O.length - 1 : I = H.lastIndex - 2, K = O.slice(z2, I + 1), b = ["comment", K, F, z2 - T, F, I - T, "inline"], z2 = I) : (P.lastIndex = z2 + 1, P.test(O), P.lastIndex === 0 ? I = O.length - 1 : I = P.lastIndex - 2, b = ["word", O.slice(z2, I + 1), F, z2 - T, F, I - T], re.push(b), z2 = I);
                    break;
                }
                return z2++, b;
              }
            }
            function ae(se) {
              ne.push(se);
            }
            return { back: ae, nextToken: ie, endOfFile: fe };
          };
        } }), Uf = R({ "node_modules/postcss-scss/lib/scss-parser.js"(e, n) {
          "use strict";
          A();
          function i(g, c) {
            g.prototype = Object.create(c.prototype), g.prototype.constructor = g, g.__proto__ = c;
          }
          var a = xr(), o = zt(), f = Bf(), p = Ff(), h = function(g) {
            i(c, g);
            function c() {
              return g.apply(this, arguments) || this;
            }
            var t = c.prototype;
            return t.createTokenizer = function() {
              this.tokenizer = p(this.input);
            }, t.rule = function(u) {
              for (var s = false, l = 0, m = "", w = u, v = Array.isArray(w), y = 0, w = v ? w : w[Symbol.iterator](); ; ) {
                var d;
                if (v) {
                  if (y >= w.length) break;
                  d = w[y++];
                } else {
                  if (y = w.next(), y.done) break;
                  d = y.value;
                }
                var _ = d;
                if (s) _[0] !== "comment" && _[0] !== "{" && (m += _[1]);
                else {
                  if (_[0] === "space" && _[1].indexOf(`
`) !== -1) break;
                  _[0] === "(" ? l += 1 : _[0] === ")" ? l -= 1 : l === 0 && _[0] === ":" && (s = true);
                }
              }
              if (!s || m.trim() === "" || /^[a-zA-Z-:#]/.test(m)) g.prototype.rule.call(this, u);
              else {
                u.pop();
                var S = new f();
                this.init(S);
                var x = u[u.length - 1];
                for (x[4] ? S.source.end = { line: x[4], column: x[5] } : S.source.end = { line: x[2], column: x[3] }; u[0][0] !== "word"; ) S.raws.before += u.shift()[1];
                for (S.source.start = { line: u[0][2], column: u[0][3] }, S.prop = ""; u.length; ) {
                  var N = u[0][0];
                  if (N === ":" || N === "space" || N === "comment") break;
                  S.prop += u.shift()[1];
                }
                S.raws.between = "";
                for (var P; u.length; ) if (P = u.shift(), P[0] === ":") {
                  S.raws.between += P[1];
                  break;
                } else S.raws.between += P[1];
                (S.prop[0] === "_" || S.prop[0] === "*") && (S.raws.before += S.prop[0], S.prop = S.prop.slice(1)), S.raws.between += this.spacesAndCommentsFromStart(u), this.precheckMissedSemicolon(u);
                for (var W = u.length - 1; W > 0; W--) {
                  if (P = u[W], P[1] === "!important") {
                    S.important = true;
                    var U = this.stringFrom(u, W);
                    U = this.spacesFromEnd(u) + U, U !== " !important" && (S.raws.important = U);
                    break;
                  } else if (P[1] === "important") {
                    for (var H = u.slice(0), D = "", $ = W; $ > 0; $--) {
                      var B = H[$][0];
                      if (D.trim().indexOf("!") === 0 && B !== "space") break;
                      D = H.pop()[1] + D;
                    }
                    D.trim().indexOf("!") === 0 && (S.important = true, S.raws.important = D, u = H);
                  }
                  if (P[0] !== "space" && P[0] !== "comment") break;
                }
                this.raw(S, "value", u), S.value.indexOf(":") !== -1 && this.checkMissedSemicolon(u), this.current = S;
              }
            }, t.comment = function(u) {
              if (u[6] === "inline") {
                var s = new a();
                this.init(s, u[2], u[3]), s.raws.inline = true, s.source.end = { line: u[4], column: u[5] };
                var l = u[1].slice(2);
                if (/^\s*$/.test(l)) s.text = "", s.raws.left = l, s.raws.right = "";
                else {
                  var m = l.match(/^(\s*)([^]*[^\s])(\s*)$/), v = m[2].replace(/(\*\/|\/\*)/g, "*//*");
                  s.text = v, s.raws.left = m[1], s.raws.right = m[3], s.raws.text = m[2];
                }
              } else g.prototype.comment.call(this, u);
            }, t.raw = function(u, s, l) {
              if (g.prototype.raw.call(this, u, s, l), u.raws[s]) {
                var m = u.raws[s].raw;
                u.raws[s].raw = l.reduce(function(v, y) {
                  if (y[0] === "comment" && y[6] === "inline") {
                    var w = y[1].slice(2).replace(/(\*\/|\/\*)/g, "*//*");
                    return v + "/*" + w + "*/";
                  } else return v + y[1];
                }, ""), m !== u.raws[s].raw && (u.raws[s].scss = m);
              }
            }, c;
          }(o);
          n.exports = h;
        } }), Wf = R({ "node_modules/postcss-scss/lib/scss-parse.js"(e, n) {
          "use strict";
          A();
          var i = _r(), a = Uf();
          n.exports = function(f, p) {
            var h = new i(f, p), g = new a(h);
            return g.parse(), g.root;
          };
        } }), $f = R({ "node_modules/postcss-scss/lib/scss-syntax.js"(e, n) {
          "use strict";
          A();
          var i = zf(), a = Wf();
          n.exports = { parse: a, stringify: i };
        } });
        A();
        var Vf = ml(), pt = Cs(), Gf = Ns(), { hasPragma: Hf } = Tl(), { locStart: Jf, locEnd: Kf } = Js(), { calculateLoc: Qf, replaceQuotesInInlineComments: Yf } = Js(), Xf = Pl(), Zf = Rl(), ht = Il(), sa = Cl(), ep = Nl(), rp = jl(), tp = Ml(), np = Dl(), ip = (e) => {
          for (; e.parent; ) e = e.parent;
          return e;
        };
        function sp(e, n) {
          let { nodes: i } = e, a = { open: null, close: null, groups: [], type: "paren_group" }, o = [a], f = a, p = { groups: [], type: "comma_group" }, h = [p];
          for (let g = 0; g < i.length; ++g) {
            let c = i[g];
            if (sa(n.parser, c.value) && c.type === "number" && c.unit === ".." && pt(c.value) === "." && (c.value = c.value.slice(0, -1), c.unit = "..."), c.type === "func" && c.value === "selector" && (c.group.groups = [Ie(ip(e).text.slice(c.group.open.sourceIndex + 1, c.group.close.sourceIndex))]), c.type === "func" && c.value === "url") {
              let t = c.group && c.group.groups || [], r = [];
              for (let u = 0; u < t.length; u++) {
                let s = t[u];
                s.type === "comma_group" ? r = [...r, ...s.groups] : r.push(s);
              }
              if (Xf(r) || !Zf(r) && !rp(r[0])) {
                let u = tp({ groups: c.group.groups });
                c.group.groups = [u.trim()];
              }
            }
            if (c.type === "paren" && c.value === "(") a = { open: c, close: null, groups: [], type: "paren_group" }, o.push(a), p = { groups: [], type: "comma_group" }, h.push(p);
            else if (c.type === "paren" && c.value === ")") {
              if (p.groups.length > 0 && a.groups.push(p), a.close = c, h.length === 1) throw new Error("Unbalanced parenthesis");
              h.pop(), p = pt(h), p.groups.push(a), o.pop(), a = pt(o);
            } else c.type === "comma" ? (a.groups.push(p), p = { groups: [], type: "comma_group" }, h[h.length - 1] = p) : p.groups.push(c);
          }
          return p.groups.length > 0 && a.groups.push(p), f;
        }
        function hr(e) {
          return e.type === "paren_group" && !e.open && !e.close && e.groups.length === 1 || e.type === "comma_group" && e.groups.length === 1 ? hr(e.groups[0]) : e.type === "paren_group" || e.type === "comma_group" ? Object.assign(Object.assign({}, e), {}, { groups: e.groups.map(hr) }) : e;
        }
        function Xe(e, n, i) {
          if (e && typeof e == "object") {
            delete e.parent;
            for (let a in e) Xe(e[a], n, i), a === "type" && typeof e[a] == "string" && !e[a].startsWith(n) && (!i || !i.test(e[a])) && (e[a] = n + e[a]);
          }
          return e;
        }
        function oa(e) {
          if (e && typeof e == "object") {
            delete e.parent;
            for (let n in e) oa(e[n]);
            !Array.isArray(e) && e.value && !e.type && (e.type = "unknown");
          }
          return e;
        }
        function aa(e, n) {
          if (e && typeof e == "object") {
            for (let i in e) i !== "parent" && (aa(e[i], n), i === "nodes" && (e.group = hr(sp(e, n)), delete e[i]));
            delete e.parent;
          }
          return e;
        }
        function Pe(e, n) {
          let i = lf(), a = null;
          try {
            a = i(e, { loose: true }).parse();
          } catch {
            return { type: "value-unknown", value: e };
          }
          a.text = e;
          let o = aa(a, n);
          return Xe(o, "value-", /^selector-/);
        }
        function Ie(e) {
          if (/\/\/|\/\*/.test(e)) return { type: "selector-unknown", value: e.trim() };
          let n = vf(), i = null;
          try {
            n((a) => {
              i = a;
            }).process(e);
          } catch {
            return { type: "selector-unknown", value: e };
          }
          return Xe(i, "selector-");
        }
        function op(e) {
          let n = gf().default, i = null;
          try {
            i = n(e);
          } catch {
            return { type: "selector-unknown", value: e };
          }
          return Xe(oa(i), "media-");
        }
        var ap = /(\s*)(!default).*$/, up = /(\s*)(!global).*$/;
        function ua(e, n) {
          if (e && typeof e == "object") {
            delete e.parent;
            for (let f in e) ua(e[f], n);
            if (!e.type) return e;
            e.raws || (e.raws = {});
            let i = "";
            typeof e.selector == "string" && (i = e.raws.selector ? e.raws.selector.scss ? e.raws.selector.scss : e.raws.selector.raw : e.selector, e.raws.between && e.raws.between.trim().length > 0 && (i += e.raws.between), e.raws.selector = i);
            let a = "";
            typeof e.value == "string" && (a = e.raws.value ? e.raws.value.scss ? e.raws.value.scss : e.raws.value.raw : e.value, a = a.trim(), e.raws.value = a);
            let o = "";
            if (typeof e.params == "string" && (o = e.raws.params ? e.raws.params.scss ? e.raws.params.scss : e.raws.params.raw : e.params, e.raws.afterName && e.raws.afterName.trim().length > 0 && (o = e.raws.afterName + o), e.raws.between && e.raws.between.trim().length > 0 && (o = o + e.raws.between), o = o.trim(), e.raws.params = o), i.trim().length > 0) return i.startsWith("@") && i.endsWith(":") ? e : e.mixin ? (e.selector = Pe(i, n), e) : (ep(e) && (e.isSCSSNesterProperty = true), e.selector = Ie(i), e);
            if (a.length > 0) {
              let f = a.match(ap);
              f && (a = a.slice(0, f.index), e.scssDefault = true, f[0].trim() !== "!default" && (e.raws.scssDefault = f[0]));
              let p = a.match(up);
              if (p && (a = a.slice(0, p.index), e.scssGlobal = true, p[0].trim() !== "!global" && (e.raws.scssGlobal = p[0])), a.startsWith("progid:")) return { type: "value-unknown", value: a };
              e.value = Pe(a, n);
            }
            if (ht(n) && e.type === "css-decl" && a.startsWith("extend(") && (e.extend || (e.extend = e.raws.between === ":"), e.extend && !e.selector && (delete e.value, e.selector = Ie(a.slice(7, -1)))), e.type === "css-atrule") {
              if (ht(n)) {
                if (e.mixin) {
                  let f = e.raws.identifier + e.name + e.raws.afterName + e.raws.params;
                  return e.selector = Ie(f), delete e.params, e;
                }
                if (e.function) return e;
              }
              if (n.parser === "css" && e.name === "custom-selector") {
                let f = e.params.match(/:--\S+\s+/)[0].trim();
                return e.customSelector = f, e.selector = Ie(e.params.slice(f.length).trim()), delete e.params, e;
              }
              if (ht(n)) {
                if (e.name.includes(":") && !e.params) {
                  e.variable = true;
                  let f = e.name.split(":");
                  e.name = f[0], e.value = Pe(f.slice(1).join(":"), n);
                }
                if (!["page", "nest", "keyframes"].includes(e.name) && e.params && e.params[0] === ":" && (e.variable = true, e.value = Pe(e.params.slice(1), n), e.raws.afterName += ":"), e.variable) return delete e.params, e;
              }
            }
            if (e.type === "css-atrule" && o.length > 0) {
              let { name: f } = e, p = e.name.toLowerCase();
              return f === "warn" || f === "error" ? (e.params = { type: "media-unknown", value: o }, e) : f === "extend" || f === "nest" ? (e.selector = Ie(o), delete e.params, e) : f === "at-root" ? (/^\(\s*(?:without|with)\s*:.+\)$/s.test(o) ? e.params = Pe(o, n) : (e.selector = Ie(o), delete e.params), e) : np(p) ? (e.import = true, delete e.filename, e.params = Pe(o, n), e) : ["namespace", "supports", "if", "else", "for", "each", "while", "debug", "mixin", "include", "function", "return", "define-mixin", "add-mixin"].includes(f) ? (o = o.replace(/(\$\S+?)(\s+)?\.{3}/, "$1...$2"), o = o.replace(/^(?!if)(\S+)(\s+)\(/, "$1($2"), e.value = Pe(o, n), delete e.params, e) : ["media", "custom-media"].includes(p) ? o.includes("#{") ? { type: "media-unknown", value: o } : (e.params = op(o), e) : (e.params = o, e);
            }
          }
          return e;
        }
        function ca(e, n, i) {
          let a = Gf(n), { frontMatter: o } = a;
          n = a.content;
          let f;
          try {
            f = e(n);
          } catch (p) {
            let { name: h, reason: g, line: c, column: t } = p;
            throw typeof c != "number" ? p : Vf("".concat(h, ": ").concat(g), { start: { line: c, column: t } });
          }
          return f = ua(Xe(f, "css-"), i), Qf(f, n), o && (o.source = { startOffset: 0, endOffset: o.raw.length }, f.nodes.unshift(o)), f;
        }
        function cp(e, n) {
          let i = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, o = sa(i.parser, e) ? [xt, bt] : [bt, xt], f;
          for (let p of o) try {
            return p(e, n, i);
          } catch (h) {
            f = f || h;
          }
          if (f) throw f;
        }
        function bt(e, n) {
          let i = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, a = Df();
          return ca((o) => a.parse(Yf(o)), e, i);
        }
        function xt(e, n) {
          let i = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, { parse: a } = $f();
          return ca(a, e, i);
        }
        var dt = { astFormat: "postcss", hasPragma: Hf, locStart: Jf, locEnd: Kf };
        la.exports = { parsers: { css: Object.assign(Object.assign({}, dt), {}, { parse: cp }), less: Object.assign(Object.assign({}, dt), {}, { parse: bt }), scss: Object.assign(Object.assign({}, dt), {}, { parse: xt }) } };
      });
      return lp();
    });
  }
});

// ../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-glimmer.js
var require_parser_glimmer = __commonJS({
  "../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-glimmer.js"(exports2, module2) {
    "use strict";
    (function(e) {
      if (typeof exports2 == "object" && typeof module2 == "object") module2.exports = e();
      else if (typeof define == "function" && define.amd) define(e);
      else {
        var i = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i.prettierPlugins = i.prettierPlugins || {}, i.prettierPlugins.glimmer = e();
      }
    })(function() {
      "use strict";
      var it = (t, f) => () => (f || t((f = { exports: {} }).exports, f), f.exports);
      var Zt = it((nr, $e) => {
        var xe = Object.getOwnPropertyNames, at = (t, f) => function() {
          return t && (f = (0, t[xe(t)[0]])(t = 0)), f;
        }, I = (t, f) => function() {
          return f || (0, t[xe(t)[0]])((f = { exports: {} }).exports, f), f.exports;
        }, F = at({ "<define:process>"() {
        } }), st = I({ "node_modules/lines-and-columns/build/index.cjs"(t) {
          "use strict";
          F(), t.__esModule = true, t.LinesAndColumns = void 0;
          var f = `
`, h = "\r", d = function() {
            function c(o) {
              this.length = o.length;
              for (var e = [0], r = 0; r < o.length; ) switch (o[r]) {
                case f:
                  r += f.length, e.push(r);
                  break;
                case h:
                  r += h.length, o[r] === f && (r += f.length), e.push(r);
                  break;
                default:
                  r++;
                  break;
              }
              this.offsets = e;
            }
            return c.prototype.locationForIndex = function(o) {
              if (o < 0 || o > this.length) return null;
              for (var e = 0, r = this.offsets; r[e + 1] <= o; ) e++;
              var s = o - r[e];
              return { line: e, column: s };
            }, c.prototype.indexForLocation = function(o) {
              var e = o.line, r = o.column;
              return e < 0 || e >= this.offsets.length || r < 0 || r > this.lengthOfLine(e) ? null : this.offsets[e] + r;
            }, c.prototype.lengthOfLine = function(o) {
              var e = this.offsets[o], r = o === this.offsets.length - 1 ? this.length : this.offsets[o + 1];
              return r - e;
            }, c;
          }();
          t.LinesAndColumns = d;
        } }), ut = I({ "src/common/parser-create-error.js"(t, f) {
          "use strict";
          F();
          function h(d, c) {
            let o = new SyntaxError(d + " (" + c.start.line + ":" + c.start.column + ")");
            return o.loc = c, o;
          }
          f.exports = h;
        } }), ot = I({ "src/language-handlebars/loc.js"(t, f) {
          "use strict";
          F();
          function h(c) {
            return c.loc.start.offset;
          }
          function d(c) {
            return c.loc.end.offset;
          }
          f.exports = { locStart: h, locEnd: d };
        } }), fe = I({ "node_modules/@glimmer/env/dist/commonjs/es5/index.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true });
          var f = t.DEBUG = false, h = t.CI = false;
        } }), lt = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/array-utils.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.emptyArray = h, t.isEmptyArray = o, t.EMPTY_NUMBER_ARRAY = t.EMPTY_STRING_ARRAY = t.EMPTY_ARRAY = void 0;
          var f = Object.freeze([]);
          t.EMPTY_ARRAY = f;
          function h() {
            return f;
          }
          var d = h();
          t.EMPTY_STRING_ARRAY = d;
          var c = h();
          t.EMPTY_NUMBER_ARRAY = c;
          function o(e) {
            return e === f;
          }
        } }), Pe = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/assert.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.debugAssert = h, t.prodAssert = d, t.deprecate = c, t.default = void 0;
          var f = X();
          function h(e, r) {
            if (!e) throw new Error(r || "assertion failure");
          }
          function d() {
          }
          function c(e) {
            f.LOCAL_LOGGER.warn("DEPRECATION: ".concat(e));
          }
          var o = h;
          t.default = o;
        } }), ct = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/collections.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.dict = f, t.isDict = h, t.isObject = d, t.StackImpl = void 0;
          function f() {
            return /* @__PURE__ */ Object.create(null);
          }
          function h(o) {
            return o != null;
          }
          function d(o) {
            return typeof o == "function" || typeof o == "object" && o !== null;
          }
          var c = class {
            constructor() {
              let o = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : [];
              this.current = null, this.stack = o;
            }
            get size() {
              return this.stack.length;
            }
            push(o) {
              this.current = o, this.stack.push(o);
            }
            pop() {
              let o = this.stack.pop(), e = this.stack.length;
              return this.current = e === 0 ? null : this.stack[e - 1], o === void 0 ? null : o;
            }
            nth(o) {
              let e = this.stack.length;
              return e < o ? null : this.stack[e - o];
            }
            isEmpty() {
              return this.stack.length === 0;
            }
            toArray() {
              return this.stack;
            }
          };
          t.StackImpl = c;
        } }), ht = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/dom.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.clearElement = f;
          function f(h) {
            let d = h.firstChild;
            for (; d; ) {
              let c = d.nextSibling;
              h.removeChild(d), d = c;
            }
          }
        } }), dt = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/is-serialization-first-node.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.isSerializationFirstNode = h, t.SERIALIZATION_FIRST_NODE_STRING = void 0;
          var f = "%+b:0%";
          t.SERIALIZATION_FIRST_NODE_STRING = f;
          function h(d) {
            return d.nodeValue === f;
          }
        } }), pt = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/object-utils.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.fillNulls = h, t.values = d, t.assign = void 0;
          var f = Object.assign;
          t.assign = f;
          function h(c) {
            let o = new Array(c);
            for (let e = 0; e < c; e++) o[e] = null;
            return o;
          }
          function d(c) {
            let o = [];
            for (let e in c) o.push(c[e]);
            return o;
          }
        } }), je = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/intern.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.default = f;
          function f(h) {
            let d = {};
            d[h] = 1;
            for (let c in d) if (c === h) return c;
            return h;
          }
        } }), me = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/platform-utils.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.keys = o, t.unwrap = e, t.expect = r, t.unreachable = s, t.exhausted = p, t.enumerableSymbol = a, t.symbol = t.tuple = t.HAS_NATIVE_SYMBOL = t.HAS_NATIVE_PROXY = void 0;
          var f = h(je());
          function h(i) {
            return i && i.__esModule ? i : { default: i };
          }
          var d = typeof Proxy == "function";
          t.HAS_NATIVE_PROXY = d;
          var c = function() {
            return typeof Symbol != "function" ? false : typeof Symbol() == "symbol";
          }();
          t.HAS_NATIVE_SYMBOL = c;
          function o(i) {
            return Object.keys(i);
          }
          function e(i) {
            if (i == null) throw new Error("Expected value to be present");
            return i;
          }
          function r(i, l) {
            if (i == null) throw new Error(l);
            return i;
          }
          function s() {
            let i = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : "unreachable";
            return new Error(i);
          }
          function p(i) {
            throw new Error("Exhausted ".concat(i));
          }
          var n = function() {
            for (var i = arguments.length, l = new Array(i), b = 0; b < i; b++) l[b] = arguments[b];
            return l;
          };
          t.tuple = n;
          function a(i) {
            return (0, f.default)("__".concat(i).concat(Math.floor(Math.random() * Date.now()), "__"));
          }
          var u = c ? Symbol : a;
          t.symbol = u;
        } }), ft = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/string.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.strip = f;
          function f(h) {
            let d = "";
            for (var c = arguments.length, o = new Array(c > 1 ? c - 1 : 0), e = 1; e < c; e++) o[e - 1] = arguments[e];
            for (let n = 0; n < h.length; n++) {
              let a = h[n], u = o[n] !== void 0 ? String(o[n]) : "";
              d += "".concat(a).concat(u);
            }
            let r = d.split(`
`);
            for (; r.length && r[0].match(/^\s*$/); ) r.shift();
            for (; r.length && r[r.length - 1].match(/^\s*$/); ) r.pop();
            let s = 1 / 0;
            for (let n of r) {
              let a = n.match(/^\s*/)[0].length;
              s = Math.min(s, a);
            }
            let p = [];
            for (let n of r) p.push(n.slice(s));
            return p.join(`
`);
          }
        } }), mt = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/immediate.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.isHandle = h, t.isNonPrimitiveHandle = d, t.constants = c, t.isSmallInt = o, t.encodeNegative = e, t.decodeNegative = r, t.encodePositive = s, t.decodePositive = p, t.encodeHandle = n, t.decodeHandle = a, t.encodeImmediate = u, t.decodeImmediate = i;
          var f = Pe();
          function h(l) {
            return l >= 0;
          }
          function d(l) {
            return l > 3;
          }
          function c() {
            for (var l = arguments.length, b = new Array(l), P = 0; P < l; P++) b[P] = arguments[P];
            return [false, true, null, void 0, ...b];
          }
          function o(l) {
            return l % 1 === 0 && l <= 536870911 && l >= -536870912;
          }
          function e(l) {
            return l & -536870913;
          }
          function r(l) {
            return l | 536870912;
          }
          function s(l) {
            return ~l;
          }
          function p(l) {
            return ~l;
          }
          function n(l) {
            return l;
          }
          function a(l) {
            return l;
          }
          function u(l) {
            return l |= 0, l < 0 ? e(l) : s(l);
          }
          function i(l) {
            return l |= 0, l > -536870913 ? p(l) : r(l);
          }
          [1, 2, 3].forEach((l) => l), [1, -1].forEach((l) => i(u(l)));
        } }), gt = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/template.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.unwrapHandle = f, t.unwrapTemplate = h, t.extractHandle = d, t.isOkHandle = c, t.isErrHandle = o;
          function f(e) {
            if (typeof e == "number") return e;
            {
              let r = e.errors[0];
              throw new Error("Compile Error: ".concat(r.problem, " @ ").concat(r.span.start, "..").concat(r.span.end));
            }
          }
          function h(e) {
            if (e.result === "error") throw new Error("Compile Error: ".concat(e.problem, " @ ").concat(e.span.start, "..").concat(e.span.end));
            return e;
          }
          function d(e) {
            return typeof e == "number" ? e : e.handle;
          }
          function c(e) {
            return typeof e == "number";
          }
          function o(e) {
            return typeof e == "number";
          }
        } }), bt = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/weak-set.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.default = void 0;
          var f = typeof WeakSet == "function" ? WeakSet : class {
            constructor() {
              this._map = /* @__PURE__ */ new WeakMap();
            }
            add(d) {
              return this._map.set(d, true), this;
            }
            delete(d) {
              return this._map.delete(d);
            }
            has(d) {
              return this._map.has(d);
            }
          };
          t.default = f;
        } }), vt = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/simple-cast.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.castToSimple = h, t.castToBrowser = d, t.checkNode = r;
          var f = me();
          function h(p) {
            return o(p) || e(p), p;
          }
          function d(p, n) {
            if (p == null) return null;
            if (typeof document === void 0) throw new Error("Attempted to cast to a browser node in a non-browser context");
            if (o(p)) return p;
            if (p.ownerDocument !== document) throw new Error("Attempted to cast to a browser node with a node that was not created from this document");
            return r(p, n);
          }
          function c(p, n) {
            return new Error("cannot cast a ".concat(p, " into ").concat(n));
          }
          function o(p) {
            return p.nodeType === 9;
          }
          function e(p) {
            return p.nodeType === 1;
          }
          function r(p, n) {
            let a = false;
            if (p !== null) if (typeof n == "string") a = s(p, n);
            else if (Array.isArray(n)) a = n.some((u) => s(p, u));
            else throw (0, f.unreachable)();
            if (a) return p;
            throw c("SimpleElement(".concat(p, ")"), n);
          }
          function s(p, n) {
            switch (n) {
              case "NODE":
                return true;
              case "HTML":
                return p instanceof HTMLElement;
              case "SVG":
                return p instanceof SVGElement;
              case "ELEMENT":
                return p instanceof Element;
              default:
                if (n.toUpperCase() === n) throw new Error("BUG: this code is missing handling for a generic node type");
                return p instanceof Element && p.tagName.toLowerCase() === n;
            }
          }
        } }), yt = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/present.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.isPresent = f, t.ifPresent = h, t.toPresentOption = d, t.assertPresent = c, t.mapPresent = o;
          function f(e) {
            return e.length > 0;
          }
          function h(e, r, s) {
            return f(e) ? r(e) : s();
          }
          function d(e) {
            return f(e) ? e : null;
          }
          function c(e) {
            let r = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "unexpected empty list";
            if (!f(e)) throw new Error(r);
          }
          function o(e, r) {
            if (e === null) return null;
            let s = [];
            for (let p of e) s.push(r(p));
            return s;
          }
        } }), At = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/untouchable-this.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.default = d;
          var f = fe(), h = me();
          function d(c) {
            let o = null;
            if (f.DEBUG && h.HAS_NATIVE_PROXY) {
              let e = (r) => {
                throw new Error("You accessed `this.".concat(String(r), "` from a function passed to the ").concat(c, ", but the function itself was not bound to a valid `this` context. Consider updating to use a bound function (for instance, use an arrow function, `() => {}`)."));
              };
              o = new Proxy({}, { get(r, s) {
                e(s);
              }, set(r, s) {
                return e(s), false;
              }, has(r, s) {
                return e(s), false;
              } });
            }
            return o;
          }
        } }), Et = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/debug-to-string.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.default = void 0;
          var f = fe(), h;
          if (f.DEBUG) {
            let c = (r) => {
              let s = r.name;
              if (s === void 0) {
                let p = Function.prototype.toString.call(r).match(/function (\w+)\s*\(/);
                s = p && p[1] || "";
              }
              return s.replace(/^bound /, "");
            }, o = (r) => {
              let s, p;
              return r.constructor && typeof r.constructor == "function" && (p = c(r.constructor)), "toString" in r && r.toString !== Object.prototype.toString && r.toString !== Function.prototype.toString && (s = r.toString()), s && s.match(/<.*:ember\d+>/) && p && p[0] !== "_" && p.length > 2 && p !== "Class" ? s.replace(/<.*:/, "<".concat(p, ":")) : s || p;
            }, e = (r) => String(r);
            h = (r) => typeof r == "function" ? c(r) || "(unknown function)" : typeof r == "object" && r !== null ? o(r) || "(unknown object)" : e(r);
          }
          var d = h;
          t.default = d;
        } }), _t = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/debug-steps.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.logStep = t.verifySteps = t.endTestSteps = t.beginTestSteps = void 0;
          var f = d(Pe()), h = me();
          function d(s) {
            return s && s.__esModule ? s : { default: s };
          }
          var c;
          t.beginTestSteps = c;
          var o;
          t.endTestSteps = o;
          var e;
          t.verifySteps = e;
          var r;
          t.logStep = r;
        } }), X = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/index.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true });
          var f = { LOCAL_LOGGER: true, LOGGER: true, assertNever: true, assert: true, deprecate: true, dict: true, isDict: true, isObject: true, Stack: true, isSerializationFirstNode: true, SERIALIZATION_FIRST_NODE_STRING: true, assign: true, fillNulls: true, values: true, _WeakSet: true, castToSimple: true, castToBrowser: true, checkNode: true, intern: true, buildUntouchableThis: true, debugToString: true, beginTestSteps: true, endTestSteps: true, logStep: true, verifySteps: true };
          t.assertNever = x, Object.defineProperty(t, "assert", { enumerable: true, get: function() {
            return d.default;
          } }), Object.defineProperty(t, "deprecate", { enumerable: true, get: function() {
            return d.deprecate;
          } }), Object.defineProperty(t, "dict", { enumerable: true, get: function() {
            return c.dict;
          } }), Object.defineProperty(t, "isDict", { enumerable: true, get: function() {
            return c.isDict;
          } }), Object.defineProperty(t, "isObject", { enumerable: true, get: function() {
            return c.isObject;
          } }), Object.defineProperty(t, "Stack", { enumerable: true, get: function() {
            return c.StackImpl;
          } }), Object.defineProperty(t, "isSerializationFirstNode", { enumerable: true, get: function() {
            return e.isSerializationFirstNode;
          } }), Object.defineProperty(t, "SERIALIZATION_FIRST_NODE_STRING", { enumerable: true, get: function() {
            return e.SERIALIZATION_FIRST_NODE_STRING;
          } }), Object.defineProperty(t, "assign", { enumerable: true, get: function() {
            return r.assign;
          } }), Object.defineProperty(t, "fillNulls", { enumerable: true, get: function() {
            return r.fillNulls;
          } }), Object.defineProperty(t, "values", { enumerable: true, get: function() {
            return r.values;
          } }), Object.defineProperty(t, "_WeakSet", { enumerable: true, get: function() {
            return u.default;
          } }), Object.defineProperty(t, "castToSimple", { enumerable: true, get: function() {
            return i.castToSimple;
          } }), Object.defineProperty(t, "castToBrowser", { enumerable: true, get: function() {
            return i.castToBrowser;
          } }), Object.defineProperty(t, "checkNode", { enumerable: true, get: function() {
            return i.checkNode;
          } }), Object.defineProperty(t, "intern", { enumerable: true, get: function() {
            return b.default;
          } }), Object.defineProperty(t, "buildUntouchableThis", { enumerable: true, get: function() {
            return P.default;
          } }), Object.defineProperty(t, "debugToString", { enumerable: true, get: function() {
            return E.default;
          } }), Object.defineProperty(t, "beginTestSteps", { enumerable: true, get: function() {
            return v.beginTestSteps;
          } }), Object.defineProperty(t, "endTestSteps", { enumerable: true, get: function() {
            return v.endTestSteps;
          } }), Object.defineProperty(t, "logStep", { enumerable: true, get: function() {
            return v.logStep;
          } }), Object.defineProperty(t, "verifySteps", { enumerable: true, get: function() {
            return v.verifySteps;
          } }), t.LOGGER = t.LOCAL_LOGGER = void 0;
          var h = lt();
          Object.keys(h).forEach(function(w) {
            w === "default" || w === "__esModule" || Object.prototype.hasOwnProperty.call(f, w) || Object.defineProperty(t, w, { enumerable: true, get: function() {
              return h[w];
            } });
          });
          var d = g(Pe()), c = ct(), o = ht();
          Object.keys(o).forEach(function(w) {
            w === "default" || w === "__esModule" || Object.prototype.hasOwnProperty.call(f, w) || Object.defineProperty(t, w, { enumerable: true, get: function() {
              return o[w];
            } });
          });
          var e = dt(), r = pt(), s = me();
          Object.keys(s).forEach(function(w) {
            w === "default" || w === "__esModule" || Object.prototype.hasOwnProperty.call(f, w) || Object.defineProperty(t, w, { enumerable: true, get: function() {
              return s[w];
            } });
          });
          var p = ft();
          Object.keys(p).forEach(function(w) {
            w === "default" || w === "__esModule" || Object.prototype.hasOwnProperty.call(f, w) || Object.defineProperty(t, w, { enumerable: true, get: function() {
              return p[w];
            } });
          });
          var n = mt();
          Object.keys(n).forEach(function(w) {
            w === "default" || w === "__esModule" || Object.prototype.hasOwnProperty.call(f, w) || Object.defineProperty(t, w, { enumerable: true, get: function() {
              return n[w];
            } });
          });
          var a = gt();
          Object.keys(a).forEach(function(w) {
            w === "default" || w === "__esModule" || Object.prototype.hasOwnProperty.call(f, w) || Object.defineProperty(t, w, { enumerable: true, get: function() {
              return a[w];
            } });
          });
          var u = _(bt()), i = vt(), l = yt();
          Object.keys(l).forEach(function(w) {
            w === "default" || w === "__esModule" || Object.prototype.hasOwnProperty.call(f, w) || Object.defineProperty(t, w, { enumerable: true, get: function() {
              return l[w];
            } });
          });
          var b = _(je()), P = _(At()), E = _(Et()), v = _t();
          function _(w) {
            return w && w.__esModule ? w : { default: w };
          }
          function y() {
            if (typeof WeakMap != "function") return null;
            var w = /* @__PURE__ */ new WeakMap();
            return y = function() {
              return w;
            }, w;
          }
          function g(w) {
            if (w && w.__esModule) return w;
            if (w === null || typeof w != "object" && typeof w != "function") return { default: w };
            var H = y();
            if (H && H.has(w)) return H.get(w);
            var m = {}, C = Object.defineProperty && Object.getOwnPropertyDescriptor;
            for (var S in w) if (Object.prototype.hasOwnProperty.call(w, S)) {
              var R = C ? Object.getOwnPropertyDescriptor(w, S) : null;
              R && (R.get || R.set) ? Object.defineProperty(m, S, R) : m[S] = w[S];
            }
            return m.default = w, H && H.set(w, m), m;
          }
          var L = console;
          t.LOCAL_LOGGER = L;
          var j = console;
          t.LOGGER = j;
          function x(w) {
            let H = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "unexpected unreachable branch";
            throw j.log("unreachable", w), j.log("".concat(H, " :: ").concat(JSON.stringify(w), " (").concat(w, ")")), new Error("code reached unreachable");
          }
        } }), ge = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/source/location.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.isLocatedWithPositionsArray = s, t.isLocatedWithPositions = p, t.BROKEN_LOCATION = t.NON_EXISTENT_LOCATION = t.TEMPORARY_LOCATION = t.SYNTHETIC = t.SYNTHETIC_LOCATION = t.UNKNOWN_POSITION = void 0;
          var f = X(), h = Object.freeze({ line: 1, column: 0 });
          t.UNKNOWN_POSITION = h;
          var d = Object.freeze({ source: "(synthetic)", start: h, end: h });
          t.SYNTHETIC_LOCATION = d;
          var c = d;
          t.SYNTHETIC = c;
          var o = Object.freeze({ source: "(temporary)", start: h, end: h });
          t.TEMPORARY_LOCATION = o;
          var e = Object.freeze({ source: "(nonexistent)", start: h, end: h });
          t.NON_EXISTENT_LOCATION = e;
          var r = Object.freeze({ source: "(broken)", start: h, end: h });
          t.BROKEN_LOCATION = r;
          function s(n) {
            return (0, f.isPresent)(n) && n.every(p);
          }
          function p(n) {
            return n.loc !== void 0;
          }
        } }), le = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/source/slice.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.SourceSlice = void 0;
          var f = ue(), h = class {
            constructor(d) {
              this.loc = d.loc, this.chars = d.chars;
            }
            static synthetic(d) {
              let c = f.SourceSpan.synthetic(d);
              return new h({ loc: c, chars: d });
            }
            static load(d, c) {
              return new h({ loc: f.SourceSpan.load(d, c[1]), chars: c[0] });
            }
            getString() {
              return this.chars;
            }
            serialize() {
              return [this.chars, this.loc.serialize()];
            }
          };
          t.SourceSlice = h;
        } }), Me = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/source/loc/match.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.match = e, t.IsInvisible = t.MatchAny = void 0;
          var f = X(), h = "MATCH_ANY";
          t.MatchAny = h;
          var d = "IS_INVISIBLE";
          t.IsInvisible = d;
          var c = class {
            constructor(p) {
              this._whens = p;
            }
            first(p) {
              for (let n of this._whens) {
                let a = n.match(p);
                if ((0, f.isPresent)(a)) return a[0];
              }
              return null;
            }
          }, o = class {
            constructor() {
              this._map = /* @__PURE__ */ new Map();
            }
            get(p, n) {
              let a = this._map.get(p);
              return a || (a = n(), this._map.set(p, a), a);
            }
            add(p, n) {
              this._map.set(p, n);
            }
            match(p) {
              let n = s(p), a = [], u = this._map.get(n), i = this._map.get(h);
              return u && a.push(u), i && a.push(i), a;
            }
          };
          function e(p) {
            return p(new r()).check();
          }
          var r = class {
            constructor() {
              this._whens = new o();
            }
            check() {
              return (p, n) => this.matchFor(p.kind, n.kind)(p, n);
            }
            matchFor(p, n) {
              let a = this._whens.match(p);
              return new c(a).first(n);
            }
            when(p, n, a) {
              return this._whens.get(p, () => new o()).add(n, a), this;
            }
          };
          function s(p) {
            switch (p) {
              case "Broken":
              case "InternalsSynthetic":
              case "NonExistent":
                return d;
              default:
                return p;
            }
          }
        } }), He = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/source/loc/offset.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.InvisiblePosition = t.HbsPosition = t.CharPosition = t.SourceOffset = t.BROKEN = void 0;
          var f = ge(), h = Me(), d = Ve(), c = "BROKEN";
          t.BROKEN = c;
          var o = class {
            constructor(n) {
              this.data = n;
            }
            static forHbsPos(n, a) {
              return new r(n, a, null).wrap();
            }
            static broken() {
              let n = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : f.UNKNOWN_POSITION;
              return new s("Broken", n).wrap();
            }
            get offset() {
              let n = this.data.toCharPos();
              return n === null ? null : n.offset;
            }
            eql(n) {
              return p(this.data, n.data);
            }
            until(n) {
              return (0, d.span)(this.data, n.data);
            }
            move(n) {
              let a = this.data.toCharPos();
              if (a === null) return o.broken();
              {
                let u = a.offset + n;
                return a.source.check(u) ? new e(a.source, u).wrap() : o.broken();
              }
            }
            collapsed() {
              return (0, d.span)(this.data, this.data);
            }
            toJSON() {
              return this.data.toJSON();
            }
          };
          t.SourceOffset = o;
          var e = class {
            constructor(n, a) {
              this.source = n, this.charPos = a, this.kind = "CharPosition", this._locPos = null;
            }
            toCharPos() {
              return this;
            }
            toJSON() {
              let n = this.toHbsPos();
              return n === null ? f.UNKNOWN_POSITION : n.toJSON();
            }
            wrap() {
              return new o(this);
            }
            get offset() {
              return this.charPos;
            }
            toHbsPos() {
              let n = this._locPos;
              if (n === null) {
                let a = this.source.hbsPosFor(this.charPos);
                a === null ? this._locPos = n = c : this._locPos = n = new r(this.source, a, this.charPos);
              }
              return n === c ? null : n;
            }
          };
          t.CharPosition = e;
          var r = class {
            constructor(n, a) {
              let u = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
              this.source = n, this.hbsPos = a, this.kind = "HbsPosition", this._charPos = u === null ? null : new e(n, u);
            }
            toCharPos() {
              let n = this._charPos;
              if (n === null) {
                let a = this.source.charPosFor(this.hbsPos);
                a === null ? this._charPos = n = c : this._charPos = n = new e(this.source, a);
              }
              return n === c ? null : n;
            }
            toJSON() {
              return this.hbsPos;
            }
            wrap() {
              return new o(this);
            }
            toHbsPos() {
              return this;
            }
          };
          t.HbsPosition = r;
          var s = class {
            constructor(n, a) {
              this.kind = n, this.pos = a;
            }
            toCharPos() {
              return null;
            }
            toJSON() {
              return this.pos;
            }
            wrap() {
              return new o(this);
            }
            get offset() {
              return null;
            }
          };
          t.InvisiblePosition = s;
          var p = (0, h.match)((n) => n.when("HbsPosition", "HbsPosition", (a, u) => {
            let { hbsPos: i } = a, { hbsPos: l } = u;
            return i.column === l.column && i.line === l.line;
          }).when("CharPosition", "CharPosition", (a, u) => {
            let { charPos: i } = a, { charPos: l } = u;
            return i === l;
          }).when("CharPosition", "HbsPosition", (a, u) => {
            let { offset: i } = a;
            var l;
            return i === ((l = u.toCharPos()) === null || l === void 0 ? void 0 : l.offset);
          }).when("HbsPosition", "CharPosition", (a, u) => {
            let { offset: i } = u;
            var l;
            return ((l = a.toCharPos()) === null || l === void 0 ? void 0 : l.offset) === i;
          }).when(h.MatchAny, h.MatchAny, () => false));
        } }), Ve = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/source/loc/span.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.span = t.HbsSpan = t.SourceSpan = void 0;
          var f = fe(), h = X(), d = ge(), c = le(), o = Me(), e = He(), r = class {
            constructor(u) {
              this.data = u, this.isInvisible = u.kind !== "CharPosition" && u.kind !== "HbsPosition";
            }
            static get NON_EXISTENT() {
              return new n("NonExistent", d.NON_EXISTENT_LOCATION).wrap();
            }
            static load(u, i) {
              if (typeof i == "number") return r.forCharPositions(u, i, i);
              if (typeof i == "string") return r.synthetic(i);
              if (Array.isArray(i)) return r.forCharPositions(u, i[0], i[1]);
              if (i === "NonExistent") return r.NON_EXISTENT;
              if (i === "Broken") return r.broken(d.BROKEN_LOCATION);
              (0, h.assertNever)(i);
            }
            static forHbsLoc(u, i) {
              let l = new e.HbsPosition(u, i.start), b = new e.HbsPosition(u, i.end);
              return new p(u, { start: l, end: b }, i).wrap();
            }
            static forCharPositions(u, i, l) {
              let b = new e.CharPosition(u, i), P = new e.CharPosition(u, l);
              return new s(u, { start: b, end: P }).wrap();
            }
            static synthetic(u) {
              return new n("InternalsSynthetic", d.NON_EXISTENT_LOCATION, u).wrap();
            }
            static broken() {
              let u = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : d.BROKEN_LOCATION;
              return new n("Broken", u).wrap();
            }
            getStart() {
              return this.data.getStart().wrap();
            }
            getEnd() {
              return this.data.getEnd().wrap();
            }
            get loc() {
              let u = this.data.toHbsSpan();
              return u === null ? d.BROKEN_LOCATION : u.toHbsLoc();
            }
            get module() {
              return this.data.getModule();
            }
            get startPosition() {
              return this.loc.start;
            }
            get endPosition() {
              return this.loc.end;
            }
            toJSON() {
              return this.loc;
            }
            withStart(u) {
              return a(u.data, this.data.getEnd());
            }
            withEnd(u) {
              return a(this.data.getStart(), u.data);
            }
            asString() {
              return this.data.asString();
            }
            toSlice(u) {
              let i = this.data.asString();
              return f.DEBUG && u !== void 0 && i !== u && console.warn("unexpectedly found ".concat(JSON.stringify(i), " when slicing source, but expected ").concat(JSON.stringify(u))), new c.SourceSlice({ loc: this, chars: u || i });
            }
            get start() {
              return this.loc.start;
            }
            set start(u) {
              this.data.locDidUpdate({ start: u });
            }
            get end() {
              return this.loc.end;
            }
            set end(u) {
              this.data.locDidUpdate({ end: u });
            }
            get source() {
              return this.module;
            }
            collapse(u) {
              switch (u) {
                case "start":
                  return this.getStart().collapsed();
                case "end":
                  return this.getEnd().collapsed();
              }
            }
            extend(u) {
              return a(this.data.getStart(), u.data.getEnd());
            }
            serialize() {
              return this.data.serialize();
            }
            slice(u) {
              let { skipStart: i = 0, skipEnd: l = 0 } = u;
              return a(this.getStart().move(i).data, this.getEnd().move(-l).data);
            }
            sliceStartChars(u) {
              let { skipStart: i = 0, chars: l } = u;
              return a(this.getStart().move(i).data, this.getStart().move(i + l).data);
            }
            sliceEndChars(u) {
              let { skipEnd: i = 0, chars: l } = u;
              return a(this.getEnd().move(i - l).data, this.getStart().move(-i).data);
            }
          };
          t.SourceSpan = r;
          var s = class {
            constructor(u, i) {
              this.source = u, this.charPositions = i, this.kind = "CharPosition", this._locPosSpan = null;
            }
            wrap() {
              return new r(this);
            }
            asString() {
              return this.source.slice(this.charPositions.start.charPos, this.charPositions.end.charPos);
            }
            getModule() {
              return this.source.module;
            }
            getStart() {
              return this.charPositions.start;
            }
            getEnd() {
              return this.charPositions.end;
            }
            locDidUpdate() {
            }
            toHbsSpan() {
              let u = this._locPosSpan;
              if (u === null) {
                let i = this.charPositions.start.toHbsPos(), l = this.charPositions.end.toHbsPos();
                i === null || l === null ? u = this._locPosSpan = e.BROKEN : u = this._locPosSpan = new p(this.source, { start: i, end: l });
              }
              return u === e.BROKEN ? null : u;
            }
            serialize() {
              let { start: { charPos: u }, end: { charPos: i } } = this.charPositions;
              return u === i ? u : [u, i];
            }
            toCharPosSpan() {
              return this;
            }
          }, p = class {
            constructor(u, i) {
              let l = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
              this.source = u, this.hbsPositions = i, this.kind = "HbsPosition", this._charPosSpan = null, this._providedHbsLoc = l;
            }
            serialize() {
              let u = this.toCharPosSpan();
              return u === null ? "Broken" : u.wrap().serialize();
            }
            wrap() {
              return new r(this);
            }
            updateProvided(u, i) {
              this._providedHbsLoc && (this._providedHbsLoc[i] = u), this._charPosSpan = null, this._providedHbsLoc = { start: u, end: u };
            }
            locDidUpdate(u) {
              let { start: i, end: l } = u;
              i !== void 0 && (this.updateProvided(i, "start"), this.hbsPositions.start = new e.HbsPosition(this.source, i, null)), l !== void 0 && (this.updateProvided(l, "end"), this.hbsPositions.end = new e.HbsPosition(this.source, l, null));
            }
            asString() {
              let u = this.toCharPosSpan();
              return u === null ? "" : u.asString();
            }
            getModule() {
              return this.source.module;
            }
            getStart() {
              return this.hbsPositions.start;
            }
            getEnd() {
              return this.hbsPositions.end;
            }
            toHbsLoc() {
              return { start: this.hbsPositions.start.hbsPos, end: this.hbsPositions.end.hbsPos };
            }
            toHbsSpan() {
              return this;
            }
            toCharPosSpan() {
              let u = this._charPosSpan;
              if (u === null) {
                let i = this.hbsPositions.start.toCharPos(), l = this.hbsPositions.end.toCharPos();
                if (i && l) u = this._charPosSpan = new s(this.source, { start: i, end: l });
                else return u = this._charPosSpan = e.BROKEN, null;
              }
              return u === e.BROKEN ? null : u;
            }
          };
          t.HbsSpan = p;
          var n = class {
            constructor(u, i) {
              let l = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
              this.kind = u, this.loc = i, this.string = l;
            }
            serialize() {
              switch (this.kind) {
                case "Broken":
                case "NonExistent":
                  return this.kind;
                case "InternalsSynthetic":
                  return this.string || "";
              }
            }
            wrap() {
              return new r(this);
            }
            asString() {
              return this.string || "";
            }
            locDidUpdate(u) {
              let { start: i, end: l } = u;
              i !== void 0 && (this.loc.start = i), l !== void 0 && (this.loc.end = l);
            }
            getModule() {
              return "an unknown module";
            }
            getStart() {
              return new e.InvisiblePosition(this.kind, this.loc.start);
            }
            getEnd() {
              return new e.InvisiblePosition(this.kind, this.loc.end);
            }
            toCharPosSpan() {
              return this;
            }
            toHbsSpan() {
              return null;
            }
            toHbsLoc() {
              return d.BROKEN_LOCATION;
            }
          }, a = (0, o.match)((u) => u.when("HbsPosition", "HbsPosition", (i, l) => new p(i.source, { start: i, end: l }).wrap()).when("CharPosition", "CharPosition", (i, l) => new s(i.source, { start: i, end: l }).wrap()).when("CharPosition", "HbsPosition", (i, l) => {
            let b = l.toCharPos();
            return b === null ? new n("Broken", d.BROKEN_LOCATION).wrap() : a(i, b);
          }).when("HbsPosition", "CharPosition", (i, l) => {
            let b = i.toCharPos();
            return b === null ? new n("Broken", d.BROKEN_LOCATION).wrap() : a(b, l);
          }).when(o.IsInvisible, o.MatchAny, (i) => new n(i.kind, d.BROKEN_LOCATION).wrap()).when(o.MatchAny, o.IsInvisible, (i, l) => new n(l.kind, d.BROKEN_LOCATION).wrap()));
          t.span = a;
        } }), ue = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/source/span.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), Object.defineProperty(t, "SourceSpan", { enumerable: true, get: function() {
            return f.SourceSpan;
          } }), Object.defineProperty(t, "SourceOffset", { enumerable: true, get: function() {
            return h.SourceOffset;
          } });
          var f = Ve(), h = He();
        } }), De = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/source/source.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.Source = void 0;
          var f = fe(), h = X(), d = ue(), c = class {
            constructor(o) {
              let e = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "an unknown module";
              this.source = o, this.module = e;
            }
            check(o) {
              return o >= 0 && o <= this.source.length;
            }
            slice(o, e) {
              return this.source.slice(o, e);
            }
            offsetFor(o, e) {
              return d.SourceOffset.forHbsPos(this, { line: o, column: e });
            }
            spanFor(o) {
              let { start: e, end: r } = o;
              return d.SourceSpan.forHbsLoc(this, { start: { line: e.line, column: e.column }, end: { line: r.line, column: r.column } });
            }
            hbsPosFor(o) {
              let e = 0, r = 0;
              if (o > this.source.length) return null;
              for (; ; ) {
                let s = this.source.indexOf(`
`, r);
                if (o <= s || s === -1) return { line: e + 1, column: o - r };
                e += 1, r = s + 1;
              }
            }
            charPosFor(o) {
              let { line: e, column: r } = o, p = this.source.length, n = 0, a = 0;
              for (; ; ) {
                if (a >= p) return p;
                let u = this.source.indexOf(`
`, a);
                if (u === -1 && (u = this.source.length), n === e - 1) {
                  if (a + r > u) return u;
                  if (f.DEBUG) {
                    let i = this.hbsPosFor(a + r);
                  }
                  return a + r;
                } else {
                  if (u === -1) return 0;
                  n += 1, a = u + 1;
                }
              }
            }
          };
          t.Source = c;
        } }), we = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v1/legacy-interop.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.PathExpressionImplV1 = void 0;
          var f = h(ke());
          function h(c) {
            return c && c.__esModule ? c : { default: c };
          }
          var d = class {
            constructor(c, o, e, r) {
              this.original = c, this.loc = r, this.type = "PathExpression", this.this = false, this.data = false, this._head = void 0;
              let s = e.slice();
              o.type === "ThisHead" ? this.this = true : o.type === "AtHead" ? (this.data = true, s.unshift(o.name.slice(1))) : s.unshift(o.name), this.parts = s;
            }
            get head() {
              if (this._head) return this._head;
              let c;
              this.this ? c = "this" : this.data ? c = "@".concat(this.parts[0]) : c = this.parts[0];
              let o = this.loc.collapse("start").sliceStartChars({ chars: c.length }).loc;
              return this._head = f.default.head(c, o);
            }
            get tail() {
              return this.this ? this.parts : this.parts.slice(1);
            }
          };
          t.PathExpressionImplV1 = d;
        } }), ke = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v1/public-builders.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.default = void 0;
          var f = X(), h = ge(), d = De(), c = ue(), o = we(), e;
          function r() {
            return e || (e = new d.Source("", "(synthetic)")), e;
          }
          function s(T, N, k, B, O, q) {
            return typeof T == "string" && (T = m(T)), { type: "MustacheStatement", path: T, params: N || [], hash: k || S([]), escaped: !B, trusting: !!B, loc: U(O || null), strip: q || { open: false, close: false } };
          }
          function p(T, N, k, B, O, q, z2, A, Q) {
            let D, $;
            return B.type === "Template" ? D = (0, f.assign)({}, B, { type: "Block" }) : D = B, O != null && O.type === "Template" ? $ = (0, f.assign)({}, O, { type: "Block" }) : $ = O, { type: "BlockStatement", path: m(T), params: N || [], hash: k || S([]), program: D || null, inverse: $ || null, loc: U(q || null), openStrip: z2 || { open: false, close: false }, inverseStrip: A || { open: false, close: false }, closeStrip: Q || { open: false, close: false } };
          }
          function n(T, N, k, B) {
            return { type: "ElementModifierStatement", path: m(T), params: N || [], hash: k || S([]), loc: U(B || null) };
          }
          function a(T, N, k, B, O) {
            return { type: "PartialStatement", name: T, params: N || [], hash: k || S([]), indent: B || "", strip: { open: false, close: false }, loc: U(O || null) };
          }
          function u(T, N) {
            return { type: "CommentStatement", value: T, loc: U(N || null) };
          }
          function i(T, N) {
            return { type: "MustacheCommentStatement", value: T, loc: U(N || null) };
          }
          function l(T, N) {
            if (!(0, f.isPresent)(T)) throw new Error("b.concat requires at least one part");
            return { type: "ConcatStatement", parts: T || [], loc: U(N || null) };
          }
          function b(T) {
            let N = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, { attrs: k, blockParams: B, modifiers: O, comments: q, children: z2, loc: A } = N, Q, D = false;
            return typeof T == "object" ? (D = T.selfClosing, Q = T.name) : T.slice(-1) === "/" ? (Q = T.slice(0, -1), D = true) : Q = T, { type: "ElementNode", tag: Q, selfClosing: D, attributes: k || [], blockParams: B || [], modifiers: O || [], comments: q || [], children: z2 || [], loc: U(A || null) };
          }
          function P(T, N, k) {
            return { type: "AttrNode", name: T, value: N, loc: U(k || null) };
          }
          function E(T, N) {
            return { type: "TextNode", chars: T || "", loc: U(N || null) };
          }
          function v(T, N, k, B) {
            return { type: "SubExpression", path: m(T), params: N || [], hash: k || S([]), loc: U(B || null) };
          }
          function _(T) {
            switch (T.type) {
              case "AtHead":
                return { original: T.name, parts: [T.name] };
              case "ThisHead":
                return { original: "this", parts: [] };
              case "VarHead":
                return { original: T.name, parts: [T.name] };
            }
          }
          function y(T, N) {
            let [k, ...B] = T.split("."), O;
            return k === "this" ? O = { type: "ThisHead", loc: U(N || null) } : k[0] === "@" ? O = { type: "AtHead", name: k, loc: U(N || null) } : O = { type: "VarHead", name: k, loc: U(N || null) }, { head: O, tail: B };
          }
          function g(T) {
            return { type: "ThisHead", loc: U(T || null) };
          }
          function L(T, N) {
            return { type: "AtHead", name: T, loc: U(N || null) };
          }
          function j(T, N) {
            return { type: "VarHead", name: T, loc: U(N || null) };
          }
          function x(T, N) {
            return T[0] === "@" ? L(T, N) : T === "this" ? g(N) : j(T, N);
          }
          function w(T, N) {
            return { type: "NamedBlockName", name: T, loc: U(N || null) };
          }
          function H(T, N, k) {
            let { original: B, parts: O } = _(T), q = [...O, ...N], z2 = [...B, ...q].join(".");
            return new o.PathExpressionImplV1(z2, T, N, U(k || null));
          }
          function m(T, N) {
            if (typeof T != "string") {
              if ("type" in T) return T;
              {
                let { head: O, tail: q } = y(T.head, c.SourceSpan.broken()), { original: z2 } = _(O);
                return new o.PathExpressionImplV1([z2, ...q].join("."), O, q, U(N || null));
              }
            }
            let { head: k, tail: B } = y(T, c.SourceSpan.broken());
            return new o.PathExpressionImplV1(T, k, B, U(N || null));
          }
          function C(T, N, k) {
            return { type: T, value: N, original: N, loc: U(k || null) };
          }
          function S(T, N) {
            return { type: "Hash", pairs: T || [], loc: U(N || null) };
          }
          function R(T, N, k) {
            return { type: "HashPair", key: T, value: N, loc: U(k || null) };
          }
          function M(T, N, k) {
            return { type: "Template", body: T || [], blockParams: N || [], loc: U(k || null) };
          }
          function V(T, N) {
            let k = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, B = arguments.length > 3 ? arguments[3] : void 0;
            return { type: "Block", body: T || [], blockParams: N || [], chained: k, loc: U(B || null) };
          }
          function G(T, N, k) {
            return { type: "Template", body: T || [], blockParams: N || [], loc: U(k || null) };
          }
          function K(T, N) {
            return { line: T, column: N };
          }
          function U() {
            for (var T = arguments.length, N = new Array(T), k = 0; k < T; k++) N[k] = arguments[k];
            if (N.length === 1) {
              let B = N[0];
              return B && typeof B == "object" ? c.SourceSpan.forHbsLoc(r(), B) : c.SourceSpan.forHbsLoc(r(), h.SYNTHETIC_LOCATION);
            } else {
              let [B, O, q, z2, A] = N, Q = A ? new d.Source("", A) : r();
              return c.SourceSpan.forHbsLoc(Q, { start: { line: B, column: O }, end: { line: q, column: z2 } });
            }
          }
          var Z = { mustache: s, block: p, partial: a, comment: u, mustacheComment: i, element: b, elementModifier: n, attr: P, text: E, sexpr: v, concat: l, hash: S, pair: R, literal: C, program: M, blockItself: V, template: G, loc: U, pos: K, path: m, fullPath: H, head: x, at: L, var: j, this: g, blockName: w, string: W("StringLiteral"), boolean: W("BooleanLiteral"), number: W("NumberLiteral"), undefined() {
            return C("UndefinedLiteral", void 0);
          }, null() {
            return C("NullLiteral", null);
          } };
          t.default = Z;
          function W(T) {
            return function(N, k) {
              return C(T, N, k);
            };
          }
        } }), St = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v1/nodes-v1.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true });
        } }), Ct = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v1/api.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true });
          var f = St();
          Object.keys(f).forEach(function(h) {
            h === "default" || h === "__esModule" || Object.defineProperty(t, h, { enumerable: true, get: function() {
              return f[h];
            } });
          });
        } }), Pt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/resolution.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.loadResolution = o, t.ARGUMENT_RESOLUTION = t.LooseModeResolution = t.STRICT_RESOLUTION = t.StrictResolution = void 0;
          var f = class {
            constructor() {
              this.isAngleBracket = false;
            }
            resolution() {
              return 31;
            }
            serialize() {
              return "Strict";
            }
          };
          t.StrictResolution = f;
          var h = new f();
          t.STRICT_RESOLUTION = h;
          var d = class {
            constructor(e) {
              let r = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              this.ambiguity = e, this.isAngleBracket = r;
            }
            static namespaced(e) {
              let r = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              return new d({ namespaces: [e], fallback: false }, r);
            }
            static fallback() {
              return new d({ namespaces: [], fallback: true });
            }
            static append(e) {
              let { invoke: r } = e;
              return new d({ namespaces: ["Component", "Helper"], fallback: !r });
            }
            static trustingAppend(e) {
              let { invoke: r } = e;
              return new d({ namespaces: ["Helper"], fallback: !r });
            }
            static attr() {
              return new d({ namespaces: ["Helper"], fallback: true });
            }
            resolution() {
              if (this.ambiguity.namespaces.length === 0) return 31;
              if (this.ambiguity.namespaces.length === 1) {
                if (this.ambiguity.fallback) return 36;
                switch (this.ambiguity.namespaces[0]) {
                  case "Helper":
                    return 37;
                  case "Modifier":
                    return 38;
                  case "Component":
                    return 39;
                }
              } else return this.ambiguity.fallback ? 34 : 35;
            }
            serialize() {
              return this.ambiguity.namespaces.length === 0 ? "Loose" : this.ambiguity.namespaces.length === 1 ? this.ambiguity.fallback ? ["ambiguous", "Attr"] : ["ns", this.ambiguity.namespaces[0]] : this.ambiguity.fallback ? ["ambiguous", "Append"] : ["ambiguous", "Invoke"];
            }
          };
          t.LooseModeResolution = d;
          var c = d.fallback();
          t.ARGUMENT_RESOLUTION = c;
          function o(e) {
            if (typeof e == "string") switch (e) {
              case "Loose":
                return d.fallback();
              case "Strict":
                return h;
            }
            switch (e[0]) {
              case "ambiguous":
                switch (e[1]) {
                  case "Append":
                    return d.append({ invoke: false });
                  case "Attr":
                    return d.attr();
                  case "Invoke":
                    return d.append({ invoke: true });
                }
              case "ns":
                return d.namespaced(e[1]);
            }
          }
        } }), ne = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/node.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.node = h;
          var f = X();
          function h(d) {
            if (d !== void 0) {
              let c = d;
              return { fields() {
                return class {
                  constructor(o) {
                    this.type = c, (0, f.assign)(this, o);
                  }
                };
              } };
            } else return { fields() {
              return class {
                constructor(c) {
                  (0, f.assign)(this, c);
                }
              };
            } };
          }
        } }), be = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/args.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.NamedArgument = t.NamedArguments = t.PositionalArguments = t.Args = void 0;
          var f = ne(), h = class extends (0, f.node)().fields() {
            static empty(e) {
              return new h({ loc: e, positional: d.empty(e), named: c.empty(e) });
            }
            static named(e) {
              return new h({ loc: e.loc, positional: d.empty(e.loc.collapse("end")), named: e });
            }
            nth(e) {
              return this.positional.nth(e);
            }
            get(e) {
              return this.named.get(e);
            }
            isEmpty() {
              return this.positional.isEmpty() && this.named.isEmpty();
            }
          };
          t.Args = h;
          var d = class extends (0, f.node)().fields() {
            static empty(e) {
              return new d({ loc: e, exprs: [] });
            }
            get size() {
              return this.exprs.length;
            }
            nth(e) {
              return this.exprs[e] || null;
            }
            isEmpty() {
              return this.exprs.length === 0;
            }
          };
          t.PositionalArguments = d;
          var c = class extends (0, f.node)().fields() {
            static empty(e) {
              return new c({ loc: e, entries: [] });
            }
            get size() {
              return this.entries.length;
            }
            get(e) {
              let r = this.entries.filter((s) => s.name.chars === e)[0];
              return r ? r.value : null;
            }
            isEmpty() {
              return this.entries.length === 0;
            }
          };
          t.NamedArguments = c;
          var o = class {
            constructor(e) {
              this.loc = e.name.loc.extend(e.value.loc), this.name = e.name, this.value = e.value;
            }
          };
          t.NamedArgument = o;
        } }), Dt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/attr-block.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.ElementModifier = t.ComponentArg = t.SplatAttr = t.HtmlAttr = void 0;
          var f = be(), h = ne(), d = class extends (0, h.node)("HtmlAttr").fields() {
          };
          t.HtmlAttr = d;
          var c = class extends (0, h.node)("SplatAttr").fields() {
          };
          t.SplatAttr = c;
          var o = class extends (0, h.node)().fields() {
            toNamedArgument() {
              return new f.NamedArgument({ name: this.name, value: this.value });
            }
          };
          t.ComponentArg = o;
          var e = class extends (0, h.node)("ElementModifier").fields() {
          };
          t.ElementModifier = e;
        } }), wt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/base.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true });
        } }), ce = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/source/span-list.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.loc = d, t.hasSpan = c, t.maybeLoc = o, t.SpanList = void 0;
          var f = ue(), h = class {
            constructor() {
              let e = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : [];
              this._span = e;
            }
            static range(e) {
              let r = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : f.SourceSpan.NON_EXISTENT;
              return new h(e.map(d)).getRangeOffset(r);
            }
            add(e) {
              this._span.push(e);
            }
            getRangeOffset(e) {
              if (this._span.length === 0) return e;
              {
                let r = this._span[0], s = this._span[this._span.length - 1];
                return r.extend(s);
              }
            }
          };
          t.SpanList = h;
          function d(e) {
            if (Array.isArray(e)) {
              let r = e[0], s = e[e.length - 1];
              return d(r).extend(d(s));
            } else return e instanceof f.SourceSpan ? e : e.loc;
          }
          function c(e) {
            return !(Array.isArray(e) && e.length === 0);
          }
          function o(e, r) {
            return c(e) ? d(e) : r;
          }
        } }), kt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/content.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.SimpleElement = t.InvokeComponent = t.InvokeBlock = t.AppendContent = t.HtmlComment = t.HtmlText = t.GlimmerComment = void 0;
          var f = ce(), h = be(), d = ne(), c = class extends (0, d.node)("GlimmerComment").fields() {
          };
          t.GlimmerComment = c;
          var o = class extends (0, d.node)("HtmlText").fields() {
          };
          t.HtmlText = o;
          var e = class extends (0, d.node)("HtmlComment").fields() {
          };
          t.HtmlComment = e;
          var r = class extends (0, d.node)("AppendContent").fields() {
            get callee() {
              return this.value.type === "Call" ? this.value.callee : this.value;
            }
            get args() {
              return this.value.type === "Call" ? this.value.args : h.Args.empty(this.value.loc.collapse("end"));
            }
          };
          t.AppendContent = r;
          var s = class extends (0, d.node)("InvokeBlock").fields() {
          };
          t.InvokeBlock = s;
          var p = class extends (0, d.node)("InvokeComponent").fields() {
            get args() {
              let a = this.componentArgs.map((u) => u.toNamedArgument());
              return h.Args.named(new h.NamedArguments({ loc: f.SpanList.range(a, this.callee.loc.collapse("end")), entries: a }));
            }
          };
          t.InvokeComponent = p;
          var n = class extends (0, d.node)("SimpleElement").fields() {
            get args() {
              let a = this.componentArgs.map((u) => u.toNamedArgument());
              return h.Args.named(new h.NamedArguments({ loc: f.SpanList.range(a, this.tag.loc.collapse("end")), entries: a }));
            }
          };
          t.SimpleElement = n;
        } }), Tt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/expr.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.isLiteral = c, t.InterpolateExpression = t.DeprecatedCallExpression = t.CallExpression = t.PathExpression = t.LiteralExpression = void 0;
          var f = le(), h = ne(), d = class extends (0, h.node)("Literal").fields() {
            toSlice() {
              return new f.SourceSlice({ loc: this.loc, chars: this.value });
            }
          };
          t.LiteralExpression = d;
          function c(p, n) {
            return p.type === "Literal" ? n === void 0 ? true : n === "null" ? p.value === null : typeof p.value === n : false;
          }
          var o = class extends (0, h.node)("Path").fields() {
          };
          t.PathExpression = o;
          var e = class extends (0, h.node)("Call").fields() {
          };
          t.CallExpression = e;
          var r = class extends (0, h.node)("DeprecatedCall").fields() {
          };
          t.DeprecatedCallExpression = r;
          var s = class extends (0, h.node)("Interpolate").fields() {
          };
          t.InterpolateExpression = s;
        } }), Bt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/refs.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.FreeVarReference = t.LocalVarReference = t.ArgReference = t.ThisReference = void 0;
          var f = ne(), h = class extends (0, f.node)("This").fields() {
          };
          t.ThisReference = h;
          var d = class extends (0, f.node)("Arg").fields() {
          };
          t.ArgReference = d;
          var c = class extends (0, f.node)("Local").fields() {
          };
          t.LocalVarReference = c;
          var o = class extends (0, f.node)("Free").fields() {
          };
          t.FreeVarReference = o;
        } }), Ot = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/internal-node.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.NamedBlock = t.NamedBlocks = t.Block = t.Template = void 0;
          var f = ce(), h = be(), d = ne(), c = class extends (0, d.node)().fields() {
          };
          t.Template = c;
          var o = class extends (0, d.node)().fields() {
          };
          t.Block = o;
          var e = class extends (0, d.node)().fields() {
            get(s) {
              return this.blocks.filter((p) => p.name.chars === s)[0] || null;
            }
          };
          t.NamedBlocks = e;
          var r = class extends (0, d.node)().fields() {
            get args() {
              let s = this.componentArgs.map((p) => p.toNamedArgument());
              return h.Args.named(new h.NamedArguments({ loc: f.SpanList.range(s, this.name.loc.collapse("end")), entries: s }));
            }
          };
          t.NamedBlock = r;
        } }), ve = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/api.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true });
          var f = Pt();
          Object.keys(f).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t, n, { enumerable: true, get: function() {
              return f[n];
            } });
          });
          var h = ne();
          Object.keys(h).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t, n, { enumerable: true, get: function() {
              return h[n];
            } });
          });
          var d = be();
          Object.keys(d).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t, n, { enumerable: true, get: function() {
              return d[n];
            } });
          });
          var c = Dt();
          Object.keys(c).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t, n, { enumerable: true, get: function() {
              return c[n];
            } });
          });
          var o = wt();
          Object.keys(o).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t, n, { enumerable: true, get: function() {
              return o[n];
            } });
          });
          var e = kt();
          Object.keys(e).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t, n, { enumerable: true, get: function() {
              return e[n];
            } });
          });
          var r = Tt();
          Object.keys(r).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t, n, { enumerable: true, get: function() {
              return r[n];
            } });
          });
          var s = Bt();
          Object.keys(s).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t, n, { enumerable: true, get: function() {
              return s[n];
            } });
          });
          var p = Ot();
          Object.keys(p).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t, n, { enumerable: true, get: function() {
              return p[n];
            } });
          });
        } }), Ue = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/generation/util.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.escapeAttrValue = r, t.escapeText = s, t.sortByLoc = p;
          var f = /[\xA0"&]/, h = new RegExp(f.source, "g"), d = /[\xA0&<>]/, c = new RegExp(d.source, "g");
          function o(n) {
            switch (n.charCodeAt(0)) {
              case 160:
                return "&nbsp;";
              case 34:
                return "&quot;";
              case 38:
                return "&amp;";
              default:
                return n;
            }
          }
          function e(n) {
            switch (n.charCodeAt(0)) {
              case 160:
                return "&nbsp;";
              case 38:
                return "&amp;";
              case 60:
                return "&lt;";
              case 62:
                return "&gt;";
              default:
                return n;
            }
          }
          function r(n) {
            return f.test(n) ? n.replace(h, o) : n;
          }
          function s(n) {
            return d.test(n) ? n.replace(c, e) : n;
          }
          function p(n, a) {
            return n.loc.isInvisible || a.loc.isInvisible ? 0 : n.loc.startPosition.line < a.loc.startPosition.line || n.loc.startPosition.line === a.loc.startPosition.line && n.loc.startPosition.column < a.loc.startPosition.column ? -1 : n.loc.startPosition.line === a.loc.startPosition.line && n.loc.startPosition.column === a.loc.startPosition.column ? 0 : 1;
          }
        } }), Te = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/generation/printer.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.default = t.voidMap = void 0;
          var f = Ue(), h = /* @__PURE__ */ Object.create(null);
          t.voidMap = h;
          var d = "area base br col command embed hr img input keygen link meta param source track wbr";
          d.split(" ").forEach((e) => {
            h[e] = true;
          });
          var c = /\S/, o = class {
            constructor(e) {
              this.buffer = "", this.options = e;
            }
            handledByOverride(e) {
              let r = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              if (this.options.override !== void 0) {
                let s = this.options.override(e, this.options);
                if (typeof s == "string") return r && s !== "" && c.test(s[0]) && (s = " ".concat(s)), this.buffer += s, true;
              }
              return false;
            }
            Node(e) {
              switch (e.type) {
                case "MustacheStatement":
                case "BlockStatement":
                case "PartialStatement":
                case "MustacheCommentStatement":
                case "CommentStatement":
                case "TextNode":
                case "ElementNode":
                case "AttrNode":
                case "Block":
                case "Template":
                  return this.TopLevelStatement(e);
                case "StringLiteral":
                case "BooleanLiteral":
                case "NumberLiteral":
                case "UndefinedLiteral":
                case "NullLiteral":
                case "PathExpression":
                case "SubExpression":
                  return this.Expression(e);
                case "Program":
                  return this.Block(e);
                case "ConcatStatement":
                  return this.ConcatStatement(e);
                case "Hash":
                  return this.Hash(e);
                case "HashPair":
                  return this.HashPair(e);
                case "ElementModifierStatement":
                  return this.ElementModifierStatement(e);
              }
            }
            Expression(e) {
              switch (e.type) {
                case "StringLiteral":
                case "BooleanLiteral":
                case "NumberLiteral":
                case "UndefinedLiteral":
                case "NullLiteral":
                  return this.Literal(e);
                case "PathExpression":
                  return this.PathExpression(e);
                case "SubExpression":
                  return this.SubExpression(e);
              }
            }
            Literal(e) {
              switch (e.type) {
                case "StringLiteral":
                  return this.StringLiteral(e);
                case "BooleanLiteral":
                  return this.BooleanLiteral(e);
                case "NumberLiteral":
                  return this.NumberLiteral(e);
                case "UndefinedLiteral":
                  return this.UndefinedLiteral(e);
                case "NullLiteral":
                  return this.NullLiteral(e);
              }
            }
            TopLevelStatement(e) {
              switch (e.type) {
                case "MustacheStatement":
                  return this.MustacheStatement(e);
                case "BlockStatement":
                  return this.BlockStatement(e);
                case "PartialStatement":
                  return this.PartialStatement(e);
                case "MustacheCommentStatement":
                  return this.MustacheCommentStatement(e);
                case "CommentStatement":
                  return this.CommentStatement(e);
                case "TextNode":
                  return this.TextNode(e);
                case "ElementNode":
                  return this.ElementNode(e);
                case "Block":
                case "Template":
                  return this.Block(e);
                case "AttrNode":
                  return this.AttrNode(e);
              }
            }
            Block(e) {
              if (e.chained) {
                let r = e.body[0];
                r.chained = true;
              }
              this.handledByOverride(e) || this.TopLevelStatements(e.body);
            }
            TopLevelStatements(e) {
              e.forEach((r) => this.TopLevelStatement(r));
            }
            ElementNode(e) {
              this.handledByOverride(e) || (this.OpenElementNode(e), this.TopLevelStatements(e.children), this.CloseElementNode(e));
            }
            OpenElementNode(e) {
              this.buffer += "<".concat(e.tag);
              let r = [...e.attributes, ...e.modifiers, ...e.comments].sort(f.sortByLoc);
              for (let s of r) switch (this.buffer += " ", s.type) {
                case "AttrNode":
                  this.AttrNode(s);
                  break;
                case "ElementModifierStatement":
                  this.ElementModifierStatement(s);
                  break;
                case "MustacheCommentStatement":
                  this.MustacheCommentStatement(s);
                  break;
              }
              e.blockParams.length && this.BlockParams(e.blockParams), e.selfClosing && (this.buffer += " /"), this.buffer += ">";
            }
            CloseElementNode(e) {
              e.selfClosing || h[e.tag.toLowerCase()] || (this.buffer += "</".concat(e.tag, ">"));
            }
            AttrNode(e) {
              if (this.handledByOverride(e)) return;
              let { name: r, value: s } = e;
              this.buffer += r, (s.type !== "TextNode" || s.chars.length > 0) && (this.buffer += "=", this.AttrNodeValue(s));
            }
            AttrNodeValue(e) {
              e.type === "TextNode" ? (this.buffer += '"', this.TextNode(e, true), this.buffer += '"') : this.Node(e);
            }
            TextNode(e, r) {
              this.handledByOverride(e) || (this.options.entityEncoding === "raw" ? this.buffer += e.chars : r ? this.buffer += (0, f.escapeAttrValue)(e.chars) : this.buffer += (0, f.escapeText)(e.chars));
            }
            MustacheStatement(e) {
              this.handledByOverride(e) || (this.buffer += e.escaped ? "{{" : "{{{", e.strip.open && (this.buffer += "~"), this.Expression(e.path), this.Params(e.params), this.Hash(e.hash), e.strip.close && (this.buffer += "~"), this.buffer += e.escaped ? "}}" : "}}}");
            }
            BlockStatement(e) {
              this.handledByOverride(e) || (e.chained ? (this.buffer += e.inverseStrip.open ? "{{~" : "{{", this.buffer += "else ") : this.buffer += e.openStrip.open ? "{{~#" : "{{#", this.Expression(e.path), this.Params(e.params), this.Hash(e.hash), e.program.blockParams.length && this.BlockParams(e.program.blockParams), e.chained ? this.buffer += e.inverseStrip.close ? "~}}" : "}}" : this.buffer += e.openStrip.close ? "~}}" : "}}", this.Block(e.program), e.inverse && (e.inverse.chained || (this.buffer += e.inverseStrip.open ? "{{~" : "{{", this.buffer += "else", this.buffer += e.inverseStrip.close ? "~}}" : "}}"), this.Block(e.inverse)), e.chained || (this.buffer += e.closeStrip.open ? "{{~/" : "{{/", this.Expression(e.path), this.buffer += e.closeStrip.close ? "~}}" : "}}"));
            }
            BlockParams(e) {
              this.buffer += " as |".concat(e.join(" "), "|");
            }
            PartialStatement(e) {
              this.handledByOverride(e) || (this.buffer += "{{>", this.Expression(e.name), this.Params(e.params), this.Hash(e.hash), this.buffer += "}}");
            }
            ConcatStatement(e) {
              this.handledByOverride(e) || (this.buffer += '"', e.parts.forEach((r) => {
                r.type === "TextNode" ? this.TextNode(r, true) : this.Node(r);
              }), this.buffer += '"');
            }
            MustacheCommentStatement(e) {
              this.handledByOverride(e) || (this.buffer += "{{!--".concat(e.value, "--}}"));
            }
            ElementModifierStatement(e) {
              this.handledByOverride(e) || (this.buffer += "{{", this.Expression(e.path), this.Params(e.params), this.Hash(e.hash), this.buffer += "}}");
            }
            CommentStatement(e) {
              this.handledByOverride(e) || (this.buffer += "<!--".concat(e.value, "-->"));
            }
            PathExpression(e) {
              this.handledByOverride(e) || (this.buffer += e.original);
            }
            SubExpression(e) {
              this.handledByOverride(e) || (this.buffer += "(", this.Expression(e.path), this.Params(e.params), this.Hash(e.hash), this.buffer += ")");
            }
            Params(e) {
              e.length && e.forEach((r) => {
                this.buffer += " ", this.Expression(r);
              });
            }
            Hash(e) {
              this.handledByOverride(e, true) || e.pairs.forEach((r) => {
                this.buffer += " ", this.HashPair(r);
              });
            }
            HashPair(e) {
              this.handledByOverride(e) || (this.buffer += e.key, this.buffer += "=", this.Node(e.value));
            }
            StringLiteral(e) {
              this.handledByOverride(e) || (this.buffer += JSON.stringify(e.value));
            }
            BooleanLiteral(e) {
              this.handledByOverride(e) || (this.buffer += e.value);
            }
            NumberLiteral(e) {
              this.handledByOverride(e) || (this.buffer += e.value);
            }
            UndefinedLiteral(e) {
              this.handledByOverride(e) || (this.buffer += "undefined");
            }
            NullLiteral(e) {
              this.handledByOverride(e) || (this.buffer += "null");
            }
            print(e) {
              let { options: r } = this;
              if (r.override) {
                let s = r.override(e, r);
                if (s !== void 0) return s;
              }
              return this.buffer = "", this.Node(e), this.buffer;
            }
          };
          t.default = o;
        } }), Be = I({ "node_modules/@handlebars/parser/dist/cjs/exception.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true });
          var f = ["description", "fileName", "lineNumber", "endLineNumber", "message", "name", "number", "stack"];
          function h(d, c) {
            var o = c && c.loc, e, r, s, p;
            o && (e = o.start.line, r = o.end.line, s = o.start.column, p = o.end.column, d += " - " + e + ":" + s);
            for (var n = Error.prototype.constructor.call(this, d), a = 0; a < f.length; a++) this[f[a]] = n[f[a]];
            Error.captureStackTrace && Error.captureStackTrace(this, h);
            try {
              o && (this.lineNumber = e, this.endLineNumber = r, Object.defineProperty ? (Object.defineProperty(this, "column", { value: s, enumerable: true }), Object.defineProperty(this, "endColumn", { value: p, enumerable: true })) : (this.column = s, this.endColumn = p));
            } catch {
            }
          }
          h.prototype = new Error(), t.default = h;
        } }), Oe = I({ "node_modules/@handlebars/parser/dist/cjs/visitor.js"(t) {
          "use strict";
          F();
          var f = t && t.__importDefault || function(r) {
            return r && r.__esModule ? r : { default: r };
          };
          Object.defineProperty(t, "__esModule", { value: true });
          var h = f(Be());
          function d() {
            this.parents = [];
          }
          d.prototype = { constructor: d, mutating: false, acceptKey: function(r, s) {
            var p = this.accept(r[s]);
            if (this.mutating) {
              if (p && !d.prototype[p.type]) throw new h.default('Unexpected node type "' + p.type + '" found when accepting ' + s + " on " + r.type);
              r[s] = p;
            }
          }, acceptRequired: function(r, s) {
            if (this.acceptKey(r, s), !r[s]) throw new h.default(r.type + " requires " + s);
          }, acceptArray: function(r) {
            for (var s = 0, p = r.length; s < p; s++) this.acceptKey(r, s), r[s] || (r.splice(s, 1), s--, p--);
          }, accept: function(r) {
            if (!!r) {
              if (!this[r.type]) throw new h.default("Unknown type: " + r.type, r);
              this.current && this.parents.unshift(this.current), this.current = r;
              var s = this[r.type](r);
              if (this.current = this.parents.shift(), !this.mutating || s) return s;
              if (s !== false) return r;
            }
          }, Program: function(r) {
            this.acceptArray(r.body);
          }, MustacheStatement: c, Decorator: c, BlockStatement: o, DecoratorBlock: o, PartialStatement: e, PartialBlockStatement: function(r) {
            e.call(this, r), this.acceptKey(r, "program");
          }, ContentStatement: function() {
          }, CommentStatement: function() {
          }, SubExpression: c, PathExpression: function() {
          }, StringLiteral: function() {
          }, NumberLiteral: function() {
          }, BooleanLiteral: function() {
          }, UndefinedLiteral: function() {
          }, NullLiteral: function() {
          }, Hash: function(r) {
            this.acceptArray(r.pairs);
          }, HashPair: function(r) {
            this.acceptRequired(r, "value");
          } };
          function c(r) {
            this.acceptRequired(r, "path"), this.acceptArray(r.params), this.acceptKey(r, "hash");
          }
          function o(r) {
            c.call(this, r), this.acceptKey(r, "program"), this.acceptKey(r, "inverse");
          }
          function e(r) {
            this.acceptRequired(r, "name"), this.acceptArray(r.params), this.acceptKey(r, "hash");
          }
          t.default = d;
        } }), ze = I({ "node_modules/@handlebars/parser/dist/cjs/whitespace-control.js"(t) {
          "use strict";
          F();
          var f = t && t.__importDefault || function(s) {
            return s && s.__esModule ? s : { default: s };
          };
          Object.defineProperty(t, "__esModule", { value: true });
          var h = f(Oe());
          function d(s) {
            s === void 0 && (s = {}), this.options = s;
          }
          d.prototype = new h.default(), d.prototype.Program = function(s) {
            var p = !this.options.ignoreStandalone, n = !this.isRootSeen;
            this.isRootSeen = true;
            for (var a = s.body, u = 0, i = a.length; u < i; u++) {
              var l = a[u], b = this.accept(l);
              if (!!b) {
                var P = c(a, u, n), E = o(a, u, n), v = b.openStandalone && P, _ = b.closeStandalone && E, y = b.inlineStandalone && P && E;
                b.close && e(a, u, true), b.open && r(a, u, true), p && y && (e(a, u), r(a, u) && l.type === "PartialStatement" && (l.indent = /([ \t]+$)/.exec(a[u - 1].original)[1])), p && v && (e((l.program || l.inverse).body), r(a, u)), p && _ && (e(a, u), r((l.inverse || l.program).body));
              }
            }
            return s;
          }, d.prototype.BlockStatement = d.prototype.DecoratorBlock = d.prototype.PartialBlockStatement = function(s) {
            this.accept(s.program), this.accept(s.inverse);
            var p = s.program || s.inverse, n = s.program && s.inverse, a = n, u = n;
            if (n && n.chained) for (a = n.body[0].program; u.chained; ) u = u.body[u.body.length - 1].program;
            var i = { open: s.openStrip.open, close: s.closeStrip.close, openStandalone: o(p.body), closeStandalone: c((a || p).body) };
            if (s.openStrip.close && e(p.body, null, true), n) {
              var l = s.inverseStrip;
              l.open && r(p.body, null, true), l.close && e(a.body, null, true), s.closeStrip.open && r(u.body, null, true), !this.options.ignoreStandalone && c(p.body) && o(a.body) && (r(p.body), e(a.body));
            } else s.closeStrip.open && r(p.body, null, true);
            return i;
          }, d.prototype.Decorator = d.prototype.MustacheStatement = function(s) {
            return s.strip;
          }, d.prototype.PartialStatement = d.prototype.CommentStatement = function(s) {
            var p = s.strip || {};
            return { inlineStandalone: true, open: p.open, close: p.close };
          };
          function c(s, p, n) {
            p === void 0 && (p = s.length);
            var a = s[p - 1], u = s[p - 2];
            if (!a) return n;
            if (a.type === "ContentStatement") return (u || !n ? /\r?\n\s*?$/ : /(^|\r?\n)\s*?$/).test(a.original);
          }
          function o(s, p, n) {
            p === void 0 && (p = -1);
            var a = s[p + 1], u = s[p + 2];
            if (!a) return n;
            if (a.type === "ContentStatement") return (u || !n ? /^\s*?\r?\n/ : /^\s*?(\r?\n|$)/).test(a.original);
          }
          function e(s, p, n) {
            var a = s[p == null ? 0 : p + 1];
            if (!(!a || a.type !== "ContentStatement" || !n && a.rightStripped)) {
              var u = a.value;
              a.value = a.value.replace(n ? /^\s+/ : /^[ \t]*\r?\n?/, ""), a.rightStripped = a.value !== u;
            }
          }
          function r(s, p, n) {
            var a = s[p == null ? s.length - 1 : p - 1];
            if (!(!a || a.type !== "ContentStatement" || !n && a.leftStripped)) {
              var u = a.value;
              return a.value = a.value.replace(n ? /\s+$/ : /[ \t]+$/, ""), a.leftStripped = a.value !== u, a.leftStripped;
            }
          }
          t.default = d;
        } }), Ge = I({ "node_modules/@handlebars/parser/dist/cjs/parser.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true });
          var f = function() {
            var h = function(N, k, B, O) {
              for (B = B || {}, O = N.length; O--; B[N[O]] = k) ;
              return B;
            }, d = [2, 44], c = [1, 20], o = [5, 14, 15, 19, 29, 34, 39, 44, 47, 48, 52, 56, 60], e = [1, 35], r = [1, 38], s = [1, 30], p = [1, 31], n = [1, 32], a = [1, 33], u = [1, 34], i = [1, 37], l = [14, 15, 19, 29, 34, 39, 44, 47, 48, 52, 56, 60], b = [14, 15, 19, 29, 34, 44, 47, 48, 52, 56, 60], P = [15, 18], E = [14, 15, 19, 29, 34, 47, 48, 52, 56, 60], v = [33, 64, 71, 79, 80, 81, 82, 83, 84], _ = [23, 33, 55, 64, 67, 71, 74, 79, 80, 81, 82, 83, 84], y = [1, 51], g = [23, 33, 55, 64, 67, 71, 74, 79, 80, 81, 82, 83, 84, 86], L = [2, 43], j = [55, 64, 71, 79, 80, 81, 82, 83, 84], x = [1, 58], w = [1, 59], H = [1, 66], m = [33, 64, 71, 74, 79, 80, 81, 82, 83, 84], C = [23, 64, 71, 79, 80, 81, 82, 83, 84], S = [1, 76], R = [64, 67, 71, 79, 80, 81, 82, 83, 84], M = [33, 74], V = [23, 33, 55, 67, 71, 74], G = [1, 106], K = [1, 118], U = [71, 76], Z = { trace: function() {
            }, yy: {}, symbols_: { error: 2, root: 3, program: 4, EOF: 5, program_repetition0: 6, statement: 7, mustache: 8, block: 9, rawBlock: 10, partial: 11, partialBlock: 12, content: 13, COMMENT: 14, CONTENT: 15, openRawBlock: 16, rawBlock_repetition0: 17, END_RAW_BLOCK: 18, OPEN_RAW_BLOCK: 19, helperName: 20, openRawBlock_repetition0: 21, openRawBlock_option0: 22, CLOSE_RAW_BLOCK: 23, openBlock: 24, block_option0: 25, closeBlock: 26, openInverse: 27, block_option1: 28, OPEN_BLOCK: 29, openBlock_repetition0: 30, openBlock_option0: 31, openBlock_option1: 32, CLOSE: 33, OPEN_INVERSE: 34, openInverse_repetition0: 35, openInverse_option0: 36, openInverse_option1: 37, openInverseChain: 38, OPEN_INVERSE_CHAIN: 39, openInverseChain_repetition0: 40, openInverseChain_option0: 41, openInverseChain_option1: 42, inverseAndProgram: 43, INVERSE: 44, inverseChain: 45, inverseChain_option0: 46, OPEN_ENDBLOCK: 47, OPEN: 48, expr: 49, mustache_repetition0: 50, mustache_option0: 51, OPEN_UNESCAPED: 52, mustache_repetition1: 53, mustache_option1: 54, CLOSE_UNESCAPED: 55, OPEN_PARTIAL: 56, partial_repetition0: 57, partial_option0: 58, openPartialBlock: 59, OPEN_PARTIAL_BLOCK: 60, openPartialBlock_repetition0: 61, openPartialBlock_option0: 62, sexpr: 63, OPEN_SEXPR: 64, sexpr_repetition0: 65, sexpr_option0: 66, CLOSE_SEXPR: 67, hash: 68, hash_repetition_plus0: 69, hashSegment: 70, ID: 71, EQUALS: 72, blockParams: 73, OPEN_BLOCK_PARAMS: 74, blockParams_repetition_plus0: 75, CLOSE_BLOCK_PARAMS: 76, path: 77, dataName: 78, STRING: 79, NUMBER: 80, BOOLEAN: 81, UNDEFINED: 82, NULL: 83, DATA: 84, pathSegments: 85, SEP: 86, $accept: 0, $end: 1 }, terminals_: { 2: "error", 5: "EOF", 14: "COMMENT", 15: "CONTENT", 18: "END_RAW_BLOCK", 19: "OPEN_RAW_BLOCK", 23: "CLOSE_RAW_BLOCK", 29: "OPEN_BLOCK", 33: "CLOSE", 34: "OPEN_INVERSE", 39: "OPEN_INVERSE_CHAIN", 44: "INVERSE", 47: "OPEN_ENDBLOCK", 48: "OPEN", 52: "OPEN_UNESCAPED", 55: "CLOSE_UNESCAPED", 56: "OPEN_PARTIAL", 60: "OPEN_PARTIAL_BLOCK", 64: "OPEN_SEXPR", 67: "CLOSE_SEXPR", 71: "ID", 72: "EQUALS", 74: "OPEN_BLOCK_PARAMS", 76: "CLOSE_BLOCK_PARAMS", 79: "STRING", 80: "NUMBER", 81: "BOOLEAN", 82: "UNDEFINED", 83: "NULL", 84: "DATA", 86: "SEP" }, productions_: [0, [3, 2], [4, 1], [7, 1], [7, 1], [7, 1], [7, 1], [7, 1], [7, 1], [7, 1], [13, 1], [10, 3], [16, 5], [9, 4], [9, 4], [24, 6], [27, 6], [38, 6], [43, 2], [45, 3], [45, 1], [26, 3], [8, 5], [8, 5], [11, 5], [12, 3], [59, 5], [49, 1], [49, 1], [63, 5], [68, 1], [70, 3], [73, 3], [20, 1], [20, 1], [20, 1], [20, 1], [20, 1], [20, 1], [20, 1], [78, 2], [77, 1], [85, 3], [85, 1], [6, 0], [6, 2], [17, 0], [17, 2], [21, 0], [21, 2], [22, 0], [22, 1], [25, 0], [25, 1], [28, 0], [28, 1], [30, 0], [30, 2], [31, 0], [31, 1], [32, 0], [32, 1], [35, 0], [35, 2], [36, 0], [36, 1], [37, 0], [37, 1], [40, 0], [40, 2], [41, 0], [41, 1], [42, 0], [42, 1], [46, 0], [46, 1], [50, 0], [50, 2], [51, 0], [51, 1], [53, 0], [53, 2], [54, 0], [54, 1], [57, 0], [57, 2], [58, 0], [58, 1], [61, 0], [61, 2], [62, 0], [62, 1], [65, 0], [65, 2], [66, 0], [66, 1], [69, 1], [69, 2], [75, 1], [75, 2]], performAction: function(k, B, O, q, z2, A, Q) {
              var D = A.length - 1;
              switch (z2) {
                case 1:
                  return A[D - 1];
                case 2:
                  this.$ = q.prepareProgram(A[D]);
                  break;
                case 3:
                case 4:
                case 5:
                case 6:
                case 7:
                case 8:
                case 20:
                case 27:
                case 28:
                case 33:
                case 34:
                  this.$ = A[D];
                  break;
                case 9:
                  this.$ = { type: "CommentStatement", value: q.stripComment(A[D]), strip: q.stripFlags(A[D], A[D]), loc: q.locInfo(this._$) };
                  break;
                case 10:
                  this.$ = { type: "ContentStatement", original: A[D], value: A[D], loc: q.locInfo(this._$) };
                  break;
                case 11:
                  this.$ = q.prepareRawBlock(A[D - 2], A[D - 1], A[D], this._$);
                  break;
                case 12:
                  this.$ = { path: A[D - 3], params: A[D - 2], hash: A[D - 1] };
                  break;
                case 13:
                  this.$ = q.prepareBlock(A[D - 3], A[D - 2], A[D - 1], A[D], false, this._$);
                  break;
                case 14:
                  this.$ = q.prepareBlock(A[D - 3], A[D - 2], A[D - 1], A[D], true, this._$);
                  break;
                case 15:
                  this.$ = { open: A[D - 5], path: A[D - 4], params: A[D - 3], hash: A[D - 2], blockParams: A[D - 1], strip: q.stripFlags(A[D - 5], A[D]) };
                  break;
                case 16:
                case 17:
                  this.$ = { path: A[D - 4], params: A[D - 3], hash: A[D - 2], blockParams: A[D - 1], strip: q.stripFlags(A[D - 5], A[D]) };
                  break;
                case 18:
                  this.$ = { strip: q.stripFlags(A[D - 1], A[D - 1]), program: A[D] };
                  break;
                case 19:
                  var $ = q.prepareBlock(A[D - 2], A[D - 1], A[D], A[D], false, this._$), oe = q.prepareProgram([$], A[D - 1].loc);
                  oe.chained = true, this.$ = { strip: A[D - 2].strip, program: oe, chain: true };
                  break;
                case 21:
                  this.$ = { path: A[D - 1], strip: q.stripFlags(A[D - 2], A[D]) };
                  break;
                case 22:
                case 23:
                  this.$ = q.prepareMustache(A[D - 3], A[D - 2], A[D - 1], A[D - 4], q.stripFlags(A[D - 4], A[D]), this._$);
                  break;
                case 24:
                  this.$ = { type: "PartialStatement", name: A[D - 3], params: A[D - 2], hash: A[D - 1], indent: "", strip: q.stripFlags(A[D - 4], A[D]), loc: q.locInfo(this._$) };
                  break;
                case 25:
                  this.$ = q.preparePartialBlock(A[D - 2], A[D - 1], A[D], this._$);
                  break;
                case 26:
                  this.$ = { path: A[D - 3], params: A[D - 2], hash: A[D - 1], strip: q.stripFlags(A[D - 4], A[D]) };
                  break;
                case 29:
                  this.$ = { type: "SubExpression", path: A[D - 3], params: A[D - 2], hash: A[D - 1], loc: q.locInfo(this._$) };
                  break;
                case 30:
                  this.$ = { type: "Hash", pairs: A[D], loc: q.locInfo(this._$) };
                  break;
                case 31:
                  this.$ = { type: "HashPair", key: q.id(A[D - 2]), value: A[D], loc: q.locInfo(this._$) };
                  break;
                case 32:
                  this.$ = q.id(A[D - 1]);
                  break;
                case 35:
                  this.$ = { type: "StringLiteral", value: A[D], original: A[D], loc: q.locInfo(this._$) };
                  break;
                case 36:
                  this.$ = { type: "NumberLiteral", value: Number(A[D]), original: Number(A[D]), loc: q.locInfo(this._$) };
                  break;
                case 37:
                  this.$ = { type: "BooleanLiteral", value: A[D] === "true", original: A[D] === "true", loc: q.locInfo(this._$) };
                  break;
                case 38:
                  this.$ = { type: "UndefinedLiteral", original: void 0, value: void 0, loc: q.locInfo(this._$) };
                  break;
                case 39:
                  this.$ = { type: "NullLiteral", original: null, value: null, loc: q.locInfo(this._$) };
                  break;
                case 40:
                  this.$ = q.preparePath(true, A[D], this._$);
                  break;
                case 41:
                  this.$ = q.preparePath(false, A[D], this._$);
                  break;
                case 42:
                  A[D - 2].push({ part: q.id(A[D]), original: A[D], separator: A[D - 1] }), this.$ = A[D - 2];
                  break;
                case 43:
                  this.$ = [{ part: q.id(A[D]), original: A[D] }];
                  break;
                case 44:
                case 46:
                case 48:
                case 56:
                case 62:
                case 68:
                case 76:
                case 80:
                case 84:
                case 88:
                case 92:
                  this.$ = [];
                  break;
                case 45:
                case 47:
                case 49:
                case 57:
                case 63:
                case 69:
                case 77:
                case 81:
                case 85:
                case 89:
                case 93:
                case 97:
                case 99:
                  A[D - 1].push(A[D]);
                  break;
                case 96:
                case 98:
                  this.$ = [A[D]];
                  break;
              }
            }, table: [h([5, 14, 15, 19, 29, 34, 48, 52, 56, 60], d, { 3: 1, 4: 2, 6: 3 }), { 1: [3] }, { 5: [1, 4] }, h([5, 39, 44, 47], [2, 2], { 7: 5, 8: 6, 9: 7, 10: 8, 11: 9, 12: 10, 13: 11, 24: 15, 27: 16, 16: 17, 59: 19, 14: [1, 12], 15: c, 19: [1, 23], 29: [1, 21], 34: [1, 22], 48: [1, 13], 52: [1, 14], 56: [1, 18], 60: [1, 24] }), { 1: [2, 1] }, h(o, [2, 45]), h(o, [2, 3]), h(o, [2, 4]), h(o, [2, 5]), h(o, [2, 6]), h(o, [2, 7]), h(o, [2, 8]), h(o, [2, 9]), { 20: 26, 49: 25, 63: 27, 64: e, 71: r, 77: 28, 78: 29, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i, 85: 36 }, { 20: 26, 49: 39, 63: 27, 64: e, 71: r, 77: 28, 78: 29, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i, 85: 36 }, h(l, d, { 6: 3, 4: 40 }), h(b, d, { 6: 3, 4: 41 }), h(P, [2, 46], { 17: 42 }), { 20: 26, 49: 43, 63: 27, 64: e, 71: r, 77: 28, 78: 29, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i, 85: 36 }, h(E, d, { 6: 3, 4: 44 }), h([5, 14, 15, 18, 19, 29, 34, 39, 44, 47, 48, 52, 56, 60], [2, 10]), { 20: 45, 71: r, 77: 28, 78: 29, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i, 85: 36 }, { 20: 46, 71: r, 77: 28, 78: 29, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i, 85: 36 }, { 20: 47, 71: r, 77: 28, 78: 29, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i, 85: 36 }, { 20: 26, 49: 48, 63: 27, 64: e, 71: r, 77: 28, 78: 29, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i, 85: 36 }, h(v, [2, 76], { 50: 49 }), h(_, [2, 27]), h(_, [2, 28]), h(_, [2, 33]), h(_, [2, 34]), h(_, [2, 35]), h(_, [2, 36]), h(_, [2, 37]), h(_, [2, 38]), h(_, [2, 39]), { 20: 26, 49: 50, 63: 27, 64: e, 71: r, 77: 28, 78: 29, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i, 85: 36 }, h(_, [2, 41], { 86: y }), { 71: r, 85: 52 }, h(g, L), h(j, [2, 80], { 53: 53 }), { 25: 54, 38: 56, 39: x, 43: 57, 44: w, 45: 55, 47: [2, 52] }, { 28: 60, 43: 61, 44: w, 47: [2, 54] }, { 13: 63, 15: c, 18: [1, 62] }, h(v, [2, 84], { 57: 64 }), { 26: 65, 47: H }, h(m, [2, 56], { 30: 67 }), h(m, [2, 62], { 35: 68 }), h(C, [2, 48], { 21: 69 }), h(v, [2, 88], { 61: 70 }), { 20: 26, 33: [2, 78], 49: 72, 51: 71, 63: 27, 64: e, 68: 73, 69: 74, 70: 75, 71: S, 77: 28, 78: 29, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i, 85: 36 }, h(R, [2, 92], { 65: 77 }), { 71: [1, 78] }, h(_, [2, 40], { 86: y }), { 20: 26, 49: 80, 54: 79, 55: [2, 82], 63: 27, 64: e, 68: 81, 69: 74, 70: 75, 71: S, 77: 28, 78: 29, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i, 85: 36 }, { 26: 82, 47: H }, { 47: [2, 53] }, h(l, d, { 6: 3, 4: 83 }), { 47: [2, 20] }, { 20: 84, 71: r, 77: 28, 78: 29, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i, 85: 36 }, h(E, d, { 6: 3, 4: 85 }), { 26: 86, 47: H }, { 47: [2, 55] }, h(o, [2, 11]), h(P, [2, 47]), { 20: 26, 33: [2, 86], 49: 88, 58: 87, 63: 27, 64: e, 68: 89, 69: 74, 70: 75, 71: S, 77: 28, 78: 29, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i, 85: 36 }, h(o, [2, 25]), { 20: 90, 71: r, 77: 28, 78: 29, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i, 85: 36 }, h(M, [2, 58], { 20: 26, 63: 27, 77: 28, 78: 29, 85: 36, 69: 74, 70: 75, 31: 91, 49: 92, 68: 93, 64: e, 71: S, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i }), h(M, [2, 64], { 20: 26, 63: 27, 77: 28, 78: 29, 85: 36, 69: 74, 70: 75, 36: 94, 49: 95, 68: 96, 64: e, 71: S, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i }), { 20: 26, 22: 97, 23: [2, 50], 49: 98, 63: 27, 64: e, 68: 99, 69: 74, 70: 75, 71: S, 77: 28, 78: 29, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i, 85: 36 }, { 20: 26, 33: [2, 90], 49: 101, 62: 100, 63: 27, 64: e, 68: 102, 69: 74, 70: 75, 71: S, 77: 28, 78: 29, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i, 85: 36 }, { 33: [1, 103] }, h(v, [2, 77]), { 33: [2, 79] }, h([23, 33, 55, 67, 74], [2, 30], { 70: 104, 71: [1, 105] }), h(V, [2, 96]), h(g, L, { 72: G }), { 20: 26, 49: 108, 63: 27, 64: e, 66: 107, 67: [2, 94], 68: 109, 69: 74, 70: 75, 71: S, 77: 28, 78: 29, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i, 85: 36 }, h(g, [2, 42]), { 55: [1, 110] }, h(j, [2, 81]), { 55: [2, 83] }, h(o, [2, 13]), { 38: 56, 39: x, 43: 57, 44: w, 45: 112, 46: 111, 47: [2, 74] }, h(m, [2, 68], { 40: 113 }), { 47: [2, 18] }, h(o, [2, 14]), { 33: [1, 114] }, h(v, [2, 85]), { 33: [2, 87] }, { 33: [1, 115] }, { 32: 116, 33: [2, 60], 73: 117, 74: K }, h(m, [2, 57]), h(M, [2, 59]), { 33: [2, 66], 37: 119, 73: 120, 74: K }, h(m, [2, 63]), h(M, [2, 65]), { 23: [1, 121] }, h(C, [2, 49]), { 23: [2, 51] }, { 33: [1, 122] }, h(v, [2, 89]), { 33: [2, 91] }, h(o, [2, 22]), h(V, [2, 97]), { 72: G }, { 20: 26, 49: 123, 63: 27, 64: e, 71: r, 77: 28, 78: 29, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i, 85: 36 }, { 67: [1, 124] }, h(R, [2, 93]), { 67: [2, 95] }, h(o, [2, 23]), { 47: [2, 19] }, { 47: [2, 75] }, h(M, [2, 70], { 20: 26, 63: 27, 77: 28, 78: 29, 85: 36, 69: 74, 70: 75, 41: 125, 49: 126, 68: 127, 64: e, 71: S, 79: s, 80: p, 81: n, 82: a, 83: u, 84: i }), h(o, [2, 24]), h(o, [2, 21]), { 33: [1, 128] }, { 33: [2, 61] }, { 71: [1, 130], 75: 129 }, { 33: [1, 131] }, { 33: [2, 67] }, h(P, [2, 12]), h(E, [2, 26]), h(V, [2, 31]), h(_, [2, 29]), { 33: [2, 72], 42: 132, 73: 133, 74: K }, h(m, [2, 69]), h(M, [2, 71]), h(l, [2, 15]), { 71: [1, 135], 76: [1, 134] }, h(U, [2, 98]), h(b, [2, 16]), { 33: [1, 136] }, { 33: [2, 73] }, { 33: [2, 32] }, h(U, [2, 99]), h(l, [2, 17])], defaultActions: { 4: [2, 1], 55: [2, 53], 57: [2, 20], 61: [2, 55], 73: [2, 79], 81: [2, 83], 85: [2, 18], 89: [2, 87], 99: [2, 51], 102: [2, 91], 109: [2, 95], 111: [2, 19], 112: [2, 75], 117: [2, 61], 120: [2, 67], 133: [2, 73], 134: [2, 32] }, parseError: function(k, B) {
              if (B.recoverable) this.trace(k);
              else {
                var O = new Error(k);
                throw O.hash = B, O;
              }
            }, parse: function(k) {
              var B = this, O = [0], q = [], z2 = [null], A = [], Q = this.table, D = "", $ = 0, oe = 0, Ie = 0, et = 2, Re = 1, tt = A.slice.call(arguments, 1), Y = Object.create(this.lexer), ie = { yy: {} };
              for (var Ae in this.yy) Object.prototype.hasOwnProperty.call(this.yy, Ae) && (ie.yy[Ae] = this.yy[Ae]);
              Y.setInput(k, ie.yy), ie.yy.lexer = Y, ie.yy.parser = this, typeof Y.yylloc > "u" && (Y.yylloc = {});
              var Ee = Y.yylloc;
              A.push(Ee);
              var rt = Y.options && Y.options.ranges;
              typeof ie.yy.parseError == "function" ? this.parseError = ie.yy.parseError : this.parseError = Object.getPrototypeOf(this).parseError;
              function $t(te) {
                O.length = O.length - 2 * te, z2.length = z2.length - te, A.length = A.length - te;
              }
              e: var nt = function() {
                var te;
                return te = Y.lex() || Re, typeof te != "number" && (te = B.symbols_[te] || te), te;
              };
              for (var J, _e, ae, ee, er, Se, se = {}, de, re, qe, pe; ; ) {
                if (ae = O[O.length - 1], this.defaultActions[ae] ? ee = this.defaultActions[ae] : ((J === null || typeof J > "u") && (J = nt()), ee = Q[ae] && Q[ae][J]), typeof ee > "u" || !ee.length || !ee[0]) {
                  var Ce = "";
                  pe = [];
                  for (de in Q[ae]) this.terminals_[de] && de > et && pe.push("'" + this.terminals_[de] + "'");
                  Y.showPosition ? Ce = "Parse error on line " + ($ + 1) + `:
` + Y.showPosition() + `
Expecting ` + pe.join(", ") + ", got '" + (this.terminals_[J] || J) + "'" : Ce = "Parse error on line " + ($ + 1) + ": Unexpected " + (J == Re ? "end of input" : "'" + (this.terminals_[J] || J) + "'"), this.parseError(Ce, { text: Y.match, token: this.terminals_[J] || J, line: Y.yylineno, loc: Ee, expected: pe });
                }
                if (ee[0] instanceof Array && ee.length > 1) throw new Error("Parse Error: multiple actions possible at state: " + ae + ", token: " + J);
                switch (ee[0]) {
                  case 1:
                    O.push(J), z2.push(Y.yytext), A.push(Y.yylloc), O.push(ee[1]), J = null, _e ? (J = _e, _e = null) : (oe = Y.yyleng, D = Y.yytext, $ = Y.yylineno, Ee = Y.yylloc, Ie > 0 && Ie--);
                    break;
                  case 2:
                    if (re = this.productions_[ee[1]][1], se.$ = z2[z2.length - re], se._$ = { first_line: A[A.length - (re || 1)].first_line, last_line: A[A.length - 1].last_line, first_column: A[A.length - (re || 1)].first_column, last_column: A[A.length - 1].last_column }, rt && (se._$.range = [A[A.length - (re || 1)].range[0], A[A.length - 1].range[1]]), Se = this.performAction.apply(se, [D, oe, $, ie.yy, ee[1], z2, A].concat(tt)), typeof Se < "u") return Se;
                    re && (O = O.slice(0, -1 * re * 2), z2 = z2.slice(0, -1 * re), A = A.slice(0, -1 * re)), O.push(this.productions_[ee[1]][0]), z2.push(se.$), A.push(se._$), qe = Q[O[O.length - 2]][O[O.length - 1]], O.push(qe);
                    break;
                  case 3:
                    return true;
                }
              }
              return true;
            } }, W = /* @__PURE__ */ function() {
              var N = { EOF: 1, parseError: function(B, O) {
                if (this.yy.parser) this.yy.parser.parseError(B, O);
                else throw new Error(B);
              }, setInput: function(k, B) {
                return this.yy = B || this.yy || {}, this._input = k, this._more = this._backtrack = this.done = false, this.yylineno = this.yyleng = 0, this.yytext = this.matched = this.match = "", this.conditionStack = ["INITIAL"], this.yylloc = { first_line: 1, first_column: 0, last_line: 1, last_column: 0 }, this.options.ranges && (this.yylloc.range = [0, 0]), this.offset = 0, this;
              }, input: function() {
                var k = this._input[0];
                this.yytext += k, this.yyleng++, this.offset++, this.match += k, this.matched += k;
                var B = k.match(/(?:\r\n?|\n).*/g);
                return B ? (this.yylineno++, this.yylloc.last_line++) : this.yylloc.last_column++, this.options.ranges && this.yylloc.range[1]++, this._input = this._input.slice(1), k;
              }, unput: function(k) {
                var B = k.length, O = k.split(/(?:\r\n?|\n)/g);
                this._input = k + this._input, this.yytext = this.yytext.substr(0, this.yytext.length - B), this.offset -= B;
                var q = this.match.split(/(?:\r\n?|\n)/g);
                this.match = this.match.substr(0, this.match.length - 1), this.matched = this.matched.substr(0, this.matched.length - 1), O.length - 1 && (this.yylineno -= O.length - 1);
                var z2 = this.yylloc.range;
                return this.yylloc = { first_line: this.yylloc.first_line, last_line: this.yylineno + 1, first_column: this.yylloc.first_column, last_column: O ? (O.length === q.length ? this.yylloc.first_column : 0) + q[q.length - O.length].length - O[0].length : this.yylloc.first_column - B }, this.options.ranges && (this.yylloc.range = [z2[0], z2[0] + this.yyleng - B]), this.yyleng = this.yytext.length, this;
              }, more: function() {
                return this._more = true, this;
              }, reject: function() {
                if (this.options.backtrack_lexer) this._backtrack = true;
                else return this.parseError("Lexical error on line " + (this.yylineno + 1) + `. You can only invoke reject() in the lexer when the lexer is of the backtracking persuasion (options.backtrack_lexer = true).
` + this.showPosition(), { text: "", token: null, line: this.yylineno });
                return this;
              }, less: function(k) {
                this.unput(this.match.slice(k));
              }, pastInput: function() {
                var k = this.matched.substr(0, this.matched.length - this.match.length);
                return (k.length > 20 ? "..." : "") + k.substr(-20).replace(/\n/g, "");
              }, upcomingInput: function() {
                var k = this.match;
                return k.length < 20 && (k += this._input.substr(0, 20 - k.length)), (k.substr(0, 20) + (k.length > 20 ? "..." : "")).replace(/\n/g, "");
              }, showPosition: function() {
                var k = this.pastInput(), B = new Array(k.length + 1).join("-");
                return k + this.upcomingInput() + `
` + B + "^";
              }, test_match: function(k, B) {
                var O, q, z2;
                if (this.options.backtrack_lexer && (z2 = { yylineno: this.yylineno, yylloc: { first_line: this.yylloc.first_line, last_line: this.last_line, first_column: this.yylloc.first_column, last_column: this.yylloc.last_column }, yytext: this.yytext, match: this.match, matches: this.matches, matched: this.matched, yyleng: this.yyleng, offset: this.offset, _more: this._more, _input: this._input, yy: this.yy, conditionStack: this.conditionStack.slice(0), done: this.done }, this.options.ranges && (z2.yylloc.range = this.yylloc.range.slice(0))), q = k[0].match(/(?:\r\n?|\n).*/g), q && (this.yylineno += q.length), this.yylloc = { first_line: this.yylloc.last_line, last_line: this.yylineno + 1, first_column: this.yylloc.last_column, last_column: q ? q[q.length - 1].length - q[q.length - 1].match(/\r?\n?/)[0].length : this.yylloc.last_column + k[0].length }, this.yytext += k[0], this.match += k[0], this.matches = k, this.yyleng = this.yytext.length, this.options.ranges && (this.yylloc.range = [this.offset, this.offset += this.yyleng]), this._more = false, this._backtrack = false, this._input = this._input.slice(k[0].length), this.matched += k[0], O = this.performAction.call(this, this.yy, this, B, this.conditionStack[this.conditionStack.length - 1]), this.done && this._input && (this.done = false), O) return O;
                if (this._backtrack) {
                  for (var A in z2) this[A] = z2[A];
                  return false;
                }
                return false;
              }, next: function() {
                if (this.done) return this.EOF;
                this._input || (this.done = true);
                var k, B, O, q;
                this._more || (this.yytext = "", this.match = "");
                for (var z2 = this._currentRules(), A = 0; A < z2.length; A++) if (O = this._input.match(this.rules[z2[A]]), O && (!B || O[0].length > B[0].length)) {
                  if (B = O, q = A, this.options.backtrack_lexer) {
                    if (k = this.test_match(O, z2[A]), k !== false) return k;
                    if (this._backtrack) {
                      B = false;
                      continue;
                    } else return false;
                  } else if (!this.options.flex) break;
                }
                return B ? (k = this.test_match(B, z2[q]), k !== false ? k : false) : this._input === "" ? this.EOF : this.parseError("Lexical error on line " + (this.yylineno + 1) + `. Unrecognized text.
` + this.showPosition(), { text: "", token: null, line: this.yylineno });
              }, lex: function() {
                var B = this.next();
                return B || this.lex();
              }, begin: function(B) {
                this.conditionStack.push(B);
              }, popState: function() {
                var B = this.conditionStack.length - 1;
                return B > 0 ? this.conditionStack.pop() : this.conditionStack[0];
              }, _currentRules: function() {
                return this.conditionStack.length && this.conditionStack[this.conditionStack.length - 1] ? this.conditions[this.conditionStack[this.conditionStack.length - 1]].rules : this.conditions.INITIAL.rules;
              }, topState: function(B) {
                return B = this.conditionStack.length - 1 - Math.abs(B || 0), B >= 0 ? this.conditionStack[B] : "INITIAL";
              }, pushState: function(B) {
                this.begin(B);
              }, stateStackSize: function() {
                return this.conditionStack.length;
              }, options: {}, performAction: function(B, O, q, z2) {
                function A(D, $) {
                  return O.yytext = O.yytext.substring(D, O.yyleng - $ + D);
                }
                var Q = z2;
                switch (q) {
                  case 0:
                    if (O.yytext.slice(-2) === "\\\\" ? (A(0, 1), this.begin("mu")) : O.yytext.slice(-1) === "\\" ? (A(0, 1), this.begin("emu")) : this.begin("mu"), O.yytext) return 15;
                    break;
                  case 1:
                    return 15;
                  case 2:
                    return this.popState(), 15;
                    break;
                  case 3:
                    return this.begin("raw"), 15;
                    break;
                  case 4:
                    return this.popState(), this.conditionStack[this.conditionStack.length - 1] === "raw" ? 15 : (A(5, 9), 18);
                  case 5:
                    return 15;
                  case 6:
                    return this.popState(), 14;
                    break;
                  case 7:
                    return 64;
                  case 8:
                    return 67;
                  case 9:
                    return 19;
                  case 10:
                    return this.popState(), this.begin("raw"), 23;
                    break;
                  case 11:
                    return 56;
                  case 12:
                    return 60;
                  case 13:
                    return 29;
                  case 14:
                    return 47;
                  case 15:
                    return this.popState(), 44;
                    break;
                  case 16:
                    return this.popState(), 44;
                    break;
                  case 17:
                    return 34;
                  case 18:
                    return 39;
                  case 19:
                    return 52;
                  case 20:
                    return 48;
                  case 21:
                    this.unput(O.yytext), this.popState(), this.begin("com");
                    break;
                  case 22:
                    return this.popState(), 14;
                    break;
                  case 23:
                    return 48;
                  case 24:
                    return 72;
                  case 25:
                    return 71;
                  case 26:
                    return 71;
                  case 27:
                    return 86;
                  case 28:
                    break;
                  case 29:
                    return this.popState(), 55;
                    break;
                  case 30:
                    return this.popState(), 33;
                    break;
                  case 31:
                    return O.yytext = A(1, 2).replace(/\\"/g, '"'), 79;
                    break;
                  case 32:
                    return O.yytext = A(1, 2).replace(/\\'/g, "'"), 79;
                    break;
                  case 33:
                    return 84;
                  case 34:
                    return 81;
                  case 35:
                    return 81;
                  case 36:
                    return 82;
                  case 37:
                    return 83;
                  case 38:
                    return 80;
                  case 39:
                    return 74;
                  case 40:
                    return 76;
                  case 41:
                    return 71;
                  case 42:
                    return O.yytext = O.yytext.replace(/\\([\\\]])/g, "$1"), 71;
                    break;
                  case 43:
                    return "INVALID";
                  case 44:
                    return 5;
                }
              }, rules: [/^(?:[^\x00]*?(?=(\{\{)))/, /^(?:[^\x00]+)/, /^(?:[^\x00]{2,}?(?=(\{\{|\\\{\{|\\\\\{\{|$)))/, /^(?:\{\{\{\{(?=[^/]))/, /^(?:\{\{\{\{\/[^\s!"#%-,\.\/;->@\[-\^`\{-~]+(?=[=}\s\/.])\}\}\}\})/, /^(?:[^\x00]+?(?=(\{\{\{\{)))/, /^(?:[\s\S]*?--(~)?\}\})/, /^(?:\()/, /^(?:\))/, /^(?:\{\{\{\{)/, /^(?:\}\}\}\})/, /^(?:\{\{(~)?>)/, /^(?:\{\{(~)?#>)/, /^(?:\{\{(~)?#\*?)/, /^(?:\{\{(~)?\/)/, /^(?:\{\{(~)?\^\s*(~)?\}\})/, /^(?:\{\{(~)?\s*else\s*(~)?\}\})/, /^(?:\{\{(~)?\^)/, /^(?:\{\{(~)?\s*else\b)/, /^(?:\{\{(~)?\{)/, /^(?:\{\{(~)?&)/, /^(?:\{\{(~)?!--)/, /^(?:\{\{(~)?![\s\S]*?\}\})/, /^(?:\{\{(~)?\*?)/, /^(?:=)/, /^(?:\.\.)/, /^(?:\.(?=([=~}\s\/.)|])))/, /^(?:[\/.])/, /^(?:\s+)/, /^(?:\}(~)?\}\})/, /^(?:(~)?\}\})/, /^(?:"(\\["]|[^"])*")/, /^(?:'(\\[']|[^'])*')/, /^(?:@)/, /^(?:true(?=([~}\s)])))/, /^(?:false(?=([~}\s)])))/, /^(?:undefined(?=([~}\s)])))/, /^(?:null(?=([~}\s)])))/, /^(?:-?[0-9]+(?:\.[0-9]+)?(?=([~}\s)])))/, /^(?:as\s+\|)/, /^(?:\|)/, /^(?:([^\s!"#%-,\.\/;->@\[-\^`\{-~]+(?=([=~}\s\/.)|]))))/, /^(?:\[(\\\]|[^\]])*\])/, /^(?:.)/, /^(?:$)/], conditions: { mu: { rules: [7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44], inclusive: false }, emu: { rules: [2], inclusive: false }, com: { rules: [6], inclusive: false }, raw: { rules: [3, 4, 5], inclusive: false }, INITIAL: { rules: [0, 1, 44], inclusive: true } } };
              return N;
            }();
            Z.lexer = W;
            function T() {
              this.yy = {};
            }
            return T.prototype = Z, Z.Parser = T, new T();
          }();
          t.default = f;
        } }), Nt = I({ "node_modules/@handlebars/parser/dist/cjs/printer.js"(t) {
          "use strict";
          F();
          var f = t && t.__importDefault || function(o) {
            return o && o.__esModule ? o : { default: o };
          };
          Object.defineProperty(t, "__esModule", { value: true }), t.PrintVisitor = t.print = void 0;
          var h = f(Oe());
          function d(o) {
            return new c().accept(o);
          }
          t.print = d;
          function c() {
            this.padding = 0;
          }
          t.PrintVisitor = c, c.prototype = new h.default(), c.prototype.pad = function(o) {
            for (var e = "", r = 0, s = this.padding; r < s; r++) e += "  ";
            return e += o + `
`, e;
          }, c.prototype.Program = function(o) {
            var e = "", r = o.body, s, p;
            if (o.blockParams) {
              var n = "BLOCK PARAMS: [";
              for (s = 0, p = o.blockParams.length; s < p; s++) n += " " + o.blockParams[s];
              n += " ]", e += this.pad(n);
            }
            for (s = 0, p = r.length; s < p; s++) e += this.accept(r[s]);
            return this.padding--, e;
          }, c.prototype.MustacheStatement = function(o) {
            return this.pad("{{ " + this.SubExpression(o) + " }}");
          }, c.prototype.Decorator = function(o) {
            return this.pad("{{ DIRECTIVE " + this.SubExpression(o) + " }}");
          }, c.prototype.BlockStatement = c.prototype.DecoratorBlock = function(o) {
            var e = "";
            return e += this.pad((o.type === "DecoratorBlock" ? "DIRECTIVE " : "") + "BLOCK:"), this.padding++, e += this.pad(this.SubExpression(o)), o.program && (e += this.pad("PROGRAM:"), this.padding++, e += this.accept(o.program), this.padding--), o.inverse && (o.program && this.padding++, e += this.pad("{{^}}"), this.padding++, e += this.accept(o.inverse), this.padding--, o.program && this.padding--), this.padding--, e;
          }, c.prototype.PartialStatement = function(o) {
            var e = "PARTIAL:" + o.name.original;
            return o.params[0] && (e += " " + this.accept(o.params[0])), o.hash && (e += " " + this.accept(o.hash)), this.pad("{{> " + e + " }}");
          }, c.prototype.PartialBlockStatement = function(o) {
            var e = "PARTIAL BLOCK:" + o.name.original;
            return o.params[0] && (e += " " + this.accept(o.params[0])), o.hash && (e += " " + this.accept(o.hash)), e += " " + this.pad("PROGRAM:"), this.padding++, e += this.accept(o.program), this.padding--, this.pad("{{> " + e + " }}");
          }, c.prototype.ContentStatement = function(o) {
            return this.pad("CONTENT[ '" + o.value + "' ]");
          }, c.prototype.CommentStatement = function(o) {
            return this.pad("{{! '" + o.value + "' }}");
          }, c.prototype.SubExpression = function(o) {
            for (var e = o.params, r = [], s, p = 0, n = e.length; p < n; p++) r.push(this.accept(e[p]));
            return e = "[" + r.join(", ") + "]", s = o.hash ? " " + this.accept(o.hash) : "", this.accept(o.path) + " " + e + s;
          }, c.prototype.PathExpression = function(o) {
            var e = o.parts.join("/");
            return (o.data ? "@" : "") + "PATH:" + e;
          }, c.prototype.StringLiteral = function(o) {
            return '"' + o.value + '"';
          }, c.prototype.NumberLiteral = function(o) {
            return "NUMBER{" + o.value + "}";
          }, c.prototype.BooleanLiteral = function(o) {
            return "BOOLEAN{" + o.value + "}";
          }, c.prototype.UndefinedLiteral = function() {
            return "UNDEFINED";
          }, c.prototype.NullLiteral = function() {
            return "NULL";
          }, c.prototype.Hash = function(o) {
            for (var e = o.pairs, r = [], s = 0, p = e.length; s < p; s++) r.push(this.accept(e[s]));
            return "HASH{" + r.join(", ") + "}";
          }, c.prototype.HashPair = function(o) {
            return o.key + "=" + this.accept(o.value);
          };
        } }), Lt = I({ "node_modules/@handlebars/parser/dist/cjs/helpers.js"(t) {
          "use strict";
          F();
          var f = t && t.__importDefault || function(l) {
            return l && l.__esModule ? l : { default: l };
          };
          Object.defineProperty(t, "__esModule", { value: true }), t.preparePartialBlock = t.prepareProgram = t.prepareBlock = t.prepareRawBlock = t.prepareMustache = t.preparePath = t.stripComment = t.stripFlags = t.id = t.SourceLocation = void 0;
          var h = f(Be());
          function d(l, b) {
            if (b = b.path ? b.path.original : b, l.path.original !== b) {
              var P = { loc: l.path.loc };
              throw new h.default(l.path.original + " doesn't match " + b, P);
            }
          }
          function c(l, b) {
            this.source = l, this.start = { line: b.first_line, column: b.first_column }, this.end = { line: b.last_line, column: b.last_column };
          }
          t.SourceLocation = c;
          function o(l) {
            return /^\[.*\]$/.test(l) ? l.substring(1, l.length - 1) : l;
          }
          t.id = o;
          function e(l, b) {
            return { open: l.charAt(2) === "~", close: b.charAt(b.length - 3) === "~" };
          }
          t.stripFlags = e;
          function r(l) {
            return l.replace(/^\{\{~?!-?-?/, "").replace(/-?-?~?\}\}$/, "");
          }
          t.stripComment = r;
          function s(l, b, P) {
            P = this.locInfo(P);
            for (var E = l ? "@" : "", v = [], _ = 0, y = 0, g = b.length; y < g; y++) {
              var L = b[y].part, j = b[y].original !== L;
              if (E += (b[y].separator || "") + L, !j && (L === ".." || L === "." || L === "this")) {
                if (v.length > 0) throw new h.default("Invalid path: " + E, { loc: P });
                L === ".." && _++;
              } else v.push(L);
            }
            return { type: "PathExpression", data: l, depth: _, parts: v, original: E, loc: P };
          }
          t.preparePath = s;
          function p(l, b, P, E, v, _) {
            var y = E.charAt(3) || E.charAt(2), g = y !== "{" && y !== "&", L = /\*/.test(E);
            return { type: L ? "Decorator" : "MustacheStatement", path: l, params: b, hash: P, escaped: g, strip: v, loc: this.locInfo(_) };
          }
          t.prepareMustache = p;
          function n(l, b, P, E) {
            d(l, P), E = this.locInfo(E);
            var v = { type: "Program", body: b, strip: {}, loc: E };
            return { type: "BlockStatement", path: l.path, params: l.params, hash: l.hash, program: v, openStrip: {}, inverseStrip: {}, closeStrip: {}, loc: E };
          }
          t.prepareRawBlock = n;
          function a(l, b, P, E, v, _) {
            E && E.path && d(l, E);
            var y = /\*/.test(l.open);
            b.blockParams = l.blockParams;
            var g, L;
            if (P) {
              if (y) throw new h.default("Unexpected inverse block on decorator", P);
              P.chain && (P.program.body[0].closeStrip = E.strip), L = P.strip, g = P.program;
            }
            return v && (v = g, g = b, b = v), { type: y ? "DecoratorBlock" : "BlockStatement", path: l.path, params: l.params, hash: l.hash, program: b, inverse: g, openStrip: l.strip, inverseStrip: L, closeStrip: E && E.strip, loc: this.locInfo(_) };
          }
          t.prepareBlock = a;
          function u(l, b) {
            if (!b && l.length) {
              var P = l[0].loc, E = l[l.length - 1].loc;
              P && E && (b = { source: P.source, start: { line: P.start.line, column: P.start.column }, end: { line: E.end.line, column: E.end.column } });
            }
            return { type: "Program", body: l, strip: {}, loc: b };
          }
          t.prepareProgram = u;
          function i(l, b, P, E) {
            return d(l, P), { type: "PartialBlockStatement", name: l.path, params: l.params, hash: l.hash, program: b, openStrip: l.strip, closeStrip: P && P.strip, loc: this.locInfo(E) };
          }
          t.preparePartialBlock = i;
        } }), Ft = I({ "node_modules/@handlebars/parser/dist/cjs/parse.js"(t) {
          "use strict";
          F();
          var f = t && t.__createBinding || (Object.create ? function(u, i, l, b) {
            b === void 0 && (b = l), Object.defineProperty(u, b, { enumerable: true, get: function() {
              return i[l];
            } });
          } : function(u, i, l, b) {
            b === void 0 && (b = l), u[b] = i[l];
          }), h = t && t.__setModuleDefault || (Object.create ? function(u, i) {
            Object.defineProperty(u, "default", { enumerable: true, value: i });
          } : function(u, i) {
            u.default = i;
          }), d = t && t.__importStar || function(u) {
            if (u && u.__esModule) return u;
            var i = {};
            if (u != null) for (var l in u) l !== "default" && Object.prototype.hasOwnProperty.call(u, l) && f(i, u, l);
            return h(i, u), i;
          }, c = t && t.__importDefault || function(u) {
            return u && u.__esModule ? u : { default: u };
          };
          Object.defineProperty(t, "__esModule", { value: true }), t.parse = t.parseWithoutProcessing = void 0;
          var o = c(Ge()), e = c(ze()), r = d(Lt()), s = {};
          for (p in r) Object.prototype.hasOwnProperty.call(r, p) && (s[p] = r[p]);
          var p;
          function n(u, i) {
            if (u.type === "Program") return u;
            o.default.yy = s, o.default.yy.locInfo = function(b) {
              return new r.SourceLocation(i && i.srcName, b);
            };
            var l = o.default.parse(u);
            return l;
          }
          t.parseWithoutProcessing = n;
          function a(u, i) {
            var l = n(u, i), b = new e.default(i);
            return b.accept(l);
          }
          t.parse = a;
        } }), It = I({ "node_modules/@handlebars/parser/dist/cjs/index.js"(t) {
          "use strict";
          F();
          var f = t && t.__importDefault || function(s) {
            return s && s.__esModule ? s : { default: s };
          };
          Object.defineProperty(t, "__esModule", { value: true }), t.parseWithoutProcessing = t.parse = t.PrintVisitor = t.print = t.Exception = t.parser = t.WhitespaceControl = t.Visitor = void 0;
          var h = Oe();
          Object.defineProperty(t, "Visitor", { enumerable: true, get: function() {
            return f(h).default;
          } });
          var d = ze();
          Object.defineProperty(t, "WhitespaceControl", { enumerable: true, get: function() {
            return f(d).default;
          } });
          var c = Ge();
          Object.defineProperty(t, "parser", { enumerable: true, get: function() {
            return f(c).default;
          } });
          var o = Be();
          Object.defineProperty(t, "Exception", { enumerable: true, get: function() {
            return f(o).default;
          } });
          var e = Nt();
          Object.defineProperty(t, "print", { enumerable: true, get: function() {
            return e.print;
          } }), Object.defineProperty(t, "PrintVisitor", { enumerable: true, get: function() {
            return e.PrintVisitor;
          } });
          var r = Ft();
          Object.defineProperty(t, "parse", { enumerable: true, get: function() {
            return r.parse;
          } }), Object.defineProperty(t, "parseWithoutProcessing", { enumerable: true, get: function() {
            return r.parseWithoutProcessing;
          } });
        } }), Ke = I({ "node_modules/simple-html-tokenizer/dist/simple-html-tokenizer.js"(t, f) {
          F(), function(h, d) {
            typeof t == "object" && typeof f < "u" ? d(t) : typeof define == "function" && define.amd ? define(["exports"], d) : d(h.HTML5Tokenizer = {});
          }(t, function(h) {
            "use strict";
            var d = { Aacute: "\xC1", aacute: "\xE1", Abreve: "\u0102", abreve: "\u0103", ac: "\u223E", acd: "\u223F", acE: "\u223E\u0333", Acirc: "\xC2", acirc: "\xE2", acute: "\xB4", Acy: "\u0410", acy: "\u0430", AElig: "\xC6", aelig: "\xE6", af: "\u2061", Afr: "\u{1D504}", afr: "\u{1D51E}", Agrave: "\xC0", agrave: "\xE0", alefsym: "\u2135", aleph: "\u2135", Alpha: "\u0391", alpha: "\u03B1", Amacr: "\u0100", amacr: "\u0101", amalg: "\u2A3F", amp: "&", AMP: "&", andand: "\u2A55", And: "\u2A53", and: "\u2227", andd: "\u2A5C", andslope: "\u2A58", andv: "\u2A5A", ang: "\u2220", ange: "\u29A4", angle: "\u2220", angmsdaa: "\u29A8", angmsdab: "\u29A9", angmsdac: "\u29AA", angmsdad: "\u29AB", angmsdae: "\u29AC", angmsdaf: "\u29AD", angmsdag: "\u29AE", angmsdah: "\u29AF", angmsd: "\u2221", angrt: "\u221F", angrtvb: "\u22BE", angrtvbd: "\u299D", angsph: "\u2222", angst: "\xC5", angzarr: "\u237C", Aogon: "\u0104", aogon: "\u0105", Aopf: "\u{1D538}", aopf: "\u{1D552}", apacir: "\u2A6F", ap: "\u2248", apE: "\u2A70", ape: "\u224A", apid: "\u224B", apos: "'", ApplyFunction: "\u2061", approx: "\u2248", approxeq: "\u224A", Aring: "\xC5", aring: "\xE5", Ascr: "\u{1D49C}", ascr: "\u{1D4B6}", Assign: "\u2254", ast: "*", asymp: "\u2248", asympeq: "\u224D", Atilde: "\xC3", atilde: "\xE3", Auml: "\xC4", auml: "\xE4", awconint: "\u2233", awint: "\u2A11", backcong: "\u224C", backepsilon: "\u03F6", backprime: "\u2035", backsim: "\u223D", backsimeq: "\u22CD", Backslash: "\u2216", Barv: "\u2AE7", barvee: "\u22BD", barwed: "\u2305", Barwed: "\u2306", barwedge: "\u2305", bbrk: "\u23B5", bbrktbrk: "\u23B6", bcong: "\u224C", Bcy: "\u0411", bcy: "\u0431", bdquo: "\u201E", becaus: "\u2235", because: "\u2235", Because: "\u2235", bemptyv: "\u29B0", bepsi: "\u03F6", bernou: "\u212C", Bernoullis: "\u212C", Beta: "\u0392", beta: "\u03B2", beth: "\u2136", between: "\u226C", Bfr: "\u{1D505}", bfr: "\u{1D51F}", bigcap: "\u22C2", bigcirc: "\u25EF", bigcup: "\u22C3", bigodot: "\u2A00", bigoplus: "\u2A01", bigotimes: "\u2A02", bigsqcup: "\u2A06", bigstar: "\u2605", bigtriangledown: "\u25BD", bigtriangleup: "\u25B3", biguplus: "\u2A04", bigvee: "\u22C1", bigwedge: "\u22C0", bkarow: "\u290D", blacklozenge: "\u29EB", blacksquare: "\u25AA", blacktriangle: "\u25B4", blacktriangledown: "\u25BE", blacktriangleleft: "\u25C2", blacktriangleright: "\u25B8", blank: "\u2423", blk12: "\u2592", blk14: "\u2591", blk34: "\u2593", block: "\u2588", bne: "=\u20E5", bnequiv: "\u2261\u20E5", bNot: "\u2AED", bnot: "\u2310", Bopf: "\u{1D539}", bopf: "\u{1D553}", bot: "\u22A5", bottom: "\u22A5", bowtie: "\u22C8", boxbox: "\u29C9", boxdl: "\u2510", boxdL: "\u2555", boxDl: "\u2556", boxDL: "\u2557", boxdr: "\u250C", boxdR: "\u2552", boxDr: "\u2553", boxDR: "\u2554", boxh: "\u2500", boxH: "\u2550", boxhd: "\u252C", boxHd: "\u2564", boxhD: "\u2565", boxHD: "\u2566", boxhu: "\u2534", boxHu: "\u2567", boxhU: "\u2568", boxHU: "\u2569", boxminus: "\u229F", boxplus: "\u229E", boxtimes: "\u22A0", boxul: "\u2518", boxuL: "\u255B", boxUl: "\u255C", boxUL: "\u255D", boxur: "\u2514", boxuR: "\u2558", boxUr: "\u2559", boxUR: "\u255A", boxv: "\u2502", boxV: "\u2551", boxvh: "\u253C", boxvH: "\u256A", boxVh: "\u256B", boxVH: "\u256C", boxvl: "\u2524", boxvL: "\u2561", boxVl: "\u2562", boxVL: "\u2563", boxvr: "\u251C", boxvR: "\u255E", boxVr: "\u255F", boxVR: "\u2560", bprime: "\u2035", breve: "\u02D8", Breve: "\u02D8", brvbar: "\xA6", bscr: "\u{1D4B7}", Bscr: "\u212C", bsemi: "\u204F", bsim: "\u223D", bsime: "\u22CD", bsolb: "\u29C5", bsol: "\\", bsolhsub: "\u27C8", bull: "\u2022", bullet: "\u2022", bump: "\u224E", bumpE: "\u2AAE", bumpe: "\u224F", Bumpeq: "\u224E", bumpeq: "\u224F", Cacute: "\u0106", cacute: "\u0107", capand: "\u2A44", capbrcup: "\u2A49", capcap: "\u2A4B", cap: "\u2229", Cap: "\u22D2", capcup: "\u2A47", capdot: "\u2A40", CapitalDifferentialD: "\u2145", caps: "\u2229\uFE00", caret: "\u2041", caron: "\u02C7", Cayleys: "\u212D", ccaps: "\u2A4D", Ccaron: "\u010C", ccaron: "\u010D", Ccedil: "\xC7", ccedil: "\xE7", Ccirc: "\u0108", ccirc: "\u0109", Cconint: "\u2230", ccups: "\u2A4C", ccupssm: "\u2A50", Cdot: "\u010A", cdot: "\u010B", cedil: "\xB8", Cedilla: "\xB8", cemptyv: "\u29B2", cent: "\xA2", centerdot: "\xB7", CenterDot: "\xB7", cfr: "\u{1D520}", Cfr: "\u212D", CHcy: "\u0427", chcy: "\u0447", check: "\u2713", checkmark: "\u2713", Chi: "\u03A7", chi: "\u03C7", circ: "\u02C6", circeq: "\u2257", circlearrowleft: "\u21BA", circlearrowright: "\u21BB", circledast: "\u229B", circledcirc: "\u229A", circleddash: "\u229D", CircleDot: "\u2299", circledR: "\xAE", circledS: "\u24C8", CircleMinus: "\u2296", CirclePlus: "\u2295", CircleTimes: "\u2297", cir: "\u25CB", cirE: "\u29C3", cire: "\u2257", cirfnint: "\u2A10", cirmid: "\u2AEF", cirscir: "\u29C2", ClockwiseContourIntegral: "\u2232", CloseCurlyDoubleQuote: "\u201D", CloseCurlyQuote: "\u2019", clubs: "\u2663", clubsuit: "\u2663", colon: ":", Colon: "\u2237", Colone: "\u2A74", colone: "\u2254", coloneq: "\u2254", comma: ",", commat: "@", comp: "\u2201", compfn: "\u2218", complement: "\u2201", complexes: "\u2102", cong: "\u2245", congdot: "\u2A6D", Congruent: "\u2261", conint: "\u222E", Conint: "\u222F", ContourIntegral: "\u222E", copf: "\u{1D554}", Copf: "\u2102", coprod: "\u2210", Coproduct: "\u2210", copy: "\xA9", COPY: "\xA9", copysr: "\u2117", CounterClockwiseContourIntegral: "\u2233", crarr: "\u21B5", cross: "\u2717", Cross: "\u2A2F", Cscr: "\u{1D49E}", cscr: "\u{1D4B8}", csub: "\u2ACF", csube: "\u2AD1", csup: "\u2AD0", csupe: "\u2AD2", ctdot: "\u22EF", cudarrl: "\u2938", cudarrr: "\u2935", cuepr: "\u22DE", cuesc: "\u22DF", cularr: "\u21B6", cularrp: "\u293D", cupbrcap: "\u2A48", cupcap: "\u2A46", CupCap: "\u224D", cup: "\u222A", Cup: "\u22D3", cupcup: "\u2A4A", cupdot: "\u228D", cupor: "\u2A45", cups: "\u222A\uFE00", curarr: "\u21B7", curarrm: "\u293C", curlyeqprec: "\u22DE", curlyeqsucc: "\u22DF", curlyvee: "\u22CE", curlywedge: "\u22CF", curren: "\xA4", curvearrowleft: "\u21B6", curvearrowright: "\u21B7", cuvee: "\u22CE", cuwed: "\u22CF", cwconint: "\u2232", cwint: "\u2231", cylcty: "\u232D", dagger: "\u2020", Dagger: "\u2021", daleth: "\u2138", darr: "\u2193", Darr: "\u21A1", dArr: "\u21D3", dash: "\u2010", Dashv: "\u2AE4", dashv: "\u22A3", dbkarow: "\u290F", dblac: "\u02DD", Dcaron: "\u010E", dcaron: "\u010F", Dcy: "\u0414", dcy: "\u0434", ddagger: "\u2021", ddarr: "\u21CA", DD: "\u2145", dd: "\u2146", DDotrahd: "\u2911", ddotseq: "\u2A77", deg: "\xB0", Del: "\u2207", Delta: "\u0394", delta: "\u03B4", demptyv: "\u29B1", dfisht: "\u297F", Dfr: "\u{1D507}", dfr: "\u{1D521}", dHar: "\u2965", dharl: "\u21C3", dharr: "\u21C2", DiacriticalAcute: "\xB4", DiacriticalDot: "\u02D9", DiacriticalDoubleAcute: "\u02DD", DiacriticalGrave: "`", DiacriticalTilde: "\u02DC", diam: "\u22C4", diamond: "\u22C4", Diamond: "\u22C4", diamondsuit: "\u2666", diams: "\u2666", die: "\xA8", DifferentialD: "\u2146", digamma: "\u03DD", disin: "\u22F2", div: "\xF7", divide: "\xF7", divideontimes: "\u22C7", divonx: "\u22C7", DJcy: "\u0402", djcy: "\u0452", dlcorn: "\u231E", dlcrop: "\u230D", dollar: "$", Dopf: "\u{1D53B}", dopf: "\u{1D555}", Dot: "\xA8", dot: "\u02D9", DotDot: "\u20DC", doteq: "\u2250", doteqdot: "\u2251", DotEqual: "\u2250", dotminus: "\u2238", dotplus: "\u2214", dotsquare: "\u22A1", doublebarwedge: "\u2306", DoubleContourIntegral: "\u222F", DoubleDot: "\xA8", DoubleDownArrow: "\u21D3", DoubleLeftArrow: "\u21D0", DoubleLeftRightArrow: "\u21D4", DoubleLeftTee: "\u2AE4", DoubleLongLeftArrow: "\u27F8", DoubleLongLeftRightArrow: "\u27FA", DoubleLongRightArrow: "\u27F9", DoubleRightArrow: "\u21D2", DoubleRightTee: "\u22A8", DoubleUpArrow: "\u21D1", DoubleUpDownArrow: "\u21D5", DoubleVerticalBar: "\u2225", DownArrowBar: "\u2913", downarrow: "\u2193", DownArrow: "\u2193", Downarrow: "\u21D3", DownArrowUpArrow: "\u21F5", DownBreve: "\u0311", downdownarrows: "\u21CA", downharpoonleft: "\u21C3", downharpoonright: "\u21C2", DownLeftRightVector: "\u2950", DownLeftTeeVector: "\u295E", DownLeftVectorBar: "\u2956", DownLeftVector: "\u21BD", DownRightTeeVector: "\u295F", DownRightVectorBar: "\u2957", DownRightVector: "\u21C1", DownTeeArrow: "\u21A7", DownTee: "\u22A4", drbkarow: "\u2910", drcorn: "\u231F", drcrop: "\u230C", Dscr: "\u{1D49F}", dscr: "\u{1D4B9}", DScy: "\u0405", dscy: "\u0455", dsol: "\u29F6", Dstrok: "\u0110", dstrok: "\u0111", dtdot: "\u22F1", dtri: "\u25BF", dtrif: "\u25BE", duarr: "\u21F5", duhar: "\u296F", dwangle: "\u29A6", DZcy: "\u040F", dzcy: "\u045F", dzigrarr: "\u27FF", Eacute: "\xC9", eacute: "\xE9", easter: "\u2A6E", Ecaron: "\u011A", ecaron: "\u011B", Ecirc: "\xCA", ecirc: "\xEA", ecir: "\u2256", ecolon: "\u2255", Ecy: "\u042D", ecy: "\u044D", eDDot: "\u2A77", Edot: "\u0116", edot: "\u0117", eDot: "\u2251", ee: "\u2147", efDot: "\u2252", Efr: "\u{1D508}", efr: "\u{1D522}", eg: "\u2A9A", Egrave: "\xC8", egrave: "\xE8", egs: "\u2A96", egsdot: "\u2A98", el: "\u2A99", Element: "\u2208", elinters: "\u23E7", ell: "\u2113", els: "\u2A95", elsdot: "\u2A97", Emacr: "\u0112", emacr: "\u0113", empty: "\u2205", emptyset: "\u2205", EmptySmallSquare: "\u25FB", emptyv: "\u2205", EmptyVerySmallSquare: "\u25AB", emsp13: "\u2004", emsp14: "\u2005", emsp: "\u2003", ENG: "\u014A", eng: "\u014B", ensp: "\u2002", Eogon: "\u0118", eogon: "\u0119", Eopf: "\u{1D53C}", eopf: "\u{1D556}", epar: "\u22D5", eparsl: "\u29E3", eplus: "\u2A71", epsi: "\u03B5", Epsilon: "\u0395", epsilon: "\u03B5", epsiv: "\u03F5", eqcirc: "\u2256", eqcolon: "\u2255", eqsim: "\u2242", eqslantgtr: "\u2A96", eqslantless: "\u2A95", Equal: "\u2A75", equals: "=", EqualTilde: "\u2242", equest: "\u225F", Equilibrium: "\u21CC", equiv: "\u2261", equivDD: "\u2A78", eqvparsl: "\u29E5", erarr: "\u2971", erDot: "\u2253", escr: "\u212F", Escr: "\u2130", esdot: "\u2250", Esim: "\u2A73", esim: "\u2242", Eta: "\u0397", eta: "\u03B7", ETH: "\xD0", eth: "\xF0", Euml: "\xCB", euml: "\xEB", euro: "\u20AC", excl: "!", exist: "\u2203", Exists: "\u2203", expectation: "\u2130", exponentiale: "\u2147", ExponentialE: "\u2147", fallingdotseq: "\u2252", Fcy: "\u0424", fcy: "\u0444", female: "\u2640", ffilig: "\uFB03", fflig: "\uFB00", ffllig: "\uFB04", Ffr: "\u{1D509}", ffr: "\u{1D523}", filig: "\uFB01", FilledSmallSquare: "\u25FC", FilledVerySmallSquare: "\u25AA", fjlig: "fj", flat: "\u266D", fllig: "\uFB02", fltns: "\u25B1", fnof: "\u0192", Fopf: "\u{1D53D}", fopf: "\u{1D557}", forall: "\u2200", ForAll: "\u2200", fork: "\u22D4", forkv: "\u2AD9", Fouriertrf: "\u2131", fpartint: "\u2A0D", frac12: "\xBD", frac13: "\u2153", frac14: "\xBC", frac15: "\u2155", frac16: "\u2159", frac18: "\u215B", frac23: "\u2154", frac25: "\u2156", frac34: "\xBE", frac35: "\u2157", frac38: "\u215C", frac45: "\u2158", frac56: "\u215A", frac58: "\u215D", frac78: "\u215E", frasl: "\u2044", frown: "\u2322", fscr: "\u{1D4BB}", Fscr: "\u2131", gacute: "\u01F5", Gamma: "\u0393", gamma: "\u03B3", Gammad: "\u03DC", gammad: "\u03DD", gap: "\u2A86", Gbreve: "\u011E", gbreve: "\u011F", Gcedil: "\u0122", Gcirc: "\u011C", gcirc: "\u011D", Gcy: "\u0413", gcy: "\u0433", Gdot: "\u0120", gdot: "\u0121", ge: "\u2265", gE: "\u2267", gEl: "\u2A8C", gel: "\u22DB", geq: "\u2265", geqq: "\u2267", geqslant: "\u2A7E", gescc: "\u2AA9", ges: "\u2A7E", gesdot: "\u2A80", gesdoto: "\u2A82", gesdotol: "\u2A84", gesl: "\u22DB\uFE00", gesles: "\u2A94", Gfr: "\u{1D50A}", gfr: "\u{1D524}", gg: "\u226B", Gg: "\u22D9", ggg: "\u22D9", gimel: "\u2137", GJcy: "\u0403", gjcy: "\u0453", gla: "\u2AA5", gl: "\u2277", glE: "\u2A92", glj: "\u2AA4", gnap: "\u2A8A", gnapprox: "\u2A8A", gne: "\u2A88", gnE: "\u2269", gneq: "\u2A88", gneqq: "\u2269", gnsim: "\u22E7", Gopf: "\u{1D53E}", gopf: "\u{1D558}", grave: "`", GreaterEqual: "\u2265", GreaterEqualLess: "\u22DB", GreaterFullEqual: "\u2267", GreaterGreater: "\u2AA2", GreaterLess: "\u2277", GreaterSlantEqual: "\u2A7E", GreaterTilde: "\u2273", Gscr: "\u{1D4A2}", gscr: "\u210A", gsim: "\u2273", gsime: "\u2A8E", gsiml: "\u2A90", gtcc: "\u2AA7", gtcir: "\u2A7A", gt: ">", GT: ">", Gt: "\u226B", gtdot: "\u22D7", gtlPar: "\u2995", gtquest: "\u2A7C", gtrapprox: "\u2A86", gtrarr: "\u2978", gtrdot: "\u22D7", gtreqless: "\u22DB", gtreqqless: "\u2A8C", gtrless: "\u2277", gtrsim: "\u2273", gvertneqq: "\u2269\uFE00", gvnE: "\u2269\uFE00", Hacek: "\u02C7", hairsp: "\u200A", half: "\xBD", hamilt: "\u210B", HARDcy: "\u042A", hardcy: "\u044A", harrcir: "\u2948", harr: "\u2194", hArr: "\u21D4", harrw: "\u21AD", Hat: "^", hbar: "\u210F", Hcirc: "\u0124", hcirc: "\u0125", hearts: "\u2665", heartsuit: "\u2665", hellip: "\u2026", hercon: "\u22B9", hfr: "\u{1D525}", Hfr: "\u210C", HilbertSpace: "\u210B", hksearow: "\u2925", hkswarow: "\u2926", hoarr: "\u21FF", homtht: "\u223B", hookleftarrow: "\u21A9", hookrightarrow: "\u21AA", hopf: "\u{1D559}", Hopf: "\u210D", horbar: "\u2015", HorizontalLine: "\u2500", hscr: "\u{1D4BD}", Hscr: "\u210B", hslash: "\u210F", Hstrok: "\u0126", hstrok: "\u0127", HumpDownHump: "\u224E", HumpEqual: "\u224F", hybull: "\u2043", hyphen: "\u2010", Iacute: "\xCD", iacute: "\xED", ic: "\u2063", Icirc: "\xCE", icirc: "\xEE", Icy: "\u0418", icy: "\u0438", Idot: "\u0130", IEcy: "\u0415", iecy: "\u0435", iexcl: "\xA1", iff: "\u21D4", ifr: "\u{1D526}", Ifr: "\u2111", Igrave: "\xCC", igrave: "\xEC", ii: "\u2148", iiiint: "\u2A0C", iiint: "\u222D", iinfin: "\u29DC", iiota: "\u2129", IJlig: "\u0132", ijlig: "\u0133", Imacr: "\u012A", imacr: "\u012B", image: "\u2111", ImaginaryI: "\u2148", imagline: "\u2110", imagpart: "\u2111", imath: "\u0131", Im: "\u2111", imof: "\u22B7", imped: "\u01B5", Implies: "\u21D2", incare: "\u2105", in: "\u2208", infin: "\u221E", infintie: "\u29DD", inodot: "\u0131", intcal: "\u22BA", int: "\u222B", Int: "\u222C", integers: "\u2124", Integral: "\u222B", intercal: "\u22BA", Intersection: "\u22C2", intlarhk: "\u2A17", intprod: "\u2A3C", InvisibleComma: "\u2063", InvisibleTimes: "\u2062", IOcy: "\u0401", iocy: "\u0451", Iogon: "\u012E", iogon: "\u012F", Iopf: "\u{1D540}", iopf: "\u{1D55A}", Iota: "\u0399", iota: "\u03B9", iprod: "\u2A3C", iquest: "\xBF", iscr: "\u{1D4BE}", Iscr: "\u2110", isin: "\u2208", isindot: "\u22F5", isinE: "\u22F9", isins: "\u22F4", isinsv: "\u22F3", isinv: "\u2208", it: "\u2062", Itilde: "\u0128", itilde: "\u0129", Iukcy: "\u0406", iukcy: "\u0456", Iuml: "\xCF", iuml: "\xEF", Jcirc: "\u0134", jcirc: "\u0135", Jcy: "\u0419", jcy: "\u0439", Jfr: "\u{1D50D}", jfr: "\u{1D527}", jmath: "\u0237", Jopf: "\u{1D541}", jopf: "\u{1D55B}", Jscr: "\u{1D4A5}", jscr: "\u{1D4BF}", Jsercy: "\u0408", jsercy: "\u0458", Jukcy: "\u0404", jukcy: "\u0454", Kappa: "\u039A", kappa: "\u03BA", kappav: "\u03F0", Kcedil: "\u0136", kcedil: "\u0137", Kcy: "\u041A", kcy: "\u043A", Kfr: "\u{1D50E}", kfr: "\u{1D528}", kgreen: "\u0138", KHcy: "\u0425", khcy: "\u0445", KJcy: "\u040C", kjcy: "\u045C", Kopf: "\u{1D542}", kopf: "\u{1D55C}", Kscr: "\u{1D4A6}", kscr: "\u{1D4C0}", lAarr: "\u21DA", Lacute: "\u0139", lacute: "\u013A", laemptyv: "\u29B4", lagran: "\u2112", Lambda: "\u039B", lambda: "\u03BB", lang: "\u27E8", Lang: "\u27EA", langd: "\u2991", langle: "\u27E8", lap: "\u2A85", Laplacetrf: "\u2112", laquo: "\xAB", larrb: "\u21E4", larrbfs: "\u291F", larr: "\u2190", Larr: "\u219E", lArr: "\u21D0", larrfs: "\u291D", larrhk: "\u21A9", larrlp: "\u21AB", larrpl: "\u2939", larrsim: "\u2973", larrtl: "\u21A2", latail: "\u2919", lAtail: "\u291B", lat: "\u2AAB", late: "\u2AAD", lates: "\u2AAD\uFE00", lbarr: "\u290C", lBarr: "\u290E", lbbrk: "\u2772", lbrace: "{", lbrack: "[", lbrke: "\u298B", lbrksld: "\u298F", lbrkslu: "\u298D", Lcaron: "\u013D", lcaron: "\u013E", Lcedil: "\u013B", lcedil: "\u013C", lceil: "\u2308", lcub: "{", Lcy: "\u041B", lcy: "\u043B", ldca: "\u2936", ldquo: "\u201C", ldquor: "\u201E", ldrdhar: "\u2967", ldrushar: "\u294B", ldsh: "\u21B2", le: "\u2264", lE: "\u2266", LeftAngleBracket: "\u27E8", LeftArrowBar: "\u21E4", leftarrow: "\u2190", LeftArrow: "\u2190", Leftarrow: "\u21D0", LeftArrowRightArrow: "\u21C6", leftarrowtail: "\u21A2", LeftCeiling: "\u2308", LeftDoubleBracket: "\u27E6", LeftDownTeeVector: "\u2961", LeftDownVectorBar: "\u2959", LeftDownVector: "\u21C3", LeftFloor: "\u230A", leftharpoondown: "\u21BD", leftharpoonup: "\u21BC", leftleftarrows: "\u21C7", leftrightarrow: "\u2194", LeftRightArrow: "\u2194", Leftrightarrow: "\u21D4", leftrightarrows: "\u21C6", leftrightharpoons: "\u21CB", leftrightsquigarrow: "\u21AD", LeftRightVector: "\u294E", LeftTeeArrow: "\u21A4", LeftTee: "\u22A3", LeftTeeVector: "\u295A", leftthreetimes: "\u22CB", LeftTriangleBar: "\u29CF", LeftTriangle: "\u22B2", LeftTriangleEqual: "\u22B4", LeftUpDownVector: "\u2951", LeftUpTeeVector: "\u2960", LeftUpVectorBar: "\u2958", LeftUpVector: "\u21BF", LeftVectorBar: "\u2952", LeftVector: "\u21BC", lEg: "\u2A8B", leg: "\u22DA", leq: "\u2264", leqq: "\u2266", leqslant: "\u2A7D", lescc: "\u2AA8", les: "\u2A7D", lesdot: "\u2A7F", lesdoto: "\u2A81", lesdotor: "\u2A83", lesg: "\u22DA\uFE00", lesges: "\u2A93", lessapprox: "\u2A85", lessdot: "\u22D6", lesseqgtr: "\u22DA", lesseqqgtr: "\u2A8B", LessEqualGreater: "\u22DA", LessFullEqual: "\u2266", LessGreater: "\u2276", lessgtr: "\u2276", LessLess: "\u2AA1", lesssim: "\u2272", LessSlantEqual: "\u2A7D", LessTilde: "\u2272", lfisht: "\u297C", lfloor: "\u230A", Lfr: "\u{1D50F}", lfr: "\u{1D529}", lg: "\u2276", lgE: "\u2A91", lHar: "\u2962", lhard: "\u21BD", lharu: "\u21BC", lharul: "\u296A", lhblk: "\u2584", LJcy: "\u0409", ljcy: "\u0459", llarr: "\u21C7", ll: "\u226A", Ll: "\u22D8", llcorner: "\u231E", Lleftarrow: "\u21DA", llhard: "\u296B", lltri: "\u25FA", Lmidot: "\u013F", lmidot: "\u0140", lmoustache: "\u23B0", lmoust: "\u23B0", lnap: "\u2A89", lnapprox: "\u2A89", lne: "\u2A87", lnE: "\u2268", lneq: "\u2A87", lneqq: "\u2268", lnsim: "\u22E6", loang: "\u27EC", loarr: "\u21FD", lobrk: "\u27E6", longleftarrow: "\u27F5", LongLeftArrow: "\u27F5", Longleftarrow: "\u27F8", longleftrightarrow: "\u27F7", LongLeftRightArrow: "\u27F7", Longleftrightarrow: "\u27FA", longmapsto: "\u27FC", longrightarrow: "\u27F6", LongRightArrow: "\u27F6", Longrightarrow: "\u27F9", looparrowleft: "\u21AB", looparrowright: "\u21AC", lopar: "\u2985", Lopf: "\u{1D543}", lopf: "\u{1D55D}", loplus: "\u2A2D", lotimes: "\u2A34", lowast: "\u2217", lowbar: "_", LowerLeftArrow: "\u2199", LowerRightArrow: "\u2198", loz: "\u25CA", lozenge: "\u25CA", lozf: "\u29EB", lpar: "(", lparlt: "\u2993", lrarr: "\u21C6", lrcorner: "\u231F", lrhar: "\u21CB", lrhard: "\u296D", lrm: "\u200E", lrtri: "\u22BF", lsaquo: "\u2039", lscr: "\u{1D4C1}", Lscr: "\u2112", lsh: "\u21B0", Lsh: "\u21B0", lsim: "\u2272", lsime: "\u2A8D", lsimg: "\u2A8F", lsqb: "[", lsquo: "\u2018", lsquor: "\u201A", Lstrok: "\u0141", lstrok: "\u0142", ltcc: "\u2AA6", ltcir: "\u2A79", lt: "<", LT: "<", Lt: "\u226A", ltdot: "\u22D6", lthree: "\u22CB", ltimes: "\u22C9", ltlarr: "\u2976", ltquest: "\u2A7B", ltri: "\u25C3", ltrie: "\u22B4", ltrif: "\u25C2", ltrPar: "\u2996", lurdshar: "\u294A", luruhar: "\u2966", lvertneqq: "\u2268\uFE00", lvnE: "\u2268\uFE00", macr: "\xAF", male: "\u2642", malt: "\u2720", maltese: "\u2720", Map: "\u2905", map: "\u21A6", mapsto: "\u21A6", mapstodown: "\u21A7", mapstoleft: "\u21A4", mapstoup: "\u21A5", marker: "\u25AE", mcomma: "\u2A29", Mcy: "\u041C", mcy: "\u043C", mdash: "\u2014", mDDot: "\u223A", measuredangle: "\u2221", MediumSpace: "\u205F", Mellintrf: "\u2133", Mfr: "\u{1D510}", mfr: "\u{1D52A}", mho: "\u2127", micro: "\xB5", midast: "*", midcir: "\u2AF0", mid: "\u2223", middot: "\xB7", minusb: "\u229F", minus: "\u2212", minusd: "\u2238", minusdu: "\u2A2A", MinusPlus: "\u2213", mlcp: "\u2ADB", mldr: "\u2026", mnplus: "\u2213", models: "\u22A7", Mopf: "\u{1D544}", mopf: "\u{1D55E}", mp: "\u2213", mscr: "\u{1D4C2}", Mscr: "\u2133", mstpos: "\u223E", Mu: "\u039C", mu: "\u03BC", multimap: "\u22B8", mumap: "\u22B8", nabla: "\u2207", Nacute: "\u0143", nacute: "\u0144", nang: "\u2220\u20D2", nap: "\u2249", napE: "\u2A70\u0338", napid: "\u224B\u0338", napos: "\u0149", napprox: "\u2249", natural: "\u266E", naturals: "\u2115", natur: "\u266E", nbsp: "\xA0", nbump: "\u224E\u0338", nbumpe: "\u224F\u0338", ncap: "\u2A43", Ncaron: "\u0147", ncaron: "\u0148", Ncedil: "\u0145", ncedil: "\u0146", ncong: "\u2247", ncongdot: "\u2A6D\u0338", ncup: "\u2A42", Ncy: "\u041D", ncy: "\u043D", ndash: "\u2013", nearhk: "\u2924", nearr: "\u2197", neArr: "\u21D7", nearrow: "\u2197", ne: "\u2260", nedot: "\u2250\u0338", NegativeMediumSpace: "\u200B", NegativeThickSpace: "\u200B", NegativeThinSpace: "\u200B", NegativeVeryThinSpace: "\u200B", nequiv: "\u2262", nesear: "\u2928", nesim: "\u2242\u0338", NestedGreaterGreater: "\u226B", NestedLessLess: "\u226A", NewLine: `
`, nexist: "\u2204", nexists: "\u2204", Nfr: "\u{1D511}", nfr: "\u{1D52B}", ngE: "\u2267\u0338", nge: "\u2271", ngeq: "\u2271", ngeqq: "\u2267\u0338", ngeqslant: "\u2A7E\u0338", nges: "\u2A7E\u0338", nGg: "\u22D9\u0338", ngsim: "\u2275", nGt: "\u226B\u20D2", ngt: "\u226F", ngtr: "\u226F", nGtv: "\u226B\u0338", nharr: "\u21AE", nhArr: "\u21CE", nhpar: "\u2AF2", ni: "\u220B", nis: "\u22FC", nisd: "\u22FA", niv: "\u220B", NJcy: "\u040A", njcy: "\u045A", nlarr: "\u219A", nlArr: "\u21CD", nldr: "\u2025", nlE: "\u2266\u0338", nle: "\u2270", nleftarrow: "\u219A", nLeftarrow: "\u21CD", nleftrightarrow: "\u21AE", nLeftrightarrow: "\u21CE", nleq: "\u2270", nleqq: "\u2266\u0338", nleqslant: "\u2A7D\u0338", nles: "\u2A7D\u0338", nless: "\u226E", nLl: "\u22D8\u0338", nlsim: "\u2274", nLt: "\u226A\u20D2", nlt: "\u226E", nltri: "\u22EA", nltrie: "\u22EC", nLtv: "\u226A\u0338", nmid: "\u2224", NoBreak: "\u2060", NonBreakingSpace: "\xA0", nopf: "\u{1D55F}", Nopf: "\u2115", Not: "\u2AEC", not: "\xAC", NotCongruent: "\u2262", NotCupCap: "\u226D", NotDoubleVerticalBar: "\u2226", NotElement: "\u2209", NotEqual: "\u2260", NotEqualTilde: "\u2242\u0338", NotExists: "\u2204", NotGreater: "\u226F", NotGreaterEqual: "\u2271", NotGreaterFullEqual: "\u2267\u0338", NotGreaterGreater: "\u226B\u0338", NotGreaterLess: "\u2279", NotGreaterSlantEqual: "\u2A7E\u0338", NotGreaterTilde: "\u2275", NotHumpDownHump: "\u224E\u0338", NotHumpEqual: "\u224F\u0338", notin: "\u2209", notindot: "\u22F5\u0338", notinE: "\u22F9\u0338", notinva: "\u2209", notinvb: "\u22F7", notinvc: "\u22F6", NotLeftTriangleBar: "\u29CF\u0338", NotLeftTriangle: "\u22EA", NotLeftTriangleEqual: "\u22EC", NotLess: "\u226E", NotLessEqual: "\u2270", NotLessGreater: "\u2278", NotLessLess: "\u226A\u0338", NotLessSlantEqual: "\u2A7D\u0338", NotLessTilde: "\u2274", NotNestedGreaterGreater: "\u2AA2\u0338", NotNestedLessLess: "\u2AA1\u0338", notni: "\u220C", notniva: "\u220C", notnivb: "\u22FE", notnivc: "\u22FD", NotPrecedes: "\u2280", NotPrecedesEqual: "\u2AAF\u0338", NotPrecedesSlantEqual: "\u22E0", NotReverseElement: "\u220C", NotRightTriangleBar: "\u29D0\u0338", NotRightTriangle: "\u22EB", NotRightTriangleEqual: "\u22ED", NotSquareSubset: "\u228F\u0338", NotSquareSubsetEqual: "\u22E2", NotSquareSuperset: "\u2290\u0338", NotSquareSupersetEqual: "\u22E3", NotSubset: "\u2282\u20D2", NotSubsetEqual: "\u2288", NotSucceeds: "\u2281", NotSucceedsEqual: "\u2AB0\u0338", NotSucceedsSlantEqual: "\u22E1", NotSucceedsTilde: "\u227F\u0338", NotSuperset: "\u2283\u20D2", NotSupersetEqual: "\u2289", NotTilde: "\u2241", NotTildeEqual: "\u2244", NotTildeFullEqual: "\u2247", NotTildeTilde: "\u2249", NotVerticalBar: "\u2224", nparallel: "\u2226", npar: "\u2226", nparsl: "\u2AFD\u20E5", npart: "\u2202\u0338", npolint: "\u2A14", npr: "\u2280", nprcue: "\u22E0", nprec: "\u2280", npreceq: "\u2AAF\u0338", npre: "\u2AAF\u0338", nrarrc: "\u2933\u0338", nrarr: "\u219B", nrArr: "\u21CF", nrarrw: "\u219D\u0338", nrightarrow: "\u219B", nRightarrow: "\u21CF", nrtri: "\u22EB", nrtrie: "\u22ED", nsc: "\u2281", nsccue: "\u22E1", nsce: "\u2AB0\u0338", Nscr: "\u{1D4A9}", nscr: "\u{1D4C3}", nshortmid: "\u2224", nshortparallel: "\u2226", nsim: "\u2241", nsime: "\u2244", nsimeq: "\u2244", nsmid: "\u2224", nspar: "\u2226", nsqsube: "\u22E2", nsqsupe: "\u22E3", nsub: "\u2284", nsubE: "\u2AC5\u0338", nsube: "\u2288", nsubset: "\u2282\u20D2", nsubseteq: "\u2288", nsubseteqq: "\u2AC5\u0338", nsucc: "\u2281", nsucceq: "\u2AB0\u0338", nsup: "\u2285", nsupE: "\u2AC6\u0338", nsupe: "\u2289", nsupset: "\u2283\u20D2", nsupseteq: "\u2289", nsupseteqq: "\u2AC6\u0338", ntgl: "\u2279", Ntilde: "\xD1", ntilde: "\xF1", ntlg: "\u2278", ntriangleleft: "\u22EA", ntrianglelefteq: "\u22EC", ntriangleright: "\u22EB", ntrianglerighteq: "\u22ED", Nu: "\u039D", nu: "\u03BD", num: "#", numero: "\u2116", numsp: "\u2007", nvap: "\u224D\u20D2", nvdash: "\u22AC", nvDash: "\u22AD", nVdash: "\u22AE", nVDash: "\u22AF", nvge: "\u2265\u20D2", nvgt: ">\u20D2", nvHarr: "\u2904", nvinfin: "\u29DE", nvlArr: "\u2902", nvle: "\u2264\u20D2", nvlt: "<\u20D2", nvltrie: "\u22B4\u20D2", nvrArr: "\u2903", nvrtrie: "\u22B5\u20D2", nvsim: "\u223C\u20D2", nwarhk: "\u2923", nwarr: "\u2196", nwArr: "\u21D6", nwarrow: "\u2196", nwnear: "\u2927", Oacute: "\xD3", oacute: "\xF3", oast: "\u229B", Ocirc: "\xD4", ocirc: "\xF4", ocir: "\u229A", Ocy: "\u041E", ocy: "\u043E", odash: "\u229D", Odblac: "\u0150", odblac: "\u0151", odiv: "\u2A38", odot: "\u2299", odsold: "\u29BC", OElig: "\u0152", oelig: "\u0153", ofcir: "\u29BF", Ofr: "\u{1D512}", ofr: "\u{1D52C}", ogon: "\u02DB", Ograve: "\xD2", ograve: "\xF2", ogt: "\u29C1", ohbar: "\u29B5", ohm: "\u03A9", oint: "\u222E", olarr: "\u21BA", olcir: "\u29BE", olcross: "\u29BB", oline: "\u203E", olt: "\u29C0", Omacr: "\u014C", omacr: "\u014D", Omega: "\u03A9", omega: "\u03C9", Omicron: "\u039F", omicron: "\u03BF", omid: "\u29B6", ominus: "\u2296", Oopf: "\u{1D546}", oopf: "\u{1D560}", opar: "\u29B7", OpenCurlyDoubleQuote: "\u201C", OpenCurlyQuote: "\u2018", operp: "\u29B9", oplus: "\u2295", orarr: "\u21BB", Or: "\u2A54", or: "\u2228", ord: "\u2A5D", order: "\u2134", orderof: "\u2134", ordf: "\xAA", ordm: "\xBA", origof: "\u22B6", oror: "\u2A56", orslope: "\u2A57", orv: "\u2A5B", oS: "\u24C8", Oscr: "\u{1D4AA}", oscr: "\u2134", Oslash: "\xD8", oslash: "\xF8", osol: "\u2298", Otilde: "\xD5", otilde: "\xF5", otimesas: "\u2A36", Otimes: "\u2A37", otimes: "\u2297", Ouml: "\xD6", ouml: "\xF6", ovbar: "\u233D", OverBar: "\u203E", OverBrace: "\u23DE", OverBracket: "\u23B4", OverParenthesis: "\u23DC", para: "\xB6", parallel: "\u2225", par: "\u2225", parsim: "\u2AF3", parsl: "\u2AFD", part: "\u2202", PartialD: "\u2202", Pcy: "\u041F", pcy: "\u043F", percnt: "%", period: ".", permil: "\u2030", perp: "\u22A5", pertenk: "\u2031", Pfr: "\u{1D513}", pfr: "\u{1D52D}", Phi: "\u03A6", phi: "\u03C6", phiv: "\u03D5", phmmat: "\u2133", phone: "\u260E", Pi: "\u03A0", pi: "\u03C0", pitchfork: "\u22D4", piv: "\u03D6", planck: "\u210F", planckh: "\u210E", plankv: "\u210F", plusacir: "\u2A23", plusb: "\u229E", pluscir: "\u2A22", plus: "+", plusdo: "\u2214", plusdu: "\u2A25", pluse: "\u2A72", PlusMinus: "\xB1", plusmn: "\xB1", plussim: "\u2A26", plustwo: "\u2A27", pm: "\xB1", Poincareplane: "\u210C", pointint: "\u2A15", popf: "\u{1D561}", Popf: "\u2119", pound: "\xA3", prap: "\u2AB7", Pr: "\u2ABB", pr: "\u227A", prcue: "\u227C", precapprox: "\u2AB7", prec: "\u227A", preccurlyeq: "\u227C", Precedes: "\u227A", PrecedesEqual: "\u2AAF", PrecedesSlantEqual: "\u227C", PrecedesTilde: "\u227E", preceq: "\u2AAF", precnapprox: "\u2AB9", precneqq: "\u2AB5", precnsim: "\u22E8", pre: "\u2AAF", prE: "\u2AB3", precsim: "\u227E", prime: "\u2032", Prime: "\u2033", primes: "\u2119", prnap: "\u2AB9", prnE: "\u2AB5", prnsim: "\u22E8", prod: "\u220F", Product: "\u220F", profalar: "\u232E", profline: "\u2312", profsurf: "\u2313", prop: "\u221D", Proportional: "\u221D", Proportion: "\u2237", propto: "\u221D", prsim: "\u227E", prurel: "\u22B0", Pscr: "\u{1D4AB}", pscr: "\u{1D4C5}", Psi: "\u03A8", psi: "\u03C8", puncsp: "\u2008", Qfr: "\u{1D514}", qfr: "\u{1D52E}", qint: "\u2A0C", qopf: "\u{1D562}", Qopf: "\u211A", qprime: "\u2057", Qscr: "\u{1D4AC}", qscr: "\u{1D4C6}", quaternions: "\u210D", quatint: "\u2A16", quest: "?", questeq: "\u225F", quot: '"', QUOT: '"', rAarr: "\u21DB", race: "\u223D\u0331", Racute: "\u0154", racute: "\u0155", radic: "\u221A", raemptyv: "\u29B3", rang: "\u27E9", Rang: "\u27EB", rangd: "\u2992", range: "\u29A5", rangle: "\u27E9", raquo: "\xBB", rarrap: "\u2975", rarrb: "\u21E5", rarrbfs: "\u2920", rarrc: "\u2933", rarr: "\u2192", Rarr: "\u21A0", rArr: "\u21D2", rarrfs: "\u291E", rarrhk: "\u21AA", rarrlp: "\u21AC", rarrpl: "\u2945", rarrsim: "\u2974", Rarrtl: "\u2916", rarrtl: "\u21A3", rarrw: "\u219D", ratail: "\u291A", rAtail: "\u291C", ratio: "\u2236", rationals: "\u211A", rbarr: "\u290D", rBarr: "\u290F", RBarr: "\u2910", rbbrk: "\u2773", rbrace: "}", rbrack: "]", rbrke: "\u298C", rbrksld: "\u298E", rbrkslu: "\u2990", Rcaron: "\u0158", rcaron: "\u0159", Rcedil: "\u0156", rcedil: "\u0157", rceil: "\u2309", rcub: "}", Rcy: "\u0420", rcy: "\u0440", rdca: "\u2937", rdldhar: "\u2969", rdquo: "\u201D", rdquor: "\u201D", rdsh: "\u21B3", real: "\u211C", realine: "\u211B", realpart: "\u211C", reals: "\u211D", Re: "\u211C", rect: "\u25AD", reg: "\xAE", REG: "\xAE", ReverseElement: "\u220B", ReverseEquilibrium: "\u21CB", ReverseUpEquilibrium: "\u296F", rfisht: "\u297D", rfloor: "\u230B", rfr: "\u{1D52F}", Rfr: "\u211C", rHar: "\u2964", rhard: "\u21C1", rharu: "\u21C0", rharul: "\u296C", Rho: "\u03A1", rho: "\u03C1", rhov: "\u03F1", RightAngleBracket: "\u27E9", RightArrowBar: "\u21E5", rightarrow: "\u2192", RightArrow: "\u2192", Rightarrow: "\u21D2", RightArrowLeftArrow: "\u21C4", rightarrowtail: "\u21A3", RightCeiling: "\u2309", RightDoubleBracket: "\u27E7", RightDownTeeVector: "\u295D", RightDownVectorBar: "\u2955", RightDownVector: "\u21C2", RightFloor: "\u230B", rightharpoondown: "\u21C1", rightharpoonup: "\u21C0", rightleftarrows: "\u21C4", rightleftharpoons: "\u21CC", rightrightarrows: "\u21C9", rightsquigarrow: "\u219D", RightTeeArrow: "\u21A6", RightTee: "\u22A2", RightTeeVector: "\u295B", rightthreetimes: "\u22CC", RightTriangleBar: "\u29D0", RightTriangle: "\u22B3", RightTriangleEqual: "\u22B5", RightUpDownVector: "\u294F", RightUpTeeVector: "\u295C", RightUpVectorBar: "\u2954", RightUpVector: "\u21BE", RightVectorBar: "\u2953", RightVector: "\u21C0", ring: "\u02DA", risingdotseq: "\u2253", rlarr: "\u21C4", rlhar: "\u21CC", rlm: "\u200F", rmoustache: "\u23B1", rmoust: "\u23B1", rnmid: "\u2AEE", roang: "\u27ED", roarr: "\u21FE", robrk: "\u27E7", ropar: "\u2986", ropf: "\u{1D563}", Ropf: "\u211D", roplus: "\u2A2E", rotimes: "\u2A35", RoundImplies: "\u2970", rpar: ")", rpargt: "\u2994", rppolint: "\u2A12", rrarr: "\u21C9", Rrightarrow: "\u21DB", rsaquo: "\u203A", rscr: "\u{1D4C7}", Rscr: "\u211B", rsh: "\u21B1", Rsh: "\u21B1", rsqb: "]", rsquo: "\u2019", rsquor: "\u2019", rthree: "\u22CC", rtimes: "\u22CA", rtri: "\u25B9", rtrie: "\u22B5", rtrif: "\u25B8", rtriltri: "\u29CE", RuleDelayed: "\u29F4", ruluhar: "\u2968", rx: "\u211E", Sacute: "\u015A", sacute: "\u015B", sbquo: "\u201A", scap: "\u2AB8", Scaron: "\u0160", scaron: "\u0161", Sc: "\u2ABC", sc: "\u227B", sccue: "\u227D", sce: "\u2AB0", scE: "\u2AB4", Scedil: "\u015E", scedil: "\u015F", Scirc: "\u015C", scirc: "\u015D", scnap: "\u2ABA", scnE: "\u2AB6", scnsim: "\u22E9", scpolint: "\u2A13", scsim: "\u227F", Scy: "\u0421", scy: "\u0441", sdotb: "\u22A1", sdot: "\u22C5", sdote: "\u2A66", searhk: "\u2925", searr: "\u2198", seArr: "\u21D8", searrow: "\u2198", sect: "\xA7", semi: ";", seswar: "\u2929", setminus: "\u2216", setmn: "\u2216", sext: "\u2736", Sfr: "\u{1D516}", sfr: "\u{1D530}", sfrown: "\u2322", sharp: "\u266F", SHCHcy: "\u0429", shchcy: "\u0449", SHcy: "\u0428", shcy: "\u0448", ShortDownArrow: "\u2193", ShortLeftArrow: "\u2190", shortmid: "\u2223", shortparallel: "\u2225", ShortRightArrow: "\u2192", ShortUpArrow: "\u2191", shy: "\xAD", Sigma: "\u03A3", sigma: "\u03C3", sigmaf: "\u03C2", sigmav: "\u03C2", sim: "\u223C", simdot: "\u2A6A", sime: "\u2243", simeq: "\u2243", simg: "\u2A9E", simgE: "\u2AA0", siml: "\u2A9D", simlE: "\u2A9F", simne: "\u2246", simplus: "\u2A24", simrarr: "\u2972", slarr: "\u2190", SmallCircle: "\u2218", smallsetminus: "\u2216", smashp: "\u2A33", smeparsl: "\u29E4", smid: "\u2223", smile: "\u2323", smt: "\u2AAA", smte: "\u2AAC", smtes: "\u2AAC\uFE00", SOFTcy: "\u042C", softcy: "\u044C", solbar: "\u233F", solb: "\u29C4", sol: "/", Sopf: "\u{1D54A}", sopf: "\u{1D564}", spades: "\u2660", spadesuit: "\u2660", spar: "\u2225", sqcap: "\u2293", sqcaps: "\u2293\uFE00", sqcup: "\u2294", sqcups: "\u2294\uFE00", Sqrt: "\u221A", sqsub: "\u228F", sqsube: "\u2291", sqsubset: "\u228F", sqsubseteq: "\u2291", sqsup: "\u2290", sqsupe: "\u2292", sqsupset: "\u2290", sqsupseteq: "\u2292", square: "\u25A1", Square: "\u25A1", SquareIntersection: "\u2293", SquareSubset: "\u228F", SquareSubsetEqual: "\u2291", SquareSuperset: "\u2290", SquareSupersetEqual: "\u2292", SquareUnion: "\u2294", squarf: "\u25AA", squ: "\u25A1", squf: "\u25AA", srarr: "\u2192", Sscr: "\u{1D4AE}", sscr: "\u{1D4C8}", ssetmn: "\u2216", ssmile: "\u2323", sstarf: "\u22C6", Star: "\u22C6", star: "\u2606", starf: "\u2605", straightepsilon: "\u03F5", straightphi: "\u03D5", strns: "\xAF", sub: "\u2282", Sub: "\u22D0", subdot: "\u2ABD", subE: "\u2AC5", sube: "\u2286", subedot: "\u2AC3", submult: "\u2AC1", subnE: "\u2ACB", subne: "\u228A", subplus: "\u2ABF", subrarr: "\u2979", subset: "\u2282", Subset: "\u22D0", subseteq: "\u2286", subseteqq: "\u2AC5", SubsetEqual: "\u2286", subsetneq: "\u228A", subsetneqq: "\u2ACB", subsim: "\u2AC7", subsub: "\u2AD5", subsup: "\u2AD3", succapprox: "\u2AB8", succ: "\u227B", succcurlyeq: "\u227D", Succeeds: "\u227B", SucceedsEqual: "\u2AB0", SucceedsSlantEqual: "\u227D", SucceedsTilde: "\u227F", succeq: "\u2AB0", succnapprox: "\u2ABA", succneqq: "\u2AB6", succnsim: "\u22E9", succsim: "\u227F", SuchThat: "\u220B", sum: "\u2211", Sum: "\u2211", sung: "\u266A", sup1: "\xB9", sup2: "\xB2", sup3: "\xB3", sup: "\u2283", Sup: "\u22D1", supdot: "\u2ABE", supdsub: "\u2AD8", supE: "\u2AC6", supe: "\u2287", supedot: "\u2AC4", Superset: "\u2283", SupersetEqual: "\u2287", suphsol: "\u27C9", suphsub: "\u2AD7", suplarr: "\u297B", supmult: "\u2AC2", supnE: "\u2ACC", supne: "\u228B", supplus: "\u2AC0", supset: "\u2283", Supset: "\u22D1", supseteq: "\u2287", supseteqq: "\u2AC6", supsetneq: "\u228B", supsetneqq: "\u2ACC", supsim: "\u2AC8", supsub: "\u2AD4", supsup: "\u2AD6", swarhk: "\u2926", swarr: "\u2199", swArr: "\u21D9", swarrow: "\u2199", swnwar: "\u292A", szlig: "\xDF", Tab: "	", target: "\u2316", Tau: "\u03A4", tau: "\u03C4", tbrk: "\u23B4", Tcaron: "\u0164", tcaron: "\u0165", Tcedil: "\u0162", tcedil: "\u0163", Tcy: "\u0422", tcy: "\u0442", tdot: "\u20DB", telrec: "\u2315", Tfr: "\u{1D517}", tfr: "\u{1D531}", there4: "\u2234", therefore: "\u2234", Therefore: "\u2234", Theta: "\u0398", theta: "\u03B8", thetasym: "\u03D1", thetav: "\u03D1", thickapprox: "\u2248", thicksim: "\u223C", ThickSpace: "\u205F\u200A", ThinSpace: "\u2009", thinsp: "\u2009", thkap: "\u2248", thksim: "\u223C", THORN: "\xDE", thorn: "\xFE", tilde: "\u02DC", Tilde: "\u223C", TildeEqual: "\u2243", TildeFullEqual: "\u2245", TildeTilde: "\u2248", timesbar: "\u2A31", timesb: "\u22A0", times: "\xD7", timesd: "\u2A30", tint: "\u222D", toea: "\u2928", topbot: "\u2336", topcir: "\u2AF1", top: "\u22A4", Topf: "\u{1D54B}", topf: "\u{1D565}", topfork: "\u2ADA", tosa: "\u2929", tprime: "\u2034", trade: "\u2122", TRADE: "\u2122", triangle: "\u25B5", triangledown: "\u25BF", triangleleft: "\u25C3", trianglelefteq: "\u22B4", triangleq: "\u225C", triangleright: "\u25B9", trianglerighteq: "\u22B5", tridot: "\u25EC", trie: "\u225C", triminus: "\u2A3A", TripleDot: "\u20DB", triplus: "\u2A39", trisb: "\u29CD", tritime: "\u2A3B", trpezium: "\u23E2", Tscr: "\u{1D4AF}", tscr: "\u{1D4C9}", TScy: "\u0426", tscy: "\u0446", TSHcy: "\u040B", tshcy: "\u045B", Tstrok: "\u0166", tstrok: "\u0167", twixt: "\u226C", twoheadleftarrow: "\u219E", twoheadrightarrow: "\u21A0", Uacute: "\xDA", uacute: "\xFA", uarr: "\u2191", Uarr: "\u219F", uArr: "\u21D1", Uarrocir: "\u2949", Ubrcy: "\u040E", ubrcy: "\u045E", Ubreve: "\u016C", ubreve: "\u016D", Ucirc: "\xDB", ucirc: "\xFB", Ucy: "\u0423", ucy: "\u0443", udarr: "\u21C5", Udblac: "\u0170", udblac: "\u0171", udhar: "\u296E", ufisht: "\u297E", Ufr: "\u{1D518}", ufr: "\u{1D532}", Ugrave: "\xD9", ugrave: "\xF9", uHar: "\u2963", uharl: "\u21BF", uharr: "\u21BE", uhblk: "\u2580", ulcorn: "\u231C", ulcorner: "\u231C", ulcrop: "\u230F", ultri: "\u25F8", Umacr: "\u016A", umacr: "\u016B", uml: "\xA8", UnderBar: "_", UnderBrace: "\u23DF", UnderBracket: "\u23B5", UnderParenthesis: "\u23DD", Union: "\u22C3", UnionPlus: "\u228E", Uogon: "\u0172", uogon: "\u0173", Uopf: "\u{1D54C}", uopf: "\u{1D566}", UpArrowBar: "\u2912", uparrow: "\u2191", UpArrow: "\u2191", Uparrow: "\u21D1", UpArrowDownArrow: "\u21C5", updownarrow: "\u2195", UpDownArrow: "\u2195", Updownarrow: "\u21D5", UpEquilibrium: "\u296E", upharpoonleft: "\u21BF", upharpoonright: "\u21BE", uplus: "\u228E", UpperLeftArrow: "\u2196", UpperRightArrow: "\u2197", upsi: "\u03C5", Upsi: "\u03D2", upsih: "\u03D2", Upsilon: "\u03A5", upsilon: "\u03C5", UpTeeArrow: "\u21A5", UpTee: "\u22A5", upuparrows: "\u21C8", urcorn: "\u231D", urcorner: "\u231D", urcrop: "\u230E", Uring: "\u016E", uring: "\u016F", urtri: "\u25F9", Uscr: "\u{1D4B0}", uscr: "\u{1D4CA}", utdot: "\u22F0", Utilde: "\u0168", utilde: "\u0169", utri: "\u25B5", utrif: "\u25B4", uuarr: "\u21C8", Uuml: "\xDC", uuml: "\xFC", uwangle: "\u29A7", vangrt: "\u299C", varepsilon: "\u03F5", varkappa: "\u03F0", varnothing: "\u2205", varphi: "\u03D5", varpi: "\u03D6", varpropto: "\u221D", varr: "\u2195", vArr: "\u21D5", varrho: "\u03F1", varsigma: "\u03C2", varsubsetneq: "\u228A\uFE00", varsubsetneqq: "\u2ACB\uFE00", varsupsetneq: "\u228B\uFE00", varsupsetneqq: "\u2ACC\uFE00", vartheta: "\u03D1", vartriangleleft: "\u22B2", vartriangleright: "\u22B3", vBar: "\u2AE8", Vbar: "\u2AEB", vBarv: "\u2AE9", Vcy: "\u0412", vcy: "\u0432", vdash: "\u22A2", vDash: "\u22A8", Vdash: "\u22A9", VDash: "\u22AB", Vdashl: "\u2AE6", veebar: "\u22BB", vee: "\u2228", Vee: "\u22C1", veeeq: "\u225A", vellip: "\u22EE", verbar: "|", Verbar: "\u2016", vert: "|", Vert: "\u2016", VerticalBar: "\u2223", VerticalLine: "|", VerticalSeparator: "\u2758", VerticalTilde: "\u2240", VeryThinSpace: "\u200A", Vfr: "\u{1D519}", vfr: "\u{1D533}", vltri: "\u22B2", vnsub: "\u2282\u20D2", vnsup: "\u2283\u20D2", Vopf: "\u{1D54D}", vopf: "\u{1D567}", vprop: "\u221D", vrtri: "\u22B3", Vscr: "\u{1D4B1}", vscr: "\u{1D4CB}", vsubnE: "\u2ACB\uFE00", vsubne: "\u228A\uFE00", vsupnE: "\u2ACC\uFE00", vsupne: "\u228B\uFE00", Vvdash: "\u22AA", vzigzag: "\u299A", Wcirc: "\u0174", wcirc: "\u0175", wedbar: "\u2A5F", wedge: "\u2227", Wedge: "\u22C0", wedgeq: "\u2259", weierp: "\u2118", Wfr: "\u{1D51A}", wfr: "\u{1D534}", Wopf: "\u{1D54E}", wopf: "\u{1D568}", wp: "\u2118", wr: "\u2240", wreath: "\u2240", Wscr: "\u{1D4B2}", wscr: "\u{1D4CC}", xcap: "\u22C2", xcirc: "\u25EF", xcup: "\u22C3", xdtri: "\u25BD", Xfr: "\u{1D51B}", xfr: "\u{1D535}", xharr: "\u27F7", xhArr: "\u27FA", Xi: "\u039E", xi: "\u03BE", xlarr: "\u27F5", xlArr: "\u27F8", xmap: "\u27FC", xnis: "\u22FB", xodot: "\u2A00", Xopf: "\u{1D54F}", xopf: "\u{1D569}", xoplus: "\u2A01", xotime: "\u2A02", xrarr: "\u27F6", xrArr: "\u27F9", Xscr: "\u{1D4B3}", xscr: "\u{1D4CD}", xsqcup: "\u2A06", xuplus: "\u2A04", xutri: "\u25B3", xvee: "\u22C1", xwedge: "\u22C0", Yacute: "\xDD", yacute: "\xFD", YAcy: "\u042F", yacy: "\u044F", Ycirc: "\u0176", ycirc: "\u0177", Ycy: "\u042B", ycy: "\u044B", yen: "\xA5", Yfr: "\u{1D51C}", yfr: "\u{1D536}", YIcy: "\u0407", yicy: "\u0457", Yopf: "\u{1D550}", yopf: "\u{1D56A}", Yscr: "\u{1D4B4}", yscr: "\u{1D4CE}", YUcy: "\u042E", yucy: "\u044E", yuml: "\xFF", Yuml: "\u0178", Zacute: "\u0179", zacute: "\u017A", Zcaron: "\u017D", zcaron: "\u017E", Zcy: "\u0417", zcy: "\u0437", Zdot: "\u017B", zdot: "\u017C", zeetrf: "\u2128", ZeroWidthSpace: "\u200B", Zeta: "\u0396", zeta: "\u03B6", zfr: "\u{1D537}", Zfr: "\u2128", ZHcy: "\u0416", zhcy: "\u0436", zigrarr: "\u21DD", zopf: "\u{1D56B}", Zopf: "\u2124", Zscr: "\u{1D4B5}", zscr: "\u{1D4CF}", zwj: "\u200D", zwnj: "\u200C" }, c = /^#[xX]([A-Fa-f0-9]+)$/, o = /^#([0-9]+)$/, e = /^([A-Za-z0-9]+)$/, r = function() {
              function E(v) {
                this.named = v;
              }
              return E.prototype.parse = function(v) {
                if (!!v) {
                  var _ = v.match(c);
                  if (_) return String.fromCharCode(parseInt(_[1], 16));
                  if (_ = v.match(o), _) return String.fromCharCode(parseInt(_[1], 10));
                  if (_ = v.match(e), _) return this.named[_[1]];
                }
              }, E;
            }(), s = /[\t\n\f ]/, p = /[A-Za-z]/, n = /\r\n?/g;
            function a(E) {
              return s.test(E);
            }
            function u(E) {
              return p.test(E);
            }
            function i(E) {
              return E.replace(n, `
`);
            }
            var l = function() {
              function E(v, _, y) {
                y === void 0 && (y = "precompile"), this.delegate = v, this.entityParser = _, this.mode = y, this.state = "beforeData", this.line = -1, this.column = -1, this.input = "", this.index = -1, this.tagNameBuffer = "", this.states = { beforeData: function() {
                  var g = this.peek();
                  if (g === "<" && !this.isIgnoredEndTag()) this.transitionTo("tagOpen"), this.markTagStart(), this.consume();
                  else {
                    if (this.mode === "precompile" && g === `
`) {
                      var L = this.tagNameBuffer.toLowerCase();
                      (L === "pre" || L === "textarea") && this.consume();
                    }
                    this.transitionTo("data"), this.delegate.beginData();
                  }
                }, data: function() {
                  var g = this.peek(), L = this.tagNameBuffer;
                  g === "<" && !this.isIgnoredEndTag() ? (this.delegate.finishData(), this.transitionTo("tagOpen"), this.markTagStart(), this.consume()) : g === "&" && L !== "script" && L !== "style" ? (this.consume(), this.delegate.appendToData(this.consumeCharRef() || "&")) : (this.consume(), this.delegate.appendToData(g));
                }, tagOpen: function() {
                  var g = this.consume();
                  g === "!" ? this.transitionTo("markupDeclarationOpen") : g === "/" ? this.transitionTo("endTagOpen") : (g === "@" || g === ":" || u(g)) && (this.transitionTo("tagName"), this.tagNameBuffer = "", this.delegate.beginStartTag(), this.appendToTagName(g));
                }, markupDeclarationOpen: function() {
                  var g = this.consume();
                  if (g === "-" && this.peek() === "-") this.consume(), this.transitionTo("commentStart"), this.delegate.beginComment();
                  else {
                    var L = g.toUpperCase() + this.input.substring(this.index, this.index + 6).toUpperCase();
                    L === "DOCTYPE" && (this.consume(), this.consume(), this.consume(), this.consume(), this.consume(), this.consume(), this.transitionTo("doctype"), this.delegate.beginDoctype && this.delegate.beginDoctype());
                  }
                }, doctype: function() {
                  var g = this.consume();
                  a(g) && this.transitionTo("beforeDoctypeName");
                }, beforeDoctypeName: function() {
                  var g = this.consume();
                  a(g) || (this.transitionTo("doctypeName"), this.delegate.appendToDoctypeName && this.delegate.appendToDoctypeName(g.toLowerCase()));
                }, doctypeName: function() {
                  var g = this.consume();
                  a(g) ? this.transitionTo("afterDoctypeName") : g === ">" ? (this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData")) : this.delegate.appendToDoctypeName && this.delegate.appendToDoctypeName(g.toLowerCase());
                }, afterDoctypeName: function() {
                  var g = this.consume();
                  if (!a(g)) if (g === ">") this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData");
                  else {
                    var L = g.toUpperCase() + this.input.substring(this.index, this.index + 5).toUpperCase(), j = L.toUpperCase() === "PUBLIC", x = L.toUpperCase() === "SYSTEM";
                    (j || x) && (this.consume(), this.consume(), this.consume(), this.consume(), this.consume(), this.consume()), j ? this.transitionTo("afterDoctypePublicKeyword") : x && this.transitionTo("afterDoctypeSystemKeyword");
                  }
                }, afterDoctypePublicKeyword: function() {
                  var g = this.peek();
                  a(g) ? (this.transitionTo("beforeDoctypePublicIdentifier"), this.consume()) : g === '"' ? (this.transitionTo("doctypePublicIdentifierDoubleQuoted"), this.consume()) : g === "'" ? (this.transitionTo("doctypePublicIdentifierSingleQuoted"), this.consume()) : g === ">" && (this.consume(), this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData"));
                }, doctypePublicIdentifierDoubleQuoted: function() {
                  var g = this.consume();
                  g === '"' ? this.transitionTo("afterDoctypePublicIdentifier") : g === ">" ? (this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData")) : this.delegate.appendToDoctypePublicIdentifier && this.delegate.appendToDoctypePublicIdentifier(g);
                }, doctypePublicIdentifierSingleQuoted: function() {
                  var g = this.consume();
                  g === "'" ? this.transitionTo("afterDoctypePublicIdentifier") : g === ">" ? (this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData")) : this.delegate.appendToDoctypePublicIdentifier && this.delegate.appendToDoctypePublicIdentifier(g);
                }, afterDoctypePublicIdentifier: function() {
                  var g = this.consume();
                  a(g) ? this.transitionTo("betweenDoctypePublicAndSystemIdentifiers") : g === ">" ? (this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData")) : g === '"' ? this.transitionTo("doctypeSystemIdentifierDoubleQuoted") : g === "'" && this.transitionTo("doctypeSystemIdentifierSingleQuoted");
                }, betweenDoctypePublicAndSystemIdentifiers: function() {
                  var g = this.consume();
                  a(g) || (g === ">" ? (this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData")) : g === '"' ? this.transitionTo("doctypeSystemIdentifierDoubleQuoted") : g === "'" && this.transitionTo("doctypeSystemIdentifierSingleQuoted"));
                }, doctypeSystemIdentifierDoubleQuoted: function() {
                  var g = this.consume();
                  g === '"' ? this.transitionTo("afterDoctypeSystemIdentifier") : g === ">" ? (this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData")) : this.delegate.appendToDoctypeSystemIdentifier && this.delegate.appendToDoctypeSystemIdentifier(g);
                }, doctypeSystemIdentifierSingleQuoted: function() {
                  var g = this.consume();
                  g === "'" ? this.transitionTo("afterDoctypeSystemIdentifier") : g === ">" ? (this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData")) : this.delegate.appendToDoctypeSystemIdentifier && this.delegate.appendToDoctypeSystemIdentifier(g);
                }, afterDoctypeSystemIdentifier: function() {
                  var g = this.consume();
                  a(g) || g === ">" && (this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData"));
                }, commentStart: function() {
                  var g = this.consume();
                  g === "-" ? this.transitionTo("commentStartDash") : g === ">" ? (this.delegate.finishComment(), this.transitionTo("beforeData")) : (this.delegate.appendToCommentData(g), this.transitionTo("comment"));
                }, commentStartDash: function() {
                  var g = this.consume();
                  g === "-" ? this.transitionTo("commentEnd") : g === ">" ? (this.delegate.finishComment(), this.transitionTo("beforeData")) : (this.delegate.appendToCommentData("-"), this.transitionTo("comment"));
                }, comment: function() {
                  var g = this.consume();
                  g === "-" ? this.transitionTo("commentEndDash") : this.delegate.appendToCommentData(g);
                }, commentEndDash: function() {
                  var g = this.consume();
                  g === "-" ? this.transitionTo("commentEnd") : (this.delegate.appendToCommentData("-" + g), this.transitionTo("comment"));
                }, commentEnd: function() {
                  var g = this.consume();
                  g === ">" ? (this.delegate.finishComment(), this.transitionTo("beforeData")) : (this.delegate.appendToCommentData("--" + g), this.transitionTo("comment"));
                }, tagName: function() {
                  var g = this.consume();
                  a(g) ? this.transitionTo("beforeAttributeName") : g === "/" ? this.transitionTo("selfClosingStartTag") : g === ">" ? (this.delegate.finishTag(), this.transitionTo("beforeData")) : this.appendToTagName(g);
                }, endTagName: function() {
                  var g = this.consume();
                  a(g) ? (this.transitionTo("beforeAttributeName"), this.tagNameBuffer = "") : g === "/" ? (this.transitionTo("selfClosingStartTag"), this.tagNameBuffer = "") : g === ">" ? (this.delegate.finishTag(), this.transitionTo("beforeData"), this.tagNameBuffer = "") : this.appendToTagName(g);
                }, beforeAttributeName: function() {
                  var g = this.peek();
                  if (a(g)) {
                    this.consume();
                    return;
                  } else g === "/" ? (this.transitionTo("selfClosingStartTag"), this.consume()) : g === ">" ? (this.consume(), this.delegate.finishTag(), this.transitionTo("beforeData")) : g === "=" ? (this.delegate.reportSyntaxError("attribute name cannot start with equals sign"), this.transitionTo("attributeName"), this.delegate.beginAttribute(), this.consume(), this.delegate.appendToAttributeName(g)) : (this.transitionTo("attributeName"), this.delegate.beginAttribute());
                }, attributeName: function() {
                  var g = this.peek();
                  a(g) ? (this.transitionTo("afterAttributeName"), this.consume()) : g === "/" ? (this.delegate.beginAttributeValue(false), this.delegate.finishAttributeValue(), this.consume(), this.transitionTo("selfClosingStartTag")) : g === "=" ? (this.transitionTo("beforeAttributeValue"), this.consume()) : g === ">" ? (this.delegate.beginAttributeValue(false), this.delegate.finishAttributeValue(), this.consume(), this.delegate.finishTag(), this.transitionTo("beforeData")) : g === '"' || g === "'" || g === "<" ? (this.delegate.reportSyntaxError(g + " is not a valid character within attribute names"), this.consume(), this.delegate.appendToAttributeName(g)) : (this.consume(), this.delegate.appendToAttributeName(g));
                }, afterAttributeName: function() {
                  var g = this.peek();
                  if (a(g)) {
                    this.consume();
                    return;
                  } else g === "/" ? (this.delegate.beginAttributeValue(false), this.delegate.finishAttributeValue(), this.consume(), this.transitionTo("selfClosingStartTag")) : g === "=" ? (this.consume(), this.transitionTo("beforeAttributeValue")) : g === ">" ? (this.delegate.beginAttributeValue(false), this.delegate.finishAttributeValue(), this.consume(), this.delegate.finishTag(), this.transitionTo("beforeData")) : (this.delegate.beginAttributeValue(false), this.delegate.finishAttributeValue(), this.transitionTo("attributeName"), this.delegate.beginAttribute(), this.consume(), this.delegate.appendToAttributeName(g));
                }, beforeAttributeValue: function() {
                  var g = this.peek();
                  a(g) ? this.consume() : g === '"' ? (this.transitionTo("attributeValueDoubleQuoted"), this.delegate.beginAttributeValue(true), this.consume()) : g === "'" ? (this.transitionTo("attributeValueSingleQuoted"), this.delegate.beginAttributeValue(true), this.consume()) : g === ">" ? (this.delegate.beginAttributeValue(false), this.delegate.finishAttributeValue(), this.consume(), this.delegate.finishTag(), this.transitionTo("beforeData")) : (this.transitionTo("attributeValueUnquoted"), this.delegate.beginAttributeValue(false), this.consume(), this.delegate.appendToAttributeValue(g));
                }, attributeValueDoubleQuoted: function() {
                  var g = this.consume();
                  g === '"' ? (this.delegate.finishAttributeValue(), this.transitionTo("afterAttributeValueQuoted")) : g === "&" ? this.delegate.appendToAttributeValue(this.consumeCharRef() || "&") : this.delegate.appendToAttributeValue(g);
                }, attributeValueSingleQuoted: function() {
                  var g = this.consume();
                  g === "'" ? (this.delegate.finishAttributeValue(), this.transitionTo("afterAttributeValueQuoted")) : g === "&" ? this.delegate.appendToAttributeValue(this.consumeCharRef() || "&") : this.delegate.appendToAttributeValue(g);
                }, attributeValueUnquoted: function() {
                  var g = this.peek();
                  a(g) ? (this.delegate.finishAttributeValue(), this.consume(), this.transitionTo("beforeAttributeName")) : g === "/" ? (this.delegate.finishAttributeValue(), this.consume(), this.transitionTo("selfClosingStartTag")) : g === "&" ? (this.consume(), this.delegate.appendToAttributeValue(this.consumeCharRef() || "&")) : g === ">" ? (this.delegate.finishAttributeValue(), this.consume(), this.delegate.finishTag(), this.transitionTo("beforeData")) : (this.consume(), this.delegate.appendToAttributeValue(g));
                }, afterAttributeValueQuoted: function() {
                  var g = this.peek();
                  a(g) ? (this.consume(), this.transitionTo("beforeAttributeName")) : g === "/" ? (this.consume(), this.transitionTo("selfClosingStartTag")) : g === ">" ? (this.consume(), this.delegate.finishTag(), this.transitionTo("beforeData")) : this.transitionTo("beforeAttributeName");
                }, selfClosingStartTag: function() {
                  var g = this.peek();
                  g === ">" ? (this.consume(), this.delegate.markTagAsSelfClosing(), this.delegate.finishTag(), this.transitionTo("beforeData")) : this.transitionTo("beforeAttributeName");
                }, endTagOpen: function() {
                  var g = this.consume();
                  (g === "@" || g === ":" || u(g)) && (this.transitionTo("endTagName"), this.tagNameBuffer = "", this.delegate.beginEndTag(), this.appendToTagName(g));
                } }, this.reset();
              }
              return E.prototype.reset = function() {
                this.transitionTo("beforeData"), this.input = "", this.tagNameBuffer = "", this.index = 0, this.line = 1, this.column = 0, this.delegate.reset();
              }, E.prototype.transitionTo = function(v) {
                this.state = v;
              }, E.prototype.tokenize = function(v) {
                this.reset(), this.tokenizePart(v), this.tokenizeEOF();
              }, E.prototype.tokenizePart = function(v) {
                for (this.input += i(v); this.index < this.input.length; ) {
                  var _ = this.states[this.state];
                  if (_ !== void 0) _.call(this);
                  else throw new Error("unhandled state " + this.state);
                }
              }, E.prototype.tokenizeEOF = function() {
                this.flushData();
              }, E.prototype.flushData = function() {
                this.state === "data" && (this.delegate.finishData(), this.transitionTo("beforeData"));
              }, E.prototype.peek = function() {
                return this.input.charAt(this.index);
              }, E.prototype.consume = function() {
                var v = this.peek();
                return this.index++, v === `
` ? (this.line++, this.column = 0) : this.column++, v;
              }, E.prototype.consumeCharRef = function() {
                var v = this.input.indexOf(";", this.index);
                if (v !== -1) {
                  var _ = this.input.slice(this.index, v), y = this.entityParser.parse(_);
                  if (y) {
                    for (var g = _.length; g; ) this.consume(), g--;
                    return this.consume(), y;
                  }
                }
              }, E.prototype.markTagStart = function() {
                this.delegate.tagOpen();
              }, E.prototype.appendToTagName = function(v) {
                this.tagNameBuffer += v, this.delegate.appendToTagName(v);
              }, E.prototype.isIgnoredEndTag = function() {
                var v = this.tagNameBuffer;
                return v === "title" && this.input.substring(this.index, this.index + 8) !== "</title>" || v === "style" && this.input.substring(this.index, this.index + 8) !== "</style>" || v === "script" && this.input.substring(this.index, this.index + 9) !== "</script>";
              }, E;
            }(), b = function() {
              function E(v, _) {
                _ === void 0 && (_ = {}), this.options = _, this.token = null, this.startLine = 1, this.startColumn = 0, this.tokens = [], this.tokenizer = new l(this, v, _.mode), this._currentAttribute = void 0;
              }
              return E.prototype.tokenize = function(v) {
                return this.tokens = [], this.tokenizer.tokenize(v), this.tokens;
              }, E.prototype.tokenizePart = function(v) {
                return this.tokens = [], this.tokenizer.tokenizePart(v), this.tokens;
              }, E.prototype.tokenizeEOF = function() {
                return this.tokens = [], this.tokenizer.tokenizeEOF(), this.tokens[0];
              }, E.prototype.reset = function() {
                this.token = null, this.startLine = 1, this.startColumn = 0;
              }, E.prototype.current = function() {
                var v = this.token;
                if (v === null) throw new Error("token was unexpectedly null");
                if (arguments.length === 0) return v;
                for (var _ = 0; _ < arguments.length; _++) if (v.type === arguments[_]) return v;
                throw new Error("token type was unexpectedly " + v.type);
              }, E.prototype.push = function(v) {
                this.token = v, this.tokens.push(v);
              }, E.prototype.currentAttribute = function() {
                return this._currentAttribute;
              }, E.prototype.addLocInfo = function() {
                this.options.loc && (this.current().loc = { start: { line: this.startLine, column: this.startColumn }, end: { line: this.tokenizer.line, column: this.tokenizer.column } }), this.startLine = this.tokenizer.line, this.startColumn = this.tokenizer.column;
              }, E.prototype.beginDoctype = function() {
                this.push({ type: "Doctype", name: "" });
              }, E.prototype.appendToDoctypeName = function(v) {
                this.current("Doctype").name += v;
              }, E.prototype.appendToDoctypePublicIdentifier = function(v) {
                var _ = this.current("Doctype");
                _.publicIdentifier === void 0 ? _.publicIdentifier = v : _.publicIdentifier += v;
              }, E.prototype.appendToDoctypeSystemIdentifier = function(v) {
                var _ = this.current("Doctype");
                _.systemIdentifier === void 0 ? _.systemIdentifier = v : _.systemIdentifier += v;
              }, E.prototype.endDoctype = function() {
                this.addLocInfo();
              }, E.prototype.beginData = function() {
                this.push({ type: "Chars", chars: "" });
              }, E.prototype.appendToData = function(v) {
                this.current("Chars").chars += v;
              }, E.prototype.finishData = function() {
                this.addLocInfo();
              }, E.prototype.beginComment = function() {
                this.push({ type: "Comment", chars: "" });
              }, E.prototype.appendToCommentData = function(v) {
                this.current("Comment").chars += v;
              }, E.prototype.finishComment = function() {
                this.addLocInfo();
              }, E.prototype.tagOpen = function() {
              }, E.prototype.beginStartTag = function() {
                this.push({ type: "StartTag", tagName: "", attributes: [], selfClosing: false });
              }, E.prototype.beginEndTag = function() {
                this.push({ type: "EndTag", tagName: "" });
              }, E.prototype.finishTag = function() {
                this.addLocInfo();
              }, E.prototype.markTagAsSelfClosing = function() {
                this.current("StartTag").selfClosing = true;
              }, E.prototype.appendToTagName = function(v) {
                this.current("StartTag", "EndTag").tagName += v;
              }, E.prototype.beginAttribute = function() {
                this._currentAttribute = ["", "", false];
              }, E.prototype.appendToAttributeName = function(v) {
                this.currentAttribute()[0] += v;
              }, E.prototype.beginAttributeValue = function(v) {
                this.currentAttribute()[2] = v;
              }, E.prototype.appendToAttributeValue = function(v) {
                this.currentAttribute()[1] += v;
              }, E.prototype.finishAttributeValue = function() {
                this.current("StartTag").attributes.push(this._currentAttribute);
              }, E.prototype.reportSyntaxError = function(v) {
                this.current().syntaxError = v;
              }, E;
            }();
            function P(E, v) {
              var _ = new b(new r(d), v);
              return _.tokenize(E);
            }
            h.HTML5NamedCharRefs = d, h.EntityParser = r, h.EventedTokenizer = l, h.Tokenizer = b, h.tokenize = P, Object.defineProperty(h, "__esModule", { value: true });
          });
        } }), We = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/generation/print.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.default = d;
          var f = h(Te());
          function h(c) {
            return c && c.__esModule ? c : { default: c };
          }
          function d(c) {
            let o = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : { entityEncoding: "transformed" };
            return c ? new f.default(o).print(c) : "";
          }
        } }), he = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/syntax-error.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.generateSyntaxError = f;
          function f(h, d) {
            let { module: c, loc: o } = d, { line: e, column: r } = o.start, s = d.asString(), p = s ? `

|
|  `.concat(s.split(`
`).join(`
|  `), `
|

`) : "", n = new Error("".concat(h, ": ").concat(p, "(error occurred in '").concat(c, "' @ line ").concat(e, " : column ").concat(r, ")"));
            return n.name = "SyntaxError", n.location = d, n.code = s, n;
          }
        } }), Rt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v1/visitor-keys.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.default = void 0;
          var f = X(), h = { Program: (0, f.tuple)("body"), Template: (0, f.tuple)("body"), Block: (0, f.tuple)("body"), MustacheStatement: (0, f.tuple)("path", "params", "hash"), BlockStatement: (0, f.tuple)("path", "params", "hash", "program", "inverse"), ElementModifierStatement: (0, f.tuple)("path", "params", "hash"), PartialStatement: (0, f.tuple)("name", "params", "hash"), CommentStatement: (0, f.tuple)(), MustacheCommentStatement: (0, f.tuple)(), ElementNode: (0, f.tuple)("attributes", "modifiers", "children", "comments"), AttrNode: (0, f.tuple)("value"), TextNode: (0, f.tuple)(), ConcatStatement: (0, f.tuple)("parts"), SubExpression: (0, f.tuple)("path", "params", "hash"), PathExpression: (0, f.tuple)(), PathHead: (0, f.tuple)(), StringLiteral: (0, f.tuple)(), BooleanLiteral: (0, f.tuple)(), NumberLiteral: (0, f.tuple)(), NullLiteral: (0, f.tuple)(), UndefinedLiteral: (0, f.tuple)(), Hash: (0, f.tuple)("pairs"), HashPair: (0, f.tuple)("value"), NamedBlock: (0, f.tuple)("attributes", "modifiers", "children", "comments"), SimpleElement: (0, f.tuple)("attributes", "modifiers", "children", "comments"), Component: (0, f.tuple)("head", "attributes", "modifiers", "children", "comments") }, d = h;
          t.default = d;
        } }), Ye = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/traversal/errors.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.cannotRemoveNode = d, t.cannotReplaceNode = c, t.cannotReplaceOrRemoveInKeyHandlerYet = o, t.default = void 0;
          var f = function() {
            e.prototype = Object.create(Error.prototype), e.prototype.constructor = e;
            function e(r, s, p, n) {
              let a = Error.call(this, r);
              this.key = n, this.message = r, this.node = s, this.parent = p, this.stack = a.stack;
            }
            return e;
          }(), h = f;
          t.default = h;
          function d(e, r, s) {
            return new f("Cannot remove a node unless it is part of an array", e, r, s);
          }
          function c(e, r, s) {
            return new f("Cannot replace a node with multiple nodes unless it is part of an array", e, r, s);
          }
          function o(e, r) {
            return new f("Replacing and removing in key handlers is not yet supported.", e, null, r);
          }
        } }), Qe = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/traversal/path.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.default = void 0;
          var f = class {
            constructor(d) {
              let c = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, o = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
              this.node = d, this.parent = c, this.parentKey = o;
            }
            get parentNode() {
              return this.parent ? this.parent.node : null;
            }
            parents() {
              return { [Symbol.iterator]: () => new h(this) };
            }
          };
          t.default = f;
          var h = class {
            constructor(d) {
              this.path = d;
            }
            next() {
              return this.path.parent ? (this.path = this.path.parent, { done: false, value: this.path }) : { done: true, value: null };
            }
          };
        } }), Ne = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/traversal/traverse.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.default = E;
          var f = X(), h = o(Rt()), d = Ye(), c = o(Qe());
          function o(v) {
            return v && v.__esModule ? v : { default: v };
          }
          function e(v) {
            return typeof v == "function" ? v : v.enter;
          }
          function r(v) {
            if (typeof v != "function") return v.exit;
          }
          function s(v, _) {
            let y = typeof v != "function" ? v.keys : void 0;
            if (y === void 0) return;
            let g = y[_];
            return g !== void 0 ? g : y.All;
          }
          function p(v, _) {
            if ((_ === "Template" || _ === "Block") && v.Program) return v.Program;
            let y = v[_];
            return y !== void 0 ? y : v.All;
          }
          function n(v, _) {
            let { node: y, parent: g, parentKey: L } = _, j = p(v, y.type), x, w;
            j !== void 0 && (x = e(j), w = r(j));
            let H;
            if (x !== void 0 && (H = x(y, _)), H != null) if (JSON.stringify(y) === JSON.stringify(H)) H = void 0;
            else {
              if (Array.isArray(H)) return l(v, H, g, L), H;
              {
                let m = new c.default(H, g, L);
                return n(v, m) || H;
              }
            }
            if (H === void 0) {
              let m = h.default[y.type];
              for (let C = 0; C < m.length; C++) {
                let S = m[C];
                i(v, j, _, S);
              }
              w !== void 0 && (H = w(y, _));
            }
            return H;
          }
          function a(v, _) {
            return v[_];
          }
          function u(v, _, y) {
            v[_] = y;
          }
          function i(v, _, y, g) {
            let { node: L } = y, j = a(L, g);
            if (!j) return;
            let x, w;
            if (_ !== void 0) {
              let H = s(_, g);
              H !== void 0 && (x = e(H), w = r(H));
            }
            if (x !== void 0 && x(L, g) !== void 0) throw (0, d.cannotReplaceOrRemoveInKeyHandlerYet)(L, g);
            if (Array.isArray(j)) l(v, j, y, g);
            else {
              let H = new c.default(j, y, g), m = n(v, H);
              m !== void 0 && b(L, g, j, m);
            }
            if (w !== void 0 && w(L, g) !== void 0) throw (0, d.cannotReplaceOrRemoveInKeyHandlerYet)(L, g);
          }
          function l(v, _, y, g) {
            for (let L = 0; L < _.length; L++) {
              let j = _[L], x = new c.default(j, y, g), w = n(v, x);
              w !== void 0 && (L += P(_, L, w) - 1);
            }
          }
          function b(v, _, y, g) {
            if (g === null) throw (0, d.cannotRemoveNode)(y, v, _);
            if (Array.isArray(g)) if (g.length === 1) u(v, _, g[0]);
            else throw g.length === 0 ? (0, d.cannotRemoveNode)(y, v, _) : (0, d.cannotReplaceNode)(y, v, _);
            else u(v, _, g);
          }
          function P(v, _, y) {
            return y === null ? (v.splice(_, 1), 0) : Array.isArray(y) ? (v.splice(_, 1, ...y), y.length) : (v.splice(_, 1, y), 1);
          }
          function E(v, _) {
            let y = new c.default(v);
            n(_, y);
          }
        } }), Je = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/traversal/walker.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.default = void 0;
          var f = class {
            constructor(d) {
              this.order = d, this.stack = [];
            }
            visit(d, c) {
              !d || (this.stack.push(d), this.order === "post" ? (this.children(d, c), c(d, this)) : (c(d, this), this.children(d, c)), this.stack.pop());
            }
            children(d, c) {
              switch (d.type) {
                case "Block":
                case "Template":
                  return h.Program(this, d, c);
                case "ElementNode":
                  return h.ElementNode(this, d, c);
                case "BlockStatement":
                  return h.BlockStatement(this, d, c);
                default:
                  return;
              }
            }
          };
          t.default = f;
          var h = { Program(d, c, o) {
            for (let e = 0; e < c.body.length; e++) d.visit(c.body[e], o);
          }, Template(d, c, o) {
            for (let e = 0; e < c.body.length; e++) d.visit(c.body[e], o);
          }, Block(d, c, o) {
            for (let e = 0; e < c.body.length; e++) d.visit(c.body[e], o);
          }, ElementNode(d, c, o) {
            for (let e = 0; e < c.children.length; e++) d.visit(c.children[e], o);
          }, BlockStatement(d, c, o) {
            d.visit(c.program, o), d.visit(c.inverse || null, o);
          } };
        } }), ye = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/utils.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.parseElementBlockParams = d, t.childrenFor = o, t.appendChild = e, t.isHBSLiteral = r, t.printLiteral = s, t.isUpperCase = p, t.isLowerCase = n;
          var f = he(), h = /[!"#%-,\.\/;->@\[-\^`\{-~]/;
          function d(a) {
            let u = c(a);
            u && (a.blockParams = u);
          }
          function c(a) {
            let u = a.attributes.length, i = [];
            for (let b = 0; b < u; b++) i.push(a.attributes[b].name);
            let l = i.indexOf("as");
            if (l === -1 && i.length > 0 && i[i.length - 1].charAt(0) === "|") throw (0, f.generateSyntaxError)("Block parameters must be preceded by the `as` keyword, detected block parameters without `as`", a.loc);
            if (l !== -1 && u > l && i[l + 1].charAt(0) === "|") {
              let b = i.slice(l).join(" ");
              if (b.charAt(b.length - 1) !== "|" || b.match(/\|/g).length !== 2) throw (0, f.generateSyntaxError)("Invalid block parameters syntax, '" + b + "'", a.loc);
              let P = [];
              for (let E = l + 1; E < u; E++) {
                let v = i[E].replace(/\|/g, "");
                if (v !== "") {
                  if (h.test(v)) throw (0, f.generateSyntaxError)("Invalid identifier for block parameters, '" + v + "'", a.loc);
                  P.push(v);
                }
              }
              if (P.length === 0) throw (0, f.generateSyntaxError)("Cannot use zero block parameters", a.loc);
              return a.attributes = a.attributes.slice(0, l), P;
            }
            return null;
          }
          function o(a) {
            switch (a.type) {
              case "Block":
              case "Template":
                return a.body;
              case "ElementNode":
                return a.children;
            }
          }
          function e(a, u) {
            o(a).push(u);
          }
          function r(a) {
            return a.type === "StringLiteral" || a.type === "BooleanLiteral" || a.type === "NumberLiteral" || a.type === "NullLiteral" || a.type === "UndefinedLiteral";
          }
          function s(a) {
            return a.type === "UndefinedLiteral" ? "undefined" : JSON.stringify(a.value);
          }
          function p(a) {
            return a[0] === a[0].toUpperCase() && a[0] !== a[0].toLowerCase();
          }
          function n(a) {
            return a[0] === a[0].toLowerCase() && a[0] !== a[0].toUpperCase();
          }
        } }), Le = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v1/parser-builders.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.default = void 0;
          var f = X(), h = we(), d = { close: false, open: false }, c = class {
            pos(r, s) {
              return { line: r, column: s };
            }
            blockItself(r) {
              let { body: s, blockParams: p, chained: n = false, loc: a } = r;
              return { type: "Block", body: s || [], blockParams: p || [], chained: n, loc: a };
            }
            template(r) {
              let { body: s, blockParams: p, loc: n } = r;
              return { type: "Template", body: s || [], blockParams: p || [], loc: n };
            }
            mustache(r) {
              let { path: s, params: p, hash: n, trusting: a, loc: u, strip: i = d } = r;
              return { type: "MustacheStatement", path: s, params: p, hash: n, escaped: !a, trusting: a, loc: u, strip: i || { open: false, close: false } };
            }
            block(r) {
              let { path: s, params: p, hash: n, defaultBlock: a, elseBlock: u = null, loc: i, openStrip: l = d, inverseStrip: b = d, closeStrip: P = d } = r;
              return { type: "BlockStatement", path: s, params: p, hash: n, program: a, inverse: u, loc: i, openStrip: l, inverseStrip: b, closeStrip: P };
            }
            comment(r, s) {
              return { type: "CommentStatement", value: r, loc: s };
            }
            mustacheComment(r, s) {
              return { type: "MustacheCommentStatement", value: r, loc: s };
            }
            concat(r, s) {
              return { type: "ConcatStatement", parts: r, loc: s };
            }
            element(r) {
              let { tag: s, selfClosing: p, attrs: n, blockParams: a, modifiers: u, comments: i, children: l, loc: b } = r;
              return { type: "ElementNode", tag: s, selfClosing: p, attributes: n || [], blockParams: a || [], modifiers: u || [], comments: i || [], children: l || [], loc: b };
            }
            elementModifier(r) {
              let { path: s, params: p, hash: n, loc: a } = r;
              return { type: "ElementModifierStatement", path: s, params: p, hash: n, loc: a };
            }
            attr(r) {
              let { name: s, value: p, loc: n } = r;
              return { type: "AttrNode", name: s, value: p, loc: n };
            }
            text(r) {
              let { chars: s, loc: p } = r;
              return { type: "TextNode", chars: s, loc: p };
            }
            sexpr(r) {
              let { path: s, params: p, hash: n, loc: a } = r;
              return { type: "SubExpression", path: s, params: p, hash: n, loc: a };
            }
            path(r) {
              let { head: s, tail: p, loc: n } = r, { original: a } = o(s), u = [...a, ...p].join(".");
              return new h.PathExpressionImplV1(u, s, p, n);
            }
            head(r, s) {
              return r[0] === "@" ? this.atName(r, s) : r === "this" ? this.this(s) : this.var(r, s);
            }
            this(r) {
              return { type: "ThisHead", loc: r };
            }
            atName(r, s) {
              return { type: "AtHead", name: r, loc: s };
            }
            var(r, s) {
              return { type: "VarHead", name: r, loc: s };
            }
            hash(r, s) {
              return { type: "Hash", pairs: r || [], loc: s };
            }
            pair(r) {
              let { key: s, value: p, loc: n } = r;
              return { type: "HashPair", key: s, value: p, loc: n };
            }
            literal(r) {
              let { type: s, value: p, loc: n } = r;
              return { type: s, value: p, original: p, loc: n };
            }
            undefined() {
              return this.literal({ type: "UndefinedLiteral", value: void 0 });
            }
            null() {
              return this.literal({ type: "NullLiteral", value: null });
            }
            string(r, s) {
              return this.literal({ type: "StringLiteral", value: r, loc: s });
            }
            boolean(r, s) {
              return this.literal({ type: "BooleanLiteral", value: r, loc: s });
            }
            number(r, s) {
              return this.literal({ type: "NumberLiteral", value: r, loc: s });
            }
          };
          function o(r) {
            switch (r.type) {
              case "AtHead":
                return { original: r.name, parts: [r.name] };
              case "ThisHead":
                return { original: "this", parts: [] };
              case "VarHead":
                return { original: r.name, parts: [r.name] };
            }
          }
          var e = new c();
          t.default = e;
        } }), qt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/parser.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.Parser = void 0;
          var f = X(), h = Ke(), d = class {
            constructor(c) {
              let o = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : new h.EntityParser(h.HTML5NamedCharRefs), e = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : "precompile";
              this.elementStack = [], this.currentAttribute = null, this.currentNode = null, this.source = c, this.lines = c.source.split(/(?:\r\n?|\n)/g), this.tokenizer = new h.EventedTokenizer(this, o, e);
            }
            offset() {
              let { line: c, column: o } = this.tokenizer;
              return this.source.offsetFor(c, o);
            }
            pos(c) {
              let { line: o, column: e } = c;
              return this.source.offsetFor(o, e);
            }
            finish(c) {
              return (0, f.assign)({}, c, { loc: c.loc.until(this.offset()) });
            }
            get currentAttr() {
              return this.currentAttribute;
            }
            get currentTag() {
              return this.currentNode;
            }
            get currentStartTag() {
              return this.currentNode;
            }
            get currentEndTag() {
              return this.currentNode;
            }
            get currentComment() {
              return this.currentNode;
            }
            get currentData() {
              return this.currentNode;
            }
            acceptTemplate(c) {
              return this[c.type](c);
            }
            acceptNode(c) {
              return this[c.type](c);
            }
            currentElement() {
              return this.elementStack[this.elementStack.length - 1];
            }
            sourceForNode(c, o) {
              let e = c.loc.start.line - 1, r = e - 1, s = c.loc.start.column, p = [], n, a, u;
              for (o ? (a = o.loc.end.line - 1, u = o.loc.end.column) : (a = c.loc.end.line - 1, u = c.loc.end.column); r < a; ) r++, n = this.lines[r], r === e ? e === a ? p.push(n.slice(s, u)) : p.push(n.slice(s)) : r === a ? p.push(n.slice(0, u)) : p.push(n);
              return p.join(`
`);
            }
          };
          t.Parser = d;
        } }), xt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/parser/handlebars-node-visitors.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.HandlebarsNodeVisitors = void 0;
          var f = qt(), h = ge(), d = he(), c = ye(), o = we(), e = r(Le());
          function r(i) {
            return i && i.__esModule ? i : { default: i };
          }
          var s = class extends f.Parser {
            get isTopLevel() {
              return this.elementStack.length === 0;
            }
            Program(i) {
              let l = [], b;
              this.isTopLevel ? b = e.default.template({ body: l, blockParams: i.blockParams, loc: this.source.spanFor(i.loc) }) : b = e.default.blockItself({ body: l, blockParams: i.blockParams, chained: i.chained, loc: this.source.spanFor(i.loc) });
              let P, E = i.body.length;
              if (this.elementStack.push(b), E === 0) return this.elementStack.pop();
              for (P = 0; P < E; P++) this.acceptNode(i.body[P]);
              let v = this.elementStack.pop();
              if (v !== b) {
                let _ = v;
                throw (0, d.generateSyntaxError)("Unclosed element `".concat(_.tag, "`"), _.loc);
              }
              return b;
            }
            BlockStatement(i) {
              if (this.tokenizer.state === "comment") {
                this.appendToCommentData(this.sourceForNode(i));
                return;
              }
              if (this.tokenizer.state !== "data" && this.tokenizer.state !== "beforeData") throw (0, d.generateSyntaxError)("A block may only be used inside an HTML element or another block.", this.source.spanFor(i.loc));
              let { path: l, params: b, hash: P } = a(this, i);
              i.program.loc || (i.program.loc = h.NON_EXISTENT_LOCATION), i.inverse && !i.inverse.loc && (i.inverse.loc = h.NON_EXISTENT_LOCATION);
              let E = this.Program(i.program), v = i.inverse ? this.Program(i.inverse) : null, _ = e.default.block({ path: l, params: b, hash: P, defaultBlock: E, elseBlock: v, loc: this.source.spanFor(i.loc), openStrip: i.openStrip, inverseStrip: i.inverseStrip, closeStrip: i.closeStrip }), y = this.currentElement();
              (0, c.appendChild)(y, _);
            }
            MustacheStatement(i) {
              let { tokenizer: l } = this;
              if (l.state === "comment") {
                this.appendToCommentData(this.sourceForNode(i));
                return;
              }
              let b, { escaped: P, loc: E, strip: v } = i;
              if ((0, c.isHBSLiteral)(i.path)) b = e.default.mustache({ path: this.acceptNode(i.path), params: [], hash: e.default.hash([], this.source.spanFor(i.path.loc).collapse("end")), trusting: !P, loc: this.source.spanFor(E), strip: v });
              else {
                let { path: _, params: y, hash: g } = a(this, i);
                b = e.default.mustache({ path: _, params: y, hash: g, trusting: !P, loc: this.source.spanFor(E), strip: v });
              }
              switch (l.state) {
                case "tagOpen":
                case "tagName":
                  throw (0, d.generateSyntaxError)("Cannot use mustaches in an elements tagname", b.loc);
                case "beforeAttributeName":
                  u(this.currentStartTag, b);
                  break;
                case "attributeName":
                case "afterAttributeName":
                  this.beginAttributeValue(false), this.finishAttributeValue(), u(this.currentStartTag, b), l.transitionTo("beforeAttributeName");
                  break;
                case "afterAttributeValueQuoted":
                  u(this.currentStartTag, b), l.transitionTo("beforeAttributeName");
                  break;
                case "beforeAttributeValue":
                  this.beginAttributeValue(false), this.appendDynamicAttributeValuePart(b), l.transitionTo("attributeValueUnquoted");
                  break;
                case "attributeValueDoubleQuoted":
                case "attributeValueSingleQuoted":
                case "attributeValueUnquoted":
                  this.appendDynamicAttributeValuePart(b);
                  break;
                default:
                  (0, c.appendChild)(this.currentElement(), b);
              }
              return b;
            }
            appendDynamicAttributeValuePart(i) {
              this.finalizeTextPart();
              let l = this.currentAttr;
              l.isDynamic = true, l.parts.push(i);
            }
            finalizeTextPart() {
              let l = this.currentAttr.currentPart;
              l !== null && (this.currentAttr.parts.push(l), this.startTextPart());
            }
            startTextPart() {
              this.currentAttr.currentPart = null;
            }
            ContentStatement(i) {
              n(this.tokenizer, i), this.tokenizer.tokenizePart(i.value), this.tokenizer.flushData();
            }
            CommentStatement(i) {
              let { tokenizer: l } = this;
              if (l.state === "comment") return this.appendToCommentData(this.sourceForNode(i)), null;
              let { value: b, loc: P } = i, E = e.default.mustacheComment(b, this.source.spanFor(P));
              switch (l.state) {
                case "beforeAttributeName":
                case "afterAttributeName":
                  this.currentStartTag.comments.push(E);
                  break;
                case "beforeData":
                case "data":
                  (0, c.appendChild)(this.currentElement(), E);
                  break;
                default:
                  throw (0, d.generateSyntaxError)("Using a Handlebars comment when in the `".concat(l.state, "` state is not supported"), this.source.spanFor(i.loc));
              }
              return E;
            }
            PartialStatement(i) {
              throw (0, d.generateSyntaxError)("Handlebars partials are not supported", this.source.spanFor(i.loc));
            }
            PartialBlockStatement(i) {
              throw (0, d.generateSyntaxError)("Handlebars partial blocks are not supported", this.source.spanFor(i.loc));
            }
            Decorator(i) {
              throw (0, d.generateSyntaxError)("Handlebars decorators are not supported", this.source.spanFor(i.loc));
            }
            DecoratorBlock(i) {
              throw (0, d.generateSyntaxError)("Handlebars decorator blocks are not supported", this.source.spanFor(i.loc));
            }
            SubExpression(i) {
              let { path: l, params: b, hash: P } = a(this, i);
              return e.default.sexpr({ path: l, params: b, hash: P, loc: this.source.spanFor(i.loc) });
            }
            PathExpression(i) {
              let { original: l } = i, b;
              if (l.indexOf("/") !== -1) {
                if (l.slice(0, 2) === "./") throw (0, d.generateSyntaxError)('Using "./" is not supported in Glimmer and unnecessary', this.source.spanFor(i.loc));
                if (l.slice(0, 3) === "../") throw (0, d.generateSyntaxError)('Changing context using "../" is not supported in Glimmer', this.source.spanFor(i.loc));
                if (l.indexOf(".") !== -1) throw (0, d.generateSyntaxError)("Mixing '.' and '/' in paths is not supported in Glimmer; use only '.' to separate property paths", this.source.spanFor(i.loc));
                b = [i.parts.join("/")];
              } else {
                if (l === ".") throw (0, d.generateSyntaxError)("'.' is not a supported path in Glimmer; check for a path with a trailing '.'", this.source.spanFor(i.loc));
                b = i.parts;
              }
              let P = false;
              l.match(/^this(\..+)?$/) && (P = true);
              let E;
              if (P) E = { type: "ThisHead", loc: { start: i.loc.start, end: { line: i.loc.start.line, column: i.loc.start.column + 4 } } };
              else if (i.data) {
                let v = b.shift();
                if (v === void 0) throw (0, d.generateSyntaxError)("Attempted to parse a path expression, but it was not valid. Paths beginning with @ must start with a-z.", this.source.spanFor(i.loc));
                E = { type: "AtHead", name: "@".concat(v), loc: { start: i.loc.start, end: { line: i.loc.start.line, column: i.loc.start.column + v.length + 1 } } };
              } else {
                let v = b.shift();
                if (v === void 0) throw (0, d.generateSyntaxError)("Attempted to parse a path expression, but it was not valid. Paths must start with a-z or A-Z.", this.source.spanFor(i.loc));
                E = { type: "VarHead", name: v, loc: { start: i.loc.start, end: { line: i.loc.start.line, column: i.loc.start.column + v.length } } };
              }
              return new o.PathExpressionImplV1(i.original, E, b, this.source.spanFor(i.loc));
            }
            Hash(i) {
              let l = [];
              for (let b = 0; b < i.pairs.length; b++) {
                let P = i.pairs[b];
                l.push(e.default.pair({ key: P.key, value: this.acceptNode(P.value), loc: this.source.spanFor(P.loc) }));
              }
              return e.default.hash(l, this.source.spanFor(i.loc));
            }
            StringLiteral(i) {
              return e.default.literal({ type: "StringLiteral", value: i.value, loc: i.loc });
            }
            BooleanLiteral(i) {
              return e.default.literal({ type: "BooleanLiteral", value: i.value, loc: i.loc });
            }
            NumberLiteral(i) {
              return e.default.literal({ type: "NumberLiteral", value: i.value, loc: i.loc });
            }
            UndefinedLiteral(i) {
              return e.default.literal({ type: "UndefinedLiteral", value: void 0, loc: i.loc });
            }
            NullLiteral(i) {
              return e.default.literal({ type: "NullLiteral", value: null, loc: i.loc });
            }
          };
          t.HandlebarsNodeVisitors = s;
          function p(i, l) {
            if (l === "") return { lines: i.split(`
`).length - 1, columns: 0 };
            let P = i.split(l)[0].split(/\n/), E = P.length - 1;
            return { lines: E, columns: P[E].length };
          }
          function n(i, l) {
            let b = l.loc.start.line, P = l.loc.start.column, E = p(l.original, l.value);
            b = b + E.lines, E.lines ? P = E.columns : P = P + E.columns, i.line = b, i.column = P;
          }
          function a(i, l) {
            if (l.path.type.endsWith("Literal")) {
              let _ = l.path, y = "";
              throw _.type === "BooleanLiteral" ? y = _.original.toString() : _.type === "StringLiteral" ? y = '"'.concat(_.original, '"') : _.type === "NullLiteral" ? y = "null" : _.type === "NumberLiteral" ? y = _.value.toString() : y = "undefined", (0, d.generateSyntaxError)("".concat(_.type, ' "').concat(_.type === "StringLiteral" ? _.original : y, '" cannot be called as a sub-expression, replace (').concat(y, ") with ").concat(y), i.source.spanFor(_.loc));
            }
            let b = l.path.type === "PathExpression" ? i.PathExpression(l.path) : i.SubExpression(l.path), P = l.params ? l.params.map((_) => i.acceptNode(_)) : [], E = P.length > 0 ? P[P.length - 1].loc : b.loc, v = l.hash ? i.Hash(l.hash) : { type: "Hash", pairs: [], loc: i.source.spanFor(E).collapse("end") };
            return { path: b, params: P, hash: v };
          }
          function u(i, l) {
            let { path: b, params: P, hash: E, loc: v } = l;
            if ((0, c.isHBSLiteral)(b)) {
              let y = "{{".concat((0, c.printLiteral)(b), "}}"), g = "<".concat(i.name, " ... ").concat(y, " ...");
              throw (0, d.generateSyntaxError)("In ".concat(g, ", ").concat(y, " is not a valid modifier"), l.loc);
            }
            let _ = e.default.elementModifier({ path: b, params: P, hash: E, loc: v });
            i.modifiers.push(_);
          }
        } }), Fe = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/parser/tokenizer-event-handlers.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.preprocess = _, t.TokenizerEventHandlers = void 0;
          var f = X(), h = It(), d = Ke(), c = b(We()), o = Te(), e = De(), r = ue(), s = he(), p = b(Ne()), n = b(Je()), a = ye(), u = b(Le()), i = b(ke()), l = xt();
          function b(y) {
            return y && y.__esModule ? y : { default: y };
          }
          var P = class extends l.HandlebarsNodeVisitors {
            constructor() {
              super(...arguments), this.tagOpenLine = 0, this.tagOpenColumn = 0;
            }
            reset() {
              this.currentNode = null;
            }
            beginComment() {
              this.currentNode = u.default.comment("", this.source.offsetFor(this.tagOpenLine, this.tagOpenColumn));
            }
            appendToCommentData(y) {
              this.currentComment.value += y;
            }
            finishComment() {
              (0, a.appendChild)(this.currentElement(), this.finish(this.currentComment));
            }
            beginData() {
              this.currentNode = u.default.text({ chars: "", loc: this.offset().collapsed() });
            }
            appendToData(y) {
              this.currentData.chars += y;
            }
            finishData() {
              this.currentData.loc = this.currentData.loc.withEnd(this.offset()), (0, a.appendChild)(this.currentElement(), this.currentData);
            }
            tagOpen() {
              this.tagOpenLine = this.tokenizer.line, this.tagOpenColumn = this.tokenizer.column;
            }
            beginStartTag() {
              this.currentNode = { type: "StartTag", name: "", attributes: [], modifiers: [], comments: [], selfClosing: false, loc: this.source.offsetFor(this.tagOpenLine, this.tagOpenColumn) };
            }
            beginEndTag() {
              this.currentNode = { type: "EndTag", name: "", attributes: [], modifiers: [], comments: [], selfClosing: false, loc: this.source.offsetFor(this.tagOpenLine, this.tagOpenColumn) };
            }
            finishTag() {
              let y = this.finish(this.currentTag);
              if (y.type === "StartTag") {
                if (this.finishStartTag(), y.name === ":") throw (0, s.generateSyntaxError)("Invalid named block named detected, you may have created a named block without a name, or you may have began your name with a number. Named blocks must have names that are at least one character long, and begin with a lower case letter", this.source.spanFor({ start: this.currentTag.loc.toJSON(), end: this.offset().toJSON() }));
                (o.voidMap[y.name] || y.selfClosing) && this.finishEndTag(true);
              } else y.type === "EndTag" && this.finishEndTag(false);
            }
            finishStartTag() {
              let { name: y, attributes: g, modifiers: L, comments: j, selfClosing: x, loc: w } = this.finish(this.currentStartTag), H = u.default.element({ tag: y, selfClosing: x, attrs: g, modifiers: L, comments: j, children: [], blockParams: [], loc: w });
              this.elementStack.push(H);
            }
            finishEndTag(y) {
              let g = this.finish(this.currentTag), L = this.elementStack.pop(), j = this.currentElement();
              this.validateEndTag(g, L, y), L.loc = L.loc.withEnd(this.offset()), (0, a.parseElementBlockParams)(L), (0, a.appendChild)(j, L);
            }
            markTagAsSelfClosing() {
              this.currentTag.selfClosing = true;
            }
            appendToTagName(y) {
              this.currentTag.name += y;
            }
            beginAttribute() {
              let y = this.offset();
              this.currentAttribute = { name: "", parts: [], currentPart: null, isQuoted: false, isDynamic: false, start: y, valueSpan: y.collapsed() };
            }
            appendToAttributeName(y) {
              this.currentAttr.name += y;
            }
            beginAttributeValue(y) {
              this.currentAttr.isQuoted = y, this.startTextPart(), this.currentAttr.valueSpan = this.offset().collapsed();
            }
            appendToAttributeValue(y) {
              let g = this.currentAttr.parts, L = g[g.length - 1], j = this.currentAttr.currentPart;
              if (j) j.chars += y, j.loc = j.loc.withEnd(this.offset());
              else {
                let x = this.offset();
                y === `
` ? x = L ? L.loc.getEnd() : this.currentAttr.valueSpan.getStart() : x = x.move(-1), this.currentAttr.currentPart = u.default.text({ chars: y, loc: x.collapsed() });
              }
            }
            finishAttributeValue() {
              this.finalizeTextPart();
              let y = this.currentTag, g = this.offset();
              if (y.type === "EndTag") throw (0, s.generateSyntaxError)("Invalid end tag: closing tag must not have attributes", this.source.spanFor({ start: y.loc.toJSON(), end: g.toJSON() }));
              let { name: L, parts: j, start: x, isQuoted: w, isDynamic: H, valueSpan: m } = this.currentAttr, C = this.assembleAttributeValue(j, w, H, x.until(g));
              C.loc = m.withEnd(g);
              let S = u.default.attr({ name: L, value: C, loc: x.until(g) });
              this.currentStartTag.attributes.push(S);
            }
            reportSyntaxError(y) {
              throw (0, s.generateSyntaxError)(y, this.offset().collapsed());
            }
            assembleConcatenatedValue(y) {
              for (let j = 0; j < y.length; j++) {
                let x = y[j];
                if (x.type !== "MustacheStatement" && x.type !== "TextNode") throw (0, s.generateSyntaxError)("Unsupported node in quoted attribute value: " + x.type, x.loc);
              }
              (0, f.assertPresent)(y, "the concatenation parts of an element should not be empty");
              let g = y[0], L = y[y.length - 1];
              return u.default.concat(y, this.source.spanFor(g.loc).extend(this.source.spanFor(L.loc)));
            }
            validateEndTag(y, g, L) {
              let j;
              if (o.voidMap[y.name] && !L ? j = "<".concat(y.name, "> elements do not need end tags. You should remove it") : g.tag === void 0 ? j = "Closing tag </".concat(y.name, "> without an open tag") : g.tag !== y.name && (j = "Closing tag </".concat(y.name, "> did not match last open tag <").concat(g.tag, "> (on line ").concat(g.loc.startPosition.line, ")")), j) throw (0, s.generateSyntaxError)(j, y.loc);
            }
            assembleAttributeValue(y, g, L, j) {
              if (L) {
                if (g) return this.assembleConcatenatedValue(y);
                if (y.length === 1 || y.length === 2 && y[1].type === "TextNode" && y[1].chars === "/") return y[0];
                throw (0, s.generateSyntaxError)("An unquoted attribute value must be a string or a mustache, preceded by whitespace or a '=' character, and followed by whitespace, a '>' character, or '/>'", j);
              } else return y.length > 0 ? y[0] : u.default.text({ chars: "", loc: j });
            }
          };
          t.TokenizerEventHandlers = P;
          var E = { parse: _, builders: i.default, print: c.default, traverse: p.default, Walker: n.default }, v = class extends d.EntityParser {
            constructor() {
              super({});
            }
            parse() {
            }
          };
          function _(y) {
            let g = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
            var L, j, x;
            let w = g.mode || "precompile", H, m;
            typeof y == "string" ? (H = new e.Source(y, (L = g.meta) === null || L === void 0 ? void 0 : L.moduleName), w === "codemod" ? m = (0, h.parseWithoutProcessing)(y, g.parseOptions) : m = (0, h.parse)(y, g.parseOptions)) : y instanceof e.Source ? (H = y, w === "codemod" ? m = (0, h.parseWithoutProcessing)(y.source, g.parseOptions) : m = (0, h.parse)(y.source, g.parseOptions)) : (H = new e.Source("", (j = g.meta) === null || j === void 0 ? void 0 : j.moduleName), m = y);
            let C;
            w === "codemod" && (C = new v());
            let S = r.SourceSpan.forCharPositions(H, 0, H.source.length);
            m.loc = { source: "(program)", start: S.startPosition, end: S.endPosition };
            let R = new P(H, C, w).acceptTemplate(m);
            if (g.strictMode && (R.blockParams = (x = g.locals) !== null && x !== void 0 ? x : []), g && g.plugins && g.plugins.ast) for (let M = 0, V = g.plugins.ast.length; M < V; M++) {
              let G = g.plugins.ast[M], K = (0, f.assign)({}, g, { syntax: E }, { plugins: void 0 }), U = G(K);
              (0, p.default)(R, U.visitor);
            }
            return R;
          }
        } }), Xe = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/symbol-table.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.BlockSymbolTable = t.ProgramSymbolTable = t.SymbolTable = void 0;
          var f = X(), h = ye(), d = class {
            static top(e, r) {
              return new c(e, r);
            }
            child(e) {
              let r = e.map((s) => this.allocate(s));
              return new o(this, e, r);
            }
          };
          t.SymbolTable = d;
          var c = class extends d {
            constructor(e, r) {
              super(), this.templateLocals = e, this.customizeComponentName = r, this.symbols = [], this.upvars = [], this.size = 1, this.named = (0, f.dict)(), this.blocks = (0, f.dict)(), this.usedTemplateLocals = [], this._hasEval = false;
            }
            getUsedTemplateLocals() {
              return this.usedTemplateLocals;
            }
            setHasEval() {
              this._hasEval = true;
            }
            get hasEval() {
              return this._hasEval;
            }
            has(e) {
              return this.templateLocals.indexOf(e) !== -1;
            }
            get(e) {
              let r = this.usedTemplateLocals.indexOf(e);
              return r !== -1 ? [r, true] : (r = this.usedTemplateLocals.length, this.usedTemplateLocals.push(e), [r, true]);
            }
            getLocalsMap() {
              return (0, f.dict)();
            }
            getEvalInfo() {
              let e = this.getLocalsMap();
              return Object.keys(e).map((r) => e[r]);
            }
            allocateFree(e, r) {
              r.resolution() === 39 && r.isAngleBracket && (0, h.isUpperCase)(e) && (e = this.customizeComponentName(e));
              let s = this.upvars.indexOf(e);
              return s !== -1 || (s = this.upvars.length, this.upvars.push(e)), s;
            }
            allocateNamed(e) {
              let r = this.named[e];
              return r || (r = this.named[e] = this.allocate(e)), r;
            }
            allocateBlock(e) {
              e === "inverse" && (e = "else");
              let r = this.blocks[e];
              return r || (r = this.blocks[e] = this.allocate("&".concat(e))), r;
            }
            allocate(e) {
              return this.symbols.push(e), this.size++;
            }
          };
          t.ProgramSymbolTable = c;
          var o = class extends d {
            constructor(e, r, s) {
              super(), this.parent = e, this.symbols = r, this.slots = s;
            }
            get locals() {
              return this.symbols;
            }
            has(e) {
              return this.symbols.indexOf(e) !== -1 || this.parent.has(e);
            }
            get(e) {
              let r = this.symbols.indexOf(e);
              return r === -1 ? this.parent.get(e) : [this.slots[r], false];
            }
            getLocalsMap() {
              let e = this.parent.getLocalsMap();
              return this.symbols.forEach((r) => e[r] = this.get(r)[0]), e;
            }
            getEvalInfo() {
              let e = this.getLocalsMap();
              return Object.keys(e).map((r) => e[r]);
            }
            setHasEval() {
              this.parent.setHasEval();
            }
            allocateFree(e, r) {
              return this.parent.allocateFree(e, r);
            }
            allocateNamed(e) {
              return this.parent.allocateNamed(e);
            }
            allocateBlock(e) {
              return this.parent.allocateBlock(e);
            }
            allocate(e) {
              return this.parent.allocate(e);
            }
          };
          t.BlockSymbolTable = o;
        } }), jt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/builders.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.BuildElement = t.Builder = void 0;
          var f = X(), h = le(), d = ce(), c = e(ve());
          function o() {
            if (typeof WeakMap != "function") return null;
            var n = /* @__PURE__ */ new WeakMap();
            return o = function() {
              return n;
            }, n;
          }
          function e(n) {
            if (n && n.__esModule) return n;
            if (n === null || typeof n != "object" && typeof n != "function") return { default: n };
            var a = o();
            if (a && a.has(n)) return a.get(n);
            var u = {}, i = Object.defineProperty && Object.getOwnPropertyDescriptor;
            for (var l in n) if (Object.prototype.hasOwnProperty.call(n, l)) {
              var b = i ? Object.getOwnPropertyDescriptor(n, l) : null;
              b && (b.get || b.set) ? Object.defineProperty(u, l, b) : u[l] = n[l];
            }
            return u.default = n, a && a.set(n, u), u;
          }
          var r = function(n, a) {
            var u = {};
            for (var i in n) Object.prototype.hasOwnProperty.call(n, i) && a.indexOf(i) < 0 && (u[i] = n[i]);
            if (n != null && typeof Object.getOwnPropertySymbols == "function") for (var l = 0, i = Object.getOwnPropertySymbols(n); l < i.length; l++) a.indexOf(i[l]) < 0 && Object.prototype.propertyIsEnumerable.call(n, i[l]) && (u[i[l]] = n[i[l]]);
            return u;
          }, s = class {
            template(n, a, u) {
              return new c.Template({ table: n, body: a, loc: u });
            }
            block(n, a, u) {
              return new c.Block({ scope: n, body: a, loc: u });
            }
            namedBlock(n, a, u) {
              return new c.NamedBlock({ name: n, block: a, attrs: [], componentArgs: [], modifiers: [], loc: u });
            }
            simpleNamedBlock(n, a, u) {
              return new p({ selfClosing: false, attrs: [], componentArgs: [], modifiers: [], comments: [] }).named(n, a, u);
            }
            slice(n, a) {
              return new h.SourceSlice({ loc: a, chars: n });
            }
            args(n, a, u) {
              return new c.Args({ loc: u, positional: n, named: a });
            }
            positional(n, a) {
              return new c.PositionalArguments({ loc: a, exprs: n });
            }
            namedArgument(n, a) {
              return new c.NamedArgument({ name: n, value: a });
            }
            named(n, a) {
              return new c.NamedArguments({ loc: a, entries: n });
            }
            attr(n, a) {
              let { name: u, value: i, trusting: l } = n;
              return new c.HtmlAttr({ loc: a, name: u, value: i, trusting: l });
            }
            splatAttr(n, a) {
              return new c.SplatAttr({ symbol: n, loc: a });
            }
            arg(n, a) {
              let { name: u, value: i, trusting: l } = n;
              return new c.ComponentArg({ name: u, value: i, trusting: l, loc: a });
            }
            path(n, a, u) {
              return new c.PathExpression({ loc: u, ref: n, tail: a });
            }
            self(n) {
              return new c.ThisReference({ loc: n });
            }
            at(n, a, u) {
              return new c.ArgReference({ loc: u, name: new h.SourceSlice({ loc: u, chars: n }), symbol: a });
            }
            freeVar(n) {
              let { name: a, context: u, symbol: i, loc: l } = n;
              return new c.FreeVarReference({ name: a, resolution: u, symbol: i, loc: l });
            }
            localVar(n, a, u, i) {
              return new c.LocalVarReference({ loc: i, name: n, isTemplateLocal: u, symbol: a });
            }
            sexp(n, a) {
              return new c.CallExpression({ loc: a, callee: n.callee, args: n.args });
            }
            deprecatedCall(n, a, u) {
              return new c.DeprecatedCallExpression({ loc: u, arg: n, callee: a });
            }
            interpolate(n, a) {
              return (0, f.assertPresent)(n), new c.InterpolateExpression({ loc: a, parts: n });
            }
            literal(n, a) {
              return new c.LiteralExpression({ loc: a, value: n });
            }
            append(n, a) {
              let { table: u, trusting: i, value: l } = n;
              return new c.AppendContent({ table: u, trusting: i, value: l, loc: a });
            }
            modifier(n, a) {
              let { callee: u, args: i } = n;
              return new c.ElementModifier({ loc: a, callee: u, args: i });
            }
            namedBlocks(n, a) {
              return new c.NamedBlocks({ loc: a, blocks: n });
            }
            blockStatement(n, a) {
              var { symbols: u, program: i, inverse: l = null } = n, b = r(n, ["symbols", "program", "inverse"]);
              let P = i.loc, E = [this.namedBlock(h.SourceSlice.synthetic("default"), i, i.loc)];
              return l && (P = P.extend(l.loc), E.push(this.namedBlock(h.SourceSlice.synthetic("else"), l, l.loc))), new c.InvokeBlock({ loc: a, blocks: this.namedBlocks(E, P), callee: b.callee, args: b.args });
            }
            element(n) {
              return new p(n);
            }
          };
          t.Builder = s;
          var p = class {
            constructor(n) {
              this.base = n, this.builder = new s();
            }
            simple(n, a, u) {
              return new c.SimpleElement((0, f.assign)({ tag: n, body: a, componentArgs: [], loc: u }, this.base));
            }
            named(n, a, u) {
              return new c.NamedBlock((0, f.assign)({ name: n, block: a, componentArgs: [], loc: u }, this.base));
            }
            selfClosingComponent(n, a) {
              return new c.InvokeComponent((0, f.assign)({ loc: a, callee: n, blocks: new c.NamedBlocks({ blocks: [], loc: a.sliceEndChars({ skipEnd: 1, chars: 1 }) }) }, this.base));
            }
            componentWithDefaultBlock(n, a, u, i) {
              let l = this.builder.block(u, a, i), b = this.builder.namedBlock(h.SourceSlice.synthetic("default"), l, i);
              return new c.InvokeComponent((0, f.assign)({ loc: i, callee: n, blocks: this.builder.namedBlocks([b], b.loc) }, this.base));
            }
            componentWithNamedBlocks(n, a, u) {
              return new c.InvokeComponent((0, f.assign)({ loc: u, callee: n, blocks: this.builder.namedBlocks(a, d.SpanList.range(a)) }, this.base));
            }
          };
          t.BuildElement = p;
        } }), Mt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/loose-resolution.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.SexpSyntaxContext = c, t.ModifierSyntaxContext = o, t.BlockSyntaxContext = e, t.ComponentSyntaxContext = r, t.AttrValueSyntaxContext = s, t.AppendSyntaxContext = p;
          var f = d(ve());
          function h() {
            if (typeof WeakMap != "function") return null;
            var i = /* @__PURE__ */ new WeakMap();
            return h = function() {
              return i;
            }, i;
          }
          function d(i) {
            if (i && i.__esModule) return i;
            if (i === null || typeof i != "object" && typeof i != "function") return { default: i };
            var l = h();
            if (l && l.has(i)) return l.get(i);
            var b = {}, P = Object.defineProperty && Object.getOwnPropertyDescriptor;
            for (var E in i) if (Object.prototype.hasOwnProperty.call(i, E)) {
              var v = P ? Object.getOwnPropertyDescriptor(i, E) : null;
              v && (v.get || v.set) ? Object.defineProperty(b, E, v) : b[E] = i[E];
            }
            return b.default = i, l && l.set(i, b), b;
          }
          function c(i) {
            return n(i) ? f.LooseModeResolution.namespaced("Helper") : null;
          }
          function o(i) {
            return n(i) ? f.LooseModeResolution.namespaced("Modifier") : null;
          }
          function e(i) {
            return n(i) ? f.LooseModeResolution.namespaced("Component") : f.LooseModeResolution.fallback();
          }
          function r(i) {
            return a(i) ? f.LooseModeResolution.namespaced("Component", true) : null;
          }
          function s(i) {
            let l = n(i), b = u(i);
            return l ? b ? f.LooseModeResolution.namespaced("Helper") : f.LooseModeResolution.attr() : b ? f.STRICT_RESOLUTION : f.LooseModeResolution.fallback();
          }
          function p(i) {
            let l = n(i), b = u(i), P = i.trusting;
            return l ? P ? f.LooseModeResolution.trustingAppend({ invoke: b }) : f.LooseModeResolution.append({ invoke: b }) : f.LooseModeResolution.fallback();
          }
          function n(i) {
            let l = i.path;
            return a(l);
          }
          function a(i) {
            return i.type === "PathExpression" && i.head.type === "VarHead" ? i.tail.length === 0 : false;
          }
          function u(i) {
            return i.params.length > 0 || i.hash.pairs.length > 0;
          }
        } }), Ht = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/normalize.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.normalize = P, t.BlockContext = void 0;
          var f = X(), h = b(Te()), d = Fe(), c = le(), o = ce(), e = Xe(), r = he(), s = ye(), p = b(Le()), n = l(ve()), a = jt(), u = Mt();
          function i() {
            if (typeof WeakMap != "function") return null;
            var m = /* @__PURE__ */ new WeakMap();
            return i = function() {
              return m;
            }, m;
          }
          function l(m) {
            if (m && m.__esModule) return m;
            if (m === null || typeof m != "object" && typeof m != "function") return { default: m };
            var C = i();
            if (C && C.has(m)) return C.get(m);
            var S = {}, R = Object.defineProperty && Object.getOwnPropertyDescriptor;
            for (var M in m) if (Object.prototype.hasOwnProperty.call(m, M)) {
              var V = R ? Object.getOwnPropertyDescriptor(m, M) : null;
              V && (V.get || V.set) ? Object.defineProperty(S, M, V) : S[M] = m[M];
            }
            return S.default = m, C && C.set(m, S), S;
          }
          function b(m) {
            return m && m.__esModule ? m : { default: m };
          }
          function P(m) {
            let C = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
            var S;
            let R = (0, d.preprocess)(m, C), M = (0, f.assign)({ strictMode: false, locals: [] }, C), V = e.SymbolTable.top(M.locals, (S = C.customizeComponentName) !== null && S !== void 0 ? S : (W) => W), G = new E(m, M, V), K = new _(G), U = new L(G.loc(R.loc), R.body.map((W) => K.normalize(W)), G).assertTemplate(V), Z = V.getUsedTemplateLocals();
            return [U, Z];
          }
          var E = class {
            constructor(m, C, S) {
              this.source = m, this.options = C, this.table = S, this.builder = new a.Builder();
            }
            get strict() {
              return this.options.strictMode || false;
            }
            loc(m) {
              return this.source.spanFor(m);
            }
            resolutionFor(m, C) {
              if (this.strict) return { resolution: n.STRICT_RESOLUTION };
              if (this.isFreeVar(m)) {
                let S = C(m);
                return S === null ? { resolution: "error", path: w(m), head: H(m) } : { resolution: S };
              } else return { resolution: n.STRICT_RESOLUTION };
            }
            isFreeVar(m) {
              return m.type === "PathExpression" ? m.head.type !== "VarHead" ? false : !this.table.has(m.head.name) : m.path.type === "PathExpression" ? this.isFreeVar(m.path) : false;
            }
            hasBinding(m) {
              return this.table.has(m);
            }
            child(m) {
              return new E(this.source, this.options, this.table.child(m));
            }
            customizeComponentName(m) {
              return this.options.customizeComponentName ? this.options.customizeComponentName(m) : m;
            }
          };
          t.BlockContext = E;
          var v = class {
            constructor(m) {
              this.block = m;
            }
            normalize(m, C) {
              switch (m.type) {
                case "NullLiteral":
                case "BooleanLiteral":
                case "NumberLiteral":
                case "StringLiteral":
                case "UndefinedLiteral":
                  return this.block.builder.literal(m.value, this.block.loc(m.loc));
                case "PathExpression":
                  return this.path(m, C);
                case "SubExpression": {
                  let S = this.block.resolutionFor(m, u.SexpSyntaxContext);
                  if (S.resolution === "error") throw (0, r.generateSyntaxError)("You attempted to invoke a path (`".concat(S.path, "`) but ").concat(S.head, " was not in scope"), m.loc);
                  return this.block.builder.sexp(this.callParts(m, S.resolution), this.block.loc(m.loc));
                }
              }
            }
            path(m, C) {
              let S = this.block.loc(m.head.loc), R = [], M = S;
              for (let V of m.tail) M = M.sliceStartChars({ chars: V.length, skipStart: 1 }), R.push(new c.SourceSlice({ loc: M, chars: V }));
              return this.block.builder.path(this.ref(m.head, C), R, this.block.loc(m.loc));
            }
            callParts(m, C) {
              let { path: S, params: R, hash: M } = m, V = this.normalize(S, C), G = R.map((N) => this.normalize(N, n.ARGUMENT_RESOLUTION)), K = o.SpanList.range(G, V.loc.collapse("end")), U = this.block.loc(M.loc), Z = o.SpanList.range([K, U]), W = this.block.builder.positional(R.map((N) => this.normalize(N, n.ARGUMENT_RESOLUTION)), K), T = this.block.builder.named(M.pairs.map((N) => this.namedArgument(N)), this.block.loc(M.loc));
              return { callee: V, args: this.block.builder.args(W, T, Z) };
            }
            namedArgument(m) {
              let S = this.block.loc(m.loc).sliceStartChars({ chars: m.key.length });
              return this.block.builder.namedArgument(new c.SourceSlice({ chars: m.key, loc: S }), this.normalize(m.value, n.ARGUMENT_RESOLUTION));
            }
            ref(m, C) {
              let { block: S } = this, { builder: R, table: M } = S, V = S.loc(m.loc);
              switch (m.type) {
                case "ThisHead":
                  return R.self(V);
                case "AtHead": {
                  let G = M.allocateNamed(m.name);
                  return R.at(m.name, G, V);
                }
                case "VarHead":
                  if (S.hasBinding(m.name)) {
                    let [G, K] = M.get(m.name);
                    return S.builder.localVar(m.name, G, K, V);
                  } else {
                    let G = S.strict ? n.STRICT_RESOLUTION : C, K = S.table.allocateFree(m.name, G);
                    return S.builder.freeVar({ name: m.name, context: G, symbol: K, loc: V });
                  }
              }
            }
          }, _ = class {
            constructor(m) {
              this.block = m;
            }
            normalize(m) {
              switch (m.type) {
                case "PartialStatement":
                  throw new Error("Handlebars partial syntax ({{> ...}}) is not allowed in Glimmer");
                case "BlockStatement":
                  return this.BlockStatement(m);
                case "ElementNode":
                  return new y(this.block).ElementNode(m);
                case "MustacheStatement":
                  return this.MustacheStatement(m);
                case "MustacheCommentStatement":
                  return this.MustacheCommentStatement(m);
                case "CommentStatement": {
                  let C = this.block.loc(m.loc);
                  return new n.HtmlComment({ loc: C, text: C.slice({ skipStart: 4, skipEnd: 3 }).toSlice(m.value) });
                }
                case "TextNode":
                  return new n.HtmlText({ loc: this.block.loc(m.loc), chars: m.chars });
              }
            }
            MustacheCommentStatement(m) {
              let C = this.block.loc(m.loc), S;
              return C.asString().slice(0, 5) === "{{!--" ? S = C.slice({ skipStart: 5, skipEnd: 4 }) : S = C.slice({ skipStart: 3, skipEnd: 2 }), new n.GlimmerComment({ loc: C, text: S.toSlice(m.value) });
            }
            MustacheStatement(m) {
              let { escaped: C } = m, S = this.block.loc(m.loc), R = this.expr.callParts({ path: m.path, params: m.params, hash: m.hash }, (0, u.AppendSyntaxContext)(m)), M = R.args.isEmpty() ? R.callee : this.block.builder.sexp(R, S);
              return this.block.builder.append({ table: this.block.table, trusting: !C, value: M }, S);
            }
            BlockStatement(m) {
              let { program: C, inverse: S } = m, R = this.block.loc(m.loc), M = this.block.resolutionFor(m, u.BlockSyntaxContext);
              if (M.resolution === "error") throw (0, r.generateSyntaxError)("You attempted to invoke a path (`{{#".concat(M.path, "}}`) but ").concat(M.head, " was not in scope"), R);
              let V = this.expr.callParts(m, M.resolution);
              return this.block.builder.blockStatement((0, f.assign)({ symbols: this.block.table, program: this.Block(C), inverse: S ? this.Block(S) : null }, V), R);
            }
            Block(m) {
              let { body: C, loc: S, blockParams: R } = m, M = this.block.child(R), V = new _(M);
              return new j(this.block.loc(S), C.map((G) => V.normalize(G)), this.block).assertBlock(M.table);
            }
            get expr() {
              return new v(this.block);
            }
          }, y = class {
            constructor(m) {
              this.ctx = m;
            }
            ElementNode(m) {
              let { tag: C, selfClosing: S, comments: R } = m, M = this.ctx.loc(m.loc), [V, ...G] = C.split("."), K = this.classifyTag(V, G, m.loc), U = m.attributes.filter((A) => A.name[0] !== "@").map((A) => this.attr(A)), Z = m.attributes.filter((A) => A.name[0] === "@").map((A) => this.arg(A)), W = m.modifiers.map((A) => this.modifier(A)), T = this.ctx.child(m.blockParams), N = new _(T), k = m.children.map((A) => N.normalize(A)), B = this.ctx.builder.element({ selfClosing: S, attrs: U, componentArgs: Z, modifiers: W, comments: R.map((A) => new _(this.ctx).MustacheCommentStatement(A)) }), O = new x(B, M, k, this.ctx), z2 = this.ctx.loc(m.loc).sliceStartChars({ chars: C.length, skipStart: 1 });
              if (K === "ElementHead") return C[0] === ":" ? O.assertNamedBlock(z2.slice({ skipStart: 1 }).toSlice(C.slice(1)), T.table) : O.assertElement(z2.toSlice(C), m.blockParams.length > 0);
              if (m.selfClosing) return B.selfClosingComponent(K, M);
              {
                let A = O.assertComponent(C, T.table, m.blockParams.length > 0);
                return B.componentWithNamedBlocks(K, A, M);
              }
            }
            modifier(m) {
              let C = this.ctx.resolutionFor(m, u.ModifierSyntaxContext);
              if (C.resolution === "error") throw (0, r.generateSyntaxError)("You attempted to invoke a path (`{{#".concat(C.path, "}}`) as a modifier, but ").concat(C.head, " was not in scope. Try adding `this` to the beginning of the path"), m.loc);
              let S = this.expr.callParts(m, C.resolution);
              return this.ctx.builder.modifier(S, this.ctx.loc(m.loc));
            }
            mustacheAttr(m) {
              let C = this.ctx.builder.sexp(this.expr.callParts(m, (0, u.AttrValueSyntaxContext)(m)), this.ctx.loc(m.loc));
              return C.args.isEmpty() ? C.callee : C;
            }
            attrPart(m) {
              switch (m.type) {
                case "MustacheStatement":
                  return { expr: this.mustacheAttr(m), trusting: !m.escaped };
                case "TextNode":
                  return { expr: this.ctx.builder.literal(m.chars, this.ctx.loc(m.loc)), trusting: true };
              }
            }
            attrValue(m) {
              switch (m.type) {
                case "ConcatStatement": {
                  let C = m.parts.map((S) => this.attrPart(S).expr);
                  return { expr: this.ctx.builder.interpolate(C, this.ctx.loc(m.loc)), trusting: false };
                }
                default:
                  return this.attrPart(m);
              }
            }
            attr(m) {
              if (m.name === "...attributes") return this.ctx.builder.splatAttr(this.ctx.table.allocateBlock("attrs"), this.ctx.loc(m.loc));
              let C = this.ctx.loc(m.loc), S = C.sliceStartChars({ chars: m.name.length }).toSlice(m.name), R = this.attrValue(m.value);
              return this.ctx.builder.attr({ name: S, value: R.expr, trusting: R.trusting }, C);
            }
            maybeDeprecatedCall(m, C) {
              if (this.ctx.strict || C.type !== "MustacheStatement") return null;
              let { path: S } = C;
              if (S.type !== "PathExpression" || S.head.type !== "VarHead") return null;
              let { name: R } = S.head;
              if (R === "has-block" || R === "has-block-params" || this.ctx.hasBinding(R) || S.tail.length !== 0 || C.params.length !== 0 || C.hash.pairs.length !== 0) return null;
              let M = n.LooseModeResolution.attr(), V = this.ctx.builder.freeVar({ name: R, context: M, symbol: this.ctx.table.allocateFree(R, M), loc: S.loc });
              return { expr: this.ctx.builder.deprecatedCall(m, V, C.loc), trusting: false };
            }
            arg(m) {
              let C = this.ctx.loc(m.loc), S = C.sliceStartChars({ chars: m.name.length }).toSlice(m.name), R = this.maybeDeprecatedCall(S, m.value) || this.attrValue(m.value);
              return this.ctx.builder.arg({ name: S, value: R.expr, trusting: R.trusting }, C);
            }
            classifyTag(m, C, S) {
              let R = (0, s.isUpperCase)(m), M = m[0] === "@" || m === "this" || this.ctx.hasBinding(m);
              if (this.ctx.strict && !M) {
                if (R) throw (0, r.generateSyntaxError)("Attempted to invoke a component that was not in scope in a strict mode template, `<".concat(m, ">`. If you wanted to create an element with that name, convert it to lowercase - `<").concat(m.toLowerCase(), ">`"), S);
                return "ElementHead";
              }
              let V = M || R, G = S.sliceStartChars({ skipStart: 1, chars: m.length }), K = C.reduce((W, T) => W + 1 + T.length, 0), U = G.getEnd().move(K), Z = G.withEnd(U);
              if (V) {
                let W = p.default.path({ head: p.default.head(m, G), tail: C, loc: Z }), T = this.ctx.resolutionFor(W, u.ComponentSyntaxContext);
                if (T.resolution === "error") throw (0, r.generateSyntaxError)("You attempted to invoke a path (`<".concat(T.path, ">`) but ").concat(T.head, " was not in scope"), S);
                return new v(this.ctx).normalize(W, T.resolution);
              }
              if (C.length > 0) throw (0, r.generateSyntaxError)("You used ".concat(m, ".").concat(C.join("."), " as a tag name, but ").concat(m, " is not in scope"), S);
              return "ElementHead";
            }
            get expr() {
              return new v(this.ctx);
            }
          }, g = class {
            constructor(m, C, S) {
              this.loc = m, this.children = C, this.block = S, this.namedBlocks = C.filter((R) => R instanceof n.NamedBlock), this.hasSemanticContent = Boolean(C.filter((R) => {
                if (R instanceof n.NamedBlock) return false;
                switch (R.type) {
                  case "GlimmerComment":
                  case "HtmlComment":
                    return false;
                  case "HtmlText":
                    return !/^\s*$/.exec(R.chars);
                  default:
                    return true;
                }
              }).length), this.nonBlockChildren = C.filter((R) => !(R instanceof n.NamedBlock));
            }
          }, L = class extends g {
            assertTemplate(m) {
              if ((0, f.isPresent)(this.namedBlocks)) throw (0, r.generateSyntaxError)("Unexpected named block at the top-level of a template", this.loc);
              return this.block.builder.template(m, this.nonBlockChildren, this.block.loc(this.loc));
            }
          }, j = class extends g {
            assertBlock(m) {
              if ((0, f.isPresent)(this.namedBlocks)) throw (0, r.generateSyntaxError)("Unexpected named block nested in a normal block", this.loc);
              return this.block.builder.block(m, this.nonBlockChildren, this.loc);
            }
          }, x = class extends g {
            constructor(m, C, S, R) {
              super(C, S, R), this.el = m;
            }
            assertNamedBlock(m, C) {
              if (this.el.base.selfClosing) throw (0, r.generateSyntaxError)("<:".concat(m.chars, "/> is not a valid named block: named blocks cannot be self-closing"), this.loc);
              if ((0, f.isPresent)(this.namedBlocks)) throw (0, r.generateSyntaxError)("Unexpected named block inside <:".concat(m.chars, "> named block: named blocks cannot contain nested named blocks"), this.loc);
              if (!(0, s.isLowerCase)(m.chars)) throw (0, r.generateSyntaxError)("<:".concat(m.chars, "> is not a valid named block, and named blocks must begin with a lowercase letter"), this.loc);
              if (this.el.base.attrs.length > 0 || this.el.base.componentArgs.length > 0 || this.el.base.modifiers.length > 0) throw (0, r.generateSyntaxError)("named block <:".concat(m.chars, "> cannot have attributes, arguments, or modifiers"), this.loc);
              let S = o.SpanList.range(this.nonBlockChildren, this.loc);
              return this.block.builder.namedBlock(m, this.block.builder.block(C, this.nonBlockChildren, S), this.loc);
            }
            assertElement(m, C) {
              if (C) throw (0, r.generateSyntaxError)("Unexpected block params in <".concat(m, ">: simple elements cannot have block params"), this.loc);
              if ((0, f.isPresent)(this.namedBlocks)) {
                let S = this.namedBlocks.map((R) => R.name);
                if (S.length === 1) throw (0, r.generateSyntaxError)("Unexpected named block <:foo> inside <".concat(m.chars, "> HTML element"), this.loc);
                {
                  let R = S.map((M) => "<:".concat(M.chars, ">")).join(", ");
                  throw (0, r.generateSyntaxError)("Unexpected named blocks inside <".concat(m.chars, "> HTML element (").concat(R, ")"), this.loc);
                }
              }
              return this.el.simple(m, this.nonBlockChildren, this.loc);
            }
            assertComponent(m, C, S) {
              if ((0, f.isPresent)(this.namedBlocks) && this.hasSemanticContent) throw (0, r.generateSyntaxError)("Unexpected content inside <".concat(m, "> component invocation: when using named blocks, the tag cannot contain other content"), this.loc);
              if ((0, f.isPresent)(this.namedBlocks)) {
                if (S) throw (0, r.generateSyntaxError)("Unexpected block params list on <".concat(m, "> component invocation: when passing named blocks, the invocation tag cannot take block params"), this.loc);
                let R = /* @__PURE__ */ new Set();
                for (let M of this.namedBlocks) {
                  let V = M.name.chars;
                  if (R.has(V)) throw (0, r.generateSyntaxError)("Component had two named blocks with the same name, `<:".concat(V, ">`. Only one block with a given name may be passed"), this.loc);
                  if (V === "inverse" && R.has("else") || V === "else" && R.has("inverse")) throw (0, r.generateSyntaxError)("Component has both <:else> and <:inverse> block. <:inverse> is an alias for <:else>", this.loc);
                  R.add(V);
                }
                return this.namedBlocks;
              } else return [this.block.builder.namedBlock(c.SourceSlice.synthetic("default"), this.block.builder.block(C, this.nonBlockChildren, this.loc), this.loc)];
            }
          };
          function w(m) {
            return m.type !== "PathExpression" && m.path.type === "PathExpression" ? w(m.path) : new h.default({ entityEncoding: "raw" }).print(m);
          }
          function H(m) {
            if (m.type === "PathExpression") switch (m.head.type) {
              case "AtHead":
              case "VarHead":
                return m.head.name;
              case "ThisHead":
                return "this";
            }
            else return m.path.type === "PathExpression" ? H(m.path) : new h.default({ entityEncoding: "raw" }).print(m);
          }
        } }), Ze = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/keywords.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.isKeyword = f, t.KEYWORDS_TYPES = void 0;
          function f(d) {
            return d in h;
          }
          var h = { component: ["Call", "Append", "Block"], debugger: ["Append"], "each-in": ["Block"], each: ["Block"], "has-block-params": ["Call", "Append"], "has-block": ["Call", "Append"], helper: ["Call", "Append"], if: ["Call", "Append", "Block"], "in-element": ["Block"], let: ["Block"], "link-to": ["Append", "Block"], log: ["Call", "Append"], modifier: ["Call"], mount: ["Append"], mut: ["Call", "Append"], outlet: ["Append"], "query-params": ["Call"], readonly: ["Call", "Append"], unbound: ["Call", "Append"], unless: ["Call", "Append", "Block"], with: ["Block"], yield: ["Append"] };
          t.KEYWORDS_TYPES = h;
        } }), Vt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/get-template-locals.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), t.getTemplateLocals = r;
          var f = Ze(), h = Fe(), d = c(Ne());
          function c(s) {
            return s && s.__esModule ? s : { default: s };
          }
          function o(s, p, n) {
            if (s.type === "PathExpression") {
              if (s.head.type === "AtHead" || s.head.type === "ThisHead") return;
              let a = s.head.name;
              if (p.indexOf(a) === -1) return a;
            } else if (s.type === "ElementNode") {
              let { tag: a } = s, u = a.charAt(0);
              return u === ":" || u === "@" || !n.includeHtmlElements && a.indexOf(".") === -1 && a.toLowerCase() === a || a.substr(0, 5) === "this." || p.indexOf(a) !== -1 ? void 0 : a;
            }
          }
          function e(s, p, n, a) {
            let u = o(p, n, a);
            (Array.isArray(u) ? u : [u]).forEach((i) => {
              i !== void 0 && i[0] !== "@" && s.add(i.split(".")[0]);
            });
          }
          function r(s) {
            let p = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : { includeHtmlElements: false, includeKeywords: false }, n = (0, h.preprocess)(s), a = /* @__PURE__ */ new Set(), u = [];
            (0, d.default)(n, { Block: { enter(l) {
              let { blockParams: b } = l;
              b.forEach((P) => {
                u.push(P);
              });
            }, exit(l) {
              let { blockParams: b } = l;
              b.forEach(() => {
                u.pop();
              });
            } }, ElementNode: { enter(l) {
              l.blockParams.forEach((b) => {
                u.push(b);
              }), e(a, l, u, p);
            }, exit(l) {
              let { blockParams: b } = l;
              b.forEach(() => {
                u.pop();
              });
            } }, PathExpression(l) {
              e(a, l, u, p);
            } });
            let i = [];
            return a.forEach((l) => i.push(l)), p != null && p.includeKeywords || (i = i.filter((l) => !(0, f.isKeyword)(l))), i;
          }
        } }), Ut = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/index.js"(t) {
          "use strict";
          F(), Object.defineProperty(t, "__esModule", { value: true }), Object.defineProperty(t, "Source", { enumerable: true, get: function() {
            return f.Source;
          } }), Object.defineProperty(t, "builders", { enumerable: true, get: function() {
            return h.default;
          } }), Object.defineProperty(t, "normalize", { enumerable: true, get: function() {
            return o.normalize;
          } }), Object.defineProperty(t, "SymbolTable", { enumerable: true, get: function() {
            return e.SymbolTable;
          } }), Object.defineProperty(t, "BlockSymbolTable", { enumerable: true, get: function() {
            return e.BlockSymbolTable;
          } }), Object.defineProperty(t, "ProgramSymbolTable", { enumerable: true, get: function() {
            return e.ProgramSymbolTable;
          } }), Object.defineProperty(t, "generateSyntaxError", { enumerable: true, get: function() {
            return r.generateSyntaxError;
          } }), Object.defineProperty(t, "preprocess", { enumerable: true, get: function() {
            return s.preprocess;
          } }), Object.defineProperty(t, "print", { enumerable: true, get: function() {
            return p.default;
          } }), Object.defineProperty(t, "sortByLoc", { enumerable: true, get: function() {
            return n.sortByLoc;
          } }), Object.defineProperty(t, "Walker", { enumerable: true, get: function() {
            return a.default;
          } }), Object.defineProperty(t, "Path", { enumerable: true, get: function() {
            return a.default;
          } }), Object.defineProperty(t, "traverse", { enumerable: true, get: function() {
            return u.default;
          } }), Object.defineProperty(t, "cannotRemoveNode", { enumerable: true, get: function() {
            return i.cannotRemoveNode;
          } }), Object.defineProperty(t, "cannotReplaceNode", { enumerable: true, get: function() {
            return i.cannotReplaceNode;
          } }), Object.defineProperty(t, "WalkerPath", { enumerable: true, get: function() {
            return l.default;
          } }), Object.defineProperty(t, "isKeyword", { enumerable: true, get: function() {
            return b.isKeyword;
          } }), Object.defineProperty(t, "KEYWORDS_TYPES", { enumerable: true, get: function() {
            return b.KEYWORDS_TYPES;
          } }), Object.defineProperty(t, "getTemplateLocals", { enumerable: true, get: function() {
            return P.getTemplateLocals;
          } }), Object.defineProperty(t, "SourceSlice", { enumerable: true, get: function() {
            return E.SourceSlice;
          } }), Object.defineProperty(t, "SourceSpan", { enumerable: true, get: function() {
            return v.SourceSpan;
          } }), Object.defineProperty(t, "SpanList", { enumerable: true, get: function() {
            return _.SpanList;
          } }), Object.defineProperty(t, "maybeLoc", { enumerable: true, get: function() {
            return _.maybeLoc;
          } }), Object.defineProperty(t, "loc", { enumerable: true, get: function() {
            return _.loc;
          } }), Object.defineProperty(t, "hasSpan", { enumerable: true, get: function() {
            return _.hasSpan;
          } }), Object.defineProperty(t, "node", { enumerable: true, get: function() {
            return y.node;
          } }), t.ASTv2 = t.AST = t.ASTv1 = void 0;
          var f = De(), h = j(ke()), d = L(Ct());
          t.ASTv1 = d, t.AST = d;
          var c = L(ve());
          t.ASTv2 = c;
          var o = Ht(), e = Xe(), r = he(), s = Fe(), p = j(We()), n = Ue(), a = j(Je()), u = j(Ne()), i = Ye(), l = j(Qe()), b = Ze(), P = Vt(), E = le(), v = ue(), _ = ce(), y = ne();
          function g() {
            if (typeof WeakMap != "function") return null;
            var x = /* @__PURE__ */ new WeakMap();
            return g = function() {
              return x;
            }, x;
          }
          function L(x) {
            if (x && x.__esModule) return x;
            if (x === null || typeof x != "object" && typeof x != "function") return { default: x };
            var w = g();
            if (w && w.has(x)) return w.get(x);
            var H = {}, m = Object.defineProperty && Object.getOwnPropertyDescriptor;
            for (var C in x) if (Object.prototype.hasOwnProperty.call(x, C)) {
              var S = m ? Object.getOwnPropertyDescriptor(x, C) : null;
              S && (S.get || S.set) ? Object.defineProperty(H, C, S) : H[C] = x[C];
            }
            return H.default = x, w && w.set(x, H), H;
          }
          function j(x) {
            return x && x.__esModule ? x : { default: x };
          }
        } });
        F();
        var { LinesAndColumns: zt } = st(), Gt = ut(), { locStart: Kt, locEnd: Wt } = ot();
        function Yt() {
          return { name: "addBackslash", visitor: { All(t) {
            var f;
            let h = (f = t.children) !== null && f !== void 0 ? f : t.body;
            if (h) for (let d = 0; d < h.length - 1; d++) h[d].type === "TextNode" && h[d + 1].type === "MustacheStatement" && (h[d].chars = h[d].chars.replace(/\\$/, "\\\\"));
          } } };
        }
        function Qt(t) {
          let f = new zt(t), h = (d) => {
            let { line: c, column: o } = d;
            return f.indexForLocation({ line: c - 1, column: o });
          };
          return () => ({ name: "addOffset", visitor: { All(d) {
            let { start: c, end: o } = d.loc;
            c.offset = h(c), o.offset = h(o);
          } } });
        }
        function Jt(t) {
          let { preprocess: f } = Ut(), h;
          try {
            h = f(t, { mode: "codemod", plugins: { ast: [Yt, Qt(t)] } });
          } catch (d) {
            let c = Xt(d);
            throw c ? Gt(d.message, c) : d;
          }
          return h;
        }
        function Xt(t) {
          let { location: f, hash: h } = t;
          if (f) {
            let { start: d, end: c } = f;
            return typeof c.line != "number" ? { start: d } : f;
          }
          if (h) {
            let { loc: { last_line: d, last_column: c } } = h;
            return { start: { line: d, column: c + 1 } };
          }
        }
        $e.exports = { parsers: { glimmer: { parse: Jt, astFormat: "glimmer", locStart: Kt, locEnd: Wt } } };
      });
      return Zt();
    });
  }
});

// ../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-graphql.js
var require_parser_graphql = __commonJS({
  "../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-graphql.js"(exports2, module2) {
    "use strict";
    (function(e) {
      if (typeof exports2 == "object" && typeof module2 == "object") module2.exports = e();
      else if (typeof define == "function" && define.amd) define(e);
      else {
        var i = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i.prettierPlugins = i.prettierPlugins || {}, i.prettierPlugins.graphql = e();
      }
    })(function() {
      "use strict";
      var oe = (a, d) => () => (d || a((d = { exports: {} }).exports, d), d.exports);
      var be = oe((Ce, ae) => {
        var H = Object.getOwnPropertyNames, se = (a, d) => function() {
          return a && (d = (0, a[H(a)[0]])(a = 0)), d;
        }, L = (a, d) => function() {
          return d || (0, a[H(a)[0]])((d = { exports: {} }).exports, d), d.exports;
        }, K = se({ "<define:process>"() {
        } }), ce = L({ "src/common/parser-create-error.js"(a, d) {
          "use strict";
          K();
          function i(c, r) {
            let _ = new SyntaxError(c + " (" + r.start.line + ":" + r.start.column + ")");
            return _.loc = r, _;
          }
          d.exports = i;
        } }), ue = L({ "src/utils/try-combinations.js"(a, d) {
          "use strict";
          K();
          function i() {
            let c;
            for (var r = arguments.length, _ = new Array(r), E = 0; E < r; E++) _[E] = arguments[E];
            for (let [k, O] of _.entries()) try {
              return { result: O() };
            } catch (A) {
              k === 0 && (c = A);
            }
            return { error: c };
          }
          d.exports = i;
        } }), le = L({ "src/language-graphql/pragma.js"(a, d) {
          "use strict";
          K();
          function i(r) {
            return /^\s*#[^\S\n]*@(?:format|prettier)\s*(?:\n|$)/.test(r);
          }
          function c(r) {
            return `# @format

` + r;
          }
          d.exports = { hasPragma: i, insertPragma: c };
        } }), pe = L({ "src/language-graphql/loc.js"(a, d) {
          "use strict";
          K();
          function i(r) {
            return typeof r.start == "number" ? r.start : r.loc && r.loc.start;
          }
          function c(r) {
            return typeof r.end == "number" ? r.end : r.loc && r.loc.end;
          }
          d.exports = { locStart: i, locEnd: c };
        } }), fe = L({ "node_modules/graphql/jsutils/isObjectLike.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.default = i;
          function d(c) {
            return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? d = function(_) {
              return typeof _;
            } : d = function(_) {
              return _ && typeof Symbol == "function" && _.constructor === Symbol && _ !== Symbol.prototype ? "symbol" : typeof _;
            }, d(c);
          }
          function i(c) {
            return d(c) == "object" && c !== null;
          }
        } }), z2 = L({ "node_modules/graphql/polyfills/symbols.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.SYMBOL_TO_STRING_TAG = a.SYMBOL_ASYNC_ITERATOR = a.SYMBOL_ITERATOR = void 0;
          var d = typeof Symbol == "function" && Symbol.iterator != null ? Symbol.iterator : "@@iterator";
          a.SYMBOL_ITERATOR = d;
          var i = typeof Symbol == "function" && Symbol.asyncIterator != null ? Symbol.asyncIterator : "@@asyncIterator";
          a.SYMBOL_ASYNC_ITERATOR = i;
          var c = typeof Symbol == "function" && Symbol.toStringTag != null ? Symbol.toStringTag : "@@toStringTag";
          a.SYMBOL_TO_STRING_TAG = c;
        } }), $ = L({ "node_modules/graphql/language/location.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.getLocation = d;
          function d(i, c) {
            for (var r = /\r\n|[\n\r]/g, _ = 1, E = c + 1, k; (k = r.exec(i.body)) && k.index < c; ) _ += 1, E = c + 1 - (k.index + k[0].length);
            return { line: _, column: E };
          }
        } }), de = L({ "node_modules/graphql/language/printLocation.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.printLocation = i, a.printSourceLocation = c;
          var d = $();
          function i(k) {
            return c(k.source, (0, d.getLocation)(k.source, k.start));
          }
          function c(k, O) {
            var A = k.locationOffset.column - 1, N = _(A) + k.body, g = O.line - 1, D = k.locationOffset.line - 1, v = O.line + D, I = O.line === 1 ? A : 0, s = O.column + I, p = "".concat(k.name, ":").concat(v, ":").concat(s, `
`), e = N.split(/\r\n|[\n\r]/g), n = e[g];
            if (n.length > 120) {
              for (var t = Math.floor(s / 80), u = s % 80, y = [], f = 0; f < n.length; f += 80) y.push(n.slice(f, f + 80));
              return p + r([["".concat(v), y[0]]].concat(y.slice(1, t + 1).map(function(m) {
                return ["", m];
              }), [[" ", _(u - 1) + "^"], ["", y[t + 1]]]));
            }
            return p + r([["".concat(v - 1), e[g - 1]], ["".concat(v), n], ["", _(s - 1) + "^"], ["".concat(v + 1), e[g + 1]]]);
          }
          function r(k) {
            var O = k.filter(function(N) {
              var g = N[0], D = N[1];
              return D !== void 0;
            }), A = Math.max.apply(Math, O.map(function(N) {
              var g = N[0];
              return g.length;
            }));
            return O.map(function(N) {
              var g = N[0], D = N[1];
              return E(A, g) + (D ? " | " + D : " |");
            }).join(`
`);
          }
          function _(k) {
            return Array(k + 1).join(" ");
          }
          function E(k, O) {
            return _(k - O.length) + O;
          }
        } }), W = L({ "node_modules/graphql/error/GraphQLError.js"(a) {
          "use strict";
          K();
          function d(f) {
            return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? d = function(o) {
              return typeof o;
            } : d = function(o) {
              return o && typeof Symbol == "function" && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
            }, d(f);
          }
          Object.defineProperty(a, "__esModule", { value: true }), a.printError = y, a.GraphQLError = void 0;
          var i = E(fe()), c = z2(), r = $(), _ = de();
          function E(f) {
            return f && f.__esModule ? f : { default: f };
          }
          function k(f, m) {
            if (!(f instanceof m)) throw new TypeError("Cannot call a class as a function");
          }
          function O(f, m) {
            for (var o = 0; o < m.length; o++) {
              var h = m[o];
              h.enumerable = h.enumerable || false, h.configurable = true, "value" in h && (h.writable = true), Object.defineProperty(f, h.key, h);
            }
          }
          function A(f, m, o) {
            return m && O(f.prototype, m), o && O(f, o), f;
          }
          function N(f, m) {
            if (typeof m != "function" && m !== null) throw new TypeError("Super expression must either be null or a function");
            f.prototype = Object.create(m && m.prototype, { constructor: { value: f, writable: true, configurable: true } }), m && n(f, m);
          }
          function g(f) {
            var m = p();
            return function() {
              var h = t(f), l;
              if (m) {
                var T = t(this).constructor;
                l = Reflect.construct(h, arguments, T);
              } else l = h.apply(this, arguments);
              return D(this, l);
            };
          }
          function D(f, m) {
            return m && (d(m) === "object" || typeof m == "function") ? m : v(f);
          }
          function v(f) {
            if (f === void 0) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return f;
          }
          function I(f) {
            var m = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
            return I = function(h) {
              if (h === null || !e(h)) return h;
              if (typeof h != "function") throw new TypeError("Super expression must either be null or a function");
              if (typeof m < "u") {
                if (m.has(h)) return m.get(h);
                m.set(h, l);
              }
              function l() {
                return s(h, arguments, t(this).constructor);
              }
              return l.prototype = Object.create(h.prototype, { constructor: { value: l, enumerable: false, writable: true, configurable: true } }), n(l, h);
            }, I(f);
          }
          function s(f, m, o) {
            return p() ? s = Reflect.construct : s = function(l, T, S) {
              var x = [null];
              x.push.apply(x, T);
              var b = Function.bind.apply(l, x), M = new b();
              return S && n(M, S.prototype), M;
            }, s.apply(null, arguments);
          }
          function p() {
            if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham) return false;
            if (typeof Proxy == "function") return true;
            try {
              return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
              })), true;
            } catch {
              return false;
            }
          }
          function e(f) {
            return Function.toString.call(f).indexOf("[native code]") !== -1;
          }
          function n(f, m) {
            return n = Object.setPrototypeOf || function(h, l) {
              return h.__proto__ = l, h;
            }, n(f, m);
          }
          function t(f) {
            return t = Object.setPrototypeOf ? Object.getPrototypeOf : function(o) {
              return o.__proto__ || Object.getPrototypeOf(o);
            }, t(f);
          }
          var u = function(f) {
            N(o, f);
            var m = g(o);
            function o(h, l, T, S, x, b, M) {
              var U, V, q, G, C;
              k(this, o), C = m.call(this, h);
              var R = Array.isArray(l) ? l.length !== 0 ? l : void 0 : l ? [l] : void 0, Y = T;
              if (!Y && R) {
                var J;
                Y = (J = R[0].loc) === null || J === void 0 ? void 0 : J.source;
              }
              var F = S;
              !F && R && (F = R.reduce(function(w, P) {
                return P.loc && w.push(P.loc.start), w;
              }, [])), F && F.length === 0 && (F = void 0);
              var B;
              S && T ? B = S.map(function(w) {
                return (0, r.getLocation)(T, w);
              }) : R && (B = R.reduce(function(w, P) {
                return P.loc && w.push((0, r.getLocation)(P.loc.source, P.loc.start)), w;
              }, []));
              var j = M;
              if (j == null && b != null) {
                var Q = b.extensions;
                (0, i.default)(Q) && (j = Q);
              }
              return Object.defineProperties(v(C), { name: { value: "GraphQLError" }, message: { value: h, enumerable: true, writable: true }, locations: { value: (U = B) !== null && U !== void 0 ? U : void 0, enumerable: B != null }, path: { value: x != null ? x : void 0, enumerable: x != null }, nodes: { value: R != null ? R : void 0 }, source: { value: (V = Y) !== null && V !== void 0 ? V : void 0 }, positions: { value: (q = F) !== null && q !== void 0 ? q : void 0 }, originalError: { value: b }, extensions: { value: (G = j) !== null && G !== void 0 ? G : void 0, enumerable: j != null } }), b != null && b.stack ? (Object.defineProperty(v(C), "stack", { value: b.stack, writable: true, configurable: true }), D(C)) : (Error.captureStackTrace ? Error.captureStackTrace(v(C), o) : Object.defineProperty(v(C), "stack", { value: Error().stack, writable: true, configurable: true }), C);
            }
            return A(o, [{ key: "toString", value: function() {
              return y(this);
            } }, { key: c.SYMBOL_TO_STRING_TAG, get: function() {
              return "Object";
            } }]), o;
          }(I(Error));
          a.GraphQLError = u;
          function y(f) {
            var m = f.message;
            if (f.nodes) for (var o = 0, h = f.nodes; o < h.length; o++) {
              var l = h[o];
              l.loc && (m += `

` + (0, _.printLocation)(l.loc));
            }
            else if (f.source && f.locations) for (var T = 0, S = f.locations; T < S.length; T++) {
              var x = S[T];
              m += `

` + (0, _.printSourceLocation)(f.source, x);
            }
            return m;
          }
        } }), Z = L({ "node_modules/graphql/error/syntaxError.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.syntaxError = i;
          var d = W();
          function i(c, r, _) {
            return new d.GraphQLError("Syntax Error: ".concat(_), void 0, c, [r]);
          }
        } }), he = L({ "node_modules/graphql/language/kinds.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.Kind = void 0;
          var d = Object.freeze({ NAME: "Name", DOCUMENT: "Document", OPERATION_DEFINITION: "OperationDefinition", VARIABLE_DEFINITION: "VariableDefinition", SELECTION_SET: "SelectionSet", FIELD: "Field", ARGUMENT: "Argument", FRAGMENT_SPREAD: "FragmentSpread", INLINE_FRAGMENT: "InlineFragment", FRAGMENT_DEFINITION: "FragmentDefinition", VARIABLE: "Variable", INT: "IntValue", FLOAT: "FloatValue", STRING: "StringValue", BOOLEAN: "BooleanValue", NULL: "NullValue", ENUM: "EnumValue", LIST: "ListValue", OBJECT: "ObjectValue", OBJECT_FIELD: "ObjectField", DIRECTIVE: "Directive", NAMED_TYPE: "NamedType", LIST_TYPE: "ListType", NON_NULL_TYPE: "NonNullType", SCHEMA_DEFINITION: "SchemaDefinition", OPERATION_TYPE_DEFINITION: "OperationTypeDefinition", SCALAR_TYPE_DEFINITION: "ScalarTypeDefinition", OBJECT_TYPE_DEFINITION: "ObjectTypeDefinition", FIELD_DEFINITION: "FieldDefinition", INPUT_VALUE_DEFINITION: "InputValueDefinition", INTERFACE_TYPE_DEFINITION: "InterfaceTypeDefinition", UNION_TYPE_DEFINITION: "UnionTypeDefinition", ENUM_TYPE_DEFINITION: "EnumTypeDefinition", ENUM_VALUE_DEFINITION: "EnumValueDefinition", INPUT_OBJECT_TYPE_DEFINITION: "InputObjectTypeDefinition", DIRECTIVE_DEFINITION: "DirectiveDefinition", SCHEMA_EXTENSION: "SchemaExtension", SCALAR_TYPE_EXTENSION: "ScalarTypeExtension", OBJECT_TYPE_EXTENSION: "ObjectTypeExtension", INTERFACE_TYPE_EXTENSION: "InterfaceTypeExtension", UNION_TYPE_EXTENSION: "UnionTypeExtension", ENUM_TYPE_EXTENSION: "EnumTypeExtension", INPUT_OBJECT_TYPE_EXTENSION: "InputObjectTypeExtension" });
          a.Kind = d;
        } }), ve = L({ "node_modules/graphql/jsutils/invariant.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.default = d;
          function d(i, c) {
            var r = Boolean(i);
            if (!r) throw new Error(c != null ? c : "Unexpected invariant triggered.");
          }
        } }), ee = L({ "node_modules/graphql/jsutils/nodejsCustomInspectSymbol.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.default = void 0;
          var d = typeof Symbol == "function" && typeof Symbol.for == "function" ? Symbol.for("nodejs.util.inspect.custom") : void 0, i = d;
          a.default = i;
        } }), Te = L({ "node_modules/graphql/jsutils/defineInspect.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.default = r;
          var d = c(ve()), i = c(ee());
          function c(_) {
            return _ && _.__esModule ? _ : { default: _ };
          }
          function r(_) {
            var E = _.prototype.toJSON;
            typeof E == "function" || (0, d.default)(0), _.prototype.inspect = E, i.default && (_.prototype[i.default] = E);
          }
        } }), te = L({ "node_modules/graphql/language/ast.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.isNode = _, a.Token = a.Location = void 0;
          var d = i(Te());
          function i(E) {
            return E && E.__esModule ? E : { default: E };
          }
          var c = function() {
            function E(O, A, N) {
              this.start = O.start, this.end = A.end, this.startToken = O, this.endToken = A, this.source = N;
            }
            var k = E.prototype;
            return k.toJSON = function() {
              return { start: this.start, end: this.end };
            }, E;
          }();
          a.Location = c, (0, d.default)(c);
          var r = function() {
            function E(O, A, N, g, D, v, I) {
              this.kind = O, this.start = A, this.end = N, this.line = g, this.column = D, this.value = I, this.prev = v, this.next = null;
            }
            var k = E.prototype;
            return k.toJSON = function() {
              return { kind: this.kind, value: this.value, line: this.line, column: this.column };
            }, E;
          }();
          a.Token = r, (0, d.default)(r);
          function _(E) {
            return E != null && typeof E.kind == "string";
          }
        } }), ne = L({ "node_modules/graphql/language/tokenKind.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.TokenKind = void 0;
          var d = Object.freeze({ SOF: "<SOF>", EOF: "<EOF>", BANG: "!", DOLLAR: "$", AMP: "&", PAREN_L: "(", PAREN_R: ")", SPREAD: "...", COLON: ":", EQUALS: "=", AT: "@", BRACKET_L: "[", BRACKET_R: "]", BRACE_L: "{", PIPE: "|", BRACE_R: "}", NAME: "Name", INT: "Int", FLOAT: "Float", STRING: "String", BLOCK_STRING: "BlockString", COMMENT: "Comment" });
          a.TokenKind = d;
        } }), re = L({ "node_modules/graphql/jsutils/inspect.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.default = E;
          var d = i(ee());
          function i(v) {
            return v && v.__esModule ? v : { default: v };
          }
          function c(v) {
            return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? c = function(s) {
              return typeof s;
            } : c = function(s) {
              return s && typeof Symbol == "function" && s.constructor === Symbol && s !== Symbol.prototype ? "symbol" : typeof s;
            }, c(v);
          }
          var r = 10, _ = 2;
          function E(v) {
            return k(v, []);
          }
          function k(v, I) {
            switch (c(v)) {
              case "string":
                return JSON.stringify(v);
              case "function":
                return v.name ? "[function ".concat(v.name, "]") : "[function]";
              case "object":
                return v === null ? "null" : O(v, I);
              default:
                return String(v);
            }
          }
          function O(v, I) {
            if (I.indexOf(v) !== -1) return "[Circular]";
            var s = [].concat(I, [v]), p = g(v);
            if (p !== void 0) {
              var e = p.call(v);
              if (e !== v) return typeof e == "string" ? e : k(e, s);
            } else if (Array.isArray(v)) return N(v, s);
            return A(v, s);
          }
          function A(v, I) {
            var s = Object.keys(v);
            if (s.length === 0) return "{}";
            if (I.length > _) return "[" + D(v) + "]";
            var p = s.map(function(e) {
              var n = k(v[e], I);
              return e + ": " + n;
            });
            return "{ " + p.join(", ") + " }";
          }
          function N(v, I) {
            if (v.length === 0) return "[]";
            if (I.length > _) return "[Array]";
            for (var s = Math.min(r, v.length), p = v.length - s, e = [], n = 0; n < s; ++n) e.push(k(v[n], I));
            return p === 1 ? e.push("... 1 more item") : p > 1 && e.push("... ".concat(p, " more items")), "[" + e.join(", ") + "]";
          }
          function g(v) {
            var I = v[String(d.default)];
            if (typeof I == "function") return I;
            if (typeof v.inspect == "function") return v.inspect;
          }
          function D(v) {
            var I = Object.prototype.toString.call(v).replace(/^\[object /, "").replace(/]$/, "");
            if (I === "Object" && typeof v.constructor == "function") {
              var s = v.constructor.name;
              if (typeof s == "string" && s !== "") return s;
            }
            return I;
          }
        } }), _e = L({ "node_modules/graphql/jsutils/devAssert.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.default = d;
          function d(i, c) {
            var r = Boolean(i);
            if (!r) throw new Error(c);
          }
        } }), Ee = L({ "node_modules/graphql/jsutils/instanceOf.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.default = void 0;
          var d = i(re());
          function i(r) {
            return r && r.__esModule ? r : { default: r };
          }
          var c = function(_, E) {
            return _ instanceof E;
          };
          a.default = c;
        } }), me = L({ "node_modules/graphql/language/source.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.isSource = A, a.Source = void 0;
          var d = z2(), i = _(re()), c = _(_e()), r = _(Ee());
          function _(N) {
            return N && N.__esModule ? N : { default: N };
          }
          function E(N, g) {
            for (var D = 0; D < g.length; D++) {
              var v = g[D];
              v.enumerable = v.enumerable || false, v.configurable = true, "value" in v && (v.writable = true), Object.defineProperty(N, v.key, v);
            }
          }
          function k(N, g, D) {
            return g && E(N.prototype, g), D && E(N, D), N;
          }
          var O = function() {
            function N(g) {
              var D = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "GraphQL request", v = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : { line: 1, column: 1 };
              typeof g == "string" || (0, c.default)(0, "Body must be a string. Received: ".concat((0, i.default)(g), ".")), this.body = g, this.name = D, this.locationOffset = v, this.locationOffset.line > 0 || (0, c.default)(0, "line in locationOffset is 1-indexed and must be positive."), this.locationOffset.column > 0 || (0, c.default)(0, "column in locationOffset is 1-indexed and must be positive.");
            }
            return k(N, [{ key: d.SYMBOL_TO_STRING_TAG, get: function() {
              return "Source";
            } }]), N;
          }();
          a.Source = O;
          function A(N) {
            return (0, r.default)(N, O);
          }
        } }), ye = L({ "node_modules/graphql/language/directiveLocation.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.DirectiveLocation = void 0;
          var d = Object.freeze({ QUERY: "QUERY", MUTATION: "MUTATION", SUBSCRIPTION: "SUBSCRIPTION", FIELD: "FIELD", FRAGMENT_DEFINITION: "FRAGMENT_DEFINITION", FRAGMENT_SPREAD: "FRAGMENT_SPREAD", INLINE_FRAGMENT: "INLINE_FRAGMENT", VARIABLE_DEFINITION: "VARIABLE_DEFINITION", SCHEMA: "SCHEMA", SCALAR: "SCALAR", OBJECT: "OBJECT", FIELD_DEFINITION: "FIELD_DEFINITION", ARGUMENT_DEFINITION: "ARGUMENT_DEFINITION", INTERFACE: "INTERFACE", UNION: "UNION", ENUM: "ENUM", ENUM_VALUE: "ENUM_VALUE", INPUT_OBJECT: "INPUT_OBJECT", INPUT_FIELD_DEFINITION: "INPUT_FIELD_DEFINITION" });
          a.DirectiveLocation = d;
        } }), ke = L({ "node_modules/graphql/language/blockString.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.dedentBlockStringValue = d, a.getBlockStringIndentation = c, a.printBlockString = r;
          function d(_) {
            var E = _.split(/\r\n|[\n\r]/g), k = c(_);
            if (k !== 0) for (var O = 1; O < E.length; O++) E[O] = E[O].slice(k);
            for (var A = 0; A < E.length && i(E[A]); ) ++A;
            for (var N = E.length; N > A && i(E[N - 1]); ) --N;
            return E.slice(A, N).join(`
`);
          }
          function i(_) {
            for (var E = 0; E < _.length; ++E) if (_[E] !== " " && _[E] !== "	") return false;
            return true;
          }
          function c(_) {
            for (var E, k = true, O = true, A = 0, N = null, g = 0; g < _.length; ++g) switch (_.charCodeAt(g)) {
              case 13:
                _.charCodeAt(g + 1) === 10 && ++g;
              case 10:
                k = false, O = true, A = 0;
                break;
              case 9:
              case 32:
                ++A;
                break;
              default:
                O && !k && (N === null || A < N) && (N = A), O = false;
            }
            return (E = N) !== null && E !== void 0 ? E : 0;
          }
          function r(_) {
            var E = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "", k = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, O = _.indexOf(`
`) === -1, A = _[0] === " " || _[0] === "	", N = _[_.length - 1] === '"', g = _[_.length - 1] === "\\", D = !O || N || g || k, v = "";
            return D && !(O && A) && (v += `
` + E), v += E ? _.replace(/\n/g, `
` + E) : _, D && (v += `
`), '"""' + v.replace(/"""/g, '\\"""') + '"""';
          }
        } }), Ne = L({ "node_modules/graphql/language/lexer.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.isPunctuatorTokenKind = E, a.Lexer = void 0;
          var d = Z(), i = te(), c = ne(), r = ke(), _ = function() {
            function t(y) {
              var f = new i.Token(c.TokenKind.SOF, 0, 0, 0, 0, null);
              this.source = y, this.lastToken = f, this.token = f, this.line = 1, this.lineStart = 0;
            }
            var u = t.prototype;
            return u.advance = function() {
              this.lastToken = this.token;
              var f = this.token = this.lookahead();
              return f;
            }, u.lookahead = function() {
              var f = this.token;
              if (f.kind !== c.TokenKind.EOF) do {
                var m;
                f = (m = f.next) !== null && m !== void 0 ? m : f.next = O(this, f);
              } while (f.kind === c.TokenKind.COMMENT);
              return f;
            }, t;
          }();
          a.Lexer = _;
          function E(t) {
            return t === c.TokenKind.BANG || t === c.TokenKind.DOLLAR || t === c.TokenKind.AMP || t === c.TokenKind.PAREN_L || t === c.TokenKind.PAREN_R || t === c.TokenKind.SPREAD || t === c.TokenKind.COLON || t === c.TokenKind.EQUALS || t === c.TokenKind.AT || t === c.TokenKind.BRACKET_L || t === c.TokenKind.BRACKET_R || t === c.TokenKind.BRACE_L || t === c.TokenKind.PIPE || t === c.TokenKind.BRACE_R;
          }
          function k(t) {
            return isNaN(t) ? c.TokenKind.EOF : t < 127 ? JSON.stringify(String.fromCharCode(t)) : '"\\u'.concat(("00" + t.toString(16).toUpperCase()).slice(-4), '"');
          }
          function O(t, u) {
            for (var y = t.source, f = y.body, m = f.length, o = u.end; o < m; ) {
              var h = f.charCodeAt(o), l = t.line, T = 1 + o - t.lineStart;
              switch (h) {
                case 65279:
                case 9:
                case 32:
                case 44:
                  ++o;
                  continue;
                case 10:
                  ++o, ++t.line, t.lineStart = o;
                  continue;
                case 13:
                  f.charCodeAt(o + 1) === 10 ? o += 2 : ++o, ++t.line, t.lineStart = o;
                  continue;
                case 33:
                  return new i.Token(c.TokenKind.BANG, o, o + 1, l, T, u);
                case 35:
                  return N(y, o, l, T, u);
                case 36:
                  return new i.Token(c.TokenKind.DOLLAR, o, o + 1, l, T, u);
                case 38:
                  return new i.Token(c.TokenKind.AMP, o, o + 1, l, T, u);
                case 40:
                  return new i.Token(c.TokenKind.PAREN_L, o, o + 1, l, T, u);
                case 41:
                  return new i.Token(c.TokenKind.PAREN_R, o, o + 1, l, T, u);
                case 46:
                  if (f.charCodeAt(o + 1) === 46 && f.charCodeAt(o + 2) === 46) return new i.Token(c.TokenKind.SPREAD, o, o + 3, l, T, u);
                  break;
                case 58:
                  return new i.Token(c.TokenKind.COLON, o, o + 1, l, T, u);
                case 61:
                  return new i.Token(c.TokenKind.EQUALS, o, o + 1, l, T, u);
                case 64:
                  return new i.Token(c.TokenKind.AT, o, o + 1, l, T, u);
                case 91:
                  return new i.Token(c.TokenKind.BRACKET_L, o, o + 1, l, T, u);
                case 93:
                  return new i.Token(c.TokenKind.BRACKET_R, o, o + 1, l, T, u);
                case 123:
                  return new i.Token(c.TokenKind.BRACE_L, o, o + 1, l, T, u);
                case 124:
                  return new i.Token(c.TokenKind.PIPE, o, o + 1, l, T, u);
                case 125:
                  return new i.Token(c.TokenKind.BRACE_R, o, o + 1, l, T, u);
                case 34:
                  return f.charCodeAt(o + 1) === 34 && f.charCodeAt(o + 2) === 34 ? I(y, o, l, T, u, t) : v(y, o, l, T, u);
                case 45:
                case 48:
                case 49:
                case 50:
                case 51:
                case 52:
                case 53:
                case 54:
                case 55:
                case 56:
                case 57:
                  return g(y, o, h, l, T, u);
                case 65:
                case 66:
                case 67:
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 86:
                case 87:
                case 88:
                case 89:
                case 90:
                case 95:
                case 97:
                case 98:
                case 99:
                case 100:
                case 101:
                case 102:
                case 103:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                  return e(y, o, l, T, u);
              }
              throw (0, d.syntaxError)(y, o, A(h));
            }
            var S = t.line, x = 1 + o - t.lineStart;
            return new i.Token(c.TokenKind.EOF, m, m, S, x, u);
          }
          function A(t) {
            return t < 32 && t !== 9 && t !== 10 && t !== 13 ? "Cannot contain the invalid character ".concat(k(t), ".") : t === 39 ? `Unexpected single quote character ('), did you mean to use a double quote (")?` : "Cannot parse the unexpected character ".concat(k(t), ".");
          }
          function N(t, u, y, f, m) {
            var o = t.body, h, l = u;
            do
              h = o.charCodeAt(++l);
            while (!isNaN(h) && (h > 31 || h === 9));
            return new i.Token(c.TokenKind.COMMENT, u, l, y, f, m, o.slice(u + 1, l));
          }
          function g(t, u, y, f, m, o) {
            var h = t.body, l = y, T = u, S = false;
            if (l === 45 && (l = h.charCodeAt(++T)), l === 48) {
              if (l = h.charCodeAt(++T), l >= 48 && l <= 57) throw (0, d.syntaxError)(t, T, "Invalid number, unexpected digit after 0: ".concat(k(l), "."));
            } else T = D(t, T, l), l = h.charCodeAt(T);
            if (l === 46 && (S = true, l = h.charCodeAt(++T), T = D(t, T, l), l = h.charCodeAt(T)), (l === 69 || l === 101) && (S = true, l = h.charCodeAt(++T), (l === 43 || l === 45) && (l = h.charCodeAt(++T)), T = D(t, T, l), l = h.charCodeAt(T)), l === 46 || n(l)) throw (0, d.syntaxError)(t, T, "Invalid number, expected digit but got: ".concat(k(l), "."));
            return new i.Token(S ? c.TokenKind.FLOAT : c.TokenKind.INT, u, T, f, m, o, h.slice(u, T));
          }
          function D(t, u, y) {
            var f = t.body, m = u, o = y;
            if (o >= 48 && o <= 57) {
              do
                o = f.charCodeAt(++m);
              while (o >= 48 && o <= 57);
              return m;
            }
            throw (0, d.syntaxError)(t, m, "Invalid number, expected digit but got: ".concat(k(o), "."));
          }
          function v(t, u, y, f, m) {
            for (var o = t.body, h = u + 1, l = h, T = 0, S = ""; h < o.length && !isNaN(T = o.charCodeAt(h)) && T !== 10 && T !== 13; ) {
              if (T === 34) return S += o.slice(l, h), new i.Token(c.TokenKind.STRING, u, h + 1, y, f, m, S);
              if (T < 32 && T !== 9) throw (0, d.syntaxError)(t, h, "Invalid character within String: ".concat(k(T), "."));
              if (++h, T === 92) {
                switch (S += o.slice(l, h - 1), T = o.charCodeAt(h), T) {
                  case 34:
                    S += '"';
                    break;
                  case 47:
                    S += "/";
                    break;
                  case 92:
                    S += "\\";
                    break;
                  case 98:
                    S += "\b";
                    break;
                  case 102:
                    S += "\f";
                    break;
                  case 110:
                    S += `
`;
                    break;
                  case 114:
                    S += "\r";
                    break;
                  case 116:
                    S += "	";
                    break;
                  case 117: {
                    var x = s(o.charCodeAt(h + 1), o.charCodeAt(h + 2), o.charCodeAt(h + 3), o.charCodeAt(h + 4));
                    if (x < 0) {
                      var b = o.slice(h + 1, h + 5);
                      throw (0, d.syntaxError)(t, h, "Invalid character escape sequence: \\u".concat(b, "."));
                    }
                    S += String.fromCharCode(x), h += 4;
                    break;
                  }
                  default:
                    throw (0, d.syntaxError)(t, h, "Invalid character escape sequence: \\".concat(String.fromCharCode(T), "."));
                }
                ++h, l = h;
              }
            }
            throw (0, d.syntaxError)(t, h, "Unterminated string.");
          }
          function I(t, u, y, f, m, o) {
            for (var h = t.body, l = u + 3, T = l, S = 0, x = ""; l < h.length && !isNaN(S = h.charCodeAt(l)); ) {
              if (S === 34 && h.charCodeAt(l + 1) === 34 && h.charCodeAt(l + 2) === 34) return x += h.slice(T, l), new i.Token(c.TokenKind.BLOCK_STRING, u, l + 3, y, f, m, (0, r.dedentBlockStringValue)(x));
              if (S < 32 && S !== 9 && S !== 10 && S !== 13) throw (0, d.syntaxError)(t, l, "Invalid character within String: ".concat(k(S), "."));
              S === 10 ? (++l, ++o.line, o.lineStart = l) : S === 13 ? (h.charCodeAt(l + 1) === 10 ? l += 2 : ++l, ++o.line, o.lineStart = l) : S === 92 && h.charCodeAt(l + 1) === 34 && h.charCodeAt(l + 2) === 34 && h.charCodeAt(l + 3) === 34 ? (x += h.slice(T, l) + '"""', l += 4, T = l) : ++l;
            }
            throw (0, d.syntaxError)(t, l, "Unterminated string.");
          }
          function s(t, u, y, f) {
            return p(t) << 12 | p(u) << 8 | p(y) << 4 | p(f);
          }
          function p(t) {
            return t >= 48 && t <= 57 ? t - 48 : t >= 65 && t <= 70 ? t - 55 : t >= 97 && t <= 102 ? t - 87 : -1;
          }
          function e(t, u, y, f, m) {
            for (var o = t.body, h = o.length, l = u + 1, T = 0; l !== h && !isNaN(T = o.charCodeAt(l)) && (T === 95 || T >= 48 && T <= 57 || T >= 65 && T <= 90 || T >= 97 && T <= 122); ) ++l;
            return new i.Token(c.TokenKind.NAME, u, l, y, f, m, o.slice(u, l));
          }
          function n(t) {
            return t === 95 || t >= 65 && t <= 90 || t >= 97 && t <= 122;
          }
        } }), Oe = L({ "node_modules/graphql/language/parser.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.parse = O, a.parseValue = A, a.parseType = N, a.Parser = void 0;
          var d = Z(), i = he(), c = te(), r = ne(), _ = me(), E = ye(), k = Ne();
          function O(I, s) {
            var p = new g(I, s);
            return p.parseDocument();
          }
          function A(I, s) {
            var p = new g(I, s);
            p.expectToken(r.TokenKind.SOF);
            var e = p.parseValueLiteral(false);
            return p.expectToken(r.TokenKind.EOF), e;
          }
          function N(I, s) {
            var p = new g(I, s);
            p.expectToken(r.TokenKind.SOF);
            var e = p.parseTypeReference();
            return p.expectToken(r.TokenKind.EOF), e;
          }
          var g = function() {
            function I(p, e) {
              var n = (0, _.isSource)(p) ? p : new _.Source(p);
              this._lexer = new k.Lexer(n), this._options = e;
            }
            var s = I.prototype;
            return s.parseName = function() {
              var e = this.expectToken(r.TokenKind.NAME);
              return { kind: i.Kind.NAME, value: e.value, loc: this.loc(e) };
            }, s.parseDocument = function() {
              var e = this._lexer.token;
              return { kind: i.Kind.DOCUMENT, definitions: this.many(r.TokenKind.SOF, this.parseDefinition, r.TokenKind.EOF), loc: this.loc(e) };
            }, s.parseDefinition = function() {
              if (this.peek(r.TokenKind.NAME)) switch (this._lexer.token.value) {
                case "query":
                case "mutation":
                case "subscription":
                  return this.parseOperationDefinition();
                case "fragment":
                  return this.parseFragmentDefinition();
                case "schema":
                case "scalar":
                case "type":
                case "interface":
                case "union":
                case "enum":
                case "input":
                case "directive":
                  return this.parseTypeSystemDefinition();
                case "extend":
                  return this.parseTypeSystemExtension();
              }
              else {
                if (this.peek(r.TokenKind.BRACE_L)) return this.parseOperationDefinition();
                if (this.peekDescription()) return this.parseTypeSystemDefinition();
              }
              throw this.unexpected();
            }, s.parseOperationDefinition = function() {
              var e = this._lexer.token;
              if (this.peek(r.TokenKind.BRACE_L)) return { kind: i.Kind.OPERATION_DEFINITION, operation: "query", name: void 0, variableDefinitions: [], directives: [], selectionSet: this.parseSelectionSet(), loc: this.loc(e) };
              var n = this.parseOperationType(), t;
              return this.peek(r.TokenKind.NAME) && (t = this.parseName()), { kind: i.Kind.OPERATION_DEFINITION, operation: n, name: t, variableDefinitions: this.parseVariableDefinitions(), directives: this.parseDirectives(false), selectionSet: this.parseSelectionSet(), loc: this.loc(e) };
            }, s.parseOperationType = function() {
              var e = this.expectToken(r.TokenKind.NAME);
              switch (e.value) {
                case "query":
                  return "query";
                case "mutation":
                  return "mutation";
                case "subscription":
                  return "subscription";
              }
              throw this.unexpected(e);
            }, s.parseVariableDefinitions = function() {
              return this.optionalMany(r.TokenKind.PAREN_L, this.parseVariableDefinition, r.TokenKind.PAREN_R);
            }, s.parseVariableDefinition = function() {
              var e = this._lexer.token;
              return { kind: i.Kind.VARIABLE_DEFINITION, variable: this.parseVariable(), type: (this.expectToken(r.TokenKind.COLON), this.parseTypeReference()), defaultValue: this.expectOptionalToken(r.TokenKind.EQUALS) ? this.parseValueLiteral(true) : void 0, directives: this.parseDirectives(true), loc: this.loc(e) };
            }, s.parseVariable = function() {
              var e = this._lexer.token;
              return this.expectToken(r.TokenKind.DOLLAR), { kind: i.Kind.VARIABLE, name: this.parseName(), loc: this.loc(e) };
            }, s.parseSelectionSet = function() {
              var e = this._lexer.token;
              return { kind: i.Kind.SELECTION_SET, selections: this.many(r.TokenKind.BRACE_L, this.parseSelection, r.TokenKind.BRACE_R), loc: this.loc(e) };
            }, s.parseSelection = function() {
              return this.peek(r.TokenKind.SPREAD) ? this.parseFragment() : this.parseField();
            }, s.parseField = function() {
              var e = this._lexer.token, n = this.parseName(), t, u;
              return this.expectOptionalToken(r.TokenKind.COLON) ? (t = n, u = this.parseName()) : u = n, { kind: i.Kind.FIELD, alias: t, name: u, arguments: this.parseArguments(false), directives: this.parseDirectives(false), selectionSet: this.peek(r.TokenKind.BRACE_L) ? this.parseSelectionSet() : void 0, loc: this.loc(e) };
            }, s.parseArguments = function(e) {
              var n = e ? this.parseConstArgument : this.parseArgument;
              return this.optionalMany(r.TokenKind.PAREN_L, n, r.TokenKind.PAREN_R);
            }, s.parseArgument = function() {
              var e = this._lexer.token, n = this.parseName();
              return this.expectToken(r.TokenKind.COLON), { kind: i.Kind.ARGUMENT, name: n, value: this.parseValueLiteral(false), loc: this.loc(e) };
            }, s.parseConstArgument = function() {
              var e = this._lexer.token;
              return { kind: i.Kind.ARGUMENT, name: this.parseName(), value: (this.expectToken(r.TokenKind.COLON), this.parseValueLiteral(true)), loc: this.loc(e) };
            }, s.parseFragment = function() {
              var e = this._lexer.token;
              this.expectToken(r.TokenKind.SPREAD);
              var n = this.expectOptionalKeyword("on");
              return !n && this.peek(r.TokenKind.NAME) ? { kind: i.Kind.FRAGMENT_SPREAD, name: this.parseFragmentName(), directives: this.parseDirectives(false), loc: this.loc(e) } : { kind: i.Kind.INLINE_FRAGMENT, typeCondition: n ? this.parseNamedType() : void 0, directives: this.parseDirectives(false), selectionSet: this.parseSelectionSet(), loc: this.loc(e) };
            }, s.parseFragmentDefinition = function() {
              var e, n = this._lexer.token;
              return this.expectKeyword("fragment"), ((e = this._options) === null || e === void 0 ? void 0 : e.experimentalFragmentVariables) === true ? { kind: i.Kind.FRAGMENT_DEFINITION, name: this.parseFragmentName(), variableDefinitions: this.parseVariableDefinitions(), typeCondition: (this.expectKeyword("on"), this.parseNamedType()), directives: this.parseDirectives(false), selectionSet: this.parseSelectionSet(), loc: this.loc(n) } : { kind: i.Kind.FRAGMENT_DEFINITION, name: this.parseFragmentName(), typeCondition: (this.expectKeyword("on"), this.parseNamedType()), directives: this.parseDirectives(false), selectionSet: this.parseSelectionSet(), loc: this.loc(n) };
            }, s.parseFragmentName = function() {
              if (this._lexer.token.value === "on") throw this.unexpected();
              return this.parseName();
            }, s.parseValueLiteral = function(e) {
              var n = this._lexer.token;
              switch (n.kind) {
                case r.TokenKind.BRACKET_L:
                  return this.parseList(e);
                case r.TokenKind.BRACE_L:
                  return this.parseObject(e);
                case r.TokenKind.INT:
                  return this._lexer.advance(), { kind: i.Kind.INT, value: n.value, loc: this.loc(n) };
                case r.TokenKind.FLOAT:
                  return this._lexer.advance(), { kind: i.Kind.FLOAT, value: n.value, loc: this.loc(n) };
                case r.TokenKind.STRING:
                case r.TokenKind.BLOCK_STRING:
                  return this.parseStringLiteral();
                case r.TokenKind.NAME:
                  switch (this._lexer.advance(), n.value) {
                    case "true":
                      return { kind: i.Kind.BOOLEAN, value: true, loc: this.loc(n) };
                    case "false":
                      return { kind: i.Kind.BOOLEAN, value: false, loc: this.loc(n) };
                    case "null":
                      return { kind: i.Kind.NULL, loc: this.loc(n) };
                    default:
                      return { kind: i.Kind.ENUM, value: n.value, loc: this.loc(n) };
                  }
                case r.TokenKind.DOLLAR:
                  if (!e) return this.parseVariable();
                  break;
              }
              throw this.unexpected();
            }, s.parseStringLiteral = function() {
              var e = this._lexer.token;
              return this._lexer.advance(), { kind: i.Kind.STRING, value: e.value, block: e.kind === r.TokenKind.BLOCK_STRING, loc: this.loc(e) };
            }, s.parseList = function(e) {
              var n = this, t = this._lexer.token, u = function() {
                return n.parseValueLiteral(e);
              };
              return { kind: i.Kind.LIST, values: this.any(r.TokenKind.BRACKET_L, u, r.TokenKind.BRACKET_R), loc: this.loc(t) };
            }, s.parseObject = function(e) {
              var n = this, t = this._lexer.token, u = function() {
                return n.parseObjectField(e);
              };
              return { kind: i.Kind.OBJECT, fields: this.any(r.TokenKind.BRACE_L, u, r.TokenKind.BRACE_R), loc: this.loc(t) };
            }, s.parseObjectField = function(e) {
              var n = this._lexer.token, t = this.parseName();
              return this.expectToken(r.TokenKind.COLON), { kind: i.Kind.OBJECT_FIELD, name: t, value: this.parseValueLiteral(e), loc: this.loc(n) };
            }, s.parseDirectives = function(e) {
              for (var n = []; this.peek(r.TokenKind.AT); ) n.push(this.parseDirective(e));
              return n;
            }, s.parseDirective = function(e) {
              var n = this._lexer.token;
              return this.expectToken(r.TokenKind.AT), { kind: i.Kind.DIRECTIVE, name: this.parseName(), arguments: this.parseArguments(e), loc: this.loc(n) };
            }, s.parseTypeReference = function() {
              var e = this._lexer.token, n;
              return this.expectOptionalToken(r.TokenKind.BRACKET_L) ? (n = this.parseTypeReference(), this.expectToken(r.TokenKind.BRACKET_R), n = { kind: i.Kind.LIST_TYPE, type: n, loc: this.loc(e) }) : n = this.parseNamedType(), this.expectOptionalToken(r.TokenKind.BANG) ? { kind: i.Kind.NON_NULL_TYPE, type: n, loc: this.loc(e) } : n;
            }, s.parseNamedType = function() {
              var e = this._lexer.token;
              return { kind: i.Kind.NAMED_TYPE, name: this.parseName(), loc: this.loc(e) };
            }, s.parseTypeSystemDefinition = function() {
              var e = this.peekDescription() ? this._lexer.lookahead() : this._lexer.token;
              if (e.kind === r.TokenKind.NAME) switch (e.value) {
                case "schema":
                  return this.parseSchemaDefinition();
                case "scalar":
                  return this.parseScalarTypeDefinition();
                case "type":
                  return this.parseObjectTypeDefinition();
                case "interface":
                  return this.parseInterfaceTypeDefinition();
                case "union":
                  return this.parseUnionTypeDefinition();
                case "enum":
                  return this.parseEnumTypeDefinition();
                case "input":
                  return this.parseInputObjectTypeDefinition();
                case "directive":
                  return this.parseDirectiveDefinition();
              }
              throw this.unexpected(e);
            }, s.peekDescription = function() {
              return this.peek(r.TokenKind.STRING) || this.peek(r.TokenKind.BLOCK_STRING);
            }, s.parseDescription = function() {
              if (this.peekDescription()) return this.parseStringLiteral();
            }, s.parseSchemaDefinition = function() {
              var e = this._lexer.token, n = this.parseDescription();
              this.expectKeyword("schema");
              var t = this.parseDirectives(true), u = this.many(r.TokenKind.BRACE_L, this.parseOperationTypeDefinition, r.TokenKind.BRACE_R);
              return { kind: i.Kind.SCHEMA_DEFINITION, description: n, directives: t, operationTypes: u, loc: this.loc(e) };
            }, s.parseOperationTypeDefinition = function() {
              var e = this._lexer.token, n = this.parseOperationType();
              this.expectToken(r.TokenKind.COLON);
              var t = this.parseNamedType();
              return { kind: i.Kind.OPERATION_TYPE_DEFINITION, operation: n, type: t, loc: this.loc(e) };
            }, s.parseScalarTypeDefinition = function() {
              var e = this._lexer.token, n = this.parseDescription();
              this.expectKeyword("scalar");
              var t = this.parseName(), u = this.parseDirectives(true);
              return { kind: i.Kind.SCALAR_TYPE_DEFINITION, description: n, name: t, directives: u, loc: this.loc(e) };
            }, s.parseObjectTypeDefinition = function() {
              var e = this._lexer.token, n = this.parseDescription();
              this.expectKeyword("type");
              var t = this.parseName(), u = this.parseImplementsInterfaces(), y = this.parseDirectives(true), f = this.parseFieldsDefinition();
              return { kind: i.Kind.OBJECT_TYPE_DEFINITION, description: n, name: t, interfaces: u, directives: y, fields: f, loc: this.loc(e) };
            }, s.parseImplementsInterfaces = function() {
              var e;
              if (!this.expectOptionalKeyword("implements")) return [];
              if (((e = this._options) === null || e === void 0 ? void 0 : e.allowLegacySDLImplementsInterfaces) === true) {
                var n = [];
                this.expectOptionalToken(r.TokenKind.AMP);
                do
                  n.push(this.parseNamedType());
                while (this.expectOptionalToken(r.TokenKind.AMP) || this.peek(r.TokenKind.NAME));
                return n;
              }
              return this.delimitedMany(r.TokenKind.AMP, this.parseNamedType);
            }, s.parseFieldsDefinition = function() {
              var e;
              return ((e = this._options) === null || e === void 0 ? void 0 : e.allowLegacySDLEmptyFields) === true && this.peek(r.TokenKind.BRACE_L) && this._lexer.lookahead().kind === r.TokenKind.BRACE_R ? (this._lexer.advance(), this._lexer.advance(), []) : this.optionalMany(r.TokenKind.BRACE_L, this.parseFieldDefinition, r.TokenKind.BRACE_R);
            }, s.parseFieldDefinition = function() {
              var e = this._lexer.token, n = this.parseDescription(), t = this.parseName(), u = this.parseArgumentDefs();
              this.expectToken(r.TokenKind.COLON);
              var y = this.parseTypeReference(), f = this.parseDirectives(true);
              return { kind: i.Kind.FIELD_DEFINITION, description: n, name: t, arguments: u, type: y, directives: f, loc: this.loc(e) };
            }, s.parseArgumentDefs = function() {
              return this.optionalMany(r.TokenKind.PAREN_L, this.parseInputValueDef, r.TokenKind.PAREN_R);
            }, s.parseInputValueDef = function() {
              var e = this._lexer.token, n = this.parseDescription(), t = this.parseName();
              this.expectToken(r.TokenKind.COLON);
              var u = this.parseTypeReference(), y;
              this.expectOptionalToken(r.TokenKind.EQUALS) && (y = this.parseValueLiteral(true));
              var f = this.parseDirectives(true);
              return { kind: i.Kind.INPUT_VALUE_DEFINITION, description: n, name: t, type: u, defaultValue: y, directives: f, loc: this.loc(e) };
            }, s.parseInterfaceTypeDefinition = function() {
              var e = this._lexer.token, n = this.parseDescription();
              this.expectKeyword("interface");
              var t = this.parseName(), u = this.parseImplementsInterfaces(), y = this.parseDirectives(true), f = this.parseFieldsDefinition();
              return { kind: i.Kind.INTERFACE_TYPE_DEFINITION, description: n, name: t, interfaces: u, directives: y, fields: f, loc: this.loc(e) };
            }, s.parseUnionTypeDefinition = function() {
              var e = this._lexer.token, n = this.parseDescription();
              this.expectKeyword("union");
              var t = this.parseName(), u = this.parseDirectives(true), y = this.parseUnionMemberTypes();
              return { kind: i.Kind.UNION_TYPE_DEFINITION, description: n, name: t, directives: u, types: y, loc: this.loc(e) };
            }, s.parseUnionMemberTypes = function() {
              return this.expectOptionalToken(r.TokenKind.EQUALS) ? this.delimitedMany(r.TokenKind.PIPE, this.parseNamedType) : [];
            }, s.parseEnumTypeDefinition = function() {
              var e = this._lexer.token, n = this.parseDescription();
              this.expectKeyword("enum");
              var t = this.parseName(), u = this.parseDirectives(true), y = this.parseEnumValuesDefinition();
              return { kind: i.Kind.ENUM_TYPE_DEFINITION, description: n, name: t, directives: u, values: y, loc: this.loc(e) };
            }, s.parseEnumValuesDefinition = function() {
              return this.optionalMany(r.TokenKind.BRACE_L, this.parseEnumValueDefinition, r.TokenKind.BRACE_R);
            }, s.parseEnumValueDefinition = function() {
              var e = this._lexer.token, n = this.parseDescription(), t = this.parseName(), u = this.parseDirectives(true);
              return { kind: i.Kind.ENUM_VALUE_DEFINITION, description: n, name: t, directives: u, loc: this.loc(e) };
            }, s.parseInputObjectTypeDefinition = function() {
              var e = this._lexer.token, n = this.parseDescription();
              this.expectKeyword("input");
              var t = this.parseName(), u = this.parseDirectives(true), y = this.parseInputFieldsDefinition();
              return { kind: i.Kind.INPUT_OBJECT_TYPE_DEFINITION, description: n, name: t, directives: u, fields: y, loc: this.loc(e) };
            }, s.parseInputFieldsDefinition = function() {
              return this.optionalMany(r.TokenKind.BRACE_L, this.parseInputValueDef, r.TokenKind.BRACE_R);
            }, s.parseTypeSystemExtension = function() {
              var e = this._lexer.lookahead();
              if (e.kind === r.TokenKind.NAME) switch (e.value) {
                case "schema":
                  return this.parseSchemaExtension();
                case "scalar":
                  return this.parseScalarTypeExtension();
                case "type":
                  return this.parseObjectTypeExtension();
                case "interface":
                  return this.parseInterfaceTypeExtension();
                case "union":
                  return this.parseUnionTypeExtension();
                case "enum":
                  return this.parseEnumTypeExtension();
                case "input":
                  return this.parseInputObjectTypeExtension();
              }
              throw this.unexpected(e);
            }, s.parseSchemaExtension = function() {
              var e = this._lexer.token;
              this.expectKeyword("extend"), this.expectKeyword("schema");
              var n = this.parseDirectives(true), t = this.optionalMany(r.TokenKind.BRACE_L, this.parseOperationTypeDefinition, r.TokenKind.BRACE_R);
              if (n.length === 0 && t.length === 0) throw this.unexpected();
              return { kind: i.Kind.SCHEMA_EXTENSION, directives: n, operationTypes: t, loc: this.loc(e) };
            }, s.parseScalarTypeExtension = function() {
              var e = this._lexer.token;
              this.expectKeyword("extend"), this.expectKeyword("scalar");
              var n = this.parseName(), t = this.parseDirectives(true);
              if (t.length === 0) throw this.unexpected();
              return { kind: i.Kind.SCALAR_TYPE_EXTENSION, name: n, directives: t, loc: this.loc(e) };
            }, s.parseObjectTypeExtension = function() {
              var e = this._lexer.token;
              this.expectKeyword("extend"), this.expectKeyword("type");
              var n = this.parseName(), t = this.parseImplementsInterfaces(), u = this.parseDirectives(true), y = this.parseFieldsDefinition();
              if (t.length === 0 && u.length === 0 && y.length === 0) throw this.unexpected();
              return { kind: i.Kind.OBJECT_TYPE_EXTENSION, name: n, interfaces: t, directives: u, fields: y, loc: this.loc(e) };
            }, s.parseInterfaceTypeExtension = function() {
              var e = this._lexer.token;
              this.expectKeyword("extend"), this.expectKeyword("interface");
              var n = this.parseName(), t = this.parseImplementsInterfaces(), u = this.parseDirectives(true), y = this.parseFieldsDefinition();
              if (t.length === 0 && u.length === 0 && y.length === 0) throw this.unexpected();
              return { kind: i.Kind.INTERFACE_TYPE_EXTENSION, name: n, interfaces: t, directives: u, fields: y, loc: this.loc(e) };
            }, s.parseUnionTypeExtension = function() {
              var e = this._lexer.token;
              this.expectKeyword("extend"), this.expectKeyword("union");
              var n = this.parseName(), t = this.parseDirectives(true), u = this.parseUnionMemberTypes();
              if (t.length === 0 && u.length === 0) throw this.unexpected();
              return { kind: i.Kind.UNION_TYPE_EXTENSION, name: n, directives: t, types: u, loc: this.loc(e) };
            }, s.parseEnumTypeExtension = function() {
              var e = this._lexer.token;
              this.expectKeyword("extend"), this.expectKeyword("enum");
              var n = this.parseName(), t = this.parseDirectives(true), u = this.parseEnumValuesDefinition();
              if (t.length === 0 && u.length === 0) throw this.unexpected();
              return { kind: i.Kind.ENUM_TYPE_EXTENSION, name: n, directives: t, values: u, loc: this.loc(e) };
            }, s.parseInputObjectTypeExtension = function() {
              var e = this._lexer.token;
              this.expectKeyword("extend"), this.expectKeyword("input");
              var n = this.parseName(), t = this.parseDirectives(true), u = this.parseInputFieldsDefinition();
              if (t.length === 0 && u.length === 0) throw this.unexpected();
              return { kind: i.Kind.INPUT_OBJECT_TYPE_EXTENSION, name: n, directives: t, fields: u, loc: this.loc(e) };
            }, s.parseDirectiveDefinition = function() {
              var e = this._lexer.token, n = this.parseDescription();
              this.expectKeyword("directive"), this.expectToken(r.TokenKind.AT);
              var t = this.parseName(), u = this.parseArgumentDefs(), y = this.expectOptionalKeyword("repeatable");
              this.expectKeyword("on");
              var f = this.parseDirectiveLocations();
              return { kind: i.Kind.DIRECTIVE_DEFINITION, description: n, name: t, arguments: u, repeatable: y, locations: f, loc: this.loc(e) };
            }, s.parseDirectiveLocations = function() {
              return this.delimitedMany(r.TokenKind.PIPE, this.parseDirectiveLocation);
            }, s.parseDirectiveLocation = function() {
              var e = this._lexer.token, n = this.parseName();
              if (E.DirectiveLocation[n.value] !== void 0) return n;
              throw this.unexpected(e);
            }, s.loc = function(e) {
              var n;
              if (((n = this._options) === null || n === void 0 ? void 0 : n.noLocation) !== true) return new c.Location(e, this._lexer.lastToken, this._lexer.source);
            }, s.peek = function(e) {
              return this._lexer.token.kind === e;
            }, s.expectToken = function(e) {
              var n = this._lexer.token;
              if (n.kind === e) return this._lexer.advance(), n;
              throw (0, d.syntaxError)(this._lexer.source, n.start, "Expected ".concat(v(e), ", found ").concat(D(n), "."));
            }, s.expectOptionalToken = function(e) {
              var n = this._lexer.token;
              if (n.kind === e) return this._lexer.advance(), n;
            }, s.expectKeyword = function(e) {
              var n = this._lexer.token;
              if (n.kind === r.TokenKind.NAME && n.value === e) this._lexer.advance();
              else throw (0, d.syntaxError)(this._lexer.source, n.start, 'Expected "'.concat(e, '", found ').concat(D(n), "."));
            }, s.expectOptionalKeyword = function(e) {
              var n = this._lexer.token;
              return n.kind === r.TokenKind.NAME && n.value === e ? (this._lexer.advance(), true) : false;
            }, s.unexpected = function(e) {
              var n = e != null ? e : this._lexer.token;
              return (0, d.syntaxError)(this._lexer.source, n.start, "Unexpected ".concat(D(n), "."));
            }, s.any = function(e, n, t) {
              this.expectToken(e);
              for (var u = []; !this.expectOptionalToken(t); ) u.push(n.call(this));
              return u;
            }, s.optionalMany = function(e, n, t) {
              if (this.expectOptionalToken(e)) {
                var u = [];
                do
                  u.push(n.call(this));
                while (!this.expectOptionalToken(t));
                return u;
              }
              return [];
            }, s.many = function(e, n, t) {
              this.expectToken(e);
              var u = [];
              do
                u.push(n.call(this));
              while (!this.expectOptionalToken(t));
              return u;
            }, s.delimitedMany = function(e, n) {
              this.expectOptionalToken(e);
              var t = [];
              do
                t.push(n.call(this));
              while (this.expectOptionalToken(e));
              return t;
            }, I;
          }();
          a.Parser = g;
          function D(I) {
            var s = I.value;
            return v(I.kind) + (s != null ? ' "'.concat(s, '"') : "");
          }
          function v(I) {
            return (0, k.isPunctuatorTokenKind)(I) ? '"'.concat(I, '"') : I;
          }
        } });
        K();
        var Ie = ce(), ge = ue(), { hasPragma: Se } = le(), { locStart: Ae, locEnd: De } = pe();
        function Ke(a) {
          let d = [], { startToken: i } = a.loc, { next: c } = i;
          for (; c.kind !== "<EOF>"; ) c.kind === "Comment" && (Object.assign(c, { column: c.column - 1 }), d.push(c)), c = c.next;
          return d;
        }
        function ie(a) {
          if (a && typeof a == "object") {
            delete a.startToken, delete a.endToken, delete a.prev, delete a.next;
            for (let d in a) ie(a[d]);
          }
          return a;
        }
        var X = { allowLegacySDLImplementsInterfaces: false, experimentalFragmentVariables: true };
        function Le(a) {
          let { GraphQLError: d } = W();
          if (a instanceof d) {
            let { message: i, locations: [c] } = a;
            return Ie(i, { start: c });
          }
          return a;
        }
        function xe(a) {
          let { parse: d } = Oe(), { result: i, error: c } = ge(() => d(a, Object.assign({}, X)), () => d(a, Object.assign(Object.assign({}, X), {}, { allowLegacySDLImplementsInterfaces: true })));
          if (!i) throw Le(c);
          return i.comments = Ke(i), ie(i), i;
        }
        ae.exports = { parsers: { graphql: { parse: xe, astFormat: "graphql", hasPragma: Se, locStart: Ae, locEnd: De } } };
      });
      return be();
    });
  }
});

// ../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-markdown.js
var require_parser_markdown = __commonJS({
  "../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-markdown.js"(exports2, module2) {
    "use strict";
    (function(e) {
      if (typeof exports2 == "object" && typeof module2 == "object") module2.exports = e();
      else if (typeof define == "function" && define.amd) define(e);
      else {
        var i = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i.prettierPlugins = i.prettierPlugins || {}, i.prettierPlugins.markdown = e();
      }
    })(function() {
      "use strict";
      var H = (e, r) => () => (r || e((r = { exports: {} }).exports, r), r.exports);
      var ue = H((uf, Au) => {
        var ur = function(e) {
          return e && e.Math == Math && e;
        };
        Au.exports = ur(typeof globalThis == "object" && globalThis) || ur(typeof window == "object" && window) || ur(typeof self == "object" && self) || ur(typeof global == "object" && global) || /* @__PURE__ */ function() {
          return this;
        }() || Function("return this")();
      });
      var Ae = H((tf, xu) => {
        xu.exports = function(e) {
          try {
            return !!e();
          } catch {
            return true;
          }
        };
      });
      var _e = H((nf, bu) => {
        var ca = Ae();
        bu.exports = !ca(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      });
      var tr = H((af, yu) => {
        var la = Ae();
        yu.exports = !la(function() {
          var e = function() {
          }.bind();
          return typeof e != "function" || e.hasOwnProperty("prototype");
        });
      });
      var Oe = H((of, Bu) => {
        var Da = tr(), nr = Function.prototype.call;
        Bu.exports = Da ? nr.bind(nr) : function() {
          return nr.apply(nr, arguments);
        };
      });
      var _u = H((qu) => {
        "use strict";
        var wu = {}.propertyIsEnumerable, ku = Object.getOwnPropertyDescriptor, fa = ku && !wu.call({ 1: 2 }, 1);
        qu.f = fa ? function(r) {
          var u = ku(this, r);
          return !!u && u.enumerable;
        } : wu;
      });
      var ir = H((cf, Ou) => {
        Ou.exports = function(e, r) {
          return { enumerable: !(e & 1), configurable: !(e & 2), writable: !(e & 4), value: r };
        };
      });
      var ve = H((lf, Tu) => {
        var Iu = tr(), Su = Function.prototype, pa = Su.bind, Br = Su.call, da = Iu && pa.bind(Br, Br);
        Tu.exports = Iu ? function(e) {
          return e && da(e);
        } : function(e) {
          return e && function() {
            return Br.apply(e, arguments);
          };
        };
      });
      var ar = H((Df, Lu) => {
        var Nu = ve(), ha = Nu({}.toString), va = Nu("".slice);
        Lu.exports = function(e) {
          return va(ha(e), 8, -1);
        };
      });
      var ju = H((ff, Ru) => {
        var ma = ue(), Ea = ve(), Ca = Ae(), ga = ar(), wr = ma.Object, Fa = Ea("".split);
        Ru.exports = Ca(function() {
          return !wr("z").propertyIsEnumerable(0);
        }) ? function(e) {
          return ga(e) == "String" ? Fa(e, "") : wr(e);
        } : wr;
      });
      var kr = H((pf, Pu) => {
        var Aa = ue(), xa = Aa.TypeError;
        Pu.exports = function(e) {
          if (e == null) throw xa("Can't call method on " + e);
          return e;
        };
      });
      var or = H((df, Mu) => {
        var ba = ju(), ya = kr();
        Mu.exports = function(e) {
          return ba(ya(e));
        };
      });
      var me = H((hf, zu) => {
        zu.exports = function(e) {
          return typeof e == "function";
        };
      });
      var Ie = H((vf, Gu) => {
        var Ba = me();
        Gu.exports = function(e) {
          return typeof e == "object" ? e !== null : Ba(e);
        };
      });
      var He = H((mf, Uu) => {
        var qr = ue(), wa = me(), ka = function(e) {
          return wa(e) ? e : void 0;
        };
        Uu.exports = function(e, r) {
          return arguments.length < 2 ? ka(qr[e]) : qr[e] && qr[e][r];
        };
      });
      var _r = H((Ef, Vu) => {
        var qa = ve();
        Vu.exports = qa({}.isPrototypeOf);
      });
      var Hu = H((Cf, $u) => {
        var _a = He();
        $u.exports = _a("navigator", "userAgent") || "";
      });
      var Qu = H((gf, Zu) => {
        var Ju = ue(), Or = Hu(), Xu = Ju.process, Wu = Ju.Deno, Ku = Xu && Xu.versions || Wu && Wu.version, Yu = Ku && Ku.v8, Ee, sr;
        Yu && (Ee = Yu.split("."), sr = Ee[0] > 0 && Ee[0] < 4 ? 1 : +(Ee[0] + Ee[1]));
        !sr && Or && (Ee = Or.match(/Edge\/(\d+)/), (!Ee || Ee[1] >= 74) && (Ee = Or.match(/Chrome\/(\d+)/), Ee && (sr = +Ee[1])));
        Zu.exports = sr;
      });
      var Ir = H((Ff, rt) => {
        var et = Qu(), Oa = Ae();
        rt.exports = !!Object.getOwnPropertySymbols && !Oa(function() {
          var e = Symbol();
          return !String(e) || !(Object(e) instanceof Symbol) || !Symbol.sham && et && et < 41;
        });
      });
      var Sr = H((Af, ut) => {
        var Ia = Ir();
        ut.exports = Ia && !Symbol.sham && typeof Symbol.iterator == "symbol";
      });
      var Tr = H((xf, tt) => {
        var Sa = ue(), Ta = He(), Na = me(), La = _r(), Ra = Sr(), ja = Sa.Object;
        tt.exports = Ra ? function(e) {
          return typeof e == "symbol";
        } : function(e) {
          var r = Ta("Symbol");
          return Na(r) && La(r.prototype, ja(e));
        };
      });
      var cr = H((bf, nt) => {
        var Pa = ue(), Ma = Pa.String;
        nt.exports = function(e) {
          try {
            return Ma(e);
          } catch {
            return "Object";
          }
        };
      });
      var Xe = H((yf, it) => {
        var za = ue(), Ga = me(), Ua = cr(), Va = za.TypeError;
        it.exports = function(e) {
          if (Ga(e)) return e;
          throw Va(Ua(e) + " is not a function");
        };
      });
      var lr = H((Bf, at) => {
        var $a = Xe();
        at.exports = function(e, r) {
          var u = e[r];
          return u == null ? void 0 : $a(u);
        };
      });
      var st = H((wf, ot) => {
        var Ha = ue(), Nr = Oe(), Lr = me(), Rr = Ie(), Xa = Ha.TypeError;
        ot.exports = function(e, r) {
          var u, t;
          if (r === "string" && Lr(u = e.toString) && !Rr(t = Nr(u, e)) || Lr(u = e.valueOf) && !Rr(t = Nr(u, e)) || r !== "string" && Lr(u = e.toString) && !Rr(t = Nr(u, e))) return t;
          throw Xa("Can't convert object to primitive value");
        };
      });
      var lt = H((kf, ct) => {
        ct.exports = false;
      });
      var Dr = H((qf, ft) => {
        var Dt = ue(), Wa = Object.defineProperty;
        ft.exports = function(e, r) {
          try {
            Wa(Dt, e, { value: r, configurable: true, writable: true });
          } catch {
            Dt[e] = r;
          }
          return r;
        };
      });
      var fr = H((_f, dt) => {
        var Ka = ue(), Ya = Dr(), pt = "__core-js_shared__", Ja = Ka[pt] || Ya(pt, {});
        dt.exports = Ja;
      });
      var jr = H((Of, vt) => {
        var Za = lt(), ht = fr();
        (vt.exports = function(e, r) {
          return ht[e] || (ht[e] = r !== void 0 ? r : {});
        })("versions", []).push({ version: "3.22.2", mode: Za ? "pure" : "global", copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)", license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE", source: "https://github.com/zloirock/core-js" });
      });
      var Pr = H((If, mt) => {
        var Qa = ue(), eo = kr(), ro = Qa.Object;
        mt.exports = function(e) {
          return ro(eo(e));
        };
      });
      var Be = H((Sf, Et) => {
        var uo = ve(), to = Pr(), no = uo({}.hasOwnProperty);
        Et.exports = Object.hasOwn || function(r, u) {
          return no(to(r), u);
        };
      });
      var Mr = H((Tf, Ct) => {
        var io = ve(), ao = 0, oo = Math.random(), so = io(1 .toString);
        Ct.exports = function(e) {
          return "Symbol(" + (e === void 0 ? "" : e) + ")_" + so(++ao + oo, 36);
        };
      });
      var Te = H((Nf, bt) => {
        var co = ue(), lo = jr(), gt = Be(), Do = Mr(), Ft = Ir(), xt = Sr(), Le = lo("wks"), Se = co.Symbol, At = Se && Se.for, fo = xt ? Se : Se && Se.withoutSetter || Do;
        bt.exports = function(e) {
          if (!gt(Le, e) || !(Ft || typeof Le[e] == "string")) {
            var r = "Symbol." + e;
            Ft && gt(Se, e) ? Le[e] = Se[e] : xt && At ? Le[e] = At(r) : Le[e] = fo(r);
          }
          return Le[e];
        };
      });
      var kt = H((Lf, wt) => {
        var po = ue(), ho = Oe(), yt = Ie(), Bt = Tr(), vo = lr(), mo = st(), Eo = Te(), Co = po.TypeError, go = Eo("toPrimitive");
        wt.exports = function(e, r) {
          if (!yt(e) || Bt(e)) return e;
          var u = vo(e, go), t;
          if (u) {
            if (r === void 0 && (r = "default"), t = ho(u, e, r), !yt(t) || Bt(t)) return t;
            throw Co("Can't convert object to primitive value");
          }
          return r === void 0 && (r = "number"), mo(e, r);
        };
      });
      var pr = H((Rf, qt) => {
        var Fo = kt(), Ao = Tr();
        qt.exports = function(e) {
          var r = Fo(e, "string");
          return Ao(r) ? r : r + "";
        };
      });
      var It = H((jf, Ot) => {
        var xo = ue(), _t = Ie(), zr = xo.document, bo = _t(zr) && _t(zr.createElement);
        Ot.exports = function(e) {
          return bo ? zr.createElement(e) : {};
        };
      });
      var Gr = H((Pf, St) => {
        var yo = _e(), Bo = Ae(), wo = It();
        St.exports = !yo && !Bo(function() {
          return Object.defineProperty(wo("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      });
      var Ur = H((Nt) => {
        var ko = _e(), qo = Oe(), _o = _u(), Oo = ir(), Io = or(), So = pr(), To = Be(), No = Gr(), Tt = Object.getOwnPropertyDescriptor;
        Nt.f = ko ? Tt : function(r, u) {
          if (r = Io(r), u = So(u), No) try {
            return Tt(r, u);
          } catch {
          }
          if (To(r, u)) return Oo(!qo(_o.f, r, u), r[u]);
        };
      });
      var Rt = H((zf, Lt) => {
        var Lo = _e(), Ro = Ae();
        Lt.exports = Lo && Ro(function() {
          return Object.defineProperty(function() {
          }, "prototype", { value: 42, writable: false }).prototype != 42;
        });
      });
      var Re = H((Gf, Pt) => {
        var jt = ue(), jo = Ie(), Po = jt.String, Mo = jt.TypeError;
        Pt.exports = function(e) {
          if (jo(e)) return e;
          throw Mo(Po(e) + " is not an object");
        };
      });
      var hr = H((zt) => {
        var zo = ue(), Go = _e(), Uo = Gr(), Vo = Rt(), dr = Re(), Mt = pr(), $o = zo.TypeError, Vr = Object.defineProperty, Ho = Object.getOwnPropertyDescriptor, $r = "enumerable", Hr = "configurable", Xr = "writable";
        zt.f = Go ? Vo ? function(r, u, t) {
          if (dr(r), u = Mt(u), dr(t), typeof r == "function" && u === "prototype" && "value" in t && Xr in t && !t[Xr]) {
            var o = Ho(r, u);
            o && o[Xr] && (r[u] = t.value, t = { configurable: Hr in t ? t[Hr] : o[Hr], enumerable: $r in t ? t[$r] : o[$r], writable: false });
          }
          return Vr(r, u, t);
        } : Vr : function(r, u, t) {
          if (dr(r), u = Mt(u), dr(t), Uo) try {
            return Vr(r, u, t);
          } catch {
          }
          if ("get" in t || "set" in t) throw $o("Accessors not supported");
          return "value" in t && (r[u] = t.value), r;
        };
      });
      var vr = H((Vf, Gt) => {
        var Xo = _e(), Wo = hr(), Ko = ir();
        Gt.exports = Xo ? function(e, r, u) {
          return Wo.f(e, r, Ko(1, u));
        } : function(e, r, u) {
          return e[r] = u, e;
        };
      });
      var mr = H(($f, Ut) => {
        var Yo = ve(), Jo = me(), Wr = fr(), Zo = Yo(Function.toString);
        Jo(Wr.inspectSource) || (Wr.inspectSource = function(e) {
          return Zo(e);
        });
        Ut.exports = Wr.inspectSource;
      });
      var Ht = H((Hf, $t) => {
        var Qo = ue(), es = me(), rs = mr(), Vt = Qo.WeakMap;
        $t.exports = es(Vt) && /native code/.test(rs(Vt));
      });
      var Kt = H((Xf, Wt) => {
        var us = jr(), ts = Mr(), Xt = us("keys");
        Wt.exports = function(e) {
          return Xt[e] || (Xt[e] = ts(e));
        };
      });
      var Kr = H((Wf, Yt) => {
        Yt.exports = {};
      });
      var un = H((Kf, rn) => {
        var ns = Ht(), en = ue(), Yr = ve(), is = Ie(), as = vr(), Jr = Be(), Zr = fr(), os = Kt(), ss = Kr(), Jt = "Object already initialized", eu = en.TypeError, cs = en.WeakMap, Er, We, Cr, ls = function(e) {
          return Cr(e) ? We(e) : Er(e, {});
        }, Ds = function(e) {
          return function(r) {
            var u;
            if (!is(r) || (u = We(r)).type !== e) throw eu("Incompatible receiver, " + e + " required");
            return u;
          };
        };
        ns || Zr.state ? (we = Zr.state || (Zr.state = new cs()), Zt = Yr(we.get), Qr = Yr(we.has), Qt = Yr(we.set), Er = function(e, r) {
          if (Qr(we, e)) throw new eu(Jt);
          return r.facade = e, Qt(we, e, r), r;
        }, We = function(e) {
          return Zt(we, e) || {};
        }, Cr = function(e) {
          return Qr(we, e);
        }) : (Ne = os("state"), ss[Ne] = true, Er = function(e, r) {
          if (Jr(e, Ne)) throw new eu(Jt);
          return r.facade = e, as(e, Ne, r), r;
        }, We = function(e) {
          return Jr(e, Ne) ? e[Ne] : {};
        }, Cr = function(e) {
          return Jr(e, Ne);
        });
        var we, Zt, Qr, Qt, Ne;
        rn.exports = { set: Er, get: We, has: Cr, enforce: ls, getterFor: Ds };
      });
      var an = H((Yf, nn) => {
        var ru = _e(), fs = Be(), tn = Function.prototype, ps = ru && Object.getOwnPropertyDescriptor, uu = fs(tn, "name"), ds = uu && function() {
        }.name === "something", hs = uu && (!ru || ru && ps(tn, "name").configurable);
        nn.exports = { EXISTS: uu, PROPER: ds, CONFIGURABLE: hs };
      });
      var Dn = H((Jf, ln) => {
        var vs = ue(), on = me(), ms = Be(), sn = vr(), Es = Dr(), Cs = mr(), cn = un(), gs = an().CONFIGURABLE, Fs = cn.get, As = cn.enforce, xs = String(String).split("String");
        (ln.exports = function(e, r, u, t) {
          var o = t ? !!t.unsafe : false, n = t ? !!t.enumerable : false, s = t ? !!t.noTargetGet : false, c = t && t.name !== void 0 ? t.name : r, i;
          if (on(u) && (String(c).slice(0, 7) === "Symbol(" && (c = "[" + String(c).replace(/^Symbol\(([^)]*)\)/, "$1") + "]"), (!ms(u, "name") || gs && u.name !== c) && sn(u, "name", c), i = As(u), i.source || (i.source = xs.join(typeof c == "string" ? c : ""))), e === vs) {
            n ? e[r] = u : Es(r, u);
            return;
          } else o ? !s && e[r] && (n = true) : delete e[r];
          n ? e[r] = u : sn(e, r, u);
        })(Function.prototype, "toString", function() {
          return on(this) && Fs(this).source || Cs(this);
        });
      });
      var tu = H((Zf, fn) => {
        var bs = Math.ceil, ys = Math.floor;
        fn.exports = function(e) {
          var r = +e;
          return r !== r || r === 0 ? 0 : (r > 0 ? ys : bs)(r);
        };
      });
      var dn = H((Qf, pn) => {
        var Bs = tu(), ws = Math.max, ks = Math.min;
        pn.exports = function(e, r) {
          var u = Bs(e);
          return u < 0 ? ws(u + r, 0) : ks(u, r);
        };
      });
      var vn = H((ep, hn) => {
        var qs = tu(), _s = Math.min;
        hn.exports = function(e) {
          return e > 0 ? _s(qs(e), 9007199254740991) : 0;
        };
      });
      var Ke = H((rp, mn) => {
        var Os = vn();
        mn.exports = function(e) {
          return Os(e.length);
        };
      });
      var gn = H((up, Cn) => {
        var Is = or(), Ss = dn(), Ts = Ke(), En = function(e) {
          return function(r, u, t) {
            var o = Is(r), n = Ts(o), s = Ss(t, n), c;
            if (e && u != u) {
              for (; n > s; ) if (c = o[s++], c != c) return true;
            } else for (; n > s; s++) if ((e || s in o) && o[s] === u) return e || s || 0;
            return !e && -1;
          };
        };
        Cn.exports = { includes: En(true), indexOf: En(false) };
      });
      var xn = H((tp, An) => {
        var Ns = ve(), nu = Be(), Ls = or(), Rs = gn().indexOf, js = Kr(), Fn = Ns([].push);
        An.exports = function(e, r) {
          var u = Ls(e), t = 0, o = [], n;
          for (n in u) !nu(js, n) && nu(u, n) && Fn(o, n);
          for (; r.length > t; ) nu(u, n = r[t++]) && (~Rs(o, n) || Fn(o, n));
          return o;
        };
      });
      var yn = H((np, bn) => {
        bn.exports = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
      });
      var wn = H((Bn) => {
        var Ps = xn(), Ms = yn(), zs = Ms.concat("length", "prototype");
        Bn.f = Object.getOwnPropertyNames || function(r) {
          return Ps(r, zs);
        };
      });
      var qn = H((kn) => {
        kn.f = Object.getOwnPropertySymbols;
      });
      var On = H((op, _n) => {
        var Gs = He(), Us = ve(), Vs = wn(), $s = qn(), Hs = Re(), Xs = Us([].concat);
        _n.exports = Gs("Reflect", "ownKeys") || function(r) {
          var u = Vs.f(Hs(r)), t = $s.f;
          return t ? Xs(u, t(r)) : u;
        };
      });
      var Tn = H((sp, Sn) => {
        var In = Be(), Ws = On(), Ks = Ur(), Ys = hr();
        Sn.exports = function(e, r, u) {
          for (var t = Ws(r), o = Ys.f, n = Ks.f, s = 0; s < t.length; s++) {
            var c = t[s];
            !In(e, c) && !(u && In(u, c)) && o(e, c, n(r, c));
          }
        };
      });
      var Ln = H((cp, Nn) => {
        var Js = Ae(), Zs = me(), Qs = /#|\.prototype\./, Ye = function(e, r) {
          var u = rc[ec(e)];
          return u == tc ? true : u == uc ? false : Zs(r) ? Js(r) : !!r;
        }, ec = Ye.normalize = function(e) {
          return String(e).replace(Qs, ".").toLowerCase();
        }, rc = Ye.data = {}, uc = Ye.NATIVE = "N", tc = Ye.POLYFILL = "P";
        Nn.exports = Ye;
      });
      var au = H((lp, Rn) => {
        var iu = ue(), nc = Ur().f, ic = vr(), ac = Dn(), oc = Dr(), sc = Tn(), cc = Ln();
        Rn.exports = function(e, r) {
          var u = e.target, t = e.global, o = e.stat, n, s, c, i, D, a;
          if (t ? s = iu : o ? s = iu[u] || oc(u, {}) : s = (iu[u] || {}).prototype, s) for (c in r) {
            if (D = r[c], e.noTargetGet ? (a = nc(s, c), i = a && a.value) : i = s[c], n = cc(t ? c : u + (o ? "." : "#") + c, e.forced), !n && i !== void 0) {
              if (typeof D == typeof i) continue;
              sc(D, i);
            }
            (e.sham || i && i.sham) && ic(D, "sham", true), ac(s, c, D, e);
          }
        };
      });
      var ou = H((Dp, jn) => {
        var lc = ar();
        jn.exports = Array.isArray || function(r) {
          return lc(r) == "Array";
        };
      });
      var su = H((fp, Mn) => {
        var Pn = ve(), Dc = Xe(), fc = tr(), pc = Pn(Pn.bind);
        Mn.exports = function(e, r) {
          return Dc(e), r === void 0 ? e : fc ? pc(e, r) : function() {
            return e.apply(r, arguments);
          };
        };
      });
      var Un = H((pp, Gn) => {
        "use strict";
        var dc = ue(), hc = ou(), vc = Ke(), mc = su(), Ec = dc.TypeError, zn = function(e, r, u, t, o, n, s, c) {
          for (var i = o, D = 0, a = s ? mc(s, c) : false, l, p; D < t; ) {
            if (D in u) {
              if (l = a ? a(u[D], D, r) : u[D], n > 0 && hc(l)) p = vc(l), i = zn(e, r, l, p, i, n - 1) - 1;
              else {
                if (i >= 9007199254740991) throw Ec("Exceed the acceptable array length");
                e[i] = l;
              }
              i++;
            }
            D++;
          }
          return i;
        };
        Gn.exports = zn;
      });
      var Hn = H((dp, $n) => {
        var Cc = Te(), gc = Cc("toStringTag"), Vn = {};
        Vn[gc] = "z";
        $n.exports = String(Vn) === "[object z]";
      });
      var cu = H((hp, Xn) => {
        var Fc = ue(), Ac = Hn(), xc = me(), gr = ar(), bc = Te(), yc = bc("toStringTag"), Bc = Fc.Object, wc = gr(/* @__PURE__ */ function() {
          return arguments;
        }()) == "Arguments", kc = function(e, r) {
          try {
            return e[r];
          } catch {
          }
        };
        Xn.exports = Ac ? gr : function(e) {
          var r, u, t;
          return e === void 0 ? "Undefined" : e === null ? "Null" : typeof (u = kc(r = Bc(e), yc)) == "string" ? u : wc ? gr(r) : (t = gr(r)) == "Object" && xc(r.callee) ? "Arguments" : t;
        };
      });
      var Qn = H((vp, Zn) => {
        var qc = ve(), _c = Ae(), Wn = me(), Oc = cu(), Ic = He(), Sc = mr(), Kn = function() {
        }, Tc = [], Yn = Ic("Reflect", "construct"), lu = /^\s*(?:class|function)\b/, Nc = qc(lu.exec), Lc = !lu.exec(Kn), Je = function(r) {
          if (!Wn(r)) return false;
          try {
            return Yn(Kn, Tc, r), true;
          } catch {
            return false;
          }
        }, Jn = function(r) {
          if (!Wn(r)) return false;
          switch (Oc(r)) {
            case "AsyncFunction":
            case "GeneratorFunction":
            case "AsyncGeneratorFunction":
              return false;
          }
          try {
            return Lc || !!Nc(lu, Sc(r));
          } catch {
            return true;
          }
        };
        Jn.sham = true;
        Zn.exports = !Yn || _c(function() {
          var e;
          return Je(Je.call) || !Je(Object) || !Je(function() {
            e = true;
          }) || e;
        }) ? Jn : Je;
      });
      var ti = H((mp, ui) => {
        var Rc = ue(), ei = ou(), jc = Qn(), Pc = Ie(), Mc = Te(), zc = Mc("species"), ri = Rc.Array;
        ui.exports = function(e) {
          var r;
          return ei(e) && (r = e.constructor, jc(r) && (r === ri || ei(r.prototype)) ? r = void 0 : Pc(r) && (r = r[zc], r === null && (r = void 0))), r === void 0 ? ri : r;
        };
      });
      var ii = H((Ep, ni) => {
        var Gc = ti();
        ni.exports = function(e, r) {
          return new (Gc(e))(r === 0 ? 0 : r);
        };
      });
      var ai = H(() => {
        "use strict";
        var Uc = au(), Vc = Un(), $c = Xe(), Hc = Pr(), Xc = Ke(), Wc = ii();
        Uc({ target: "Array", proto: true }, { flatMap: function(r) {
          var u = Hc(this), t = Xc(u), o;
          return $c(r), o = Wc(u, 0), o.length = Vc(o, u, u, t, 0, 1, r, arguments.length > 1 ? arguments[1] : void 0), o;
        } });
      });
      var Du = H((Fp, oi) => {
        oi.exports = {};
      });
      var ci = H((Ap, si) => {
        var Kc = Te(), Yc = Du(), Jc = Kc("iterator"), Zc = Array.prototype;
        si.exports = function(e) {
          return e !== void 0 && (Yc.Array === e || Zc[Jc] === e);
        };
      });
      var fu = H((xp, Di) => {
        var Qc = cu(), li = lr(), el = Du(), rl = Te(), ul = rl("iterator");
        Di.exports = function(e) {
          if (e != null) return li(e, ul) || li(e, "@@iterator") || el[Qc(e)];
        };
      });
      var pi = H((bp, fi) => {
        var tl = ue(), nl = Oe(), il = Xe(), al = Re(), ol = cr(), sl = fu(), cl = tl.TypeError;
        fi.exports = function(e, r) {
          var u = arguments.length < 2 ? sl(e) : r;
          if (il(u)) return al(nl(u, e));
          throw cl(ol(e) + " is not iterable");
        };
      });
      var vi = H((yp, hi) => {
        var ll = Oe(), di = Re(), Dl = lr();
        hi.exports = function(e, r, u) {
          var t, o;
          di(e);
          try {
            if (t = Dl(e, "return"), !t) {
              if (r === "throw") throw u;
              return u;
            }
            t = ll(t, e);
          } catch (n) {
            o = true, t = n;
          }
          if (r === "throw") throw u;
          if (o) throw t;
          return di(t), u;
        };
      });
      var Fi = H((Bp, gi) => {
        var fl = ue(), pl = su(), dl = Oe(), hl = Re(), vl = cr(), ml = ci(), El = Ke(), mi = _r(), Cl = pi(), gl = fu(), Ei = vi(), Fl = fl.TypeError, Fr = function(e, r) {
          this.stopped = e, this.result = r;
        }, Ci = Fr.prototype;
        gi.exports = function(e, r, u) {
          var t = u && u.that, o = !!(u && u.AS_ENTRIES), n = !!(u && u.IS_ITERATOR), s = !!(u && u.INTERRUPTED), c = pl(r, t), i, D, a, l, p, d, g, F = function(x) {
            return i && Ei(i, "normal", x), new Fr(true, x);
          }, E = function(x) {
            return o ? (hl(x), s ? c(x[0], x[1], F) : c(x[0], x[1])) : s ? c(x, F) : c(x);
          };
          if (n) i = e;
          else {
            if (D = gl(e), !D) throw Fl(vl(e) + " is not iterable");
            if (ml(D)) {
              for (a = 0, l = El(e); l > a; a++) if (p = E(e[a]), p && mi(Ci, p)) return p;
              return new Fr(false);
            }
            i = Cl(e, D);
          }
          for (d = i.next; !(g = dl(d, i)).done; ) {
            try {
              p = E(g.value);
            } catch (x) {
              Ei(i, "throw", x);
            }
            if (typeof p == "object" && p && mi(Ci, p)) return p;
          }
          return new Fr(false);
        };
      });
      var xi = H((wp, Ai) => {
        "use strict";
        var Al = pr(), xl = hr(), bl = ir();
        Ai.exports = function(e, r, u) {
          var t = Al(r);
          t in e ? xl.f(e, t, bl(0, u)) : e[t] = u;
        };
      });
      var bi = H(() => {
        var yl = au(), Bl = Fi(), wl = xi();
        yl({ target: "Object", stat: true }, { fromEntries: function(r) {
          var u = {};
          return Bl(r, function(t, o) {
            wl(u, t, o);
          }, { AS_ENTRIES: true }), u;
        } });
      });
      var ef = H((_p, oa) => {
        var kl = ["cliName", "cliCategory", "cliDescription"], yi, Bi, wi, ki, qi, _i;
        function ql(e, r) {
          if (e == null) return {};
          var u = _l(e, r), t, o;
          if (Object.getOwnPropertySymbols) {
            var n = Object.getOwnPropertySymbols(e);
            for (o = 0; o < n.length; o++) t = n[o], !(r.indexOf(t) >= 0) && (!Object.prototype.propertyIsEnumerable.call(e, t) || (u[t] = e[t]));
          }
          return u;
        }
        function _l(e, r) {
          if (e == null) return {};
          var u = {}, t = Object.keys(e), o, n;
          for (n = 0; n < t.length; n++) o = t[n], !(r.indexOf(o) >= 0) && (u[o] = e[o]);
          return u;
        }
        ai();
        bi();
        function je(e, r) {
          return r || (r = e.slice(0)), Object.freeze(Object.defineProperties(e, { raw: { value: Object.freeze(r) } }));
        }
        var Ol = Object.create, Ar = Object.defineProperty, Il = Object.getOwnPropertyDescriptor, pu = Object.getOwnPropertyNames, Sl = Object.getPrototypeOf, Tl = Object.prototype.hasOwnProperty, Pe = (e, r) => function() {
          return e && (r = (0, e[pu(e)[0]])(e = 0)), r;
        }, S = (e, r) => function() {
          return r || (0, e[pu(e)[0]])((r = { exports: {} }).exports, r), r.exports;
        }, Li = (e, r) => {
          for (var u in r) Ar(e, u, { get: r[u], enumerable: true });
        }, Ri = (e, r, u, t) => {
          if (r && typeof r == "object" || typeof r == "function") for (let o of pu(r)) !Tl.call(e, o) && o !== u && Ar(e, o, { get: () => r[o], enumerable: !(t = Il(r, o)) || t.enumerable });
          return e;
        }, Nl = (e, r, u) => (u = e != null ? Ol(Sl(e)) : {}, Ri(r || !e || !e.__esModule ? Ar(u, "default", { value: e, enumerable: true }) : u, e)), ji = (e) => Ri(Ar({}, "__esModule", { value: true }), e), Oi, Ii, Ze, I = Pe({ "<define:process>"() {
          Oi = {}, Ii = [], Ze = { env: Oi, argv: Ii };
        } }), Me = S({ "node_modules/xtend/immutable.js"(e, r) {
          I(), r.exports = t;
          var u = Object.prototype.hasOwnProperty;
          function t() {
            for (var o = {}, n = 0; n < arguments.length; n++) {
              var s = arguments[n];
              for (var c in s) u.call(s, c) && (o[c] = s[c]);
            }
            return o;
          }
        } }), Ll = S({ "node_modules/inherits/inherits_browser.js"(e, r) {
          I(), typeof Object.create == "function" ? r.exports = function(t, o) {
            o && (t.super_ = o, t.prototype = Object.create(o.prototype, { constructor: { value: t, enumerable: false, writable: true, configurable: true } }));
          } : r.exports = function(t, o) {
            if (o) {
              t.super_ = o;
              var n = function() {
              };
              n.prototype = o.prototype, t.prototype = new n(), t.prototype.constructor = t;
            }
          };
        } }), Rl = S({ "node_modules/unherit/index.js"(e, r) {
          "use strict";
          I();
          var u = Me(), t = Ll();
          r.exports = o;
          function o(n) {
            var s, c, i;
            t(a, n), t(D, a), s = a.prototype;
            for (c in s) i = s[c], i && typeof i == "object" && (s[c] = "concat" in i ? i.concat() : u(i));
            return a;
            function D(l) {
              return n.apply(this, l);
            }
            function a() {
              return this instanceof a ? n.apply(this, arguments) : new D(arguments);
            }
          }
        } }), jl = S({ "node_modules/state-toggle/index.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t, o, n) {
            return s;
            function s() {
              var c = n || this, i = c[t];
              return c[t] = !o, D;
              function D() {
                c[t] = i;
              }
            }
          }
        } }), Pl = S({ "node_modules/vfile-location/index.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t) {
            for (var o = String(t), n = [], s = /\r?\n|\r/g; s.exec(o); ) n.push(s.lastIndex);
            return n.push(o.length + 1), { toPoint: c, toPosition: c, toOffset: i };
            function c(D) {
              var a = -1;
              if (D > -1 && D < n[n.length - 1]) {
                for (; ++a < n.length; ) if (n[a] > D) return { line: a + 1, column: D - (n[a - 1] || 0) + 1, offset: D };
              }
              return {};
            }
            function i(D) {
              var a = D && D.line, l = D && D.column, p;
              return !isNaN(a) && !isNaN(l) && a - 1 in n && (p = (n[a - 2] || 0) + l - 1 || 0), p > -1 && p < n[n.length - 1] ? p : -1;
            }
          }
        } }), Ml = S({ "node_modules/remark-parse/lib/unescape.js"(e, r) {
          "use strict";
          I(), r.exports = t;
          var u = "\\";
          function t(o, n) {
            return s;
            function s(c) {
              for (var i = 0, D = c.indexOf(u), a = o[n], l = [], p; D !== -1; ) l.push(c.slice(i, D)), i = D + 1, p = c.charAt(i), (!p || a.indexOf(p) === -1) && l.push(u), D = c.indexOf(u, i + 1);
              return l.push(c.slice(i)), l.join("");
            }
          }
        } }), zl = S({ "node_modules/character-entities-legacy/index.json"(e, r) {
          r.exports = { AElig: "\xC6", AMP: "&", Aacute: "\xC1", Acirc: "\xC2", Agrave: "\xC0", Aring: "\xC5", Atilde: "\xC3", Auml: "\xC4", COPY: "\xA9", Ccedil: "\xC7", ETH: "\xD0", Eacute: "\xC9", Ecirc: "\xCA", Egrave: "\xC8", Euml: "\xCB", GT: ">", Iacute: "\xCD", Icirc: "\xCE", Igrave: "\xCC", Iuml: "\xCF", LT: "<", Ntilde: "\xD1", Oacute: "\xD3", Ocirc: "\xD4", Ograve: "\xD2", Oslash: "\xD8", Otilde: "\xD5", Ouml: "\xD6", QUOT: '"', REG: "\xAE", THORN: "\xDE", Uacute: "\xDA", Ucirc: "\xDB", Ugrave: "\xD9", Uuml: "\xDC", Yacute: "\xDD", aacute: "\xE1", acirc: "\xE2", acute: "\xB4", aelig: "\xE6", agrave: "\xE0", amp: "&", aring: "\xE5", atilde: "\xE3", auml: "\xE4", brvbar: "\xA6", ccedil: "\xE7", cedil: "\xB8", cent: "\xA2", copy: "\xA9", curren: "\xA4", deg: "\xB0", divide: "\xF7", eacute: "\xE9", ecirc: "\xEA", egrave: "\xE8", eth: "\xF0", euml: "\xEB", frac12: "\xBD", frac14: "\xBC", frac34: "\xBE", gt: ">", iacute: "\xED", icirc: "\xEE", iexcl: "\xA1", igrave: "\xEC", iquest: "\xBF", iuml: "\xEF", laquo: "\xAB", lt: "<", macr: "\xAF", micro: "\xB5", middot: "\xB7", nbsp: "\xA0", not: "\xAC", ntilde: "\xF1", oacute: "\xF3", ocirc: "\xF4", ograve: "\xF2", ordf: "\xAA", ordm: "\xBA", oslash: "\xF8", otilde: "\xF5", ouml: "\xF6", para: "\xB6", plusmn: "\xB1", pound: "\xA3", quot: '"', raquo: "\xBB", reg: "\xAE", sect: "\xA7", shy: "\xAD", sup1: "\xB9", sup2: "\xB2", sup3: "\xB3", szlig: "\xDF", thorn: "\xFE", times: "\xD7", uacute: "\xFA", ucirc: "\xFB", ugrave: "\xF9", uml: "\xA8", uuml: "\xFC", yacute: "\xFD", yen: "\xA5", yuml: "\xFF" };
        } }), Gl = S({ "node_modules/character-reference-invalid/index.json"(e, r) {
          r.exports = { 0: "\uFFFD", 128: "\u20AC", 130: "\u201A", 131: "\u0192", 132: "\u201E", 133: "\u2026", 134: "\u2020", 135: "\u2021", 136: "\u02C6", 137: "\u2030", 138: "\u0160", 139: "\u2039", 140: "\u0152", 142: "\u017D", 145: "\u2018", 146: "\u2019", 147: "\u201C", 148: "\u201D", 149: "\u2022", 150: "\u2013", 151: "\u2014", 152: "\u02DC", 153: "\u2122", 154: "\u0161", 155: "\u203A", 156: "\u0153", 158: "\u017E", 159: "\u0178" };
        } }), ze = S({ "node_modules/is-decimal/index.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t) {
            var o = typeof t == "string" ? t.charCodeAt(0) : t;
            return o >= 48 && o <= 57;
          }
        } }), Ul = S({ "node_modules/is-hexadecimal/index.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t) {
            var o = typeof t == "string" ? t.charCodeAt(0) : t;
            return o >= 97 && o <= 102 || o >= 65 && o <= 70 || o >= 48 && o <= 57;
          }
        } }), Qe = S({ "node_modules/is-alphabetical/index.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t) {
            var o = typeof t == "string" ? t.charCodeAt(0) : t;
            return o >= 97 && o <= 122 || o >= 65 && o <= 90;
          }
        } }), Vl = S({ "node_modules/is-alphanumerical/index.js"(e, r) {
          "use strict";
          I();
          var u = Qe(), t = ze();
          r.exports = o;
          function o(n) {
            return u(n) || t(n);
          }
        } }), $l = S({ "node_modules/character-entities/index.json"(e, r) {
          r.exports = { AEli: "\xC6", AElig: "\xC6", AM: "&", AMP: "&", Aacut: "\xC1", Aacute: "\xC1", Abreve: "\u0102", Acir: "\xC2", Acirc: "\xC2", Acy: "\u0410", Afr: "\u{1D504}", Agrav: "\xC0", Agrave: "\xC0", Alpha: "\u0391", Amacr: "\u0100", And: "\u2A53", Aogon: "\u0104", Aopf: "\u{1D538}", ApplyFunction: "\u2061", Arin: "\xC5", Aring: "\xC5", Ascr: "\u{1D49C}", Assign: "\u2254", Atild: "\xC3", Atilde: "\xC3", Aum: "\xC4", Auml: "\xC4", Backslash: "\u2216", Barv: "\u2AE7", Barwed: "\u2306", Bcy: "\u0411", Because: "\u2235", Bernoullis: "\u212C", Beta: "\u0392", Bfr: "\u{1D505}", Bopf: "\u{1D539}", Breve: "\u02D8", Bscr: "\u212C", Bumpeq: "\u224E", CHcy: "\u0427", COP: "\xA9", COPY: "\xA9", Cacute: "\u0106", Cap: "\u22D2", CapitalDifferentialD: "\u2145", Cayleys: "\u212D", Ccaron: "\u010C", Ccedi: "\xC7", Ccedil: "\xC7", Ccirc: "\u0108", Cconint: "\u2230", Cdot: "\u010A", Cedilla: "\xB8", CenterDot: "\xB7", Cfr: "\u212D", Chi: "\u03A7", CircleDot: "\u2299", CircleMinus: "\u2296", CirclePlus: "\u2295", CircleTimes: "\u2297", ClockwiseContourIntegral: "\u2232", CloseCurlyDoubleQuote: "\u201D", CloseCurlyQuote: "\u2019", Colon: "\u2237", Colone: "\u2A74", Congruent: "\u2261", Conint: "\u222F", ContourIntegral: "\u222E", Copf: "\u2102", Coproduct: "\u2210", CounterClockwiseContourIntegral: "\u2233", Cross: "\u2A2F", Cscr: "\u{1D49E}", Cup: "\u22D3", CupCap: "\u224D", DD: "\u2145", DDotrahd: "\u2911", DJcy: "\u0402", DScy: "\u0405", DZcy: "\u040F", Dagger: "\u2021", Darr: "\u21A1", Dashv: "\u2AE4", Dcaron: "\u010E", Dcy: "\u0414", Del: "\u2207", Delta: "\u0394", Dfr: "\u{1D507}", DiacriticalAcute: "\xB4", DiacriticalDot: "\u02D9", DiacriticalDoubleAcute: "\u02DD", DiacriticalGrave: "`", DiacriticalTilde: "\u02DC", Diamond: "\u22C4", DifferentialD: "\u2146", Dopf: "\u{1D53B}", Dot: "\xA8", DotDot: "\u20DC", DotEqual: "\u2250", DoubleContourIntegral: "\u222F", DoubleDot: "\xA8", DoubleDownArrow: "\u21D3", DoubleLeftArrow: "\u21D0", DoubleLeftRightArrow: "\u21D4", DoubleLeftTee: "\u2AE4", DoubleLongLeftArrow: "\u27F8", DoubleLongLeftRightArrow: "\u27FA", DoubleLongRightArrow: "\u27F9", DoubleRightArrow: "\u21D2", DoubleRightTee: "\u22A8", DoubleUpArrow: "\u21D1", DoubleUpDownArrow: "\u21D5", DoubleVerticalBar: "\u2225", DownArrow: "\u2193", DownArrowBar: "\u2913", DownArrowUpArrow: "\u21F5", DownBreve: "\u0311", DownLeftRightVector: "\u2950", DownLeftTeeVector: "\u295E", DownLeftVector: "\u21BD", DownLeftVectorBar: "\u2956", DownRightTeeVector: "\u295F", DownRightVector: "\u21C1", DownRightVectorBar: "\u2957", DownTee: "\u22A4", DownTeeArrow: "\u21A7", Downarrow: "\u21D3", Dscr: "\u{1D49F}", Dstrok: "\u0110", ENG: "\u014A", ET: "\xD0", ETH: "\xD0", Eacut: "\xC9", Eacute: "\xC9", Ecaron: "\u011A", Ecir: "\xCA", Ecirc: "\xCA", Ecy: "\u042D", Edot: "\u0116", Efr: "\u{1D508}", Egrav: "\xC8", Egrave: "\xC8", Element: "\u2208", Emacr: "\u0112", EmptySmallSquare: "\u25FB", EmptyVerySmallSquare: "\u25AB", Eogon: "\u0118", Eopf: "\u{1D53C}", Epsilon: "\u0395", Equal: "\u2A75", EqualTilde: "\u2242", Equilibrium: "\u21CC", Escr: "\u2130", Esim: "\u2A73", Eta: "\u0397", Eum: "\xCB", Euml: "\xCB", Exists: "\u2203", ExponentialE: "\u2147", Fcy: "\u0424", Ffr: "\u{1D509}", FilledSmallSquare: "\u25FC", FilledVerySmallSquare: "\u25AA", Fopf: "\u{1D53D}", ForAll: "\u2200", Fouriertrf: "\u2131", Fscr: "\u2131", GJcy: "\u0403", G: ">", GT: ">", Gamma: "\u0393", Gammad: "\u03DC", Gbreve: "\u011E", Gcedil: "\u0122", Gcirc: "\u011C", Gcy: "\u0413", Gdot: "\u0120", Gfr: "\u{1D50A}", Gg: "\u22D9", Gopf: "\u{1D53E}", GreaterEqual: "\u2265", GreaterEqualLess: "\u22DB", GreaterFullEqual: "\u2267", GreaterGreater: "\u2AA2", GreaterLess: "\u2277", GreaterSlantEqual: "\u2A7E", GreaterTilde: "\u2273", Gscr: "\u{1D4A2}", Gt: "\u226B", HARDcy: "\u042A", Hacek: "\u02C7", Hat: "^", Hcirc: "\u0124", Hfr: "\u210C", HilbertSpace: "\u210B", Hopf: "\u210D", HorizontalLine: "\u2500", Hscr: "\u210B", Hstrok: "\u0126", HumpDownHump: "\u224E", HumpEqual: "\u224F", IEcy: "\u0415", IJlig: "\u0132", IOcy: "\u0401", Iacut: "\xCD", Iacute: "\xCD", Icir: "\xCE", Icirc: "\xCE", Icy: "\u0418", Idot: "\u0130", Ifr: "\u2111", Igrav: "\xCC", Igrave: "\xCC", Im: "\u2111", Imacr: "\u012A", ImaginaryI: "\u2148", Implies: "\u21D2", Int: "\u222C", Integral: "\u222B", Intersection: "\u22C2", InvisibleComma: "\u2063", InvisibleTimes: "\u2062", Iogon: "\u012E", Iopf: "\u{1D540}", Iota: "\u0399", Iscr: "\u2110", Itilde: "\u0128", Iukcy: "\u0406", Ium: "\xCF", Iuml: "\xCF", Jcirc: "\u0134", Jcy: "\u0419", Jfr: "\u{1D50D}", Jopf: "\u{1D541}", Jscr: "\u{1D4A5}", Jsercy: "\u0408", Jukcy: "\u0404", KHcy: "\u0425", KJcy: "\u040C", Kappa: "\u039A", Kcedil: "\u0136", Kcy: "\u041A", Kfr: "\u{1D50E}", Kopf: "\u{1D542}", Kscr: "\u{1D4A6}", LJcy: "\u0409", L: "<", LT: "<", Lacute: "\u0139", Lambda: "\u039B", Lang: "\u27EA", Laplacetrf: "\u2112", Larr: "\u219E", Lcaron: "\u013D", Lcedil: "\u013B", Lcy: "\u041B", LeftAngleBracket: "\u27E8", LeftArrow: "\u2190", LeftArrowBar: "\u21E4", LeftArrowRightArrow: "\u21C6", LeftCeiling: "\u2308", LeftDoubleBracket: "\u27E6", LeftDownTeeVector: "\u2961", LeftDownVector: "\u21C3", LeftDownVectorBar: "\u2959", LeftFloor: "\u230A", LeftRightArrow: "\u2194", LeftRightVector: "\u294E", LeftTee: "\u22A3", LeftTeeArrow: "\u21A4", LeftTeeVector: "\u295A", LeftTriangle: "\u22B2", LeftTriangleBar: "\u29CF", LeftTriangleEqual: "\u22B4", LeftUpDownVector: "\u2951", LeftUpTeeVector: "\u2960", LeftUpVector: "\u21BF", LeftUpVectorBar: "\u2958", LeftVector: "\u21BC", LeftVectorBar: "\u2952", Leftarrow: "\u21D0", Leftrightarrow: "\u21D4", LessEqualGreater: "\u22DA", LessFullEqual: "\u2266", LessGreater: "\u2276", LessLess: "\u2AA1", LessSlantEqual: "\u2A7D", LessTilde: "\u2272", Lfr: "\u{1D50F}", Ll: "\u22D8", Lleftarrow: "\u21DA", Lmidot: "\u013F", LongLeftArrow: "\u27F5", LongLeftRightArrow: "\u27F7", LongRightArrow: "\u27F6", Longleftarrow: "\u27F8", Longleftrightarrow: "\u27FA", Longrightarrow: "\u27F9", Lopf: "\u{1D543}", LowerLeftArrow: "\u2199", LowerRightArrow: "\u2198", Lscr: "\u2112", Lsh: "\u21B0", Lstrok: "\u0141", Lt: "\u226A", Map: "\u2905", Mcy: "\u041C", MediumSpace: "\u205F", Mellintrf: "\u2133", Mfr: "\u{1D510}", MinusPlus: "\u2213", Mopf: "\u{1D544}", Mscr: "\u2133", Mu: "\u039C", NJcy: "\u040A", Nacute: "\u0143", Ncaron: "\u0147", Ncedil: "\u0145", Ncy: "\u041D", NegativeMediumSpace: "\u200B", NegativeThickSpace: "\u200B", NegativeThinSpace: "\u200B", NegativeVeryThinSpace: "\u200B", NestedGreaterGreater: "\u226B", NestedLessLess: "\u226A", NewLine: `
`, Nfr: "\u{1D511}", NoBreak: "\u2060", NonBreakingSpace: "\xA0", Nopf: "\u2115", Not: "\u2AEC", NotCongruent: "\u2262", NotCupCap: "\u226D", NotDoubleVerticalBar: "\u2226", NotElement: "\u2209", NotEqual: "\u2260", NotEqualTilde: "\u2242\u0338", NotExists: "\u2204", NotGreater: "\u226F", NotGreaterEqual: "\u2271", NotGreaterFullEqual: "\u2267\u0338", NotGreaterGreater: "\u226B\u0338", NotGreaterLess: "\u2279", NotGreaterSlantEqual: "\u2A7E\u0338", NotGreaterTilde: "\u2275", NotHumpDownHump: "\u224E\u0338", NotHumpEqual: "\u224F\u0338", NotLeftTriangle: "\u22EA", NotLeftTriangleBar: "\u29CF\u0338", NotLeftTriangleEqual: "\u22EC", NotLess: "\u226E", NotLessEqual: "\u2270", NotLessGreater: "\u2278", NotLessLess: "\u226A\u0338", NotLessSlantEqual: "\u2A7D\u0338", NotLessTilde: "\u2274", NotNestedGreaterGreater: "\u2AA2\u0338", NotNestedLessLess: "\u2AA1\u0338", NotPrecedes: "\u2280", NotPrecedesEqual: "\u2AAF\u0338", NotPrecedesSlantEqual: "\u22E0", NotReverseElement: "\u220C", NotRightTriangle: "\u22EB", NotRightTriangleBar: "\u29D0\u0338", NotRightTriangleEqual: "\u22ED", NotSquareSubset: "\u228F\u0338", NotSquareSubsetEqual: "\u22E2", NotSquareSuperset: "\u2290\u0338", NotSquareSupersetEqual: "\u22E3", NotSubset: "\u2282\u20D2", NotSubsetEqual: "\u2288", NotSucceeds: "\u2281", NotSucceedsEqual: "\u2AB0\u0338", NotSucceedsSlantEqual: "\u22E1", NotSucceedsTilde: "\u227F\u0338", NotSuperset: "\u2283\u20D2", NotSupersetEqual: "\u2289", NotTilde: "\u2241", NotTildeEqual: "\u2244", NotTildeFullEqual: "\u2247", NotTildeTilde: "\u2249", NotVerticalBar: "\u2224", Nscr: "\u{1D4A9}", Ntild: "\xD1", Ntilde: "\xD1", Nu: "\u039D", OElig: "\u0152", Oacut: "\xD3", Oacute: "\xD3", Ocir: "\xD4", Ocirc: "\xD4", Ocy: "\u041E", Odblac: "\u0150", Ofr: "\u{1D512}", Ograv: "\xD2", Ograve: "\xD2", Omacr: "\u014C", Omega: "\u03A9", Omicron: "\u039F", Oopf: "\u{1D546}", OpenCurlyDoubleQuote: "\u201C", OpenCurlyQuote: "\u2018", Or: "\u2A54", Oscr: "\u{1D4AA}", Oslas: "\xD8", Oslash: "\xD8", Otild: "\xD5", Otilde: "\xD5", Otimes: "\u2A37", Oum: "\xD6", Ouml: "\xD6", OverBar: "\u203E", OverBrace: "\u23DE", OverBracket: "\u23B4", OverParenthesis: "\u23DC", PartialD: "\u2202", Pcy: "\u041F", Pfr: "\u{1D513}", Phi: "\u03A6", Pi: "\u03A0", PlusMinus: "\xB1", Poincareplane: "\u210C", Popf: "\u2119", Pr: "\u2ABB", Precedes: "\u227A", PrecedesEqual: "\u2AAF", PrecedesSlantEqual: "\u227C", PrecedesTilde: "\u227E", Prime: "\u2033", Product: "\u220F", Proportion: "\u2237", Proportional: "\u221D", Pscr: "\u{1D4AB}", Psi: "\u03A8", QUO: '"', QUOT: '"', Qfr: "\u{1D514}", Qopf: "\u211A", Qscr: "\u{1D4AC}", RBarr: "\u2910", RE: "\xAE", REG: "\xAE", Racute: "\u0154", Rang: "\u27EB", Rarr: "\u21A0", Rarrtl: "\u2916", Rcaron: "\u0158", Rcedil: "\u0156", Rcy: "\u0420", Re: "\u211C", ReverseElement: "\u220B", ReverseEquilibrium: "\u21CB", ReverseUpEquilibrium: "\u296F", Rfr: "\u211C", Rho: "\u03A1", RightAngleBracket: "\u27E9", RightArrow: "\u2192", RightArrowBar: "\u21E5", RightArrowLeftArrow: "\u21C4", RightCeiling: "\u2309", RightDoubleBracket: "\u27E7", RightDownTeeVector: "\u295D", RightDownVector: "\u21C2", RightDownVectorBar: "\u2955", RightFloor: "\u230B", RightTee: "\u22A2", RightTeeArrow: "\u21A6", RightTeeVector: "\u295B", RightTriangle: "\u22B3", RightTriangleBar: "\u29D0", RightTriangleEqual: "\u22B5", RightUpDownVector: "\u294F", RightUpTeeVector: "\u295C", RightUpVector: "\u21BE", RightUpVectorBar: "\u2954", RightVector: "\u21C0", RightVectorBar: "\u2953", Rightarrow: "\u21D2", Ropf: "\u211D", RoundImplies: "\u2970", Rrightarrow: "\u21DB", Rscr: "\u211B", Rsh: "\u21B1", RuleDelayed: "\u29F4", SHCHcy: "\u0429", SHcy: "\u0428", SOFTcy: "\u042C", Sacute: "\u015A", Sc: "\u2ABC", Scaron: "\u0160", Scedil: "\u015E", Scirc: "\u015C", Scy: "\u0421", Sfr: "\u{1D516}", ShortDownArrow: "\u2193", ShortLeftArrow: "\u2190", ShortRightArrow: "\u2192", ShortUpArrow: "\u2191", Sigma: "\u03A3", SmallCircle: "\u2218", Sopf: "\u{1D54A}", Sqrt: "\u221A", Square: "\u25A1", SquareIntersection: "\u2293", SquareSubset: "\u228F", SquareSubsetEqual: "\u2291", SquareSuperset: "\u2290", SquareSupersetEqual: "\u2292", SquareUnion: "\u2294", Sscr: "\u{1D4AE}", Star: "\u22C6", Sub: "\u22D0", Subset: "\u22D0", SubsetEqual: "\u2286", Succeeds: "\u227B", SucceedsEqual: "\u2AB0", SucceedsSlantEqual: "\u227D", SucceedsTilde: "\u227F", SuchThat: "\u220B", Sum: "\u2211", Sup: "\u22D1", Superset: "\u2283", SupersetEqual: "\u2287", Supset: "\u22D1", THOR: "\xDE", THORN: "\xDE", TRADE: "\u2122", TSHcy: "\u040B", TScy: "\u0426", Tab: "	", Tau: "\u03A4", Tcaron: "\u0164", Tcedil: "\u0162", Tcy: "\u0422", Tfr: "\u{1D517}", Therefore: "\u2234", Theta: "\u0398", ThickSpace: "\u205F\u200A", ThinSpace: "\u2009", Tilde: "\u223C", TildeEqual: "\u2243", TildeFullEqual: "\u2245", TildeTilde: "\u2248", Topf: "\u{1D54B}", TripleDot: "\u20DB", Tscr: "\u{1D4AF}", Tstrok: "\u0166", Uacut: "\xDA", Uacute: "\xDA", Uarr: "\u219F", Uarrocir: "\u2949", Ubrcy: "\u040E", Ubreve: "\u016C", Ucir: "\xDB", Ucirc: "\xDB", Ucy: "\u0423", Udblac: "\u0170", Ufr: "\u{1D518}", Ugrav: "\xD9", Ugrave: "\xD9", Umacr: "\u016A", UnderBar: "_", UnderBrace: "\u23DF", UnderBracket: "\u23B5", UnderParenthesis: "\u23DD", Union: "\u22C3", UnionPlus: "\u228E", Uogon: "\u0172", Uopf: "\u{1D54C}", UpArrow: "\u2191", UpArrowBar: "\u2912", UpArrowDownArrow: "\u21C5", UpDownArrow: "\u2195", UpEquilibrium: "\u296E", UpTee: "\u22A5", UpTeeArrow: "\u21A5", Uparrow: "\u21D1", Updownarrow: "\u21D5", UpperLeftArrow: "\u2196", UpperRightArrow: "\u2197", Upsi: "\u03D2", Upsilon: "\u03A5", Uring: "\u016E", Uscr: "\u{1D4B0}", Utilde: "\u0168", Uum: "\xDC", Uuml: "\xDC", VDash: "\u22AB", Vbar: "\u2AEB", Vcy: "\u0412", Vdash: "\u22A9", Vdashl: "\u2AE6", Vee: "\u22C1", Verbar: "\u2016", Vert: "\u2016", VerticalBar: "\u2223", VerticalLine: "|", VerticalSeparator: "\u2758", VerticalTilde: "\u2240", VeryThinSpace: "\u200A", Vfr: "\u{1D519}", Vopf: "\u{1D54D}", Vscr: "\u{1D4B1}", Vvdash: "\u22AA", Wcirc: "\u0174", Wedge: "\u22C0", Wfr: "\u{1D51A}", Wopf: "\u{1D54E}", Wscr: "\u{1D4B2}", Xfr: "\u{1D51B}", Xi: "\u039E", Xopf: "\u{1D54F}", Xscr: "\u{1D4B3}", YAcy: "\u042F", YIcy: "\u0407", YUcy: "\u042E", Yacut: "\xDD", Yacute: "\xDD", Ycirc: "\u0176", Ycy: "\u042B", Yfr: "\u{1D51C}", Yopf: "\u{1D550}", Yscr: "\u{1D4B4}", Yuml: "\u0178", ZHcy: "\u0416", Zacute: "\u0179", Zcaron: "\u017D", Zcy: "\u0417", Zdot: "\u017B", ZeroWidthSpace: "\u200B", Zeta: "\u0396", Zfr: "\u2128", Zopf: "\u2124", Zscr: "\u{1D4B5}", aacut: "\xE1", aacute: "\xE1", abreve: "\u0103", ac: "\u223E", acE: "\u223E\u0333", acd: "\u223F", acir: "\xE2", acirc: "\xE2", acut: "\xB4", acute: "\xB4", acy: "\u0430", aeli: "\xE6", aelig: "\xE6", af: "\u2061", afr: "\u{1D51E}", agrav: "\xE0", agrave: "\xE0", alefsym: "\u2135", aleph: "\u2135", alpha: "\u03B1", amacr: "\u0101", amalg: "\u2A3F", am: "&", amp: "&", and: "\u2227", andand: "\u2A55", andd: "\u2A5C", andslope: "\u2A58", andv: "\u2A5A", ang: "\u2220", ange: "\u29A4", angle: "\u2220", angmsd: "\u2221", angmsdaa: "\u29A8", angmsdab: "\u29A9", angmsdac: "\u29AA", angmsdad: "\u29AB", angmsdae: "\u29AC", angmsdaf: "\u29AD", angmsdag: "\u29AE", angmsdah: "\u29AF", angrt: "\u221F", angrtvb: "\u22BE", angrtvbd: "\u299D", angsph: "\u2222", angst: "\xC5", angzarr: "\u237C", aogon: "\u0105", aopf: "\u{1D552}", ap: "\u2248", apE: "\u2A70", apacir: "\u2A6F", ape: "\u224A", apid: "\u224B", apos: "'", approx: "\u2248", approxeq: "\u224A", arin: "\xE5", aring: "\xE5", ascr: "\u{1D4B6}", ast: "*", asymp: "\u2248", asympeq: "\u224D", atild: "\xE3", atilde: "\xE3", aum: "\xE4", auml: "\xE4", awconint: "\u2233", awint: "\u2A11", bNot: "\u2AED", backcong: "\u224C", backepsilon: "\u03F6", backprime: "\u2035", backsim: "\u223D", backsimeq: "\u22CD", barvee: "\u22BD", barwed: "\u2305", barwedge: "\u2305", bbrk: "\u23B5", bbrktbrk: "\u23B6", bcong: "\u224C", bcy: "\u0431", bdquo: "\u201E", becaus: "\u2235", because: "\u2235", bemptyv: "\u29B0", bepsi: "\u03F6", bernou: "\u212C", beta: "\u03B2", beth: "\u2136", between: "\u226C", bfr: "\u{1D51F}", bigcap: "\u22C2", bigcirc: "\u25EF", bigcup: "\u22C3", bigodot: "\u2A00", bigoplus: "\u2A01", bigotimes: "\u2A02", bigsqcup: "\u2A06", bigstar: "\u2605", bigtriangledown: "\u25BD", bigtriangleup: "\u25B3", biguplus: "\u2A04", bigvee: "\u22C1", bigwedge: "\u22C0", bkarow: "\u290D", blacklozenge: "\u29EB", blacksquare: "\u25AA", blacktriangle: "\u25B4", blacktriangledown: "\u25BE", blacktriangleleft: "\u25C2", blacktriangleright: "\u25B8", blank: "\u2423", blk12: "\u2592", blk14: "\u2591", blk34: "\u2593", block: "\u2588", bne: "=\u20E5", bnequiv: "\u2261\u20E5", bnot: "\u2310", bopf: "\u{1D553}", bot: "\u22A5", bottom: "\u22A5", bowtie: "\u22C8", boxDL: "\u2557", boxDR: "\u2554", boxDl: "\u2556", boxDr: "\u2553", boxH: "\u2550", boxHD: "\u2566", boxHU: "\u2569", boxHd: "\u2564", boxHu: "\u2567", boxUL: "\u255D", boxUR: "\u255A", boxUl: "\u255C", boxUr: "\u2559", boxV: "\u2551", boxVH: "\u256C", boxVL: "\u2563", boxVR: "\u2560", boxVh: "\u256B", boxVl: "\u2562", boxVr: "\u255F", boxbox: "\u29C9", boxdL: "\u2555", boxdR: "\u2552", boxdl: "\u2510", boxdr: "\u250C", boxh: "\u2500", boxhD: "\u2565", boxhU: "\u2568", boxhd: "\u252C", boxhu: "\u2534", boxminus: "\u229F", boxplus: "\u229E", boxtimes: "\u22A0", boxuL: "\u255B", boxuR: "\u2558", boxul: "\u2518", boxur: "\u2514", boxv: "\u2502", boxvH: "\u256A", boxvL: "\u2561", boxvR: "\u255E", boxvh: "\u253C", boxvl: "\u2524", boxvr: "\u251C", bprime: "\u2035", breve: "\u02D8", brvba: "\xA6", brvbar: "\xA6", bscr: "\u{1D4B7}", bsemi: "\u204F", bsim: "\u223D", bsime: "\u22CD", bsol: "\\", bsolb: "\u29C5", bsolhsub: "\u27C8", bull: "\u2022", bullet: "\u2022", bump: "\u224E", bumpE: "\u2AAE", bumpe: "\u224F", bumpeq: "\u224F", cacute: "\u0107", cap: "\u2229", capand: "\u2A44", capbrcup: "\u2A49", capcap: "\u2A4B", capcup: "\u2A47", capdot: "\u2A40", caps: "\u2229\uFE00", caret: "\u2041", caron: "\u02C7", ccaps: "\u2A4D", ccaron: "\u010D", ccedi: "\xE7", ccedil: "\xE7", ccirc: "\u0109", ccups: "\u2A4C", ccupssm: "\u2A50", cdot: "\u010B", cedi: "\xB8", cedil: "\xB8", cemptyv: "\u29B2", cen: "\xA2", cent: "\xA2", centerdot: "\xB7", cfr: "\u{1D520}", chcy: "\u0447", check: "\u2713", checkmark: "\u2713", chi: "\u03C7", cir: "\u25CB", cirE: "\u29C3", circ: "\u02C6", circeq: "\u2257", circlearrowleft: "\u21BA", circlearrowright: "\u21BB", circledR: "\xAE", circledS: "\u24C8", circledast: "\u229B", circledcirc: "\u229A", circleddash: "\u229D", cire: "\u2257", cirfnint: "\u2A10", cirmid: "\u2AEF", cirscir: "\u29C2", clubs: "\u2663", clubsuit: "\u2663", colon: ":", colone: "\u2254", coloneq: "\u2254", comma: ",", commat: "@", comp: "\u2201", compfn: "\u2218", complement: "\u2201", complexes: "\u2102", cong: "\u2245", congdot: "\u2A6D", conint: "\u222E", copf: "\u{1D554}", coprod: "\u2210", cop: "\xA9", copy: "\xA9", copysr: "\u2117", crarr: "\u21B5", cross: "\u2717", cscr: "\u{1D4B8}", csub: "\u2ACF", csube: "\u2AD1", csup: "\u2AD0", csupe: "\u2AD2", ctdot: "\u22EF", cudarrl: "\u2938", cudarrr: "\u2935", cuepr: "\u22DE", cuesc: "\u22DF", cularr: "\u21B6", cularrp: "\u293D", cup: "\u222A", cupbrcap: "\u2A48", cupcap: "\u2A46", cupcup: "\u2A4A", cupdot: "\u228D", cupor: "\u2A45", cups: "\u222A\uFE00", curarr: "\u21B7", curarrm: "\u293C", curlyeqprec: "\u22DE", curlyeqsucc: "\u22DF", curlyvee: "\u22CE", curlywedge: "\u22CF", curre: "\xA4", curren: "\xA4", curvearrowleft: "\u21B6", curvearrowright: "\u21B7", cuvee: "\u22CE", cuwed: "\u22CF", cwconint: "\u2232", cwint: "\u2231", cylcty: "\u232D", dArr: "\u21D3", dHar: "\u2965", dagger: "\u2020", daleth: "\u2138", darr: "\u2193", dash: "\u2010", dashv: "\u22A3", dbkarow: "\u290F", dblac: "\u02DD", dcaron: "\u010F", dcy: "\u0434", dd: "\u2146", ddagger: "\u2021", ddarr: "\u21CA", ddotseq: "\u2A77", de: "\xB0", deg: "\xB0", delta: "\u03B4", demptyv: "\u29B1", dfisht: "\u297F", dfr: "\u{1D521}", dharl: "\u21C3", dharr: "\u21C2", diam: "\u22C4", diamond: "\u22C4", diamondsuit: "\u2666", diams: "\u2666", die: "\xA8", digamma: "\u03DD", disin: "\u22F2", div: "\xF7", divid: "\xF7", divide: "\xF7", divideontimes: "\u22C7", divonx: "\u22C7", djcy: "\u0452", dlcorn: "\u231E", dlcrop: "\u230D", dollar: "$", dopf: "\u{1D555}", dot: "\u02D9", doteq: "\u2250", doteqdot: "\u2251", dotminus: "\u2238", dotplus: "\u2214", dotsquare: "\u22A1", doublebarwedge: "\u2306", downarrow: "\u2193", downdownarrows: "\u21CA", downharpoonleft: "\u21C3", downharpoonright: "\u21C2", drbkarow: "\u2910", drcorn: "\u231F", drcrop: "\u230C", dscr: "\u{1D4B9}", dscy: "\u0455", dsol: "\u29F6", dstrok: "\u0111", dtdot: "\u22F1", dtri: "\u25BF", dtrif: "\u25BE", duarr: "\u21F5", duhar: "\u296F", dwangle: "\u29A6", dzcy: "\u045F", dzigrarr: "\u27FF", eDDot: "\u2A77", eDot: "\u2251", eacut: "\xE9", eacute: "\xE9", easter: "\u2A6E", ecaron: "\u011B", ecir: "\xEA", ecirc: "\xEA", ecolon: "\u2255", ecy: "\u044D", edot: "\u0117", ee: "\u2147", efDot: "\u2252", efr: "\u{1D522}", eg: "\u2A9A", egrav: "\xE8", egrave: "\xE8", egs: "\u2A96", egsdot: "\u2A98", el: "\u2A99", elinters: "\u23E7", ell: "\u2113", els: "\u2A95", elsdot: "\u2A97", emacr: "\u0113", empty: "\u2205", emptyset: "\u2205", emptyv: "\u2205", emsp13: "\u2004", emsp14: "\u2005", emsp: "\u2003", eng: "\u014B", ensp: "\u2002", eogon: "\u0119", eopf: "\u{1D556}", epar: "\u22D5", eparsl: "\u29E3", eplus: "\u2A71", epsi: "\u03B5", epsilon: "\u03B5", epsiv: "\u03F5", eqcirc: "\u2256", eqcolon: "\u2255", eqsim: "\u2242", eqslantgtr: "\u2A96", eqslantless: "\u2A95", equals: "=", equest: "\u225F", equiv: "\u2261", equivDD: "\u2A78", eqvparsl: "\u29E5", erDot: "\u2253", erarr: "\u2971", escr: "\u212F", esdot: "\u2250", esim: "\u2242", eta: "\u03B7", et: "\xF0", eth: "\xF0", eum: "\xEB", euml: "\xEB", euro: "\u20AC", excl: "!", exist: "\u2203", expectation: "\u2130", exponentiale: "\u2147", fallingdotseq: "\u2252", fcy: "\u0444", female: "\u2640", ffilig: "\uFB03", fflig: "\uFB00", ffllig: "\uFB04", ffr: "\u{1D523}", filig: "\uFB01", fjlig: "fj", flat: "\u266D", fllig: "\uFB02", fltns: "\u25B1", fnof: "\u0192", fopf: "\u{1D557}", forall: "\u2200", fork: "\u22D4", forkv: "\u2AD9", fpartint: "\u2A0D", frac1: "\xBC", frac12: "\xBD", frac13: "\u2153", frac14: "\xBC", frac15: "\u2155", frac16: "\u2159", frac18: "\u215B", frac23: "\u2154", frac25: "\u2156", frac3: "\xBE", frac34: "\xBE", frac35: "\u2157", frac38: "\u215C", frac45: "\u2158", frac56: "\u215A", frac58: "\u215D", frac78: "\u215E", frasl: "\u2044", frown: "\u2322", fscr: "\u{1D4BB}", gE: "\u2267", gEl: "\u2A8C", gacute: "\u01F5", gamma: "\u03B3", gammad: "\u03DD", gap: "\u2A86", gbreve: "\u011F", gcirc: "\u011D", gcy: "\u0433", gdot: "\u0121", ge: "\u2265", gel: "\u22DB", geq: "\u2265", geqq: "\u2267", geqslant: "\u2A7E", ges: "\u2A7E", gescc: "\u2AA9", gesdot: "\u2A80", gesdoto: "\u2A82", gesdotol: "\u2A84", gesl: "\u22DB\uFE00", gesles: "\u2A94", gfr: "\u{1D524}", gg: "\u226B", ggg: "\u22D9", gimel: "\u2137", gjcy: "\u0453", gl: "\u2277", glE: "\u2A92", gla: "\u2AA5", glj: "\u2AA4", gnE: "\u2269", gnap: "\u2A8A", gnapprox: "\u2A8A", gne: "\u2A88", gneq: "\u2A88", gneqq: "\u2269", gnsim: "\u22E7", gopf: "\u{1D558}", grave: "`", gscr: "\u210A", gsim: "\u2273", gsime: "\u2A8E", gsiml: "\u2A90", g: ">", gt: ">", gtcc: "\u2AA7", gtcir: "\u2A7A", gtdot: "\u22D7", gtlPar: "\u2995", gtquest: "\u2A7C", gtrapprox: "\u2A86", gtrarr: "\u2978", gtrdot: "\u22D7", gtreqless: "\u22DB", gtreqqless: "\u2A8C", gtrless: "\u2277", gtrsim: "\u2273", gvertneqq: "\u2269\uFE00", gvnE: "\u2269\uFE00", hArr: "\u21D4", hairsp: "\u200A", half: "\xBD", hamilt: "\u210B", hardcy: "\u044A", harr: "\u2194", harrcir: "\u2948", harrw: "\u21AD", hbar: "\u210F", hcirc: "\u0125", hearts: "\u2665", heartsuit: "\u2665", hellip: "\u2026", hercon: "\u22B9", hfr: "\u{1D525}", hksearow: "\u2925", hkswarow: "\u2926", hoarr: "\u21FF", homtht: "\u223B", hookleftarrow: "\u21A9", hookrightarrow: "\u21AA", hopf: "\u{1D559}", horbar: "\u2015", hscr: "\u{1D4BD}", hslash: "\u210F", hstrok: "\u0127", hybull: "\u2043", hyphen: "\u2010", iacut: "\xED", iacute: "\xED", ic: "\u2063", icir: "\xEE", icirc: "\xEE", icy: "\u0438", iecy: "\u0435", iexc: "\xA1", iexcl: "\xA1", iff: "\u21D4", ifr: "\u{1D526}", igrav: "\xEC", igrave: "\xEC", ii: "\u2148", iiiint: "\u2A0C", iiint: "\u222D", iinfin: "\u29DC", iiota: "\u2129", ijlig: "\u0133", imacr: "\u012B", image: "\u2111", imagline: "\u2110", imagpart: "\u2111", imath: "\u0131", imof: "\u22B7", imped: "\u01B5", in: "\u2208", incare: "\u2105", infin: "\u221E", infintie: "\u29DD", inodot: "\u0131", int: "\u222B", intcal: "\u22BA", integers: "\u2124", intercal: "\u22BA", intlarhk: "\u2A17", intprod: "\u2A3C", iocy: "\u0451", iogon: "\u012F", iopf: "\u{1D55A}", iota: "\u03B9", iprod: "\u2A3C", iques: "\xBF", iquest: "\xBF", iscr: "\u{1D4BE}", isin: "\u2208", isinE: "\u22F9", isindot: "\u22F5", isins: "\u22F4", isinsv: "\u22F3", isinv: "\u2208", it: "\u2062", itilde: "\u0129", iukcy: "\u0456", ium: "\xEF", iuml: "\xEF", jcirc: "\u0135", jcy: "\u0439", jfr: "\u{1D527}", jmath: "\u0237", jopf: "\u{1D55B}", jscr: "\u{1D4BF}", jsercy: "\u0458", jukcy: "\u0454", kappa: "\u03BA", kappav: "\u03F0", kcedil: "\u0137", kcy: "\u043A", kfr: "\u{1D528}", kgreen: "\u0138", khcy: "\u0445", kjcy: "\u045C", kopf: "\u{1D55C}", kscr: "\u{1D4C0}", lAarr: "\u21DA", lArr: "\u21D0", lAtail: "\u291B", lBarr: "\u290E", lE: "\u2266", lEg: "\u2A8B", lHar: "\u2962", lacute: "\u013A", laemptyv: "\u29B4", lagran: "\u2112", lambda: "\u03BB", lang: "\u27E8", langd: "\u2991", langle: "\u27E8", lap: "\u2A85", laqu: "\xAB", laquo: "\xAB", larr: "\u2190", larrb: "\u21E4", larrbfs: "\u291F", larrfs: "\u291D", larrhk: "\u21A9", larrlp: "\u21AB", larrpl: "\u2939", larrsim: "\u2973", larrtl: "\u21A2", lat: "\u2AAB", latail: "\u2919", late: "\u2AAD", lates: "\u2AAD\uFE00", lbarr: "\u290C", lbbrk: "\u2772", lbrace: "{", lbrack: "[", lbrke: "\u298B", lbrksld: "\u298F", lbrkslu: "\u298D", lcaron: "\u013E", lcedil: "\u013C", lceil: "\u2308", lcub: "{", lcy: "\u043B", ldca: "\u2936", ldquo: "\u201C", ldquor: "\u201E", ldrdhar: "\u2967", ldrushar: "\u294B", ldsh: "\u21B2", le: "\u2264", leftarrow: "\u2190", leftarrowtail: "\u21A2", leftharpoondown: "\u21BD", leftharpoonup: "\u21BC", leftleftarrows: "\u21C7", leftrightarrow: "\u2194", leftrightarrows: "\u21C6", leftrightharpoons: "\u21CB", leftrightsquigarrow: "\u21AD", leftthreetimes: "\u22CB", leg: "\u22DA", leq: "\u2264", leqq: "\u2266", leqslant: "\u2A7D", les: "\u2A7D", lescc: "\u2AA8", lesdot: "\u2A7F", lesdoto: "\u2A81", lesdotor: "\u2A83", lesg: "\u22DA\uFE00", lesges: "\u2A93", lessapprox: "\u2A85", lessdot: "\u22D6", lesseqgtr: "\u22DA", lesseqqgtr: "\u2A8B", lessgtr: "\u2276", lesssim: "\u2272", lfisht: "\u297C", lfloor: "\u230A", lfr: "\u{1D529}", lg: "\u2276", lgE: "\u2A91", lhard: "\u21BD", lharu: "\u21BC", lharul: "\u296A", lhblk: "\u2584", ljcy: "\u0459", ll: "\u226A", llarr: "\u21C7", llcorner: "\u231E", llhard: "\u296B", lltri: "\u25FA", lmidot: "\u0140", lmoust: "\u23B0", lmoustache: "\u23B0", lnE: "\u2268", lnap: "\u2A89", lnapprox: "\u2A89", lne: "\u2A87", lneq: "\u2A87", lneqq: "\u2268", lnsim: "\u22E6", loang: "\u27EC", loarr: "\u21FD", lobrk: "\u27E6", longleftarrow: "\u27F5", longleftrightarrow: "\u27F7", longmapsto: "\u27FC", longrightarrow: "\u27F6", looparrowleft: "\u21AB", looparrowright: "\u21AC", lopar: "\u2985", lopf: "\u{1D55D}", loplus: "\u2A2D", lotimes: "\u2A34", lowast: "\u2217", lowbar: "_", loz: "\u25CA", lozenge: "\u25CA", lozf: "\u29EB", lpar: "(", lparlt: "\u2993", lrarr: "\u21C6", lrcorner: "\u231F", lrhar: "\u21CB", lrhard: "\u296D", lrm: "\u200E", lrtri: "\u22BF", lsaquo: "\u2039", lscr: "\u{1D4C1}", lsh: "\u21B0", lsim: "\u2272", lsime: "\u2A8D", lsimg: "\u2A8F", lsqb: "[", lsquo: "\u2018", lsquor: "\u201A", lstrok: "\u0142", l: "<", lt: "<", ltcc: "\u2AA6", ltcir: "\u2A79", ltdot: "\u22D6", lthree: "\u22CB", ltimes: "\u22C9", ltlarr: "\u2976", ltquest: "\u2A7B", ltrPar: "\u2996", ltri: "\u25C3", ltrie: "\u22B4", ltrif: "\u25C2", lurdshar: "\u294A", luruhar: "\u2966", lvertneqq: "\u2268\uFE00", lvnE: "\u2268\uFE00", mDDot: "\u223A", mac: "\xAF", macr: "\xAF", male: "\u2642", malt: "\u2720", maltese: "\u2720", map: "\u21A6", mapsto: "\u21A6", mapstodown: "\u21A7", mapstoleft: "\u21A4", mapstoup: "\u21A5", marker: "\u25AE", mcomma: "\u2A29", mcy: "\u043C", mdash: "\u2014", measuredangle: "\u2221", mfr: "\u{1D52A}", mho: "\u2127", micr: "\xB5", micro: "\xB5", mid: "\u2223", midast: "*", midcir: "\u2AF0", middo: "\xB7", middot: "\xB7", minus: "\u2212", minusb: "\u229F", minusd: "\u2238", minusdu: "\u2A2A", mlcp: "\u2ADB", mldr: "\u2026", mnplus: "\u2213", models: "\u22A7", mopf: "\u{1D55E}", mp: "\u2213", mscr: "\u{1D4C2}", mstpos: "\u223E", mu: "\u03BC", multimap: "\u22B8", mumap: "\u22B8", nGg: "\u22D9\u0338", nGt: "\u226B\u20D2", nGtv: "\u226B\u0338", nLeftarrow: "\u21CD", nLeftrightarrow: "\u21CE", nLl: "\u22D8\u0338", nLt: "\u226A\u20D2", nLtv: "\u226A\u0338", nRightarrow: "\u21CF", nVDash: "\u22AF", nVdash: "\u22AE", nabla: "\u2207", nacute: "\u0144", nang: "\u2220\u20D2", nap: "\u2249", napE: "\u2A70\u0338", napid: "\u224B\u0338", napos: "\u0149", napprox: "\u2249", natur: "\u266E", natural: "\u266E", naturals: "\u2115", nbs: "\xA0", nbsp: "\xA0", nbump: "\u224E\u0338", nbumpe: "\u224F\u0338", ncap: "\u2A43", ncaron: "\u0148", ncedil: "\u0146", ncong: "\u2247", ncongdot: "\u2A6D\u0338", ncup: "\u2A42", ncy: "\u043D", ndash: "\u2013", ne: "\u2260", neArr: "\u21D7", nearhk: "\u2924", nearr: "\u2197", nearrow: "\u2197", nedot: "\u2250\u0338", nequiv: "\u2262", nesear: "\u2928", nesim: "\u2242\u0338", nexist: "\u2204", nexists: "\u2204", nfr: "\u{1D52B}", ngE: "\u2267\u0338", nge: "\u2271", ngeq: "\u2271", ngeqq: "\u2267\u0338", ngeqslant: "\u2A7E\u0338", nges: "\u2A7E\u0338", ngsim: "\u2275", ngt: "\u226F", ngtr: "\u226F", nhArr: "\u21CE", nharr: "\u21AE", nhpar: "\u2AF2", ni: "\u220B", nis: "\u22FC", nisd: "\u22FA", niv: "\u220B", njcy: "\u045A", nlArr: "\u21CD", nlE: "\u2266\u0338", nlarr: "\u219A", nldr: "\u2025", nle: "\u2270", nleftarrow: "\u219A", nleftrightarrow: "\u21AE", nleq: "\u2270", nleqq: "\u2266\u0338", nleqslant: "\u2A7D\u0338", nles: "\u2A7D\u0338", nless: "\u226E", nlsim: "\u2274", nlt: "\u226E", nltri: "\u22EA", nltrie: "\u22EC", nmid: "\u2224", nopf: "\u{1D55F}", no: "\xAC", not: "\xAC", notin: "\u2209", notinE: "\u22F9\u0338", notindot: "\u22F5\u0338", notinva: "\u2209", notinvb: "\u22F7", notinvc: "\u22F6", notni: "\u220C", notniva: "\u220C", notnivb: "\u22FE", notnivc: "\u22FD", npar: "\u2226", nparallel: "\u2226", nparsl: "\u2AFD\u20E5", npart: "\u2202\u0338", npolint: "\u2A14", npr: "\u2280", nprcue: "\u22E0", npre: "\u2AAF\u0338", nprec: "\u2280", npreceq: "\u2AAF\u0338", nrArr: "\u21CF", nrarr: "\u219B", nrarrc: "\u2933\u0338", nrarrw: "\u219D\u0338", nrightarrow: "\u219B", nrtri: "\u22EB", nrtrie: "\u22ED", nsc: "\u2281", nsccue: "\u22E1", nsce: "\u2AB0\u0338", nscr: "\u{1D4C3}", nshortmid: "\u2224", nshortparallel: "\u2226", nsim: "\u2241", nsime: "\u2244", nsimeq: "\u2244", nsmid: "\u2224", nspar: "\u2226", nsqsube: "\u22E2", nsqsupe: "\u22E3", nsub: "\u2284", nsubE: "\u2AC5\u0338", nsube: "\u2288", nsubset: "\u2282\u20D2", nsubseteq: "\u2288", nsubseteqq: "\u2AC5\u0338", nsucc: "\u2281", nsucceq: "\u2AB0\u0338", nsup: "\u2285", nsupE: "\u2AC6\u0338", nsupe: "\u2289", nsupset: "\u2283\u20D2", nsupseteq: "\u2289", nsupseteqq: "\u2AC6\u0338", ntgl: "\u2279", ntild: "\xF1", ntilde: "\xF1", ntlg: "\u2278", ntriangleleft: "\u22EA", ntrianglelefteq: "\u22EC", ntriangleright: "\u22EB", ntrianglerighteq: "\u22ED", nu: "\u03BD", num: "#", numero: "\u2116", numsp: "\u2007", nvDash: "\u22AD", nvHarr: "\u2904", nvap: "\u224D\u20D2", nvdash: "\u22AC", nvge: "\u2265\u20D2", nvgt: ">\u20D2", nvinfin: "\u29DE", nvlArr: "\u2902", nvle: "\u2264\u20D2", nvlt: "<\u20D2", nvltrie: "\u22B4\u20D2", nvrArr: "\u2903", nvrtrie: "\u22B5\u20D2", nvsim: "\u223C\u20D2", nwArr: "\u21D6", nwarhk: "\u2923", nwarr: "\u2196", nwarrow: "\u2196", nwnear: "\u2927", oS: "\u24C8", oacut: "\xF3", oacute: "\xF3", oast: "\u229B", ocir: "\xF4", ocirc: "\xF4", ocy: "\u043E", odash: "\u229D", odblac: "\u0151", odiv: "\u2A38", odot: "\u2299", odsold: "\u29BC", oelig: "\u0153", ofcir: "\u29BF", ofr: "\u{1D52C}", ogon: "\u02DB", ograv: "\xF2", ograve: "\xF2", ogt: "\u29C1", ohbar: "\u29B5", ohm: "\u03A9", oint: "\u222E", olarr: "\u21BA", olcir: "\u29BE", olcross: "\u29BB", oline: "\u203E", olt: "\u29C0", omacr: "\u014D", omega: "\u03C9", omicron: "\u03BF", omid: "\u29B6", ominus: "\u2296", oopf: "\u{1D560}", opar: "\u29B7", operp: "\u29B9", oplus: "\u2295", or: "\u2228", orarr: "\u21BB", ord: "\xBA", order: "\u2134", orderof: "\u2134", ordf: "\xAA", ordm: "\xBA", origof: "\u22B6", oror: "\u2A56", orslope: "\u2A57", orv: "\u2A5B", oscr: "\u2134", oslas: "\xF8", oslash: "\xF8", osol: "\u2298", otild: "\xF5", otilde: "\xF5", otimes: "\u2297", otimesas: "\u2A36", oum: "\xF6", ouml: "\xF6", ovbar: "\u233D", par: "\xB6", para: "\xB6", parallel: "\u2225", parsim: "\u2AF3", parsl: "\u2AFD", part: "\u2202", pcy: "\u043F", percnt: "%", period: ".", permil: "\u2030", perp: "\u22A5", pertenk: "\u2031", pfr: "\u{1D52D}", phi: "\u03C6", phiv: "\u03D5", phmmat: "\u2133", phone: "\u260E", pi: "\u03C0", pitchfork: "\u22D4", piv: "\u03D6", planck: "\u210F", planckh: "\u210E", plankv: "\u210F", plus: "+", plusacir: "\u2A23", plusb: "\u229E", pluscir: "\u2A22", plusdo: "\u2214", plusdu: "\u2A25", pluse: "\u2A72", plusm: "\xB1", plusmn: "\xB1", plussim: "\u2A26", plustwo: "\u2A27", pm: "\xB1", pointint: "\u2A15", popf: "\u{1D561}", poun: "\xA3", pound: "\xA3", pr: "\u227A", prE: "\u2AB3", prap: "\u2AB7", prcue: "\u227C", pre: "\u2AAF", prec: "\u227A", precapprox: "\u2AB7", preccurlyeq: "\u227C", preceq: "\u2AAF", precnapprox: "\u2AB9", precneqq: "\u2AB5", precnsim: "\u22E8", precsim: "\u227E", prime: "\u2032", primes: "\u2119", prnE: "\u2AB5", prnap: "\u2AB9", prnsim: "\u22E8", prod: "\u220F", profalar: "\u232E", profline: "\u2312", profsurf: "\u2313", prop: "\u221D", propto: "\u221D", prsim: "\u227E", prurel: "\u22B0", pscr: "\u{1D4C5}", psi: "\u03C8", puncsp: "\u2008", qfr: "\u{1D52E}", qint: "\u2A0C", qopf: "\u{1D562}", qprime: "\u2057", qscr: "\u{1D4C6}", quaternions: "\u210D", quatint: "\u2A16", quest: "?", questeq: "\u225F", quo: '"', quot: '"', rAarr: "\u21DB", rArr: "\u21D2", rAtail: "\u291C", rBarr: "\u290F", rHar: "\u2964", race: "\u223D\u0331", racute: "\u0155", radic: "\u221A", raemptyv: "\u29B3", rang: "\u27E9", rangd: "\u2992", range: "\u29A5", rangle: "\u27E9", raqu: "\xBB", raquo: "\xBB", rarr: "\u2192", rarrap: "\u2975", rarrb: "\u21E5", rarrbfs: "\u2920", rarrc: "\u2933", rarrfs: "\u291E", rarrhk: "\u21AA", rarrlp: "\u21AC", rarrpl: "\u2945", rarrsim: "\u2974", rarrtl: "\u21A3", rarrw: "\u219D", ratail: "\u291A", ratio: "\u2236", rationals: "\u211A", rbarr: "\u290D", rbbrk: "\u2773", rbrace: "}", rbrack: "]", rbrke: "\u298C", rbrksld: "\u298E", rbrkslu: "\u2990", rcaron: "\u0159", rcedil: "\u0157", rceil: "\u2309", rcub: "}", rcy: "\u0440", rdca: "\u2937", rdldhar: "\u2969", rdquo: "\u201D", rdquor: "\u201D", rdsh: "\u21B3", real: "\u211C", realine: "\u211B", realpart: "\u211C", reals: "\u211D", rect: "\u25AD", re: "\xAE", reg: "\xAE", rfisht: "\u297D", rfloor: "\u230B", rfr: "\u{1D52F}", rhard: "\u21C1", rharu: "\u21C0", rharul: "\u296C", rho: "\u03C1", rhov: "\u03F1", rightarrow: "\u2192", rightarrowtail: "\u21A3", rightharpoondown: "\u21C1", rightharpoonup: "\u21C0", rightleftarrows: "\u21C4", rightleftharpoons: "\u21CC", rightrightarrows: "\u21C9", rightsquigarrow: "\u219D", rightthreetimes: "\u22CC", ring: "\u02DA", risingdotseq: "\u2253", rlarr: "\u21C4", rlhar: "\u21CC", rlm: "\u200F", rmoust: "\u23B1", rmoustache: "\u23B1", rnmid: "\u2AEE", roang: "\u27ED", roarr: "\u21FE", robrk: "\u27E7", ropar: "\u2986", ropf: "\u{1D563}", roplus: "\u2A2E", rotimes: "\u2A35", rpar: ")", rpargt: "\u2994", rppolint: "\u2A12", rrarr: "\u21C9", rsaquo: "\u203A", rscr: "\u{1D4C7}", rsh: "\u21B1", rsqb: "]", rsquo: "\u2019", rsquor: "\u2019", rthree: "\u22CC", rtimes: "\u22CA", rtri: "\u25B9", rtrie: "\u22B5", rtrif: "\u25B8", rtriltri: "\u29CE", ruluhar: "\u2968", rx: "\u211E", sacute: "\u015B", sbquo: "\u201A", sc: "\u227B", scE: "\u2AB4", scap: "\u2AB8", scaron: "\u0161", sccue: "\u227D", sce: "\u2AB0", scedil: "\u015F", scirc: "\u015D", scnE: "\u2AB6", scnap: "\u2ABA", scnsim: "\u22E9", scpolint: "\u2A13", scsim: "\u227F", scy: "\u0441", sdot: "\u22C5", sdotb: "\u22A1", sdote: "\u2A66", seArr: "\u21D8", searhk: "\u2925", searr: "\u2198", searrow: "\u2198", sec: "\xA7", sect: "\xA7", semi: ";", seswar: "\u2929", setminus: "\u2216", setmn: "\u2216", sext: "\u2736", sfr: "\u{1D530}", sfrown: "\u2322", sharp: "\u266F", shchcy: "\u0449", shcy: "\u0448", shortmid: "\u2223", shortparallel: "\u2225", sh: "\xAD", shy: "\xAD", sigma: "\u03C3", sigmaf: "\u03C2", sigmav: "\u03C2", sim: "\u223C", simdot: "\u2A6A", sime: "\u2243", simeq: "\u2243", simg: "\u2A9E", simgE: "\u2AA0", siml: "\u2A9D", simlE: "\u2A9F", simne: "\u2246", simplus: "\u2A24", simrarr: "\u2972", slarr: "\u2190", smallsetminus: "\u2216", smashp: "\u2A33", smeparsl: "\u29E4", smid: "\u2223", smile: "\u2323", smt: "\u2AAA", smte: "\u2AAC", smtes: "\u2AAC\uFE00", softcy: "\u044C", sol: "/", solb: "\u29C4", solbar: "\u233F", sopf: "\u{1D564}", spades: "\u2660", spadesuit: "\u2660", spar: "\u2225", sqcap: "\u2293", sqcaps: "\u2293\uFE00", sqcup: "\u2294", sqcups: "\u2294\uFE00", sqsub: "\u228F", sqsube: "\u2291", sqsubset: "\u228F", sqsubseteq: "\u2291", sqsup: "\u2290", sqsupe: "\u2292", sqsupset: "\u2290", sqsupseteq: "\u2292", squ: "\u25A1", square: "\u25A1", squarf: "\u25AA", squf: "\u25AA", srarr: "\u2192", sscr: "\u{1D4C8}", ssetmn: "\u2216", ssmile: "\u2323", sstarf: "\u22C6", star: "\u2606", starf: "\u2605", straightepsilon: "\u03F5", straightphi: "\u03D5", strns: "\xAF", sub: "\u2282", subE: "\u2AC5", subdot: "\u2ABD", sube: "\u2286", subedot: "\u2AC3", submult: "\u2AC1", subnE: "\u2ACB", subne: "\u228A", subplus: "\u2ABF", subrarr: "\u2979", subset: "\u2282", subseteq: "\u2286", subseteqq: "\u2AC5", subsetneq: "\u228A", subsetneqq: "\u2ACB", subsim: "\u2AC7", subsub: "\u2AD5", subsup: "\u2AD3", succ: "\u227B", succapprox: "\u2AB8", succcurlyeq: "\u227D", succeq: "\u2AB0", succnapprox: "\u2ABA", succneqq: "\u2AB6", succnsim: "\u22E9", succsim: "\u227F", sum: "\u2211", sung: "\u266A", sup: "\u2283", sup1: "\xB9", sup2: "\xB2", sup3: "\xB3", supE: "\u2AC6", supdot: "\u2ABE", supdsub: "\u2AD8", supe: "\u2287", supedot: "\u2AC4", suphsol: "\u27C9", suphsub: "\u2AD7", suplarr: "\u297B", supmult: "\u2AC2", supnE: "\u2ACC", supne: "\u228B", supplus: "\u2AC0", supset: "\u2283", supseteq: "\u2287", supseteqq: "\u2AC6", supsetneq: "\u228B", supsetneqq: "\u2ACC", supsim: "\u2AC8", supsub: "\u2AD4", supsup: "\u2AD6", swArr: "\u21D9", swarhk: "\u2926", swarr: "\u2199", swarrow: "\u2199", swnwar: "\u292A", szli: "\xDF", szlig: "\xDF", target: "\u2316", tau: "\u03C4", tbrk: "\u23B4", tcaron: "\u0165", tcedil: "\u0163", tcy: "\u0442", tdot: "\u20DB", telrec: "\u2315", tfr: "\u{1D531}", there4: "\u2234", therefore: "\u2234", theta: "\u03B8", thetasym: "\u03D1", thetav: "\u03D1", thickapprox: "\u2248", thicksim: "\u223C", thinsp: "\u2009", thkap: "\u2248", thksim: "\u223C", thor: "\xFE", thorn: "\xFE", tilde: "\u02DC", time: "\xD7", times: "\xD7", timesb: "\u22A0", timesbar: "\u2A31", timesd: "\u2A30", tint: "\u222D", toea: "\u2928", top: "\u22A4", topbot: "\u2336", topcir: "\u2AF1", topf: "\u{1D565}", topfork: "\u2ADA", tosa: "\u2929", tprime: "\u2034", trade: "\u2122", triangle: "\u25B5", triangledown: "\u25BF", triangleleft: "\u25C3", trianglelefteq: "\u22B4", triangleq: "\u225C", triangleright: "\u25B9", trianglerighteq: "\u22B5", tridot: "\u25EC", trie: "\u225C", triminus: "\u2A3A", triplus: "\u2A39", trisb: "\u29CD", tritime: "\u2A3B", trpezium: "\u23E2", tscr: "\u{1D4C9}", tscy: "\u0446", tshcy: "\u045B", tstrok: "\u0167", twixt: "\u226C", twoheadleftarrow: "\u219E", twoheadrightarrow: "\u21A0", uArr: "\u21D1", uHar: "\u2963", uacut: "\xFA", uacute: "\xFA", uarr: "\u2191", ubrcy: "\u045E", ubreve: "\u016D", ucir: "\xFB", ucirc: "\xFB", ucy: "\u0443", udarr: "\u21C5", udblac: "\u0171", udhar: "\u296E", ufisht: "\u297E", ufr: "\u{1D532}", ugrav: "\xF9", ugrave: "\xF9", uharl: "\u21BF", uharr: "\u21BE", uhblk: "\u2580", ulcorn: "\u231C", ulcorner: "\u231C", ulcrop: "\u230F", ultri: "\u25F8", umacr: "\u016B", um: "\xA8", uml: "\xA8", uogon: "\u0173", uopf: "\u{1D566}", uparrow: "\u2191", updownarrow: "\u2195", upharpoonleft: "\u21BF", upharpoonright: "\u21BE", uplus: "\u228E", upsi: "\u03C5", upsih: "\u03D2", upsilon: "\u03C5", upuparrows: "\u21C8", urcorn: "\u231D", urcorner: "\u231D", urcrop: "\u230E", uring: "\u016F", urtri: "\u25F9", uscr: "\u{1D4CA}", utdot: "\u22F0", utilde: "\u0169", utri: "\u25B5", utrif: "\u25B4", uuarr: "\u21C8", uum: "\xFC", uuml: "\xFC", uwangle: "\u29A7", vArr: "\u21D5", vBar: "\u2AE8", vBarv: "\u2AE9", vDash: "\u22A8", vangrt: "\u299C", varepsilon: "\u03F5", varkappa: "\u03F0", varnothing: "\u2205", varphi: "\u03D5", varpi: "\u03D6", varpropto: "\u221D", varr: "\u2195", varrho: "\u03F1", varsigma: "\u03C2", varsubsetneq: "\u228A\uFE00", varsubsetneqq: "\u2ACB\uFE00", varsupsetneq: "\u228B\uFE00", varsupsetneqq: "\u2ACC\uFE00", vartheta: "\u03D1", vartriangleleft: "\u22B2", vartriangleright: "\u22B3", vcy: "\u0432", vdash: "\u22A2", vee: "\u2228", veebar: "\u22BB", veeeq: "\u225A", vellip: "\u22EE", verbar: "|", vert: "|", vfr: "\u{1D533}", vltri: "\u22B2", vnsub: "\u2282\u20D2", vnsup: "\u2283\u20D2", vopf: "\u{1D567}", vprop: "\u221D", vrtri: "\u22B3", vscr: "\u{1D4CB}", vsubnE: "\u2ACB\uFE00", vsubne: "\u228A\uFE00", vsupnE: "\u2ACC\uFE00", vsupne: "\u228B\uFE00", vzigzag: "\u299A", wcirc: "\u0175", wedbar: "\u2A5F", wedge: "\u2227", wedgeq: "\u2259", weierp: "\u2118", wfr: "\u{1D534}", wopf: "\u{1D568}", wp: "\u2118", wr: "\u2240", wreath: "\u2240", wscr: "\u{1D4CC}", xcap: "\u22C2", xcirc: "\u25EF", xcup: "\u22C3", xdtri: "\u25BD", xfr: "\u{1D535}", xhArr: "\u27FA", xharr: "\u27F7", xi: "\u03BE", xlArr: "\u27F8", xlarr: "\u27F5", xmap: "\u27FC", xnis: "\u22FB", xodot: "\u2A00", xopf: "\u{1D569}", xoplus: "\u2A01", xotime: "\u2A02", xrArr: "\u27F9", xrarr: "\u27F6", xscr: "\u{1D4CD}", xsqcup: "\u2A06", xuplus: "\u2A04", xutri: "\u25B3", xvee: "\u22C1", xwedge: "\u22C0", yacut: "\xFD", yacute: "\xFD", yacy: "\u044F", ycirc: "\u0177", ycy: "\u044B", ye: "\xA5", yen: "\xA5", yfr: "\u{1D536}", yicy: "\u0457", yopf: "\u{1D56A}", yscr: "\u{1D4CE}", yucy: "\u044E", yum: "\xFF", yuml: "\xFF", zacute: "\u017A", zcaron: "\u017E", zcy: "\u0437", zdot: "\u017C", zeetrf: "\u2128", zeta: "\u03B6", zfr: "\u{1D537}", zhcy: "\u0436", zigrarr: "\u21DD", zopf: "\u{1D56B}", zscr: "\u{1D4CF}", zwj: "\u200D", zwnj: "\u200C" };
        } }), Hl = S({ "node_modules/parse-entities/decode-entity.js"(e, r) {
          "use strict";
          I();
          var u = $l();
          r.exports = o;
          var t = {}.hasOwnProperty;
          function o(n) {
            return t.call(u, n) ? u[n] : false;
          }
        } }), xr = S({ "node_modules/parse-entities/index.js"(e, r) {
          "use strict";
          I();
          var u = zl(), t = Gl(), o = ze(), n = Ul(), s = Vl(), c = Hl();
          r.exports = J;
          var i = {}.hasOwnProperty, D = String.fromCharCode, a = Function.prototype, l = { warning: null, reference: null, text: null, warningContext: null, referenceContext: null, textContext: null, position: {}, additional: null, attribute: false, nonTerminated: true }, p = 9, d = 10, g = 12, F = 32, E = 38, x = 59, f = 60, b = 61, v = 35, h = 88, m = 120, C = 65533, B = "named", q = "hexadecimal", L = "decimal", w = {};
          w[q] = 16, w[L] = 10;
          var O = {};
          O[B] = s, O[L] = o, O[q] = n;
          var T = 1, P = 2, A = 3, j = 4, $ = 5, U = 6, X = 7, R = {};
          R[T] = "Named character references must be terminated by a semicolon", R[P] = "Numeric character references must be terminated by a semicolon", R[A] = "Named character references cannot be empty", R[j] = "Numeric character references cannot be empty", R[$] = "Named character references must be known", R[U] = "Numeric character references cannot be disallowed", R[X] = "Numeric character references cannot be outside the permissible Unicode range";
          function J(k, y) {
            var _ = {}, N, V;
            y || (y = {});
            for (V in l) N = y[V], _[V] = N == null ? l[V] : N;
            return (_.position.indent || _.position.start) && (_.indent = _.position.indent || [], _.position = _.position.start), z3(k, _);
          }
          function z3(k, y) {
            var _ = y.additional, N = y.nonTerminated, V = y.text, W = y.reference, K = y.warning, ee = y.textContext, Y = y.referenceContext, te = y.warningContext, De = y.position, le = y.indent || [], ne = k.length, Z = 0, Q = -1, fe = De.column || 1, be = De.line || 1, pe = "", he = [], oe, de, ie, re, ye, se, ae, Ce, er, br, ke, Ue, qe, Fe, Eu, Ve, rr, ge, ce;
            for (typeof _ == "string" && (_ = _.charCodeAt(0)), Ve = $e(), Ce = K ? sa : a, Z--, ne++; ++Z < ne; ) if (ye === d && (fe = le[Q] || 1), ye = k.charCodeAt(Z), ye === E) {
              if (ae = k.charCodeAt(Z + 1), ae === p || ae === d || ae === g || ae === F || ae === E || ae === f || ae !== ae || _ && ae === _) {
                pe += D(ye), fe++;
                continue;
              }
              for (qe = Z + 1, Ue = qe, ce = qe, ae === v ? (ce = ++Ue, ae = k.charCodeAt(ce), ae === h || ae === m ? (Fe = q, ce = ++Ue) : Fe = L) : Fe = B, oe = "", ke = "", re = "", Eu = O[Fe], ce--; ++ce < ne && (ae = k.charCodeAt(ce), !!Eu(ae)); ) re += D(ae), Fe === B && i.call(u, re) && (oe = re, ke = u[re]);
              ie = k.charCodeAt(ce) === x, ie && (ce++, de = Fe === B ? c(re) : false, de && (oe = re, ke = de)), ge = 1 + ce - qe, !ie && !N || (re ? Fe === B ? (ie && !ke ? Ce($, 1) : (oe !== re && (ce = Ue + oe.length, ge = 1 + ce - Ue, ie = false), ie || (er = oe ? T : A, y.attribute ? (ae = k.charCodeAt(ce), ae === b ? (Ce(er, ge), ke = null) : s(ae) ? ke = null : Ce(er, ge)) : Ce(er, ge))), se = ke) : (ie || Ce(P, ge), se = parseInt(re, w[Fe]), M(se) ? (Ce(X, ge), se = D(C)) : se in t ? (Ce(U, ge), se = t[se]) : (br = "", G(se) && Ce(U, ge), se > 65535 && (se -= 65536, br += D(se >>> 10 | 55296), se = 56320 | se & 1023), se = br + D(se))) : Fe !== B && Ce(j, ge)), se ? (Cu(), Ve = $e(), Z = ce - 1, fe += ce - qe + 1, he.push(se), rr = $e(), rr.offset++, W && W.call(Y, se, { start: Ve, end: rr }, k.slice(qe - 1, ce)), Ve = rr) : (re = k.slice(qe - 1, ce), pe += re, fe += re.length, Z = ce - 1);
            } else ye === 10 && (be++, Q++, fe = 0), ye === ye ? (pe += D(ye), fe++) : Cu();
            return he.join("");
            function $e() {
              return { line: be, column: fe, offset: Z + (De.offset || 0) };
            }
            function sa(gu, Fu) {
              var yr = $e();
              yr.column += Fu, yr.offset += Fu, K.call(te, R[gu], yr, gu);
            }
            function Cu() {
              pe && (he.push(pe), V && V.call(ee, pe, { start: Ve, end: $e() }), pe = "");
            }
          }
          function M(k) {
            return k >= 55296 && k <= 57343 || k > 1114111;
          }
          function G(k) {
            return k >= 1 && k <= 8 || k === 11 || k >= 13 && k <= 31 || k >= 127 && k <= 159 || k >= 64976 && k <= 65007 || (k & 65535) === 65535 || (k & 65535) === 65534;
          }
        } }), Xl = S({ "node_modules/remark-parse/lib/decode.js"(e, r) {
          "use strict";
          I();
          var u = Me(), t = xr();
          r.exports = o;
          function o(n) {
            return c.raw = i, c;
            function s(a) {
              for (var l = n.offset, p = a.line, d = []; ++p && p in l; ) d.push((l[p] || 0) + 1);
              return { start: a, indent: d };
            }
            function c(a, l, p) {
              t(a, { position: s(l), warning: D, text: p, reference: p, textContext: n, referenceContext: n });
            }
            function i(a, l, p) {
              return t(a, u(p, { position: s(l), warning: D }));
            }
            function D(a, l, p) {
              p !== 3 && n.file.message(a, l);
            }
          }
        } }), Wl = S({ "node_modules/remark-parse/lib/tokenizer.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(s) {
            return c;
            function c(i, D) {
              var a = this, l = a.offset, p = [], d = a[s + "Methods"], g = a[s + "Tokenizers"], F = D.line, E = D.column, x, f, b, v, h, m;
              if (!i) return p;
              for (P.now = q, P.file = a.file, C(""); i; ) {
                for (x = -1, f = d.length, h = false; ++x < f && (v = d[x], b = g[v], !(b && (!b.onlyAtStart || a.atStart) && (!b.notInList || !a.inList) && (!b.notInBlock || !a.inBlock) && (!b.notInLink || !a.inLink) && (m = i.length, b.apply(a, [P, i]), h = m !== i.length, h))); ) ;
                h || a.file.fail(new Error("Infinite loop"), P.now());
              }
              return a.eof = q(), p;
              function C(A) {
                for (var j = -1, $ = A.indexOf(`
`); $ !== -1; ) F++, j = $, $ = A.indexOf(`
`, $ + 1);
                j === -1 ? E += A.length : E = A.length - j, F in l && (j !== -1 ? E += l[F] : E <= l[F] && (E = l[F] + 1));
              }
              function B() {
                var A = [], j = F + 1;
                return function() {
                  for (var $ = F + 1; j < $; ) A.push((l[j] || 0) + 1), j++;
                  return A;
                };
              }
              function q() {
                var A = { line: F, column: E };
                return A.offset = a.toOffset(A), A;
              }
              function L(A) {
                this.start = A, this.end = q();
              }
              function w(A) {
                i.slice(0, A.length) !== A && a.file.fail(new Error("Incorrectly eaten value: please report this warning on https://git.io/vg5Ft"), q());
              }
              function O() {
                var A = q();
                return j;
                function j($, U) {
                  var X = $.position, R = X ? X.start : A, J = [], z3 = X && X.end.line, M = A.line;
                  if ($.position = new L(R), X && U && X.indent) {
                    if (J = X.indent, z3 < M) {
                      for (; ++z3 < M; ) J.push((l[z3] || 0) + 1);
                      J.push(A.column);
                    }
                    U = J.concat(U);
                  }
                  return $.position.indent = U || [], $;
                }
              }
              function T(A, j) {
                var $ = j ? j.children : p, U = $[$.length - 1], X;
                return U && A.type === U.type && (A.type === "text" || A.type === "blockquote") && t(U) && t(A) && (X = A.type === "text" ? o : n, A = X.call(a, U, A)), A !== U && $.push(A), a.atStart && p.length !== 0 && a.exitStart(), A;
              }
              function P(A) {
                var j = B(), $ = O(), U = q();
                return w(A), X.reset = R, R.test = J, X.test = J, i = i.slice(A.length), C(A), j = j(), X;
                function X(z3, M) {
                  return $(T($(z3), M), j);
                }
                function R() {
                  var z3 = X.apply(null, arguments);
                  return F = U.line, E = U.column, i = A + i, z3;
                }
                function J() {
                  var z3 = $({});
                  return F = U.line, E = U.column, i = A + i, z3.position;
                }
              }
            }
          }
          function t(s) {
            var c, i;
            return s.type !== "text" || !s.position ? true : (c = s.position.start, i = s.position.end, c.line !== i.line || i.column - c.column === s.value.length);
          }
          function o(s, c) {
            return s.value += c.value, s;
          }
          function n(s, c) {
            return this.options.commonmark || this.options.gfm ? c : (s.children = s.children.concat(c.children), s);
          }
        } }), Kl = S({ "node_modules/markdown-escapes/index.js"(e, r) {
          "use strict";
          I(), r.exports = n;
          var u = ["\\", "`", "*", "{", "}", "[", "]", "(", ")", "#", "+", "-", ".", "!", "_", ">"], t = u.concat(["~", "|"]), o = t.concat([`
`, '"', "$", "%", "&", "'", ",", "/", ":", ";", "<", "=", "?", "@", "^"]);
          n.default = u, n.gfm = t, n.commonmark = o;
          function n(s) {
            var c = s || {};
            return c.commonmark ? o : c.gfm ? t : u;
          }
        } }), Yl = S({ "node_modules/remark-parse/lib/block-elements.js"(e, r) {
          "use strict";
          I(), r.exports = ["address", "article", "aside", "base", "basefont", "blockquote", "body", "caption", "center", "col", "colgroup", "dd", "details", "dialog", "dir", "div", "dl", "dt", "fieldset", "figcaption", "figure", "footer", "form", "frame", "frameset", "h1", "h2", "h3", "h4", "h5", "h6", "head", "header", "hgroup", "hr", "html", "iframe", "legend", "li", "link", "main", "menu", "menuitem", "meta", "nav", "noframes", "ol", "optgroup", "option", "p", "param", "pre", "section", "source", "title", "summary", "table", "tbody", "td", "tfoot", "th", "thead", "title", "tr", "track", "ul"];
        } }), Pi = S({ "node_modules/remark-parse/lib/defaults.js"(e, r) {
          "use strict";
          I(), r.exports = { position: true, gfm: true, commonmark: false, pedantic: false, blocks: Yl() };
        } }), Jl = S({ "node_modules/remark-parse/lib/set-options.js"(e, r) {
          "use strict";
          I();
          var u = Me(), t = Kl(), o = Pi();
          r.exports = n;
          function n(s) {
            var c = this, i = c.options, D, a;
            if (s == null) s = {};
            else if (typeof s == "object") s = u(s);
            else throw new Error("Invalid value `" + s + "` for setting `options`");
            for (D in o) {
              if (a = s[D], a == null && (a = i[D]), D !== "blocks" && typeof a != "boolean" || D === "blocks" && typeof a != "object") throw new Error("Invalid value `" + a + "` for setting `options." + D + "`");
              s[D] = a;
            }
            return c.options = s, c.escape = t(s), c;
          }
        } }), Zl = S({ "node_modules/unist-util-is/convert.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(c) {
            if (c == null) return s;
            if (typeof c == "string") return n(c);
            if (typeof c == "object") return "length" in c ? o(c) : t(c);
            if (typeof c == "function") return c;
            throw new Error("Expected function, string, or object as test");
          }
          function t(c) {
            return i;
            function i(D) {
              var a;
              for (a in c) if (D[a] !== c[a]) return false;
              return true;
            }
          }
          function o(c) {
            for (var i = [], D = -1; ++D < c.length; ) i[D] = u(c[D]);
            return a;
            function a() {
              for (var l = -1; ++l < i.length; ) if (i[l].apply(this, arguments)) return true;
              return false;
            }
          }
          function n(c) {
            return i;
            function i(D) {
              return Boolean(D && D.type === c);
            }
          }
          function s() {
            return true;
          }
        } }), Ql = S({ "node_modules/unist-util-visit-parents/color.browser.js"(e, r) {
          I(), r.exports = u;
          function u(t) {
            return t;
          }
        } }), eD = S({ "node_modules/unist-util-visit-parents/index.js"(e, r) {
          "use strict";
          I(), r.exports = c;
          var u = Zl(), t = Ql(), o = true, n = "skip", s = false;
          c.CONTINUE = o, c.SKIP = n, c.EXIT = s;
          function c(D, a, l, p) {
            var d, g;
            typeof a == "function" && typeof l != "function" && (p = l, l = a, a = null), g = u(a), d = p ? -1 : 1, F(D, null, [])();
            function F(E, x, f) {
              var b = typeof E == "object" && E !== null ? E : {}, v;
              return typeof b.type == "string" && (v = typeof b.tagName == "string" ? b.tagName : typeof b.name == "string" ? b.name : void 0, h.displayName = "node (" + t(b.type + (v ? "<" + v + ">" : "")) + ")"), h;
              function h() {
                var m = f.concat(E), C = [], B, q;
                if ((!a || g(E, x, f[f.length - 1] || null)) && (C = i(l(E, f)), C[0] === s)) return C;
                if (E.children && C[0] !== n) for (q = (p ? E.children.length : -1) + d; q > -1 && q < E.children.length; ) {
                  if (B = F(E.children[q], q, m)(), B[0] === s) return B;
                  q = typeof B[1] == "number" ? B[1] : q + d;
                }
                return C;
              }
            }
          }
          function i(D) {
            return D !== null && typeof D == "object" && "length" in D ? D : typeof D == "number" ? [o, D] : [D];
          }
        } }), rD = S({ "node_modules/unist-util-visit/index.js"(e, r) {
          "use strict";
          I(), r.exports = s;
          var u = eD(), t = u.CONTINUE, o = u.SKIP, n = u.EXIT;
          s.CONTINUE = t, s.SKIP = o, s.EXIT = n;
          function s(c, i, D, a) {
            typeof i == "function" && typeof D != "function" && (a = D, D = i, i = null), u(c, i, l, a);
            function l(p, d) {
              var g = d[d.length - 1], F = g ? g.children.indexOf(p) : null;
              return D(p, F, g);
            }
          }
        } }), uD = S({ "node_modules/unist-util-remove-position/index.js"(e, r) {
          "use strict";
          I();
          var u = rD();
          r.exports = t;
          function t(s, c) {
            return u(s, c ? o : n), s;
          }
          function o(s) {
            delete s.position;
          }
          function n(s) {
            s.position = void 0;
          }
        } }), tD = S({ "node_modules/remark-parse/lib/parse.js"(e, r) {
          "use strict";
          I();
          var u = Me(), t = uD();
          r.exports = s;
          var o = `
`, n = /\r\n|\r/g;
          function s() {
            var c = this, i = String(c.file), D = { line: 1, column: 1, offset: 0 }, a = u(D), l;
            return i = i.replace(n, o), i.charCodeAt(0) === 65279 && (i = i.slice(1), a.column++, a.offset++), l = { type: "root", children: c.tokenizeBlock(i, a), position: { start: D, end: c.eof || u(D) } }, c.options.position || t(l, true), l;
          }
        } }), nD = S({ "node_modules/remark-parse/lib/tokenize/blank-line.js"(e, r) {
          "use strict";
          I();
          var u = /^[ \t]*(\n|$)/;
          r.exports = t;
          function t(o, n, s) {
            for (var c, i = "", D = 0, a = n.length; D < a && (c = u.exec(n.slice(D)), c != null); ) D += c[0].length, i += c[0];
            if (i !== "") {
              if (s) return true;
              o(i);
            }
          }
        } }), du = S({ "node_modules/repeat-string/index.js"(e, r) {
          "use strict";
          I();
          var u = "", t;
          r.exports = o;
          function o(n, s) {
            if (typeof n != "string") throw new TypeError("expected a string");
            if (s === 1) return n;
            if (s === 2) return n + n;
            var c = n.length * s;
            if (t !== n || typeof t > "u") t = n, u = "";
            else if (u.length >= c) return u.substr(0, c);
            for (; c > u.length && s > 1; ) s & 1 && (u += n), s >>= 1, n += n;
            return u += n, u = u.substr(0, c), u;
          }
        } }), Mi = S({ "node_modules/trim-trailing-lines/index.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t) {
            return String(t).replace(/\n+$/, "");
          }
        } }), iD = S({ "node_modules/remark-parse/lib/tokenize/code-indented.js"(e, r) {
          "use strict";
          I();
          var u = du(), t = Mi();
          r.exports = D;
          var o = `
`, n = "	", s = " ", c = 4, i = u(s, c);
          function D(a, l, p) {
            for (var d = -1, g = l.length, F = "", E = "", x = "", f = "", b, v, h; ++d < g; ) if (b = l.charAt(d), h) if (h = false, F += x, E += f, x = "", f = "", b === o) x = b, f = b;
            else for (F += b, E += b; ++d < g; ) {
              if (b = l.charAt(d), !b || b === o) {
                f = b, x = b;
                break;
              }
              F += b, E += b;
            }
            else if (b === s && l.charAt(d + 1) === b && l.charAt(d + 2) === b && l.charAt(d + 3) === b) x += i, d += 3, h = true;
            else if (b === n) x += b, h = true;
            else {
              for (v = ""; b === n || b === s; ) v += b, b = l.charAt(++d);
              if (b !== o) break;
              x += v + b, f += b;
            }
            if (E) return p ? true : a(F)({ type: "code", lang: null, meta: null, value: t(E) });
          }
        } }), aD = S({ "node_modules/remark-parse/lib/tokenize/code-fenced.js"(e, r) {
          "use strict";
          I(), r.exports = D;
          var u = `
`, t = "	", o = " ", n = "~", s = "`", c = 3, i = 4;
          function D(a, l, p) {
            var d = this, g = d.options.gfm, F = l.length + 1, E = 0, x = "", f, b, v, h, m, C, B, q, L, w, O, T, P;
            if (!!g) {
              for (; E < F && (v = l.charAt(E), !(v !== o && v !== t)); ) x += v, E++;
              if (T = E, v = l.charAt(E), !(v !== n && v !== s)) {
                for (E++, b = v, f = 1, x += v; E < F && (v = l.charAt(E), v === b); ) x += v, f++, E++;
                if (!(f < c)) {
                  for (; E < F && (v = l.charAt(E), !(v !== o && v !== t)); ) x += v, E++;
                  for (h = "", B = ""; E < F && (v = l.charAt(E), !(v === u || b === s && v === b)); ) v === o || v === t ? B += v : (h += B + v, B = ""), E++;
                  if (v = l.charAt(E), !(v && v !== u)) {
                    if (p) return true;
                    P = a.now(), P.column += x.length, P.offset += x.length, x += h, h = d.decode.raw(d.unescape(h), P), B && (x += B), B = "", w = "", O = "", q = "", L = "";
                    for (var A = true; E < F; ) {
                      if (v = l.charAt(E), q += w, L += O, w = "", O = "", v !== u) {
                        q += v, O += v, E++;
                        continue;
                      }
                      for (A ? (x += v, A = false) : (w += v, O += v), B = "", E++; E < F && (v = l.charAt(E), v === o); ) B += v, E++;
                      if (w += B, O += B.slice(T), !(B.length >= i)) {
                        for (B = ""; E < F && (v = l.charAt(E), v === b); ) B += v, E++;
                        if (w += B, O += B, !(B.length < f)) {
                          for (B = ""; E < F && (v = l.charAt(E), !(v !== o && v !== t)); ) w += v, O += v, E++;
                          if (!v || v === u) break;
                        }
                      }
                    }
                    for (x += q + w, E = -1, F = h.length; ++E < F; ) if (v = h.charAt(E), v === o || v === t) m || (m = h.slice(0, E));
                    else if (m) {
                      C = h.slice(E);
                      break;
                    }
                    return a(x)({ type: "code", lang: m || h || null, meta: C || null, value: L });
                  }
                }
              }
            }
          }
        } }), Ge = S({ "node_modules/trim/index.js"(e, r) {
          I(), e = r.exports = u;
          function u(t) {
            return t.replace(/^\s*|\s*$/g, "");
          }
          e.left = function(t) {
            return t.replace(/^\s*/, "");
          }, e.right = function(t) {
            return t.replace(/\s*$/, "");
          };
        } }), hu = S({ "node_modules/remark-parse/lib/util/interrupt.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t, o, n, s) {
            for (var c = t.length, i = -1, D, a; ++i < c; ) if (D = t[i], a = D[1] || {}, !(a.pedantic !== void 0 && a.pedantic !== n.options.pedantic) && !(a.commonmark !== void 0 && a.commonmark !== n.options.commonmark) && o[D[0]].apply(n, s)) return true;
            return false;
          }
        } }), oD = S({ "node_modules/remark-parse/lib/tokenize/blockquote.js"(e, r) {
          "use strict";
          I();
          var u = Ge(), t = hu();
          r.exports = i;
          var o = `
`, n = "	", s = " ", c = ">";
          function i(D, a, l) {
            for (var p = this, d = p.offset, g = p.blockTokenizers, F = p.interruptBlockquote, E = D.now(), x = E.line, f = a.length, b = [], v = [], h = [], m, C = 0, B, q, L, w, O, T, P, A; C < f && (B = a.charAt(C), !(B !== s && B !== n)); ) C++;
            if (a.charAt(C) === c) {
              if (l) return true;
              for (C = 0; C < f; ) {
                for (L = a.indexOf(o, C), T = C, P = false, L === -1 && (L = f); C < f && (B = a.charAt(C), !(B !== s && B !== n)); ) C++;
                if (a.charAt(C) === c ? (C++, P = true, a.charAt(C) === s && C++) : C = T, w = a.slice(C, L), !P && !u(w)) {
                  C = T;
                  break;
                }
                if (!P && (q = a.slice(C), t(F, g, p, [D, q, true]))) break;
                O = T === C ? w : a.slice(T, L), h.push(C - T), b.push(O), v.push(w), C = L + 1;
              }
              for (C = -1, f = h.length, m = D(b.join(o)); ++C < f; ) d[x] = (d[x] || 0) + h[C], x++;
              return A = p.enterBlock(), v = p.tokenizeBlock(v.join(o), E), A(), m({ type: "blockquote", children: v });
            }
          }
        } }), sD = S({ "node_modules/remark-parse/lib/tokenize/heading-atx.js"(e, r) {
          "use strict";
          I(), r.exports = c;
          var u = `
`, t = "	", o = " ", n = "#", s = 6;
          function c(i, D, a) {
            for (var l = this, p = l.options.pedantic, d = D.length + 1, g = -1, F = i.now(), E = "", x = "", f, b, v; ++g < d; ) {
              if (f = D.charAt(g), f !== o && f !== t) {
                g--;
                break;
              }
              E += f;
            }
            for (v = 0; ++g <= d; ) {
              if (f = D.charAt(g), f !== n) {
                g--;
                break;
              }
              E += f, v++;
            }
            if (!(v > s) && !(!v || !p && D.charAt(g + 1) === n)) {
              for (d = D.length + 1, b = ""; ++g < d; ) {
                if (f = D.charAt(g), f !== o && f !== t) {
                  g--;
                  break;
                }
                b += f;
              }
              if (!(!p && b.length === 0 && f && f !== u)) {
                if (a) return true;
                for (E += b, b = "", x = ""; ++g < d && (f = D.charAt(g), !(!f || f === u)); ) {
                  if (f !== o && f !== t && f !== n) {
                    x += b + f, b = "";
                    continue;
                  }
                  for (; f === o || f === t; ) b += f, f = D.charAt(++g);
                  if (!p && x && !b && f === n) {
                    x += f;
                    continue;
                  }
                  for (; f === n; ) b += f, f = D.charAt(++g);
                  for (; f === o || f === t; ) b += f, f = D.charAt(++g);
                  g--;
                }
                return F.column += E.length, F.offset += E.length, E += x + b, i(E)({ type: "heading", depth: v, children: l.tokenizeInline(x, F) });
              }
            }
          }
        } }), cD = S({ "node_modules/remark-parse/lib/tokenize/thematic-break.js"(e, r) {
          "use strict";
          I(), r.exports = D;
          var u = "	", t = `
`, o = " ", n = "*", s = "-", c = "_", i = 3;
          function D(a, l, p) {
            for (var d = -1, g = l.length + 1, F = "", E, x, f, b; ++d < g && (E = l.charAt(d), !(E !== u && E !== o)); ) F += E;
            if (!(E !== n && E !== s && E !== c)) for (x = E, F += E, f = 1, b = ""; ++d < g; ) if (E = l.charAt(d), E === x) f++, F += b + x, b = "";
            else if (E === o) b += E;
            else return f >= i && (!E || E === t) ? (F += b, p ? true : a(F)({ type: "thematicBreak" })) : void 0;
          }
        } }), zi = S({ "node_modules/remark-parse/lib/util/get-indentation.js"(e, r) {
          "use strict";
          I(), r.exports = s;
          var u = "	", t = " ", o = 1, n = 4;
          function s(c) {
            for (var i = 0, D = 0, a = c.charAt(i), l = {}, p, d = 0; a === u || a === t; ) {
              for (p = a === u ? n : o, D += p, p > 1 && (D = Math.floor(D / p) * p); d < D; ) l[++d] = i;
              a = c.charAt(++i);
            }
            return { indent: D, stops: l };
          }
        } }), lD = S({ "node_modules/remark-parse/lib/util/remove-indentation.js"(e, r) {
          "use strict";
          I();
          var u = Ge(), t = du(), o = zi();
          r.exports = i;
          var n = `
`, s = " ", c = "!";
          function i(D, a) {
            var l = D.split(n), p = l.length + 1, d = 1 / 0, g = [], F, E, x;
            for (l.unshift(t(s, a) + c); p--; ) if (E = o(l[p]), g[p] = E.stops, u(l[p]).length !== 0) if (E.indent) E.indent > 0 && E.indent < d && (d = E.indent);
            else {
              d = 1 / 0;
              break;
            }
            if (d !== 1 / 0) for (p = l.length; p--; ) {
              for (x = g[p], F = d; F && !(F in x); ) F--;
              l[p] = l[p].slice(x[F] + 1);
            }
            return l.shift(), l.join(n);
          }
        } }), DD = S({ "node_modules/remark-parse/lib/tokenize/list.js"(e, r) {
          "use strict";
          I();
          var u = Ge(), t = du(), o = ze(), n = zi(), s = lD(), c = hu();
          r.exports = B;
          var i = "*", D = "_", a = "+", l = "-", p = ".", d = " ", g = `
`, F = "	", E = ")", x = "x", f = 4, b = /\n\n(?!\s*$)/, v = /^\[([ X\tx])][ \t]/, h = /^([ \t]*)([*+-]|\d+[.)])( {1,4}(?! )| |\t|$|(?=\n))([^\n]*)/, m = /^([ \t]*)([*+-]|\d+[.)])([ \t]+)/, C = /^( {1,4}|\t)?/gm;
          function B(O, T, P) {
            for (var A = this, j = A.options.commonmark, $ = A.options.pedantic, U = A.blockTokenizers, X = A.interruptList, R = 0, J = T.length, z3 = null, M, G, k, y, _, N, V, W, K, ee, Y, te, De, le, ne, Z, Q, fe, be, pe = false, he, oe, de, ie; R < J && (y = T.charAt(R), !(y !== F && y !== d)); ) R++;
            if (y = T.charAt(R), y === i || y === a || y === l) _ = y, k = false;
            else {
              for (k = true, G = ""; R < J && (y = T.charAt(R), !!o(y)); ) G += y, R++;
              if (y = T.charAt(R), !G || !(y === p || j && y === E) || P && G !== "1") return;
              z3 = parseInt(G, 10), _ = y;
            }
            if (y = T.charAt(++R), !(y !== d && y !== F && ($ || y !== g && y !== ""))) {
              if (P) return true;
              for (R = 0, le = [], ne = [], Z = []; R < J; ) {
                for (N = T.indexOf(g, R), V = R, W = false, ie = false, N === -1 && (N = J), M = 0; R < J; ) {
                  if (y = T.charAt(R), y === F) M += f - M % f;
                  else if (y === d) M++;
                  else break;
                  R++;
                }
                if (Q && M >= Q.indent && (ie = true), y = T.charAt(R), K = null, !ie) {
                  if (y === i || y === a || y === l) K = y, R++, M++;
                  else {
                    for (G = ""; R < J && (y = T.charAt(R), !!o(y)); ) G += y, R++;
                    y = T.charAt(R), R++, G && (y === p || j && y === E) && (K = y, M += G.length + 1);
                  }
                  if (K) if (y = T.charAt(R), y === F) M += f - M % f, R++;
                  else if (y === d) {
                    for (de = R + f; R < de && T.charAt(R) === d; ) R++, M++;
                    R === de && T.charAt(R) === d && (R -= f - 1, M -= f - 1);
                  } else y !== g && y !== "" && (K = null);
                }
                if (K) {
                  if (!$ && _ !== K) break;
                  W = true;
                } else !j && !ie && T.charAt(V) === d ? ie = true : j && Q && (ie = M >= Q.indent || M > f), W = false, R = V;
                if (Y = T.slice(V, N), ee = V === R ? Y : T.slice(R, N), (K === i || K === D || K === l) && U.thematicBreak.call(A, O, Y, true)) break;
                if (te = De, De = !W && !u(ee).length, ie && Q) Q.value = Q.value.concat(Z, Y), ne = ne.concat(Z, Y), Z = [];
                else if (W) Z.length !== 0 && (pe = true, Q.value.push(""), Q.trail = Z.concat()), Q = { value: [Y], indent: M, trail: [] }, le.push(Q), ne = ne.concat(Z, Y), Z = [];
                else if (De) {
                  if (te && !j) break;
                  Z.push(Y);
                } else {
                  if (te || c(X, U, A, [O, Y, true])) break;
                  Q.value = Q.value.concat(Z, Y), ne = ne.concat(Z, Y), Z = [];
                }
                R = N + 1;
              }
              for (he = O(ne.join(g)).reset({ type: "list", ordered: k, start: z3, spread: pe, children: [] }), fe = A.enterList(), be = A.enterBlock(), R = -1, J = le.length; ++R < J; ) Q = le[R].value.join(g), oe = O.now(), O(Q)(q(A, Q, oe), he), Q = le[R].trail.join(g), R !== J - 1 && (Q += g), O(Q);
              return fe(), be(), he;
            }
          }
          function q(O, T, P) {
            var A = O.offset, j = O.options.pedantic ? L : w, $ = null, U, X;
            return T = j.apply(null, arguments), O.options.gfm && (U = T.match(v), U && (X = U[0].length, $ = U[1].toLowerCase() === x, A[P.line] += X, T = T.slice(X))), { type: "listItem", spread: b.test(T), checked: $, children: O.tokenizeBlock(T, P) };
          }
          function L(O, T, P) {
            var A = O.offset, j = P.line;
            return T = T.replace(m, $), j = P.line, T.replace(C, $);
            function $(U) {
              return A[j] = (A[j] || 0) + U.length, j++, "";
            }
          }
          function w(O, T, P) {
            var A = O.offset, j = P.line, $, U, X, R, J, z3, M;
            for (T = T.replace(h, G), R = T.split(g), J = s(T, n($).indent).split(g), J[0] = X, A[j] = (A[j] || 0) + U.length, j++, z3 = 0, M = R.length; ++z3 < M; ) A[j] = (A[j] || 0) + R[z3].length - J[z3].length, j++;
            return J.join(g);
            function G(k, y, _, N, V) {
              return U = y + _ + N, X = V, Number(_) < 10 && U.length % 2 === 1 && (_ = d + _), $ = y + t(d, _.length) + N, $ + X;
            }
          }
        } }), fD = S({ "node_modules/remark-parse/lib/tokenize/heading-setext.js"(e, r) {
          "use strict";
          I(), r.exports = a;
          var u = `
`, t = "	", o = " ", n = "=", s = "-", c = 3, i = 1, D = 2;
          function a(l, p, d) {
            for (var g = this, F = l.now(), E = p.length, x = -1, f = "", b, v, h, m, C; ++x < E; ) {
              if (h = p.charAt(x), h !== o || x >= c) {
                x--;
                break;
              }
              f += h;
            }
            for (b = "", v = ""; ++x < E; ) {
              if (h = p.charAt(x), h === u) {
                x--;
                break;
              }
              h === o || h === t ? v += h : (b += v + h, v = "");
            }
            if (F.column += f.length, F.offset += f.length, f += b + v, h = p.charAt(++x), m = p.charAt(++x), !(h !== u || m !== n && m !== s)) {
              for (f += h, v = m, C = m === n ? i : D; ++x < E; ) {
                if (h = p.charAt(x), h !== m) {
                  if (h !== u) return;
                  x--;
                  break;
                }
                v += h;
              }
              return d ? true : l(f + v)({ type: "heading", depth: C, children: g.tokenizeInline(b, F) });
            }
          }
        } }), Gi = S({ "node_modules/remark-parse/lib/util/html.js"(e) {
          "use strict";
          I();
          var r = "[a-zA-Z_:][a-zA-Z0-9:._-]*", u = "[^\"'=<>`\\u0000-\\u0020]+", t = "'[^']*'", o = '"[^"]*"', n = "(?:" + u + "|" + t + "|" + o + ")", s = "(?:\\s+" + r + "(?:\\s*=\\s*" + n + ")?)", c = "<[A-Za-z][A-Za-z0-9\\-]*" + s + "*\\s*\\/?>", i = "<\\/[A-Za-z][A-Za-z0-9\\-]*\\s*>", D = "<!---->|<!--(?:-?[^>-])(?:-?[^-])*-->", a = "<[?].*?[?]>", l = "<![A-Za-z]+\\s+[^>]*>", p = "<!\\[CDATA\\[[\\s\\S]*?\\]\\]>";
          e.openCloseTag = new RegExp("^(?:" + c + "|" + i + ")"), e.tag = new RegExp("^(?:" + c + "|" + i + "|" + D + "|" + a + "|" + l + "|" + p + ")");
        } }), pD = S({ "node_modules/remark-parse/lib/tokenize/html-block.js"(e, r) {
          "use strict";
          I();
          var u = Gi().openCloseTag;
          r.exports = b;
          var t = "	", o = " ", n = `
`, s = "<", c = /^<(script|pre|style)(?=(\s|>|$))/i, i = /<\/(script|pre|style)>/i, D = /^<!--/, a = /-->/, l = /^<\?/, p = /\?>/, d = /^<![A-Za-z]/, g = />/, F = /^<!\[CDATA\[/, E = /]]>/, x = /^$/, f = new RegExp(u.source + "\\s*$");
          function b(v, h, m) {
            for (var C = this, B = C.options.blocks.join("|"), q = new RegExp("^</?(" + B + ")(?=(\\s|/?>|$))", "i"), L = h.length, w = 0, O, T, P, A, j, $, U, X = [[c, i, true], [D, a, true], [l, p, true], [d, g, true], [F, E, true], [q, x, true], [f, x, false]]; w < L && (A = h.charAt(w), !(A !== t && A !== o)); ) w++;
            if (h.charAt(w) === s) {
              for (O = h.indexOf(n, w + 1), O = O === -1 ? L : O, T = h.slice(w, O), P = -1, j = X.length; ++P < j; ) if (X[P][0].test(T)) {
                $ = X[P];
                break;
              }
              if (!!$) {
                if (m) return $[2];
                if (w = O, !$[1].test(T)) for (; w < L; ) {
                  if (O = h.indexOf(n, w + 1), O = O === -1 ? L : O, T = h.slice(w + 1, O), $[1].test(T)) {
                    T && (w = O);
                    break;
                  }
                  w = O;
                }
                return U = h.slice(0, w), v(U)({ type: "html", value: U });
              }
            }
          }
        } }), xe = S({ "node_modules/is-whitespace-character/index.js"(e, r) {
          "use strict";
          I(), r.exports = o;
          var u = String.fromCharCode, t = /\s/;
          function o(n) {
            return t.test(typeof n == "number" ? u(n) : n.charAt(0));
          }
        } }), dD = S({ "node_modules/collapse-white-space/index.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t) {
            return String(t).replace(/\s+/g, " ");
          }
        } }), Ui = S({ "node_modules/remark-parse/lib/util/normalize.js"(e, r) {
          "use strict";
          I();
          var u = dD();
          r.exports = t;
          function t(o) {
            return u(o).toLowerCase();
          }
        } }), hD = S({ "node_modules/remark-parse/lib/tokenize/definition.js"(e, r) {
          "use strict";
          I();
          var u = xe(), t = Ui();
          r.exports = x;
          var o = '"', n = "'", s = "\\", c = `
`, i = "	", D = " ", a = "[", l = "]", p = "(", d = ")", g = ":", F = "<", E = ">";
          function x(v, h, m) {
            for (var C = this, B = C.options.commonmark, q = 0, L = h.length, w = "", O, T, P, A, j, $, U, X; q < L && (A = h.charAt(q), !(A !== D && A !== i)); ) w += A, q++;
            if (A = h.charAt(q), A === a) {
              for (q++, w += A, P = ""; q < L && (A = h.charAt(q), A !== l); ) A === s && (P += A, q++, A = h.charAt(q)), P += A, q++;
              if (!(!P || h.charAt(q) !== l || h.charAt(q + 1) !== g)) {
                for ($ = P, w += P + l + g, q = w.length, P = ""; q < L && (A = h.charAt(q), !(A !== i && A !== D && A !== c)); ) w += A, q++;
                if (A = h.charAt(q), P = "", O = w, A === F) {
                  for (q++; q < L && (A = h.charAt(q), !!f(A)); ) P += A, q++;
                  if (A = h.charAt(q), A === f.delimiter) w += F + P + A, q++;
                  else {
                    if (B) return;
                    q -= P.length + 1, P = "";
                  }
                }
                if (!P) {
                  for (; q < L && (A = h.charAt(q), !!b(A)); ) P += A, q++;
                  w += P;
                }
                if (!!P) {
                  for (U = P, P = ""; q < L && (A = h.charAt(q), !(A !== i && A !== D && A !== c)); ) P += A, q++;
                  if (A = h.charAt(q), j = null, A === o ? j = o : A === n ? j = n : A === p && (j = d), !j) P = "", q = w.length;
                  else if (P) {
                    for (w += P + A, q = w.length, P = ""; q < L && (A = h.charAt(q), A !== j); ) {
                      if (A === c) {
                        if (q++, A = h.charAt(q), A === c || A === j) return;
                        P += c;
                      }
                      P += A, q++;
                    }
                    if (A = h.charAt(q), A !== j) return;
                    T = w, w += P + A, q++, X = P, P = "";
                  } else return;
                  for (; q < L && (A = h.charAt(q), !(A !== i && A !== D)); ) w += A, q++;
                  if (A = h.charAt(q), !A || A === c) return m ? true : (O = v(O).test().end, U = C.decode.raw(C.unescape(U), O, { nonTerminated: false }), X && (T = v(T).test().end, X = C.decode.raw(C.unescape(X), T)), v(w)({ type: "definition", identifier: t($), label: $, title: X || null, url: U }));
                }
              }
            }
          }
          function f(v) {
            return v !== E && v !== a && v !== l;
          }
          f.delimiter = E;
          function b(v) {
            return v !== a && v !== l && !u(v);
          }
        } }), vD = S({ "node_modules/remark-parse/lib/tokenize/table.js"(e, r) {
          "use strict";
          I();
          var u = xe();
          r.exports = F;
          var t = "	", o = `
`, n = " ", s = "-", c = ":", i = "\\", D = "|", a = 1, l = 2, p = "left", d = "center", g = "right";
          function F(E, x, f) {
            var b = this, v, h, m, C, B, q, L, w, O, T, P, A, j, $, U, X, R, J, z3, M, G, k;
            if (!!b.options.gfm) {
              for (v = 0, X = 0, q = x.length + 1, L = []; v < q; ) {
                if (M = x.indexOf(o, v), G = x.indexOf(D, v + 1), M === -1 && (M = x.length), G === -1 || G > M) {
                  if (X < l) return;
                  break;
                }
                L.push(x.slice(v, M)), X++, v = M + 1;
              }
              for (C = L.join(o), h = L.splice(1, 1)[0] || [], v = 0, q = h.length, X--, m = false, P = []; v < q; ) {
                if (O = h.charAt(v), O === D) {
                  if (T = null, m === false) {
                    if (k === false) return;
                  } else P.push(m), m = false;
                  k = false;
                } else if (O === s) T = true, m = m || null;
                else if (O === c) m === p ? m = d : T && m === null ? m = g : m = p;
                else if (!u(O)) return;
                v++;
              }
              if (m !== false && P.push(m), !(P.length < a)) {
                if (f) return true;
                for (U = -1, J = [], z3 = E(C).reset({ type: "table", align: P, children: J }); ++U < X; ) {
                  for (R = L[U], B = { type: "tableRow", children: [] }, U && E(o), E(R).reset(B, z3), q = R.length + 1, v = 0, w = "", A = "", j = true; v < q; ) {
                    if (O = R.charAt(v), O === t || O === n) {
                      A ? w += O : E(O), v++;
                      continue;
                    }
                    O === "" || O === D ? j ? E(O) : ((A || O) && !j && (C = A, w.length > 1 && (O ? (C += w.slice(0, -1), w = w.charAt(w.length - 1)) : (C += w, w = "")), $ = E.now(), E(C)({ type: "tableCell", children: b.tokenizeInline(A, $) }, B)), E(w + O), w = "", A = "") : (w && (A += w, w = ""), A += O, O === i && v !== q - 2 && (A += R.charAt(v + 1), v++)), j = false, v++;
                  }
                  U || E(o + h);
                }
                return z3;
              }
            }
          }
        } }), mD = S({ "node_modules/remark-parse/lib/tokenize/paragraph.js"(e, r) {
          "use strict";
          I();
          var u = Ge(), t = Mi(), o = hu();
          r.exports = D;
          var n = "	", s = `
`, c = " ", i = 4;
          function D(a, l, p) {
            for (var d = this, g = d.options, F = g.commonmark, E = d.blockTokenizers, x = d.interruptParagraph, f = l.indexOf(s), b = l.length, v, h, m, C, B; f < b; ) {
              if (f === -1) {
                f = b;
                break;
              }
              if (l.charAt(f + 1) === s) break;
              if (F) {
                for (C = 0, v = f + 1; v < b; ) {
                  if (m = l.charAt(v), m === n) {
                    C = i;
                    break;
                  } else if (m === c) C++;
                  else break;
                  v++;
                }
                if (C >= i && m !== s) {
                  f = l.indexOf(s, f + 1);
                  continue;
                }
              }
              if (h = l.slice(f + 1), o(x, E, d, [a, h, true])) break;
              if (v = f, f = l.indexOf(s, f + 1), f !== -1 && u(l.slice(v, f)) === "") {
                f = v;
                break;
              }
            }
            return h = l.slice(0, f), p ? true : (B = a.now(), h = t(h), a(h)({ type: "paragraph", children: d.tokenizeInline(h, B) }));
          }
        } }), ED = S({ "node_modules/remark-parse/lib/locate/escape.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t, o) {
            return t.indexOf("\\", o);
          }
        } }), CD = S({ "node_modules/remark-parse/lib/tokenize/escape.js"(e, r) {
          "use strict";
          I();
          var u = ED();
          r.exports = n, n.locator = u;
          var t = `
`, o = "\\";
          function n(s, c, i) {
            var D = this, a, l;
            if (c.charAt(0) === o && (a = c.charAt(1), D.escape.indexOf(a) !== -1)) return i ? true : (a === t ? l = { type: "break" } : l = { type: "text", value: a }, s(o + a)(l));
          }
        } }), Vi = S({ "node_modules/remark-parse/lib/locate/tag.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t, o) {
            return t.indexOf("<", o);
          }
        } }), gD = S({ "node_modules/remark-parse/lib/tokenize/auto-link.js"(e, r) {
          "use strict";
          I();
          var u = xe(), t = xr(), o = Vi();
          r.exports = l, l.locator = o, l.notInLink = true;
          var n = "<", s = ">", c = "@", i = "/", D = "mailto:", a = D.length;
          function l(p, d, g) {
            var F = this, E = "", x = d.length, f = 0, b = "", v = false, h = "", m, C, B, q, L;
            if (d.charAt(0) === n) {
              for (f++, E = n; f < x && (m = d.charAt(f), !(u(m) || m === s || m === c || m === ":" && d.charAt(f + 1) === i)); ) b += m, f++;
              if (!!b) {
                if (h += b, b = "", m = d.charAt(f), h += m, f++, m === c) v = true;
                else {
                  if (m !== ":" || d.charAt(f + 1) !== i) return;
                  h += i, f++;
                }
                for (; f < x && (m = d.charAt(f), !(u(m) || m === s)); ) b += m, f++;
                if (m = d.charAt(f), !(!b || m !== s)) return g ? true : (h += b, B = h, E += h + m, C = p.now(), C.column++, C.offset++, v && (h.slice(0, a).toLowerCase() === D ? (B = B.slice(a), C.column += a, C.offset += a) : h = D + h), q = F.inlineTokenizers, F.inlineTokenizers = { text: q.text }, L = F.enterLink(), B = F.tokenizeInline(B, C), F.inlineTokenizers = q, L(), p(E)({ type: "link", title: null, url: t(h, { nonTerminated: false }), children: B }));
              }
            }
          }
        } }), FD = S({ "node_modules/ccount/index.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t, o) {
            var n = String(t), s = 0, c;
            if (typeof o != "string") throw new Error("Expected character");
            for (c = n.indexOf(o); c !== -1; ) s++, c = n.indexOf(o, c + o.length);
            return s;
          }
        } }), AD = S({ "node_modules/remark-parse/lib/locate/url.js"(e, r) {
          "use strict";
          I(), r.exports = t;
          var u = ["www.", "http://", "https://"];
          function t(o, n) {
            var s = -1, c, i, D;
            if (!this.options.gfm) return s;
            for (i = u.length, c = -1; ++c < i; ) D = o.indexOf(u[c], n), D !== -1 && (s === -1 || D < s) && (s = D);
            return s;
          }
        } }), xD = S({ "node_modules/remark-parse/lib/tokenize/url.js"(e, r) {
          "use strict";
          I();
          var u = FD(), t = xr(), o = ze(), n = Qe(), s = xe(), c = AD();
          r.exports = C, C.locator = c, C.notInLink = true;
          var i = 33, D = 38, a = 41, l = 42, p = 44, d = 45, g = 46, F = 58, E = 59, x = 63, f = 60, b = 95, v = 126, h = "(", m = ")";
          function C(B, q, L) {
            var w = this, O = w.options.gfm, T = w.inlineTokenizers, P = q.length, A = -1, j = false, $, U, X, R, J, z3, M, G, k, y, _, N, V, W;
            if (!!O) {
              if (q.slice(0, 4) === "www.") j = true, R = 4;
              else if (q.slice(0, 7).toLowerCase() === "http://") R = 7;
              else if (q.slice(0, 8).toLowerCase() === "https://") R = 8;
              else return;
              for (A = R - 1, X = R, $ = []; R < P; ) {
                if (M = q.charCodeAt(R), M === g) {
                  if (A === R - 1) break;
                  $.push(R), A = R, R++;
                  continue;
                }
                if (o(M) || n(M) || M === d || M === b) {
                  R++;
                  continue;
                }
                break;
              }
              if (M === g && ($.pop(), R--), $[0] !== void 0 && (U = $.length < 2 ? X : $[$.length - 2] + 1, q.slice(U, R).indexOf("_") === -1)) {
                if (L) return true;
                for (G = R, J = R; R < P && (M = q.charCodeAt(R), !(s(M) || M === f)); ) R++, M === i || M === l || M === p || M === g || M === F || M === x || M === b || M === v || (G = R);
                if (R = G, q.charCodeAt(R - 1) === a) for (z3 = q.slice(J, R), k = u(z3, h), y = u(z3, m); y > k; ) R = J + z3.lastIndexOf(m), z3 = q.slice(J, R), y--;
                if (q.charCodeAt(R - 1) === E && (R--, n(q.charCodeAt(R - 1)))) {
                  for (G = R - 2; n(q.charCodeAt(G)); ) G--;
                  q.charCodeAt(G) === D && (R = G);
                }
                return _ = q.slice(0, R), V = t(_, { nonTerminated: false }), j && (V = "http://" + V), W = w.enterLink(), w.inlineTokenizers = { text: T.text }, N = w.tokenizeInline(_, B.now()), w.inlineTokenizers = T, W(), B(_)({ type: "link", title: null, url: V, children: N });
              }
            }
          }
        } }), bD = S({ "node_modules/remark-parse/lib/locate/email.js"(e, r) {
          "use strict";
          I();
          var u = ze(), t = Qe(), o = 43, n = 45, s = 46, c = 95;
          r.exports = i;
          function i(a, l) {
            var p = this, d, g;
            if (!this.options.gfm || (d = a.indexOf("@", l), d === -1)) return -1;
            if (g = d, g === l || !D(a.charCodeAt(g - 1))) return i.call(p, a, d + 1);
            for (; g > l && D(a.charCodeAt(g - 1)); ) g--;
            return g;
          }
          function D(a) {
            return u(a) || t(a) || a === o || a === n || a === s || a === c;
          }
        } }), yD = S({ "node_modules/remark-parse/lib/tokenize/email.js"(e, r) {
          "use strict";
          I();
          var u = xr(), t = ze(), o = Qe(), n = bD();
          r.exports = l, l.locator = n, l.notInLink = true;
          var s = 43, c = 45, i = 46, D = 64, a = 95;
          function l(p, d, g) {
            var F = this, E = F.options.gfm, x = F.inlineTokenizers, f = 0, b = d.length, v = -1, h, m, C, B;
            if (!!E) {
              for (h = d.charCodeAt(f); t(h) || o(h) || h === s || h === c || h === i || h === a; ) h = d.charCodeAt(++f);
              if (f !== 0 && h === D) {
                for (f++; f < b; ) {
                  if (h = d.charCodeAt(f), t(h) || o(h) || h === c || h === i || h === a) {
                    f++, v === -1 && h === i && (v = f);
                    continue;
                  }
                  break;
                }
                if (!(v === -1 || v === f || h === c || h === a)) return h === i && f--, m = d.slice(0, f), g ? true : (B = F.enterLink(), F.inlineTokenizers = { text: x.text }, C = F.tokenizeInline(m, p.now()), F.inlineTokenizers = x, B(), p(m)({ type: "link", title: null, url: "mailto:" + u(m, { nonTerminated: false }), children: C }));
              }
            }
          }
        } }), BD = S({ "node_modules/remark-parse/lib/tokenize/html-inline.js"(e, r) {
          "use strict";
          I();
          var u = Qe(), t = Vi(), o = Gi().tag;
          r.exports = l, l.locator = t;
          var n = "<", s = "?", c = "!", i = "/", D = /^<a /i, a = /^<\/a>/i;
          function l(p, d, g) {
            var F = this, E = d.length, x, f;
            if (!(d.charAt(0) !== n || E < 3) && (x = d.charAt(1), !(!u(x) && x !== s && x !== c && x !== i) && (f = d.match(o), !!f))) return g ? true : (f = f[0], !F.inLink && D.test(f) ? F.inLink = true : F.inLink && a.test(f) && (F.inLink = false), p(f)({ type: "html", value: f }));
          }
        } }), $i = S({ "node_modules/remark-parse/lib/locate/link.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t, o) {
            var n = t.indexOf("[", o), s = t.indexOf("![", o);
            return s === -1 || n < s ? n : s;
          }
        } }), wD = S({ "node_modules/remark-parse/lib/tokenize/link.js"(e, r) {
          "use strict";
          I();
          var u = xe(), t = $i();
          r.exports = E, E.locator = t;
          var o = `
`, n = "!", s = '"', c = "'", i = "(", D = ")", a = "<", l = ">", p = "[", d = "\\", g = "]", F = "`";
          function E(x, f, b) {
            var v = this, h = "", m = 0, C = f.charAt(0), B = v.options.pedantic, q = v.options.commonmark, L = v.options.gfm, w, O, T, P, A, j, $, U, X, R, J, z3, M, G, k, y, _, N;
            if (C === n && (U = true, h = C, C = f.charAt(++m)), C === p && !(!U && v.inLink)) {
              for (h += C, G = "", m++, J = f.length, y = x.now(), M = 0, y.column += m, y.offset += m; m < J; ) {
                if (C = f.charAt(m), j = C, C === F) {
                  for (O = 1; f.charAt(m + 1) === F; ) j += C, m++, O++;
                  T ? O >= T && (T = 0) : T = O;
                } else if (C === d) m++, j += f.charAt(m);
                else if ((!T || L) && C === p) M++;
                else if ((!T || L) && C === g) if (M) M--;
                else {
                  if (f.charAt(m + 1) !== i) return;
                  j += i, w = true, m++;
                  break;
                }
                G += j, j = "", m++;
              }
              if (!!w) {
                for (X = G, h += G + j, m++; m < J && (C = f.charAt(m), !!u(C)); ) h += C, m++;
                if (C = f.charAt(m), G = "", P = h, C === a) {
                  for (m++, P += a; m < J && (C = f.charAt(m), C !== l); ) {
                    if (q && C === o) return;
                    G += C, m++;
                  }
                  if (f.charAt(m) !== l) return;
                  h += a + G + l, k = G, m++;
                } else {
                  for (C = null, j = ""; m < J && (C = f.charAt(m), !(j && (C === s || C === c || q && C === i))); ) {
                    if (u(C)) {
                      if (!B) break;
                      j += C;
                    } else {
                      if (C === i) M++;
                      else if (C === D) {
                        if (M === 0) break;
                        M--;
                      }
                      G += j, j = "", C === d && (G += d, C = f.charAt(++m)), G += C;
                    }
                    m++;
                  }
                  h += G, k = G, m = h.length;
                }
                for (G = ""; m < J && (C = f.charAt(m), !!u(C)); ) G += C, m++;
                if (C = f.charAt(m), h += G, G && (C === s || C === c || q && C === i)) if (m++, h += C, G = "", R = C === i ? D : C, A = h, q) {
                  for (; m < J && (C = f.charAt(m), C !== R); ) C === d && (G += d, C = f.charAt(++m)), m++, G += C;
                  if (C = f.charAt(m), C !== R) return;
                  for (z3 = G, h += G + C, m++; m < J && (C = f.charAt(m), !!u(C)); ) h += C, m++;
                } else for (j = ""; m < J; ) {
                  if (C = f.charAt(m), C === R) $ && (G += R + j, j = ""), $ = true;
                  else if (!$) G += C;
                  else if (C === D) {
                    h += G + R + j, z3 = G;
                    break;
                  } else u(C) ? j += C : (G += R + j + C, j = "", $ = false);
                  m++;
                }
                if (f.charAt(m) === D) return b ? true : (h += D, k = v.decode.raw(v.unescape(k), x(P).test().end, { nonTerminated: false }), z3 && (A = x(A).test().end, z3 = v.decode.raw(v.unescape(z3), A)), N = { type: U ? "image" : "link", title: z3 || null, url: k }, U ? N.alt = v.decode.raw(v.unescape(X), y) || null : (_ = v.enterLink(), N.children = v.tokenizeInline(X, y), _()), x(h)(N));
              }
            }
          }
        } }), kD = S({ "node_modules/remark-parse/lib/tokenize/reference.js"(e, r) {
          "use strict";
          I();
          var u = xe(), t = $i(), o = Ui();
          r.exports = g, g.locator = t;
          var n = "link", s = "image", c = "shortcut", i = "collapsed", D = "full", a = "!", l = "[", p = "\\", d = "]";
          function g(F, E, x) {
            var f = this, b = f.options.commonmark, v = E.charAt(0), h = 0, m = E.length, C = "", B = "", q = n, L = c, w, O, T, P, A, j, $, U;
            if (v === a && (q = s, B = v, v = E.charAt(++h)), v === l) {
              for (h++, B += v, j = "", U = 0; h < m; ) {
                if (v = E.charAt(h), v === l) $ = true, U++;
                else if (v === d) {
                  if (!U) break;
                  U--;
                }
                v === p && (j += p, v = E.charAt(++h)), j += v, h++;
              }
              if (C = j, w = j, v = E.charAt(h), v === d) {
                if (h++, C += v, j = "", !b) for (; h < m && (v = E.charAt(h), !!u(v)); ) j += v, h++;
                if (v = E.charAt(h), v === l) {
                  for (O = "", j += v, h++; h < m && (v = E.charAt(h), !(v === l || v === d)); ) v === p && (O += p, v = E.charAt(++h)), O += v, h++;
                  v = E.charAt(h), v === d ? (L = O ? D : i, j += O + v, h++) : O = "", C += j, j = "";
                } else {
                  if (!w) return;
                  O = w;
                }
                if (!(L !== D && $)) return C = B + C, q === n && f.inLink ? null : x ? true : (T = F.now(), T.column += B.length, T.offset += B.length, O = L === D ? O : w, P = { type: q + "Reference", identifier: o(O), label: O, referenceType: L }, q === n ? (A = f.enterLink(), P.children = f.tokenizeInline(w, T), A()) : P.alt = f.decode.raw(f.unescape(w), T) || null, F(C)(P));
              }
            }
          }
        } }), qD = S({ "node_modules/remark-parse/lib/locate/strong.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t, o) {
            var n = t.indexOf("**", o), s = t.indexOf("__", o);
            return s === -1 ? n : n === -1 || s < n ? s : n;
          }
        } }), _D = S({ "node_modules/remark-parse/lib/tokenize/strong.js"(e, r) {
          "use strict";
          I();
          var u = Ge(), t = xe(), o = qD();
          r.exports = i, i.locator = o;
          var n = "\\", s = "*", c = "_";
          function i(D, a, l) {
            var p = this, d = 0, g = a.charAt(d), F, E, x, f, b, v, h;
            if (!(g !== s && g !== c || a.charAt(++d) !== g) && (E = p.options.pedantic, x = g, b = x + x, v = a.length, d++, f = "", g = "", !(E && t(a.charAt(d))))) for (; d < v; ) {
              if (h = g, g = a.charAt(d), g === x && a.charAt(d + 1) === x && (!E || !t(h)) && (g = a.charAt(d + 2), g !== x)) return u(f) ? l ? true : (F = D.now(), F.column += 2, F.offset += 2, D(b + f + b)({ type: "strong", children: p.tokenizeInline(f, F) })) : void 0;
              !E && g === n && (f += g, g = a.charAt(++d)), f += g, d++;
            }
          }
        } }), OD = S({ "node_modules/is-word-character/index.js"(e, r) {
          "use strict";
          I(), r.exports = o;
          var u = String.fromCharCode, t = /\w/;
          function o(n) {
            return t.test(typeof n == "number" ? u(n) : n.charAt(0));
          }
        } }), ID = S({ "node_modules/remark-parse/lib/locate/emphasis.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t, o) {
            var n = t.indexOf("*", o), s = t.indexOf("_", o);
            return s === -1 ? n : n === -1 || s < n ? s : n;
          }
        } }), SD = S({ "node_modules/remark-parse/lib/tokenize/emphasis.js"(e, r) {
          "use strict";
          I();
          var u = Ge(), t = OD(), o = xe(), n = ID();
          r.exports = D, D.locator = n;
          var s = "*", c = "_", i = "\\";
          function D(a, l, p) {
            var d = this, g = 0, F = l.charAt(g), E, x, f, b, v, h, m;
            if (!(F !== s && F !== c) && (x = d.options.pedantic, v = F, f = F, h = l.length, g++, b = "", F = "", !(x && o(l.charAt(g))))) for (; g < h; ) {
              if (m = F, F = l.charAt(g), F === f && (!x || !o(m))) {
                if (F = l.charAt(++g), F !== f) {
                  if (!u(b) || m === f) return;
                  if (!x && f === c && t(F)) {
                    b += f;
                    continue;
                  }
                  return p ? true : (E = a.now(), E.column++, E.offset++, a(v + b + f)({ type: "emphasis", children: d.tokenizeInline(b, E) }));
                }
                b += f;
              }
              !x && F === i && (b += F, F = l.charAt(++g)), b += F, g++;
            }
          }
        } }), TD = S({ "node_modules/remark-parse/lib/locate/delete.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t, o) {
            return t.indexOf("~~", o);
          }
        } }), ND = S({ "node_modules/remark-parse/lib/tokenize/delete.js"(e, r) {
          "use strict";
          I();
          var u = xe(), t = TD();
          r.exports = s, s.locator = t;
          var o = "~", n = "~~";
          function s(c, i, D) {
            var a = this, l = "", p = "", d = "", g = "", F, E, x;
            if (!(!a.options.gfm || i.charAt(0) !== o || i.charAt(1) !== o || u(i.charAt(2)))) for (F = 1, E = i.length, x = c.now(), x.column += 2, x.offset += 2; ++F < E; ) {
              if (l = i.charAt(F), l === o && p === o && (!d || !u(d))) return D ? true : c(n + g + n)({ type: "delete", children: a.tokenizeInline(g, x) });
              g += p, d = p, p = l;
            }
          }
        } }), LD = S({ "node_modules/remark-parse/lib/locate/code-inline.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t, o) {
            return t.indexOf("`", o);
          }
        } }), RD = S({ "node_modules/remark-parse/lib/tokenize/code-inline.js"(e, r) {
          "use strict";
          I();
          var u = LD();
          r.exports = s, s.locator = u;
          var t = 10, o = 32, n = 96;
          function s(c, i, D) {
            for (var a = i.length, l = 0, p, d, g, F, E, x; l < a && i.charCodeAt(l) === n; ) l++;
            if (!(l === 0 || l === a)) {
              for (p = l, E = i.charCodeAt(l); l < a; ) {
                if (F = E, E = i.charCodeAt(l + 1), F === n) {
                  if (d === void 0 && (d = l), g = l + 1, E !== n && g - d === p) {
                    x = true;
                    break;
                  }
                } else d !== void 0 && (d = void 0, g = void 0);
                l++;
              }
              if (!!x) {
                if (D) return true;
                if (l = p, a = d, F = i.charCodeAt(l), E = i.charCodeAt(a - 1), x = false, a - l > 2 && (F === o || F === t) && (E === o || E === t)) {
                  for (l++, a--; l < a; ) {
                    if (F = i.charCodeAt(l), F !== o && F !== t) {
                      x = true;
                      break;
                    }
                    l++;
                  }
                  x === true && (p++, d--);
                }
                return c(i.slice(0, g))({ type: "inlineCode", value: i.slice(p, d) });
              }
            }
          }
        } }), jD = S({ "node_modules/remark-parse/lib/locate/break.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t, o) {
            for (var n = t.indexOf(`
`, o); n > o && t.charAt(n - 1) === " "; ) n--;
            return n;
          }
        } }), PD = S({ "node_modules/remark-parse/lib/tokenize/break.js"(e, r) {
          "use strict";
          I();
          var u = jD();
          r.exports = s, s.locator = u;
          var t = " ", o = `
`, n = 2;
          function s(c, i, D) {
            for (var a = i.length, l = -1, p = "", d; ++l < a; ) {
              if (d = i.charAt(l), d === o) return l < n ? void 0 : D ? true : (p += d, c(p)({ type: "break" }));
              if (d !== t) return;
              p += d;
            }
          }
        } }), MD = S({ "node_modules/remark-parse/lib/tokenize/text.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t, o, n) {
            var s = this, c, i, D, a, l, p, d, g, F, E;
            if (n) return true;
            for (c = s.inlineMethods, a = c.length, i = s.inlineTokenizers, D = -1, F = o.length; ++D < a; ) g = c[D], !(g === "text" || !i[g]) && (d = i[g].locator, d || t.file.fail("Missing locator: `" + g + "`"), p = d.call(s, o, 1), p !== -1 && p < F && (F = p));
            l = o.slice(0, F), E = t.now(), s.decode(l, E, x);
            function x(f, b, v) {
              t(v || f)({ type: "text", value: f });
            }
          }
        } }), zD = S({ "node_modules/remark-parse/lib/parser.js"(e, r) {
          "use strict";
          I();
          var u = Me(), t = jl(), o = Pl(), n = Ml(), s = Xl(), c = Wl();
          r.exports = i;
          function i(l, p) {
            this.file = p, this.offset = {}, this.options = u(this.options), this.setOptions({}), this.inList = false, this.inBlock = false, this.inLink = false, this.atStart = true, this.toOffset = o(p).toOffset, this.unescape = n(this, "escape"), this.decode = s(this);
          }
          var D = i.prototype;
          D.setOptions = Jl(), D.parse = tD(), D.options = Pi(), D.exitStart = t("atStart", true), D.enterList = t("inList", false), D.enterLink = t("inLink", false), D.enterBlock = t("inBlock", false), D.interruptParagraph = [["thematicBreak"], ["list"], ["atxHeading"], ["fencedCode"], ["blockquote"], ["html"], ["setextHeading", { commonmark: false }], ["definition", { commonmark: false }]], D.interruptList = [["atxHeading", { pedantic: false }], ["fencedCode", { pedantic: false }], ["thematicBreak", { pedantic: false }], ["definition", { commonmark: false }]], D.interruptBlockquote = [["indentedCode", { commonmark: true }], ["fencedCode", { commonmark: true }], ["atxHeading", { commonmark: true }], ["setextHeading", { commonmark: true }], ["thematicBreak", { commonmark: true }], ["html", { commonmark: true }], ["list", { commonmark: true }], ["definition", { commonmark: false }]], D.blockTokenizers = { blankLine: nD(), indentedCode: iD(), fencedCode: aD(), blockquote: oD(), atxHeading: sD(), thematicBreak: cD(), list: DD(), setextHeading: fD(), html: pD(), definition: hD(), table: vD(), paragraph: mD() }, D.inlineTokenizers = { escape: CD(), autoLink: gD(), url: xD(), email: yD(), html: BD(), link: wD(), reference: kD(), strong: _D(), emphasis: SD(), deletion: ND(), code: RD(), break: PD(), text: MD() }, D.blockMethods = a(D.blockTokenizers), D.inlineMethods = a(D.inlineTokenizers), D.tokenizeBlock = c("block"), D.tokenizeInline = c("inline"), D.tokenizeFactory = c;
          function a(l) {
            var p = [], d;
            for (d in l) p.push(d);
            return p;
          }
        } }), GD = S({ "node_modules/remark-parse/index.js"(e, r) {
          "use strict";
          I();
          var u = Rl(), t = Me(), o = zD();
          r.exports = n, n.Parser = o;
          function n(s) {
            var c = this.data("settings"), i = u(o);
            i.prototype.options = t(i.prototype.options, c, s), this.Parser = i;
          }
        } }), UD = S({ "node_modules/bail/index.js"(e, r) {
          "use strict";
          I(), r.exports = u;
          function u(t) {
            if (t) throw t;
          }
        } }), Hi = S({ "node_modules/is-buffer/index.js"(e, r) {
          I(), r.exports = function(t) {
            return t != null && t.constructor != null && typeof t.constructor.isBuffer == "function" && t.constructor.isBuffer(t);
          };
        } }), VD = S({ "node_modules/extend/index.js"(e, r) {
          "use strict";
          I();
          var u = Object.prototype.hasOwnProperty, t = Object.prototype.toString, o = Object.defineProperty, n = Object.getOwnPropertyDescriptor, s = function(l) {
            return typeof Array.isArray == "function" ? Array.isArray(l) : t.call(l) === "[object Array]";
          }, c = function(l) {
            if (!l || t.call(l) !== "[object Object]") return false;
            var p = u.call(l, "constructor"), d = l.constructor && l.constructor.prototype && u.call(l.constructor.prototype, "isPrototypeOf");
            if (l.constructor && !p && !d) return false;
            var g;
            for (g in l) ;
            return typeof g > "u" || u.call(l, g);
          }, i = function(l, p) {
            o && p.name === "__proto__" ? o(l, p.name, { enumerable: true, configurable: true, value: p.newValue, writable: true }) : l[p.name] = p.newValue;
          }, D = function(l, p) {
            if (p === "__proto__") if (u.call(l, p)) {
              if (n) return n(l, p).value;
            } else return;
            return l[p];
          };
          r.exports = function a() {
            var l, p, d, g, F, E, x = arguments[0], f = 1, b = arguments.length, v = false;
            for (typeof x == "boolean" && (v = x, x = arguments[1] || {}, f = 2), (x == null || typeof x != "object" && typeof x != "function") && (x = {}); f < b; ++f) if (l = arguments[f], l != null) for (p in l) d = D(x, p), g = D(l, p), x !== g && (v && g && (c(g) || (F = s(g))) ? (F ? (F = false, E = d && s(d) ? d : []) : E = d && c(d) ? d : {}, i(x, { name: p, newValue: a(v, E, g) })) : typeof g < "u" && i(x, { name: p, newValue: g }));
            return x;
          };
        } }), $D = S({ "node_modules/is-plain-obj/index.js"(e, r) {
          "use strict";
          I(), r.exports = (u) => {
            if (Object.prototype.toString.call(u) !== "[object Object]") return false;
            let t = Object.getPrototypeOf(u);
            return t === null || t === Object.prototype;
          };
        } }), HD = S({ "node_modules/trough/wrap.js"(e, r) {
          "use strict";
          I();
          var u = [].slice;
          r.exports = t;
          function t(o, n) {
            var s;
            return c;
            function c() {
              var a = u.call(arguments, 0), l = o.length > a.length, p;
              l && a.push(i);
              try {
                p = o.apply(null, a);
              } catch (d) {
                if (l && s) throw d;
                return i(d);
              }
              l || (p && typeof p.then == "function" ? p.then(D, i) : p instanceof Error ? i(p) : D(p));
            }
            function i() {
              s || (s = true, n.apply(null, arguments));
            }
            function D(a) {
              i(null, a);
            }
          }
        } }), XD = S({ "node_modules/trough/index.js"(e, r) {
          "use strict";
          I();
          var u = HD();
          r.exports = o, o.wrap = u;
          var t = [].slice;
          function o() {
            var n = [], s = {};
            return s.run = c, s.use = i, s;
            function c() {
              var D = -1, a = t.call(arguments, 0, -1), l = arguments[arguments.length - 1];
              if (typeof l != "function") throw new Error("Expected function as last argument, not " + l);
              p.apply(null, [null].concat(a));
              function p(d) {
                var g = n[++D], F = t.call(arguments, 0), E = F.slice(1), x = a.length, f = -1;
                if (d) {
                  l(d);
                  return;
                }
                for (; ++f < x; ) (E[f] === null || E[f] === void 0) && (E[f] = a[f]);
                a = E, g ? u(g, p).apply(null, a) : l.apply(null, [null].concat(a));
              }
            }
            function i(D) {
              if (typeof D != "function") throw new Error("Expected `fn` to be a function, not " + D);
              return n.push(D), s;
            }
          }
        } }), WD = S({ "node_modules/unist-util-stringify-position/index.js"(e, r) {
          "use strict";
          I();
          var u = {}.hasOwnProperty;
          r.exports = t;
          function t(c) {
            return !c || typeof c != "object" ? "" : u.call(c, "position") || u.call(c, "type") ? n(c.position) : u.call(c, "start") || u.call(c, "end") ? n(c) : u.call(c, "line") || u.call(c, "column") ? o(c) : "";
          }
          function o(c) {
            return (!c || typeof c != "object") && (c = {}), s(c.line) + ":" + s(c.column);
          }
          function n(c) {
            return (!c || typeof c != "object") && (c = {}), o(c.start) + "-" + o(c.end);
          }
          function s(c) {
            return c && typeof c == "number" ? c : 1;
          }
        } }), KD = S({ "node_modules/vfile-message/index.js"(e, r) {
          "use strict";
          I();
          var u = WD();
          r.exports = n;
          function t() {
          }
          t.prototype = Error.prototype, n.prototype = new t();
          var o = n.prototype;
          o.file = "", o.name = "", o.reason = "", o.message = "", o.stack = "", o.fatal = null, o.column = null, o.line = null;
          function n(c, i, D) {
            var a, l, p;
            typeof i == "string" && (D = i, i = null), a = s(D), l = u(i) || "1:1", p = { start: { line: null, column: null }, end: { line: null, column: null } }, i && i.position && (i = i.position), i && (i.start ? (p = i, i = i.start) : p.start = i), c.stack && (this.stack = c.stack, c = c.message), this.message = c, this.name = l, this.reason = c, this.line = i ? i.line : null, this.column = i ? i.column : null, this.location = p, this.source = a[0], this.ruleId = a[1];
          }
          function s(c) {
            var i = [null, null], D;
            return typeof c == "string" && (D = c.indexOf(":"), D === -1 ? i[1] = c : (i[0] = c.slice(0, D), i[1] = c.slice(D + 1))), i;
          }
        } }), YD = S({ "node_modules/vfile/lib/minpath.browser.js"(e) {
          "use strict";
          I(), e.basename = r, e.dirname = u, e.extname = t, e.join = o, e.sep = "/";
          function r(i, D) {
            var a = 0, l = -1, p, d, g, F;
            if (D !== void 0 && typeof D != "string") throw new TypeError('"ext" argument must be a string');
            if (c(i), p = i.length, D === void 0 || !D.length || D.length > i.length) {
              for (; p--; ) if (i.charCodeAt(p) === 47) {
                if (g) {
                  a = p + 1;
                  break;
                }
              } else l < 0 && (g = true, l = p + 1);
              return l < 0 ? "" : i.slice(a, l);
            }
            if (D === i) return "";
            for (d = -1, F = D.length - 1; p--; ) if (i.charCodeAt(p) === 47) {
              if (g) {
                a = p + 1;
                break;
              }
            } else d < 0 && (g = true, d = p + 1), F > -1 && (i.charCodeAt(p) === D.charCodeAt(F--) ? F < 0 && (l = p) : (F = -1, l = d));
            return a === l ? l = d : l < 0 && (l = i.length), i.slice(a, l);
          }
          function u(i) {
            var D, a, l;
            if (c(i), !i.length) return ".";
            for (D = -1, l = i.length; --l; ) if (i.charCodeAt(l) === 47) {
              if (a) {
                D = l;
                break;
              }
            } else a || (a = true);
            return D < 0 ? i.charCodeAt(0) === 47 ? "/" : "." : D === 1 && i.charCodeAt(0) === 47 ? "//" : i.slice(0, D);
          }
          function t(i) {
            var D = -1, a = 0, l = -1, p = 0, d, g, F;
            for (c(i), F = i.length; F--; ) {
              if (g = i.charCodeAt(F), g === 47) {
                if (d) {
                  a = F + 1;
                  break;
                }
                continue;
              }
              l < 0 && (d = true, l = F + 1), g === 46 ? D < 0 ? D = F : p !== 1 && (p = 1) : D > -1 && (p = -1);
            }
            return D < 0 || l < 0 || p === 0 || p === 1 && D === l - 1 && D === a + 1 ? "" : i.slice(D, l);
          }
          function o() {
            for (var i = -1, D; ++i < arguments.length; ) c(arguments[i]), arguments[i] && (D = D === void 0 ? arguments[i] : D + "/" + arguments[i]);
            return D === void 0 ? "." : n(D);
          }
          function n(i) {
            var D, a;
            return c(i), D = i.charCodeAt(0) === 47, a = s(i, !D), !a.length && !D && (a = "."), a.length && i.charCodeAt(i.length - 1) === 47 && (a += "/"), D ? "/" + a : a;
          }
          function s(i, D) {
            for (var a = "", l = 0, p = -1, d = 0, g = -1, F, E; ++g <= i.length; ) {
              if (g < i.length) F = i.charCodeAt(g);
              else {
                if (F === 47) break;
                F = 47;
              }
              if (F === 47) {
                if (!(p === g - 1 || d === 1)) if (p !== g - 1 && d === 2) {
                  if (a.length < 2 || l !== 2 || a.charCodeAt(a.length - 1) !== 46 || a.charCodeAt(a.length - 2) !== 46) {
                    if (a.length > 2) {
                      if (E = a.lastIndexOf("/"), E !== a.length - 1) {
                        E < 0 ? (a = "", l = 0) : (a = a.slice(0, E), l = a.length - 1 - a.lastIndexOf("/")), p = g, d = 0;
                        continue;
                      }
                    } else if (a.length) {
                      a = "", l = 0, p = g, d = 0;
                      continue;
                    }
                  }
                  D && (a = a.length ? a + "/.." : "..", l = 2);
                } else a.length ? a += "/" + i.slice(p + 1, g) : a = i.slice(p + 1, g), l = g - p - 1;
                p = g, d = 0;
              } else F === 46 && d > -1 ? d++ : d = -1;
            }
            return a;
          }
          function c(i) {
            if (typeof i != "string") throw new TypeError("Path must be a string. Received " + JSON.stringify(i));
          }
        } }), JD = S({ "node_modules/vfile/lib/minproc.browser.js"(e) {
          "use strict";
          I(), e.cwd = r;
          function r() {
            return "/";
          }
        } }), ZD = S({ "node_modules/vfile/lib/core.js"(e, r) {
          "use strict";
          I();
          var u = YD(), t = JD(), o = Hi();
          r.exports = c;
          var n = {}.hasOwnProperty, s = ["history", "path", "basename", "stem", "extname", "dirname"];
          c.prototype.toString = f, Object.defineProperty(c.prototype, "path", { get: i, set: D }), Object.defineProperty(c.prototype, "dirname", { get: a, set: l }), Object.defineProperty(c.prototype, "basename", { get: p, set: d }), Object.defineProperty(c.prototype, "extname", { get: g, set: F }), Object.defineProperty(c.prototype, "stem", { get: E, set: x });
          function c(m) {
            var C, B;
            if (!m) m = {};
            else if (typeof m == "string" || o(m)) m = { contents: m };
            else if ("message" in m && "messages" in m) return m;
            if (!(this instanceof c)) return new c(m);
            for (this.data = {}, this.messages = [], this.history = [], this.cwd = t.cwd(), B = -1; ++B < s.length; ) C = s[B], n.call(m, C) && (this[C] = m[C]);
            for (C in m) s.indexOf(C) < 0 && (this[C] = m[C]);
          }
          function i() {
            return this.history[this.history.length - 1];
          }
          function D(m) {
            v(m, "path"), this.path !== m && this.history.push(m);
          }
          function a() {
            return typeof this.path == "string" ? u.dirname(this.path) : void 0;
          }
          function l(m) {
            h(this.path, "dirname"), this.path = u.join(m || "", this.basename);
          }
          function p() {
            return typeof this.path == "string" ? u.basename(this.path) : void 0;
          }
          function d(m) {
            v(m, "basename"), b(m, "basename"), this.path = u.join(this.dirname || "", m);
          }
          function g() {
            return typeof this.path == "string" ? u.extname(this.path) : void 0;
          }
          function F(m) {
            if (b(m, "extname"), h(this.path, "extname"), m) {
              if (m.charCodeAt(0) !== 46) throw new Error("`extname` must start with `.`");
              if (m.indexOf(".", 1) > -1) throw new Error("`extname` cannot contain multiple dots");
            }
            this.path = u.join(this.dirname, this.stem + (m || ""));
          }
          function E() {
            return typeof this.path == "string" ? u.basename(this.path, this.extname) : void 0;
          }
          function x(m) {
            v(m, "stem"), b(m, "stem"), this.path = u.join(this.dirname || "", m + (this.extname || ""));
          }
          function f(m) {
            return (this.contents || "").toString(m);
          }
          function b(m, C) {
            if (m && m.indexOf(u.sep) > -1) throw new Error("`" + C + "` cannot be a path: did not expect `" + u.sep + "`");
          }
          function v(m, C) {
            if (!m) throw new Error("`" + C + "` cannot be empty");
          }
          function h(m, C) {
            if (!m) throw new Error("Setting `" + C + "` requires `path` to be set too");
          }
        } }), QD = S({ "node_modules/vfile/lib/index.js"(e, r) {
          "use strict";
          I();
          var u = KD(), t = ZD();
          r.exports = t, t.prototype.message = o, t.prototype.info = s, t.prototype.fail = n;
          function o(c, i, D) {
            var a = new u(c, i, D);
            return this.path && (a.name = this.path + ":" + a.name, a.file = this.path), a.fatal = false, this.messages.push(a), a;
          }
          function n() {
            var c = this.message.apply(this, arguments);
            throw c.fatal = true, c;
          }
          function s() {
            var c = this.message.apply(this, arguments);
            return c.fatal = null, c;
          }
        } }), e2 = S({ "node_modules/vfile/index.js"(e, r) {
          "use strict";
          I(), r.exports = QD();
        } }), r2 = S({ "node_modules/unified/index.js"(e, r) {
          "use strict";
          I();
          var u = UD(), t = Hi(), o = VD(), n = $D(), s = XD(), c = e2();
          r.exports = g().freeze();
          var i = [].slice, D = {}.hasOwnProperty, a = s().use(l).use(p).use(d);
          function l(m, C) {
            C.tree = m.parse(C.file);
          }
          function p(m, C, B) {
            m.run(C.tree, C.file, q);
            function q(L, w, O) {
              L ? B(L) : (C.tree = w, C.file = O, B());
            }
          }
          function d(m, C) {
            var B = m.stringify(C.tree, C.file);
            B == null || (typeof B == "string" || t(B) ? C.file.contents = B : C.file.result = B);
          }
          function g() {
            var m = [], C = s(), B = {}, q = -1, L;
            return w.data = T, w.freeze = O, w.attachers = m, w.use = P, w.parse = j, w.stringify = X, w.run = $, w.runSync = U, w.process = R, w.processSync = J, w;
            function w() {
              for (var z3 = g(), M = -1; ++M < m.length; ) z3.use.apply(null, m[M]);
              return z3.data(o(true, {}, B)), z3;
            }
            function O() {
              var z3, M;
              if (L) return w;
              for (; ++q < m.length; ) z3 = m[q], z3[1] !== false && (z3[1] === true && (z3[1] = void 0), M = z3[0].apply(w, z3.slice(1)), typeof M == "function" && C.use(M));
              return L = true, q = 1 / 0, w;
            }
            function T(z3, M) {
              return typeof z3 == "string" ? arguments.length === 2 ? (b("data", L), B[z3] = M, w) : D.call(B, z3) && B[z3] || null : z3 ? (b("data", L), B = z3, w) : B;
            }
            function P(z3) {
              var M;
              if (b("use", L), z3 != null) if (typeof z3 == "function") _.apply(null, arguments);
              else if (typeof z3 == "object") "length" in z3 ? y(z3) : G(z3);
              else throw new Error("Expected usable value, not `" + z3 + "`");
              return M && (B.settings = o(B.settings || {}, M)), w;
              function G(N) {
                y(N.plugins), N.settings && (M = o(M || {}, N.settings));
              }
              function k(N) {
                if (typeof N == "function") _(N);
                else if (typeof N == "object") "length" in N ? _.apply(null, N) : G(N);
                else throw new Error("Expected usable value, not `" + N + "`");
              }
              function y(N) {
                var V = -1;
                if (N != null) if (typeof N == "object" && "length" in N) for (; ++V < N.length; ) k(N[V]);
                else throw new Error("Expected a list of plugins, not `" + N + "`");
              }
              function _(N, V) {
                var W = A(N);
                W ? (n(W[1]) && n(V) && (V = o(true, W[1], V)), W[1] = V) : m.push(i.call(arguments));
              }
            }
            function A(z3) {
              for (var M = -1; ++M < m.length; ) if (m[M][0] === z3) return m[M];
            }
            function j(z3) {
              var M = c(z3), G;
              return O(), G = w.Parser, x("parse", G), F(G, "parse") ? new G(String(M), M).parse() : G(String(M), M);
            }
            function $(z3, M, G) {
              if (v(z3), O(), !G && typeof M == "function" && (G = M, M = null), !G) return new Promise(k);
              k(null, G);
              function k(y, _) {
                C.run(z3, c(M), N);
                function N(V, W, K) {
                  W = W || z3, V ? _(V) : y ? y(W) : G(null, W, K);
                }
              }
            }
            function U(z3, M) {
              var G, k;
              return $(z3, M, y), h("runSync", "run", k), G;
              function y(_, N) {
                k = true, G = N, u(_);
              }
            }
            function X(z3, M) {
              var G = c(M), k;
              return O(), k = w.Compiler, f("stringify", k), v(z3), F(k, "compile") ? new k(z3, G).compile() : k(z3, G);
            }
            function R(z3, M) {
              if (O(), x("process", w.Parser), f("process", w.Compiler), !M) return new Promise(G);
              G(null, M);
              function G(k, y) {
                var _ = c(z3);
                a.run(w, { file: _ }, N);
                function N(V) {
                  V ? y(V) : k ? k(_) : M(null, _);
                }
              }
            }
            function J(z3) {
              var M, G;
              return O(), x("processSync", w.Parser), f("processSync", w.Compiler), M = c(z3), R(M, k), h("processSync", "process", G), M;
              function k(y) {
                G = true, u(y);
              }
            }
          }
          function F(m, C) {
            return typeof m == "function" && m.prototype && (E(m.prototype) || C in m.prototype);
          }
          function E(m) {
            var C;
            for (C in m) return true;
            return false;
          }
          function x(m, C) {
            if (typeof C != "function") throw new Error("Cannot `" + m + "` without `Parser`");
          }
          function f(m, C) {
            if (typeof C != "function") throw new Error("Cannot `" + m + "` without `Compiler`");
          }
          function b(m, C) {
            if (C) throw new Error("Cannot invoke `" + m + "` on a frozen processor.\nCreate a new processor first, by invoking it: use `processor()` instead of `processor`.");
          }
          function v(m) {
            if (!m || typeof m.type != "string") throw new Error("Expected node, got `" + m + "`");
          }
          function h(m, C, B) {
            if (!B) throw new Error("`" + m + "` finished async. Use `" + C + "` instead");
          }
        } }), Xi = S({ "node_modules/remark-math/util.js"(e) {
          I(), e.isRemarkParser = r, e.isRemarkCompiler = u;
          function r(t) {
            return Boolean(t && t.prototype && t.prototype.blockTokenizers);
          }
          function u(t) {
            return Boolean(t && t.prototype && t.prototype.visitors);
          }
        } }), u2 = S({ "node_modules/remark-math/inline.js"(e, r) {
          I();
          var u = Xi();
          r.exports = l;
          var t = 9, o = 32, n = 36, s = 48, c = 57, i = 92, D = ["math", "math-inline"], a = "math-display";
          function l(g) {
            let F = this.Parser, E = this.Compiler;
            u.isRemarkParser(F) && p(F, g), u.isRemarkCompiler(E) && d(E, g);
          }
          function p(g, F) {
            let E = g.prototype, x = E.inlineMethods;
            b.locator = f, E.inlineTokenizers.math = b, x.splice(x.indexOf("text"), 0, "math");
            function f(v, h) {
              return v.indexOf("$", h);
            }
            function b(v, h, m) {
              let C = h.length, B = false, q = false, L = 0, w, O, T, P, A, j, $;
              if (h.charCodeAt(L) === i && (q = true, L++), h.charCodeAt(L) === n) {
                if (L++, q) return m ? true : v(h.slice(0, L))({ type: "text", value: "$" });
                if (h.charCodeAt(L) === n && (B = true, L++), T = h.charCodeAt(L), !(T === o || T === t)) {
                  for (P = L; L < C; ) {
                    if (O = T, T = h.charCodeAt(L + 1), O === n) {
                      if (w = h.charCodeAt(L - 1), w !== o && w !== t && (T !== T || T < s || T > c) && (!B || T === n)) {
                        A = L - 1, L++, B && L++, j = L;
                        break;
                      }
                    } else O === i && (L++, T = h.charCodeAt(L + 1));
                    L++;
                  }
                  if (j !== void 0) return m ? true : ($ = h.slice(P, A + 1), v(h.slice(0, j))({ type: "inlineMath", value: $, data: { hName: "span", hProperties: { className: D.concat(B && F.inlineMathDouble ? [a] : []) }, hChildren: [{ type: "text", value: $ }] } }));
                }
              }
            }
          }
          function d(g) {
            let F = g.prototype;
            F.visitors.inlineMath = E;
            function E(x) {
              let f = "$";
              return (x.data && x.data.hProperties && x.data.hProperties.className || []).includes(a) && (f = "$$"), f + x.value + f;
            }
          }
        } }), t2 = S({ "node_modules/remark-math/block.js"(e, r) {
          I();
          var u = Xi();
          r.exports = a;
          var t = 10, o = 32, n = 36, s = `
`, c = "$", i = 2, D = ["math", "math-display"];
          function a() {
            let d = this.Parser, g = this.Compiler;
            u.isRemarkParser(d) && l(d), u.isRemarkCompiler(g) && p(g);
          }
          function l(d) {
            let g = d.prototype, F = g.blockMethods, E = g.interruptParagraph, x = g.interruptList, f = g.interruptBlockquote;
            g.blockTokenizers.math = b, F.splice(F.indexOf("fencedCode") + 1, 0, "math"), E.splice(E.indexOf("fencedCode") + 1, 0, ["math"]), x.splice(x.indexOf("fencedCode") + 1, 0, ["math"]), f.splice(f.indexOf("fencedCode") + 1, 0, ["math"]);
            function b(v, h, m) {
              var C = h.length, B = 0;
              let q, L, w, O, T, P, A, j, $, U, X;
              for (; B < C && h.charCodeAt(B) === o; ) B++;
              for (T = B; B < C && h.charCodeAt(B) === n; ) B++;
              if (P = B - T, !(P < i)) {
                for (; B < C && h.charCodeAt(B) === o; ) B++;
                for (A = B; B < C; ) {
                  if (q = h.charCodeAt(B), q === n) return;
                  if (q === t) break;
                  B++;
                }
                if (h.charCodeAt(B) === t) {
                  if (m) return true;
                  for (L = [], A !== B && L.push(h.slice(A, B)), B++, w = h.indexOf(s, B + 1), w = w === -1 ? C : w; B < C; ) {
                    for (j = false, U = B, X = w, O = w, $ = 0; O > U && h.charCodeAt(O - 1) === o; ) O--;
                    for (; O > U && h.charCodeAt(O - 1) === n; ) $++, O--;
                    for (P <= $ && h.indexOf(c, U) === O && (j = true, X = O); U <= X && U - B < T && h.charCodeAt(U) === o; ) U++;
                    if (j) for (; X > U && h.charCodeAt(X - 1) === o; ) X--;
                    if ((!j || U !== X) && L.push(h.slice(U, X)), j) break;
                    B = w + 1, w = h.indexOf(s, B + 1), w = w === -1 ? C : w;
                  }
                  return L = L.join(`
`), v(h.slice(0, w))({ type: "math", value: L, data: { hName: "div", hProperties: { className: D.concat() }, hChildren: [{ type: "text", value: L }] } });
                }
              }
            }
          }
          function p(d) {
            let g = d.prototype;
            g.visitors.math = F;
            function F(E) {
              return `$$
` + E.value + `
$$`;
            }
          }
        } }), n2 = S({ "node_modules/remark-math/index.js"(e, r) {
          I();
          var u = u2(), t = t2();
          r.exports = o;
          function o(n) {
            var s = n || {};
            t.call(this, s), u.call(this, s);
          }
        } }), i2 = S({ "node_modules/remark-footnotes/index.js"(e, r) {
          "use strict";
          I(), r.exports = g;
          var u = 9, t = 10, o = 32, n = 33, s = 58, c = 91, i = 92, D = 93, a = 94, l = 96, p = 4, d = 1024;
          function g(h) {
            var m = this.Parser, C = this.Compiler;
            F(m) && x(m, h), E(C) && f(C);
          }
          function F(h) {
            return Boolean(h && h.prototype && h.prototype.blockTokenizers);
          }
          function E(h) {
            return Boolean(h && h.prototype && h.prototype.visitors);
          }
          function x(h, m) {
            for (var C = m || {}, B = h.prototype, q = B.blockTokenizers, L = B.inlineTokenizers, w = B.blockMethods, O = B.inlineMethods, T = q.definition, P = L.reference, A = [], j = -1, $ = w.length, U; ++j < $; ) U = w[j], !(U === "newline" || U === "indentedCode" || U === "paragraph" || U === "footnoteDefinition") && A.push([U]);
            A.push(["footnoteDefinition"]), C.inlineNotes && (b(O, "reference", "inlineNote"), L.inlineNote = J), b(w, "definition", "footnoteDefinition"), b(O, "reference", "footnoteCall"), q.definition = M, q.footnoteDefinition = X, L.footnoteCall = R, L.reference = z3, B.interruptFootnoteDefinition = A, z3.locator = P.locator, R.locator = G, J.locator = k;
            function X(y, _, N) {
              for (var V = this, W = V.interruptFootnoteDefinition, K = V.offset, ee = _.length + 1, Y = 0, te = [], De, le, ne, Z, Q, fe, be, pe, he, oe, de, ie, re; Y < ee && (Z = _.charCodeAt(Y), !(Z !== u && Z !== o)); ) Y++;
              if (_.charCodeAt(Y++) === c && _.charCodeAt(Y++) === a) {
                for (le = Y; Y < ee; ) {
                  if (Z = _.charCodeAt(Y), Z !== Z || Z === t || Z === u || Z === o) return;
                  if (Z === D) {
                    ne = Y, Y++;
                    break;
                  }
                  Y++;
                }
                if (!(ne === void 0 || le === ne || _.charCodeAt(Y++) !== s)) {
                  if (N) return true;
                  for (De = _.slice(le, ne), Q = y.now(), he = 0, oe = 0, de = Y, ie = []; Y < ee; ) {
                    if (Z = _.charCodeAt(Y), Z !== Z || Z === t) re = { start: he, contentStart: de || Y, contentEnd: Y, end: Y }, ie.push(re), Z === t && (he = Y + 1, oe = 0, de = void 0, re.end = he);
                    else if (oe !== void 0) if (Z === o || Z === u) oe += Z === o ? 1 : p - oe % p, oe > p && (oe = void 0, de = Y);
                    else {
                      if (oe < p && re && (re.contentStart === re.contentEnd || v(W, q, V, [y, _.slice(Y, d), true]))) break;
                      oe = void 0, de = Y;
                    }
                    Y++;
                  }
                  for (Y = -1, ee = ie.length; ee > 0 && (re = ie[ee - 1], re.contentStart === re.contentEnd); ) ee--;
                  for (fe = y(_.slice(0, re.contentEnd)); ++Y < ee; ) re = ie[Y], K[Q.line + Y] = (K[Q.line + Y] || 0) + (re.contentStart - re.start), te.push(_.slice(re.contentStart, re.end));
                  return be = V.enterBlock(), pe = V.tokenizeBlock(te.join(""), Q), be(), fe({ type: "footnoteDefinition", identifier: De.toLowerCase(), label: De, children: pe });
                }
              }
            }
            function R(y, _, N) {
              var V = _.length + 1, W = 0, K, ee, Y, te;
              if (_.charCodeAt(W++) === c && _.charCodeAt(W++) === a) {
                for (ee = W; W < V; ) {
                  if (te = _.charCodeAt(W), te !== te || te === t || te === u || te === o) return;
                  if (te === D) {
                    Y = W, W++;
                    break;
                  }
                  W++;
                }
                if (!(Y === void 0 || ee === Y)) return N ? true : (K = _.slice(ee, Y), y(_.slice(0, W))({ type: "footnoteReference", identifier: K.toLowerCase(), label: K }));
              }
            }
            function J(y, _, N) {
              var V = this, W = _.length + 1, K = 0, ee = 0, Y, te, De, le, ne, Z, Q;
              if (_.charCodeAt(K++) === a && _.charCodeAt(K++) === c) {
                for (De = K; K < W; ) {
                  if (te = _.charCodeAt(K), te !== te) return;
                  if (Z === void 0) if (te === i) K += 2;
                  else if (te === c) ee++, K++;
                  else if (te === D) if (ee === 0) {
                    le = K, K++;
                    break;
                  } else ee--, K++;
                  else if (te === l) {
                    for (ne = K, Z = 1; _.charCodeAt(ne + Z) === l; ) Z++;
                    K += Z;
                  } else K++;
                  else if (te === l) {
                    for (ne = K, Q = 1; _.charCodeAt(ne + Q) === l; ) Q++;
                    K += Q, Z === Q && (Z = void 0), Q = void 0;
                  } else K++;
                }
                if (le !== void 0) return N ? true : (Y = y.now(), Y.column += 2, Y.offset += 2, y(_.slice(0, K))({ type: "footnote", children: V.tokenizeInline(_.slice(De, le), Y) }));
              }
            }
            function z3(y, _, N) {
              var V = 0;
              if (_.charCodeAt(V) === n && V++, _.charCodeAt(V) === c && _.charCodeAt(V + 1) !== a) return P.call(this, y, _, N);
            }
            function M(y, _, N) {
              for (var V = 0, W = _.charCodeAt(V); W === o || W === u; ) W = _.charCodeAt(++V);
              if (W === c && _.charCodeAt(V + 1) !== a) return T.call(this, y, _, N);
            }
            function G(y, _) {
              return y.indexOf("[", _);
            }
            function k(y, _) {
              return y.indexOf("^[", _);
            }
          }
          function f(h) {
            var m = h.prototype.visitors, C = "    ";
            m.footnote = B, m.footnoteReference = q, m.footnoteDefinition = L;
            function B(w) {
              return "^[" + this.all(w).join("") + "]";
            }
            function q(w) {
              return "[^" + (w.label || w.identifier) + "]";
            }
            function L(w) {
              for (var O = this.all(w).join(`

`).split(`
`), T = 0, P = O.length, A; ++T < P; ) A = O[T], A !== "" && (O[T] = C + A);
              return "[^" + (w.label || w.identifier) + "]: " + O.join(`
`);
            }
          }
          function b(h, m, C) {
            h.splice(h.indexOf(m), 0, C);
          }
          function v(h, m, C, B) {
            for (var q = h.length, L = -1; ++L < q; ) if (m[h[L][0]].apply(C, B)) return true;
            return false;
          }
        } }), Wi = S({ "src/utils/front-matter/parse.js"(e, r) {
          "use strict";
          I();
          var u = new RegExp("^(?<startDelimiter>-{3}|\\+{3})(?<language>[^\\n]*)\\n(?:|(?<value>.*?)\\n)(?<endDelimiter>\\k<startDelimiter>|\\.{3})[^\\S\\n]*(?:\\n|$)", "s");
          function t(o) {
            let n = o.match(u);
            if (!n) return { content: o };
            let { startDelimiter: s, language: c, value: i = "", endDelimiter: D } = n.groups, a = c.trim() || "yaml";
            if (s === "+++" && (a = "toml"), a !== "yaml" && s !== D) return { content: o };
            let [l] = n;
            return { frontMatter: { type: "front-matter", lang: a, value: i, startDelimiter: s, endDelimiter: D, raw: l.replace(/\n$/, "") }, content: l.replace(/[^\n]/g, " ") + o.slice(l.length) };
          }
          r.exports = t;
        } }), a2 = S({ "src/language-markdown/pragma.js"(e, r) {
          "use strict";
          I();
          var u = Wi(), t = ["format", "prettier"];
          function o(n) {
            let s = "@(".concat(t.join("|"), ")"), c = new RegExp(["<!--\\s*".concat(s, "\\s*-->"), "{\\s*\\/\\*\\s*".concat(s, "\\s*\\*\\/\\s*}"), `<!--.*\r?
[\\s\\S]*(^|
)[^\\S
]*`.concat(s, `[^\\S
]*($|
)[\\s\\S]*
.*-->`)].join("|"), "m"), i = n.match(c);
            return (i == null ? void 0 : i.index) === 0;
          }
          r.exports = { startWithPragma: o, hasPragma: (n) => o(u(n).content.trimStart()), insertPragma: (n) => {
            let s = u(n), c = "<!-- @".concat(t[0], " -->");
            return s.frontMatter ? "".concat(s.frontMatter.raw, `

`).concat(c, `

`).concat(s.content) : "".concat(c, `

`).concat(s.content);
          } };
        } }), Ki = S({ "src/language-markdown/loc.js"(e, r) {
          "use strict";
          I();
          function u(o) {
            return o.position.start.offset;
          }
          function t(o) {
            return o.position.end.offset;
          }
          r.exports = { locStart: u, locEnd: t };
        } }), Yi = S({ "src/language-markdown/mdx.js"(e, r) {
          "use strict";
          I();
          var u = /^import\s/, t = /^export\s/, o = "[a-z][a-z0-9]*(\\.[a-z][a-z0-9]*)*|", n = /<!---->|<!---?[^>-](?:-?[^-])*-->/, s = /^{\s*\/\*(.*)\*\/\s*}/, c = `

`, i = (d) => u.test(d), D = (d) => t.test(d), a = (d, g) => {
            let F = g.indexOf(c), E = g.slice(0, F);
            if (D(E) || i(E)) return d(E)({ type: D(E) ? "export" : "import", value: E });
          }, l = (d, g) => {
            let F = s.exec(g);
            if (F) return d(F[0])({ type: "esComment", value: F[1].trim() });
          };
          a.locator = (d) => D(d) || i(d) ? -1 : 1, l.locator = (d, g) => d.indexOf("{", g);
          function p() {
            let { Parser: d } = this, { blockTokenizers: g, blockMethods: F, inlineTokenizers: E, inlineMethods: x } = d.prototype;
            g.esSyntax = a, E.esComment = l, F.splice(F.indexOf("paragraph"), 0, "esSyntax"), x.splice(x.indexOf("text"), 0, "esComment");
          }
          r.exports = { esSyntax: p, BLOCKS_REGEX: o, COMMENT_REGEX: n };
        } }), Ji = {};
        Li(Ji, { default: () => o2 });
        function o2(e) {
          if (typeof e != "string") throw new TypeError("Expected a string");
          return e.replace(/[|\\{}()[\]^$+*?.]/g, "\\$&").replace(/-/g, "\\x2d");
        }
        var s2 = Pe({ "node_modules/escape-string-regexp/index.js"() {
          I();
        } }), c2 = S({ "src/utils/get-last.js"(e, r) {
          "use strict";
          I();
          var u = (t) => t[t.length - 1];
          r.exports = u;
        } }), Zi = S({ "node_modules/semver/internal/debug.js"(e, r) {
          I();
          var u = typeof Ze == "object" && Ze.env && Ze.env.NODE_DEBUG && /\bsemver\b/i.test(Ze.env.NODE_DEBUG) ? function() {
            for (var t = arguments.length, o = new Array(t), n = 0; n < t; n++) o[n] = arguments[n];
            return console.error("SEMVER", ...o);
          } : () => {
          };
          r.exports = u;
        } }), Qi = S({ "node_modules/semver/internal/constants.js"(e, r) {
          I();
          var u = "2.0.0", t = 256, o = Number.MAX_SAFE_INTEGER || 9007199254740991, n = 16;
          r.exports = { SEMVER_SPEC_VERSION: u, MAX_LENGTH: t, MAX_SAFE_INTEGER: o, MAX_SAFE_COMPONENT_LENGTH: n };
        } }), l2 = S({ "node_modules/semver/internal/re.js"(e, r) {
          I();
          var { MAX_SAFE_COMPONENT_LENGTH: u } = Qi(), t = Zi();
          e = r.exports = {};
          var o = e.re = [], n = e.src = [], s = e.t = {}, c = 0, i = (D, a, l) => {
            let p = c++;
            t(D, p, a), s[D] = p, n[p] = a, o[p] = new RegExp(a, l ? "g" : void 0);
          };
          i("NUMERICIDENTIFIER", "0|[1-9]\\d*"), i("NUMERICIDENTIFIERLOOSE", "[0-9]+"), i("NONNUMERICIDENTIFIER", "\\d*[a-zA-Z-][a-zA-Z0-9-]*"), i("MAINVERSION", "(".concat(n[s.NUMERICIDENTIFIER], ")\\.(").concat(n[s.NUMERICIDENTIFIER], ")\\.(").concat(n[s.NUMERICIDENTIFIER], ")")), i("MAINVERSIONLOOSE", "(".concat(n[s.NUMERICIDENTIFIERLOOSE], ")\\.(").concat(n[s.NUMERICIDENTIFIERLOOSE], ")\\.(").concat(n[s.NUMERICIDENTIFIERLOOSE], ")")), i("PRERELEASEIDENTIFIER", "(?:".concat(n[s.NUMERICIDENTIFIER], "|").concat(n[s.NONNUMERICIDENTIFIER], ")")), i("PRERELEASEIDENTIFIERLOOSE", "(?:".concat(n[s.NUMERICIDENTIFIERLOOSE], "|").concat(n[s.NONNUMERICIDENTIFIER], ")")), i("PRERELEASE", "(?:-(".concat(n[s.PRERELEASEIDENTIFIER], "(?:\\.").concat(n[s.PRERELEASEIDENTIFIER], ")*))")), i("PRERELEASELOOSE", "(?:-?(".concat(n[s.PRERELEASEIDENTIFIERLOOSE], "(?:\\.").concat(n[s.PRERELEASEIDENTIFIERLOOSE], ")*))")), i("BUILDIDENTIFIER", "[0-9A-Za-z-]+"), i("BUILD", "(?:\\+(".concat(n[s.BUILDIDENTIFIER], "(?:\\.").concat(n[s.BUILDIDENTIFIER], ")*))")), i("FULLPLAIN", "v?".concat(n[s.MAINVERSION]).concat(n[s.PRERELEASE], "?").concat(n[s.BUILD], "?")), i("FULL", "^".concat(n[s.FULLPLAIN], "$")), i("LOOSEPLAIN", "[v=\\s]*".concat(n[s.MAINVERSIONLOOSE]).concat(n[s.PRERELEASELOOSE], "?").concat(n[s.BUILD], "?")), i("LOOSE", "^".concat(n[s.LOOSEPLAIN], "$")), i("GTLT", "((?:<|>)?=?)"), i("XRANGEIDENTIFIERLOOSE", "".concat(n[s.NUMERICIDENTIFIERLOOSE], "|x|X|\\*")), i("XRANGEIDENTIFIER", "".concat(n[s.NUMERICIDENTIFIER], "|x|X|\\*")), i("XRANGEPLAIN", "[v=\\s]*(".concat(n[s.XRANGEIDENTIFIER], ")(?:\\.(").concat(n[s.XRANGEIDENTIFIER], ")(?:\\.(").concat(n[s.XRANGEIDENTIFIER], ")(?:").concat(n[s.PRERELEASE], ")?").concat(n[s.BUILD], "?)?)?")), i("XRANGEPLAINLOOSE", "[v=\\s]*(".concat(n[s.XRANGEIDENTIFIERLOOSE], ")(?:\\.(").concat(n[s.XRANGEIDENTIFIERLOOSE], ")(?:\\.(").concat(n[s.XRANGEIDENTIFIERLOOSE], ")(?:").concat(n[s.PRERELEASELOOSE], ")?").concat(n[s.BUILD], "?)?)?")), i("XRANGE", "^".concat(n[s.GTLT], "\\s*").concat(n[s.XRANGEPLAIN], "$")), i("XRANGELOOSE", "^".concat(n[s.GTLT], "\\s*").concat(n[s.XRANGEPLAINLOOSE], "$")), i("COERCE", "(^|[^\\d])(\\d{1,".concat(u, "})(?:\\.(\\d{1,").concat(u, "}))?(?:\\.(\\d{1,").concat(u, "}))?(?:$|[^\\d])")), i("COERCERTL", n[s.COERCE], true), i("LONETILDE", "(?:~>?)"), i("TILDETRIM", "(\\s*)".concat(n[s.LONETILDE], "\\s+"), true), e.tildeTrimReplace = "$1~", i("TILDE", "^".concat(n[s.LONETILDE]).concat(n[s.XRANGEPLAIN], "$")), i("TILDELOOSE", "^".concat(n[s.LONETILDE]).concat(n[s.XRANGEPLAINLOOSE], "$")), i("LONECARET", "(?:\\^)"), i("CARETTRIM", "(\\s*)".concat(n[s.LONECARET], "\\s+"), true), e.caretTrimReplace = "$1^", i("CARET", "^".concat(n[s.LONECARET]).concat(n[s.XRANGEPLAIN], "$")), i("CARETLOOSE", "^".concat(n[s.LONECARET]).concat(n[s.XRANGEPLAINLOOSE], "$")), i("COMPARATORLOOSE", "^".concat(n[s.GTLT], "\\s*(").concat(n[s.LOOSEPLAIN], ")$|^$")), i("COMPARATOR", "^".concat(n[s.GTLT], "\\s*(").concat(n[s.FULLPLAIN], ")$|^$")), i("COMPARATORTRIM", "(\\s*)".concat(n[s.GTLT], "\\s*(").concat(n[s.LOOSEPLAIN], "|").concat(n[s.XRANGEPLAIN], ")"), true), e.comparatorTrimReplace = "$1$2$3", i("HYPHENRANGE", "^\\s*(".concat(n[s.XRANGEPLAIN], ")\\s+-\\s+(").concat(n[s.XRANGEPLAIN], ")\\s*$")), i("HYPHENRANGELOOSE", "^\\s*(".concat(n[s.XRANGEPLAINLOOSE], ")\\s+-\\s+(").concat(n[s.XRANGEPLAINLOOSE], ")\\s*$")), i("STAR", "(<|>)?=?\\s*\\*"), i("GTE0", "^\\s*>=\\s*0\\.0\\.0\\s*$"), i("GTE0PRE", "^\\s*>=\\s*0\\.0\\.0-0\\s*$");
        } }), D2 = S({ "node_modules/semver/internal/parse-options.js"(e, r) {
          I();
          var u = ["includePrerelease", "loose", "rtl"], t = (o) => o ? typeof o != "object" ? { loose: true } : u.filter((n) => o[n]).reduce((n, s) => (n[s] = true, n), {}) : {};
          r.exports = t;
        } }), f2 = S({ "node_modules/semver/internal/identifiers.js"(e, r) {
          I();
          var u = /^[0-9]+$/, t = (n, s) => {
            let c = u.test(n), i = u.test(s);
            return c && i && (n = +n, s = +s), n === s ? 0 : c && !i ? -1 : i && !c ? 1 : n < s ? -1 : 1;
          }, o = (n, s) => t(s, n);
          r.exports = { compareIdentifiers: t, rcompareIdentifiers: o };
        } }), p2 = S({ "node_modules/semver/classes/semver.js"(e, r) {
          I();
          var u = Zi(), { MAX_LENGTH: t, MAX_SAFE_INTEGER: o } = Qi(), { re: n, t: s } = l2(), c = D2(), { compareIdentifiers: i } = f2(), D = class {
            constructor(a, l) {
              if (l = c(l), a instanceof D) {
                if (a.loose === !!l.loose && a.includePrerelease === !!l.includePrerelease) return a;
                a = a.version;
              } else if (typeof a != "string") throw new TypeError("Invalid Version: ".concat(a));
              if (a.length > t) throw new TypeError("version is longer than ".concat(t, " characters"));
              u("SemVer", a, l), this.options = l, this.loose = !!l.loose, this.includePrerelease = !!l.includePrerelease;
              let p = a.trim().match(l.loose ? n[s.LOOSE] : n[s.FULL]);
              if (!p) throw new TypeError("Invalid Version: ".concat(a));
              if (this.raw = a, this.major = +p[1], this.minor = +p[2], this.patch = +p[3], this.major > o || this.major < 0) throw new TypeError("Invalid major version");
              if (this.minor > o || this.minor < 0) throw new TypeError("Invalid minor version");
              if (this.patch > o || this.patch < 0) throw new TypeError("Invalid patch version");
              p[4] ? this.prerelease = p[4].split(".").map((d) => {
                if (/^[0-9]+$/.test(d)) {
                  let g = +d;
                  if (g >= 0 && g < o) return g;
                }
                return d;
              }) : this.prerelease = [], this.build = p[5] ? p[5].split(".") : [], this.format();
            }
            format() {
              return this.version = "".concat(this.major, ".").concat(this.minor, ".").concat(this.patch), this.prerelease.length && (this.version += "-".concat(this.prerelease.join("."))), this.version;
            }
            toString() {
              return this.version;
            }
            compare(a) {
              if (u("SemVer.compare", this.version, this.options, a), !(a instanceof D)) {
                if (typeof a == "string" && a === this.version) return 0;
                a = new D(a, this.options);
              }
              return a.version === this.version ? 0 : this.compareMain(a) || this.comparePre(a);
            }
            compareMain(a) {
              return a instanceof D || (a = new D(a, this.options)), i(this.major, a.major) || i(this.minor, a.minor) || i(this.patch, a.patch);
            }
            comparePre(a) {
              if (a instanceof D || (a = new D(a, this.options)), this.prerelease.length && !a.prerelease.length) return -1;
              if (!this.prerelease.length && a.prerelease.length) return 1;
              if (!this.prerelease.length && !a.prerelease.length) return 0;
              let l = 0;
              do {
                let p = this.prerelease[l], d = a.prerelease[l];
                if (u("prerelease compare", l, p, d), p === void 0 && d === void 0) return 0;
                if (d === void 0) return 1;
                if (p === void 0) return -1;
                if (p === d) continue;
                return i(p, d);
              } while (++l);
            }
            compareBuild(a) {
              a instanceof D || (a = new D(a, this.options));
              let l = 0;
              do {
                let p = this.build[l], d = a.build[l];
                if (u("prerelease compare", l, p, d), p === void 0 && d === void 0) return 0;
                if (d === void 0) return 1;
                if (p === void 0) return -1;
                if (p === d) continue;
                return i(p, d);
              } while (++l);
            }
            inc(a, l) {
              switch (a) {
                case "premajor":
                  this.prerelease.length = 0, this.patch = 0, this.minor = 0, this.major++, this.inc("pre", l);
                  break;
                case "preminor":
                  this.prerelease.length = 0, this.patch = 0, this.minor++, this.inc("pre", l);
                  break;
                case "prepatch":
                  this.prerelease.length = 0, this.inc("patch", l), this.inc("pre", l);
                  break;
                case "prerelease":
                  this.prerelease.length === 0 && this.inc("patch", l), this.inc("pre", l);
                  break;
                case "major":
                  (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) && this.major++, this.minor = 0, this.patch = 0, this.prerelease = [];
                  break;
                case "minor":
                  (this.patch !== 0 || this.prerelease.length === 0) && this.minor++, this.patch = 0, this.prerelease = [];
                  break;
                case "patch":
                  this.prerelease.length === 0 && this.patch++, this.prerelease = [];
                  break;
                case "pre":
                  if (this.prerelease.length === 0) this.prerelease = [0];
                  else {
                    let p = this.prerelease.length;
                    for (; --p >= 0; ) typeof this.prerelease[p] == "number" && (this.prerelease[p]++, p = -2);
                    p === -1 && this.prerelease.push(0);
                  }
                  l && (i(this.prerelease[0], l) === 0 ? isNaN(this.prerelease[1]) && (this.prerelease = [l, 0]) : this.prerelease = [l, 0]);
                  break;
                default:
                  throw new Error("invalid increment argument: ".concat(a));
              }
              return this.format(), this.raw = this.version, this;
            }
          };
          r.exports = D;
        } }), vu = S({ "node_modules/semver/functions/compare.js"(e, r) {
          I();
          var u = p2(), t = (o, n, s) => new u(o, s).compare(new u(n, s));
          r.exports = t;
        } }), d2 = S({ "node_modules/semver/functions/lt.js"(e, r) {
          I();
          var u = vu(), t = (o, n, s) => u(o, n, s) < 0;
          r.exports = t;
        } }), h22 = S({ "node_modules/semver/functions/gte.js"(e, r) {
          I();
          var u = vu(), t = (o, n, s) => u(o, n, s) >= 0;
          r.exports = t;
        } }), v2 = S({ "src/utils/arrayify.js"(e, r) {
          "use strict";
          I(), r.exports = (u, t) => Object.entries(u).map((o) => {
            let [n, s] = o;
            return Object.assign({ [t]: n }, s);
          });
        } }), m2 = S({ "package.json"(e, r) {
          r.exports = { version: "2.7.1" };
        } }), E2 = S({ "node_modules/outdent/lib/index.js"(e, r) {
          "use strict";
          I(), Object.defineProperty(e, "__esModule", { value: true }), e.outdent = void 0;
          function u() {
            for (var f = [], b = 0; b < arguments.length; b++) f[b] = arguments[b];
          }
          function t() {
            return typeof WeakMap < "u" ? /* @__PURE__ */ new WeakMap() : o();
          }
          function o() {
            return { add: u, delete: u, get: u, set: u, has: function(f) {
              return false;
            } };
          }
          var n = Object.prototype.hasOwnProperty, s = function(f, b) {
            return n.call(f, b);
          };
          function c(f, b) {
            for (var v in b) s(b, v) && (f[v] = b[v]);
            return f;
          }
          var i = /^[ \t]*(?:\r\n|\r|\n)/, D = /(?:\r\n|\r|\n)[ \t]*$/, a = /^(?:[\r\n]|$)/, l = /(?:\r\n|\r|\n)([ \t]*)(?:[^ \t\r\n]|$)/, p = /^[ \t]*[\r\n][ \t\r\n]*$/;
          function d(f, b, v) {
            var h = 0, m = f[0].match(l);
            m && (h = m[1].length);
            var C = "(\\r\\n|\\r|\\n).{0," + h + "}", B = new RegExp(C, "g");
            b && (f = f.slice(1));
            var q = v.newline, L = v.trimLeadingNewline, w = v.trimTrailingNewline, O = typeof q == "string", T = f.length, P = f.map(function(A, j) {
              return A = A.replace(B, "$1"), j === 0 && L && (A = A.replace(i, "")), j === T - 1 && w && (A = A.replace(D, "")), O && (A = A.replace(/\r\n|\n|\r/g, function($) {
                return q;
              })), A;
            });
            return P;
          }
          function g(f, b) {
            for (var v = "", h = 0, m = f.length; h < m; h++) v += f[h], h < m - 1 && (v += b[h]);
            return v;
          }
          function F(f) {
            return s(f, "raw") && s(f, "length");
          }
          function E(f) {
            var b = t(), v = t();
            function h(C) {
              for (var B = [], q = 1; q < arguments.length; q++) B[q - 1] = arguments[q];
              if (F(C)) {
                var L = C, w = (B[0] === h || B[0] === x) && p.test(L[0]) && a.test(L[1]), O = w ? v : b, T = O.get(L);
                if (T || (T = d(L, w, f), O.set(L, T)), B.length === 0) return T[0];
                var P = g(T, w ? B.slice(1) : B);
                return P;
              } else return E(c(c({}, f), C || {}));
            }
            var m = c(h, { string: function(C) {
              return d([C], false, f)[0];
            } });
            return m;
          }
          var x = E({ trimLeadingNewline: true, trimTrailingNewline: true });
          if (e.outdent = x, e.default = x, typeof r < "u") try {
            r.exports = x, Object.defineProperty(x, "__esModule", { value: true }), x.default = x, x.outdent = x;
          } catch {
          }
        } }), C2 = S({ "src/main/core-options.js"(e, r) {
          "use strict";
          I();
          var { outdent: u } = E2(), t = "Config", o = "Editor", n = "Format", s = "Other", c = "Output", i = "Global", D = "Special", a = { cursorOffset: { since: "1.4.0", category: D, type: "int", default: -1, range: { start: -1, end: Number.POSITIVE_INFINITY, step: 1 }, description: u(yi || (yi = je([`
      Print (to stderr) where a cursor at the given position would move to after formatting.
      This option cannot be used with --range-start and --range-end.
    `]))), cliCategory: o }, endOfLine: { since: "1.15.0", category: i, type: "choice", default: [{ since: "1.15.0", value: "auto" }, { since: "2.0.0", value: "lf" }], description: "Which end of line characters to apply.", choices: [{ value: "lf", description: "Line Feed only (\\n), common on Linux and macOS as well as inside git repos" }, { value: "crlf", description: "Carriage Return + Line Feed characters (\\r\\n), common on Windows" }, { value: "cr", description: "Carriage Return character only (\\r), used very rarely" }, { value: "auto", description: u(Bi || (Bi = je([`
          Maintain existing
          (mixed values within one file are normalised by looking at what's used after the first line)
        `]))) }] }, filepath: { since: "1.4.0", category: D, type: "path", description: "Specify the input filepath. This will be used to do parser inference.", cliName: "stdin-filepath", cliCategory: s, cliDescription: "Path to the file to pretend that stdin comes from." }, insertPragma: { since: "1.8.0", category: D, type: "boolean", default: false, description: "Insert @format pragma into file's first docblock comment.", cliCategory: s }, parser: { since: "0.0.10", category: i, type: "choice", default: [{ since: "0.0.10", value: "babylon" }, { since: "1.13.0", value: void 0 }], description: "Which parser to use.", exception: (l) => typeof l == "string" || typeof l == "function", choices: [{ value: "flow", description: "Flow" }, { value: "babel", since: "1.16.0", description: "JavaScript" }, { value: "babel-flow", since: "1.16.0", description: "Flow" }, { value: "babel-ts", since: "2.0.0", description: "TypeScript" }, { value: "typescript", since: "1.4.0", description: "TypeScript" }, { value: "acorn", since: "2.6.0", description: "JavaScript" }, { value: "espree", since: "2.2.0", description: "JavaScript" }, { value: "meriyah", since: "2.2.0", description: "JavaScript" }, { value: "css", since: "1.7.1", description: "CSS" }, { value: "less", since: "1.7.1", description: "Less" }, { value: "scss", since: "1.7.1", description: "SCSS" }, { value: "json", since: "1.5.0", description: "JSON" }, { value: "json5", since: "1.13.0", description: "JSON5" }, { value: "json-stringify", since: "1.13.0", description: "JSON.stringify" }, { value: "graphql", since: "1.5.0", description: "GraphQL" }, { value: "markdown", since: "1.8.0", description: "Markdown" }, { value: "mdx", since: "1.15.0", description: "MDX" }, { value: "vue", since: "1.10.0", description: "Vue" }, { value: "yaml", since: "1.14.0", description: "YAML" }, { value: "glimmer", since: "2.3.0", description: "Ember / Handlebars" }, { value: "html", since: "1.15.0", description: "HTML" }, { value: "angular", since: "1.15.0", description: "Angular" }, { value: "lwc", since: "1.17.0", description: "Lightning Web Components" }] }, plugins: { since: "1.10.0", type: "path", array: true, default: [{ value: [] }], category: i, description: "Add a plugin. Multiple plugins can be passed as separate `--plugin`s.", exception: (l) => typeof l == "string" || typeof l == "object", cliName: "plugin", cliCategory: t }, pluginSearchDirs: { since: "1.13.0", type: "path", array: true, default: [{ value: [] }], category: i, description: u(wi || (wi = je([`
      Custom directory that contains prettier plugins in node_modules subdirectory.
      Overrides default behavior when plugins are searched relatively to the location of Prettier.
      Multiple values are accepted.
    `]))), exception: (l) => typeof l == "string" || typeof l == "object", cliName: "plugin-search-dir", cliCategory: t }, printWidth: { since: "0.0.0", category: i, type: "int", default: 80, description: "The line length where Prettier will try wrap.", range: { start: 0, end: Number.POSITIVE_INFINITY, step: 1 } }, rangeEnd: { since: "1.4.0", category: D, type: "int", default: Number.POSITIVE_INFINITY, range: { start: 0, end: Number.POSITIVE_INFINITY, step: 1 }, description: u(ki || (ki = je([`
      Format code ending at a given character offset (exclusive).
      The range will extend forwards to the end of the selected statement.
      This option cannot be used with --cursor-offset.
    `]))), cliCategory: o }, rangeStart: { since: "1.4.0", category: D, type: "int", default: 0, range: { start: 0, end: Number.POSITIVE_INFINITY, step: 1 }, description: u(qi || (qi = je([`
      Format code starting at a given character offset.
      The range will extend backwards to the start of the first line containing the selected statement.
      This option cannot be used with --cursor-offset.
    `]))), cliCategory: o }, requirePragma: { since: "1.7.0", category: D, type: "boolean", default: false, description: u(_i || (_i = je([`
      Require either '@prettier' or '@format' to be present in the file's first docblock comment
      in order for it to be formatted.
    `]))), cliCategory: s }, tabWidth: { type: "int", category: i, default: 2, description: "Number of spaces per indentation level.", range: { start: 0, end: Number.POSITIVE_INFINITY, step: 1 } }, useTabs: { since: "1.0.0", category: i, type: "boolean", default: false, description: "Indent with tabs instead of spaces." }, embeddedLanguageFormatting: { since: "2.1.0", category: i, type: "choice", default: [{ since: "2.1.0", value: "auto" }], description: "Control how Prettier formats quoted code embedded in the file.", choices: [{ value: "auto", description: "Format embedded code if Prettier can automatically identify it." }, { value: "off", description: "Never automatically format embedded code." }] } };
          r.exports = { CATEGORY_CONFIG: t, CATEGORY_EDITOR: o, CATEGORY_FORMAT: n, CATEGORY_OTHER: s, CATEGORY_OUTPUT: c, CATEGORY_GLOBAL: i, CATEGORY_SPECIAL: D, options: a };
        } }), g2 = S({ "src/main/support.js"(e, r) {
          "use strict";
          I();
          var u = { compare: vu(), lt: d2(), gte: h22() }, t = v2(), o = m2().version, n = C2().options;
          function s() {
            let { plugins: i = [], showUnreleased: D = false, showDeprecated: a = false, showInternal: l = false } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, p = o.split("-", 1)[0], d = i.flatMap((f) => f.languages || []).filter(F), g = t(Object.assign({}, ...i.map((f) => {
              let { options: b } = f;
              return b;
            }), n), "name").filter((f) => F(f) && E(f)).sort((f, b) => f.name === b.name ? 0 : f.name < b.name ? -1 : 1).map(x).map((f) => {
              f = Object.assign({}, f), Array.isArray(f.default) && (f.default = f.default.length === 1 ? f.default[0].value : f.default.filter(F).sort((v, h) => u.compare(h.since, v.since))[0].value), Array.isArray(f.choices) && (f.choices = f.choices.filter((v) => F(v) && E(v)), f.name === "parser" && c(f, d, i));
              let b = Object.fromEntries(i.filter((v) => v.defaultOptions && v.defaultOptions[f.name] !== void 0).map((v) => [v.name, v.defaultOptions[f.name]]));
              return Object.assign(Object.assign({}, f), {}, { pluginDefaults: b });
            });
            return { languages: d, options: g };
            function F(f) {
              return D || !("since" in f) || f.since && u.gte(p, f.since);
            }
            function E(f) {
              return a || !("deprecated" in f) || f.deprecated && u.lt(p, f.deprecated);
            }
            function x(f) {
              if (l) return f;
              let { cliName: b, cliCategory: v, cliDescription: h } = f;
              return ql(f, kl);
            }
          }
          function c(i, D, a) {
            let l = new Set(i.choices.map((p) => p.value));
            for (let p of D) if (p.parsers) {
              for (let d of p.parsers) if (!l.has(d)) {
                l.add(d);
                let g = a.find((E) => E.parsers && E.parsers[d]), F = p.name;
                g && g.name && (F += " (plugin: ".concat(g.name, ")")), i.choices.push({ value: d, description: F });
              }
            }
          }
          r.exports = { getSupportInfo: s };
        } }), F2 = S({ "src/utils/is-non-empty-array.js"(e, r) {
          "use strict";
          I();
          function u(t) {
            return Array.isArray(t) && t.length > 0;
          }
          r.exports = u;
        } });
        function A2() {
          let { onlyFirst: e = false } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, r = ["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)", "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"].join("|");
          return new RegExp(r, e ? void 0 : "g");
        }
        var x2 = Pe({ "node_modules/strip-ansi/node_modules/ansi-regex/index.js"() {
          I();
        } });
        function b2(e) {
          if (typeof e != "string") throw new TypeError("Expected a `string`, got `".concat(typeof e, "`"));
          return e.replace(A2(), "");
        }
        var y2 = Pe({ "node_modules/strip-ansi/index.js"() {
          I(), x2();
        } });
        function B2(e) {
          return Number.isInteger(e) ? e >= 4352 && (e <= 4447 || e === 9001 || e === 9002 || 11904 <= e && e <= 12871 && e !== 12351 || 12880 <= e && e <= 19903 || 19968 <= e && e <= 42182 || 43360 <= e && e <= 43388 || 44032 <= e && e <= 55203 || 63744 <= e && e <= 64255 || 65040 <= e && e <= 65049 || 65072 <= e && e <= 65131 || 65281 <= e && e <= 65376 || 65504 <= e && e <= 65510 || 110592 <= e && e <= 110593 || 127488 <= e && e <= 127569 || 131072 <= e && e <= 262141) : false;
        }
        var w2 = Pe({ "node_modules/is-fullwidth-code-point/index.js"() {
          I();
        } }), k2 = S({ "node_modules/emoji-regex/index.js"(e, r) {
          "use strict";
          I(), r.exports = function() {
            return /\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67)\uDB40\uDC7F|(?:\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFE])|(?:\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFC-\uDFFF])|\uD83D\uDC68(?:\uD83C\uDFFB(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFC-\uDFFF])|[\u2695\u2696\u2708]\uFE0F|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))?|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFE])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])\uFE0F|\u200D(?:(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D[\uDC66\uDC67])|\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC)?|(?:\uD83D\uDC69(?:\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69]))|\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1)(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC69(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83E\uDDD1(?:\u200D(?:\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D\uDC69\u200D\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83E\uDDD1(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDC69(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDE36\u200D\uD83C\uDF2B|\uD83C\uDFF3\uFE0F\u200D\u26A7|\uD83D\uDC3B\u200D\u2744|(?:(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF])\u200D[\u2640\u2642]|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\uD83C\uDFF4\u200D\u2620|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])\u200D[\u2640\u2642]|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u2600-\u2604\u260E\u2611\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26B0\u26B1\u26C8\u26CF\u26D1\u26D3\u26E9\u26F0\u26F1\u26F4\u26F7\u26F8\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u3030\u303D\u3297\u3299]|\uD83C[\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]|\uD83D[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3])\uFE0F|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC69\u200D\uD83D\uDC67|\uD83D\uDC69\u200D\uD83D\uDC66|\uD83D\uDE35\u200D\uD83D\uDCAB|\uD83D\uDE2E\u200D\uD83D\uDCA8|\uD83D\uDC15\u200D\uD83E\uDDBA|\uD83E\uDDD1(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83D\uDC69(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDF6\uD83C\uDDE6|\uD83C\uDDF4\uD83C\uDDF2|\uD83D\uDC08\u200D\u2B1B|\u2764\uFE0F\u200D(?:\uD83D\uDD25|\uD83E\uDE79)|\uD83D\uDC41\uFE0F|\uD83C\uDFF3\uFE0F|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|[#\*0-9]\uFE0F\u20E3|\u2764\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|\uD83C\uDFF4|(?:[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u261D\u270C\u270D]|\uD83D[\uDD74\uDD90])(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC08\uDC15\uDC3B\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE2E\uDE35\uDE36\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5]|\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD]|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF]|[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0D\uDD0E\uDD10-\uDD17\uDD1D\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78\uDD7A-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCB\uDDD0\uDDE0-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6]|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26A7\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDED5-\uDED7\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])\uFE0F|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDC8F\uDC91\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1F\uDD26\uDD30-\uDD39\uDD3C-\uDD3E\uDD77\uDDB5\uDDB6\uDDB8\uDDB9\uDDBB\uDDCD-\uDDCF\uDDD1-\uDDDD])/g;
          };
        } }), ea = {};
        Li(ea, { default: () => q2 });
        function q2(e) {
          if (typeof e != "string" || e.length === 0 || (e = b2(e), e.length === 0)) return 0;
          e = e.replace((0, ra.default)(), "  ");
          let r = 0;
          for (let u = 0; u < e.length; u++) {
            let t = e.codePointAt(u);
            t <= 31 || t >= 127 && t <= 159 || t >= 768 && t <= 879 || (t > 65535 && u++, r += B2(t) ? 2 : 1);
          }
          return r;
        }
        var ra, _2 = Pe({ "node_modules/string-width/index.js"() {
          I(), y2(), w2(), ra = Nl(k2());
        } }), O2 = S({ "src/utils/get-string-width.js"(e, r) {
          "use strict";
          I();
          var u = (_2(), ji(ea)).default, t = /[^\x20-\x7F]/;
          function o(n) {
            return n ? t.test(n) ? u(n) : n.length : 0;
          }
          r.exports = o;
        } }), mu = S({ "src/utils/text/skip.js"(e, r) {
          "use strict";
          I();
          function u(c) {
            return (i, D, a) => {
              let l = a && a.backwards;
              if (D === false) return false;
              let { length: p } = i, d = D;
              for (; d >= 0 && d < p; ) {
                let g = i.charAt(d);
                if (c instanceof RegExp) {
                  if (!c.test(g)) return d;
                } else if (!c.includes(g)) return d;
                l ? d-- : d++;
              }
              return d === -1 || d === p ? d : false;
            };
          }
          var t = u(/\s/), o = u(" 	"), n = u(",; 	"), s = u(/[^\n\r]/);
          r.exports = { skipWhitespace: t, skipSpaces: o, skipToLineEnd: n, skipEverythingButNewLine: s };
        } }), ua = S({ "src/utils/text/skip-inline-comment.js"(e, r) {
          "use strict";
          I();
          function u(t, o) {
            if (o === false) return false;
            if (t.charAt(o) === "/" && t.charAt(o + 1) === "*") {
              for (let n = o + 2; n < t.length; ++n) if (t.charAt(n) === "*" && t.charAt(n + 1) === "/") return n + 2;
            }
            return o;
          }
          r.exports = u;
        } }), ta = S({ "src/utils/text/skip-trailing-comment.js"(e, r) {
          "use strict";
          I();
          var { skipEverythingButNewLine: u } = mu();
          function t(o, n) {
            return n === false ? false : o.charAt(n) === "/" && o.charAt(n + 1) === "/" ? u(o, n) : n;
          }
          r.exports = t;
        } }), na = S({ "src/utils/text/skip-newline.js"(e, r) {
          "use strict";
          I();
          function u(t, o, n) {
            let s = n && n.backwards;
            if (o === false) return false;
            let c = t.charAt(o);
            if (s) {
              if (t.charAt(o - 1) === "\r" && c === `
`) return o - 2;
              if (c === `
` || c === "\r" || c === "\u2028" || c === "\u2029") return o - 1;
            } else {
              if (c === "\r" && t.charAt(o + 1) === `
`) return o + 2;
              if (c === `
` || c === "\r" || c === "\u2028" || c === "\u2029") return o + 1;
            }
            return o;
          }
          r.exports = u;
        } }), I2 = S({ "src/utils/text/get-next-non-space-non-comment-character-index-with-start-index.js"(e, r) {
          "use strict";
          I();
          var u = ua(), t = na(), o = ta(), { skipSpaces: n } = mu();
          function s(c, i) {
            let D = null, a = i;
            for (; a !== D; ) D = a, a = n(c, a), a = u(c, a), a = o(c, a), a = t(c, a);
            return a;
          }
          r.exports = s;
        } }), S2 = S({ "src/common/util.js"(e, r) {
          "use strict";
          I();
          var { default: u } = (s2(), ji(Ji)), t = c2(), { getSupportInfo: o } = g2(), n = F2(), s = O2(), { skipWhitespace: c, skipSpaces: i, skipToLineEnd: D, skipEverythingButNewLine: a } = mu(), l = ua(), p = ta(), d = na(), g = I2(), F = (k) => k[k.length - 2];
          function E(k) {
            return (y, _, N) => {
              let V = N && N.backwards;
              if (_ === false) return false;
              let { length: W } = y, K = _;
              for (; K >= 0 && K < W; ) {
                let ee = y.charAt(K);
                if (k instanceof RegExp) {
                  if (!k.test(ee)) return K;
                } else if (!k.includes(ee)) return K;
                V ? K-- : K++;
              }
              return K === -1 || K === W ? K : false;
            };
          }
          function x(k, y) {
            let _ = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, N = i(k, _.backwards ? y - 1 : y, _), V = d(k, N, _);
            return N !== V;
          }
          function f(k, y, _) {
            for (let N = y; N < _; ++N) if (k.charAt(N) === `
`) return true;
            return false;
          }
          function b(k, y, _) {
            let N = _(y) - 1;
            N = i(k, N, { backwards: true }), N = d(k, N, { backwards: true }), N = i(k, N, { backwards: true });
            let V = d(k, N, { backwards: true });
            return N !== V;
          }
          function v(k, y) {
            let _ = null, N = y;
            for (; N !== _; ) _ = N, N = D(k, N), N = l(k, N), N = i(k, N);
            return N = p(k, N), N = d(k, N), N !== false && x(k, N);
          }
          function h(k, y, _) {
            return v(k, _(y));
          }
          function m(k, y, _) {
            return g(k, _(y));
          }
          function C(k, y, _) {
            return k.charAt(m(k, y, _));
          }
          function B(k, y) {
            let _ = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
            return i(k, _.backwards ? y - 1 : y, _) !== y;
          }
          function q(k, y) {
            let _ = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0, N = 0;
            for (let V = _; V < k.length; ++V) k[V] === "	" ? N = N + y - N % y : N++;
            return N;
          }
          function L(k, y) {
            let _ = k.lastIndexOf(`
`);
            return _ === -1 ? 0 : q(k.slice(_ + 1).match(/^[\t ]*/)[0], y);
          }
          function w(k, y) {
            let _ = { quote: '"', regex: /"/g, escaped: "&quot;" }, N = { quote: "'", regex: /'/g, escaped: "&apos;" }, V = y === "'" ? N : _, W = V === N ? _ : N, K = V;
            if (k.includes(V.quote) || k.includes(W.quote)) {
              let ee = (k.match(V.regex) || []).length, Y = (k.match(W.regex) || []).length;
              K = ee > Y ? W : V;
            }
            return K;
          }
          function O(k, y) {
            let _ = k.slice(1, -1), N = y.parser === "json" || y.parser === "json5" && y.quoteProps === "preserve" && !y.singleQuote ? '"' : y.__isInHtmlAttribute ? "'" : w(_, y.singleQuote ? "'" : '"').quote;
            return T(_, N, !(y.parser === "css" || y.parser === "less" || y.parser === "scss" || y.__embeddedInHtml));
          }
          function T(k, y, _) {
            let N = y === '"' ? "'" : '"', V = /\\(.)|(["'])/gs, W = k.replace(V, (K, ee, Y) => ee === N ? ee : Y === y ? "\\" + Y : Y || (_ && /^[^\n\r"'0-7\\bfnrt-vx\u2028\u2029]$/.test(ee) ? ee : "\\" + ee));
            return y + W + y;
          }
          function P(k) {
            return k.toLowerCase().replace(/^([+-]?[\d.]+e)(?:\+|(-))?0*(\d)/, "$1$2$3").replace(/^([+-]?[\d.]+)e[+-]?0+$/, "$1").replace(/^([+-])?\./, "$10.").replace(/(\.\d+?)0+(?=e|$)/, "$1").replace(/\.(?=e|$)/, "");
          }
          function A(k, y) {
            let _ = k.match(new RegExp("(".concat(u(y), ")+"), "g"));
            return _ === null ? 0 : _.reduce((N, V) => Math.max(N, V.length / y.length), 0);
          }
          function j(k, y) {
            let _ = k.match(new RegExp("(".concat(u(y), ")+"), "g"));
            if (_ === null) return 0;
            let N = /* @__PURE__ */ new Map(), V = 0;
            for (let W of _) {
              let K = W.length / y.length;
              N.set(K, true), K > V && (V = K);
            }
            for (let W = 1; W < V; W++) if (!N.get(W)) return W;
            return V + 1;
          }
          function $(k, y) {
            (k.comments || (k.comments = [])).push(y), y.printed = false, y.nodeDescription = G(k);
          }
          function U(k, y) {
            y.leading = true, y.trailing = false, $(k, y);
          }
          function X(k, y, _) {
            y.leading = false, y.trailing = false, _ && (y.marker = _), $(k, y);
          }
          function R(k, y) {
            y.leading = false, y.trailing = true, $(k, y);
          }
          function J(k, y) {
            let { languages: _ } = o({ plugins: y.plugins }), N = _.find((V) => {
              let { name: W } = V;
              return W.toLowerCase() === k;
            }) || _.find((V) => {
              let { aliases: W } = V;
              return Array.isArray(W) && W.includes(k);
            }) || _.find((V) => {
              let { extensions: W } = V;
              return Array.isArray(W) && W.includes(".".concat(k));
            });
            return N && N.parsers[0];
          }
          function z3(k) {
            return k && k.type === "front-matter";
          }
          function M(k) {
            let y = /* @__PURE__ */ new WeakMap();
            return function(_) {
              return y.has(_) || y.set(_, Symbol(k)), y.get(_);
            };
          }
          function G(k) {
            let y = k.type || k.kind || "(unknown type)", _ = String(k.name || k.id && (typeof k.id == "object" ? k.id.name : k.id) || k.key && (typeof k.key == "object" ? k.key.name : k.key) || k.value && (typeof k.value == "object" ? "" : String(k.value)) || k.operator || "");
            return _.length > 20 && (_ = _.slice(0, 19) + "\u2026"), y + (_ ? " " + _ : "");
          }
          r.exports = { inferParserByLanguage: J, getStringWidth: s, getMaxContinuousCount: A, getMinNotPresentContinuousCount: j, getPenultimate: F, getLast: t, getNextNonSpaceNonCommentCharacterIndexWithStartIndex: g, getNextNonSpaceNonCommentCharacterIndex: m, getNextNonSpaceNonCommentCharacter: C, skip: E, skipWhitespace: c, skipSpaces: i, skipToLineEnd: D, skipEverythingButNewLine: a, skipInlineComment: l, skipTrailingComment: p, skipNewline: d, isNextLineEmptyAfterIndex: v, isNextLineEmpty: h, isPreviousLineEmpty: b, hasNewline: x, hasNewlineInRange: f, hasSpaces: B, getAlignmentSize: q, getIndentSize: L, getPreferredQuote: w, printString: O, printNumber: P, makeString: T, addLeadingComment: U, addDanglingComment: X, addTrailingComment: R, isFrontMatterNode: z3, isNonEmptyArray: n, createGroupIdMapper: M };
        } }), T2 = S({ "src/language-markdown/constants.evaluate.js"(e, r) {
          r.exports = { cjkPattern: "(?:[\\u02ea-\\u02eb\\u1100-\\u11ff\\u2e80-\\u2e99\\u2e9b-\\u2ef3\\u2f00-\\u2fd5\\u2ff0-\\u303f\\u3041-\\u3096\\u3099-\\u309f\\u30a1-\\u30fa\\u30fc-\\u30ff\\u3105-\\u312f\\u3131-\\u318e\\u3190-\\u3191\\u3196-\\u31ba\\u31c0-\\u31e3\\u31f0-\\u321e\\u322a-\\u3247\\u3260-\\u327e\\u328a-\\u32b0\\u32c0-\\u32cb\\u32d0-\\u3370\\u337b-\\u337f\\u33e0-\\u33fe\\u3400-\\u4db5\\u4e00-\\u9fef\\ua960-\\ua97c\\uac00-\\ud7a3\\ud7b0-\\ud7c6\\ud7cb-\\ud7fb\\uf900-\\ufa6d\\ufa70-\\ufad9\\ufe10-\\ufe1f\\ufe30-\\ufe6f\\uff00-\\uffef]|[\\ud840-\\ud868\\ud86a-\\ud86c\\ud86f-\\ud872\\ud874-\\ud879][\\udc00-\\udfff]|\\ud82c[\\udc00-\\udd1e\\udd50-\\udd52\\udd64-\\udd67]|\\ud83c[\\ude00\\ude50-\\ude51]|\\ud869[\\udc00-\\uded6\\udf00-\\udfff]|\\ud86d[\\udc00-\\udf34\\udf40-\\udfff]|\\ud86e[\\udc00-\\udc1d\\udc20-\\udfff]|\\ud873[\\udc00-\\udea1\\udeb0-\\udfff]|\\ud87a[\\udc00-\\udfe0]|\\ud87e[\\udc00-\\ude1d])(?:[\\ufe00-\\ufe0f]|\\udb40[\\udd00-\\uddef])?", kPattern: "[\\u1100-\\u11ff\\u3001-\\u3003\\u3008-\\u3011\\u3013-\\u301f\\u302e-\\u3030\\u3037\\u30fb\\u3131-\\u318e\\u3200-\\u321e\\u3260-\\u327e\\ua960-\\ua97c\\uac00-\\ud7a3\\ud7b0-\\ud7c6\\ud7cb-\\ud7fb\\ufe45-\\ufe46\\uff61-\\uff65\\uffa0-\\uffbe\\uffc2-\\uffc7\\uffca-\\uffcf\\uffd2-\\uffd7\\uffda-\\uffdc]", punctuationPattern: "[\\u0021-\\u002f\\u003a-\\u0040\\u005b-\\u0060\\u007b-\\u007e\\u00a1\\u00a7\\u00ab\\u00b6-\\u00b7\\u00bb\\u00bf\\u037e\\u0387\\u055a-\\u055f\\u0589-\\u058a\\u05be\\u05c0\\u05c3\\u05c6\\u05f3-\\u05f4\\u0609-\\u060a\\u060c-\\u060d\\u061b\\u061e-\\u061f\\u066a-\\u066d\\u06d4\\u0700-\\u070d\\u07f7-\\u07f9\\u0830-\\u083e\\u085e\\u0964-\\u0965\\u0970\\u09fd\\u0a76\\u0af0\\u0c77\\u0c84\\u0df4\\u0e4f\\u0e5a-\\u0e5b\\u0f04-\\u0f12\\u0f14\\u0f3a-\\u0f3d\\u0f85\\u0fd0-\\u0fd4\\u0fd9-\\u0fda\\u104a-\\u104f\\u10fb\\u1360-\\u1368\\u1400\\u166e\\u169b-\\u169c\\u16eb-\\u16ed\\u1735-\\u1736\\u17d4-\\u17d6\\u17d8-\\u17da\\u1800-\\u180a\\u1944-\\u1945\\u1a1e-\\u1a1f\\u1aa0-\\u1aa6\\u1aa8-\\u1aad\\u1b5a-\\u1b60\\u1bfc-\\u1bff\\u1c3b-\\u1c3f\\u1c7e-\\u1c7f\\u1cc0-\\u1cc7\\u1cd3\\u2010-\\u2027\\u2030-\\u2043\\u2045-\\u2051\\u2053-\\u205e\\u207d-\\u207e\\u208d-\\u208e\\u2308-\\u230b\\u2329-\\u232a\\u2768-\\u2775\\u27c5-\\u27c6\\u27e6-\\u27ef\\u2983-\\u2998\\u29d8-\\u29db\\u29fc-\\u29fd\\u2cf9-\\u2cfc\\u2cfe-\\u2cff\\u2d70\\u2e00-\\u2e2e\\u2e30-\\u2e4f\\u3001-\\u3003\\u3008-\\u3011\\u3014-\\u301f\\u3030\\u303d\\u30a0\\u30fb\\ua4fe-\\ua4ff\\ua60d-\\ua60f\\ua673\\ua67e\\ua6f2-\\ua6f7\\ua874-\\ua877\\ua8ce-\\ua8cf\\ua8f8-\\ua8fa\\ua8fc\\ua92e-\\ua92f\\ua95f\\ua9c1-\\ua9cd\\ua9de-\\ua9df\\uaa5c-\\uaa5f\\uaade-\\uaadf\\uaaf0-\\uaaf1\\uabeb\\ufd3e-\\ufd3f\\ufe10-\\ufe19\\ufe30-\\ufe52\\ufe54-\\ufe61\\ufe63\\ufe68\\ufe6a-\\ufe6b\\uff01-\\uff03\\uff05-\\uff0a\\uff0c-\\uff0f\\uff1a-\\uff1b\\uff1f-\\uff20\\uff3b-\\uff3d\\uff3f\\uff5b\\uff5d\\uff5f-\\uff65]|\\ud800[\\udd00-\\udd02\\udf9f\\udfd0]|\\ud801[\\udd6f]|\\ud802[\\udc57\\udd1f\\udd3f\\ude50-\\ude58\\ude7f\\udef0-\\udef6\\udf39-\\udf3f\\udf99-\\udf9c]|\\ud803[\\udf55-\\udf59]|\\ud804[\\udc47-\\udc4d\\udcbb-\\udcbc\\udcbe-\\udcc1\\udd40-\\udd43\\udd74-\\udd75\\uddc5-\\uddc8\\uddcd\\udddb\\udddd-\\udddf\\ude38-\\ude3d\\udea9]|\\ud805[\\udc4b-\\udc4f\\udc5b\\udc5d\\udcc6\\uddc1-\\uddd7\\ude41-\\ude43\\ude60-\\ude6c\\udf3c-\\udf3e]|\\ud806[\\udc3b\\udde2\\ude3f-\\ude46\\ude9a-\\ude9c\\ude9e-\\udea2]|\\ud807[\\udc41-\\udc45\\udc70-\\udc71\\udef7-\\udef8\\udfff]|\\ud809[\\udc70-\\udc74]|\\ud81a[\\ude6e-\\ude6f\\udef5\\udf37-\\udf3b\\udf44]|\\ud81b[\\ude97-\\ude9a\\udfe2]|\\ud82f[\\udc9f]|\\ud836[\\ude87-\\ude8b]|\\ud83a[\\udd5e-\\udd5f]" };
        } }), N2 = S({ "src/language-markdown/utils.js"(e, r) {
          "use strict";
          I();
          var { getLast: u } = S2(), { locStart: t, locEnd: o } = Ki(), { cjkPattern: n, kPattern: s, punctuationPattern: c } = T2(), i = ["liquidNode", "inlineCode", "emphasis", "esComment", "strong", "delete", "wikiLink", "link", "linkReference", "image", "imageReference", "footnote", "footnoteReference", "sentence", "whitespace", "word", "break", "inlineMath"], D = [...i, "tableCell", "paragraph", "heading"], a = new RegExp(s), l = new RegExp(c);
          function p(f, b) {
            let v = "non-cjk", h = "cj-letter", m = "k-letter", C = "cjk-punctuation", B = [], q = (b.proseWrap === "preserve" ? f : f.replace(new RegExp("(".concat(n, `)
(`).concat(n, ")"), "g"), "$1$2")).split(/([\t\n ]+)/);
            for (let [w, O] of q.entries()) {
              if (w % 2 === 1) {
                B.push({ type: "whitespace", value: /\n/.test(O) ? `
` : " " });
                continue;
              }
              if ((w === 0 || w === q.length - 1) && O === "") continue;
              let T = O.split(new RegExp("(".concat(n, ")")));
              for (let [P, A] of T.entries()) if (!((P === 0 || P === T.length - 1) && A === "")) {
                if (P % 2 === 0) {
                  A !== "" && L({ type: "word", value: A, kind: v, hasLeadingPunctuation: l.test(A[0]), hasTrailingPunctuation: l.test(u(A)) });
                  continue;
                }
                L(l.test(A) ? { type: "word", value: A, kind: C, hasLeadingPunctuation: true, hasTrailingPunctuation: true } : { type: "word", value: A, kind: a.test(A) ? m : h, hasLeadingPunctuation: false, hasTrailingPunctuation: false });
              }
            }
            return B;
            function L(w) {
              let O = u(B);
              O && O.type === "word" && (O.kind === v && w.kind === h && !O.hasTrailingPunctuation || O.kind === h && w.kind === v && !w.hasLeadingPunctuation ? B.push({ type: "whitespace", value: " " }) : !T(v, C) && ![O.value, w.value].some((P) => /\u3000/.test(P)) && B.push({ type: "whitespace", value: "" })), B.push(w);
              function T(P, A) {
                return O.kind === P && w.kind === A || O.kind === A && w.kind === P;
              }
            }
          }
          function d(f, b) {
            let [, v, h, m] = b.slice(f.position.start.offset, f.position.end.offset).match(/^\s*(\d+)(\.|\))(\s*)/);
            return { numberText: v, marker: h, leadingSpaces: m };
          }
          function g(f, b) {
            if (!f.ordered || f.children.length < 2) return false;
            let v = Number(d(f.children[0], b.originalText).numberText), h = Number(d(f.children[1], b.originalText).numberText);
            if (v === 0 && f.children.length > 2) {
              let m = Number(d(f.children[2], b.originalText).numberText);
              return h === 1 && m === 1;
            }
            return h === 1;
          }
          function F(f, b) {
            let { value: v } = f;
            return f.position.end.offset === b.length && v.endsWith(`
`) && b.endsWith(`
`) ? v.slice(0, -1) : v;
          }
          function E(f, b) {
            return function v(h, m, C) {
              let B = Object.assign({}, b(h, m, C));
              return B.children && (B.children = B.children.map((q, L) => v(q, L, [B, ...C]))), B;
            }(f, null, []);
          }
          function x(f) {
            if ((f == null ? void 0 : f.type) !== "link" || f.children.length !== 1) return false;
            let [b] = f.children;
            return t(f) === t(b) && o(f) === o(b);
          }
          r.exports = { mapAst: E, splitText: p, punctuationPattern: c, getFencedCodeBlockValue: F, getOrderedListItemInfo: d, hasGitDiffFriendlyOrderedList: g, INLINE_NODE_TYPES: i, INLINE_NODE_WRAPPER_TYPES: D, isAutolink: x };
        } }), L2 = S({ "src/language-markdown/unified-plugins/html-to-jsx.js"(e, r) {
          "use strict";
          I();
          var u = Yi(), { mapAst: t, INLINE_NODE_WRAPPER_TYPES: o } = N2();
          function n() {
            return (s) => t(s, (c, i, D) => {
              let [a] = D;
              return c.type !== "html" || u.COMMENT_REGEX.test(c.value) || o.includes(a.type) ? c : Object.assign(Object.assign({}, c), {}, { type: "jsx" });
            });
          }
          r.exports = n;
        } }), R2 = S({ "src/language-markdown/unified-plugins/front-matter.js"(e, r) {
          "use strict";
          I();
          var u = Wi();
          function t() {
            let o = this.Parser.prototype;
            o.blockMethods = ["frontMatter", ...o.blockMethods], o.blockTokenizers.frontMatter = n;
            function n(s, c) {
              let i = u(c);
              if (i.frontMatter) return s(i.frontMatter.raw)(i.frontMatter);
            }
            n.onlyAtStart = true;
          }
          r.exports = t;
        } }), j2 = S({ "src/language-markdown/unified-plugins/liquid.js"(e, r) {
          "use strict";
          I();
          function u() {
            let t = this.Parser.prototype, o = t.inlineMethods;
            o.splice(o.indexOf("text"), 0, "liquid"), t.inlineTokenizers.liquid = n;
            function n(s, c) {
              let i = c.match(/^({%.*?%}|{{.*?}})/s);
              if (i) return s(i[0])({ type: "liquidNode", value: i[0] });
            }
            n.locator = function(s, c) {
              return s.indexOf("{", c);
            };
          }
          r.exports = u;
        } }), P2 = S({ "src/language-markdown/unified-plugins/wiki-link.js"(e, r) {
          "use strict";
          I();
          function u() {
            let t = "wikiLink", o = /^\[\[(?<linkContents>.+?)]]/s, n = this.Parser.prototype, s = n.inlineMethods;
            s.splice(s.indexOf("link"), 0, t), n.inlineTokenizers.wikiLink = c;
            function c(i, D) {
              let a = o.exec(D);
              if (a) {
                let l = a.groups.linkContents.trim();
                return i(a[0])({ type: t, value: l });
              }
            }
            c.locator = function(i, D) {
              return i.indexOf("[", D);
            };
          }
          r.exports = u;
        } }), M2 = S({ "src/language-markdown/unified-plugins/loose-items.js"(e, r) {
          "use strict";
          I();
          function u() {
            let t = this.Parser.prototype, o = t.blockTokenizers.list;
            function n(s, c, i) {
              return c.type === "listItem" && (c.loose = c.spread || s.charAt(s.length - 1) === `
`, c.loose && (i.loose = true)), c;
            }
            t.blockTokenizers.list = function(c, i, D) {
              function a(l) {
                let p = c(l);
                function d(g, F) {
                  return p(n(l, g, F), F);
                }
                return d.reset = function(g, F) {
                  return p.reset(n(l, g, F), F);
                }, d;
              }
              return a.now = c.now, o.call(this, a, i, D);
            };
          }
          r.exports = u;
        } });
        I();
        var z2 = GD(), G2 = r2(), U2 = n2(), V2 = i2(), $2 = a2(), { locStart: H2, locEnd: X2 } = Ki(), Si = Yi(), W2 = L2(), K2 = R2(), Y2 = j2(), J2 = P2(), Z2 = M2();
        function ia(e) {
          let { isMDX: r } = e;
          return (u) => {
            let t = G2().use(z2, Object.assign({ commonmark: true }, r && { blocks: [Si.BLOCKS_REGEX] })).use(V2).use(K2).use(U2).use(r ? Si.esSyntax : Ti).use(Y2).use(r ? W2 : Ti).use(J2).use(Z2);
            return t.runSync(t.parse(u));
          };
        }
        function Ti(e) {
          return e;
        }
        var aa = { astFormat: "mdast", hasPragma: $2.hasPragma, locStart: H2, locEnd: X2 }, Ni = Object.assign(Object.assign({}, aa), {}, { parse: ia({ isMDX: false }) }), Q2 = Object.assign(Object.assign({}, aa), {}, { parse: ia({ isMDX: true }) });
        oa.exports = { parsers: { remark: Ni, markdown: Ni, mdx: Q2 } };
      });
      return ef();
    });
  }
});

// ../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-html.js
var require_parser_html = __commonJS({
  "../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-html.js"(exports2, module2) {
    "use strict";
    (function(e) {
      if (typeof exports2 == "object" && typeof module2 == "object") module2.exports = e();
      else if (typeof define == "function" && define.amd) define(e);
      else {
        var i = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i.prettierPlugins = i.prettierPlugins || {}, i.prettierPlugins.html = e();
      }
    })(function() {
      "use strict";
      var y = (e, r) => () => (r || e((r = { exports: {} }).exports, r), r.exports);
      var G = y((cl, zr) => {
        var we = function(e) {
          return e && e.Math == Math && e;
        };
        zr.exports = we(typeof globalThis == "object" && globalThis) || we(typeof window == "object" && window) || we(typeof self == "object" && self) || we(typeof global == "object" && global) || /* @__PURE__ */ function() {
          return this;
        }() || Function("return this")();
      });
      var se = y((Dl, Wr) => {
        Wr.exports = function(e) {
          try {
            return !!e();
          } catch {
            return true;
          }
        };
      });
      var oe = y((ll, Yr) => {
        var bs = se();
        Yr.exports = !bs(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      });
      var Ne = y((hl, Qr) => {
        var ws = se();
        Qr.exports = !ws(function() {
          var e = function() {
          }.bind();
          return typeof e != "function" || e.hasOwnProperty("prototype");
        });
      });
      var ce = y((pl, Kr) => {
        var Ns = Ne(), Oe = Function.prototype.call;
        Kr.exports = Ns ? Oe.bind(Oe) : function() {
          return Oe.apply(Oe, arguments);
        };
      });
      var rt = y((et) => {
        "use strict";
        var Jr = {}.propertyIsEnumerable, Zr = Object.getOwnPropertyDescriptor, Os = Zr && !Jr.call({ 1: 2 }, 1);
        et.f = Os ? function(r) {
          var t = Zr(this, r);
          return !!t && t.enumerable;
        } : Jr;
      });
      var qe = y((dl, tt) => {
        tt.exports = function(e, r) {
          return { enumerable: !(e & 1), configurable: !(e & 2), writable: !(e & 4), value: r };
        };
      });
      var Q = y((El, st) => {
        var ut = Ne(), nt = Function.prototype, qs = nt.bind, er = nt.call, Is = ut && qs.bind(er, er);
        st.exports = ut ? function(e) {
          return e && Is(e);
        } : function(e) {
          return e && function() {
            return er.apply(e, arguments);
          };
        };
      });
      var Ie = y((Cl, it) => {
        var at = Q(), Rs = at({}.toString), xs = at("".slice);
        it.exports = function(e) {
          return xs(Rs(e), 8, -1);
        };
      });
      var ct = y((ml, ot) => {
        var Ps = G(), ks = Q(), Ls = se(), Ms = Ie(), rr = Ps.Object, js = ks("".split);
        ot.exports = Ls(function() {
          return !rr("z").propertyIsEnumerable(0);
        }) ? function(e) {
          return Ms(e) == "String" ? js(e, "") : rr(e);
        } : rr;
      });
      var tr = y((gl, Dt) => {
        var $s = G(), Us = $s.TypeError;
        Dt.exports = function(e) {
          if (e == null) throw Us("Can't call method on " + e);
          return e;
        };
      });
      var Re = y((Fl, lt) => {
        var Gs = ct(), Vs = tr();
        lt.exports = function(e) {
          return Gs(Vs(e));
        };
      });
      var K = y((Al, ht) => {
        ht.exports = function(e) {
          return typeof e == "function";
        };
      });
      var De = y((vl, pt) => {
        var Xs = K();
        pt.exports = function(e) {
          return typeof e == "object" ? e !== null : Xs(e);
        };
      });
      var ge = y((_l, ft) => {
        var ur = G(), Hs = K(), zs = function(e) {
          return Hs(e) ? e : void 0;
        };
        ft.exports = function(e, r) {
          return arguments.length < 2 ? zs(ur[e]) : ur[e] && ur[e][r];
        };
      });
      var nr = y((Sl, dt) => {
        var Ws = Q();
        dt.exports = Ws({}.isPrototypeOf);
      });
      var Ct = y((yl, Et) => {
        var Ys = ge();
        Et.exports = Ys("navigator", "userAgent") || "";
      });
      var St = y((Tl, _t) => {
        var vt = G(), sr = Ct(), mt = vt.process, gt = vt.Deno, Ft = mt && mt.versions || gt && gt.version, At = Ft && Ft.v8, te, xe;
        At && (te = At.split("."), xe = te[0] > 0 && te[0] < 4 ? 1 : +(te[0] + te[1]));
        !xe && sr && (te = sr.match(/Edge\/(\d+)/), (!te || te[1] >= 74) && (te = sr.match(/Chrome\/(\d+)/), te && (xe = +te[1])));
        _t.exports = xe;
      });
      var ar = y((Bl, Tt) => {
        var yt = St(), Qs = se();
        Tt.exports = !!Object.getOwnPropertySymbols && !Qs(function() {
          var e = Symbol();
          return !String(e) || !(Object(e) instanceof Symbol) || !Symbol.sham && yt && yt < 41;
        });
      });
      var ir = y((bl, Bt) => {
        var Ks = ar();
        Bt.exports = Ks && !Symbol.sham && typeof Symbol.iterator == "symbol";
      });
      var or = y((wl, bt) => {
        var Js = G(), Zs = ge(), ea = K(), ra = nr(), ta = ir(), ua = Js.Object;
        bt.exports = ta ? function(e) {
          return typeof e == "symbol";
        } : function(e) {
          var r = Zs("Symbol");
          return ea(r) && ra(r.prototype, ua(e));
        };
      });
      var Pe = y((Nl, wt) => {
        var na = G(), sa = na.String;
        wt.exports = function(e) {
          try {
            return sa(e);
          } catch {
            return "Object";
          }
        };
      });
      var Fe = y((Ol, Nt) => {
        var aa = G(), ia = K(), oa = Pe(), ca = aa.TypeError;
        Nt.exports = function(e) {
          if (ia(e)) return e;
          throw ca(oa(e) + " is not a function");
        };
      });
      var ke = y((ql, Ot) => {
        var Da = Fe();
        Ot.exports = function(e, r) {
          var t = e[r];
          return t == null ? void 0 : Da(t);
        };
      });
      var It = y((Il, qt) => {
        var la = G(), cr = ce(), Dr = K(), lr = De(), ha = la.TypeError;
        qt.exports = function(e, r) {
          var t, s;
          if (r === "string" && Dr(t = e.toString) && !lr(s = cr(t, e)) || Dr(t = e.valueOf) && !lr(s = cr(t, e)) || r !== "string" && Dr(t = e.toString) && !lr(s = cr(t, e))) return s;
          throw ha("Can't convert object to primitive value");
        };
      });
      var xt = y((Rl, Rt) => {
        Rt.exports = false;
      });
      var Le = y((xl, kt) => {
        var Pt = G(), pa = Object.defineProperty;
        kt.exports = function(e, r) {
          try {
            pa(Pt, e, { value: r, configurable: true, writable: true });
          } catch {
            Pt[e] = r;
          }
          return r;
        };
      });
      var Me = y((Pl, Mt) => {
        var fa = G(), da = Le(), Lt = "__core-js_shared__", Ea = fa[Lt] || da(Lt, {});
        Mt.exports = Ea;
      });
      var hr = y((kl, $t) => {
        var Ca = xt(), jt = Me();
        ($t.exports = function(e, r) {
          return jt[e] || (jt[e] = r !== void 0 ? r : {});
        })("versions", []).push({ version: "3.22.2", mode: Ca ? "pure" : "global", copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)", license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE", source: "https://github.com/zloirock/core-js" });
      });
      var pr = y((Ll, Ut) => {
        var ma = G(), ga = tr(), Fa = ma.Object;
        Ut.exports = function(e) {
          return Fa(ga(e));
        };
      });
      var ae = y((Ml, Gt) => {
        var Aa = Q(), va = pr(), _a = Aa({}.hasOwnProperty);
        Gt.exports = Object.hasOwn || function(r, t) {
          return _a(va(r), t);
        };
      });
      var fr = y((jl, Vt) => {
        var Sa = Q(), ya = 0, Ta = Math.random(), Ba = Sa(1 .toString);
        Vt.exports = function(e) {
          return "Symbol(" + (e === void 0 ? "" : e) + ")_" + Ba(++ya + Ta, 36);
        };
      });
      var he = y(($l, Yt) => {
        var ba = G(), wa = hr(), Xt = ae(), Na = fr(), Ht = ar(), Wt = ir(), fe = wa("wks"), le = ba.Symbol, zt = le && le.for, Oa = Wt ? le : le && le.withoutSetter || Na;
        Yt.exports = function(e) {
          if (!Xt(fe, e) || !(Ht || typeof fe[e] == "string")) {
            var r = "Symbol." + e;
            Ht && Xt(le, e) ? fe[e] = le[e] : Wt && zt ? fe[e] = zt(r) : fe[e] = Oa(r);
          }
          return fe[e];
        };
      });
      var Zt = y((Ul, Jt) => {
        var qa = G(), Ia = ce(), Qt = De(), Kt = or(), Ra = ke(), xa = It(), Pa = he(), ka = qa.TypeError, La = Pa("toPrimitive");
        Jt.exports = function(e, r) {
          if (!Qt(e) || Kt(e)) return e;
          var t = Ra(e, La), s;
          if (t) {
            if (r === void 0 && (r = "default"), s = Ia(t, e, r), !Qt(s) || Kt(s)) return s;
            throw ka("Can't convert object to primitive value");
          }
          return r === void 0 && (r = "number"), xa(e, r);
        };
      });
      var je = y((Gl, eu) => {
        var Ma = Zt(), ja = or();
        eu.exports = function(e) {
          var r = Ma(e, "string");
          return ja(r) ? r : r + "";
        };
      });
      var uu = y((Vl, tu) => {
        var $a = G(), ru = De(), dr = $a.document, Ua = ru(dr) && ru(dr.createElement);
        tu.exports = function(e) {
          return Ua ? dr.createElement(e) : {};
        };
      });
      var Er = y((Xl, nu) => {
        var Ga = oe(), Va = se(), Xa = uu();
        nu.exports = !Ga && !Va(function() {
          return Object.defineProperty(Xa("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      });
      var Cr = y((au) => {
        var Ha = oe(), za = ce(), Wa = rt(), Ya = qe(), Qa = Re(), Ka = je(), Ja = ae(), Za = Er(), su = Object.getOwnPropertyDescriptor;
        au.f = Ha ? su : function(r, t) {
          if (r = Qa(r), t = Ka(t), Za) try {
            return su(r, t);
          } catch {
          }
          if (Ja(r, t)) return Ya(!za(Wa.f, r, t), r[t]);
        };
      });
      var ou = y((zl, iu) => {
        var ei = oe(), ri = se();
        iu.exports = ei && ri(function() {
          return Object.defineProperty(function() {
          }, "prototype", { value: 42, writable: false }).prototype != 42;
        });
      });
      var de = y((Wl, Du) => {
        var cu = G(), ti = De(), ui = cu.String, ni = cu.TypeError;
        Du.exports = function(e) {
          if (ti(e)) return e;
          throw ni(ui(e) + " is not an object");
        };
      });
      var Ue = y((hu) => {
        var si = G(), ai = oe(), ii = Er(), oi = ou(), $e = de(), lu = je(), ci = si.TypeError, mr = Object.defineProperty, Di = Object.getOwnPropertyDescriptor, gr = "enumerable", Fr = "configurable", Ar = "writable";
        hu.f = ai ? oi ? function(r, t, s) {
          if ($e(r), t = lu(t), $e(s), typeof r == "function" && t === "prototype" && "value" in s && Ar in s && !s[Ar]) {
            var c = Di(r, t);
            c && c[Ar] && (r[t] = s.value, s = { configurable: Fr in s ? s[Fr] : c[Fr], enumerable: gr in s ? s[gr] : c[gr], writable: false });
          }
          return mr(r, t, s);
        } : mr : function(r, t, s) {
          if ($e(r), t = lu(t), $e(s), ii) try {
            return mr(r, t, s);
          } catch {
          }
          if ("get" in s || "set" in s) throw ci("Accessors not supported");
          return "value" in s && (r[t] = s.value), r;
        };
      });
      var Ge = y((Ql, pu) => {
        var li = oe(), hi = Ue(), pi = qe();
        pu.exports = li ? function(e, r, t) {
          return hi.f(e, r, pi(1, t));
        } : function(e, r, t) {
          return e[r] = t, e;
        };
      });
      var Ve = y((Kl, fu) => {
        var fi = Q(), di = K(), vr = Me(), Ei = fi(Function.toString);
        di(vr.inspectSource) || (vr.inspectSource = function(e) {
          return Ei(e);
        });
        fu.exports = vr.inspectSource;
      });
      var Cu = y((Jl, Eu) => {
        var Ci = G(), mi = K(), gi = Ve(), du = Ci.WeakMap;
        Eu.exports = mi(du) && /native code/.test(gi(du));
      });
      var Fu = y((Zl, gu) => {
        var Fi = hr(), Ai = fr(), mu = Fi("keys");
        gu.exports = function(e) {
          return mu[e] || (mu[e] = Ai(e));
        };
      });
      var _r = y((e2, Au) => {
        Au.exports = {};
      });
      var Bu = y((r2, Tu) => {
        var vi = Cu(), yu = G(), Sr = Q(), _i = De(), Si = Ge(), yr = ae(), Tr = Me(), yi = Fu(), Ti = _r(), vu = "Object already initialized", br = yu.TypeError, Bi = yu.WeakMap, Xe, Ae, He, bi = function(e) {
          return He(e) ? Ae(e) : Xe(e, {});
        }, wi = function(e) {
          return function(r) {
            var t;
            if (!_i(r) || (t = Ae(r)).type !== e) throw br("Incompatible receiver, " + e + " required");
            return t;
          };
        };
        vi || Tr.state ? (ie = Tr.state || (Tr.state = new Bi()), _u = Sr(ie.get), Br = Sr(ie.has), Su = Sr(ie.set), Xe = function(e, r) {
          if (Br(ie, e)) throw new br(vu);
          return r.facade = e, Su(ie, e, r), r;
        }, Ae = function(e) {
          return _u(ie, e) || {};
        }, He = function(e) {
          return Br(ie, e);
        }) : (pe = yi("state"), Ti[pe] = true, Xe = function(e, r) {
          if (yr(e, pe)) throw new br(vu);
          return r.facade = e, Si(e, pe, r), r;
        }, Ae = function(e) {
          return yr(e, pe) ? e[pe] : {};
        }, He = function(e) {
          return yr(e, pe);
        });
        var ie, _u, Br, Su, pe;
        Tu.exports = { set: Xe, get: Ae, has: He, enforce: bi, getterFor: wi };
      });
      var Nu = y((t2, wu) => {
        var wr = oe(), Ni = ae(), bu = Function.prototype, Oi = wr && Object.getOwnPropertyDescriptor, Nr = Ni(bu, "name"), qi = Nr && function() {
        }.name === "something", Ii = Nr && (!wr || wr && Oi(bu, "name").configurable);
        wu.exports = { EXISTS: Nr, PROPER: qi, CONFIGURABLE: Ii };
      });
      var xu = y((u2, Ru) => {
        var Ri = G(), Ou = K(), xi = ae(), qu = Ge(), Pi = Le(), ki = Ve(), Iu = Bu(), Li = Nu().CONFIGURABLE, Mi = Iu.get, ji = Iu.enforce, $i = String(String).split("String");
        (Ru.exports = function(e, r, t, s) {
          var c = s ? !!s.unsafe : false, n = s ? !!s.enumerable : false, a = s ? !!s.noTargetGet : false, p = s && s.name !== void 0 ? s.name : r, D;
          if (Ou(t) && (String(p).slice(0, 7) === "Symbol(" && (p = "[" + String(p).replace(/^Symbol\(([^)]*)\)/, "$1") + "]"), (!xi(t, "name") || Li && t.name !== p) && qu(t, "name", p), D = ji(t), D.source || (D.source = $i.join(typeof p == "string" ? p : ""))), e === Ri) {
            n ? e[r] = t : Pi(r, t);
            return;
          } else c ? !a && e[r] && (n = true) : delete e[r];
          n ? e[r] = t : qu(e, r, t);
        })(Function.prototype, "toString", function() {
          return Ou(this) && Mi(this).source || ki(this);
        });
      });
      var Or = y((n2, Pu) => {
        var Ui = Math.ceil, Gi = Math.floor;
        Pu.exports = function(e) {
          var r = +e;
          return r !== r || r === 0 ? 0 : (r > 0 ? Gi : Ui)(r);
        };
      });
      var Lu = y((s2, ku) => {
        var Vi = Or(), Xi = Math.max, Hi = Math.min;
        ku.exports = function(e, r) {
          var t = Vi(e);
          return t < 0 ? Xi(t + r, 0) : Hi(t, r);
        };
      });
      var ju = y((a2, Mu) => {
        var zi = Or(), Wi = Math.min;
        Mu.exports = function(e) {
          return e > 0 ? Wi(zi(e), 9007199254740991) : 0;
        };
      });
      var ve = y((i2, $u) => {
        var Yi = ju();
        $u.exports = function(e) {
          return Yi(e.length);
        };
      });
      var Vu = y((o2, Gu) => {
        var Qi = Re(), Ki = Lu(), Ji = ve(), Uu = function(e) {
          return function(r, t, s) {
            var c = Qi(r), n = Ji(c), a = Ki(s, n), p;
            if (e && t != t) {
              for (; n > a; ) if (p = c[a++], p != p) return true;
            } else for (; n > a; a++) if ((e || a in c) && c[a] === t) return e || a || 0;
            return !e && -1;
          };
        };
        Gu.exports = { includes: Uu(true), indexOf: Uu(false) };
      });
      var zu = y((c2, Hu) => {
        var Zi = Q(), qr = ae(), eo = Re(), ro = Vu().indexOf, to = _r(), Xu = Zi([].push);
        Hu.exports = function(e, r) {
          var t = eo(e), s = 0, c = [], n;
          for (n in t) !qr(to, n) && qr(t, n) && Xu(c, n);
          for (; r.length > s; ) qr(t, n = r[s++]) && (~ro(c, n) || Xu(c, n));
          return c;
        };
      });
      var Yu = y((D2, Wu) => {
        Wu.exports = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
      });
      var Ku = y((Qu) => {
        var uo = zu(), no = Yu(), so = no.concat("length", "prototype");
        Qu.f = Object.getOwnPropertyNames || function(r) {
          return uo(r, so);
        };
      });
      var Zu = y((Ju) => {
        Ju.f = Object.getOwnPropertySymbols;
      });
      var rn = y((p2, en) => {
        var ao = ge(), io = Q(), oo = Ku(), co = Zu(), Do = de(), lo = io([].concat);
        en.exports = ao("Reflect", "ownKeys") || function(r) {
          var t = oo.f(Do(r)), s = co.f;
          return s ? lo(t, s(r)) : t;
        };
      });
      var nn = y((f2, un) => {
        var tn = ae(), ho = rn(), po = Cr(), fo = Ue();
        un.exports = function(e, r, t) {
          for (var s = ho(r), c = fo.f, n = po.f, a = 0; a < s.length; a++) {
            var p = s[a];
            !tn(e, p) && !(t && tn(t, p)) && c(e, p, n(r, p));
          }
        };
      });
      var an = y((d2, sn) => {
        var Eo = se(), Co = K(), mo = /#|\.prototype\./, _e = function(e, r) {
          var t = Fo[go(e)];
          return t == vo ? true : t == Ao ? false : Co(r) ? Eo(r) : !!r;
        }, go = _e.normalize = function(e) {
          return String(e).replace(mo, ".").toLowerCase();
        }, Fo = _e.data = {}, Ao = _e.NATIVE = "N", vo = _e.POLYFILL = "P";
        sn.exports = _e;
      });
      var ze = y((E2, on) => {
        var Ir = G(), _o = Cr().f, So = Ge(), yo = xu(), To = Le(), Bo = nn(), bo = an();
        on.exports = function(e, r) {
          var t = e.target, s = e.global, c = e.stat, n, a, p, D, g, i;
          if (s ? a = Ir : c ? a = Ir[t] || To(t, {}) : a = (Ir[t] || {}).prototype, a) for (p in r) {
            if (g = r[p], e.noTargetGet ? (i = _o(a, p), D = i && i.value) : D = a[p], n = bo(s ? p : t + (c ? "." : "#") + p, e.forced), !n && D !== void 0) {
              if (typeof g == typeof D) continue;
              Bo(g, D);
            }
            (e.sham || D && D.sham) && So(g, "sham", true), yo(a, p, g, e);
          }
        };
      });
      var cn = y(() => {
        var wo = ze(), No = G();
        wo({ global: true }, { globalThis: No });
      });
      var Dn = y(() => {
        cn();
      });
      var Rr = y((A2, ln) => {
        var Oo = Ie();
        ln.exports = Array.isArray || function(r) {
          return Oo(r) == "Array";
        };
      });
      var xr = y((v2, pn) => {
        var hn = Q(), qo = Fe(), Io = Ne(), Ro = hn(hn.bind);
        pn.exports = function(e, r) {
          return qo(e), r === void 0 ? e : Io ? Ro(e, r) : function() {
            return e.apply(r, arguments);
          };
        };
      });
      var En = y((_2, dn) => {
        "use strict";
        var xo = G(), Po = Rr(), ko = ve(), Lo = xr(), Mo = xo.TypeError, fn = function(e, r, t, s, c, n, a, p) {
          for (var D = c, g = 0, i = a ? Lo(a, p) : false, l, h; g < s; ) {
            if (g in t) {
              if (l = i ? i(t[g], g, r) : t[g], n > 0 && Po(l)) h = ko(l), D = fn(e, r, l, h, D, n - 1) - 1;
              else {
                if (D >= 9007199254740991) throw Mo("Exceed the acceptable array length");
                e[D] = l;
              }
              D++;
            }
            g++;
          }
          return D;
        };
        dn.exports = fn;
      });
      var gn = y((S2, mn) => {
        var jo = he(), $o = jo("toStringTag"), Cn = {};
        Cn[$o] = "z";
        mn.exports = String(Cn) === "[object z]";
      });
      var Pr = y((y2, Fn) => {
        var Uo = G(), Go = gn(), Vo = K(), We = Ie(), Xo = he(), Ho = Xo("toStringTag"), zo = Uo.Object, Wo = We(/* @__PURE__ */ function() {
          return arguments;
        }()) == "Arguments", Yo = function(e, r) {
          try {
            return e[r];
          } catch {
          }
        };
        Fn.exports = Go ? We : function(e) {
          var r, t, s;
          return e === void 0 ? "Undefined" : e === null ? "Null" : typeof (t = Yo(r = zo(e), Ho)) == "string" ? t : Wo ? We(r) : (s = We(r)) == "Object" && Vo(r.callee) ? "Arguments" : s;
        };
      });
      var Tn = y((T2, yn) => {
        var Qo = Q(), Ko = se(), An = K(), Jo = Pr(), Zo = ge(), ec = Ve(), vn = function() {
        }, rc = [], _n = Zo("Reflect", "construct"), kr = /^\s*(?:class|function)\b/, tc = Qo(kr.exec), uc = !kr.exec(vn), Se = function(r) {
          if (!An(r)) return false;
          try {
            return _n(vn, rc, r), true;
          } catch {
            return false;
          }
        }, Sn = function(r) {
          if (!An(r)) return false;
          switch (Jo(r)) {
            case "AsyncFunction":
            case "GeneratorFunction":
            case "AsyncGeneratorFunction":
              return false;
          }
          try {
            return uc || !!tc(kr, ec(r));
          } catch {
            return true;
          }
        };
        Sn.sham = true;
        yn.exports = !_n || Ko(function() {
          var e;
          return Se(Se.call) || !Se(Object) || !Se(function() {
            e = true;
          }) || e;
        }) ? Sn : Se;
      });
      var Nn = y((B2, wn) => {
        var nc = G(), Bn = Rr(), sc = Tn(), ac = De(), ic = he(), oc = ic("species"), bn = nc.Array;
        wn.exports = function(e) {
          var r;
          return Bn(e) && (r = e.constructor, sc(r) && (r === bn || Bn(r.prototype)) ? r = void 0 : ac(r) && (r = r[oc], r === null && (r = void 0))), r === void 0 ? bn : r;
        };
      });
      var qn = y((b2, On) => {
        var cc = Nn();
        On.exports = function(e, r) {
          return new (cc(e))(r === 0 ? 0 : r);
        };
      });
      var In = y(() => {
        "use strict";
        var Dc = ze(), lc = En(), hc = Fe(), pc = pr(), fc = ve(), dc = qn();
        Dc({ target: "Array", proto: true }, { flatMap: function(r) {
          var t = pc(this), s = fc(t), c;
          return hc(r), c = dc(t, 0), c.length = lc(c, t, t, s, 0, 1, r, arguments.length > 1 ? arguments[1] : void 0), c;
        } });
      });
      var Lr = y((O2, Rn) => {
        Rn.exports = {};
      });
      var Pn = y((q2, xn) => {
        var Ec = he(), Cc = Lr(), mc = Ec("iterator"), gc = Array.prototype;
        xn.exports = function(e) {
          return e !== void 0 && (Cc.Array === e || gc[mc] === e);
        };
      });
      var Mr = y((I2, Ln) => {
        var Fc = Pr(), kn = ke(), Ac = Lr(), vc = he(), _c = vc("iterator");
        Ln.exports = function(e) {
          if (e != null) return kn(e, _c) || kn(e, "@@iterator") || Ac[Fc(e)];
        };
      });
      var jn = y((R2, Mn) => {
        var Sc = G(), yc = ce(), Tc = Fe(), Bc = de(), bc = Pe(), wc = Mr(), Nc = Sc.TypeError;
        Mn.exports = function(e, r) {
          var t = arguments.length < 2 ? wc(e) : r;
          if (Tc(t)) return Bc(yc(t, e));
          throw Nc(bc(e) + " is not iterable");
        };
      });
      var Gn = y((x2, Un) => {
        var Oc = ce(), $n = de(), qc = ke();
        Un.exports = function(e, r, t) {
          var s, c;
          $n(e);
          try {
            if (s = qc(e, "return"), !s) {
              if (r === "throw") throw t;
              return t;
            }
            s = Oc(s, e);
          } catch (n) {
            c = true, s = n;
          }
          if (r === "throw") throw t;
          if (c) throw s;
          return $n(s), t;
        };
      });
      var Wn = y((P2, zn) => {
        var Ic = G(), Rc = xr(), xc = ce(), Pc = de(), kc = Pe(), Lc = Pn(), Mc = ve(), Vn = nr(), jc = jn(), $c = Mr(), Xn = Gn(), Uc = Ic.TypeError, Ye = function(e, r) {
          this.stopped = e, this.result = r;
        }, Hn = Ye.prototype;
        zn.exports = function(e, r, t) {
          var s = t && t.that, c = !!(t && t.AS_ENTRIES), n = !!(t && t.IS_ITERATOR), a = !!(t && t.INTERRUPTED), p = Rc(r, s), D, g, i, l, h, C, d, m = function(B) {
            return D && Xn(D, "normal", B), new Ye(true, B);
          }, T = function(B) {
            return c ? (Pc(B), a ? p(B[0], B[1], m) : p(B[0], B[1])) : a ? p(B, m) : p(B);
          };
          if (n) D = e;
          else {
            if (g = $c(e), !g) throw Uc(kc(e) + " is not iterable");
            if (Lc(g)) {
              for (i = 0, l = Mc(e); l > i; i++) if (h = T(e[i]), h && Vn(Hn, h)) return h;
              return new Ye(false);
            }
            D = jc(e, g);
          }
          for (C = D.next; !(d = xc(C, D)).done; ) {
            try {
              h = T(d.value);
            } catch (B) {
              Xn(D, "throw", B);
            }
            if (typeof h == "object" && h && Vn(Hn, h)) return h;
          }
          return new Ye(false);
        };
      });
      var Qn = y((k2, Yn) => {
        "use strict";
        var Gc = je(), Vc = Ue(), Xc = qe();
        Yn.exports = function(e, r, t) {
          var s = Gc(r);
          s in e ? Vc.f(e, s, Xc(0, t)) : e[s] = t;
        };
      });
      var Kn = y(() => {
        var Hc = ze(), zc = Wn(), Wc = Qn();
        Hc({ target: "Object", stat: true }, { fromEntries: function(r) {
          var t = {};
          return zc(r, function(s, c) {
            Wc(t, s, c);
          }, { AS_ENTRIES: true }), t;
        } });
      });
      var il = y((j2, Bs) => {
        var Yc = ["cliName", "cliCategory", "cliDescription"], Jn, Zn, es, rs, ts, us;
        function Qc(e, r) {
          if (e == null) return {};
          var t = Kc(e, r), s, c;
          if (Object.getOwnPropertySymbols) {
            var n = Object.getOwnPropertySymbols(e);
            for (c = 0; c < n.length; c++) s = n[c], !(r.indexOf(s) >= 0) && (!Object.prototype.propertyIsEnumerable.call(e, s) || (t[s] = e[s]));
          }
          return t;
        }
        function Kc(e, r) {
          if (e == null) return {};
          var t = {}, s = Object.keys(e), c, n;
          for (n = 0; n < s.length; n++) c = s[n], !(r.indexOf(c) >= 0) && (t[c] = e[c]);
          return t;
        }
        function Ee(e, r) {
          return r || (r = e.slice(0)), Object.freeze(Object.defineProperties(e, { raw: { value: Object.freeze(r) } }));
        }
        Dn();
        In();
        Kn();
        var Jc = Object.create, Je = Object.defineProperty, Zc = Object.getOwnPropertyDescriptor, $r = Object.getOwnPropertyNames, eD = Object.getPrototypeOf, rD = Object.prototype.hasOwnProperty, Ce = (e, r) => function() {
          return e && (r = (0, e[$r(e)[0]])(e = 0)), r;
        }, I = (e, r) => function() {
          return r || (0, e[$r(e)[0]])((r = { exports: {} }).exports, r), r.exports;
        }, cs = (e, r) => {
          for (var t in r) Je(e, t, { get: r[t], enumerable: true });
        }, Ds = (e, r, t, s) => {
          if (r && typeof r == "object" || typeof r == "function") for (let c of $r(r)) !rD.call(e, c) && c !== t && Je(e, c, { get: () => r[c], enumerable: !(s = Zc(r, c)) || s.enumerable });
          return e;
        }, tD = (e, r, t) => (t = e != null ? Jc(eD(e)) : {}, Ds(r || !e || !e.__esModule ? Je(t, "default", { value: e, enumerable: true }) : t, e)), ls = (e) => Ds(Je({}, "__esModule", { value: true }), e), ns, ss, ye, q = Ce({ "<define:process>"() {
          ns = {}, ss = [], ye = { env: ns, argv: ss };
        } }), hs = I({ "node_modules/angular-html-parser/lib/compiler/src/chars.js"(e) {
          "use strict";
          q(), Object.defineProperty(e, "__esModule", { value: true }), e.$EOF = 0, e.$BSPACE = 8, e.$TAB = 9, e.$LF = 10, e.$VTAB = 11, e.$FF = 12, e.$CR = 13, e.$SPACE = 32, e.$BANG = 33, e.$DQ = 34, e.$HASH = 35, e.$$ = 36, e.$PERCENT = 37, e.$AMPERSAND = 38, e.$SQ = 39, e.$LPAREN = 40, e.$RPAREN = 41, e.$STAR = 42, e.$PLUS = 43, e.$COMMA = 44, e.$MINUS = 45, e.$PERIOD = 46, e.$SLASH = 47, e.$COLON = 58, e.$SEMICOLON = 59, e.$LT = 60, e.$EQ = 61, e.$GT = 62, e.$QUESTION = 63, e.$0 = 48, e.$7 = 55, e.$9 = 57, e.$A = 65, e.$E = 69, e.$F = 70, e.$X = 88, e.$Z = 90, e.$LBRACKET = 91, e.$BACKSLASH = 92, e.$RBRACKET = 93, e.$CARET = 94, e.$_ = 95, e.$a = 97, e.$b = 98, e.$e = 101, e.$f = 102, e.$n = 110, e.$r = 114, e.$t = 116, e.$u = 117, e.$v = 118, e.$x = 120, e.$z = 122, e.$LBRACE = 123, e.$BAR = 124, e.$RBRACE = 125, e.$NBSP = 160, e.$PIPE = 124, e.$TILDA = 126, e.$AT = 64, e.$BT = 96;
          function r(p) {
            return p >= e.$TAB && p <= e.$SPACE || p == e.$NBSP;
          }
          e.isWhitespace = r;
          function t(p) {
            return e.$0 <= p && p <= e.$9;
          }
          e.isDigit = t;
          function s(p) {
            return p >= e.$a && p <= e.$z || p >= e.$A && p <= e.$Z;
          }
          e.isAsciiLetter = s;
          function c(p) {
            return p >= e.$a && p <= e.$f || p >= e.$A && p <= e.$F || t(p);
          }
          e.isAsciiHexDigit = c;
          function n(p) {
            return p === e.$LF || p === e.$CR;
          }
          e.isNewLine = n;
          function a(p) {
            return e.$0 <= p && p <= e.$7;
          }
          e.isOctalDigit = a;
        } }), uD = I({ "node_modules/angular-html-parser/lib/compiler/src/aot/static_symbol.js"(e) {
          "use strict";
          q(), Object.defineProperty(e, "__esModule", { value: true });
          var r = class {
            constructor(s, c, n) {
              this.filePath = s, this.name = c, this.members = n;
            }
            assertNoMembers() {
              if (this.members.length) throw new Error("Illegal state: symbol without members expected, but got ".concat(JSON.stringify(this), "."));
            }
          };
          e.StaticSymbol = r;
          var t = class {
            constructor() {
              this.cache = /* @__PURE__ */ new Map();
            }
            get(s, c, n) {
              n = n || [];
              let a = n.length ? ".".concat(n.join(".")) : "", p = '"'.concat(s, '".').concat(c).concat(a), D = this.cache.get(p);
              return D || (D = new r(s, c, n), this.cache.set(p, D)), D;
            }
          };
          e.StaticSymbolCache = t;
        } }), nD = I({ "node_modules/angular-html-parser/lib/compiler/src/util.js"(e) {
          "use strict";
          q(), Object.defineProperty(e, "__esModule", { value: true });
          var r = /-+([a-z0-9])/g;
          function t(o) {
            return o.replace(r, function() {
              for (var E = arguments.length, f = new Array(E), F = 0; F < E; F++) f[F] = arguments[F];
              return f[1].toUpperCase();
            });
          }
          e.dashCaseToCamelCase = t;
          function s(o, E) {
            return n(o, ":", E);
          }
          e.splitAtColon = s;
          function c(o, E) {
            return n(o, ".", E);
          }
          e.splitAtPeriod = c;
          function n(o, E, f) {
            let F = o.indexOf(E);
            return F == -1 ? f : [o.slice(0, F).trim(), o.slice(F + 1).trim()];
          }
          function a(o, E, f) {
            return Array.isArray(o) ? E.visitArray(o, f) : A(o) ? E.visitStringMap(o, f) : o == null || typeof o == "string" || typeof o == "number" || typeof o == "boolean" ? E.visitPrimitive(o, f) : E.visitOther(o, f);
          }
          e.visitValue = a;
          function p(o) {
            return o != null;
          }
          e.isDefined = p;
          function D(o) {
            return o === void 0 ? null : o;
          }
          e.noUndefined = D;
          var g = class {
            visitArray(o, E) {
              return o.map((f) => a(f, this, E));
            }
            visitStringMap(o, E) {
              let f = {};
              return Object.keys(o).forEach((F) => {
                f[F] = a(o[F], this, E);
              }), f;
            }
            visitPrimitive(o, E) {
              return o;
            }
            visitOther(o, E) {
              return o;
            }
          };
          e.ValueTransformer = g, e.SyncAsync = { assertSync: (o) => {
            if (_(o)) throw new Error("Illegal state: value cannot be a promise");
            return o;
          }, then: (o, E) => _(o) ? o.then(E) : E(o), all: (o) => o.some(_) ? Promise.all(o) : o };
          function i(o) {
            throw new Error("Internal Error: ".concat(o));
          }
          e.error = i;
          function l(o, E) {
            let f = Error(o);
            return f[h] = true, E && (f[C] = E), f;
          }
          e.syntaxError = l;
          var h = "ngSyntaxError", C = "ngParseErrors";
          function d(o) {
            return o[h];
          }
          e.isSyntaxError = d;
          function m(o) {
            return o[C] || [];
          }
          e.getParseErrors = m;
          function T(o) {
            return o.replace(/([.*+?^=!:${}()|[\]\/\\])/g, "\\$1");
          }
          e.escapeRegExp = T;
          var B = Object.getPrototypeOf({});
          function A(o) {
            return typeof o == "object" && o !== null && Object.getPrototypeOf(o) === B;
          }
          function N(o) {
            let E = "";
            for (let f = 0; f < o.length; f++) {
              let F = o.charCodeAt(f);
              if (F >= 55296 && F <= 56319 && o.length > f + 1) {
                let P = o.charCodeAt(f + 1);
                P >= 56320 && P <= 57343 && (f++, F = (F - 55296 << 10) + P - 56320 + 65536);
              }
              F <= 127 ? E += String.fromCharCode(F) : F <= 2047 ? E += String.fromCharCode(F >> 6 & 31 | 192, F & 63 | 128) : F <= 65535 ? E += String.fromCharCode(F >> 12 | 224, F >> 6 & 63 | 128, F & 63 | 128) : F <= 2097151 && (E += String.fromCharCode(F >> 18 & 7 | 240, F >> 12 & 63 | 128, F >> 6 & 63 | 128, F & 63 | 128));
            }
            return E;
          }
          e.utf8Encode = N;
          function R(o) {
            if (typeof o == "string") return o;
            if (o instanceof Array) return "[" + o.map(R).join(", ") + "]";
            if (o == null) return "" + o;
            if (o.overriddenName) return "".concat(o.overriddenName);
            if (o.name) return "".concat(o.name);
            if (!o.toString) return "object";
            let E = o.toString();
            if (E == null) return "" + E;
            let f = E.indexOf(`
`);
            return f === -1 ? E : E.substring(0, f);
          }
          e.stringify = R;
          function $(o) {
            return typeof o == "function" && o.hasOwnProperty("__forward_ref__") ? o() : o;
          }
          e.resolveForwardRef = $;
          function _(o) {
            return !!o && typeof o.then == "function";
          }
          e.isPromise = _;
          var O = class {
            constructor(o) {
              this.full = o;
              let E = o.split(".");
              this.major = E[0], this.minor = E[1], this.patch = E.slice(2).join(".");
            }
          };
          e.Version = O;
          var x = typeof window < "u" && window, k = typeof self < "u" && typeof WorkerGlobalScope < "u" && self instanceof WorkerGlobalScope && self, M = typeof globalThis < "u" && globalThis, u = M || x || k;
          e.global = u;
        } }), sD = I({ "node_modules/angular-html-parser/lib/compiler/src/compile_metadata.js"(e) {
          "use strict";
          q(), Object.defineProperty(e, "__esModule", { value: true });
          var r = uD(), t = nD(), s = /^(?:(?:\[([^\]]+)\])|(?:\(([^\)]+)\)))|(\@[-\w]+)$/;
          function c(f) {
            return f.replace(/\W/g, "_");
          }
          e.sanitizeIdentifier = c;
          var n = 0;
          function a(f) {
            if (!f || !f.reference) return null;
            let F = f.reference;
            if (F instanceof r.StaticSymbol) return F.name;
            if (F.__anonymousType) return F.__anonymousType;
            let P = t.stringify(F);
            return P.indexOf("(") >= 0 ? (P = "anonymous_".concat(n++), F.__anonymousType = P) : P = c(P), P;
          }
          e.identifierName = a;
          function p(f) {
            let F = f.reference;
            return F instanceof r.StaticSymbol ? F.filePath : "./".concat(t.stringify(F));
          }
          e.identifierModuleUrl = p;
          function D(f, F) {
            return "View_".concat(a({ reference: f }), "_").concat(F);
          }
          e.viewClassName = D;
          function g(f) {
            return "RenderType_".concat(a({ reference: f }));
          }
          e.rendererTypeName = g;
          function i(f) {
            return "HostView_".concat(a({ reference: f }));
          }
          e.hostViewClassName = i;
          function l(f) {
            return "".concat(a({ reference: f }), "NgFactory");
          }
          e.componentFactoryName = l;
          var h;
          (function(f) {
            f[f.Pipe = 0] = "Pipe", f[f.Directive = 1] = "Directive", f[f.NgModule = 2] = "NgModule", f[f.Injectable = 3] = "Injectable";
          })(h = e.CompileSummaryKind || (e.CompileSummaryKind = {}));
          function C(f) {
            return f.value != null ? c(f.value) : a(f.identifier);
          }
          e.tokenName = C;
          function d(f) {
            return f.identifier != null ? f.identifier.reference : f.value;
          }
          e.tokenReference = d;
          var m = class {
            constructor() {
              let { moduleUrl: f, styles: F, styleUrls: P } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
              this.moduleUrl = f || null, this.styles = _(F), this.styleUrls = _(P);
            }
          };
          e.CompileStylesheetMetadata = m;
          var T = class {
            constructor(f) {
              let { encapsulation: F, template: P, templateUrl: j, htmlAst: W, styles: X, styleUrls: H, externalStylesheets: z2, animations: J, ngContentSelectors: Z, interpolation: ee, isInline: v, preserveWhitespaces: S } = f;
              if (this.encapsulation = F, this.template = P, this.templateUrl = j, this.htmlAst = W, this.styles = _(X), this.styleUrls = _(H), this.externalStylesheets = _(z2), this.animations = J ? x(J) : [], this.ngContentSelectors = Z || [], ee && ee.length != 2) throw new Error("'interpolation' should have a start and an end symbol.");
              this.interpolation = ee, this.isInline = v, this.preserveWhitespaces = S;
            }
            toSummary() {
              return { ngContentSelectors: this.ngContentSelectors, encapsulation: this.encapsulation, styles: this.styles, animations: this.animations };
            }
          };
          e.CompileTemplateMetadata = T;
          var B = class {
            static create(f) {
              let { isHost: F, type: P, isComponent: j, selector: W, exportAs: X, changeDetection: H, inputs: z2, outputs: J, host: Z, providers: ee, viewProviders: v, queries: S, guards: b, viewQueries: w, entryComponents: L, template: U, componentViewType: V, rendererType: Y, componentFactory: ue } = f, Be = {}, be = {}, Vr = {};
              Z != null && Object.keys(Z).forEach((re) => {
                let ne = Z[re], me = re.match(s);
                me === null ? Vr[re] = ne : me[1] != null ? be[me[1]] = ne : me[2] != null && (Be[me[2]] = ne);
              });
              let Xr = {};
              z2 != null && z2.forEach((re) => {
                let ne = t.splitAtColon(re, [re, re]);
                Xr[ne[0]] = ne[1];
              });
              let Hr = {};
              return J != null && J.forEach((re) => {
                let ne = t.splitAtColon(re, [re, re]);
                Hr[ne[0]] = ne[1];
              }), new B({ isHost: F, type: P, isComponent: !!j, selector: W, exportAs: X, changeDetection: H, inputs: Xr, outputs: Hr, hostListeners: Be, hostProperties: be, hostAttributes: Vr, providers: ee, viewProviders: v, queries: S, guards: b, viewQueries: w, entryComponents: L, template: U, componentViewType: V, rendererType: Y, componentFactory: ue });
            }
            constructor(f) {
              let { isHost: F, type: P, isComponent: j, selector: W, exportAs: X, changeDetection: H, inputs: z2, outputs: J, hostListeners: Z, hostProperties: ee, hostAttributes: v, providers: S, viewProviders: b, queries: w, guards: L, viewQueries: U, entryComponents: V, template: Y, componentViewType: ue, rendererType: Be, componentFactory: be } = f;
              this.isHost = !!F, this.type = P, this.isComponent = j, this.selector = W, this.exportAs = X, this.changeDetection = H, this.inputs = z2, this.outputs = J, this.hostListeners = Z, this.hostProperties = ee, this.hostAttributes = v, this.providers = _(S), this.viewProviders = _(b), this.queries = _(w), this.guards = L, this.viewQueries = _(U), this.entryComponents = _(V), this.template = Y, this.componentViewType = ue, this.rendererType = Be, this.componentFactory = be;
            }
            toSummary() {
              return { summaryKind: h.Directive, type: this.type, isComponent: this.isComponent, selector: this.selector, exportAs: this.exportAs, inputs: this.inputs, outputs: this.outputs, hostListeners: this.hostListeners, hostProperties: this.hostProperties, hostAttributes: this.hostAttributes, providers: this.providers, viewProviders: this.viewProviders, queries: this.queries, guards: this.guards, viewQueries: this.viewQueries, entryComponents: this.entryComponents, changeDetection: this.changeDetection, template: this.template && this.template.toSummary(), componentViewType: this.componentViewType, rendererType: this.rendererType, componentFactory: this.componentFactory };
            }
          };
          e.CompileDirectiveMetadata = B;
          var A = class {
            constructor(f) {
              let { type: F, name: P, pure: j } = f;
              this.type = F, this.name = P, this.pure = !!j;
            }
            toSummary() {
              return { summaryKind: h.Pipe, type: this.type, name: this.name, pure: this.pure };
            }
          };
          e.CompilePipeMetadata = A;
          var N = class {
          };
          e.CompileShallowModuleMetadata = N;
          var R = class {
            constructor(f) {
              let { type: F, providers: P, declaredDirectives: j, exportedDirectives: W, declaredPipes: X, exportedPipes: H, entryComponents: z2, bootstrapComponents: J, importedModules: Z, exportedModules: ee, schemas: v, transitiveModule: S, id: b } = f;
              this.type = F || null, this.declaredDirectives = _(j), this.exportedDirectives = _(W), this.declaredPipes = _(X), this.exportedPipes = _(H), this.providers = _(P), this.entryComponents = _(z2), this.bootstrapComponents = _(J), this.importedModules = _(Z), this.exportedModules = _(ee), this.schemas = _(v), this.id = b || null, this.transitiveModule = S || null;
            }
            toSummary() {
              let f = this.transitiveModule;
              return { summaryKind: h.NgModule, type: this.type, entryComponents: f.entryComponents, providers: f.providers, modules: f.modules, exportedDirectives: f.exportedDirectives, exportedPipes: f.exportedPipes };
            }
          };
          e.CompileNgModuleMetadata = R;
          var $ = class {
            constructor() {
              this.directivesSet = /* @__PURE__ */ new Set(), this.directives = [], this.exportedDirectivesSet = /* @__PURE__ */ new Set(), this.exportedDirectives = [], this.pipesSet = /* @__PURE__ */ new Set(), this.pipes = [], this.exportedPipesSet = /* @__PURE__ */ new Set(), this.exportedPipes = [], this.modulesSet = /* @__PURE__ */ new Set(), this.modules = [], this.entryComponentsSet = /* @__PURE__ */ new Set(), this.entryComponents = [], this.providers = [];
            }
            addProvider(f, F) {
              this.providers.push({ provider: f, module: F });
            }
            addDirective(f) {
              this.directivesSet.has(f.reference) || (this.directivesSet.add(f.reference), this.directives.push(f));
            }
            addExportedDirective(f) {
              this.exportedDirectivesSet.has(f.reference) || (this.exportedDirectivesSet.add(f.reference), this.exportedDirectives.push(f));
            }
            addPipe(f) {
              this.pipesSet.has(f.reference) || (this.pipesSet.add(f.reference), this.pipes.push(f));
            }
            addExportedPipe(f) {
              this.exportedPipesSet.has(f.reference) || (this.exportedPipesSet.add(f.reference), this.exportedPipes.push(f));
            }
            addModule(f) {
              this.modulesSet.has(f.reference) || (this.modulesSet.add(f.reference), this.modules.push(f));
            }
            addEntryComponent(f) {
              this.entryComponentsSet.has(f.componentType) || (this.entryComponentsSet.add(f.componentType), this.entryComponents.push(f));
            }
          };
          e.TransitiveCompileNgModuleMetadata = $;
          function _(f) {
            return f || [];
          }
          var O = class {
            constructor(f, F) {
              let { useClass: P, useValue: j, useExisting: W, useFactory: X, deps: H, multi: z2 } = F;
              this.token = f, this.useClass = P || null, this.useValue = j, this.useExisting = W, this.useFactory = X || null, this.dependencies = H || null, this.multi = !!z2;
            }
          };
          e.ProviderMeta = O;
          function x(f) {
            return f.reduce((F, P) => {
              let j = Array.isArray(P) ? x(P) : P;
              return F.concat(j);
            }, []);
          }
          e.flatten = x;
          function k(f) {
            return f.replace(/(\w+:\/\/[\w:-]+)?(\/+)?/, "ng:///");
          }
          function M(f, F, P) {
            let j;
            return P.isInline ? F.type.reference instanceof r.StaticSymbol ? j = "".concat(F.type.reference.filePath, ".").concat(F.type.reference.name, ".html") : j = "".concat(a(f), "/").concat(a(F.type), ".html") : j = P.templateUrl, F.type.reference instanceof r.StaticSymbol ? j : k(j);
          }
          e.templateSourceUrl = M;
          function u(f, F) {
            let P = f.moduleUrl.split(/\/\\/g), j = P[P.length - 1];
            return k("css/".concat(F).concat(j, ".ngstyle.js"));
          }
          e.sharedStylesheetJitUrl = u;
          function o(f) {
            return k("".concat(a(f.type), "/module.ngfactory.js"));
          }
          e.ngModuleJitUrl = o;
          function E(f, F) {
            return k("".concat(a(f), "/").concat(a(F.type), ".ngfactory.js"));
          }
          e.templateJitUrl = E;
        } }), Te = I({ "node_modules/angular-html-parser/lib/compiler/src/parse_util.js"(e) {
          "use strict";
          q(), Object.defineProperty(e, "__esModule", { value: true });
          var r = hs(), t = sD(), s = class {
            constructor(i, l, h, C) {
              this.file = i, this.offset = l, this.line = h, this.col = C;
            }
            toString() {
              return this.offset != null ? "".concat(this.file.url, "@").concat(this.line, ":").concat(this.col) : this.file.url;
            }
            moveBy(i) {
              let l = this.file.content, h = l.length, C = this.offset, d = this.line, m = this.col;
              for (; C > 0 && i < 0; ) if (C--, i++, l.charCodeAt(C) == r.$LF) {
                d--;
                let B = l.substr(0, C - 1).lastIndexOf(String.fromCharCode(r.$LF));
                m = B > 0 ? C - B : C;
              } else m--;
              for (; C < h && i > 0; ) {
                let T = l.charCodeAt(C);
                C++, i--, T == r.$LF ? (d++, m = 0) : m++;
              }
              return new s(this.file, C, d, m);
            }
            getContext(i, l) {
              let h = this.file.content, C = this.offset;
              if (C != null) {
                C > h.length - 1 && (C = h.length - 1);
                let d = C, m = 0, T = 0;
                for (; m < i && C > 0 && (C--, m++, !(h[C] == `
` && ++T == l)); ) ;
                for (m = 0, T = 0; m < i && d < h.length - 1 && (d++, m++, !(h[d] == `
` && ++T == l)); ) ;
                return { before: h.substring(C, this.offset), after: h.substring(this.offset, d + 1) };
              }
              return null;
            }
          };
          e.ParseLocation = s;
          var c = class {
            constructor(i, l) {
              this.content = i, this.url = l;
            }
          };
          e.ParseSourceFile = c;
          var n = class {
            constructor(i, l) {
              let h = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
              this.start = i, this.end = l, this.details = h;
            }
            toString() {
              return this.start.file.content.substring(this.start.offset, this.end.offset);
            }
          };
          e.ParseSourceSpan = n, e.EMPTY_PARSE_LOCATION = new s(new c("", ""), 0, 0, 0), e.EMPTY_SOURCE_SPAN = new n(e.EMPTY_PARSE_LOCATION, e.EMPTY_PARSE_LOCATION);
          var a;
          (function(i) {
            i[i.WARNING = 0] = "WARNING", i[i.ERROR = 1] = "ERROR";
          })(a = e.ParseErrorLevel || (e.ParseErrorLevel = {}));
          var p = class {
            constructor(i, l) {
              let h = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : a.ERROR;
              this.span = i, this.msg = l, this.level = h;
            }
            contextualMessage() {
              let i = this.span.start.getContext(100, 3);
              return i ? "".concat(this.msg, ' ("').concat(i.before, "[").concat(a[this.level], " ->]").concat(i.after, '")') : this.msg;
            }
            toString() {
              let i = this.span.details ? ", ".concat(this.span.details) : "";
              return "".concat(this.contextualMessage(), ": ").concat(this.span.start).concat(i);
            }
          };
          e.ParseError = p;
          function D(i, l) {
            let h = t.identifierModuleUrl(l), C = h != null ? "in ".concat(i, " ").concat(t.identifierName(l), " in ").concat(h) : "in ".concat(i, " ").concat(t.identifierName(l)), d = new c("", C);
            return new n(new s(d, -1, -1, -1), new s(d, -1, -1, -1));
          }
          e.typeSourceSpan = D;
          function g(i, l, h) {
            let C = "in ".concat(i, " ").concat(l, " in ").concat(h), d = new c("", C);
            return new n(new s(d, -1, -1, -1), new s(d, -1, -1, -1));
          }
          e.r3JitTypeSourceSpan = g;
        } }), aD = I({ "src/utils/front-matter/parse.js"(e, r) {
          "use strict";
          q();
          var t = new RegExp("^(?<startDelimiter>-{3}|\\+{3})(?<language>[^\\n]*)\\n(?:|(?<value>.*?)\\n)(?<endDelimiter>\\k<startDelimiter>|\\.{3})[^\\S\\n]*(?:\\n|$)", "s");
          function s(c) {
            let n = c.match(t);
            if (!n) return { content: c };
            let { startDelimiter: a, language: p, value: D = "", endDelimiter: g } = n.groups, i = p.trim() || "yaml";
            if (a === "+++" && (i = "toml"), i !== "yaml" && a !== g) return { content: c };
            let [l] = n;
            return { frontMatter: { type: "front-matter", lang: i, value: D, startDelimiter: a, endDelimiter: g, raw: l.replace(/\n$/, "") }, content: l.replace(/[^\n]/g, " ") + c.slice(l.length) };
          }
          r.exports = s;
        } }), ps = I({ "src/utils/get-last.js"(e, r) {
          "use strict";
          q();
          var t = (s) => s[s.length - 1];
          r.exports = t;
        } }), iD = I({ "src/common/parser-create-error.js"(e, r) {
          "use strict";
          q();
          function t(s, c) {
            let n = new SyntaxError(s + " (" + c.start.line + ":" + c.start.column + ")");
            return n.loc = c, n;
          }
          r.exports = t;
        } }), fs = {};
        cs(fs, { default: () => oD });
        function oD(e) {
          if (typeof e != "string") throw new TypeError("Expected a string");
          return e.replace(/[|\\{}()[\]^$+*?.]/g, "\\$&").replace(/-/g, "\\x2d");
        }
        var cD = Ce({ "node_modules/escape-string-regexp/index.js"() {
          q();
        } }), ds = I({ "node_modules/semver/internal/debug.js"(e, r) {
          q();
          var t = typeof ye == "object" && ye.env && ye.env.NODE_DEBUG && /\bsemver\b/i.test(ye.env.NODE_DEBUG) ? function() {
            for (var s = arguments.length, c = new Array(s), n = 0; n < s; n++) c[n] = arguments[n];
            return console.error("SEMVER", ...c);
          } : () => {
          };
          r.exports = t;
        } }), Es = I({ "node_modules/semver/internal/constants.js"(e, r) {
          q();
          var t = "2.0.0", s = 256, c = Number.MAX_SAFE_INTEGER || 9007199254740991, n = 16;
          r.exports = { SEMVER_SPEC_VERSION: t, MAX_LENGTH: s, MAX_SAFE_INTEGER: c, MAX_SAFE_COMPONENT_LENGTH: n };
        } }), DD = I({ "node_modules/semver/internal/re.js"(e, r) {
          q();
          var { MAX_SAFE_COMPONENT_LENGTH: t } = Es(), s = ds();
          e = r.exports = {};
          var c = e.re = [], n = e.src = [], a = e.t = {}, p = 0, D = (g, i, l) => {
            let h = p++;
            s(g, h, i), a[g] = h, n[h] = i, c[h] = new RegExp(i, l ? "g" : void 0);
          };
          D("NUMERICIDENTIFIER", "0|[1-9]\\d*"), D("NUMERICIDENTIFIERLOOSE", "[0-9]+"), D("NONNUMERICIDENTIFIER", "\\d*[a-zA-Z-][a-zA-Z0-9-]*"), D("MAINVERSION", "(".concat(n[a.NUMERICIDENTIFIER], ")\\.(").concat(n[a.NUMERICIDENTIFIER], ")\\.(").concat(n[a.NUMERICIDENTIFIER], ")")), D("MAINVERSIONLOOSE", "(".concat(n[a.NUMERICIDENTIFIERLOOSE], ")\\.(").concat(n[a.NUMERICIDENTIFIERLOOSE], ")\\.(").concat(n[a.NUMERICIDENTIFIERLOOSE], ")")), D("PRERELEASEIDENTIFIER", "(?:".concat(n[a.NUMERICIDENTIFIER], "|").concat(n[a.NONNUMERICIDENTIFIER], ")")), D("PRERELEASEIDENTIFIERLOOSE", "(?:".concat(n[a.NUMERICIDENTIFIERLOOSE], "|").concat(n[a.NONNUMERICIDENTIFIER], ")")), D("PRERELEASE", "(?:-(".concat(n[a.PRERELEASEIDENTIFIER], "(?:\\.").concat(n[a.PRERELEASEIDENTIFIER], ")*))")), D("PRERELEASELOOSE", "(?:-?(".concat(n[a.PRERELEASEIDENTIFIERLOOSE], "(?:\\.").concat(n[a.PRERELEASEIDENTIFIERLOOSE], ")*))")), D("BUILDIDENTIFIER", "[0-9A-Za-z-]+"), D("BUILD", "(?:\\+(".concat(n[a.BUILDIDENTIFIER], "(?:\\.").concat(n[a.BUILDIDENTIFIER], ")*))")), D("FULLPLAIN", "v?".concat(n[a.MAINVERSION]).concat(n[a.PRERELEASE], "?").concat(n[a.BUILD], "?")), D("FULL", "^".concat(n[a.FULLPLAIN], "$")), D("LOOSEPLAIN", "[v=\\s]*".concat(n[a.MAINVERSIONLOOSE]).concat(n[a.PRERELEASELOOSE], "?").concat(n[a.BUILD], "?")), D("LOOSE", "^".concat(n[a.LOOSEPLAIN], "$")), D("GTLT", "((?:<|>)?=?)"), D("XRANGEIDENTIFIERLOOSE", "".concat(n[a.NUMERICIDENTIFIERLOOSE], "|x|X|\\*")), D("XRANGEIDENTIFIER", "".concat(n[a.NUMERICIDENTIFIER], "|x|X|\\*")), D("XRANGEPLAIN", "[v=\\s]*(".concat(n[a.XRANGEIDENTIFIER], ")(?:\\.(").concat(n[a.XRANGEIDENTIFIER], ")(?:\\.(").concat(n[a.XRANGEIDENTIFIER], ")(?:").concat(n[a.PRERELEASE], ")?").concat(n[a.BUILD], "?)?)?")), D("XRANGEPLAINLOOSE", "[v=\\s]*(".concat(n[a.XRANGEIDENTIFIERLOOSE], ")(?:\\.(").concat(n[a.XRANGEIDENTIFIERLOOSE], ")(?:\\.(").concat(n[a.XRANGEIDENTIFIERLOOSE], ")(?:").concat(n[a.PRERELEASELOOSE], ")?").concat(n[a.BUILD], "?)?)?")), D("XRANGE", "^".concat(n[a.GTLT], "\\s*").concat(n[a.XRANGEPLAIN], "$")), D("XRANGELOOSE", "^".concat(n[a.GTLT], "\\s*").concat(n[a.XRANGEPLAINLOOSE], "$")), D("COERCE", "(^|[^\\d])(\\d{1,".concat(t, "})(?:\\.(\\d{1,").concat(t, "}))?(?:\\.(\\d{1,").concat(t, "}))?(?:$|[^\\d])")), D("COERCERTL", n[a.COERCE], true), D("LONETILDE", "(?:~>?)"), D("TILDETRIM", "(\\s*)".concat(n[a.LONETILDE], "\\s+"), true), e.tildeTrimReplace = "$1~", D("TILDE", "^".concat(n[a.LONETILDE]).concat(n[a.XRANGEPLAIN], "$")), D("TILDELOOSE", "^".concat(n[a.LONETILDE]).concat(n[a.XRANGEPLAINLOOSE], "$")), D("LONECARET", "(?:\\^)"), D("CARETTRIM", "(\\s*)".concat(n[a.LONECARET], "\\s+"), true), e.caretTrimReplace = "$1^", D("CARET", "^".concat(n[a.LONECARET]).concat(n[a.XRANGEPLAIN], "$")), D("CARETLOOSE", "^".concat(n[a.LONECARET]).concat(n[a.XRANGEPLAINLOOSE], "$")), D("COMPARATORLOOSE", "^".concat(n[a.GTLT], "\\s*(").concat(n[a.LOOSEPLAIN], ")$|^$")), D("COMPARATOR", "^".concat(n[a.GTLT], "\\s*(").concat(n[a.FULLPLAIN], ")$|^$")), D("COMPARATORTRIM", "(\\s*)".concat(n[a.GTLT], "\\s*(").concat(n[a.LOOSEPLAIN], "|").concat(n[a.XRANGEPLAIN], ")"), true), e.comparatorTrimReplace = "$1$2$3", D("HYPHENRANGE", "^\\s*(".concat(n[a.XRANGEPLAIN], ")\\s+-\\s+(").concat(n[a.XRANGEPLAIN], ")\\s*$")), D("HYPHENRANGELOOSE", "^\\s*(".concat(n[a.XRANGEPLAINLOOSE], ")\\s+-\\s+(").concat(n[a.XRANGEPLAINLOOSE], ")\\s*$")), D("STAR", "(<|>)?=?\\s*\\*"), D("GTE0", "^\\s*>=\\s*0\\.0\\.0\\s*$"), D("GTE0PRE", "^\\s*>=\\s*0\\.0\\.0-0\\s*$");
        } }), lD = I({ "node_modules/semver/internal/parse-options.js"(e, r) {
          q();
          var t = ["includePrerelease", "loose", "rtl"], s = (c) => c ? typeof c != "object" ? { loose: true } : t.filter((n) => c[n]).reduce((n, a) => (n[a] = true, n), {}) : {};
          r.exports = s;
        } }), hD = I({ "node_modules/semver/internal/identifiers.js"(e, r) {
          q();
          var t = /^[0-9]+$/, s = (n, a) => {
            let p = t.test(n), D = t.test(a);
            return p && D && (n = +n, a = +a), n === a ? 0 : p && !D ? -1 : D && !p ? 1 : n < a ? -1 : 1;
          }, c = (n, a) => s(a, n);
          r.exports = { compareIdentifiers: s, rcompareIdentifiers: c };
        } }), pD = I({ "node_modules/semver/classes/semver.js"(e, r) {
          q();
          var t = ds(), { MAX_LENGTH: s, MAX_SAFE_INTEGER: c } = Es(), { re: n, t: a } = DD(), p = lD(), { compareIdentifiers: D } = hD(), g = class {
            constructor(i, l) {
              if (l = p(l), i instanceof g) {
                if (i.loose === !!l.loose && i.includePrerelease === !!l.includePrerelease) return i;
                i = i.version;
              } else if (typeof i != "string") throw new TypeError("Invalid Version: ".concat(i));
              if (i.length > s) throw new TypeError("version is longer than ".concat(s, " characters"));
              t("SemVer", i, l), this.options = l, this.loose = !!l.loose, this.includePrerelease = !!l.includePrerelease;
              let h = i.trim().match(l.loose ? n[a.LOOSE] : n[a.FULL]);
              if (!h) throw new TypeError("Invalid Version: ".concat(i));
              if (this.raw = i, this.major = +h[1], this.minor = +h[2], this.patch = +h[3], this.major > c || this.major < 0) throw new TypeError("Invalid major version");
              if (this.minor > c || this.minor < 0) throw new TypeError("Invalid minor version");
              if (this.patch > c || this.patch < 0) throw new TypeError("Invalid patch version");
              h[4] ? this.prerelease = h[4].split(".").map((C) => {
                if (/^[0-9]+$/.test(C)) {
                  let d = +C;
                  if (d >= 0 && d < c) return d;
                }
                return C;
              }) : this.prerelease = [], this.build = h[5] ? h[5].split(".") : [], this.format();
            }
            format() {
              return this.version = "".concat(this.major, ".").concat(this.minor, ".").concat(this.patch), this.prerelease.length && (this.version += "-".concat(this.prerelease.join("."))), this.version;
            }
            toString() {
              return this.version;
            }
            compare(i) {
              if (t("SemVer.compare", this.version, this.options, i), !(i instanceof g)) {
                if (typeof i == "string" && i === this.version) return 0;
                i = new g(i, this.options);
              }
              return i.version === this.version ? 0 : this.compareMain(i) || this.comparePre(i);
            }
            compareMain(i) {
              return i instanceof g || (i = new g(i, this.options)), D(this.major, i.major) || D(this.minor, i.minor) || D(this.patch, i.patch);
            }
            comparePre(i) {
              if (i instanceof g || (i = new g(i, this.options)), this.prerelease.length && !i.prerelease.length) return -1;
              if (!this.prerelease.length && i.prerelease.length) return 1;
              if (!this.prerelease.length && !i.prerelease.length) return 0;
              let l = 0;
              do {
                let h = this.prerelease[l], C = i.prerelease[l];
                if (t("prerelease compare", l, h, C), h === void 0 && C === void 0) return 0;
                if (C === void 0) return 1;
                if (h === void 0) return -1;
                if (h === C) continue;
                return D(h, C);
              } while (++l);
            }
            compareBuild(i) {
              i instanceof g || (i = new g(i, this.options));
              let l = 0;
              do {
                let h = this.build[l], C = i.build[l];
                if (t("prerelease compare", l, h, C), h === void 0 && C === void 0) return 0;
                if (C === void 0) return 1;
                if (h === void 0) return -1;
                if (h === C) continue;
                return D(h, C);
              } while (++l);
            }
            inc(i, l) {
              switch (i) {
                case "premajor":
                  this.prerelease.length = 0, this.patch = 0, this.minor = 0, this.major++, this.inc("pre", l);
                  break;
                case "preminor":
                  this.prerelease.length = 0, this.patch = 0, this.minor++, this.inc("pre", l);
                  break;
                case "prepatch":
                  this.prerelease.length = 0, this.inc("patch", l), this.inc("pre", l);
                  break;
                case "prerelease":
                  this.prerelease.length === 0 && this.inc("patch", l), this.inc("pre", l);
                  break;
                case "major":
                  (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) && this.major++, this.minor = 0, this.patch = 0, this.prerelease = [];
                  break;
                case "minor":
                  (this.patch !== 0 || this.prerelease.length === 0) && this.minor++, this.patch = 0, this.prerelease = [];
                  break;
                case "patch":
                  this.prerelease.length === 0 && this.patch++, this.prerelease = [];
                  break;
                case "pre":
                  if (this.prerelease.length === 0) this.prerelease = [0];
                  else {
                    let h = this.prerelease.length;
                    for (; --h >= 0; ) typeof this.prerelease[h] == "number" && (this.prerelease[h]++, h = -2);
                    h === -1 && this.prerelease.push(0);
                  }
                  l && (D(this.prerelease[0], l) === 0 ? isNaN(this.prerelease[1]) && (this.prerelease = [l, 0]) : this.prerelease = [l, 0]);
                  break;
                default:
                  throw new Error("invalid increment argument: ".concat(i));
              }
              return this.format(), this.raw = this.version, this;
            }
          };
          r.exports = g;
        } }), Ur = I({ "node_modules/semver/functions/compare.js"(e, r) {
          q();
          var t = pD(), s = (c, n, a) => new t(c, a).compare(new t(n, a));
          r.exports = s;
        } }), fD = I({ "node_modules/semver/functions/lt.js"(e, r) {
          q();
          var t = Ur(), s = (c, n, a) => t(c, n, a) < 0;
          r.exports = s;
        } }), dD = I({ "node_modules/semver/functions/gte.js"(e, r) {
          q();
          var t = Ur(), s = (c, n, a) => t(c, n, a) >= 0;
          r.exports = s;
        } }), ED = I({ "src/utils/arrayify.js"(e, r) {
          "use strict";
          q(), r.exports = (t, s) => Object.entries(t).map((c) => {
            let [n, a] = c;
            return Object.assign({ [s]: n }, a);
          });
        } }), CD = I({ "package.json"(e, r) {
          r.exports = { version: "2.7.1" };
        } }), mD = I({ "node_modules/outdent/lib/index.js"(e, r) {
          "use strict";
          q(), Object.defineProperty(e, "__esModule", { value: true }), e.outdent = void 0;
          function t() {
            for (var A = [], N = 0; N < arguments.length; N++) A[N] = arguments[N];
          }
          function s() {
            return typeof WeakMap < "u" ? /* @__PURE__ */ new WeakMap() : c();
          }
          function c() {
            return { add: t, delete: t, get: t, set: t, has: function(A) {
              return false;
            } };
          }
          var n = Object.prototype.hasOwnProperty, a = function(A, N) {
            return n.call(A, N);
          };
          function p(A, N) {
            for (var R in N) a(N, R) && (A[R] = N[R]);
            return A;
          }
          var D = /^[ \t]*(?:\r\n|\r|\n)/, g = /(?:\r\n|\r|\n)[ \t]*$/, i = /^(?:[\r\n]|$)/, l = /(?:\r\n|\r|\n)([ \t]*)(?:[^ \t\r\n]|$)/, h = /^[ \t]*[\r\n][ \t\r\n]*$/;
          function C(A, N, R) {
            var $ = 0, _ = A[0].match(l);
            _ && ($ = _[1].length);
            var O = "(\\r\\n|\\r|\\n).{0," + $ + "}", x = new RegExp(O, "g");
            N && (A = A.slice(1));
            var k = R.newline, M = R.trimLeadingNewline, u = R.trimTrailingNewline, o = typeof k == "string", E = A.length, f = A.map(function(F, P) {
              return F = F.replace(x, "$1"), P === 0 && M && (F = F.replace(D, "")), P === E - 1 && u && (F = F.replace(g, "")), o && (F = F.replace(/\r\n|\n|\r/g, function(j) {
                return k;
              })), F;
            });
            return f;
          }
          function d(A, N) {
            for (var R = "", $ = 0, _ = A.length; $ < _; $++) R += A[$], $ < _ - 1 && (R += N[$]);
            return R;
          }
          function m(A) {
            return a(A, "raw") && a(A, "length");
          }
          function T(A) {
            var N = s(), R = s();
            function $(O) {
              for (var x = [], k = 1; k < arguments.length; k++) x[k - 1] = arguments[k];
              if (m(O)) {
                var M = O, u = (x[0] === $ || x[0] === B) && h.test(M[0]) && i.test(M[1]), o = u ? R : N, E = o.get(M);
                if (E || (E = C(M, u, A), o.set(M, E)), x.length === 0) return E[0];
                var f = d(E, u ? x.slice(1) : x);
                return f;
              } else return T(p(p({}, A), O || {}));
            }
            var _ = p($, { string: function(O) {
              return C([O], false, A)[0];
            } });
            return _;
          }
          var B = T({ trimLeadingNewline: true, trimTrailingNewline: true });
          if (e.outdent = B, e.default = B, typeof r < "u") try {
            r.exports = B, Object.defineProperty(B, "__esModule", { value: true }), B.default = B, B.outdent = B;
          } catch {
          }
        } }), gD = I({ "src/main/core-options.js"(e, r) {
          "use strict";
          q();
          var { outdent: t } = mD(), s = "Config", c = "Editor", n = "Format", a = "Other", p = "Output", D = "Global", g = "Special", i = { cursorOffset: { since: "1.4.0", category: g, type: "int", default: -1, range: { start: -1, end: Number.POSITIVE_INFINITY, step: 1 }, description: t(Jn || (Jn = Ee([`
      Print (to stderr) where a cursor at the given position would move to after formatting.
      This option cannot be used with --range-start and --range-end.
    `]))), cliCategory: c }, endOfLine: { since: "1.15.0", category: D, type: "choice", default: [{ since: "1.15.0", value: "auto" }, { since: "2.0.0", value: "lf" }], description: "Which end of line characters to apply.", choices: [{ value: "lf", description: "Line Feed only (\\n), common on Linux and macOS as well as inside git repos" }, { value: "crlf", description: "Carriage Return + Line Feed characters (\\r\\n), common on Windows" }, { value: "cr", description: "Carriage Return character only (\\r), used very rarely" }, { value: "auto", description: t(Zn || (Zn = Ee([`
          Maintain existing
          (mixed values within one file are normalised by looking at what's used after the first line)
        `]))) }] }, filepath: { since: "1.4.0", category: g, type: "path", description: "Specify the input filepath. This will be used to do parser inference.", cliName: "stdin-filepath", cliCategory: a, cliDescription: "Path to the file to pretend that stdin comes from." }, insertPragma: { since: "1.8.0", category: g, type: "boolean", default: false, description: "Insert @format pragma into file's first docblock comment.", cliCategory: a }, parser: { since: "0.0.10", category: D, type: "choice", default: [{ since: "0.0.10", value: "babylon" }, { since: "1.13.0", value: void 0 }], description: "Which parser to use.", exception: (l) => typeof l == "string" || typeof l == "function", choices: [{ value: "flow", description: "Flow" }, { value: "babel", since: "1.16.0", description: "JavaScript" }, { value: "babel-flow", since: "1.16.0", description: "Flow" }, { value: "babel-ts", since: "2.0.0", description: "TypeScript" }, { value: "typescript", since: "1.4.0", description: "TypeScript" }, { value: "acorn", since: "2.6.0", description: "JavaScript" }, { value: "espree", since: "2.2.0", description: "JavaScript" }, { value: "meriyah", since: "2.2.0", description: "JavaScript" }, { value: "css", since: "1.7.1", description: "CSS" }, { value: "less", since: "1.7.1", description: "Less" }, { value: "scss", since: "1.7.1", description: "SCSS" }, { value: "json", since: "1.5.0", description: "JSON" }, { value: "json5", since: "1.13.0", description: "JSON5" }, { value: "json-stringify", since: "1.13.0", description: "JSON.stringify" }, { value: "graphql", since: "1.5.0", description: "GraphQL" }, { value: "markdown", since: "1.8.0", description: "Markdown" }, { value: "mdx", since: "1.15.0", description: "MDX" }, { value: "vue", since: "1.10.0", description: "Vue" }, { value: "yaml", since: "1.14.0", description: "YAML" }, { value: "glimmer", since: "2.3.0", description: "Ember / Handlebars" }, { value: "html", since: "1.15.0", description: "HTML" }, { value: "angular", since: "1.15.0", description: "Angular" }, { value: "lwc", since: "1.17.0", description: "Lightning Web Components" }] }, plugins: { since: "1.10.0", type: "path", array: true, default: [{ value: [] }], category: D, description: "Add a plugin. Multiple plugins can be passed as separate `--plugin`s.", exception: (l) => typeof l == "string" || typeof l == "object", cliName: "plugin", cliCategory: s }, pluginSearchDirs: { since: "1.13.0", type: "path", array: true, default: [{ value: [] }], category: D, description: t(es || (es = Ee([`
      Custom directory that contains prettier plugins in node_modules subdirectory.
      Overrides default behavior when plugins are searched relatively to the location of Prettier.
      Multiple values are accepted.
    `]))), exception: (l) => typeof l == "string" || typeof l == "object", cliName: "plugin-search-dir", cliCategory: s }, printWidth: { since: "0.0.0", category: D, type: "int", default: 80, description: "The line length where Prettier will try wrap.", range: { start: 0, end: Number.POSITIVE_INFINITY, step: 1 } }, rangeEnd: { since: "1.4.0", category: g, type: "int", default: Number.POSITIVE_INFINITY, range: { start: 0, end: Number.POSITIVE_INFINITY, step: 1 }, description: t(rs || (rs = Ee([`
      Format code ending at a given character offset (exclusive).
      The range will extend forwards to the end of the selected statement.
      This option cannot be used with --cursor-offset.
    `]))), cliCategory: c }, rangeStart: { since: "1.4.0", category: g, type: "int", default: 0, range: { start: 0, end: Number.POSITIVE_INFINITY, step: 1 }, description: t(ts || (ts = Ee([`
      Format code starting at a given character offset.
      The range will extend backwards to the start of the first line containing the selected statement.
      This option cannot be used with --cursor-offset.
    `]))), cliCategory: c }, requirePragma: { since: "1.7.0", category: g, type: "boolean", default: false, description: t(us || (us = Ee([`
      Require either '@prettier' or '@format' to be present in the file's first docblock comment
      in order for it to be formatted.
    `]))), cliCategory: a }, tabWidth: { type: "int", category: D, default: 2, description: "Number of spaces per indentation level.", range: { start: 0, end: Number.POSITIVE_INFINITY, step: 1 } }, useTabs: { since: "1.0.0", category: D, type: "boolean", default: false, description: "Indent with tabs instead of spaces." }, embeddedLanguageFormatting: { since: "2.1.0", category: D, type: "choice", default: [{ since: "2.1.0", value: "auto" }], description: "Control how Prettier formats quoted code embedded in the file.", choices: [{ value: "auto", description: "Format embedded code if Prettier can automatically identify it." }, { value: "off", description: "Never automatically format embedded code." }] } };
          r.exports = { CATEGORY_CONFIG: s, CATEGORY_EDITOR: c, CATEGORY_FORMAT: n, CATEGORY_OTHER: a, CATEGORY_OUTPUT: p, CATEGORY_GLOBAL: D, CATEGORY_SPECIAL: g, options: i };
        } }), FD = I({ "src/main/support.js"(e, r) {
          "use strict";
          q();
          var t = { compare: Ur(), lt: fD(), gte: dD() }, s = ED(), c = CD().version, n = gD().options;
          function a() {
            let { plugins: D = [], showUnreleased: g = false, showDeprecated: i = false, showInternal: l = false } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, h = c.split("-", 1)[0], C = D.flatMap((A) => A.languages || []).filter(m), d = s(Object.assign({}, ...D.map((A) => {
              let { options: N } = A;
              return N;
            }), n), "name").filter((A) => m(A) && T(A)).sort((A, N) => A.name === N.name ? 0 : A.name < N.name ? -1 : 1).map(B).map((A) => {
              A = Object.assign({}, A), Array.isArray(A.default) && (A.default = A.default.length === 1 ? A.default[0].value : A.default.filter(m).sort((R, $) => t.compare($.since, R.since))[0].value), Array.isArray(A.choices) && (A.choices = A.choices.filter((R) => m(R) && T(R)), A.name === "parser" && p(A, C, D));
              let N = Object.fromEntries(D.filter((R) => R.defaultOptions && R.defaultOptions[A.name] !== void 0).map((R) => [R.name, R.defaultOptions[A.name]]));
              return Object.assign(Object.assign({}, A), {}, { pluginDefaults: N });
            });
            return { languages: C, options: d };
            function m(A) {
              return g || !("since" in A) || A.since && t.gte(h, A.since);
            }
            function T(A) {
              return i || !("deprecated" in A) || A.deprecated && t.lt(h, A.deprecated);
            }
            function B(A) {
              if (l) return A;
              let { cliName: N, cliCategory: R, cliDescription: $ } = A;
              return Qc(A, Yc);
            }
          }
          function p(D, g, i) {
            let l = new Set(D.choices.map((h) => h.value));
            for (let h of g) if (h.parsers) {
              for (let C of h.parsers) if (!l.has(C)) {
                l.add(C);
                let d = i.find((T) => T.parsers && T.parsers[C]), m = h.name;
                d && d.name && (m += " (plugin: ".concat(d.name, ")")), D.choices.push({ value: C, description: m });
              }
            }
          }
          r.exports = { getSupportInfo: a };
        } }), AD = I({ "src/utils/is-non-empty-array.js"(e, r) {
          "use strict";
          q();
          function t(s) {
            return Array.isArray(s) && s.length > 0;
          }
          r.exports = t;
        } });
        function vD() {
          let { onlyFirst: e = false } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, r = ["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)", "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"].join("|");
          return new RegExp(r, e ? void 0 : "g");
        }
        var _D = Ce({ "node_modules/strip-ansi/node_modules/ansi-regex/index.js"() {
          q();
        } });
        function SD(e) {
          if (typeof e != "string") throw new TypeError("Expected a `string`, got `".concat(typeof e, "`"));
          return e.replace(vD(), "");
        }
        var yD = Ce({ "node_modules/strip-ansi/index.js"() {
          q(), _D();
        } });
        function TD(e) {
          return Number.isInteger(e) ? e >= 4352 && (e <= 4447 || e === 9001 || e === 9002 || 11904 <= e && e <= 12871 && e !== 12351 || 12880 <= e && e <= 19903 || 19968 <= e && e <= 42182 || 43360 <= e && e <= 43388 || 44032 <= e && e <= 55203 || 63744 <= e && e <= 64255 || 65040 <= e && e <= 65049 || 65072 <= e && e <= 65131 || 65281 <= e && e <= 65376 || 65504 <= e && e <= 65510 || 110592 <= e && e <= 110593 || 127488 <= e && e <= 127569 || 131072 <= e && e <= 262141) : false;
        }
        var BD = Ce({ "node_modules/is-fullwidth-code-point/index.js"() {
          q();
        } }), bD = I({ "node_modules/emoji-regex/index.js"(e, r) {
          "use strict";
          q(), r.exports = function() {
            return /\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67)\uDB40\uDC7F|(?:\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFE])|(?:\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFC-\uDFFF])|\uD83D\uDC68(?:\uD83C\uDFFB(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFC-\uDFFF])|[\u2695\u2696\u2708]\uFE0F|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))?|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFE])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])\uFE0F|\u200D(?:(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D[\uDC66\uDC67])|\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC)?|(?:\uD83D\uDC69(?:\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69]))|\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1)(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC69(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83E\uDDD1(?:\u200D(?:\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D\uDC69\u200D\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83E\uDDD1(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDC69(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDE36\u200D\uD83C\uDF2B|\uD83C\uDFF3\uFE0F\u200D\u26A7|\uD83D\uDC3B\u200D\u2744|(?:(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF])\u200D[\u2640\u2642]|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\uD83C\uDFF4\u200D\u2620|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])\u200D[\u2640\u2642]|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u2600-\u2604\u260E\u2611\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26B0\u26B1\u26C8\u26CF\u26D1\u26D3\u26E9\u26F0\u26F1\u26F4\u26F7\u26F8\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u3030\u303D\u3297\u3299]|\uD83C[\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]|\uD83D[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3])\uFE0F|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC69\u200D\uD83D\uDC67|\uD83D\uDC69\u200D\uD83D\uDC66|\uD83D\uDE35\u200D\uD83D\uDCAB|\uD83D\uDE2E\u200D\uD83D\uDCA8|\uD83D\uDC15\u200D\uD83E\uDDBA|\uD83E\uDDD1(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83D\uDC69(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDF6\uD83C\uDDE6|\uD83C\uDDF4\uD83C\uDDF2|\uD83D\uDC08\u200D\u2B1B|\u2764\uFE0F\u200D(?:\uD83D\uDD25|\uD83E\uDE79)|\uD83D\uDC41\uFE0F|\uD83C\uDFF3\uFE0F|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|[#\*0-9]\uFE0F\u20E3|\u2764\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|\uD83C\uDFF4|(?:[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u261D\u270C\u270D]|\uD83D[\uDD74\uDD90])(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC08\uDC15\uDC3B\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE2E\uDE35\uDE36\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5]|\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD]|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF]|[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0D\uDD0E\uDD10-\uDD17\uDD1D\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78\uDD7A-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCB\uDDD0\uDDE0-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6]|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26A7\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDED5-\uDED7\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])\uFE0F|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDC8F\uDC91\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1F\uDD26\uDD30-\uDD39\uDD3C-\uDD3E\uDD77\uDDB5\uDDB6\uDDB8\uDDB9\uDDBB\uDDCD-\uDDCF\uDDD1-\uDDDD])/g;
          };
        } }), Cs = {};
        cs(Cs, { default: () => wD });
        function wD(e) {
          if (typeof e != "string" || e.length === 0 || (e = SD(e), e.length === 0)) return 0;
          e = e.replace((0, ms.default)(), "  ");
          let r = 0;
          for (let t = 0; t < e.length; t++) {
            let s = e.codePointAt(t);
            s <= 31 || s >= 127 && s <= 159 || s >= 768 && s <= 879 || (s > 65535 && t++, r += TD(s) ? 2 : 1);
          }
          return r;
        }
        var ms, ND = Ce({ "node_modules/string-width/index.js"() {
          q(), yD(), BD(), ms = tD(bD());
        } }), OD = I({ "src/utils/get-string-width.js"(e, r) {
          "use strict";
          q();
          var t = (ND(), ls(Cs)).default, s = /[^\x20-\x7F]/;
          function c(n) {
            return n ? s.test(n) ? t(n) : n.length : 0;
          }
          r.exports = c;
        } }), Gr = I({ "src/utils/text/skip.js"(e, r) {
          "use strict";
          q();
          function t(p) {
            return (D, g, i) => {
              let l = i && i.backwards;
              if (g === false) return false;
              let { length: h } = D, C = g;
              for (; C >= 0 && C < h; ) {
                let d = D.charAt(C);
                if (p instanceof RegExp) {
                  if (!p.test(d)) return C;
                } else if (!p.includes(d)) return C;
                l ? C-- : C++;
              }
              return C === -1 || C === h ? C : false;
            };
          }
          var s = t(/\s/), c = t(" 	"), n = t(",; 	"), a = t(/[^\n\r]/);
          r.exports = { skipWhitespace: s, skipSpaces: c, skipToLineEnd: n, skipEverythingButNewLine: a };
        } }), gs = I({ "src/utils/text/skip-inline-comment.js"(e, r) {
          "use strict";
          q();
          function t(s, c) {
            if (c === false) return false;
            if (s.charAt(c) === "/" && s.charAt(c + 1) === "*") {
              for (let n = c + 2; n < s.length; ++n) if (s.charAt(n) === "*" && s.charAt(n + 1) === "/") return n + 2;
            }
            return c;
          }
          r.exports = t;
        } }), Fs = I({ "src/utils/text/skip-trailing-comment.js"(e, r) {
          "use strict";
          q();
          var { skipEverythingButNewLine: t } = Gr();
          function s(c, n) {
            return n === false ? false : c.charAt(n) === "/" && c.charAt(n + 1) === "/" ? t(c, n) : n;
          }
          r.exports = s;
        } }), As = I({ "src/utils/text/skip-newline.js"(e, r) {
          "use strict";
          q();
          function t(s, c, n) {
            let a = n && n.backwards;
            if (c === false) return false;
            let p = s.charAt(c);
            if (a) {
              if (s.charAt(c - 1) === "\r" && p === `
`) return c - 2;
              if (p === `
` || p === "\r" || p === "\u2028" || p === "\u2029") return c - 1;
            } else {
              if (p === "\r" && s.charAt(c + 1) === `
`) return c + 2;
              if (p === `
` || p === "\r" || p === "\u2028" || p === "\u2029") return c + 1;
            }
            return c;
          }
          r.exports = t;
        } }), qD = I({ "src/utils/text/get-next-non-space-non-comment-character-index-with-start-index.js"(e, r) {
          "use strict";
          q();
          var t = gs(), s = As(), c = Fs(), { skipSpaces: n } = Gr();
          function a(p, D) {
            let g = null, i = D;
            for (; i !== g; ) g = i, i = n(p, i), i = t(p, i), i = c(p, i), i = s(p, i);
            return i;
          }
          r.exports = a;
        } }), ID = I({ "src/common/util.js"(e, r) {
          "use strict";
          q();
          var { default: t } = (cD(), ls(fs)), s = ps(), { getSupportInfo: c } = FD(), n = AD(), a = OD(), { skipWhitespace: p, skipSpaces: D, skipToLineEnd: g, skipEverythingButNewLine: i } = Gr(), l = gs(), h = Fs(), C = As(), d = qD(), m = (v) => v[v.length - 2];
          function T(v) {
            return (S, b, w) => {
              let L = w && w.backwards;
              if (b === false) return false;
              let { length: U } = S, V = b;
              for (; V >= 0 && V < U; ) {
                let Y = S.charAt(V);
                if (v instanceof RegExp) {
                  if (!v.test(Y)) return V;
                } else if (!v.includes(Y)) return V;
                L ? V-- : V++;
              }
              return V === -1 || V === U ? V : false;
            };
          }
          function B(v, S) {
            let b = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, w = D(v, b.backwards ? S - 1 : S, b), L = C(v, w, b);
            return w !== L;
          }
          function A(v, S, b) {
            for (let w = S; w < b; ++w) if (v.charAt(w) === `
`) return true;
            return false;
          }
          function N(v, S, b) {
            let w = b(S) - 1;
            w = D(v, w, { backwards: true }), w = C(v, w, { backwards: true }), w = D(v, w, { backwards: true });
            let L = C(v, w, { backwards: true });
            return w !== L;
          }
          function R(v, S) {
            let b = null, w = S;
            for (; w !== b; ) b = w, w = g(v, w), w = l(v, w), w = D(v, w);
            return w = h(v, w), w = C(v, w), w !== false && B(v, w);
          }
          function $(v, S, b) {
            return R(v, b(S));
          }
          function _(v, S, b) {
            return d(v, b(S));
          }
          function O(v, S, b) {
            return v.charAt(_(v, S, b));
          }
          function x(v, S) {
            let b = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
            return D(v, b.backwards ? S - 1 : S, b) !== S;
          }
          function k(v, S) {
            let b = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0, w = 0;
            for (let L = b; L < v.length; ++L) v[L] === "	" ? w = w + S - w % S : w++;
            return w;
          }
          function M(v, S) {
            let b = v.lastIndexOf(`
`);
            return b === -1 ? 0 : k(v.slice(b + 1).match(/^[\t ]*/)[0], S);
          }
          function u(v, S) {
            let b = { quote: '"', regex: /"/g, escaped: "&quot;" }, w = { quote: "'", regex: /'/g, escaped: "&apos;" }, L = S === "'" ? w : b, U = L === w ? b : w, V = L;
            if (v.includes(L.quote) || v.includes(U.quote)) {
              let Y = (v.match(L.regex) || []).length, ue = (v.match(U.regex) || []).length;
              V = Y > ue ? U : L;
            }
            return V;
          }
          function o(v, S) {
            let b = v.slice(1, -1), w = S.parser === "json" || S.parser === "json5" && S.quoteProps === "preserve" && !S.singleQuote ? '"' : S.__isInHtmlAttribute ? "'" : u(b, S.singleQuote ? "'" : '"').quote;
            return E(b, w, !(S.parser === "css" || S.parser === "less" || S.parser === "scss" || S.__embeddedInHtml));
          }
          function E(v, S, b) {
            let w = S === '"' ? "'" : '"', L = /\\(.)|(["'])/gs, U = v.replace(L, (V, Y, ue) => Y === w ? Y : ue === S ? "\\" + ue : ue || (b && /^[^\n\r"'0-7\\bfnrt-vx\u2028\u2029]$/.test(Y) ? Y : "\\" + Y));
            return S + U + S;
          }
          function f(v) {
            return v.toLowerCase().replace(/^([+-]?[\d.]+e)(?:\+|(-))?0*(\d)/, "$1$2$3").replace(/^([+-]?[\d.]+)e[+-]?0+$/, "$1").replace(/^([+-])?\./, "$10.").replace(/(\.\d+?)0+(?=e|$)/, "$1").replace(/\.(?=e|$)/, "");
          }
          function F(v, S) {
            let b = v.match(new RegExp("(".concat(t(S), ")+"), "g"));
            return b === null ? 0 : b.reduce((w, L) => Math.max(w, L.length / S.length), 0);
          }
          function P(v, S) {
            let b = v.match(new RegExp("(".concat(t(S), ")+"), "g"));
            if (b === null) return 0;
            let w = /* @__PURE__ */ new Map(), L = 0;
            for (let U of b) {
              let V = U.length / S.length;
              w.set(V, true), V > L && (L = V);
            }
            for (let U = 1; U < L; U++) if (!w.get(U)) return U;
            return L + 1;
          }
          function j(v, S) {
            (v.comments || (v.comments = [])).push(S), S.printed = false, S.nodeDescription = ee(v);
          }
          function W(v, S) {
            S.leading = true, S.trailing = false, j(v, S);
          }
          function X(v, S, b) {
            S.leading = false, S.trailing = false, b && (S.marker = b), j(v, S);
          }
          function H(v, S) {
            S.leading = false, S.trailing = true, j(v, S);
          }
          function z2(v, S) {
            let { languages: b } = c({ plugins: S.plugins }), w = b.find((L) => {
              let { name: U } = L;
              return U.toLowerCase() === v;
            }) || b.find((L) => {
              let { aliases: U } = L;
              return Array.isArray(U) && U.includes(v);
            }) || b.find((L) => {
              let { extensions: U } = L;
              return Array.isArray(U) && U.includes(".".concat(v));
            });
            return w && w.parsers[0];
          }
          function J(v) {
            return v && v.type === "front-matter";
          }
          function Z(v) {
            let S = /* @__PURE__ */ new WeakMap();
            return function(b) {
              return S.has(b) || S.set(b, Symbol(v)), S.get(b);
            };
          }
          function ee(v) {
            let S = v.type || v.kind || "(unknown type)", b = String(v.name || v.id && (typeof v.id == "object" ? v.id.name : v.id) || v.key && (typeof v.key == "object" ? v.key.name : v.key) || v.value && (typeof v.value == "object" ? "" : String(v.value)) || v.operator || "");
            return b.length > 20 && (b = b.slice(0, 19) + "\u2026"), S + (b ? " " + b : "");
          }
          r.exports = { inferParserByLanguage: z2, getStringWidth: a, getMaxContinuousCount: F, getMinNotPresentContinuousCount: P, getPenultimate: m, getLast: s, getNextNonSpaceNonCommentCharacterIndexWithStartIndex: d, getNextNonSpaceNonCommentCharacterIndex: _, getNextNonSpaceNonCommentCharacter: O, skip: T, skipWhitespace: p, skipSpaces: D, skipToLineEnd: g, skipEverythingButNewLine: i, skipInlineComment: l, skipTrailingComment: h, skipNewline: C, isNextLineEmptyAfterIndex: R, isNextLineEmpty: $, isPreviousLineEmpty: N, hasNewline: B, hasNewlineInRange: A, hasSpaces: x, getAlignmentSize: k, getIndentSize: M, getPreferredQuote: u, printString: o, printNumber: f, makeString: E, addLeadingComment: W, addDanglingComment: X, addTrailingComment: H, isFrontMatterNode: J, isNonEmptyArray: n, createGroupIdMapper: Z };
        } }), RD = I({ "vendors/html-tag-names.json"(e, r) {
          r.exports = { htmlTagNames: ["a", "abbr", "acronym", "address", "applet", "area", "article", "aside", "audio", "b", "base", "basefont", "bdi", "bdo", "bgsound", "big", "blink", "blockquote", "body", "br", "button", "canvas", "caption", "center", "cite", "code", "col", "colgroup", "command", "content", "data", "datalist", "dd", "del", "details", "dfn", "dialog", "dir", "div", "dl", "dt", "element", "em", "embed", "fieldset", "figcaption", "figure", "font", "footer", "form", "frame", "frameset", "h1", "h2", "h3", "h4", "h5", "h6", "head", "header", "hgroup", "hr", "html", "i", "iframe", "image", "img", "input", "ins", "isindex", "kbd", "keygen", "label", "legend", "li", "link", "listing", "main", "map", "mark", "marquee", "math", "menu", "menuitem", "meta", "meter", "multicol", "nav", "nextid", "nobr", "noembed", "noframes", "noscript", "object", "ol", "optgroup", "option", "output", "p", "param", "picture", "plaintext", "pre", "progress", "q", "rb", "rbc", "rp", "rt", "rtc", "ruby", "s", "samp", "script", "section", "select", "shadow", "slot", "small", "source", "spacer", "span", "strike", "strong", "style", "sub", "summary", "sup", "svg", "table", "tbody", "td", "template", "textarea", "tfoot", "th", "thead", "time", "title", "tr", "track", "tt", "u", "ul", "var", "video", "wbr", "xmp"] };
        } }), vs = I({ "src/language-html/utils/array-to-map.js"(e, r) {
          "use strict";
          q();
          function t(s) {
            let c = /* @__PURE__ */ Object.create(null);
            for (let n of s) c[n] = true;
            return c;
          }
          r.exports = t;
        } }), xD = I({ "src/language-html/utils/html-tag-names.js"(e, r) {
          "use strict";
          q();
          var { htmlTagNames: t } = RD(), s = vs(), c = s(t);
          r.exports = c;
        } }), PD = I({ "vendors/html-element-attributes.json"(e, r) {
          r.exports = { htmlElementAttributes: { "*": ["accesskey", "autocapitalize", "autofocus", "class", "contenteditable", "dir", "draggable", "enterkeyhint", "hidden", "id", "inputmode", "is", "itemid", "itemprop", "itemref", "itemscope", "itemtype", "lang", "nonce", "slot", "spellcheck", "style", "tabindex", "title", "translate"], a: ["charset", "coords", "download", "href", "hreflang", "name", "ping", "referrerpolicy", "rel", "rev", "shape", "target", "type"], applet: ["align", "alt", "archive", "code", "codebase", "height", "hspace", "name", "object", "vspace", "width"], area: ["alt", "coords", "download", "href", "hreflang", "nohref", "ping", "referrerpolicy", "rel", "shape", "target", "type"], audio: ["autoplay", "controls", "crossorigin", "loop", "muted", "preload", "src"], base: ["href", "target"], basefont: ["color", "face", "size"], blockquote: ["cite"], body: ["alink", "background", "bgcolor", "link", "text", "vlink"], br: ["clear"], button: ["disabled", "form", "formaction", "formenctype", "formmethod", "formnovalidate", "formtarget", "name", "type", "value"], canvas: ["height", "width"], caption: ["align"], col: ["align", "char", "charoff", "span", "valign", "width"], colgroup: ["align", "char", "charoff", "span", "valign", "width"], data: ["value"], del: ["cite", "datetime"], details: ["open"], dialog: ["open"], dir: ["compact"], div: ["align"], dl: ["compact"], embed: ["height", "src", "type", "width"], fieldset: ["disabled", "form", "name"], font: ["color", "face", "size"], form: ["accept", "accept-charset", "action", "autocomplete", "enctype", "method", "name", "novalidate", "target"], frame: ["frameborder", "longdesc", "marginheight", "marginwidth", "name", "noresize", "scrolling", "src"], frameset: ["cols", "rows"], h1: ["align"], h2: ["align"], h3: ["align"], h4: ["align"], h5: ["align"], h6: ["align"], head: ["profile"], hr: ["align", "noshade", "size", "width"], html: ["manifest", "version"], iframe: ["align", "allow", "allowfullscreen", "allowpaymentrequest", "allowusermedia", "frameborder", "height", "loading", "longdesc", "marginheight", "marginwidth", "name", "referrerpolicy", "sandbox", "scrolling", "src", "srcdoc", "width"], img: ["align", "alt", "border", "crossorigin", "decoding", "height", "hspace", "ismap", "loading", "longdesc", "name", "referrerpolicy", "sizes", "src", "srcset", "usemap", "vspace", "width"], input: ["accept", "align", "alt", "autocomplete", "checked", "dirname", "disabled", "form", "formaction", "formenctype", "formmethod", "formnovalidate", "formtarget", "height", "ismap", "list", "max", "maxlength", "min", "minlength", "multiple", "name", "pattern", "placeholder", "readonly", "required", "size", "src", "step", "type", "usemap", "value", "width"], ins: ["cite", "datetime"], isindex: ["prompt"], label: ["for", "form"], legend: ["align"], li: ["type", "value"], link: ["as", "charset", "color", "crossorigin", "disabled", "href", "hreflang", "imagesizes", "imagesrcset", "integrity", "media", "referrerpolicy", "rel", "rev", "sizes", "target", "type"], map: ["name"], menu: ["compact"], meta: ["charset", "content", "http-equiv", "media", "name", "scheme"], meter: ["high", "low", "max", "min", "optimum", "value"], object: ["align", "archive", "border", "classid", "codebase", "codetype", "data", "declare", "form", "height", "hspace", "name", "standby", "type", "typemustmatch", "usemap", "vspace", "width"], ol: ["compact", "reversed", "start", "type"], optgroup: ["disabled", "label"], option: ["disabled", "label", "selected", "value"], output: ["for", "form", "name"], p: ["align"], param: ["name", "type", "value", "valuetype"], pre: ["width"], progress: ["max", "value"], q: ["cite"], script: ["async", "charset", "crossorigin", "defer", "integrity", "language", "nomodule", "referrerpolicy", "src", "type"], select: ["autocomplete", "disabled", "form", "multiple", "name", "required", "size"], slot: ["name"], source: ["height", "media", "sizes", "src", "srcset", "type", "width"], style: ["media", "type"], table: ["align", "bgcolor", "border", "cellpadding", "cellspacing", "frame", "rules", "summary", "width"], tbody: ["align", "char", "charoff", "valign"], td: ["abbr", "align", "axis", "bgcolor", "char", "charoff", "colspan", "headers", "height", "nowrap", "rowspan", "scope", "valign", "width"], textarea: ["autocomplete", "cols", "dirname", "disabled", "form", "maxlength", "minlength", "name", "placeholder", "readonly", "required", "rows", "wrap"], tfoot: ["align", "char", "charoff", "valign"], th: ["abbr", "align", "axis", "bgcolor", "char", "charoff", "colspan", "headers", "height", "nowrap", "rowspan", "scope", "valign", "width"], thead: ["align", "char", "charoff", "valign"], time: ["datetime"], tr: ["align", "bgcolor", "char", "charoff", "valign"], track: ["default", "kind", "label", "src", "srclang"], ul: ["compact", "type"], video: ["autoplay", "controls", "crossorigin", "height", "loop", "muted", "playsinline", "poster", "preload", "src", "width"] } };
        } }), kD = I({ "src/language-html/utils/map-object.js"(e, r) {
          "use strict";
          q();
          function t(s, c) {
            let n = /* @__PURE__ */ Object.create(null);
            for (let [a, p] of Object.entries(s)) n[a] = c(p, a);
            return n;
          }
          r.exports = t;
        } }), LD = I({ "src/language-html/utils/html-elements-attributes.js"(e, r) {
          "use strict";
          q();
          var { htmlElementAttributes: t } = PD(), s = kD(), c = vs(), n = s(t, c);
          r.exports = n;
        } }), MD = I({ "src/language-html/utils/is-unknown-namespace.js"(e, r) {
          "use strict";
          q();
          function t(s) {
            return s.type === "element" && !s.hasExplicitNamespace && !["html", "svg"].includes(s.namespace);
          }
          r.exports = t;
        } }), jD = I({ "src/language-html/pragma.js"(e, r) {
          "use strict";
          q();
          function t(c) {
            return /^\s*<!--\s*@(?:format|prettier)\s*-->/.test(c);
          }
          function s(c) {
            return `<!-- @format -->

` + c.replace(/^\s*\n/, "");
          }
          r.exports = { hasPragma: t, insertPragma: s };
        } }), $D = I({ "src/language-html/ast.js"(e, r) {
          "use strict";
          q();
          var t = { attrs: true, children: true }, s = /* @__PURE__ */ new Set(["parent"]), c = class {
            constructor() {
              let a = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
              for (let p of /* @__PURE__ */ new Set([...s, ...Object.keys(a)])) this.setProperty(p, a[p]);
            }
            setProperty(a, p) {
              if (this[a] !== p) {
                if (a in t && (p = p.map((D) => this.createChild(D))), !s.has(a)) {
                  this[a] = p;
                  return;
                }
                Object.defineProperty(this, a, { value: p, enumerable: false, configurable: true });
              }
            }
            map(a) {
              let p;
              for (let D in t) {
                let g = this[D];
                if (g) {
                  let i = n(g, (l) => l.map(a));
                  p !== g && (p || (p = new c({ parent: this.parent })), p.setProperty(D, i));
                }
              }
              if (p) for (let D in this) D in t || (p[D] = this[D]);
              return a(p || this);
            }
            walk(a) {
              for (let p in t) {
                let D = this[p];
                if (D) for (let g = 0; g < D.length; g++) D[g].walk(a);
              }
              a(this);
            }
            createChild(a) {
              let p = a instanceof c ? a.clone() : new c(a);
              return p.setProperty("parent", this), p;
            }
            insertChildBefore(a, p) {
              this.children.splice(this.children.indexOf(a), 0, this.createChild(p));
            }
            removeChild(a) {
              this.children.splice(this.children.indexOf(a), 1);
            }
            replaceChild(a, p) {
              this.children[this.children.indexOf(a)] = this.createChild(p);
            }
            clone() {
              return new c(this);
            }
            get firstChild() {
              var a;
              return (a = this.children) === null || a === void 0 ? void 0 : a[0];
            }
            get lastChild() {
              var a;
              return (a = this.children) === null || a === void 0 ? void 0 : a[this.children.length - 1];
            }
            get prev() {
              var a;
              return (a = this.parent) === null || a === void 0 ? void 0 : a.children[this.parent.children.indexOf(this) - 1];
            }
            get next() {
              var a;
              return (a = this.parent) === null || a === void 0 ? void 0 : a.children[this.parent.children.indexOf(this) + 1];
            }
            get rawName() {
              return this.hasExplicitNamespace ? this.fullName : this.name;
            }
            get fullName() {
              return this.namespace ? this.namespace + ":" + this.name : this.name;
            }
            get attrMap() {
              return Object.fromEntries(this.attrs.map((a) => [a.fullName, a.value]));
            }
          };
          function n(a, p) {
            let D = a.map(p);
            return D.some((g, i) => g !== a[i]) ? D : a;
          }
          r.exports = { Node: c };
        } }), UD = I({ "src/language-html/conditional-comment.js"(e, r) {
          "use strict";
          q();
          var { ParseSourceSpan: t } = Te(), s = [{ regex: /^(\[if([^\]]*)]>)(.*?)<!\s*\[endif]$/s, parse: n }, { regex: /^\[if([^\]]*)]><!$/, parse: a }, { regex: /^<!\s*\[endif]$/, parse: p }];
          function c(D, g) {
            if (D.value) for (let { regex: i, parse: l } of s) {
              let h = D.value.match(i);
              if (h) return l(D, g, h);
            }
            return null;
          }
          function n(D, g, i) {
            let [, l, h, C] = i, d = 4 + l.length, m = D.sourceSpan.start.moveBy(d), T = m.moveBy(C.length), [B, A] = (() => {
              try {
                return [true, g(C, m).children];
              } catch {
                let N = { type: "text", value: C, sourceSpan: new t(m, T) };
                return [false, [N]];
              }
            })();
            return { type: "ieConditionalComment", complete: B, children: A, condition: h.trim().replace(/\s+/g, " "), sourceSpan: D.sourceSpan, startSourceSpan: new t(D.sourceSpan.start, m), endSourceSpan: new t(T, D.sourceSpan.end) };
          }
          function a(D, g, i) {
            let [, l] = i;
            return { type: "ieConditionalStartComment", condition: l.trim().replace(/\s+/g, " "), sourceSpan: D.sourceSpan };
          }
          function p(D) {
            return { type: "ieConditionalEndComment", sourceSpan: D.sourceSpan };
          }
          r.exports = { parseIeConditionalComment: c };
        } }), GD = I({ "src/language-html/loc.js"(e, r) {
          "use strict";
          q();
          function t(c) {
            return c.sourceSpan.start.offset;
          }
          function s(c) {
            return c.sourceSpan.end.offset;
          }
          r.exports = { locStart: t, locEnd: s };
        } }), Ze = I({ "node_modules/angular-html-parser/lib/compiler/src/ml_parser/tags.js"(e) {
          "use strict";
          q(), Object.defineProperty(e, "__esModule", { value: true });
          var r;
          (function(D) {
            D[D.RAW_TEXT = 0] = "RAW_TEXT", D[D.ESCAPABLE_RAW_TEXT = 1] = "ESCAPABLE_RAW_TEXT", D[D.PARSABLE_DATA = 2] = "PARSABLE_DATA";
          })(r = e.TagContentType || (e.TagContentType = {}));
          function t(D) {
            if (D[0] != ":") return [null, D];
            let g = D.indexOf(":", 1);
            if (g == -1) throw new Error('Unsupported format "'.concat(D, '" expecting ":namespace:name"'));
            return [D.slice(1, g), D.slice(g + 1)];
          }
          e.splitNsName = t;
          function s(D) {
            return t(D)[1] === "ng-container";
          }
          e.isNgContainer = s;
          function c(D) {
            return t(D)[1] === "ng-content";
          }
          e.isNgContent = c;
          function n(D) {
            return t(D)[1] === "ng-template";
          }
          e.isNgTemplate = n;
          function a(D) {
            return D === null ? null : t(D)[0];
          }
          e.getNsPrefix = a;
          function p(D, g) {
            return D ? ":".concat(D, ":").concat(g) : g;
          }
          e.mergeNsAndName = p, e.NAMED_ENTITIES = { Aacute: "\xC1", aacute: "\xE1", Abreve: "\u0102", abreve: "\u0103", ac: "\u223E", acd: "\u223F", acE: "\u223E\u0333", Acirc: "\xC2", acirc: "\xE2", acute: "\xB4", Acy: "\u0410", acy: "\u0430", AElig: "\xC6", aelig: "\xE6", af: "\u2061", Afr: "\u{1D504}", afr: "\u{1D51E}", Agrave: "\xC0", agrave: "\xE0", alefsym: "\u2135", aleph: "\u2135", Alpha: "\u0391", alpha: "\u03B1", Amacr: "\u0100", amacr: "\u0101", amalg: "\u2A3F", AMP: "&", amp: "&", And: "\u2A53", and: "\u2227", andand: "\u2A55", andd: "\u2A5C", andslope: "\u2A58", andv: "\u2A5A", ang: "\u2220", ange: "\u29A4", angle: "\u2220", angmsd: "\u2221", angmsdaa: "\u29A8", angmsdab: "\u29A9", angmsdac: "\u29AA", angmsdad: "\u29AB", angmsdae: "\u29AC", angmsdaf: "\u29AD", angmsdag: "\u29AE", angmsdah: "\u29AF", angrt: "\u221F", angrtvb: "\u22BE", angrtvbd: "\u299D", angsph: "\u2222", angst: "\xC5", angzarr: "\u237C", Aogon: "\u0104", aogon: "\u0105", Aopf: "\u{1D538}", aopf: "\u{1D552}", ap: "\u2248", apacir: "\u2A6F", apE: "\u2A70", ape: "\u224A", apid: "\u224B", apos: "'", ApplyFunction: "\u2061", approx: "\u2248", approxeq: "\u224A", Aring: "\xC5", aring: "\xE5", Ascr: "\u{1D49C}", ascr: "\u{1D4B6}", Assign: "\u2254", ast: "*", asymp: "\u2248", asympeq: "\u224D", Atilde: "\xC3", atilde: "\xE3", Auml: "\xC4", auml: "\xE4", awconint: "\u2233", awint: "\u2A11", backcong: "\u224C", backepsilon: "\u03F6", backprime: "\u2035", backsim: "\u223D", backsimeq: "\u22CD", Backslash: "\u2216", Barv: "\u2AE7", barvee: "\u22BD", Barwed: "\u2306", barwed: "\u2305", barwedge: "\u2305", bbrk: "\u23B5", bbrktbrk: "\u23B6", bcong: "\u224C", Bcy: "\u0411", bcy: "\u0431", bdquo: "\u201E", becaus: "\u2235", Because: "\u2235", because: "\u2235", bemptyv: "\u29B0", bepsi: "\u03F6", bernou: "\u212C", Bernoullis: "\u212C", Beta: "\u0392", beta: "\u03B2", beth: "\u2136", between: "\u226C", Bfr: "\u{1D505}", bfr: "\u{1D51F}", bigcap: "\u22C2", bigcirc: "\u25EF", bigcup: "\u22C3", bigodot: "\u2A00", bigoplus: "\u2A01", bigotimes: "\u2A02", bigsqcup: "\u2A06", bigstar: "\u2605", bigtriangledown: "\u25BD", bigtriangleup: "\u25B3", biguplus: "\u2A04", bigvee: "\u22C1", bigwedge: "\u22C0", bkarow: "\u290D", blacklozenge: "\u29EB", blacksquare: "\u25AA", blacktriangle: "\u25B4", blacktriangledown: "\u25BE", blacktriangleleft: "\u25C2", blacktriangleright: "\u25B8", blank: "\u2423", blk12: "\u2592", blk14: "\u2591", blk34: "\u2593", block: "\u2588", bne: "=\u20E5", bnequiv: "\u2261\u20E5", bNot: "\u2AED", bnot: "\u2310", Bopf: "\u{1D539}", bopf: "\u{1D553}", bot: "\u22A5", bottom: "\u22A5", bowtie: "\u22C8", boxbox: "\u29C9", boxDL: "\u2557", boxDl: "\u2556", boxdL: "\u2555", boxdl: "\u2510", boxDR: "\u2554", boxDr: "\u2553", boxdR: "\u2552", boxdr: "\u250C", boxH: "\u2550", boxh: "\u2500", boxHD: "\u2566", boxHd: "\u2564", boxhD: "\u2565", boxhd: "\u252C", boxHU: "\u2569", boxHu: "\u2567", boxhU: "\u2568", boxhu: "\u2534", boxminus: "\u229F", boxplus: "\u229E", boxtimes: "\u22A0", boxUL: "\u255D", boxUl: "\u255C", boxuL: "\u255B", boxul: "\u2518", boxUR: "\u255A", boxUr: "\u2559", boxuR: "\u2558", boxur: "\u2514", boxV: "\u2551", boxv: "\u2502", boxVH: "\u256C", boxVh: "\u256B", boxvH: "\u256A", boxvh: "\u253C", boxVL: "\u2563", boxVl: "\u2562", boxvL: "\u2561", boxvl: "\u2524", boxVR: "\u2560", boxVr: "\u255F", boxvR: "\u255E", boxvr: "\u251C", bprime: "\u2035", Breve: "\u02D8", breve: "\u02D8", brvbar: "\xA6", Bscr: "\u212C", bscr: "\u{1D4B7}", bsemi: "\u204F", bsim: "\u223D", bsime: "\u22CD", bsol: "\\", bsolb: "\u29C5", bsolhsub: "\u27C8", bull: "\u2022", bullet: "\u2022", bump: "\u224E", bumpE: "\u2AAE", bumpe: "\u224F", Bumpeq: "\u224E", bumpeq: "\u224F", Cacute: "\u0106", cacute: "\u0107", Cap: "\u22D2", cap: "\u2229", capand: "\u2A44", capbrcup: "\u2A49", capcap: "\u2A4B", capcup: "\u2A47", capdot: "\u2A40", CapitalDifferentialD: "\u2145", caps: "\u2229\uFE00", caret: "\u2041", caron: "\u02C7", Cayleys: "\u212D", ccaps: "\u2A4D", Ccaron: "\u010C", ccaron: "\u010D", Ccedil: "\xC7", ccedil: "\xE7", Ccirc: "\u0108", ccirc: "\u0109", Cconint: "\u2230", ccups: "\u2A4C", ccupssm: "\u2A50", Cdot: "\u010A", cdot: "\u010B", cedil: "\xB8", Cedilla: "\xB8", cemptyv: "\u29B2", cent: "\xA2", CenterDot: "\xB7", centerdot: "\xB7", Cfr: "\u212D", cfr: "\u{1D520}", CHcy: "\u0427", chcy: "\u0447", check: "\u2713", checkmark: "\u2713", Chi: "\u03A7", chi: "\u03C7", cir: "\u25CB", circ: "\u02C6", circeq: "\u2257", circlearrowleft: "\u21BA", circlearrowright: "\u21BB", circledast: "\u229B", circledcirc: "\u229A", circleddash: "\u229D", CircleDot: "\u2299", circledR: "\xAE", circledS: "\u24C8", CircleMinus: "\u2296", CirclePlus: "\u2295", CircleTimes: "\u2297", cirE: "\u29C3", cire: "\u2257", cirfnint: "\u2A10", cirmid: "\u2AEF", cirscir: "\u29C2", ClockwiseContourIntegral: "\u2232", CloseCurlyDoubleQuote: "\u201D", CloseCurlyQuote: "\u2019", clubs: "\u2663", clubsuit: "\u2663", Colon: "\u2237", colon: ":", Colone: "\u2A74", colone: "\u2254", coloneq: "\u2254", comma: ",", commat: "@", comp: "\u2201", compfn: "\u2218", complement: "\u2201", complexes: "\u2102", cong: "\u2245", congdot: "\u2A6D", Congruent: "\u2261", Conint: "\u222F", conint: "\u222E", ContourIntegral: "\u222E", Copf: "\u2102", copf: "\u{1D554}", coprod: "\u2210", Coproduct: "\u2210", COPY: "\xA9", copy: "\xA9", copysr: "\u2117", CounterClockwiseContourIntegral: "\u2233", crarr: "\u21B5", Cross: "\u2A2F", cross: "\u2717", Cscr: "\u{1D49E}", cscr: "\u{1D4B8}", csub: "\u2ACF", csube: "\u2AD1", csup: "\u2AD0", csupe: "\u2AD2", ctdot: "\u22EF", cudarrl: "\u2938", cudarrr: "\u2935", cuepr: "\u22DE", cuesc: "\u22DF", cularr: "\u21B6", cularrp: "\u293D", Cup: "\u22D3", cup: "\u222A", cupbrcap: "\u2A48", CupCap: "\u224D", cupcap: "\u2A46", cupcup: "\u2A4A", cupdot: "\u228D", cupor: "\u2A45", cups: "\u222A\uFE00", curarr: "\u21B7", curarrm: "\u293C", curlyeqprec: "\u22DE", curlyeqsucc: "\u22DF", curlyvee: "\u22CE", curlywedge: "\u22CF", curren: "\xA4", curvearrowleft: "\u21B6", curvearrowright: "\u21B7", cuvee: "\u22CE", cuwed: "\u22CF", cwconint: "\u2232", cwint: "\u2231", cylcty: "\u232D", Dagger: "\u2021", dagger: "\u2020", daleth: "\u2138", Darr: "\u21A1", dArr: "\u21D3", darr: "\u2193", dash: "\u2010", Dashv: "\u2AE4", dashv: "\u22A3", dbkarow: "\u290F", dblac: "\u02DD", Dcaron: "\u010E", dcaron: "\u010F", Dcy: "\u0414", dcy: "\u0434", DD: "\u2145", dd: "\u2146", ddagger: "\u2021", ddarr: "\u21CA", DDotrahd: "\u2911", ddotseq: "\u2A77", deg: "\xB0", Del: "\u2207", Delta: "\u0394", delta: "\u03B4", demptyv: "\u29B1", dfisht: "\u297F", Dfr: "\u{1D507}", dfr: "\u{1D521}", dHar: "\u2965", dharl: "\u21C3", dharr: "\u21C2", DiacriticalAcute: "\xB4", DiacriticalDot: "\u02D9", DiacriticalDoubleAcute: "\u02DD", DiacriticalGrave: "`", DiacriticalTilde: "\u02DC", diam: "\u22C4", Diamond: "\u22C4", diamond: "\u22C4", diamondsuit: "\u2666", diams: "\u2666", die: "\xA8", DifferentialD: "\u2146", digamma: "\u03DD", disin: "\u22F2", div: "\xF7", divide: "\xF7", divideontimes: "\u22C7", divonx: "\u22C7", DJcy: "\u0402", djcy: "\u0452", dlcorn: "\u231E", dlcrop: "\u230D", dollar: "$", Dopf: "\u{1D53B}", dopf: "\u{1D555}", Dot: "\xA8", dot: "\u02D9", DotDot: "\u20DC", doteq: "\u2250", doteqdot: "\u2251", DotEqual: "\u2250", dotminus: "\u2238", dotplus: "\u2214", dotsquare: "\u22A1", doublebarwedge: "\u2306", DoubleContourIntegral: "\u222F", DoubleDot: "\xA8", DoubleDownArrow: "\u21D3", DoubleLeftArrow: "\u21D0", DoubleLeftRightArrow: "\u21D4", DoubleLeftTee: "\u2AE4", DoubleLongLeftArrow: "\u27F8", DoubleLongLeftRightArrow: "\u27FA", DoubleLongRightArrow: "\u27F9", DoubleRightArrow: "\u21D2", DoubleRightTee: "\u22A8", DoubleUpArrow: "\u21D1", DoubleUpDownArrow: "\u21D5", DoubleVerticalBar: "\u2225", DownArrow: "\u2193", Downarrow: "\u21D3", downarrow: "\u2193", DownArrowBar: "\u2913", DownArrowUpArrow: "\u21F5", DownBreve: "\u0311", downdownarrows: "\u21CA", downharpoonleft: "\u21C3", downharpoonright: "\u21C2", DownLeftRightVector: "\u2950", DownLeftTeeVector: "\u295E", DownLeftVector: "\u21BD", DownLeftVectorBar: "\u2956", DownRightTeeVector: "\u295F", DownRightVector: "\u21C1", DownRightVectorBar: "\u2957", DownTee: "\u22A4", DownTeeArrow: "\u21A7", drbkarow: "\u2910", drcorn: "\u231F", drcrop: "\u230C", Dscr: "\u{1D49F}", dscr: "\u{1D4B9}", DScy: "\u0405", dscy: "\u0455", dsol: "\u29F6", Dstrok: "\u0110", dstrok: "\u0111", dtdot: "\u22F1", dtri: "\u25BF", dtrif: "\u25BE", duarr: "\u21F5", duhar: "\u296F", dwangle: "\u29A6", DZcy: "\u040F", dzcy: "\u045F", dzigrarr: "\u27FF", Eacute: "\xC9", eacute: "\xE9", easter: "\u2A6E", Ecaron: "\u011A", ecaron: "\u011B", ecir: "\u2256", Ecirc: "\xCA", ecirc: "\xEA", ecolon: "\u2255", Ecy: "\u042D", ecy: "\u044D", eDDot: "\u2A77", Edot: "\u0116", eDot: "\u2251", edot: "\u0117", ee: "\u2147", efDot: "\u2252", Efr: "\u{1D508}", efr: "\u{1D522}", eg: "\u2A9A", Egrave: "\xC8", egrave: "\xE8", egs: "\u2A96", egsdot: "\u2A98", el: "\u2A99", Element: "\u2208", elinters: "\u23E7", ell: "\u2113", els: "\u2A95", elsdot: "\u2A97", Emacr: "\u0112", emacr: "\u0113", empty: "\u2205", emptyset: "\u2205", EmptySmallSquare: "\u25FB", emptyv: "\u2205", EmptyVerySmallSquare: "\u25AB", emsp: "\u2003", emsp13: "\u2004", emsp14: "\u2005", ENG: "\u014A", eng: "\u014B", ensp: "\u2002", Eogon: "\u0118", eogon: "\u0119", Eopf: "\u{1D53C}", eopf: "\u{1D556}", epar: "\u22D5", eparsl: "\u29E3", eplus: "\u2A71", epsi: "\u03B5", Epsilon: "\u0395", epsilon: "\u03B5", epsiv: "\u03F5", eqcirc: "\u2256", eqcolon: "\u2255", eqsim: "\u2242", eqslantgtr: "\u2A96", eqslantless: "\u2A95", Equal: "\u2A75", equals: "=", EqualTilde: "\u2242", equest: "\u225F", Equilibrium: "\u21CC", equiv: "\u2261", equivDD: "\u2A78", eqvparsl: "\u29E5", erarr: "\u2971", erDot: "\u2253", Escr: "\u2130", escr: "\u212F", esdot: "\u2250", Esim: "\u2A73", esim: "\u2242", Eta: "\u0397", eta: "\u03B7", ETH: "\xD0", eth: "\xF0", Euml: "\xCB", euml: "\xEB", euro: "\u20AC", excl: "!", exist: "\u2203", Exists: "\u2203", expectation: "\u2130", ExponentialE: "\u2147", exponentiale: "\u2147", fallingdotseq: "\u2252", Fcy: "\u0424", fcy: "\u0444", female: "\u2640", ffilig: "\uFB03", fflig: "\uFB00", ffllig: "\uFB04", Ffr: "\u{1D509}", ffr: "\u{1D523}", filig: "\uFB01", FilledSmallSquare: "\u25FC", FilledVerySmallSquare: "\u25AA", fjlig: "fj", flat: "\u266D", fllig: "\uFB02", fltns: "\u25B1", fnof: "\u0192", Fopf: "\u{1D53D}", fopf: "\u{1D557}", ForAll: "\u2200", forall: "\u2200", fork: "\u22D4", forkv: "\u2AD9", Fouriertrf: "\u2131", fpartint: "\u2A0D", frac12: "\xBD", frac13: "\u2153", frac14: "\xBC", frac15: "\u2155", frac16: "\u2159", frac18: "\u215B", frac23: "\u2154", frac25: "\u2156", frac34: "\xBE", frac35: "\u2157", frac38: "\u215C", frac45: "\u2158", frac56: "\u215A", frac58: "\u215D", frac78: "\u215E", frasl: "\u2044", frown: "\u2322", Fscr: "\u2131", fscr: "\u{1D4BB}", gacute: "\u01F5", Gamma: "\u0393", gamma: "\u03B3", Gammad: "\u03DC", gammad: "\u03DD", gap: "\u2A86", Gbreve: "\u011E", gbreve: "\u011F", Gcedil: "\u0122", Gcirc: "\u011C", gcirc: "\u011D", Gcy: "\u0413", gcy: "\u0433", Gdot: "\u0120", gdot: "\u0121", gE: "\u2267", ge: "\u2265", gEl: "\u2A8C", gel: "\u22DB", geq: "\u2265", geqq: "\u2267", geqslant: "\u2A7E", ges: "\u2A7E", gescc: "\u2AA9", gesdot: "\u2A80", gesdoto: "\u2A82", gesdotol: "\u2A84", gesl: "\u22DB\uFE00", gesles: "\u2A94", Gfr: "\u{1D50A}", gfr: "\u{1D524}", Gg: "\u22D9", gg: "\u226B", ggg: "\u22D9", gimel: "\u2137", GJcy: "\u0403", gjcy: "\u0453", gl: "\u2277", gla: "\u2AA5", glE: "\u2A92", glj: "\u2AA4", gnap: "\u2A8A", gnapprox: "\u2A8A", gnE: "\u2269", gne: "\u2A88", gneq: "\u2A88", gneqq: "\u2269", gnsim: "\u22E7", Gopf: "\u{1D53E}", gopf: "\u{1D558}", grave: "`", GreaterEqual: "\u2265", GreaterEqualLess: "\u22DB", GreaterFullEqual: "\u2267", GreaterGreater: "\u2AA2", GreaterLess: "\u2277", GreaterSlantEqual: "\u2A7E", GreaterTilde: "\u2273", Gscr: "\u{1D4A2}", gscr: "\u210A", gsim: "\u2273", gsime: "\u2A8E", gsiml: "\u2A90", GT: ">", Gt: "\u226B", gt: ">", gtcc: "\u2AA7", gtcir: "\u2A7A", gtdot: "\u22D7", gtlPar: "\u2995", gtquest: "\u2A7C", gtrapprox: "\u2A86", gtrarr: "\u2978", gtrdot: "\u22D7", gtreqless: "\u22DB", gtreqqless: "\u2A8C", gtrless: "\u2277", gtrsim: "\u2273", gvertneqq: "\u2269\uFE00", gvnE: "\u2269\uFE00", Hacek: "\u02C7", hairsp: "\u200A", half: "\xBD", hamilt: "\u210B", HARDcy: "\u042A", hardcy: "\u044A", hArr: "\u21D4", harr: "\u2194", harrcir: "\u2948", harrw: "\u21AD", Hat: "^", hbar: "\u210F", Hcirc: "\u0124", hcirc: "\u0125", hearts: "\u2665", heartsuit: "\u2665", hellip: "\u2026", hercon: "\u22B9", Hfr: "\u210C", hfr: "\u{1D525}", HilbertSpace: "\u210B", hksearow: "\u2925", hkswarow: "\u2926", hoarr: "\u21FF", homtht: "\u223B", hookleftarrow: "\u21A9", hookrightarrow: "\u21AA", Hopf: "\u210D", hopf: "\u{1D559}", horbar: "\u2015", HorizontalLine: "\u2500", Hscr: "\u210B", hscr: "\u{1D4BD}", hslash: "\u210F", Hstrok: "\u0126", hstrok: "\u0127", HumpDownHump: "\u224E", HumpEqual: "\u224F", hybull: "\u2043", hyphen: "\u2010", Iacute: "\xCD", iacute: "\xED", ic: "\u2063", Icirc: "\xCE", icirc: "\xEE", Icy: "\u0418", icy: "\u0438", Idot: "\u0130", IEcy: "\u0415", iecy: "\u0435", iexcl: "\xA1", iff: "\u21D4", Ifr: "\u2111", ifr: "\u{1D526}", Igrave: "\xCC", igrave: "\xEC", ii: "\u2148", iiiint: "\u2A0C", iiint: "\u222D", iinfin: "\u29DC", iiota: "\u2129", IJlig: "\u0132", ijlig: "\u0133", Im: "\u2111", Imacr: "\u012A", imacr: "\u012B", image: "\u2111", ImaginaryI: "\u2148", imagline: "\u2110", imagpart: "\u2111", imath: "\u0131", imof: "\u22B7", imped: "\u01B5", Implies: "\u21D2", in: "\u2208", incare: "\u2105", infin: "\u221E", infintie: "\u29DD", inodot: "\u0131", Int: "\u222C", int: "\u222B", intcal: "\u22BA", integers: "\u2124", Integral: "\u222B", intercal: "\u22BA", Intersection: "\u22C2", intlarhk: "\u2A17", intprod: "\u2A3C", InvisibleComma: "\u2063", InvisibleTimes: "\u2062", IOcy: "\u0401", iocy: "\u0451", Iogon: "\u012E", iogon: "\u012F", Iopf: "\u{1D540}", iopf: "\u{1D55A}", Iota: "\u0399", iota: "\u03B9", iprod: "\u2A3C", iquest: "\xBF", Iscr: "\u2110", iscr: "\u{1D4BE}", isin: "\u2208", isindot: "\u22F5", isinE: "\u22F9", isins: "\u22F4", isinsv: "\u22F3", isinv: "\u2208", it: "\u2062", Itilde: "\u0128", itilde: "\u0129", Iukcy: "\u0406", iukcy: "\u0456", Iuml: "\xCF", iuml: "\xEF", Jcirc: "\u0134", jcirc: "\u0135", Jcy: "\u0419", jcy: "\u0439", Jfr: "\u{1D50D}", jfr: "\u{1D527}", jmath: "\u0237", Jopf: "\u{1D541}", jopf: "\u{1D55B}", Jscr: "\u{1D4A5}", jscr: "\u{1D4BF}", Jsercy: "\u0408", jsercy: "\u0458", Jukcy: "\u0404", jukcy: "\u0454", Kappa: "\u039A", kappa: "\u03BA", kappav: "\u03F0", Kcedil: "\u0136", kcedil: "\u0137", Kcy: "\u041A", kcy: "\u043A", Kfr: "\u{1D50E}", kfr: "\u{1D528}", kgreen: "\u0138", KHcy: "\u0425", khcy: "\u0445", KJcy: "\u040C", kjcy: "\u045C", Kopf: "\u{1D542}", kopf: "\u{1D55C}", Kscr: "\u{1D4A6}", kscr: "\u{1D4C0}", lAarr: "\u21DA", Lacute: "\u0139", lacute: "\u013A", laemptyv: "\u29B4", lagran: "\u2112", Lambda: "\u039B", lambda: "\u03BB", Lang: "\u27EA", lang: "\u27E8", langd: "\u2991", langle: "\u27E8", lap: "\u2A85", Laplacetrf: "\u2112", laquo: "\xAB", Larr: "\u219E", lArr: "\u21D0", larr: "\u2190", larrb: "\u21E4", larrbfs: "\u291F", larrfs: "\u291D", larrhk: "\u21A9", larrlp: "\u21AB", larrpl: "\u2939", larrsim: "\u2973", larrtl: "\u21A2", lat: "\u2AAB", lAtail: "\u291B", latail: "\u2919", late: "\u2AAD", lates: "\u2AAD\uFE00", lBarr: "\u290E", lbarr: "\u290C", lbbrk: "\u2772", lbrace: "{", lbrack: "[", lbrke: "\u298B", lbrksld: "\u298F", lbrkslu: "\u298D", Lcaron: "\u013D", lcaron: "\u013E", Lcedil: "\u013B", lcedil: "\u013C", lceil: "\u2308", lcub: "{", Lcy: "\u041B", lcy: "\u043B", ldca: "\u2936", ldquo: "\u201C", ldquor: "\u201E", ldrdhar: "\u2967", ldrushar: "\u294B", ldsh: "\u21B2", lE: "\u2266", le: "\u2264", LeftAngleBracket: "\u27E8", LeftArrow: "\u2190", Leftarrow: "\u21D0", leftarrow: "\u2190", LeftArrowBar: "\u21E4", LeftArrowRightArrow: "\u21C6", leftarrowtail: "\u21A2", LeftCeiling: "\u2308", LeftDoubleBracket: "\u27E6", LeftDownTeeVector: "\u2961", LeftDownVector: "\u21C3", LeftDownVectorBar: "\u2959", LeftFloor: "\u230A", leftharpoondown: "\u21BD", leftharpoonup: "\u21BC", leftleftarrows: "\u21C7", LeftRightArrow: "\u2194", Leftrightarrow: "\u21D4", leftrightarrow: "\u2194", leftrightarrows: "\u21C6", leftrightharpoons: "\u21CB", leftrightsquigarrow: "\u21AD", LeftRightVector: "\u294E", LeftTee: "\u22A3", LeftTeeArrow: "\u21A4", LeftTeeVector: "\u295A", leftthreetimes: "\u22CB", LeftTriangle: "\u22B2", LeftTriangleBar: "\u29CF", LeftTriangleEqual: "\u22B4", LeftUpDownVector: "\u2951", LeftUpTeeVector: "\u2960", LeftUpVector: "\u21BF", LeftUpVectorBar: "\u2958", LeftVector: "\u21BC", LeftVectorBar: "\u2952", lEg: "\u2A8B", leg: "\u22DA", leq: "\u2264", leqq: "\u2266", leqslant: "\u2A7D", les: "\u2A7D", lescc: "\u2AA8", lesdot: "\u2A7F", lesdoto: "\u2A81", lesdotor: "\u2A83", lesg: "\u22DA\uFE00", lesges: "\u2A93", lessapprox: "\u2A85", lessdot: "\u22D6", lesseqgtr: "\u22DA", lesseqqgtr: "\u2A8B", LessEqualGreater: "\u22DA", LessFullEqual: "\u2266", LessGreater: "\u2276", lessgtr: "\u2276", LessLess: "\u2AA1", lesssim: "\u2272", LessSlantEqual: "\u2A7D", LessTilde: "\u2272", lfisht: "\u297C", lfloor: "\u230A", Lfr: "\u{1D50F}", lfr: "\u{1D529}", lg: "\u2276", lgE: "\u2A91", lHar: "\u2962", lhard: "\u21BD", lharu: "\u21BC", lharul: "\u296A", lhblk: "\u2584", LJcy: "\u0409", ljcy: "\u0459", Ll: "\u22D8", ll: "\u226A", llarr: "\u21C7", llcorner: "\u231E", Lleftarrow: "\u21DA", llhard: "\u296B", lltri: "\u25FA", Lmidot: "\u013F", lmidot: "\u0140", lmoust: "\u23B0", lmoustache: "\u23B0", lnap: "\u2A89", lnapprox: "\u2A89", lnE: "\u2268", lne: "\u2A87", lneq: "\u2A87", lneqq: "\u2268", lnsim: "\u22E6", loang: "\u27EC", loarr: "\u21FD", lobrk: "\u27E6", LongLeftArrow: "\u27F5", Longleftarrow: "\u27F8", longleftarrow: "\u27F5", LongLeftRightArrow: "\u27F7", Longleftrightarrow: "\u27FA", longleftrightarrow: "\u27F7", longmapsto: "\u27FC", LongRightArrow: "\u27F6", Longrightarrow: "\u27F9", longrightarrow: "\u27F6", looparrowleft: "\u21AB", looparrowright: "\u21AC", lopar: "\u2985", Lopf: "\u{1D543}", lopf: "\u{1D55D}", loplus: "\u2A2D", lotimes: "\u2A34", lowast: "\u2217", lowbar: "_", LowerLeftArrow: "\u2199", LowerRightArrow: "\u2198", loz: "\u25CA", lozenge: "\u25CA", lozf: "\u29EB", lpar: "(", lparlt: "\u2993", lrarr: "\u21C6", lrcorner: "\u231F", lrhar: "\u21CB", lrhard: "\u296D", lrm: "\u200E", lrtri: "\u22BF", lsaquo: "\u2039", Lscr: "\u2112", lscr: "\u{1D4C1}", Lsh: "\u21B0", lsh: "\u21B0", lsim: "\u2272", lsime: "\u2A8D", lsimg: "\u2A8F", lsqb: "[", lsquo: "\u2018", lsquor: "\u201A", Lstrok: "\u0141", lstrok: "\u0142", LT: "<", Lt: "\u226A", lt: "<", ltcc: "\u2AA6", ltcir: "\u2A79", ltdot: "\u22D6", lthree: "\u22CB", ltimes: "\u22C9", ltlarr: "\u2976", ltquest: "\u2A7B", ltri: "\u25C3", ltrie: "\u22B4", ltrif: "\u25C2", ltrPar: "\u2996", lurdshar: "\u294A", luruhar: "\u2966", lvertneqq: "\u2268\uFE00", lvnE: "\u2268\uFE00", macr: "\xAF", male: "\u2642", malt: "\u2720", maltese: "\u2720", Map: "\u2905", map: "\u21A6", mapsto: "\u21A6", mapstodown: "\u21A7", mapstoleft: "\u21A4", mapstoup: "\u21A5", marker: "\u25AE", mcomma: "\u2A29", Mcy: "\u041C", mcy: "\u043C", mdash: "\u2014", mDDot: "\u223A", measuredangle: "\u2221", MediumSpace: "\u205F", Mellintrf: "\u2133", Mfr: "\u{1D510}", mfr: "\u{1D52A}", mho: "\u2127", micro: "\xB5", mid: "\u2223", midast: "*", midcir: "\u2AF0", middot: "\xB7", minus: "\u2212", minusb: "\u229F", minusd: "\u2238", minusdu: "\u2A2A", MinusPlus: "\u2213", mlcp: "\u2ADB", mldr: "\u2026", mnplus: "\u2213", models: "\u22A7", Mopf: "\u{1D544}", mopf: "\u{1D55E}", mp: "\u2213", Mscr: "\u2133", mscr: "\u{1D4C2}", mstpos: "\u223E", Mu: "\u039C", mu: "\u03BC", multimap: "\u22B8", mumap: "\u22B8", nabla: "\u2207", Nacute: "\u0143", nacute: "\u0144", nang: "\u2220\u20D2", nap: "\u2249", napE: "\u2A70\u0338", napid: "\u224B\u0338", napos: "\u0149", napprox: "\u2249", natur: "\u266E", natural: "\u266E", naturals: "\u2115", nbsp: "\xA0", nbump: "\u224E\u0338", nbumpe: "\u224F\u0338", ncap: "\u2A43", Ncaron: "\u0147", ncaron: "\u0148", Ncedil: "\u0145", ncedil: "\u0146", ncong: "\u2247", ncongdot: "\u2A6D\u0338", ncup: "\u2A42", Ncy: "\u041D", ncy: "\u043D", ndash: "\u2013", ne: "\u2260", nearhk: "\u2924", neArr: "\u21D7", nearr: "\u2197", nearrow: "\u2197", nedot: "\u2250\u0338", NegativeMediumSpace: "\u200B", NegativeThickSpace: "\u200B", NegativeThinSpace: "\u200B", NegativeVeryThinSpace: "\u200B", nequiv: "\u2262", nesear: "\u2928", nesim: "\u2242\u0338", NestedGreaterGreater: "\u226B", NestedLessLess: "\u226A", NewLine: `
`, nexist: "\u2204", nexists: "\u2204", Nfr: "\u{1D511}", nfr: "\u{1D52B}", ngE: "\u2267\u0338", nge: "\u2271", ngeq: "\u2271", ngeqq: "\u2267\u0338", ngeqslant: "\u2A7E\u0338", nges: "\u2A7E\u0338", nGg: "\u22D9\u0338", ngsim: "\u2275", nGt: "\u226B\u20D2", ngt: "\u226F", ngtr: "\u226F", nGtv: "\u226B\u0338", nhArr: "\u21CE", nharr: "\u21AE", nhpar: "\u2AF2", ni: "\u220B", nis: "\u22FC", nisd: "\u22FA", niv: "\u220B", NJcy: "\u040A", njcy: "\u045A", nlArr: "\u21CD", nlarr: "\u219A", nldr: "\u2025", nlE: "\u2266\u0338", nle: "\u2270", nLeftarrow: "\u21CD", nleftarrow: "\u219A", nLeftrightarrow: "\u21CE", nleftrightarrow: "\u21AE", nleq: "\u2270", nleqq: "\u2266\u0338", nleqslant: "\u2A7D\u0338", nles: "\u2A7D\u0338", nless: "\u226E", nLl: "\u22D8\u0338", nlsim: "\u2274", nLt: "\u226A\u20D2", nlt: "\u226E", nltri: "\u22EA", nltrie: "\u22EC", nLtv: "\u226A\u0338", nmid: "\u2224", NoBreak: "\u2060", NonBreakingSpace: "\xA0", Nopf: "\u2115", nopf: "\u{1D55F}", Not: "\u2AEC", not: "\xAC", NotCongruent: "\u2262", NotCupCap: "\u226D", NotDoubleVerticalBar: "\u2226", NotElement: "\u2209", NotEqual: "\u2260", NotEqualTilde: "\u2242\u0338", NotExists: "\u2204", NotGreater: "\u226F", NotGreaterEqual: "\u2271", NotGreaterFullEqual: "\u2267\u0338", NotGreaterGreater: "\u226B\u0338", NotGreaterLess: "\u2279", NotGreaterSlantEqual: "\u2A7E\u0338", NotGreaterTilde: "\u2275", NotHumpDownHump: "\u224E\u0338", NotHumpEqual: "\u224F\u0338", notin: "\u2209", notindot: "\u22F5\u0338", notinE: "\u22F9\u0338", notinva: "\u2209", notinvb: "\u22F7", notinvc: "\u22F6", NotLeftTriangle: "\u22EA", NotLeftTriangleBar: "\u29CF\u0338", NotLeftTriangleEqual: "\u22EC", NotLess: "\u226E", NotLessEqual: "\u2270", NotLessGreater: "\u2278", NotLessLess: "\u226A\u0338", NotLessSlantEqual: "\u2A7D\u0338", NotLessTilde: "\u2274", NotNestedGreaterGreater: "\u2AA2\u0338", NotNestedLessLess: "\u2AA1\u0338", notni: "\u220C", notniva: "\u220C", notnivb: "\u22FE", notnivc: "\u22FD", NotPrecedes: "\u2280", NotPrecedesEqual: "\u2AAF\u0338", NotPrecedesSlantEqual: "\u22E0", NotReverseElement: "\u220C", NotRightTriangle: "\u22EB", NotRightTriangleBar: "\u29D0\u0338", NotRightTriangleEqual: "\u22ED", NotSquareSubset: "\u228F\u0338", NotSquareSubsetEqual: "\u22E2", NotSquareSuperset: "\u2290\u0338", NotSquareSupersetEqual: "\u22E3", NotSubset: "\u2282\u20D2", NotSubsetEqual: "\u2288", NotSucceeds: "\u2281", NotSucceedsEqual: "\u2AB0\u0338", NotSucceedsSlantEqual: "\u22E1", NotSucceedsTilde: "\u227F\u0338", NotSuperset: "\u2283\u20D2", NotSupersetEqual: "\u2289", NotTilde: "\u2241", NotTildeEqual: "\u2244", NotTildeFullEqual: "\u2247", NotTildeTilde: "\u2249", NotVerticalBar: "\u2224", npar: "\u2226", nparallel: "\u2226", nparsl: "\u2AFD\u20E5", npart: "\u2202\u0338", npolint: "\u2A14", npr: "\u2280", nprcue: "\u22E0", npre: "\u2AAF\u0338", nprec: "\u2280", npreceq: "\u2AAF\u0338", nrArr: "\u21CF", nrarr: "\u219B", nrarrc: "\u2933\u0338", nrarrw: "\u219D\u0338", nRightarrow: "\u21CF", nrightarrow: "\u219B", nrtri: "\u22EB", nrtrie: "\u22ED", nsc: "\u2281", nsccue: "\u22E1", nsce: "\u2AB0\u0338", Nscr: "\u{1D4A9}", nscr: "\u{1D4C3}", nshortmid: "\u2224", nshortparallel: "\u2226", nsim: "\u2241", nsime: "\u2244", nsimeq: "\u2244", nsmid: "\u2224", nspar: "\u2226", nsqsube: "\u22E2", nsqsupe: "\u22E3", nsub: "\u2284", nsubE: "\u2AC5\u0338", nsube: "\u2288", nsubset: "\u2282\u20D2", nsubseteq: "\u2288", nsubseteqq: "\u2AC5\u0338", nsucc: "\u2281", nsucceq: "\u2AB0\u0338", nsup: "\u2285", nsupE: "\u2AC6\u0338", nsupe: "\u2289", nsupset: "\u2283\u20D2", nsupseteq: "\u2289", nsupseteqq: "\u2AC6\u0338", ntgl: "\u2279", Ntilde: "\xD1", ntilde: "\xF1", ntlg: "\u2278", ntriangleleft: "\u22EA", ntrianglelefteq: "\u22EC", ntriangleright: "\u22EB", ntrianglerighteq: "\u22ED", Nu: "\u039D", nu: "\u03BD", num: "#", numero: "\u2116", numsp: "\u2007", nvap: "\u224D\u20D2", nVDash: "\u22AF", nVdash: "\u22AE", nvDash: "\u22AD", nvdash: "\u22AC", nvge: "\u2265\u20D2", nvgt: ">\u20D2", nvHarr: "\u2904", nvinfin: "\u29DE", nvlArr: "\u2902", nvle: "\u2264\u20D2", nvlt: "<\u20D2", nvltrie: "\u22B4\u20D2", nvrArr: "\u2903", nvrtrie: "\u22B5\u20D2", nvsim: "\u223C\u20D2", nwarhk: "\u2923", nwArr: "\u21D6", nwarr: "\u2196", nwarrow: "\u2196", nwnear: "\u2927", Oacute: "\xD3", oacute: "\xF3", oast: "\u229B", ocir: "\u229A", Ocirc: "\xD4", ocirc: "\xF4", Ocy: "\u041E", ocy: "\u043E", odash: "\u229D", Odblac: "\u0150", odblac: "\u0151", odiv: "\u2A38", odot: "\u2299", odsold: "\u29BC", OElig: "\u0152", oelig: "\u0153", ofcir: "\u29BF", Ofr: "\u{1D512}", ofr: "\u{1D52C}", ogon: "\u02DB", Ograve: "\xD2", ograve: "\xF2", ogt: "\u29C1", ohbar: "\u29B5", ohm: "\u03A9", oint: "\u222E", olarr: "\u21BA", olcir: "\u29BE", olcross: "\u29BB", oline: "\u203E", olt: "\u29C0", Omacr: "\u014C", omacr: "\u014D", Omega: "\u03A9", omega: "\u03C9", Omicron: "\u039F", omicron: "\u03BF", omid: "\u29B6", ominus: "\u2296", Oopf: "\u{1D546}", oopf: "\u{1D560}", opar: "\u29B7", OpenCurlyDoubleQuote: "\u201C", OpenCurlyQuote: "\u2018", operp: "\u29B9", oplus: "\u2295", Or: "\u2A54", or: "\u2228", orarr: "\u21BB", ord: "\u2A5D", order: "\u2134", orderof: "\u2134", ordf: "\xAA", ordm: "\xBA", origof: "\u22B6", oror: "\u2A56", orslope: "\u2A57", orv: "\u2A5B", oS: "\u24C8", Oscr: "\u{1D4AA}", oscr: "\u2134", Oslash: "\xD8", oslash: "\xF8", osol: "\u2298", Otilde: "\xD5", otilde: "\xF5", Otimes: "\u2A37", otimes: "\u2297", otimesas: "\u2A36", Ouml: "\xD6", ouml: "\xF6", ovbar: "\u233D", OverBar: "\u203E", OverBrace: "\u23DE", OverBracket: "\u23B4", OverParenthesis: "\u23DC", par: "\u2225", para: "\xB6", parallel: "\u2225", parsim: "\u2AF3", parsl: "\u2AFD", part: "\u2202", PartialD: "\u2202", Pcy: "\u041F", pcy: "\u043F", percnt: "%", period: ".", permil: "\u2030", perp: "\u22A5", pertenk: "\u2031", Pfr: "\u{1D513}", pfr: "\u{1D52D}", Phi: "\u03A6", phi: "\u03C6", phiv: "\u03D5", phmmat: "\u2133", phone: "\u260E", Pi: "\u03A0", pi: "\u03C0", pitchfork: "\u22D4", piv: "\u03D6", planck: "\u210F", planckh: "\u210E", plankv: "\u210F", plus: "+", plusacir: "\u2A23", plusb: "\u229E", pluscir: "\u2A22", plusdo: "\u2214", plusdu: "\u2A25", pluse: "\u2A72", PlusMinus: "\xB1", plusmn: "\xB1", plussim: "\u2A26", plustwo: "\u2A27", pm: "\xB1", Poincareplane: "\u210C", pointint: "\u2A15", Popf: "\u2119", popf: "\u{1D561}", pound: "\xA3", Pr: "\u2ABB", pr: "\u227A", prap: "\u2AB7", prcue: "\u227C", prE: "\u2AB3", pre: "\u2AAF", prec: "\u227A", precapprox: "\u2AB7", preccurlyeq: "\u227C", Precedes: "\u227A", PrecedesEqual: "\u2AAF", PrecedesSlantEqual: "\u227C", PrecedesTilde: "\u227E", preceq: "\u2AAF", precnapprox: "\u2AB9", precneqq: "\u2AB5", precnsim: "\u22E8", precsim: "\u227E", Prime: "\u2033", prime: "\u2032", primes: "\u2119", prnap: "\u2AB9", prnE: "\u2AB5", prnsim: "\u22E8", prod: "\u220F", Product: "\u220F", profalar: "\u232E", profline: "\u2312", profsurf: "\u2313", prop: "\u221D", Proportion: "\u2237", Proportional: "\u221D", propto: "\u221D", prsim: "\u227E", prurel: "\u22B0", Pscr: "\u{1D4AB}", pscr: "\u{1D4C5}", Psi: "\u03A8", psi: "\u03C8", puncsp: "\u2008", Qfr: "\u{1D514}", qfr: "\u{1D52E}", qint: "\u2A0C", Qopf: "\u211A", qopf: "\u{1D562}", qprime: "\u2057", Qscr: "\u{1D4AC}", qscr: "\u{1D4C6}", quaternions: "\u210D", quatint: "\u2A16", quest: "?", questeq: "\u225F", QUOT: '"', quot: '"', rAarr: "\u21DB", race: "\u223D\u0331", Racute: "\u0154", racute: "\u0155", radic: "\u221A", raemptyv: "\u29B3", Rang: "\u27EB", rang: "\u27E9", rangd: "\u2992", range: "\u29A5", rangle: "\u27E9", raquo: "\xBB", Rarr: "\u21A0", rArr: "\u21D2", rarr: "\u2192", rarrap: "\u2975", rarrb: "\u21E5", rarrbfs: "\u2920", rarrc: "\u2933", rarrfs: "\u291E", rarrhk: "\u21AA", rarrlp: "\u21AC", rarrpl: "\u2945", rarrsim: "\u2974", Rarrtl: "\u2916", rarrtl: "\u21A3", rarrw: "\u219D", rAtail: "\u291C", ratail: "\u291A", ratio: "\u2236", rationals: "\u211A", RBarr: "\u2910", rBarr: "\u290F", rbarr: "\u290D", rbbrk: "\u2773", rbrace: "}", rbrack: "]", rbrke: "\u298C", rbrksld: "\u298E", rbrkslu: "\u2990", Rcaron: "\u0158", rcaron: "\u0159", Rcedil: "\u0156", rcedil: "\u0157", rceil: "\u2309", rcub: "}", Rcy: "\u0420", rcy: "\u0440", rdca: "\u2937", rdldhar: "\u2969", rdquo: "\u201D", rdquor: "\u201D", rdsh: "\u21B3", Re: "\u211C", real: "\u211C", realine: "\u211B", realpart: "\u211C", reals: "\u211D", rect: "\u25AD", REG: "\xAE", reg: "\xAE", ReverseElement: "\u220B", ReverseEquilibrium: "\u21CB", ReverseUpEquilibrium: "\u296F", rfisht: "\u297D", rfloor: "\u230B", Rfr: "\u211C", rfr: "\u{1D52F}", rHar: "\u2964", rhard: "\u21C1", rharu: "\u21C0", rharul: "\u296C", Rho: "\u03A1", rho: "\u03C1", rhov: "\u03F1", RightAngleBracket: "\u27E9", RightArrow: "\u2192", Rightarrow: "\u21D2", rightarrow: "\u2192", RightArrowBar: "\u21E5", RightArrowLeftArrow: "\u21C4", rightarrowtail: "\u21A3", RightCeiling: "\u2309", RightDoubleBracket: "\u27E7", RightDownTeeVector: "\u295D", RightDownVector: "\u21C2", RightDownVectorBar: "\u2955", RightFloor: "\u230B", rightharpoondown: "\u21C1", rightharpoonup: "\u21C0", rightleftarrows: "\u21C4", rightleftharpoons: "\u21CC", rightrightarrows: "\u21C9", rightsquigarrow: "\u219D", RightTee: "\u22A2", RightTeeArrow: "\u21A6", RightTeeVector: "\u295B", rightthreetimes: "\u22CC", RightTriangle: "\u22B3", RightTriangleBar: "\u29D0", RightTriangleEqual: "\u22B5", RightUpDownVector: "\u294F", RightUpTeeVector: "\u295C", RightUpVector: "\u21BE", RightUpVectorBar: "\u2954", RightVector: "\u21C0", RightVectorBar: "\u2953", ring: "\u02DA", risingdotseq: "\u2253", rlarr: "\u21C4", rlhar: "\u21CC", rlm: "\u200F", rmoust: "\u23B1", rmoustache: "\u23B1", rnmid: "\u2AEE", roang: "\u27ED", roarr: "\u21FE", robrk: "\u27E7", ropar: "\u2986", Ropf: "\u211D", ropf: "\u{1D563}", roplus: "\u2A2E", rotimes: "\u2A35", RoundImplies: "\u2970", rpar: ")", rpargt: "\u2994", rppolint: "\u2A12", rrarr: "\u21C9", Rrightarrow: "\u21DB", rsaquo: "\u203A", Rscr: "\u211B", rscr: "\u{1D4C7}", Rsh: "\u21B1", rsh: "\u21B1", rsqb: "]", rsquo: "\u2019", rsquor: "\u2019", rthree: "\u22CC", rtimes: "\u22CA", rtri: "\u25B9", rtrie: "\u22B5", rtrif: "\u25B8", rtriltri: "\u29CE", RuleDelayed: "\u29F4", ruluhar: "\u2968", rx: "\u211E", Sacute: "\u015A", sacute: "\u015B", sbquo: "\u201A", Sc: "\u2ABC", sc: "\u227B", scap: "\u2AB8", Scaron: "\u0160", scaron: "\u0161", sccue: "\u227D", scE: "\u2AB4", sce: "\u2AB0", Scedil: "\u015E", scedil: "\u015F", Scirc: "\u015C", scirc: "\u015D", scnap: "\u2ABA", scnE: "\u2AB6", scnsim: "\u22E9", scpolint: "\u2A13", scsim: "\u227F", Scy: "\u0421", scy: "\u0441", sdot: "\u22C5", sdotb: "\u22A1", sdote: "\u2A66", searhk: "\u2925", seArr: "\u21D8", searr: "\u2198", searrow: "\u2198", sect: "\xA7", semi: ";", seswar: "\u2929", setminus: "\u2216", setmn: "\u2216", sext: "\u2736", Sfr: "\u{1D516}", sfr: "\u{1D530}", sfrown: "\u2322", sharp: "\u266F", SHCHcy: "\u0429", shchcy: "\u0449", SHcy: "\u0428", shcy: "\u0448", ShortDownArrow: "\u2193", ShortLeftArrow: "\u2190", shortmid: "\u2223", shortparallel: "\u2225", ShortRightArrow: "\u2192", ShortUpArrow: "\u2191", shy: "\xAD", Sigma: "\u03A3", sigma: "\u03C3", sigmaf: "\u03C2", sigmav: "\u03C2", sim: "\u223C", simdot: "\u2A6A", sime: "\u2243", simeq: "\u2243", simg: "\u2A9E", simgE: "\u2AA0", siml: "\u2A9D", simlE: "\u2A9F", simne: "\u2246", simplus: "\u2A24", simrarr: "\u2972", slarr: "\u2190", SmallCircle: "\u2218", smallsetminus: "\u2216", smashp: "\u2A33", smeparsl: "\u29E4", smid: "\u2223", smile: "\u2323", smt: "\u2AAA", smte: "\u2AAC", smtes: "\u2AAC\uFE00", SOFTcy: "\u042C", softcy: "\u044C", sol: "/", solb: "\u29C4", solbar: "\u233F", Sopf: "\u{1D54A}", sopf: "\u{1D564}", spades: "\u2660", spadesuit: "\u2660", spar: "\u2225", sqcap: "\u2293", sqcaps: "\u2293\uFE00", sqcup: "\u2294", sqcups: "\u2294\uFE00", Sqrt: "\u221A", sqsub: "\u228F", sqsube: "\u2291", sqsubset: "\u228F", sqsubseteq: "\u2291", sqsup: "\u2290", sqsupe: "\u2292", sqsupset: "\u2290", sqsupseteq: "\u2292", squ: "\u25A1", Square: "\u25A1", square: "\u25A1", SquareIntersection: "\u2293", SquareSubset: "\u228F", SquareSubsetEqual: "\u2291", SquareSuperset: "\u2290", SquareSupersetEqual: "\u2292", SquareUnion: "\u2294", squarf: "\u25AA", squf: "\u25AA", srarr: "\u2192", Sscr: "\u{1D4AE}", sscr: "\u{1D4C8}", ssetmn: "\u2216", ssmile: "\u2323", sstarf: "\u22C6", Star: "\u22C6", star: "\u2606", starf: "\u2605", straightepsilon: "\u03F5", straightphi: "\u03D5", strns: "\xAF", Sub: "\u22D0", sub: "\u2282", subdot: "\u2ABD", subE: "\u2AC5", sube: "\u2286", subedot: "\u2AC3", submult: "\u2AC1", subnE: "\u2ACB", subne: "\u228A", subplus: "\u2ABF", subrarr: "\u2979", Subset: "\u22D0", subset: "\u2282", subseteq: "\u2286", subseteqq: "\u2AC5", SubsetEqual: "\u2286", subsetneq: "\u228A", subsetneqq: "\u2ACB", subsim: "\u2AC7", subsub: "\u2AD5", subsup: "\u2AD3", succ: "\u227B", succapprox: "\u2AB8", succcurlyeq: "\u227D", Succeeds: "\u227B", SucceedsEqual: "\u2AB0", SucceedsSlantEqual: "\u227D", SucceedsTilde: "\u227F", succeq: "\u2AB0", succnapprox: "\u2ABA", succneqq: "\u2AB6", succnsim: "\u22E9", succsim: "\u227F", SuchThat: "\u220B", Sum: "\u2211", sum: "\u2211", sung: "\u266A", Sup: "\u22D1", sup: "\u2283", sup1: "\xB9", sup2: "\xB2", sup3: "\xB3", supdot: "\u2ABE", supdsub: "\u2AD8", supE: "\u2AC6", supe: "\u2287", supedot: "\u2AC4", Superset: "\u2283", SupersetEqual: "\u2287", suphsol: "\u27C9", suphsub: "\u2AD7", suplarr: "\u297B", supmult: "\u2AC2", supnE: "\u2ACC", supne: "\u228B", supplus: "\u2AC0", Supset: "\u22D1", supset: "\u2283", supseteq: "\u2287", supseteqq: "\u2AC6", supsetneq: "\u228B", supsetneqq: "\u2ACC", supsim: "\u2AC8", supsub: "\u2AD4", supsup: "\u2AD6", swarhk: "\u2926", swArr: "\u21D9", swarr: "\u2199", swarrow: "\u2199", swnwar: "\u292A", szlig: "\xDF", Tab: "	", target: "\u2316", Tau: "\u03A4", tau: "\u03C4", tbrk: "\u23B4", Tcaron: "\u0164", tcaron: "\u0165", Tcedil: "\u0162", tcedil: "\u0163", Tcy: "\u0422", tcy: "\u0442", tdot: "\u20DB", telrec: "\u2315", Tfr: "\u{1D517}", tfr: "\u{1D531}", there4: "\u2234", Therefore: "\u2234", therefore: "\u2234", Theta: "\u0398", theta: "\u03B8", thetasym: "\u03D1", thetav: "\u03D1", thickapprox: "\u2248", thicksim: "\u223C", ThickSpace: "\u205F\u200A", thinsp: "\u2009", ThinSpace: "\u2009", thkap: "\u2248", thksim: "\u223C", THORN: "\xDE", thorn: "\xFE", Tilde: "\u223C", tilde: "\u02DC", TildeEqual: "\u2243", TildeFullEqual: "\u2245", TildeTilde: "\u2248", times: "\xD7", timesb: "\u22A0", timesbar: "\u2A31", timesd: "\u2A30", tint: "\u222D", toea: "\u2928", top: "\u22A4", topbot: "\u2336", topcir: "\u2AF1", Topf: "\u{1D54B}", topf: "\u{1D565}", topfork: "\u2ADA", tosa: "\u2929", tprime: "\u2034", TRADE: "\u2122", trade: "\u2122", triangle: "\u25B5", triangledown: "\u25BF", triangleleft: "\u25C3", trianglelefteq: "\u22B4", triangleq: "\u225C", triangleright: "\u25B9", trianglerighteq: "\u22B5", tridot: "\u25EC", trie: "\u225C", triminus: "\u2A3A", TripleDot: "\u20DB", triplus: "\u2A39", trisb: "\u29CD", tritime: "\u2A3B", trpezium: "\u23E2", Tscr: "\u{1D4AF}", tscr: "\u{1D4C9}", TScy: "\u0426", tscy: "\u0446", TSHcy: "\u040B", tshcy: "\u045B", Tstrok: "\u0166", tstrok: "\u0167", twixt: "\u226C", twoheadleftarrow: "\u219E", twoheadrightarrow: "\u21A0", Uacute: "\xDA", uacute: "\xFA", Uarr: "\u219F", uArr: "\u21D1", uarr: "\u2191", Uarrocir: "\u2949", Ubrcy: "\u040E", ubrcy: "\u045E", Ubreve: "\u016C", ubreve: "\u016D", Ucirc: "\xDB", ucirc: "\xFB", Ucy: "\u0423", ucy: "\u0443", udarr: "\u21C5", Udblac: "\u0170", udblac: "\u0171", udhar: "\u296E", ufisht: "\u297E", Ufr: "\u{1D518}", ufr: "\u{1D532}", Ugrave: "\xD9", ugrave: "\xF9", uHar: "\u2963", uharl: "\u21BF", uharr: "\u21BE", uhblk: "\u2580", ulcorn: "\u231C", ulcorner: "\u231C", ulcrop: "\u230F", ultri: "\u25F8", Umacr: "\u016A", umacr: "\u016B", uml: "\xA8", UnderBar: "_", UnderBrace: "\u23DF", UnderBracket: "\u23B5", UnderParenthesis: "\u23DD", Union: "\u22C3", UnionPlus: "\u228E", Uogon: "\u0172", uogon: "\u0173", Uopf: "\u{1D54C}", uopf: "\u{1D566}", UpArrow: "\u2191", Uparrow: "\u21D1", uparrow: "\u2191", UpArrowBar: "\u2912", UpArrowDownArrow: "\u21C5", UpDownArrow: "\u2195", Updownarrow: "\u21D5", updownarrow: "\u2195", UpEquilibrium: "\u296E", upharpoonleft: "\u21BF", upharpoonright: "\u21BE", uplus: "\u228E", UpperLeftArrow: "\u2196", UpperRightArrow: "\u2197", Upsi: "\u03D2", upsi: "\u03C5", upsih: "\u03D2", Upsilon: "\u03A5", upsilon: "\u03C5", UpTee: "\u22A5", UpTeeArrow: "\u21A5", upuparrows: "\u21C8", urcorn: "\u231D", urcorner: "\u231D", urcrop: "\u230E", Uring: "\u016E", uring: "\u016F", urtri: "\u25F9", Uscr: "\u{1D4B0}", uscr: "\u{1D4CA}", utdot: "\u22F0", Utilde: "\u0168", utilde: "\u0169", utri: "\u25B5", utrif: "\u25B4", uuarr: "\u21C8", Uuml: "\xDC", uuml: "\xFC", uwangle: "\u29A7", vangrt: "\u299C", varepsilon: "\u03F5", varkappa: "\u03F0", varnothing: "\u2205", varphi: "\u03D5", varpi: "\u03D6", varpropto: "\u221D", vArr: "\u21D5", varr: "\u2195", varrho: "\u03F1", varsigma: "\u03C2", varsubsetneq: "\u228A\uFE00", varsubsetneqq: "\u2ACB\uFE00", varsupsetneq: "\u228B\uFE00", varsupsetneqq: "\u2ACC\uFE00", vartheta: "\u03D1", vartriangleleft: "\u22B2", vartriangleright: "\u22B3", Vbar: "\u2AEB", vBar: "\u2AE8", vBarv: "\u2AE9", Vcy: "\u0412", vcy: "\u0432", VDash: "\u22AB", Vdash: "\u22A9", vDash: "\u22A8", vdash: "\u22A2", Vdashl: "\u2AE6", Vee: "\u22C1", vee: "\u2228", veebar: "\u22BB", veeeq: "\u225A", vellip: "\u22EE", Verbar: "\u2016", verbar: "|", Vert: "\u2016", vert: "|", VerticalBar: "\u2223", VerticalLine: "|", VerticalSeparator: "\u2758", VerticalTilde: "\u2240", VeryThinSpace: "\u200A", Vfr: "\u{1D519}", vfr: "\u{1D533}", vltri: "\u22B2", vnsub: "\u2282\u20D2", vnsup: "\u2283\u20D2", Vopf: "\u{1D54D}", vopf: "\u{1D567}", vprop: "\u221D", vrtri: "\u22B3", Vscr: "\u{1D4B1}", vscr: "\u{1D4CB}", vsubnE: "\u2ACB\uFE00", vsubne: "\u228A\uFE00", vsupnE: "\u2ACC\uFE00", vsupne: "\u228B\uFE00", Vvdash: "\u22AA", vzigzag: "\u299A", Wcirc: "\u0174", wcirc: "\u0175", wedbar: "\u2A5F", Wedge: "\u22C0", wedge: "\u2227", wedgeq: "\u2259", weierp: "\u2118", Wfr: "\u{1D51A}", wfr: "\u{1D534}", Wopf: "\u{1D54E}", wopf: "\u{1D568}", wp: "\u2118", wr: "\u2240", wreath: "\u2240", Wscr: "\u{1D4B2}", wscr: "\u{1D4CC}", xcap: "\u22C2", xcirc: "\u25EF", xcup: "\u22C3", xdtri: "\u25BD", Xfr: "\u{1D51B}", xfr: "\u{1D535}", xhArr: "\u27FA", xharr: "\u27F7", Xi: "\u039E", xi: "\u03BE", xlArr: "\u27F8", xlarr: "\u27F5", xmap: "\u27FC", xnis: "\u22FB", xodot: "\u2A00", Xopf: "\u{1D54F}", xopf: "\u{1D569}", xoplus: "\u2A01", xotime: "\u2A02", xrArr: "\u27F9", xrarr: "\u27F6", Xscr: "\u{1D4B3}", xscr: "\u{1D4CD}", xsqcup: "\u2A06", xuplus: "\u2A04", xutri: "\u25B3", xvee: "\u22C1", xwedge: "\u22C0", Yacute: "\xDD", yacute: "\xFD", YAcy: "\u042F", yacy: "\u044F", Ycirc: "\u0176", ycirc: "\u0177", Ycy: "\u042B", ycy: "\u044B", yen: "\xA5", Yfr: "\u{1D51C}", yfr: "\u{1D536}", YIcy: "\u0407", yicy: "\u0457", Yopf: "\u{1D550}", yopf: "\u{1D56A}", Yscr: "\u{1D4B4}", yscr: "\u{1D4CE}", YUcy: "\u042E", yucy: "\u044E", Yuml: "\u0178", yuml: "\xFF", Zacute: "\u0179", zacute: "\u017A", Zcaron: "\u017D", zcaron: "\u017E", Zcy: "\u0417", zcy: "\u0437", Zdot: "\u017B", zdot: "\u017C", zeetrf: "\u2128", ZeroWidthSpace: "\u200B", Zeta: "\u0396", zeta: "\u03B6", Zfr: "\u2128", zfr: "\u{1D537}", ZHcy: "\u0416", zhcy: "\u0436", zigrarr: "\u21DD", Zopf: "\u2124", zopf: "\u{1D56B}", Zscr: "\u{1D4B5}", zscr: "\u{1D4CF}", zwj: "\u200D", zwnj: "\u200C" }, e.NGSP_UNICODE = "\uE500", e.NAMED_ENTITIES.ngsp = e.NGSP_UNICODE;
        } }), _s = I({ "node_modules/angular-html-parser/lib/compiler/src/ml_parser/html_tags.js"(e) {
          "use strict";
          q(), Object.defineProperty(e, "__esModule", { value: true });
          var r = Ze(), t = class {
            constructor() {
              let { closedByChildren: a, implicitNamespacePrefix: p, contentType: D = r.TagContentType.PARSABLE_DATA, closedByParent: g = false, isVoid: i = false, ignoreFirstLf: l = false } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
              this.closedByChildren = {}, this.closedByParent = false, this.canSelfClose = false, a && a.length > 0 && a.forEach((h) => this.closedByChildren[h] = true), this.isVoid = i, this.closedByParent = g || i, this.implicitNamespacePrefix = p || null, this.contentType = D, this.ignoreFirstLf = l;
            }
            isClosedByChild(a) {
              return this.isVoid || a.toLowerCase() in this.closedByChildren;
            }
          };
          e.HtmlTagDefinition = t;
          var s, c;
          function n(a) {
            return c || (s = new t(), c = { base: new t({ isVoid: true }), meta: new t({ isVoid: true }), area: new t({ isVoid: true }), embed: new t({ isVoid: true }), link: new t({ isVoid: true }), img: new t({ isVoid: true }), input: new t({ isVoid: true }), param: new t({ isVoid: true }), hr: new t({ isVoid: true }), br: new t({ isVoid: true }), source: new t({ isVoid: true }), track: new t({ isVoid: true }), wbr: new t({ isVoid: true }), p: new t({ closedByChildren: ["address", "article", "aside", "blockquote", "div", "dl", "fieldset", "footer", "form", "h1", "h2", "h3", "h4", "h5", "h6", "header", "hgroup", "hr", "main", "nav", "ol", "p", "pre", "section", "table", "ul"], closedByParent: true }), thead: new t({ closedByChildren: ["tbody", "tfoot"] }), tbody: new t({ closedByChildren: ["tbody", "tfoot"], closedByParent: true }), tfoot: new t({ closedByChildren: ["tbody"], closedByParent: true }), tr: new t({ closedByChildren: ["tr"], closedByParent: true }), td: new t({ closedByChildren: ["td", "th"], closedByParent: true }), th: new t({ closedByChildren: ["td", "th"], closedByParent: true }), col: new t({ isVoid: true }), svg: new t({ implicitNamespacePrefix: "svg" }), math: new t({ implicitNamespacePrefix: "math" }), li: new t({ closedByChildren: ["li"], closedByParent: true }), dt: new t({ closedByChildren: ["dt", "dd"] }), dd: new t({ closedByChildren: ["dt", "dd"], closedByParent: true }), rb: new t({ closedByChildren: ["rb", "rt", "rtc", "rp"], closedByParent: true }), rt: new t({ closedByChildren: ["rb", "rt", "rtc", "rp"], closedByParent: true }), rtc: new t({ closedByChildren: ["rb", "rtc", "rp"], closedByParent: true }), rp: new t({ closedByChildren: ["rb", "rt", "rtc", "rp"], closedByParent: true }), optgroup: new t({ closedByChildren: ["optgroup"], closedByParent: true }), option: new t({ closedByChildren: ["option", "optgroup"], closedByParent: true }), pre: new t({ ignoreFirstLf: true }), listing: new t({ ignoreFirstLf: true }), style: new t({ contentType: r.TagContentType.RAW_TEXT }), script: new t({ contentType: r.TagContentType.RAW_TEXT }), title: new t({ contentType: r.TagContentType.ESCAPABLE_RAW_TEXT }), textarea: new t({ contentType: r.TagContentType.ESCAPABLE_RAW_TEXT, ignoreFirstLf: true }) }), c[a] || s;
          }
          e.getHtmlTagDefinition = n;
        } }), VD = I({ "node_modules/angular-html-parser/lib/compiler/src/ast_path.js"(e) {
          "use strict";
          q(), Object.defineProperty(e, "__esModule", { value: true });
          var r = class {
            constructor(t) {
              let s = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : -1;
              this.path = t, this.position = s;
            }
            get empty() {
              return !this.path || !this.path.length;
            }
            get head() {
              return this.path[0];
            }
            get tail() {
              return this.path[this.path.length - 1];
            }
            parentOf(t) {
              return t && this.path[this.path.indexOf(t) - 1];
            }
            childOf(t) {
              return this.path[this.path.indexOf(t) + 1];
            }
            first(t) {
              for (let s = this.path.length - 1; s >= 0; s--) {
                let c = this.path[s];
                if (c instanceof t) return c;
              }
            }
            push(t) {
              this.path.push(t);
            }
            pop() {
              return this.path.pop();
            }
          };
          e.AstPath = r;
        } }), Ss = I({ "node_modules/angular-html-parser/lib/compiler/src/ml_parser/ast.js"(e) {
          "use strict";
          q(), Object.defineProperty(e, "__esModule", { value: true });
          var r = VD(), t = class {
            constructor(d, m, T) {
              this.value = d, this.sourceSpan = m, this.i18n = T, this.type = "text";
            }
            visit(d, m) {
              return d.visitText(this, m);
            }
          };
          e.Text = t;
          var s = class {
            constructor(d, m) {
              this.value = d, this.sourceSpan = m, this.type = "cdata";
            }
            visit(d, m) {
              return d.visitCdata(this, m);
            }
          };
          e.CDATA = s;
          var c = class {
            constructor(d, m, T, B, A, N) {
              this.switchValue = d, this.type = m, this.cases = T, this.sourceSpan = B, this.switchValueSourceSpan = A, this.i18n = N;
            }
            visit(d, m) {
              return d.visitExpansion(this, m);
            }
          };
          e.Expansion = c;
          var n = class {
            constructor(d, m, T, B, A) {
              this.value = d, this.expression = m, this.sourceSpan = T, this.valueSourceSpan = B, this.expSourceSpan = A;
            }
            visit(d, m) {
              return d.visitExpansionCase(this, m);
            }
          };
          e.ExpansionCase = n;
          var a = class {
            constructor(d, m, T) {
              let B = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null, A = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : null, N = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : null;
              this.name = d, this.value = m, this.sourceSpan = T, this.valueSpan = B, this.nameSpan = A, this.i18n = N, this.type = "attribute";
            }
            visit(d, m) {
              return d.visitAttribute(this, m);
            }
          };
          e.Attribute = a;
          var p = class {
            constructor(d, m, T, B) {
              let A = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : null, N = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : null, R = arguments.length > 6 && arguments[6] !== void 0 ? arguments[6] : null, $ = arguments.length > 7 && arguments[7] !== void 0 ? arguments[7] : null;
              this.name = d, this.attrs = m, this.children = T, this.sourceSpan = B, this.startSourceSpan = A, this.endSourceSpan = N, this.nameSpan = R, this.i18n = $, this.type = "element";
            }
            visit(d, m) {
              return d.visitElement(this, m);
            }
          };
          e.Element = p;
          var D = class {
            constructor(d, m) {
              this.value = d, this.sourceSpan = m, this.type = "comment";
            }
            visit(d, m) {
              return d.visitComment(this, m);
            }
          };
          e.Comment = D;
          var g = class {
            constructor(d, m) {
              this.value = d, this.sourceSpan = m, this.type = "docType";
            }
            visit(d, m) {
              return d.visitDocType(this, m);
            }
          };
          e.DocType = g;
          function i(d, m) {
            let T = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, B = [], A = d.visit ? (N) => d.visit(N, T) || N.visit(d, T) : (N) => N.visit(d, T);
            return m.forEach((N) => {
              let R = A(N);
              R && B.push(R);
            }), B;
          }
          e.visitAll = i;
          var l = class {
            constructor() {
            }
            visitElement(d, m) {
              this.visitChildren(m, (T) => {
                T(d.attrs), T(d.children);
              });
            }
            visitAttribute(d, m) {
            }
            visitText(d, m) {
            }
            visitCdata(d, m) {
            }
            visitComment(d, m) {
            }
            visitDocType(d, m) {
            }
            visitExpansion(d, m) {
              return this.visitChildren(m, (T) => {
                T(d.cases);
              });
            }
            visitExpansionCase(d, m) {
            }
            visitChildren(d, m) {
              let T = [], B = this;
              function A(N) {
                N && T.push(i(B, N, d));
              }
              return m(A), Array.prototype.concat.apply([], T);
            }
          };
          e.RecursiveVisitor = l;
          function h(d) {
            let m = d.sourceSpan.start.offset, T = d.sourceSpan.end.offset;
            return d instanceof p && (d.endSourceSpan ? T = d.endSourceSpan.end.offset : d.children && d.children.length && (T = h(d.children[d.children.length - 1]).end)), { start: m, end: T };
          }
          function C(d, m) {
            let T = [], B = new class extends l {
              visit(A, N) {
                let R = h(A);
                if (R.start <= m && m < R.end) T.push(A);
                else return true;
              }
            }();
            return i(B, d), new r.AstPath(T, m);
          }
          e.findNode = C;
        } }), XD = I({ "node_modules/angular-html-parser/lib/compiler/src/assertions.js"(e) {
          "use strict";
          q(), Object.defineProperty(e, "__esModule", { value: true });
          function r(c, n) {
            if (n != null) {
              if (!Array.isArray(n)) throw new Error("Expected '".concat(c, "' to be an array of strings."));
              for (let a = 0; a < n.length; a += 1) if (typeof n[a] != "string") throw new Error("Expected '".concat(c, "' to be an array of strings."));
            }
          }
          e.assertArrayOfStrings = r;
          var t = [/^\s*$/, /[<>]/, /^[{}]$/, /&(#|[a-z])/i, /^\/\//];
          function s(c, n) {
            if (n != null && !(Array.isArray(n) && n.length == 2)) throw new Error("Expected '".concat(c, "' to be an array, [start, end]."));
            if (n != null) {
              let a = n[0], p = n[1];
              t.forEach((D) => {
                if (D.test(a) || D.test(p)) throw new Error("['".concat(a, "', '").concat(p, "'] contains unusable interpolation symbol."));
              });
            }
          }
          e.assertInterpolationSymbols = s;
        } }), HD = I({ "node_modules/angular-html-parser/lib/compiler/src/ml_parser/interpolation_config.js"(e) {
          "use strict";
          q(), Object.defineProperty(e, "__esModule", { value: true });
          var r = XD(), t = class {
            constructor(s, c) {
              this.start = s, this.end = c;
            }
            static fromArray(s) {
              return s ? (r.assertInterpolationSymbols("interpolation", s), new t(s[0], s[1])) : e.DEFAULT_INTERPOLATION_CONFIG;
            }
          };
          e.InterpolationConfig = t, e.DEFAULT_INTERPOLATION_CONFIG = new t("{{", "}}");
        } }), zD = I({ "node_modules/angular-html-parser/lib/compiler/src/ml_parser/lexer.js"(e) {
          "use strict";
          q(), Object.defineProperty(e, "__esModule", { value: true });
          var r = hs(), t = Te(), s = HD(), c = Ze(), n;
          (function(u) {
            u[u.TAG_OPEN_START = 0] = "TAG_OPEN_START", u[u.TAG_OPEN_END = 1] = "TAG_OPEN_END", u[u.TAG_OPEN_END_VOID = 2] = "TAG_OPEN_END_VOID", u[u.TAG_CLOSE = 3] = "TAG_CLOSE", u[u.TEXT = 4] = "TEXT", u[u.ESCAPABLE_RAW_TEXT = 5] = "ESCAPABLE_RAW_TEXT", u[u.RAW_TEXT = 6] = "RAW_TEXT", u[u.COMMENT_START = 7] = "COMMENT_START", u[u.COMMENT_END = 8] = "COMMENT_END", u[u.CDATA_START = 9] = "CDATA_START", u[u.CDATA_END = 10] = "CDATA_END", u[u.ATTR_NAME = 11] = "ATTR_NAME", u[u.ATTR_QUOTE = 12] = "ATTR_QUOTE", u[u.ATTR_VALUE = 13] = "ATTR_VALUE", u[u.DOC_TYPE_START = 14] = "DOC_TYPE_START", u[u.DOC_TYPE_END = 15] = "DOC_TYPE_END", u[u.EXPANSION_FORM_START = 16] = "EXPANSION_FORM_START", u[u.EXPANSION_CASE_VALUE = 17] = "EXPANSION_CASE_VALUE", u[u.EXPANSION_CASE_EXP_START = 18] = "EXPANSION_CASE_EXP_START", u[u.EXPANSION_CASE_EXP_END = 19] = "EXPANSION_CASE_EXP_END", u[u.EXPANSION_FORM_END = 20] = "EXPANSION_FORM_END", u[u.EOF = 21] = "EOF";
          })(n = e.TokenType || (e.TokenType = {}));
          var a = class {
            constructor(u, o, E) {
              this.type = u, this.parts = o, this.sourceSpan = E;
            }
          };
          e.Token = a;
          var p = class extends t.ParseError {
            constructor(u, o, E) {
              super(E, u), this.tokenType = o;
            }
          };
          e.TokenError = p;
          var D = class {
            constructor(u, o) {
              this.tokens = u, this.errors = o;
            }
          };
          e.TokenizeResult = D;
          function g(u, o, E) {
            let f = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : {};
            return new d(new t.ParseSourceFile(u, o), E, f).tokenize();
          }
          e.tokenize = g;
          var i = /\r\n?/g;
          function l(u) {
            let o = u === r.$EOF ? "EOF" : String.fromCharCode(u);
            return 'Unexpected character "'.concat(o, '"');
          }
          function h(u) {
            return 'Unknown entity "'.concat(u, '" - use the "&#<decimal>;" or  "&#x<hex>;" syntax');
          }
          var C = class {
            constructor(u) {
              this.error = u;
            }
          }, d = class {
            constructor(u, o, E) {
              this._getTagContentType = o, this._currentTokenStart = null, this._currentTokenType = null, this._expansionCaseStack = [], this._inInterpolation = false, this._fullNameStack = [], this.tokens = [], this.errors = [], this._tokenizeIcu = E.tokenizeExpansionForms || false, this._interpolationConfig = E.interpolationConfig || s.DEFAULT_INTERPOLATION_CONFIG, this._leadingTriviaCodePoints = E.leadingTriviaChars && E.leadingTriviaChars.map((F) => F.codePointAt(0) || 0), this._canSelfClose = E.canSelfClose || false, this._allowHtmComponentClosingTags = E.allowHtmComponentClosingTags || false;
              let f = E.range || { endPos: u.content.length, startPos: 0, startLine: 0, startCol: 0 };
              this._cursor = E.escapedString ? new k(u, f) : new x(u, f);
              try {
                this._cursor.init();
              } catch (F) {
                this.handleError(F);
              }
            }
            _processCarriageReturns(u) {
              return u.replace(i, `
`);
            }
            tokenize() {
              for (; this._cursor.peek() !== r.$EOF; ) {
                let u = this._cursor.clone();
                try {
                  if (this._attemptCharCode(r.$LT)) if (this._attemptCharCode(r.$BANG)) this._attemptStr("[CDATA[") ? this._consumeCdata(u) : this._attemptStr("--") ? this._consumeComment(u) : this._attemptStrCaseInsensitive("doctype") ? this._consumeDocType(u) : this._consumeBogusComment(u);
                  else if (this._attemptCharCode(r.$SLASH)) this._consumeTagClose(u);
                  else {
                    let o = this._cursor.clone();
                    this._attemptCharCode(r.$QUESTION) ? (this._cursor = o, this._consumeBogusComment(u)) : this._consumeTagOpen(u);
                  }
                  else this._tokenizeIcu && this._tokenizeExpansionForm() || this._consumeText();
                } catch (o) {
                  this.handleError(o);
                }
              }
              return this._beginToken(n.EOF), this._endToken([]), new D(O(this.tokens), this.errors);
            }
            _tokenizeExpansionForm() {
              if (this.isExpansionFormStart()) return this._consumeExpansionFormStart(), true;
              if (R(this._cursor.peek()) && this._isInExpansionForm()) return this._consumeExpansionCaseStart(), true;
              if (this._cursor.peek() === r.$RBRACE) {
                if (this._isInExpansionCase()) return this._consumeExpansionCaseEnd(), true;
                if (this._isInExpansionForm()) return this._consumeExpansionFormEnd(), true;
              }
              return false;
            }
            _beginToken(u) {
              let o = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this._cursor.clone();
              this._currentTokenStart = o, this._currentTokenType = u;
            }
            _endToken(u) {
              let o = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this._cursor.clone();
              if (this._currentTokenStart === null) throw new p("Programming error - attempted to end a token when there was no start to the token", this._currentTokenType, this._cursor.getSpan(o));
              if (this._currentTokenType === null) throw new p("Programming error - attempted to end a token which has no token type", null, this._cursor.getSpan(this._currentTokenStart));
              let E = new a(this._currentTokenType, u, this._cursor.getSpan(this._currentTokenStart, this._leadingTriviaCodePoints));
              return this.tokens.push(E), this._currentTokenStart = null, this._currentTokenType = null, E;
            }
            _createError(u, o) {
              this._isInExpansionForm() && (u += ` (Do you have an unescaped "{" in your template? Use "{{ '{' }}") to escape it.)`);
              let E = new p(u, this._currentTokenType, o);
              return this._currentTokenStart = null, this._currentTokenType = null, new C(E);
            }
            handleError(u) {
              if (u instanceof M && (u = this._createError(u.msg, this._cursor.getSpan(u.cursor))), u instanceof C) this.errors.push(u.error);
              else throw u;
            }
            _attemptCharCode(u) {
              return this._cursor.peek() === u ? (this._cursor.advance(), true) : false;
            }
            _attemptCharCodeCaseInsensitive(u) {
              return $(this._cursor.peek(), u) ? (this._cursor.advance(), true) : false;
            }
            _requireCharCode(u) {
              let o = this._cursor.clone();
              if (!this._attemptCharCode(u)) throw this._createError(l(this._cursor.peek()), this._cursor.getSpan(o));
            }
            _attemptStr(u) {
              let o = u.length;
              if (this._cursor.charsLeft() < o) return false;
              let E = this._cursor.clone();
              for (let f = 0; f < o; f++) if (!this._attemptCharCode(u.charCodeAt(f))) return this._cursor = E, false;
              return true;
            }
            _attemptStrCaseInsensitive(u) {
              for (let o = 0; o < u.length; o++) if (!this._attemptCharCodeCaseInsensitive(u.charCodeAt(o))) return false;
              return true;
            }
            _requireStr(u) {
              let o = this._cursor.clone();
              if (!this._attemptStr(u)) throw this._createError(l(this._cursor.peek()), this._cursor.getSpan(o));
            }
            _requireStrCaseInsensitive(u) {
              let o = this._cursor.clone();
              if (!this._attemptStrCaseInsensitive(u)) throw this._createError(l(this._cursor.peek()), this._cursor.getSpan(o));
            }
            _attemptCharCodeUntilFn(u) {
              for (; !u(this._cursor.peek()); ) this._cursor.advance();
            }
            _requireCharCodeUntilFn(u, o) {
              let E = this._cursor.clone();
              if (this._attemptCharCodeUntilFn(u), this._cursor.clone().diff(E) < o) throw this._createError(l(this._cursor.peek()), this._cursor.getSpan(E));
            }
            _attemptUntilChar(u) {
              for (; this._cursor.peek() !== u; ) this._cursor.advance();
            }
            _readChar(u) {
              if (u && this._cursor.peek() === r.$AMPERSAND) return this._decodeEntity();
              {
                let o = String.fromCodePoint(this._cursor.peek());
                return this._cursor.advance(), o;
              }
            }
            _decodeEntity() {
              let u = this._cursor.clone();
              if (this._cursor.advance(), this._attemptCharCode(r.$HASH)) {
                let o = this._attemptCharCode(r.$x) || this._attemptCharCode(r.$X), E = this._cursor.clone();
                if (this._attemptCharCodeUntilFn(A), this._cursor.peek() != r.$SEMICOLON) throw this._createError(l(this._cursor.peek()), this._cursor.getSpan());
                let f = this._cursor.getChars(E);
                this._cursor.advance();
                try {
                  let F = parseInt(f, o ? 16 : 10);
                  return String.fromCharCode(F);
                } catch {
                  throw this._createError(h(this._cursor.getChars(u)), this._cursor.getSpan());
                }
              } else {
                let o = this._cursor.clone();
                if (this._attemptCharCodeUntilFn(N), this._cursor.peek() != r.$SEMICOLON) return this._cursor = o, "&";
                let E = this._cursor.getChars(o);
                this._cursor.advance();
                let f = c.NAMED_ENTITIES[E];
                if (!f) throw this._createError(h(E), this._cursor.getSpan(u));
                return f;
              }
            }
            _consumeRawText(u, o) {
              this._beginToken(u ? n.ESCAPABLE_RAW_TEXT : n.RAW_TEXT);
              let E = [];
              for (; ; ) {
                let f = this._cursor.clone(), F = o();
                if (this._cursor = f, F) break;
                E.push(this._readChar(u));
              }
              return this._endToken([this._processCarriageReturns(E.join(""))]);
            }
            _consumeComment(u) {
              this._beginToken(n.COMMENT_START, u), this._endToken([]), this._consumeRawText(false, () => this._attemptStr("-->")), this._beginToken(n.COMMENT_END), this._requireStr("-->"), this._endToken([]);
            }
            _consumeBogusComment(u) {
              this._beginToken(n.COMMENT_START, u), this._endToken([]), this._consumeRawText(false, () => this._cursor.peek() === r.$GT), this._beginToken(n.COMMENT_END), this._cursor.advance(), this._endToken([]);
            }
            _consumeCdata(u) {
              this._beginToken(n.CDATA_START, u), this._endToken([]), this._consumeRawText(false, () => this._attemptStr("]]>")), this._beginToken(n.CDATA_END), this._requireStr("]]>"), this._endToken([]);
            }
            _consumeDocType(u) {
              this._beginToken(n.DOC_TYPE_START, u), this._endToken([]), this._consumeRawText(false, () => this._cursor.peek() === r.$GT), this._beginToken(n.DOC_TYPE_END), this._cursor.advance(), this._endToken([]);
            }
            _consumePrefixAndName() {
              let u = this._cursor.clone(), o = "";
              for (; this._cursor.peek() !== r.$COLON && !B(this._cursor.peek()); ) this._cursor.advance();
              let E;
              this._cursor.peek() === r.$COLON ? (o = this._cursor.getChars(u), this._cursor.advance(), E = this._cursor.clone()) : E = u, this._requireCharCodeUntilFn(T, o === "" ? 0 : 1);
              let f = this._cursor.getChars(E);
              return [o, f];
            }
            _consumeTagOpen(u) {
              let o, E, f, F = this.tokens.length, P = this._cursor.clone(), j = [];
              try {
                if (!r.isAsciiLetter(this._cursor.peek())) throw this._createError(l(this._cursor.peek()), this._cursor.getSpan(u));
                for (f = this._consumeTagOpenStart(u), E = f.parts[0], o = f.parts[1], this._attemptCharCodeUntilFn(m); this._cursor.peek() !== r.$SLASH && this._cursor.peek() !== r.$GT; ) {
                  let [X, H] = this._consumeAttributeName();
                  if (this._attemptCharCodeUntilFn(m), this._attemptCharCode(r.$EQ)) {
                    this._attemptCharCodeUntilFn(m);
                    let z2 = this._consumeAttributeValue();
                    j.push({ prefix: X, name: H, value: z2 });
                  } else j.push({ prefix: X, name: H });
                  this._attemptCharCodeUntilFn(m);
                }
                this._consumeTagOpenEnd();
              } catch (X) {
                if (X instanceof C) {
                  this._cursor = P, f && (this.tokens.length = F), this._beginToken(n.TEXT, u), this._endToken(["<"]);
                  return;
                }
                throw X;
              }
              if (this._canSelfClose && this.tokens[this.tokens.length - 1].type === n.TAG_OPEN_END_VOID) return;
              let W = this._getTagContentType(o, E, this._fullNameStack.length > 0, j);
              this._handleFullNameStackForTagOpen(E, o), W === c.TagContentType.RAW_TEXT ? this._consumeRawTextWithTagClose(E, o, false) : W === c.TagContentType.ESCAPABLE_RAW_TEXT && this._consumeRawTextWithTagClose(E, o, true);
            }
            _consumeRawTextWithTagClose(u, o, E) {
              let f = this._consumeRawText(E, () => !this._attemptCharCode(r.$LT) || !this._attemptCharCode(r.$SLASH) || (this._attemptCharCodeUntilFn(m), !this._attemptStrCaseInsensitive(u ? "".concat(u, ":").concat(o) : o)) ? false : (this._attemptCharCodeUntilFn(m), this._attemptCharCode(r.$GT)));
              this._beginToken(n.TAG_CLOSE), this._requireCharCodeUntilFn((F) => F === r.$GT, 3), this._cursor.advance(), this._endToken([u, o]), this._handleFullNameStackForTagClose(u, o);
            }
            _consumeTagOpenStart(u) {
              this._beginToken(n.TAG_OPEN_START, u);
              let o = this._consumePrefixAndName();
              return this._endToken(o);
            }
            _consumeAttributeName() {
              let u = this._cursor.peek();
              if (u === r.$SQ || u === r.$DQ) throw this._createError(l(u), this._cursor.getSpan());
              this._beginToken(n.ATTR_NAME);
              let o = this._consumePrefixAndName();
              return this._endToken(o), o;
            }
            _consumeAttributeValue() {
              let u;
              if (this._cursor.peek() === r.$SQ || this._cursor.peek() === r.$DQ) {
                this._beginToken(n.ATTR_QUOTE);
                let o = this._cursor.peek();
                this._cursor.advance(), this._endToken([String.fromCodePoint(o)]), this._beginToken(n.ATTR_VALUE);
                let E = [];
                for (; this._cursor.peek() !== o; ) E.push(this._readChar(true));
                u = this._processCarriageReturns(E.join("")), this._endToken([u]), this._beginToken(n.ATTR_QUOTE), this._cursor.advance(), this._endToken([String.fromCodePoint(o)]);
              } else {
                this._beginToken(n.ATTR_VALUE);
                let o = this._cursor.clone();
                this._requireCharCodeUntilFn(T, 1), u = this._processCarriageReturns(this._cursor.getChars(o)), this._endToken([u]);
              }
              return u;
            }
            _consumeTagOpenEnd() {
              let u = this._attemptCharCode(r.$SLASH) ? n.TAG_OPEN_END_VOID : n.TAG_OPEN_END;
              this._beginToken(u), this._requireCharCode(r.$GT), this._endToken([]);
            }
            _consumeTagClose(u) {
              if (this._beginToken(n.TAG_CLOSE, u), this._attemptCharCodeUntilFn(m), this._allowHtmComponentClosingTags && this._attemptCharCode(r.$SLASH)) this._attemptCharCodeUntilFn(m), this._requireCharCode(r.$GT), this._endToken([]);
              else {
                let [o, E] = this._consumePrefixAndName();
                this._attemptCharCodeUntilFn(m), this._requireCharCode(r.$GT), this._endToken([o, E]), this._handleFullNameStackForTagClose(o, E);
              }
            }
            _consumeExpansionFormStart() {
              this._beginToken(n.EXPANSION_FORM_START), this._requireCharCode(r.$LBRACE), this._endToken([]), this._expansionCaseStack.push(n.EXPANSION_FORM_START), this._beginToken(n.RAW_TEXT);
              let u = this._readUntil(r.$COMMA);
              this._endToken([u]), this._requireCharCode(r.$COMMA), this._attemptCharCodeUntilFn(m), this._beginToken(n.RAW_TEXT);
              let o = this._readUntil(r.$COMMA);
              this._endToken([o]), this._requireCharCode(r.$COMMA), this._attemptCharCodeUntilFn(m);
            }
            _consumeExpansionCaseStart() {
              this._beginToken(n.EXPANSION_CASE_VALUE);
              let u = this._readUntil(r.$LBRACE).trim();
              this._endToken([u]), this._attemptCharCodeUntilFn(m), this._beginToken(n.EXPANSION_CASE_EXP_START), this._requireCharCode(r.$LBRACE), this._endToken([]), this._attemptCharCodeUntilFn(m), this._expansionCaseStack.push(n.EXPANSION_CASE_EXP_START);
            }
            _consumeExpansionCaseEnd() {
              this._beginToken(n.EXPANSION_CASE_EXP_END), this._requireCharCode(r.$RBRACE), this._endToken([]), this._attemptCharCodeUntilFn(m), this._expansionCaseStack.pop();
            }
            _consumeExpansionFormEnd() {
              this._beginToken(n.EXPANSION_FORM_END), this._requireCharCode(r.$RBRACE), this._endToken([]), this._expansionCaseStack.pop();
            }
            _consumeText() {
              let u = this._cursor.clone();
              this._beginToken(n.TEXT, u);
              let o = [];
              do
                this._interpolationConfig && this._attemptStr(this._interpolationConfig.start) ? (o.push(this._interpolationConfig.start), this._inInterpolation = true) : this._interpolationConfig && this._inInterpolation && this._attemptStr(this._interpolationConfig.end) ? (o.push(this._interpolationConfig.end), this._inInterpolation = false) : o.push(this._readChar(true));
              while (!this._isTextEnd());
              this._endToken([this._processCarriageReturns(o.join(""))]);
            }
            _isTextEnd() {
              return !!(this._cursor.peek() === r.$LT || this._cursor.peek() === r.$EOF || this._tokenizeIcu && !this._inInterpolation && (this.isExpansionFormStart() || this._cursor.peek() === r.$RBRACE && this._isInExpansionCase()));
            }
            _readUntil(u) {
              let o = this._cursor.clone();
              return this._attemptUntilChar(u), this._cursor.getChars(o);
            }
            _isInExpansionCase() {
              return this._expansionCaseStack.length > 0 && this._expansionCaseStack[this._expansionCaseStack.length - 1] === n.EXPANSION_CASE_EXP_START;
            }
            _isInExpansionForm() {
              return this._expansionCaseStack.length > 0 && this._expansionCaseStack[this._expansionCaseStack.length - 1] === n.EXPANSION_FORM_START;
            }
            isExpansionFormStart() {
              if (this._cursor.peek() !== r.$LBRACE) return false;
              if (this._interpolationConfig) {
                let u = this._cursor.clone(), o = this._attemptStr(this._interpolationConfig.start);
                return this._cursor = u, !o;
              }
              return true;
            }
            _handleFullNameStackForTagOpen(u, o) {
              let E = c.mergeNsAndName(u, o);
              (this._fullNameStack.length === 0 || this._fullNameStack[this._fullNameStack.length - 1] === E) && this._fullNameStack.push(E);
            }
            _handleFullNameStackForTagClose(u, o) {
              let E = c.mergeNsAndName(u, o);
              this._fullNameStack.length !== 0 && this._fullNameStack[this._fullNameStack.length - 1] === E && this._fullNameStack.pop();
            }
          };
          function m(u) {
            return !r.isWhitespace(u) || u === r.$EOF;
          }
          function T(u) {
            return r.isWhitespace(u) || u === r.$GT || u === r.$SLASH || u === r.$SQ || u === r.$DQ || u === r.$EQ;
          }
          function B(u) {
            return (u < r.$a || r.$z < u) && (u < r.$A || r.$Z < u) && (u < r.$0 || u > r.$9);
          }
          function A(u) {
            return u == r.$SEMICOLON || u == r.$EOF || !r.isAsciiHexDigit(u);
          }
          function N(u) {
            return u == r.$SEMICOLON || u == r.$EOF || !r.isAsciiLetter(u);
          }
          function R(u) {
            return u === r.$EQ || r.isAsciiLetter(u) || r.isDigit(u);
          }
          function $(u, o) {
            return _(u) == _(o);
          }
          function _(u) {
            return u >= r.$a && u <= r.$z ? u - r.$a + r.$A : u;
          }
          function O(u) {
            let o = [], E;
            for (let f = 0; f < u.length; f++) {
              let F = u[f];
              E && E.type == n.TEXT && F.type == n.TEXT ? (E.parts[0] += F.parts[0], E.sourceSpan.end = F.sourceSpan.end) : (E = F, o.push(E));
            }
            return o;
          }
          var x = class {
            constructor(u, o) {
              if (u instanceof x) this.file = u.file, this.input = u.input, this.end = u.end, this.state = Object.assign({}, u.state);
              else {
                if (!o) throw new Error("Programming error: the range argument must be provided with a file argument.");
                this.file = u, this.input = u.content, this.end = o.endPos, this.state = { peek: -1, offset: o.startPos, line: o.startLine, column: o.startCol };
              }
            }
            clone() {
              return new x(this);
            }
            peek() {
              return this.state.peek;
            }
            charsLeft() {
              return this.end - this.state.offset;
            }
            diff(u) {
              return this.state.offset - u.state.offset;
            }
            advance() {
              this.advanceState(this.state);
            }
            init() {
              this.updatePeek(this.state);
            }
            getSpan(u, o) {
              if (u = u || this, o) for (u = u.clone(); this.diff(u) > 0 && o.indexOf(u.peek()) !== -1; ) u.advance();
              return new t.ParseSourceSpan(new t.ParseLocation(u.file, u.state.offset, u.state.line, u.state.column), new t.ParseLocation(this.file, this.state.offset, this.state.line, this.state.column));
            }
            getChars(u) {
              return this.input.substring(u.state.offset, this.state.offset);
            }
            charAt(u) {
              return this.input.charCodeAt(u);
            }
            advanceState(u) {
              if (u.offset >= this.end) throw this.state = u, new M('Unexpected character "EOF"', this);
              let o = this.charAt(u.offset);
              o === r.$LF ? (u.line++, u.column = 0) : r.isNewLine(o) || u.column++, u.offset++, this.updatePeek(u);
            }
            updatePeek(u) {
              u.peek = u.offset >= this.end ? r.$EOF : this.charAt(u.offset);
            }
          }, k = class extends x {
            constructor(u, o) {
              u instanceof k ? (super(u), this.internalState = Object.assign({}, u.internalState)) : (super(u, o), this.internalState = this.state);
            }
            advance() {
              this.state = this.internalState, super.advance(), this.processEscapeSequence();
            }
            init() {
              super.init(), this.processEscapeSequence();
            }
            clone() {
              return new k(this);
            }
            getChars(u) {
              let o = u.clone(), E = "";
              for (; o.internalState.offset < this.internalState.offset; ) E += String.fromCodePoint(o.peek()), o.advance();
              return E;
            }
            processEscapeSequence() {
              let u = () => this.internalState.peek;
              if (u() === r.$BACKSLASH) if (this.internalState = Object.assign({}, this.state), this.advanceState(this.internalState), u() === r.$n) this.state.peek = r.$LF;
              else if (u() === r.$r) this.state.peek = r.$CR;
              else if (u() === r.$v) this.state.peek = r.$VTAB;
              else if (u() === r.$t) this.state.peek = r.$TAB;
              else if (u() === r.$b) this.state.peek = r.$BSPACE;
              else if (u() === r.$f) this.state.peek = r.$FF;
              else if (u() === r.$u) if (this.advanceState(this.internalState), u() === r.$LBRACE) {
                this.advanceState(this.internalState);
                let o = this.clone(), E = 0;
                for (; u() !== r.$RBRACE; ) this.advanceState(this.internalState), E++;
                this.state.peek = this.decodeHexDigits(o, E);
              } else {
                let o = this.clone();
                this.advanceState(this.internalState), this.advanceState(this.internalState), this.advanceState(this.internalState), this.state.peek = this.decodeHexDigits(o, 4);
              }
              else if (u() === r.$x) {
                this.advanceState(this.internalState);
                let o = this.clone();
                this.advanceState(this.internalState), this.state.peek = this.decodeHexDigits(o, 2);
              } else if (r.isOctalDigit(u())) {
                let o = "", E = 0, f = this.clone();
                for (; r.isOctalDigit(u()) && E < 3; ) f = this.clone(), o += String.fromCodePoint(u()), this.advanceState(this.internalState), E++;
                this.state.peek = parseInt(o, 8), this.internalState = f.internalState;
              } else r.isNewLine(this.internalState.peek) ? (this.advanceState(this.internalState), this.state = this.internalState) : this.state.peek = this.internalState.peek;
            }
            decodeHexDigits(u, o) {
              let E = this.input.substr(u.internalState.offset, o), f = parseInt(E, 16);
              if (isNaN(f)) throw u.state = u.internalState, new M("Invalid hexadecimal escape sequence", u);
              return f;
            }
          }, M = class {
            constructor(u, o) {
              this.msg = u, this.cursor = o;
            }
          };
          e.CursorError = M;
        } }), as = I({ "node_modules/angular-html-parser/lib/compiler/src/ml_parser/parser.js"(e) {
          "use strict";
          q(), Object.defineProperty(e, "__esModule", { value: true });
          var r = Te(), t = Ss(), s = zD(), c = Ze(), n = class extends r.ParseError {
            constructor(i, l, h) {
              super(l, h), this.elementName = i;
            }
            static create(i, l, h) {
              return new n(i, l, h);
            }
          };
          e.TreeError = n;
          var a = class {
            constructor(i, l) {
              this.rootNodes = i, this.errors = l;
            }
          };
          e.ParseTreeResult = a;
          var p = class {
            constructor(i) {
              this.getTagDefinition = i;
            }
            parse(i, l, h) {
              let C = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, d = arguments.length > 4 ? arguments[4] : void 0, m = (x) => function(k) {
                for (var M = arguments.length, u = new Array(M > 1 ? M - 1 : 0), o = 1; o < M; o++) u[o - 1] = arguments[o];
                return x(k.toLowerCase(), ...u);
              }, T = C ? this.getTagDefinition : m(this.getTagDefinition), B = (x) => T(x).contentType, A = C ? d : m(d), N = d ? (x, k, M, u) => {
                let o = A(x, k, M, u);
                return o !== void 0 ? o : B(x);
              } : B, R = s.tokenize(i, l, N, h), $ = h && h.canSelfClose || false, _ = h && h.allowHtmComponentClosingTags || false, O = new D(R.tokens, T, $, _, C).build();
              return new a(O.rootNodes, R.errors.concat(O.errors));
            }
          };
          e.Parser = p;
          var D = class {
            constructor(i, l, h, C, d) {
              this.tokens = i, this.getTagDefinition = l, this.canSelfClose = h, this.allowHtmComponentClosingTags = C, this.isTagNameCaseSensitive = d, this._index = -1, this._rootNodes = [], this._errors = [], this._elementStack = [], this._advance();
            }
            build() {
              for (; this._peek.type !== s.TokenType.EOF; ) this._peek.type === s.TokenType.TAG_OPEN_START ? this._consumeStartTag(this._advance()) : this._peek.type === s.TokenType.TAG_CLOSE ? (this._closeVoidElement(), this._consumeEndTag(this._advance())) : this._peek.type === s.TokenType.CDATA_START ? (this._closeVoidElement(), this._consumeCdata(this._advance())) : this._peek.type === s.TokenType.COMMENT_START ? (this._closeVoidElement(), this._consumeComment(this._advance())) : this._peek.type === s.TokenType.TEXT || this._peek.type === s.TokenType.RAW_TEXT || this._peek.type === s.TokenType.ESCAPABLE_RAW_TEXT ? (this._closeVoidElement(), this._consumeText(this._advance())) : this._peek.type === s.TokenType.EXPANSION_FORM_START ? this._consumeExpansion(this._advance()) : this._peek.type === s.TokenType.DOC_TYPE_START ? this._consumeDocType(this._advance()) : this._advance();
              return new a(this._rootNodes, this._errors);
            }
            _advance() {
              let i = this._peek;
              return this._index < this.tokens.length - 1 && this._index++, this._peek = this.tokens[this._index], i;
            }
            _advanceIf(i) {
              return this._peek.type === i ? this._advance() : null;
            }
            _consumeCdata(i) {
              let l = this._advance(), h = this._getText(l), C = this._advanceIf(s.TokenType.CDATA_END);
              this._addToParent(new t.CDATA(h, new r.ParseSourceSpan(i.sourceSpan.start, (C || l).sourceSpan.end)));
            }
            _consumeComment(i) {
              let l = this._advanceIf(s.TokenType.RAW_TEXT), h = this._advanceIf(s.TokenType.COMMENT_END), C = l != null ? l.parts[0].trim() : null, d = new r.ParseSourceSpan(i.sourceSpan.start, (h || l || i).sourceSpan.end);
              this._addToParent(new t.Comment(C, d));
            }
            _consumeDocType(i) {
              let l = this._advanceIf(s.TokenType.RAW_TEXT), h = this._advanceIf(s.TokenType.DOC_TYPE_END), C = l != null ? l.parts[0].trim() : null, d = new r.ParseSourceSpan(i.sourceSpan.start, (h || l || i).sourceSpan.end);
              this._addToParent(new t.DocType(C, d));
            }
            _consumeExpansion(i) {
              let l = this._advance(), h = this._advance(), C = [];
              for (; this._peek.type === s.TokenType.EXPANSION_CASE_VALUE; ) {
                let m = this._parseExpansionCase();
                if (!m) return;
                C.push(m);
              }
              if (this._peek.type !== s.TokenType.EXPANSION_FORM_END) {
                this._errors.push(n.create(null, this._peek.sourceSpan, "Invalid ICU message. Missing '}'."));
                return;
              }
              let d = new r.ParseSourceSpan(i.sourceSpan.start, this._peek.sourceSpan.end);
              this._addToParent(new t.Expansion(l.parts[0], h.parts[0], C, d, l.sourceSpan)), this._advance();
            }
            _parseExpansionCase() {
              let i = this._advance();
              if (this._peek.type !== s.TokenType.EXPANSION_CASE_EXP_START) return this._errors.push(n.create(null, this._peek.sourceSpan, "Invalid ICU message. Missing '{'.")), null;
              let l = this._advance(), h = this._collectExpansionExpTokens(l);
              if (!h) return null;
              let C = this._advance();
              h.push(new s.Token(s.TokenType.EOF, [], C.sourceSpan));
              let d = new D(h, this.getTagDefinition, this.canSelfClose, this.allowHtmComponentClosingTags, this.isTagNameCaseSensitive).build();
              if (d.errors.length > 0) return this._errors = this._errors.concat(d.errors), null;
              let m = new r.ParseSourceSpan(i.sourceSpan.start, C.sourceSpan.end), T = new r.ParseSourceSpan(l.sourceSpan.start, C.sourceSpan.end);
              return new t.ExpansionCase(i.parts[0], d.rootNodes, m, i.sourceSpan, T);
            }
            _collectExpansionExpTokens(i) {
              let l = [], h = [s.TokenType.EXPANSION_CASE_EXP_START];
              for (; ; ) {
                if ((this._peek.type === s.TokenType.EXPANSION_FORM_START || this._peek.type === s.TokenType.EXPANSION_CASE_EXP_START) && h.push(this._peek.type), this._peek.type === s.TokenType.EXPANSION_CASE_EXP_END) if (g(h, s.TokenType.EXPANSION_CASE_EXP_START)) {
                  if (h.pop(), h.length == 0) return l;
                } else return this._errors.push(n.create(null, i.sourceSpan, "Invalid ICU message. Missing '}'.")), null;
                if (this._peek.type === s.TokenType.EXPANSION_FORM_END) if (g(h, s.TokenType.EXPANSION_FORM_START)) h.pop();
                else return this._errors.push(n.create(null, i.sourceSpan, "Invalid ICU message. Missing '}'.")), null;
                if (this._peek.type === s.TokenType.EOF) return this._errors.push(n.create(null, i.sourceSpan, "Invalid ICU message. Missing '}'.")), null;
                l.push(this._advance());
              }
            }
            _getText(i) {
              let l = i.parts[0];
              if (l.length > 0 && l[0] == `
`) {
                let h = this._getParentElement();
                h != null && h.children.length == 0 && this.getTagDefinition(h.name).ignoreFirstLf && (l = l.substring(1));
              }
              return l;
            }
            _consumeText(i) {
              let l = this._getText(i);
              l.length > 0 && this._addToParent(new t.Text(l, i.sourceSpan));
            }
            _closeVoidElement() {
              let i = this._getParentElement();
              i && this.getTagDefinition(i.name).isVoid && this._elementStack.pop();
            }
            _consumeStartTag(i) {
              let l = i.parts[0], h = i.parts[1], C = [];
              for (; this._peek.type === s.TokenType.ATTR_NAME; ) C.push(this._consumeAttr(this._advance()));
              let d = this._getElementFullName(l, h, this._getParentElement()), m = false;
              if (this._peek.type === s.TokenType.TAG_OPEN_END_VOID) {
                this._advance(), m = true;
                let R = this.getTagDefinition(d);
                this.canSelfClose || R.canSelfClose || c.getNsPrefix(d) !== null || R.isVoid || this._errors.push(n.create(d, i.sourceSpan, 'Only void and foreign elements can be self closed "'.concat(i.parts[1], '"')));
              } else this._peek.type === s.TokenType.TAG_OPEN_END && (this._advance(), m = false);
              let T = this._peek.sourceSpan.start, B = new r.ParseSourceSpan(i.sourceSpan.start, T), A = new r.ParseSourceSpan(i.sourceSpan.start.moveBy(1), i.sourceSpan.end), N = new t.Element(d, C, [], B, B, void 0, A);
              this._pushElement(N), m && (this._popElement(d), N.endSourceSpan = B);
            }
            _pushElement(i) {
              let l = this._getParentElement();
              l && this.getTagDefinition(l.name).isClosedByChild(i.name) && this._elementStack.pop(), this._addToParent(i), this._elementStack.push(i);
            }
            _consumeEndTag(i) {
              let l = this.allowHtmComponentClosingTags && i.parts.length === 0 ? null : this._getElementFullName(i.parts[0], i.parts[1], this._getParentElement());
              if (this._getParentElement() && (this._getParentElement().endSourceSpan = i.sourceSpan), l && this.getTagDefinition(l).isVoid) this._errors.push(n.create(l, i.sourceSpan, 'Void elements do not have end tags "'.concat(i.parts[1], '"')));
              else if (!this._popElement(l)) {
                let h = 'Unexpected closing tag "'.concat(l, '". It may happen when the tag has already been closed by another tag. For more info see https://www.w3.org/TR/html5/syntax.html#closing-elements-that-have-implied-end-tags');
                this._errors.push(n.create(l, i.sourceSpan, h));
              }
            }
            _popElement(i) {
              for (let l = this._elementStack.length - 1; l >= 0; l--) {
                let h = this._elementStack[l];
                if (!i || (c.getNsPrefix(h.name) ? h.name == i : h.name.toLowerCase() == i.toLowerCase())) return this._elementStack.splice(l, this._elementStack.length - l), true;
                if (!this.getTagDefinition(h.name).closedByParent) return false;
              }
              return false;
            }
            _consumeAttr(i) {
              let l = c.mergeNsAndName(i.parts[0], i.parts[1]), h = i.sourceSpan.end, C = "", d, m;
              if (this._peek.type === s.TokenType.ATTR_QUOTE && (m = this._advance().sourceSpan.start), this._peek.type === s.TokenType.ATTR_VALUE) {
                let T = this._advance();
                C = T.parts[0], h = T.sourceSpan.end, d = T.sourceSpan;
              }
              return this._peek.type === s.TokenType.ATTR_QUOTE && (h = this._advance().sourceSpan.end, d = new r.ParseSourceSpan(m, h)), new t.Attribute(l, C, new r.ParseSourceSpan(i.sourceSpan.start, h), d, i.sourceSpan);
            }
            _getParentElement() {
              return this._elementStack.length > 0 ? this._elementStack[this._elementStack.length - 1] : null;
            }
            _getParentElementSkippingContainers() {
              let i = null;
              for (let l = this._elementStack.length - 1; l >= 0; l--) {
                if (!c.isNgContainer(this._elementStack[l].name)) return { parent: this._elementStack[l], container: i };
                i = this._elementStack[l];
              }
              return { parent: null, container: i };
            }
            _addToParent(i) {
              let l = this._getParentElement();
              l != null ? l.children.push(i) : this._rootNodes.push(i);
            }
            _insertBeforeContainer(i, l, h) {
              if (!l) this._addToParent(h), this._elementStack.push(h);
              else {
                if (i) {
                  let C = i.children.indexOf(l);
                  i.children[C] = h;
                } else this._rootNodes.push(h);
                h.children.push(l), this._elementStack.splice(this._elementStack.indexOf(l), 0, h);
              }
            }
            _getElementFullName(i, l, h) {
              return i === "" && (i = this.getTagDefinition(l).implicitNamespacePrefix || "", i === "" && h != null && (i = c.getNsPrefix(h.name))), c.mergeNsAndName(i, l);
            }
          };
          function g(i, l) {
            return i.length > 0 && i[i.length - 1] === l;
          }
        } }), WD = I({ "node_modules/angular-html-parser/lib/compiler/src/ml_parser/html_parser.js"(e) {
          "use strict";
          q(), Object.defineProperty(e, "__esModule", { value: true });
          var r = _s(), t = as(), s = as();
          e.ParseTreeResult = s.ParseTreeResult, e.TreeError = s.TreeError;
          var c = class extends t.Parser {
            constructor() {
              super(r.getHtmlTagDefinition);
            }
            parse(n, a, p) {
              let D = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, g = arguments.length > 4 ? arguments[4] : void 0;
              return super.parse(n, a, p, D, g);
            }
          };
          e.HtmlParser = c;
        } }), ys = I({ "node_modules/angular-html-parser/lib/angular-html-parser/src/index.js"(e) {
          "use strict";
          q(), Object.defineProperty(e, "__esModule", { value: true });
          var r = WD(), t = Ze();
          e.TagContentType = t.TagContentType;
          var s = null, c = () => (s || (s = new r.HtmlParser()), s);
          function n(a) {
            let p = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, { canSelfClose: D = false, allowHtmComponentClosingTags: g = false, isTagNameCaseSensitive: i = false, getTagContentType: l } = p;
            return c().parse(a, "angular-html-parser", { tokenizeExpansionForms: false, interpolationConfig: void 0, canSelfClose: D, allowHtmComponentClosingTags: g }, i, l);
          }
          e.parse = n;
        } });
        q();
        var { ParseSourceSpan: Qe, ParseLocation: is, ParseSourceFile: YD } = Te(), QD = aD(), KD = ps(), JD = iD(), { inferParserByLanguage: ZD } = ID(), el = xD(), jr = LD(), os = MD(), { hasPragma: rl } = jD(), { Node: tl } = $D(), { parseIeConditionalComment: ul } = UD(), { locStart: nl, locEnd: sl } = GD();
        function al(e, r, t) {
          let { recognizeSelfClosing: s, normalizeTagName: c, normalizeAttributeName: n, allowHtmComponentClosingTags: a, isTagNameCaseSensitive: p, getTagContentType: D } = r, g = ys(), { RecursiveVisitor: i, visitAll: l } = Ss(), { ParseSourceSpan: h } = Te(), { getHtmlTagDefinition: C } = _s(), { rootNodes: d, errors: m } = g.parse(e, { canSelfClose: s, allowHtmComponentClosingTags: a, isTagNameCaseSensitive: p, getTagContentType: D });
          if (t.parser === "vue") if (d.some((O) => O.type === "docType" && O.value === "html" || O.type === "element" && O.name.toLowerCase() === "html")) {
            s = true, c = true, n = true, a = true, p = false;
            let O = g.parse(e, { canSelfClose: s, allowHtmComponentClosingTags: a, isTagNameCaseSensitive: p });
            d = O.rootNodes, m = O.errors;
          } else {
            let O = (x) => {
              if (!x || x.type !== "element" || x.name !== "template") return false;
              let k = x.attrs.find((u) => u.name === "lang"), M = k && k.value;
              return !M || ZD(M, t) === "html";
            };
            if (d.some(O)) {
              let x, k = () => g.parse(e, { canSelfClose: s, allowHtmComponentClosingTags: a, isTagNameCaseSensitive: p }), M = () => x || (x = k()), u = (o) => M().rootNodes.find((E) => {
                let { startSourceSpan: f } = E;
                return f && f.start.offset === o.startSourceSpan.start.offset;
              });
              for (let o = 0; o < d.length; o++) {
                let E = d[o], { endSourceSpan: f, startSourceSpan: F } = E;
                if (f === null) m = M().errors, d[o] = u(E) || E;
                else if (O(E)) {
                  let j = M(), W = F.end.offset, X = f.start.offset;
                  for (let H of j.errors) {
                    let { offset: z2 } = H.span.start;
                    if (W < z2 && z2 < X) {
                      m = [H];
                      break;
                    }
                  }
                  d[o] = u(E) || E;
                }
              }
            }
          }
          if (m.length > 0) {
            let { msg: _, span: { start: O, end: x } } = m[0];
            throw JD(_, { start: { line: O.line + 1, column: O.col + 1 }, end: { line: x.line + 1, column: x.col + 1 } });
          }
          let T = (_) => {
            let O = _.name.startsWith(":") ? _.name.slice(1).split(":")[0] : null, x = _.nameSpan.toString(), k = O !== null && x.startsWith("".concat(O, ":")), M = k ? x.slice(O.length + 1) : x;
            _.name = M, _.namespace = O, _.hasExplicitNamespace = k;
          }, B = (_) => {
            switch (_.type) {
              case "element":
                T(_);
                for (let O of _.attrs) T(O), O.valueSpan ? (O.value = O.valueSpan.toString(), /["']/.test(O.value[0]) && (O.value = O.value.slice(1, -1))) : O.value = null;
                break;
              case "comment":
                _.value = _.sourceSpan.toString().slice(4, -3);
                break;
              case "text":
                _.value = _.sourceSpan.toString();
                break;
            }
          }, A = (_, O) => {
            let x = _.toLowerCase();
            return O(x) ? x : _;
          }, N = (_) => {
            if (_.type === "element" && (c && (!_.namespace || _.namespace === _.tagDefinition.implicitNamespacePrefix || os(_)) && (_.name = A(_.name, (O) => O in el)), n)) {
              let O = jr[_.name] || /* @__PURE__ */ Object.create(null);
              for (let x of _.attrs) x.namespace || (x.name = A(x.name, (k) => _.name in jr && (k in jr["*"] || k in O)));
            }
          }, R = (_) => {
            _.sourceSpan && _.endSourceSpan && (_.sourceSpan = new h(_.sourceSpan.start, _.endSourceSpan.end));
          }, $ = (_) => {
            if (_.type === "element") {
              let O = C(p ? _.name : _.name.toLowerCase());
              !_.namespace || _.namespace === O.implicitNamespacePrefix || os(_) ? _.tagDefinition = O : _.tagDefinition = C("");
            }
          };
          return l(new class extends i {
            visit(_) {
              B(_), $(_), N(_), R(_);
            }
          }(), d), d;
        }
        function Ts(e, r, t) {
          let s = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true, { frontMatter: c, content: n } = s ? QD(e) : { frontMatter: null, content: e }, a = new YD(e, r.filepath), p = new is(a, 0, 0, 0), D = p.moveBy(e.length), g = { type: "root", sourceSpan: new Qe(p, D), children: al(n, t, r) };
          if (c) {
            let h = new is(a, 0, 0, 0), C = h.moveBy(c.raw.length);
            c.sourceSpan = new Qe(h, C), g.children.unshift(c);
          }
          let i = new tl(g), l = (h, C) => {
            let { offset: d } = C, m = e.slice(0, d).replace(/[^\n\r]/g, " "), B = Ts(m + h, r, t, false);
            B.sourceSpan = new Qe(C, KD(B.children).sourceSpan.end);
            let A = B.children[0];
            return A.length === d ? B.children.shift() : (A.sourceSpan = new Qe(A.sourceSpan.start.moveBy(d), A.sourceSpan.end), A.value = A.value.slice(d)), B;
          };
          return i.walk((h) => {
            if (h.type === "comment") {
              let C = ul(h, l);
              C && h.parent.replaceChild(h, C);
            }
          }), i;
        }
        function Ke() {
          let { name: e, recognizeSelfClosing: r = false, normalizeTagName: t = false, normalizeAttributeName: s = false, allowHtmComponentClosingTags: c = false, isTagNameCaseSensitive: n = false, getTagContentType: a } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
          return { parse: (p, D, g) => Ts(p, Object.assign({ parser: e }, g), { recognizeSelfClosing: r, normalizeTagName: t, normalizeAttributeName: s, allowHtmComponentClosingTags: c, isTagNameCaseSensitive: n, getTagContentType: a }), hasPragma: rl, astFormat: "html", locStart: nl, locEnd: sl };
        }
        Bs.exports = { parsers: { html: Ke({ name: "html", recognizeSelfClosing: true, normalizeTagName: true, normalizeAttributeName: true, allowHtmComponentClosingTags: true }), angular: Ke({ name: "angular" }), vue: Ke({ name: "vue", recognizeSelfClosing: true, isTagNameCaseSensitive: true, getTagContentType: (e, r, t, s) => {
          if (e.toLowerCase() !== "html" && !t && (e !== "template" || s.some((c) => {
            let { name: n, value: a } = c;
            return n === "lang" && a !== "html" && a !== "" && a !== void 0;
          }))) return ys().TagContentType.RAW_TEXT;
        } }), lwc: Ke({ name: "lwc" }) } };
      });
      return il();
    });
  }
});

// ../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-yaml.js
var require_parser_yaml = __commonJS({
  "../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/parser-yaml.js"(exports2, module2) {
    "use strict";
    (function(e) {
      if (typeof exports2 == "object" && typeof module2 == "object") module2.exports = e();
      else if (typeof define == "function" && define.amd) define(e);
      else {
        var i = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i.prettierPlugins = i.prettierPlugins || {}, i.prettierPlugins.yaml = e();
      }
    })(function() {
      "use strict";
      var wt = (r, e) => () => (e || r((e = { exports: {} }).exports, e), e.exports);
      var ur = wt((mr, lt) => {
        var De = Object.defineProperty, St = Object.getOwnPropertyDescriptor, Fe = Object.getOwnPropertyNames, Et = Object.prototype.hasOwnProperty, xe = (r, e) => function() {
          return r && (e = (0, r[Fe(r)[0]])(r = 0)), e;
        }, F = (r, e) => function() {
          return e || (0, r[Fe(r)[0]])((e = { exports: {} }).exports, e), e.exports;
        }, Mt = (r, e) => {
          for (var n in e) De(r, n, { get: e[n], enumerable: true });
        }, Ot = (r, e, n, c) => {
          if (e && typeof e == "object" || typeof e == "function") for (let h of Fe(e)) !Et.call(r, h) && h !== n && De(r, h, { get: () => e[h], enumerable: !(c = St(e, h)) || c.enumerable });
          return r;
        }, se = (r) => Ot(De({}, "__esModule", { value: true }), r), Ke, $e, Te, D = xe({ "<define:process>"() {
          Ke = {}, $e = [], Te = { env: Ke, argv: $e };
        } }), Lt = F({ "src/common/parser-create-error.js"(r, e) {
          "use strict";
          D();
          function n(c, h) {
            let d = new SyntaxError(c + " (" + h.start.line + ":" + h.start.column + ")");
            return d.loc = h, d;
          }
          e.exports = n;
        } }), At = F({ "src/language-yaml/pragma.js"(r, e) {
          "use strict";
          D();
          function n(d) {
            return /^\s*@(?:prettier|format)\s*$/.test(d);
          }
          function c(d) {
            return /^\s*#[^\S\n]*@(?:prettier|format)\s*?(?:\n|$)/.test(d);
          }
          function h(d) {
            return `# @format

`.concat(d);
          }
          e.exports = { isPragma: n, hasPragma: c, insertPragma: h };
        } }), Nt = F({ "src/language-yaml/loc.js"(r, e) {
          "use strict";
          D();
          function n(h) {
            return h.position.start.offset;
          }
          function c(h) {
            return h.position.end.offset;
          }
          e.exports = { locStart: n, locEnd: c };
        } }), te = {};
        Mt(te, { __assign: () => qe, __asyncDelegator: () => Wt, __asyncGenerator: () => Ft, __asyncValues: () => Vt, __await: () => Ce, __awaiter: () => Rt, __classPrivateFieldGet: () => $t, __classPrivateFieldSet: () => Jt, __createBinding: () => Bt, __decorate: () => kt, __exportStar: () => jt, __extends: () => Tt, __generator: () => qt, __importDefault: () => Kt, __importStar: () => Ut, __makeTemplateObject: () => Qt, __metadata: () => It, __param: () => Pt, __read: () => He, __rest: () => Ct, __spread: () => Yt, __spreadArrays: () => Dt, __values: () => Ye });
        function Tt(r, e) {
          Re(r, e);
          function n() {
            this.constructor = r;
          }
          r.prototype = e === null ? Object.create(e) : (n.prototype = e.prototype, new n());
        }
        function Ct(r, e) {
          var n = {};
          for (var c in r) Object.prototype.hasOwnProperty.call(r, c) && e.indexOf(c) < 0 && (n[c] = r[c]);
          if (r != null && typeof Object.getOwnPropertySymbols == "function") for (var h = 0, c = Object.getOwnPropertySymbols(r); h < c.length; h++) e.indexOf(c[h]) < 0 && Object.prototype.propertyIsEnumerable.call(r, c[h]) && (n[c[h]] = r[c[h]]);
          return n;
        }
        function kt(r, e, n, c) {
          var h = arguments.length, d = h < 3 ? e : c === null ? c = Object.getOwnPropertyDescriptor(e, n) : c, y;
          if (typeof Reflect == "object" && typeof Reflect.decorate == "function") d = Reflect.decorate(r, e, n, c);
          else for (var E = r.length - 1; E >= 0; E--) (y = r[E]) && (d = (h < 3 ? y(d) : h > 3 ? y(e, n, d) : y(e, n)) || d);
          return h > 3 && d && Object.defineProperty(e, n, d), d;
        }
        function Pt(r, e) {
          return function(n, c) {
            e(n, c, r);
          };
        }
        function It(r, e) {
          if (typeof Reflect == "object" && typeof Reflect.metadata == "function") return Reflect.metadata(r, e);
        }
        function Rt(r, e, n, c) {
          function h(d) {
            return d instanceof n ? d : new n(function(y) {
              y(d);
            });
          }
          return new (n || (n = Promise))(function(d, y) {
            function E(M) {
              try {
                S(c.next(M));
              } catch (T) {
                y(T);
              }
            }
            function I(M) {
              try {
                S(c.throw(M));
              } catch (T) {
                y(T);
              }
            }
            function S(M) {
              M.done ? d(M.value) : h(M.value).then(E, I);
            }
            S((c = c.apply(r, e || [])).next());
          });
        }
        function qt(r, e) {
          var n = { label: 0, sent: function() {
            if (d[0] & 1) throw d[1];
            return d[1];
          }, trys: [], ops: [] }, c, h, d, y;
          return y = { next: E(0), throw: E(1), return: E(2) }, typeof Symbol == "function" && (y[Symbol.iterator] = function() {
            return this;
          }), y;
          function E(S) {
            return function(M) {
              return I([S, M]);
            };
          }
          function I(S) {
            if (c) throw new TypeError("Generator is already executing.");
            for (; n; ) try {
              if (c = 1, h && (d = S[0] & 2 ? h.return : S[0] ? h.throw || ((d = h.return) && d.call(h), 0) : h.next) && !(d = d.call(h, S[1])).done) return d;
              switch (h = 0, d && (S = [S[0] & 2, d.value]), S[0]) {
                case 0:
                case 1:
                  d = S;
                  break;
                case 4:
                  return n.label++, { value: S[1], done: false };
                case 5:
                  n.label++, h = S[1], S = [0];
                  continue;
                case 7:
                  S = n.ops.pop(), n.trys.pop();
                  continue;
                default:
                  if (d = n.trys, !(d = d.length > 0 && d[d.length - 1]) && (S[0] === 6 || S[0] === 2)) {
                    n = 0;
                    continue;
                  }
                  if (S[0] === 3 && (!d || S[1] > d[0] && S[1] < d[3])) {
                    n.label = S[1];
                    break;
                  }
                  if (S[0] === 6 && n.label < d[1]) {
                    n.label = d[1], d = S;
                    break;
                  }
                  if (d && n.label < d[2]) {
                    n.label = d[2], n.ops.push(S);
                    break;
                  }
                  d[2] && n.ops.pop(), n.trys.pop();
                  continue;
              }
              S = e.call(r, n);
            } catch (M) {
              S = [6, M], h = 0;
            } finally {
              c = d = 0;
            }
            if (S[0] & 5) throw S[1];
            return { value: S[0] ? S[1] : void 0, done: true };
          }
        }
        function Bt(r, e, n, c) {
          c === void 0 && (c = n), r[c] = e[n];
        }
        function jt(r, e) {
          for (var n in r) n !== "default" && !e.hasOwnProperty(n) && (e[n] = r[n]);
        }
        function Ye(r) {
          var e = typeof Symbol == "function" && Symbol.iterator, n = e && r[e], c = 0;
          if (n) return n.call(r);
          if (r && typeof r.length == "number") return { next: function() {
            return r && c >= r.length && (r = void 0), { value: r && r[c++], done: !r };
          } };
          throw new TypeError(e ? "Object is not iterable." : "Symbol.iterator is not defined.");
        }
        function He(r, e) {
          var n = typeof Symbol == "function" && r[Symbol.iterator];
          if (!n) return r;
          var c = n.call(r), h, d = [], y;
          try {
            for (; (e === void 0 || e-- > 0) && !(h = c.next()).done; ) d.push(h.value);
          } catch (E) {
            y = { error: E };
          } finally {
            try {
              h && !h.done && (n = c.return) && n.call(c);
            } finally {
              if (y) throw y.error;
            }
          }
          return d;
        }
        function Yt() {
          for (var r = [], e = 0; e < arguments.length; e++) r = r.concat(He(arguments[e]));
          return r;
        }
        function Dt() {
          for (var r = 0, e = 0, n = arguments.length; e < n; e++) r += arguments[e].length;
          for (var c = Array(r), h = 0, e = 0; e < n; e++) for (var d = arguments[e], y = 0, E = d.length; y < E; y++, h++) c[h] = d[y];
          return c;
        }
        function Ce(r) {
          return this instanceof Ce ? (this.v = r, this) : new Ce(r);
        }
        function Ft(r, e, n) {
          if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
          var c = n.apply(r, e || []), h, d = [];
          return h = {}, y("next"), y("throw"), y("return"), h[Symbol.asyncIterator] = function() {
            return this;
          }, h;
          function y(P) {
            c[P] && (h[P] = function(C) {
              return new Promise(function(q, R) {
                d.push([P, C, q, R]) > 1 || E(P, C);
              });
            });
          }
          function E(P, C) {
            try {
              I(c[P](C));
            } catch (q) {
              T(d[0][3], q);
            }
          }
          function I(P) {
            P.value instanceof Ce ? Promise.resolve(P.value.v).then(S, M) : T(d[0][2], P);
          }
          function S(P) {
            E("next", P);
          }
          function M(P) {
            E("throw", P);
          }
          function T(P, C) {
            P(C), d.shift(), d.length && E(d[0][0], d[0][1]);
          }
        }
        function Wt(r) {
          var e, n;
          return e = {}, c("next"), c("throw", function(h) {
            throw h;
          }), c("return"), e[Symbol.iterator] = function() {
            return this;
          }, e;
          function c(h, d) {
            e[h] = r[h] ? function(y) {
              return (n = !n) ? { value: Ce(r[h](y)), done: h === "return" } : d ? d(y) : y;
            } : d;
          }
        }
        function Vt(r) {
          if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
          var e = r[Symbol.asyncIterator], n;
          return e ? e.call(r) : (r = typeof Ye == "function" ? Ye(r) : r[Symbol.iterator](), n = {}, c("next"), c("throw"), c("return"), n[Symbol.asyncIterator] = function() {
            return this;
          }, n);
          function c(d) {
            n[d] = r[d] && function(y) {
              return new Promise(function(E, I) {
                y = r[d](y), h(E, I, y.done, y.value);
              });
            };
          }
          function h(d, y, E, I) {
            Promise.resolve(I).then(function(S) {
              d({ value: S, done: E });
            }, y);
          }
        }
        function Qt(r, e) {
          return Object.defineProperty ? Object.defineProperty(r, "raw", { value: e }) : r.raw = e, r;
        }
        function Ut(r) {
          if (r && r.__esModule) return r;
          var e = {};
          if (r != null) for (var n in r) Object.hasOwnProperty.call(r, n) && (e[n] = r[n]);
          return e.default = r, e;
        }
        function Kt(r) {
          return r && r.__esModule ? r : { default: r };
        }
        function $t(r, e) {
          if (!e.has(r)) throw new TypeError("attempted to get private field on non-instance");
          return e.get(r);
        }
        function Jt(r, e, n) {
          if (!e.has(r)) throw new TypeError("attempted to set private field on non-instance");
          return e.set(r, n), n;
        }
        var Re, qe, ae = xe({ "node_modules/tslib/tslib.es6.js"() {
          D(), Re = function(r, e) {
            return Re = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(n, c) {
              n.__proto__ = c;
            } || function(n, c) {
              for (var h in c) c.hasOwnProperty(h) && (n[h] = c[h]);
            }, Re(r, e);
          }, qe = function() {
            return qe = Object.assign || function(e) {
              for (var n, c = 1, h = arguments.length; c < h; c++) {
                n = arguments[c];
                for (var d in n) Object.prototype.hasOwnProperty.call(n, d) && (e[d] = n[d]);
              }
              return e;
            }, qe.apply(this, arguments);
          };
        } }), xt = F({ "node_modules/yaml-unist-parser/node_modules/lines-and-columns/build/index.js"(r) {
          "use strict";
          D(), r.__esModule = true, r.LinesAndColumns = void 0;
          var e = `
`, n = "\r", c = function() {
            function h(d) {
              this.string = d;
              for (var y = [0], E = 0; E < d.length; ) switch (d[E]) {
                case e:
                  E += e.length, y.push(E);
                  break;
                case n:
                  E += n.length, d[E] === e && (E += e.length), y.push(E);
                  break;
                default:
                  E++;
                  break;
              }
              this.offsets = y;
            }
            return h.prototype.locationForIndex = function(d) {
              if (d < 0 || d > this.string.length) return null;
              for (var y = 0, E = this.offsets; E[y + 1] <= d; ) y++;
              var I = d - E[y];
              return { line: y, column: I };
            }, h.prototype.indexForLocation = function(d) {
              var y = d.line, E = d.column;
              return y < 0 || y >= this.offsets.length || E < 0 || E > this.lengthOfLine(y) ? null : this.offsets[y] + E;
            }, h.prototype.lengthOfLine = function(d) {
              var y = this.offsets[d], E = d === this.offsets.length - 1 ? this.string.length : this.offsets[d + 1];
              return E - y;
            }, h;
          }();
          r.LinesAndColumns = c, r.default = c;
        } }), Ht = F({ "node_modules/yaml-unist-parser/lib/utils/define-parents.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(n, c) {
            c === void 0 && (c = null), "children" in n && n.children.forEach(function(h) {
              return e(h, n);
            }), "anchor" in n && n.anchor && e(n.anchor, n), "tag" in n && n.tag && e(n.tag, n), "leadingComments" in n && n.leadingComments.forEach(function(h) {
              return e(h, n);
            }), "middleComments" in n && n.middleComments.forEach(function(h) {
              return e(h, n);
            }), "indicatorComment" in n && n.indicatorComment && e(n.indicatorComment, n), "trailingComment" in n && n.trailingComment && e(n.trailingComment, n), "endComments" in n && n.endComments.forEach(function(h) {
              return e(h, n);
            }), Object.defineProperty(n, "_parent", { value: c, enumerable: false });
          }
          r.defineParents = e;
        } }), We = F({ "node_modules/yaml-unist-parser/lib/utils/get-point-text.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(n) {
            return n.line + ":" + n.column;
          }
          r.getPointText = e;
        } }), Gt = F({ "node_modules/yaml-unist-parser/lib/attach.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = Ht(), n = We();
          function c(S) {
            e.defineParents(S);
            var M = h(S), T = S.children.slice();
            S.comments.sort(function(P, C) {
              return P.position.start.offset - C.position.end.offset;
            }).filter(function(P) {
              return !P._parent;
            }).forEach(function(P) {
              for (; T.length > 1 && P.position.start.line > T[0].position.end.line; ) T.shift();
              y(P, M, T[0]);
            });
          }
          r.attachComments = c;
          function h(S) {
            for (var M = Array.from(new Array(S.position.end.line), function() {
              return {};
            }), T = 0, P = S.comments; T < P.length; T++) {
              var C = P[T];
              M[C.position.start.line - 1].comment = C;
            }
            return d(M, S), M;
          }
          function d(S, M) {
            if (M.position.start.offset !== M.position.end.offset) {
              if ("leadingComments" in M) {
                var T = M.position.start, P = S[T.line - 1].leadingAttachableNode;
                (!P || T.column < P.position.start.column) && (S[T.line - 1].leadingAttachableNode = M);
              }
              if ("trailingComment" in M && M.position.end.column > 1 && M.type !== "document" && M.type !== "documentHead") {
                var C = M.position.end, q = S[C.line - 1].trailingAttachableNode;
                (!q || C.column >= q.position.end.column) && (S[C.line - 1].trailingAttachableNode = M);
              }
              if (M.type !== "root" && M.type !== "document" && M.type !== "documentHead" && M.type !== "documentBody") for (var R = M.position, T = R.start, C = R.end, j = [C.line].concat(T.line === C.line ? [] : T.line), K = 0, m = j; K < m.length; K++) {
                var a = m[K], t = S[a - 1].trailingNode;
                (!t || C.column >= t.position.end.column) && (S[a - 1].trailingNode = M);
              }
              "children" in M && M.children.forEach(function(s) {
                d(S, s);
              });
            }
          }
          function y(S, M, T) {
            var P = S.position.start.line, C = M[P - 1].trailingAttachableNode;
            if (C) {
              if (C.trailingComment) throw new Error("Unexpected multiple trailing comment at " + n.getPointText(S.position.start));
              e.defineParents(S, C), C.trailingComment = S;
              return;
            }
            for (var q = P; q >= T.position.start.line; q--) {
              var R = M[q - 1].trailingNode, j = void 0;
              if (R) j = R;
              else if (q !== P && M[q - 1].comment) j = M[q - 1].comment._parent;
              else continue;
              if ((j.type === "sequence" || j.type === "mapping") && (j = j.children[0]), j.type === "mappingItem") {
                var K = j.children, m = K[0], a = K[1];
                j = I(m) ? m : a;
              }
              for (; ; ) {
                if (E(j, S)) {
                  e.defineParents(S, j), j.endComments.push(S);
                  return;
                }
                if (!j._parent) break;
                j = j._parent;
              }
              break;
            }
            for (var q = P + 1; q <= T.position.end.line; q++) {
              var t = M[q - 1].leadingAttachableNode;
              if (t) {
                e.defineParents(S, t), t.leadingComments.push(S);
                return;
              }
            }
            var s = T.children[1];
            e.defineParents(S, s), s.endComments.push(S);
          }
          function E(S, M) {
            if (S.position.start.offset < M.position.start.offset && S.position.end.offset > M.position.end.offset) switch (S.type) {
              case "flowMapping":
              case "flowSequence":
                return S.children.length === 0 || M.position.start.line > S.children[S.children.length - 1].position.end.line;
            }
            if (M.position.end.offset < S.position.end.offset) return false;
            switch (S.type) {
              case "sequenceItem":
                return M.position.start.column > S.position.start.column;
              case "mappingKey":
              case "mappingValue":
                return M.position.start.column > S._parent.position.start.column && (S.children.length === 0 || S.children.length === 1 && S.children[0].type !== "blockFolded" && S.children[0].type !== "blockLiteral") && (S.type === "mappingValue" || I(S));
              default:
                return false;
            }
          }
          function I(S) {
            return S.position.start !== S.position.end && (S.children.length === 0 || S.position.start.offset !== S.children[0].position.start.offset);
          }
        } }), me = F({ "node_modules/yaml-unist-parser/lib/factories/node.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(n, c) {
            return { type: n, position: c };
          }
          r.createNode = e;
        } }), zt = F({ "node_modules/yaml-unist-parser/lib/factories/root.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = me();
          function c(h, d, y) {
            return e.__assign(e.__assign({}, n.createNode("root", h)), { children: d, comments: y });
          }
          r.createRoot = c;
        } }), Zt = F({ "node_modules/yaml-unist-parser/lib/preprocess.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(n) {
            switch (n.type) {
              case "DOCUMENT":
                for (var c = n.contents.length - 1; c >= 0; c--) n.contents[c].type === "BLANK_LINE" ? n.contents.splice(c, 1) : e(n.contents[c]);
                for (var c = n.directives.length - 1; c >= 0; c--) n.directives[c].type === "BLANK_LINE" && n.directives.splice(c, 1);
                break;
              case "FLOW_MAP":
              case "FLOW_SEQ":
              case "MAP":
              case "SEQ":
                for (var c = n.items.length - 1; c >= 0; c--) {
                  var h = n.items[c];
                  "char" in h || (h.type === "BLANK_LINE" ? n.items.splice(c, 1) : e(h));
                }
                break;
              case "MAP_KEY":
              case "MAP_VALUE":
              case "SEQ_ITEM":
                n.node && e(n.node);
                break;
              case "ALIAS":
              case "BLANK_LINE":
              case "BLOCK_FOLDED":
              case "BLOCK_LITERAL":
              case "COMMENT":
              case "DIRECTIVE":
              case "PLAIN":
              case "QUOTE_DOUBLE":
              case "QUOTE_SINGLE":
                break;
              default:
                throw new Error("Unexpected node type " + JSON.stringify(n.type));
            }
          }
          r.removeCstBlankLine = e;
        } }), Oe = F({ "node_modules/yaml-unist-parser/lib/factories/leading-comment-attachable.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e() {
            return { leadingComments: [] };
          }
          r.createLeadingCommentAttachable = e;
        } }), Be = F({ "node_modules/yaml-unist-parser/lib/factories/trailing-comment-attachable.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(n) {
            return n === void 0 && (n = null), { trailingComment: n };
          }
          r.createTrailingCommentAttachable = e;
        } }), Se = F({ "node_modules/yaml-unist-parser/lib/factories/comment-attachable.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = Oe(), c = Be();
          function h() {
            return e.__assign(e.__assign({}, n.createLeadingCommentAttachable()), c.createTrailingCommentAttachable());
          }
          r.createCommentAttachable = h;
        } }), Xt = F({ "node_modules/yaml-unist-parser/lib/factories/alias.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = Se(), c = me();
          function h(d, y, E) {
            return e.__assign(e.__assign(e.__assign(e.__assign({}, c.createNode("alias", d)), n.createCommentAttachable()), y), { value: E });
          }
          r.createAlias = h;
        } }), en = F({ "node_modules/yaml-unist-parser/lib/transforms/alias.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = Xt();
          function n(c, h) {
            var d = c.cstNode;
            return e.createAlias(h.transformRange({ origStart: d.valueRange.origStart - 1, origEnd: d.valueRange.origEnd }), h.transformContent(c), d.rawValue);
          }
          r.transformAlias = n;
        } }), tn = F({ "node_modules/yaml-unist-parser/lib/factories/block-folded.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te));
          function n(c) {
            return e.__assign(e.__assign({}, c), { type: "blockFolded" });
          }
          r.createBlockFolded = n;
        } }), nn = F({ "node_modules/yaml-unist-parser/lib/factories/block-value.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = Oe(), c = me();
          function h(d, y, E, I, S, M) {
            return e.__assign(e.__assign(e.__assign(e.__assign({}, c.createNode("blockValue", d)), n.createLeadingCommentAttachable()), y), { chomping: E, indent: I, value: S, indicatorComment: M });
          }
          r.createBlockValue = h;
        } }), Ge = F({ "node_modules/yaml-unist-parser/lib/constants.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e;
          (function(n) {
            n.Tag = "!", n.Anchor = "&", n.Comment = "#";
          })(e = r.PropLeadingCharacter || (r.PropLeadingCharacter = {}));
        } }), rn = F({ "node_modules/yaml-unist-parser/lib/factories/anchor.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = me();
          function c(h, d) {
            return e.__assign(e.__assign({}, n.createNode("anchor", h)), { value: d });
          }
          r.createAnchor = c;
        } }), Ve = F({ "node_modules/yaml-unist-parser/lib/factories/comment.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = me();
          function c(h, d) {
            return e.__assign(e.__assign({}, n.createNode("comment", h)), { value: d });
          }
          r.createComment = c;
        } }), sn = F({ "node_modules/yaml-unist-parser/lib/factories/content.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(n, c, h) {
            return { anchor: c, tag: n, middleComments: h };
          }
          r.createContent = e;
        } }), an = F({ "node_modules/yaml-unist-parser/lib/factories/tag.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = me();
          function c(h, d) {
            return e.__assign(e.__assign({}, n.createNode("tag", h)), { value: d });
          }
          r.createTag = c;
        } }), ze = F({ "node_modules/yaml-unist-parser/lib/transforms/content.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = Ge(), n = rn(), c = Ve(), h = sn(), d = an();
          function y(E, I, S) {
            S === void 0 && (S = function() {
              return false;
            });
            for (var M = E.cstNode, T = [], P = null, C = null, q = null, R = 0, j = M.props; R < j.length; R++) {
              var K = j[R], m = I.text[K.origStart];
              switch (m) {
                case e.PropLeadingCharacter.Tag:
                  P = P || K, C = d.createTag(I.transformRange(K), E.tag);
                  break;
                case e.PropLeadingCharacter.Anchor:
                  P = P || K, q = n.createAnchor(I.transformRange(K), M.anchor);
                  break;
                case e.PropLeadingCharacter.Comment: {
                  var a = c.createComment(I.transformRange(K), I.text.slice(K.origStart + 1, K.origEnd));
                  I.comments.push(a), !S(a) && P && P.origEnd <= K.origStart && K.origEnd <= M.valueRange.origStart && T.push(a);
                  break;
                }
                default:
                  throw new Error("Unexpected leading character " + JSON.stringify(m));
              }
            }
            return h.createContent(C, q, T);
          }
          r.transformContent = y;
        } }), Ze = F({ "node_modules/yaml-unist-parser/lib/transforms/block-value.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = nn(), n = We(), c = ze(), h;
          (function(y) {
            y.CLIP = "clip", y.STRIP = "strip", y.KEEP = "keep";
          })(h || (h = {}));
          function d(y, E) {
            var I = y.cstNode, S = 1, M = I.chomping === "CLIP" ? 0 : 1, T = I.header.origEnd - I.header.origStart, P = T - S - M !== 0, C = E.transformRange({ origStart: I.header.origStart, origEnd: I.valueRange.origEnd }), q = null, R = c.transformContent(y, E, function(j) {
              var K = C.start.offset < j.position.start.offset && j.position.end.offset < C.end.offset;
              if (!K) return false;
              if (q) throw new Error("Unexpected multiple indicator comments at " + n.getPointText(j.position.start));
              return q = j, true;
            });
            return e.createBlockValue(C, R, h[I.chomping], P ? I.blockIndent : null, I.strValue, q);
          }
          r.transformAstBlockValue = d;
        } }), on = F({ "node_modules/yaml-unist-parser/lib/transforms/block-folded.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = tn(), n = Ze();
          function c(h, d) {
            return e.createBlockFolded(n.transformAstBlockValue(h, d));
          }
          r.transformBlockFolded = c;
        } }), ln = F({ "node_modules/yaml-unist-parser/lib/factories/block-literal.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te));
          function n(c) {
            return e.__assign(e.__assign({}, c), { type: "blockLiteral" });
          }
          r.createBlockLiteral = n;
        } }), cn = F({ "node_modules/yaml-unist-parser/lib/transforms/block-literal.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = ln(), n = Ze();
          function c(h, d) {
            return e.createBlockLiteral(n.transformAstBlockValue(h, d));
          }
          r.transformBlockLiteral = c;
        } }), un = F({ "node_modules/yaml-unist-parser/lib/transforms/comment.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = Ve();
          function n(c, h) {
            return e.createComment(h.transformRange(c.range), c.comment);
          }
          r.transformComment = n;
        } }), fn = F({ "node_modules/yaml-unist-parser/lib/factories/directive.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = Se(), c = me();
          function h(d, y, E) {
            return e.__assign(e.__assign(e.__assign({}, c.createNode("directive", d)), n.createCommentAttachable()), { name: y, parameters: E });
          }
          r.createDirective = h;
        } }), Qe = F({ "node_modules/yaml-unist-parser/lib/utils/extract-prop-comments.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = Ge(), n = Ve();
          function c(h, d) {
            for (var y = 0, E = h.props; y < E.length; y++) {
              var I = E[y], S = d.text[I.origStart];
              switch (S) {
                case e.PropLeadingCharacter.Comment:
                  d.comments.push(n.createComment(d.transformRange(I), d.text.slice(I.origStart + 1, I.origEnd)));
                  break;
                default:
                  throw new Error("Unexpected leading character " + JSON.stringify(S));
              }
            }
          }
          r.extractPropComments = c;
        } }), mn = F({ "node_modules/yaml-unist-parser/lib/transforms/directive.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = fn(), n = Qe();
          function c(h, d) {
            return n.extractPropComments(h, d), e.createDirective(d.transformRange(h.range), h.name, h.parameters);
          }
          r.transformDirective = c;
        } }), dn = F({ "node_modules/yaml-unist-parser/lib/factories/document.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = me(), c = Be();
          function h(d, y, E, I) {
            return e.__assign(e.__assign(e.__assign({}, n.createNode("document", d)), c.createTrailingCommentAttachable(I)), { children: [y, E] });
          }
          r.createDocument = h;
        } }), Le = F({ "node_modules/yaml-unist-parser/lib/factories/position.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(c, h) {
            return { start: c, end: h };
          }
          r.createPosition = e;
          function n(c) {
            return { start: c, end: c };
          }
          r.createEmptyPosition = n;
        } }), Ee = F({ "node_modules/yaml-unist-parser/lib/factories/end-comment-attachable.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(n) {
            return n === void 0 && (n = []), { endComments: n };
          }
          r.createEndCommentAttachable = e;
        } }), hn = F({ "node_modules/yaml-unist-parser/lib/factories/document-body.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = Ee(), c = me();
          function h(d, y, E) {
            return e.__assign(e.__assign(e.__assign({}, c.createNode("documentBody", d)), n.createEndCommentAttachable(E)), { children: y ? [y] : [] });
          }
          r.createDocumentBody = h;
        } }), Ae = F({ "node_modules/yaml-unist-parser/lib/utils/get-last.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(n) {
            return n[n.length - 1];
          }
          r.getLast = e;
        } }), Xe = F({ "node_modules/yaml-unist-parser/lib/utils/get-match-index.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(n, c) {
            var h = n.match(c);
            return h ? h.index : -1;
          }
          r.getMatchIndex = e;
        } }), gn = F({ "node_modules/yaml-unist-parser/lib/transforms/document-body.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = hn(), c = Ae(), h = Xe(), d = We();
          function y(S, M, T) {
            var P, C = S.cstNode, q = E(C, M, T), R = q.comments, j = q.endComments, K = q.documentTrailingComment, m = q.documentHeadTrailingComment, a = M.transformNode(S.contents), t = I(C, a, M), s = t.position, i = t.documentEndPoint;
            return (P = M.comments).push.apply(P, e.__spreadArrays(R, j)), { documentBody: n.createDocumentBody(s, a, j), documentEndPoint: i, documentTrailingComment: K, documentHeadTrailingComment: m };
          }
          r.transformDocumentBody = y;
          function E(S, M, T) {
            for (var P = [], C = [], q = [], R = [], j = false, K = S.contents.length - 1; K >= 0; K--) {
              var m = S.contents[K];
              if (m.type === "COMMENT") {
                var a = M.transformNode(m);
                T && T.line === a.position.start.line ? R.unshift(a) : j ? P.unshift(a) : a.position.start.offset >= S.valueRange.origEnd ? q.unshift(a) : P.unshift(a);
              } else j = true;
            }
            if (q.length > 1) throw new Error("Unexpected multiple document trailing comments at " + d.getPointText(q[1].position.start));
            if (R.length > 1) throw new Error("Unexpected multiple documentHead trailing comments at " + d.getPointText(R[1].position.start));
            return { comments: P, endComments: C, documentTrailingComment: c.getLast(q) || null, documentHeadTrailingComment: c.getLast(R) || null };
          }
          function I(S, M, T) {
            var P = h.getMatchIndex(T.text.slice(S.valueRange.origEnd), /^\.\.\./), C = P === -1 ? S.valueRange.origEnd : Math.max(0, S.valueRange.origEnd - 1);
            T.text[C - 1] === "\r" && C--;
            var q = T.transformRange({ origStart: M !== null ? M.position.start.offset : C, origEnd: C }), R = P === -1 ? q.end : T.transformOffset(S.valueRange.origEnd + 3);
            return { position: q, documentEndPoint: R };
          }
        } }), pn = F({ "node_modules/yaml-unist-parser/lib/factories/document-head.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = Ee(), c = me(), h = Be();
          function d(y, E, I, S) {
            return e.__assign(e.__assign(e.__assign(e.__assign({}, c.createNode("documentHead", y)), n.createEndCommentAttachable(I)), h.createTrailingCommentAttachable(S)), { children: E });
          }
          r.createDocumentHead = d;
        } }), _n = F({ "node_modules/yaml-unist-parser/lib/transforms/document-head.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = pn(), c = Xe();
          function h(E, I) {
            var S, M = E.cstNode, T = d(M, I), P = T.directives, C = T.comments, q = T.endComments, R = y(M, P, I), j = R.position, K = R.endMarkerPoint;
            (S = I.comments).push.apply(S, e.__spreadArrays(C, q));
            var m = function(a) {
              return a && I.comments.push(a), n.createDocumentHead(j, P, q, a);
            };
            return { createDocumentHeadWithTrailingComment: m, documentHeadEndMarkerPoint: K };
          }
          r.transformDocumentHead = h;
          function d(E, I) {
            for (var S = [], M = [], T = [], P = false, C = E.directives.length - 1; C >= 0; C--) {
              var q = I.transformNode(E.directives[C]);
              q.type === "comment" ? P ? M.unshift(q) : T.unshift(q) : (P = true, S.unshift(q));
            }
            return { directives: S, comments: M, endComments: T };
          }
          function y(E, I, S) {
            var M = c.getMatchIndex(S.text.slice(0, E.valueRange.origStart), /---\s*$/);
            M > 0 && !/[\r\n]/.test(S.text[M - 1]) && (M = -1);
            var T = M === -1 ? { origStart: E.valueRange.origStart, origEnd: E.valueRange.origStart } : { origStart: M, origEnd: M + 3 };
            return I.length !== 0 && (T.origStart = I[0].position.start.offset), { position: S.transformRange(T), endMarkerPoint: M === -1 ? null : S.transformOffset(M) };
          }
        } }), vn = F({ "node_modules/yaml-unist-parser/lib/transforms/document.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = dn(), n = Le(), c = gn(), h = _n();
          function d(y, E) {
            var I = h.transformDocumentHead(y, E), S = I.createDocumentHeadWithTrailingComment, M = I.documentHeadEndMarkerPoint, T = c.transformDocumentBody(y, E, M), P = T.documentBody, C = T.documentEndPoint, q = T.documentTrailingComment, R = T.documentHeadTrailingComment, j = S(R);
            return q && E.comments.push(q), e.createDocument(n.createPosition(j.position.start, C), j, P, q);
          }
          r.transformDocument = d;
        } }), et = F({ "node_modules/yaml-unist-parser/lib/factories/flow-collection.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = Se(), c = Ee(), h = me();
          function d(y, E, I) {
            return e.__assign(e.__assign(e.__assign(e.__assign(e.__assign({}, h.createNode("flowCollection", y)), n.createCommentAttachable()), c.createEndCommentAttachable()), E), { children: I });
          }
          r.createFlowCollection = d;
        } }), yn = F({ "node_modules/yaml-unist-parser/lib/factories/flow-mapping.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = et();
          function c(h, d, y) {
            return e.__assign(e.__assign({}, n.createFlowCollection(h, d, y)), { type: "flowMapping" });
          }
          r.createFlowMapping = c;
        } }), tt = F({ "node_modules/yaml-unist-parser/lib/factories/flow-mapping-item.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = Oe(), c = me();
          function h(d, y, E) {
            return e.__assign(e.__assign(e.__assign({}, c.createNode("flowMappingItem", d)), n.createLeadingCommentAttachable()), { children: [y, E] });
          }
          r.createFlowMappingItem = h;
        } }), je = F({ "node_modules/yaml-unist-parser/lib/utils/extract-comments.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(n, c) {
            for (var h = [], d = 0, y = n; d < y.length; d++) {
              var E = y[d];
              E && "type" in E && E.type === "COMMENT" ? c.comments.push(c.transformNode(E)) : h.push(E);
            }
            return h;
          }
          r.extractComments = e;
        } }), nt = F({ "node_modules/yaml-unist-parser/lib/utils/get-flow-map-item-additional-ranges.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(n) {
            var c = ["?", ":"].map(function(y) {
              var E = n.find(function(I) {
                return "char" in I && I.char === y;
              });
              return E ? { origStart: E.origOffset, origEnd: E.origOffset + 1 } : null;
            }), h = c[0], d = c[1];
            return { additionalKeyRange: h, additionalValueRange: d };
          }
          r.getFlowMapItemAdditionalRanges = e;
        } }), rt = F({ "node_modules/yaml-unist-parser/lib/utils/create-slicer.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(n, c) {
            var h = c;
            return function(d) {
              return n.slice(h, h = d);
            };
          }
          r.createSlicer = e;
        } }), st = F({ "node_modules/yaml-unist-parser/lib/utils/group-cst-flow-collection-items.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = rt();
          function n(c) {
            for (var h = [], d = e.createSlicer(c, 1), y = false, E = 1; E < c.length - 1; E++) {
              var I = c[E];
              if ("char" in I && I.char === ",") {
                h.push(d(E)), d(E + 1), y = false;
                continue;
              }
              y = true;
            }
            return y && h.push(d(c.length - 1)), h;
          }
          r.groupCstFlowCollectionItems = n;
        } }), bn = F({ "node_modules/yaml-unist-parser/lib/factories/mapping-key.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = Ee(), c = me(), h = Be();
          function d(y, E) {
            return e.__assign(e.__assign(e.__assign(e.__assign({}, c.createNode("mappingKey", y)), h.createTrailingCommentAttachable()), n.createEndCommentAttachable()), { children: E ? [E] : [] });
          }
          r.createMappingKey = d;
        } }), wn = F({ "node_modules/yaml-unist-parser/lib/factories/mapping-value.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = Se(), c = Ee(), h = me();
          function d(y, E) {
            return e.__assign(e.__assign(e.__assign(e.__assign({}, h.createNode("mappingValue", y)), n.createCommentAttachable()), c.createEndCommentAttachable()), { children: E ? [E] : [] });
          }
          r.createMappingValue = d;
        } }), Ue = F({ "node_modules/yaml-unist-parser/lib/transforms/pair.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = bn(), n = wn(), c = Le();
          function h(d, y, E, I, S) {
            var M = y.transformNode(d.key), T = y.transformNode(d.value), P = M || I ? e.createMappingKey(y.transformRange({ origStart: I ? I.origStart : M.position.start.offset, origEnd: M ? M.position.end.offset : I.origStart + 1 }), M) : null, C = T || S ? n.createMappingValue(y.transformRange({ origStart: S ? S.origStart : T.position.start.offset, origEnd: T ? T.position.end.offset : S.origStart + 1 }), T) : null;
            return E(c.createPosition(P ? P.position.start : C.position.start, C ? C.position.end : P.position.end), P || e.createMappingKey(c.createEmptyPosition(C.position.start), null), C || n.createMappingValue(c.createEmptyPosition(P.position.end), null));
          }
          r.transformAstPair = h;
        } }), Sn = F({ "node_modules/yaml-unist-parser/lib/transforms/flow-map.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = yn(), n = tt(), c = je(), h = nt(), d = Ae(), y = st(), E = Ue();
          function I(S, M) {
            var T = c.extractComments(S.cstNode.items, M), P = y.groupCstFlowCollectionItems(T), C = S.items.map(function(j, K) {
              var m = P[K], a = h.getFlowMapItemAdditionalRanges(m), t = a.additionalKeyRange, s = a.additionalValueRange;
              return E.transformAstPair(j, M, n.createFlowMappingItem, t, s);
            }), q = T[0], R = d.getLast(T);
            return e.createFlowMapping(M.transformRange({ origStart: q.origOffset, origEnd: R.origOffset + 1 }), M.transformContent(S), C);
          }
          r.transformFlowMap = I;
        } }), En = F({ "node_modules/yaml-unist-parser/lib/factories/flow-sequence.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = et();
          function c(h, d, y) {
            return e.__assign(e.__assign({}, n.createFlowCollection(h, d, y)), { type: "flowSequence" });
          }
          r.createFlowSequence = c;
        } }), Mn = F({ "node_modules/yaml-unist-parser/lib/factories/flow-sequence-item.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = me();
          function c(h, d) {
            return e.__assign(e.__assign({}, n.createNode("flowSequenceItem", h)), { children: [d] });
          }
          r.createFlowSequenceItem = c;
        } }), On = F({ "node_modules/yaml-unist-parser/lib/transforms/flow-seq.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = tt(), n = En(), c = Mn(), h = Le(), d = je(), y = nt(), E = Ae(), I = st(), S = Ue();
          function M(T, P) {
            var C = d.extractComments(T.cstNode.items, P), q = I.groupCstFlowCollectionItems(C), R = T.items.map(function(m, a) {
              if (m.type !== "PAIR") {
                var t = P.transformNode(m);
                return c.createFlowSequenceItem(h.createPosition(t.position.start, t.position.end), t);
              } else {
                var s = q[a], i = y.getFlowMapItemAdditionalRanges(s), f = i.additionalKeyRange, g = i.additionalValueRange;
                return S.transformAstPair(m, P, e.createFlowMappingItem, f, g);
              }
            }), j = C[0], K = E.getLast(C);
            return n.createFlowSequence(P.transformRange({ origStart: j.origOffset, origEnd: K.origOffset + 1 }), P.transformContent(T), R);
          }
          r.transformFlowSeq = M;
        } }), Ln = F({ "node_modules/yaml-unist-parser/lib/factories/mapping.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = Oe(), c = me();
          function h(d, y, E) {
            return e.__assign(e.__assign(e.__assign(e.__assign({}, c.createNode("mapping", d)), n.createLeadingCommentAttachable()), y), { children: E });
          }
          r.createMapping = h;
        } }), An = F({ "node_modules/yaml-unist-parser/lib/factories/mapping-item.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = Oe(), c = me();
          function h(d, y, E) {
            return e.__assign(e.__assign(e.__assign({}, c.createNode("mappingItem", d)), n.createLeadingCommentAttachable()), { children: [y, E] });
          }
          r.createMappingItem = h;
        } }), Nn = F({ "node_modules/yaml-unist-parser/lib/transforms/map.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = Ln(), n = An(), c = Le(), h = rt(), d = je(), y = Qe(), E = Ae(), I = Ue();
          function S(T, P) {
            var C = T.cstNode;
            C.items.filter(function(K) {
              return K.type === "MAP_KEY" || K.type === "MAP_VALUE";
            }).forEach(function(K) {
              return y.extractPropComments(K, P);
            });
            var q = d.extractComments(C.items, P), R = M(q), j = T.items.map(function(K, m) {
              var a = R[m], t = a[0].type === "MAP_VALUE" ? [null, a[0].range] : [a[0].range, a.length === 1 ? null : a[1].range], s = t[0], i = t[1];
              return I.transformAstPair(K, P, n.createMappingItem, s, i);
            });
            return e.createMapping(c.createPosition(j[0].position.start, E.getLast(j).position.end), P.transformContent(T), j);
          }
          r.transformMap = S;
          function M(T) {
            for (var P = [], C = h.createSlicer(T, 0), q = false, R = 0; R < T.length; R++) {
              var j = T[R];
              if (j.type === "MAP_VALUE") {
                P.push(C(R + 1)), q = false;
                continue;
              }
              q && P.push(C(R)), q = true;
            }
            return q && P.push(C(1 / 0)), P;
          }
        } }), Tn = F({ "node_modules/yaml-unist-parser/lib/factories/plain.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = Se(), c = me();
          function h(d, y, E) {
            return e.__assign(e.__assign(e.__assign(e.__assign({}, c.createNode("plain", d)), n.createCommentAttachable()), y), { value: E });
          }
          r.createPlain = h;
        } }), Cn = F({ "node_modules/yaml-unist-parser/lib/utils/find-last-char-index.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(n, c, h) {
            for (var d = c; d >= 0; d--) if (h.test(n[d])) return d;
            return -1;
          }
          r.findLastCharIndex = e;
        } }), kn = F({ "node_modules/yaml-unist-parser/lib/transforms/plain.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = Tn(), n = Cn();
          function c(h, d) {
            var y = h.cstNode;
            return e.createPlain(d.transformRange({ origStart: y.valueRange.origStart, origEnd: n.findLastCharIndex(d.text, y.valueRange.origEnd - 1, /\S/) + 1 }), d.transformContent(h), y.strValue);
          }
          r.transformPlain = c;
        } }), Pn = F({ "node_modules/yaml-unist-parser/lib/factories/quote-double.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te));
          function n(c) {
            return e.__assign(e.__assign({}, c), { type: "quoteDouble" });
          }
          r.createQuoteDouble = n;
        } }), In = F({ "node_modules/yaml-unist-parser/lib/factories/quote-value.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = Se(), c = me();
          function h(d, y, E) {
            return e.__assign(e.__assign(e.__assign(e.__assign({}, c.createNode("quoteValue", d)), y), n.createCommentAttachable()), { value: E });
          }
          r.createQuoteValue = h;
        } }), at = F({ "node_modules/yaml-unist-parser/lib/transforms/quote-value.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = In();
          function n(c, h) {
            var d = c.cstNode;
            return e.createQuoteValue(h.transformRange(d.valueRange), h.transformContent(c), d.strValue);
          }
          r.transformAstQuoteValue = n;
        } }), Rn = F({ "node_modules/yaml-unist-parser/lib/transforms/quote-double.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = Pn(), n = at();
          function c(h, d) {
            return e.createQuoteDouble(n.transformAstQuoteValue(h, d));
          }
          r.transformQuoteDouble = c;
        } }), qn = F({ "node_modules/yaml-unist-parser/lib/factories/quote-single.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te));
          function n(c) {
            return e.__assign(e.__assign({}, c), { type: "quoteSingle" });
          }
          r.createQuoteSingle = n;
        } }), Bn = F({ "node_modules/yaml-unist-parser/lib/transforms/quote-single.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = qn(), n = at();
          function c(h, d) {
            return e.createQuoteSingle(n.transformAstQuoteValue(h, d));
          }
          r.transformQuoteSingle = c;
        } }), jn = F({ "node_modules/yaml-unist-parser/lib/factories/sequence.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = Ee(), c = Oe(), h = me();
          function d(y, E, I) {
            return e.__assign(e.__assign(e.__assign(e.__assign(e.__assign({}, h.createNode("sequence", y)), c.createLeadingCommentAttachable()), n.createEndCommentAttachable()), E), { children: I });
          }
          r.createSequence = d;
        } }), Yn = F({ "node_modules/yaml-unist-parser/lib/factories/sequence-item.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te)), n = Se(), c = Ee(), h = me();
          function d(y, E) {
            return e.__assign(e.__assign(e.__assign(e.__assign({}, h.createNode("sequenceItem", y)), n.createCommentAttachable()), c.createEndCommentAttachable()), { children: E ? [E] : [] });
          }
          r.createSequenceItem = d;
        } }), Dn = F({ "node_modules/yaml-unist-parser/lib/transforms/seq.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = Le(), n = jn(), c = Yn(), h = je(), d = Qe(), y = Ae();
          function E(I, S) {
            var M = h.extractComments(I.cstNode.items, S), T = M.map(function(P, C) {
              d.extractPropComments(P, S);
              var q = S.transformNode(I.items[C]);
              return c.createSequenceItem(e.createPosition(S.transformOffset(P.valueRange.origStart), q === null ? S.transformOffset(P.valueRange.origStart + 1) : q.position.end), q);
            });
            return n.createSequence(e.createPosition(T[0].position.start, y.getLast(T).position.end), S.transformContent(I), T);
          }
          r.transformSeq = E;
        } }), Fn = F({ "node_modules/yaml-unist-parser/lib/transform.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = en(), n = on(), c = cn(), h = un(), d = mn(), y = vn(), E = Sn(), I = On(), S = Nn(), M = kn(), T = Rn(), P = Bn(), C = Dn();
          function q(R, j) {
            if (R === null || R.type === void 0 && R.value === null) return null;
            switch (R.type) {
              case "ALIAS":
                return e.transformAlias(R, j);
              case "BLOCK_FOLDED":
                return n.transformBlockFolded(R, j);
              case "BLOCK_LITERAL":
                return c.transformBlockLiteral(R, j);
              case "COMMENT":
                return h.transformComment(R, j);
              case "DIRECTIVE":
                return d.transformDirective(R, j);
              case "DOCUMENT":
                return y.transformDocument(R, j);
              case "FLOW_MAP":
                return E.transformFlowMap(R, j);
              case "FLOW_SEQ":
                return I.transformFlowSeq(R, j);
              case "MAP":
                return S.transformMap(R, j);
              case "PLAIN":
                return M.transformPlain(R, j);
              case "QUOTE_DOUBLE":
                return T.transformQuoteDouble(R, j);
              case "QUOTE_SINGLE":
                return P.transformQuoteSingle(R, j);
              case "SEQ":
                return C.transformSeq(R, j);
              default:
                throw new Error("Unexpected node type " + R.type);
            }
          }
          r.transformNode = q;
        } }), Wn = F({ "node_modules/yaml-unist-parser/lib/factories/error.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(n, c, h) {
            var d = new SyntaxError(n);
            return d.name = "YAMLSyntaxError", d.source = c, d.position = h, d;
          }
          r.createError = e;
        } }), Vn = F({ "node_modules/yaml-unist-parser/lib/transforms/error.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = Wn();
          function n(c, h) {
            var d = c.source.range || c.source.valueRange;
            return e.createError(c.message, h.text, h.transformRange(d));
          }
          r.transformError = n;
        } }), Qn = F({ "node_modules/yaml-unist-parser/lib/factories/point.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(n, c, h) {
            return { offset: n, line: c, column: h };
          }
          r.createPoint = e;
        } }), Un = F({ "node_modules/yaml-unist-parser/lib/transforms/offset.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = Qn();
          function n(c, h) {
            c < 0 ? c = 0 : c > h.text.length && (c = h.text.length);
            var d = h.locator.locationForIndex(c);
            return e.createPoint(c, d.line + 1, d.column + 1);
          }
          r.transformOffset = n;
        } }), Kn = F({ "node_modules/yaml-unist-parser/lib/transforms/range.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = Le();
          function n(c, h) {
            return e.createPosition(h.transformOffset(c.origStart), h.transformOffset(c.origEnd));
          }
          r.transformRange = n;
        } }), $n = F({ "node_modules/yaml-unist-parser/lib/utils/add-orig-range.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = true;
          function n(y) {
            if (!y.setOrigRanges()) {
              var E = function(I) {
                if (h(I)) return I.origStart = I.start, I.origEnd = I.end, e;
                if (d(I)) return I.origOffset = I.offset, e;
              };
              y.forEach(function(I) {
                return c(I, E);
              });
            }
          }
          r.addOrigRange = n;
          function c(y, E) {
            if (!(!y || typeof y != "object") && E(y) !== e) for (var I = 0, S = Object.keys(y); I < S.length; I++) {
              var M = S[I];
              if (!(M === "context" || M === "error")) {
                var T = y[M];
                Array.isArray(T) ? T.forEach(function(P) {
                  return c(P, E);
                }) : c(T, E);
              }
            }
          }
          function h(y) {
            return typeof y.start == "number";
          }
          function d(y) {
            return typeof y.offset == "number";
          }
        } }), Jn = F({ "node_modules/yaml-unist-parser/lib/utils/remove-fake-nodes.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(n) {
            if ("children" in n) {
              if (n.children.length === 1) {
                var c = n.children[0];
                if (c.type === "plain" && c.tag === null && c.anchor === null && c.value === "") return n.children.splice(0, 1), n;
              }
              n.children.forEach(e);
            }
            return n;
          }
          r.removeFakeNodes = e;
        } }), xn = F({ "node_modules/yaml-unist-parser/lib/utils/create-updater.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          function e(n, c, h, d) {
            var y = c(n);
            return function(E) {
              d(y, E) && h(n, y = E);
            };
          }
          r.createUpdater = e;
        } }), Hn = F({ "node_modules/yaml-unist-parser/lib/utils/update-positions.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = xn(), n = Ae();
          function c(M) {
            if (!(M === null || !("children" in M))) {
              var T = M.children;
              if (T.forEach(c), M.type === "document") {
                var P = M.children, C = P[0], q = P[1];
                C.position.start.offset === C.position.end.offset ? C.position.start = C.position.end = q.position.start : q.position.start.offset === q.position.end.offset && (q.position.start = q.position.end = C.position.end);
              }
              var R = e.createUpdater(M.position, h, d, I), j = e.createUpdater(M.position, y, E, S);
              "endComments" in M && M.endComments.length !== 0 && (R(M.endComments[0].position.start), j(n.getLast(M.endComments).position.end));
              var K = T.filter(function(t) {
                return t !== null;
              });
              if (K.length !== 0) {
                var m = K[0], a = n.getLast(K);
                R(m.position.start), j(a.position.end), "leadingComments" in m && m.leadingComments.length !== 0 && R(m.leadingComments[0].position.start), "tag" in m && m.tag && R(m.tag.position.start), "anchor" in m && m.anchor && R(m.anchor.position.start), "trailingComment" in a && a.trailingComment && j(a.trailingComment.position.end);
              }
            }
          }
          r.updatePositions = c;
          function h(M) {
            return M.start;
          }
          function d(M, T) {
            M.start = T;
          }
          function y(M) {
            return M.end;
          }
          function E(M, T) {
            M.end = T;
          }
          function I(M, T) {
            return T.offset < M.offset;
          }
          function S(M, T) {
            return T.offset > M.offset;
          }
        } }), Me = F({ "node_modules/yaml/dist/PlainValue-ec8e588e.js"(r) {
          "use strict";
          D();
          var e = { ANCHOR: "&", COMMENT: "#", TAG: "!", DIRECTIVES_END: "-", DOCUMENT_END: "." }, n = { ALIAS: "ALIAS", BLANK_LINE: "BLANK_LINE", BLOCK_FOLDED: "BLOCK_FOLDED", BLOCK_LITERAL: "BLOCK_LITERAL", COMMENT: "COMMENT", DIRECTIVE: "DIRECTIVE", DOCUMENT: "DOCUMENT", FLOW_MAP: "FLOW_MAP", FLOW_SEQ: "FLOW_SEQ", MAP: "MAP", MAP_KEY: "MAP_KEY", MAP_VALUE: "MAP_VALUE", PLAIN: "PLAIN", QUOTE_DOUBLE: "QUOTE_DOUBLE", QUOTE_SINGLE: "QUOTE_SINGLE", SEQ: "SEQ", SEQ_ITEM: "SEQ_ITEM" }, c = "tag:yaml.org,2002:", h = { MAP: "tag:yaml.org,2002:map", SEQ: "tag:yaml.org,2002:seq", STR: "tag:yaml.org,2002:str" };
          function d(a) {
            let t = [0], s = a.indexOf(`
`);
            for (; s !== -1; ) s += 1, t.push(s), s = a.indexOf(`
`, s);
            return t;
          }
          function y(a) {
            let t, s;
            return typeof a == "string" ? (t = d(a), s = a) : (Array.isArray(a) && (a = a[0]), a && a.context && (a.lineStarts || (a.lineStarts = d(a.context.src)), t = a.lineStarts, s = a.context.src)), { lineStarts: t, src: s };
          }
          function E(a, t) {
            if (typeof a != "number" || a < 0) return null;
            let { lineStarts: s, src: i } = y(t);
            if (!s || !i || a > i.length) return null;
            for (let g = 0; g < s.length; ++g) {
              let u = s[g];
              if (a < u) return { line: g, col: a - s[g - 1] + 1 };
              if (a === u) return { line: g + 1, col: 1 };
            }
            let f = s.length;
            return { line: f, col: a - s[f - 1] + 1 };
          }
          function I(a, t) {
            let { lineStarts: s, src: i } = y(t);
            if (!s || !(a >= 1) || a > s.length) return null;
            let f = s[a - 1], g = s[a];
            for (; g && g > f && i[g - 1] === `
`; ) --g;
            return i.slice(f, g);
          }
          function S(a, t) {
            let { start: s, end: i } = a, f = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 80, g = I(s.line, t);
            if (!g) return null;
            let { col: u } = s;
            if (g.length > f) if (u <= f - 10) g = g.substr(0, f - 1) + "\u2026";
            else {
              let $ = Math.round(f / 2);
              g.length > u + $ && (g = g.substr(0, u + $ - 1) + "\u2026"), u -= g.length - f, g = "\u2026" + g.substr(1 - f);
            }
            let p = 1, L = "";
            i && (i.line === s.line && u + (i.col - s.col) <= f + 1 ? p = i.col - s.col : (p = Math.min(g.length + 1, f) - u, L = "\u2026"));
            let k = u > 1 ? " ".repeat(u - 1) : "", B = "^".repeat(p);
            return "".concat(g, `
`).concat(k).concat(B).concat(L);
          }
          var M = class {
            static copy(a) {
              return new M(a.start, a.end);
            }
            constructor(a, t) {
              this.start = a, this.end = t || a;
            }
            isEmpty() {
              return typeof this.start != "number" || !this.end || this.end <= this.start;
            }
            setOrigRange(a, t) {
              let { start: s, end: i } = this;
              if (a.length === 0 || i <= a[0]) return this.origStart = s, this.origEnd = i, t;
              let f = t;
              for (; f < a.length && !(a[f] > s); ) ++f;
              this.origStart = s + f;
              let g = f;
              for (; f < a.length && !(a[f] >= i); ) ++f;
              return this.origEnd = i + f, g;
            }
          }, T = class {
            static addStringTerminator(a, t, s) {
              if (s[s.length - 1] === `
`) return s;
              let i = T.endOfWhiteSpace(a, t);
              return i >= a.length || a[i] === `
` ? s + `
` : s;
            }
            static atDocumentBoundary(a, t, s) {
              let i = a[t];
              if (!i) return true;
              let f = a[t - 1];
              if (f && f !== `
`) return false;
              if (s) {
                if (i !== s) return false;
              } else if (i !== e.DIRECTIVES_END && i !== e.DOCUMENT_END) return false;
              let g = a[t + 1], u = a[t + 2];
              if (g !== i || u !== i) return false;
              let p = a[t + 3];
              return !p || p === `
` || p === "	" || p === " ";
            }
            static endOfIdentifier(a, t) {
              let s = a[t], i = s === "<", f = i ? [`
`, "	", " ", ">"] : [`
`, "	", " ", "[", "]", "{", "}", ","];
              for (; s && f.indexOf(s) === -1; ) s = a[t += 1];
              return i && s === ">" && (t += 1), t;
            }
            static endOfIndent(a, t) {
              let s = a[t];
              for (; s === " "; ) s = a[t += 1];
              return t;
            }
            static endOfLine(a, t) {
              let s = a[t];
              for (; s && s !== `
`; ) s = a[t += 1];
              return t;
            }
            static endOfWhiteSpace(a, t) {
              let s = a[t];
              for (; s === "	" || s === " "; ) s = a[t += 1];
              return t;
            }
            static startOfLine(a, t) {
              let s = a[t - 1];
              if (s === `
`) return t;
              for (; s && s !== `
`; ) s = a[t -= 1];
              return t + 1;
            }
            static endOfBlockIndent(a, t, s) {
              let i = T.endOfIndent(a, s);
              if (i > s + t) return i;
              {
                let f = T.endOfWhiteSpace(a, i), g = a[f];
                if (!g || g === `
`) return f;
              }
              return null;
            }
            static atBlank(a, t, s) {
              let i = a[t];
              return i === `
` || i === "	" || i === " " || s && !i;
            }
            static nextNodeIsIndented(a, t, s) {
              return !a || t < 0 ? false : t > 0 ? true : s && a === "-";
            }
            static normalizeOffset(a, t) {
              let s = a[t];
              return s ? s !== `
` && a[t - 1] === `
` ? t - 1 : T.endOfWhiteSpace(a, t) : t;
            }
            static foldNewline(a, t, s) {
              let i = 0, f = false, g = "", u = a[t + 1];
              for (; u === " " || u === "	" || u === `
`; ) {
                switch (u) {
                  case `
`:
                    i = 0, t += 1, g += `
`;
                    break;
                  case "	":
                    i <= s && (f = true), t = T.endOfWhiteSpace(a, t + 2) - 1;
                    break;
                  case " ":
                    i += 1, t += 1;
                    break;
                }
                u = a[t + 1];
              }
              return g || (g = " "), u && i <= s && (f = true), { fold: g, offset: t, error: f };
            }
            constructor(a, t, s) {
              Object.defineProperty(this, "context", { value: s || null, writable: true }), this.error = null, this.range = null, this.valueRange = null, this.props = t || [], this.type = a, this.value = null;
            }
            getPropValue(a, t, s) {
              if (!this.context) return null;
              let { src: i } = this.context, f = this.props[a];
              return f && i[f.start] === t ? i.slice(f.start + (s ? 1 : 0), f.end) : null;
            }
            get anchor() {
              for (let a = 0; a < this.props.length; ++a) {
                let t = this.getPropValue(a, e.ANCHOR, true);
                if (t != null) return t;
              }
              return null;
            }
            get comment() {
              let a = [];
              for (let t = 0; t < this.props.length; ++t) {
                let s = this.getPropValue(t, e.COMMENT, true);
                s != null && a.push(s);
              }
              return a.length > 0 ? a.join(`
`) : null;
            }
            commentHasRequiredWhitespace(a) {
              let { src: t } = this.context;
              if (this.header && a === this.header.end || !this.valueRange) return false;
              let { end: s } = this.valueRange;
              return a !== s || T.atBlank(t, s - 1);
            }
            get hasComment() {
              if (this.context) {
                let { src: a } = this.context;
                for (let t = 0; t < this.props.length; ++t) if (a[this.props[t].start] === e.COMMENT) return true;
              }
              return false;
            }
            get hasProps() {
              if (this.context) {
                let { src: a } = this.context;
                for (let t = 0; t < this.props.length; ++t) if (a[this.props[t].start] !== e.COMMENT) return true;
              }
              return false;
            }
            get includesTrailingLines() {
              return false;
            }
            get jsonLike() {
              return [n.FLOW_MAP, n.FLOW_SEQ, n.QUOTE_DOUBLE, n.QUOTE_SINGLE].indexOf(this.type) !== -1;
            }
            get rangeAsLinePos() {
              if (!this.range || !this.context) return;
              let a = E(this.range.start, this.context.root);
              if (!a) return;
              let t = E(this.range.end, this.context.root);
              return { start: a, end: t };
            }
            get rawValue() {
              if (!this.valueRange || !this.context) return null;
              let { start: a, end: t } = this.valueRange;
              return this.context.src.slice(a, t);
            }
            get tag() {
              for (let a = 0; a < this.props.length; ++a) {
                let t = this.getPropValue(a, e.TAG, false);
                if (t != null) {
                  if (t[1] === "<") return { verbatim: t.slice(2, -1) };
                  {
                    let [s, i, f] = t.match(/^(.*!)([^!]*)$/);
                    return { handle: i, suffix: f };
                  }
                }
              }
              return null;
            }
            get valueRangeContainsNewline() {
              if (!this.valueRange || !this.context) return false;
              let { start: a, end: t } = this.valueRange, { src: s } = this.context;
              for (let i = a; i < t; ++i) if (s[i] === `
`) return true;
              return false;
            }
            parseComment(a) {
              let { src: t } = this.context;
              if (t[a] === e.COMMENT) {
                let s = T.endOfLine(t, a + 1), i = new M(a, s);
                return this.props.push(i), s;
              }
              return a;
            }
            setOrigRanges(a, t) {
              return this.range && (t = this.range.setOrigRange(a, t)), this.valueRange && this.valueRange.setOrigRange(a, t), this.props.forEach((s) => s.setOrigRange(a, t)), t;
            }
            toString() {
              let { context: { src: a }, range: t, value: s } = this;
              if (s != null) return s;
              let i = a.slice(t.start, t.end);
              return T.addStringTerminator(a, t.end, i);
            }
          }, P = class extends Error {
            constructor(a, t, s) {
              if (!s || !(t instanceof T)) throw new Error("Invalid arguments for new ".concat(a));
              super(), this.name = a, this.message = s, this.source = t;
            }
            makePretty() {
              if (!this.source) return;
              this.nodeType = this.source.type;
              let a = this.source.context && this.source.context.root;
              if (typeof this.offset == "number") {
                this.range = new M(this.offset, this.offset + 1);
                let t = a && E(this.offset, a);
                if (t) {
                  let s = { line: t.line, col: t.col + 1 };
                  this.linePos = { start: t, end: s };
                }
                delete this.offset;
              } else this.range = this.source.range, this.linePos = this.source.rangeAsLinePos;
              if (this.linePos) {
                let { line: t, col: s } = this.linePos.start;
                this.message += " at line ".concat(t, ", column ").concat(s);
                let i = a && S(this.linePos, a);
                i && (this.message += `:

`.concat(i, `
`));
              }
              delete this.source;
            }
          }, C = class extends P {
            constructor(a, t) {
              super("YAMLReferenceError", a, t);
            }
          }, q = class extends P {
            constructor(a, t) {
              super("YAMLSemanticError", a, t);
            }
          }, R = class extends P {
            constructor(a, t) {
              super("YAMLSyntaxError", a, t);
            }
          }, j = class extends P {
            constructor(a, t) {
              super("YAMLWarning", a, t);
            }
          };
          function K(a, t, s) {
            return t in a ? Object.defineProperty(a, t, { value: s, enumerable: true, configurable: true, writable: true }) : a[t] = s, a;
          }
          var m = class extends T {
            static endOfLine(a, t, s) {
              let i = a[t], f = t;
              for (; i && i !== `
` && !(s && (i === "[" || i === "]" || i === "{" || i === "}" || i === ",")); ) {
                let g = a[f + 1];
                if (i === ":" && (!g || g === `
` || g === "	" || g === " " || s && g === ",") || (i === " " || i === "	") && g === "#") break;
                f += 1, i = g;
              }
              return f;
            }
            get strValue() {
              if (!this.valueRange || !this.context) return null;
              let { start: a, end: t } = this.valueRange, { src: s } = this.context, i = s[t - 1];
              for (; a < t && (i === `
` || i === "	" || i === " "); ) i = s[--t - 1];
              let f = "";
              for (let u = a; u < t; ++u) {
                let p = s[u];
                if (p === `
`) {
                  let { fold: L, offset: k } = T.foldNewline(s, u, -1);
                  f += L, u = k;
                } else if (p === " " || p === "	") {
                  let L = u, k = s[u + 1];
                  for (; u < t && (k === " " || k === "	"); ) u += 1, k = s[u + 1];
                  k !== `
` && (f += u > L ? s.slice(L, u + 1) : p);
                } else f += p;
              }
              let g = s[a];
              switch (g) {
                case "	": {
                  let u = "Plain value cannot start with a tab character";
                  return { errors: [new q(this, u)], str: f };
                }
                case "@":
                case "`": {
                  let u = "Plain value cannot start with reserved character ".concat(g);
                  return { errors: [new q(this, u)], str: f };
                }
                default:
                  return f;
              }
            }
            parseBlockValue(a) {
              let { indent: t, inFlow: s, src: i } = this.context, f = a, g = a;
              for (let u = i[f]; u === `
` && !T.atDocumentBoundary(i, f + 1); u = i[f]) {
                let p = T.endOfBlockIndent(i, t, f + 1);
                if (p === null || i[p] === "#") break;
                i[p] === `
` ? f = p : (g = m.endOfLine(i, p, s), f = g);
              }
              return this.valueRange.isEmpty() && (this.valueRange.start = a), this.valueRange.end = g, g;
            }
            parse(a, t) {
              this.context = a;
              let { inFlow: s, src: i } = a, f = t, g = i[f];
              return g && g !== "#" && g !== `
` && (f = m.endOfLine(i, t, s)), this.valueRange = new M(t, f), f = T.endOfWhiteSpace(i, f), f = this.parseComment(f), (!this.hasComment || this.valueRange.isEmpty()) && (f = this.parseBlockValue(f)), f;
            }
          };
          r.Char = e, r.Node = T, r.PlainValue = m, r.Range = M, r.Type = n, r.YAMLError = P, r.YAMLReferenceError = C, r.YAMLSemanticError = q, r.YAMLSyntaxError = R, r.YAMLWarning = j, r._defineProperty = K, r.defaultTagPrefix = c, r.defaultTags = h;
        } }), Gn = F({ "node_modules/yaml/dist/parse-cst.js"(r) {
          "use strict";
          D();
          var e = Me(), n = class extends e.Node {
            constructor() {
              super(e.Type.BLANK_LINE);
            }
            get includesTrailingLines() {
              return true;
            }
            parse(m, a) {
              return this.context = m, this.range = new e.Range(a, a + 1), a + 1;
            }
          }, c = class extends e.Node {
            constructor(m, a) {
              super(m, a), this.node = null;
            }
            get includesTrailingLines() {
              return !!this.node && this.node.includesTrailingLines;
            }
            parse(m, a) {
              this.context = m;
              let { parseNode: t, src: s } = m, { atLineStart: i, lineStart: f } = m;
              !i && this.type === e.Type.SEQ_ITEM && (this.error = new e.YAMLSemanticError(this, "Sequence items must not have preceding content on the same line"));
              let g = i ? a - f : m.indent, u = e.Node.endOfWhiteSpace(s, a + 1), p = s[u], L = p === "#", k = [], B = null;
              for (; p === `
` || p === "#"; ) {
                if (p === "#") {
                  let Q = e.Node.endOfLine(s, u + 1);
                  k.push(new e.Range(u, Q)), u = Q;
                } else {
                  i = true, f = u + 1;
                  let Q = e.Node.endOfWhiteSpace(s, f);
                  s[Q] === `
` && k.length === 0 && (B = new n(), f = B.parse({ src: s }, f)), u = e.Node.endOfIndent(s, f);
                }
                p = s[u];
              }
              if (e.Node.nextNodeIsIndented(p, u - (f + g), this.type !== e.Type.SEQ_ITEM) ? this.node = t({ atLineStart: i, inCollection: false, indent: g, lineStart: f, parent: this }, u) : p && f > a + 1 && (u = f - 1), this.node) {
                if (B) {
                  let Q = m.parent.items || m.parent.contents;
                  Q && Q.push(B);
                }
                k.length && Array.prototype.push.apply(this.props, k), u = this.node.range.end;
              } else if (L) {
                let Q = k[0];
                this.props.push(Q), u = Q.end;
              } else u = e.Node.endOfLine(s, a + 1);
              let $ = this.node ? this.node.valueRange.end : u;
              return this.valueRange = new e.Range(a, $), u;
            }
            setOrigRanges(m, a) {
              return a = super.setOrigRanges(m, a), this.node ? this.node.setOrigRanges(m, a) : a;
            }
            toString() {
              let { context: { src: m }, node: a, range: t, value: s } = this;
              if (s != null) return s;
              let i = a ? m.slice(t.start, a.range.start) + String(a) : m.slice(t.start, t.end);
              return e.Node.addStringTerminator(m, t.end, i);
            }
          }, h = class extends e.Node {
            constructor() {
              super(e.Type.COMMENT);
            }
            parse(m, a) {
              this.context = m;
              let t = this.parseComment(a);
              return this.range = new e.Range(a, t), t;
            }
          };
          function d(m) {
            let a = m;
            for (; a instanceof c; ) a = a.node;
            if (!(a instanceof y)) return null;
            let t = a.items.length, s = -1;
            for (let g = t - 1; g >= 0; --g) {
              let u = a.items[g];
              if (u.type === e.Type.COMMENT) {
                let { indent: p, lineStart: L } = u.context;
                if (p > 0 && u.range.start >= L + p) break;
                s = g;
              } else if (u.type === e.Type.BLANK_LINE) s = g;
              else break;
            }
            if (s === -1) return null;
            let i = a.items.splice(s, t - s), f = i[0].range.start;
            for (; a.range.end = f, a.valueRange && a.valueRange.end > f && (a.valueRange.end = f), a !== m; ) a = a.context.parent;
            return i;
          }
          var y = class extends e.Node {
            static nextContentHasIndent(m, a, t) {
              let s = e.Node.endOfLine(m, a) + 1;
              a = e.Node.endOfWhiteSpace(m, s);
              let i = m[a];
              return i ? a >= s + t ? true : i !== "#" && i !== `
` ? false : y.nextContentHasIndent(m, a, t) : false;
            }
            constructor(m) {
              super(m.type === e.Type.SEQ_ITEM ? e.Type.SEQ : e.Type.MAP);
              for (let t = m.props.length - 1; t >= 0; --t) if (m.props[t].start < m.context.lineStart) {
                this.props = m.props.slice(0, t + 1), m.props = m.props.slice(t + 1);
                let s = m.props[0] || m.valueRange;
                m.range.start = s.start;
                break;
              }
              this.items = [m];
              let a = d(m);
              a && Array.prototype.push.apply(this.items, a);
            }
            get includesTrailingLines() {
              return this.items.length > 0;
            }
            parse(m, a) {
              this.context = m;
              let { parseNode: t, src: s } = m, i = e.Node.startOfLine(s, a), f = this.items[0];
              f.context.parent = this, this.valueRange = e.Range.copy(f.valueRange);
              let g = f.range.start - f.context.lineStart, u = a;
              u = e.Node.normalizeOffset(s, u);
              let p = s[u], L = e.Node.endOfWhiteSpace(s, i) === u, k = false;
              for (; p; ) {
                for (; p === `
` || p === "#"; ) {
                  if (L && p === `
` && !k) {
                    let Q = new n();
                    if (u = Q.parse({ src: s }, u), this.valueRange.end = u, u >= s.length) {
                      p = null;
                      break;
                    }
                    this.items.push(Q), u -= 1;
                  } else if (p === "#") {
                    if (u < i + g && !y.nextContentHasIndent(s, u, g)) return u;
                    let Q = new h();
                    if (u = Q.parse({ indent: g, lineStart: i, src: s }, u), this.items.push(Q), this.valueRange.end = u, u >= s.length) {
                      p = null;
                      break;
                    }
                  }
                  if (i = u + 1, u = e.Node.endOfIndent(s, i), e.Node.atBlank(s, u)) {
                    let Q = e.Node.endOfWhiteSpace(s, u), z2 = s[Q];
                    (!z2 || z2 === `
` || z2 === "#") && (u = Q);
                  }
                  p = s[u], L = true;
                }
                if (!p) break;
                if (u !== i + g && (L || p !== ":")) {
                  if (u < i + g) {
                    i > a && (u = i);
                    break;
                  } else if (!this.error) {
                    let Q = "All collection items must start at the same column";
                    this.error = new e.YAMLSyntaxError(this, Q);
                  }
                }
                if (f.type === e.Type.SEQ_ITEM) {
                  if (p !== "-") {
                    i > a && (u = i);
                    break;
                  }
                } else if (p === "-" && !this.error) {
                  let Q = s[u + 1];
                  if (!Q || Q === `
` || Q === "	" || Q === " ") {
                    let z2 = "A collection cannot be both a mapping and a sequence";
                    this.error = new e.YAMLSyntaxError(this, z2);
                  }
                }
                let B = t({ atLineStart: L, inCollection: true, indent: g, lineStart: i, parent: this }, u);
                if (!B) return u;
                if (this.items.push(B), this.valueRange.end = B.valueRange.end, u = e.Node.normalizeOffset(s, B.range.end), p = s[u], L = false, k = B.includesTrailingLines, p) {
                  let Q = u - 1, z2 = s[Q];
                  for (; z2 === " " || z2 === "	"; ) z2 = s[--Q];
                  z2 === `
` && (i = Q + 1, L = true);
                }
                let $ = d(B);
                $ && Array.prototype.push.apply(this.items, $);
              }
              return u;
            }
            setOrigRanges(m, a) {
              return a = super.setOrigRanges(m, a), this.items.forEach((t) => {
                a = t.setOrigRanges(m, a);
              }), a;
            }
            toString() {
              let { context: { src: m }, items: a, range: t, value: s } = this;
              if (s != null) return s;
              let i = m.slice(t.start, a[0].range.start) + String(a[0]);
              for (let f = 1; f < a.length; ++f) {
                let g = a[f], { atLineStart: u, indent: p } = g.context;
                if (u) for (let L = 0; L < p; ++L) i += " ";
                i += String(g);
              }
              return e.Node.addStringTerminator(m, t.end, i);
            }
          }, E = class extends e.Node {
            constructor() {
              super(e.Type.DIRECTIVE), this.name = null;
            }
            get parameters() {
              let m = this.rawValue;
              return m ? m.trim().split(/[ \t]+/) : [];
            }
            parseName(m) {
              let { src: a } = this.context, t = m, s = a[t];
              for (; s && s !== `
` && s !== "	" && s !== " "; ) s = a[t += 1];
              return this.name = a.slice(m, t), t;
            }
            parseParameters(m) {
              let { src: a } = this.context, t = m, s = a[t];
              for (; s && s !== `
` && s !== "#"; ) s = a[t += 1];
              return this.valueRange = new e.Range(m, t), t;
            }
            parse(m, a) {
              this.context = m;
              let t = this.parseName(a + 1);
              return t = this.parseParameters(t), t = this.parseComment(t), this.range = new e.Range(a, t), t;
            }
          }, I = class extends e.Node {
            static startCommentOrEndBlankLine(m, a) {
              let t = e.Node.endOfWhiteSpace(m, a), s = m[t];
              return s === "#" || s === `
` ? t : a;
            }
            constructor() {
              super(e.Type.DOCUMENT), this.directives = null, this.contents = null, this.directivesEndMarker = null, this.documentEndMarker = null;
            }
            parseDirectives(m) {
              let { src: a } = this.context;
              this.directives = [];
              let t = true, s = false, i = m;
              for (; !e.Node.atDocumentBoundary(a, i, e.Char.DIRECTIVES_END); ) switch (i = I.startCommentOrEndBlankLine(a, i), a[i]) {
                case `
`:
                  if (t) {
                    let f = new n();
                    i = f.parse({ src: a }, i), i < a.length && this.directives.push(f);
                  } else i += 1, t = true;
                  break;
                case "#":
                  {
                    let f = new h();
                    i = f.parse({ src: a }, i), this.directives.push(f), t = false;
                  }
                  break;
                case "%":
                  {
                    let f = new E();
                    i = f.parse({ parent: this, src: a }, i), this.directives.push(f), s = true, t = false;
                  }
                  break;
                default:
                  return s ? this.error = new e.YAMLSemanticError(this, "Missing directives-end indicator line") : this.directives.length > 0 && (this.contents = this.directives, this.directives = []), i;
              }
              return a[i] ? (this.directivesEndMarker = new e.Range(i, i + 3), i + 3) : (s ? this.error = new e.YAMLSemanticError(this, "Missing directives-end indicator line") : this.directives.length > 0 && (this.contents = this.directives, this.directives = []), i);
            }
            parseContents(m) {
              let { parseNode: a, src: t } = this.context;
              this.contents || (this.contents = []);
              let s = m;
              for (; t[s - 1] === "-"; ) s -= 1;
              let i = e.Node.endOfWhiteSpace(t, m), f = s === m;
              for (this.valueRange = new e.Range(i); !e.Node.atDocumentBoundary(t, i, e.Char.DOCUMENT_END); ) {
                switch (t[i]) {
                  case `
`:
                    if (f) {
                      let g = new n();
                      i = g.parse({ src: t }, i), i < t.length && this.contents.push(g);
                    } else i += 1, f = true;
                    s = i;
                    break;
                  case "#":
                    {
                      let g = new h();
                      i = g.parse({ src: t }, i), this.contents.push(g), f = false;
                    }
                    break;
                  default: {
                    let g = e.Node.endOfIndent(t, i), p = a({ atLineStart: f, indent: -1, inFlow: false, inCollection: false, lineStart: s, parent: this }, g);
                    if (!p) return this.valueRange.end = g;
                    this.contents.push(p), i = p.range.end, f = false;
                    let L = d(p);
                    L && Array.prototype.push.apply(this.contents, L);
                  }
                }
                i = I.startCommentOrEndBlankLine(t, i);
              }
              if (this.valueRange.end = i, t[i] && (this.documentEndMarker = new e.Range(i, i + 3), i += 3, t[i])) {
                if (i = e.Node.endOfWhiteSpace(t, i), t[i] === "#") {
                  let g = new h();
                  i = g.parse({ src: t }, i), this.contents.push(g);
                }
                switch (t[i]) {
                  case `
`:
                    i += 1;
                    break;
                  case void 0:
                    break;
                  default:
                    this.error = new e.YAMLSyntaxError(this, "Document end marker line cannot have a non-comment suffix");
                }
              }
              return i;
            }
            parse(m, a) {
              m.root = this, this.context = m;
              let { src: t } = m, s = t.charCodeAt(a) === 65279 ? a + 1 : a;
              return s = this.parseDirectives(s), s = this.parseContents(s), s;
            }
            setOrigRanges(m, a) {
              return a = super.setOrigRanges(m, a), this.directives.forEach((t) => {
                a = t.setOrigRanges(m, a);
              }), this.directivesEndMarker && (a = this.directivesEndMarker.setOrigRange(m, a)), this.contents.forEach((t) => {
                a = t.setOrigRanges(m, a);
              }), this.documentEndMarker && (a = this.documentEndMarker.setOrigRange(m, a)), a;
            }
            toString() {
              let { contents: m, directives: a, value: t } = this;
              if (t != null) return t;
              let s = a.join("");
              return m.length > 0 && ((a.length > 0 || m[0].type === e.Type.COMMENT) && (s += `---
`), s += m.join("")), s[s.length - 1] !== `
` && (s += `
`), s;
            }
          }, S = class extends e.Node {
            parse(m, a) {
              this.context = m;
              let { src: t } = m, s = e.Node.endOfIdentifier(t, a + 1);
              return this.valueRange = new e.Range(a + 1, s), s = e.Node.endOfWhiteSpace(t, s), s = this.parseComment(s), s;
            }
          }, M = { CLIP: "CLIP", KEEP: "KEEP", STRIP: "STRIP" }, T = class extends e.Node {
            constructor(m, a) {
              super(m, a), this.blockIndent = null, this.chomping = M.CLIP, this.header = null;
            }
            get includesTrailingLines() {
              return this.chomping === M.KEEP;
            }
            get strValue() {
              if (!this.valueRange || !this.context) return null;
              let { start: m, end: a } = this.valueRange, { indent: t, src: s } = this.context;
              if (this.valueRange.isEmpty()) return "";
              let i = null, f = s[a - 1];
              for (; f === `
` || f === "	" || f === " "; ) {
                if (a -= 1, a <= m) {
                  if (this.chomping === M.KEEP) break;
                  return "";
                }
                f === `
` && (i = a), f = s[a - 1];
              }
              let g = a + 1;
              i && (this.chomping === M.KEEP ? (g = i, a = this.valueRange.end) : a = i);
              let u = t + this.blockIndent, p = this.type === e.Type.BLOCK_FOLDED, L = true, k = "", B = "", $ = false;
              for (let Q = m; Q < a; ++Q) {
                for (let ie = 0; ie < u && s[Q] === " "; ++ie) Q += 1;
                let z2 = s[Q];
                if (z2 === `
`) B === `
` ? k += `
` : B = `
`;
                else {
                  let ie = e.Node.endOfLine(s, Q), ue = s.slice(Q, ie);
                  Q = ie, p && (z2 === " " || z2 === "	") && Q < g ? (B === " " ? B = `
` : !$ && !L && B === `
` && (B = `

`), k += B + ue, B = ie < a && s[ie] || "", $ = true) : (k += B + ue, B = p && Q < g ? " " : `
`, $ = false), L && ue !== "" && (L = false);
                }
              }
              return this.chomping === M.STRIP ? k : k + `
`;
            }
            parseBlockHeader(m) {
              let { src: a } = this.context, t = m + 1, s = "";
              for (; ; ) {
                let i = a[t];
                switch (i) {
                  case "-":
                    this.chomping = M.STRIP;
                    break;
                  case "+":
                    this.chomping = M.KEEP;
                    break;
                  case "0":
                  case "1":
                  case "2":
                  case "3":
                  case "4":
                  case "5":
                  case "6":
                  case "7":
                  case "8":
                  case "9":
                    s += i;
                    break;
                  default:
                    return this.blockIndent = Number(s) || null, this.header = new e.Range(m, t), t;
                }
                t += 1;
              }
            }
            parseBlockValue(m) {
              let { indent: a, src: t } = this.context, s = !!this.blockIndent, i = m, f = m, g = 1;
              for (let u = t[i]; u === `
` && (i += 1, !e.Node.atDocumentBoundary(t, i)); u = t[i]) {
                let p = e.Node.endOfBlockIndent(t, a, i);
                if (p === null) break;
                let L = t[p], k = p - (i + a);
                if (this.blockIndent) {
                  if (L && L !== `
` && k < this.blockIndent) {
                    if (t[p] === "#") break;
                    if (!this.error) {
                      let B = s ? "explicit indentation indicator" : "first line", $ = "Block scalars must not be less indented than their ".concat(B);
                      this.error = new e.YAMLSemanticError(this, $);
                    }
                  }
                } else if (t[p] !== `
`) {
                  if (k < g) {
                    let B = "Block scalars with more-indented leading empty lines must use an explicit indentation indicator";
                    this.error = new e.YAMLSemanticError(this, B);
                  }
                  this.blockIndent = k;
                } else k > g && (g = k);
                t[p] === `
` ? i = p : i = f = e.Node.endOfLine(t, p);
              }
              return this.chomping !== M.KEEP && (i = t[f] ? f + 1 : f), this.valueRange = new e.Range(m + 1, i), i;
            }
            parse(m, a) {
              this.context = m;
              let { src: t } = m, s = this.parseBlockHeader(a);
              return s = e.Node.endOfWhiteSpace(t, s), s = this.parseComment(s), s = this.parseBlockValue(s), s;
            }
            setOrigRanges(m, a) {
              return a = super.setOrigRanges(m, a), this.header ? this.header.setOrigRange(m, a) : a;
            }
          }, P = class extends e.Node {
            constructor(m, a) {
              super(m, a), this.items = null;
            }
            prevNodeIsJsonLike() {
              let m = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.items.length, a = this.items[m - 1];
              return !!a && (a.jsonLike || a.type === e.Type.COMMENT && this.prevNodeIsJsonLike(m - 1));
            }
            parse(m, a) {
              this.context = m;
              let { parseNode: t, src: s } = m, { indent: i, lineStart: f } = m, g = s[a];
              this.items = [{ char: g, offset: a }];
              let u = e.Node.endOfWhiteSpace(s, a + 1);
              for (g = s[u]; g && g !== "]" && g !== "}"; ) {
                switch (g) {
                  case `
`:
                    {
                      f = u + 1;
                      let p = e.Node.endOfWhiteSpace(s, f);
                      if (s[p] === `
`) {
                        let L = new n();
                        f = L.parse({ src: s }, f), this.items.push(L);
                      }
                      if (u = e.Node.endOfIndent(s, f), u <= f + i && (g = s[u], u < f + i || g !== "]" && g !== "}")) {
                        let L = "Insufficient indentation in flow collection";
                        this.error = new e.YAMLSemanticError(this, L);
                      }
                    }
                    break;
                  case ",":
                    this.items.push({ char: g, offset: u }), u += 1;
                    break;
                  case "#":
                    {
                      let p = new h();
                      u = p.parse({ src: s }, u), this.items.push(p);
                    }
                    break;
                  case "?":
                  case ":": {
                    let p = s[u + 1];
                    if (p === `
` || p === "	" || p === " " || p === "," || g === ":" && this.prevNodeIsJsonLike()) {
                      this.items.push({ char: g, offset: u }), u += 1;
                      break;
                    }
                  }
                  default: {
                    let p = t({ atLineStart: false, inCollection: false, inFlow: true, indent: -1, lineStart: f, parent: this }, u);
                    if (!p) return this.valueRange = new e.Range(a, u), u;
                    this.items.push(p), u = e.Node.normalizeOffset(s, p.range.end);
                  }
                }
                u = e.Node.endOfWhiteSpace(s, u), g = s[u];
              }
              return this.valueRange = new e.Range(a, u + 1), g && (this.items.push({ char: g, offset: u }), u = e.Node.endOfWhiteSpace(s, u + 1), u = this.parseComment(u)), u;
            }
            setOrigRanges(m, a) {
              return a = super.setOrigRanges(m, a), this.items.forEach((t) => {
                if (t instanceof e.Node) a = t.setOrigRanges(m, a);
                else if (m.length === 0) t.origOffset = t.offset;
                else {
                  let s = a;
                  for (; s < m.length && !(m[s] > t.offset); ) ++s;
                  t.origOffset = t.offset + s, a = s;
                }
              }), a;
            }
            toString() {
              let { context: { src: m }, items: a, range: t, value: s } = this;
              if (s != null) return s;
              let i = a.filter((u) => u instanceof e.Node), f = "", g = t.start;
              return i.forEach((u) => {
                let p = m.slice(g, u.range.start);
                g = u.range.end, f += p + String(u), f[f.length - 1] === `
` && m[g - 1] !== `
` && m[g] === `
` && (g += 1);
              }), f += m.slice(g, t.end), e.Node.addStringTerminator(m, t.end, f);
            }
          }, C = class extends e.Node {
            static endOfQuote(m, a) {
              let t = m[a];
              for (; t && t !== '"'; ) a += t === "\\" ? 2 : 1, t = m[a];
              return a + 1;
            }
            get strValue() {
              if (!this.valueRange || !this.context) return null;
              let m = [], { start: a, end: t } = this.valueRange, { indent: s, src: i } = this.context;
              i[t - 1] !== '"' && m.push(new e.YAMLSyntaxError(this, 'Missing closing "quote'));
              let f = "";
              for (let g = a + 1; g < t - 1; ++g) {
                let u = i[g];
                if (u === `
`) {
                  e.Node.atDocumentBoundary(i, g + 1) && m.push(new e.YAMLSemanticError(this, "Document boundary indicators are not allowed within string values"));
                  let { fold: p, offset: L, error: k } = e.Node.foldNewline(i, g, s);
                  f += p, g = L, k && m.push(new e.YAMLSemanticError(this, "Multi-line double-quoted string needs to be sufficiently indented"));
                } else if (u === "\\") switch (g += 1, i[g]) {
                  case "0":
                    f += "\0";
                    break;
                  case "a":
                    f += "\x07";
                    break;
                  case "b":
                    f += "\b";
                    break;
                  case "e":
                    f += "\x1B";
                    break;
                  case "f":
                    f += "\f";
                    break;
                  case "n":
                    f += `
`;
                    break;
                  case "r":
                    f += "\r";
                    break;
                  case "t":
                    f += "	";
                    break;
                  case "v":
                    f += "\v";
                    break;
                  case "N":
                    f += "\x85";
                    break;
                  case "_":
                    f += "\xA0";
                    break;
                  case "L":
                    f += "\u2028";
                    break;
                  case "P":
                    f += "\u2029";
                    break;
                  case " ":
                    f += " ";
                    break;
                  case '"':
                    f += '"';
                    break;
                  case "/":
                    f += "/";
                    break;
                  case "\\":
                    f += "\\";
                    break;
                  case "	":
                    f += "	";
                    break;
                  case "x":
                    f += this.parseCharCode(g + 1, 2, m), g += 2;
                    break;
                  case "u":
                    f += this.parseCharCode(g + 1, 4, m), g += 4;
                    break;
                  case "U":
                    f += this.parseCharCode(g + 1, 8, m), g += 8;
                    break;
                  case `
`:
                    for (; i[g + 1] === " " || i[g + 1] === "	"; ) g += 1;
                    break;
                  default:
                    m.push(new e.YAMLSyntaxError(this, "Invalid escape sequence ".concat(i.substr(g - 1, 2)))), f += "\\" + i[g];
                }
                else if (u === " " || u === "	") {
                  let p = g, L = i[g + 1];
                  for (; L === " " || L === "	"; ) g += 1, L = i[g + 1];
                  L !== `
` && (f += g > p ? i.slice(p, g + 1) : u);
                } else f += u;
              }
              return m.length > 0 ? { errors: m, str: f } : f;
            }
            parseCharCode(m, a, t) {
              let { src: s } = this.context, i = s.substr(m, a), g = i.length === a && /^[0-9a-fA-F]+$/.test(i) ? parseInt(i, 16) : NaN;
              return isNaN(g) ? (t.push(new e.YAMLSyntaxError(this, "Invalid escape sequence ".concat(s.substr(m - 2, a + 2)))), s.substr(m - 2, a + 2)) : String.fromCodePoint(g);
            }
            parse(m, a) {
              this.context = m;
              let { src: t } = m, s = C.endOfQuote(t, a + 1);
              return this.valueRange = new e.Range(a, s), s = e.Node.endOfWhiteSpace(t, s), s = this.parseComment(s), s;
            }
          }, q = class extends e.Node {
            static endOfQuote(m, a) {
              let t = m[a];
              for (; t; ) if (t === "'") {
                if (m[a + 1] !== "'") break;
                t = m[a += 2];
              } else t = m[a += 1];
              return a + 1;
            }
            get strValue() {
              if (!this.valueRange || !this.context) return null;
              let m = [], { start: a, end: t } = this.valueRange, { indent: s, src: i } = this.context;
              i[t - 1] !== "'" && m.push(new e.YAMLSyntaxError(this, "Missing closing 'quote"));
              let f = "";
              for (let g = a + 1; g < t - 1; ++g) {
                let u = i[g];
                if (u === `
`) {
                  e.Node.atDocumentBoundary(i, g + 1) && m.push(new e.YAMLSemanticError(this, "Document boundary indicators are not allowed within string values"));
                  let { fold: p, offset: L, error: k } = e.Node.foldNewline(i, g, s);
                  f += p, g = L, k && m.push(new e.YAMLSemanticError(this, "Multi-line single-quoted string needs to be sufficiently indented"));
                } else if (u === "'") f += u, g += 1, i[g] !== "'" && m.push(new e.YAMLSyntaxError(this, "Unescaped single quote? This should not happen."));
                else if (u === " " || u === "	") {
                  let p = g, L = i[g + 1];
                  for (; L === " " || L === "	"; ) g += 1, L = i[g + 1];
                  L !== `
` && (f += g > p ? i.slice(p, g + 1) : u);
                } else f += u;
              }
              return m.length > 0 ? { errors: m, str: f } : f;
            }
            parse(m, a) {
              this.context = m;
              let { src: t } = m, s = q.endOfQuote(t, a + 1);
              return this.valueRange = new e.Range(a, s), s = e.Node.endOfWhiteSpace(t, s), s = this.parseComment(s), s;
            }
          };
          function R(m, a) {
            switch (m) {
              case e.Type.ALIAS:
                return new S(m, a);
              case e.Type.BLOCK_FOLDED:
              case e.Type.BLOCK_LITERAL:
                return new T(m, a);
              case e.Type.FLOW_MAP:
              case e.Type.FLOW_SEQ:
                return new P(m, a);
              case e.Type.MAP_KEY:
              case e.Type.MAP_VALUE:
              case e.Type.SEQ_ITEM:
                return new c(m, a);
              case e.Type.COMMENT:
              case e.Type.PLAIN:
                return new e.PlainValue(m, a);
              case e.Type.QUOTE_DOUBLE:
                return new C(m, a);
              case e.Type.QUOTE_SINGLE:
                return new q(m, a);
              default:
                return null;
            }
          }
          var j = class {
            static parseType(m, a, t) {
              switch (m[a]) {
                case "*":
                  return e.Type.ALIAS;
                case ">":
                  return e.Type.BLOCK_FOLDED;
                case "|":
                  return e.Type.BLOCK_LITERAL;
                case "{":
                  return e.Type.FLOW_MAP;
                case "[":
                  return e.Type.FLOW_SEQ;
                case "?":
                  return !t && e.Node.atBlank(m, a + 1, true) ? e.Type.MAP_KEY : e.Type.PLAIN;
                case ":":
                  return !t && e.Node.atBlank(m, a + 1, true) ? e.Type.MAP_VALUE : e.Type.PLAIN;
                case "-":
                  return !t && e.Node.atBlank(m, a + 1, true) ? e.Type.SEQ_ITEM : e.Type.PLAIN;
                case '"':
                  return e.Type.QUOTE_DOUBLE;
                case "'":
                  return e.Type.QUOTE_SINGLE;
                default:
                  return e.Type.PLAIN;
              }
            }
            constructor() {
              let m = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, { atLineStart: a, inCollection: t, inFlow: s, indent: i, lineStart: f, parent: g } = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
              e._defineProperty(this, "parseNode", (u, p) => {
                if (e.Node.atDocumentBoundary(this.src, p)) return null;
                let L = new j(this, u), { props: k, type: B, valueStart: $ } = L.parseProps(p), Q = R(B, k), z2 = Q.parse(L, $);
                if (Q.range = new e.Range(p, z2), z2 <= p && (Q.error = new Error("Node#parse consumed no characters"), Q.error.parseEnd = z2, Q.error.source = Q, Q.range.end = p + 1), L.nodeStartsCollection(Q)) {
                  !Q.error && !L.atLineStart && L.parent.type === e.Type.DOCUMENT && (Q.error = new e.YAMLSyntaxError(Q, "Block collection must not have preceding content here (e.g. directives-end indicator)"));
                  let ie = new y(Q);
                  return z2 = ie.parse(new j(L), z2), ie.range = new e.Range(p, z2), ie;
                }
                return Q;
              }), this.atLineStart = a != null ? a : m.atLineStart || false, this.inCollection = t != null ? t : m.inCollection || false, this.inFlow = s != null ? s : m.inFlow || false, this.indent = i != null ? i : m.indent, this.lineStart = f != null ? f : m.lineStart, this.parent = g != null ? g : m.parent || {}, this.root = m.root, this.src = m.src;
            }
            nodeStartsCollection(m) {
              let { inCollection: a, inFlow: t, src: s } = this;
              if (a || t) return false;
              if (m instanceof c) return true;
              let i = m.range.end;
              return s[i] === `
` || s[i - 1] === `
` ? false : (i = e.Node.endOfWhiteSpace(s, i), s[i] === ":");
            }
            parseProps(m) {
              let { inFlow: a, parent: t, src: s } = this, i = [], f = false;
              m = this.atLineStart ? e.Node.endOfIndent(s, m) : e.Node.endOfWhiteSpace(s, m);
              let g = s[m];
              for (; g === e.Char.ANCHOR || g === e.Char.COMMENT || g === e.Char.TAG || g === `
`; ) {
                if (g === `
`) {
                  let p = m, L;
                  do
                    L = p + 1, p = e.Node.endOfIndent(s, L);
                  while (s[p] === `
`);
                  let k = p - (L + this.indent), B = t.type === e.Type.SEQ_ITEM && t.context.atLineStart;
                  if (s[p] !== "#" && !e.Node.nextNodeIsIndented(s[p], k, !B)) break;
                  this.atLineStart = true, this.lineStart = L, f = false, m = p;
                } else if (g === e.Char.COMMENT) {
                  let p = e.Node.endOfLine(s, m + 1);
                  i.push(new e.Range(m, p)), m = p;
                } else {
                  let p = e.Node.endOfIdentifier(s, m + 1);
                  g === e.Char.TAG && s[p] === "," && /^[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+,\d\d\d\d(-\d\d){0,2}\/\S/.test(s.slice(m + 1, p + 13)) && (p = e.Node.endOfIdentifier(s, p + 5)), i.push(new e.Range(m, p)), f = true, m = e.Node.endOfWhiteSpace(s, p);
                }
                g = s[m];
              }
              f && g === ":" && e.Node.atBlank(s, m + 1, true) && (m -= 1);
              let u = j.parseType(s, m, a);
              return { props: i, type: u, valueStart: m };
            }
          };
          function K(m) {
            let a = [];
            m.indexOf("\r") !== -1 && (m = m.replace(/\r\n?/g, (i, f) => (i.length > 1 && a.push(f), `
`)));
            let t = [], s = 0;
            do {
              let i = new I(), f = new j({ src: m });
              s = i.parse(f, s), t.push(i);
            } while (s < m.length);
            return t.setOrigRanges = () => {
              if (a.length === 0) return false;
              for (let f = 1; f < a.length; ++f) a[f] -= f;
              let i = 0;
              for (let f = 0; f < t.length; ++f) i = t[f].setOrigRanges(a, i);
              return a.splice(0, a.length), true;
            }, t.toString = () => t.join(`...
`), t;
          }
          r.parse = K;
        } }), ke = F({ "node_modules/yaml/dist/resolveSeq-d03cb037.js"(r) {
          "use strict";
          D();
          var e = Me();
          function n(o, l, _) {
            if (!_) return o;
            let v = _.replace(/[\s\S]^/gm, "$&".concat(l, "#"));
            return "#".concat(v, `
`).concat(l).concat(o);
          }
          function c(o, l, _) {
            return _ ? _.indexOf(`
`) === -1 ? "".concat(o, " #").concat(_) : "".concat(o, `
`) + _.replace(/^/gm, "".concat(l || "", "#")) : o;
          }
          var h = class {
          };
          function d(o, l, _) {
            if (Array.isArray(o)) return o.map((v, b) => d(v, String(b), _));
            if (o && typeof o.toJSON == "function") {
              let v = _ && _.anchors && _.anchors.get(o);
              v && (_.onCreate = (w) => {
                v.res = w, delete _.onCreate;
              });
              let b = o.toJSON(l, _);
              return v && _.onCreate && _.onCreate(b), b;
            }
            return (!_ || !_.keep) && typeof o == "bigint" ? Number(o) : o;
          }
          var y = class extends h {
            constructor(o) {
              super(), this.value = o;
            }
            toJSON(o, l) {
              return l && l.keep ? this.value : d(this.value, o, l);
            }
            toString() {
              return String(this.value);
            }
          };
          function E(o, l, _) {
            let v = _;
            for (let b = l.length - 1; b >= 0; --b) {
              let w = l[b];
              if (Number.isInteger(w) && w >= 0) {
                let A = [];
                A[w] = v, v = A;
              } else {
                let A = {};
                Object.defineProperty(A, w, { value: v, writable: true, enumerable: true, configurable: true }), v = A;
              }
            }
            return o.createNode(v, false);
          }
          var I = (o) => o == null || typeof o == "object" && o[Symbol.iterator]().next().done, S = class extends h {
            constructor(o) {
              super(), e._defineProperty(this, "items", []), this.schema = o;
            }
            addIn(o, l) {
              if (I(o)) this.add(l);
              else {
                let [_, ...v] = o, b = this.get(_, true);
                if (b instanceof S) b.addIn(v, l);
                else if (b === void 0 && this.schema) this.set(_, E(this.schema, v, l));
                else throw new Error("Expected YAML collection at ".concat(_, ". Remaining path: ").concat(v));
              }
            }
            deleteIn(o) {
              let [l, ..._] = o;
              if (_.length === 0) return this.delete(l);
              let v = this.get(l, true);
              if (v instanceof S) return v.deleteIn(_);
              throw new Error("Expected YAML collection at ".concat(l, ". Remaining path: ").concat(_));
            }
            getIn(o, l) {
              let [_, ...v] = o, b = this.get(_, true);
              return v.length === 0 ? !l && b instanceof y ? b.value : b : b instanceof S ? b.getIn(v, l) : void 0;
            }
            hasAllNullValues() {
              return this.items.every((o) => {
                if (!o || o.type !== "PAIR") return false;
                let l = o.value;
                return l == null || l instanceof y && l.value == null && !l.commentBefore && !l.comment && !l.tag;
              });
            }
            hasIn(o) {
              let [l, ..._] = o;
              if (_.length === 0) return this.has(l);
              let v = this.get(l, true);
              return v instanceof S ? v.hasIn(_) : false;
            }
            setIn(o, l) {
              let [_, ...v] = o;
              if (v.length === 0) this.set(_, l);
              else {
                let b = this.get(_, true);
                if (b instanceof S) b.setIn(v, l);
                else if (b === void 0 && this.schema) this.set(_, E(this.schema, v, l));
                else throw new Error("Expected YAML collection at ".concat(_, ". Remaining path: ").concat(v));
              }
            }
            toJSON() {
              return null;
            }
            toString(o, l, _, v) {
              let { blockItem: b, flowChars: w, isMap: A, itemIndent: N } = l, { indent: Y, indentStep: W, stringify: U } = o, H = this.type === e.Type.FLOW_MAP || this.type === e.Type.FLOW_SEQ || o.inFlow;
              H && (N += W);
              let oe = A && this.hasAllNullValues();
              o = Object.assign({}, o, { allNullValues: oe, indent: N, inFlow: H, type: null });
              let le = false, Z = false, ee = this.items.reduce((de, re, he) => {
                let ce;
                re && (!le && re.spaceBefore && de.push({ type: "comment", str: "" }), re.commentBefore && re.commentBefore.match(/^.*$/gm).forEach((Ie) => {
                  de.push({ type: "comment", str: "#".concat(Ie) });
                }), re.comment && (ce = re.comment), H && (!le && re.spaceBefore || re.commentBefore || re.comment || re.key && (re.key.commentBefore || re.key.comment) || re.value && (re.value.commentBefore || re.value.comment)) && (Z = true)), le = false;
                let fe = U(re, o, () => ce = null, () => le = true);
                return H && !Z && fe.includes(`
`) && (Z = true), H && he < this.items.length - 1 && (fe += ","), fe = c(fe, N, ce), le && (ce || H) && (le = false), de.push({ type: "item", str: fe }), de;
              }, []), X;
              if (ee.length === 0) X = w.start + w.end;
              else if (H) {
                let { start: de, end: re } = w, he = ee.map((ce) => ce.str);
                if (Z || he.reduce((ce, fe) => ce + fe.length + 2, 2) > S.maxFlowStringSingleLineLength) {
                  X = de;
                  for (let ce of he) X += ce ? `
`.concat(W).concat(Y).concat(ce) : `
`;
                  X += `
`.concat(Y).concat(re);
                } else X = "".concat(de, " ").concat(he.join(" "), " ").concat(re);
              } else {
                let de = ee.map(b);
                X = de.shift();
                for (let re of de) X += re ? `
`.concat(Y).concat(re) : `
`;
              }
              return this.comment ? (X += `
` + this.comment.replace(/^/gm, "".concat(Y, "#")), _ && _()) : le && v && v(), X;
            }
          };
          e._defineProperty(S, "maxFlowStringSingleLineLength", 60);
          function M(o) {
            let l = o instanceof y ? o.value : o;
            return l && typeof l == "string" && (l = Number(l)), Number.isInteger(l) && l >= 0 ? l : null;
          }
          var T = class extends S {
            add(o) {
              this.items.push(o);
            }
            delete(o) {
              let l = M(o);
              return typeof l != "number" ? false : this.items.splice(l, 1).length > 0;
            }
            get(o, l) {
              let _ = M(o);
              if (typeof _ != "number") return;
              let v = this.items[_];
              return !l && v instanceof y ? v.value : v;
            }
            has(o) {
              let l = M(o);
              return typeof l == "number" && l < this.items.length;
            }
            set(o, l) {
              let _ = M(o);
              if (typeof _ != "number") throw new Error("Expected a valid index, not ".concat(o, "."));
              this.items[_] = l;
            }
            toJSON(o, l) {
              let _ = [];
              l && l.onCreate && l.onCreate(_);
              let v = 0;
              for (let b of this.items) _.push(d(b, String(v++), l));
              return _;
            }
            toString(o, l, _) {
              return o ? super.toString(o, { blockItem: (v) => v.type === "comment" ? v.str : "- ".concat(v.str), flowChars: { start: "[", end: "]" }, isMap: false, itemIndent: (o.indent || "") + "  " }, l, _) : JSON.stringify(this);
            }
          }, P = (o, l, _) => l === null ? "" : typeof l != "object" ? String(l) : o instanceof h && _ && _.doc ? o.toString({ anchors: /* @__PURE__ */ Object.create(null), doc: _.doc, indent: "", indentStep: _.indentStep, inFlow: true, inStringifyKey: true, stringify: _.stringify }) : JSON.stringify(l), C = class extends h {
            constructor(o) {
              let l = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              super(), this.key = o, this.value = l, this.type = C.Type.PAIR;
            }
            get commentBefore() {
              return this.key instanceof h ? this.key.commentBefore : void 0;
            }
            set commentBefore(o) {
              if (this.key == null && (this.key = new y(null)), this.key instanceof h) this.key.commentBefore = o;
              else {
                let l = "Pair.commentBefore is an alias for Pair.key.commentBefore. To set it, the key must be a Node.";
                throw new Error(l);
              }
            }
            addToJSMap(o, l) {
              let _ = d(this.key, "", o);
              if (l instanceof Map) {
                let v = d(this.value, _, o);
                l.set(_, v);
              } else if (l instanceof Set) l.add(_);
              else {
                let v = P(this.key, _, o), b = d(this.value, v, o);
                v in l ? Object.defineProperty(l, v, { value: b, writable: true, enumerable: true, configurable: true }) : l[v] = b;
              }
              return l;
            }
            toJSON(o, l) {
              let _ = l && l.mapAsMap ? /* @__PURE__ */ new Map() : {};
              return this.addToJSMap(l, _);
            }
            toString(o, l, _) {
              if (!o || !o.doc) return JSON.stringify(this);
              let { indent: v, indentSeq: b, simpleKeys: w } = o.doc.options, { key: A, value: N } = this, Y = A instanceof h && A.comment;
              if (w) {
                if (Y) throw new Error("With simple keys, key nodes cannot have comments");
                if (A instanceof S) {
                  let ce = "With simple keys, collection cannot be used as a key value";
                  throw new Error(ce);
                }
              }
              let W = !w && (!A || Y || (A instanceof h ? A instanceof S || A.type === e.Type.BLOCK_FOLDED || A.type === e.Type.BLOCK_LITERAL : typeof A == "object")), { doc: U, indent: H, indentStep: oe, stringify: le } = o;
              o = Object.assign({}, o, { implicitKey: !W, indent: H + oe });
              let Z = false, ee = le(A, o, () => Y = null, () => Z = true);
              if (ee = c(ee, o.indent, Y), !W && ee.length > 1024) {
                if (w) throw new Error("With simple keys, single line scalar must not span more than 1024 characters");
                W = true;
              }
              if (o.allNullValues && !w) return this.comment ? (ee = c(ee, o.indent, this.comment), l && l()) : Z && !Y && _ && _(), o.inFlow && !W ? ee : "? ".concat(ee);
              ee = W ? "? ".concat(ee, `
`).concat(H, ":") : "".concat(ee, ":"), this.comment && (ee = c(ee, o.indent, this.comment), l && l());
              let X = "", de = null;
              if (N instanceof h) {
                if (N.spaceBefore && (X = `
`), N.commentBefore) {
                  let ce = N.commentBefore.replace(/^/gm, "".concat(o.indent, "#"));
                  X += `
`.concat(ce);
                }
                de = N.comment;
              } else N && typeof N == "object" && (N = U.schema.createNode(N, true));
              o.implicitKey = false, !W && !this.comment && N instanceof y && (o.indentAtStart = ee.length + 1), Z = false, !b && v >= 2 && !o.inFlow && !W && N instanceof T && N.type !== e.Type.FLOW_SEQ && !N.tag && !U.anchors.getName(N) && (o.indent = o.indent.substr(2));
              let re = le(N, o, () => de = null, () => Z = true), he = " ";
              return X || this.comment ? he = "".concat(X, `
`).concat(o.indent) : !W && N instanceof S ? (!(re[0] === "[" || re[0] === "{") || re.includes(`
`)) && (he = `
`.concat(o.indent)) : re[0] === `
` && (he = ""), Z && !de && _ && _(), c(ee + he + re, o.indent, de);
            }
          };
          e._defineProperty(C, "Type", { PAIR: "PAIR", MERGE_PAIR: "MERGE_PAIR" });
          var q = (o, l) => {
            if (o instanceof R) {
              let _ = l.get(o.source);
              return _.count * _.aliasCount;
            } else if (o instanceof S) {
              let _ = 0;
              for (let v of o.items) {
                let b = q(v, l);
                b > _ && (_ = b);
              }
              return _;
            } else if (o instanceof C) {
              let _ = q(o.key, l), v = q(o.value, l);
              return Math.max(_, v);
            }
            return 1;
          }, R = class extends h {
            static stringify(o, l) {
              let { range: _, source: v } = o, { anchors: b, doc: w, implicitKey: A, inStringifyKey: N } = l, Y = Object.keys(b).find((U) => b[U] === v);
              if (!Y && N && (Y = w.anchors.getName(v) || w.anchors.newName()), Y) return "*".concat(Y).concat(A ? " " : "");
              let W = w.anchors.getName(v) ? "Alias node must be after source node" : "Source node not found for alias node";
              throw new Error("".concat(W, " [").concat(_, "]"));
            }
            constructor(o) {
              super(), this.source = o, this.type = e.Type.ALIAS;
            }
            set tag(o) {
              throw new Error("Alias nodes cannot have tags");
            }
            toJSON(o, l) {
              if (!l) return d(this.source, o, l);
              let { anchors: _, maxAliasCount: v } = l, b = _.get(this.source);
              if (!b || b.res === void 0) {
                let w = "This should not happen: Alias anchor was not resolved?";
                throw this.cstNode ? new e.YAMLReferenceError(this.cstNode, w) : new ReferenceError(w);
              }
              if (v >= 0 && (b.count += 1, b.aliasCount === 0 && (b.aliasCount = q(this.source, _)), b.count * b.aliasCount > v)) {
                let w = "Excessive alias count indicates a resource exhaustion attack";
                throw this.cstNode ? new e.YAMLReferenceError(this.cstNode, w) : new ReferenceError(w);
              }
              return b.res;
            }
            toString(o) {
              return R.stringify(this, o);
            }
          };
          e._defineProperty(R, "default", true);
          function j(o, l) {
            let _ = l instanceof y ? l.value : l;
            for (let v of o) if (v instanceof C && (v.key === l || v.key === _ || v.key && v.key.value === _)) return v;
          }
          var K = class extends S {
            add(o, l) {
              o ? o instanceof C || (o = new C(o.key || o, o.value)) : o = new C(o);
              let _ = j(this.items, o.key), v = this.schema && this.schema.sortMapEntries;
              if (_) if (l) _.value = o.value;
              else throw new Error("Key ".concat(o.key, " already set"));
              else if (v) {
                let b = this.items.findIndex((w) => v(o, w) < 0);
                b === -1 ? this.items.push(o) : this.items.splice(b, 0, o);
              } else this.items.push(o);
            }
            delete(o) {
              let l = j(this.items, o);
              return l ? this.items.splice(this.items.indexOf(l), 1).length > 0 : false;
            }
            get(o, l) {
              let _ = j(this.items, o), v = _ && _.value;
              return !l && v instanceof y ? v.value : v;
            }
            has(o) {
              return !!j(this.items, o);
            }
            set(o, l) {
              this.add(new C(o, l), true);
            }
            toJSON(o, l, _) {
              let v = _ ? new _() : l && l.mapAsMap ? /* @__PURE__ */ new Map() : {};
              l && l.onCreate && l.onCreate(v);
              for (let b of this.items) b.addToJSMap(l, v);
              return v;
            }
            toString(o, l, _) {
              if (!o) return JSON.stringify(this);
              for (let v of this.items) if (!(v instanceof C)) throw new Error("Map items must all be pairs; found ".concat(JSON.stringify(v), " instead"));
              return super.toString(o, { blockItem: (v) => v.str, flowChars: { start: "{", end: "}" }, isMap: true, itemIndent: o.indent || "" }, l, _);
            }
          }, m = "<<", a = class extends C {
            constructor(o) {
              if (o instanceof C) {
                let l = o.value;
                l instanceof T || (l = new T(), l.items.push(o.value), l.range = o.value.range), super(o.key, l), this.range = o.range;
              } else super(new y(m), new T());
              this.type = C.Type.MERGE_PAIR;
            }
            addToJSMap(o, l) {
              for (let { source: _ } of this.value.items) {
                if (!(_ instanceof K)) throw new Error("Merge sources must be maps");
                let v = _.toJSON(null, o, Map);
                for (let [b, w] of v) l instanceof Map ? l.has(b) || l.set(b, w) : l instanceof Set ? l.add(b) : Object.prototype.hasOwnProperty.call(l, b) || Object.defineProperty(l, b, { value: w, writable: true, enumerable: true, configurable: true });
              }
              return l;
            }
            toString(o, l) {
              let _ = this.value;
              if (_.items.length > 1) return super.toString(o, l);
              this.value = _.items[0];
              let v = super.toString(o, l);
              return this.value = _, v;
            }
          }, t = { defaultType: e.Type.BLOCK_LITERAL, lineWidth: 76 }, s = { trueStr: "true", falseStr: "false" }, i = { asBigInt: false }, f = { nullStr: "null" }, g = { defaultType: e.Type.PLAIN, doubleQuoted: { jsonEncoding: false, minMultiLineLength: 40 }, fold: { lineWidth: 80, minContentWidth: 20 } };
          function u(o, l, _) {
            for (let { format: v, test: b, resolve: w } of l) if (b) {
              let A = o.match(b);
              if (A) {
                let N = w.apply(null, A);
                return N instanceof y || (N = new y(N)), v && (N.format = v), N;
              }
            }
            return _ && (o = _(o)), new y(o);
          }
          var p = "flow", L = "block", k = "quoted", B = (o, l) => {
            let _ = o[l + 1];
            for (; _ === " " || _ === "	"; ) {
              do
                _ = o[l += 1];
              while (_ && _ !== `
`);
              _ = o[l + 1];
            }
            return l;
          };
          function $(o, l, _, v) {
            let { indentAtStart: b, lineWidth: w = 80, minContentWidth: A = 20, onFold: N, onOverflow: Y } = v;
            if (!w || w < 0) return o;
            let W = Math.max(1 + A, 1 + w - l.length);
            if (o.length <= W) return o;
            let U = [], H = {}, oe = w - l.length;
            typeof b == "number" && (b > w - Math.max(2, A) ? U.push(0) : oe = w - b);
            let le, Z, ee = false, X = -1, de = -1, re = -1;
            _ === L && (X = B(o, X), X !== -1 && (oe = X + W));
            for (let ce; ce = o[X += 1]; ) {
              if (_ === k && ce === "\\") {
                switch (de = X, o[X + 1]) {
                  case "x":
                    X += 3;
                    break;
                  case "u":
                    X += 5;
                    break;
                  case "U":
                    X += 9;
                    break;
                  default:
                    X += 1;
                }
                re = X;
              }
              if (ce === `
`) _ === L && (X = B(o, X)), oe = X + W, le = void 0;
              else {
                if (ce === " " && Z && Z !== " " && Z !== `
` && Z !== "	") {
                  let fe = o[X + 1];
                  fe && fe !== " " && fe !== `
` && fe !== "	" && (le = X);
                }
                if (X >= oe) if (le) U.push(le), oe = le + W, le = void 0;
                else if (_ === k) {
                  for (; Z === " " || Z === "	"; ) Z = ce, ce = o[X += 1], ee = true;
                  let fe = X > re + 1 ? X - 2 : de - 1;
                  if (H[fe]) return o;
                  U.push(fe), H[fe] = true, oe = fe + W, le = void 0;
                } else ee = true;
              }
              Z = ce;
            }
            if (ee && Y && Y(), U.length === 0) return o;
            N && N();
            let he = o.slice(0, U[0]);
            for (let ce = 0; ce < U.length; ++ce) {
              let fe = U[ce], Ie = U[ce + 1] || o.length;
              fe === 0 ? he = `
`.concat(l).concat(o.slice(0, Ie)) : (_ === k && H[fe] && (he += "".concat(o[fe], "\\")), he += `
`.concat(l).concat(o.slice(fe + 1, Ie)));
            }
            return he;
          }
          var Q = (o) => {
            let { indentAtStart: l } = o;
            return l ? Object.assign({ indentAtStart: l }, g.fold) : g.fold;
          }, z2 = (o) => /^(%|---|\.\.\.)/m.test(o);
          function ie(o, l, _) {
            if (!l || l < 0) return false;
            let v = l - _, b = o.length;
            if (b <= v) return false;
            for (let w = 0, A = 0; w < b; ++w) if (o[w] === `
`) {
              if (w - A > v) return true;
              if (A = w + 1, b - A <= v) return false;
            }
            return true;
          }
          function ue(o, l) {
            let { implicitKey: _ } = l, { jsonEncoding: v, minMultiLineLength: b } = g.doubleQuoted, w = JSON.stringify(o);
            if (v) return w;
            let A = l.indent || (z2(o) ? "  " : ""), N = "", Y = 0;
            for (let W = 0, U = w[W]; U; U = w[++W]) if (U === " " && w[W + 1] === "\\" && w[W + 2] === "n" && (N += w.slice(Y, W) + "\\ ", W += 1, Y = W, U = "\\"), U === "\\") switch (w[W + 1]) {
              case "u":
                {
                  N += w.slice(Y, W);
                  let H = w.substr(W + 2, 4);
                  switch (H) {
                    case "0000":
                      N += "\\0";
                      break;
                    case "0007":
                      N += "\\a";
                      break;
                    case "000b":
                      N += "\\v";
                      break;
                    case "001b":
                      N += "\\e";
                      break;
                    case "0085":
                      N += "\\N";
                      break;
                    case "00a0":
                      N += "\\_";
                      break;
                    case "2028":
                      N += "\\L";
                      break;
                    case "2029":
                      N += "\\P";
                      break;
                    default:
                      H.substr(0, 2) === "00" ? N += "\\x" + H.substr(2) : N += w.substr(W, 6);
                  }
                  W += 5, Y = W + 1;
                }
                break;
              case "n":
                if (_ || w[W + 2] === '"' || w.length < b) W += 1;
                else {
                  for (N += w.slice(Y, W) + `

`; w[W + 2] === "\\" && w[W + 3] === "n" && w[W + 4] !== '"'; ) N += `
`, W += 2;
                  N += A, w[W + 2] === " " && (N += "\\"), W += 1, Y = W + 1;
                }
                break;
              default:
                W += 1;
            }
            return N = Y ? N + w.slice(Y) : w, _ ? N : $(N, A, k, Q(l));
          }
          function pe(o, l) {
            if (l.implicitKey) {
              if (/\n/.test(o)) return ue(o, l);
            } else if (/[ \t]\n|\n[ \t]/.test(o)) return ue(o, l);
            let _ = l.indent || (z2(o) ? "  " : ""), v = "'" + o.replace(/'/g, "''").replace(/\n+/g, `$&
`.concat(_)) + "'";
            return l.implicitKey ? v : $(v, _, p, Q(l));
          }
          function ge(o, l, _, v) {
            let { comment: b, type: w, value: A } = o;
            if (/\n[\t ]+$/.test(A) || /^\s*$/.test(A)) return ue(A, l);
            let N = l.indent || (l.forceBlockIndent || z2(A) ? "  " : ""), Y = N ? "2" : "1", W = w === e.Type.BLOCK_FOLDED ? false : w === e.Type.BLOCK_LITERAL ? true : !ie(A, g.fold.lineWidth, N.length), U = W ? "|" : ">";
            if (!A) return U + `
`;
            let H = "", oe = "";
            if (A = A.replace(/[\n\t ]*$/, (Z) => {
              let ee = Z.indexOf(`
`);
              return ee === -1 ? U += "-" : (A === Z || ee !== Z.length - 1) && (U += "+", v && v()), oe = Z.replace(/\n$/, ""), "";
            }).replace(/^[\n ]*/, (Z) => {
              Z.indexOf(" ") !== -1 && (U += Y);
              let ee = Z.match(/ +$/);
              return ee ? (H = Z.slice(0, -ee[0].length), ee[0]) : (H = Z, "");
            }), oe && (oe = oe.replace(/\n+(?!\n|$)/g, "$&".concat(N))), H && (H = H.replace(/\n+/g, "$&".concat(N))), b && (U += " #" + b.replace(/ ?[\r\n]+/g, " "), _ && _()), !A) return "".concat(U).concat(Y, `
`).concat(N).concat(oe);
            if (W) return A = A.replace(/\n+/g, "$&".concat(N)), "".concat(U, `
`).concat(N).concat(H).concat(A).concat(oe);
            A = A.replace(/\n+/g, `
$&`).replace(/(?:^|\n)([\t ].*)(?:([\n\t ]*)\n(?![\n\t ]))?/g, "$1$2").replace(/\n+/g, "$&".concat(N));
            let le = $("".concat(H).concat(A).concat(oe), N, L, g.fold);
            return "".concat(U, `
`).concat(N).concat(le);
          }
          function O(o, l, _, v) {
            let { comment: b, type: w, value: A } = o, { actualString: N, implicitKey: Y, indent: W, inFlow: U } = l;
            if (Y && /[\n[\]{},]/.test(A) || U && /[[\]{},]/.test(A)) return ue(A, l);
            if (!A || /^[\n\t ,[\]{}#&*!|>'"%@`]|^[?-]$|^[?-][ \t]|[\n:][ \t]|[ \t]\n|[\n\t ]#|[\n\t :]$/.test(A)) return Y || U || A.indexOf(`
`) === -1 ? A.indexOf('"') !== -1 && A.indexOf("'") === -1 ? pe(A, l) : ue(A, l) : ge(o, l, _, v);
            if (!Y && !U && w !== e.Type.PLAIN && A.indexOf(`
`) !== -1) return ge(o, l, _, v);
            if (W === "" && z2(A)) return l.forceBlockIndent = true, ge(o, l, _, v);
            let H = A.replace(/\n+/g, `$&
`.concat(W));
            if (N) {
              let { tags: le } = l.doc.schema;
              if (typeof u(H, le, le.scalarFallback).value != "string") return ue(A, l);
            }
            let oe = Y ? H : $(H, W, p, Q(l));
            return b && !U && (oe.indexOf(`
`) !== -1 || b.indexOf(`
`) !== -1) ? (_ && _(), n(oe, W, b)) : oe;
          }
          function V(o, l, _, v) {
            let { defaultType: b } = g, { implicitKey: w, inFlow: A } = l, { type: N, value: Y } = o;
            typeof Y != "string" && (Y = String(Y), o = Object.assign({}, o, { value: Y }));
            let W = (H) => {
              switch (H) {
                case e.Type.BLOCK_FOLDED:
                case e.Type.BLOCK_LITERAL:
                  return ge(o, l, _, v);
                case e.Type.QUOTE_DOUBLE:
                  return ue(Y, l);
                case e.Type.QUOTE_SINGLE:
                  return pe(Y, l);
                case e.Type.PLAIN:
                  return O(o, l, _, v);
                default:
                  return null;
              }
            };
            (N !== e.Type.QUOTE_DOUBLE && /[\x00-\x08\x0b-\x1f\x7f-\x9f]/.test(Y) || (w || A) && (N === e.Type.BLOCK_FOLDED || N === e.Type.BLOCK_LITERAL)) && (N = e.Type.QUOTE_DOUBLE);
            let U = W(N);
            if (U === null && (U = W(b), U === null)) throw new Error("Unsupported default string type ".concat(b));
            return U;
          }
          function J(o) {
            let { format: l, minFractionDigits: _, tag: v, value: b } = o;
            if (typeof b == "bigint") return String(b);
            if (!isFinite(b)) return isNaN(b) ? ".nan" : b < 0 ? "-.inf" : ".inf";
            let w = JSON.stringify(b);
            if (!l && _ && (!v || v === "tag:yaml.org,2002:float") && /^\d/.test(w)) {
              let A = w.indexOf(".");
              A < 0 && (A = w.length, w += ".");
              let N = _ - (w.length - A - 1);
              for (; N-- > 0; ) w += "0";
            }
            return w;
          }
          function x(o, l) {
            let _, v;
            switch (l.type) {
              case e.Type.FLOW_MAP:
                _ = "}", v = "flow map";
                break;
              case e.Type.FLOW_SEQ:
                _ = "]", v = "flow sequence";
                break;
              default:
                o.push(new e.YAMLSemanticError(l, "Not a flow collection!?"));
                return;
            }
            let b;
            for (let w = l.items.length - 1; w >= 0; --w) {
              let A = l.items[w];
              if (!A || A.type !== e.Type.COMMENT) {
                b = A;
                break;
              }
            }
            if (b && b.char !== _) {
              let w = "Expected ".concat(v, " to end with ").concat(_), A;
              typeof b.offset == "number" ? (A = new e.YAMLSemanticError(l, w), A.offset = b.offset + 1) : (A = new e.YAMLSemanticError(b, w), b.range && b.range.end && (A.offset = b.range.end - b.range.start)), o.push(A);
            }
          }
          function G(o, l) {
            let _ = l.context.src[l.range.start - 1];
            if (_ !== `
` && _ !== "	" && _ !== " ") {
              let v = "Comments must be separated from other tokens by white space characters";
              o.push(new e.YAMLSemanticError(l, v));
            }
          }
          function ne(o, l) {
            let _ = String(l), v = _.substr(0, 8) + "..." + _.substr(-8);
            return new e.YAMLSemanticError(o, 'The "'.concat(v, '" key is too long'));
          }
          function _e(o, l) {
            for (let { afterKey: _, before: v, comment: b } of l) {
              let w = o.items[v];
              w ? (_ && w.value && (w = w.value), b === void 0 ? (_ || !w.commentBefore) && (w.spaceBefore = true) : w.commentBefore ? w.commentBefore += `
` + b : w.commentBefore = b) : b !== void 0 && (o.comment ? o.comment += `
` + b : o.comment = b);
            }
          }
          function ye(o, l) {
            let _ = l.strValue;
            return _ ? typeof _ == "string" ? _ : (_.errors.forEach((v) => {
              v.source || (v.source = l), o.errors.push(v);
            }), _.str) : "";
          }
          function be(o, l) {
            let { handle: _, suffix: v } = l.tag, b = o.tagPrefixes.find((w) => w.handle === _);
            if (!b) {
              let w = o.getDefaults().tagPrefixes;
              if (w && (b = w.find((A) => A.handle === _)), !b) throw new e.YAMLSemanticError(l, "The ".concat(_, " tag handle is non-default and was not declared."));
            }
            if (!v) throw new e.YAMLSemanticError(l, "The ".concat(_, " tag has no suffix."));
            if (_ === "!" && (o.version || o.options.version) === "1.0") {
              if (v[0] === "^") return o.warnings.push(new e.YAMLWarning(l, "YAML 1.0 ^ tag expansion is not supported")), v;
              if (/[:/]/.test(v)) {
                let w = v.match(/^([a-z0-9-]+)\/(.*)/i);
                return w ? "tag:".concat(w[1], ".yaml.org,2002:").concat(w[2]) : "tag:".concat(v);
              }
            }
            return b.prefix + decodeURIComponent(v);
          }
          function ve(o, l) {
            let { tag: _, type: v } = l, b = false;
            if (_) {
              let { handle: w, suffix: A, verbatim: N } = _;
              if (N) {
                if (N !== "!" && N !== "!!") return N;
                let Y = "Verbatim tags aren't resolved, so ".concat(N, " is invalid.");
                o.errors.push(new e.YAMLSemanticError(l, Y));
              } else if (w === "!" && !A) b = true;
              else try {
                return be(o, l);
              } catch (Y) {
                o.errors.push(Y);
              }
            }
            switch (v) {
              case e.Type.BLOCK_FOLDED:
              case e.Type.BLOCK_LITERAL:
              case e.Type.QUOTE_DOUBLE:
              case e.Type.QUOTE_SINGLE:
                return e.defaultTags.STR;
              case e.Type.FLOW_MAP:
              case e.Type.MAP:
                return e.defaultTags.MAP;
              case e.Type.FLOW_SEQ:
              case e.Type.SEQ:
                return e.defaultTags.SEQ;
              case e.Type.PLAIN:
                return b ? e.defaultTags.STR : null;
              default:
                return null;
            }
          }
          function Ne(o, l, _) {
            let { tags: v } = o.schema, b = [];
            for (let A of v) if (A.tag === _) if (A.test) b.push(A);
            else {
              let N = A.resolve(o, l);
              return N instanceof S ? N : new y(N);
            }
            let w = ye(o, l);
            return typeof w == "string" && b.length > 0 ? u(w, b, v.scalarFallback) : null;
          }
          function Pe(o) {
            let { type: l } = o;
            switch (l) {
              case e.Type.FLOW_MAP:
              case e.Type.MAP:
                return e.defaultTags.MAP;
              case e.Type.FLOW_SEQ:
              case e.Type.SEQ:
                return e.defaultTags.SEQ;
              default:
                return e.defaultTags.STR;
            }
          }
          function ct(o, l, _) {
            try {
              let v = Ne(o, l, _);
              if (v) return _ && l.tag && (v.tag = _), v;
            } catch (v) {
              return v.source || (v.source = l), o.errors.push(v), null;
            }
            try {
              let v = Pe(l);
              if (!v) throw new Error("The tag ".concat(_, " is unavailable"));
              let b = "The tag ".concat(_, " is unavailable, falling back to ").concat(v);
              o.warnings.push(new e.YAMLWarning(l, b));
              let w = Ne(o, l, v);
              return w.tag = _, w;
            } catch (v) {
              let b = new e.YAMLReferenceError(l, v.message);
              return b.stack = v.stack, o.errors.push(b), null;
            }
          }
          var ut = (o) => {
            if (!o) return false;
            let { type: l } = o;
            return l === e.Type.MAP_KEY || l === e.Type.MAP_VALUE || l === e.Type.SEQ_ITEM;
          };
          function ft(o, l) {
            let _ = { before: [], after: [] }, v = false, b = false, w = ut(l.context.parent) ? l.context.parent.props.concat(l.props) : l.props;
            for (let { start: A, end: N } of w) switch (l.context.src[A]) {
              case e.Char.COMMENT: {
                if (!l.commentHasRequiredWhitespace(A)) {
                  let H = "Comments must be separated from other tokens by white space characters";
                  o.push(new e.YAMLSemanticError(l, H));
                }
                let { header: Y, valueRange: W } = l;
                (W && (A > W.start || Y && A > Y.start) ? _.after : _.before).push(l.context.src.slice(A + 1, N));
                break;
              }
              case e.Char.ANCHOR:
                if (v) {
                  let Y = "A node can have at most one anchor";
                  o.push(new e.YAMLSemanticError(l, Y));
                }
                v = true;
                break;
              case e.Char.TAG:
                if (b) {
                  let Y = "A node can have at most one tag";
                  o.push(new e.YAMLSemanticError(l, Y));
                }
                b = true;
                break;
            }
            return { comments: _, hasAnchor: v, hasTag: b };
          }
          function mt(o, l) {
            let { anchors: _, errors: v, schema: b } = o;
            if (l.type === e.Type.ALIAS) {
              let A = l.rawValue, N = _.getNode(A);
              if (!N) {
                let W = "Aliased anchor not found: ".concat(A);
                return v.push(new e.YAMLReferenceError(l, W)), null;
              }
              let Y = new R(N);
              return _._cstAliases.push(Y), Y;
            }
            let w = ve(o, l);
            if (w) return ct(o, l, w);
            if (l.type !== e.Type.PLAIN) {
              let A = "Failed to resolve ".concat(l.type, " node here");
              return v.push(new e.YAMLSyntaxError(l, A)), null;
            }
            try {
              let A = ye(o, l);
              return u(A, b.tags, b.tags.scalarFallback);
            } catch (A) {
              return A.source || (A.source = l), v.push(A), null;
            }
          }
          function we(o, l) {
            if (!l) return null;
            l.error && o.errors.push(l.error);
            let { comments: _, hasAnchor: v, hasTag: b } = ft(o.errors, l);
            if (v) {
              let { anchors: A } = o, N = l.anchor, Y = A.getNode(N);
              Y && (A.map[A.newName(N)] = Y), A.map[N] = l;
            }
            if (l.type === e.Type.ALIAS && (v || b)) {
              let A = "An alias node must not specify any properties";
              o.errors.push(new e.YAMLSemanticError(l, A));
            }
            let w = mt(o, l);
            if (w) {
              w.range = [l.range.start, l.range.end], o.options.keepCstNodes && (w.cstNode = l), o.options.keepNodeTypes && (w.type = l.type);
              let A = _.before.join(`
`);
              A && (w.commentBefore = w.commentBefore ? "".concat(w.commentBefore, `
`).concat(A) : A);
              let N = _.after.join(`
`);
              N && (w.comment = w.comment ? "".concat(w.comment, `
`).concat(N) : N);
            }
            return l.resolved = w;
          }
          function dt(o, l) {
            if (l.type !== e.Type.MAP && l.type !== e.Type.FLOW_MAP) {
              let A = "A ".concat(l.type, " node cannot be resolved as a mapping");
              return o.errors.push(new e.YAMLSyntaxError(l, A)), null;
            }
            let { comments: _, items: v } = l.type === e.Type.FLOW_MAP ? _t(o, l) : pt(o, l), b = new K();
            b.items = v, _e(b, _);
            let w = false;
            for (let A = 0; A < v.length; ++A) {
              let { key: N } = v[A];
              if (N instanceof S && (w = true), o.schema.merge && N && N.value === m) {
                v[A] = new a(v[A]);
                let Y = v[A].value.items, W = null;
                Y.some((U) => {
                  if (U instanceof R) {
                    let { type: H } = U.source;
                    return H === e.Type.MAP || H === e.Type.FLOW_MAP ? false : W = "Merge nodes aliases can only point to maps";
                  }
                  return W = "Merge nodes can only have Alias nodes as values";
                }), W && o.errors.push(new e.YAMLSemanticError(l, W));
              } else for (let Y = A + 1; Y < v.length; ++Y) {
                let { key: W } = v[Y];
                if (N === W || N && W && Object.prototype.hasOwnProperty.call(N, "value") && N.value === W.value) {
                  let U = 'Map keys must be unique; "'.concat(N, '" is repeated');
                  o.errors.push(new e.YAMLSemanticError(l, U));
                  break;
                }
              }
            }
            if (w && !o.options.mapAsMap) {
              let A = "Keys with collection values will be stringified as YAML due to JS Object restrictions. Use mapAsMap: true to avoid this.";
              o.warnings.push(new e.YAMLWarning(l, A));
            }
            return l.resolved = b, b;
          }
          var ht = (o) => {
            let { context: { lineStart: l, node: _, src: v }, props: b } = o;
            if (b.length === 0) return false;
            let { start: w } = b[0];
            if (_ && w > _.valueRange.start || v[w] !== e.Char.COMMENT) return false;
            for (let A = l; A < w; ++A) if (v[A] === `
`) return false;
            return true;
          };
          function gt(o, l) {
            if (!ht(o)) return;
            let _ = o.getPropValue(0, e.Char.COMMENT, true), v = false, b = l.value.commentBefore;
            if (b && b.startsWith(_)) l.value.commentBefore = b.substr(_.length + 1), v = true;
            else {
              let w = l.value.comment;
              !o.node && w && w.startsWith(_) && (l.value.comment = w.substr(_.length + 1), v = true);
            }
            v && (l.comment = _);
          }
          function pt(o, l) {
            let _ = [], v = [], b, w = null;
            for (let A = 0; A < l.items.length; ++A) {
              let N = l.items[A];
              switch (N.type) {
                case e.Type.BLANK_LINE:
                  _.push({ afterKey: !!b, before: v.length });
                  break;
                case e.Type.COMMENT:
                  _.push({ afterKey: !!b, before: v.length, comment: N.comment });
                  break;
                case e.Type.MAP_KEY:
                  b !== void 0 && v.push(new C(b)), N.error && o.errors.push(N.error), b = we(o, N.node), w = null;
                  break;
                case e.Type.MAP_VALUE:
                  {
                    if (b === void 0 && (b = null), N.error && o.errors.push(N.error), !N.context.atLineStart && N.node && N.node.type === e.Type.MAP && !N.node.context.atLineStart) {
                      let U = "Nested mappings are not allowed in compact mappings";
                      o.errors.push(new e.YAMLSemanticError(N.node, U));
                    }
                    let Y = N.node;
                    if (!Y && N.props.length > 0) {
                      Y = new e.PlainValue(e.Type.PLAIN, []), Y.context = { parent: N, src: N.context.src };
                      let U = N.range.start + 1;
                      if (Y.range = { start: U, end: U }, Y.valueRange = { start: U, end: U }, typeof N.range.origStart == "number") {
                        let H = N.range.origStart + 1;
                        Y.range.origStart = Y.range.origEnd = H, Y.valueRange.origStart = Y.valueRange.origEnd = H;
                      }
                    }
                    let W = new C(b, we(o, Y));
                    gt(N, W), v.push(W), b && typeof w == "number" && N.range.start > w + 1024 && o.errors.push(ne(l, b)), b = void 0, w = null;
                  }
                  break;
                default:
                  b !== void 0 && v.push(new C(b)), b = we(o, N), w = N.range.start, N.error && o.errors.push(N.error);
                  e: for (let Y = A + 1; ; ++Y) {
                    let W = l.items[Y];
                    switch (W && W.type) {
                      case e.Type.BLANK_LINE:
                      case e.Type.COMMENT:
                        continue e;
                      case e.Type.MAP_VALUE:
                        break e;
                      default: {
                        let U = "Implicit map keys need to be followed by map values";
                        o.errors.push(new e.YAMLSemanticError(N, U));
                        break e;
                      }
                    }
                  }
                  if (N.valueRangeContainsNewline) {
                    let Y = "Implicit map keys need to be on a single line";
                    o.errors.push(new e.YAMLSemanticError(N, Y));
                  }
              }
            }
            return b !== void 0 && v.push(new C(b)), { comments: _, items: v };
          }
          function _t(o, l) {
            let _ = [], v = [], b, w = false, A = "{";
            for (let N = 0; N < l.items.length; ++N) {
              let Y = l.items[N];
              if (typeof Y.char == "string") {
                let { char: W, offset: U } = Y;
                if (W === "?" && b === void 0 && !w) {
                  w = true, A = ":";
                  continue;
                }
                if (W === ":") {
                  if (b === void 0 && (b = null), A === ":") {
                    A = ",";
                    continue;
                  }
                } else if (w && (b === void 0 && W !== "," && (b = null), w = false), b !== void 0 && (v.push(new C(b)), b = void 0, W === ",")) {
                  A = ":";
                  continue;
                }
                if (W === "}") {
                  if (N === l.items.length - 1) continue;
                } else if (W === A) {
                  A = ":";
                  continue;
                }
                let H = "Flow map contains an unexpected ".concat(W), oe = new e.YAMLSyntaxError(l, H);
                oe.offset = U, o.errors.push(oe);
              } else Y.type === e.Type.BLANK_LINE ? _.push({ afterKey: !!b, before: v.length }) : Y.type === e.Type.COMMENT ? (G(o.errors, Y), _.push({ afterKey: !!b, before: v.length, comment: Y.comment })) : b === void 0 ? (A === "," && o.errors.push(new e.YAMLSemanticError(Y, "Separator , missing in flow map")), b = we(o, Y)) : (A !== "," && o.errors.push(new e.YAMLSemanticError(Y, "Indicator : missing in flow map entry")), v.push(new C(b, we(o, Y))), b = void 0, w = false);
            }
            return x(o.errors, l), b !== void 0 && v.push(new C(b)), { comments: _, items: v };
          }
          function vt(o, l) {
            if (l.type !== e.Type.SEQ && l.type !== e.Type.FLOW_SEQ) {
              let w = "A ".concat(l.type, " node cannot be resolved as a sequence");
              return o.errors.push(new e.YAMLSyntaxError(l, w)), null;
            }
            let { comments: _, items: v } = l.type === e.Type.FLOW_SEQ ? bt(o, l) : yt(o, l), b = new T();
            if (b.items = v, _e(b, _), !o.options.mapAsMap && v.some((w) => w instanceof C && w.key instanceof S)) {
              let w = "Keys with collection values will be stringified as YAML due to JS Object restrictions. Use mapAsMap: true to avoid this.";
              o.warnings.push(new e.YAMLWarning(l, w));
            }
            return l.resolved = b, b;
          }
          function yt(o, l) {
            let _ = [], v = [];
            for (let b = 0; b < l.items.length; ++b) {
              let w = l.items[b];
              switch (w.type) {
                case e.Type.BLANK_LINE:
                  _.push({ before: v.length });
                  break;
                case e.Type.COMMENT:
                  _.push({ comment: w.comment, before: v.length });
                  break;
                case e.Type.SEQ_ITEM:
                  if (w.error && o.errors.push(w.error), v.push(we(o, w.node)), w.hasProps) {
                    let A = "Sequence items cannot have tags or anchors before the - indicator";
                    o.errors.push(new e.YAMLSemanticError(w, A));
                  }
                  break;
                default:
                  w.error && o.errors.push(w.error), o.errors.push(new e.YAMLSyntaxError(w, "Unexpected ".concat(w.type, " node in sequence")));
              }
            }
            return { comments: _, items: v };
          }
          function bt(o, l) {
            let _ = [], v = [], b = false, w, A = null, N = "[", Y = null;
            for (let W = 0; W < l.items.length; ++W) {
              let U = l.items[W];
              if (typeof U.char == "string") {
                let { char: H, offset: oe } = U;
                if (H !== ":" && (b || w !== void 0) && (b && w === void 0 && (w = N ? v.pop() : null), v.push(new C(w)), b = false, w = void 0, A = null), H === N) N = null;
                else if (!N && H === "?") b = true;
                else if (N !== "[" && H === ":" && w === void 0) {
                  if (N === ",") {
                    if (w = v.pop(), w instanceof C) {
                      let le = "Chaining flow sequence pairs is invalid", Z = new e.YAMLSemanticError(l, le);
                      Z.offset = oe, o.errors.push(Z);
                    }
                    if (!b && typeof A == "number") {
                      let le = U.range ? U.range.start : U.offset;
                      le > A + 1024 && o.errors.push(ne(l, w));
                      let { src: Z } = Y.context;
                      for (let ee = A; ee < le; ++ee) if (Z[ee] === `
`) {
                        let X = "Implicit keys of flow sequence pairs need to be on a single line";
                        o.errors.push(new e.YAMLSemanticError(Y, X));
                        break;
                      }
                    }
                  } else w = null;
                  A = null, b = false, N = null;
                } else if (N === "[" || H !== "]" || W < l.items.length - 1) {
                  let le = "Flow sequence contains an unexpected ".concat(H), Z = new e.YAMLSyntaxError(l, le);
                  Z.offset = oe, o.errors.push(Z);
                }
              } else if (U.type === e.Type.BLANK_LINE) _.push({ before: v.length });
              else if (U.type === e.Type.COMMENT) G(o.errors, U), _.push({ comment: U.comment, before: v.length });
              else {
                if (N) {
                  let oe = "Expected a ".concat(N, " in flow sequence");
                  o.errors.push(new e.YAMLSemanticError(U, oe));
                }
                let H = we(o, U);
                w === void 0 ? (v.push(H), Y = U) : (v.push(new C(w, H)), w = void 0), A = U.range.start, N = ",";
              }
            }
            return x(o.errors, l), w !== void 0 && v.push(new C(w)), { comments: _, items: v };
          }
          r.Alias = R, r.Collection = S, r.Merge = a, r.Node = h, r.Pair = C, r.Scalar = y, r.YAMLMap = K, r.YAMLSeq = T, r.addComment = c, r.binaryOptions = t, r.boolOptions = s, r.findPair = j, r.intOptions = i, r.isEmptyPath = I, r.nullOptions = f, r.resolveMap = dt, r.resolveNode = we, r.resolveSeq = vt, r.resolveString = ye, r.strOptions = g, r.stringifyNumber = J, r.stringifyString = V, r.toJSON = d;
        } }), it = F({ "node_modules/yaml/dist/warnings-1000a372.js"(r) {
          "use strict";
          D();
          var e = Me(), n = ke(), c = { identify: (u) => u instanceof Uint8Array, default: false, tag: "tag:yaml.org,2002:binary", resolve: (u, p) => {
            let L = n.resolveString(u, p);
            if (typeof Buffer == "function") return Buffer.from(L, "base64");
            if (typeof atob == "function") {
              let k = atob(L.replace(/[\n\r]/g, "")), B = new Uint8Array(k.length);
              for (let $ = 0; $ < k.length; ++$) B[$] = k.charCodeAt($);
              return B;
            } else {
              let k = "This environment does not support reading binary tags; either Buffer or atob is required";
              return u.errors.push(new e.YAMLReferenceError(p, k)), null;
            }
          }, options: n.binaryOptions, stringify: (u, p, L, k) => {
            let { comment: B, type: $, value: Q } = u, z2;
            if (typeof Buffer == "function") z2 = Q instanceof Buffer ? Q.toString("base64") : Buffer.from(Q.buffer).toString("base64");
            else if (typeof btoa == "function") {
              let ie = "";
              for (let ue = 0; ue < Q.length; ++ue) ie += String.fromCharCode(Q[ue]);
              z2 = btoa(ie);
            } else throw new Error("This environment does not support writing binary tags; either Buffer or btoa is required");
            if ($ || ($ = n.binaryOptions.defaultType), $ === e.Type.QUOTE_DOUBLE) Q = z2;
            else {
              let { lineWidth: ie } = n.binaryOptions, ue = Math.ceil(z2.length / ie), pe = new Array(ue);
              for (let ge = 0, O = 0; ge < ue; ++ge, O += ie) pe[ge] = z2.substr(O, ie);
              Q = pe.join($ === e.Type.BLOCK_LITERAL ? `
` : " ");
            }
            return n.stringifyString({ comment: B, type: $, value: Q }, p, L, k);
          } };
          function h(u, p) {
            let L = n.resolveSeq(u, p);
            for (let k = 0; k < L.items.length; ++k) {
              let B = L.items[k];
              if (!(B instanceof n.Pair)) {
                if (B instanceof n.YAMLMap) {
                  if (B.items.length > 1) {
                    let Q = "Each pair must have its own sequence indicator";
                    throw new e.YAMLSemanticError(p, Q);
                  }
                  let $ = B.items[0] || new n.Pair();
                  B.commentBefore && ($.commentBefore = $.commentBefore ? "".concat(B.commentBefore, `
`).concat($.commentBefore) : B.commentBefore), B.comment && ($.comment = $.comment ? "".concat(B.comment, `
`).concat($.comment) : B.comment), B = $;
                }
                L.items[k] = B instanceof n.Pair ? B : new n.Pair(B);
              }
            }
            return L;
          }
          function d(u, p, L) {
            let k = new n.YAMLSeq(u);
            k.tag = "tag:yaml.org,2002:pairs";
            for (let B of p) {
              let $, Q;
              if (Array.isArray(B)) if (B.length === 2) $ = B[0], Q = B[1];
              else throw new TypeError("Expected [key, value] tuple: ".concat(B));
              else if (B && B instanceof Object) {
                let ie = Object.keys(B);
                if (ie.length === 1) $ = ie[0], Q = B[$];
                else throw new TypeError("Expected { key: value } tuple: ".concat(B));
              } else $ = B;
              let z2 = u.createPair($, Q, L);
              k.items.push(z2);
            }
            return k;
          }
          var y = { default: false, tag: "tag:yaml.org,2002:pairs", resolve: h, createNode: d }, E = class extends n.YAMLSeq {
            constructor() {
              super(), e._defineProperty(this, "add", n.YAMLMap.prototype.add.bind(this)), e._defineProperty(this, "delete", n.YAMLMap.prototype.delete.bind(this)), e._defineProperty(this, "get", n.YAMLMap.prototype.get.bind(this)), e._defineProperty(this, "has", n.YAMLMap.prototype.has.bind(this)), e._defineProperty(this, "set", n.YAMLMap.prototype.set.bind(this)), this.tag = E.tag;
            }
            toJSON(u, p) {
              let L = /* @__PURE__ */ new Map();
              p && p.onCreate && p.onCreate(L);
              for (let k of this.items) {
                let B, $;
                if (k instanceof n.Pair ? (B = n.toJSON(k.key, "", p), $ = n.toJSON(k.value, B, p)) : B = n.toJSON(k, "", p), L.has(B)) throw new Error("Ordered maps must not include duplicate keys");
                L.set(B, $);
              }
              return L;
            }
          };
          e._defineProperty(E, "tag", "tag:yaml.org,2002:omap");
          function I(u, p) {
            let L = h(u, p), k = [];
            for (let { key: B } of L.items) if (B instanceof n.Scalar) if (k.includes(B.value)) {
              let $ = "Ordered maps must not include duplicate keys";
              throw new e.YAMLSemanticError(p, $);
            } else k.push(B.value);
            return Object.assign(new E(), L);
          }
          function S(u, p, L) {
            let k = d(u, p, L), B = new E();
            return B.items = k.items, B;
          }
          var M = { identify: (u) => u instanceof Map, nodeClass: E, default: false, tag: "tag:yaml.org,2002:omap", resolve: I, createNode: S }, T = class extends n.YAMLMap {
            constructor() {
              super(), this.tag = T.tag;
            }
            add(u) {
              let p = u instanceof n.Pair ? u : new n.Pair(u);
              n.findPair(this.items, p.key) || this.items.push(p);
            }
            get(u, p) {
              let L = n.findPair(this.items, u);
              return !p && L instanceof n.Pair ? L.key instanceof n.Scalar ? L.key.value : L.key : L;
            }
            set(u, p) {
              if (typeof p != "boolean") throw new Error("Expected boolean value for set(key, value) in a YAML set, not ".concat(typeof p));
              let L = n.findPair(this.items, u);
              L && !p ? this.items.splice(this.items.indexOf(L), 1) : !L && p && this.items.push(new n.Pair(u));
            }
            toJSON(u, p) {
              return super.toJSON(u, p, Set);
            }
            toString(u, p, L) {
              if (!u) return JSON.stringify(this);
              if (this.hasAllNullValues()) return super.toString(u, p, L);
              throw new Error("Set items must all have null values");
            }
          };
          e._defineProperty(T, "tag", "tag:yaml.org,2002:set");
          function P(u, p) {
            let L = n.resolveMap(u, p);
            if (!L.hasAllNullValues()) throw new e.YAMLSemanticError(p, "Set items must all have null values");
            return Object.assign(new T(), L);
          }
          function C(u, p, L) {
            let k = new T();
            for (let B of p) k.items.push(u.createPair(B, null, L));
            return k;
          }
          var q = { identify: (u) => u instanceof Set, nodeClass: T, default: false, tag: "tag:yaml.org,2002:set", resolve: P, createNode: C }, R = (u, p) => {
            let L = p.split(":").reduce((k, B) => k * 60 + Number(B), 0);
            return u === "-" ? -L : L;
          }, j = (u) => {
            let { value: p } = u;
            if (isNaN(p) || !isFinite(p)) return n.stringifyNumber(p);
            let L = "";
            p < 0 && (L = "-", p = Math.abs(p));
            let k = [p % 60];
            return p < 60 ? k.unshift(0) : (p = Math.round((p - k[0]) / 60), k.unshift(p % 60), p >= 60 && (p = Math.round((p - k[0]) / 60), k.unshift(p))), L + k.map((B) => B < 10 ? "0" + String(B) : String(B)).join(":").replace(/000000\d*$/, "");
          }, K = { identify: (u) => typeof u == "number", default: true, tag: "tag:yaml.org,2002:int", format: "TIME", test: /^([-+]?)([0-9][0-9_]*(?::[0-5]?[0-9])+)$/, resolve: (u, p, L) => R(p, L.replace(/_/g, "")), stringify: j }, m = { identify: (u) => typeof u == "number", default: true, tag: "tag:yaml.org,2002:float", format: "TIME", test: /^([-+]?)([0-9][0-9_]*(?::[0-5]?[0-9])+\.[0-9_]*)$/, resolve: (u, p, L) => R(p, L.replace(/_/g, "")), stringify: j }, a = { identify: (u) => u instanceof Date, default: true, tag: "tag:yaml.org,2002:timestamp", test: RegExp("^(?:([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})(?:(?:t|T|[ \\t]+)([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2}(\\.[0-9]+)?)(?:[ \\t]*(Z|[-+][012]?[0-9](?::[0-9]{2})?))?)?)$"), resolve: (u, p, L, k, B, $, Q, z2, ie) => {
            z2 && (z2 = (z2 + "00").substr(1, 3));
            let ue = Date.UTC(p, L - 1, k, B || 0, $ || 0, Q || 0, z2 || 0);
            if (ie && ie !== "Z") {
              let pe = R(ie[0], ie.slice(1));
              Math.abs(pe) < 30 && (pe *= 60), ue -= 6e4 * pe;
            }
            return new Date(ue);
          }, stringify: (u) => {
            let { value: p } = u;
            return p.toISOString().replace(/((T00:00)?:00)?\.000Z$/, "");
          } };
          function t(u) {
            let p = typeof Te < "u" && Te.env || {};
            return u ? typeof YAML_SILENCE_DEPRECATION_WARNINGS < "u" ? !YAML_SILENCE_DEPRECATION_WARNINGS : !p.YAML_SILENCE_DEPRECATION_WARNINGS : typeof YAML_SILENCE_WARNINGS < "u" ? !YAML_SILENCE_WARNINGS : !p.YAML_SILENCE_WARNINGS;
          }
          function s(u, p) {
            if (t(false)) {
              let L = typeof Te < "u" && Te.emitWarning;
              L ? L(u, p) : console.warn(p ? "".concat(p, ": ").concat(u) : u);
            }
          }
          function i(u) {
            if (t(true)) {
              let p = u.replace(/.*yaml[/\\]/i, "").replace(/\.js$/, "").replace(/\\/g, "/");
              s("The endpoint 'yaml/".concat(p, "' will be removed in a future release."), "DeprecationWarning");
            }
          }
          var f = {};
          function g(u, p) {
            if (!f[u] && t(true)) {
              f[u] = true;
              let L = "The option '".concat(u, "' will be removed in a future release");
              L += p ? ", use '".concat(p, "' instead.") : ".", s(L, "DeprecationWarning");
            }
          }
          r.binary = c, r.floatTime = m, r.intTime = K, r.omap = M, r.pairs = y, r.set = q, r.timestamp = a, r.warn = s, r.warnFileDeprecation = i, r.warnOptionDeprecation = g;
        } }), ot = F({ "node_modules/yaml/dist/Schema-88e323a7.js"(r) {
          "use strict";
          D();
          var e = Me(), n = ke(), c = it();
          function h(O, V, J) {
            let x = new n.YAMLMap(O);
            if (V instanceof Map) for (let [G, ne] of V) x.items.push(O.createPair(G, ne, J));
            else if (V && typeof V == "object") for (let G of Object.keys(V)) x.items.push(O.createPair(G, V[G], J));
            return typeof O.sortMapEntries == "function" && x.items.sort(O.sortMapEntries), x;
          }
          var d = { createNode: h, default: true, nodeClass: n.YAMLMap, tag: "tag:yaml.org,2002:map", resolve: n.resolveMap };
          function y(O, V, J) {
            let x = new n.YAMLSeq(O);
            if (V && V[Symbol.iterator]) for (let G of V) {
              let ne = O.createNode(G, J.wrapScalars, null, J);
              x.items.push(ne);
            }
            return x;
          }
          var E = { createNode: y, default: true, nodeClass: n.YAMLSeq, tag: "tag:yaml.org,2002:seq", resolve: n.resolveSeq }, I = { identify: (O) => typeof O == "string", default: true, tag: "tag:yaml.org,2002:str", resolve: n.resolveString, stringify(O, V, J, x) {
            return V = Object.assign({ actualString: true }, V), n.stringifyString(O, V, J, x);
          }, options: n.strOptions }, S = [d, E, I], M = (O) => typeof O == "bigint" || Number.isInteger(O), T = (O, V, J) => n.intOptions.asBigInt ? BigInt(O) : parseInt(V, J);
          function P(O, V, J) {
            let { value: x } = O;
            return M(x) && x >= 0 ? J + x.toString(V) : n.stringifyNumber(O);
          }
          var C = { identify: (O) => O == null, createNode: (O, V, J) => J.wrapScalars ? new n.Scalar(null) : null, default: true, tag: "tag:yaml.org,2002:null", test: /^(?:~|[Nn]ull|NULL)?$/, resolve: () => null, options: n.nullOptions, stringify: () => n.nullOptions.nullStr }, q = { identify: (O) => typeof O == "boolean", default: true, tag: "tag:yaml.org,2002:bool", test: /^(?:[Tt]rue|TRUE|[Ff]alse|FALSE)$/, resolve: (O) => O[0] === "t" || O[0] === "T", options: n.boolOptions, stringify: (O) => {
            let { value: V } = O;
            return V ? n.boolOptions.trueStr : n.boolOptions.falseStr;
          } }, R = { identify: (O) => M(O) && O >= 0, default: true, tag: "tag:yaml.org,2002:int", format: "OCT", test: /^0o([0-7]+)$/, resolve: (O, V) => T(O, V, 8), options: n.intOptions, stringify: (O) => P(O, 8, "0o") }, j = { identify: M, default: true, tag: "tag:yaml.org,2002:int", test: /^[-+]?[0-9]+$/, resolve: (O) => T(O, O, 10), options: n.intOptions, stringify: n.stringifyNumber }, K = { identify: (O) => M(O) && O >= 0, default: true, tag: "tag:yaml.org,2002:int", format: "HEX", test: /^0x([0-9a-fA-F]+)$/, resolve: (O, V) => T(O, V, 16), options: n.intOptions, stringify: (O) => P(O, 16, "0x") }, m = { identify: (O) => typeof O == "number", default: true, tag: "tag:yaml.org,2002:float", test: /^(?:[-+]?\.inf|(\.nan))$/i, resolve: (O, V) => V ? NaN : O[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY, stringify: n.stringifyNumber }, a = { identify: (O) => typeof O == "number", default: true, tag: "tag:yaml.org,2002:float", format: "EXP", test: /^[-+]?(?:\.[0-9]+|[0-9]+(?:\.[0-9]*)?)[eE][-+]?[0-9]+$/, resolve: (O) => parseFloat(O), stringify: (O) => {
            let { value: V } = O;
            return Number(V).toExponential();
          } }, t = { identify: (O) => typeof O == "number", default: true, tag: "tag:yaml.org,2002:float", test: /^[-+]?(?:\.([0-9]+)|[0-9]+\.([0-9]*))$/, resolve(O, V, J) {
            let x = V || J, G = new n.Scalar(parseFloat(O));
            return x && x[x.length - 1] === "0" && (G.minFractionDigits = x.length), G;
          }, stringify: n.stringifyNumber }, s = S.concat([C, q, R, j, K, m, a, t]), i = (O) => typeof O == "bigint" || Number.isInteger(O), f = (O) => {
            let { value: V } = O;
            return JSON.stringify(V);
          }, g = [d, E, { identify: (O) => typeof O == "string", default: true, tag: "tag:yaml.org,2002:str", resolve: n.resolveString, stringify: f }, { identify: (O) => O == null, createNode: (O, V, J) => J.wrapScalars ? new n.Scalar(null) : null, default: true, tag: "tag:yaml.org,2002:null", test: /^null$/, resolve: () => null, stringify: f }, { identify: (O) => typeof O == "boolean", default: true, tag: "tag:yaml.org,2002:bool", test: /^true|false$/, resolve: (O) => O === "true", stringify: f }, { identify: i, default: true, tag: "tag:yaml.org,2002:int", test: /^-?(?:0|[1-9][0-9]*)$/, resolve: (O) => n.intOptions.asBigInt ? BigInt(O) : parseInt(O, 10), stringify: (O) => {
            let { value: V } = O;
            return i(V) ? V.toString() : JSON.stringify(V);
          } }, { identify: (O) => typeof O == "number", default: true, tag: "tag:yaml.org,2002:float", test: /^-?(?:0|[1-9][0-9]*)(?:\.[0-9]*)?(?:[eE][-+]?[0-9]+)?$/, resolve: (O) => parseFloat(O), stringify: f }];
          g.scalarFallback = (O) => {
            throw new SyntaxError("Unresolved plain scalar ".concat(JSON.stringify(O)));
          };
          var u = (O) => {
            let { value: V } = O;
            return V ? n.boolOptions.trueStr : n.boolOptions.falseStr;
          }, p = (O) => typeof O == "bigint" || Number.isInteger(O);
          function L(O, V, J) {
            let x = V.replace(/_/g, "");
            if (n.intOptions.asBigInt) {
              switch (J) {
                case 2:
                  x = "0b".concat(x);
                  break;
                case 8:
                  x = "0o".concat(x);
                  break;
                case 16:
                  x = "0x".concat(x);
                  break;
              }
              let ne = BigInt(x);
              return O === "-" ? BigInt(-1) * ne : ne;
            }
            let G = parseInt(x, J);
            return O === "-" ? -1 * G : G;
          }
          function k(O, V, J) {
            let { value: x } = O;
            if (p(x)) {
              let G = x.toString(V);
              return x < 0 ? "-" + J + G.substr(1) : J + G;
            }
            return n.stringifyNumber(O);
          }
          var B = S.concat([{ identify: (O) => O == null, createNode: (O, V, J) => J.wrapScalars ? new n.Scalar(null) : null, default: true, tag: "tag:yaml.org,2002:null", test: /^(?:~|[Nn]ull|NULL)?$/, resolve: () => null, options: n.nullOptions, stringify: () => n.nullOptions.nullStr }, { identify: (O) => typeof O == "boolean", default: true, tag: "tag:yaml.org,2002:bool", test: /^(?:Y|y|[Yy]es|YES|[Tt]rue|TRUE|[Oo]n|ON)$/, resolve: () => true, options: n.boolOptions, stringify: u }, { identify: (O) => typeof O == "boolean", default: true, tag: "tag:yaml.org,2002:bool", test: /^(?:N|n|[Nn]o|NO|[Ff]alse|FALSE|[Oo]ff|OFF)$/i, resolve: () => false, options: n.boolOptions, stringify: u }, { identify: p, default: true, tag: "tag:yaml.org,2002:int", format: "BIN", test: /^([-+]?)0b([0-1_]+)$/, resolve: (O, V, J) => L(V, J, 2), stringify: (O) => k(O, 2, "0b") }, { identify: p, default: true, tag: "tag:yaml.org,2002:int", format: "OCT", test: /^([-+]?)0([0-7_]+)$/, resolve: (O, V, J) => L(V, J, 8), stringify: (O) => k(O, 8, "0") }, { identify: p, default: true, tag: "tag:yaml.org,2002:int", test: /^([-+]?)([0-9][0-9_]*)$/, resolve: (O, V, J) => L(V, J, 10), stringify: n.stringifyNumber }, { identify: p, default: true, tag: "tag:yaml.org,2002:int", format: "HEX", test: /^([-+]?)0x([0-9a-fA-F_]+)$/, resolve: (O, V, J) => L(V, J, 16), stringify: (O) => k(O, 16, "0x") }, { identify: (O) => typeof O == "number", default: true, tag: "tag:yaml.org,2002:float", test: /^(?:[-+]?\.inf|(\.nan))$/i, resolve: (O, V) => V ? NaN : O[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY, stringify: n.stringifyNumber }, { identify: (O) => typeof O == "number", default: true, tag: "tag:yaml.org,2002:float", format: "EXP", test: /^[-+]?([0-9][0-9_]*)?(\.[0-9_]*)?[eE][-+]?[0-9]+$/, resolve: (O) => parseFloat(O.replace(/_/g, "")), stringify: (O) => {
            let { value: V } = O;
            return Number(V).toExponential();
          } }, { identify: (O) => typeof O == "number", default: true, tag: "tag:yaml.org,2002:float", test: /^[-+]?(?:[0-9][0-9_]*)?\.([0-9_]*)$/, resolve(O, V) {
            let J = new n.Scalar(parseFloat(O.replace(/_/g, "")));
            if (V) {
              let x = V.replace(/_/g, "");
              x[x.length - 1] === "0" && (J.minFractionDigits = x.length);
            }
            return J;
          }, stringify: n.stringifyNumber }], c.binary, c.omap, c.pairs, c.set, c.intTime, c.floatTime, c.timestamp), $ = { core: s, failsafe: S, json: g, yaml11: B }, Q = { binary: c.binary, bool: q, float: t, floatExp: a, floatNaN: m, floatTime: c.floatTime, int: j, intHex: K, intOct: R, intTime: c.intTime, map: d, null: C, omap: c.omap, pairs: c.pairs, seq: E, set: c.set, timestamp: c.timestamp };
          function z2(O, V, J) {
            if (V) {
              let x = J.filter((ne) => ne.tag === V), G = x.find((ne) => !ne.format) || x[0];
              if (!G) throw new Error("Tag ".concat(V, " not found"));
              return G;
            }
            return J.find((x) => (x.identify && x.identify(O) || x.class && O instanceof x.class) && !x.format);
          }
          function ie(O, V, J) {
            if (O instanceof n.Node) return O;
            let { defaultPrefix: x, onTagObj: G, prevObjects: ne, schema: _e, wrapScalars: ye } = J;
            V && V.startsWith("!!") && (V = x + V.slice(2));
            let be = z2(O, V, _e.tags);
            if (!be) {
              if (typeof O.toJSON == "function" && (O = O.toJSON()), !O || typeof O != "object") return ye ? new n.Scalar(O) : O;
              be = O instanceof Map ? d : O[Symbol.iterator] ? E : d;
            }
            G && (G(be), delete J.onTagObj);
            let ve = { value: void 0, node: void 0 };
            if (O && typeof O == "object" && ne) {
              let Ne = ne.get(O);
              if (Ne) {
                let Pe = new n.Alias(Ne);
                return J.aliasNodes.push(Pe), Pe;
              }
              ve.value = O, ne.set(O, ve);
            }
            return ve.node = be.createNode ? be.createNode(J.schema, O, J) : ye ? new n.Scalar(O) : O, V && ve.node instanceof n.Node && (ve.node.tag = V), ve.node;
          }
          function ue(O, V, J, x) {
            let G = O[x.replace(/\W/g, "")];
            if (!G) {
              let ne = Object.keys(O).map((_e) => JSON.stringify(_e)).join(", ");
              throw new Error('Unknown schema "'.concat(x, '"; use one of ').concat(ne));
            }
            if (Array.isArray(J)) for (let ne of J) G = G.concat(ne);
            else typeof J == "function" && (G = J(G.slice()));
            for (let ne = 0; ne < G.length; ++ne) {
              let _e = G[ne];
              if (typeof _e == "string") {
                let ye = V[_e];
                if (!ye) {
                  let be = Object.keys(V).map((ve) => JSON.stringify(ve)).join(", ");
                  throw new Error('Unknown custom tag "'.concat(_e, '"; use one of ').concat(be));
                }
                G[ne] = ye;
              }
            }
            return G;
          }
          var pe = (O, V) => O.key < V.key ? -1 : O.key > V.key ? 1 : 0, ge = class {
            constructor(O) {
              let { customTags: V, merge: J, schema: x, sortMapEntries: G, tags: ne } = O;
              this.merge = !!J, this.name = x, this.sortMapEntries = G === true ? pe : G || null, !V && ne && c.warnOptionDeprecation("tags", "customTags"), this.tags = ue($, Q, V || ne, x);
            }
            createNode(O, V, J, x) {
              let G = { defaultPrefix: ge.defaultPrefix, schema: this, wrapScalars: V }, ne = x ? Object.assign(x, G) : G;
              return ie(O, J, ne);
            }
            createPair(O, V, J) {
              J || (J = { wrapScalars: true });
              let x = this.createNode(O, J.wrapScalars, null, J), G = this.createNode(V, J.wrapScalars, null, J);
              return new n.Pair(x, G);
            }
          };
          e._defineProperty(ge, "defaultPrefix", e.defaultTagPrefix), e._defineProperty(ge, "defaultTags", e.defaultTags), r.Schema = ge;
        } }), zn = F({ "node_modules/yaml/dist/Document-9b4560a1.js"(r) {
          "use strict";
          D();
          var e = Me(), n = ke(), c = ot(), h = { anchorPrefix: "a", customTags: null, indent: 2, indentSeq: true, keepCstNodes: false, keepNodeTypes: true, keepBlobsInJSON: true, mapAsMap: false, maxAliasCount: 100, prettyErrors: false, simpleKeys: false, version: "1.2" }, d = { get binary() {
            return n.binaryOptions;
          }, set binary(t) {
            Object.assign(n.binaryOptions, t);
          }, get bool() {
            return n.boolOptions;
          }, set bool(t) {
            Object.assign(n.boolOptions, t);
          }, get int() {
            return n.intOptions;
          }, set int(t) {
            Object.assign(n.intOptions, t);
          }, get null() {
            return n.nullOptions;
          }, set null(t) {
            Object.assign(n.nullOptions, t);
          }, get str() {
            return n.strOptions;
          }, set str(t) {
            Object.assign(n.strOptions, t);
          } }, y = { "1.0": { schema: "yaml-1.1", merge: true, tagPrefixes: [{ handle: "!", prefix: e.defaultTagPrefix }, { handle: "!!", prefix: "tag:private.yaml.org,2002:" }] }, 1.1: { schema: "yaml-1.1", merge: true, tagPrefixes: [{ handle: "!", prefix: "!" }, { handle: "!!", prefix: e.defaultTagPrefix }] }, 1.2: { schema: "core", merge: false, tagPrefixes: [{ handle: "!", prefix: "!" }, { handle: "!!", prefix: e.defaultTagPrefix }] } };
          function E(t, s) {
            if ((t.version || t.options.version) === "1.0") {
              let g = s.match(/^tag:private\.yaml\.org,2002:([^:/]+)$/);
              if (g) return "!" + g[1];
              let u = s.match(/^tag:([a-zA-Z0-9-]+)\.yaml\.org,2002:(.*)/);
              return u ? "!".concat(u[1], "/").concat(u[2]) : "!".concat(s.replace(/^tag:/, ""));
            }
            let i = t.tagPrefixes.find((g) => s.indexOf(g.prefix) === 0);
            if (!i) {
              let g = t.getDefaults().tagPrefixes;
              i = g && g.find((u) => s.indexOf(u.prefix) === 0);
            }
            if (!i) return s[0] === "!" ? s : "!<".concat(s, ">");
            let f = s.substr(i.prefix.length).replace(/[!,[\]{}]/g, (g) => ({ "!": "%21", ",": "%2C", "[": "%5B", "]": "%5D", "{": "%7B", "}": "%7D" })[g]);
            return i.handle + f;
          }
          function I(t, s) {
            if (s instanceof n.Alias) return n.Alias;
            if (s.tag) {
              let g = t.filter((u) => u.tag === s.tag);
              if (g.length > 0) return g.find((u) => u.format === s.format) || g[0];
            }
            let i, f;
            if (s instanceof n.Scalar) {
              f = s.value;
              let g = t.filter((u) => u.identify && u.identify(f) || u.class && f instanceof u.class);
              i = g.find((u) => u.format === s.format) || g.find((u) => !u.format);
            } else f = s, i = t.find((g) => g.nodeClass && f instanceof g.nodeClass);
            if (!i) {
              let g = f && f.constructor ? f.constructor.name : typeof f;
              throw new Error("Tag not resolved for ".concat(g, " value"));
            }
            return i;
          }
          function S(t, s, i) {
            let { anchors: f, doc: g } = i, u = [], p = g.anchors.getName(t);
            return p && (f[p] = t, u.push("&".concat(p))), t.tag ? u.push(E(g, t.tag)) : s.default || u.push(E(g, s.tag)), u.join(" ");
          }
          function M(t, s, i, f) {
            let { anchors: g, schema: u } = s.doc, p;
            if (!(t instanceof n.Node)) {
              let B = { aliasNodes: [], onTagObj: ($) => p = $, prevObjects: /* @__PURE__ */ new Map() };
              t = u.createNode(t, true, null, B);
              for (let $ of B.aliasNodes) {
                $.source = $.source.node;
                let Q = g.getName($.source);
                Q || (Q = g.newName(), g.map[Q] = $.source);
              }
            }
            if (t instanceof n.Pair) return t.toString(s, i, f);
            p || (p = I(u.tags, t));
            let L = S(t, p, s);
            L.length > 0 && (s.indentAtStart = (s.indentAtStart || 0) + L.length + 1);
            let k = typeof p.stringify == "function" ? p.stringify(t, s, i, f) : t instanceof n.Scalar ? n.stringifyString(t, s, i, f) : t.toString(s, i, f);
            return L ? t instanceof n.Scalar || k[0] === "{" || k[0] === "[" ? "".concat(L, " ").concat(k) : "".concat(L, `
`).concat(s.indent).concat(k) : k;
          }
          var T = class {
            static validAnchorNode(t) {
              return t instanceof n.Scalar || t instanceof n.YAMLSeq || t instanceof n.YAMLMap;
            }
            constructor(t) {
              e._defineProperty(this, "map", /* @__PURE__ */ Object.create(null)), this.prefix = t;
            }
            createAlias(t, s) {
              return this.setAnchor(t, s), new n.Alias(t);
            }
            createMergePair() {
              let t = new n.Merge();
              for (var s = arguments.length, i = new Array(s), f = 0; f < s; f++) i[f] = arguments[f];
              return t.value.items = i.map((g) => {
                if (g instanceof n.Alias) {
                  if (g.source instanceof n.YAMLMap) return g;
                } else if (g instanceof n.YAMLMap) return this.createAlias(g);
                throw new Error("Merge sources must be Map nodes or their Aliases");
              }), t;
            }
            getName(t) {
              let { map: s } = this;
              return Object.keys(s).find((i) => s[i] === t);
            }
            getNames() {
              return Object.keys(this.map);
            }
            getNode(t) {
              return this.map[t];
            }
            newName(t) {
              t || (t = this.prefix);
              let s = Object.keys(this.map);
              for (let i = 1; ; ++i) {
                let f = "".concat(t).concat(i);
                if (!s.includes(f)) return f;
              }
            }
            resolveNodes() {
              let { map: t, _cstAliases: s } = this;
              Object.keys(t).forEach((i) => {
                t[i] = t[i].resolved;
              }), s.forEach((i) => {
                i.source = i.source.resolved;
              }), delete this._cstAliases;
            }
            setAnchor(t, s) {
              if (t != null && !T.validAnchorNode(t)) throw new Error("Anchors may only be set for Scalar, Seq and Map nodes");
              if (s && /[\x00-\x19\s,[\]{}]/.test(s)) throw new Error("Anchor names must not contain whitespace or control characters");
              let { map: i } = this, f = t && Object.keys(i).find((g) => i[g] === t);
              if (f) if (s) f !== s && (delete i[f], i[s] = t);
              else return f;
              else {
                if (!s) {
                  if (!t) return null;
                  s = this.newName();
                }
                i[s] = t;
              }
              return s;
            }
          }, P = (t, s) => {
            if (t && typeof t == "object") {
              let { tag: i } = t;
              t instanceof n.Collection ? (i && (s[i] = true), t.items.forEach((f) => P(f, s))) : t instanceof n.Pair ? (P(t.key, s), P(t.value, s)) : t instanceof n.Scalar && i && (s[i] = true);
            }
            return s;
          }, C = (t) => Object.keys(P(t, {}));
          function q(t, s) {
            let i = { before: [], after: [] }, f, g = false;
            for (let u of s) if (u.valueRange) {
              if (f !== void 0) {
                let L = "Document contains trailing content not separated by a ... or --- line";
                t.errors.push(new e.YAMLSyntaxError(u, L));
                break;
              }
              let p = n.resolveNode(t, u);
              g && (p.spaceBefore = true, g = false), f = p;
            } else u.comment !== null ? (f === void 0 ? i.before : i.after).push(u.comment) : u.type === e.Type.BLANK_LINE && (g = true, f === void 0 && i.before.length > 0 && !t.commentBefore && (t.commentBefore = i.before.join(`
`), i.before = []));
            if (t.contents = f || null, !f) t.comment = i.before.concat(i.after).join(`
`) || null;
            else {
              let u = i.before.join(`
`);
              if (u) {
                let p = f instanceof n.Collection && f.items[0] ? f.items[0] : f;
                p.commentBefore = p.commentBefore ? "".concat(u, `
`).concat(p.commentBefore) : u;
              }
              t.comment = i.after.join(`
`) || null;
            }
          }
          function R(t, s) {
            let { tagPrefixes: i } = t, [f, g] = s.parameters;
            if (!f || !g) {
              let u = "Insufficient parameters given for %TAG directive";
              throw new e.YAMLSemanticError(s, u);
            }
            if (i.some((u) => u.handle === f)) {
              let u = "The %TAG directive must only be given at most once per handle in the same document.";
              throw new e.YAMLSemanticError(s, u);
            }
            return { handle: f, prefix: g };
          }
          function j(t, s) {
            let [i] = s.parameters;
            if (s.name === "YAML:1.0" && (i = "1.0"), !i) {
              let f = "Insufficient parameters given for %YAML directive";
              throw new e.YAMLSemanticError(s, f);
            }
            if (!y[i]) {
              let f = t.version || t.options.version, g = "Document will be parsed as YAML ".concat(f, " rather than YAML ").concat(i);
              t.warnings.push(new e.YAMLWarning(s, g));
            }
            return i;
          }
          function K(t, s, i) {
            let f = [], g = false;
            for (let u of s) {
              let { comment: p, name: L } = u;
              switch (L) {
                case "TAG":
                  try {
                    t.tagPrefixes.push(R(t, u));
                  } catch (k) {
                    t.errors.push(k);
                  }
                  g = true;
                  break;
                case "YAML":
                case "YAML:1.0":
                  if (t.version) {
                    let k = "The %YAML directive must only be given at most once per document.";
                    t.errors.push(new e.YAMLSemanticError(u, k));
                  }
                  try {
                    t.version = j(t, u);
                  } catch (k) {
                    t.errors.push(k);
                  }
                  g = true;
                  break;
                default:
                  if (L) {
                    let k = "YAML only supports %TAG and %YAML directives, and not %".concat(L);
                    t.warnings.push(new e.YAMLWarning(u, k));
                  }
              }
              p && f.push(p);
            }
            if (i && !g && (t.version || i.version || t.options.version) === "1.1") {
              let u = (p) => {
                let { handle: L, prefix: k } = p;
                return { handle: L, prefix: k };
              };
              t.tagPrefixes = i.tagPrefixes.map(u), t.version = i.version;
            }
            t.commentBefore = f.join(`
`) || null;
          }
          function m(t) {
            if (t instanceof n.Collection) return true;
            throw new Error("Expected a YAML collection as document contents");
          }
          var a = class {
            constructor(t) {
              this.anchors = new T(t.anchorPrefix), this.commentBefore = null, this.comment = null, this.contents = null, this.directivesEndMarker = null, this.errors = [], this.options = t, this.schema = null, this.tagPrefixes = [], this.version = null, this.warnings = [];
            }
            add(t) {
              return m(this.contents), this.contents.add(t);
            }
            addIn(t, s) {
              m(this.contents), this.contents.addIn(t, s);
            }
            delete(t) {
              return m(this.contents), this.contents.delete(t);
            }
            deleteIn(t) {
              return n.isEmptyPath(t) ? this.contents == null ? false : (this.contents = null, true) : (m(this.contents), this.contents.deleteIn(t));
            }
            getDefaults() {
              return a.defaults[this.version] || a.defaults[this.options.version] || {};
            }
            get(t, s) {
              return this.contents instanceof n.Collection ? this.contents.get(t, s) : void 0;
            }
            getIn(t, s) {
              return n.isEmptyPath(t) ? !s && this.contents instanceof n.Scalar ? this.contents.value : this.contents : this.contents instanceof n.Collection ? this.contents.getIn(t, s) : void 0;
            }
            has(t) {
              return this.contents instanceof n.Collection ? this.contents.has(t) : false;
            }
            hasIn(t) {
              return n.isEmptyPath(t) ? this.contents !== void 0 : this.contents instanceof n.Collection ? this.contents.hasIn(t) : false;
            }
            set(t, s) {
              m(this.contents), this.contents.set(t, s);
            }
            setIn(t, s) {
              n.isEmptyPath(t) ? this.contents = s : (m(this.contents), this.contents.setIn(t, s));
            }
            setSchema(t, s) {
              if (!t && !s && this.schema) return;
              typeof t == "number" && (t = t.toFixed(1)), t === "1.0" || t === "1.1" || t === "1.2" ? (this.version ? this.version = t : this.options.version = t, delete this.options.schema) : t && typeof t == "string" && (this.options.schema = t), Array.isArray(s) && (this.options.customTags = s);
              let i = Object.assign({}, this.getDefaults(), this.options);
              this.schema = new c.Schema(i);
            }
            parse(t, s) {
              this.options.keepCstNodes && (this.cstNode = t), this.options.keepNodeTypes && (this.type = "DOCUMENT");
              let { directives: i = [], contents: f = [], directivesEndMarker: g, error: u, valueRange: p } = t;
              if (u && (u.source || (u.source = this), this.errors.push(u)), K(this, i, s), g && (this.directivesEndMarker = true), this.range = p ? [p.start, p.end] : null, this.setSchema(), this.anchors._cstAliases = [], q(this, f), this.anchors.resolveNodes(), this.options.prettyErrors) {
                for (let L of this.errors) L instanceof e.YAMLError && L.makePretty();
                for (let L of this.warnings) L instanceof e.YAMLError && L.makePretty();
              }
              return this;
            }
            listNonDefaultTags() {
              return C(this.contents).filter((t) => t.indexOf(c.Schema.defaultPrefix) !== 0);
            }
            setTagPrefix(t, s) {
              if (t[0] !== "!" || t[t.length - 1] !== "!") throw new Error("Handle must start and end with !");
              if (s) {
                let i = this.tagPrefixes.find((f) => f.handle === t);
                i ? i.prefix = s : this.tagPrefixes.push({ handle: t, prefix: s });
              } else this.tagPrefixes = this.tagPrefixes.filter((i) => i.handle !== t);
            }
            toJSON(t, s) {
              let { keepBlobsInJSON: i, mapAsMap: f, maxAliasCount: g } = this.options, u = i && (typeof t != "string" || !(this.contents instanceof n.Scalar)), p = { doc: this, indentStep: "  ", keep: u, mapAsMap: u && !!f, maxAliasCount: g, stringify: M }, L = Object.keys(this.anchors.map);
              L.length > 0 && (p.anchors = new Map(L.map((B) => [this.anchors.map[B], { alias: [], aliasCount: 0, count: 1 }])));
              let k = n.toJSON(this.contents, t, p);
              if (typeof s == "function" && p.anchors) for (let { count: B, res: $ } of p.anchors.values()) s($, B);
              return k;
            }
            toString() {
              if (this.errors.length > 0) throw new Error("Document with errors cannot be stringified");
              let t = this.options.indent;
              if (!Number.isInteger(t) || t <= 0) {
                let L = JSON.stringify(t);
                throw new Error('"indent" option must be a positive integer, not '.concat(L));
              }
              this.setSchema();
              let s = [], i = false;
              if (this.version) {
                let L = "%YAML 1.2";
                this.schema.name === "yaml-1.1" && (this.version === "1.0" ? L = "%YAML:1.0" : this.version === "1.1" && (L = "%YAML 1.1")), s.push(L), i = true;
              }
              let f = this.listNonDefaultTags();
              this.tagPrefixes.forEach((L) => {
                let { handle: k, prefix: B } = L;
                f.some(($) => $.indexOf(B) === 0) && (s.push("%TAG ".concat(k, " ").concat(B)), i = true);
              }), (i || this.directivesEndMarker) && s.push("---"), this.commentBefore && ((i || !this.directivesEndMarker) && s.unshift(""), s.unshift(this.commentBefore.replace(/^/gm, "#")));
              let g = { anchors: /* @__PURE__ */ Object.create(null), doc: this, indent: "", indentStep: " ".repeat(t), stringify: M }, u = false, p = null;
              if (this.contents) {
                this.contents instanceof n.Node && (this.contents.spaceBefore && (i || this.directivesEndMarker) && s.push(""), this.contents.commentBefore && s.push(this.contents.commentBefore.replace(/^/gm, "#")), g.forceBlockIndent = !!this.comment, p = this.contents.comment);
                let L = p ? null : () => u = true, k = M(this.contents, g, () => p = null, L);
                s.push(n.addComment(k, "", p));
              } else this.contents !== void 0 && s.push(M(this.contents, g));
              return this.comment && ((!u || p) && s[s.length - 1] !== "" && s.push(""), s.push(this.comment.replace(/^/gm, "#"))), s.join(`
`) + `
`;
            }
          };
          e._defineProperty(a, "defaults", y), r.Document = a, r.defaultOptions = h, r.scalarOptions = d;
        } }), Zn = F({ "node_modules/yaml/dist/index.js"(r) {
          "use strict";
          D();
          var e = Gn(), n = zn(), c = ot(), h = Me(), d = it();
          ke();
          function y(C) {
            let q = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true, R = arguments.length > 2 ? arguments[2] : void 0;
            R === void 0 && typeof q == "string" && (R = q, q = true);
            let j = Object.assign({}, n.Document.defaults[n.defaultOptions.version], n.defaultOptions);
            return new c.Schema(j).createNode(C, q, R);
          }
          var E = class extends n.Document {
            constructor(C) {
              super(Object.assign({}, n.defaultOptions, C));
            }
          };
          function I(C, q) {
            let R = [], j;
            for (let K of e.parse(C)) {
              let m = new E(q);
              m.parse(K, j), R.push(m), j = m;
            }
            return R;
          }
          function S(C, q) {
            let R = e.parse(C), j = new E(q).parse(R[0]);
            if (R.length > 1) {
              let K = "Source contains multiple documents; please use YAML.parseAllDocuments()";
              j.errors.unshift(new h.YAMLSemanticError(R[1], K));
            }
            return j;
          }
          function M(C, q) {
            let R = S(C, q);
            if (R.warnings.forEach((j) => d.warn(j)), R.errors.length > 0) throw R.errors[0];
            return R.toJSON();
          }
          function T(C, q) {
            let R = new E(q);
            return R.contents = C, String(R);
          }
          var P = { createNode: y, defaultOptions: n.defaultOptions, Document: E, parse: M, parseAllDocuments: I, parseCST: e.parse, parseDocument: S, scalarOptions: n.scalarOptions, stringify: T };
          r.YAML = P;
        } }), Je = F({ "node_modules/yaml/index.js"(r, e) {
          D(), e.exports = Zn().YAML;
        } }), Xn = F({ "node_modules/yaml/dist/util.js"(r) {
          "use strict";
          D();
          var e = ke(), n = Me();
          r.findPair = e.findPair, r.parseMap = e.resolveMap, r.parseSeq = e.resolveSeq, r.stringifyNumber = e.stringifyNumber, r.stringifyString = e.stringifyString, r.toJSON = e.toJSON, r.Type = n.Type, r.YAMLError = n.YAMLError, r.YAMLReferenceError = n.YAMLReferenceError, r.YAMLSemanticError = n.YAMLSemanticError, r.YAMLSyntaxError = n.YAMLSyntaxError, r.YAMLWarning = n.YAMLWarning;
        } }), er = F({ "node_modules/yaml/util.js"(r) {
          D();
          var e = Xn();
          r.findPair = e.findPair, r.toJSON = e.toJSON, r.parseMap = e.parseMap, r.parseSeq = e.parseSeq, r.stringifyNumber = e.stringifyNumber, r.stringifyString = e.stringifyString, r.Type = e.Type, r.YAMLError = e.YAMLError, r.YAMLReferenceError = e.YAMLReferenceError, r.YAMLSemanticError = e.YAMLSemanticError, r.YAMLSyntaxError = e.YAMLSyntaxError, r.YAMLWarning = e.YAMLWarning;
        } }), tr = F({ "node_modules/yaml-unist-parser/lib/yaml.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = Je();
          r.Document = e.Document;
          var n = Je();
          r.parseCST = n.parseCST;
          var c = er();
          r.YAMLError = c.YAMLError, r.YAMLSyntaxError = c.YAMLSyntaxError, r.YAMLSemanticError = c.YAMLSemanticError;
        } }), nr = F({ "node_modules/yaml-unist-parser/lib/parse.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = xt(), n = Gt(), c = zt(), h = Zt(), d = Fn(), y = ze(), E = Vn(), I = Un(), S = Kn(), M = $n(), T = Jn(), P = Hn(), C = tr();
          function q(R) {
            var j = C.parseCST(R);
            M.addOrigRange(j);
            for (var K = j.map(function(k) {
              return new C.Document({ merge: false, keepCstNodes: true }).parse(k);
            }), m = new e.default(R), a = [], t = { text: R, locator: m, comments: a, transformOffset: function(k) {
              return I.transformOffset(k, t);
            }, transformRange: function(k) {
              return S.transformRange(k, t);
            }, transformNode: function(k) {
              return d.transformNode(k, t);
            }, transformContent: function(k) {
              return y.transformContent(k, t);
            } }, s = 0, i = K; s < i.length; s++) for (var f = i[s], g = 0, u = f.errors; g < u.length; g++) {
              var p = u[g];
              if (!(p instanceof C.YAMLSemanticError && p.message === 'Map keys must be unique; "<<" is repeated')) throw E.transformError(p, t);
            }
            K.forEach(function(k) {
              return h.removeCstBlankLine(k.cstNode);
            });
            var L = c.createRoot(t.transformRange({ origStart: 0, origEnd: t.text.length }), K.map(t.transformNode), a);
            return n.attachComments(L), P.updatePositions(L), T.removeFakeNodes(L), L;
          }
          r.parse = q;
        } }), rr = F({ "node_modules/yaml-unist-parser/lib/index.js"(r) {
          "use strict";
          D(), r.__esModule = true;
          var e = (ae(), se(te));
          e.__exportStar(nr(), r);
        } });
        D();
        var sr = Lt(), { hasPragma: ar } = At(), { locStart: ir, locEnd: or } = Nt();
        function lr(r) {
          let { parse: e } = rr();
          try {
            let n = e(r);
            return delete n.comments, n;
          } catch (n) {
            throw n != null && n.position ? sr(n.message, n.position) : n;
          }
        }
        var cr = { astFormat: "yaml", parse: lr, hasPragma: ar, locStart: ir, locEnd: or };
        lt.exports = { parsers: { yaml: cr } };
      });
      return ur();
    });
  }
});

// ../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/index.js
var require_prettier = __commonJS({
  "../../../node_modules/.pnpm/prettier@2.7.1/node_modules/prettier/index.js"(exports2, module2) {
    "use strict";
    var __getOwnPropNames2 = Object.getOwnPropertyNames;
    var __commonJS2 = (cb, mod) => function __require() {
      return mod || (0, cb[__getOwnPropNames2(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
    };
    var require_global = __commonJS2({
      "node_modules/core-js/internals/global.js"(exports22, module22) {
        var check = function(it) {
          return it && it.Math == Math && it;
        };
        module22.exports = check(typeof globalThis == "object" && globalThis) || check(typeof window == "object" && window) || check(typeof self == "object" && self) || check(typeof global == "object" && global) || /* @__PURE__ */ function() {
          return this;
        }() || Function("return this")();
      }
    });
    var require_fails = __commonJS2({
      "node_modules/core-js/internals/fails.js"(exports22, module22) {
        module22.exports = function(exec) {
          try {
            return !!exec();
          } catch (error) {
            return true;
          }
        };
      }
    });
    var require_descriptors = __commonJS2({
      "node_modules/core-js/internals/descriptors.js"(exports22, module22) {
        var fails = require_fails();
        module22.exports = !fails(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      }
    });
    var require_function_bind_native = __commonJS2({
      "node_modules/core-js/internals/function-bind-native.js"(exports22, module22) {
        var fails = require_fails();
        module22.exports = !fails(function() {
          var test = function() {
          }.bind();
          return typeof test != "function" || test.hasOwnProperty("prototype");
        });
      }
    });
    var require_function_call = __commonJS2({
      "node_modules/core-js/internals/function-call.js"(exports22, module22) {
        var NATIVE_BIND = require_function_bind_native();
        var call = Function.prototype.call;
        module22.exports = NATIVE_BIND ? call.bind(call) : function() {
          return call.apply(call, arguments);
        };
      }
    });
    var require_object_property_is_enumerable = __commonJS2({
      "node_modules/core-js/internals/object-property-is-enumerable.js"(exports22) {
        "use strict";
        var $propertyIsEnumerable = {}.propertyIsEnumerable;
        var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
        var NASHORN_BUG = getOwnPropertyDescriptor && !$propertyIsEnumerable.call({ 1: 2 }, 1);
        exports22.f = NASHORN_BUG ? function propertyIsEnumerable3(V) {
          var descriptor = getOwnPropertyDescriptor(this, V);
          return !!descriptor && descriptor.enumerable;
        } : $propertyIsEnumerable;
      }
    });
    var require_create_property_descriptor = __commonJS2({
      "node_modules/core-js/internals/create-property-descriptor.js"(exports22, module22) {
        module22.exports = function(bitmap, value) {
          return {
            enumerable: !(bitmap & 1),
            configurable: !(bitmap & 2),
            writable: !(bitmap & 4),
            value
          };
        };
      }
    });
    var require_function_uncurry_this = __commonJS2({
      "node_modules/core-js/internals/function-uncurry-this.js"(exports22, module22) {
        var NATIVE_BIND = require_function_bind_native();
        var FunctionPrototype = Function.prototype;
        var bind = FunctionPrototype.bind;
        var call = FunctionPrototype.call;
        var uncurryThis = NATIVE_BIND && bind.bind(call, call);
        module22.exports = NATIVE_BIND ? function(fn) {
          return fn && uncurryThis(fn);
        } : function(fn) {
          return fn && function() {
            return call.apply(fn, arguments);
          };
        };
      }
    });
    var require_classof_raw = __commonJS2({
      "node_modules/core-js/internals/classof-raw.js"(exports22, module22) {
        var uncurryThis = require_function_uncurry_this();
        var toString4 = uncurryThis({}.toString);
        var stringSlice = uncurryThis("".slice);
        module22.exports = function(it) {
          return stringSlice(toString4(it), 8, -1);
        };
      }
    });
    var require_indexed_object = __commonJS2({
      "node_modules/core-js/internals/indexed-object.js"(exports22, module22) {
        var global2 = require_global();
        var uncurryThis = require_function_uncurry_this();
        var fails = require_fails();
        var classof = require_classof_raw();
        var Object2 = global2.Object;
        var split = uncurryThis("".split);
        module22.exports = fails(function() {
          return !Object2("z").propertyIsEnumerable(0);
        }) ? function(it) {
          return classof(it) == "String" ? split(it, "") : Object2(it);
        } : Object2;
      }
    });
    var require_require_object_coercible = __commonJS2({
      "node_modules/core-js/internals/require-object-coercible.js"(exports22, module22) {
        var global2 = require_global();
        var TypeError2 = global2.TypeError;
        module22.exports = function(it) {
          if (it == void 0)
            throw TypeError2("Can't call method on " + it);
          return it;
        };
      }
    });
    var require_to_indexed_object = __commonJS2({
      "node_modules/core-js/internals/to-indexed-object.js"(exports22, module22) {
        var IndexedObject = require_indexed_object();
        var requireObjectCoercible = require_require_object_coercible();
        module22.exports = function(it) {
          return IndexedObject(requireObjectCoercible(it));
        };
      }
    });
    var require_is_callable = __commonJS2({
      "node_modules/core-js/internals/is-callable.js"(exports22, module22) {
        module22.exports = function(argument) {
          return typeof argument == "function";
        };
      }
    });
    var require_is_object = __commonJS2({
      "node_modules/core-js/internals/is-object.js"(exports22, module22) {
        var isCallable = require_is_callable();
        module22.exports = function(it) {
          return typeof it == "object" ? it !== null : isCallable(it);
        };
      }
    });
    var require_get_built_in = __commonJS2({
      "node_modules/core-js/internals/get-built-in.js"(exports22, module22) {
        var global2 = require_global();
        var isCallable = require_is_callable();
        var aFunction = function(argument) {
          return isCallable(argument) ? argument : void 0;
        };
        module22.exports = function(namespace, method) {
          return arguments.length < 2 ? aFunction(global2[namespace]) : global2[namespace] && global2[namespace][method];
        };
      }
    });
    var require_object_is_prototype_of = __commonJS2({
      "node_modules/core-js/internals/object-is-prototype-of.js"(exports22, module22) {
        var uncurryThis = require_function_uncurry_this();
        module22.exports = uncurryThis({}.isPrototypeOf);
      }
    });
    var require_engine_user_agent = __commonJS2({
      "node_modules/core-js/internals/engine-user-agent.js"(exports22, module22) {
        var getBuiltIn = require_get_built_in();
        module22.exports = getBuiltIn("navigator", "userAgent") || "";
      }
    });
    var require_engine_v8_version = __commonJS2({
      "node_modules/core-js/internals/engine-v8-version.js"(exports22, module22) {
        var global2 = require_global();
        var userAgent = require_engine_user_agent();
        var process2 = global2.process;
        var Deno = global2.Deno;
        var versions = process2 && process2.versions || Deno && Deno.version;
        var v8 = versions && versions.v8;
        var match;
        var version2;
        if (v8) {
          match = v8.split(".");
          version2 = match[0] > 0 && match[0] < 4 ? 1 : +(match[0] + match[1]);
        }
        if (!version2 && userAgent) {
          match = userAgent.match(/Edge\/(\d+)/);
          if (!match || match[1] >= 74) {
            match = userAgent.match(/Chrome\/(\d+)/);
            if (match)
              version2 = +match[1];
          }
        }
        module22.exports = version2;
      }
    });
    var require_native_symbol = __commonJS2({
      "node_modules/core-js/internals/native-symbol.js"(exports22, module22) {
        var V8_VERSION = require_engine_v8_version();
        var fails = require_fails();
        module22.exports = !!Object.getOwnPropertySymbols && !fails(function() {
          var symbol = Symbol();
          return !String(symbol) || !(Object(symbol) instanceof Symbol) || !Symbol.sham && V8_VERSION && V8_VERSION < 41;
        });
      }
    });
    var require_use_symbol_as_uid = __commonJS2({
      "node_modules/core-js/internals/use-symbol-as-uid.js"(exports22, module22) {
        var NATIVE_SYMBOL = require_native_symbol();
        module22.exports = NATIVE_SYMBOL && !Symbol.sham && typeof Symbol.iterator == "symbol";
      }
    });
    var require_is_symbol = __commonJS2({
      "node_modules/core-js/internals/is-symbol.js"(exports22, module22) {
        var global2 = require_global();
        var getBuiltIn = require_get_built_in();
        var isCallable = require_is_callable();
        var isPrototypeOf = require_object_is_prototype_of();
        var USE_SYMBOL_AS_UID = require_use_symbol_as_uid();
        var Object2 = global2.Object;
        module22.exports = USE_SYMBOL_AS_UID ? function(it) {
          return typeof it == "symbol";
        } : function(it) {
          var $Symbol = getBuiltIn("Symbol");
          return isCallable($Symbol) && isPrototypeOf($Symbol.prototype, Object2(it));
        };
      }
    });
    var require_try_to_string = __commonJS2({
      "node_modules/core-js/internals/try-to-string.js"(exports22, module22) {
        var global2 = require_global();
        var String2 = global2.String;
        module22.exports = function(argument) {
          try {
            return String2(argument);
          } catch (error) {
            return "Object";
          }
        };
      }
    });
    var require_a_callable = __commonJS2({
      "node_modules/core-js/internals/a-callable.js"(exports22, module22) {
        var global2 = require_global();
        var isCallable = require_is_callable();
        var tryToString = require_try_to_string();
        var TypeError2 = global2.TypeError;
        module22.exports = function(argument) {
          if (isCallable(argument))
            return argument;
          throw TypeError2(tryToString(argument) + " is not a function");
        };
      }
    });
    var require_get_method = __commonJS2({
      "node_modules/core-js/internals/get-method.js"(exports22, module22) {
        var aCallable = require_a_callable();
        module22.exports = function(V, P) {
          var func = V[P];
          return func == null ? void 0 : aCallable(func);
        };
      }
    });
    var require_ordinary_to_primitive = __commonJS2({
      "node_modules/core-js/internals/ordinary-to-primitive.js"(exports22, module22) {
        var global2 = require_global();
        var call = require_function_call();
        var isCallable = require_is_callable();
        var isObject3 = require_is_object();
        var TypeError2 = global2.TypeError;
        module22.exports = function(input, pref) {
          var fn, val;
          if (pref === "string" && isCallable(fn = input.toString) && !isObject3(val = call(fn, input)))
            return val;
          if (isCallable(fn = input.valueOf) && !isObject3(val = call(fn, input)))
            return val;
          if (pref !== "string" && isCallable(fn = input.toString) && !isObject3(val = call(fn, input)))
            return val;
          throw TypeError2("Can't convert object to primitive value");
        };
      }
    });
    var require_is_pure = __commonJS2({
      "node_modules/core-js/internals/is-pure.js"(exports22, module22) {
        module22.exports = false;
      }
    });
    var require_set_global = __commonJS2({
      "node_modules/core-js/internals/set-global.js"(exports22, module22) {
        var global2 = require_global();
        var defineProperty2 = Object.defineProperty;
        module22.exports = function(key, value) {
          try {
            defineProperty2(global2, key, { value, configurable: true, writable: true });
          } catch (error) {
            global2[key] = value;
          }
          return value;
        };
      }
    });
    var require_shared_store = __commonJS2({
      "node_modules/core-js/internals/shared-store.js"(exports22, module22) {
        var global2 = require_global();
        var setGlobal = require_set_global();
        var SHARED = "__core-js_shared__";
        var store = global2[SHARED] || setGlobal(SHARED, {});
        module22.exports = store;
      }
    });
    var require_shared = __commonJS2({
      "node_modules/core-js/internals/shared.js"(exports22, module22) {
        var IS_PURE = require_is_pure();
        var store = require_shared_store();
        (module22.exports = function(key, value) {
          return store[key] || (store[key] = value !== void 0 ? value : {});
        })("versions", []).push({
          version: "3.22.2",
          mode: IS_PURE ? "pure" : "global",
          copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)",
          license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE",
          source: "https://github.com/zloirock/core-js"
        });
      }
    });
    var require_to_object = __commonJS2({
      "node_modules/core-js/internals/to-object.js"(exports22, module22) {
        var global2 = require_global();
        var requireObjectCoercible = require_require_object_coercible();
        var Object2 = global2.Object;
        module22.exports = function(argument) {
          return Object2(requireObjectCoercible(argument));
        };
      }
    });
    var require_has_own_property = __commonJS2({
      "node_modules/core-js/internals/has-own-property.js"(exports22, module22) {
        var uncurryThis = require_function_uncurry_this();
        var toObject = require_to_object();
        var hasOwnProperty13 = uncurryThis({}.hasOwnProperty);
        module22.exports = Object.hasOwn || function hasOwn(it, key) {
          return hasOwnProperty13(toObject(it), key);
        };
      }
    });
    var require_uid = __commonJS2({
      "node_modules/core-js/internals/uid.js"(exports22, module22) {
        var uncurryThis = require_function_uncurry_this();
        var id = 0;
        var postfix = Math.random();
        var toString4 = uncurryThis(1 .toString);
        module22.exports = function(key) {
          return "Symbol(" + (key === void 0 ? "" : key) + ")_" + toString4(++id + postfix, 36);
        };
      }
    });
    var require_well_known_symbol = __commonJS2({
      "node_modules/core-js/internals/well-known-symbol.js"(exports22, module22) {
        var global2 = require_global();
        var shared = require_shared();
        var hasOwn = require_has_own_property();
        var uid = require_uid();
        var NATIVE_SYMBOL = require_native_symbol();
        var USE_SYMBOL_AS_UID = require_use_symbol_as_uid();
        var WellKnownSymbolsStore = shared("wks");
        var Symbol22 = global2.Symbol;
        var symbolFor = Symbol22 && Symbol22["for"];
        var createWellKnownSymbol = USE_SYMBOL_AS_UID ? Symbol22 : Symbol22 && Symbol22.withoutSetter || uid;
        module22.exports = function(name) {
          if (!hasOwn(WellKnownSymbolsStore, name) || !(NATIVE_SYMBOL || typeof WellKnownSymbolsStore[name] == "string")) {
            var description = "Symbol." + name;
            if (NATIVE_SYMBOL && hasOwn(Symbol22, name)) {
              WellKnownSymbolsStore[name] = Symbol22[name];
            } else if (USE_SYMBOL_AS_UID && symbolFor) {
              WellKnownSymbolsStore[name] = symbolFor(description);
            } else {
              WellKnownSymbolsStore[name] = createWellKnownSymbol(description);
            }
          }
          return WellKnownSymbolsStore[name];
        };
      }
    });
    var require_to_primitive = __commonJS2({
      "node_modules/core-js/internals/to-primitive.js"(exports22, module22) {
        var global2 = require_global();
        var call = require_function_call();
        var isObject3 = require_is_object();
        var isSymbol2 = require_is_symbol();
        var getMethod = require_get_method();
        var ordinaryToPrimitive = require_ordinary_to_primitive();
        var wellKnownSymbol = require_well_known_symbol();
        var TypeError2 = global2.TypeError;
        var TO_PRIMITIVE = wellKnownSymbol("toPrimitive");
        module22.exports = function(input, pref) {
          if (!isObject3(input) || isSymbol2(input))
            return input;
          var exoticToPrim = getMethod(input, TO_PRIMITIVE);
          var result;
          if (exoticToPrim) {
            if (pref === void 0)
              pref = "default";
            result = call(exoticToPrim, input, pref);
            if (!isObject3(result) || isSymbol2(result))
              return result;
            throw TypeError2("Can't convert object to primitive value");
          }
          if (pref === void 0)
            pref = "number";
          return ordinaryToPrimitive(input, pref);
        };
      }
    });
    var require_to_property_key = __commonJS2({
      "node_modules/core-js/internals/to-property-key.js"(exports22, module22) {
        var toPrimitive = require_to_primitive();
        var isSymbol2 = require_is_symbol();
        module22.exports = function(argument) {
          var key = toPrimitive(argument, "string");
          return isSymbol2(key) ? key : key + "";
        };
      }
    });
    var require_document_create_element = __commonJS2({
      "node_modules/core-js/internals/document-create-element.js"(exports22, module22) {
        var global2 = require_global();
        var isObject3 = require_is_object();
        var document2 = global2.document;
        var EXISTS = isObject3(document2) && isObject3(document2.createElement);
        module22.exports = function(it) {
          return EXISTS ? document2.createElement(it) : {};
        };
      }
    });
    var require_ie8_dom_define = __commonJS2({
      "node_modules/core-js/internals/ie8-dom-define.js"(exports22, module22) {
        var DESCRIPTORS = require_descriptors();
        var fails = require_fails();
        var createElement = require_document_create_element();
        module22.exports = !DESCRIPTORS && !fails(function() {
          return Object.defineProperty(createElement("div"), "a", {
            get: function() {
              return 7;
            }
          }).a != 7;
        });
      }
    });
    var require_object_get_own_property_descriptor = __commonJS2({
      "node_modules/core-js/internals/object-get-own-property-descriptor.js"(exports22) {
        var DESCRIPTORS = require_descriptors();
        var call = require_function_call();
        var propertyIsEnumerableModule = require_object_property_is_enumerable();
        var createPropertyDescriptor = require_create_property_descriptor();
        var toIndexedObject = require_to_indexed_object();
        var toPropertyKey = require_to_property_key();
        var hasOwn = require_has_own_property();
        var IE8_DOM_DEFINE = require_ie8_dom_define();
        var $getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
        exports22.f = DESCRIPTORS ? $getOwnPropertyDescriptor : function getOwnPropertyDescriptor(O, P) {
          O = toIndexedObject(O);
          P = toPropertyKey(P);
          if (IE8_DOM_DEFINE)
            try {
              return $getOwnPropertyDescriptor(O, P);
            } catch (error) {
            }
          if (hasOwn(O, P))
            return createPropertyDescriptor(!call(propertyIsEnumerableModule.f, O, P), O[P]);
        };
      }
    });
    var require_v8_prototype_define_bug = __commonJS2({
      "node_modules/core-js/internals/v8-prototype-define-bug.js"(exports22, module22) {
        var DESCRIPTORS = require_descriptors();
        var fails = require_fails();
        module22.exports = DESCRIPTORS && fails(function() {
          return Object.defineProperty(function() {
          }, "prototype", {
            value: 42,
            writable: false
          }).prototype != 42;
        });
      }
    });
    var require_an_object = __commonJS2({
      "node_modules/core-js/internals/an-object.js"(exports22, module22) {
        var global2 = require_global();
        var isObject3 = require_is_object();
        var String2 = global2.String;
        var TypeError2 = global2.TypeError;
        module22.exports = function(argument) {
          if (isObject3(argument))
            return argument;
          throw TypeError2(String2(argument) + " is not an object");
        };
      }
    });
    var require_object_define_property = __commonJS2({
      "node_modules/core-js/internals/object-define-property.js"(exports22) {
        var global2 = require_global();
        var DESCRIPTORS = require_descriptors();
        var IE8_DOM_DEFINE = require_ie8_dom_define();
        var V8_PROTOTYPE_DEFINE_BUG = require_v8_prototype_define_bug();
        var anObject = require_an_object();
        var toPropertyKey = require_to_property_key();
        var TypeError2 = global2.TypeError;
        var $defineProperty = Object.defineProperty;
        var $getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
        var ENUMERABLE = "enumerable";
        var CONFIGURABLE = "configurable";
        var WRITABLE = "writable";
        exports22.f = DESCRIPTORS ? V8_PROTOTYPE_DEFINE_BUG ? function defineProperty2(O, P, Attributes) {
          anObject(O);
          P = toPropertyKey(P);
          anObject(Attributes);
          if (typeof O === "function" && P === "prototype" && "value" in Attributes && WRITABLE in Attributes && !Attributes[WRITABLE]) {
            var current = $getOwnPropertyDescriptor(O, P);
            if (current && current[WRITABLE]) {
              O[P] = Attributes.value;
              Attributes = {
                configurable: CONFIGURABLE in Attributes ? Attributes[CONFIGURABLE] : current[CONFIGURABLE],
                enumerable: ENUMERABLE in Attributes ? Attributes[ENUMERABLE] : current[ENUMERABLE],
                writable: false
              };
            }
          }
          return $defineProperty(O, P, Attributes);
        } : $defineProperty : function defineProperty2(O, P, Attributes) {
          anObject(O);
          P = toPropertyKey(P);
          anObject(Attributes);
          if (IE8_DOM_DEFINE)
            try {
              return $defineProperty(O, P, Attributes);
            } catch (error) {
            }
          if ("get" in Attributes || "set" in Attributes)
            throw TypeError2("Accessors not supported");
          if ("value" in Attributes)
            O[P] = Attributes.value;
          return O;
        };
      }
    });
    var require_create_non_enumerable_property = __commonJS2({
      "node_modules/core-js/internals/create-non-enumerable-property.js"(exports22, module22) {
        var DESCRIPTORS = require_descriptors();
        var definePropertyModule = require_object_define_property();
        var createPropertyDescriptor = require_create_property_descriptor();
        module22.exports = DESCRIPTORS ? function(object3, key, value) {
          return definePropertyModule.f(object3, key, createPropertyDescriptor(1, value));
        } : function(object3, key, value) {
          object3[key] = value;
          return object3;
        };
      }
    });
    var require_inspect_source = __commonJS2({
      "node_modules/core-js/internals/inspect-source.js"(exports22, module22) {
        var uncurryThis = require_function_uncurry_this();
        var isCallable = require_is_callable();
        var store = require_shared_store();
        var functionToString = uncurryThis(Function.toString);
        if (!isCallable(store.inspectSource)) {
          store.inspectSource = function(it) {
            return functionToString(it);
          };
        }
        module22.exports = store.inspectSource;
      }
    });
    var require_native_weak_map = __commonJS2({
      "node_modules/core-js/internals/native-weak-map.js"(exports22, module22) {
        var global2 = require_global();
        var isCallable = require_is_callable();
        var inspectSource = require_inspect_source();
        var WeakMap22 = global2.WeakMap;
        module22.exports = isCallable(WeakMap22) && /native code/.test(inspectSource(WeakMap22));
      }
    });
    var require_shared_key = __commonJS2({
      "node_modules/core-js/internals/shared-key.js"(exports22, module22) {
        var shared = require_shared();
        var uid = require_uid();
        var keys5 = shared("keys");
        module22.exports = function(key) {
          return keys5[key] || (keys5[key] = uid(key));
        };
      }
    });
    var require_hidden_keys = __commonJS2({
      "node_modules/core-js/internals/hidden-keys.js"(exports22, module22) {
        module22.exports = {};
      }
    });
    var require_internal_state = __commonJS2({
      "node_modules/core-js/internals/internal-state.js"(exports22, module22) {
        var NATIVE_WEAK_MAP = require_native_weak_map();
        var global2 = require_global();
        var uncurryThis = require_function_uncurry_this();
        var isObject3 = require_is_object();
        var createNonEnumerableProperty = require_create_non_enumerable_property();
        var hasOwn = require_has_own_property();
        var shared = require_shared_store();
        var sharedKey = require_shared_key();
        var hiddenKeys = require_hidden_keys();
        var OBJECT_ALREADY_INITIALIZED = "Object already initialized";
        var TypeError2 = global2.TypeError;
        var WeakMap22 = global2.WeakMap;
        var set4;
        var get2;
        var has;
        var enforce = function(it) {
          return has(it) ? get2(it) : set4(it, {});
        };
        var getterFor = function(TYPE3) {
          return function(it) {
            var state;
            if (!isObject3(it) || (state = get2(it)).type !== TYPE3) {
              throw TypeError2("Incompatible receiver, " + TYPE3 + " required");
            }
            return state;
          };
        };
        if (NATIVE_WEAK_MAP || shared.state) {
          store = shared.state || (shared.state = new WeakMap22());
          wmget = uncurryThis(store.get);
          wmhas = uncurryThis(store.has);
          wmset = uncurryThis(store.set);
          set4 = function(it, metadata) {
            if (wmhas(store, it))
              throw new TypeError2(OBJECT_ALREADY_INITIALIZED);
            metadata.facade = it;
            wmset(store, it, metadata);
            return metadata;
          };
          get2 = function(it) {
            return wmget(store, it) || {};
          };
          has = function(it) {
            return wmhas(store, it);
          };
        } else {
          STATE = sharedKey("state");
          hiddenKeys[STATE] = true;
          set4 = function(it, metadata) {
            if (hasOwn(it, STATE))
              throw new TypeError2(OBJECT_ALREADY_INITIALIZED);
            metadata.facade = it;
            createNonEnumerableProperty(it, STATE, metadata);
            return metadata;
          };
          get2 = function(it) {
            return hasOwn(it, STATE) ? it[STATE] : {};
          };
          has = function(it) {
            return hasOwn(it, STATE);
          };
        }
        var store;
        var wmget;
        var wmhas;
        var wmset;
        var STATE;
        module22.exports = {
          set: set4,
          get: get2,
          has,
          enforce,
          getterFor
        };
      }
    });
    var require_function_name = __commonJS2({
      "node_modules/core-js/internals/function-name.js"(exports22, module22) {
        var DESCRIPTORS = require_descriptors();
        var hasOwn = require_has_own_property();
        var FunctionPrototype = Function.prototype;
        var getDescriptor = DESCRIPTORS && Object.getOwnPropertyDescriptor;
        var EXISTS = hasOwn(FunctionPrototype, "name");
        var PROPER = EXISTS && function something() {
        }.name === "something";
        var CONFIGURABLE = EXISTS && (!DESCRIPTORS || DESCRIPTORS && getDescriptor(FunctionPrototype, "name").configurable);
        module22.exports = {
          EXISTS,
          PROPER,
          CONFIGURABLE
        };
      }
    });
    var require_redefine = __commonJS2({
      "node_modules/core-js/internals/redefine.js"(exports22, module22) {
        var global2 = require_global();
        var isCallable = require_is_callable();
        var hasOwn = require_has_own_property();
        var createNonEnumerableProperty = require_create_non_enumerable_property();
        var setGlobal = require_set_global();
        var inspectSource = require_inspect_source();
        var InternalStateModule = require_internal_state();
        var CONFIGURABLE_FUNCTION_NAME = require_function_name().CONFIGURABLE;
        var getInternalState = InternalStateModule.get;
        var enforceInternalState = InternalStateModule.enforce;
        var TEMPLATE = String(String).split("String");
        (module22.exports = function(O, key, value, options) {
          var unsafe = options ? !!options.unsafe : false;
          var simple = options ? !!options.enumerable : false;
          var noTargetGet = options ? !!options.noTargetGet : false;
          var name = options && options.name !== void 0 ? options.name : key;
          var state;
          if (isCallable(value)) {
            if (String(name).slice(0, 7) === "Symbol(") {
              name = "[" + String(name).replace(/^Symbol\(([^)]*)\)/, "$1") + "]";
            }
            if (!hasOwn(value, "name") || CONFIGURABLE_FUNCTION_NAME && value.name !== name) {
              createNonEnumerableProperty(value, "name", name);
            }
            state = enforceInternalState(value);
            if (!state.source) {
              state.source = TEMPLATE.join(typeof name == "string" ? name : "");
            }
          }
          if (O === global2) {
            if (simple)
              O[key] = value;
            else
              setGlobal(key, value);
            return;
          } else if (!unsafe) {
            delete O[key];
          } else if (!noTargetGet && O[key]) {
            simple = true;
          }
          if (simple)
            O[key] = value;
          else
            createNonEnumerableProperty(O, key, value);
        })(Function.prototype, "toString", function toString4() {
          return isCallable(this) && getInternalState(this).source || inspectSource(this);
        });
      }
    });
    var require_to_integer_or_infinity = __commonJS2({
      "node_modules/core-js/internals/to-integer-or-infinity.js"(exports22, module22) {
        var ceil = Math.ceil;
        var floor = Math.floor;
        module22.exports = function(argument) {
          var number3 = +argument;
          return number3 !== number3 || number3 === 0 ? 0 : (number3 > 0 ? floor : ceil)(number3);
        };
      }
    });
    var require_to_absolute_index = __commonJS2({
      "node_modules/core-js/internals/to-absolute-index.js"(exports22, module22) {
        var toIntegerOrInfinity = require_to_integer_or_infinity();
        var max = Math.max;
        var min = Math.min;
        module22.exports = function(index, length) {
          var integer = toIntegerOrInfinity(index);
          return integer < 0 ? max(integer + length, 0) : min(integer, length);
        };
      }
    });
    var require_to_length = __commonJS2({
      "node_modules/core-js/internals/to-length.js"(exports22, module22) {
        var toIntegerOrInfinity = require_to_integer_or_infinity();
        var min = Math.min;
        module22.exports = function(argument) {
          return argument > 0 ? min(toIntegerOrInfinity(argument), 9007199254740991) : 0;
        };
      }
    });
    var require_length_of_array_like = __commonJS2({
      "node_modules/core-js/internals/length-of-array-like.js"(exports22, module22) {
        var toLength = require_to_length();
        module22.exports = function(obj) {
          return toLength(obj.length);
        };
      }
    });
    var require_array_includes = __commonJS2({
      "node_modules/core-js/internals/array-includes.js"(exports22, module22) {
        var toIndexedObject = require_to_indexed_object();
        var toAbsoluteIndex = require_to_absolute_index();
        var lengthOfArrayLike = require_length_of_array_like();
        var createMethod = function(IS_INCLUDES) {
          return function($this, el, fromIndex) {
            var O = toIndexedObject($this);
            var length = lengthOfArrayLike(O);
            var index = toAbsoluteIndex(fromIndex, length);
            var value;
            if (IS_INCLUDES && el != el)
              while (length > index) {
                value = O[index++];
                if (value != value)
                  return true;
              }
            else
              for (; length > index; index++) {
                if ((IS_INCLUDES || index in O) && O[index] === el)
                  return IS_INCLUDES || index || 0;
              }
            return !IS_INCLUDES && -1;
          };
        };
        module22.exports = {
          includes: createMethod(true),
          indexOf: createMethod(false)
        };
      }
    });
    var require_object_keys_internal = __commonJS2({
      "node_modules/core-js/internals/object-keys-internal.js"(exports22, module22) {
        var uncurryThis = require_function_uncurry_this();
        var hasOwn = require_has_own_property();
        var toIndexedObject = require_to_indexed_object();
        var indexOf = require_array_includes().indexOf;
        var hiddenKeys = require_hidden_keys();
        var push = uncurryThis([].push);
        module22.exports = function(object3, names) {
          var O = toIndexedObject(object3);
          var i = 0;
          var result = [];
          var key;
          for (key in O)
            !hasOwn(hiddenKeys, key) && hasOwn(O, key) && push(result, key);
          while (names.length > i)
            if (hasOwn(O, key = names[i++])) {
              ~indexOf(result, key) || push(result, key);
            }
          return result;
        };
      }
    });
    var require_enum_bug_keys = __commonJS2({
      "node_modules/core-js/internals/enum-bug-keys.js"(exports22, module22) {
        module22.exports = [
          "constructor",
          "hasOwnProperty",
          "isPrototypeOf",
          "propertyIsEnumerable",
          "toLocaleString",
          "toString",
          "valueOf"
        ];
      }
    });
    var require_object_get_own_property_names = __commonJS2({
      "node_modules/core-js/internals/object-get-own-property-names.js"(exports22) {
        var internalObjectKeys = require_object_keys_internal();
        var enumBugKeys = require_enum_bug_keys();
        var hiddenKeys = enumBugKeys.concat("length", "prototype");
        exports22.f = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
          return internalObjectKeys(O, hiddenKeys);
        };
      }
    });
    var require_object_get_own_property_symbols = __commonJS2({
      "node_modules/core-js/internals/object-get-own-property-symbols.js"(exports22) {
        exports22.f = Object.getOwnPropertySymbols;
      }
    });
    var require_own_keys = __commonJS2({
      "node_modules/core-js/internals/own-keys.js"(exports22, module22) {
        var getBuiltIn = require_get_built_in();
        var uncurryThis = require_function_uncurry_this();
        var getOwnPropertyNamesModule = require_object_get_own_property_names();
        var getOwnPropertySymbolsModule = require_object_get_own_property_symbols();
        var anObject = require_an_object();
        var concat = uncurryThis([].concat);
        module22.exports = getBuiltIn("Reflect", "ownKeys") || function ownKeys(it) {
          var keys5 = getOwnPropertyNamesModule.f(anObject(it));
          var getOwnPropertySymbols = getOwnPropertySymbolsModule.f;
          return getOwnPropertySymbols ? concat(keys5, getOwnPropertySymbols(it)) : keys5;
        };
      }
    });
    var require_copy_constructor_properties = __commonJS2({
      "node_modules/core-js/internals/copy-constructor-properties.js"(exports22, module22) {
        var hasOwn = require_has_own_property();
        var ownKeys = require_own_keys();
        var getOwnPropertyDescriptorModule = require_object_get_own_property_descriptor();
        var definePropertyModule = require_object_define_property();
        module22.exports = function(target, source, exceptions) {
          var keys5 = ownKeys(source);
          var defineProperty2 = definePropertyModule.f;
          var getOwnPropertyDescriptor = getOwnPropertyDescriptorModule.f;
          for (var i = 0; i < keys5.length; i++) {
            var key = keys5[i];
            if (!hasOwn(target, key) && !(exceptions && hasOwn(exceptions, key))) {
              defineProperty2(target, key, getOwnPropertyDescriptor(source, key));
            }
          }
        };
      }
    });
    var require_is_forced = __commonJS2({
      "node_modules/core-js/internals/is-forced.js"(exports22, module22) {
        var fails = require_fails();
        var isCallable = require_is_callable();
        var replacement = /#|\.prototype\./;
        var isForced = function(feature, detection) {
          var value = data[normalize2(feature)];
          return value == POLYFILL ? true : value == NATIVE ? false : isCallable(detection) ? fails(detection) : !!detection;
        };
        var normalize2 = isForced.normalize = function(string3) {
          return String(string3).replace(replacement, ".").toLowerCase();
        };
        var data = isForced.data = {};
        var NATIVE = isForced.NATIVE = "N";
        var POLYFILL = isForced.POLYFILL = "P";
        module22.exports = isForced;
      }
    });
    var require_export = __commonJS2({
      "node_modules/core-js/internals/export.js"(exports22, module22) {
        var global2 = require_global();
        var getOwnPropertyDescriptor = require_object_get_own_property_descriptor().f;
        var createNonEnumerableProperty = require_create_non_enumerable_property();
        var redefine = require_redefine();
        var setGlobal = require_set_global();
        var copyConstructorProperties = require_copy_constructor_properties();
        var isForced = require_is_forced();
        module22.exports = function(options, source) {
          var TARGET = options.target;
          var GLOBAL = options.global;
          var STATIC = options.stat;
          var FORCED, target, key, targetProperty, sourceProperty, descriptor;
          if (GLOBAL) {
            target = global2;
          } else if (STATIC) {
            target = global2[TARGET] || setGlobal(TARGET, {});
          } else {
            target = (global2[TARGET] || {}).prototype;
          }
          if (target)
            for (key in source) {
              sourceProperty = source[key];
              if (options.noTargetGet) {
                descriptor = getOwnPropertyDescriptor(target, key);
                targetProperty = descriptor && descriptor.value;
              } else
                targetProperty = target[key];
              FORCED = isForced(GLOBAL ? key : TARGET + (STATIC ? "." : "#") + key, options.forced);
              if (!FORCED && targetProperty !== void 0) {
                if (typeof sourceProperty == typeof targetProperty)
                  continue;
                copyConstructorProperties(sourceProperty, targetProperty);
              }
              if (options.sham || targetProperty && targetProperty.sham) {
                createNonEnumerableProperty(sourceProperty, "sham", true);
              }
              redefine(target, key, sourceProperty, options);
            }
        };
      }
    });
    var require_is_array = __commonJS2({
      "node_modules/core-js/internals/is-array.js"(exports22, module22) {
        var classof = require_classof_raw();
        module22.exports = Array.isArray || function isArray2(argument) {
          return classof(argument) == "Array";
        };
      }
    });
    var require_function_bind_context = __commonJS2({
      "node_modules/core-js/internals/function-bind-context.js"(exports22, module22) {
        var uncurryThis = require_function_uncurry_this();
        var aCallable = require_a_callable();
        var NATIVE_BIND = require_function_bind_native();
        var bind = uncurryThis(uncurryThis.bind);
        module22.exports = function(fn, that) {
          aCallable(fn);
          return that === void 0 ? fn : NATIVE_BIND ? bind(fn, that) : function() {
            return fn.apply(that, arguments);
          };
        };
      }
    });
    var require_flatten_into_array = __commonJS2({
      "node_modules/core-js/internals/flatten-into-array.js"(exports22, module22) {
        "use strict";
        var global2 = require_global();
        var isArray2 = require_is_array();
        var lengthOfArrayLike = require_length_of_array_like();
        var bind = require_function_bind_context();
        var TypeError2 = global2.TypeError;
        var flattenIntoArray = function(target, original, source, sourceLen, start, depth, mapper, thisArg) {
          var targetIndex = start;
          var sourceIndex = 0;
          var mapFn = mapper ? bind(mapper, thisArg) : false;
          var element, elementLen;
          while (sourceIndex < sourceLen) {
            if (sourceIndex in source) {
              element = mapFn ? mapFn(source[sourceIndex], sourceIndex, original) : source[sourceIndex];
              if (depth > 0 && isArray2(element)) {
                elementLen = lengthOfArrayLike(element);
                targetIndex = flattenIntoArray(target, original, element, elementLen, targetIndex, depth - 1) - 1;
              } else {
                if (targetIndex >= 9007199254740991)
                  throw TypeError2("Exceed the acceptable array length");
                target[targetIndex] = element;
              }
              targetIndex++;
            }
            sourceIndex++;
          }
          return targetIndex;
        };
        module22.exports = flattenIntoArray;
      }
    });
    var require_to_string_tag_support = __commonJS2({
      "node_modules/core-js/internals/to-string-tag-support.js"(exports22, module22) {
        var wellKnownSymbol = require_well_known_symbol();
        var TO_STRING_TAG = wellKnownSymbol("toStringTag");
        var test = {};
        test[TO_STRING_TAG] = "z";
        module22.exports = String(test) === "[object z]";
      }
    });
    var require_classof = __commonJS2({
      "node_modules/core-js/internals/classof.js"(exports22, module22) {
        var global2 = require_global();
        var TO_STRING_TAG_SUPPORT = require_to_string_tag_support();
        var isCallable = require_is_callable();
        var classofRaw = require_classof_raw();
        var wellKnownSymbol = require_well_known_symbol();
        var TO_STRING_TAG = wellKnownSymbol("toStringTag");
        var Object2 = global2.Object;
        var CORRECT_ARGUMENTS = classofRaw(/* @__PURE__ */ function() {
          return arguments;
        }()) == "Arguments";
        var tryGet = function(it, key) {
          try {
            return it[key];
          } catch (error) {
          }
        };
        module22.exports = TO_STRING_TAG_SUPPORT ? classofRaw : function(it) {
          var O, tag, result;
          return it === void 0 ? "Undefined" : it === null ? "Null" : typeof (tag = tryGet(O = Object2(it), TO_STRING_TAG)) == "string" ? tag : CORRECT_ARGUMENTS ? classofRaw(O) : (result = classofRaw(O)) == "Object" && isCallable(O.callee) ? "Arguments" : result;
        };
      }
    });
    var require_is_constructor = __commonJS2({
      "node_modules/core-js/internals/is-constructor.js"(exports22, module22) {
        var uncurryThis = require_function_uncurry_this();
        var fails = require_fails();
        var isCallable = require_is_callable();
        var classof = require_classof();
        var getBuiltIn = require_get_built_in();
        var inspectSource = require_inspect_source();
        var noop2 = function() {
        };
        var empty = [];
        var construct = getBuiltIn("Reflect", "construct");
        var constructorRegExp = /^\s*(?:class|function)\b/;
        var exec = uncurryThis(constructorRegExp.exec);
        var INCORRECT_TO_STRING = !constructorRegExp.exec(noop2);
        var isConstructorModern = function isConstructor(argument) {
          if (!isCallable(argument))
            return false;
          try {
            construct(noop2, empty, argument);
            return true;
          } catch (error) {
            return false;
          }
        };
        var isConstructorLegacy = function isConstructor(argument) {
          if (!isCallable(argument))
            return false;
          switch (classof(argument)) {
            case "AsyncFunction":
            case "GeneratorFunction":
            case "AsyncGeneratorFunction":
              return false;
          }
          try {
            return INCORRECT_TO_STRING || !!exec(constructorRegExp, inspectSource(argument));
          } catch (error) {
            return true;
          }
        };
        isConstructorLegacy.sham = true;
        module22.exports = !construct || fails(function() {
          var called;
          return isConstructorModern(isConstructorModern.call) || !isConstructorModern(Object) || !isConstructorModern(function() {
            called = true;
          }) || called;
        }) ? isConstructorLegacy : isConstructorModern;
      }
    });
    var require_array_species_constructor = __commonJS2({
      "node_modules/core-js/internals/array-species-constructor.js"(exports22, module22) {
        var global2 = require_global();
        var isArray2 = require_is_array();
        var isConstructor = require_is_constructor();
        var isObject3 = require_is_object();
        var wellKnownSymbol = require_well_known_symbol();
        var SPECIES = wellKnownSymbol("species");
        var Array2 = global2.Array;
        module22.exports = function(originalArray) {
          var C;
          if (isArray2(originalArray)) {
            C = originalArray.constructor;
            if (isConstructor(C) && (C === Array2 || isArray2(C.prototype)))
              C = void 0;
            else if (isObject3(C)) {
              C = C[SPECIES];
              if (C === null)
                C = void 0;
            }
          }
          return C === void 0 ? Array2 : C;
        };
      }
    });
    var require_array_species_create = __commonJS2({
      "node_modules/core-js/internals/array-species-create.js"(exports22, module22) {
        var arraySpeciesConstructor = require_array_species_constructor();
        module22.exports = function(originalArray, length) {
          return new (arraySpeciesConstructor(originalArray))(length === 0 ? 0 : length);
        };
      }
    });
    var require_es_array_flat_map = __commonJS2({
      "node_modules/core-js/modules/es.array.flat-map.js"() {
        "use strict";
        var $ = require_export();
        var flattenIntoArray = require_flatten_into_array();
        var aCallable = require_a_callable();
        var toObject = require_to_object();
        var lengthOfArrayLike = require_length_of_array_like();
        var arraySpeciesCreate = require_array_species_create();
        $({ target: "Array", proto: true }, {
          flatMap: function flatMap(callbackfn) {
            var O = toObject(this);
            var sourceLen = lengthOfArrayLike(O);
            var A;
            aCallable(callbackfn);
            A = arraySpeciesCreate(O, 0);
            A.length = flattenIntoArray(A, O, O, sourceLen, 0, 1, callbackfn, arguments.length > 1 ? arguments[1] : void 0);
            return A;
          }
        });
      }
    });
    var require_iterators = __commonJS2({
      "node_modules/core-js/internals/iterators.js"(exports22, module22) {
        module22.exports = {};
      }
    });
    var require_is_array_iterator_method = __commonJS2({
      "node_modules/core-js/internals/is-array-iterator-method.js"(exports22, module22) {
        var wellKnownSymbol = require_well_known_symbol();
        var Iterators = require_iterators();
        var ITERATOR = wellKnownSymbol("iterator");
        var ArrayPrototype = Array.prototype;
        module22.exports = function(it) {
          return it !== void 0 && (Iterators.Array === it || ArrayPrototype[ITERATOR] === it);
        };
      }
    });
    var require_get_iterator_method = __commonJS2({
      "node_modules/core-js/internals/get-iterator-method.js"(exports22, module22) {
        var classof = require_classof();
        var getMethod = require_get_method();
        var Iterators = require_iterators();
        var wellKnownSymbol = require_well_known_symbol();
        var ITERATOR = wellKnownSymbol("iterator");
        module22.exports = function(it) {
          if (it != void 0)
            return getMethod(it, ITERATOR) || getMethod(it, "@@iterator") || Iterators[classof(it)];
        };
      }
    });
    var require_get_iterator = __commonJS2({
      "node_modules/core-js/internals/get-iterator.js"(exports22, module22) {
        var global2 = require_global();
        var call = require_function_call();
        var aCallable = require_a_callable();
        var anObject = require_an_object();
        var tryToString = require_try_to_string();
        var getIteratorMethod = require_get_iterator_method();
        var TypeError2 = global2.TypeError;
        module22.exports = function(argument, usingIterator) {
          var iteratorMethod = arguments.length < 2 ? getIteratorMethod(argument) : usingIterator;
          if (aCallable(iteratorMethod))
            return anObject(call(iteratorMethod, argument));
          throw TypeError2(tryToString(argument) + " is not iterable");
        };
      }
    });
    var require_iterator_close = __commonJS2({
      "node_modules/core-js/internals/iterator-close.js"(exports22, module22) {
        var call = require_function_call();
        var anObject = require_an_object();
        var getMethod = require_get_method();
        module22.exports = function(iterator, kind, value) {
          var innerResult, innerError;
          anObject(iterator);
          try {
            innerResult = getMethod(iterator, "return");
            if (!innerResult) {
              if (kind === "throw")
                throw value;
              return value;
            }
            innerResult = call(innerResult, iterator);
          } catch (error) {
            innerError = true;
            innerResult = error;
          }
          if (kind === "throw")
            throw value;
          if (innerError)
            throw innerResult;
          anObject(innerResult);
          return value;
        };
      }
    });
    var require_iterate = __commonJS2({
      "node_modules/core-js/internals/iterate.js"(exports22, module22) {
        var global2 = require_global();
        var bind = require_function_bind_context();
        var call = require_function_call();
        var anObject = require_an_object();
        var tryToString = require_try_to_string();
        var isArrayIteratorMethod = require_is_array_iterator_method();
        var lengthOfArrayLike = require_length_of_array_like();
        var isPrototypeOf = require_object_is_prototype_of();
        var getIterator = require_get_iterator();
        var getIteratorMethod = require_get_iterator_method();
        var iteratorClose = require_iterator_close();
        var TypeError2 = global2.TypeError;
        var Result = function(stopped, result) {
          this.stopped = stopped;
          this.result = result;
        };
        var ResultPrototype = Result.prototype;
        module22.exports = function(iterable, unboundFunction, options) {
          var that = options && options.that;
          var AS_ENTRIES = !!(options && options.AS_ENTRIES);
          var IS_ITERATOR = !!(options && options.IS_ITERATOR);
          var INTERRUPTED = !!(options && options.INTERRUPTED);
          var fn = bind(unboundFunction, that);
          var iterator, iterFn, index, length, result, next, step;
          var stop = function(condition) {
            if (iterator)
              iteratorClose(iterator, "normal", condition);
            return new Result(true, condition);
          };
          var callFn = function(value) {
            if (AS_ENTRIES) {
              anObject(value);
              return INTERRUPTED ? fn(value[0], value[1], stop) : fn(value[0], value[1]);
            }
            return INTERRUPTED ? fn(value, stop) : fn(value);
          };
          if (IS_ITERATOR) {
            iterator = iterable;
          } else {
            iterFn = getIteratorMethod(iterable);
            if (!iterFn)
              throw TypeError2(tryToString(iterable) + " is not iterable");
            if (isArrayIteratorMethod(iterFn)) {
              for (index = 0, length = lengthOfArrayLike(iterable); length > index; index++) {
                result = callFn(iterable[index]);
                if (result && isPrototypeOf(ResultPrototype, result))
                  return result;
              }
              return new Result(false);
            }
            iterator = getIterator(iterable, iterFn);
          }
          next = iterator.next;
          while (!(step = call(next, iterator)).done) {
            try {
              result = callFn(step.value);
            } catch (error) {
              iteratorClose(iterator, "throw", error);
            }
            if (typeof result == "object" && result && isPrototypeOf(ResultPrototype, result))
              return result;
          }
          return new Result(false);
        };
      }
    });
    var require_create_property = __commonJS2({
      "node_modules/core-js/internals/create-property.js"(exports22, module22) {
        "use strict";
        var toPropertyKey = require_to_property_key();
        var definePropertyModule = require_object_define_property();
        var createPropertyDescriptor = require_create_property_descriptor();
        module22.exports = function(object3, key, value) {
          var propertyKey = toPropertyKey(key);
          if (propertyKey in object3)
            definePropertyModule.f(object3, propertyKey, createPropertyDescriptor(0, value));
          else
            object3[propertyKey] = value;
        };
      }
    });
    var require_es_object_from_entries = __commonJS2({
      "node_modules/core-js/modules/es.object.from-entries.js"() {
        var $ = require_export();
        var iterate = require_iterate();
        var createProperty = require_create_property();
        $({ target: "Object", stat: true }, {
          fromEntries: function fromEntries(iterable) {
            var obj = {};
            iterate(iterable, function(k, v) {
              createProperty(obj, k, v);
            }, { AS_ENTRIES: true });
            return obj;
          }
        });
      }
    });
    var require_es_array_flat = __commonJS2({
      "node_modules/core-js/modules/es.array.flat.js"() {
        "use strict";
        var $ = require_export();
        var flattenIntoArray = require_flatten_into_array();
        var toObject = require_to_object();
        var lengthOfArrayLike = require_length_of_array_like();
        var toIntegerOrInfinity = require_to_integer_or_infinity();
        var arraySpeciesCreate = require_array_species_create();
        $({ target: "Array", proto: true }, {
          flat: function flat() {
            var depthArg = arguments.length ? arguments[0] : void 0;
            var O = toObject(this);
            var sourceLen = lengthOfArrayLike(O);
            var A = arraySpeciesCreate(O, 0);
            A.length = flattenIntoArray(A, O, O, sourceLen, 0, depthArg === void 0 ? 1 : toIntegerOrInfinity(depthArg));
            return A;
          }
        });
      }
    });
    var _excluded = ["cliName", "cliCategory", "cliDescription"];
    var _excluded2 = ["_"];
    var _excluded3 = ["overrides"];
    var _excluded4 = ["languageId"];
    function _objectWithoutProperties(source, excluded) {
      if (source == null)
        return {};
      var target = _objectWithoutPropertiesLoose(source, excluded);
      var key, i;
      if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i = 0; i < sourceSymbolKeys.length; i++) {
          key = sourceSymbolKeys[i];
          if (excluded.indexOf(key) >= 0)
            continue;
          if (!Object.prototype.propertyIsEnumerable.call(source, key))
            continue;
          target[key] = source[key];
        }
      }
      return target;
    }
    function _objectWithoutPropertiesLoose(source, excluded) {
      if (source == null)
        return {};
      var target = {};
      var sourceKeys = Object.keys(source);
      var key, i;
      for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0)
          continue;
        target[key] = source[key];
      }
      return target;
    }
    require_es_array_flat_map();
    require_es_object_from_entries();
    require_es_array_flat();
    var __create2 = Object.create;
    var __defProp2 = Object.defineProperty;
    var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
    var __getOwnPropNames22 = Object.getOwnPropertyNames;
    var __getProtoOf2 = Object.getPrototypeOf;
    var __hasOwnProp2 = Object.prototype.hasOwnProperty;
    var __esm2 = (fn, res) => function __init() {
      return fn && (res = (0, fn[__getOwnPropNames22(fn)[0]])(fn = 0)), res;
    };
    var __commonJS22 = (cb, mod) => function __require() {
      return mod || (0, cb[__getOwnPropNames22(cb)[0]])((mod = {
        exports: {}
      }).exports, mod), mod.exports;
    };
    var __export2 = (target, all) => {
      for (var name in all)
        __defProp2(target, name, {
          get: all[name],
          enumerable: true
        });
    };
    var __copyProps2 = (to, from, except, desc) => {
      if (from && typeof from === "object" || typeof from === "function") {
        for (let key of __getOwnPropNames22(from))
          if (!__hasOwnProp2.call(to, key) && key !== except)
            __defProp2(to, key, {
              get: () => from[key],
              enumerable: !(desc = __getOwnPropDesc2(from, key)) || desc.enumerable
            });
      }
      return to;
    };
    var __toESM2 = (mod, isNodeMode, target) => (target = mod != null ? __create2(__getProtoOf2(mod)) : {}, __copyProps2(isNodeMode || !mod || !mod.__esModule ? __defProp2(target, "default", {
      value: mod,
      enumerable: true
    }) : target, mod));
    var __toCommonJS2 = (mod) => __copyProps2(__defProp2({}, "__esModule", {
      value: true
    }), mod);
    var require_base = __commonJS22({
      "node_modules/diff/lib/diff/base.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22["default"] = Diff;
        function Diff() {
        }
        Diff.prototype = {
          diff: function diff(oldString, newString) {
            var options = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
            var callback = options.callback;
            if (typeof options === "function") {
              callback = options;
              options = {};
            }
            this.options = options;
            var self2 = this;
            function done(value) {
              if (callback) {
                setTimeout(function() {
                  callback(void 0, value);
                }, 0);
                return true;
              } else {
                return value;
              }
            }
            oldString = this.castInput(oldString);
            newString = this.castInput(newString);
            oldString = this.removeEmpty(this.tokenize(oldString));
            newString = this.removeEmpty(this.tokenize(newString));
            var newLen = newString.length, oldLen = oldString.length;
            var editLength = 1;
            var maxEditLength = newLen + oldLen;
            var bestPath = [{
              newPos: -1,
              components: []
            }];
            var oldPos = this.extractCommon(bestPath[0], newString, oldString, 0);
            if (bestPath[0].newPos + 1 >= newLen && oldPos + 1 >= oldLen) {
              return done([{
                value: this.join(newString),
                count: newString.length
              }]);
            }
            function execEditLength() {
              for (var diagonalPath = -1 * editLength; diagonalPath <= editLength; diagonalPath += 2) {
                var basePath = void 0;
                var addPath = bestPath[diagonalPath - 1], removePath = bestPath[diagonalPath + 1], _oldPos = (removePath ? removePath.newPos : 0) - diagonalPath;
                if (addPath) {
                  bestPath[diagonalPath - 1] = void 0;
                }
                var canAdd = addPath && addPath.newPos + 1 < newLen, canRemove = removePath && 0 <= _oldPos && _oldPos < oldLen;
                if (!canAdd && !canRemove) {
                  bestPath[diagonalPath] = void 0;
                  continue;
                }
                if (!canAdd || canRemove && addPath.newPos < removePath.newPos) {
                  basePath = clonePath(removePath);
                  self2.pushComponent(basePath.components, void 0, true);
                } else {
                  basePath = addPath;
                  basePath.newPos++;
                  self2.pushComponent(basePath.components, true, void 0);
                }
                _oldPos = self2.extractCommon(basePath, newString, oldString, diagonalPath);
                if (basePath.newPos + 1 >= newLen && _oldPos + 1 >= oldLen) {
                  return done(buildValues(self2, basePath.components, newString, oldString, self2.useLongestToken));
                } else {
                  bestPath[diagonalPath] = basePath;
                }
              }
              editLength++;
            }
            if (callback) {
              (function exec() {
                setTimeout(function() {
                  if (editLength > maxEditLength) {
                    return callback();
                  }
                  if (!execEditLength()) {
                    exec();
                  }
                }, 0);
              })();
            } else {
              while (editLength <= maxEditLength) {
                var ret = execEditLength();
                if (ret) {
                  return ret;
                }
              }
            }
          },
          pushComponent: function pushComponent(components, added, removed) {
            var last = components[components.length - 1];
            if (last && last.added === added && last.removed === removed) {
              components[components.length - 1] = {
                count: last.count + 1,
                added,
                removed
              };
            } else {
              components.push({
                count: 1,
                added,
                removed
              });
            }
          },
          extractCommon: function extractCommon(basePath, newString, oldString, diagonalPath) {
            var newLen = newString.length, oldLen = oldString.length, newPos = basePath.newPos, oldPos = newPos - diagonalPath, commonCount = 0;
            while (newPos + 1 < newLen && oldPos + 1 < oldLen && this.equals(newString[newPos + 1], oldString[oldPos + 1])) {
              newPos++;
              oldPos++;
              commonCount++;
            }
            if (commonCount) {
              basePath.components.push({
                count: commonCount
              });
            }
            basePath.newPos = newPos;
            return oldPos;
          },
          equals: function equals(left, right) {
            if (this.options.comparator) {
              return this.options.comparator(left, right);
            } else {
              return left === right || this.options.ignoreCase && left.toLowerCase() === right.toLowerCase();
            }
          },
          removeEmpty: function removeEmpty(array) {
            var ret = [];
            for (var i = 0; i < array.length; i++) {
              if (array[i]) {
                ret.push(array[i]);
              }
            }
            return ret;
          },
          castInput: function castInput(value) {
            return value;
          },
          tokenize: function tokenize(value) {
            return value.split("");
          },
          join: function join2(chars) {
            return chars.join("");
          }
        };
        function buildValues(diff, components, newString, oldString, useLongestToken) {
          var componentPos = 0, componentLen = components.length, newPos = 0, oldPos = 0;
          for (; componentPos < componentLen; componentPos++) {
            var component = components[componentPos];
            if (!component.removed) {
              if (!component.added && useLongestToken) {
                var value = newString.slice(newPos, newPos + component.count);
                value = value.map(function(value2, i) {
                  var oldValue = oldString[oldPos + i];
                  return oldValue.length > value2.length ? oldValue : value2;
                });
                component.value = diff.join(value);
              } else {
                component.value = diff.join(newString.slice(newPos, newPos + component.count));
              }
              newPos += component.count;
              if (!component.added) {
                oldPos += component.count;
              }
            } else {
              component.value = diff.join(oldString.slice(oldPos, oldPos + component.count));
              oldPos += component.count;
              if (componentPos && components[componentPos - 1].added) {
                var tmp = components[componentPos - 1];
                components[componentPos - 1] = components[componentPos];
                components[componentPos] = tmp;
              }
            }
          }
          var lastComponent = components[componentLen - 1];
          if (componentLen > 1 && typeof lastComponent.value === "string" && (lastComponent.added || lastComponent.removed) && diff.equals("", lastComponent.value)) {
            components[componentLen - 2].value += lastComponent.value;
            components.pop();
          }
          return components;
        }
        function clonePath(path5) {
          return {
            newPos: path5.newPos,
            components: path5.components.slice(0)
          };
        }
      }
    });
    var require_array = __commonJS22({
      "node_modules/diff/lib/diff/array.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.diffArrays = diffArrays;
        exports22.arrayDiff = void 0;
        var _base = _interopRequireDefault(require_base());
        function _interopRequireDefault(obj) {
          return obj && obj.__esModule ? obj : {
            "default": obj
          };
        }
        var arrayDiff = new _base["default"]();
        exports22.arrayDiff = arrayDiff;
        arrayDiff.tokenize = function(value) {
          return value.slice();
        };
        arrayDiff.join = arrayDiff.removeEmpty = function(value) {
          return value;
        };
        function diffArrays(oldArr, newArr, callback) {
          return arrayDiff.diff(oldArr, newArr, callback);
        }
      }
    });
    var escape_string_regexp_exports = {};
    __export2(escape_string_regexp_exports, {
      default: () => escapeStringRegexp
    });
    function escapeStringRegexp(string3) {
      if (typeof string3 !== "string") {
        throw new TypeError("Expected a string");
      }
      return string3.replace(/[|\\{}()[\]^$+*?.]/g, "\\$&").replace(/-/g, "\\x2d");
    }
    var init_escape_string_regexp = __esm2({
      "node_modules/escape-string-regexp/index.js"() {
      }
    });
    var require_get_last = __commonJS22({
      "src/utils/get-last.js"(exports22, module22) {
        "use strict";
        var getLast = (arr) => arr[arr.length - 1];
        module22.exports = getLast;
      }
    });
    var require_debug = __commonJS22({
      "node_modules/semver/internal/debug.js"(exports22, module22) {
        var debug = typeof process === "object" && process.env && process.env.NODE_DEBUG && /\bsemver\b/i.test(process.env.NODE_DEBUG) ? (...args) => console.error("SEMVER", ...args) : () => {
        };
        module22.exports = debug;
      }
    });
    var require_constants = __commonJS22({
      "node_modules/semver/internal/constants.js"(exports22, module22) {
        var SEMVER_SPEC_VERSION = "2.0.0";
        var MAX_LENGTH = 256;
        var MAX_SAFE_INTEGER3 = Number.MAX_SAFE_INTEGER || 9007199254740991;
        var MAX_SAFE_COMPONENT_LENGTH = 16;
        module22.exports = {
          SEMVER_SPEC_VERSION,
          MAX_LENGTH,
          MAX_SAFE_INTEGER: MAX_SAFE_INTEGER3,
          MAX_SAFE_COMPONENT_LENGTH
        };
      }
    });
    var require_re = __commonJS22({
      "node_modules/semver/internal/re.js"(exports22, module22) {
        var {
          MAX_SAFE_COMPONENT_LENGTH
        } = require_constants();
        var debug = require_debug();
        exports22 = module22.exports = {};
        var re = exports22.re = [];
        var src = exports22.src = [];
        var t = exports22.t = {};
        var R = 0;
        var createToken = (name, value, isGlobal) => {
          const index = R++;
          debug(name, index, value);
          t[name] = index;
          src[index] = value;
          re[index] = new RegExp(value, isGlobal ? "g" : void 0);
        };
        createToken("NUMERICIDENTIFIER", "0|[1-9]\\d*");
        createToken("NUMERICIDENTIFIERLOOSE", "[0-9]+");
        createToken("NONNUMERICIDENTIFIER", "\\d*[a-zA-Z-][a-zA-Z0-9-]*");
        createToken("MAINVERSION", `(${src[t.NUMERICIDENTIFIER]})\\.(${src[t.NUMERICIDENTIFIER]})\\.(${src[t.NUMERICIDENTIFIER]})`);
        createToken("MAINVERSIONLOOSE", `(${src[t.NUMERICIDENTIFIERLOOSE]})\\.(${src[t.NUMERICIDENTIFIERLOOSE]})\\.(${src[t.NUMERICIDENTIFIERLOOSE]})`);
        createToken("PRERELEASEIDENTIFIER", `(?:${src[t.NUMERICIDENTIFIER]}|${src[t.NONNUMERICIDENTIFIER]})`);
        createToken("PRERELEASEIDENTIFIERLOOSE", `(?:${src[t.NUMERICIDENTIFIERLOOSE]}|${src[t.NONNUMERICIDENTIFIER]})`);
        createToken("PRERELEASE", `(?:-(${src[t.PRERELEASEIDENTIFIER]}(?:\\.${src[t.PRERELEASEIDENTIFIER]})*))`);
        createToken("PRERELEASELOOSE", `(?:-?(${src[t.PRERELEASEIDENTIFIERLOOSE]}(?:\\.${src[t.PRERELEASEIDENTIFIERLOOSE]})*))`);
        createToken("BUILDIDENTIFIER", "[0-9A-Za-z-]+");
        createToken("BUILD", `(?:\\+(${src[t.BUILDIDENTIFIER]}(?:\\.${src[t.BUILDIDENTIFIER]})*))`);
        createToken("FULLPLAIN", `v?${src[t.MAINVERSION]}${src[t.PRERELEASE]}?${src[t.BUILD]}?`);
        createToken("FULL", `^${src[t.FULLPLAIN]}$`);
        createToken("LOOSEPLAIN", `[v=\\s]*${src[t.MAINVERSIONLOOSE]}${src[t.PRERELEASELOOSE]}?${src[t.BUILD]}?`);
        createToken("LOOSE", `^${src[t.LOOSEPLAIN]}$`);
        createToken("GTLT", "((?:<|>)?=?)");
        createToken("XRANGEIDENTIFIERLOOSE", `${src[t.NUMERICIDENTIFIERLOOSE]}|x|X|\\*`);
        createToken("XRANGEIDENTIFIER", `${src[t.NUMERICIDENTIFIER]}|x|X|\\*`);
        createToken("XRANGEPLAIN", `[v=\\s]*(${src[t.XRANGEIDENTIFIER]})(?:\\.(${src[t.XRANGEIDENTIFIER]})(?:\\.(${src[t.XRANGEIDENTIFIER]})(?:${src[t.PRERELEASE]})?${src[t.BUILD]}?)?)?`);
        createToken("XRANGEPLAINLOOSE", `[v=\\s]*(${src[t.XRANGEIDENTIFIERLOOSE]})(?:\\.(${src[t.XRANGEIDENTIFIERLOOSE]})(?:\\.(${src[t.XRANGEIDENTIFIERLOOSE]})(?:${src[t.PRERELEASELOOSE]})?${src[t.BUILD]}?)?)?`);
        createToken("XRANGE", `^${src[t.GTLT]}\\s*${src[t.XRANGEPLAIN]}$`);
        createToken("XRANGELOOSE", `^${src[t.GTLT]}\\s*${src[t.XRANGEPLAINLOOSE]}$`);
        createToken("COERCE", `${"(^|[^\\d])(\\d{1,"}${MAX_SAFE_COMPONENT_LENGTH}})(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?(?:$|[^\\d])`);
        createToken("COERCERTL", src[t.COERCE], true);
        createToken("LONETILDE", "(?:~>?)");
        createToken("TILDETRIM", `(\\s*)${src[t.LONETILDE]}\\s+`, true);
        exports22.tildeTrimReplace = "$1~";
        createToken("TILDE", `^${src[t.LONETILDE]}${src[t.XRANGEPLAIN]}$`);
        createToken("TILDELOOSE", `^${src[t.LONETILDE]}${src[t.XRANGEPLAINLOOSE]}$`);
        createToken("LONECARET", "(?:\\^)");
        createToken("CARETTRIM", `(\\s*)${src[t.LONECARET]}\\s+`, true);
        exports22.caretTrimReplace = "$1^";
        createToken("CARET", `^${src[t.LONECARET]}${src[t.XRANGEPLAIN]}$`);
        createToken("CARETLOOSE", `^${src[t.LONECARET]}${src[t.XRANGEPLAINLOOSE]}$`);
        createToken("COMPARATORLOOSE", `^${src[t.GTLT]}\\s*(${src[t.LOOSEPLAIN]})$|^$`);
        createToken("COMPARATOR", `^${src[t.GTLT]}\\s*(${src[t.FULLPLAIN]})$|^$`);
        createToken("COMPARATORTRIM", `(\\s*)${src[t.GTLT]}\\s*(${src[t.LOOSEPLAIN]}|${src[t.XRANGEPLAIN]})`, true);
        exports22.comparatorTrimReplace = "$1$2$3";
        createToken("HYPHENRANGE", `^\\s*(${src[t.XRANGEPLAIN]})\\s+-\\s+(${src[t.XRANGEPLAIN]})\\s*$`);
        createToken("HYPHENRANGELOOSE", `^\\s*(${src[t.XRANGEPLAINLOOSE]})\\s+-\\s+(${src[t.XRANGEPLAINLOOSE]})\\s*$`);
        createToken("STAR", "(<|>)?=?\\s*\\*");
        createToken("GTE0", "^\\s*>=\\s*0\\.0\\.0\\s*$");
        createToken("GTE0PRE", "^\\s*>=\\s*0\\.0\\.0-0\\s*$");
      }
    });
    var require_parse_options = __commonJS22({
      "node_modules/semver/internal/parse-options.js"(exports22, module22) {
        var opts = ["includePrerelease", "loose", "rtl"];
        var parseOptions = (options) => !options ? {} : typeof options !== "object" ? {
          loose: true
        } : opts.filter((k) => options[k]).reduce((o, k) => {
          o[k] = true;
          return o;
        }, {});
        module22.exports = parseOptions;
      }
    });
    var require_identifiers = __commonJS22({
      "node_modules/semver/internal/identifiers.js"(exports22, module22) {
        var numeric = /^[0-9]+$/;
        var compareIdentifiers = (a, b) => {
          const anum = numeric.test(a);
          const bnum = numeric.test(b);
          if (anum && bnum) {
            a = +a;
            b = +b;
          }
          return a === b ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a < b ? -1 : 1;
        };
        var rcompareIdentifiers = (a, b) => compareIdentifiers(b, a);
        module22.exports = {
          compareIdentifiers,
          rcompareIdentifiers
        };
      }
    });
    var require_semver = __commonJS22({
      "node_modules/semver/classes/semver.js"(exports22, module22) {
        var debug = require_debug();
        var {
          MAX_LENGTH,
          MAX_SAFE_INTEGER: MAX_SAFE_INTEGER3
        } = require_constants();
        var {
          re,
          t
        } = require_re();
        var parseOptions = require_parse_options();
        var {
          compareIdentifiers
        } = require_identifiers();
        var SemVer = class {
          constructor(version2, options) {
            options = parseOptions(options);
            if (version2 instanceof SemVer) {
              if (version2.loose === !!options.loose && version2.includePrerelease === !!options.includePrerelease) {
                return version2;
              } else {
                version2 = version2.version;
              }
            } else if (typeof version2 !== "string") {
              throw new TypeError(`Invalid Version: ${version2}`);
            }
            if (version2.length > MAX_LENGTH) {
              throw new TypeError(`version is longer than ${MAX_LENGTH} characters`);
            }
            debug("SemVer", version2, options);
            this.options = options;
            this.loose = !!options.loose;
            this.includePrerelease = !!options.includePrerelease;
            const m = version2.trim().match(options.loose ? re[t.LOOSE] : re[t.FULL]);
            if (!m) {
              throw new TypeError(`Invalid Version: ${version2}`);
            }
            this.raw = version2;
            this.major = +m[1];
            this.minor = +m[2];
            this.patch = +m[3];
            if (this.major > MAX_SAFE_INTEGER3 || this.major < 0) {
              throw new TypeError("Invalid major version");
            }
            if (this.minor > MAX_SAFE_INTEGER3 || this.minor < 0) {
              throw new TypeError("Invalid minor version");
            }
            if (this.patch > MAX_SAFE_INTEGER3 || this.patch < 0) {
              throw new TypeError("Invalid patch version");
            }
            if (!m[4]) {
              this.prerelease = [];
            } else {
              this.prerelease = m[4].split(".").map((id) => {
                if (/^[0-9]+$/.test(id)) {
                  const num = +id;
                  if (num >= 0 && num < MAX_SAFE_INTEGER3) {
                    return num;
                  }
                }
                return id;
              });
            }
            this.build = m[5] ? m[5].split(".") : [];
            this.format();
          }
          format() {
            this.version = `${this.major}.${this.minor}.${this.patch}`;
            if (this.prerelease.length) {
              this.version += `-${this.prerelease.join(".")}`;
            }
            return this.version;
          }
          toString() {
            return this.version;
          }
          compare(other) {
            debug("SemVer.compare", this.version, this.options, other);
            if (!(other instanceof SemVer)) {
              if (typeof other === "string" && other === this.version) {
                return 0;
              }
              other = new SemVer(other, this.options);
            }
            if (other.version === this.version) {
              return 0;
            }
            return this.compareMain(other) || this.comparePre(other);
          }
          compareMain(other) {
            if (!(other instanceof SemVer)) {
              other = new SemVer(other, this.options);
            }
            return compareIdentifiers(this.major, other.major) || compareIdentifiers(this.minor, other.minor) || compareIdentifiers(this.patch, other.patch);
          }
          comparePre(other) {
            if (!(other instanceof SemVer)) {
              other = new SemVer(other, this.options);
            }
            if (this.prerelease.length && !other.prerelease.length) {
              return -1;
            } else if (!this.prerelease.length && other.prerelease.length) {
              return 1;
            } else if (!this.prerelease.length && !other.prerelease.length) {
              return 0;
            }
            let i = 0;
            do {
              const a = this.prerelease[i];
              const b = other.prerelease[i];
              debug("prerelease compare", i, a, b);
              if (a === void 0 && b === void 0) {
                return 0;
              } else if (b === void 0) {
                return 1;
              } else if (a === void 0) {
                return -1;
              } else if (a === b) {
                continue;
              } else {
                return compareIdentifiers(a, b);
              }
            } while (++i);
          }
          compareBuild(other) {
            if (!(other instanceof SemVer)) {
              other = new SemVer(other, this.options);
            }
            let i = 0;
            do {
              const a = this.build[i];
              const b = other.build[i];
              debug("prerelease compare", i, a, b);
              if (a === void 0 && b === void 0) {
                return 0;
              } else if (b === void 0) {
                return 1;
              } else if (a === void 0) {
                return -1;
              } else if (a === b) {
                continue;
              } else {
                return compareIdentifiers(a, b);
              }
            } while (++i);
          }
          inc(release, identifier) {
            switch (release) {
              case "premajor":
                this.prerelease.length = 0;
                this.patch = 0;
                this.minor = 0;
                this.major++;
                this.inc("pre", identifier);
                break;
              case "preminor":
                this.prerelease.length = 0;
                this.patch = 0;
                this.minor++;
                this.inc("pre", identifier);
                break;
              case "prepatch":
                this.prerelease.length = 0;
                this.inc("patch", identifier);
                this.inc("pre", identifier);
                break;
              case "prerelease":
                if (this.prerelease.length === 0) {
                  this.inc("patch", identifier);
                }
                this.inc("pre", identifier);
                break;
              case "major":
                if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
                  this.major++;
                }
                this.minor = 0;
                this.patch = 0;
                this.prerelease = [];
                break;
              case "minor":
                if (this.patch !== 0 || this.prerelease.length === 0) {
                  this.minor++;
                }
                this.patch = 0;
                this.prerelease = [];
                break;
              case "patch":
                if (this.prerelease.length === 0) {
                  this.patch++;
                }
                this.prerelease = [];
                break;
              case "pre":
                if (this.prerelease.length === 0) {
                  this.prerelease = [0];
                } else {
                  let i = this.prerelease.length;
                  while (--i >= 0) {
                    if (typeof this.prerelease[i] === "number") {
                      this.prerelease[i]++;
                      i = -2;
                    }
                  }
                  if (i === -1) {
                    this.prerelease.push(0);
                  }
                }
                if (identifier) {
                  if (compareIdentifiers(this.prerelease[0], identifier) === 0) {
                    if (isNaN(this.prerelease[1])) {
                      this.prerelease = [identifier, 0];
                    }
                  } else {
                    this.prerelease = [identifier, 0];
                  }
                }
                break;
              default:
                throw new Error(`invalid increment argument: ${release}`);
            }
            this.format();
            this.raw = this.version;
            return this;
          }
        };
        module22.exports = SemVer;
      }
    });
    var require_compare = __commonJS22({
      "node_modules/semver/functions/compare.js"(exports22, module22) {
        var SemVer = require_semver();
        var compare = (a, b, loose) => new SemVer(a, loose).compare(new SemVer(b, loose));
        module22.exports = compare;
      }
    });
    var require_lt = __commonJS22({
      "node_modules/semver/functions/lt.js"(exports22, module22) {
        var compare = require_compare();
        var lt = (a, b, loose) => compare(a, b, loose) < 0;
        module22.exports = lt;
      }
    });
    var require_gte = __commonJS22({
      "node_modules/semver/functions/gte.js"(exports22, module22) {
        var compare = require_compare();
        var gte = (a, b, loose) => compare(a, b, loose) >= 0;
        module22.exports = gte;
      }
    });
    var require_arrayify = __commonJS22({
      "src/utils/arrayify.js"(exports22, module22) {
        "use strict";
        module22.exports = (object3, keyName) => Object.entries(object3).map(([key, value]) => Object.assign({
          [keyName]: key
        }, value));
      }
    });
    var require_lib4 = __commonJS22({
      "node_modules/outdent/lib/index.js"(exports22, module22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.outdent = void 0;
        function noop2() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
        }
        function createWeakMap() {
          if (typeof WeakMap !== "undefined") {
            return /* @__PURE__ */ new WeakMap();
          } else {
            return fakeSetOrMap();
          }
        }
        function fakeSetOrMap() {
          return {
            add: noop2,
            delete: noop2,
            get: noop2,
            set: noop2,
            has: function(k) {
              return false;
            }
          };
        }
        var hop = Object.prototype.hasOwnProperty;
        var has = function(obj, prop) {
          return hop.call(obj, prop);
        };
        function extend3(target, source) {
          for (var prop in source) {
            if (has(source, prop)) {
              target[prop] = source[prop];
            }
          }
          return target;
        }
        var reLeadingNewline = /^[ \t]*(?:\r\n|\r|\n)/;
        var reTrailingNewline = /(?:\r\n|\r|\n)[ \t]*$/;
        var reStartsWithNewlineOrIsEmpty = /^(?:[\r\n]|$)/;
        var reDetectIndentation = /(?:\r\n|\r|\n)([ \t]*)(?:[^ \t\r\n]|$)/;
        var reOnlyWhitespaceWithAtLeastOneNewline = /^[ \t]*[\r\n][ \t\r\n]*$/;
        function _outdentArray(strings, firstInterpolatedValueSetsIndentationLevel, options) {
          var indentationLevel = 0;
          var match = strings[0].match(reDetectIndentation);
          if (match) {
            indentationLevel = match[1].length;
          }
          var reSource = "(\\r\\n|\\r|\\n).{0," + indentationLevel + "}";
          var reMatchIndent = new RegExp(reSource, "g");
          if (firstInterpolatedValueSetsIndentationLevel) {
            strings = strings.slice(1);
          }
          var newline = options.newline, trimLeadingNewline = options.trimLeadingNewline, trimTrailingNewline = options.trimTrailingNewline;
          var normalizeNewlines = typeof newline === "string";
          var l = strings.length;
          var outdentedStrings = strings.map(function(v, i) {
            v = v.replace(reMatchIndent, "$1");
            if (i === 0 && trimLeadingNewline) {
              v = v.replace(reLeadingNewline, "");
            }
            if (i === l - 1 && trimTrailingNewline) {
              v = v.replace(reTrailingNewline, "");
            }
            if (normalizeNewlines) {
              v = v.replace(/\r\n|\n|\r/g, function(_) {
                return newline;
              });
            }
            return v;
          });
          return outdentedStrings;
        }
        function concatStringsAndValues(strings, values) {
          var ret = "";
          for (var i = 0, l = strings.length; i < l; i++) {
            ret += strings[i];
            if (i < l - 1) {
              ret += values[i];
            }
          }
          return ret;
        }
        function isTemplateStringsArray(v) {
          return has(v, "raw") && has(v, "length");
        }
        function createInstance(options) {
          var arrayAutoIndentCache = createWeakMap();
          var arrayFirstInterpSetsIndentCache = createWeakMap();
          function outdent(stringsOrOptions) {
            var values = [];
            for (var _i = 1; _i < arguments.length; _i++) {
              values[_i - 1] = arguments[_i];
            }
            if (isTemplateStringsArray(stringsOrOptions)) {
              var strings = stringsOrOptions;
              var firstInterpolatedValueSetsIndentationLevel = (values[0] === outdent || values[0] === defaultOutdent) && reOnlyWhitespaceWithAtLeastOneNewline.test(strings[0]) && reStartsWithNewlineOrIsEmpty.test(strings[1]);
              var cache = firstInterpolatedValueSetsIndentationLevel ? arrayFirstInterpSetsIndentCache : arrayAutoIndentCache;
              var renderedArray = cache.get(strings);
              if (!renderedArray) {
                renderedArray = _outdentArray(strings, firstInterpolatedValueSetsIndentationLevel, options);
                cache.set(strings, renderedArray);
              }
              if (values.length === 0) {
                return renderedArray[0];
              }
              var rendered = concatStringsAndValues(renderedArray, firstInterpolatedValueSetsIndentationLevel ? values.slice(1) : values);
              return rendered;
            } else {
              return createInstance(extend3(extend3({}, options), stringsOrOptions || {}));
            }
          }
          var fullOutdent = extend3(outdent, {
            string: function(str2) {
              return _outdentArray([str2], false, options)[0];
            }
          });
          return fullOutdent;
        }
        var defaultOutdent = createInstance({
          trimLeadingNewline: true,
          trimTrailingNewline: true
        });
        exports22.outdent = defaultOutdent;
        exports22.default = defaultOutdent;
        if (typeof module22 !== "undefined") {
          try {
            module22.exports = defaultOutdent;
            Object.defineProperty(defaultOutdent, "__esModule", {
              value: true
            });
            defaultOutdent.default = defaultOutdent;
            defaultOutdent.outdent = defaultOutdent;
          } catch (e) {
          }
        }
      }
    });
    var require_core_options = __commonJS22({
      "src/main/core-options.js"(exports22, module22) {
        "use strict";
        var {
          outdent
        } = require_lib4();
        var CATEGORY_CONFIG = "Config";
        var CATEGORY_EDITOR = "Editor";
        var CATEGORY_FORMAT = "Format";
        var CATEGORY_OTHER = "Other";
        var CATEGORY_OUTPUT = "Output";
        var CATEGORY_GLOBAL = "Global";
        var CATEGORY_SPECIAL = "Special";
        var options = {
          cursorOffset: {
            since: "1.4.0",
            category: CATEGORY_SPECIAL,
            type: "int",
            default: -1,
            range: {
              start: -1,
              end: Number.POSITIVE_INFINITY,
              step: 1
            },
            description: outdent`
      Print (to stderr) where a cursor at the given position would move to after formatting.
      This option cannot be used with --range-start and --range-end.
    `,
            cliCategory: CATEGORY_EDITOR
          },
          endOfLine: {
            since: "1.15.0",
            category: CATEGORY_GLOBAL,
            type: "choice",
            default: [{
              since: "1.15.0",
              value: "auto"
            }, {
              since: "2.0.0",
              value: "lf"
            }],
            description: "Which end of line characters to apply.",
            choices: [{
              value: "lf",
              description: "Line Feed only (\\n), common on Linux and macOS as well as inside git repos"
            }, {
              value: "crlf",
              description: "Carriage Return + Line Feed characters (\\r\\n), common on Windows"
            }, {
              value: "cr",
              description: "Carriage Return character only (\\r), used very rarely"
            }, {
              value: "auto",
              description: outdent`
          Maintain existing
          (mixed values within one file are normalised by looking at what's used after the first line)
        `
            }]
          },
          filepath: {
            since: "1.4.0",
            category: CATEGORY_SPECIAL,
            type: "path",
            description: "Specify the input filepath. This will be used to do parser inference.",
            cliName: "stdin-filepath",
            cliCategory: CATEGORY_OTHER,
            cliDescription: "Path to the file to pretend that stdin comes from."
          },
          insertPragma: {
            since: "1.8.0",
            category: CATEGORY_SPECIAL,
            type: "boolean",
            default: false,
            description: "Insert @format pragma into file's first docblock comment.",
            cliCategory: CATEGORY_OTHER
          },
          parser: {
            since: "0.0.10",
            category: CATEGORY_GLOBAL,
            type: "choice",
            default: [{
              since: "0.0.10",
              value: "babylon"
            }, {
              since: "1.13.0",
              value: void 0
            }],
            description: "Which parser to use.",
            exception: (value) => typeof value === "string" || typeof value === "function",
            choices: [{
              value: "flow",
              description: "Flow"
            }, {
              value: "babel",
              since: "1.16.0",
              description: "JavaScript"
            }, {
              value: "babel-flow",
              since: "1.16.0",
              description: "Flow"
            }, {
              value: "babel-ts",
              since: "2.0.0",
              description: "TypeScript"
            }, {
              value: "typescript",
              since: "1.4.0",
              description: "TypeScript"
            }, {
              value: "acorn",
              since: "2.6.0",
              description: "JavaScript"
            }, {
              value: "espree",
              since: "2.2.0",
              description: "JavaScript"
            }, {
              value: "meriyah",
              since: "2.2.0",
              description: "JavaScript"
            }, {
              value: "css",
              since: "1.7.1",
              description: "CSS"
            }, {
              value: "less",
              since: "1.7.1",
              description: "Less"
            }, {
              value: "scss",
              since: "1.7.1",
              description: "SCSS"
            }, {
              value: "json",
              since: "1.5.0",
              description: "JSON"
            }, {
              value: "json5",
              since: "1.13.0",
              description: "JSON5"
            }, {
              value: "json-stringify",
              since: "1.13.0",
              description: "JSON.stringify"
            }, {
              value: "graphql",
              since: "1.5.0",
              description: "GraphQL"
            }, {
              value: "markdown",
              since: "1.8.0",
              description: "Markdown"
            }, {
              value: "mdx",
              since: "1.15.0",
              description: "MDX"
            }, {
              value: "vue",
              since: "1.10.0",
              description: "Vue"
            }, {
              value: "yaml",
              since: "1.14.0",
              description: "YAML"
            }, {
              value: "glimmer",
              since: "2.3.0",
              description: "Ember / Handlebars"
            }, {
              value: "html",
              since: "1.15.0",
              description: "HTML"
            }, {
              value: "angular",
              since: "1.15.0",
              description: "Angular"
            }, {
              value: "lwc",
              since: "1.17.0",
              description: "Lightning Web Components"
            }]
          },
          plugins: {
            since: "1.10.0",
            type: "path",
            array: true,
            default: [{
              value: []
            }],
            category: CATEGORY_GLOBAL,
            description: "Add a plugin. Multiple plugins can be passed as separate `--plugin`s.",
            exception: (value) => typeof value === "string" || typeof value === "object",
            cliName: "plugin",
            cliCategory: CATEGORY_CONFIG
          },
          pluginSearchDirs: {
            since: "1.13.0",
            type: "path",
            array: true,
            default: [{
              value: []
            }],
            category: CATEGORY_GLOBAL,
            description: outdent`
      Custom directory that contains prettier plugins in node_modules subdirectory.
      Overrides default behavior when plugins are searched relatively to the location of Prettier.
      Multiple values are accepted.
    `,
            exception: (value) => typeof value === "string" || typeof value === "object",
            cliName: "plugin-search-dir",
            cliCategory: CATEGORY_CONFIG
          },
          printWidth: {
            since: "0.0.0",
            category: CATEGORY_GLOBAL,
            type: "int",
            default: 80,
            description: "The line length where Prettier will try wrap.",
            range: {
              start: 0,
              end: Number.POSITIVE_INFINITY,
              step: 1
            }
          },
          rangeEnd: {
            since: "1.4.0",
            category: CATEGORY_SPECIAL,
            type: "int",
            default: Number.POSITIVE_INFINITY,
            range: {
              start: 0,
              end: Number.POSITIVE_INFINITY,
              step: 1
            },
            description: outdent`
      Format code ending at a given character offset (exclusive).
      The range will extend forwards to the end of the selected statement.
      This option cannot be used with --cursor-offset.
    `,
            cliCategory: CATEGORY_EDITOR
          },
          rangeStart: {
            since: "1.4.0",
            category: CATEGORY_SPECIAL,
            type: "int",
            default: 0,
            range: {
              start: 0,
              end: Number.POSITIVE_INFINITY,
              step: 1
            },
            description: outdent`
      Format code starting at a given character offset.
      The range will extend backwards to the start of the first line containing the selected statement.
      This option cannot be used with --cursor-offset.
    `,
            cliCategory: CATEGORY_EDITOR
          },
          requirePragma: {
            since: "1.7.0",
            category: CATEGORY_SPECIAL,
            type: "boolean",
            default: false,
            description: outdent`
      Require either '@prettier' or '@format' to be present in the file's first docblock comment
      in order for it to be formatted.
    `,
            cliCategory: CATEGORY_OTHER
          },
          tabWidth: {
            type: "int",
            category: CATEGORY_GLOBAL,
            default: 2,
            description: "Number of spaces per indentation level.",
            range: {
              start: 0,
              end: Number.POSITIVE_INFINITY,
              step: 1
            }
          },
          useTabs: {
            since: "1.0.0",
            category: CATEGORY_GLOBAL,
            type: "boolean",
            default: false,
            description: "Indent with tabs instead of spaces."
          },
          embeddedLanguageFormatting: {
            since: "2.1.0",
            category: CATEGORY_GLOBAL,
            type: "choice",
            default: [{
              since: "2.1.0",
              value: "auto"
            }],
            description: "Control how Prettier formats quoted code embedded in the file.",
            choices: [{
              value: "auto",
              description: "Format embedded code if Prettier can automatically identify it."
            }, {
              value: "off",
              description: "Never automatically format embedded code."
            }]
          }
        };
        module22.exports = {
          CATEGORY_CONFIG,
          CATEGORY_EDITOR,
          CATEGORY_FORMAT,
          CATEGORY_OTHER,
          CATEGORY_OUTPUT,
          CATEGORY_GLOBAL,
          CATEGORY_SPECIAL,
          options
        };
      }
    });
    var require_support = __commonJS22({
      "src/main/support.js"(exports22, module22) {
        "use strict";
        var semver = {
          compare: require_compare(),
          lt: require_lt(),
          gte: require_gte()
        };
        var arrayify = require_arrayify();
        var currentVersion = require_package().version;
        var coreOptions = require_core_options().options;
        function getSupportInfo2({
          plugins: plugins2 = [],
          showUnreleased = false,
          showDeprecated = false,
          showInternal = false
        } = {}) {
          const version2 = currentVersion.split("-", 1)[0];
          const languages = plugins2.flatMap((plugin) => plugin.languages || []).filter(filterSince);
          const options = arrayify(Object.assign({}, ...plugins2.map(({
            options: options2
          }) => options2), coreOptions), "name").filter((option) => filterSince(option) && filterDeprecated(option)).sort((a, b) => a.name === b.name ? 0 : a.name < b.name ? -1 : 1).map(mapInternal).map((option) => {
            option = Object.assign({}, option);
            if (Array.isArray(option.default)) {
              option.default = option.default.length === 1 ? option.default[0].value : option.default.filter(filterSince).sort((info1, info2) => semver.compare(info2.since, info1.since))[0].value;
            }
            if (Array.isArray(option.choices)) {
              option.choices = option.choices.filter((option2) => filterSince(option2) && filterDeprecated(option2));
              if (option.name === "parser") {
                collectParsersFromLanguages(option, languages, plugins2);
              }
            }
            const pluginDefaults = Object.fromEntries(plugins2.filter((plugin) => plugin.defaultOptions && plugin.defaultOptions[option.name] !== void 0).map((plugin) => [plugin.name, plugin.defaultOptions[option.name]]));
            return Object.assign(Object.assign({}, option), {}, {
              pluginDefaults
            });
          });
          return {
            languages,
            options
          };
          function filterSince(object3) {
            return showUnreleased || !("since" in object3) || object3.since && semver.gte(version2, object3.since);
          }
          function filterDeprecated(object3) {
            return showDeprecated || !("deprecated" in object3) || object3.deprecated && semver.lt(version2, object3.deprecated);
          }
          function mapInternal(object3) {
            if (showInternal) {
              return object3;
            }
            const {
              cliName,
              cliCategory,
              cliDescription
            } = object3, newObject = _objectWithoutProperties(object3, _excluded);
            return newObject;
          }
        }
        function collectParsersFromLanguages(option, languages, plugins2) {
          const existingValues = new Set(option.choices.map((choice) => choice.value));
          for (const language of languages) {
            if (language.parsers) {
              for (const value of language.parsers) {
                if (!existingValues.has(value)) {
                  existingValues.add(value);
                  const plugin = plugins2.find((plugin2) => plugin2.parsers && plugin2.parsers[value]);
                  let description = language.name;
                  if (plugin && plugin.name) {
                    description += ` (plugin: ${plugin.name})`;
                  }
                  option.choices.push({
                    value,
                    description
                  });
                }
              }
            }
          }
        }
        module22.exports = {
          getSupportInfo: getSupportInfo2
        };
      }
    });
    var require_is_non_empty_array = __commonJS22({
      "src/utils/is-non-empty-array.js"(exports22, module22) {
        "use strict";
        function isNonEmptyArray(object3) {
          return Array.isArray(object3) && object3.length > 0;
        }
        module22.exports = isNonEmptyArray;
      }
    });
    function ansiRegex({
      onlyFirst = false
    } = {}) {
      const pattern = ["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)", "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"].join("|");
      return new RegExp(pattern, onlyFirst ? void 0 : "g");
    }
    var init_ansi_regex = __esm2({
      "node_modules/strip-ansi/node_modules/ansi-regex/index.js"() {
      }
    });
    function stripAnsi(string3) {
      if (typeof string3 !== "string") {
        throw new TypeError(`Expected a \`string\`, got \`${typeof string3}\``);
      }
      return string3.replace(ansiRegex(), "");
    }
    var init_strip_ansi = __esm2({
      "node_modules/strip-ansi/index.js"() {
        init_ansi_regex();
      }
    });
    function isFullwidthCodePoint(codePoint) {
      if (!Number.isInteger(codePoint)) {
        return false;
      }
      return codePoint >= 4352 && (codePoint <= 4447 || codePoint === 9001 || codePoint === 9002 || 11904 <= codePoint && codePoint <= 12871 && codePoint !== 12351 || 12880 <= codePoint && codePoint <= 19903 || 19968 <= codePoint && codePoint <= 42182 || 43360 <= codePoint && codePoint <= 43388 || 44032 <= codePoint && codePoint <= 55203 || 63744 <= codePoint && codePoint <= 64255 || 65040 <= codePoint && codePoint <= 65049 || 65072 <= codePoint && codePoint <= 65131 || 65281 <= codePoint && codePoint <= 65376 || 65504 <= codePoint && codePoint <= 65510 || 110592 <= codePoint && codePoint <= 110593 || 127488 <= codePoint && codePoint <= 127569 || 131072 <= codePoint && codePoint <= 262141);
    }
    var init_is_fullwidth_code_point = __esm2({
      "node_modules/is-fullwidth-code-point/index.js"() {
      }
    });
    var require_emoji_regex = __commonJS22({
      "node_modules/emoji-regex/index.js"(exports22, module22) {
        "use strict";
        module22.exports = function() {
          return /\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67)\uDB40\uDC7F|(?:\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFE])|(?:\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFC-\uDFFF])|\uD83D\uDC68(?:\uD83C\uDFFB(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFC-\uDFFF])|[\u2695\u2696\u2708]\uFE0F|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))?|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFE])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])\uFE0F|\u200D(?:(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D[\uDC66\uDC67])|\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC)?|(?:\uD83D\uDC69(?:\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69]))|\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1)(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC69(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83E\uDDD1(?:\u200D(?:\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D\uDC69\u200D\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83E\uDDD1(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDC69(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDE36\u200D\uD83C\uDF2B|\uD83C\uDFF3\uFE0F\u200D\u26A7|\uD83D\uDC3B\u200D\u2744|(?:(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF])\u200D[\u2640\u2642]|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\uD83C\uDFF4\u200D\u2620|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])\u200D[\u2640\u2642]|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u2600-\u2604\u260E\u2611\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26B0\u26B1\u26C8\u26CF\u26D1\u26D3\u26E9\u26F0\u26F1\u26F4\u26F7\u26F8\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u3030\u303D\u3297\u3299]|\uD83C[\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]|\uD83D[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3])\uFE0F|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC69\u200D\uD83D\uDC67|\uD83D\uDC69\u200D\uD83D\uDC66|\uD83D\uDE35\u200D\uD83D\uDCAB|\uD83D\uDE2E\u200D\uD83D\uDCA8|\uD83D\uDC15\u200D\uD83E\uDDBA|\uD83E\uDDD1(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83D\uDC69(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDF6\uD83C\uDDE6|\uD83C\uDDF4\uD83C\uDDF2|\uD83D\uDC08\u200D\u2B1B|\u2764\uFE0F\u200D(?:\uD83D\uDD25|\uD83E\uDE79)|\uD83D\uDC41\uFE0F|\uD83C\uDFF3\uFE0F|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|[#\*0-9]\uFE0F\u20E3|\u2764\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|\uD83C\uDFF4|(?:[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u261D\u270C\u270D]|\uD83D[\uDD74\uDD90])(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC08\uDC15\uDC3B\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE2E\uDE35\uDE36\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5]|\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD]|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF]|[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0D\uDD0E\uDD10-\uDD17\uDD1D\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78\uDD7A-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCB\uDDD0\uDDE0-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6]|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26A7\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDED5-\uDED7\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])\uFE0F|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDC8F\uDC91\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1F\uDD26\uDD30-\uDD39\uDD3C-\uDD3E\uDD77\uDDB5\uDDB6\uDDB8\uDDB9\uDDBB\uDDCD-\uDDCF\uDDD1-\uDDDD])/g;
        };
      }
    });
    var string_width_exports = {};
    __export2(string_width_exports, {
      default: () => stringWidth
    });
    function stringWidth(string3) {
      if (typeof string3 !== "string" || string3.length === 0) {
        return 0;
      }
      string3 = stripAnsi(string3);
      if (string3.length === 0) {
        return 0;
      }
      string3 = string3.replace((0, import_emoji_regex.default)(), "  ");
      let width = 0;
      for (let index = 0; index < string3.length; index++) {
        const codePoint = string3.codePointAt(index);
        if (codePoint <= 31 || codePoint >= 127 && codePoint <= 159) {
          continue;
        }
        if (codePoint >= 768 && codePoint <= 879) {
          continue;
        }
        if (codePoint > 65535) {
          index++;
        }
        width += isFullwidthCodePoint(codePoint) ? 2 : 1;
      }
      return width;
    }
    var import_emoji_regex;
    var init_string_width = __esm2({
      "node_modules/string-width/index.js"() {
        init_strip_ansi();
        init_is_fullwidth_code_point();
        import_emoji_regex = __toESM2(require_emoji_regex());
      }
    });
    var require_get_string_width = __commonJS22({
      "src/utils/get-string-width.js"(exports22, module22) {
        "use strict";
        var stringWidth2 = (init_string_width(), __toCommonJS2(string_width_exports)).default;
        var notAsciiRegex = /[^\x20-\x7F]/;
        function getStringWidth(text) {
          if (!text) {
            return 0;
          }
          if (!notAsciiRegex.test(text)) {
            return text.length;
          }
          return stringWidth2(text);
        }
        module22.exports = getStringWidth;
      }
    });
    var require_skip = __commonJS22({
      "src/utils/text/skip.js"(exports22, module22) {
        "use strict";
        function skip(chars) {
          return (text, index, opts) => {
            const backwards = opts && opts.backwards;
            if (index === false) {
              return false;
            }
            const {
              length
            } = text;
            let cursor = index;
            while (cursor >= 0 && cursor < length) {
              const c = text.charAt(cursor);
              if (chars instanceof RegExp) {
                if (!chars.test(c)) {
                  return cursor;
                }
              } else if (!chars.includes(c)) {
                return cursor;
              }
              backwards ? cursor-- : cursor++;
            }
            if (cursor === -1 || cursor === length) {
              return cursor;
            }
            return false;
          };
        }
        var skipWhitespace = skip(/\s/);
        var skipSpaces = skip(" 	");
        var skipToLineEnd = skip(",; 	");
        var skipEverythingButNewLine = skip(/[^\n\r]/);
        module22.exports = {
          skipWhitespace,
          skipSpaces,
          skipToLineEnd,
          skipEverythingButNewLine
        };
      }
    });
    var require_skip_inline_comment = __commonJS22({
      "src/utils/text/skip-inline-comment.js"(exports22, module22) {
        "use strict";
        function skipInlineComment(text, index) {
          if (index === false) {
            return false;
          }
          if (text.charAt(index) === "/" && text.charAt(index + 1) === "*") {
            for (let i = index + 2; i < text.length; ++i) {
              if (text.charAt(i) === "*" && text.charAt(i + 1) === "/") {
                return i + 2;
              }
            }
          }
          return index;
        }
        module22.exports = skipInlineComment;
      }
    });
    var require_skip_trailing_comment = __commonJS22({
      "src/utils/text/skip-trailing-comment.js"(exports22, module22) {
        "use strict";
        var {
          skipEverythingButNewLine
        } = require_skip();
        function skipTrailingComment(text, index) {
          if (index === false) {
            return false;
          }
          if (text.charAt(index) === "/" && text.charAt(index + 1) === "/") {
            return skipEverythingButNewLine(text, index);
          }
          return index;
        }
        module22.exports = skipTrailingComment;
      }
    });
    var require_skip_newline = __commonJS22({
      "src/utils/text/skip-newline.js"(exports22, module22) {
        "use strict";
        function skipNewline(text, index, opts) {
          const backwards = opts && opts.backwards;
          if (index === false) {
            return false;
          }
          const atIndex = text.charAt(index);
          if (backwards) {
            if (text.charAt(index - 1) === "\r" && atIndex === "\n") {
              return index - 2;
            }
            if (atIndex === "\n" || atIndex === "\r" || atIndex === "\u2028" || atIndex === "\u2029") {
              return index - 1;
            }
          } else {
            if (atIndex === "\r" && text.charAt(index + 1) === "\n") {
              return index + 2;
            }
            if (atIndex === "\n" || atIndex === "\r" || atIndex === "\u2028" || atIndex === "\u2029") {
              return index + 1;
            }
          }
          return index;
        }
        module22.exports = skipNewline;
      }
    });
    var require_get_next_non_space_non_comment_character_index_with_start_index = __commonJS22({
      "src/utils/text/get-next-non-space-non-comment-character-index-with-start-index.js"(exports22, module22) {
        "use strict";
        var skipInlineComment = require_skip_inline_comment();
        var skipNewline = require_skip_newline();
        var skipTrailingComment = require_skip_trailing_comment();
        var {
          skipSpaces
        } = require_skip();
        function getNextNonSpaceNonCommentCharacterIndexWithStartIndex(text, idx) {
          let oldIdx = null;
          let nextIdx = idx;
          while (nextIdx !== oldIdx) {
            oldIdx = nextIdx;
            nextIdx = skipSpaces(text, nextIdx);
            nextIdx = skipInlineComment(text, nextIdx);
            nextIdx = skipTrailingComment(text, nextIdx);
            nextIdx = skipNewline(text, nextIdx);
          }
          return nextIdx;
        }
        module22.exports = getNextNonSpaceNonCommentCharacterIndexWithStartIndex;
      }
    });
    var require_util2 = __commonJS22({
      "src/common/util.js"(exports22, module22) {
        "use strict";
        var {
          default: escapeStringRegexp2
        } = (init_escape_string_regexp(), __toCommonJS2(escape_string_regexp_exports));
        var getLast = require_get_last();
        var {
          getSupportInfo: getSupportInfo2
        } = require_support();
        var isNonEmptyArray = require_is_non_empty_array();
        var getStringWidth = require_get_string_width();
        var {
          skipWhitespace,
          skipSpaces,
          skipToLineEnd,
          skipEverythingButNewLine
        } = require_skip();
        var skipInlineComment = require_skip_inline_comment();
        var skipTrailingComment = require_skip_trailing_comment();
        var skipNewline = require_skip_newline();
        var getNextNonSpaceNonCommentCharacterIndexWithStartIndex = require_get_next_non_space_non_comment_character_index_with_start_index();
        var getPenultimate = (arr) => arr[arr.length - 2];
        function skip(chars) {
          return (text, index, opts) => {
            const backwards = opts && opts.backwards;
            if (index === false) {
              return false;
            }
            const {
              length
            } = text;
            let cursor = index;
            while (cursor >= 0 && cursor < length) {
              const c = text.charAt(cursor);
              if (chars instanceof RegExp) {
                if (!chars.test(c)) {
                  return cursor;
                }
              } else if (!chars.includes(c)) {
                return cursor;
              }
              backwards ? cursor-- : cursor++;
            }
            if (cursor === -1 || cursor === length) {
              return cursor;
            }
            return false;
          };
        }
        function hasNewline(text, index, opts = {}) {
          const idx = skipSpaces(text, opts.backwards ? index - 1 : index, opts);
          const idx2 = skipNewline(text, idx, opts);
          return idx !== idx2;
        }
        function hasNewlineInRange(text, start, end) {
          for (let i = start; i < end; ++i) {
            if (text.charAt(i) === "\n") {
              return true;
            }
          }
          return false;
        }
        function isPreviousLineEmpty(text, node, locStart) {
          let idx = locStart(node) - 1;
          idx = skipSpaces(text, idx, {
            backwards: true
          });
          idx = skipNewline(text, idx, {
            backwards: true
          });
          idx = skipSpaces(text, idx, {
            backwards: true
          });
          const idx2 = skipNewline(text, idx, {
            backwards: true
          });
          return idx !== idx2;
        }
        function isNextLineEmptyAfterIndex(text, index) {
          let oldIdx = null;
          let idx = index;
          while (idx !== oldIdx) {
            oldIdx = idx;
            idx = skipToLineEnd(text, idx);
            idx = skipInlineComment(text, idx);
            idx = skipSpaces(text, idx);
          }
          idx = skipTrailingComment(text, idx);
          idx = skipNewline(text, idx);
          return idx !== false && hasNewline(text, idx);
        }
        function isNextLineEmpty(text, node, locEnd) {
          return isNextLineEmptyAfterIndex(text, locEnd(node));
        }
        function getNextNonSpaceNonCommentCharacterIndex(text, node, locEnd) {
          return getNextNonSpaceNonCommentCharacterIndexWithStartIndex(text, locEnd(node));
        }
        function getNextNonSpaceNonCommentCharacter(text, node, locEnd) {
          return text.charAt(getNextNonSpaceNonCommentCharacterIndex(text, node, locEnd));
        }
        function hasSpaces(text, index, opts = {}) {
          const idx = skipSpaces(text, opts.backwards ? index - 1 : index, opts);
          return idx !== index;
        }
        function getAlignmentSize(value, tabWidth, startIndex = 0) {
          let size2 = 0;
          for (let i = startIndex; i < value.length; ++i) {
            if (value[i] === "	") {
              size2 = size2 + tabWidth - size2 % tabWidth;
            } else {
              size2++;
            }
          }
          return size2;
        }
        function getIndentSize(value, tabWidth) {
          const lastNewlineIndex = value.lastIndexOf("\n");
          if (lastNewlineIndex === -1) {
            return 0;
          }
          return getAlignmentSize(value.slice(lastNewlineIndex + 1).match(/^[\t ]*/)[0], tabWidth);
        }
        function getPreferredQuote(rawContent, preferredQuote) {
          const double = {
            quote: '"',
            regex: /"/g,
            escaped: "&quot;"
          };
          const single = {
            quote: "'",
            regex: /'/g,
            escaped: "&apos;"
          };
          const preferred = preferredQuote === "'" ? single : double;
          const alternate = preferred === single ? double : single;
          let result = preferred;
          if (rawContent.includes(preferred.quote) || rawContent.includes(alternate.quote)) {
            const numPreferredQuotes = (rawContent.match(preferred.regex) || []).length;
            const numAlternateQuotes = (rawContent.match(alternate.regex) || []).length;
            result = numPreferredQuotes > numAlternateQuotes ? alternate : preferred;
          }
          return result;
        }
        function printString(raw, options) {
          const rawContent = raw.slice(1, -1);
          const enclosingQuote = options.parser === "json" || options.parser === "json5" && options.quoteProps === "preserve" && !options.singleQuote ? '"' : options.__isInHtmlAttribute ? "'" : getPreferredQuote(rawContent, options.singleQuote ? "'" : '"').quote;
          return makeString(rawContent, enclosingQuote, !(options.parser === "css" || options.parser === "less" || options.parser === "scss" || options.__embeddedInHtml));
        }
        function makeString(rawContent, enclosingQuote, unescapeUnnecessaryEscapes) {
          const otherQuote = enclosingQuote === '"' ? "'" : '"';
          const regex = /\\(.)|(["'])/gs;
          const newContent = rawContent.replace(regex, (match, escaped, quote) => {
            if (escaped === otherQuote) {
              return escaped;
            }
            if (quote === enclosingQuote) {
              return "\\" + quote;
            }
            if (quote) {
              return quote;
            }
            return unescapeUnnecessaryEscapes && /^[^\n\r"'0-7\\bfnrt-vx\u2028\u2029]$/.test(escaped) ? escaped : "\\" + escaped;
          });
          return enclosingQuote + newContent + enclosingQuote;
        }
        function printNumber(rawNumber) {
          return rawNumber.toLowerCase().replace(/^([+-]?[\d.]+e)(?:\+|(-))?0*(\d)/, "$1$2$3").replace(/^([+-]?[\d.]+)e[+-]?0+$/, "$1").replace(/^([+-])?\./, "$10.").replace(/(\.\d+?)0+(?=e|$)/, "$1").replace(/\.(?=e|$)/, "");
        }
        function getMaxContinuousCount(str2, target) {
          const results = str2.match(new RegExp(`(${escapeStringRegexp2(target)})+`, "g"));
          if (results === null) {
            return 0;
          }
          return results.reduce((maxCount, result) => Math.max(maxCount, result.length / target.length), 0);
        }
        function getMinNotPresentContinuousCount(str2, target) {
          const matches = str2.match(new RegExp(`(${escapeStringRegexp2(target)})+`, "g"));
          if (matches === null) {
            return 0;
          }
          const countPresent = /* @__PURE__ */ new Map();
          let max = 0;
          for (const match of matches) {
            const count = match.length / target.length;
            countPresent.set(count, true);
            if (count > max) {
              max = count;
            }
          }
          for (let i = 1; i < max; i++) {
            if (!countPresent.get(i)) {
              return i;
            }
          }
          return max + 1;
        }
        function addCommentHelper(node, comment) {
          const comments = node.comments || (node.comments = []);
          comments.push(comment);
          comment.printed = false;
          comment.nodeDescription = describeNodeForDebugging(node);
        }
        function addLeadingComment(node, comment) {
          comment.leading = true;
          comment.trailing = false;
          addCommentHelper(node, comment);
        }
        function addDanglingComment(node, comment, marker) {
          comment.leading = false;
          comment.trailing = false;
          if (marker) {
            comment.marker = marker;
          }
          addCommentHelper(node, comment);
        }
        function addTrailingComment(node, comment) {
          comment.leading = false;
          comment.trailing = true;
          addCommentHelper(node, comment);
        }
        function inferParserByLanguage(language, options) {
          const {
            languages
          } = getSupportInfo2({
            plugins: options.plugins
          });
          const matched = languages.find(({
            name
          }) => name.toLowerCase() === language) || languages.find(({
            aliases
          }) => Array.isArray(aliases) && aliases.includes(language)) || languages.find(({
            extensions
          }) => Array.isArray(extensions) && extensions.includes(`.${language}`));
          return matched && matched.parsers[0];
        }
        function isFrontMatterNode(node) {
          return node && node.type === "front-matter";
        }
        function createGroupIdMapper(description) {
          const groupIds = /* @__PURE__ */ new WeakMap();
          return function(node) {
            if (!groupIds.has(node)) {
              groupIds.set(node, Symbol(description));
            }
            return groupIds.get(node);
          };
        }
        function describeNodeForDebugging(node) {
          const nodeType = node.type || node.kind || "(unknown type)";
          let nodeName = String(node.name || node.id && (typeof node.id === "object" ? node.id.name : node.id) || node.key && (typeof node.key === "object" ? node.key.name : node.key) || node.value && (typeof node.value === "object" ? "" : String(node.value)) || node.operator || "");
          if (nodeName.length > 20) {
            nodeName = nodeName.slice(0, 19) + "\u2026";
          }
          return nodeType + (nodeName ? " " + nodeName : "");
        }
        module22.exports = {
          inferParserByLanguage,
          getStringWidth,
          getMaxContinuousCount,
          getMinNotPresentContinuousCount,
          getPenultimate,
          getLast,
          getNextNonSpaceNonCommentCharacterIndexWithStartIndex,
          getNextNonSpaceNonCommentCharacterIndex,
          getNextNonSpaceNonCommentCharacter,
          skip,
          skipWhitespace,
          skipSpaces,
          skipToLineEnd,
          skipEverythingButNewLine,
          skipInlineComment,
          skipTrailingComment,
          skipNewline,
          isNextLineEmptyAfterIndex,
          isNextLineEmpty,
          isPreviousLineEmpty,
          hasNewline,
          hasNewlineInRange,
          hasSpaces,
          getAlignmentSize,
          getIndentSize,
          getPreferredQuote,
          printString,
          printNumber,
          makeString,
          addLeadingComment,
          addDanglingComment,
          addTrailingComment,
          isFrontMatterNode,
          isNonEmptyArray,
          createGroupIdMapper
        };
      }
    });
    var require_end_of_line = __commonJS22({
      "src/common/end-of-line.js"(exports22, module22) {
        "use strict";
        function guessEndOfLine(text) {
          const index = text.indexOf("\r");
          if (index >= 0) {
            return text.charAt(index + 1) === "\n" ? "crlf" : "cr";
          }
          return "lf";
        }
        function convertEndOfLineToChars(value) {
          switch (value) {
            case "cr":
              return "\r";
            case "crlf":
              return "\r\n";
            default:
              return "\n";
          }
        }
        function countEndOfLineChars(text, eol) {
          let regex;
          switch (eol) {
            case "\n":
              regex = /\n/g;
              break;
            case "\r":
              regex = /\r/g;
              break;
            case "\r\n":
              regex = /\r\n/g;
              break;
            default:
              throw new Error(`Unexpected "eol" ${JSON.stringify(eol)}.`);
          }
          const endOfLines = text.match(regex);
          return endOfLines ? endOfLines.length : 0;
        }
        function normalizeEndOfLine(text) {
          return text.replace(/\r\n?/g, "\n");
        }
        module22.exports = {
          guessEndOfLine,
          convertEndOfLineToChars,
          countEndOfLineChars,
          normalizeEndOfLine
        };
      }
    });
    var require_errors3 = __commonJS22({
      "src/common/errors.js"(exports22, module22) {
        "use strict";
        var ConfigError = class extends Error {
        };
        var DebugError = class extends Error {
        };
        var UndefinedParserError = class extends Error {
        };
        var ArgExpansionBailout = class extends Error {
        };
        module22.exports = {
          ConfigError,
          DebugError,
          UndefinedParserError,
          ArgExpansionBailout
        };
      }
    });
    var tslib_es6_exports = {};
    __export2(tslib_es6_exports, {
      __assign: () => __assign,
      __asyncDelegator: () => __asyncDelegator,
      __asyncGenerator: () => __asyncGenerator,
      __asyncValues: () => __asyncValues,
      __await: () => __await,
      __awaiter: () => __awaiter,
      __classPrivateFieldGet: () => __classPrivateFieldGet2,
      __classPrivateFieldSet: () => __classPrivateFieldSet2,
      __createBinding: () => __createBinding,
      __decorate: () => __decorate,
      __exportStar: () => __exportStar,
      __extends: () => __extends,
      __generator: () => __generator,
      __importDefault: () => __importDefault,
      __importStar: () => __importStar,
      __makeTemplateObject: () => __makeTemplateObject,
      __metadata: () => __metadata,
      __param: () => __param,
      __read: () => __read,
      __rest: () => __rest,
      __spread: () => __spread,
      __spreadArrays: () => __spreadArrays,
      __values: () => __values
    });
    function __extends(d, b) {
      extendStatics(d, b);
      function __() {
        this.constructor = d;
      }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    function __rest(s, e) {
      var t = {};
      for (var p in s)
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
          t[p] = s[p];
      if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
          if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
            t[p[i]] = s[p[i]];
        }
      return t;
    }
    function __decorate(decorators, target, key, desc) {
      var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
      if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
      else
        for (var i = decorators.length - 1; i >= 0; i--)
          if (d = decorators[i])
            r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
      return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
      return function(target, key) {
        decorator(target, key, paramIndex);
      };
    }
    function __metadata(metadataKey, metadataValue) {
      if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
        return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    }
    function __generator(thisArg, body) {
      var _ = {
        label: 0,
        sent: function() {
          if (t[0] & 1)
            throw t[1];
          return t[1];
        },
        trys: [],
        ops: []
      }, f, y, t, g;
      return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
      }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
      }), g;
      function verb(n) {
        return function(v) {
          return step([n, v]);
        };
      }
      function step(op) {
        if (f)
          throw new TypeError("Generator is already executing.");
        while (_)
          try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
              return t;
            if (y = 0, t)
              op = [op[0] & 2, t.value];
            switch (op[0]) {
              case 0:
              case 1:
                t = op;
                break;
              case 4:
                _.label++;
                return {
                  value: op[1],
                  done: false
                };
              case 5:
                _.label++;
                y = op[1];
                op = [0];
                continue;
              case 7:
                op = _.ops.pop();
                _.trys.pop();
                continue;
              default:
                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                  _ = 0;
                  continue;
                }
                if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                  _.label = op[1];
                  break;
                }
                if (op[0] === 6 && _.label < t[1]) {
                  _.label = t[1];
                  t = op;
                  break;
                }
                if (t && _.label < t[2]) {
                  _.label = t[2];
                  _.ops.push(op);
                  break;
                }
                if (t[2])
                  _.ops.pop();
                _.trys.pop();
                continue;
            }
            op = body.call(thisArg, _);
          } catch (e) {
            op = [6, e];
            y = 0;
          } finally {
            f = t = 0;
          }
        if (op[0] & 5)
          throw op[1];
        return {
          value: op[0] ? op[1] : void 0,
          done: true
        };
      }
    }
    function __createBinding(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    }
    function __exportStar(m, exports22) {
      for (var p in m)
        if (p !== "default" && !exports22.hasOwnProperty(p))
          exports22[p] = m[p];
    }
    function __values(o) {
      var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
      if (m)
        return m.call(o);
      if (o && typeof o.length === "number")
        return {
          next: function() {
            if (o && i >= o.length)
              o = void 0;
            return {
              value: o && o[i++],
              done: !o
            };
          }
        };
      throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
      var m = typeof Symbol === "function" && o[Symbol.iterator];
      if (!m)
        return o;
      var i = m.call(o), r, ar = [], e;
      try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
          ar.push(r.value);
      } catch (error) {
        e = {
          error
        };
      } finally {
        try {
          if (r && !r.done && (m = i["return"]))
            m.call(i);
        } finally {
          if (e)
            throw e.error;
        }
      }
      return ar;
    }
    function __spread() {
      for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
      return ar;
    }
    function __spreadArrays() {
      for (var s = 0, i = 0, il = arguments.length; i < il; i++)
        s += arguments[i].length;
      for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
          r[k] = a[j];
      return r;
    }
    function __await(v) {
      return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
      if (!Symbol.asyncIterator)
        throw new TypeError("Symbol.asyncIterator is not defined.");
      var g = generator.apply(thisArg, _arguments || []), i, q = [];
      return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
        return this;
      }, i;
      function verb(n) {
        if (g[n])
          i[n] = function(v) {
            return new Promise(function(a, b) {
              q.push([n, v, a, b]) > 1 || resume(n, v);
            });
          };
      }
      function resume(n, v) {
        try {
          step(g[n](v));
        } catch (e) {
          settle(q[0][3], e);
        }
      }
      function step(r) {
        r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r);
      }
      function fulfill(value) {
        resume("next", value);
      }
      function reject(value) {
        resume("throw", value);
      }
      function settle(f, v) {
        if (f(v), q.shift(), q.length)
          resume(q[0][0], q[0][1]);
      }
    }
    function __asyncDelegator(o) {
      var i, p;
      return i = {}, verb("next"), verb("throw", function(e) {
        throw e;
      }), verb("return"), i[Symbol.iterator] = function() {
        return this;
      }, i;
      function verb(n, f) {
        i[n] = o[n] ? function(v) {
          return (p = !p) ? {
            value: __await(o[n](v)),
            done: n === "return"
          } : f ? f(v) : v;
        } : f;
      }
    }
    function __asyncValues(o) {
      if (!Symbol.asyncIterator)
        throw new TypeError("Symbol.asyncIterator is not defined.");
      var m = o[Symbol.asyncIterator], i;
      return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
        return this;
      }, i);
      function verb(n) {
        i[n] = o[n] && function(v) {
          return new Promise(function(resolve, reject) {
            v = o[n](v), settle(resolve, reject, v.done, v.value);
          });
        };
      }
      function settle(resolve, reject, d, v) {
        Promise.resolve(v).then(function(v2) {
          resolve({
            value: v2,
            done: d
          });
        }, reject);
      }
    }
    function __makeTemplateObject(cooked, raw) {
      if (Object.defineProperty) {
        Object.defineProperty(cooked, "raw", {
          value: raw
        });
      } else {
        cooked.raw = raw;
      }
      return cooked;
    }
    function __importStar(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (Object.hasOwnProperty.call(mod, k))
            result[k] = mod[k];
      }
      result.default = mod;
      return result;
    }
    function __importDefault(mod) {
      return mod && mod.__esModule ? mod : {
        default: mod
      };
    }
    function __classPrivateFieldGet2(receiver, privateMap) {
      if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to get private field on non-instance");
      }
      return privateMap.get(receiver);
    }
    function __classPrivateFieldSet2(receiver, privateMap, value) {
      if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to set private field on non-instance");
      }
      privateMap.set(receiver, value);
      return value;
    }
    var extendStatics;
    var __assign;
    var init_tslib_es6 = __esm2({
      "node_modules/tslib/tslib.es6.js"() {
        extendStatics = function(d, b) {
          extendStatics = Object.setPrototypeOf || {
            __proto__: []
          } instanceof Array && function(d2, b2) {
            d2.__proto__ = b2;
          } || function(d2, b2) {
            for (var p in b2)
              if (b2.hasOwnProperty(p))
                d2[p] = b2[p];
          };
          return extendStatics(d, b);
        };
        __assign = function() {
          __assign = Object.assign || function __assign2(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
              s = arguments[i];
              for (var p in s)
                if (Object.prototype.hasOwnProperty.call(s, p))
                  t[p] = s[p];
            }
            return t;
          };
          return __assign.apply(this, arguments);
        };
      }
    });
    var require_api = __commonJS22({
      "node_modules/vnopts/lib/descriptors/api.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.apiDescriptor = {
          key: (key) => /^[$_a-zA-Z][$_a-zA-Z0-9]*$/.test(key) ? key : JSON.stringify(key),
          value(value) {
            if (value === null || typeof value !== "object") {
              return JSON.stringify(value);
            }
            if (Array.isArray(value)) {
              return `[${value.map((subValue) => exports22.apiDescriptor.value(subValue)).join(", ")}]`;
            }
            const keys5 = Object.keys(value);
            return keys5.length === 0 ? "{}" : `{ ${keys5.map((key) => `${exports22.apiDescriptor.key(key)}: ${exports22.apiDescriptor.value(value[key])}`).join(", ")} }`;
          },
          pair: ({
            key,
            value
          }) => exports22.apiDescriptor.value({
            [key]: value
          })
        };
      }
    });
    var require_descriptors2 = __commonJS22({
      "node_modules/vnopts/lib/descriptors/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var tslib_1 = (init_tslib_es6(), __toCommonJS2(tslib_es6_exports));
        tslib_1.__exportStar(require_api(), exports22);
      }
    });
    var require_escape_string_regexp = __commonJS22({
      "node_modules/vnopts/node_modules/escape-string-regexp/index.js"(exports22, module22) {
        "use strict";
        var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
        module22.exports = function(str2) {
          if (typeof str2 !== "string") {
            throw new TypeError("Expected a string");
          }
          return str2.replace(matchOperatorsRe, "\\$&");
        };
      }
    });
    var require_color_name = __commonJS22({
      "node_modules/color-name/index.js"(exports22, module22) {
        "use strict";
        module22.exports = {
          "aliceblue": [240, 248, 255],
          "antiquewhite": [250, 235, 215],
          "aqua": [0, 255, 255],
          "aquamarine": [127, 255, 212],
          "azure": [240, 255, 255],
          "beige": [245, 245, 220],
          "bisque": [255, 228, 196],
          "black": [0, 0, 0],
          "blanchedalmond": [255, 235, 205],
          "blue": [0, 0, 255],
          "blueviolet": [138, 43, 226],
          "brown": [165, 42, 42],
          "burlywood": [222, 184, 135],
          "cadetblue": [95, 158, 160],
          "chartreuse": [127, 255, 0],
          "chocolate": [210, 105, 30],
          "coral": [255, 127, 80],
          "cornflowerblue": [100, 149, 237],
          "cornsilk": [255, 248, 220],
          "crimson": [220, 20, 60],
          "cyan": [0, 255, 255],
          "darkblue": [0, 0, 139],
          "darkcyan": [0, 139, 139],
          "darkgoldenrod": [184, 134, 11],
          "darkgray": [169, 169, 169],
          "darkgreen": [0, 100, 0],
          "darkgrey": [169, 169, 169],
          "darkkhaki": [189, 183, 107],
          "darkmagenta": [139, 0, 139],
          "darkolivegreen": [85, 107, 47],
          "darkorange": [255, 140, 0],
          "darkorchid": [153, 50, 204],
          "darkred": [139, 0, 0],
          "darksalmon": [233, 150, 122],
          "darkseagreen": [143, 188, 143],
          "darkslateblue": [72, 61, 139],
          "darkslategray": [47, 79, 79],
          "darkslategrey": [47, 79, 79],
          "darkturquoise": [0, 206, 209],
          "darkviolet": [148, 0, 211],
          "deeppink": [255, 20, 147],
          "deepskyblue": [0, 191, 255],
          "dimgray": [105, 105, 105],
          "dimgrey": [105, 105, 105],
          "dodgerblue": [30, 144, 255],
          "firebrick": [178, 34, 34],
          "floralwhite": [255, 250, 240],
          "forestgreen": [34, 139, 34],
          "fuchsia": [255, 0, 255],
          "gainsboro": [220, 220, 220],
          "ghostwhite": [248, 248, 255],
          "gold": [255, 215, 0],
          "goldenrod": [218, 165, 32],
          "gray": [128, 128, 128],
          "green": [0, 128, 0],
          "greenyellow": [173, 255, 47],
          "grey": [128, 128, 128],
          "honeydew": [240, 255, 240],
          "hotpink": [255, 105, 180],
          "indianred": [205, 92, 92],
          "indigo": [75, 0, 130],
          "ivory": [255, 255, 240],
          "khaki": [240, 230, 140],
          "lavender": [230, 230, 250],
          "lavenderblush": [255, 240, 245],
          "lawngreen": [124, 252, 0],
          "lemonchiffon": [255, 250, 205],
          "lightblue": [173, 216, 230],
          "lightcoral": [240, 128, 128],
          "lightcyan": [224, 255, 255],
          "lightgoldenrodyellow": [250, 250, 210],
          "lightgray": [211, 211, 211],
          "lightgreen": [144, 238, 144],
          "lightgrey": [211, 211, 211],
          "lightpink": [255, 182, 193],
          "lightsalmon": [255, 160, 122],
          "lightseagreen": [32, 178, 170],
          "lightskyblue": [135, 206, 250],
          "lightslategray": [119, 136, 153],
          "lightslategrey": [119, 136, 153],
          "lightsteelblue": [176, 196, 222],
          "lightyellow": [255, 255, 224],
          "lime": [0, 255, 0],
          "limegreen": [50, 205, 50],
          "linen": [250, 240, 230],
          "magenta": [255, 0, 255],
          "maroon": [128, 0, 0],
          "mediumaquamarine": [102, 205, 170],
          "mediumblue": [0, 0, 205],
          "mediumorchid": [186, 85, 211],
          "mediumpurple": [147, 112, 219],
          "mediumseagreen": [60, 179, 113],
          "mediumslateblue": [123, 104, 238],
          "mediumspringgreen": [0, 250, 154],
          "mediumturquoise": [72, 209, 204],
          "mediumvioletred": [199, 21, 133],
          "midnightblue": [25, 25, 112],
          "mintcream": [245, 255, 250],
          "mistyrose": [255, 228, 225],
          "moccasin": [255, 228, 181],
          "navajowhite": [255, 222, 173],
          "navy": [0, 0, 128],
          "oldlace": [253, 245, 230],
          "olive": [128, 128, 0],
          "olivedrab": [107, 142, 35],
          "orange": [255, 165, 0],
          "orangered": [255, 69, 0],
          "orchid": [218, 112, 214],
          "palegoldenrod": [238, 232, 170],
          "palegreen": [152, 251, 152],
          "paleturquoise": [175, 238, 238],
          "palevioletred": [219, 112, 147],
          "papayawhip": [255, 239, 213],
          "peachpuff": [255, 218, 185],
          "peru": [205, 133, 63],
          "pink": [255, 192, 203],
          "plum": [221, 160, 221],
          "powderblue": [176, 224, 230],
          "purple": [128, 0, 128],
          "rebeccapurple": [102, 51, 153],
          "red": [255, 0, 0],
          "rosybrown": [188, 143, 143],
          "royalblue": [65, 105, 225],
          "saddlebrown": [139, 69, 19],
          "salmon": [250, 128, 114],
          "sandybrown": [244, 164, 96],
          "seagreen": [46, 139, 87],
          "seashell": [255, 245, 238],
          "sienna": [160, 82, 45],
          "silver": [192, 192, 192],
          "skyblue": [135, 206, 235],
          "slateblue": [106, 90, 205],
          "slategray": [112, 128, 144],
          "slategrey": [112, 128, 144],
          "snow": [255, 250, 250],
          "springgreen": [0, 255, 127],
          "steelblue": [70, 130, 180],
          "tan": [210, 180, 140],
          "teal": [0, 128, 128],
          "thistle": [216, 191, 216],
          "tomato": [255, 99, 71],
          "turquoise": [64, 224, 208],
          "violet": [238, 130, 238],
          "wheat": [245, 222, 179],
          "white": [255, 255, 255],
          "whitesmoke": [245, 245, 245],
          "yellow": [255, 255, 0],
          "yellowgreen": [154, 205, 50]
        };
      }
    });
    var require_conversions = __commonJS22({
      "node_modules/color-convert/conversions.js"(exports22, module22) {
        var cssKeywords = require_color_name();
        var reverseKeywords = {};
        for (key in cssKeywords) {
          if (cssKeywords.hasOwnProperty(key)) {
            reverseKeywords[cssKeywords[key]] = key;
          }
        }
        var key;
        var convert4 = module22.exports = {
          rgb: {
            channels: 3,
            labels: "rgb"
          },
          hsl: {
            channels: 3,
            labels: "hsl"
          },
          hsv: {
            channels: 3,
            labels: "hsv"
          },
          hwb: {
            channels: 3,
            labels: "hwb"
          },
          cmyk: {
            channels: 4,
            labels: "cmyk"
          },
          xyz: {
            channels: 3,
            labels: "xyz"
          },
          lab: {
            channels: 3,
            labels: "lab"
          },
          lch: {
            channels: 3,
            labels: "lch"
          },
          hex: {
            channels: 1,
            labels: ["hex"]
          },
          keyword: {
            channels: 1,
            labels: ["keyword"]
          },
          ansi16: {
            channels: 1,
            labels: ["ansi16"]
          },
          ansi256: {
            channels: 1,
            labels: ["ansi256"]
          },
          hcg: {
            channels: 3,
            labels: ["h", "c", "g"]
          },
          apple: {
            channels: 3,
            labels: ["r16", "g16", "b16"]
          },
          gray: {
            channels: 1,
            labels: ["gray"]
          }
        };
        for (model in convert4) {
          if (convert4.hasOwnProperty(model)) {
            if (!("channels" in convert4[model])) {
              throw new Error("missing channels property: " + model);
            }
            if (!("labels" in convert4[model])) {
              throw new Error("missing channel labels property: " + model);
            }
            if (convert4[model].labels.length !== convert4[model].channels) {
              throw new Error("channel and label counts mismatch: " + model);
            }
            channels = convert4[model].channels;
            labels = convert4[model].labels;
            delete convert4[model].channels;
            delete convert4[model].labels;
            Object.defineProperty(convert4[model], "channels", {
              value: channels
            });
            Object.defineProperty(convert4[model], "labels", {
              value: labels
            });
          }
        }
        var channels;
        var labels;
        var model;
        convert4.rgb.hsl = function(rgb) {
          var r = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          var min = Math.min(r, g, b);
          var max = Math.max(r, g, b);
          var delta = max - min;
          var h;
          var s;
          var l;
          if (max === min) {
            h = 0;
          } else if (r === max) {
            h = (g - b) / delta;
          } else if (g === max) {
            h = 2 + (b - r) / delta;
          } else if (b === max) {
            h = 4 + (r - g) / delta;
          }
          h = Math.min(h * 60, 360);
          if (h < 0) {
            h += 360;
          }
          l = (min + max) / 2;
          if (max === min) {
            s = 0;
          } else if (l <= 0.5) {
            s = delta / (max + min);
          } else {
            s = delta / (2 - max - min);
          }
          return [h, s * 100, l * 100];
        };
        convert4.rgb.hsv = function(rgb) {
          var rdif;
          var gdif;
          var bdif;
          var h;
          var s;
          var r = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          var v = Math.max(r, g, b);
          var diff = v - Math.min(r, g, b);
          var diffc = function(c) {
            return (v - c) / 6 / diff + 1 / 2;
          };
          if (diff === 0) {
            h = s = 0;
          } else {
            s = diff / v;
            rdif = diffc(r);
            gdif = diffc(g);
            bdif = diffc(b);
            if (r === v) {
              h = bdif - gdif;
            } else if (g === v) {
              h = 1 / 3 + rdif - bdif;
            } else if (b === v) {
              h = 2 / 3 + gdif - rdif;
            }
            if (h < 0) {
              h += 1;
            } else if (h > 1) {
              h -= 1;
            }
          }
          return [h * 360, s * 100, v * 100];
        };
        convert4.rgb.hwb = function(rgb) {
          var r = rgb[0];
          var g = rgb[1];
          var b = rgb[2];
          var h = convert4.rgb.hsl(rgb)[0];
          var w = 1 / 255 * Math.min(r, Math.min(g, b));
          b = 1 - 1 / 255 * Math.max(r, Math.max(g, b));
          return [h, w * 100, b * 100];
        };
        convert4.rgb.cmyk = function(rgb) {
          var r = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          var c;
          var m;
          var y;
          var k;
          k = Math.min(1 - r, 1 - g, 1 - b);
          c = (1 - r - k) / (1 - k) || 0;
          m = (1 - g - k) / (1 - k) || 0;
          y = (1 - b - k) / (1 - k) || 0;
          return [c * 100, m * 100, y * 100, k * 100];
        };
        function comparativeDistance(x, y) {
          return Math.pow(x[0] - y[0], 2) + Math.pow(x[1] - y[1], 2) + Math.pow(x[2] - y[2], 2);
        }
        convert4.rgb.keyword = function(rgb) {
          var reversed = reverseKeywords[rgb];
          if (reversed) {
            return reversed;
          }
          var currentClosestDistance = Infinity;
          var currentClosestKeyword;
          for (var keyword in cssKeywords) {
            if (cssKeywords.hasOwnProperty(keyword)) {
              var value = cssKeywords[keyword];
              var distance = comparativeDistance(rgb, value);
              if (distance < currentClosestDistance) {
                currentClosestDistance = distance;
                currentClosestKeyword = keyword;
              }
            }
          }
          return currentClosestKeyword;
        };
        convert4.keyword.rgb = function(keyword) {
          return cssKeywords[keyword];
        };
        convert4.rgb.xyz = function(rgb) {
          var r = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          r = r > 0.04045 ? Math.pow((r + 0.055) / 1.055, 2.4) : r / 12.92;
          g = g > 0.04045 ? Math.pow((g + 0.055) / 1.055, 2.4) : g / 12.92;
          b = b > 0.04045 ? Math.pow((b + 0.055) / 1.055, 2.4) : b / 12.92;
          var x = r * 0.4124 + g * 0.3576 + b * 0.1805;
          var y = r * 0.2126 + g * 0.7152 + b * 0.0722;
          var z2 = r * 0.0193 + g * 0.1192 + b * 0.9505;
          return [x * 100, y * 100, z2 * 100];
        };
        convert4.rgb.lab = function(rgb) {
          var xyz = convert4.rgb.xyz(rgb);
          var x = xyz[0];
          var y = xyz[1];
          var z2 = xyz[2];
          var l;
          var a;
          var b;
          x /= 95.047;
          y /= 100;
          z2 /= 108.883;
          x = x > 8856e-6 ? Math.pow(x, 1 / 3) : 7.787 * x + 16 / 116;
          y = y > 8856e-6 ? Math.pow(y, 1 / 3) : 7.787 * y + 16 / 116;
          z2 = z2 > 8856e-6 ? Math.pow(z2, 1 / 3) : 7.787 * z2 + 16 / 116;
          l = 116 * y - 16;
          a = 500 * (x - y);
          b = 200 * (y - z2);
          return [l, a, b];
        };
        convert4.hsl.rgb = function(hsl) {
          var h = hsl[0] / 360;
          var s = hsl[1] / 100;
          var l = hsl[2] / 100;
          var t1;
          var t2;
          var t3;
          var rgb;
          var val;
          if (s === 0) {
            val = l * 255;
            return [val, val, val];
          }
          if (l < 0.5) {
            t2 = l * (1 + s);
          } else {
            t2 = l + s - l * s;
          }
          t1 = 2 * l - t2;
          rgb = [0, 0, 0];
          for (var i = 0; i < 3; i++) {
            t3 = h + 1 / 3 * -(i - 1);
            if (t3 < 0) {
              t3++;
            }
            if (t3 > 1) {
              t3--;
            }
            if (6 * t3 < 1) {
              val = t1 + (t2 - t1) * 6 * t3;
            } else if (2 * t3 < 1) {
              val = t2;
            } else if (3 * t3 < 2) {
              val = t1 + (t2 - t1) * (2 / 3 - t3) * 6;
            } else {
              val = t1;
            }
            rgb[i] = val * 255;
          }
          return rgb;
        };
        convert4.hsl.hsv = function(hsl) {
          var h = hsl[0];
          var s = hsl[1] / 100;
          var l = hsl[2] / 100;
          var smin = s;
          var lmin = Math.max(l, 0.01);
          var sv;
          var v;
          l *= 2;
          s *= l <= 1 ? l : 2 - l;
          smin *= lmin <= 1 ? lmin : 2 - lmin;
          v = (l + s) / 2;
          sv = l === 0 ? 2 * smin / (lmin + smin) : 2 * s / (l + s);
          return [h, sv * 100, v * 100];
        };
        convert4.hsv.rgb = function(hsv) {
          var h = hsv[0] / 60;
          var s = hsv[1] / 100;
          var v = hsv[2] / 100;
          var hi = Math.floor(h) % 6;
          var f = h - Math.floor(h);
          var p = 255 * v * (1 - s);
          var q = 255 * v * (1 - s * f);
          var t = 255 * v * (1 - s * (1 - f));
          v *= 255;
          switch (hi) {
            case 0:
              return [v, t, p];
            case 1:
              return [q, v, p];
            case 2:
              return [p, v, t];
            case 3:
              return [p, q, v];
            case 4:
              return [t, p, v];
            case 5:
              return [v, p, q];
          }
        };
        convert4.hsv.hsl = function(hsv) {
          var h = hsv[0];
          var s = hsv[1] / 100;
          var v = hsv[2] / 100;
          var vmin = Math.max(v, 0.01);
          var lmin;
          var sl;
          var l;
          l = (2 - s) * v;
          lmin = (2 - s) * vmin;
          sl = s * vmin;
          sl /= lmin <= 1 ? lmin : 2 - lmin;
          sl = sl || 0;
          l /= 2;
          return [h, sl * 100, l * 100];
        };
        convert4.hwb.rgb = function(hwb) {
          var h = hwb[0] / 360;
          var wh = hwb[1] / 100;
          var bl = hwb[2] / 100;
          var ratio = wh + bl;
          var i;
          var v;
          var f;
          var n;
          if (ratio > 1) {
            wh /= ratio;
            bl /= ratio;
          }
          i = Math.floor(6 * h);
          v = 1 - bl;
          f = 6 * h - i;
          if ((i & 1) !== 0) {
            f = 1 - f;
          }
          n = wh + f * (v - wh);
          var r;
          var g;
          var b;
          switch (i) {
            default:
            case 6:
            case 0:
              r = v;
              g = n;
              b = wh;
              break;
            case 1:
              r = n;
              g = v;
              b = wh;
              break;
            case 2:
              r = wh;
              g = v;
              b = n;
              break;
            case 3:
              r = wh;
              g = n;
              b = v;
              break;
            case 4:
              r = n;
              g = wh;
              b = v;
              break;
            case 5:
              r = v;
              g = wh;
              b = n;
              break;
          }
          return [r * 255, g * 255, b * 255];
        };
        convert4.cmyk.rgb = function(cmyk) {
          var c = cmyk[0] / 100;
          var m = cmyk[1] / 100;
          var y = cmyk[2] / 100;
          var k = cmyk[3] / 100;
          var r;
          var g;
          var b;
          r = 1 - Math.min(1, c * (1 - k) + k);
          g = 1 - Math.min(1, m * (1 - k) + k);
          b = 1 - Math.min(1, y * (1 - k) + k);
          return [r * 255, g * 255, b * 255];
        };
        convert4.xyz.rgb = function(xyz) {
          var x = xyz[0] / 100;
          var y = xyz[1] / 100;
          var z2 = xyz[2] / 100;
          var r;
          var g;
          var b;
          r = x * 3.2406 + y * -1.5372 + z2 * -0.4986;
          g = x * -0.9689 + y * 1.8758 + z2 * 0.0415;
          b = x * 0.0557 + y * -0.204 + z2 * 1.057;
          r = r > 31308e-7 ? 1.055 * Math.pow(r, 1 / 2.4) - 0.055 : r * 12.92;
          g = g > 31308e-7 ? 1.055 * Math.pow(g, 1 / 2.4) - 0.055 : g * 12.92;
          b = b > 31308e-7 ? 1.055 * Math.pow(b, 1 / 2.4) - 0.055 : b * 12.92;
          r = Math.min(Math.max(0, r), 1);
          g = Math.min(Math.max(0, g), 1);
          b = Math.min(Math.max(0, b), 1);
          return [r * 255, g * 255, b * 255];
        };
        convert4.xyz.lab = function(xyz) {
          var x = xyz[0];
          var y = xyz[1];
          var z2 = xyz[2];
          var l;
          var a;
          var b;
          x /= 95.047;
          y /= 100;
          z2 /= 108.883;
          x = x > 8856e-6 ? Math.pow(x, 1 / 3) : 7.787 * x + 16 / 116;
          y = y > 8856e-6 ? Math.pow(y, 1 / 3) : 7.787 * y + 16 / 116;
          z2 = z2 > 8856e-6 ? Math.pow(z2, 1 / 3) : 7.787 * z2 + 16 / 116;
          l = 116 * y - 16;
          a = 500 * (x - y);
          b = 200 * (y - z2);
          return [l, a, b];
        };
        convert4.lab.xyz = function(lab) {
          var l = lab[0];
          var a = lab[1];
          var b = lab[2];
          var x;
          var y;
          var z2;
          y = (l + 16) / 116;
          x = a / 500 + y;
          z2 = y - b / 200;
          var y2 = Math.pow(y, 3);
          var x2 = Math.pow(x, 3);
          var z22 = Math.pow(z2, 3);
          y = y2 > 8856e-6 ? y2 : (y - 16 / 116) / 7.787;
          x = x2 > 8856e-6 ? x2 : (x - 16 / 116) / 7.787;
          z2 = z22 > 8856e-6 ? z22 : (z2 - 16 / 116) / 7.787;
          x *= 95.047;
          y *= 100;
          z2 *= 108.883;
          return [x, y, z2];
        };
        convert4.lab.lch = function(lab) {
          var l = lab[0];
          var a = lab[1];
          var b = lab[2];
          var hr;
          var h;
          var c;
          hr = Math.atan2(b, a);
          h = hr * 360 / 2 / Math.PI;
          if (h < 0) {
            h += 360;
          }
          c = Math.sqrt(a * a + b * b);
          return [l, c, h];
        };
        convert4.lch.lab = function(lch) {
          var l = lch[0];
          var c = lch[1];
          var h = lch[2];
          var a;
          var b;
          var hr;
          hr = h / 360 * 2 * Math.PI;
          a = c * Math.cos(hr);
          b = c * Math.sin(hr);
          return [l, a, b];
        };
        convert4.rgb.ansi16 = function(args) {
          var r = args[0];
          var g = args[1];
          var b = args[2];
          var value = 1 in arguments ? arguments[1] : convert4.rgb.hsv(args)[2];
          value = Math.round(value / 50);
          if (value === 0) {
            return 30;
          }
          var ansi = 30 + (Math.round(b / 255) << 2 | Math.round(g / 255) << 1 | Math.round(r / 255));
          if (value === 2) {
            ansi += 60;
          }
          return ansi;
        };
        convert4.hsv.ansi16 = function(args) {
          return convert4.rgb.ansi16(convert4.hsv.rgb(args), args[2]);
        };
        convert4.rgb.ansi256 = function(args) {
          var r = args[0];
          var g = args[1];
          var b = args[2];
          if (r === g && g === b) {
            if (r < 8) {
              return 16;
            }
            if (r > 248) {
              return 231;
            }
            return Math.round((r - 8) / 247 * 24) + 232;
          }
          var ansi = 16 + 36 * Math.round(r / 255 * 5) + 6 * Math.round(g / 255 * 5) + Math.round(b / 255 * 5);
          return ansi;
        };
        convert4.ansi16.rgb = function(args) {
          var color = args % 10;
          if (color === 0 || color === 7) {
            if (args > 50) {
              color += 3.5;
            }
            color = color / 10.5 * 255;
            return [color, color, color];
          }
          var mult = (~~(args > 50) + 1) * 0.5;
          var r = (color & 1) * mult * 255;
          var g = (color >> 1 & 1) * mult * 255;
          var b = (color >> 2 & 1) * mult * 255;
          return [r, g, b];
        };
        convert4.ansi256.rgb = function(args) {
          if (args >= 232) {
            var c = (args - 232) * 10 + 8;
            return [c, c, c];
          }
          args -= 16;
          var rem;
          var r = Math.floor(args / 36) / 5 * 255;
          var g = Math.floor((rem = args % 36) / 6) / 5 * 255;
          var b = rem % 6 / 5 * 255;
          return [r, g, b];
        };
        convert4.rgb.hex = function(args) {
          var integer = ((Math.round(args[0]) & 255) << 16) + ((Math.round(args[1]) & 255) << 8) + (Math.round(args[2]) & 255);
          var string3 = integer.toString(16).toUpperCase();
          return "000000".substring(string3.length) + string3;
        };
        convert4.hex.rgb = function(args) {
          var match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
          if (!match) {
            return [0, 0, 0];
          }
          var colorString = match[0];
          if (match[0].length === 3) {
            colorString = colorString.split("").map(function(char) {
              return char + char;
            }).join("");
          }
          var integer = parseInt(colorString, 16);
          var r = integer >> 16 & 255;
          var g = integer >> 8 & 255;
          var b = integer & 255;
          return [r, g, b];
        };
        convert4.rgb.hcg = function(rgb) {
          var r = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          var max = Math.max(Math.max(r, g), b);
          var min = Math.min(Math.min(r, g), b);
          var chroma = max - min;
          var grayscale;
          var hue;
          if (chroma < 1) {
            grayscale = min / (1 - chroma);
          } else {
            grayscale = 0;
          }
          if (chroma <= 0) {
            hue = 0;
          } else if (max === r) {
            hue = (g - b) / chroma % 6;
          } else if (max === g) {
            hue = 2 + (b - r) / chroma;
          } else {
            hue = 4 + (r - g) / chroma + 4;
          }
          hue /= 6;
          hue %= 1;
          return [hue * 360, chroma * 100, grayscale * 100];
        };
        convert4.hsl.hcg = function(hsl) {
          var s = hsl[1] / 100;
          var l = hsl[2] / 100;
          var c = 1;
          var f = 0;
          if (l < 0.5) {
            c = 2 * s * l;
          } else {
            c = 2 * s * (1 - l);
          }
          if (c < 1) {
            f = (l - 0.5 * c) / (1 - c);
          }
          return [hsl[0], c * 100, f * 100];
        };
        convert4.hsv.hcg = function(hsv) {
          var s = hsv[1] / 100;
          var v = hsv[2] / 100;
          var c = s * v;
          var f = 0;
          if (c < 1) {
            f = (v - c) / (1 - c);
          }
          return [hsv[0], c * 100, f * 100];
        };
        convert4.hcg.rgb = function(hcg) {
          var h = hcg[0] / 360;
          var c = hcg[1] / 100;
          var g = hcg[2] / 100;
          if (c === 0) {
            return [g * 255, g * 255, g * 255];
          }
          var pure = [0, 0, 0];
          var hi = h % 1 * 6;
          var v = hi % 1;
          var w = 1 - v;
          var mg = 0;
          switch (Math.floor(hi)) {
            case 0:
              pure[0] = 1;
              pure[1] = v;
              pure[2] = 0;
              break;
            case 1:
              pure[0] = w;
              pure[1] = 1;
              pure[2] = 0;
              break;
            case 2:
              pure[0] = 0;
              pure[1] = 1;
              pure[2] = v;
              break;
            case 3:
              pure[0] = 0;
              pure[1] = w;
              pure[2] = 1;
              break;
            case 4:
              pure[0] = v;
              pure[1] = 0;
              pure[2] = 1;
              break;
            default:
              pure[0] = 1;
              pure[1] = 0;
              pure[2] = w;
          }
          mg = (1 - c) * g;
          return [(c * pure[0] + mg) * 255, (c * pure[1] + mg) * 255, (c * pure[2] + mg) * 255];
        };
        convert4.hcg.hsv = function(hcg) {
          var c = hcg[1] / 100;
          var g = hcg[2] / 100;
          var v = c + g * (1 - c);
          var f = 0;
          if (v > 0) {
            f = c / v;
          }
          return [hcg[0], f * 100, v * 100];
        };
        convert4.hcg.hsl = function(hcg) {
          var c = hcg[1] / 100;
          var g = hcg[2] / 100;
          var l = g * (1 - c) + 0.5 * c;
          var s = 0;
          if (l > 0 && l < 0.5) {
            s = c / (2 * l);
          } else if (l >= 0.5 && l < 1) {
            s = c / (2 * (1 - l));
          }
          return [hcg[0], s * 100, l * 100];
        };
        convert4.hcg.hwb = function(hcg) {
          var c = hcg[1] / 100;
          var g = hcg[2] / 100;
          var v = c + g * (1 - c);
          return [hcg[0], (v - c) * 100, (1 - v) * 100];
        };
        convert4.hwb.hcg = function(hwb) {
          var w = hwb[1] / 100;
          var b = hwb[2] / 100;
          var v = 1 - b;
          var c = v - w;
          var g = 0;
          if (c < 1) {
            g = (v - c) / (1 - c);
          }
          return [hwb[0], c * 100, g * 100];
        };
        convert4.apple.rgb = function(apple) {
          return [apple[0] / 65535 * 255, apple[1] / 65535 * 255, apple[2] / 65535 * 255];
        };
        convert4.rgb.apple = function(rgb) {
          return [rgb[0] / 255 * 65535, rgb[1] / 255 * 65535, rgb[2] / 255 * 65535];
        };
        convert4.gray.rgb = function(args) {
          return [args[0] / 100 * 255, args[0] / 100 * 255, args[0] / 100 * 255];
        };
        convert4.gray.hsl = convert4.gray.hsv = function(args) {
          return [0, 0, args[0]];
        };
        convert4.gray.hwb = function(gray) {
          return [0, 100, gray[0]];
        };
        convert4.gray.cmyk = function(gray) {
          return [0, 0, 0, gray[0]];
        };
        convert4.gray.lab = function(gray) {
          return [gray[0], 0, 0];
        };
        convert4.gray.hex = function(gray) {
          var val = Math.round(gray[0] / 100 * 255) & 255;
          var integer = (val << 16) + (val << 8) + val;
          var string3 = integer.toString(16).toUpperCase();
          return "000000".substring(string3.length) + string3;
        };
        convert4.rgb.gray = function(rgb) {
          var val = (rgb[0] + rgb[1] + rgb[2]) / 3;
          return [val / 255 * 100];
        };
      }
    });
    var require_route = __commonJS22({
      "node_modules/color-convert/route.js"(exports22, module22) {
        var conversions = require_conversions();
        function buildGraph() {
          var graph = {};
          var models = Object.keys(conversions);
          for (var len = models.length, i = 0; i < len; i++) {
            graph[models[i]] = {
              distance: -1,
              parent: null
            };
          }
          return graph;
        }
        function deriveBFS(fromModel) {
          var graph = buildGraph();
          var queue = [fromModel];
          graph[fromModel].distance = 0;
          while (queue.length) {
            var current = queue.pop();
            var adjacents = Object.keys(conversions[current]);
            for (var len = adjacents.length, i = 0; i < len; i++) {
              var adjacent = adjacents[i];
              var node = graph[adjacent];
              if (node.distance === -1) {
                node.distance = graph[current].distance + 1;
                node.parent = current;
                queue.unshift(adjacent);
              }
            }
          }
          return graph;
        }
        function link(from, to) {
          return function(args) {
            return to(from(args));
          };
        }
        function wrapConversion(toModel, graph) {
          var path5 = [graph[toModel].parent, toModel];
          var fn = conversions[graph[toModel].parent][toModel];
          var cur = graph[toModel].parent;
          while (graph[cur].parent) {
            path5.unshift(graph[cur].parent);
            fn = link(conversions[graph[cur].parent][cur], fn);
            cur = graph[cur].parent;
          }
          fn.conversion = path5;
          return fn;
        }
        module22.exports = function(fromModel) {
          var graph = deriveBFS(fromModel);
          var conversion = {};
          var models = Object.keys(graph);
          for (var len = models.length, i = 0; i < len; i++) {
            var toModel = models[i];
            var node = graph[toModel];
            if (node.parent === null) {
              continue;
            }
            conversion[toModel] = wrapConversion(toModel, graph);
          }
          return conversion;
        };
      }
    });
    var require_color_convert = __commonJS22({
      "node_modules/color-convert/index.js"(exports22, module22) {
        var conversions = require_conversions();
        var route = require_route();
        var convert4 = {};
        var models = Object.keys(conversions);
        function wrapRaw(fn) {
          var wrappedFn = function(args) {
            if (args === void 0 || args === null) {
              return args;
            }
            if (arguments.length > 1) {
              args = Array.prototype.slice.call(arguments);
            }
            return fn(args);
          };
          if ("conversion" in fn) {
            wrappedFn.conversion = fn.conversion;
          }
          return wrappedFn;
        }
        function wrapRounded(fn) {
          var wrappedFn = function(args) {
            if (args === void 0 || args === null) {
              return args;
            }
            if (arguments.length > 1) {
              args = Array.prototype.slice.call(arguments);
            }
            var result = fn(args);
            if (typeof result === "object") {
              for (var len = result.length, i = 0; i < len; i++) {
                result[i] = Math.round(result[i]);
              }
            }
            return result;
          };
          if ("conversion" in fn) {
            wrappedFn.conversion = fn.conversion;
          }
          return wrappedFn;
        }
        models.forEach(function(fromModel) {
          convert4[fromModel] = {};
          Object.defineProperty(convert4[fromModel], "channels", {
            value: conversions[fromModel].channels
          });
          Object.defineProperty(convert4[fromModel], "labels", {
            value: conversions[fromModel].labels
          });
          var routes = route(fromModel);
          var routeModels = Object.keys(routes);
          routeModels.forEach(function(toModel) {
            var fn = routes[toModel];
            convert4[fromModel][toModel] = wrapRounded(fn);
            convert4[fromModel][toModel].raw = wrapRaw(fn);
          });
        });
        module22.exports = convert4;
      }
    });
    var require_ansi_styles = __commonJS22({
      "node_modules/ansi-styles/index.js"(exports22, module22) {
        "use strict";
        var colorConvert = require_color_convert();
        var wrapAnsi16 = (fn, offset) => function() {
          const code = fn.apply(colorConvert, arguments);
          return `\x1B[${code + offset}m`;
        };
        var wrapAnsi256 = (fn, offset) => function() {
          const code = fn.apply(colorConvert, arguments);
          return `\x1B[${38 + offset};5;${code}m`;
        };
        var wrapAnsi16m = (fn, offset) => function() {
          const rgb = fn.apply(colorConvert, arguments);
          return `\x1B[${38 + offset};2;${rgb[0]};${rgb[1]};${rgb[2]}m`;
        };
        function assembleStyles() {
          const codes = /* @__PURE__ */ new Map();
          const styles = {
            modifier: {
              reset: [0, 0],
              bold: [1, 22],
              dim: [2, 22],
              italic: [3, 23],
              underline: [4, 24],
              inverse: [7, 27],
              hidden: [8, 28],
              strikethrough: [9, 29]
            },
            color: {
              black: [30, 39],
              red: [31, 39],
              green: [32, 39],
              yellow: [33, 39],
              blue: [34, 39],
              magenta: [35, 39],
              cyan: [36, 39],
              white: [37, 39],
              gray: [90, 39],
              redBright: [91, 39],
              greenBright: [92, 39],
              yellowBright: [93, 39],
              blueBright: [94, 39],
              magentaBright: [95, 39],
              cyanBright: [96, 39],
              whiteBright: [97, 39]
            },
            bgColor: {
              bgBlack: [40, 49],
              bgRed: [41, 49],
              bgGreen: [42, 49],
              bgYellow: [43, 49],
              bgBlue: [44, 49],
              bgMagenta: [45, 49],
              bgCyan: [46, 49],
              bgWhite: [47, 49],
              bgBlackBright: [100, 49],
              bgRedBright: [101, 49],
              bgGreenBright: [102, 49],
              bgYellowBright: [103, 49],
              bgBlueBright: [104, 49],
              bgMagentaBright: [105, 49],
              bgCyanBright: [106, 49],
              bgWhiteBright: [107, 49]
            }
          };
          styles.color.grey = styles.color.gray;
          for (const groupName of Object.keys(styles)) {
            const group = styles[groupName];
            for (const styleName of Object.keys(group)) {
              const style = group[styleName];
              styles[styleName] = {
                open: `\x1B[${style[0]}m`,
                close: `\x1B[${style[1]}m`
              };
              group[styleName] = styles[styleName];
              codes.set(style[0], style[1]);
            }
            Object.defineProperty(styles, groupName, {
              value: group,
              enumerable: false
            });
            Object.defineProperty(styles, "codes", {
              value: codes,
              enumerable: false
            });
          }
          const ansi2ansi = (n) => n;
          const rgb2rgb = (r, g, b) => [r, g, b];
          styles.color.close = "\x1B[39m";
          styles.bgColor.close = "\x1B[49m";
          styles.color.ansi = {
            ansi: wrapAnsi16(ansi2ansi, 0)
          };
          styles.color.ansi256 = {
            ansi256: wrapAnsi256(ansi2ansi, 0)
          };
          styles.color.ansi16m = {
            rgb: wrapAnsi16m(rgb2rgb, 0)
          };
          styles.bgColor.ansi = {
            ansi: wrapAnsi16(ansi2ansi, 10)
          };
          styles.bgColor.ansi256 = {
            ansi256: wrapAnsi256(ansi2ansi, 10)
          };
          styles.bgColor.ansi16m = {
            rgb: wrapAnsi16m(rgb2rgb, 10)
          };
          for (let key of Object.keys(colorConvert)) {
            if (typeof colorConvert[key] !== "object") {
              continue;
            }
            const suite = colorConvert[key];
            if (key === "ansi16") {
              key = "ansi";
            }
            if ("ansi16" in suite) {
              styles.color.ansi[key] = wrapAnsi16(suite.ansi16, 0);
              styles.bgColor.ansi[key] = wrapAnsi16(suite.ansi16, 10);
            }
            if ("ansi256" in suite) {
              styles.color.ansi256[key] = wrapAnsi256(suite.ansi256, 0);
              styles.bgColor.ansi256[key] = wrapAnsi256(suite.ansi256, 10);
            }
            if ("rgb" in suite) {
              styles.color.ansi16m[key] = wrapAnsi16m(suite.rgb, 0);
              styles.bgColor.ansi16m[key] = wrapAnsi16m(suite.rgb, 10);
            }
          }
          return styles;
        }
        Object.defineProperty(module22, "exports", {
          enumerable: true,
          get: assembleStyles
        });
      }
    });
    var require_has_flag = __commonJS22({
      "node_modules/vnopts/node_modules/has-flag/index.js"(exports22, module22) {
        "use strict";
        module22.exports = (flag, argv) => {
          argv = argv || process.argv;
          const prefix = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
          const pos = argv.indexOf(prefix + flag);
          const terminatorPos = argv.indexOf("--");
          return pos !== -1 && (terminatorPos === -1 ? true : pos < terminatorPos);
        };
      }
    });
    var require_supports_color = __commonJS22({
      "node_modules/vnopts/node_modules/supports-color/index.js"(exports22, module22) {
        "use strict";
        var os = require("os");
        var hasFlag = require_has_flag();
        var env = process.env;
        var forceColor;
        if (hasFlag("no-color") || hasFlag("no-colors") || hasFlag("color=false")) {
          forceColor = false;
        } else if (hasFlag("color") || hasFlag("colors") || hasFlag("color=true") || hasFlag("color=always")) {
          forceColor = true;
        }
        if ("FORCE_COLOR" in env) {
          forceColor = env.FORCE_COLOR.length === 0 || parseInt(env.FORCE_COLOR, 10) !== 0;
        }
        function translateLevel(level) {
          if (level === 0) {
            return false;
          }
          return {
            level,
            hasBasic: true,
            has256: level >= 2,
            has16m: level >= 3
          };
        }
        function supportsColor(stream) {
          if (forceColor === false) {
            return 0;
          }
          if (hasFlag("color=16m") || hasFlag("color=full") || hasFlag("color=truecolor")) {
            return 3;
          }
          if (hasFlag("color=256")) {
            return 2;
          }
          if (stream && !stream.isTTY && forceColor !== true) {
            return 0;
          }
          const min = forceColor ? 1 : 0;
          if (process.platform === "win32") {
            const osRelease = os.release().split(".");
            if (Number(process.versions.node.split(".")[0]) >= 8 && Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
              return Number(osRelease[2]) >= 14931 ? 3 : 2;
            }
            return 1;
          }
          if ("CI" in env) {
            if (["TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI"].some((sign) => sign in env) || env.CI_NAME === "codeship") {
              return 1;
            }
            return min;
          }
          if ("TEAMCITY_VERSION" in env) {
            return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
          }
          if (env.COLORTERM === "truecolor") {
            return 3;
          }
          if ("TERM_PROGRAM" in env) {
            const version2 = parseInt((env.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
            switch (env.TERM_PROGRAM) {
              case "iTerm.app":
                return version2 >= 3 ? 3 : 2;
              case "Apple_Terminal":
                return 2;
            }
          }
          if (/-256(color)?$/i.test(env.TERM)) {
            return 2;
          }
          if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
            return 1;
          }
          if ("COLORTERM" in env) {
            return 1;
          }
          if (env.TERM === "dumb") {
            return min;
          }
          return min;
        }
        function getSupportLevel(stream) {
          const level = supportsColor(stream);
          return translateLevel(level);
        }
        module22.exports = {
          supportsColor: getSupportLevel,
          stdout: getSupportLevel(process.stdout),
          stderr: getSupportLevel(process.stderr)
        };
      }
    });
    var require_templates = __commonJS22({
      "node_modules/vnopts/node_modules/chalk/templates.js"(exports22, module22) {
        "use strict";
        var TEMPLATE_REGEX = /(?:\\(u[a-f\d]{4}|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
        var STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
        var STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
        var ESCAPE_REGEX = /\\(u[a-f\d]{4}|x[a-f\d]{2}|.)|([^\\])/gi;
        var ESCAPES = /* @__PURE__ */ new Map([["n", "\n"], ["r", "\r"], ["t", "	"], ["b", "\b"], ["f", "\f"], ["v", "\v"], ["0", "\0"], ["\\", "\\"], ["e", "\x1B"], ["a", "\x07"]]);
        function unescape(c) {
          if (c[0] === "u" && c.length === 5 || c[0] === "x" && c.length === 3) {
            return String.fromCharCode(parseInt(c.slice(1), 16));
          }
          return ESCAPES.get(c) || c;
        }
        function parseArguments(name, args) {
          const results = [];
          const chunks = args.trim().split(/\s*,\s*/g);
          let matches;
          for (const chunk of chunks) {
            if (!isNaN(chunk)) {
              results.push(Number(chunk));
            } else if (matches = chunk.match(STRING_REGEX)) {
              results.push(matches[2].replace(ESCAPE_REGEX, (m, escape, chr) => escape ? unescape(escape) : chr));
            } else {
              throw new Error(`Invalid Chalk template style argument: ${chunk} (in style '${name}')`);
            }
          }
          return results;
        }
        function parseStyle(style) {
          STYLE_REGEX.lastIndex = 0;
          const results = [];
          let matches;
          while ((matches = STYLE_REGEX.exec(style)) !== null) {
            const name = matches[1];
            if (matches[2]) {
              const args = parseArguments(name, matches[2]);
              results.push([name].concat(args));
            } else {
              results.push([name]);
            }
          }
          return results;
        }
        function buildStyle(chalk, styles) {
          const enabled = {};
          for (const layer of styles) {
            for (const style of layer.styles) {
              enabled[style[0]] = layer.inverse ? null : style.slice(1);
            }
          }
          let current = chalk;
          for (const styleName of Object.keys(enabled)) {
            if (Array.isArray(enabled[styleName])) {
              if (!(styleName in current)) {
                throw new Error(`Unknown Chalk style: ${styleName}`);
              }
              if (enabled[styleName].length > 0) {
                current = current[styleName].apply(current, enabled[styleName]);
              } else {
                current = current[styleName];
              }
            }
          }
          return current;
        }
        module22.exports = (chalk, tmp) => {
          const styles = [];
          const chunks = [];
          let chunk = [];
          tmp.replace(TEMPLATE_REGEX, (m, escapeChar, inverse, style, close, chr) => {
            if (escapeChar) {
              chunk.push(unescape(escapeChar));
            } else if (style) {
              const str2 = chunk.join("");
              chunk = [];
              chunks.push(styles.length === 0 ? str2 : buildStyle(chalk, styles)(str2));
              styles.push({
                inverse,
                styles: parseStyle(style)
              });
            } else if (close) {
              if (styles.length === 0) {
                throw new Error("Found extraneous } in Chalk template literal");
              }
              chunks.push(buildStyle(chalk, styles)(chunk.join("")));
              chunk = [];
              styles.pop();
            } else {
              chunk.push(chr);
            }
          });
          chunks.push(chunk.join(""));
          if (styles.length > 0) {
            const errMsg = `Chalk template literal is missing ${styles.length} closing bracket${styles.length === 1 ? "" : "s"} (\`}\`)`;
            throw new Error(errMsg);
          }
          return chunks.join("");
        };
      }
    });
    var require_chalk = __commonJS22({
      "node_modules/vnopts/node_modules/chalk/index.js"(exports22, module22) {
        "use strict";
        var escapeStringRegexp2 = require_escape_string_regexp();
        var ansiStyles = require_ansi_styles();
        var stdoutColor = require_supports_color().stdout;
        var template = require_templates();
        var isSimpleWindowsTerm = process.platform === "win32" && !(process.env.TERM || "").toLowerCase().startsWith("xterm");
        var levelMapping = ["ansi", "ansi", "ansi256", "ansi16m"];
        var skipModels = /* @__PURE__ */ new Set(["gray"]);
        var styles = /* @__PURE__ */ Object.create(null);
        function applyOptions(obj, options) {
          options = options || {};
          const scLevel = stdoutColor ? stdoutColor.level : 0;
          obj.level = options.level === void 0 ? scLevel : options.level;
          obj.enabled = "enabled" in options ? options.enabled : obj.level > 0;
        }
        function Chalk(options) {
          if (!this || !(this instanceof Chalk) || this.template) {
            const chalk = {};
            applyOptions(chalk, options);
            chalk.template = function() {
              const args = [].slice.call(arguments);
              return chalkTag.apply(null, [chalk.template].concat(args));
            };
            Object.setPrototypeOf(chalk, Chalk.prototype);
            Object.setPrototypeOf(chalk.template, chalk);
            chalk.template.constructor = Chalk;
            return chalk.template;
          }
          applyOptions(this, options);
        }
        if (isSimpleWindowsTerm) {
          ansiStyles.blue.open = "\x1B[94m";
        }
        for (const key of Object.keys(ansiStyles)) {
          ansiStyles[key].closeRe = new RegExp(escapeStringRegexp2(ansiStyles[key].close), "g");
          styles[key] = {
            get() {
              const codes = ansiStyles[key];
              return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, key);
            }
          };
        }
        styles.visible = {
          get() {
            return build.call(this, this._styles || [], true, "visible");
          }
        };
        ansiStyles.color.closeRe = new RegExp(escapeStringRegexp2(ansiStyles.color.close), "g");
        for (const model of Object.keys(ansiStyles.color.ansi)) {
          if (skipModels.has(model)) {
            continue;
          }
          styles[model] = {
            get() {
              const level = this.level;
              return function() {
                const open = ansiStyles.color[levelMapping[level]][model].apply(null, arguments);
                const codes = {
                  open,
                  close: ansiStyles.color.close,
                  closeRe: ansiStyles.color.closeRe
                };
                return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
              };
            }
          };
        }
        ansiStyles.bgColor.closeRe = new RegExp(escapeStringRegexp2(ansiStyles.bgColor.close), "g");
        for (const model of Object.keys(ansiStyles.bgColor.ansi)) {
          if (skipModels.has(model)) {
            continue;
          }
          const bgModel = "bg" + model[0].toUpperCase() + model.slice(1);
          styles[bgModel] = {
            get() {
              const level = this.level;
              return function() {
                const open = ansiStyles.bgColor[levelMapping[level]][model].apply(null, arguments);
                const codes = {
                  open,
                  close: ansiStyles.bgColor.close,
                  closeRe: ansiStyles.bgColor.closeRe
                };
                return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
              };
            }
          };
        }
        var proto = Object.defineProperties(() => {
        }, styles);
        function build(_styles, _empty, key) {
          const builder = function() {
            return applyStyle.apply(builder, arguments);
          };
          builder._styles = _styles;
          builder._empty = _empty;
          const self2 = this;
          Object.defineProperty(builder, "level", {
            enumerable: true,
            get() {
              return self2.level;
            },
            set(level) {
              self2.level = level;
            }
          });
          Object.defineProperty(builder, "enabled", {
            enumerable: true,
            get() {
              return self2.enabled;
            },
            set(enabled) {
              self2.enabled = enabled;
            }
          });
          builder.hasGrey = this.hasGrey || key === "gray" || key === "grey";
          builder.__proto__ = proto;
          return builder;
        }
        function applyStyle() {
          const args = arguments;
          const argsLen = args.length;
          let str2 = String(arguments[0]);
          if (argsLen === 0) {
            return "";
          }
          if (argsLen > 1) {
            for (let a = 1; a < argsLen; a++) {
              str2 += " " + args[a];
            }
          }
          if (!this.enabled || this.level <= 0 || !str2) {
            return this._empty ? "" : str2;
          }
          const originalDim = ansiStyles.dim.open;
          if (isSimpleWindowsTerm && this.hasGrey) {
            ansiStyles.dim.open = "";
          }
          for (const code of this._styles.slice().reverse()) {
            str2 = code.open + str2.replace(code.closeRe, code.open) + code.close;
            str2 = str2.replace(/\r?\n/g, `${code.close}$&${code.open}`);
          }
          ansiStyles.dim.open = originalDim;
          return str2;
        }
        function chalkTag(chalk, strings) {
          if (!Array.isArray(strings)) {
            return [].slice.call(arguments, 1).join(" ");
          }
          const args = [].slice.call(arguments, 2);
          const parts = [strings.raw[0]];
          for (let i = 1; i < strings.length; i++) {
            parts.push(String(args[i - 1]).replace(/[{}\\]/g, "\\$&"));
            parts.push(String(strings.raw[i]));
          }
          return template(chalk, parts.join(""));
        }
        Object.defineProperties(Chalk.prototype, styles);
        module22.exports = Chalk();
        module22.exports.supportsColor = stdoutColor;
        module22.exports.default = module22.exports;
      }
    });
    var require_common3 = __commonJS22({
      "node_modules/vnopts/lib/handlers/deprecated/common.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var chalk_1 = require_chalk();
        exports22.commonDeprecatedHandler = (keyOrPair, redirectTo, {
          descriptor
        }) => {
          const messages = [`${chalk_1.default.yellow(typeof keyOrPair === "string" ? descriptor.key(keyOrPair) : descriptor.pair(keyOrPair))} is deprecated`];
          if (redirectTo) {
            messages.push(`we now treat it as ${chalk_1.default.blue(typeof redirectTo === "string" ? descriptor.key(redirectTo) : descriptor.pair(redirectTo))}`);
          }
          return messages.join("; ") + ".";
        };
      }
    });
    var require_deprecated = __commonJS22({
      "node_modules/vnopts/lib/handlers/deprecated/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var tslib_1 = (init_tslib_es6(), __toCommonJS2(tslib_es6_exports));
        tslib_1.__exportStar(require_common3(), exports22);
      }
    });
    var require_common22 = __commonJS22({
      "node_modules/vnopts/lib/handlers/invalid/common.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var chalk_1 = require_chalk();
        exports22.commonInvalidHandler = (key, value, utils) => [`Invalid ${chalk_1.default.red(utils.descriptor.key(key))} value.`, `Expected ${chalk_1.default.blue(utils.schemas[key].expected(utils))},`, `but received ${chalk_1.default.red(utils.descriptor.value(value))}.`].join(" ");
      }
    });
    var require_invalid = __commonJS22({
      "node_modules/vnopts/lib/handlers/invalid/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var tslib_1 = (init_tslib_es6(), __toCommonJS2(tslib_es6_exports));
        tslib_1.__exportStar(require_common22(), exports22);
      }
    });
    var require_leven = __commonJS22({
      "node_modules/vnopts/node_modules/leven/index.js"(exports22, module22) {
        "use strict";
        var arr = [];
        var charCodeCache = [];
        module22.exports = function(a, b) {
          if (a === b) {
            return 0;
          }
          var swap = a;
          if (a.length > b.length) {
            a = b;
            b = swap;
          }
          var aLen = a.length;
          var bLen = b.length;
          if (aLen === 0) {
            return bLen;
          }
          if (bLen === 0) {
            return aLen;
          }
          while (aLen > 0 && a.charCodeAt(~-aLen) === b.charCodeAt(~-bLen)) {
            aLen--;
            bLen--;
          }
          if (aLen === 0) {
            return bLen;
          }
          var start = 0;
          while (start < aLen && a.charCodeAt(start) === b.charCodeAt(start)) {
            start++;
          }
          aLen -= start;
          bLen -= start;
          if (aLen === 0) {
            return bLen;
          }
          var bCharCode;
          var ret;
          var tmp;
          var tmp2;
          var i = 0;
          var j = 0;
          while (i < aLen) {
            charCodeCache[start + i] = a.charCodeAt(start + i);
            arr[i] = ++i;
          }
          while (j < bLen) {
            bCharCode = b.charCodeAt(start + j);
            tmp = j++;
            ret = j;
            for (i = 0; i < aLen; i++) {
              tmp2 = bCharCode === charCodeCache[start + i] ? tmp : tmp + 1;
              tmp = arr[i];
              ret = arr[i] = tmp > ret ? tmp2 > ret ? ret + 1 : tmp2 : tmp2 > tmp ? tmp + 1 : tmp2;
            }
          }
          return ret;
        };
      }
    });
    var require_leven2 = __commonJS22({
      "node_modules/vnopts/lib/handlers/unknown/leven.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var chalk_1 = require_chalk();
        var leven = require_leven();
        exports22.levenUnknownHandler = (key, value, {
          descriptor,
          logger,
          schemas
        }) => {
          const messages = [`Ignored unknown option ${chalk_1.default.yellow(descriptor.pair({
            key,
            value
          }))}.`];
          const suggestion = Object.keys(schemas).sort().find((knownKey) => leven(key, knownKey) < 3);
          if (suggestion) {
            messages.push(`Did you mean ${chalk_1.default.blue(descriptor.key(suggestion))}?`);
          }
          logger.warn(messages.join(" "));
        };
      }
    });
    var require_unknown = __commonJS22({
      "node_modules/vnopts/lib/handlers/unknown/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var tslib_1 = (init_tslib_es6(), __toCommonJS2(tslib_es6_exports));
        tslib_1.__exportStar(require_leven2(), exports22);
      }
    });
    var require_handlers = __commonJS22({
      "node_modules/vnopts/lib/handlers/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var tslib_1 = (init_tslib_es6(), __toCommonJS2(tslib_es6_exports));
        tslib_1.__exportStar(require_deprecated(), exports22);
        tslib_1.__exportStar(require_invalid(), exports22);
        tslib_1.__exportStar(require_unknown(), exports22);
      }
    });
    var require_schema7 = __commonJS22({
      "node_modules/vnopts/lib/schema.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var HANDLER_KEYS = ["default", "expected", "validate", "deprecated", "forward", "redirect", "overlap", "preprocess", "postprocess"];
        function createSchema(SchemaConstructor, parameters) {
          const schema2 = new SchemaConstructor(parameters);
          const subSchema = Object.create(schema2);
          for (const handlerKey of HANDLER_KEYS) {
            if (handlerKey in parameters) {
              subSchema[handlerKey] = normalizeHandler(parameters[handlerKey], schema2, Schema3.prototype[handlerKey].length);
            }
          }
          return subSchema;
        }
        exports22.createSchema = createSchema;
        var Schema3 = class {
          constructor(parameters) {
            this.name = parameters.name;
          }
          static create(parameters) {
            return createSchema(this, parameters);
          }
          default(_utils) {
            return void 0;
          }
          expected(_utils) {
            return "nothing";
          }
          validate(_value, _utils) {
            return false;
          }
          deprecated(_value, _utils) {
            return false;
          }
          forward(_value, _utils) {
            return void 0;
          }
          redirect(_value, _utils) {
            return void 0;
          }
          overlap(currentValue, _newValue, _utils) {
            return currentValue;
          }
          preprocess(value, _utils) {
            return value;
          }
          postprocess(value, _utils) {
            return value;
          }
        };
        exports22.Schema = Schema3;
        function normalizeHandler(handler, superSchema, handlerArgumentsLength) {
          return typeof handler === "function" ? (...args) => handler(...args.slice(0, handlerArgumentsLength - 1), superSchema, ...args.slice(handlerArgumentsLength - 1)) : () => handler;
        }
      }
    });
    var require_alias = __commonJS22({
      "node_modules/vnopts/lib/schemas/alias.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var schema_1 = require_schema7();
        var AliasSchema2 = class extends schema_1.Schema {
          constructor(parameters) {
            super(parameters);
            this._sourceName = parameters.sourceName;
          }
          expected(utils) {
            return utils.schemas[this._sourceName].expected(utils);
          }
          validate(value, utils) {
            return utils.schemas[this._sourceName].validate(value, utils);
          }
          redirect(_value, _utils) {
            return this._sourceName;
          }
        };
        exports22.AliasSchema = AliasSchema2;
      }
    });
    var require_any = __commonJS22({
      "node_modules/vnopts/lib/schemas/any.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var schema_1 = require_schema7();
        var AnySchema = class extends schema_1.Schema {
          expected() {
            return "anything";
          }
          validate() {
            return true;
          }
        };
        exports22.AnySchema = AnySchema;
      }
    });
    var require_array2 = __commonJS22({
      "node_modules/vnopts/lib/schemas/array.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var tslib_1 = (init_tslib_es6(), __toCommonJS2(tslib_es6_exports));
        var schema_1 = require_schema7();
        var ArraySchema = class extends schema_1.Schema {
          constructor(_a) {
            var {
              valueSchema,
              name = valueSchema.name
            } = _a, handlers = tslib_1.__rest(_a, ["valueSchema", "name"]);
            super(Object.assign({}, handlers, {
              name
            }));
            this._valueSchema = valueSchema;
          }
          expected(utils) {
            return `an array of ${this._valueSchema.expected(utils)}`;
          }
          validate(value, utils) {
            if (!Array.isArray(value)) {
              return false;
            }
            const invalidValues = [];
            for (const subValue of value) {
              const subValidateResult = utils.normalizeValidateResult(this._valueSchema.validate(subValue, utils), subValue);
              if (subValidateResult !== true) {
                invalidValues.push(subValidateResult.value);
              }
            }
            return invalidValues.length === 0 ? true : {
              value: invalidValues
            };
          }
          deprecated(value, utils) {
            const deprecatedResult = [];
            for (const subValue of value) {
              const subDeprecatedResult = utils.normalizeDeprecatedResult(this._valueSchema.deprecated(subValue, utils), subValue);
              if (subDeprecatedResult !== false) {
                deprecatedResult.push(...subDeprecatedResult.map(({
                  value: deprecatedValue
                }) => ({
                  value: [deprecatedValue]
                })));
              }
            }
            return deprecatedResult;
          }
          forward(value, utils) {
            const forwardResult = [];
            for (const subValue of value) {
              const subForwardResult = utils.normalizeForwardResult(this._valueSchema.forward(subValue, utils), subValue);
              forwardResult.push(...subForwardResult.map(wrapTransferResult));
            }
            return forwardResult;
          }
          redirect(value, utils) {
            const remain = [];
            const redirect = [];
            for (const subValue of value) {
              const subRedirectResult = utils.normalizeRedirectResult(this._valueSchema.redirect(subValue, utils), subValue);
              if ("remain" in subRedirectResult) {
                remain.push(subRedirectResult.remain);
              }
              redirect.push(...subRedirectResult.redirect.map(wrapTransferResult));
            }
            return remain.length === 0 ? {
              redirect
            } : {
              redirect,
              remain
            };
          }
          overlap(currentValue, newValue) {
            return currentValue.concat(newValue);
          }
        };
        exports22.ArraySchema = ArraySchema;
        function wrapTransferResult({
          from,
          to
        }) {
          return {
            from: [from],
            to
          };
        }
      }
    });
    var require_boolean = __commonJS22({
      "node_modules/vnopts/lib/schemas/boolean.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var schema_1 = require_schema7();
        var BooleanSchema = class extends schema_1.Schema {
          expected() {
            return "true or false";
          }
          validate(value) {
            return typeof value === "boolean";
          }
        };
        exports22.BooleanSchema = BooleanSchema;
      }
    });
    var require_utils8 = __commonJS22({
      "node_modules/vnopts/lib/utils.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        function recordFromArray(array, mainKey) {
          const record3 = /* @__PURE__ */ Object.create(null);
          for (const value of array) {
            const key = value[mainKey];
            if (record3[key]) {
              throw new Error(`Duplicate ${mainKey} ${JSON.stringify(key)}`);
            }
            record3[key] = value;
          }
          return record3;
        }
        exports22.recordFromArray = recordFromArray;
        function mapFromArray(array, mainKey) {
          const map2 = /* @__PURE__ */ new Map();
          for (const value of array) {
            const key = value[mainKey];
            if (map2.has(key)) {
              throw new Error(`Duplicate ${mainKey} ${JSON.stringify(key)}`);
            }
            map2.set(key, value);
          }
          return map2;
        }
        exports22.mapFromArray = mapFromArray;
        function createAutoChecklist() {
          const map2 = /* @__PURE__ */ Object.create(null);
          return (id) => {
            const idString = JSON.stringify(id);
            if (map2[idString]) {
              return true;
            }
            map2[idString] = true;
            return false;
          };
        }
        exports22.createAutoChecklist = createAutoChecklist;
        function partition3(array, predicate) {
          const trueArray = [];
          const falseArray = [];
          for (const value of array) {
            if (predicate(value)) {
              trueArray.push(value);
            } else {
              falseArray.push(value);
            }
          }
          return [trueArray, falseArray];
        }
        exports22.partition = partition3;
        function isInt(value) {
          return value === Math.floor(value);
        }
        exports22.isInt = isInt;
        function comparePrimitive(a, b) {
          if (a === b) {
            return 0;
          }
          const typeofA = typeof a;
          const typeofB = typeof b;
          const orders = ["undefined", "object", "boolean", "number", "string"];
          if (typeofA !== typeofB) {
            return orders.indexOf(typeofA) - orders.indexOf(typeofB);
          }
          if (typeofA !== "string") {
            return Number(a) - Number(b);
          }
          return a.localeCompare(b);
        }
        exports22.comparePrimitive = comparePrimitive;
        function normalizeDefaultResult(result) {
          return result === void 0 ? {} : result;
        }
        exports22.normalizeDefaultResult = normalizeDefaultResult;
        function normalizeValidateResult(result, value) {
          return result === true ? true : result === false ? {
            value
          } : result;
        }
        exports22.normalizeValidateResult = normalizeValidateResult;
        function normalizeDeprecatedResult(result, value, doNotNormalizeTrue = false) {
          return result === false ? false : result === true ? doNotNormalizeTrue ? true : [{
            value
          }] : "value" in result ? [result] : result.length === 0 ? false : result;
        }
        exports22.normalizeDeprecatedResult = normalizeDeprecatedResult;
        function normalizeTransferResult(result, value) {
          return typeof result === "string" || "key" in result ? {
            from: value,
            to: result
          } : "from" in result ? {
            from: result.from,
            to: result.to
          } : {
            from: value,
            to: result.to
          };
        }
        exports22.normalizeTransferResult = normalizeTransferResult;
        function normalizeForwardResult(result, value) {
          return result === void 0 ? [] : Array.isArray(result) ? result.map((transferResult) => normalizeTransferResult(transferResult, value)) : [normalizeTransferResult(result, value)];
        }
        exports22.normalizeForwardResult = normalizeForwardResult;
        function normalizeRedirectResult(result, value) {
          const redirect = normalizeForwardResult(typeof result === "object" && "redirect" in result ? result.redirect : result, value);
          return redirect.length === 0 ? {
            remain: value,
            redirect
          } : typeof result === "object" && "remain" in result ? {
            remain: result.remain,
            redirect
          } : {
            redirect
          };
        }
        exports22.normalizeRedirectResult = normalizeRedirectResult;
      }
    });
    var require_choice = __commonJS22({
      "node_modules/vnopts/lib/schemas/choice.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var schema_1 = require_schema7();
        var utils_1 = require_utils8();
        var ChoiceSchema = class extends schema_1.Schema {
          constructor(parameters) {
            super(parameters);
            this._choices = utils_1.mapFromArray(parameters.choices.map((choice) => choice && typeof choice === "object" ? choice : {
              value: choice
            }), "value");
          }
          expected({
            descriptor
          }) {
            const choiceValues = Array.from(this._choices.keys()).map((value) => this._choices.get(value)).filter((choiceInfo) => !choiceInfo.deprecated).map((choiceInfo) => choiceInfo.value).sort(utils_1.comparePrimitive).map(descriptor.value);
            const head = choiceValues.slice(0, -2);
            const tail = choiceValues.slice(-2);
            return head.concat(tail.join(" or ")).join(", ");
          }
          validate(value) {
            return this._choices.has(value);
          }
          deprecated(value) {
            const choiceInfo = this._choices.get(value);
            return choiceInfo && choiceInfo.deprecated ? {
              value
            } : false;
          }
          forward(value) {
            const choiceInfo = this._choices.get(value);
            return choiceInfo ? choiceInfo.forward : void 0;
          }
          redirect(value) {
            const choiceInfo = this._choices.get(value);
            return choiceInfo ? choiceInfo.redirect : void 0;
          }
        };
        exports22.ChoiceSchema = ChoiceSchema;
      }
    });
    var require_number = __commonJS22({
      "node_modules/vnopts/lib/schemas/number.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var schema_1 = require_schema7();
        var NumberSchema = class extends schema_1.Schema {
          expected() {
            return "a number";
          }
          validate(value, _utils) {
            return typeof value === "number";
          }
        };
        exports22.NumberSchema = NumberSchema;
      }
    });
    var require_integer = __commonJS22({
      "node_modules/vnopts/lib/schemas/integer.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var utils_1 = require_utils8();
        var number_1 = require_number();
        var IntegerSchema = class extends number_1.NumberSchema {
          expected() {
            return "an integer";
          }
          validate(value, utils) {
            return utils.normalizeValidateResult(super.validate(value, utils), value) === true && utils_1.isInt(value);
          }
        };
        exports22.IntegerSchema = IntegerSchema;
      }
    });
    var require_string2 = __commonJS22({
      "node_modules/vnopts/lib/schemas/string.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var schema_1 = require_schema7();
        var StringSchema = class extends schema_1.Schema {
          expected() {
            return "a string";
          }
          validate(value) {
            return typeof value === "string";
          }
        };
        exports22.StringSchema = StringSchema;
      }
    });
    var require_schemas = __commonJS22({
      "node_modules/vnopts/lib/schemas/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var tslib_1 = (init_tslib_es6(), __toCommonJS2(tslib_es6_exports));
        tslib_1.__exportStar(require_alias(), exports22);
        tslib_1.__exportStar(require_any(), exports22);
        tslib_1.__exportStar(require_array2(), exports22);
        tslib_1.__exportStar(require_boolean(), exports22);
        tslib_1.__exportStar(require_choice(), exports22);
        tslib_1.__exportStar(require_integer(), exports22);
        tslib_1.__exportStar(require_number(), exports22);
        tslib_1.__exportStar(require_string2(), exports22);
      }
    });
    var require_defaults2 = __commonJS22({
      "node_modules/vnopts/lib/defaults.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var api_1 = require_api();
        var common_1 = require_common3();
        var invalid_1 = require_invalid();
        var leven_1 = require_leven2();
        exports22.defaultDescriptor = api_1.apiDescriptor;
        exports22.defaultUnknownHandler = leven_1.levenUnknownHandler;
        exports22.defaultInvalidHandler = invalid_1.commonInvalidHandler;
        exports22.defaultDeprecatedHandler = common_1.commonDeprecatedHandler;
      }
    });
    var require_normalize = __commonJS22({
      "node_modules/vnopts/lib/normalize.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var defaults_1 = require_defaults2();
        var utils_1 = require_utils8();
        exports22.normalize = (options, schemas, opts) => new Normalizer(schemas, opts).normalize(options);
        var Normalizer = class {
          constructor(schemas, opts) {
            const {
              logger = console,
              descriptor = defaults_1.defaultDescriptor,
              unknown: unknown3 = defaults_1.defaultUnknownHandler,
              invalid = defaults_1.defaultInvalidHandler,
              deprecated = defaults_1.defaultDeprecatedHandler
            } = opts || {};
            this._utils = {
              descriptor,
              logger: logger || {
                warn: () => {
                }
              },
              schemas: utils_1.recordFromArray(schemas, "name"),
              normalizeDefaultResult: utils_1.normalizeDefaultResult,
              normalizeDeprecatedResult: utils_1.normalizeDeprecatedResult,
              normalizeForwardResult: utils_1.normalizeForwardResult,
              normalizeRedirectResult: utils_1.normalizeRedirectResult,
              normalizeValidateResult: utils_1.normalizeValidateResult
            };
            this._unknownHandler = unknown3;
            this._invalidHandler = invalid;
            this._deprecatedHandler = deprecated;
            this.cleanHistory();
          }
          cleanHistory() {
            this._hasDeprecationWarned = utils_1.createAutoChecklist();
          }
          normalize(options) {
            const normalized = {};
            const restOptionsArray = [options];
            const applyNormalization = () => {
              while (restOptionsArray.length !== 0) {
                const currentOptions = restOptionsArray.shift();
                const transferredOptionsArray = this._applyNormalization(currentOptions, normalized);
                restOptionsArray.push(...transferredOptionsArray);
              }
            };
            applyNormalization();
            for (const key of Object.keys(this._utils.schemas)) {
              const schema2 = this._utils.schemas[key];
              if (!(key in normalized)) {
                const defaultResult = utils_1.normalizeDefaultResult(schema2.default(this._utils));
                if ("value" in defaultResult) {
                  restOptionsArray.push({
                    [key]: defaultResult.value
                  });
                }
              }
            }
            applyNormalization();
            for (const key of Object.keys(this._utils.schemas)) {
              const schema2 = this._utils.schemas[key];
              if (key in normalized) {
                normalized[key] = schema2.postprocess(normalized[key], this._utils);
              }
            }
            return normalized;
          }
          _applyNormalization(options, normalized) {
            const transferredOptionsArray = [];
            const [knownOptionNames, unknownOptionNames] = utils_1.partition(Object.keys(options), (key) => key in this._utils.schemas);
            for (const key of knownOptionNames) {
              const schema2 = this._utils.schemas[key];
              const value = schema2.preprocess(options[key], this._utils);
              const validateResult = utils_1.normalizeValidateResult(schema2.validate(value, this._utils), value);
              if (validateResult !== true) {
                const {
                  value: invalidValue
                } = validateResult;
                const errorMessageOrError = this._invalidHandler(key, invalidValue, this._utils);
                throw typeof errorMessageOrError === "string" ? new Error(errorMessageOrError) : errorMessageOrError;
              }
              const appendTransferredOptions = ({
                from,
                to
              }) => {
                transferredOptionsArray.push(typeof to === "string" ? {
                  [to]: from
                } : {
                  [to.key]: to.value
                });
              };
              const warnDeprecated = ({
                value: currentValue,
                redirectTo
              }) => {
                const deprecatedResult = utils_1.normalizeDeprecatedResult(schema2.deprecated(currentValue, this._utils), value, true);
                if (deprecatedResult === false) {
                  return;
                }
                if (deprecatedResult === true) {
                  if (!this._hasDeprecationWarned(key)) {
                    this._utils.logger.warn(this._deprecatedHandler(key, redirectTo, this._utils));
                  }
                } else {
                  for (const {
                    value: deprecatedValue
                  } of deprecatedResult) {
                    const pair = {
                      key,
                      value: deprecatedValue
                    };
                    if (!this._hasDeprecationWarned(pair)) {
                      const redirectToPair = typeof redirectTo === "string" ? {
                        key: redirectTo,
                        value: deprecatedValue
                      } : redirectTo;
                      this._utils.logger.warn(this._deprecatedHandler(pair, redirectToPair, this._utils));
                    }
                  }
                }
              };
              const forwardResult = utils_1.normalizeForwardResult(schema2.forward(value, this._utils), value);
              forwardResult.forEach(appendTransferredOptions);
              const redirectResult = utils_1.normalizeRedirectResult(schema2.redirect(value, this._utils), value);
              redirectResult.redirect.forEach(appendTransferredOptions);
              if ("remain" in redirectResult) {
                const remainingValue = redirectResult.remain;
                normalized[key] = key in normalized ? schema2.overlap(normalized[key], remainingValue, this._utils) : remainingValue;
                warnDeprecated({
                  value: remainingValue
                });
              }
              for (const {
                from,
                to
              } of redirectResult.redirect) {
                warnDeprecated({
                  value: from,
                  redirectTo: to
                });
              }
            }
            for (const key of unknownOptionNames) {
              const value = options[key];
              const unknownResult = this._unknownHandler(key, value, this._utils);
              if (unknownResult) {
                for (const unknownKey of Object.keys(unknownResult)) {
                  const unknownOption = {
                    [unknownKey]: unknownResult[unknownKey]
                  };
                  if (unknownKey in this._utils.schemas) {
                    transferredOptionsArray.push(unknownOption);
                  } else {
                    Object.assign(normalized, unknownOption);
                  }
                }
              }
            }
            return transferredOptionsArray;
          }
        };
        exports22.Normalizer = Normalizer;
      }
    });
    var require_lib22 = __commonJS22({
      "node_modules/vnopts/lib/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var tslib_1 = (init_tslib_es6(), __toCommonJS2(tslib_es6_exports));
        tslib_1.__exportStar(require_descriptors2(), exports22);
        tslib_1.__exportStar(require_handlers(), exports22);
        tslib_1.__exportStar(require_schemas(), exports22);
        tslib_1.__exportStar(require_normalize(), exports22);
        tslib_1.__exportStar(require_schema7(), exports22);
      }
    });
    var require_options_normalizer = __commonJS22({
      "src/main/options-normalizer.js"(exports22, module22) {
        "use strict";
        var vnopts = require_lib22();
        var getLast = require_get_last();
        var cliDescriptor = {
          key: (key) => key.length === 1 ? `-${key}` : `--${key}`,
          value: (value) => vnopts.apiDescriptor.value(value),
          pair: ({
            key,
            value
          }) => value === false ? `--no-${key}` : value === true ? cliDescriptor.key(key) : value === "" ? `${cliDescriptor.key(key)} without an argument` : `${cliDescriptor.key(key)}=${value}`
        };
        var getFlagSchema = ({
          colorsModule,
          levenshteinDistance
        }) => class FlagSchema extends vnopts.ChoiceSchema {
          constructor({
            name,
            flags
          }) {
            super({
              name,
              choices: flags
            });
            this._flags = [...flags].sort();
          }
          preprocess(value, utils) {
            if (typeof value === "string" && value.length > 0 && !this._flags.includes(value)) {
              const suggestion = this._flags.find((flag) => levenshteinDistance(flag, value) < 3);
              if (suggestion) {
                utils.logger.warn([`Unknown flag ${colorsModule.yellow(utils.descriptor.value(value))},`, `did you mean ${colorsModule.blue(utils.descriptor.value(suggestion))}?`].join(" "));
                return suggestion;
              }
            }
            return value;
          }
          expected() {
            return "a flag";
          }
        };
        var hasDeprecationWarned;
        function normalizeOptions(options, optionInfos, {
          logger = false,
          isCLI = false,
          passThrough = false,
          colorsModule = null,
          levenshteinDistance = null
        } = {}) {
          const unknown3 = !passThrough ? (key, value, options2) => {
            const _options2$schemas = options2.schemas, {
              _
            } = _options2$schemas, schemas2 = _objectWithoutProperties(_options2$schemas, _excluded2);
            return vnopts.levenUnknownHandler(key, value, Object.assign(Object.assign({}, options2), {}, {
              schemas: schemas2
            }));
          } : Array.isArray(passThrough) ? (key, value) => !passThrough.includes(key) ? void 0 : {
            [key]: value
          } : (key, value) => ({
            [key]: value
          });
          const descriptor = isCLI ? cliDescriptor : vnopts.apiDescriptor;
          const schemas = optionInfosToSchemas(optionInfos, {
            isCLI,
            colorsModule,
            levenshteinDistance
          });
          const normalizer = new vnopts.Normalizer(schemas, {
            logger,
            unknown: unknown3,
            descriptor
          });
          const shouldSuppressDuplicateDeprecationWarnings = logger !== false;
          if (shouldSuppressDuplicateDeprecationWarnings && hasDeprecationWarned) {
            normalizer._hasDeprecationWarned = hasDeprecationWarned;
          }
          const normalized = normalizer.normalize(options);
          if (shouldSuppressDuplicateDeprecationWarnings) {
            hasDeprecationWarned = normalizer._hasDeprecationWarned;
          }
          if (isCLI && normalized["plugin-search"] === false) {
            normalized["plugin-search-dir"] = false;
          }
          return normalized;
        }
        function optionInfosToSchemas(optionInfos, {
          isCLI,
          colorsModule,
          levenshteinDistance
        }) {
          const schemas = [];
          if (isCLI) {
            schemas.push(vnopts.AnySchema.create({
              name: "_"
            }));
          }
          for (const optionInfo of optionInfos) {
            schemas.push(optionInfoToSchema(optionInfo, {
              isCLI,
              optionInfos,
              colorsModule,
              levenshteinDistance
            }));
            if (optionInfo.alias && isCLI) {
              schemas.push(vnopts.AliasSchema.create({
                name: optionInfo.alias,
                sourceName: optionInfo.name
              }));
            }
          }
          return schemas;
        }
        function optionInfoToSchema(optionInfo, {
          isCLI,
          optionInfos,
          colorsModule,
          levenshteinDistance
        }) {
          const {
            name
          } = optionInfo;
          if (name === "plugin-search-dir" || name === "pluginSearchDirs") {
            return vnopts.AnySchema.create({
              name,
              preprocess(value) {
                if (value === false) {
                  return value;
                }
                value = Array.isArray(value) ? value : [value];
                return value;
              },
              validate(value) {
                if (value === false) {
                  return true;
                }
                return value.every((dir) => typeof dir === "string");
              },
              expected() {
                return "false or paths to plugin search dir";
              }
            });
          }
          const parameters = {
            name
          };
          let SchemaConstructor;
          const handlers = {};
          switch (optionInfo.type) {
            case "int":
              SchemaConstructor = vnopts.IntegerSchema;
              if (isCLI) {
                parameters.preprocess = Number;
              }
              break;
            case "string":
              SchemaConstructor = vnopts.StringSchema;
              break;
            case "choice":
              SchemaConstructor = vnopts.ChoiceSchema;
              parameters.choices = optionInfo.choices.map((choiceInfo) => typeof choiceInfo === "object" && choiceInfo.redirect ? Object.assign(Object.assign({}, choiceInfo), {}, {
                redirect: {
                  to: {
                    key: optionInfo.name,
                    value: choiceInfo.redirect
                  }
                }
              }) : choiceInfo);
              break;
            case "boolean":
              SchemaConstructor = vnopts.BooleanSchema;
              break;
            case "flag":
              SchemaConstructor = getFlagSchema({
                colorsModule,
                levenshteinDistance
              });
              parameters.flags = optionInfos.flatMap((optionInfo2) => [optionInfo2.alias, optionInfo2.description && optionInfo2.name, optionInfo2.oppositeDescription && `no-${optionInfo2.name}`].filter(Boolean));
              break;
            case "path":
              SchemaConstructor = vnopts.StringSchema;
              break;
            default:
              throw new Error(`Unexpected type ${optionInfo.type}`);
          }
          if (optionInfo.exception) {
            parameters.validate = (value, schema2, utils) => optionInfo.exception(value) || schema2.validate(value, utils);
          } else {
            parameters.validate = (value, schema2, utils) => value === void 0 || schema2.validate(value, utils);
          }
          if (optionInfo.redirect) {
            handlers.redirect = (value) => !value ? void 0 : {
              to: {
                key: optionInfo.redirect.option,
                value: optionInfo.redirect.value
              }
            };
          }
          if (optionInfo.deprecated) {
            handlers.deprecated = true;
          }
          if (isCLI && !optionInfo.array) {
            const originalPreprocess = parameters.preprocess || ((x) => x);
            parameters.preprocess = (value, schema2, utils) => schema2.preprocess(originalPreprocess(Array.isArray(value) ? getLast(value) : value), utils);
          }
          return optionInfo.array ? vnopts.ArraySchema.create(Object.assign(Object.assign(Object.assign({}, isCLI ? {
            preprocess: (v) => Array.isArray(v) ? v : [v]
          } : {}), handlers), {}, {
            valueSchema: SchemaConstructor.create(parameters)
          })) : SchemaConstructor.create(Object.assign(Object.assign({}, parameters), handlers));
        }
        function normalizeApiOptions(options, optionInfos, opts) {
          return normalizeOptions(options, optionInfos, opts);
        }
        function normalizeCliOptions(options, optionInfos, opts) {
          if (false) {
            if (!opts.colorsModule) {
              throw new Error("'colorsModule' option is required.");
            }
            if (!opts.levenshteinDistance) {
              throw new Error("'levenshteinDistance' option is required.");
            }
          }
          return normalizeOptions(options, optionInfos, Object.assign({
            isCLI: true
          }, opts));
        }
        module22.exports = {
          normalizeApiOptions,
          normalizeCliOptions
        };
      }
    });
    var require_loc = __commonJS22({
      "src/language-js/loc.js"(exports22, module22) {
        "use strict";
        var isNonEmptyArray = require_is_non_empty_array();
        function locStart(node, opts) {
          const {
            ignoreDecorators
          } = opts || {};
          if (!ignoreDecorators) {
            const decorators = node.declaration && node.declaration.decorators || node.decorators;
            if (isNonEmptyArray(decorators)) {
              return locStart(decorators[0]);
            }
          }
          return node.range ? node.range[0] : node.start;
        }
        function locEnd(node) {
          return node.range ? node.range[1] : node.end;
        }
        function hasSameLocStart(nodeA, nodeB) {
          const nodeAStart = locStart(nodeA);
          return Number.isInteger(nodeAStart) && nodeAStart === locStart(nodeB);
        }
        function hasSameLocEnd(nodeA, nodeB) {
          const nodeAEnd = locEnd(nodeA);
          return Number.isInteger(nodeAEnd) && nodeAEnd === locEnd(nodeB);
        }
        function hasSameLoc(nodeA, nodeB) {
          return hasSameLocStart(nodeA, nodeB) && hasSameLocEnd(nodeA, nodeB);
        }
        module22.exports = {
          locStart,
          locEnd,
          hasSameLocStart,
          hasSameLoc
        };
      }
    });
    var require_load_parser = __commonJS22({
      "src/main/load-parser.js"(exports22, module22) {
        "use strict";
        var path5 = require("path");
        var {
          ConfigError
        } = require_errors3();
        var {
          locStart,
          locEnd
        } = require_loc();
        function requireParser(parser) {
          try {
            return {
              parse: require(path5.resolve(process.cwd(), parser)),
              astFormat: "estree",
              locStart,
              locEnd
            };
          } catch {
            throw new ConfigError(`Couldn't resolve parser "${parser}"`);
          }
        }
        module22.exports = requireParser;
      }
    });
    var require_js_tokens = __commonJS22({
      "node_modules/js-tokens/index.js"(exports22) {
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.default = /((['"])(?:(?!\2|\\).|\\(?:\r\n|[\s\S]))*(\2)?|`(?:[^`\\$]|\\[\s\S]|\$(?!\{)|\$\{(?:[^{}]|\{[^}]*\}?)*\}?)*(`)?)|(\/\/.*)|(\/\*(?:[^*]|\*(?!\/))*(\*\/)?)|(\/(?!\*)(?:\[(?:(?![\]\\]).|\\.)*\]|(?![\/\]\\]).|\\.)+\/(?:(?!\s*(?:\b|[\u0080-\uFFFF$\\'"~({]|[+\-!](?!=)|\.?\d))|[gmiyus]{1,6}\b(?![\u0080-\uFFFF$\\]|\s*(?:[+\-*%&|^<>!=?({]|\/(?![\/*])))))|(0[xX][\da-fA-F]+|0[oO][0-7]+|0[bB][01]+|(?:\d*\.\d+|\d+\.?)(?:[eE][+-]?\d+)?)|((?!\d)(?:(?!\s)[$\w\u0080-\uFFFF]|\\u[\da-fA-F]{4}|\\u\{[\da-fA-F]+\})+)|(--|\+\+|&&|\|\||=>|\.{3}|(?:[+\-\/%&|^]|\*{1,2}|<{1,2}|>{1,3}|!=?|={1,2})=?|[?~.,:;[\](){}])|(\s+)|(^$|[\s\S])/g;
        exports22.matchToToken = function(match) {
          var token = {
            type: "invalid",
            value: match[0],
            closed: void 0
          };
          if (match[1])
            token.type = "string", token.closed = !!(match[3] || match[4]);
          else if (match[5])
            token.type = "comment";
          else if (match[6])
            token.type = "comment", token.closed = !!match[7];
          else if (match[8])
            token.type = "regex";
          else if (match[9])
            token.type = "number";
          else if (match[10])
            token.type = "name";
          else if (match[11])
            token.type = "punctuator";
          else if (match[12])
            token.type = "whitespace";
          return token;
        };
      }
    });
    var require_identifier = __commonJS22({
      "node_modules/@babel/helper-validator-identifier/lib/identifier.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.isIdentifierChar = isIdentifierChar;
        exports22.isIdentifierName = isIdentifierName;
        exports22.isIdentifierStart = isIdentifierStart;
        var nonASCIIidentifierStartChars = "\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BF\u31F0-\u31FF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC";
        var nonASCIIidentifierChars = "\u200C\u200D\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u0898-\u089F\u08CA-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B55-\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3C\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D81-\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EBC\u0EC8-\u0ECD\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u180F-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1ABF-\u1ACE\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DFF\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA82C\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F";
        var nonASCIIidentifierStart = new RegExp("[" + nonASCIIidentifierStartChars + "]");
        var nonASCIIidentifier = new RegExp("[" + nonASCIIidentifierStartChars + nonASCIIidentifierChars + "]");
        nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
        var astralIdentifierStartCodes = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 85, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 190, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1070, 4050, 582, 8634, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 46, 2, 18, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 482, 44, 11, 6, 17, 0, 322, 29, 19, 43, 1269, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4152, 8, 221, 3, 5761, 15, 7472, 3104, 541, 1507, 4938];
        var astralIdentifierCodes = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 370, 1, 154, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 161, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 19306, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 262, 6, 10, 9, 357, 0, 62, 13, 1495, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];
        function isInAstralSet(code, set4) {
          let pos = 65536;
          for (let i = 0, length = set4.length; i < length; i += 2) {
            pos += set4[i];
            if (pos > code)
              return false;
            pos += set4[i + 1];
            if (pos >= code)
              return true;
          }
          return false;
        }
        function isIdentifierStart(code) {
          if (code < 65)
            return code === 36;
          if (code <= 90)
            return true;
          if (code < 97)
            return code === 95;
          if (code <= 122)
            return true;
          if (code <= 65535) {
            return code >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code));
          }
          return isInAstralSet(code, astralIdentifierStartCodes);
        }
        function isIdentifierChar(code) {
          if (code < 48)
            return code === 36;
          if (code < 58)
            return true;
          if (code < 65)
            return false;
          if (code <= 90)
            return true;
          if (code < 97)
            return code === 95;
          if (code <= 122)
            return true;
          if (code <= 65535) {
            return code >= 170 && nonASCIIidentifier.test(String.fromCharCode(code));
          }
          return isInAstralSet(code, astralIdentifierStartCodes) || isInAstralSet(code, astralIdentifierCodes);
        }
        function isIdentifierName(name) {
          let isFirst = true;
          for (let i = 0; i < name.length; i++) {
            let cp = name.charCodeAt(i);
            if ((cp & 64512) === 55296 && i + 1 < name.length) {
              const trail = name.charCodeAt(++i);
              if ((trail & 64512) === 56320) {
                cp = 65536 + ((cp & 1023) << 10) + (trail & 1023);
              }
            }
            if (isFirst) {
              isFirst = false;
              if (!isIdentifierStart(cp)) {
                return false;
              }
            } else if (!isIdentifierChar(cp)) {
              return false;
            }
          }
          return !isFirst;
        }
      }
    });
    var require_keyword2 = __commonJS22({
      "node_modules/@babel/helper-validator-identifier/lib/keyword.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.isKeyword = isKeyword;
        exports22.isReservedWord = isReservedWord;
        exports22.isStrictBindOnlyReservedWord = isStrictBindOnlyReservedWord;
        exports22.isStrictBindReservedWord = isStrictBindReservedWord;
        exports22.isStrictReservedWord = isStrictReservedWord;
        var reservedWords = {
          keyword: ["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete"],
          strict: ["implements", "interface", "let", "package", "private", "protected", "public", "static", "yield"],
          strictBind: ["eval", "arguments"]
        };
        var keywords = new Set(reservedWords.keyword);
        var reservedWordsStrictSet = new Set(reservedWords.strict);
        var reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
        function isReservedWord(word, inModule) {
          return inModule && word === "await" || word === "enum";
        }
        function isStrictReservedWord(word, inModule) {
          return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
        }
        function isStrictBindOnlyReservedWord(word) {
          return reservedWordsStrictBindSet.has(word);
        }
        function isStrictBindReservedWord(word, inModule) {
          return isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word);
        }
        function isKeyword(word) {
          return keywords.has(word);
        }
      }
    });
    var require_lib32 = __commonJS22({
      "node_modules/@babel/helper-validator-identifier/lib/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        Object.defineProperty(exports22, "isIdentifierChar", {
          enumerable: true,
          get: function() {
            return _identifier.isIdentifierChar;
          }
        });
        Object.defineProperty(exports22, "isIdentifierName", {
          enumerable: true,
          get: function() {
            return _identifier.isIdentifierName;
          }
        });
        Object.defineProperty(exports22, "isIdentifierStart", {
          enumerable: true,
          get: function() {
            return _identifier.isIdentifierStart;
          }
        });
        Object.defineProperty(exports22, "isKeyword", {
          enumerable: true,
          get: function() {
            return _keyword.isKeyword;
          }
        });
        Object.defineProperty(exports22, "isReservedWord", {
          enumerable: true,
          get: function() {
            return _keyword.isReservedWord;
          }
        });
        Object.defineProperty(exports22, "isStrictBindOnlyReservedWord", {
          enumerable: true,
          get: function() {
            return _keyword.isStrictBindOnlyReservedWord;
          }
        });
        Object.defineProperty(exports22, "isStrictBindReservedWord", {
          enumerable: true,
          get: function() {
            return _keyword.isStrictBindReservedWord;
          }
        });
        Object.defineProperty(exports22, "isStrictReservedWord", {
          enumerable: true,
          get: function() {
            return _keyword.isStrictReservedWord;
          }
        });
        var _identifier = require_identifier();
        var _keyword = require_keyword2();
      }
    });
    var require_escape_string_regexp2 = __commonJS22({
      "node_modules/@babel/highlight/node_modules/escape-string-regexp/index.js"(exports22, module22) {
        "use strict";
        var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
        module22.exports = function(str2) {
          if (typeof str2 !== "string") {
            throw new TypeError("Expected a string");
          }
          return str2.replace(matchOperatorsRe, "\\$&");
        };
      }
    });
    var require_has_flag2 = __commonJS22({
      "node_modules/@babel/highlight/node_modules/has-flag/index.js"(exports22, module22) {
        "use strict";
        module22.exports = (flag, argv) => {
          argv = argv || process.argv;
          const prefix = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
          const pos = argv.indexOf(prefix + flag);
          const terminatorPos = argv.indexOf("--");
          return pos !== -1 && (terminatorPos === -1 ? true : pos < terminatorPos);
        };
      }
    });
    var require_supports_color2 = __commonJS22({
      "node_modules/@babel/highlight/node_modules/supports-color/index.js"(exports22, module22) {
        "use strict";
        var os = require("os");
        var hasFlag = require_has_flag2();
        var env = process.env;
        var forceColor;
        if (hasFlag("no-color") || hasFlag("no-colors") || hasFlag("color=false")) {
          forceColor = false;
        } else if (hasFlag("color") || hasFlag("colors") || hasFlag("color=true") || hasFlag("color=always")) {
          forceColor = true;
        }
        if ("FORCE_COLOR" in env) {
          forceColor = env.FORCE_COLOR.length === 0 || parseInt(env.FORCE_COLOR, 10) !== 0;
        }
        function translateLevel(level) {
          if (level === 0) {
            return false;
          }
          return {
            level,
            hasBasic: true,
            has256: level >= 2,
            has16m: level >= 3
          };
        }
        function supportsColor(stream) {
          if (forceColor === false) {
            return 0;
          }
          if (hasFlag("color=16m") || hasFlag("color=full") || hasFlag("color=truecolor")) {
            return 3;
          }
          if (hasFlag("color=256")) {
            return 2;
          }
          if (stream && !stream.isTTY && forceColor !== true) {
            return 0;
          }
          const min = forceColor ? 1 : 0;
          if (process.platform === "win32") {
            const osRelease = os.release().split(".");
            if (Number(process.versions.node.split(".")[0]) >= 8 && Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
              return Number(osRelease[2]) >= 14931 ? 3 : 2;
            }
            return 1;
          }
          if ("CI" in env) {
            if (["TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI"].some((sign) => sign in env) || env.CI_NAME === "codeship") {
              return 1;
            }
            return min;
          }
          if ("TEAMCITY_VERSION" in env) {
            return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
          }
          if (env.COLORTERM === "truecolor") {
            return 3;
          }
          if ("TERM_PROGRAM" in env) {
            const version2 = parseInt((env.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
            switch (env.TERM_PROGRAM) {
              case "iTerm.app":
                return version2 >= 3 ? 3 : 2;
              case "Apple_Terminal":
                return 2;
            }
          }
          if (/-256(color)?$/i.test(env.TERM)) {
            return 2;
          }
          if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
            return 1;
          }
          if ("COLORTERM" in env) {
            return 1;
          }
          if (env.TERM === "dumb") {
            return min;
          }
          return min;
        }
        function getSupportLevel(stream) {
          const level = supportsColor(stream);
          return translateLevel(level);
        }
        module22.exports = {
          supportsColor: getSupportLevel,
          stdout: getSupportLevel(process.stdout),
          stderr: getSupportLevel(process.stderr)
        };
      }
    });
    var require_templates2 = __commonJS22({
      "node_modules/@babel/highlight/node_modules/chalk/templates.js"(exports22, module22) {
        "use strict";
        var TEMPLATE_REGEX = /(?:\\(u[a-f\d]{4}|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
        var STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
        var STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
        var ESCAPE_REGEX = /\\(u[a-f\d]{4}|x[a-f\d]{2}|.)|([^\\])/gi;
        var ESCAPES = /* @__PURE__ */ new Map([["n", "\n"], ["r", "\r"], ["t", "	"], ["b", "\b"], ["f", "\f"], ["v", "\v"], ["0", "\0"], ["\\", "\\"], ["e", "\x1B"], ["a", "\x07"]]);
        function unescape(c) {
          if (c[0] === "u" && c.length === 5 || c[0] === "x" && c.length === 3) {
            return String.fromCharCode(parseInt(c.slice(1), 16));
          }
          return ESCAPES.get(c) || c;
        }
        function parseArguments(name, args) {
          const results = [];
          const chunks = args.trim().split(/\s*,\s*/g);
          let matches;
          for (const chunk of chunks) {
            if (!isNaN(chunk)) {
              results.push(Number(chunk));
            } else if (matches = chunk.match(STRING_REGEX)) {
              results.push(matches[2].replace(ESCAPE_REGEX, (m, escape, chr) => escape ? unescape(escape) : chr));
            } else {
              throw new Error(`Invalid Chalk template style argument: ${chunk} (in style '${name}')`);
            }
          }
          return results;
        }
        function parseStyle(style) {
          STYLE_REGEX.lastIndex = 0;
          const results = [];
          let matches;
          while ((matches = STYLE_REGEX.exec(style)) !== null) {
            const name = matches[1];
            if (matches[2]) {
              const args = parseArguments(name, matches[2]);
              results.push([name].concat(args));
            } else {
              results.push([name]);
            }
          }
          return results;
        }
        function buildStyle(chalk, styles) {
          const enabled = {};
          for (const layer of styles) {
            for (const style of layer.styles) {
              enabled[style[0]] = layer.inverse ? null : style.slice(1);
            }
          }
          let current = chalk;
          for (const styleName of Object.keys(enabled)) {
            if (Array.isArray(enabled[styleName])) {
              if (!(styleName in current)) {
                throw new Error(`Unknown Chalk style: ${styleName}`);
              }
              if (enabled[styleName].length > 0) {
                current = current[styleName].apply(current, enabled[styleName]);
              } else {
                current = current[styleName];
              }
            }
          }
          return current;
        }
        module22.exports = (chalk, tmp) => {
          const styles = [];
          const chunks = [];
          let chunk = [];
          tmp.replace(TEMPLATE_REGEX, (m, escapeChar, inverse, style, close, chr) => {
            if (escapeChar) {
              chunk.push(unescape(escapeChar));
            } else if (style) {
              const str2 = chunk.join("");
              chunk = [];
              chunks.push(styles.length === 0 ? str2 : buildStyle(chalk, styles)(str2));
              styles.push({
                inverse,
                styles: parseStyle(style)
              });
            } else if (close) {
              if (styles.length === 0) {
                throw new Error("Found extraneous } in Chalk template literal");
              }
              chunks.push(buildStyle(chalk, styles)(chunk.join("")));
              chunk = [];
              styles.pop();
            } else {
              chunk.push(chr);
            }
          });
          chunks.push(chunk.join(""));
          if (styles.length > 0) {
            const errMsg = `Chalk template literal is missing ${styles.length} closing bracket${styles.length === 1 ? "" : "s"} (\`}\`)`;
            throw new Error(errMsg);
          }
          return chunks.join("");
        };
      }
    });
    var require_chalk2 = __commonJS22({
      "node_modules/@babel/highlight/node_modules/chalk/index.js"(exports22, module22) {
        "use strict";
        var escapeStringRegexp2 = require_escape_string_regexp2();
        var ansiStyles = require_ansi_styles();
        var stdoutColor = require_supports_color2().stdout;
        var template = require_templates2();
        var isSimpleWindowsTerm = process.platform === "win32" && !(process.env.TERM || "").toLowerCase().startsWith("xterm");
        var levelMapping = ["ansi", "ansi", "ansi256", "ansi16m"];
        var skipModels = /* @__PURE__ */ new Set(["gray"]);
        var styles = /* @__PURE__ */ Object.create(null);
        function applyOptions(obj, options) {
          options = options || {};
          const scLevel = stdoutColor ? stdoutColor.level : 0;
          obj.level = options.level === void 0 ? scLevel : options.level;
          obj.enabled = "enabled" in options ? options.enabled : obj.level > 0;
        }
        function Chalk(options) {
          if (!this || !(this instanceof Chalk) || this.template) {
            const chalk = {};
            applyOptions(chalk, options);
            chalk.template = function() {
              const args = [].slice.call(arguments);
              return chalkTag.apply(null, [chalk.template].concat(args));
            };
            Object.setPrototypeOf(chalk, Chalk.prototype);
            Object.setPrototypeOf(chalk.template, chalk);
            chalk.template.constructor = Chalk;
            return chalk.template;
          }
          applyOptions(this, options);
        }
        if (isSimpleWindowsTerm) {
          ansiStyles.blue.open = "\x1B[94m";
        }
        for (const key of Object.keys(ansiStyles)) {
          ansiStyles[key].closeRe = new RegExp(escapeStringRegexp2(ansiStyles[key].close), "g");
          styles[key] = {
            get() {
              const codes = ansiStyles[key];
              return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, key);
            }
          };
        }
        styles.visible = {
          get() {
            return build.call(this, this._styles || [], true, "visible");
          }
        };
        ansiStyles.color.closeRe = new RegExp(escapeStringRegexp2(ansiStyles.color.close), "g");
        for (const model of Object.keys(ansiStyles.color.ansi)) {
          if (skipModels.has(model)) {
            continue;
          }
          styles[model] = {
            get() {
              const level = this.level;
              return function() {
                const open = ansiStyles.color[levelMapping[level]][model].apply(null, arguments);
                const codes = {
                  open,
                  close: ansiStyles.color.close,
                  closeRe: ansiStyles.color.closeRe
                };
                return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
              };
            }
          };
        }
        ansiStyles.bgColor.closeRe = new RegExp(escapeStringRegexp2(ansiStyles.bgColor.close), "g");
        for (const model of Object.keys(ansiStyles.bgColor.ansi)) {
          if (skipModels.has(model)) {
            continue;
          }
          const bgModel = "bg" + model[0].toUpperCase() + model.slice(1);
          styles[bgModel] = {
            get() {
              const level = this.level;
              return function() {
                const open = ansiStyles.bgColor[levelMapping[level]][model].apply(null, arguments);
                const codes = {
                  open,
                  close: ansiStyles.bgColor.close,
                  closeRe: ansiStyles.bgColor.closeRe
                };
                return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
              };
            }
          };
        }
        var proto = Object.defineProperties(() => {
        }, styles);
        function build(_styles, _empty, key) {
          const builder = function() {
            return applyStyle.apply(builder, arguments);
          };
          builder._styles = _styles;
          builder._empty = _empty;
          const self2 = this;
          Object.defineProperty(builder, "level", {
            enumerable: true,
            get() {
              return self2.level;
            },
            set(level) {
              self2.level = level;
            }
          });
          Object.defineProperty(builder, "enabled", {
            enumerable: true,
            get() {
              return self2.enabled;
            },
            set(enabled) {
              self2.enabled = enabled;
            }
          });
          builder.hasGrey = this.hasGrey || key === "gray" || key === "grey";
          builder.__proto__ = proto;
          return builder;
        }
        function applyStyle() {
          const args = arguments;
          const argsLen = args.length;
          let str2 = String(arguments[0]);
          if (argsLen === 0) {
            return "";
          }
          if (argsLen > 1) {
            for (let a = 1; a < argsLen; a++) {
              str2 += " " + args[a];
            }
          }
          if (!this.enabled || this.level <= 0 || !str2) {
            return this._empty ? "" : str2;
          }
          const originalDim = ansiStyles.dim.open;
          if (isSimpleWindowsTerm && this.hasGrey) {
            ansiStyles.dim.open = "";
          }
          for (const code of this._styles.slice().reverse()) {
            str2 = code.open + str2.replace(code.closeRe, code.open) + code.close;
            str2 = str2.replace(/\r?\n/g, `${code.close}$&${code.open}`);
          }
          ansiStyles.dim.open = originalDim;
          return str2;
        }
        function chalkTag(chalk, strings) {
          if (!Array.isArray(strings)) {
            return [].slice.call(arguments, 1).join(" ");
          }
          const args = [].slice.call(arguments, 2);
          const parts = [strings.raw[0]];
          for (let i = 1; i < strings.length; i++) {
            parts.push(String(args[i - 1]).replace(/[{}\\]/g, "\\$&"));
            parts.push(String(strings.raw[i]));
          }
          return template(chalk, parts.join(""));
        }
        Object.defineProperties(Chalk.prototype, styles);
        module22.exports = Chalk();
        module22.exports.supportsColor = stdoutColor;
        module22.exports.default = module22.exports;
      }
    });
    var require_lib42 = __commonJS22({
      "node_modules/@babel/highlight/lib/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.default = highlight;
        exports22.getChalk = getChalk;
        exports22.shouldHighlight = shouldHighlight;
        var _jsTokens = require_js_tokens();
        var _helperValidatorIdentifier = require_lib32();
        var _chalk = require_chalk2();
        var sometimesKeywords = /* @__PURE__ */ new Set(["as", "async", "from", "get", "of", "set"]);
        function getDefs(chalk) {
          return {
            keyword: chalk.cyan,
            capitalized: chalk.yellow,
            jsxIdentifier: chalk.yellow,
            punctuator: chalk.yellow,
            number: chalk.magenta,
            string: chalk.green,
            regex: chalk.magenta,
            comment: chalk.grey,
            invalid: chalk.white.bgRed.bold
          };
        }
        var NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
        var BRACKET = /^[()[\]{}]$/;
        var tokenize;
        {
          const JSX_TAG = /^[a-z][\w-]*$/i;
          const getTokenType = function(token, offset, text) {
            if (token.type === "name") {
              if ((0, _helperValidatorIdentifier.isKeyword)(token.value) || (0, _helperValidatorIdentifier.isStrictReservedWord)(token.value, true) || sometimesKeywords.has(token.value)) {
                return "keyword";
              }
              if (JSX_TAG.test(token.value) && (text[offset - 1] === "<" || text.substr(offset - 2, 2) == "</")) {
                return "jsxIdentifier";
              }
              if (token.value[0] !== token.value[0].toLowerCase()) {
                return "capitalized";
              }
            }
            if (token.type === "punctuator" && BRACKET.test(token.value)) {
              return "bracket";
            }
            if (token.type === "invalid" && (token.value === "@" || token.value === "#")) {
              return "punctuator";
            }
            return token.type;
          };
          tokenize = function* (text) {
            let match;
            while (match = _jsTokens.default.exec(text)) {
              const token = _jsTokens.matchToToken(match);
              yield {
                type: getTokenType(token, match.index, text),
                value: token.value
              };
            }
          };
        }
        function highlightTokens(defs, text) {
          let highlighted = "";
          for (const {
            type: type2,
            value
          } of tokenize(text)) {
            const colorize = defs[type2];
            if (colorize) {
              highlighted += value.split(NEWLINE).map((str2) => colorize(str2)).join("\n");
            } else {
              highlighted += value;
            }
          }
          return highlighted;
        }
        function shouldHighlight(options) {
          return !!_chalk.supportsColor || options.forceColor;
        }
        function getChalk(options) {
          return options.forceColor ? new _chalk.constructor({
            enabled: true,
            level: 1
          }) : _chalk;
        }
        function highlight(code, options = {}) {
          if (code !== "" && shouldHighlight(options)) {
            const chalk = getChalk(options);
            const defs = getDefs(chalk);
            return highlightTokens(defs, code);
          } else {
            return code;
          }
        }
      }
    });
    var require_lib5 = __commonJS22({
      "node_modules/@babel/code-frame/lib/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.codeFrameColumns = codeFrameColumns;
        exports22.default = _default2;
        var _highlight = require_lib42();
        var deprecationWarningShown = false;
        function getDefs(chalk) {
          return {
            gutter: chalk.grey,
            marker: chalk.red.bold,
            message: chalk.red.bold
          };
        }
        var NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
        function getMarkerLines(loc, source, opts) {
          const startLoc = Object.assign({
            column: 0,
            line: -1
          }, loc.start);
          const endLoc = Object.assign({}, startLoc, loc.end);
          const {
            linesAbove = 2,
            linesBelow = 3
          } = opts || {};
          const startLine = startLoc.line;
          const startColumn = startLoc.column;
          const endLine = endLoc.line;
          const endColumn = endLoc.column;
          let start = Math.max(startLine - (linesAbove + 1), 0);
          let end = Math.min(source.length, endLine + linesBelow);
          if (startLine === -1) {
            start = 0;
          }
          if (endLine === -1) {
            end = source.length;
          }
          const lineDiff = endLine - startLine;
          const markerLines = {};
          if (lineDiff) {
            for (let i = 0; i <= lineDiff; i++) {
              const lineNumber = i + startLine;
              if (!startColumn) {
                markerLines[lineNumber] = true;
              } else if (i === 0) {
                const sourceLength = source[lineNumber - 1].length;
                markerLines[lineNumber] = [startColumn, sourceLength - startColumn + 1];
              } else if (i === lineDiff) {
                markerLines[lineNumber] = [0, endColumn];
              } else {
                const sourceLength = source[lineNumber - i].length;
                markerLines[lineNumber] = [0, sourceLength];
              }
            }
          } else {
            if (startColumn === endColumn) {
              if (startColumn) {
                markerLines[startLine] = [startColumn, 0];
              } else {
                markerLines[startLine] = true;
              }
            } else {
              markerLines[startLine] = [startColumn, endColumn - startColumn];
            }
          }
          return {
            start,
            end,
            markerLines
          };
        }
        function codeFrameColumns(rawLines, loc, opts = {}) {
          const highlighted = (opts.highlightCode || opts.forceColor) && (0, _highlight.shouldHighlight)(opts);
          const chalk = (0, _highlight.getChalk)(opts);
          const defs = getDefs(chalk);
          const maybeHighlight = (chalkFn, string3) => {
            return highlighted ? chalkFn(string3) : string3;
          };
          const lines = rawLines.split(NEWLINE);
          const {
            start,
            end,
            markerLines
          } = getMarkerLines(loc, lines, opts);
          const hasColumns = loc.start && typeof loc.start.column === "number";
          const numberMaxWidth = String(end).length;
          const highlightedLines = highlighted ? (0, _highlight.default)(rawLines, opts) : rawLines;
          let frame = highlightedLines.split(NEWLINE, end).slice(start, end).map((line, index) => {
            const number3 = start + 1 + index;
            const paddedNumber = ` ${number3}`.slice(-numberMaxWidth);
            const gutter = ` ${paddedNumber} |`;
            const hasMarker = markerLines[number3];
            const lastMarkerLine = !markerLines[number3 + 1];
            if (hasMarker) {
              let markerLine = "";
              if (Array.isArray(hasMarker)) {
                const markerSpacing = line.slice(0, Math.max(hasMarker[0] - 1, 0)).replace(/[^\t]/g, " ");
                const numberOfMarkers = hasMarker[1] || 1;
                markerLine = ["\n ", maybeHighlight(defs.gutter, gutter.replace(/\d/g, " ")), " ", markerSpacing, maybeHighlight(defs.marker, "^").repeat(numberOfMarkers)].join("");
                if (lastMarkerLine && opts.message) {
                  markerLine += " " + maybeHighlight(defs.message, opts.message);
                }
              }
              return [maybeHighlight(defs.marker, ">"), maybeHighlight(defs.gutter, gutter), line.length > 0 ? ` ${line}` : "", markerLine].join("");
            } else {
              return ` ${maybeHighlight(defs.gutter, gutter)}${line.length > 0 ? ` ${line}` : ""}`;
            }
          }).join("\n");
          if (opts.message && !hasColumns) {
            frame = `${" ".repeat(numberMaxWidth + 1)}${opts.message}
${frame}`;
          }
          if (highlighted) {
            return chalk.reset(frame);
          } else {
            return frame;
          }
        }
        function _default2(rawLines, lineNumber, colNumber, opts = {}) {
          if (!deprecationWarningShown) {
            deprecationWarningShown = true;
            const message = "Passing lineNumber and colNumber is deprecated to @babel/code-frame. Please use `codeFrameColumns`.";
            if (process.emitWarning) {
              process.emitWarning(message, "DeprecationWarning");
            } else {
              const deprecationError = new Error(message);
              deprecationError.name = "DeprecationWarning";
              console.warn(new Error(message));
            }
          }
          colNumber = Math.max(colNumber, 0);
          const location = {
            start: {
              column: colNumber,
              line: lineNumber
            }
          };
          return codeFrameColumns(rawLines, location, opts);
        }
      }
    });
    var require_parser3 = __commonJS22({
      "src/main/parser.js"(exports22, module22) {
        "use strict";
        var {
          ConfigError
        } = require_errors3();
        var jsLoc = require_loc();
        var loadParser = require_load_parser();
        var {
          locStart,
          locEnd
        } = jsLoc;
        var ownNames = Object.getOwnPropertyNames;
        var ownDescriptor = Object.getOwnPropertyDescriptor;
        function getParsers(options) {
          const parsers = {};
          for (const plugin of options.plugins) {
            if (!plugin.parsers) {
              continue;
            }
            for (const name of ownNames(plugin.parsers)) {
              Object.defineProperty(parsers, name, ownDescriptor(plugin.parsers, name));
            }
          }
          return parsers;
        }
        function resolveParser(opts, parsers = getParsers(opts)) {
          if (typeof opts.parser === "function") {
            return {
              parse: opts.parser,
              astFormat: "estree",
              locStart,
              locEnd
            };
          }
          if (typeof opts.parser === "string") {
            if (Object.prototype.hasOwnProperty.call(parsers, opts.parser)) {
              return parsers[opts.parser];
            }
            if (false) {
              throw new ConfigError(`Couldn't resolve parser "${opts.parser}". Parsers must be explicitly added to the standalone bundle.`);
            }
            return loadParser(opts.parser);
          }
        }
        function parse2(text, opts) {
          const parsers = getParsers(opts);
          const parsersForCustomParserApi = Object.defineProperties({}, Object.fromEntries(Object.keys(parsers).map((parserName) => [parserName, {
            enumerable: true,
            get() {
              return parsers[parserName].parse;
            }
          }])));
          const parser = resolveParser(opts, parsers);
          try {
            if (parser.preprocess) {
              text = parser.preprocess(text, opts);
            }
            return {
              text,
              ast: parser.parse(text, parsersForCustomParserApi, opts)
            };
          } catch (error) {
            const {
              loc
            } = error;
            if (loc) {
              const {
                codeFrameColumns
              } = require_lib5();
              error.codeFrame = codeFrameColumns(text, loc, {
                highlightCode: true
              });
              error.message += "\n" + error.codeFrame;
              throw error;
            }
            throw error.stack;
          }
        }
        module22.exports = {
          parse: parse2,
          resolveParser
        };
      }
    });
    var require_readlines = __commonJS22({
      "node_modules/n-readlines/readlines.js"(exports22, module22) {
        "use strict";
        var fs = require("fs");
        var LineByLine = class {
          constructor(file, options) {
            options = options || {};
            if (!options.readChunk)
              options.readChunk = 1024;
            if (!options.newLineCharacter) {
              options.newLineCharacter = 10;
            } else {
              options.newLineCharacter = options.newLineCharacter.charCodeAt(0);
            }
            if (typeof file === "number") {
              this.fd = file;
            } else {
              this.fd = fs.openSync(file, "r");
            }
            this.options = options;
            this.newLineCharacter = options.newLineCharacter;
            this.reset();
          }
          _searchInBuffer(buffer, hexNeedle) {
            let found = -1;
            for (let i = 0; i <= buffer.length; i++) {
              let b_byte = buffer[i];
              if (b_byte === hexNeedle) {
                found = i;
                break;
              }
            }
            return found;
          }
          reset() {
            this.eofReached = false;
            this.linesCache = [];
            this.fdPosition = 0;
          }
          close() {
            fs.closeSync(this.fd);
            this.fd = null;
          }
          _extractLines(buffer) {
            let line;
            const lines = [];
            let bufferPosition = 0;
            let lastNewLineBufferPosition = 0;
            while (true) {
              let bufferPositionValue = buffer[bufferPosition++];
              if (bufferPositionValue === this.newLineCharacter) {
                line = buffer.slice(lastNewLineBufferPosition, bufferPosition);
                lines.push(line);
                lastNewLineBufferPosition = bufferPosition;
              } else if (bufferPositionValue === void 0) {
                break;
              }
            }
            let leftovers = buffer.slice(lastNewLineBufferPosition, bufferPosition);
            if (leftovers.length) {
              lines.push(leftovers);
            }
            return lines;
          }
          _readChunk(lineLeftovers) {
            let totalBytesRead = 0;
            let bytesRead;
            const buffers = [];
            do {
              const readBuffer = new Buffer(this.options.readChunk);
              bytesRead = fs.readSync(this.fd, readBuffer, 0, this.options.readChunk, this.fdPosition);
              totalBytesRead = totalBytesRead + bytesRead;
              this.fdPosition = this.fdPosition + bytesRead;
              buffers.push(readBuffer);
            } while (bytesRead && this._searchInBuffer(buffers[buffers.length - 1], this.options.newLineCharacter) === -1);
            let bufferData = Buffer.concat(buffers);
            if (bytesRead < this.options.readChunk) {
              this.eofReached = true;
              bufferData = bufferData.slice(0, totalBytesRead);
            }
            if (totalBytesRead) {
              this.linesCache = this._extractLines(bufferData);
              if (lineLeftovers) {
                this.linesCache[0] = Buffer.concat([lineLeftovers, this.linesCache[0]]);
              }
            }
            return totalBytesRead;
          }
          next() {
            if (!this.fd)
              return false;
            let line = false;
            if (this.eofReached && this.linesCache.length === 0) {
              return line;
            }
            let bytesRead;
            if (!this.linesCache.length) {
              bytesRead = this._readChunk();
            }
            if (this.linesCache.length) {
              line = this.linesCache.shift();
              const lastLineCharacter = line[line.length - 1];
              if (lastLineCharacter !== this.newLineCharacter) {
                bytesRead = this._readChunk(line);
                if (bytesRead) {
                  line = this.linesCache.shift();
                }
              }
            }
            if (this.eofReached && this.linesCache.length === 0) {
              this.close();
            }
            if (line && line[line.length - 1] === this.newLineCharacter) {
              line = line.slice(0, line.length - 1);
            }
            return line;
          }
        };
        module22.exports = LineByLine;
      }
    });
    var require_get_interpreter = __commonJS22({
      "src/utils/get-interpreter.js"(exports22, module22) {
        "use strict";
        var fs = require("fs");
        var readlines = require_readlines();
        function getInterpreter(filepath) {
          if (typeof filepath !== "string") {
            return "";
          }
          let fd;
          try {
            fd = fs.openSync(filepath, "r");
          } catch {
            return "";
          }
          try {
            const liner = new readlines(fd);
            const firstLine = liner.next().toString("utf8");
            const m1 = firstLine.match(/^#!\/(?:usr\/)?bin\/env\s+(\S+)/);
            if (m1) {
              return m1[1];
            }
            const m2 = firstLine.match(/^#!\/(?:usr\/(?:local\/)?)?bin\/(\S+)/);
            if (m2) {
              return m2[1];
            }
            return "";
          } catch {
            return "";
          } finally {
            try {
              fs.closeSync(fd);
            } catch {
            }
          }
        }
        module22.exports = getInterpreter;
      }
    });
    var require_options = __commonJS22({
      "src/main/options.js"(exports22, module22) {
        "use strict";
        var path5 = require("path");
        var {
          UndefinedParserError
        } = require_errors3();
        var {
          getSupportInfo: getSupportInfo2
        } = require_support();
        var normalizer = require_options_normalizer();
        var {
          resolveParser
        } = require_parser3();
        var hiddenDefaults = {
          astFormat: "estree",
          printer: {},
          originalText: void 0,
          locStart: null,
          locEnd: null
        };
        function normalize2(options, opts = {}) {
          const rawOptions = Object.assign({}, options);
          const supportOptions = getSupportInfo2({
            plugins: options.plugins,
            showUnreleased: true,
            showDeprecated: true
          }).options;
          const defaults = Object.assign(Object.assign({}, hiddenDefaults), Object.fromEntries(supportOptions.filter((optionInfo) => optionInfo.default !== void 0).map((option) => [option.name, option.default])));
          if (!rawOptions.parser) {
            if (!rawOptions.filepath) {
              const logger = opts.logger || console;
              logger.warn("No parser and no filepath given, using 'babel' the parser now but this will throw an error in the future. Please specify a parser or a filepath so one can be inferred.");
              rawOptions.parser = "babel";
            } else {
              rawOptions.parser = inferParser(rawOptions.filepath, rawOptions.plugins);
              if (!rawOptions.parser) {
                throw new UndefinedParserError(`No parser could be inferred for file: ${rawOptions.filepath}`);
              }
            }
          }
          const parser = resolveParser(normalizer.normalizeApiOptions(rawOptions, [supportOptions.find((x) => x.name === "parser")], {
            passThrough: true,
            logger: false
          }));
          rawOptions.astFormat = parser.astFormat;
          rawOptions.locEnd = parser.locEnd;
          rawOptions.locStart = parser.locStart;
          const plugin = getPlugin(rawOptions);
          rawOptions.printer = plugin.printers[rawOptions.astFormat];
          const pluginDefaults = Object.fromEntries(supportOptions.filter((optionInfo) => optionInfo.pluginDefaults && optionInfo.pluginDefaults[plugin.name] !== void 0).map((optionInfo) => [optionInfo.name, optionInfo.pluginDefaults[plugin.name]]));
          const mixedDefaults = Object.assign(Object.assign({}, defaults), pluginDefaults);
          for (const [k, value] of Object.entries(mixedDefaults)) {
            if (rawOptions[k] === null || rawOptions[k] === void 0) {
              rawOptions[k] = value;
            }
          }
          if (rawOptions.parser === "json") {
            rawOptions.trailingComma = "none";
          }
          return normalizer.normalizeApiOptions(rawOptions, supportOptions, Object.assign({
            passThrough: Object.keys(hiddenDefaults)
          }, opts));
        }
        function getPlugin(options) {
          const {
            astFormat
          } = options;
          if (!astFormat) {
            throw new Error("getPlugin() requires astFormat to be set");
          }
          const printerPlugin = options.plugins.find((plugin) => plugin.printers && plugin.printers[astFormat]);
          if (!printerPlugin) {
            throw new Error(`Couldn't find plugin for AST format "${astFormat}"`);
          }
          return printerPlugin;
        }
        function inferParser(filepath, plugins2) {
          const filename = path5.basename(filepath).toLowerCase();
          const languages = getSupportInfo2({
            plugins: plugins2
          }).languages.filter((language2) => language2.since !== null);
          let language = languages.find((language2) => language2.extensions && language2.extensions.some((extension) => filename.endsWith(extension)) || language2.filenames && language2.filenames.some((name) => name.toLowerCase() === filename));
          if (!language && !filename.includes(".")) {
            const getInterpreter = require_get_interpreter();
            const interpreter = getInterpreter(filepath);
            language = languages.find((language2) => language2.interpreters && language2.interpreters.includes(interpreter));
          }
          return language && language.parsers[0];
        }
        module22.exports = {
          normalize: normalize2,
          hiddenDefaults,
          inferParser
        };
      }
    });
    var require_massage_ast = __commonJS22({
      "src/main/massage-ast.js"(exports22, module22) {
        "use strict";
        function massageAST(ast, options, parent) {
          if (Array.isArray(ast)) {
            return ast.map((e) => massageAST(e, options, parent)).filter(Boolean);
          }
          if (!ast || typeof ast !== "object") {
            return ast;
          }
          const cleanFunction = options.printer.massageAstNode;
          let ignoredProperties;
          if (cleanFunction && cleanFunction.ignoredProperties) {
            ignoredProperties = cleanFunction.ignoredProperties;
          } else {
            ignoredProperties = /* @__PURE__ */ new Set();
          }
          const newObj = {};
          for (const [key, value] of Object.entries(ast)) {
            if (!ignoredProperties.has(key) && typeof value !== "function") {
              newObj[key] = massageAST(value, options, ast);
            }
          }
          if (cleanFunction) {
            const result = cleanFunction(ast, newObj, parent);
            if (result === null) {
              return;
            }
            if (result) {
              return result;
            }
          }
          return newObj;
        }
        module22.exports = massageAST;
      }
    });
    var require_comments = __commonJS22({
      "src/main/comments.js"(exports22, module22) {
        "use strict";
        var assert = require("assert");
        var {
          builders: {
            line,
            hardline,
            breakParent,
            indent,
            lineSuffix,
            join: join2,
            cursor
          }
        } = require_doc();
        var {
          hasNewline,
          skipNewline,
          skipSpaces,
          isPreviousLineEmpty,
          addLeadingComment,
          addDanglingComment,
          addTrailingComment
        } = require_util2();
        var childNodesCache = /* @__PURE__ */ new WeakMap();
        function getSortedChildNodes(node, options, resultArray) {
          if (!node) {
            return;
          }
          const {
            printer,
            locStart,
            locEnd
          } = options;
          if (resultArray) {
            if (printer.canAttachComment && printer.canAttachComment(node)) {
              let i;
              for (i = resultArray.length - 1; i >= 0; --i) {
                if (locStart(resultArray[i]) <= locStart(node) && locEnd(resultArray[i]) <= locEnd(node)) {
                  break;
                }
              }
              resultArray.splice(i + 1, 0, node);
              return;
            }
          } else if (childNodesCache.has(node)) {
            return childNodesCache.get(node);
          }
          const childNodes = printer.getCommentChildNodes && printer.getCommentChildNodes(node, options) || typeof node === "object" && Object.entries(node).filter(([key]) => key !== "enclosingNode" && key !== "precedingNode" && key !== "followingNode" && key !== "tokens" && key !== "comments" && key !== "parent").map(([, value]) => value);
          if (!childNodes) {
            return;
          }
          if (!resultArray) {
            resultArray = [];
            childNodesCache.set(node, resultArray);
          }
          for (const childNode of childNodes) {
            getSortedChildNodes(childNode, options, resultArray);
          }
          return resultArray;
        }
        function decorateComment(node, comment, options, enclosingNode) {
          const {
            locStart,
            locEnd
          } = options;
          const commentStart = locStart(comment);
          const commentEnd = locEnd(comment);
          const childNodes = getSortedChildNodes(node, options);
          let precedingNode;
          let followingNode;
          let left = 0;
          let right = childNodes.length;
          while (left < right) {
            const middle = left + right >> 1;
            const child = childNodes[middle];
            const start = locStart(child);
            const end = locEnd(child);
            if (start <= commentStart && commentEnd <= end) {
              return decorateComment(child, comment, options, child);
            }
            if (end <= commentStart) {
              precedingNode = child;
              left = middle + 1;
              continue;
            }
            if (commentEnd <= start) {
              followingNode = child;
              right = middle;
              continue;
            }
            throw new Error("Comment location overlaps with node location");
          }
          if (enclosingNode && enclosingNode.type === "TemplateLiteral") {
            const {
              quasis
            } = enclosingNode;
            const commentIndex = findExpressionIndexForComment(quasis, comment, options);
            if (precedingNode && findExpressionIndexForComment(quasis, precedingNode, options) !== commentIndex) {
              precedingNode = null;
            }
            if (followingNode && findExpressionIndexForComment(quasis, followingNode, options) !== commentIndex) {
              followingNode = null;
            }
          }
          return {
            enclosingNode,
            precedingNode,
            followingNode
          };
        }
        var returnFalse = () => false;
        function attach(comments, ast, text, options) {
          if (!Array.isArray(comments)) {
            return;
          }
          const tiesToBreak = [];
          const {
            locStart,
            locEnd,
            printer: {
              handleComments = {}
            }
          } = options;
          const {
            avoidAstMutation,
            ownLine: handleOwnLineComment = returnFalse,
            endOfLine: handleEndOfLineComment = returnFalse,
            remaining: handleRemainingComment = returnFalse
          } = handleComments;
          const decoratedComments = comments.map((comment, index) => Object.assign(Object.assign({}, decorateComment(ast, comment, options)), {}, {
            comment,
            text,
            options,
            ast,
            isLastComment: comments.length - 1 === index
          }));
          for (const [index, context] of decoratedComments.entries()) {
            const {
              comment,
              precedingNode,
              enclosingNode,
              followingNode,
              text: text2,
              options: options2,
              ast: ast2,
              isLastComment
            } = context;
            if (options2.parser === "json" || options2.parser === "json5" || options2.parser === "__js_expression" || options2.parser === "__vue_expression" || options2.parser === "__vue_ts_expression") {
              if (locStart(comment) - locStart(ast2) <= 0) {
                addLeadingComment(ast2, comment);
                continue;
              }
              if (locEnd(comment) - locEnd(ast2) >= 0) {
                addTrailingComment(ast2, comment);
                continue;
              }
            }
            let args;
            if (avoidAstMutation) {
              args = [context];
            } else {
              comment.enclosingNode = enclosingNode;
              comment.precedingNode = precedingNode;
              comment.followingNode = followingNode;
              args = [comment, text2, options2, ast2, isLastComment];
            }
            if (isOwnLineComment(text2, options2, decoratedComments, index)) {
              comment.placement = "ownLine";
              if (handleOwnLineComment(...args)) {
              } else if (followingNode) {
                addLeadingComment(followingNode, comment);
              } else if (precedingNode) {
                addTrailingComment(precedingNode, comment);
              } else if (enclosingNode) {
                addDanglingComment(enclosingNode, comment);
              } else {
                addDanglingComment(ast2, comment);
              }
            } else if (isEndOfLineComment(text2, options2, decoratedComments, index)) {
              comment.placement = "endOfLine";
              if (handleEndOfLineComment(...args)) {
              } else if (precedingNode) {
                addTrailingComment(precedingNode, comment);
              } else if (followingNode) {
                addLeadingComment(followingNode, comment);
              } else if (enclosingNode) {
                addDanglingComment(enclosingNode, comment);
              } else {
                addDanglingComment(ast2, comment);
              }
            } else {
              comment.placement = "remaining";
              if (handleRemainingComment(...args)) {
              } else if (precedingNode && followingNode) {
                const tieCount = tiesToBreak.length;
                if (tieCount > 0) {
                  const lastTie = tiesToBreak[tieCount - 1];
                  if (lastTie.followingNode !== followingNode) {
                    breakTies(tiesToBreak, text2, options2);
                  }
                }
                tiesToBreak.push(context);
              } else if (precedingNode) {
                addTrailingComment(precedingNode, comment);
              } else if (followingNode) {
                addLeadingComment(followingNode, comment);
              } else if (enclosingNode) {
                addDanglingComment(enclosingNode, comment);
              } else {
                addDanglingComment(ast2, comment);
              }
            }
          }
          breakTies(tiesToBreak, text, options);
          if (!avoidAstMutation) {
            for (const comment of comments) {
              delete comment.precedingNode;
              delete comment.enclosingNode;
              delete comment.followingNode;
            }
          }
        }
        var isAllEmptyAndNoLineBreak = (text) => !/[\S\n\u2028\u2029]/.test(text);
        function isOwnLineComment(text, options, decoratedComments, commentIndex) {
          const {
            comment,
            precedingNode
          } = decoratedComments[commentIndex];
          const {
            locStart,
            locEnd
          } = options;
          let start = locStart(comment);
          if (precedingNode) {
            for (let index = commentIndex - 1; index >= 0; index--) {
              const {
                comment: comment2,
                precedingNode: currentCommentPrecedingNode
              } = decoratedComments[index];
              if (currentCommentPrecedingNode !== precedingNode || !isAllEmptyAndNoLineBreak(text.slice(locEnd(comment2), start))) {
                break;
              }
              start = locStart(comment2);
            }
          }
          return hasNewline(text, start, {
            backwards: true
          });
        }
        function isEndOfLineComment(text, options, decoratedComments, commentIndex) {
          const {
            comment,
            followingNode
          } = decoratedComments[commentIndex];
          const {
            locStart,
            locEnd
          } = options;
          let end = locEnd(comment);
          if (followingNode) {
            for (let index = commentIndex + 1; index < decoratedComments.length; index++) {
              const {
                comment: comment2,
                followingNode: currentCommentFollowingNode
              } = decoratedComments[index];
              if (currentCommentFollowingNode !== followingNode || !isAllEmptyAndNoLineBreak(text.slice(end, locStart(comment2)))) {
                break;
              }
              end = locEnd(comment2);
            }
          }
          return hasNewline(text, end);
        }
        function breakTies(tiesToBreak, text, options) {
          const tieCount = tiesToBreak.length;
          if (tieCount === 0) {
            return;
          }
          const {
            precedingNode,
            followingNode,
            enclosingNode
          } = tiesToBreak[0];
          const gapRegExp = options.printer.getGapRegex && options.printer.getGapRegex(enclosingNode) || /^[\s(]*$/;
          let gapEndPos = options.locStart(followingNode);
          let indexOfFirstLeadingComment;
          for (indexOfFirstLeadingComment = tieCount; indexOfFirstLeadingComment > 0; --indexOfFirstLeadingComment) {
            const {
              comment,
              precedingNode: currentCommentPrecedingNode,
              followingNode: currentCommentFollowingNode
            } = tiesToBreak[indexOfFirstLeadingComment - 1];
            assert.strictEqual(currentCommentPrecedingNode, precedingNode);
            assert.strictEqual(currentCommentFollowingNode, followingNode);
            const gap = text.slice(options.locEnd(comment), gapEndPos);
            if (gapRegExp.test(gap)) {
              gapEndPos = options.locStart(comment);
            } else {
              break;
            }
          }
          for (const [i, {
            comment
          }] of tiesToBreak.entries()) {
            if (i < indexOfFirstLeadingComment) {
              addTrailingComment(precedingNode, comment);
            } else {
              addLeadingComment(followingNode, comment);
            }
          }
          for (const node of [precedingNode, followingNode]) {
            if (node.comments && node.comments.length > 1) {
              node.comments.sort((a, b) => options.locStart(a) - options.locStart(b));
            }
          }
          tiesToBreak.length = 0;
        }
        function printComment(path5, options) {
          const comment = path5.getValue();
          comment.printed = true;
          return options.printer.printComment(path5, options);
        }
        function findExpressionIndexForComment(quasis, comment, options) {
          const startPos = options.locStart(comment) - 1;
          for (let i = 1; i < quasis.length; ++i) {
            if (startPos < options.locStart(quasis[i])) {
              return i - 1;
            }
          }
          return 0;
        }
        function printLeadingComment(path5, options) {
          const comment = path5.getValue();
          const parts = [printComment(path5, options)];
          const {
            printer,
            originalText,
            locStart,
            locEnd
          } = options;
          const isBlock = printer.isBlockComment && printer.isBlockComment(comment);
          if (isBlock) {
            const lineBreak = hasNewline(originalText, locEnd(comment)) ? hasNewline(originalText, locStart(comment), {
              backwards: true
            }) ? hardline : line : " ";
            parts.push(lineBreak);
          } else {
            parts.push(hardline);
          }
          const index = skipNewline(originalText, skipSpaces(originalText, locEnd(comment)));
          if (index !== false && hasNewline(originalText, index)) {
            parts.push(hardline);
          }
          return parts;
        }
        function printTrailingComment(path5, options) {
          const comment = path5.getValue();
          const printed = printComment(path5, options);
          const {
            printer,
            originalText,
            locStart
          } = options;
          const isBlock = printer.isBlockComment && printer.isBlockComment(comment);
          if (hasNewline(originalText, locStart(comment), {
            backwards: true
          })) {
            const isLineBeforeEmpty = isPreviousLineEmpty(originalText, comment, locStart);
            return lineSuffix([hardline, isLineBeforeEmpty ? hardline : "", printed]);
          }
          let parts = [" ", printed];
          if (!isBlock) {
            parts = [lineSuffix(parts), breakParent];
          }
          return parts;
        }
        function printDanglingComments(path5, options, sameIndent, filter) {
          const parts = [];
          const node = path5.getValue();
          if (!node || !node.comments) {
            return "";
          }
          path5.each(() => {
            const comment = path5.getValue();
            if (!comment.leading && !comment.trailing && (!filter || filter(comment))) {
              parts.push(printComment(path5, options));
            }
          }, "comments");
          if (parts.length === 0) {
            return "";
          }
          if (sameIndent) {
            return join2(hardline, parts);
          }
          return indent([hardline, join2(hardline, parts)]);
        }
        function printCommentsSeparately(path5, options, ignored) {
          const value = path5.getValue();
          if (!value) {
            return {};
          }
          let comments = value.comments || [];
          if (ignored) {
            comments = comments.filter((comment) => !ignored.has(comment));
          }
          const isCursorNode = value === options.cursorNode;
          if (comments.length === 0) {
            const maybeCursor = isCursorNode ? cursor : "";
            return {
              leading: maybeCursor,
              trailing: maybeCursor
            };
          }
          const leadingParts = [];
          const trailingParts = [];
          path5.each(() => {
            const comment = path5.getValue();
            if (ignored && ignored.has(comment)) {
              return;
            }
            const {
              leading,
              trailing
            } = comment;
            if (leading) {
              leadingParts.push(printLeadingComment(path5, options));
            } else if (trailing) {
              trailingParts.push(printTrailingComment(path5, options));
            }
          }, "comments");
          if (isCursorNode) {
            leadingParts.unshift(cursor);
            trailingParts.push(cursor);
          }
          return {
            leading: leadingParts,
            trailing: trailingParts
          };
        }
        function printComments(path5, doc2, options, ignored) {
          const {
            leading,
            trailing
          } = printCommentsSeparately(path5, options, ignored);
          if (!leading && !trailing) {
            return doc2;
          }
          return [leading, doc2, trailing];
        }
        function ensureAllCommentsPrinted(astComments) {
          if (!astComments) {
            return;
          }
          for (const comment of astComments) {
            if (!comment.printed) {
              throw new Error('Comment "' + comment.value.trim() + '" was not printed. Please report this error!');
            }
            delete comment.printed;
          }
        }
        module22.exports = {
          attach,
          printComments,
          printCommentsSeparately,
          printDanglingComments,
          getSortedChildNodes,
          ensureAllCommentsPrinted
        };
      }
    });
    var require_ast_path = __commonJS22({
      "src/common/ast-path.js"(exports22, module22) {
        "use strict";
        var getLast = require_get_last();
        function getNodeHelper(path5, count) {
          const stackIndex = getNodeStackIndexHelper(path5.stack, count);
          return stackIndex === -1 ? null : path5.stack[stackIndex];
        }
        function getNodeStackIndexHelper(stack, count) {
          for (let i = stack.length - 1; i >= 0; i -= 2) {
            const value = stack[i];
            if (value && !Array.isArray(value) && --count < 0) {
              return i;
            }
          }
          return -1;
        }
        var AstPath = class {
          constructor(value) {
            this.stack = [value];
          }
          getName() {
            const {
              stack
            } = this;
            const {
              length
            } = stack;
            if (length > 1) {
              return stack[length - 2];
            }
            return null;
          }
          getValue() {
            return getLast(this.stack);
          }
          getNode(count = 0) {
            return getNodeHelper(this, count);
          }
          getParentNode(count = 0) {
            return getNodeHelper(this, count + 1);
          }
          call(callback, ...names) {
            const {
              stack
            } = this;
            const {
              length
            } = stack;
            let value = getLast(stack);
            for (const name of names) {
              value = value[name];
              stack.push(name, value);
            }
            const result = callback(this);
            stack.length = length;
            return result;
          }
          callParent(callback, count = 0) {
            const stackIndex = getNodeStackIndexHelper(this.stack, count + 1);
            const parentValues = this.stack.splice(stackIndex + 1);
            const result = callback(this);
            this.stack.push(...parentValues);
            return result;
          }
          each(callback, ...names) {
            const {
              stack
            } = this;
            const {
              length
            } = stack;
            let value = getLast(stack);
            for (const name of names) {
              value = value[name];
              stack.push(name, value);
            }
            for (let i = 0; i < value.length; ++i) {
              stack.push(i, value[i]);
              callback(this, i, value);
              stack.length -= 2;
            }
            stack.length = length;
          }
          map(callback, ...names) {
            const result = [];
            this.each((path5, index, value) => {
              result[index] = callback(path5, index, value);
            }, ...names);
            return result;
          }
          try(callback) {
            const {
              stack
            } = this;
            const stackBackup = [...stack];
            try {
              return callback();
            } finally {
              stack.length = 0;
              stack.push(...stackBackup);
            }
          }
          match(...predicates) {
            let stackPointer = this.stack.length - 1;
            let name = null;
            let node = this.stack[stackPointer--];
            for (const predicate of predicates) {
              if (node === void 0) {
                return false;
              }
              let number3 = null;
              if (typeof name === "number") {
                number3 = name;
                name = this.stack[stackPointer--];
                node = this.stack[stackPointer--];
              }
              if (predicate && !predicate(node, name, number3)) {
                return false;
              }
              name = this.stack[stackPointer--];
              node = this.stack[stackPointer--];
            }
            return true;
          }
          findAncestor(predicate) {
            let stackPointer = this.stack.length - 1;
            let name = null;
            let node = this.stack[stackPointer--];
            while (node) {
              let number3 = null;
              if (typeof name === "number") {
                number3 = name;
                name = this.stack[stackPointer--];
                node = this.stack[stackPointer--];
              }
              if (name !== null && predicate(node, name, number3)) {
                return node;
              }
              name = this.stack[stackPointer--];
              node = this.stack[stackPointer--];
            }
          }
        };
        module22.exports = AstPath;
      }
    });
    var require_multiparser = __commonJS22({
      "src/main/multiparser.js"(exports22, module22) {
        "use strict";
        var {
          utils: {
            stripTrailingHardline
          }
        } = require_doc();
        var {
          normalize: normalize2
        } = require_options();
        var comments = require_comments();
        function printSubtree(path5, print, options, printAstToDoc) {
          if (options.printer.embed && options.embeddedLanguageFormatting === "auto") {
            return options.printer.embed(path5, print, (text, partialNextOptions, textToDocOptions) => textToDoc(text, partialNextOptions, options, printAstToDoc, textToDocOptions), options);
          }
        }
        function textToDoc(text, partialNextOptions, parentOptions, printAstToDoc, {
          stripTrailingHardline: shouldStripTrailingHardline = false
        } = {}) {
          const nextOptions = normalize2(Object.assign(Object.assign(Object.assign({}, parentOptions), partialNextOptions), {}, {
            parentParser: parentOptions.parser,
            originalText: text
          }), {
            passThrough: true
          });
          const result = require_parser3().parse(text, nextOptions);
          const {
            ast
          } = result;
          text = result.text;
          const astComments = ast.comments;
          delete ast.comments;
          comments.attach(astComments, ast, text, nextOptions);
          nextOptions[Symbol.for("comments")] = astComments || [];
          nextOptions[Symbol.for("tokens")] = ast.tokens || [];
          const doc2 = printAstToDoc(ast, nextOptions);
          comments.ensureAllCommentsPrinted(astComments);
          if (shouldStripTrailingHardline) {
            if (typeof doc2 === "string") {
              return doc2.replace(/(?:\r?\n)*$/, "");
            }
            return stripTrailingHardline(doc2);
          }
          return doc2;
        }
        module22.exports = {
          printSubtree
        };
      }
    });
    var require_ast_to_doc = __commonJS22({
      "src/main/ast-to-doc.js"(exports22, module22) {
        "use strict";
        var AstPath = require_ast_path();
        var {
          builders: {
            hardline,
            addAlignmentToDoc
          },
          utils: {
            propagateBreaks
          }
        } = require_doc();
        var {
          printComments
        } = require_comments();
        var multiparser = require_multiparser();
        function printAstToDoc(ast, options, alignmentSize = 0) {
          const {
            printer
          } = options;
          if (printer.preprocess) {
            ast = printer.preprocess(ast, options);
          }
          const cache = /* @__PURE__ */ new Map();
          const path5 = new AstPath(ast);
          let doc2 = mainPrint();
          if (alignmentSize > 0) {
            doc2 = addAlignmentToDoc([hardline, doc2], alignmentSize, options.tabWidth);
          }
          propagateBreaks(doc2);
          return doc2;
          function mainPrint(selector, args) {
            if (selector === void 0 || selector === path5) {
              return mainPrintInternal(args);
            }
            if (Array.isArray(selector)) {
              return path5.call(() => mainPrintInternal(args), ...selector);
            }
            return path5.call(() => mainPrintInternal(args), selector);
          }
          function mainPrintInternal(args) {
            const value = path5.getValue();
            const shouldCache = value && typeof value === "object" && args === void 0;
            if (shouldCache && cache.has(value)) {
              return cache.get(value);
            }
            const doc3 = callPluginPrintFunction(path5, options, mainPrint, args);
            if (shouldCache) {
              cache.set(value, doc3);
            }
            return doc3;
          }
        }
        function printPrettierIgnoredNode(node, options) {
          const {
            originalText,
            [Symbol.for("comments")]: comments,
            locStart,
            locEnd
          } = options;
          const start = locStart(node);
          const end = locEnd(node);
          const printedComments = /* @__PURE__ */ new Set();
          for (const comment of comments) {
            if (locStart(comment) >= start && locEnd(comment) <= end) {
              comment.printed = true;
              printedComments.add(comment);
            }
          }
          return {
            doc: originalText.slice(start, end),
            printedComments
          };
        }
        function callPluginPrintFunction(path5, options, printPath, args) {
          const node = path5.getValue();
          const {
            printer
          } = options;
          let doc2;
          let printedComments;
          if (printer.hasPrettierIgnore && printer.hasPrettierIgnore(path5)) {
            ({
              doc: doc2,
              printedComments
            } = printPrettierIgnoredNode(node, options));
          } else {
            if (node) {
              try {
                doc2 = multiparser.printSubtree(path5, printPath, options, printAstToDoc);
              } catch (error) {
                if (process.env.PRETTIER_DEBUG) {
                  throw error;
                }
              }
            }
            if (!doc2) {
              doc2 = printer.print(path5, options, printPath, args);
            }
          }
          if (!printer.willPrintOwnComments || !printer.willPrintOwnComments(path5, options)) {
            doc2 = printComments(path5, doc2, options, printedComments);
          }
          return doc2;
        }
        module22.exports = printAstToDoc;
      }
    });
    var require_range_util = __commonJS22({
      "src/main/range-util.js"(exports22, module22) {
        "use strict";
        var assert = require("assert");
        var comments = require_comments();
        var isJsonParser = ({
          parser
        }) => parser === "json" || parser === "json5" || parser === "json-stringify";
        function findCommonAncestor(startNodeAndParents, endNodeAndParents) {
          const startNodeAndAncestors = [startNodeAndParents.node, ...startNodeAndParents.parentNodes];
          const endNodeAndAncestors = /* @__PURE__ */ new Set([endNodeAndParents.node, ...endNodeAndParents.parentNodes]);
          return startNodeAndAncestors.find((node) => jsonSourceElements.has(node.type) && endNodeAndAncestors.has(node));
        }
        function dropRootParents(parents) {
          let lastParentIndex = parents.length - 1;
          for (; ; ) {
            const parent = parents[lastParentIndex];
            if (parent && (parent.type === "Program" || parent.type === "File")) {
              lastParentIndex--;
            } else {
              break;
            }
          }
          return parents.slice(0, lastParentIndex + 1);
        }
        function findSiblingAncestors(startNodeAndParents, endNodeAndParents, {
          locStart,
          locEnd
        }) {
          let resultStartNode = startNodeAndParents.node;
          let resultEndNode = endNodeAndParents.node;
          if (resultStartNode === resultEndNode) {
            return {
              startNode: resultStartNode,
              endNode: resultEndNode
            };
          }
          const startNodeStart = locStart(startNodeAndParents.node);
          for (const endParent of dropRootParents(endNodeAndParents.parentNodes)) {
            if (locStart(endParent) >= startNodeStart) {
              resultEndNode = endParent;
            } else {
              break;
            }
          }
          const endNodeEnd = locEnd(endNodeAndParents.node);
          for (const startParent of dropRootParents(startNodeAndParents.parentNodes)) {
            if (locEnd(startParent) <= endNodeEnd) {
              resultStartNode = startParent;
            } else {
              break;
            }
          }
          return {
            startNode: resultStartNode,
            endNode: resultEndNode
          };
        }
        function findNodeAtOffset(node, offset, options, predicate, parentNodes = [], type2) {
          const {
            locStart,
            locEnd
          } = options;
          const start = locStart(node);
          const end = locEnd(node);
          if (offset > end || offset < start || type2 === "rangeEnd" && offset === start || type2 === "rangeStart" && offset === end) {
            return;
          }
          for (const childNode of comments.getSortedChildNodes(node, options)) {
            const childResult = findNodeAtOffset(childNode, offset, options, predicate, [node, ...parentNodes], type2);
            if (childResult) {
              return childResult;
            }
          }
          if (!predicate || predicate(node, parentNodes[0])) {
            return {
              node,
              parentNodes
            };
          }
        }
        function isJsSourceElement(type2, parentType) {
          return parentType !== "DeclareExportDeclaration" && type2 !== "TypeParameterDeclaration" && (type2 === "Directive" || type2 === "TypeAlias" || type2 === "TSExportAssignment" || type2.startsWith("Declare") || type2.startsWith("TSDeclare") || type2.endsWith("Statement") || type2.endsWith("Declaration"));
        }
        var jsonSourceElements = /* @__PURE__ */ new Set(["ObjectExpression", "ArrayExpression", "StringLiteral", "NumericLiteral", "BooleanLiteral", "NullLiteral", "UnaryExpression", "TemplateLiteral"]);
        var graphqlSourceElements = /* @__PURE__ */ new Set(["OperationDefinition", "FragmentDefinition", "VariableDefinition", "TypeExtensionDefinition", "ObjectTypeDefinition", "FieldDefinition", "DirectiveDefinition", "EnumTypeDefinition", "EnumValueDefinition", "InputValueDefinition", "InputObjectTypeDefinition", "SchemaDefinition", "OperationTypeDefinition", "InterfaceTypeDefinition", "UnionTypeDefinition", "ScalarTypeDefinition"]);
        function isSourceElement(opts, node, parentNode) {
          if (!node) {
            return false;
          }
          switch (opts.parser) {
            case "flow":
            case "babel":
            case "babel-flow":
            case "babel-ts":
            case "typescript":
            case "acorn":
            case "espree":
            case "meriyah":
            case "__babel_estree":
              return isJsSourceElement(node.type, parentNode && parentNode.type);
            case "json":
            case "json5":
            case "json-stringify":
              return jsonSourceElements.has(node.type);
            case "graphql":
              return graphqlSourceElements.has(node.kind);
            case "vue":
              return node.tag !== "root";
          }
          return false;
        }
        function calculateRange(text, opts, ast) {
          let {
            rangeStart: start,
            rangeEnd: end,
            locStart,
            locEnd
          } = opts;
          assert.ok(end > start);
          const firstNonWhitespaceCharacterIndex = text.slice(start, end).search(/\S/);
          const isAllWhitespace = firstNonWhitespaceCharacterIndex === -1;
          if (!isAllWhitespace) {
            start += firstNonWhitespaceCharacterIndex;
            for (; end > start; --end) {
              if (/\S/.test(text[end - 1])) {
                break;
              }
            }
          }
          const startNodeAndParents = findNodeAtOffset(ast, start, opts, (node, parentNode) => isSourceElement(opts, node, parentNode), [], "rangeStart");
          const endNodeAndParents = isAllWhitespace ? startNodeAndParents : findNodeAtOffset(ast, end, opts, (node) => isSourceElement(opts, node), [], "rangeEnd");
          if (!startNodeAndParents || !endNodeAndParents) {
            return {
              rangeStart: 0,
              rangeEnd: 0
            };
          }
          let startNode;
          let endNode;
          if (isJsonParser(opts)) {
            const commonAncestor = findCommonAncestor(startNodeAndParents, endNodeAndParents);
            startNode = commonAncestor;
            endNode = commonAncestor;
          } else {
            ({
              startNode,
              endNode
            } = findSiblingAncestors(startNodeAndParents, endNodeAndParents, opts));
          }
          return {
            rangeStart: Math.min(locStart(startNode), locStart(endNode)),
            rangeEnd: Math.max(locEnd(startNode), locEnd(endNode))
          };
        }
        module22.exports = {
          calculateRange,
          findNodeAtOffset
        };
      }
    });
    var require_core6 = __commonJS22({
      "src/main/core.js"(exports22, module22) {
        "use strict";
        var {
          diffArrays
        } = require_array();
        var {
          printer: {
            printDocToString
          },
          debug: {
            printDocToDebug
          }
        } = require_doc();
        var {
          getAlignmentSize
        } = require_util2();
        var {
          guessEndOfLine,
          convertEndOfLineToChars,
          countEndOfLineChars,
          normalizeEndOfLine
        } = require_end_of_line();
        var normalizeOptions = require_options().normalize;
        var massageAST = require_massage_ast();
        var comments = require_comments();
        var parser = require_parser3();
        var printAstToDoc = require_ast_to_doc();
        var rangeUtil = require_range_util();
        var BOM = "\uFEFF";
        var CURSOR = Symbol("cursor");
        function attachComments(text, ast, opts) {
          const astComments = ast.comments;
          if (astComments) {
            delete ast.comments;
            comments.attach(astComments, ast, text, opts);
          }
          opts[Symbol.for("comments")] = astComments || [];
          opts[Symbol.for("tokens")] = ast.tokens || [];
          opts.originalText = text;
          return astComments;
        }
        function coreFormat(originalText, opts, addAlignmentSize = 0) {
          if (!originalText || originalText.trim().length === 0) {
            return {
              formatted: "",
              cursorOffset: -1,
              comments: []
            };
          }
          const {
            ast,
            text
          } = parser.parse(originalText, opts);
          if (opts.cursorOffset >= 0) {
            const nodeResult = rangeUtil.findNodeAtOffset(ast, opts.cursorOffset, opts);
            if (nodeResult && nodeResult.node) {
              opts.cursorNode = nodeResult.node;
            }
          }
          const astComments = attachComments(text, ast, opts);
          const doc2 = printAstToDoc(ast, opts, addAlignmentSize);
          const result = printDocToString(doc2, opts);
          comments.ensureAllCommentsPrinted(astComments);
          if (addAlignmentSize > 0) {
            const trimmed = result.formatted.trim();
            if (result.cursorNodeStart !== void 0) {
              result.cursorNodeStart -= result.formatted.indexOf(trimmed);
            }
            result.formatted = trimmed + convertEndOfLineToChars(opts.endOfLine);
          }
          if (opts.cursorOffset >= 0) {
            let oldCursorNodeStart;
            let oldCursorNodeText;
            let cursorOffsetRelativeToOldCursorNode;
            let newCursorNodeStart;
            let newCursorNodeText;
            if (opts.cursorNode && result.cursorNodeText) {
              oldCursorNodeStart = opts.locStart(opts.cursorNode);
              oldCursorNodeText = text.slice(oldCursorNodeStart, opts.locEnd(opts.cursorNode));
              cursorOffsetRelativeToOldCursorNode = opts.cursorOffset - oldCursorNodeStart;
              newCursorNodeStart = result.cursorNodeStart;
              newCursorNodeText = result.cursorNodeText;
            } else {
              oldCursorNodeStart = 0;
              oldCursorNodeText = text;
              cursorOffsetRelativeToOldCursorNode = opts.cursorOffset;
              newCursorNodeStart = 0;
              newCursorNodeText = result.formatted;
            }
            if (oldCursorNodeText === newCursorNodeText) {
              return {
                formatted: result.formatted,
                cursorOffset: newCursorNodeStart + cursorOffsetRelativeToOldCursorNode,
                comments: astComments
              };
            }
            const oldCursorNodeCharArray = [...oldCursorNodeText];
            oldCursorNodeCharArray.splice(cursorOffsetRelativeToOldCursorNode, 0, CURSOR);
            const newCursorNodeCharArray = [...newCursorNodeText];
            const cursorNodeDiff = diffArrays(oldCursorNodeCharArray, newCursorNodeCharArray);
            let cursorOffset = newCursorNodeStart;
            for (const entry of cursorNodeDiff) {
              if (entry.removed) {
                if (entry.value.includes(CURSOR)) {
                  break;
                }
              } else {
                cursorOffset += entry.count;
              }
            }
            return {
              formatted: result.formatted,
              cursorOffset,
              comments: astComments
            };
          }
          return {
            formatted: result.formatted,
            cursorOffset: -1,
            comments: astComments
          };
        }
        function formatRange(originalText, opts) {
          const {
            ast,
            text
          } = parser.parse(originalText, opts);
          const {
            rangeStart,
            rangeEnd
          } = rangeUtil.calculateRange(text, opts, ast);
          const rangeString = text.slice(rangeStart, rangeEnd);
          const rangeStart2 = Math.min(rangeStart, text.lastIndexOf("\n", rangeStart) + 1);
          const indentString2 = text.slice(rangeStart2, rangeStart).match(/^\s*/)[0];
          const alignmentSize = getAlignmentSize(indentString2, opts.tabWidth);
          const rangeResult = coreFormat(rangeString, Object.assign(Object.assign({}, opts), {}, {
            rangeStart: 0,
            rangeEnd: Number.POSITIVE_INFINITY,
            cursorOffset: opts.cursorOffset > rangeStart && opts.cursorOffset <= rangeEnd ? opts.cursorOffset - rangeStart : -1,
            endOfLine: "lf"
          }), alignmentSize);
          const rangeTrimmed = rangeResult.formatted.trimEnd();
          let {
            cursorOffset
          } = opts;
          if (cursorOffset > rangeEnd) {
            cursorOffset += rangeTrimmed.length - rangeString.length;
          } else if (rangeResult.cursorOffset >= 0) {
            cursorOffset = rangeResult.cursorOffset + rangeStart;
          }
          let formatted = text.slice(0, rangeStart) + rangeTrimmed + text.slice(rangeEnd);
          if (opts.endOfLine !== "lf") {
            const eol = convertEndOfLineToChars(opts.endOfLine);
            if (cursorOffset >= 0 && eol === "\r\n") {
              cursorOffset += countEndOfLineChars(formatted.slice(0, cursorOffset), "\n");
            }
            formatted = formatted.replace(/\n/g, eol);
          }
          return {
            formatted,
            cursorOffset,
            comments: rangeResult.comments
          };
        }
        function ensureIndexInText(text, index, defaultValue) {
          if (typeof index !== "number" || Number.isNaN(index) || index < 0 || index > text.length) {
            return defaultValue;
          }
          return index;
        }
        function normalizeIndexes(text, options) {
          let {
            cursorOffset,
            rangeStart,
            rangeEnd
          } = options;
          cursorOffset = ensureIndexInText(text, cursorOffset, -1);
          rangeStart = ensureIndexInText(text, rangeStart, 0);
          rangeEnd = ensureIndexInText(text, rangeEnd, text.length);
          return Object.assign(Object.assign({}, options), {}, {
            cursorOffset,
            rangeStart,
            rangeEnd
          });
        }
        function normalizeInputAndOptions(text, options) {
          let {
            cursorOffset,
            rangeStart,
            rangeEnd,
            endOfLine
          } = normalizeIndexes(text, options);
          const hasBOM = text.charAt(0) === BOM;
          if (hasBOM) {
            text = text.slice(1);
            cursorOffset--;
            rangeStart--;
            rangeEnd--;
          }
          if (endOfLine === "auto") {
            endOfLine = guessEndOfLine(text);
          }
          if (text.includes("\r")) {
            const countCrlfBefore = (index) => countEndOfLineChars(text.slice(0, Math.max(index, 0)), "\r\n");
            cursorOffset -= countCrlfBefore(cursorOffset);
            rangeStart -= countCrlfBefore(rangeStart);
            rangeEnd -= countCrlfBefore(rangeEnd);
            text = normalizeEndOfLine(text);
          }
          return {
            hasBOM,
            text,
            options: normalizeIndexes(text, Object.assign(Object.assign({}, options), {}, {
              cursorOffset,
              rangeStart,
              rangeEnd,
              endOfLine
            }))
          };
        }
        function hasPragma(text, options) {
          const selectedParser = parser.resolveParser(options);
          return !selectedParser.hasPragma || selectedParser.hasPragma(text);
        }
        function formatWithCursor2(originalText, originalOptions) {
          let {
            hasBOM,
            text,
            options
          } = normalizeInputAndOptions(originalText, normalizeOptions(originalOptions));
          if (options.rangeStart >= options.rangeEnd && text !== "" || options.requirePragma && !hasPragma(text, options)) {
            return {
              formatted: originalText,
              cursorOffset: originalOptions.cursorOffset,
              comments: []
            };
          }
          let result;
          if (options.rangeStart > 0 || options.rangeEnd < text.length) {
            result = formatRange(text, options);
          } else {
            if (!options.requirePragma && options.insertPragma && options.printer.insertPragma && !hasPragma(text, options)) {
              text = options.printer.insertPragma(text);
            }
            result = coreFormat(text, options);
          }
          if (hasBOM) {
            result.formatted = BOM + result.formatted;
            if (result.cursorOffset >= 0) {
              result.cursorOffset++;
            }
          }
          return result;
        }
        module22.exports = {
          formatWithCursor: formatWithCursor2,
          parse(originalText, originalOptions, massage) {
            const {
              text,
              options
            } = normalizeInputAndOptions(originalText, normalizeOptions(originalOptions));
            const parsed = parser.parse(text, options);
            if (massage) {
              parsed.ast = massageAST(parsed.ast, options);
            }
            return parsed;
          },
          formatAST(ast, options) {
            options = normalizeOptions(options);
            const doc2 = printAstToDoc(ast, options);
            return printDocToString(doc2, options);
          },
          formatDoc(doc2, options) {
            return formatWithCursor2(printDocToDebug(doc2), Object.assign(Object.assign({}, options), {}, {
              parser: "__js_expression"
            })).formatted;
          },
          printToDoc(originalText, options) {
            options = normalizeOptions(options);
            const {
              ast,
              text
            } = parser.parse(originalText, options);
            attachComments(text, ast, options);
            return printAstToDoc(ast, options);
          },
          printDocToString(doc2, options) {
            return printDocToString(doc2, normalizeOptions(options));
          }
        };
      }
    });
    var require_utils22 = __commonJS22({
      "node_modules/braces/lib/utils.js"(exports22) {
        "use strict";
        exports22.isInteger = (num) => {
          if (typeof num === "number") {
            return Number.isInteger(num);
          }
          if (typeof num === "string" && num.trim() !== "") {
            return Number.isInteger(Number(num));
          }
          return false;
        };
        exports22.find = (node, type2) => node.nodes.find((node2) => node2.type === type2);
        exports22.exceedsLimit = (min, max, step = 1, limit) => {
          if (limit === false)
            return false;
          if (!exports22.isInteger(min) || !exports22.isInteger(max))
            return false;
          return (Number(max) - Number(min)) / Number(step) >= limit;
        };
        exports22.escapeNode = (block, n = 0, type2) => {
          let node = block.nodes[n];
          if (!node)
            return;
          if (type2 && node.type === type2 || node.type === "open" || node.type === "close") {
            if (node.escaped !== true) {
              node.value = "\\" + node.value;
              node.escaped = true;
            }
          }
        };
        exports22.encloseBrace = (node) => {
          if (node.type !== "brace")
            return false;
          if (node.commas >> 0 + node.ranges >> 0 === 0) {
            node.invalid = true;
            return true;
          }
          return false;
        };
        exports22.isInvalidBrace = (block) => {
          if (block.type !== "brace")
            return false;
          if (block.invalid === true || block.dollar)
            return true;
          if (block.commas >> 0 + block.ranges >> 0 === 0) {
            block.invalid = true;
            return true;
          }
          if (block.open !== true || block.close !== true) {
            block.invalid = true;
            return true;
          }
          return false;
        };
        exports22.isOpenOrClose = (node) => {
          if (node.type === "open" || node.type === "close") {
            return true;
          }
          return node.open === true || node.close === true;
        };
        exports22.reduce = (nodes) => nodes.reduce((acc, node) => {
          if (node.type === "text")
            acc.push(node.value);
          if (node.type === "range")
            node.type = "text";
          return acc;
        }, []);
        exports22.flatten = (...args) => {
          const result = [];
          const flat = (arr) => {
            for (let i = 0; i < arr.length; i++) {
              let ele = arr[i];
              Array.isArray(ele) ? flat(ele, result) : ele !== void 0 && result.push(ele);
            }
            return result;
          };
          flat(args);
          return result;
        };
      }
    });
    var require_stringify2 = __commonJS22({
      "node_modules/braces/lib/stringify.js"(exports22, module22) {
        "use strict";
        var utils = require_utils22();
        module22.exports = (ast, options = {}) => {
          let stringify = (node, parent = {}) => {
            let invalidBlock = options.escapeInvalid && utils.isInvalidBrace(parent);
            let invalidNode = node.invalid === true && options.escapeInvalid === true;
            let output = "";
            if (node.value) {
              if ((invalidBlock || invalidNode) && utils.isOpenOrClose(node)) {
                return "\\" + node.value;
              }
              return node.value;
            }
            if (node.value) {
              return node.value;
            }
            if (node.nodes) {
              for (let child of node.nodes) {
                output += stringify(child);
              }
            }
            return output;
          };
          return stringify(ast);
        };
      }
    });
    var require_is_number = __commonJS22({
      "node_modules/is-number/index.js"(exports22, module22) {
        "use strict";
        module22.exports = function(num) {
          if (typeof num === "number") {
            return num - num === 0;
          }
          if (typeof num === "string" && num.trim() !== "") {
            return Number.isFinite ? Number.isFinite(+num) : isFinite(+num);
          }
          return false;
        };
      }
    });
    var require_to_regex_range = __commonJS22({
      "node_modules/to-regex-range/index.js"(exports22, module22) {
        "use strict";
        var isNumber = require_is_number();
        var toRegexRange = (min, max, options) => {
          if (isNumber(min) === false) {
            throw new TypeError("toRegexRange: expected the first argument to be a number");
          }
          if (max === void 0 || min === max) {
            return String(min);
          }
          if (isNumber(max) === false) {
            throw new TypeError("toRegexRange: expected the second argument to be a number.");
          }
          let opts = Object.assign({
            relaxZeros: true
          }, options);
          if (typeof opts.strictZeros === "boolean") {
            opts.relaxZeros = opts.strictZeros === false;
          }
          let relax = String(opts.relaxZeros);
          let shorthand = String(opts.shorthand);
          let capture = String(opts.capture);
          let wrap = String(opts.wrap);
          let cacheKey = min + ":" + max + "=" + relax + shorthand + capture + wrap;
          if (toRegexRange.cache.hasOwnProperty(cacheKey)) {
            return toRegexRange.cache[cacheKey].result;
          }
          let a = Math.min(min, max);
          let b = Math.max(min, max);
          if (Math.abs(a - b) === 1) {
            let result = min + "|" + max;
            if (opts.capture) {
              return `(${result})`;
            }
            if (opts.wrap === false) {
              return result;
            }
            return `(?:${result})`;
          }
          let isPadded = hasPadding(min) || hasPadding(max);
          let state = {
            min,
            max,
            a,
            b
          };
          let positives = [];
          let negatives = [];
          if (isPadded) {
            state.isPadded = isPadded;
            state.maxLen = String(state.max).length;
          }
          if (a < 0) {
            let newMin = b < 0 ? Math.abs(b) : 1;
            negatives = splitToPatterns(newMin, Math.abs(a), state, opts);
            a = state.a = 0;
          }
          if (b >= 0) {
            positives = splitToPatterns(a, b, state, opts);
          }
          state.negatives = negatives;
          state.positives = positives;
          state.result = collatePatterns(negatives, positives, opts);
          if (opts.capture === true) {
            state.result = `(${state.result})`;
          } else if (opts.wrap !== false && positives.length + negatives.length > 1) {
            state.result = `(?:${state.result})`;
          }
          toRegexRange.cache[cacheKey] = state;
          return state.result;
        };
        function collatePatterns(neg, pos, options) {
          let onlyNegative = filterPatterns(neg, pos, "-", false, options) || [];
          let onlyPositive = filterPatterns(pos, neg, "", false, options) || [];
          let intersected = filterPatterns(neg, pos, "-?", true, options) || [];
          let subpatterns = onlyNegative.concat(intersected).concat(onlyPositive);
          return subpatterns.join("|");
        }
        function splitToRanges(min, max) {
          let nines = 1;
          let zeros = 1;
          let stop = countNines(min, nines);
          let stops = /* @__PURE__ */ new Set([max]);
          while (min <= stop && stop <= max) {
            stops.add(stop);
            nines += 1;
            stop = countNines(min, nines);
          }
          stop = countZeros(max + 1, zeros) - 1;
          while (min < stop && stop <= max) {
            stops.add(stop);
            zeros += 1;
            stop = countZeros(max + 1, zeros) - 1;
          }
          stops = [...stops];
          stops.sort(compare);
          return stops;
        }
        function rangeToPattern(start, stop, options) {
          if (start === stop) {
            return {
              pattern: start,
              count: [],
              digits: 0
            };
          }
          let zipped = zip(start, stop);
          let digits = zipped.length;
          let pattern = "";
          let count = 0;
          for (let i = 0; i < digits; i++) {
            let [startDigit, stopDigit] = zipped[i];
            if (startDigit === stopDigit) {
              pattern += startDigit;
            } else if (startDigit !== "0" || stopDigit !== "9") {
              pattern += toCharacterClass(startDigit, stopDigit, options);
            } else {
              count++;
            }
          }
          if (count) {
            pattern += options.shorthand === true ? "\\d" : "[0-9]";
          }
          return {
            pattern,
            count: [count],
            digits
          };
        }
        function splitToPatterns(min, max, tok, options) {
          let ranges = splitToRanges(min, max);
          let tokens = [];
          let start = min;
          let prev;
          for (let i = 0; i < ranges.length; i++) {
            let max2 = ranges[i];
            let obj = rangeToPattern(String(start), String(max2), options);
            let zeros = "";
            if (!tok.isPadded && prev && prev.pattern === obj.pattern) {
              if (prev.count.length > 1) {
                prev.count.pop();
              }
              prev.count.push(obj.count[0]);
              prev.string = prev.pattern + toQuantifier(prev.count);
              start = max2 + 1;
              continue;
            }
            if (tok.isPadded) {
              zeros = padZeros(max2, tok, options);
            }
            obj.string = zeros + obj.pattern + toQuantifier(obj.count);
            tokens.push(obj);
            start = max2 + 1;
            prev = obj;
          }
          return tokens;
        }
        function filterPatterns(arr, comparison, prefix, intersection, options) {
          let result = [];
          for (let ele of arr) {
            let {
              string: string3
            } = ele;
            if (!intersection && !contains(comparison, "string", string3)) {
              result.push(prefix + string3);
            }
            if (intersection && contains(comparison, "string", string3)) {
              result.push(prefix + string3);
            }
          }
          return result;
        }
        function zip(a, b) {
          let arr = [];
          for (let i = 0; i < a.length; i++)
            arr.push([a[i], b[i]]);
          return arr;
        }
        function compare(a, b) {
          return a > b ? 1 : b > a ? -1 : 0;
        }
        function contains(arr, key, val) {
          return arr.some((ele) => ele[key] === val);
        }
        function countNines(min, len) {
          return Number(String(min).slice(0, -len) + "9".repeat(len));
        }
        function countZeros(integer, zeros) {
          return integer - integer % Math.pow(10, zeros);
        }
        function toQuantifier(digits) {
          let [start = 0, stop = ""] = digits;
          if (stop || start > 1) {
            return `{${start + (stop ? "," + stop : "")}}`;
          }
          return "";
        }
        function toCharacterClass(a, b, options) {
          return `[${a}${b - a === 1 ? "" : "-"}${b}]`;
        }
        function hasPadding(str2) {
          return /^-?(0+)\d/.test(str2);
        }
        function padZeros(value, tok, options) {
          if (!tok.isPadded) {
            return value;
          }
          let diff = Math.abs(tok.maxLen - String(value).length);
          let relax = options.relaxZeros !== false;
          switch (diff) {
            case 0:
              return "";
            case 1:
              return relax ? "0?" : "0";
            case 2:
              return relax ? "0{0,2}" : "00";
            default: {
              return relax ? `0{0,${diff}}` : `0{${diff}}`;
            }
          }
        }
        toRegexRange.cache = {};
        toRegexRange.clearCache = () => toRegexRange.cache = {};
        module22.exports = toRegexRange;
      }
    });
    var require_fill_range = __commonJS22({
      "node_modules/fill-range/index.js"(exports22, module22) {
        "use strict";
        var util2 = require("util");
        var toRegexRange = require_to_regex_range();
        var isObject3 = (val) => val !== null && typeof val === "object" && !Array.isArray(val);
        var transform3 = (toNumber) => {
          return (value) => toNumber === true ? Number(value) : String(value);
        };
        var isValidValue = (value) => {
          return typeof value === "number" || typeof value === "string" && value !== "";
        };
        var isNumber = (num) => Number.isInteger(+num);
        var zeros = (input) => {
          let value = `${input}`;
          let index = -1;
          if (value[0] === "-")
            value = value.slice(1);
          if (value === "0")
            return false;
          while (value[++index] === "0")
            ;
          return index > 0;
        };
        var stringify = (start, end, options) => {
          if (typeof start === "string" || typeof end === "string") {
            return true;
          }
          return options.stringify === true;
        };
        var pad = (input, maxLength, toNumber) => {
          if (maxLength > 0) {
            let dash = input[0] === "-" ? "-" : "";
            if (dash)
              input = input.slice(1);
            input = dash + input.padStart(dash ? maxLength - 1 : maxLength, "0");
          }
          if (toNumber === false) {
            return String(input);
          }
          return input;
        };
        var toMaxLen = (input, maxLength) => {
          let negative = input[0] === "-" ? "-" : "";
          if (negative) {
            input = input.slice(1);
            maxLength--;
          }
          while (input.length < maxLength)
            input = "0" + input;
          return negative ? "-" + input : input;
        };
        var toSequence = (parts, options) => {
          parts.negatives.sort((a, b) => a < b ? -1 : a > b ? 1 : 0);
          parts.positives.sort((a, b) => a < b ? -1 : a > b ? 1 : 0);
          let prefix = options.capture ? "" : "?:";
          let positives = "";
          let negatives = "";
          let result;
          if (parts.positives.length) {
            positives = parts.positives.join("|");
          }
          if (parts.negatives.length) {
            negatives = `-(${prefix}${parts.negatives.join("|")})`;
          }
          if (positives && negatives) {
            result = `${positives}|${negatives}`;
          } else {
            result = positives || negatives;
          }
          if (options.wrap) {
            return `(${prefix}${result})`;
          }
          return result;
        };
        var toRange = (a, b, isNumbers, options) => {
          if (isNumbers) {
            return toRegexRange(a, b, Object.assign({
              wrap: false
            }, options));
          }
          let start = String.fromCharCode(a);
          if (a === b)
            return start;
          let stop = String.fromCharCode(b);
          return `[${start}-${stop}]`;
        };
        var toRegex = (start, end, options) => {
          if (Array.isArray(start)) {
            let wrap = options.wrap === true;
            let prefix = options.capture ? "" : "?:";
            return wrap ? `(${prefix}${start.join("|")})` : start.join("|");
          }
          return toRegexRange(start, end, options);
        };
        var rangeError = (...args) => {
          return new RangeError("Invalid range arguments: " + util2.inspect(...args));
        };
        var invalidRange = (start, end, options) => {
          if (options.strictRanges === true)
            throw rangeError([start, end]);
          return [];
        };
        var invalidStep = (step, options) => {
          if (options.strictRanges === true) {
            throw new TypeError(`Expected step "${step}" to be a number`);
          }
          return [];
        };
        var fillNumbers = (start, end, step = 1, options = {}) => {
          let a = Number(start);
          let b = Number(end);
          if (!Number.isInteger(a) || !Number.isInteger(b)) {
            if (options.strictRanges === true)
              throw rangeError([start, end]);
            return [];
          }
          if (a === 0)
            a = 0;
          if (b === 0)
            b = 0;
          let descending = a > b;
          let startString = String(start);
          let endString = String(end);
          let stepString = String(step);
          step = Math.max(Math.abs(step), 1);
          let padded = zeros(startString) || zeros(endString) || zeros(stepString);
          let maxLen = padded ? Math.max(startString.length, endString.length, stepString.length) : 0;
          let toNumber = padded === false && stringify(start, end, options) === false;
          let format = options.transform || transform3(toNumber);
          if (options.toRegex && step === 1) {
            return toRange(toMaxLen(start, maxLen), toMaxLen(end, maxLen), true, options);
          }
          let parts = {
            negatives: [],
            positives: []
          };
          let push = (num) => parts[num < 0 ? "negatives" : "positives"].push(Math.abs(num));
          let range = [];
          let index = 0;
          while (descending ? a >= b : a <= b) {
            if (options.toRegex === true && step > 1) {
              push(a);
            } else {
              range.push(pad(format(a, index), maxLen, toNumber));
            }
            a = descending ? a - step : a + step;
            index++;
          }
          if (options.toRegex === true) {
            return step > 1 ? toSequence(parts, options) : toRegex(range, null, Object.assign({
              wrap: false
            }, options));
          }
          return range;
        };
        var fillLetters = (start, end, step = 1, options = {}) => {
          if (!isNumber(start) && start.length > 1 || !isNumber(end) && end.length > 1) {
            return invalidRange(start, end, options);
          }
          let format = options.transform || ((val) => String.fromCharCode(val));
          let a = `${start}`.charCodeAt(0);
          let b = `${end}`.charCodeAt(0);
          let descending = a > b;
          let min = Math.min(a, b);
          let max = Math.max(a, b);
          if (options.toRegex && step === 1) {
            return toRange(min, max, false, options);
          }
          let range = [];
          let index = 0;
          while (descending ? a >= b : a <= b) {
            range.push(format(a, index));
            a = descending ? a - step : a + step;
            index++;
          }
          if (options.toRegex === true) {
            return toRegex(range, null, {
              wrap: false,
              options
            });
          }
          return range;
        };
        var fill = (start, end, step, options = {}) => {
          if (end == null && isValidValue(start)) {
            return [start];
          }
          if (!isValidValue(start) || !isValidValue(end)) {
            return invalidRange(start, end, options);
          }
          if (typeof step === "function") {
            return fill(start, end, 1, {
              transform: step
            });
          }
          if (isObject3(step)) {
            return fill(start, end, 0, step);
          }
          let opts = Object.assign({}, options);
          if (opts.capture === true)
            opts.wrap = true;
          step = step || opts.step || 1;
          if (!isNumber(step)) {
            if (step != null && !isObject3(step))
              return invalidStep(step, opts);
            return fill(start, end, 1, step);
          }
          if (isNumber(start) && isNumber(end)) {
            return fillNumbers(start, end, step, opts);
          }
          return fillLetters(start, end, Math.max(Math.abs(step), 1), opts);
        };
        module22.exports = fill;
      }
    });
    var require_compile2 = __commonJS22({
      "node_modules/braces/lib/compile.js"(exports22, module22) {
        "use strict";
        var fill = require_fill_range();
        var utils = require_utils22();
        var compile = (ast, options = {}) => {
          let walk = (node, parent = {}) => {
            let invalidBlock = utils.isInvalidBrace(parent);
            let invalidNode = node.invalid === true && options.escapeInvalid === true;
            let invalid = invalidBlock === true || invalidNode === true;
            let prefix = options.escapeInvalid === true ? "\\" : "";
            let output = "";
            if (node.isOpen === true) {
              return prefix + node.value;
            }
            if (node.isClose === true) {
              return prefix + node.value;
            }
            if (node.type === "open") {
              return invalid ? prefix + node.value : "(";
            }
            if (node.type === "close") {
              return invalid ? prefix + node.value : ")";
            }
            if (node.type === "comma") {
              return node.prev.type === "comma" ? "" : invalid ? node.value : "|";
            }
            if (node.value) {
              return node.value;
            }
            if (node.nodes && node.ranges > 0) {
              let args = utils.reduce(node.nodes);
              let range = fill(...args, Object.assign(Object.assign({}, options), {}, {
                wrap: false,
                toRegex: true
              }));
              if (range.length !== 0) {
                return args.length > 1 && range.length > 1 ? `(${range})` : range;
              }
            }
            if (node.nodes) {
              for (let child of node.nodes) {
                output += walk(child, node);
              }
            }
            return output;
          };
          return walk(ast);
        };
        module22.exports = compile;
      }
    });
    var require_expand = __commonJS22({
      "node_modules/braces/lib/expand.js"(exports22, module22) {
        "use strict";
        var fill = require_fill_range();
        var stringify = require_stringify2();
        var utils = require_utils22();
        var append = (queue = "", stash = "", enclose = false) => {
          let result = [];
          queue = [].concat(queue);
          stash = [].concat(stash);
          if (!stash.length)
            return queue;
          if (!queue.length) {
            return enclose ? utils.flatten(stash).map((ele) => `{${ele}}`) : stash;
          }
          for (let item of queue) {
            if (Array.isArray(item)) {
              for (let value of item) {
                result.push(append(value, stash, enclose));
              }
            } else {
              for (let ele of stash) {
                if (enclose === true && typeof ele === "string")
                  ele = `{${ele}}`;
                result.push(Array.isArray(ele) ? append(item, ele, enclose) : item + ele);
              }
            }
          }
          return utils.flatten(result);
        };
        var expand = (ast, options = {}) => {
          let rangeLimit = options.rangeLimit === void 0 ? 1e3 : options.rangeLimit;
          let walk = (node, parent = {}) => {
            node.queue = [];
            let p = parent;
            let q = parent.queue;
            while (p.type !== "brace" && p.type !== "root" && p.parent) {
              p = p.parent;
              q = p.queue;
            }
            if (node.invalid || node.dollar) {
              q.push(append(q.pop(), stringify(node, options)));
              return;
            }
            if (node.type === "brace" && node.invalid !== true && node.nodes.length === 2) {
              q.push(append(q.pop(), ["{}"]));
              return;
            }
            if (node.nodes && node.ranges > 0) {
              let args = utils.reduce(node.nodes);
              if (utils.exceedsLimit(...args, options.step, rangeLimit)) {
                throw new RangeError("expanded array length exceeds range limit. Use options.rangeLimit to increase or disable the limit.");
              }
              let range = fill(...args, options);
              if (range.length === 0) {
                range = stringify(node, options);
              }
              q.push(append(q.pop(), range));
              node.nodes = [];
              return;
            }
            let enclose = utils.encloseBrace(node);
            let queue = node.queue;
            let block = node;
            while (block.type !== "brace" && block.type !== "root" && block.parent) {
              block = block.parent;
              queue = block.queue;
            }
            for (let i = 0; i < node.nodes.length; i++) {
              let child = node.nodes[i];
              if (child.type === "comma" && node.type === "brace") {
                if (i === 1)
                  queue.push("");
                queue.push("");
                continue;
              }
              if (child.type === "close") {
                q.push(append(q.pop(), queue, enclose));
                continue;
              }
              if (child.value && child.type !== "open") {
                queue.push(append(queue.pop(), child.value));
                continue;
              }
              if (child.nodes) {
                walk(child, node);
              }
            }
            return queue;
          };
          return utils.flatten(walk(ast));
        };
        module22.exports = expand;
      }
    });
    var require_constants2 = __commonJS22({
      "node_modules/braces/lib/constants.js"(exports22, module22) {
        "use strict";
        module22.exports = {
          MAX_LENGTH: 1024 * 64,
          CHAR_0: "0",
          CHAR_9: "9",
          CHAR_UPPERCASE_A: "A",
          CHAR_LOWERCASE_A: "a",
          CHAR_UPPERCASE_Z: "Z",
          CHAR_LOWERCASE_Z: "z",
          CHAR_LEFT_PARENTHESES: "(",
          CHAR_RIGHT_PARENTHESES: ")",
          CHAR_ASTERISK: "*",
          CHAR_AMPERSAND: "&",
          CHAR_AT: "@",
          CHAR_BACKSLASH: "\\",
          CHAR_BACKTICK: "`",
          CHAR_CARRIAGE_RETURN: "\r",
          CHAR_CIRCUMFLEX_ACCENT: "^",
          CHAR_COLON: ":",
          CHAR_COMMA: ",",
          CHAR_DOLLAR: "$",
          CHAR_DOT: ".",
          CHAR_DOUBLE_QUOTE: '"',
          CHAR_EQUAL: "=",
          CHAR_EXCLAMATION_MARK: "!",
          CHAR_FORM_FEED: "\f",
          CHAR_FORWARD_SLASH: "/",
          CHAR_HASH: "#",
          CHAR_HYPHEN_MINUS: "-",
          CHAR_LEFT_ANGLE_BRACKET: "<",
          CHAR_LEFT_CURLY_BRACE: "{",
          CHAR_LEFT_SQUARE_BRACKET: "[",
          CHAR_LINE_FEED: "\n",
          CHAR_NO_BREAK_SPACE: "\xA0",
          CHAR_PERCENT: "%",
          CHAR_PLUS: "+",
          CHAR_QUESTION_MARK: "?",
          CHAR_RIGHT_ANGLE_BRACKET: ">",
          CHAR_RIGHT_CURLY_BRACE: "}",
          CHAR_RIGHT_SQUARE_BRACKET: "]",
          CHAR_SEMICOLON: ";",
          CHAR_SINGLE_QUOTE: "'",
          CHAR_SPACE: " ",
          CHAR_TAB: "	",
          CHAR_UNDERSCORE: "_",
          CHAR_VERTICAL_LINE: "|",
          CHAR_ZERO_WIDTH_NOBREAK_SPACE: "\uFEFF"
        };
      }
    });
    var require_parse = __commonJS22({
      "node_modules/braces/lib/parse.js"(exports22, module22) {
        "use strict";
        var stringify = require_stringify2();
        var {
          MAX_LENGTH,
          CHAR_BACKSLASH,
          CHAR_BACKTICK,
          CHAR_COMMA: CHAR_COMMA2,
          CHAR_DOT,
          CHAR_LEFT_PARENTHESES,
          CHAR_RIGHT_PARENTHESES,
          CHAR_LEFT_CURLY_BRACE,
          CHAR_RIGHT_CURLY_BRACE,
          CHAR_LEFT_SQUARE_BRACKET: CHAR_LEFT_SQUARE_BRACKET2,
          CHAR_RIGHT_SQUARE_BRACKET: CHAR_RIGHT_SQUARE_BRACKET2,
          CHAR_DOUBLE_QUOTE: CHAR_DOUBLE_QUOTE2,
          CHAR_SINGLE_QUOTE: CHAR_SINGLE_QUOTE2,
          CHAR_NO_BREAK_SPACE,
          CHAR_ZERO_WIDTH_NOBREAK_SPACE
        } = require_constants2();
        var parse2 = (input, options = {}) => {
          if (typeof input !== "string") {
            throw new TypeError("Expected a string");
          }
          let opts = options || {};
          let max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
          if (input.length > max) {
            throw new SyntaxError(`Input length (${input.length}), exceeds max characters (${max})`);
          }
          let ast = {
            type: "root",
            input,
            nodes: []
          };
          let stack = [ast];
          let block = ast;
          let prev = ast;
          let brackets = 0;
          let length = input.length;
          let index = 0;
          let depth = 0;
          let value;
          let memo = {};
          const advance = () => input[index++];
          const push = (node) => {
            if (node.type === "text" && prev.type === "dot") {
              prev.type = "text";
            }
            if (prev && prev.type === "text" && node.type === "text") {
              prev.value += node.value;
              return;
            }
            block.nodes.push(node);
            node.parent = block;
            node.prev = prev;
            prev = node;
            return node;
          };
          push({
            type: "bos"
          });
          while (index < length) {
            block = stack[stack.length - 1];
            value = advance();
            if (value === CHAR_ZERO_WIDTH_NOBREAK_SPACE || value === CHAR_NO_BREAK_SPACE) {
              continue;
            }
            if (value === CHAR_BACKSLASH) {
              push({
                type: "text",
                value: (options.keepEscaping ? value : "") + advance()
              });
              continue;
            }
            if (value === CHAR_RIGHT_SQUARE_BRACKET2) {
              push({
                type: "text",
                value: "\\" + value
              });
              continue;
            }
            if (value === CHAR_LEFT_SQUARE_BRACKET2) {
              brackets++;
              let closed = true;
              let next;
              while (index < length && (next = advance())) {
                value += next;
                if (next === CHAR_LEFT_SQUARE_BRACKET2) {
                  brackets++;
                  continue;
                }
                if (next === CHAR_BACKSLASH) {
                  value += advance();
                  continue;
                }
                if (next === CHAR_RIGHT_SQUARE_BRACKET2) {
                  brackets--;
                  if (brackets === 0) {
                    break;
                  }
                }
              }
              push({
                type: "text",
                value
              });
              continue;
            }
            if (value === CHAR_LEFT_PARENTHESES) {
              block = push({
                type: "paren",
                nodes: []
              });
              stack.push(block);
              push({
                type: "text",
                value
              });
              continue;
            }
            if (value === CHAR_RIGHT_PARENTHESES) {
              if (block.type !== "paren") {
                push({
                  type: "text",
                  value
                });
                continue;
              }
              block = stack.pop();
              push({
                type: "text",
                value
              });
              block = stack[stack.length - 1];
              continue;
            }
            if (value === CHAR_DOUBLE_QUOTE2 || value === CHAR_SINGLE_QUOTE2 || value === CHAR_BACKTICK) {
              let open = value;
              let next;
              if (options.keepQuotes !== true) {
                value = "";
              }
              while (index < length && (next = advance())) {
                if (next === CHAR_BACKSLASH) {
                  value += next + advance();
                  continue;
                }
                if (next === open) {
                  if (options.keepQuotes === true)
                    value += next;
                  break;
                }
                value += next;
              }
              push({
                type: "text",
                value
              });
              continue;
            }
            if (value === CHAR_LEFT_CURLY_BRACE) {
              depth++;
              let dollar = prev.value && prev.value.slice(-1) === "$" || block.dollar === true;
              let brace = {
                type: "brace",
                open: true,
                close: false,
                dollar,
                depth,
                commas: 0,
                ranges: 0,
                nodes: []
              };
              block = push(brace);
              stack.push(block);
              push({
                type: "open",
                value
              });
              continue;
            }
            if (value === CHAR_RIGHT_CURLY_BRACE) {
              if (block.type !== "brace") {
                push({
                  type: "text",
                  value
                });
                continue;
              }
              let type2 = "close";
              block = stack.pop();
              block.close = true;
              push({
                type: type2,
                value
              });
              depth--;
              block = stack[stack.length - 1];
              continue;
            }
            if (value === CHAR_COMMA2 && depth > 0) {
              if (block.ranges > 0) {
                block.ranges = 0;
                let open = block.nodes.shift();
                block.nodes = [open, {
                  type: "text",
                  value: stringify(block)
                }];
              }
              push({
                type: "comma",
                value
              });
              block.commas++;
              continue;
            }
            if (value === CHAR_DOT && depth > 0 && block.commas === 0) {
              let siblings = block.nodes;
              if (depth === 0 || siblings.length === 0) {
                push({
                  type: "text",
                  value
                });
                continue;
              }
              if (prev.type === "dot") {
                block.range = [];
                prev.value += value;
                prev.type = "range";
                if (block.nodes.length !== 3 && block.nodes.length !== 5) {
                  block.invalid = true;
                  block.ranges = 0;
                  prev.type = "text";
                  continue;
                }
                block.ranges++;
                block.args = [];
                continue;
              }
              if (prev.type === "range") {
                siblings.pop();
                let before = siblings[siblings.length - 1];
                before.value += prev.value + value;
                prev = before;
                block.ranges--;
                continue;
              }
              push({
                type: "dot",
                value
              });
              continue;
            }
            push({
              type: "text",
              value
            });
          }
          do {
            block = stack.pop();
            if (block.type !== "root") {
              block.nodes.forEach((node) => {
                if (!node.nodes) {
                  if (node.type === "open")
                    node.isOpen = true;
                  if (node.type === "close")
                    node.isClose = true;
                  if (!node.nodes)
                    node.type = "text";
                  node.invalid = true;
                }
              });
              let parent = stack[stack.length - 1];
              let index2 = parent.nodes.indexOf(block);
              parent.nodes.splice(index2, 1, ...block.nodes);
            }
          } while (stack.length > 0);
          push({
            type: "eos"
          });
          return ast;
        };
        module22.exports = parse2;
      }
    });
    var require_braces = __commonJS22({
      "node_modules/braces/index.js"(exports22, module22) {
        "use strict";
        var stringify = require_stringify2();
        var compile = require_compile2();
        var expand = require_expand();
        var parse2 = require_parse();
        var braces = (input, options = {}) => {
          let output = [];
          if (Array.isArray(input)) {
            for (let pattern of input) {
              let result = braces.create(pattern, options);
              if (Array.isArray(result)) {
                output.push(...result);
              } else {
                output.push(result);
              }
            }
          } else {
            output = [].concat(braces.create(input, options));
          }
          if (options && options.expand === true && options.nodupes === true) {
            output = [...new Set(output)];
          }
          return output;
        };
        braces.parse = (input, options = {}) => parse2(input, options);
        braces.stringify = (input, options = {}) => {
          if (typeof input === "string") {
            return stringify(braces.parse(input, options), options);
          }
          return stringify(input, options);
        };
        braces.compile = (input, options = {}) => {
          if (typeof input === "string") {
            input = braces.parse(input, options);
          }
          return compile(input, options);
        };
        braces.expand = (input, options = {}) => {
          if (typeof input === "string") {
            input = braces.parse(input, options);
          }
          let result = expand(input, options);
          if (options.noempty === true) {
            result = result.filter(Boolean);
          }
          if (options.nodupes === true) {
            result = [...new Set(result)];
          }
          return result;
        };
        braces.create = (input, options = {}) => {
          if (input === "" || input.length < 3) {
            return [input];
          }
          return options.expand !== true ? braces.compile(input, options) : braces.expand(input, options);
        };
        module22.exports = braces;
      }
    });
    var require_constants3 = __commonJS22({
      "node_modules/picomatch/lib/constants.js"(exports22, module22) {
        "use strict";
        var path5 = require("path");
        var WIN_SLASH = "\\\\/";
        var WIN_NO_SLASH = `[^${WIN_SLASH}]`;
        var DOT_LITERAL = "\\.";
        var PLUS_LITERAL = "\\+";
        var QMARK_LITERAL = "\\?";
        var SLASH_LITERAL = "\\/";
        var ONE_CHAR = "(?=.)";
        var QMARK = "[^/]";
        var END_ANCHOR = `(?:${SLASH_LITERAL}|$)`;
        var START_ANCHOR = `(?:^|${SLASH_LITERAL})`;
        var DOTS_SLASH = `${DOT_LITERAL}{1,2}${END_ANCHOR}`;
        var NO_DOT = `(?!${DOT_LITERAL})`;
        var NO_DOTS = `(?!${START_ANCHOR}${DOTS_SLASH})`;
        var NO_DOT_SLASH = `(?!${DOT_LITERAL}{0,1}${END_ANCHOR})`;
        var NO_DOTS_SLASH = `(?!${DOTS_SLASH})`;
        var QMARK_NO_DOT = `[^.${SLASH_LITERAL}]`;
        var STAR = `${QMARK}*?`;
        var POSIX_CHARS = {
          DOT_LITERAL,
          PLUS_LITERAL,
          QMARK_LITERAL,
          SLASH_LITERAL,
          ONE_CHAR,
          QMARK,
          END_ANCHOR,
          DOTS_SLASH,
          NO_DOT,
          NO_DOTS,
          NO_DOT_SLASH,
          NO_DOTS_SLASH,
          QMARK_NO_DOT,
          STAR,
          START_ANCHOR
        };
        var WINDOWS_CHARS = Object.assign(Object.assign({}, POSIX_CHARS), {}, {
          SLASH_LITERAL: `[${WIN_SLASH}]`,
          QMARK: WIN_NO_SLASH,
          STAR: `${WIN_NO_SLASH}*?`,
          DOTS_SLASH: `${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$)`,
          NO_DOT: `(?!${DOT_LITERAL})`,
          NO_DOTS: `(?!(?:^|[${WIN_SLASH}])${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$))`,
          NO_DOT_SLASH: `(?!${DOT_LITERAL}{0,1}(?:[${WIN_SLASH}]|$))`,
          NO_DOTS_SLASH: `(?!${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$))`,
          QMARK_NO_DOT: `[^.${WIN_SLASH}]`,
          START_ANCHOR: `(?:^|[${WIN_SLASH}])`,
          END_ANCHOR: `(?:[${WIN_SLASH}]|$)`
        });
        var POSIX_REGEX_SOURCE = {
          alnum: "a-zA-Z0-9",
          alpha: "a-zA-Z",
          ascii: "\\x00-\\x7F",
          blank: " \\t",
          cntrl: "\\x00-\\x1F\\x7F",
          digit: "0-9",
          graph: "\\x21-\\x7E",
          lower: "a-z",
          print: "\\x20-\\x7E ",
          punct: "\\-!\"#$%&'()\\*+,./:;<=>?@[\\]^_`{|}~",
          space: " \\t\\r\\n\\v\\f",
          upper: "A-Z",
          word: "A-Za-z0-9_",
          xdigit: "A-Fa-f0-9"
        };
        module22.exports = {
          MAX_LENGTH: 1024 * 64,
          POSIX_REGEX_SOURCE,
          REGEX_BACKSLASH: /\\(?![*+?^${}(|)[\]])/g,
          REGEX_NON_SPECIAL_CHARS: /^[^@![\].,$*+?^{}()|\\/]+/,
          REGEX_SPECIAL_CHARS: /[-*+?.^${}(|)[\]]/,
          REGEX_SPECIAL_CHARS_BACKREF: /(\\?)((\W)(\3*))/g,
          REGEX_SPECIAL_CHARS_GLOBAL: /([-*+?.^${}(|)[\]])/g,
          REGEX_REMOVE_BACKSLASH: /(?:\[.*?[^\\]\]|\\(?=.))/g,
          REPLACEMENTS: {
            "***": "*",
            "**/**": "**",
            "**/**/**": "**"
          },
          CHAR_0: 48,
          CHAR_9: 57,
          CHAR_UPPERCASE_A: 65,
          CHAR_LOWERCASE_A: 97,
          CHAR_UPPERCASE_Z: 90,
          CHAR_LOWERCASE_Z: 122,
          CHAR_LEFT_PARENTHESES: 40,
          CHAR_RIGHT_PARENTHESES: 41,
          CHAR_ASTERISK: 42,
          CHAR_AMPERSAND: 38,
          CHAR_AT: 64,
          CHAR_BACKWARD_SLASH: 92,
          CHAR_CARRIAGE_RETURN: 13,
          CHAR_CIRCUMFLEX_ACCENT: 94,
          CHAR_COLON: 58,
          CHAR_COMMA: 44,
          CHAR_DOT: 46,
          CHAR_DOUBLE_QUOTE: 34,
          CHAR_EQUAL: 61,
          CHAR_EXCLAMATION_MARK: 33,
          CHAR_FORM_FEED: 12,
          CHAR_FORWARD_SLASH: 47,
          CHAR_GRAVE_ACCENT: 96,
          CHAR_HASH: 35,
          CHAR_HYPHEN_MINUS: 45,
          CHAR_LEFT_ANGLE_BRACKET: 60,
          CHAR_LEFT_CURLY_BRACE: 123,
          CHAR_LEFT_SQUARE_BRACKET: 91,
          CHAR_LINE_FEED: 10,
          CHAR_NO_BREAK_SPACE: 160,
          CHAR_PERCENT: 37,
          CHAR_PLUS: 43,
          CHAR_QUESTION_MARK: 63,
          CHAR_RIGHT_ANGLE_BRACKET: 62,
          CHAR_RIGHT_CURLY_BRACE: 125,
          CHAR_RIGHT_SQUARE_BRACKET: 93,
          CHAR_SEMICOLON: 59,
          CHAR_SINGLE_QUOTE: 39,
          CHAR_SPACE: 32,
          CHAR_TAB: 9,
          CHAR_UNDERSCORE: 95,
          CHAR_VERTICAL_LINE: 124,
          CHAR_ZERO_WIDTH_NOBREAK_SPACE: 65279,
          SEP: path5.sep,
          extglobChars(chars) {
            return {
              "!": {
                type: "negate",
                open: "(?:(?!(?:",
                close: `))${chars.STAR})`
              },
              "?": {
                type: "qmark",
                open: "(?:",
                close: ")?"
              },
              "+": {
                type: "plus",
                open: "(?:",
                close: ")+"
              },
              "*": {
                type: "star",
                open: "(?:",
                close: ")*"
              },
              "@": {
                type: "at",
                open: "(?:",
                close: ")"
              }
            };
          },
          globChars(win32) {
            return win32 === true ? WINDOWS_CHARS : POSIX_CHARS;
          }
        };
      }
    });
    var require_utils32 = __commonJS22({
      "node_modules/picomatch/lib/utils.js"(exports22) {
        "use strict";
        var path5 = require("path");
        var win32 = process.platform === "win32";
        var {
          REGEX_BACKSLASH,
          REGEX_REMOVE_BACKSLASH,
          REGEX_SPECIAL_CHARS,
          REGEX_SPECIAL_CHARS_GLOBAL
        } = require_constants3();
        exports22.isObject = (val) => val !== null && typeof val === "object" && !Array.isArray(val);
        exports22.hasRegexChars = (str2) => REGEX_SPECIAL_CHARS.test(str2);
        exports22.isRegexChar = (str2) => str2.length === 1 && exports22.hasRegexChars(str2);
        exports22.escapeRegex = (str2) => str2.replace(REGEX_SPECIAL_CHARS_GLOBAL, "\\$1");
        exports22.toPosixSlashes = (str2) => str2.replace(REGEX_BACKSLASH, "/");
        exports22.removeBackslashes = (str2) => {
          return str2.replace(REGEX_REMOVE_BACKSLASH, (match) => {
            return match === "\\" ? "" : match;
          });
        };
        exports22.supportsLookbehinds = () => {
          const segs = process.version.slice(1).split(".").map(Number);
          if (segs.length === 3 && segs[0] >= 9 || segs[0] === 8 && segs[1] >= 10) {
            return true;
          }
          return false;
        };
        exports22.isWindows = (options) => {
          if (options && typeof options.windows === "boolean") {
            return options.windows;
          }
          return win32 === true || path5.sep === "\\";
        };
        exports22.escapeLast = (input, char, lastIdx) => {
          const idx = input.lastIndexOf(char, lastIdx);
          if (idx === -1)
            return input;
          if (input[idx - 1] === "\\")
            return exports22.escapeLast(input, char, idx - 1);
          return `${input.slice(0, idx)}\\${input.slice(idx)}`;
        };
        exports22.removePrefix = (input, state = {}) => {
          let output = input;
          if (output.startsWith("./")) {
            output = output.slice(2);
            state.prefix = "./";
          }
          return output;
        };
        exports22.wrapOutput = (input, state = {}, options = {}) => {
          const prepend = options.contains ? "" : "^";
          const append = options.contains ? "" : "$";
          let output = `${prepend}(?:${input})${append}`;
          if (state.negated === true) {
            output = `(?:^(?!${output}).*$)`;
          }
          return output;
        };
      }
    });
    var require_scan = __commonJS22({
      "node_modules/picomatch/lib/scan.js"(exports22, module22) {
        "use strict";
        var utils = require_utils32();
        var {
          CHAR_ASTERISK: CHAR_ASTERISK2,
          CHAR_AT,
          CHAR_BACKWARD_SLASH,
          CHAR_COMMA: CHAR_COMMA2,
          CHAR_DOT,
          CHAR_EXCLAMATION_MARK,
          CHAR_FORWARD_SLASH,
          CHAR_LEFT_CURLY_BRACE,
          CHAR_LEFT_PARENTHESES,
          CHAR_LEFT_SQUARE_BRACKET: CHAR_LEFT_SQUARE_BRACKET2,
          CHAR_PLUS,
          CHAR_QUESTION_MARK,
          CHAR_RIGHT_CURLY_BRACE,
          CHAR_RIGHT_PARENTHESES,
          CHAR_RIGHT_SQUARE_BRACKET: CHAR_RIGHT_SQUARE_BRACKET2
        } = require_constants3();
        var isPathSeparator = (code) => {
          return code === CHAR_FORWARD_SLASH || code === CHAR_BACKWARD_SLASH;
        };
        var depth = (token) => {
          if (token.isPrefix !== true) {
            token.depth = token.isGlobstar ? Infinity : 1;
          }
        };
        var scan = (input, options) => {
          const opts = options || {};
          const length = input.length - 1;
          const scanToEnd = opts.parts === true || opts.scanToEnd === true;
          const slashes = [];
          const tokens = [];
          const parts = [];
          let str2 = input;
          let index = -1;
          let start = 0;
          let lastIndex = 0;
          let isBrace = false;
          let isBracket = false;
          let isGlob = false;
          let isExtglob = false;
          let isGlobstar = false;
          let braceEscaped = false;
          let backslashes = false;
          let negated = false;
          let negatedExtglob = false;
          let finished = false;
          let braces = 0;
          let prev;
          let code;
          let token = {
            value: "",
            depth: 0,
            isGlob: false
          };
          const eos = () => index >= length;
          const peek = () => str2.charCodeAt(index + 1);
          const advance = () => {
            prev = code;
            return str2.charCodeAt(++index);
          };
          while (index < length) {
            code = advance();
            let next;
            if (code === CHAR_BACKWARD_SLASH) {
              backslashes = token.backslashes = true;
              code = advance();
              if (code === CHAR_LEFT_CURLY_BRACE) {
                braceEscaped = true;
              }
              continue;
            }
            if (braceEscaped === true || code === CHAR_LEFT_CURLY_BRACE) {
              braces++;
              while (eos() !== true && (code = advance())) {
                if (code === CHAR_BACKWARD_SLASH) {
                  backslashes = token.backslashes = true;
                  advance();
                  continue;
                }
                if (code === CHAR_LEFT_CURLY_BRACE) {
                  braces++;
                  continue;
                }
                if (braceEscaped !== true && code === CHAR_DOT && (code = advance()) === CHAR_DOT) {
                  isBrace = token.isBrace = true;
                  isGlob = token.isGlob = true;
                  finished = true;
                  if (scanToEnd === true) {
                    continue;
                  }
                  break;
                }
                if (braceEscaped !== true && code === CHAR_COMMA2) {
                  isBrace = token.isBrace = true;
                  isGlob = token.isGlob = true;
                  finished = true;
                  if (scanToEnd === true) {
                    continue;
                  }
                  break;
                }
                if (code === CHAR_RIGHT_CURLY_BRACE) {
                  braces--;
                  if (braces === 0) {
                    braceEscaped = false;
                    isBrace = token.isBrace = true;
                    finished = true;
                    break;
                  }
                }
              }
              if (scanToEnd === true) {
                continue;
              }
              break;
            }
            if (code === CHAR_FORWARD_SLASH) {
              slashes.push(index);
              tokens.push(token);
              token = {
                value: "",
                depth: 0,
                isGlob: false
              };
              if (finished === true)
                continue;
              if (prev === CHAR_DOT && index === start + 1) {
                start += 2;
                continue;
              }
              lastIndex = index + 1;
              continue;
            }
            if (opts.noext !== true) {
              const isExtglobChar = code === CHAR_PLUS || code === CHAR_AT || code === CHAR_ASTERISK2 || code === CHAR_QUESTION_MARK || code === CHAR_EXCLAMATION_MARK;
              if (isExtglobChar === true && peek() === CHAR_LEFT_PARENTHESES) {
                isGlob = token.isGlob = true;
                isExtglob = token.isExtglob = true;
                finished = true;
                if (code === CHAR_EXCLAMATION_MARK && index === start) {
                  negatedExtglob = true;
                }
                if (scanToEnd === true) {
                  while (eos() !== true && (code = advance())) {
                    if (code === CHAR_BACKWARD_SLASH) {
                      backslashes = token.backslashes = true;
                      code = advance();
                      continue;
                    }
                    if (code === CHAR_RIGHT_PARENTHESES) {
                      isGlob = token.isGlob = true;
                      finished = true;
                      break;
                    }
                  }
                  continue;
                }
                break;
              }
            }
            if (code === CHAR_ASTERISK2) {
              if (prev === CHAR_ASTERISK2)
                isGlobstar = token.isGlobstar = true;
              isGlob = token.isGlob = true;
              finished = true;
              if (scanToEnd === true) {
                continue;
              }
              break;
            }
            if (code === CHAR_QUESTION_MARK) {
              isGlob = token.isGlob = true;
              finished = true;
              if (scanToEnd === true) {
                continue;
              }
              break;
            }
            if (code === CHAR_LEFT_SQUARE_BRACKET2) {
              while (eos() !== true && (next = advance())) {
                if (next === CHAR_BACKWARD_SLASH) {
                  backslashes = token.backslashes = true;
                  advance();
                  continue;
                }
                if (next === CHAR_RIGHT_SQUARE_BRACKET2) {
                  isBracket = token.isBracket = true;
                  isGlob = token.isGlob = true;
                  finished = true;
                  break;
                }
              }
              if (scanToEnd === true) {
                continue;
              }
              break;
            }
            if (opts.nonegate !== true && code === CHAR_EXCLAMATION_MARK && index === start) {
              negated = token.negated = true;
              start++;
              continue;
            }
            if (opts.noparen !== true && code === CHAR_LEFT_PARENTHESES) {
              isGlob = token.isGlob = true;
              if (scanToEnd === true) {
                while (eos() !== true && (code = advance())) {
                  if (code === CHAR_LEFT_PARENTHESES) {
                    backslashes = token.backslashes = true;
                    code = advance();
                    continue;
                  }
                  if (code === CHAR_RIGHT_PARENTHESES) {
                    finished = true;
                    break;
                  }
                }
                continue;
              }
              break;
            }
            if (isGlob === true) {
              finished = true;
              if (scanToEnd === true) {
                continue;
              }
              break;
            }
          }
          if (opts.noext === true) {
            isExtglob = false;
            isGlob = false;
          }
          let base = str2;
          let prefix = "";
          let glob = "";
          if (start > 0) {
            prefix = str2.slice(0, start);
            str2 = str2.slice(start);
            lastIndex -= start;
          }
          if (base && isGlob === true && lastIndex > 0) {
            base = str2.slice(0, lastIndex);
            glob = str2.slice(lastIndex);
          } else if (isGlob === true) {
            base = "";
            glob = str2;
          } else {
            base = str2;
          }
          if (base && base !== "" && base !== "/" && base !== str2) {
            if (isPathSeparator(base.charCodeAt(base.length - 1))) {
              base = base.slice(0, -1);
            }
          }
          if (opts.unescape === true) {
            if (glob)
              glob = utils.removeBackslashes(glob);
            if (base && backslashes === true) {
              base = utils.removeBackslashes(base);
            }
          }
          const state = {
            prefix,
            input,
            start,
            base,
            glob,
            isBrace,
            isBracket,
            isGlob,
            isExtglob,
            isGlobstar,
            negated,
            negatedExtglob
          };
          if (opts.tokens === true) {
            state.maxDepth = 0;
            if (!isPathSeparator(code)) {
              tokens.push(token);
            }
            state.tokens = tokens;
          }
          if (opts.parts === true || opts.tokens === true) {
            let prevIndex;
            for (let idx = 0; idx < slashes.length; idx++) {
              const n = prevIndex ? prevIndex + 1 : start;
              const i = slashes[idx];
              const value = input.slice(n, i);
              if (opts.tokens) {
                if (idx === 0 && start !== 0) {
                  tokens[idx].isPrefix = true;
                  tokens[idx].value = prefix;
                } else {
                  tokens[idx].value = value;
                }
                depth(tokens[idx]);
                state.maxDepth += tokens[idx].depth;
              }
              if (idx !== 0 || value !== "") {
                parts.push(value);
              }
              prevIndex = i;
            }
            if (prevIndex && prevIndex + 1 < input.length) {
              const value = input.slice(prevIndex + 1);
              parts.push(value);
              if (opts.tokens) {
                tokens[tokens.length - 1].value = value;
                depth(tokens[tokens.length - 1]);
                state.maxDepth += tokens[tokens.length - 1].depth;
              }
            }
            state.slashes = slashes;
            state.parts = parts;
          }
          return state;
        };
        module22.exports = scan;
      }
    });
    var require_parse2 = __commonJS22({
      "node_modules/picomatch/lib/parse.js"(exports22, module22) {
        "use strict";
        var constants = require_constants3();
        var utils = require_utils32();
        var {
          MAX_LENGTH,
          POSIX_REGEX_SOURCE,
          REGEX_NON_SPECIAL_CHARS,
          REGEX_SPECIAL_CHARS_BACKREF,
          REPLACEMENTS
        } = constants;
        var expandRange = (args, options) => {
          if (typeof options.expandRange === "function") {
            return options.expandRange(...args, options);
          }
          args.sort();
          const value = `[${args.join("-")}]`;
          try {
            new RegExp(value);
          } catch (ex) {
            return args.map((v) => utils.escapeRegex(v)).join("..");
          }
          return value;
        };
        var syntaxError = (type2, char) => {
          return `Missing ${type2}: "${char}" - use "\\\\${char}" to match literal characters`;
        };
        var parse2 = (input, options) => {
          if (typeof input !== "string") {
            throw new TypeError("Expected a string");
          }
          input = REPLACEMENTS[input] || input;
          const opts = Object.assign({}, options);
          const max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
          let len = input.length;
          if (len > max) {
            throw new SyntaxError(`Input length: ${len}, exceeds maximum allowed length: ${max}`);
          }
          const bos = {
            type: "bos",
            value: "",
            output: opts.prepend || ""
          };
          const tokens = [bos];
          const capture = opts.capture ? "" : "?:";
          const win32 = utils.isWindows(options);
          const PLATFORM_CHARS = constants.globChars(win32);
          const EXTGLOB_CHARS = constants.extglobChars(PLATFORM_CHARS);
          const {
            DOT_LITERAL,
            PLUS_LITERAL,
            SLASH_LITERAL,
            ONE_CHAR,
            DOTS_SLASH,
            NO_DOT,
            NO_DOT_SLASH,
            NO_DOTS_SLASH,
            QMARK,
            QMARK_NO_DOT,
            STAR,
            START_ANCHOR
          } = PLATFORM_CHARS;
          const globstar = (opts2) => {
            return `(${capture}(?:(?!${START_ANCHOR}${opts2.dot ? DOTS_SLASH : DOT_LITERAL}).)*?)`;
          };
          const nodot = opts.dot ? "" : NO_DOT;
          const qmarkNoDot = opts.dot ? QMARK : QMARK_NO_DOT;
          let star = opts.bash === true ? globstar(opts) : STAR;
          if (opts.capture) {
            star = `(${star})`;
          }
          if (typeof opts.noext === "boolean") {
            opts.noextglob = opts.noext;
          }
          const state = {
            input,
            index: -1,
            start: 0,
            dot: opts.dot === true,
            consumed: "",
            output: "",
            prefix: "",
            backtrack: false,
            negated: false,
            brackets: 0,
            braces: 0,
            parens: 0,
            quotes: 0,
            globstar: false,
            tokens
          };
          input = utils.removePrefix(input, state);
          len = input.length;
          const extglobs = [];
          const braces = [];
          const stack = [];
          let prev = bos;
          let value;
          const eos = () => state.index === len - 1;
          const peek = state.peek = (n = 1) => input[state.index + n];
          const advance = state.advance = () => input[++state.index] || "";
          const remaining = () => input.slice(state.index + 1);
          const consume = (value2 = "", num = 0) => {
            state.consumed += value2;
            state.index += num;
          };
          const append = (token) => {
            state.output += token.output != null ? token.output : token.value;
            consume(token.value);
          };
          const negate2 = () => {
            let count = 1;
            while (peek() === "!" && (peek(2) !== "(" || peek(3) === "?")) {
              advance();
              state.start++;
              count++;
            }
            if (count % 2 === 0) {
              return false;
            }
            state.negated = true;
            state.start++;
            return true;
          };
          const increment = (type2) => {
            state[type2]++;
            stack.push(type2);
          };
          const decrement = (type2) => {
            state[type2]--;
            stack.pop();
          };
          const push = (tok) => {
            if (prev.type === "globstar") {
              const isBrace = state.braces > 0 && (tok.type === "comma" || tok.type === "brace");
              const isExtglob = tok.extglob === true || extglobs.length && (tok.type === "pipe" || tok.type === "paren");
              if (tok.type !== "slash" && tok.type !== "paren" && !isBrace && !isExtglob) {
                state.output = state.output.slice(0, -prev.output.length);
                prev.type = "star";
                prev.value = "*";
                prev.output = star;
                state.output += prev.output;
              }
            }
            if (extglobs.length && tok.type !== "paren") {
              extglobs[extglobs.length - 1].inner += tok.value;
            }
            if (tok.value || tok.output)
              append(tok);
            if (prev && prev.type === "text" && tok.type === "text") {
              prev.value += tok.value;
              prev.output = (prev.output || "") + tok.value;
              return;
            }
            tok.prev = prev;
            tokens.push(tok);
            prev = tok;
          };
          const extglobOpen = (type2, value2) => {
            const token = Object.assign(Object.assign({}, EXTGLOB_CHARS[value2]), {}, {
              conditions: 1,
              inner: ""
            });
            token.prev = prev;
            token.parens = state.parens;
            token.output = state.output;
            const output = (opts.capture ? "(" : "") + token.open;
            increment("parens");
            push({
              type: type2,
              value: value2,
              output: state.output ? "" : ONE_CHAR
            });
            push({
              type: "paren",
              extglob: true,
              value: advance(),
              output
            });
            extglobs.push(token);
          };
          const extglobClose = (token) => {
            let output = token.close + (opts.capture ? ")" : "");
            let rest;
            if (token.type === "negate") {
              let extglobStar = star;
              if (token.inner && token.inner.length > 1 && token.inner.includes("/")) {
                extglobStar = globstar(opts);
              }
              if (extglobStar !== star || eos() || /^\)+$/.test(remaining())) {
                output = token.close = `)$))${extglobStar}`;
              }
              if (token.inner.includes("*") && (rest = remaining()) && /^\.[^\\/.]+$/.test(rest)) {
                const expression = parse2(rest, Object.assign(Object.assign({}, options), {}, {
                  fastpaths: false
                })).output;
                output = token.close = `)${expression})${extglobStar})`;
              }
              if (token.prev.type === "bos") {
                state.negatedExtglob = true;
              }
            }
            push({
              type: "paren",
              extglob: true,
              value,
              output
            });
            decrement("parens");
          };
          if (opts.fastpaths !== false && !/(^[*!]|[/()[\]{}"])/.test(input)) {
            let backslashes = false;
            let output = input.replace(REGEX_SPECIAL_CHARS_BACKREF, (m, esc, chars, first, rest, index) => {
              if (first === "\\") {
                backslashes = true;
                return m;
              }
              if (first === "?") {
                if (esc) {
                  return esc + first + (rest ? QMARK.repeat(rest.length) : "");
                }
                if (index === 0) {
                  return qmarkNoDot + (rest ? QMARK.repeat(rest.length) : "");
                }
                return QMARK.repeat(chars.length);
              }
              if (first === ".") {
                return DOT_LITERAL.repeat(chars.length);
              }
              if (first === "*") {
                if (esc) {
                  return esc + first + (rest ? star : "");
                }
                return star;
              }
              return esc ? m : `\\${m}`;
            });
            if (backslashes === true) {
              if (opts.unescape === true) {
                output = output.replace(/\\/g, "");
              } else {
                output = output.replace(/\\+/g, (m) => {
                  return m.length % 2 === 0 ? "\\\\" : m ? "\\" : "";
                });
              }
            }
            if (output === input && opts.contains === true) {
              state.output = input;
              return state;
            }
            state.output = utils.wrapOutput(output, state, options);
            return state;
          }
          while (!eos()) {
            value = advance();
            if (value === "\0") {
              continue;
            }
            if (value === "\\") {
              const next = peek();
              if (next === "/" && opts.bash !== true) {
                continue;
              }
              if (next === "." || next === ";") {
                continue;
              }
              if (!next) {
                value += "\\";
                push({
                  type: "text",
                  value
                });
                continue;
              }
              const match = /^\\+/.exec(remaining());
              let slashes = 0;
              if (match && match[0].length > 2) {
                slashes = match[0].length;
                state.index += slashes;
                if (slashes % 2 !== 0) {
                  value += "\\";
                }
              }
              if (opts.unescape === true) {
                value = advance();
              } else {
                value += advance();
              }
              if (state.brackets === 0) {
                push({
                  type: "text",
                  value
                });
                continue;
              }
            }
            if (state.brackets > 0 && (value !== "]" || prev.value === "[" || prev.value === "[^")) {
              if (opts.posix !== false && value === ":") {
                const inner = prev.value.slice(1);
                if (inner.includes("[")) {
                  prev.posix = true;
                  if (inner.includes(":")) {
                    const idx = prev.value.lastIndexOf("[");
                    const pre = prev.value.slice(0, idx);
                    const rest2 = prev.value.slice(idx + 2);
                    const posix = POSIX_REGEX_SOURCE[rest2];
                    if (posix) {
                      prev.value = pre + posix;
                      state.backtrack = true;
                      advance();
                      if (!bos.output && tokens.indexOf(prev) === 1) {
                        bos.output = ONE_CHAR;
                      }
                      continue;
                    }
                  }
                }
              }
              if (value === "[" && peek() !== ":" || value === "-" && peek() === "]") {
                value = `\\${value}`;
              }
              if (value === "]" && (prev.value === "[" || prev.value === "[^")) {
                value = `\\${value}`;
              }
              if (opts.posix === true && value === "!" && prev.value === "[") {
                value = "^";
              }
              prev.value += value;
              append({
                value
              });
              continue;
            }
            if (state.quotes === 1 && value !== '"') {
              value = utils.escapeRegex(value);
              prev.value += value;
              append({
                value
              });
              continue;
            }
            if (value === '"') {
              state.quotes = state.quotes === 1 ? 0 : 1;
              if (opts.keepQuotes === true) {
                push({
                  type: "text",
                  value
                });
              }
              continue;
            }
            if (value === "(") {
              increment("parens");
              push({
                type: "paren",
                value
              });
              continue;
            }
            if (value === ")") {
              if (state.parens === 0 && opts.strictBrackets === true) {
                throw new SyntaxError(syntaxError("opening", "("));
              }
              const extglob = extglobs[extglobs.length - 1];
              if (extglob && state.parens === extglob.parens + 1) {
                extglobClose(extglobs.pop());
                continue;
              }
              push({
                type: "paren",
                value,
                output: state.parens ? ")" : "\\)"
              });
              decrement("parens");
              continue;
            }
            if (value === "[") {
              if (opts.nobracket === true || !remaining().includes("]")) {
                if (opts.nobracket !== true && opts.strictBrackets === true) {
                  throw new SyntaxError(syntaxError("closing", "]"));
                }
                value = `\\${value}`;
              } else {
                increment("brackets");
              }
              push({
                type: "bracket",
                value
              });
              continue;
            }
            if (value === "]") {
              if (opts.nobracket === true || prev && prev.type === "bracket" && prev.value.length === 1) {
                push({
                  type: "text",
                  value,
                  output: `\\${value}`
                });
                continue;
              }
              if (state.brackets === 0) {
                if (opts.strictBrackets === true) {
                  throw new SyntaxError(syntaxError("opening", "["));
                }
                push({
                  type: "text",
                  value,
                  output: `\\${value}`
                });
                continue;
              }
              decrement("brackets");
              const prevValue = prev.value.slice(1);
              if (prev.posix !== true && prevValue[0] === "^" && !prevValue.includes("/")) {
                value = `/${value}`;
              }
              prev.value += value;
              append({
                value
              });
              if (opts.literalBrackets === false || utils.hasRegexChars(prevValue)) {
                continue;
              }
              const escaped = utils.escapeRegex(prev.value);
              state.output = state.output.slice(0, -prev.value.length);
              if (opts.literalBrackets === true) {
                state.output += escaped;
                prev.value = escaped;
                continue;
              }
              prev.value = `(${capture}${escaped}|${prev.value})`;
              state.output += prev.value;
              continue;
            }
            if (value === "{" && opts.nobrace !== true) {
              increment("braces");
              const open = {
                type: "brace",
                value,
                output: "(",
                outputIndex: state.output.length,
                tokensIndex: state.tokens.length
              };
              braces.push(open);
              push(open);
              continue;
            }
            if (value === "}") {
              const brace = braces[braces.length - 1];
              if (opts.nobrace === true || !brace) {
                push({
                  type: "text",
                  value,
                  output: value
                });
                continue;
              }
              let output = ")";
              if (brace.dots === true) {
                const arr = tokens.slice();
                const range = [];
                for (let i = arr.length - 1; i >= 0; i--) {
                  tokens.pop();
                  if (arr[i].type === "brace") {
                    break;
                  }
                  if (arr[i].type !== "dots") {
                    range.unshift(arr[i].value);
                  }
                }
                output = expandRange(range, opts);
                state.backtrack = true;
              }
              if (brace.comma !== true && brace.dots !== true) {
                const out = state.output.slice(0, brace.outputIndex);
                const toks = state.tokens.slice(brace.tokensIndex);
                brace.value = brace.output = "\\{";
                value = output = "\\}";
                state.output = out;
                for (const t of toks) {
                  state.output += t.output || t.value;
                }
              }
              push({
                type: "brace",
                value,
                output
              });
              decrement("braces");
              braces.pop();
              continue;
            }
            if (value === "|") {
              if (extglobs.length > 0) {
                extglobs[extglobs.length - 1].conditions++;
              }
              push({
                type: "text",
                value
              });
              continue;
            }
            if (value === ",") {
              let output = value;
              const brace = braces[braces.length - 1];
              if (brace && stack[stack.length - 1] === "braces") {
                brace.comma = true;
                output = "|";
              }
              push({
                type: "comma",
                value,
                output
              });
              continue;
            }
            if (value === "/") {
              if (prev.type === "dot" && state.index === state.start + 1) {
                state.start = state.index + 1;
                state.consumed = "";
                state.output = "";
                tokens.pop();
                prev = bos;
                continue;
              }
              push({
                type: "slash",
                value,
                output: SLASH_LITERAL
              });
              continue;
            }
            if (value === ".") {
              if (state.braces > 0 && prev.type === "dot") {
                if (prev.value === ".")
                  prev.output = DOT_LITERAL;
                const brace = braces[braces.length - 1];
                prev.type = "dots";
                prev.output += value;
                prev.value += value;
                brace.dots = true;
                continue;
              }
              if (state.braces + state.parens === 0 && prev.type !== "bos" && prev.type !== "slash") {
                push({
                  type: "text",
                  value,
                  output: DOT_LITERAL
                });
                continue;
              }
              push({
                type: "dot",
                value,
                output: DOT_LITERAL
              });
              continue;
            }
            if (value === "?") {
              const isGroup = prev && prev.value === "(";
              if (!isGroup && opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
                extglobOpen("qmark", value);
                continue;
              }
              if (prev && prev.type === "paren") {
                const next = peek();
                let output = value;
                if (next === "<" && !utils.supportsLookbehinds()) {
                  throw new Error("Node.js v10 or higher is required for regex lookbehinds");
                }
                if (prev.value === "(" && !/[!=<:]/.test(next) || next === "<" && !/<([!=]|\w+>)/.test(remaining())) {
                  output = `\\${value}`;
                }
                push({
                  type: "text",
                  value,
                  output
                });
                continue;
              }
              if (opts.dot !== true && (prev.type === "slash" || prev.type === "bos")) {
                push({
                  type: "qmark",
                  value,
                  output: QMARK_NO_DOT
                });
                continue;
              }
              push({
                type: "qmark",
                value,
                output: QMARK
              });
              continue;
            }
            if (value === "!") {
              if (opts.noextglob !== true && peek() === "(") {
                if (peek(2) !== "?" || !/[!=<:]/.test(peek(3))) {
                  extglobOpen("negate", value);
                  continue;
                }
              }
              if (opts.nonegate !== true && state.index === 0) {
                negate2();
                continue;
              }
            }
            if (value === "+") {
              if (opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
                extglobOpen("plus", value);
                continue;
              }
              if (prev && prev.value === "(" || opts.regex === false) {
                push({
                  type: "plus",
                  value,
                  output: PLUS_LITERAL
                });
                continue;
              }
              if (prev && (prev.type === "bracket" || prev.type === "paren" || prev.type === "brace") || state.parens > 0) {
                push({
                  type: "plus",
                  value
                });
                continue;
              }
              push({
                type: "plus",
                value: PLUS_LITERAL
              });
              continue;
            }
            if (value === "@") {
              if (opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
                push({
                  type: "at",
                  extglob: true,
                  value,
                  output: ""
                });
                continue;
              }
              push({
                type: "text",
                value
              });
              continue;
            }
            if (value !== "*") {
              if (value === "$" || value === "^") {
                value = `\\${value}`;
              }
              const match = REGEX_NON_SPECIAL_CHARS.exec(remaining());
              if (match) {
                value += match[0];
                state.index += match[0].length;
              }
              push({
                type: "text",
                value
              });
              continue;
            }
            if (prev && (prev.type === "globstar" || prev.star === true)) {
              prev.type = "star";
              prev.star = true;
              prev.value += value;
              prev.output = star;
              state.backtrack = true;
              state.globstar = true;
              consume(value);
              continue;
            }
            let rest = remaining();
            if (opts.noextglob !== true && /^\([^?]/.test(rest)) {
              extglobOpen("star", value);
              continue;
            }
            if (prev.type === "star") {
              if (opts.noglobstar === true) {
                consume(value);
                continue;
              }
              const prior = prev.prev;
              const before = prior.prev;
              const isStart = prior.type === "slash" || prior.type === "bos";
              const afterStar = before && (before.type === "star" || before.type === "globstar");
              if (opts.bash === true && (!isStart || rest[0] && rest[0] !== "/")) {
                push({
                  type: "star",
                  value,
                  output: ""
                });
                continue;
              }
              const isBrace = state.braces > 0 && (prior.type === "comma" || prior.type === "brace");
              const isExtglob = extglobs.length && (prior.type === "pipe" || prior.type === "paren");
              if (!isStart && prior.type !== "paren" && !isBrace && !isExtglob) {
                push({
                  type: "star",
                  value,
                  output: ""
                });
                continue;
              }
              while (rest.slice(0, 3) === "/**") {
                const after = input[state.index + 4];
                if (after && after !== "/") {
                  break;
                }
                rest = rest.slice(3);
                consume("/**", 3);
              }
              if (prior.type === "bos" && eos()) {
                prev.type = "globstar";
                prev.value += value;
                prev.output = globstar(opts);
                state.output = prev.output;
                state.globstar = true;
                consume(value);
                continue;
              }
              if (prior.type === "slash" && prior.prev.type !== "bos" && !afterStar && eos()) {
                state.output = state.output.slice(0, -(prior.output + prev.output).length);
                prior.output = `(?:${prior.output}`;
                prev.type = "globstar";
                prev.output = globstar(opts) + (opts.strictSlashes ? ")" : "|$)");
                prev.value += value;
                state.globstar = true;
                state.output += prior.output + prev.output;
                consume(value);
                continue;
              }
              if (prior.type === "slash" && prior.prev.type !== "bos" && rest[0] === "/") {
                const end = rest[1] !== void 0 ? "|$" : "";
                state.output = state.output.slice(0, -(prior.output + prev.output).length);
                prior.output = `(?:${prior.output}`;
                prev.type = "globstar";
                prev.output = `${globstar(opts)}${SLASH_LITERAL}|${SLASH_LITERAL}${end})`;
                prev.value += value;
                state.output += prior.output + prev.output;
                state.globstar = true;
                consume(value + advance());
                push({
                  type: "slash",
                  value: "/",
                  output: ""
                });
                continue;
              }
              if (prior.type === "bos" && rest[0] === "/") {
                prev.type = "globstar";
                prev.value += value;
                prev.output = `(?:^|${SLASH_LITERAL}|${globstar(opts)}${SLASH_LITERAL})`;
                state.output = prev.output;
                state.globstar = true;
                consume(value + advance());
                push({
                  type: "slash",
                  value: "/",
                  output: ""
                });
                continue;
              }
              state.output = state.output.slice(0, -prev.output.length);
              prev.type = "globstar";
              prev.output = globstar(opts);
              prev.value += value;
              state.output += prev.output;
              state.globstar = true;
              consume(value);
              continue;
            }
            const token = {
              type: "star",
              value,
              output: star
            };
            if (opts.bash === true) {
              token.output = ".*?";
              if (prev.type === "bos" || prev.type === "slash") {
                token.output = nodot + token.output;
              }
              push(token);
              continue;
            }
            if (prev && (prev.type === "bracket" || prev.type === "paren") && opts.regex === true) {
              token.output = value;
              push(token);
              continue;
            }
            if (state.index === state.start || prev.type === "slash" || prev.type === "dot") {
              if (prev.type === "dot") {
                state.output += NO_DOT_SLASH;
                prev.output += NO_DOT_SLASH;
              } else if (opts.dot === true) {
                state.output += NO_DOTS_SLASH;
                prev.output += NO_DOTS_SLASH;
              } else {
                state.output += nodot;
                prev.output += nodot;
              }
              if (peek() !== "*") {
                state.output += ONE_CHAR;
                prev.output += ONE_CHAR;
              }
            }
            push(token);
          }
          while (state.brackets > 0) {
            if (opts.strictBrackets === true)
              throw new SyntaxError(syntaxError("closing", "]"));
            state.output = utils.escapeLast(state.output, "[");
            decrement("brackets");
          }
          while (state.parens > 0) {
            if (opts.strictBrackets === true)
              throw new SyntaxError(syntaxError("closing", ")"));
            state.output = utils.escapeLast(state.output, "(");
            decrement("parens");
          }
          while (state.braces > 0) {
            if (opts.strictBrackets === true)
              throw new SyntaxError(syntaxError("closing", "}"));
            state.output = utils.escapeLast(state.output, "{");
            decrement("braces");
          }
          if (opts.strictSlashes !== true && (prev.type === "star" || prev.type === "bracket")) {
            push({
              type: "maybe_slash",
              value: "",
              output: `${SLASH_LITERAL}?`
            });
          }
          if (state.backtrack === true) {
            state.output = "";
            for (const token of state.tokens) {
              state.output += token.output != null ? token.output : token.value;
              if (token.suffix) {
                state.output += token.suffix;
              }
            }
          }
          return state;
        };
        parse2.fastpaths = (input, options) => {
          const opts = Object.assign({}, options);
          const max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
          const len = input.length;
          if (len > max) {
            throw new SyntaxError(`Input length: ${len}, exceeds maximum allowed length: ${max}`);
          }
          input = REPLACEMENTS[input] || input;
          const win32 = utils.isWindows(options);
          const {
            DOT_LITERAL,
            SLASH_LITERAL,
            ONE_CHAR,
            DOTS_SLASH,
            NO_DOT,
            NO_DOTS,
            NO_DOTS_SLASH,
            STAR,
            START_ANCHOR
          } = constants.globChars(win32);
          const nodot = opts.dot ? NO_DOTS : NO_DOT;
          const slashDot = opts.dot ? NO_DOTS_SLASH : NO_DOT;
          const capture = opts.capture ? "" : "?:";
          const state = {
            negated: false,
            prefix: ""
          };
          let star = opts.bash === true ? ".*?" : STAR;
          if (opts.capture) {
            star = `(${star})`;
          }
          const globstar = (opts2) => {
            if (opts2.noglobstar === true)
              return star;
            return `(${capture}(?:(?!${START_ANCHOR}${opts2.dot ? DOTS_SLASH : DOT_LITERAL}).)*?)`;
          };
          const create = (str2) => {
            switch (str2) {
              case "*":
                return `${nodot}${ONE_CHAR}${star}`;
              case ".*":
                return `${DOT_LITERAL}${ONE_CHAR}${star}`;
              case "*.*":
                return `${nodot}${star}${DOT_LITERAL}${ONE_CHAR}${star}`;
              case "*/*":
                return `${nodot}${star}${SLASH_LITERAL}${ONE_CHAR}${slashDot}${star}`;
              case "**":
                return nodot + globstar(opts);
              case "**/*":
                return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${slashDot}${ONE_CHAR}${star}`;
              case "**/*.*":
                return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${slashDot}${star}${DOT_LITERAL}${ONE_CHAR}${star}`;
              case "**/.*":
                return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${DOT_LITERAL}${ONE_CHAR}${star}`;
              default: {
                const match = /^(.*?)\.(\w+)$/.exec(str2);
                if (!match)
                  return;
                const source2 = create(match[1]);
                if (!source2)
                  return;
                return source2 + DOT_LITERAL + match[2];
              }
            }
          };
          const output = utils.removePrefix(input, state);
          let source = create(output);
          if (source && opts.strictSlashes !== true) {
            source += `${SLASH_LITERAL}?`;
          }
          return source;
        };
        module22.exports = parse2;
      }
    });
    var require_picomatch = __commonJS22({
      "node_modules/picomatch/lib/picomatch.js"(exports22, module22) {
        "use strict";
        var path5 = require("path");
        var scan = require_scan();
        var parse2 = require_parse2();
        var utils = require_utils32();
        var constants = require_constants3();
        var isObject3 = (val) => val && typeof val === "object" && !Array.isArray(val);
        var picomatch = (glob, options, returnState = false) => {
          if (Array.isArray(glob)) {
            const fns = glob.map((input) => picomatch(input, options, returnState));
            const arrayMatcher = (str2) => {
              for (const isMatch of fns) {
                const state2 = isMatch(str2);
                if (state2)
                  return state2;
              }
              return false;
            };
            return arrayMatcher;
          }
          const isState = isObject3(glob) && glob.tokens && glob.input;
          if (glob === "" || typeof glob !== "string" && !isState) {
            throw new TypeError("Expected pattern to be a non-empty string");
          }
          const opts = options || {};
          const posix = utils.isWindows(options);
          const regex = isState ? picomatch.compileRe(glob, options) : picomatch.makeRe(glob, options, false, true);
          const state = regex.state;
          delete regex.state;
          let isIgnored = () => false;
          if (opts.ignore) {
            const ignoreOpts = Object.assign(Object.assign({}, options), {}, {
              ignore: null,
              onMatch: null,
              onResult: null
            });
            isIgnored = picomatch(opts.ignore, ignoreOpts, returnState);
          }
          const matcher = (input, returnObject = false) => {
            const {
              isMatch,
              match,
              output
            } = picomatch.test(input, regex, options, {
              glob,
              posix
            });
            const result = {
              glob,
              state,
              regex,
              posix,
              input,
              output,
              match,
              isMatch
            };
            if (typeof opts.onResult === "function") {
              opts.onResult(result);
            }
            if (isMatch === false) {
              result.isMatch = false;
              return returnObject ? result : false;
            }
            if (isIgnored(input)) {
              if (typeof opts.onIgnore === "function") {
                opts.onIgnore(result);
              }
              result.isMatch = false;
              return returnObject ? result : false;
            }
            if (typeof opts.onMatch === "function") {
              opts.onMatch(result);
            }
            return returnObject ? result : true;
          };
          if (returnState) {
            matcher.state = state;
          }
          return matcher;
        };
        picomatch.test = (input, regex, options, {
          glob,
          posix
        } = {}) => {
          if (typeof input !== "string") {
            throw new TypeError("Expected input to be a string");
          }
          if (input === "") {
            return {
              isMatch: false,
              output: ""
            };
          }
          const opts = options || {};
          const format = opts.format || (posix ? utils.toPosixSlashes : null);
          let match = input === glob;
          let output = match && format ? format(input) : input;
          if (match === false) {
            output = format ? format(input) : input;
            match = output === glob;
          }
          if (match === false || opts.capture === true) {
            if (opts.matchBase === true || opts.basename === true) {
              match = picomatch.matchBase(input, regex, options, posix);
            } else {
              match = regex.exec(output);
            }
          }
          return {
            isMatch: Boolean(match),
            match,
            output
          };
        };
        picomatch.matchBase = (input, glob, options, posix = utils.isWindows(options)) => {
          const regex = glob instanceof RegExp ? glob : picomatch.makeRe(glob, options);
          return regex.test(path5.basename(input));
        };
        picomatch.isMatch = (str2, patterns, options) => picomatch(patterns, options)(str2);
        picomatch.parse = (pattern, options) => {
          if (Array.isArray(pattern))
            return pattern.map((p) => picomatch.parse(p, options));
          return parse2(pattern, Object.assign(Object.assign({}, options), {}, {
            fastpaths: false
          }));
        };
        picomatch.scan = (input, options) => scan(input, options);
        picomatch.compileRe = (state, options, returnOutput = false, returnState = false) => {
          if (returnOutput === true) {
            return state.output;
          }
          const opts = options || {};
          const prepend = opts.contains ? "" : "^";
          const append = opts.contains ? "" : "$";
          let source = `${prepend}(?:${state.output})${append}`;
          if (state && state.negated === true) {
            source = `^(?!${source}).*$`;
          }
          const regex = picomatch.toRegex(source, options);
          if (returnState === true) {
            regex.state = state;
          }
          return regex;
        };
        picomatch.makeRe = (input, options = {}, returnOutput = false, returnState = false) => {
          if (!input || typeof input !== "string") {
            throw new TypeError("Expected a non-empty string");
          }
          let parsed = {
            negated: false,
            fastpaths: true
          };
          if (options.fastpaths !== false && (input[0] === "." || input[0] === "*")) {
            parsed.output = parse2.fastpaths(input, options);
          }
          if (!parsed.output) {
            parsed = parse2(input, options);
          }
          return picomatch.compileRe(parsed, options, returnOutput, returnState);
        };
        picomatch.toRegex = (source, options) => {
          try {
            const opts = options || {};
            return new RegExp(source, opts.flags || (opts.nocase ? "i" : ""));
          } catch (err) {
            if (options && options.debug === true)
              throw err;
            return /$^/;
          }
        };
        picomatch.constants = constants;
        module22.exports = picomatch;
      }
    });
    var require_picomatch2 = __commonJS22({
      "node_modules/picomatch/index.js"(exports22, module22) {
        "use strict";
        module22.exports = require_picomatch();
      }
    });
    var require_micromatch = __commonJS22({
      "node_modules/micromatch/index.js"(exports22, module22) {
        "use strict";
        var util2 = require("util");
        var braces = require_braces();
        var picomatch = require_picomatch2();
        var utils = require_utils32();
        var isEmptyString = (val) => val === "" || val === "./";
        var micromatch = (list3, patterns, options) => {
          patterns = [].concat(patterns);
          list3 = [].concat(list3);
          let omit = /* @__PURE__ */ new Set();
          let keep = /* @__PURE__ */ new Set();
          let items = /* @__PURE__ */ new Set();
          let negatives = 0;
          let onResult = (state) => {
            items.add(state.output);
            if (options && options.onResult) {
              options.onResult(state);
            }
          };
          for (let i = 0; i < patterns.length; i++) {
            let isMatch = picomatch(String(patterns[i]), Object.assign(Object.assign({}, options), {}, {
              onResult
            }), true);
            let negated = isMatch.state.negated || isMatch.state.negatedExtglob;
            if (negated)
              negatives++;
            for (let item of list3) {
              let matched = isMatch(item, true);
              let match = negated ? !matched.isMatch : matched.isMatch;
              if (!match)
                continue;
              if (negated) {
                omit.add(matched.output);
              } else {
                omit.delete(matched.output);
                keep.add(matched.output);
              }
            }
          }
          let result = negatives === patterns.length ? [...items] : [...keep];
          let matches = result.filter((item) => !omit.has(item));
          if (options && matches.length === 0) {
            if (options.failglob === true) {
              throw new Error(`No matches found for "${patterns.join(", ")}"`);
            }
            if (options.nonull === true || options.nullglob === true) {
              return options.unescape ? patterns.map((p) => p.replace(/\\/g, "")) : patterns;
            }
          }
          return matches;
        };
        micromatch.match = micromatch;
        micromatch.matcher = (pattern, options) => picomatch(pattern, options);
        micromatch.isMatch = (str2, patterns, options) => picomatch(patterns, options)(str2);
        micromatch.any = micromatch.isMatch;
        micromatch.not = (list3, patterns, options = {}) => {
          patterns = [].concat(patterns).map(String);
          let result = /* @__PURE__ */ new Set();
          let items = [];
          let onResult = (state) => {
            if (options.onResult)
              options.onResult(state);
            items.push(state.output);
          };
          let matches = new Set(micromatch(list3, patterns, Object.assign(Object.assign({}, options), {}, {
            onResult
          })));
          for (let item of items) {
            if (!matches.has(item)) {
              result.add(item);
            }
          }
          return [...result];
        };
        micromatch.contains = (str2, pattern, options) => {
          if (typeof str2 !== "string") {
            throw new TypeError(`Expected a string: "${util2.inspect(str2)}"`);
          }
          if (Array.isArray(pattern)) {
            return pattern.some((p) => micromatch.contains(str2, p, options));
          }
          if (typeof pattern === "string") {
            if (isEmptyString(str2) || isEmptyString(pattern)) {
              return false;
            }
            if (str2.includes(pattern) || str2.startsWith("./") && str2.slice(2).includes(pattern)) {
              return true;
            }
          }
          return micromatch.isMatch(str2, pattern, Object.assign(Object.assign({}, options), {}, {
            contains: true
          }));
        };
        micromatch.matchKeys = (obj, patterns, options) => {
          if (!utils.isObject(obj)) {
            throw new TypeError("Expected the first argument to be an object");
          }
          let keys5 = micromatch(Object.keys(obj), patterns, options);
          let res = {};
          for (let key of keys5)
            res[key] = obj[key];
          return res;
        };
        micromatch.some = (list3, patterns, options) => {
          let items = [].concat(list3);
          for (let pattern of [].concat(patterns)) {
            let isMatch = picomatch(String(pattern), options);
            if (items.some((item) => isMatch(item))) {
              return true;
            }
          }
          return false;
        };
        micromatch.every = (list3, patterns, options) => {
          let items = [].concat(list3);
          for (let pattern of [].concat(patterns)) {
            let isMatch = picomatch(String(pattern), options);
            if (!items.every((item) => isMatch(item))) {
              return false;
            }
          }
          return true;
        };
        micromatch.all = (str2, patterns, options) => {
          if (typeof str2 !== "string") {
            throw new TypeError(`Expected a string: "${util2.inspect(str2)}"`);
          }
          return [].concat(patterns).every((p) => picomatch(p, options)(str2));
        };
        micromatch.capture = (glob, input, options) => {
          let posix = utils.isWindows(options);
          let regex = picomatch.makeRe(String(glob), Object.assign(Object.assign({}, options), {}, {
            capture: true
          }));
          let match = regex.exec(posix ? utils.toPosixSlashes(input) : input);
          if (match) {
            return match.slice(1).map((v) => v === void 0 ? "" : v);
          }
        };
        micromatch.makeRe = (...args) => picomatch.makeRe(...args);
        micromatch.scan = (...args) => picomatch.scan(...args);
        micromatch.parse = (patterns, options) => {
          let res = [];
          for (let pattern of [].concat(patterns || [])) {
            for (let str2 of braces(String(pattern), options)) {
              res.push(picomatch.parse(str2, options));
            }
          }
          return res;
        };
        micromatch.braces = (pattern, options) => {
          if (typeof pattern !== "string")
            throw new TypeError("Expected a string");
          if (options && options.nobrace === true || !/\{.*\}/.test(pattern)) {
            return [pattern];
          }
          return braces(pattern, options);
        };
        micromatch.braceExpand = (pattern, options) => {
          if (typeof pattern !== "string")
            throw new TypeError("Expected a string");
          return micromatch.braces(pattern, Object.assign(Object.assign({}, options), {}, {
            expand: true
          }));
        };
        module22.exports = micromatch;
      }
    });
    var require_parser22 = __commonJS22({
      "node_modules/@iarna/toml/lib/parser.js"(exports22, module22) {
        "use strict";
        var ParserEND = 1114112;
        var ParserError = class extends Error {
          constructor(msg, filename, linenumber) {
            super("[ParserError] " + msg, filename, linenumber);
            this.name = "ParserError";
            this.code = "ParserError";
            if (Error.captureStackTrace)
              Error.captureStackTrace(this, ParserError);
          }
        };
        var State3 = class {
          constructor(parser) {
            this.parser = parser;
            this.buf = "";
            this.returned = null;
            this.result = null;
            this.resultTable = null;
            this.resultArr = null;
          }
        };
        var Parser = class {
          constructor() {
            this.pos = 0;
            this.col = 0;
            this.line = 0;
            this.obj = {};
            this.ctx = this.obj;
            this.stack = [];
            this._buf = "";
            this.char = null;
            this.ii = 0;
            this.state = new State3(this.parseStart);
          }
          parse(str2) {
            if (str2.length === 0 || str2.length == null)
              return;
            this._buf = String(str2);
            this.ii = -1;
            this.char = -1;
            let getNext;
            while (getNext === false || this.nextChar()) {
              getNext = this.runOne();
            }
            this._buf = null;
          }
          nextChar() {
            if (this.char === 10) {
              ++this.line;
              this.col = -1;
            }
            ++this.ii;
            this.char = this._buf.codePointAt(this.ii);
            ++this.pos;
            ++this.col;
            return this.haveBuffer();
          }
          haveBuffer() {
            return this.ii < this._buf.length;
          }
          runOne() {
            return this.state.parser.call(this, this.state.returned);
          }
          finish() {
            this.char = ParserEND;
            let last;
            do {
              last = this.state.parser;
              this.runOne();
            } while (this.state.parser !== last);
            this.ctx = null;
            this.state = null;
            this._buf = null;
            return this.obj;
          }
          next(fn) {
            if (typeof fn !== "function")
              throw new ParserError("Tried to set state to non-existent state: " + JSON.stringify(fn));
            this.state.parser = fn;
          }
          goto(fn) {
            this.next(fn);
            return this.runOne();
          }
          call(fn, returnWith) {
            if (returnWith)
              this.next(returnWith);
            this.stack.push(this.state);
            this.state = new State3(fn);
          }
          callNow(fn, returnWith) {
            this.call(fn, returnWith);
            return this.runOne();
          }
          return(value) {
            if (this.stack.length === 0)
              throw this.error(new ParserError("Stack underflow"));
            if (value === void 0)
              value = this.state.buf;
            this.state = this.stack.pop();
            this.state.returned = value;
          }
          returnNow(value) {
            this.return(value);
            return this.runOne();
          }
          consume() {
            if (this.char === ParserEND)
              throw this.error(new ParserError("Unexpected end-of-buffer"));
            this.state.buf += this._buf[this.ii];
          }
          error(err) {
            err.line = this.line;
            err.col = this.col;
            err.pos = this.pos;
            return err;
          }
          parseStart() {
            throw new ParserError("Must declare a parseStart method");
          }
        };
        Parser.END = ParserEND;
        Parser.Error = ParserError;
        module22.exports = Parser;
      }
    });
    var require_create_datetime = __commonJS22({
      "node_modules/@iarna/toml/lib/create-datetime.js"(exports22, module22) {
        "use strict";
        module22.exports = (value) => {
          const date3 = new Date(value);
          if (isNaN(date3)) {
            throw new TypeError("Invalid Datetime");
          } else {
            return date3;
          }
        };
      }
    });
    var require_format_num = __commonJS22({
      "node_modules/@iarna/toml/lib/format-num.js"(exports22, module22) {
        "use strict";
        module22.exports = (d, num) => {
          num = String(num);
          while (num.length < d)
            num = "0" + num;
          return num;
        };
      }
    });
    var require_create_datetime_float = __commonJS22({
      "node_modules/@iarna/toml/lib/create-datetime-float.js"(exports22, module22) {
        "use strict";
        var f = require_format_num();
        var FloatingDateTime = class extends Date {
          constructor(value) {
            super(value + "Z");
            this.isFloating = true;
          }
          toISOString() {
            const date3 = `${this.getUTCFullYear()}-${f(2, this.getUTCMonth() + 1)}-${f(2, this.getUTCDate())}`;
            const time = `${f(2, this.getUTCHours())}:${f(2, this.getUTCMinutes())}:${f(2, this.getUTCSeconds())}.${f(3, this.getUTCMilliseconds())}`;
            return `${date3}T${time}`;
          }
        };
        module22.exports = (value) => {
          const date3 = new FloatingDateTime(value);
          if (isNaN(date3)) {
            throw new TypeError("Invalid Datetime");
          } else {
            return date3;
          }
        };
      }
    });
    var require_create_date = __commonJS22({
      "node_modules/@iarna/toml/lib/create-date.js"(exports22, module22) {
        "use strict";
        var f = require_format_num();
        var DateTime = global.Date;
        var Date2 = class extends DateTime {
          constructor(value) {
            super(value);
            this.isDate = true;
          }
          toISOString() {
            return `${this.getUTCFullYear()}-${f(2, this.getUTCMonth() + 1)}-${f(2, this.getUTCDate())}`;
          }
        };
        module22.exports = (value) => {
          const date3 = new Date2(value);
          if (isNaN(date3)) {
            throw new TypeError("Invalid Datetime");
          } else {
            return date3;
          }
        };
      }
    });
    var require_create_time = __commonJS22({
      "node_modules/@iarna/toml/lib/create-time.js"(exports22, module22) {
        "use strict";
        var f = require_format_num();
        var Time = class extends Date {
          constructor(value) {
            super(`0000-01-01T${value}Z`);
            this.isTime = true;
          }
          toISOString() {
            return `${f(2, this.getUTCHours())}:${f(2, this.getUTCMinutes())}:${f(2, this.getUTCSeconds())}.${f(3, this.getUTCMilliseconds())}`;
          }
        };
        module22.exports = (value) => {
          const date3 = new Time(value);
          if (isNaN(date3)) {
            throw new TypeError("Invalid Datetime");
          } else {
            return date3;
          }
        };
      }
    });
    var require_toml_parser = __commonJS22({
      "node_modules/@iarna/toml/lib/toml-parser.js"(exports22, module22) {
        "use strict";
        module22.exports = makeParserClass(require_parser22());
        module22.exports.makeParserClass = makeParserClass;
        var TomlError = class extends Error {
          constructor(msg) {
            super(msg);
            this.name = "TomlError";
            if (Error.captureStackTrace)
              Error.captureStackTrace(this, TomlError);
            this.fromTOML = true;
            this.wrapped = null;
          }
        };
        TomlError.wrap = (err) => {
          const terr = new TomlError(err.message);
          terr.code = err.code;
          terr.wrapped = err;
          return terr;
        };
        module22.exports.TomlError = TomlError;
        var createDateTime = require_create_datetime();
        var createDateTimeFloat = require_create_datetime_float();
        var createDate = require_create_date();
        var createTime = require_create_time();
        var CTRL_I = 9;
        var CTRL_J = 10;
        var CTRL_M = 13;
        var CTRL_CHAR_BOUNDARY = 31;
        var CHAR_SP = 32;
        var CHAR_QUOT = 34;
        var CHAR_NUM = 35;
        var CHAR_APOS = 39;
        var CHAR_PLUS = 43;
        var CHAR_COMMA2 = 44;
        var CHAR_HYPHEN = 45;
        var CHAR_PERIOD = 46;
        var CHAR_0 = 48;
        var CHAR_1 = 49;
        var CHAR_7 = 55;
        var CHAR_9 = 57;
        var CHAR_COLON2 = 58;
        var CHAR_EQUALS2 = 61;
        var CHAR_A = 65;
        var CHAR_E = 69;
        var CHAR_F = 70;
        var CHAR_T = 84;
        var CHAR_U = 85;
        var CHAR_Z = 90;
        var CHAR_LOWBAR = 95;
        var CHAR_a = 97;
        var CHAR_b = 98;
        var CHAR_e = 101;
        var CHAR_f = 102;
        var CHAR_i = 105;
        var CHAR_l = 108;
        var CHAR_n = 110;
        var CHAR_o = 111;
        var CHAR_r = 114;
        var CHAR_s = 115;
        var CHAR_t = 116;
        var CHAR_u = 117;
        var CHAR_x = 120;
        var CHAR_z = 122;
        var CHAR_LCUB = 123;
        var CHAR_RCUB = 125;
        var CHAR_LSQB = 91;
        var CHAR_BSOL = 92;
        var CHAR_RSQB = 93;
        var CHAR_DEL = 127;
        var SURROGATE_FIRST = 55296;
        var SURROGATE_LAST = 57343;
        var escapes = {
          [CHAR_b]: "\b",
          [CHAR_t]: "	",
          [CHAR_n]: "\n",
          [CHAR_f]: "\f",
          [CHAR_r]: "\r",
          [CHAR_QUOT]: '"',
          [CHAR_BSOL]: "\\"
        };
        function isDigit(cp) {
          return cp >= CHAR_0 && cp <= CHAR_9;
        }
        function isHexit(cp) {
          return cp >= CHAR_A && cp <= CHAR_F || cp >= CHAR_a && cp <= CHAR_f || cp >= CHAR_0 && cp <= CHAR_9;
        }
        function isBit(cp) {
          return cp === CHAR_1 || cp === CHAR_0;
        }
        function isOctit(cp) {
          return cp >= CHAR_0 && cp <= CHAR_7;
        }
        function isAlphaNumQuoteHyphen(cp) {
          return cp >= CHAR_A && cp <= CHAR_Z || cp >= CHAR_a && cp <= CHAR_z || cp >= CHAR_0 && cp <= CHAR_9 || cp === CHAR_APOS || cp === CHAR_QUOT || cp === CHAR_LOWBAR || cp === CHAR_HYPHEN;
        }
        function isAlphaNumHyphen(cp) {
          return cp >= CHAR_A && cp <= CHAR_Z || cp >= CHAR_a && cp <= CHAR_z || cp >= CHAR_0 && cp <= CHAR_9 || cp === CHAR_LOWBAR || cp === CHAR_HYPHEN;
        }
        var _type = Symbol("type");
        var _declared = Symbol("declared");
        var hasOwnProperty13 = Object.prototype.hasOwnProperty;
        var defineProperty2 = Object.defineProperty;
        var descriptor = {
          configurable: true,
          enumerable: true,
          writable: true,
          value: void 0
        };
        function hasKey(obj, key) {
          if (hasOwnProperty13.call(obj, key))
            return true;
          if (key === "__proto__")
            defineProperty2(obj, "__proto__", descriptor);
          return false;
        }
        var INLINE_TABLE = Symbol("inline-table");
        function InlineTable() {
          return Object.defineProperties({}, {
            [_type]: {
              value: INLINE_TABLE
            }
          });
        }
        function isInlineTable(obj) {
          if (obj === null || typeof obj !== "object")
            return false;
          return obj[_type] === INLINE_TABLE;
        }
        var TABLE = Symbol("table");
        function Table() {
          return Object.defineProperties({}, {
            [_type]: {
              value: TABLE
            },
            [_declared]: {
              value: false,
              writable: true
            }
          });
        }
        function isTable(obj) {
          if (obj === null || typeof obj !== "object")
            return false;
          return obj[_type] === TABLE;
        }
        var _contentType = Symbol("content-type");
        var INLINE_LIST = Symbol("inline-list");
        function InlineList(type2) {
          return Object.defineProperties([], {
            [_type]: {
              value: INLINE_LIST
            },
            [_contentType]: {
              value: type2
            }
          });
        }
        function isInlineList(obj) {
          if (obj === null || typeof obj !== "object")
            return false;
          return obj[_type] === INLINE_LIST;
        }
        var LIST = Symbol("list");
        function List() {
          return Object.defineProperties([], {
            [_type]: {
              value: LIST
            }
          });
        }
        function isList(obj) {
          if (obj === null || typeof obj !== "object")
            return false;
          return obj[_type] === LIST;
        }
        var _custom;
        try {
          const utilInspect = require("util").inspect;
          _custom = utilInspect.custom;
        } catch (_) {
        }
        var _inspect = _custom || "inspect";
        var BoxedBigInt = class {
          constructor(value) {
            try {
              this.value = global.BigInt.asIntN(64, value);
            } catch (_) {
              this.value = null;
            }
            Object.defineProperty(this, _type, {
              value: INTEGER
            });
          }
          isNaN() {
            return this.value === null;
          }
          toString() {
            return String(this.value);
          }
          [_inspect]() {
            return `[BigInt: ${this.toString()}]}`;
          }
          valueOf() {
            return this.value;
          }
        };
        var INTEGER = Symbol("integer");
        function Integer(value) {
          let num = Number(value);
          if (Object.is(num, -0))
            num = 0;
          if (global.BigInt && !Number.isSafeInteger(num)) {
            return new BoxedBigInt(value);
          } else {
            return Object.defineProperties(new Number(num), {
              isNaN: {
                value: function() {
                  return isNaN(this);
                }
              },
              [_type]: {
                value: INTEGER
              },
              [_inspect]: {
                value: () => `[Integer: ${value}]`
              }
            });
          }
        }
        function isInteger2(obj) {
          if (obj === null || typeof obj !== "object")
            return false;
          return obj[_type] === INTEGER;
        }
        var FLOAT2 = Symbol("float");
        function Float(value) {
          return Object.defineProperties(new Number(value), {
            [_type]: {
              value: FLOAT2
            },
            [_inspect]: {
              value: () => `[Float: ${value}]`
            }
          });
        }
        function isFloat2(obj) {
          if (obj === null || typeof obj !== "object")
            return false;
          return obj[_type] === FLOAT2;
        }
        function tomlType(value) {
          const type2 = typeof value;
          if (type2 === "object") {
            if (value === null)
              return "null";
            if (value instanceof Date)
              return "datetime";
            if (_type in value) {
              switch (value[_type]) {
                case INLINE_TABLE:
                  return "inline-table";
                case INLINE_LIST:
                  return "inline-list";
                case TABLE:
                  return "table";
                case LIST:
                  return "list";
                case FLOAT2:
                  return "float";
                case INTEGER:
                  return "integer";
              }
            }
          }
          return type2;
        }
        function makeParserClass(Parser) {
          class TOMLParser extends Parser {
            constructor() {
              super();
              this.ctx = this.obj = Table();
            }
            atEndOfWord() {
              return this.char === CHAR_NUM || this.char === CTRL_I || this.char === CHAR_SP || this.atEndOfLine();
            }
            atEndOfLine() {
              return this.char === Parser.END || this.char === CTRL_J || this.char === CTRL_M;
            }
            parseStart() {
              if (this.char === Parser.END) {
                return null;
              } else if (this.char === CHAR_LSQB) {
                return this.call(this.parseTableOrList);
              } else if (this.char === CHAR_NUM) {
                return this.call(this.parseComment);
              } else if (this.char === CTRL_J || this.char === CHAR_SP || this.char === CTRL_I || this.char === CTRL_M) {
                return null;
              } else if (isAlphaNumQuoteHyphen(this.char)) {
                return this.callNow(this.parseAssignStatement);
              } else {
                throw this.error(new TomlError(`Unknown character "${this.char}"`));
              }
            }
            parseWhitespaceToEOL() {
              if (this.char === CHAR_SP || this.char === CTRL_I || this.char === CTRL_M) {
                return null;
              } else if (this.char === CHAR_NUM) {
                return this.goto(this.parseComment);
              } else if (this.char === Parser.END || this.char === CTRL_J) {
                return this.return();
              } else {
                throw this.error(new TomlError("Unexpected character, expected only whitespace or comments till end of line"));
              }
            }
            parseAssignStatement() {
              return this.callNow(this.parseAssign, this.recordAssignStatement);
            }
            recordAssignStatement(kv) {
              let target = this.ctx;
              let finalKey = kv.key.pop();
              for (let kw of kv.key) {
                if (hasKey(target, kw) && (!isTable(target[kw]) || target[kw][_declared])) {
                  throw this.error(new TomlError("Can't redefine existing key"));
                }
                target = target[kw] = target[kw] || Table();
              }
              if (hasKey(target, finalKey)) {
                throw this.error(new TomlError("Can't redefine existing key"));
              }
              if (isInteger2(kv.value) || isFloat2(kv.value)) {
                target[finalKey] = kv.value.valueOf();
              } else {
                target[finalKey] = kv.value;
              }
              return this.goto(this.parseWhitespaceToEOL);
            }
            parseAssign() {
              return this.callNow(this.parseKeyword, this.recordAssignKeyword);
            }
            recordAssignKeyword(key) {
              if (this.state.resultTable) {
                this.state.resultTable.push(key);
              } else {
                this.state.resultTable = [key];
              }
              return this.goto(this.parseAssignKeywordPreDot);
            }
            parseAssignKeywordPreDot() {
              if (this.char === CHAR_PERIOD) {
                return this.next(this.parseAssignKeywordPostDot);
              } else if (this.char !== CHAR_SP && this.char !== CTRL_I) {
                return this.goto(this.parseAssignEqual);
              }
            }
            parseAssignKeywordPostDot() {
              if (this.char !== CHAR_SP && this.char !== CTRL_I) {
                return this.callNow(this.parseKeyword, this.recordAssignKeyword);
              }
            }
            parseAssignEqual() {
              if (this.char === CHAR_EQUALS2) {
                return this.next(this.parseAssignPreValue);
              } else {
                throw this.error(new TomlError('Invalid character, expected "="'));
              }
            }
            parseAssignPreValue() {
              if (this.char === CHAR_SP || this.char === CTRL_I) {
                return null;
              } else {
                return this.callNow(this.parseValue, this.recordAssignValue);
              }
            }
            recordAssignValue(value) {
              return this.returnNow({
                key: this.state.resultTable,
                value
              });
            }
            parseComment() {
              do {
                if (this.char === Parser.END || this.char === CTRL_J) {
                  return this.return();
                }
              } while (this.nextChar());
            }
            parseTableOrList() {
              if (this.char === CHAR_LSQB) {
                this.next(this.parseList);
              } else {
                return this.goto(this.parseTable);
              }
            }
            parseTable() {
              this.ctx = this.obj;
              return this.goto(this.parseTableNext);
            }
            parseTableNext() {
              if (this.char === CHAR_SP || this.char === CTRL_I) {
                return null;
              } else {
                return this.callNow(this.parseKeyword, this.parseTableMore);
              }
            }
            parseTableMore(keyword) {
              if (this.char === CHAR_SP || this.char === CTRL_I) {
                return null;
              } else if (this.char === CHAR_RSQB) {
                if (hasKey(this.ctx, keyword) && (!isTable(this.ctx[keyword]) || this.ctx[keyword][_declared])) {
                  throw this.error(new TomlError("Can't redefine existing key"));
                } else {
                  this.ctx = this.ctx[keyword] = this.ctx[keyword] || Table();
                  this.ctx[_declared] = true;
                }
                return this.next(this.parseWhitespaceToEOL);
              } else if (this.char === CHAR_PERIOD) {
                if (!hasKey(this.ctx, keyword)) {
                  this.ctx = this.ctx[keyword] = Table();
                } else if (isTable(this.ctx[keyword])) {
                  this.ctx = this.ctx[keyword];
                } else if (isList(this.ctx[keyword])) {
                  this.ctx = this.ctx[keyword][this.ctx[keyword].length - 1];
                } else {
                  throw this.error(new TomlError("Can't redefine existing key"));
                }
                return this.next(this.parseTableNext);
              } else {
                throw this.error(new TomlError("Unexpected character, expected whitespace, . or ]"));
              }
            }
            parseList() {
              this.ctx = this.obj;
              return this.goto(this.parseListNext);
            }
            parseListNext() {
              if (this.char === CHAR_SP || this.char === CTRL_I) {
                return null;
              } else {
                return this.callNow(this.parseKeyword, this.parseListMore);
              }
            }
            parseListMore(keyword) {
              if (this.char === CHAR_SP || this.char === CTRL_I) {
                return null;
              } else if (this.char === CHAR_RSQB) {
                if (!hasKey(this.ctx, keyword)) {
                  this.ctx[keyword] = List();
                }
                if (isInlineList(this.ctx[keyword])) {
                  throw this.error(new TomlError("Can't extend an inline array"));
                } else if (isList(this.ctx[keyword])) {
                  const next = Table();
                  this.ctx[keyword].push(next);
                  this.ctx = next;
                } else {
                  throw this.error(new TomlError("Can't redefine an existing key"));
                }
                return this.next(this.parseListEnd);
              } else if (this.char === CHAR_PERIOD) {
                if (!hasKey(this.ctx, keyword)) {
                  this.ctx = this.ctx[keyword] = Table();
                } else if (isInlineList(this.ctx[keyword])) {
                  throw this.error(new TomlError("Can't extend an inline array"));
                } else if (isInlineTable(this.ctx[keyword])) {
                  throw this.error(new TomlError("Can't extend an inline table"));
                } else if (isList(this.ctx[keyword])) {
                  this.ctx = this.ctx[keyword][this.ctx[keyword].length - 1];
                } else if (isTable(this.ctx[keyword])) {
                  this.ctx = this.ctx[keyword];
                } else {
                  throw this.error(new TomlError("Can't redefine an existing key"));
                }
                return this.next(this.parseListNext);
              } else {
                throw this.error(new TomlError("Unexpected character, expected whitespace, . or ]"));
              }
            }
            parseListEnd(keyword) {
              if (this.char === CHAR_RSQB) {
                return this.next(this.parseWhitespaceToEOL);
              } else {
                throw this.error(new TomlError("Unexpected character, expected whitespace, . or ]"));
              }
            }
            parseValue() {
              if (this.char === Parser.END) {
                throw this.error(new TomlError("Key without value"));
              } else if (this.char === CHAR_QUOT) {
                return this.next(this.parseDoubleString);
              }
              if (this.char === CHAR_APOS) {
                return this.next(this.parseSingleString);
              } else if (this.char === CHAR_HYPHEN || this.char === CHAR_PLUS) {
                return this.goto(this.parseNumberSign);
              } else if (this.char === CHAR_i) {
                return this.next(this.parseInf);
              } else if (this.char === CHAR_n) {
                return this.next(this.parseNan);
              } else if (isDigit(this.char)) {
                return this.goto(this.parseNumberOrDateTime);
              } else if (this.char === CHAR_t || this.char === CHAR_f) {
                return this.goto(this.parseBoolean);
              } else if (this.char === CHAR_LSQB) {
                return this.call(this.parseInlineList, this.recordValue);
              } else if (this.char === CHAR_LCUB) {
                return this.call(this.parseInlineTable, this.recordValue);
              } else {
                throw this.error(new TomlError("Unexpected character, expecting string, number, datetime, boolean, inline array or inline table"));
              }
            }
            recordValue(value) {
              return this.returnNow(value);
            }
            parseInf() {
              if (this.char === CHAR_n) {
                return this.next(this.parseInf2);
              } else {
                throw this.error(new TomlError('Unexpected character, expected "inf", "+inf" or "-inf"'));
              }
            }
            parseInf2() {
              if (this.char === CHAR_f) {
                if (this.state.buf === "-") {
                  return this.return(-Infinity);
                } else {
                  return this.return(Infinity);
                }
              } else {
                throw this.error(new TomlError('Unexpected character, expected "inf", "+inf" or "-inf"'));
              }
            }
            parseNan() {
              if (this.char === CHAR_a) {
                return this.next(this.parseNan2);
              } else {
                throw this.error(new TomlError('Unexpected character, expected "nan"'));
              }
            }
            parseNan2() {
              if (this.char === CHAR_n) {
                return this.return(NaN);
              } else {
                throw this.error(new TomlError('Unexpected character, expected "nan"'));
              }
            }
            parseKeyword() {
              if (this.char === CHAR_QUOT) {
                return this.next(this.parseBasicString);
              } else if (this.char === CHAR_APOS) {
                return this.next(this.parseLiteralString);
              } else {
                return this.goto(this.parseBareKey);
              }
            }
            parseBareKey() {
              do {
                if (this.char === Parser.END) {
                  throw this.error(new TomlError("Key ended without value"));
                } else if (isAlphaNumHyphen(this.char)) {
                  this.consume();
                } else if (this.state.buf.length === 0) {
                  throw this.error(new TomlError("Empty bare keys are not allowed"));
                } else {
                  return this.returnNow();
                }
              } while (this.nextChar());
            }
            parseSingleString() {
              if (this.char === CHAR_APOS) {
                return this.next(this.parseLiteralMultiStringMaybe);
              } else {
                return this.goto(this.parseLiteralString);
              }
            }
            parseLiteralString() {
              do {
                if (this.char === CHAR_APOS) {
                  return this.return();
                } else if (this.atEndOfLine()) {
                  throw this.error(new TomlError("Unterminated string"));
                } else if (this.char === CHAR_DEL || this.char <= CTRL_CHAR_BOUNDARY && this.char !== CTRL_I) {
                  throw this.errorControlCharInString();
                } else {
                  this.consume();
                }
              } while (this.nextChar());
            }
            parseLiteralMultiStringMaybe() {
              if (this.char === CHAR_APOS) {
                return this.next(this.parseLiteralMultiString);
              } else {
                return this.returnNow();
              }
            }
            parseLiteralMultiString() {
              if (this.char === CTRL_M) {
                return null;
              } else if (this.char === CTRL_J) {
                return this.next(this.parseLiteralMultiStringContent);
              } else {
                return this.goto(this.parseLiteralMultiStringContent);
              }
            }
            parseLiteralMultiStringContent() {
              do {
                if (this.char === CHAR_APOS) {
                  return this.next(this.parseLiteralMultiEnd);
                } else if (this.char === Parser.END) {
                  throw this.error(new TomlError("Unterminated multi-line string"));
                } else if (this.char === CHAR_DEL || this.char <= CTRL_CHAR_BOUNDARY && this.char !== CTRL_I && this.char !== CTRL_J && this.char !== CTRL_M) {
                  throw this.errorControlCharInString();
                } else {
                  this.consume();
                }
              } while (this.nextChar());
            }
            parseLiteralMultiEnd() {
              if (this.char === CHAR_APOS) {
                return this.next(this.parseLiteralMultiEnd2);
              } else {
                this.state.buf += "'";
                return this.goto(this.parseLiteralMultiStringContent);
              }
            }
            parseLiteralMultiEnd2() {
              if (this.char === CHAR_APOS) {
                return this.return();
              } else {
                this.state.buf += "''";
                return this.goto(this.parseLiteralMultiStringContent);
              }
            }
            parseDoubleString() {
              if (this.char === CHAR_QUOT) {
                return this.next(this.parseMultiStringMaybe);
              } else {
                return this.goto(this.parseBasicString);
              }
            }
            parseBasicString() {
              do {
                if (this.char === CHAR_BSOL) {
                  return this.call(this.parseEscape, this.recordEscapeReplacement);
                } else if (this.char === CHAR_QUOT) {
                  return this.return();
                } else if (this.atEndOfLine()) {
                  throw this.error(new TomlError("Unterminated string"));
                } else if (this.char === CHAR_DEL || this.char <= CTRL_CHAR_BOUNDARY && this.char !== CTRL_I) {
                  throw this.errorControlCharInString();
                } else {
                  this.consume();
                }
              } while (this.nextChar());
            }
            recordEscapeReplacement(replacement) {
              this.state.buf += replacement;
              return this.goto(this.parseBasicString);
            }
            parseMultiStringMaybe() {
              if (this.char === CHAR_QUOT) {
                return this.next(this.parseMultiString);
              } else {
                return this.returnNow();
              }
            }
            parseMultiString() {
              if (this.char === CTRL_M) {
                return null;
              } else if (this.char === CTRL_J) {
                return this.next(this.parseMultiStringContent);
              } else {
                return this.goto(this.parseMultiStringContent);
              }
            }
            parseMultiStringContent() {
              do {
                if (this.char === CHAR_BSOL) {
                  return this.call(this.parseMultiEscape, this.recordMultiEscapeReplacement);
                } else if (this.char === CHAR_QUOT) {
                  return this.next(this.parseMultiEnd);
                } else if (this.char === Parser.END) {
                  throw this.error(new TomlError("Unterminated multi-line string"));
                } else if (this.char === CHAR_DEL || this.char <= CTRL_CHAR_BOUNDARY && this.char !== CTRL_I && this.char !== CTRL_J && this.char !== CTRL_M) {
                  throw this.errorControlCharInString();
                } else {
                  this.consume();
                }
              } while (this.nextChar());
            }
            errorControlCharInString() {
              let displayCode = "\\u00";
              if (this.char < 16) {
                displayCode += "0";
              }
              displayCode += this.char.toString(16);
              return this.error(new TomlError(`Control characters (codes < 0x1f and 0x7f) are not allowed in strings, use ${displayCode} instead`));
            }
            recordMultiEscapeReplacement(replacement) {
              this.state.buf += replacement;
              return this.goto(this.parseMultiStringContent);
            }
            parseMultiEnd() {
              if (this.char === CHAR_QUOT) {
                return this.next(this.parseMultiEnd2);
              } else {
                this.state.buf += '"';
                return this.goto(this.parseMultiStringContent);
              }
            }
            parseMultiEnd2() {
              if (this.char === CHAR_QUOT) {
                return this.return();
              } else {
                this.state.buf += '""';
                return this.goto(this.parseMultiStringContent);
              }
            }
            parseMultiEscape() {
              if (this.char === CTRL_M || this.char === CTRL_J) {
                return this.next(this.parseMultiTrim);
              } else if (this.char === CHAR_SP || this.char === CTRL_I) {
                return this.next(this.parsePreMultiTrim);
              } else {
                return this.goto(this.parseEscape);
              }
            }
            parsePreMultiTrim() {
              if (this.char === CHAR_SP || this.char === CTRL_I) {
                return null;
              } else if (this.char === CTRL_M || this.char === CTRL_J) {
                return this.next(this.parseMultiTrim);
              } else {
                throw this.error(new TomlError("Can't escape whitespace"));
              }
            }
            parseMultiTrim() {
              if (this.char === CTRL_J || this.char === CHAR_SP || this.char === CTRL_I || this.char === CTRL_M) {
                return null;
              } else {
                return this.returnNow();
              }
            }
            parseEscape() {
              if (this.char in escapes) {
                return this.return(escapes[this.char]);
              } else if (this.char === CHAR_u) {
                return this.call(this.parseSmallUnicode, this.parseUnicodeReturn);
              } else if (this.char === CHAR_U) {
                return this.call(this.parseLargeUnicode, this.parseUnicodeReturn);
              } else {
                throw this.error(new TomlError("Unknown escape character: " + this.char));
              }
            }
            parseUnicodeReturn(char) {
              try {
                const codePoint = parseInt(char, 16);
                if (codePoint >= SURROGATE_FIRST && codePoint <= SURROGATE_LAST) {
                  throw this.error(new TomlError("Invalid unicode, character in range 0xD800 - 0xDFFF is reserved"));
                }
                return this.returnNow(String.fromCodePoint(codePoint));
              } catch (err) {
                throw this.error(TomlError.wrap(err));
              }
            }
            parseSmallUnicode() {
              if (!isHexit(this.char)) {
                throw this.error(new TomlError("Invalid character in unicode sequence, expected hex"));
              } else {
                this.consume();
                if (this.state.buf.length >= 4)
                  return this.return();
              }
            }
            parseLargeUnicode() {
              if (!isHexit(this.char)) {
                throw this.error(new TomlError("Invalid character in unicode sequence, expected hex"));
              } else {
                this.consume();
                if (this.state.buf.length >= 8)
                  return this.return();
              }
            }
            parseNumberSign() {
              this.consume();
              return this.next(this.parseMaybeSignedInfOrNan);
            }
            parseMaybeSignedInfOrNan() {
              if (this.char === CHAR_i) {
                return this.next(this.parseInf);
              } else if (this.char === CHAR_n) {
                return this.next(this.parseNan);
              } else {
                return this.callNow(this.parseNoUnder, this.parseNumberIntegerStart);
              }
            }
            parseNumberIntegerStart() {
              if (this.char === CHAR_0) {
                this.consume();
                return this.next(this.parseNumberIntegerExponentOrDecimal);
              } else {
                return this.goto(this.parseNumberInteger);
              }
            }
            parseNumberIntegerExponentOrDecimal() {
              if (this.char === CHAR_PERIOD) {
                this.consume();
                return this.call(this.parseNoUnder, this.parseNumberFloat);
              } else if (this.char === CHAR_E || this.char === CHAR_e) {
                this.consume();
                return this.next(this.parseNumberExponentSign);
              } else {
                return this.returnNow(Integer(this.state.buf));
              }
            }
            parseNumberInteger() {
              if (isDigit(this.char)) {
                this.consume();
              } else if (this.char === CHAR_LOWBAR) {
                return this.call(this.parseNoUnder);
              } else if (this.char === CHAR_E || this.char === CHAR_e) {
                this.consume();
                return this.next(this.parseNumberExponentSign);
              } else if (this.char === CHAR_PERIOD) {
                this.consume();
                return this.call(this.parseNoUnder, this.parseNumberFloat);
              } else {
                const result = Integer(this.state.buf);
                if (result.isNaN()) {
                  throw this.error(new TomlError("Invalid number"));
                } else {
                  return this.returnNow(result);
                }
              }
            }
            parseNoUnder() {
              if (this.char === CHAR_LOWBAR || this.char === CHAR_PERIOD || this.char === CHAR_E || this.char === CHAR_e) {
                throw this.error(new TomlError("Unexpected character, expected digit"));
              } else if (this.atEndOfWord()) {
                throw this.error(new TomlError("Incomplete number"));
              }
              return this.returnNow();
            }
            parseNoUnderHexOctBinLiteral() {
              if (this.char === CHAR_LOWBAR || this.char === CHAR_PERIOD) {
                throw this.error(new TomlError("Unexpected character, expected digit"));
              } else if (this.atEndOfWord()) {
                throw this.error(new TomlError("Incomplete number"));
              }
              return this.returnNow();
            }
            parseNumberFloat() {
              if (this.char === CHAR_LOWBAR) {
                return this.call(this.parseNoUnder, this.parseNumberFloat);
              } else if (isDigit(this.char)) {
                this.consume();
              } else if (this.char === CHAR_E || this.char === CHAR_e) {
                this.consume();
                return this.next(this.parseNumberExponentSign);
              } else {
                return this.returnNow(Float(this.state.buf));
              }
            }
            parseNumberExponentSign() {
              if (isDigit(this.char)) {
                return this.goto(this.parseNumberExponent);
              } else if (this.char === CHAR_HYPHEN || this.char === CHAR_PLUS) {
                this.consume();
                this.call(this.parseNoUnder, this.parseNumberExponent);
              } else {
                throw this.error(new TomlError("Unexpected character, expected -, + or digit"));
              }
            }
            parseNumberExponent() {
              if (isDigit(this.char)) {
                this.consume();
              } else if (this.char === CHAR_LOWBAR) {
                return this.call(this.parseNoUnder);
              } else {
                return this.returnNow(Float(this.state.buf));
              }
            }
            parseNumberOrDateTime() {
              if (this.char === CHAR_0) {
                this.consume();
                return this.next(this.parseNumberBaseOrDateTime);
              } else {
                return this.goto(this.parseNumberOrDateTimeOnly);
              }
            }
            parseNumberOrDateTimeOnly() {
              if (this.char === CHAR_LOWBAR) {
                return this.call(this.parseNoUnder, this.parseNumberInteger);
              } else if (isDigit(this.char)) {
                this.consume();
                if (this.state.buf.length > 4)
                  this.next(this.parseNumberInteger);
              } else if (this.char === CHAR_E || this.char === CHAR_e) {
                this.consume();
                return this.next(this.parseNumberExponentSign);
              } else if (this.char === CHAR_PERIOD) {
                this.consume();
                return this.call(this.parseNoUnder, this.parseNumberFloat);
              } else if (this.char === CHAR_HYPHEN) {
                return this.goto(this.parseDateTime);
              } else if (this.char === CHAR_COLON2) {
                return this.goto(this.parseOnlyTimeHour);
              } else {
                return this.returnNow(Integer(this.state.buf));
              }
            }
            parseDateTimeOnly() {
              if (this.state.buf.length < 4) {
                if (isDigit(this.char)) {
                  return this.consume();
                } else if (this.char === CHAR_COLON2) {
                  return this.goto(this.parseOnlyTimeHour);
                } else {
                  throw this.error(new TomlError("Expected digit while parsing year part of a date"));
                }
              } else {
                if (this.char === CHAR_HYPHEN) {
                  return this.goto(this.parseDateTime);
                } else {
                  throw this.error(new TomlError("Expected hyphen (-) while parsing year part of date"));
                }
              }
            }
            parseNumberBaseOrDateTime() {
              if (this.char === CHAR_b) {
                this.consume();
                return this.call(this.parseNoUnderHexOctBinLiteral, this.parseIntegerBin);
              } else if (this.char === CHAR_o) {
                this.consume();
                return this.call(this.parseNoUnderHexOctBinLiteral, this.parseIntegerOct);
              } else if (this.char === CHAR_x) {
                this.consume();
                return this.call(this.parseNoUnderHexOctBinLiteral, this.parseIntegerHex);
              } else if (this.char === CHAR_PERIOD) {
                return this.goto(this.parseNumberInteger);
              } else if (isDigit(this.char)) {
                return this.goto(this.parseDateTimeOnly);
              } else {
                return this.returnNow(Integer(this.state.buf));
              }
            }
            parseIntegerHex() {
              if (isHexit(this.char)) {
                this.consume();
              } else if (this.char === CHAR_LOWBAR) {
                return this.call(this.parseNoUnderHexOctBinLiteral);
              } else {
                const result = Integer(this.state.buf);
                if (result.isNaN()) {
                  throw this.error(new TomlError("Invalid number"));
                } else {
                  return this.returnNow(result);
                }
              }
            }
            parseIntegerOct() {
              if (isOctit(this.char)) {
                this.consume();
              } else if (this.char === CHAR_LOWBAR) {
                return this.call(this.parseNoUnderHexOctBinLiteral);
              } else {
                const result = Integer(this.state.buf);
                if (result.isNaN()) {
                  throw this.error(new TomlError("Invalid number"));
                } else {
                  return this.returnNow(result);
                }
              }
            }
            parseIntegerBin() {
              if (isBit(this.char)) {
                this.consume();
              } else if (this.char === CHAR_LOWBAR) {
                return this.call(this.parseNoUnderHexOctBinLiteral);
              } else {
                const result = Integer(this.state.buf);
                if (result.isNaN()) {
                  throw this.error(new TomlError("Invalid number"));
                } else {
                  return this.returnNow(result);
                }
              }
            }
            parseDateTime() {
              if (this.state.buf.length < 4) {
                throw this.error(new TomlError("Years less than 1000 must be zero padded to four characters"));
              }
              this.state.result = this.state.buf;
              this.state.buf = "";
              return this.next(this.parseDateMonth);
            }
            parseDateMonth() {
              if (this.char === CHAR_HYPHEN) {
                if (this.state.buf.length < 2) {
                  throw this.error(new TomlError("Months less than 10 must be zero padded to two characters"));
                }
                this.state.result += "-" + this.state.buf;
                this.state.buf = "";
                return this.next(this.parseDateDay);
              } else if (isDigit(this.char)) {
                this.consume();
              } else {
                throw this.error(new TomlError("Incomplete datetime"));
              }
            }
            parseDateDay() {
              if (this.char === CHAR_T || this.char === CHAR_SP) {
                if (this.state.buf.length < 2) {
                  throw this.error(new TomlError("Days less than 10 must be zero padded to two characters"));
                }
                this.state.result += "-" + this.state.buf;
                this.state.buf = "";
                return this.next(this.parseStartTimeHour);
              } else if (this.atEndOfWord()) {
                return this.returnNow(createDate(this.state.result + "-" + this.state.buf));
              } else if (isDigit(this.char)) {
                this.consume();
              } else {
                throw this.error(new TomlError("Incomplete datetime"));
              }
            }
            parseStartTimeHour() {
              if (this.atEndOfWord()) {
                return this.returnNow(createDate(this.state.result));
              } else {
                return this.goto(this.parseTimeHour);
              }
            }
            parseTimeHour() {
              if (this.char === CHAR_COLON2) {
                if (this.state.buf.length < 2) {
                  throw this.error(new TomlError("Hours less than 10 must be zero padded to two characters"));
                }
                this.state.result += "T" + this.state.buf;
                this.state.buf = "";
                return this.next(this.parseTimeMin);
              } else if (isDigit(this.char)) {
                this.consume();
              } else {
                throw this.error(new TomlError("Incomplete datetime"));
              }
            }
            parseTimeMin() {
              if (this.state.buf.length < 2 && isDigit(this.char)) {
                this.consume();
              } else if (this.state.buf.length === 2 && this.char === CHAR_COLON2) {
                this.state.result += ":" + this.state.buf;
                this.state.buf = "";
                return this.next(this.parseTimeSec);
              } else {
                throw this.error(new TomlError("Incomplete datetime"));
              }
            }
            parseTimeSec() {
              if (isDigit(this.char)) {
                this.consume();
                if (this.state.buf.length === 2) {
                  this.state.result += ":" + this.state.buf;
                  this.state.buf = "";
                  return this.next(this.parseTimeZoneOrFraction);
                }
              } else {
                throw this.error(new TomlError("Incomplete datetime"));
              }
            }
            parseOnlyTimeHour() {
              if (this.char === CHAR_COLON2) {
                if (this.state.buf.length < 2) {
                  throw this.error(new TomlError("Hours less than 10 must be zero padded to two characters"));
                }
                this.state.result = this.state.buf;
                this.state.buf = "";
                return this.next(this.parseOnlyTimeMin);
              } else {
                throw this.error(new TomlError("Incomplete time"));
              }
            }
            parseOnlyTimeMin() {
              if (this.state.buf.length < 2 && isDigit(this.char)) {
                this.consume();
              } else if (this.state.buf.length === 2 && this.char === CHAR_COLON2) {
                this.state.result += ":" + this.state.buf;
                this.state.buf = "";
                return this.next(this.parseOnlyTimeSec);
              } else {
                throw this.error(new TomlError("Incomplete time"));
              }
            }
            parseOnlyTimeSec() {
              if (isDigit(this.char)) {
                this.consume();
                if (this.state.buf.length === 2) {
                  return this.next(this.parseOnlyTimeFractionMaybe);
                }
              } else {
                throw this.error(new TomlError("Incomplete time"));
              }
            }
            parseOnlyTimeFractionMaybe() {
              this.state.result += ":" + this.state.buf;
              if (this.char === CHAR_PERIOD) {
                this.state.buf = "";
                this.next(this.parseOnlyTimeFraction);
              } else {
                return this.return(createTime(this.state.result));
              }
            }
            parseOnlyTimeFraction() {
              if (isDigit(this.char)) {
                this.consume();
              } else if (this.atEndOfWord()) {
                if (this.state.buf.length === 0)
                  throw this.error(new TomlError("Expected digit in milliseconds"));
                return this.returnNow(createTime(this.state.result + "." + this.state.buf));
              } else {
                throw this.error(new TomlError("Unexpected character in datetime, expected period (.), minus (-), plus (+) or Z"));
              }
            }
            parseTimeZoneOrFraction() {
              if (this.char === CHAR_PERIOD) {
                this.consume();
                this.next(this.parseDateTimeFraction);
              } else if (this.char === CHAR_HYPHEN || this.char === CHAR_PLUS) {
                this.consume();
                this.next(this.parseTimeZoneHour);
              } else if (this.char === CHAR_Z) {
                this.consume();
                return this.return(createDateTime(this.state.result + this.state.buf));
              } else if (this.atEndOfWord()) {
                return this.returnNow(createDateTimeFloat(this.state.result + this.state.buf));
              } else {
                throw this.error(new TomlError("Unexpected character in datetime, expected period (.), minus (-), plus (+) or Z"));
              }
            }
            parseDateTimeFraction() {
              if (isDigit(this.char)) {
                this.consume();
              } else if (this.state.buf.length === 1) {
                throw this.error(new TomlError("Expected digit in milliseconds"));
              } else if (this.char === CHAR_HYPHEN || this.char === CHAR_PLUS) {
                this.consume();
                this.next(this.parseTimeZoneHour);
              } else if (this.char === CHAR_Z) {
                this.consume();
                return this.return(createDateTime(this.state.result + this.state.buf));
              } else if (this.atEndOfWord()) {
                return this.returnNow(createDateTimeFloat(this.state.result + this.state.buf));
              } else {
                throw this.error(new TomlError("Unexpected character in datetime, expected period (.), minus (-), plus (+) or Z"));
              }
            }
            parseTimeZoneHour() {
              if (isDigit(this.char)) {
                this.consume();
                if (/\d\d$/.test(this.state.buf))
                  return this.next(this.parseTimeZoneSep);
              } else {
                throw this.error(new TomlError("Unexpected character in datetime, expected digit"));
              }
            }
            parseTimeZoneSep() {
              if (this.char === CHAR_COLON2) {
                this.consume();
                this.next(this.parseTimeZoneMin);
              } else {
                throw this.error(new TomlError("Unexpected character in datetime, expected colon"));
              }
            }
            parseTimeZoneMin() {
              if (isDigit(this.char)) {
                this.consume();
                if (/\d\d$/.test(this.state.buf))
                  return this.return(createDateTime(this.state.result + this.state.buf));
              } else {
                throw this.error(new TomlError("Unexpected character in datetime, expected digit"));
              }
            }
            parseBoolean() {
              if (this.char === CHAR_t) {
                this.consume();
                return this.next(this.parseTrue_r);
              } else if (this.char === CHAR_f) {
                this.consume();
                return this.next(this.parseFalse_a);
              }
            }
            parseTrue_r() {
              if (this.char === CHAR_r) {
                this.consume();
                return this.next(this.parseTrue_u);
              } else {
                throw this.error(new TomlError("Invalid boolean, expected true or false"));
              }
            }
            parseTrue_u() {
              if (this.char === CHAR_u) {
                this.consume();
                return this.next(this.parseTrue_e);
              } else {
                throw this.error(new TomlError("Invalid boolean, expected true or false"));
              }
            }
            parseTrue_e() {
              if (this.char === CHAR_e) {
                return this.return(true);
              } else {
                throw this.error(new TomlError("Invalid boolean, expected true or false"));
              }
            }
            parseFalse_a() {
              if (this.char === CHAR_a) {
                this.consume();
                return this.next(this.parseFalse_l);
              } else {
                throw this.error(new TomlError("Invalid boolean, expected true or false"));
              }
            }
            parseFalse_l() {
              if (this.char === CHAR_l) {
                this.consume();
                return this.next(this.parseFalse_s);
              } else {
                throw this.error(new TomlError("Invalid boolean, expected true or false"));
              }
            }
            parseFalse_s() {
              if (this.char === CHAR_s) {
                this.consume();
                return this.next(this.parseFalse_e);
              } else {
                throw this.error(new TomlError("Invalid boolean, expected true or false"));
              }
            }
            parseFalse_e() {
              if (this.char === CHAR_e) {
                return this.return(false);
              } else {
                throw this.error(new TomlError("Invalid boolean, expected true or false"));
              }
            }
            parseInlineList() {
              if (this.char === CHAR_SP || this.char === CTRL_I || this.char === CTRL_M || this.char === CTRL_J) {
                return null;
              } else if (this.char === Parser.END) {
                throw this.error(new TomlError("Unterminated inline array"));
              } else if (this.char === CHAR_NUM) {
                return this.call(this.parseComment);
              } else if (this.char === CHAR_RSQB) {
                return this.return(this.state.resultArr || InlineList());
              } else {
                return this.callNow(this.parseValue, this.recordInlineListValue);
              }
            }
            recordInlineListValue(value) {
              if (this.state.resultArr) {
                const listType = this.state.resultArr[_contentType];
                const valueType = tomlType(value);
                if (listType !== valueType) {
                  throw this.error(new TomlError(`Inline lists must be a single type, not a mix of ${listType} and ${valueType}`));
                }
              } else {
                this.state.resultArr = InlineList(tomlType(value));
              }
              if (isFloat2(value) || isInteger2(value)) {
                this.state.resultArr.push(value.valueOf());
              } else {
                this.state.resultArr.push(value);
              }
              return this.goto(this.parseInlineListNext);
            }
            parseInlineListNext() {
              if (this.char === CHAR_SP || this.char === CTRL_I || this.char === CTRL_M || this.char === CTRL_J) {
                return null;
              } else if (this.char === CHAR_NUM) {
                return this.call(this.parseComment);
              } else if (this.char === CHAR_COMMA2) {
                return this.next(this.parseInlineList);
              } else if (this.char === CHAR_RSQB) {
                return this.goto(this.parseInlineList);
              } else {
                throw this.error(new TomlError("Invalid character, expected whitespace, comma (,) or close bracket (])"));
              }
            }
            parseInlineTable() {
              if (this.char === CHAR_SP || this.char === CTRL_I) {
                return null;
              } else if (this.char === Parser.END || this.char === CHAR_NUM || this.char === CTRL_J || this.char === CTRL_M) {
                throw this.error(new TomlError("Unterminated inline array"));
              } else if (this.char === CHAR_RCUB) {
                return this.return(this.state.resultTable || InlineTable());
              } else {
                if (!this.state.resultTable)
                  this.state.resultTable = InlineTable();
                return this.callNow(this.parseAssign, this.recordInlineTableValue);
              }
            }
            recordInlineTableValue(kv) {
              let target = this.state.resultTable;
              let finalKey = kv.key.pop();
              for (let kw of kv.key) {
                if (hasKey(target, kw) && (!isTable(target[kw]) || target[kw][_declared])) {
                  throw this.error(new TomlError("Can't redefine existing key"));
                }
                target = target[kw] = target[kw] || Table();
              }
              if (hasKey(target, finalKey)) {
                throw this.error(new TomlError("Can't redefine existing key"));
              }
              if (isInteger2(kv.value) || isFloat2(kv.value)) {
                target[finalKey] = kv.value.valueOf();
              } else {
                target[finalKey] = kv.value;
              }
              return this.goto(this.parseInlineTableNext);
            }
            parseInlineTableNext() {
              if (this.char === CHAR_SP || this.char === CTRL_I) {
                return null;
              } else if (this.char === Parser.END || this.char === CHAR_NUM || this.char === CTRL_J || this.char === CTRL_M) {
                throw this.error(new TomlError("Unterminated inline array"));
              } else if (this.char === CHAR_COMMA2) {
                return this.next(this.parseInlineTable);
              } else if (this.char === CHAR_RCUB) {
                return this.goto(this.parseInlineTable);
              } else {
                throw this.error(new TomlError("Invalid character, expected whitespace, comma (,) or close bracket (])"));
              }
            }
          }
          return TOMLParser;
        }
      }
    });
    var require_parse_pretty_error = __commonJS22({
      "node_modules/@iarna/toml/parse-pretty-error.js"(exports22, module22) {
        "use strict";
        module22.exports = prettyError;
        function prettyError(err, buf) {
          if (err.pos == null || err.line == null)
            return err;
          let msg = err.message;
          msg += ` at row ${err.line + 1}, col ${err.col + 1}, pos ${err.pos}:
`;
          if (buf && buf.split) {
            const lines = buf.split(/\n/);
            const lineNumWidth = String(Math.min(lines.length, err.line + 3)).length;
            let linePadding = " ";
            while (linePadding.length < lineNumWidth)
              linePadding += " ";
            for (let ii = Math.max(0, err.line - 1); ii < Math.min(lines.length, err.line + 2); ++ii) {
              let lineNum = String(ii + 1);
              if (lineNum.length < lineNumWidth)
                lineNum = " " + lineNum;
              if (err.line === ii) {
                msg += lineNum + "> " + lines[ii] + "\n";
                msg += linePadding + "  ";
                for (let hh = 0; hh < err.col; ++hh) {
                  msg += " ";
                }
                msg += "^\n";
              } else {
                msg += lineNum + ": " + lines[ii] + "\n";
              }
            }
          }
          err.message = msg + "\n";
          return err;
        }
      }
    });
    var require_parse_string = __commonJS22({
      "node_modules/@iarna/toml/parse-string.js"(exports22, module22) {
        "use strict";
        module22.exports = parseString;
        var TOMLParser = require_toml_parser();
        var prettyError = require_parse_pretty_error();
        function parseString(str2) {
          if (global.Buffer && global.Buffer.isBuffer(str2)) {
            str2 = str2.toString("utf8");
          }
          const parser = new TOMLParser();
          try {
            parser.parse(str2);
            return parser.finish();
          } catch (err) {
            throw prettyError(err, str2);
          }
        }
      }
    });
    var require_load_toml = __commonJS22({
      "src/utils/load-toml.js"(exports22, module22) {
        "use strict";
        var parse2 = require_parse_string();
        module22.exports = function(filePath, content) {
          try {
            return parse2(content);
          } catch (error) {
            error.message = `TOML Error in ${filePath}:
${error.message}`;
            throw error;
          }
        };
      }
    });
    var require_unicode = __commonJS22({
      "node_modules/json5/lib/unicode.js"(exports22, module22) {
        module22.exports.Space_Separator = /[\u1680\u2000-\u200A\u202F\u205F\u3000]/;
        module22.exports.ID_Start = /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312E\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FEA\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF19]|\uD806[\uDCA0-\uDCDF\uDCFF\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE83\uDE86-\uDE89\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50\uDF93-\uDF9F\uDFE0\uDFE1]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00-\uDD1E\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4\uDD00-\uDD43]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]/;
        module22.exports.ID_Continue = /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u0860-\u086A\u08A0-\u08B4\u08B6-\u08BD\u08D4-\u08E1\u08E3-\u0963\u0966-\u096F\u0971-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u09FC\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0AF9-\u0AFF\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C00-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58-\u0C5A\u0C60-\u0C63\u0C66-\u0C6F\u0C80-\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D00-\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D54-\u0D57\u0D5F-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191E\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19D9\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1AB0-\u1ABD\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1CD0-\u1CD2\u1CD4-\u1CF9\u1D00-\u1DF9\u1DFB-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u2E2F\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099\u309A\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312E\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FEA\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA827\uA840-\uA873\uA880-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA8FD\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uA9E0-\uA9FE\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDDFD\uDE80-\uDE9C\uDEA0-\uDED0\uDEE0\uDF00-\uDF1F\uDF2D-\uDF4A\uDF50-\uDF7A\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00-\uDE03\uDE05\uDE06\uDE0C-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE38-\uDE3A\uDE3F\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE6\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC00-\uDC46\uDC66-\uDC6F\uDC7F-\uDCBA\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD00-\uDD34\uDD36-\uDD3F\uDD50-\uDD73\uDD76\uDD80-\uDDC4\uDDCA-\uDDCC\uDDD0-\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE37\uDE3E\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEEA\uDEF0-\uDEF9\uDF00-\uDF03\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3C-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF50\uDF57\uDF5D-\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDC00-\uDC4A\uDC50-\uDC59\uDC80-\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDB5\uDDB8-\uDDC0\uDDD8-\uDDDD\uDE00-\uDE40\uDE44\uDE50-\uDE59\uDE80-\uDEB7\uDEC0-\uDEC9\uDF00-\uDF19\uDF1D-\uDF2B\uDF30-\uDF39]|\uD806[\uDCA0-\uDCE9\uDCFF\uDE00-\uDE3E\uDE47\uDE50-\uDE83\uDE86-\uDE99\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC36\uDC38-\uDC40\uDC50-\uDC59\uDC72-\uDC8F\uDC92-\uDCA7\uDCA9-\uDCB6\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD36\uDD3A\uDD3C\uDD3D\uDD3F-\uDD47\uDD50-\uDD59]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDEF0-\uDEF4\uDF00-\uDF36\uDF40-\uDF43\uDF50-\uDF59\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50-\uDF7E\uDF8F-\uDF9F\uDFE0\uDFE1]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00-\uDD1E\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD836[\uDE00-\uDE36\uDE3B-\uDE6C\uDE75\uDE84\uDE9B-\uDE9F\uDEA1-\uDEAF]|\uD838[\uDC00-\uDC06\uDC08-\uDC18\uDC1B-\uDC21\uDC23\uDC24\uDC26-\uDC2A]|\uD83A[\uDC00-\uDCC4\uDCD0-\uDCD6\uDD00-\uDD4A\uDD50-\uDD59]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uDB40[\uDD00-\uDDEF]/;
      }
    });
    var require_util22 = __commonJS22({
      "node_modules/json5/lib/util.js"(exports22, module22) {
        var unicode = require_unicode();
        module22.exports = {
          isSpaceSeparator(c) {
            return typeof c === "string" && unicode.Space_Separator.test(c);
          },
          isIdStartChar(c) {
            return typeof c === "string" && (c >= "a" && c <= "z" || c >= "A" && c <= "Z" || c === "$" || c === "_" || unicode.ID_Start.test(c));
          },
          isIdContinueChar(c) {
            return typeof c === "string" && (c >= "a" && c <= "z" || c >= "A" && c <= "Z" || c >= "0" && c <= "9" || c === "$" || c === "_" || c === "\u200C" || c === "\u200D" || unicode.ID_Continue.test(c));
          },
          isDigit(c) {
            return typeof c === "string" && /[0-9]/.test(c);
          },
          isHexDigit(c) {
            return typeof c === "string" && /[0-9A-Fa-f]/.test(c);
          }
        };
      }
    });
    var require_parse3 = __commonJS22({
      "node_modules/json5/lib/parse.js"(exports22, module22) {
        var util2 = require_util22();
        var source;
        var parseState;
        var stack;
        var pos;
        var line;
        var column;
        var token;
        var key;
        var root2;
        module22.exports = function parse2(text, reviver) {
          source = String(text);
          parseState = "start";
          stack = [];
          pos = 0;
          line = 1;
          column = 0;
          token = void 0;
          key = void 0;
          root2 = void 0;
          do {
            token = lex();
            parseStates[parseState]();
          } while (token.type !== "eof");
          if (typeof reviver === "function") {
            return internalize({
              "": root2
            }, "", reviver);
          }
          return root2;
        };
        function internalize(holder, name, reviver) {
          const value = holder[name];
          if (value != null && typeof value === "object") {
            for (const key2 in value) {
              const replacement = internalize(value, key2, reviver);
              if (replacement === void 0) {
                delete value[key2];
              } else {
                value[key2] = replacement;
              }
            }
          }
          return reviver.call(holder, name, value);
        }
        var lexState;
        var buffer;
        var doubleQuote;
        var sign;
        var c;
        function lex() {
          lexState = "default";
          buffer = "";
          doubleQuote = false;
          sign = 1;
          for (; ; ) {
            c = peek();
            const token2 = lexStates[lexState]();
            if (token2) {
              return token2;
            }
          }
        }
        function peek() {
          if (source[pos]) {
            return String.fromCodePoint(source.codePointAt(pos));
          }
        }
        function read() {
          const c2 = peek();
          if (c2 === "\n") {
            line++;
            column = 0;
          } else if (c2) {
            column += c2.length;
          } else {
            column++;
          }
          if (c2) {
            pos += c2.length;
          }
          return c2;
        }
        var lexStates = {
          default() {
            switch (c) {
              case "	":
              case "\v":
              case "\f":
              case " ":
              case "\xA0":
              case "\uFEFF":
              case "\n":
              case "\r":
              case "\u2028":
              case "\u2029":
                read();
                return;
              case "/":
                read();
                lexState = "comment";
                return;
              case void 0:
                read();
                return newToken("eof");
            }
            if (util2.isSpaceSeparator(c)) {
              read();
              return;
            }
            return lexStates[parseState]();
          },
          comment() {
            switch (c) {
              case "*":
                read();
                lexState = "multiLineComment";
                return;
              case "/":
                read();
                lexState = "singleLineComment";
                return;
            }
            throw invalidChar(read());
          },
          multiLineComment() {
            switch (c) {
              case "*":
                read();
                lexState = "multiLineCommentAsterisk";
                return;
              case void 0:
                throw invalidChar(read());
            }
            read();
          },
          multiLineCommentAsterisk() {
            switch (c) {
              case "*":
                read();
                return;
              case "/":
                read();
                lexState = "default";
                return;
              case void 0:
                throw invalidChar(read());
            }
            read();
            lexState = "multiLineComment";
          },
          singleLineComment() {
            switch (c) {
              case "\n":
              case "\r":
              case "\u2028":
              case "\u2029":
                read();
                lexState = "default";
                return;
              case void 0:
                read();
                return newToken("eof");
            }
            read();
          },
          value() {
            switch (c) {
              case "{":
              case "[":
                return newToken("punctuator", read());
              case "n":
                read();
                literal("ull");
                return newToken("null", null);
              case "t":
                read();
                literal("rue");
                return newToken("boolean", true);
              case "f":
                read();
                literal("alse");
                return newToken("boolean", false);
              case "-":
              case "+":
                if (read() === "-") {
                  sign = -1;
                }
                lexState = "sign";
                return;
              case ".":
                buffer = read();
                lexState = "decimalPointLeading";
                return;
              case "0":
                buffer = read();
                lexState = "zero";
                return;
              case "1":
              case "2":
              case "3":
              case "4":
              case "5":
              case "6":
              case "7":
              case "8":
              case "9":
                buffer = read();
                lexState = "decimalInteger";
                return;
              case "I":
                read();
                literal("nfinity");
                return newToken("numeric", Infinity);
              case "N":
                read();
                literal("aN");
                return newToken("numeric", NaN);
              case '"':
              case "'":
                doubleQuote = read() === '"';
                buffer = "";
                lexState = "string";
                return;
            }
            throw invalidChar(read());
          },
          identifierNameStartEscape() {
            if (c !== "u") {
              throw invalidChar(read());
            }
            read();
            const u = unicodeEscape();
            switch (u) {
              case "$":
              case "_":
                break;
              default:
                if (!util2.isIdStartChar(u)) {
                  throw invalidIdentifier();
                }
                break;
            }
            buffer += u;
            lexState = "identifierName";
          },
          identifierName() {
            switch (c) {
              case "$":
              case "_":
              case "\u200C":
              case "\u200D":
                buffer += read();
                return;
              case "\\":
                read();
                lexState = "identifierNameEscape";
                return;
            }
            if (util2.isIdContinueChar(c)) {
              buffer += read();
              return;
            }
            return newToken("identifier", buffer);
          },
          identifierNameEscape() {
            if (c !== "u") {
              throw invalidChar(read());
            }
            read();
            const u = unicodeEscape();
            switch (u) {
              case "$":
              case "_":
              case "\u200C":
              case "\u200D":
                break;
              default:
                if (!util2.isIdContinueChar(u)) {
                  throw invalidIdentifier();
                }
                break;
            }
            buffer += u;
            lexState = "identifierName";
          },
          sign() {
            switch (c) {
              case ".":
                buffer = read();
                lexState = "decimalPointLeading";
                return;
              case "0":
                buffer = read();
                lexState = "zero";
                return;
              case "1":
              case "2":
              case "3":
              case "4":
              case "5":
              case "6":
              case "7":
              case "8":
              case "9":
                buffer = read();
                lexState = "decimalInteger";
                return;
              case "I":
                read();
                literal("nfinity");
                return newToken("numeric", sign * Infinity);
              case "N":
                read();
                literal("aN");
                return newToken("numeric", NaN);
            }
            throw invalidChar(read());
          },
          zero() {
            switch (c) {
              case ".":
                buffer += read();
                lexState = "decimalPoint";
                return;
              case "e":
              case "E":
                buffer += read();
                lexState = "decimalExponent";
                return;
              case "x":
              case "X":
                buffer += read();
                lexState = "hexadecimal";
                return;
            }
            return newToken("numeric", sign * 0);
          },
          decimalInteger() {
            switch (c) {
              case ".":
                buffer += read();
                lexState = "decimalPoint";
                return;
              case "e":
              case "E":
                buffer += read();
                lexState = "decimalExponent";
                return;
            }
            if (util2.isDigit(c)) {
              buffer += read();
              return;
            }
            return newToken("numeric", sign * Number(buffer));
          },
          decimalPointLeading() {
            if (util2.isDigit(c)) {
              buffer += read();
              lexState = "decimalFraction";
              return;
            }
            throw invalidChar(read());
          },
          decimalPoint() {
            switch (c) {
              case "e":
              case "E":
                buffer += read();
                lexState = "decimalExponent";
                return;
            }
            if (util2.isDigit(c)) {
              buffer += read();
              lexState = "decimalFraction";
              return;
            }
            return newToken("numeric", sign * Number(buffer));
          },
          decimalFraction() {
            switch (c) {
              case "e":
              case "E":
                buffer += read();
                lexState = "decimalExponent";
                return;
            }
            if (util2.isDigit(c)) {
              buffer += read();
              return;
            }
            return newToken("numeric", sign * Number(buffer));
          },
          decimalExponent() {
            switch (c) {
              case "+":
              case "-":
                buffer += read();
                lexState = "decimalExponentSign";
                return;
            }
            if (util2.isDigit(c)) {
              buffer += read();
              lexState = "decimalExponentInteger";
              return;
            }
            throw invalidChar(read());
          },
          decimalExponentSign() {
            if (util2.isDigit(c)) {
              buffer += read();
              lexState = "decimalExponentInteger";
              return;
            }
            throw invalidChar(read());
          },
          decimalExponentInteger() {
            if (util2.isDigit(c)) {
              buffer += read();
              return;
            }
            return newToken("numeric", sign * Number(buffer));
          },
          hexadecimal() {
            if (util2.isHexDigit(c)) {
              buffer += read();
              lexState = "hexadecimalInteger";
              return;
            }
            throw invalidChar(read());
          },
          hexadecimalInteger() {
            if (util2.isHexDigit(c)) {
              buffer += read();
              return;
            }
            return newToken("numeric", sign * Number(buffer));
          },
          string() {
            switch (c) {
              case "\\":
                read();
                buffer += escape();
                return;
              case '"':
                if (doubleQuote) {
                  read();
                  return newToken("string", buffer);
                }
                buffer += read();
                return;
              case "'":
                if (!doubleQuote) {
                  read();
                  return newToken("string", buffer);
                }
                buffer += read();
                return;
              case "\n":
              case "\r":
                throw invalidChar(read());
              case "\u2028":
              case "\u2029":
                separatorChar(c);
                break;
              case void 0:
                throw invalidChar(read());
            }
            buffer += read();
          },
          start() {
            switch (c) {
              case "{":
              case "[":
                return newToken("punctuator", read());
            }
            lexState = "value";
          },
          beforePropertyName() {
            switch (c) {
              case "$":
              case "_":
                buffer = read();
                lexState = "identifierName";
                return;
              case "\\":
                read();
                lexState = "identifierNameStartEscape";
                return;
              case "}":
                return newToken("punctuator", read());
              case '"':
              case "'":
                doubleQuote = read() === '"';
                lexState = "string";
                return;
            }
            if (util2.isIdStartChar(c)) {
              buffer += read();
              lexState = "identifierName";
              return;
            }
            throw invalidChar(read());
          },
          afterPropertyName() {
            if (c === ":") {
              return newToken("punctuator", read());
            }
            throw invalidChar(read());
          },
          beforePropertyValue() {
            lexState = "value";
          },
          afterPropertyValue() {
            switch (c) {
              case ",":
              case "}":
                return newToken("punctuator", read());
            }
            throw invalidChar(read());
          },
          beforeArrayValue() {
            if (c === "]") {
              return newToken("punctuator", read());
            }
            lexState = "value";
          },
          afterArrayValue() {
            switch (c) {
              case ",":
              case "]":
                return newToken("punctuator", read());
            }
            throw invalidChar(read());
          },
          end() {
            throw invalidChar(read());
          }
        };
        function newToken(type2, value) {
          return {
            type: type2,
            value,
            line,
            column
          };
        }
        function literal(s) {
          for (const c2 of s) {
            const p = peek();
            if (p !== c2) {
              throw invalidChar(read());
            }
            read();
          }
        }
        function escape() {
          const c2 = peek();
          switch (c2) {
            case "b":
              read();
              return "\b";
            case "f":
              read();
              return "\f";
            case "n":
              read();
              return "\n";
            case "r":
              read();
              return "\r";
            case "t":
              read();
              return "	";
            case "v":
              read();
              return "\v";
            case "0":
              read();
              if (util2.isDigit(peek())) {
                throw invalidChar(read());
              }
              return "\0";
            case "x":
              read();
              return hexEscape();
            case "u":
              read();
              return unicodeEscape();
            case "\n":
            case "\u2028":
            case "\u2029":
              read();
              return "";
            case "\r":
              read();
              if (peek() === "\n") {
                read();
              }
              return "";
            case "1":
            case "2":
            case "3":
            case "4":
            case "5":
            case "6":
            case "7":
            case "8":
            case "9":
              throw invalidChar(read());
            case void 0:
              throw invalidChar(read());
          }
          return read();
        }
        function hexEscape() {
          let buffer2 = "";
          let c2 = peek();
          if (!util2.isHexDigit(c2)) {
            throw invalidChar(read());
          }
          buffer2 += read();
          c2 = peek();
          if (!util2.isHexDigit(c2)) {
            throw invalidChar(read());
          }
          buffer2 += read();
          return String.fromCodePoint(parseInt(buffer2, 16));
        }
        function unicodeEscape() {
          let buffer2 = "";
          let count = 4;
          while (count-- > 0) {
            const c2 = peek();
            if (!util2.isHexDigit(c2)) {
              throw invalidChar(read());
            }
            buffer2 += read();
          }
          return String.fromCodePoint(parseInt(buffer2, 16));
        }
        var parseStates = {
          start() {
            if (token.type === "eof") {
              throw invalidEOF();
            }
            push();
          },
          beforePropertyName() {
            switch (token.type) {
              case "identifier":
              case "string":
                key = token.value;
                parseState = "afterPropertyName";
                return;
              case "punctuator":
                pop();
                return;
              case "eof":
                throw invalidEOF();
            }
          },
          afterPropertyName() {
            if (token.type === "eof") {
              throw invalidEOF();
            }
            parseState = "beforePropertyValue";
          },
          beforePropertyValue() {
            if (token.type === "eof") {
              throw invalidEOF();
            }
            push();
          },
          beforeArrayValue() {
            if (token.type === "eof") {
              throw invalidEOF();
            }
            if (token.type === "punctuator" && token.value === "]") {
              pop();
              return;
            }
            push();
          },
          afterPropertyValue() {
            if (token.type === "eof") {
              throw invalidEOF();
            }
            switch (token.value) {
              case ",":
                parseState = "beforePropertyName";
                return;
              case "}":
                pop();
            }
          },
          afterArrayValue() {
            if (token.type === "eof") {
              throw invalidEOF();
            }
            switch (token.value) {
              case ",":
                parseState = "beforeArrayValue";
                return;
              case "]":
                pop();
            }
          },
          end() {
          }
        };
        function push() {
          let value;
          switch (token.type) {
            case "punctuator":
              switch (token.value) {
                case "{":
                  value = {};
                  break;
                case "[":
                  value = [];
                  break;
              }
              break;
            case "null":
            case "boolean":
            case "numeric":
            case "string":
              value = token.value;
              break;
          }
          if (root2 === void 0) {
            root2 = value;
          } else {
            const parent = stack[stack.length - 1];
            if (Array.isArray(parent)) {
              parent.push(value);
            } else {
              parent[key] = value;
            }
          }
          if (value !== null && typeof value === "object") {
            stack.push(value);
            if (Array.isArray(value)) {
              parseState = "beforeArrayValue";
            } else {
              parseState = "beforePropertyName";
            }
          } else {
            const current = stack[stack.length - 1];
            if (current == null) {
              parseState = "end";
            } else if (Array.isArray(current)) {
              parseState = "afterArrayValue";
            } else {
              parseState = "afterPropertyValue";
            }
          }
        }
        function pop() {
          stack.pop();
          const current = stack[stack.length - 1];
          if (current == null) {
            parseState = "end";
          } else if (Array.isArray(current)) {
            parseState = "afterArrayValue";
          } else {
            parseState = "afterPropertyValue";
          }
        }
        function invalidChar(c2) {
          if (c2 === void 0) {
            return syntaxError(`JSON5: invalid end of input at ${line}:${column}`);
          }
          return syntaxError(`JSON5: invalid character '${formatChar(c2)}' at ${line}:${column}`);
        }
        function invalidEOF() {
          return syntaxError(`JSON5: invalid end of input at ${line}:${column}`);
        }
        function invalidIdentifier() {
          column -= 5;
          return syntaxError(`JSON5: invalid identifier character at ${line}:${column}`);
        }
        function separatorChar(c2) {
          console.warn(`JSON5: '${formatChar(c2)}' in strings is not valid ECMAScript; consider escaping`);
        }
        function formatChar(c2) {
          const replacements = {
            "'": "\\'",
            '"': '\\"',
            "\\": "\\\\",
            "\b": "\\b",
            "\f": "\\f",
            "\n": "\\n",
            "\r": "\\r",
            "	": "\\t",
            "\v": "\\v",
            "\0": "\\0",
            "\u2028": "\\u2028",
            "\u2029": "\\u2029"
          };
          if (replacements[c2]) {
            return replacements[c2];
          }
          if (c2 < " ") {
            const hexString = c2.charCodeAt(0).toString(16);
            return "\\x" + ("00" + hexString).substring(hexString.length);
          }
          return c2;
        }
        function syntaxError(message) {
          const err = new SyntaxError(message);
          err.lineNumber = line;
          err.columnNumber = column;
          return err;
        }
      }
    });
    var require_stringify22 = __commonJS22({
      "node_modules/json5/lib/stringify.js"(exports22, module22) {
        var util2 = require_util22();
        module22.exports = function stringify(value, replacer, space) {
          const stack = [];
          let indent = "";
          let propertyList;
          let replacerFunc;
          let gap = "";
          let quote;
          if (replacer != null && typeof replacer === "object" && !Array.isArray(replacer)) {
            space = replacer.space;
            quote = replacer.quote;
            replacer = replacer.replacer;
          }
          if (typeof replacer === "function") {
            replacerFunc = replacer;
          } else if (Array.isArray(replacer)) {
            propertyList = [];
            for (const v of replacer) {
              let item;
              if (typeof v === "string") {
                item = v;
              } else if (typeof v === "number" || v instanceof String || v instanceof Number) {
                item = String(v);
              }
              if (item !== void 0 && propertyList.indexOf(item) < 0) {
                propertyList.push(item);
              }
            }
          }
          if (space instanceof Number) {
            space = Number(space);
          } else if (space instanceof String) {
            space = String(space);
          }
          if (typeof space === "number") {
            if (space > 0) {
              space = Math.min(10, Math.floor(space));
              gap = "          ".substr(0, space);
            }
          } else if (typeof space === "string") {
            gap = space.substr(0, 10);
          }
          return serializeProperty("", {
            "": value
          });
          function serializeProperty(key, holder) {
            let value2 = holder[key];
            if (value2 != null) {
              if (typeof value2.toJSON5 === "function") {
                value2 = value2.toJSON5(key);
              } else if (typeof value2.toJSON === "function") {
                value2 = value2.toJSON(key);
              }
            }
            if (replacerFunc) {
              value2 = replacerFunc.call(holder, key, value2);
            }
            if (value2 instanceof Number) {
              value2 = Number(value2);
            } else if (value2 instanceof String) {
              value2 = String(value2);
            } else if (value2 instanceof Boolean) {
              value2 = value2.valueOf();
            }
            switch (value2) {
              case null:
                return "null";
              case true:
                return "true";
              case false:
                return "false";
            }
            if (typeof value2 === "string") {
              return quoteString(value2, false);
            }
            if (typeof value2 === "number") {
              return String(value2);
            }
            if (typeof value2 === "object") {
              return Array.isArray(value2) ? serializeArray(value2) : serializeObject(value2);
            }
            return void 0;
          }
          function quoteString(value2) {
            const quotes = {
              "'": 0.1,
              '"': 0.2
            };
            const replacements = {
              "'": "\\'",
              '"': '\\"',
              "\\": "\\\\",
              "\b": "\\b",
              "\f": "\\f",
              "\n": "\\n",
              "\r": "\\r",
              "	": "\\t",
              "\v": "\\v",
              "\0": "\\0",
              "\u2028": "\\u2028",
              "\u2029": "\\u2029"
            };
            let product = "";
            for (let i = 0; i < value2.length; i++) {
              const c = value2[i];
              switch (c) {
                case "'":
                case '"':
                  quotes[c]++;
                  product += c;
                  continue;
                case "\0":
                  if (util2.isDigit(value2[i + 1])) {
                    product += "\\x00";
                    continue;
                  }
              }
              if (replacements[c]) {
                product += replacements[c];
                continue;
              }
              if (c < " ") {
                let hexString = c.charCodeAt(0).toString(16);
                product += "\\x" + ("00" + hexString).substring(hexString.length);
                continue;
              }
              product += c;
            }
            const quoteChar = quote || Object.keys(quotes).reduce((a, b) => quotes[a] < quotes[b] ? a : b);
            product = product.replace(new RegExp(quoteChar, "g"), replacements[quoteChar]);
            return quoteChar + product + quoteChar;
          }
          function serializeObject(value2) {
            if (stack.indexOf(value2) >= 0) {
              throw TypeError("Converting circular structure to JSON5");
            }
            stack.push(value2);
            let stepback = indent;
            indent = indent + gap;
            let keys5 = propertyList || Object.keys(value2);
            let partial = [];
            for (const key of keys5) {
              const propertyString = serializeProperty(key, value2);
              if (propertyString !== void 0) {
                let member = serializeKey(key) + ":";
                if (gap !== "") {
                  member += " ";
                }
                member += propertyString;
                partial.push(member);
              }
            }
            let final;
            if (partial.length === 0) {
              final = "{}";
            } else {
              let properties;
              if (gap === "") {
                properties = partial.join(",");
                final = "{" + properties + "}";
              } else {
                let separator = ",\n" + indent;
                properties = partial.join(separator);
                final = "{\n" + indent + properties + ",\n" + stepback + "}";
              }
            }
            stack.pop();
            indent = stepback;
            return final;
          }
          function serializeKey(key) {
            if (key.length === 0) {
              return quoteString(key, true);
            }
            const firstChar = String.fromCodePoint(key.codePointAt(0));
            if (!util2.isIdStartChar(firstChar)) {
              return quoteString(key, true);
            }
            for (let i = firstChar.length; i < key.length; i++) {
              if (!util2.isIdContinueChar(String.fromCodePoint(key.codePointAt(i)))) {
                return quoteString(key, true);
              }
            }
            return key;
          }
          function serializeArray(value2) {
            if (stack.indexOf(value2) >= 0) {
              throw TypeError("Converting circular structure to JSON5");
            }
            stack.push(value2);
            let stepback = indent;
            indent = indent + gap;
            let partial = [];
            for (let i = 0; i < value2.length; i++) {
              const propertyString = serializeProperty(String(i), value2);
              partial.push(propertyString !== void 0 ? propertyString : "null");
            }
            let final;
            if (partial.length === 0) {
              final = "[]";
            } else {
              if (gap === "") {
                let properties = partial.join(",");
                final = "[" + properties + "]";
              } else {
                let separator = ",\n" + indent;
                let properties = partial.join(separator);
                final = "[\n" + indent + properties + ",\n" + stepback + "]";
              }
            }
            stack.pop();
            indent = stepback;
            return final;
          }
        };
      }
    });
    var require_lib6 = __commonJS22({
      "node_modules/json5/lib/index.js"(exports22, module22) {
        var parse2 = require_parse3();
        var stringify = require_stringify22();
        var JSON5 = {
          parse: parse2,
          stringify
        };
        module22.exports = JSON5;
      }
    });
    var require_load_json5 = __commonJS22({
      "src/utils/load-json5.js"(exports22, module22) {
        "use strict";
        var {
          parse: parse2
        } = require_lib6();
        module22.exports = function(filePath, content) {
          try {
            return parse2(content);
          } catch (error) {
            error.message = `JSON5 Error in ${filePath}:
${error.message}`;
            throw error;
          }
        };
      }
    });
    var require_partition = __commonJS22({
      "src/utils/partition.js"(exports22, module22) {
        "use strict";
        function partition3(array, predicate) {
          const result = [[], []];
          for (const value of array) {
            result[predicate(value) ? 0 : 1].push(value);
          }
          return result;
        }
        module22.exports = partition3;
      }
    });
    var require_homedir = __commonJS22({
      "node_modules/resolve/lib/homedir.js"(exports22, module22) {
        "use strict";
        var os = require("os");
        module22.exports = os.homedir || function homedir() {
          var home = process.env.HOME;
          var user = process.env.LOGNAME || process.env.USER || process.env.LNAME || process.env.USERNAME;
          if (process.platform === "win32") {
            return process.env.USERPROFILE || process.env.HOMEDRIVE + process.env.HOMEPATH || home || null;
          }
          if (process.platform === "darwin") {
            return home || (user ? "/Users/" + user : null);
          }
          if (process.platform === "linux") {
            return home || (process.getuid() === 0 ? "/root" : user ? "/home/" + user : null);
          }
          return home || null;
        };
      }
    });
    var require_caller = __commonJS22({
      "node_modules/resolve/lib/caller.js"(exports22, module22) {
        module22.exports = function() {
          var origPrepareStackTrace = Error.prepareStackTrace;
          Error.prepareStackTrace = function(_, stack2) {
            return stack2;
          };
          var stack = new Error().stack;
          Error.prepareStackTrace = origPrepareStackTrace;
          return stack[2].getFileName();
        };
      }
    });
    var require_path_parse = __commonJS22({
      "node_modules/path-parse/index.js"(exports22, module22) {
        "use strict";
        var isWindows = process.platform === "win32";
        var splitWindowsRe = /^(((?:[a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/]+[^\\\/]+)?[\\\/]?)(?:[^\\\/]*[\\\/])*)((\.{1,2}|[^\\\/]+?|)(\.[^.\/\\]*|))[\\\/]*$/;
        var win32 = {};
        function win32SplitPath(filename) {
          return splitWindowsRe.exec(filename).slice(1);
        }
        win32.parse = function(pathString) {
          if (typeof pathString !== "string") {
            throw new TypeError("Parameter 'pathString' must be a string, not " + typeof pathString);
          }
          var allParts = win32SplitPath(pathString);
          if (!allParts || allParts.length !== 5) {
            throw new TypeError("Invalid path '" + pathString + "'");
          }
          return {
            root: allParts[1],
            dir: allParts[0] === allParts[1] ? allParts[0] : allParts[0].slice(0, -1),
            base: allParts[2],
            ext: allParts[4],
            name: allParts[3]
          };
        };
        var splitPathRe = /^((\/?)(?:[^\/]*\/)*)((\.{1,2}|[^\/]+?|)(\.[^.\/]*|))[\/]*$/;
        var posix = {};
        function posixSplitPath(filename) {
          return splitPathRe.exec(filename).slice(1);
        }
        posix.parse = function(pathString) {
          if (typeof pathString !== "string") {
            throw new TypeError("Parameter 'pathString' must be a string, not " + typeof pathString);
          }
          var allParts = posixSplitPath(pathString);
          if (!allParts || allParts.length !== 5) {
            throw new TypeError("Invalid path '" + pathString + "'");
          }
          return {
            root: allParts[1],
            dir: allParts[0].slice(0, -1),
            base: allParts[2],
            ext: allParts[4],
            name: allParts[3]
          };
        };
        if (isWindows)
          module22.exports = win32.parse;
        else
          module22.exports = posix.parse;
        module22.exports.posix = posix.parse;
        module22.exports.win32 = win32.parse;
      }
    });
    var require_node_modules_paths = __commonJS22({
      "node_modules/resolve/lib/node-modules-paths.js"(exports22, module22) {
        var path5 = require("path");
        var parse2 = path5.parse || require_path_parse();
        var getNodeModulesDirs = function getNodeModulesDirs2(absoluteStart, modules) {
          var prefix = "/";
          if (/^([A-Za-z]:)/.test(absoluteStart)) {
            prefix = "";
          } else if (/^\\\\/.test(absoluteStart)) {
            prefix = "\\\\";
          }
          var paths = [absoluteStart];
          var parsed = parse2(absoluteStart);
          while (parsed.dir !== paths[paths.length - 1]) {
            paths.push(parsed.dir);
            parsed = parse2(parsed.dir);
          }
          return paths.reduce(function(dirs, aPath) {
            return dirs.concat(modules.map(function(moduleDir) {
              return path5.resolve(prefix, aPath, moduleDir);
            }));
          }, []);
        };
        module22.exports = function nodeModulesPaths(start, opts, request) {
          var modules = opts && opts.moduleDirectory ? [].concat(opts.moduleDirectory) : ["node_modules"];
          if (opts && typeof opts.paths === "function") {
            return opts.paths(request, start, function() {
              return getNodeModulesDirs(start, modules);
            }, opts);
          }
          var dirs = getNodeModulesDirs(start, modules);
          return opts && opts.paths ? dirs.concat(opts.paths) : dirs;
        };
      }
    });
    var require_normalize_options = __commonJS22({
      "node_modules/resolve/lib/normalize-options.js"(exports22, module22) {
        module22.exports = function(x, opts) {
          return opts || {};
        };
      }
    });
    var require_implementation = __commonJS22({
      "node_modules/function-bind/implementation.js"(exports22, module22) {
        "use strict";
        var ERROR_MESSAGE = "Function.prototype.bind called on incompatible ";
        var slice = Array.prototype.slice;
        var toStr = Object.prototype.toString;
        var funcType = "[object Function]";
        module22.exports = function bind(that) {
          var target = this;
          if (typeof target !== "function" || toStr.call(target) !== funcType) {
            throw new TypeError(ERROR_MESSAGE + target);
          }
          var args = slice.call(arguments, 1);
          var bound;
          var binder = function() {
            if (this instanceof bound) {
              var result = target.apply(this, args.concat(slice.call(arguments)));
              if (Object(result) === result) {
                return result;
              }
              return this;
            } else {
              return target.apply(that, args.concat(slice.call(arguments)));
            }
          };
          var boundLength = Math.max(0, target.length - args.length);
          var boundArgs = [];
          for (var i = 0; i < boundLength; i++) {
            boundArgs.push("$" + i);
          }
          bound = Function("binder", "return function (" + boundArgs.join(",") + "){ return binder.apply(this,arguments); }")(binder);
          if (target.prototype) {
            var Empty = function Empty2() {
            };
            Empty.prototype = target.prototype;
            bound.prototype = new Empty();
            Empty.prototype = null;
          }
          return bound;
        };
      }
    });
    var require_function_bind = __commonJS22({
      "node_modules/function-bind/index.js"(exports22, module22) {
        "use strict";
        var implementation = require_implementation();
        module22.exports = Function.prototype.bind || implementation;
      }
    });
    var require_src2 = __commonJS22({
      "node_modules/has/src/index.js"(exports22, module22) {
        "use strict";
        var bind = require_function_bind();
        module22.exports = bind.call(Function.call, Object.prototype.hasOwnProperty);
      }
    });
    var require_core22 = __commonJS22({
      "node_modules/is-core-module/core.json"(exports22, module22) {
        module22.exports = {
          assert: true,
          "node:assert": [">= 14.18 && < 15", ">= 16"],
          "assert/strict": ">= 15",
          "node:assert/strict": ">= 16",
          async_hooks: ">= 8",
          "node:async_hooks": [">= 14.18 && < 15", ">= 16"],
          buffer_ieee754: ">= 0.5 && < 0.9.7",
          buffer: true,
          "node:buffer": [">= 14.18 && < 15", ">= 16"],
          child_process: true,
          "node:child_process": [">= 14.18 && < 15", ">= 16"],
          cluster: ">= 0.5",
          "node:cluster": [">= 14.18 && < 15", ">= 16"],
          console: true,
          "node:console": [">= 14.18 && < 15", ">= 16"],
          constants: true,
          "node:constants": [">= 14.18 && < 15", ">= 16"],
          crypto: true,
          "node:crypto": [">= 14.18 && < 15", ">= 16"],
          _debug_agent: ">= 1 && < 8",
          _debugger: "< 8",
          dgram: true,
          "node:dgram": [">= 14.18 && < 15", ">= 16"],
          diagnostics_channel: [">= 14.17 && < 15", ">= 15.1"],
          "node:diagnostics_channel": [">= 14.18 && < 15", ">= 16"],
          dns: true,
          "node:dns": [">= 14.18 && < 15", ">= 16"],
          "dns/promises": ">= 15",
          "node:dns/promises": ">= 16",
          domain: ">= 0.7.12",
          "node:domain": [">= 14.18 && < 15", ">= 16"],
          events: true,
          "node:events": [">= 14.18 && < 15", ">= 16"],
          freelist: "< 6",
          fs: true,
          "node:fs": [">= 14.18 && < 15", ">= 16"],
          "fs/promises": [">= 10 && < 10.1", ">= 14"],
          "node:fs/promises": [">= 14.18 && < 15", ">= 16"],
          _http_agent: ">= 0.11.1",
          "node:_http_agent": [">= 14.18 && < 15", ">= 16"],
          _http_client: ">= 0.11.1",
          "node:_http_client": [">= 14.18 && < 15", ">= 16"],
          _http_common: ">= 0.11.1",
          "node:_http_common": [">= 14.18 && < 15", ">= 16"],
          _http_incoming: ">= 0.11.1",
          "node:_http_incoming": [">= 14.18 && < 15", ">= 16"],
          _http_outgoing: ">= 0.11.1",
          "node:_http_outgoing": [">= 14.18 && < 15", ">= 16"],
          _http_server: ">= 0.11.1",
          "node:_http_server": [">= 14.18 && < 15", ">= 16"],
          http: true,
          "node:http": [">= 14.18 && < 15", ">= 16"],
          http2: ">= 8.8",
          "node:http2": [">= 14.18 && < 15", ">= 16"],
          https: true,
          "node:https": [">= 14.18 && < 15", ">= 16"],
          inspector: ">= 8",
          "node:inspector": [">= 14.18 && < 15", ">= 16"],
          _linklist: "< 8",
          module: true,
          "node:module": [">= 14.18 && < 15", ">= 16"],
          net: true,
          "node:net": [">= 14.18 && < 15", ">= 16"],
          "node-inspect/lib/_inspect": ">= 7.6 && < 12",
          "node-inspect/lib/internal/inspect_client": ">= 7.6 && < 12",
          "node-inspect/lib/internal/inspect_repl": ">= 7.6 && < 12",
          os: true,
          "node:os": [">= 14.18 && < 15", ">= 16"],
          path: true,
          "node:path": [">= 14.18 && < 15", ">= 16"],
          "path/posix": ">= 15.3",
          "node:path/posix": ">= 16",
          "path/win32": ">= 15.3",
          "node:path/win32": ">= 16",
          perf_hooks: ">= 8.5",
          "node:perf_hooks": [">= 14.18 && < 15", ">= 16"],
          process: ">= 1",
          "node:process": [">= 14.18 && < 15", ">= 16"],
          punycode: ">= 0.5",
          "node:punycode": [">= 14.18 && < 15", ">= 16"],
          querystring: true,
          "node:querystring": [">= 14.18 && < 15", ">= 16"],
          readline: true,
          "node:readline": [">= 14.18 && < 15", ">= 16"],
          "readline/promises": ">= 17",
          "node:readline/promises": ">= 17",
          repl: true,
          "node:repl": [">= 14.18 && < 15", ">= 16"],
          smalloc: ">= 0.11.5 && < 3",
          _stream_duplex: ">= 0.9.4",
          "node:_stream_duplex": [">= 14.18 && < 15", ">= 16"],
          _stream_transform: ">= 0.9.4",
          "node:_stream_transform": [">= 14.18 && < 15", ">= 16"],
          _stream_wrap: ">= 1.4.1",
          "node:_stream_wrap": [">= 14.18 && < 15", ">= 16"],
          _stream_passthrough: ">= 0.9.4",
          "node:_stream_passthrough": [">= 14.18 && < 15", ">= 16"],
          _stream_readable: ">= 0.9.4",
          "node:_stream_readable": [">= 14.18 && < 15", ">= 16"],
          _stream_writable: ">= 0.9.4",
          "node:_stream_writable": [">= 14.18 && < 15", ">= 16"],
          stream: true,
          "node:stream": [">= 14.18 && < 15", ">= 16"],
          "stream/consumers": ">= 16.7",
          "node:stream/consumers": ">= 16.7",
          "stream/promises": ">= 15",
          "node:stream/promises": ">= 16",
          "stream/web": ">= 16.5",
          "node:stream/web": ">= 16.5",
          string_decoder: true,
          "node:string_decoder": [">= 14.18 && < 15", ">= 16"],
          sys: [">= 0.4 && < 0.7", ">= 0.8"],
          "node:sys": [">= 14.18 && < 15", ">= 16"],
          timers: true,
          "node:timers": [">= 14.18 && < 15", ">= 16"],
          "timers/promises": ">= 15",
          "node:timers/promises": ">= 16",
          _tls_common: ">= 0.11.13",
          "node:_tls_common": [">= 14.18 && < 15", ">= 16"],
          _tls_legacy: ">= 0.11.3 && < 10",
          _tls_wrap: ">= 0.11.3",
          "node:_tls_wrap": [">= 14.18 && < 15", ">= 16"],
          tls: true,
          "node:tls": [">= 14.18 && < 15", ">= 16"],
          trace_events: ">= 10",
          "node:trace_events": [">= 14.18 && < 15", ">= 16"],
          tty: true,
          "node:tty": [">= 14.18 && < 15", ">= 16"],
          url: true,
          "node:url": [">= 14.18 && < 15", ">= 16"],
          util: true,
          "node:util": [">= 14.18 && < 15", ">= 16"],
          "util/types": ">= 15.3",
          "node:util/types": ">= 16",
          "v8/tools/arguments": ">= 10 && < 12",
          "v8/tools/codemap": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/consarray": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/csvparser": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/logreader": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/profile_view": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/splaytree": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          v8: ">= 1",
          "node:v8": [">= 14.18 && < 15", ">= 16"],
          vm: true,
          "node:vm": [">= 14.18 && < 15", ">= 16"],
          wasi: ">= 13.4 && < 13.5",
          worker_threads: ">= 11.7",
          "node:worker_threads": [">= 14.18 && < 15", ">= 16"],
          zlib: ">= 0.5",
          "node:zlib": [">= 14.18 && < 15", ">= 16"]
        };
      }
    });
    var require_is_core_module = __commonJS22({
      "node_modules/is-core-module/index.js"(exports22, module22) {
        "use strict";
        var has = require_src2();
        function specifierIncluded(current, specifier) {
          var nodeParts = current.split(".");
          var parts = specifier.split(" ");
          var op = parts.length > 1 ? parts[0] : "=";
          var versionParts = (parts.length > 1 ? parts[1] : parts[0]).split(".");
          for (var i = 0; i < 3; ++i) {
            var cur = parseInt(nodeParts[i] || 0, 10);
            var ver = parseInt(versionParts[i] || 0, 10);
            if (cur === ver) {
              continue;
            }
            if (op === "<") {
              return cur < ver;
            }
            if (op === ">=") {
              return cur >= ver;
            }
            return false;
          }
          return op === ">=";
        }
        function matchesRange(current, range) {
          var specifiers = range.split(/ ?&& ?/);
          if (specifiers.length === 0) {
            return false;
          }
          for (var i = 0; i < specifiers.length; ++i) {
            if (!specifierIncluded(current, specifiers[i])) {
              return false;
            }
          }
          return true;
        }
        function versionIncluded(nodeVersion, specifierValue) {
          if (typeof specifierValue === "boolean") {
            return specifierValue;
          }
          var current = typeof nodeVersion === "undefined" ? process.versions && process.versions.node : nodeVersion;
          if (typeof current !== "string") {
            throw new TypeError(typeof nodeVersion === "undefined" ? "Unable to determine current node version" : "If provided, a valid node version is required");
          }
          if (specifierValue && typeof specifierValue === "object") {
            for (var i = 0; i < specifierValue.length; ++i) {
              if (matchesRange(current, specifierValue[i])) {
                return true;
              }
            }
            return false;
          }
          return matchesRange(current, specifierValue);
        }
        var data = require_core22();
        module22.exports = function isCore(x, nodeVersion) {
          return has(data, x) && versionIncluded(nodeVersion, data[x]);
        };
      }
    });
    var require_async = __commonJS22({
      "node_modules/resolve/lib/async.js"(exports22, module22) {
        var fs = require("fs");
        var getHomedir = require_homedir();
        var path5 = require("path");
        var caller = require_caller();
        var nodeModulesPaths = require_node_modules_paths();
        var normalizeOptions = require_normalize_options();
        var isCore = require_is_core_module();
        var realpathFS = fs.realpath && typeof fs.realpath.native === "function" ? fs.realpath.native : fs.realpath;
        var homedir = getHomedir();
        var defaultPaths = function() {
          return [path5.join(homedir, ".node_modules"), path5.join(homedir, ".node_libraries")];
        };
        var defaultIsFile = function isFile(file, cb) {
          fs.stat(file, function(err, stat) {
            if (!err) {
              return cb(null, stat.isFile() || stat.isFIFO());
            }
            if (err.code === "ENOENT" || err.code === "ENOTDIR")
              return cb(null, false);
            return cb(err);
          });
        };
        var defaultIsDir = function isDirectory(dir, cb) {
          fs.stat(dir, function(err, stat) {
            if (!err) {
              return cb(null, stat.isDirectory());
            }
            if (err.code === "ENOENT" || err.code === "ENOTDIR")
              return cb(null, false);
            return cb(err);
          });
        };
        var defaultRealpath = function realpath(x, cb) {
          realpathFS(x, function(realpathErr, realPath) {
            if (realpathErr && realpathErr.code !== "ENOENT")
              cb(realpathErr);
            else
              cb(null, realpathErr ? x : realPath);
          });
        };
        var maybeRealpath = function maybeRealpath2(realpath, x, opts, cb) {
          if (opts && opts.preserveSymlinks === false) {
            realpath(x, cb);
          } else {
            cb(null, x);
          }
        };
        var defaultReadPackage = function defaultReadPackage2(readFile, pkgfile, cb) {
          readFile(pkgfile, function(readFileErr, body) {
            if (readFileErr)
              cb(readFileErr);
            else {
              try {
                var pkg = JSON.parse(body);
                cb(null, pkg);
              } catch (jsonErr) {
                cb(null);
              }
            }
          });
        };
        var getPackageCandidates = function getPackageCandidates2(x, start, opts) {
          var dirs = nodeModulesPaths(start, opts, x);
          for (var i = 0; i < dirs.length; i++) {
            dirs[i] = path5.join(dirs[i], x);
          }
          return dirs;
        };
        module22.exports = function resolve(x, options, callback) {
          var cb = callback;
          var opts = options;
          if (typeof options === "function") {
            cb = opts;
            opts = {};
          }
          if (typeof x !== "string") {
            var err = new TypeError("Path must be a string.");
            return process.nextTick(function() {
              cb(err);
            });
          }
          opts = normalizeOptions(x, opts);
          var isFile = opts.isFile || defaultIsFile;
          var isDirectory = opts.isDirectory || defaultIsDir;
          var readFile = opts.readFile || fs.readFile;
          var realpath = opts.realpath || defaultRealpath;
          var readPackage = opts.readPackage || defaultReadPackage;
          if (opts.readFile && opts.readPackage) {
            var conflictErr = new TypeError("`readFile` and `readPackage` are mutually exclusive.");
            return process.nextTick(function() {
              cb(conflictErr);
            });
          }
          var packageIterator = opts.packageIterator;
          var extensions = opts.extensions || [".js"];
          var includeCoreModules = opts.includeCoreModules !== false;
          var basedir = opts.basedir || path5.dirname(caller());
          var parent = opts.filename || basedir;
          opts.paths = opts.paths || defaultPaths();
          var absoluteStart = path5.resolve(basedir);
          maybeRealpath(realpath, absoluteStart, opts, function(err2, realStart) {
            if (err2)
              cb(err2);
            else
              init(realStart);
          });
          var res;
          function init(basedir2) {
            if (/^(?:\.\.?(?:\/|$)|\/|([A-Za-z]:)?[/\\])/.test(x)) {
              res = path5.resolve(basedir2, x);
              if (x === "." || x === ".." || x.slice(-1) === "/")
                res += "/";
              if (/\/$/.test(x) && res === basedir2) {
                loadAsDirectory(res, opts.package, onfile);
              } else
                loadAsFile(res, opts.package, onfile);
            } else if (includeCoreModules && isCore(x)) {
              return cb(null, x);
            } else
              loadNodeModules(x, basedir2, function(err2, n, pkg) {
                if (err2)
                  cb(err2);
                else if (n) {
                  return maybeRealpath(realpath, n, opts, function(err3, realN) {
                    if (err3) {
                      cb(err3);
                    } else {
                      cb(null, realN, pkg);
                    }
                  });
                } else {
                  var moduleError = new Error("Cannot find module '" + x + "' from '" + parent + "'");
                  moduleError.code = "MODULE_NOT_FOUND";
                  cb(moduleError);
                }
              });
          }
          function onfile(err2, m, pkg) {
            if (err2)
              cb(err2);
            else if (m)
              cb(null, m, pkg);
            else
              loadAsDirectory(res, function(err3, d, pkg2) {
                if (err3)
                  cb(err3);
                else if (d) {
                  maybeRealpath(realpath, d, opts, function(err4, realD) {
                    if (err4) {
                      cb(err4);
                    } else {
                      cb(null, realD, pkg2);
                    }
                  });
                } else {
                  var moduleError = new Error("Cannot find module '" + x + "' from '" + parent + "'");
                  moduleError.code = "MODULE_NOT_FOUND";
                  cb(moduleError);
                }
              });
          }
          function loadAsFile(x2, thePackage, callback2) {
            var loadAsFilePackage = thePackage;
            var cb2 = callback2;
            if (typeof loadAsFilePackage === "function") {
              cb2 = loadAsFilePackage;
              loadAsFilePackage = void 0;
            }
            var exts = [""].concat(extensions);
            load2(exts, x2, loadAsFilePackage);
            function load2(exts2, x3, loadPackage) {
              if (exts2.length === 0)
                return cb2(null, void 0, loadPackage);
              var file = x3 + exts2[0];
              var pkg = loadPackage;
              if (pkg)
                onpkg(null, pkg);
              else
                loadpkg(path5.dirname(file), onpkg);
              function onpkg(err2, pkg_, dir) {
                pkg = pkg_;
                if (err2)
                  return cb2(err2);
                if (dir && pkg && opts.pathFilter) {
                  var rfile = path5.relative(dir, file);
                  var rel = rfile.slice(0, rfile.length - exts2[0].length);
                  var r = opts.pathFilter(pkg, x3, rel);
                  if (r)
                    return load2([""].concat(extensions.slice()), path5.resolve(dir, r), pkg);
                }
                isFile(file, onex);
              }
              function onex(err2, ex) {
                if (err2)
                  return cb2(err2);
                if (ex)
                  return cb2(null, file, pkg);
                load2(exts2.slice(1), x3, pkg);
              }
            }
          }
          function loadpkg(dir, cb2) {
            if (dir === "" || dir === "/")
              return cb2(null);
            if (process.platform === "win32" && /^\w:[/\\]*$/.test(dir)) {
              return cb2(null);
            }
            if (/[/\\]node_modules[/\\]*$/.test(dir))
              return cb2(null);
            maybeRealpath(realpath, dir, opts, function(unwrapErr, pkgdir) {
              if (unwrapErr)
                return loadpkg(path5.dirname(dir), cb2);
              var pkgfile = path5.join(pkgdir, "package.json");
              isFile(pkgfile, function(err2, ex) {
                if (!ex)
                  return loadpkg(path5.dirname(dir), cb2);
                readPackage(readFile, pkgfile, function(err3, pkgParam) {
                  if (err3)
                    cb2(err3);
                  var pkg = pkgParam;
                  if (pkg && opts.packageFilter) {
                    pkg = opts.packageFilter(pkg, pkgfile);
                  }
                  cb2(null, pkg, dir);
                });
              });
            });
          }
          function loadAsDirectory(x2, loadAsDirectoryPackage, callback2) {
            var cb2 = callback2;
            var fpkg = loadAsDirectoryPackage;
            if (typeof fpkg === "function") {
              cb2 = fpkg;
              fpkg = opts.package;
            }
            maybeRealpath(realpath, x2, opts, function(unwrapErr, pkgdir) {
              if (unwrapErr)
                return cb2(unwrapErr);
              var pkgfile = path5.join(pkgdir, "package.json");
              isFile(pkgfile, function(err2, ex) {
                if (err2)
                  return cb2(err2);
                if (!ex)
                  return loadAsFile(path5.join(x2, "index"), fpkg, cb2);
                readPackage(readFile, pkgfile, function(err3, pkgParam) {
                  if (err3)
                    return cb2(err3);
                  var pkg = pkgParam;
                  if (pkg && opts.packageFilter) {
                    pkg = opts.packageFilter(pkg, pkgfile);
                  }
                  if (pkg && pkg.main) {
                    if (typeof pkg.main !== "string") {
                      var mainError = new TypeError("package \u201C" + pkg.name + "\u201D `main` must be a string");
                      mainError.code = "INVALID_PACKAGE_MAIN";
                      return cb2(mainError);
                    }
                    if (pkg.main === "." || pkg.main === "./") {
                      pkg.main = "index";
                    }
                    loadAsFile(path5.resolve(x2, pkg.main), pkg, function(err4, m, pkg2) {
                      if (err4)
                        return cb2(err4);
                      if (m)
                        return cb2(null, m, pkg2);
                      if (!pkg2)
                        return loadAsFile(path5.join(x2, "index"), pkg2, cb2);
                      var dir = path5.resolve(x2, pkg2.main);
                      loadAsDirectory(dir, pkg2, function(err5, n, pkg3) {
                        if (err5)
                          return cb2(err5);
                        if (n)
                          return cb2(null, n, pkg3);
                        loadAsFile(path5.join(x2, "index"), pkg3, cb2);
                      });
                    });
                    return;
                  }
                  loadAsFile(path5.join(x2, "/index"), pkg, cb2);
                });
              });
            });
          }
          function processDirs(cb2, dirs) {
            if (dirs.length === 0)
              return cb2(null, void 0);
            var dir = dirs[0];
            isDirectory(path5.dirname(dir), isdir);
            function isdir(err2, isdir2) {
              if (err2)
                return cb2(err2);
              if (!isdir2)
                return processDirs(cb2, dirs.slice(1));
              loadAsFile(dir, opts.package, onfile2);
            }
            function onfile2(err2, m, pkg) {
              if (err2)
                return cb2(err2);
              if (m)
                return cb2(null, m, pkg);
              loadAsDirectory(dir, opts.package, ondir);
            }
            function ondir(err2, n, pkg) {
              if (err2)
                return cb2(err2);
              if (n)
                return cb2(null, n, pkg);
              processDirs(cb2, dirs.slice(1));
            }
          }
          function loadNodeModules(x2, start, cb2) {
            var thunk = function() {
              return getPackageCandidates(x2, start, opts);
            };
            processDirs(cb2, packageIterator ? packageIterator(x2, start, thunk, opts) : thunk());
          }
        };
      }
    });
    var require_core32 = __commonJS22({
      "node_modules/resolve/lib/core.json"(exports22, module22) {
        module22.exports = {
          assert: true,
          "node:assert": [">= 14.18 && < 15", ">= 16"],
          "assert/strict": ">= 15",
          "node:assert/strict": ">= 16",
          async_hooks: ">= 8",
          "node:async_hooks": [">= 14.18 && < 15", ">= 16"],
          buffer_ieee754: ">= 0.5 && < 0.9.7",
          buffer: true,
          "node:buffer": [">= 14.18 && < 15", ">= 16"],
          child_process: true,
          "node:child_process": [">= 14.18 && < 15", ">= 16"],
          cluster: ">= 0.5",
          "node:cluster": [">= 14.18 && < 15", ">= 16"],
          console: true,
          "node:console": [">= 14.18 && < 15", ">= 16"],
          constants: true,
          "node:constants": [">= 14.18 && < 15", ">= 16"],
          crypto: true,
          "node:crypto": [">= 14.18 && < 15", ">= 16"],
          _debug_agent: ">= 1 && < 8",
          _debugger: "< 8",
          dgram: true,
          "node:dgram": [">= 14.18 && < 15", ">= 16"],
          diagnostics_channel: [">= 14.17 && < 15", ">= 15.1"],
          "node:diagnostics_channel": [">= 14.18 && < 15", ">= 16"],
          dns: true,
          "node:dns": [">= 14.18 && < 15", ">= 16"],
          "dns/promises": ">= 15",
          "node:dns/promises": ">= 16",
          domain: ">= 0.7.12",
          "node:domain": [">= 14.18 && < 15", ">= 16"],
          events: true,
          "node:events": [">= 14.18 && < 15", ">= 16"],
          freelist: "< 6",
          fs: true,
          "node:fs": [">= 14.18 && < 15", ">= 16"],
          "fs/promises": [">= 10 && < 10.1", ">= 14"],
          "node:fs/promises": [">= 14.18 && < 15", ">= 16"],
          _http_agent: ">= 0.11.1",
          "node:_http_agent": [">= 14.18 && < 15", ">= 16"],
          _http_client: ">= 0.11.1",
          "node:_http_client": [">= 14.18 && < 15", ">= 16"],
          _http_common: ">= 0.11.1",
          "node:_http_common": [">= 14.18 && < 15", ">= 16"],
          _http_incoming: ">= 0.11.1",
          "node:_http_incoming": [">= 14.18 && < 15", ">= 16"],
          _http_outgoing: ">= 0.11.1",
          "node:_http_outgoing": [">= 14.18 && < 15", ">= 16"],
          _http_server: ">= 0.11.1",
          "node:_http_server": [">= 14.18 && < 15", ">= 16"],
          http: true,
          "node:http": [">= 14.18 && < 15", ">= 16"],
          http2: ">= 8.8",
          "node:http2": [">= 14.18 && < 15", ">= 16"],
          https: true,
          "node:https": [">= 14.18 && < 15", ">= 16"],
          inspector: ">= 8",
          "node:inspector": [">= 14.18 && < 15", ">= 16"],
          _linklist: "< 8",
          module: true,
          "node:module": [">= 14.18 && < 15", ">= 16"],
          net: true,
          "node:net": [">= 14.18 && < 15", ">= 16"],
          "node-inspect/lib/_inspect": ">= 7.6 && < 12",
          "node-inspect/lib/internal/inspect_client": ">= 7.6 && < 12",
          "node-inspect/lib/internal/inspect_repl": ">= 7.6 && < 12",
          os: true,
          "node:os": [">= 14.18 && < 15", ">= 16"],
          path: true,
          "node:path": [">= 14.18 && < 15", ">= 16"],
          "path/posix": ">= 15.3",
          "node:path/posix": ">= 16",
          "path/win32": ">= 15.3",
          "node:path/win32": ">= 16",
          perf_hooks: ">= 8.5",
          "node:perf_hooks": [">= 14.18 && < 15", ">= 16"],
          process: ">= 1",
          "node:process": [">= 14.18 && < 15", ">= 16"],
          punycode: ">= 0.5",
          "node:punycode": [">= 14.18 && < 15", ">= 16"],
          querystring: true,
          "node:querystring": [">= 14.18 && < 15", ">= 16"],
          readline: true,
          "node:readline": [">= 14.18 && < 15", ">= 16"],
          "readline/promises": ">= 17",
          "node:readline/promises": ">= 17",
          repl: true,
          "node:repl": [">= 14.18 && < 15", ">= 16"],
          smalloc: ">= 0.11.5 && < 3",
          _stream_duplex: ">= 0.9.4",
          "node:_stream_duplex": [">= 14.18 && < 15", ">= 16"],
          _stream_transform: ">= 0.9.4",
          "node:_stream_transform": [">= 14.18 && < 15", ">= 16"],
          _stream_wrap: ">= 1.4.1",
          "node:_stream_wrap": [">= 14.18 && < 15", ">= 16"],
          _stream_passthrough: ">= 0.9.4",
          "node:_stream_passthrough": [">= 14.18 && < 15", ">= 16"],
          _stream_readable: ">= 0.9.4",
          "node:_stream_readable": [">= 14.18 && < 15", ">= 16"],
          _stream_writable: ">= 0.9.4",
          "node:_stream_writable": [">= 14.18 && < 15", ">= 16"],
          stream: true,
          "node:stream": [">= 14.18 && < 15", ">= 16"],
          "stream/consumers": ">= 16.7",
          "node:stream/consumers": ">= 16.7",
          "stream/promises": ">= 15",
          "node:stream/promises": ">= 16",
          "stream/web": ">= 16.5",
          "node:stream/web": ">= 16.5",
          string_decoder: true,
          "node:string_decoder": [">= 14.18 && < 15", ">= 16"],
          sys: [">= 0.4 && < 0.7", ">= 0.8"],
          "node:sys": [">= 14.18 && < 15", ">= 16"],
          timers: true,
          "node:timers": [">= 14.18 && < 15", ">= 16"],
          "timers/promises": ">= 15",
          "node:timers/promises": ">= 16",
          _tls_common: ">= 0.11.13",
          "node:_tls_common": [">= 14.18 && < 15", ">= 16"],
          _tls_legacy: ">= 0.11.3 && < 10",
          _tls_wrap: ">= 0.11.3",
          "node:_tls_wrap": [">= 14.18 && < 15", ">= 16"],
          tls: true,
          "node:tls": [">= 14.18 && < 15", ">= 16"],
          trace_events: ">= 10",
          "node:trace_events": [">= 14.18 && < 15", ">= 16"],
          tty: true,
          "node:tty": [">= 14.18 && < 15", ">= 16"],
          url: true,
          "node:url": [">= 14.18 && < 15", ">= 16"],
          util: true,
          "node:util": [">= 14.18 && < 15", ">= 16"],
          "util/types": ">= 15.3",
          "node:util/types": ">= 16",
          "v8/tools/arguments": ">= 10 && < 12",
          "v8/tools/codemap": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/consarray": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/csvparser": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/logreader": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/profile_view": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/splaytree": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          v8: ">= 1",
          "node:v8": [">= 14.18 && < 15", ">= 16"],
          vm: true,
          "node:vm": [">= 14.18 && < 15", ">= 16"],
          wasi: ">= 13.4 && < 13.5",
          worker_threads: ">= 11.7",
          "node:worker_threads": [">= 14.18 && < 15", ">= 16"],
          zlib: ">= 0.5",
          "node:zlib": [">= 14.18 && < 15", ">= 16"]
        };
      }
    });
    var require_core42 = __commonJS22({
      "node_modules/resolve/lib/core.js"(exports22, module22) {
        var current = process.versions && process.versions.node && process.versions.node.split(".") || [];
        function specifierIncluded(specifier) {
          var parts = specifier.split(" ");
          var op = parts.length > 1 ? parts[0] : "=";
          var versionParts = (parts.length > 1 ? parts[1] : parts[0]).split(".");
          for (var i = 0; i < 3; ++i) {
            var cur = parseInt(current[i] || 0, 10);
            var ver = parseInt(versionParts[i] || 0, 10);
            if (cur === ver) {
              continue;
            }
            if (op === "<") {
              return cur < ver;
            } else if (op === ">=") {
              return cur >= ver;
            }
            return false;
          }
          return op === ">=";
        }
        function matchesRange(range) {
          var specifiers = range.split(/ ?&& ?/);
          if (specifiers.length === 0) {
            return false;
          }
          for (var i = 0; i < specifiers.length; ++i) {
            if (!specifierIncluded(specifiers[i])) {
              return false;
            }
          }
          return true;
        }
        function versionIncluded(specifierValue) {
          if (typeof specifierValue === "boolean") {
            return specifierValue;
          }
          if (specifierValue && typeof specifierValue === "object") {
            for (var i = 0; i < specifierValue.length; ++i) {
              if (matchesRange(specifierValue[i])) {
                return true;
              }
            }
            return false;
          }
          return matchesRange(specifierValue);
        }
        var data = require_core32();
        var core22 = {};
        for (mod in data) {
          if (Object.prototype.hasOwnProperty.call(data, mod)) {
            core22[mod] = versionIncluded(data[mod]);
          }
        }
        var mod;
        module22.exports = core22;
      }
    });
    var require_is_core = __commonJS22({
      "node_modules/resolve/lib/is-core.js"(exports22, module22) {
        var isCoreModule = require_is_core_module();
        module22.exports = function isCore(x) {
          return isCoreModule(x);
        };
      }
    });
    var require_sync = __commonJS22({
      "node_modules/resolve/lib/sync.js"(exports22, module22) {
        var isCore = require_is_core_module();
        var fs = require("fs");
        var path5 = require("path");
        var getHomedir = require_homedir();
        var caller = require_caller();
        var nodeModulesPaths = require_node_modules_paths();
        var normalizeOptions = require_normalize_options();
        var realpathFS = fs.realpathSync && typeof fs.realpathSync.native === "function" ? fs.realpathSync.native : fs.realpathSync;
        var homedir = getHomedir();
        var defaultPaths = function() {
          return [path5.join(homedir, ".node_modules"), path5.join(homedir, ".node_libraries")];
        };
        var defaultIsFile = function isFile(file) {
          try {
            var stat = fs.statSync(file, {
              throwIfNoEntry: false
            });
          } catch (e) {
            if (e && (e.code === "ENOENT" || e.code === "ENOTDIR"))
              return false;
            throw e;
          }
          return !!stat && (stat.isFile() || stat.isFIFO());
        };
        var defaultIsDir = function isDirectory(dir) {
          try {
            var stat = fs.statSync(dir, {
              throwIfNoEntry: false
            });
          } catch (e) {
            if (e && (e.code === "ENOENT" || e.code === "ENOTDIR"))
              return false;
            throw e;
          }
          return !!stat && stat.isDirectory();
        };
        var defaultRealpathSync = function realpathSync(x) {
          try {
            return realpathFS(x);
          } catch (realpathErr) {
            if (realpathErr.code !== "ENOENT") {
              throw realpathErr;
            }
          }
          return x;
        };
        var maybeRealpathSync = function maybeRealpathSync2(realpathSync, x, opts) {
          if (opts && opts.preserveSymlinks === false) {
            return realpathSync(x);
          }
          return x;
        };
        var defaultReadPackageSync = function defaultReadPackageSync2(readFileSync, pkgfile) {
          var body = readFileSync(pkgfile);
          try {
            var pkg = JSON.parse(body);
            return pkg;
          } catch (jsonErr) {
          }
        };
        var getPackageCandidates = function getPackageCandidates2(x, start, opts) {
          var dirs = nodeModulesPaths(start, opts, x);
          for (var i = 0; i < dirs.length; i++) {
            dirs[i] = path5.join(dirs[i], x);
          }
          return dirs;
        };
        module22.exports = function resolveSync(x, options) {
          if (typeof x !== "string") {
            throw new TypeError("Path must be a string.");
          }
          var opts = normalizeOptions(x, options);
          var isFile = opts.isFile || defaultIsFile;
          var readFileSync = opts.readFileSync || fs.readFileSync;
          var isDirectory = opts.isDirectory || defaultIsDir;
          var realpathSync = opts.realpathSync || defaultRealpathSync;
          var readPackageSync = opts.readPackageSync || defaultReadPackageSync;
          if (opts.readFileSync && opts.readPackageSync) {
            throw new TypeError("`readFileSync` and `readPackageSync` are mutually exclusive.");
          }
          var packageIterator = opts.packageIterator;
          var extensions = opts.extensions || [".js"];
          var includeCoreModules = opts.includeCoreModules !== false;
          var basedir = opts.basedir || path5.dirname(caller());
          var parent = opts.filename || basedir;
          opts.paths = opts.paths || defaultPaths();
          var absoluteStart = maybeRealpathSync(realpathSync, path5.resolve(basedir), opts);
          if (/^(?:\.\.?(?:\/|$)|\/|([A-Za-z]:)?[/\\])/.test(x)) {
            var res = path5.resolve(absoluteStart, x);
            if (x === "." || x === ".." || x.slice(-1) === "/")
              res += "/";
            var m = loadAsFileSync(res) || loadAsDirectorySync(res);
            if (m)
              return maybeRealpathSync(realpathSync, m, opts);
          } else if (includeCoreModules && isCore(x)) {
            return x;
          } else {
            var n = loadNodeModulesSync(x, absoluteStart);
            if (n)
              return maybeRealpathSync(realpathSync, n, opts);
          }
          var err = new Error("Cannot find module '" + x + "' from '" + parent + "'");
          err.code = "MODULE_NOT_FOUND";
          throw err;
          function loadAsFileSync(x2) {
            var pkg = loadpkg(path5.dirname(x2));
            if (pkg && pkg.dir && pkg.pkg && opts.pathFilter) {
              var rfile = path5.relative(pkg.dir, x2);
              var r = opts.pathFilter(pkg.pkg, x2, rfile);
              if (r) {
                x2 = path5.resolve(pkg.dir, r);
              }
            }
            if (isFile(x2)) {
              return x2;
            }
            for (var i = 0; i < extensions.length; i++) {
              var file = x2 + extensions[i];
              if (isFile(file)) {
                return file;
              }
            }
          }
          function loadpkg(dir) {
            if (dir === "" || dir === "/")
              return;
            if (process.platform === "win32" && /^\w:[/\\]*$/.test(dir)) {
              return;
            }
            if (/[/\\]node_modules[/\\]*$/.test(dir))
              return;
            var pkgfile = path5.join(maybeRealpathSync(realpathSync, dir, opts), "package.json");
            if (!isFile(pkgfile)) {
              return loadpkg(path5.dirname(dir));
            }
            var pkg = readPackageSync(readFileSync, pkgfile);
            if (pkg && opts.packageFilter) {
              pkg = opts.packageFilter(pkg, dir);
            }
            return {
              pkg,
              dir
            };
          }
          function loadAsDirectorySync(x2) {
            var pkgfile = path5.join(maybeRealpathSync(realpathSync, x2, opts), "/package.json");
            if (isFile(pkgfile)) {
              try {
                var pkg = readPackageSync(readFileSync, pkgfile);
              } catch (e) {
              }
              if (pkg && opts.packageFilter) {
                pkg = opts.packageFilter(pkg, x2);
              }
              if (pkg && pkg.main) {
                if (typeof pkg.main !== "string") {
                  var mainError = new TypeError("package \u201C" + pkg.name + "\u201D `main` must be a string");
                  mainError.code = "INVALID_PACKAGE_MAIN";
                  throw mainError;
                }
                if (pkg.main === "." || pkg.main === "./") {
                  pkg.main = "index";
                }
                try {
                  var m2 = loadAsFileSync(path5.resolve(x2, pkg.main));
                  if (m2)
                    return m2;
                  var n2 = loadAsDirectorySync(path5.resolve(x2, pkg.main));
                  if (n2)
                    return n2;
                } catch (e) {
                }
              }
            }
            return loadAsFileSync(path5.join(x2, "/index"));
          }
          function loadNodeModulesSync(x2, start) {
            var thunk = function() {
              return getPackageCandidates(x2, start, opts);
            };
            var dirs = packageIterator ? packageIterator(x2, start, thunk, opts) : thunk();
            for (var i = 0; i < dirs.length; i++) {
              var dir = dirs[i];
              if (isDirectory(path5.dirname(dir))) {
                var m2 = loadAsFileSync(dir);
                if (m2)
                  return m2;
                var n2 = loadAsDirectorySync(dir);
                if (n2)
                  return n2;
              }
            }
          }
        };
      }
    });
    var require_resolve3 = __commonJS22({
      "node_modules/resolve/index.js"(exports22, module22) {
        var async = require_async();
        async.core = require_core42();
        async.isCore = require_is_core();
        async.sync = require_sync();
        module22.exports = async;
      }
    });
    var require_resolve22 = __commonJS22({
      "src/common/resolve.js"(exports22, module22) {
        "use strict";
        var {
          resolve
        } = require;
        if (resolve.length === 1 || process.env.PRETTIER_FALLBACK_RESOLVE) {
          resolve = (id, options) => {
            let basedir;
            if (options && options.paths && options.paths.length === 1) {
              basedir = options.paths[0];
            }
            return require_resolve3().sync(id, {
              basedir
            });
          };
        }
        module22.exports = resolve;
      }
    });
    function mimicFunction(to, from, {
      ignoreNonConfigurable = false
    } = {}) {
      const {
        name
      } = to;
      for (const property4 of Reflect.ownKeys(from)) {
        copyProperty(to, from, property4, ignoreNonConfigurable);
      }
      changePrototype(to, from);
      changeToString(to, from, name);
      return to;
    }
    var copyProperty;
    var canCopyProperty;
    var changePrototype;
    var wrappedToString;
    var toStringDescriptor;
    var toStringName;
    var changeToString;
    var init_mimic_fn = __esm2({
      "node_modules/mimic-fn/index.js"() {
        copyProperty = (to, from, property4, ignoreNonConfigurable) => {
          if (property4 === "length" || property4 === "prototype") {
            return;
          }
          if (property4 === "arguments" || property4 === "caller") {
            return;
          }
          const toDescriptor = Object.getOwnPropertyDescriptor(to, property4);
          const fromDescriptor = Object.getOwnPropertyDescriptor(from, property4);
          if (!canCopyProperty(toDescriptor, fromDescriptor) && ignoreNonConfigurable) {
            return;
          }
          Object.defineProperty(to, property4, fromDescriptor);
        };
        canCopyProperty = function(toDescriptor, fromDescriptor) {
          return toDescriptor === void 0 || toDescriptor.configurable || toDescriptor.writable === fromDescriptor.writable && toDescriptor.enumerable === fromDescriptor.enumerable && toDescriptor.configurable === fromDescriptor.configurable && (toDescriptor.writable || toDescriptor.value === fromDescriptor.value);
        };
        changePrototype = (to, from) => {
          const fromPrototype = Object.getPrototypeOf(from);
          if (fromPrototype === Object.getPrototypeOf(to)) {
            return;
          }
          Object.setPrototypeOf(to, fromPrototype);
        };
        wrappedToString = (withName, fromBody) => `/* Wrapped ${withName}*/
${fromBody}`;
        toStringDescriptor = Object.getOwnPropertyDescriptor(Function.prototype, "toString");
        toStringName = Object.getOwnPropertyDescriptor(Function.prototype.toString, "name");
        changeToString = (to, from, name) => {
          const withName = name === "" ? "" : `with ${name.trim()}() `;
          const newToString = wrappedToString.bind(null, withName, from.toString());
          Object.defineProperty(newToString, "name", toStringName);
          Object.defineProperty(to, "toString", Object.assign(Object.assign({}, toStringDescriptor), {}, {
            value: newToString
          }));
        };
      }
    });
    var require_p_defer = __commonJS22({
      "node_modules/p-defer/index.js"(exports22, module22) {
        "use strict";
        module22.exports = () => {
          const ret = {};
          ret.promise = new Promise((resolve, reject) => {
            ret.resolve = resolve;
            ret.reject = reject;
          });
          return ret;
        };
      }
    });
    var require_dist2 = __commonJS22({
      "node_modules/map-age-cleaner/dist/index.js"(exports22, module22) {
        "use strict";
        var __awaiter2 = exports22 && exports22.__awaiter || function(thisArg, _arguments, P, generator) {
          return new (P || (P = Promise))(function(resolve, reject) {
            function fulfilled(value) {
              try {
                step(generator.next(value));
              } catch (e) {
                reject(e);
              }
            }
            function rejected(value) {
              try {
                step(generator["throw"](value));
              } catch (e) {
                reject(e);
              }
            }
            function step(result) {
              result.done ? resolve(result.value) : new P(function(resolve2) {
                resolve2(result.value);
              }).then(fulfilled, rejected);
            }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
          });
        };
        var __importDefault2 = exports22 && exports22.__importDefault || function(mod) {
          return mod && mod.__esModule ? mod : {
            "default": mod
          };
        };
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var p_defer_1 = __importDefault2(require_p_defer());
        function mapAgeCleaner2(map2, property4 = "maxAge") {
          let processingKey;
          let processingTimer;
          let processingDeferred;
          const cleanup = () => __awaiter2(this, void 0, void 0, function* () {
            if (processingKey !== void 0) {
              return;
            }
            const setupTimer = (item) => __awaiter2(this, void 0, void 0, function* () {
              processingDeferred = p_defer_1.default();
              const delay = item[1][property4] - Date.now();
              if (delay <= 0) {
                map2.delete(item[0]);
                processingDeferred.resolve();
                return;
              }
              processingKey = item[0];
              processingTimer = setTimeout(() => {
                map2.delete(item[0]);
                if (processingDeferred) {
                  processingDeferred.resolve();
                }
              }, delay);
              if (typeof processingTimer.unref === "function") {
                processingTimer.unref();
              }
              return processingDeferred.promise;
            });
            try {
              for (const entry of map2) {
                yield setupTimer(entry);
              }
            } catch (_a) {
            }
            processingKey = void 0;
          });
          const reset = () => {
            processingKey = void 0;
            if (processingTimer !== void 0) {
              clearTimeout(processingTimer);
              processingTimer = void 0;
            }
            if (processingDeferred !== void 0) {
              processingDeferred.reject(void 0);
              processingDeferred = void 0;
            }
          };
          const originalSet = map2.set.bind(map2);
          map2.set = (key, value) => {
            if (map2.has(key)) {
              map2.delete(key);
            }
            const result = originalSet(key, value);
            if (processingKey && processingKey === key) {
              reset();
            }
            cleanup();
            return result;
          };
          cleanup();
          return map2;
        }
        exports22.default = mapAgeCleaner2;
        module22.exports = mapAgeCleaner2;
        module22.exports.default = mapAgeCleaner2;
      }
    });
    var dist_exports = {};
    __export2(dist_exports, {
      default: () => mem,
      memClear: () => memClear,
      memDecorator: () => memDecorator
    });
    function mem(fn, {
      cacheKey,
      cache = /* @__PURE__ */ new Map(),
      maxAge
    } = {}) {
      if (typeof maxAge === "number") {
        (0, import_map_age_cleaner.default)(cache);
      }
      const memoized = function(...arguments_) {
        const key = cacheKey ? cacheKey(arguments_) : arguments_[0];
        const cacheItem = cache.get(key);
        if (cacheItem) {
          return cacheItem.data;
        }
        const result = fn.apply(this, arguments_);
        cache.set(key, {
          data: result,
          maxAge: maxAge ? Date.now() + maxAge : Number.POSITIVE_INFINITY
        });
        return result;
      };
      mimicFunction(memoized, fn, {
        ignoreNonConfigurable: true
      });
      cacheStore.set(memoized, cache);
      return memoized;
    }
    function memDecorator(options = {}) {
      const instanceMap = /* @__PURE__ */ new WeakMap();
      return (target, propertyKey, descriptor) => {
        const input = target[propertyKey];
        if (typeof input !== "function") {
          throw new TypeError("The decorated value must be a function");
        }
        delete descriptor.value;
        delete descriptor.writable;
        descriptor.get = function() {
          if (!instanceMap.has(this)) {
            const value = mem(input, options);
            instanceMap.set(this, value);
            return value;
          }
          return instanceMap.get(this);
        };
      };
    }
    function memClear(fn) {
      const cache = cacheStore.get(fn);
      if (!cache) {
        throw new TypeError("Can't clear a function that was not memoized!");
      }
      if (typeof cache.clear !== "function") {
        throw new TypeError("The cache Map can't be cleared!");
      }
      cache.clear();
    }
    var import_map_age_cleaner;
    var cacheStore;
    var init_dist = __esm2({
      "node_modules/mem/dist/index.js"() {
        init_mimic_fn();
        import_map_age_cleaner = __toESM2(require_dist2());
        cacheStore = /* @__PURE__ */ new WeakMap();
      }
    });
    var require_pseudomap = __commonJS22({
      "node_modules/pseudomap/pseudomap.js"(exports22, module22) {
        var hasOwnProperty13 = Object.prototype.hasOwnProperty;
        module22.exports = PseudoMap;
        function PseudoMap(set22) {
          if (!(this instanceof PseudoMap))
            throw new TypeError("Constructor PseudoMap requires 'new'");
          this.clear();
          if (set22) {
            if (set22 instanceof PseudoMap || typeof Map === "function" && set22 instanceof Map)
              set22.forEach(function(value, key) {
                this.set(key, value);
              }, this);
            else if (Array.isArray(set22))
              set22.forEach(function(kv) {
                this.set(kv[0], kv[1]);
              }, this);
            else
              throw new TypeError("invalid argument");
          }
        }
        PseudoMap.prototype.forEach = function(fn, thisp) {
          thisp = thisp || this;
          Object.keys(this._data).forEach(function(k) {
            if (k !== "size")
              fn.call(thisp, this._data[k].value, this._data[k].key);
          }, this);
        };
        PseudoMap.prototype.has = function(k) {
          return !!find3(this._data, k);
        };
        PseudoMap.prototype.get = function(k) {
          var res = find3(this._data, k);
          return res && res.value;
        };
        PseudoMap.prototype.set = function(k, v) {
          set4(this._data, k, v);
        };
        PseudoMap.prototype.delete = function(k) {
          var res = find3(this._data, k);
          if (res) {
            delete this._data[res._index];
            this._data.size--;
          }
        };
        PseudoMap.prototype.clear = function() {
          var data = /* @__PURE__ */ Object.create(null);
          data.size = 0;
          Object.defineProperty(this, "_data", {
            value: data,
            enumerable: false,
            configurable: true,
            writable: false
          });
        };
        Object.defineProperty(PseudoMap.prototype, "size", {
          get: function() {
            return this._data.size;
          },
          set: function(n) {
          },
          enumerable: true,
          configurable: true
        });
        PseudoMap.prototype.values = PseudoMap.prototype.keys = PseudoMap.prototype.entries = function() {
          throw new Error("iterators are not implemented in this version");
        };
        function same(a, b) {
          return a === b || a !== a && b !== b;
        }
        function Entry(k, v, i) {
          this.key = k;
          this.value = v;
          this._index = i;
        }
        function find3(data, k) {
          for (var i = 0, s = "_" + k, key = s; hasOwnProperty13.call(data, key); key = s + i++) {
            if (same(data[key].key, k))
              return data[key];
          }
        }
        function set4(data, k, v) {
          for (var i = 0, s = "_" + k, key = s; hasOwnProperty13.call(data, key); key = s + i++) {
            if (same(data[key].key, k)) {
              data[key].value = v;
              return;
            }
          }
          data.size++;
          data[key] = new Entry(k, v, key);
        }
      }
    });
    var require_map4 = __commonJS22({
      "node_modules/pseudomap/map.js"(exports22, module22) {
        if (process.env.npm_package_name === "pseudomap" && process.env.npm_lifecycle_script === "test")
          process.env.TEST_PSEUDOMAP = "true";
        if (typeof Map === "function" && !process.env.TEST_PSEUDOMAP) {
          module22.exports = Map;
        } else {
          module22.exports = require_pseudomap();
        }
      }
    });
    var require_yallist = __commonJS22({
      "node_modules/editorconfig/node_modules/yallist/yallist.js"(exports22, module22) {
        module22.exports = Yallist;
        Yallist.Node = Node;
        Yallist.create = Yallist;
        function Yallist(list3) {
          var self2 = this;
          if (!(self2 instanceof Yallist)) {
            self2 = new Yallist();
          }
          self2.tail = null;
          self2.head = null;
          self2.length = 0;
          if (list3 && typeof list3.forEach === "function") {
            list3.forEach(function(item) {
              self2.push(item);
            });
          } else if (arguments.length > 0) {
            for (var i = 0, l = arguments.length; i < l; i++) {
              self2.push(arguments[i]);
            }
          }
          return self2;
        }
        Yallist.prototype.removeNode = function(node) {
          if (node.list !== this) {
            throw new Error("removing node which does not belong to this list");
          }
          var next = node.next;
          var prev = node.prev;
          if (next) {
            next.prev = prev;
          }
          if (prev) {
            prev.next = next;
          }
          if (node === this.head) {
            this.head = next;
          }
          if (node === this.tail) {
            this.tail = prev;
          }
          node.list.length--;
          node.next = null;
          node.prev = null;
          node.list = null;
        };
        Yallist.prototype.unshiftNode = function(node) {
          if (node === this.head) {
            return;
          }
          if (node.list) {
            node.list.removeNode(node);
          }
          var head = this.head;
          node.list = this;
          node.next = head;
          if (head) {
            head.prev = node;
          }
          this.head = node;
          if (!this.tail) {
            this.tail = node;
          }
          this.length++;
        };
        Yallist.prototype.pushNode = function(node) {
          if (node === this.tail) {
            return;
          }
          if (node.list) {
            node.list.removeNode(node);
          }
          var tail = this.tail;
          node.list = this;
          node.prev = tail;
          if (tail) {
            tail.next = node;
          }
          this.tail = node;
          if (!this.head) {
            this.head = node;
          }
          this.length++;
        };
        Yallist.prototype.push = function() {
          for (var i = 0, l = arguments.length; i < l; i++) {
            push(this, arguments[i]);
          }
          return this.length;
        };
        Yallist.prototype.unshift = function() {
          for (var i = 0, l = arguments.length; i < l; i++) {
            unshift(this, arguments[i]);
          }
          return this.length;
        };
        Yallist.prototype.pop = function() {
          if (!this.tail) {
            return void 0;
          }
          var res = this.tail.value;
          this.tail = this.tail.prev;
          if (this.tail) {
            this.tail.next = null;
          } else {
            this.head = null;
          }
          this.length--;
          return res;
        };
        Yallist.prototype.shift = function() {
          if (!this.head) {
            return void 0;
          }
          var res = this.head.value;
          this.head = this.head.next;
          if (this.head) {
            this.head.prev = null;
          } else {
            this.tail = null;
          }
          this.length--;
          return res;
        };
        Yallist.prototype.forEach = function(fn, thisp) {
          thisp = thisp || this;
          for (var walker = this.head, i = 0; walker !== null; i++) {
            fn.call(thisp, walker.value, i, this);
            walker = walker.next;
          }
        };
        Yallist.prototype.forEachReverse = function(fn, thisp) {
          thisp = thisp || this;
          for (var walker = this.tail, i = this.length - 1; walker !== null; i--) {
            fn.call(thisp, walker.value, i, this);
            walker = walker.prev;
          }
        };
        Yallist.prototype.get = function(n) {
          for (var i = 0, walker = this.head; walker !== null && i < n; i++) {
            walker = walker.next;
          }
          if (i === n && walker !== null) {
            return walker.value;
          }
        };
        Yallist.prototype.getReverse = function(n) {
          for (var i = 0, walker = this.tail; walker !== null && i < n; i++) {
            walker = walker.prev;
          }
          if (i === n && walker !== null) {
            return walker.value;
          }
        };
        Yallist.prototype.map = function(fn, thisp) {
          thisp = thisp || this;
          var res = new Yallist();
          for (var walker = this.head; walker !== null; ) {
            res.push(fn.call(thisp, walker.value, this));
            walker = walker.next;
          }
          return res;
        };
        Yallist.prototype.mapReverse = function(fn, thisp) {
          thisp = thisp || this;
          var res = new Yallist();
          for (var walker = this.tail; walker !== null; ) {
            res.push(fn.call(thisp, walker.value, this));
            walker = walker.prev;
          }
          return res;
        };
        Yallist.prototype.reduce = function(fn, initial) {
          var acc;
          var walker = this.head;
          if (arguments.length > 1) {
            acc = initial;
          } else if (this.head) {
            walker = this.head.next;
            acc = this.head.value;
          } else {
            throw new TypeError("Reduce of empty list with no initial value");
          }
          for (var i = 0; walker !== null; i++) {
            acc = fn(acc, walker.value, i);
            walker = walker.next;
          }
          return acc;
        };
        Yallist.prototype.reduceReverse = function(fn, initial) {
          var acc;
          var walker = this.tail;
          if (arguments.length > 1) {
            acc = initial;
          } else if (this.tail) {
            walker = this.tail.prev;
            acc = this.tail.value;
          } else {
            throw new TypeError("Reduce of empty list with no initial value");
          }
          for (var i = this.length - 1; walker !== null; i--) {
            acc = fn(acc, walker.value, i);
            walker = walker.prev;
          }
          return acc;
        };
        Yallist.prototype.toArray = function() {
          var arr = new Array(this.length);
          for (var i = 0, walker = this.head; walker !== null; i++) {
            arr[i] = walker.value;
            walker = walker.next;
          }
          return arr;
        };
        Yallist.prototype.toArrayReverse = function() {
          var arr = new Array(this.length);
          for (var i = 0, walker = this.tail; walker !== null; i++) {
            arr[i] = walker.value;
            walker = walker.prev;
          }
          return arr;
        };
        Yallist.prototype.slice = function(from, to) {
          to = to || this.length;
          if (to < 0) {
            to += this.length;
          }
          from = from || 0;
          if (from < 0) {
            from += this.length;
          }
          var ret = new Yallist();
          if (to < from || to < 0) {
            return ret;
          }
          if (from < 0) {
            from = 0;
          }
          if (to > this.length) {
            to = this.length;
          }
          for (var i = 0, walker = this.head; walker !== null && i < from; i++) {
            walker = walker.next;
          }
          for (; walker !== null && i < to; i++, walker = walker.next) {
            ret.push(walker.value);
          }
          return ret;
        };
        Yallist.prototype.sliceReverse = function(from, to) {
          to = to || this.length;
          if (to < 0) {
            to += this.length;
          }
          from = from || 0;
          if (from < 0) {
            from += this.length;
          }
          var ret = new Yallist();
          if (to < from || to < 0) {
            return ret;
          }
          if (from < 0) {
            from = 0;
          }
          if (to > this.length) {
            to = this.length;
          }
          for (var i = this.length, walker = this.tail; walker !== null && i > to; i--) {
            walker = walker.prev;
          }
          for (; walker !== null && i > from; i--, walker = walker.prev) {
            ret.push(walker.value);
          }
          return ret;
        };
        Yallist.prototype.reverse = function() {
          var head = this.head;
          var tail = this.tail;
          for (var walker = head; walker !== null; walker = walker.prev) {
            var p = walker.prev;
            walker.prev = walker.next;
            walker.next = p;
          }
          this.head = tail;
          this.tail = head;
          return this;
        };
        function push(self2, item) {
          self2.tail = new Node(item, self2.tail, null, self2);
          if (!self2.head) {
            self2.head = self2.tail;
          }
          self2.length++;
        }
        function unshift(self2, item) {
          self2.head = new Node(item, null, self2.head, self2);
          if (!self2.tail) {
            self2.tail = self2.head;
          }
          self2.length++;
        }
        function Node(value, prev, next, list3) {
          if (!(this instanceof Node)) {
            return new Node(value, prev, next, list3);
          }
          this.list = list3;
          this.value = value;
          if (prev) {
            prev.next = this;
            this.prev = prev;
          } else {
            this.prev = null;
          }
          if (next) {
            next.prev = this;
            this.next = next;
          } else {
            this.next = null;
          }
        }
      }
    });
    var require_lru_cache = __commonJS22({
      "node_modules/editorconfig/node_modules/lru-cache/index.js"(exports22, module22) {
        "use strict";
        module22.exports = LRUCache;
        var Map22 = require_map4();
        var util2 = require("util");
        var Yallist = require_yallist();
        var hasSymbol = typeof Symbol === "function" && process.env._nodeLRUCacheForceNoSymbol !== "1";
        var makeSymbol;
        if (hasSymbol) {
          makeSymbol = function(key) {
            return Symbol(key);
          };
        } else {
          makeSymbol = function(key) {
            return "_" + key;
          };
        }
        var MAX = makeSymbol("max");
        var LENGTH = makeSymbol("length");
        var LENGTH_CALCULATOR = makeSymbol("lengthCalculator");
        var ALLOW_STALE = makeSymbol("allowStale");
        var MAX_AGE = makeSymbol("maxAge");
        var DISPOSE = makeSymbol("dispose");
        var NO_DISPOSE_ON_SET = makeSymbol("noDisposeOnSet");
        var LRU_LIST = makeSymbol("lruList");
        var CACHE = makeSymbol("cache");
        function naiveLength() {
          return 1;
        }
        function LRUCache(options) {
          if (!(this instanceof LRUCache)) {
            return new LRUCache(options);
          }
          if (typeof options === "number") {
            options = {
              max: options
            };
          }
          if (!options) {
            options = {};
          }
          var max = this[MAX] = options.max;
          if (!max || !(typeof max === "number") || max <= 0) {
            this[MAX] = Infinity;
          }
          var lc = options.length || naiveLength;
          if (typeof lc !== "function") {
            lc = naiveLength;
          }
          this[LENGTH_CALCULATOR] = lc;
          this[ALLOW_STALE] = options.stale || false;
          this[MAX_AGE] = options.maxAge || 0;
          this[DISPOSE] = options.dispose;
          this[NO_DISPOSE_ON_SET] = options.noDisposeOnSet || false;
          this.reset();
        }
        Object.defineProperty(LRUCache.prototype, "max", {
          set: function(mL) {
            if (!mL || !(typeof mL === "number") || mL <= 0) {
              mL = Infinity;
            }
            this[MAX] = mL;
            trim(this);
          },
          get: function() {
            return this[MAX];
          },
          enumerable: true
        });
        Object.defineProperty(LRUCache.prototype, "allowStale", {
          set: function(allowStale) {
            this[ALLOW_STALE] = !!allowStale;
          },
          get: function() {
            return this[ALLOW_STALE];
          },
          enumerable: true
        });
        Object.defineProperty(LRUCache.prototype, "maxAge", {
          set: function(mA) {
            if (!mA || !(typeof mA === "number") || mA < 0) {
              mA = 0;
            }
            this[MAX_AGE] = mA;
            trim(this);
          },
          get: function() {
            return this[MAX_AGE];
          },
          enumerable: true
        });
        Object.defineProperty(LRUCache.prototype, "lengthCalculator", {
          set: function(lC) {
            if (typeof lC !== "function") {
              lC = naiveLength;
            }
            if (lC !== this[LENGTH_CALCULATOR]) {
              this[LENGTH_CALCULATOR] = lC;
              this[LENGTH] = 0;
              this[LRU_LIST].forEach(function(hit) {
                hit.length = this[LENGTH_CALCULATOR](hit.value, hit.key);
                this[LENGTH] += hit.length;
              }, this);
            }
            trim(this);
          },
          get: function() {
            return this[LENGTH_CALCULATOR];
          },
          enumerable: true
        });
        Object.defineProperty(LRUCache.prototype, "length", {
          get: function() {
            return this[LENGTH];
          },
          enumerable: true
        });
        Object.defineProperty(LRUCache.prototype, "itemCount", {
          get: function() {
            return this[LRU_LIST].length;
          },
          enumerable: true
        });
        LRUCache.prototype.rforEach = function(fn, thisp) {
          thisp = thisp || this;
          for (var walker = this[LRU_LIST].tail; walker !== null; ) {
            var prev = walker.prev;
            forEachStep(this, fn, walker, thisp);
            walker = prev;
          }
        };
        function forEachStep(self2, fn, node, thisp) {
          var hit = node.value;
          if (isStale(self2, hit)) {
            del(self2, node);
            if (!self2[ALLOW_STALE]) {
              hit = void 0;
            }
          }
          if (hit) {
            fn.call(thisp, hit.value, hit.key, self2);
          }
        }
        LRUCache.prototype.forEach = function(fn, thisp) {
          thisp = thisp || this;
          for (var walker = this[LRU_LIST].head; walker !== null; ) {
            var next = walker.next;
            forEachStep(this, fn, walker, thisp);
            walker = next;
          }
        };
        LRUCache.prototype.keys = function() {
          return this[LRU_LIST].toArray().map(function(k) {
            return k.key;
          }, this);
        };
        LRUCache.prototype.values = function() {
          return this[LRU_LIST].toArray().map(function(k) {
            return k.value;
          }, this);
        };
        LRUCache.prototype.reset = function() {
          if (this[DISPOSE] && this[LRU_LIST] && this[LRU_LIST].length) {
            this[LRU_LIST].forEach(function(hit) {
              this[DISPOSE](hit.key, hit.value);
            }, this);
          }
          this[CACHE] = new Map22();
          this[LRU_LIST] = new Yallist();
          this[LENGTH] = 0;
        };
        LRUCache.prototype.dump = function() {
          return this[LRU_LIST].map(function(hit) {
            if (!isStale(this, hit)) {
              return {
                k: hit.key,
                v: hit.value,
                e: hit.now + (hit.maxAge || 0)
              };
            }
          }, this).toArray().filter(function(h) {
            return h;
          });
        };
        LRUCache.prototype.dumpLru = function() {
          return this[LRU_LIST];
        };
        LRUCache.prototype.inspect = function(n, opts) {
          var str2 = "LRUCache {";
          var extras = false;
          var as = this[ALLOW_STALE];
          if (as) {
            str2 += "\n  allowStale: true";
            extras = true;
          }
          var max = this[MAX];
          if (max && max !== Infinity) {
            if (extras) {
              str2 += ",";
            }
            str2 += "\n  max: " + util2.inspect(max, opts);
            extras = true;
          }
          var maxAge = this[MAX_AGE];
          if (maxAge) {
            if (extras) {
              str2 += ",";
            }
            str2 += "\n  maxAge: " + util2.inspect(maxAge, opts);
            extras = true;
          }
          var lc = this[LENGTH_CALCULATOR];
          if (lc && lc !== naiveLength) {
            if (extras) {
              str2 += ",";
            }
            str2 += "\n  length: " + util2.inspect(this[LENGTH], opts);
            extras = true;
          }
          var didFirst = false;
          this[LRU_LIST].forEach(function(item) {
            if (didFirst) {
              str2 += ",\n  ";
            } else {
              if (extras) {
                str2 += ",\n";
              }
              didFirst = true;
              str2 += "\n  ";
            }
            var key = util2.inspect(item.key).split("\n").join("\n  ");
            var val = {
              value: item.value
            };
            if (item.maxAge !== maxAge) {
              val.maxAge = item.maxAge;
            }
            if (lc !== naiveLength) {
              val.length = item.length;
            }
            if (isStale(this, item)) {
              val.stale = true;
            }
            val = util2.inspect(val, opts).split("\n").join("\n  ");
            str2 += key + " => " + val;
          });
          if (didFirst || extras) {
            str2 += "\n";
          }
          str2 += "}";
          return str2;
        };
        LRUCache.prototype.set = function(key, value, maxAge) {
          maxAge = maxAge || this[MAX_AGE];
          var now = maxAge ? Date.now() : 0;
          var len = this[LENGTH_CALCULATOR](value, key);
          if (this[CACHE].has(key)) {
            if (len > this[MAX]) {
              del(this, this[CACHE].get(key));
              return false;
            }
            var node = this[CACHE].get(key);
            var item = node.value;
            if (this[DISPOSE]) {
              if (!this[NO_DISPOSE_ON_SET]) {
                this[DISPOSE](key, item.value);
              }
            }
            item.now = now;
            item.maxAge = maxAge;
            item.value = value;
            this[LENGTH] += len - item.length;
            item.length = len;
            this.get(key);
            trim(this);
            return true;
          }
          var hit = new Entry(key, value, len, now, maxAge);
          if (hit.length > this[MAX]) {
            if (this[DISPOSE]) {
              this[DISPOSE](key, value);
            }
            return false;
          }
          this[LENGTH] += hit.length;
          this[LRU_LIST].unshift(hit);
          this[CACHE].set(key, this[LRU_LIST].head);
          trim(this);
          return true;
        };
        LRUCache.prototype.has = function(key) {
          if (!this[CACHE].has(key))
            return false;
          var hit = this[CACHE].get(key).value;
          if (isStale(this, hit)) {
            return false;
          }
          return true;
        };
        LRUCache.prototype.get = function(key) {
          return get2(this, key, true);
        };
        LRUCache.prototype.peek = function(key) {
          return get2(this, key, false);
        };
        LRUCache.prototype.pop = function() {
          var node = this[LRU_LIST].tail;
          if (!node)
            return null;
          del(this, node);
          return node.value;
        };
        LRUCache.prototype.del = function(key) {
          del(this, this[CACHE].get(key));
        };
        LRUCache.prototype.load = function(arr) {
          this.reset();
          var now = Date.now();
          for (var l = arr.length - 1; l >= 0; l--) {
            var hit = arr[l];
            var expiresAt = hit.e || 0;
            if (expiresAt === 0) {
              this.set(hit.k, hit.v);
            } else {
              var maxAge = expiresAt - now;
              if (maxAge > 0) {
                this.set(hit.k, hit.v, maxAge);
              }
            }
          }
        };
        LRUCache.prototype.prune = function() {
          var self2 = this;
          this[CACHE].forEach(function(value, key) {
            get2(self2, key, false);
          });
        };
        function get2(self2, key, doUse) {
          var node = self2[CACHE].get(key);
          if (node) {
            var hit = node.value;
            if (isStale(self2, hit)) {
              del(self2, node);
              if (!self2[ALLOW_STALE])
                hit = void 0;
            } else {
              if (doUse) {
                self2[LRU_LIST].unshiftNode(node);
              }
            }
            if (hit)
              hit = hit.value;
          }
          return hit;
        }
        function isStale(self2, hit) {
          if (!hit || !hit.maxAge && !self2[MAX_AGE]) {
            return false;
          }
          var stale = false;
          var diff = Date.now() - hit.now;
          if (hit.maxAge) {
            stale = diff > hit.maxAge;
          } else {
            stale = self2[MAX_AGE] && diff > self2[MAX_AGE];
          }
          return stale;
        }
        function trim(self2) {
          if (self2[LENGTH] > self2[MAX]) {
            for (var walker = self2[LRU_LIST].tail; self2[LENGTH] > self2[MAX] && walker !== null; ) {
              var prev = walker.prev;
              del(self2, walker);
              walker = prev;
            }
          }
        }
        function del(self2, node) {
          if (node) {
            var hit = node.value;
            if (self2[DISPOSE]) {
              self2[DISPOSE](hit.key, hit.value);
            }
            self2[LENGTH] -= hit.length;
            self2[CACHE].delete(hit.key);
            self2[LRU_LIST].removeNode(node);
          }
        }
        function Entry(key, value, length, now, maxAge) {
          this.key = key;
          this.value = value;
          this.length = length;
          this.now = now;
          this.maxAge = maxAge || 0;
        }
      }
    });
    var require_sigmund = __commonJS22({
      "node_modules/sigmund/sigmund.js"(exports22, module22) {
        module22.exports = sigmund;
        function sigmund(subject, maxSessions) {
          maxSessions = maxSessions || 10;
          var notes = [];
          var analysis = "";
          var RE = RegExp;
          function psychoAnalyze(subject2, session) {
            if (session > maxSessions)
              return;
            if (typeof subject2 === "function" || typeof subject2 === "undefined") {
              return;
            }
            if (typeof subject2 !== "object" || !subject2 || subject2 instanceof RE) {
              analysis += subject2;
              return;
            }
            if (notes.indexOf(subject2) !== -1 || session === maxSessions)
              return;
            notes.push(subject2);
            analysis += "{";
            Object.keys(subject2).forEach(function(issue, _, __) {
              if (issue.charAt(0) === "_")
                return;
              var to = typeof subject2[issue];
              if (to === "function" || to === "undefined")
                return;
              analysis += issue;
              psychoAnalyze(subject2[issue], session + 1);
            });
          }
          psychoAnalyze(subject, 0);
          return analysis;
        }
      }
    });
    var require_fnmatch = __commonJS22({
      "node_modules/editorconfig/src/lib/fnmatch.js"(exports22, module22) {
        var platform = typeof process === "object" ? process.platform : "win32";
        if (module22)
          module22.exports = minimatch;
        else
          exports22.minimatch = minimatch;
        minimatch.Minimatch = Minimatch;
        var LRU = require_lru_cache();
        var cache = minimatch.cache = new LRU({
          max: 100
        });
        var GLOBSTAR = minimatch.GLOBSTAR = Minimatch.GLOBSTAR = {};
        var sigmund = require_sigmund();
        var path5 = require("path");
        var qmark = "[^/]";
        var star = qmark + "*?";
        var twoStarDot = "(?:(?!(?:\\/|^)(?:\\.{1,2})($|\\/)).)*?";
        var twoStarNoDot = "(?:(?!(?:\\/|^)\\.).)*?";
        var reSpecials = charSet("().*{}+?[]^$\\!");
        function charSet(s) {
          return s.split("").reduce(function(set4, c) {
            set4[c] = true;
            return set4;
          }, {});
        }
        var slashSplit = /\/+/;
        minimatch.monkeyPatch = monkeyPatch;
        function monkeyPatch() {
          var desc = Object.getOwnPropertyDescriptor(String.prototype, "match");
          var orig = desc.value;
          desc.value = function(p) {
            if (p instanceof Minimatch)
              return p.match(this);
            return orig.call(this, p);
          };
          Object.defineProperty(String.prototype, desc);
        }
        minimatch.filter = filter;
        function filter(pattern, options) {
          options = options || {};
          return function(p, i, list3) {
            return minimatch(p, pattern, options);
          };
        }
        function ext(a, b) {
          a = a || {};
          b = b || {};
          var t = {};
          Object.keys(b).forEach(function(k) {
            t[k] = b[k];
          });
          Object.keys(a).forEach(function(k) {
            t[k] = a[k];
          });
          return t;
        }
        minimatch.defaults = function(def) {
          if (!def || !Object.keys(def).length)
            return minimatch;
          var orig = minimatch;
          var m = function minimatch2(p, pattern, options) {
            return orig.minimatch(p, pattern, ext(def, options));
          };
          m.Minimatch = function Minimatch2(pattern, options) {
            return new orig.Minimatch(pattern, ext(def, options));
          };
          return m;
        };
        Minimatch.defaults = function(def) {
          if (!def || !Object.keys(def).length)
            return Minimatch;
          return minimatch.defaults(def).Minimatch;
        };
        function minimatch(p, pattern, options) {
          if (typeof pattern !== "string") {
            throw new TypeError("glob pattern string required");
          }
          if (!options)
            options = {};
          if (!options.nocomment && pattern.charAt(0) === "#") {
            return false;
          }
          if (pattern.trim() === "")
            return p === "";
          return new Minimatch(pattern, options).match(p);
        }
        function Minimatch(pattern, options) {
          if (!(this instanceof Minimatch)) {
            return new Minimatch(pattern, options, cache);
          }
          if (typeof pattern !== "string") {
            throw new TypeError("glob pattern string required");
          }
          if (!options)
            options = {};
          if (platform === "win32") {
            pattern = pattern.split("\\").join("/");
          }
          var cacheKey = pattern + "\n" + sigmund(options);
          var cached = minimatch.cache.get(cacheKey);
          if (cached)
            return cached;
          minimatch.cache.set(cacheKey, this);
          this.options = options;
          this.set = [];
          this.pattern = pattern;
          this.regexp = null;
          this.negate = false;
          this.comment = false;
          this.empty = false;
          this.make();
        }
        Minimatch.prototype.make = make;
        function make() {
          if (this._made)
            return;
          var pattern = this.pattern;
          var options = this.options;
          if (!options.nocomment && pattern.charAt(0) === "#") {
            this.comment = true;
            return;
          }
          if (!pattern) {
            this.empty = true;
            return;
          }
          this.parseNegate();
          var set4 = this.globSet = this.braceExpand();
          if (options.debug)
            console.error(this.pattern, set4);
          set4 = this.globParts = set4.map(function(s) {
            return s.split(slashSplit);
          });
          if (options.debug)
            console.error(this.pattern, set4);
          set4 = set4.map(function(s, si, set22) {
            return s.map(this.parse, this);
          }, this);
          if (options.debug)
            console.error(this.pattern, set4);
          set4 = set4.filter(function(s) {
            return s.indexOf(false) === -1;
          });
          if (options.debug)
            console.error(this.pattern, set4);
          this.set = set4;
        }
        Minimatch.prototype.parseNegate = parseNegate;
        function parseNegate() {
          var pattern = this.pattern, negate2 = false, options = this.options, negateOffset = 0;
          if (options.nonegate)
            return;
          for (var i = 0, l = pattern.length; i < l && pattern.charAt(i) === "!"; i++) {
            negate2 = !negate2;
            negateOffset++;
          }
          if (negateOffset)
            this.pattern = pattern.substr(negateOffset);
          this.negate = negate2;
        }
        minimatch.braceExpand = function(pattern, options) {
          return new Minimatch(pattern, options).braceExpand();
        };
        Minimatch.prototype.braceExpand = braceExpand;
        function braceExpand(pattern, options) {
          options = options || this.options;
          pattern = typeof pattern === "undefined" ? this.pattern : pattern;
          if (typeof pattern === "undefined") {
            throw new Error("undefined pattern");
          }
          if (options.nobrace || !pattern.match(/\{.*\}/)) {
            return [pattern];
          }
          var escaping = false;
          if (pattern.charAt(0) !== "{") {
            var prefix = null;
            for (var i = 0, l = pattern.length; i < l; i++) {
              var c = pattern.charAt(i);
              if (c === "\\") {
                escaping = !escaping;
              } else if (c === "{" && !escaping) {
                prefix = pattern.substr(0, i);
                break;
              }
            }
            if (prefix === null) {
              return [pattern];
            }
            var tail = braceExpand(pattern.substr(i), options);
            return tail.map(function(t) {
              return prefix + t;
            });
          }
          var numset = pattern.match(/^\{(-?[0-9]+)\.\.(-?[0-9]+)\}/);
          if (numset) {
            var suf = braceExpand(pattern.substr(numset[0].length), options), start = +numset[1], end = +numset[2], inc = start > end ? -1 : 1, set4 = [];
            for (var i = start; i != end + inc; i += inc) {
              for (var ii = 0, ll = suf.length; ii < ll; ii++) {
                set4.push(i + suf[ii]);
              }
            }
            return set4;
          }
          var i = 1, depth = 1, set4 = [], member = "", sawEnd = false, escaping = false;
          function addMember() {
            set4.push(member);
            member = "";
          }
          FOR:
            for (i = 1, l = pattern.length; i < l; i++) {
              var c = pattern.charAt(i);
              if (escaping) {
                escaping = false;
                member += "\\" + c;
              } else {
                switch (c) {
                  case "\\":
                    escaping = true;
                    continue;
                  case "{":
                    depth++;
                    member += "{";
                    continue;
                  case "}":
                    depth--;
                    if (depth === 0) {
                      addMember();
                      i++;
                      break FOR;
                    } else {
                      member += c;
                      continue;
                    }
                  case ",":
                    if (depth === 1) {
                      addMember();
                    } else {
                      member += c;
                    }
                    continue;
                  default:
                    member += c;
                    continue;
                }
              }
            }
          if (depth !== 0) {
            return braceExpand("\\" + pattern, options);
          }
          var suf = braceExpand(pattern.substr(i), options);
          var addBraces = set4.length === 1;
          set4 = set4.map(function(p) {
            return braceExpand(p, options);
          });
          set4 = set4.reduce(function(l2, r) {
            return l2.concat(r);
          });
          if (addBraces) {
            set4 = set4.map(function(s) {
              return "{" + s + "}";
            });
          }
          var ret = [];
          for (var i = 0, l = set4.length; i < l; i++) {
            for (var ii = 0, ll = suf.length; ii < ll; ii++) {
              ret.push(set4[i] + suf[ii]);
            }
          }
          return ret;
        }
        Minimatch.prototype.parse = parse2;
        var SUBPARSE = {};
        function parse2(pattern, isSub) {
          var options = this.options;
          if (!options.noglobstar && pattern === "**")
            return GLOBSTAR;
          if (pattern === "")
            return "";
          var re = "", hasMagic = !!options.nocase, escaping = false, patternListStack = [], plType, stateChar, inClass = false, reClassStart = -1, classStart = -1, patternStart = pattern.charAt(0) === "." ? "" : options.dot ? "(?!(?:^|\\/)\\.{1,2}(?:$|\\/))" : "(?!\\.)";
          function clearStateChar() {
            if (stateChar) {
              switch (stateChar) {
                case "*":
                  re += star;
                  hasMagic = true;
                  break;
                case "?":
                  re += qmark;
                  hasMagic = true;
                  break;
                default:
                  re += "\\" + stateChar;
                  break;
              }
              stateChar = false;
            }
          }
          for (var i = 0, len = pattern.length, c; i < len && (c = pattern.charAt(i)); i++) {
            if (options.debug) {
              console.error("%s	%s %s %j", pattern, i, re, c);
            }
            if (escaping && reSpecials[c]) {
              re += "\\" + c;
              escaping = false;
              continue;
            }
            SWITCH:
              switch (c) {
                case "/":
                  return false;
                case "\\":
                  clearStateChar();
                  escaping = true;
                  continue;
                case "?":
                case "*":
                case "+":
                case "@":
                case "!":
                  if (options.debug) {
                    console.error("%s	%s %s %j <-- stateChar", pattern, i, re, c);
                  }
                  if (inClass) {
                    if (c === "!" && i === classStart + 1)
                      c = "^";
                    re += c;
                    continue;
                  }
                  clearStateChar();
                  stateChar = c;
                  if (options.noext)
                    clearStateChar();
                  continue;
                case "(":
                  if (inClass) {
                    re += "(";
                    continue;
                  }
                  if (!stateChar) {
                    re += "\\(";
                    continue;
                  }
                  plType = stateChar;
                  patternListStack.push({
                    type: plType,
                    start: i - 1,
                    reStart: re.length
                  });
                  re += stateChar === "!" ? "(?:(?!" : "(?:";
                  stateChar = false;
                  continue;
                case ")":
                  if (inClass || !patternListStack.length) {
                    re += "\\)";
                    continue;
                  }
                  hasMagic = true;
                  re += ")";
                  plType = patternListStack.pop().type;
                  switch (plType) {
                    case "!":
                      re += "[^/]*?)";
                      break;
                    case "?":
                    case "+":
                    case "*":
                      re += plType;
                    case "@":
                      break;
                  }
                  continue;
                case "|":
                  if (inClass || !patternListStack.length || escaping) {
                    re += "\\|";
                    escaping = false;
                    continue;
                  }
                  re += "|";
                  continue;
                case "[":
                  clearStateChar();
                  if (inClass) {
                    re += "\\" + c;
                    continue;
                  }
                  inClass = true;
                  classStart = i;
                  reClassStart = re.length;
                  re += c;
                  continue;
                case "]":
                  if (i === classStart + 1 || !inClass) {
                    re += "\\" + c;
                    escaping = false;
                    continue;
                  }
                  hasMagic = true;
                  inClass = false;
                  re += c;
                  continue;
                default:
                  clearStateChar();
                  if (escaping) {
                    escaping = false;
                  } else if (reSpecials[c] && !(c === "^" && inClass)) {
                    re += "\\";
                  }
                  re += c;
              }
          }
          if (inClass) {
            var cs = pattern.substr(classStart + 1), sp = this.parse(cs, SUBPARSE);
            re = re.substr(0, reClassStart) + "\\[" + sp[0];
            hasMagic = hasMagic || sp[1];
          }
          var pl;
          while (pl = patternListStack.pop()) {
            var tail = re.slice(pl.reStart + 3);
            tail = tail.replace(/((?:\\{2})*)(\\?)\|/g, function(_, $1, $2) {
              if (!$2) {
                $2 = "\\";
              }
              return $1 + $1 + $2 + "|";
            });
            var t = pl.type === "*" ? star : pl.type === "?" ? qmark : "\\" + pl.type;
            hasMagic = true;
            re = re.slice(0, pl.reStart) + t + "\\(" + tail;
          }
          clearStateChar();
          if (escaping) {
            re += "\\\\";
          }
          var addPatternStart = false;
          switch (re.charAt(0)) {
            case ".":
            case "[":
            case "(":
              addPatternStart = true;
          }
          if (re !== "" && hasMagic)
            re = "(?=.)" + re;
          if (addPatternStart)
            re = patternStart + re;
          if (isSub === SUBPARSE) {
            return [re, hasMagic];
          }
          if (!hasMagic) {
            return globUnescape(pattern);
          }
          var flags = options.nocase ? "i" : "", regExp = new RegExp("^" + re + "$", flags);
          regExp._glob = pattern;
          regExp._src = re;
          return regExp;
        }
        minimatch.makeRe = function(pattern, options) {
          return new Minimatch(pattern, options || {}).makeRe();
        };
        Minimatch.prototype.makeRe = makeRe;
        function makeRe() {
          if (this.regexp || this.regexp === false)
            return this.regexp;
          var set4 = this.set;
          if (!set4.length)
            return this.regexp = false;
          var options = this.options;
          var twoStar = options.noglobstar ? star : options.dot ? twoStarDot : twoStarNoDot, flags = options.nocase ? "i" : "";
          var re = set4.map(function(pattern) {
            return pattern.map(function(p) {
              return p === GLOBSTAR ? twoStar : typeof p === "string" ? regExpEscape(p) : p._src;
            }).join("\\/");
          }).join("|");
          re = "^(?:" + re + ")$";
          if (this.negate)
            re = "^(?!" + re + ").*$";
          try {
            return this.regexp = new RegExp(re, flags);
          } catch (ex) {
            return this.regexp = false;
          }
        }
        minimatch.match = function(list3, pattern, options) {
          var mm = new Minimatch(pattern, options);
          list3 = list3.filter(function(f) {
            return mm.match(f);
          });
          if (options.nonull && !list3.length) {
            list3.push(pattern);
          }
          return list3;
        };
        Minimatch.prototype.match = match;
        function match(f, partial) {
          if (this.comment)
            return false;
          if (this.empty)
            return f === "";
          if (f === "/" && partial)
            return true;
          var options = this.options;
          if (platform === "win32") {
            f = f.split("\\").join("/");
          }
          f = f.split(slashSplit);
          if (options.debug) {
            console.error(this.pattern, "split", f);
          }
          var set4 = this.set;
          for (var i = 0, l = set4.length; i < l; i++) {
            var pattern = set4[i];
            var hit = this.matchOne(f, pattern, partial);
            if (hit) {
              if (options.flipNegate)
                return true;
              return !this.negate;
            }
          }
          if (options.flipNegate)
            return false;
          return this.negate;
        }
        Minimatch.prototype.matchOne = function(file, pattern, partial) {
          var options = this.options;
          if (options.debug) {
            console.error("matchOne", {
              "this": this,
              file,
              pattern
            });
          }
          if (options.matchBase && pattern.length === 1) {
            file = path5.basename(file.join("/")).split("/");
          }
          if (options.debug) {
            console.error("matchOne", file.length, pattern.length);
          }
          for (var fi = 0, pi = 0, fl = file.length, pl = pattern.length; fi < fl && pi < pl; fi++, pi++) {
            if (options.debug) {
              console.error("matchOne loop");
            }
            var p = pattern[pi], f = file[fi];
            if (options.debug) {
              console.error(pattern, p, f);
            }
            if (p === false)
              return false;
            if (p === GLOBSTAR) {
              if (options.debug)
                console.error("GLOBSTAR", [pattern, p, f]);
              var fr = fi, pr = pi + 1;
              if (pr === pl) {
                if (options.debug)
                  console.error("** at the end");
                for (; fi < fl; fi++) {
                  if (file[fi] === "." || file[fi] === ".." || !options.dot && file[fi].charAt(0) === ".")
                    return false;
                }
                return true;
              }
              WHILE:
                while (fr < fl) {
                  var swallowee = file[fr];
                  if (options.debug) {
                    console.error("\nglobstar while", file, fr, pattern, pr, swallowee);
                  }
                  if (this.matchOne(file.slice(fr), pattern.slice(pr), partial)) {
                    if (options.debug)
                      console.error("globstar found match!", fr, fl, swallowee);
                    return true;
                  } else {
                    if (swallowee === "." || swallowee === ".." || !options.dot && swallowee.charAt(0) === ".") {
                      if (options.debug)
                        console.error("dot detected!", file, fr, pattern, pr);
                      break WHILE;
                    }
                    if (options.debug)
                      console.error("globstar swallow a segment, and continue");
                    fr++;
                  }
                }
              if (partial) {
                if (fr === fl)
                  return true;
              }
              return false;
            }
            var hit;
            if (typeof p === "string") {
              if (options.nocase) {
                hit = f.toLowerCase() === p.toLowerCase();
              } else {
                hit = f === p;
              }
              if (options.debug) {
                console.error("string match", p, f, hit);
              }
            } else {
              hit = f.match(p);
              if (options.debug) {
                console.error("pattern match", p, f, hit);
              }
            }
            if (!hit)
              return false;
          }
          if (fi === fl && pi === pl) {
            return true;
          } else if (fi === fl) {
            return partial;
          } else if (pi === pl) {
            var emptyFileEnd = fi === fl - 1 && file[fi] === "";
            return emptyFileEnd;
          }
          throw new Error("wtf?");
        };
        function globUnescape(s) {
          return s.replace(/\\(.)/g, "$1");
        }
        function regExpEscape(s) {
          return s.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
        }
      }
    });
    var require_ini = __commonJS22({
      "node_modules/editorconfig/src/lib/ini.js"(exports22) {
        "use strict";
        var __awaiter2 = exports22 && exports22.__awaiter || function(thisArg, _arguments, P, generator) {
          return new (P || (P = Promise))(function(resolve, reject) {
            function fulfilled(value) {
              try {
                step(generator.next(value));
              } catch (e) {
                reject(e);
              }
            }
            function rejected(value) {
              try {
                step(generator["throw"](value));
              } catch (e) {
                reject(e);
              }
            }
            function step(result) {
              result.done ? resolve(result.value) : new P(function(resolve2) {
                resolve2(result.value);
              }).then(fulfilled, rejected);
            }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
          });
        };
        var __generator2 = exports22 && exports22.__generator || function(thisArg, body) {
          var _ = {
            label: 0,
            sent: function() {
              if (t[0] & 1)
                throw t[1];
              return t[1];
            },
            trys: [],
            ops: []
          }, f, y, t, g;
          return g = {
            next: verb(0),
            "throw": verb(1),
            "return": verb(2)
          }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
            return this;
          }), g;
          function verb(n) {
            return function(v) {
              return step([n, v]);
            };
          }
          function step(op) {
            if (f)
              throw new TypeError("Generator is already executing.");
            while (_)
              try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                  return t;
                if (y = 0, t)
                  op = [op[0] & 2, t.value];
                switch (op[0]) {
                  case 0:
                  case 1:
                    t = op;
                    break;
                  case 4:
                    _.label++;
                    return {
                      value: op[1],
                      done: false
                    };
                  case 5:
                    _.label++;
                    y = op[1];
                    op = [0];
                    continue;
                  case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                  default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                      _ = 0;
                      continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                      _.label = op[1];
                      break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                      _.label = t[1];
                      t = op;
                      break;
                    }
                    if (t && _.label < t[2]) {
                      _.label = t[2];
                      _.ops.push(op);
                      break;
                    }
                    if (t[2])
                      _.ops.pop();
                    _.trys.pop();
                    continue;
                }
                op = body.call(thisArg, _);
              } catch (e) {
                op = [6, e];
                y = 0;
              } finally {
                f = t = 0;
              }
            if (op[0] & 5)
              throw op[1];
            return {
              value: op[0] ? op[1] : void 0,
              done: true
            };
          }
        };
        var __importStar2 = exports22 && exports22.__importStar || function(mod) {
          if (mod && mod.__esModule)
            return mod;
          var result = {};
          if (mod != null) {
            for (var k in mod)
              if (Object.hasOwnProperty.call(mod, k))
                result[k] = mod[k];
          }
          result["default"] = mod;
          return result;
        };
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var fs = __importStar2(require("fs"));
        var regex = {
          section: /^\s*\[(([^#;]|\\#|\\;)+)\]\s*([#;].*)?$/,
          param: /^\s*([\w\.\-\_]+)\s*[=:]\s*(.*?)\s*([#;].*)?$/,
          comment: /^\s*[#;].*$/
        };
        function parse2(file) {
          return __awaiter2(this, void 0, void 0, function() {
            return __generator2(this, function(_a) {
              return [2, new Promise(function(resolve, reject) {
                fs.readFile(file, "utf8", function(err, data) {
                  if (err) {
                    reject(err);
                    return;
                  }
                  resolve(parseString(data));
                });
              })];
            });
          });
        }
        exports22.parse = parse2;
        function parseSync(file) {
          return parseString(fs.readFileSync(file, "utf8"));
        }
        exports22.parseSync = parseSync;
        function parseString(data) {
          var sectionBody = {};
          var sectionName = null;
          var value = [[sectionName, sectionBody]];
          var lines = data.split(/\r\n|\r|\n/);
          lines.forEach(function(line) {
            var match;
            if (regex.comment.test(line)) {
              return;
            }
            if (regex.param.test(line)) {
              match = line.match(regex.param);
              sectionBody[match[1]] = match[2];
            } else if (regex.section.test(line)) {
              match = line.match(regex.section);
              sectionName = match[1];
              sectionBody = {};
              value.push([sectionName, sectionBody]);
            }
          });
          return value;
        }
        exports22.parseString = parseString;
      }
    });
    var require_package4 = __commonJS22({
      "node_modules/editorconfig/package.json"(exports22, module22) {
        module22.exports = {
          name: "editorconfig",
          version: "0.15.3",
          description: "EditorConfig File Locator and Interpreter for Node.js",
          keywords: ["editorconfig", "core"],
          main: "src/index.js",
          contributors: ["Hong Xu (topbug.net)", "Jed Mao (https://github.com/jedmao/)", "Trey Hunner (http://treyhunner.com)"],
          directories: {
            bin: "./bin",
            lib: "./lib"
          },
          scripts: {
            clean: "rimraf dist",
            prebuild: "npm run clean",
            build: "tsc",
            pretest: "npm run lint && npm run build && npm run copy && cmake .",
            test: "ctest .",
            "pretest:ci": "npm run pretest",
            "test:ci": "ctest -VV --output-on-failure .",
            lint: "npm run eclint && npm run tslint",
            eclint: 'eclint check --indent_size ignore "src/**"',
            tslint: "tslint --project tsconfig.json --exclude package.json",
            copy: "cpy .npmignore LICENSE README.md CHANGELOG.md dist && cpy bin/* dist/bin && cpy src/lib/fnmatch*.* dist/src/lib",
            prepub: "npm run lint && npm run build && npm run copy",
            pub: "npm publish ./dist"
          },
          repository: {
            type: "git",
            url: "git://github.com/editorconfig/editorconfig-core-js.git"
          },
          bugs: "https://github.com/editorconfig/editorconfig-core-js/issues",
          author: "EditorConfig Team",
          license: "MIT",
          dependencies: {
            commander: "^2.19.0",
            "lru-cache": "^4.1.5",
            semver: "^5.6.0",
            sigmund: "^1.0.1"
          },
          devDependencies: {
            "@types/mocha": "^5.2.6",
            "@types/node": "^10.12.29",
            "@types/semver": "^5.5.0",
            "cpy-cli": "^2.0.0",
            eclint: "^2.8.1",
            mocha: "^5.2.0",
            rimraf: "^2.6.3",
            should: "^13.2.3",
            tslint: "^5.13.1",
            typescript: "^3.3.3333"
          }
        };
      }
    });
    var require_src22 = __commonJS22({
      "node_modules/editorconfig/src/index.js"(exports22) {
        "use strict";
        var __awaiter2 = exports22 && exports22.__awaiter || function(thisArg, _arguments, P, generator) {
          return new (P || (P = Promise))(function(resolve, reject) {
            function fulfilled(value) {
              try {
                step(generator.next(value));
              } catch (e) {
                reject(e);
              }
            }
            function rejected(value) {
              try {
                step(generator["throw"](value));
              } catch (e) {
                reject(e);
              }
            }
            function step(result) {
              result.done ? resolve(result.value) : new P(function(resolve2) {
                resolve2(result.value);
              }).then(fulfilled, rejected);
            }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
          });
        };
        var __generator2 = exports22 && exports22.__generator || function(thisArg, body) {
          var _ = {
            label: 0,
            sent: function() {
              if (t[0] & 1)
                throw t[1];
              return t[1];
            },
            trys: [],
            ops: []
          }, f, y, t, g;
          return g = {
            next: verb(0),
            "throw": verb(1),
            "return": verb(2)
          }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
            return this;
          }), g;
          function verb(n) {
            return function(v) {
              return step([n, v]);
            };
          }
          function step(op) {
            if (f)
              throw new TypeError("Generator is already executing.");
            while (_)
              try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                  return t;
                if (y = 0, t)
                  op = [op[0] & 2, t.value];
                switch (op[0]) {
                  case 0:
                  case 1:
                    t = op;
                    break;
                  case 4:
                    _.label++;
                    return {
                      value: op[1],
                      done: false
                    };
                  case 5:
                    _.label++;
                    y = op[1];
                    op = [0];
                    continue;
                  case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                  default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                      _ = 0;
                      continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                      _.label = op[1];
                      break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                      _.label = t[1];
                      t = op;
                      break;
                    }
                    if (t && _.label < t[2]) {
                      _.label = t[2];
                      _.ops.push(op);
                      break;
                    }
                    if (t[2])
                      _.ops.pop();
                    _.trys.pop();
                    continue;
                }
                op = body.call(thisArg, _);
              } catch (e) {
                op = [6, e];
                y = 0;
              } finally {
                f = t = 0;
              }
            if (op[0] & 5)
              throw op[1];
            return {
              value: op[0] ? op[1] : void 0,
              done: true
            };
          }
        };
        var __importStar2 = exports22 && exports22.__importStar || function(mod) {
          if (mod && mod.__esModule)
            return mod;
          var result = {};
          if (mod != null) {
            for (var k in mod)
              if (Object.hasOwnProperty.call(mod, k))
                result[k] = mod[k];
          }
          result["default"] = mod;
          return result;
        };
        var __importDefault2 = exports22 && exports22.__importDefault || function(mod) {
          return mod && mod.__esModule ? mod : {
            "default": mod
          };
        };
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var fs = __importStar2(require("fs"));
        var path5 = __importStar2(require("path"));
        var semver = {
          gte: require_gte()
        };
        var fnmatch_1 = __importDefault2(require_fnmatch());
        var ini_1 = require_ini();
        exports22.parseString = ini_1.parseString;
        var package_json_1 = __importDefault2(require_package4());
        var knownProps = {
          end_of_line: true,
          indent_style: true,
          indent_size: true,
          insert_final_newline: true,
          trim_trailing_whitespace: true,
          charset: true
        };
        function fnmatch(filepath, glob) {
          var matchOptions = {
            matchBase: true,
            dot: true,
            noext: true
          };
          glob = glob.replace(/\*\*/g, "{*,**/**/**}");
          return fnmatch_1.default(filepath, glob, matchOptions);
        }
        function getConfigFileNames(filepath, options) {
          var paths = [];
          do {
            filepath = path5.dirname(filepath);
            paths.push(path5.join(filepath, options.config));
          } while (filepath !== options.root);
          return paths;
        }
        function processMatches(matches, version2) {
          if ("indent_style" in matches && matches.indent_style === "tab" && !("indent_size" in matches) && semver.gte(version2, "0.10.0")) {
            matches.indent_size = "tab";
          }
          if ("indent_size" in matches && !("tab_width" in matches) && matches.indent_size !== "tab") {
            matches.tab_width = matches.indent_size;
          }
          if ("indent_size" in matches && "tab_width" in matches && matches.indent_size === "tab") {
            matches.indent_size = matches.tab_width;
          }
          return matches;
        }
        function processOptions(options, filepath) {
          if (options === void 0) {
            options = {};
          }
          return {
            config: options.config || ".editorconfig",
            version: options.version || package_json_1.default.version,
            root: path5.resolve(options.root || path5.parse(filepath).root)
          };
        }
        function buildFullGlob(pathPrefix, glob) {
          switch (glob.indexOf("/")) {
            case -1:
              glob = "**/" + glob;
              break;
            case 0:
              glob = glob.substring(1);
              break;
            default:
              break;
          }
          return path5.join(pathPrefix, glob);
        }
        function extendProps(props, options) {
          if (props === void 0) {
            props = {};
          }
          if (options === void 0) {
            options = {};
          }
          for (var key in options) {
            if (options.hasOwnProperty(key)) {
              var value = options[key];
              var key2 = key.toLowerCase();
              var value2 = value;
              if (knownProps[key2]) {
                value2 = value.toLowerCase();
              }
              try {
                value2 = JSON.parse(value);
              } catch (e) {
              }
              if (typeof value === "undefined" || value === null) {
                value2 = String(value);
              }
              props[key2] = value2;
            }
          }
          return props;
        }
        function parseFromConfigs(configs, filepath, options) {
          return processMatches(configs.reverse().reduce(function(matches, file) {
            var pathPrefix = path5.dirname(file.name);
            file.contents.forEach(function(section) {
              var glob = section[0];
              var options2 = section[1];
              if (!glob) {
                return;
              }
              var fullGlob = buildFullGlob(pathPrefix, glob);
              if (!fnmatch(filepath, fullGlob)) {
                return;
              }
              matches = extendProps(matches, options2);
            });
            return matches;
          }, {}), options.version);
        }
        function getConfigsForFiles(files) {
          var configs = [];
          for (var i in files) {
            if (files.hasOwnProperty(i)) {
              var file = files[i];
              var contents = ini_1.parseString(file.contents);
              configs.push({
                name: file.name,
                contents
              });
              if ((contents[0][1].root || "").toLowerCase() === "true") {
                break;
              }
            }
          }
          return configs;
        }
        function readConfigFiles(filepaths) {
          return __awaiter2(this, void 0, void 0, function() {
            return __generator2(this, function(_a) {
              return [2, Promise.all(filepaths.map(function(name) {
                return new Promise(function(resolve) {
                  fs.readFile(name, "utf8", function(err, data) {
                    resolve({
                      name,
                      contents: err ? "" : data
                    });
                  });
                });
              }))];
            });
          });
        }
        function readConfigFilesSync(filepaths) {
          var files = [];
          var file;
          filepaths.forEach(function(filepath) {
            try {
              file = fs.readFileSync(filepath, "utf8");
            } catch (e) {
              file = "";
            }
            files.push({
              name: filepath,
              contents: file
            });
          });
          return files;
        }
        function opts(filepath, options) {
          if (options === void 0) {
            options = {};
          }
          var resolvedFilePath = path5.resolve(filepath);
          return [resolvedFilePath, processOptions(options, resolvedFilePath)];
        }
        function parseFromFiles(filepath, files, options) {
          if (options === void 0) {
            options = {};
          }
          return __awaiter2(this, void 0, void 0, function() {
            var _a, resolvedFilePath, processedOptions;
            return __generator2(this, function(_b) {
              _a = opts(filepath, options), resolvedFilePath = _a[0], processedOptions = _a[1];
              return [2, files.then(getConfigsForFiles).then(function(configs) {
                return parseFromConfigs(configs, resolvedFilePath, processedOptions);
              })];
            });
          });
        }
        exports22.parseFromFiles = parseFromFiles;
        function parseFromFilesSync(filepath, files, options) {
          if (options === void 0) {
            options = {};
          }
          var _a = opts(filepath, options), resolvedFilePath = _a[0], processedOptions = _a[1];
          return parseFromConfigs(getConfigsForFiles(files), resolvedFilePath, processedOptions);
        }
        exports22.parseFromFilesSync = parseFromFilesSync;
        function parse2(_filepath, _options) {
          if (_options === void 0) {
            _options = {};
          }
          return __awaiter2(this, void 0, void 0, function() {
            var _a, resolvedFilePath, processedOptions, filepaths;
            return __generator2(this, function(_b) {
              _a = opts(_filepath, _options), resolvedFilePath = _a[0], processedOptions = _a[1];
              filepaths = getConfigFileNames(resolvedFilePath, processedOptions);
              return [2, readConfigFiles(filepaths).then(getConfigsForFiles).then(function(configs) {
                return parseFromConfigs(configs, resolvedFilePath, processedOptions);
              })];
            });
          });
        }
        exports22.parse = parse2;
        function parseSync(_filepath, _options) {
          if (_options === void 0) {
            _options = {};
          }
          var _a = opts(_filepath, _options), resolvedFilePath = _a[0], processedOptions = _a[1];
          var filepaths = getConfigFileNames(resolvedFilePath, processedOptions);
          var files = readConfigFilesSync(filepaths);
          return parseFromConfigs(getConfigsForFiles(files), resolvedFilePath, processedOptions);
        }
        exports22.parseSync = parseSync;
      }
    });
    var require_editorconfig_to_prettier = __commonJS22({
      "node_modules/editorconfig-to-prettier/index.js"(exports22, module22) {
        module22.exports = editorConfigToPrettier;
        function removeUnset(editorConfig) {
          const result = {};
          const keys5 = Object.keys(editorConfig);
          for (let i = 0; i < keys5.length; i++) {
            const key = keys5[i];
            if (editorConfig[key] === "unset") {
              continue;
            }
            result[key] = editorConfig[key];
          }
          return result;
        }
        function editorConfigToPrettier(editorConfig) {
          if (!editorConfig) {
            return null;
          }
          editorConfig = removeUnset(editorConfig);
          if (Object.keys(editorConfig).length === 0) {
            return null;
          }
          const result = {};
          if (editorConfig.indent_style) {
            result.useTabs = editorConfig.indent_style === "tab";
          }
          if (editorConfig.indent_size === "tab") {
            result.useTabs = true;
          }
          if (result.useTabs && editorConfig.tab_width) {
            result.tabWidth = editorConfig.tab_width;
          } else if (editorConfig.indent_style === "space" && editorConfig.indent_size && editorConfig.indent_size !== "tab") {
            result.tabWidth = editorConfig.indent_size;
          } else if (editorConfig.tab_width !== void 0) {
            result.tabWidth = editorConfig.tab_width;
          }
          if (editorConfig.max_line_length && editorConfig.max_line_length !== "off") {
            result.printWidth = editorConfig.max_line_length;
          }
          if (editorConfig.quote_type === "single") {
            result.singleQuote = true;
          } else if (editorConfig.quote_type === "double") {
            result.singleQuote = false;
          }
          if (["cr", "crlf", "lf"].indexOf(editorConfig.end_of_line) !== -1) {
            result.endOfLine = editorConfig.end_of_line;
          }
          if (editorConfig.insert_final_newline === false || editorConfig.insert_final_newline === true) {
            result.insertFinalNewline = editorConfig.insert_final_newline;
          }
          return result;
        }
      }
    });
    var require_find_project_root = __commonJS22({
      "src/config/find-project-root.js"(exports22, module22) {
        "use strict";
        var fs = require("fs");
        var path5 = require("path");
        var MARKERS = [".git", ".hg"];
        var markerExists = (directory) => MARKERS.some((mark) => fs.existsSync(path5.join(directory, mark)));
        function findProjectRoot(directory) {
          while (!markerExists(directory)) {
            const parentDirectory = path5.resolve(directory, "..");
            if (parentDirectory === directory) {
              break;
            }
            directory = parentDirectory;
          }
          return directory;
        }
        module22.exports = findProjectRoot;
      }
    });
    var require_resolve_config_editorconfig = __commonJS22({
      "src/config/resolve-config-editorconfig.js"(exports22, module22) {
        "use strict";
        var path5 = require("path");
        var editorconfig = require_src22();
        var editorConfigToPrettier = require_editorconfig_to_prettier();
        var {
          default: mem2,
          memClear: memClear2
        } = (init_dist(), __toCommonJS2(dist_exports));
        var findProjectRoot = require_find_project_root();
        var jsonStringifyMem = (fn) => mem2(fn, {
          cacheKey: JSON.stringify
        });
        var maybeParse = (filePath, parse2) => filePath && parse2(filePath, {
          root: findProjectRoot(path5.dirname(path5.resolve(filePath)))
        });
        var editorconfigAsyncNoCache = async (filePath) => editorConfigToPrettier(await maybeParse(filePath, editorconfig.parse));
        var editorconfigAsyncWithCache = jsonStringifyMem(editorconfigAsyncNoCache);
        var editorconfigSyncNoCache = (filePath) => editorConfigToPrettier(maybeParse(filePath, editorconfig.parseSync));
        var editorconfigSyncWithCache = jsonStringifyMem(editorconfigSyncNoCache);
        function getLoadFunction(opts) {
          if (!opts.editorconfig) {
            return () => null;
          }
          if (opts.sync) {
            return opts.cache ? editorconfigSyncWithCache : editorconfigSyncNoCache;
          }
          return opts.cache ? editorconfigAsyncWithCache : editorconfigAsyncNoCache;
        }
        function clearCache() {
          memClear2(editorconfigSyncWithCache);
          memClear2(editorconfigAsyncWithCache);
        }
        module22.exports = {
          getLoadFunction,
          clearCache
        };
      }
    });
    var require_resolve_config = __commonJS22({
      "src/config/resolve-config.js"(exports22, module22) {
        "use strict";
        var path5 = require("path");
        var micromatch = require_micromatch();
        var thirdParty = require_third_party();
        var loadToml = require_load_toml();
        var loadJson5 = require_load_json5();
        var partition3 = require_partition();
        var resolve = require_resolve22();
        var {
          default: mem2,
          memClear: memClear2
        } = (init_dist(), __toCommonJS2(dist_exports));
        var resolveEditorConfig = require_resolve_config_editorconfig();
        var getExplorerMemoized = mem2((opts) => {
          const cosmiconfig = thirdParty["cosmiconfig" + (opts.sync ? "Sync" : "")];
          const explorer = cosmiconfig("prettier", {
            cache: opts.cache,
            transform: (result) => {
              if (result && result.config) {
                if (typeof result.config === "string") {
                  const dir = path5.dirname(result.filepath);
                  const modulePath = resolve(result.config, {
                    paths: [dir]
                  });
                  result.config = require(modulePath);
                }
                if (typeof result.config !== "object") {
                  throw new TypeError(`Config is only allowed to be an object, but received ${typeof result.config} in "${result.filepath}"`);
                }
                delete result.config.$schema;
              }
              return result;
            },
            searchPlaces: ["package.json", ".prettierrc", ".prettierrc.json", ".prettierrc.yaml", ".prettierrc.yml", ".prettierrc.json5", ".prettierrc.js", ".prettierrc.cjs", "prettier.config.js", "prettier.config.cjs", ".prettierrc.toml"],
            loaders: {
              ".toml": loadToml,
              ".json5": loadJson5
            }
          });
          return explorer;
        }, {
          cacheKey: JSON.stringify
        });
        function getExplorer(opts) {
          opts = Object.assign({
            sync: false,
            cache: false
          }, opts);
          return getExplorerMemoized(opts);
        }
        function _resolveConfig(filePath, opts, sync) {
          opts = Object.assign({
            useCache: true
          }, opts);
          const loadOpts = {
            cache: Boolean(opts.useCache),
            sync: Boolean(sync),
            editorconfig: Boolean(opts.editorconfig)
          };
          const {
            load: load2,
            search
          } = getExplorer(loadOpts);
          const loadEditorConfig = resolveEditorConfig.getLoadFunction(loadOpts);
          const arr = [opts.config ? load2(opts.config) : search(filePath), loadEditorConfig(filePath)];
          const unwrapAndMerge = ([result, editorConfigured]) => {
            const merged = Object.assign(Object.assign({}, editorConfigured), mergeOverrides(result, filePath));
            for (const optionName of ["plugins", "pluginSearchDirs"]) {
              if (Array.isArray(merged[optionName])) {
                merged[optionName] = merged[optionName].map((value) => typeof value === "string" && value.startsWith(".") ? path5.resolve(path5.dirname(result.filepath), value) : value);
              }
            }
            if (!result && !editorConfigured) {
              return null;
            }
            delete merged.insertFinalNewline;
            return merged;
          };
          if (loadOpts.sync) {
            return unwrapAndMerge(arr);
          }
          return Promise.all(arr).then(unwrapAndMerge);
        }
        var resolveConfig = (filePath, opts) => _resolveConfig(filePath, opts, false);
        resolveConfig.sync = (filePath, opts) => _resolveConfig(filePath, opts, true);
        function clearCache() {
          memClear2(getExplorerMemoized);
          resolveEditorConfig.clearCache();
        }
        async function resolveConfigFile(filePath) {
          const {
            search
          } = getExplorer({
            sync: false
          });
          const result = await search(filePath);
          return result ? result.filepath : null;
        }
        resolveConfigFile.sync = (filePath) => {
          const {
            search
          } = getExplorer({
            sync: true
          });
          const result = search(filePath);
          return result ? result.filepath : null;
        };
        function mergeOverrides(configResult, filePath) {
          const {
            config: config2,
            filepath: configPath
          } = configResult || {};
          const _ref = config2 || {}, {
            overrides
          } = _ref, options = _objectWithoutProperties(_ref, _excluded3);
          if (filePath && overrides) {
            const relativeFilePath = path5.relative(path5.dirname(configPath), filePath);
            for (const override of overrides) {
              if (pathMatchesGlobs(relativeFilePath, override.files, override.excludeFiles)) {
                Object.assign(options, override.options);
              }
            }
          }
          return options;
        }
        function pathMatchesGlobs(filePath, patterns, excludedPatterns) {
          const patternList = Array.isArray(patterns) ? patterns : [patterns];
          const [withSlashes, withoutSlashes] = partition3(patternList, (pattern) => pattern.includes("/"));
          return micromatch.isMatch(filePath, withoutSlashes, {
            ignore: excludedPatterns,
            basename: true,
            dot: true
          }) || micromatch.isMatch(filePath, withSlashes, {
            ignore: excludedPatterns,
            basename: false,
            dot: true
          });
        }
        module22.exports = {
          resolveConfig,
          resolveConfigFile,
          clearCache
        };
      }
    });
    var require_ignore = __commonJS22({
      "node_modules/ignore/index.js"(exports22, module22) {
        function makeArray(subject) {
          return Array.isArray(subject) ? subject : [subject];
        }
        var EMPTY = "";
        var SPACE = " ";
        var ESCAPE = "\\";
        var REGEX_TEST_BLANK_LINE = /^\s+$/;
        var REGEX_REPLACE_LEADING_EXCAPED_EXCLAMATION = /^\\!/;
        var REGEX_REPLACE_LEADING_EXCAPED_HASH = /^\\#/;
        var REGEX_SPLITALL_CRLF = /\r?\n/g;
        var REGEX_TEST_INVALID_PATH = /^\.*\/|^\.+$/;
        var SLASH = "/";
        var KEY_IGNORE = typeof Symbol !== "undefined" ? Symbol.for("node-ignore") : "node-ignore";
        var define2 = (object3, key, value) => Object.defineProperty(object3, key, {
          value
        });
        var REGEX_REGEXP_RANGE = /([0-z])-([0-z])/g;
        var RETURN_FALSE = () => false;
        var sanitizeRange = (range) => range.replace(REGEX_REGEXP_RANGE, (match, from, to) => from.charCodeAt(0) <= to.charCodeAt(0) ? match : EMPTY);
        var cleanRangeBackSlash = (slashes) => {
          const {
            length
          } = slashes;
          return slashes.slice(0, length - length % 2);
        };
        var REPLACERS = [[/\\?\s+$/, (match) => match.indexOf("\\") === 0 ? SPACE : EMPTY], [/\\\s/g, () => SPACE], [/[\\$.|*+(){^]/g, (match) => `\\${match}`], [/(?!\\)\?/g, () => "[^/]"], [/^\//, () => "^"], [/\//g, () => "\\/"], [/^\^*\\\*\\\*\\\//, () => "^(?:.*\\/)?"], [/^(?=[^^])/, function startingReplacer() {
          return !/\/(?!$)/.test(this) ? "(?:^|\\/)" : "^";
        }], [/\\\/\\\*\\\*(?=\\\/|$)/g, (_, index, str2) => index + 6 < str2.length ? "(?:\\/[^\\/]+)*" : "\\/.+"], [/(^|[^\\]+)\\\*(?=.+)/g, (_, p1) => `${p1}[^\\/]*`], [/\\\\\\(?=[$.|*+(){^])/g, () => ESCAPE], [/\\\\/g, () => ESCAPE], [/(\\)?\[([^\]/]*?)(\\*)($|\])/g, (match, leadEscape, range, endEscape, close) => leadEscape === ESCAPE ? `\\[${range}${cleanRangeBackSlash(endEscape)}${close}` : close === "]" ? endEscape.length % 2 === 0 ? `[${sanitizeRange(range)}${endEscape}]` : "[]" : "[]"], [/(?:[^*])$/, (match) => /\/$/.test(match) ? `${match}$` : `${match}(?=$|\\/$)`], [/(\^|\\\/)?\\\*$/, (_, p1) => {
          const prefix = p1 ? `${p1}[^/]+` : "[^/]*";
          return `${prefix}(?=$|\\/$)`;
        }]];
        var regexCache = /* @__PURE__ */ Object.create(null);
        var makeRegex = (pattern, ignoreCase) => {
          let source = regexCache[pattern];
          if (!source) {
            source = REPLACERS.reduce((prev, current) => prev.replace(current[0], current[1].bind(pattern)), pattern);
            regexCache[pattern] = source;
          }
          return ignoreCase ? new RegExp(source, "i") : new RegExp(source);
        };
        var isString2 = (subject) => typeof subject === "string";
        var checkPattern = (pattern) => pattern && isString2(pattern) && !REGEX_TEST_BLANK_LINE.test(pattern) && pattern.indexOf("#") !== 0;
        var splitPattern = (pattern) => pattern.split(REGEX_SPLITALL_CRLF);
        var IgnoreRule = class {
          constructor(origin, pattern, negative, regex) {
            this.origin = origin;
            this.pattern = pattern;
            this.negative = negative;
            this.regex = regex;
          }
        };
        var createRule = (pattern, ignoreCase) => {
          const origin = pattern;
          let negative = false;
          if (pattern.indexOf("!") === 0) {
            negative = true;
            pattern = pattern.substr(1);
          }
          pattern = pattern.replace(REGEX_REPLACE_LEADING_EXCAPED_EXCLAMATION, "!").replace(REGEX_REPLACE_LEADING_EXCAPED_HASH, "#");
          const regex = makeRegex(pattern, ignoreCase);
          return new IgnoreRule(origin, pattern, negative, regex);
        };
        var throwError2 = (message, Ctor) => {
          throw new Ctor(message);
        };
        var checkPath = (path5, originalPath, doThrow) => {
          if (!isString2(path5)) {
            return doThrow(`path must be a string, but got \`${originalPath}\``, TypeError);
          }
          if (!path5) {
            return doThrow(`path must not be empty`, TypeError);
          }
          if (checkPath.isNotRelative(path5)) {
            const r = "`path.relative()`d";
            return doThrow(`path should be a ${r} string, but got "${originalPath}"`, RangeError);
          }
          return true;
        };
        var isNotRelative = (path5) => REGEX_TEST_INVALID_PATH.test(path5);
        checkPath.isNotRelative = isNotRelative;
        checkPath.convert = (p) => p;
        var Ignore = class {
          constructor({
            ignorecase = true,
            ignoreCase = ignorecase,
            allowRelativePaths = false
          } = {}) {
            define2(this, KEY_IGNORE, true);
            this._rules = [];
            this._ignoreCase = ignoreCase;
            this._allowRelativePaths = allowRelativePaths;
            this._initCache();
          }
          _initCache() {
            this._ignoreCache = /* @__PURE__ */ Object.create(null);
            this._testCache = /* @__PURE__ */ Object.create(null);
          }
          _addPattern(pattern) {
            if (pattern && pattern[KEY_IGNORE]) {
              this._rules = this._rules.concat(pattern._rules);
              this._added = true;
              return;
            }
            if (checkPattern(pattern)) {
              const rule = createRule(pattern, this._ignoreCase);
              this._added = true;
              this._rules.push(rule);
            }
          }
          add(pattern) {
            this._added = false;
            makeArray(isString2(pattern) ? splitPattern(pattern) : pattern).forEach(this._addPattern, this);
            if (this._added) {
              this._initCache();
            }
            return this;
          }
          addPattern(pattern) {
            return this.add(pattern);
          }
          _testOne(path5, checkUnignored) {
            let ignored = false;
            let unignored = false;
            this._rules.forEach((rule) => {
              const {
                negative
              } = rule;
              if (unignored === negative && ignored !== unignored || negative && !ignored && !unignored && !checkUnignored) {
                return;
              }
              const matched = rule.regex.test(path5);
              if (matched) {
                ignored = !negative;
                unignored = negative;
              }
            });
            return {
              ignored,
              unignored
            };
          }
          _test(originalPath, cache, checkUnignored, slices) {
            const path5 = originalPath && checkPath.convert(originalPath);
            checkPath(path5, originalPath, this._allowRelativePaths ? RETURN_FALSE : throwError2);
            return this._t(path5, cache, checkUnignored, slices);
          }
          _t(path5, cache, checkUnignored, slices) {
            if (path5 in cache) {
              return cache[path5];
            }
            if (!slices) {
              slices = path5.split(SLASH);
            }
            slices.pop();
            if (!slices.length) {
              return cache[path5] = this._testOne(path5, checkUnignored);
            }
            const parent = this._t(slices.join(SLASH) + SLASH, cache, checkUnignored, slices);
            return cache[path5] = parent.ignored ? parent : this._testOne(path5, checkUnignored);
          }
          ignores(path5) {
            return this._test(path5, this._ignoreCache, false).ignored;
          }
          createFilter() {
            return (path5) => !this.ignores(path5);
          }
          filter(paths) {
            return makeArray(paths).filter(this.createFilter());
          }
          test(path5) {
            return this._test(path5, this._testCache, true);
          }
        };
        var factory = (options) => new Ignore(options);
        var isPathValid = (path5) => checkPath(path5 && checkPath.convert(path5), path5, RETURN_FALSE);
        factory.isPathValid = isPathValid;
        factory.default = factory;
        module22.exports = factory;
        if (typeof process !== "undefined" && (process.env && process.env.IGNORE_TEST_WIN32 || process.platform === "win32")) {
          const makePosix = (str2) => /^\\\\\?\\/.test(str2) || /["<>|\u0000-\u001F]+/u.test(str2) ? str2 : str2.replace(/\\/g, "/");
          checkPath.convert = makePosix;
          const REGIX_IS_WINDOWS_PATH_ABSOLUTE = /^[a-z]:\//i;
          checkPath.isNotRelative = (path5) => REGIX_IS_WINDOWS_PATH_ABSOLUTE.test(path5) || isNotRelative(path5);
        }
      }
    });
    var require_get_file_content_or_null = __commonJS22({
      "src/utils/get-file-content-or-null.js"(exports22, module22) {
        "use strict";
        var fs = require("fs");
        var fsAsync = fs.promises;
        async function getFileContentOrNull(filename) {
          try {
            return await fsAsync.readFile(filename, "utf8");
          } catch (error) {
            return handleError(filename, error);
          }
        }
        getFileContentOrNull.sync = function(filename) {
          try {
            return fs.readFileSync(filename, "utf8");
          } catch (error) {
            return handleError(filename, error);
          }
        };
        function handleError(filename, error) {
          if (error && error.code === "ENOENT") {
            return null;
          }
          throw new Error(`Unable to read ${filename}: ${error.message}`);
        }
        module22.exports = getFileContentOrNull;
      }
    });
    var require_create_ignorer = __commonJS22({
      "src/common/create-ignorer.js"(exports22, module22) {
        "use strict";
        var path5 = require("path");
        var ignore = require_ignore().default;
        var getFileContentOrNull = require_get_file_content_or_null();
        async function createIgnorer(ignorePath, withNodeModules) {
          const ignoreContent = ignorePath ? await getFileContentOrNull(path5.resolve(ignorePath)) : null;
          return _createIgnorer(ignoreContent, withNodeModules);
        }
        createIgnorer.sync = function(ignorePath, withNodeModules) {
          const ignoreContent = !ignorePath ? null : getFileContentOrNull.sync(path5.resolve(ignorePath));
          return _createIgnorer(ignoreContent, withNodeModules);
        };
        function _createIgnorer(ignoreContent, withNodeModules) {
          const ignorer = ignore({
            allowRelativePaths: true
          }).add(ignoreContent || "");
          if (!withNodeModules) {
            ignorer.add("node_modules");
          }
          return ignorer;
        }
        module22.exports = createIgnorer;
      }
    });
    var require_get_file_info = __commonJS22({
      "src/common/get-file-info.js"(exports22, module22) {
        "use strict";
        var path5 = require("path");
        var options = require_options();
        var config2 = require_resolve_config();
        var createIgnorer = require_create_ignorer();
        async function getFileInfo2(filePath, opts) {
          if (typeof filePath !== "string") {
            throw new TypeError(`expect \`filePath\` to be a string, got \`${typeof filePath}\``);
          }
          const ignorer = await createIgnorer(opts.ignorePath, opts.withNodeModules);
          return _getFileInfo({
            ignorer,
            filePath,
            plugins: opts.plugins,
            resolveConfig: opts.resolveConfig,
            ignorePath: opts.ignorePath,
            sync: false
          });
        }
        getFileInfo2.sync = function(filePath, opts) {
          if (typeof filePath !== "string") {
            throw new TypeError(`expect \`filePath\` to be a string, got \`${typeof filePath}\``);
          }
          const ignorer = createIgnorer.sync(opts.ignorePath, opts.withNodeModules);
          return _getFileInfo({
            ignorer,
            filePath,
            plugins: opts.plugins,
            resolveConfig: opts.resolveConfig,
            ignorePath: opts.ignorePath,
            sync: true
          });
        };
        function getFileParser(resolvedConfig, filePath, plugins2) {
          if (resolvedConfig && resolvedConfig.parser) {
            return resolvedConfig.parser;
          }
          const inferredParser = options.inferParser(filePath, plugins2);
          if (inferredParser) {
            return inferredParser;
          }
          return null;
        }
        function _getFileInfo({
          ignorer,
          filePath,
          plugins: plugins2,
          resolveConfig = false,
          ignorePath,
          sync = false
        }) {
          const normalizedFilePath = normalizeFilePath(filePath, ignorePath);
          const fileInfo = {
            ignored: ignorer.ignores(normalizedFilePath),
            inferredParser: null
          };
          if (fileInfo.ignored) {
            return fileInfo;
          }
          let resolvedConfig;
          if (resolveConfig) {
            if (sync) {
              resolvedConfig = config2.resolveConfig.sync(filePath);
            } else {
              return config2.resolveConfig(filePath).then((resolvedConfig2) => {
                fileInfo.inferredParser = getFileParser(resolvedConfig2, filePath, plugins2);
                return fileInfo;
              });
            }
          }
          fileInfo.inferredParser = getFileParser(resolvedConfig, filePath, plugins2);
          return fileInfo;
        }
        function normalizeFilePath(filePath, ignorePath) {
          return ignorePath ? path5.relative(path5.dirname(ignorePath), filePath) : filePath;
        }
        module22.exports = getFileInfo2;
      }
    });
    var require_util_shared = __commonJS22({
      "src/common/util-shared.js"(exports22, module22) {
        "use strict";
        var {
          getMaxContinuousCount,
          getStringWidth,
          getAlignmentSize,
          getIndentSize,
          skip,
          skipWhitespace,
          skipSpaces,
          skipNewline,
          skipToLineEnd,
          skipEverythingButNewLine,
          skipInlineComment,
          skipTrailingComment,
          hasNewline,
          hasNewlineInRange,
          hasSpaces,
          isNextLineEmpty,
          isNextLineEmptyAfterIndex,
          isPreviousLineEmpty,
          getNextNonSpaceNonCommentCharacterIndex,
          makeString,
          addLeadingComment,
          addDanglingComment,
          addTrailingComment
        } = require_util2();
        module22.exports = {
          getMaxContinuousCount,
          getStringWidth,
          getAlignmentSize,
          getIndentSize,
          skip,
          skipWhitespace,
          skipSpaces,
          skipNewline,
          skipToLineEnd,
          skipEverythingButNewLine,
          skipInlineComment,
          skipTrailingComment,
          hasNewline,
          hasNewlineInRange,
          hasSpaces,
          isNextLineEmpty,
          isNextLineEmptyAfterIndex,
          isPreviousLineEmpty,
          getNextNonSpaceNonCommentCharacterIndex,
          makeString,
          addLeadingComment,
          addDanglingComment,
          addTrailingComment
        };
      }
    });
    var require_array3 = __commonJS22({
      "node_modules/fast-glob/out/utils/array.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.splitWhen = exports22.flatten = void 0;
        function flatten(items) {
          return items.reduce((collection, item) => [].concat(collection, item), []);
        }
        exports22.flatten = flatten;
        function splitWhen(items, predicate) {
          const result = [[]];
          let groupIndex = 0;
          for (const item of items) {
            if (predicate(item)) {
              groupIndex++;
              result[groupIndex] = [];
            } else {
              result[groupIndex].push(item);
            }
          }
          return result;
        }
        exports22.splitWhen = splitWhen;
      }
    });
    var require_errno = __commonJS22({
      "node_modules/fast-glob/out/utils/errno.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.isEnoentCodeError = void 0;
        function isEnoentCodeError(error) {
          return error.code === "ENOENT";
        }
        exports22.isEnoentCodeError = isEnoentCodeError;
      }
    });
    var require_fs = __commonJS22({
      "node_modules/fast-glob/out/utils/fs.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.createDirentFromStats = void 0;
        var DirentFromStats = class {
          constructor(name, stats) {
            this.name = name;
            this.isBlockDevice = stats.isBlockDevice.bind(stats);
            this.isCharacterDevice = stats.isCharacterDevice.bind(stats);
            this.isDirectory = stats.isDirectory.bind(stats);
            this.isFIFO = stats.isFIFO.bind(stats);
            this.isFile = stats.isFile.bind(stats);
            this.isSocket = stats.isSocket.bind(stats);
            this.isSymbolicLink = stats.isSymbolicLink.bind(stats);
          }
        };
        function createDirentFromStats(name, stats) {
          return new DirentFromStats(name, stats);
        }
        exports22.createDirentFromStats = createDirentFromStats;
      }
    });
    var require_path2 = __commonJS22({
      "node_modules/fast-glob/out/utils/path.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.removeLeadingDotSegment = exports22.escape = exports22.makeAbsolute = exports22.unixify = void 0;
        var path5 = require("path");
        var LEADING_DOT_SEGMENT_CHARACTERS_COUNT = 2;
        var UNESCAPED_GLOB_SYMBOLS_RE = /(\\?)([()*?[\]{|}]|^!|[!+@](?=\())/g;
        function unixify(filepath) {
          return filepath.replace(/\\/g, "/");
        }
        exports22.unixify = unixify;
        function makeAbsolute(cwd, filepath) {
          return path5.resolve(cwd, filepath);
        }
        exports22.makeAbsolute = makeAbsolute;
        function escape(pattern) {
          return pattern.replace(UNESCAPED_GLOB_SYMBOLS_RE, "\\$2");
        }
        exports22.escape = escape;
        function removeLeadingDotSegment(entry) {
          if (entry.charAt(0) === ".") {
            const secondCharactery = entry.charAt(1);
            if (secondCharactery === "/" || secondCharactery === "\\") {
              return entry.slice(LEADING_DOT_SEGMENT_CHARACTERS_COUNT);
            }
          }
          return entry;
        }
        exports22.removeLeadingDotSegment = removeLeadingDotSegment;
      }
    });
    var require_is_extglob = __commonJS22({
      "node_modules/is-extglob/index.js"(exports22, module22) {
        module22.exports = function isExtglob(str2) {
          if (typeof str2 !== "string" || str2 === "") {
            return false;
          }
          var match;
          while (match = /(\\).|([@?!+*]\(.*\))/g.exec(str2)) {
            if (match[2])
              return true;
            str2 = str2.slice(match.index + match[0].length);
          }
          return false;
        };
      }
    });
    var require_is_glob = __commonJS22({
      "node_modules/is-glob/index.js"(exports22, module22) {
        var isExtglob = require_is_extglob();
        var chars = {
          "{": "}",
          "(": ")",
          "[": "]"
        };
        var strictCheck = function(str2) {
          if (str2[0] === "!") {
            return true;
          }
          var index = 0;
          var pipeIndex = -2;
          var closeSquareIndex = -2;
          var closeCurlyIndex = -2;
          var closeParenIndex = -2;
          var backSlashIndex = -2;
          while (index < str2.length) {
            if (str2[index] === "*") {
              return true;
            }
            if (str2[index + 1] === "?" && /[\].+)]/.test(str2[index])) {
              return true;
            }
            if (closeSquareIndex !== -1 && str2[index] === "[" && str2[index + 1] !== "]") {
              if (closeSquareIndex < index) {
                closeSquareIndex = str2.indexOf("]", index);
              }
              if (closeSquareIndex > index) {
                if (backSlashIndex === -1 || backSlashIndex > closeSquareIndex) {
                  return true;
                }
                backSlashIndex = str2.indexOf("\\", index);
                if (backSlashIndex === -1 || backSlashIndex > closeSquareIndex) {
                  return true;
                }
              }
            }
            if (closeCurlyIndex !== -1 && str2[index] === "{" && str2[index + 1] !== "}") {
              closeCurlyIndex = str2.indexOf("}", index);
              if (closeCurlyIndex > index) {
                backSlashIndex = str2.indexOf("\\", index);
                if (backSlashIndex === -1 || backSlashIndex > closeCurlyIndex) {
                  return true;
                }
              }
            }
            if (closeParenIndex !== -1 && str2[index] === "(" && str2[index + 1] === "?" && /[:!=]/.test(str2[index + 2]) && str2[index + 3] !== ")") {
              closeParenIndex = str2.indexOf(")", index);
              if (closeParenIndex > index) {
                backSlashIndex = str2.indexOf("\\", index);
                if (backSlashIndex === -1 || backSlashIndex > closeParenIndex) {
                  return true;
                }
              }
            }
            if (pipeIndex !== -1 && str2[index] === "(" && str2[index + 1] !== "|") {
              if (pipeIndex < index) {
                pipeIndex = str2.indexOf("|", index);
              }
              if (pipeIndex !== -1 && str2[pipeIndex + 1] !== ")") {
                closeParenIndex = str2.indexOf(")", pipeIndex);
                if (closeParenIndex > pipeIndex) {
                  backSlashIndex = str2.indexOf("\\", pipeIndex);
                  if (backSlashIndex === -1 || backSlashIndex > closeParenIndex) {
                    return true;
                  }
                }
              }
            }
            if (str2[index] === "\\") {
              var open = str2[index + 1];
              index += 2;
              var close = chars[open];
              if (close) {
                var n = str2.indexOf(close, index);
                if (n !== -1) {
                  index = n + 1;
                }
              }
              if (str2[index] === "!") {
                return true;
              }
            } else {
              index++;
            }
          }
          return false;
        };
        var relaxedCheck = function(str2) {
          if (str2[0] === "!") {
            return true;
          }
          var index = 0;
          while (index < str2.length) {
            if (/[*?{}()[\]]/.test(str2[index])) {
              return true;
            }
            if (str2[index] === "\\") {
              var open = str2[index + 1];
              index += 2;
              var close = chars[open];
              if (close) {
                var n = str2.indexOf(close, index);
                if (n !== -1) {
                  index = n + 1;
                }
              }
              if (str2[index] === "!") {
                return true;
              }
            } else {
              index++;
            }
          }
          return false;
        };
        module22.exports = function isGlob(str2, options) {
          if (typeof str2 !== "string" || str2 === "") {
            return false;
          }
          if (isExtglob(str2)) {
            return true;
          }
          var check = strictCheck;
          if (options && options.strict === false) {
            check = relaxedCheck;
          }
          return check(str2);
        };
      }
    });
    var require_glob_parent = __commonJS22({
      "node_modules/glob-parent/index.js"(exports22, module22) {
        "use strict";
        var isGlob = require_is_glob();
        var pathPosixDirname = require("path").posix.dirname;
        var isWin32 = require("os").platform() === "win32";
        var slash = "/";
        var backslash = /\\/g;
        var enclosure = /[\{\[].*[\}\]]$/;
        var globby = /(^|[^\\])([\{\[]|\([^\)]+$)/;
        var escaped = /\\([\!\*\?\|\[\]\(\)\{\}])/g;
        module22.exports = function globParent(str2, opts) {
          var options = Object.assign({
            flipBackslashes: true
          }, opts);
          if (options.flipBackslashes && isWin32 && str2.indexOf(slash) < 0) {
            str2 = str2.replace(backslash, slash);
          }
          if (enclosure.test(str2)) {
            str2 += slash;
          }
          str2 += "a";
          do {
            str2 = pathPosixDirname(str2);
          } while (isGlob(str2) || globby.test(str2));
          return str2.replace(escaped, "$1");
        };
      }
    });
    var require_pattern2 = __commonJS22({
      "node_modules/fast-glob/out/utils/pattern.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.matchAny = exports22.convertPatternsToRe = exports22.makeRe = exports22.getPatternParts = exports22.expandBraceExpansion = exports22.expandPatternsWithBraceExpansion = exports22.isAffectDepthOfReadingPattern = exports22.endsWithSlashGlobStar = exports22.hasGlobStar = exports22.getBaseDirectory = exports22.isPatternRelatedToParentDirectory = exports22.getPatternsOutsideCurrentDirectory = exports22.getPatternsInsideCurrentDirectory = exports22.getPositivePatterns = exports22.getNegativePatterns = exports22.isPositivePattern = exports22.isNegativePattern = exports22.convertToNegativePattern = exports22.convertToPositivePattern = exports22.isDynamicPattern = exports22.isStaticPattern = void 0;
        var path5 = require("path");
        var globParent = require_glob_parent();
        var micromatch = require_micromatch();
        var GLOBSTAR = "**";
        var ESCAPE_SYMBOL = "\\";
        var COMMON_GLOB_SYMBOLS_RE = /[*?]|^!/;
        var REGEX_CHARACTER_CLASS_SYMBOLS_RE = /\[[^[]*]/;
        var REGEX_GROUP_SYMBOLS_RE = /(?:^|[^!*+?@])\([^(]*\|[^|]*\)/;
        var GLOB_EXTENSION_SYMBOLS_RE = /[!*+?@]\([^(]*\)/;
        var BRACE_EXPANSION_SEPARATORS_RE = /,|\.\./;
        function isStaticPattern(pattern, options = {}) {
          return !isDynamicPattern(pattern, options);
        }
        exports22.isStaticPattern = isStaticPattern;
        function isDynamicPattern(pattern, options = {}) {
          if (pattern === "") {
            return false;
          }
          if (options.caseSensitiveMatch === false || pattern.includes(ESCAPE_SYMBOL)) {
            return true;
          }
          if (COMMON_GLOB_SYMBOLS_RE.test(pattern) || REGEX_CHARACTER_CLASS_SYMBOLS_RE.test(pattern) || REGEX_GROUP_SYMBOLS_RE.test(pattern)) {
            return true;
          }
          if (options.extglob !== false && GLOB_EXTENSION_SYMBOLS_RE.test(pattern)) {
            return true;
          }
          if (options.braceExpansion !== false && hasBraceExpansion(pattern)) {
            return true;
          }
          return false;
        }
        exports22.isDynamicPattern = isDynamicPattern;
        function hasBraceExpansion(pattern) {
          const openingBraceIndex = pattern.indexOf("{");
          if (openingBraceIndex === -1) {
            return false;
          }
          const closingBraceIndex = pattern.indexOf("}", openingBraceIndex + 1);
          if (closingBraceIndex === -1) {
            return false;
          }
          const braceContent = pattern.slice(openingBraceIndex, closingBraceIndex);
          return BRACE_EXPANSION_SEPARATORS_RE.test(braceContent);
        }
        function convertToPositivePattern(pattern) {
          return isNegativePattern(pattern) ? pattern.slice(1) : pattern;
        }
        exports22.convertToPositivePattern = convertToPositivePattern;
        function convertToNegativePattern(pattern) {
          return "!" + pattern;
        }
        exports22.convertToNegativePattern = convertToNegativePattern;
        function isNegativePattern(pattern) {
          return pattern.startsWith("!") && pattern[1] !== "(";
        }
        exports22.isNegativePattern = isNegativePattern;
        function isPositivePattern(pattern) {
          return !isNegativePattern(pattern);
        }
        exports22.isPositivePattern = isPositivePattern;
        function getNegativePatterns(patterns) {
          return patterns.filter(isNegativePattern);
        }
        exports22.getNegativePatterns = getNegativePatterns;
        function getPositivePatterns(patterns) {
          return patterns.filter(isPositivePattern);
        }
        exports22.getPositivePatterns = getPositivePatterns;
        function getPatternsInsideCurrentDirectory(patterns) {
          return patterns.filter((pattern) => !isPatternRelatedToParentDirectory(pattern));
        }
        exports22.getPatternsInsideCurrentDirectory = getPatternsInsideCurrentDirectory;
        function getPatternsOutsideCurrentDirectory(patterns) {
          return patterns.filter(isPatternRelatedToParentDirectory);
        }
        exports22.getPatternsOutsideCurrentDirectory = getPatternsOutsideCurrentDirectory;
        function isPatternRelatedToParentDirectory(pattern) {
          return pattern.startsWith("..") || pattern.startsWith("./..");
        }
        exports22.isPatternRelatedToParentDirectory = isPatternRelatedToParentDirectory;
        function getBaseDirectory(pattern) {
          return globParent(pattern, {
            flipBackslashes: false
          });
        }
        exports22.getBaseDirectory = getBaseDirectory;
        function hasGlobStar(pattern) {
          return pattern.includes(GLOBSTAR);
        }
        exports22.hasGlobStar = hasGlobStar;
        function endsWithSlashGlobStar(pattern) {
          return pattern.endsWith("/" + GLOBSTAR);
        }
        exports22.endsWithSlashGlobStar = endsWithSlashGlobStar;
        function isAffectDepthOfReadingPattern(pattern) {
          const basename3 = path5.basename(pattern);
          return endsWithSlashGlobStar(pattern) || isStaticPattern(basename3);
        }
        exports22.isAffectDepthOfReadingPattern = isAffectDepthOfReadingPattern;
        function expandPatternsWithBraceExpansion(patterns) {
          return patterns.reduce((collection, pattern) => {
            return collection.concat(expandBraceExpansion(pattern));
          }, []);
        }
        exports22.expandPatternsWithBraceExpansion = expandPatternsWithBraceExpansion;
        function expandBraceExpansion(pattern) {
          return micromatch.braces(pattern, {
            expand: true,
            nodupes: true
          });
        }
        exports22.expandBraceExpansion = expandBraceExpansion;
        function getPatternParts(pattern, options) {
          let {
            parts
          } = micromatch.scan(pattern, Object.assign(Object.assign({}, options), {
            parts: true
          }));
          if (parts.length === 0) {
            parts = [pattern];
          }
          if (parts[0].startsWith("/")) {
            parts[0] = parts[0].slice(1);
            parts.unshift("");
          }
          return parts;
        }
        exports22.getPatternParts = getPatternParts;
        function makeRe(pattern, options) {
          return micromatch.makeRe(pattern, options);
        }
        exports22.makeRe = makeRe;
        function convertPatternsToRe(patterns, options) {
          return patterns.map((pattern) => makeRe(pattern, options));
        }
        exports22.convertPatternsToRe = convertPatternsToRe;
        function matchAny(entry, patternsRe) {
          return patternsRe.some((patternRe) => patternRe.test(entry));
        }
        exports22.matchAny = matchAny;
      }
    });
    var require_merge22 = __commonJS22({
      "node_modules/merge2/index.js"(exports22, module22) {
        "use strict";
        var Stream3 = require("stream");
        var PassThrough3 = Stream3.PassThrough;
        var slice = Array.prototype.slice;
        module22.exports = merge22;
        function merge22() {
          const streamsQueue = [];
          const args = slice.call(arguments);
          let merging = false;
          let options = args[args.length - 1];
          if (options && !Array.isArray(options) && options.pipe == null) {
            args.pop();
          } else {
            options = {};
          }
          const doEnd = options.end !== false;
          const doPipeError = options.pipeError === true;
          if (options.objectMode == null) {
            options.objectMode = true;
          }
          if (options.highWaterMark == null) {
            options.highWaterMark = 64 * 1024;
          }
          const mergedStream = PassThrough3(options);
          function addStream() {
            for (let i = 0, len = arguments.length; i < len; i++) {
              streamsQueue.push(pauseStreams(arguments[i], options));
            }
            mergeStream();
            return this;
          }
          function mergeStream() {
            if (merging) {
              return;
            }
            merging = true;
            let streams = streamsQueue.shift();
            if (!streams) {
              process.nextTick(endStream);
              return;
            }
            if (!Array.isArray(streams)) {
              streams = [streams];
            }
            let pipesCount = streams.length + 1;
            function next() {
              if (--pipesCount > 0) {
                return;
              }
              merging = false;
              mergeStream();
            }
            function pipe(stream) {
              function onend() {
                stream.removeListener("merge2UnpipeEnd", onend);
                stream.removeListener("end", onend);
                if (doPipeError) {
                  stream.removeListener("error", onerror);
                }
                next();
              }
              function onerror(err) {
                mergedStream.emit("error", err);
              }
              if (stream._readableState.endEmitted) {
                return next();
              }
              stream.on("merge2UnpipeEnd", onend);
              stream.on("end", onend);
              if (doPipeError) {
                stream.on("error", onerror);
              }
              stream.pipe(mergedStream, {
                end: false
              });
              stream.resume();
            }
            for (let i = 0; i < streams.length; i++) {
              pipe(streams[i]);
            }
            next();
          }
          function endStream() {
            merging = false;
            mergedStream.emit("queueDrain");
            if (doEnd) {
              mergedStream.end();
            }
          }
          mergedStream.setMaxListeners(0);
          mergedStream.add = addStream;
          mergedStream.on("unpipe", function(stream) {
            stream.emit("merge2UnpipeEnd");
          });
          if (args.length) {
            addStream.apply(null, args);
          }
          return mergedStream;
        }
        function pauseStreams(streams, options) {
          if (!Array.isArray(streams)) {
            if (!streams._readableState && streams.pipe) {
              streams = streams.pipe(PassThrough3(options));
            }
            if (!streams._readableState || !streams.pause || !streams.pipe) {
              throw new Error("Only readable stream can be merged.");
            }
            streams.pause();
          } else {
            for (let i = 0, len = streams.length; i < len; i++) {
              streams[i] = pauseStreams(streams[i], options);
            }
          }
          return streams;
        }
      }
    });
    var require_stream = __commonJS22({
      "node_modules/fast-glob/out/utils/stream.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.merge = void 0;
        var merge22 = require_merge22();
        function merge3(streams) {
          const mergedStream = merge22(streams);
          streams.forEach((stream) => {
            stream.once("error", (error) => mergedStream.emit("error", error));
          });
          mergedStream.once("close", () => propagateCloseEventToSources(streams));
          mergedStream.once("end", () => propagateCloseEventToSources(streams));
          return mergedStream;
        }
        exports22.merge = merge3;
        function propagateCloseEventToSources(streams) {
          streams.forEach((stream) => stream.emit("close"));
        }
      }
    });
    var require_string22 = __commonJS22({
      "node_modules/fast-glob/out/utils/string.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.isEmpty = exports22.isString = void 0;
        function isString2(input) {
          return typeof input === "string";
        }
        exports22.isString = isString2;
        function isEmpty(input) {
          return input === "";
        }
        exports22.isEmpty = isEmpty;
      }
    });
    var require_utils42 = __commonJS22({
      "node_modules/fast-glob/out/utils/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.string = exports22.stream = exports22.pattern = exports22.path = exports22.fs = exports22.errno = exports22.array = void 0;
        var array = require_array3();
        exports22.array = array;
        var errno = require_errno();
        exports22.errno = errno;
        var fs = require_fs();
        exports22.fs = fs;
        var path5 = require_path2();
        exports22.path = path5;
        var pattern = require_pattern2();
        exports22.pattern = pattern;
        var stream = require_stream();
        exports22.stream = stream;
        var string3 = require_string22();
        exports22.string = string3;
      }
    });
    var require_tasks = __commonJS22({
      "node_modules/fast-glob/out/managers/tasks.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.convertPatternGroupToTask = exports22.convertPatternGroupsToTasks = exports22.groupPatternsByBaseDirectory = exports22.getNegativePatternsAsPositive = exports22.getPositivePatterns = exports22.convertPatternsToTasks = exports22.generate = void 0;
        var utils = require_utils42();
        function generate(patterns, settings) {
          const positivePatterns = getPositivePatterns(patterns);
          const negativePatterns = getNegativePatternsAsPositive(patterns, settings.ignore);
          const staticPatterns = positivePatterns.filter((pattern) => utils.pattern.isStaticPattern(pattern, settings));
          const dynamicPatterns = positivePatterns.filter((pattern) => utils.pattern.isDynamicPattern(pattern, settings));
          const staticTasks = convertPatternsToTasks(staticPatterns, negativePatterns, false);
          const dynamicTasks = convertPatternsToTasks(dynamicPatterns, negativePatterns, true);
          return staticTasks.concat(dynamicTasks);
        }
        exports22.generate = generate;
        function convertPatternsToTasks(positive, negative, dynamic) {
          const tasks = [];
          const patternsOutsideCurrentDirectory = utils.pattern.getPatternsOutsideCurrentDirectory(positive);
          const patternsInsideCurrentDirectory = utils.pattern.getPatternsInsideCurrentDirectory(positive);
          const outsideCurrentDirectoryGroup = groupPatternsByBaseDirectory(patternsOutsideCurrentDirectory);
          const insideCurrentDirectoryGroup = groupPatternsByBaseDirectory(patternsInsideCurrentDirectory);
          tasks.push(...convertPatternGroupsToTasks(outsideCurrentDirectoryGroup, negative, dynamic));
          if ("." in insideCurrentDirectoryGroup) {
            tasks.push(convertPatternGroupToTask(".", patternsInsideCurrentDirectory, negative, dynamic));
          } else {
            tasks.push(...convertPatternGroupsToTasks(insideCurrentDirectoryGroup, negative, dynamic));
          }
          return tasks;
        }
        exports22.convertPatternsToTasks = convertPatternsToTasks;
        function getPositivePatterns(patterns) {
          return utils.pattern.getPositivePatterns(patterns);
        }
        exports22.getPositivePatterns = getPositivePatterns;
        function getNegativePatternsAsPositive(patterns, ignore) {
          const negative = utils.pattern.getNegativePatterns(patterns).concat(ignore);
          const positive = negative.map(utils.pattern.convertToPositivePattern);
          return positive;
        }
        exports22.getNegativePatternsAsPositive = getNegativePatternsAsPositive;
        function groupPatternsByBaseDirectory(patterns) {
          const group = {};
          return patterns.reduce((collection, pattern) => {
            const base = utils.pattern.getBaseDirectory(pattern);
            if (base in collection) {
              collection[base].push(pattern);
            } else {
              collection[base] = [pattern];
            }
            return collection;
          }, group);
        }
        exports22.groupPatternsByBaseDirectory = groupPatternsByBaseDirectory;
        function convertPatternGroupsToTasks(positive, negative, dynamic) {
          return Object.keys(positive).map((base) => {
            return convertPatternGroupToTask(base, positive[base], negative, dynamic);
          });
        }
        exports22.convertPatternGroupsToTasks = convertPatternGroupsToTasks;
        function convertPatternGroupToTask(base, positive, negative, dynamic) {
          return {
            dynamic,
            positive,
            negative,
            base,
            patterns: [].concat(positive, negative.map(utils.pattern.convertToNegativePattern))
          };
        }
        exports22.convertPatternGroupToTask = convertPatternGroupToTask;
      }
    });
    var require_patterns = __commonJS22({
      "node_modules/fast-glob/out/managers/patterns.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.removeDuplicateSlashes = exports22.transform = void 0;
        var DOUBLE_SLASH_RE = /(?!^)\/{2,}/g;
        function transform3(patterns) {
          return patterns.map((pattern) => removeDuplicateSlashes(pattern));
        }
        exports22.transform = transform3;
        function removeDuplicateSlashes(pattern) {
          return pattern.replace(DOUBLE_SLASH_RE, "/");
        }
        exports22.removeDuplicateSlashes = removeDuplicateSlashes;
      }
    });
    var require_async22 = __commonJS22({
      "node_modules/@nodelib/fs.stat/out/providers/async.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.read = void 0;
        function read(path5, settings, callback) {
          settings.fs.lstat(path5, (lstatError, lstat) => {
            if (lstatError !== null) {
              callFailureCallback(callback, lstatError);
              return;
            }
            if (!lstat.isSymbolicLink() || !settings.followSymbolicLink) {
              callSuccessCallback(callback, lstat);
              return;
            }
            settings.fs.stat(path5, (statError, stat) => {
              if (statError !== null) {
                if (settings.throwErrorOnBrokenSymbolicLink) {
                  callFailureCallback(callback, statError);
                  return;
                }
                callSuccessCallback(callback, lstat);
                return;
              }
              if (settings.markSymbolicLink) {
                stat.isSymbolicLink = () => true;
              }
              callSuccessCallback(callback, stat);
            });
          });
        }
        exports22.read = read;
        function callFailureCallback(callback, error) {
          callback(error);
        }
        function callSuccessCallback(callback, result) {
          callback(null, result);
        }
      }
    });
    var require_sync2 = __commonJS22({
      "node_modules/@nodelib/fs.stat/out/providers/sync.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.read = void 0;
        function read(path5, settings) {
          const lstat = settings.fs.lstatSync(path5);
          if (!lstat.isSymbolicLink() || !settings.followSymbolicLink) {
            return lstat;
          }
          try {
            const stat = settings.fs.statSync(path5);
            if (settings.markSymbolicLink) {
              stat.isSymbolicLink = () => true;
            }
            return stat;
          } catch (error) {
            if (!settings.throwErrorOnBrokenSymbolicLink) {
              return lstat;
            }
            throw error;
          }
        }
        exports22.read = read;
      }
    });
    var require_fs2 = __commonJS22({
      "node_modules/@nodelib/fs.stat/out/adapters/fs.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.createFileSystemAdapter = exports22.FILE_SYSTEM_ADAPTER = void 0;
        var fs = require("fs");
        exports22.FILE_SYSTEM_ADAPTER = {
          lstat: fs.lstat,
          stat: fs.stat,
          lstatSync: fs.lstatSync,
          statSync: fs.statSync
        };
        function createFileSystemAdapter(fsMethods) {
          if (fsMethods === void 0) {
            return exports22.FILE_SYSTEM_ADAPTER;
          }
          return Object.assign(Object.assign({}, exports22.FILE_SYSTEM_ADAPTER), fsMethods);
        }
        exports22.createFileSystemAdapter = createFileSystemAdapter;
      }
    });
    var require_settings = __commonJS22({
      "node_modules/@nodelib/fs.stat/out/settings.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var fs = require_fs2();
        var Settings = class {
          constructor(_options = {}) {
            this._options = _options;
            this.followSymbolicLink = this._getValue(this._options.followSymbolicLink, true);
            this.fs = fs.createFileSystemAdapter(this._options.fs);
            this.markSymbolicLink = this._getValue(this._options.markSymbolicLink, false);
            this.throwErrorOnBrokenSymbolicLink = this._getValue(this._options.throwErrorOnBrokenSymbolicLink, true);
          }
          _getValue(option, value) {
            return option !== null && option !== void 0 ? option : value;
          }
        };
        exports22.default = Settings;
      }
    });
    var require_out = __commonJS22({
      "node_modules/@nodelib/fs.stat/out/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.statSync = exports22.stat = exports22.Settings = void 0;
        var async = require_async22();
        var sync = require_sync2();
        var settings_1 = require_settings();
        exports22.Settings = settings_1.default;
        function stat(path5, optionsOrSettingsOrCallback, callback) {
          if (typeof optionsOrSettingsOrCallback === "function") {
            async.read(path5, getSettings(), optionsOrSettingsOrCallback);
            return;
          }
          async.read(path5, getSettings(optionsOrSettingsOrCallback), callback);
        }
        exports22.stat = stat;
        function statSync(path5, optionsOrSettings) {
          const settings = getSettings(optionsOrSettings);
          return sync.read(path5, settings);
        }
        exports22.statSync = statSync;
        function getSettings(settingsOrOptions = {}) {
          if (settingsOrOptions instanceof settings_1.default) {
            return settingsOrOptions;
          }
          return new settings_1.default(settingsOrOptions);
        }
      }
    });
    var require_queue_microtask = __commonJS22({
      "node_modules/queue-microtask/index.js"(exports22, module22) {
        var promise;
        module22.exports = typeof queueMicrotask === "function" ? queueMicrotask.bind(typeof window !== "undefined" ? window : global) : (cb) => (promise || (promise = Promise.resolve())).then(cb).catch((err) => setTimeout(() => {
          throw err;
        }, 0));
      }
    });
    var require_run_parallel = __commonJS22({
      "node_modules/run-parallel/index.js"(exports22, module22) {
        module22.exports = runParallel;
        var queueMicrotask2 = require_queue_microtask();
        function runParallel(tasks, cb) {
          let results, pending, keys5;
          let isSync = true;
          if (Array.isArray(tasks)) {
            results = [];
            pending = tasks.length;
          } else {
            keys5 = Object.keys(tasks);
            results = {};
            pending = keys5.length;
          }
          function done(err) {
            function end() {
              if (cb)
                cb(err, results);
              cb = null;
            }
            if (isSync)
              queueMicrotask2(end);
            else
              end();
          }
          function each(i, err, result) {
            results[i] = result;
            if (--pending === 0 || err) {
              done(err);
            }
          }
          if (!pending) {
            done(null);
          } else if (keys5) {
            keys5.forEach(function(key) {
              tasks[key](function(err, result) {
                each(key, err, result);
              });
            });
          } else {
            tasks.forEach(function(task, i) {
              task(function(err, result) {
                each(i, err, result);
              });
            });
          }
          isSync = false;
        }
      }
    });
    var require_constants4 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/constants.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.IS_SUPPORT_READDIR_WITH_FILE_TYPES = void 0;
        var NODE_PROCESS_VERSION_PARTS = process.versions.node.split(".");
        if (NODE_PROCESS_VERSION_PARTS[0] === void 0 || NODE_PROCESS_VERSION_PARTS[1] === void 0) {
          throw new Error(`Unexpected behavior. The 'process.versions.node' variable has invalid value: ${process.versions.node}`);
        }
        var MAJOR_VERSION = Number.parseInt(NODE_PROCESS_VERSION_PARTS[0], 10);
        var MINOR_VERSION = Number.parseInt(NODE_PROCESS_VERSION_PARTS[1], 10);
        var SUPPORTED_MAJOR_VERSION = 10;
        var SUPPORTED_MINOR_VERSION = 10;
        var IS_MATCHED_BY_MAJOR = MAJOR_VERSION > SUPPORTED_MAJOR_VERSION;
        var IS_MATCHED_BY_MAJOR_AND_MINOR = MAJOR_VERSION === SUPPORTED_MAJOR_VERSION && MINOR_VERSION >= SUPPORTED_MINOR_VERSION;
        exports22.IS_SUPPORT_READDIR_WITH_FILE_TYPES = IS_MATCHED_BY_MAJOR || IS_MATCHED_BY_MAJOR_AND_MINOR;
      }
    });
    var require_fs3 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/utils/fs.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.createDirentFromStats = void 0;
        var DirentFromStats = class {
          constructor(name, stats) {
            this.name = name;
            this.isBlockDevice = stats.isBlockDevice.bind(stats);
            this.isCharacterDevice = stats.isCharacterDevice.bind(stats);
            this.isDirectory = stats.isDirectory.bind(stats);
            this.isFIFO = stats.isFIFO.bind(stats);
            this.isFile = stats.isFile.bind(stats);
            this.isSocket = stats.isSocket.bind(stats);
            this.isSymbolicLink = stats.isSymbolicLink.bind(stats);
          }
        };
        function createDirentFromStats(name, stats) {
          return new DirentFromStats(name, stats);
        }
        exports22.createDirentFromStats = createDirentFromStats;
      }
    });
    var require_utils52 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/utils/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.fs = void 0;
        var fs = require_fs3();
        exports22.fs = fs;
      }
    });
    var require_common32 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/providers/common.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.joinPathSegments = void 0;
        function joinPathSegments(a, b, separator) {
          if (a.endsWith(separator)) {
            return a + b;
          }
          return a + separator + b;
        }
        exports22.joinPathSegments = joinPathSegments;
      }
    });
    var require_async3 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/providers/async.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.readdir = exports22.readdirWithFileTypes = exports22.read = void 0;
        var fsStat = require_out();
        var rpl = require_run_parallel();
        var constants_1 = require_constants4();
        var utils = require_utils52();
        var common2 = require_common32();
        function read(directory, settings, callback) {
          if (!settings.stats && constants_1.IS_SUPPORT_READDIR_WITH_FILE_TYPES) {
            readdirWithFileTypes(directory, settings, callback);
            return;
          }
          readdir(directory, settings, callback);
        }
        exports22.read = read;
        function readdirWithFileTypes(directory, settings, callback) {
          settings.fs.readdir(directory, {
            withFileTypes: true
          }, (readdirError, dirents) => {
            if (readdirError !== null) {
              callFailureCallback(callback, readdirError);
              return;
            }
            const entries4 = dirents.map((dirent) => ({
              dirent,
              name: dirent.name,
              path: common2.joinPathSegments(directory, dirent.name, settings.pathSegmentSeparator)
            }));
            if (!settings.followSymbolicLinks) {
              callSuccessCallback(callback, entries4);
              return;
            }
            const tasks = entries4.map((entry) => makeRplTaskEntry(entry, settings));
            rpl(tasks, (rplError, rplEntries) => {
              if (rplError !== null) {
                callFailureCallback(callback, rplError);
                return;
              }
              callSuccessCallback(callback, rplEntries);
            });
          });
        }
        exports22.readdirWithFileTypes = readdirWithFileTypes;
        function makeRplTaskEntry(entry, settings) {
          return (done) => {
            if (!entry.dirent.isSymbolicLink()) {
              done(null, entry);
              return;
            }
            settings.fs.stat(entry.path, (statError, stats) => {
              if (statError !== null) {
                if (settings.throwErrorOnBrokenSymbolicLink) {
                  done(statError);
                  return;
                }
                done(null, entry);
                return;
              }
              entry.dirent = utils.fs.createDirentFromStats(entry.name, stats);
              done(null, entry);
            });
          };
        }
        function readdir(directory, settings, callback) {
          settings.fs.readdir(directory, (readdirError, names) => {
            if (readdirError !== null) {
              callFailureCallback(callback, readdirError);
              return;
            }
            const tasks = names.map((name) => {
              const path5 = common2.joinPathSegments(directory, name, settings.pathSegmentSeparator);
              return (done) => {
                fsStat.stat(path5, settings.fsStatSettings, (error, stats) => {
                  if (error !== null) {
                    done(error);
                    return;
                  }
                  const entry = {
                    name,
                    path: path5,
                    dirent: utils.fs.createDirentFromStats(name, stats)
                  };
                  if (settings.stats) {
                    entry.stats = stats;
                  }
                  done(null, entry);
                });
              };
            });
            rpl(tasks, (rplError, entries4) => {
              if (rplError !== null) {
                callFailureCallback(callback, rplError);
                return;
              }
              callSuccessCallback(callback, entries4);
            });
          });
        }
        exports22.readdir = readdir;
        function callFailureCallback(callback, error) {
          callback(error);
        }
        function callSuccessCallback(callback, result) {
          callback(null, result);
        }
      }
    });
    var require_sync3 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/providers/sync.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.readdir = exports22.readdirWithFileTypes = exports22.read = void 0;
        var fsStat = require_out();
        var constants_1 = require_constants4();
        var utils = require_utils52();
        var common2 = require_common32();
        function read(directory, settings) {
          if (!settings.stats && constants_1.IS_SUPPORT_READDIR_WITH_FILE_TYPES) {
            return readdirWithFileTypes(directory, settings);
          }
          return readdir(directory, settings);
        }
        exports22.read = read;
        function readdirWithFileTypes(directory, settings) {
          const dirents = settings.fs.readdirSync(directory, {
            withFileTypes: true
          });
          return dirents.map((dirent) => {
            const entry = {
              dirent,
              name: dirent.name,
              path: common2.joinPathSegments(directory, dirent.name, settings.pathSegmentSeparator)
            };
            if (entry.dirent.isSymbolicLink() && settings.followSymbolicLinks) {
              try {
                const stats = settings.fs.statSync(entry.path);
                entry.dirent = utils.fs.createDirentFromStats(entry.name, stats);
              } catch (error) {
                if (settings.throwErrorOnBrokenSymbolicLink) {
                  throw error;
                }
              }
            }
            return entry;
          });
        }
        exports22.readdirWithFileTypes = readdirWithFileTypes;
        function readdir(directory, settings) {
          const names = settings.fs.readdirSync(directory);
          return names.map((name) => {
            const entryPath = common2.joinPathSegments(directory, name, settings.pathSegmentSeparator);
            const stats = fsStat.statSync(entryPath, settings.fsStatSettings);
            const entry = {
              name,
              path: entryPath,
              dirent: utils.fs.createDirentFromStats(name, stats)
            };
            if (settings.stats) {
              entry.stats = stats;
            }
            return entry;
          });
        }
        exports22.readdir = readdir;
      }
    });
    var require_fs4 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/adapters/fs.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.createFileSystemAdapter = exports22.FILE_SYSTEM_ADAPTER = void 0;
        var fs = require("fs");
        exports22.FILE_SYSTEM_ADAPTER = {
          lstat: fs.lstat,
          stat: fs.stat,
          lstatSync: fs.lstatSync,
          statSync: fs.statSync,
          readdir: fs.readdir,
          readdirSync: fs.readdirSync
        };
        function createFileSystemAdapter(fsMethods) {
          if (fsMethods === void 0) {
            return exports22.FILE_SYSTEM_ADAPTER;
          }
          return Object.assign(Object.assign({}, exports22.FILE_SYSTEM_ADAPTER), fsMethods);
        }
        exports22.createFileSystemAdapter = createFileSystemAdapter;
      }
    });
    var require_settings2 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/settings.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var path5 = require("path");
        var fsStat = require_out();
        var fs = require_fs4();
        var Settings = class {
          constructor(_options = {}) {
            this._options = _options;
            this.followSymbolicLinks = this._getValue(this._options.followSymbolicLinks, false);
            this.fs = fs.createFileSystemAdapter(this._options.fs);
            this.pathSegmentSeparator = this._getValue(this._options.pathSegmentSeparator, path5.sep);
            this.stats = this._getValue(this._options.stats, false);
            this.throwErrorOnBrokenSymbolicLink = this._getValue(this._options.throwErrorOnBrokenSymbolicLink, true);
            this.fsStatSettings = new fsStat.Settings({
              followSymbolicLink: this.followSymbolicLinks,
              fs: this.fs,
              throwErrorOnBrokenSymbolicLink: this.throwErrorOnBrokenSymbolicLink
            });
          }
          _getValue(option, value) {
            return option !== null && option !== void 0 ? option : value;
          }
        };
        exports22.default = Settings;
      }
    });
    var require_out2 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.Settings = exports22.scandirSync = exports22.scandir = void 0;
        var async = require_async3();
        var sync = require_sync3();
        var settings_1 = require_settings2();
        exports22.Settings = settings_1.default;
        function scandir(path5, optionsOrSettingsOrCallback, callback) {
          if (typeof optionsOrSettingsOrCallback === "function") {
            async.read(path5, getSettings(), optionsOrSettingsOrCallback);
            return;
          }
          async.read(path5, getSettings(optionsOrSettingsOrCallback), callback);
        }
        exports22.scandir = scandir;
        function scandirSync(path5, optionsOrSettings) {
          const settings = getSettings(optionsOrSettings);
          return sync.read(path5, settings);
        }
        exports22.scandirSync = scandirSync;
        function getSettings(settingsOrOptions = {}) {
          if (settingsOrOptions instanceof settings_1.default) {
            return settingsOrOptions;
          }
          return new settings_1.default(settingsOrOptions);
        }
      }
    });
    var require_reusify = __commonJS22({
      "node_modules/reusify/reusify.js"(exports22, module22) {
        "use strict";
        function reusify(Constructor) {
          var head = new Constructor();
          var tail = head;
          function get2() {
            var current = head;
            if (current.next) {
              head = current.next;
            } else {
              head = new Constructor();
              tail = head;
            }
            current.next = null;
            return current;
          }
          function release(obj) {
            tail.next = obj;
            tail = obj;
          }
          return {
            get: get2,
            release
          };
        }
        module22.exports = reusify;
      }
    });
    var require_queue = __commonJS22({
      "node_modules/fastq/queue.js"(exports22, module22) {
        "use strict";
        var reusify = require_reusify();
        function fastqueue(context, worker, concurrency) {
          if (typeof context === "function") {
            concurrency = worker;
            worker = context;
            context = null;
          }
          if (concurrency < 1) {
            throw new Error("fastqueue concurrency must be greater than 1");
          }
          var cache = reusify(Task);
          var queueHead = null;
          var queueTail = null;
          var _running = 0;
          var errorHandler = null;
          var self2 = {
            push,
            drain: noop2,
            saturated: noop2,
            pause,
            paused: false,
            concurrency,
            running,
            resume,
            idle,
            length,
            getQueue,
            unshift,
            empty: noop2,
            kill,
            killAndDrain,
            error
          };
          return self2;
          function running() {
            return _running;
          }
          function pause() {
            self2.paused = true;
          }
          function length() {
            var current = queueHead;
            var counter = 0;
            while (current) {
              current = current.next;
              counter++;
            }
            return counter;
          }
          function getQueue() {
            var current = queueHead;
            var tasks = [];
            while (current) {
              tasks.push(current.value);
              current = current.next;
            }
            return tasks;
          }
          function resume() {
            if (!self2.paused)
              return;
            self2.paused = false;
            for (var i = 0; i < self2.concurrency; i++) {
              _running++;
              release();
            }
          }
          function idle() {
            return _running === 0 && self2.length() === 0;
          }
          function push(value, done) {
            var current = cache.get();
            current.context = context;
            current.release = release;
            current.value = value;
            current.callback = done || noop2;
            current.errorHandler = errorHandler;
            if (_running === self2.concurrency || self2.paused) {
              if (queueTail) {
                queueTail.next = current;
                queueTail = current;
              } else {
                queueHead = current;
                queueTail = current;
                self2.saturated();
              }
            } else {
              _running++;
              worker.call(context, current.value, current.worked);
            }
          }
          function unshift(value, done) {
            var current = cache.get();
            current.context = context;
            current.release = release;
            current.value = value;
            current.callback = done || noop2;
            if (_running === self2.concurrency || self2.paused) {
              if (queueHead) {
                current.next = queueHead;
                queueHead = current;
              } else {
                queueHead = current;
                queueTail = current;
                self2.saturated();
              }
            } else {
              _running++;
              worker.call(context, current.value, current.worked);
            }
          }
          function release(holder) {
            if (holder) {
              cache.release(holder);
            }
            var next = queueHead;
            if (next) {
              if (!self2.paused) {
                if (queueTail === queueHead) {
                  queueTail = null;
                }
                queueHead = next.next;
                next.next = null;
                worker.call(context, next.value, next.worked);
                if (queueTail === null) {
                  self2.empty();
                }
              } else {
                _running--;
              }
            } else if (--_running === 0) {
              self2.drain();
            }
          }
          function kill() {
            queueHead = null;
            queueTail = null;
            self2.drain = noop2;
          }
          function killAndDrain() {
            queueHead = null;
            queueTail = null;
            self2.drain();
            self2.drain = noop2;
          }
          function error(handler) {
            errorHandler = handler;
          }
        }
        function noop2() {
        }
        function Task() {
          this.value = null;
          this.callback = noop2;
          this.next = null;
          this.release = noop2;
          this.context = null;
          this.errorHandler = null;
          var self2 = this;
          this.worked = function worked(err, result) {
            var callback = self2.callback;
            var errorHandler = self2.errorHandler;
            var val = self2.value;
            self2.value = null;
            self2.callback = noop2;
            if (self2.errorHandler) {
              errorHandler(err, val);
            }
            callback.call(self2.context, err, result);
            self2.release(self2);
          };
        }
        function queueAsPromised(context, worker, concurrency) {
          if (typeof context === "function") {
            concurrency = worker;
            worker = context;
            context = null;
          }
          function asyncWrapper(arg, cb) {
            worker.call(this, arg).then(function(res) {
              cb(null, res);
            }, cb);
          }
          var queue = fastqueue(context, asyncWrapper, concurrency);
          var pushCb = queue.push;
          var unshiftCb = queue.unshift;
          queue.push = push;
          queue.unshift = unshift;
          queue.drained = drained;
          return queue;
          function push(value) {
            var p = new Promise(function(resolve, reject) {
              pushCb(value, function(err, result) {
                if (err) {
                  reject(err);
                  return;
                }
                resolve(result);
              });
            });
            p.catch(noop2);
            return p;
          }
          function unshift(value) {
            var p = new Promise(function(resolve, reject) {
              unshiftCb(value, function(err, result) {
                if (err) {
                  reject(err);
                  return;
                }
                resolve(result);
              });
            });
            p.catch(noop2);
            return p;
          }
          function drained() {
            var previousDrain = queue.drain;
            var p = new Promise(function(resolve) {
              queue.drain = function() {
                previousDrain();
                resolve();
              };
            });
            return p;
          }
        }
        module22.exports = fastqueue;
        module22.exports.promise = queueAsPromised;
      }
    });
    var require_common4 = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/readers/common.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.joinPathSegments = exports22.replacePathSegmentSeparator = exports22.isAppliedFilter = exports22.isFatalError = void 0;
        function isFatalError(settings, error) {
          if (settings.errorFilter === null) {
            return true;
          }
          return !settings.errorFilter(error);
        }
        exports22.isFatalError = isFatalError;
        function isAppliedFilter(filter, value) {
          return filter === null || filter(value);
        }
        exports22.isAppliedFilter = isAppliedFilter;
        function replacePathSegmentSeparator(filepath, separator) {
          return filepath.split(/[/\\]/).join(separator);
        }
        exports22.replacePathSegmentSeparator = replacePathSegmentSeparator;
        function joinPathSegments(a, b, separator) {
          if (a === "") {
            return b;
          }
          if (a.endsWith(separator)) {
            return a + b;
          }
          return a + separator + b;
        }
        exports22.joinPathSegments = joinPathSegments;
      }
    });
    var require_reader = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/readers/reader.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var common2 = require_common4();
        var Reader = class {
          constructor(_root, _settings) {
            this._root = _root;
            this._settings = _settings;
            this._root = common2.replacePathSegmentSeparator(_root, _settings.pathSegmentSeparator);
          }
        };
        exports22.default = Reader;
      }
    });
    var require_async4 = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/readers/async.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var events_1 = require("events");
        var fsScandir = require_out2();
        var fastq = require_queue();
        var common2 = require_common4();
        var reader_1 = require_reader();
        var AsyncReader = class extends reader_1.default {
          constructor(_root, _settings) {
            super(_root, _settings);
            this._settings = _settings;
            this._scandir = fsScandir.scandir;
            this._emitter = new events_1.EventEmitter();
            this._queue = fastq(this._worker.bind(this), this._settings.concurrency);
            this._isFatalError = false;
            this._isDestroyed = false;
            this._queue.drain = () => {
              if (!this._isFatalError) {
                this._emitter.emit("end");
              }
            };
          }
          read() {
            this._isFatalError = false;
            this._isDestroyed = false;
            setImmediate(() => {
              this._pushToQueue(this._root, this._settings.basePath);
            });
            return this._emitter;
          }
          get isDestroyed() {
            return this._isDestroyed;
          }
          destroy() {
            if (this._isDestroyed) {
              throw new Error("The reader is already destroyed");
            }
            this._isDestroyed = true;
            this._queue.killAndDrain();
          }
          onEntry(callback) {
            this._emitter.on("entry", callback);
          }
          onError(callback) {
            this._emitter.once("error", callback);
          }
          onEnd(callback) {
            this._emitter.once("end", callback);
          }
          _pushToQueue(directory, base) {
            const queueItem = {
              directory,
              base
            };
            this._queue.push(queueItem, (error) => {
              if (error !== null) {
                this._handleError(error);
              }
            });
          }
          _worker(item, done) {
            this._scandir(item.directory, this._settings.fsScandirSettings, (error, entries4) => {
              if (error !== null) {
                done(error, void 0);
                return;
              }
              for (const entry of entries4) {
                this._handleEntry(entry, item.base);
              }
              done(null, void 0);
            });
          }
          _handleError(error) {
            if (this._isDestroyed || !common2.isFatalError(this._settings, error)) {
              return;
            }
            this._isFatalError = true;
            this._isDestroyed = true;
            this._emitter.emit("error", error);
          }
          _handleEntry(entry, base) {
            if (this._isDestroyed || this._isFatalError) {
              return;
            }
            const fullpath = entry.path;
            if (base !== void 0) {
              entry.path = common2.joinPathSegments(base, entry.name, this._settings.pathSegmentSeparator);
            }
            if (common2.isAppliedFilter(this._settings.entryFilter, entry)) {
              this._emitEntry(entry);
            }
            if (entry.dirent.isDirectory() && common2.isAppliedFilter(this._settings.deepFilter, entry)) {
              this._pushToQueue(fullpath, base === void 0 ? void 0 : entry.path);
            }
          }
          _emitEntry(entry) {
            this._emitter.emit("entry", entry);
          }
        };
        exports22.default = AsyncReader;
      }
    });
    var require_async5 = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/providers/async.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var async_1 = require_async4();
        var AsyncProvider = class {
          constructor(_root, _settings) {
            this._root = _root;
            this._settings = _settings;
            this._reader = new async_1.default(this._root, this._settings);
            this._storage = [];
          }
          read(callback) {
            this._reader.onError((error) => {
              callFailureCallback(callback, error);
            });
            this._reader.onEntry((entry) => {
              this._storage.push(entry);
            });
            this._reader.onEnd(() => {
              callSuccessCallback(callback, this._storage);
            });
            this._reader.read();
          }
        };
        exports22.default = AsyncProvider;
        function callFailureCallback(callback, error) {
          callback(error);
        }
        function callSuccessCallback(callback, entries4) {
          callback(null, entries4);
        }
      }
    });
    var require_stream2 = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/providers/stream.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var stream_1 = require("stream");
        var async_1 = require_async4();
        var StreamProvider = class {
          constructor(_root, _settings) {
            this._root = _root;
            this._settings = _settings;
            this._reader = new async_1.default(this._root, this._settings);
            this._stream = new stream_1.Readable({
              objectMode: true,
              read: () => {
              },
              destroy: () => {
                if (!this._reader.isDestroyed) {
                  this._reader.destroy();
                }
              }
            });
          }
          read() {
            this._reader.onError((error) => {
              this._stream.emit("error", error);
            });
            this._reader.onEntry((entry) => {
              this._stream.push(entry);
            });
            this._reader.onEnd(() => {
              this._stream.push(null);
            });
            this._reader.read();
            return this._stream;
          }
        };
        exports22.default = StreamProvider;
      }
    });
    var require_sync4 = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/readers/sync.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var fsScandir = require_out2();
        var common2 = require_common4();
        var reader_1 = require_reader();
        var SyncReader = class extends reader_1.default {
          constructor() {
            super(...arguments);
            this._scandir = fsScandir.scandirSync;
            this._storage = [];
            this._queue = /* @__PURE__ */ new Set();
          }
          read() {
            this._pushToQueue(this._root, this._settings.basePath);
            this._handleQueue();
            return this._storage;
          }
          _pushToQueue(directory, base) {
            this._queue.add({
              directory,
              base
            });
          }
          _handleQueue() {
            for (const item of this._queue.values()) {
              this._handleDirectory(item.directory, item.base);
            }
          }
          _handleDirectory(directory, base) {
            try {
              const entries4 = this._scandir(directory, this._settings.fsScandirSettings);
              for (const entry of entries4) {
                this._handleEntry(entry, base);
              }
            } catch (error) {
              this._handleError(error);
            }
          }
          _handleError(error) {
            if (!common2.isFatalError(this._settings, error)) {
              return;
            }
            throw error;
          }
          _handleEntry(entry, base) {
            const fullpath = entry.path;
            if (base !== void 0) {
              entry.path = common2.joinPathSegments(base, entry.name, this._settings.pathSegmentSeparator);
            }
            if (common2.isAppliedFilter(this._settings.entryFilter, entry)) {
              this._pushToStorage(entry);
            }
            if (entry.dirent.isDirectory() && common2.isAppliedFilter(this._settings.deepFilter, entry)) {
              this._pushToQueue(fullpath, base === void 0 ? void 0 : entry.path);
            }
          }
          _pushToStorage(entry) {
            this._storage.push(entry);
          }
        };
        exports22.default = SyncReader;
      }
    });
    var require_sync5 = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/providers/sync.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var sync_1 = require_sync4();
        var SyncProvider = class {
          constructor(_root, _settings) {
            this._root = _root;
            this._settings = _settings;
            this._reader = new sync_1.default(this._root, this._settings);
          }
          read() {
            return this._reader.read();
          }
        };
        exports22.default = SyncProvider;
      }
    });
    var require_settings3 = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/settings.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var path5 = require("path");
        var fsScandir = require_out2();
        var Settings = class {
          constructor(_options = {}) {
            this._options = _options;
            this.basePath = this._getValue(this._options.basePath, void 0);
            this.concurrency = this._getValue(this._options.concurrency, Number.POSITIVE_INFINITY);
            this.deepFilter = this._getValue(this._options.deepFilter, null);
            this.entryFilter = this._getValue(this._options.entryFilter, null);
            this.errorFilter = this._getValue(this._options.errorFilter, null);
            this.pathSegmentSeparator = this._getValue(this._options.pathSegmentSeparator, path5.sep);
            this.fsScandirSettings = new fsScandir.Settings({
              followSymbolicLinks: this._options.followSymbolicLinks,
              fs: this._options.fs,
              pathSegmentSeparator: this._options.pathSegmentSeparator,
              stats: this._options.stats,
              throwErrorOnBrokenSymbolicLink: this._options.throwErrorOnBrokenSymbolicLink
            });
          }
          _getValue(option, value) {
            return option !== null && option !== void 0 ? option : value;
          }
        };
        exports22.default = Settings;
      }
    });
    var require_out3 = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.Settings = exports22.walkStream = exports22.walkSync = exports22.walk = void 0;
        var async_1 = require_async5();
        var stream_1 = require_stream2();
        var sync_1 = require_sync5();
        var settings_1 = require_settings3();
        exports22.Settings = settings_1.default;
        function walk(directory, optionsOrSettingsOrCallback, callback) {
          if (typeof optionsOrSettingsOrCallback === "function") {
            new async_1.default(directory, getSettings()).read(optionsOrSettingsOrCallback);
            return;
          }
          new async_1.default(directory, getSettings(optionsOrSettingsOrCallback)).read(callback);
        }
        exports22.walk = walk;
        function walkSync(directory, optionsOrSettings) {
          const settings = getSettings(optionsOrSettings);
          const provider = new sync_1.default(directory, settings);
          return provider.read();
        }
        exports22.walkSync = walkSync;
        function walkStream(directory, optionsOrSettings) {
          const settings = getSettings(optionsOrSettings);
          const provider = new stream_1.default(directory, settings);
          return provider.read();
        }
        exports22.walkStream = walkStream;
        function getSettings(settingsOrOptions = {}) {
          if (settingsOrOptions instanceof settings_1.default) {
            return settingsOrOptions;
          }
          return new settings_1.default(settingsOrOptions);
        }
      }
    });
    var require_reader2 = __commonJS22({
      "node_modules/fast-glob/out/readers/reader.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var path5 = require("path");
        var fsStat = require_out();
        var utils = require_utils42();
        var Reader = class {
          constructor(_settings) {
            this._settings = _settings;
            this._fsStatSettings = new fsStat.Settings({
              followSymbolicLink: this._settings.followSymbolicLinks,
              fs: this._settings.fs,
              throwErrorOnBrokenSymbolicLink: this._settings.followSymbolicLinks
            });
          }
          _getFullEntryPath(filepath) {
            return path5.resolve(this._settings.cwd, filepath);
          }
          _makeEntry(stats, pattern) {
            const entry = {
              name: pattern,
              path: pattern,
              dirent: utils.fs.createDirentFromStats(pattern, stats)
            };
            if (this._settings.stats) {
              entry.stats = stats;
            }
            return entry;
          }
          _isFatalError(error) {
            return !utils.errno.isEnoentCodeError(error) && !this._settings.suppressErrors;
          }
        };
        exports22.default = Reader;
      }
    });
    var require_stream3 = __commonJS22({
      "node_modules/fast-glob/out/readers/stream.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var stream_1 = require("stream");
        var fsStat = require_out();
        var fsWalk = require_out3();
        var reader_1 = require_reader2();
        var ReaderStream = class extends reader_1.default {
          constructor() {
            super(...arguments);
            this._walkStream = fsWalk.walkStream;
            this._stat = fsStat.stat;
          }
          dynamic(root2, options) {
            return this._walkStream(root2, options);
          }
          static(patterns, options) {
            const filepaths = patterns.map(this._getFullEntryPath, this);
            const stream = new stream_1.PassThrough({
              objectMode: true
            });
            stream._write = (index, _enc, done) => {
              return this._getEntry(filepaths[index], patterns[index], options).then((entry) => {
                if (entry !== null && options.entryFilter(entry)) {
                  stream.push(entry);
                }
                if (index === filepaths.length - 1) {
                  stream.end();
                }
                done();
              }).catch(done);
            };
            for (let i = 0; i < filepaths.length; i++) {
              stream.write(i);
            }
            return stream;
          }
          _getEntry(filepath, pattern, options) {
            return this._getStat(filepath).then((stats) => this._makeEntry(stats, pattern)).catch((error) => {
              if (options.errorFilter(error)) {
                return null;
              }
              throw error;
            });
          }
          _getStat(filepath) {
            return new Promise((resolve, reject) => {
              this._stat(filepath, this._fsStatSettings, (error, stats) => {
                return error === null ? resolve(stats) : reject(error);
              });
            });
          }
        };
        exports22.default = ReaderStream;
      }
    });
    var require_matcher = __commonJS22({
      "node_modules/fast-glob/out/providers/matchers/matcher.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var utils = require_utils42();
        var Matcher = class {
          constructor(_patterns, _settings, _micromatchOptions) {
            this._patterns = _patterns;
            this._settings = _settings;
            this._micromatchOptions = _micromatchOptions;
            this._storage = [];
            this._fillStorage();
          }
          _fillStorage() {
            const patterns = utils.pattern.expandPatternsWithBraceExpansion(this._patterns);
            for (const pattern of patterns) {
              const segments = this._getPatternSegments(pattern);
              const sections = this._splitSegmentsIntoSections(segments);
              this._storage.push({
                complete: sections.length <= 1,
                pattern,
                segments,
                sections
              });
            }
          }
          _getPatternSegments(pattern) {
            const parts = utils.pattern.getPatternParts(pattern, this._micromatchOptions);
            return parts.map((part) => {
              const dynamic = utils.pattern.isDynamicPattern(part, this._settings);
              if (!dynamic) {
                return {
                  dynamic: false,
                  pattern: part
                };
              }
              return {
                dynamic: true,
                pattern: part,
                patternRe: utils.pattern.makeRe(part, this._micromatchOptions)
              };
            });
          }
          _splitSegmentsIntoSections(segments) {
            return utils.array.splitWhen(segments, (segment) => segment.dynamic && utils.pattern.hasGlobStar(segment.pattern));
          }
        };
        exports22.default = Matcher;
      }
    });
    var require_partial = __commonJS22({
      "node_modules/fast-glob/out/providers/matchers/partial.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var matcher_1 = require_matcher();
        var PartialMatcher = class extends matcher_1.default {
          match(filepath) {
            const parts = filepath.split("/");
            const levels = parts.length;
            const patterns = this._storage.filter((info) => !info.complete || info.segments.length > levels);
            for (const pattern of patterns) {
              const section = pattern.sections[0];
              if (!pattern.complete && levels > section.length) {
                return true;
              }
              const match = parts.every((part, index) => {
                const segment = pattern.segments[index];
                if (segment.dynamic && segment.patternRe.test(part)) {
                  return true;
                }
                if (!segment.dynamic && segment.pattern === part) {
                  return true;
                }
                return false;
              });
              if (match) {
                return true;
              }
            }
            return false;
          }
        };
        exports22.default = PartialMatcher;
      }
    });
    var require_deep = __commonJS22({
      "node_modules/fast-glob/out/providers/filters/deep.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var utils = require_utils42();
        var partial_1 = require_partial();
        var DeepFilter = class {
          constructor(_settings, _micromatchOptions) {
            this._settings = _settings;
            this._micromatchOptions = _micromatchOptions;
          }
          getFilter(basePath, positive, negative) {
            const matcher = this._getMatcher(positive);
            const negativeRe = this._getNegativePatternsRe(negative);
            return (entry) => this._filter(basePath, entry, matcher, negativeRe);
          }
          _getMatcher(patterns) {
            return new partial_1.default(patterns, this._settings, this._micromatchOptions);
          }
          _getNegativePatternsRe(patterns) {
            const affectDepthOfReadingPatterns = patterns.filter(utils.pattern.isAffectDepthOfReadingPattern);
            return utils.pattern.convertPatternsToRe(affectDepthOfReadingPatterns, this._micromatchOptions);
          }
          _filter(basePath, entry, matcher, negativeRe) {
            if (this._isSkippedByDeep(basePath, entry.path)) {
              return false;
            }
            if (this._isSkippedSymbolicLink(entry)) {
              return false;
            }
            const filepath = utils.path.removeLeadingDotSegment(entry.path);
            if (this._isSkippedByPositivePatterns(filepath, matcher)) {
              return false;
            }
            return this._isSkippedByNegativePatterns(filepath, negativeRe);
          }
          _isSkippedByDeep(basePath, entryPath) {
            if (this._settings.deep === Infinity) {
              return false;
            }
            return this._getEntryLevel(basePath, entryPath) >= this._settings.deep;
          }
          _getEntryLevel(basePath, entryPath) {
            const entryPathDepth = entryPath.split("/").length;
            if (basePath === "") {
              return entryPathDepth;
            }
            const basePathDepth = basePath.split("/").length;
            return entryPathDepth - basePathDepth;
          }
          _isSkippedSymbolicLink(entry) {
            return !this._settings.followSymbolicLinks && entry.dirent.isSymbolicLink();
          }
          _isSkippedByPositivePatterns(entryPath, matcher) {
            return !this._settings.baseNameMatch && !matcher.match(entryPath);
          }
          _isSkippedByNegativePatterns(entryPath, patternsRe) {
            return !utils.pattern.matchAny(entryPath, patternsRe);
          }
        };
        exports22.default = DeepFilter;
      }
    });
    var require_entry = __commonJS22({
      "node_modules/fast-glob/out/providers/filters/entry.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var utils = require_utils42();
        var EntryFilter = class {
          constructor(_settings, _micromatchOptions) {
            this._settings = _settings;
            this._micromatchOptions = _micromatchOptions;
            this.index = /* @__PURE__ */ new Map();
          }
          getFilter(positive, negative) {
            const positiveRe = utils.pattern.convertPatternsToRe(positive, this._micromatchOptions);
            const negativeRe = utils.pattern.convertPatternsToRe(negative, this._micromatchOptions);
            return (entry) => this._filter(entry, positiveRe, negativeRe);
          }
          _filter(entry, positiveRe, negativeRe) {
            if (this._settings.unique && this._isDuplicateEntry(entry)) {
              return false;
            }
            if (this._onlyFileFilter(entry) || this._onlyDirectoryFilter(entry)) {
              return false;
            }
            if (this._isSkippedByAbsoluteNegativePatterns(entry.path, negativeRe)) {
              return false;
            }
            const filepath = this._settings.baseNameMatch ? entry.name : entry.path;
            const isMatched = this._isMatchToPatterns(filepath, positiveRe) && !this._isMatchToPatterns(entry.path, negativeRe);
            if (this._settings.unique && isMatched) {
              this._createIndexRecord(entry);
            }
            return isMatched;
          }
          _isDuplicateEntry(entry) {
            return this.index.has(entry.path);
          }
          _createIndexRecord(entry) {
            this.index.set(entry.path, void 0);
          }
          _onlyFileFilter(entry) {
            return this._settings.onlyFiles && !entry.dirent.isFile();
          }
          _onlyDirectoryFilter(entry) {
            return this._settings.onlyDirectories && !entry.dirent.isDirectory();
          }
          _isSkippedByAbsoluteNegativePatterns(entryPath, patternsRe) {
            if (!this._settings.absolute) {
              return false;
            }
            const fullpath = utils.path.makeAbsolute(this._settings.cwd, entryPath);
            return utils.pattern.matchAny(fullpath, patternsRe);
          }
          _isMatchToPatterns(entryPath, patternsRe) {
            const filepath = utils.path.removeLeadingDotSegment(entryPath);
            return utils.pattern.matchAny(filepath, patternsRe) || utils.pattern.matchAny(filepath + "/", patternsRe);
          }
        };
        exports22.default = EntryFilter;
      }
    });
    var require_error = __commonJS22({
      "node_modules/fast-glob/out/providers/filters/error.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var utils = require_utils42();
        var ErrorFilter = class {
          constructor(_settings) {
            this._settings = _settings;
          }
          getFilter() {
            return (error) => this._isNonFatalError(error);
          }
          _isNonFatalError(error) {
            return utils.errno.isEnoentCodeError(error) || this._settings.suppressErrors;
          }
        };
        exports22.default = ErrorFilter;
      }
    });
    var require_entry2 = __commonJS22({
      "node_modules/fast-glob/out/providers/transformers/entry.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var utils = require_utils42();
        var EntryTransformer = class {
          constructor(_settings) {
            this._settings = _settings;
          }
          getTransformer() {
            return (entry) => this._transform(entry);
          }
          _transform(entry) {
            let filepath = entry.path;
            if (this._settings.absolute) {
              filepath = utils.path.makeAbsolute(this._settings.cwd, filepath);
              filepath = utils.path.unixify(filepath);
            }
            if (this._settings.markDirectories && entry.dirent.isDirectory()) {
              filepath += "/";
            }
            if (!this._settings.objectMode) {
              return filepath;
            }
            return Object.assign(Object.assign({}, entry), {
              path: filepath
            });
          }
        };
        exports22.default = EntryTransformer;
      }
    });
    var require_provider = __commonJS22({
      "node_modules/fast-glob/out/providers/provider.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var path5 = require("path");
        var deep_1 = require_deep();
        var entry_1 = require_entry();
        var error_1 = require_error();
        var entry_2 = require_entry2();
        var Provider = class {
          constructor(_settings) {
            this._settings = _settings;
            this.errorFilter = new error_1.default(this._settings);
            this.entryFilter = new entry_1.default(this._settings, this._getMicromatchOptions());
            this.deepFilter = new deep_1.default(this._settings, this._getMicromatchOptions());
            this.entryTransformer = new entry_2.default(this._settings);
          }
          _getRootDirectory(task) {
            return path5.resolve(this._settings.cwd, task.base);
          }
          _getReaderOptions(task) {
            const basePath = task.base === "." ? "" : task.base;
            return {
              basePath,
              pathSegmentSeparator: "/",
              concurrency: this._settings.concurrency,
              deepFilter: this.deepFilter.getFilter(basePath, task.positive, task.negative),
              entryFilter: this.entryFilter.getFilter(task.positive, task.negative),
              errorFilter: this.errorFilter.getFilter(),
              followSymbolicLinks: this._settings.followSymbolicLinks,
              fs: this._settings.fs,
              stats: this._settings.stats,
              throwErrorOnBrokenSymbolicLink: this._settings.throwErrorOnBrokenSymbolicLink,
              transform: this.entryTransformer.getTransformer()
            };
          }
          _getMicromatchOptions() {
            return {
              dot: this._settings.dot,
              matchBase: this._settings.baseNameMatch,
              nobrace: !this._settings.braceExpansion,
              nocase: !this._settings.caseSensitiveMatch,
              noext: !this._settings.extglob,
              noglobstar: !this._settings.globstar,
              posix: true,
              strictSlashes: false
            };
          }
        };
        exports22.default = Provider;
      }
    });
    var require_async6 = __commonJS22({
      "node_modules/fast-glob/out/providers/async.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var stream_1 = require_stream3();
        var provider_1 = require_provider();
        var ProviderAsync = class extends provider_1.default {
          constructor() {
            super(...arguments);
            this._reader = new stream_1.default(this._settings);
          }
          read(task) {
            const root2 = this._getRootDirectory(task);
            const options = this._getReaderOptions(task);
            const entries4 = [];
            return new Promise((resolve, reject) => {
              const stream = this.api(root2, task, options);
              stream.once("error", reject);
              stream.on("data", (entry) => entries4.push(options.transform(entry)));
              stream.once("end", () => resolve(entries4));
            });
          }
          api(root2, task, options) {
            if (task.dynamic) {
              return this._reader.dynamic(root2, options);
            }
            return this._reader.static(task.patterns, options);
          }
        };
        exports22.default = ProviderAsync;
      }
    });
    var require_stream4 = __commonJS22({
      "node_modules/fast-glob/out/providers/stream.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var stream_1 = require("stream");
        var stream_2 = require_stream3();
        var provider_1 = require_provider();
        var ProviderStream = class extends provider_1.default {
          constructor() {
            super(...arguments);
            this._reader = new stream_2.default(this._settings);
          }
          read(task) {
            const root2 = this._getRootDirectory(task);
            const options = this._getReaderOptions(task);
            const source = this.api(root2, task, options);
            const destination = new stream_1.Readable({
              objectMode: true,
              read: () => {
              }
            });
            source.once("error", (error) => destination.emit("error", error)).on("data", (entry) => destination.emit("data", options.transform(entry))).once("end", () => destination.emit("end"));
            destination.once("close", () => source.destroy());
            return destination;
          }
          api(root2, task, options) {
            if (task.dynamic) {
              return this._reader.dynamic(root2, options);
            }
            return this._reader.static(task.patterns, options);
          }
        };
        exports22.default = ProviderStream;
      }
    });
    var require_sync6 = __commonJS22({
      "node_modules/fast-glob/out/readers/sync.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var fsStat = require_out();
        var fsWalk = require_out3();
        var reader_1 = require_reader2();
        var ReaderSync = class extends reader_1.default {
          constructor() {
            super(...arguments);
            this._walkSync = fsWalk.walkSync;
            this._statSync = fsStat.statSync;
          }
          dynamic(root2, options) {
            return this._walkSync(root2, options);
          }
          static(patterns, options) {
            const entries4 = [];
            for (const pattern of patterns) {
              const filepath = this._getFullEntryPath(pattern);
              const entry = this._getEntry(filepath, pattern, options);
              if (entry === null || !options.entryFilter(entry)) {
                continue;
              }
              entries4.push(entry);
            }
            return entries4;
          }
          _getEntry(filepath, pattern, options) {
            try {
              const stats = this._getStat(filepath);
              return this._makeEntry(stats, pattern);
            } catch (error) {
              if (options.errorFilter(error)) {
                return null;
              }
              throw error;
            }
          }
          _getStat(filepath) {
            return this._statSync(filepath, this._fsStatSettings);
          }
        };
        exports22.default = ReaderSync;
      }
    });
    var require_sync7 = __commonJS22({
      "node_modules/fast-glob/out/providers/sync.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var sync_1 = require_sync6();
        var provider_1 = require_provider();
        var ProviderSync = class extends provider_1.default {
          constructor() {
            super(...arguments);
            this._reader = new sync_1.default(this._settings);
          }
          read(task) {
            const root2 = this._getRootDirectory(task);
            const options = this._getReaderOptions(task);
            const entries4 = this.api(root2, task, options);
            return entries4.map(options.transform);
          }
          api(root2, task, options) {
            if (task.dynamic) {
              return this._reader.dynamic(root2, options);
            }
            return this._reader.static(task.patterns, options);
          }
        };
        exports22.default = ProviderSync;
      }
    });
    var require_settings4 = __commonJS22({
      "node_modules/fast-glob/out/settings.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.DEFAULT_FILE_SYSTEM_ADAPTER = void 0;
        var fs = require("fs");
        var os = require("os");
        var CPU_COUNT = Math.max(os.cpus().length, 1);
        exports22.DEFAULT_FILE_SYSTEM_ADAPTER = {
          lstat: fs.lstat,
          lstatSync: fs.lstatSync,
          stat: fs.stat,
          statSync: fs.statSync,
          readdir: fs.readdir,
          readdirSync: fs.readdirSync
        };
        var Settings = class {
          constructor(_options = {}) {
            this._options = _options;
            this.absolute = this._getValue(this._options.absolute, false);
            this.baseNameMatch = this._getValue(this._options.baseNameMatch, false);
            this.braceExpansion = this._getValue(this._options.braceExpansion, true);
            this.caseSensitiveMatch = this._getValue(this._options.caseSensitiveMatch, true);
            this.concurrency = this._getValue(this._options.concurrency, CPU_COUNT);
            this.cwd = this._getValue(this._options.cwd, process.cwd());
            this.deep = this._getValue(this._options.deep, Infinity);
            this.dot = this._getValue(this._options.dot, false);
            this.extglob = this._getValue(this._options.extglob, true);
            this.followSymbolicLinks = this._getValue(this._options.followSymbolicLinks, true);
            this.fs = this._getFileSystemMethods(this._options.fs);
            this.globstar = this._getValue(this._options.globstar, true);
            this.ignore = this._getValue(this._options.ignore, []);
            this.markDirectories = this._getValue(this._options.markDirectories, false);
            this.objectMode = this._getValue(this._options.objectMode, false);
            this.onlyDirectories = this._getValue(this._options.onlyDirectories, false);
            this.onlyFiles = this._getValue(this._options.onlyFiles, true);
            this.stats = this._getValue(this._options.stats, false);
            this.suppressErrors = this._getValue(this._options.suppressErrors, false);
            this.throwErrorOnBrokenSymbolicLink = this._getValue(this._options.throwErrorOnBrokenSymbolicLink, false);
            this.unique = this._getValue(this._options.unique, true);
            if (this.onlyDirectories) {
              this.onlyFiles = false;
            }
            if (this.stats) {
              this.objectMode = true;
            }
          }
          _getValue(option, value) {
            return option === void 0 ? value : option;
          }
          _getFileSystemMethods(methods = {}) {
            return Object.assign(Object.assign({}, exports22.DEFAULT_FILE_SYSTEM_ADAPTER), methods);
          }
        };
        exports22.default = Settings;
      }
    });
    var require_out4 = __commonJS22({
      "node_modules/fast-glob/out/index.js"(exports22, module22) {
        "use strict";
        var taskManager = require_tasks();
        var patternManager = require_patterns();
        var async_1 = require_async6();
        var stream_1 = require_stream4();
        var sync_1 = require_sync7();
        var settings_1 = require_settings4();
        var utils = require_utils42();
        async function FastGlob(source, options) {
          assertPatternsInput(source);
          const works = getWorks(source, async_1.default, options);
          const result = await Promise.all(works);
          return utils.array.flatten(result);
        }
        (function(FastGlob2) {
          function sync(source, options) {
            assertPatternsInput(source);
            const works = getWorks(source, sync_1.default, options);
            return utils.array.flatten(works);
          }
          FastGlob2.sync = sync;
          function stream(source, options) {
            assertPatternsInput(source);
            const works = getWorks(source, stream_1.default, options);
            return utils.stream.merge(works);
          }
          FastGlob2.stream = stream;
          function generateTasks(source, options) {
            assertPatternsInput(source);
            const patterns = patternManager.transform([].concat(source));
            const settings = new settings_1.default(options);
            return taskManager.generate(patterns, settings);
          }
          FastGlob2.generateTasks = generateTasks;
          function isDynamicPattern(source, options) {
            assertPatternsInput(source);
            const settings = new settings_1.default(options);
            return utils.pattern.isDynamicPattern(source, settings);
          }
          FastGlob2.isDynamicPattern = isDynamicPattern;
          function escapePath(source) {
            assertPatternsInput(source);
            return utils.path.escape(source);
          }
          FastGlob2.escapePath = escapePath;
        })(FastGlob || (FastGlob = {}));
        function getWorks(source, _Provider, options) {
          const patterns = patternManager.transform([].concat(source));
          const settings = new settings_1.default(options);
          const tasks = taskManager.generate(patterns, settings);
          const provider = new _Provider(settings);
          return tasks.map(provider.read, provider);
        }
        function assertPatternsInput(input) {
          const source = [].concat(input);
          const isValidSource = source.every((item) => utils.string.isString(item) && !utils.string.isEmpty(item));
          if (!isValidSource) {
            throw new TypeError("Patterns must be a string (non empty) or an array of strings");
          }
        }
        module22.exports = FastGlob;
      }
    });
    var require_uniq_by_key = __commonJS22({
      "src/utils/uniq-by-key.js"(exports22, module22) {
        "use strict";
        function uniqByKey(array, key) {
          const result = [];
          const seen = /* @__PURE__ */ new Set();
          for (const element of array) {
            const value = element[key];
            if (!seen.has(value)) {
              seen.add(value);
              result.push(element);
            }
          }
          return result;
        }
        module22.exports = uniqByKey;
      }
    });
    var require_create_language = __commonJS22({
      "src/utils/create-language.js"(exports22, module22) {
        "use strict";
        module22.exports = function(linguistData, override) {
          const {
            languageId
          } = linguistData, rest = _objectWithoutProperties(linguistData, _excluded4);
          return Object.assign(Object.assign({
            linguistLanguageId: languageId
          }, rest), override(linguistData));
        };
      }
    });
    var require_ast = __commonJS22({
      "node_modules/esutils/lib/ast.js"(exports22, module22) {
        (function() {
          "use strict";
          function isExpression(node) {
            if (node == null) {
              return false;
            }
            switch (node.type) {
              case "ArrayExpression":
              case "AssignmentExpression":
              case "BinaryExpression":
              case "CallExpression":
              case "ConditionalExpression":
              case "FunctionExpression":
              case "Identifier":
              case "Literal":
              case "LogicalExpression":
              case "MemberExpression":
              case "NewExpression":
              case "ObjectExpression":
              case "SequenceExpression":
              case "ThisExpression":
              case "UnaryExpression":
              case "UpdateExpression":
                return true;
            }
            return false;
          }
          function isIterationStatement(node) {
            if (node == null) {
              return false;
            }
            switch (node.type) {
              case "DoWhileStatement":
              case "ForInStatement":
              case "ForStatement":
              case "WhileStatement":
                return true;
            }
            return false;
          }
          function isStatement(node) {
            if (node == null) {
              return false;
            }
            switch (node.type) {
              case "BlockStatement":
              case "BreakStatement":
              case "ContinueStatement":
              case "DebuggerStatement":
              case "DoWhileStatement":
              case "EmptyStatement":
              case "ExpressionStatement":
              case "ForInStatement":
              case "ForStatement":
              case "IfStatement":
              case "LabeledStatement":
              case "ReturnStatement":
              case "SwitchStatement":
              case "ThrowStatement":
              case "TryStatement":
              case "VariableDeclaration":
              case "WhileStatement":
              case "WithStatement":
                return true;
            }
            return false;
          }
          function isSourceElement(node) {
            return isStatement(node) || node != null && node.type === "FunctionDeclaration";
          }
          function trailingStatement(node) {
            switch (node.type) {
              case "IfStatement":
                if (node.alternate != null) {
                  return node.alternate;
                }
                return node.consequent;
              case "LabeledStatement":
              case "ForStatement":
              case "ForInStatement":
              case "WhileStatement":
              case "WithStatement":
                return node.body;
            }
            return null;
          }
          function isProblematicIfStatement(node) {
            var current;
            if (node.type !== "IfStatement") {
              return false;
            }
            if (node.alternate == null) {
              return false;
            }
            current = node.consequent;
            do {
              if (current.type === "IfStatement") {
                if (current.alternate == null) {
                  return true;
                }
              }
              current = trailingStatement(current);
            } while (current);
            return false;
          }
          module22.exports = {
            isExpression,
            isStatement,
            isIterationStatement,
            isSourceElement,
            isProblematicIfStatement,
            trailingStatement
          };
        })();
      }
    });
    var require_code3 = __commonJS22({
      "node_modules/esutils/lib/code.js"(exports22, module22) {
        (function() {
          "use strict";
          var ES6Regex, ES5Regex, NON_ASCII_WHITESPACES, IDENTIFIER_START, IDENTIFIER_PART, ch;
          ES5Regex = {
            NonAsciiIdentifierStart: /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]/,
            NonAsciiIdentifierPart: /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u08A0-\u08B4\u08B6-\u08BD\u08D4-\u08E1\u08E3-\u0963\u0966-\u096F\u0971-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0AF9\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C00-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58-\u0C5A\u0C60-\u0C63\u0C66-\u0C6F\u0C80-\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D01-\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D54-\u0D57\u0D5F-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191E\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19D9\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1AB0-\u1ABD\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1CD0-\u1CD2\u1CD4-\u1CF6\u1CF8\u1CF9\u1D00-\u1DF5\u1DFB-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u200C\u200D\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u2E2F\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099\u309A\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA827\uA840-\uA873\uA880-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA8FD\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uA9E0-\uA9FE\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]/
          };
          ES6Regex = {
            NonAsciiIdentifierStart: /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF30-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF19]|\uD806[\uDCA0-\uDCDF\uDCFF\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC72-\uDC8F]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50\uDF93-\uDF9F\uDFE0]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4\uDD00-\uDD43]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]/,
            NonAsciiIdentifierPart: /[\xAA\xB5\xB7\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u08A0-\u08B4\u08B6-\u08BD\u08D4-\u08E1\u08E3-\u0963\u0966-\u096F\u0971-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0AF9\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C00-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58-\u0C5A\u0C60-\u0C63\u0C66-\u0C6F\u0C80-\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D01-\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D54-\u0D57\u0D5F-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1369-\u1371\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191E\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1AB0-\u1ABD\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1CD0-\u1CD2\u1CD4-\u1CF6\u1CF8\u1CF9\u1D00-\u1DF5\u1DFB-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u200C\u200D\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA827\uA840-\uA873\uA880-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA8FD\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uA9E0-\uA9FE\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDDFD\uDE80-\uDE9C\uDEA0-\uDED0\uDEE0\uDF00-\uDF1F\uDF30-\uDF4A\uDF50-\uDF7A\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00-\uDE03\uDE05\uDE06\uDE0C-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE38-\uDE3A\uDE3F\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE6\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC00-\uDC46\uDC66-\uDC6F\uDC7F-\uDCBA\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD00-\uDD34\uDD36-\uDD3F\uDD50-\uDD73\uDD76\uDD80-\uDDC4\uDDCA-\uDDCC\uDDD0-\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE37\uDE3E\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEEA\uDEF0-\uDEF9\uDF00-\uDF03\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3C-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF50\uDF57\uDF5D-\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDC00-\uDC4A\uDC50-\uDC59\uDC80-\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDB5\uDDB8-\uDDC0\uDDD8-\uDDDD\uDE00-\uDE40\uDE44\uDE50-\uDE59\uDE80-\uDEB7\uDEC0-\uDEC9\uDF00-\uDF19\uDF1D-\uDF2B\uDF30-\uDF39]|\uD806[\uDCA0-\uDCE9\uDCFF\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC36\uDC38-\uDC40\uDC50-\uDC59\uDC72-\uDC8F\uDC92-\uDCA7\uDCA9-\uDCB6]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDEF0-\uDEF4\uDF00-\uDF36\uDF40-\uDF43\uDF50-\uDF59\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50-\uDF7E\uDF8F-\uDF9F\uDFE0]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD836[\uDE00-\uDE36\uDE3B-\uDE6C\uDE75\uDE84\uDE9B-\uDE9F\uDEA1-\uDEAF]|\uD838[\uDC00-\uDC06\uDC08-\uDC18\uDC1B-\uDC21\uDC23\uDC24\uDC26-\uDC2A]|\uD83A[\uDC00-\uDCC4\uDCD0-\uDCD6\uDD00-\uDD4A\uDD50-\uDD59]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]|\uDB40[\uDD00-\uDDEF]/
          };
          function isDecimalDigit(ch2) {
            return 48 <= ch2 && ch2 <= 57;
          }
          function isHexDigit(ch2) {
            return 48 <= ch2 && ch2 <= 57 || 97 <= ch2 && ch2 <= 102 || 65 <= ch2 && ch2 <= 70;
          }
          function isOctalDigit(ch2) {
            return ch2 >= 48 && ch2 <= 55;
          }
          NON_ASCII_WHITESPACES = [5760, 8192, 8193, 8194, 8195, 8196, 8197, 8198, 8199, 8200, 8201, 8202, 8239, 8287, 12288, 65279];
          function isWhiteSpace(ch2) {
            return ch2 === 32 || ch2 === 9 || ch2 === 11 || ch2 === 12 || ch2 === 160 || ch2 >= 5760 && NON_ASCII_WHITESPACES.indexOf(ch2) >= 0;
          }
          function isLineTerminator(ch2) {
            return ch2 === 10 || ch2 === 13 || ch2 === 8232 || ch2 === 8233;
          }
          function fromCodePoint(cp) {
            if (cp <= 65535) {
              return String.fromCharCode(cp);
            }
            var cu1 = String.fromCharCode(Math.floor((cp - 65536) / 1024) + 55296);
            var cu2 = String.fromCharCode((cp - 65536) % 1024 + 56320);
            return cu1 + cu2;
          }
          IDENTIFIER_START = new Array(128);
          for (ch = 0; ch < 128; ++ch) {
            IDENTIFIER_START[ch] = ch >= 97 && ch <= 122 || ch >= 65 && ch <= 90 || ch === 36 || ch === 95;
          }
          IDENTIFIER_PART = new Array(128);
          for (ch = 0; ch < 128; ++ch) {
            IDENTIFIER_PART[ch] = ch >= 97 && ch <= 122 || ch >= 65 && ch <= 90 || ch >= 48 && ch <= 57 || ch === 36 || ch === 95;
          }
          function isIdentifierStartES5(ch2) {
            return ch2 < 128 ? IDENTIFIER_START[ch2] : ES5Regex.NonAsciiIdentifierStart.test(fromCodePoint(ch2));
          }
          function isIdentifierPartES5(ch2) {
            return ch2 < 128 ? IDENTIFIER_PART[ch2] : ES5Regex.NonAsciiIdentifierPart.test(fromCodePoint(ch2));
          }
          function isIdentifierStartES6(ch2) {
            return ch2 < 128 ? IDENTIFIER_START[ch2] : ES6Regex.NonAsciiIdentifierStart.test(fromCodePoint(ch2));
          }
          function isIdentifierPartES6(ch2) {
            return ch2 < 128 ? IDENTIFIER_PART[ch2] : ES6Regex.NonAsciiIdentifierPart.test(fromCodePoint(ch2));
          }
          module22.exports = {
            isDecimalDigit,
            isHexDigit,
            isOctalDigit,
            isWhiteSpace,
            isLineTerminator,
            isIdentifierStartES5,
            isIdentifierPartES5,
            isIdentifierStartES6,
            isIdentifierPartES6
          };
        })();
      }
    });
    var require_keyword22 = __commonJS22({
      "node_modules/esutils/lib/keyword.js"(exports22, module22) {
        (function() {
          "use strict";
          var code = require_code3();
          function isStrictModeReservedWordES6(id) {
            switch (id) {
              case "implements":
              case "interface":
              case "package":
              case "private":
              case "protected":
              case "public":
              case "static":
              case "let":
                return true;
              default:
                return false;
            }
          }
          function isKeywordES5(id, strict) {
            if (!strict && id === "yield") {
              return false;
            }
            return isKeywordES6(id, strict);
          }
          function isKeywordES6(id, strict) {
            if (strict && isStrictModeReservedWordES6(id)) {
              return true;
            }
            switch (id.length) {
              case 2:
                return id === "if" || id === "in" || id === "do";
              case 3:
                return id === "var" || id === "for" || id === "new" || id === "try";
              case 4:
                return id === "this" || id === "else" || id === "case" || id === "void" || id === "with" || id === "enum";
              case 5:
                return id === "while" || id === "break" || id === "catch" || id === "throw" || id === "const" || id === "yield" || id === "class" || id === "super";
              case 6:
                return id === "return" || id === "typeof" || id === "delete" || id === "switch" || id === "export" || id === "import";
              case 7:
                return id === "default" || id === "finally" || id === "extends";
              case 8:
                return id === "function" || id === "continue" || id === "debugger";
              case 10:
                return id === "instanceof";
              default:
                return false;
            }
          }
          function isReservedWordES5(id, strict) {
            return id === "null" || id === "true" || id === "false" || isKeywordES5(id, strict);
          }
          function isReservedWordES6(id, strict) {
            return id === "null" || id === "true" || id === "false" || isKeywordES6(id, strict);
          }
          function isRestrictedWord(id) {
            return id === "eval" || id === "arguments";
          }
          function isIdentifierNameES5(id) {
            var i, iz, ch;
            if (id.length === 0) {
              return false;
            }
            ch = id.charCodeAt(0);
            if (!code.isIdentifierStartES5(ch)) {
              return false;
            }
            for (i = 1, iz = id.length; i < iz; ++i) {
              ch = id.charCodeAt(i);
              if (!code.isIdentifierPartES5(ch)) {
                return false;
              }
            }
            return true;
          }
          function decodeUtf16(lead, trail) {
            return (lead - 55296) * 1024 + (trail - 56320) + 65536;
          }
          function isIdentifierNameES6(id) {
            var i, iz, ch, lowCh, check;
            if (id.length === 0) {
              return false;
            }
            check = code.isIdentifierStartES6;
            for (i = 0, iz = id.length; i < iz; ++i) {
              ch = id.charCodeAt(i);
              if (55296 <= ch && ch <= 56319) {
                ++i;
                if (i >= iz) {
                  return false;
                }
                lowCh = id.charCodeAt(i);
                if (!(56320 <= lowCh && lowCh <= 57343)) {
                  return false;
                }
                ch = decodeUtf16(ch, lowCh);
              }
              if (!check(ch)) {
                return false;
              }
              check = code.isIdentifierPartES6;
            }
            return true;
          }
          function isIdentifierES5(id, strict) {
            return isIdentifierNameES5(id) && !isReservedWordES5(id, strict);
          }
          function isIdentifierES6(id, strict) {
            return isIdentifierNameES6(id) && !isReservedWordES6(id, strict);
          }
          module22.exports = {
            isKeywordES5,
            isKeywordES6,
            isReservedWordES5,
            isReservedWordES6,
            isRestrictedWord,
            isIdentifierNameES5,
            isIdentifierNameES6,
            isIdentifierES5,
            isIdentifierES6
          };
        })();
      }
    });
    var require_utils62 = __commonJS22({
      "node_modules/esutils/lib/utils.js"(exports22) {
        (function() {
          "use strict";
          exports22.ast = require_ast();
          exports22.code = require_code3();
          exports22.keyword = require_keyword22();
        })();
      }
    });
    var require_is_block_comment = __commonJS22({
      "src/language-js/utils/is-block-comment.js"(exports22, module22) {
        "use strict";
        var BLOCK_COMMENT_TYPES = /* @__PURE__ */ new Set(["Block", "CommentBlock", "MultiLine"]);
        var isBlockComment = (comment) => BLOCK_COMMENT_TYPES.has(comment === null || comment === void 0 ? void 0 : comment.type);
        module22.exports = isBlockComment;
      }
    });
    var require_is_node_matches = __commonJS22({
      "src/language-js/utils/is-node-matches.js"(exports22, module22) {
        "use strict";
        function isNodeMatchesNameOrPath(node, nameOrPath) {
          const names = nameOrPath.split(".");
          for (let index = names.length - 1; index >= 0; index--) {
            const name = names[index];
            if (index === 0) {
              return node.type === "Identifier" && node.name === name;
            }
            if (node.type !== "MemberExpression" || node.optional || node.computed || node.property.type !== "Identifier" || node.property.name !== name) {
              return false;
            }
            node = node.object;
          }
        }
        function isNodeMatches(node, nameOrPaths) {
          return nameOrPaths.some((nameOrPath) => isNodeMatchesNameOrPath(node, nameOrPath));
        }
        module22.exports = isNodeMatches;
      }
    });
    var require_utils72 = __commonJS22({
      "src/language-js/utils/index.js"(exports22, module22) {
        "use strict";
        var isIdentifierName = require_utils62().keyword.isIdentifierNameES5;
        var {
          getLast,
          hasNewline,
          skipWhitespace,
          isNonEmptyArray,
          isNextLineEmptyAfterIndex,
          getStringWidth
        } = require_util2();
        var {
          locStart,
          locEnd,
          hasSameLocStart
        } = require_loc();
        var isBlockComment = require_is_block_comment();
        var isNodeMatches = require_is_node_matches();
        var NON_LINE_TERMINATING_WHITE_SPACE = "(?:(?=.)\\s)";
        var FLOW_SHORTHAND_ANNOTATION = new RegExp(`^${NON_LINE_TERMINATING_WHITE_SPACE}*:`);
        var FLOW_ANNOTATION = new RegExp(`^${NON_LINE_TERMINATING_WHITE_SPACE}*::`);
        function hasFlowShorthandAnnotationComment(node) {
          var _node$extra, _node$trailingComment;
          return ((_node$extra = node.extra) === null || _node$extra === void 0 ? void 0 : _node$extra.parenthesized) && isBlockComment((_node$trailingComment = node.trailingComments) === null || _node$trailingComment === void 0 ? void 0 : _node$trailingComment[0]) && FLOW_SHORTHAND_ANNOTATION.test(node.trailingComments[0].value);
        }
        function hasFlowAnnotationComment(comments) {
          const firstComment = comments === null || comments === void 0 ? void 0 : comments[0];
          return isBlockComment(firstComment) && FLOW_ANNOTATION.test(firstComment.value);
        }
        function hasNode(node, fn) {
          if (!node || typeof node !== "object") {
            return false;
          }
          if (Array.isArray(node)) {
            return node.some((value) => hasNode(value, fn));
          }
          const result = fn(node);
          return typeof result === "boolean" ? result : Object.values(node).some((value) => hasNode(value, fn));
        }
        function hasNakedLeftSide(node) {
          return node.type === "AssignmentExpression" || node.type === "BinaryExpression" || node.type === "LogicalExpression" || node.type === "NGPipeExpression" || node.type === "ConditionalExpression" || isCallExpression(node) || isMemberExpression(node) || node.type === "SequenceExpression" || node.type === "TaggedTemplateExpression" || node.type === "BindExpression" || node.type === "UpdateExpression" && !node.prefix || node.type === "TSAsExpression" || node.type === "TSNonNullExpression";
        }
        function getLeftSide(node) {
          var _ref2, _ref3, _ref4, _ref5, _ref6, _node$left;
          if (node.expressions) {
            return node.expressions[0];
          }
          return (_ref2 = (_ref3 = (_ref4 = (_ref5 = (_ref6 = (_node$left = node.left) !== null && _node$left !== void 0 ? _node$left : node.test) !== null && _ref6 !== void 0 ? _ref6 : node.callee) !== null && _ref5 !== void 0 ? _ref5 : node.object) !== null && _ref4 !== void 0 ? _ref4 : node.tag) !== null && _ref3 !== void 0 ? _ref3 : node.argument) !== null && _ref2 !== void 0 ? _ref2 : node.expression;
        }
        function getLeftSidePathName(path5, node) {
          if (node.expressions) {
            return ["expressions", 0];
          }
          if (node.left) {
            return ["left"];
          }
          if (node.test) {
            return ["test"];
          }
          if (node.object) {
            return ["object"];
          }
          if (node.callee) {
            return ["callee"];
          }
          if (node.tag) {
            return ["tag"];
          }
          if (node.argument) {
            return ["argument"];
          }
          if (node.expression) {
            return ["expression"];
          }
          throw new Error("Unexpected node has no left side.");
        }
        function createTypeCheckFunction(types2) {
          types2 = new Set(types2);
          return (node) => types2.has(node === null || node === void 0 ? void 0 : node.type);
        }
        var isLineComment = createTypeCheckFunction(["Line", "CommentLine", "SingleLine", "HashbangComment", "HTMLOpen", "HTMLClose"]);
        var isExportDeclaration = createTypeCheckFunction(["ExportDefaultDeclaration", "ExportDefaultSpecifier", "DeclareExportDeclaration", "ExportNamedDeclaration", "ExportAllDeclaration"]);
        function getParentExportDeclaration(path5) {
          const parentNode = path5.getParentNode();
          if (path5.getName() === "declaration" && isExportDeclaration(parentNode)) {
            return parentNode;
          }
          return null;
        }
        var isLiteral = createTypeCheckFunction(["BooleanLiteral", "DirectiveLiteral", "Literal", "NullLiteral", "NumericLiteral", "BigIntLiteral", "DecimalLiteral", "RegExpLiteral", "StringLiteral", "TemplateLiteral", "TSTypeLiteral", "JSXText"]);
        function isNumericLiteral(node) {
          return node.type === "NumericLiteral" || node.type === "Literal" && typeof node.value === "number";
        }
        function isSignedNumericLiteral(node) {
          return node.type === "UnaryExpression" && (node.operator === "+" || node.operator === "-") && isNumericLiteral(node.argument);
        }
        function isStringLiteral(node) {
          return node.type === "StringLiteral" || node.type === "Literal" && typeof node.value === "string";
        }
        var isObjectType = createTypeCheckFunction(["ObjectTypeAnnotation", "TSTypeLiteral", "TSMappedType"]);
        var isFunctionOrArrowExpression = createTypeCheckFunction(["FunctionExpression", "ArrowFunctionExpression"]);
        function isFunctionOrArrowExpressionWithBody(node) {
          return node.type === "FunctionExpression" || node.type === "ArrowFunctionExpression" && node.body.type === "BlockStatement";
        }
        function isAngularTestWrapper(node) {
          return isCallExpression(node) && node.callee.type === "Identifier" && ["async", "inject", "fakeAsync", "waitForAsync"].includes(node.callee.name);
        }
        var isJsxNode = createTypeCheckFunction(["JSXElement", "JSXFragment"]);
        function isTheOnlyJsxElementInMarkdown(options, path5) {
          if (options.parentParser !== "markdown" && options.parentParser !== "mdx") {
            return false;
          }
          const node = path5.getNode();
          if (!node.expression || !isJsxNode(node.expression)) {
            return false;
          }
          const parent = path5.getParentNode();
          return parent.type === "Program" && parent.body.length === 1;
        }
        function isGetterOrSetter(node) {
          return node.kind === "get" || node.kind === "set";
        }
        function isFunctionNotation(node) {
          return isGetterOrSetter(node) || hasSameLocStart(node, node.value);
        }
        function isObjectTypePropertyAFunction(node) {
          return (node.type === "ObjectTypeProperty" || node.type === "ObjectTypeInternalSlot") && node.value.type === "FunctionTypeAnnotation" && !node.static && !isFunctionNotation(node);
        }
        function isTypeAnnotationAFunction(node) {
          return (node.type === "TypeAnnotation" || node.type === "TSTypeAnnotation") && node.typeAnnotation.type === "FunctionTypeAnnotation" && !node.static && !hasSameLocStart(node, node.typeAnnotation);
        }
        var isBinaryish = createTypeCheckFunction(["BinaryExpression", "LogicalExpression", "NGPipeExpression"]);
        function isMemberish(node) {
          return isMemberExpression(node) || node.type === "BindExpression" && Boolean(node.object);
        }
        var simpleTypeAnnotations = /* @__PURE__ */ new Set(["AnyTypeAnnotation", "TSAnyKeyword", "NullLiteralTypeAnnotation", "TSNullKeyword", "ThisTypeAnnotation", "TSThisType", "NumberTypeAnnotation", "TSNumberKeyword", "VoidTypeAnnotation", "TSVoidKeyword", "BooleanTypeAnnotation", "TSBooleanKeyword", "BigIntTypeAnnotation", "TSBigIntKeyword", "SymbolTypeAnnotation", "TSSymbolKeyword", "StringTypeAnnotation", "TSStringKeyword", "BooleanLiteralTypeAnnotation", "StringLiteralTypeAnnotation", "BigIntLiteralTypeAnnotation", "NumberLiteralTypeAnnotation", "TSLiteralType", "TSTemplateLiteralType", "EmptyTypeAnnotation", "MixedTypeAnnotation", "TSNeverKeyword", "TSObjectKeyword", "TSUndefinedKeyword", "TSUnknownKeyword"]);
        function isSimpleType(node) {
          if (!node) {
            return false;
          }
          if ((node.type === "GenericTypeAnnotation" || node.type === "TSTypeReference") && !node.typeParameters) {
            return true;
          }
          if (simpleTypeAnnotations.has(node.type)) {
            return true;
          }
          return false;
        }
        function isUnitTestSetUp(node) {
          const unitTestSetUpRe = /^(?:before|after)(?:Each|All)$/;
          return node.callee.type === "Identifier" && unitTestSetUpRe.test(node.callee.name) && node.arguments.length === 1;
        }
        var testCallCalleePatterns = ["it", "it.only", "it.skip", "describe", "describe.only", "describe.skip", "test", "test.only", "test.skip", "test.step", "test.describe", "test.describe.only", "test.describe.parallel", "test.describe.parallel.only", "test.describe.serial", "test.describe.serial.only", "skip", "xit", "xdescribe", "xtest", "fit", "fdescribe", "ftest"];
        function isTestCallCallee(node) {
          return isNodeMatches(node, testCallCalleePatterns);
        }
        function isTestCall(node, parent) {
          if (node.type !== "CallExpression") {
            return false;
          }
          if (node.arguments.length === 1) {
            if (isAngularTestWrapper(node) && parent && isTestCall(parent)) {
              return isFunctionOrArrowExpression(node.arguments[0]);
            }
            if (isUnitTestSetUp(node)) {
              return isAngularTestWrapper(node.arguments[0]);
            }
          } else if (node.arguments.length === 2 || node.arguments.length === 3) {
            if ((node.arguments[0].type === "TemplateLiteral" || isStringLiteral(node.arguments[0])) && isTestCallCallee(node.callee)) {
              if (node.arguments[2] && !isNumericLiteral(node.arguments[2])) {
                return false;
              }
              return (node.arguments.length === 2 ? isFunctionOrArrowExpression(node.arguments[1]) : isFunctionOrArrowExpressionWithBody(node.arguments[1]) && getFunctionParameters(node.arguments[1]).length <= 1) || isAngularTestWrapper(node.arguments[1]);
            }
          }
          return false;
        }
        var isCallExpression = createTypeCheckFunction(["CallExpression", "OptionalCallExpression"]);
        var isMemberExpression = createTypeCheckFunction(["MemberExpression", "OptionalMemberExpression"]);
        function isSimpleTemplateLiteral(node) {
          let expressionsKey = "expressions";
          if (node.type === "TSTemplateLiteralType") {
            expressionsKey = "types";
          }
          const expressions = node[expressionsKey];
          if (expressions.length === 0) {
            return false;
          }
          return expressions.every((expr) => {
            if (hasComment(expr)) {
              return false;
            }
            if (expr.type === "Identifier" || expr.type === "ThisExpression") {
              return true;
            }
            if (isMemberExpression(expr)) {
              let head = expr;
              while (isMemberExpression(head)) {
                if (head.property.type !== "Identifier" && head.property.type !== "Literal" && head.property.type !== "StringLiteral" && head.property.type !== "NumericLiteral") {
                  return false;
                }
                head = head.object;
                if (hasComment(head)) {
                  return false;
                }
              }
              if (head.type === "Identifier" || head.type === "ThisExpression") {
                return true;
              }
              return false;
            }
            return false;
          });
        }
        function getTypeScriptMappedTypeModifier(tokenNode, keyword) {
          if (tokenNode === "+" || tokenNode === "-") {
            return tokenNode + keyword;
          }
          return keyword;
        }
        function isFlowAnnotationComment(text, typeAnnotation) {
          const start = locStart(typeAnnotation);
          const end = skipWhitespace(text, locEnd(typeAnnotation));
          return end !== false && text.slice(start, start + 2) === "/*" && text.slice(end, end + 2) === "*/";
        }
        function hasLeadingOwnLineComment(text, node) {
          if (isJsxNode(node)) {
            return hasNodeIgnoreComment(node);
          }
          return hasComment(node, CommentCheckFlags.Leading, (comment) => hasNewline(text, locEnd(comment)));
        }
        function isStringPropSafeToUnquote(node, options) {
          return options.parser !== "json" && isStringLiteral(node.key) && rawText(node.key).slice(1, -1) === node.key.value && (isIdentifierName(node.key.value) && !(options.parser === "babel-ts" && node.type === "ClassProperty" || options.parser === "typescript" && node.type === "PropertyDefinition") || isSimpleNumber(node.key.value) && String(Number(node.key.value)) === node.key.value && (options.parser === "babel" || options.parser === "acorn" || options.parser === "espree" || options.parser === "meriyah" || options.parser === "__babel_estree"));
        }
        function isSimpleNumber(numberString) {
          return /^(?:\d+|\d+\.\d+)$/.test(numberString);
        }
        function isJestEachTemplateLiteral(node, parentNode) {
          const jestEachTriggerRegex = /^[fx]?(?:describe|it|test)$/;
          return parentNode.type === "TaggedTemplateExpression" && parentNode.quasi === node && parentNode.tag.type === "MemberExpression" && parentNode.tag.property.type === "Identifier" && parentNode.tag.property.name === "each" && (parentNode.tag.object.type === "Identifier" && jestEachTriggerRegex.test(parentNode.tag.object.name) || parentNode.tag.object.type === "MemberExpression" && parentNode.tag.object.property.type === "Identifier" && (parentNode.tag.object.property.name === "only" || parentNode.tag.object.property.name === "skip") && parentNode.tag.object.object.type === "Identifier" && jestEachTriggerRegex.test(parentNode.tag.object.object.name));
        }
        function templateLiteralHasNewLines(template) {
          return template.quasis.some((quasi) => quasi.value.raw.includes("\n"));
        }
        function isTemplateOnItsOwnLine(node, text) {
          return (node.type === "TemplateLiteral" && templateLiteralHasNewLines(node) || node.type === "TaggedTemplateExpression" && templateLiteralHasNewLines(node.quasi)) && !hasNewline(text, locStart(node), {
            backwards: true
          });
        }
        function needsHardlineAfterDanglingComment(node) {
          if (!hasComment(node)) {
            return false;
          }
          const lastDanglingComment = getLast(getComments(node, CommentCheckFlags.Dangling));
          return lastDanglingComment && !isBlockComment(lastDanglingComment);
        }
        function isFunctionCompositionArgs(args) {
          if (args.length <= 1) {
            return false;
          }
          let count = 0;
          for (const arg of args) {
            if (isFunctionOrArrowExpression(arg)) {
              count += 1;
              if (count > 1) {
                return true;
              }
            } else if (isCallExpression(arg)) {
              for (const childArg of arg.arguments) {
                if (isFunctionOrArrowExpression(childArg)) {
                  return true;
                }
              }
            }
          }
          return false;
        }
        function isLongCurriedCallExpression(path5) {
          const node = path5.getValue();
          const parent = path5.getParentNode();
          return isCallExpression(node) && isCallExpression(parent) && parent.callee === node && node.arguments.length > parent.arguments.length && parent.arguments.length > 0;
        }
        function isSimpleCallArgument(node, depth) {
          if (depth >= 2) {
            return false;
          }
          const isChildSimple = (child) => isSimpleCallArgument(child, depth + 1);
          const regexpPattern = node.type === "Literal" && "regex" in node && node.regex.pattern || node.type === "RegExpLiteral" && node.pattern;
          if (regexpPattern && getStringWidth(regexpPattern) > 5) {
            return false;
          }
          if (node.type === "Literal" || node.type === "BigIntLiteral" || node.type === "DecimalLiteral" || node.type === "BooleanLiteral" || node.type === "NullLiteral" || node.type === "NumericLiteral" || node.type === "RegExpLiteral" || node.type === "StringLiteral" || node.type === "Identifier" || node.type === "ThisExpression" || node.type === "Super" || node.type === "PrivateName" || node.type === "PrivateIdentifier" || node.type === "ArgumentPlaceholder" || node.type === "Import") {
            return true;
          }
          if (node.type === "TemplateLiteral") {
            return node.quasis.every((element) => !element.value.raw.includes("\n")) && node.expressions.every(isChildSimple);
          }
          if (node.type === "ObjectExpression") {
            return node.properties.every((p) => !p.computed && (p.shorthand || p.value && isChildSimple(p.value)));
          }
          if (node.type === "ArrayExpression") {
            return node.elements.every((x) => x === null || isChildSimple(x));
          }
          if (isCallLikeExpression(node)) {
            return (node.type === "ImportExpression" || isSimpleCallArgument(node.callee, depth)) && getCallArguments(node).every(isChildSimple);
          }
          if (isMemberExpression(node)) {
            return isSimpleCallArgument(node.object, depth) && isSimpleCallArgument(node.property, depth);
          }
          if (node.type === "UnaryExpression" && (node.operator === "!" || node.operator === "-")) {
            return isSimpleCallArgument(node.argument, depth);
          }
          if (node.type === "TSNonNullExpression") {
            return isSimpleCallArgument(node.expression, depth);
          }
          return false;
        }
        function rawText(node) {
          var _node$extra$raw, _node$extra2;
          return (_node$extra$raw = (_node$extra2 = node.extra) === null || _node$extra2 === void 0 ? void 0 : _node$extra2.raw) !== null && _node$extra$raw !== void 0 ? _node$extra$raw : node.raw;
        }
        function identity2(x) {
          return x;
        }
        function isTSXFile(options) {
          return options.filepath && /\.tsx$/i.test(options.filepath);
        }
        function shouldPrintComma(options, level = "es5") {
          return options.trailingComma === "es5" && level === "es5" || options.trailingComma === "all" && (level === "all" || level === "es5");
        }
        function startsWithNoLookaheadToken(node, forbidFunctionClassAndDoExpr) {
          node = getLeftMost(node);
          switch (node.type) {
            case "FunctionExpression":
            case "ClassExpression":
            case "DoExpression":
              return forbidFunctionClassAndDoExpr;
            case "ObjectExpression":
              return true;
            case "MemberExpression":
            case "OptionalMemberExpression":
              return startsWithNoLookaheadToken(node.object, forbidFunctionClassAndDoExpr);
            case "TaggedTemplateExpression":
              if (node.tag.type === "FunctionExpression") {
                return false;
              }
              return startsWithNoLookaheadToken(node.tag, forbidFunctionClassAndDoExpr);
            case "CallExpression":
            case "OptionalCallExpression":
              if (node.callee.type === "FunctionExpression") {
                return false;
              }
              return startsWithNoLookaheadToken(node.callee, forbidFunctionClassAndDoExpr);
            case "ConditionalExpression":
              return startsWithNoLookaheadToken(node.test, forbidFunctionClassAndDoExpr);
            case "UpdateExpression":
              return !node.prefix && startsWithNoLookaheadToken(node.argument, forbidFunctionClassAndDoExpr);
            case "BindExpression":
              return node.object && startsWithNoLookaheadToken(node.object, forbidFunctionClassAndDoExpr);
            case "SequenceExpression":
              return startsWithNoLookaheadToken(node.expressions[0], forbidFunctionClassAndDoExpr);
            case "TSAsExpression":
            case "TSNonNullExpression":
              return startsWithNoLookaheadToken(node.expression, forbidFunctionClassAndDoExpr);
            default:
              return false;
          }
        }
        var equalityOperators = {
          "==": true,
          "!=": true,
          "===": true,
          "!==": true
        };
        var multiplicativeOperators = {
          "*": true,
          "/": true,
          "%": true
        };
        var bitshiftOperators = {
          ">>": true,
          ">>>": true,
          "<<": true
        };
        function shouldFlatten(parentOp, nodeOp) {
          if (getPrecedence(nodeOp) !== getPrecedence(parentOp)) {
            return false;
          }
          if (parentOp === "**") {
            return false;
          }
          if (equalityOperators[parentOp] && equalityOperators[nodeOp]) {
            return false;
          }
          if (nodeOp === "%" && multiplicativeOperators[parentOp] || parentOp === "%" && multiplicativeOperators[nodeOp]) {
            return false;
          }
          if (nodeOp !== parentOp && multiplicativeOperators[nodeOp] && multiplicativeOperators[parentOp]) {
            return false;
          }
          if (bitshiftOperators[parentOp] && bitshiftOperators[nodeOp]) {
            return false;
          }
          return true;
        }
        var PRECEDENCE = new Map([["|>"], ["??"], ["||"], ["&&"], ["|"], ["^"], ["&"], ["==", "===", "!=", "!=="], ["<", ">", "<=", ">=", "in", "instanceof"], [">>", "<<", ">>>"], ["+", "-"], ["*", "/", "%"], ["**"]].flatMap((operators, index) => operators.map((operator) => [operator, index])));
        function getPrecedence(operator) {
          return PRECEDENCE.get(operator);
        }
        function getLeftMost(node) {
          while (node.left) {
            node = node.left;
          }
          return node;
        }
        function isBitwiseOperator(operator) {
          return Boolean(bitshiftOperators[operator]) || operator === "|" || operator === "^" || operator === "&";
        }
        function hasRestParameter(node) {
          var _getLast;
          if (node.rest) {
            return true;
          }
          const parameters = getFunctionParameters(node);
          return ((_getLast = getLast(parameters)) === null || _getLast === void 0 ? void 0 : _getLast.type) === "RestElement";
        }
        var functionParametersCache = /* @__PURE__ */ new WeakMap();
        function getFunctionParameters(node) {
          if (functionParametersCache.has(node)) {
            return functionParametersCache.get(node);
          }
          const parameters = [];
          if (node.this) {
            parameters.push(node.this);
          }
          if (Array.isArray(node.parameters)) {
            parameters.push(...node.parameters);
          } else if (Array.isArray(node.params)) {
            parameters.push(...node.params);
          }
          if (node.rest) {
            parameters.push(node.rest);
          }
          functionParametersCache.set(node, parameters);
          return parameters;
        }
        function iterateFunctionParametersPath(path5, iteratee) {
          const node = path5.getValue();
          let index = 0;
          const callback = (childPath) => iteratee(childPath, index++);
          if (node.this) {
            path5.call(callback, "this");
          }
          if (Array.isArray(node.parameters)) {
            path5.each(callback, "parameters");
          } else if (Array.isArray(node.params)) {
            path5.each(callback, "params");
          }
          if (node.rest) {
            path5.call(callback, "rest");
          }
        }
        var callArgumentsCache = /* @__PURE__ */ new WeakMap();
        function getCallArguments(node) {
          if (callArgumentsCache.has(node)) {
            return callArgumentsCache.get(node);
          }
          let args = node.arguments;
          if (node.type === "ImportExpression") {
            args = [node.source];
            if (node.attributes) {
              args.push(node.attributes);
            }
          }
          callArgumentsCache.set(node, args);
          return args;
        }
        function iterateCallArgumentsPath(path5, iteratee) {
          const node = path5.getValue();
          if (node.type === "ImportExpression") {
            path5.call((sourcePath) => iteratee(sourcePath, 0), "source");
            if (node.attributes) {
              path5.call((sourcePath) => iteratee(sourcePath, 1), "attributes");
            }
          } else {
            path5.each(iteratee, "arguments");
          }
        }
        function isPrettierIgnoreComment(comment) {
          return comment.value.trim() === "prettier-ignore" && !comment.unignore;
        }
        function hasNodeIgnoreComment(node) {
          return node && (node.prettierIgnore || hasComment(node, CommentCheckFlags.PrettierIgnore));
        }
        function hasIgnoreComment(path5) {
          const node = path5.getValue();
          return hasNodeIgnoreComment(node);
        }
        var CommentCheckFlags = {
          Leading: 1 << 1,
          Trailing: 1 << 2,
          Dangling: 1 << 3,
          Block: 1 << 4,
          Line: 1 << 5,
          PrettierIgnore: 1 << 6,
          First: 1 << 7,
          Last: 1 << 8
        };
        var getCommentTestFunction = (flags, fn) => {
          if (typeof flags === "function") {
            fn = flags;
            flags = 0;
          }
          if (flags || fn) {
            return (comment, index, comments) => !(flags & CommentCheckFlags.Leading && !comment.leading || flags & CommentCheckFlags.Trailing && !comment.trailing || flags & CommentCheckFlags.Dangling && (comment.leading || comment.trailing) || flags & CommentCheckFlags.Block && !isBlockComment(comment) || flags & CommentCheckFlags.Line && !isLineComment(comment) || flags & CommentCheckFlags.First && index !== 0 || flags & CommentCheckFlags.Last && index !== comments.length - 1 || flags & CommentCheckFlags.PrettierIgnore && !isPrettierIgnoreComment(comment) || fn && !fn(comment));
          }
        };
        function hasComment(node, flags, fn) {
          if (!isNonEmptyArray(node === null || node === void 0 ? void 0 : node.comments)) {
            return false;
          }
          const test = getCommentTestFunction(flags, fn);
          return test ? node.comments.some(test) : true;
        }
        function getComments(node, flags, fn) {
          if (!Array.isArray(node === null || node === void 0 ? void 0 : node.comments)) {
            return [];
          }
          const test = getCommentTestFunction(flags, fn);
          return test ? node.comments.filter(test) : node.comments;
        }
        var isNextLineEmpty = (node, {
          originalText
        }) => isNextLineEmptyAfterIndex(originalText, locEnd(node));
        function isCallLikeExpression(node) {
          return isCallExpression(node) || node.type === "NewExpression" || node.type === "ImportExpression";
        }
        function isObjectProperty(node) {
          return node && (node.type === "ObjectProperty" || node.type === "Property" && !node.method && node.kind === "init");
        }
        function isEnabledHackPipeline(options) {
          return Boolean(options.__isUsingHackPipeline);
        }
        var markerForIfWithoutBlockAndSameLineComment = Symbol("ifWithoutBlockAndSameLineComment");
        module22.exports = {
          getFunctionParameters,
          iterateFunctionParametersPath,
          getCallArguments,
          iterateCallArgumentsPath,
          hasRestParameter,
          getLeftSide,
          getLeftSidePathName,
          getParentExportDeclaration,
          getTypeScriptMappedTypeModifier,
          hasFlowAnnotationComment,
          hasFlowShorthandAnnotationComment,
          hasLeadingOwnLineComment,
          hasNakedLeftSide,
          hasNode,
          hasIgnoreComment,
          hasNodeIgnoreComment,
          identity: identity2,
          isBinaryish,
          isCallLikeExpression,
          isEnabledHackPipeline,
          isLineComment,
          isPrettierIgnoreComment,
          isCallExpression,
          isMemberExpression,
          isExportDeclaration,
          isFlowAnnotationComment,
          isFunctionCompositionArgs,
          isFunctionNotation,
          isFunctionOrArrowExpression,
          isGetterOrSetter,
          isJestEachTemplateLiteral,
          isJsxNode,
          isLiteral,
          isLongCurriedCallExpression,
          isSimpleCallArgument,
          isMemberish,
          isNumericLiteral,
          isSignedNumericLiteral,
          isObjectProperty,
          isObjectType,
          isObjectTypePropertyAFunction,
          isSimpleType,
          isSimpleNumber,
          isSimpleTemplateLiteral,
          isStringLiteral,
          isStringPropSafeToUnquote,
          isTemplateOnItsOwnLine,
          isTestCall,
          isTheOnlyJsxElementInMarkdown,
          isTSXFile,
          isTypeAnnotationAFunction,
          isNextLineEmpty,
          needsHardlineAfterDanglingComment,
          rawText,
          shouldPrintComma,
          isBitwiseOperator,
          shouldFlatten,
          startsWithNoLookaheadToken,
          getPrecedence,
          hasComment,
          getComments,
          CommentCheckFlags,
          markerForIfWithoutBlockAndSameLineComment
        };
      }
    });
    var require_template_literal = __commonJS22({
      "src/language-js/print/template-literal.js"(exports22, module22) {
        "use strict";
        var getLast = require_get_last();
        var {
          getStringWidth,
          getIndentSize
        } = require_util2();
        var {
          builders: {
            join: join2,
            hardline,
            softline,
            group,
            indent,
            align,
            lineSuffixBoundary,
            addAlignmentToDoc
          },
          printer: {
            printDocToString
          },
          utils: {
            mapDoc
          }
        } = require_doc();
        var {
          isBinaryish,
          isJestEachTemplateLiteral,
          isSimpleTemplateLiteral,
          hasComment,
          isMemberExpression
        } = require_utils72();
        function printTemplateLiteral(path5, print, options) {
          const node = path5.getValue();
          const isTemplateLiteral = node.type === "TemplateLiteral";
          if (isTemplateLiteral && isJestEachTemplateLiteral(node, path5.getParentNode())) {
            const printed = printJestEachTemplateLiteral(path5, options, print);
            if (printed) {
              return printed;
            }
          }
          let expressionsKey = "expressions";
          if (node.type === "TSTemplateLiteralType") {
            expressionsKey = "types";
          }
          const parts = [];
          let expressions = path5.map(print, expressionsKey);
          const isSimple = isSimpleTemplateLiteral(node);
          if (isSimple) {
            expressions = expressions.map((doc2) => printDocToString(doc2, Object.assign(Object.assign({}, options), {}, {
              printWidth: Number.POSITIVE_INFINITY
            })).formatted);
          }
          parts.push(lineSuffixBoundary, "`");
          path5.each((childPath) => {
            const i = childPath.getName();
            parts.push(print());
            if (i < expressions.length) {
              const {
                tabWidth
              } = options;
              const quasi = childPath.getValue();
              const indentSize = getIndentSize(quasi.value.raw, tabWidth);
              let printed = expressions[i];
              if (!isSimple) {
                const expression = node[expressionsKey][i];
                if (hasComment(expression) || isMemberExpression(expression) || expression.type === "ConditionalExpression" || expression.type === "SequenceExpression" || expression.type === "TSAsExpression" || isBinaryish(expression)) {
                  printed = [indent([softline, printed]), softline];
                }
              }
              const aligned = indentSize === 0 && quasi.value.raw.endsWith("\n") ? align(Number.NEGATIVE_INFINITY, printed) : addAlignmentToDoc(printed, indentSize, tabWidth);
              parts.push(group(["${", aligned, lineSuffixBoundary, "}"]));
            }
          }, "quasis");
          parts.push("`");
          return parts;
        }
        function printJestEachTemplateLiteral(path5, options, print) {
          const node = path5.getNode();
          const headerNames = node.quasis[0].value.raw.trim().split(/\s*\|\s*/);
          if (headerNames.length > 1 || headerNames.some((headerName) => headerName.length > 0)) {
            options.__inJestEach = true;
            const expressions = path5.map(print, "expressions");
            options.__inJestEach = false;
            const parts = [];
            const stringifiedExpressions = expressions.map((doc2) => "${" + printDocToString(doc2, Object.assign(Object.assign({}, options), {}, {
              printWidth: Number.POSITIVE_INFINITY,
              endOfLine: "lf"
            })).formatted + "}");
            const tableBody = [{
              hasLineBreak: false,
              cells: []
            }];
            for (let i = 1; i < node.quasis.length; i++) {
              const row = getLast(tableBody);
              const correspondingExpression = stringifiedExpressions[i - 1];
              row.cells.push(correspondingExpression);
              if (correspondingExpression.includes("\n")) {
                row.hasLineBreak = true;
              }
              if (node.quasis[i].value.raw.includes("\n")) {
                tableBody.push({
                  hasLineBreak: false,
                  cells: []
                });
              }
            }
            const maxColumnCount = Math.max(headerNames.length, ...tableBody.map((row) => row.cells.length));
            const maxColumnWidths = Array.from({
              length: maxColumnCount
            }).fill(0);
            const table = [{
              cells: headerNames
            }, ...tableBody.filter((row) => row.cells.length > 0)];
            for (const {
              cells
            } of table.filter((row) => !row.hasLineBreak)) {
              for (const [index, cell] of cells.entries()) {
                maxColumnWidths[index] = Math.max(maxColumnWidths[index], getStringWidth(cell));
              }
            }
            parts.push(lineSuffixBoundary, "`", indent([hardline, join2(hardline, table.map((row) => join2(" | ", row.cells.map((cell, index) => row.hasLineBreak ? cell : cell + " ".repeat(maxColumnWidths[index] - getStringWidth(cell))))))]), hardline, "`");
            return parts;
          }
        }
        function printTemplateExpression(path5, print) {
          const node = path5.getValue();
          let printed = print();
          if (hasComment(node)) {
            printed = group([indent([softline, printed]), softline]);
          }
          return ["${", printed, lineSuffixBoundary, "}"];
        }
        function printTemplateExpressions(path5, print) {
          return path5.map((path22) => printTemplateExpression(path22, print), "expressions");
        }
        function escapeTemplateCharacters(doc2, raw) {
          return mapDoc(doc2, (currentDoc) => {
            if (typeof currentDoc === "string") {
              return raw ? currentDoc.replace(/(\\*)`/g, "$1$1\\`") : uncookTemplateElementValue(currentDoc);
            }
            return currentDoc;
          });
        }
        function uncookTemplateElementValue(cookedValue) {
          return cookedValue.replace(/([\\`]|\${)/g, "\\$1");
        }
        module22.exports = {
          printTemplateLiteral,
          printTemplateExpressions,
          escapeTemplateCharacters,
          uncookTemplateElementValue
        };
      }
    });
    var require_markdown = __commonJS22({
      "src/language-js/embed/markdown.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            indent,
            softline,
            literalline,
            dedentToRoot
          }
        } = require_doc();
        var {
          escapeTemplateCharacters
        } = require_template_literal();
        function format(path5, print, textToDoc) {
          const node = path5.getValue();
          let text = node.quasis[0].value.raw.replace(/((?:\\\\)*)\\`/g, (_, backslashes) => "\\".repeat(backslashes.length / 2) + "`");
          const indentation = getIndentation(text);
          const hasIndent = indentation !== "";
          if (hasIndent) {
            text = text.replace(new RegExp(`^${indentation}`, "gm"), "");
          }
          const doc2 = escapeTemplateCharacters(textToDoc(text, {
            parser: "markdown",
            __inJsTemplate: true
          }, {
            stripTrailingHardline: true
          }), true);
          return ["`", hasIndent ? indent([softline, doc2]) : [literalline, dedentToRoot(doc2)], softline, "`"];
        }
        function getIndentation(str2) {
          const firstMatchedIndent = str2.match(/^([^\S\n]*)\S/m);
          return firstMatchedIndent === null ? "" : firstMatchedIndent[1];
        }
        module22.exports = format;
      }
    });
    var require_css = __commonJS22({
      "src/language-js/embed/css.js"(exports22, module22) {
        "use strict";
        var {
          isNonEmptyArray
        } = require_util2();
        var {
          builders: {
            indent,
            hardline,
            softline
          },
          utils: {
            mapDoc,
            replaceEndOfLine,
            cleanDoc
          }
        } = require_doc();
        var {
          printTemplateExpressions
        } = require_template_literal();
        function format(path5, print, textToDoc) {
          const node = path5.getValue();
          const rawQuasis = node.quasis.map((q) => q.value.raw);
          let placeholderID = 0;
          const text = rawQuasis.reduce((prevVal, currVal, idx) => idx === 0 ? currVal : prevVal + "@prettier-placeholder-" + placeholderID++ + "-id" + currVal, "");
          const doc2 = textToDoc(text, {
            parser: "scss"
          }, {
            stripTrailingHardline: true
          });
          const expressionDocs = printTemplateExpressions(path5, print);
          return transformCssDoc(doc2, node, expressionDocs);
        }
        function transformCssDoc(quasisDoc, parentNode, expressionDocs) {
          const isEmpty = parentNode.quasis.length === 1 && !parentNode.quasis[0].value.raw.trim();
          if (isEmpty) {
            return "``";
          }
          const newDoc = replacePlaceholders(quasisDoc, expressionDocs);
          if (!newDoc) {
            throw new Error("Couldn't insert all the expressions");
          }
          return ["`", indent([hardline, newDoc]), softline, "`"];
        }
        function replacePlaceholders(quasisDoc, expressionDocs) {
          if (!isNonEmptyArray(expressionDocs)) {
            return quasisDoc;
          }
          let replaceCounter = 0;
          const newDoc = mapDoc(cleanDoc(quasisDoc), (doc2) => {
            if (typeof doc2 !== "string" || !doc2.includes("@prettier-placeholder")) {
              return doc2;
            }
            return doc2.split(/@prettier-placeholder-(\d+)-id/).map((component, idx) => {
              if (idx % 2 === 0) {
                return replaceEndOfLine(component);
              }
              replaceCounter++;
              return expressionDocs[component];
            });
          });
          return expressionDocs.length === replaceCounter ? newDoc : null;
        }
        module22.exports = format;
      }
    });
    var require_graphql = __commonJS22({
      "src/language-js/embed/graphql.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            indent,
            join: join2,
            hardline
          }
        } = require_doc();
        var {
          escapeTemplateCharacters,
          printTemplateExpressions
        } = require_template_literal();
        function format(path5, print, textToDoc) {
          const node = path5.getValue();
          const numQuasis = node.quasis.length;
          if (numQuasis === 1 && node.quasis[0].value.raw.trim() === "") {
            return "``";
          }
          const expressionDocs = printTemplateExpressions(path5, print);
          const parts = [];
          for (let i = 0; i < numQuasis; i++) {
            const templateElement = node.quasis[i];
            const isFirst = i === 0;
            const isLast = i === numQuasis - 1;
            const text = templateElement.value.cooked;
            const lines = text.split("\n");
            const numLines = lines.length;
            const expressionDoc = expressionDocs[i];
            const startsWithBlankLine = numLines > 2 && lines[0].trim() === "" && lines[1].trim() === "";
            const endsWithBlankLine = numLines > 2 && lines[numLines - 1].trim() === "" && lines[numLines - 2].trim() === "";
            const commentsAndWhitespaceOnly = lines.every((line) => /^\s*(?:#[^\n\r]*)?$/.test(line));
            if (!isLast && /#[^\n\r]*$/.test(lines[numLines - 1])) {
              return null;
            }
            let doc2 = null;
            if (commentsAndWhitespaceOnly) {
              doc2 = printGraphqlComments(lines);
            } else {
              doc2 = textToDoc(text, {
                parser: "graphql"
              }, {
                stripTrailingHardline: true
              });
            }
            if (doc2) {
              doc2 = escapeTemplateCharacters(doc2, false);
              if (!isFirst && startsWithBlankLine) {
                parts.push("");
              }
              parts.push(doc2);
              if (!isLast && endsWithBlankLine) {
                parts.push("");
              }
            } else if (!isFirst && !isLast && startsWithBlankLine) {
              parts.push("");
            }
            if (expressionDoc) {
              parts.push(expressionDoc);
            }
          }
          return ["`", indent([hardline, join2(hardline, parts)]), hardline, "`"];
        }
        function printGraphqlComments(lines) {
          const parts = [];
          let seenComment = false;
          const array = lines.map((textLine) => textLine.trim());
          for (const [i, textLine] of array.entries()) {
            if (textLine === "") {
              continue;
            }
            if (array[i - 1] === "" && seenComment) {
              parts.push([hardline, textLine]);
            } else {
              parts.push(textLine);
            }
            seenComment = true;
          }
          return parts.length === 0 ? null : join2(hardline, parts);
        }
        module22.exports = format;
      }
    });
    var require_html = __commonJS22({
      "src/language-js/embed/html.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            indent,
            line,
            hardline,
            group
          },
          utils: {
            mapDoc
          }
        } = require_doc();
        var {
          printTemplateExpressions,
          uncookTemplateElementValue
        } = require_template_literal();
        var htmlTemplateLiteralCounter = 0;
        function format(path5, print, textToDoc, options, {
          parser
        }) {
          const node = path5.getValue();
          const counter = htmlTemplateLiteralCounter;
          htmlTemplateLiteralCounter = htmlTemplateLiteralCounter + 1 >>> 0;
          const composePlaceholder = (index) => `PRETTIER_HTML_PLACEHOLDER_${index}_${counter}_IN_JS`;
          const text = node.quasis.map((quasi, index, quasis) => index === quasis.length - 1 ? quasi.value.cooked : quasi.value.cooked + composePlaceholder(index)).join("");
          const expressionDocs = printTemplateExpressions(path5, print);
          if (expressionDocs.length === 0 && text.trim().length === 0) {
            return "``";
          }
          const placeholderRegex = new RegExp(composePlaceholder("(\\d+)"), "g");
          let topLevelCount = 0;
          const doc2 = textToDoc(text, {
            parser,
            __onHtmlRoot(root2) {
              topLevelCount = root2.children.length;
            }
          }, {
            stripTrailingHardline: true
          });
          const contentDoc = mapDoc(doc2, (doc3) => {
            if (typeof doc3 !== "string") {
              return doc3;
            }
            const parts = [];
            const components = doc3.split(placeholderRegex);
            for (let i = 0; i < components.length; i++) {
              let component = components[i];
              if (i % 2 === 0) {
                if (component) {
                  component = uncookTemplateElementValue(component);
                  if (options.__embeddedInHtml) {
                    component = component.replace(/<\/(script)\b/gi, "<\\/$1");
                  }
                  parts.push(component);
                }
                continue;
              }
              const placeholderIndex = Number(component);
              parts.push(expressionDocs[placeholderIndex]);
            }
            return parts;
          });
          const leadingWhitespace = /^\s/.test(text) ? " " : "";
          const trailingWhitespace = /\s$/.test(text) ? " " : "";
          const linebreak = options.htmlWhitespaceSensitivity === "ignore" ? hardline : leadingWhitespace && trailingWhitespace ? line : null;
          if (linebreak) {
            return group(["`", indent([linebreak, group(contentDoc)]), linebreak, "`"]);
          }
          return group(["`", leadingWhitespace, topLevelCount > 1 ? indent(group(contentDoc)) : group(contentDoc), trailingWhitespace, "`"]);
        }
        module22.exports = format;
      }
    });
    var require_embed = __commonJS22({
      "src/language-js/embed.js"(exports22, module22) {
        "use strict";
        var {
          hasComment,
          CommentCheckFlags,
          isObjectProperty
        } = require_utils72();
        var formatMarkdown = require_markdown();
        var formatCss = require_css();
        var formatGraphql = require_graphql();
        var formatHtml = require_html();
        function getLanguage(path5) {
          if (isStyledJsx(path5) || isStyledComponents(path5) || isCssProp(path5) || isAngularComponentStyles(path5)) {
            return "css";
          }
          if (isGraphQL(path5)) {
            return "graphql";
          }
          if (isHtml(path5)) {
            return "html";
          }
          if (isAngularComponentTemplate(path5)) {
            return "angular";
          }
          if (isMarkdown(path5)) {
            return "markdown";
          }
        }
        function embed(path5, print, textToDoc, options) {
          const node = path5.getValue();
          if (node.type !== "TemplateLiteral" || hasInvalidCookedValue(node)) {
            return;
          }
          const language = getLanguage(path5);
          if (!language) {
            return;
          }
          if (language === "markdown") {
            return formatMarkdown(path5, print, textToDoc);
          }
          if (language === "css") {
            return formatCss(path5, print, textToDoc);
          }
          if (language === "graphql") {
            return formatGraphql(path5, print, textToDoc);
          }
          if (language === "html" || language === "angular") {
            return formatHtml(path5, print, textToDoc, options, {
              parser: language
            });
          }
        }
        function isMarkdown(path5) {
          const node = path5.getValue();
          const parent = path5.getParentNode();
          return parent && parent.type === "TaggedTemplateExpression" && node.quasis.length === 1 && parent.tag.type === "Identifier" && (parent.tag.name === "md" || parent.tag.name === "markdown");
        }
        function isStyledJsx(path5) {
          const node = path5.getValue();
          const parent = path5.getParentNode();
          const parentParent = path5.getParentNode(1);
          return parentParent && node.quasis && parent.type === "JSXExpressionContainer" && parentParent.type === "JSXElement" && parentParent.openingElement.name.name === "style" && parentParent.openingElement.attributes.some((attribute) => attribute.name.name === "jsx") || parent && parent.type === "TaggedTemplateExpression" && parent.tag.type === "Identifier" && parent.tag.name === "css" || parent && parent.type === "TaggedTemplateExpression" && parent.tag.type === "MemberExpression" && parent.tag.object.name === "css" && (parent.tag.property.name === "global" || parent.tag.property.name === "resolve");
        }
        function isAngularComponentStyles(path5) {
          return path5.match((node) => node.type === "TemplateLiteral", (node, name) => node.type === "ArrayExpression" && name === "elements", (node, name) => isObjectProperty(node) && node.key.type === "Identifier" && node.key.name === "styles" && name === "value", ...angularComponentObjectExpressionPredicates);
        }
        function isAngularComponentTemplate(path5) {
          return path5.match((node) => node.type === "TemplateLiteral", (node, name) => isObjectProperty(node) && node.key.type === "Identifier" && node.key.name === "template" && name === "value", ...angularComponentObjectExpressionPredicates);
        }
        var angularComponentObjectExpressionPredicates = [(node, name) => node.type === "ObjectExpression" && name === "properties", (node, name) => node.type === "CallExpression" && node.callee.type === "Identifier" && node.callee.name === "Component" && name === "arguments", (node, name) => node.type === "Decorator" && name === "expression"];
        function isStyledComponents(path5) {
          const parent = path5.getParentNode();
          if (!parent || parent.type !== "TaggedTemplateExpression") {
            return false;
          }
          const tag = parent.tag.type === "ParenthesizedExpression" ? parent.tag.expression : parent.tag;
          switch (tag.type) {
            case "MemberExpression":
              return isStyledIdentifier(tag.object) || isStyledExtend(tag);
            case "CallExpression":
              return isStyledIdentifier(tag.callee) || tag.callee.type === "MemberExpression" && (tag.callee.object.type === "MemberExpression" && (isStyledIdentifier(tag.callee.object.object) || isStyledExtend(tag.callee.object)) || tag.callee.object.type === "CallExpression" && isStyledIdentifier(tag.callee.object.callee));
            case "Identifier":
              return tag.name === "css";
            default:
              return false;
          }
        }
        function isCssProp(path5) {
          const parent = path5.getParentNode();
          const parentParent = path5.getParentNode(1);
          return parentParent && parent.type === "JSXExpressionContainer" && parentParent.type === "JSXAttribute" && parentParent.name.type === "JSXIdentifier" && parentParent.name.name === "css";
        }
        function isStyledIdentifier(node) {
          return node.type === "Identifier" && node.name === "styled";
        }
        function isStyledExtend(node) {
          return /^[A-Z]/.test(node.object.name) && node.property.name === "extend";
        }
        function isGraphQL(path5) {
          const node = path5.getValue();
          const parent = path5.getParentNode();
          return hasLanguageComment(node, "GraphQL") || parent && (parent.type === "TaggedTemplateExpression" && (parent.tag.type === "MemberExpression" && parent.tag.object.name === "graphql" && parent.tag.property.name === "experimental" || parent.tag.type === "Identifier" && (parent.tag.name === "gql" || parent.tag.name === "graphql")) || parent.type === "CallExpression" && parent.callee.type === "Identifier" && parent.callee.name === "graphql");
        }
        function hasLanguageComment(node, languageName) {
          return hasComment(node, CommentCheckFlags.Block | CommentCheckFlags.Leading, ({
            value
          }) => value === ` ${languageName} `);
        }
        function isHtml(path5) {
          return hasLanguageComment(path5.getValue(), "HTML") || path5.match((node) => node.type === "TemplateLiteral", (node, name) => node.type === "TaggedTemplateExpression" && node.tag.type === "Identifier" && node.tag.name === "html" && name === "quasi");
        }
        function hasInvalidCookedValue({
          quasis
        }) {
          return quasis.some(({
            value: {
              cooked
            }
          }) => cooked === null);
        }
        module22.exports = embed;
      }
    });
    var require_clean = __commonJS22({
      "src/language-js/clean.js"(exports22, module22) {
        "use strict";
        var isBlockComment = require_is_block_comment();
        var ignoredProperties = /* @__PURE__ */ new Set(["range", "raw", "comments", "leadingComments", "trailingComments", "innerComments", "extra", "start", "end", "loc", "flags", "errors", "tokens"]);
        var removeTemplateElementsValue = (node) => {
          for (const templateElement of node.quasis) {
            delete templateElement.value;
          }
        };
        function clean(ast, newObj, parent) {
          if (ast.type === "Program") {
            delete newObj.sourceType;
          }
          if (ast.type === "BigIntLiteral" || ast.type === "BigIntLiteralTypeAnnotation") {
            if (newObj.value) {
              newObj.value = newObj.value.toLowerCase();
            }
          }
          if (ast.type === "BigIntLiteral" || ast.type === "Literal") {
            if (newObj.bigint) {
              newObj.bigint = newObj.bigint.toLowerCase();
            }
          }
          if (ast.type === "DecimalLiteral") {
            newObj.value = Number(newObj.value);
          }
          if (ast.type === "Literal" && newObj.decimal) {
            newObj.decimal = Number(newObj.decimal);
          }
          if (ast.type === "EmptyStatement") {
            return null;
          }
          if (ast.type === "JSXText") {
            return null;
          }
          if (ast.type === "JSXExpressionContainer" && (ast.expression.type === "Literal" || ast.expression.type === "StringLiteral") && ast.expression.value === " ") {
            return null;
          }
          if ((ast.type === "Property" || ast.type === "ObjectProperty" || ast.type === "MethodDefinition" || ast.type === "ClassProperty" || ast.type === "ClassMethod" || ast.type === "PropertyDefinition" || ast.type === "TSDeclareMethod" || ast.type === "TSPropertySignature" || ast.type === "ObjectTypeProperty") && typeof ast.key === "object" && ast.key && (ast.key.type === "Literal" || ast.key.type === "NumericLiteral" || ast.key.type === "StringLiteral" || ast.key.type === "Identifier")) {
            delete newObj.key;
          }
          if (ast.type === "JSXElement" && ast.openingElement.name.name === "style" && ast.openingElement.attributes.some((attr) => attr.name.name === "jsx")) {
            for (const {
              type: type2,
              expression: expression2
            } of newObj.children) {
              if (type2 === "JSXExpressionContainer" && expression2.type === "TemplateLiteral") {
                removeTemplateElementsValue(expression2);
              }
            }
          }
          if (ast.type === "JSXAttribute" && ast.name.name === "css" && ast.value.type === "JSXExpressionContainer" && ast.value.expression.type === "TemplateLiteral") {
            removeTemplateElementsValue(newObj.value.expression);
          }
          if (ast.type === "JSXAttribute" && ast.value && ast.value.type === "Literal" && /["']|&quot;|&apos;/.test(ast.value.value)) {
            newObj.value.value = newObj.value.value.replace(/["']|&quot;|&apos;/g, '"');
          }
          const expression = ast.expression || ast.callee;
          if (ast.type === "Decorator" && expression.type === "CallExpression" && expression.callee.name === "Component" && expression.arguments.length === 1) {
            const astProps = ast.expression.arguments[0].properties;
            for (const [index, prop] of newObj.expression.arguments[0].properties.entries()) {
              switch (astProps[index].key.name) {
                case "styles":
                  if (prop.value.type === "ArrayExpression") {
                    removeTemplateElementsValue(prop.value.elements[0]);
                  }
                  break;
                case "template":
                  if (prop.value.type === "TemplateLiteral") {
                    removeTemplateElementsValue(prop.value);
                  }
                  break;
              }
            }
          }
          if (ast.type === "TaggedTemplateExpression" && (ast.tag.type === "MemberExpression" || ast.tag.type === "Identifier" && (ast.tag.name === "gql" || ast.tag.name === "graphql" || ast.tag.name === "css" || ast.tag.name === "md" || ast.tag.name === "markdown" || ast.tag.name === "html") || ast.tag.type === "CallExpression")) {
            removeTemplateElementsValue(newObj.quasi);
          }
          if (ast.type === "TemplateLiteral") {
            var _ast$leadingComments;
            const hasLanguageComment = (_ast$leadingComments = ast.leadingComments) === null || _ast$leadingComments === void 0 ? void 0 : _ast$leadingComments.some((comment) => isBlockComment(comment) && ["GraphQL", "HTML"].some((languageName) => comment.value === ` ${languageName} `));
            if (hasLanguageComment || parent.type === "CallExpression" && parent.callee.name === "graphql" || !ast.leadingComments) {
              removeTemplateElementsValue(newObj);
            }
          }
          if (ast.type === "InterpreterDirective") {
            newObj.value = newObj.value.trimEnd();
          }
          if ((ast.type === "TSIntersectionType" || ast.type === "TSUnionType") && ast.types.length === 1) {
            return newObj.types[0];
          }
        }
        clean.ignoredProperties = ignoredProperties;
        module22.exports = clean;
      }
    });
    var require_detect_newline = __commonJS22({
      "node_modules/detect-newline/index.js"(exports22, module22) {
        "use strict";
        var detectNewline = (string3) => {
          if (typeof string3 !== "string") {
            throw new TypeError("Expected a string");
          }
          const newlines = string3.match(/(?:\r?\n)/g) || [];
          if (newlines.length === 0) {
            return;
          }
          const crlf = newlines.filter((newline) => newline === "\r\n").length;
          const lf = newlines.length - crlf;
          return crlf > lf ? "\r\n" : "\n";
        };
        module22.exports = detectNewline;
        module22.exports.graceful = (string3) => typeof string3 === "string" && detectNewline(string3) || "\n";
      }
    });
    var require_build = __commonJS22({
      "node_modules/jest-docblock/build/index.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.extract = extract;
        exports22.parse = parse2;
        exports22.parseWithComments = parseWithComments;
        exports22.print = print;
        exports22.strip = strip;
        function _os() {
          const data = require("os");
          _os = function() {
            return data;
          };
          return data;
        }
        function _detectNewline() {
          const data = _interopRequireDefault(require_detect_newline());
          _detectNewline = function() {
            return data;
          };
          return data;
        }
        function _interopRequireDefault(obj) {
          return obj && obj.__esModule ? obj : {
            default: obj
          };
        }
        var commentEndRe = /\*\/$/;
        var commentStartRe = /^\/\*\*/;
        var docblockRe = /^\s*(\/\*\*?(.|\r?\n)*?\*\/)/;
        var lineCommentRe = /(^|\s+)\/\/([^\r\n]*)/g;
        var ltrimNewlineRe = /^(\r?\n)+/;
        var multilineRe = /(?:^|\r?\n) *(@[^\r\n]*?) *\r?\n *(?![^@\r\n]*\/\/[^]*)([^@\r\n\s][^@\r\n]+?) *\r?\n/g;
        var propertyRe = /(?:^|\r?\n) *@(\S+) *([^\r\n]*)/g;
        var stringStartRe = /(\r?\n|^) *\* ?/g;
        var STRING_ARRAY = [];
        function extract(contents) {
          const match = contents.match(docblockRe);
          return match ? match[0].trimLeft() : "";
        }
        function strip(contents) {
          const match = contents.match(docblockRe);
          return match && match[0] ? contents.substring(match[0].length) : contents;
        }
        function parse2(docblock) {
          return parseWithComments(docblock).pragmas;
        }
        function parseWithComments(docblock) {
          const line = (0, _detectNewline().default)(docblock) || _os().EOL;
          docblock = docblock.replace(commentStartRe, "").replace(commentEndRe, "").replace(stringStartRe, "$1");
          let prev = "";
          while (prev !== docblock) {
            prev = docblock;
            docblock = docblock.replace(multilineRe, `${line}$1 $2${line}`);
          }
          docblock = docblock.replace(ltrimNewlineRe, "").trimRight();
          const result = /* @__PURE__ */ Object.create(null);
          const comments = docblock.replace(propertyRe, "").replace(ltrimNewlineRe, "").trimRight();
          let match;
          while (match = propertyRe.exec(docblock)) {
            const nextPragma = match[2].replace(lineCommentRe, "");
            if (typeof result[match[1]] === "string" || Array.isArray(result[match[1]])) {
              result[match[1]] = STRING_ARRAY.concat(result[match[1]], nextPragma);
            } else {
              result[match[1]] = nextPragma;
            }
          }
          return {
            comments,
            pragmas: result
          };
        }
        function print({
          comments = "",
          pragmas = {}
        }) {
          const line = (0, _detectNewline().default)(comments) || _os().EOL;
          const head = "/**";
          const start = " *";
          const tail = " */";
          const keys5 = Object.keys(pragmas);
          const printedObject = keys5.map((key) => printKeyValues(key, pragmas[key])).reduce((arr, next) => arr.concat(next), []).map((keyValue) => start + " " + keyValue + line).join("");
          if (!comments) {
            if (keys5.length === 0) {
              return "";
            }
            if (keys5.length === 1 && !Array.isArray(pragmas[keys5[0]])) {
              const value = pragmas[keys5[0]];
              return `${head} ${printKeyValues(keys5[0], value)[0]}${tail}`;
            }
          }
          const printedComments = comments.split(line).map((textLine) => `${start} ${textLine}`).join(line) + line;
          return head + line + (comments ? printedComments : "") + (comments && keys5.length ? start + line : "") + printedObject + tail;
        }
        function printKeyValues(key, valueOrArray) {
          return STRING_ARRAY.concat(valueOrArray).map((value) => `@${key} ${value}`.trim());
        }
      }
    });
    var require_get_shebang = __commonJS22({
      "src/language-js/utils/get-shebang.js"(exports22, module22) {
        "use strict";
        function getShebang(text) {
          if (!text.startsWith("#!")) {
            return "";
          }
          const index = text.indexOf("\n");
          if (index === -1) {
            return text;
          }
          return text.slice(0, index);
        }
        module22.exports = getShebang;
      }
    });
    var require_pragma = __commonJS22({
      "src/language-js/pragma.js"(exports22, module22) {
        "use strict";
        var {
          parseWithComments,
          strip,
          extract,
          print
        } = require_build();
        var {
          normalizeEndOfLine
        } = require_end_of_line();
        var getShebang = require_get_shebang();
        function parseDocBlock(text) {
          const shebang = getShebang(text);
          if (shebang) {
            text = text.slice(shebang.length + 1);
          }
          const docBlock = extract(text);
          const {
            pragmas,
            comments
          } = parseWithComments(docBlock);
          return {
            shebang,
            text,
            pragmas,
            comments
          };
        }
        function hasPragma(text) {
          const pragmas = Object.keys(parseDocBlock(text).pragmas);
          return pragmas.includes("prettier") || pragmas.includes("format");
        }
        function insertPragma(originalText) {
          const {
            shebang,
            text,
            pragmas,
            comments
          } = parseDocBlock(originalText);
          const strippedText = strip(text);
          const docBlock = print({
            pragmas: Object.assign({
              format: ""
            }, pragmas),
            comments: comments.trimStart()
          });
          return (shebang ? `${shebang}
` : "") + normalizeEndOfLine(docBlock) + (strippedText.startsWith("\n") ? "\n" : "\n\n") + strippedText;
        }
        module22.exports = {
          hasPragma,
          insertPragma
        };
      }
    });
    var require_comments2 = __commonJS22({
      "src/language-js/comments.js"(exports22, module22) {
        "use strict";
        var {
          getLast,
          hasNewline,
          getNextNonSpaceNonCommentCharacterIndexWithStartIndex,
          getNextNonSpaceNonCommentCharacter,
          hasNewlineInRange,
          addLeadingComment,
          addTrailingComment,
          addDanglingComment,
          getNextNonSpaceNonCommentCharacterIndex,
          isNonEmptyArray
        } = require_util2();
        var {
          getFunctionParameters,
          isPrettierIgnoreComment,
          isJsxNode,
          hasFlowShorthandAnnotationComment,
          hasFlowAnnotationComment,
          hasIgnoreComment,
          isCallLikeExpression,
          getCallArguments,
          isCallExpression,
          isMemberExpression,
          isObjectProperty,
          isLineComment,
          getComments,
          CommentCheckFlags,
          markerForIfWithoutBlockAndSameLineComment
        } = require_utils72();
        var {
          locStart,
          locEnd
        } = require_loc();
        var isBlockComment = require_is_block_comment();
        function handleOwnLineComment(context) {
          return [handleIgnoreComments, handleLastFunctionArgComments, handleMemberExpressionComments, handleIfStatementComments, handleWhileComments, handleTryStatementComments, handleClassComments, handleForComments, handleUnionTypeComments, handleOnlyComments, handleModuleSpecifiersComments, handleAssignmentPatternComments, handleMethodNameComments, handleLabeledStatementComments, handleBreakAndContinueStatementComments].some((fn) => fn(context));
        }
        function handleEndOfLineComment(context) {
          return [handleClosureTypeCastComments, handleLastFunctionArgComments, handleConditionalExpressionComments, handleModuleSpecifiersComments, handleIfStatementComments, handleWhileComments, handleTryStatementComments, handleClassComments, handleLabeledStatementComments, handleCallExpressionComments, handlePropertyComments, handleOnlyComments, handleVariableDeclaratorComments, handleBreakAndContinueStatementComments, handleSwitchDefaultCaseComments].some((fn) => fn(context));
        }
        function handleRemainingComment(context) {
          return [handleIgnoreComments, handleIfStatementComments, handleWhileComments, handleObjectPropertyAssignment, handleCommentInEmptyParens, handleMethodNameComments, handleOnlyComments, handleCommentAfterArrowParams, handleFunctionNameComments, handleTSMappedTypeComments, handleBreakAndContinueStatementComments, handleTSFunctionTrailingComments].some((fn) => fn(context));
        }
        function addBlockStatementFirstComment(node, comment) {
          const firstNonEmptyNode = (node.body || node.properties).find(({
            type: type2
          }) => type2 !== "EmptyStatement");
          if (firstNonEmptyNode) {
            addLeadingComment(firstNonEmptyNode, comment);
          } else {
            addDanglingComment(node, comment);
          }
        }
        function addBlockOrNotComment(node, comment) {
          if (node.type === "BlockStatement") {
            addBlockStatementFirstComment(node, comment);
          } else {
            addLeadingComment(node, comment);
          }
        }
        function handleClosureTypeCastComments({
          comment,
          followingNode
        }) {
          if (followingNode && isTypeCastComment(comment)) {
            addLeadingComment(followingNode, comment);
            return true;
          }
          return false;
        }
        function handleIfStatementComments({
          comment,
          precedingNode,
          enclosingNode,
          followingNode,
          text
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) !== "IfStatement" || !followingNode) {
            return false;
          }
          const nextCharacter = getNextNonSpaceNonCommentCharacter(text, comment, locEnd);
          if (nextCharacter === ")") {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          if (precedingNode === enclosingNode.consequent && followingNode === enclosingNode.alternate) {
            if (precedingNode.type === "BlockStatement") {
              addTrailingComment(precedingNode, comment);
            } else {
              const isSingleLineComment = comment.type === "SingleLine" || comment.loc.start.line === comment.loc.end.line;
              const isSameLineComment = comment.loc.start.line === precedingNode.loc.start.line;
              if (isSingleLineComment && isSameLineComment) {
                addDanglingComment(precedingNode, comment, markerForIfWithoutBlockAndSameLineComment);
              } else {
                addDanglingComment(enclosingNode, comment);
              }
            }
            return true;
          }
          if (followingNode.type === "BlockStatement") {
            addBlockStatementFirstComment(followingNode, comment);
            return true;
          }
          if (followingNode.type === "IfStatement") {
            addBlockOrNotComment(followingNode.consequent, comment);
            return true;
          }
          if (enclosingNode.consequent === followingNode) {
            addLeadingComment(followingNode, comment);
            return true;
          }
          return false;
        }
        function handleWhileComments({
          comment,
          precedingNode,
          enclosingNode,
          followingNode,
          text
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) !== "WhileStatement" || !followingNode) {
            return false;
          }
          const nextCharacter = getNextNonSpaceNonCommentCharacter(text, comment, locEnd);
          if (nextCharacter === ")") {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          if (followingNode.type === "BlockStatement") {
            addBlockStatementFirstComment(followingNode, comment);
            return true;
          }
          if (enclosingNode.body === followingNode) {
            addLeadingComment(followingNode, comment);
            return true;
          }
          return false;
        }
        function handleTryStatementComments({
          comment,
          precedingNode,
          enclosingNode,
          followingNode
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) !== "TryStatement" && (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) !== "CatchClause" || !followingNode) {
            return false;
          }
          if (enclosingNode.type === "CatchClause" && precedingNode) {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          if (followingNode.type === "BlockStatement") {
            addBlockStatementFirstComment(followingNode, comment);
            return true;
          }
          if (followingNode.type === "TryStatement") {
            addBlockOrNotComment(followingNode.finalizer, comment);
            return true;
          }
          if (followingNode.type === "CatchClause") {
            addBlockOrNotComment(followingNode.body, comment);
            return true;
          }
          return false;
        }
        function handleMemberExpressionComments({
          comment,
          enclosingNode,
          followingNode
        }) {
          if (isMemberExpression(enclosingNode) && (followingNode === null || followingNode === void 0 ? void 0 : followingNode.type) === "Identifier") {
            addLeadingComment(enclosingNode, comment);
            return true;
          }
          return false;
        }
        function handleConditionalExpressionComments({
          comment,
          precedingNode,
          enclosingNode,
          followingNode,
          text
        }) {
          const isSameLineAsPrecedingNode = precedingNode && !hasNewlineInRange(text, locEnd(precedingNode), locStart(comment));
          if ((!precedingNode || !isSameLineAsPrecedingNode) && ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ConditionalExpression" || (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "TSConditionalType") && followingNode) {
            addLeadingComment(followingNode, comment);
            return true;
          }
          return false;
        }
        function handleObjectPropertyAssignment({
          comment,
          precedingNode,
          enclosingNode
        }) {
          if (isObjectProperty(enclosingNode) && enclosingNode.shorthand && enclosingNode.key === precedingNode && enclosingNode.value.type === "AssignmentPattern") {
            addTrailingComment(enclosingNode.value.left, comment);
            return true;
          }
          return false;
        }
        var classLikeNodeTypes = /* @__PURE__ */ new Set(["ClassDeclaration", "ClassExpression", "DeclareClass", "DeclareInterface", "InterfaceDeclaration", "TSInterfaceDeclaration"]);
        function handleClassComments({
          comment,
          precedingNode,
          enclosingNode,
          followingNode
        }) {
          if (classLikeNodeTypes.has(enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type)) {
            if (isNonEmptyArray(enclosingNode.decorators) && !(followingNode && followingNode.type === "Decorator")) {
              addTrailingComment(getLast(enclosingNode.decorators), comment);
              return true;
            }
            if (enclosingNode.body && followingNode === enclosingNode.body) {
              addBlockStatementFirstComment(enclosingNode.body, comment);
              return true;
            }
            if (followingNode) {
              if (enclosingNode.superClass && followingNode === enclosingNode.superClass && precedingNode && (precedingNode === enclosingNode.id || precedingNode === enclosingNode.typeParameters)) {
                addTrailingComment(precedingNode, comment);
                return true;
              }
              for (const prop of ["implements", "extends", "mixins"]) {
                if (enclosingNode[prop] && followingNode === enclosingNode[prop][0]) {
                  if (precedingNode && (precedingNode === enclosingNode.id || precedingNode === enclosingNode.typeParameters || precedingNode === enclosingNode.superClass)) {
                    addTrailingComment(precedingNode, comment);
                  } else {
                    addDanglingComment(enclosingNode, comment, prop);
                  }
                  return true;
                }
              }
            }
          }
          return false;
        }
        var propertyLikeNodeTypes = /* @__PURE__ */ new Set(["ClassMethod", "ClassProperty", "PropertyDefinition", "TSAbstractPropertyDefinition", "TSAbstractMethodDefinition", "TSDeclareMethod", "MethodDefinition"]);
        function handleMethodNameComments({
          comment,
          precedingNode,
          enclosingNode,
          text
        }) {
          if (enclosingNode && precedingNode && getNextNonSpaceNonCommentCharacter(text, comment, locEnd) === "(" && (enclosingNode.type === "Property" || enclosingNode.type === "TSDeclareMethod" || enclosingNode.type === "TSAbstractMethodDefinition") && precedingNode.type === "Identifier" && enclosingNode.key === precedingNode && getNextNonSpaceNonCommentCharacter(text, precedingNode, locEnd) !== ":") {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          if ((precedingNode === null || precedingNode === void 0 ? void 0 : precedingNode.type) === "Decorator" && propertyLikeNodeTypes.has(enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type)) {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          return false;
        }
        var functionLikeNodeTypes = /* @__PURE__ */ new Set(["FunctionDeclaration", "FunctionExpression", "ClassMethod", "MethodDefinition", "ObjectMethod"]);
        function handleFunctionNameComments({
          comment,
          precedingNode,
          enclosingNode,
          text
        }) {
          if (getNextNonSpaceNonCommentCharacter(text, comment, locEnd) !== "(") {
            return false;
          }
          if (precedingNode && functionLikeNodeTypes.has(enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type)) {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          return false;
        }
        function handleCommentAfterArrowParams({
          comment,
          enclosingNode,
          text
        }) {
          if (!((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ArrowFunctionExpression")) {
            return false;
          }
          const index = getNextNonSpaceNonCommentCharacterIndex(text, comment, locEnd);
          if (index !== false && text.slice(index, index + 2) === "=>") {
            addDanglingComment(enclosingNode, comment);
            return true;
          }
          return false;
        }
        function handleCommentInEmptyParens({
          comment,
          enclosingNode,
          text
        }) {
          if (getNextNonSpaceNonCommentCharacter(text, comment, locEnd) !== ")") {
            return false;
          }
          if (enclosingNode && (isRealFunctionLikeNode(enclosingNode) && getFunctionParameters(enclosingNode).length === 0 || isCallLikeExpression(enclosingNode) && getCallArguments(enclosingNode).length === 0)) {
            addDanglingComment(enclosingNode, comment);
            return true;
          }
          if (((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "MethodDefinition" || (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "TSAbstractMethodDefinition") && getFunctionParameters(enclosingNode.value).length === 0) {
            addDanglingComment(enclosingNode.value, comment);
            return true;
          }
          return false;
        }
        function handleLastFunctionArgComments({
          comment,
          precedingNode,
          enclosingNode,
          followingNode,
          text
        }) {
          if ((precedingNode === null || precedingNode === void 0 ? void 0 : precedingNode.type) === "FunctionTypeParam" && (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "FunctionTypeAnnotation" && (followingNode === null || followingNode === void 0 ? void 0 : followingNode.type) !== "FunctionTypeParam") {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          if (((precedingNode === null || precedingNode === void 0 ? void 0 : precedingNode.type) === "Identifier" || (precedingNode === null || precedingNode === void 0 ? void 0 : precedingNode.type) === "AssignmentPattern") && enclosingNode && isRealFunctionLikeNode(enclosingNode) && getNextNonSpaceNonCommentCharacter(text, comment, locEnd) === ")") {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "FunctionDeclaration" && (followingNode === null || followingNode === void 0 ? void 0 : followingNode.type) === "BlockStatement") {
            const functionParamRightParenIndex = (() => {
              const parameters = getFunctionParameters(enclosingNode);
              if (parameters.length > 0) {
                return getNextNonSpaceNonCommentCharacterIndexWithStartIndex(text, locEnd(getLast(parameters)));
              }
              const functionParamLeftParenIndex = getNextNonSpaceNonCommentCharacterIndexWithStartIndex(text, locEnd(enclosingNode.id));
              return functionParamLeftParenIndex !== false && getNextNonSpaceNonCommentCharacterIndexWithStartIndex(text, functionParamLeftParenIndex + 1);
            })();
            if (locStart(comment) > functionParamRightParenIndex) {
              addBlockStatementFirstComment(followingNode, comment);
              return true;
            }
          }
          return false;
        }
        function handleLabeledStatementComments({
          comment,
          enclosingNode
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "LabeledStatement") {
            addLeadingComment(enclosingNode, comment);
            return true;
          }
          return false;
        }
        function handleBreakAndContinueStatementComments({
          comment,
          enclosingNode
        }) {
          if (((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ContinueStatement" || (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "BreakStatement") && !enclosingNode.label) {
            addTrailingComment(enclosingNode, comment);
            return true;
          }
          return false;
        }
        function handleCallExpressionComments({
          comment,
          precedingNode,
          enclosingNode
        }) {
          if (isCallExpression(enclosingNode) && precedingNode && enclosingNode.callee === precedingNode && enclosingNode.arguments.length > 0) {
            addLeadingComment(enclosingNode.arguments[0], comment);
            return true;
          }
          return false;
        }
        function handleUnionTypeComments({
          comment,
          precedingNode,
          enclosingNode,
          followingNode
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "UnionTypeAnnotation" || (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "TSUnionType") {
            if (isPrettierIgnoreComment(comment)) {
              followingNode.prettierIgnore = true;
              comment.unignore = true;
            }
            if (precedingNode) {
              addTrailingComment(precedingNode, comment);
              return true;
            }
            return false;
          }
          if (((followingNode === null || followingNode === void 0 ? void 0 : followingNode.type) === "UnionTypeAnnotation" || (followingNode === null || followingNode === void 0 ? void 0 : followingNode.type) === "TSUnionType") && isPrettierIgnoreComment(comment)) {
            followingNode.types[0].prettierIgnore = true;
            comment.unignore = true;
          }
          return false;
        }
        function handlePropertyComments({
          comment,
          enclosingNode
        }) {
          if (isObjectProperty(enclosingNode)) {
            addLeadingComment(enclosingNode, comment);
            return true;
          }
          return false;
        }
        function handleOnlyComments({
          comment,
          enclosingNode,
          followingNode,
          ast,
          isLastComment
        }) {
          if (ast && ast.body && ast.body.length === 0) {
            if (isLastComment) {
              addDanglingComment(ast, comment);
            } else {
              addLeadingComment(ast, comment);
            }
            return true;
          }
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "Program" && (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.body.length) === 0 && !isNonEmptyArray(enclosingNode.directives)) {
            if (isLastComment) {
              addDanglingComment(enclosingNode, comment);
            } else {
              addLeadingComment(enclosingNode, comment);
            }
            return true;
          }
          if ((followingNode === null || followingNode === void 0 ? void 0 : followingNode.type) === "Program" && (followingNode === null || followingNode === void 0 ? void 0 : followingNode.body.length) === 0 && (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ModuleExpression") {
            addDanglingComment(followingNode, comment);
            return true;
          }
          return false;
        }
        function handleForComments({
          comment,
          enclosingNode
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ForInStatement" || (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ForOfStatement") {
            addLeadingComment(enclosingNode, comment);
            return true;
          }
          return false;
        }
        function handleModuleSpecifiersComments({
          comment,
          precedingNode,
          enclosingNode,
          text
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ImportSpecifier" || (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ExportSpecifier") {
            addLeadingComment(enclosingNode, comment);
            return true;
          }
          const isImportDeclaration = (precedingNode === null || precedingNode === void 0 ? void 0 : precedingNode.type) === "ImportSpecifier" && (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ImportDeclaration";
          const isExportDeclaration = (precedingNode === null || precedingNode === void 0 ? void 0 : precedingNode.type) === "ExportSpecifier" && (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ExportNamedDeclaration";
          if ((isImportDeclaration || isExportDeclaration) && hasNewline(text, locEnd(comment))) {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          return false;
        }
        function handleAssignmentPatternComments({
          comment,
          enclosingNode
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "AssignmentPattern") {
            addLeadingComment(enclosingNode, comment);
            return true;
          }
          return false;
        }
        var assignmentLikeNodeTypes = /* @__PURE__ */ new Set(["VariableDeclarator", "AssignmentExpression", "TypeAlias", "TSTypeAliasDeclaration"]);
        var complexExprNodeTypes = /* @__PURE__ */ new Set(["ObjectExpression", "ArrayExpression", "TemplateLiteral", "TaggedTemplateExpression", "ObjectTypeAnnotation", "TSTypeLiteral"]);
        function handleVariableDeclaratorComments({
          comment,
          enclosingNode,
          followingNode
        }) {
          if (assignmentLikeNodeTypes.has(enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) && followingNode && (complexExprNodeTypes.has(followingNode.type) || isBlockComment(comment))) {
            addLeadingComment(followingNode, comment);
            return true;
          }
          return false;
        }
        function handleTSFunctionTrailingComments({
          comment,
          enclosingNode,
          followingNode,
          text
        }) {
          if (!followingNode && ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "TSMethodSignature" || (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "TSDeclareFunction" || (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "TSAbstractMethodDefinition") && getNextNonSpaceNonCommentCharacter(text, comment, locEnd) === ";") {
            addTrailingComment(enclosingNode, comment);
            return true;
          }
          return false;
        }
        function handleIgnoreComments({
          comment,
          enclosingNode,
          followingNode
        }) {
          if (isPrettierIgnoreComment(comment) && (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "TSMappedType" && (followingNode === null || followingNode === void 0 ? void 0 : followingNode.type) === "TSTypeParameter" && followingNode.constraint) {
            enclosingNode.prettierIgnore = true;
            comment.unignore = true;
            return true;
          }
        }
        function handleTSMappedTypeComments({
          comment,
          precedingNode,
          enclosingNode,
          followingNode
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) !== "TSMappedType") {
            return false;
          }
          if ((followingNode === null || followingNode === void 0 ? void 0 : followingNode.type) === "TSTypeParameter" && followingNode.name) {
            addLeadingComment(followingNode.name, comment);
            return true;
          }
          if ((precedingNode === null || precedingNode === void 0 ? void 0 : precedingNode.type) === "TSTypeParameter" && precedingNode.constraint) {
            addTrailingComment(precedingNode.constraint, comment);
            return true;
          }
          return false;
        }
        function handleSwitchDefaultCaseComments({
          comment,
          enclosingNode,
          followingNode
        }) {
          if (!enclosingNode || enclosingNode.type !== "SwitchCase" || enclosingNode.test) {
            return false;
          }
          if (followingNode.type === "BlockStatement" && isLineComment(comment)) {
            addBlockStatementFirstComment(followingNode, comment);
          } else {
            addDanglingComment(enclosingNode, comment);
          }
          return true;
        }
        function isRealFunctionLikeNode(node) {
          return node.type === "ArrowFunctionExpression" || node.type === "FunctionExpression" || node.type === "FunctionDeclaration" || node.type === "ObjectMethod" || node.type === "ClassMethod" || node.type === "TSDeclareFunction" || node.type === "TSCallSignatureDeclaration" || node.type === "TSConstructSignatureDeclaration" || node.type === "TSMethodSignature" || node.type === "TSConstructorType" || node.type === "TSFunctionType" || node.type === "TSDeclareMethod";
        }
        function getCommentChildNodes(node, options) {
          if ((options.parser === "typescript" || options.parser === "flow" || options.parser === "acorn" || options.parser === "espree" || options.parser === "meriyah" || options.parser === "__babel_estree") && node.type === "MethodDefinition" && node.value && node.value.type === "FunctionExpression" && getFunctionParameters(node.value).length === 0 && !node.value.returnType && !isNonEmptyArray(node.value.typeParameters) && node.value.body) {
            return [...node.decorators || [], node.key, node.value.body];
          }
        }
        function isTypeCastComment(comment) {
          return isBlockComment(comment) && comment.value[0] === "*" && /@type\b/.test(comment.value);
        }
        function willPrintOwnComments(path5) {
          const node = path5.getValue();
          const parent = path5.getParentNode();
          const hasFlowAnnotations = (node2) => hasFlowAnnotationComment(getComments(node2, CommentCheckFlags.Leading)) || hasFlowAnnotationComment(getComments(node2, CommentCheckFlags.Trailing));
          return (node && (isJsxNode(node) || hasFlowShorthandAnnotationComment(node) || isCallExpression(parent) && hasFlowAnnotations(node)) || parent && (parent.type === "JSXSpreadAttribute" || parent.type === "JSXSpreadChild" || parent.type === "UnionTypeAnnotation" || parent.type === "TSUnionType" || (parent.type === "ClassDeclaration" || parent.type === "ClassExpression") && parent.superClass === node)) && (!hasIgnoreComment(path5) || parent.type === "UnionTypeAnnotation" || parent.type === "TSUnionType");
        }
        module22.exports = {
          handleOwnLineComment,
          handleEndOfLineComment,
          handleRemainingComment,
          isTypeCastComment,
          getCommentChildNodes,
          willPrintOwnComments
        };
      }
    });
    var require_needs_parens = __commonJS22({
      "src/language-js/needs-parens.js"(exports22, module22) {
        "use strict";
        var getLast = require_get_last();
        var isNonEmptyArray = require_is_non_empty_array();
        var {
          getFunctionParameters,
          getLeftSidePathName,
          hasFlowShorthandAnnotationComment,
          hasNakedLeftSide,
          hasNode,
          isBitwiseOperator,
          startsWithNoLookaheadToken,
          shouldFlatten,
          getPrecedence,
          isCallExpression,
          isMemberExpression,
          isObjectProperty
        } = require_utils72();
        function needsParens(path5, options) {
          const parent = path5.getParentNode();
          if (!parent) {
            return false;
          }
          const name = path5.getName();
          const node = path5.getNode();
          if (options.__isInHtmlInterpolation && !options.bracketSpacing && endsWithRightBracket(node) && isFollowedByRightBracket(path5)) {
            return true;
          }
          if (isStatement(node)) {
            return false;
          }
          if (options.parser !== "flow" && hasFlowShorthandAnnotationComment(path5.getValue())) {
            return true;
          }
          if (node.type === "Identifier") {
            if (node.extra && node.extra.parenthesized && /^PRETTIER_HTML_PLACEHOLDER_\d+_\d+_IN_JS$/.test(node.name)) {
              return true;
            }
            if (name === "left" && node.name === "async" && parent.type === "ForOfStatement" && !parent.await) {
              return true;
            }
            return false;
          }
          switch (parent.type) {
            case "ParenthesizedExpression":
              return false;
            case "ClassDeclaration":
            case "ClassExpression": {
              if (name === "superClass" && (node.type === "ArrowFunctionExpression" || node.type === "AssignmentExpression" || node.type === "AwaitExpression" || node.type === "BinaryExpression" || node.type === "ConditionalExpression" || node.type === "LogicalExpression" || node.type === "NewExpression" || node.type === "ObjectExpression" || node.type === "SequenceExpression" || node.type === "TaggedTemplateExpression" || node.type === "UnaryExpression" || node.type === "UpdateExpression" || node.type === "YieldExpression" || node.type === "TSNonNullExpression")) {
                return true;
              }
              break;
            }
            case "ExportDefaultDeclaration": {
              return shouldWrapFunctionForExportDefault(path5, options) || node.type === "SequenceExpression";
            }
            case "Decorator": {
              if (name === "expression") {
                let hasCallExpression = false;
                let hasMemberExpression = false;
                let current = node;
                while (current) {
                  switch (current.type) {
                    case "MemberExpression":
                      hasMemberExpression = true;
                      current = current.object;
                      break;
                    case "CallExpression":
                      if (hasMemberExpression || hasCallExpression) {
                        return options.parser !== "typescript";
                      }
                      hasCallExpression = true;
                      current = current.callee;
                      break;
                    case "Identifier":
                      return false;
                    case "TaggedTemplateExpression":
                      return options.parser !== "typescript";
                    default:
                      return true;
                  }
                }
                return true;
              }
              break;
            }
            case "ExpressionStatement": {
              if (startsWithNoLookaheadToken(node, true)) {
                return true;
              }
              break;
            }
            case "ArrowFunctionExpression": {
              if (name === "body" && node.type !== "SequenceExpression" && startsWithNoLookaheadToken(node, false)) {
                return true;
              }
              break;
            }
          }
          switch (node.type) {
            case "UpdateExpression":
              if (parent.type === "UnaryExpression") {
                return node.prefix && (node.operator === "++" && parent.operator === "+" || node.operator === "--" && parent.operator === "-");
              }
            case "UnaryExpression":
              switch (parent.type) {
                case "UnaryExpression":
                  return node.operator === parent.operator && (node.operator === "+" || node.operator === "-");
                case "BindExpression":
                  return true;
                case "MemberExpression":
                case "OptionalMemberExpression":
                  return name === "object";
                case "TaggedTemplateExpression":
                  return true;
                case "NewExpression":
                case "CallExpression":
                case "OptionalCallExpression":
                  return name === "callee";
                case "BinaryExpression":
                  return name === "left" && parent.operator === "**";
                case "TSNonNullExpression":
                  return true;
                default:
                  return false;
              }
            case "BinaryExpression": {
              if (parent.type === "UpdateExpression") {
                return true;
              }
              if (node.operator === "in" && isPathInForStatementInitializer(path5)) {
                return true;
              }
              if (node.operator === "|>" && node.extra && node.extra.parenthesized) {
                const grandParent = path5.getParentNode(1);
                if (grandParent.type === "BinaryExpression" && grandParent.operator === "|>") {
                  return true;
                }
              }
            }
            case "TSTypeAssertion":
            case "TSAsExpression":
            case "LogicalExpression":
              switch (parent.type) {
                case "TSAsExpression":
                  return node.type !== "TSAsExpression";
                case "ConditionalExpression":
                  return node.type === "TSAsExpression";
                case "CallExpression":
                case "NewExpression":
                case "OptionalCallExpression":
                  return name === "callee";
                case "ClassExpression":
                case "ClassDeclaration":
                  return name === "superClass";
                case "TSTypeAssertion":
                case "TaggedTemplateExpression":
                case "UnaryExpression":
                case "JSXSpreadAttribute":
                case "SpreadElement":
                case "SpreadProperty":
                case "BindExpression":
                case "AwaitExpression":
                case "TSNonNullExpression":
                case "UpdateExpression":
                  return true;
                case "MemberExpression":
                case "OptionalMemberExpression":
                  return name === "object";
                case "AssignmentExpression":
                case "AssignmentPattern":
                  return name === "left" && (node.type === "TSTypeAssertion" || node.type === "TSAsExpression");
                case "LogicalExpression":
                  if (node.type === "LogicalExpression") {
                    return parent.operator !== node.operator;
                  }
                case "BinaryExpression": {
                  const {
                    operator,
                    type: type2
                  } = node;
                  if (!operator && type2 !== "TSTypeAssertion") {
                    return true;
                  }
                  const precedence = getPrecedence(operator);
                  const parentOperator = parent.operator;
                  const parentPrecedence = getPrecedence(parentOperator);
                  if (parentPrecedence > precedence) {
                    return true;
                  }
                  if (name === "right" && parentPrecedence === precedence) {
                    return true;
                  }
                  if (parentPrecedence === precedence && !shouldFlatten(parentOperator, operator)) {
                    return true;
                  }
                  if (parentPrecedence < precedence && operator === "%") {
                    return parentOperator === "+" || parentOperator === "-";
                  }
                  if (isBitwiseOperator(parentOperator)) {
                    return true;
                  }
                  return false;
                }
                default:
                  return false;
              }
            case "SequenceExpression":
              switch (parent.type) {
                case "ReturnStatement":
                  return false;
                case "ForStatement":
                  return false;
                case "ExpressionStatement":
                  return name !== "expression";
                case "ArrowFunctionExpression":
                  return name !== "body";
                default:
                  return true;
              }
            case "YieldExpression":
              if (parent.type === "UnaryExpression" || parent.type === "AwaitExpression" || parent.type === "TSAsExpression" || parent.type === "TSNonNullExpression") {
                return true;
              }
            case "AwaitExpression":
              switch (parent.type) {
                case "TaggedTemplateExpression":
                case "UnaryExpression":
                case "LogicalExpression":
                case "SpreadElement":
                case "SpreadProperty":
                case "TSAsExpression":
                case "TSNonNullExpression":
                case "BindExpression":
                  return true;
                case "MemberExpression":
                case "OptionalMemberExpression":
                  return name === "object";
                case "NewExpression":
                case "CallExpression":
                case "OptionalCallExpression":
                  return name === "callee";
                case "ConditionalExpression":
                  return name === "test";
                case "BinaryExpression": {
                  if (!node.argument && parent.operator === "|>") {
                    return false;
                  }
                  return true;
                }
                default:
                  return false;
              }
            case "TSConditionalType":
              if (name === "extendsType" && parent.type === "TSConditionalType") {
                return true;
              }
            case "TSFunctionType":
            case "TSConstructorType":
              if (name === "checkType" && parent.type === "TSConditionalType") {
                return true;
              }
            case "TSUnionType":
            case "TSIntersectionType":
              if ((parent.type === "TSUnionType" || parent.type === "TSIntersectionType") && parent.types.length > 1 && (!node.types || node.types.length > 1)) {
                return true;
              }
            case "TSInferType":
              if (node.type === "TSInferType" && parent.type === "TSRestType") {
                return false;
              }
            case "TSTypeOperator":
              return parent.type === "TSArrayType" || parent.type === "TSOptionalType" || parent.type === "TSRestType" || name === "objectType" && parent.type === "TSIndexedAccessType" || parent.type === "TSTypeOperator" || parent.type === "TSTypeAnnotation" && path5.getParentNode(1).type.startsWith("TSJSDoc");
            case "ArrayTypeAnnotation":
              return parent.type === "NullableTypeAnnotation";
            case "IntersectionTypeAnnotation":
            case "UnionTypeAnnotation":
              return parent.type === "ArrayTypeAnnotation" || parent.type === "NullableTypeAnnotation" || parent.type === "IntersectionTypeAnnotation" || parent.type === "UnionTypeAnnotation" || name === "objectType" && (parent.type === "IndexedAccessType" || parent.type === "OptionalIndexedAccessType");
            case "NullableTypeAnnotation":
              return parent.type === "ArrayTypeAnnotation" || name === "objectType" && (parent.type === "IndexedAccessType" || parent.type === "OptionalIndexedAccessType");
            case "FunctionTypeAnnotation": {
              const ancestor = parent.type === "NullableTypeAnnotation" ? path5.getParentNode(1) : parent;
              return ancestor.type === "UnionTypeAnnotation" || ancestor.type === "IntersectionTypeAnnotation" || ancestor.type === "ArrayTypeAnnotation" || name === "objectType" && (ancestor.type === "IndexedAccessType" || ancestor.type === "OptionalIndexedAccessType") || ancestor.type === "NullableTypeAnnotation" || parent.type === "FunctionTypeParam" && parent.name === null && getFunctionParameters(node).some((param) => param.typeAnnotation && param.typeAnnotation.type === "NullableTypeAnnotation");
            }
            case "OptionalIndexedAccessType":
              return name === "objectType" && parent.type === "IndexedAccessType";
            case "TypeofTypeAnnotation":
              return name === "objectType" && (parent.type === "IndexedAccessType" || parent.type === "OptionalIndexedAccessType");
            case "StringLiteral":
            case "NumericLiteral":
            case "Literal":
              if (typeof node.value === "string" && parent.type === "ExpressionStatement" && !parent.directive) {
                const grandParent = path5.getParentNode(1);
                return grandParent.type === "Program" || grandParent.type === "BlockStatement";
              }
              return name === "object" && parent.type === "MemberExpression" && typeof node.value === "number";
            case "AssignmentExpression": {
              const grandParent = path5.getParentNode(1);
              if (name === "body" && parent.type === "ArrowFunctionExpression") {
                return true;
              }
              if (name === "key" && (parent.type === "ClassProperty" || parent.type === "PropertyDefinition") && parent.computed) {
                return false;
              }
              if ((name === "init" || name === "update") && parent.type === "ForStatement") {
                return false;
              }
              if (parent.type === "ExpressionStatement") {
                return node.left.type === "ObjectPattern";
              }
              if (name === "key" && parent.type === "TSPropertySignature") {
                return false;
              }
              if (parent.type === "AssignmentExpression") {
                return false;
              }
              if (parent.type === "SequenceExpression" && grandParent && grandParent.type === "ForStatement" && (grandParent.init === parent || grandParent.update === parent)) {
                return false;
              }
              if (name === "value" && parent.type === "Property" && grandParent && grandParent.type === "ObjectPattern" && grandParent.properties.includes(parent)) {
                return false;
              }
              if (parent.type === "NGChainedExpression") {
                return false;
              }
              return true;
            }
            case "ConditionalExpression":
              switch (parent.type) {
                case "TaggedTemplateExpression":
                case "UnaryExpression":
                case "SpreadElement":
                case "SpreadProperty":
                case "BinaryExpression":
                case "LogicalExpression":
                case "NGPipeExpression":
                case "ExportDefaultDeclaration":
                case "AwaitExpression":
                case "JSXSpreadAttribute":
                case "TSTypeAssertion":
                case "TypeCastExpression":
                case "TSAsExpression":
                case "TSNonNullExpression":
                  return true;
                case "NewExpression":
                case "CallExpression":
                case "OptionalCallExpression":
                  return name === "callee";
                case "ConditionalExpression":
                  return name === "test";
                case "MemberExpression":
                case "OptionalMemberExpression":
                  return name === "object";
                default:
                  return false;
              }
            case "FunctionExpression":
              switch (parent.type) {
                case "NewExpression":
                case "CallExpression":
                case "OptionalCallExpression":
                  return name === "callee";
                case "TaggedTemplateExpression":
                  return true;
                default:
                  return false;
              }
            case "ArrowFunctionExpression":
              switch (parent.type) {
                case "BinaryExpression":
                  return parent.operator !== "|>" || node.extra && node.extra.parenthesized;
                case "NewExpression":
                case "CallExpression":
                case "OptionalCallExpression":
                  return name === "callee";
                case "MemberExpression":
                case "OptionalMemberExpression":
                  return name === "object";
                case "TSAsExpression":
                case "TSNonNullExpression":
                case "BindExpression":
                case "TaggedTemplateExpression":
                case "UnaryExpression":
                case "LogicalExpression":
                case "AwaitExpression":
                case "TSTypeAssertion":
                  return true;
                case "ConditionalExpression":
                  return name === "test";
                default:
                  return false;
              }
            case "ClassExpression":
              if (isNonEmptyArray(node.decorators)) {
                return true;
              }
              switch (parent.type) {
                case "NewExpression":
                  return name === "callee";
                default:
                  return false;
              }
            case "OptionalMemberExpression":
            case "OptionalCallExpression": {
              const parentParent = path5.getParentNode(1);
              if (name === "object" && parent.type === "MemberExpression" || name === "callee" && (parent.type === "CallExpression" || parent.type === "NewExpression") || parent.type === "TSNonNullExpression" && parentParent.type === "MemberExpression" && parentParent.object === parent) {
                return true;
              }
            }
            case "CallExpression":
            case "MemberExpression":
            case "TaggedTemplateExpression":
            case "TSNonNullExpression":
              if (name === "callee" && (parent.type === "BindExpression" || parent.type === "NewExpression")) {
                let object3 = node;
                while (object3) {
                  switch (object3.type) {
                    case "CallExpression":
                    case "OptionalCallExpression":
                      return true;
                    case "MemberExpression":
                    case "OptionalMemberExpression":
                    case "BindExpression":
                      object3 = object3.object;
                      break;
                    case "TaggedTemplateExpression":
                      object3 = object3.tag;
                      break;
                    case "TSNonNullExpression":
                      object3 = object3.expression;
                      break;
                    default:
                      return false;
                  }
                }
              }
              return false;
            case "BindExpression":
              return name === "callee" && (parent.type === "BindExpression" || parent.type === "NewExpression") || name === "object" && isMemberExpression(parent);
            case "NGPipeExpression":
              if (parent.type === "NGRoot" || parent.type === "NGMicrosyntaxExpression" || parent.type === "ObjectProperty" && !(node.extra && node.extra.parenthesized) || parent.type === "ArrayExpression" || isCallExpression(parent) && parent.arguments[name] === node || name === "right" && parent.type === "NGPipeExpression" || name === "property" && parent.type === "MemberExpression" || parent.type === "AssignmentExpression") {
                return false;
              }
              return true;
            case "JSXFragment":
            case "JSXElement":
              return name === "callee" || name === "left" && parent.type === "BinaryExpression" && parent.operator === "<" || parent.type !== "ArrayExpression" && parent.type !== "ArrowFunctionExpression" && parent.type !== "AssignmentExpression" && parent.type !== "AssignmentPattern" && parent.type !== "BinaryExpression" && parent.type !== "NewExpression" && parent.type !== "ConditionalExpression" && parent.type !== "ExpressionStatement" && parent.type !== "JsExpressionRoot" && parent.type !== "JSXAttribute" && parent.type !== "JSXElement" && parent.type !== "JSXExpressionContainer" && parent.type !== "JSXFragment" && parent.type !== "LogicalExpression" && !isCallExpression(parent) && !isObjectProperty(parent) && parent.type !== "ReturnStatement" && parent.type !== "ThrowStatement" && parent.type !== "TypeCastExpression" && parent.type !== "VariableDeclarator" && parent.type !== "YieldExpression";
            case "TypeAnnotation":
              return name === "returnType" && parent.type === "ArrowFunctionExpression" && includesFunctionTypeInObjectType(node);
          }
          return false;
        }
        function isStatement(node) {
          return node.type === "BlockStatement" || node.type === "BreakStatement" || node.type === "ClassBody" || node.type === "ClassDeclaration" || node.type === "ClassMethod" || node.type === "ClassProperty" || node.type === "PropertyDefinition" || node.type === "ClassPrivateProperty" || node.type === "ContinueStatement" || node.type === "DebuggerStatement" || node.type === "DeclareClass" || node.type === "DeclareExportAllDeclaration" || node.type === "DeclareExportDeclaration" || node.type === "DeclareFunction" || node.type === "DeclareInterface" || node.type === "DeclareModule" || node.type === "DeclareModuleExports" || node.type === "DeclareVariable" || node.type === "DoWhileStatement" || node.type === "EnumDeclaration" || node.type === "ExportAllDeclaration" || node.type === "ExportDefaultDeclaration" || node.type === "ExportNamedDeclaration" || node.type === "ExpressionStatement" || node.type === "ForInStatement" || node.type === "ForOfStatement" || node.type === "ForStatement" || node.type === "FunctionDeclaration" || node.type === "IfStatement" || node.type === "ImportDeclaration" || node.type === "InterfaceDeclaration" || node.type === "LabeledStatement" || node.type === "MethodDefinition" || node.type === "ReturnStatement" || node.type === "SwitchStatement" || node.type === "ThrowStatement" || node.type === "TryStatement" || node.type === "TSDeclareFunction" || node.type === "TSEnumDeclaration" || node.type === "TSImportEqualsDeclaration" || node.type === "TSInterfaceDeclaration" || node.type === "TSModuleDeclaration" || node.type === "TSNamespaceExportDeclaration" || node.type === "TypeAlias" || node.type === "VariableDeclaration" || node.type === "WhileStatement" || node.type === "WithStatement";
        }
        function isPathInForStatementInitializer(path5) {
          let i = 0;
          let node = path5.getValue();
          while (node) {
            const parent = path5.getParentNode(i++);
            if (parent && parent.type === "ForStatement" && parent.init === node) {
              return true;
            }
            node = parent;
          }
          return false;
        }
        function includesFunctionTypeInObjectType(node) {
          return hasNode(node, (n1) => n1.type === "ObjectTypeAnnotation" && hasNode(n1, (n2) => n2.type === "FunctionTypeAnnotation" || void 0) || void 0);
        }
        function endsWithRightBracket(node) {
          switch (node.type) {
            case "ObjectExpression":
              return true;
            default:
              return false;
          }
        }
        function isFollowedByRightBracket(path5) {
          const node = path5.getValue();
          const parent = path5.getParentNode();
          const name = path5.getName();
          switch (parent.type) {
            case "NGPipeExpression":
              if (typeof name === "number" && parent.arguments[name] === node && parent.arguments.length - 1 === name) {
                return path5.callParent(isFollowedByRightBracket);
              }
              break;
            case "ObjectProperty":
              if (name === "value") {
                const parentParent = path5.getParentNode(1);
                return getLast(parentParent.properties) === parent;
              }
              break;
            case "BinaryExpression":
            case "LogicalExpression":
              if (name === "right") {
                return path5.callParent(isFollowedByRightBracket);
              }
              break;
            case "ConditionalExpression":
              if (name === "alternate") {
                return path5.callParent(isFollowedByRightBracket);
              }
              break;
            case "UnaryExpression":
              if (parent.prefix) {
                return path5.callParent(isFollowedByRightBracket);
              }
              break;
          }
          return false;
        }
        function shouldWrapFunctionForExportDefault(path5, options) {
          const node = path5.getValue();
          const parent = path5.getParentNode();
          if (node.type === "FunctionExpression" || node.type === "ClassExpression") {
            return parent.type === "ExportDefaultDeclaration" || !needsParens(path5, options);
          }
          if (!hasNakedLeftSide(node) || parent.type !== "ExportDefaultDeclaration" && needsParens(path5, options)) {
            return false;
          }
          return path5.call((childPath) => shouldWrapFunctionForExportDefault(childPath, options), ...getLeftSidePathName(path5, node));
        }
        module22.exports = needsParens;
      }
    });
    var require_print_preprocess = __commonJS22({
      "src/language-js/print-preprocess.js"(exports22, module22) {
        "use strict";
        function preprocess(ast, options) {
          switch (options.parser) {
            case "json":
            case "json5":
            case "json-stringify":
            case "__js_expression":
            case "__vue_expression":
            case "__vue_ts_expression":
              return Object.assign(Object.assign({}, ast), {}, {
                type: options.parser.startsWith("__") ? "JsExpressionRoot" : "JsonRoot",
                node: ast,
                comments: [],
                rootMarker: options.rootMarker
              });
            default:
              return ast;
          }
        }
        module22.exports = preprocess;
      }
    });
    var require_html_binding = __commonJS22({
      "src/language-js/print/html-binding.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            join: join2,
            line,
            group,
            softline,
            indent
          }
        } = require_doc();
        function printHtmlBinding(path5, options, print) {
          const node = path5.getValue();
          if (options.__onHtmlBindingRoot && path5.getName() === null) {
            options.__onHtmlBindingRoot(node, options);
          }
          if (node.type !== "File") {
            return;
          }
          if (options.__isVueForBindingLeft) {
            return path5.call((functionDeclarationPath) => {
              const printed = join2([",", line], functionDeclarationPath.map(print, "params"));
              const {
                params
              } = functionDeclarationPath.getValue();
              if (params.length === 1) {
                return printed;
              }
              return ["(", indent([softline, group(printed)]), softline, ")"];
            }, "program", "body", 0);
          }
          if (options.__isVueBindings) {
            return path5.call((functionDeclarationPath) => join2([",", line], functionDeclarationPath.map(print, "params")), "program", "body", 0);
          }
        }
        function isVueEventBindingExpression(node) {
          switch (node.type) {
            case "MemberExpression":
              switch (node.property.type) {
                case "Identifier":
                case "NumericLiteral":
                case "StringLiteral":
                  return isVueEventBindingExpression(node.object);
              }
              return false;
            case "Identifier":
              return true;
            default:
              return false;
          }
        }
        module22.exports = {
          isVueEventBindingExpression,
          printHtmlBinding
        };
      }
    });
    var require_binaryish = __commonJS22({
      "src/language-js/print/binaryish.js"(exports22, module22) {
        "use strict";
        var {
          printComments
        } = require_comments();
        var {
          getLast
        } = require_util2();
        var {
          builders: {
            join: join2,
            line,
            softline,
            group,
            indent,
            align,
            ifBreak,
            indentIfBreak
          },
          utils: {
            cleanDoc,
            getDocParts,
            isConcat
          }
        } = require_doc();
        var {
          hasLeadingOwnLineComment,
          isBinaryish,
          isJsxNode,
          shouldFlatten,
          hasComment,
          CommentCheckFlags,
          isCallExpression,
          isMemberExpression,
          isObjectProperty,
          isEnabledHackPipeline
        } = require_utils72();
        var uid = 0;
        function printBinaryishExpression(path5, options, print) {
          const node = path5.getValue();
          const parent = path5.getParentNode();
          const parentParent = path5.getParentNode(1);
          const isInsideParenthesis = node !== parent.body && (parent.type === "IfStatement" || parent.type === "WhileStatement" || parent.type === "SwitchStatement" || parent.type === "DoWhileStatement");
          const isHackPipeline = isEnabledHackPipeline(options) && node.operator === "|>";
          const parts = printBinaryishExpressions(path5, print, options, false, isInsideParenthesis);
          if (isInsideParenthesis) {
            return parts;
          }
          if (isHackPipeline) {
            return group(parts);
          }
          if (isCallExpression(parent) && parent.callee === node || parent.type === "UnaryExpression" || isMemberExpression(parent) && !parent.computed) {
            return group([indent([softline, ...parts]), softline]);
          }
          const shouldNotIndent = parent.type === "ReturnStatement" || parent.type === "ThrowStatement" || parent.type === "JSXExpressionContainer" && parentParent.type === "JSXAttribute" || node.operator !== "|" && parent.type === "JsExpressionRoot" || node.type !== "NGPipeExpression" && (parent.type === "NGRoot" && options.parser === "__ng_binding" || parent.type === "NGMicrosyntaxExpression" && parentParent.type === "NGMicrosyntax" && parentParent.body.length === 1) || node === parent.body && parent.type === "ArrowFunctionExpression" || node !== parent.body && parent.type === "ForStatement" || parent.type === "ConditionalExpression" && parentParent.type !== "ReturnStatement" && parentParent.type !== "ThrowStatement" && !isCallExpression(parentParent) || parent.type === "TemplateLiteral";
          const shouldIndentIfInlining = parent.type === "AssignmentExpression" || parent.type === "VariableDeclarator" || parent.type === "ClassProperty" || parent.type === "PropertyDefinition" || parent.type === "TSAbstractPropertyDefinition" || parent.type === "ClassPrivateProperty" || isObjectProperty(parent);
          const samePrecedenceSubExpression = isBinaryish(node.left) && shouldFlatten(node.operator, node.left.operator);
          if (shouldNotIndent || shouldInlineLogicalExpression(node) && !samePrecedenceSubExpression || !shouldInlineLogicalExpression(node) && shouldIndentIfInlining) {
            return group(parts);
          }
          if (parts.length === 0) {
            return "";
          }
          const hasJsx = isJsxNode(node.right);
          const firstGroupIndex = parts.findIndex((part) => typeof part !== "string" && !Array.isArray(part) && part.type === "group");
          const headParts = parts.slice(0, firstGroupIndex === -1 ? 1 : firstGroupIndex + 1);
          const rest = parts.slice(headParts.length, hasJsx ? -1 : void 0);
          const groupId = Symbol("logicalChain-" + ++uid);
          const chain = group([...headParts, indent(rest)], {
            id: groupId
          });
          if (!hasJsx) {
            return chain;
          }
          const jsxPart = getLast(parts);
          return group([chain, indentIfBreak(jsxPart, {
            groupId
          })]);
        }
        function printBinaryishExpressions(path5, print, options, isNested, isInsideParenthesis) {
          const node = path5.getValue();
          if (!isBinaryish(node)) {
            return [group(print())];
          }
          let parts = [];
          if (shouldFlatten(node.operator, node.left.operator)) {
            parts = path5.call((left) => printBinaryishExpressions(left, print, options, true, isInsideParenthesis), "left");
          } else {
            parts.push(group(print("left")));
          }
          const shouldInline = shouldInlineLogicalExpression(node);
          const lineBeforeOperator = (node.operator === "|>" || node.type === "NGPipeExpression" || node.operator === "|" && options.parser === "__vue_expression") && !hasLeadingOwnLineComment(options.originalText, node.right);
          const operator = node.type === "NGPipeExpression" ? "|" : node.operator;
          const rightSuffix = node.type === "NGPipeExpression" && node.arguments.length > 0 ? group(indent([softline, ": ", join2([softline, ":", ifBreak(" ")], path5.map(print, "arguments").map((arg) => align(2, group(arg))))])) : "";
          let right;
          if (shouldInline) {
            right = [operator, " ", print("right"), rightSuffix];
          } else {
            const isHackPipeline = isEnabledHackPipeline(options) && operator === "|>";
            const rightContent = isHackPipeline ? path5.call((left) => printBinaryishExpressions(left, print, options, true, isInsideParenthesis), "right") : print("right");
            right = [lineBeforeOperator ? line : "", operator, lineBeforeOperator ? " " : line, rightContent, rightSuffix];
          }
          const parent = path5.getParentNode();
          const shouldBreak = hasComment(node.left, CommentCheckFlags.Trailing | CommentCheckFlags.Line);
          const shouldGroup = shouldBreak || !(isInsideParenthesis && node.type === "LogicalExpression") && parent.type !== node.type && node.left.type !== node.type && node.right.type !== node.type;
          parts.push(lineBeforeOperator ? "" : " ", shouldGroup ? group(right, {
            shouldBreak
          }) : right);
          if (isNested && hasComment(node)) {
            const printed = cleanDoc(printComments(path5, parts, options));
            if (isConcat(printed) || printed.type === "fill") {
              return getDocParts(printed);
            }
            return [printed];
          }
          return parts;
        }
        function shouldInlineLogicalExpression(node) {
          if (node.type !== "LogicalExpression") {
            return false;
          }
          if (node.right.type === "ObjectExpression" && node.right.properties.length > 0) {
            return true;
          }
          if (node.right.type === "ArrayExpression" && node.right.elements.length > 0) {
            return true;
          }
          if (isJsxNode(node.right)) {
            return true;
          }
          return false;
        }
        module22.exports = {
          printBinaryishExpression,
          shouldInlineLogicalExpression
        };
      }
    });
    var require_angular = __commonJS22({
      "src/language-js/print/angular.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            join: join2,
            line,
            group
          }
        } = require_doc();
        var {
          hasNode,
          hasComment,
          getComments
        } = require_utils72();
        var {
          printBinaryishExpression
        } = require_binaryish();
        function printAngular(path5, options, print) {
          const node = path5.getValue();
          if (!node.type.startsWith("NG")) {
            return;
          }
          switch (node.type) {
            case "NGRoot":
              return [print("node"), !hasComment(node.node) ? "" : " //" + getComments(node.node)[0].value.trimEnd()];
            case "NGPipeExpression":
              return printBinaryishExpression(path5, options, print);
            case "NGChainedExpression":
              return group(join2([";", line], path5.map((childPath) => hasNgSideEffect(childPath) ? print() : ["(", print(), ")"], "expressions")));
            case "NGEmptyExpression":
              return "";
            case "NGQuotedExpression":
              return [node.prefix, ": ", node.value.trim()];
            case "NGMicrosyntax":
              return path5.map((childPath, index) => [index === 0 ? "" : isNgForOf(childPath.getValue(), index, node) ? " " : [";", line], print()], "body");
            case "NGMicrosyntaxKey":
              return /^[$_a-z][\w$]*(?:-[$_a-z][\w$])*$/i.test(node.name) ? node.name : JSON.stringify(node.name);
            case "NGMicrosyntaxExpression":
              return [print("expression"), node.alias === null ? "" : [" as ", print("alias")]];
            case "NGMicrosyntaxKeyedExpression": {
              const index = path5.getName();
              const parentNode = path5.getParentNode();
              const shouldNotPrintColon = isNgForOf(node, index, parentNode) || (index === 1 && (node.key.name === "then" || node.key.name === "else") || index === 2 && node.key.name === "else" && parentNode.body[index - 1].type === "NGMicrosyntaxKeyedExpression" && parentNode.body[index - 1].key.name === "then") && parentNode.body[0].type === "NGMicrosyntaxExpression";
              return [print("key"), shouldNotPrintColon ? " " : ": ", print("expression")];
            }
            case "NGMicrosyntaxLet":
              return ["let ", print("key"), node.value === null ? "" : [" = ", print("value")]];
            case "NGMicrosyntaxAs":
              return [print("key"), " as ", print("alias")];
            default:
              throw new Error(`Unknown Angular node type: ${JSON.stringify(node.type)}.`);
          }
        }
        function isNgForOf(node, index, parentNode) {
          return node.type === "NGMicrosyntaxKeyedExpression" && node.key.name === "of" && index === 1 && parentNode.body[0].type === "NGMicrosyntaxLet" && parentNode.body[0].value === null;
        }
        function hasNgSideEffect(path5) {
          return hasNode(path5.getValue(), (node) => {
            switch (node.type) {
              case void 0:
                return false;
              case "CallExpression":
              case "OptionalCallExpression":
              case "AssignmentExpression":
                return true;
            }
          });
        }
        module22.exports = {
          printAngular
        };
      }
    });
    var require_jsx = __commonJS22({
      "src/language-js/print/jsx.js"(exports22, module22) {
        "use strict";
        var {
          printComments,
          printDanglingComments
        } = require_comments();
        var {
          builders: {
            line,
            hardline,
            softline,
            group,
            indent,
            conditionalGroup,
            fill,
            ifBreak,
            lineSuffixBoundary,
            join: join2
          },
          utils: {
            willBreak
          }
        } = require_doc();
        var {
          getLast,
          getPreferredQuote
        } = require_util2();
        var {
          isJsxNode,
          rawText,
          isLiteral,
          isCallExpression,
          isStringLiteral,
          isBinaryish,
          hasComment,
          CommentCheckFlags,
          hasNodeIgnoreComment
        } = require_utils72();
        var pathNeedsParens = require_needs_parens();
        var {
          willPrintOwnComments
        } = require_comments2();
        var isEmptyStringOrAnyLine = (doc2) => doc2 === "" || doc2 === line || doc2 === hardline || doc2 === softline;
        function printJsxElementInternal(path5, options, print) {
          const node = path5.getValue();
          if (node.type === "JSXElement" && isEmptyJsxElement(node)) {
            return [print("openingElement"), print("closingElement")];
          }
          const openingLines = node.type === "JSXElement" ? print("openingElement") : print("openingFragment");
          const closingLines = node.type === "JSXElement" ? print("closingElement") : print("closingFragment");
          if (node.children.length === 1 && node.children[0].type === "JSXExpressionContainer" && (node.children[0].expression.type === "TemplateLiteral" || node.children[0].expression.type === "TaggedTemplateExpression")) {
            return [openingLines, ...path5.map(print, "children"), closingLines];
          }
          node.children = node.children.map((child) => {
            if (isJsxWhitespaceExpression(child)) {
              return {
                type: "JSXText",
                value: " ",
                raw: " "
              };
            }
            return child;
          });
          const containsTag = node.children.some(isJsxNode);
          const containsMultipleExpressions = node.children.filter((child) => child.type === "JSXExpressionContainer").length > 1;
          const containsMultipleAttributes = node.type === "JSXElement" && node.openingElement.attributes.length > 1;
          let forcedBreak = willBreak(openingLines) || containsTag || containsMultipleAttributes || containsMultipleExpressions;
          const isMdxBlock = path5.getParentNode().rootMarker === "mdx";
          const rawJsxWhitespace = options.singleQuote ? "{' '}" : '{" "}';
          const jsxWhitespace = isMdxBlock ? " " : ifBreak([rawJsxWhitespace, softline], " ");
          const isFacebookTranslationTag = node.openingElement && node.openingElement.name && node.openingElement.name.name === "fbt";
          const children = printJsxChildren(path5, options, print, jsxWhitespace, isFacebookTranslationTag);
          const containsText = node.children.some((child) => isMeaningfulJsxText(child));
          for (let i = children.length - 2; i >= 0; i--) {
            const isPairOfEmptyStrings = children[i] === "" && children[i + 1] === "";
            const isPairOfHardlines = children[i] === hardline && children[i + 1] === "" && children[i + 2] === hardline;
            const isLineFollowedByJsxWhitespace = (children[i] === softline || children[i] === hardline) && children[i + 1] === "" && children[i + 2] === jsxWhitespace;
            const isJsxWhitespaceFollowedByLine = children[i] === jsxWhitespace && children[i + 1] === "" && (children[i + 2] === softline || children[i + 2] === hardline);
            const isDoubleJsxWhitespace = children[i] === jsxWhitespace && children[i + 1] === "" && children[i + 2] === jsxWhitespace;
            const isPairOfHardOrSoftLines = children[i] === softline && children[i + 1] === "" && children[i + 2] === hardline || children[i] === hardline && children[i + 1] === "" && children[i + 2] === softline;
            if (isPairOfHardlines && containsText || isPairOfEmptyStrings || isLineFollowedByJsxWhitespace || isDoubleJsxWhitespace || isPairOfHardOrSoftLines) {
              children.splice(i, 2);
            } else if (isJsxWhitespaceFollowedByLine) {
              children.splice(i + 1, 2);
            }
          }
          while (children.length > 0 && isEmptyStringOrAnyLine(getLast(children))) {
            children.pop();
          }
          while (children.length > 1 && isEmptyStringOrAnyLine(children[0]) && isEmptyStringOrAnyLine(children[1])) {
            children.shift();
            children.shift();
          }
          const multilineChildren = [];
          for (const [i, child] of children.entries()) {
            if (child === jsxWhitespace) {
              if (i === 1 && children[i - 1] === "") {
                if (children.length === 2) {
                  multilineChildren.push(rawJsxWhitespace);
                  continue;
                }
                multilineChildren.push([rawJsxWhitespace, hardline]);
                continue;
              } else if (i === children.length - 1) {
                multilineChildren.push(rawJsxWhitespace);
                continue;
              } else if (children[i - 1] === "" && children[i - 2] === hardline) {
                multilineChildren.push(rawJsxWhitespace);
                continue;
              }
            }
            multilineChildren.push(child);
            if (willBreak(child)) {
              forcedBreak = true;
            }
          }
          const content = containsText ? fill(multilineChildren) : group(multilineChildren, {
            shouldBreak: true
          });
          if (isMdxBlock) {
            return content;
          }
          const multiLineElem = group([openingLines, indent([hardline, content]), hardline, closingLines]);
          if (forcedBreak) {
            return multiLineElem;
          }
          return conditionalGroup([group([openingLines, ...children, closingLines]), multiLineElem]);
        }
        function printJsxChildren(path5, options, print, jsxWhitespace, isFacebookTranslationTag) {
          const parts = [];
          path5.each((childPath, i, children) => {
            const child = childPath.getValue();
            if (isLiteral(child)) {
              const text = rawText(child);
              if (isMeaningfulJsxText(child)) {
                const words2 = text.split(matchJsxWhitespaceRegex);
                if (words2[0] === "") {
                  parts.push("");
                  words2.shift();
                  if (/\n/.test(words2[0])) {
                    const next = children[i + 1];
                    parts.push(separatorWithWhitespace(isFacebookTranslationTag, words2[1], child, next));
                  } else {
                    parts.push(jsxWhitespace);
                  }
                  words2.shift();
                }
                let endWhitespace;
                if (getLast(words2) === "") {
                  words2.pop();
                  endWhitespace = words2.pop();
                }
                if (words2.length === 0) {
                  return;
                }
                for (const [i2, word] of words2.entries()) {
                  if (i2 % 2 === 1) {
                    parts.push(line);
                  } else {
                    parts.push(word);
                  }
                }
                if (endWhitespace !== void 0) {
                  if (/\n/.test(endWhitespace)) {
                    const next = children[i + 1];
                    parts.push(separatorWithWhitespace(isFacebookTranslationTag, getLast(parts), child, next));
                  } else {
                    parts.push(jsxWhitespace);
                  }
                } else {
                  const next = children[i + 1];
                  parts.push(separatorNoWhitespace(isFacebookTranslationTag, getLast(parts), child, next));
                }
              } else if (/\n/.test(text)) {
                if (text.match(/\n/g).length > 1) {
                  parts.push("", hardline);
                }
              } else {
                parts.push("", jsxWhitespace);
              }
            } else {
              const printedChild = print();
              parts.push(printedChild);
              const next = children[i + 1];
              const directlyFollowedByMeaningfulText = next && isMeaningfulJsxText(next);
              if (directlyFollowedByMeaningfulText) {
                const firstWord = trimJsxWhitespace(rawText(next)).split(matchJsxWhitespaceRegex)[0];
                parts.push(separatorNoWhitespace(isFacebookTranslationTag, firstWord, child, next));
              } else {
                parts.push(hardline);
              }
            }
          }, "children");
          return parts;
        }
        function separatorNoWhitespace(isFacebookTranslationTag, child, childNode, nextNode) {
          if (isFacebookTranslationTag) {
            return "";
          }
          if (childNode.type === "JSXElement" && !childNode.closingElement || nextNode && nextNode.type === "JSXElement" && !nextNode.closingElement) {
            return child.length === 1 ? softline : hardline;
          }
          return softline;
        }
        function separatorWithWhitespace(isFacebookTranslationTag, child, childNode, nextNode) {
          if (isFacebookTranslationTag) {
            return hardline;
          }
          if (child.length === 1) {
            return childNode.type === "JSXElement" && !childNode.closingElement || nextNode && nextNode.type === "JSXElement" && !nextNode.closingElement ? hardline : softline;
          }
          return hardline;
        }
        function maybeWrapJsxElementInParens(path5, elem, options) {
          const parent = path5.getParentNode();
          if (!parent) {
            return elem;
          }
          const NO_WRAP_PARENTS = {
            ArrayExpression: true,
            JSXAttribute: true,
            JSXElement: true,
            JSXExpressionContainer: true,
            JSXFragment: true,
            ExpressionStatement: true,
            CallExpression: true,
            OptionalCallExpression: true,
            ConditionalExpression: true,
            JsExpressionRoot: true
          };
          if (NO_WRAP_PARENTS[parent.type]) {
            return elem;
          }
          const shouldBreak = path5.match(void 0, (node) => node.type === "ArrowFunctionExpression", isCallExpression, (node) => node.type === "JSXExpressionContainer");
          const needsParens = pathNeedsParens(path5, options);
          return group([needsParens ? "" : ifBreak("("), indent([softline, elem]), softline, needsParens ? "" : ifBreak(")")], {
            shouldBreak
          });
        }
        function printJsxAttribute(path5, options, print) {
          const node = path5.getValue();
          const parts = [];
          parts.push(print("name"));
          if (node.value) {
            let res;
            if (isStringLiteral(node.value)) {
              const raw = rawText(node.value);
              let final = raw.slice(1, -1).replace(/&apos;/g, "'").replace(/&quot;/g, '"');
              const {
                escaped,
                quote,
                regex
              } = getPreferredQuote(final, options.jsxSingleQuote ? "'" : '"');
              final = final.replace(regex, escaped);
              res = [quote, final, quote];
            } else {
              res = print("value");
            }
            parts.push("=", res);
          }
          return parts;
        }
        function printJsxExpressionContainer(path5, options, print) {
          const node = path5.getValue();
          const shouldInline = (node2, parent) => node2.type === "JSXEmptyExpression" || !hasComment(node2) && (node2.type === "ArrayExpression" || node2.type === "ObjectExpression" || node2.type === "ArrowFunctionExpression" || node2.type === "AwaitExpression" && (shouldInline(node2.argument, node2) || node2.argument.type === "JSXElement") || isCallExpression(node2) || node2.type === "FunctionExpression" || node2.type === "TemplateLiteral" || node2.type === "TaggedTemplateExpression" || node2.type === "DoExpression" || isJsxNode(parent) && (node2.type === "ConditionalExpression" || isBinaryish(node2)));
          if (shouldInline(node.expression, path5.getParentNode(0))) {
            return group(["{", print("expression"), lineSuffixBoundary, "}"]);
          }
          return group(["{", indent([softline, print("expression")]), softline, lineSuffixBoundary, "}"]);
        }
        function printJsxOpeningElement(path5, options, print) {
          const node = path5.getValue();
          const nameHasComments = node.name && hasComment(node.name) || node.typeParameters && hasComment(node.typeParameters);
          if (node.selfClosing && node.attributes.length === 0 && !nameHasComments) {
            return ["<", print("name"), print("typeParameters"), " />"];
          }
          if (node.attributes && node.attributes.length === 1 && node.attributes[0].value && isStringLiteral(node.attributes[0].value) && !node.attributes[0].value.value.includes("\n") && !nameHasComments && !hasComment(node.attributes[0])) {
            return group(["<", print("name"), print("typeParameters"), " ", ...path5.map(print, "attributes"), node.selfClosing ? " />" : ">"]);
          }
          const lastAttrHasTrailingComments = node.attributes.length > 0 && hasComment(getLast(node.attributes), CommentCheckFlags.Trailing);
          const bracketSameLine = node.attributes.length === 0 && !nameHasComments || (options.bracketSameLine || options.jsxBracketSameLine) && (!nameHasComments || node.attributes.length > 0) && !lastAttrHasTrailingComments;
          const shouldBreak = node.attributes && node.attributes.some((attr) => attr.value && isStringLiteral(attr.value) && attr.value.value.includes("\n"));
          const attributeLine = options.singleAttributePerLine && node.attributes.length > 1 ? hardline : line;
          return group(["<", print("name"), print("typeParameters"), indent(path5.map(() => [attributeLine, print()], "attributes")), node.selfClosing ? line : bracketSameLine ? ">" : softline, node.selfClosing ? "/>" : bracketSameLine ? "" : ">"], {
            shouldBreak
          });
        }
        function printJsxClosingElement(path5, options, print) {
          const node = path5.getValue();
          const parts = [];
          parts.push("</");
          const printed = print("name");
          if (hasComment(node.name, CommentCheckFlags.Leading | CommentCheckFlags.Line)) {
            parts.push(indent([hardline, printed]), hardline);
          } else if (hasComment(node.name, CommentCheckFlags.Leading | CommentCheckFlags.Block)) {
            parts.push(" ", printed);
          } else {
            parts.push(printed);
          }
          parts.push(">");
          return parts;
        }
        function printJsxOpeningClosingFragment(path5, options) {
          const node = path5.getValue();
          const nodeHasComment = hasComment(node);
          const hasOwnLineComment = hasComment(node, CommentCheckFlags.Line);
          const isOpeningFragment = node.type === "JSXOpeningFragment";
          return [isOpeningFragment ? "<" : "</", indent([hasOwnLineComment ? hardline : nodeHasComment && !isOpeningFragment ? " " : "", printDanglingComments(path5, options, true)]), hasOwnLineComment ? hardline : "", ">"];
        }
        function printJsxElement(path5, options, print) {
          const elem = printComments(path5, printJsxElementInternal(path5, options, print), options);
          return maybeWrapJsxElementInParens(path5, elem, options);
        }
        function printJsxEmptyExpression(path5, options) {
          const node = path5.getValue();
          const requiresHardline = hasComment(node, CommentCheckFlags.Line);
          return [printDanglingComments(path5, options, !requiresHardline), requiresHardline ? hardline : ""];
        }
        function printJsxSpreadAttribute(path5, options, print) {
          const node = path5.getValue();
          return ["{", path5.call((p) => {
            const printed = ["...", print()];
            const node2 = p.getValue();
            if (!hasComment(node2) || !willPrintOwnComments(p)) {
              return printed;
            }
            return [indent([softline, printComments(p, printed, options)]), softline];
          }, node.type === "JSXSpreadAttribute" ? "argument" : "expression"), "}"];
        }
        function printJsx(path5, options, print) {
          const node = path5.getValue();
          if (!node.type.startsWith("JSX")) {
            return;
          }
          switch (node.type) {
            case "JSXAttribute":
              return printJsxAttribute(path5, options, print);
            case "JSXIdentifier":
              return String(node.name);
            case "JSXNamespacedName":
              return join2(":", [print("namespace"), print("name")]);
            case "JSXMemberExpression":
              return join2(".", [print("object"), print("property")]);
            case "JSXSpreadAttribute":
              return printJsxSpreadAttribute(path5, options, print);
            case "JSXSpreadChild": {
              const printJsxSpreadChild = printJsxSpreadAttribute;
              return printJsxSpreadChild(path5, options, print);
            }
            case "JSXExpressionContainer":
              return printJsxExpressionContainer(path5, options, print);
            case "JSXFragment":
            case "JSXElement":
              return printJsxElement(path5, options, print);
            case "JSXOpeningElement":
              return printJsxOpeningElement(path5, options, print);
            case "JSXClosingElement":
              return printJsxClosingElement(path5, options, print);
            case "JSXOpeningFragment":
            case "JSXClosingFragment":
              return printJsxOpeningClosingFragment(path5, options);
            case "JSXEmptyExpression":
              return printJsxEmptyExpression(path5, options);
            case "JSXText":
              throw new Error("JSXTest should be handled by JSXElement");
            default:
              throw new Error(`Unknown JSX node type: ${JSON.stringify(node.type)}.`);
          }
        }
        var jsxWhitespaceChars = " \n\r	";
        var matchJsxWhitespaceRegex = new RegExp("([" + jsxWhitespaceChars + "]+)");
        var containsNonJsxWhitespaceRegex = new RegExp("[^" + jsxWhitespaceChars + "]");
        var trimJsxWhitespace = (text) => text.replace(new RegExp("(?:^" + matchJsxWhitespaceRegex.source + "|" + matchJsxWhitespaceRegex.source + "$)"), "");
        function isEmptyJsxElement(node) {
          if (node.children.length === 0) {
            return true;
          }
          if (node.children.length > 1) {
            return false;
          }
          const child = node.children[0];
          return isLiteral(child) && !isMeaningfulJsxText(child);
        }
        function isMeaningfulJsxText(node) {
          return isLiteral(node) && (containsNonJsxWhitespaceRegex.test(rawText(node)) || !/\n/.test(rawText(node)));
        }
        function isJsxWhitespaceExpression(node) {
          return node.type === "JSXExpressionContainer" && isLiteral(node.expression) && node.expression.value === " " && !hasComment(node.expression);
        }
        function hasJsxIgnoreComment(path5) {
          const node = path5.getValue();
          const parent = path5.getParentNode();
          if (!parent || !node || !isJsxNode(node) || !isJsxNode(parent)) {
            return false;
          }
          const index = parent.children.indexOf(node);
          let prevSibling = null;
          for (let i = index; i > 0; i--) {
            const candidate = parent.children[i - 1];
            if (candidate.type === "JSXText" && !isMeaningfulJsxText(candidate)) {
              continue;
            }
            prevSibling = candidate;
            break;
          }
          return prevSibling && prevSibling.type === "JSXExpressionContainer" && prevSibling.expression.type === "JSXEmptyExpression" && hasNodeIgnoreComment(prevSibling.expression);
        }
        module22.exports = {
          hasJsxIgnoreComment,
          printJsx
        };
      }
    });
    var require_misc = __commonJS22({
      "src/language-js/print/misc.js"(exports22, module22) {
        "use strict";
        var {
          isNonEmptyArray
        } = require_util2();
        var {
          builders: {
            indent,
            join: join2,
            line
          }
        } = require_doc();
        var {
          isFlowAnnotationComment
        } = require_utils72();
        function printOptionalToken(path5) {
          const node = path5.getValue();
          if (!node.optional || node.type === "Identifier" && node === path5.getParentNode().key) {
            return "";
          }
          if (node.type === "OptionalCallExpression" || node.type === "OptionalMemberExpression" && node.computed) {
            return "?.";
          }
          return "?";
        }
        function printDefiniteToken(path5) {
          return path5.getValue().definite || path5.match(void 0, (node, name) => name === "id" && node.type === "VariableDeclarator" && node.definite) ? "!" : "";
        }
        function printFunctionTypeParameters(path5, options, print) {
          const fun = path5.getValue();
          if (fun.typeArguments) {
            return print("typeArguments");
          }
          if (fun.typeParameters) {
            return print("typeParameters");
          }
          return "";
        }
        function printTypeAnnotation(path5, options, print) {
          const node = path5.getValue();
          if (!node.typeAnnotation) {
            return "";
          }
          const parentNode = path5.getParentNode();
          const isFunctionDeclarationIdentifier = parentNode.type === "DeclareFunction" && parentNode.id === node;
          if (isFlowAnnotationComment(options.originalText, node.typeAnnotation)) {
            return [" /*: ", print("typeAnnotation"), " */"];
          }
          return [isFunctionDeclarationIdentifier ? "" : ": ", print("typeAnnotation")];
        }
        function printBindExpressionCallee(path5, options, print) {
          return ["::", print("callee")];
        }
        function printTypeScriptModifiers(path5, options, print) {
          const node = path5.getValue();
          if (!isNonEmptyArray(node.modifiers)) {
            return "";
          }
          return [join2(" ", path5.map(print, "modifiers")), " "];
        }
        function adjustClause(node, clause, forceSpace) {
          if (node.type === "EmptyStatement") {
            return ";";
          }
          if (node.type === "BlockStatement" || forceSpace) {
            return [" ", clause];
          }
          return indent([line, clause]);
        }
        function printRestSpread(path5, options, print) {
          return ["...", print("argument"), printTypeAnnotation(path5, options, print)];
        }
        module22.exports = {
          printOptionalToken,
          printDefiniteToken,
          printFunctionTypeParameters,
          printBindExpressionCallee,
          printTypeScriptModifiers,
          printTypeAnnotation,
          printRestSpread,
          adjustClause
        };
      }
    });
    var require_array4 = __commonJS22({
      "src/language-js/print/array.js"(exports22, module22) {
        "use strict";
        var {
          printDanglingComments
        } = require_comments();
        var {
          builders: {
            line,
            softline,
            hardline,
            group,
            indent,
            ifBreak,
            fill
          }
        } = require_doc();
        var {
          getLast,
          hasNewline
        } = require_util2();
        var {
          shouldPrintComma,
          hasComment,
          CommentCheckFlags,
          isNextLineEmpty,
          isNumericLiteral,
          isSignedNumericLiteral
        } = require_utils72();
        var {
          locStart
        } = require_loc();
        var {
          printOptionalToken,
          printTypeAnnotation
        } = require_misc();
        function printArray(path5, options, print) {
          const node = path5.getValue();
          const parts = [];
          const openBracket = node.type === "TupleExpression" ? "#[" : "[";
          const closeBracket = "]";
          if (node.elements.length === 0) {
            if (!hasComment(node, CommentCheckFlags.Dangling)) {
              parts.push(openBracket, closeBracket);
            } else {
              parts.push(group([openBracket, printDanglingComments(path5, options), softline, closeBracket]));
            }
          } else {
            const lastElem = getLast(node.elements);
            const canHaveTrailingComma = !(lastElem && lastElem.type === "RestElement");
            const needsForcedTrailingComma = lastElem === null;
            const groupId = Symbol("array");
            const shouldBreak = !options.__inJestEach && node.elements.length > 1 && node.elements.every((element, i, elements) => {
              const elementType = element && element.type;
              if (elementType !== "ArrayExpression" && elementType !== "ObjectExpression") {
                return false;
              }
              const nextElement = elements[i + 1];
              if (nextElement && elementType !== nextElement.type) {
                return false;
              }
              const itemsKey = elementType === "ArrayExpression" ? "elements" : "properties";
              return element[itemsKey] && element[itemsKey].length > 1;
            });
            const shouldUseConciseFormatting = isConciselyPrintedArray(node, options);
            const trailingComma = !canHaveTrailingComma ? "" : needsForcedTrailingComma ? "," : !shouldPrintComma(options) ? "" : shouldUseConciseFormatting ? ifBreak(",", "", {
              groupId
            }) : ifBreak(",");
            parts.push(group([openBracket, indent([softline, shouldUseConciseFormatting ? printArrayItemsConcisely(path5, options, print, trailingComma) : [printArrayItems(path5, options, "elements", print), trailingComma], printDanglingComments(path5, options, true)]), softline, closeBracket], {
              shouldBreak,
              id: groupId
            }));
          }
          parts.push(printOptionalToken(path5), printTypeAnnotation(path5, options, print));
          return parts;
        }
        function isConciselyPrintedArray(node, options) {
          return node.elements.length > 1 && node.elements.every((element) => element && (isNumericLiteral(element) || isSignedNumericLiteral(element) && !hasComment(element.argument)) && !hasComment(element, CommentCheckFlags.Trailing | CommentCheckFlags.Line, (comment) => !hasNewline(options.originalText, locStart(comment), {
            backwards: true
          })));
        }
        function printArrayItems(path5, options, printPath, print) {
          const printedElements = [];
          let separatorParts = [];
          path5.each((childPath) => {
            printedElements.push(separatorParts, group(print()));
            separatorParts = [",", line];
            if (childPath.getValue() && isNextLineEmpty(childPath.getValue(), options)) {
              separatorParts.push(softline);
            }
          }, printPath);
          return printedElements;
        }
        function printArrayItemsConcisely(path5, options, print, trailingComma) {
          const parts = [];
          path5.each((childPath, i, elements) => {
            const isLast = i === elements.length - 1;
            parts.push([print(), isLast ? trailingComma : ","]);
            if (!isLast) {
              parts.push(isNextLineEmpty(childPath.getValue(), options) ? [hardline, hardline] : hasComment(elements[i + 1], CommentCheckFlags.Leading | CommentCheckFlags.Line) ? hardline : line);
            }
          }, "elements");
          return fill(parts);
        }
        module22.exports = {
          printArray,
          printArrayItems,
          isConciselyPrintedArray
        };
      }
    });
    var require_call_arguments = __commonJS22({
      "src/language-js/print/call-arguments.js"(exports22, module22) {
        "use strict";
        var {
          printDanglingComments
        } = require_comments();
        var {
          getLast,
          getPenultimate
        } = require_util2();
        var {
          getFunctionParameters,
          hasComment,
          CommentCheckFlags,
          isFunctionCompositionArgs,
          isJsxNode,
          isLongCurriedCallExpression,
          shouldPrintComma,
          getCallArguments,
          iterateCallArgumentsPath,
          isNextLineEmpty,
          isCallExpression,
          isStringLiteral,
          isObjectProperty
        } = require_utils72();
        var {
          builders: {
            line,
            hardline,
            softline,
            group,
            indent,
            conditionalGroup,
            ifBreak,
            breakParent
          },
          utils: {
            willBreak
          }
        } = require_doc();
        var {
          ArgExpansionBailout
        } = require_errors3();
        var {
          isConciselyPrintedArray
        } = require_array4();
        function printCallArguments(path5, options, print) {
          const node = path5.getValue();
          const isDynamicImport = node.type === "ImportExpression";
          const args = getCallArguments(node);
          if (args.length === 0) {
            return ["(", printDanglingComments(path5, options, true), ")"];
          }
          if (isReactHookCallWithDepsArray(args)) {
            return ["(", print(["arguments", 0]), ", ", print(["arguments", 1]), ")"];
          }
          let anyArgEmptyLine = false;
          let hasEmptyLineFollowingFirstArg = false;
          const lastArgIndex = args.length - 1;
          const printedArguments = [];
          iterateCallArgumentsPath(path5, (argPath, index) => {
            const arg = argPath.getNode();
            const parts = [print()];
            if (index === lastArgIndex) {
            } else if (isNextLineEmpty(arg, options)) {
              if (index === 0) {
                hasEmptyLineFollowingFirstArg = true;
              }
              anyArgEmptyLine = true;
              parts.push(",", hardline, hardline);
            } else {
              parts.push(",", line);
            }
            printedArguments.push(parts);
          });
          const maybeTrailingComma = !(isDynamicImport || node.callee && node.callee.type === "Import") && shouldPrintComma(options, "all") ? "," : "";
          function allArgsBrokenOut() {
            return group(["(", indent([line, ...printedArguments]), maybeTrailingComma, line, ")"], {
              shouldBreak: true
            });
          }
          if (anyArgEmptyLine || path5.getParentNode().type !== "Decorator" && isFunctionCompositionArgs(args)) {
            return allArgsBrokenOut();
          }
          const shouldGroupFirst = shouldGroupFirstArg(args);
          const shouldGroupLast = shouldGroupLastArg(args, options);
          if (shouldGroupFirst || shouldGroupLast) {
            if (shouldGroupFirst ? printedArguments.slice(1).some(willBreak) : printedArguments.slice(0, -1).some(willBreak)) {
              return allArgsBrokenOut();
            }
            let printedExpanded = [];
            try {
              path5.try(() => {
                iterateCallArgumentsPath(path5, (argPath, i) => {
                  if (shouldGroupFirst && i === 0) {
                    printedExpanded = [[print([], {
                      expandFirstArg: true
                    }), printedArguments.length > 1 ? "," : "", hasEmptyLineFollowingFirstArg ? hardline : line, hasEmptyLineFollowingFirstArg ? hardline : ""], ...printedArguments.slice(1)];
                  }
                  if (shouldGroupLast && i === lastArgIndex) {
                    printedExpanded = [...printedArguments.slice(0, -1), print([], {
                      expandLastArg: true
                    })];
                  }
                });
              });
            } catch (caught) {
              if (caught instanceof ArgExpansionBailout) {
                return allArgsBrokenOut();
              }
              throw caught;
            }
            return [printedArguments.some(willBreak) ? breakParent : "", conditionalGroup([["(", ...printedExpanded, ")"], shouldGroupFirst ? ["(", group(printedExpanded[0], {
              shouldBreak: true
            }), ...printedExpanded.slice(1), ")"] : ["(", ...printedArguments.slice(0, -1), group(getLast(printedExpanded), {
              shouldBreak: true
            }), ")"], allArgsBrokenOut()])];
          }
          const contents = ["(", indent([softline, ...printedArguments]), ifBreak(maybeTrailingComma), softline, ")"];
          if (isLongCurriedCallExpression(path5)) {
            return contents;
          }
          return group(contents, {
            shouldBreak: printedArguments.some(willBreak) || anyArgEmptyLine
          });
        }
        function couldGroupArg(arg, arrowChainRecursion = false) {
          return arg.type === "ObjectExpression" && (arg.properties.length > 0 || hasComment(arg)) || arg.type === "ArrayExpression" && (arg.elements.length > 0 || hasComment(arg)) || arg.type === "TSTypeAssertion" && couldGroupArg(arg.expression) || arg.type === "TSAsExpression" && couldGroupArg(arg.expression) || arg.type === "FunctionExpression" || arg.type === "ArrowFunctionExpression" && (!arg.returnType || !arg.returnType.typeAnnotation || arg.returnType.typeAnnotation.type !== "TSTypeReference" || isNonEmptyBlockStatement(arg.body)) && (arg.body.type === "BlockStatement" || arg.body.type === "ArrowFunctionExpression" && couldGroupArg(arg.body, true) || arg.body.type === "ObjectExpression" || arg.body.type === "ArrayExpression" || !arrowChainRecursion && (isCallExpression(arg.body) || arg.body.type === "ConditionalExpression") || isJsxNode(arg.body)) || arg.type === "DoExpression" || arg.type === "ModuleExpression";
        }
        function shouldGroupLastArg(args, options) {
          const lastArg = getLast(args);
          const penultimateArg = getPenultimate(args);
          return !hasComment(lastArg, CommentCheckFlags.Leading) && !hasComment(lastArg, CommentCheckFlags.Trailing) && couldGroupArg(lastArg) && (!penultimateArg || penultimateArg.type !== lastArg.type) && (args.length !== 2 || penultimateArg.type !== "ArrowFunctionExpression" || lastArg.type !== "ArrayExpression") && !(args.length > 1 && lastArg.type === "ArrayExpression" && isConciselyPrintedArray(lastArg, options));
        }
        function shouldGroupFirstArg(args) {
          if (args.length !== 2) {
            return false;
          }
          const [firstArg, secondArg] = args;
          if (firstArg.type === "ModuleExpression" && isTypeModuleObjectExpression(secondArg)) {
            return true;
          }
          return !hasComment(firstArg) && (firstArg.type === "FunctionExpression" || firstArg.type === "ArrowFunctionExpression" && firstArg.body.type === "BlockStatement") && secondArg.type !== "FunctionExpression" && secondArg.type !== "ArrowFunctionExpression" && secondArg.type !== "ConditionalExpression" && !couldGroupArg(secondArg);
        }
        function isReactHookCallWithDepsArray(args) {
          return args.length === 2 && args[0].type === "ArrowFunctionExpression" && getFunctionParameters(args[0]).length === 0 && args[0].body.type === "BlockStatement" && args[1].type === "ArrayExpression" && !args.some((arg) => hasComment(arg));
        }
        function isNonEmptyBlockStatement(node) {
          return node.type === "BlockStatement" && (node.body.some((node2) => node2.type !== "EmptyStatement") || hasComment(node, CommentCheckFlags.Dangling));
        }
        function isTypeModuleObjectExpression(node) {
          return node.type === "ObjectExpression" && node.properties.length === 1 && isObjectProperty(node.properties[0]) && node.properties[0].key.type === "Identifier" && node.properties[0].key.name === "type" && isStringLiteral(node.properties[0].value) && node.properties[0].value.value === "module";
        }
        module22.exports = printCallArguments;
      }
    });
    var require_member = __commonJS22({
      "src/language-js/print/member.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            softline,
            group,
            indent,
            label
          }
        } = require_doc();
        var {
          isNumericLiteral,
          isMemberExpression,
          isCallExpression
        } = require_utils72();
        var {
          printOptionalToken
        } = require_misc();
        function printMemberExpression(path5, options, print) {
          const node = path5.getValue();
          const parent = path5.getParentNode();
          let firstNonMemberParent;
          let i = 0;
          do {
            firstNonMemberParent = path5.getParentNode(i);
            i++;
          } while (firstNonMemberParent && (isMemberExpression(firstNonMemberParent) || firstNonMemberParent.type === "TSNonNullExpression"));
          const objectDoc = print("object");
          const lookupDoc = printMemberLookup(path5, options, print);
          const shouldInline = firstNonMemberParent && (firstNonMemberParent.type === "NewExpression" || firstNonMemberParent.type === "BindExpression" || firstNonMemberParent.type === "AssignmentExpression" && firstNonMemberParent.left.type !== "Identifier") || node.computed || node.object.type === "Identifier" && node.property.type === "Identifier" && !isMemberExpression(parent) || (parent.type === "AssignmentExpression" || parent.type === "VariableDeclarator") && (isCallExpression(node.object) && node.object.arguments.length > 0 || node.object.type === "TSNonNullExpression" && isCallExpression(node.object.expression) && node.object.expression.arguments.length > 0 || objectDoc.label === "member-chain");
          return label(objectDoc.label === "member-chain" ? "member-chain" : "member", [objectDoc, shouldInline ? lookupDoc : group(indent([softline, lookupDoc]))]);
        }
        function printMemberLookup(path5, options, print) {
          const property4 = print("property");
          const node = path5.getValue();
          const optional3 = printOptionalToken(path5);
          if (!node.computed) {
            return [optional3, ".", property4];
          }
          if (!node.property || isNumericLiteral(node.property)) {
            return [optional3, "[", property4, "]"];
          }
          return group([optional3, "[", indent([softline, property4]), softline, "]"]);
        }
        module22.exports = {
          printMemberExpression,
          printMemberLookup
        };
      }
    });
    var require_member_chain = __commonJS22({
      "src/language-js/print/member-chain.js"(exports22, module22) {
        "use strict";
        var {
          printComments
        } = require_comments();
        var {
          getLast,
          isNextLineEmptyAfterIndex,
          getNextNonSpaceNonCommentCharacterIndex
        } = require_util2();
        var pathNeedsParens = require_needs_parens();
        var {
          isCallExpression,
          isMemberExpression,
          isFunctionOrArrowExpression,
          isLongCurriedCallExpression,
          isMemberish,
          isNumericLiteral,
          isSimpleCallArgument,
          hasComment,
          CommentCheckFlags,
          isNextLineEmpty
        } = require_utils72();
        var {
          locEnd
        } = require_loc();
        var {
          builders: {
            join: join2,
            hardline,
            group,
            indent,
            conditionalGroup,
            breakParent,
            label
          },
          utils: {
            willBreak
          }
        } = require_doc();
        var printCallArguments = require_call_arguments();
        var {
          printMemberLookup
        } = require_member();
        var {
          printOptionalToken,
          printFunctionTypeParameters,
          printBindExpressionCallee
        } = require_misc();
        function printMemberChain(path5, options, print) {
          const parent = path5.getParentNode();
          const isExpressionStatement = !parent || parent.type === "ExpressionStatement";
          const printedNodes = [];
          function shouldInsertEmptyLineAfter(node2) {
            const {
              originalText
            } = options;
            const nextCharIndex = getNextNonSpaceNonCommentCharacterIndex(originalText, node2, locEnd);
            const nextChar = originalText.charAt(nextCharIndex);
            if (nextChar === ")") {
              return nextCharIndex !== false && isNextLineEmptyAfterIndex(originalText, nextCharIndex + 1);
            }
            return isNextLineEmpty(node2, options);
          }
          function rec(path22) {
            const node2 = path22.getValue();
            if (isCallExpression(node2) && (isMemberish(node2.callee) || isCallExpression(node2.callee))) {
              printedNodes.unshift({
                node: node2,
                printed: [printComments(path22, [printOptionalToken(path22), printFunctionTypeParameters(path22, options, print), printCallArguments(path22, options, print)], options), shouldInsertEmptyLineAfter(node2) ? hardline : ""]
              });
              path22.call((callee) => rec(callee), "callee");
            } else if (isMemberish(node2)) {
              printedNodes.unshift({
                node: node2,
                needsParens: pathNeedsParens(path22, options),
                printed: printComments(path22, isMemberExpression(node2) ? printMemberLookup(path22, options, print) : printBindExpressionCallee(path22, options, print), options)
              });
              path22.call((object3) => rec(object3), "object");
            } else if (node2.type === "TSNonNullExpression") {
              printedNodes.unshift({
                node: node2,
                printed: printComments(path22, "!", options)
              });
              path22.call((expression) => rec(expression), "expression");
            } else {
              printedNodes.unshift({
                node: node2,
                printed: print()
              });
            }
          }
          const node = path5.getValue();
          printedNodes.unshift({
            node,
            printed: [printOptionalToken(path5), printFunctionTypeParameters(path5, options, print), printCallArguments(path5, options, print)]
          });
          if (node.callee) {
            path5.call((callee) => rec(callee), "callee");
          }
          const groups = [];
          let currentGroup = [printedNodes[0]];
          let i = 1;
          for (; i < printedNodes.length; ++i) {
            if (printedNodes[i].node.type === "TSNonNullExpression" || isCallExpression(printedNodes[i].node) || isMemberExpression(printedNodes[i].node) && printedNodes[i].node.computed && isNumericLiteral(printedNodes[i].node.property)) {
              currentGroup.push(printedNodes[i]);
            } else {
              break;
            }
          }
          if (!isCallExpression(printedNodes[0].node)) {
            for (; i + 1 < printedNodes.length; ++i) {
              if (isMemberish(printedNodes[i].node) && isMemberish(printedNodes[i + 1].node)) {
                currentGroup.push(printedNodes[i]);
              } else {
                break;
              }
            }
          }
          groups.push(currentGroup);
          currentGroup = [];
          let hasSeenCallExpression = false;
          for (; i < printedNodes.length; ++i) {
            if (hasSeenCallExpression && isMemberish(printedNodes[i].node)) {
              if (printedNodes[i].node.computed && isNumericLiteral(printedNodes[i].node.property)) {
                currentGroup.push(printedNodes[i]);
                continue;
              }
              groups.push(currentGroup);
              currentGroup = [];
              hasSeenCallExpression = false;
            }
            if (isCallExpression(printedNodes[i].node) || printedNodes[i].node.type === "ImportExpression") {
              hasSeenCallExpression = true;
            }
            currentGroup.push(printedNodes[i]);
            if (hasComment(printedNodes[i].node, CommentCheckFlags.Trailing)) {
              groups.push(currentGroup);
              currentGroup = [];
              hasSeenCallExpression = false;
            }
          }
          if (currentGroup.length > 0) {
            groups.push(currentGroup);
          }
          function isFactory(name) {
            return /^[A-Z]|^[$_]+$/.test(name);
          }
          function isShort(name) {
            return name.length <= options.tabWidth;
          }
          function shouldNotWrap(groups2) {
            const hasComputed = groups2[1].length > 0 && groups2[1][0].node.computed;
            if (groups2[0].length === 1) {
              const firstNode = groups2[0][0].node;
              return firstNode.type === "ThisExpression" || firstNode.type === "Identifier" && (isFactory(firstNode.name) || isExpressionStatement && isShort(firstNode.name) || hasComputed);
            }
            const lastNode = getLast(groups2[0]).node;
            return isMemberExpression(lastNode) && lastNode.property.type === "Identifier" && (isFactory(lastNode.property.name) || hasComputed);
          }
          const shouldMerge = groups.length >= 2 && !hasComment(groups[1][0].node) && shouldNotWrap(groups);
          function printGroup(printedGroup) {
            const printed = printedGroup.map((tuple) => tuple.printed);
            if (printedGroup.length > 0 && getLast(printedGroup).needsParens) {
              return ["(", ...printed, ")"];
            }
            return printed;
          }
          function printIndentedGroup(groups2) {
            if (groups2.length === 0) {
              return "";
            }
            return indent(group([hardline, join2(hardline, groups2.map(printGroup))]));
          }
          const printedGroups = groups.map(printGroup);
          const oneLine = printedGroups;
          const cutoff = shouldMerge ? 3 : 2;
          const flatGroups = groups.flat();
          const nodeHasComment = flatGroups.slice(1, -1).some((node2) => hasComment(node2.node, CommentCheckFlags.Leading)) || flatGroups.slice(0, -1).some((node2) => hasComment(node2.node, CommentCheckFlags.Trailing)) || groups[cutoff] && hasComment(groups[cutoff][0].node, CommentCheckFlags.Leading);
          if (groups.length <= cutoff && !nodeHasComment) {
            if (isLongCurriedCallExpression(path5)) {
              return oneLine;
            }
            return group(oneLine);
          }
          const lastNodeBeforeIndent = getLast(groups[shouldMerge ? 1 : 0]).node;
          const shouldHaveEmptyLineBeforeIndent = !isCallExpression(lastNodeBeforeIndent) && shouldInsertEmptyLineAfter(lastNodeBeforeIndent);
          const expanded = [printGroup(groups[0]), shouldMerge ? groups.slice(1, 2).map(printGroup) : "", shouldHaveEmptyLineBeforeIndent ? hardline : "", printIndentedGroup(groups.slice(shouldMerge ? 2 : 1))];
          const callExpressions = printedNodes.map(({
            node: node2
          }) => node2).filter(isCallExpression);
          function lastGroupWillBreakAndOtherCallsHaveFunctionArguments() {
            const lastGroupNode = getLast(getLast(groups)).node;
            const lastGroupDoc = getLast(printedGroups);
            return isCallExpression(lastGroupNode) && willBreak(lastGroupDoc) && callExpressions.slice(0, -1).some((node2) => node2.arguments.some(isFunctionOrArrowExpression));
          }
          let result;
          if (nodeHasComment || callExpressions.length > 2 && callExpressions.some((expr) => !expr.arguments.every((arg) => isSimpleCallArgument(arg, 0))) || printedGroups.slice(0, -1).some(willBreak) || lastGroupWillBreakAndOtherCallsHaveFunctionArguments()) {
            result = group(expanded);
          } else {
            result = [willBreak(oneLine) || shouldHaveEmptyLineBeforeIndent ? breakParent : "", conditionalGroup([oneLine, expanded])];
          }
          return label("member-chain", result);
        }
        module22.exports = printMemberChain;
      }
    });
    var require_call_expression = __commonJS22({
      "src/language-js/print/call-expression.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            join: join2,
            group
          }
        } = require_doc();
        var pathNeedsParens = require_needs_parens();
        var {
          getCallArguments,
          hasFlowAnnotationComment,
          isCallExpression,
          isMemberish,
          isStringLiteral,
          isTemplateOnItsOwnLine,
          isTestCall,
          iterateCallArgumentsPath
        } = require_utils72();
        var printMemberChain = require_member_chain();
        var printCallArguments = require_call_arguments();
        var {
          printOptionalToken,
          printFunctionTypeParameters
        } = require_misc();
        function printCallExpression(path5, options, print) {
          const node = path5.getValue();
          const parentNode = path5.getParentNode();
          const isNew = node.type === "NewExpression";
          const isDynamicImport = node.type === "ImportExpression";
          const optional3 = printOptionalToken(path5);
          const args = getCallArguments(node);
          if (args.length > 0 && (!isDynamicImport && !isNew && isCommonsJsOrAmdCall(node, parentNode) || args.length === 1 && isTemplateOnItsOwnLine(args[0], options.originalText) || !isNew && isTestCall(node, parentNode))) {
            const printed = [];
            iterateCallArgumentsPath(path5, () => {
              printed.push(print());
            });
            return [isNew ? "new " : "", print("callee"), optional3, printFunctionTypeParameters(path5, options, print), "(", join2(", ", printed), ")"];
          }
          const isIdentifierWithFlowAnnotation = (options.parser === "babel" || options.parser === "babel-flow") && node.callee && node.callee.type === "Identifier" && hasFlowAnnotationComment(node.callee.trailingComments);
          if (isIdentifierWithFlowAnnotation) {
            node.callee.trailingComments[0].printed = true;
          }
          if (!isDynamicImport && !isNew && isMemberish(node.callee) && !path5.call((path22) => pathNeedsParens(path22, options), "callee")) {
            return printMemberChain(path5, options, print);
          }
          const contents = [isNew ? "new " : "", isDynamicImport ? "import" : print("callee"), optional3, isIdentifierWithFlowAnnotation ? `/*:: ${node.callee.trailingComments[0].value.slice(2).trim()} */` : "", printFunctionTypeParameters(path5, options, print), printCallArguments(path5, options, print)];
          if (isDynamicImport || isCallExpression(node.callee)) {
            return group(contents);
          }
          return contents;
        }
        function isCommonsJsOrAmdCall(node, parentNode) {
          if (node.callee.type !== "Identifier") {
            return false;
          }
          if (node.callee.name === "require") {
            return true;
          }
          if (node.callee.name === "define") {
            const args = getCallArguments(node);
            return parentNode.type === "ExpressionStatement" && (args.length === 1 || args.length === 2 && args[0].type === "ArrayExpression" || args.length === 3 && isStringLiteral(args[0]) && args[1].type === "ArrayExpression");
          }
          return false;
        }
        module22.exports = {
          printCallExpression
        };
      }
    });
    var require_assignment = __commonJS22({
      "src/language-js/print/assignment.js"(exports22, module22) {
        "use strict";
        var {
          isNonEmptyArray,
          getStringWidth
        } = require_util2();
        var {
          builders: {
            line,
            group,
            indent,
            indentIfBreak,
            lineSuffixBoundary
          },
          utils: {
            cleanDoc,
            willBreak,
            canBreak
          }
        } = require_doc();
        var {
          hasLeadingOwnLineComment,
          isBinaryish,
          isStringLiteral,
          isLiteral,
          isNumericLiteral,
          isCallExpression,
          isMemberExpression,
          getCallArguments,
          rawText,
          hasComment,
          isSignedNumericLiteral,
          isObjectProperty
        } = require_utils72();
        var {
          shouldInlineLogicalExpression
        } = require_binaryish();
        var {
          printCallExpression
        } = require_call_expression();
        function printAssignment(path5, options, print, leftDoc, operator, rightPropertyName) {
          const layout = chooseLayout(path5, options, print, leftDoc, rightPropertyName);
          const rightDoc = print(rightPropertyName, {
            assignmentLayout: layout
          });
          switch (layout) {
            case "break-after-operator":
              return group([group(leftDoc), operator, group(indent([line, rightDoc]))]);
            case "never-break-after-operator":
              return group([group(leftDoc), operator, " ", rightDoc]);
            case "fluid": {
              const groupId = Symbol("assignment");
              return group([group(leftDoc), operator, group(indent(line), {
                id: groupId
              }), lineSuffixBoundary, indentIfBreak(rightDoc, {
                groupId
              })]);
            }
            case "break-lhs":
              return group([leftDoc, operator, " ", group(rightDoc)]);
            case "chain":
              return [group(leftDoc), operator, line, rightDoc];
            case "chain-tail":
              return [group(leftDoc), operator, indent([line, rightDoc])];
            case "chain-tail-arrow-chain":
              return [group(leftDoc), operator, rightDoc];
            case "only-left":
              return leftDoc;
          }
        }
        function printAssignmentExpression(path5, options, print) {
          const node = path5.getValue();
          return printAssignment(path5, options, print, print("left"), [" ", node.operator], "right");
        }
        function printVariableDeclarator(path5, options, print) {
          return printAssignment(path5, options, print, print("id"), " =", "init");
        }
        function chooseLayout(path5, options, print, leftDoc, rightPropertyName) {
          const node = path5.getValue();
          const rightNode = node[rightPropertyName];
          if (!rightNode) {
            return "only-left";
          }
          const isTail = !isAssignment(rightNode);
          const shouldUseChainFormatting = path5.match(isAssignment, isAssignmentOrVariableDeclarator, (node2) => !isTail || node2.type !== "ExpressionStatement" && node2.type !== "VariableDeclaration");
          if (shouldUseChainFormatting) {
            return !isTail ? "chain" : rightNode.type === "ArrowFunctionExpression" && rightNode.body.type === "ArrowFunctionExpression" ? "chain-tail-arrow-chain" : "chain-tail";
          }
          const isHeadOfLongChain = !isTail && isAssignment(rightNode.right);
          if (isHeadOfLongChain || hasLeadingOwnLineComment(options.originalText, rightNode)) {
            return "break-after-operator";
          }
          if (rightNode.type === "CallExpression" && rightNode.callee.name === "require" || options.parser === "json5" || options.parser === "json") {
            return "never-break-after-operator";
          }
          if (isComplexDestructuring(node) || isComplexTypeAliasParams(node) || hasComplexTypeAnnotation(node) || isArrowFunctionVariableDeclarator(node) && canBreak(leftDoc)) {
            return "break-lhs";
          }
          const hasShortKey = isObjectPropertyWithShortKey(node, leftDoc, options);
          if (path5.call(() => shouldBreakAfterOperator(path5, options, print, hasShortKey), rightPropertyName)) {
            return "break-after-operator";
          }
          if (hasShortKey || rightNode.type === "TemplateLiteral" || rightNode.type === "TaggedTemplateExpression" || rightNode.type === "BooleanLiteral" || isNumericLiteral(rightNode) || rightNode.type === "ClassExpression") {
            return "never-break-after-operator";
          }
          return "fluid";
        }
        function shouldBreakAfterOperator(path5, options, print, hasShortKey) {
          const rightNode = path5.getValue();
          if (isBinaryish(rightNode) && !shouldInlineLogicalExpression(rightNode)) {
            return true;
          }
          switch (rightNode.type) {
            case "StringLiteralTypeAnnotation":
            case "SequenceExpression":
              return true;
            case "ConditionalExpression": {
              const {
                test
              } = rightNode;
              return isBinaryish(test) && !shouldInlineLogicalExpression(test);
            }
            case "ClassExpression":
              return isNonEmptyArray(rightNode.decorators);
          }
          if (hasShortKey) {
            return false;
          }
          let node = rightNode;
          const propertiesForPath = [];
          for (; ; ) {
            if (node.type === "UnaryExpression") {
              node = node.argument;
              propertiesForPath.push("argument");
            } else if (node.type === "TSNonNullExpression") {
              node = node.expression;
              propertiesForPath.push("expression");
            } else {
              break;
            }
          }
          if (isStringLiteral(node) || path5.call(() => isPoorlyBreakableMemberOrCallChain(path5, options, print), ...propertiesForPath)) {
            return true;
          }
          return false;
        }
        function isComplexDestructuring(node) {
          if (isAssignmentOrVariableDeclarator(node)) {
            const leftNode = node.left || node.id;
            return leftNode.type === "ObjectPattern" && leftNode.properties.length > 2 && leftNode.properties.some((property4) => isObjectProperty(property4) && (!property4.shorthand || property4.value && property4.value.type === "AssignmentPattern"));
          }
          return false;
        }
        function isAssignment(node) {
          return node.type === "AssignmentExpression";
        }
        function isAssignmentOrVariableDeclarator(node) {
          return isAssignment(node) || node.type === "VariableDeclarator";
        }
        function isComplexTypeAliasParams(node) {
          const typeParams = getTypeParametersFromTypeAlias(node);
          if (isNonEmptyArray(typeParams)) {
            const constraintPropertyName = node.type === "TSTypeAliasDeclaration" ? "constraint" : "bound";
            if (typeParams.length > 1 && typeParams.some((param) => param[constraintPropertyName] || param.default)) {
              return true;
            }
          }
          return false;
        }
        function getTypeParametersFromTypeAlias(node) {
          if (isTypeAlias(node) && node.typeParameters && node.typeParameters.params) {
            return node.typeParameters.params;
          }
          return null;
        }
        function isTypeAlias(node) {
          return node.type === "TSTypeAliasDeclaration" || node.type === "TypeAlias";
        }
        function hasComplexTypeAnnotation(node) {
          if (node.type !== "VariableDeclarator") {
            return false;
          }
          const {
            typeAnnotation
          } = node.id;
          if (!typeAnnotation || !typeAnnotation.typeAnnotation) {
            return false;
          }
          const typeParams = getTypeParametersFromTypeReference(typeAnnotation.typeAnnotation);
          return isNonEmptyArray(typeParams) && typeParams.length > 1 && typeParams.some((param) => isNonEmptyArray(getTypeParametersFromTypeReference(param)) || param.type === "TSConditionalType");
        }
        function isArrowFunctionVariableDeclarator(node) {
          return node.type === "VariableDeclarator" && node.init && node.init.type === "ArrowFunctionExpression";
        }
        function getTypeParametersFromTypeReference(node) {
          if (isTypeReference(node) && node.typeParameters && node.typeParameters.params) {
            return node.typeParameters.params;
          }
          return null;
        }
        function isTypeReference(node) {
          return node.type === "TSTypeReference" || node.type === "GenericTypeAnnotation";
        }
        function isPoorlyBreakableMemberOrCallChain(path5, options, print, deep = false) {
          const node = path5.getValue();
          const goDeeper = () => isPoorlyBreakableMemberOrCallChain(path5, options, print, true);
          if (node.type === "TSNonNullExpression") {
            return path5.call(goDeeper, "expression");
          }
          if (isCallExpression(node)) {
            const doc2 = printCallExpression(path5, options, print);
            if (doc2.label === "member-chain") {
              return false;
            }
            const args = getCallArguments(node);
            const isPoorlyBreakableCall = args.length === 0 || args.length === 1 && isLoneShortArgument(args[0], options);
            if (!isPoorlyBreakableCall) {
              return false;
            }
            if (isCallExpressionWithComplexTypeArguments(node, print)) {
              return false;
            }
            return path5.call(goDeeper, "callee");
          }
          if (isMemberExpression(node)) {
            return path5.call(goDeeper, "object");
          }
          return deep && (node.type === "Identifier" || node.type === "ThisExpression");
        }
        var LONE_SHORT_ARGUMENT_THRESHOLD_RATE = 0.25;
        function isLoneShortArgument(node, {
          printWidth
        }) {
          if (hasComment(node)) {
            return false;
          }
          const threshold = printWidth * LONE_SHORT_ARGUMENT_THRESHOLD_RATE;
          if (node.type === "ThisExpression" || node.type === "Identifier" && node.name.length <= threshold || isSignedNumericLiteral(node) && !hasComment(node.argument)) {
            return true;
          }
          const regexpPattern = node.type === "Literal" && "regex" in node && node.regex.pattern || node.type === "RegExpLiteral" && node.pattern;
          if (regexpPattern) {
            return regexpPattern.length <= threshold;
          }
          if (isStringLiteral(node)) {
            return rawText(node).length <= threshold;
          }
          if (node.type === "TemplateLiteral") {
            return node.expressions.length === 0 && node.quasis[0].value.raw.length <= threshold && !node.quasis[0].value.raw.includes("\n");
          }
          return isLiteral(node);
        }
        function isObjectPropertyWithShortKey(node, keyDoc, options) {
          if (!isObjectProperty(node)) {
            return false;
          }
          keyDoc = cleanDoc(keyDoc);
          const MIN_OVERLAP_FOR_BREAK = 3;
          return typeof keyDoc === "string" && getStringWidth(keyDoc) < options.tabWidth + MIN_OVERLAP_FOR_BREAK;
        }
        function isCallExpressionWithComplexTypeArguments(node, print) {
          const typeArgs = getTypeArgumentsFromCallExpression(node);
          if (isNonEmptyArray(typeArgs)) {
            if (typeArgs.length > 1) {
              return true;
            }
            if (typeArgs.length === 1) {
              const firstArg = typeArgs[0];
              if (firstArg.type === "TSUnionType" || firstArg.type === "UnionTypeAnnotation" || firstArg.type === "TSIntersectionType" || firstArg.type === "IntersectionTypeAnnotation" || firstArg.type === "TSTypeLiteral" || firstArg.type === "ObjectTypeAnnotation") {
                return true;
              }
            }
            const typeArgsKeyName = node.typeParameters ? "typeParameters" : "typeArguments";
            if (willBreak(print(typeArgsKeyName))) {
              return true;
            }
          }
          return false;
        }
        function getTypeArgumentsFromCallExpression(node) {
          return node.typeParameters && node.typeParameters.params || node.typeArguments && node.typeArguments.params;
        }
        module22.exports = {
          printVariableDeclarator,
          printAssignmentExpression,
          printAssignment,
          isArrowFunctionVariableDeclarator
        };
      }
    });
    var require_function_parameters = __commonJS22({
      "src/language-js/print/function-parameters.js"(exports22, module22) {
        "use strict";
        var {
          getNextNonSpaceNonCommentCharacter
        } = require_util2();
        var {
          printDanglingComments
        } = require_comments();
        var {
          builders: {
            line,
            hardline,
            softline,
            group,
            indent,
            ifBreak
          },
          utils: {
            removeLines,
            willBreak
          }
        } = require_doc();
        var {
          getFunctionParameters,
          iterateFunctionParametersPath,
          isSimpleType,
          isTestCall,
          isTypeAnnotationAFunction,
          isObjectType,
          isObjectTypePropertyAFunction,
          hasRestParameter,
          shouldPrintComma,
          hasComment,
          isNextLineEmpty
        } = require_utils72();
        var {
          locEnd
        } = require_loc();
        var {
          ArgExpansionBailout
        } = require_errors3();
        var {
          printFunctionTypeParameters
        } = require_misc();
        function printFunctionParameters(path5, print, options, expandArg, printTypeParams) {
          const functionNode = path5.getValue();
          const parameters = getFunctionParameters(functionNode);
          const typeParams = printTypeParams ? printFunctionTypeParameters(path5, options, print) : "";
          if (parameters.length === 0) {
            return [typeParams, "(", printDanglingComments(path5, options, true, (comment) => getNextNonSpaceNonCommentCharacter(options.originalText, comment, locEnd) === ")"), ")"];
          }
          const parent = path5.getParentNode();
          const isParametersInTestCall = isTestCall(parent);
          const shouldHugParameters = shouldHugFunctionParameters(functionNode);
          const printed = [];
          iterateFunctionParametersPath(path5, (parameterPath, index) => {
            const isLastParameter = index === parameters.length - 1;
            if (isLastParameter && functionNode.rest) {
              printed.push("...");
            }
            printed.push(print());
            if (isLastParameter) {
              return;
            }
            printed.push(",");
            if (isParametersInTestCall || shouldHugParameters) {
              printed.push(" ");
            } else if (isNextLineEmpty(parameters[index], options)) {
              printed.push(hardline, hardline);
            } else {
              printed.push(line);
            }
          });
          if (expandArg) {
            if (willBreak(typeParams) || willBreak(printed)) {
              throw new ArgExpansionBailout();
            }
            return group([removeLines(typeParams), "(", removeLines(printed), ")"]);
          }
          const hasNotParameterDecorator = parameters.every((node) => !node.decorators);
          if (shouldHugParameters && hasNotParameterDecorator) {
            return [typeParams, "(", ...printed, ")"];
          }
          if (isParametersInTestCall) {
            return [typeParams, "(", ...printed, ")"];
          }
          const isFlowShorthandWithOneArg = (isObjectTypePropertyAFunction(parent) || isTypeAnnotationAFunction(parent) || parent.type === "TypeAlias" || parent.type === "UnionTypeAnnotation" || parent.type === "TSUnionType" || parent.type === "IntersectionTypeAnnotation" || parent.type === "FunctionTypeAnnotation" && parent.returnType === functionNode) && parameters.length === 1 && parameters[0].name === null && functionNode.this !== parameters[0] && parameters[0].typeAnnotation && functionNode.typeParameters === null && isSimpleType(parameters[0].typeAnnotation) && !functionNode.rest;
          if (isFlowShorthandWithOneArg) {
            if (options.arrowParens === "always") {
              return ["(", ...printed, ")"];
            }
            return printed;
          }
          return [typeParams, "(", indent([softline, ...printed]), ifBreak(!hasRestParameter(functionNode) && shouldPrintComma(options, "all") ? "," : ""), softline, ")"];
        }
        function shouldHugFunctionParameters(node) {
          if (!node) {
            return false;
          }
          const parameters = getFunctionParameters(node);
          if (parameters.length !== 1) {
            return false;
          }
          const [parameter] = parameters;
          return !hasComment(parameter) && (parameter.type === "ObjectPattern" || parameter.type === "ArrayPattern" || parameter.type === "Identifier" && parameter.typeAnnotation && (parameter.typeAnnotation.type === "TypeAnnotation" || parameter.typeAnnotation.type === "TSTypeAnnotation") && isObjectType(parameter.typeAnnotation.typeAnnotation) || parameter.type === "FunctionTypeParam" && isObjectType(parameter.typeAnnotation) || parameter.type === "AssignmentPattern" && (parameter.left.type === "ObjectPattern" || parameter.left.type === "ArrayPattern") && (parameter.right.type === "Identifier" || parameter.right.type === "ObjectExpression" && parameter.right.properties.length === 0 || parameter.right.type === "ArrayExpression" && parameter.right.elements.length === 0));
        }
        function getReturnTypeNode(functionNode) {
          let returnTypeNode;
          if (functionNode.returnType) {
            returnTypeNode = functionNode.returnType;
            if (returnTypeNode.typeAnnotation) {
              returnTypeNode = returnTypeNode.typeAnnotation;
            }
          } else if (functionNode.typeAnnotation) {
            returnTypeNode = functionNode.typeAnnotation;
          }
          return returnTypeNode;
        }
        function shouldGroupFunctionParameters(functionNode, returnTypeDoc) {
          const returnTypeNode = getReturnTypeNode(functionNode);
          if (!returnTypeNode) {
            return false;
          }
          const typeParameters = functionNode.typeParameters && functionNode.typeParameters.params;
          if (typeParameters) {
            if (typeParameters.length > 1) {
              return false;
            }
            if (typeParameters.length === 1) {
              const typeParameter = typeParameters[0];
              if (typeParameter.constraint || typeParameter.default) {
                return false;
              }
            }
          }
          return getFunctionParameters(functionNode).length === 1 && (isObjectType(returnTypeNode) || willBreak(returnTypeDoc));
        }
        module22.exports = {
          printFunctionParameters,
          shouldHugFunctionParameters,
          shouldGroupFunctionParameters
        };
      }
    });
    var require_type_annotation = __commonJS22({
      "src/language-js/print/type-annotation.js"(exports22, module22) {
        "use strict";
        var {
          printComments,
          printDanglingComments
        } = require_comments();
        var {
          isNonEmptyArray
        } = require_util2();
        var {
          builders: {
            group,
            join: join2,
            line,
            softline,
            indent,
            align,
            ifBreak
          }
        } = require_doc();
        var pathNeedsParens = require_needs_parens();
        var {
          locStart
        } = require_loc();
        var {
          isSimpleType,
          isObjectType,
          hasLeadingOwnLineComment,
          isObjectTypePropertyAFunction,
          shouldPrintComma
        } = require_utils72();
        var {
          printAssignment
        } = require_assignment();
        var {
          printFunctionParameters,
          shouldGroupFunctionParameters
        } = require_function_parameters();
        var {
          printArrayItems
        } = require_array4();
        function shouldHugType(node) {
          if (isSimpleType(node) || isObjectType(node)) {
            return true;
          }
          if (node.type === "UnionTypeAnnotation" || node.type === "TSUnionType") {
            const voidCount = node.types.filter((node2) => node2.type === "VoidTypeAnnotation" || node2.type === "TSVoidKeyword" || node2.type === "NullLiteralTypeAnnotation" || node2.type === "TSNullKeyword").length;
            const hasObject = node.types.some((node2) => node2.type === "ObjectTypeAnnotation" || node2.type === "TSTypeLiteral" || node2.type === "GenericTypeAnnotation" || node2.type === "TSTypeReference");
            if (node.types.length - 1 === voidCount && hasObject) {
              return true;
            }
          }
          return false;
        }
        function printOpaqueType(path5, options, print) {
          const semi = options.semi ? ";" : "";
          const node = path5.getValue();
          const parts = [];
          parts.push("opaque type ", print("id"), print("typeParameters"));
          if (node.supertype) {
            parts.push(": ", print("supertype"));
          }
          if (node.impltype) {
            parts.push(" = ", print("impltype"));
          }
          parts.push(semi);
          return parts;
        }
        function printTypeAlias(path5, options, print) {
          const semi = options.semi ? ";" : "";
          const node = path5.getValue();
          const parts = [];
          if (node.declare) {
            parts.push("declare ");
          }
          parts.push("type ", print("id"), print("typeParameters"));
          const rightPropertyName = node.type === "TSTypeAliasDeclaration" ? "typeAnnotation" : "right";
          return [printAssignment(path5, options, print, parts, " =", rightPropertyName), semi];
        }
        function printIntersectionType(path5, options, print) {
          const node = path5.getValue();
          const types2 = path5.map(print, "types");
          const result = [];
          let wasIndented = false;
          for (let i = 0; i < types2.length; ++i) {
            if (i === 0) {
              result.push(types2[i]);
            } else if (isObjectType(node.types[i - 1]) && isObjectType(node.types[i])) {
              result.push([" & ", wasIndented ? indent(types2[i]) : types2[i]]);
            } else if (!isObjectType(node.types[i - 1]) && !isObjectType(node.types[i])) {
              result.push(indent([" &", line, types2[i]]));
            } else {
              if (i > 1) {
                wasIndented = true;
              }
              result.push(" & ", i > 1 ? indent(types2[i]) : types2[i]);
            }
          }
          return group(result);
        }
        function printUnionType(path5, options, print) {
          const node = path5.getValue();
          const parent = path5.getParentNode();
          const shouldIndent = parent.type !== "TypeParameterInstantiation" && parent.type !== "TSTypeParameterInstantiation" && parent.type !== "GenericTypeAnnotation" && parent.type !== "TSTypeReference" && parent.type !== "TSTypeAssertion" && parent.type !== "TupleTypeAnnotation" && parent.type !== "TSTupleType" && !(parent.type === "FunctionTypeParam" && !parent.name && path5.getParentNode(1).this !== parent) && !((parent.type === "TypeAlias" || parent.type === "VariableDeclarator" || parent.type === "TSTypeAliasDeclaration") && hasLeadingOwnLineComment(options.originalText, node));
          const shouldHug = shouldHugType(node);
          const printed = path5.map((typePath) => {
            let printedType = print();
            if (!shouldHug) {
              printedType = align(2, printedType);
            }
            return printComments(typePath, printedType, options);
          }, "types");
          if (shouldHug) {
            return join2(" | ", printed);
          }
          const shouldAddStartLine = shouldIndent && !hasLeadingOwnLineComment(options.originalText, node);
          const code = [ifBreak([shouldAddStartLine ? line : "", "| "]), join2([line, "| "], printed)];
          if (pathNeedsParens(path5, options)) {
            return group([indent(code), softline]);
          }
          if (parent.type === "TupleTypeAnnotation" && parent.types.length > 1 || parent.type === "TSTupleType" && parent.elementTypes.length > 1) {
            return group([indent([ifBreak(["(", softline]), code]), softline, ifBreak(")")]);
          }
          return group(shouldIndent ? indent(code) : code);
        }
        function printFunctionType(path5, options, print) {
          const node = path5.getValue();
          const parts = [];
          const parent = path5.getParentNode(0);
          const parentParent = path5.getParentNode(1);
          const parentParentParent = path5.getParentNode(2);
          let isArrowFunctionTypeAnnotation = node.type === "TSFunctionType" || !((parent.type === "ObjectTypeProperty" || parent.type === "ObjectTypeInternalSlot") && !parent.variance && !parent.optional && locStart(parent) === locStart(node) || parent.type === "ObjectTypeCallProperty" || parentParentParent && parentParentParent.type === "DeclareFunction");
          let needsColon = isArrowFunctionTypeAnnotation && (parent.type === "TypeAnnotation" || parent.type === "TSTypeAnnotation");
          const needsParens = needsColon && isArrowFunctionTypeAnnotation && (parent.type === "TypeAnnotation" || parent.type === "TSTypeAnnotation") && parentParent.type === "ArrowFunctionExpression";
          if (isObjectTypePropertyAFunction(parent)) {
            isArrowFunctionTypeAnnotation = true;
            needsColon = true;
          }
          if (needsParens) {
            parts.push("(");
          }
          const parametersDoc = printFunctionParameters(path5, print, options, false, true);
          const returnTypeDoc = node.returnType || node.predicate || node.typeAnnotation ? [isArrowFunctionTypeAnnotation ? " => " : ": ", print("returnType"), print("predicate"), print("typeAnnotation")] : "";
          const shouldGroupParameters = shouldGroupFunctionParameters(node, returnTypeDoc);
          parts.push(shouldGroupParameters ? group(parametersDoc) : parametersDoc);
          if (returnTypeDoc) {
            parts.push(returnTypeDoc);
          }
          if (needsParens) {
            parts.push(")");
          }
          return group(parts);
        }
        function printTupleType(path5, options, print) {
          const node = path5.getValue();
          const typesField = node.type === "TSTupleType" ? "elementTypes" : "types";
          const types2 = node[typesField];
          const isNonEmptyTuple = isNonEmptyArray(types2);
          const bracketsDelimiterLine = isNonEmptyTuple ? softline : "";
          return group(["[", indent([bracketsDelimiterLine, printArrayItems(path5, options, typesField, print)]), ifBreak(isNonEmptyTuple && shouldPrintComma(options, "all") ? "," : ""), printDanglingComments(path5, options, true), bracketsDelimiterLine, "]"]);
        }
        function printIndexedAccessType(path5, options, print) {
          const node = path5.getValue();
          const leftDelimiter = node.type === "OptionalIndexedAccessType" && node.optional ? "?.[" : "[";
          return [print("objectType"), leftDelimiter, print("indexType"), "]"];
        }
        function printJSDocType(path5, print, token) {
          const node = path5.getValue();
          return [node.postfix ? "" : token, print("typeAnnotation"), node.postfix ? token : ""];
        }
        module22.exports = {
          printOpaqueType,
          printTypeAlias,
          printIntersectionType,
          printUnionType,
          printFunctionType,
          printTupleType,
          printIndexedAccessType,
          shouldHugType,
          printJSDocType
        };
      }
    });
    var require_type_parameters = __commonJS22({
      "src/language-js/print/type-parameters.js"(exports22, module22) {
        "use strict";
        var {
          printDanglingComments
        } = require_comments();
        var {
          builders: {
            join: join2,
            line,
            hardline,
            softline,
            group,
            indent,
            ifBreak
          }
        } = require_doc();
        var {
          isTestCall,
          hasComment,
          CommentCheckFlags,
          isTSXFile,
          shouldPrintComma,
          getFunctionParameters,
          isObjectType
        } = require_utils72();
        var {
          createGroupIdMapper
        } = require_util2();
        var {
          shouldHugType
        } = require_type_annotation();
        var {
          isArrowFunctionVariableDeclarator
        } = require_assignment();
        var getTypeParametersGroupId = createGroupIdMapper("typeParameters");
        function printTypeParameters(path5, options, print, paramsKey) {
          const node = path5.getValue();
          if (!node[paramsKey]) {
            return "";
          }
          if (!Array.isArray(node[paramsKey])) {
            return print(paramsKey);
          }
          const grandparent = path5.getNode(2);
          const isParameterInTestCall = grandparent && isTestCall(grandparent);
          const isArrowFunctionVariable = path5.match((node2) => !(node2[paramsKey].length === 1 && isObjectType(node2[paramsKey][0])), void 0, (node2, name) => name === "typeAnnotation", (node2) => node2.type === "Identifier", isArrowFunctionVariableDeclarator);
          const shouldInline = !isArrowFunctionVariable && (isParameterInTestCall || node[paramsKey].length === 0 || node[paramsKey].length === 1 && (node[paramsKey][0].type === "NullableTypeAnnotation" || shouldHugType(node[paramsKey][0])));
          if (shouldInline) {
            return ["<", join2(", ", path5.map(print, paramsKey)), printDanglingCommentsForInline(path5, options), ">"];
          }
          const trailingComma = node.type === "TSTypeParameterInstantiation" ? "" : getFunctionParameters(node).length === 1 && isTSXFile(options) && !node[paramsKey][0].constraint && path5.getParentNode().type === "ArrowFunctionExpression" ? "," : shouldPrintComma(options, "all") ? ifBreak(",") : "";
          return group(["<", indent([softline, join2([",", line], path5.map(print, paramsKey))]), trailingComma, softline, ">"], {
            id: getTypeParametersGroupId(node)
          });
        }
        function printDanglingCommentsForInline(path5, options) {
          const node = path5.getValue();
          if (!hasComment(node, CommentCheckFlags.Dangling)) {
            return "";
          }
          const hasOnlyBlockComments = !hasComment(node, CommentCheckFlags.Line);
          const printed = printDanglingComments(path5, options, hasOnlyBlockComments);
          if (hasOnlyBlockComments) {
            return printed;
          }
          return [printed, hardline];
        }
        function printTypeParameter(path5, options, print) {
          const node = path5.getValue();
          const parts = [];
          const parent = path5.getParentNode();
          if (parent.type === "TSMappedType") {
            parts.push("[", print("name"));
            if (node.constraint) {
              parts.push(" in ", print("constraint"));
            }
            if (parent.nameType) {
              parts.push(" as ", path5.callParent(() => print("nameType")));
            }
            parts.push("]");
            return parts;
          }
          if (node.variance) {
            parts.push(print("variance"));
          }
          if (node.in) {
            parts.push("in ");
          }
          if (node.out) {
            parts.push("out ");
          }
          parts.push(print("name"));
          if (node.bound) {
            parts.push(": ", print("bound"));
          }
          if (node.constraint) {
            parts.push(" extends ", print("constraint"));
          }
          if (node.default) {
            parts.push(" = ", print("default"));
          }
          return parts;
        }
        module22.exports = {
          printTypeParameter,
          printTypeParameters,
          getTypeParametersGroupId
        };
      }
    });
    var require_property = __commonJS22({
      "src/language-js/print/property.js"(exports22, module22) {
        "use strict";
        var {
          printComments
        } = require_comments();
        var {
          printString,
          printNumber
        } = require_util2();
        var {
          isNumericLiteral,
          isSimpleNumber,
          isStringLiteral,
          isStringPropSafeToUnquote,
          rawText
        } = require_utils72();
        var {
          printAssignment
        } = require_assignment();
        var needsQuoteProps = /* @__PURE__ */ new WeakMap();
        function printPropertyKey(path5, options, print) {
          const node = path5.getNode();
          if (node.computed) {
            return ["[", print("key"), "]"];
          }
          const parent = path5.getParentNode();
          const {
            key
          } = node;
          if (node.type === "ClassPrivateProperty" && key.type === "Identifier") {
            return ["#", print("key")];
          }
          if (options.quoteProps === "consistent" && !needsQuoteProps.has(parent)) {
            const objectHasStringProp = (parent.properties || parent.body || parent.members).some((prop) => !prop.computed && prop.key && isStringLiteral(prop.key) && !isStringPropSafeToUnquote(prop, options));
            needsQuoteProps.set(parent, objectHasStringProp);
          }
          if ((key.type === "Identifier" || isNumericLiteral(key) && isSimpleNumber(printNumber(rawText(key))) && String(key.value) === printNumber(rawText(key)) && !(options.parser === "typescript" || options.parser === "babel-ts")) && (options.parser === "json" || options.quoteProps === "consistent" && needsQuoteProps.get(parent))) {
            const prop = printString(JSON.stringify(key.type === "Identifier" ? key.name : key.value.toString()), options);
            return path5.call((keyPath) => printComments(keyPath, prop, options), "key");
          }
          if (isStringPropSafeToUnquote(node, options) && (options.quoteProps === "as-needed" || options.quoteProps === "consistent" && !needsQuoteProps.get(parent))) {
            return path5.call((keyPath) => printComments(keyPath, /^\d/.test(key.value) ? printNumber(key.value) : key.value, options), "key");
          }
          return print("key");
        }
        function printProperty(path5, options, print) {
          const node = path5.getValue();
          if (node.shorthand) {
            return print("value");
          }
          return printAssignment(path5, options, print, printPropertyKey(path5, options, print), ":", "value");
        }
        module22.exports = {
          printProperty,
          printPropertyKey
        };
      }
    });
    var require_function = __commonJS22({
      "src/language-js/print/function.js"(exports22, module22) {
        "use strict";
        var assert = require("assert");
        var {
          printDanglingComments,
          printCommentsSeparately
        } = require_comments();
        var getLast = require_get_last();
        var {
          getNextNonSpaceNonCommentCharacterIndex
        } = require_util2();
        var {
          builders: {
            line,
            softline,
            group,
            indent,
            ifBreak,
            hardline,
            join: join2,
            indentIfBreak
          },
          utils: {
            removeLines,
            willBreak
          }
        } = require_doc();
        var {
          ArgExpansionBailout
        } = require_errors3();
        var {
          getFunctionParameters,
          hasLeadingOwnLineComment,
          isFlowAnnotationComment,
          isJsxNode,
          isTemplateOnItsOwnLine,
          shouldPrintComma,
          startsWithNoLookaheadToken,
          isBinaryish,
          isLineComment,
          hasComment,
          getComments,
          CommentCheckFlags,
          isCallLikeExpression,
          isCallExpression,
          getCallArguments,
          hasNakedLeftSide,
          getLeftSide
        } = require_utils72();
        var {
          locEnd
        } = require_loc();
        var {
          printFunctionParameters,
          shouldGroupFunctionParameters
        } = require_function_parameters();
        var {
          printPropertyKey
        } = require_property();
        var {
          printFunctionTypeParameters
        } = require_misc();
        function printFunction(path5, print, options, args) {
          const node = path5.getValue();
          let expandArg = false;
          if ((node.type === "FunctionDeclaration" || node.type === "FunctionExpression") && args && args.expandLastArg) {
            const parent = path5.getParentNode();
            if (isCallExpression(parent) && getCallArguments(parent).length > 1) {
              expandArg = true;
            }
          }
          const parts = [];
          if (node.type === "TSDeclareFunction" && node.declare) {
            parts.push("declare ");
          }
          if (node.async) {
            parts.push("async ");
          }
          if (node.generator) {
            parts.push("function* ");
          } else {
            parts.push("function ");
          }
          if (node.id) {
            parts.push(print("id"));
          }
          const parametersDoc = printFunctionParameters(path5, print, options, expandArg);
          const returnTypeDoc = printReturnType(path5, print, options);
          const shouldGroupParameters = shouldGroupFunctionParameters(node, returnTypeDoc);
          parts.push(printFunctionTypeParameters(path5, options, print), group([shouldGroupParameters ? group(parametersDoc) : parametersDoc, returnTypeDoc]), node.body ? " " : "", print("body"));
          if (options.semi && (node.declare || !node.body)) {
            parts.push(";");
          }
          return parts;
        }
        function printMethod(path5, options, print) {
          const node = path5.getNode();
          const {
            kind
          } = node;
          const value = node.value || node;
          const parts = [];
          if (!kind || kind === "init" || kind === "method" || kind === "constructor") {
            if (value.async) {
              parts.push("async ");
            }
          } else {
            assert.ok(kind === "get" || kind === "set");
            parts.push(kind, " ");
          }
          if (value.generator) {
            parts.push("*");
          }
          parts.push(printPropertyKey(path5, options, print), node.optional || node.key.optional ? "?" : "");
          if (node === value) {
            parts.push(printMethodInternal(path5, options, print));
          } else if (value.type === "FunctionExpression") {
            parts.push(path5.call((path22) => printMethodInternal(path22, options, print), "value"));
          } else {
            parts.push(print("value"));
          }
          return parts;
        }
        function printMethodInternal(path5, options, print) {
          const node = path5.getNode();
          const parametersDoc = printFunctionParameters(path5, print, options);
          const returnTypeDoc = printReturnType(path5, print, options);
          const shouldGroupParameters = shouldGroupFunctionParameters(node, returnTypeDoc);
          const parts = [printFunctionTypeParameters(path5, options, print), group([shouldGroupParameters ? group(parametersDoc) : parametersDoc, returnTypeDoc])];
          if (node.body) {
            parts.push(" ", print("body"));
          } else {
            parts.push(options.semi ? ";" : "");
          }
          return parts;
        }
        function printArrowFunctionSignature(path5, options, print, args) {
          const node = path5.getValue();
          const parts = [];
          if (node.async) {
            parts.push("async ");
          }
          if (shouldPrintParamsWithoutParens(path5, options)) {
            parts.push(print(["params", 0]));
          } else {
            const expandArg = args && (args.expandLastArg || args.expandFirstArg);
            let returnTypeDoc = printReturnType(path5, print, options);
            if (expandArg) {
              if (willBreak(returnTypeDoc)) {
                throw new ArgExpansionBailout();
              }
              returnTypeDoc = group(removeLines(returnTypeDoc));
            }
            parts.push(group([printFunctionParameters(path5, print, options, expandArg, true), returnTypeDoc]));
          }
          const dangling = printDanglingComments(path5, options, true, (comment) => {
            const nextCharacter = getNextNonSpaceNonCommentCharacterIndex(options.originalText, comment, locEnd);
            return nextCharacter !== false && options.originalText.slice(nextCharacter, nextCharacter + 2) === "=>";
          });
          if (dangling) {
            parts.push(" ", dangling);
          }
          return parts;
        }
        function printArrowChain(path5, args, signatures, shouldBreak, bodyDoc, tailNode) {
          const name = path5.getName();
          const parent = path5.getParentNode();
          const isCallee = isCallLikeExpression(parent) && name === "callee";
          const isAssignmentRhs = Boolean(args && args.assignmentLayout);
          const shouldPutBodyOnSeparateLine = tailNode.body.type !== "BlockStatement" && tailNode.body.type !== "ObjectExpression" && tailNode.body.type !== "SequenceExpression";
          const shouldBreakBeforeChain = isCallee && shouldPutBodyOnSeparateLine || args && args.assignmentLayout === "chain-tail-arrow-chain";
          const groupId = Symbol("arrow-chain");
          if (tailNode.body.type === "SequenceExpression") {
            bodyDoc = group(["(", indent([softline, bodyDoc]), softline, ")"]);
          }
          return group([group(indent([isCallee || isAssignmentRhs ? softline : "", group(join2([" =>", line], signatures), {
            shouldBreak
          })]), {
            id: groupId,
            shouldBreak: shouldBreakBeforeChain
          }), " =>", indentIfBreak(shouldPutBodyOnSeparateLine ? indent([line, bodyDoc]) : [" ", bodyDoc], {
            groupId
          }), isCallee ? ifBreak(softline, "", {
            groupId
          }) : ""]);
        }
        function printArrowFunction(path5, options, print, args) {
          let node = path5.getValue();
          const signatures = [];
          const body = [];
          let chainShouldBreak = false;
          (function rec() {
            const doc2 = printArrowFunctionSignature(path5, options, print, args);
            if (signatures.length === 0) {
              signatures.push(doc2);
            } else {
              const {
                leading,
                trailing
              } = printCommentsSeparately(path5, options);
              signatures.push([leading, doc2]);
              body.unshift(trailing);
            }
            chainShouldBreak = chainShouldBreak || node.returnType && getFunctionParameters(node).length > 0 || node.typeParameters || getFunctionParameters(node).some((param) => param.type !== "Identifier");
            if (node.body.type !== "ArrowFunctionExpression" || args && args.expandLastArg) {
              body.unshift(print("body", args));
            } else {
              node = node.body;
              path5.call(rec, "body");
            }
          })();
          if (signatures.length > 1) {
            return printArrowChain(path5, args, signatures, chainShouldBreak, body, node);
          }
          const parts = signatures;
          parts.push(" =>");
          if (!hasLeadingOwnLineComment(options.originalText, node.body) && (node.body.type === "ArrayExpression" || node.body.type === "ObjectExpression" || node.body.type === "BlockStatement" || isJsxNode(node.body) || isTemplateOnItsOwnLine(node.body, options.originalText) || node.body.type === "ArrowFunctionExpression" || node.body.type === "DoExpression")) {
            return group([...parts, " ", body]);
          }
          if (node.body.type === "SequenceExpression") {
            return group([...parts, group([" (", indent([softline, body]), softline, ")"])]);
          }
          const shouldAddSoftLine = (args && args.expandLastArg || path5.getParentNode().type === "JSXExpressionContainer") && !hasComment(node);
          const printTrailingComma = args && args.expandLastArg && shouldPrintComma(options, "all");
          const shouldAddParens = node.body.type === "ConditionalExpression" && !startsWithNoLookaheadToken(node.body, false);
          return group([...parts, group([indent([line, shouldAddParens ? ifBreak("", "(") : "", body, shouldAddParens ? ifBreak("", ")") : ""]), shouldAddSoftLine ? [ifBreak(printTrailingComma ? "," : ""), softline] : ""])]);
        }
        function canPrintParamsWithoutParens(node) {
          const parameters = getFunctionParameters(node);
          return parameters.length === 1 && !node.typeParameters && !hasComment(node, CommentCheckFlags.Dangling) && parameters[0].type === "Identifier" && !parameters[0].typeAnnotation && !hasComment(parameters[0]) && !parameters[0].optional && !node.predicate && !node.returnType;
        }
        function shouldPrintParamsWithoutParens(path5, options) {
          if (options.arrowParens === "always") {
            return false;
          }
          if (options.arrowParens === "avoid") {
            const node = path5.getValue();
            return canPrintParamsWithoutParens(node);
          }
          return false;
        }
        function printReturnType(path5, print, options) {
          const node = path5.getValue();
          const returnType = print("returnType");
          if (node.returnType && isFlowAnnotationComment(options.originalText, node.returnType)) {
            return [" /*: ", returnType, " */"];
          }
          const parts = [returnType];
          if (node.returnType && node.returnType.typeAnnotation) {
            parts.unshift(": ");
          }
          if (node.predicate) {
            parts.push(node.returnType ? " " : ": ", print("predicate"));
          }
          return parts;
        }
        function printReturnOrThrowArgument(path5, options, print) {
          const node = path5.getValue();
          const semi = options.semi ? ";" : "";
          const parts = [];
          if (node.argument) {
            if (returnArgumentHasLeadingComment(options, node.argument)) {
              parts.push([" (", indent([hardline, print("argument")]), hardline, ")"]);
            } else if (isBinaryish(node.argument) || node.argument.type === "SequenceExpression") {
              parts.push(group([ifBreak(" (", " "), indent([softline, print("argument")]), softline, ifBreak(")")]));
            } else {
              parts.push(" ", print("argument"));
            }
          }
          const comments = getComments(node);
          const lastComment = getLast(comments);
          const isLastCommentLine = lastComment && isLineComment(lastComment);
          if (isLastCommentLine) {
            parts.push(semi);
          }
          if (hasComment(node, CommentCheckFlags.Dangling)) {
            parts.push(" ", printDanglingComments(path5, options, true));
          }
          if (!isLastCommentLine) {
            parts.push(semi);
          }
          return parts;
        }
        function printReturnStatement(path5, options, print) {
          return ["return", printReturnOrThrowArgument(path5, options, print)];
        }
        function printThrowStatement(path5, options, print) {
          return ["throw", printReturnOrThrowArgument(path5, options, print)];
        }
        function returnArgumentHasLeadingComment(options, argument) {
          if (hasLeadingOwnLineComment(options.originalText, argument)) {
            return true;
          }
          if (hasNakedLeftSide(argument)) {
            let leftMost = argument;
            let newLeftMost;
            while (newLeftMost = getLeftSide(leftMost)) {
              leftMost = newLeftMost;
              if (hasLeadingOwnLineComment(options.originalText, leftMost)) {
                return true;
              }
            }
          }
          return false;
        }
        module22.exports = {
          printFunction,
          printArrowFunction,
          printMethod,
          printReturnStatement,
          printThrowStatement,
          printMethodInternal,
          shouldPrintParamsWithoutParens
        };
      }
    });
    var require_decorators = __commonJS22({
      "src/language-js/print/decorators.js"(exports22, module22) {
        "use strict";
        var {
          isNonEmptyArray,
          hasNewline
        } = require_util2();
        var {
          builders: {
            line,
            hardline,
            join: join2,
            breakParent,
            group
          }
        } = require_doc();
        var {
          locStart,
          locEnd
        } = require_loc();
        var {
          getParentExportDeclaration
        } = require_utils72();
        function printClassMemberDecorators(path5, options, print) {
          const node = path5.getValue();
          return group([join2(line, path5.map(print, "decorators")), hasNewlineBetweenOrAfterDecorators(node, options) ? hardline : line]);
        }
        function printDecoratorsBeforeExport(path5, options, print) {
          return [join2(hardline, path5.map(print, "declaration", "decorators")), hardline];
        }
        function printDecorators(path5, options, print) {
          const node = path5.getValue();
          const {
            decorators
          } = node;
          if (!isNonEmptyArray(decorators) || hasDecoratorsBeforeExport(path5.getParentNode())) {
            return;
          }
          const shouldBreak = node.type === "ClassExpression" || node.type === "ClassDeclaration" || hasNewlineBetweenOrAfterDecorators(node, options);
          return [getParentExportDeclaration(path5) ? hardline : shouldBreak ? breakParent : "", join2(line, path5.map(print, "decorators")), line];
        }
        function hasNewlineBetweenOrAfterDecorators(node, options) {
          return node.decorators.some((decorator) => hasNewline(options.originalText, locEnd(decorator)));
        }
        function hasDecoratorsBeforeExport(node) {
          if (node.type !== "ExportDefaultDeclaration" && node.type !== "ExportNamedDeclaration" && node.type !== "DeclareExportDeclaration") {
            return false;
          }
          const decorators = node.declaration && node.declaration.decorators;
          return isNonEmptyArray(decorators) && locStart(node, {
            ignoreDecorators: true
          }) > locStart(decorators[0]);
        }
        module22.exports = {
          printDecorators,
          printClassMemberDecorators,
          printDecoratorsBeforeExport,
          hasDecoratorsBeforeExport
        };
      }
    });
    var require_class = __commonJS22({
      "src/language-js/print/class.js"(exports22, module22) {
        "use strict";
        var {
          isNonEmptyArray,
          createGroupIdMapper
        } = require_util2();
        var {
          printComments,
          printDanglingComments
        } = require_comments();
        var {
          builders: {
            join: join2,
            line,
            hardline,
            softline,
            group,
            indent,
            ifBreak
          }
        } = require_doc();
        var {
          hasComment,
          CommentCheckFlags
        } = require_utils72();
        var {
          getTypeParametersGroupId
        } = require_type_parameters();
        var {
          printMethod
        } = require_function();
        var {
          printOptionalToken,
          printTypeAnnotation,
          printDefiniteToken
        } = require_misc();
        var {
          printPropertyKey
        } = require_property();
        var {
          printAssignment
        } = require_assignment();
        var {
          printClassMemberDecorators
        } = require_decorators();
        function printClass(path5, options, print) {
          const node = path5.getValue();
          const parts = [];
          if (node.declare) {
            parts.push("declare ");
          }
          if (node.abstract) {
            parts.push("abstract ");
          }
          parts.push("class");
          const groupMode = node.id && hasComment(node.id, CommentCheckFlags.Trailing) || node.typeParameters && hasComment(node.typeParameters, CommentCheckFlags.Trailing) || node.superClass && hasComment(node.superClass) || isNonEmptyArray(node.extends) || isNonEmptyArray(node.mixins) || isNonEmptyArray(node.implements);
          const partsGroup = [];
          const extendsParts = [];
          if (node.id) {
            partsGroup.push(" ", print("id"));
          }
          partsGroup.push(print("typeParameters"));
          if (node.superClass) {
            const printed = [printSuperClass(path5, options, print), print("superTypeParameters")];
            const printedWithComments = path5.call((superClass) => ["extends ", printComments(superClass, printed, options)], "superClass");
            if (groupMode) {
              extendsParts.push(line, group(printedWithComments));
            } else {
              extendsParts.push(" ", printedWithComments);
            }
          } else {
            extendsParts.push(printList(path5, options, print, "extends"));
          }
          extendsParts.push(printList(path5, options, print, "mixins"), printList(path5, options, print, "implements"));
          if (groupMode) {
            let printedPartsGroup;
            if (shouldIndentOnlyHeritageClauses(node)) {
              printedPartsGroup = [...partsGroup, indent(extendsParts)];
            } else {
              printedPartsGroup = indent([...partsGroup, extendsParts]);
            }
            parts.push(group(printedPartsGroup, {
              id: getHeritageGroupId(node)
            }));
          } else {
            parts.push(...partsGroup, ...extendsParts);
          }
          parts.push(" ", print("body"));
          return parts;
        }
        var getHeritageGroupId = createGroupIdMapper("heritageGroup");
        function printHardlineAfterHeritage(node) {
          return ifBreak(hardline, "", {
            groupId: getHeritageGroupId(node)
          });
        }
        function hasMultipleHeritage(node) {
          return ["superClass", "extends", "mixins", "implements"].filter((key) => Boolean(node[key])).length > 1;
        }
        function shouldIndentOnlyHeritageClauses(node) {
          return node.typeParameters && !hasComment(node.typeParameters, CommentCheckFlags.Trailing | CommentCheckFlags.Line) && !hasMultipleHeritage(node);
        }
        function printList(path5, options, print, listName) {
          const node = path5.getValue();
          if (!isNonEmptyArray(node[listName])) {
            return "";
          }
          const printedLeadingComments = printDanglingComments(path5, options, true, ({
            marker
          }) => marker === listName);
          return [shouldIndentOnlyHeritageClauses(node) ? ifBreak(" ", line, {
            groupId: getTypeParametersGroupId(node.typeParameters)
          }) : line, printedLeadingComments, printedLeadingComments && hardline, listName, group(indent([line, join2([",", line], path5.map(print, listName))]))];
        }
        function printSuperClass(path5, options, print) {
          const printed = print("superClass");
          const parent = path5.getParentNode();
          if (parent.type === "AssignmentExpression") {
            return group(ifBreak(["(", indent([softline, printed]), softline, ")"], printed));
          }
          return printed;
        }
        function printClassMethod(path5, options, print) {
          const node = path5.getValue();
          const parts = [];
          if (isNonEmptyArray(node.decorators)) {
            parts.push(printClassMemberDecorators(path5, options, print));
          }
          if (node.accessibility) {
            parts.push(node.accessibility + " ");
          }
          if (node.readonly) {
            parts.push("readonly ");
          }
          if (node.declare) {
            parts.push("declare ");
          }
          if (node.static) {
            parts.push("static ");
          }
          if (node.type === "TSAbstractMethodDefinition" || node.abstract) {
            parts.push("abstract ");
          }
          if (node.override) {
            parts.push("override ");
          }
          parts.push(printMethod(path5, options, print));
          return parts;
        }
        function printClassProperty(path5, options, print) {
          const node = path5.getValue();
          const parts = [];
          const semi = options.semi ? ";" : "";
          if (isNonEmptyArray(node.decorators)) {
            parts.push(printClassMemberDecorators(path5, options, print));
          }
          if (node.accessibility) {
            parts.push(node.accessibility + " ");
          }
          if (node.declare) {
            parts.push("declare ");
          }
          if (node.static) {
            parts.push("static ");
          }
          if (node.type === "TSAbstractPropertyDefinition" || node.abstract) {
            parts.push("abstract ");
          }
          if (node.override) {
            parts.push("override ");
          }
          if (node.readonly) {
            parts.push("readonly ");
          }
          if (node.variance) {
            parts.push(print("variance"));
          }
          if (node.type === "ClassAccessorProperty") {
            parts.push("accessor ");
          }
          parts.push(printPropertyKey(path5, options, print), printOptionalToken(path5), printDefiniteToken(path5), printTypeAnnotation(path5, options, print));
          return [printAssignment(path5, options, print, parts, " =", "value"), semi];
        }
        module22.exports = {
          printClass,
          printClassMethod,
          printClassProperty,
          printHardlineAfterHeritage
        };
      }
    });
    var require_interface = __commonJS22({
      "src/language-js/print/interface.js"(exports22, module22) {
        "use strict";
        var {
          isNonEmptyArray
        } = require_util2();
        var {
          builders: {
            join: join2,
            line,
            group,
            indent,
            ifBreak
          }
        } = require_doc();
        var {
          hasComment,
          identity: identity2,
          CommentCheckFlags
        } = require_utils72();
        var {
          getTypeParametersGroupId
        } = require_type_parameters();
        var {
          printTypeScriptModifiers
        } = require_misc();
        function printInterface(path5, options, print) {
          const node = path5.getValue();
          const parts = [];
          if (node.declare) {
            parts.push("declare ");
          }
          if (node.type === "TSInterfaceDeclaration") {
            parts.push(node.abstract ? "abstract " : "", printTypeScriptModifiers(path5, options, print));
          }
          parts.push("interface");
          const partsGroup = [];
          const extendsParts = [];
          if (node.type !== "InterfaceTypeAnnotation") {
            partsGroup.push(" ", print("id"), print("typeParameters"));
          }
          const shouldIndentOnlyHeritageClauses = node.typeParameters && !hasComment(node.typeParameters, CommentCheckFlags.Trailing | CommentCheckFlags.Line);
          if (isNonEmptyArray(node.extends)) {
            extendsParts.push(shouldIndentOnlyHeritageClauses ? ifBreak(" ", line, {
              groupId: getTypeParametersGroupId(node.typeParameters)
            }) : line, "extends ", (node.extends.length === 1 ? identity2 : indent)(join2([",", line], path5.map(print, "extends"))));
          }
          if (node.id && hasComment(node.id, CommentCheckFlags.Trailing) || isNonEmptyArray(node.extends)) {
            if (shouldIndentOnlyHeritageClauses) {
              parts.push(group([...partsGroup, indent(extendsParts)]));
            } else {
              parts.push(group(indent([...partsGroup, ...extendsParts])));
            }
          } else {
            parts.push(...partsGroup, ...extendsParts);
          }
          parts.push(" ", print("body"));
          return group(parts);
        }
        module22.exports = {
          printInterface
        };
      }
    });
    var require_module = __commonJS22({
      "src/language-js/print/module.js"(exports22, module22) {
        "use strict";
        var {
          isNonEmptyArray
        } = require_util2();
        var {
          builders: {
            softline,
            group,
            indent,
            join: join2,
            line,
            ifBreak,
            hardline
          }
        } = require_doc();
        var {
          printDanglingComments
        } = require_comments();
        var {
          hasComment,
          CommentCheckFlags,
          shouldPrintComma,
          needsHardlineAfterDanglingComment,
          isStringLiteral,
          rawText
        } = require_utils72();
        var {
          locStart,
          hasSameLoc
        } = require_loc();
        var {
          hasDecoratorsBeforeExport,
          printDecoratorsBeforeExport
        } = require_decorators();
        function printImportDeclaration(path5, options, print) {
          const node = path5.getValue();
          const semi = options.semi ? ";" : "";
          const parts = [];
          const {
            importKind
          } = node;
          parts.push("import");
          if (importKind && importKind !== "value") {
            parts.push(" ", importKind);
          }
          parts.push(printModuleSpecifiers(path5, options, print), printModuleSource(path5, options, print), printImportAssertions(path5, options, print), semi);
          return parts;
        }
        function printExportDeclaration(path5, options, print) {
          const node = path5.getValue();
          const parts = [];
          if (hasDecoratorsBeforeExport(node)) {
            parts.push(printDecoratorsBeforeExport(path5, options, print));
          }
          const {
            type: type2,
            exportKind,
            declaration
          } = node;
          parts.push("export");
          const isDefaultExport = node.default || type2 === "ExportDefaultDeclaration";
          if (isDefaultExport) {
            parts.push(" default");
          }
          if (hasComment(node, CommentCheckFlags.Dangling)) {
            parts.push(" ", printDanglingComments(path5, options, true));
            if (needsHardlineAfterDanglingComment(node)) {
              parts.push(hardline);
            }
          }
          if (declaration) {
            parts.push(" ", print("declaration"));
          } else {
            parts.push(exportKind === "type" ? " type" : "", printModuleSpecifiers(path5, options, print), printModuleSource(path5, options, print), printImportAssertions(path5, options, print));
          }
          if (shouldExportDeclarationPrintSemi(node, options)) {
            parts.push(";");
          }
          return parts;
        }
        function printExportAllDeclaration(path5, options, print) {
          const node = path5.getValue();
          const semi = options.semi ? ";" : "";
          const parts = [];
          const {
            exportKind,
            exported
          } = node;
          parts.push("export");
          if (exportKind === "type") {
            parts.push(" type");
          }
          parts.push(" *");
          if (exported) {
            parts.push(" as ", print("exported"));
          }
          parts.push(printModuleSource(path5, options, print), printImportAssertions(path5, options, print), semi);
          return parts;
        }
        function shouldExportDeclarationPrintSemi(node, options) {
          if (!options.semi) {
            return false;
          }
          const {
            type: type2,
            declaration
          } = node;
          const isDefaultExport = node.default || type2 === "ExportDefaultDeclaration";
          if (!declaration) {
            return true;
          }
          const {
            type: declarationType
          } = declaration;
          if (isDefaultExport && declarationType !== "ClassDeclaration" && declarationType !== "FunctionDeclaration" && declarationType !== "TSInterfaceDeclaration" && declarationType !== "DeclareClass" && declarationType !== "DeclareFunction" && declarationType !== "TSDeclareFunction" && declarationType !== "EnumDeclaration") {
            return true;
          }
          return false;
        }
        function printModuleSource(path5, options, print) {
          const node = path5.getValue();
          if (!node.source) {
            return "";
          }
          const parts = [];
          if (!shouldNotPrintSpecifiers(node, options)) {
            parts.push(" from");
          }
          parts.push(" ", print("source"));
          return parts;
        }
        function printModuleSpecifiers(path5, options, print) {
          const node = path5.getValue();
          if (shouldNotPrintSpecifiers(node, options)) {
            return "";
          }
          const parts = [" "];
          if (isNonEmptyArray(node.specifiers)) {
            const standaloneSpecifiers = [];
            const groupedSpecifiers = [];
            path5.each(() => {
              const specifierType = path5.getValue().type;
              if (specifierType === "ExportNamespaceSpecifier" || specifierType === "ExportDefaultSpecifier" || specifierType === "ImportNamespaceSpecifier" || specifierType === "ImportDefaultSpecifier") {
                standaloneSpecifiers.push(print());
              } else if (specifierType === "ExportSpecifier" || specifierType === "ImportSpecifier") {
                groupedSpecifiers.push(print());
              } else {
                throw new Error(`Unknown specifier type ${JSON.stringify(specifierType)}`);
              }
            }, "specifiers");
            parts.push(join2(", ", standaloneSpecifiers));
            if (groupedSpecifiers.length > 0) {
              if (standaloneSpecifiers.length > 0) {
                parts.push(", ");
              }
              const canBreak = groupedSpecifiers.length > 1 || standaloneSpecifiers.length > 0 || node.specifiers.some((node2) => hasComment(node2));
              if (canBreak) {
                parts.push(group(["{", indent([options.bracketSpacing ? line : softline, join2([",", line], groupedSpecifiers)]), ifBreak(shouldPrintComma(options) ? "," : ""), options.bracketSpacing ? line : softline, "}"]));
              } else {
                parts.push(["{", options.bracketSpacing ? " " : "", ...groupedSpecifiers, options.bracketSpacing ? " " : "", "}"]);
              }
            }
          } else {
            parts.push("{}");
          }
          return parts;
        }
        function shouldNotPrintSpecifiers(node, options) {
          const {
            type: type2,
            importKind,
            source,
            specifiers
          } = node;
          if (type2 !== "ImportDeclaration" || isNonEmptyArray(specifiers) || importKind === "type") {
            return false;
          }
          return !/{\s*}/.test(options.originalText.slice(locStart(node), locStart(source)));
        }
        function printImportAssertions(path5, options, print) {
          const node = path5.getNode();
          if (isNonEmptyArray(node.assertions)) {
            return [" assert {", options.bracketSpacing ? " " : "", join2(", ", path5.map(print, "assertions")), options.bracketSpacing ? " " : "", "}"];
          }
          return "";
        }
        function printModuleSpecifier(path5, options, print) {
          const node = path5.getNode();
          const {
            type: type2
          } = node;
          const parts = [];
          const kind = type2 === "ImportSpecifier" ? node.importKind : node.exportKind;
          if (kind && kind !== "value") {
            parts.push(kind, " ");
          }
          const isImport = type2.startsWith("Import");
          const leftSideProperty = isImport ? "imported" : "local";
          const rightSideProperty = isImport ? "local" : "exported";
          const leftSideNode = node[leftSideProperty];
          const rightSideNode = node[rightSideProperty];
          let left = "";
          let right = "";
          if (type2 === "ExportNamespaceSpecifier" || type2 === "ImportNamespaceSpecifier") {
            left = "*";
          } else if (leftSideNode) {
            left = print(leftSideProperty);
          }
          if (rightSideNode && !isShorthandSpecifier(node)) {
            right = print(rightSideProperty);
          }
          parts.push(left, left && right ? " as " : "", right);
          return parts;
        }
        function isShorthandSpecifier(specifier) {
          if (specifier.type !== "ImportSpecifier" && specifier.type !== "ExportSpecifier") {
            return false;
          }
          const {
            local,
            [specifier.type === "ImportSpecifier" ? "imported" : "exported"]: importedOrExported
          } = specifier;
          if (local.type !== importedOrExported.type || !hasSameLoc(local, importedOrExported)) {
            return false;
          }
          if (isStringLiteral(local)) {
            return local.value === importedOrExported.value && rawText(local) === rawText(importedOrExported);
          }
          switch (local.type) {
            case "Identifier":
              return local.name === importedOrExported.name;
            default:
              return false;
          }
        }
        module22.exports = {
          printImportDeclaration,
          printExportDeclaration,
          printExportAllDeclaration,
          printModuleSpecifier
        };
      }
    });
    var require_object = __commonJS22({
      "src/language-js/print/object.js"(exports22, module22) {
        "use strict";
        var {
          printDanglingComments
        } = require_comments();
        var {
          builders: {
            line,
            softline,
            group,
            indent,
            ifBreak,
            hardline
          }
        } = require_doc();
        var {
          getLast,
          hasNewlineInRange,
          hasNewline,
          isNonEmptyArray
        } = require_util2();
        var {
          shouldPrintComma,
          hasComment,
          getComments,
          CommentCheckFlags,
          isNextLineEmpty
        } = require_utils72();
        var {
          locStart,
          locEnd
        } = require_loc();
        var {
          printOptionalToken,
          printTypeAnnotation
        } = require_misc();
        var {
          shouldHugFunctionParameters
        } = require_function_parameters();
        var {
          shouldHugType
        } = require_type_annotation();
        var {
          printHardlineAfterHeritage
        } = require_class();
        function printObject(path5, options, print) {
          const semi = options.semi ? ";" : "";
          const node = path5.getValue();
          let propertiesField;
          if (node.type === "TSTypeLiteral") {
            propertiesField = "members";
          } else if (node.type === "TSInterfaceBody") {
            propertiesField = "body";
          } else {
            propertiesField = "properties";
          }
          const isTypeAnnotation = node.type === "ObjectTypeAnnotation";
          const fields = [propertiesField];
          if (isTypeAnnotation) {
            fields.push("indexers", "callProperties", "internalSlots");
          }
          const firstProperty = fields.map((field) => node[field][0]).sort((a, b) => locStart(a) - locStart(b))[0];
          const parent = path5.getParentNode(0);
          const isFlowInterfaceLikeBody = isTypeAnnotation && parent && (parent.type === "InterfaceDeclaration" || parent.type === "DeclareInterface" || parent.type === "DeclareClass") && path5.getName() === "body";
          const shouldBreak = node.type === "TSInterfaceBody" || isFlowInterfaceLikeBody || node.type === "ObjectPattern" && parent.type !== "FunctionDeclaration" && parent.type !== "FunctionExpression" && parent.type !== "ArrowFunctionExpression" && parent.type !== "ObjectMethod" && parent.type !== "ClassMethod" && parent.type !== "ClassPrivateMethod" && parent.type !== "AssignmentPattern" && parent.type !== "CatchClause" && node.properties.some((property4) => property4.value && (property4.value.type === "ObjectPattern" || property4.value.type === "ArrayPattern")) || node.type !== "ObjectPattern" && firstProperty && hasNewlineInRange(options.originalText, locStart(node), locStart(firstProperty));
          const separator = isFlowInterfaceLikeBody ? ";" : node.type === "TSInterfaceBody" || node.type === "TSTypeLiteral" ? ifBreak(semi, ";") : ",";
          const leftBrace = node.type === "RecordExpression" ? "#{" : node.exact ? "{|" : "{";
          const rightBrace = node.exact ? "|}" : "}";
          const propsAndLoc = [];
          for (const field of fields) {
            path5.each((childPath) => {
              const node2 = childPath.getValue();
              propsAndLoc.push({
                node: node2,
                printed: print(),
                loc: locStart(node2)
              });
            }, field);
          }
          if (fields.length > 1) {
            propsAndLoc.sort((a, b) => a.loc - b.loc);
          }
          let separatorParts = [];
          const props = propsAndLoc.map((prop) => {
            const result = [...separatorParts, group(prop.printed)];
            separatorParts = [separator, line];
            if ((prop.node.type === "TSPropertySignature" || prop.node.type === "TSMethodSignature" || prop.node.type === "TSConstructSignatureDeclaration") && hasComment(prop.node, CommentCheckFlags.PrettierIgnore)) {
              separatorParts.shift();
            }
            if (isNextLineEmpty(prop.node, options)) {
              separatorParts.push(hardline);
            }
            return result;
          });
          if (node.inexact) {
            let printed;
            if (hasComment(node, CommentCheckFlags.Dangling)) {
              const hasLineComments = hasComment(node, CommentCheckFlags.Line);
              const printedDanglingComments = printDanglingComments(path5, options, true);
              printed = [printedDanglingComments, hasLineComments || hasNewline(options.originalText, locEnd(getLast(getComments(node)))) ? hardline : line, "..."];
            } else {
              printed = ["..."];
            }
            props.push([...separatorParts, ...printed]);
          }
          const lastElem = getLast(node[propertiesField]);
          const canHaveTrailingSeparator = !(node.inexact || lastElem && lastElem.type === "RestElement" || lastElem && (lastElem.type === "TSPropertySignature" || lastElem.type === "TSCallSignatureDeclaration" || lastElem.type === "TSMethodSignature" || lastElem.type === "TSConstructSignatureDeclaration") && hasComment(lastElem, CommentCheckFlags.PrettierIgnore));
          let content;
          if (props.length === 0) {
            if (!hasComment(node, CommentCheckFlags.Dangling)) {
              return [leftBrace, rightBrace, printTypeAnnotation(path5, options, print)];
            }
            content = group([leftBrace, printDanglingComments(path5, options), softline, rightBrace, printOptionalToken(path5), printTypeAnnotation(path5, options, print)]);
          } else {
            content = [isFlowInterfaceLikeBody && isNonEmptyArray(node.properties) ? printHardlineAfterHeritage(parent) : "", leftBrace, indent([options.bracketSpacing ? line : softline, ...props]), ifBreak(canHaveTrailingSeparator && (separator !== "," || shouldPrintComma(options)) ? separator : ""), options.bracketSpacing ? line : softline, rightBrace, printOptionalToken(path5), printTypeAnnotation(path5, options, print)];
          }
          if (path5.match((node2) => node2.type === "ObjectPattern" && !node2.decorators, (node2, name, number3) => shouldHugFunctionParameters(node2) && (name === "params" || name === "parameters" || name === "this" || name === "rest") && number3 === 0) || path5.match(shouldHugType, (node2, name) => name === "typeAnnotation", (node2, name) => name === "typeAnnotation", (node2, name, number3) => shouldHugFunctionParameters(node2) && (name === "params" || name === "parameters" || name === "this" || name === "rest") && number3 === 0) || !shouldBreak && path5.match((node2) => node2.type === "ObjectPattern", (node2) => node2.type === "AssignmentExpression" || node2.type === "VariableDeclarator")) {
            return content;
          }
          return group(content, {
            shouldBreak
          });
        }
        module22.exports = {
          printObject
        };
      }
    });
    var require_flow = __commonJS22({
      "src/language-js/print/flow.js"(exports22, module22) {
        "use strict";
        var assert = require("assert");
        var {
          printDanglingComments
        } = require_comments();
        var {
          printString,
          printNumber
        } = require_util2();
        var {
          builders: {
            hardline,
            softline,
            group,
            indent
          }
        } = require_doc();
        var {
          getParentExportDeclaration,
          isFunctionNotation,
          isGetterOrSetter,
          rawText,
          shouldPrintComma
        } = require_utils72();
        var {
          locStart,
          locEnd
        } = require_loc();
        var {
          printClass
        } = require_class();
        var {
          printOpaqueType,
          printTypeAlias,
          printIntersectionType,
          printUnionType,
          printFunctionType,
          printTupleType,
          printIndexedAccessType
        } = require_type_annotation();
        var {
          printInterface
        } = require_interface();
        var {
          printTypeParameter,
          printTypeParameters
        } = require_type_parameters();
        var {
          printExportDeclaration,
          printExportAllDeclaration
        } = require_module();
        var {
          printArrayItems
        } = require_array4();
        var {
          printObject
        } = require_object();
        var {
          printPropertyKey
        } = require_property();
        var {
          printOptionalToken,
          printTypeAnnotation,
          printRestSpread
        } = require_misc();
        function printFlow(path5, options, print) {
          const node = path5.getValue();
          const semi = options.semi ? ";" : "";
          const parts = [];
          switch (node.type) {
            case "DeclareClass":
              return printFlowDeclaration(path5, printClass(path5, options, print));
            case "DeclareFunction":
              return printFlowDeclaration(path5, ["function ", print("id"), node.predicate ? " " : "", print("predicate"), semi]);
            case "DeclareModule":
              return printFlowDeclaration(path5, ["module ", print("id"), " ", print("body")]);
            case "DeclareModuleExports":
              return printFlowDeclaration(path5, ["module.exports", ": ", print("typeAnnotation"), semi]);
            case "DeclareVariable":
              return printFlowDeclaration(path5, ["var ", print("id"), semi]);
            case "DeclareOpaqueType":
              return printFlowDeclaration(path5, printOpaqueType(path5, options, print));
            case "DeclareInterface":
              return printFlowDeclaration(path5, printInterface(path5, options, print));
            case "DeclareTypeAlias":
              return printFlowDeclaration(path5, printTypeAlias(path5, options, print));
            case "DeclareExportDeclaration":
              return printFlowDeclaration(path5, printExportDeclaration(path5, options, print));
            case "DeclareExportAllDeclaration":
              return printFlowDeclaration(path5, printExportAllDeclaration(path5, options, print));
            case "OpaqueType":
              return printOpaqueType(path5, options, print);
            case "TypeAlias":
              return printTypeAlias(path5, options, print);
            case "IntersectionTypeAnnotation":
              return printIntersectionType(path5, options, print);
            case "UnionTypeAnnotation":
              return printUnionType(path5, options, print);
            case "FunctionTypeAnnotation":
              return printFunctionType(path5, options, print);
            case "TupleTypeAnnotation":
              return printTupleType(path5, options, print);
            case "GenericTypeAnnotation":
              return [print("id"), printTypeParameters(path5, options, print, "typeParameters")];
            case "IndexedAccessType":
            case "OptionalIndexedAccessType":
              return printIndexedAccessType(path5, options, print);
            case "TypeAnnotation":
              return print("typeAnnotation");
            case "TypeParameter":
              return printTypeParameter(path5, options, print);
            case "TypeofTypeAnnotation":
              return ["typeof ", print("argument")];
            case "ExistsTypeAnnotation":
              return "*";
            case "EmptyTypeAnnotation":
              return "empty";
            case "MixedTypeAnnotation":
              return "mixed";
            case "ArrayTypeAnnotation":
              return [print("elementType"), "[]"];
            case "BooleanLiteralTypeAnnotation":
              return String(node.value);
            case "EnumDeclaration":
              return ["enum ", print("id"), " ", print("body")];
            case "EnumBooleanBody":
            case "EnumNumberBody":
            case "EnumStringBody":
            case "EnumSymbolBody": {
              if (node.type === "EnumSymbolBody" || node.explicitType) {
                let type2 = null;
                switch (node.type) {
                  case "EnumBooleanBody":
                    type2 = "boolean";
                    break;
                  case "EnumNumberBody":
                    type2 = "number";
                    break;
                  case "EnumStringBody":
                    type2 = "string";
                    break;
                  case "EnumSymbolBody":
                    type2 = "symbol";
                    break;
                }
                parts.push("of ", type2, " ");
              }
              if (node.members.length === 0 && !node.hasUnknownMembers) {
                parts.push(group(["{", printDanglingComments(path5, options), softline, "}"]));
              } else {
                const members = node.members.length > 0 ? [hardline, printArrayItems(path5, options, "members", print), node.hasUnknownMembers || shouldPrintComma(options) ? "," : ""] : [];
                parts.push(group(["{", indent([...members, ...node.hasUnknownMembers ? [hardline, "..."] : []]), printDanglingComments(path5, options, true), hardline, "}"]));
              }
              return parts;
            }
            case "EnumBooleanMember":
            case "EnumNumberMember":
            case "EnumStringMember":
              return [print("id"), " = ", typeof node.init === "object" ? print("init") : String(node.init)];
            case "EnumDefaultedMember":
              return print("id");
            case "FunctionTypeParam": {
              const name = node.name ? print("name") : path5.getParentNode().this === node ? "this" : "";
              return [name, printOptionalToken(path5), name ? ": " : "", print("typeAnnotation")];
            }
            case "InterfaceDeclaration":
            case "InterfaceTypeAnnotation":
              return printInterface(path5, options, print);
            case "ClassImplements":
            case "InterfaceExtends":
              return [print("id"), print("typeParameters")];
            case "NullableTypeAnnotation":
              return ["?", print("typeAnnotation")];
            case "Variance": {
              const {
                kind
              } = node;
              assert.ok(kind === "plus" || kind === "minus");
              return kind === "plus" ? "+" : "-";
            }
            case "ObjectTypeCallProperty":
              if (node.static) {
                parts.push("static ");
              }
              parts.push(print("value"));
              return parts;
            case "ObjectTypeIndexer": {
              return [node.static ? "static " : "", node.variance ? print("variance") : "", "[", print("id"), node.id ? ": " : "", print("key"), "]: ", print("value")];
            }
            case "ObjectTypeProperty": {
              let modifier = "";
              if (node.proto) {
                modifier = "proto ";
              } else if (node.static) {
                modifier = "static ";
              }
              return [modifier, isGetterOrSetter(node) ? node.kind + " " : "", node.variance ? print("variance") : "", printPropertyKey(path5, options, print), printOptionalToken(path5), isFunctionNotation(node) ? "" : ": ", print("value")];
            }
            case "ObjectTypeAnnotation":
              return printObject(path5, options, print);
            case "ObjectTypeInternalSlot":
              return [node.static ? "static " : "", "[[", print("id"), "]]", printOptionalToken(path5), node.method ? "" : ": ", print("value")];
            case "ObjectTypeSpreadProperty":
              return printRestSpread(path5, options, print);
            case "QualifiedTypeofIdentifier":
            case "QualifiedTypeIdentifier":
              return [print("qualification"), ".", print("id")];
            case "StringLiteralTypeAnnotation":
              return printString(rawText(node), options);
            case "NumberLiteralTypeAnnotation":
              assert.strictEqual(typeof node.value, "number");
            case "BigIntLiteralTypeAnnotation":
              if (node.extra) {
                return printNumber(node.extra.raw);
              }
              return printNumber(node.raw);
            case "TypeCastExpression": {
              return ["(", print("expression"), printTypeAnnotation(path5, options, print), ")"];
            }
            case "TypeParameterDeclaration":
            case "TypeParameterInstantiation": {
              const printed = printTypeParameters(path5, options, print, "params");
              if (options.parser === "flow") {
                const start = locStart(node);
                const end = locEnd(node);
                const commentStartIndex = options.originalText.lastIndexOf("/*", start);
                const commentEndIndex = options.originalText.indexOf("*/", end);
                if (commentStartIndex !== -1 && commentEndIndex !== -1) {
                  const comment = options.originalText.slice(commentStartIndex + 2, commentEndIndex).trim();
                  if (comment.startsWith("::") && !comment.includes("/*") && !comment.includes("*/")) {
                    return ["/*:: ", printed, " */"];
                  }
                }
              }
              return printed;
            }
            case "InferredPredicate":
              return "%checks";
            case "DeclaredPredicate":
              return ["%checks(", print("value"), ")"];
            case "AnyTypeAnnotation":
              return "any";
            case "BooleanTypeAnnotation":
              return "boolean";
            case "BigIntTypeAnnotation":
              return "bigint";
            case "NullLiteralTypeAnnotation":
              return "null";
            case "NumberTypeAnnotation":
              return "number";
            case "SymbolTypeAnnotation":
              return "symbol";
            case "StringTypeAnnotation":
              return "string";
            case "VoidTypeAnnotation":
              return "void";
            case "ThisTypeAnnotation":
              return "this";
            case "Node":
            case "Printable":
            case "SourceLocation":
            case "Position":
            case "Statement":
            case "Function":
            case "Pattern":
            case "Expression":
            case "Declaration":
            case "Specifier":
            case "NamedSpecifier":
            case "Comment":
            case "MemberTypeAnnotation":
            case "Type":
              throw new Error("unprintable type: " + JSON.stringify(node.type));
          }
        }
        function printFlowDeclaration(path5, printed) {
          const parentExportDecl = getParentExportDeclaration(path5);
          if (parentExportDecl) {
            assert.strictEqual(parentExportDecl.type, "DeclareExportDeclaration");
            return printed;
          }
          return ["declare ", printed];
        }
        module22.exports = {
          printFlow
        };
      }
    });
    var require_is_ts_keyword_type = __commonJS22({
      "src/language-js/utils/is-ts-keyword-type.js"(exports22, module22) {
        "use strict";
        function isTsKeywordType({
          type: type2
        }) {
          return type2.startsWith("TS") && type2.endsWith("Keyword");
        }
        module22.exports = isTsKeywordType;
      }
    });
    var require_ternary = __commonJS22({
      "src/language-js/print/ternary.js"(exports22, module22) {
        "use strict";
        var {
          hasNewlineInRange
        } = require_util2();
        var {
          isJsxNode,
          getComments,
          isCallExpression,
          isMemberExpression
        } = require_utils72();
        var {
          locStart,
          locEnd
        } = require_loc();
        var isBlockComment = require_is_block_comment();
        var {
          builders: {
            line,
            softline,
            group,
            indent,
            align,
            ifBreak,
            dedent,
            breakParent
          }
        } = require_doc();
        function conditionalExpressionChainContainsJsx(node) {
          const conditionalExpressions = [node];
          for (let index = 0; index < conditionalExpressions.length; index++) {
            const conditionalExpression = conditionalExpressions[index];
            for (const property4 of ["test", "consequent", "alternate"]) {
              const node2 = conditionalExpression[property4];
              if (isJsxNode(node2)) {
                return true;
              }
              if (node2.type === "ConditionalExpression") {
                conditionalExpressions.push(node2);
              }
            }
          }
          return false;
        }
        function printTernaryTest(path5, options, print) {
          const node = path5.getValue();
          const isConditionalExpression = node.type === "ConditionalExpression";
          const alternateNodePropertyName = isConditionalExpression ? "alternate" : "falseType";
          const parent = path5.getParentNode();
          const printed = isConditionalExpression ? print("test") : [print("checkType"), " ", "extends", " ", print("extendsType")];
          if (parent.type === node.type && parent[alternateNodePropertyName] === node) {
            return align(2, printed);
          }
          return printed;
        }
        var ancestorNameMap = /* @__PURE__ */ new Map([["AssignmentExpression", "right"], ["VariableDeclarator", "init"], ["ReturnStatement", "argument"], ["ThrowStatement", "argument"], ["UnaryExpression", "argument"], ["YieldExpression", "argument"]]);
        function shouldExtraIndentForConditionalExpression(path5) {
          const node = path5.getValue();
          if (node.type !== "ConditionalExpression") {
            return false;
          }
          let parent;
          let child = node;
          for (let ancestorCount = 0; !parent; ancestorCount++) {
            const node2 = path5.getParentNode(ancestorCount);
            if (isCallExpression(node2) && node2.callee === child || isMemberExpression(node2) && node2.object === child || node2.type === "TSNonNullExpression" && node2.expression === child) {
              child = node2;
              continue;
            }
            if (node2.type === "NewExpression" && node2.callee === child || node2.type === "TSAsExpression" && node2.expression === child) {
              parent = path5.getParentNode(ancestorCount + 1);
              child = node2;
            } else {
              parent = node2;
            }
          }
          if (child === node) {
            return false;
          }
          return parent[ancestorNameMap.get(parent.type)] === child;
        }
        function printTernary(path5, options, print) {
          const node = path5.getValue();
          const isConditionalExpression = node.type === "ConditionalExpression";
          const consequentNodePropertyName = isConditionalExpression ? "consequent" : "trueType";
          const alternateNodePropertyName = isConditionalExpression ? "alternate" : "falseType";
          const testNodePropertyNames = isConditionalExpression ? ["test"] : ["checkType", "extendsType"];
          const consequentNode = node[consequentNodePropertyName];
          const alternateNode = node[alternateNodePropertyName];
          const parts = [];
          let jsxMode = false;
          const parent = path5.getParentNode();
          const isParentTest = parent.type === node.type && testNodePropertyNames.some((prop) => parent[prop] === node);
          let forceNoIndent = parent.type === node.type && !isParentTest;
          let currentParent;
          let previousParent;
          let i = 0;
          do {
            previousParent = currentParent || node;
            currentParent = path5.getParentNode(i);
            i++;
          } while (currentParent && currentParent.type === node.type && testNodePropertyNames.every((prop) => currentParent[prop] !== previousParent));
          const firstNonConditionalParent = currentParent || parent;
          const lastConditionalParent = previousParent;
          if (isConditionalExpression && (isJsxNode(node[testNodePropertyNames[0]]) || isJsxNode(consequentNode) || isJsxNode(alternateNode) || conditionalExpressionChainContainsJsx(lastConditionalParent))) {
            jsxMode = true;
            forceNoIndent = true;
            const wrap = (doc2) => [ifBreak("("), indent([softline, doc2]), softline, ifBreak(")")];
            const isNil = (node2) => node2.type === "NullLiteral" || node2.type === "Literal" && node2.value === null || node2.type === "Identifier" && node2.name === "undefined";
            parts.push(" ? ", isNil(consequentNode) ? print(consequentNodePropertyName) : wrap(print(consequentNodePropertyName)), " : ", alternateNode.type === node.type || isNil(alternateNode) ? print(alternateNodePropertyName) : wrap(print(alternateNodePropertyName)));
          } else {
            const part = [line, "? ", consequentNode.type === node.type ? ifBreak("", "(") : "", align(2, print(consequentNodePropertyName)), consequentNode.type === node.type ? ifBreak("", ")") : "", line, ": ", alternateNode.type === node.type ? print(alternateNodePropertyName) : align(2, print(alternateNodePropertyName))];
            parts.push(parent.type !== node.type || parent[alternateNodePropertyName] === node || isParentTest ? part : options.useTabs ? dedent(indent(part)) : align(Math.max(0, options.tabWidth - 2), part));
          }
          const comments = [...testNodePropertyNames.map((propertyName) => getComments(node[propertyName])), getComments(consequentNode), getComments(alternateNode)].flat();
          const shouldBreak = comments.some((comment) => isBlockComment(comment) && hasNewlineInRange(options.originalText, locStart(comment), locEnd(comment)));
          const maybeGroup = (doc2) => parent === firstNonConditionalParent ? group(doc2, {
            shouldBreak
          }) : shouldBreak ? [doc2, breakParent] : doc2;
          const breakClosingParen = !jsxMode && (isMemberExpression(parent) || parent.type === "NGPipeExpression" && parent.left === node) && !parent.computed;
          const shouldExtraIndent = shouldExtraIndentForConditionalExpression(path5);
          const result = maybeGroup([printTernaryTest(path5, options, print), forceNoIndent ? parts : indent(parts), isConditionalExpression && breakClosingParen && !shouldExtraIndent ? softline : ""]);
          return isParentTest || shouldExtraIndent ? group([indent([softline, result]), softline]) : result;
        }
        module22.exports = {
          printTernary
        };
      }
    });
    var require_statement = __commonJS22({
      "src/language-js/print/statement.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            hardline
          }
        } = require_doc();
        var pathNeedsParens = require_needs_parens();
        var {
          getLeftSidePathName,
          hasNakedLeftSide,
          isJsxNode,
          isTheOnlyJsxElementInMarkdown,
          hasComment,
          CommentCheckFlags,
          isNextLineEmpty
        } = require_utils72();
        var {
          shouldPrintParamsWithoutParens
        } = require_function();
        function printStatementSequence(path5, options, print, property4) {
          const node = path5.getValue();
          const parts = [];
          const isClassBody = node.type === "ClassBody";
          const lastStatement = getLastStatement(node[property4]);
          path5.each((path22, index, statements) => {
            const node2 = path22.getValue();
            if (node2.type === "EmptyStatement") {
              return;
            }
            const printed = print();
            if (!options.semi && !isClassBody && !isTheOnlyJsxElementInMarkdown(options, path22) && statementNeedsASIProtection(path22, options)) {
              if (hasComment(node2, CommentCheckFlags.Leading)) {
                parts.push(print([], {
                  needsSemi: true
                }));
              } else {
                parts.push(";", printed);
              }
            } else {
              parts.push(printed);
            }
            if (!options.semi && isClassBody && isClassProperty(node2) && shouldPrintSemicolonAfterClassProperty(node2, statements[index + 1])) {
              parts.push(";");
            }
            if (node2 !== lastStatement) {
              parts.push(hardline);
              if (isNextLineEmpty(node2, options)) {
                parts.push(hardline);
              }
            }
          }, property4);
          return parts;
        }
        function getLastStatement(statements) {
          for (let i = statements.length - 1; i >= 0; i--) {
            const statement = statements[i];
            if (statement.type !== "EmptyStatement") {
              return statement;
            }
          }
        }
        function statementNeedsASIProtection(path5, options) {
          const node = path5.getNode();
          if (node.type !== "ExpressionStatement") {
            return false;
          }
          return path5.call((childPath) => expressionNeedsASIProtection(childPath, options), "expression");
        }
        function expressionNeedsASIProtection(path5, options) {
          const node = path5.getValue();
          switch (node.type) {
            case "ParenthesizedExpression":
            case "TypeCastExpression":
            case "ArrayExpression":
            case "ArrayPattern":
            case "TemplateLiteral":
            case "TemplateElement":
            case "RegExpLiteral":
              return true;
            case "ArrowFunctionExpression": {
              if (!shouldPrintParamsWithoutParens(path5, options)) {
                return true;
              }
              break;
            }
            case "UnaryExpression": {
              const {
                prefix,
                operator
              } = node;
              if (prefix && (operator === "+" || operator === "-")) {
                return true;
              }
              break;
            }
            case "BindExpression": {
              if (!node.object) {
                return true;
              }
              break;
            }
            case "Literal": {
              if (node.regex) {
                return true;
              }
              break;
            }
            default: {
              if (isJsxNode(node)) {
                return true;
              }
            }
          }
          if (pathNeedsParens(path5, options)) {
            return true;
          }
          if (!hasNakedLeftSide(node)) {
            return false;
          }
          return path5.call((childPath) => expressionNeedsASIProtection(childPath, options), ...getLeftSidePathName(path5, node));
        }
        function printBody(path5, options, print) {
          return printStatementSequence(path5, options, print, "body");
        }
        function printSwitchCaseConsequent(path5, options, print) {
          return printStatementSequence(path5, options, print, "consequent");
        }
        var isClassProperty = ({
          type: type2
        }) => type2 === "ClassProperty" || type2 === "PropertyDefinition" || type2 === "ClassPrivateProperty" || type2 === "ClassAccessorProperty";
        function shouldPrintSemicolonAfterClassProperty(node, nextNode) {
          const name = node.key && node.key.name;
          if ((name === "static" || name === "get" || name === "set") && !node.value && !node.typeAnnotation) {
            return true;
          }
          if (!nextNode) {
            return false;
          }
          if (nextNode.static || nextNode.accessibility) {
            return false;
          }
          if (!nextNode.computed) {
            const name2 = nextNode.key && nextNode.key.name;
            if (name2 === "in" || name2 === "instanceof") {
              return true;
            }
          }
          if (isClassProperty(nextNode) && nextNode.variance && !nextNode.static && !nextNode.declare) {
            return true;
          }
          switch (nextNode.type) {
            case "ClassProperty":
            case "PropertyDefinition":
            case "TSAbstractPropertyDefinition":
              return nextNode.computed;
            case "MethodDefinition":
            case "TSAbstractMethodDefinition":
            case "ClassMethod":
            case "ClassPrivateMethod": {
              const isAsync2 = nextNode.value ? nextNode.value.async : nextNode.async;
              if (isAsync2 || nextNode.kind === "get" || nextNode.kind === "set") {
                return false;
              }
              const isGenerator = nextNode.value ? nextNode.value.generator : nextNode.generator;
              if (nextNode.computed || isGenerator) {
                return true;
              }
              return false;
            }
            case "TSIndexSignature":
              return true;
          }
          return false;
        }
        module22.exports = {
          printBody,
          printSwitchCaseConsequent
        };
      }
    });
    var require_block = __commonJS22({
      "src/language-js/print/block.js"(exports22, module22) {
        "use strict";
        var {
          printDanglingComments
        } = require_comments();
        var {
          isNonEmptyArray
        } = require_util2();
        var {
          builders: {
            hardline,
            indent
          }
        } = require_doc();
        var {
          hasComment,
          CommentCheckFlags,
          isNextLineEmpty
        } = require_utils72();
        var {
          printHardlineAfterHeritage
        } = require_class();
        var {
          printBody
        } = require_statement();
        function printBlock(path5, options, print) {
          const node = path5.getValue();
          const parts = [];
          if (node.type === "StaticBlock") {
            parts.push("static ");
          }
          if (node.type === "ClassBody" && isNonEmptyArray(node.body)) {
            const parent = path5.getParentNode();
            parts.push(printHardlineAfterHeritage(parent));
          }
          parts.push("{");
          const printed = printBlockBody(path5, options, print);
          if (printed) {
            parts.push(indent([hardline, printed]), hardline);
          } else {
            const parent = path5.getParentNode();
            const parentParent = path5.getParentNode(1);
            if (!(parent.type === "ArrowFunctionExpression" || parent.type === "FunctionExpression" || parent.type === "FunctionDeclaration" || parent.type === "ObjectMethod" || parent.type === "ClassMethod" || parent.type === "ClassPrivateMethod" || parent.type === "ForStatement" || parent.type === "WhileStatement" || parent.type === "DoWhileStatement" || parent.type === "DoExpression" || parent.type === "CatchClause" && !parentParent.finalizer || parent.type === "TSModuleDeclaration" || parent.type === "TSDeclareFunction" || node.type === "StaticBlock" || node.type === "ClassBody")) {
              parts.push(hardline);
            }
          }
          parts.push("}");
          return parts;
        }
        function printBlockBody(path5, options, print) {
          const node = path5.getValue();
          const nodeHasDirectives = isNonEmptyArray(node.directives);
          const nodeHasBody = node.body.some((node2) => node2.type !== "EmptyStatement");
          const nodeHasComment = hasComment(node, CommentCheckFlags.Dangling);
          if (!nodeHasDirectives && !nodeHasBody && !nodeHasComment) {
            return "";
          }
          const parts = [];
          if (nodeHasDirectives) {
            path5.each((childPath, index, directives) => {
              parts.push(print());
              if (index < directives.length - 1 || nodeHasBody || nodeHasComment) {
                parts.push(hardline);
                if (isNextLineEmpty(childPath.getValue(), options)) {
                  parts.push(hardline);
                }
              }
            }, "directives");
          }
          if (nodeHasBody) {
            parts.push(printBody(path5, options, print));
          }
          if (nodeHasComment) {
            parts.push(printDanglingComments(path5, options, true));
          }
          if (node.type === "Program") {
            const parent = path5.getParentNode();
            if (!parent || parent.type !== "ModuleExpression") {
              parts.push(hardline);
            }
          }
          return parts;
        }
        module22.exports = {
          printBlock,
          printBlockBody
        };
      }
    });
    var require_typescript = __commonJS22({
      "src/language-js/print/typescript.js"(exports22, module22) {
        "use strict";
        var {
          printDanglingComments
        } = require_comments();
        var {
          hasNewlineInRange
        } = require_util2();
        var {
          builders: {
            join: join2,
            line,
            hardline,
            softline,
            group,
            indent,
            conditionalGroup,
            ifBreak
          }
        } = require_doc();
        var {
          isLiteral,
          getTypeScriptMappedTypeModifier,
          shouldPrintComma,
          isCallExpression,
          isMemberExpression
        } = require_utils72();
        var isTsKeywordType = require_is_ts_keyword_type();
        var {
          locStart,
          locEnd
        } = require_loc();
        var {
          printOptionalToken,
          printTypeScriptModifiers
        } = require_misc();
        var {
          printTernary
        } = require_ternary();
        var {
          printFunctionParameters,
          shouldGroupFunctionParameters
        } = require_function_parameters();
        var {
          printTemplateLiteral
        } = require_template_literal();
        var {
          printArrayItems
        } = require_array4();
        var {
          printObject
        } = require_object();
        var {
          printClassProperty,
          printClassMethod
        } = require_class();
        var {
          printTypeParameter,
          printTypeParameters
        } = require_type_parameters();
        var {
          printPropertyKey
        } = require_property();
        var {
          printFunction,
          printMethodInternal
        } = require_function();
        var {
          printInterface
        } = require_interface();
        var {
          printBlock
        } = require_block();
        var {
          printTypeAlias,
          printIntersectionType,
          printUnionType,
          printFunctionType,
          printTupleType,
          printIndexedAccessType,
          printJSDocType
        } = require_type_annotation();
        function printTypescript(path5, options, print) {
          const node = path5.getValue();
          if (!node.type.startsWith("TS")) {
            return;
          }
          if (isTsKeywordType(node)) {
            return node.type.slice(2, -7).toLowerCase();
          }
          const semi = options.semi ? ";" : "";
          const parts = [];
          switch (node.type) {
            case "TSThisType":
              return "this";
            case "TSTypeAssertion": {
              const shouldBreakAfterCast = !(node.expression.type === "ArrayExpression" || node.expression.type === "ObjectExpression");
              const castGroup = group(["<", indent([softline, print("typeAnnotation")]), softline, ">"]);
              const exprContents = [ifBreak("("), indent([softline, print("expression")]), softline, ifBreak(")")];
              if (shouldBreakAfterCast) {
                return conditionalGroup([[castGroup, print("expression")], [castGroup, group(exprContents, {
                  shouldBreak: true
                })], [castGroup, print("expression")]]);
              }
              return group([castGroup, print("expression")]);
            }
            case "TSDeclareFunction":
              return printFunction(path5, print, options);
            case "TSExportAssignment":
              return ["export = ", print("expression"), semi];
            case "TSModuleBlock":
              return printBlock(path5, options, print);
            case "TSInterfaceBody":
            case "TSTypeLiteral":
              return printObject(path5, options, print);
            case "TSTypeAliasDeclaration":
              return printTypeAlias(path5, options, print);
            case "TSQualifiedName":
              return join2(".", [print("left"), print("right")]);
            case "TSAbstractMethodDefinition":
            case "TSDeclareMethod":
              return printClassMethod(path5, options, print);
            case "TSAbstractPropertyDefinition":
              return printClassProperty(path5, options, print);
            case "TSInterfaceHeritage":
            case "TSExpressionWithTypeArguments":
              parts.push(print("expression"));
              if (node.typeParameters) {
                parts.push(print("typeParameters"));
              }
              return parts;
            case "TSTemplateLiteralType":
              return printTemplateLiteral(path5, print, options);
            case "TSNamedTupleMember":
              return [print("label"), node.optional ? "?" : "", ": ", print("elementType")];
            case "TSRestType":
              return ["...", print("typeAnnotation")];
            case "TSOptionalType":
              return [print("typeAnnotation"), "?"];
            case "TSInterfaceDeclaration":
              return printInterface(path5, options, print);
            case "TSClassImplements":
              return [print("expression"), print("typeParameters")];
            case "TSTypeParameterDeclaration":
            case "TSTypeParameterInstantiation":
              return printTypeParameters(path5, options, print, "params");
            case "TSTypeParameter":
              return printTypeParameter(path5, options, print);
            case "TSAsExpression": {
              parts.push(print("expression"), " as ", print("typeAnnotation"));
              const parent = path5.getParentNode();
              if (isCallExpression(parent) && parent.callee === node || isMemberExpression(parent) && parent.object === node) {
                return group([indent([softline, ...parts]), softline]);
              }
              return parts;
            }
            case "TSArrayType":
              return [print("elementType"), "[]"];
            case "TSPropertySignature": {
              if (node.readonly) {
                parts.push("readonly ");
              }
              parts.push(printPropertyKey(path5, options, print), printOptionalToken(path5));
              if (node.typeAnnotation) {
                parts.push(": ", print("typeAnnotation"));
              }
              if (node.initializer) {
                parts.push(" = ", print("initializer"));
              }
              return parts;
            }
            case "TSParameterProperty":
              if (node.accessibility) {
                parts.push(node.accessibility + " ");
              }
              if (node.export) {
                parts.push("export ");
              }
              if (node.static) {
                parts.push("static ");
              }
              if (node.override) {
                parts.push("override ");
              }
              if (node.readonly) {
                parts.push("readonly ");
              }
              parts.push(print("parameter"));
              return parts;
            case "TSTypeQuery":
              return ["typeof ", print("exprName"), print("typeParameters")];
            case "TSIndexSignature": {
              const parent = path5.getParentNode();
              const trailingComma = node.parameters.length > 1 ? ifBreak(shouldPrintComma(options) ? "," : "") : "";
              const parametersGroup = group([indent([softline, join2([", ", softline], path5.map(print, "parameters"))]), trailingComma, softline]);
              return [node.export ? "export " : "", node.accessibility ? [node.accessibility, " "] : "", node.static ? "static " : "", node.readonly ? "readonly " : "", node.declare ? "declare " : "", "[", node.parameters ? parametersGroup : "", node.typeAnnotation ? "]: " : "]", node.typeAnnotation ? print("typeAnnotation") : "", parent.type === "ClassBody" ? semi : ""];
            }
            case "TSTypePredicate":
              return [node.asserts ? "asserts " : "", print("parameterName"), node.typeAnnotation ? [" is ", print("typeAnnotation")] : ""];
            case "TSNonNullExpression":
              return [print("expression"), "!"];
            case "TSImportType":
              return [!node.isTypeOf ? "" : "typeof ", "import(", print(node.parameter ? "parameter" : "argument"), ")", !node.qualifier ? "" : [".", print("qualifier")], printTypeParameters(path5, options, print, "typeParameters")];
            case "TSLiteralType":
              return print("literal");
            case "TSIndexedAccessType":
              return printIndexedAccessType(path5, options, print);
            case "TSConstructSignatureDeclaration":
            case "TSCallSignatureDeclaration":
            case "TSConstructorType": {
              if (node.type === "TSConstructorType" && node.abstract) {
                parts.push("abstract ");
              }
              if (node.type !== "TSCallSignatureDeclaration") {
                parts.push("new ");
              }
              parts.push(group(printFunctionParameters(path5, print, options, false, true)));
              if (node.returnType || node.typeAnnotation) {
                const isType = node.type === "TSConstructorType";
                parts.push(isType ? " => " : ": ", print("returnType"), print("typeAnnotation"));
              }
              return parts;
            }
            case "TSTypeOperator":
              return [node.operator, " ", print("typeAnnotation")];
            case "TSMappedType": {
              const shouldBreak = hasNewlineInRange(options.originalText, locStart(node), locEnd(node));
              return group(["{", indent([options.bracketSpacing ? line : softline, node.readonly ? [getTypeScriptMappedTypeModifier(node.readonly, "readonly"), " "] : "", printTypeScriptModifiers(path5, options, print), print("typeParameter"), node.optional ? getTypeScriptMappedTypeModifier(node.optional, "?") : "", node.typeAnnotation ? ": " : "", print("typeAnnotation"), ifBreak(semi)]), printDanglingComments(path5, options, true), options.bracketSpacing ? line : softline, "}"], {
                shouldBreak
              });
            }
            case "TSMethodSignature": {
              const kind = node.kind && node.kind !== "method" ? `${node.kind} ` : "";
              parts.push(node.accessibility ? [node.accessibility, " "] : "", kind, node.export ? "export " : "", node.static ? "static " : "", node.readonly ? "readonly " : "", node.abstract ? "abstract " : "", node.declare ? "declare " : "", node.computed ? "[" : "", print("key"), node.computed ? "]" : "", printOptionalToken(path5));
              const parametersDoc = printFunctionParameters(path5, print, options, false, true);
              const returnTypePropertyName = node.returnType ? "returnType" : "typeAnnotation";
              const returnTypeNode = node[returnTypePropertyName];
              const returnTypeDoc = returnTypeNode ? print(returnTypePropertyName) : "";
              const shouldGroupParameters = shouldGroupFunctionParameters(node, returnTypeDoc);
              parts.push(shouldGroupParameters ? group(parametersDoc) : parametersDoc);
              if (returnTypeNode) {
                parts.push(": ", group(returnTypeDoc));
              }
              return group(parts);
            }
            case "TSNamespaceExportDeclaration":
              parts.push("export as namespace ", print("id"));
              if (options.semi) {
                parts.push(";");
              }
              return group(parts);
            case "TSEnumDeclaration":
              if (node.declare) {
                parts.push("declare ");
              }
              if (node.modifiers) {
                parts.push(printTypeScriptModifiers(path5, options, print));
              }
              if (node.const) {
                parts.push("const ");
              }
              parts.push("enum ", print("id"), " ");
              if (node.members.length === 0) {
                parts.push(group(["{", printDanglingComments(path5, options), softline, "}"]));
              } else {
                parts.push(group(["{", indent([hardline, printArrayItems(path5, options, "members", print), shouldPrintComma(options, "es5") ? "," : ""]), printDanglingComments(path5, options, true), hardline, "}"]));
              }
              return parts;
            case "TSEnumMember":
              if (node.computed) {
                parts.push("[", print("id"), "]");
              } else {
                parts.push(print("id"));
              }
              if (node.initializer) {
                parts.push(" = ", print("initializer"));
              }
              return parts;
            case "TSImportEqualsDeclaration":
              if (node.isExport) {
                parts.push("export ");
              }
              parts.push("import ");
              if (node.importKind && node.importKind !== "value") {
                parts.push(node.importKind, " ");
              }
              parts.push(print("id"), " = ", print("moduleReference"));
              if (options.semi) {
                parts.push(";");
              }
              return group(parts);
            case "TSExternalModuleReference":
              return ["require(", print("expression"), ")"];
            case "TSModuleDeclaration": {
              const parent = path5.getParentNode();
              const isExternalModule = isLiteral(node.id);
              const parentIsDeclaration = parent.type === "TSModuleDeclaration";
              const bodyIsDeclaration = node.body && node.body.type === "TSModuleDeclaration";
              if (parentIsDeclaration) {
                parts.push(".");
              } else {
                if (node.declare) {
                  parts.push("declare ");
                }
                parts.push(printTypeScriptModifiers(path5, options, print));
                const textBetweenNodeAndItsId = options.originalText.slice(locStart(node), locStart(node.id));
                const isGlobalDeclaration = node.id.type === "Identifier" && node.id.name === "global" && !/namespace|module/.test(textBetweenNodeAndItsId);
                if (!isGlobalDeclaration) {
                  parts.push(isExternalModule || /(?:^|\s)module(?:\s|$)/.test(textBetweenNodeAndItsId) ? "module " : "namespace ");
                }
              }
              parts.push(print("id"));
              if (bodyIsDeclaration) {
                parts.push(print("body"));
              } else if (node.body) {
                parts.push(" ", group(print("body")));
              } else {
                parts.push(semi);
              }
              return parts;
            }
            case "TSConditionalType":
              return printTernary(path5, options, print);
            case "TSInferType":
              return ["infer", " ", print("typeParameter")];
            case "TSIntersectionType":
              return printIntersectionType(path5, options, print);
            case "TSUnionType":
              return printUnionType(path5, options, print);
            case "TSFunctionType":
              return printFunctionType(path5, options, print);
            case "TSTupleType":
              return printTupleType(path5, options, print);
            case "TSTypeReference":
              return [print("typeName"), printTypeParameters(path5, options, print, "typeParameters")];
            case "TSTypeAnnotation":
              return print("typeAnnotation");
            case "TSEmptyBodyFunctionExpression":
              return printMethodInternal(path5, options, print);
            case "TSJSDocAllType":
              return "*";
            case "TSJSDocUnknownType":
              return "?";
            case "TSJSDocNullableType":
              return printJSDocType(path5, print, "?");
            case "TSJSDocNonNullableType":
              return printJSDocType(path5, print, "!");
            case "TSInstantiationExpression":
              return [print("expression"), print("typeParameters")];
            default:
              throw new Error(`Unknown TypeScript node type: ${JSON.stringify(node.type)}.`);
          }
        }
        module22.exports = {
          printTypescript
        };
      }
    });
    var require_comment = __commonJS22({
      "src/language-js/print/comment.js"(exports22, module22) {
        "use strict";
        var {
          hasNewline
        } = require_util2();
        var {
          builders: {
            join: join2,
            hardline
          },
          utils: {
            replaceTextEndOfLine
          }
        } = require_doc();
        var {
          isLineComment
        } = require_utils72();
        var {
          locStart,
          locEnd
        } = require_loc();
        var isBlockComment = require_is_block_comment();
        function printComment(commentPath, options) {
          const comment = commentPath.getValue();
          if (isLineComment(comment)) {
            return options.originalText.slice(locStart(comment), locEnd(comment)).trimEnd();
          }
          if (isBlockComment(comment)) {
            if (isIndentableBlockComment(comment)) {
              const printed = printIndentableBlockComment(comment);
              if (comment.trailing && !hasNewline(options.originalText, locStart(comment), {
                backwards: true
              })) {
                return [hardline, printed];
              }
              return printed;
            }
            const commentEnd = locEnd(comment);
            const isInsideFlowComment = options.originalText.slice(commentEnd - 3, commentEnd) === "*-/";
            return ["/*", replaceTextEndOfLine(comment.value), isInsideFlowComment ? "*-/" : "*/"];
          }
          throw new Error("Not a comment: " + JSON.stringify(comment));
        }
        function isIndentableBlockComment(comment) {
          const lines = `*${comment.value}*`.split("\n");
          return lines.length > 1 && lines.every((line) => line.trim()[0] === "*");
        }
        function printIndentableBlockComment(comment) {
          const lines = comment.value.split("\n");
          return ["/*", join2(hardline, lines.map((line, index) => index === 0 ? line.trimEnd() : " " + (index < lines.length - 1 ? line.trim() : line.trimStart()))), "*/"];
        }
        module22.exports = {
          printComment
        };
      }
    });
    var require_literal = __commonJS22({
      "src/language-js/print/literal.js"(exports22, module22) {
        "use strict";
        var {
          printString,
          printNumber
        } = require_util2();
        function printLiteral(path5, options) {
          const node = path5.getNode();
          switch (node.type) {
            case "RegExpLiteral":
              return printRegex(node);
            case "BigIntLiteral":
              return printBigInt(node.bigint || node.extra.raw);
            case "NumericLiteral":
              return printNumber(node.extra.raw);
            case "StringLiteral":
              return printString(node.extra.raw, options);
            case "NullLiteral":
              return "null";
            case "BooleanLiteral":
              return String(node.value);
            case "DecimalLiteral":
              return printNumber(node.value) + "m";
            case "Literal": {
              if (node.regex) {
                return printRegex(node.regex);
              }
              if (node.bigint) {
                return printBigInt(node.raw);
              }
              if (node.decimal) {
                return printNumber(node.decimal) + "m";
              }
              const {
                value
              } = node;
              if (typeof value === "number") {
                return printNumber(node.raw);
              }
              if (typeof value === "string") {
                return printString(node.raw, options);
              }
              return String(value);
            }
          }
        }
        function printBigInt(raw) {
          return raw.toLowerCase();
        }
        function printRegex({
          pattern,
          flags
        }) {
          flags = [...flags].sort().join("");
          return `/${pattern}/${flags}`;
        }
        module22.exports = {
          printLiteral
        };
      }
    });
    var require_printer_estree = __commonJS22({
      "src/language-js/printer-estree.js"(exports22, module22) {
        "use strict";
        var {
          printDanglingComments
        } = require_comments();
        var {
          hasNewline
        } = require_util2();
        var {
          builders: {
            join: join2,
            line,
            hardline,
            softline,
            group,
            indent
          },
          utils: {
            replaceTextEndOfLine
          }
        } = require_doc();
        var embed = require_embed();
        var clean = require_clean();
        var {
          insertPragma
        } = require_pragma();
        var handleComments = require_comments2();
        var pathNeedsParens = require_needs_parens();
        var preprocess = require_print_preprocess();
        var {
          hasFlowShorthandAnnotationComment,
          hasComment,
          CommentCheckFlags,
          isTheOnlyJsxElementInMarkdown,
          isLineComment,
          isNextLineEmpty,
          needsHardlineAfterDanglingComment,
          rawText,
          hasIgnoreComment,
          isCallExpression,
          isMemberExpression,
          markerForIfWithoutBlockAndSameLineComment
        } = require_utils72();
        var {
          locStart,
          locEnd
        } = require_loc();
        var isBlockComment = require_is_block_comment();
        var {
          printHtmlBinding,
          isVueEventBindingExpression
        } = require_html_binding();
        var {
          printAngular
        } = require_angular();
        var {
          printJsx,
          hasJsxIgnoreComment
        } = require_jsx();
        var {
          printFlow
        } = require_flow();
        var {
          printTypescript
        } = require_typescript();
        var {
          printOptionalToken,
          printBindExpressionCallee,
          printTypeAnnotation,
          adjustClause,
          printRestSpread,
          printDefiniteToken
        } = require_misc();
        var {
          printImportDeclaration,
          printExportDeclaration,
          printExportAllDeclaration,
          printModuleSpecifier
        } = require_module();
        var {
          printTernary
        } = require_ternary();
        var {
          printTemplateLiteral
        } = require_template_literal();
        var {
          printArray
        } = require_array4();
        var {
          printObject
        } = require_object();
        var {
          printClass,
          printClassMethod,
          printClassProperty
        } = require_class();
        var {
          printProperty
        } = require_property();
        var {
          printFunction,
          printArrowFunction,
          printMethod,
          printReturnStatement,
          printThrowStatement
        } = require_function();
        var {
          printCallExpression
        } = require_call_expression();
        var {
          printVariableDeclarator,
          printAssignmentExpression
        } = require_assignment();
        var {
          printBinaryishExpression
        } = require_binaryish();
        var {
          printSwitchCaseConsequent
        } = require_statement();
        var {
          printMemberExpression
        } = require_member();
        var {
          printBlock,
          printBlockBody
        } = require_block();
        var {
          printComment
        } = require_comment();
        var {
          printLiteral
        } = require_literal();
        var {
          printDecorators
        } = require_decorators();
        function genericPrint(path5, options, print, args) {
          const printed = printPathNoParens(path5, options, print, args);
          if (!printed) {
            return "";
          }
          const node = path5.getValue();
          const {
            type: type2
          } = node;
          if (type2 === "ClassMethod" || type2 === "ClassPrivateMethod" || type2 === "ClassProperty" || type2 === "ClassAccessorProperty" || type2 === "PropertyDefinition" || type2 === "TSAbstractPropertyDefinition" || type2 === "ClassPrivateProperty" || type2 === "MethodDefinition" || type2 === "TSAbstractMethodDefinition" || type2 === "TSDeclareMethod") {
            return printed;
          }
          let parts = [printed];
          const printedDecorators = printDecorators(path5, options, print);
          const isClassExpressionWithDecorators = node.type === "ClassExpression" && printedDecorators;
          if (printedDecorators) {
            parts = [...printedDecorators, printed];
            if (!isClassExpressionWithDecorators) {
              return group(parts);
            }
          }
          const needsParens = pathNeedsParens(path5, options);
          if (!needsParens) {
            if (args && args.needsSemi) {
              parts.unshift(";");
            }
            if (parts.length === 1 && parts[0] === printed) {
              return printed;
            }
            return parts;
          }
          if (isClassExpressionWithDecorators) {
            parts = [indent([line, ...parts])];
          }
          parts.unshift("(");
          if (args && args.needsSemi) {
            parts.unshift(";");
          }
          if (hasFlowShorthandAnnotationComment(node)) {
            const [comment] = node.trailingComments;
            parts.push(" /*", comment.value.trimStart(), "*/");
            comment.printed = true;
          }
          if (isClassExpressionWithDecorators) {
            parts.push(line);
          }
          parts.push(")");
          return parts;
        }
        function printPathNoParens(path5, options, print, args) {
          const node = path5.getValue();
          const semi = options.semi ? ";" : "";
          if (!node) {
            return "";
          }
          if (typeof node === "string") {
            return node;
          }
          for (const printer of [printLiteral, printHtmlBinding, printAngular, printJsx, printFlow, printTypescript]) {
            const printed = printer(path5, options, print);
            if (typeof printed !== "undefined") {
              return printed;
            }
          }
          let parts = [];
          switch (node.type) {
            case "JsExpressionRoot":
              return print("node");
            case "JsonRoot":
              return [print("node"), hardline];
            case "File":
              if (node.program && node.program.interpreter) {
                parts.push(print(["program", "interpreter"]));
              }
              parts.push(print("program"));
              return parts;
            case "Program":
              return printBlockBody(path5, options, print);
            case "EmptyStatement":
              return "";
            case "ExpressionStatement": {
              if (node.directive) {
                return [printDirective(node.expression, options), semi];
              }
              if (options.parser === "__vue_event_binding" || options.parser === "__vue_ts_event_binding") {
                const parent = path5.getParentNode();
                if (parent.type === "Program" && parent.body.length === 1 && parent.body[0] === node) {
                  return [print("expression"), isVueEventBindingExpression(node.expression) ? ";" : ""];
                }
              }
              const danglingComment = printDanglingComments(path5, options, true, ({
                marker
              }) => marker === markerForIfWithoutBlockAndSameLineComment);
              return [print("expression"), isTheOnlyJsxElementInMarkdown(options, path5) ? "" : semi, danglingComment ? [" ", danglingComment] : ""];
            }
            case "ParenthesizedExpression": {
              const shouldHug = !hasComment(node.expression) && (node.expression.type === "ObjectExpression" || node.expression.type === "ArrayExpression");
              if (shouldHug) {
                return ["(", print("expression"), ")"];
              }
              return group(["(", indent([softline, print("expression")]), softline, ")"]);
            }
            case "AssignmentExpression":
              return printAssignmentExpression(path5, options, print);
            case "VariableDeclarator":
              return printVariableDeclarator(path5, options, print);
            case "BinaryExpression":
            case "LogicalExpression":
              return printBinaryishExpression(path5, options, print);
            case "AssignmentPattern":
              return [print("left"), " = ", print("right")];
            case "OptionalMemberExpression":
            case "MemberExpression": {
              return printMemberExpression(path5, options, print);
            }
            case "MetaProperty":
              return [print("meta"), ".", print("property")];
            case "BindExpression":
              if (node.object) {
                parts.push(print("object"));
              }
              parts.push(group(indent([softline, printBindExpressionCallee(path5, options, print)])));
              return parts;
            case "Identifier": {
              return [node.name, printOptionalToken(path5), printDefiniteToken(path5), printTypeAnnotation(path5, options, print)];
            }
            case "V8IntrinsicIdentifier":
              return ["%", node.name];
            case "SpreadElement":
            case "SpreadElementPattern":
            case "SpreadProperty":
            case "SpreadPropertyPattern":
            case "RestElement":
              return printRestSpread(path5, options, print);
            case "FunctionDeclaration":
            case "FunctionExpression":
              return printFunction(path5, print, options, args);
            case "ArrowFunctionExpression":
              return printArrowFunction(path5, options, print, args);
            case "YieldExpression":
              parts.push("yield");
              if (node.delegate) {
                parts.push("*");
              }
              if (node.argument) {
                parts.push(" ", print("argument"));
              }
              return parts;
            case "AwaitExpression": {
              parts.push("await");
              if (node.argument) {
                parts.push(" ", print("argument"));
                const parent = path5.getParentNode();
                if (isCallExpression(parent) && parent.callee === node || isMemberExpression(parent) && parent.object === node) {
                  parts = [indent([softline, ...parts]), softline];
                  const parentAwaitOrBlock = path5.findAncestor((node2) => node2.type === "AwaitExpression" || node2.type === "BlockStatement");
                  if (!parentAwaitOrBlock || parentAwaitOrBlock.type !== "AwaitExpression") {
                    return group(parts);
                  }
                }
              }
              return parts;
            }
            case "ExportDefaultDeclaration":
            case "ExportNamedDeclaration":
              return printExportDeclaration(path5, options, print);
            case "ExportAllDeclaration":
              return printExportAllDeclaration(path5, options, print);
            case "ImportDeclaration":
              return printImportDeclaration(path5, options, print);
            case "ImportSpecifier":
            case "ExportSpecifier":
            case "ImportNamespaceSpecifier":
            case "ExportNamespaceSpecifier":
            case "ImportDefaultSpecifier":
            case "ExportDefaultSpecifier":
              return printModuleSpecifier(path5, options, print);
            case "ImportAttribute":
              return [print("key"), ": ", print("value")];
            case "Import":
              return "import";
            case "BlockStatement":
            case "StaticBlock":
            case "ClassBody":
              return printBlock(path5, options, print);
            case "ThrowStatement":
              return printThrowStatement(path5, options, print);
            case "ReturnStatement":
              return printReturnStatement(path5, options, print);
            case "NewExpression":
            case "ImportExpression":
            case "OptionalCallExpression":
            case "CallExpression":
              return printCallExpression(path5, options, print);
            case "ObjectExpression":
            case "ObjectPattern":
            case "RecordExpression":
              return printObject(path5, options, print);
            case "ObjectProperty":
            case "Property":
              if (node.method || node.kind === "get" || node.kind === "set") {
                return printMethod(path5, options, print);
              }
              return printProperty(path5, options, print);
            case "ObjectMethod":
              return printMethod(path5, options, print);
            case "Decorator":
              return ["@", print("expression")];
            case "ArrayExpression":
            case "ArrayPattern":
            case "TupleExpression":
              return printArray(path5, options, print);
            case "SequenceExpression": {
              const parent = path5.getParentNode(0);
              if (parent.type === "ExpressionStatement" || parent.type === "ForStatement") {
                const parts2 = [];
                path5.each((expressionPath, index) => {
                  if (index === 0) {
                    parts2.push(print());
                  } else {
                    parts2.push(",", indent([line, print()]));
                  }
                }, "expressions");
                return group(parts2);
              }
              return group(join2([",", line], path5.map(print, "expressions")));
            }
            case "ThisExpression":
              return "this";
            case "Super":
              return "super";
            case "Directive":
              return [print("value"), semi];
            case "DirectiveLiteral":
              return printDirective(node, options);
            case "UnaryExpression":
              parts.push(node.operator);
              if (/[a-z]$/.test(node.operator)) {
                parts.push(" ");
              }
              if (hasComment(node.argument)) {
                parts.push(group(["(", indent([softline, print("argument")]), softline, ")"]));
              } else {
                parts.push(print("argument"));
              }
              return parts;
            case "UpdateExpression":
              parts.push(print("argument"), node.operator);
              if (node.prefix) {
                parts.reverse();
              }
              return parts;
            case "ConditionalExpression":
              return printTernary(path5, options, print);
            case "VariableDeclaration": {
              const printed = path5.map(print, "declarations");
              const parentNode = path5.getParentNode();
              const isParentForLoop = parentNode.type === "ForStatement" || parentNode.type === "ForInStatement" || parentNode.type === "ForOfStatement";
              const hasValue = node.declarations.some((decl) => decl.init);
              let firstVariable;
              if (printed.length === 1 && !hasComment(node.declarations[0])) {
                firstVariable = printed[0];
              } else if (printed.length > 0) {
                firstVariable = indent(printed[0]);
              }
              parts = [node.declare ? "declare " : "", node.kind, firstVariable ? [" ", firstVariable] : "", indent(printed.slice(1).map((p) => [",", hasValue && !isParentForLoop ? hardline : line, p]))];
              if (!(isParentForLoop && parentNode.body !== node)) {
                parts.push(semi);
              }
              return group(parts);
            }
            case "WithStatement":
              return group(["with (", print("object"), ")", adjustClause(node.body, print("body"))]);
            case "IfStatement": {
              const con = adjustClause(node.consequent, print("consequent"));
              const opening = group(["if (", group([indent([softline, print("test")]), softline]), ")", con]);
              parts.push(opening);
              if (node.alternate) {
                const commentOnOwnLine = hasComment(node.consequent, CommentCheckFlags.Trailing | CommentCheckFlags.Line) || needsHardlineAfterDanglingComment(node);
                const elseOnSameLine = node.consequent.type === "BlockStatement" && !commentOnOwnLine;
                parts.push(elseOnSameLine ? " " : hardline);
                if (hasComment(node, CommentCheckFlags.Dangling)) {
                  parts.push(printDanglingComments(path5, options, true), commentOnOwnLine ? hardline : " ");
                }
                parts.push("else", group(adjustClause(node.alternate, print("alternate"), node.alternate.type === "IfStatement")));
              }
              return parts;
            }
            case "ForStatement": {
              const body = adjustClause(node.body, print("body"));
              const dangling = printDanglingComments(path5, options, true);
              const printedComments = dangling ? [dangling, softline] : "";
              if (!node.init && !node.test && !node.update) {
                return [printedComments, group(["for (;;)", body])];
              }
              return [printedComments, group(["for (", group([indent([softline, print("init"), ";", line, print("test"), ";", line, print("update")]), softline]), ")", body])];
            }
            case "WhileStatement":
              return group(["while (", group([indent([softline, print("test")]), softline]), ")", adjustClause(node.body, print("body"))]);
            case "ForInStatement":
              return group(["for (", print("left"), " in ", print("right"), ")", adjustClause(node.body, print("body"))]);
            case "ForOfStatement":
              return group(["for", node.await ? " await" : "", " (", print("left"), " of ", print("right"), ")", adjustClause(node.body, print("body"))]);
            case "DoWhileStatement": {
              const clause = adjustClause(node.body, print("body"));
              const doBody = group(["do", clause]);
              parts = [doBody];
              if (node.body.type === "BlockStatement") {
                parts.push(" ");
              } else {
                parts.push(hardline);
              }
              parts.push("while (", group([indent([softline, print("test")]), softline]), ")", semi);
              return parts;
            }
            case "DoExpression":
              return [node.async ? "async " : "", "do ", print("body")];
            case "BreakStatement":
              parts.push("break");
              if (node.label) {
                parts.push(" ", print("label"));
              }
              parts.push(semi);
              return parts;
            case "ContinueStatement":
              parts.push("continue");
              if (node.label) {
                parts.push(" ", print("label"));
              }
              parts.push(semi);
              return parts;
            case "LabeledStatement":
              if (node.body.type === "EmptyStatement") {
                return [print("label"), ":;"];
              }
              return [print("label"), ": ", print("body")];
            case "TryStatement":
              return ["try ", print("block"), node.handler ? [" ", print("handler")] : "", node.finalizer ? [" finally ", print("finalizer")] : ""];
            case "CatchClause":
              if (node.param) {
                const parameterHasComments = hasComment(node.param, (comment) => !isBlockComment(comment) || comment.leading && hasNewline(options.originalText, locEnd(comment)) || comment.trailing && hasNewline(options.originalText, locStart(comment), {
                  backwards: true
                }));
                const param = print("param");
                return ["catch ", parameterHasComments ? ["(", indent([softline, param]), softline, ") "] : ["(", param, ") "], print("body")];
              }
              return ["catch ", print("body")];
            case "SwitchStatement":
              return [group(["switch (", indent([softline, print("discriminant")]), softline, ")"]), " {", node.cases.length > 0 ? indent([hardline, join2(hardline, path5.map((casePath, index, cases) => {
                const caseNode = casePath.getValue();
                return [print(), index !== cases.length - 1 && isNextLineEmpty(caseNode, options) ? hardline : ""];
              }, "cases"))]) : "", hardline, "}"];
            case "SwitchCase": {
              if (node.test) {
                parts.push("case ", print("test"), ":");
              } else {
                parts.push("default:");
              }
              if (hasComment(node, CommentCheckFlags.Dangling)) {
                parts.push(" ", printDanglingComments(path5, options, true));
              }
              const consequent = node.consequent.filter((node2) => node2.type !== "EmptyStatement");
              if (consequent.length > 0) {
                const cons = printSwitchCaseConsequent(path5, options, print);
                parts.push(consequent.length === 1 && consequent[0].type === "BlockStatement" ? [" ", cons] : indent([hardline, cons]));
              }
              return parts;
            }
            case "DebuggerStatement":
              return ["debugger", semi];
            case "ClassDeclaration":
            case "ClassExpression":
              return printClass(path5, options, print);
            case "ClassMethod":
            case "ClassPrivateMethod":
            case "MethodDefinition":
              return printClassMethod(path5, options, print);
            case "ClassProperty":
            case "PropertyDefinition":
            case "ClassPrivateProperty":
            case "ClassAccessorProperty":
              return printClassProperty(path5, options, print);
            case "TemplateElement":
              return replaceTextEndOfLine(node.value.raw);
            case "TemplateLiteral":
              return printTemplateLiteral(path5, print, options);
            case "TaggedTemplateExpression":
              return [print("tag"), print("typeParameters"), print("quasi")];
            case "PrivateIdentifier":
              return ["#", print("name")];
            case "PrivateName":
              return ["#", print("id")];
            case "InterpreterDirective":
              parts.push("#!", node.value, hardline);
              if (isNextLineEmpty(node, options)) {
                parts.push(hardline);
              }
              return parts;
            case "TopicReference":
              return "%";
            case "ArgumentPlaceholder":
              return "?";
            case "ModuleExpression": {
              parts.push("module {");
              const printed = print("body");
              if (printed) {
                parts.push(indent([hardline, printed]), hardline);
              }
              parts.push("}");
              return parts;
            }
            default:
              throw new Error("unknown type: " + JSON.stringify(node.type));
          }
        }
        function printDirective(node, options) {
          const raw = rawText(node);
          const rawContent = raw.slice(1, -1);
          if (rawContent.includes('"') || rawContent.includes("'")) {
            return raw;
          }
          const enclosingQuote = options.singleQuote ? "'" : '"';
          return enclosingQuote + rawContent + enclosingQuote;
        }
        function canAttachComment(node) {
          return node.type && !isBlockComment(node) && !isLineComment(node) && node.type !== "EmptyStatement" && node.type !== "TemplateElement" && node.type !== "Import" && node.type !== "TSEmptyBodyFunctionExpression";
        }
        module22.exports = {
          preprocess,
          print: genericPrint,
          embed,
          insertPragma,
          massageAstNode: clean,
          hasPrettierIgnore(path5) {
            return hasIgnoreComment(path5) || hasJsxIgnoreComment(path5);
          },
          willPrintOwnComments: handleComments.willPrintOwnComments,
          canAttachComment,
          printComment,
          isBlockComment,
          handleComments: {
            avoidAstMutation: true,
            ownLine: handleComments.handleOwnLineComment,
            endOfLine: handleComments.handleEndOfLineComment,
            remaining: handleComments.handleRemainingComment
          },
          getCommentChildNodes: handleComments.getCommentChildNodes
        };
      }
    });
    var require_printer_estree_json = __commonJS22({
      "src/language-js/printer-estree-json.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            hardline,
            indent,
            join: join2
          }
        } = require_doc();
        var preprocess = require_print_preprocess();
        function genericPrint(path5, options, print) {
          const node = path5.getValue();
          switch (node.type) {
            case "JsonRoot":
              return [print("node"), hardline];
            case "ArrayExpression": {
              if (node.elements.length === 0) {
                return "[]";
              }
              const printed = path5.map(() => path5.getValue() === null ? "null" : print(), "elements");
              return ["[", indent([hardline, join2([",", hardline], printed)]), hardline, "]"];
            }
            case "ObjectExpression":
              return node.properties.length === 0 ? "{}" : ["{", indent([hardline, join2([",", hardline], path5.map(print, "properties"))]), hardline, "}"];
            case "ObjectProperty":
              return [print("key"), ": ", print("value")];
            case "UnaryExpression":
              return [node.operator === "+" ? "" : node.operator, print("argument")];
            case "NullLiteral":
              return "null";
            case "BooleanLiteral":
              return node.value ? "true" : "false";
            case "StringLiteral":
            case "NumericLiteral":
              return JSON.stringify(node.value);
            case "Identifier": {
              const parent = path5.getParentNode();
              if (parent && parent.type === "ObjectProperty" && parent.key === node) {
                return JSON.stringify(node.name);
              }
              return node.name;
            }
            case "TemplateLiteral":
              return print(["quasis", 0]);
            case "TemplateElement":
              return JSON.stringify(node.value.cooked);
            default:
              throw new Error("unknown type: " + JSON.stringify(node.type));
          }
        }
        var ignoredProperties = /* @__PURE__ */ new Set(["start", "end", "extra", "loc", "comments", "leadingComments", "trailingComments", "innerComments", "errors", "range", "tokens"]);
        function clean(node, newNode) {
          const {
            type: type2
          } = node;
          if (type2 === "ObjectProperty" && node.key.type === "Identifier") {
            newNode.key = {
              type: "StringLiteral",
              value: node.key.name
            };
            return;
          }
          if (type2 === "UnaryExpression" && node.operator === "+") {
            return newNode.argument;
          }
          if (type2 === "ArrayExpression") {
            for (const [index, element] of node.elements.entries()) {
              if (element === null) {
                newNode.elements.splice(index, 0, {
                  type: "NullLiteral"
                });
              }
            }
            return;
          }
          if (type2 === "TemplateLiteral") {
            return {
              type: "StringLiteral",
              value: node.quasis[0].value.cooked
            };
          }
        }
        clean.ignoredProperties = ignoredProperties;
        module22.exports = {
          preprocess,
          print: genericPrint,
          massageAstNode: clean
        };
      }
    });
    var require_common_options = __commonJS22({
      "src/common/common-options.js"(exports22, module22) {
        "use strict";
        var CATEGORY_COMMON = "Common";
        module22.exports = {
          bracketSpacing: {
            since: "0.0.0",
            category: CATEGORY_COMMON,
            type: "boolean",
            default: true,
            description: "Print spaces between brackets.",
            oppositeDescription: "Do not print spaces between brackets."
          },
          singleQuote: {
            since: "0.0.0",
            category: CATEGORY_COMMON,
            type: "boolean",
            default: false,
            description: "Use single quotes instead of double quotes."
          },
          proseWrap: {
            since: "1.8.2",
            category: CATEGORY_COMMON,
            type: "choice",
            default: [{
              since: "1.8.2",
              value: true
            }, {
              since: "1.9.0",
              value: "preserve"
            }],
            description: "How to wrap prose.",
            choices: [{
              since: "1.9.0",
              value: "always",
              description: "Wrap prose if it exceeds the print width."
            }, {
              since: "1.9.0",
              value: "never",
              description: "Do not wrap prose."
            }, {
              since: "1.9.0",
              value: "preserve",
              description: "Wrap prose as-is."
            }]
          },
          bracketSameLine: {
            since: "2.4.0",
            category: CATEGORY_COMMON,
            type: "boolean",
            default: false,
            description: "Put > of opening tags on the last line instead of on a new line."
          },
          singleAttributePerLine: {
            since: "2.6.0",
            category: CATEGORY_COMMON,
            type: "boolean",
            default: false,
            description: "Enforce single attribute per line in HTML, Vue and JSX."
          }
        };
      }
    });
    var require_options2 = __commonJS22({
      "src/language-js/options.js"(exports22, module22) {
        "use strict";
        var commonOptions = require_common_options();
        var CATEGORY_JAVASCRIPT = "JavaScript";
        module22.exports = {
          arrowParens: {
            since: "1.9.0",
            category: CATEGORY_JAVASCRIPT,
            type: "choice",
            default: [{
              since: "1.9.0",
              value: "avoid"
            }, {
              since: "2.0.0",
              value: "always"
            }],
            description: "Include parentheses around a sole arrow function parameter.",
            choices: [{
              value: "always",
              description: "Always include parens. Example: `(x) => x`"
            }, {
              value: "avoid",
              description: "Omit parens when possible. Example: `x => x`"
            }]
          },
          bracketSameLine: commonOptions.bracketSameLine,
          bracketSpacing: commonOptions.bracketSpacing,
          jsxBracketSameLine: {
            since: "0.17.0",
            category: CATEGORY_JAVASCRIPT,
            type: "boolean",
            description: "Put > on the last line instead of at a new line.",
            deprecated: "2.4.0"
          },
          semi: {
            since: "1.0.0",
            category: CATEGORY_JAVASCRIPT,
            type: "boolean",
            default: true,
            description: "Print semicolons.",
            oppositeDescription: "Do not print semicolons, except at the beginning of lines which may need them."
          },
          singleQuote: commonOptions.singleQuote,
          jsxSingleQuote: {
            since: "1.15.0",
            category: CATEGORY_JAVASCRIPT,
            type: "boolean",
            default: false,
            description: "Use single quotes in JSX."
          },
          quoteProps: {
            since: "1.17.0",
            category: CATEGORY_JAVASCRIPT,
            type: "choice",
            default: "as-needed",
            description: "Change when properties in objects are quoted.",
            choices: [{
              value: "as-needed",
              description: "Only add quotes around object properties where required."
            }, {
              value: "consistent",
              description: "If at least one property in an object requires quotes, quote all properties."
            }, {
              value: "preserve",
              description: "Respect the input use of quotes in object properties."
            }]
          },
          trailingComma: {
            since: "0.0.0",
            category: CATEGORY_JAVASCRIPT,
            type: "choice",
            default: [{
              since: "0.0.0",
              value: false
            }, {
              since: "0.19.0",
              value: "none"
            }, {
              since: "2.0.0",
              value: "es5"
            }],
            description: "Print trailing commas wherever possible when multi-line.",
            choices: [{
              value: "es5",
              description: "Trailing commas where valid in ES5 (objects, arrays, etc.)"
            }, {
              value: "none",
              description: "No trailing commas."
            }, {
              value: "all",
              description: "Trailing commas wherever possible (including function arguments)."
            }]
          },
          singleAttributePerLine: commonOptions.singleAttributePerLine
        };
      }
    });
    var require_parsers = __commonJS22({
      "src/language-js/parse/parsers.js"(exports22, module22) {
        "use strict";
        module22.exports = {
          get babel() {
            return require_parser_babel().parsers.babel;
          },
          get "babel-flow"() {
            return require_parser_babel().parsers["babel-flow"];
          },
          get "babel-ts"() {
            return require_parser_babel().parsers["babel-ts"];
          },
          get json() {
            return require_parser_babel().parsers.json;
          },
          get json5() {
            return require_parser_babel().parsers.json5;
          },
          get "json-stringify"() {
            return require_parser_babel().parsers["json-stringify"];
          },
          get __js_expression() {
            return require_parser_babel().parsers.__js_expression;
          },
          get __vue_expression() {
            return require_parser_babel().parsers.__vue_expression;
          },
          get __vue_ts_expression() {
            return require_parser_babel().parsers.__vue_ts_expression;
          },
          get __vue_event_binding() {
            return require_parser_babel().parsers.__vue_event_binding;
          },
          get __vue_ts_event_binding() {
            return require_parser_babel().parsers.__vue_ts_event_binding;
          },
          get flow() {
            return require_parser_flow().parsers.flow;
          },
          get typescript() {
            return require_parser_typescript().parsers.typescript;
          },
          get __ng_action() {
            return require_parser_angular().parsers.__ng_action;
          },
          get __ng_binding() {
            return require_parser_angular().parsers.__ng_binding;
          },
          get __ng_interpolation() {
            return require_parser_angular().parsers.__ng_interpolation;
          },
          get __ng_directive() {
            return require_parser_angular().parsers.__ng_directive;
          },
          get acorn() {
            return require_parser_espree().parsers.acorn;
          },
          get espree() {
            return require_parser_espree().parsers.espree;
          },
          get meriyah() {
            return require_parser_meriyah().parsers.meriyah;
          },
          get __babel_estree() {
            return require_parser_babel().parsers.__babel_estree;
          }
        };
      }
    });
    var require_JavaScript = __commonJS22({
      "node_modules/linguist-languages/data/JavaScript.json"(exports22, module22) {
        module22.exports = {
          name: "JavaScript",
          type: "programming",
          tmScope: "source.js",
          aceMode: "javascript",
          codemirrorMode: "javascript",
          codemirrorMimeType: "text/javascript",
          color: "#f1e05a",
          aliases: ["js", "node"],
          extensions: [".js", "._js", ".bones", ".cjs", ".es", ".es6", ".frag", ".gs", ".jake", ".javascript", ".jsb", ".jscad", ".jsfl", ".jslib", ".jsm", ".jspre", ".jss", ".jsx", ".mjs", ".njs", ".pac", ".sjs", ".ssjs", ".xsjs", ".xsjslib"],
          filenames: ["Jakefile"],
          interpreters: ["chakra", "d8", "gjs", "js", "node", "nodejs", "qjs", "rhino", "v8", "v8-shell"],
          languageId: 183
        };
      }
    });
    var require_TypeScript = __commonJS22({
      "node_modules/linguist-languages/data/TypeScript.json"(exports22, module22) {
        module22.exports = {
          name: "TypeScript",
          type: "programming",
          color: "#3178c6",
          aliases: ["ts"],
          interpreters: ["deno", "ts-node"],
          extensions: [".ts", ".cts", ".mts"],
          tmScope: "source.ts",
          aceMode: "typescript",
          codemirrorMode: "javascript",
          codemirrorMimeType: "application/typescript",
          languageId: 378
        };
      }
    });
    var require_TSX = __commonJS22({
      "node_modules/linguist-languages/data/TSX.json"(exports22, module22) {
        module22.exports = {
          name: "TSX",
          type: "programming",
          color: "#3178c6",
          group: "TypeScript",
          extensions: [".tsx"],
          tmScope: "source.tsx",
          aceMode: "javascript",
          codemirrorMode: "jsx",
          codemirrorMimeType: "text/jsx",
          languageId: 94901924
        };
      }
    });
    var require_JSON = __commonJS22({
      "node_modules/linguist-languages/data/JSON.json"(exports22, module22) {
        module22.exports = {
          name: "JSON",
          type: "data",
          color: "#292929",
          tmScope: "source.json",
          aceMode: "json",
          codemirrorMode: "javascript",
          codemirrorMimeType: "application/json",
          aliases: ["geojson", "jsonl", "topojson"],
          extensions: [".json", ".4DForm", ".4DProject", ".avsc", ".geojson", ".gltf", ".har", ".ice", ".JSON-tmLanguage", ".jsonl", ".mcmeta", ".tfstate", ".tfstate.backup", ".topojson", ".webapp", ".webmanifest", ".yy", ".yyp"],
          filenames: [".arcconfig", ".auto-changelog", ".c8rc", ".htmlhintrc", ".imgbotconfig", ".nycrc", ".tern-config", ".tern-project", ".watchmanconfig", "Pipfile.lock", "composer.lock", "mcmod.info"],
          languageId: 174
        };
      }
    });
    var require_JSON_with_Comments = __commonJS22({
      "node_modules/linguist-languages/data/JSON with Comments.json"(exports22, module22) {
        module22.exports = {
          name: "JSON with Comments",
          type: "data",
          color: "#292929",
          group: "JSON",
          tmScope: "source.js",
          aceMode: "javascript",
          codemirrorMode: "javascript",
          codemirrorMimeType: "text/javascript",
          aliases: ["jsonc"],
          extensions: [".jsonc", ".code-snippets", ".sublime-build", ".sublime-commands", ".sublime-completions", ".sublime-keymap", ".sublime-macro", ".sublime-menu", ".sublime-mousemap", ".sublime-project", ".sublime-settings", ".sublime-theme", ".sublime-workspace", ".sublime_metrics", ".sublime_session"],
          filenames: [".babelrc", ".devcontainer.json", ".eslintrc.json", ".jscsrc", ".jshintrc", ".jslintrc", "api-extractor.json", "devcontainer.json", "jsconfig.json", "language-configuration.json", "tsconfig.json", "tslint.json"],
          languageId: 423
        };
      }
    });
    var require_JSON5 = __commonJS22({
      "node_modules/linguist-languages/data/JSON5.json"(exports22, module22) {
        module22.exports = {
          name: "JSON5",
          type: "data",
          color: "#267CB9",
          extensions: [".json5"],
          tmScope: "source.js",
          aceMode: "javascript",
          codemirrorMode: "javascript",
          codemirrorMimeType: "application/json",
          languageId: 175
        };
      }
    });
    var require_language_js = __commonJS22({
      "src/language-js/index.js"(exports22, module22) {
        "use strict";
        var createLanguage = require_create_language();
        var estreePrinter = require_printer_estree();
        var estreeJsonPrinter = require_printer_estree_json();
        var options = require_options2();
        var parsers = require_parsers();
        var languages = [createLanguage(require_JavaScript(), (data) => ({
          since: "0.0.0",
          parsers: ["babel", "acorn", "espree", "meriyah", "babel-flow", "babel-ts", "flow", "typescript"],
          vscodeLanguageIds: ["javascript", "mongo"],
          interpreters: [...data.interpreters, "zx"],
          extensions: [...data.extensions.filter((extension) => extension !== ".jsx"), ".wxs"]
        })), createLanguage(require_JavaScript(), () => ({
          name: "Flow",
          since: "0.0.0",
          parsers: ["flow", "babel-flow"],
          vscodeLanguageIds: ["javascript"],
          aliases: [],
          filenames: [],
          extensions: [".js.flow"]
        })), createLanguage(require_JavaScript(), () => ({
          name: "JSX",
          since: "0.0.0",
          parsers: ["babel", "babel-flow", "babel-ts", "flow", "typescript", "espree", "meriyah"],
          vscodeLanguageIds: ["javascriptreact"],
          aliases: void 0,
          filenames: void 0,
          extensions: [".jsx"],
          group: "JavaScript",
          interpreters: void 0,
          tmScope: "source.js.jsx",
          aceMode: "javascript",
          codemirrorMode: "jsx",
          codemirrorMimeType: "text/jsx",
          color: void 0
        })), createLanguage(require_TypeScript(), () => ({
          since: "1.4.0",
          parsers: ["typescript", "babel-ts"],
          vscodeLanguageIds: ["typescript"]
        })), createLanguage(require_TSX(), () => ({
          since: "1.4.0",
          parsers: ["typescript", "babel-ts"],
          vscodeLanguageIds: ["typescriptreact"]
        })), createLanguage(require_JSON(), () => ({
          name: "JSON.stringify",
          since: "1.13.0",
          parsers: ["json-stringify"],
          vscodeLanguageIds: ["json"],
          extensions: [".importmap"],
          filenames: ["package.json", "package-lock.json", "composer.json"]
        })), createLanguage(require_JSON(), (data) => ({
          since: "1.5.0",
          parsers: ["json"],
          vscodeLanguageIds: ["json"],
          extensions: data.extensions.filter((extension) => extension !== ".jsonl")
        })), createLanguage(require_JSON_with_Comments(), (data) => ({
          since: "1.5.0",
          parsers: ["json"],
          vscodeLanguageIds: ["jsonc"],
          filenames: [...data.filenames, ".eslintrc", ".swcrc"]
        })), createLanguage(require_JSON5(), () => ({
          since: "1.13.0",
          parsers: ["json5"],
          vscodeLanguageIds: ["json5"]
        }))];
        var printers = {
          estree: estreePrinter,
          "estree-json": estreeJsonPrinter
        };
        module22.exports = {
          languages,
          options,
          printers,
          parsers
        };
      }
    });
    var require_clean2 = __commonJS22({
      "src/language-css/clean.js"(exports22, module22) {
        "use strict";
        var {
          isFrontMatterNode
        } = require_util2();
        var getLast = require_get_last();
        var ignoredProperties = /* @__PURE__ */ new Set(["raw", "raws", "sourceIndex", "source", "before", "after", "trailingComma"]);
        function clean(ast, newObj, parent) {
          if (isFrontMatterNode(ast) && ast.lang === "yaml") {
            delete newObj.value;
          }
          if (ast.type === "css-comment" && parent.type === "css-root" && parent.nodes.length > 0) {
            if (parent.nodes[0] === ast || isFrontMatterNode(parent.nodes[0]) && parent.nodes[1] === ast) {
              delete newObj.text;
              if (/^\*\s*@(?:format|prettier)\s*$/.test(ast.text)) {
                return null;
              }
            }
            if (parent.type === "css-root" && getLast(parent.nodes) === ast) {
              return null;
            }
          }
          if (ast.type === "value-root") {
            delete newObj.text;
          }
          if (ast.type === "media-query" || ast.type === "media-query-list" || ast.type === "media-feature-expression") {
            delete newObj.value;
          }
          if (ast.type === "css-rule") {
            delete newObj.params;
          }
          if (ast.type === "selector-combinator") {
            newObj.value = newObj.value.replace(/\s+/g, " ");
          }
          if (ast.type === "media-feature") {
            newObj.value = newObj.value.replace(/ /g, "");
          }
          if (ast.type === "value-word" && (ast.isColor && ast.isHex || ["initial", "inherit", "unset", "revert"].includes(newObj.value.replace().toLowerCase())) || ast.type === "media-feature" || ast.type === "selector-root-invalid" || ast.type === "selector-pseudo") {
            newObj.value = newObj.value.toLowerCase();
          }
          if (ast.type === "css-decl") {
            newObj.prop = newObj.prop.toLowerCase();
          }
          if (ast.type === "css-atrule" || ast.type === "css-import") {
            newObj.name = newObj.name.toLowerCase();
          }
          if (ast.type === "value-number") {
            newObj.unit = newObj.unit.toLowerCase();
          }
          if ((ast.type === "media-feature" || ast.type === "media-keyword" || ast.type === "media-type" || ast.type === "media-unknown" || ast.type === "media-url" || ast.type === "media-value" || ast.type === "selector-attribute" || ast.type === "selector-string" || ast.type === "selector-class" || ast.type === "selector-combinator" || ast.type === "value-string") && newObj.value) {
            newObj.value = cleanCSSStrings(newObj.value);
          }
          if (ast.type === "selector-attribute") {
            newObj.attribute = newObj.attribute.trim();
            if (newObj.namespace) {
              if (typeof newObj.namespace === "string") {
                newObj.namespace = newObj.namespace.trim();
                if (newObj.namespace.length === 0) {
                  newObj.namespace = true;
                }
              }
            }
            if (newObj.value) {
              newObj.value = newObj.value.trim().replace(/^["']|["']$/g, "");
              delete newObj.quoted;
            }
          }
          if ((ast.type === "media-value" || ast.type === "media-type" || ast.type === "value-number" || ast.type === "selector-root-invalid" || ast.type === "selector-class" || ast.type === "selector-combinator" || ast.type === "selector-tag") && newObj.value) {
            newObj.value = newObj.value.replace(/([\d+.Ee-]+)([A-Za-z]*)/g, (match, numStr, unit) => {
              const num = Number(numStr);
              return Number.isNaN(num) ? match : num + unit.toLowerCase();
            });
          }
          if (ast.type === "selector-tag") {
            const lowercasedValue = ast.value.toLowerCase();
            if (["from", "to"].includes(lowercasedValue)) {
              newObj.value = lowercasedValue;
            }
          }
          if (ast.type === "css-atrule" && ast.name.toLowerCase() === "supports") {
            delete newObj.value;
          }
          if (ast.type === "selector-unknown") {
            delete newObj.value;
          }
          if (ast.type === "value-comma_group") {
            const index = ast.groups.findIndex((node) => node.type === "value-number" && node.unit === "...");
            if (index !== -1) {
              newObj.groups[index].unit = "";
              newObj.groups.splice(index + 1, 0, {
                type: "value-word",
                value: "...",
                isColor: false,
                isHex: false
              });
            }
          }
        }
        clean.ignoredProperties = ignoredProperties;
        function cleanCSSStrings(value) {
          return value.replace(/'/g, '"').replace(/\\([^\dA-Fa-f])/g, "$1");
        }
        module22.exports = clean;
      }
    });
    var require_print = __commonJS22({
      "src/utils/front-matter/print.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            hardline,
            markAsRoot
          }
        } = require_doc();
        function print(node, textToDoc) {
          if (node.lang === "yaml") {
            const value = node.value.trim();
            const doc2 = value ? textToDoc(value, {
              parser: "yaml"
            }, {
              stripTrailingHardline: true
            }) : "";
            return markAsRoot([node.startDelimiter, hardline, doc2, doc2 ? hardline : "", node.endDelimiter]);
          }
        }
        module22.exports = print;
      }
    });
    var require_embed2 = __commonJS22({
      "src/language-css/embed.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            hardline
          }
        } = require_doc();
        var printFrontMatter = require_print();
        function embed(path5, print, textToDoc) {
          const node = path5.getValue();
          if (node.type === "front-matter") {
            const doc2 = printFrontMatter(node, textToDoc);
            return doc2 ? [doc2, hardline] : "";
          }
        }
        module22.exports = embed;
      }
    });
    var require_parse4 = __commonJS22({
      "src/utils/front-matter/parse.js"(exports22, module22) {
        "use strict";
        var frontMatterRegex = new RegExp("^(?<startDelimiter>-{3}|\\+{3})(?<language>[^\\n]*)\\n(?:|(?<value>.*?)\\n)(?<endDelimiter>\\k<startDelimiter>|\\.{3})[^\\S\\n]*(?:\\n|$)", "s");
        function parse2(text) {
          const match = text.match(frontMatterRegex);
          if (!match) {
            return {
              content: text
            };
          }
          const {
            startDelimiter,
            language,
            value = "",
            endDelimiter
          } = match.groups;
          let lang = language.trim() || "yaml";
          if (startDelimiter === "+++") {
            lang = "toml";
          }
          if (lang !== "yaml" && startDelimiter !== endDelimiter) {
            return {
              content: text
            };
          }
          const [raw] = match;
          const frontMatter = {
            type: "front-matter",
            lang,
            value,
            startDelimiter,
            endDelimiter,
            raw: raw.replace(/\n$/, "")
          };
          return {
            frontMatter,
            content: raw.replace(/[^\n]/g, " ") + text.slice(raw.length)
          };
        }
        module22.exports = parse2;
      }
    });
    var require_pragma2 = __commonJS22({
      "src/language-css/pragma.js"(exports22, module22) {
        "use strict";
        var jsPragma = require_pragma();
        var parseFrontMatter = require_parse4();
        function hasPragma(text) {
          return jsPragma.hasPragma(parseFrontMatter(text).content);
        }
        function insertPragma(text) {
          const {
            frontMatter,
            content
          } = parseFrontMatter(text);
          return (frontMatter ? frontMatter.raw + "\n\n" : "") + jsPragma.insertPragma(content);
        }
        module22.exports = {
          hasPragma,
          insertPragma
        };
      }
    });
    var require_utils82 = __commonJS22({
      "src/language-css/utils/index.js"(exports22, module22) {
        "use strict";
        var colorAdjusterFunctions = /* @__PURE__ */ new Set(["red", "green", "blue", "alpha", "a", "rgb", "hue", "h", "saturation", "s", "lightness", "l", "whiteness", "w", "blackness", "b", "tint", "shade", "blend", "blenda", "contrast", "hsl", "hsla", "hwb", "hwba"]);
        function getAncestorCounter(path5, typeOrTypes) {
          const types2 = Array.isArray(typeOrTypes) ? typeOrTypes : [typeOrTypes];
          let counter = -1;
          let ancestorNode;
          while (ancestorNode = path5.getParentNode(++counter)) {
            if (types2.includes(ancestorNode.type)) {
              return counter;
            }
          }
          return -1;
        }
        function getAncestorNode(path5, typeOrTypes) {
          const counter = getAncestorCounter(path5, typeOrTypes);
          return counter === -1 ? null : path5.getParentNode(counter);
        }
        function getPropOfDeclNode(path5) {
          var _declAncestorNode$pro;
          const declAncestorNode = getAncestorNode(path5, "css-decl");
          return declAncestorNode === null || declAncestorNode === void 0 ? void 0 : (_declAncestorNode$pro = declAncestorNode.prop) === null || _declAncestorNode$pro === void 0 ? void 0 : _declAncestorNode$pro.toLowerCase();
        }
        var wideKeywords = /* @__PURE__ */ new Set(["initial", "inherit", "unset", "revert"]);
        function isWideKeywords(value) {
          return wideKeywords.has(value.toLowerCase());
        }
        function isKeyframeAtRuleKeywords(path5, value) {
          const atRuleAncestorNode = getAncestorNode(path5, "css-atrule");
          return (atRuleAncestorNode === null || atRuleAncestorNode === void 0 ? void 0 : atRuleAncestorNode.name) && atRuleAncestorNode.name.toLowerCase().endsWith("keyframes") && ["from", "to"].includes(value.toLowerCase());
        }
        function maybeToLowerCase(value) {
          return value.includes("$") || value.includes("@") || value.includes("#") || value.startsWith("%") || value.startsWith("--") || value.startsWith(":--") || value.includes("(") && value.includes(")") ? value : value.toLowerCase();
        }
        function insideValueFunctionNode(path5, functionName) {
          var _funcAncestorNode$val;
          const funcAncestorNode = getAncestorNode(path5, "value-func");
          return (funcAncestorNode === null || funcAncestorNode === void 0 ? void 0 : (_funcAncestorNode$val = funcAncestorNode.value) === null || _funcAncestorNode$val === void 0 ? void 0 : _funcAncestorNode$val.toLowerCase()) === functionName;
        }
        function insideICSSRuleNode(path5) {
          var _ruleAncestorNode$raw;
          const ruleAncestorNode = getAncestorNode(path5, "css-rule");
          const selector = ruleAncestorNode === null || ruleAncestorNode === void 0 ? void 0 : (_ruleAncestorNode$raw = ruleAncestorNode.raws) === null || _ruleAncestorNode$raw === void 0 ? void 0 : _ruleAncestorNode$raw.selector;
          return selector && (selector.startsWith(":import") || selector.startsWith(":export"));
        }
        function insideAtRuleNode(path5, atRuleNameOrAtRuleNames) {
          const atRuleNames = Array.isArray(atRuleNameOrAtRuleNames) ? atRuleNameOrAtRuleNames : [atRuleNameOrAtRuleNames];
          const atRuleAncestorNode = getAncestorNode(path5, "css-atrule");
          return atRuleAncestorNode && atRuleNames.includes(atRuleAncestorNode.name.toLowerCase());
        }
        function insideURLFunctionInImportAtRuleNode(path5) {
          const node = path5.getValue();
          const atRuleAncestorNode = getAncestorNode(path5, "css-atrule");
          return (atRuleAncestorNode === null || atRuleAncestorNode === void 0 ? void 0 : atRuleAncestorNode.name) === "import" && node.groups[0].value === "url" && node.groups.length === 2;
        }
        function isURLFunctionNode(node) {
          return node.type === "value-func" && node.value.toLowerCase() === "url";
        }
        function isLastNode(path5, node) {
          var _path$getParentNode;
          const nodes = (_path$getParentNode = path5.getParentNode()) === null || _path$getParentNode === void 0 ? void 0 : _path$getParentNode.nodes;
          return nodes && nodes.indexOf(node) === nodes.length - 1;
        }
        function isDetachedRulesetDeclarationNode(node) {
          const {
            selector
          } = node;
          if (!selector) {
            return false;
          }
          return typeof selector === "string" && /^@.+:.*$/.test(selector) || selector.value && /^@.+:.*$/.test(selector.value);
        }
        function isForKeywordNode(node) {
          return node.type === "value-word" && ["from", "through", "end"].includes(node.value);
        }
        function isIfElseKeywordNode(node) {
          return node.type === "value-word" && ["and", "or", "not"].includes(node.value);
        }
        function isEachKeywordNode(node) {
          return node.type === "value-word" && node.value === "in";
        }
        function isMultiplicationNode(node) {
          return node.type === "value-operator" && node.value === "*";
        }
        function isDivisionNode(node) {
          return node.type === "value-operator" && node.value === "/";
        }
        function isAdditionNode(node) {
          return node.type === "value-operator" && node.value === "+";
        }
        function isSubtractionNode(node) {
          return node.type === "value-operator" && node.value === "-";
        }
        function isModuloNode(node) {
          return node.type === "value-operator" && node.value === "%";
        }
        function isMathOperatorNode(node) {
          return isMultiplicationNode(node) || isDivisionNode(node) || isAdditionNode(node) || isSubtractionNode(node) || isModuloNode(node);
        }
        function isEqualityOperatorNode(node) {
          return node.type === "value-word" && ["==", "!="].includes(node.value);
        }
        function isRelationalOperatorNode(node) {
          return node.type === "value-word" && ["<", ">", "<=", ">="].includes(node.value);
        }
        function isSCSSControlDirectiveNode(node) {
          return node.type === "css-atrule" && ["if", "else", "for", "each", "while"].includes(node.name);
        }
        function isDetachedRulesetCallNode(node) {
          var _node$raws;
          return ((_node$raws = node.raws) === null || _node$raws === void 0 ? void 0 : _node$raws.params) && /^\(\s*\)$/.test(node.raws.params);
        }
        function isTemplatePlaceholderNode(node) {
          return node.name.startsWith("prettier-placeholder");
        }
        function isTemplatePropNode(node) {
          return node.prop.startsWith("@prettier-placeholder");
        }
        function isPostcssSimpleVarNode(currentNode, nextNode) {
          return currentNode.value === "$$" && currentNode.type === "value-func" && (nextNode === null || nextNode === void 0 ? void 0 : nextNode.type) === "value-word" && !nextNode.raws.before;
        }
        function hasComposesNode(node) {
          var _node$value, _node$value$group;
          return ((_node$value = node.value) === null || _node$value === void 0 ? void 0 : _node$value.type) === "value-root" && ((_node$value$group = node.value.group) === null || _node$value$group === void 0 ? void 0 : _node$value$group.type) === "value-value" && node.prop.toLowerCase() === "composes";
        }
        function hasParensAroundNode(node) {
          var _node$value2, _node$value2$group, _node$value2$group$gr;
          return ((_node$value2 = node.value) === null || _node$value2 === void 0 ? void 0 : (_node$value2$group = _node$value2.group) === null || _node$value2$group === void 0 ? void 0 : (_node$value2$group$gr = _node$value2$group.group) === null || _node$value2$group$gr === void 0 ? void 0 : _node$value2$group$gr.type) === "value-paren_group" && node.value.group.group.open !== null && node.value.group.group.close !== null;
        }
        function hasEmptyRawBefore(node) {
          var _node$raws2;
          return ((_node$raws2 = node.raws) === null || _node$raws2 === void 0 ? void 0 : _node$raws2.before) === "";
        }
        function isKeyValuePairNode(node) {
          var _node$groups, _node$groups$;
          return node.type === "value-comma_group" && ((_node$groups = node.groups) === null || _node$groups === void 0 ? void 0 : (_node$groups$ = _node$groups[1]) === null || _node$groups$ === void 0 ? void 0 : _node$groups$.type) === "value-colon";
        }
        function isKeyValuePairInParenGroupNode(node) {
          var _node$groups2;
          return node.type === "value-paren_group" && ((_node$groups2 = node.groups) === null || _node$groups2 === void 0 ? void 0 : _node$groups2[0]) && isKeyValuePairNode(node.groups[0]);
        }
        function isSCSSMapItemNode(path5) {
          var _declNode$prop;
          const node = path5.getValue();
          if (node.groups.length === 0) {
            return false;
          }
          const parentParentNode = path5.getParentNode(1);
          if (!isKeyValuePairInParenGroupNode(node) && !(parentParentNode && isKeyValuePairInParenGroupNode(parentParentNode))) {
            return false;
          }
          const declNode = getAncestorNode(path5, "css-decl");
          if (declNode !== null && declNode !== void 0 && (_declNode$prop = declNode.prop) !== null && _declNode$prop !== void 0 && _declNode$prop.startsWith("$")) {
            return true;
          }
          if (isKeyValuePairInParenGroupNode(parentParentNode)) {
            return true;
          }
          if (parentParentNode.type === "value-func") {
            return true;
          }
          return false;
        }
        function isInlineValueCommentNode(node) {
          return node.type === "value-comment" && node.inline;
        }
        function isHashNode(node) {
          return node.type === "value-word" && node.value === "#";
        }
        function isLeftCurlyBraceNode(node) {
          return node.type === "value-word" && node.value === "{";
        }
        function isRightCurlyBraceNode(node) {
          return node.type === "value-word" && node.value === "}";
        }
        function isWordNode(node) {
          return ["value-word", "value-atword"].includes(node.type);
        }
        function isColonNode(node) {
          return (node === null || node === void 0 ? void 0 : node.type) === "value-colon";
        }
        function isKeyInValuePairNode(node, parentNode) {
          if (!isKeyValuePairNode(parentNode)) {
            return false;
          }
          const {
            groups
          } = parentNode;
          const index = groups.indexOf(node);
          if (index === -1) {
            return false;
          }
          return isColonNode(groups[index + 1]);
        }
        function isMediaAndSupportsKeywords(node) {
          return node.value && ["not", "and", "or"].includes(node.value.toLowerCase());
        }
        function isColorAdjusterFuncNode(node) {
          if (node.type !== "value-func") {
            return false;
          }
          return colorAdjusterFunctions.has(node.value.toLowerCase());
        }
        function lastLineHasInlineComment(text) {
          return /\/\//.test(text.split(/[\n\r]/).pop());
        }
        function isAtWordPlaceholderNode(node) {
          return (node === null || node === void 0 ? void 0 : node.type) === "value-atword" && node.value.startsWith("prettier-placeholder-");
        }
        function isConfigurationNode(node, parentNode) {
          var _node$open, _node$close;
          if (((_node$open = node.open) === null || _node$open === void 0 ? void 0 : _node$open.value) !== "(" || ((_node$close = node.close) === null || _node$close === void 0 ? void 0 : _node$close.value) !== ")" || node.groups.some((group) => group.type !== "value-comma_group")) {
            return false;
          }
          if (parentNode.type === "value-comma_group") {
            const prevIdx = parentNode.groups.indexOf(node) - 1;
            const maybeWithNode = parentNode.groups[prevIdx];
            if ((maybeWithNode === null || maybeWithNode === void 0 ? void 0 : maybeWithNode.type) === "value-word" && maybeWithNode.value === "with") {
              return true;
            }
          }
          return false;
        }
        function isParenGroupNode(node) {
          var _node$open2, _node$close2;
          return node.type === "value-paren_group" && ((_node$open2 = node.open) === null || _node$open2 === void 0 ? void 0 : _node$open2.value) === "(" && ((_node$close2 = node.close) === null || _node$close2 === void 0 ? void 0 : _node$close2.value) === ")";
        }
        module22.exports = {
          getAncestorCounter,
          getAncestorNode,
          getPropOfDeclNode,
          maybeToLowerCase,
          insideValueFunctionNode,
          insideICSSRuleNode,
          insideAtRuleNode,
          insideURLFunctionInImportAtRuleNode,
          isKeyframeAtRuleKeywords,
          isWideKeywords,
          isLastNode,
          isSCSSControlDirectiveNode,
          isDetachedRulesetDeclarationNode,
          isRelationalOperatorNode,
          isEqualityOperatorNode,
          isMultiplicationNode,
          isDivisionNode,
          isAdditionNode,
          isSubtractionNode,
          isModuloNode,
          isMathOperatorNode,
          isEachKeywordNode,
          isForKeywordNode,
          isURLFunctionNode,
          isIfElseKeywordNode,
          hasComposesNode,
          hasParensAroundNode,
          hasEmptyRawBefore,
          isDetachedRulesetCallNode,
          isTemplatePlaceholderNode,
          isTemplatePropNode,
          isPostcssSimpleVarNode,
          isKeyValuePairNode,
          isKeyValuePairInParenGroupNode,
          isKeyInValuePairNode,
          isSCSSMapItemNode,
          isInlineValueCommentNode,
          isHashNode,
          isLeftCurlyBraceNode,
          isRightCurlyBraceNode,
          isWordNode,
          isColonNode,
          isMediaAndSupportsKeywords,
          isColorAdjusterFuncNode,
          lastLineHasInlineComment,
          isAtWordPlaceholderNode,
          isConfigurationNode,
          isParenGroupNode
        };
      }
    });
    var require_line_column_to_index = __commonJS22({
      "src/utils/line-column-to-index.js"(exports22, module22) {
        "use strict";
        module22.exports = function(lineColumn, text) {
          let index = 0;
          for (let i = 0; i < lineColumn.line - 1; ++i) {
            index = text.indexOf("\n", index) + 1;
          }
          return index + lineColumn.column;
        };
      }
    });
    var require_loc2 = __commonJS22({
      "src/language-css/loc.js"(exports22, module22) {
        "use strict";
        var {
          skipEverythingButNewLine
        } = require_skip();
        var getLast = require_get_last();
        var lineColumnToIndex = require_line_column_to_index();
        function calculateLocStart(node, text) {
          if (typeof node.sourceIndex === "number") {
            return node.sourceIndex;
          }
          return node.source ? lineColumnToIndex(node.source.start, text) - 1 : null;
        }
        function calculateLocEnd(node, text) {
          if (node.type === "css-comment" && node.inline) {
            return skipEverythingButNewLine(text, node.source.startOffset);
          }
          const endNode = node.nodes && getLast(node.nodes);
          if (endNode && node.source && !node.source.end) {
            node = endNode;
          }
          if (node.source && node.source.end) {
            return lineColumnToIndex(node.source.end, text);
          }
          return null;
        }
        function calculateLoc(node, text) {
          if (node.source) {
            node.source.startOffset = calculateLocStart(node, text);
            node.source.endOffset = calculateLocEnd(node, text);
          }
          for (const key in node) {
            const child = node[key];
            if (key === "source" || !child || typeof child !== "object") {
              continue;
            }
            if (child.type === "value-root" || child.type === "value-unknown") {
              calculateValueNodeLoc(child, getValueRootOffset(node), child.text || child.value);
            } else {
              calculateLoc(child, text);
            }
          }
        }
        function calculateValueNodeLoc(node, rootOffset, text) {
          if (node.source) {
            node.source.startOffset = calculateLocStart(node, text) + rootOffset;
            node.source.endOffset = calculateLocEnd(node, text) + rootOffset;
          }
          for (const key in node) {
            const child = node[key];
            if (key === "source" || !child || typeof child !== "object") {
              continue;
            }
            calculateValueNodeLoc(child, rootOffset, text);
          }
        }
        function getValueRootOffset(node) {
          let result = node.source.startOffset;
          if (typeof node.prop === "string") {
            result += node.prop.length;
          }
          if (node.type === "css-atrule" && typeof node.name === "string") {
            result += 1 + node.name.length + node.raws.afterName.match(/^\s*:?\s*/)[0].length;
          }
          if (node.type !== "css-atrule" && node.raws && typeof node.raws.between === "string") {
            result += node.raws.between.length;
          }
          return result;
        }
        function replaceQuotesInInlineComments(text) {
          let state = "initial";
          let stateToReturnFromQuotes = "initial";
          let inlineCommentStartIndex;
          let inlineCommentContainsQuotes = false;
          const inlineCommentsToReplace = [];
          for (let i = 0; i < text.length; i++) {
            const c = text[i];
            switch (state) {
              case "initial":
                if (c === "'") {
                  state = "single-quotes";
                  continue;
                }
                if (c === '"') {
                  state = "double-quotes";
                  continue;
                }
                if ((c === "u" || c === "U") && text.slice(i, i + 4).toLowerCase() === "url(") {
                  state = "url";
                  i += 3;
                  continue;
                }
                if (c === "*" && text[i - 1] === "/") {
                  state = "comment-block";
                  continue;
                }
                if (c === "/" && text[i - 1] === "/") {
                  state = "comment-inline";
                  inlineCommentStartIndex = i - 1;
                  continue;
                }
                continue;
              case "single-quotes":
                if (c === "'" && text[i - 1] !== "\\") {
                  state = stateToReturnFromQuotes;
                  stateToReturnFromQuotes = "initial";
                }
                if (c === "\n" || c === "\r") {
                  return text;
                }
                continue;
              case "double-quotes":
                if (c === '"' && text[i - 1] !== "\\") {
                  state = stateToReturnFromQuotes;
                  stateToReturnFromQuotes = "initial";
                }
                if (c === "\n" || c === "\r") {
                  return text;
                }
                continue;
              case "url":
                if (c === ")") {
                  state = "initial";
                }
                if (c === "\n" || c === "\r") {
                  return text;
                }
                if (c === "'") {
                  state = "single-quotes";
                  stateToReturnFromQuotes = "url";
                  continue;
                }
                if (c === '"') {
                  state = "double-quotes";
                  stateToReturnFromQuotes = "url";
                  continue;
                }
                continue;
              case "comment-block":
                if (c === "/" && text[i - 1] === "*") {
                  state = "initial";
                }
                continue;
              case "comment-inline":
                if (c === '"' || c === "'" || c === "*") {
                  inlineCommentContainsQuotes = true;
                }
                if (c === "\n" || c === "\r") {
                  if (inlineCommentContainsQuotes) {
                    inlineCommentsToReplace.push([inlineCommentStartIndex, i]);
                  }
                  state = "initial";
                  inlineCommentContainsQuotes = false;
                }
                continue;
            }
          }
          for (const [start, end] of inlineCommentsToReplace) {
            text = text.slice(0, start) + text.slice(start, end).replace(/["'*]/g, " ") + text.slice(end);
          }
          return text;
        }
        function locStart(node) {
          return node.source.startOffset;
        }
        function locEnd(node) {
          return node.source.endOffset;
        }
        module22.exports = {
          locStart,
          locEnd,
          calculateLoc,
          replaceQuotesInInlineComments
        };
      }
    });
    var require_is_less_parser = __commonJS22({
      "src/language-css/utils/is-less-parser.js"(exports22, module22) {
        "use strict";
        function isLessParser(options) {
          return options.parser === "css" || options.parser === "less";
        }
        module22.exports = isLessParser;
      }
    });
    var require_is_scss = __commonJS22({
      "src/language-css/utils/is-scss.js"(exports22, module22) {
        "use strict";
        function isSCSS(parser, text) {
          const hasExplicitParserChoice = parser === "less" || parser === "scss";
          const IS_POSSIBLY_SCSS = /(?:\w\s*:\s*[^:}]+|#){|@import[^\n]+(?:url|,)/;
          return hasExplicitParserChoice ? parser === "scss" : IS_POSSIBLY_SCSS.test(text);
        }
        module22.exports = isSCSS;
      }
    });
    var require_css_units_evaluate = __commonJS22({
      "src/language-css/utils/css-units.evaluate.js"(exports22, module22) {
        module22.exports = {
          em: "em",
          rem: "rem",
          ex: "ex",
          rex: "rex",
          cap: "cap",
          rcap: "rcap",
          ch: "ch",
          rch: "rch",
          ic: "ic",
          ric: "ric",
          lh: "lh",
          rlh: "rlh",
          vw: "vw",
          svw: "svw",
          lvw: "lvw",
          dvw: "dvw",
          vh: "vh",
          svh: "svh",
          lvh: "lvh",
          dvh: "dvh",
          vi: "vi",
          svi: "svi",
          lvi: "lvi",
          dvi: "dvi",
          vb: "vb",
          svb: "svb",
          lvb: "lvb",
          dvb: "dvb",
          vmin: "vmin",
          svmin: "svmin",
          lvmin: "lvmin",
          dvmin: "dvmin",
          vmax: "vmax",
          svmax: "svmax",
          lvmax: "lvmax",
          dvmax: "dvmax",
          cm: "cm",
          mm: "mm",
          q: "Q",
          in: "in",
          pt: "pt",
          pc: "pc",
          px: "px",
          deg: "deg",
          grad: "grad",
          rad: "rad",
          turn: "turn",
          s: "s",
          ms: "ms",
          hz: "Hz",
          khz: "kHz",
          dpi: "dpi",
          dpcm: "dpcm",
          dppx: "dppx",
          x: "x"
        };
      }
    });
    var require_print_unit = __commonJS22({
      "src/language-css/utils/print-unit.js"(exports22, module22) {
        "use strict";
        var CSS_UNITS = require_css_units_evaluate();
        function printUnit(unit) {
          const lowercased = unit.toLowerCase();
          return Object.prototype.hasOwnProperty.call(CSS_UNITS, lowercased) ? CSS_UNITS[lowercased] : unit;
        }
        module22.exports = printUnit;
      }
    });
    var require_printer_postcss = __commonJS22({
      "src/language-css/printer-postcss.js"(exports22, module22) {
        "use strict";
        var getLast = require_get_last();
        var {
          printNumber,
          printString,
          hasNewline,
          isFrontMatterNode,
          isNextLineEmpty,
          isNonEmptyArray
        } = require_util2();
        var {
          builders: {
            join: join2,
            line,
            hardline,
            softline,
            group,
            fill,
            indent,
            dedent,
            ifBreak,
            breakParent
          },
          utils: {
            removeLines,
            getDocParts
          }
        } = require_doc();
        var clean = require_clean2();
        var embed = require_embed2();
        var {
          insertPragma
        } = require_pragma2();
        var {
          getAncestorNode,
          getPropOfDeclNode,
          maybeToLowerCase,
          insideValueFunctionNode,
          insideICSSRuleNode,
          insideAtRuleNode,
          insideURLFunctionInImportAtRuleNode,
          isKeyframeAtRuleKeywords,
          isWideKeywords,
          isLastNode,
          isSCSSControlDirectiveNode,
          isDetachedRulesetDeclarationNode,
          isRelationalOperatorNode,
          isEqualityOperatorNode,
          isMultiplicationNode,
          isDivisionNode,
          isAdditionNode,
          isSubtractionNode,
          isMathOperatorNode,
          isEachKeywordNode,
          isForKeywordNode,
          isURLFunctionNode,
          isIfElseKeywordNode,
          hasComposesNode,
          hasParensAroundNode,
          hasEmptyRawBefore,
          isKeyValuePairNode,
          isKeyInValuePairNode,
          isDetachedRulesetCallNode,
          isTemplatePlaceholderNode,
          isTemplatePropNode,
          isPostcssSimpleVarNode,
          isSCSSMapItemNode,
          isInlineValueCommentNode,
          isHashNode,
          isLeftCurlyBraceNode,
          isRightCurlyBraceNode,
          isWordNode,
          isColonNode,
          isMediaAndSupportsKeywords,
          isColorAdjusterFuncNode,
          lastLineHasInlineComment,
          isAtWordPlaceholderNode,
          isConfigurationNode,
          isParenGroupNode
        } = require_utils82();
        var {
          locStart,
          locEnd
        } = require_loc2();
        var isLessParser = require_is_less_parser();
        var isSCSS = require_is_scss();
        var printUnit = require_print_unit();
        function shouldPrintComma(options) {
          return options.trailingComma === "es5" || options.trailingComma === "all";
        }
        function genericPrint(path5, options, print) {
          const node = path5.getValue();
          if (!node) {
            return "";
          }
          if (typeof node === "string") {
            return node;
          }
          switch (node.type) {
            case "front-matter":
              return [node.raw, hardline];
            case "css-root": {
              const nodes = printNodeSequence(path5, options, print);
              const after = node.raws.after.trim();
              return [nodes, after ? ` ${after}` : "", getDocParts(nodes).length > 0 ? hardline : ""];
            }
            case "css-comment": {
              const isInlineComment = node.inline || node.raws.inline;
              const text = options.originalText.slice(locStart(node), locEnd(node));
              return isInlineComment ? text.trimEnd() : text;
            }
            case "css-rule": {
              return [print("selector"), node.important ? " !important" : "", node.nodes ? [node.selector && node.selector.type === "selector-unknown" && lastLineHasInlineComment(node.selector.value) ? line : " ", "{", node.nodes.length > 0 ? indent([hardline, printNodeSequence(path5, options, print)]) : "", hardline, "}", isDetachedRulesetDeclarationNode(node) ? ";" : ""] : ";"];
            }
            case "css-decl": {
              const parentNode = path5.getParentNode();
              const {
                between: rawBetween
              } = node.raws;
              const trimmedBetween = rawBetween.trim();
              const isColon = trimmedBetween === ":";
              let value = hasComposesNode(node) ? removeLines(print("value")) : print("value");
              if (!isColon && lastLineHasInlineComment(trimmedBetween)) {
                value = indent([hardline, dedent(value)]);
              }
              return [node.raws.before.replace(/[\s;]/g, ""), insideICSSRuleNode(path5) ? node.prop : maybeToLowerCase(node.prop), trimmedBetween.startsWith("//") ? " " : "", trimmedBetween, node.extend ? "" : " ", isLessParser(options) && node.extend && node.selector ? ["extend(", print("selector"), ")"] : "", value, node.raws.important ? node.raws.important.replace(/\s*!\s*important/i, " !important") : node.important ? " !important" : "", node.raws.scssDefault ? node.raws.scssDefault.replace(/\s*!default/i, " !default") : node.scssDefault ? " !default" : "", node.raws.scssGlobal ? node.raws.scssGlobal.replace(/\s*!global/i, " !global") : node.scssGlobal ? " !global" : "", node.nodes ? [" {", indent([softline, printNodeSequence(path5, options, print)]), softline, "}"] : isTemplatePropNode(node) && !parentNode.raws.semicolon && options.originalText[locEnd(node) - 1] !== ";" ? "" : options.__isHTMLStyleAttribute && isLastNode(path5, node) ? ifBreak(";") : ";"];
            }
            case "css-atrule": {
              const parentNode = path5.getParentNode();
              const isTemplatePlaceholderNodeWithoutSemiColon = isTemplatePlaceholderNode(node) && !parentNode.raws.semicolon && options.originalText[locEnd(node) - 1] !== ";";
              if (isLessParser(options)) {
                if (node.mixin) {
                  return [print("selector"), node.important ? " !important" : "", isTemplatePlaceholderNodeWithoutSemiColon ? "" : ";"];
                }
                if (node.function) {
                  return [node.name, print("params"), isTemplatePlaceholderNodeWithoutSemiColon ? "" : ";"];
                }
                if (node.variable) {
                  return ["@", node.name, ": ", node.value ? print("value") : "", node.raws.between.trim() ? node.raws.between.trim() + " " : "", node.nodes ? ["{", indent([node.nodes.length > 0 ? softline : "", printNodeSequence(path5, options, print)]), softline, "}"] : "", isTemplatePlaceholderNodeWithoutSemiColon ? "" : ";"];
                }
              }
              return ["@", isDetachedRulesetCallNode(node) || node.name.endsWith(":") ? node.name : maybeToLowerCase(node.name), node.params ? [isDetachedRulesetCallNode(node) ? "" : isTemplatePlaceholderNode(node) ? node.raws.afterName === "" ? "" : node.name.endsWith(":") ? " " : /^\s*\n\s*\n/.test(node.raws.afterName) ? [hardline, hardline] : /^\s*\n/.test(node.raws.afterName) ? hardline : " " : " ", print("params")] : "", node.selector ? indent([" ", print("selector")]) : "", node.value ? group([" ", print("value"), isSCSSControlDirectiveNode(node) ? hasParensAroundNode(node) ? " " : line : ""]) : node.name === "else" ? " " : "", node.nodes ? [isSCSSControlDirectiveNode(node) ? "" : node.selector && !node.selector.nodes && typeof node.selector.value === "string" && lastLineHasInlineComment(node.selector.value) || !node.selector && typeof node.params === "string" && lastLineHasInlineComment(node.params) ? line : " ", "{", indent([node.nodes.length > 0 ? softline : "", printNodeSequence(path5, options, print)]), softline, "}"] : isTemplatePlaceholderNodeWithoutSemiColon ? "" : ";"];
            }
            case "media-query-list": {
              const parts = [];
              path5.each((childPath) => {
                const node2 = childPath.getValue();
                if (node2.type === "media-query" && node2.value === "") {
                  return;
                }
                parts.push(print());
              }, "nodes");
              return group(indent(join2(line, parts)));
            }
            case "media-query": {
              return [join2(" ", path5.map(print, "nodes")), isLastNode(path5, node) ? "" : ","];
            }
            case "media-type": {
              return adjustNumbers(adjustStrings(node.value, options));
            }
            case "media-feature-expression": {
              if (!node.nodes) {
                return node.value;
              }
              return ["(", ...path5.map(print, "nodes"), ")"];
            }
            case "media-feature": {
              return maybeToLowerCase(adjustStrings(node.value.replace(/ +/g, " "), options));
            }
            case "media-colon": {
              return [node.value, " "];
            }
            case "media-value": {
              return adjustNumbers(adjustStrings(node.value, options));
            }
            case "media-keyword": {
              return adjustStrings(node.value, options);
            }
            case "media-url": {
              return adjustStrings(node.value.replace(/^url\(\s+/gi, "url(").replace(/\s+\)$/g, ")"), options);
            }
            case "media-unknown": {
              return node.value;
            }
            case "selector-root": {
              return group([insideAtRuleNode(path5, "custom-selector") ? [getAncestorNode(path5, "css-atrule").customSelector, line] : "", join2([",", insideAtRuleNode(path5, ["extend", "custom-selector", "nest"]) ? line : hardline], path5.map(print, "nodes"))]);
            }
            case "selector-selector": {
              return group(indent(path5.map(print, "nodes")));
            }
            case "selector-comment": {
              return node.value;
            }
            case "selector-string": {
              return adjustStrings(node.value, options);
            }
            case "selector-tag": {
              const parentNode = path5.getParentNode();
              const index = parentNode && parentNode.nodes.indexOf(node);
              const prevNode = index && parentNode.nodes[index - 1];
              return [node.namespace ? [node.namespace === true ? "" : node.namespace.trim(), "|"] : "", prevNode.type === "selector-nesting" ? node.value : adjustNumbers(isKeyframeAtRuleKeywords(path5, node.value) ? node.value.toLowerCase() : node.value)];
            }
            case "selector-id": {
              return ["#", node.value];
            }
            case "selector-class": {
              return [".", adjustNumbers(adjustStrings(node.value, options))];
            }
            case "selector-attribute": {
              return ["[", node.namespace ? [node.namespace === true ? "" : node.namespace.trim(), "|"] : "", node.attribute.trim(), node.operator ? node.operator : "", node.value ? quoteAttributeValue(adjustStrings(node.value.trim(), options), options) : "", node.insensitive ? " i" : "", "]"];
            }
            case "selector-combinator": {
              if (node.value === "+" || node.value === ">" || node.value === "~" || node.value === ">>>") {
                const parentNode = path5.getParentNode();
                const leading2 = parentNode.type === "selector-selector" && parentNode.nodes[0] === node ? "" : line;
                return [leading2, node.value, isLastNode(path5, node) ? "" : " "];
              }
              const leading = node.value.trim().startsWith("(") ? line : "";
              const value = adjustNumbers(adjustStrings(node.value.trim(), options)) || line;
              return [leading, value];
            }
            case "selector-universal": {
              return [node.namespace ? [node.namespace === true ? "" : node.namespace.trim(), "|"] : "", node.value];
            }
            case "selector-pseudo": {
              return [maybeToLowerCase(node.value), isNonEmptyArray(node.nodes) ? ["(", join2(", ", path5.map(print, "nodes")), ")"] : ""];
            }
            case "selector-nesting": {
              return node.value;
            }
            case "selector-unknown": {
              const ruleAncestorNode = getAncestorNode(path5, "css-rule");
              if (ruleAncestorNode && ruleAncestorNode.isSCSSNesterProperty) {
                return adjustNumbers(adjustStrings(maybeToLowerCase(node.value), options));
              }
              const parentNode = path5.getParentNode();
              if (parentNode.raws && parentNode.raws.selector) {
                const start = locStart(parentNode);
                const end = start + parentNode.raws.selector.length;
                return options.originalText.slice(start, end).trim();
              }
              const grandParent = path5.getParentNode(1);
              if (parentNode.type === "value-paren_group" && grandParent && grandParent.type === "value-func" && grandParent.value === "selector") {
                const start = locEnd(parentNode.open) + 1;
                const end = locStart(parentNode.close);
                const selector = options.originalText.slice(start, end).trim();
                return lastLineHasInlineComment(selector) ? [breakParent, selector] : selector;
              }
              return node.value;
            }
            case "value-value":
            case "value-root": {
              return print("group");
            }
            case "value-comment": {
              return options.originalText.slice(locStart(node), locEnd(node));
            }
            case "value-comma_group": {
              const parentNode = path5.getParentNode();
              const parentParentNode = path5.getParentNode(1);
              const declAncestorProp = getPropOfDeclNode(path5);
              const isGridValue = declAncestorProp && parentNode.type === "value-value" && (declAncestorProp === "grid" || declAncestorProp.startsWith("grid-template"));
              const atRuleAncestorNode = getAncestorNode(path5, "css-atrule");
              const isControlDirective = atRuleAncestorNode && isSCSSControlDirectiveNode(atRuleAncestorNode);
              const hasInlineComment = node.groups.some((node2) => isInlineValueCommentNode(node2));
              const printed = path5.map(print, "groups");
              const parts = [];
              const insideURLFunction = insideValueFunctionNode(path5, "url");
              let insideSCSSInterpolationInString = false;
              let didBreak = false;
              for (let i = 0; i < node.groups.length; ++i) {
                parts.push(printed[i]);
                const iPrevNode = node.groups[i - 1];
                const iNode = node.groups[i];
                const iNextNode = node.groups[i + 1];
                const iNextNextNode = node.groups[i + 2];
                if (insideURLFunction) {
                  if (iNextNode && isAdditionNode(iNextNode) || isAdditionNode(iNode)) {
                    parts.push(" ");
                  }
                  continue;
                }
                if (insideAtRuleNode(path5, "forward") && iNode.type === "value-word" && iNode.value && iPrevNode !== void 0 && iPrevNode.type === "value-word" && iPrevNode.value === "as" && iNextNode.type === "value-operator" && iNextNode.value === "*") {
                  continue;
                }
                if (!iNextNode) {
                  continue;
                }
                if (iNode.type === "value-word" && iNode.value.endsWith("-") && isAtWordPlaceholderNode(iNextNode)) {
                  continue;
                }
                const isStartSCSSInterpolationInString = iNode.type === "value-string" && iNode.value.startsWith("#{");
                const isEndingSCSSInterpolationInString = insideSCSSInterpolationInString && iNextNode.type === "value-string" && iNextNode.value.endsWith("}");
                if (isStartSCSSInterpolationInString || isEndingSCSSInterpolationInString) {
                  insideSCSSInterpolationInString = !insideSCSSInterpolationInString;
                  continue;
                }
                if (insideSCSSInterpolationInString) {
                  continue;
                }
                if (isColonNode(iNode) || isColonNode(iNextNode)) {
                  continue;
                }
                if (iNode.type === "value-atword" && iNode.value === "") {
                  continue;
                }
                if (iNode.value === "~") {
                  continue;
                }
                if (iNode.value && iNode.value.includes("\\") && iNextNode && iNextNode.type !== "value-comment") {
                  continue;
                }
                if (iPrevNode && iPrevNode.value && iPrevNode.value.indexOf("\\") === iPrevNode.value.length - 1 && iNode.type === "value-operator" && iNode.value === "/") {
                  continue;
                }
                if (iNode.value === "\\") {
                  continue;
                }
                if (isPostcssSimpleVarNode(iNode, iNextNode)) {
                  continue;
                }
                if (isHashNode(iNode) || isLeftCurlyBraceNode(iNode) || isRightCurlyBraceNode(iNextNode) || isLeftCurlyBraceNode(iNextNode) && hasEmptyRawBefore(iNextNode) || isRightCurlyBraceNode(iNode) && hasEmptyRawBefore(iNextNode)) {
                  continue;
                }
                if (iNode.value === "--" && isHashNode(iNextNode)) {
                  continue;
                }
                const isMathOperator = isMathOperatorNode(iNode);
                const isNextMathOperator = isMathOperatorNode(iNextNode);
                if ((isMathOperator && isHashNode(iNextNode) || isNextMathOperator && isRightCurlyBraceNode(iNode)) && hasEmptyRawBefore(iNextNode)) {
                  continue;
                }
                if (!iPrevNode && isDivisionNode(iNode)) {
                  continue;
                }
                if (insideValueFunctionNode(path5, "calc") && (isAdditionNode(iNode) || isAdditionNode(iNextNode) || isSubtractionNode(iNode) || isSubtractionNode(iNextNode)) && hasEmptyRawBefore(iNextNode)) {
                  continue;
                }
                const isColorAdjusterNode = (isAdditionNode(iNode) || isSubtractionNode(iNode)) && i === 0 && (iNextNode.type === "value-number" || iNextNode.isHex) && parentParentNode && isColorAdjusterFuncNode(parentParentNode) && !hasEmptyRawBefore(iNextNode);
                const requireSpaceBeforeOperator = iNextNextNode && iNextNextNode.type === "value-func" || iNextNextNode && isWordNode(iNextNextNode) || iNode.type === "value-func" || isWordNode(iNode);
                const requireSpaceAfterOperator = iNextNode.type === "value-func" || isWordNode(iNextNode) || iPrevNode && iPrevNode.type === "value-func" || iPrevNode && isWordNode(iPrevNode);
                if (!(isMultiplicationNode(iNextNode) || isMultiplicationNode(iNode)) && !insideValueFunctionNode(path5, "calc") && !isColorAdjusterNode && (isDivisionNode(iNextNode) && !requireSpaceBeforeOperator || isDivisionNode(iNode) && !requireSpaceAfterOperator || isAdditionNode(iNextNode) && !requireSpaceBeforeOperator || isAdditionNode(iNode) && !requireSpaceAfterOperator || isSubtractionNode(iNextNode) || isSubtractionNode(iNode)) && (hasEmptyRawBefore(iNextNode) || isMathOperator && (!iPrevNode || iPrevNode && isMathOperatorNode(iPrevNode)))) {
                  continue;
                }
                if (isInlineValueCommentNode(iNode)) {
                  if (parentNode.type === "value-paren_group") {
                    parts.push(dedent(hardline));
                    continue;
                  }
                  parts.push(hardline);
                  continue;
                }
                if (isControlDirective && (isEqualityOperatorNode(iNextNode) || isRelationalOperatorNode(iNextNode) || isIfElseKeywordNode(iNextNode) || isEachKeywordNode(iNode) || isForKeywordNode(iNode))) {
                  parts.push(" ");
                  continue;
                }
                if (atRuleAncestorNode && atRuleAncestorNode.name.toLowerCase() === "namespace") {
                  parts.push(" ");
                  continue;
                }
                if (isGridValue) {
                  if (iNode.source && iNextNode.source && iNode.source.start.line !== iNextNode.source.start.line) {
                    parts.push(hardline);
                    didBreak = true;
                  } else {
                    parts.push(" ");
                  }
                  continue;
                }
                if (isNextMathOperator) {
                  parts.push(" ");
                  continue;
                }
                if (iNextNode && iNextNode.value === "...") {
                  continue;
                }
                if (isAtWordPlaceholderNode(iNode) && isAtWordPlaceholderNode(iNextNode) && locEnd(iNode) === locStart(iNextNode)) {
                  continue;
                }
                if (isAtWordPlaceholderNode(iNode) && isParenGroupNode(iNextNode) && locEnd(iNode) === locStart(iNextNode.open)) {
                  parts.push(softline);
                  continue;
                }
                if (iNode.value === "with" && isParenGroupNode(iNextNode)) {
                  parts.push(" ");
                  continue;
                }
                parts.push(line);
              }
              if (hasInlineComment) {
                parts.push(breakParent);
              }
              if (didBreak) {
                parts.unshift(hardline);
              }
              if (isControlDirective) {
                return group(indent(parts));
              }
              if (insideURLFunctionInImportAtRuleNode(path5)) {
                return group(fill(parts));
              }
              return group(indent(fill(parts)));
            }
            case "value-paren_group": {
              const parentNode = path5.getParentNode();
              if (parentNode && isURLFunctionNode(parentNode) && (node.groups.length === 1 || node.groups.length > 0 && node.groups[0].type === "value-comma_group" && node.groups[0].groups.length > 0 && node.groups[0].groups[0].type === "value-word" && node.groups[0].groups[0].value.startsWith("data:"))) {
                return [node.open ? print("open") : "", join2(",", path5.map(print, "groups")), node.close ? print("close") : ""];
              }
              if (!node.open) {
                const printed2 = path5.map(print, "groups");
                const res = [];
                for (let i = 0; i < printed2.length; i++) {
                  if (i !== 0) {
                    res.push([",", line]);
                  }
                  res.push(printed2[i]);
                }
                return group(indent(fill(res)));
              }
              const isSCSSMapItem = isSCSSMapItemNode(path5);
              const lastItem = getLast(node.groups);
              const isLastItemComment = lastItem && lastItem.type === "value-comment";
              const isKey2 = isKeyInValuePairNode(node, parentNode);
              const isConfiguration = isConfigurationNode(node, parentNode);
              const shouldBreak = isConfiguration || isSCSSMapItem && !isKey2;
              const shouldDedent = isConfiguration || isKey2;
              const printed = group([node.open ? print("open") : "", indent([softline, join2([line], path5.map((childPath, index) => {
                const child = childPath.getValue();
                const isLast = index === node.groups.length - 1;
                const printed2 = [print(), isLast ? "" : ","];
                if (isKeyValuePairNode(child) && child.type === "value-comma_group" && child.groups && child.groups[0].type !== "value-paren_group" && child.groups[2] && child.groups[2].type === "value-paren_group") {
                  const parts = getDocParts(printed2[0].contents.contents);
                  parts[1] = group(parts[1]);
                  return group(dedent(printed2));
                }
                if (!isLast && child.type === "value-comma_group" && isNonEmptyArray(child.groups)) {
                  const last = getLast(child.groups);
                  if (last.source && isNextLineEmpty(options.originalText, last, locEnd)) {
                    printed2.push(hardline);
                  }
                }
                return printed2;
              }, "groups"))]), ifBreak(!isLastItemComment && isSCSS(options.parser, options.originalText) && isSCSSMapItem && shouldPrintComma(options) ? "," : ""), softline, node.close ? print("close") : ""], {
                shouldBreak
              });
              return shouldDedent ? dedent(printed) : printed;
            }
            case "value-func": {
              return [node.value, insideAtRuleNode(path5, "supports") && isMediaAndSupportsKeywords(node) ? " " : "", print("group")];
            }
            case "value-paren": {
              return node.value;
            }
            case "value-number": {
              return [printCssNumber(node.value), printUnit(node.unit)];
            }
            case "value-operator": {
              return node.value;
            }
            case "value-word": {
              if (node.isColor && node.isHex || isWideKeywords(node.value)) {
                return node.value.toLowerCase();
              }
              return node.value;
            }
            case "value-colon": {
              const parentNode = path5.getParentNode();
              const index = parentNode && parentNode.groups.indexOf(node);
              const prevNode = index && parentNode.groups[index - 1];
              return [node.value, prevNode && typeof prevNode.value === "string" && getLast(prevNode.value) === "\\" || insideValueFunctionNode(path5, "url") ? "" : line];
            }
            case "value-comma": {
              return [node.value, " "];
            }
            case "value-string": {
              return printString(node.raws.quote + node.value + node.raws.quote, options);
            }
            case "value-atword": {
              return ["@", node.value];
            }
            case "value-unicode-range": {
              return node.value;
            }
            case "value-unknown": {
              return node.value;
            }
            default:
              throw new Error(`Unknown postcss type ${JSON.stringify(node.type)}`);
          }
        }
        function printNodeSequence(path5, options, print) {
          const parts = [];
          path5.each((pathChild, i, nodes) => {
            const prevNode = nodes[i - 1];
            if (prevNode && prevNode.type === "css-comment" && prevNode.text.trim() === "prettier-ignore") {
              const childNode = pathChild.getValue();
              parts.push(options.originalText.slice(locStart(childNode), locEnd(childNode)));
            } else {
              parts.push(print());
            }
            if (i !== nodes.length - 1) {
              if (nodes[i + 1].type === "css-comment" && !hasNewline(options.originalText, locStart(nodes[i + 1]), {
                backwards: true
              }) && !isFrontMatterNode(nodes[i]) || nodes[i + 1].type === "css-atrule" && nodes[i + 1].name === "else" && nodes[i].type !== "css-comment") {
                parts.push(" ");
              } else {
                parts.push(options.__isHTMLStyleAttribute ? line : hardline);
                if (isNextLineEmpty(options.originalText, pathChild.getValue(), locEnd) && !isFrontMatterNode(nodes[i])) {
                  parts.push(hardline);
                }
              }
            }
          }, "nodes");
          return parts;
        }
        var STRING_REGEX = /(["'])(?:(?!\1)[^\\]|\\.)*\1/gs;
        var NUMBER_REGEX = /(?:\d*\.\d+|\d+\.?)(?:[Ee][+-]?\d+)?/g;
        var STANDARD_UNIT_REGEX = /[A-Za-z]+/g;
        var WORD_PART_REGEX = /[$@]?[A-Z_a-z\u0080-\uFFFF][\w\u0080-\uFFFF-]*/g;
        var ADJUST_NUMBERS_REGEX = new RegExp(STRING_REGEX.source + `|(${WORD_PART_REGEX.source})?(${NUMBER_REGEX.source})(${STANDARD_UNIT_REGEX.source})?`, "g");
        function adjustStrings(value, options) {
          return value.replace(STRING_REGEX, (match) => printString(match, options));
        }
        function quoteAttributeValue(value, options) {
          const quote = options.singleQuote ? "'" : '"';
          return value.includes('"') || value.includes("'") ? value : quote + value + quote;
        }
        function adjustNumbers(value) {
          return value.replace(ADJUST_NUMBERS_REGEX, (match, quote, wordPart, number3, unit) => !wordPart && number3 ? printCssNumber(number3) + maybeToLowerCase(unit || "") : match);
        }
        function printCssNumber(rawNumber) {
          return printNumber(rawNumber).replace(/\.0(?=$|e)/, "");
        }
        module22.exports = {
          print: genericPrint,
          embed,
          insertPragma,
          massageAstNode: clean
        };
      }
    });
    var require_options3 = __commonJS22({
      "src/language-css/options.js"(exports22, module22) {
        "use strict";
        var commonOptions = require_common_options();
        module22.exports = {
          singleQuote: commonOptions.singleQuote
        };
      }
    });
    var require_parsers2 = __commonJS22({
      "src/language-css/parsers.js"(exports22, module22) {
        "use strict";
        module22.exports = {
          get css() {
            return require_parser_postcss().parsers.css;
          },
          get less() {
            return require_parser_postcss().parsers.less;
          },
          get scss() {
            return require_parser_postcss().parsers.scss;
          }
        };
      }
    });
    var require_CSS = __commonJS22({
      "node_modules/linguist-languages/data/CSS.json"(exports22, module22) {
        module22.exports = {
          name: "CSS",
          type: "markup",
          tmScope: "source.css",
          aceMode: "css",
          codemirrorMode: "css",
          codemirrorMimeType: "text/css",
          color: "#563d7c",
          extensions: [".css"],
          languageId: 50
        };
      }
    });
    var require_PostCSS = __commonJS22({
      "node_modules/linguist-languages/data/PostCSS.json"(exports22, module22) {
        module22.exports = {
          name: "PostCSS",
          type: "markup",
          color: "#dc3a0c",
          tmScope: "source.postcss",
          group: "CSS",
          extensions: [".pcss", ".postcss"],
          aceMode: "text",
          languageId: 262764437
        };
      }
    });
    var require_Less = __commonJS22({
      "node_modules/linguist-languages/data/Less.json"(exports22, module22) {
        module22.exports = {
          name: "Less",
          type: "markup",
          color: "#1d365d",
          aliases: ["less-css"],
          extensions: [".less"],
          tmScope: "source.css.less",
          aceMode: "less",
          codemirrorMode: "css",
          codemirrorMimeType: "text/css",
          languageId: 198
        };
      }
    });
    var require_SCSS = __commonJS22({
      "node_modules/linguist-languages/data/SCSS.json"(exports22, module22) {
        module22.exports = {
          name: "SCSS",
          type: "markup",
          color: "#c6538c",
          tmScope: "source.css.scss",
          aceMode: "scss",
          codemirrorMode: "css",
          codemirrorMimeType: "text/x-scss",
          extensions: [".scss"],
          languageId: 329
        };
      }
    });
    var require_language_css = __commonJS22({
      "src/language-css/index.js"(exports22, module22) {
        "use strict";
        var createLanguage = require_create_language();
        var printer = require_printer_postcss();
        var options = require_options3();
        var parsers = require_parsers2();
        var languages = [createLanguage(require_CSS(), (data) => ({
          since: "1.4.0",
          parsers: ["css"],
          vscodeLanguageIds: ["css"],
          extensions: [...data.extensions, ".wxss"]
        })), createLanguage(require_PostCSS(), () => ({
          since: "1.4.0",
          parsers: ["css"],
          vscodeLanguageIds: ["postcss"]
        })), createLanguage(require_Less(), () => ({
          since: "1.4.0",
          parsers: ["less"],
          vscodeLanguageIds: ["less"]
        })), createLanguage(require_SCSS(), () => ({
          since: "1.4.0",
          parsers: ["scss"],
          vscodeLanguageIds: ["scss"]
        }))];
        var printers = {
          postcss: printer
        };
        module22.exports = {
          languages,
          options,
          printers,
          parsers
        };
      }
    });
    var require_loc3 = __commonJS22({
      "src/language-handlebars/loc.js"(exports22, module22) {
        "use strict";
        function locStart(node) {
          return node.loc.start.offset;
        }
        function locEnd(node) {
          return node.loc.end.offset;
        }
        module22.exports = {
          locStart,
          locEnd
        };
      }
    });
    var require_clean3 = __commonJS22({
      "src/language-handlebars/clean.js"(exports22, module22) {
        "use strict";
        function clean(ast, newNode) {
          if (ast.type === "TextNode") {
            const trimmed = ast.chars.trim();
            if (!trimmed) {
              return null;
            }
            newNode.chars = trimmed.replace(/[\t\n\f\r ]+/g, " ");
          }
          if (ast.type === "AttrNode" && ast.name.toLowerCase() === "class") {
            delete newNode.value;
          }
        }
        clean.ignoredProperties = /* @__PURE__ */ new Set(["loc", "selfClosing"]);
        module22.exports = clean;
      }
    });
    var require_html_void_elements = __commonJS22({
      "vendors/html-void-elements.json"(exports22, module22) {
        module22.exports = {
          htmlVoidElements: ["area", "base", "basefont", "bgsound", "br", "col", "command", "embed", "frame", "hr", "image", "img", "input", "isindex", "keygen", "link", "menuitem", "meta", "nextid", "param", "source", "track", "wbr"]
        };
      }
    });
    var require_utils9 = __commonJS22({
      "src/language-handlebars/utils.js"(exports22, module22) {
        "use strict";
        var {
          htmlVoidElements
        } = require_html_void_elements();
        var getLast = require_get_last();
        function isLastNodeOfSiblings(path5) {
          const node = path5.getValue();
          const parentNode = path5.getParentNode(0);
          if (isParentOfSomeType(path5, ["ElementNode"]) && getLast(parentNode.children) === node) {
            return true;
          }
          if (isParentOfSomeType(path5, ["Block"]) && getLast(parentNode.body) === node) {
            return true;
          }
          return false;
        }
        function isUppercase(string3) {
          return string3.toUpperCase() === string3;
        }
        function isGlimmerComponent(node) {
          return isNodeOfSomeType(node, ["ElementNode"]) && typeof node.tag === "string" && !node.tag.startsWith(":") && (isUppercase(node.tag[0]) || node.tag.includes("."));
        }
        var voidTags = new Set(htmlVoidElements);
        function isVoid(node) {
          return voidTags.has(node.tag) || isGlimmerComponent(node) && node.children.every((node2) => isWhitespaceNode(node2));
        }
        function isWhitespaceNode(node) {
          return isNodeOfSomeType(node, ["TextNode"]) && !/\S/.test(node.chars);
        }
        function isNodeOfSomeType(node, types2) {
          return node && types2.includes(node.type);
        }
        function isParentOfSomeType(path5, types2) {
          const parentNode = path5.getParentNode(0);
          return isNodeOfSomeType(parentNode, types2);
        }
        function isPreviousNodeOfSomeType(path5, types2) {
          const previousNode = getPreviousNode(path5);
          return isNodeOfSomeType(previousNode, types2);
        }
        function isNextNodeOfSomeType(path5, types2) {
          const nextNode = getNextNode(path5);
          return isNodeOfSomeType(nextNode, types2);
        }
        function getSiblingNode(path5, offset) {
          var _path$getParentNode2, _ref7, _ref8, _parentNode$children;
          const node = path5.getValue();
          const parentNode = (_path$getParentNode2 = path5.getParentNode(0)) !== null && _path$getParentNode2 !== void 0 ? _path$getParentNode2 : {};
          const children = (_ref7 = (_ref8 = (_parentNode$children = parentNode.children) !== null && _parentNode$children !== void 0 ? _parentNode$children : parentNode.body) !== null && _ref8 !== void 0 ? _ref8 : parentNode.parts) !== null && _ref7 !== void 0 ? _ref7 : [];
          const index = children.indexOf(node);
          return index !== -1 && children[index + offset];
        }
        function getPreviousNode(path5, lookBack = 1) {
          return getSiblingNode(path5, -lookBack);
        }
        function getNextNode(path5) {
          return getSiblingNode(path5, 1);
        }
        function isPrettierIgnoreNode(node) {
          return isNodeOfSomeType(node, ["MustacheCommentStatement"]) && typeof node.value === "string" && node.value.trim() === "prettier-ignore";
        }
        function hasPrettierIgnore(path5) {
          const node = path5.getValue();
          const previousPreviousNode = getPreviousNode(path5, 2);
          return isPrettierIgnoreNode(node) || isPrettierIgnoreNode(previousPreviousNode);
        }
        module22.exports = {
          getNextNode,
          getPreviousNode,
          hasPrettierIgnore,
          isLastNodeOfSiblings,
          isNextNodeOfSomeType,
          isNodeOfSomeType,
          isParentOfSomeType,
          isPreviousNodeOfSomeType,
          isVoid,
          isWhitespaceNode
        };
      }
    });
    var require_printer_glimmer = __commonJS22({
      "src/language-handlebars/printer-glimmer.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            dedent,
            fill,
            group,
            hardline,
            ifBreak,
            indent,
            join: join2,
            line,
            softline
          },
          utils: {
            getDocParts,
            replaceTextEndOfLine
          }
        } = require_doc();
        var {
          getPreferredQuote,
          isNonEmptyArray
        } = require_util2();
        var {
          locStart,
          locEnd
        } = require_loc3();
        var clean = require_clean3();
        var {
          getNextNode,
          getPreviousNode,
          hasPrettierIgnore,
          isLastNodeOfSiblings,
          isNextNodeOfSomeType,
          isNodeOfSomeType,
          isParentOfSomeType,
          isPreviousNodeOfSomeType,
          isVoid,
          isWhitespaceNode
        } = require_utils9();
        var NEWLINES_TO_PRESERVE_MAX = 2;
        function print(path5, options, print2) {
          const node = path5.getValue();
          if (!node) {
            return "";
          }
          if (hasPrettierIgnore(path5)) {
            return options.originalText.slice(locStart(node), locEnd(node));
          }
          const favoriteQuote = options.singleQuote ? "'" : '"';
          switch (node.type) {
            case "Block":
            case "Program":
            case "Template": {
              return group(path5.map(print2, "body"));
            }
            case "ElementNode": {
              const startingTag = group(printStartingTag(path5, print2));
              const escapeNextElementNode = options.htmlWhitespaceSensitivity === "ignore" && isNextNodeOfSomeType(path5, ["ElementNode"]) ? softline : "";
              if (isVoid(node)) {
                return [startingTag, escapeNextElementNode];
              }
              const endingTag = ["</", node.tag, ">"];
              if (node.children.length === 0) {
                return [startingTag, indent(endingTag), escapeNextElementNode];
              }
              if (options.htmlWhitespaceSensitivity === "ignore") {
                return [startingTag, indent(printChildren(path5, options, print2)), hardline, indent(endingTag), escapeNextElementNode];
              }
              return [startingTag, indent(group(printChildren(path5, options, print2))), indent(endingTag), escapeNextElementNode];
            }
            case "BlockStatement": {
              const pp = path5.getParentNode(1);
              const isElseIf = pp && pp.inverse && pp.inverse.body.length === 1 && pp.inverse.body[0] === node && pp.inverse.body[0].path.parts[0] === "if";
              if (isElseIf) {
                return [printElseIfBlock(path5, print2), printProgram(path5, print2, options), printInverse(path5, print2, options)];
              }
              return [printOpenBlock(path5, print2), group([printProgram(path5, print2, options), printInverse(path5, print2, options), printCloseBlock(path5, print2, options)])];
            }
            case "ElementModifierStatement": {
              return group(["{{", printPathAndParams(path5, print2), "}}"]);
            }
            case "MustacheStatement": {
              return group([printOpeningMustache(node), printPathAndParams(path5, print2), printClosingMustache(node)]);
            }
            case "SubExpression": {
              return group(["(", printSubExpressionPathAndParams(path5, print2), softline, ")"]);
            }
            case "AttrNode": {
              const isText = node.value.type === "TextNode";
              const isEmptyText = isText && node.value.chars === "";
              if (isEmptyText && locStart(node.value) === locEnd(node.value)) {
                return node.name;
              }
              const quote = isText ? getPreferredQuote(node.value.chars, favoriteQuote).quote : node.value.type === "ConcatStatement" ? getPreferredQuote(node.value.parts.filter((part) => part.type === "TextNode").map((part) => part.chars).join(""), favoriteQuote).quote : "";
              const valueDoc = print2("value");
              return [node.name, "=", quote, node.name === "class" && quote ? group(indent(valueDoc)) : valueDoc, quote];
            }
            case "ConcatStatement": {
              return path5.map(print2, "parts");
            }
            case "Hash": {
              return join2(line, path5.map(print2, "pairs"));
            }
            case "HashPair": {
              return [node.key, "=", print2("value")];
            }
            case "TextNode": {
              let text = node.chars.replace(/{{/g, "\\{{");
              const attrName = getCurrentAttributeName(path5);
              if (attrName) {
                if (attrName === "class") {
                  const formattedClasses = text.trim().split(/\s+/).join(" ");
                  let leadingSpace2 = false;
                  let trailingSpace2 = false;
                  if (isParentOfSomeType(path5, ["ConcatStatement"])) {
                    if (isPreviousNodeOfSomeType(path5, ["MustacheStatement"]) && /^\s/.test(text)) {
                      leadingSpace2 = true;
                    }
                    if (isNextNodeOfSomeType(path5, ["MustacheStatement"]) && /\s$/.test(text) && formattedClasses !== "") {
                      trailingSpace2 = true;
                    }
                  }
                  return [leadingSpace2 ? line : "", formattedClasses, trailingSpace2 ? line : ""];
                }
                return replaceTextEndOfLine(text);
              }
              const whitespacesOnlyRE = /^[\t\n\f\r ]*$/;
              const isWhitespaceOnly = whitespacesOnlyRE.test(text);
              const isFirstElement = !getPreviousNode(path5);
              const isLastElement = !getNextNode(path5);
              if (options.htmlWhitespaceSensitivity !== "ignore") {
                const leadingWhitespacesRE = /^[\t\n\f\r ]*/;
                const trailingWhitespacesRE = /[\t\n\f\r ]*$/;
                const shouldTrimTrailingNewlines = isLastElement && isParentOfSomeType(path5, ["Template"]);
                const shouldTrimLeadingNewlines = isFirstElement && isParentOfSomeType(path5, ["Template"]);
                if (isWhitespaceOnly) {
                  if (shouldTrimLeadingNewlines || shouldTrimTrailingNewlines) {
                    return "";
                  }
                  let breaks = [line];
                  const newlines = countNewLines(text);
                  if (newlines) {
                    breaks = generateHardlines(newlines);
                  }
                  if (isLastNodeOfSiblings(path5)) {
                    breaks = breaks.map((newline) => dedent(newline));
                  }
                  return breaks;
                }
                const [lead] = text.match(leadingWhitespacesRE);
                const [tail] = text.match(trailingWhitespacesRE);
                let leadBreaks = [];
                if (lead) {
                  leadBreaks = [line];
                  const leadingNewlines = countNewLines(lead);
                  if (leadingNewlines) {
                    leadBreaks = generateHardlines(leadingNewlines);
                  }
                  text = text.replace(leadingWhitespacesRE, "");
                }
                let trailBreaks = [];
                if (tail) {
                  if (!shouldTrimTrailingNewlines) {
                    trailBreaks = [line];
                    const trailingNewlines = countNewLines(tail);
                    if (trailingNewlines) {
                      trailBreaks = generateHardlines(trailingNewlines);
                    }
                    if (isLastNodeOfSiblings(path5)) {
                      trailBreaks = trailBreaks.map((hardline2) => dedent(hardline2));
                    }
                  }
                  text = text.replace(trailingWhitespacesRE, "");
                }
                return [...leadBreaks, fill(getTextValueParts(text)), ...trailBreaks];
              }
              const lineBreaksCount = countNewLines(text);
              let leadingLineBreaksCount = countLeadingNewLines(text);
              let trailingLineBreaksCount = countTrailingNewLines(text);
              if ((isFirstElement || isLastElement) && isWhitespaceOnly && isParentOfSomeType(path5, ["Block", "ElementNode", "Template"])) {
                return "";
              }
              if (isWhitespaceOnly && lineBreaksCount) {
                leadingLineBreaksCount = Math.min(lineBreaksCount, NEWLINES_TO_PRESERVE_MAX);
                trailingLineBreaksCount = 0;
              } else {
                if (isNextNodeOfSomeType(path5, ["BlockStatement", "ElementNode"])) {
                  trailingLineBreaksCount = Math.max(trailingLineBreaksCount, 1);
                }
                if (isPreviousNodeOfSomeType(path5, ["BlockStatement", "ElementNode"])) {
                  leadingLineBreaksCount = Math.max(leadingLineBreaksCount, 1);
                }
              }
              let leadingSpace = "";
              let trailingSpace = "";
              if (trailingLineBreaksCount === 0 && isNextNodeOfSomeType(path5, ["MustacheStatement"])) {
                trailingSpace = " ";
              }
              if (leadingLineBreaksCount === 0 && isPreviousNodeOfSomeType(path5, ["MustacheStatement"])) {
                leadingSpace = " ";
              }
              if (isFirstElement) {
                leadingLineBreaksCount = 0;
                leadingSpace = "";
              }
              if (isLastElement) {
                trailingLineBreaksCount = 0;
                trailingSpace = "";
              }
              text = text.replace(/^[\t\n\f\r ]+/g, leadingSpace).replace(/[\t\n\f\r ]+$/, trailingSpace);
              return [...generateHardlines(leadingLineBreaksCount), fill(getTextValueParts(text)), ...generateHardlines(trailingLineBreaksCount)];
            }
            case "MustacheCommentStatement": {
              const start = locStart(node);
              const end = locEnd(node);
              const isLeftWhiteSpaceSensitive = options.originalText.charAt(start + 2) === "~";
              const isRightWhitespaceSensitive = options.originalText.charAt(end - 3) === "~";
              const dashes = node.value.includes("}}") ? "--" : "";
              return ["{{", isLeftWhiteSpaceSensitive ? "~" : "", "!", dashes, node.value, dashes, isRightWhitespaceSensitive ? "~" : "", "}}"];
            }
            case "PathExpression": {
              return node.original;
            }
            case "BooleanLiteral": {
              return String(node.value);
            }
            case "CommentStatement": {
              return ["<!--", node.value, "-->"];
            }
            case "StringLiteral": {
              if (needsOppositeQuote(path5)) {
                const printFavoriteQuote = !options.singleQuote ? "'" : '"';
                return printStringLiteral(node.value, printFavoriteQuote);
              }
              return printStringLiteral(node.value, favoriteQuote);
            }
            case "NumberLiteral": {
              return String(node.value);
            }
            case "UndefinedLiteral": {
              return "undefined";
            }
            case "NullLiteral": {
              return "null";
            }
            default:
              throw new Error("unknown glimmer type: " + JSON.stringify(node.type));
          }
        }
        function sortByLoc(a, b) {
          return locStart(a) - locStart(b);
        }
        function printStartingTag(path5, print2) {
          const node = path5.getValue();
          const types2 = ["attributes", "modifiers", "comments"].filter((property4) => isNonEmptyArray(node[property4]));
          const attributes = types2.flatMap((type2) => node[type2]).sort(sortByLoc);
          for (const attributeType of types2) {
            path5.each((attributePath) => {
              const index = attributes.indexOf(attributePath.getValue());
              attributes.splice(index, 1, [line, print2()]);
            }, attributeType);
          }
          if (isNonEmptyArray(node.blockParams)) {
            attributes.push(line, printBlockParams(node));
          }
          return ["<", node.tag, indent(attributes), printStartingTagEndMarker(node)];
        }
        function printChildren(path5, options, print2) {
          const node = path5.getValue();
          const isEmpty = node.children.every((node2) => isWhitespaceNode(node2));
          if (options.htmlWhitespaceSensitivity === "ignore" && isEmpty) {
            return "";
          }
          return path5.map((childPath, childIndex) => {
            const printedChild = print2();
            if (childIndex === 0 && options.htmlWhitespaceSensitivity === "ignore") {
              return [softline, printedChild];
            }
            return printedChild;
          }, "children");
        }
        function printStartingTagEndMarker(node) {
          if (isVoid(node)) {
            return ifBreak([softline, "/>"], [" />", softline]);
          }
          return ifBreak([softline, ">"], ">");
        }
        function printOpeningMustache(node) {
          const mustache = node.escaped === false ? "{{{" : "{{";
          const strip = node.strip && node.strip.open ? "~" : "";
          return [mustache, strip];
        }
        function printClosingMustache(node) {
          const mustache = node.escaped === false ? "}}}" : "}}";
          const strip = node.strip && node.strip.close ? "~" : "";
          return [strip, mustache];
        }
        function printOpeningBlockOpeningMustache(node) {
          const opening = printOpeningMustache(node);
          const strip = node.openStrip.open ? "~" : "";
          return [opening, strip, "#"];
        }
        function printOpeningBlockClosingMustache(node) {
          const closing = printClosingMustache(node);
          const strip = node.openStrip.close ? "~" : "";
          return [strip, closing];
        }
        function printClosingBlockOpeningMustache(node) {
          const opening = printOpeningMustache(node);
          const strip = node.closeStrip.open ? "~" : "";
          return [opening, strip, "/"];
        }
        function printClosingBlockClosingMustache(node) {
          const closing = printClosingMustache(node);
          const strip = node.closeStrip.close ? "~" : "";
          return [strip, closing];
        }
        function printInverseBlockOpeningMustache(node) {
          const opening = printOpeningMustache(node);
          const strip = node.inverseStrip.open ? "~" : "";
          return [opening, strip];
        }
        function printInverseBlockClosingMustache(node) {
          const closing = printClosingMustache(node);
          const strip = node.inverseStrip.close ? "~" : "";
          return [strip, closing];
        }
        function printOpenBlock(path5, print2) {
          const node = path5.getValue();
          const openingMustache = printOpeningBlockOpeningMustache(node);
          const closingMustache = printOpeningBlockClosingMustache(node);
          const attributes = [printPath(path5, print2)];
          const params = printParams(path5, print2);
          if (params) {
            attributes.push(line, params);
          }
          if (isNonEmptyArray(node.program.blockParams)) {
            const block = printBlockParams(node.program);
            attributes.push(line, block);
          }
          return group([openingMustache, indent(attributes), softline, closingMustache]);
        }
        function printElseBlock(node, options) {
          return [options.htmlWhitespaceSensitivity === "ignore" ? hardline : "", printInverseBlockOpeningMustache(node), "else", printInverseBlockClosingMustache(node)];
        }
        function printElseIfBlock(path5, print2) {
          const parentNode = path5.getParentNode(1);
          return [printInverseBlockOpeningMustache(parentNode), "else if ", printParams(path5, print2), printInverseBlockClosingMustache(parentNode)];
        }
        function printCloseBlock(path5, print2, options) {
          const node = path5.getValue();
          if (options.htmlWhitespaceSensitivity === "ignore") {
            const escape = blockStatementHasOnlyWhitespaceInProgram(node) ? softline : hardline;
            return [escape, printClosingBlockOpeningMustache(node), print2("path"), printClosingBlockClosingMustache(node)];
          }
          return [printClosingBlockOpeningMustache(node), print2("path"), printClosingBlockClosingMustache(node)];
        }
        function blockStatementHasOnlyWhitespaceInProgram(node) {
          return isNodeOfSomeType(node, ["BlockStatement"]) && node.program.body.every((node2) => isWhitespaceNode(node2));
        }
        function blockStatementHasElseIf(node) {
          return blockStatementHasElse(node) && node.inverse.body.length === 1 && isNodeOfSomeType(node.inverse.body[0], ["BlockStatement"]) && node.inverse.body[0].path.parts[0] === "if";
        }
        function blockStatementHasElse(node) {
          return isNodeOfSomeType(node, ["BlockStatement"]) && node.inverse;
        }
        function printProgram(path5, print2, options) {
          const node = path5.getValue();
          if (blockStatementHasOnlyWhitespaceInProgram(node)) {
            return "";
          }
          const program = print2("program");
          if (options.htmlWhitespaceSensitivity === "ignore") {
            return indent([hardline, program]);
          }
          return indent(program);
        }
        function printInverse(path5, print2, options) {
          const node = path5.getValue();
          const inverse = print2("inverse");
          const printed = options.htmlWhitespaceSensitivity === "ignore" ? [hardline, inverse] : inverse;
          if (blockStatementHasElseIf(node)) {
            return printed;
          }
          if (blockStatementHasElse(node)) {
            return [printElseBlock(node, options), indent(printed)];
          }
          return "";
        }
        function getTextValueParts(value) {
          return getDocParts(join2(line, splitByHtmlWhitespace(value)));
        }
        function splitByHtmlWhitespace(string3) {
          return string3.split(/[\t\n\f\r ]+/);
        }
        function getCurrentAttributeName(path5) {
          for (let depth = 0; depth < 2; depth++) {
            const parentNode = path5.getParentNode(depth);
            if (parentNode && parentNode.type === "AttrNode") {
              return parentNode.name.toLowerCase();
            }
          }
        }
        function countNewLines(string3) {
          string3 = typeof string3 === "string" ? string3 : "";
          return string3.split("\n").length - 1;
        }
        function countLeadingNewLines(string3) {
          string3 = typeof string3 === "string" ? string3 : "";
          const newLines = (string3.match(/^([^\S\n\r]*[\n\r])+/g) || [])[0] || "";
          return countNewLines(newLines);
        }
        function countTrailingNewLines(string3) {
          string3 = typeof string3 === "string" ? string3 : "";
          const newLines = (string3.match(/([\n\r][^\S\n\r]*)+$/g) || [])[0] || "";
          return countNewLines(newLines);
        }
        function generateHardlines(number3 = 0) {
          return Array.from({
            length: Math.min(number3, NEWLINES_TO_PRESERVE_MAX)
          }).fill(hardline);
        }
        function printStringLiteral(stringLiteral3, favoriteQuote) {
          const {
            quote,
            regex
          } = getPreferredQuote(stringLiteral3, favoriteQuote);
          return [quote, stringLiteral3.replace(regex, `\\${quote}`), quote];
        }
        function needsOppositeQuote(path5) {
          let index = 0;
          let parentNode = path5.getParentNode(index);
          while (parentNode && isNodeOfSomeType(parentNode, ["SubExpression"])) {
            index++;
            parentNode = path5.getParentNode(index);
          }
          if (parentNode && isNodeOfSomeType(path5.getParentNode(index + 1), ["ConcatStatement"]) && isNodeOfSomeType(path5.getParentNode(index + 2), ["AttrNode"])) {
            return true;
          }
          return false;
        }
        function printSubExpressionPathAndParams(path5, print2) {
          const printed = printPath(path5, print2);
          const params = printParams(path5, print2);
          if (!params) {
            return printed;
          }
          return indent([printed, line, group(params)]);
        }
        function printPathAndParams(path5, print2) {
          const p = printPath(path5, print2);
          const params = printParams(path5, print2);
          if (!params) {
            return p;
          }
          return [indent([p, line, params]), softline];
        }
        function printPath(path5, print2) {
          return print2("path");
        }
        function printParams(path5, print2) {
          const node = path5.getValue();
          const parts = [];
          if (node.params.length > 0) {
            const params = path5.map(print2, "params");
            parts.push(...params);
          }
          if (node.hash && node.hash.pairs.length > 0) {
            const hash2 = print2("hash");
            parts.push(hash2);
          }
          if (parts.length === 0) {
            return "";
          }
          return join2(line, parts);
        }
        function printBlockParams(node) {
          return ["as |", node.blockParams.join(" "), "|"];
        }
        module22.exports = {
          print,
          massageAstNode: clean
        };
      }
    });
    var require_parsers3 = __commonJS22({
      "src/language-handlebars/parsers.js"(exports22, module22) {
        "use strict";
        module22.exports = {
          get glimmer() {
            return require_parser_glimmer().parsers.glimmer;
          }
        };
      }
    });
    var require_Handlebars = __commonJS22({
      "node_modules/linguist-languages/data/Handlebars.json"(exports22, module22) {
        module22.exports = {
          name: "Handlebars",
          type: "markup",
          color: "#f7931e",
          aliases: ["hbs", "htmlbars"],
          extensions: [".handlebars", ".hbs"],
          tmScope: "text.html.handlebars",
          aceMode: "handlebars",
          languageId: 155
        };
      }
    });
    var require_language_handlebars = __commonJS22({
      "src/language-handlebars/index.js"(exports22, module22) {
        "use strict";
        var createLanguage = require_create_language();
        var printer = require_printer_glimmer();
        var parsers = require_parsers3();
        var languages = [createLanguage(require_Handlebars(), () => ({
          since: "2.3.0",
          parsers: ["glimmer"],
          vscodeLanguageIds: ["handlebars"]
        }))];
        var printers = {
          glimmer: printer
        };
        module22.exports = {
          languages,
          printers,
          parsers
        };
      }
    });
    var require_pragma3 = __commonJS22({
      "src/language-graphql/pragma.js"(exports22, module22) {
        "use strict";
        function hasPragma(text) {
          return /^\s*#[^\S\n]*@(?:format|prettier)\s*(?:\n|$)/.test(text);
        }
        function insertPragma(text) {
          return "# @format\n\n" + text;
        }
        module22.exports = {
          hasPragma,
          insertPragma
        };
      }
    });
    var require_loc4 = __commonJS22({
      "src/language-graphql/loc.js"(exports22, module22) {
        "use strict";
        function locStart(node) {
          if (typeof node.start === "number") {
            return node.start;
          }
          return node.loc && node.loc.start;
        }
        function locEnd(node) {
          if (typeof node.end === "number") {
            return node.end;
          }
          return node.loc && node.loc.end;
        }
        module22.exports = {
          locStart,
          locEnd
        };
      }
    });
    var require_printer_graphql = __commonJS22({
      "src/language-graphql/printer-graphql.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            join: join2,
            hardline,
            line,
            softline,
            group,
            indent,
            ifBreak
          }
        } = require_doc();
        var {
          isNextLineEmpty,
          isNonEmptyArray
        } = require_util2();
        var {
          insertPragma
        } = require_pragma3();
        var {
          locStart,
          locEnd
        } = require_loc4();
        function genericPrint(path5, options, print) {
          const node = path5.getValue();
          if (!node) {
            return "";
          }
          if (typeof node === "string") {
            return node;
          }
          switch (node.kind) {
            case "Document": {
              const parts = [];
              path5.each((pathChild, index, definitions) => {
                parts.push(print());
                if (index !== definitions.length - 1) {
                  parts.push(hardline);
                  if (isNextLineEmpty(options.originalText, pathChild.getValue(), locEnd)) {
                    parts.push(hardline);
                  }
                }
              }, "definitions");
              return [...parts, hardline];
            }
            case "OperationDefinition": {
              const hasOperation = options.originalText[locStart(node)] !== "{";
              const hasName = Boolean(node.name);
              return [hasOperation ? node.operation : "", hasOperation && hasName ? [" ", print("name")] : "", hasOperation && !hasName && isNonEmptyArray(node.variableDefinitions) ? " " : "", isNonEmptyArray(node.variableDefinitions) ? group(["(", indent([softline, join2([ifBreak("", ", "), softline], path5.map(print, "variableDefinitions"))]), softline, ")"]) : "", printDirectives(path5, print, node), node.selectionSet ? !hasOperation && !hasName ? "" : " " : "", print("selectionSet")];
            }
            case "FragmentDefinition": {
              return ["fragment ", print("name"), isNonEmptyArray(node.variableDefinitions) ? group(["(", indent([softline, join2([ifBreak("", ", "), softline], path5.map(print, "variableDefinitions"))]), softline, ")"]) : "", " on ", print("typeCondition"), printDirectives(path5, print, node), " ", print("selectionSet")];
            }
            case "SelectionSet": {
              return ["{", indent([hardline, join2(hardline, printSequence(path5, options, print, "selections"))]), hardline, "}"];
            }
            case "Field": {
              return group([node.alias ? [print("alias"), ": "] : "", print("name"), node.arguments.length > 0 ? group(["(", indent([softline, join2([ifBreak("", ", "), softline], printSequence(path5, options, print, "arguments"))]), softline, ")"]) : "", printDirectives(path5, print, node), node.selectionSet ? " " : "", print("selectionSet")]);
            }
            case "Name": {
              return node.value;
            }
            case "StringValue": {
              if (node.block) {
                const lines = node.value.replace(/"""/g, "\\$&").split("\n");
                if (lines.length === 1) {
                  lines[0] = lines[0].trim();
                }
                if (lines.every((line2) => line2 === "")) {
                  lines.length = 0;
                }
                return join2(hardline, ['"""', ...lines, '"""']);
              }
              return ['"', node.value.replace(/["\\]/g, "\\$&").replace(/\n/g, "\\n"), '"'];
            }
            case "IntValue":
            case "FloatValue":
            case "EnumValue": {
              return node.value;
            }
            case "BooleanValue": {
              return node.value ? "true" : "false";
            }
            case "NullValue": {
              return "null";
            }
            case "Variable": {
              return ["$", print("name")];
            }
            case "ListValue": {
              return group(["[", indent([softline, join2([ifBreak("", ", "), softline], path5.map(print, "values"))]), softline, "]"]);
            }
            case "ObjectValue": {
              return group(["{", options.bracketSpacing && node.fields.length > 0 ? " " : "", indent([softline, join2([ifBreak("", ", "), softline], path5.map(print, "fields"))]), softline, ifBreak("", options.bracketSpacing && node.fields.length > 0 ? " " : ""), "}"]);
            }
            case "ObjectField":
            case "Argument": {
              return [print("name"), ": ", print("value")];
            }
            case "Directive": {
              return ["@", print("name"), node.arguments.length > 0 ? group(["(", indent([softline, join2([ifBreak("", ", "), softline], printSequence(path5, options, print, "arguments"))]), softline, ")"]) : ""];
            }
            case "NamedType": {
              return print("name");
            }
            case "VariableDefinition": {
              return [print("variable"), ": ", print("type"), node.defaultValue ? [" = ", print("defaultValue")] : "", printDirectives(path5, print, node)];
            }
            case "ObjectTypeExtension":
            case "ObjectTypeDefinition": {
              return [print("description"), node.description ? hardline : "", node.kind === "ObjectTypeExtension" ? "extend " : "", "type ", print("name"), node.interfaces.length > 0 ? [" implements ", ...printInterfaces(path5, options, print)] : "", printDirectives(path5, print, node), node.fields.length > 0 ? [" {", indent([hardline, join2(hardline, printSequence(path5, options, print, "fields"))]), hardline, "}"] : ""];
            }
            case "FieldDefinition": {
              return [print("description"), node.description ? hardline : "", print("name"), node.arguments.length > 0 ? group(["(", indent([softline, join2([ifBreak("", ", "), softline], printSequence(path5, options, print, "arguments"))]), softline, ")"]) : "", ": ", print("type"), printDirectives(path5, print, node)];
            }
            case "DirectiveDefinition": {
              return [print("description"), node.description ? hardline : "", "directive ", "@", print("name"), node.arguments.length > 0 ? group(["(", indent([softline, join2([ifBreak("", ", "), softline], printSequence(path5, options, print, "arguments"))]), softline, ")"]) : "", node.repeatable ? " repeatable" : "", " on ", join2(" | ", path5.map(print, "locations"))];
            }
            case "EnumTypeExtension":
            case "EnumTypeDefinition": {
              return [print("description"), node.description ? hardline : "", node.kind === "EnumTypeExtension" ? "extend " : "", "enum ", print("name"), printDirectives(path5, print, node), node.values.length > 0 ? [" {", indent([hardline, join2(hardline, printSequence(path5, options, print, "values"))]), hardline, "}"] : ""];
            }
            case "EnumValueDefinition": {
              return [print("description"), node.description ? hardline : "", print("name"), printDirectives(path5, print, node)];
            }
            case "InputValueDefinition": {
              return [print("description"), node.description ? node.description.block ? hardline : line : "", print("name"), ": ", print("type"), node.defaultValue ? [" = ", print("defaultValue")] : "", printDirectives(path5, print, node)];
            }
            case "InputObjectTypeExtension":
            case "InputObjectTypeDefinition": {
              return [print("description"), node.description ? hardline : "", node.kind === "InputObjectTypeExtension" ? "extend " : "", "input ", print("name"), printDirectives(path5, print, node), node.fields.length > 0 ? [" {", indent([hardline, join2(hardline, printSequence(path5, options, print, "fields"))]), hardline, "}"] : ""];
            }
            case "SchemaExtension": {
              return ["extend schema", printDirectives(path5, print, node), ...node.operationTypes.length > 0 ? [" {", indent([hardline, join2(hardline, printSequence(path5, options, print, "operationTypes"))]), hardline, "}"] : []];
            }
            case "SchemaDefinition": {
              return [print("description"), node.description ? hardline : "", "schema", printDirectives(path5, print, node), " {", node.operationTypes.length > 0 ? indent([hardline, join2(hardline, printSequence(path5, options, print, "operationTypes"))]) : "", hardline, "}"];
            }
            case "OperationTypeDefinition": {
              return [print("operation"), ": ", print("type")];
            }
            case "InterfaceTypeExtension":
            case "InterfaceTypeDefinition": {
              return [print("description"), node.description ? hardline : "", node.kind === "InterfaceTypeExtension" ? "extend " : "", "interface ", print("name"), node.interfaces.length > 0 ? [" implements ", ...printInterfaces(path5, options, print)] : "", printDirectives(path5, print, node), node.fields.length > 0 ? [" {", indent([hardline, join2(hardline, printSequence(path5, options, print, "fields"))]), hardline, "}"] : ""];
            }
            case "FragmentSpread": {
              return ["...", print("name"), printDirectives(path5, print, node)];
            }
            case "InlineFragment": {
              return ["...", node.typeCondition ? [" on ", print("typeCondition")] : "", printDirectives(path5, print, node), " ", print("selectionSet")];
            }
            case "UnionTypeExtension":
            case "UnionTypeDefinition": {
              return group([print("description"), node.description ? hardline : "", group([node.kind === "UnionTypeExtension" ? "extend " : "", "union ", print("name"), printDirectives(path5, print, node), node.types.length > 0 ? [" =", ifBreak("", " "), indent([ifBreak([line, "  "]), join2([line, "| "], path5.map(print, "types"))])] : ""])]);
            }
            case "ScalarTypeExtension":
            case "ScalarTypeDefinition": {
              return [print("description"), node.description ? hardline : "", node.kind === "ScalarTypeExtension" ? "extend " : "", "scalar ", print("name"), printDirectives(path5, print, node)];
            }
            case "NonNullType": {
              return [print("type"), "!"];
            }
            case "ListType": {
              return ["[", print("type"), "]"];
            }
            default:
              throw new Error("unknown graphql type: " + JSON.stringify(node.kind));
          }
        }
        function printDirectives(path5, print, node) {
          if (node.directives.length === 0) {
            return "";
          }
          const printed = join2(line, path5.map(print, "directives"));
          if (node.kind === "FragmentDefinition" || node.kind === "OperationDefinition") {
            return group([line, printed]);
          }
          return [" ", group(indent([softline, printed]))];
        }
        function printSequence(path5, options, print, property4) {
          return path5.map((path22, index, sequence) => {
            const printed = print();
            if (index < sequence.length - 1 && isNextLineEmpty(options.originalText, path22.getValue(), locEnd)) {
              return [printed, hardline];
            }
            return printed;
          }, property4);
        }
        function canAttachComment(node) {
          return node.kind && node.kind !== "Comment";
        }
        function printComment(commentPath) {
          const comment = commentPath.getValue();
          if (comment.kind === "Comment") {
            return "#" + comment.value.trimEnd();
          }
          throw new Error("Not a comment: " + JSON.stringify(comment));
        }
        function printInterfaces(path5, options, print) {
          const node = path5.getNode();
          const parts = [];
          const {
            interfaces
          } = node;
          const printed = path5.map((node2) => print(node2), "interfaces");
          for (let index = 0; index < interfaces.length; index++) {
            const interfaceNode = interfaces[index];
            parts.push(printed[index]);
            const nextInterfaceNode = interfaces[index + 1];
            if (nextInterfaceNode) {
              const textBetween = options.originalText.slice(interfaceNode.loc.end, nextInterfaceNode.loc.start);
              const hasComment = textBetween.includes("#");
              const separator = textBetween.replace(/#.*/g, "").trim();
              parts.push(separator === "," ? "," : " &", hasComment ? line : " ");
            }
          }
          return parts;
        }
        function clean(node, newNode) {
          if (node.kind === "StringValue" && node.block && !node.value.includes("\n")) {
            newNode.value = newNode.value.trim();
          }
        }
        clean.ignoredProperties = /* @__PURE__ */ new Set(["loc", "comments"]);
        function hasPrettierIgnore(path5) {
          var _node$comments;
          const node = path5.getValue();
          return node === null || node === void 0 ? void 0 : (_node$comments = node.comments) === null || _node$comments === void 0 ? void 0 : _node$comments.some((comment) => comment.value.trim() === "prettier-ignore");
        }
        module22.exports = {
          print: genericPrint,
          massageAstNode: clean,
          hasPrettierIgnore,
          insertPragma,
          printComment,
          canAttachComment
        };
      }
    });
    var require_options4 = __commonJS22({
      "src/language-graphql/options.js"(exports22, module22) {
        "use strict";
        var commonOptions = require_common_options();
        module22.exports = {
          bracketSpacing: commonOptions.bracketSpacing
        };
      }
    });
    var require_parsers4 = __commonJS22({
      "src/language-graphql/parsers.js"(exports22, module22) {
        "use strict";
        module22.exports = {
          get graphql() {
            return require_parser_graphql().parsers.graphql;
          }
        };
      }
    });
    var require_GraphQL = __commonJS22({
      "node_modules/linguist-languages/data/GraphQL.json"(exports22, module22) {
        module22.exports = {
          name: "GraphQL",
          type: "data",
          color: "#e10098",
          extensions: [".graphql", ".gql", ".graphqls"],
          tmScope: "source.graphql",
          aceMode: "text",
          languageId: 139
        };
      }
    });
    var require_language_graphql = __commonJS22({
      "src/language-graphql/index.js"(exports22, module22) {
        "use strict";
        var createLanguage = require_create_language();
        var printer = require_printer_graphql();
        var options = require_options4();
        var parsers = require_parsers4();
        var languages = [createLanguage(require_GraphQL(), () => ({
          since: "1.5.0",
          parsers: ["graphql"],
          vscodeLanguageIds: ["graphql"]
        }))];
        var printers = {
          graphql: printer
        };
        module22.exports = {
          languages,
          options,
          printers,
          parsers
        };
      }
    });
    var require_loc5 = __commonJS22({
      "src/language-markdown/loc.js"(exports22, module22) {
        "use strict";
        function locStart(node) {
          return node.position.start.offset;
        }
        function locEnd(node) {
          return node.position.end.offset;
        }
        module22.exports = {
          locStart,
          locEnd
        };
      }
    });
    var require_constants_evaluate = __commonJS22({
      "src/language-markdown/constants.evaluate.js"(exports22, module22) {
        module22.exports = {
          cjkPattern: "(?:[\\u02ea-\\u02eb\\u1100-\\u11ff\\u2e80-\\u2e99\\u2e9b-\\u2ef3\\u2f00-\\u2fd5\\u2ff0-\\u303f\\u3041-\\u3096\\u3099-\\u309f\\u30a1-\\u30fa\\u30fc-\\u30ff\\u3105-\\u312f\\u3131-\\u318e\\u3190-\\u3191\\u3196-\\u31ba\\u31c0-\\u31e3\\u31f0-\\u321e\\u322a-\\u3247\\u3260-\\u327e\\u328a-\\u32b0\\u32c0-\\u32cb\\u32d0-\\u3370\\u337b-\\u337f\\u33e0-\\u33fe\\u3400-\\u4db5\\u4e00-\\u9fef\\ua960-\\ua97c\\uac00-\\ud7a3\\ud7b0-\\ud7c6\\ud7cb-\\ud7fb\\uf900-\\ufa6d\\ufa70-\\ufad9\\ufe10-\\ufe1f\\ufe30-\\ufe6f\\uff00-\\uffef]|[\\ud840-\\ud868\\ud86a-\\ud86c\\ud86f-\\ud872\\ud874-\\ud879][\\udc00-\\udfff]|\\ud82c[\\udc00-\\udd1e\\udd50-\\udd52\\udd64-\\udd67]|\\ud83c[\\ude00\\ude50-\\ude51]|\\ud869[\\udc00-\\uded6\\udf00-\\udfff]|\\ud86d[\\udc00-\\udf34\\udf40-\\udfff]|\\ud86e[\\udc00-\\udc1d\\udc20-\\udfff]|\\ud873[\\udc00-\\udea1\\udeb0-\\udfff]|\\ud87a[\\udc00-\\udfe0]|\\ud87e[\\udc00-\\ude1d])(?:[\\ufe00-\\ufe0f]|\\udb40[\\udd00-\\uddef])?",
          kPattern: "[\\u1100-\\u11ff\\u3001-\\u3003\\u3008-\\u3011\\u3013-\\u301f\\u302e-\\u3030\\u3037\\u30fb\\u3131-\\u318e\\u3200-\\u321e\\u3260-\\u327e\\ua960-\\ua97c\\uac00-\\ud7a3\\ud7b0-\\ud7c6\\ud7cb-\\ud7fb\\ufe45-\\ufe46\\uff61-\\uff65\\uffa0-\\uffbe\\uffc2-\\uffc7\\uffca-\\uffcf\\uffd2-\\uffd7\\uffda-\\uffdc]",
          punctuationPattern: "[\\u0021-\\u002f\\u003a-\\u0040\\u005b-\\u0060\\u007b-\\u007e\\u00a1\\u00a7\\u00ab\\u00b6-\\u00b7\\u00bb\\u00bf\\u037e\\u0387\\u055a-\\u055f\\u0589-\\u058a\\u05be\\u05c0\\u05c3\\u05c6\\u05f3-\\u05f4\\u0609-\\u060a\\u060c-\\u060d\\u061b\\u061e-\\u061f\\u066a-\\u066d\\u06d4\\u0700-\\u070d\\u07f7-\\u07f9\\u0830-\\u083e\\u085e\\u0964-\\u0965\\u0970\\u09fd\\u0a76\\u0af0\\u0c77\\u0c84\\u0df4\\u0e4f\\u0e5a-\\u0e5b\\u0f04-\\u0f12\\u0f14\\u0f3a-\\u0f3d\\u0f85\\u0fd0-\\u0fd4\\u0fd9-\\u0fda\\u104a-\\u104f\\u10fb\\u1360-\\u1368\\u1400\\u166e\\u169b-\\u169c\\u16eb-\\u16ed\\u1735-\\u1736\\u17d4-\\u17d6\\u17d8-\\u17da\\u1800-\\u180a\\u1944-\\u1945\\u1a1e-\\u1a1f\\u1aa0-\\u1aa6\\u1aa8-\\u1aad\\u1b5a-\\u1b60\\u1bfc-\\u1bff\\u1c3b-\\u1c3f\\u1c7e-\\u1c7f\\u1cc0-\\u1cc7\\u1cd3\\u2010-\\u2027\\u2030-\\u2043\\u2045-\\u2051\\u2053-\\u205e\\u207d-\\u207e\\u208d-\\u208e\\u2308-\\u230b\\u2329-\\u232a\\u2768-\\u2775\\u27c5-\\u27c6\\u27e6-\\u27ef\\u2983-\\u2998\\u29d8-\\u29db\\u29fc-\\u29fd\\u2cf9-\\u2cfc\\u2cfe-\\u2cff\\u2d70\\u2e00-\\u2e2e\\u2e30-\\u2e4f\\u3001-\\u3003\\u3008-\\u3011\\u3014-\\u301f\\u3030\\u303d\\u30a0\\u30fb\\ua4fe-\\ua4ff\\ua60d-\\ua60f\\ua673\\ua67e\\ua6f2-\\ua6f7\\ua874-\\ua877\\ua8ce-\\ua8cf\\ua8f8-\\ua8fa\\ua8fc\\ua92e-\\ua92f\\ua95f\\ua9c1-\\ua9cd\\ua9de-\\ua9df\\uaa5c-\\uaa5f\\uaade-\\uaadf\\uaaf0-\\uaaf1\\uabeb\\ufd3e-\\ufd3f\\ufe10-\\ufe19\\ufe30-\\ufe52\\ufe54-\\ufe61\\ufe63\\ufe68\\ufe6a-\\ufe6b\\uff01-\\uff03\\uff05-\\uff0a\\uff0c-\\uff0f\\uff1a-\\uff1b\\uff1f-\\uff20\\uff3b-\\uff3d\\uff3f\\uff5b\\uff5d\\uff5f-\\uff65]|\\ud800[\\udd00-\\udd02\\udf9f\\udfd0]|\\ud801[\\udd6f]|\\ud802[\\udc57\\udd1f\\udd3f\\ude50-\\ude58\\ude7f\\udef0-\\udef6\\udf39-\\udf3f\\udf99-\\udf9c]|\\ud803[\\udf55-\\udf59]|\\ud804[\\udc47-\\udc4d\\udcbb-\\udcbc\\udcbe-\\udcc1\\udd40-\\udd43\\udd74-\\udd75\\uddc5-\\uddc8\\uddcd\\udddb\\udddd-\\udddf\\ude38-\\ude3d\\udea9]|\\ud805[\\udc4b-\\udc4f\\udc5b\\udc5d\\udcc6\\uddc1-\\uddd7\\ude41-\\ude43\\ude60-\\ude6c\\udf3c-\\udf3e]|\\ud806[\\udc3b\\udde2\\ude3f-\\ude46\\ude9a-\\ude9c\\ude9e-\\udea2]|\\ud807[\\udc41-\\udc45\\udc70-\\udc71\\udef7-\\udef8\\udfff]|\\ud809[\\udc70-\\udc74]|\\ud81a[\\ude6e-\\ude6f\\udef5\\udf37-\\udf3b\\udf44]|\\ud81b[\\ude97-\\ude9a\\udfe2]|\\ud82f[\\udc9f]|\\ud836[\\ude87-\\ude8b]|\\ud83a[\\udd5e-\\udd5f]"
        };
      }
    });
    var require_utils10 = __commonJS22({
      "src/language-markdown/utils.js"(exports22, module22) {
        "use strict";
        var {
          getLast
        } = require_util2();
        var {
          locStart,
          locEnd
        } = require_loc5();
        var {
          cjkPattern,
          kPattern,
          punctuationPattern
        } = require_constants_evaluate();
        var INLINE_NODE_TYPES = ["liquidNode", "inlineCode", "emphasis", "esComment", "strong", "delete", "wikiLink", "link", "linkReference", "image", "imageReference", "footnote", "footnoteReference", "sentence", "whitespace", "word", "break", "inlineMath"];
        var INLINE_NODE_WRAPPER_TYPES = [...INLINE_NODE_TYPES, "tableCell", "paragraph", "heading"];
        var kRegex = new RegExp(kPattern);
        var punctuationRegex = new RegExp(punctuationPattern);
        function splitText(text, options) {
          const KIND_NON_CJK = "non-cjk";
          const KIND_CJ_LETTER = "cj-letter";
          const KIND_K_LETTER = "k-letter";
          const KIND_CJK_PUNCTUATION = "cjk-punctuation";
          const nodes = [];
          const tokens = (options.proseWrap === "preserve" ? text : text.replace(new RegExp(`(${cjkPattern})
(${cjkPattern})`, "g"), "$1$2")).split(/([\t\n ]+)/);
          for (const [index, token] of tokens.entries()) {
            if (index % 2 === 1) {
              nodes.push({
                type: "whitespace",
                value: /\n/.test(token) ? "\n" : " "
              });
              continue;
            }
            if ((index === 0 || index === tokens.length - 1) && token === "") {
              continue;
            }
            const innerTokens = token.split(new RegExp(`(${cjkPattern})`));
            for (const [innerIndex, innerToken] of innerTokens.entries()) {
              if ((innerIndex === 0 || innerIndex === innerTokens.length - 1) && innerToken === "") {
                continue;
              }
              if (innerIndex % 2 === 0) {
                if (innerToken !== "") {
                  appendNode({
                    type: "word",
                    value: innerToken,
                    kind: KIND_NON_CJK,
                    hasLeadingPunctuation: punctuationRegex.test(innerToken[0]),
                    hasTrailingPunctuation: punctuationRegex.test(getLast(innerToken))
                  });
                }
                continue;
              }
              appendNode(punctuationRegex.test(innerToken) ? {
                type: "word",
                value: innerToken,
                kind: KIND_CJK_PUNCTUATION,
                hasLeadingPunctuation: true,
                hasTrailingPunctuation: true
              } : {
                type: "word",
                value: innerToken,
                kind: kRegex.test(innerToken) ? KIND_K_LETTER : KIND_CJ_LETTER,
                hasLeadingPunctuation: false,
                hasTrailingPunctuation: false
              });
            }
          }
          return nodes;
          function appendNode(node) {
            const lastNode = getLast(nodes);
            if (lastNode && lastNode.type === "word") {
              if (lastNode.kind === KIND_NON_CJK && node.kind === KIND_CJ_LETTER && !lastNode.hasTrailingPunctuation || lastNode.kind === KIND_CJ_LETTER && node.kind === KIND_NON_CJK && !node.hasLeadingPunctuation) {
                nodes.push({
                  type: "whitespace",
                  value: " "
                });
              } else if (!isBetween(KIND_NON_CJK, KIND_CJK_PUNCTUATION) && ![lastNode.value, node.value].some((value) => /\u3000/.test(value))) {
                nodes.push({
                  type: "whitespace",
                  value: ""
                });
              }
            }
            nodes.push(node);
            function isBetween(kind1, kind2) {
              return lastNode.kind === kind1 && node.kind === kind2 || lastNode.kind === kind2 && node.kind === kind1;
            }
          }
        }
        function getOrderedListItemInfo(orderListItem, originalText) {
          const [, numberText, marker, leadingSpaces] = originalText.slice(orderListItem.position.start.offset, orderListItem.position.end.offset).match(/^\s*(\d+)(\.|\))(\s*)/);
          return {
            numberText,
            marker,
            leadingSpaces
          };
        }
        function hasGitDiffFriendlyOrderedList(node, options) {
          if (!node.ordered) {
            return false;
          }
          if (node.children.length < 2) {
            return false;
          }
          const firstNumber = Number(getOrderedListItemInfo(node.children[0], options.originalText).numberText);
          const secondNumber = Number(getOrderedListItemInfo(node.children[1], options.originalText).numberText);
          if (firstNumber === 0 && node.children.length > 2) {
            const thirdNumber = Number(getOrderedListItemInfo(node.children[2], options.originalText).numberText);
            return secondNumber === 1 && thirdNumber === 1;
          }
          return secondNumber === 1;
        }
        function getFencedCodeBlockValue(node, originalText) {
          const {
            value
          } = node;
          if (node.position.end.offset === originalText.length && value.endsWith("\n") && originalText.endsWith("\n")) {
            return value.slice(0, -1);
          }
          return value;
        }
        function mapAst(ast, handler) {
          return function preorder(node, index, parentStack) {
            const newNode = Object.assign({}, handler(node, index, parentStack));
            if (newNode.children) {
              newNode.children = newNode.children.map((child, index2) => preorder(child, index2, [newNode, ...parentStack]));
            }
            return newNode;
          }(ast, null, []);
        }
        function isAutolink(node) {
          if ((node === null || node === void 0 ? void 0 : node.type) !== "link" || node.children.length !== 1) {
            return false;
          }
          const [child] = node.children;
          return locStart(node) === locStart(child) && locEnd(node) === locEnd(child);
        }
        module22.exports = {
          mapAst,
          splitText,
          punctuationPattern,
          getFencedCodeBlockValue,
          getOrderedListItemInfo,
          hasGitDiffFriendlyOrderedList,
          INLINE_NODE_TYPES,
          INLINE_NODE_WRAPPER_TYPES,
          isAutolink
        };
      }
    });
    var require_embed3 = __commonJS22({
      "src/language-markdown/embed.js"(exports22, module22) {
        "use strict";
        var {
          inferParserByLanguage,
          getMaxContinuousCount
        } = require_util2();
        var {
          builders: {
            hardline,
            markAsRoot
          },
          utils: {
            replaceEndOfLine
          }
        } = require_doc();
        var printFrontMatter = require_print();
        var {
          getFencedCodeBlockValue
        } = require_utils10();
        function embed(path5, print, textToDoc, options) {
          const node = path5.getValue();
          if (node.type === "code" && node.lang !== null) {
            const parser = inferParserByLanguage(node.lang, options);
            if (parser) {
              const styleUnit = options.__inJsTemplate ? "~" : "`";
              const style = styleUnit.repeat(Math.max(3, getMaxContinuousCount(node.value, styleUnit) + 1));
              const newOptions = {
                parser
              };
              if (node.lang === "tsx") {
                newOptions.filepath = "dummy.tsx";
              }
              const doc2 = textToDoc(getFencedCodeBlockValue(node, options.originalText), newOptions, {
                stripTrailingHardline: true
              });
              return markAsRoot([style, node.lang, node.meta ? " " + node.meta : "", hardline, replaceEndOfLine(doc2), hardline, style]);
            }
          }
          switch (node.type) {
            case "front-matter":
              return printFrontMatter(node, textToDoc);
            case "importExport":
              return [textToDoc(node.value, {
                parser: "babel"
              }, {
                stripTrailingHardline: true
              }), hardline];
            case "jsx":
              return textToDoc(`<$>${node.value}</$>`, {
                parser: "__js_expression",
                rootMarker: "mdx"
              }, {
                stripTrailingHardline: true
              });
          }
          return null;
        }
        module22.exports = embed;
      }
    });
    var require_pragma4 = __commonJS22({
      "src/language-markdown/pragma.js"(exports22, module22) {
        "use strict";
        var parseFrontMatter = require_parse4();
        var pragmas = ["format", "prettier"];
        function startWithPragma(text) {
          const pragma = `@(${pragmas.join("|")})`;
          const regex = new RegExp([`<!--\\s*${pragma}\\s*-->`, `{\\s*\\/\\*\\s*${pragma}\\s*\\*\\/\\s*}`, `<!--.*\r?
[\\s\\S]*(^|
)[^\\S
]*${pragma}[^\\S
]*($|
)[\\s\\S]*
.*-->`].join("|"), "m");
          const matched = text.match(regex);
          return (matched === null || matched === void 0 ? void 0 : matched.index) === 0;
        }
        module22.exports = {
          startWithPragma,
          hasPragma: (text) => startWithPragma(parseFrontMatter(text).content.trimStart()),
          insertPragma: (text) => {
            const extracted = parseFrontMatter(text);
            const pragma = `<!-- @${pragmas[0]} -->`;
            return extracted.frontMatter ? `${extracted.frontMatter.raw}

${pragma}

${extracted.content}` : `${pragma}

${extracted.content}`;
          }
        };
      }
    });
    var require_print_preprocess2 = __commonJS22({
      "src/language-markdown/print-preprocess.js"(exports22, module22) {
        "use strict";
        var getLast = require_get_last();
        var {
          getOrderedListItemInfo,
          mapAst,
          splitText
        } = require_utils10();
        var isSingleCharRegex = /^.$/su;
        function preprocess(ast, options) {
          ast = restoreUnescapedCharacter(ast, options);
          ast = mergeContinuousTexts(ast);
          ast = transformInlineCode(ast);
          ast = transformIndentedCodeblockAndMarkItsParentList(ast, options);
          ast = markAlignedList(ast, options);
          ast = splitTextIntoSentences(ast, options);
          ast = transformImportExport(ast);
          ast = mergeContinuousImportExport(ast);
          return ast;
        }
        function transformImportExport(ast) {
          return mapAst(ast, (node) => {
            if (node.type !== "import" && node.type !== "export") {
              return node;
            }
            return Object.assign(Object.assign({}, node), {}, {
              type: "importExport"
            });
          });
        }
        function transformInlineCode(ast) {
          return mapAst(ast, (node) => {
            if (node.type !== "inlineCode") {
              return node;
            }
            return Object.assign(Object.assign({}, node), {}, {
              value: node.value.replace(/\s+/g, " ")
            });
          });
        }
        function restoreUnescapedCharacter(ast, options) {
          return mapAst(ast, (node) => node.type !== "text" || node.value === "*" || node.value === "_" || !isSingleCharRegex.test(node.value) || node.position.end.offset - node.position.start.offset === node.value.length ? node : Object.assign(Object.assign({}, node), {}, {
            value: options.originalText.slice(node.position.start.offset, node.position.end.offset)
          }));
        }
        function mergeContinuousImportExport(ast) {
          return mergeChildren(ast, (prevNode, node) => prevNode.type === "importExport" && node.type === "importExport", (prevNode, node) => ({
            type: "importExport",
            value: prevNode.value + "\n\n" + node.value,
            position: {
              start: prevNode.position.start,
              end: node.position.end
            }
          }));
        }
        function mergeChildren(ast, shouldMerge, mergeNode) {
          return mapAst(ast, (node) => {
            if (!node.children) {
              return node;
            }
            const children = node.children.reduce((current, child) => {
              const lastChild = getLast(current);
              if (lastChild && shouldMerge(lastChild, child)) {
                current.splice(-1, 1, mergeNode(lastChild, child));
              } else {
                current.push(child);
              }
              return current;
            }, []);
            return Object.assign(Object.assign({}, node), {}, {
              children
            });
          });
        }
        function mergeContinuousTexts(ast) {
          return mergeChildren(ast, (prevNode, node) => prevNode.type === "text" && node.type === "text", (prevNode, node) => ({
            type: "text",
            value: prevNode.value + node.value,
            position: {
              start: prevNode.position.start,
              end: node.position.end
            }
          }));
        }
        function splitTextIntoSentences(ast, options) {
          return mapAst(ast, (node, index, [parentNode]) => {
            if (node.type !== "text") {
              return node;
            }
            let {
              value
            } = node;
            if (parentNode.type === "paragraph") {
              if (index === 0) {
                value = value.trimStart();
              }
              if (index === parentNode.children.length - 1) {
                value = value.trimEnd();
              }
            }
            return {
              type: "sentence",
              position: node.position,
              children: splitText(value, options)
            };
          });
        }
        function transformIndentedCodeblockAndMarkItsParentList(ast, options) {
          return mapAst(ast, (node, index, parentStack) => {
            if (node.type === "code") {
              const isIndented = /^\n?(?: {4,}|\t)/.test(options.originalText.slice(node.position.start.offset, node.position.end.offset));
              node.isIndented = isIndented;
              if (isIndented) {
                for (let i = 0; i < parentStack.length; i++) {
                  const parent = parentStack[i];
                  if (parent.hasIndentedCodeblock) {
                    break;
                  }
                  if (parent.type === "list") {
                    parent.hasIndentedCodeblock = true;
                  }
                }
              }
            }
            return node;
          });
        }
        function markAlignedList(ast, options) {
          return mapAst(ast, (node, index, parentStack) => {
            if (node.type === "list" && node.children.length > 0) {
              for (let i = 0; i < parentStack.length; i++) {
                const parent = parentStack[i];
                if (parent.type === "list" && !parent.isAligned) {
                  node.isAligned = false;
                  return node;
                }
              }
              node.isAligned = isAligned(node);
            }
            return node;
          });
          function getListItemStart(listItem) {
            return listItem.children.length === 0 ? -1 : listItem.children[0].position.start.column - 1;
          }
          function isAligned(list3) {
            if (!list3.ordered) {
              return true;
            }
            const [firstItem, secondItem] = list3.children;
            const firstInfo = getOrderedListItemInfo(firstItem, options.originalText);
            if (firstInfo.leadingSpaces.length > 1) {
              return true;
            }
            const firstStart = getListItemStart(firstItem);
            if (firstStart === -1) {
              return false;
            }
            if (list3.children.length === 1) {
              return firstStart % options.tabWidth === 0;
            }
            const secondStart = getListItemStart(secondItem);
            if (firstStart !== secondStart) {
              return false;
            }
            if (firstStart % options.tabWidth === 0) {
              return true;
            }
            const secondInfo = getOrderedListItemInfo(secondItem, options.originalText);
            return secondInfo.leadingSpaces.length > 1;
          }
        }
        module22.exports = preprocess;
      }
    });
    var require_clean4 = __commonJS22({
      "src/language-markdown/clean.js"(exports22, module22) {
        "use strict";
        var {
          isFrontMatterNode
        } = require_util2();
        var {
          startWithPragma
        } = require_pragma4();
        var ignoredProperties = /* @__PURE__ */ new Set(["position", "raw"]);
        function clean(ast, newObj, parent) {
          if (ast.type === "front-matter" || ast.type === "code" || ast.type === "yaml" || ast.type === "import" || ast.type === "export" || ast.type === "jsx") {
            delete newObj.value;
          }
          if (ast.type === "list") {
            delete newObj.isAligned;
          }
          if (ast.type === "list" || ast.type === "listItem") {
            delete newObj.spread;
            delete newObj.loose;
          }
          if (ast.type === "text") {
            return null;
          }
          if (ast.type === "inlineCode") {
            newObj.value = ast.value.replace(/[\t\n ]+/g, " ");
          }
          if (ast.type === "wikiLink") {
            newObj.value = ast.value.trim().replace(/[\t\n]+/g, " ");
          }
          if (ast.type === "definition" || ast.type === "linkReference") {
            newObj.label = ast.label.trim().replace(/[\t\n ]+/g, " ").toLowerCase();
          }
          if ((ast.type === "definition" || ast.type === "link" || ast.type === "image") && ast.title) {
            newObj.title = ast.title.replace(/\\(["')])/g, "$1");
          }
          if (parent && parent.type === "root" && parent.children.length > 0 && (parent.children[0] === ast || isFrontMatterNode(parent.children[0]) && parent.children[1] === ast) && ast.type === "html" && startWithPragma(ast.value)) {
            return null;
          }
        }
        clean.ignoredProperties = ignoredProperties;
        module22.exports = clean;
      }
    });
    var require_printer_markdown = __commonJS22({
      "src/language-markdown/printer-markdown.js"(exports22, module22) {
        "use strict";
        var {
          getLast,
          getMinNotPresentContinuousCount,
          getMaxContinuousCount,
          getStringWidth,
          isNonEmptyArray
        } = require_util2();
        var {
          builders: {
            breakParent,
            join: join2,
            line,
            literalline,
            markAsRoot,
            hardline,
            softline,
            ifBreak,
            fill,
            align,
            indent,
            group,
            hardlineWithoutBreakParent
          },
          utils: {
            normalizeDoc,
            replaceTextEndOfLine
          },
          printer: {
            printDocToString
          }
        } = require_doc();
        var embed = require_embed3();
        var {
          insertPragma
        } = require_pragma4();
        var {
          locStart,
          locEnd
        } = require_loc5();
        var preprocess = require_print_preprocess2();
        var clean = require_clean4();
        var {
          getFencedCodeBlockValue,
          hasGitDiffFriendlyOrderedList,
          splitText,
          punctuationPattern,
          INLINE_NODE_TYPES,
          INLINE_NODE_WRAPPER_TYPES,
          isAutolink
        } = require_utils10();
        var TRAILING_HARDLINE_NODES = /* @__PURE__ */ new Set(["importExport"]);
        var SINGLE_LINE_NODE_TYPES = ["heading", "tableCell", "link", "wikiLink"];
        var SIBLING_NODE_TYPES = /* @__PURE__ */ new Set(["listItem", "definition", "footnoteDefinition"]);
        function genericPrint(path5, options, print) {
          const node = path5.getValue();
          if (shouldRemainTheSameContent(path5)) {
            return splitText(options.originalText.slice(node.position.start.offset, node.position.end.offset), options).map((node2) => node2.type === "word" ? node2.value : node2.value === "" ? "" : printLine(path5, node2.value, options));
          }
          switch (node.type) {
            case "front-matter":
              return options.originalText.slice(node.position.start.offset, node.position.end.offset);
            case "root":
              if (node.children.length === 0) {
                return "";
              }
              return [normalizeDoc(printRoot(path5, options, print)), !TRAILING_HARDLINE_NODES.has(getLastDescendantNode(node).type) ? hardline : ""];
            case "paragraph":
              return printChildren(path5, options, print, {
                postprocessor: fill
              });
            case "sentence":
              return printChildren(path5, options, print);
            case "word": {
              let escapedValue = node.value.replace(/\*/g, "\\$&").replace(new RegExp([`(^|${punctuationPattern})(_+)`, `(_+)(${punctuationPattern}|$)`].join("|"), "g"), (_, text1, underscore1, underscore2, text2) => (underscore1 ? `${text1}${underscore1}` : `${underscore2}${text2}`).replace(/_/g, "\\_"));
              const isFirstSentence = (node2, name, index) => node2.type === "sentence" && index === 0;
              const isLastChildAutolink = (node2, name, index) => isAutolink(node2.children[index - 1]);
              if (escapedValue !== node.value && (path5.match(void 0, isFirstSentence, isLastChildAutolink) || path5.match(void 0, isFirstSentence, (node2, name, index) => node2.type === "emphasis" && index === 0, isLastChildAutolink))) {
                escapedValue = escapedValue.replace(/^(\\?[*_])+/, (prefix) => prefix.replace(/\\/g, ""));
              }
              return escapedValue;
            }
            case "whitespace": {
              const parentNode = path5.getParentNode();
              const index = parentNode.children.indexOf(node);
              const nextNode = parentNode.children[index + 1];
              const proseWrap = nextNode && /^>|^(?:[*+-]|#{1,6}|\d+[).])$/.test(nextNode.value) ? "never" : options.proseWrap;
              return printLine(path5, node.value, {
                proseWrap
              });
            }
            case "emphasis": {
              let style;
              if (isAutolink(node.children[0])) {
                style = options.originalText[node.position.start.offset];
              } else {
                const parentNode = path5.getParentNode();
                const index = parentNode.children.indexOf(node);
                const prevNode = parentNode.children[index - 1];
                const nextNode = parentNode.children[index + 1];
                const hasPrevOrNextWord = prevNode && prevNode.type === "sentence" && prevNode.children.length > 0 && getLast(prevNode.children).type === "word" && !getLast(prevNode.children).hasTrailingPunctuation || nextNode && nextNode.type === "sentence" && nextNode.children.length > 0 && nextNode.children[0].type === "word" && !nextNode.children[0].hasLeadingPunctuation;
                style = hasPrevOrNextWord || getAncestorNode(path5, "emphasis") ? "*" : "_";
              }
              return [style, printChildren(path5, options, print), style];
            }
            case "strong":
              return ["**", printChildren(path5, options, print), "**"];
            case "delete":
              return ["~~", printChildren(path5, options, print), "~~"];
            case "inlineCode": {
              const backtickCount = getMinNotPresentContinuousCount(node.value, "`");
              const style = "`".repeat(backtickCount || 1);
              const gap = backtickCount && !/^\s/.test(node.value) ? " " : "";
              return [style, gap, node.value, gap, style];
            }
            case "wikiLink": {
              let contents = "";
              if (options.proseWrap === "preserve") {
                contents = node.value;
              } else {
                contents = node.value.replace(/[\t\n]+/g, " ");
              }
              return ["[[", contents, "]]"];
            }
            case "link":
              switch (options.originalText[node.position.start.offset]) {
                case "<": {
                  const mailto = "mailto:";
                  const url = node.url.startsWith(mailto) && options.originalText.slice(node.position.start.offset + 1, node.position.start.offset + 1 + mailto.length) !== mailto ? node.url.slice(mailto.length) : node.url;
                  return ["<", url, ">"];
                }
                case "[":
                  return ["[", printChildren(path5, options, print), "](", printUrl(node.url, ")"), printTitle(node.title, options), ")"];
                default:
                  return options.originalText.slice(node.position.start.offset, node.position.end.offset);
              }
            case "image":
              return ["![", node.alt || "", "](", printUrl(node.url, ")"), printTitle(node.title, options), ")"];
            case "blockquote":
              return ["> ", align("> ", printChildren(path5, options, print))];
            case "heading":
              return ["#".repeat(node.depth) + " ", printChildren(path5, options, print)];
            case "code": {
              if (node.isIndented) {
                const alignment = " ".repeat(4);
                return align(alignment, [alignment, ...replaceTextEndOfLine(node.value, hardline)]);
              }
              const styleUnit = options.__inJsTemplate ? "~" : "`";
              const style = styleUnit.repeat(Math.max(3, getMaxContinuousCount(node.value, styleUnit) + 1));
              return [style, node.lang || "", node.meta ? " " + node.meta : "", hardline, ...replaceTextEndOfLine(getFencedCodeBlockValue(node, options.originalText), hardline), hardline, style];
            }
            case "html": {
              const parentNode = path5.getParentNode();
              const value = parentNode.type === "root" && getLast(parentNode.children) === node ? node.value.trimEnd() : node.value;
              const isHtmlComment = /^<!--.*-->$/s.test(value);
              return replaceTextEndOfLine(value, isHtmlComment ? hardline : markAsRoot(literalline));
            }
            case "list": {
              const nthSiblingIndex = getNthListSiblingIndex(node, path5.getParentNode());
              const isGitDiffFriendlyOrderedList = hasGitDiffFriendlyOrderedList(node, options);
              return printChildren(path5, options, print, {
                processor: (childPath, index) => {
                  const prefix = getPrefix();
                  const childNode = childPath.getValue();
                  if (childNode.children.length === 2 && childNode.children[1].type === "html" && childNode.children[0].position.start.column !== childNode.children[1].position.start.column) {
                    return [prefix, printListItem(childPath, options, print, prefix)];
                  }
                  return [prefix, align(" ".repeat(prefix.length), printListItem(childPath, options, print, prefix))];
                  function getPrefix() {
                    const rawPrefix = node.ordered ? (index === 0 ? node.start : isGitDiffFriendlyOrderedList ? 1 : node.start + index) + (nthSiblingIndex % 2 === 0 ? ". " : ") ") : nthSiblingIndex % 2 === 0 ? "- " : "* ";
                    return node.isAligned || node.hasIndentedCodeblock ? alignListPrefix(rawPrefix, options) : rawPrefix;
                  }
                }
              });
            }
            case "thematicBreak": {
              const counter = getAncestorCounter(path5, "list");
              if (counter === -1) {
                return "---";
              }
              const nthSiblingIndex = getNthListSiblingIndex(path5.getParentNode(counter), path5.getParentNode(counter + 1));
              return nthSiblingIndex % 2 === 0 ? "***" : "---";
            }
            case "linkReference":
              return ["[", printChildren(path5, options, print), "]", node.referenceType === "full" ? ["[", node.identifier, "]"] : node.referenceType === "collapsed" ? "[]" : ""];
            case "imageReference":
              switch (node.referenceType) {
                case "full":
                  return ["![", node.alt || "", "][", node.identifier, "]"];
                default:
                  return ["![", node.alt, "]", node.referenceType === "collapsed" ? "[]" : ""];
              }
            case "definition": {
              const lineOrSpace = options.proseWrap === "always" ? line : " ";
              return group(["[", node.identifier, "]:", indent([lineOrSpace, printUrl(node.url), node.title === null ? "" : [lineOrSpace, printTitle(node.title, options, false)]])]);
            }
            case "footnote":
              return ["[^", printChildren(path5, options, print), "]"];
            case "footnoteReference":
              return ["[^", node.identifier, "]"];
            case "footnoteDefinition": {
              const nextNode = path5.getParentNode().children[path5.getName() + 1];
              const shouldInlineFootnote = node.children.length === 1 && node.children[0].type === "paragraph" && (options.proseWrap === "never" || options.proseWrap === "preserve" && node.children[0].position.start.line === node.children[0].position.end.line);
              return ["[^", node.identifier, "]: ", shouldInlineFootnote ? printChildren(path5, options, print) : group([align(" ".repeat(4), printChildren(path5, options, print, {
                processor: (childPath, index) => index === 0 ? group([softline, print()]) : print()
              })), nextNode && nextNode.type === "footnoteDefinition" ? softline : ""])];
            }
            case "table":
              return printTable(path5, options, print);
            case "tableCell":
              return printChildren(path5, options, print);
            case "break":
              return /\s/.test(options.originalText[node.position.start.offset]) ? ["  ", markAsRoot(literalline)] : ["\\", hardline];
            case "liquidNode":
              return replaceTextEndOfLine(node.value, hardline);
            case "importExport":
              return [node.value, hardline];
            case "esComment":
              return ["{/* ", node.value, " */}"];
            case "jsx":
              return node.value;
            case "math":
              return ["$$", hardline, node.value ? [...replaceTextEndOfLine(node.value, hardline), hardline] : "", "$$"];
            case "inlineMath": {
              return options.originalText.slice(locStart(node), locEnd(node));
            }
            case "tableRow":
            case "listItem":
            default:
              throw new Error(`Unknown markdown type ${JSON.stringify(node.type)}`);
          }
        }
        function printListItem(path5, options, print, listPrefix) {
          const node = path5.getValue();
          const prefix = node.checked === null ? "" : node.checked ? "[x] " : "[ ] ";
          return [prefix, printChildren(path5, options, print, {
            processor: (childPath, index) => {
              if (index === 0 && childPath.getValue().type !== "list") {
                return align(" ".repeat(prefix.length), print());
              }
              const alignment = " ".repeat(clamp(options.tabWidth - listPrefix.length, 0, 3));
              return [alignment, align(alignment, print())];
            }
          })];
        }
        function alignListPrefix(prefix, options) {
          const additionalSpaces = getAdditionalSpaces();
          return prefix + " ".repeat(additionalSpaces >= 4 ? 0 : additionalSpaces);
          function getAdditionalSpaces() {
            const restSpaces = prefix.length % options.tabWidth;
            return restSpaces === 0 ? 0 : options.tabWidth - restSpaces;
          }
        }
        function getNthListSiblingIndex(node, parentNode) {
          return getNthSiblingIndex(node, parentNode, (siblingNode) => siblingNode.ordered === node.ordered);
        }
        function getNthSiblingIndex(node, parentNode, condition) {
          let index = -1;
          for (const childNode of parentNode.children) {
            if (childNode.type === node.type && condition(childNode)) {
              index++;
            } else {
              index = -1;
            }
            if (childNode === node) {
              return index;
            }
          }
        }
        function getAncestorCounter(path5, typeOrTypes) {
          const types2 = Array.isArray(typeOrTypes) ? typeOrTypes : [typeOrTypes];
          let counter = -1;
          let ancestorNode;
          while (ancestorNode = path5.getParentNode(++counter)) {
            if (types2.includes(ancestorNode.type)) {
              return counter;
            }
          }
          return -1;
        }
        function getAncestorNode(path5, typeOrTypes) {
          const counter = getAncestorCounter(path5, typeOrTypes);
          return counter === -1 ? null : path5.getParentNode(counter);
        }
        function printLine(path5, value, options) {
          if (options.proseWrap === "preserve" && value === "\n") {
            return hardline;
          }
          const isBreakable = options.proseWrap === "always" && !getAncestorNode(path5, SINGLE_LINE_NODE_TYPES);
          return value !== "" ? isBreakable ? line : " " : isBreakable ? softline : "";
        }
        function printTable(path5, options, print) {
          const node = path5.getValue();
          const columnMaxWidths = [];
          const contents = path5.map((rowPath) => rowPath.map((cellPath, columnIndex) => {
            const text = printDocToString(print(), options).formatted;
            const width = getStringWidth(text);
            columnMaxWidths[columnIndex] = Math.max(columnMaxWidths[columnIndex] || 3, width);
            return {
              text,
              width
            };
          }, "children"), "children");
          const alignedTable = printTableContents(false);
          if (options.proseWrap !== "never") {
            return [breakParent, alignedTable];
          }
          const compactTable = printTableContents(true);
          return [breakParent, group(ifBreak(compactTable, alignedTable))];
          function printTableContents(isCompact) {
            const parts = [printRow(contents[0], isCompact), printAlign(isCompact)];
            if (contents.length > 1) {
              parts.push(join2(hardlineWithoutBreakParent, contents.slice(1).map((rowContents) => printRow(rowContents, isCompact))));
            }
            return join2(hardlineWithoutBreakParent, parts);
          }
          function printAlign(isCompact) {
            const align2 = columnMaxWidths.map((width, index) => {
              const align3 = node.align[index];
              const first = align3 === "center" || align3 === "left" ? ":" : "-";
              const last = align3 === "center" || align3 === "right" ? ":" : "-";
              const middle = isCompact ? "-" : "-".repeat(width - 2);
              return `${first}${middle}${last}`;
            });
            return `| ${align2.join(" | ")} |`;
          }
          function printRow(rowContents, isCompact) {
            const columns = rowContents.map(({
              text,
              width
            }, columnIndex) => {
              if (isCompact) {
                return text;
              }
              const spaces = columnMaxWidths[columnIndex] - width;
              const align2 = node.align[columnIndex];
              let before = 0;
              if (align2 === "right") {
                before = spaces;
              } else if (align2 === "center") {
                before = Math.floor(spaces / 2);
              }
              const after = spaces - before;
              return `${" ".repeat(before)}${text}${" ".repeat(after)}`;
            });
            return `| ${columns.join(" | ")} |`;
          }
        }
        function printRoot(path5, options, print) {
          const ignoreRanges = [];
          let ignoreStart = null;
          const {
            children
          } = path5.getValue();
          for (const [index, childNode] of children.entries()) {
            switch (isPrettierIgnore(childNode)) {
              case "start":
                if (ignoreStart === null) {
                  ignoreStart = {
                    index,
                    offset: childNode.position.end.offset
                  };
                }
                break;
              case "end":
                if (ignoreStart !== null) {
                  ignoreRanges.push({
                    start: ignoreStart,
                    end: {
                      index,
                      offset: childNode.position.start.offset
                    }
                  });
                  ignoreStart = null;
                }
                break;
              default:
                break;
            }
          }
          return printChildren(path5, options, print, {
            processor: (childPath, index) => {
              if (ignoreRanges.length > 0) {
                const ignoreRange = ignoreRanges[0];
                if (index === ignoreRange.start.index) {
                  return [children[ignoreRange.start.index].value, options.originalText.slice(ignoreRange.start.offset, ignoreRange.end.offset), children[ignoreRange.end.index].value];
                }
                if (ignoreRange.start.index < index && index < ignoreRange.end.index) {
                  return false;
                }
                if (index === ignoreRange.end.index) {
                  ignoreRanges.shift();
                  return false;
                }
              }
              return print();
            }
          });
        }
        function printChildren(path5, options, print, events = {}) {
          const {
            postprocessor
          } = events;
          const processor = events.processor || (() => print());
          const node = path5.getValue();
          const parts = [];
          let lastChildNode;
          path5.each((childPath, index) => {
            const childNode = childPath.getValue();
            const result = processor(childPath, index);
            if (result !== false) {
              const data = {
                parts,
                prevNode: lastChildNode,
                parentNode: node,
                options
              };
              if (shouldPrePrintHardline(childNode, data)) {
                parts.push(hardline);
                if (lastChildNode && TRAILING_HARDLINE_NODES.has(lastChildNode.type)) {
                  if (shouldPrePrintTripleHardline(childNode, data)) {
                    parts.push(hardline);
                  }
                } else {
                  if (shouldPrePrintDoubleHardline(childNode, data) || shouldPrePrintTripleHardline(childNode, data)) {
                    parts.push(hardline);
                  }
                  if (shouldPrePrintTripleHardline(childNode, data)) {
                    parts.push(hardline);
                  }
                }
              }
              parts.push(result);
              lastChildNode = childNode;
            }
          }, "children");
          return postprocessor ? postprocessor(parts) : parts;
        }
        function getLastDescendantNode(node) {
          let current = node;
          while (isNonEmptyArray(current.children)) {
            current = getLast(current.children);
          }
          return current;
        }
        function isPrettierIgnore(node) {
          let match;
          if (node.type === "html") {
            match = node.value.match(/^<!--\s*prettier-ignore(?:-(start|end))?\s*-->$/);
          } else {
            let comment;
            if (node.type === "esComment") {
              comment = node;
            } else if (node.type === "paragraph" && node.children.length === 1 && node.children[0].type === "esComment") {
              comment = node.children[0];
            }
            if (comment) {
              match = comment.value.match(/^prettier-ignore(?:-(start|end))?$/);
            }
          }
          return match ? match[1] || "next" : false;
        }
        function shouldPrePrintHardline(node, data) {
          const isFirstNode = data.parts.length === 0;
          const isInlineNode = INLINE_NODE_TYPES.includes(node.type);
          const isInlineHTML = node.type === "html" && INLINE_NODE_WRAPPER_TYPES.includes(data.parentNode.type);
          return !isFirstNode && !isInlineNode && !isInlineHTML;
        }
        function shouldPrePrintDoubleHardline(node, data) {
          var _data$prevNode, _data$prevNode2, _data$prevNode3;
          const isSequence = (data.prevNode && data.prevNode.type) === node.type;
          const isSiblingNode = isSequence && SIBLING_NODE_TYPES.has(node.type);
          const isInTightListItem = data.parentNode.type === "listItem" && !data.parentNode.loose;
          const isPrevNodeLooseListItem = ((_data$prevNode = data.prevNode) === null || _data$prevNode === void 0 ? void 0 : _data$prevNode.type) === "listItem" && data.prevNode.loose;
          const isPrevNodePrettierIgnore = isPrettierIgnore(data.prevNode) === "next";
          const isBlockHtmlWithoutBlankLineBetweenPrevHtml = node.type === "html" && ((_data$prevNode2 = data.prevNode) === null || _data$prevNode2 === void 0 ? void 0 : _data$prevNode2.type) === "html" && data.prevNode.position.end.line + 1 === node.position.start.line;
          const isHtmlDirectAfterListItem = node.type === "html" && data.parentNode.type === "listItem" && ((_data$prevNode3 = data.prevNode) === null || _data$prevNode3 === void 0 ? void 0 : _data$prevNode3.type) === "paragraph" && data.prevNode.position.end.line + 1 === node.position.start.line;
          return isPrevNodeLooseListItem || !(isSiblingNode || isInTightListItem || isPrevNodePrettierIgnore || isBlockHtmlWithoutBlankLineBetweenPrevHtml || isHtmlDirectAfterListItem);
        }
        function shouldPrePrintTripleHardline(node, data) {
          const isPrevNodeList = data.prevNode && data.prevNode.type === "list";
          const isIndentedCode = node.type === "code" && node.isIndented;
          return isPrevNodeList && isIndentedCode;
        }
        function shouldRemainTheSameContent(path5) {
          const ancestorNode = getAncestorNode(path5, ["linkReference", "imageReference"]);
          return ancestorNode && (ancestorNode.type !== "linkReference" || ancestorNode.referenceType !== "full");
        }
        function printUrl(url, dangerousCharOrChars = []) {
          const dangerousChars = [" ", ...Array.isArray(dangerousCharOrChars) ? dangerousCharOrChars : [dangerousCharOrChars]];
          return new RegExp(dangerousChars.map((x) => `\\${x}`).join("|")).test(url) ? `<${url}>` : url;
        }
        function printTitle(title, options, printSpace = true) {
          if (!title) {
            return "";
          }
          if (printSpace) {
            return " " + printTitle(title, options, false);
          }
          title = title.replace(/\\(["')])/g, "$1");
          if (title.includes('"') && title.includes("'") && !title.includes(")")) {
            return `(${title})`;
          }
          const singleCount = title.split("'").length - 1;
          const doubleCount = title.split('"').length - 1;
          const quote = singleCount > doubleCount ? '"' : doubleCount > singleCount ? "'" : options.singleQuote ? "'" : '"';
          title = title.replace(/\\/, "\\\\");
          title = title.replace(new RegExp(`(${quote})`, "g"), "\\$1");
          return `${quote}${title}${quote}`;
        }
        function clamp(value, min, max) {
          return value < min ? min : value > max ? max : value;
        }
        function hasPrettierIgnore(path5) {
          const index = Number(path5.getName());
          if (index === 0) {
            return false;
          }
          const prevNode = path5.getParentNode().children[index - 1];
          return isPrettierIgnore(prevNode) === "next";
        }
        module22.exports = {
          preprocess,
          print: genericPrint,
          embed,
          massageAstNode: clean,
          hasPrettierIgnore,
          insertPragma
        };
      }
    });
    var require_options5 = __commonJS22({
      "src/language-markdown/options.js"(exports22, module22) {
        "use strict";
        var commonOptions = require_common_options();
        module22.exports = {
          proseWrap: commonOptions.proseWrap,
          singleQuote: commonOptions.singleQuote
        };
      }
    });
    var require_parsers5 = __commonJS22({
      "src/language-markdown/parsers.js"(exports22, module22) {
        "use strict";
        module22.exports = {
          get remark() {
            return require_parser_markdown().parsers.remark;
          },
          get markdown() {
            return require_parser_markdown().parsers.remark;
          },
          get mdx() {
            return require_parser_markdown().parsers.mdx;
          }
        };
      }
    });
    var require_Markdown = __commonJS22({
      "node_modules/linguist-languages/data/Markdown.json"(exports22, module22) {
        module22.exports = {
          name: "Markdown",
          type: "prose",
          color: "#083fa1",
          aliases: ["pandoc"],
          aceMode: "markdown",
          codemirrorMode: "gfm",
          codemirrorMimeType: "text/x-gfm",
          wrap: true,
          extensions: [".md", ".livemd", ".markdown", ".mdown", ".mdwn", ".mdx", ".mkd", ".mkdn", ".mkdown", ".ronn", ".scd", ".workbook"],
          filenames: ["contents.lr"],
          tmScope: "source.gfm",
          languageId: 222
        };
      }
    });
    var require_language_markdown = __commonJS22({
      "src/language-markdown/index.js"(exports22, module22) {
        "use strict";
        var createLanguage = require_create_language();
        var printer = require_printer_markdown();
        var options = require_options5();
        var parsers = require_parsers5();
        var languages = [createLanguage(require_Markdown(), (data) => ({
          since: "1.8.0",
          parsers: ["markdown"],
          vscodeLanguageIds: ["markdown"],
          filenames: [...data.filenames, "README"],
          extensions: data.extensions.filter((extension) => extension !== ".mdx")
        })), createLanguage(require_Markdown(), () => ({
          name: "MDX",
          since: "1.15.0",
          parsers: ["mdx"],
          vscodeLanguageIds: ["mdx"],
          filenames: [],
          extensions: [".mdx"]
        }))];
        var printers = {
          mdast: printer
        };
        module22.exports = {
          languages,
          options,
          printers,
          parsers
        };
      }
    });
    var require_clean5 = __commonJS22({
      "src/language-html/clean.js"(exports22, module22) {
        "use strict";
        var {
          isFrontMatterNode
        } = require_util2();
        var ignoredProperties = /* @__PURE__ */ new Set(["sourceSpan", "startSourceSpan", "endSourceSpan", "nameSpan", "valueSpan"]);
        function clean(ast, newNode) {
          if (ast.type === "text" || ast.type === "comment") {
            return null;
          }
          if (isFrontMatterNode(ast) || ast.type === "yaml" || ast.type === "toml") {
            return null;
          }
          if (ast.type === "attribute") {
            delete newNode.value;
          }
          if (ast.type === "docType") {
            delete newNode.value;
          }
        }
        clean.ignoredProperties = ignoredProperties;
        module22.exports = clean;
      }
    });
    var require_constants_evaluate2 = __commonJS22({
      "src/language-html/constants.evaluate.js"(exports22, module22) {
        module22.exports = {
          CSS_DISPLAY_TAGS: {
            area: "none",
            base: "none",
            basefont: "none",
            datalist: "none",
            head: "none",
            link: "none",
            meta: "none",
            noembed: "none",
            noframes: "none",
            param: "block",
            rp: "none",
            script: "block",
            source: "block",
            style: "none",
            template: "inline",
            track: "block",
            title: "none",
            html: "block",
            body: "block",
            address: "block",
            blockquote: "block",
            center: "block",
            div: "block",
            figure: "block",
            figcaption: "block",
            footer: "block",
            form: "block",
            header: "block",
            hr: "block",
            legend: "block",
            listing: "block",
            main: "block",
            p: "block",
            plaintext: "block",
            pre: "block",
            xmp: "block",
            slot: "contents",
            ruby: "ruby",
            rt: "ruby-text",
            article: "block",
            aside: "block",
            h1: "block",
            h2: "block",
            h3: "block",
            h4: "block",
            h5: "block",
            h6: "block",
            hgroup: "block",
            nav: "block",
            section: "block",
            dir: "block",
            dd: "block",
            dl: "block",
            dt: "block",
            ol: "block",
            ul: "block",
            li: "list-item",
            table: "table",
            caption: "table-caption",
            colgroup: "table-column-group",
            col: "table-column",
            thead: "table-header-group",
            tbody: "table-row-group",
            tfoot: "table-footer-group",
            tr: "table-row",
            td: "table-cell",
            th: "table-cell",
            fieldset: "block",
            button: "inline-block",
            details: "block",
            summary: "block",
            dialog: "block",
            meter: "inline-block",
            progress: "inline-block",
            object: "inline-block",
            video: "inline-block",
            audio: "inline-block",
            select: "inline-block",
            option: "block",
            optgroup: "block"
          },
          CSS_DISPLAY_DEFAULT: "inline",
          CSS_WHITE_SPACE_TAGS: {
            listing: "pre",
            plaintext: "pre",
            pre: "pre",
            xmp: "pre",
            nobr: "nowrap",
            table: "initial",
            textarea: "pre-wrap"
          },
          CSS_WHITE_SPACE_DEFAULT: "normal"
        };
      }
    });
    var require_is_unknown_namespace = __commonJS22({
      "src/language-html/utils/is-unknown-namespace.js"(exports22, module22) {
        "use strict";
        function isUnknownNamespace(node) {
          return node.type === "element" && !node.hasExplicitNamespace && !["html", "svg"].includes(node.namespace);
        }
        module22.exports = isUnknownNamespace;
      }
    });
    var require_utils11 = __commonJS22({
      "src/language-html/utils/index.js"(exports22, module22) {
        "use strict";
        var {
          inferParserByLanguage,
          isFrontMatterNode
        } = require_util2();
        var {
          builders: {
            line,
            hardline,
            join: join2
          },
          utils: {
            getDocParts,
            replaceTextEndOfLine
          }
        } = require_doc();
        var {
          CSS_DISPLAY_TAGS,
          CSS_DISPLAY_DEFAULT,
          CSS_WHITE_SPACE_TAGS,
          CSS_WHITE_SPACE_DEFAULT
        } = require_constants_evaluate2();
        var isUnknownNamespace = require_is_unknown_namespace();
        var HTML_WHITESPACE = /* @__PURE__ */ new Set(["	", "\n", "\f", "\r", " "]);
        var htmlTrimStart = (string3) => string3.replace(/^[\t\n\f\r ]+/, "");
        var htmlTrimEnd = (string3) => string3.replace(/[\t\n\f\r ]+$/, "");
        var htmlTrim = (string3) => htmlTrimStart(htmlTrimEnd(string3));
        var htmlTrimLeadingBlankLines = (string3) => string3.replace(/^[\t\f\r ]*\n/g, "");
        var htmlTrimPreserveIndentation = (string3) => htmlTrimLeadingBlankLines(htmlTrimEnd(string3));
        var splitByHtmlWhitespace = (string3) => string3.split(/[\t\n\f\r ]+/);
        var getLeadingHtmlWhitespace = (string3) => string3.match(/^[\t\n\f\r ]*/)[0];
        var getLeadingAndTrailingHtmlWhitespace = (string3) => {
          const [, leadingWhitespace, text, trailingWhitespace] = string3.match(/^([\t\n\f\r ]*)(.*?)([\t\n\f\r ]*)$/s);
          return {
            leadingWhitespace,
            trailingWhitespace,
            text
          };
        };
        var hasHtmlWhitespace = (string3) => /[\t\n\f\r ]/.test(string3);
        function shouldPreserveContent(node, options) {
          if (node.type === "ieConditionalComment" && node.lastChild && !node.lastChild.isSelfClosing && !node.lastChild.endSourceSpan) {
            return true;
          }
          if (node.type === "ieConditionalComment" && !node.complete) {
            return true;
          }
          if (isPreLikeNode(node) && node.children.some((child) => child.type !== "text" && child.type !== "interpolation")) {
            return true;
          }
          if (isVueNonHtmlBlock(node, options) && !isScriptLikeTag(node) && node.type !== "interpolation") {
            return true;
          }
          return false;
        }
        function hasPrettierIgnore(node) {
          if (node.type === "attribute") {
            return false;
          }
          if (!node.parent) {
            return false;
          }
          if (!node.prev) {
            return false;
          }
          return isPrettierIgnore(node.prev);
        }
        function isPrettierIgnore(node) {
          return node.type === "comment" && node.value.trim() === "prettier-ignore";
        }
        function isTextLikeNode(node) {
          return node.type === "text" || node.type === "comment";
        }
        function isScriptLikeTag(node) {
          return node.type === "element" && (node.fullName === "script" || node.fullName === "style" || node.fullName === "svg:style" || isUnknownNamespace(node) && (node.name === "script" || node.name === "style"));
        }
        function canHaveInterpolation(node) {
          return node.children && !isScriptLikeTag(node);
        }
        function isWhitespaceSensitiveNode(node) {
          return isScriptLikeTag(node) || node.type === "interpolation" || isIndentationSensitiveNode(node);
        }
        function isIndentationSensitiveNode(node) {
          return getNodeCssStyleWhiteSpace(node).startsWith("pre");
        }
        function isLeadingSpaceSensitiveNode(node, options) {
          const isLeadingSpaceSensitive = _isLeadingSpaceSensitiveNode();
          if (isLeadingSpaceSensitive && !node.prev && node.parent && node.parent.tagDefinition && node.parent.tagDefinition.ignoreFirstLf) {
            return node.type === "interpolation";
          }
          return isLeadingSpaceSensitive;
          function _isLeadingSpaceSensitiveNode() {
            if (isFrontMatterNode(node)) {
              return false;
            }
            if ((node.type === "text" || node.type === "interpolation") && node.prev && (node.prev.type === "text" || node.prev.type === "interpolation")) {
              return true;
            }
            if (!node.parent || node.parent.cssDisplay === "none") {
              return false;
            }
            if (isPreLikeNode(node.parent)) {
              return true;
            }
            if (!node.prev && (node.parent.type === "root" || isPreLikeNode(node) && node.parent || isScriptLikeTag(node.parent) || isVueCustomBlock(node.parent, options) || !isFirstChildLeadingSpaceSensitiveCssDisplay(node.parent.cssDisplay))) {
              return false;
            }
            if (node.prev && !isNextLeadingSpaceSensitiveCssDisplay(node.prev.cssDisplay)) {
              return false;
            }
            return true;
          }
        }
        function isTrailingSpaceSensitiveNode(node, options) {
          if (isFrontMatterNode(node)) {
            return false;
          }
          if ((node.type === "text" || node.type === "interpolation") && node.next && (node.next.type === "text" || node.next.type === "interpolation")) {
            return true;
          }
          if (!node.parent || node.parent.cssDisplay === "none") {
            return false;
          }
          if (isPreLikeNode(node.parent)) {
            return true;
          }
          if (!node.next && (node.parent.type === "root" || isPreLikeNode(node) && node.parent || isScriptLikeTag(node.parent) || isVueCustomBlock(node.parent, options) || !isLastChildTrailingSpaceSensitiveCssDisplay(node.parent.cssDisplay))) {
            return false;
          }
          if (node.next && !isPrevTrailingSpaceSensitiveCssDisplay(node.next.cssDisplay)) {
            return false;
          }
          return true;
        }
        function isDanglingSpaceSensitiveNode(node) {
          return isDanglingSpaceSensitiveCssDisplay(node.cssDisplay) && !isScriptLikeTag(node);
        }
        function forceNextEmptyLine(node) {
          return isFrontMatterNode(node) || node.next && node.sourceSpan.end && node.sourceSpan.end.line + 1 < node.next.sourceSpan.start.line;
        }
        function forceBreakContent(node) {
          return forceBreakChildren(node) || node.type === "element" && node.children.length > 0 && (["body", "script", "style"].includes(node.name) || node.children.some((child) => hasNonTextChild(child))) || node.firstChild && node.firstChild === node.lastChild && node.firstChild.type !== "text" && hasLeadingLineBreak(node.firstChild) && (!node.lastChild.isTrailingSpaceSensitive || hasTrailingLineBreak(node.lastChild));
        }
        function forceBreakChildren(node) {
          return node.type === "element" && node.children.length > 0 && (["html", "head", "ul", "ol", "select"].includes(node.name) || node.cssDisplay.startsWith("table") && node.cssDisplay !== "table-cell");
        }
        function preferHardlineAsLeadingSpaces(node) {
          return preferHardlineAsSurroundingSpaces(node) || node.prev && preferHardlineAsTrailingSpaces(node.prev) || hasSurroundingLineBreak(node);
        }
        function preferHardlineAsTrailingSpaces(node) {
          return preferHardlineAsSurroundingSpaces(node) || node.type === "element" && node.fullName === "br" || hasSurroundingLineBreak(node);
        }
        function hasSurroundingLineBreak(node) {
          return hasLeadingLineBreak(node) && hasTrailingLineBreak(node);
        }
        function hasLeadingLineBreak(node) {
          return node.hasLeadingSpaces && (node.prev ? node.prev.sourceSpan.end.line < node.sourceSpan.start.line : node.parent.type === "root" || node.parent.startSourceSpan.end.line < node.sourceSpan.start.line);
        }
        function hasTrailingLineBreak(node) {
          return node.hasTrailingSpaces && (node.next ? node.next.sourceSpan.start.line > node.sourceSpan.end.line : node.parent.type === "root" || node.parent.endSourceSpan && node.parent.endSourceSpan.start.line > node.sourceSpan.end.line);
        }
        function preferHardlineAsSurroundingSpaces(node) {
          switch (node.type) {
            case "ieConditionalComment":
            case "comment":
            case "directive":
              return true;
            case "element":
              return ["script", "select"].includes(node.name);
          }
          return false;
        }
        function getLastDescendant(node) {
          return node.lastChild ? getLastDescendant(node.lastChild) : node;
        }
        function hasNonTextChild(node) {
          return node.children && node.children.some((child) => child.type !== "text");
        }
        function _inferScriptParser(node) {
          const {
            type: type2,
            lang
          } = node.attrMap;
          if (type2 === "module" || type2 === "text/javascript" || type2 === "text/babel" || type2 === "application/javascript" || lang === "jsx") {
            return "babel";
          }
          if (type2 === "application/x-typescript" || lang === "ts" || lang === "tsx") {
            return "typescript";
          }
          if (type2 === "text/markdown") {
            return "markdown";
          }
          if (type2 === "text/html") {
            return "html";
          }
          if (type2 && (type2.endsWith("json") || type2.endsWith("importmap")) || type2 === "speculationrules") {
            return "json";
          }
          if (type2 === "text/x-handlebars-template") {
            return "glimmer";
          }
        }
        function inferStyleParser(node, options) {
          const {
            lang
          } = node.attrMap;
          if (!lang || lang === "postcss" || lang === "css") {
            return "css";
          }
          if (lang === "scss") {
            return "scss";
          }
          if (lang === "less") {
            return "less";
          }
          if (lang === "stylus") {
            return inferParserByLanguage("stylus", options);
          }
        }
        function inferScriptParser(node, options) {
          if (node.name === "script" && !node.attrMap.src) {
            if (!node.attrMap.lang && !node.attrMap.type) {
              return "babel";
            }
            return _inferScriptParser(node);
          }
          if (node.name === "style") {
            return inferStyleParser(node, options);
          }
          if (options && isVueNonHtmlBlock(node, options)) {
            return _inferScriptParser(node) || !("src" in node.attrMap) && inferParserByLanguage(node.attrMap.lang, options);
          }
        }
        function isBlockLikeCssDisplay(cssDisplay) {
          return cssDisplay === "block" || cssDisplay === "list-item" || cssDisplay.startsWith("table");
        }
        function isFirstChildLeadingSpaceSensitiveCssDisplay(cssDisplay) {
          return !isBlockLikeCssDisplay(cssDisplay) && cssDisplay !== "inline-block";
        }
        function isLastChildTrailingSpaceSensitiveCssDisplay(cssDisplay) {
          return !isBlockLikeCssDisplay(cssDisplay) && cssDisplay !== "inline-block";
        }
        function isPrevTrailingSpaceSensitiveCssDisplay(cssDisplay) {
          return !isBlockLikeCssDisplay(cssDisplay);
        }
        function isNextLeadingSpaceSensitiveCssDisplay(cssDisplay) {
          return !isBlockLikeCssDisplay(cssDisplay);
        }
        function isDanglingSpaceSensitiveCssDisplay(cssDisplay) {
          return !isBlockLikeCssDisplay(cssDisplay) && cssDisplay !== "inline-block";
        }
        function isPreLikeNode(node) {
          return getNodeCssStyleWhiteSpace(node).startsWith("pre");
        }
        function countParents(path5, predicate) {
          let counter = 0;
          for (let i = path5.stack.length - 1; i >= 0; i--) {
            const value = path5.stack[i];
            if (value && typeof value === "object" && !Array.isArray(value) && predicate(value)) {
              counter++;
            }
          }
          return counter;
        }
        function hasParent(node, fn) {
          let current = node;
          while (current) {
            if (fn(current)) {
              return true;
            }
            current = current.parent;
          }
          return false;
        }
        function getNodeCssStyleDisplay(node, options) {
          if (node.prev && node.prev.type === "comment") {
            const match = node.prev.value.match(/^\s*display:\s*([a-z]+)\s*$/);
            if (match) {
              return match[1];
            }
          }
          let isInSvgForeignObject = false;
          if (node.type === "element" && node.namespace === "svg") {
            if (hasParent(node, (parent) => parent.fullName === "svg:foreignObject")) {
              isInSvgForeignObject = true;
            } else {
              return node.name === "svg" ? "inline-block" : "block";
            }
          }
          switch (options.htmlWhitespaceSensitivity) {
            case "strict":
              return "inline";
            case "ignore":
              return "block";
            default: {
              if (options.parser === "vue" && node.parent && node.parent.type === "root") {
                return "block";
              }
              return node.type === "element" && (!node.namespace || isInSvgForeignObject || isUnknownNamespace(node)) && CSS_DISPLAY_TAGS[node.name] || CSS_DISPLAY_DEFAULT;
            }
          }
        }
        function getNodeCssStyleWhiteSpace(node) {
          return node.type === "element" && (!node.namespace || isUnknownNamespace(node)) && CSS_WHITE_SPACE_TAGS[node.name] || CSS_WHITE_SPACE_DEFAULT;
        }
        function getMinIndentation(text) {
          let minIndentation = Number.POSITIVE_INFINITY;
          for (const lineText of text.split("\n")) {
            if (lineText.length === 0) {
              continue;
            }
            if (!HTML_WHITESPACE.has(lineText[0])) {
              return 0;
            }
            const indentation = getLeadingHtmlWhitespace(lineText).length;
            if (lineText.length === indentation) {
              continue;
            }
            if (indentation < minIndentation) {
              minIndentation = indentation;
            }
          }
          return minIndentation === Number.POSITIVE_INFINITY ? 0 : minIndentation;
        }
        function dedentString(text, minIndent = getMinIndentation(text)) {
          return minIndent === 0 ? text : text.split("\n").map((lineText) => lineText.slice(minIndent)).join("\n");
        }
        function countChars(text, char) {
          let counter = 0;
          for (let i = 0; i < text.length; i++) {
            if (text[i] === char) {
              counter++;
            }
          }
          return counter;
        }
        function unescapeQuoteEntities(text) {
          return text.replace(/&apos;/g, "'").replace(/&quot;/g, '"');
        }
        var vueRootElementsSet = /* @__PURE__ */ new Set(["template", "style", "script"]);
        function isVueCustomBlock(node, options) {
          return isVueSfcBlock(node, options) && !vueRootElementsSet.has(node.fullName);
        }
        function isVueSfcBlock(node, options) {
          return options.parser === "vue" && node.type === "element" && node.parent.type === "root" && node.fullName.toLowerCase() !== "html";
        }
        function isVueNonHtmlBlock(node, options) {
          return isVueSfcBlock(node, options) && (isVueCustomBlock(node, options) || node.attrMap.lang && node.attrMap.lang !== "html");
        }
        function isVueSlotAttribute(attribute) {
          const attributeName = attribute.fullName;
          return attributeName.charAt(0) === "#" || attributeName === "slot-scope" || attributeName === "v-slot" || attributeName.startsWith("v-slot:");
        }
        function isVueSfcBindingsAttribute(attribute, options) {
          const element = attribute.parent;
          if (!isVueSfcBlock(element, options)) {
            return false;
          }
          const tagName = element.fullName;
          const attributeName = attribute.fullName;
          return tagName === "script" && attributeName === "setup" || tagName === "style" && attributeName === "vars";
        }
        function getTextValueParts(node, value = node.value) {
          return node.parent.isWhitespaceSensitive ? node.parent.isIndentationSensitive ? replaceTextEndOfLine(value) : replaceTextEndOfLine(dedentString(htmlTrimPreserveIndentation(value)), hardline) : getDocParts(join2(line, splitByHtmlWhitespace(value)));
        }
        function isVueScriptTag(node, options) {
          return isVueSfcBlock(node, options) && node.name === "script";
        }
        module22.exports = {
          htmlTrim,
          htmlTrimPreserveIndentation,
          hasHtmlWhitespace,
          getLeadingAndTrailingHtmlWhitespace,
          canHaveInterpolation,
          countChars,
          countParents,
          dedentString,
          forceBreakChildren,
          forceBreakContent,
          forceNextEmptyLine,
          getLastDescendant,
          getNodeCssStyleDisplay,
          getNodeCssStyleWhiteSpace,
          hasPrettierIgnore,
          inferScriptParser,
          isVueCustomBlock,
          isVueNonHtmlBlock,
          isVueScriptTag,
          isVueSlotAttribute,
          isVueSfcBindingsAttribute,
          isVueSfcBlock,
          isDanglingSpaceSensitiveNode,
          isIndentationSensitiveNode,
          isLeadingSpaceSensitiveNode,
          isPreLikeNode,
          isScriptLikeTag,
          isTextLikeNode,
          isTrailingSpaceSensitiveNode,
          isWhitespaceSensitiveNode,
          isUnknownNamespace,
          preferHardlineAsLeadingSpaces,
          preferHardlineAsTrailingSpaces,
          shouldPreserveContent,
          unescapeQuoteEntities,
          getTextValueParts
        };
      }
    });
    var require_chars = __commonJS22({
      "node_modules/angular-html-parser/lib/compiler/src/chars.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        exports22.$EOF = 0;
        exports22.$BSPACE = 8;
        exports22.$TAB = 9;
        exports22.$LF = 10;
        exports22.$VTAB = 11;
        exports22.$FF = 12;
        exports22.$CR = 13;
        exports22.$SPACE = 32;
        exports22.$BANG = 33;
        exports22.$DQ = 34;
        exports22.$HASH = 35;
        exports22.$$ = 36;
        exports22.$PERCENT = 37;
        exports22.$AMPERSAND = 38;
        exports22.$SQ = 39;
        exports22.$LPAREN = 40;
        exports22.$RPAREN = 41;
        exports22.$STAR = 42;
        exports22.$PLUS = 43;
        exports22.$COMMA = 44;
        exports22.$MINUS = 45;
        exports22.$PERIOD = 46;
        exports22.$SLASH = 47;
        exports22.$COLON = 58;
        exports22.$SEMICOLON = 59;
        exports22.$LT = 60;
        exports22.$EQ = 61;
        exports22.$GT = 62;
        exports22.$QUESTION = 63;
        exports22.$0 = 48;
        exports22.$7 = 55;
        exports22.$9 = 57;
        exports22.$A = 65;
        exports22.$E = 69;
        exports22.$F = 70;
        exports22.$X = 88;
        exports22.$Z = 90;
        exports22.$LBRACKET = 91;
        exports22.$BACKSLASH = 92;
        exports22.$RBRACKET = 93;
        exports22.$CARET = 94;
        exports22.$_ = 95;
        exports22.$a = 97;
        exports22.$b = 98;
        exports22.$e = 101;
        exports22.$f = 102;
        exports22.$n = 110;
        exports22.$r = 114;
        exports22.$t = 116;
        exports22.$u = 117;
        exports22.$v = 118;
        exports22.$x = 120;
        exports22.$z = 122;
        exports22.$LBRACE = 123;
        exports22.$BAR = 124;
        exports22.$RBRACE = 125;
        exports22.$NBSP = 160;
        exports22.$PIPE = 124;
        exports22.$TILDA = 126;
        exports22.$AT = 64;
        exports22.$BT = 96;
        function isWhitespace2(code) {
          return code >= exports22.$TAB && code <= exports22.$SPACE || code == exports22.$NBSP;
        }
        exports22.isWhitespace = isWhitespace2;
        function isDigit(code) {
          return exports22.$0 <= code && code <= exports22.$9;
        }
        exports22.isDigit = isDigit;
        function isAsciiLetter(code) {
          return code >= exports22.$a && code <= exports22.$z || code >= exports22.$A && code <= exports22.$Z;
        }
        exports22.isAsciiLetter = isAsciiLetter;
        function isAsciiHexDigit(code) {
          return code >= exports22.$a && code <= exports22.$f || code >= exports22.$A && code <= exports22.$F || isDigit(code);
        }
        exports22.isAsciiHexDigit = isAsciiHexDigit;
        function isNewLine(code) {
          return code === exports22.$LF || code === exports22.$CR;
        }
        exports22.isNewLine = isNewLine;
        function isOctalDigit(code) {
          return exports22.$0 <= code && code <= exports22.$7;
        }
        exports22.isOctalDigit = isOctalDigit;
      }
    });
    var require_static_symbol = __commonJS22({
      "node_modules/angular-html-parser/lib/compiler/src/aot/static_symbol.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var StaticSymbol = class {
          constructor(filePath, name, members) {
            this.filePath = filePath;
            this.name = name;
            this.members = members;
          }
          assertNoMembers() {
            if (this.members.length) {
              throw new Error(`Illegal state: symbol without members expected, but got ${JSON.stringify(this)}.`);
            }
          }
        };
        exports22.StaticSymbol = StaticSymbol;
        var StaticSymbolCache = class {
          constructor() {
            this.cache = /* @__PURE__ */ new Map();
          }
          get(declarationFile, name, members) {
            members = members || [];
            const memberSuffix = members.length ? `.${members.join(".")}` : "";
            const key = `"${declarationFile}".${name}${memberSuffix}`;
            let result = this.cache.get(key);
            if (!result) {
              result = new StaticSymbol(declarationFile, name, members);
              this.cache.set(key, result);
            }
            return result;
          }
        };
        exports22.StaticSymbolCache = StaticSymbolCache;
      }
    });
    var require_util3 = __commonJS22({
      "node_modules/angular-html-parser/lib/compiler/src/util.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var DASH_CASE_REGEXP = /-+([a-z0-9])/g;
        function dashCaseToCamelCase(input) {
          return input.replace(DASH_CASE_REGEXP, (...m) => m[1].toUpperCase());
        }
        exports22.dashCaseToCamelCase = dashCaseToCamelCase;
        function splitAtColon(input, defaultValues) {
          return _splitAt(input, ":", defaultValues);
        }
        exports22.splitAtColon = splitAtColon;
        function splitAtPeriod(input, defaultValues) {
          return _splitAt(input, ".", defaultValues);
        }
        exports22.splitAtPeriod = splitAtPeriod;
        function _splitAt(input, character, defaultValues) {
          const characterIndex = input.indexOf(character);
          if (characterIndex == -1)
            return defaultValues;
          return [input.slice(0, characterIndex).trim(), input.slice(characterIndex + 1).trim()];
        }
        function visitValue(value, visitor, context) {
          if (Array.isArray(value)) {
            return visitor.visitArray(value, context);
          }
          if (isStrictStringMap(value)) {
            return visitor.visitStringMap(value, context);
          }
          if (value == null || typeof value == "string" || typeof value == "number" || typeof value == "boolean") {
            return visitor.visitPrimitive(value, context);
          }
          return visitor.visitOther(value, context);
        }
        exports22.visitValue = visitValue;
        function isDefined(val) {
          return val !== null && val !== void 0;
        }
        exports22.isDefined = isDefined;
        function noUndefined(val) {
          return val === void 0 ? null : val;
        }
        exports22.noUndefined = noUndefined;
        var ValueTransformer = class {
          visitArray(arr, context) {
            return arr.map((value) => visitValue(value, this, context));
          }
          visitStringMap(map2, context) {
            const result = {};
            Object.keys(map2).forEach((key) => {
              result[key] = visitValue(map2[key], this, context);
            });
            return result;
          }
          visitPrimitive(value, context) {
            return value;
          }
          visitOther(value, context) {
            return value;
          }
        };
        exports22.ValueTransformer = ValueTransformer;
        exports22.SyncAsync = {
          assertSync: (value) => {
            if (isPromise(value)) {
              throw new Error(`Illegal state: value cannot be a promise`);
            }
            return value;
          },
          then: (value, cb) => {
            return isPromise(value) ? value.then(cb) : cb(value);
          },
          all: (syncAsyncValues) => {
            return syncAsyncValues.some(isPromise) ? Promise.all(syncAsyncValues) : syncAsyncValues;
          }
        };
        function error(msg) {
          throw new Error(`Internal Error: ${msg}`);
        }
        exports22.error = error;
        function syntaxError(msg, parseErrors) {
          const error2 = Error(msg);
          error2[ERROR_SYNTAX_ERROR] = true;
          if (parseErrors)
            error2[ERROR_PARSE_ERRORS] = parseErrors;
          return error2;
        }
        exports22.syntaxError = syntaxError;
        var ERROR_SYNTAX_ERROR = "ngSyntaxError";
        var ERROR_PARSE_ERRORS = "ngParseErrors";
        function isSyntaxError(error2) {
          return error2[ERROR_SYNTAX_ERROR];
        }
        exports22.isSyntaxError = isSyntaxError;
        function getParseErrors(error2) {
          return error2[ERROR_PARSE_ERRORS] || [];
        }
        exports22.getParseErrors = getParseErrors;
        function escapeRegExp(s) {
          return s.replace(/([.*+?^=!:${}()|[\]\/\\])/g, "\\$1");
        }
        exports22.escapeRegExp = escapeRegExp;
        var STRING_MAP_PROTO = Object.getPrototypeOf({});
        function isStrictStringMap(obj) {
          return typeof obj === "object" && obj !== null && Object.getPrototypeOf(obj) === STRING_MAP_PROTO;
        }
        function utf8Encode(str2) {
          let encoded = "";
          for (let index = 0; index < str2.length; index++) {
            let codePoint = str2.charCodeAt(index);
            if (codePoint >= 55296 && codePoint <= 56319 && str2.length > index + 1) {
              const low = str2.charCodeAt(index + 1);
              if (low >= 56320 && low <= 57343) {
                index++;
                codePoint = (codePoint - 55296 << 10) + low - 56320 + 65536;
              }
            }
            if (codePoint <= 127) {
              encoded += String.fromCharCode(codePoint);
            } else if (codePoint <= 2047) {
              encoded += String.fromCharCode(codePoint >> 6 & 31 | 192, codePoint & 63 | 128);
            } else if (codePoint <= 65535) {
              encoded += String.fromCharCode(codePoint >> 12 | 224, codePoint >> 6 & 63 | 128, codePoint & 63 | 128);
            } else if (codePoint <= 2097151) {
              encoded += String.fromCharCode(codePoint >> 18 & 7 | 240, codePoint >> 12 & 63 | 128, codePoint >> 6 & 63 | 128, codePoint & 63 | 128);
            }
          }
          return encoded;
        }
        exports22.utf8Encode = utf8Encode;
        function stringify(token) {
          if (typeof token === "string") {
            return token;
          }
          if (token instanceof Array) {
            return "[" + token.map(stringify).join(", ") + "]";
          }
          if (token == null) {
            return "" + token;
          }
          if (token.overriddenName) {
            return `${token.overriddenName}`;
          }
          if (token.name) {
            return `${token.name}`;
          }
          if (!token.toString) {
            return "object";
          }
          const res = token.toString();
          if (res == null) {
            return "" + res;
          }
          const newLineIndex = res.indexOf("\n");
          return newLineIndex === -1 ? res : res.substring(0, newLineIndex);
        }
        exports22.stringify = stringify;
        function resolveForwardRef(type2) {
          if (typeof type2 === "function" && type2.hasOwnProperty("__forward_ref__")) {
            return type2();
          } else {
            return type2;
          }
        }
        exports22.resolveForwardRef = resolveForwardRef;
        function isPromise(obj) {
          return !!obj && typeof obj.then === "function";
        }
        exports22.isPromise = isPromise;
        var Version2 = class {
          constructor(full) {
            this.full = full;
            const splits = full.split(".");
            this.major = splits[0];
            this.minor = splits[1];
            this.patch = splits.slice(2).join(".");
          }
        };
        exports22.Version = Version2;
        var __window = typeof window !== "undefined" && window;
        var __self = typeof self !== "undefined" && typeof WorkerGlobalScope !== "undefined" && self instanceof WorkerGlobalScope && self;
        var __global = typeof global !== "undefined" && global;
        var _global = __global || __window || __self;
        exports22.global = _global;
      }
    });
    var require_compile_metadata = __commonJS22({
      "node_modules/angular-html-parser/lib/compiler/src/compile_metadata.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var static_symbol_1 = require_static_symbol();
        var util_1 = require_util3();
        var HOST_REG_EXP = /^(?:(?:\[([^\]]+)\])|(?:\(([^\)]+)\)))|(\@[-\w]+)$/;
        function sanitizeIdentifier(name) {
          return name.replace(/\W/g, "_");
        }
        exports22.sanitizeIdentifier = sanitizeIdentifier;
        var _anonymousTypeIndex = 0;
        function identifierName(compileIdentifier) {
          if (!compileIdentifier || !compileIdentifier.reference) {
            return null;
          }
          const ref = compileIdentifier.reference;
          if (ref instanceof static_symbol_1.StaticSymbol) {
            return ref.name;
          }
          if (ref["__anonymousType"]) {
            return ref["__anonymousType"];
          }
          let identifier = util_1.stringify(ref);
          if (identifier.indexOf("(") >= 0) {
            identifier = `anonymous_${_anonymousTypeIndex++}`;
            ref["__anonymousType"] = identifier;
          } else {
            identifier = sanitizeIdentifier(identifier);
          }
          return identifier;
        }
        exports22.identifierName = identifierName;
        function identifierModuleUrl(compileIdentifier) {
          const ref = compileIdentifier.reference;
          if (ref instanceof static_symbol_1.StaticSymbol) {
            return ref.filePath;
          }
          return `./${util_1.stringify(ref)}`;
        }
        exports22.identifierModuleUrl = identifierModuleUrl;
        function viewClassName(compType, embeddedTemplateIndex) {
          return `View_${identifierName({
            reference: compType
          })}_${embeddedTemplateIndex}`;
        }
        exports22.viewClassName = viewClassName;
        function rendererTypeName(compType) {
          return `RenderType_${identifierName({
            reference: compType
          })}`;
        }
        exports22.rendererTypeName = rendererTypeName;
        function hostViewClassName(compType) {
          return `HostView_${identifierName({
            reference: compType
          })}`;
        }
        exports22.hostViewClassName = hostViewClassName;
        function componentFactoryName(compType) {
          return `${identifierName({
            reference: compType
          })}NgFactory`;
        }
        exports22.componentFactoryName = componentFactoryName;
        var CompileSummaryKind;
        (function(CompileSummaryKind2) {
          CompileSummaryKind2[CompileSummaryKind2["Pipe"] = 0] = "Pipe";
          CompileSummaryKind2[CompileSummaryKind2["Directive"] = 1] = "Directive";
          CompileSummaryKind2[CompileSummaryKind2["NgModule"] = 2] = "NgModule";
          CompileSummaryKind2[CompileSummaryKind2["Injectable"] = 3] = "Injectable";
        })(CompileSummaryKind = exports22.CompileSummaryKind || (exports22.CompileSummaryKind = {}));
        function tokenName(token) {
          return token.value != null ? sanitizeIdentifier(token.value) : identifierName(token.identifier);
        }
        exports22.tokenName = tokenName;
        function tokenReference(token) {
          if (token.identifier != null) {
            return token.identifier.reference;
          } else {
            return token.value;
          }
        }
        exports22.tokenReference = tokenReference;
        var CompileStylesheetMetadata = class {
          constructor({
            moduleUrl,
            styles,
            styleUrls
          } = {}) {
            this.moduleUrl = moduleUrl || null;
            this.styles = _normalizeArray(styles);
            this.styleUrls = _normalizeArray(styleUrls);
          }
        };
        exports22.CompileStylesheetMetadata = CompileStylesheetMetadata;
        var CompileTemplateMetadata = class {
          constructor({
            encapsulation,
            template,
            templateUrl,
            htmlAst,
            styles,
            styleUrls,
            externalStylesheets,
            animations,
            ngContentSelectors,
            interpolation,
            isInline,
            preserveWhitespaces
          }) {
            this.encapsulation = encapsulation;
            this.template = template;
            this.templateUrl = templateUrl;
            this.htmlAst = htmlAst;
            this.styles = _normalizeArray(styles);
            this.styleUrls = _normalizeArray(styleUrls);
            this.externalStylesheets = _normalizeArray(externalStylesheets);
            this.animations = animations ? flatten(animations) : [];
            this.ngContentSelectors = ngContentSelectors || [];
            if (interpolation && interpolation.length != 2) {
              throw new Error(`'interpolation' should have a start and an end symbol.`);
            }
            this.interpolation = interpolation;
            this.isInline = isInline;
            this.preserveWhitespaces = preserveWhitespaces;
          }
          toSummary() {
            return {
              ngContentSelectors: this.ngContentSelectors,
              encapsulation: this.encapsulation,
              styles: this.styles,
              animations: this.animations
            };
          }
        };
        exports22.CompileTemplateMetadata = CompileTemplateMetadata;
        var CompileDirectiveMetadata = class {
          static create({
            isHost,
            type: type2,
            isComponent,
            selector,
            exportAs,
            changeDetection,
            inputs,
            outputs,
            host,
            providers,
            viewProviders,
            queries,
            guards,
            viewQueries,
            entryComponents,
            template,
            componentViewType,
            rendererType,
            componentFactory
          }) {
            const hostListeners = {};
            const hostProperties = {};
            const hostAttributes = {};
            if (host != null) {
              Object.keys(host).forEach((key) => {
                const value = host[key];
                const matches = key.match(HOST_REG_EXP);
                if (matches === null) {
                  hostAttributes[key] = value;
                } else if (matches[1] != null) {
                  hostProperties[matches[1]] = value;
                } else if (matches[2] != null) {
                  hostListeners[matches[2]] = value;
                }
              });
            }
            const inputsMap = {};
            if (inputs != null) {
              inputs.forEach((bindConfig) => {
                const parts = util_1.splitAtColon(bindConfig, [bindConfig, bindConfig]);
                inputsMap[parts[0]] = parts[1];
              });
            }
            const outputsMap = {};
            if (outputs != null) {
              outputs.forEach((bindConfig) => {
                const parts = util_1.splitAtColon(bindConfig, [bindConfig, bindConfig]);
                outputsMap[parts[0]] = parts[1];
              });
            }
            return new CompileDirectiveMetadata({
              isHost,
              type: type2,
              isComponent: !!isComponent,
              selector,
              exportAs,
              changeDetection,
              inputs: inputsMap,
              outputs: outputsMap,
              hostListeners,
              hostProperties,
              hostAttributes,
              providers,
              viewProviders,
              queries,
              guards,
              viewQueries,
              entryComponents,
              template,
              componentViewType,
              rendererType,
              componentFactory
            });
          }
          constructor({
            isHost,
            type: type2,
            isComponent,
            selector,
            exportAs,
            changeDetection,
            inputs,
            outputs,
            hostListeners,
            hostProperties,
            hostAttributes,
            providers,
            viewProviders,
            queries,
            guards,
            viewQueries,
            entryComponents,
            template,
            componentViewType,
            rendererType,
            componentFactory
          }) {
            this.isHost = !!isHost;
            this.type = type2;
            this.isComponent = isComponent;
            this.selector = selector;
            this.exportAs = exportAs;
            this.changeDetection = changeDetection;
            this.inputs = inputs;
            this.outputs = outputs;
            this.hostListeners = hostListeners;
            this.hostProperties = hostProperties;
            this.hostAttributes = hostAttributes;
            this.providers = _normalizeArray(providers);
            this.viewProviders = _normalizeArray(viewProviders);
            this.queries = _normalizeArray(queries);
            this.guards = guards;
            this.viewQueries = _normalizeArray(viewQueries);
            this.entryComponents = _normalizeArray(entryComponents);
            this.template = template;
            this.componentViewType = componentViewType;
            this.rendererType = rendererType;
            this.componentFactory = componentFactory;
          }
          toSummary() {
            return {
              summaryKind: CompileSummaryKind.Directive,
              type: this.type,
              isComponent: this.isComponent,
              selector: this.selector,
              exportAs: this.exportAs,
              inputs: this.inputs,
              outputs: this.outputs,
              hostListeners: this.hostListeners,
              hostProperties: this.hostProperties,
              hostAttributes: this.hostAttributes,
              providers: this.providers,
              viewProviders: this.viewProviders,
              queries: this.queries,
              guards: this.guards,
              viewQueries: this.viewQueries,
              entryComponents: this.entryComponents,
              changeDetection: this.changeDetection,
              template: this.template && this.template.toSummary(),
              componentViewType: this.componentViewType,
              rendererType: this.rendererType,
              componentFactory: this.componentFactory
            };
          }
        };
        exports22.CompileDirectiveMetadata = CompileDirectiveMetadata;
        var CompilePipeMetadata = class {
          constructor({
            type: type2,
            name,
            pure
          }) {
            this.type = type2;
            this.name = name;
            this.pure = !!pure;
          }
          toSummary() {
            return {
              summaryKind: CompileSummaryKind.Pipe,
              type: this.type,
              name: this.name,
              pure: this.pure
            };
          }
        };
        exports22.CompilePipeMetadata = CompilePipeMetadata;
        var CompileShallowModuleMetadata = class {
        };
        exports22.CompileShallowModuleMetadata = CompileShallowModuleMetadata;
        var CompileNgModuleMetadata = class {
          constructor({
            type: type2,
            providers,
            declaredDirectives,
            exportedDirectives,
            declaredPipes,
            exportedPipes,
            entryComponents,
            bootstrapComponents,
            importedModules,
            exportedModules,
            schemas,
            transitiveModule,
            id
          }) {
            this.type = type2 || null;
            this.declaredDirectives = _normalizeArray(declaredDirectives);
            this.exportedDirectives = _normalizeArray(exportedDirectives);
            this.declaredPipes = _normalizeArray(declaredPipes);
            this.exportedPipes = _normalizeArray(exportedPipes);
            this.providers = _normalizeArray(providers);
            this.entryComponents = _normalizeArray(entryComponents);
            this.bootstrapComponents = _normalizeArray(bootstrapComponents);
            this.importedModules = _normalizeArray(importedModules);
            this.exportedModules = _normalizeArray(exportedModules);
            this.schemas = _normalizeArray(schemas);
            this.id = id || null;
            this.transitiveModule = transitiveModule || null;
          }
          toSummary() {
            const module3 = this.transitiveModule;
            return {
              summaryKind: CompileSummaryKind.NgModule,
              type: this.type,
              entryComponents: module3.entryComponents,
              providers: module3.providers,
              modules: module3.modules,
              exportedDirectives: module3.exportedDirectives,
              exportedPipes: module3.exportedPipes
            };
          }
        };
        exports22.CompileNgModuleMetadata = CompileNgModuleMetadata;
        var TransitiveCompileNgModuleMetadata = class {
          constructor() {
            this.directivesSet = /* @__PURE__ */ new Set();
            this.directives = [];
            this.exportedDirectivesSet = /* @__PURE__ */ new Set();
            this.exportedDirectives = [];
            this.pipesSet = /* @__PURE__ */ new Set();
            this.pipes = [];
            this.exportedPipesSet = /* @__PURE__ */ new Set();
            this.exportedPipes = [];
            this.modulesSet = /* @__PURE__ */ new Set();
            this.modules = [];
            this.entryComponentsSet = /* @__PURE__ */ new Set();
            this.entryComponents = [];
            this.providers = [];
          }
          addProvider(provider, module3) {
            this.providers.push({
              provider,
              module: module3
            });
          }
          addDirective(id) {
            if (!this.directivesSet.has(id.reference)) {
              this.directivesSet.add(id.reference);
              this.directives.push(id);
            }
          }
          addExportedDirective(id) {
            if (!this.exportedDirectivesSet.has(id.reference)) {
              this.exportedDirectivesSet.add(id.reference);
              this.exportedDirectives.push(id);
            }
          }
          addPipe(id) {
            if (!this.pipesSet.has(id.reference)) {
              this.pipesSet.add(id.reference);
              this.pipes.push(id);
            }
          }
          addExportedPipe(id) {
            if (!this.exportedPipesSet.has(id.reference)) {
              this.exportedPipesSet.add(id.reference);
              this.exportedPipes.push(id);
            }
          }
          addModule(id) {
            if (!this.modulesSet.has(id.reference)) {
              this.modulesSet.add(id.reference);
              this.modules.push(id);
            }
          }
          addEntryComponent(ec) {
            if (!this.entryComponentsSet.has(ec.componentType)) {
              this.entryComponentsSet.add(ec.componentType);
              this.entryComponents.push(ec);
            }
          }
        };
        exports22.TransitiveCompileNgModuleMetadata = TransitiveCompileNgModuleMetadata;
        function _normalizeArray(obj) {
          return obj || [];
        }
        var ProviderMeta = class {
          constructor(token, {
            useClass,
            useValue,
            useExisting,
            useFactory,
            deps,
            multi
          }) {
            this.token = token;
            this.useClass = useClass || null;
            this.useValue = useValue;
            this.useExisting = useExisting;
            this.useFactory = useFactory || null;
            this.dependencies = deps || null;
            this.multi = !!multi;
          }
        };
        exports22.ProviderMeta = ProviderMeta;
        function flatten(list3) {
          return list3.reduce((flat, item) => {
            const flatItem = Array.isArray(item) ? flatten(item) : item;
            return flat.concat(flatItem);
          }, []);
        }
        exports22.flatten = flatten;
        function jitSourceUrl(url) {
          return url.replace(/(\w+:\/\/[\w:-]+)?(\/+)?/, "ng:///");
        }
        function templateSourceUrl(ngModuleType, compMeta, templateMeta) {
          let url;
          if (templateMeta.isInline) {
            if (compMeta.type.reference instanceof static_symbol_1.StaticSymbol) {
              url = `${compMeta.type.reference.filePath}.${compMeta.type.reference.name}.html`;
            } else {
              url = `${identifierName(ngModuleType)}/${identifierName(compMeta.type)}.html`;
            }
          } else {
            url = templateMeta.templateUrl;
          }
          return compMeta.type.reference instanceof static_symbol_1.StaticSymbol ? url : jitSourceUrl(url);
        }
        exports22.templateSourceUrl = templateSourceUrl;
        function sharedStylesheetJitUrl(meta, id) {
          const pathParts = meta.moduleUrl.split(/\/\\/g);
          const baseName = pathParts[pathParts.length - 1];
          return jitSourceUrl(`css/${id}${baseName}.ngstyle.js`);
        }
        exports22.sharedStylesheetJitUrl = sharedStylesheetJitUrl;
        function ngModuleJitUrl(moduleMeta) {
          return jitSourceUrl(`${identifierName(moduleMeta.type)}/module.ngfactory.js`);
        }
        exports22.ngModuleJitUrl = ngModuleJitUrl;
        function templateJitUrl(ngModuleType, compMeta) {
          return jitSourceUrl(`${identifierName(ngModuleType)}/${identifierName(compMeta.type)}.ngfactory.js`);
        }
        exports22.templateJitUrl = templateJitUrl;
      }
    });
    var require_parse_util = __commonJS22({
      "node_modules/angular-html-parser/lib/compiler/src/parse_util.js"(exports22) {
        "use strict";
        Object.defineProperty(exports22, "__esModule", {
          value: true
        });
        var chars = require_chars();
        var compile_metadata_1 = require_compile_metadata();
        var ParseLocation = class {
          constructor(file, offset, line, col) {
            this.file = file;
            this.offset = offset;
            this.line = line;
            this.col = col;
          }
          toString() {
            return this.offset != null ? `${this.file.url}@${this.line}:${this.col}` : this.file.url;
          }
          moveBy(delta) {
            const source = this.file.content;
            const len = source.length;
            let offset = this.offset;
            let line = this.line;
            let col = this.col;
            while (offset > 0 && delta < 0) {
              offset--;
              delta++;
              const ch = source.charCodeAt(offset);
              if (ch == chars.$LF) {
                line--;
                const priorLine = source.substr(0, offset - 1).lastIndexOf(String.fromCharCode(chars.$LF));
                col = priorLine > 0 ? offset - priorLine : offset;
              } else {
                col--;
              }
            }
            while (offset < len && delta > 0) {
              const ch = source.charCodeAt(offset);
              offset++;
              delta--;
              if (ch == chars.$LF) {
                line++;
                col = 0;
              } else {
                col++;
              }
            }
            return new ParseLocation(this.file, offset, line, col);
          }
          getContext(maxChars, maxLines) {
            const content = this.file.content;
            let startOffset = this.offset;
            if (startOffset != null) {
              if (startOffset > content.length - 1) {
                startOffset = content.length - 1;
              }
              let endOffset = startOffset;
              let ctxChars = 0;
              let ctxLines = 0;
              while (ctxChars < maxChars && startOffset > 0) {
                startOffset--;
                ctxChars++;
                if (content[startOffset] == "\n") {
                  if (++ctxLines == maxLines) {
                    break;
                  }
                }
              }
              ctxChars = 0;
              ctxLines = 0;
              while (ctxChars < maxChars && endOffset < content.length - 1) {
                endOffset++;
                ctxChars++;
                if (content[endOffset] == "\n") {
                  if (++ctxLines == maxLines) {
                    break;
                  }
                }
              }
              return {
                before: content.substring(startOffset, this.offset),
                after: content.substring(this.offset, endOffset + 1)
              };
            }
            return null;
          }
        };
        exports22.ParseLocation = ParseLocation;
        var ParseSourceFile = class {
          constructor(content, url) {
            this.content = content;
            this.url = url;
          }
        };
        exports22.ParseSourceFile = ParseSourceFile;
        var ParseSourceSpan = class {
          constructor(start, end, details = null) {
            this.start = start;
            this.end = end;
            this.details = details;
          }
          toString() {
            return this.start.file.content.substring(this.start.offset, this.end.offset);
          }
        };
        exports22.ParseSourceSpan = ParseSourceSpan;
        exports22.EMPTY_PARSE_LOCATION = new ParseLocation(new ParseSourceFile("", ""), 0, 0, 0);
        exports22.EMPTY_SOURCE_SPAN = new ParseSourceSpan(exports22.EMPTY_PARSE_LOCATION, exports22.EMPTY_PARSE_LOCATION);
        var ParseErrorLevel;
        (function(ParseErrorLevel2) {
          ParseErrorLevel2[ParseErrorLevel2["WARNING"] = 0] = "WARNING";
          ParseErrorLevel2[ParseErrorLevel2["ERROR"] = 1] = "ERROR";
        })(ParseErrorLevel = exports22.ParseErrorLevel || (exports22.ParseErrorLevel = {}));
        var ParseError3 = class {
          constructor(span, msg, level = ParseErrorLevel.ERROR) {
            this.span = span;
            this.msg = msg;
            this.level = level;
          }
          contextualMessage() {
            const ctx = this.span.start.getContext(100, 3);
            return ctx ? `${this.msg} ("${ctx.before}[${ParseErrorLevel[this.level]} ->]${ctx.after}")` : this.msg;
          }
          toString() {
            const details = this.span.details ? `, ${this.span.details}` : "";
            return `${this.contextualMessage()}: ${this.span.start}${details}`;
          }
        };
        exports22.ParseError = ParseError3;
        function typeSourceSpan(kind, type2) {
          const moduleUrl = compile_metadata_1.identifierModuleUrl(type2);
          const sourceFileName = moduleUrl != null ? `in ${kind} ${compile_metadata_1.identifierName(type2)} in ${moduleUrl}` : `in ${kind} ${compile_metadata_1.identifierName(type2)}`;
          const sourceFile = new ParseSourceFile("", sourceFileName);
          return new ParseSourceSpan(new ParseLocation(sourceFile, -1, -1, -1), new ParseLocation(sourceFile, -1, -1, -1));
        }
        exports22.typeSourceSpan = typeSourceSpan;
        function r3JitTypeSourceSpan(kind, typeName, sourceUrl) {
          const sourceFileName = `in ${kind} ${typeName} in ${sourceUrl}`;
          const sourceFile = new ParseSourceFile("", sourceFileName);
          return new ParseSourceSpan(new ParseLocation(sourceFile, -1, -1, -1), new ParseLocation(sourceFile, -1, -1, -1));
        }
        exports22.r3JitTypeSourceSpan = r3JitTypeSourceSpan;
      }
    });
    var require_print_preprocess3 = __commonJS22({
      "src/language-html/print-preprocess.js"(exports22, module22) {
        "use strict";
        var {
          ParseSourceSpan
        } = require_parse_util();
        var {
          htmlTrim,
          getLeadingAndTrailingHtmlWhitespace,
          hasHtmlWhitespace,
          canHaveInterpolation,
          getNodeCssStyleDisplay,
          isDanglingSpaceSensitiveNode,
          isIndentationSensitiveNode,
          isLeadingSpaceSensitiveNode,
          isTrailingSpaceSensitiveNode,
          isWhitespaceSensitiveNode,
          isVueScriptTag
        } = require_utils11();
        var PREPROCESS_PIPELINE = [removeIgnorableFirstLf, mergeIfConditionalStartEndCommentIntoElementOpeningTag, mergeCdataIntoText, extractInterpolation, extractWhitespaces, addCssDisplay, addIsSelfClosing, addHasHtmComponentClosingTag, addIsSpaceSensitive, mergeSimpleElementIntoText, markTsScript];
        function preprocess(ast, options) {
          for (const fn of PREPROCESS_PIPELINE) {
            fn(ast, options);
          }
          return ast;
        }
        function removeIgnorableFirstLf(ast) {
          ast.walk((node) => {
            if (node.type === "element" && node.tagDefinition.ignoreFirstLf && node.children.length > 0 && node.children[0].type === "text" && node.children[0].value[0] === "\n") {
              const text = node.children[0];
              if (text.value.length === 1) {
                node.removeChild(text);
              } else {
                text.value = text.value.slice(1);
              }
            }
          });
        }
        function mergeIfConditionalStartEndCommentIntoElementOpeningTag(ast) {
          const isTarget = (node) => node.type === "element" && node.prev && node.prev.type === "ieConditionalStartComment" && node.prev.sourceSpan.end.offset === node.startSourceSpan.start.offset && node.firstChild && node.firstChild.type === "ieConditionalEndComment" && node.firstChild.sourceSpan.start.offset === node.startSourceSpan.end.offset;
          ast.walk((node) => {
            if (node.children) {
              for (let i = 0; i < node.children.length; i++) {
                const child = node.children[i];
                if (!isTarget(child)) {
                  continue;
                }
                const ieConditionalStartComment = child.prev;
                const ieConditionalEndComment = child.firstChild;
                node.removeChild(ieConditionalStartComment);
                i--;
                const startSourceSpan = new ParseSourceSpan(ieConditionalStartComment.sourceSpan.start, ieConditionalEndComment.sourceSpan.end);
                const sourceSpan = new ParseSourceSpan(startSourceSpan.start, child.sourceSpan.end);
                child.condition = ieConditionalStartComment.condition;
                child.sourceSpan = sourceSpan;
                child.startSourceSpan = startSourceSpan;
                child.removeChild(ieConditionalEndComment);
              }
            }
          });
        }
        function mergeNodeIntoText(ast, shouldMerge, getValue2) {
          ast.walk((node) => {
            if (node.children) {
              for (let i = 0; i < node.children.length; i++) {
                const child = node.children[i];
                if (child.type !== "text" && !shouldMerge(child)) {
                  continue;
                }
                if (child.type !== "text") {
                  child.type = "text";
                  child.value = getValue2(child);
                }
                const prevChild = child.prev;
                if (!prevChild || prevChild.type !== "text") {
                  continue;
                }
                prevChild.value += child.value;
                prevChild.sourceSpan = new ParseSourceSpan(prevChild.sourceSpan.start, child.sourceSpan.end);
                node.removeChild(child);
                i--;
              }
            }
          });
        }
        function mergeCdataIntoText(ast) {
          return mergeNodeIntoText(ast, (node) => node.type === "cdata", (node) => `<![CDATA[${node.value}]]>`);
        }
        function mergeSimpleElementIntoText(ast) {
          const isSimpleElement = (node) => node.type === "element" && node.attrs.length === 0 && node.children.length === 1 && node.firstChild.type === "text" && !hasHtmlWhitespace(node.children[0].value) && !node.firstChild.hasLeadingSpaces && !node.firstChild.hasTrailingSpaces && node.isLeadingSpaceSensitive && !node.hasLeadingSpaces && node.isTrailingSpaceSensitive && !node.hasTrailingSpaces && node.prev && node.prev.type === "text" && node.next && node.next.type === "text";
          ast.walk((node) => {
            if (node.children) {
              for (let i = 0; i < node.children.length; i++) {
                const child = node.children[i];
                if (!isSimpleElement(child)) {
                  continue;
                }
                const prevChild = child.prev;
                const nextChild = child.next;
                prevChild.value += `<${child.rawName}>` + child.firstChild.value + `</${child.rawName}>` + nextChild.value;
                prevChild.sourceSpan = new ParseSourceSpan(prevChild.sourceSpan.start, nextChild.sourceSpan.end);
                prevChild.isTrailingSpaceSensitive = nextChild.isTrailingSpaceSensitive;
                prevChild.hasTrailingSpaces = nextChild.hasTrailingSpaces;
                node.removeChild(child);
                i--;
                node.removeChild(nextChild);
              }
            }
          });
        }
        function extractInterpolation(ast, options) {
          if (options.parser === "html") {
            return;
          }
          const interpolationRegex = /{{(.+?)}}/s;
          ast.walk((node) => {
            if (!canHaveInterpolation(node)) {
              return;
            }
            for (const child of node.children) {
              if (child.type !== "text") {
                continue;
              }
              let startSourceSpan = child.sourceSpan.start;
              let endSourceSpan = null;
              const components = child.value.split(interpolationRegex);
              for (let i = 0; i < components.length; i++, startSourceSpan = endSourceSpan) {
                const value = components[i];
                if (i % 2 === 0) {
                  endSourceSpan = startSourceSpan.moveBy(value.length);
                  if (value.length > 0) {
                    node.insertChildBefore(child, {
                      type: "text",
                      value,
                      sourceSpan: new ParseSourceSpan(startSourceSpan, endSourceSpan)
                    });
                  }
                  continue;
                }
                endSourceSpan = startSourceSpan.moveBy(value.length + 4);
                node.insertChildBefore(child, {
                  type: "interpolation",
                  sourceSpan: new ParseSourceSpan(startSourceSpan, endSourceSpan),
                  children: value.length === 0 ? [] : [{
                    type: "text",
                    value,
                    sourceSpan: new ParseSourceSpan(startSourceSpan.moveBy(2), endSourceSpan.moveBy(-2))
                  }]
                });
              }
              node.removeChild(child);
            }
          });
        }
        function extractWhitespaces(ast) {
          ast.walk((node) => {
            if (!node.children) {
              return;
            }
            if (node.children.length === 0 || node.children.length === 1 && node.children[0].type === "text" && htmlTrim(node.children[0].value).length === 0) {
              node.hasDanglingSpaces = node.children.length > 0;
              node.children = [];
              return;
            }
            const isWhitespaceSensitive = isWhitespaceSensitiveNode(node);
            const isIndentationSensitive = isIndentationSensitiveNode(node);
            if (!isWhitespaceSensitive) {
              for (let i = 0; i < node.children.length; i++) {
                const child = node.children[i];
                if (child.type !== "text") {
                  continue;
                }
                const {
                  leadingWhitespace,
                  text,
                  trailingWhitespace
                } = getLeadingAndTrailingHtmlWhitespace(child.value);
                const prevChild = child.prev;
                const nextChild = child.next;
                if (!text) {
                  node.removeChild(child);
                  i--;
                  if (leadingWhitespace || trailingWhitespace) {
                    if (prevChild) {
                      prevChild.hasTrailingSpaces = true;
                    }
                    if (nextChild) {
                      nextChild.hasLeadingSpaces = true;
                    }
                  }
                } else {
                  child.value = text;
                  child.sourceSpan = new ParseSourceSpan(child.sourceSpan.start.moveBy(leadingWhitespace.length), child.sourceSpan.end.moveBy(-trailingWhitespace.length));
                  if (leadingWhitespace) {
                    if (prevChild) {
                      prevChild.hasTrailingSpaces = true;
                    }
                    child.hasLeadingSpaces = true;
                  }
                  if (trailingWhitespace) {
                    child.hasTrailingSpaces = true;
                    if (nextChild) {
                      nextChild.hasLeadingSpaces = true;
                    }
                  }
                }
              }
            }
            node.isWhitespaceSensitive = isWhitespaceSensitive;
            node.isIndentationSensitive = isIndentationSensitive;
          });
        }
        function addIsSelfClosing(ast) {
          ast.walk((node) => {
            node.isSelfClosing = !node.children || node.type === "element" && (node.tagDefinition.isVoid || node.startSourceSpan === node.endSourceSpan);
          });
        }
        function addHasHtmComponentClosingTag(ast, options) {
          ast.walk((node) => {
            if (node.type !== "element") {
              return;
            }
            node.hasHtmComponentClosingTag = node.endSourceSpan && /^<\s*\/\s*\/\s*>$/.test(options.originalText.slice(node.endSourceSpan.start.offset, node.endSourceSpan.end.offset));
          });
        }
        function addCssDisplay(ast, options) {
          ast.walk((node) => {
            node.cssDisplay = getNodeCssStyleDisplay(node, options);
          });
        }
        function addIsSpaceSensitive(ast, options) {
          ast.walk((node) => {
            const {
              children
            } = node;
            if (!children) {
              return;
            }
            if (children.length === 0) {
              node.isDanglingSpaceSensitive = isDanglingSpaceSensitiveNode(node);
              return;
            }
            for (const child of children) {
              child.isLeadingSpaceSensitive = isLeadingSpaceSensitiveNode(child, options);
              child.isTrailingSpaceSensitive = isTrailingSpaceSensitiveNode(child, options);
            }
            for (let index = 0; index < children.length; index++) {
              const child = children[index];
              child.isLeadingSpaceSensitive = index === 0 ? child.isLeadingSpaceSensitive : child.prev.isTrailingSpaceSensitive && child.isLeadingSpaceSensitive;
              child.isTrailingSpaceSensitive = index === children.length - 1 ? child.isTrailingSpaceSensitive : child.next.isLeadingSpaceSensitive && child.isTrailingSpaceSensitive;
            }
          });
        }
        function markTsScript(ast, options) {
          if (options.parser === "vue") {
            const vueScriptTag = ast.children.find((child) => isVueScriptTag(child, options));
            if (!vueScriptTag) {
              return;
            }
            const {
              lang
            } = vueScriptTag.attrMap;
            if (lang === "ts" || lang === "typescript") {
              options.__should_parse_vue_template_with_ts = true;
            }
          }
        }
        module22.exports = preprocess;
      }
    });
    var require_pragma5 = __commonJS22({
      "src/language-html/pragma.js"(exports22, module22) {
        "use strict";
        function hasPragma(text) {
          return /^\s*<!--\s*@(?:format|prettier)\s*-->/.test(text);
        }
        function insertPragma(text) {
          return "<!-- @format -->\n\n" + text.replace(/^\s*\n/, "");
        }
        module22.exports = {
          hasPragma,
          insertPragma
        };
      }
    });
    var require_loc6 = __commonJS22({
      "src/language-html/loc.js"(exports22, module22) {
        "use strict";
        function locStart(node) {
          return node.sourceSpan.start.offset;
        }
        function locEnd(node) {
          return node.sourceSpan.end.offset;
        }
        module22.exports = {
          locStart,
          locEnd
        };
      }
    });
    var require_tag = __commonJS22({
      "src/language-html/print/tag.js"(exports22, module22) {
        "use strict";
        var assert = require("assert");
        var {
          isNonEmptyArray
        } = require_util2();
        var {
          builders: {
            indent,
            join: join2,
            line,
            softline,
            hardline
          },
          utils: {
            replaceTextEndOfLine
          }
        } = require_doc();
        var {
          locStart,
          locEnd
        } = require_loc6();
        var {
          isTextLikeNode,
          getLastDescendant,
          isPreLikeNode,
          hasPrettierIgnore,
          shouldPreserveContent,
          isVueSfcBlock
        } = require_utils11();
        function printClosingTag(node, options) {
          return [node.isSelfClosing ? "" : printClosingTagStart(node, options), printClosingTagEnd(node, options)];
        }
        function printClosingTagStart(node, options) {
          return node.lastChild && needsToBorrowParentClosingTagStartMarker(node.lastChild) ? "" : [printClosingTagPrefix(node, options), printClosingTagStartMarker(node, options)];
        }
        function printClosingTagEnd(node, options) {
          return (node.next ? needsToBorrowPrevClosingTagEndMarker(node.next) : needsToBorrowLastChildClosingTagEndMarker(node.parent)) ? "" : [printClosingTagEndMarker(node, options), printClosingTagSuffix(node, options)];
        }
        function printClosingTagPrefix(node, options) {
          return needsToBorrowLastChildClosingTagEndMarker(node) ? printClosingTagEndMarker(node.lastChild, options) : "";
        }
        function printClosingTagSuffix(node, options) {
          return needsToBorrowParentClosingTagStartMarker(node) ? printClosingTagStartMarker(node.parent, options) : needsToBorrowNextOpeningTagStartMarker(node) ? printOpeningTagStartMarker(node.next) : "";
        }
        function printClosingTagStartMarker(node, options) {
          assert(!node.isSelfClosing);
          if (shouldNotPrintClosingTag(node, options)) {
            return "";
          }
          switch (node.type) {
            case "ieConditionalComment":
              return "<!";
            case "element":
              if (node.hasHtmComponentClosingTag) {
                return "<//";
              }
            default:
              return `</${node.rawName}`;
          }
        }
        function printClosingTagEndMarker(node, options) {
          if (shouldNotPrintClosingTag(node, options)) {
            return "";
          }
          switch (node.type) {
            case "ieConditionalComment":
            case "ieConditionalEndComment":
              return "[endif]-->";
            case "ieConditionalStartComment":
              return "]><!-->";
            case "interpolation":
              return "}}";
            case "element":
              if (node.isSelfClosing) {
                return "/>";
              }
            default:
              return ">";
          }
        }
        function shouldNotPrintClosingTag(node, options) {
          return !node.isSelfClosing && !node.endSourceSpan && (hasPrettierIgnore(node) || shouldPreserveContent(node.parent, options));
        }
        function needsToBorrowPrevClosingTagEndMarker(node) {
          return node.prev && node.prev.type !== "docType" && !isTextLikeNode(node.prev) && node.isLeadingSpaceSensitive && !node.hasLeadingSpaces;
        }
        function needsToBorrowLastChildClosingTagEndMarker(node) {
          return node.lastChild && node.lastChild.isTrailingSpaceSensitive && !node.lastChild.hasTrailingSpaces && !isTextLikeNode(getLastDescendant(node.lastChild)) && !isPreLikeNode(node);
        }
        function needsToBorrowParentClosingTagStartMarker(node) {
          return !node.next && !node.hasTrailingSpaces && node.isTrailingSpaceSensitive && isTextLikeNode(getLastDescendant(node));
        }
        function needsToBorrowNextOpeningTagStartMarker(node) {
          return node.next && !isTextLikeNode(node.next) && isTextLikeNode(node) && node.isTrailingSpaceSensitive && !node.hasTrailingSpaces;
        }
        function getPrettierIgnoreAttributeCommentData(value) {
          const match = value.trim().match(/^prettier-ignore-attribute(?:\s+(.+))?$/s);
          if (!match) {
            return false;
          }
          if (!match[1]) {
            return true;
          }
          return match[1].split(/\s+/);
        }
        function needsToBorrowParentOpeningTagEndMarker(node) {
          return !node.prev && node.isLeadingSpaceSensitive && !node.hasLeadingSpaces;
        }
        function printAttributes(path5, options, print) {
          const node = path5.getValue();
          if (!isNonEmptyArray(node.attrs)) {
            return node.isSelfClosing ? " " : "";
          }
          const ignoreAttributeData = node.prev && node.prev.type === "comment" && getPrettierIgnoreAttributeCommentData(node.prev.value);
          const hasPrettierIgnoreAttribute = typeof ignoreAttributeData === "boolean" ? () => ignoreAttributeData : Array.isArray(ignoreAttributeData) ? (attribute) => ignoreAttributeData.includes(attribute.rawName) : () => false;
          const printedAttributes = path5.map((attributePath) => {
            const attribute = attributePath.getValue();
            return hasPrettierIgnoreAttribute(attribute) ? replaceTextEndOfLine(options.originalText.slice(locStart(attribute), locEnd(attribute))) : print();
          }, "attrs");
          const forceNotToBreakAttrContent = node.type === "element" && node.fullName === "script" && node.attrs.length === 1 && node.attrs[0].fullName === "src" && node.children.length === 0;
          const shouldPrintAttributePerLine = options.singleAttributePerLine && node.attrs.length > 1 && !isVueSfcBlock(node, options);
          const attributeLine = shouldPrintAttributePerLine ? hardline : line;
          const parts = [indent([forceNotToBreakAttrContent ? " " : line, join2(attributeLine, printedAttributes)])];
          if (node.firstChild && needsToBorrowParentOpeningTagEndMarker(node.firstChild) || node.isSelfClosing && needsToBorrowLastChildClosingTagEndMarker(node.parent) || forceNotToBreakAttrContent) {
            parts.push(node.isSelfClosing ? " " : "");
          } else {
            parts.push(options.bracketSameLine ? node.isSelfClosing ? " " : "" : node.isSelfClosing ? line : softline);
          }
          return parts;
        }
        function printOpeningTagEnd(node) {
          return node.firstChild && needsToBorrowParentOpeningTagEndMarker(node.firstChild) ? "" : printOpeningTagEndMarker(node);
        }
        function printOpeningTag(path5, options, print) {
          const node = path5.getValue();
          return [printOpeningTagStart(node, options), printAttributes(path5, options, print), node.isSelfClosing ? "" : printOpeningTagEnd(node)];
        }
        function printOpeningTagStart(node, options) {
          return node.prev && needsToBorrowNextOpeningTagStartMarker(node.prev) ? "" : [printOpeningTagPrefix(node, options), printOpeningTagStartMarker(node)];
        }
        function printOpeningTagPrefix(node, options) {
          return needsToBorrowParentOpeningTagEndMarker(node) ? printOpeningTagEndMarker(node.parent) : needsToBorrowPrevClosingTagEndMarker(node) ? printClosingTagEndMarker(node.prev, options) : "";
        }
        function printOpeningTagStartMarker(node) {
          switch (node.type) {
            case "ieConditionalComment":
            case "ieConditionalStartComment":
              return `<!--[if ${node.condition}`;
            case "ieConditionalEndComment":
              return "<!--<!";
            case "interpolation":
              return "{{";
            case "docType":
              return "<!DOCTYPE";
            case "element":
              if (node.condition) {
                return `<!--[if ${node.condition}]><!--><${node.rawName}`;
              }
            default:
              return `<${node.rawName}`;
          }
        }
        function printOpeningTagEndMarker(node) {
          assert(!node.isSelfClosing);
          switch (node.type) {
            case "ieConditionalComment":
              return "]>";
            case "element":
              if (node.condition) {
                return "><!--<![endif]-->";
              }
            default:
              return ">";
          }
        }
        module22.exports = {
          printClosingTag,
          printClosingTagStart,
          printClosingTagStartMarker,
          printClosingTagEndMarker,
          printClosingTagSuffix,
          printClosingTagEnd,
          needsToBorrowLastChildClosingTagEndMarker,
          needsToBorrowParentClosingTagStartMarker,
          needsToBorrowPrevClosingTagEndMarker,
          printOpeningTag,
          printOpeningTagStart,
          printOpeningTagPrefix,
          printOpeningTagStartMarker,
          printOpeningTagEndMarker,
          needsToBorrowNextOpeningTagStartMarker,
          needsToBorrowParentOpeningTagEndMarker
        };
      }
    });
    var require_parse_srcset = __commonJS22({
      "node_modules/parse-srcset/src/parse-srcset.js"(exports22, module22) {
        (function(root2, factory) {
          if (typeof define === "function" && define.amd) {
            define([], factory);
          } else if (typeof module22 === "object" && module22.exports) {
            module22.exports = factory();
          } else {
            root2.parseSrcset = factory();
          }
        })(exports22, function() {
          return function(input, options) {
            var logger = options && options.logger || console;
            function isSpace(c2) {
              return c2 === " " || c2 === "	" || c2 === "\n" || c2 === "\f" || c2 === "\r";
            }
            function collectCharacters(regEx) {
              var chars, match = regEx.exec(input.substring(pos));
              if (match) {
                chars = match[0];
                pos += chars.length;
                return chars;
              }
            }
            var inputLength = input.length, regexLeadingSpaces = /^[ \t\n\r\u000c]+/, regexLeadingCommasOrSpaces = /^[, \t\n\r\u000c]+/, regexLeadingNotSpaces = /^[^ \t\n\r\u000c]+/, regexTrailingCommas = /[,]+$/, regexNonNegativeInteger = /^\d+$/, regexFloatingPoint = /^-?(?:[0-9]+|[0-9]*\.[0-9]+)(?:[eE][+-]?[0-9]+)?$/, url, descriptors, currentDescriptor, state, c, pos = 0, candidates = [];
            while (true) {
              collectCharacters(regexLeadingCommasOrSpaces);
              if (pos >= inputLength) {
                return candidates;
              }
              url = collectCharacters(regexLeadingNotSpaces);
              descriptors = [];
              if (url.slice(-1) === ",") {
                url = url.replace(regexTrailingCommas, "");
                parseDescriptors();
              } else {
                tokenize();
              }
            }
            function tokenize() {
              collectCharacters(regexLeadingSpaces);
              currentDescriptor = "";
              state = "in descriptor";
              while (true) {
                c = input.charAt(pos);
                if (state === "in descriptor") {
                  if (isSpace(c)) {
                    if (currentDescriptor) {
                      descriptors.push(currentDescriptor);
                      currentDescriptor = "";
                      state = "after descriptor";
                    }
                  } else if (c === ",") {
                    pos += 1;
                    if (currentDescriptor) {
                      descriptors.push(currentDescriptor);
                    }
                    parseDescriptors();
                    return;
                  } else if (c === "(") {
                    currentDescriptor = currentDescriptor + c;
                    state = "in parens";
                  } else if (c === "") {
                    if (currentDescriptor) {
                      descriptors.push(currentDescriptor);
                    }
                    parseDescriptors();
                    return;
                  } else {
                    currentDescriptor = currentDescriptor + c;
                  }
                } else if (state === "in parens") {
                  if (c === ")") {
                    currentDescriptor = currentDescriptor + c;
                    state = "in descriptor";
                  } else if (c === "") {
                    descriptors.push(currentDescriptor);
                    parseDescriptors();
                    return;
                  } else {
                    currentDescriptor = currentDescriptor + c;
                  }
                } else if (state === "after descriptor") {
                  if (isSpace(c)) {
                  } else if (c === "") {
                    parseDescriptors();
                    return;
                  } else {
                    state = "in descriptor";
                    pos -= 1;
                  }
                }
                pos += 1;
              }
            }
            function parseDescriptors() {
              var pError = false, w, d, h, i, candidate = {}, desc, lastChar, value, intVal, floatVal;
              for (i = 0; i < descriptors.length; i++) {
                desc = descriptors[i];
                lastChar = desc[desc.length - 1];
                value = desc.substring(0, desc.length - 1);
                intVal = parseInt(value, 10);
                floatVal = parseFloat(value);
                if (regexNonNegativeInteger.test(value) && lastChar === "w") {
                  if (w || d) {
                    pError = true;
                  }
                  if (intVal === 0) {
                    pError = true;
                  } else {
                    w = intVal;
                  }
                } else if (regexFloatingPoint.test(value) && lastChar === "x") {
                  if (w || d || h) {
                    pError = true;
                  }
                  if (floatVal < 0) {
                    pError = true;
                  } else {
                    d = floatVal;
                  }
                } else if (regexNonNegativeInteger.test(value) && lastChar === "h") {
                  if (h || d) {
                    pError = true;
                  }
                  if (intVal === 0) {
                    pError = true;
                  } else {
                    h = intVal;
                  }
                } else {
                  pError = true;
                }
              }
              if (!pError) {
                candidate.url = url;
                if (w) {
                  candidate.w = w;
                }
                if (d) {
                  candidate.d = d;
                }
                if (h) {
                  candidate.h = h;
                }
                candidates.push(candidate);
              } else if (logger && logger.error) {
                logger.error("Invalid srcset descriptor found in '" + input + "' at '" + desc + "'.");
              }
            }
          };
        });
      }
    });
    var require_syntax_attribute = __commonJS22({
      "src/language-html/syntax-attribute.js"(exports22, module22) {
        "use strict";
        var parseSrcset = require_parse_srcset();
        var {
          builders: {
            ifBreak,
            join: join2,
            line
          }
        } = require_doc();
        function printImgSrcset(value) {
          const srcset = parseSrcset(value, {
            logger: {
              error(message) {
                throw new Error(message);
              }
            }
          });
          const hasW = srcset.some(({
            w
          }) => w);
          const hasH = srcset.some(({
            h
          }) => h);
          const hasX = srcset.some(({
            d
          }) => d);
          if (hasW + hasH + hasX > 1) {
            throw new Error("Mixed descriptor in srcset is not supported");
          }
          const key = hasW ? "w" : hasH ? "h" : "d";
          const unit = hasW ? "w" : hasH ? "h" : "x";
          const getMax = (values) => Math.max(...values);
          const urls = srcset.map((src) => src.url);
          const maxUrlLength = getMax(urls.map((url) => url.length));
          const descriptors = srcset.map((src) => src[key]).map((descriptor) => descriptor ? descriptor.toString() : "");
          const descriptorLeftLengths = descriptors.map((descriptor) => {
            const index = descriptor.indexOf(".");
            return index === -1 ? descriptor.length : index;
          });
          const maxDescriptorLeftLength = getMax(descriptorLeftLengths);
          return join2([",", line], urls.map((url, index) => {
            const parts = [url];
            const descriptor = descriptors[index];
            if (descriptor) {
              const urlPadding = maxUrlLength - url.length + 1;
              const descriptorPadding = maxDescriptorLeftLength - descriptorLeftLengths[index];
              const alignment = " ".repeat(urlPadding + descriptorPadding);
              parts.push(ifBreak(alignment, " "), descriptor + unit);
            }
            return parts;
          }));
        }
        function printClassNames(value) {
          return value.trim().split(/\s+/).join(" ");
        }
        module22.exports = {
          printImgSrcset,
          printClassNames
        };
      }
    });
    var require_syntax_vue = __commonJS22({
      "src/language-html/syntax-vue.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            group
          }
        } = require_doc();
        function printVueFor(value, textToDoc) {
          const {
            left,
            operator,
            right
          } = parseVueFor(value);
          return [group(textToDoc(`function _(${left}) {}`, {
            parser: "babel",
            __isVueForBindingLeft: true
          })), " ", operator, " ", textToDoc(right, {
            parser: "__js_expression"
          }, {
            stripTrailingHardline: true
          })];
        }
        function parseVueFor(value) {
          const forAliasRE = /(.*?)\s+(in|of)\s+(.*)/s;
          const forIteratorRE = /,([^,\]}]*)(?:,([^,\]}]*))?$/;
          const stripParensRE = /^\(|\)$/g;
          const inMatch = value.match(forAliasRE);
          if (!inMatch) {
            return;
          }
          const res = {};
          res.for = inMatch[3].trim();
          if (!res.for) {
            return;
          }
          const alias = inMatch[1].trim().replace(stripParensRE, "");
          const iteratorMatch = alias.match(forIteratorRE);
          if (iteratorMatch) {
            res.alias = alias.replace(forIteratorRE, "");
            res.iterator1 = iteratorMatch[1].trim();
            if (iteratorMatch[2]) {
              res.iterator2 = iteratorMatch[2].trim();
            }
          } else {
            res.alias = alias;
          }
          const left = [res.alias, res.iterator1, res.iterator2];
          if (left.some((part, index) => !part && (index === 0 || left.slice(index + 1).some(Boolean)))) {
            return;
          }
          return {
            left: left.filter(Boolean).join(","),
            operator: inMatch[2],
            right: res.for
          };
        }
        function printVueBindings(value, textToDoc) {
          return textToDoc(`function _(${value}) {}`, {
            parser: "babel",
            __isVueBindings: true
          });
        }
        function isVueEventBindingExpression(eventBindingValue) {
          const fnExpRE = /^(?:[\w$]+|\([^)]*\))\s*=>|^function\s*\(/;
          const simplePathRE = /^[$A-Z_a-z][\w$]*(?:\.[$A-Z_a-z][\w$]*|\['[^']*']|\["[^"]*"]|\[\d+]|\[[$A-Z_a-z][\w$]*])*$/;
          const value = eventBindingValue.trim();
          return fnExpRE.test(value) || simplePathRE.test(value);
        }
        module22.exports = {
          isVueEventBindingExpression,
          printVueFor,
          printVueBindings
        };
      }
    });
    var require_get_node_content = __commonJS22({
      "src/language-html/get-node-content.js"(exports22, module22) {
        "use strict";
        var {
          needsToBorrowParentClosingTagStartMarker,
          printClosingTagStartMarker,
          needsToBorrowLastChildClosingTagEndMarker,
          printClosingTagEndMarker,
          needsToBorrowParentOpeningTagEndMarker,
          printOpeningTagEndMarker
        } = require_tag();
        function getNodeContent(node, options) {
          let start = node.startSourceSpan.end.offset;
          if (node.firstChild && needsToBorrowParentOpeningTagEndMarker(node.firstChild)) {
            start -= printOpeningTagEndMarker(node).length;
          }
          let end = node.endSourceSpan.start.offset;
          if (node.lastChild && needsToBorrowParentClosingTagStartMarker(node.lastChild)) {
            end += printClosingTagStartMarker(node, options).length;
          } else if (needsToBorrowLastChildClosingTagEndMarker(node)) {
            end -= printClosingTagEndMarker(node.lastChild, options).length;
          }
          return options.originalText.slice(start, end);
        }
        module22.exports = getNodeContent;
      }
    });
    var require_embed4 = __commonJS22({
      "src/language-html/embed.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            breakParent,
            group,
            hardline,
            indent,
            line,
            fill,
            softline
          },
          utils: {
            mapDoc,
            replaceTextEndOfLine
          }
        } = require_doc();
        var printFrontMatter = require_print();
        var {
          printClosingTag,
          printClosingTagSuffix,
          needsToBorrowPrevClosingTagEndMarker,
          printOpeningTagPrefix,
          printOpeningTag
        } = require_tag();
        var {
          printImgSrcset,
          printClassNames
        } = require_syntax_attribute();
        var {
          printVueFor,
          printVueBindings,
          isVueEventBindingExpression
        } = require_syntax_vue();
        var {
          isScriptLikeTag,
          isVueNonHtmlBlock,
          inferScriptParser,
          htmlTrimPreserveIndentation,
          dedentString,
          unescapeQuoteEntities,
          isVueSlotAttribute,
          isVueSfcBindingsAttribute,
          getTextValueParts
        } = require_utils11();
        var getNodeContent = require_get_node_content();
        function printEmbeddedAttributeValue(node, htmlTextToDoc, options) {
          const isKeyMatched = (patterns) => new RegExp(patterns.join("|")).test(node.fullName);
          const getValue2 = () => unescapeQuoteEntities(node.value);
          let shouldHug = false;
          const __onHtmlBindingRoot = (root2, options2) => {
            const rootNode = root2.type === "NGRoot" ? root2.node.type === "NGMicrosyntax" && root2.node.body.length === 1 && root2.node.body[0].type === "NGMicrosyntaxExpression" ? root2.node.body[0].expression : root2.node : root2.type === "JsExpressionRoot" ? root2.node : root2;
            if (rootNode && (rootNode.type === "ObjectExpression" || rootNode.type === "ArrayExpression" || options2.parser === "__vue_expression" && (rootNode.type === "TemplateLiteral" || rootNode.type === "StringLiteral"))) {
              shouldHug = true;
            }
          };
          const printHug = (doc2) => group(doc2);
          const printExpand = (doc2, canHaveTrailingWhitespace = true) => group([indent([softline, doc2]), canHaveTrailingWhitespace ? softline : ""]);
          const printMaybeHug = (doc2) => shouldHug ? printHug(doc2) : printExpand(doc2);
          const attributeTextToDoc = (code, opts) => htmlTextToDoc(code, Object.assign({
            __onHtmlBindingRoot,
            __embeddedInHtml: true
          }, opts));
          if (node.fullName === "srcset" && (node.parent.fullName === "img" || node.parent.fullName === "source")) {
            return printExpand(printImgSrcset(getValue2()));
          }
          if (node.fullName === "class" && !options.parentParser) {
            const value = getValue2();
            if (!value.includes("{{")) {
              return printClassNames(value);
            }
          }
          if (node.fullName === "style" && !options.parentParser) {
            const value = getValue2();
            if (!value.includes("{{")) {
              return printExpand(attributeTextToDoc(value, {
                parser: "css",
                __isHTMLStyleAttribute: true
              }));
            }
          }
          if (options.parser === "vue") {
            if (node.fullName === "v-for") {
              return printVueFor(getValue2(), attributeTextToDoc);
            }
            if (isVueSlotAttribute(node) || isVueSfcBindingsAttribute(node, options)) {
              return printVueBindings(getValue2(), attributeTextToDoc);
            }
            const vueEventBindingPatterns = ["^@", "^v-on:"];
            const vueExpressionBindingPatterns = ["^:", "^v-bind:"];
            const jsExpressionBindingPatterns = ["^v-"];
            if (isKeyMatched(vueEventBindingPatterns)) {
              const value = getValue2();
              const parser = isVueEventBindingExpression(value) ? "__js_expression" : options.__should_parse_vue_template_with_ts ? "__vue_ts_event_binding" : "__vue_event_binding";
              return printMaybeHug(attributeTextToDoc(value, {
                parser
              }));
            }
            if (isKeyMatched(vueExpressionBindingPatterns)) {
              return printMaybeHug(attributeTextToDoc(getValue2(), {
                parser: "__vue_expression"
              }));
            }
            if (isKeyMatched(jsExpressionBindingPatterns)) {
              return printMaybeHug(attributeTextToDoc(getValue2(), {
                parser: "__js_expression"
              }));
            }
          }
          if (options.parser === "angular") {
            const ngTextToDoc = (code, opts) => attributeTextToDoc(code, Object.assign(Object.assign({}, opts), {}, {
              trailingComma: "none"
            }));
            const ngDirectiveBindingPatterns = ["^\\*"];
            const ngStatementBindingPatterns = ["^\\(.+\\)$", "^on-"];
            const ngExpressionBindingPatterns = ["^\\[.+\\]$", "^bind(on)?-", "^ng-(if|show|hide|class|style)$"];
            const ngI18nPatterns = ["^i18n(-.+)?$"];
            if (isKeyMatched(ngStatementBindingPatterns)) {
              return printMaybeHug(ngTextToDoc(getValue2(), {
                parser: "__ng_action"
              }));
            }
            if (isKeyMatched(ngExpressionBindingPatterns)) {
              return printMaybeHug(ngTextToDoc(getValue2(), {
                parser: "__ng_binding"
              }));
            }
            if (isKeyMatched(ngI18nPatterns)) {
              const value2 = getValue2().trim();
              return printExpand(fill(getTextValueParts(node, value2)), !value2.includes("@@"));
            }
            if (isKeyMatched(ngDirectiveBindingPatterns)) {
              return printMaybeHug(ngTextToDoc(getValue2(), {
                parser: "__ng_directive"
              }));
            }
            const interpolationRegex = /{{(.+?)}}/s;
            const value = getValue2();
            if (interpolationRegex.test(value)) {
              const parts = [];
              for (const [index, part] of value.split(interpolationRegex).entries()) {
                if (index % 2 === 0) {
                  parts.push(replaceTextEndOfLine(part));
                } else {
                  try {
                    parts.push(group(["{{", indent([line, ngTextToDoc(part, {
                      parser: "__ng_interpolation",
                      __isInHtmlInterpolation: true
                    })]), line, "}}"]));
                  } catch {
                    parts.push("{{", replaceTextEndOfLine(part), "}}");
                  }
                }
              }
              return group(parts);
            }
          }
          return null;
        }
        function embed(path5, print, textToDoc, options) {
          const node = path5.getValue();
          switch (node.type) {
            case "element": {
              if (isScriptLikeTag(node) || node.type === "interpolation") {
                return;
              }
              if (!node.isSelfClosing && isVueNonHtmlBlock(node, options)) {
                const parser = inferScriptParser(node, options);
                if (!parser) {
                  return;
                }
                const content = getNodeContent(node, options);
                let isEmpty = /^\s*$/.test(content);
                let doc2 = "";
                if (!isEmpty) {
                  doc2 = textToDoc(htmlTrimPreserveIndentation(content), {
                    parser,
                    __embeddedInHtml: true
                  }, {
                    stripTrailingHardline: true
                  });
                  isEmpty = doc2 === "";
                }
                return [printOpeningTagPrefix(node, options), group(printOpeningTag(path5, options, print)), isEmpty ? "" : hardline, doc2, isEmpty ? "" : hardline, printClosingTag(node, options), printClosingTagSuffix(node, options)];
              }
              break;
            }
            case "text": {
              if (isScriptLikeTag(node.parent)) {
                const parser = inferScriptParser(node.parent, options);
                if (parser) {
                  const value = parser === "markdown" ? dedentString(node.value.replace(/^[^\S\n]*\n/, "")) : node.value;
                  const textToDocOptions = {
                    parser,
                    __embeddedInHtml: true
                  };
                  if (options.parser === "html" && parser === "babel") {
                    let sourceType = "script";
                    const {
                      attrMap
                    } = node.parent;
                    if (attrMap && (attrMap.type === "module" || attrMap.type === "text/babel" && attrMap["data-type"] === "module")) {
                      sourceType = "module";
                    }
                    textToDocOptions.__babelSourceType = sourceType;
                  }
                  return [breakParent, printOpeningTagPrefix(node, options), textToDoc(value, textToDocOptions, {
                    stripTrailingHardline: true
                  }), printClosingTagSuffix(node, options)];
                }
              } else if (node.parent.type === "interpolation") {
                const textToDocOptions = {
                  __isInHtmlInterpolation: true,
                  __embeddedInHtml: true
                };
                if (options.parser === "angular") {
                  textToDocOptions.parser = "__ng_interpolation";
                  textToDocOptions.trailingComma = "none";
                } else if (options.parser === "vue") {
                  textToDocOptions.parser = options.__should_parse_vue_template_with_ts ? "__vue_ts_expression" : "__vue_expression";
                } else {
                  textToDocOptions.parser = "__js_expression";
                }
                return [indent([line, textToDoc(node.value, textToDocOptions, {
                  stripTrailingHardline: true
                })]), node.parent.next && needsToBorrowPrevClosingTagEndMarker(node.parent.next) ? " " : line];
              }
              break;
            }
            case "attribute": {
              if (!node.value) {
                break;
              }
              if (/^PRETTIER_HTML_PLACEHOLDER_\d+_\d+_IN_JS$/.test(options.originalText.slice(node.valueSpan.start.offset, node.valueSpan.end.offset))) {
                return [node.rawName, "=", node.value];
              }
              if (options.parser === "lwc") {
                const interpolationRegex = /^{.*}$/s;
                if (interpolationRegex.test(options.originalText.slice(node.valueSpan.start.offset, node.valueSpan.end.offset))) {
                  return [node.rawName, "=", node.value];
                }
              }
              const embeddedAttributeValueDoc = printEmbeddedAttributeValue(node, (code, opts) => textToDoc(code, Object.assign({
                __isInHtmlAttribute: true,
                __embeddedInHtml: true
              }, opts), {
                stripTrailingHardline: true
              }), options);
              if (embeddedAttributeValueDoc) {
                return [node.rawName, '="', group(mapDoc(embeddedAttributeValueDoc, (doc2) => typeof doc2 === "string" ? doc2.replace(/"/g, "&quot;") : doc2)), '"'];
              }
              break;
            }
            case "front-matter":
              return printFrontMatter(node, textToDoc);
          }
        }
        module22.exports = embed;
      }
    });
    var require_children = __commonJS22({
      "src/language-html/print/children.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            breakParent,
            group,
            ifBreak,
            line,
            softline,
            hardline
          },
          utils: {
            replaceTextEndOfLine
          }
        } = require_doc();
        var {
          locStart,
          locEnd
        } = require_loc6();
        var {
          forceBreakChildren,
          forceNextEmptyLine,
          isTextLikeNode,
          hasPrettierIgnore,
          preferHardlineAsLeadingSpaces
        } = require_utils11();
        var {
          printOpeningTagPrefix,
          needsToBorrowNextOpeningTagStartMarker,
          printOpeningTagStartMarker,
          needsToBorrowPrevClosingTagEndMarker,
          printClosingTagEndMarker,
          printClosingTagSuffix,
          needsToBorrowParentClosingTagStartMarker
        } = require_tag();
        function printChild(childPath, options, print) {
          const child = childPath.getValue();
          if (hasPrettierIgnore(child)) {
            return [printOpeningTagPrefix(child, options), ...replaceTextEndOfLine(options.originalText.slice(locStart(child) + (child.prev && needsToBorrowNextOpeningTagStartMarker(child.prev) ? printOpeningTagStartMarker(child).length : 0), locEnd(child) - (child.next && needsToBorrowPrevClosingTagEndMarker(child.next) ? printClosingTagEndMarker(child, options).length : 0))), printClosingTagSuffix(child, options)];
          }
          return print();
        }
        function printBetweenLine(prevNode, nextNode) {
          return isTextLikeNode(prevNode) && isTextLikeNode(nextNode) ? prevNode.isTrailingSpaceSensitive ? prevNode.hasTrailingSpaces ? preferHardlineAsLeadingSpaces(nextNode) ? hardline : line : "" : preferHardlineAsLeadingSpaces(nextNode) ? hardline : softline : needsToBorrowNextOpeningTagStartMarker(prevNode) && (hasPrettierIgnore(nextNode) || nextNode.firstChild || nextNode.isSelfClosing || nextNode.type === "element" && nextNode.attrs.length > 0) || prevNode.type === "element" && prevNode.isSelfClosing && needsToBorrowPrevClosingTagEndMarker(nextNode) ? "" : !nextNode.isLeadingSpaceSensitive || preferHardlineAsLeadingSpaces(nextNode) || needsToBorrowPrevClosingTagEndMarker(nextNode) && prevNode.lastChild && needsToBorrowParentClosingTagStartMarker(prevNode.lastChild) && prevNode.lastChild.lastChild && needsToBorrowParentClosingTagStartMarker(prevNode.lastChild.lastChild) ? hardline : nextNode.hasLeadingSpaces ? line : softline;
        }
        function printChildren(path5, options, print) {
          const node = path5.getValue();
          if (forceBreakChildren(node)) {
            return [breakParent, ...path5.map((childPath) => {
              const childNode = childPath.getValue();
              const prevBetweenLine = !childNode.prev ? "" : printBetweenLine(childNode.prev, childNode);
              return [!prevBetweenLine ? "" : [prevBetweenLine, forceNextEmptyLine(childNode.prev) ? hardline : ""], printChild(childPath, options, print)];
            }, "children")];
          }
          const groupIds = node.children.map(() => Symbol(""));
          return path5.map((childPath, childIndex) => {
            const childNode = childPath.getValue();
            if (isTextLikeNode(childNode)) {
              if (childNode.prev && isTextLikeNode(childNode.prev)) {
                const prevBetweenLine2 = printBetweenLine(childNode.prev, childNode);
                if (prevBetweenLine2) {
                  if (forceNextEmptyLine(childNode.prev)) {
                    return [hardline, hardline, printChild(childPath, options, print)];
                  }
                  return [prevBetweenLine2, printChild(childPath, options, print)];
                }
              }
              return printChild(childPath, options, print);
            }
            const prevParts = [];
            const leadingParts = [];
            const trailingParts = [];
            const nextParts = [];
            const prevBetweenLine = childNode.prev ? printBetweenLine(childNode.prev, childNode) : "";
            const nextBetweenLine = childNode.next ? printBetweenLine(childNode, childNode.next) : "";
            if (prevBetweenLine) {
              if (forceNextEmptyLine(childNode.prev)) {
                prevParts.push(hardline, hardline);
              } else if (prevBetweenLine === hardline) {
                prevParts.push(hardline);
              } else {
                if (isTextLikeNode(childNode.prev)) {
                  leadingParts.push(prevBetweenLine);
                } else {
                  leadingParts.push(ifBreak("", softline, {
                    groupId: groupIds[childIndex - 1]
                  }));
                }
              }
            }
            if (nextBetweenLine) {
              if (forceNextEmptyLine(childNode)) {
                if (isTextLikeNode(childNode.next)) {
                  nextParts.push(hardline, hardline);
                }
              } else if (nextBetweenLine === hardline) {
                if (isTextLikeNode(childNode.next)) {
                  nextParts.push(hardline);
                }
              } else {
                trailingParts.push(nextBetweenLine);
              }
            }
            return [...prevParts, group([...leadingParts, group([printChild(childPath, options, print), ...trailingParts], {
              id: groupIds[childIndex]
            })]), ...nextParts];
          }, "children");
        }
        module22.exports = {
          printChildren
        };
      }
    });
    var require_element = __commonJS22({
      "src/language-html/print/element.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            breakParent,
            dedentToRoot,
            group,
            ifBreak,
            indentIfBreak,
            indent,
            line,
            softline
          },
          utils: {
            replaceTextEndOfLine
          }
        } = require_doc();
        var getNodeContent = require_get_node_content();
        var {
          shouldPreserveContent,
          isScriptLikeTag,
          isVueCustomBlock,
          countParents,
          forceBreakContent
        } = require_utils11();
        var {
          printOpeningTagPrefix,
          printOpeningTag,
          printClosingTagSuffix,
          printClosingTag,
          needsToBorrowPrevClosingTagEndMarker,
          needsToBorrowLastChildClosingTagEndMarker
        } = require_tag();
        var {
          printChildren
        } = require_children();
        function printElement(path5, options, print) {
          const node = path5.getValue();
          if (shouldPreserveContent(node, options)) {
            return [printOpeningTagPrefix(node, options), group(printOpeningTag(path5, options, print)), ...replaceTextEndOfLine(getNodeContent(node, options)), ...printClosingTag(node, options), printClosingTagSuffix(node, options)];
          }
          const shouldHugContent = node.children.length === 1 && node.firstChild.type === "interpolation" && node.firstChild.isLeadingSpaceSensitive && !node.firstChild.hasLeadingSpaces && node.lastChild.isTrailingSpaceSensitive && !node.lastChild.hasTrailingSpaces;
          const attrGroupId = Symbol("element-attr-group-id");
          const printTag = (doc2) => group([group(printOpeningTag(path5, options, print), {
            id: attrGroupId
          }), doc2, printClosingTag(node, options)]);
          const printChildrenDoc = (childrenDoc) => {
            if (shouldHugContent) {
              return indentIfBreak(childrenDoc, {
                groupId: attrGroupId
              });
            }
            if ((isScriptLikeTag(node) || isVueCustomBlock(node, options)) && node.parent.type === "root" && options.parser === "vue" && !options.vueIndentScriptAndStyle) {
              return childrenDoc;
            }
            return indent(childrenDoc);
          };
          const printLineBeforeChildren = () => {
            if (shouldHugContent) {
              return ifBreak(softline, "", {
                groupId: attrGroupId
              });
            }
            if (node.firstChild.hasLeadingSpaces && node.firstChild.isLeadingSpaceSensitive) {
              return line;
            }
            if (node.firstChild.type === "text" && node.isWhitespaceSensitive && node.isIndentationSensitive) {
              return dedentToRoot(softline);
            }
            return softline;
          };
          const printLineAfterChildren = () => {
            const needsToBorrow = node.next ? needsToBorrowPrevClosingTagEndMarker(node.next) : needsToBorrowLastChildClosingTagEndMarker(node.parent);
            if (needsToBorrow) {
              if (node.lastChild.hasTrailingSpaces && node.lastChild.isTrailingSpaceSensitive) {
                return " ";
              }
              return "";
            }
            if (shouldHugContent) {
              return ifBreak(softline, "", {
                groupId: attrGroupId
              });
            }
            if (node.lastChild.hasTrailingSpaces && node.lastChild.isTrailingSpaceSensitive) {
              return line;
            }
            if ((node.lastChild.type === "comment" || node.lastChild.type === "text" && node.isWhitespaceSensitive && node.isIndentationSensitive) && new RegExp(`\\n[\\t ]{${options.tabWidth * countParents(path5, (node2) => node2.parent && node2.parent.type !== "root")}}$`).test(node.lastChild.value)) {
              return "";
            }
            return softline;
          };
          if (node.children.length === 0) {
            return printTag(node.hasDanglingSpaces && node.isDanglingSpaceSensitive ? line : "");
          }
          return printTag([forceBreakContent(node) ? breakParent : "", printChildrenDoc([printLineBeforeChildren(), printChildren(path5, options, print)]), printLineAfterChildren()]);
        }
        module22.exports = {
          printElement
        };
      }
    });
    var require_printer_html = __commonJS22({
      "src/language-html/printer-html.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            fill,
            group,
            hardline,
            literalline
          },
          utils: {
            cleanDoc,
            getDocParts,
            isConcat,
            replaceTextEndOfLine
          }
        } = require_doc();
        var clean = require_clean5();
        var {
          countChars,
          unescapeQuoteEntities,
          getTextValueParts
        } = require_utils11();
        var preprocess = require_print_preprocess3();
        var {
          insertPragma
        } = require_pragma5();
        var {
          locStart,
          locEnd
        } = require_loc6();
        var embed = require_embed4();
        var {
          printClosingTagSuffix,
          printClosingTagEnd,
          printOpeningTagPrefix,
          printOpeningTagStart
        } = require_tag();
        var {
          printElement
        } = require_element();
        var {
          printChildren
        } = require_children();
        function genericPrint(path5, options, print) {
          const node = path5.getValue();
          switch (node.type) {
            case "front-matter":
              return replaceTextEndOfLine(node.raw);
            case "root":
              if (options.__onHtmlRoot) {
                options.__onHtmlRoot(node);
              }
              return [group(printChildren(path5, options, print)), hardline];
            case "element":
            case "ieConditionalComment": {
              return printElement(path5, options, print);
            }
            case "ieConditionalStartComment":
            case "ieConditionalEndComment":
              return [printOpeningTagStart(node), printClosingTagEnd(node)];
            case "interpolation":
              return [printOpeningTagStart(node, options), ...path5.map(print, "children"), printClosingTagEnd(node, options)];
            case "text": {
              if (node.parent.type === "interpolation") {
                const trailingNewlineRegex = /\n[^\S\n]*$/;
                const hasTrailingNewline = trailingNewlineRegex.test(node.value);
                const value = hasTrailingNewline ? node.value.replace(trailingNewlineRegex, "") : node.value;
                return [...replaceTextEndOfLine(value), hasTrailingNewline ? hardline : ""];
              }
              const printed = cleanDoc([printOpeningTagPrefix(node, options), ...getTextValueParts(node), printClosingTagSuffix(node, options)]);
              if (isConcat(printed) || printed.type === "fill") {
                return fill(getDocParts(printed));
              }
              return printed;
            }
            case "docType":
              return [group([printOpeningTagStart(node, options), " ", node.value.replace(/^html\b/i, "html").replace(/\s+/g, " ")]), printClosingTagEnd(node, options)];
            case "comment": {
              return [printOpeningTagPrefix(node, options), ...replaceTextEndOfLine(options.originalText.slice(locStart(node), locEnd(node)), literalline), printClosingTagSuffix(node, options)];
            }
            case "attribute": {
              if (node.value === null) {
                return node.rawName;
              }
              const value = unescapeQuoteEntities(node.value);
              const singleQuoteCount = countChars(value, "'");
              const doubleQuoteCount = countChars(value, '"');
              const quote = singleQuoteCount < doubleQuoteCount ? "'" : '"';
              return [node.rawName, "=", quote, ...replaceTextEndOfLine(quote === '"' ? value.replace(/"/g, "&quot;") : value.replace(/'/g, "&apos;")), quote];
            }
            default:
              throw new Error(`Unexpected node type ${node.type}`);
          }
        }
        module22.exports = {
          preprocess,
          print: genericPrint,
          insertPragma,
          massageAstNode: clean,
          embed
        };
      }
    });
    var require_options6 = __commonJS22({
      "src/language-html/options.js"(exports22, module22) {
        "use strict";
        var commonOptions = require_common_options();
        var CATEGORY_HTML = "HTML";
        module22.exports = {
          bracketSameLine: commonOptions.bracketSameLine,
          htmlWhitespaceSensitivity: {
            since: "1.15.0",
            category: CATEGORY_HTML,
            type: "choice",
            default: "css",
            description: "How to handle whitespaces in HTML.",
            choices: [{
              value: "css",
              description: "Respect the default value of CSS display property."
            }, {
              value: "strict",
              description: "Whitespaces are considered sensitive."
            }, {
              value: "ignore",
              description: "Whitespaces are considered insensitive."
            }]
          },
          singleAttributePerLine: commonOptions.singleAttributePerLine,
          vueIndentScriptAndStyle: {
            since: "1.19.0",
            category: CATEGORY_HTML,
            type: "boolean",
            default: false,
            description: "Indent script and style tags in Vue files."
          }
        };
      }
    });
    var require_parsers6 = __commonJS22({
      "src/language-html/parsers.js"(exports22, module22) {
        "use strict";
        module22.exports = {
          get html() {
            return require_parser_html().parsers.html;
          },
          get vue() {
            return require_parser_html().parsers.vue;
          },
          get angular() {
            return require_parser_html().parsers.angular;
          },
          get lwc() {
            return require_parser_html().parsers.lwc;
          }
        };
      }
    });
    var require_HTML = __commonJS22({
      "node_modules/linguist-languages/data/HTML.json"(exports22, module22) {
        module22.exports = {
          name: "HTML",
          type: "markup",
          tmScope: "text.html.basic",
          aceMode: "html",
          codemirrorMode: "htmlmixed",
          codemirrorMimeType: "text/html",
          color: "#e34c26",
          aliases: ["xhtml"],
          extensions: [".html", ".hta", ".htm", ".html.hl", ".inc", ".xht", ".xhtml"],
          languageId: 146
        };
      }
    });
    var require_Vue = __commonJS22({
      "node_modules/linguist-languages/data/Vue.json"(exports22, module22) {
        module22.exports = {
          name: "Vue",
          type: "markup",
          color: "#41b883",
          extensions: [".vue"],
          tmScope: "text.html.vue",
          aceMode: "html",
          languageId: 391
        };
      }
    });
    var require_language_html = __commonJS22({
      "src/language-html/index.js"(exports22, module22) {
        "use strict";
        var createLanguage = require_create_language();
        var printer = require_printer_html();
        var options = require_options6();
        var parsers = require_parsers6();
        var languages = [createLanguage(require_HTML(), () => ({
          name: "Angular",
          since: "1.15.0",
          parsers: ["angular"],
          vscodeLanguageIds: ["html"],
          extensions: [".component.html"],
          filenames: []
        })), createLanguage(require_HTML(), (data) => ({
          since: "1.15.0",
          parsers: ["html"],
          vscodeLanguageIds: ["html"],
          extensions: [...data.extensions, ".mjml"]
        })), createLanguage(require_HTML(), () => ({
          name: "Lightning Web Components",
          since: "1.17.0",
          parsers: ["lwc"],
          vscodeLanguageIds: ["html"],
          extensions: [],
          filenames: []
        })), createLanguage(require_Vue(), () => ({
          since: "1.10.0",
          parsers: ["vue"],
          vscodeLanguageIds: ["vue"]
        }))];
        var printers = {
          html: printer
        };
        module22.exports = {
          languages,
          printers,
          options,
          parsers
        };
      }
    });
    var require_pragma6 = __commonJS22({
      "src/language-yaml/pragma.js"(exports22, module22) {
        "use strict";
        function isPragma(text) {
          return /^\s*@(?:prettier|format)\s*$/.test(text);
        }
        function hasPragma(text) {
          return /^\s*#[^\S\n]*@(?:prettier|format)\s*?(?:\n|$)/.test(text);
        }
        function insertPragma(text) {
          return `# @format

${text}`;
        }
        module22.exports = {
          isPragma,
          hasPragma,
          insertPragma
        };
      }
    });
    var require_loc7 = __commonJS22({
      "src/language-yaml/loc.js"(exports22, module22) {
        "use strict";
        function locStart(node) {
          return node.position.start.offset;
        }
        function locEnd(node) {
          return node.position.end.offset;
        }
        module22.exports = {
          locStart,
          locEnd
        };
      }
    });
    var require_embed5 = __commonJS22({
      "src/language-yaml/embed.js"(exports22, module22) {
        "use strict";
        function embed(path5, print, textToDoc, options) {
          const node = path5.getValue();
          if (node.type === "root" && options.filepath && /(?:[/\\]|^)\.(?:prettier|stylelint)rc$/.test(options.filepath)) {
            return textToDoc(options.originalText, Object.assign(Object.assign({}, options), {}, {
              parser: "json"
            }));
          }
        }
        module22.exports = embed;
      }
    });
    var require_utils12 = __commonJS22({
      "src/language-yaml/utils.js"(exports22, module22) {
        "use strict";
        var {
          getLast,
          isNonEmptyArray
        } = require_util2();
        function getAncestorCount(path5, filter) {
          let counter = 0;
          const pathStackLength = path5.stack.length - 1;
          for (let i = 0; i < pathStackLength; i++) {
            const value = path5.stack[i];
            if (isNode(value) && filter(value)) {
              counter++;
            }
          }
          return counter;
        }
        function isNode(value, types2) {
          return value && typeof value.type === "string" && (!types2 || types2.includes(value.type));
        }
        function mapNode(node, callback, parent) {
          return callback("children" in node ? Object.assign(Object.assign({}, node), {}, {
            children: node.children.map((childNode) => mapNode(childNode, callback, node))
          }) : node, parent);
        }
        function defineShortcut(x, key, getter) {
          Object.defineProperty(x, key, {
            get: getter,
            enumerable: false
          });
        }
        function isNextLineEmpty(node, text) {
          let newlineCount = 0;
          const textLength = text.length;
          for (let i = node.position.end.offset - 1; i < textLength; i++) {
            const char = text[i];
            if (char === "\n") {
              newlineCount++;
            }
            if (newlineCount === 1 && /\S/.test(char)) {
              return false;
            }
            if (newlineCount === 2) {
              return true;
            }
          }
          return false;
        }
        function isLastDescendantNode(path5) {
          const node = path5.getValue();
          switch (node.type) {
            case "tag":
            case "anchor":
            case "comment":
              return false;
          }
          const pathStackLength = path5.stack.length;
          for (let i = 1; i < pathStackLength; i++) {
            const item = path5.stack[i];
            const parentItem = path5.stack[i - 1];
            if (Array.isArray(parentItem) && typeof item === "number" && item !== parentItem.length - 1) {
              return false;
            }
          }
          return true;
        }
        function getLastDescendantNode(node) {
          return isNonEmptyArray(node.children) ? getLastDescendantNode(getLast(node.children)) : node;
        }
        function isPrettierIgnore(comment) {
          return comment.value.trim() === "prettier-ignore";
        }
        function hasPrettierIgnore(path5) {
          const node = path5.getValue();
          if (node.type === "documentBody") {
            const document2 = path5.getParentNode();
            return hasEndComments(document2.head) && isPrettierIgnore(getLast(document2.head.endComments));
          }
          return hasLeadingComments(node) && isPrettierIgnore(getLast(node.leadingComments));
        }
        function isEmptyNode(node) {
          return !isNonEmptyArray(node.children) && !hasComments(node);
        }
        function hasComments(node) {
          return hasLeadingComments(node) || hasMiddleComments(node) || hasIndicatorComment(node) || hasTrailingComment(node) || hasEndComments(node);
        }
        function hasLeadingComments(node) {
          return isNonEmptyArray(node === null || node === void 0 ? void 0 : node.leadingComments);
        }
        function hasMiddleComments(node) {
          return isNonEmptyArray(node === null || node === void 0 ? void 0 : node.middleComments);
        }
        function hasIndicatorComment(node) {
          return node === null || node === void 0 ? void 0 : node.indicatorComment;
        }
        function hasTrailingComment(node) {
          return node === null || node === void 0 ? void 0 : node.trailingComment;
        }
        function hasEndComments(node) {
          return isNonEmptyArray(node === null || node === void 0 ? void 0 : node.endComments);
        }
        function splitWithSingleSpace(text) {
          const parts = [];
          let lastPart;
          for (const part of text.split(/( +)/)) {
            if (part !== " ") {
              if (lastPart === " ") {
                parts.push(part);
              } else {
                parts.push((parts.pop() || "") + part);
              }
            } else if (lastPart === void 0) {
              parts.unshift("");
            }
            lastPart = part;
          }
          if (lastPart === " ") {
            parts.push((parts.pop() || "") + " ");
          }
          if (parts[0] === "") {
            parts.shift();
            parts.unshift(" " + (parts.shift() || ""));
          }
          return parts;
        }
        function getFlowScalarLineContents(nodeType, content, options) {
          const rawLineContents = content.split("\n").map((lineContent, index, lineContents) => index === 0 && index === lineContents.length - 1 ? lineContent : index !== 0 && index !== lineContents.length - 1 ? lineContent.trim() : index === 0 ? lineContent.trimEnd() : lineContent.trimStart());
          if (options.proseWrap === "preserve") {
            return rawLineContents.map((lineContent) => lineContent.length === 0 ? [] : [lineContent]);
          }
          return rawLineContents.map((lineContent) => lineContent.length === 0 ? [] : splitWithSingleSpace(lineContent)).reduce((reduced, lineContentWords, index) => index !== 0 && rawLineContents[index - 1].length > 0 && lineContentWords.length > 0 && !(nodeType === "quoteDouble" && getLast(getLast(reduced)).endsWith("\\")) ? [...reduced.slice(0, -1), [...getLast(reduced), ...lineContentWords]] : [...reduced, lineContentWords], []).map((lineContentWords) => options.proseWrap === "never" ? [lineContentWords.join(" ")] : lineContentWords);
        }
        function getBlockValueLineContents(node, {
          parentIndent,
          isLastDescendant,
          options
        }) {
          const content = node.position.start.line === node.position.end.line ? "" : options.originalText.slice(node.position.start.offset, node.position.end.offset).match(/^[^\n]*\n(.*)$/s)[1];
          let leadingSpaceCount;
          if (node.indent === null) {
            const matches = content.match(/^(?<leadingSpace> *)[^\n\r ]/m);
            leadingSpaceCount = matches ? matches.groups.leadingSpace.length : Number.POSITIVE_INFINITY;
          } else {
            leadingSpaceCount = node.indent - 1 + parentIndent;
          }
          const rawLineContents = content.split("\n").map((lineContent) => lineContent.slice(leadingSpaceCount));
          if (options.proseWrap === "preserve" || node.type === "blockLiteral") {
            return removeUnnecessaryTrailingNewlines(rawLineContents.map((lineContent) => lineContent.length === 0 ? [] : [lineContent]));
          }
          return removeUnnecessaryTrailingNewlines(rawLineContents.map((lineContent) => lineContent.length === 0 ? [] : splitWithSingleSpace(lineContent)).reduce((reduced, lineContentWords, index) => index !== 0 && rawLineContents[index - 1].length > 0 && lineContentWords.length > 0 && !/^\s/.test(lineContentWords[0]) && !/^\s|\s$/.test(getLast(reduced)) ? [...reduced.slice(0, -1), [...getLast(reduced), ...lineContentWords]] : [...reduced, lineContentWords], []).map((lineContentWords) => lineContentWords.reduce((reduced, word) => reduced.length > 0 && /\s$/.test(getLast(reduced)) ? [...reduced.slice(0, -1), getLast(reduced) + " " + word] : [...reduced, word], [])).map((lineContentWords) => options.proseWrap === "never" ? [lineContentWords.join(" ")] : lineContentWords));
          function removeUnnecessaryTrailingNewlines(lineContents) {
            if (node.chomping === "keep") {
              return getLast(lineContents).length === 0 ? lineContents.slice(0, -1) : lineContents;
            }
            let trailingNewlineCount = 0;
            for (let i = lineContents.length - 1; i >= 0; i--) {
              if (lineContents[i].length === 0) {
                trailingNewlineCount++;
              } else {
                break;
              }
            }
            return trailingNewlineCount === 0 ? lineContents : trailingNewlineCount >= 2 && !isLastDescendant ? lineContents.slice(0, -(trailingNewlineCount - 1)) : lineContents.slice(0, -trailingNewlineCount);
          }
        }
        function isInlineNode(node) {
          if (!node) {
            return true;
          }
          switch (node.type) {
            case "plain":
            case "quoteDouble":
            case "quoteSingle":
            case "alias":
            case "flowMapping":
            case "flowSequence":
              return true;
            default:
              return false;
          }
        }
        module22.exports = {
          getLast,
          getAncestorCount,
          isNode,
          isEmptyNode,
          isInlineNode,
          mapNode,
          defineShortcut,
          isNextLineEmpty,
          isLastDescendantNode,
          getBlockValueLineContents,
          getFlowScalarLineContents,
          getLastDescendantNode,
          hasPrettierIgnore,
          hasLeadingComments,
          hasMiddleComments,
          hasIndicatorComment,
          hasTrailingComment,
          hasEndComments
        };
      }
    });
    var require_print_preprocess4 = __commonJS22({
      "src/language-yaml/print-preprocess.js"(exports22, module22) {
        "use strict";
        var {
          defineShortcut,
          mapNode
        } = require_utils12();
        function preprocess(ast) {
          return mapNode(ast, defineShortcuts);
        }
        function defineShortcuts(node) {
          switch (node.type) {
            case "document":
              defineShortcut(node, "head", () => node.children[0]);
              defineShortcut(node, "body", () => node.children[1]);
              break;
            case "documentBody":
            case "sequenceItem":
            case "flowSequenceItem":
            case "mappingKey":
            case "mappingValue":
              defineShortcut(node, "content", () => node.children[0]);
              break;
            case "mappingItem":
            case "flowMappingItem":
              defineShortcut(node, "key", () => node.children[0]);
              defineShortcut(node, "value", () => node.children[1]);
              break;
          }
          return node;
        }
        module22.exports = preprocess;
      }
    });
    var require_misc2 = __commonJS22({
      "src/language-yaml/print/misc.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            softline,
            align
          }
        } = require_doc();
        var {
          hasEndComments,
          isNextLineEmpty,
          isNode
        } = require_utils12();
        var printedEmptyLineCache = /* @__PURE__ */ new WeakMap();
        function printNextEmptyLine(path5, originalText) {
          const node = path5.getValue();
          const root2 = path5.stack[0];
          let isNextEmptyLinePrintedSet;
          if (printedEmptyLineCache.has(root2)) {
            isNextEmptyLinePrintedSet = printedEmptyLineCache.get(root2);
          } else {
            isNextEmptyLinePrintedSet = /* @__PURE__ */ new Set();
            printedEmptyLineCache.set(root2, isNextEmptyLinePrintedSet);
          }
          if (!isNextEmptyLinePrintedSet.has(node.position.end.line)) {
            isNextEmptyLinePrintedSet.add(node.position.end.line);
            if (isNextLineEmpty(node, originalText) && !shouldPrintEndComments(path5.getParentNode())) {
              return softline;
            }
          }
          return "";
        }
        function shouldPrintEndComments(node) {
          return hasEndComments(node) && !isNode(node, ["documentHead", "documentBody", "flowMapping", "flowSequence"]);
        }
        function alignWithSpaces(width, doc2) {
          return align(" ".repeat(width), doc2);
        }
        module22.exports = {
          alignWithSpaces,
          shouldPrintEndComments,
          printNextEmptyLine
        };
      }
    });
    var require_flow_mapping_sequence = __commonJS22({
      "src/language-yaml/print/flow-mapping-sequence.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            ifBreak,
            line,
            softline,
            hardline,
            join: join2
          }
        } = require_doc();
        var {
          isEmptyNode,
          getLast,
          hasEndComments
        } = require_utils12();
        var {
          printNextEmptyLine,
          alignWithSpaces
        } = require_misc2();
        function printFlowMapping(path5, print, options) {
          const node = path5.getValue();
          const isMapping = node.type === "flowMapping";
          const openMarker = isMapping ? "{" : "[";
          const closeMarker = isMapping ? "}" : "]";
          let bracketSpacing = softline;
          if (isMapping && node.children.length > 0 && options.bracketSpacing) {
            bracketSpacing = line;
          }
          const lastItem = getLast(node.children);
          const isLastItemEmptyMappingItem = lastItem && lastItem.type === "flowMappingItem" && isEmptyNode(lastItem.key) && isEmptyNode(lastItem.value);
          return [openMarker, alignWithSpaces(options.tabWidth, [bracketSpacing, printChildren(path5, print, options), options.trailingComma === "none" ? "" : ifBreak(","), hasEndComments(node) ? [hardline, join2(hardline, path5.map(print, "endComments"))] : ""]), isLastItemEmptyMappingItem ? "" : bracketSpacing, closeMarker];
        }
        function printChildren(path5, print, options) {
          const node = path5.getValue();
          const parts = path5.map((childPath, index) => [print(), index === node.children.length - 1 ? "" : [",", line, node.children[index].position.start.line !== node.children[index + 1].position.start.line ? printNextEmptyLine(childPath, options.originalText) : ""]], "children");
          return parts;
        }
        module22.exports = {
          printFlowMapping,
          printFlowSequence: printFlowMapping
        };
      }
    });
    var require_mapping_item = __commonJS22({
      "src/language-yaml/print/mapping-item.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            conditionalGroup,
            group,
            hardline,
            ifBreak,
            join: join2,
            line
          }
        } = require_doc();
        var {
          hasLeadingComments,
          hasMiddleComments,
          hasTrailingComment,
          hasEndComments,
          isNode,
          isEmptyNode,
          isInlineNode
        } = require_utils12();
        var {
          alignWithSpaces
        } = require_misc2();
        function printMappingItem(node, parentNode, path5, print, options) {
          const {
            key,
            value
          } = node;
          const isEmptyMappingKey = isEmptyNode(key);
          const isEmptyMappingValue = isEmptyNode(value);
          if (isEmptyMappingKey && isEmptyMappingValue) {
            return ": ";
          }
          const printedKey = print("key");
          const spaceBeforeColon = needsSpaceInFrontOfMappingValue(node) ? " " : "";
          if (isEmptyMappingValue) {
            if (node.type === "flowMappingItem" && parentNode.type === "flowMapping") {
              return printedKey;
            }
            if (node.type === "mappingItem" && isAbsolutelyPrintedAsSingleLineNode(key.content, options) && !hasTrailingComment(key.content) && (!parentNode.tag || parentNode.tag.value !== "tag:yaml.org,2002:set")) {
              return [printedKey, spaceBeforeColon, ":"];
            }
            return ["? ", alignWithSpaces(2, printedKey)];
          }
          const printedValue = print("value");
          if (isEmptyMappingKey) {
            return [": ", alignWithSpaces(2, printedValue)];
          }
          if (hasLeadingComments(value) || !isInlineNode(key.content)) {
            return ["? ", alignWithSpaces(2, printedKey), hardline, join2("", path5.map(print, "value", "leadingComments").map((comment) => [comment, hardline])), ": ", alignWithSpaces(2, printedValue)];
          }
          if (isSingleLineNode(key.content) && !hasLeadingComments(key.content) && !hasMiddleComments(key.content) && !hasTrailingComment(key.content) && !hasEndComments(key) && !hasLeadingComments(value.content) && !hasMiddleComments(value.content) && !hasEndComments(value) && isAbsolutelyPrintedAsSingleLineNode(value.content, options)) {
            return [printedKey, spaceBeforeColon, ": ", printedValue];
          }
          const groupId = Symbol("mappingKey");
          const groupedKey = group([ifBreak("? "), group(alignWithSpaces(2, printedKey), {
            id: groupId
          })]);
          const explicitMappingValue = [hardline, ": ", alignWithSpaces(2, printedValue)];
          const implicitMappingValueParts = [spaceBeforeColon, ":"];
          if (hasLeadingComments(value.content) || hasEndComments(value) && value.content && !isNode(value.content, ["mapping", "sequence"]) || parentNode.type === "mapping" && hasTrailingComment(key.content) && isInlineNode(value.content) || isNode(value.content, ["mapping", "sequence"]) && value.content.tag === null && value.content.anchor === null) {
            implicitMappingValueParts.push(hardline);
          } else if (value.content) {
            implicitMappingValueParts.push(line);
          }
          implicitMappingValueParts.push(printedValue);
          const implicitMappingValue = alignWithSpaces(options.tabWidth, implicitMappingValueParts);
          if (isAbsolutelyPrintedAsSingleLineNode(key.content, options) && !hasLeadingComments(key.content) && !hasMiddleComments(key.content) && !hasEndComments(key)) {
            return conditionalGroup([[printedKey, implicitMappingValue]]);
          }
          return conditionalGroup([[groupedKey, ifBreak(explicitMappingValue, implicitMappingValue, {
            groupId
          })]]);
        }
        function isAbsolutelyPrintedAsSingleLineNode(node, options) {
          if (!node) {
            return true;
          }
          switch (node.type) {
            case "plain":
            case "quoteSingle":
            case "quoteDouble":
              break;
            case "alias":
              return true;
            default:
              return false;
          }
          if (options.proseWrap === "preserve") {
            return node.position.start.line === node.position.end.line;
          }
          if (/\\$/m.test(options.originalText.slice(node.position.start.offset, node.position.end.offset))) {
            return false;
          }
          switch (options.proseWrap) {
            case "never":
              return !node.value.includes("\n");
            case "always":
              return !/[\n ]/.test(node.value);
            default:
              return false;
          }
        }
        function needsSpaceInFrontOfMappingValue(node) {
          return node.key.content && node.key.content.type === "alias";
        }
        function isSingleLineNode(node) {
          if (!node) {
            return true;
          }
          switch (node.type) {
            case "plain":
            case "quoteDouble":
            case "quoteSingle":
              return node.position.start.line === node.position.end.line;
            case "alias":
              return true;
            default:
              return false;
          }
        }
        module22.exports = printMappingItem;
      }
    });
    var require_block2 = __commonJS22({
      "src/language-yaml/print/block.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            dedent,
            dedentToRoot,
            fill,
            hardline,
            join: join2,
            line,
            literalline,
            markAsRoot
          },
          utils: {
            getDocParts
          }
        } = require_doc();
        var {
          getAncestorCount,
          getBlockValueLineContents,
          hasIndicatorComment,
          isLastDescendantNode,
          isNode
        } = require_utils12();
        var {
          alignWithSpaces
        } = require_misc2();
        function printBlock(path5, print, options) {
          const node = path5.getValue();
          const parentIndent = getAncestorCount(path5, (ancestorNode) => isNode(ancestorNode, ["sequence", "mapping"]));
          const isLastDescendant = isLastDescendantNode(path5);
          const parts = [node.type === "blockFolded" ? ">" : "|"];
          if (node.indent !== null) {
            parts.push(node.indent.toString());
          }
          if (node.chomping !== "clip") {
            parts.push(node.chomping === "keep" ? "+" : "-");
          }
          if (hasIndicatorComment(node)) {
            parts.push(" ", print("indicatorComment"));
          }
          const lineContents = getBlockValueLineContents(node, {
            parentIndent,
            isLastDescendant,
            options
          });
          const contentsParts = [];
          for (const [index, lineWords] of lineContents.entries()) {
            if (index === 0) {
              contentsParts.push(hardline);
            }
            contentsParts.push(fill(getDocParts(join2(line, lineWords))));
            if (index !== lineContents.length - 1) {
              contentsParts.push(lineWords.length === 0 ? hardline : markAsRoot(literalline));
            } else if (node.chomping === "keep" && isLastDescendant) {
              contentsParts.push(dedentToRoot(lineWords.length === 0 ? hardline : literalline));
            }
          }
          if (node.indent === null) {
            parts.push(dedent(alignWithSpaces(options.tabWidth, contentsParts)));
          } else {
            parts.push(dedentToRoot(alignWithSpaces(node.indent - 1 + parentIndent, contentsParts)));
          }
          return parts;
        }
        module22.exports = printBlock;
      }
    });
    var require_printer_yaml = __commonJS22({
      "src/language-yaml/printer-yaml.js"(exports22, module22) {
        "use strict";
        var {
          builders: {
            breakParent,
            fill,
            group,
            hardline,
            join: join2,
            line,
            lineSuffix,
            literalline
          },
          utils: {
            getDocParts,
            replaceTextEndOfLine
          }
        } = require_doc();
        var {
          isPreviousLineEmpty
        } = require_util2();
        var {
          insertPragma,
          isPragma
        } = require_pragma6();
        var {
          locStart
        } = require_loc7();
        var embed = require_embed5();
        var {
          getFlowScalarLineContents,
          getLastDescendantNode,
          hasLeadingComments,
          hasMiddleComments,
          hasTrailingComment,
          hasEndComments,
          hasPrettierIgnore,
          isLastDescendantNode,
          isNode,
          isInlineNode
        } = require_utils12();
        var preprocess = require_print_preprocess4();
        var {
          alignWithSpaces,
          printNextEmptyLine,
          shouldPrintEndComments
        } = require_misc2();
        var {
          printFlowMapping,
          printFlowSequence
        } = require_flow_mapping_sequence();
        var printMappingItem = require_mapping_item();
        var printBlock = require_block2();
        function genericPrint(path5, options, print) {
          const node = path5.getValue();
          const parts = [];
          if (node.type !== "mappingValue" && hasLeadingComments(node)) {
            parts.push([join2(hardline, path5.map(print, "leadingComments")), hardline]);
          }
          const {
            tag,
            anchor
          } = node;
          if (tag) {
            parts.push(print("tag"));
          }
          if (tag && anchor) {
            parts.push(" ");
          }
          if (anchor) {
            parts.push(print("anchor"));
          }
          let nextEmptyLine = "";
          if (isNode(node, ["mapping", "sequence", "comment", "directive", "mappingItem", "sequenceItem"]) && !isLastDescendantNode(path5)) {
            nextEmptyLine = printNextEmptyLine(path5, options.originalText);
          }
          if (tag || anchor) {
            if (isNode(node, ["sequence", "mapping"]) && !hasMiddleComments(node)) {
              parts.push(hardline);
            } else {
              parts.push(" ");
            }
          }
          if (hasMiddleComments(node)) {
            parts.push([node.middleComments.length === 1 ? "" : hardline, join2(hardline, path5.map(print, "middleComments")), hardline]);
          }
          const parentNode = path5.getParentNode();
          if (hasPrettierIgnore(path5)) {
            parts.push(replaceTextEndOfLine(options.originalText.slice(node.position.start.offset, node.position.end.offset).trimEnd(), literalline));
          } else {
            parts.push(group(printNode(node, parentNode, path5, options, print)));
          }
          if (hasTrailingComment(node) && !isNode(node, ["document", "documentHead"])) {
            parts.push(lineSuffix([node.type === "mappingValue" && !node.content ? "" : " ", parentNode.type === "mappingKey" && path5.getParentNode(2).type === "mapping" && isInlineNode(node) ? "" : breakParent, print("trailingComment")]));
          }
          if (shouldPrintEndComments(node)) {
            parts.push(alignWithSpaces(node.type === "sequenceItem" ? 2 : 0, [hardline, join2(hardline, path5.map((path22) => [isPreviousLineEmpty(options.originalText, path22.getValue(), locStart) ? hardline : "", print()], "endComments"))]));
          }
          parts.push(nextEmptyLine);
          return parts;
        }
        function printNode(node, parentNode, path5, options, print) {
          switch (node.type) {
            case "root": {
              const {
                children
              } = node;
              const parts = [];
              path5.each((childPath, index) => {
                const document2 = children[index];
                const nextDocument = children[index + 1];
                if (index !== 0) {
                  parts.push(hardline);
                }
                parts.push(print());
                if (shouldPrintDocumentEndMarker(document2, nextDocument)) {
                  parts.push(hardline, "...");
                  if (hasTrailingComment(document2)) {
                    parts.push(" ", print("trailingComment"));
                  }
                } else if (nextDocument && !hasTrailingComment(nextDocument.head)) {
                  parts.push(hardline, "---");
                }
              }, "children");
              const lastDescendantNode = getLastDescendantNode(node);
              if (!isNode(lastDescendantNode, ["blockLiteral", "blockFolded"]) || lastDescendantNode.chomping !== "keep") {
                parts.push(hardline);
              }
              return parts;
            }
            case "document": {
              const nextDocument = parentNode.children[path5.getName() + 1];
              const parts = [];
              if (shouldPrintDocumentHeadEndMarker(node, nextDocument, parentNode, options) === "head") {
                if (node.head.children.length > 0 || node.head.endComments.length > 0) {
                  parts.push(print("head"));
                }
                if (hasTrailingComment(node.head)) {
                  parts.push(["---", " ", print(["head", "trailingComment"])]);
                } else {
                  parts.push("---");
                }
              }
              if (shouldPrintDocumentBody(node)) {
                parts.push(print("body"));
              }
              return join2(hardline, parts);
            }
            case "documentHead":
              return join2(hardline, [...path5.map(print, "children"), ...path5.map(print, "endComments")]);
            case "documentBody": {
              const {
                children,
                endComments
              } = node;
              let separator = "";
              if (children.length > 0 && endComments.length > 0) {
                const lastDescendantNode = getLastDescendantNode(node);
                if (isNode(lastDescendantNode, ["blockFolded", "blockLiteral"])) {
                  if (lastDescendantNode.chomping !== "keep") {
                    separator = [hardline, hardline];
                  }
                } else {
                  separator = hardline;
                }
              }
              return [join2(hardline, path5.map(print, "children")), separator, join2(hardline, path5.map(print, "endComments"))];
            }
            case "directive":
              return ["%", join2(" ", [node.name, ...node.parameters])];
            case "comment":
              return ["#", node.value];
            case "alias":
              return ["*", node.value];
            case "tag":
              return options.originalText.slice(node.position.start.offset, node.position.end.offset);
            case "anchor":
              return ["&", node.value];
            case "plain":
              return printFlowScalarContent(node.type, options.originalText.slice(node.position.start.offset, node.position.end.offset), options);
            case "quoteDouble":
            case "quoteSingle": {
              const singleQuote = "'";
              const doubleQuote = '"';
              const raw = options.originalText.slice(node.position.start.offset + 1, node.position.end.offset - 1);
              if (node.type === "quoteSingle" && raw.includes("\\") || node.type === "quoteDouble" && /\\[^"]/.test(raw)) {
                const originalQuote = node.type === "quoteDouble" ? doubleQuote : singleQuote;
                return [originalQuote, printFlowScalarContent(node.type, raw, options), originalQuote];
              }
              if (raw.includes(doubleQuote)) {
                return [singleQuote, printFlowScalarContent(node.type, node.type === "quoteDouble" ? raw.replace(/\\"/g, doubleQuote).replace(/'/g, singleQuote.repeat(2)) : raw, options), singleQuote];
              }
              if (raw.includes(singleQuote)) {
                return [doubleQuote, printFlowScalarContent(node.type, node.type === "quoteSingle" ? raw.replace(/''/g, singleQuote) : raw, options), doubleQuote];
              }
              const quote = options.singleQuote ? singleQuote : doubleQuote;
              return [quote, printFlowScalarContent(node.type, raw, options), quote];
            }
            case "blockFolded":
            case "blockLiteral": {
              return printBlock(path5, print, options);
            }
            case "mapping":
            case "sequence":
              return join2(hardline, path5.map(print, "children"));
            case "sequenceItem":
              return ["- ", alignWithSpaces(2, node.content ? print("content") : "")];
            case "mappingKey":
            case "mappingValue":
              return !node.content ? "" : print("content");
            case "mappingItem":
            case "flowMappingItem": {
              return printMappingItem(node, parentNode, path5, print, options);
            }
            case "flowMapping":
              return printFlowMapping(path5, print, options);
            case "flowSequence":
              return printFlowSequence(path5, print, options);
            case "flowSequenceItem":
              return print("content");
            default:
              throw new Error(`Unexpected node type ${node.type}`);
          }
        }
        function shouldPrintDocumentBody(document2) {
          return document2.body.children.length > 0 || hasEndComments(document2.body);
        }
        function shouldPrintDocumentEndMarker(document2, nextDocument) {
          return hasTrailingComment(document2) || nextDocument && (nextDocument.head.children.length > 0 || hasEndComments(nextDocument.head));
        }
        function shouldPrintDocumentHeadEndMarker(document2, nextDocument, root2, options) {
          if (root2.children[0] === document2 && /---(?:\s|$)/.test(options.originalText.slice(locStart(document2), locStart(document2) + 4)) || document2.head.children.length > 0 || hasEndComments(document2.head) || hasTrailingComment(document2.head)) {
            return "head";
          }
          if (shouldPrintDocumentEndMarker(document2, nextDocument)) {
            return false;
          }
          return nextDocument ? "root" : false;
        }
        function printFlowScalarContent(nodeType, content, options) {
          const lineContents = getFlowScalarLineContents(nodeType, content, options);
          return join2(hardline, lineContents.map((lineContentWords) => fill(getDocParts(join2(line, lineContentWords)))));
        }
        function clean(node, newNode) {
          if (isNode(newNode)) {
            delete newNode.position;
            switch (newNode.type) {
              case "comment":
                if (isPragma(newNode.value)) {
                  return null;
                }
                break;
              case "quoteDouble":
              case "quoteSingle":
                newNode.type = "quote";
                break;
            }
          }
        }
        module22.exports = {
          preprocess,
          embed,
          print: genericPrint,
          massageAstNode: clean,
          insertPragma
        };
      }
    });
    var require_options7 = __commonJS22({
      "src/language-yaml/options.js"(exports22, module22) {
        "use strict";
        var commonOptions = require_common_options();
        module22.exports = {
          bracketSpacing: commonOptions.bracketSpacing,
          singleQuote: commonOptions.singleQuote,
          proseWrap: commonOptions.proseWrap
        };
      }
    });
    var require_parsers7 = __commonJS22({
      "src/language-yaml/parsers.js"(exports22, module22) {
        "use strict";
        module22.exports = {
          get yaml() {
            return require_parser_yaml().parsers.yaml;
          }
        };
      }
    });
    var require_YAML = __commonJS22({
      "node_modules/linguist-languages/data/YAML.json"(exports22, module22) {
        module22.exports = {
          name: "YAML",
          type: "data",
          color: "#cb171e",
          tmScope: "source.yaml",
          aliases: ["yml"],
          extensions: [".yml", ".mir", ".reek", ".rviz", ".sublime-syntax", ".syntax", ".yaml", ".yaml-tmlanguage", ".yaml.sed", ".yml.mysql"],
          filenames: [".clang-format", ".clang-tidy", ".gemrc", "CITATION.cff", "glide.lock", "yarn.lock"],
          aceMode: "yaml",
          codemirrorMode: "yaml",
          codemirrorMimeType: "text/x-yaml",
          languageId: 407
        };
      }
    });
    var require_language_yaml = __commonJS22({
      "src/language-yaml/index.js"(exports22, module22) {
        "use strict";
        var createLanguage = require_create_language();
        var printer = require_printer_yaml();
        var options = require_options7();
        var parsers = require_parsers7();
        var languages = [createLanguage(require_YAML(), (data) => ({
          since: "1.14.0",
          parsers: ["yaml"],
          vscodeLanguageIds: ["yaml", "ansible", "home-assistant"],
          filenames: [...data.filenames.filter((filename) => filename !== "yarn.lock"), ".prettierrc", ".stylelintrc"]
        }))];
        module22.exports = {
          languages,
          printers: {
            yaml: printer
          },
          options,
          parsers
        };
      }
    });
    var require_languages = __commonJS22({
      "src/languages.js"(exports22, module22) {
        "use strict";
        module22.exports = [require_language_js(), require_language_css(), require_language_handlebars(), require_language_graphql(), require_language_markdown(), require_language_html(), require_language_yaml()];
      }
    });
    var require_load_plugins = __commonJS22({
      "src/common/load-plugins.js"(exports22, module22) {
        "use strict";
        var fs = require("fs");
        var path5 = require("path");
        var fastGlob = require_out4();
        var partition3 = require_partition();
        var uniqByKey = require_uniq_by_key();
        var internalPlugins = require_languages();
        var {
          default: mem2,
          memClear: memClear2
        } = (init_dist(), __toCommonJS2(dist_exports));
        var thirdParty = require_third_party();
        var resolve = require_resolve22();
        var memoizedLoad = mem2(load2, {
          cacheKey: JSON.stringify
        });
        var memoizedSearch = mem2(findPluginsInNodeModules);
        var clearCache = () => {
          memClear2(memoizedLoad);
          memClear2(memoizedSearch);
        };
        function load2(plugins2, pluginSearchDirs) {
          if (!plugins2) {
            plugins2 = [];
          }
          if (pluginSearchDirs === false) {
            pluginSearchDirs = [];
          } else {
            pluginSearchDirs = pluginSearchDirs || [];
            if (pluginSearchDirs.length === 0) {
              const autoLoadDir = thirdParty.findParentDir(__dirname, "node_modules");
              if (autoLoadDir) {
                pluginSearchDirs = [autoLoadDir];
              }
            }
          }
          const [externalPluginNames, externalPluginInstances] = partition3(plugins2, (plugin) => typeof plugin === "string");
          const externalManualLoadPluginInfos = externalPluginNames.map((pluginName) => {
            let requirePath;
            try {
              requirePath = resolve(path5.resolve(process.cwd(), pluginName));
            } catch {
              requirePath = resolve(pluginName, {
                paths: [process.cwd()]
              });
            }
            return {
              name: pluginName,
              requirePath
            };
          });
          const externalAutoLoadPluginInfos = pluginSearchDirs.flatMap((pluginSearchDir) => {
            const resolvedPluginSearchDir = path5.resolve(process.cwd(), pluginSearchDir);
            const nodeModulesDir = path5.resolve(resolvedPluginSearchDir, "node_modules");
            if (!isDirectory(nodeModulesDir) && !isDirectory(resolvedPluginSearchDir)) {
              throw new Error(`${pluginSearchDir} does not exist or is not a directory`);
            }
            return memoizedSearch(nodeModulesDir).map((pluginName) => ({
              name: pluginName,
              requirePath: resolve(pluginName, {
                paths: [resolvedPluginSearchDir]
              })
            }));
          });
          const externalPlugins = [...uniqByKey([...externalManualLoadPluginInfos, ...externalAutoLoadPluginInfos], "requirePath").map((externalPluginInfo) => Object.assign({
            name: externalPluginInfo.name
          }, require(externalPluginInfo.requirePath))), ...externalPluginInstances];
          return [...internalPlugins, ...externalPlugins];
        }
        function findPluginsInNodeModules(nodeModulesDir) {
          const pluginPackageJsonPaths = fastGlob.sync(["prettier-plugin-*/package.json", "@*/prettier-plugin-*/package.json", "@prettier/plugin-*/package.json"], {
            cwd: nodeModulesDir
          });
          return pluginPackageJsonPaths.map(path5.dirname);
        }
        function isDirectory(dir) {
          try {
            return fs.statSync(dir).isDirectory();
          } catch {
            return false;
          }
        }
        module22.exports = {
          loadPlugins: memoizedLoad,
          clearCache
        };
      }
    });
    var {
      version
    } = require_package();
    var core2 = require_core6();
    var {
      getSupportInfo
    } = require_support();
    var getFileInfo = require_get_file_info();
    var sharedUtil = require_util_shared();
    var plugins = require_load_plugins();
    var config = require_resolve_config();
    var doc = require_doc();
    function _withPlugins(fn, optsArgIdx = 1) {
      return (...args) => {
        const opts = args[optsArgIdx] || {};
        args[optsArgIdx] = Object.assign(Object.assign({}, opts), {}, {
          plugins: plugins.loadPlugins(opts.plugins, opts.pluginSearchDirs)
        });
        return fn(...args);
      };
    }
    function withPlugins(fn, optsArgIdx) {
      const resultingFn = _withPlugins(fn, optsArgIdx);
      if (fn.sync) {
        resultingFn.sync = _withPlugins(fn.sync, optsArgIdx);
      }
      return resultingFn;
    }
    var formatWithCursor = withPlugins(core2.formatWithCursor);
    module2.exports = {
      formatWithCursor,
      format(text, opts) {
        return formatWithCursor(text, opts).formatted;
      },
      check(text, opts) {
        const {
          formatted
        } = formatWithCursor(text, opts);
        return formatted === text;
      },
      doc,
      resolveConfig: config.resolveConfig,
      resolveConfigFile: config.resolveConfigFile,
      clearConfigCache() {
        config.clearCache();
        plugins.clearCache();
      },
      getFileInfo: withPlugins(getFileInfo),
      getSupportInfo: withPlugins(getSupportInfo, 0),
      version,
      util: sharedUtil,
      __internal: {
        errors: require_errors3(),
        coreOptions: require_core_options(),
        createIgnorer: require_create_ignorer(),
        optionsModule: require_options(),
        optionsNormalizer: require_options_normalizer(),
        utils: {
          arrayify: require_arrayify(),
          getLast: require_get_last(),
          partition: require_partition(),
          isNonEmptyArray: require_util2().isNonEmptyArray
        }
      },
      __debug: {
        parse: withPlugins(core2.parse),
        formatAST: withPlugins(core2.formatAST),
        formatDoc: withPlugins(core2.formatDoc),
        printToDoc: withPlugins(core2.printToDoc),
        printDocToString: withPlugins(core2.printDocToString)
      }
    };
  }
});

// ../../../node_modules/.pnpm/call-me-maybe@1.0.2/node_modules/call-me-maybe/src/next.js
var require_next = __commonJS({
  "../../../node_modules/.pnpm/call-me-maybe@1.0.2/node_modules/call-me-maybe/src/next.js"(exports2, module2) {
    "use strict";
    function makeNext() {
      if (typeof process === "object" && typeof process.nextTick === "function") {
        return process.nextTick;
      } else if (typeof setImmediate === "function") {
        return setImmediate;
      } else {
        return function next(f) {
          setTimeout(f, 0);
        };
      }
    }
    module2.exports = makeNext();
  }
});

// ../../../node_modules/.pnpm/call-me-maybe@1.0.2/node_modules/call-me-maybe/src/maybe.js
var require_maybe = __commonJS({
  "../../../node_modules/.pnpm/call-me-maybe@1.0.2/node_modules/call-me-maybe/src/maybe.js"(exports2, module2) {
    "use strict";
    var next = require_next();
    module2.exports = function maybe(cb, promise) {
      if (cb) {
        promise.then(function(result) {
          next(function() {
            cb(null, result);
          });
        }, function(err) {
          next(function() {
            cb(err);
          });
        });
        return void 0;
      } else {
        return promise;
      }
    };
  }
});

// ../../../node_modules/.pnpm/http2-client@1.3.5/node_modules/http2-client/lib/utils.js
var require_utils2 = __commonJS({
  "../../../node_modules/.pnpm/http2-client@1.3.5/node_modules/http2-client/lib/utils.js"(exports2, module2) {
    "use strict";
    var DebounceTimers = class {
      constructor(cb, defaultDelay) {
        this.cb = cb;
        this.delay = defaultDelay;
        this.timers = {};
        this.pausers = {};
      }
      setDelay(delay) {
        if (delay >= 0)
          this.delay = delay;
      }
      pause(key) {
        this.pausers[key] = this.pausers[key] || 0;
        this.pausers[key]++;
      }
      unpause(key) {
        var count = this.pausers[key] || 0;
        if (count > 0)
          count--;
        this.pausers[key] = count;
      }
      unpauseAndTime(key) {
        this.unpause(key);
        this.time(key);
      }
      time(key) {
        var self2 = this;
        var timers = this.timers;
        var timer = this.timers[key];
        if (this.pausers[key] > 0)
          return;
        if (timer)
          clearTimeout(timer);
        timers[key] = setTimeout(function onTimer() {
          self2.cb(key);
          delete timers[key];
        }, self2.delay);
      }
    };
    var ERR_INVALID_ARG_TYPE = class extends TypeError {
      constructor(name, expected, actual) {
        const type2 = name.includes(".") ? "property" : "argument";
        let msg = `The "${name}" ${type2} ${determiner} ${expected}`;
      }
    };
    function assertIsObject(value, name, types2 = "Object") {
      if (value !== void 0 && (value === null || typeof value !== "object" || Array.isArray(value))) {
        const err = new ERR_INVALID_ARG_TYPE(name, types2, value);
        Error.captureStackTrace(err, assertIsObject);
        throw err;
      }
    }
    module2.exports = {
      ERR_INVALID_ARG_TYPE,
      assertIsObject,
      DebounceTimers
    };
  }
});

// ../../../node_modules/.pnpm/http2-client@1.3.5/node_modules/http2-client/lib/request-options.js
var require_request_options = __commonJS({
  "../../../node_modules/.pnpm/http2-client@1.3.5/node_modules/http2-client/lib/request-options.js"(exports2, module2) {
    "use strict";
    var { assertIsObject } = require_utils2();
    function initializeOptions(options) {
      assertIsObject(options, "options");
      options = Object.assign({}, options);
      options.allowHalfOpen = true;
      options.rejectUnauthorized = false;
      assertIsObject(options.settings, "options.settings");
      options.settings = Object.assign({}, options.settings);
      options.Http1IncomingMessage = options.Http1IncomingMessage || this.http.IncomingMessage;
      options.Http1ServerResponse = options.Http1ServerResponse || this.http.ServerResponse;
      options.Http2ServerRequest = options.Http2ServerRequest || (this.http2 || {}).Http2ServerRequest;
      options.Http2ServerResponse = options.Http2ServerResponse || (this.http2 || {}).Http2ServerResponse;
      return options;
    }
    function initializeTLSOptions(options, servername) {
      options = initializeOptions.call(this, options);
      var ALPNProtocols = options.ALPNProtocols = [];
      if (this.http2Support)
        ALPNProtocols.push("h2");
      if (options.allowHTTP1 == true || !this.http2Support)
        ALPNProtocols.push("http/1.1");
      if (servername !== void 0 && options.servername === void 0)
        options.servername = servername;
      return options;
    }
    module2.exports = {
      initializeTLSOptions
    };
  }
});

// ../../../node_modules/.pnpm/http2-client@1.3.5/node_modules/http2-client/lib/request.js
var require_request = __commonJS({
  "../../../node_modules/.pnpm/http2-client@1.3.5/node_modules/http2-client/lib/request.js"(exports2, module2) {
    "use strict";
    var { URL: URL3 } = require("url");
    var { EventEmitter } = require("events");
    var _extend = require("util")._extend;
    var { DebounceTimers, assertIsObject, ERR_INVALID_ARG_TYPE } = require_utils2();
    var { initializeTLSOptions } = require_request_options();
    var http3 = require("http");
    var https2 = require("https");
    var { Stream: Stream3 } = require("stream");
    function addFunctions(container, obj) {
      const proto = obj.prototype;
      Object.keys(proto).forEach((name) => {
        if (container.indexOf(name) != -1)
          return;
        if (name.indexOf("_") != 0 && typeof proto[name] == "function") {
          container.push(name);
        }
      });
    }
    var STUBBED_METHODS_NAME = [];
    addFunctions(STUBBED_METHODS_NAME, http3.ClientRequest);
    addFunctions(STUBBED_METHODS_NAME, http3.OutgoingMessage);
    addFunctions(STUBBED_METHODS_NAME, EventEmitter);
    addFunctions(STUBBED_METHODS_NAME, Stream3);
    var PROPERTIES_TO_PROXY = [
      "httpVersionMajor",
      "httpVersionMinor",
      "httpVersion"
    ];
    var HEADERS_TO_REMOVE = ["host", "connection"];
    var $stubs = Symbol("stubs");
    function ClientRequest() {
      this.http2Mimic = true;
      this[$stubs] = [];
      for (var i = 0; i < STUBBED_METHODS_NAME.length; i++) {
        let name = STUBBED_METHODS_NAME[i];
        if (!ClientRequest.prototype[name]) {
          this[name] = function method() {
            return this.genericStubber(name, arguments);
          }.bind(this);
        }
      }
      var requestOptions, cb, url, args;
      const isInternal = arguments[0] instanceof RequestInternalEnforce;
      var isInternalMethod, isInternalProtocol;
      if (isInternal) {
        const enforceOptions = arguments[0];
        if (enforceOptions.method)
          isInternalMethod = enforceOptions.method;
        if (enforceOptions.protocol)
          isInternalProtocol = enforceOptions.protocol;
      }
      if (isInternal) {
        args = arguments[0].args;
      } else {
        args = arguments;
      }
      if (args[2] != void 0) {
        url = args[0];
        requestOptions = args[1];
        cb = args[2];
      } else if (args[1] == void 0) {
        requestOptions = args[0];
      } else {
        requestOptions = args[0];
        cb = args[1];
      }
      cb = cb || function dummy() {
      };
      if (typeof requestOptions === "string") {
        requestOptions = urlToOptions(new URL3(requestOptions));
        if (!requestOptions.hostname) {
          throw new Error("Unable to determine the domain name");
        }
      } else {
        if (url) {
          requestOptions = _extend(urlToOptions(new URL3(url)), requestOptions);
        } else {
          requestOptions = _extend({}, requestOptions);
        }
      }
      if (isInternalProtocol != isInternalProtocol) {
        requestOptions.protocol = isInternalProtocol;
      }
      if (requestOptions.protocol == "https:" && !requestOptions.port && requestOptions.port != 0)
        requestOptions.port = 443;
      if (!requestOptions.port && requestOptions.port != 0)
        requestOptions.port = 80;
      if (isInternalMethod) {
        requestOptions.method = isInternalMethod;
      } else if (!requestOptions.method)
        requestOptions.method = "GET";
      requestOptions.method = requestOptions.method.toUpperCase();
      const requestManager = requestOptions.requestManager || this.getGlobalManager(requestOptions);
      requestManager.handleClientRequest(this, requestOptions, cb);
    }
    ClientRequest.prototype = {
      getGlobalManager(options) {
        if (options.agent)
          return options.agent.protocol == "https:" ? HttpsRequest.globalManager : HttpRequest2.globalManager;
        else
          return HttpRequestManager.globalManager;
      },
      genericStubber(method, args) {
        if (this[$stubs]) {
          this[$stubs].push([method, args]);
          return true;
        } else
          return this[method](...arguments);
      },
      on(eventName, cb) {
        if (eventName == "response") {
          if (!cb.http2Safe) {
            eventName = "http1.response";
            arguments[0] = eventName;
          }
        }
        if (this._on) {
          this._on(...arguments);
        } else
          this.genericStubber("on", arguments);
      },
      once(eventName, cb) {
        if (eventName == "response") {
          if (!cb.http2Safe) {
            eventName = "http1.response";
          }
        }
        if (this._once) {
          this._once(...arguments);
        } else
          this.genericStubber("once", arguments);
      },
      emitError(error) {
        if (this[$stubs]) {
          this[$stubs].forEach(([method, args]) => {
            if ((method === "on" || method === "once") && args[0] === "error") {
              args[1](error);
            }
          });
        } else
          return this.emit("error", error);
      },
      take(stream) {
        for (var i = 0; i < STUBBED_METHODS_NAME.length; i++) {
          let name = STUBBED_METHODS_NAME[i];
          if (stream[name]) {
            this[name] = stream[name].bind(stream);
          }
        }
        this._on = stream.on.bind(stream);
        this._once = stream.once.bind(stream);
        this.proxyProps(stream);
        for (let i2 = 0; i2 < this[$stubs].length; i2++) {
          var stub = this[$stubs][i2];
          stream[stub[0]](...stub[1]);
        }
        this[$stubs] = null;
      },
      proxyProps(http2Stream) {
        function getter() {
          return http2Stream[this];
        }
        function setter(value) {
          http2Stream[this] = value;
        }
        const notToProxy = ["on", "_on", "_once", "once", "http2Mimic"].concat(STUBBED_METHODS_NAME);
        const keys5 = Object.keys(this);
        const keysToProxy = [].concat(PROPERTIES_TO_PROXY);
        keys5.forEach(function whichProxyKeys(key) {
          if (notToProxy.indexOf(key) == -1 && keysToProxy.indexOf(key) == -1) {
            keysToProxy.push(key);
          }
        });
        const properties = Object.getOwnPropertyDescriptors(http2Stream);
        for (var i = 0; i < keysToProxy.length; i++) {
          let name = keysToProxy[i];
          const propConfig = properties[name];
          let shouldCopyValue;
          if (!propConfig)
            shouldCopyValue = true;
          if (propConfig && (propConfig.writable || propConfig))
            shouldCopyValue = true;
          if (shouldCopyValue)
            http2Stream[name] = this[name];
          Object.defineProperty(this, name, {
            get: getter.bind(name),
            set: setter.bind(name)
          });
        }
      }
    };
    var HttpRequestManager = class _HttpRequestManager extends EventEmitter {
      constructor(options) {
        super();
        this.httpsAgent = https2.globalAgent;
        this.httpAgent = http3.globalAgent;
        this.init(options);
      }
      log() {
      }
      init(options) {
        options = options || {};
        this.http2Clients = {};
        this.cachedHTTP1Result = {};
        this.setModules();
        this.http2Debouncer = new DebounceTimers(function stopConnection(key) {
          this.log("stopping ", key);
          var foundConnection = this.http2Clients[key];
          if (foundConnection) {
            this.removeHttp2Client(key, foundConnection);
          }
        }.bind(this), 1e3);
        this.keepH1IdentificationCacheFor = options.keepH1IdentificationCacheFor || 3e4;
        this.http2Debouncer.setDelay(options.keepH2ConnectionFor);
        if (options.useHttp) {
          this.enforceProtocol = "http:";
        } else if (options.useHttps) {
          this.enforceProtocol = "https:";
        }
      }
      setModules() {
        this["http"] = require("http");
        this["https"] = require("https");
        this["tls"] = require("tls");
        this["net"] = require("net");
        this.http2Support = false;
        try {
          this["http2"] = require("http2");
          this.http2Support = true;
        } catch (err) {
        }
      }
      handleClientRequest(clientRequest, requestOptions, cb) {
        const requestManager = this;
        const clientKey = requestManager.getClientKey(requestOptions);
        if (requestManager.hasCachedConnection(clientKey)) {
          const socket = requestManager.getHttp2Client(clientKey);
          const connectionOptions = {
            createConnection() {
              return socket;
            }
          };
          process.nextTick(function onMakeRequest() {
            requestManager.makeRequest(clientRequest, clientKey, requestOptions, cb, connectionOptions);
          }.bind(requestManager));
        } else
          requestManager.holdConnectionToIdentification(clientKey, requestOptions, function onIdentification(error, connectionOptions) {
            if (error) {
              clientRequest.emitError(error);
              return;
            }
            requestManager.makeRequest(clientRequest, clientKey, requestOptions, cb, connectionOptions);
          }.bind(requestManager));
      }
      getClientKey(url) {
        return `${url.protocol || this.enforceProtocol}${url.servername || url.host || url.hostname}:${url.port}`;
      }
      getHttp2Client(clientKey) {
        return this.http2Clients[clientKey];
      }
      setHttp2Client(clientKey, client) {
        const httpManager = this;
        const prevClient = httpManager.http2Clients[clientKey];
        if (prevClient)
          httpManager.removeHttp2Client(clientKey, prevClient);
        httpManager.http2Clients[clientKey] = client;
        function closeClient() {
          httpManager.removeHttp2Client(clientKey, client);
        }
        client.on("close", closeClient);
        client.on("goaway", closeClient);
        client.on("error", closeClient);
        client.on("frameError", closeClient);
        client.on("timeout", closeClient);
      }
      removeHttp2Client(clientKey, client) {
        try {
          delete this.http2Clients[clientKey];
          if (!client.closed) {
            client.close();
          }
        } catch (err) {
        }
        client.removeAllListeners("close");
        client.removeAllListeners("error");
        client.removeAllListeners("frameError");
        client.removeAllListeners("timeout");
      }
      request(url, options, cb) {
        var args = new RequestInternalEnforce(arguments);
        if (this.enforceProtocol) {
          args.protocol = this.enforceProtocol;
        }
        return new ClientRequest(args);
      }
      get() {
        var args = new RequestInternalEnforce(arguments);
        args.method = "GET";
        var request = this.request(args);
        request.end();
        return request;
      }
      hasCachedConnection(clientKey) {
        const http2Client = this.getHttp2Client(clientKey);
        if (http2Client) {
          return true;
        }
        return this.cachedHTTP1Result[clientKey] + this.keepH1IdentificationCacheFor < Date.now();
      }
      makeRequest(inStream, clientKey, requestOptions, cb, connectionOptions) {
        const http2Client = this.getHttp2Client(clientKey);
        if (http2Client) {
          return this.makeHttp2Request(clientKey, inStream, http2Client, Object.assign(connectionOptions || {}, requestOptions), cb);
        }
        if (!requestOptions.agent) {
          if (requestOptions.protocol == "https:")
            requestOptions.agent = this.httpsAgent;
          else
            requestOptions.agent = this.httpAgent;
        }
        return this.makeHttpRequest(clientKey, inStream, requestOptions, cb, connectionOptions);
      }
      holdConnectionToIdentification(clientKey, requestOptions, cb) {
        const topic = `identify-${clientKey}`;
        if (this._events[topic])
          this.once(topic, cb);
        else {
          this.once(topic, function letKnowThereIsAnEvent() {
          });
          const socket = this.identifyConnection(requestOptions, function onIdentify(error, type2) {
            if (error) {
              return cb(error);
            }
            var options = {
              createConnection() {
                return socket;
              }
            };
            if (type2 == "h2" && this.http2Support) {
              var http2Client = this.http2.connect(requestOptions, options);
              this.setHttp2Client(clientKey, http2Client);
            } else {
              this.cachedHTTP1Result[clientKey] = Date.now();
            }
            cb(null, options);
            this.emit(topic, options);
          }.bind(this));
        }
      }
      makeHttpRequest(clientKey, inStream, options, cb, connectionOptions) {
        if (options instanceof URL3)
          options = urlToOptions(options);
        const h1op = _extend({}, options);
        if (connectionOptions)
          h1op.createConnection = connectionOptions.createConnection;
        const requestModule = h1op.protocol == "https:" ? this.https : this.http;
        const req = requestModule.request(h1op, cb);
        inStream.take(req);
        inStream._on("response", function onHttp1Response(v) {
          this.emit("http1.response", v);
        });
      }
      makeHttp2Request(clientKey, inStream, http2Client, requestOptions, cb) {
        var http2Debouncer = this.http2Debouncer;
        http2Debouncer.pause(clientKey);
        var headers = _extend({}, requestOptions.headers || {});
        if (requestOptions.method)
          headers[":method"] = requestOptions.method;
        if (requestOptions.path)
          headers[":path"] = requestOptions.path;
        Object.keys(headers).forEach((key) => {
          if (HEADERS_TO_REMOVE.indexOf((key + "").toLowerCase()) != -1) {
            delete headers[key];
          }
        });
        requestOptions.headers = headers;
        var req = http2Client.request(
          headers
        );
        inStream.emit("socket", requestOptions.createConnection());
        let maxContentLength;
        let currentContent = 0;
        req.on("data", function onData(data) {
          currentContent += data.length;
          if (currentContent >= maxContentLength)
            http2Debouncer.unpauseAndTime(clientKey);
        });
        inStream.take(req);
        function onResponse(headers2) {
          maxContentLength = parseInt(headers2["content-length"]);
          if (maxContentLength < 0)
            this.http2Debouncer.unpauseAndTime(clientKey);
          _HttpRequestManager.httpCompatibleResponse(req, requestOptions, headers2);
          inStream.emit("http1.response", req);
          if (cb)
            cb(req);
        }
        onResponse.http2Safe = true;
        req.once("response", onResponse.bind(this));
      }
      static httpCompatibleResponse(res, requestOptions, headers) {
        res.httpVersion = "2.0";
        res.rawHeaders = headers;
        res.headers = headers;
        res.statusCode = headers[":status"];
        delete headers[":status"];
      }
      identifyConnection(requestOptions, cb) {
        var socket = this.connect(requestOptions, { allowHTTP1: true }, function onConnect() {
          socket.removeListener("error", cb);
          if (socket.alpnProtocol == "h2") {
            cb(null, "h2");
          } else {
            socket.end();
            cb(null, "h1");
          }
        });
        socket.on("error", cb);
        return socket;
      }
      connect(authority, options, listener) {
        if (typeof options === "function") {
          listener = options;
          options = void 0;
        }
        assertIsObject(options, "options");
        options = Object.assign({}, options);
        if (typeof authority === "string")
          authority = new URL3(authority);
        assertIsObject(authority, "authority", ["string", "Object", "URL"]);
        var protocol = authority.protocol || options.protocol || (this.enforceProtocol != "detect" ? this.enforceProtocol : null) || "http:";
        var port = "" + (authority.port !== "" ? authority.port : authority.protocol === "http:" ? 80 : 443);
        var host = authority.hostname || authority.host || "localhost";
        var socket;
        if (typeof options.createConnection === "function") {
          socket = options.createConnection(authority, options);
        } else {
          switch (protocol) {
            case "http:":
              socket = this.net.connect(port, host, listener);
              break;
            case "https:":
              socket = this.tls.connect(port, host, initializeTLSOptions.call(this, options, host), listener);
              break;
            default:
              throw new Error("Not supprted" + protocol);
          }
        }
        return socket;
      }
    };
    function urlToOptions(url) {
      var options = {
        protocol: url.protocol,
        hostname: url.hostname,
        hash: url.hash,
        search: url.search,
        pathname: url.pathname,
        path: `${url.pathname}${url.search}`,
        href: url.href
      };
      if (url.port !== "") {
        options.port = Number(url.port);
      }
      if (url.username || url.password) {
        options.auth = `${url.username}:${url.password}`;
      }
      return options;
    }
    var RequestInternalEnforce = class _RequestInternalEnforce {
      constructor(args) {
        if (args[0] instanceof _RequestInternalEnforce) {
          return args[0];
        }
        this.args = args;
        this.method = null;
        this.protocol = null;
      }
    };
    var HttpsRequest = class extends HttpRequestManager {
      constructor() {
        super(...arguments);
        this.Agent = https2.Agent;
        this.globalAgent = https2.globalAgent;
        this.enforceProtocol = "https:";
      }
    };
    var httpsRequestSinglton = new HttpsRequest();
    HttpsRequest.globalManager = httpsRequestSinglton;
    HttpsRequest.Manager = HttpsRequest;
    var HttpRequest2 = class extends HttpRequestManager {
      constructor() {
        super(...arguments);
        this.Agent = http3.Agent;
        this.globalAgent = http3.globalAgent;
        this.enforceProtocol = "http:";
      }
    };
    var httpRequestSinglton = new HttpRequest2();
    HttpRequest2.globalManager = httpRequestSinglton;
    HttpRequest2.Manager = HttpRequest2;
    var singeltonHttpManager = new HttpRequestManager();
    singeltonHttpManager.enforceProtocol = "detect";
    HttpRequestManager.globalManager = singeltonHttpManager;
    module2.exports = {
      HttpRequest: HttpRequest2,
      HttpsRequest,
      HTTP2OutgoingMessage: ClientRequest,
      ClientRequest,
      HttpRequestManager
    };
  }
});

// ../../../node_modules/.pnpm/http2-client@1.3.5/node_modules/http2-client/lib/http.js
var require_http = __commonJS({
  "../../../node_modules/.pnpm/http2-client@1.3.5/node_modules/http2-client/lib/http.js"(exports2, module2) {
    "use strict";
    var {
      HttpRequest: HttpRequest2,
      ClientRequest
    } = require_request();
    var globalManager = HttpRequest2.globalManager;
    var request = globalManager.request.bind(globalManager);
    var get2 = globalManager.get.bind(globalManager);
    var http3 = Object.assign({}, require("http"));
    module2.exports = Object.assign(http3, {
      ClientRequest,
      globalManager,
      request,
      get: get2
    });
  }
});

// ../../../node_modules/.pnpm/http2-client@1.3.5/node_modules/http2-client/lib/https.js
var require_https = __commonJS({
  "../../../node_modules/.pnpm/http2-client@1.3.5/node_modules/http2-client/lib/https.js"(exports2, module2) {
    "use strict";
    var {
      HttpsRequest,
      ClientRequest
    } = require_request();
    var globalManager = HttpsRequest.globalManager;
    var request = globalManager.request.bind(globalManager);
    var get2 = globalManager.get.bind(globalManager);
    var https2 = Object.assign({}, require("https"));
    module2.exports = Object.assign(https2, {
      ClientRequest,
      globalManager,
      request,
      get: get2
    });
  }
});

// ../../../node_modules/.pnpm/http2-client@1.3.5/node_modules/http2-client/lib/index.js
var require_lib = __commonJS({
  "../../../node_modules/.pnpm/http2-client@1.3.5/node_modules/http2-client/lib/index.js"(exports2, module2) {
    "use strict";
    var {
      HttpRequestManager,
      HTTP2OutgoingMessage,
      ClientRequest
    } = require_request();
    var http3 = require_http();
    var https2 = require_https();
    var autoDetectManager = new HttpRequestManager();
    HttpRequestManager.globalManager = autoDetectManager;
    var request = autoDetectManager.request.bind(autoDetectManager);
    var get2 = autoDetectManager.get.bind(autoDetectManager);
    module2.exports = {
      HTTP2OutgoingMessage,
      ClientRequest,
      globalManager: HttpRequestManager.globalManager,
      request,
      get: get2,
      http: http3,
      https: https2
    };
  }
});

// ../../../node_modules/.pnpm/node-fetch-h2@2.3.0/node_modules/node-fetch-h2/lib/index.mjs
var lib_exports = {};
__export(lib_exports, {
  FetchError: () => FetchError,
  Headers: () => Headers,
  Request: () => Request2,
  Response: () => Response2,
  default: () => lib_default
});
function FetchError(message, type2, systemError) {
  Error.call(this, message);
  this.message = message;
  this.type = type2;
  if (systemError) {
    this.code = this.errno = systemError.code;
  }
  Error.captureStackTrace(this, this.constructor);
}
function Body(body) {
  var _this = this;
  var _ref = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, _ref$size = _ref.size;
  let size2 = _ref$size === void 0 ? 0 : _ref$size;
  var _ref$timeout = _ref.timeout;
  let timeout = _ref$timeout === void 0 ? 0 : _ref$timeout;
  if (body == null) {
    body = null;
  } else if (isURLSearchParams(body)) {
    body = Buffer.from(body.toString());
  } else if (body instanceof Blob) {
    body = body[BUFFER];
  } else if (Buffer.isBuffer(body)) ;
  else if (Object.prototype.toString.call(body) === "[object ArrayBuffer]") {
    body = Buffer.from(body);
  } else if (ArrayBuffer.isView(body)) {
    body = Buffer.from(body.buffer, body.byteOffset, body.byteLength);
  } else if (body instanceof import_stream.default) ;
  else {
    body = Buffer.from(String(body));
  }
  this[INTERNALS] = {
    body,
    disturbed: false,
    error: null
  };
  this.size = size2;
  this.timeout = timeout;
  if (body instanceof import_stream.default) {
    body.on("error", function(err) {
      const error = err.name === "AbortError" ? err : new FetchError(`Invalid response body while trying to fetch ${_this.url}: ${err.message}`, "system", err);
      _this[INTERNALS].error = error;
    });
  }
}
function consumeBody() {
  var _this4 = this;
  if (this[INTERNALS].disturbed) {
    return Body.Promise.reject(new TypeError(`body used already for: ${this.url}`));
  }
  this[INTERNALS].disturbed = true;
  if (this[INTERNALS].error) {
    return Body.Promise.reject(this[INTERNALS].error);
  }
  if (this.body === null) {
    return Body.Promise.resolve(Buffer.alloc(0));
  }
  if (Buffer.isBuffer(this.body)) {
    return Body.Promise.resolve(this.body);
  }
  if (!(this.body instanceof import_stream.default)) {
    return Body.Promise.resolve(Buffer.alloc(0));
  }
  let accum = [];
  let accumBytes = 0;
  let abort = false;
  return new Body.Promise(function(resolve, reject) {
    let resTimeout;
    if (_this4.timeout) {
      resTimeout = setTimeout(function() {
        abort = true;
        reject(new FetchError(`Response timeout while trying to fetch ${_this4.url} (over ${_this4.timeout}ms)`, "body-timeout"));
      }, _this4.timeout);
    }
    _this4.body.on("error", function(err) {
      if (err.name === "AbortError") {
        abort = true;
        reject(err);
      } else {
        reject(new FetchError(`Invalid response body while trying to fetch ${_this4.url}: ${err.message}`, "system", err));
      }
    });
    _this4.body.on("data", function(chunk) {
      if (abort || chunk === null) {
        return;
      }
      if (_this4.size && accumBytes + chunk.length > _this4.size) {
        abort = true;
        reject(new FetchError(`content size at ${_this4.url} over limit: ${_this4.size}`, "max-size"));
        return;
      }
      accumBytes += chunk.length;
      accum.push(chunk);
    });
    _this4.body.on("end", function() {
      if (abort) {
        return;
      }
      clearTimeout(resTimeout);
      try {
        resolve(Buffer.concat(accum));
      } catch (err) {
        reject(new FetchError(`Could not create Buffer from response body for ${_this4.url}: ${err.message}`, "system", err));
      }
    });
  });
}
function convertBody(buffer, headers) {
  if (typeof convert2 !== "function") {
    throw new Error("The package `encoding` must be installed to use the textConverted() function");
  }
  const ct = headers.get("content-type");
  let charset = "utf-8";
  let res, str2;
  if (ct) {
    res = /charset=([^;]*)/i.exec(ct);
  }
  str2 = buffer.slice(0, 1024).toString();
  if (!res && str2) {
    res = /<meta.+?charset=(['"])(.+?)\1/i.exec(str2);
  }
  if (!res && str2) {
    res = /<meta[\s]+?http-equiv=(['"])content-type\1[\s]+?content=(['"])(.+?)\2/i.exec(str2);
    if (res) {
      res = /charset=(.*)/i.exec(res.pop());
    }
  }
  if (!res && str2) {
    res = /<\?xml.+?encoding=(['"])(.+?)\1/i.exec(str2);
  }
  if (res) {
    charset = res.pop();
    if (charset === "gb2312" || charset === "gbk") {
      charset = "gb18030";
    }
  }
  return convert2(buffer, "UTF-8", charset).toString();
}
function isURLSearchParams(obj) {
  if (typeof obj !== "object" || typeof obj.append !== "function" || typeof obj.delete !== "function" || typeof obj.get !== "function" || typeof obj.getAll !== "function" || typeof obj.has !== "function" || typeof obj.set !== "function") {
    return false;
  }
  return obj.constructor.name === "URLSearchParams" || Object.prototype.toString.call(obj) === "[object URLSearchParams]" || typeof obj.sort === "function";
}
function clone(instance) {
  let p1, p2;
  let body = instance.body;
  if (instance.bodyUsed) {
    throw new Error("cannot clone body after it is used");
  }
  if (body instanceof import_stream.default && typeof body.getBoundary !== "function") {
    p1 = new PassThrough();
    p2 = new PassThrough();
    body.pipe(p1);
    body.pipe(p2);
    instance[INTERNALS].body = p1;
    body = p2;
  }
  return body;
}
function extractContentType(body) {
  if (body === null) {
    return null;
  } else if (typeof body === "string") {
    return "text/plain;charset=UTF-8";
  } else if (isURLSearchParams(body)) {
    return "application/x-www-form-urlencoded;charset=UTF-8";
  } else if (body instanceof Blob) {
    return body.type || null;
  } else if (Buffer.isBuffer(body)) {
    return null;
  } else if (Object.prototype.toString.call(body) === "[object ArrayBuffer]") {
    return null;
  } else if (ArrayBuffer.isView(body)) {
    return null;
  } else if (typeof body.getBoundary === "function") {
    return `multipart/form-data;boundary=${body.getBoundary()}`;
  } else if (body instanceof import_stream.default) {
    return null;
  } else {
    return "text/plain;charset=UTF-8";
  }
}
function getTotalBytes(instance) {
  const body = instance.body;
  if (body === null) {
    return 0;
  } else if (Buffer.isBuffer(body)) {
    return body.length;
  } else if (body && typeof body.getLengthSync === "function") {
    if (body._lengthRetrievers && body._lengthRetrievers.length == 0 || // 1.x
    body.hasKnownLength && body.hasKnownLength()) {
      return body.getLengthSync();
    }
    return null;
  } else {
    return null;
  }
}
function writeToStream(dest, instance) {
  const body = instance.body;
  if (body === null) {
    dest.end();
  } else if (Buffer.isBuffer(body)) {
    dest.write(body);
    dest.end();
  } else {
    body.pipe(dest);
  }
}
function validateName(name) {
  name = `${name}`;
  if (invalidTokenRegex.test(name)) {
    throw new TypeError(`${name} is not a legal HTTP header name`);
  }
}
function validateValue(value) {
  value = `${value}`;
  if (invalidHeaderCharRegex.test(value)) {
    throw new TypeError(`${value} is not a legal HTTP header value`);
  }
}
function find(map2, name) {
  name = name.toLowerCase();
  for (const key in map2) {
    if (key.toLowerCase() === name) {
      return key;
    }
  }
  return void 0;
}
function getHeaders(headers) {
  let kind = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "key+value";
  const keys5 = Object.keys(headers[MAP]).sort();
  return keys5.map(kind === "key" ? function(k) {
    return k.toLowerCase();
  } : kind === "value" ? function(k) {
    return headers[MAP][k].join(", ");
  } : function(k) {
    return [k.toLowerCase(), headers[MAP][k].join(", ")];
  });
}
function createHeadersIterator(target, kind) {
  const iterator = Object.create(HeadersIteratorPrototype);
  iterator[INTERNAL] = {
    target,
    kind,
    index: 0
  };
  return iterator;
}
function exportNodeCompatibleHeaders(headers) {
  const obj = Object.assign({ __proto__: null }, headers[MAP]);
  const hostHeaderKey = find(headers[MAP], "Host");
  if (hostHeaderKey !== void 0) {
    obj[hostHeaderKey] = obj[hostHeaderKey][0];
  }
  return obj;
}
function createHeadersLenient(obj) {
  const headers = new Headers();
  for (const name of Object.keys(obj)) {
    if (invalidTokenRegex.test(name)) {
      continue;
    }
    if (Array.isArray(obj[name])) {
      for (const val of obj[name]) {
        if (invalidHeaderCharRegex.test(val)) {
          continue;
        }
        if (headers[MAP][name] === void 0) {
          headers[MAP][name] = [val];
        } else {
          headers[MAP][name].push(val);
        }
      }
    } else if (!invalidHeaderCharRegex.test(obj[name])) {
      headers[MAP][name] = [obj[name]];
    }
  }
  return headers;
}
function isRequest(input) {
  return typeof input === "object" && typeof input[INTERNALS$2] === "object";
}
function isAbortSignal(signal) {
  const proto = signal && typeof signal === "object" && Object.getPrototypeOf(signal);
  return !!(proto && proto.constructor.name === "AbortSignal");
}
function getNodeRequestOptions(request) {
  const parsedURL = request[INTERNALS$2].parsedURL;
  const headers = new Headers(request[INTERNALS$2].headers);
  if (!headers.has("Accept")) {
    headers.set("Accept", "*/*");
  }
  if (!parsedURL.protocol || !parsedURL.hostname) {
    throw new TypeError("Only absolute URLs are supported");
  }
  if (!/^https?:$/.test(parsedURL.protocol)) {
    throw new TypeError("Only HTTP(S) protocols are supported");
  }
  if (request.signal && request.body instanceof import_stream.default.Readable && !streamDestructionSupported) {
    throw new Error("Cancellation of streamed requests with AbortSignal is not supported in node < 8");
  }
  let contentLengthValue = null;
  if (request.body == null && /^(POST|PUT)$/i.test(request.method)) {
    contentLengthValue = "0";
  }
  if (request.body != null) {
    const totalBytes = getTotalBytes(request);
    if (typeof totalBytes === "number") {
      contentLengthValue = String(totalBytes);
    }
  }
  if (contentLengthValue) {
    headers.set("Content-Length", contentLengthValue);
  }
  if (!headers.has("User-Agent")) {
    headers.set("User-Agent", "node-fetch/1.0 (+https://github.com/bitinn/node-fetch)");
  }
  if (request.compress && !headers.has("Accept-Encoding")) {
    headers.set("Accept-Encoding", "gzip,deflate");
  }
  if (!headers.has("Connection") && !request.agent) {
    headers.set("Connection", "close");
  }
  return Object.assign({}, parsedURL, {
    method: request.method,
    headers: exportNodeCompatibleHeaders(headers),
    agent: request.agent
  });
}
function AbortError(message) {
  Error.call(this, message);
  this.type = "aborted";
  this.message = message;
  Error.captureStackTrace(this, this.constructor);
}
function fetch(url, opts) {
  if (!fetch.Promise) {
    throw new Error("native promise missing, set fetch.Promise to your favorite alternative");
  }
  Body.Promise = fetch.Promise;
  return new fetch.Promise(function(resolve, reject) {
    const request = new Request2(url, opts);
    const options = getNodeRequestOptions(request);
    const send = import_http2_client.default.request;
    const signal = request.signal;
    let response = null;
    const abort = function abort2() {
      let error = new AbortError("The user aborted a request.");
      reject(error);
      if (request.body && request.body instanceof import_stream.default.Readable) {
        request.body.destroy(error);
      }
      if (!response || !response.body) return;
      response.body.emit("error", error);
    };
    if (signal && signal.aborted) {
      abort();
      return;
    }
    const abortAndFinalize = function abortAndFinalize2() {
      abort();
      finalize();
    };
    const req = send(options);
    let reqTimeout;
    if (signal) {
      signal.addEventListener("abort", abortAndFinalize);
    }
    function finalize() {
      req.abort();
      if (signal) signal.removeEventListener("abort", abortAndFinalize);
      clearTimeout(reqTimeout);
    }
    if (request.timeout) {
      req.once("socket", function(socket) {
        reqTimeout = setTimeout(function() {
          reject(new FetchError(`network timeout at: ${request.url}`, "request-timeout"));
          finalize();
        }, request.timeout);
      });
    }
    req.on("error", function(err) {
      reject(new FetchError(`request to ${request.url} failed, reason: ${err.message}`, "system", err));
      finalize();
    });
    req.on("response", function(res) {
      clearTimeout(reqTimeout);
      const headers = createHeadersLenient(res.headers);
      if (fetch.isRedirect(res.statusCode)) {
        const location = headers.get("Location");
        const locationURL = location === null ? null : resolve_url(request.url, location);
        switch (request.redirect) {
          case "error":
            reject(new FetchError(`redirect mode is set to error: ${request.url}`, "no-redirect"));
            finalize();
            return;
          case "manual":
            if (locationURL !== null) {
              try {
                headers.set("Location", locationURL);
              } catch (err) {
                reject(err);
              }
            }
            break;
          case "follow":
            if (locationURL === null) {
              break;
            }
            if (request.counter >= request.follow) {
              reject(new FetchError(`maximum redirect reached at: ${request.url}`, "max-redirect"));
              finalize();
              return;
            }
            const requestOpts = {
              headers: new Headers(request.headers),
              follow: request.follow,
              counter: request.counter + 1,
              agent: request.agent,
              compress: request.compress,
              method: request.method,
              body: request.body,
              signal: request.signal
            };
            if (res.statusCode !== 303 && request.body && getTotalBytes(request) === null) {
              reject(new FetchError("Cannot follow redirect with body being a readable stream", "unsupported-redirect"));
              finalize();
              return;
            }
            if (res.statusCode === 303 || (res.statusCode === 301 || res.statusCode === 302) && request.method === "POST") {
              requestOpts.method = "GET";
              requestOpts.body = void 0;
              requestOpts.headers.delete("content-length");
            }
            resolve(fetch(new Request2(locationURL, requestOpts)));
            finalize();
            return;
        }
      }
      res.once("end", function() {
        if (signal) signal.removeEventListener("abort", abortAndFinalize);
      });
      let body = res.pipe(new PassThrough$1());
      const response_options = {
        url: request.url,
        status: res.statusCode,
        statusText: res.statusMessage,
        headers,
        size: request.size,
        timeout: request.timeout
      };
      const codings = headers.get("Content-Encoding");
      if (!request.compress || request.method === "HEAD" || codings === null || res.statusCode === 204 || res.statusCode === 304) {
        response = new Response2(body, response_options);
        resolve(response);
        return;
      }
      const zlibOptions = {
        flush: import_zlib.default.Z_SYNC_FLUSH,
        finishFlush: import_zlib.default.Z_SYNC_FLUSH
      };
      if (codings == "gzip" || codings == "x-gzip") {
        body = body.pipe(import_zlib.default.createGunzip(zlibOptions));
        response = new Response2(body, response_options);
        resolve(response);
        return;
      }
      if (codings == "deflate" || codings == "x-deflate") {
        const raw = res.pipe(new PassThrough$1());
        raw.once("data", function(chunk) {
          if ((chunk[0] & 15) === 8) {
            body = body.pipe(import_zlib.default.createInflate());
          } else {
            body = body.pipe(import_zlib.default.createInflateRaw());
          }
          response = new Response2(body, response_options);
          resolve(response);
        });
        return;
      }
      response = new Response2(body, response_options);
      resolve(response);
    });
    writeToStream(req, request);
  });
}
var import_stream, import_http, import_url, import_http2_client, import_zlib, BUFFER, TYPE, Blob, convert2, INTERNALS, PassThrough, invalidTokenRegex, invalidHeaderCharRegex, MAP, Headers, INTERNAL, HeadersIteratorPrototype, INTERNALS$1, STATUS_CODES, Response2, INTERNALS$2, parse_url, format_url, streamDestructionSupported, Request2, PassThrough$1, resolve_url, lib_default;
var init_lib = __esm({
  "../../../node_modules/.pnpm/node-fetch-h2@2.3.0/node_modules/node-fetch-h2/lib/index.mjs"() {
    "use strict";
    import_stream = __toESM(require("stream"), 1);
    import_http = __toESM(require("http"), 1);
    import_url = __toESM(require("url"), 1);
    import_http2_client = __toESM(require_lib(), 1);
    import_zlib = __toESM(require("zlib"), 1);
    BUFFER = Symbol("buffer");
    TYPE = Symbol("type");
    Blob = class _Blob {
      constructor() {
        this[TYPE] = "";
        const blobParts = arguments[0];
        const options = arguments[1];
        const buffers = [];
        if (blobParts) {
          const a = blobParts;
          const length = Number(a.length);
          for (let i = 0; i < length; i++) {
            const element = a[i];
            let buffer;
            if (element instanceof Buffer) {
              buffer = element;
            } else if (ArrayBuffer.isView(element)) {
              buffer = Buffer.from(element.buffer, element.byteOffset, element.byteLength);
            } else if (element instanceof ArrayBuffer) {
              buffer = Buffer.from(element);
            } else if (element instanceof _Blob) {
              buffer = element[BUFFER];
            } else {
              buffer = Buffer.from(typeof element === "string" ? element : String(element));
            }
            buffers.push(buffer);
          }
        }
        this[BUFFER] = Buffer.concat(buffers);
        let type2 = options && options.type !== void 0 && String(options.type).toLowerCase();
        if (type2 && !/[^\u0020-\u007E]/.test(type2)) {
          this[TYPE] = type2;
        }
      }
      get size() {
        return this[BUFFER].length;
      }
      get type() {
        return this[TYPE];
      }
      slice() {
        const size2 = this.size;
        const start = arguments[0];
        const end = arguments[1];
        let relativeStart, relativeEnd;
        if (start === void 0) {
          relativeStart = 0;
        } else if (start < 0) {
          relativeStart = Math.max(size2 + start, 0);
        } else {
          relativeStart = Math.min(start, size2);
        }
        if (end === void 0) {
          relativeEnd = size2;
        } else if (end < 0) {
          relativeEnd = Math.max(size2 + end, 0);
        } else {
          relativeEnd = Math.min(end, size2);
        }
        const span = Math.max(relativeEnd - relativeStart, 0);
        const buffer = this[BUFFER];
        const slicedBuffer = buffer.slice(relativeStart, relativeStart + span);
        const blob = new _Blob([], { type: arguments[2] });
        blob[BUFFER] = slicedBuffer;
        return blob;
      }
    };
    Object.defineProperties(Blob.prototype, {
      size: { enumerable: true },
      type: { enumerable: true },
      slice: { enumerable: true }
    });
    Object.defineProperty(Blob.prototype, Symbol.toStringTag, {
      value: "Blob",
      writable: false,
      enumerable: false,
      configurable: true
    });
    FetchError.prototype = Object.create(Error.prototype);
    FetchError.prototype.constructor = FetchError;
    FetchError.prototype.name = "FetchError";
    try {
      convert2 = require("encoding").convert;
    } catch (e) {
    }
    INTERNALS = Symbol("Body internals");
    PassThrough = import_stream.default.PassThrough;
    Body.prototype = {
      get body() {
        return this[INTERNALS].body;
      },
      get bodyUsed() {
        return this[INTERNALS].disturbed;
      },
      /**
       * Decode response as ArrayBuffer
       *
       * @return  Promise
       */
      arrayBuffer() {
        return consumeBody.call(this).then(function(buf) {
          return buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength);
        });
      },
      /**
       * Return raw response as Blob
       *
       * @return Promise
       */
      blob() {
        let ct = this.headers && this.headers.get("content-type") || "";
        return consumeBody.call(this).then(function(buf) {
          return Object.assign(
            // Prevent copying
            new Blob([], {
              type: ct.toLowerCase()
            }),
            {
              [BUFFER]: buf
            }
          );
        });
      },
      /**
       * Decode response as json
       *
       * @return  Promise
       */
      json() {
        var _this2 = this;
        return consumeBody.call(this).then(function(buffer) {
          try {
            return JSON.parse(buffer.toString());
          } catch (err) {
            return Body.Promise.reject(new FetchError(`invalid json response body at ${_this2.url} reason: ${err.message}`, "invalid-json"));
          }
        });
      },
      /**
       * Decode response as text
       *
       * @return  Promise
       */
      text() {
        return consumeBody.call(this).then(function(buffer) {
          return buffer.toString();
        });
      },
      /**
       * Decode response as buffer (non-spec api)
       *
       * @return  Promise
       */
      buffer() {
        return consumeBody.call(this);
      },
      /**
       * Decode response as text, while automatically detecting the encoding and
       * trying to decode to UTF-8 (non-spec api)
       *
       * @return  Promise
       */
      textConverted() {
        var _this3 = this;
        return consumeBody.call(this).then(function(buffer) {
          return convertBody(buffer, _this3.headers);
        });
      }
    };
    Object.defineProperties(Body.prototype, {
      body: { enumerable: true },
      bodyUsed: { enumerable: true },
      arrayBuffer: { enumerable: true },
      blob: { enumerable: true },
      json: { enumerable: true },
      text: { enumerable: true }
    });
    Body.mixIn = function(proto) {
      for (const name of Object.getOwnPropertyNames(Body.prototype)) {
        if (!(name in proto)) {
          const desc = Object.getOwnPropertyDescriptor(Body.prototype, name);
          Object.defineProperty(proto, name, desc);
        }
      }
    };
    Body.Promise = global.Promise;
    invalidTokenRegex = /[^\^_`a-zA-Z\-0-9!#$%&'*+.|~]/;
    invalidHeaderCharRegex = /[^\t\x20-\x7e\x80-\xff]/;
    MAP = Symbol("map");
    Headers = class _Headers {
      /**
       * Headers class
       *
       * @param   Object  headers  Response headers
       * @return  Void
       */
      constructor() {
        let init = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : void 0;
        this[MAP] = /* @__PURE__ */ Object.create(null);
        if (init instanceof _Headers) {
          const rawHeaders = init.raw();
          const headerNames = Object.keys(rawHeaders);
          for (const headerName of headerNames) {
            for (const value of rawHeaders[headerName]) {
              this.append(headerName, value);
            }
          }
          return;
        }
        if (init == null) ;
        else if (typeof init === "object") {
          const method = init[Symbol.iterator];
          if (method != null) {
            if (typeof method !== "function") {
              throw new TypeError("Header pairs must be iterable");
            }
            const pairs2 = [];
            for (const pair of init) {
              if (typeof pair !== "object" || typeof pair[Symbol.iterator] !== "function") {
                throw new TypeError("Each header pair must be iterable");
              }
              pairs2.push(Array.from(pair));
            }
            for (const pair of pairs2) {
              if (pair.length !== 2) {
                throw new TypeError("Each header pair must be a name/value tuple");
              }
              this.append(pair[0], pair[1]);
            }
          } else {
            for (const key of Object.keys(init)) {
              const value = init[key];
              this.append(key, value);
            }
          }
        } else {
          throw new TypeError("Provided initializer must be an object");
        }
      }
      /**
       * Return combined header value given name
       *
       * @param   String  name  Header name
       * @return  Mixed
       */
      get(name) {
        name = `${name}`;
        validateName(name);
        const key = find(this[MAP], name);
        if (key === void 0) {
          return null;
        }
        return this[MAP][key].join(", ");
      }
      /**
       * Iterate over all headers
       *
       * @param   Function  callback  Executed for each item with parameters (value, name, thisArg)
       * @param   Boolean   thisArg   `this` context for callback function
       * @return  Void
       */
      forEach(callback) {
        let thisArg = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : void 0;
        let pairs2 = getHeaders(this);
        let i = 0;
        while (i < pairs2.length) {
          var _pairs$i = pairs2[i];
          const name = _pairs$i[0], value = _pairs$i[1];
          callback.call(thisArg, value, name, this);
          pairs2 = getHeaders(this);
          i++;
        }
      }
      /**
       * Overwrite header values given name
       *
       * @param   String  name   Header name
       * @param   String  value  Header value
       * @return  Void
       */
      set(name, value) {
        name = `${name}`;
        value = `${value}`;
        validateName(name);
        validateValue(value);
        const key = find(this[MAP], name);
        this[MAP][key !== void 0 ? key : name] = [value];
      }
      /**
       * Append a value onto existing header
       *
       * @param   String  name   Header name
       * @param   String  value  Header value
       * @return  Void
       */
      append(name, value) {
        name = `${name}`;
        value = `${value}`;
        validateName(name);
        validateValue(value);
        const key = find(this[MAP], name);
        if (key !== void 0) {
          this[MAP][key].push(value);
        } else {
          this[MAP][name] = [value];
        }
      }
      /**
       * Check for header name existence
       *
       * @param   String   name  Header name
       * @return  Boolean
       */
      has(name) {
        name = `${name}`;
        validateName(name);
        return find(this[MAP], name) !== void 0;
      }
      /**
       * Delete all header values given name
       *
       * @param   String  name  Header name
       * @return  Void
       */
      delete(name) {
        name = `${name}`;
        validateName(name);
        const key = find(this[MAP], name);
        if (key !== void 0) {
          delete this[MAP][key];
        }
      }
      /**
       * Return raw headers (non-spec api)
       *
       * @return  Object
       */
      raw() {
        return this[MAP];
      }
      /**
       * Get an iterator on keys.
       *
       * @return  Iterator
       */
      keys() {
        return createHeadersIterator(this, "key");
      }
      /**
       * Get an iterator on values.
       *
       * @return  Iterator
       */
      values() {
        return createHeadersIterator(this, "value");
      }
      /**
       * Get an iterator on entries.
       *
       * This is the default iterator of the Headers object.
       *
       * @return  Iterator
       */
      [Symbol.iterator]() {
        return createHeadersIterator(this, "key+value");
      }
    };
    Headers.prototype.entries = Headers.prototype[Symbol.iterator];
    Object.defineProperty(Headers.prototype, Symbol.toStringTag, {
      value: "Headers",
      writable: false,
      enumerable: false,
      configurable: true
    });
    Object.defineProperties(Headers.prototype, {
      get: { enumerable: true },
      forEach: { enumerable: true },
      set: { enumerable: true },
      append: { enumerable: true },
      has: { enumerable: true },
      delete: { enumerable: true },
      keys: { enumerable: true },
      values: { enumerable: true },
      entries: { enumerable: true }
    });
    INTERNAL = Symbol("internal");
    HeadersIteratorPrototype = Object.setPrototypeOf({
      next() {
        if (!this || Object.getPrototypeOf(this) !== HeadersIteratorPrototype) {
          throw new TypeError("Value of `this` is not a HeadersIterator");
        }
        var _INTERNAL = this[INTERNAL];
        const target = _INTERNAL.target, kind = _INTERNAL.kind, index = _INTERNAL.index;
        const values = getHeaders(target, kind);
        const len = values.length;
        if (index >= len) {
          return {
            value: void 0,
            done: true
          };
        }
        this[INTERNAL].index = index + 1;
        return {
          value: values[index],
          done: false
        };
      }
    }, Object.getPrototypeOf(Object.getPrototypeOf([][Symbol.iterator]())));
    Object.defineProperty(HeadersIteratorPrototype, Symbol.toStringTag, {
      value: "HeadersIterator",
      writable: false,
      enumerable: false,
      configurable: true
    });
    INTERNALS$1 = Symbol("Response internals");
    STATUS_CODES = import_http.default.STATUS_CODES;
    Response2 = class _Response {
      constructor() {
        let body = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null;
        let opts = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        Body.call(this, body, opts);
        const status = opts.status || 200;
        const headers = new Headers(opts.headers);
        if (body != null && !headers.has("Content-Type")) {
          const contentType = extractContentType(body);
          if (contentType) {
            headers.append("Content-Type", contentType);
          }
        }
        this[INTERNALS$1] = {
          url: opts.url,
          status,
          statusText: opts.statusText || STATUS_CODES[status],
          headers
        };
      }
      get url() {
        return this[INTERNALS$1].url;
      }
      get status() {
        return this[INTERNALS$1].status;
      }
      /**
       * Convenience property representing if the request ended normally
       */
      get ok() {
        return this[INTERNALS$1].status >= 200 && this[INTERNALS$1].status < 300;
      }
      get statusText() {
        return this[INTERNALS$1].statusText;
      }
      get headers() {
        return this[INTERNALS$1].headers;
      }
      /**
       * Clone this response
       *
       * @return  Response
       */
      clone() {
        return new _Response(clone(this), {
          url: this.url,
          status: this.status,
          statusText: this.statusText,
          headers: this.headers,
          ok: this.ok
        });
      }
    };
    Body.mixIn(Response2.prototype);
    Object.defineProperties(Response2.prototype, {
      url: { enumerable: true },
      status: { enumerable: true },
      ok: { enumerable: true },
      statusText: { enumerable: true },
      headers: { enumerable: true },
      clone: { enumerable: true }
    });
    Object.defineProperty(Response2.prototype, Symbol.toStringTag, {
      value: "Response",
      writable: false,
      enumerable: false,
      configurable: true
    });
    INTERNALS$2 = Symbol("Request internals");
    parse_url = import_url.default.parse;
    format_url = import_url.default.format;
    streamDestructionSupported = "destroy" in import_stream.default.Readable.prototype;
    Request2 = class _Request {
      constructor(input) {
        let init = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        let parsedURL;
        if (!isRequest(input)) {
          if (input && input.href) {
            parsedURL = parse_url(input.href);
          } else {
            parsedURL = parse_url(`${input}`);
          }
          input = {};
        } else {
          parsedURL = parse_url(input.url);
        }
        let method = init.method || input.method || "GET";
        method = method.toUpperCase();
        if ((init.body != null || isRequest(input) && input.body !== null) && (method === "GET" || method === "HEAD")) {
          throw new TypeError("Request with GET/HEAD method cannot have body");
        }
        let inputBody = init.body != null ? init.body : isRequest(input) && input.body !== null ? clone(input) : null;
        Body.call(this, inputBody, {
          timeout: init.timeout || input.timeout || 0,
          size: init.size || input.size || 0
        });
        const headers = new Headers(init.headers || input.headers || {});
        if (inputBody != null && !headers.has("Content-Type")) {
          const contentType = extractContentType(inputBody);
          if (contentType) {
            headers.append("Content-Type", contentType);
          }
        }
        let signal = isRequest(input) ? input.signal : null;
        if ("signal" in init) signal = init.signal;
        if (signal != null && !isAbortSignal(signal)) {
          throw new TypeError("Expected signal to be an instanceof AbortSignal");
        }
        this[INTERNALS$2] = {
          method,
          redirect: init.redirect || input.redirect || "follow",
          headers,
          parsedURL,
          signal
        };
        this.follow = init.follow !== void 0 ? init.follow : input.follow !== void 0 ? input.follow : 20;
        this.compress = init.compress !== void 0 ? init.compress : input.compress !== void 0 ? input.compress : true;
        this.counter = init.counter || input.counter || 0;
        this.agent = init.agent || input.agent;
      }
      get method() {
        return this[INTERNALS$2].method;
      }
      get url() {
        return format_url(this[INTERNALS$2].parsedURL);
      }
      get headers() {
        return this[INTERNALS$2].headers;
      }
      get redirect() {
        return this[INTERNALS$2].redirect;
      }
      get signal() {
        return this[INTERNALS$2].signal;
      }
      /**
       * Clone this request
       *
       * @return  Request
       */
      clone() {
        return new _Request(this);
      }
    };
    Body.mixIn(Request2.prototype);
    Object.defineProperty(Request2.prototype, Symbol.toStringTag, {
      value: "Request",
      writable: false,
      enumerable: false,
      configurable: true
    });
    Object.defineProperties(Request2.prototype, {
      method: { enumerable: true },
      url: { enumerable: true },
      headers: { enumerable: true },
      redirect: { enumerable: true },
      clone: { enumerable: true },
      signal: { enumerable: true }
    });
    AbortError.prototype = Object.create(Error.prototype);
    AbortError.prototype.constructor = AbortError;
    AbortError.prototype.name = "AbortError";
    PassThrough$1 = import_stream.default.PassThrough;
    resolve_url = import_url.default.resolve;
    fetch.isRedirect = function(code) {
      return code === 301 || code === 302 || code === 303 || code === 307 || code === 308;
    };
    fetch.Promise = global.Promise;
    lib_default = fetch;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/identity.js
var require_identity = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/identity.js"(exports2) {
    "use strict";
    var ALIAS = Symbol.for("yaml.alias");
    var DOC = Symbol.for("yaml.document");
    var MAP3 = Symbol.for("yaml.map");
    var PAIR = Symbol.for("yaml.pair");
    var SCALAR = Symbol.for("yaml.scalar");
    var SEQ = Symbol.for("yaml.seq");
    var NODE_TYPE = Symbol.for("yaml.node.type");
    var isAlias = (node) => !!node && typeof node === "object" && node[NODE_TYPE] === ALIAS;
    var isDocument = (node) => !!node && typeof node === "object" && node[NODE_TYPE] === DOC;
    var isMap = (node) => !!node && typeof node === "object" && node[NODE_TYPE] === MAP3;
    var isPair = (node) => !!node && typeof node === "object" && node[NODE_TYPE] === PAIR;
    var isScalar = (node) => !!node && typeof node === "object" && node[NODE_TYPE] === SCALAR;
    var isSeq = (node) => !!node && typeof node === "object" && node[NODE_TYPE] === SEQ;
    function isCollection(node) {
      if (node && typeof node === "object")
        switch (node[NODE_TYPE]) {
          case MAP3:
          case SEQ:
            return true;
        }
      return false;
    }
    function isNode(node) {
      if (node && typeof node === "object")
        switch (node[NODE_TYPE]) {
          case ALIAS:
          case MAP3:
          case SCALAR:
          case SEQ:
            return true;
        }
      return false;
    }
    var hasAnchor = (node) => (isScalar(node) || isCollection(node)) && !!node.anchor;
    exports2.ALIAS = ALIAS;
    exports2.DOC = DOC;
    exports2.MAP = MAP3;
    exports2.NODE_TYPE = NODE_TYPE;
    exports2.PAIR = PAIR;
    exports2.SCALAR = SCALAR;
    exports2.SEQ = SEQ;
    exports2.hasAnchor = hasAnchor;
    exports2.isAlias = isAlias;
    exports2.isCollection = isCollection;
    exports2.isDocument = isDocument;
    exports2.isMap = isMap;
    exports2.isNode = isNode;
    exports2.isPair = isPair;
    exports2.isScalar = isScalar;
    exports2.isSeq = isSeq;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/visit.js
var require_visit = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/visit.js"(exports2) {
    "use strict";
    var identity2 = require_identity();
    var BREAK = Symbol("break visit");
    var SKIP = Symbol("skip children");
    var REMOVE = Symbol("remove node");
    function visit(node, visitor) {
      const visitor_ = initVisitor(visitor);
      if (identity2.isDocument(node)) {
        const cd = visit_(null, node.contents, visitor_, Object.freeze([node]));
        if (cd === REMOVE)
          node.contents = null;
      } else
        visit_(null, node, visitor_, Object.freeze([]));
    }
    visit.BREAK = BREAK;
    visit.SKIP = SKIP;
    visit.REMOVE = REMOVE;
    function visit_(key, node, visitor, path5) {
      const ctrl = callVisitor(key, node, visitor, path5);
      if (identity2.isNode(ctrl) || identity2.isPair(ctrl)) {
        replaceNode(key, path5, ctrl);
        return visit_(key, ctrl, visitor, path5);
      }
      if (typeof ctrl !== "symbol") {
        if (identity2.isCollection(node)) {
          path5 = Object.freeze(path5.concat(node));
          for (let i = 0; i < node.items.length; ++i) {
            const ci = visit_(i, node.items[i], visitor, path5);
            if (typeof ci === "number")
              i = ci - 1;
            else if (ci === BREAK)
              return BREAK;
            else if (ci === REMOVE) {
              node.items.splice(i, 1);
              i -= 1;
            }
          }
        } else if (identity2.isPair(node)) {
          path5 = Object.freeze(path5.concat(node));
          const ck = visit_("key", node.key, visitor, path5);
          if (ck === BREAK)
            return BREAK;
          else if (ck === REMOVE)
            node.key = null;
          const cv = visit_("value", node.value, visitor, path5);
          if (cv === BREAK)
            return BREAK;
          else if (cv === REMOVE)
            node.value = null;
        }
      }
      return ctrl;
    }
    async function visitAsync(node, visitor) {
      const visitor_ = initVisitor(visitor);
      if (identity2.isDocument(node)) {
        const cd = await visitAsync_(null, node.contents, visitor_, Object.freeze([node]));
        if (cd === REMOVE)
          node.contents = null;
      } else
        await visitAsync_(null, node, visitor_, Object.freeze([]));
    }
    visitAsync.BREAK = BREAK;
    visitAsync.SKIP = SKIP;
    visitAsync.REMOVE = REMOVE;
    async function visitAsync_(key, node, visitor, path5) {
      const ctrl = await callVisitor(key, node, visitor, path5);
      if (identity2.isNode(ctrl) || identity2.isPair(ctrl)) {
        replaceNode(key, path5, ctrl);
        return visitAsync_(key, ctrl, visitor, path5);
      }
      if (typeof ctrl !== "symbol") {
        if (identity2.isCollection(node)) {
          path5 = Object.freeze(path5.concat(node));
          for (let i = 0; i < node.items.length; ++i) {
            const ci = await visitAsync_(i, node.items[i], visitor, path5);
            if (typeof ci === "number")
              i = ci - 1;
            else if (ci === BREAK)
              return BREAK;
            else if (ci === REMOVE) {
              node.items.splice(i, 1);
              i -= 1;
            }
          }
        } else if (identity2.isPair(node)) {
          path5 = Object.freeze(path5.concat(node));
          const ck = await visitAsync_("key", node.key, visitor, path5);
          if (ck === BREAK)
            return BREAK;
          else if (ck === REMOVE)
            node.key = null;
          const cv = await visitAsync_("value", node.value, visitor, path5);
          if (cv === BREAK)
            return BREAK;
          else if (cv === REMOVE)
            node.value = null;
        }
      }
      return ctrl;
    }
    function initVisitor(visitor) {
      if (typeof visitor === "object" && (visitor.Collection || visitor.Node || visitor.Value)) {
        return Object.assign({
          Alias: visitor.Node,
          Map: visitor.Node,
          Scalar: visitor.Node,
          Seq: visitor.Node
        }, visitor.Value && {
          Map: visitor.Value,
          Scalar: visitor.Value,
          Seq: visitor.Value
        }, visitor.Collection && {
          Map: visitor.Collection,
          Seq: visitor.Collection
        }, visitor);
      }
      return visitor;
    }
    function callVisitor(key, node, visitor, path5) {
      if (typeof visitor === "function")
        return visitor(key, node, path5);
      if (identity2.isMap(node))
        return visitor.Map?.(key, node, path5);
      if (identity2.isSeq(node))
        return visitor.Seq?.(key, node, path5);
      if (identity2.isPair(node))
        return visitor.Pair?.(key, node, path5);
      if (identity2.isScalar(node))
        return visitor.Scalar?.(key, node, path5);
      if (identity2.isAlias(node))
        return visitor.Alias?.(key, node, path5);
      return void 0;
    }
    function replaceNode(key, path5, node) {
      const parent = path5[path5.length - 1];
      if (identity2.isCollection(parent)) {
        parent.items[key] = node;
      } else if (identity2.isPair(parent)) {
        if (key === "key")
          parent.key = node;
        else
          parent.value = node;
      } else if (identity2.isDocument(parent)) {
        parent.contents = node;
      } else {
        const pt = identity2.isAlias(parent) ? "alias" : "scalar";
        throw new Error(`Cannot replace node with ${pt} parent`);
      }
    }
    exports2.visit = visit;
    exports2.visitAsync = visitAsync;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/doc/directives.js
var require_directives = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/doc/directives.js"(exports2) {
    "use strict";
    var identity2 = require_identity();
    var visit = require_visit();
    var escapeChars = {
      "!": "%21",
      ",": "%2C",
      "[": "%5B",
      "]": "%5D",
      "{": "%7B",
      "}": "%7D"
    };
    var escapeTagName = (tn) => tn.replace(/[!,[\]{}]/g, (ch) => escapeChars[ch]);
    var Directives = class _Directives {
      constructor(yaml, tags) {
        this.docStart = null;
        this.docEnd = false;
        this.yaml = Object.assign({}, _Directives.defaultYaml, yaml);
        this.tags = Object.assign({}, _Directives.defaultTags, tags);
      }
      clone() {
        const copy = new _Directives(this.yaml, this.tags);
        copy.docStart = this.docStart;
        return copy;
      }
      /**
       * During parsing, get a Directives instance for the current document and
       * update the stream state according to the current version's spec.
       */
      atDocument() {
        const res = new _Directives(this.yaml, this.tags);
        switch (this.yaml.version) {
          case "1.1":
            this.atNextDocument = true;
            break;
          case "1.2":
            this.atNextDocument = false;
            this.yaml = {
              explicit: _Directives.defaultYaml.explicit,
              version: "1.2"
            };
            this.tags = Object.assign({}, _Directives.defaultTags);
            break;
        }
        return res;
      }
      /**
       * @param onError - May be called even if the action was successful
       * @returns `true` on success
       */
      add(line, onError) {
        if (this.atNextDocument) {
          this.yaml = { explicit: _Directives.defaultYaml.explicit, version: "1.1" };
          this.tags = Object.assign({}, _Directives.defaultTags);
          this.atNextDocument = false;
        }
        const parts = line.trim().split(/[ \t]+/);
        const name = parts.shift();
        switch (name) {
          case "%TAG": {
            if (parts.length !== 2) {
              onError(0, "%TAG directive should contain exactly two parts");
              if (parts.length < 2)
                return false;
            }
            const [handle, prefix] = parts;
            this.tags[handle] = prefix;
            return true;
          }
          case "%YAML": {
            this.yaml.explicit = true;
            if (parts.length !== 1) {
              onError(0, "%YAML directive should contain exactly one part");
              return false;
            }
            const [version] = parts;
            if (version === "1.1" || version === "1.2") {
              this.yaml.version = version;
              return true;
            } else {
              const isValid2 = /^\d+\.\d+$/.test(version);
              onError(6, `Unsupported YAML version ${version}`, isValid2);
              return false;
            }
          }
          default:
            onError(0, `Unknown directive ${name}`, true);
            return false;
        }
      }
      /**
       * Resolves a tag, matching handles to those defined in %TAG directives.
       *
       * @returns Resolved tag, which may also be the non-specific tag `'!'` or a
       *   `'!local'` tag, or `null` if unresolvable.
       */
      tagName(source, onError) {
        if (source === "!")
          return "!";
        if (source[0] !== "!") {
          onError(`Not a valid tag: ${source}`);
          return null;
        }
        if (source[1] === "<") {
          const verbatim = source.slice(2, -1);
          if (verbatim === "!" || verbatim === "!!") {
            onError(`Verbatim tags aren't resolved, so ${source} is invalid.`);
            return null;
          }
          if (source[source.length - 1] !== ">")
            onError("Verbatim tags must end with a >");
          return verbatim;
        }
        const [, handle, suffix] = source.match(/^(.*!)([^!]*)$/);
        if (!suffix)
          onError(`The ${source} tag has no suffix`);
        const prefix = this.tags[handle];
        if (prefix) {
          try {
            return prefix + decodeURIComponent(suffix);
          } catch (error) {
            onError(String(error));
            return null;
          }
        }
        if (handle === "!")
          return source;
        onError(`Could not resolve tag: ${source}`);
        return null;
      }
      /**
       * Given a fully resolved tag, returns its printable string form,
       * taking into account current tag prefixes and defaults.
       */
      tagString(tag) {
        for (const [handle, prefix] of Object.entries(this.tags)) {
          if (tag.startsWith(prefix))
            return handle + escapeTagName(tag.substring(prefix.length));
        }
        return tag[0] === "!" ? tag : `!<${tag}>`;
      }
      toString(doc) {
        const lines = this.yaml.explicit ? [`%YAML ${this.yaml.version || "1.2"}`] : [];
        const tagEntries = Object.entries(this.tags);
        let tagNames;
        if (doc && tagEntries.length > 0 && identity2.isNode(doc.contents)) {
          const tags = {};
          visit.visit(doc.contents, (_key, node) => {
            if (identity2.isNode(node) && node.tag)
              tags[node.tag] = true;
          });
          tagNames = Object.keys(tags);
        } else
          tagNames = [];
        for (const [handle, prefix] of tagEntries) {
          if (handle === "!!" && prefix === "tag:yaml.org,2002:")
            continue;
          if (!doc || tagNames.some((tn) => tn.startsWith(prefix)))
            lines.push(`%TAG ${handle} ${prefix}`);
        }
        return lines.join("\n");
      }
    };
    Directives.defaultYaml = { explicit: false, version: "1.2" };
    Directives.defaultTags = { "!!": "tag:yaml.org,2002:" };
    exports2.Directives = Directives;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/doc/anchors.js
var require_anchors = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/doc/anchors.js"(exports2) {
    "use strict";
    var identity2 = require_identity();
    var visit = require_visit();
    function anchorIsValid(anchor) {
      if (/[\x00-\x19\s,[\]{}]/.test(anchor)) {
        const sa = JSON.stringify(anchor);
        const msg = `Anchor must not contain whitespace or control characters: ${sa}`;
        throw new Error(msg);
      }
      return true;
    }
    function anchorNames(root2) {
      const anchors = /* @__PURE__ */ new Set();
      visit.visit(root2, {
        Value(_key, node) {
          if (node.anchor)
            anchors.add(node.anchor);
        }
      });
      return anchors;
    }
    function findNewAnchor(prefix, exclude) {
      for (let i = 1; true; ++i) {
        const name = `${prefix}${i}`;
        if (!exclude.has(name))
          return name;
      }
    }
    function createNodeAnchors(doc, prefix) {
      const aliasObjects = [];
      const sourceObjects = /* @__PURE__ */ new Map();
      let prevAnchors = null;
      return {
        onAnchor: (source) => {
          aliasObjects.push(source);
          if (!prevAnchors)
            prevAnchors = anchorNames(doc);
          const anchor = findNewAnchor(prefix, prevAnchors);
          prevAnchors.add(anchor);
          return anchor;
        },
        /**
         * With circular references, the source node is only resolved after all
         * of its child nodes are. This is why anchors are set only after all of
         * the nodes have been created.
         */
        setAnchors: () => {
          for (const source of aliasObjects) {
            const ref = sourceObjects.get(source);
            if (typeof ref === "object" && ref.anchor && (identity2.isScalar(ref.node) || identity2.isCollection(ref.node))) {
              ref.node.anchor = ref.anchor;
            } else {
              const error = new Error("Failed to resolve repeated object (this should not happen)");
              error.source = source;
              throw error;
            }
          }
        },
        sourceObjects
      };
    }
    exports2.anchorIsValid = anchorIsValid;
    exports2.anchorNames = anchorNames;
    exports2.createNodeAnchors = createNodeAnchors;
    exports2.findNewAnchor = findNewAnchor;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/doc/applyReviver.js
var require_applyReviver = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/doc/applyReviver.js"(exports2) {
    "use strict";
    function applyReviver(reviver, obj, key, val) {
      if (val && typeof val === "object") {
        if (Array.isArray(val)) {
          for (let i = 0, len = val.length; i < len; ++i) {
            const v0 = val[i];
            const v1 = applyReviver(reviver, val, String(i), v0);
            if (v1 === void 0)
              delete val[i];
            else if (v1 !== v0)
              val[i] = v1;
          }
        } else if (val instanceof Map) {
          for (const k of Array.from(val.keys())) {
            const v0 = val.get(k);
            const v1 = applyReviver(reviver, val, k, v0);
            if (v1 === void 0)
              val.delete(k);
            else if (v1 !== v0)
              val.set(k, v1);
          }
        } else if (val instanceof Set) {
          for (const v0 of Array.from(val)) {
            const v1 = applyReviver(reviver, val, v0, v0);
            if (v1 === void 0)
              val.delete(v0);
            else if (v1 !== v0) {
              val.delete(v0);
              val.add(v1);
            }
          }
        } else {
          for (const [k, v0] of Object.entries(val)) {
            const v1 = applyReviver(reviver, val, k, v0);
            if (v1 === void 0)
              delete val[k];
            else if (v1 !== v0)
              val[k] = v1;
          }
        }
      }
      return reviver.call(obj, key, val);
    }
    exports2.applyReviver = applyReviver;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/toJS.js
var require_toJS = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/toJS.js"(exports2) {
    "use strict";
    var identity2 = require_identity();
    function toJS(value, arg, ctx) {
      if (Array.isArray(value))
        return value.map((v, i) => toJS(v, String(i), ctx));
      if (value && typeof value.toJSON === "function") {
        if (!ctx || !identity2.hasAnchor(value))
          return value.toJSON(arg, ctx);
        const data = { aliasCount: 0, count: 1, res: void 0 };
        ctx.anchors.set(value, data);
        ctx.onCreate = (res2) => {
          data.res = res2;
          delete ctx.onCreate;
        };
        const res = value.toJSON(arg, ctx);
        if (ctx.onCreate)
          ctx.onCreate(res);
        return res;
      }
      if (typeof value === "bigint" && !ctx?.keep)
        return Number(value);
      return value;
    }
    exports2.toJS = toJS;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/Node.js
var require_Node = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/Node.js"(exports2) {
    "use strict";
    var applyReviver = require_applyReviver();
    var identity2 = require_identity();
    var toJS = require_toJS();
    var NodeBase = class {
      constructor(type2) {
        Object.defineProperty(this, identity2.NODE_TYPE, { value: type2 });
      }
      /** Create a copy of this node.  */
      clone() {
        const copy = Object.create(Object.getPrototypeOf(this), Object.getOwnPropertyDescriptors(this));
        if (this.range)
          copy.range = this.range.slice();
        return copy;
      }
      /** A plain JavaScript representation of this node. */
      toJS(doc, { mapAsMap, maxAliasCount, onAnchor, reviver } = {}) {
        if (!identity2.isDocument(doc))
          throw new TypeError("A document argument is required");
        const ctx = {
          anchors: /* @__PURE__ */ new Map(),
          doc,
          keep: true,
          mapAsMap: mapAsMap === true,
          mapKeyWarned: false,
          maxAliasCount: typeof maxAliasCount === "number" ? maxAliasCount : 100
        };
        const res = toJS.toJS(this, "", ctx);
        if (typeof onAnchor === "function")
          for (const { count, res: res2 } of ctx.anchors.values())
            onAnchor(res2, count);
        return typeof reviver === "function" ? applyReviver.applyReviver(reviver, { "": res }, "", res) : res;
      }
    };
    exports2.NodeBase = NodeBase;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/Alias.js
var require_Alias = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/Alias.js"(exports2) {
    "use strict";
    var anchors = require_anchors();
    var visit = require_visit();
    var identity2 = require_identity();
    var Node = require_Node();
    var toJS = require_toJS();
    var Alias = class extends Node.NodeBase {
      constructor(source) {
        super(identity2.ALIAS);
        this.source = source;
        Object.defineProperty(this, "tag", {
          set() {
            throw new Error("Alias nodes cannot have tags");
          }
        });
      }
      /**
       * Resolve the value of this alias within `doc`, finding the last
       * instance of the `source` anchor before this node.
       */
      resolve(doc) {
        let found = void 0;
        visit.visit(doc, {
          Node: (_key, node) => {
            if (node === this)
              return visit.visit.BREAK;
            if (node.anchor === this.source)
              found = node;
          }
        });
        return found;
      }
      toJSON(_arg, ctx) {
        if (!ctx)
          return { source: this.source };
        const { anchors: anchors2, doc, maxAliasCount } = ctx;
        const source = this.resolve(doc);
        if (!source) {
          const msg = `Unresolved alias (the anchor must be set before the alias): ${this.source}`;
          throw new ReferenceError(msg);
        }
        let data = anchors2.get(source);
        if (!data) {
          toJS.toJS(source, null, ctx);
          data = anchors2.get(source);
        }
        if (!data || data.res === void 0) {
          const msg = "This should not happen: Alias anchor was not resolved?";
          throw new ReferenceError(msg);
        }
        if (maxAliasCount >= 0) {
          data.count += 1;
          if (data.aliasCount === 0)
            data.aliasCount = getAliasCount(doc, source, anchors2);
          if (data.count * data.aliasCount > maxAliasCount) {
            const msg = "Excessive alias count indicates a resource exhaustion attack";
            throw new ReferenceError(msg);
          }
        }
        return data.res;
      }
      toString(ctx, _onComment, _onChompKeep) {
        const src = `*${this.source}`;
        if (ctx) {
          anchors.anchorIsValid(this.source);
          if (ctx.options.verifyAliasOrder && !ctx.anchors.has(this.source)) {
            const msg = `Unresolved alias (the anchor must be set before the alias): ${this.source}`;
            throw new Error(msg);
          }
          if (ctx.implicitKey)
            return `${src} `;
        }
        return src;
      }
    };
    function getAliasCount(doc, node, anchors2) {
      if (identity2.isAlias(node)) {
        const source = node.resolve(doc);
        const anchor = anchors2 && source && anchors2.get(source);
        return anchor ? anchor.count * anchor.aliasCount : 0;
      } else if (identity2.isCollection(node)) {
        let count = 0;
        for (const item of node.items) {
          const c = getAliasCount(doc, item, anchors2);
          if (c > count)
            count = c;
        }
        return count;
      } else if (identity2.isPair(node)) {
        const kc = getAliasCount(doc, node.key, anchors2);
        const vc = getAliasCount(doc, node.value, anchors2);
        return Math.max(kc, vc);
      }
      return 1;
    }
    exports2.Alias = Alias;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/Scalar.js
var require_Scalar = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/Scalar.js"(exports2) {
    "use strict";
    var identity2 = require_identity();
    var Node = require_Node();
    var toJS = require_toJS();
    var isScalarValue = (value) => !value || typeof value !== "function" && typeof value !== "object";
    var Scalar = class extends Node.NodeBase {
      constructor(value) {
        super(identity2.SCALAR);
        this.value = value;
      }
      toJSON(arg, ctx) {
        return ctx?.keep ? this.value : toJS.toJS(this.value, arg, ctx);
      }
      toString() {
        return String(this.value);
      }
    };
    Scalar.BLOCK_FOLDED = "BLOCK_FOLDED";
    Scalar.BLOCK_LITERAL = "BLOCK_LITERAL";
    Scalar.PLAIN = "PLAIN";
    Scalar.QUOTE_DOUBLE = "QUOTE_DOUBLE";
    Scalar.QUOTE_SINGLE = "QUOTE_SINGLE";
    exports2.Scalar = Scalar;
    exports2.isScalarValue = isScalarValue;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/doc/createNode.js
var require_createNode = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/doc/createNode.js"(exports2) {
    "use strict";
    var Alias = require_Alias();
    var identity2 = require_identity();
    var Scalar = require_Scalar();
    var defaultTagPrefix = "tag:yaml.org,2002:";
    function findTagObject(value, tagName, tags) {
      if (tagName) {
        const match = tags.filter((t) => t.tag === tagName);
        const tagObj = match.find((t) => !t.format) ?? match[0];
        if (!tagObj)
          throw new Error(`Tag ${tagName} not found`);
        return tagObj;
      }
      return tags.find((t) => t.identify?.(value) && !t.format);
    }
    function createNode(value, tagName, ctx) {
      if (identity2.isDocument(value))
        value = value.contents;
      if (identity2.isNode(value))
        return value;
      if (identity2.isPair(value)) {
        const map2 = ctx.schema[identity2.MAP].createNode?.(ctx.schema, null, ctx);
        map2.items.push(value);
        return map2;
      }
      if (value instanceof String || value instanceof Number || value instanceof Boolean || typeof BigInt !== "undefined" && value instanceof BigInt) {
        value = value.valueOf();
      }
      const { aliasDuplicateObjects, onAnchor, onTagObj, schema: schema2, sourceObjects } = ctx;
      let ref = void 0;
      if (aliasDuplicateObjects && value && typeof value === "object") {
        ref = sourceObjects.get(value);
        if (ref) {
          if (!ref.anchor)
            ref.anchor = onAnchor(value);
          return new Alias.Alias(ref.anchor);
        } else {
          ref = { anchor: null, node: null };
          sourceObjects.set(value, ref);
        }
      }
      if (tagName?.startsWith("!!"))
        tagName = defaultTagPrefix + tagName.slice(2);
      let tagObj = findTagObject(value, tagName, schema2.tags);
      if (!tagObj) {
        if (value && typeof value.toJSON === "function") {
          value = value.toJSON();
        }
        if (!value || typeof value !== "object") {
          const node2 = new Scalar.Scalar(value);
          if (ref)
            ref.node = node2;
          return node2;
        }
        tagObj = value instanceof Map ? schema2[identity2.MAP] : Symbol.iterator in Object(value) ? schema2[identity2.SEQ] : schema2[identity2.MAP];
      }
      if (onTagObj) {
        onTagObj(tagObj);
        delete ctx.onTagObj;
      }
      const node = tagObj?.createNode ? tagObj.createNode(ctx.schema, value, ctx) : typeof tagObj?.nodeClass?.from === "function" ? tagObj.nodeClass.from(ctx.schema, value, ctx) : new Scalar.Scalar(value);
      if (tagName)
        node.tag = tagName;
      else if (!tagObj.default)
        node.tag = tagObj.tag;
      if (ref)
        ref.node = node;
      return node;
    }
    exports2.createNode = createNode;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/Collection.js
var require_Collection = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/Collection.js"(exports2) {
    "use strict";
    var createNode = require_createNode();
    var identity2 = require_identity();
    var Node = require_Node();
    function collectionFromPath(schema2, path5, value) {
      let v = value;
      for (let i = path5.length - 1; i >= 0; --i) {
        const k = path5[i];
        if (typeof k === "number" && Number.isInteger(k) && k >= 0) {
          const a = [];
          a[k] = v;
          v = a;
        } else {
          v = /* @__PURE__ */ new Map([[k, v]]);
        }
      }
      return createNode.createNode(v, void 0, {
        aliasDuplicateObjects: false,
        keepUndefined: false,
        onAnchor: () => {
          throw new Error("This should not happen, please report a bug.");
        },
        schema: schema2,
        sourceObjects: /* @__PURE__ */ new Map()
      });
    }
    var isEmptyPath = (path5) => path5 == null || typeof path5 === "object" && !!path5[Symbol.iterator]().next().done;
    var Collection = class extends Node.NodeBase {
      constructor(type2, schema2) {
        super(type2);
        Object.defineProperty(this, "schema", {
          value: schema2,
          configurable: true,
          enumerable: false,
          writable: true
        });
      }
      /**
       * Create a copy of this collection.
       *
       * @param schema - If defined, overwrites the original's schema
       */
      clone(schema2) {
        const copy = Object.create(Object.getPrototypeOf(this), Object.getOwnPropertyDescriptors(this));
        if (schema2)
          copy.schema = schema2;
        copy.items = copy.items.map((it) => identity2.isNode(it) || identity2.isPair(it) ? it.clone(schema2) : it);
        if (this.range)
          copy.range = this.range.slice();
        return copy;
      }
      /**
       * Adds a value to the collection. For `!!map` and `!!omap` the value must
       * be a Pair instance or a `{ key, value }` object, which may not have a key
       * that already exists in the map.
       */
      addIn(path5, value) {
        if (isEmptyPath(path5))
          this.add(value);
        else {
          const [key, ...rest] = path5;
          const node = this.get(key, true);
          if (identity2.isCollection(node))
            node.addIn(rest, value);
          else if (node === void 0 && this.schema)
            this.set(key, collectionFromPath(this.schema, rest, value));
          else
            throw new Error(`Expected YAML collection at ${key}. Remaining path: ${rest}`);
        }
      }
      /**
       * Removes a value from the collection.
       * @returns `true` if the item was found and removed.
       */
      deleteIn(path5) {
        const [key, ...rest] = path5;
        if (rest.length === 0)
          return this.delete(key);
        const node = this.get(key, true);
        if (identity2.isCollection(node))
          return node.deleteIn(rest);
        else
          throw new Error(`Expected YAML collection at ${key}. Remaining path: ${rest}`);
      }
      /**
       * Returns item at `key`, or `undefined` if not found. By default unwraps
       * scalar values from their surrounding node; to disable set `keepScalar` to
       * `true` (collections are always returned intact).
       */
      getIn(path5, keepScalar) {
        const [key, ...rest] = path5;
        const node = this.get(key, true);
        if (rest.length === 0)
          return !keepScalar && identity2.isScalar(node) ? node.value : node;
        else
          return identity2.isCollection(node) ? node.getIn(rest, keepScalar) : void 0;
      }
      hasAllNullValues(allowScalar) {
        return this.items.every((node) => {
          if (!identity2.isPair(node))
            return false;
          const n = node.value;
          return n == null || allowScalar && identity2.isScalar(n) && n.value == null && !n.commentBefore && !n.comment && !n.tag;
        });
      }
      /**
       * Checks if the collection includes a value with the key `key`.
       */
      hasIn(path5) {
        const [key, ...rest] = path5;
        if (rest.length === 0)
          return this.has(key);
        const node = this.get(key, true);
        return identity2.isCollection(node) ? node.hasIn(rest) : false;
      }
      /**
       * Sets a value in this collection. For `!!set`, `value` needs to be a
       * boolean to add/remove the item from the set.
       */
      setIn(path5, value) {
        const [key, ...rest] = path5;
        if (rest.length === 0) {
          this.set(key, value);
        } else {
          const node = this.get(key, true);
          if (identity2.isCollection(node))
            node.setIn(rest, value);
          else if (node === void 0 && this.schema)
            this.set(key, collectionFromPath(this.schema, rest, value));
          else
            throw new Error(`Expected YAML collection at ${key}. Remaining path: ${rest}`);
        }
      }
    };
    Collection.maxFlowStringSingleLineLength = 60;
    exports2.Collection = Collection;
    exports2.collectionFromPath = collectionFromPath;
    exports2.isEmptyPath = isEmptyPath;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/stringify/stringifyComment.js
var require_stringifyComment = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/stringify/stringifyComment.js"(exports2) {
    "use strict";
    var stringifyComment = (str2) => str2.replace(/^(?!$)(?: $)?/gm, "#");
    function indentComment(comment, indent) {
      if (/^\n+$/.test(comment))
        return comment.substring(1);
      return indent ? comment.replace(/^(?! *$)/gm, indent) : comment;
    }
    var lineComment = (str2, indent, comment) => str2.endsWith("\n") ? indentComment(comment, indent) : comment.includes("\n") ? "\n" + indentComment(comment, indent) : (str2.endsWith(" ") ? "" : " ") + comment;
    exports2.indentComment = indentComment;
    exports2.lineComment = lineComment;
    exports2.stringifyComment = stringifyComment;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/stringify/foldFlowLines.js
var require_foldFlowLines = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/stringify/foldFlowLines.js"(exports2) {
    "use strict";
    var FOLD_FLOW = "flow";
    var FOLD_BLOCK = "block";
    var FOLD_QUOTED = "quoted";
    function foldFlowLines(text, indent, mode = "flow", { indentAtStart, lineWidth = 80, minContentWidth = 20, onFold, onOverflow } = {}) {
      if (!lineWidth || lineWidth < 0)
        return text;
      const endStep = Math.max(1 + minContentWidth, 1 + lineWidth - indent.length);
      if (text.length <= endStep)
        return text;
      const folds = [];
      const escapedFolds = {};
      let end = lineWidth - indent.length;
      if (typeof indentAtStart === "number") {
        if (indentAtStart > lineWidth - Math.max(2, minContentWidth))
          folds.push(0);
        else
          end = lineWidth - indentAtStart;
      }
      let split = void 0;
      let prev = void 0;
      let overflow = false;
      let i = -1;
      let escStart = -1;
      let escEnd = -1;
      if (mode === FOLD_BLOCK) {
        i = consumeMoreIndentedLines(text, i);
        if (i !== -1)
          end = i + endStep;
      }
      for (let ch; ch = text[i += 1]; ) {
        if (mode === FOLD_QUOTED && ch === "\\") {
          escStart = i;
          switch (text[i + 1]) {
            case "x":
              i += 3;
              break;
            case "u":
              i += 5;
              break;
            case "U":
              i += 9;
              break;
            default:
              i += 1;
          }
          escEnd = i;
        }
        if (ch === "\n") {
          if (mode === FOLD_BLOCK)
            i = consumeMoreIndentedLines(text, i);
          end = i + endStep;
          split = void 0;
        } else {
          if (ch === " " && prev && prev !== " " && prev !== "\n" && prev !== "	") {
            const next = text[i + 1];
            if (next && next !== " " && next !== "\n" && next !== "	")
              split = i;
          }
          if (i >= end) {
            if (split) {
              folds.push(split);
              end = split + endStep;
              split = void 0;
            } else if (mode === FOLD_QUOTED) {
              while (prev === " " || prev === "	") {
                prev = ch;
                ch = text[i += 1];
                overflow = true;
              }
              const j = i > escEnd + 1 ? i - 2 : escStart - 1;
              if (escapedFolds[j])
                return text;
              folds.push(j);
              escapedFolds[j] = true;
              end = j + endStep;
              split = void 0;
            } else {
              overflow = true;
            }
          }
        }
        prev = ch;
      }
      if (overflow && onOverflow)
        onOverflow();
      if (folds.length === 0)
        return text;
      if (onFold)
        onFold();
      let res = text.slice(0, folds[0]);
      for (let i2 = 0; i2 < folds.length; ++i2) {
        const fold = folds[i2];
        const end2 = folds[i2 + 1] || text.length;
        if (fold === 0)
          res = `
${indent}${text.slice(0, end2)}`;
        else {
          if (mode === FOLD_QUOTED && escapedFolds[fold])
            res += `${text[fold]}\\`;
          res += `
${indent}${text.slice(fold + 1, end2)}`;
        }
      }
      return res;
    }
    function consumeMoreIndentedLines(text, i) {
      let ch = text[i + 1];
      while (ch === " " || ch === "	") {
        do {
          ch = text[i += 1];
        } while (ch && ch !== "\n");
        ch = text[i + 1];
      }
      return i;
    }
    exports2.FOLD_BLOCK = FOLD_BLOCK;
    exports2.FOLD_FLOW = FOLD_FLOW;
    exports2.FOLD_QUOTED = FOLD_QUOTED;
    exports2.foldFlowLines = foldFlowLines;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/stringify/stringifyString.js
var require_stringifyString = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/stringify/stringifyString.js"(exports2) {
    "use strict";
    var Scalar = require_Scalar();
    var foldFlowLines = require_foldFlowLines();
    var getFoldOptions = (ctx, isBlock) => ({
      indentAtStart: isBlock ? ctx.indent.length : ctx.indentAtStart,
      lineWidth: ctx.options.lineWidth,
      minContentWidth: ctx.options.minContentWidth
    });
    var containsDocumentMarker = (str2) => /^(%|---|\.\.\.)/m.test(str2);
    function lineLengthOverLimit(str2, lineWidth, indentLength) {
      if (!lineWidth || lineWidth < 0)
        return false;
      const limit = lineWidth - indentLength;
      const strLen = str2.length;
      if (strLen <= limit)
        return false;
      for (let i = 0, start = 0; i < strLen; ++i) {
        if (str2[i] === "\n") {
          if (i - start > limit)
            return true;
          start = i + 1;
          if (strLen - start <= limit)
            return false;
        }
      }
      return true;
    }
    function doubleQuotedString(value, ctx) {
      const json2 = JSON.stringify(value);
      if (ctx.options.doubleQuotedAsJSON)
        return json2;
      const { implicitKey } = ctx;
      const minMultiLineLength = ctx.options.doubleQuotedMinMultiLineLength;
      const indent = ctx.indent || (containsDocumentMarker(value) ? "  " : "");
      let str2 = "";
      let start = 0;
      for (let i = 0, ch = json2[i]; ch; ch = json2[++i]) {
        if (ch === " " && json2[i + 1] === "\\" && json2[i + 2] === "n") {
          str2 += json2.slice(start, i) + "\\ ";
          i += 1;
          start = i;
          ch = "\\";
        }
        if (ch === "\\")
          switch (json2[i + 1]) {
            case "u":
              {
                str2 += json2.slice(start, i);
                const code = json2.substr(i + 2, 4);
                switch (code) {
                  case "0000":
                    str2 += "\\0";
                    break;
                  case "0007":
                    str2 += "\\a";
                    break;
                  case "000b":
                    str2 += "\\v";
                    break;
                  case "001b":
                    str2 += "\\e";
                    break;
                  case "0085":
                    str2 += "\\N";
                    break;
                  case "00a0":
                    str2 += "\\_";
                    break;
                  case "2028":
                    str2 += "\\L";
                    break;
                  case "2029":
                    str2 += "\\P";
                    break;
                  default:
                    if (code.substr(0, 2) === "00")
                      str2 += "\\x" + code.substr(2);
                    else
                      str2 += json2.substr(i, 6);
                }
                i += 5;
                start = i + 1;
              }
              break;
            case "n":
              if (implicitKey || json2[i + 2] === '"' || json2.length < minMultiLineLength) {
                i += 1;
              } else {
                str2 += json2.slice(start, i) + "\n\n";
                while (json2[i + 2] === "\\" && json2[i + 3] === "n" && json2[i + 4] !== '"') {
                  str2 += "\n";
                  i += 2;
                }
                str2 += indent;
                if (json2[i + 2] === " ")
                  str2 += "\\";
                i += 1;
                start = i + 1;
              }
              break;
            default:
              i += 1;
          }
      }
      str2 = start ? str2 + json2.slice(start) : json2;
      return implicitKey ? str2 : foldFlowLines.foldFlowLines(str2, indent, foldFlowLines.FOLD_QUOTED, getFoldOptions(ctx, false));
    }
    function singleQuotedString(value, ctx) {
      if (ctx.options.singleQuote === false || ctx.implicitKey && value.includes("\n") || /[ \t]\n|\n[ \t]/.test(value))
        return doubleQuotedString(value, ctx);
      const indent = ctx.indent || (containsDocumentMarker(value) ? "  " : "");
      const res = "'" + value.replace(/'/g, "''").replace(/\n+/g, `$&
${indent}`) + "'";
      return ctx.implicitKey ? res : foldFlowLines.foldFlowLines(res, indent, foldFlowLines.FOLD_FLOW, getFoldOptions(ctx, false));
    }
    function quotedString(value, ctx) {
      const { singleQuote } = ctx.options;
      let qs;
      if (singleQuote === false)
        qs = doubleQuotedString;
      else {
        const hasDouble = value.includes('"');
        const hasSingle = value.includes("'");
        if (hasDouble && !hasSingle)
          qs = singleQuotedString;
        else if (hasSingle && !hasDouble)
          qs = doubleQuotedString;
        else
          qs = singleQuote ? singleQuotedString : doubleQuotedString;
      }
      return qs(value, ctx);
    }
    var blockEndNewlines;
    try {
      blockEndNewlines = new RegExp("(^|(?<!\n))\n+(?!\n|$)", "g");
    } catch {
      blockEndNewlines = /\n+(?!\n|$)/g;
    }
    function blockString({ comment, type: type2, value }, ctx, onComment, onChompKeep) {
      const { blockQuote, commentString, lineWidth } = ctx.options;
      if (!blockQuote || /\n[\t ]+$/.test(value) || /^\s*$/.test(value)) {
        return quotedString(value, ctx);
      }
      const indent = ctx.indent || (ctx.forceBlockIndent || containsDocumentMarker(value) ? "  " : "");
      const literal = blockQuote === "literal" ? true : blockQuote === "folded" || type2 === Scalar.Scalar.BLOCK_FOLDED ? false : type2 === Scalar.Scalar.BLOCK_LITERAL ? true : !lineLengthOverLimit(value, lineWidth, indent.length);
      if (!value)
        return literal ? "|\n" : ">\n";
      let chomp;
      let endStart;
      for (endStart = value.length; endStart > 0; --endStart) {
        const ch = value[endStart - 1];
        if (ch !== "\n" && ch !== "	" && ch !== " ")
          break;
      }
      let end = value.substring(endStart);
      const endNlPos = end.indexOf("\n");
      if (endNlPos === -1) {
        chomp = "-";
      } else if (value === end || endNlPos !== end.length - 1) {
        chomp = "+";
        if (onChompKeep)
          onChompKeep();
      } else {
        chomp = "";
      }
      if (end) {
        value = value.slice(0, -end.length);
        if (end[end.length - 1] === "\n")
          end = end.slice(0, -1);
        end = end.replace(blockEndNewlines, `$&${indent}`);
      }
      let startWithSpace = false;
      let startEnd;
      let startNlPos = -1;
      for (startEnd = 0; startEnd < value.length; ++startEnd) {
        const ch = value[startEnd];
        if (ch === " ")
          startWithSpace = true;
        else if (ch === "\n")
          startNlPos = startEnd;
        else
          break;
      }
      let start = value.substring(0, startNlPos < startEnd ? startNlPos + 1 : startEnd);
      if (start) {
        value = value.substring(start.length);
        start = start.replace(/\n+/g, `$&${indent}`);
      }
      const indentSize = indent ? "2" : "1";
      let header = (literal ? "|" : ">") + (startWithSpace ? indentSize : "") + chomp;
      if (comment) {
        header += " " + commentString(comment.replace(/ ?[\r\n]+/g, " "));
        if (onComment)
          onComment();
      }
      if (literal) {
        value = value.replace(/\n+/g, `$&${indent}`);
        return `${header}
${indent}${start}${value}${end}`;
      }
      value = value.replace(/\n+/g, "\n$&").replace(/(?:^|\n)([\t ].*)(?:([\n\t ]*)\n(?![\n\t ]))?/g, "$1$2").replace(/\n+/g, `$&${indent}`);
      const body = foldFlowLines.foldFlowLines(`${start}${value}${end}`, indent, foldFlowLines.FOLD_BLOCK, getFoldOptions(ctx, true));
      return `${header}
${indent}${body}`;
    }
    function plainString(item, ctx, onComment, onChompKeep) {
      const { type: type2, value } = item;
      const { actualString, implicitKey, indent, indentStep, inFlow } = ctx;
      if (implicitKey && value.includes("\n") || inFlow && /[[\]{},]/.test(value)) {
        return quotedString(value, ctx);
      }
      if (!value || /^[\n\t ,[\]{}#&*!|>'"%@`]|^[?-]$|^[?-][ \t]|[\n:][ \t]|[ \t]\n|[\n\t ]#|[\n\t :]$/.test(value)) {
        return implicitKey || inFlow || !value.includes("\n") ? quotedString(value, ctx) : blockString(item, ctx, onComment, onChompKeep);
      }
      if (!implicitKey && !inFlow && type2 !== Scalar.Scalar.PLAIN && value.includes("\n")) {
        return blockString(item, ctx, onComment, onChompKeep);
      }
      if (containsDocumentMarker(value)) {
        if (indent === "") {
          ctx.forceBlockIndent = true;
          return blockString(item, ctx, onComment, onChompKeep);
        } else if (implicitKey && indent === indentStep) {
          return quotedString(value, ctx);
        }
      }
      const str2 = value.replace(/\n+/g, `$&
${indent}`);
      if (actualString) {
        const test = (tag) => tag.default && tag.tag !== "tag:yaml.org,2002:str" && tag.test?.test(str2);
        const { compat, tags } = ctx.doc.schema;
        if (tags.some(test) || compat?.some(test))
          return quotedString(value, ctx);
      }
      return implicitKey ? str2 : foldFlowLines.foldFlowLines(str2, indent, foldFlowLines.FOLD_FLOW, getFoldOptions(ctx, false));
    }
    function stringifyString(item, ctx, onComment, onChompKeep) {
      const { implicitKey, inFlow } = ctx;
      const ss = typeof item.value === "string" ? item : Object.assign({}, item, { value: String(item.value) });
      let { type: type2 } = item;
      if (type2 !== Scalar.Scalar.QUOTE_DOUBLE) {
        if (/[\x00-\x08\x0b-\x1f\x7f-\x9f\u{D800}-\u{DFFF}]/u.test(ss.value))
          type2 = Scalar.Scalar.QUOTE_DOUBLE;
      }
      const _stringify = (_type) => {
        switch (_type) {
          case Scalar.Scalar.BLOCK_FOLDED:
          case Scalar.Scalar.BLOCK_LITERAL:
            return implicitKey || inFlow ? quotedString(ss.value, ctx) : blockString(ss, ctx, onComment, onChompKeep);
          case Scalar.Scalar.QUOTE_DOUBLE:
            return doubleQuotedString(ss.value, ctx);
          case Scalar.Scalar.QUOTE_SINGLE:
            return singleQuotedString(ss.value, ctx);
          case Scalar.Scalar.PLAIN:
            return plainString(ss, ctx, onComment, onChompKeep);
          default:
            return null;
        }
      };
      let res = _stringify(type2);
      if (res === null) {
        const { defaultKeyType, defaultStringType } = ctx.options;
        const t = implicitKey && defaultKeyType || defaultStringType;
        res = _stringify(t);
        if (res === null)
          throw new Error(`Unsupported default string type ${t}`);
      }
      return res;
    }
    exports2.stringifyString = stringifyString;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/stringify/stringify.js
var require_stringify = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/stringify/stringify.js"(exports2) {
    "use strict";
    var anchors = require_anchors();
    var identity2 = require_identity();
    var stringifyComment = require_stringifyComment();
    var stringifyString = require_stringifyString();
    function createStringifyContext(doc, options) {
      const opt = Object.assign({
        blockQuote: true,
        commentString: stringifyComment.stringifyComment,
        defaultKeyType: null,
        defaultStringType: "PLAIN",
        directives: null,
        doubleQuotedAsJSON: false,
        doubleQuotedMinMultiLineLength: 40,
        falseStr: "false",
        flowCollectionPadding: true,
        indentSeq: true,
        lineWidth: 80,
        minContentWidth: 20,
        nullStr: "null",
        simpleKeys: false,
        singleQuote: null,
        trueStr: "true",
        verifyAliasOrder: true
      }, doc.schema.toStringOptions, options);
      let inFlow;
      switch (opt.collectionStyle) {
        case "block":
          inFlow = false;
          break;
        case "flow":
          inFlow = true;
          break;
        default:
          inFlow = null;
      }
      return {
        anchors: /* @__PURE__ */ new Set(),
        doc,
        flowCollectionPadding: opt.flowCollectionPadding ? " " : "",
        indent: "",
        indentStep: typeof opt.indent === "number" ? " ".repeat(opt.indent) : "  ",
        inFlow,
        options: opt
      };
    }
    function getTagObject(tags, item) {
      if (item.tag) {
        const match = tags.filter((t) => t.tag === item.tag);
        if (match.length > 0)
          return match.find((t) => t.format === item.format) ?? match[0];
      }
      let tagObj = void 0;
      let obj;
      if (identity2.isScalar(item)) {
        obj = item.value;
        const match = tags.filter((t) => t.identify?.(obj));
        tagObj = match.find((t) => t.format === item.format) ?? match.find((t) => !t.format);
      } else {
        obj = item;
        tagObj = tags.find((t) => t.nodeClass && obj instanceof t.nodeClass);
      }
      if (!tagObj) {
        const name = obj?.constructor?.name ?? typeof obj;
        throw new Error(`Tag not resolved for ${name} value`);
      }
      return tagObj;
    }
    function stringifyProps(node, tagObj, { anchors: anchors$1, doc }) {
      if (!doc.directives)
        return "";
      const props = [];
      const anchor = (identity2.isScalar(node) || identity2.isCollection(node)) && node.anchor;
      if (anchor && anchors.anchorIsValid(anchor)) {
        anchors$1.add(anchor);
        props.push(`&${anchor}`);
      }
      const tag = node.tag ? node.tag : tagObj.default ? null : tagObj.tag;
      if (tag)
        props.push(doc.directives.tagString(tag));
      return props.join(" ");
    }
    function stringify(item, ctx, onComment, onChompKeep) {
      if (identity2.isPair(item))
        return item.toString(ctx, onComment, onChompKeep);
      if (identity2.isAlias(item)) {
        if (ctx.doc.directives)
          return item.toString(ctx);
        if (ctx.resolvedAliases?.has(item)) {
          throw new TypeError(`Cannot stringify circular structure without alias nodes`);
        } else {
          if (ctx.resolvedAliases)
            ctx.resolvedAliases.add(item);
          else
            ctx.resolvedAliases = /* @__PURE__ */ new Set([item]);
          item = item.resolve(ctx.doc);
        }
      }
      let tagObj = void 0;
      const node = identity2.isNode(item) ? item : ctx.doc.createNode(item, { onTagObj: (o) => tagObj = o });
      if (!tagObj)
        tagObj = getTagObject(ctx.doc.schema.tags, node);
      const props = stringifyProps(node, tagObj, ctx);
      if (props.length > 0)
        ctx.indentAtStart = (ctx.indentAtStart ?? 0) + props.length + 1;
      const str2 = typeof tagObj.stringify === "function" ? tagObj.stringify(node, ctx, onComment, onChompKeep) : identity2.isScalar(node) ? stringifyString.stringifyString(node, ctx, onComment, onChompKeep) : node.toString(ctx, onComment, onChompKeep);
      if (!props)
        return str2;
      return identity2.isScalar(node) || str2[0] === "{" || str2[0] === "[" ? `${props} ${str2}` : `${props}
${ctx.indent}${str2}`;
    }
    exports2.createStringifyContext = createStringifyContext;
    exports2.stringify = stringify;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/stringify/stringifyPair.js
var require_stringifyPair = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/stringify/stringifyPair.js"(exports2) {
    "use strict";
    var identity2 = require_identity();
    var Scalar = require_Scalar();
    var stringify = require_stringify();
    var stringifyComment = require_stringifyComment();
    function stringifyPair({ key, value }, ctx, onComment, onChompKeep) {
      const { allNullValues, doc, indent, indentStep, options: { commentString, indentSeq, simpleKeys } } = ctx;
      let keyComment = identity2.isNode(key) && key.comment || null;
      if (simpleKeys) {
        if (keyComment) {
          throw new Error("With simple keys, key nodes cannot have comments");
        }
        if (identity2.isCollection(key)) {
          const msg = "With simple keys, collection cannot be used as a key value";
          throw new Error(msg);
        }
      }
      let explicitKey = !simpleKeys && (!key || keyComment && value == null && !ctx.inFlow || identity2.isCollection(key) || (identity2.isScalar(key) ? key.type === Scalar.Scalar.BLOCK_FOLDED || key.type === Scalar.Scalar.BLOCK_LITERAL : typeof key === "object"));
      ctx = Object.assign({}, ctx, {
        allNullValues: false,
        implicitKey: !explicitKey && (simpleKeys || !allNullValues),
        indent: indent + indentStep
      });
      let keyCommentDone = false;
      let chompKeep = false;
      let str2 = stringify.stringify(key, ctx, () => keyCommentDone = true, () => chompKeep = true);
      if (!explicitKey && !ctx.inFlow && str2.length > 1024) {
        if (simpleKeys)
          throw new Error("With simple keys, single line scalar must not span more than 1024 characters");
        explicitKey = true;
      }
      if (ctx.inFlow) {
        if (allNullValues || value == null) {
          if (keyCommentDone && onComment)
            onComment();
          return str2 === "" ? "?" : explicitKey ? `? ${str2}` : str2;
        }
      } else if (allNullValues && !simpleKeys || value == null && explicitKey) {
        str2 = `? ${str2}`;
        if (keyComment && !keyCommentDone) {
          str2 += stringifyComment.lineComment(str2, ctx.indent, commentString(keyComment));
        } else if (chompKeep && onChompKeep)
          onChompKeep();
        return str2;
      }
      if (keyCommentDone)
        keyComment = null;
      if (explicitKey) {
        if (keyComment)
          str2 += stringifyComment.lineComment(str2, ctx.indent, commentString(keyComment));
        str2 = `? ${str2}
${indent}:`;
      } else {
        str2 = `${str2}:`;
        if (keyComment)
          str2 += stringifyComment.lineComment(str2, ctx.indent, commentString(keyComment));
      }
      let vsb, vcb, valueComment;
      if (identity2.isNode(value)) {
        vsb = !!value.spaceBefore;
        vcb = value.commentBefore;
        valueComment = value.comment;
      } else {
        vsb = false;
        vcb = null;
        valueComment = null;
        if (value && typeof value === "object")
          value = doc.createNode(value);
      }
      ctx.implicitKey = false;
      if (!explicitKey && !keyComment && identity2.isScalar(value))
        ctx.indentAtStart = str2.length + 1;
      chompKeep = false;
      if (!indentSeq && indentStep.length >= 2 && !ctx.inFlow && !explicitKey && identity2.isSeq(value) && !value.flow && !value.tag && !value.anchor) {
        ctx.indent = ctx.indent.substring(2);
      }
      let valueCommentDone = false;
      const valueStr = stringify.stringify(value, ctx, () => valueCommentDone = true, () => chompKeep = true);
      let ws = " ";
      if (keyComment || vsb || vcb) {
        ws = vsb ? "\n" : "";
        if (vcb) {
          const cs = commentString(vcb);
          ws += `
${stringifyComment.indentComment(cs, ctx.indent)}`;
        }
        if (valueStr === "" && !ctx.inFlow) {
          if (ws === "\n")
            ws = "\n\n";
        } else {
          ws += `
${ctx.indent}`;
        }
      } else if (!explicitKey && identity2.isCollection(value)) {
        const vs0 = valueStr[0];
        const nl0 = valueStr.indexOf("\n");
        const hasNewline = nl0 !== -1;
        const flow = ctx.inFlow ?? value.flow ?? value.items.length === 0;
        if (hasNewline || !flow) {
          let hasPropsLine = false;
          if (hasNewline && (vs0 === "&" || vs0 === "!")) {
            let sp0 = valueStr.indexOf(" ");
            if (vs0 === "&" && sp0 !== -1 && sp0 < nl0 && valueStr[sp0 + 1] === "!") {
              sp0 = valueStr.indexOf(" ", sp0 + 1);
            }
            if (sp0 === -1 || nl0 < sp0)
              hasPropsLine = true;
          }
          if (!hasPropsLine)
            ws = `
${ctx.indent}`;
        }
      } else if (valueStr === "" || valueStr[0] === "\n") {
        ws = "";
      }
      str2 += ws + valueStr;
      if (ctx.inFlow) {
        if (valueCommentDone && onComment)
          onComment();
      } else if (valueComment && !valueCommentDone) {
        str2 += stringifyComment.lineComment(str2, ctx.indent, commentString(valueComment));
      } else if (chompKeep && onChompKeep) {
        onChompKeep();
      }
      return str2;
    }
    exports2.stringifyPair = stringifyPair;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/log.js
var require_log = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/log.js"(exports2) {
    "use strict";
    function debug(logLevel, ...messages) {
      if (logLevel === "debug")
        console.log(...messages);
    }
    function warn(logLevel, warning) {
      if (logLevel === "debug" || logLevel === "warn") {
        if (typeof process !== "undefined" && process.emitWarning)
          process.emitWarning(warning);
        else
          console.warn(warning);
      }
    }
    exports2.debug = debug;
    exports2.warn = warn;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/addPairToJSMap.js
var require_addPairToJSMap = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/addPairToJSMap.js"(exports2) {
    "use strict";
    var log = require_log();
    var stringify = require_stringify();
    var identity2 = require_identity();
    var Scalar = require_Scalar();
    var toJS = require_toJS();
    var MERGE_KEY = "<<";
    function addPairToJSMap(ctx, map2, { key, value }) {
      if (ctx?.doc.schema.merge && isMergeKey(key)) {
        value = identity2.isAlias(value) ? value.resolve(ctx.doc) : value;
        if (identity2.isSeq(value))
          for (const it of value.items)
            mergeToJSMap(ctx, map2, it);
        else if (Array.isArray(value))
          for (const it of value)
            mergeToJSMap(ctx, map2, it);
        else
          mergeToJSMap(ctx, map2, value);
      } else {
        const jsKey = toJS.toJS(key, "", ctx);
        if (map2 instanceof Map) {
          map2.set(jsKey, toJS.toJS(value, jsKey, ctx));
        } else if (map2 instanceof Set) {
          map2.add(jsKey);
        } else {
          const stringKey = stringifyKey(key, jsKey, ctx);
          const jsValue = toJS.toJS(value, stringKey, ctx);
          if (stringKey in map2)
            Object.defineProperty(map2, stringKey, {
              value: jsValue,
              writable: true,
              enumerable: true,
              configurable: true
            });
          else
            map2[stringKey] = jsValue;
        }
      }
      return map2;
    }
    var isMergeKey = (key) => key === MERGE_KEY || identity2.isScalar(key) && key.value === MERGE_KEY && (!key.type || key.type === Scalar.Scalar.PLAIN);
    function mergeToJSMap(ctx, map2, value) {
      const source = ctx && identity2.isAlias(value) ? value.resolve(ctx.doc) : value;
      if (!identity2.isMap(source))
        throw new Error("Merge sources must be maps or map aliases");
      const srcMap = source.toJSON(null, ctx, Map);
      for (const [key, value2] of srcMap) {
        if (map2 instanceof Map) {
          if (!map2.has(key))
            map2.set(key, value2);
        } else if (map2 instanceof Set) {
          map2.add(key);
        } else if (!Object.prototype.hasOwnProperty.call(map2, key)) {
          Object.defineProperty(map2, key, {
            value: value2,
            writable: true,
            enumerable: true,
            configurable: true
          });
        }
      }
      return map2;
    }
    function stringifyKey(key, jsKey, ctx) {
      if (jsKey === null)
        return "";
      if (typeof jsKey !== "object")
        return String(jsKey);
      if (identity2.isNode(key) && ctx?.doc) {
        const strCtx = stringify.createStringifyContext(ctx.doc, {});
        strCtx.anchors = /* @__PURE__ */ new Set();
        for (const node of ctx.anchors.keys())
          strCtx.anchors.add(node.anchor);
        strCtx.inFlow = true;
        strCtx.inStringifyKey = true;
        const strKey = key.toString(strCtx);
        if (!ctx.mapKeyWarned) {
          let jsonStr = JSON.stringify(strKey);
          if (jsonStr.length > 40)
            jsonStr = jsonStr.substring(0, 36) + '..."';
          log.warn(ctx.doc.options.logLevel, `Keys with collection values will be stringified due to JS Object restrictions: ${jsonStr}. Set mapAsMap: true to use object keys.`);
          ctx.mapKeyWarned = true;
        }
        return strKey;
      }
      return JSON.stringify(jsKey);
    }
    exports2.addPairToJSMap = addPairToJSMap;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/Pair.js
var require_Pair = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/Pair.js"(exports2) {
    "use strict";
    var createNode = require_createNode();
    var stringifyPair = require_stringifyPair();
    var addPairToJSMap = require_addPairToJSMap();
    var identity2 = require_identity();
    function createPair(key, value, ctx) {
      const k = createNode.createNode(key, void 0, ctx);
      const v = createNode.createNode(value, void 0, ctx);
      return new Pair(k, v);
    }
    var Pair = class _Pair {
      constructor(key, value = null) {
        Object.defineProperty(this, identity2.NODE_TYPE, { value: identity2.PAIR });
        this.key = key;
        this.value = value;
      }
      clone(schema2) {
        let { key, value } = this;
        if (identity2.isNode(key))
          key = key.clone(schema2);
        if (identity2.isNode(value))
          value = value.clone(schema2);
        return new _Pair(key, value);
      }
      toJSON(_, ctx) {
        const pair = ctx?.mapAsMap ? /* @__PURE__ */ new Map() : {};
        return addPairToJSMap.addPairToJSMap(ctx, pair, this);
      }
      toString(ctx, onComment, onChompKeep) {
        return ctx?.doc ? stringifyPair.stringifyPair(this, ctx, onComment, onChompKeep) : JSON.stringify(this);
      }
    };
    exports2.Pair = Pair;
    exports2.createPair = createPair;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/stringify/stringifyCollection.js
var require_stringifyCollection = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/stringify/stringifyCollection.js"(exports2) {
    "use strict";
    var Collection = require_Collection();
    var identity2 = require_identity();
    var stringify = require_stringify();
    var stringifyComment = require_stringifyComment();
    function stringifyCollection(collection, ctx, options) {
      const flow = ctx.inFlow ?? collection.flow;
      const stringify2 = flow ? stringifyFlowCollection : stringifyBlockCollection;
      return stringify2(collection, ctx, options);
    }
    function stringifyBlockCollection({ comment, items }, ctx, { blockItemPrefix, flowChars, itemIndent, onChompKeep, onComment }) {
      const { indent, options: { commentString } } = ctx;
      const itemCtx = Object.assign({}, ctx, { indent: itemIndent, type: null });
      let chompKeep = false;
      const lines = [];
      for (let i = 0; i < items.length; ++i) {
        const item = items[i];
        let comment2 = null;
        if (identity2.isNode(item)) {
          if (!chompKeep && item.spaceBefore)
            lines.push("");
          addCommentBefore(ctx, lines, item.commentBefore, chompKeep);
          if (item.comment)
            comment2 = item.comment;
        } else if (identity2.isPair(item)) {
          const ik = identity2.isNode(item.key) ? item.key : null;
          if (ik) {
            if (!chompKeep && ik.spaceBefore)
              lines.push("");
            addCommentBefore(ctx, lines, ik.commentBefore, chompKeep);
          }
        }
        chompKeep = false;
        let str3 = stringify.stringify(item, itemCtx, () => comment2 = null, () => chompKeep = true);
        if (comment2)
          str3 += stringifyComment.lineComment(str3, itemIndent, commentString(comment2));
        if (chompKeep && comment2)
          chompKeep = false;
        lines.push(blockItemPrefix + str3);
      }
      let str2;
      if (lines.length === 0) {
        str2 = flowChars.start + flowChars.end;
      } else {
        str2 = lines[0];
        for (let i = 1; i < lines.length; ++i) {
          const line = lines[i];
          str2 += line ? `
${indent}${line}` : "\n";
        }
      }
      if (comment) {
        str2 += "\n" + stringifyComment.indentComment(commentString(comment), indent);
        if (onComment)
          onComment();
      } else if (chompKeep && onChompKeep)
        onChompKeep();
      return str2;
    }
    function stringifyFlowCollection({ comment, items }, ctx, { flowChars, itemIndent, onComment }) {
      const { indent, indentStep, flowCollectionPadding: fcPadding, options: { commentString } } = ctx;
      itemIndent += indentStep;
      const itemCtx = Object.assign({}, ctx, {
        indent: itemIndent,
        inFlow: true,
        type: null
      });
      let reqNewline = false;
      let linesAtValue = 0;
      const lines = [];
      for (let i = 0; i < items.length; ++i) {
        const item = items[i];
        let comment2 = null;
        if (identity2.isNode(item)) {
          if (item.spaceBefore)
            lines.push("");
          addCommentBefore(ctx, lines, item.commentBefore, false);
          if (item.comment)
            comment2 = item.comment;
        } else if (identity2.isPair(item)) {
          const ik = identity2.isNode(item.key) ? item.key : null;
          if (ik) {
            if (ik.spaceBefore)
              lines.push("");
            addCommentBefore(ctx, lines, ik.commentBefore, false);
            if (ik.comment)
              reqNewline = true;
          }
          const iv = identity2.isNode(item.value) ? item.value : null;
          if (iv) {
            if (iv.comment)
              comment2 = iv.comment;
            if (iv.commentBefore)
              reqNewline = true;
          } else if (item.value == null && ik?.comment) {
            comment2 = ik.comment;
          }
        }
        if (comment2)
          reqNewline = true;
        let str3 = stringify.stringify(item, itemCtx, () => comment2 = null);
        if (i < items.length - 1)
          str3 += ",";
        if (comment2)
          str3 += stringifyComment.lineComment(str3, itemIndent, commentString(comment2));
        if (!reqNewline && (lines.length > linesAtValue || str3.includes("\n")))
          reqNewline = true;
        lines.push(str3);
        linesAtValue = lines.length;
      }
      let str2;
      const { start, end } = flowChars;
      if (lines.length === 0) {
        str2 = start + end;
      } else {
        if (!reqNewline) {
          const len = lines.reduce((sum, line) => sum + line.length + 2, 2);
          reqNewline = len > Collection.Collection.maxFlowStringSingleLineLength;
        }
        if (reqNewline) {
          str2 = start;
          for (const line of lines)
            str2 += line ? `
${indentStep}${indent}${line}` : "\n";
          str2 += `
${indent}${end}`;
        } else {
          str2 = `${start}${fcPadding}${lines.join(" ")}${fcPadding}${end}`;
        }
      }
      if (comment) {
        str2 += stringifyComment.lineComment(str2, indent, commentString(comment));
        if (onComment)
          onComment();
      }
      return str2;
    }
    function addCommentBefore({ indent, options: { commentString } }, lines, comment, chompKeep) {
      if (comment && chompKeep)
        comment = comment.replace(/^\n+/, "");
      if (comment) {
        const ic = stringifyComment.indentComment(commentString(comment), indent);
        lines.push(ic.trimStart());
      }
    }
    exports2.stringifyCollection = stringifyCollection;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/YAMLMap.js
var require_YAMLMap = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/YAMLMap.js"(exports2) {
    "use strict";
    var stringifyCollection = require_stringifyCollection();
    var addPairToJSMap = require_addPairToJSMap();
    var Collection = require_Collection();
    var identity2 = require_identity();
    var Pair = require_Pair();
    var Scalar = require_Scalar();
    function findPair(items, key) {
      const k = identity2.isScalar(key) ? key.value : key;
      for (const it of items) {
        if (identity2.isPair(it)) {
          if (it.key === key || it.key === k)
            return it;
          if (identity2.isScalar(it.key) && it.key.value === k)
            return it;
        }
      }
      return void 0;
    }
    var YAMLMap = class extends Collection.Collection {
      static get tagName() {
        return "tag:yaml.org,2002:map";
      }
      constructor(schema2) {
        super(identity2.MAP, schema2);
        this.items = [];
      }
      /**
       * A generic collection parsing method that can be extended
       * to other node classes that inherit from YAMLMap
       */
      static from(schema2, obj, ctx) {
        const { keepUndefined, replacer } = ctx;
        const map2 = new this(schema2);
        const add = (key, value) => {
          if (typeof replacer === "function")
            value = replacer.call(obj, key, value);
          else if (Array.isArray(replacer) && !replacer.includes(key))
            return;
          if (value !== void 0 || keepUndefined)
            map2.items.push(Pair.createPair(key, value, ctx));
        };
        if (obj instanceof Map) {
          for (const [key, value] of obj)
            add(key, value);
        } else if (obj && typeof obj === "object") {
          for (const key of Object.keys(obj))
            add(key, obj[key]);
        }
        if (typeof schema2.sortMapEntries === "function") {
          map2.items.sort(schema2.sortMapEntries);
        }
        return map2;
      }
      /**
       * Adds a value to the collection.
       *
       * @param overwrite - If not set `true`, using a key that is already in the
       *   collection will throw. Otherwise, overwrites the previous value.
       */
      add(pair, overwrite) {
        let _pair;
        if (identity2.isPair(pair))
          _pair = pair;
        else if (!pair || typeof pair !== "object" || !("key" in pair)) {
          _pair = new Pair.Pair(pair, pair?.value);
        } else
          _pair = new Pair.Pair(pair.key, pair.value);
        const prev = findPair(this.items, _pair.key);
        const sortEntries = this.schema?.sortMapEntries;
        if (prev) {
          if (!overwrite)
            throw new Error(`Key ${_pair.key} already set`);
          if (identity2.isScalar(prev.value) && Scalar.isScalarValue(_pair.value))
            prev.value.value = _pair.value;
          else
            prev.value = _pair.value;
        } else if (sortEntries) {
          const i = this.items.findIndex((item) => sortEntries(_pair, item) < 0);
          if (i === -1)
            this.items.push(_pair);
          else
            this.items.splice(i, 0, _pair);
        } else {
          this.items.push(_pair);
        }
      }
      delete(key) {
        const it = findPair(this.items, key);
        if (!it)
          return false;
        const del = this.items.splice(this.items.indexOf(it), 1);
        return del.length > 0;
      }
      get(key, keepScalar) {
        const it = findPair(this.items, key);
        const node = it?.value;
        return (!keepScalar && identity2.isScalar(node) ? node.value : node) ?? void 0;
      }
      has(key) {
        return !!findPair(this.items, key);
      }
      set(key, value) {
        this.add(new Pair.Pair(key, value), true);
      }
      /**
       * @param ctx - Conversion context, originally set in Document#toJS()
       * @param {Class} Type - If set, forces the returned collection type
       * @returns Instance of Type, Map, or Object
       */
      toJSON(_, ctx, Type3) {
        const map2 = Type3 ? new Type3() : ctx?.mapAsMap ? /* @__PURE__ */ new Map() : {};
        if (ctx?.onCreate)
          ctx.onCreate(map2);
        for (const item of this.items)
          addPairToJSMap.addPairToJSMap(ctx, map2, item);
        return map2;
      }
      toString(ctx, onComment, onChompKeep) {
        if (!ctx)
          return JSON.stringify(this);
        for (const item of this.items) {
          if (!identity2.isPair(item))
            throw new Error(`Map items must all be pairs; found ${JSON.stringify(item)} instead`);
        }
        if (!ctx.allNullValues && this.hasAllNullValues(false))
          ctx = Object.assign({}, ctx, { allNullValues: true });
        return stringifyCollection.stringifyCollection(this, ctx, {
          blockItemPrefix: "",
          flowChars: { start: "{", end: "}" },
          itemIndent: ctx.indent || "",
          onChompKeep,
          onComment
        });
      }
    };
    exports2.YAMLMap = YAMLMap;
    exports2.findPair = findPair;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/common/map.js
var require_map = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/common/map.js"(exports2) {
    "use strict";
    var identity2 = require_identity();
    var YAMLMap = require_YAMLMap();
    var map2 = {
      collection: "map",
      default: true,
      nodeClass: YAMLMap.YAMLMap,
      tag: "tag:yaml.org,2002:map",
      resolve(map3, onError) {
        if (!identity2.isMap(map3))
          onError("Expected a mapping for this tag");
        return map3;
      },
      createNode: (schema2, obj, ctx) => YAMLMap.YAMLMap.from(schema2, obj, ctx)
    };
    exports2.map = map2;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/YAMLSeq.js
var require_YAMLSeq = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/nodes/YAMLSeq.js"(exports2) {
    "use strict";
    var createNode = require_createNode();
    var stringifyCollection = require_stringifyCollection();
    var Collection = require_Collection();
    var identity2 = require_identity();
    var Scalar = require_Scalar();
    var toJS = require_toJS();
    var YAMLSeq = class extends Collection.Collection {
      static get tagName() {
        return "tag:yaml.org,2002:seq";
      }
      constructor(schema2) {
        super(identity2.SEQ, schema2);
        this.items = [];
      }
      add(value) {
        this.items.push(value);
      }
      /**
       * Removes a value from the collection.
       *
       * `key` must contain a representation of an integer for this to succeed.
       * It may be wrapped in a `Scalar`.
       *
       * @returns `true` if the item was found and removed.
       */
      delete(key) {
        const idx = asItemIndex(key);
        if (typeof idx !== "number")
          return false;
        const del = this.items.splice(idx, 1);
        return del.length > 0;
      }
      get(key, keepScalar) {
        const idx = asItemIndex(key);
        if (typeof idx !== "number")
          return void 0;
        const it = this.items[idx];
        return !keepScalar && identity2.isScalar(it) ? it.value : it;
      }
      /**
       * Checks if the collection includes a value with the key `key`.
       *
       * `key` must contain a representation of an integer for this to succeed.
       * It may be wrapped in a `Scalar`.
       */
      has(key) {
        const idx = asItemIndex(key);
        return typeof idx === "number" && idx < this.items.length;
      }
      /**
       * Sets a value in this collection. For `!!set`, `value` needs to be a
       * boolean to add/remove the item from the set.
       *
       * If `key` does not contain a representation of an integer, this will throw.
       * It may be wrapped in a `Scalar`.
       */
      set(key, value) {
        const idx = asItemIndex(key);
        if (typeof idx !== "number")
          throw new Error(`Expected a valid index, not ${key}.`);
        const prev = this.items[idx];
        if (identity2.isScalar(prev) && Scalar.isScalarValue(value))
          prev.value = value;
        else
          this.items[idx] = value;
      }
      toJSON(_, ctx) {
        const seq2 = [];
        if (ctx?.onCreate)
          ctx.onCreate(seq2);
        let i = 0;
        for (const item of this.items)
          seq2.push(toJS.toJS(item, String(i++), ctx));
        return seq2;
      }
      toString(ctx, onComment, onChompKeep) {
        if (!ctx)
          return JSON.stringify(this);
        return stringifyCollection.stringifyCollection(this, ctx, {
          blockItemPrefix: "- ",
          flowChars: { start: "[", end: "]" },
          itemIndent: (ctx.indent || "") + "  ",
          onChompKeep,
          onComment
        });
      }
      static from(schema2, obj, ctx) {
        const { replacer } = ctx;
        const seq2 = new this(schema2);
        if (obj && Symbol.iterator in Object(obj)) {
          let i = 0;
          for (let it of obj) {
            if (typeof replacer === "function") {
              const key = obj instanceof Set ? it : String(i++);
              it = replacer.call(obj, key, it);
            }
            seq2.items.push(createNode.createNode(it, void 0, ctx));
          }
        }
        return seq2;
      }
    };
    function asItemIndex(key) {
      let idx = identity2.isScalar(key) ? key.value : key;
      if (idx && typeof idx === "string")
        idx = Number(idx);
      return typeof idx === "number" && Number.isInteger(idx) && idx >= 0 ? idx : null;
    }
    exports2.YAMLSeq = YAMLSeq;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/common/seq.js
var require_seq = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/common/seq.js"(exports2) {
    "use strict";
    var identity2 = require_identity();
    var YAMLSeq = require_YAMLSeq();
    var seq2 = {
      collection: "seq",
      default: true,
      nodeClass: YAMLSeq.YAMLSeq,
      tag: "tag:yaml.org,2002:seq",
      resolve(seq3, onError) {
        if (!identity2.isSeq(seq3))
          onError("Expected a sequence for this tag");
        return seq3;
      },
      createNode: (schema2, obj, ctx) => YAMLSeq.YAMLSeq.from(schema2, obj, ctx)
    };
    exports2.seq = seq2;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/common/string.js
var require_string = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/common/string.js"(exports2) {
    "use strict";
    var stringifyString = require_stringifyString();
    var string3 = {
      identify: (value) => typeof value === "string",
      default: true,
      tag: "tag:yaml.org,2002:str",
      resolve: (str2) => str2,
      stringify(item, ctx, onComment, onChompKeep) {
        ctx = Object.assign({ actualString: true }, ctx);
        return stringifyString.stringifyString(item, ctx, onComment, onChompKeep);
      }
    };
    exports2.string = string3;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/common/null.js
var require_null = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/common/null.js"(exports2) {
    "use strict";
    var Scalar = require_Scalar();
    var nullTag2 = {
      identify: (value) => value == null,
      createNode: () => new Scalar.Scalar(null),
      default: true,
      tag: "tag:yaml.org,2002:null",
      test: /^(?:~|[Nn]ull|NULL)?$/,
      resolve: () => new Scalar.Scalar(null),
      stringify: ({ source }, ctx) => typeof source === "string" && nullTag2.test.test(source) ? source : ctx.options.nullStr
    };
    exports2.nullTag = nullTag2;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/core/bool.js
var require_bool = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/core/bool.js"(exports2) {
    "use strict";
    var Scalar = require_Scalar();
    var boolTag3 = {
      identify: (value) => typeof value === "boolean",
      default: true,
      tag: "tag:yaml.org,2002:bool",
      test: /^(?:[Tt]rue|TRUE|[Ff]alse|FALSE)$/,
      resolve: (str2) => new Scalar.Scalar(str2[0] === "t" || str2[0] === "T"),
      stringify({ source, value }, ctx) {
        if (source && boolTag3.test.test(source)) {
          const sv = source[0] === "t" || source[0] === "T";
          if (value === sv)
            return source;
        }
        return value ? ctx.options.trueStr : ctx.options.falseStr;
      }
    };
    exports2.boolTag = boolTag3;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/stringify/stringifyNumber.js
var require_stringifyNumber = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/stringify/stringifyNumber.js"(exports2) {
    "use strict";
    function stringifyNumber({ format, minFractionDigits, tag, value }) {
      if (typeof value === "bigint")
        return String(value);
      const num = typeof value === "number" ? value : Number(value);
      if (!isFinite(num))
        return isNaN(num) ? ".nan" : num < 0 ? "-.inf" : ".inf";
      let n = JSON.stringify(value);
      if (!format && minFractionDigits && (!tag || tag === "tag:yaml.org,2002:float") && /^\d/.test(n)) {
        let i = n.indexOf(".");
        if (i < 0) {
          i = n.length;
          n += ".";
        }
        let d = minFractionDigits - (n.length - i - 1);
        while (d-- > 0)
          n += "0";
      }
      return n;
    }
    exports2.stringifyNumber = stringifyNumber;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/core/float.js
var require_float = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/core/float.js"(exports2) {
    "use strict";
    var Scalar = require_Scalar();
    var stringifyNumber = require_stringifyNumber();
    var floatNaN = {
      identify: (value) => typeof value === "number",
      default: true,
      tag: "tag:yaml.org,2002:float",
      test: /^(?:[-+]?\.(?:inf|Inf|INF|nan|NaN|NAN))$/,
      resolve: (str2) => str2.slice(-3).toLowerCase() === "nan" ? NaN : str2[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY,
      stringify: stringifyNumber.stringifyNumber
    };
    var floatExp = {
      identify: (value) => typeof value === "number",
      default: true,
      tag: "tag:yaml.org,2002:float",
      format: "EXP",
      test: /^[-+]?(?:\.[0-9]+|[0-9]+(?:\.[0-9]*)?)[eE][-+]?[0-9]+$/,
      resolve: (str2) => parseFloat(str2),
      stringify(node) {
        const num = Number(node.value);
        return isFinite(num) ? num.toExponential() : stringifyNumber.stringifyNumber(node);
      }
    };
    var float2 = {
      identify: (value) => typeof value === "number",
      default: true,
      tag: "tag:yaml.org,2002:float",
      test: /^[-+]?(?:\.[0-9]+|[0-9]+\.[0-9]*)$/,
      resolve(str2) {
        const node = new Scalar.Scalar(parseFloat(str2));
        const dot = str2.indexOf(".");
        if (dot !== -1 && str2[str2.length - 1] === "0")
          node.minFractionDigits = str2.length - dot - 1;
        return node;
      },
      stringify: stringifyNumber.stringifyNumber
    };
    exports2.float = float2;
    exports2.floatExp = floatExp;
    exports2.floatNaN = floatNaN;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/core/int.js
var require_int = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/core/int.js"(exports2) {
    "use strict";
    var stringifyNumber = require_stringifyNumber();
    var intIdentify = (value) => typeof value === "bigint" || Number.isInteger(value);
    var intResolve = (str2, offset, radix, { intAsBigInt }) => intAsBigInt ? BigInt(str2) : parseInt(str2.substring(offset), radix);
    function intStringify(node, radix, prefix) {
      const { value } = node;
      if (intIdentify(value) && value >= 0)
        return prefix + value.toString(radix);
      return stringifyNumber.stringifyNumber(node);
    }
    var intOct = {
      identify: (value) => intIdentify(value) && value >= 0,
      default: true,
      tag: "tag:yaml.org,2002:int",
      format: "OCT",
      test: /^0o[0-7]+$/,
      resolve: (str2, _onError, opt) => intResolve(str2, 2, 8, opt),
      stringify: (node) => intStringify(node, 8, "0o")
    };
    var int2 = {
      identify: intIdentify,
      default: true,
      tag: "tag:yaml.org,2002:int",
      test: /^[-+]?[0-9]+$/,
      resolve: (str2, _onError, opt) => intResolve(str2, 0, 10, opt),
      stringify: stringifyNumber.stringifyNumber
    };
    var intHex = {
      identify: (value) => intIdentify(value) && value >= 0,
      default: true,
      tag: "tag:yaml.org,2002:int",
      format: "HEX",
      test: /^0x[0-9a-fA-F]+$/,
      resolve: (str2, _onError, opt) => intResolve(str2, 2, 16, opt),
      stringify: (node) => intStringify(node, 16, "0x")
    };
    exports2.int = int2;
    exports2.intHex = intHex;
    exports2.intOct = intOct;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/core/schema.js
var require_schema = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/core/schema.js"(exports2) {
    "use strict";
    var map2 = require_map();
    var _null2 = require_null();
    var seq2 = require_seq();
    var string3 = require_string();
    var bool2 = require_bool();
    var float2 = require_float();
    var int2 = require_int();
    var schema2 = [
      map2.map,
      seq2.seq,
      string3.string,
      _null2.nullTag,
      bool2.boolTag,
      int2.intOct,
      int2.int,
      int2.intHex,
      float2.floatNaN,
      float2.floatExp,
      float2.float
    ];
    exports2.schema = schema2;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/json/schema.js
var require_schema2 = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/json/schema.js"(exports2) {
    "use strict";
    var Scalar = require_Scalar();
    var map2 = require_map();
    var seq2 = require_seq();
    function intIdentify(value) {
      return typeof value === "bigint" || Number.isInteger(value);
    }
    var stringifyJSON = ({ value }) => JSON.stringify(value);
    var jsonScalars = [
      {
        identify: (value) => typeof value === "string",
        default: true,
        tag: "tag:yaml.org,2002:str",
        resolve: (str2) => str2,
        stringify: stringifyJSON
      },
      {
        identify: (value) => value == null,
        createNode: () => new Scalar.Scalar(null),
        default: true,
        tag: "tag:yaml.org,2002:null",
        test: /^null$/,
        resolve: () => null,
        stringify: stringifyJSON
      },
      {
        identify: (value) => typeof value === "boolean",
        default: true,
        tag: "tag:yaml.org,2002:bool",
        test: /^true|false$/,
        resolve: (str2) => str2 === "true",
        stringify: stringifyJSON
      },
      {
        identify: intIdentify,
        default: true,
        tag: "tag:yaml.org,2002:int",
        test: /^-?(?:0|[1-9][0-9]*)$/,
        resolve: (str2, _onError, { intAsBigInt }) => intAsBigInt ? BigInt(str2) : parseInt(str2, 10),
        stringify: ({ value }) => intIdentify(value) ? value.toString() : JSON.stringify(value)
      },
      {
        identify: (value) => typeof value === "number",
        default: true,
        tag: "tag:yaml.org,2002:float",
        test: /^-?(?:0|[1-9][0-9]*)(?:\.[0-9]*)?(?:[eE][-+]?[0-9]+)?$/,
        resolve: (str2) => parseFloat(str2),
        stringify: stringifyJSON
      }
    ];
    var jsonError = {
      default: true,
      tag: "",
      test: /^/,
      resolve(str2, onError) {
        onError(`Unresolved plain scalar ${JSON.stringify(str2)}`);
        return str2;
      }
    };
    var schema2 = [map2.map, seq2.seq].concat(jsonScalars, jsonError);
    exports2.schema = schema2;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/binary.js
var require_binary = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/binary.js"(exports2) {
    "use strict";
    var Scalar = require_Scalar();
    var stringifyString = require_stringifyString();
    var binary2 = {
      identify: (value) => value instanceof Uint8Array,
      default: false,
      tag: "tag:yaml.org,2002:binary",
      /**
       * Returns a Buffer in node and an Uint8Array in browsers
       *
       * To use the resulting buffer as an image, you'll want to do something like:
       *
       *   const blob = new Blob([buffer], { type: 'image/jpeg' })
       *   document.querySelector('#photo').src = URL.createObjectURL(blob)
       */
      resolve(src, onError) {
        if (typeof Buffer === "function") {
          return Buffer.from(src, "base64");
        } else if (typeof atob === "function") {
          const str2 = atob(src.replace(/[\n\r]/g, ""));
          const buffer = new Uint8Array(str2.length);
          for (let i = 0; i < str2.length; ++i)
            buffer[i] = str2.charCodeAt(i);
          return buffer;
        } else {
          onError("This environment does not support reading binary tags; either Buffer or atob is required");
          return src;
        }
      },
      stringify({ comment, type: type2, value }, ctx, onComment, onChompKeep) {
        const buf = value;
        let str2;
        if (typeof Buffer === "function") {
          str2 = buf instanceof Buffer ? buf.toString("base64") : Buffer.from(buf.buffer).toString("base64");
        } else if (typeof btoa === "function") {
          let s = "";
          for (let i = 0; i < buf.length; ++i)
            s += String.fromCharCode(buf[i]);
          str2 = btoa(s);
        } else {
          throw new Error("This environment does not support writing binary tags; either Buffer or btoa is required");
        }
        if (!type2)
          type2 = Scalar.Scalar.BLOCK_LITERAL;
        if (type2 !== Scalar.Scalar.QUOTE_DOUBLE) {
          const lineWidth = Math.max(ctx.options.lineWidth - ctx.indent.length, ctx.options.minContentWidth);
          const n = Math.ceil(str2.length / lineWidth);
          const lines = new Array(n);
          for (let i = 0, o = 0; i < n; ++i, o += lineWidth) {
            lines[i] = str2.substr(o, lineWidth);
          }
          str2 = lines.join(type2 === Scalar.Scalar.BLOCK_LITERAL ? "\n" : " ");
        }
        return stringifyString.stringifyString({ comment, type: type2, value: str2 }, ctx, onComment, onChompKeep);
      }
    };
    exports2.binary = binary2;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/pairs.js
var require_pairs = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/pairs.js"(exports2) {
    "use strict";
    var identity2 = require_identity();
    var Pair = require_Pair();
    var Scalar = require_Scalar();
    var YAMLSeq = require_YAMLSeq();
    function resolvePairs(seq2, onError) {
      if (identity2.isSeq(seq2)) {
        for (let i = 0; i < seq2.items.length; ++i) {
          let item = seq2.items[i];
          if (identity2.isPair(item))
            continue;
          else if (identity2.isMap(item)) {
            if (item.items.length > 1)
              onError("Each pair must have its own sequence indicator");
            const pair = item.items[0] || new Pair.Pair(new Scalar.Scalar(null));
            if (item.commentBefore)
              pair.key.commentBefore = pair.key.commentBefore ? `${item.commentBefore}
${pair.key.commentBefore}` : item.commentBefore;
            if (item.comment) {
              const cn = pair.value ?? pair.key;
              cn.comment = cn.comment ? `${item.comment}
${cn.comment}` : item.comment;
            }
            item = pair;
          }
          seq2.items[i] = identity2.isPair(item) ? item : new Pair.Pair(item);
        }
      } else
        onError("Expected a sequence for this tag");
      return seq2;
    }
    function createPairs(schema2, iterable, ctx) {
      const { replacer } = ctx;
      const pairs3 = new YAMLSeq.YAMLSeq(schema2);
      pairs3.tag = "tag:yaml.org,2002:pairs";
      let i = 0;
      if (iterable && Symbol.iterator in Object(iterable))
        for (let it of iterable) {
          if (typeof replacer === "function")
            it = replacer.call(iterable, String(i++), it);
          let key, value;
          if (Array.isArray(it)) {
            if (it.length === 2) {
              key = it[0];
              value = it[1];
            } else
              throw new TypeError(`Expected [key, value] tuple: ${it}`);
          } else if (it && it instanceof Object) {
            const keys5 = Object.keys(it);
            if (keys5.length === 1) {
              key = keys5[0];
              value = it[key];
            } else {
              throw new TypeError(`Expected tuple with one key, not ${keys5.length} keys`);
            }
          } else {
            key = it;
          }
          pairs3.items.push(Pair.createPair(key, value, ctx));
        }
      return pairs3;
    }
    var pairs2 = {
      collection: "seq",
      default: false,
      tag: "tag:yaml.org,2002:pairs",
      resolve: resolvePairs,
      createNode: createPairs
    };
    exports2.createPairs = createPairs;
    exports2.pairs = pairs2;
    exports2.resolvePairs = resolvePairs;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/omap.js
var require_omap = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/omap.js"(exports2) {
    "use strict";
    var identity2 = require_identity();
    var toJS = require_toJS();
    var YAMLMap = require_YAMLMap();
    var YAMLSeq = require_YAMLSeq();
    var pairs2 = require_pairs();
    var YAMLOMap = class _YAMLOMap extends YAMLSeq.YAMLSeq {
      constructor() {
        super();
        this.add = YAMLMap.YAMLMap.prototype.add.bind(this);
        this.delete = YAMLMap.YAMLMap.prototype.delete.bind(this);
        this.get = YAMLMap.YAMLMap.prototype.get.bind(this);
        this.has = YAMLMap.YAMLMap.prototype.has.bind(this);
        this.set = YAMLMap.YAMLMap.prototype.set.bind(this);
        this.tag = _YAMLOMap.tag;
      }
      /**
       * If `ctx` is given, the return type is actually `Map<unknown, unknown>`,
       * but TypeScript won't allow widening the signature of a child method.
       */
      toJSON(_, ctx) {
        if (!ctx)
          return super.toJSON(_);
        const map2 = /* @__PURE__ */ new Map();
        if (ctx?.onCreate)
          ctx.onCreate(map2);
        for (const pair of this.items) {
          let key, value;
          if (identity2.isPair(pair)) {
            key = toJS.toJS(pair.key, "", ctx);
            value = toJS.toJS(pair.value, key, ctx);
          } else {
            key = toJS.toJS(pair, "", ctx);
          }
          if (map2.has(key))
            throw new Error("Ordered maps must not include duplicate keys");
          map2.set(key, value);
        }
        return map2;
      }
      static from(schema2, iterable, ctx) {
        const pairs$1 = pairs2.createPairs(schema2, iterable, ctx);
        const omap3 = new this();
        omap3.items = pairs$1.items;
        return omap3;
      }
    };
    YAMLOMap.tag = "tag:yaml.org,2002:omap";
    var omap2 = {
      collection: "seq",
      identify: (value) => value instanceof Map,
      nodeClass: YAMLOMap,
      default: false,
      tag: "tag:yaml.org,2002:omap",
      resolve(seq2, onError) {
        const pairs$1 = pairs2.resolvePairs(seq2, onError);
        const seenKeys = [];
        for (const { key } of pairs$1.items) {
          if (identity2.isScalar(key)) {
            if (seenKeys.includes(key.value)) {
              onError(`Ordered maps must not include duplicate keys: ${key.value}`);
            } else {
              seenKeys.push(key.value);
            }
          }
        }
        return Object.assign(new YAMLOMap(), pairs$1);
      },
      createNode: (schema2, iterable, ctx) => YAMLOMap.from(schema2, iterable, ctx)
    };
    exports2.YAMLOMap = YAMLOMap;
    exports2.omap = omap2;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/bool.js
var require_bool2 = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/bool.js"(exports2) {
    "use strict";
    var Scalar = require_Scalar();
    function boolStringify({ value, source }, ctx) {
      const boolObj = value ? trueTag : falseTag;
      if (source && boolObj.test.test(source))
        return source;
      return value ? ctx.options.trueStr : ctx.options.falseStr;
    }
    var trueTag = {
      identify: (value) => value === true,
      default: true,
      tag: "tag:yaml.org,2002:bool",
      test: /^(?:Y|y|[Yy]es|YES|[Tt]rue|TRUE|[Oo]n|ON)$/,
      resolve: () => new Scalar.Scalar(true),
      stringify: boolStringify
    };
    var falseTag = {
      identify: (value) => value === false,
      default: true,
      tag: "tag:yaml.org,2002:bool",
      test: /^(?:N|n|[Nn]o|NO|[Ff]alse|FALSE|[Oo]ff|OFF)$/i,
      resolve: () => new Scalar.Scalar(false),
      stringify: boolStringify
    };
    exports2.falseTag = falseTag;
    exports2.trueTag = trueTag;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/float.js
var require_float2 = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/float.js"(exports2) {
    "use strict";
    var Scalar = require_Scalar();
    var stringifyNumber = require_stringifyNumber();
    var floatNaN = {
      identify: (value) => typeof value === "number",
      default: true,
      tag: "tag:yaml.org,2002:float",
      test: /^[-+]?\.(?:inf|Inf|INF|nan|NaN|NAN)$/,
      resolve: (str2) => str2.slice(-3).toLowerCase() === "nan" ? NaN : str2[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY,
      stringify: stringifyNumber.stringifyNumber
    };
    var floatExp = {
      identify: (value) => typeof value === "number",
      default: true,
      tag: "tag:yaml.org,2002:float",
      format: "EXP",
      test: /^[-+]?(?:[0-9][0-9_]*)?(?:\.[0-9_]*)?[eE][-+]?[0-9]+$/,
      resolve: (str2) => parseFloat(str2.replace(/_/g, "")),
      stringify(node) {
        const num = Number(node.value);
        return isFinite(num) ? num.toExponential() : stringifyNumber.stringifyNumber(node);
      }
    };
    var float2 = {
      identify: (value) => typeof value === "number",
      default: true,
      tag: "tag:yaml.org,2002:float",
      test: /^[-+]?(?:[0-9][0-9_]*)?\.[0-9_]*$/,
      resolve(str2) {
        const node = new Scalar.Scalar(parseFloat(str2.replace(/_/g, "")));
        const dot = str2.indexOf(".");
        if (dot !== -1) {
          const f = str2.substring(dot + 1).replace(/_/g, "");
          if (f[f.length - 1] === "0")
            node.minFractionDigits = f.length;
        }
        return node;
      },
      stringify: stringifyNumber.stringifyNumber
    };
    exports2.float = float2;
    exports2.floatExp = floatExp;
    exports2.floatNaN = floatNaN;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/int.js
var require_int2 = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/int.js"(exports2) {
    "use strict";
    var stringifyNumber = require_stringifyNumber();
    var intIdentify = (value) => typeof value === "bigint" || Number.isInteger(value);
    function intResolve(str2, offset, radix, { intAsBigInt }) {
      const sign = str2[0];
      if (sign === "-" || sign === "+")
        offset += 1;
      str2 = str2.substring(offset).replace(/_/g, "");
      if (intAsBigInt) {
        switch (radix) {
          case 2:
            str2 = `0b${str2}`;
            break;
          case 8:
            str2 = `0o${str2}`;
            break;
          case 16:
            str2 = `0x${str2}`;
            break;
        }
        const n2 = BigInt(str2);
        return sign === "-" ? BigInt(-1) * n2 : n2;
      }
      const n = parseInt(str2, radix);
      return sign === "-" ? -1 * n : n;
    }
    function intStringify(node, radix, prefix) {
      const { value } = node;
      if (intIdentify(value)) {
        const str2 = value.toString(radix);
        return value < 0 ? "-" + prefix + str2.substr(1) : prefix + str2;
      }
      return stringifyNumber.stringifyNumber(node);
    }
    var intBin = {
      identify: intIdentify,
      default: true,
      tag: "tag:yaml.org,2002:int",
      format: "BIN",
      test: /^[-+]?0b[0-1_]+$/,
      resolve: (str2, _onError, opt) => intResolve(str2, 2, 2, opt),
      stringify: (node) => intStringify(node, 2, "0b")
    };
    var intOct = {
      identify: intIdentify,
      default: true,
      tag: "tag:yaml.org,2002:int",
      format: "OCT",
      test: /^[-+]?0[0-7_]+$/,
      resolve: (str2, _onError, opt) => intResolve(str2, 1, 8, opt),
      stringify: (node) => intStringify(node, 8, "0")
    };
    var int2 = {
      identify: intIdentify,
      default: true,
      tag: "tag:yaml.org,2002:int",
      test: /^[-+]?[0-9][0-9_]*$/,
      resolve: (str2, _onError, opt) => intResolve(str2, 0, 10, opt),
      stringify: stringifyNumber.stringifyNumber
    };
    var intHex = {
      identify: intIdentify,
      default: true,
      tag: "tag:yaml.org,2002:int",
      format: "HEX",
      test: /^[-+]?0x[0-9a-fA-F_]+$/,
      resolve: (str2, _onError, opt) => intResolve(str2, 2, 16, opt),
      stringify: (node) => intStringify(node, 16, "0x")
    };
    exports2.int = int2;
    exports2.intBin = intBin;
    exports2.intHex = intHex;
    exports2.intOct = intOct;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/set.js
var require_set = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/set.js"(exports2) {
    "use strict";
    var identity2 = require_identity();
    var Pair = require_Pair();
    var YAMLMap = require_YAMLMap();
    var YAMLSet = class _YAMLSet extends YAMLMap.YAMLMap {
      constructor(schema2) {
        super(schema2);
        this.tag = _YAMLSet.tag;
      }
      add(key) {
        let pair;
        if (identity2.isPair(key))
          pair = key;
        else if (key && typeof key === "object" && "key" in key && "value" in key && key.value === null)
          pair = new Pair.Pair(key.key, null);
        else
          pair = new Pair.Pair(key, null);
        const prev = YAMLMap.findPair(this.items, pair.key);
        if (!prev)
          this.items.push(pair);
      }
      /**
       * If `keepPair` is `true`, returns the Pair matching `key`.
       * Otherwise, returns the value of that Pair's key.
       */
      get(key, keepPair) {
        const pair = YAMLMap.findPair(this.items, key);
        return !keepPair && identity2.isPair(pair) ? identity2.isScalar(pair.key) ? pair.key.value : pair.key : pair;
      }
      set(key, value) {
        if (typeof value !== "boolean")
          throw new Error(`Expected boolean value for set(key, value) in a YAML set, not ${typeof value}`);
        const prev = YAMLMap.findPair(this.items, key);
        if (prev && !value) {
          this.items.splice(this.items.indexOf(prev), 1);
        } else if (!prev && value) {
          this.items.push(new Pair.Pair(key));
        }
      }
      toJSON(_, ctx) {
        return super.toJSON(_, ctx, Set);
      }
      toString(ctx, onComment, onChompKeep) {
        if (!ctx)
          return JSON.stringify(this);
        if (this.hasAllNullValues(true))
          return super.toString(Object.assign({}, ctx, { allNullValues: true }), onComment, onChompKeep);
        else
          throw new Error("Set items must all have null values");
      }
      static from(schema2, iterable, ctx) {
        const { replacer } = ctx;
        const set5 = new this(schema2);
        if (iterable && Symbol.iterator in Object(iterable))
          for (let value of iterable) {
            if (typeof replacer === "function")
              value = replacer.call(iterable, value, value);
            set5.items.push(Pair.createPair(value, null, ctx));
          }
        return set5;
      }
    };
    YAMLSet.tag = "tag:yaml.org,2002:set";
    var set4 = {
      collection: "map",
      identify: (value) => value instanceof Set,
      nodeClass: YAMLSet,
      default: false,
      tag: "tag:yaml.org,2002:set",
      createNode: (schema2, iterable, ctx) => YAMLSet.from(schema2, iterable, ctx),
      resolve(map2, onError) {
        if (identity2.isMap(map2)) {
          if (map2.hasAllNullValues(true))
            return Object.assign(new YAMLSet(), map2);
          else
            onError("Set items must all have null values");
        } else
          onError("Expected a mapping for this tag");
        return map2;
      }
    };
    exports2.YAMLSet = YAMLSet;
    exports2.set = set4;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/timestamp.js
var require_timestamp = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/timestamp.js"(exports2) {
    "use strict";
    var stringifyNumber = require_stringifyNumber();
    function parseSexagesimal(str2, asBigInt) {
      const sign = str2[0];
      const parts = sign === "-" || sign === "+" ? str2.substring(1) : str2;
      const num = (n) => asBigInt ? BigInt(n) : Number(n);
      const res = parts.replace(/_/g, "").split(":").reduce((res2, p) => res2 * num(60) + num(p), num(0));
      return sign === "-" ? num(-1) * res : res;
    }
    function stringifySexagesimal(node) {
      let { value } = node;
      let num = (n) => n;
      if (typeof value === "bigint")
        num = (n) => BigInt(n);
      else if (isNaN(value) || !isFinite(value))
        return stringifyNumber.stringifyNumber(node);
      let sign = "";
      if (value < 0) {
        sign = "-";
        value *= num(-1);
      }
      const _60 = num(60);
      const parts = [value % _60];
      if (value < 60) {
        parts.unshift(0);
      } else {
        value = (value - parts[0]) / _60;
        parts.unshift(value % _60);
        if (value >= 60) {
          value = (value - parts[0]) / _60;
          parts.unshift(value);
        }
      }
      return sign + parts.map((n) => String(n).padStart(2, "0")).join(":").replace(/000000\d*$/, "");
    }
    var intTime = {
      identify: (value) => typeof value === "bigint" || Number.isInteger(value),
      default: true,
      tag: "tag:yaml.org,2002:int",
      format: "TIME",
      test: /^[-+]?[0-9][0-9_]*(?::[0-5]?[0-9])+$/,
      resolve: (str2, _onError, { intAsBigInt }) => parseSexagesimal(str2, intAsBigInt),
      stringify: stringifySexagesimal
    };
    var floatTime = {
      identify: (value) => typeof value === "number",
      default: true,
      tag: "tag:yaml.org,2002:float",
      format: "TIME",
      test: /^[-+]?[0-9][0-9_]*(?::[0-5]?[0-9])+\.[0-9_]*$/,
      resolve: (str2) => parseSexagesimal(str2, false),
      stringify: stringifySexagesimal
    };
    var timestamp2 = {
      identify: (value) => value instanceof Date,
      default: true,
      tag: "tag:yaml.org,2002:timestamp",
      // If the time zone is omitted, the timestamp is assumed to be specified in UTC. The time part
      // may be omitted altogether, resulting in a date format. In such a case, the time part is
      // assumed to be 00:00:00Z (start of day, UTC).
      test: RegExp("^([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})(?:(?:t|T|[ \\t]+)([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2}(\\.[0-9]+)?)(?:[ \\t]*(Z|[-+][012]?[0-9](?::[0-9]{2})?))?)?$"),
      resolve(str2) {
        const match = str2.match(timestamp2.test);
        if (!match)
          throw new Error("!!timestamp expects a date, starting with yyyy-mm-dd");
        const [, year, month, day, hour, minute, second] = match.map(Number);
        const millisec = match[7] ? Number((match[7] + "00").substr(1, 3)) : 0;
        let date3 = Date.UTC(year, month - 1, day, hour || 0, minute || 0, second || 0, millisec);
        const tz = match[8];
        if (tz && tz !== "Z") {
          let d = parseSexagesimal(tz, false);
          if (Math.abs(d) < 30)
            d *= 60;
          date3 -= 6e4 * d;
        }
        return new Date(date3);
      },
      stringify: ({ value }) => value.toISOString().replace(/((T00:00)?:00)?\.000Z$/, "")
    };
    exports2.floatTime = floatTime;
    exports2.intTime = intTime;
    exports2.timestamp = timestamp2;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/schema.js
var require_schema3 = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/yaml-1.1/schema.js"(exports2) {
    "use strict";
    var map2 = require_map();
    var _null2 = require_null();
    var seq2 = require_seq();
    var string3 = require_string();
    var binary2 = require_binary();
    var bool2 = require_bool2();
    var float2 = require_float2();
    var int2 = require_int2();
    var omap2 = require_omap();
    var pairs2 = require_pairs();
    var set4 = require_set();
    var timestamp2 = require_timestamp();
    var schema2 = [
      map2.map,
      seq2.seq,
      string3.string,
      _null2.nullTag,
      bool2.trueTag,
      bool2.falseTag,
      int2.intBin,
      int2.intOct,
      int2.int,
      int2.intHex,
      float2.floatNaN,
      float2.floatExp,
      float2.float,
      binary2.binary,
      omap2.omap,
      pairs2.pairs,
      set4.set,
      timestamp2.intTime,
      timestamp2.floatTime,
      timestamp2.timestamp
    ];
    exports2.schema = schema2;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/tags.js
var require_tags = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/tags.js"(exports2) {
    "use strict";
    var map2 = require_map();
    var _null2 = require_null();
    var seq2 = require_seq();
    var string3 = require_string();
    var bool2 = require_bool();
    var float2 = require_float();
    var int2 = require_int();
    var schema2 = require_schema();
    var schema$1 = require_schema2();
    var binary2 = require_binary();
    var omap2 = require_omap();
    var pairs2 = require_pairs();
    var schema$2 = require_schema3();
    var set4 = require_set();
    var timestamp2 = require_timestamp();
    var schemas = /* @__PURE__ */ new Map([
      ["core", schema2.schema],
      ["failsafe", [map2.map, seq2.seq, string3.string]],
      ["json", schema$1.schema],
      ["yaml11", schema$2.schema],
      ["yaml-1.1", schema$2.schema]
    ]);
    var tagsByName = {
      binary: binary2.binary,
      bool: bool2.boolTag,
      float: float2.float,
      floatExp: float2.floatExp,
      floatNaN: float2.floatNaN,
      floatTime: timestamp2.floatTime,
      int: int2.int,
      intHex: int2.intHex,
      intOct: int2.intOct,
      intTime: timestamp2.intTime,
      map: map2.map,
      null: _null2.nullTag,
      omap: omap2.omap,
      pairs: pairs2.pairs,
      seq: seq2.seq,
      set: set4.set,
      timestamp: timestamp2.timestamp
    };
    var coreKnownTags = {
      "tag:yaml.org,2002:binary": binary2.binary,
      "tag:yaml.org,2002:omap": omap2.omap,
      "tag:yaml.org,2002:pairs": pairs2.pairs,
      "tag:yaml.org,2002:set": set4.set,
      "tag:yaml.org,2002:timestamp": timestamp2.timestamp
    };
    function getTags(customTags, schemaName) {
      let tags = schemas.get(schemaName);
      if (!tags) {
        if (Array.isArray(customTags))
          tags = [];
        else {
          const keys5 = Array.from(schemas.keys()).filter((key) => key !== "yaml11").map((key) => JSON.stringify(key)).join(", ");
          throw new Error(`Unknown schema "${schemaName}"; use one of ${keys5} or define customTags array`);
        }
      }
      if (Array.isArray(customTags)) {
        for (const tag of customTags)
          tags = tags.concat(tag);
      } else if (typeof customTags === "function") {
        tags = customTags(tags.slice());
      }
      return tags.map((tag) => {
        if (typeof tag !== "string")
          return tag;
        const tagObj = tagsByName[tag];
        if (tagObj)
          return tagObj;
        const keys5 = Object.keys(tagsByName).map((key) => JSON.stringify(key)).join(", ");
        throw new Error(`Unknown custom tag "${tag}"; use one of ${keys5}`);
      });
    }
    exports2.coreKnownTags = coreKnownTags;
    exports2.getTags = getTags;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/Schema.js
var require_Schema = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/schema/Schema.js"(exports2) {
    "use strict";
    var identity2 = require_identity();
    var map2 = require_map();
    var seq2 = require_seq();
    var string3 = require_string();
    var tags = require_tags();
    var sortMapEntriesByKey = (a, b) => a.key < b.key ? -1 : a.key > b.key ? 1 : 0;
    var Schema3 = class _Schema {
      constructor({ compat, customTags, merge: merge3, resolveKnownTags, schema: schema2, sortMapEntries, toStringDefaults }) {
        this.compat = Array.isArray(compat) ? tags.getTags(compat, "compat") : compat ? tags.getTags(null, compat) : null;
        this.merge = !!merge3;
        this.name = typeof schema2 === "string" && schema2 || "core";
        this.knownTags = resolveKnownTags ? tags.coreKnownTags : {};
        this.tags = tags.getTags(customTags, this.name);
        this.toStringOptions = toStringDefaults ?? null;
        Object.defineProperty(this, identity2.MAP, { value: map2.map });
        Object.defineProperty(this, identity2.SCALAR, { value: string3.string });
        Object.defineProperty(this, identity2.SEQ, { value: seq2.seq });
        this.sortMapEntries = typeof sortMapEntries === "function" ? sortMapEntries : sortMapEntries === true ? sortMapEntriesByKey : null;
      }
      clone() {
        const copy = Object.create(_Schema.prototype, Object.getOwnPropertyDescriptors(this));
        copy.tags = this.tags.slice();
        return copy;
      }
    };
    exports2.Schema = Schema3;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/stringify/stringifyDocument.js
var require_stringifyDocument = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/stringify/stringifyDocument.js"(exports2) {
    "use strict";
    var identity2 = require_identity();
    var stringify = require_stringify();
    var stringifyComment = require_stringifyComment();
    function stringifyDocument(doc, options) {
      const lines = [];
      let hasDirectives = options.directives === true;
      if (options.directives !== false && doc.directives) {
        const dir = doc.directives.toString(doc);
        if (dir) {
          lines.push(dir);
          hasDirectives = true;
        } else if (doc.directives.docStart)
          hasDirectives = true;
      }
      if (hasDirectives)
        lines.push("---");
      const ctx = stringify.createStringifyContext(doc, options);
      const { commentString } = ctx.options;
      if (doc.commentBefore) {
        if (lines.length !== 1)
          lines.unshift("");
        const cs = commentString(doc.commentBefore);
        lines.unshift(stringifyComment.indentComment(cs, ""));
      }
      let chompKeep = false;
      let contentComment = null;
      if (doc.contents) {
        if (identity2.isNode(doc.contents)) {
          if (doc.contents.spaceBefore && hasDirectives)
            lines.push("");
          if (doc.contents.commentBefore) {
            const cs = commentString(doc.contents.commentBefore);
            lines.push(stringifyComment.indentComment(cs, ""));
          }
          ctx.forceBlockIndent = !!doc.comment;
          contentComment = doc.contents.comment;
        }
        const onChompKeep = contentComment ? void 0 : () => chompKeep = true;
        let body = stringify.stringify(doc.contents, ctx, () => contentComment = null, onChompKeep);
        if (contentComment)
          body += stringifyComment.lineComment(body, "", commentString(contentComment));
        if ((body[0] === "|" || body[0] === ">") && lines[lines.length - 1] === "---") {
          lines[lines.length - 1] = `--- ${body}`;
        } else
          lines.push(body);
      } else {
        lines.push(stringify.stringify(doc.contents, ctx));
      }
      if (doc.directives?.docEnd) {
        if (doc.comment) {
          const cs = commentString(doc.comment);
          if (cs.includes("\n")) {
            lines.push("...");
            lines.push(stringifyComment.indentComment(cs, ""));
          } else {
            lines.push(`... ${cs}`);
          }
        } else {
          lines.push("...");
        }
      } else {
        let dc = doc.comment;
        if (dc && chompKeep)
          dc = dc.replace(/^\n+/, "");
        if (dc) {
          if ((!chompKeep || contentComment) && lines[lines.length - 1] !== "")
            lines.push("");
          lines.push(stringifyComment.indentComment(commentString(dc), ""));
        }
      }
      return lines.join("\n") + "\n";
    }
    exports2.stringifyDocument = stringifyDocument;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/doc/Document.js
var require_Document = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/doc/Document.js"(exports2) {
    "use strict";
    var Alias = require_Alias();
    var Collection = require_Collection();
    var identity2 = require_identity();
    var Pair = require_Pair();
    var toJS = require_toJS();
    var Schema3 = require_Schema();
    var stringifyDocument = require_stringifyDocument();
    var anchors = require_anchors();
    var applyReviver = require_applyReviver();
    var createNode = require_createNode();
    var directives = require_directives();
    var Document = class _Document {
      constructor(value, replacer, options) {
        this.commentBefore = null;
        this.comment = null;
        this.errors = [];
        this.warnings = [];
        Object.defineProperty(this, identity2.NODE_TYPE, { value: identity2.DOC });
        let _replacer = null;
        if (typeof replacer === "function" || Array.isArray(replacer)) {
          _replacer = replacer;
        } else if (options === void 0 && replacer) {
          options = replacer;
          replacer = void 0;
        }
        const opt = Object.assign({
          intAsBigInt: false,
          keepSourceTokens: false,
          logLevel: "warn",
          prettyErrors: true,
          strict: true,
          uniqueKeys: true,
          version: "1.2"
        }, options);
        this.options = opt;
        let { version } = opt;
        if (options?._directives) {
          this.directives = options._directives.atDocument();
          if (this.directives.yaml.explicit)
            version = this.directives.yaml.version;
        } else
          this.directives = new directives.Directives({ version });
        this.setSchema(version, options);
        this.contents = value === void 0 ? null : this.createNode(value, _replacer, options);
      }
      /**
       * Create a deep copy of this Document and its contents.
       *
       * Custom Node values that inherit from `Object` still refer to their original instances.
       */
      clone() {
        const copy = Object.create(_Document.prototype, {
          [identity2.NODE_TYPE]: { value: identity2.DOC }
        });
        copy.commentBefore = this.commentBefore;
        copy.comment = this.comment;
        copy.errors = this.errors.slice();
        copy.warnings = this.warnings.slice();
        copy.options = Object.assign({}, this.options);
        if (this.directives)
          copy.directives = this.directives.clone();
        copy.schema = this.schema.clone();
        copy.contents = identity2.isNode(this.contents) ? this.contents.clone(copy.schema) : this.contents;
        if (this.range)
          copy.range = this.range.slice();
        return copy;
      }
      /** Adds a value to the document. */
      add(value) {
        if (assertCollection(this.contents))
          this.contents.add(value);
      }
      /** Adds a value to the document. */
      addIn(path5, value) {
        if (assertCollection(this.contents))
          this.contents.addIn(path5, value);
      }
      /**
       * Create a new `Alias` node, ensuring that the target `node` has the required anchor.
       *
       * If `node` already has an anchor, `name` is ignored.
       * Otherwise, the `node.anchor` value will be set to `name`,
       * or if an anchor with that name is already present in the document,
       * `name` will be used as a prefix for a new unique anchor.
       * If `name` is undefined, the generated anchor will use 'a' as a prefix.
       */
      createAlias(node, name) {
        if (!node.anchor) {
          const prev = anchors.anchorNames(this);
          node.anchor = // eslint-disable-next-line @typescript-eslint/prefer-nullish-coalescing
          !name || prev.has(name) ? anchors.findNewAnchor(name || "a", prev) : name;
        }
        return new Alias.Alias(node.anchor);
      }
      createNode(value, replacer, options) {
        let _replacer = void 0;
        if (typeof replacer === "function") {
          value = replacer.call({ "": value }, "", value);
          _replacer = replacer;
        } else if (Array.isArray(replacer)) {
          const keyToStr = (v) => typeof v === "number" || v instanceof String || v instanceof Number;
          const asStr = replacer.filter(keyToStr).map(String);
          if (asStr.length > 0)
            replacer = replacer.concat(asStr);
          _replacer = replacer;
        } else if (options === void 0 && replacer) {
          options = replacer;
          replacer = void 0;
        }
        const { aliasDuplicateObjects, anchorPrefix, flow, keepUndefined, onTagObj, tag } = options ?? {};
        const { onAnchor, setAnchors, sourceObjects } = anchors.createNodeAnchors(
          this,
          // eslint-disable-next-line @typescript-eslint/prefer-nullish-coalescing
          anchorPrefix || "a"
        );
        const ctx = {
          aliasDuplicateObjects: aliasDuplicateObjects ?? true,
          keepUndefined: keepUndefined ?? false,
          onAnchor,
          onTagObj,
          replacer: _replacer,
          schema: this.schema,
          sourceObjects
        };
        const node = createNode.createNode(value, tag, ctx);
        if (flow && identity2.isCollection(node))
          node.flow = true;
        setAnchors();
        return node;
      }
      /**
       * Convert a key and a value into a `Pair` using the current schema,
       * recursively wrapping all values as `Scalar` or `Collection` nodes.
       */
      createPair(key, value, options = {}) {
        const k = this.createNode(key, null, options);
        const v = this.createNode(value, null, options);
        return new Pair.Pair(k, v);
      }
      /**
       * Removes a value from the document.
       * @returns `true` if the item was found and removed.
       */
      delete(key) {
        return assertCollection(this.contents) ? this.contents.delete(key) : false;
      }
      /**
       * Removes a value from the document.
       * @returns `true` if the item was found and removed.
       */
      deleteIn(path5) {
        if (Collection.isEmptyPath(path5)) {
          if (this.contents == null)
            return false;
          this.contents = null;
          return true;
        }
        return assertCollection(this.contents) ? this.contents.deleteIn(path5) : false;
      }
      /**
       * Returns item at `key`, or `undefined` if not found. By default unwraps
       * scalar values from their surrounding node; to disable set `keepScalar` to
       * `true` (collections are always returned intact).
       */
      get(key, keepScalar) {
        return identity2.isCollection(this.contents) ? this.contents.get(key, keepScalar) : void 0;
      }
      /**
       * Returns item at `path`, or `undefined` if not found. By default unwraps
       * scalar values from their surrounding node; to disable set `keepScalar` to
       * `true` (collections are always returned intact).
       */
      getIn(path5, keepScalar) {
        if (Collection.isEmptyPath(path5))
          return !keepScalar && identity2.isScalar(this.contents) ? this.contents.value : this.contents;
        return identity2.isCollection(this.contents) ? this.contents.getIn(path5, keepScalar) : void 0;
      }
      /**
       * Checks if the document includes a value with the key `key`.
       */
      has(key) {
        return identity2.isCollection(this.contents) ? this.contents.has(key) : false;
      }
      /**
       * Checks if the document includes a value at `path`.
       */
      hasIn(path5) {
        if (Collection.isEmptyPath(path5))
          return this.contents !== void 0;
        return identity2.isCollection(this.contents) ? this.contents.hasIn(path5) : false;
      }
      /**
       * Sets a value in this document. For `!!set`, `value` needs to be a
       * boolean to add/remove the item from the set.
       */
      set(key, value) {
        if (this.contents == null) {
          this.contents = Collection.collectionFromPath(this.schema, [key], value);
        } else if (assertCollection(this.contents)) {
          this.contents.set(key, value);
        }
      }
      /**
       * Sets a value in this document. For `!!set`, `value` needs to be a
       * boolean to add/remove the item from the set.
       */
      setIn(path5, value) {
        if (Collection.isEmptyPath(path5)) {
          this.contents = value;
        } else if (this.contents == null) {
          this.contents = Collection.collectionFromPath(this.schema, Array.from(path5), value);
        } else if (assertCollection(this.contents)) {
          this.contents.setIn(path5, value);
        }
      }
      /**
       * Change the YAML version and schema used by the document.
       * A `null` version disables support for directives, explicit tags, anchors, and aliases.
       * It also requires the `schema` option to be given as a `Schema` instance value.
       *
       * Overrides all previously set schema options.
       */
      setSchema(version, options = {}) {
        if (typeof version === "number")
          version = String(version);
        let opt;
        switch (version) {
          case "1.1":
            if (this.directives)
              this.directives.yaml.version = "1.1";
            else
              this.directives = new directives.Directives({ version: "1.1" });
            opt = { merge: true, resolveKnownTags: false, schema: "yaml-1.1" };
            break;
          case "1.2":
          case "next":
            if (this.directives)
              this.directives.yaml.version = version;
            else
              this.directives = new directives.Directives({ version });
            opt = { merge: false, resolveKnownTags: true, schema: "core" };
            break;
          case null:
            if (this.directives)
              delete this.directives;
            opt = null;
            break;
          default: {
            const sv = JSON.stringify(version);
            throw new Error(`Expected '1.1', '1.2' or null as first argument, but found: ${sv}`);
          }
        }
        if (options.schema instanceof Object)
          this.schema = options.schema;
        else if (opt)
          this.schema = new Schema3.Schema(Object.assign(opt, options));
        else
          throw new Error(`With a null YAML version, the { schema: Schema } option is required`);
      }
      // json & jsonArg are only used from toJSON()
      toJS({ json: json2, jsonArg, mapAsMap, maxAliasCount, onAnchor, reviver } = {}) {
        const ctx = {
          anchors: /* @__PURE__ */ new Map(),
          doc: this,
          keep: !json2,
          mapAsMap: mapAsMap === true,
          mapKeyWarned: false,
          maxAliasCount: typeof maxAliasCount === "number" ? maxAliasCount : 100
        };
        const res = toJS.toJS(this.contents, jsonArg ?? "", ctx);
        if (typeof onAnchor === "function")
          for (const { count, res: res2 } of ctx.anchors.values())
            onAnchor(res2, count);
        return typeof reviver === "function" ? applyReviver.applyReviver(reviver, { "": res }, "", res) : res;
      }
      /**
       * A JSON representation of the document `contents`.
       *
       * @param jsonArg Used by `JSON.stringify` to indicate the array index or
       *   property name.
       */
      toJSON(jsonArg, onAnchor) {
        return this.toJS({ json: true, jsonArg, mapAsMap: false, onAnchor });
      }
      /** A YAML representation of the document. */
      toString(options = {}) {
        if (this.errors.length > 0)
          throw new Error("Document with errors cannot be stringified");
        if ("indent" in options && (!Number.isInteger(options.indent) || Number(options.indent) <= 0)) {
          const s = JSON.stringify(options.indent);
          throw new Error(`"indent" option must be a positive integer, not ${s}`);
        }
        return stringifyDocument.stringifyDocument(this, options);
      }
    };
    function assertCollection(contents) {
      if (identity2.isCollection(contents))
        return true;
      throw new Error("Expected a YAML collection as document contents");
    }
    exports2.Document = Document;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/errors.js
var require_errors = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/errors.js"(exports2) {
    "use strict";
    var YAMLError = class extends Error {
      constructor(name, pos, code, message) {
        super();
        this.name = name;
        this.code = code;
        this.message = message;
        this.pos = pos;
      }
    };
    var YAMLParseError = class extends YAMLError {
      constructor(pos, code, message) {
        super("YAMLParseError", pos, code, message);
      }
    };
    var YAMLWarning = class extends YAMLError {
      constructor(pos, code, message) {
        super("YAMLWarning", pos, code, message);
      }
    };
    var prettifyError = (src, lc) => (error) => {
      if (error.pos[0] === -1)
        return;
      error.linePos = error.pos.map((pos) => lc.linePos(pos));
      const { line, col } = error.linePos[0];
      error.message += ` at line ${line}, column ${col}`;
      let ci = col - 1;
      let lineStr = src.substring(lc.lineStarts[line - 1], lc.lineStarts[line]).replace(/[\n\r]+$/, "");
      if (ci >= 60 && lineStr.length > 80) {
        const trimStart = Math.min(ci - 39, lineStr.length - 79);
        lineStr = "\u2026" + lineStr.substring(trimStart);
        ci -= trimStart - 1;
      }
      if (lineStr.length > 80)
        lineStr = lineStr.substring(0, 79) + "\u2026";
      if (line > 1 && /^ *$/.test(lineStr.substring(0, ci))) {
        let prev = src.substring(lc.lineStarts[line - 2], lc.lineStarts[line - 1]);
        if (prev.length > 80)
          prev = prev.substring(0, 79) + "\u2026\n";
        lineStr = prev + lineStr;
      }
      if (/[^ ]/.test(lineStr)) {
        let count = 1;
        const end = error.linePos[1];
        if (end && end.line === line && end.col > col) {
          count = Math.max(1, Math.min(end.col - col, 80 - ci));
        }
        const pointer = " ".repeat(ci) + "^".repeat(count);
        error.message += `:

${lineStr}
${pointer}
`;
      }
    };
    exports2.YAMLError = YAMLError;
    exports2.YAMLParseError = YAMLParseError;
    exports2.YAMLWarning = YAMLWarning;
    exports2.prettifyError = prettifyError;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/resolve-props.js
var require_resolve_props = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/resolve-props.js"(exports2) {
    "use strict";
    function resolveProps(tokens, { flow, indicator, next, offset, onError, startOnNewline }) {
      let spaceBefore = false;
      let atNewline = startOnNewline;
      let hasSpace = startOnNewline;
      let comment = "";
      let commentSep = "";
      let hasNewline = false;
      let hasNewlineAfterProp = false;
      let reqSpace = false;
      let anchor = null;
      let tag = null;
      let comma = null;
      let found = null;
      let start = null;
      for (const token of tokens) {
        if (reqSpace) {
          if (token.type !== "space" && token.type !== "newline" && token.type !== "comma")
            onError(token.offset, "MISSING_CHAR", "Tags and anchors must be separated from the next token by white space");
          reqSpace = false;
        }
        switch (token.type) {
          case "space":
            if (!flow && atNewline && indicator !== "doc-start" && token.source[0] === "	")
              onError(token, "TAB_AS_INDENT", "Tabs are not allowed as indentation");
            hasSpace = true;
            break;
          case "comment": {
            if (!hasSpace)
              onError(token, "MISSING_CHAR", "Comments must be separated from other tokens by white space characters");
            const cb = token.source.substring(1) || " ";
            if (!comment)
              comment = cb;
            else
              comment += commentSep + cb;
            commentSep = "";
            atNewline = false;
            break;
          }
          case "newline":
            if (atNewline) {
              if (comment)
                comment += token.source;
              else
                spaceBefore = true;
            } else
              commentSep += token.source;
            atNewline = true;
            hasNewline = true;
            if (anchor || tag)
              hasNewlineAfterProp = true;
            hasSpace = true;
            break;
          case "anchor":
            if (anchor)
              onError(token, "MULTIPLE_ANCHORS", "A node can have at most one anchor");
            if (token.source.endsWith(":"))
              onError(token.offset + token.source.length - 1, "BAD_ALIAS", "Anchor ending in : is ambiguous", true);
            anchor = token;
            if (start === null)
              start = token.offset;
            atNewline = false;
            hasSpace = false;
            reqSpace = true;
            break;
          case "tag": {
            if (tag)
              onError(token, "MULTIPLE_TAGS", "A node can have at most one tag");
            tag = token;
            if (start === null)
              start = token.offset;
            atNewline = false;
            hasSpace = false;
            reqSpace = true;
            break;
          }
          case indicator:
            if (anchor || tag)
              onError(token, "BAD_PROP_ORDER", `Anchors and tags must be after the ${token.source} indicator`);
            if (found)
              onError(token, "UNEXPECTED_TOKEN", `Unexpected ${token.source} in ${flow ?? "collection"}`);
            found = token;
            atNewline = false;
            hasSpace = false;
            break;
          case "comma":
            if (flow) {
              if (comma)
                onError(token, "UNEXPECTED_TOKEN", `Unexpected , in ${flow}`);
              comma = token;
              atNewline = false;
              hasSpace = false;
              break;
            }
          // else fallthrough
          default:
            onError(token, "UNEXPECTED_TOKEN", `Unexpected ${token.type} token`);
            atNewline = false;
            hasSpace = false;
        }
      }
      const last = tokens[tokens.length - 1];
      const end = last ? last.offset + last.source.length : offset;
      if (reqSpace && next && next.type !== "space" && next.type !== "newline" && next.type !== "comma" && (next.type !== "scalar" || next.source !== ""))
        onError(next.offset, "MISSING_CHAR", "Tags and anchors must be separated from the next token by white space");
      return {
        comma,
        found,
        spaceBefore,
        comment,
        hasNewline,
        hasNewlineAfterProp,
        anchor,
        tag,
        end,
        start: start ?? end
      };
    }
    exports2.resolveProps = resolveProps;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/util-contains-newline.js
var require_util_contains_newline = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/util-contains-newline.js"(exports2) {
    "use strict";
    function containsNewline(key) {
      if (!key)
        return null;
      switch (key.type) {
        case "alias":
        case "scalar":
        case "double-quoted-scalar":
        case "single-quoted-scalar":
          if (key.source.includes("\n"))
            return true;
          if (key.end) {
            for (const st of key.end)
              if (st.type === "newline")
                return true;
          }
          return false;
        case "flow-collection":
          for (const it of key.items) {
            for (const st of it.start)
              if (st.type === "newline")
                return true;
            if (it.sep) {
              for (const st of it.sep)
                if (st.type === "newline")
                  return true;
            }
            if (containsNewline(it.key) || containsNewline(it.value))
              return true;
          }
          return false;
        default:
          return true;
      }
    }
    exports2.containsNewline = containsNewline;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/util-flow-indent-check.js
var require_util_flow_indent_check = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/util-flow-indent-check.js"(exports2) {
    "use strict";
    var utilContainsNewline = require_util_contains_newline();
    function flowIndentCheck(indent, fc, onError) {
      if (fc?.type === "flow-collection") {
        const end = fc.end[0];
        if (end.indent === indent && (end.source === "]" || end.source === "}") && utilContainsNewline.containsNewline(fc)) {
          const msg = "Flow end indicator should be more indented than parent";
          onError(end, "BAD_INDENT", msg, true);
        }
      }
    }
    exports2.flowIndentCheck = flowIndentCheck;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/util-map-includes.js
var require_util_map_includes = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/util-map-includes.js"(exports2) {
    "use strict";
    var identity2 = require_identity();
    function mapIncludes(ctx, items, search) {
      const { uniqueKeys } = ctx.options;
      if (uniqueKeys === false)
        return false;
      const isEqual2 = typeof uniqueKeys === "function" ? uniqueKeys : (a, b) => a === b || identity2.isScalar(a) && identity2.isScalar(b) && a.value === b.value && !(a.value === "<<" && ctx.schema.merge);
      return items.some((pair) => isEqual2(pair.key, search));
    }
    exports2.mapIncludes = mapIncludes;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/resolve-block-map.js
var require_resolve_block_map = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/resolve-block-map.js"(exports2) {
    "use strict";
    var Pair = require_Pair();
    var YAMLMap = require_YAMLMap();
    var resolveProps = require_resolve_props();
    var utilContainsNewline = require_util_contains_newline();
    var utilFlowIndentCheck = require_util_flow_indent_check();
    var utilMapIncludes = require_util_map_includes();
    var startColMsg = "All mapping items must start at the same column";
    function resolveBlockMap({ composeNode: composeNode2, composeEmptyNode }, ctx, bm, onError, tag) {
      const NodeClass = tag?.nodeClass ?? YAMLMap.YAMLMap;
      const map2 = new NodeClass(ctx.schema);
      if (ctx.atRoot)
        ctx.atRoot = false;
      let offset = bm.offset;
      let commentEnd = null;
      for (const collItem of bm.items) {
        const { start, key, sep: sep2, value } = collItem;
        const keyProps = resolveProps.resolveProps(start, {
          indicator: "explicit-key-ind",
          next: key ?? sep2?.[0],
          offset,
          onError,
          startOnNewline: true
        });
        const implicitKey = !keyProps.found;
        if (implicitKey) {
          if (key) {
            if (key.type === "block-seq")
              onError(offset, "BLOCK_AS_IMPLICIT_KEY", "A block sequence may not be used as an implicit map key");
            else if ("indent" in key && key.indent !== bm.indent)
              onError(offset, "BAD_INDENT", startColMsg);
          }
          if (!keyProps.anchor && !keyProps.tag && !sep2) {
            commentEnd = keyProps.end;
            if (keyProps.comment) {
              if (map2.comment)
                map2.comment += "\n" + keyProps.comment;
              else
                map2.comment = keyProps.comment;
            }
            continue;
          }
          if (keyProps.hasNewlineAfterProp || utilContainsNewline.containsNewline(key)) {
            onError(key ?? start[start.length - 1], "MULTILINE_IMPLICIT_KEY", "Implicit keys need to be on a single line");
          }
        } else if (keyProps.found?.indent !== bm.indent) {
          onError(offset, "BAD_INDENT", startColMsg);
        }
        const keyStart = keyProps.end;
        const keyNode = key ? composeNode2(ctx, key, keyProps, onError) : composeEmptyNode(ctx, keyStart, start, null, keyProps, onError);
        if (ctx.schema.compat)
          utilFlowIndentCheck.flowIndentCheck(bm.indent, key, onError);
        if (utilMapIncludes.mapIncludes(ctx, map2.items, keyNode))
          onError(keyStart, "DUPLICATE_KEY", "Map keys must be unique");
        const valueProps = resolveProps.resolveProps(sep2 ?? [], {
          indicator: "map-value-ind",
          next: value,
          offset: keyNode.range[2],
          onError,
          startOnNewline: !key || key.type === "block-scalar"
        });
        offset = valueProps.end;
        if (valueProps.found) {
          if (implicitKey) {
            if (value?.type === "block-map" && !valueProps.hasNewline)
              onError(offset, "BLOCK_AS_IMPLICIT_KEY", "Nested mappings are not allowed in compact mappings");
            if (ctx.options.strict && keyProps.start < valueProps.found.offset - 1024)
              onError(keyNode.range, "KEY_OVER_1024_CHARS", "The : indicator must be at most 1024 chars after the start of an implicit block mapping key");
          }
          const valueNode = value ? composeNode2(ctx, value, valueProps, onError) : composeEmptyNode(ctx, offset, sep2, null, valueProps, onError);
          if (ctx.schema.compat)
            utilFlowIndentCheck.flowIndentCheck(bm.indent, value, onError);
          offset = valueNode.range[2];
          const pair = new Pair.Pair(keyNode, valueNode);
          if (ctx.options.keepSourceTokens)
            pair.srcToken = collItem;
          map2.items.push(pair);
        } else {
          if (implicitKey)
            onError(keyNode.range, "MISSING_CHAR", "Implicit map keys need to be followed by map values");
          if (valueProps.comment) {
            if (keyNode.comment)
              keyNode.comment += "\n" + valueProps.comment;
            else
              keyNode.comment = valueProps.comment;
          }
          const pair = new Pair.Pair(keyNode);
          if (ctx.options.keepSourceTokens)
            pair.srcToken = collItem;
          map2.items.push(pair);
        }
      }
      if (commentEnd && commentEnd < offset)
        onError(commentEnd, "IMPOSSIBLE", "Map comment with trailing content");
      map2.range = [bm.offset, offset, commentEnd ?? offset];
      return map2;
    }
    exports2.resolveBlockMap = resolveBlockMap;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/resolve-block-seq.js
var require_resolve_block_seq = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/resolve-block-seq.js"(exports2) {
    "use strict";
    var YAMLSeq = require_YAMLSeq();
    var resolveProps = require_resolve_props();
    var utilFlowIndentCheck = require_util_flow_indent_check();
    function resolveBlockSeq({ composeNode: composeNode2, composeEmptyNode }, ctx, bs, onError, tag) {
      const NodeClass = tag?.nodeClass ?? YAMLSeq.YAMLSeq;
      const seq2 = new NodeClass(ctx.schema);
      if (ctx.atRoot)
        ctx.atRoot = false;
      let offset = bs.offset;
      let commentEnd = null;
      for (const { start, value } of bs.items) {
        const props = resolveProps.resolveProps(start, {
          indicator: "seq-item-ind",
          next: value,
          offset,
          onError,
          startOnNewline: true
        });
        if (!props.found) {
          if (props.anchor || props.tag || value) {
            if (value && value.type === "block-seq")
              onError(props.end, "BAD_INDENT", "All sequence items must start at the same column");
            else
              onError(offset, "MISSING_CHAR", "Sequence item without - indicator");
          } else {
            commentEnd = props.end;
            if (props.comment)
              seq2.comment = props.comment;
            continue;
          }
        }
        const node = value ? composeNode2(ctx, value, props, onError) : composeEmptyNode(ctx, props.end, start, null, props, onError);
        if (ctx.schema.compat)
          utilFlowIndentCheck.flowIndentCheck(bs.indent, value, onError);
        offset = node.range[2];
        seq2.items.push(node);
      }
      seq2.range = [bs.offset, offset, commentEnd ?? offset];
      return seq2;
    }
    exports2.resolveBlockSeq = resolveBlockSeq;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/resolve-end.js
var require_resolve_end = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/resolve-end.js"(exports2) {
    "use strict";
    function resolveEnd(end, offset, reqSpace, onError) {
      let comment = "";
      if (end) {
        let hasSpace = false;
        let sep2 = "";
        for (const token of end) {
          const { source, type: type2 } = token;
          switch (type2) {
            case "space":
              hasSpace = true;
              break;
            case "comment": {
              if (reqSpace && !hasSpace)
                onError(token, "MISSING_CHAR", "Comments must be separated from other tokens by white space characters");
              const cb = source.substring(1) || " ";
              if (!comment)
                comment = cb;
              else
                comment += sep2 + cb;
              sep2 = "";
              break;
            }
            case "newline":
              if (comment)
                sep2 += source;
              hasSpace = true;
              break;
            default:
              onError(token, "UNEXPECTED_TOKEN", `Unexpected ${type2} at node end`);
          }
          offset += source.length;
        }
      }
      return { comment, offset };
    }
    exports2.resolveEnd = resolveEnd;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/resolve-flow-collection.js
var require_resolve_flow_collection = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/resolve-flow-collection.js"(exports2) {
    "use strict";
    var identity2 = require_identity();
    var Pair = require_Pair();
    var YAMLMap = require_YAMLMap();
    var YAMLSeq = require_YAMLSeq();
    var resolveEnd = require_resolve_end();
    var resolveProps = require_resolve_props();
    var utilContainsNewline = require_util_contains_newline();
    var utilMapIncludes = require_util_map_includes();
    var blockMsg = "Block collections are not allowed within flow collections";
    var isBlock = (token) => token && (token.type === "block-map" || token.type === "block-seq");
    function resolveFlowCollection({ composeNode: composeNode2, composeEmptyNode }, ctx, fc, onError, tag) {
      const isMap = fc.start.source === "{";
      const fcName = isMap ? "flow map" : "flow sequence";
      const NodeClass = tag?.nodeClass ?? (isMap ? YAMLMap.YAMLMap : YAMLSeq.YAMLSeq);
      const coll = new NodeClass(ctx.schema);
      coll.flow = true;
      const atRoot = ctx.atRoot;
      if (atRoot)
        ctx.atRoot = false;
      let offset = fc.offset + fc.start.source.length;
      for (let i = 0; i < fc.items.length; ++i) {
        const collItem = fc.items[i];
        const { start, key, sep: sep2, value } = collItem;
        const props = resolveProps.resolveProps(start, {
          flow: fcName,
          indicator: "explicit-key-ind",
          next: key ?? sep2?.[0],
          offset,
          onError,
          startOnNewline: false
        });
        if (!props.found) {
          if (!props.anchor && !props.tag && !sep2 && !value) {
            if (i === 0 && props.comma)
              onError(props.comma, "UNEXPECTED_TOKEN", `Unexpected , in ${fcName}`);
            else if (i < fc.items.length - 1)
              onError(props.start, "UNEXPECTED_TOKEN", `Unexpected empty item in ${fcName}`);
            if (props.comment) {
              if (coll.comment)
                coll.comment += "\n" + props.comment;
              else
                coll.comment = props.comment;
            }
            offset = props.end;
            continue;
          }
          if (!isMap && ctx.options.strict && utilContainsNewline.containsNewline(key))
            onError(
              key,
              // checked by containsNewline()
              "MULTILINE_IMPLICIT_KEY",
              "Implicit keys of flow sequence pairs need to be on a single line"
            );
        }
        if (i === 0) {
          if (props.comma)
            onError(props.comma, "UNEXPECTED_TOKEN", `Unexpected , in ${fcName}`);
        } else {
          if (!props.comma)
            onError(props.start, "MISSING_CHAR", `Missing , between ${fcName} items`);
          if (props.comment) {
            let prevItemComment = "";
            loop: for (const st of start) {
              switch (st.type) {
                case "comma":
                case "space":
                  break;
                case "comment":
                  prevItemComment = st.source.substring(1);
                  break loop;
                default:
                  break loop;
              }
            }
            if (prevItemComment) {
              let prev = coll.items[coll.items.length - 1];
              if (identity2.isPair(prev))
                prev = prev.value ?? prev.key;
              if (prev.comment)
                prev.comment += "\n" + prevItemComment;
              else
                prev.comment = prevItemComment;
              props.comment = props.comment.substring(prevItemComment.length + 1);
            }
          }
        }
        if (!isMap && !sep2 && !props.found) {
          const valueNode = value ? composeNode2(ctx, value, props, onError) : composeEmptyNode(ctx, props.end, sep2, null, props, onError);
          coll.items.push(valueNode);
          offset = valueNode.range[2];
          if (isBlock(value))
            onError(valueNode.range, "BLOCK_IN_FLOW", blockMsg);
        } else {
          const keyStart = props.end;
          const keyNode = key ? composeNode2(ctx, key, props, onError) : composeEmptyNode(ctx, keyStart, start, null, props, onError);
          if (isBlock(key))
            onError(keyNode.range, "BLOCK_IN_FLOW", blockMsg);
          const valueProps = resolveProps.resolveProps(sep2 ?? [], {
            flow: fcName,
            indicator: "map-value-ind",
            next: value,
            offset: keyNode.range[2],
            onError,
            startOnNewline: false
          });
          if (valueProps.found) {
            if (!isMap && !props.found && ctx.options.strict) {
              if (sep2)
                for (const st of sep2) {
                  if (st === valueProps.found)
                    break;
                  if (st.type === "newline") {
                    onError(st, "MULTILINE_IMPLICIT_KEY", "Implicit keys of flow sequence pairs need to be on a single line");
                    break;
                  }
                }
              if (props.start < valueProps.found.offset - 1024)
                onError(valueProps.found, "KEY_OVER_1024_CHARS", "The : indicator must be at most 1024 chars after the start of an implicit flow sequence key");
            }
          } else if (value) {
            if ("source" in value && value.source && value.source[0] === ":")
              onError(value, "MISSING_CHAR", `Missing space after : in ${fcName}`);
            else
              onError(valueProps.start, "MISSING_CHAR", `Missing , or : between ${fcName} items`);
          }
          const valueNode = value ? composeNode2(ctx, value, valueProps, onError) : valueProps.found ? composeEmptyNode(ctx, valueProps.end, sep2, null, valueProps, onError) : null;
          if (valueNode) {
            if (isBlock(value))
              onError(valueNode.range, "BLOCK_IN_FLOW", blockMsg);
          } else if (valueProps.comment) {
            if (keyNode.comment)
              keyNode.comment += "\n" + valueProps.comment;
            else
              keyNode.comment = valueProps.comment;
          }
          const pair = new Pair.Pair(keyNode, valueNode);
          if (ctx.options.keepSourceTokens)
            pair.srcToken = collItem;
          if (isMap) {
            const map2 = coll;
            if (utilMapIncludes.mapIncludes(ctx, map2.items, keyNode))
              onError(keyStart, "DUPLICATE_KEY", "Map keys must be unique");
            map2.items.push(pair);
          } else {
            const map2 = new YAMLMap.YAMLMap(ctx.schema);
            map2.flow = true;
            map2.items.push(pair);
            coll.items.push(map2);
          }
          offset = valueNode ? valueNode.range[2] : valueProps.end;
        }
      }
      const expectedEnd = isMap ? "}" : "]";
      const [ce, ...ee] = fc.end;
      let cePos = offset;
      if (ce && ce.source === expectedEnd)
        cePos = ce.offset + ce.source.length;
      else {
        const name = fcName[0].toUpperCase() + fcName.substring(1);
        const msg = atRoot ? `${name} must end with a ${expectedEnd}` : `${name} in block collection must be sufficiently indented and end with a ${expectedEnd}`;
        onError(offset, atRoot ? "MISSING_CHAR" : "BAD_INDENT", msg);
        if (ce && ce.source.length !== 1)
          ee.unshift(ce);
      }
      if (ee.length > 0) {
        const end = resolveEnd.resolveEnd(ee, cePos, ctx.options.strict, onError);
        if (end.comment) {
          if (coll.comment)
            coll.comment += "\n" + end.comment;
          else
            coll.comment = end.comment;
        }
        coll.range = [fc.offset, cePos, end.offset];
      } else {
        coll.range = [fc.offset, cePos, cePos];
      }
      return coll;
    }
    exports2.resolveFlowCollection = resolveFlowCollection;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/compose-collection.js
var require_compose_collection = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/compose-collection.js"(exports2) {
    "use strict";
    var identity2 = require_identity();
    var Scalar = require_Scalar();
    var YAMLMap = require_YAMLMap();
    var YAMLSeq = require_YAMLSeq();
    var resolveBlockMap = require_resolve_block_map();
    var resolveBlockSeq = require_resolve_block_seq();
    var resolveFlowCollection = require_resolve_flow_collection();
    function resolveCollection(CN, ctx, token, onError, tagName, tag) {
      const coll = token.type === "block-map" ? resolveBlockMap.resolveBlockMap(CN, ctx, token, onError, tag) : token.type === "block-seq" ? resolveBlockSeq.resolveBlockSeq(CN, ctx, token, onError, tag) : resolveFlowCollection.resolveFlowCollection(CN, ctx, token, onError, tag);
      const Coll = coll.constructor;
      if (tagName === "!" || tagName === Coll.tagName) {
        coll.tag = Coll.tagName;
        return coll;
      }
      if (tagName)
        coll.tag = tagName;
      return coll;
    }
    function composeCollection(CN, ctx, token, tagToken, onError) {
      const tagName = !tagToken ? null : ctx.directives.tagName(tagToken.source, (msg) => onError(tagToken, "TAG_RESOLVE_FAILED", msg));
      const expType = token.type === "block-map" ? "map" : token.type === "block-seq" ? "seq" : token.start.source === "{" ? "map" : "seq";
      if (!tagToken || !tagName || tagName === "!" || tagName === YAMLMap.YAMLMap.tagName && expType === "map" || tagName === YAMLSeq.YAMLSeq.tagName && expType === "seq" || !expType) {
        return resolveCollection(CN, ctx, token, onError, tagName);
      }
      let tag = ctx.schema.tags.find((t) => t.tag === tagName && t.collection === expType);
      if (!tag) {
        const kt = ctx.schema.knownTags[tagName];
        if (kt && kt.collection === expType) {
          ctx.schema.tags.push(Object.assign({}, kt, { default: false }));
          tag = kt;
        } else {
          if (kt?.collection) {
            onError(tagToken, "BAD_COLLECTION_TYPE", `${kt.tag} used for ${expType} collection, but expects ${kt.collection}`, true);
          } else {
            onError(tagToken, "TAG_RESOLVE_FAILED", `Unresolved tag: ${tagName}`, true);
          }
          return resolveCollection(CN, ctx, token, onError, tagName);
        }
      }
      const coll = resolveCollection(CN, ctx, token, onError, tagName, tag);
      const res = tag.resolve?.(coll, (msg) => onError(tagToken, "TAG_RESOLVE_FAILED", msg), ctx.options) ?? coll;
      const node = identity2.isNode(res) ? res : new Scalar.Scalar(res);
      node.range = coll.range;
      node.tag = tagName;
      if (tag?.format)
        node.format = tag.format;
      return node;
    }
    exports2.composeCollection = composeCollection;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/resolve-block-scalar.js
var require_resolve_block_scalar = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/resolve-block-scalar.js"(exports2) {
    "use strict";
    var Scalar = require_Scalar();
    function resolveBlockScalar(scalar, strict, onError) {
      const start = scalar.offset;
      const header = parseBlockScalarHeader(scalar, strict, onError);
      if (!header)
        return { value: "", type: null, comment: "", range: [start, start, start] };
      const type2 = header.mode === ">" ? Scalar.Scalar.BLOCK_FOLDED : Scalar.Scalar.BLOCK_LITERAL;
      const lines = scalar.source ? splitLines(scalar.source) : [];
      let chompStart = lines.length;
      for (let i = lines.length - 1; i >= 0; --i) {
        const content = lines[i][1];
        if (content === "" || content === "\r")
          chompStart = i;
        else
          break;
      }
      if (chompStart === 0) {
        const value2 = header.chomp === "+" && lines.length > 0 ? "\n".repeat(Math.max(1, lines.length - 1)) : "";
        let end2 = start + header.length;
        if (scalar.source)
          end2 += scalar.source.length;
        return { value: value2, type: type2, comment: header.comment, range: [start, end2, end2] };
      }
      let trimIndent = scalar.indent + header.indent;
      let offset = scalar.offset + header.length;
      let contentStart = 0;
      for (let i = 0; i < chompStart; ++i) {
        const [indent, content] = lines[i];
        if (content === "" || content === "\r") {
          if (header.indent === 0 && indent.length > trimIndent)
            trimIndent = indent.length;
        } else {
          if (indent.length < trimIndent) {
            const message = "Block scalars with more-indented leading empty lines must use an explicit indentation indicator";
            onError(offset + indent.length, "MISSING_CHAR", message);
          }
          if (header.indent === 0)
            trimIndent = indent.length;
          contentStart = i;
          break;
        }
        offset += indent.length + content.length + 1;
      }
      for (let i = lines.length - 1; i >= chompStart; --i) {
        if (lines[i][0].length > trimIndent)
          chompStart = i + 1;
      }
      let value = "";
      let sep2 = "";
      let prevMoreIndented = false;
      for (let i = 0; i < contentStart; ++i)
        value += lines[i][0].slice(trimIndent) + "\n";
      for (let i = contentStart; i < chompStart; ++i) {
        let [indent, content] = lines[i];
        offset += indent.length + content.length + 1;
        const crlf = content[content.length - 1] === "\r";
        if (crlf)
          content = content.slice(0, -1);
        if (content && indent.length < trimIndent) {
          const src = header.indent ? "explicit indentation indicator" : "first line";
          const message = `Block scalar lines must not be less indented than their ${src}`;
          onError(offset - content.length - (crlf ? 2 : 1), "BAD_INDENT", message);
          indent = "";
        }
        if (type2 === Scalar.Scalar.BLOCK_LITERAL) {
          value += sep2 + indent.slice(trimIndent) + content;
          sep2 = "\n";
        } else if (indent.length > trimIndent || content[0] === "	") {
          if (sep2 === " ")
            sep2 = "\n";
          else if (!prevMoreIndented && sep2 === "\n")
            sep2 = "\n\n";
          value += sep2 + indent.slice(trimIndent) + content;
          sep2 = "\n";
          prevMoreIndented = true;
        } else if (content === "") {
          if (sep2 === "\n")
            value += "\n";
          else
            sep2 = "\n";
        } else {
          value += sep2 + content;
          sep2 = " ";
          prevMoreIndented = false;
        }
      }
      switch (header.chomp) {
        case "-":
          break;
        case "+":
          for (let i = chompStart; i < lines.length; ++i)
            value += "\n" + lines[i][0].slice(trimIndent);
          if (value[value.length - 1] !== "\n")
            value += "\n";
          break;
        default:
          value += "\n";
      }
      const end = start + header.length + scalar.source.length;
      return { value, type: type2, comment: header.comment, range: [start, end, end] };
    }
    function parseBlockScalarHeader({ offset, props }, strict, onError) {
      if (props[0].type !== "block-scalar-header") {
        onError(props[0], "IMPOSSIBLE", "Block scalar header not found");
        return null;
      }
      const { source } = props[0];
      const mode = source[0];
      let indent = 0;
      let chomp = "";
      let error = -1;
      for (let i = 1; i < source.length; ++i) {
        const ch = source[i];
        if (!chomp && (ch === "-" || ch === "+"))
          chomp = ch;
        else {
          const n = Number(ch);
          if (!indent && n)
            indent = n;
          else if (error === -1)
            error = offset + i;
        }
      }
      if (error !== -1)
        onError(error, "UNEXPECTED_TOKEN", `Block scalar header includes extra characters: ${source}`);
      let hasSpace = false;
      let comment = "";
      let length = source.length;
      for (let i = 1; i < props.length; ++i) {
        const token = props[i];
        switch (token.type) {
          case "space":
            hasSpace = true;
          // fallthrough
          case "newline":
            length += token.source.length;
            break;
          case "comment":
            if (strict && !hasSpace) {
              const message = "Comments must be separated from other tokens by white space characters";
              onError(token, "MISSING_CHAR", message);
            }
            length += token.source.length;
            comment = token.source.substring(1);
            break;
          case "error":
            onError(token, "UNEXPECTED_TOKEN", token.message);
            length += token.source.length;
            break;
          /* istanbul ignore next should not happen */
          default: {
            const message = `Unexpected token in block scalar header: ${token.type}`;
            onError(token, "UNEXPECTED_TOKEN", message);
            const ts = token.source;
            if (ts && typeof ts === "string")
              length += ts.length;
          }
        }
      }
      return { mode, indent, chomp, comment, length };
    }
    function splitLines(source) {
      const split = source.split(/\n( *)/);
      const first = split[0];
      const m = first.match(/^( *)/);
      const line0 = m?.[1] ? [m[1], first.slice(m[1].length)] : ["", first];
      const lines = [line0];
      for (let i = 1; i < split.length; i += 2)
        lines.push([split[i], split[i + 1]]);
      return lines;
    }
    exports2.resolveBlockScalar = resolveBlockScalar;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/resolve-flow-scalar.js
var require_resolve_flow_scalar = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/resolve-flow-scalar.js"(exports2) {
    "use strict";
    var Scalar = require_Scalar();
    var resolveEnd = require_resolve_end();
    function resolveFlowScalar(scalar, strict, onError) {
      const { offset, type: type2, source, end } = scalar;
      let _type;
      let value;
      const _onError = (rel, code, msg) => onError(offset + rel, code, msg);
      switch (type2) {
        case "scalar":
          _type = Scalar.Scalar.PLAIN;
          value = plainValue(source, _onError);
          break;
        case "single-quoted-scalar":
          _type = Scalar.Scalar.QUOTE_SINGLE;
          value = singleQuotedValue(source, _onError);
          break;
        case "double-quoted-scalar":
          _type = Scalar.Scalar.QUOTE_DOUBLE;
          value = doubleQuotedValue(source, _onError);
          break;
        /* istanbul ignore next should not happen */
        default:
          onError(scalar, "UNEXPECTED_TOKEN", `Expected a flow scalar value, but found: ${type2}`);
          return {
            value: "",
            type: null,
            comment: "",
            range: [offset, offset + source.length, offset + source.length]
          };
      }
      const valueEnd = offset + source.length;
      const re = resolveEnd.resolveEnd(end, valueEnd, strict, onError);
      return {
        value,
        type: _type,
        comment: re.comment,
        range: [offset, valueEnd, re.offset]
      };
    }
    function plainValue(source, onError) {
      let badChar = "";
      switch (source[0]) {
        /* istanbul ignore next should not happen */
        case "	":
          badChar = "a tab character";
          break;
        case ",":
          badChar = "flow indicator character ,";
          break;
        case "%":
          badChar = "directive indicator character %";
          break;
        case "|":
        case ">": {
          badChar = `block scalar indicator ${source[0]}`;
          break;
        }
        case "@":
        case "`": {
          badChar = `reserved character ${source[0]}`;
          break;
        }
      }
      if (badChar)
        onError(0, "BAD_SCALAR_START", `Plain value cannot start with ${badChar}`);
      return foldLines(source);
    }
    function singleQuotedValue(source, onError) {
      if (source[source.length - 1] !== "'" || source.length === 1)
        onError(source.length, "MISSING_CHAR", "Missing closing 'quote");
      return foldLines(source.slice(1, -1)).replace(/''/g, "'");
    }
    function foldLines(source) {
      let first, line;
      try {
        first = new RegExp("(.*?)(?<![ 	])[ 	]*\r?\n", "sy");
        line = new RegExp("[ 	]*(.*?)(?:(?<![ 	])[ 	]*)?\r?\n", "sy");
      } catch (_) {
        first = /(.*?)[ \t]*\r?\n/sy;
        line = /[ \t]*(.*?)[ \t]*\r?\n/sy;
      }
      let match = first.exec(source);
      if (!match)
        return source;
      let res = match[1];
      let sep2 = " ";
      let pos = first.lastIndex;
      line.lastIndex = pos;
      while (match = line.exec(source)) {
        if (match[1] === "") {
          if (sep2 === "\n")
            res += sep2;
          else
            sep2 = "\n";
        } else {
          res += sep2 + match[1];
          sep2 = " ";
        }
        pos = line.lastIndex;
      }
      const last = /[ \t]*(.*)/sy;
      last.lastIndex = pos;
      match = last.exec(source);
      return res + sep2 + (match?.[1] ?? "");
    }
    function doubleQuotedValue(source, onError) {
      let res = "";
      for (let i = 1; i < source.length - 1; ++i) {
        const ch = source[i];
        if (ch === "\r" && source[i + 1] === "\n")
          continue;
        if (ch === "\n") {
          const { fold, offset } = foldNewline(source, i);
          res += fold;
          i = offset;
        } else if (ch === "\\") {
          let next = source[++i];
          const cc = escapeCodes[next];
          if (cc)
            res += cc;
          else if (next === "\n") {
            next = source[i + 1];
            while (next === " " || next === "	")
              next = source[++i + 1];
          } else if (next === "\r" && source[i + 1] === "\n") {
            next = source[++i + 1];
            while (next === " " || next === "	")
              next = source[++i + 1];
          } else if (next === "x" || next === "u" || next === "U") {
            const length = { x: 2, u: 4, U: 8 }[next];
            res += parseCharCode(source, i + 1, length, onError);
            i += length;
          } else {
            const raw = source.substr(i - 1, 2);
            onError(i - 1, "BAD_DQ_ESCAPE", `Invalid escape sequence ${raw}`);
            res += raw;
          }
        } else if (ch === " " || ch === "	") {
          const wsStart = i;
          let next = source[i + 1];
          while (next === " " || next === "	")
            next = source[++i + 1];
          if (next !== "\n" && !(next === "\r" && source[i + 2] === "\n"))
            res += i > wsStart ? source.slice(wsStart, i + 1) : ch;
        } else {
          res += ch;
        }
      }
      if (source[source.length - 1] !== '"' || source.length === 1)
        onError(source.length, "MISSING_CHAR", 'Missing closing "quote');
      return res;
    }
    function foldNewline(source, offset) {
      let fold = "";
      let ch = source[offset + 1];
      while (ch === " " || ch === "	" || ch === "\n" || ch === "\r") {
        if (ch === "\r" && source[offset + 2] !== "\n")
          break;
        if (ch === "\n")
          fold += "\n";
        offset += 1;
        ch = source[offset + 1];
      }
      if (!fold)
        fold = " ";
      return { fold, offset };
    }
    var escapeCodes = {
      "0": "\0",
      a: "\x07",
      b: "\b",
      e: "\x1B",
      f: "\f",
      n: "\n",
      r: "\r",
      t: "	",
      v: "\v",
      N: "\x85",
      _: "\xA0",
      L: "\u2028",
      P: "\u2029",
      " ": " ",
      '"': '"',
      "/": "/",
      "\\": "\\",
      "	": "	"
    };
    function parseCharCode(source, offset, length, onError) {
      const cc = source.substr(offset, length);
      const ok = cc.length === length && /^[0-9a-fA-F]+$/.test(cc);
      const code = ok ? parseInt(cc, 16) : NaN;
      if (isNaN(code)) {
        const raw = source.substr(offset - 2, length + 2);
        onError(offset - 2, "BAD_DQ_ESCAPE", `Invalid escape sequence ${raw}`);
        return raw;
      }
      return String.fromCodePoint(code);
    }
    exports2.resolveFlowScalar = resolveFlowScalar;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/compose-scalar.js
var require_compose_scalar = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/compose-scalar.js"(exports2) {
    "use strict";
    var identity2 = require_identity();
    var Scalar = require_Scalar();
    var resolveBlockScalar = require_resolve_block_scalar();
    var resolveFlowScalar = require_resolve_flow_scalar();
    function composeScalar(ctx, token, tagToken, onError) {
      const { value, type: type2, comment, range } = token.type === "block-scalar" ? resolveBlockScalar.resolveBlockScalar(token, ctx.options.strict, onError) : resolveFlowScalar.resolveFlowScalar(token, ctx.options.strict, onError);
      const tagName = tagToken ? ctx.directives.tagName(tagToken.source, (msg) => onError(tagToken, "TAG_RESOLVE_FAILED", msg)) : null;
      const tag = tagToken && tagName ? findScalarTagByName(ctx.schema, value, tagName, tagToken, onError) : token.type === "scalar" ? findScalarTagByTest(ctx, value, token, onError) : ctx.schema[identity2.SCALAR];
      let scalar;
      try {
        const res = tag.resolve(value, (msg) => onError(tagToken ?? token, "TAG_RESOLVE_FAILED", msg), ctx.options);
        scalar = identity2.isScalar(res) ? res : new Scalar.Scalar(res);
      } catch (error) {
        const msg = error instanceof Error ? error.message : String(error);
        onError(tagToken ?? token, "TAG_RESOLVE_FAILED", msg);
        scalar = new Scalar.Scalar(value);
      }
      scalar.range = range;
      scalar.source = value;
      if (type2)
        scalar.type = type2;
      if (tagName)
        scalar.tag = tagName;
      if (tag.format)
        scalar.format = tag.format;
      if (comment)
        scalar.comment = comment;
      return scalar;
    }
    function findScalarTagByName(schema2, value, tagName, tagToken, onError) {
      if (tagName === "!")
        return schema2[identity2.SCALAR];
      const matchWithTest = [];
      for (const tag of schema2.tags) {
        if (!tag.collection && tag.tag === tagName) {
          if (tag.default && tag.test)
            matchWithTest.push(tag);
          else
            return tag;
        }
      }
      for (const tag of matchWithTest)
        if (tag.test?.test(value))
          return tag;
      const kt = schema2.knownTags[tagName];
      if (kt && !kt.collection) {
        schema2.tags.push(Object.assign({}, kt, { default: false, test: void 0 }));
        return kt;
      }
      onError(tagToken, "TAG_RESOLVE_FAILED", `Unresolved tag: ${tagName}`, tagName !== "tag:yaml.org,2002:str");
      return schema2[identity2.SCALAR];
    }
    function findScalarTagByTest({ directives, schema: schema2 }, value, token, onError) {
      const tag = schema2.tags.find((tag2) => tag2.default && tag2.test?.test(value)) || schema2[identity2.SCALAR];
      if (schema2.compat) {
        const compat = schema2.compat.find((tag2) => tag2.default && tag2.test?.test(value)) ?? schema2[identity2.SCALAR];
        if (tag.tag !== compat.tag) {
          const ts = directives.tagString(tag.tag);
          const cs = directives.tagString(compat.tag);
          const msg = `Value may be parsed as either ${ts} or ${cs}`;
          onError(token, "TAG_RESOLVE_FAILED", msg, true);
        }
      }
      return tag;
    }
    exports2.composeScalar = composeScalar;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/util-empty-scalar-position.js
var require_util_empty_scalar_position = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/util-empty-scalar-position.js"(exports2) {
    "use strict";
    function emptyScalarPosition(offset, before, pos) {
      if (before) {
        if (pos === null)
          pos = before.length;
        for (let i = pos - 1; i >= 0; --i) {
          let st = before[i];
          switch (st.type) {
            case "space":
            case "comment":
            case "newline":
              offset -= st.source.length;
              continue;
          }
          st = before[++i];
          while (st?.type === "space") {
            offset += st.source.length;
            st = before[++i];
          }
          break;
        }
      }
      return offset;
    }
    exports2.emptyScalarPosition = emptyScalarPosition;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/compose-node.js
var require_compose_node = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/compose-node.js"(exports2) {
    "use strict";
    var Alias = require_Alias();
    var composeCollection = require_compose_collection();
    var composeScalar = require_compose_scalar();
    var resolveEnd = require_resolve_end();
    var utilEmptyScalarPosition = require_util_empty_scalar_position();
    var CN = { composeNode: composeNode2, composeEmptyNode };
    function composeNode2(ctx, token, props, onError) {
      const { spaceBefore, comment, anchor, tag } = props;
      let node;
      let isSrcToken = true;
      switch (token.type) {
        case "alias":
          node = composeAlias(ctx, token, onError);
          if (anchor || tag)
            onError(token, "ALIAS_PROPS", "An alias node must not specify any properties");
          break;
        case "scalar":
        case "single-quoted-scalar":
        case "double-quoted-scalar":
        case "block-scalar":
          node = composeScalar.composeScalar(ctx, token, tag, onError);
          if (anchor)
            node.anchor = anchor.source.substring(1);
          break;
        case "block-map":
        case "block-seq":
        case "flow-collection":
          node = composeCollection.composeCollection(CN, ctx, token, tag, onError);
          if (anchor)
            node.anchor = anchor.source.substring(1);
          break;
        default: {
          const message = token.type === "error" ? token.message : `Unsupported token (type: ${token.type})`;
          onError(token, "UNEXPECTED_TOKEN", message);
          node = composeEmptyNode(ctx, token.offset, void 0, null, props, onError);
          isSrcToken = false;
        }
      }
      if (anchor && node.anchor === "")
        onError(anchor, "BAD_ALIAS", "Anchor cannot be an empty string");
      if (spaceBefore)
        node.spaceBefore = true;
      if (comment) {
        if (token.type === "scalar" && token.source === "")
          node.comment = comment;
        else
          node.commentBefore = comment;
      }
      if (ctx.options.keepSourceTokens && isSrcToken)
        node.srcToken = token;
      return node;
    }
    function composeEmptyNode(ctx, offset, before, pos, { spaceBefore, comment, anchor, tag, end }, onError) {
      const token = {
        type: "scalar",
        offset: utilEmptyScalarPosition.emptyScalarPosition(offset, before, pos),
        indent: -1,
        source: ""
      };
      const node = composeScalar.composeScalar(ctx, token, tag, onError);
      if (anchor) {
        node.anchor = anchor.source.substring(1);
        if (node.anchor === "")
          onError(anchor, "BAD_ALIAS", "Anchor cannot be an empty string");
      }
      if (spaceBefore)
        node.spaceBefore = true;
      if (comment) {
        node.comment = comment;
        node.range[2] = end;
      }
      return node;
    }
    function composeAlias({ options }, { offset, source, end }, onError) {
      const alias = new Alias.Alias(source.substring(1));
      if (alias.source === "")
        onError(offset, "BAD_ALIAS", "Alias cannot be an empty string");
      if (alias.source.endsWith(":"))
        onError(offset + source.length - 1, "BAD_ALIAS", "Alias ending in : is ambiguous", true);
      const valueEnd = offset + source.length;
      const re = resolveEnd.resolveEnd(end, valueEnd, options.strict, onError);
      alias.range = [offset, valueEnd, re.offset];
      if (re.comment)
        alias.comment = re.comment;
      return alias;
    }
    exports2.composeEmptyNode = composeEmptyNode;
    exports2.composeNode = composeNode2;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/compose-doc.js
var require_compose_doc = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/compose-doc.js"(exports2) {
    "use strict";
    var Document = require_Document();
    var composeNode2 = require_compose_node();
    var resolveEnd = require_resolve_end();
    var resolveProps = require_resolve_props();
    function composeDoc(options, directives, { offset, start, value, end }, onError) {
      const opts = Object.assign({ _directives: directives }, options);
      const doc = new Document.Document(void 0, opts);
      const ctx = {
        atRoot: true,
        directives: doc.directives,
        options: doc.options,
        schema: doc.schema
      };
      const props = resolveProps.resolveProps(start, {
        indicator: "doc-start",
        next: value ?? end?.[0],
        offset,
        onError,
        startOnNewline: true
      });
      if (props.found) {
        doc.directives.docStart = true;
        if (value && (value.type === "block-map" || value.type === "block-seq") && !props.hasNewline)
          onError(props.end, "MISSING_CHAR", "Block collection cannot start on same line with directives-end marker");
      }
      doc.contents = value ? composeNode2.composeNode(ctx, value, props, onError) : composeNode2.composeEmptyNode(ctx, props.end, start, null, props, onError);
      const contentEnd = doc.contents.range[2];
      const re = resolveEnd.resolveEnd(end, contentEnd, false, onError);
      if (re.comment)
        doc.comment = re.comment;
      doc.range = [offset, contentEnd, re.offset];
      return doc;
    }
    exports2.composeDoc = composeDoc;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/composer.js
var require_composer = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/compose/composer.js"(exports2) {
    "use strict";
    var directives = require_directives();
    var Document = require_Document();
    var errors = require_errors();
    var identity2 = require_identity();
    var composeDoc = require_compose_doc();
    var resolveEnd = require_resolve_end();
    function getErrorPos(src) {
      if (typeof src === "number")
        return [src, src + 1];
      if (Array.isArray(src))
        return src.length === 2 ? src : [src[0], src[1]];
      const { offset, source } = src;
      return [offset, offset + (typeof source === "string" ? source.length : 1)];
    }
    function parsePrelude(prelude) {
      let comment = "";
      let atComment = false;
      let afterEmptyLine = false;
      for (let i = 0; i < prelude.length; ++i) {
        const source = prelude[i];
        switch (source[0]) {
          case "#":
            comment += (comment === "" ? "" : afterEmptyLine ? "\n\n" : "\n") + (source.substring(1) || " ");
            atComment = true;
            afterEmptyLine = false;
            break;
          case "%":
            if (prelude[i + 1]?.[0] !== "#")
              i += 1;
            atComment = false;
            break;
          default:
            if (!atComment)
              afterEmptyLine = true;
            atComment = false;
        }
      }
      return { comment, afterEmptyLine };
    }
    var Composer = class {
      constructor(options = {}) {
        this.doc = null;
        this.atDirectives = false;
        this.prelude = [];
        this.errors = [];
        this.warnings = [];
        this.onError = (source, code, message, warning) => {
          const pos = getErrorPos(source);
          if (warning)
            this.warnings.push(new errors.YAMLWarning(pos, code, message));
          else
            this.errors.push(new errors.YAMLParseError(pos, code, message));
        };
        this.directives = new directives.Directives({ version: options.version || "1.2" });
        this.options = options;
      }
      decorate(doc, afterDoc) {
        const { comment, afterEmptyLine } = parsePrelude(this.prelude);
        if (comment) {
          const dc = doc.contents;
          if (afterDoc) {
            doc.comment = doc.comment ? `${doc.comment}
${comment}` : comment;
          } else if (afterEmptyLine || doc.directives.docStart || !dc) {
            doc.commentBefore = comment;
          } else if (identity2.isCollection(dc) && !dc.flow && dc.items.length > 0) {
            let it = dc.items[0];
            if (identity2.isPair(it))
              it = it.key;
            const cb = it.commentBefore;
            it.commentBefore = cb ? `${comment}
${cb}` : comment;
          } else {
            const cb = dc.commentBefore;
            dc.commentBefore = cb ? `${comment}
${cb}` : comment;
          }
        }
        if (afterDoc) {
          Array.prototype.push.apply(doc.errors, this.errors);
          Array.prototype.push.apply(doc.warnings, this.warnings);
        } else {
          doc.errors = this.errors;
          doc.warnings = this.warnings;
        }
        this.prelude = [];
        this.errors = [];
        this.warnings = [];
      }
      /**
       * Current stream status information.
       *
       * Mostly useful at the end of input for an empty stream.
       */
      streamInfo() {
        return {
          comment: parsePrelude(this.prelude).comment,
          directives: this.directives,
          errors: this.errors,
          warnings: this.warnings
        };
      }
      /**
       * Compose tokens into documents.
       *
       * @param forceDoc - If the stream contains no document, still emit a final document including any comments and directives that would be applied to a subsequent document.
       * @param endOffset - Should be set if `forceDoc` is also set, to set the document range end and to indicate errors correctly.
       */
      *compose(tokens, forceDoc = false, endOffset = -1) {
        for (const token of tokens)
          yield* this.next(token);
        yield* this.end(forceDoc, endOffset);
      }
      /** Advance the composer by one CST token. */
      *next(token) {
        if (process.env.LOG_STREAM)
          console.dir(token, { depth: null });
        switch (token.type) {
          case "directive":
            this.directives.add(token.source, (offset, message, warning) => {
              const pos = getErrorPos(token);
              pos[0] += offset;
              this.onError(pos, "BAD_DIRECTIVE", message, warning);
            });
            this.prelude.push(token.source);
            this.atDirectives = true;
            break;
          case "document": {
            const doc = composeDoc.composeDoc(this.options, this.directives, token, this.onError);
            if (this.atDirectives && !doc.directives.docStart)
              this.onError(token, "MISSING_CHAR", "Missing directives-end/doc-start indicator line");
            this.decorate(doc, false);
            if (this.doc)
              yield this.doc;
            this.doc = doc;
            this.atDirectives = false;
            break;
          }
          case "byte-order-mark":
          case "space":
            break;
          case "comment":
          case "newline":
            this.prelude.push(token.source);
            break;
          case "error": {
            const msg = token.source ? `${token.message}: ${JSON.stringify(token.source)}` : token.message;
            const error = new errors.YAMLParseError(getErrorPos(token), "UNEXPECTED_TOKEN", msg);
            if (this.atDirectives || !this.doc)
              this.errors.push(error);
            else
              this.doc.errors.push(error);
            break;
          }
          case "doc-end": {
            if (!this.doc) {
              const msg = "Unexpected doc-end without preceding document";
              this.errors.push(new errors.YAMLParseError(getErrorPos(token), "UNEXPECTED_TOKEN", msg));
              break;
            }
            this.doc.directives.docEnd = true;
            const end = resolveEnd.resolveEnd(token.end, token.offset + token.source.length, this.doc.options.strict, this.onError);
            this.decorate(this.doc, true);
            if (end.comment) {
              const dc = this.doc.comment;
              this.doc.comment = dc ? `${dc}
${end.comment}` : end.comment;
            }
            this.doc.range[2] = end.offset;
            break;
          }
          default:
            this.errors.push(new errors.YAMLParseError(getErrorPos(token), "UNEXPECTED_TOKEN", `Unsupported token ${token.type}`));
        }
      }
      /**
       * Call at end of input to yield any remaining document.
       *
       * @param forceDoc - If the stream contains no document, still emit a final document including any comments and directives that would be applied to a subsequent document.
       * @param endOffset - Should be set if `forceDoc` is also set, to set the document range end and to indicate errors correctly.
       */
      *end(forceDoc = false, endOffset = -1) {
        if (this.doc) {
          this.decorate(this.doc, true);
          yield this.doc;
          this.doc = null;
        } else if (forceDoc) {
          const opts = Object.assign({ _directives: this.directives }, this.options);
          const doc = new Document.Document(void 0, opts);
          if (this.atDirectives)
            this.onError(endOffset, "MISSING_CHAR", "Missing directives-end indicator line");
          doc.range = [0, endOffset, endOffset];
          this.decorate(doc, false);
          yield doc;
        }
      }
    };
    exports2.Composer = Composer;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/parse/cst-scalar.js
var require_cst_scalar = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/parse/cst-scalar.js"(exports2) {
    "use strict";
    var resolveBlockScalar = require_resolve_block_scalar();
    var resolveFlowScalar = require_resolve_flow_scalar();
    var errors = require_errors();
    var stringifyString = require_stringifyString();
    function resolveAsScalar(token, strict = true, onError) {
      if (token) {
        const _onError = (pos, code, message) => {
          const offset = typeof pos === "number" ? pos : Array.isArray(pos) ? pos[0] : pos.offset;
          if (onError)
            onError(offset, code, message);
          else
            throw new errors.YAMLParseError([offset, offset + 1], code, message);
        };
        switch (token.type) {
          case "scalar":
          case "single-quoted-scalar":
          case "double-quoted-scalar":
            return resolveFlowScalar.resolveFlowScalar(token, strict, _onError);
          case "block-scalar":
            return resolveBlockScalar.resolveBlockScalar(token, strict, _onError);
        }
      }
      return null;
    }
    function createScalarToken(value, context) {
      const { implicitKey = false, indent, inFlow = false, offset = -1, type: type2 = "PLAIN" } = context;
      const source = stringifyString.stringifyString({ type: type2, value }, {
        implicitKey,
        indent: indent > 0 ? " ".repeat(indent) : "",
        inFlow,
        options: { blockQuote: true, lineWidth: -1 }
      });
      const end = context.end ?? [
        { type: "newline", offset: -1, indent, source: "\n" }
      ];
      switch (source[0]) {
        case "|":
        case ">": {
          const he = source.indexOf("\n");
          const head = source.substring(0, he);
          const body = source.substring(he + 1) + "\n";
          const props = [
            { type: "block-scalar-header", offset, indent, source: head }
          ];
          if (!addEndtoBlockProps(props, end))
            props.push({ type: "newline", offset: -1, indent, source: "\n" });
          return { type: "block-scalar", offset, indent, props, source: body };
        }
        case '"':
          return { type: "double-quoted-scalar", offset, indent, source, end };
        case "'":
          return { type: "single-quoted-scalar", offset, indent, source, end };
        default:
          return { type: "scalar", offset, indent, source, end };
      }
    }
    function setScalarValue(token, value, context = {}) {
      let { afterKey = false, implicitKey = false, inFlow = false, type: type2 } = context;
      let indent = "indent" in token ? token.indent : null;
      if (afterKey && typeof indent === "number")
        indent += 2;
      if (!type2)
        switch (token.type) {
          case "single-quoted-scalar":
            type2 = "QUOTE_SINGLE";
            break;
          case "double-quoted-scalar":
            type2 = "QUOTE_DOUBLE";
            break;
          case "block-scalar": {
            const header = token.props[0];
            if (header.type !== "block-scalar-header")
              throw new Error("Invalid block scalar header");
            type2 = header.source[0] === ">" ? "BLOCK_FOLDED" : "BLOCK_LITERAL";
            break;
          }
          default:
            type2 = "PLAIN";
        }
      const source = stringifyString.stringifyString({ type: type2, value }, {
        implicitKey: implicitKey || indent === null,
        indent: indent !== null && indent > 0 ? " ".repeat(indent) : "",
        inFlow,
        options: { blockQuote: true, lineWidth: -1 }
      });
      switch (source[0]) {
        case "|":
        case ">":
          setBlockScalarValue(token, source);
          break;
        case '"':
          setFlowScalarValue(token, source, "double-quoted-scalar");
          break;
        case "'":
          setFlowScalarValue(token, source, "single-quoted-scalar");
          break;
        default:
          setFlowScalarValue(token, source, "scalar");
      }
    }
    function setBlockScalarValue(token, source) {
      const he = source.indexOf("\n");
      const head = source.substring(0, he);
      const body = source.substring(he + 1) + "\n";
      if (token.type === "block-scalar") {
        const header = token.props[0];
        if (header.type !== "block-scalar-header")
          throw new Error("Invalid block scalar header");
        header.source = head;
        token.source = body;
      } else {
        const { offset } = token;
        const indent = "indent" in token ? token.indent : -1;
        const props = [
          { type: "block-scalar-header", offset, indent, source: head }
        ];
        if (!addEndtoBlockProps(props, "end" in token ? token.end : void 0))
          props.push({ type: "newline", offset: -1, indent, source: "\n" });
        for (const key of Object.keys(token))
          if (key !== "type" && key !== "offset")
            delete token[key];
        Object.assign(token, { type: "block-scalar", indent, props, source: body });
      }
    }
    function addEndtoBlockProps(props, end) {
      if (end)
        for (const st of end)
          switch (st.type) {
            case "space":
            case "comment":
              props.push(st);
              break;
            case "newline":
              props.push(st);
              return true;
          }
      return false;
    }
    function setFlowScalarValue(token, source, type2) {
      switch (token.type) {
        case "scalar":
        case "double-quoted-scalar":
        case "single-quoted-scalar":
          token.type = type2;
          token.source = source;
          break;
        case "block-scalar": {
          const end = token.props.slice(1);
          let oa = source.length;
          if (token.props[0].type === "block-scalar-header")
            oa -= token.props[0].source.length;
          for (const tok of end)
            tok.offset += oa;
          delete token.props;
          Object.assign(token, { type: type2, source, end });
          break;
        }
        case "block-map":
        case "block-seq": {
          const offset = token.offset + source.length;
          const nl = { type: "newline", offset, indent: token.indent, source: "\n" };
          delete token.items;
          Object.assign(token, { type: type2, source, end: [nl] });
          break;
        }
        default: {
          const indent = "indent" in token ? token.indent : -1;
          const end = "end" in token && Array.isArray(token.end) ? token.end.filter((st) => st.type === "space" || st.type === "comment" || st.type === "newline") : [];
          for (const key of Object.keys(token))
            if (key !== "type" && key !== "offset")
              delete token[key];
          Object.assign(token, { type: type2, indent, source, end });
        }
      }
    }
    exports2.createScalarToken = createScalarToken;
    exports2.resolveAsScalar = resolveAsScalar;
    exports2.setScalarValue = setScalarValue;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/parse/cst-stringify.js
var require_cst_stringify = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/parse/cst-stringify.js"(exports2) {
    "use strict";
    var stringify = (cst) => "type" in cst ? stringifyToken(cst) : stringifyItem(cst);
    function stringifyToken(token) {
      switch (token.type) {
        case "block-scalar": {
          let res = "";
          for (const tok of token.props)
            res += stringifyToken(tok);
          return res + token.source;
        }
        case "block-map":
        case "block-seq": {
          let res = "";
          for (const item of token.items)
            res += stringifyItem(item);
          return res;
        }
        case "flow-collection": {
          let res = token.start.source;
          for (const item of token.items)
            res += stringifyItem(item);
          for (const st of token.end)
            res += st.source;
          return res;
        }
        case "document": {
          let res = stringifyItem(token);
          if (token.end)
            for (const st of token.end)
              res += st.source;
          return res;
        }
        default: {
          let res = token.source;
          if ("end" in token && token.end)
            for (const st of token.end)
              res += st.source;
          return res;
        }
      }
    }
    function stringifyItem({ start, key, sep: sep2, value }) {
      let res = "";
      for (const st of start)
        res += st.source;
      if (key)
        res += stringifyToken(key);
      if (sep2)
        for (const st of sep2)
          res += st.source;
      if (value)
        res += stringifyToken(value);
      return res;
    }
    exports2.stringify = stringify;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/parse/cst-visit.js
var require_cst_visit = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/parse/cst-visit.js"(exports2) {
    "use strict";
    var BREAK = Symbol("break visit");
    var SKIP = Symbol("skip children");
    var REMOVE = Symbol("remove item");
    function visit(cst, visitor) {
      if ("type" in cst && cst.type === "document")
        cst = { start: cst.start, value: cst.value };
      _visit(Object.freeze([]), cst, visitor);
    }
    visit.BREAK = BREAK;
    visit.SKIP = SKIP;
    visit.REMOVE = REMOVE;
    visit.itemAtPath = (cst, path5) => {
      let item = cst;
      for (const [field, index] of path5) {
        const tok = item?.[field];
        if (tok && "items" in tok) {
          item = tok.items[index];
        } else
          return void 0;
      }
      return item;
    };
    visit.parentCollection = (cst, path5) => {
      const parent = visit.itemAtPath(cst, path5.slice(0, -1));
      const field = path5[path5.length - 1][0];
      const coll = parent?.[field];
      if (coll && "items" in coll)
        return coll;
      throw new Error("Parent collection not found");
    };
    function _visit(path5, item, visitor) {
      let ctrl = visitor(item, path5);
      if (typeof ctrl === "symbol")
        return ctrl;
      for (const field of ["key", "value"]) {
        const token = item[field];
        if (token && "items" in token) {
          for (let i = 0; i < token.items.length; ++i) {
            const ci = _visit(Object.freeze(path5.concat([[field, i]])), token.items[i], visitor);
            if (typeof ci === "number")
              i = ci - 1;
            else if (ci === BREAK)
              return BREAK;
            else if (ci === REMOVE) {
              token.items.splice(i, 1);
              i -= 1;
            }
          }
          if (typeof ctrl === "function" && field === "key")
            ctrl = ctrl(item, path5);
        }
      }
      return typeof ctrl === "function" ? ctrl(item, path5) : ctrl;
    }
    exports2.visit = visit;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/parse/cst.js
var require_cst = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/parse/cst.js"(exports2) {
    "use strict";
    var cstScalar = require_cst_scalar();
    var cstStringify = require_cst_stringify();
    var cstVisit = require_cst_visit();
    var BOM = "\uFEFF";
    var DOCUMENT = "";
    var FLOW_END = "";
    var SCALAR = "";
    var isCollection = (token) => !!token && "items" in token;
    var isScalar = (token) => !!token && (token.type === "scalar" || token.type === "single-quoted-scalar" || token.type === "double-quoted-scalar" || token.type === "block-scalar");
    function prettyToken(token) {
      switch (token) {
        case BOM:
          return "<BOM>";
        case DOCUMENT:
          return "<DOC>";
        case FLOW_END:
          return "<FLOW_END>";
        case SCALAR:
          return "<SCALAR>";
        default:
          return JSON.stringify(token);
      }
    }
    function tokenType(source) {
      switch (source) {
        case BOM:
          return "byte-order-mark";
        case DOCUMENT:
          return "doc-mode";
        case FLOW_END:
          return "flow-error-end";
        case SCALAR:
          return "scalar";
        case "---":
          return "doc-start";
        case "...":
          return "doc-end";
        case "":
        case "\n":
        case "\r\n":
          return "newline";
        case "-":
          return "seq-item-ind";
        case "?":
          return "explicit-key-ind";
        case ":":
          return "map-value-ind";
        case "{":
          return "flow-map-start";
        case "}":
          return "flow-map-end";
        case "[":
          return "flow-seq-start";
        case "]":
          return "flow-seq-end";
        case ",":
          return "comma";
      }
      switch (source[0]) {
        case " ":
        case "	":
          return "space";
        case "#":
          return "comment";
        case "%":
          return "directive-line";
        case "*":
          return "alias";
        case "&":
          return "anchor";
        case "!":
          return "tag";
        case "'":
          return "single-quoted-scalar";
        case '"':
          return "double-quoted-scalar";
        case "|":
        case ">":
          return "block-scalar-header";
      }
      return null;
    }
    exports2.createScalarToken = cstScalar.createScalarToken;
    exports2.resolveAsScalar = cstScalar.resolveAsScalar;
    exports2.setScalarValue = cstScalar.setScalarValue;
    exports2.stringify = cstStringify.stringify;
    exports2.visit = cstVisit.visit;
    exports2.BOM = BOM;
    exports2.DOCUMENT = DOCUMENT;
    exports2.FLOW_END = FLOW_END;
    exports2.SCALAR = SCALAR;
    exports2.isCollection = isCollection;
    exports2.isScalar = isScalar;
    exports2.prettyToken = prettyToken;
    exports2.tokenType = tokenType;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/parse/lexer.js
var require_lexer = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/parse/lexer.js"(exports2) {
    "use strict";
    var cst = require_cst();
    function isEmpty(ch) {
      switch (ch) {
        case void 0:
        case " ":
        case "\n":
        case "\r":
        case "	":
          return true;
        default:
          return false;
      }
    }
    var hexDigits = "0123456789ABCDEFabcdef".split("");
    var tagChars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-#;/?:@&=+$_.!~*'()".split("");
    var invalidFlowScalarChars = ",[]{}".split("");
    var invalidAnchorChars = " ,[]{}\n\r	".split("");
    var isNotAnchorChar = (ch) => !ch || invalidAnchorChars.includes(ch);
    var Lexer = class {
      constructor() {
        this.atEnd = false;
        this.blockScalarIndent = -1;
        this.blockScalarKeep = false;
        this.buffer = "";
        this.flowKey = false;
        this.flowLevel = 0;
        this.indentNext = 0;
        this.indentValue = 0;
        this.lineEndPos = null;
        this.next = null;
        this.pos = 0;
      }
      /**
       * Generate YAML tokens from the `source` string. If `incomplete`,
       * a part of the last line may be left as a buffer for the next call.
       *
       * @returns A generator of lexical tokens
       */
      *lex(source, incomplete = false) {
        if (source) {
          this.buffer = this.buffer ? this.buffer + source : source;
          this.lineEndPos = null;
        }
        this.atEnd = !incomplete;
        let next = this.next ?? "stream";
        while (next && (incomplete || this.hasChars(1)))
          next = yield* this.parseNext(next);
      }
      atLineEnd() {
        let i = this.pos;
        let ch = this.buffer[i];
        while (ch === " " || ch === "	")
          ch = this.buffer[++i];
        if (!ch || ch === "#" || ch === "\n")
          return true;
        if (ch === "\r")
          return this.buffer[i + 1] === "\n";
        return false;
      }
      charAt(n) {
        return this.buffer[this.pos + n];
      }
      continueScalar(offset) {
        let ch = this.buffer[offset];
        if (this.indentNext > 0) {
          let indent = 0;
          while (ch === " ")
            ch = this.buffer[++indent + offset];
          if (ch === "\r") {
            const next = this.buffer[indent + offset + 1];
            if (next === "\n" || !next && !this.atEnd)
              return offset + indent + 1;
          }
          return ch === "\n" || indent >= this.indentNext || !ch && !this.atEnd ? offset + indent : -1;
        }
        if (ch === "-" || ch === ".") {
          const dt = this.buffer.substr(offset, 3);
          if ((dt === "---" || dt === "...") && isEmpty(this.buffer[offset + 3]))
            return -1;
        }
        return offset;
      }
      getLine() {
        let end = this.lineEndPos;
        if (typeof end !== "number" || end !== -1 && end < this.pos) {
          end = this.buffer.indexOf("\n", this.pos);
          this.lineEndPos = end;
        }
        if (end === -1)
          return this.atEnd ? this.buffer.substring(this.pos) : null;
        if (this.buffer[end - 1] === "\r")
          end -= 1;
        return this.buffer.substring(this.pos, end);
      }
      hasChars(n) {
        return this.pos + n <= this.buffer.length;
      }
      setNext(state) {
        this.buffer = this.buffer.substring(this.pos);
        this.pos = 0;
        this.lineEndPos = null;
        this.next = state;
        return null;
      }
      peek(n) {
        return this.buffer.substr(this.pos, n);
      }
      *parseNext(next) {
        switch (next) {
          case "stream":
            return yield* this.parseStream();
          case "line-start":
            return yield* this.parseLineStart();
          case "block-start":
            return yield* this.parseBlockStart();
          case "doc":
            return yield* this.parseDocument();
          case "flow":
            return yield* this.parseFlowCollection();
          case "quoted-scalar":
            return yield* this.parseQuotedScalar();
          case "block-scalar":
            return yield* this.parseBlockScalar();
          case "plain-scalar":
            return yield* this.parsePlainScalar();
        }
      }
      *parseStream() {
        let line = this.getLine();
        if (line === null)
          return this.setNext("stream");
        if (line[0] === cst.BOM) {
          yield* this.pushCount(1);
          line = line.substring(1);
        }
        if (line[0] === "%") {
          let dirEnd = line.length;
          const cs = line.indexOf("#");
          if (cs !== -1) {
            const ch = line[cs - 1];
            if (ch === " " || ch === "	")
              dirEnd = cs - 1;
          }
          while (true) {
            const ch = line[dirEnd - 1];
            if (ch === " " || ch === "	")
              dirEnd -= 1;
            else
              break;
          }
          const n = (yield* this.pushCount(dirEnd)) + (yield* this.pushSpaces(true));
          yield* this.pushCount(line.length - n);
          this.pushNewline();
          return "stream";
        }
        if (this.atLineEnd()) {
          const sp = yield* this.pushSpaces(true);
          yield* this.pushCount(line.length - sp);
          yield* this.pushNewline();
          return "stream";
        }
        yield cst.DOCUMENT;
        return yield* this.parseLineStart();
      }
      *parseLineStart() {
        const ch = this.charAt(0);
        if (!ch && !this.atEnd)
          return this.setNext("line-start");
        if (ch === "-" || ch === ".") {
          if (!this.atEnd && !this.hasChars(4))
            return this.setNext("line-start");
          const s = this.peek(3);
          if (s === "---" && isEmpty(this.charAt(3))) {
            yield* this.pushCount(3);
            this.indentValue = 0;
            this.indentNext = 0;
            return "doc";
          } else if (s === "..." && isEmpty(this.charAt(3))) {
            yield* this.pushCount(3);
            return "stream";
          }
        }
        this.indentValue = yield* this.pushSpaces(false);
        if (this.indentNext > this.indentValue && !isEmpty(this.charAt(1)))
          this.indentNext = this.indentValue;
        return yield* this.parseBlockStart();
      }
      *parseBlockStart() {
        const [ch0, ch1] = this.peek(2);
        if (!ch1 && !this.atEnd)
          return this.setNext("block-start");
        if ((ch0 === "-" || ch0 === "?" || ch0 === ":") && isEmpty(ch1)) {
          const n = (yield* this.pushCount(1)) + (yield* this.pushSpaces(true));
          this.indentNext = this.indentValue + 1;
          this.indentValue += n;
          return yield* this.parseBlockStart();
        }
        return "doc";
      }
      *parseDocument() {
        yield* this.pushSpaces(true);
        const line = this.getLine();
        if (line === null)
          return this.setNext("doc");
        let n = yield* this.pushIndicators();
        switch (line[n]) {
          case "#":
            yield* this.pushCount(line.length - n);
          // fallthrough
          case void 0:
            yield* this.pushNewline();
            return yield* this.parseLineStart();
          case "{":
          case "[":
            yield* this.pushCount(1);
            this.flowKey = false;
            this.flowLevel = 1;
            return "flow";
          case "}":
          case "]":
            yield* this.pushCount(1);
            return "doc";
          case "*":
            yield* this.pushUntil(isNotAnchorChar);
            return "doc";
          case '"':
          case "'":
            return yield* this.parseQuotedScalar();
          case "|":
          case ">":
            n += yield* this.parseBlockScalarHeader();
            n += yield* this.pushSpaces(true);
            yield* this.pushCount(line.length - n);
            yield* this.pushNewline();
            return yield* this.parseBlockScalar();
          default:
            return yield* this.parsePlainScalar();
        }
      }
      *parseFlowCollection() {
        let nl, sp;
        let indent = -1;
        do {
          nl = yield* this.pushNewline();
          if (nl > 0) {
            sp = yield* this.pushSpaces(false);
            this.indentValue = indent = sp;
          } else {
            sp = 0;
          }
          sp += yield* this.pushSpaces(true);
        } while (nl + sp > 0);
        const line = this.getLine();
        if (line === null)
          return this.setNext("flow");
        if (indent !== -1 && indent < this.indentNext && line[0] !== "#" || indent === 0 && (line.startsWith("---") || line.startsWith("...")) && isEmpty(line[3])) {
          const atFlowEndMarker = indent === this.indentNext - 1 && this.flowLevel === 1 && (line[0] === "]" || line[0] === "}");
          if (!atFlowEndMarker) {
            this.flowLevel = 0;
            yield cst.FLOW_END;
            return yield* this.parseLineStart();
          }
        }
        let n = 0;
        while (line[n] === ",") {
          n += yield* this.pushCount(1);
          n += yield* this.pushSpaces(true);
          this.flowKey = false;
        }
        n += yield* this.pushIndicators();
        switch (line[n]) {
          case void 0:
            return "flow";
          case "#":
            yield* this.pushCount(line.length - n);
            return "flow";
          case "{":
          case "[":
            yield* this.pushCount(1);
            this.flowKey = false;
            this.flowLevel += 1;
            return "flow";
          case "}":
          case "]":
            yield* this.pushCount(1);
            this.flowKey = true;
            this.flowLevel -= 1;
            return this.flowLevel ? "flow" : "doc";
          case "*":
            yield* this.pushUntil(isNotAnchorChar);
            return "flow";
          case '"':
          case "'":
            this.flowKey = true;
            return yield* this.parseQuotedScalar();
          case ":": {
            const next = this.charAt(1);
            if (this.flowKey || isEmpty(next) || next === ",") {
              this.flowKey = false;
              yield* this.pushCount(1);
              yield* this.pushSpaces(true);
              return "flow";
            }
          }
          // fallthrough
          default:
            this.flowKey = false;
            return yield* this.parsePlainScalar();
        }
      }
      *parseQuotedScalar() {
        const quote = this.charAt(0);
        let end = this.buffer.indexOf(quote, this.pos + 1);
        if (quote === "'") {
          while (end !== -1 && this.buffer[end + 1] === "'")
            end = this.buffer.indexOf("'", end + 2);
        } else {
          while (end !== -1) {
            let n = 0;
            while (this.buffer[end - 1 - n] === "\\")
              n += 1;
            if (n % 2 === 0)
              break;
            end = this.buffer.indexOf('"', end + 1);
          }
        }
        const qb = this.buffer.substring(0, end);
        let nl = qb.indexOf("\n", this.pos);
        if (nl !== -1) {
          while (nl !== -1) {
            const cs = this.continueScalar(nl + 1);
            if (cs === -1)
              break;
            nl = qb.indexOf("\n", cs);
          }
          if (nl !== -1) {
            end = nl - (qb[nl - 1] === "\r" ? 2 : 1);
          }
        }
        if (end === -1) {
          if (!this.atEnd)
            return this.setNext("quoted-scalar");
          end = this.buffer.length;
        }
        yield* this.pushToIndex(end + 1, false);
        return this.flowLevel ? "flow" : "doc";
      }
      *parseBlockScalarHeader() {
        this.blockScalarIndent = -1;
        this.blockScalarKeep = false;
        let i = this.pos;
        while (true) {
          const ch = this.buffer[++i];
          if (ch === "+")
            this.blockScalarKeep = true;
          else if (ch > "0" && ch <= "9")
            this.blockScalarIndent = Number(ch) - 1;
          else if (ch !== "-")
            break;
        }
        return yield* this.pushUntil((ch) => isEmpty(ch) || ch === "#");
      }
      *parseBlockScalar() {
        let nl = this.pos - 1;
        let indent = 0;
        let ch;
        loop: for (let i = this.pos; ch = this.buffer[i]; ++i) {
          switch (ch) {
            case " ":
              indent += 1;
              break;
            case "\n":
              nl = i;
              indent = 0;
              break;
            case "\r": {
              const next = this.buffer[i + 1];
              if (!next && !this.atEnd)
                return this.setNext("block-scalar");
              if (next === "\n")
                break;
            }
            // fallthrough
            default:
              break loop;
          }
        }
        if (!ch && !this.atEnd)
          return this.setNext("block-scalar");
        if (indent >= this.indentNext) {
          if (this.blockScalarIndent === -1)
            this.indentNext = indent;
          else
            this.indentNext += this.blockScalarIndent;
          do {
            const cs = this.continueScalar(nl + 1);
            if (cs === -1)
              break;
            nl = this.buffer.indexOf("\n", cs);
          } while (nl !== -1);
          if (nl === -1) {
            if (!this.atEnd)
              return this.setNext("block-scalar");
            nl = this.buffer.length;
          }
        }
        if (!this.blockScalarKeep) {
          do {
            let i = nl - 1;
            let ch2 = this.buffer[i];
            if (ch2 === "\r")
              ch2 = this.buffer[--i];
            const lastChar = i;
            while (ch2 === " " || ch2 === "	")
              ch2 = this.buffer[--i];
            if (ch2 === "\n" && i >= this.pos && i + 1 + indent > lastChar)
              nl = i;
            else
              break;
          } while (true);
        }
        yield cst.SCALAR;
        yield* this.pushToIndex(nl + 1, true);
        return yield* this.parseLineStart();
      }
      *parsePlainScalar() {
        const inFlow = this.flowLevel > 0;
        let end = this.pos - 1;
        let i = this.pos - 1;
        let ch;
        while (ch = this.buffer[++i]) {
          if (ch === ":") {
            const next = this.buffer[i + 1];
            if (isEmpty(next) || inFlow && next === ",")
              break;
            end = i;
          } else if (isEmpty(ch)) {
            let next = this.buffer[i + 1];
            if (ch === "\r") {
              if (next === "\n") {
                i += 1;
                ch = "\n";
                next = this.buffer[i + 1];
              } else
                end = i;
            }
            if (next === "#" || inFlow && invalidFlowScalarChars.includes(next))
              break;
            if (ch === "\n") {
              const cs = this.continueScalar(i + 1);
              if (cs === -1)
                break;
              i = Math.max(i, cs - 2);
            }
          } else {
            if (inFlow && invalidFlowScalarChars.includes(ch))
              break;
            end = i;
          }
        }
        if (!ch && !this.atEnd)
          return this.setNext("plain-scalar");
        yield cst.SCALAR;
        yield* this.pushToIndex(end + 1, true);
        return inFlow ? "flow" : "doc";
      }
      *pushCount(n) {
        if (n > 0) {
          yield this.buffer.substr(this.pos, n);
          this.pos += n;
          return n;
        }
        return 0;
      }
      *pushToIndex(i, allowEmpty) {
        const s = this.buffer.slice(this.pos, i);
        if (s) {
          yield s;
          this.pos += s.length;
          return s.length;
        } else if (allowEmpty)
          yield "";
        return 0;
      }
      *pushIndicators() {
        switch (this.charAt(0)) {
          case "!":
            return (yield* this.pushTag()) + (yield* this.pushSpaces(true)) + (yield* this.pushIndicators());
          case "&":
            return (yield* this.pushUntil(isNotAnchorChar)) + (yield* this.pushSpaces(true)) + (yield* this.pushIndicators());
          case "-":
          // this is an error
          case "?":
          // this is an error outside flow collections
          case ":": {
            const inFlow = this.flowLevel > 0;
            const ch1 = this.charAt(1);
            if (isEmpty(ch1) || inFlow && invalidFlowScalarChars.includes(ch1)) {
              if (!inFlow)
                this.indentNext = this.indentValue + 1;
              else if (this.flowKey)
                this.flowKey = false;
              return (yield* this.pushCount(1)) + (yield* this.pushSpaces(true)) + (yield* this.pushIndicators());
            }
          }
        }
        return 0;
      }
      *pushTag() {
        if (this.charAt(1) === "<") {
          let i = this.pos + 2;
          let ch = this.buffer[i];
          while (!isEmpty(ch) && ch !== ">")
            ch = this.buffer[++i];
          return yield* this.pushToIndex(ch === ">" ? i + 1 : i, false);
        } else {
          let i = this.pos + 1;
          let ch = this.buffer[i];
          while (ch) {
            if (tagChars.includes(ch))
              ch = this.buffer[++i];
            else if (ch === "%" && hexDigits.includes(this.buffer[i + 1]) && hexDigits.includes(this.buffer[i + 2])) {
              ch = this.buffer[i += 3];
            } else
              break;
          }
          return yield* this.pushToIndex(i, false);
        }
      }
      *pushNewline() {
        const ch = this.buffer[this.pos];
        if (ch === "\n")
          return yield* this.pushCount(1);
        else if (ch === "\r" && this.charAt(1) === "\n")
          return yield* this.pushCount(2);
        else
          return 0;
      }
      *pushSpaces(allowTabs) {
        let i = this.pos - 1;
        let ch;
        do {
          ch = this.buffer[++i];
        } while (ch === " " || allowTabs && ch === "	");
        const n = i - this.pos;
        if (n > 0) {
          yield this.buffer.substr(this.pos, n);
          this.pos = i;
        }
        return n;
      }
      *pushUntil(test) {
        let i = this.pos;
        let ch = this.buffer[i];
        while (!test(ch))
          ch = this.buffer[++i];
        return yield* this.pushToIndex(i, false);
      }
    };
    exports2.Lexer = Lexer;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/parse/line-counter.js
var require_line_counter = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/parse/line-counter.js"(exports2) {
    "use strict";
    var LineCounter = class {
      constructor() {
        this.lineStarts = [];
        this.addNewLine = (offset) => this.lineStarts.push(offset);
        this.linePos = (offset) => {
          let low = 0;
          let high = this.lineStarts.length;
          while (low < high) {
            const mid = low + high >> 1;
            if (this.lineStarts[mid] < offset)
              low = mid + 1;
            else
              high = mid;
          }
          if (this.lineStarts[low] === offset)
            return { line: low + 1, col: 1 };
          if (low === 0)
            return { line: 0, col: offset };
          const start = this.lineStarts[low - 1];
          return { line: low, col: offset - start + 1 };
        };
      }
    };
    exports2.LineCounter = LineCounter;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/parse/parser.js
var require_parser2 = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/parse/parser.js"(exports2) {
    "use strict";
    var cst = require_cst();
    var lexer = require_lexer();
    function includesToken(list3, type2) {
      for (let i = 0; i < list3.length; ++i)
        if (list3[i].type === type2)
          return true;
      return false;
    }
    function findNonEmptyIndex(list3) {
      for (let i = 0; i < list3.length; ++i) {
        switch (list3[i].type) {
          case "space":
          case "comment":
          case "newline":
            break;
          default:
            return i;
        }
      }
      return -1;
    }
    function isFlowToken(token) {
      switch (token?.type) {
        case "alias":
        case "scalar":
        case "single-quoted-scalar":
        case "double-quoted-scalar":
        case "flow-collection":
          return true;
        default:
          return false;
      }
    }
    function getPrevProps(parent) {
      switch (parent.type) {
        case "document":
          return parent.start;
        case "block-map": {
          const it = parent.items[parent.items.length - 1];
          return it.sep ?? it.start;
        }
        case "block-seq":
          return parent.items[parent.items.length - 1].start;
        /* istanbul ignore next should not happen */
        default:
          return [];
      }
    }
    function getFirstKeyStartProps(prev) {
      if (prev.length === 0)
        return [];
      let i = prev.length;
      loop: while (--i >= 0) {
        switch (prev[i].type) {
          case "doc-start":
          case "explicit-key-ind":
          case "map-value-ind":
          case "seq-item-ind":
          case "newline":
            break loop;
        }
      }
      while (prev[++i]?.type === "space") {
      }
      return prev.splice(i, prev.length);
    }
    function fixFlowSeqItems(fc) {
      if (fc.start.type === "flow-seq-start") {
        for (const it of fc.items) {
          if (it.sep && !it.value && !includesToken(it.start, "explicit-key-ind") && !includesToken(it.sep, "map-value-ind")) {
            if (it.key)
              it.value = it.key;
            delete it.key;
            if (isFlowToken(it.value)) {
              if (it.value.end)
                Array.prototype.push.apply(it.value.end, it.sep);
              else
                it.value.end = it.sep;
            } else
              Array.prototype.push.apply(it.start, it.sep);
            delete it.sep;
          }
        }
      }
    }
    var Parser = class {
      /**
       * @param onNewLine - If defined, called separately with the start position of
       *   each new line (in `parse()`, including the start of input).
       */
      constructor(onNewLine) {
        this.atNewLine = true;
        this.atScalar = false;
        this.indent = 0;
        this.offset = 0;
        this.onKeyLine = false;
        this.stack = [];
        this.source = "";
        this.type = "";
        this.lexer = new lexer.Lexer();
        this.onNewLine = onNewLine;
      }
      /**
       * Parse `source` as a YAML stream.
       * If `incomplete`, a part of the last line may be left as a buffer for the next call.
       *
       * Errors are not thrown, but yielded as `{ type: 'error', message }` tokens.
       *
       * @returns A generator of tokens representing each directive, document, and other structure.
       */
      *parse(source, incomplete = false) {
        if (this.onNewLine && this.offset === 0)
          this.onNewLine(0);
        for (const lexeme of this.lexer.lex(source, incomplete))
          yield* this.next(lexeme);
        if (!incomplete)
          yield* this.end();
      }
      /**
       * Advance the parser by the `source` of one lexical token.
       */
      *next(source) {
        this.source = source;
        if (process.env.LOG_TOKENS)
          console.log("|", cst.prettyToken(source));
        if (this.atScalar) {
          this.atScalar = false;
          yield* this.step();
          this.offset += source.length;
          return;
        }
        const type2 = cst.tokenType(source);
        if (!type2) {
          const message = `Not a YAML token: ${source}`;
          yield* this.pop({ type: "error", offset: this.offset, message, source });
          this.offset += source.length;
        } else if (type2 === "scalar") {
          this.atNewLine = false;
          this.atScalar = true;
          this.type = "scalar";
        } else {
          this.type = type2;
          yield* this.step();
          switch (type2) {
            case "newline":
              this.atNewLine = true;
              this.indent = 0;
              if (this.onNewLine)
                this.onNewLine(this.offset + source.length);
              break;
            case "space":
              if (this.atNewLine && source[0] === " ")
                this.indent += source.length;
              break;
            case "explicit-key-ind":
            case "map-value-ind":
            case "seq-item-ind":
              if (this.atNewLine)
                this.indent += source.length;
              break;
            case "doc-mode":
            case "flow-error-end":
              return;
            default:
              this.atNewLine = false;
          }
          this.offset += source.length;
        }
      }
      /** Call at end of input to push out any remaining constructions */
      *end() {
        while (this.stack.length > 0)
          yield* this.pop();
      }
      get sourceToken() {
        const st = {
          type: this.type,
          offset: this.offset,
          indent: this.indent,
          source: this.source
        };
        return st;
      }
      *step() {
        const top = this.peek(1);
        if (this.type === "doc-end" && (!top || top.type !== "doc-end")) {
          while (this.stack.length > 0)
            yield* this.pop();
          this.stack.push({
            type: "doc-end",
            offset: this.offset,
            source: this.source
          });
          return;
        }
        if (!top)
          return yield* this.stream();
        switch (top.type) {
          case "document":
            return yield* this.document(top);
          case "alias":
          case "scalar":
          case "single-quoted-scalar":
          case "double-quoted-scalar":
            return yield* this.scalar(top);
          case "block-scalar":
            return yield* this.blockScalar(top);
          case "block-map":
            return yield* this.blockMap(top);
          case "block-seq":
            return yield* this.blockSequence(top);
          case "flow-collection":
            return yield* this.flowCollection(top);
          case "doc-end":
            return yield* this.documentEnd(top);
        }
        yield* this.pop();
      }
      peek(n) {
        return this.stack[this.stack.length - n];
      }
      *pop(error) {
        const token = error ?? this.stack.pop();
        if (!token) {
          const message = "Tried to pop an empty stack";
          yield { type: "error", offset: this.offset, source: "", message };
        } else if (this.stack.length === 0) {
          yield token;
        } else {
          const top = this.peek(1);
          if (token.type === "block-scalar") {
            token.indent = "indent" in top ? top.indent : 0;
          } else if (token.type === "flow-collection" && top.type === "document") {
            token.indent = 0;
          }
          if (token.type === "flow-collection")
            fixFlowSeqItems(token);
          switch (top.type) {
            case "document":
              top.value = token;
              break;
            case "block-scalar":
              top.props.push(token);
              break;
            case "block-map": {
              const it = top.items[top.items.length - 1];
              if (it.value) {
                top.items.push({ start: [], key: token, sep: [] });
                this.onKeyLine = true;
                return;
              } else if (it.sep) {
                it.value = token;
              } else {
                Object.assign(it, { key: token, sep: [] });
                this.onKeyLine = !includesToken(it.start, "explicit-key-ind");
                return;
              }
              break;
            }
            case "block-seq": {
              const it = top.items[top.items.length - 1];
              if (it.value)
                top.items.push({ start: [], value: token });
              else
                it.value = token;
              break;
            }
            case "flow-collection": {
              const it = top.items[top.items.length - 1];
              if (!it || it.value)
                top.items.push({ start: [], key: token, sep: [] });
              else if (it.sep)
                it.value = token;
              else
                Object.assign(it, { key: token, sep: [] });
              return;
            }
            /* istanbul ignore next should not happen */
            default:
              yield* this.pop();
              yield* this.pop(token);
          }
          if ((top.type === "document" || top.type === "block-map" || top.type === "block-seq") && (token.type === "block-map" || token.type === "block-seq")) {
            const last = token.items[token.items.length - 1];
            if (last && !last.sep && !last.value && last.start.length > 0 && findNonEmptyIndex(last.start) === -1 && (token.indent === 0 || last.start.every((st) => st.type !== "comment" || st.indent < token.indent))) {
              if (top.type === "document")
                top.end = last.start;
              else
                top.items.push({ start: last.start });
              token.items.splice(-1, 1);
            }
          }
        }
      }
      *stream() {
        switch (this.type) {
          case "directive-line":
            yield { type: "directive", offset: this.offset, source: this.source };
            return;
          case "byte-order-mark":
          case "space":
          case "comment":
          case "newline":
            yield this.sourceToken;
            return;
          case "doc-mode":
          case "doc-start": {
            const doc = {
              type: "document",
              offset: this.offset,
              start: []
            };
            if (this.type === "doc-start")
              doc.start.push(this.sourceToken);
            this.stack.push(doc);
            return;
          }
        }
        yield {
          type: "error",
          offset: this.offset,
          message: `Unexpected ${this.type} token in YAML stream`,
          source: this.source
        };
      }
      *document(doc) {
        if (doc.value)
          return yield* this.lineEnd(doc);
        switch (this.type) {
          case "doc-start": {
            if (findNonEmptyIndex(doc.start) !== -1) {
              yield* this.pop();
              yield* this.step();
            } else
              doc.start.push(this.sourceToken);
            return;
          }
          case "anchor":
          case "tag":
          case "space":
          case "comment":
          case "newline":
            doc.start.push(this.sourceToken);
            return;
        }
        const bv = this.startBlockValue(doc);
        if (bv)
          this.stack.push(bv);
        else {
          yield {
            type: "error",
            offset: this.offset,
            message: `Unexpected ${this.type} token in YAML document`,
            source: this.source
          };
        }
      }
      *scalar(scalar) {
        if (this.type === "map-value-ind") {
          const prev = getPrevProps(this.peek(2));
          const start = getFirstKeyStartProps(prev);
          let sep2;
          if (scalar.end) {
            sep2 = scalar.end;
            sep2.push(this.sourceToken);
            delete scalar.end;
          } else
            sep2 = [this.sourceToken];
          const map2 = {
            type: "block-map",
            offset: scalar.offset,
            indent: scalar.indent,
            items: [{ start, key: scalar, sep: sep2 }]
          };
          this.onKeyLine = true;
          this.stack[this.stack.length - 1] = map2;
        } else
          yield* this.lineEnd(scalar);
      }
      *blockScalar(scalar) {
        switch (this.type) {
          case "space":
          case "comment":
          case "newline":
            scalar.props.push(this.sourceToken);
            return;
          case "scalar":
            scalar.source = this.source;
            this.atNewLine = true;
            this.indent = 0;
            if (this.onNewLine) {
              let nl = this.source.indexOf("\n") + 1;
              while (nl !== 0) {
                this.onNewLine(this.offset + nl);
                nl = this.source.indexOf("\n", nl) + 1;
              }
            }
            yield* this.pop();
            break;
          /* istanbul ignore next should not happen */
          default:
            yield* this.pop();
            yield* this.step();
        }
      }
      *blockMap(map2) {
        const it = map2.items[map2.items.length - 1];
        switch (this.type) {
          case "newline":
            this.onKeyLine = false;
            if (it.value) {
              const end = "end" in it.value ? it.value.end : void 0;
              const last = Array.isArray(end) ? end[end.length - 1] : void 0;
              if (last?.type === "comment")
                end?.push(this.sourceToken);
              else
                map2.items.push({ start: [this.sourceToken] });
            } else if (it.sep) {
              it.sep.push(this.sourceToken);
            } else {
              it.start.push(this.sourceToken);
            }
            return;
          case "space":
          case "comment":
            if (it.value) {
              map2.items.push({ start: [this.sourceToken] });
            } else if (it.sep) {
              it.sep.push(this.sourceToken);
            } else {
              if (this.atIndentedComment(it.start, map2.indent)) {
                const prev = map2.items[map2.items.length - 2];
                const end = prev?.value?.end;
                if (Array.isArray(end)) {
                  Array.prototype.push.apply(end, it.start);
                  end.push(this.sourceToken);
                  map2.items.pop();
                  return;
                }
              }
              it.start.push(this.sourceToken);
            }
            return;
        }
        if (this.indent >= map2.indent) {
          const atNextItem = !this.onKeyLine && this.indent === map2.indent && it.sep;
          let start = [];
          if (atNextItem && it.sep && !it.value) {
            const nl = [];
            for (let i = 0; i < it.sep.length; ++i) {
              const st = it.sep[i];
              switch (st.type) {
                case "newline":
                  nl.push(i);
                  break;
                case "space":
                  break;
                case "comment":
                  if (st.indent > map2.indent)
                    nl.length = 0;
                  break;
                default:
                  nl.length = 0;
              }
            }
            if (nl.length >= 2)
              start = it.sep.splice(nl[1]);
          }
          switch (this.type) {
            case "anchor":
            case "tag":
              if (atNextItem || it.value) {
                start.push(this.sourceToken);
                map2.items.push({ start });
                this.onKeyLine = true;
              } else if (it.sep) {
                it.sep.push(this.sourceToken);
              } else {
                it.start.push(this.sourceToken);
              }
              return;
            case "explicit-key-ind":
              if (!it.sep && !includesToken(it.start, "explicit-key-ind")) {
                it.start.push(this.sourceToken);
              } else if (atNextItem || it.value) {
                start.push(this.sourceToken);
                map2.items.push({ start });
              } else {
                this.stack.push({
                  type: "block-map",
                  offset: this.offset,
                  indent: this.indent,
                  items: [{ start: [this.sourceToken] }]
                });
              }
              this.onKeyLine = true;
              return;
            case "map-value-ind":
              if (includesToken(it.start, "explicit-key-ind")) {
                if (!it.sep) {
                  if (includesToken(it.start, "newline")) {
                    Object.assign(it, { key: null, sep: [this.sourceToken] });
                  } else {
                    const start2 = getFirstKeyStartProps(it.start);
                    this.stack.push({
                      type: "block-map",
                      offset: this.offset,
                      indent: this.indent,
                      items: [{ start: start2, key: null, sep: [this.sourceToken] }]
                    });
                  }
                } else if (it.value) {
                  map2.items.push({ start: [], key: null, sep: [this.sourceToken] });
                } else if (includesToken(it.sep, "map-value-ind")) {
                  this.stack.push({
                    type: "block-map",
                    offset: this.offset,
                    indent: this.indent,
                    items: [{ start, key: null, sep: [this.sourceToken] }]
                  });
                } else if (isFlowToken(it.key) && !includesToken(it.sep, "newline")) {
                  const start2 = getFirstKeyStartProps(it.start);
                  const key = it.key;
                  const sep2 = it.sep;
                  sep2.push(this.sourceToken);
                  delete it.key, delete it.sep;
                  this.stack.push({
                    type: "block-map",
                    offset: this.offset,
                    indent: this.indent,
                    items: [{ start: start2, key, sep: sep2 }]
                  });
                } else if (start.length > 0) {
                  it.sep = it.sep.concat(start, this.sourceToken);
                } else {
                  it.sep.push(this.sourceToken);
                }
              } else {
                if (!it.sep) {
                  Object.assign(it, { key: null, sep: [this.sourceToken] });
                } else if (it.value || atNextItem) {
                  map2.items.push({ start, key: null, sep: [this.sourceToken] });
                } else if (includesToken(it.sep, "map-value-ind")) {
                  this.stack.push({
                    type: "block-map",
                    offset: this.offset,
                    indent: this.indent,
                    items: [{ start: [], key: null, sep: [this.sourceToken] }]
                  });
                } else {
                  it.sep.push(this.sourceToken);
                }
              }
              this.onKeyLine = true;
              return;
            case "alias":
            case "scalar":
            case "single-quoted-scalar":
            case "double-quoted-scalar": {
              const fs = this.flowScalar(this.type);
              if (atNextItem || it.value) {
                map2.items.push({ start, key: fs, sep: [] });
                this.onKeyLine = true;
              } else if (it.sep) {
                this.stack.push(fs);
              } else {
                Object.assign(it, { key: fs, sep: [] });
                this.onKeyLine = true;
              }
              return;
            }
            default: {
              const bv = this.startBlockValue(map2);
              if (bv) {
                if (atNextItem && bv.type !== "block-seq" && includesToken(it.start, "explicit-key-ind")) {
                  map2.items.push({ start });
                }
                this.stack.push(bv);
                return;
              }
            }
          }
        }
        yield* this.pop();
        yield* this.step();
      }
      *blockSequence(seq2) {
        const it = seq2.items[seq2.items.length - 1];
        switch (this.type) {
          case "newline":
            if (it.value) {
              const end = "end" in it.value ? it.value.end : void 0;
              const last = Array.isArray(end) ? end[end.length - 1] : void 0;
              if (last?.type === "comment")
                end?.push(this.sourceToken);
              else
                seq2.items.push({ start: [this.sourceToken] });
            } else
              it.start.push(this.sourceToken);
            return;
          case "space":
          case "comment":
            if (it.value)
              seq2.items.push({ start: [this.sourceToken] });
            else {
              if (this.atIndentedComment(it.start, seq2.indent)) {
                const prev = seq2.items[seq2.items.length - 2];
                const end = prev?.value?.end;
                if (Array.isArray(end)) {
                  Array.prototype.push.apply(end, it.start);
                  end.push(this.sourceToken);
                  seq2.items.pop();
                  return;
                }
              }
              it.start.push(this.sourceToken);
            }
            return;
          case "anchor":
          case "tag":
            if (it.value || this.indent <= seq2.indent)
              break;
            it.start.push(this.sourceToken);
            return;
          case "seq-item-ind":
            if (this.indent !== seq2.indent)
              break;
            if (it.value || includesToken(it.start, "seq-item-ind"))
              seq2.items.push({ start: [this.sourceToken] });
            else
              it.start.push(this.sourceToken);
            return;
        }
        if (this.indent > seq2.indent) {
          const bv = this.startBlockValue(seq2);
          if (bv) {
            this.stack.push(bv);
            return;
          }
        }
        yield* this.pop();
        yield* this.step();
      }
      *flowCollection(fc) {
        const it = fc.items[fc.items.length - 1];
        if (this.type === "flow-error-end") {
          let top;
          do {
            yield* this.pop();
            top = this.peek(1);
          } while (top && top.type === "flow-collection");
        } else if (fc.end.length === 0) {
          switch (this.type) {
            case "comma":
            case "explicit-key-ind":
              if (!it || it.sep)
                fc.items.push({ start: [this.sourceToken] });
              else
                it.start.push(this.sourceToken);
              return;
            case "map-value-ind":
              if (!it || it.value)
                fc.items.push({ start: [], key: null, sep: [this.sourceToken] });
              else if (it.sep)
                it.sep.push(this.sourceToken);
              else
                Object.assign(it, { key: null, sep: [this.sourceToken] });
              return;
            case "space":
            case "comment":
            case "newline":
            case "anchor":
            case "tag":
              if (!it || it.value)
                fc.items.push({ start: [this.sourceToken] });
              else if (it.sep)
                it.sep.push(this.sourceToken);
              else
                it.start.push(this.sourceToken);
              return;
            case "alias":
            case "scalar":
            case "single-quoted-scalar":
            case "double-quoted-scalar": {
              const fs = this.flowScalar(this.type);
              if (!it || it.value)
                fc.items.push({ start: [], key: fs, sep: [] });
              else if (it.sep)
                this.stack.push(fs);
              else
                Object.assign(it, { key: fs, sep: [] });
              return;
            }
            case "flow-map-end":
            case "flow-seq-end":
              fc.end.push(this.sourceToken);
              return;
          }
          const bv = this.startBlockValue(fc);
          if (bv)
            this.stack.push(bv);
          else {
            yield* this.pop();
            yield* this.step();
          }
        } else {
          const parent = this.peek(2);
          if (parent.type === "block-map" && (this.type === "map-value-ind" && parent.indent === fc.indent || this.type === "newline" && !parent.items[parent.items.length - 1].sep)) {
            yield* this.pop();
            yield* this.step();
          } else if (this.type === "map-value-ind" && parent.type !== "flow-collection") {
            const prev = getPrevProps(parent);
            const start = getFirstKeyStartProps(prev);
            fixFlowSeqItems(fc);
            const sep2 = fc.end.splice(1, fc.end.length);
            sep2.push(this.sourceToken);
            const map2 = {
              type: "block-map",
              offset: fc.offset,
              indent: fc.indent,
              items: [{ start, key: fc, sep: sep2 }]
            };
            this.onKeyLine = true;
            this.stack[this.stack.length - 1] = map2;
          } else {
            yield* this.lineEnd(fc);
          }
        }
      }
      flowScalar(type2) {
        if (this.onNewLine) {
          let nl = this.source.indexOf("\n") + 1;
          while (nl !== 0) {
            this.onNewLine(this.offset + nl);
            nl = this.source.indexOf("\n", nl) + 1;
          }
        }
        return {
          type: type2,
          offset: this.offset,
          indent: this.indent,
          source: this.source
        };
      }
      startBlockValue(parent) {
        switch (this.type) {
          case "alias":
          case "scalar":
          case "single-quoted-scalar":
          case "double-quoted-scalar":
            return this.flowScalar(this.type);
          case "block-scalar-header":
            return {
              type: "block-scalar",
              offset: this.offset,
              indent: this.indent,
              props: [this.sourceToken],
              source: ""
            };
          case "flow-map-start":
          case "flow-seq-start":
            return {
              type: "flow-collection",
              offset: this.offset,
              indent: this.indent,
              start: this.sourceToken,
              items: [],
              end: []
            };
          case "seq-item-ind":
            return {
              type: "block-seq",
              offset: this.offset,
              indent: this.indent,
              items: [{ start: [this.sourceToken] }]
            };
          case "explicit-key-ind": {
            this.onKeyLine = true;
            const prev = getPrevProps(parent);
            const start = getFirstKeyStartProps(prev);
            start.push(this.sourceToken);
            return {
              type: "block-map",
              offset: this.offset,
              indent: this.indent,
              items: [{ start }]
            };
          }
          case "map-value-ind": {
            this.onKeyLine = true;
            const prev = getPrevProps(parent);
            const start = getFirstKeyStartProps(prev);
            return {
              type: "block-map",
              offset: this.offset,
              indent: this.indent,
              items: [{ start, key: null, sep: [this.sourceToken] }]
            };
          }
        }
        return null;
      }
      atIndentedComment(start, indent) {
        if (this.type !== "comment")
          return false;
        if (this.indent <= indent)
          return false;
        return start.every((st) => st.type === "newline" || st.type === "space");
      }
      *documentEnd(docEnd) {
        if (this.type !== "doc-mode") {
          if (docEnd.end)
            docEnd.end.push(this.sourceToken);
          else
            docEnd.end = [this.sourceToken];
          if (this.type === "newline")
            yield* this.pop();
        }
      }
      *lineEnd(token) {
        switch (this.type) {
          case "comma":
          case "doc-start":
          case "doc-end":
          case "flow-seq-end":
          case "flow-map-end":
          case "map-value-ind":
            yield* this.pop();
            yield* this.step();
            break;
          case "newline":
            this.onKeyLine = false;
          // fallthrough
          case "space":
          case "comment":
          default:
            if (token.end)
              token.end.push(this.sourceToken);
            else
              token.end = [this.sourceToken];
            if (this.type === "newline")
              yield* this.pop();
        }
      }
    };
    exports2.Parser = Parser;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/public-api.js
var require_public_api = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/public-api.js"(exports2) {
    "use strict";
    var composer = require_composer();
    var Document = require_Document();
    var errors = require_errors();
    var log = require_log();
    var lineCounter = require_line_counter();
    var parser = require_parser2();
    function parseOptions(options) {
      const prettyErrors = options.prettyErrors !== false;
      const lineCounter$1 = options.lineCounter || prettyErrors && new lineCounter.LineCounter() || null;
      return { lineCounter: lineCounter$1, prettyErrors };
    }
    function parseAllDocuments(source, options = {}) {
      const { lineCounter: lineCounter2, prettyErrors } = parseOptions(options);
      const parser$1 = new parser.Parser(lineCounter2?.addNewLine);
      const composer$1 = new composer.Composer(options);
      const docs = Array.from(composer$1.compose(parser$1.parse(source)));
      if (prettyErrors && lineCounter2)
        for (const doc of docs) {
          doc.errors.forEach(errors.prettifyError(source, lineCounter2));
          doc.warnings.forEach(errors.prettifyError(source, lineCounter2));
        }
      if (docs.length > 0)
        return docs;
      return Object.assign([], { empty: true }, composer$1.streamInfo());
    }
    function parseDocument(source, options = {}) {
      const { lineCounter: lineCounter2, prettyErrors } = parseOptions(options);
      const parser$1 = new parser.Parser(lineCounter2?.addNewLine);
      const composer$1 = new composer.Composer(options);
      let doc = null;
      for (const _doc of composer$1.compose(parser$1.parse(source), true, source.length)) {
        if (!doc)
          doc = _doc;
        else if (doc.options.logLevel !== "silent") {
          doc.errors.push(new errors.YAMLParseError(_doc.range.slice(0, 2), "MULTIPLE_DOCS", "Source contains multiple documents; please use YAML.parseAllDocuments()"));
          break;
        }
      }
      if (prettyErrors && lineCounter2) {
        doc.errors.forEach(errors.prettifyError(source, lineCounter2));
        doc.warnings.forEach(errors.prettifyError(source, lineCounter2));
      }
      return doc;
    }
    function parse2(src, reviver, options) {
      let _reviver = void 0;
      if (typeof reviver === "function") {
        _reviver = reviver;
      } else if (options === void 0 && reviver && typeof reviver === "object") {
        options = reviver;
      }
      const doc = parseDocument(src, options);
      if (!doc)
        return null;
      doc.warnings.forEach((warning) => log.warn(doc.options.logLevel, warning));
      if (doc.errors.length > 0) {
        if (doc.options.logLevel !== "silent")
          throw doc.errors[0];
        else
          doc.errors = [];
      }
      return doc.toJS(Object.assign({ reviver: _reviver }, options));
    }
    function stringify(value, replacer, options) {
      let _replacer = null;
      if (typeof replacer === "function" || Array.isArray(replacer)) {
        _replacer = replacer;
      } else if (options === void 0 && replacer) {
        options = replacer;
      }
      if (typeof options === "string")
        options = options.length;
      if (typeof options === "number") {
        const indent = Math.round(options);
        options = indent < 1 ? void 0 : indent > 8 ? { indent: 8 } : { indent };
      }
      if (value === void 0) {
        const { keepUndefined } = options ?? replacer ?? {};
        if (!keepUndefined)
          return void 0;
      }
      return new Document.Document(value, _replacer, options).toString(options);
    }
    exports2.parse = parse2;
    exports2.parseAllDocuments = parseAllDocuments;
    exports2.parseDocument = parseDocument;
    exports2.stringify = stringify;
  }
});

// ../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/index.js
var require_dist = __commonJS({
  "../../../node_modules/.pnpm/yaml@2.3.3/node_modules/yaml/dist/index.js"(exports2) {
    "use strict";
    var composer = require_composer();
    var Document = require_Document();
    var Schema3 = require_Schema();
    var errors = require_errors();
    var Alias = require_Alias();
    var identity2 = require_identity();
    var Pair = require_Pair();
    var Scalar = require_Scalar();
    var YAMLMap = require_YAMLMap();
    var YAMLSeq = require_YAMLSeq();
    var cst = require_cst();
    var lexer = require_lexer();
    var lineCounter = require_line_counter();
    var parser = require_parser2();
    var publicApi = require_public_api();
    var visit = require_visit();
    exports2.Composer = composer.Composer;
    exports2.Document = Document.Document;
    exports2.Schema = Schema3.Schema;
    exports2.YAMLError = errors.YAMLError;
    exports2.YAMLParseError = errors.YAMLParseError;
    exports2.YAMLWarning = errors.YAMLWarning;
    exports2.Alias = Alias.Alias;
    exports2.isAlias = identity2.isAlias;
    exports2.isCollection = identity2.isCollection;
    exports2.isDocument = identity2.isDocument;
    exports2.isMap = identity2.isMap;
    exports2.isNode = identity2.isNode;
    exports2.isPair = identity2.isPair;
    exports2.isScalar = identity2.isScalar;
    exports2.isSeq = identity2.isSeq;
    exports2.Pair = Pair.Pair;
    exports2.Scalar = Scalar.Scalar;
    exports2.YAMLMap = YAMLMap.YAMLMap;
    exports2.YAMLSeq = YAMLSeq.YAMLSeq;
    exports2.CST = cst;
    exports2.Lexer = lexer.Lexer;
    exports2.LineCounter = lineCounter.LineCounter;
    exports2.Parser = parser.Parser;
    exports2.parse = publicApi.parse;
    exports2.parseAllDocuments = publicApi.parseAllDocuments;
    exports2.parseDocument = publicApi.parseDocument;
    exports2.stringify = publicApi.stringify;
    exports2.visit = visit.visit;
    exports2.visitAsync = visit.visitAsync;
  }
});

// ../../../node_modules/.pnpm/reftools@1.1.9/node_modules/reftools/lib/jptr.js
var require_jptr = __commonJS({
  "../../../node_modules/.pnpm/reftools@1.1.9/node_modules/reftools/lib/jptr.js"(exports2, module2) {
    "use strict";
    function jpescape(s) {
      return s.replace(/\~/g, "~0").replace(/\//g, "~1");
    }
    function jpunescape(s) {
      return s.replace(/\~1/g, "/").replace(/~0/g, "~");
    }
    function jptr(obj, prop, newValue) {
      if (typeof obj === "undefined") return false;
      if (!prop || typeof prop !== "string" || prop === "#") return typeof newValue !== "undefined" ? newValue : obj;
      if (prop.indexOf("#") >= 0) {
        let parts = prop.split("#");
        let uri = parts[0];
        if (uri) return false;
        prop = parts[1];
        prop = decodeURIComponent(prop.slice(1).split("+").join(" "));
      }
      if (prop.startsWith("/")) prop = prop.slice(1);
      let components = prop.split("/");
      for (let i = 0; i < components.length; i++) {
        components[i] = jpunescape(components[i]);
        let setAndLast = typeof newValue !== "undefined" && i == components.length - 1;
        let index = parseInt(components[i], 10);
        if (!Array.isArray(obj) || isNaN(index) || index.toString() !== components[i]) {
          index = Array.isArray(obj) && components[i] === "-" ? -2 : -1;
        } else {
          components[i] = i > 0 ? components[i - 1] : "";
        }
        if (index != -1 || obj && obj.hasOwnProperty(components[i])) {
          if (index >= 0) {
            if (setAndLast) {
              obj[index] = newValue;
            }
            obj = obj[index];
          } else if (index === -2) {
            if (setAndLast) {
              if (Array.isArray(obj)) {
                obj.push(newValue);
              }
              return newValue;
            } else return void 0;
          } else {
            if (setAndLast) {
              obj[components[i]] = newValue;
            }
            obj = obj[components[i]];
          }
        } else {
          if (typeof newValue !== "undefined" && typeof obj === "object" && !Array.isArray(obj)) {
            obj[components[i]] = setAndLast ? newValue : components[i + 1] === "0" || components[i + 1] === "-" ? [] : {};
            obj = obj[components[i]];
          } else return false;
        }
      }
      return obj;
    }
    module2.exports = {
      jptr,
      jpescape,
      jpunescape
    };
  }
});

// ../../../node_modules/.pnpm/reftools@1.1.9/node_modules/reftools/lib/isref.js
var require_isref = __commonJS({
  "../../../node_modules/.pnpm/reftools@1.1.9/node_modules/reftools/lib/isref.js"(exports2, module2) {
    "use strict";
    function isRef(obj, key) {
      return key === "$ref" && (!!obj && typeof obj[key] === "string");
    }
    module2.exports = {
      isRef
    };
  }
});

// ../../../node_modules/.pnpm/reftools@1.1.9/node_modules/reftools/lib/clone.js
var require_clone = __commonJS({
  "../../../node_modules/.pnpm/reftools@1.1.9/node_modules/reftools/lib/clone.js"(exports2, module2) {
    "use strict";
    function nop(obj) {
      return obj;
    }
    function clone3(obj) {
      return JSON.parse(JSON.stringify(obj));
    }
    function shallowClone(obj) {
      let result = {};
      for (let p in obj) {
        if (obj.hasOwnProperty(p)) {
          result[p] = obj[p];
        }
      }
      return result;
    }
    function deepClone(obj) {
      let result = Array.isArray(obj) ? [] : {};
      for (let p in obj) {
        if (obj.hasOwnProperty(p) || Array.isArray(obj)) {
          result[p] = typeof obj[p] === "object" ? deepClone(obj[p]) : obj[p];
        }
      }
      return result;
    }
    function fastClone(obj) {
      return Object.assign({}, obj);
    }
    function circularClone(obj, hash2) {
      if (!hash2) hash2 = /* @__PURE__ */ new WeakMap();
      if (Object(obj) !== obj || obj instanceof Function) return obj;
      if (hash2.has(obj)) return hash2.get(obj);
      try {
        var result = new obj.constructor();
      } catch (e) {
        result = Object.create(Object.getPrototypeOf(obj));
      }
      hash2.set(obj, result);
      return Object.assign(result, ...Object.keys(obj).map(
        (key) => ({ [key]: circularClone(obj[key], hash2) })
      ));
    }
    module2.exports = {
      nop,
      clone: clone3,
      shallowClone,
      deepClone,
      fastClone,
      circularClone
    };
  }
});

// ../../../node_modules/.pnpm/reftools@1.1.9/node_modules/reftools/lib/recurse.js
var require_recurse = __commonJS({
  "../../../node_modules/.pnpm/reftools@1.1.9/node_modules/reftools/lib/recurse.js"(exports2, module2) {
    "use strict";
    var jpescape = require_jptr().jpescape;
    function defaultState() {
      return {
        path: "#",
        depth: 0,
        pkey: "",
        parent: {},
        payload: {},
        seen: /* @__PURE__ */ new WeakMap(),
        identity: false,
        identityDetection: false
      };
    }
    function recurse(object3, state, callback) {
      if (!state) state = { depth: 0 };
      if (!state.depth) {
        state = Object.assign({}, defaultState(), state);
      }
      if (typeof object3 !== "object") return;
      let oPath = state.path;
      for (let key in object3) {
        state.key = key;
        state.path = state.path + "/" + encodeURIComponent(jpescape(key));
        state.identityPath = state.seen.get(object3[key]);
        state.identity = typeof state.identityPath !== "undefined";
        if (object3.hasOwnProperty(key)) {
          callback(object3, key, state);
        }
        if (typeof object3[key] === "object" && !state.identity) {
          if (state.identityDetection && !Array.isArray(object3[key]) && object3[key] !== null) {
            state.seen.set(object3[key], state.path);
          }
          let newState = {};
          newState.parent = object3;
          newState.path = state.path;
          newState.depth = state.depth ? state.depth + 1 : 1;
          newState.pkey = key;
          newState.payload = state.payload;
          newState.seen = state.seen;
          newState.identity = false;
          newState.identityDetection = state.identityDetection;
          recurse(object3[key], newState, callback);
        }
        state.path = oPath;
      }
    }
    module2.exports = {
      recurse
    };
  }
});

// ../../../node_modules/.pnpm/reftools@1.1.9/node_modules/reftools/lib/dereference.js
var require_dereference = __commonJS({
  "../../../node_modules/.pnpm/reftools@1.1.9/node_modules/reftools/lib/dereference.js"(exports2, module2) {
    "use strict";
    var recurse = require_recurse().recurse;
    var clone3 = require_clone().shallowClone;
    var jptr = require_jptr().jptr;
    var isRef = require_isref().isRef;
    var getLogger = function(options) {
      if (options && options.verbose) {
        return {
          warn: function() {
            var args = Array.prototype.slice.call(arguments);
            console.warn.apply(console, args);
          }
        };
      } else {
        return {
          warn: function() {
          }
        };
      }
    };
    function dereference(o, definitions, options) {
      if (!options) options = {};
      if (!options.cache) options.cache = {};
      if (!options.state) options.state = {};
      options.state.identityDetection = true;
      options.depth = options.depth ? options.depth + 1 : 1;
      let obj = options.depth > 1 ? o : clone3(o);
      let container = { data: obj };
      let defs = options.depth > 1 ? definitions : clone3(definitions);
      if (!options.master) options.master = obj;
      let logger = getLogger(options);
      let changes = 1;
      while (changes > 0) {
        changes = 0;
        recurse(container, options.state, function(obj2, key, state) {
          if (isRef(obj2, key)) {
            let $ref = obj2[key];
            changes++;
            if (!options.cache[$ref]) {
              let entry = {};
              entry.path = state.path.split("/$ref")[0];
              entry.key = $ref;
              logger.warn("Dereffing %s at %s", $ref, entry.path);
              entry.source = defs;
              entry.data = jptr(entry.source, entry.key);
              if (entry.data === false) {
                entry.data = jptr(options.master, entry.key);
                entry.source = options.master;
              }
              if (entry.data === false) {
                logger.warn("Missing $ref target", entry.key);
              }
              options.cache[$ref] = entry;
              entry.data = state.parent[state.pkey] = dereference(jptr(entry.source, entry.key), entry.source, options);
              if (options.$ref && typeof state.parent[state.pkey] === "object" && state.parent[state.pkey] !== null) state.parent[state.pkey][options.$ref] = $ref;
              entry.resolved = true;
            } else {
              let entry = options.cache[$ref];
              if (entry.resolved) {
                logger.warn("Patching %s for %s", $ref, entry.path);
                state.parent[state.pkey] = entry.data;
                if (options.$ref && typeof state.parent[state.pkey] === "object" && state.parent[state.pkey] !== null) state.parent[state.pkey][options.$ref] = $ref;
              } else if ($ref === entry.path) {
                throw new Error(`Tight circle at ${entry.path}`);
              } else {
                logger.warn("Unresolved ref");
                state.parent[state.pkey] = jptr(entry.source, entry.path);
                if (state.parent[state.pkey] === false) {
                  state.parent[state.pkey] = jptr(entry.source, entry.key);
                }
                if (options.$ref && typeof state.parent[state.pkey] === "object" && state.parent[state.pkey] !== null) state.parent[options.$ref] = $ref;
              }
            }
          }
        });
      }
      return container.data;
    }
    module2.exports = {
      dereference
    };
  }
});

// ../../../node_modules/.pnpm/fast-safe-stringify@2.1.1/node_modules/fast-safe-stringify/index.js
var require_fast_safe_stringify = __commonJS({
  "../../../node_modules/.pnpm/fast-safe-stringify@2.1.1/node_modules/fast-safe-stringify/index.js"(exports2, module2) {
    "use strict";
    module2.exports = stringify;
    stringify.default = stringify;
    stringify.stable = deterministicStringify;
    stringify.stableStringify = deterministicStringify;
    var LIMIT_REPLACE_NODE = "[...]";
    var CIRCULAR_REPLACE_NODE = "[Circular]";
    var arr = [];
    var replacerStack = [];
    function defaultOptions() {
      return {
        depthLimit: Number.MAX_SAFE_INTEGER,
        edgesLimit: Number.MAX_SAFE_INTEGER
      };
    }
    function stringify(obj, replacer, spacer, options) {
      if (typeof options === "undefined") {
        options = defaultOptions();
      }
      decirc(obj, "", 0, [], void 0, 0, options);
      var res;
      try {
        if (replacerStack.length === 0) {
          res = JSON.stringify(obj, replacer, spacer);
        } else {
          res = JSON.stringify(obj, replaceGetterValues(replacer), spacer);
        }
      } catch (_) {
        return JSON.stringify("[unable to serialize, circular reference is too complex to analyze]");
      } finally {
        while (arr.length !== 0) {
          var part = arr.pop();
          if (part.length === 4) {
            Object.defineProperty(part[0], part[1], part[3]);
          } else {
            part[0][part[1]] = part[2];
          }
        }
      }
      return res;
    }
    function setReplace(replace, val, k, parent) {
      var propertyDescriptor = Object.getOwnPropertyDescriptor(parent, k);
      if (propertyDescriptor.get !== void 0) {
        if (propertyDescriptor.configurable) {
          Object.defineProperty(parent, k, { value: replace });
          arr.push([parent, k, val, propertyDescriptor]);
        } else {
          replacerStack.push([val, k, replace]);
        }
      } else {
        parent[k] = replace;
        arr.push([parent, k, val]);
      }
    }
    function decirc(val, k, edgeIndex, stack, parent, depth, options) {
      depth += 1;
      var i;
      if (typeof val === "object" && val !== null) {
        for (i = 0; i < stack.length; i++) {
          if (stack[i] === val) {
            setReplace(CIRCULAR_REPLACE_NODE, val, k, parent);
            return;
          }
        }
        if (typeof options.depthLimit !== "undefined" && depth > options.depthLimit) {
          setReplace(LIMIT_REPLACE_NODE, val, k, parent);
          return;
        }
        if (typeof options.edgesLimit !== "undefined" && edgeIndex + 1 > options.edgesLimit) {
          setReplace(LIMIT_REPLACE_NODE, val, k, parent);
          return;
        }
        stack.push(val);
        if (Array.isArray(val)) {
          for (i = 0; i < val.length; i++) {
            decirc(val[i], i, i, stack, val, depth, options);
          }
        } else {
          var keys5 = Object.keys(val);
          for (i = 0; i < keys5.length; i++) {
            var key = keys5[i];
            decirc(val[key], key, i, stack, val, depth, options);
          }
        }
        stack.pop();
      }
    }
    function compareFunction(a, b) {
      if (a < b) {
        return -1;
      }
      if (a > b) {
        return 1;
      }
      return 0;
    }
    function deterministicStringify(obj, replacer, spacer, options) {
      if (typeof options === "undefined") {
        options = defaultOptions();
      }
      var tmp = deterministicDecirc(obj, "", 0, [], void 0, 0, options) || obj;
      var res;
      try {
        if (replacerStack.length === 0) {
          res = JSON.stringify(tmp, replacer, spacer);
        } else {
          res = JSON.stringify(tmp, replaceGetterValues(replacer), spacer);
        }
      } catch (_) {
        return JSON.stringify("[unable to serialize, circular reference is too complex to analyze]");
      } finally {
        while (arr.length !== 0) {
          var part = arr.pop();
          if (part.length === 4) {
            Object.defineProperty(part[0], part[1], part[3]);
          } else {
            part[0][part[1]] = part[2];
          }
        }
      }
      return res;
    }
    function deterministicDecirc(val, k, edgeIndex, stack, parent, depth, options) {
      depth += 1;
      var i;
      if (typeof val === "object" && val !== null) {
        for (i = 0; i < stack.length; i++) {
          if (stack[i] === val) {
            setReplace(CIRCULAR_REPLACE_NODE, val, k, parent);
            return;
          }
        }
        try {
          if (typeof val.toJSON === "function") {
            return;
          }
        } catch (_) {
          return;
        }
        if (typeof options.depthLimit !== "undefined" && depth > options.depthLimit) {
          setReplace(LIMIT_REPLACE_NODE, val, k, parent);
          return;
        }
        if (typeof options.edgesLimit !== "undefined" && edgeIndex + 1 > options.edgesLimit) {
          setReplace(LIMIT_REPLACE_NODE, val, k, parent);
          return;
        }
        stack.push(val);
        if (Array.isArray(val)) {
          for (i = 0; i < val.length; i++) {
            deterministicDecirc(val[i], i, i, stack, val, depth, options);
          }
        } else {
          var tmp = {};
          var keys5 = Object.keys(val).sort(compareFunction);
          for (i = 0; i < keys5.length; i++) {
            var key = keys5[i];
            deterministicDecirc(val[key], key, i, stack, val, depth, options);
            tmp[key] = val[key];
          }
          if (typeof parent !== "undefined") {
            arr.push([parent, k, val]);
            parent[k] = tmp;
          } else {
            return tmp;
          }
        }
        stack.pop();
      }
    }
    function replaceGetterValues(replacer) {
      replacer = typeof replacer !== "undefined" ? replacer : function(k, v) {
        return v;
      };
      return function(key, val) {
        if (replacerStack.length > 0) {
          for (var i = 0; i < replacerStack.length; i++) {
            var part = replacerStack[i];
            if (part[1] === key && part[0] === val) {
              val = part[2];
              replacerStack.splice(i, 1);
              break;
            }
          }
        }
        return replacer.call(this, key, val);
      };
    }
  }
});

// ../../../node_modules/.pnpm/oas-kit-common@1.0.8/node_modules/oas-kit-common/index.js
var require_oas_kit_common = __commonJS({
  "../../../node_modules/.pnpm/oas-kit-common@1.0.8/node_modules/oas-kit-common/index.js"(exports2, module2) {
    "use strict";
    var sjs = require_fast_safe_stringify();
    var colour = process.env.NODE_DISABLE_COLORS ? { red: "", yellow: "", green: "", normal: "" } : { red: "\x1B[31m", yellow: "\x1B[33;1m", green: "\x1B[32m", normal: "\x1B[0m" };
    function uniqueOnly(value, index, self2) {
      return self2.indexOf(value) === index;
    }
    function hasDuplicates(array) {
      return new Set(array).size !== array.length;
    }
    function allSame(array) {
      return new Set(array).size <= 1;
    }
    function deepEquals(obj1, obj2) {
      function _equals(obj12, obj22) {
        return sjs.stringify(obj12) === sjs.stringify(Object.assign({}, obj12, obj22));
      }
      return _equals(obj1, obj2) && _equals(obj2, obj1);
    }
    function compressArray(arr) {
      let result = [];
      for (let candidate of arr) {
        let dupe = result.find(function(e, i, a) {
          return deepEquals(e, candidate);
        });
        if (!dupe) result.push(candidate);
      }
      return result;
    }
    function distinctArray(arr) {
      return arr.length === compressArray(arr).length;
    }
    function firstDupe(arr) {
      return arr.find(function(e, i, a) {
        return arr.indexOf(e) < i;
      });
    }
    function hash2(s) {
      let hash3 = 0;
      let chr;
      if (s.length === 0) return hash3;
      for (let i = 0; i < s.length; i++) {
        chr = s.charCodeAt(i);
        hash3 = (hash3 << 5) - hash3 + chr;
        hash3 |= 0;
      }
      return hash3;
    }
    String.prototype.toCamelCase = function camelize() {
      return this.toLowerCase().replace(/[-_ \/\.](.)/g, function(match, group1) {
        return group1.toUpperCase();
      });
    };
    var parameterTypeProperties = [
      "format",
      "minimum",
      "maximum",
      "exclusiveMinimum",
      "exclusiveMaximum",
      "minLength",
      "maxLength",
      "multipleOf",
      "minItems",
      "maxItems",
      "uniqueItems",
      "minProperties",
      "maxProperties",
      "additionalProperties",
      "pattern",
      "enum",
      "default"
    ];
    var arrayProperties = [
      "items",
      "minItems",
      "maxItems",
      "uniqueItems"
    ];
    var httpMethods = [
      "get",
      "post",
      "put",
      "delete",
      "patch",
      "head",
      "options",
      "trace"
    ];
    function sanitise(s) {
      s = s.replace("[]", "Array");
      let components = s.split("/");
      components[0] = components[0].replace(/[^A-Za-z0-9_\-\.]+|\s+/gm, "_");
      return components.join("/");
    }
    function sanitiseAll(s) {
      return sanitise(s.split("/").join("_"));
    }
    module2.exports = {
      colour,
      uniqueOnly,
      hasDuplicates,
      allSame,
      distinctArray,
      firstDupe,
      hash: hash2,
      parameterTypeProperties,
      arrayProperties,
      httpMethods,
      sanitise,
      sanitiseAll
    };
  }
});

// ../../../node_modules/.pnpm/oas-resolver@2.5.6/node_modules/oas-resolver/index.js
var require_oas_resolver = __commonJS({
  "../../../node_modules/.pnpm/oas-resolver@2.5.6/node_modules/oas-resolver/index.js"(exports2, module2) {
    "use strict";
    var fs = require("fs");
    var path5 = require("path");
    var url = require("url");
    var fetch3 = (init_lib(), __toCommonJS(lib_exports));
    var yaml = require_dist();
    var jptr = require_jptr().jptr;
    var recurse = require_recurse().recurse;
    var clone3 = require_clone().clone;
    var deRef = require_dereference().dereference;
    var isRef = require_isref().isRef;
    var common2 = require_oas_kit_common();
    function unique(arr) {
      return [...new Set(arr)];
    }
    function readFileAsync(filename, encoding, options, pointer, def) {
      return new Promise(function(resolve2, reject) {
        fs.readFile(filename, encoding, function(err, data) {
          if (err) {
            if (options.ignoreIOErrors && def) {
              if (options.verbose) console.warn("FAILED", pointer);
              options.externalRefs[pointer].failed = true;
              resolve2(def);
            } else {
              reject(err);
            }
          } else {
            resolve2(data);
          }
        });
      });
    }
    function resolveAllFragment(obj, context, src, parentPath, base, options) {
      let attachPoint = options.externalRefs[src + parentPath].paths[0];
      let baseUrl = url.parse(base);
      let seen = {};
      let changes = 1;
      while (changes) {
        changes = 0;
        recurse(obj, { identityDetection: true }, function(obj2, key, state) {
          if (isRef(obj2, key)) {
            if (obj2[key].startsWith("#")) {
              if (!seen[obj2[key]] && !obj2.$fixed) {
                let target = clone3(jptr(context, obj2[key]));
                if (options.verbose > 1) console.warn((target === false ? common2.colour.red : common2.colour.green) + "Fragment resolution", obj2[key], common2.colour.normal);
                if (target === false) {
                  state.parent[state.pkey] = {};
                  if (options.fatal) {
                    let ex = new Error("Fragment $ref resolution failed " + obj2[key]);
                    if (options.promise) options.promise.reject(ex);
                    else throw ex;
                  }
                } else {
                  changes++;
                  state.parent[state.pkey] = target;
                  seen[obj2[key]] = state.path.replace("/%24ref", "");
                }
              } else {
                if (!obj2.$fixed) {
                  let newRef = (attachPoint + "/" + seen[obj2[key]]).split("/#/").join("/");
                  state.parent[state.pkey] = { $ref: newRef, "x-miro": obj2[key], $fixed: true };
                  if (options.verbose > 1) console.warn("Replacing with", newRef);
                  changes++;
                }
              }
            } else if (baseUrl.protocol) {
              let newRef = url.resolve(base, obj2[key]).toString();
              if (options.verbose > 1) console.warn(common2.colour.yellow + "Rewriting external url ref", obj2[key], "as", newRef, common2.colour.normal);
              obj2["x-miro"] = obj2[key];
              if (options.externalRefs[obj2[key]]) {
                if (!options.externalRefs[newRef]) {
                  options.externalRefs[newRef] = options.externalRefs[obj2[key]];
                }
                options.externalRefs[newRef].failed = options.externalRefs[obj2[key]].failed;
              }
              obj2[key] = newRef;
            } else if (!obj2["x-miro"]) {
              let newRef = url.resolve(base, obj2[key]).toString();
              let failed = false;
              if (options.externalRefs[obj2[key]]) {
                failed = options.externalRefs[obj2[key]].failed;
              }
              if (!failed) {
                if (options.verbose > 1) console.warn(common2.colour.yellow + "Rewriting external ref", obj2[key], "as", newRef, common2.colour.normal);
                obj2["x-miro"] = obj2[key];
                obj2[key] = newRef;
              }
            }
          }
        });
      }
      recurse(obj, {}, function(obj2, key, state) {
        if (isRef(obj2, key)) {
          if (typeof obj2.$fixed !== "undefined") delete obj2.$fixed;
        }
      });
      if (options.verbose > 1) console.warn("Finished fragment resolution");
      return obj;
    }
    function filterData(data, options) {
      if (!options.filters || !options.filters.length) return data;
      for (let filter of options.filters) {
        data = filter(data, options);
      }
      return data;
    }
    function testProtocol(input, backup) {
      if (input && input.length > 2) return input;
      if (backup && backup.length > 2) return backup;
      return "file:";
    }
    function resolveExternal(root2, pointer, options, callback) {
      var u = url.parse(options.source);
      var base = options.source.split("\\").join("/").split("/");
      let doc = base.pop();
      if (!doc) base.pop();
      let fragment = "";
      let fnComponents = pointer.split("#");
      if (fnComponents.length > 1) {
        fragment = "#" + fnComponents[1];
        pointer = fnComponents[0];
      }
      base = base.join("/");
      let u2 = url.parse(pointer);
      let effectiveProtocol = testProtocol(u2.protocol, u.protocol);
      let target;
      if (effectiveProtocol === "file:") {
        target = path5.resolve(base ? base + "/" : "", pointer);
      } else {
        target = url.resolve(base ? base + "/" : "", pointer);
      }
      if (options.cache[target]) {
        if (options.verbose) console.warn("CACHED", target, fragment);
        let context = clone3(options.cache[target]);
        let data = options.externalRef = context;
        if (fragment) {
          data = jptr(data, fragment);
          if (data === false) {
            data = {};
            if (options.fatal) {
              let ex = new Error("Cached $ref resolution failed " + target + fragment);
              if (options.promise) options.promise.reject(ex);
              else throw ex;
            }
          }
        }
        data = resolveAllFragment(data, context, pointer, fragment, target, options);
        data = filterData(data, options);
        callback(clone3(data), target, options);
        return Promise.resolve(data);
      }
      if (options.verbose) console.warn("GET", target, fragment);
      if (options.handlers && options.handlers[effectiveProtocol]) {
        return options.handlers[effectiveProtocol](base, pointer, fragment, options).then(function(data) {
          options.externalRef = data;
          data = filterData(data, options);
          options.cache[target] = data;
          callback(data, target, options);
          return data;
        }).catch(function(ex) {
          if (options.verbose) console.warn(ex);
          throw ex;
        });
      } else if (effectiveProtocol && effectiveProtocol.startsWith("http")) {
        const fetchOptions = Object.assign({}, options.fetchOptions, { agent: options.agent });
        return options.fetch(target, fetchOptions).then(function(res) {
          if (res.status !== 200) {
            if (options.ignoreIOErrors) {
              if (options.verbose) console.warn("FAILED", pointer);
              options.externalRefs[pointer].failed = true;
              return '{"$ref":"' + pointer + '"}';
            } else {
              throw new Error(`Received status code ${res.status}: ${target}`);
            }
          }
          return res.text();
        }).then(function(data) {
          try {
            let context = yaml.parse(data, { schema: "core", prettyErrors: true });
            data = options.externalRef = context;
            options.cache[target] = clone3(data);
            if (fragment) {
              data = jptr(data, fragment);
              if (data === false) {
                data = {};
                if (options.fatal) {
                  let ex = new Error("Remote $ref resolution failed " + target + fragment);
                  if (options.promise) options.promise.reject(ex);
                  else throw ex;
                }
              }
            }
            data = resolveAllFragment(data, context, pointer, fragment, target, options);
            data = filterData(data, options);
          } catch (ex) {
            if (options.verbose) console.warn(ex);
            if (options.promise && options.fatal) options.promise.reject(ex);
            else throw ex;
          }
          callback(data, target, options);
          return data;
        }).catch(function(err) {
          if (options.verbose) console.warn(err);
          options.cache[target] = {};
          if (options.promise && options.fatal) options.promise.reject(err);
          else throw err;
        });
      } else {
        const def = '{"$ref":"' + pointer + '"}';
        return readFileAsync(target, options.encoding || "utf8", options, pointer, def).then(function(data) {
          try {
            let context = yaml.parse(data, { schema: "core", prettyErrors: true });
            data = options.externalRef = context;
            options.cache[target] = clone3(data);
            if (fragment) {
              data = jptr(data, fragment);
              if (data === false) {
                data = {};
                if (options.fatal) {
                  let ex = new Error("File $ref resolution failed " + target + fragment);
                  if (options.promise) options.promise.reject(ex);
                  else throw ex;
                }
              }
            }
            data = resolveAllFragment(data, context, pointer, fragment, target, options);
            data = filterData(data, options);
          } catch (ex) {
            if (options.verbose) console.warn(ex);
            if (options.promise && options.fatal) options.promise.reject(ex);
            else throw ex;
          }
          callback(data, target, options);
          return data;
        }).catch(function(err) {
          if (options.verbose) console.warn(err);
          if (options.promise && options.fatal) options.promise.reject(err);
          else throw err;
        });
      }
    }
    function scanExternalRefs(options) {
      return new Promise(function(res, rej) {
        function inner(obj, key, state) {
          if (obj[key] && isRef(obj[key], "$ref")) {
            let $ref = obj[key].$ref;
            if (!$ref.startsWith("#")) {
              let $extra = "";
              if (!refs[$ref]) {
                let potential = Object.keys(refs).find(function(e, i, a) {
                  return $ref.startsWith(e + "/");
                });
                if (potential) {
                  if (options.verbose) console.warn("Found potential subschema at", potential);
                  $extra = "/" + ($ref.split("#")[1] || "").replace(potential.split("#")[1] || "");
                  $extra = $extra.split("/undefined").join("");
                  $ref = potential;
                }
              }
              if (!refs[$ref]) {
                refs[$ref] = { resolved: false, paths: [], extras: {}, description: obj[key].description };
              }
              if (refs[$ref].resolved) {
                if (refs[$ref].failed) {
                } else if (options.rewriteRefs) {
                  let newRef = refs[$ref].resolvedAt;
                  if (options.verbose > 1) console.warn("Rewriting ref", $ref, newRef);
                  obj[key]["x-miro"] = $ref;
                  obj[key].$ref = newRef + $extra;
                } else {
                  obj[key] = clone3(refs[$ref].data);
                }
              } else {
                refs[$ref].paths.push(state.path);
                refs[$ref].extras[state.path] = $extra;
              }
            }
          }
        }
        let refs = options.externalRefs;
        if (options.resolver.depth > 0 && options.source === options.resolver.base) {
          return res(refs);
        }
        recurse(options.openapi.definitions, { identityDetection: true, path: "#/definitions" }, inner);
        recurse(options.openapi.components, { identityDetection: true, path: "#/components" }, inner);
        recurse(options.openapi, { identityDetection: true }, inner);
        res(refs);
      });
    }
    function findExternalRefs(options) {
      return new Promise(function(res, rej) {
        scanExternalRefs(options).then(function(refs) {
          for (let ref in refs) {
            if (!refs[ref].resolved) {
              let depth = options.resolver.depth;
              if (depth > 0) depth++;
              options.resolver.actions[depth].push(function() {
                return resolveExternal(options.openapi, ref, options, function(data, source, options2) {
                  if (!refs[ref].resolved) {
                    let external = {};
                    external.context = refs[ref];
                    external.$ref = ref;
                    external.original = clone3(data);
                    external.updated = data;
                    external.source = source;
                    options2.externals.push(external);
                    refs[ref].resolved = true;
                  }
                  let localOptions = Object.assign({}, options2, {
                    source: "",
                    resolver: {
                      actions: options2.resolver.actions,
                      depth: options2.resolver.actions.length - 1,
                      base: options2.resolver.base
                    }
                  });
                  if (options2.patch && refs[ref].description && !data.description && typeof data === "object") {
                    data.description = refs[ref].description;
                  }
                  refs[ref].data = data;
                  let pointers = unique(refs[ref].paths);
                  pointers = pointers.sort(function(a, b) {
                    const aComp = a.startsWith("#/components/") || a.startsWith("#/definitions/");
                    const bComp = b.startsWith("#/components/") || b.startsWith("#/definitions/");
                    if (aComp && !bComp) return -1;
                    if (bComp && !aComp) return 1;
                    return 0;
                  });
                  for (let ptr of pointers) {
                    if (refs[ref].resolvedAt && ptr !== refs[ref].resolvedAt && ptr.indexOf("x-ms-examples/") < 0) {
                      if (options2.verbose > 1) console.warn("Creating pointer to data at", ptr);
                      jptr(options2.openapi, ptr, { $ref: refs[ref].resolvedAt + refs[ref].extras[ptr], "x-miro": ref + refs[ref].extras[ptr] });
                    } else {
                      if (refs[ref].resolvedAt) {
                        if (options2.verbose > 1) console.warn("Avoiding circular reference");
                      } else {
                        refs[ref].resolvedAt = ptr;
                        if (options2.verbose > 1) console.warn("Creating initial clone of data at", ptr);
                      }
                      let cdata = clone3(data);
                      jptr(options2.openapi, ptr, cdata);
                    }
                  }
                  if (options2.resolver.actions[localOptions.resolver.depth].length === 0) {
                    options2.resolver.actions[localOptions.resolver.depth].push(function() {
                      return findExternalRefs(localOptions);
                    });
                  }
                });
              });
            }
          }
        }).catch(function(ex) {
          if (options.verbose) console.warn(ex);
          rej(ex);
        });
        let result = { options };
        result.actions = options.resolver.actions[options.resolver.depth];
        res(result);
      });
    }
    var serial = (funcs) => funcs.reduce((promise, func) => promise.then((result) => func().then(Array.prototype.concat.bind(result))), Promise.resolve([]));
    function loopReferences(options, res, rej) {
      options.resolver.actions.push([]);
      findExternalRefs(options).then(function(data) {
        serial(data.actions).then(function() {
          if (options.resolver.depth >= options.resolver.actions.length) {
            console.warn("Ran off the end of resolver actions");
            return res(true);
          } else {
            options.resolver.depth++;
            if (options.resolver.actions[options.resolver.depth].length) {
              setTimeout(function() {
                loopReferences(data.options, res, rej);
              }, 0);
            } else {
              if (options.verbose > 1) console.warn(common2.colour.yellow + "Finished external resolution!", common2.colour.normal);
              if (options.resolveInternal) {
                if (options.verbose > 1) console.warn(common2.colour.yellow + "Starting internal resolution!", common2.colour.normal);
                options.openapi = deRef(options.openapi, options.original, { verbose: options.verbose - 1 });
                if (options.verbose > 1) console.warn(common2.colour.yellow + "Finished internal resolution!", common2.colour.normal);
              }
              recurse(options.openapi, {}, function(obj, key, state) {
                if (isRef(obj, key)) {
                  if (!options.preserveMiro) delete obj["x-miro"];
                }
              });
              res(options);
            }
          }
        }).catch(function(ex) {
          if (options.verbose) console.warn(ex);
          rej(ex);
        });
      }).catch(function(ex) {
        if (options.verbose) console.warn(ex);
        rej(ex);
      });
    }
    function setupOptions(options) {
      if (!options.cache) options.cache = {};
      if (!options.fetch) options.fetch = fetch3;
      if (options.source) {
        let srcUrl = url.parse(options.source);
        if (!srcUrl.protocol || srcUrl.protocol.length <= 2) {
          options.source = path5.resolve(options.source);
        }
      }
      options.externals = [];
      options.externalRefs = {};
      options.rewriteRefs = true;
      options.resolver = {};
      options.resolver.depth = 0;
      options.resolver.base = options.source;
      options.resolver.actions = [[]];
    }
    function optionalResolve(options) {
      setupOptions(options);
      return new Promise(function(res, rej) {
        if (options.resolve)
          loopReferences(options, res, rej);
        else
          res(options);
      });
    }
    function resolve(openapi, source, options) {
      if (!options) options = {};
      options.openapi = openapi;
      options.source = source;
      options.resolve = true;
      setupOptions(options);
      return new Promise(function(res, rej) {
        loopReferences(options, res, rej);
      });
    }
    module2.exports = {
      optionalResolve,
      resolve
    };
  }
});

// ../../../node_modules/.pnpm/oas-schema-walker@1.1.5/node_modules/oas-schema-walker/index.js
var require_oas_schema_walker = __commonJS({
  "../../../node_modules/.pnpm/oas-schema-walker@1.1.5/node_modules/oas-schema-walker/index.js"(exports2, module2) {
    "use strict";
    function getDefaultState() {
      return { depth: 0, seen: /* @__PURE__ */ new WeakMap(), top: true, combine: false, allowRefSiblings: false };
    }
    function walkSchema(schema2, parent, state, callback) {
      if (typeof state.depth === "undefined") state = getDefaultState();
      if (schema2 === null || typeof schema2 === "undefined") return schema2;
      if (typeof schema2.$ref !== "undefined") {
        let temp = { $ref: schema2.$ref };
        if (state.allowRefSiblings && schema2.description) {
          temp.description = schema2.description;
        }
        callback(temp, parent, state);
        return temp;
      }
      if (state.combine) {
        if (schema2.allOf && Array.isArray(schema2.allOf) && schema2.allOf.length === 1) {
          schema2 = Object.assign({}, schema2.allOf[0], schema2);
          delete schema2.allOf;
        }
        if (schema2.anyOf && Array.isArray(schema2.anyOf) && schema2.anyOf.length === 1) {
          schema2 = Object.assign({}, schema2.anyOf[0], schema2);
          delete schema2.anyOf;
        }
        if (schema2.oneOf && Array.isArray(schema2.oneOf) && schema2.oneOf.length === 1) {
          schema2 = Object.assign({}, schema2.oneOf[0], schema2);
          delete schema2.oneOf;
        }
      }
      callback(schema2, parent, state);
      if (state.seen.has(schema2)) {
        return schema2;
      }
      if (typeof schema2 === "object" && schema2 !== null) state.seen.set(schema2, true);
      state.top = false;
      state.depth++;
      if (typeof schema2.items !== "undefined") {
        state.property = "items";
        walkSchema(schema2.items, schema2, state, callback);
      }
      if (schema2.additionalItems) {
        if (typeof schema2.additionalItems === "object") {
          state.property = "additionalItems";
          walkSchema(schema2.additionalItems, schema2, state, callback);
        }
      }
      if (schema2.additionalProperties) {
        if (typeof schema2.additionalProperties === "object") {
          state.property = "additionalProperties";
          walkSchema(schema2.additionalProperties, schema2, state, callback);
        }
      }
      if (schema2.properties) {
        for (let prop in schema2.properties) {
          let subSchema = schema2.properties[prop];
          state.property = "properties/" + prop;
          walkSchema(subSchema, schema2, state, callback);
        }
      }
      if (schema2.patternProperties) {
        for (let prop in schema2.patternProperties) {
          let subSchema = schema2.patternProperties[prop];
          state.property = "patternProperties/" + prop;
          walkSchema(subSchema, schema2, state, callback);
        }
      }
      if (schema2.allOf) {
        for (let index in schema2.allOf) {
          let subSchema = schema2.allOf[index];
          state.property = "allOf/" + index;
          walkSchema(subSchema, schema2, state, callback);
        }
      }
      if (schema2.anyOf) {
        for (let index in schema2.anyOf) {
          let subSchema = schema2.anyOf[index];
          state.property = "anyOf/" + index;
          walkSchema(subSchema, schema2, state, callback);
        }
      }
      if (schema2.oneOf) {
        for (let index in schema2.oneOf) {
          let subSchema = schema2.oneOf[index];
          state.property = "oneOf/" + index;
          walkSchema(subSchema, schema2, state, callback);
        }
      }
      if (schema2.not) {
        state.property = "not";
        walkSchema(schema2.not, schema2, state, callback);
      }
      state.depth--;
      return schema2;
    }
    module2.exports = {
      getDefaultState,
      walkSchema
    };
  }
});

// ../../../node_modules/.pnpm/swagger2openapi@7.0.8/node_modules/swagger2openapi/lib/statusCodes.js
var require_statusCodes = __commonJS({
  "../../../node_modules/.pnpm/swagger2openapi@7.0.8/node_modules/swagger2openapi/lib/statusCodes.js"(exports2, module2) {
    "use strict";
    var http3 = require("http");
    var ours = {
      "default": "Default response",
      "1XX": "Informational",
      "103": "Early hints",
      // not in Node < 10
      "2XX": "Successful",
      "3XX": "Redirection",
      "4XX": "Client Error",
      "5XX": "Server Error",
      "7XX": "Developer Error"
      // April fools RFC
    };
    module2.exports = {
      statusCodes: Object.assign({}, ours, http3.STATUS_CODES)
    };
  }
});

// ../../../node_modules/.pnpm/swagger2openapi@7.0.8/node_modules/swagger2openapi/package.json
var require_package2 = __commonJS({
  "../../../node_modules/.pnpm/swagger2openapi@7.0.8/node_modules/swagger2openapi/package.json"(exports2, module2) {
    module2.exports = {
      name: "swagger2openapi",
      version: "7.0.8",
      description: "Convert Swagger 2.0 definitions to OpenApi 3.0 and validate",
      main: "index.js",
      bin: {
        swagger2openapi: "./swagger2openapi.js",
        "oas-validate": "./oas-validate.js",
        boast: "./boast.js"
      },
      funding: "https://github.com/Mermade/oas-kit?sponsor=1",
      scripts: {
        test: "mocha"
      },
      browserify: {
        transform: [
          [
            "babelify",
            {
              presets: [
                "es2015"
              ]
            }
          ]
        ]
      },
      repository: {
        url: "https://github.com/Mermade/oas-kit.git",
        type: "git"
      },
      bugs: {
        url: "https://github.com/mermade/oas-kit/issues"
      },
      author: "Mike Ralphson <mike.ralphson@gmail.com>",
      license: "BSD-3-Clause",
      dependencies: {
        "call-me-maybe": "^1.0.1",
        "node-fetch": "^2.6.1",
        "node-fetch-h2": "^2.3.0",
        "node-readfiles": "^0.2.0",
        "oas-kit-common": "^1.0.8",
        "oas-resolver": "^2.5.6",
        "oas-schema-walker": "^1.1.5",
        "oas-validator": "^5.0.8",
        reftools: "^1.1.9",
        yaml: "^1.10.0",
        yargs: "^17.0.1"
      },
      keywords: [
        "swagger",
        "openapi",
        "openapi2",
        "openapi3",
        "converter",
        "conversion",
        "validator",
        "validation",
        "resolver",
        "lint",
        "linter"
      ],
      gitHead: "b1bba3fc5007e96a991bf2a015cf0534ac36b88b"
    };
  }
});

// ../../../node_modules/.pnpm/swagger2openapi@7.0.8/node_modules/swagger2openapi/index.js
var require_swagger2openapi = __commonJS({
  "../../../node_modules/.pnpm/swagger2openapi@7.0.8/node_modules/swagger2openapi/index.js"(exports2, module2) {
    "use strict";
    var fs = require("fs");
    var url = require("url");
    var pathlib = require("path");
    var maybe = require_maybe();
    var fetch3 = (init_lib(), __toCommonJS(lib_exports));
    var yaml = require_dist();
    var jptr = require_jptr();
    var resolveInternal = jptr.jptr;
    var isRef = require_isref().isRef;
    var clone3 = require_clone().clone;
    var cclone = require_clone().circularClone;
    var recurse = require_recurse().recurse;
    var resolver = require_oas_resolver();
    var sw = require_oas_schema_walker();
    var common2 = require_oas_kit_common();
    var statusCodes = require_statusCodes().statusCodes;
    var ourVersion = require_package2().version;
    var targetVersion = "3.0.0";
    var componentNames;
    var S2OError = class extends Error {
      constructor(message) {
        super(message);
        this.name = "S2OError";
      }
    };
    function throwError2(message, options) {
      let err = new S2OError(message);
      err.options = options;
      if (options.promise) {
        options.promise.reject(err);
      } else {
        throw err;
      }
    }
    function throwOrWarn(message, container, options) {
      if (options.warnOnly) {
        container[options.warnProperty || "x-s2o-warning"] = message;
      } else {
        throwError2(message, options);
      }
    }
    function fixUpSubSchema(schema2, parent, options) {
      if (schema2.nullable) options.patches++;
      if (schema2.discriminator && typeof schema2.discriminator === "string") {
        schema2.discriminator = { propertyName: schema2.discriminator };
      }
      if (schema2.items && Array.isArray(schema2.items)) {
        if (schema2.items.length === 0) {
          schema2.items = {};
        } else if (schema2.items.length === 1) {
          schema2.items = schema2.items[0];
        } else schema2.items = { anyOf: schema2.items };
      }
      if (schema2.type && Array.isArray(schema2.type)) {
        if (options.patch) {
          options.patches++;
          if (schema2.type.length === 0) {
            delete schema2.type;
          } else {
            if (!schema2.oneOf) schema2.oneOf = [];
            for (let type2 of schema2.type) {
              let newSchema = {};
              if (type2 === "null") {
                schema2.nullable = true;
              } else {
                newSchema.type = type2;
                for (let prop of common2.arrayProperties) {
                  if (typeof schema2.prop !== "undefined") {
                    newSchema[prop] = schema2[prop];
                    delete schema2[prop];
                  }
                }
              }
              if (newSchema.type) {
                schema2.oneOf.push(newSchema);
              }
            }
            delete schema2.type;
            if (schema2.oneOf.length === 0) {
              delete schema2.oneOf;
            } else if (schema2.oneOf.length < 2) {
              schema2.type = schema2.oneOf[0].type;
              if (Object.keys(schema2.oneOf[0]).length > 1) {
                throwOrWarn("Lost properties from oneOf", schema2, options);
              }
              delete schema2.oneOf;
            }
          }
          if (schema2.type && Array.isArray(schema2.type) && schema2.type.length === 1) {
            schema2.type = schema2.type[0];
          }
        } else {
          throwError2("(Patchable) schema type must not be an array", options);
        }
      }
      if (schema2.type && schema2.type === "null") {
        delete schema2.type;
        schema2.nullable = true;
      }
      if (schema2.type === "array" && !schema2.items) {
        schema2.items = {};
      }
      if (schema2.type === "file") {
        schema2.type = "string";
        schema2.format = "binary";
      }
      if (typeof schema2.required === "boolean") {
        if (schema2.required && schema2.name) {
          if (typeof parent.required === "undefined") {
            parent.required = [];
          }
          if (Array.isArray(parent.required)) parent.required.push(schema2.name);
        }
        delete schema2.required;
      }
      if (schema2.xml && typeof schema2.xml.namespace === "string") {
        if (!schema2.xml.namespace) delete schema2.xml.namespace;
      }
      if (typeof schema2.allowEmptyValue !== "undefined") {
        options.patches++;
        delete schema2.allowEmptyValue;
      }
    }
    function fixUpSubSchemaExtensions(schema2, parent) {
      if (schema2["x-required"] && Array.isArray(schema2["x-required"])) {
        if (!schema2.required) schema2.required = [];
        schema2.required = schema2.required.concat(schema2["x-required"]);
        delete schema2["x-required"];
      }
      if (schema2["x-anyOf"]) {
        schema2.anyOf = schema2["x-anyOf"];
        delete schema2["x-anyOf"];
      }
      if (schema2["x-oneOf"]) {
        schema2.oneOf = schema2["x-oneOf"];
        delete schema2["x-oneOf"];
      }
      if (schema2["x-not"]) {
        schema2.not = schema2["x-not"];
        delete schema2["x-not"];
      }
      if (typeof schema2["x-nullable"] === "boolean") {
        schema2.nullable = schema2["x-nullable"];
        delete schema2["x-nullable"];
      }
      if (typeof schema2["x-discriminator"] === "object" && typeof schema2["x-discriminator"].propertyName === "string") {
        schema2.discriminator = schema2["x-discriminator"];
        delete schema2["x-discriminator"];
        for (let entry in schema2.discriminator.mapping) {
          let schemaOrRef = schema2.discriminator.mapping[entry];
          if (schemaOrRef.startsWith("#/definitions/")) {
            schema2.discriminator.mapping[entry] = schemaOrRef.replace("#/definitions/", "#/components/schemas/");
          }
        }
      }
    }
    function fixUpSchema(schema2, options) {
      sw.walkSchema(schema2, {}, {}, function(schema3, parent, state) {
        fixUpSubSchemaExtensions(schema3, parent);
        fixUpSubSchema(schema3, parent, options);
      });
    }
    function getMiroComponentName(ref) {
      if (ref.indexOf("#") >= 0) {
        ref = ref.split("#")[1].split("/").pop();
      } else {
        ref = ref.split("/").pop().split(".")[0];
      }
      return encodeURIComponent(common2.sanitise(ref));
    }
    function fixupRefs(obj, key, state) {
      let options = state.payload.options;
      if (isRef(obj, key)) {
        if (obj[key].startsWith("#/components/")) {
        } else if (obj[key] === "#/consumes") {
          delete obj[key];
          state.parent[state.pkey] = clone3(options.openapi.consumes);
        } else if (obj[key] === "#/produces") {
          delete obj[key];
          state.parent[state.pkey] = clone3(options.openapi.produces);
        } else if (obj[key].startsWith("#/definitions/")) {
          let keys5 = obj[key].replace("#/definitions/", "").split("/");
          const ref = jptr.jpunescape(keys5[0]);
          let newKey = componentNames.schemas[decodeURIComponent(ref)];
          if (newKey) {
            keys5[0] = newKey;
          } else {
            throwOrWarn("Could not resolve reference " + obj[key], obj, options);
          }
          obj[key] = "#/components/schemas/" + keys5.join("/");
        } else if (obj[key].startsWith("#/parameters/")) {
          obj[key] = "#/components/parameters/" + common2.sanitise(obj[key].replace("#/parameters/", ""));
        } else if (obj[key].startsWith("#/responses/")) {
          obj[key] = "#/components/responses/" + common2.sanitise(obj[key].replace("#/responses/", ""));
        } else if (obj[key].startsWith("#")) {
          let target = clone3(jptr.jptr(options.openapi, obj[key]));
          if (target === false) throwOrWarn("direct $ref not found " + obj[key], obj, options);
          else if (options.refmap[obj[key]]) {
            obj[key] = options.refmap[obj[key]];
          } else {
            let oldRef = obj[key];
            oldRef = oldRef.replace("/properties/headers/", "");
            oldRef = oldRef.replace("/properties/responses/", "");
            oldRef = oldRef.replace("/properties/parameters/", "");
            oldRef = oldRef.replace("/properties/schemas/", "");
            let type2 = "schemas";
            let schemaIndex = oldRef.lastIndexOf("/schema");
            type2 = oldRef.indexOf("/headers/") > schemaIndex ? "headers" : oldRef.indexOf("/responses/") > schemaIndex ? "responses" : oldRef.indexOf("/example") > schemaIndex ? "examples" : oldRef.indexOf("/x-") > schemaIndex ? "extensions" : oldRef.indexOf("/parameters/") > schemaIndex ? "parameters" : "schemas";
            if (type2 === "schemas") {
              fixUpSchema(target, options);
            }
            if (type2 !== "responses" && type2 !== "extensions") {
              let prefix = type2.substr(0, type2.length - 1);
              if (prefix === "parameter" && target.name && target.name === common2.sanitise(target.name)) {
                prefix = encodeURIComponent(target.name);
              }
              let suffix = 1;
              if (obj["x-miro"]) {
                prefix = getMiroComponentName(obj["x-miro"]);
                suffix = "";
              }
              while (jptr.jptr(options.openapi, "#/components/" + type2 + "/" + prefix + suffix)) {
                suffix = suffix === "" ? 2 : ++suffix;
              }
              let newRef = "#/components/" + type2 + "/" + prefix + suffix;
              let refSuffix = "";
              if (type2 === "examples") {
                target = { value: target };
                refSuffix = "/value";
              }
              jptr.jptr(options.openapi, newRef, target);
              options.refmap[obj[key]] = newRef + refSuffix;
              obj[key] = newRef + refSuffix;
            }
          }
        }
        delete obj["x-miro"];
        if (Object.keys(obj).length > 1) {
          const tmpRef = obj[key];
          const inSchema = state.path.indexOf("/schema") >= 0;
          if (options.refSiblings === "preserve") {
          } else if (inSchema && options.refSiblings === "allOf") {
            delete obj.$ref;
            state.parent[state.pkey] = { allOf: [{ $ref: tmpRef }, obj] };
          } else {
            state.parent[state.pkey] = { $ref: tmpRef };
          }
        }
      }
      if (key === "x-ms-odata" && typeof obj[key] === "string" && obj[key].startsWith("#/")) {
        let keys5 = obj[key].replace("#/definitions/", "").replace("#/components/schemas/", "").split("/");
        let newKey = componentNames.schemas[decodeURIComponent(keys5[0])];
        if (newKey) {
          keys5[0] = newKey;
        } else {
          throwOrWarn("Could not resolve reference " + obj[key], obj, options);
        }
        obj[key] = "#/components/schemas/" + keys5.join("/");
      }
    }
    function dedupeRefs(openapi, options) {
      for (let ref in options.refmap) {
        jptr.jptr(openapi, ref, { $ref: options.refmap[ref] });
      }
    }
    function processSecurity(securityObject) {
      for (let s in securityObject) {
        for (let k in securityObject[s]) {
          let sname = common2.sanitise(k);
          if (k !== sname) {
            securityObject[s][sname] = securityObject[s][k];
            delete securityObject[s][k];
          }
        }
      }
    }
    function processSecurityScheme(scheme, options) {
      if (scheme.type === "basic") {
        scheme.type = "http";
        scheme.scheme = "basic";
      }
      if (scheme.type === "oauth2") {
        let flow = {};
        let flowName = scheme.flow;
        if (scheme.flow === "application") flowName = "clientCredentials";
        if (scheme.flow === "accessCode") flowName = "authorizationCode";
        if (typeof scheme.authorizationUrl !== "undefined") flow.authorizationUrl = scheme.authorizationUrl.split("?")[0].trim() || "/";
        if (typeof scheme.tokenUrl === "string") flow.tokenUrl = scheme.tokenUrl.split("?")[0].trim() || "/";
        flow.scopes = scheme.scopes || {};
        scheme.flows = {};
        scheme.flows[flowName] = flow;
        delete scheme.flow;
        delete scheme.authorizationUrl;
        delete scheme.tokenUrl;
        delete scheme.scopes;
        if (typeof scheme.name !== "undefined") {
          if (options.patch) {
            options.patches++;
            delete scheme.name;
          } else {
            throwError2("(Patchable) oauth2 securitySchemes should not have name property", options);
          }
        }
      }
    }
    function keepParameters(value) {
      return value && !value["x-s2o-delete"];
    }
    function processHeader(header, options) {
      if (header.$ref) {
        header.$ref = header.$ref.replace("#/responses/", "#/components/responses/");
      } else {
        if (header.type && !header.schema) {
          header.schema = {};
        }
        if (header.type) header.schema.type = header.type;
        if (header.items && header.items.type !== "array") {
          if (header.items.collectionFormat !== header.collectionFormat) {
            throwOrWarn("Nested collectionFormats are not supported", header, options);
          }
          delete header.items.collectionFormat;
        }
        if (header.type === "array") {
          if (header.collectionFormat === "ssv") {
            throwOrWarn("collectionFormat:ssv is no longer supported for headers", header, options);
          } else if (header.collectionFormat === "pipes") {
            throwOrWarn("collectionFormat:pipes is no longer supported for headers", header, options);
          } else if (header.collectionFormat === "multi") {
            header.explode = true;
          } else if (header.collectionFormat === "tsv") {
            throwOrWarn("collectionFormat:tsv is no longer supported", header, options);
            header["x-collectionFormat"] = "tsv";
          } else {
            header.style = "simple";
          }
          delete header.collectionFormat;
        } else if (header.collectionFormat) {
          if (options.patch) {
            options.patches++;
            delete header.collectionFormat;
          } else {
            throwError2("(Patchable) collectionFormat is only applicable to header.type array", options);
          }
        }
        delete header.type;
        for (let prop of common2.parameterTypeProperties) {
          if (typeof header[prop] !== "undefined") {
            header.schema[prop] = header[prop];
            delete header[prop];
          }
        }
        for (let prop of common2.arrayProperties) {
          if (typeof header[prop] !== "undefined") {
            header.schema[prop] = header[prop];
            delete header[prop];
          }
        }
      }
    }
    function fixParamRef(param, options) {
      if (param.$ref.indexOf("#/parameters/") >= 0) {
        let refComponents = param.$ref.split("#/parameters/");
        param.$ref = refComponents[0] + "#/components/parameters/" + common2.sanitise(refComponents[1]);
      }
      if (param.$ref.indexOf("#/definitions/") >= 0) {
        throwOrWarn("Definition used as parameter", param, options);
      }
    }
    function attachRequestBody(op, options) {
      let newOp = {};
      for (let key of Object.keys(op)) {
        newOp[key] = op[key];
        if (key === "parameters") {
          newOp.requestBody = {};
          if (options.rbname) newOp[options.rbname] = "";
        }
      }
      newOp.requestBody = {};
      return newOp;
    }
    function processParameter(param, op, path5, method, index, openapi, options) {
      let result = {};
      let singularRequestBody = true;
      let originalType;
      if (op && op.consumes && typeof op.consumes === "string") {
        if (options.patch) {
          options.patches++;
          op.consumes = [op.consumes];
        } else {
          return throwError2("(Patchable) operation.consumes must be an array", options);
        }
      }
      if (!Array.isArray(openapi.consumes)) delete openapi.consumes;
      let consumes = ((op ? op.consumes : null) || (openapi.consumes || [])).filter(common2.uniqueOnly);
      if (param && param.$ref && typeof param.$ref === "string") {
        fixParamRef(param, options);
        let ptr = decodeURIComponent(param.$ref.replace("#/components/parameters/", ""));
        let rbody = false;
        let target = openapi.components.parameters[ptr];
        if ((!target || target["x-s2o-delete"]) && param.$ref.startsWith("#/")) {
          param["x-s2o-delete"] = true;
          rbody = true;
        }
        if (rbody) {
          let ref = param.$ref;
          let newParam = resolveInternal(openapi, param.$ref);
          if (!newParam && ref.startsWith("#/")) {
            throwOrWarn("Could not resolve reference " + ref, param, options);
          } else {
            if (newParam) param = newParam;
          }
        }
      }
      if (param && (param.name || param.in)) {
        if (typeof param["x-deprecated"] === "boolean") {
          param.deprecated = param["x-deprecated"];
          delete param["x-deprecated"];
        }
        if (typeof param["x-example"] !== "undefined") {
          param.example = param["x-example"];
          delete param["x-example"];
        }
        if (param.in !== "body" && !param.type) {
          if (options.patch) {
            options.patches++;
            param.type = "string";
          } else {
            throwError2("(Patchable) parameter.type is mandatory for non-body parameters", options);
          }
        }
        if (param.type && typeof param.type === "object" && param.type.$ref) {
          param.type = resolveInternal(openapi, param.type.$ref);
        }
        if (param.type === "file") {
          param["x-s2o-originalType"] = param.type;
          originalType = param.type;
        }
        if (param.description && typeof param.description === "object" && param.description.$ref) {
          param.description = resolveInternal(openapi, param.description.$ref);
        }
        if (param.description === null) delete param.description;
        let oldCollectionFormat = param.collectionFormat;
        if (param.type === "array" && !oldCollectionFormat) {
          oldCollectionFormat = "csv";
        }
        if (oldCollectionFormat) {
          if (param.type !== "array") {
            if (options.patch) {
              options.patches++;
              delete param.collectionFormat;
            } else {
              throwError2("(Patchable) collectionFormat is only applicable to param.type array", options);
            }
          }
          if (oldCollectionFormat === "csv" && (param.in === "query" || param.in === "cookie")) {
            param.style = "form";
            param.explode = false;
          }
          if (oldCollectionFormat === "csv" && (param.in === "path" || param.in === "header")) {
            param.style = "simple";
          }
          if (oldCollectionFormat === "ssv") {
            if (param.in === "query") {
              param.style = "spaceDelimited";
            } else {
              throwOrWarn("collectionFormat:ssv is no longer supported except for in:query parameters", param, options);
            }
          }
          if (oldCollectionFormat === "pipes") {
            if (param.in === "query") {
              param.style = "pipeDelimited";
            } else {
              throwOrWarn("collectionFormat:pipes is no longer supported except for in:query parameters", param, options);
            }
          }
          if (oldCollectionFormat === "multi") {
            param.explode = true;
          }
          if (oldCollectionFormat === "tsv") {
            throwOrWarn("collectionFormat:tsv is no longer supported", param, options);
            param["x-collectionFormat"] = "tsv";
          }
          delete param.collectionFormat;
        }
        if (param.type && param.type !== "body" && param.in !== "formData") {
          if (param.items && param.schema) {
            throwOrWarn("parameter has array,items and schema", param, options);
          } else {
            if (param.schema) options.patches++;
            if (!param.schema || typeof param.schema !== "object") param.schema = {};
            param.schema.type = param.type;
            if (param.items) {
              param.schema.items = param.items;
              delete param.items;
              recurse(param.schema.items, null, function(obj, key, state) {
                if (key === "collectionFormat" && typeof obj[key] === "string") {
                  if (oldCollectionFormat && obj[key] !== oldCollectionFormat) {
                    throwOrWarn("Nested collectionFormats are not supported", param, options);
                  }
                  delete obj[key];
                }
              });
            }
            for (let prop of common2.parameterTypeProperties) {
              if (typeof param[prop] !== "undefined") param.schema[prop] = param[prop];
              delete param[prop];
            }
          }
        }
        if (param.schema) {
          fixUpSchema(param.schema, options);
        }
        if (param["x-ms-skip-url-encoding"]) {
          if (param.in === "query") {
            param.allowReserved = true;
            delete param["x-ms-skip-url-encoding"];
          }
        }
      }
      if (param && param.in === "formData") {
        singularRequestBody = false;
        result.content = {};
        let contentType = "application/x-www-form-urlencoded";
        if (consumes.length && consumes.indexOf("multipart/form-data") >= 0) {
          contentType = "multipart/form-data";
        }
        result.content[contentType] = {};
        if (param.schema) {
          result.content[contentType].schema = param.schema;
          if (param.schema.$ref) {
            result["x-s2o-name"] = decodeURIComponent(param.schema.$ref.replace("#/components/schemas/", ""));
          }
        } else {
          result.content[contentType].schema = {};
          result.content[contentType].schema.type = "object";
          result.content[contentType].schema.properties = {};
          result.content[contentType].schema.properties[param.name] = {};
          let schema2 = result.content[contentType].schema;
          let target = result.content[contentType].schema.properties[param.name];
          if (param.description) target.description = param.description;
          if (param.example) target.example = param.example;
          if (param.type) target.type = param.type;
          for (let prop of common2.parameterTypeProperties) {
            if (typeof param[prop] !== "undefined") target[prop] = param[prop];
          }
          if (param.required === true) {
            if (!schema2.required) schema2.required = [];
            schema2.required.push(param.name);
            result.required = true;
          }
          if (typeof param.default !== "undefined") target.default = param.default;
          if (target.properties) target.properties = param.properties;
          if (param.allOf) target.allOf = param.allOf;
          if (param.type === "array" && param.items) {
            target.items = param.items;
            if (target.items.collectionFormat) delete target.items.collectionFormat;
          }
          if (originalType === "file" || param["x-s2o-originalType"] === "file") {
            target.type = "string";
            target.format = "binary";
          }
          copyExtensions(param, target);
        }
      } else if (param && param.type === "file") {
        if (param.required) result.required = param.required;
        result.content = {};
        result.content["application/octet-stream"] = {};
        result.content["application/octet-stream"].schema = {};
        result.content["application/octet-stream"].schema.type = "string";
        result.content["application/octet-stream"].schema.format = "binary";
        copyExtensions(param, result);
      }
      if (param && param.in === "body") {
        result.content = {};
        if (param.name) result["x-s2o-name"] = (op && op.operationId ? common2.sanitiseAll(op.operationId) : "") + ("_" + param.name).toCamelCase();
        if (param.description) result.description = param.description;
        if (param.required) result.required = param.required;
        if (op && options.rbname && param.name) {
          op[options.rbname] = param.name;
        }
        if (param.schema && param.schema.$ref) {
          result["x-s2o-name"] = decodeURIComponent(param.schema.$ref.replace("#/components/schemas/", ""));
        } else if (param.schema && param.schema.type === "array" && param.schema.items && param.schema.items.$ref) {
          result["x-s2o-name"] = decodeURIComponent(param.schema.items.$ref.replace("#/components/schemas/", "")) + "Array";
        }
        if (!consumes.length) {
          consumes.push("application/json");
        }
        for (let mimetype of consumes) {
          result.content[mimetype] = {};
          result.content[mimetype].schema = clone3(param.schema || {});
          fixUpSchema(result.content[mimetype].schema, options);
        }
        copyExtensions(param, result);
      }
      if (Object.keys(result).length > 0) {
        param["x-s2o-delete"] = true;
        if (op) {
          if (op.requestBody && singularRequestBody) {
            op.requestBody["x-s2o-overloaded"] = true;
            let opId = op.operationId || index;
            throwOrWarn("Operation " + opId + " has multiple requestBodies", op, options);
          } else {
            if (!op.requestBody) {
              op = path5[method] = attachRequestBody(op, options);
            }
            if (op.requestBody.content && op.requestBody.content["multipart/form-data"] && op.requestBody.content["multipart/form-data"].schema && op.requestBody.content["multipart/form-data"].schema.properties && result.content["multipart/form-data"] && result.content["multipart/form-data"].schema && result.content["multipart/form-data"].schema.properties) {
              op.requestBody.content["multipart/form-data"].schema.properties = Object.assign(op.requestBody.content["multipart/form-data"].schema.properties, result.content["multipart/form-data"].schema.properties);
              op.requestBody.content["multipart/form-data"].schema.required = (op.requestBody.content["multipart/form-data"].schema.required || []).concat(result.content["multipart/form-data"].schema.required || []);
              if (!op.requestBody.content["multipart/form-data"].schema.required.length) {
                delete op.requestBody.content["multipart/form-data"].schema.required;
              }
            } else if (op.requestBody.content && op.requestBody.content["application/x-www-form-urlencoded"] && op.requestBody.content["application/x-www-form-urlencoded"].schema && op.requestBody.content["application/x-www-form-urlencoded"].schema.properties && result.content["application/x-www-form-urlencoded"] && result.content["application/x-www-form-urlencoded"].schema && result.content["application/x-www-form-urlencoded"].schema.properties) {
              op.requestBody.content["application/x-www-form-urlencoded"].schema.properties = Object.assign(op.requestBody.content["application/x-www-form-urlencoded"].schema.properties, result.content["application/x-www-form-urlencoded"].schema.properties);
              op.requestBody.content["application/x-www-form-urlencoded"].schema.required = (op.requestBody.content["application/x-www-form-urlencoded"].schema.required || []).concat(result.content["application/x-www-form-urlencoded"].schema.required || []);
              if (!op.requestBody.content["application/x-www-form-urlencoded"].schema.required.length) {
                delete op.requestBody.content["application/x-www-form-urlencoded"].schema.required;
              }
            } else {
              op.requestBody = Object.assign(op.requestBody, result);
              if (!op.requestBody["x-s2o-name"]) {
                if (op.requestBody.schema && op.requestBody.schema.$ref) {
                  op.requestBody["x-s2o-name"] = decodeURIComponent(op.requestBody.schema.$ref.replace("#/components/schemas/", "")).split("/").join("");
                } else if (op.operationId) {
                  op.requestBody["x-s2o-name"] = common2.sanitiseAll(op.operationId);
                }
              }
            }
          }
        }
      }
      if (param && !param["x-s2o-delete"]) {
        delete param.type;
        for (let prop of common2.parameterTypeProperties) {
          delete param[prop];
        }
        if (param.in === "path" && (typeof param.required === "undefined" || param.required !== true)) {
          if (options.patch) {
            options.patches++;
            param.required = true;
          } else {
            throwError2("(Patchable) path parameters must be required:true [" + param.name + " in " + index + "]", options);
          }
        }
      }
      return op;
    }
    function copyExtensions(src, tgt) {
      for (let prop in src) {
        if (prop.startsWith("x-") && !prop.startsWith("x-s2o")) {
          tgt[prop] = src[prop];
        }
      }
    }
    function processResponse(response, name, op, openapi, options) {
      if (!response) return false;
      if (response.$ref && typeof response.$ref === "string") {
        if (response.$ref.indexOf("#/definitions/") >= 0) {
          throwOrWarn("definition used as response: " + response.$ref, response, options);
        } else {
          if (response.$ref.startsWith("#/responses/")) {
            response.$ref = "#/components/responses/" + common2.sanitise(decodeURIComponent(response.$ref.replace("#/responses/", "")));
          }
        }
      } else {
        if (typeof response.description === "undefined" || response.description === null || response.description === "" && options.patch) {
          if (options.patch) {
            if (typeof response === "object" && !Array.isArray(response)) {
              options.patches++;
              response.description = statusCodes[response] || "";
            }
          } else {
            throwError2("(Patchable) response.description is mandatory", options);
          }
        }
        if (typeof response.schema !== "undefined") {
          fixUpSchema(response.schema, options);
          if (response.schema.$ref && typeof response.schema.$ref === "string" && response.schema.$ref.startsWith("#/responses/")) {
            response.schema.$ref = "#/components/responses/" + common2.sanitise(decodeURIComponent(response.schema.$ref.replace("#/responses/", "")));
          }
          if (op && op.produces && typeof op.produces === "string") {
            if (options.patch) {
              options.patches++;
              op.produces = [op.produces];
            } else {
              return throwError2("(Patchable) operation.produces must be an array", options);
            }
          }
          if (openapi.produces && !Array.isArray(openapi.produces)) delete openapi.produces;
          let produces = ((op ? op.produces : null) || (openapi.produces || [])).filter(common2.uniqueOnly);
          if (!produces.length) produces.push("*/*");
          response.content = {};
          for (let mimetype of produces) {
            response.content[mimetype] = {};
            response.content[mimetype].schema = clone3(response.schema);
            if (response.examples && response.examples[mimetype]) {
              let example = {};
              example.value = response.examples[mimetype];
              response.content[mimetype].examples = {};
              response.content[mimetype].examples.response = example;
              delete response.examples[mimetype];
            }
            if (response.content[mimetype].schema.type === "file") {
              response.content[mimetype].schema = { type: "string", format: "binary" };
            }
          }
          delete response.schema;
        }
        for (let mimetype in response.examples) {
          if (!response.content) response.content = {};
          if (!response.content[mimetype]) response.content[mimetype] = {};
          response.content[mimetype].examples = {};
          response.content[mimetype].examples.response = {};
          response.content[mimetype].examples.response.value = response.examples[mimetype];
        }
        delete response.examples;
        if (response.headers) {
          for (let h in response.headers) {
            if (h.toLowerCase() === "status code") {
              if (options.patch) {
                options.patches++;
                delete response.headers[h];
              } else {
                throwError2('(Patchable) "Status Code" is not a valid header', options);
              }
            } else {
              processHeader(response.headers[h], options);
            }
          }
        }
      }
    }
    function processPaths(container, containerName, options, requestBodyCache, openapi) {
      for (let p in container) {
        let path5 = container[p];
        if (path5 && path5["x-trace"] && typeof path5["x-trace"] === "object") {
          path5.trace = path5["x-trace"];
          delete path5["x-trace"];
        }
        if (path5 && path5["x-summary"] && typeof path5["x-summary"] === "string") {
          path5.summary = path5["x-summary"];
          delete path5["x-summary"];
        }
        if (path5 && path5["x-description"] && typeof path5["x-description"] === "string") {
          path5.description = path5["x-description"];
          delete path5["x-description"];
        }
        if (path5 && path5["x-servers"] && Array.isArray(path5["x-servers"])) {
          path5.servers = path5["x-servers"];
          delete path5["x-servers"];
        }
        for (let method in path5) {
          if (common2.httpMethods.indexOf(method) >= 0 || method === "x-amazon-apigateway-any-method") {
            let op = path5[method];
            if (op && op.parameters && Array.isArray(op.parameters)) {
              if (path5.parameters) {
                for (let param of path5.parameters) {
                  if (typeof param.$ref === "string") {
                    fixParamRef(param, options);
                    param = resolveInternal(openapi, param.$ref);
                  }
                  let match = op.parameters.find(function(e, i, a) {
                    return e.name === param.name && e.in === param.in;
                  });
                  if (!match && (param.in === "formData" || param.in === "body" || param.type === "file")) {
                    op = processParameter(param, op, path5, method, p, openapi, options);
                    if (options.rbname && op[options.rbname] === "") {
                      delete op[options.rbname];
                    }
                  }
                }
              }
              for (let param of op.parameters) {
                op = processParameter(param, op, path5, method, method + ":" + p, openapi, options);
              }
              if (options.rbname && op[options.rbname] === "") {
                delete op[options.rbname];
              }
              if (!options.debug) {
                if (op.parameters) op.parameters = op.parameters.filter(keepParameters);
              }
            }
            if (op && op.security) processSecurity(op.security);
            if (typeof op === "object") {
              if (!op.responses) {
                let defaultResp = {};
                defaultResp.description = "Default response";
                op.responses = { default: defaultResp };
              }
              for (let r in op.responses) {
                let response = op.responses[r];
                processResponse(response, r, op, openapi, options);
              }
            }
            if (op && op["x-servers"] && Array.isArray(op["x-servers"])) {
              op.servers = op["x-servers"];
              delete op["x-servers"];
            } else if (op && op.schemes && op.schemes.length) {
              for (let scheme of op.schemes) {
                if (!openapi.schemes || openapi.schemes.indexOf(scheme) < 0) {
                  if (!op.servers) {
                    op.servers = [];
                  }
                  if (Array.isArray(openapi.servers)) {
                    for (let server of openapi.servers) {
                      let newServer = clone3(server);
                      let serverUrl = url.parse(newServer.url);
                      serverUrl.protocol = scheme;
                      newServer.url = serverUrl.format();
                      op.servers.push(newServer);
                    }
                  }
                }
              }
            }
            if (options.debug) {
              op["x-s2o-consumes"] = op.consumes || [];
              op["x-s2o-produces"] = op.produces || [];
            }
            if (op) {
              delete op.consumes;
              delete op.produces;
              delete op.schemes;
              if (op["x-ms-examples"]) {
                for (let e in op["x-ms-examples"]) {
                  let example = op["x-ms-examples"][e];
                  let se = common2.sanitiseAll(e);
                  if (example.parameters) {
                    for (let p2 in example.parameters) {
                      let value = example.parameters[p2];
                      for (let param of (op.parameters || []).concat(path5.parameters || [])) {
                        if (param.$ref) {
                          param = jptr.jptr(openapi, param.$ref);
                        }
                        if (param.name === p2 && !param.example) {
                          if (!param.examples) {
                            param.examples = {};
                          }
                          param.examples[e] = { value };
                        }
                      }
                    }
                  }
                  if (example.responses) {
                    for (let r in example.responses) {
                      if (example.responses[r].headers) {
                        for (let h in example.responses[r].headers) {
                          let value = example.responses[r].headers[h];
                          for (let rh in op.responses[r].headers) {
                            if (rh === h) {
                              let header = op.responses[r].headers[rh];
                              header.example = value;
                            }
                          }
                        }
                      }
                      if (example.responses[r].body) {
                        openapi.components.examples[se] = { value: clone3(example.responses[r].body) };
                        if (op.responses[r] && op.responses[r].content) {
                          for (let ct in op.responses[r].content) {
                            let contentType = op.responses[r].content[ct];
                            if (!contentType.examples) {
                              contentType.examples = {};
                            }
                            contentType.examples[e] = { $ref: "#/components/examples/" + se };
                          }
                        }
                      }
                    }
                  }
                }
                delete op["x-ms-examples"];
              }
              if (op.parameters && op.parameters.length === 0) delete op.parameters;
              if (op.requestBody) {
                let effectiveOperationId = op.operationId ? common2.sanitiseAll(op.operationId) : common2.sanitiseAll(method + p).toCamelCase();
                let rbName = common2.sanitise(op.requestBody["x-s2o-name"] || effectiveOperationId || "");
                delete op.requestBody["x-s2o-name"];
                let rbStr = JSON.stringify(op.requestBody);
                let rbHash = common2.hash(rbStr);
                if (!requestBodyCache[rbHash]) {
                  let entry = {};
                  entry.name = rbName;
                  entry.body = op.requestBody;
                  entry.refs = [];
                  requestBodyCache[rbHash] = entry;
                }
                let ptr = "#/" + containerName + "/" + encodeURIComponent(jptr.jpescape(p)) + "/" + method + "/requestBody";
                requestBodyCache[rbHash].refs.push(ptr);
              }
            }
          }
        }
        if (path5 && path5.parameters) {
          for (let p2 in path5.parameters) {
            let param = path5.parameters[p2];
            processParameter(param, null, path5, null, p, openapi, options);
          }
          if (!options.debug && Array.isArray(path5.parameters)) {
            path5.parameters = path5.parameters.filter(keepParameters);
          }
        }
      }
    }
    function main(openapi, options) {
      let requestBodyCache = {};
      componentNames = { schemas: {} };
      if (openapi.security) processSecurity(openapi.security);
      for (let s in openapi.components.securitySchemes) {
        let sname = common2.sanitise(s);
        if (s !== sname) {
          if (openapi.components.securitySchemes[sname]) {
            throwError2("Duplicate sanitised securityScheme name " + sname, options);
          }
          openapi.components.securitySchemes[sname] = openapi.components.securitySchemes[s];
          delete openapi.components.securitySchemes[s];
        }
        processSecurityScheme(openapi.components.securitySchemes[sname], options);
      }
      for (let s in openapi.components.schemas) {
        let sname = common2.sanitiseAll(s);
        let suffix = "";
        if (s !== sname) {
          while (openapi.components.schemas[sname + suffix]) {
            suffix = suffix ? ++suffix : 2;
          }
          openapi.components.schemas[sname + suffix] = openapi.components.schemas[s];
          delete openapi.components.schemas[s];
        }
        componentNames.schemas[s] = sname + suffix;
        fixUpSchema(openapi.components.schemas[sname + suffix], options);
      }
      options.refmap = {};
      recurse(openapi, { payload: { options } }, fixupRefs);
      dedupeRefs(openapi, options);
      for (let p in openapi.components.parameters) {
        let sname = common2.sanitise(p);
        if (p !== sname) {
          if (openapi.components.parameters[sname]) {
            throwError2("Duplicate sanitised parameter name " + sname, options);
          }
          openapi.components.parameters[sname] = openapi.components.parameters[p];
          delete openapi.components.parameters[p];
        }
        let param = openapi.components.parameters[sname];
        processParameter(param, null, null, null, sname, openapi, options);
      }
      for (let r in openapi.components.responses) {
        let sname = common2.sanitise(r);
        if (r !== sname) {
          if (openapi.components.responses[sname]) {
            throwError2("Duplicate sanitised response name " + sname, options);
          }
          openapi.components.responses[sname] = openapi.components.responses[r];
          delete openapi.components.responses[r];
        }
        let response = openapi.components.responses[sname];
        processResponse(response, sname, null, openapi, options);
        if (response.headers) {
          for (let h in response.headers) {
            if (h.toLowerCase() === "status code") {
              if (options.patch) {
                options.patches++;
                delete response.headers[h];
              } else {
                throwError2('(Patchable) "Status Code" is not a valid header', options);
              }
            } else {
              processHeader(response.headers[h], options);
            }
          }
        }
      }
      for (let r in openapi.components.requestBodies) {
        let rb = openapi.components.requestBodies[r];
        let rbStr = JSON.stringify(rb);
        let rbHash = common2.hash(rbStr);
        let entry = {};
        entry.name = r;
        entry.body = rb;
        entry.refs = [];
        requestBodyCache[rbHash] = entry;
      }
      processPaths(openapi.paths, "paths", options, requestBodyCache, openapi);
      if (openapi["x-ms-paths"]) {
        processPaths(openapi["x-ms-paths"], "x-ms-paths", options, requestBodyCache, openapi);
      }
      if (!options.debug) {
        for (let p in openapi.components.parameters) {
          let param = openapi.components.parameters[p];
          if (param["x-s2o-delete"]) {
            delete openapi.components.parameters[p];
          }
        }
      }
      if (options.debug) {
        openapi["x-s2o-consumes"] = openapi.consumes || [];
        openapi["x-s2o-produces"] = openapi.produces || [];
      }
      delete openapi.consumes;
      delete openapi.produces;
      delete openapi.schemes;
      let rbNamesGenerated = [];
      openapi.components.requestBodies = {};
      if (!options.resolveInternal) {
        let counter = 1;
        for (let e in requestBodyCache) {
          let entry = requestBodyCache[e];
          if (entry.refs.length > 1) {
            let suffix = "";
            if (!entry.name) {
              entry.name = "requestBody";
              suffix = counter++;
            }
            while (rbNamesGenerated.indexOf(entry.name + suffix) >= 0) {
              suffix = suffix ? ++suffix : 2;
            }
            entry.name = entry.name + suffix;
            rbNamesGenerated.push(entry.name);
            openapi.components.requestBodies[entry.name] = clone3(entry.body);
            for (let r in entry.refs) {
              let ref = {};
              ref.$ref = "#/components/requestBodies/" + entry.name;
              jptr.jptr(openapi, entry.refs[r], ref);
            }
          }
        }
      }
      if (openapi.components.responses && Object.keys(openapi.components.responses).length === 0) {
        delete openapi.components.responses;
      }
      if (openapi.components.parameters && Object.keys(openapi.components.parameters).length === 0) {
        delete openapi.components.parameters;
      }
      if (openapi.components.examples && Object.keys(openapi.components.examples).length === 0) {
        delete openapi.components.examples;
      }
      if (openapi.components.requestBodies && Object.keys(openapi.components.requestBodies).length === 0) {
        delete openapi.components.requestBodies;
      }
      if (openapi.components.securitySchemes && Object.keys(openapi.components.securitySchemes).length === 0) {
        delete openapi.components.securitySchemes;
      }
      if (openapi.components.headers && Object.keys(openapi.components.headers).length === 0) {
        delete openapi.components.headers;
      }
      if (openapi.components.schemas && Object.keys(openapi.components.schemas).length === 0) {
        delete openapi.components.schemas;
      }
      if (openapi.components && Object.keys(openapi.components).length === 0) {
        delete openapi.components;
      }
      return openapi;
    }
    function extractServerParameters(server) {
      if (!server || !server.url || typeof server.url !== "string") return server;
      server.url = server.url.split("{{").join("{");
      server.url = server.url.split("}}").join("}");
      server.url.replace(/\{(.+?)\}/g, function(match, group1) {
        if (!server.variables) {
          server.variables = {};
        }
        server.variables[group1] = { default: "unknown" };
      });
      return server;
    }
    function fixInfo(openapi, options, reject) {
      if (typeof openapi.info === "undefined" || openapi.info === null) {
        if (options.patch) {
          options.patches++;
          openapi.info = { version: "", title: "" };
        } else {
          return reject(new S2OError("(Patchable) info object is mandatory"));
        }
      }
      if (typeof openapi.info !== "object" || Array.isArray(openapi.info)) {
        return reject(new S2OError("info must be an object"));
      }
      if (typeof openapi.info.title === "undefined" || openapi.info.title === null) {
        if (options.patch) {
          options.patches++;
          openapi.info.title = "";
        } else {
          return reject(new S2OError("(Patchable) info.title cannot be null"));
        }
      }
      if (typeof openapi.info.version === "undefined" || openapi.info.version === null) {
        if (options.patch) {
          options.patches++;
          openapi.info.version = "";
        } else {
          return reject(new S2OError("(Patchable) info.version cannot be null"));
        }
      }
      if (typeof openapi.info.version !== "string") {
        if (options.patch) {
          options.patches++;
          openapi.info.version = openapi.info.version.toString();
        } else {
          return reject(new S2OError("(Patchable) info.version must be a string"));
        }
      }
      if (typeof openapi.info.logo !== "undefined") {
        if (options.patch) {
          options.patches++;
          openapi.info["x-logo"] = openapi.info.logo;
          delete openapi.info.logo;
        } else return reject(new S2OError("(Patchable) info should not have logo property"));
      }
      if (typeof openapi.info.termsOfService !== "undefined") {
        if (openapi.info.termsOfService === null) {
          if (options.patch) {
            options.patches++;
            openapi.info.termsOfService = "";
          } else {
            return reject(new S2OError("(Patchable) info.termsOfService cannot be null"));
          }
        }
        try {
          let u = new URL(openapi.info.termsOfService);
        } catch (ex) {
          if (options.patch) {
            options.patches++;
            delete openapi.info.termsOfService;
          } else return reject(new S2OError("(Patchable) info.termsOfService must be a URL"));
        }
      }
    }
    function fixPaths(openapi, options, reject) {
      if (typeof openapi.paths === "undefined") {
        if (options.patch) {
          options.patches++;
          openapi.paths = {};
        } else {
          return reject(new S2OError("(Patchable) paths object is mandatory"));
        }
      }
    }
    function detectObjectReferences(obj, options) {
      const seen = /* @__PURE__ */ new WeakSet();
      recurse(obj, { identityDetection: true }, function(obj2, key, state) {
        if (typeof obj2[key] === "object" && obj2[key] !== null) {
          if (seen.has(obj2[key])) {
            if (options.anchors) {
              obj2[key] = clone3(obj2[key]);
            } else {
              throwError2("YAML anchor or merge key at " + state.path, options);
            }
          } else {
            seen.add(obj2[key]);
          }
        }
      });
    }
    function convertObj(swagger, options, callback) {
      return maybe(callback, new Promise(function(resolve, reject) {
        if (!swagger) swagger = {};
        options.original = swagger;
        if (!options.text) options.text = yaml.stringify(swagger);
        options.externals = [];
        options.externalRefs = {};
        options.rewriteRefs = true;
        options.preserveMiro = true;
        options.promise = {};
        options.promise.resolve = resolve;
        options.promise.reject = reject;
        options.patches = 0;
        if (!options.cache) options.cache = {};
        if (options.source) options.cache[options.source] = options.original;
        detectObjectReferences(swagger, options);
        if (swagger.openapi && typeof swagger.openapi === "string" && swagger.openapi.startsWith("3.")) {
          options.openapi = cclone(swagger);
          fixInfo(options.openapi, options, reject);
          fixPaths(options.openapi, options, reject);
          resolver.optionalResolve(options).then(function() {
            if (options.direct) {
              return resolve(options.openapi);
            } else {
              return resolve(options);
            }
          }).catch(function(ex) {
            console.warn(ex);
            reject(ex);
          });
          return;
        }
        if (!swagger.swagger || swagger.swagger != "2.0") {
          return reject(new S2OError("Unsupported swagger/OpenAPI version: " + (swagger.openapi ? swagger.openapi : swagger.swagger)));
        }
        let openapi = options.openapi = {};
        openapi.openapi = typeof options.targetVersion === "string" && options.targetVersion.startsWith("3.") ? options.targetVersion : targetVersion;
        if (options.origin) {
          if (!openapi["x-origin"]) {
            openapi["x-origin"] = [];
          }
          let origin = {};
          origin.url = options.source || options.origin;
          origin.format = "swagger";
          origin.version = swagger.swagger;
          origin.converter = {};
          origin.converter.url = "https://github.com/mermade/oas-kit";
          origin.converter.version = ourVersion;
          openapi["x-origin"].push(origin);
        }
        openapi = Object.assign(openapi, cclone(swagger));
        delete openapi.swagger;
        recurse(openapi, {}, function(obj, key, state) {
          if (obj[key] === null && !key.startsWith("x-") && key !== "default" && state.path.indexOf("/example") < 0) delete obj[key];
        });
        if (swagger.host) {
          for (let s of Array.isArray(swagger.schemes) ? swagger.schemes : [""]) {
            let server = {};
            let basePath = (swagger.basePath || "").replace(/\/$/, "");
            server.url = (s ? s + ":" : "") + "//" + swagger.host + basePath;
            extractServerParameters(server);
            if (!openapi.servers) openapi.servers = [];
            openapi.servers.push(server);
          }
        } else if (swagger.basePath) {
          let server = {};
          server.url = swagger.basePath;
          extractServerParameters(server);
          if (!openapi.servers) openapi.servers = [];
          openapi.servers.push(server);
        }
        delete openapi.host;
        delete openapi.basePath;
        if (openapi["x-servers"] && Array.isArray(openapi["x-servers"])) {
          openapi.servers = openapi["x-servers"];
          delete openapi["x-servers"];
        }
        if (swagger["x-ms-parameterized-host"]) {
          let xMsPHost = swagger["x-ms-parameterized-host"];
          let server = {};
          server.url = xMsPHost.hostTemplate + (swagger.basePath ? swagger.basePath : "");
          server.variables = {};
          const paramNames = server.url.match(/\{\w+\}/g);
          for (let msp in xMsPHost.parameters) {
            let param = xMsPHost.parameters[msp];
            if (param.$ref) {
              param = clone3(resolveInternal(openapi, param.$ref));
            }
            if (!msp.startsWith("x-")) {
              delete param.required;
              delete param.type;
              delete param.in;
              if (typeof param.default === "undefined") {
                if (param.enum) {
                  param.default = param.enum[0];
                } else {
                  param.default = "none";
                }
              }
              if (!param.name) {
                param.name = paramNames[msp].replace("{", "").replace("}", "");
              }
              server.variables[param.name] = param;
              delete param.name;
            }
          }
          if (!openapi.servers) openapi.servers = [];
          if (xMsPHost.useSchemePrefix === false) {
            openapi.servers.push(server);
          } else {
            swagger.schemes.forEach((scheme) => {
              openapi.servers.push(
                Object.assign({}, server, { url: scheme + "://" + server.url })
              );
            });
          }
          delete openapi["x-ms-parameterized-host"];
        }
        fixInfo(openapi, options, reject);
        fixPaths(openapi, options, reject);
        if (typeof openapi.consumes === "string") {
          openapi.consumes = [openapi.consumes];
        }
        if (typeof openapi.produces === "string") {
          openapi.produces = [openapi.produces];
        }
        openapi.components = {};
        if (openapi["x-callbacks"]) {
          openapi.components.callbacks = openapi["x-callbacks"];
          delete openapi["x-callbacks"];
        }
        openapi.components.examples = {};
        openapi.components.headers = {};
        if (openapi["x-links"]) {
          openapi.components.links = openapi["x-links"];
          delete openapi["x-links"];
        }
        openapi.components.parameters = openapi.parameters || {};
        openapi.components.responses = openapi.responses || {};
        openapi.components.requestBodies = {};
        openapi.components.securitySchemes = openapi.securityDefinitions || {};
        openapi.components.schemas = openapi.definitions || {};
        delete openapi.definitions;
        delete openapi.responses;
        delete openapi.parameters;
        delete openapi.securityDefinitions;
        resolver.optionalResolve(options).then(function() {
          main(options.openapi, options);
          if (options.direct) {
            resolve(options.openapi);
          } else {
            resolve(options);
          }
        }).catch(function(ex) {
          console.warn(ex);
          reject(ex);
        });
      }));
    }
    function convertStr(str2, options, callback) {
      return maybe(callback, new Promise(function(resolve, reject) {
        let obj = null;
        let error = null;
        try {
          obj = JSON.parse(str2);
          options.text = JSON.stringify(obj, null, 2);
        } catch (ex) {
          error = ex;
          try {
            obj = yaml.parse(str2, { schema: "core", prettyErrors: true });
            options.sourceYaml = true;
            options.text = str2;
          } catch (ex2) {
            error = ex2;
          }
        }
        if (obj) {
          convertObj(obj, options).then((options2) => resolve(options2)).catch((ex) => reject(ex));
        } else {
          reject(new S2OError(error ? error.message : "Could not parse string"));
        }
      }));
    }
    function convertUrl(url2, options, callback) {
      return maybe(callback, new Promise(function(resolve, reject) {
        options.origin = true;
        if (!options.source) {
          options.source = url2;
        }
        if (options.verbose) {
          console.warn("GET " + url2);
        }
        if (!options.fetch) {
          options.fetch = fetch3;
        }
        const fetchOptions = Object.assign({}, options.fetchOptions, { agent: options.agent });
        options.fetch(url2, fetchOptions).then(function(res) {
          if (res.status !== 200) throw new S2OError(`Received status code ${res.status}: ${url2}`);
          return res.text();
        }).then(function(body) {
          convertStr(body, options).then((options2) => resolve(options2)).catch((ex) => reject(ex));
        }).catch(function(err) {
          reject(err);
        });
      }));
    }
    function convertFile(filename, options, callback) {
      return maybe(callback, new Promise(function(resolve, reject) {
        fs.readFile(filename, options.encoding || "utf8", function(err, s) {
          if (err) {
            reject(err);
          } else {
            options.sourceFile = filename;
            convertStr(s, options).then((options2) => resolve(options2)).catch((ex) => reject(ex));
          }
        });
      }));
    }
    function convertStream(readable, options, callback) {
      return maybe(callback, new Promise(function(resolve, reject) {
        let data = "";
        readable.on("data", function(chunk) {
          data += chunk;
        }).on("end", function() {
          convertStr(data, options).then((options2) => resolve(options2)).catch((ex) => reject(ex));
        });
      }));
    }
    module2.exports = {
      S2OError,
      targetVersion,
      convert: convertObj,
      convertObj,
      convertUrl,
      convertStr,
      convertFile,
      convertStream
    };
  }
});

// ../../../node_modules/.pnpm/minimatch@5.1.0/node_modules/minimatch/lib/path.js
var require_path = __commonJS({
  "../../../node_modules/.pnpm/minimatch@5.1.0/node_modules/minimatch/lib/path.js"(exports2, module2) {
    "use strict";
    var isWindows = typeof process === "object" && process && process.platform === "win32";
    module2.exports = isWindows ? { sep: "\\" } : { sep: "/" };
  }
});

// ../../../node_modules/.pnpm/balanced-match@1.0.2/node_modules/balanced-match/index.js
var require_balanced_match = __commonJS({
  "../../../node_modules/.pnpm/balanced-match@1.0.2/node_modules/balanced-match/index.js"(exports2, module2) {
    "use strict";
    module2.exports = balanced;
    function balanced(a, b, str2) {
      if (a instanceof RegExp) a = maybeMatch(a, str2);
      if (b instanceof RegExp) b = maybeMatch(b, str2);
      var r = range(a, b, str2);
      return r && {
        start: r[0],
        end: r[1],
        pre: str2.slice(0, r[0]),
        body: str2.slice(r[0] + a.length, r[1]),
        post: str2.slice(r[1] + b.length)
      };
    }
    function maybeMatch(reg, str2) {
      var m = str2.match(reg);
      return m ? m[0] : null;
    }
    balanced.range = range;
    function range(a, b, str2) {
      var begs, beg, left, right, result;
      var ai = str2.indexOf(a);
      var bi = str2.indexOf(b, ai + 1);
      var i = ai;
      if (ai >= 0 && bi > 0) {
        if (a === b) {
          return [ai, bi];
        }
        begs = [];
        left = str2.length;
        while (i >= 0 && !result) {
          if (i == ai) {
            begs.push(i);
            ai = str2.indexOf(a, i + 1);
          } else if (begs.length == 1) {
            result = [begs.pop(), bi];
          } else {
            beg = begs.pop();
            if (beg < left) {
              left = beg;
              right = bi;
            }
            bi = str2.indexOf(b, i + 1);
          }
          i = ai < bi && ai >= 0 ? ai : bi;
        }
        if (begs.length) {
          result = [left, right];
        }
      }
      return result;
    }
  }
});

// ../../../node_modules/.pnpm/brace-expansion@2.0.1/node_modules/brace-expansion/index.js
var require_brace_expansion = __commonJS({
  "../../../node_modules/.pnpm/brace-expansion@2.0.1/node_modules/brace-expansion/index.js"(exports2, module2) {
    "use strict";
    var balanced = require_balanced_match();
    module2.exports = expandTop;
    var escSlash = "\0SLASH" + Math.random() + "\0";
    var escOpen = "\0OPEN" + Math.random() + "\0";
    var escClose = "\0CLOSE" + Math.random() + "\0";
    var escComma = "\0COMMA" + Math.random() + "\0";
    var escPeriod = "\0PERIOD" + Math.random() + "\0";
    function numeric(str2) {
      return parseInt(str2, 10) == str2 ? parseInt(str2, 10) : str2.charCodeAt(0);
    }
    function escapeBraces(str2) {
      return str2.split("\\\\").join(escSlash).split("\\{").join(escOpen).split("\\}").join(escClose).split("\\,").join(escComma).split("\\.").join(escPeriod);
    }
    function unescapeBraces(str2) {
      return str2.split(escSlash).join("\\").split(escOpen).join("{").split(escClose).join("}").split(escComma).join(",").split(escPeriod).join(".");
    }
    function parseCommaParts(str2) {
      if (!str2)
        return [""];
      var parts = [];
      var m = balanced("{", "}", str2);
      if (!m)
        return str2.split(",");
      var pre = m.pre;
      var body = m.body;
      var post = m.post;
      var p = pre.split(",");
      p[p.length - 1] += "{" + body + "}";
      var postParts = parseCommaParts(post);
      if (post.length) {
        p[p.length - 1] += postParts.shift();
        p.push.apply(p, postParts);
      }
      parts.push.apply(parts, p);
      return parts;
    }
    function expandTop(str2) {
      if (!str2)
        return [];
      if (str2.substr(0, 2) === "{}") {
        str2 = "\\{\\}" + str2.substr(2);
      }
      return expand(escapeBraces(str2), true).map(unescapeBraces);
    }
    function embrace(str2) {
      return "{" + str2 + "}";
    }
    function isPadded(el) {
      return /^-?0\d/.test(el);
    }
    function lte(i, y) {
      return i <= y;
    }
    function gte(i, y) {
      return i >= y;
    }
    function expand(str2, isTop) {
      var expansions = [];
      var m = balanced("{", "}", str2);
      if (!m) return [str2];
      var pre = m.pre;
      var post = m.post.length ? expand(m.post, false) : [""];
      if (/\$$/.test(m.pre)) {
        for (var k = 0; k < post.length; k++) {
          var expansion = pre + "{" + m.body + "}" + post[k];
          expansions.push(expansion);
        }
      } else {
        var isNumericSequence = /^-?\d+\.\.-?\d+(?:\.\.-?\d+)?$/.test(m.body);
        var isAlphaSequence = /^[a-zA-Z]\.\.[a-zA-Z](?:\.\.-?\d+)?$/.test(m.body);
        var isSequence = isNumericSequence || isAlphaSequence;
        var isOptions = m.body.indexOf(",") >= 0;
        if (!isSequence && !isOptions) {
          if (m.post.match(/,.*\}/)) {
            str2 = m.pre + "{" + m.body + escClose + m.post;
            return expand(str2);
          }
          return [str2];
        }
        var n;
        if (isSequence) {
          n = m.body.split(/\.\./);
        } else {
          n = parseCommaParts(m.body);
          if (n.length === 1) {
            n = expand(n[0], false).map(embrace);
            if (n.length === 1) {
              return post.map(function(p) {
                return m.pre + n[0] + p;
              });
            }
          }
        }
        var N;
        if (isSequence) {
          var x = numeric(n[0]);
          var y = numeric(n[1]);
          var width = Math.max(n[0].length, n[1].length);
          var incr = n.length == 3 ? Math.abs(numeric(n[2])) : 1;
          var test = lte;
          var reverse = y < x;
          if (reverse) {
            incr *= -1;
            test = gte;
          }
          var pad = n.some(isPadded);
          N = [];
          for (var i = x; test(i, y); i += incr) {
            var c;
            if (isAlphaSequence) {
              c = String.fromCharCode(i);
              if (c === "\\")
                c = "";
            } else {
              c = String(i);
              if (pad) {
                var need = width - c.length;
                if (need > 0) {
                  var z2 = new Array(need + 1).join("0");
                  if (i < 0)
                    c = "-" + z2 + c.slice(1);
                  else
                    c = z2 + c;
                }
              }
            }
            N.push(c);
          }
        } else {
          N = [];
          for (var j = 0; j < n.length; j++) {
            N.push.apply(N, expand(n[j], false));
          }
        }
        for (var j = 0; j < N.length; j++) {
          for (var k = 0; k < post.length; k++) {
            var expansion = pre + N[j] + post[k];
            if (!isTop || isSequence || expansion)
              expansions.push(expansion);
          }
        }
      }
      return expansions;
    }
  }
});

// ../../../node_modules/.pnpm/minimatch@5.1.0/node_modules/minimatch/minimatch.js
var require_minimatch = __commonJS({
  "../../../node_modules/.pnpm/minimatch@5.1.0/node_modules/minimatch/minimatch.js"(exports2, module2) {
    "use strict";
    var minimatch = module2.exports = (p, pattern, options = {}) => {
      assertValidPattern(pattern);
      if (!options.nocomment && pattern.charAt(0) === "#") {
        return false;
      }
      return new Minimatch(pattern, options).match(p);
    };
    module2.exports = minimatch;
    var path5 = require_path();
    minimatch.sep = path5.sep;
    var GLOBSTAR = Symbol("globstar **");
    minimatch.GLOBSTAR = GLOBSTAR;
    var expand = require_brace_expansion();
    var plTypes = {
      "!": { open: "(?:(?!(?:", close: "))[^/]*?)" },
      "?": { open: "(?:", close: ")?" },
      "+": { open: "(?:", close: ")+" },
      "*": { open: "(?:", close: ")*" },
      "@": { open: "(?:", close: ")" }
    };
    var qmark = "[^/]";
    var star = qmark + "*?";
    var twoStarDot = "(?:(?!(?:\\/|^)(?:\\.{1,2})($|\\/)).)*?";
    var twoStarNoDot = "(?:(?!(?:\\/|^)\\.).)*?";
    var charSet = (s) => s.split("").reduce((set4, c) => {
      set4[c] = true;
      return set4;
    }, {});
    var reSpecials = charSet("().*{}+?[]^$\\!");
    var addPatternStartSet = charSet("[.(");
    var slashSplit = /\/+/;
    minimatch.filter = (pattern, options = {}) => (p, i, list3) => minimatch(p, pattern, options);
    var ext = (a, b = {}) => {
      const t = {};
      Object.keys(a).forEach((k) => t[k] = a[k]);
      Object.keys(b).forEach((k) => t[k] = b[k]);
      return t;
    };
    minimatch.defaults = (def) => {
      if (!def || typeof def !== "object" || !Object.keys(def).length) {
        return minimatch;
      }
      const orig = minimatch;
      const m = (p, pattern, options) => orig(p, pattern, ext(def, options));
      m.Minimatch = class Minimatch extends orig.Minimatch {
        constructor(pattern, options) {
          super(pattern, ext(def, options));
        }
      };
      m.Minimatch.defaults = (options) => orig.defaults(ext(def, options)).Minimatch;
      m.filter = (pattern, options) => orig.filter(pattern, ext(def, options));
      m.defaults = (options) => orig.defaults(ext(def, options));
      m.makeRe = (pattern, options) => orig.makeRe(pattern, ext(def, options));
      m.braceExpand = (pattern, options) => orig.braceExpand(pattern, ext(def, options));
      m.match = (list3, pattern, options) => orig.match(list3, pattern, ext(def, options));
      return m;
    };
    minimatch.braceExpand = (pattern, options) => braceExpand(pattern, options);
    var braceExpand = (pattern, options = {}) => {
      assertValidPattern(pattern);
      if (options.nobrace || !/\{(?:(?!\{).)*\}/.test(pattern)) {
        return [pattern];
      }
      return expand(pattern);
    };
    var MAX_PATTERN_LENGTH = 1024 * 64;
    var assertValidPattern = (pattern) => {
      if (typeof pattern !== "string") {
        throw new TypeError("invalid pattern");
      }
      if (pattern.length > MAX_PATTERN_LENGTH) {
        throw new TypeError("pattern is too long");
      }
    };
    var SUBPARSE = Symbol("subparse");
    minimatch.makeRe = (pattern, options) => new Minimatch(pattern, options || {}).makeRe();
    minimatch.match = (list3, pattern, options = {}) => {
      const mm = new Minimatch(pattern, options);
      list3 = list3.filter((f) => mm.match(f));
      if (mm.options.nonull && !list3.length) {
        list3.push(pattern);
      }
      return list3;
    };
    var globUnescape = (s) => s.replace(/\\(.)/g, "$1");
    var regExpEscape = (s) => s.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
    var Minimatch = class {
      constructor(pattern, options) {
        assertValidPattern(pattern);
        if (!options) options = {};
        this.options = options;
        this.set = [];
        this.pattern = pattern;
        this.windowsPathsNoEscape = !!options.windowsPathsNoEscape || options.allowWindowsEscape === false;
        if (this.windowsPathsNoEscape) {
          this.pattern = this.pattern.replace(/\\/g, "/");
        }
        this.regexp = null;
        this.negate = false;
        this.comment = false;
        this.empty = false;
        this.partial = !!options.partial;
        this.make();
      }
      debug() {
      }
      make() {
        const pattern = this.pattern;
        const options = this.options;
        if (!options.nocomment && pattern.charAt(0) === "#") {
          this.comment = true;
          return;
        }
        if (!pattern) {
          this.empty = true;
          return;
        }
        this.parseNegate();
        let set4 = this.globSet = this.braceExpand();
        if (options.debug) this.debug = (...args) => console.error(...args);
        this.debug(this.pattern, set4);
        set4 = this.globParts = set4.map((s) => s.split(slashSplit));
        this.debug(this.pattern, set4);
        set4 = set4.map((s, si, set5) => s.map(this.parse, this));
        this.debug(this.pattern, set4);
        set4 = set4.filter((s) => s.indexOf(false) === -1);
        this.debug(this.pattern, set4);
        this.set = set4;
      }
      parseNegate() {
        if (this.options.nonegate) return;
        const pattern = this.pattern;
        let negate2 = false;
        let negateOffset = 0;
        for (let i = 0; i < pattern.length && pattern.charAt(i) === "!"; i++) {
          negate2 = !negate2;
          negateOffset++;
        }
        if (negateOffset) this.pattern = pattern.substr(negateOffset);
        this.negate = negate2;
      }
      // set partial to true to test if, for example,
      // "/a/b" matches the start of "/*/b/*/d"
      // Partial means, if you run out of file before you run
      // out of pattern, then that's fine, as long as all
      // the parts match.
      matchOne(file, pattern, partial) {
        var options = this.options;
        this.debug(
          "matchOne",
          { "this": this, file, pattern }
        );
        this.debug("matchOne", file.length, pattern.length);
        for (var fi = 0, pi = 0, fl = file.length, pl = pattern.length; fi < fl && pi < pl; fi++, pi++) {
          this.debug("matchOne loop");
          var p = pattern[pi];
          var f = file[fi];
          this.debug(pattern, p, f);
          if (p === false) return false;
          if (p === GLOBSTAR) {
            this.debug("GLOBSTAR", [pattern, p, f]);
            var fr = fi;
            var pr = pi + 1;
            if (pr === pl) {
              this.debug("** at the end");
              for (; fi < fl; fi++) {
                if (file[fi] === "." || file[fi] === ".." || !options.dot && file[fi].charAt(0) === ".") return false;
              }
              return true;
            }
            while (fr < fl) {
              var swallowee = file[fr];
              this.debug("\nglobstar while", file, fr, pattern, pr, swallowee);
              if (this.matchOne(file.slice(fr), pattern.slice(pr), partial)) {
                this.debug("globstar found match!", fr, fl, swallowee);
                return true;
              } else {
                if (swallowee === "." || swallowee === ".." || !options.dot && swallowee.charAt(0) === ".") {
                  this.debug("dot detected!", file, fr, pattern, pr);
                  break;
                }
                this.debug("globstar swallow a segment, and continue");
                fr++;
              }
            }
            if (partial) {
              this.debug("\n>>> no match, partial?", file, fr, pattern, pr);
              if (fr === fl) return true;
            }
            return false;
          }
          var hit;
          if (typeof p === "string") {
            hit = f === p;
            this.debug("string match", p, f, hit);
          } else {
            hit = f.match(p);
            this.debug("pattern match", p, f, hit);
          }
          if (!hit) return false;
        }
        if (fi === fl && pi === pl) {
          return true;
        } else if (fi === fl) {
          return partial;
        } else if (pi === pl) {
          return fi === fl - 1 && file[fi] === "";
        }
        throw new Error("wtf?");
      }
      braceExpand() {
        return braceExpand(this.pattern, this.options);
      }
      parse(pattern, isSub) {
        assertValidPattern(pattern);
        const options = this.options;
        if (pattern === "**") {
          if (!options.noglobstar)
            return GLOBSTAR;
          else
            pattern = "*";
        }
        if (pattern === "") return "";
        let re = "";
        let hasMagic = !!options.nocase;
        let escaping = false;
        const patternListStack = [];
        const negativeLists = [];
        let stateChar;
        let inClass = false;
        let reClassStart = -1;
        let classStart = -1;
        let cs;
        let pl;
        let sp;
        const patternStart = pattern.charAt(0) === "." ? "" : options.dot ? "(?!(?:^|\\/)\\.{1,2}(?:$|\\/))" : "(?!\\.)";
        const clearStateChar = () => {
          if (stateChar) {
            switch (stateChar) {
              case "*":
                re += star;
                hasMagic = true;
                break;
              case "?":
                re += qmark;
                hasMagic = true;
                break;
              default:
                re += "\\" + stateChar;
                break;
            }
            this.debug("clearStateChar %j %j", stateChar, re);
            stateChar = false;
          }
        };
        for (let i = 0, c; i < pattern.length && (c = pattern.charAt(i)); i++) {
          this.debug("%s	%s %s %j", pattern, i, re, c);
          if (escaping) {
            if (c === "/") {
              return false;
            }
            if (reSpecials[c]) {
              re += "\\";
            }
            re += c;
            escaping = false;
            continue;
          }
          switch (c) {
            /* istanbul ignore next */
            case "/": {
              return false;
            }
            case "\\":
              clearStateChar();
              escaping = true;
              continue;
            // the various stateChar values
            // for the "extglob" stuff.
            case "?":
            case "*":
            case "+":
            case "@":
            case "!":
              this.debug("%s	%s %s %j <-- stateChar", pattern, i, re, c);
              if (inClass) {
                this.debug("  in class");
                if (c === "!" && i === classStart + 1) c = "^";
                re += c;
                continue;
              }
              this.debug("call clearStateChar %j", stateChar);
              clearStateChar();
              stateChar = c;
              if (options.noext) clearStateChar();
              continue;
            case "(":
              if (inClass) {
                re += "(";
                continue;
              }
              if (!stateChar) {
                re += "\\(";
                continue;
              }
              patternListStack.push({
                type: stateChar,
                start: i - 1,
                reStart: re.length,
                open: plTypes[stateChar].open,
                close: plTypes[stateChar].close
              });
              re += stateChar === "!" ? "(?:(?!(?:" : "(?:";
              this.debug("plType %j %j", stateChar, re);
              stateChar = false;
              continue;
            case ")":
              if (inClass || !patternListStack.length) {
                re += "\\)";
                continue;
              }
              clearStateChar();
              hasMagic = true;
              pl = patternListStack.pop();
              re += pl.close;
              if (pl.type === "!") {
                negativeLists.push(pl);
              }
              pl.reEnd = re.length;
              continue;
            case "|":
              if (inClass || !patternListStack.length) {
                re += "\\|";
                continue;
              }
              clearStateChar();
              re += "|";
              continue;
            // these are mostly the same in regexp and glob
            case "[":
              clearStateChar();
              if (inClass) {
                re += "\\" + c;
                continue;
              }
              inClass = true;
              classStart = i;
              reClassStart = re.length;
              re += c;
              continue;
            case "]":
              if (i === classStart + 1 || !inClass) {
                re += "\\" + c;
                continue;
              }
              cs = pattern.substring(classStart + 1, i);
              try {
                RegExp("[" + cs + "]");
              } catch (er) {
                sp = this.parse(cs, SUBPARSE);
                re = re.substr(0, reClassStart) + "\\[" + sp[0] + "\\]";
                hasMagic = hasMagic || sp[1];
                inClass = false;
                continue;
              }
              hasMagic = true;
              inClass = false;
              re += c;
              continue;
            default:
              clearStateChar();
              if (reSpecials[c] && !(c === "^" && inClass)) {
                re += "\\";
              }
              re += c;
              break;
          }
        }
        if (inClass) {
          cs = pattern.substr(classStart + 1);
          sp = this.parse(cs, SUBPARSE);
          re = re.substr(0, reClassStart) + "\\[" + sp[0];
          hasMagic = hasMagic || sp[1];
        }
        for (pl = patternListStack.pop(); pl; pl = patternListStack.pop()) {
          let tail;
          tail = re.slice(pl.reStart + pl.open.length);
          this.debug("setting tail", re, pl);
          tail = tail.replace(/((?:\\{2}){0,64})(\\?)\|/g, (_, $1, $2) => {
            if (!$2) {
              $2 = "\\";
            }
            return $1 + $1 + $2 + "|";
          });
          this.debug("tail=%j\n   %s", tail, tail, pl, re);
          const t = pl.type === "*" ? star : pl.type === "?" ? qmark : "\\" + pl.type;
          hasMagic = true;
          re = re.slice(0, pl.reStart) + t + "\\(" + tail;
        }
        clearStateChar();
        if (escaping) {
          re += "\\\\";
        }
        const addPatternStart = addPatternStartSet[re.charAt(0)];
        for (let n = negativeLists.length - 1; n > -1; n--) {
          const nl = negativeLists[n];
          const nlBefore = re.slice(0, nl.reStart);
          const nlFirst = re.slice(nl.reStart, nl.reEnd - 8);
          let nlAfter = re.slice(nl.reEnd);
          const nlLast = re.slice(nl.reEnd - 8, nl.reEnd) + nlAfter;
          const openParensBefore = nlBefore.split("(").length - 1;
          let cleanAfter = nlAfter;
          for (let i = 0; i < openParensBefore; i++) {
            cleanAfter = cleanAfter.replace(/\)[+*?]?/, "");
          }
          nlAfter = cleanAfter;
          const dollar = nlAfter === "" && isSub !== SUBPARSE ? "$" : "";
          re = nlBefore + nlFirst + nlAfter + dollar + nlLast;
        }
        if (re !== "" && hasMagic) {
          re = "(?=.)" + re;
        }
        if (addPatternStart) {
          re = patternStart + re;
        }
        if (isSub === SUBPARSE) {
          return [re, hasMagic];
        }
        if (!hasMagic) {
          return globUnescape(pattern);
        }
        const flags = options.nocase ? "i" : "";
        try {
          return Object.assign(new RegExp("^" + re + "$", flags), {
            _glob: pattern,
            _src: re
          });
        } catch (er) {
          return new RegExp("$.");
        }
      }
      makeRe() {
        if (this.regexp || this.regexp === false) return this.regexp;
        const set4 = this.set;
        if (!set4.length) {
          this.regexp = false;
          return this.regexp;
        }
        const options = this.options;
        const twoStar = options.noglobstar ? star : options.dot ? twoStarDot : twoStarNoDot;
        const flags = options.nocase ? "i" : "";
        let re = set4.map((pattern) => {
          pattern = pattern.map(
            (p) => typeof p === "string" ? regExpEscape(p) : p === GLOBSTAR ? GLOBSTAR : p._src
          ).reduce((set5, p) => {
            if (!(set5[set5.length - 1] === GLOBSTAR && p === GLOBSTAR)) {
              set5.push(p);
            }
            return set5;
          }, []);
          pattern.forEach((p, i) => {
            if (p !== GLOBSTAR || pattern[i - 1] === GLOBSTAR) {
              return;
            }
            if (i === 0) {
              if (pattern.length > 1) {
                pattern[i + 1] = "(?:\\/|" + twoStar + "\\/)?" + pattern[i + 1];
              } else {
                pattern[i] = twoStar;
              }
            } else if (i === pattern.length - 1) {
              pattern[i - 1] += "(?:\\/|" + twoStar + ")?";
            } else {
              pattern[i - 1] += "(?:\\/|\\/" + twoStar + "\\/)" + pattern[i + 1];
              pattern[i + 1] = GLOBSTAR;
            }
          });
          return pattern.filter((p) => p !== GLOBSTAR).join("/");
        }).join("|");
        re = "^(?:" + re + ")$";
        if (this.negate) re = "^(?!" + re + ").*$";
        try {
          this.regexp = new RegExp(re, flags);
        } catch (ex) {
          this.regexp = false;
        }
        return this.regexp;
      }
      match(f, partial = this.partial) {
        this.debug("match", f, this.pattern);
        if (this.comment) return false;
        if (this.empty) return f === "";
        if (f === "/" && partial) return true;
        const options = this.options;
        if (path5.sep !== "/") {
          f = f.split(path5.sep).join("/");
        }
        f = f.split(slashSplit);
        this.debug(this.pattern, "split", f);
        const set4 = this.set;
        this.debug(this.pattern, "set", set4);
        let filename;
        for (let i = f.length - 1; i >= 0; i--) {
          filename = f[i];
          if (filename) break;
        }
        for (let i = 0; i < set4.length; i++) {
          const pattern = set4[i];
          let file = f;
          if (options.matchBase && pattern.length === 1) {
            file = [filename];
          }
          const hit = this.matchOne(file, pattern, partial);
          if (hit) {
            if (options.flipNegate) return true;
            return !this.negate;
          }
        }
        if (options.flipNegate) return false;
        return this.negate;
      }
      static defaults(def) {
        return minimatch.defaults(def).Minimatch;
      }
    };
    minimatch.Minimatch = Minimatch;
  }
});

// ../../../node_modules/.pnpm/webidl-conversions@3.0.1/node_modules/webidl-conversions/lib/index.js
var require_lib2 = __commonJS({
  "../../../node_modules/.pnpm/webidl-conversions@3.0.1/node_modules/webidl-conversions/lib/index.js"(exports2, module2) {
    "use strict";
    var conversions = {};
    module2.exports = conversions;
    function sign(x) {
      return x < 0 ? -1 : 1;
    }
    function evenRound(x) {
      if (x % 1 === 0.5 && (x & 1) === 0) {
        return Math.floor(x);
      } else {
        return Math.round(x);
      }
    }
    function createNumberConversion(bitLength, typeOpts) {
      if (!typeOpts.unsigned) {
        --bitLength;
      }
      const lowerBound = typeOpts.unsigned ? 0 : -Math.pow(2, bitLength);
      const upperBound = Math.pow(2, bitLength) - 1;
      const moduloVal = typeOpts.moduloBitLength ? Math.pow(2, typeOpts.moduloBitLength) : Math.pow(2, bitLength);
      const moduloBound = typeOpts.moduloBitLength ? Math.pow(2, typeOpts.moduloBitLength - 1) : Math.pow(2, bitLength - 1);
      return function(V, opts) {
        if (!opts) opts = {};
        let x = +V;
        if (opts.enforceRange) {
          if (!Number.isFinite(x)) {
            throw new TypeError("Argument is not a finite number");
          }
          x = sign(x) * Math.floor(Math.abs(x));
          if (x < lowerBound || x > upperBound) {
            throw new TypeError("Argument is not in byte range");
          }
          return x;
        }
        if (!isNaN(x) && opts.clamp) {
          x = evenRound(x);
          if (x < lowerBound) x = lowerBound;
          if (x > upperBound) x = upperBound;
          return x;
        }
        if (!Number.isFinite(x) || x === 0) {
          return 0;
        }
        x = sign(x) * Math.floor(Math.abs(x));
        x = x % moduloVal;
        if (!typeOpts.unsigned && x >= moduloBound) {
          return x - moduloVal;
        } else if (typeOpts.unsigned) {
          if (x < 0) {
            x += moduloVal;
          } else if (x === -0) {
            return 0;
          }
        }
        return x;
      };
    }
    conversions["void"] = function() {
      return void 0;
    };
    conversions["boolean"] = function(val) {
      return !!val;
    };
    conversions["byte"] = createNumberConversion(8, { unsigned: false });
    conversions["octet"] = createNumberConversion(8, { unsigned: true });
    conversions["short"] = createNumberConversion(16, { unsigned: false });
    conversions["unsigned short"] = createNumberConversion(16, { unsigned: true });
    conversions["long"] = createNumberConversion(32, { unsigned: false });
    conversions["unsigned long"] = createNumberConversion(32, { unsigned: true });
    conversions["long long"] = createNumberConversion(32, { unsigned: false, moduloBitLength: 64 });
    conversions["unsigned long long"] = createNumberConversion(32, { unsigned: true, moduloBitLength: 64 });
    conversions["double"] = function(V) {
      const x = +V;
      if (!Number.isFinite(x)) {
        throw new TypeError("Argument is not a finite floating-point value");
      }
      return x;
    };
    conversions["unrestricted double"] = function(V) {
      const x = +V;
      if (isNaN(x)) {
        throw new TypeError("Argument is NaN");
      }
      return x;
    };
    conversions["float"] = conversions["double"];
    conversions["unrestricted float"] = conversions["unrestricted double"];
    conversions["DOMString"] = function(V, opts) {
      if (!opts) opts = {};
      if (opts.treatNullAsEmptyString && V === null) {
        return "";
      }
      return String(V);
    };
    conversions["ByteString"] = function(V, opts) {
      const x = String(V);
      let c = void 0;
      for (let i = 0; (c = x.codePointAt(i)) !== void 0; ++i) {
        if (c > 255) {
          throw new TypeError("Argument is not a valid bytestring");
        }
      }
      return x;
    };
    conversions["USVString"] = function(V) {
      const S = String(V);
      const n = S.length;
      const U = [];
      for (let i = 0; i < n; ++i) {
        const c = S.charCodeAt(i);
        if (c < 55296 || c > 57343) {
          U.push(String.fromCodePoint(c));
        } else if (56320 <= c && c <= 57343) {
          U.push(String.fromCodePoint(65533));
        } else {
          if (i === n - 1) {
            U.push(String.fromCodePoint(65533));
          } else {
            const d = S.charCodeAt(i + 1);
            if (56320 <= d && d <= 57343) {
              const a = c & 1023;
              const b = d & 1023;
              U.push(String.fromCodePoint((2 << 15) + (2 << 9) * a + b));
              ++i;
            } else {
              U.push(String.fromCodePoint(65533));
            }
          }
        }
      }
      return U.join("");
    };
    conversions["Date"] = function(V, opts) {
      if (!(V instanceof Date)) {
        throw new TypeError("Argument is not a Date object");
      }
      if (isNaN(V)) {
        return void 0;
      }
      return V;
    };
    conversions["RegExp"] = function(V, opts) {
      if (!(V instanceof RegExp)) {
        V = new RegExp(V);
      }
      return V;
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/utils.js
var require_utils3 = __commonJS({
  "../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/utils.js"(exports2, module2) {
    "use strict";
    module2.exports.mixin = function mixin(target, source) {
      const keys5 = Object.getOwnPropertyNames(source);
      for (let i = 0; i < keys5.length; ++i) {
        Object.defineProperty(target, keys5[i], Object.getOwnPropertyDescriptor(source, keys5[i]));
      }
    };
    module2.exports.wrapperSymbol = Symbol("wrapper");
    module2.exports.implSymbol = Symbol("impl");
    module2.exports.wrapperForImpl = function(impl) {
      return impl[module2.exports.wrapperSymbol];
    };
    module2.exports.implForWrapper = function(wrapper) {
      return wrapper[module2.exports.implSymbol];
    };
  }
});

// ../../../node_modules/.pnpm/tr46@0.0.3/node_modules/tr46/lib/mappingTable.json
var require_mappingTable = __commonJS({
  "../../../node_modules/.pnpm/tr46@0.0.3/node_modules/tr46/lib/mappingTable.json"(exports2, module2) {
    module2.exports = [[[0, 44], "disallowed_STD3_valid"], [[45, 46], "valid"], [[47, 47], "disallowed_STD3_valid"], [[48, 57], "valid"], [[58, 64], "disallowed_STD3_valid"], [[65, 65], "mapped", [97]], [[66, 66], "mapped", [98]], [[67, 67], "mapped", [99]], [[68, 68], "mapped", [100]], [[69, 69], "mapped", [101]], [[70, 70], "mapped", [102]], [[71, 71], "mapped", [103]], [[72, 72], "mapped", [104]], [[73, 73], "mapped", [105]], [[74, 74], "mapped", [106]], [[75, 75], "mapped", [107]], [[76, 76], "mapped", [108]], [[77, 77], "mapped", [109]], [[78, 78], "mapped", [110]], [[79, 79], "mapped", [111]], [[80, 80], "mapped", [112]], [[81, 81], "mapped", [113]], [[82, 82], "mapped", [114]], [[83, 83], "mapped", [115]], [[84, 84], "mapped", [116]], [[85, 85], "mapped", [117]], [[86, 86], "mapped", [118]], [[87, 87], "mapped", [119]], [[88, 88], "mapped", [120]], [[89, 89], "mapped", [121]], [[90, 90], "mapped", [122]], [[91, 96], "disallowed_STD3_valid"], [[97, 122], "valid"], [[123, 127], "disallowed_STD3_valid"], [[128, 159], "disallowed"], [[160, 160], "disallowed_STD3_mapped", [32]], [[161, 167], "valid", [], "NV8"], [[168, 168], "disallowed_STD3_mapped", [32, 776]], [[169, 169], "valid", [], "NV8"], [[170, 170], "mapped", [97]], [[171, 172], "valid", [], "NV8"], [[173, 173], "ignored"], [[174, 174], "valid", [], "NV8"], [[175, 175], "disallowed_STD3_mapped", [32, 772]], [[176, 177], "valid", [], "NV8"], [[178, 178], "mapped", [50]], [[179, 179], "mapped", [51]], [[180, 180], "disallowed_STD3_mapped", [32, 769]], [[181, 181], "mapped", [956]], [[182, 182], "valid", [], "NV8"], [[183, 183], "valid"], [[184, 184], "disallowed_STD3_mapped", [32, 807]], [[185, 185], "mapped", [49]], [[186, 186], "mapped", [111]], [[187, 187], "valid", [], "NV8"], [[188, 188], "mapped", [49, 8260, 52]], [[189, 189], "mapped", [49, 8260, 50]], [[190, 190], "mapped", [51, 8260, 52]], [[191, 191], "valid", [], "NV8"], [[192, 192], "mapped", [224]], [[193, 193], "mapped", [225]], [[194, 194], "mapped", [226]], [[195, 195], "mapped", [227]], [[196, 196], "mapped", [228]], [[197, 197], "mapped", [229]], [[198, 198], "mapped", [230]], [[199, 199], "mapped", [231]], [[200, 200], "mapped", [232]], [[201, 201], "mapped", [233]], [[202, 202], "mapped", [234]], [[203, 203], "mapped", [235]], [[204, 204], "mapped", [236]], [[205, 205], "mapped", [237]], [[206, 206], "mapped", [238]], [[207, 207], "mapped", [239]], [[208, 208], "mapped", [240]], [[209, 209], "mapped", [241]], [[210, 210], "mapped", [242]], [[211, 211], "mapped", [243]], [[212, 212], "mapped", [244]], [[213, 213], "mapped", [245]], [[214, 214], "mapped", [246]], [[215, 215], "valid", [], "NV8"], [[216, 216], "mapped", [248]], [[217, 217], "mapped", [249]], [[218, 218], "mapped", [250]], [[219, 219], "mapped", [251]], [[220, 220], "mapped", [252]], [[221, 221], "mapped", [253]], [[222, 222], "mapped", [254]], [[223, 223], "deviation", [115, 115]], [[224, 246], "valid"], [[247, 247], "valid", [], "NV8"], [[248, 255], "valid"], [[256, 256], "mapped", [257]], [[257, 257], "valid"], [[258, 258], "mapped", [259]], [[259, 259], "valid"], [[260, 260], "mapped", [261]], [[261, 261], "valid"], [[262, 262], "mapped", [263]], [[263, 263], "valid"], [[264, 264], "mapped", [265]], [[265, 265], "valid"], [[266, 266], "mapped", [267]], [[267, 267], "valid"], [[268, 268], "mapped", [269]], [[269, 269], "valid"], [[270, 270], "mapped", [271]], [[271, 271], "valid"], [[272, 272], "mapped", [273]], [[273, 273], "valid"], [[274, 274], "mapped", [275]], [[275, 275], "valid"], [[276, 276], "mapped", [277]], [[277, 277], "valid"], [[278, 278], "mapped", [279]], [[279, 279], "valid"], [[280, 280], "mapped", [281]], [[281, 281], "valid"], [[282, 282], "mapped", [283]], [[283, 283], "valid"], [[284, 284], "mapped", [285]], [[285, 285], "valid"], [[286, 286], "mapped", [287]], [[287, 287], "valid"], [[288, 288], "mapped", [289]], [[289, 289], "valid"], [[290, 290], "mapped", [291]], [[291, 291], "valid"], [[292, 292], "mapped", [293]], [[293, 293], "valid"], [[294, 294], "mapped", [295]], [[295, 295], "valid"], [[296, 296], "mapped", [297]], [[297, 297], "valid"], [[298, 298], "mapped", [299]], [[299, 299], "valid"], [[300, 300], "mapped", [301]], [[301, 301], "valid"], [[302, 302], "mapped", [303]], [[303, 303], "valid"], [[304, 304], "mapped", [105, 775]], [[305, 305], "valid"], [[306, 307], "mapped", [105, 106]], [[308, 308], "mapped", [309]], [[309, 309], "valid"], [[310, 310], "mapped", [311]], [[311, 312], "valid"], [[313, 313], "mapped", [314]], [[314, 314], "valid"], [[315, 315], "mapped", [316]], [[316, 316], "valid"], [[317, 317], "mapped", [318]], [[318, 318], "valid"], [[319, 320], "mapped", [108, 183]], [[321, 321], "mapped", [322]], [[322, 322], "valid"], [[323, 323], "mapped", [324]], [[324, 324], "valid"], [[325, 325], "mapped", [326]], [[326, 326], "valid"], [[327, 327], "mapped", [328]], [[328, 328], "valid"], [[329, 329], "mapped", [700, 110]], [[330, 330], "mapped", [331]], [[331, 331], "valid"], [[332, 332], "mapped", [333]], [[333, 333], "valid"], [[334, 334], "mapped", [335]], [[335, 335], "valid"], [[336, 336], "mapped", [337]], [[337, 337], "valid"], [[338, 338], "mapped", [339]], [[339, 339], "valid"], [[340, 340], "mapped", [341]], [[341, 341], "valid"], [[342, 342], "mapped", [343]], [[343, 343], "valid"], [[344, 344], "mapped", [345]], [[345, 345], "valid"], [[346, 346], "mapped", [347]], [[347, 347], "valid"], [[348, 348], "mapped", [349]], [[349, 349], "valid"], [[350, 350], "mapped", [351]], [[351, 351], "valid"], [[352, 352], "mapped", [353]], [[353, 353], "valid"], [[354, 354], "mapped", [355]], [[355, 355], "valid"], [[356, 356], "mapped", [357]], [[357, 357], "valid"], [[358, 358], "mapped", [359]], [[359, 359], "valid"], [[360, 360], "mapped", [361]], [[361, 361], "valid"], [[362, 362], "mapped", [363]], [[363, 363], "valid"], [[364, 364], "mapped", [365]], [[365, 365], "valid"], [[366, 366], "mapped", [367]], [[367, 367], "valid"], [[368, 368], "mapped", [369]], [[369, 369], "valid"], [[370, 370], "mapped", [371]], [[371, 371], "valid"], [[372, 372], "mapped", [373]], [[373, 373], "valid"], [[374, 374], "mapped", [375]], [[375, 375], "valid"], [[376, 376], "mapped", [255]], [[377, 377], "mapped", [378]], [[378, 378], "valid"], [[379, 379], "mapped", [380]], [[380, 380], "valid"], [[381, 381], "mapped", [382]], [[382, 382], "valid"], [[383, 383], "mapped", [115]], [[384, 384], "valid"], [[385, 385], "mapped", [595]], [[386, 386], "mapped", [387]], [[387, 387], "valid"], [[388, 388], "mapped", [389]], [[389, 389], "valid"], [[390, 390], "mapped", [596]], [[391, 391], "mapped", [392]], [[392, 392], "valid"], [[393, 393], "mapped", [598]], [[394, 394], "mapped", [599]], [[395, 395], "mapped", [396]], [[396, 397], "valid"], [[398, 398], "mapped", [477]], [[399, 399], "mapped", [601]], [[400, 400], "mapped", [603]], [[401, 401], "mapped", [402]], [[402, 402], "valid"], [[403, 403], "mapped", [608]], [[404, 404], "mapped", [611]], [[405, 405], "valid"], [[406, 406], "mapped", [617]], [[407, 407], "mapped", [616]], [[408, 408], "mapped", [409]], [[409, 411], "valid"], [[412, 412], "mapped", [623]], [[413, 413], "mapped", [626]], [[414, 414], "valid"], [[415, 415], "mapped", [629]], [[416, 416], "mapped", [417]], [[417, 417], "valid"], [[418, 418], "mapped", [419]], [[419, 419], "valid"], [[420, 420], "mapped", [421]], [[421, 421], "valid"], [[422, 422], "mapped", [640]], [[423, 423], "mapped", [424]], [[424, 424], "valid"], [[425, 425], "mapped", [643]], [[426, 427], "valid"], [[428, 428], "mapped", [429]], [[429, 429], "valid"], [[430, 430], "mapped", [648]], [[431, 431], "mapped", [432]], [[432, 432], "valid"], [[433, 433], "mapped", [650]], [[434, 434], "mapped", [651]], [[435, 435], "mapped", [436]], [[436, 436], "valid"], [[437, 437], "mapped", [438]], [[438, 438], "valid"], [[439, 439], "mapped", [658]], [[440, 440], "mapped", [441]], [[441, 443], "valid"], [[444, 444], "mapped", [445]], [[445, 451], "valid"], [[452, 454], "mapped", [100, 382]], [[455, 457], "mapped", [108, 106]], [[458, 460], "mapped", [110, 106]], [[461, 461], "mapped", [462]], [[462, 462], "valid"], [[463, 463], "mapped", [464]], [[464, 464], "valid"], [[465, 465], "mapped", [466]], [[466, 466], "valid"], [[467, 467], "mapped", [468]], [[468, 468], "valid"], [[469, 469], "mapped", [470]], [[470, 470], "valid"], [[471, 471], "mapped", [472]], [[472, 472], "valid"], [[473, 473], "mapped", [474]], [[474, 474], "valid"], [[475, 475], "mapped", [476]], [[476, 477], "valid"], [[478, 478], "mapped", [479]], [[479, 479], "valid"], [[480, 480], "mapped", [481]], [[481, 481], "valid"], [[482, 482], "mapped", [483]], [[483, 483], "valid"], [[484, 484], "mapped", [485]], [[485, 485], "valid"], [[486, 486], "mapped", [487]], [[487, 487], "valid"], [[488, 488], "mapped", [489]], [[489, 489], "valid"], [[490, 490], "mapped", [491]], [[491, 491], "valid"], [[492, 492], "mapped", [493]], [[493, 493], "valid"], [[494, 494], "mapped", [495]], [[495, 496], "valid"], [[497, 499], "mapped", [100, 122]], [[500, 500], "mapped", [501]], [[501, 501], "valid"], [[502, 502], "mapped", [405]], [[503, 503], "mapped", [447]], [[504, 504], "mapped", [505]], [[505, 505], "valid"], [[506, 506], "mapped", [507]], [[507, 507], "valid"], [[508, 508], "mapped", [509]], [[509, 509], "valid"], [[510, 510], "mapped", [511]], [[511, 511], "valid"], [[512, 512], "mapped", [513]], [[513, 513], "valid"], [[514, 514], "mapped", [515]], [[515, 515], "valid"], [[516, 516], "mapped", [517]], [[517, 517], "valid"], [[518, 518], "mapped", [519]], [[519, 519], "valid"], [[520, 520], "mapped", [521]], [[521, 521], "valid"], [[522, 522], "mapped", [523]], [[523, 523], "valid"], [[524, 524], "mapped", [525]], [[525, 525], "valid"], [[526, 526], "mapped", [527]], [[527, 527], "valid"], [[528, 528], "mapped", [529]], [[529, 529], "valid"], [[530, 530], "mapped", [531]], [[531, 531], "valid"], [[532, 532], "mapped", [533]], [[533, 533], "valid"], [[534, 534], "mapped", [535]], [[535, 535], "valid"], [[536, 536], "mapped", [537]], [[537, 537], "valid"], [[538, 538], "mapped", [539]], [[539, 539], "valid"], [[540, 540], "mapped", [541]], [[541, 541], "valid"], [[542, 542], "mapped", [543]], [[543, 543], "valid"], [[544, 544], "mapped", [414]], [[545, 545], "valid"], [[546, 546], "mapped", [547]], [[547, 547], "valid"], [[548, 548], "mapped", [549]], [[549, 549], "valid"], [[550, 550], "mapped", [551]], [[551, 551], "valid"], [[552, 552], "mapped", [553]], [[553, 553], "valid"], [[554, 554], "mapped", [555]], [[555, 555], "valid"], [[556, 556], "mapped", [557]], [[557, 557], "valid"], [[558, 558], "mapped", [559]], [[559, 559], "valid"], [[560, 560], "mapped", [561]], [[561, 561], "valid"], [[562, 562], "mapped", [563]], [[563, 563], "valid"], [[564, 566], "valid"], [[567, 569], "valid"], [[570, 570], "mapped", [11365]], [[571, 571], "mapped", [572]], [[572, 572], "valid"], [[573, 573], "mapped", [410]], [[574, 574], "mapped", [11366]], [[575, 576], "valid"], [[577, 577], "mapped", [578]], [[578, 578], "valid"], [[579, 579], "mapped", [384]], [[580, 580], "mapped", [649]], [[581, 581], "mapped", [652]], [[582, 582], "mapped", [583]], [[583, 583], "valid"], [[584, 584], "mapped", [585]], [[585, 585], "valid"], [[586, 586], "mapped", [587]], [[587, 587], "valid"], [[588, 588], "mapped", [589]], [[589, 589], "valid"], [[590, 590], "mapped", [591]], [[591, 591], "valid"], [[592, 680], "valid"], [[681, 685], "valid"], [[686, 687], "valid"], [[688, 688], "mapped", [104]], [[689, 689], "mapped", [614]], [[690, 690], "mapped", [106]], [[691, 691], "mapped", [114]], [[692, 692], "mapped", [633]], [[693, 693], "mapped", [635]], [[694, 694], "mapped", [641]], [[695, 695], "mapped", [119]], [[696, 696], "mapped", [121]], [[697, 705], "valid"], [[706, 709], "valid", [], "NV8"], [[710, 721], "valid"], [[722, 727], "valid", [], "NV8"], [[728, 728], "disallowed_STD3_mapped", [32, 774]], [[729, 729], "disallowed_STD3_mapped", [32, 775]], [[730, 730], "disallowed_STD3_mapped", [32, 778]], [[731, 731], "disallowed_STD3_mapped", [32, 808]], [[732, 732], "disallowed_STD3_mapped", [32, 771]], [[733, 733], "disallowed_STD3_mapped", [32, 779]], [[734, 734], "valid", [], "NV8"], [[735, 735], "valid", [], "NV8"], [[736, 736], "mapped", [611]], [[737, 737], "mapped", [108]], [[738, 738], "mapped", [115]], [[739, 739], "mapped", [120]], [[740, 740], "mapped", [661]], [[741, 745], "valid", [], "NV8"], [[746, 747], "valid", [], "NV8"], [[748, 748], "valid"], [[749, 749], "valid", [], "NV8"], [[750, 750], "valid"], [[751, 767], "valid", [], "NV8"], [[768, 831], "valid"], [[832, 832], "mapped", [768]], [[833, 833], "mapped", [769]], [[834, 834], "valid"], [[835, 835], "mapped", [787]], [[836, 836], "mapped", [776, 769]], [[837, 837], "mapped", [953]], [[838, 846], "valid"], [[847, 847], "ignored"], [[848, 855], "valid"], [[856, 860], "valid"], [[861, 863], "valid"], [[864, 865], "valid"], [[866, 866], "valid"], [[867, 879], "valid"], [[880, 880], "mapped", [881]], [[881, 881], "valid"], [[882, 882], "mapped", [883]], [[883, 883], "valid"], [[884, 884], "mapped", [697]], [[885, 885], "valid"], [[886, 886], "mapped", [887]], [[887, 887], "valid"], [[888, 889], "disallowed"], [[890, 890], "disallowed_STD3_mapped", [32, 953]], [[891, 893], "valid"], [[894, 894], "disallowed_STD3_mapped", [59]], [[895, 895], "mapped", [1011]], [[896, 899], "disallowed"], [[900, 900], "disallowed_STD3_mapped", [32, 769]], [[901, 901], "disallowed_STD3_mapped", [32, 776, 769]], [[902, 902], "mapped", [940]], [[903, 903], "mapped", [183]], [[904, 904], "mapped", [941]], [[905, 905], "mapped", [942]], [[906, 906], "mapped", [943]], [[907, 907], "disallowed"], [[908, 908], "mapped", [972]], [[909, 909], "disallowed"], [[910, 910], "mapped", [973]], [[911, 911], "mapped", [974]], [[912, 912], "valid"], [[913, 913], "mapped", [945]], [[914, 914], "mapped", [946]], [[915, 915], "mapped", [947]], [[916, 916], "mapped", [948]], [[917, 917], "mapped", [949]], [[918, 918], "mapped", [950]], [[919, 919], "mapped", [951]], [[920, 920], "mapped", [952]], [[921, 921], "mapped", [953]], [[922, 922], "mapped", [954]], [[923, 923], "mapped", [955]], [[924, 924], "mapped", [956]], [[925, 925], "mapped", [957]], [[926, 926], "mapped", [958]], [[927, 927], "mapped", [959]], [[928, 928], "mapped", [960]], [[929, 929], "mapped", [961]], [[930, 930], "disallowed"], [[931, 931], "mapped", [963]], [[932, 932], "mapped", [964]], [[933, 933], "mapped", [965]], [[934, 934], "mapped", [966]], [[935, 935], "mapped", [967]], [[936, 936], "mapped", [968]], [[937, 937], "mapped", [969]], [[938, 938], "mapped", [970]], [[939, 939], "mapped", [971]], [[940, 961], "valid"], [[962, 962], "deviation", [963]], [[963, 974], "valid"], [[975, 975], "mapped", [983]], [[976, 976], "mapped", [946]], [[977, 977], "mapped", [952]], [[978, 978], "mapped", [965]], [[979, 979], "mapped", [973]], [[980, 980], "mapped", [971]], [[981, 981], "mapped", [966]], [[982, 982], "mapped", [960]], [[983, 983], "valid"], [[984, 984], "mapped", [985]], [[985, 985], "valid"], [[986, 986], "mapped", [987]], [[987, 987], "valid"], [[988, 988], "mapped", [989]], [[989, 989], "valid"], [[990, 990], "mapped", [991]], [[991, 991], "valid"], [[992, 992], "mapped", [993]], [[993, 993], "valid"], [[994, 994], "mapped", [995]], [[995, 995], "valid"], [[996, 996], "mapped", [997]], [[997, 997], "valid"], [[998, 998], "mapped", [999]], [[999, 999], "valid"], [[1e3, 1e3], "mapped", [1001]], [[1001, 1001], "valid"], [[1002, 1002], "mapped", [1003]], [[1003, 1003], "valid"], [[1004, 1004], "mapped", [1005]], [[1005, 1005], "valid"], [[1006, 1006], "mapped", [1007]], [[1007, 1007], "valid"], [[1008, 1008], "mapped", [954]], [[1009, 1009], "mapped", [961]], [[1010, 1010], "mapped", [963]], [[1011, 1011], "valid"], [[1012, 1012], "mapped", [952]], [[1013, 1013], "mapped", [949]], [[1014, 1014], "valid", [], "NV8"], [[1015, 1015], "mapped", [1016]], [[1016, 1016], "valid"], [[1017, 1017], "mapped", [963]], [[1018, 1018], "mapped", [1019]], [[1019, 1019], "valid"], [[1020, 1020], "valid"], [[1021, 1021], "mapped", [891]], [[1022, 1022], "mapped", [892]], [[1023, 1023], "mapped", [893]], [[1024, 1024], "mapped", [1104]], [[1025, 1025], "mapped", [1105]], [[1026, 1026], "mapped", [1106]], [[1027, 1027], "mapped", [1107]], [[1028, 1028], "mapped", [1108]], [[1029, 1029], "mapped", [1109]], [[1030, 1030], "mapped", [1110]], [[1031, 1031], "mapped", [1111]], [[1032, 1032], "mapped", [1112]], [[1033, 1033], "mapped", [1113]], [[1034, 1034], "mapped", [1114]], [[1035, 1035], "mapped", [1115]], [[1036, 1036], "mapped", [1116]], [[1037, 1037], "mapped", [1117]], [[1038, 1038], "mapped", [1118]], [[1039, 1039], "mapped", [1119]], [[1040, 1040], "mapped", [1072]], [[1041, 1041], "mapped", [1073]], [[1042, 1042], "mapped", [1074]], [[1043, 1043], "mapped", [1075]], [[1044, 1044], "mapped", [1076]], [[1045, 1045], "mapped", [1077]], [[1046, 1046], "mapped", [1078]], [[1047, 1047], "mapped", [1079]], [[1048, 1048], "mapped", [1080]], [[1049, 1049], "mapped", [1081]], [[1050, 1050], "mapped", [1082]], [[1051, 1051], "mapped", [1083]], [[1052, 1052], "mapped", [1084]], [[1053, 1053], "mapped", [1085]], [[1054, 1054], "mapped", [1086]], [[1055, 1055], "mapped", [1087]], [[1056, 1056], "mapped", [1088]], [[1057, 1057], "mapped", [1089]], [[1058, 1058], "mapped", [1090]], [[1059, 1059], "mapped", [1091]], [[1060, 1060], "mapped", [1092]], [[1061, 1061], "mapped", [1093]], [[1062, 1062], "mapped", [1094]], [[1063, 1063], "mapped", [1095]], [[1064, 1064], "mapped", [1096]], [[1065, 1065], "mapped", [1097]], [[1066, 1066], "mapped", [1098]], [[1067, 1067], "mapped", [1099]], [[1068, 1068], "mapped", [1100]], [[1069, 1069], "mapped", [1101]], [[1070, 1070], "mapped", [1102]], [[1071, 1071], "mapped", [1103]], [[1072, 1103], "valid"], [[1104, 1104], "valid"], [[1105, 1116], "valid"], [[1117, 1117], "valid"], [[1118, 1119], "valid"], [[1120, 1120], "mapped", [1121]], [[1121, 1121], "valid"], [[1122, 1122], "mapped", [1123]], [[1123, 1123], "valid"], [[1124, 1124], "mapped", [1125]], [[1125, 1125], "valid"], [[1126, 1126], "mapped", [1127]], [[1127, 1127], "valid"], [[1128, 1128], "mapped", [1129]], [[1129, 1129], "valid"], [[1130, 1130], "mapped", [1131]], [[1131, 1131], "valid"], [[1132, 1132], "mapped", [1133]], [[1133, 1133], "valid"], [[1134, 1134], "mapped", [1135]], [[1135, 1135], "valid"], [[1136, 1136], "mapped", [1137]], [[1137, 1137], "valid"], [[1138, 1138], "mapped", [1139]], [[1139, 1139], "valid"], [[1140, 1140], "mapped", [1141]], [[1141, 1141], "valid"], [[1142, 1142], "mapped", [1143]], [[1143, 1143], "valid"], [[1144, 1144], "mapped", [1145]], [[1145, 1145], "valid"], [[1146, 1146], "mapped", [1147]], [[1147, 1147], "valid"], [[1148, 1148], "mapped", [1149]], [[1149, 1149], "valid"], [[1150, 1150], "mapped", [1151]], [[1151, 1151], "valid"], [[1152, 1152], "mapped", [1153]], [[1153, 1153], "valid"], [[1154, 1154], "valid", [], "NV8"], [[1155, 1158], "valid"], [[1159, 1159], "valid"], [[1160, 1161], "valid", [], "NV8"], [[1162, 1162], "mapped", [1163]], [[1163, 1163], "valid"], [[1164, 1164], "mapped", [1165]], [[1165, 1165], "valid"], [[1166, 1166], "mapped", [1167]], [[1167, 1167], "valid"], [[1168, 1168], "mapped", [1169]], [[1169, 1169], "valid"], [[1170, 1170], "mapped", [1171]], [[1171, 1171], "valid"], [[1172, 1172], "mapped", [1173]], [[1173, 1173], "valid"], [[1174, 1174], "mapped", [1175]], [[1175, 1175], "valid"], [[1176, 1176], "mapped", [1177]], [[1177, 1177], "valid"], [[1178, 1178], "mapped", [1179]], [[1179, 1179], "valid"], [[1180, 1180], "mapped", [1181]], [[1181, 1181], "valid"], [[1182, 1182], "mapped", [1183]], [[1183, 1183], "valid"], [[1184, 1184], "mapped", [1185]], [[1185, 1185], "valid"], [[1186, 1186], "mapped", [1187]], [[1187, 1187], "valid"], [[1188, 1188], "mapped", [1189]], [[1189, 1189], "valid"], [[1190, 1190], "mapped", [1191]], [[1191, 1191], "valid"], [[1192, 1192], "mapped", [1193]], [[1193, 1193], "valid"], [[1194, 1194], "mapped", [1195]], [[1195, 1195], "valid"], [[1196, 1196], "mapped", [1197]], [[1197, 1197], "valid"], [[1198, 1198], "mapped", [1199]], [[1199, 1199], "valid"], [[1200, 1200], "mapped", [1201]], [[1201, 1201], "valid"], [[1202, 1202], "mapped", [1203]], [[1203, 1203], "valid"], [[1204, 1204], "mapped", [1205]], [[1205, 1205], "valid"], [[1206, 1206], "mapped", [1207]], [[1207, 1207], "valid"], [[1208, 1208], "mapped", [1209]], [[1209, 1209], "valid"], [[1210, 1210], "mapped", [1211]], [[1211, 1211], "valid"], [[1212, 1212], "mapped", [1213]], [[1213, 1213], "valid"], [[1214, 1214], "mapped", [1215]], [[1215, 1215], "valid"], [[1216, 1216], "disallowed"], [[1217, 1217], "mapped", [1218]], [[1218, 1218], "valid"], [[1219, 1219], "mapped", [1220]], [[1220, 1220], "valid"], [[1221, 1221], "mapped", [1222]], [[1222, 1222], "valid"], [[1223, 1223], "mapped", [1224]], [[1224, 1224], "valid"], [[1225, 1225], "mapped", [1226]], [[1226, 1226], "valid"], [[1227, 1227], "mapped", [1228]], [[1228, 1228], "valid"], [[1229, 1229], "mapped", [1230]], [[1230, 1230], "valid"], [[1231, 1231], "valid"], [[1232, 1232], "mapped", [1233]], [[1233, 1233], "valid"], [[1234, 1234], "mapped", [1235]], [[1235, 1235], "valid"], [[1236, 1236], "mapped", [1237]], [[1237, 1237], "valid"], [[1238, 1238], "mapped", [1239]], [[1239, 1239], "valid"], [[1240, 1240], "mapped", [1241]], [[1241, 1241], "valid"], [[1242, 1242], "mapped", [1243]], [[1243, 1243], "valid"], [[1244, 1244], "mapped", [1245]], [[1245, 1245], "valid"], [[1246, 1246], "mapped", [1247]], [[1247, 1247], "valid"], [[1248, 1248], "mapped", [1249]], [[1249, 1249], "valid"], [[1250, 1250], "mapped", [1251]], [[1251, 1251], "valid"], [[1252, 1252], "mapped", [1253]], [[1253, 1253], "valid"], [[1254, 1254], "mapped", [1255]], [[1255, 1255], "valid"], [[1256, 1256], "mapped", [1257]], [[1257, 1257], "valid"], [[1258, 1258], "mapped", [1259]], [[1259, 1259], "valid"], [[1260, 1260], "mapped", [1261]], [[1261, 1261], "valid"], [[1262, 1262], "mapped", [1263]], [[1263, 1263], "valid"], [[1264, 1264], "mapped", [1265]], [[1265, 1265], "valid"], [[1266, 1266], "mapped", [1267]], [[1267, 1267], "valid"], [[1268, 1268], "mapped", [1269]], [[1269, 1269], "valid"], [[1270, 1270], "mapped", [1271]], [[1271, 1271], "valid"], [[1272, 1272], "mapped", [1273]], [[1273, 1273], "valid"], [[1274, 1274], "mapped", [1275]], [[1275, 1275], "valid"], [[1276, 1276], "mapped", [1277]], [[1277, 1277], "valid"], [[1278, 1278], "mapped", [1279]], [[1279, 1279], "valid"], [[1280, 1280], "mapped", [1281]], [[1281, 1281], "valid"], [[1282, 1282], "mapped", [1283]], [[1283, 1283], "valid"], [[1284, 1284], "mapped", [1285]], [[1285, 1285], "valid"], [[1286, 1286], "mapped", [1287]], [[1287, 1287], "valid"], [[1288, 1288], "mapped", [1289]], [[1289, 1289], "valid"], [[1290, 1290], "mapped", [1291]], [[1291, 1291], "valid"], [[1292, 1292], "mapped", [1293]], [[1293, 1293], "valid"], [[1294, 1294], "mapped", [1295]], [[1295, 1295], "valid"], [[1296, 1296], "mapped", [1297]], [[1297, 1297], "valid"], [[1298, 1298], "mapped", [1299]], [[1299, 1299], "valid"], [[1300, 1300], "mapped", [1301]], [[1301, 1301], "valid"], [[1302, 1302], "mapped", [1303]], [[1303, 1303], "valid"], [[1304, 1304], "mapped", [1305]], [[1305, 1305], "valid"], [[1306, 1306], "mapped", [1307]], [[1307, 1307], "valid"], [[1308, 1308], "mapped", [1309]], [[1309, 1309], "valid"], [[1310, 1310], "mapped", [1311]], [[1311, 1311], "valid"], [[1312, 1312], "mapped", [1313]], [[1313, 1313], "valid"], [[1314, 1314], "mapped", [1315]], [[1315, 1315], "valid"], [[1316, 1316], "mapped", [1317]], [[1317, 1317], "valid"], [[1318, 1318], "mapped", [1319]], [[1319, 1319], "valid"], [[1320, 1320], "mapped", [1321]], [[1321, 1321], "valid"], [[1322, 1322], "mapped", [1323]], [[1323, 1323], "valid"], [[1324, 1324], "mapped", [1325]], [[1325, 1325], "valid"], [[1326, 1326], "mapped", [1327]], [[1327, 1327], "valid"], [[1328, 1328], "disallowed"], [[1329, 1329], "mapped", [1377]], [[1330, 1330], "mapped", [1378]], [[1331, 1331], "mapped", [1379]], [[1332, 1332], "mapped", [1380]], [[1333, 1333], "mapped", [1381]], [[1334, 1334], "mapped", [1382]], [[1335, 1335], "mapped", [1383]], [[1336, 1336], "mapped", [1384]], [[1337, 1337], "mapped", [1385]], [[1338, 1338], "mapped", [1386]], [[1339, 1339], "mapped", [1387]], [[1340, 1340], "mapped", [1388]], [[1341, 1341], "mapped", [1389]], [[1342, 1342], "mapped", [1390]], [[1343, 1343], "mapped", [1391]], [[1344, 1344], "mapped", [1392]], [[1345, 1345], "mapped", [1393]], [[1346, 1346], "mapped", [1394]], [[1347, 1347], "mapped", [1395]], [[1348, 1348], "mapped", [1396]], [[1349, 1349], "mapped", [1397]], [[1350, 1350], "mapped", [1398]], [[1351, 1351], "mapped", [1399]], [[1352, 1352], "mapped", [1400]], [[1353, 1353], "mapped", [1401]], [[1354, 1354], "mapped", [1402]], [[1355, 1355], "mapped", [1403]], [[1356, 1356], "mapped", [1404]], [[1357, 1357], "mapped", [1405]], [[1358, 1358], "mapped", [1406]], [[1359, 1359], "mapped", [1407]], [[1360, 1360], "mapped", [1408]], [[1361, 1361], "mapped", [1409]], [[1362, 1362], "mapped", [1410]], [[1363, 1363], "mapped", [1411]], [[1364, 1364], "mapped", [1412]], [[1365, 1365], "mapped", [1413]], [[1366, 1366], "mapped", [1414]], [[1367, 1368], "disallowed"], [[1369, 1369], "valid"], [[1370, 1375], "valid", [], "NV8"], [[1376, 1376], "disallowed"], [[1377, 1414], "valid"], [[1415, 1415], "mapped", [1381, 1410]], [[1416, 1416], "disallowed"], [[1417, 1417], "valid", [], "NV8"], [[1418, 1418], "valid", [], "NV8"], [[1419, 1420], "disallowed"], [[1421, 1422], "valid", [], "NV8"], [[1423, 1423], "valid", [], "NV8"], [[1424, 1424], "disallowed"], [[1425, 1441], "valid"], [[1442, 1442], "valid"], [[1443, 1455], "valid"], [[1456, 1465], "valid"], [[1466, 1466], "valid"], [[1467, 1469], "valid"], [[1470, 1470], "valid", [], "NV8"], [[1471, 1471], "valid"], [[1472, 1472], "valid", [], "NV8"], [[1473, 1474], "valid"], [[1475, 1475], "valid", [], "NV8"], [[1476, 1476], "valid"], [[1477, 1477], "valid"], [[1478, 1478], "valid", [], "NV8"], [[1479, 1479], "valid"], [[1480, 1487], "disallowed"], [[1488, 1514], "valid"], [[1515, 1519], "disallowed"], [[1520, 1524], "valid"], [[1525, 1535], "disallowed"], [[1536, 1539], "disallowed"], [[1540, 1540], "disallowed"], [[1541, 1541], "disallowed"], [[1542, 1546], "valid", [], "NV8"], [[1547, 1547], "valid", [], "NV8"], [[1548, 1548], "valid", [], "NV8"], [[1549, 1551], "valid", [], "NV8"], [[1552, 1557], "valid"], [[1558, 1562], "valid"], [[1563, 1563], "valid", [], "NV8"], [[1564, 1564], "disallowed"], [[1565, 1565], "disallowed"], [[1566, 1566], "valid", [], "NV8"], [[1567, 1567], "valid", [], "NV8"], [[1568, 1568], "valid"], [[1569, 1594], "valid"], [[1595, 1599], "valid"], [[1600, 1600], "valid", [], "NV8"], [[1601, 1618], "valid"], [[1619, 1621], "valid"], [[1622, 1624], "valid"], [[1625, 1630], "valid"], [[1631, 1631], "valid"], [[1632, 1641], "valid"], [[1642, 1645], "valid", [], "NV8"], [[1646, 1647], "valid"], [[1648, 1652], "valid"], [[1653, 1653], "mapped", [1575, 1652]], [[1654, 1654], "mapped", [1608, 1652]], [[1655, 1655], "mapped", [1735, 1652]], [[1656, 1656], "mapped", [1610, 1652]], [[1657, 1719], "valid"], [[1720, 1721], "valid"], [[1722, 1726], "valid"], [[1727, 1727], "valid"], [[1728, 1742], "valid"], [[1743, 1743], "valid"], [[1744, 1747], "valid"], [[1748, 1748], "valid", [], "NV8"], [[1749, 1756], "valid"], [[1757, 1757], "disallowed"], [[1758, 1758], "valid", [], "NV8"], [[1759, 1768], "valid"], [[1769, 1769], "valid", [], "NV8"], [[1770, 1773], "valid"], [[1774, 1775], "valid"], [[1776, 1785], "valid"], [[1786, 1790], "valid"], [[1791, 1791], "valid"], [[1792, 1805], "valid", [], "NV8"], [[1806, 1806], "disallowed"], [[1807, 1807], "disallowed"], [[1808, 1836], "valid"], [[1837, 1839], "valid"], [[1840, 1866], "valid"], [[1867, 1868], "disallowed"], [[1869, 1871], "valid"], [[1872, 1901], "valid"], [[1902, 1919], "valid"], [[1920, 1968], "valid"], [[1969, 1969], "valid"], [[1970, 1983], "disallowed"], [[1984, 2037], "valid"], [[2038, 2042], "valid", [], "NV8"], [[2043, 2047], "disallowed"], [[2048, 2093], "valid"], [[2094, 2095], "disallowed"], [[2096, 2110], "valid", [], "NV8"], [[2111, 2111], "disallowed"], [[2112, 2139], "valid"], [[2140, 2141], "disallowed"], [[2142, 2142], "valid", [], "NV8"], [[2143, 2207], "disallowed"], [[2208, 2208], "valid"], [[2209, 2209], "valid"], [[2210, 2220], "valid"], [[2221, 2226], "valid"], [[2227, 2228], "valid"], [[2229, 2274], "disallowed"], [[2275, 2275], "valid"], [[2276, 2302], "valid"], [[2303, 2303], "valid"], [[2304, 2304], "valid"], [[2305, 2307], "valid"], [[2308, 2308], "valid"], [[2309, 2361], "valid"], [[2362, 2363], "valid"], [[2364, 2381], "valid"], [[2382, 2382], "valid"], [[2383, 2383], "valid"], [[2384, 2388], "valid"], [[2389, 2389], "valid"], [[2390, 2391], "valid"], [[2392, 2392], "mapped", [2325, 2364]], [[2393, 2393], "mapped", [2326, 2364]], [[2394, 2394], "mapped", [2327, 2364]], [[2395, 2395], "mapped", [2332, 2364]], [[2396, 2396], "mapped", [2337, 2364]], [[2397, 2397], "mapped", [2338, 2364]], [[2398, 2398], "mapped", [2347, 2364]], [[2399, 2399], "mapped", [2351, 2364]], [[2400, 2403], "valid"], [[2404, 2405], "valid", [], "NV8"], [[2406, 2415], "valid"], [[2416, 2416], "valid", [], "NV8"], [[2417, 2418], "valid"], [[2419, 2423], "valid"], [[2424, 2424], "valid"], [[2425, 2426], "valid"], [[2427, 2428], "valid"], [[2429, 2429], "valid"], [[2430, 2431], "valid"], [[2432, 2432], "valid"], [[2433, 2435], "valid"], [[2436, 2436], "disallowed"], [[2437, 2444], "valid"], [[2445, 2446], "disallowed"], [[2447, 2448], "valid"], [[2449, 2450], "disallowed"], [[2451, 2472], "valid"], [[2473, 2473], "disallowed"], [[2474, 2480], "valid"], [[2481, 2481], "disallowed"], [[2482, 2482], "valid"], [[2483, 2485], "disallowed"], [[2486, 2489], "valid"], [[2490, 2491], "disallowed"], [[2492, 2492], "valid"], [[2493, 2493], "valid"], [[2494, 2500], "valid"], [[2501, 2502], "disallowed"], [[2503, 2504], "valid"], [[2505, 2506], "disallowed"], [[2507, 2509], "valid"], [[2510, 2510], "valid"], [[2511, 2518], "disallowed"], [[2519, 2519], "valid"], [[2520, 2523], "disallowed"], [[2524, 2524], "mapped", [2465, 2492]], [[2525, 2525], "mapped", [2466, 2492]], [[2526, 2526], "disallowed"], [[2527, 2527], "mapped", [2479, 2492]], [[2528, 2531], "valid"], [[2532, 2533], "disallowed"], [[2534, 2545], "valid"], [[2546, 2554], "valid", [], "NV8"], [[2555, 2555], "valid", [], "NV8"], [[2556, 2560], "disallowed"], [[2561, 2561], "valid"], [[2562, 2562], "valid"], [[2563, 2563], "valid"], [[2564, 2564], "disallowed"], [[2565, 2570], "valid"], [[2571, 2574], "disallowed"], [[2575, 2576], "valid"], [[2577, 2578], "disallowed"], [[2579, 2600], "valid"], [[2601, 2601], "disallowed"], [[2602, 2608], "valid"], [[2609, 2609], "disallowed"], [[2610, 2610], "valid"], [[2611, 2611], "mapped", [2610, 2620]], [[2612, 2612], "disallowed"], [[2613, 2613], "valid"], [[2614, 2614], "mapped", [2616, 2620]], [[2615, 2615], "disallowed"], [[2616, 2617], "valid"], [[2618, 2619], "disallowed"], [[2620, 2620], "valid"], [[2621, 2621], "disallowed"], [[2622, 2626], "valid"], [[2627, 2630], "disallowed"], [[2631, 2632], "valid"], [[2633, 2634], "disallowed"], [[2635, 2637], "valid"], [[2638, 2640], "disallowed"], [[2641, 2641], "valid"], [[2642, 2648], "disallowed"], [[2649, 2649], "mapped", [2582, 2620]], [[2650, 2650], "mapped", [2583, 2620]], [[2651, 2651], "mapped", [2588, 2620]], [[2652, 2652], "valid"], [[2653, 2653], "disallowed"], [[2654, 2654], "mapped", [2603, 2620]], [[2655, 2661], "disallowed"], [[2662, 2676], "valid"], [[2677, 2677], "valid"], [[2678, 2688], "disallowed"], [[2689, 2691], "valid"], [[2692, 2692], "disallowed"], [[2693, 2699], "valid"], [[2700, 2700], "valid"], [[2701, 2701], "valid"], [[2702, 2702], "disallowed"], [[2703, 2705], "valid"], [[2706, 2706], "disallowed"], [[2707, 2728], "valid"], [[2729, 2729], "disallowed"], [[2730, 2736], "valid"], [[2737, 2737], "disallowed"], [[2738, 2739], "valid"], [[2740, 2740], "disallowed"], [[2741, 2745], "valid"], [[2746, 2747], "disallowed"], [[2748, 2757], "valid"], [[2758, 2758], "disallowed"], [[2759, 2761], "valid"], [[2762, 2762], "disallowed"], [[2763, 2765], "valid"], [[2766, 2767], "disallowed"], [[2768, 2768], "valid"], [[2769, 2783], "disallowed"], [[2784, 2784], "valid"], [[2785, 2787], "valid"], [[2788, 2789], "disallowed"], [[2790, 2799], "valid"], [[2800, 2800], "valid", [], "NV8"], [[2801, 2801], "valid", [], "NV8"], [[2802, 2808], "disallowed"], [[2809, 2809], "valid"], [[2810, 2816], "disallowed"], [[2817, 2819], "valid"], [[2820, 2820], "disallowed"], [[2821, 2828], "valid"], [[2829, 2830], "disallowed"], [[2831, 2832], "valid"], [[2833, 2834], "disallowed"], [[2835, 2856], "valid"], [[2857, 2857], "disallowed"], [[2858, 2864], "valid"], [[2865, 2865], "disallowed"], [[2866, 2867], "valid"], [[2868, 2868], "disallowed"], [[2869, 2869], "valid"], [[2870, 2873], "valid"], [[2874, 2875], "disallowed"], [[2876, 2883], "valid"], [[2884, 2884], "valid"], [[2885, 2886], "disallowed"], [[2887, 2888], "valid"], [[2889, 2890], "disallowed"], [[2891, 2893], "valid"], [[2894, 2901], "disallowed"], [[2902, 2903], "valid"], [[2904, 2907], "disallowed"], [[2908, 2908], "mapped", [2849, 2876]], [[2909, 2909], "mapped", [2850, 2876]], [[2910, 2910], "disallowed"], [[2911, 2913], "valid"], [[2914, 2915], "valid"], [[2916, 2917], "disallowed"], [[2918, 2927], "valid"], [[2928, 2928], "valid", [], "NV8"], [[2929, 2929], "valid"], [[2930, 2935], "valid", [], "NV8"], [[2936, 2945], "disallowed"], [[2946, 2947], "valid"], [[2948, 2948], "disallowed"], [[2949, 2954], "valid"], [[2955, 2957], "disallowed"], [[2958, 2960], "valid"], [[2961, 2961], "disallowed"], [[2962, 2965], "valid"], [[2966, 2968], "disallowed"], [[2969, 2970], "valid"], [[2971, 2971], "disallowed"], [[2972, 2972], "valid"], [[2973, 2973], "disallowed"], [[2974, 2975], "valid"], [[2976, 2978], "disallowed"], [[2979, 2980], "valid"], [[2981, 2983], "disallowed"], [[2984, 2986], "valid"], [[2987, 2989], "disallowed"], [[2990, 2997], "valid"], [[2998, 2998], "valid"], [[2999, 3001], "valid"], [[3002, 3005], "disallowed"], [[3006, 3010], "valid"], [[3011, 3013], "disallowed"], [[3014, 3016], "valid"], [[3017, 3017], "disallowed"], [[3018, 3021], "valid"], [[3022, 3023], "disallowed"], [[3024, 3024], "valid"], [[3025, 3030], "disallowed"], [[3031, 3031], "valid"], [[3032, 3045], "disallowed"], [[3046, 3046], "valid"], [[3047, 3055], "valid"], [[3056, 3058], "valid", [], "NV8"], [[3059, 3066], "valid", [], "NV8"], [[3067, 3071], "disallowed"], [[3072, 3072], "valid"], [[3073, 3075], "valid"], [[3076, 3076], "disallowed"], [[3077, 3084], "valid"], [[3085, 3085], "disallowed"], [[3086, 3088], "valid"], [[3089, 3089], "disallowed"], [[3090, 3112], "valid"], [[3113, 3113], "disallowed"], [[3114, 3123], "valid"], [[3124, 3124], "valid"], [[3125, 3129], "valid"], [[3130, 3132], "disallowed"], [[3133, 3133], "valid"], [[3134, 3140], "valid"], [[3141, 3141], "disallowed"], [[3142, 3144], "valid"], [[3145, 3145], "disallowed"], [[3146, 3149], "valid"], [[3150, 3156], "disallowed"], [[3157, 3158], "valid"], [[3159, 3159], "disallowed"], [[3160, 3161], "valid"], [[3162, 3162], "valid"], [[3163, 3167], "disallowed"], [[3168, 3169], "valid"], [[3170, 3171], "valid"], [[3172, 3173], "disallowed"], [[3174, 3183], "valid"], [[3184, 3191], "disallowed"], [[3192, 3199], "valid", [], "NV8"], [[3200, 3200], "disallowed"], [[3201, 3201], "valid"], [[3202, 3203], "valid"], [[3204, 3204], "disallowed"], [[3205, 3212], "valid"], [[3213, 3213], "disallowed"], [[3214, 3216], "valid"], [[3217, 3217], "disallowed"], [[3218, 3240], "valid"], [[3241, 3241], "disallowed"], [[3242, 3251], "valid"], [[3252, 3252], "disallowed"], [[3253, 3257], "valid"], [[3258, 3259], "disallowed"], [[3260, 3261], "valid"], [[3262, 3268], "valid"], [[3269, 3269], "disallowed"], [[3270, 3272], "valid"], [[3273, 3273], "disallowed"], [[3274, 3277], "valid"], [[3278, 3284], "disallowed"], [[3285, 3286], "valid"], [[3287, 3293], "disallowed"], [[3294, 3294], "valid"], [[3295, 3295], "disallowed"], [[3296, 3297], "valid"], [[3298, 3299], "valid"], [[3300, 3301], "disallowed"], [[3302, 3311], "valid"], [[3312, 3312], "disallowed"], [[3313, 3314], "valid"], [[3315, 3328], "disallowed"], [[3329, 3329], "valid"], [[3330, 3331], "valid"], [[3332, 3332], "disallowed"], [[3333, 3340], "valid"], [[3341, 3341], "disallowed"], [[3342, 3344], "valid"], [[3345, 3345], "disallowed"], [[3346, 3368], "valid"], [[3369, 3369], "valid"], [[3370, 3385], "valid"], [[3386, 3386], "valid"], [[3387, 3388], "disallowed"], [[3389, 3389], "valid"], [[3390, 3395], "valid"], [[3396, 3396], "valid"], [[3397, 3397], "disallowed"], [[3398, 3400], "valid"], [[3401, 3401], "disallowed"], [[3402, 3405], "valid"], [[3406, 3406], "valid"], [[3407, 3414], "disallowed"], [[3415, 3415], "valid"], [[3416, 3422], "disallowed"], [[3423, 3423], "valid"], [[3424, 3425], "valid"], [[3426, 3427], "valid"], [[3428, 3429], "disallowed"], [[3430, 3439], "valid"], [[3440, 3445], "valid", [], "NV8"], [[3446, 3448], "disallowed"], [[3449, 3449], "valid", [], "NV8"], [[3450, 3455], "valid"], [[3456, 3457], "disallowed"], [[3458, 3459], "valid"], [[3460, 3460], "disallowed"], [[3461, 3478], "valid"], [[3479, 3481], "disallowed"], [[3482, 3505], "valid"], [[3506, 3506], "disallowed"], [[3507, 3515], "valid"], [[3516, 3516], "disallowed"], [[3517, 3517], "valid"], [[3518, 3519], "disallowed"], [[3520, 3526], "valid"], [[3527, 3529], "disallowed"], [[3530, 3530], "valid"], [[3531, 3534], "disallowed"], [[3535, 3540], "valid"], [[3541, 3541], "disallowed"], [[3542, 3542], "valid"], [[3543, 3543], "disallowed"], [[3544, 3551], "valid"], [[3552, 3557], "disallowed"], [[3558, 3567], "valid"], [[3568, 3569], "disallowed"], [[3570, 3571], "valid"], [[3572, 3572], "valid", [], "NV8"], [[3573, 3584], "disallowed"], [[3585, 3634], "valid"], [[3635, 3635], "mapped", [3661, 3634]], [[3636, 3642], "valid"], [[3643, 3646], "disallowed"], [[3647, 3647], "valid", [], "NV8"], [[3648, 3662], "valid"], [[3663, 3663], "valid", [], "NV8"], [[3664, 3673], "valid"], [[3674, 3675], "valid", [], "NV8"], [[3676, 3712], "disallowed"], [[3713, 3714], "valid"], [[3715, 3715], "disallowed"], [[3716, 3716], "valid"], [[3717, 3718], "disallowed"], [[3719, 3720], "valid"], [[3721, 3721], "disallowed"], [[3722, 3722], "valid"], [[3723, 3724], "disallowed"], [[3725, 3725], "valid"], [[3726, 3731], "disallowed"], [[3732, 3735], "valid"], [[3736, 3736], "disallowed"], [[3737, 3743], "valid"], [[3744, 3744], "disallowed"], [[3745, 3747], "valid"], [[3748, 3748], "disallowed"], [[3749, 3749], "valid"], [[3750, 3750], "disallowed"], [[3751, 3751], "valid"], [[3752, 3753], "disallowed"], [[3754, 3755], "valid"], [[3756, 3756], "disallowed"], [[3757, 3762], "valid"], [[3763, 3763], "mapped", [3789, 3762]], [[3764, 3769], "valid"], [[3770, 3770], "disallowed"], [[3771, 3773], "valid"], [[3774, 3775], "disallowed"], [[3776, 3780], "valid"], [[3781, 3781], "disallowed"], [[3782, 3782], "valid"], [[3783, 3783], "disallowed"], [[3784, 3789], "valid"], [[3790, 3791], "disallowed"], [[3792, 3801], "valid"], [[3802, 3803], "disallowed"], [[3804, 3804], "mapped", [3755, 3737]], [[3805, 3805], "mapped", [3755, 3745]], [[3806, 3807], "valid"], [[3808, 3839], "disallowed"], [[3840, 3840], "valid"], [[3841, 3850], "valid", [], "NV8"], [[3851, 3851], "valid"], [[3852, 3852], "mapped", [3851]], [[3853, 3863], "valid", [], "NV8"], [[3864, 3865], "valid"], [[3866, 3871], "valid", [], "NV8"], [[3872, 3881], "valid"], [[3882, 3892], "valid", [], "NV8"], [[3893, 3893], "valid"], [[3894, 3894], "valid", [], "NV8"], [[3895, 3895], "valid"], [[3896, 3896], "valid", [], "NV8"], [[3897, 3897], "valid"], [[3898, 3901], "valid", [], "NV8"], [[3902, 3906], "valid"], [[3907, 3907], "mapped", [3906, 4023]], [[3908, 3911], "valid"], [[3912, 3912], "disallowed"], [[3913, 3916], "valid"], [[3917, 3917], "mapped", [3916, 4023]], [[3918, 3921], "valid"], [[3922, 3922], "mapped", [3921, 4023]], [[3923, 3926], "valid"], [[3927, 3927], "mapped", [3926, 4023]], [[3928, 3931], "valid"], [[3932, 3932], "mapped", [3931, 4023]], [[3933, 3944], "valid"], [[3945, 3945], "mapped", [3904, 4021]], [[3946, 3946], "valid"], [[3947, 3948], "valid"], [[3949, 3952], "disallowed"], [[3953, 3954], "valid"], [[3955, 3955], "mapped", [3953, 3954]], [[3956, 3956], "valid"], [[3957, 3957], "mapped", [3953, 3956]], [[3958, 3958], "mapped", [4018, 3968]], [[3959, 3959], "mapped", [4018, 3953, 3968]], [[3960, 3960], "mapped", [4019, 3968]], [[3961, 3961], "mapped", [4019, 3953, 3968]], [[3962, 3968], "valid"], [[3969, 3969], "mapped", [3953, 3968]], [[3970, 3972], "valid"], [[3973, 3973], "valid", [], "NV8"], [[3974, 3979], "valid"], [[3980, 3983], "valid"], [[3984, 3986], "valid"], [[3987, 3987], "mapped", [3986, 4023]], [[3988, 3989], "valid"], [[3990, 3990], "valid"], [[3991, 3991], "valid"], [[3992, 3992], "disallowed"], [[3993, 3996], "valid"], [[3997, 3997], "mapped", [3996, 4023]], [[3998, 4001], "valid"], [[4002, 4002], "mapped", [4001, 4023]], [[4003, 4006], "valid"], [[4007, 4007], "mapped", [4006, 4023]], [[4008, 4011], "valid"], [[4012, 4012], "mapped", [4011, 4023]], [[4013, 4013], "valid"], [[4014, 4016], "valid"], [[4017, 4023], "valid"], [[4024, 4024], "valid"], [[4025, 4025], "mapped", [3984, 4021]], [[4026, 4028], "valid"], [[4029, 4029], "disallowed"], [[4030, 4037], "valid", [], "NV8"], [[4038, 4038], "valid"], [[4039, 4044], "valid", [], "NV8"], [[4045, 4045], "disallowed"], [[4046, 4046], "valid", [], "NV8"], [[4047, 4047], "valid", [], "NV8"], [[4048, 4049], "valid", [], "NV8"], [[4050, 4052], "valid", [], "NV8"], [[4053, 4056], "valid", [], "NV8"], [[4057, 4058], "valid", [], "NV8"], [[4059, 4095], "disallowed"], [[4096, 4129], "valid"], [[4130, 4130], "valid"], [[4131, 4135], "valid"], [[4136, 4136], "valid"], [[4137, 4138], "valid"], [[4139, 4139], "valid"], [[4140, 4146], "valid"], [[4147, 4149], "valid"], [[4150, 4153], "valid"], [[4154, 4159], "valid"], [[4160, 4169], "valid"], [[4170, 4175], "valid", [], "NV8"], [[4176, 4185], "valid"], [[4186, 4249], "valid"], [[4250, 4253], "valid"], [[4254, 4255], "valid", [], "NV8"], [[4256, 4293], "disallowed"], [[4294, 4294], "disallowed"], [[4295, 4295], "mapped", [11559]], [[4296, 4300], "disallowed"], [[4301, 4301], "mapped", [11565]], [[4302, 4303], "disallowed"], [[4304, 4342], "valid"], [[4343, 4344], "valid"], [[4345, 4346], "valid"], [[4347, 4347], "valid", [], "NV8"], [[4348, 4348], "mapped", [4316]], [[4349, 4351], "valid"], [[4352, 4441], "valid", [], "NV8"], [[4442, 4446], "valid", [], "NV8"], [[4447, 4448], "disallowed"], [[4449, 4514], "valid", [], "NV8"], [[4515, 4519], "valid", [], "NV8"], [[4520, 4601], "valid", [], "NV8"], [[4602, 4607], "valid", [], "NV8"], [[4608, 4614], "valid"], [[4615, 4615], "valid"], [[4616, 4678], "valid"], [[4679, 4679], "valid"], [[4680, 4680], "valid"], [[4681, 4681], "disallowed"], [[4682, 4685], "valid"], [[4686, 4687], "disallowed"], [[4688, 4694], "valid"], [[4695, 4695], "disallowed"], [[4696, 4696], "valid"], [[4697, 4697], "disallowed"], [[4698, 4701], "valid"], [[4702, 4703], "disallowed"], [[4704, 4742], "valid"], [[4743, 4743], "valid"], [[4744, 4744], "valid"], [[4745, 4745], "disallowed"], [[4746, 4749], "valid"], [[4750, 4751], "disallowed"], [[4752, 4782], "valid"], [[4783, 4783], "valid"], [[4784, 4784], "valid"], [[4785, 4785], "disallowed"], [[4786, 4789], "valid"], [[4790, 4791], "disallowed"], [[4792, 4798], "valid"], [[4799, 4799], "disallowed"], [[4800, 4800], "valid"], [[4801, 4801], "disallowed"], [[4802, 4805], "valid"], [[4806, 4807], "disallowed"], [[4808, 4814], "valid"], [[4815, 4815], "valid"], [[4816, 4822], "valid"], [[4823, 4823], "disallowed"], [[4824, 4846], "valid"], [[4847, 4847], "valid"], [[4848, 4878], "valid"], [[4879, 4879], "valid"], [[4880, 4880], "valid"], [[4881, 4881], "disallowed"], [[4882, 4885], "valid"], [[4886, 4887], "disallowed"], [[4888, 4894], "valid"], [[4895, 4895], "valid"], [[4896, 4934], "valid"], [[4935, 4935], "valid"], [[4936, 4954], "valid"], [[4955, 4956], "disallowed"], [[4957, 4958], "valid"], [[4959, 4959], "valid"], [[4960, 4960], "valid", [], "NV8"], [[4961, 4988], "valid", [], "NV8"], [[4989, 4991], "disallowed"], [[4992, 5007], "valid"], [[5008, 5017], "valid", [], "NV8"], [[5018, 5023], "disallowed"], [[5024, 5108], "valid"], [[5109, 5109], "valid"], [[5110, 5111], "disallowed"], [[5112, 5112], "mapped", [5104]], [[5113, 5113], "mapped", [5105]], [[5114, 5114], "mapped", [5106]], [[5115, 5115], "mapped", [5107]], [[5116, 5116], "mapped", [5108]], [[5117, 5117], "mapped", [5109]], [[5118, 5119], "disallowed"], [[5120, 5120], "valid", [], "NV8"], [[5121, 5740], "valid"], [[5741, 5742], "valid", [], "NV8"], [[5743, 5750], "valid"], [[5751, 5759], "valid"], [[5760, 5760], "disallowed"], [[5761, 5786], "valid"], [[5787, 5788], "valid", [], "NV8"], [[5789, 5791], "disallowed"], [[5792, 5866], "valid"], [[5867, 5872], "valid", [], "NV8"], [[5873, 5880], "valid"], [[5881, 5887], "disallowed"], [[5888, 5900], "valid"], [[5901, 5901], "disallowed"], [[5902, 5908], "valid"], [[5909, 5919], "disallowed"], [[5920, 5940], "valid"], [[5941, 5942], "valid", [], "NV8"], [[5943, 5951], "disallowed"], [[5952, 5971], "valid"], [[5972, 5983], "disallowed"], [[5984, 5996], "valid"], [[5997, 5997], "disallowed"], [[5998, 6e3], "valid"], [[6001, 6001], "disallowed"], [[6002, 6003], "valid"], [[6004, 6015], "disallowed"], [[6016, 6067], "valid"], [[6068, 6069], "disallowed"], [[6070, 6099], "valid"], [[6100, 6102], "valid", [], "NV8"], [[6103, 6103], "valid"], [[6104, 6107], "valid", [], "NV8"], [[6108, 6108], "valid"], [[6109, 6109], "valid"], [[6110, 6111], "disallowed"], [[6112, 6121], "valid"], [[6122, 6127], "disallowed"], [[6128, 6137], "valid", [], "NV8"], [[6138, 6143], "disallowed"], [[6144, 6149], "valid", [], "NV8"], [[6150, 6150], "disallowed"], [[6151, 6154], "valid", [], "NV8"], [[6155, 6157], "ignored"], [[6158, 6158], "disallowed"], [[6159, 6159], "disallowed"], [[6160, 6169], "valid"], [[6170, 6175], "disallowed"], [[6176, 6263], "valid"], [[6264, 6271], "disallowed"], [[6272, 6313], "valid"], [[6314, 6314], "valid"], [[6315, 6319], "disallowed"], [[6320, 6389], "valid"], [[6390, 6399], "disallowed"], [[6400, 6428], "valid"], [[6429, 6430], "valid"], [[6431, 6431], "disallowed"], [[6432, 6443], "valid"], [[6444, 6447], "disallowed"], [[6448, 6459], "valid"], [[6460, 6463], "disallowed"], [[6464, 6464], "valid", [], "NV8"], [[6465, 6467], "disallowed"], [[6468, 6469], "valid", [], "NV8"], [[6470, 6509], "valid"], [[6510, 6511], "disallowed"], [[6512, 6516], "valid"], [[6517, 6527], "disallowed"], [[6528, 6569], "valid"], [[6570, 6571], "valid"], [[6572, 6575], "disallowed"], [[6576, 6601], "valid"], [[6602, 6607], "disallowed"], [[6608, 6617], "valid"], [[6618, 6618], "valid", [], "XV8"], [[6619, 6621], "disallowed"], [[6622, 6623], "valid", [], "NV8"], [[6624, 6655], "valid", [], "NV8"], [[6656, 6683], "valid"], [[6684, 6685], "disallowed"], [[6686, 6687], "valid", [], "NV8"], [[6688, 6750], "valid"], [[6751, 6751], "disallowed"], [[6752, 6780], "valid"], [[6781, 6782], "disallowed"], [[6783, 6793], "valid"], [[6794, 6799], "disallowed"], [[6800, 6809], "valid"], [[6810, 6815], "disallowed"], [[6816, 6822], "valid", [], "NV8"], [[6823, 6823], "valid"], [[6824, 6829], "valid", [], "NV8"], [[6830, 6831], "disallowed"], [[6832, 6845], "valid"], [[6846, 6846], "valid", [], "NV8"], [[6847, 6911], "disallowed"], [[6912, 6987], "valid"], [[6988, 6991], "disallowed"], [[6992, 7001], "valid"], [[7002, 7018], "valid", [], "NV8"], [[7019, 7027], "valid"], [[7028, 7036], "valid", [], "NV8"], [[7037, 7039], "disallowed"], [[7040, 7082], "valid"], [[7083, 7085], "valid"], [[7086, 7097], "valid"], [[7098, 7103], "valid"], [[7104, 7155], "valid"], [[7156, 7163], "disallowed"], [[7164, 7167], "valid", [], "NV8"], [[7168, 7223], "valid"], [[7224, 7226], "disallowed"], [[7227, 7231], "valid", [], "NV8"], [[7232, 7241], "valid"], [[7242, 7244], "disallowed"], [[7245, 7293], "valid"], [[7294, 7295], "valid", [], "NV8"], [[7296, 7359], "disallowed"], [[7360, 7367], "valid", [], "NV8"], [[7368, 7375], "disallowed"], [[7376, 7378], "valid"], [[7379, 7379], "valid", [], "NV8"], [[7380, 7410], "valid"], [[7411, 7414], "valid"], [[7415, 7415], "disallowed"], [[7416, 7417], "valid"], [[7418, 7423], "disallowed"], [[7424, 7467], "valid"], [[7468, 7468], "mapped", [97]], [[7469, 7469], "mapped", [230]], [[7470, 7470], "mapped", [98]], [[7471, 7471], "valid"], [[7472, 7472], "mapped", [100]], [[7473, 7473], "mapped", [101]], [[7474, 7474], "mapped", [477]], [[7475, 7475], "mapped", [103]], [[7476, 7476], "mapped", [104]], [[7477, 7477], "mapped", [105]], [[7478, 7478], "mapped", [106]], [[7479, 7479], "mapped", [107]], [[7480, 7480], "mapped", [108]], [[7481, 7481], "mapped", [109]], [[7482, 7482], "mapped", [110]], [[7483, 7483], "valid"], [[7484, 7484], "mapped", [111]], [[7485, 7485], "mapped", [547]], [[7486, 7486], "mapped", [112]], [[7487, 7487], "mapped", [114]], [[7488, 7488], "mapped", [116]], [[7489, 7489], "mapped", [117]], [[7490, 7490], "mapped", [119]], [[7491, 7491], "mapped", [97]], [[7492, 7492], "mapped", [592]], [[7493, 7493], "mapped", [593]], [[7494, 7494], "mapped", [7426]], [[7495, 7495], "mapped", [98]], [[7496, 7496], "mapped", [100]], [[7497, 7497], "mapped", [101]], [[7498, 7498], "mapped", [601]], [[7499, 7499], "mapped", [603]], [[7500, 7500], "mapped", [604]], [[7501, 7501], "mapped", [103]], [[7502, 7502], "valid"], [[7503, 7503], "mapped", [107]], [[7504, 7504], "mapped", [109]], [[7505, 7505], "mapped", [331]], [[7506, 7506], "mapped", [111]], [[7507, 7507], "mapped", [596]], [[7508, 7508], "mapped", [7446]], [[7509, 7509], "mapped", [7447]], [[7510, 7510], "mapped", [112]], [[7511, 7511], "mapped", [116]], [[7512, 7512], "mapped", [117]], [[7513, 7513], "mapped", [7453]], [[7514, 7514], "mapped", [623]], [[7515, 7515], "mapped", [118]], [[7516, 7516], "mapped", [7461]], [[7517, 7517], "mapped", [946]], [[7518, 7518], "mapped", [947]], [[7519, 7519], "mapped", [948]], [[7520, 7520], "mapped", [966]], [[7521, 7521], "mapped", [967]], [[7522, 7522], "mapped", [105]], [[7523, 7523], "mapped", [114]], [[7524, 7524], "mapped", [117]], [[7525, 7525], "mapped", [118]], [[7526, 7526], "mapped", [946]], [[7527, 7527], "mapped", [947]], [[7528, 7528], "mapped", [961]], [[7529, 7529], "mapped", [966]], [[7530, 7530], "mapped", [967]], [[7531, 7531], "valid"], [[7532, 7543], "valid"], [[7544, 7544], "mapped", [1085]], [[7545, 7578], "valid"], [[7579, 7579], "mapped", [594]], [[7580, 7580], "mapped", [99]], [[7581, 7581], "mapped", [597]], [[7582, 7582], "mapped", [240]], [[7583, 7583], "mapped", [604]], [[7584, 7584], "mapped", [102]], [[7585, 7585], "mapped", [607]], [[7586, 7586], "mapped", [609]], [[7587, 7587], "mapped", [613]], [[7588, 7588], "mapped", [616]], [[7589, 7589], "mapped", [617]], [[7590, 7590], "mapped", [618]], [[7591, 7591], "mapped", [7547]], [[7592, 7592], "mapped", [669]], [[7593, 7593], "mapped", [621]], [[7594, 7594], "mapped", [7557]], [[7595, 7595], "mapped", [671]], [[7596, 7596], "mapped", [625]], [[7597, 7597], "mapped", [624]], [[7598, 7598], "mapped", [626]], [[7599, 7599], "mapped", [627]], [[7600, 7600], "mapped", [628]], [[7601, 7601], "mapped", [629]], [[7602, 7602], "mapped", [632]], [[7603, 7603], "mapped", [642]], [[7604, 7604], "mapped", [643]], [[7605, 7605], "mapped", [427]], [[7606, 7606], "mapped", [649]], [[7607, 7607], "mapped", [650]], [[7608, 7608], "mapped", [7452]], [[7609, 7609], "mapped", [651]], [[7610, 7610], "mapped", [652]], [[7611, 7611], "mapped", [122]], [[7612, 7612], "mapped", [656]], [[7613, 7613], "mapped", [657]], [[7614, 7614], "mapped", [658]], [[7615, 7615], "mapped", [952]], [[7616, 7619], "valid"], [[7620, 7626], "valid"], [[7627, 7654], "valid"], [[7655, 7669], "valid"], [[7670, 7675], "disallowed"], [[7676, 7676], "valid"], [[7677, 7677], "valid"], [[7678, 7679], "valid"], [[7680, 7680], "mapped", [7681]], [[7681, 7681], "valid"], [[7682, 7682], "mapped", [7683]], [[7683, 7683], "valid"], [[7684, 7684], "mapped", [7685]], [[7685, 7685], "valid"], [[7686, 7686], "mapped", [7687]], [[7687, 7687], "valid"], [[7688, 7688], "mapped", [7689]], [[7689, 7689], "valid"], [[7690, 7690], "mapped", [7691]], [[7691, 7691], "valid"], [[7692, 7692], "mapped", [7693]], [[7693, 7693], "valid"], [[7694, 7694], "mapped", [7695]], [[7695, 7695], "valid"], [[7696, 7696], "mapped", [7697]], [[7697, 7697], "valid"], [[7698, 7698], "mapped", [7699]], [[7699, 7699], "valid"], [[7700, 7700], "mapped", [7701]], [[7701, 7701], "valid"], [[7702, 7702], "mapped", [7703]], [[7703, 7703], "valid"], [[7704, 7704], "mapped", [7705]], [[7705, 7705], "valid"], [[7706, 7706], "mapped", [7707]], [[7707, 7707], "valid"], [[7708, 7708], "mapped", [7709]], [[7709, 7709], "valid"], [[7710, 7710], "mapped", [7711]], [[7711, 7711], "valid"], [[7712, 7712], "mapped", [7713]], [[7713, 7713], "valid"], [[7714, 7714], "mapped", [7715]], [[7715, 7715], "valid"], [[7716, 7716], "mapped", [7717]], [[7717, 7717], "valid"], [[7718, 7718], "mapped", [7719]], [[7719, 7719], "valid"], [[7720, 7720], "mapped", [7721]], [[7721, 7721], "valid"], [[7722, 7722], "mapped", [7723]], [[7723, 7723], "valid"], [[7724, 7724], "mapped", [7725]], [[7725, 7725], "valid"], [[7726, 7726], "mapped", [7727]], [[7727, 7727], "valid"], [[7728, 7728], "mapped", [7729]], [[7729, 7729], "valid"], [[7730, 7730], "mapped", [7731]], [[7731, 7731], "valid"], [[7732, 7732], "mapped", [7733]], [[7733, 7733], "valid"], [[7734, 7734], "mapped", [7735]], [[7735, 7735], "valid"], [[7736, 7736], "mapped", [7737]], [[7737, 7737], "valid"], [[7738, 7738], "mapped", [7739]], [[7739, 7739], "valid"], [[7740, 7740], "mapped", [7741]], [[7741, 7741], "valid"], [[7742, 7742], "mapped", [7743]], [[7743, 7743], "valid"], [[7744, 7744], "mapped", [7745]], [[7745, 7745], "valid"], [[7746, 7746], "mapped", [7747]], [[7747, 7747], "valid"], [[7748, 7748], "mapped", [7749]], [[7749, 7749], "valid"], [[7750, 7750], "mapped", [7751]], [[7751, 7751], "valid"], [[7752, 7752], "mapped", [7753]], [[7753, 7753], "valid"], [[7754, 7754], "mapped", [7755]], [[7755, 7755], "valid"], [[7756, 7756], "mapped", [7757]], [[7757, 7757], "valid"], [[7758, 7758], "mapped", [7759]], [[7759, 7759], "valid"], [[7760, 7760], "mapped", [7761]], [[7761, 7761], "valid"], [[7762, 7762], "mapped", [7763]], [[7763, 7763], "valid"], [[7764, 7764], "mapped", [7765]], [[7765, 7765], "valid"], [[7766, 7766], "mapped", [7767]], [[7767, 7767], "valid"], [[7768, 7768], "mapped", [7769]], [[7769, 7769], "valid"], [[7770, 7770], "mapped", [7771]], [[7771, 7771], "valid"], [[7772, 7772], "mapped", [7773]], [[7773, 7773], "valid"], [[7774, 7774], "mapped", [7775]], [[7775, 7775], "valid"], [[7776, 7776], "mapped", [7777]], [[7777, 7777], "valid"], [[7778, 7778], "mapped", [7779]], [[7779, 7779], "valid"], [[7780, 7780], "mapped", [7781]], [[7781, 7781], "valid"], [[7782, 7782], "mapped", [7783]], [[7783, 7783], "valid"], [[7784, 7784], "mapped", [7785]], [[7785, 7785], "valid"], [[7786, 7786], "mapped", [7787]], [[7787, 7787], "valid"], [[7788, 7788], "mapped", [7789]], [[7789, 7789], "valid"], [[7790, 7790], "mapped", [7791]], [[7791, 7791], "valid"], [[7792, 7792], "mapped", [7793]], [[7793, 7793], "valid"], [[7794, 7794], "mapped", [7795]], [[7795, 7795], "valid"], [[7796, 7796], "mapped", [7797]], [[7797, 7797], "valid"], [[7798, 7798], "mapped", [7799]], [[7799, 7799], "valid"], [[7800, 7800], "mapped", [7801]], [[7801, 7801], "valid"], [[7802, 7802], "mapped", [7803]], [[7803, 7803], "valid"], [[7804, 7804], "mapped", [7805]], [[7805, 7805], "valid"], [[7806, 7806], "mapped", [7807]], [[7807, 7807], "valid"], [[7808, 7808], "mapped", [7809]], [[7809, 7809], "valid"], [[7810, 7810], "mapped", [7811]], [[7811, 7811], "valid"], [[7812, 7812], "mapped", [7813]], [[7813, 7813], "valid"], [[7814, 7814], "mapped", [7815]], [[7815, 7815], "valid"], [[7816, 7816], "mapped", [7817]], [[7817, 7817], "valid"], [[7818, 7818], "mapped", [7819]], [[7819, 7819], "valid"], [[7820, 7820], "mapped", [7821]], [[7821, 7821], "valid"], [[7822, 7822], "mapped", [7823]], [[7823, 7823], "valid"], [[7824, 7824], "mapped", [7825]], [[7825, 7825], "valid"], [[7826, 7826], "mapped", [7827]], [[7827, 7827], "valid"], [[7828, 7828], "mapped", [7829]], [[7829, 7833], "valid"], [[7834, 7834], "mapped", [97, 702]], [[7835, 7835], "mapped", [7777]], [[7836, 7837], "valid"], [[7838, 7838], "mapped", [115, 115]], [[7839, 7839], "valid"], [[7840, 7840], "mapped", [7841]], [[7841, 7841], "valid"], [[7842, 7842], "mapped", [7843]], [[7843, 7843], "valid"], [[7844, 7844], "mapped", [7845]], [[7845, 7845], "valid"], [[7846, 7846], "mapped", [7847]], [[7847, 7847], "valid"], [[7848, 7848], "mapped", [7849]], [[7849, 7849], "valid"], [[7850, 7850], "mapped", [7851]], [[7851, 7851], "valid"], [[7852, 7852], "mapped", [7853]], [[7853, 7853], "valid"], [[7854, 7854], "mapped", [7855]], [[7855, 7855], "valid"], [[7856, 7856], "mapped", [7857]], [[7857, 7857], "valid"], [[7858, 7858], "mapped", [7859]], [[7859, 7859], "valid"], [[7860, 7860], "mapped", [7861]], [[7861, 7861], "valid"], [[7862, 7862], "mapped", [7863]], [[7863, 7863], "valid"], [[7864, 7864], "mapped", [7865]], [[7865, 7865], "valid"], [[7866, 7866], "mapped", [7867]], [[7867, 7867], "valid"], [[7868, 7868], "mapped", [7869]], [[7869, 7869], "valid"], [[7870, 7870], "mapped", [7871]], [[7871, 7871], "valid"], [[7872, 7872], "mapped", [7873]], [[7873, 7873], "valid"], [[7874, 7874], "mapped", [7875]], [[7875, 7875], "valid"], [[7876, 7876], "mapped", [7877]], [[7877, 7877], "valid"], [[7878, 7878], "mapped", [7879]], [[7879, 7879], "valid"], [[7880, 7880], "mapped", [7881]], [[7881, 7881], "valid"], [[7882, 7882], "mapped", [7883]], [[7883, 7883], "valid"], [[7884, 7884], "mapped", [7885]], [[7885, 7885], "valid"], [[7886, 7886], "mapped", [7887]], [[7887, 7887], "valid"], [[7888, 7888], "mapped", [7889]], [[7889, 7889], "valid"], [[7890, 7890], "mapped", [7891]], [[7891, 7891], "valid"], [[7892, 7892], "mapped", [7893]], [[7893, 7893], "valid"], [[7894, 7894], "mapped", [7895]], [[7895, 7895], "valid"], [[7896, 7896], "mapped", [7897]], [[7897, 7897], "valid"], [[7898, 7898], "mapped", [7899]], [[7899, 7899], "valid"], [[7900, 7900], "mapped", [7901]], [[7901, 7901], "valid"], [[7902, 7902], "mapped", [7903]], [[7903, 7903], "valid"], [[7904, 7904], "mapped", [7905]], [[7905, 7905], "valid"], [[7906, 7906], "mapped", [7907]], [[7907, 7907], "valid"], [[7908, 7908], "mapped", [7909]], [[7909, 7909], "valid"], [[7910, 7910], "mapped", [7911]], [[7911, 7911], "valid"], [[7912, 7912], "mapped", [7913]], [[7913, 7913], "valid"], [[7914, 7914], "mapped", [7915]], [[7915, 7915], "valid"], [[7916, 7916], "mapped", [7917]], [[7917, 7917], "valid"], [[7918, 7918], "mapped", [7919]], [[7919, 7919], "valid"], [[7920, 7920], "mapped", [7921]], [[7921, 7921], "valid"], [[7922, 7922], "mapped", [7923]], [[7923, 7923], "valid"], [[7924, 7924], "mapped", [7925]], [[7925, 7925], "valid"], [[7926, 7926], "mapped", [7927]], [[7927, 7927], "valid"], [[7928, 7928], "mapped", [7929]], [[7929, 7929], "valid"], [[7930, 7930], "mapped", [7931]], [[7931, 7931], "valid"], [[7932, 7932], "mapped", [7933]], [[7933, 7933], "valid"], [[7934, 7934], "mapped", [7935]], [[7935, 7935], "valid"], [[7936, 7943], "valid"], [[7944, 7944], "mapped", [7936]], [[7945, 7945], "mapped", [7937]], [[7946, 7946], "mapped", [7938]], [[7947, 7947], "mapped", [7939]], [[7948, 7948], "mapped", [7940]], [[7949, 7949], "mapped", [7941]], [[7950, 7950], "mapped", [7942]], [[7951, 7951], "mapped", [7943]], [[7952, 7957], "valid"], [[7958, 7959], "disallowed"], [[7960, 7960], "mapped", [7952]], [[7961, 7961], "mapped", [7953]], [[7962, 7962], "mapped", [7954]], [[7963, 7963], "mapped", [7955]], [[7964, 7964], "mapped", [7956]], [[7965, 7965], "mapped", [7957]], [[7966, 7967], "disallowed"], [[7968, 7975], "valid"], [[7976, 7976], "mapped", [7968]], [[7977, 7977], "mapped", [7969]], [[7978, 7978], "mapped", [7970]], [[7979, 7979], "mapped", [7971]], [[7980, 7980], "mapped", [7972]], [[7981, 7981], "mapped", [7973]], [[7982, 7982], "mapped", [7974]], [[7983, 7983], "mapped", [7975]], [[7984, 7991], "valid"], [[7992, 7992], "mapped", [7984]], [[7993, 7993], "mapped", [7985]], [[7994, 7994], "mapped", [7986]], [[7995, 7995], "mapped", [7987]], [[7996, 7996], "mapped", [7988]], [[7997, 7997], "mapped", [7989]], [[7998, 7998], "mapped", [7990]], [[7999, 7999], "mapped", [7991]], [[8e3, 8005], "valid"], [[8006, 8007], "disallowed"], [[8008, 8008], "mapped", [8e3]], [[8009, 8009], "mapped", [8001]], [[8010, 8010], "mapped", [8002]], [[8011, 8011], "mapped", [8003]], [[8012, 8012], "mapped", [8004]], [[8013, 8013], "mapped", [8005]], [[8014, 8015], "disallowed"], [[8016, 8023], "valid"], [[8024, 8024], "disallowed"], [[8025, 8025], "mapped", [8017]], [[8026, 8026], "disallowed"], [[8027, 8027], "mapped", [8019]], [[8028, 8028], "disallowed"], [[8029, 8029], "mapped", [8021]], [[8030, 8030], "disallowed"], [[8031, 8031], "mapped", [8023]], [[8032, 8039], "valid"], [[8040, 8040], "mapped", [8032]], [[8041, 8041], "mapped", [8033]], [[8042, 8042], "mapped", [8034]], [[8043, 8043], "mapped", [8035]], [[8044, 8044], "mapped", [8036]], [[8045, 8045], "mapped", [8037]], [[8046, 8046], "mapped", [8038]], [[8047, 8047], "mapped", [8039]], [[8048, 8048], "valid"], [[8049, 8049], "mapped", [940]], [[8050, 8050], "valid"], [[8051, 8051], "mapped", [941]], [[8052, 8052], "valid"], [[8053, 8053], "mapped", [942]], [[8054, 8054], "valid"], [[8055, 8055], "mapped", [943]], [[8056, 8056], "valid"], [[8057, 8057], "mapped", [972]], [[8058, 8058], "valid"], [[8059, 8059], "mapped", [973]], [[8060, 8060], "valid"], [[8061, 8061], "mapped", [974]], [[8062, 8063], "disallowed"], [[8064, 8064], "mapped", [7936, 953]], [[8065, 8065], "mapped", [7937, 953]], [[8066, 8066], "mapped", [7938, 953]], [[8067, 8067], "mapped", [7939, 953]], [[8068, 8068], "mapped", [7940, 953]], [[8069, 8069], "mapped", [7941, 953]], [[8070, 8070], "mapped", [7942, 953]], [[8071, 8071], "mapped", [7943, 953]], [[8072, 8072], "mapped", [7936, 953]], [[8073, 8073], "mapped", [7937, 953]], [[8074, 8074], "mapped", [7938, 953]], [[8075, 8075], "mapped", [7939, 953]], [[8076, 8076], "mapped", [7940, 953]], [[8077, 8077], "mapped", [7941, 953]], [[8078, 8078], "mapped", [7942, 953]], [[8079, 8079], "mapped", [7943, 953]], [[8080, 8080], "mapped", [7968, 953]], [[8081, 8081], "mapped", [7969, 953]], [[8082, 8082], "mapped", [7970, 953]], [[8083, 8083], "mapped", [7971, 953]], [[8084, 8084], "mapped", [7972, 953]], [[8085, 8085], "mapped", [7973, 953]], [[8086, 8086], "mapped", [7974, 953]], [[8087, 8087], "mapped", [7975, 953]], [[8088, 8088], "mapped", [7968, 953]], [[8089, 8089], "mapped", [7969, 953]], [[8090, 8090], "mapped", [7970, 953]], [[8091, 8091], "mapped", [7971, 953]], [[8092, 8092], "mapped", [7972, 953]], [[8093, 8093], "mapped", [7973, 953]], [[8094, 8094], "mapped", [7974, 953]], [[8095, 8095], "mapped", [7975, 953]], [[8096, 8096], "mapped", [8032, 953]], [[8097, 8097], "mapped", [8033, 953]], [[8098, 8098], "mapped", [8034, 953]], [[8099, 8099], "mapped", [8035, 953]], [[8100, 8100], "mapped", [8036, 953]], [[8101, 8101], "mapped", [8037, 953]], [[8102, 8102], "mapped", [8038, 953]], [[8103, 8103], "mapped", [8039, 953]], [[8104, 8104], "mapped", [8032, 953]], [[8105, 8105], "mapped", [8033, 953]], [[8106, 8106], "mapped", [8034, 953]], [[8107, 8107], "mapped", [8035, 953]], [[8108, 8108], "mapped", [8036, 953]], [[8109, 8109], "mapped", [8037, 953]], [[8110, 8110], "mapped", [8038, 953]], [[8111, 8111], "mapped", [8039, 953]], [[8112, 8113], "valid"], [[8114, 8114], "mapped", [8048, 953]], [[8115, 8115], "mapped", [945, 953]], [[8116, 8116], "mapped", [940, 953]], [[8117, 8117], "disallowed"], [[8118, 8118], "valid"], [[8119, 8119], "mapped", [8118, 953]], [[8120, 8120], "mapped", [8112]], [[8121, 8121], "mapped", [8113]], [[8122, 8122], "mapped", [8048]], [[8123, 8123], "mapped", [940]], [[8124, 8124], "mapped", [945, 953]], [[8125, 8125], "disallowed_STD3_mapped", [32, 787]], [[8126, 8126], "mapped", [953]], [[8127, 8127], "disallowed_STD3_mapped", [32, 787]], [[8128, 8128], "disallowed_STD3_mapped", [32, 834]], [[8129, 8129], "disallowed_STD3_mapped", [32, 776, 834]], [[8130, 8130], "mapped", [8052, 953]], [[8131, 8131], "mapped", [951, 953]], [[8132, 8132], "mapped", [942, 953]], [[8133, 8133], "disallowed"], [[8134, 8134], "valid"], [[8135, 8135], "mapped", [8134, 953]], [[8136, 8136], "mapped", [8050]], [[8137, 8137], "mapped", [941]], [[8138, 8138], "mapped", [8052]], [[8139, 8139], "mapped", [942]], [[8140, 8140], "mapped", [951, 953]], [[8141, 8141], "disallowed_STD3_mapped", [32, 787, 768]], [[8142, 8142], "disallowed_STD3_mapped", [32, 787, 769]], [[8143, 8143], "disallowed_STD3_mapped", [32, 787, 834]], [[8144, 8146], "valid"], [[8147, 8147], "mapped", [912]], [[8148, 8149], "disallowed"], [[8150, 8151], "valid"], [[8152, 8152], "mapped", [8144]], [[8153, 8153], "mapped", [8145]], [[8154, 8154], "mapped", [8054]], [[8155, 8155], "mapped", [943]], [[8156, 8156], "disallowed"], [[8157, 8157], "disallowed_STD3_mapped", [32, 788, 768]], [[8158, 8158], "disallowed_STD3_mapped", [32, 788, 769]], [[8159, 8159], "disallowed_STD3_mapped", [32, 788, 834]], [[8160, 8162], "valid"], [[8163, 8163], "mapped", [944]], [[8164, 8167], "valid"], [[8168, 8168], "mapped", [8160]], [[8169, 8169], "mapped", [8161]], [[8170, 8170], "mapped", [8058]], [[8171, 8171], "mapped", [973]], [[8172, 8172], "mapped", [8165]], [[8173, 8173], "disallowed_STD3_mapped", [32, 776, 768]], [[8174, 8174], "disallowed_STD3_mapped", [32, 776, 769]], [[8175, 8175], "disallowed_STD3_mapped", [96]], [[8176, 8177], "disallowed"], [[8178, 8178], "mapped", [8060, 953]], [[8179, 8179], "mapped", [969, 953]], [[8180, 8180], "mapped", [974, 953]], [[8181, 8181], "disallowed"], [[8182, 8182], "valid"], [[8183, 8183], "mapped", [8182, 953]], [[8184, 8184], "mapped", [8056]], [[8185, 8185], "mapped", [972]], [[8186, 8186], "mapped", [8060]], [[8187, 8187], "mapped", [974]], [[8188, 8188], "mapped", [969, 953]], [[8189, 8189], "disallowed_STD3_mapped", [32, 769]], [[8190, 8190], "disallowed_STD3_mapped", [32, 788]], [[8191, 8191], "disallowed"], [[8192, 8202], "disallowed_STD3_mapped", [32]], [[8203, 8203], "ignored"], [[8204, 8205], "deviation", []], [[8206, 8207], "disallowed"], [[8208, 8208], "valid", [], "NV8"], [[8209, 8209], "mapped", [8208]], [[8210, 8214], "valid", [], "NV8"], [[8215, 8215], "disallowed_STD3_mapped", [32, 819]], [[8216, 8227], "valid", [], "NV8"], [[8228, 8230], "disallowed"], [[8231, 8231], "valid", [], "NV8"], [[8232, 8238], "disallowed"], [[8239, 8239], "disallowed_STD3_mapped", [32]], [[8240, 8242], "valid", [], "NV8"], [[8243, 8243], "mapped", [8242, 8242]], [[8244, 8244], "mapped", [8242, 8242, 8242]], [[8245, 8245], "valid", [], "NV8"], [[8246, 8246], "mapped", [8245, 8245]], [[8247, 8247], "mapped", [8245, 8245, 8245]], [[8248, 8251], "valid", [], "NV8"], [[8252, 8252], "disallowed_STD3_mapped", [33, 33]], [[8253, 8253], "valid", [], "NV8"], [[8254, 8254], "disallowed_STD3_mapped", [32, 773]], [[8255, 8262], "valid", [], "NV8"], [[8263, 8263], "disallowed_STD3_mapped", [63, 63]], [[8264, 8264], "disallowed_STD3_mapped", [63, 33]], [[8265, 8265], "disallowed_STD3_mapped", [33, 63]], [[8266, 8269], "valid", [], "NV8"], [[8270, 8274], "valid", [], "NV8"], [[8275, 8276], "valid", [], "NV8"], [[8277, 8278], "valid", [], "NV8"], [[8279, 8279], "mapped", [8242, 8242, 8242, 8242]], [[8280, 8286], "valid", [], "NV8"], [[8287, 8287], "disallowed_STD3_mapped", [32]], [[8288, 8288], "ignored"], [[8289, 8291], "disallowed"], [[8292, 8292], "ignored"], [[8293, 8293], "disallowed"], [[8294, 8297], "disallowed"], [[8298, 8303], "disallowed"], [[8304, 8304], "mapped", [48]], [[8305, 8305], "mapped", [105]], [[8306, 8307], "disallowed"], [[8308, 8308], "mapped", [52]], [[8309, 8309], "mapped", [53]], [[8310, 8310], "mapped", [54]], [[8311, 8311], "mapped", [55]], [[8312, 8312], "mapped", [56]], [[8313, 8313], "mapped", [57]], [[8314, 8314], "disallowed_STD3_mapped", [43]], [[8315, 8315], "mapped", [8722]], [[8316, 8316], "disallowed_STD3_mapped", [61]], [[8317, 8317], "disallowed_STD3_mapped", [40]], [[8318, 8318], "disallowed_STD3_mapped", [41]], [[8319, 8319], "mapped", [110]], [[8320, 8320], "mapped", [48]], [[8321, 8321], "mapped", [49]], [[8322, 8322], "mapped", [50]], [[8323, 8323], "mapped", [51]], [[8324, 8324], "mapped", [52]], [[8325, 8325], "mapped", [53]], [[8326, 8326], "mapped", [54]], [[8327, 8327], "mapped", [55]], [[8328, 8328], "mapped", [56]], [[8329, 8329], "mapped", [57]], [[8330, 8330], "disallowed_STD3_mapped", [43]], [[8331, 8331], "mapped", [8722]], [[8332, 8332], "disallowed_STD3_mapped", [61]], [[8333, 8333], "disallowed_STD3_mapped", [40]], [[8334, 8334], "disallowed_STD3_mapped", [41]], [[8335, 8335], "disallowed"], [[8336, 8336], "mapped", [97]], [[8337, 8337], "mapped", [101]], [[8338, 8338], "mapped", [111]], [[8339, 8339], "mapped", [120]], [[8340, 8340], "mapped", [601]], [[8341, 8341], "mapped", [104]], [[8342, 8342], "mapped", [107]], [[8343, 8343], "mapped", [108]], [[8344, 8344], "mapped", [109]], [[8345, 8345], "mapped", [110]], [[8346, 8346], "mapped", [112]], [[8347, 8347], "mapped", [115]], [[8348, 8348], "mapped", [116]], [[8349, 8351], "disallowed"], [[8352, 8359], "valid", [], "NV8"], [[8360, 8360], "mapped", [114, 115]], [[8361, 8362], "valid", [], "NV8"], [[8363, 8363], "valid", [], "NV8"], [[8364, 8364], "valid", [], "NV8"], [[8365, 8367], "valid", [], "NV8"], [[8368, 8369], "valid", [], "NV8"], [[8370, 8373], "valid", [], "NV8"], [[8374, 8376], "valid", [], "NV8"], [[8377, 8377], "valid", [], "NV8"], [[8378, 8378], "valid", [], "NV8"], [[8379, 8381], "valid", [], "NV8"], [[8382, 8382], "valid", [], "NV8"], [[8383, 8399], "disallowed"], [[8400, 8417], "valid", [], "NV8"], [[8418, 8419], "valid", [], "NV8"], [[8420, 8426], "valid", [], "NV8"], [[8427, 8427], "valid", [], "NV8"], [[8428, 8431], "valid", [], "NV8"], [[8432, 8432], "valid", [], "NV8"], [[8433, 8447], "disallowed"], [[8448, 8448], "disallowed_STD3_mapped", [97, 47, 99]], [[8449, 8449], "disallowed_STD3_mapped", [97, 47, 115]], [[8450, 8450], "mapped", [99]], [[8451, 8451], "mapped", [176, 99]], [[8452, 8452], "valid", [], "NV8"], [[8453, 8453], "disallowed_STD3_mapped", [99, 47, 111]], [[8454, 8454], "disallowed_STD3_mapped", [99, 47, 117]], [[8455, 8455], "mapped", [603]], [[8456, 8456], "valid", [], "NV8"], [[8457, 8457], "mapped", [176, 102]], [[8458, 8458], "mapped", [103]], [[8459, 8462], "mapped", [104]], [[8463, 8463], "mapped", [295]], [[8464, 8465], "mapped", [105]], [[8466, 8467], "mapped", [108]], [[8468, 8468], "valid", [], "NV8"], [[8469, 8469], "mapped", [110]], [[8470, 8470], "mapped", [110, 111]], [[8471, 8472], "valid", [], "NV8"], [[8473, 8473], "mapped", [112]], [[8474, 8474], "mapped", [113]], [[8475, 8477], "mapped", [114]], [[8478, 8479], "valid", [], "NV8"], [[8480, 8480], "mapped", [115, 109]], [[8481, 8481], "mapped", [116, 101, 108]], [[8482, 8482], "mapped", [116, 109]], [[8483, 8483], "valid", [], "NV8"], [[8484, 8484], "mapped", [122]], [[8485, 8485], "valid", [], "NV8"], [[8486, 8486], "mapped", [969]], [[8487, 8487], "valid", [], "NV8"], [[8488, 8488], "mapped", [122]], [[8489, 8489], "valid", [], "NV8"], [[8490, 8490], "mapped", [107]], [[8491, 8491], "mapped", [229]], [[8492, 8492], "mapped", [98]], [[8493, 8493], "mapped", [99]], [[8494, 8494], "valid", [], "NV8"], [[8495, 8496], "mapped", [101]], [[8497, 8497], "mapped", [102]], [[8498, 8498], "disallowed"], [[8499, 8499], "mapped", [109]], [[8500, 8500], "mapped", [111]], [[8501, 8501], "mapped", [1488]], [[8502, 8502], "mapped", [1489]], [[8503, 8503], "mapped", [1490]], [[8504, 8504], "mapped", [1491]], [[8505, 8505], "mapped", [105]], [[8506, 8506], "valid", [], "NV8"], [[8507, 8507], "mapped", [102, 97, 120]], [[8508, 8508], "mapped", [960]], [[8509, 8510], "mapped", [947]], [[8511, 8511], "mapped", [960]], [[8512, 8512], "mapped", [8721]], [[8513, 8516], "valid", [], "NV8"], [[8517, 8518], "mapped", [100]], [[8519, 8519], "mapped", [101]], [[8520, 8520], "mapped", [105]], [[8521, 8521], "mapped", [106]], [[8522, 8523], "valid", [], "NV8"], [[8524, 8524], "valid", [], "NV8"], [[8525, 8525], "valid", [], "NV8"], [[8526, 8526], "valid"], [[8527, 8527], "valid", [], "NV8"], [[8528, 8528], "mapped", [49, 8260, 55]], [[8529, 8529], "mapped", [49, 8260, 57]], [[8530, 8530], "mapped", [49, 8260, 49, 48]], [[8531, 8531], "mapped", [49, 8260, 51]], [[8532, 8532], "mapped", [50, 8260, 51]], [[8533, 8533], "mapped", [49, 8260, 53]], [[8534, 8534], "mapped", [50, 8260, 53]], [[8535, 8535], "mapped", [51, 8260, 53]], [[8536, 8536], "mapped", [52, 8260, 53]], [[8537, 8537], "mapped", [49, 8260, 54]], [[8538, 8538], "mapped", [53, 8260, 54]], [[8539, 8539], "mapped", [49, 8260, 56]], [[8540, 8540], "mapped", [51, 8260, 56]], [[8541, 8541], "mapped", [53, 8260, 56]], [[8542, 8542], "mapped", [55, 8260, 56]], [[8543, 8543], "mapped", [49, 8260]], [[8544, 8544], "mapped", [105]], [[8545, 8545], "mapped", [105, 105]], [[8546, 8546], "mapped", [105, 105, 105]], [[8547, 8547], "mapped", [105, 118]], [[8548, 8548], "mapped", [118]], [[8549, 8549], "mapped", [118, 105]], [[8550, 8550], "mapped", [118, 105, 105]], [[8551, 8551], "mapped", [118, 105, 105, 105]], [[8552, 8552], "mapped", [105, 120]], [[8553, 8553], "mapped", [120]], [[8554, 8554], "mapped", [120, 105]], [[8555, 8555], "mapped", [120, 105, 105]], [[8556, 8556], "mapped", [108]], [[8557, 8557], "mapped", [99]], [[8558, 8558], "mapped", [100]], [[8559, 8559], "mapped", [109]], [[8560, 8560], "mapped", [105]], [[8561, 8561], "mapped", [105, 105]], [[8562, 8562], "mapped", [105, 105, 105]], [[8563, 8563], "mapped", [105, 118]], [[8564, 8564], "mapped", [118]], [[8565, 8565], "mapped", [118, 105]], [[8566, 8566], "mapped", [118, 105, 105]], [[8567, 8567], "mapped", [118, 105, 105, 105]], [[8568, 8568], "mapped", [105, 120]], [[8569, 8569], "mapped", [120]], [[8570, 8570], "mapped", [120, 105]], [[8571, 8571], "mapped", [120, 105, 105]], [[8572, 8572], "mapped", [108]], [[8573, 8573], "mapped", [99]], [[8574, 8574], "mapped", [100]], [[8575, 8575], "mapped", [109]], [[8576, 8578], "valid", [], "NV8"], [[8579, 8579], "disallowed"], [[8580, 8580], "valid"], [[8581, 8584], "valid", [], "NV8"], [[8585, 8585], "mapped", [48, 8260, 51]], [[8586, 8587], "valid", [], "NV8"], [[8588, 8591], "disallowed"], [[8592, 8682], "valid", [], "NV8"], [[8683, 8691], "valid", [], "NV8"], [[8692, 8703], "valid", [], "NV8"], [[8704, 8747], "valid", [], "NV8"], [[8748, 8748], "mapped", [8747, 8747]], [[8749, 8749], "mapped", [8747, 8747, 8747]], [[8750, 8750], "valid", [], "NV8"], [[8751, 8751], "mapped", [8750, 8750]], [[8752, 8752], "mapped", [8750, 8750, 8750]], [[8753, 8799], "valid", [], "NV8"], [[8800, 8800], "disallowed_STD3_valid"], [[8801, 8813], "valid", [], "NV8"], [[8814, 8815], "disallowed_STD3_valid"], [[8816, 8945], "valid", [], "NV8"], [[8946, 8959], "valid", [], "NV8"], [[8960, 8960], "valid", [], "NV8"], [[8961, 8961], "valid", [], "NV8"], [[8962, 9e3], "valid", [], "NV8"], [[9001, 9001], "mapped", [12296]], [[9002, 9002], "mapped", [12297]], [[9003, 9082], "valid", [], "NV8"], [[9083, 9083], "valid", [], "NV8"], [[9084, 9084], "valid", [], "NV8"], [[9085, 9114], "valid", [], "NV8"], [[9115, 9166], "valid", [], "NV8"], [[9167, 9168], "valid", [], "NV8"], [[9169, 9179], "valid", [], "NV8"], [[9180, 9191], "valid", [], "NV8"], [[9192, 9192], "valid", [], "NV8"], [[9193, 9203], "valid", [], "NV8"], [[9204, 9210], "valid", [], "NV8"], [[9211, 9215], "disallowed"], [[9216, 9252], "valid", [], "NV8"], [[9253, 9254], "valid", [], "NV8"], [[9255, 9279], "disallowed"], [[9280, 9290], "valid", [], "NV8"], [[9291, 9311], "disallowed"], [[9312, 9312], "mapped", [49]], [[9313, 9313], "mapped", [50]], [[9314, 9314], "mapped", [51]], [[9315, 9315], "mapped", [52]], [[9316, 9316], "mapped", [53]], [[9317, 9317], "mapped", [54]], [[9318, 9318], "mapped", [55]], [[9319, 9319], "mapped", [56]], [[9320, 9320], "mapped", [57]], [[9321, 9321], "mapped", [49, 48]], [[9322, 9322], "mapped", [49, 49]], [[9323, 9323], "mapped", [49, 50]], [[9324, 9324], "mapped", [49, 51]], [[9325, 9325], "mapped", [49, 52]], [[9326, 9326], "mapped", [49, 53]], [[9327, 9327], "mapped", [49, 54]], [[9328, 9328], "mapped", [49, 55]], [[9329, 9329], "mapped", [49, 56]], [[9330, 9330], "mapped", [49, 57]], [[9331, 9331], "mapped", [50, 48]], [[9332, 9332], "disallowed_STD3_mapped", [40, 49, 41]], [[9333, 9333], "disallowed_STD3_mapped", [40, 50, 41]], [[9334, 9334], "disallowed_STD3_mapped", [40, 51, 41]], [[9335, 9335], "disallowed_STD3_mapped", [40, 52, 41]], [[9336, 9336], "disallowed_STD3_mapped", [40, 53, 41]], [[9337, 9337], "disallowed_STD3_mapped", [40, 54, 41]], [[9338, 9338], "disallowed_STD3_mapped", [40, 55, 41]], [[9339, 9339], "disallowed_STD3_mapped", [40, 56, 41]], [[9340, 9340], "disallowed_STD3_mapped", [40, 57, 41]], [[9341, 9341], "disallowed_STD3_mapped", [40, 49, 48, 41]], [[9342, 9342], "disallowed_STD3_mapped", [40, 49, 49, 41]], [[9343, 9343], "disallowed_STD3_mapped", [40, 49, 50, 41]], [[9344, 9344], "disallowed_STD3_mapped", [40, 49, 51, 41]], [[9345, 9345], "disallowed_STD3_mapped", [40, 49, 52, 41]], [[9346, 9346], "disallowed_STD3_mapped", [40, 49, 53, 41]], [[9347, 9347], "disallowed_STD3_mapped", [40, 49, 54, 41]], [[9348, 9348], "disallowed_STD3_mapped", [40, 49, 55, 41]], [[9349, 9349], "disallowed_STD3_mapped", [40, 49, 56, 41]], [[9350, 9350], "disallowed_STD3_mapped", [40, 49, 57, 41]], [[9351, 9351], "disallowed_STD3_mapped", [40, 50, 48, 41]], [[9352, 9371], "disallowed"], [[9372, 9372], "disallowed_STD3_mapped", [40, 97, 41]], [[9373, 9373], "disallowed_STD3_mapped", [40, 98, 41]], [[9374, 9374], "disallowed_STD3_mapped", [40, 99, 41]], [[9375, 9375], "disallowed_STD3_mapped", [40, 100, 41]], [[9376, 9376], "disallowed_STD3_mapped", [40, 101, 41]], [[9377, 9377], "disallowed_STD3_mapped", [40, 102, 41]], [[9378, 9378], "disallowed_STD3_mapped", [40, 103, 41]], [[9379, 9379], "disallowed_STD3_mapped", [40, 104, 41]], [[9380, 9380], "disallowed_STD3_mapped", [40, 105, 41]], [[9381, 9381], "disallowed_STD3_mapped", [40, 106, 41]], [[9382, 9382], "disallowed_STD3_mapped", [40, 107, 41]], [[9383, 9383], "disallowed_STD3_mapped", [40, 108, 41]], [[9384, 9384], "disallowed_STD3_mapped", [40, 109, 41]], [[9385, 9385], "disallowed_STD3_mapped", [40, 110, 41]], [[9386, 9386], "disallowed_STD3_mapped", [40, 111, 41]], [[9387, 9387], "disallowed_STD3_mapped", [40, 112, 41]], [[9388, 9388], "disallowed_STD3_mapped", [40, 113, 41]], [[9389, 9389], "disallowed_STD3_mapped", [40, 114, 41]], [[9390, 9390], "disallowed_STD3_mapped", [40, 115, 41]], [[9391, 9391], "disallowed_STD3_mapped", [40, 116, 41]], [[9392, 9392], "disallowed_STD3_mapped", [40, 117, 41]], [[9393, 9393], "disallowed_STD3_mapped", [40, 118, 41]], [[9394, 9394], "disallowed_STD3_mapped", [40, 119, 41]], [[9395, 9395], "disallowed_STD3_mapped", [40, 120, 41]], [[9396, 9396], "disallowed_STD3_mapped", [40, 121, 41]], [[9397, 9397], "disallowed_STD3_mapped", [40, 122, 41]], [[9398, 9398], "mapped", [97]], [[9399, 9399], "mapped", [98]], [[9400, 9400], "mapped", [99]], [[9401, 9401], "mapped", [100]], [[9402, 9402], "mapped", [101]], [[9403, 9403], "mapped", [102]], [[9404, 9404], "mapped", [103]], [[9405, 9405], "mapped", [104]], [[9406, 9406], "mapped", [105]], [[9407, 9407], "mapped", [106]], [[9408, 9408], "mapped", [107]], [[9409, 9409], "mapped", [108]], [[9410, 9410], "mapped", [109]], [[9411, 9411], "mapped", [110]], [[9412, 9412], "mapped", [111]], [[9413, 9413], "mapped", [112]], [[9414, 9414], "mapped", [113]], [[9415, 9415], "mapped", [114]], [[9416, 9416], "mapped", [115]], [[9417, 9417], "mapped", [116]], [[9418, 9418], "mapped", [117]], [[9419, 9419], "mapped", [118]], [[9420, 9420], "mapped", [119]], [[9421, 9421], "mapped", [120]], [[9422, 9422], "mapped", [121]], [[9423, 9423], "mapped", [122]], [[9424, 9424], "mapped", [97]], [[9425, 9425], "mapped", [98]], [[9426, 9426], "mapped", [99]], [[9427, 9427], "mapped", [100]], [[9428, 9428], "mapped", [101]], [[9429, 9429], "mapped", [102]], [[9430, 9430], "mapped", [103]], [[9431, 9431], "mapped", [104]], [[9432, 9432], "mapped", [105]], [[9433, 9433], "mapped", [106]], [[9434, 9434], "mapped", [107]], [[9435, 9435], "mapped", [108]], [[9436, 9436], "mapped", [109]], [[9437, 9437], "mapped", [110]], [[9438, 9438], "mapped", [111]], [[9439, 9439], "mapped", [112]], [[9440, 9440], "mapped", [113]], [[9441, 9441], "mapped", [114]], [[9442, 9442], "mapped", [115]], [[9443, 9443], "mapped", [116]], [[9444, 9444], "mapped", [117]], [[9445, 9445], "mapped", [118]], [[9446, 9446], "mapped", [119]], [[9447, 9447], "mapped", [120]], [[9448, 9448], "mapped", [121]], [[9449, 9449], "mapped", [122]], [[9450, 9450], "mapped", [48]], [[9451, 9470], "valid", [], "NV8"], [[9471, 9471], "valid", [], "NV8"], [[9472, 9621], "valid", [], "NV8"], [[9622, 9631], "valid", [], "NV8"], [[9632, 9711], "valid", [], "NV8"], [[9712, 9719], "valid", [], "NV8"], [[9720, 9727], "valid", [], "NV8"], [[9728, 9747], "valid", [], "NV8"], [[9748, 9749], "valid", [], "NV8"], [[9750, 9751], "valid", [], "NV8"], [[9752, 9752], "valid", [], "NV8"], [[9753, 9753], "valid", [], "NV8"], [[9754, 9839], "valid", [], "NV8"], [[9840, 9841], "valid", [], "NV8"], [[9842, 9853], "valid", [], "NV8"], [[9854, 9855], "valid", [], "NV8"], [[9856, 9865], "valid", [], "NV8"], [[9866, 9873], "valid", [], "NV8"], [[9874, 9884], "valid", [], "NV8"], [[9885, 9885], "valid", [], "NV8"], [[9886, 9887], "valid", [], "NV8"], [[9888, 9889], "valid", [], "NV8"], [[9890, 9905], "valid", [], "NV8"], [[9906, 9906], "valid", [], "NV8"], [[9907, 9916], "valid", [], "NV8"], [[9917, 9919], "valid", [], "NV8"], [[9920, 9923], "valid", [], "NV8"], [[9924, 9933], "valid", [], "NV8"], [[9934, 9934], "valid", [], "NV8"], [[9935, 9953], "valid", [], "NV8"], [[9954, 9954], "valid", [], "NV8"], [[9955, 9955], "valid", [], "NV8"], [[9956, 9959], "valid", [], "NV8"], [[9960, 9983], "valid", [], "NV8"], [[9984, 9984], "valid", [], "NV8"], [[9985, 9988], "valid", [], "NV8"], [[9989, 9989], "valid", [], "NV8"], [[9990, 9993], "valid", [], "NV8"], [[9994, 9995], "valid", [], "NV8"], [[9996, 10023], "valid", [], "NV8"], [[10024, 10024], "valid", [], "NV8"], [[10025, 10059], "valid", [], "NV8"], [[10060, 10060], "valid", [], "NV8"], [[10061, 10061], "valid", [], "NV8"], [[10062, 10062], "valid", [], "NV8"], [[10063, 10066], "valid", [], "NV8"], [[10067, 10069], "valid", [], "NV8"], [[10070, 10070], "valid", [], "NV8"], [[10071, 10071], "valid", [], "NV8"], [[10072, 10078], "valid", [], "NV8"], [[10079, 10080], "valid", [], "NV8"], [[10081, 10087], "valid", [], "NV8"], [[10088, 10101], "valid", [], "NV8"], [[10102, 10132], "valid", [], "NV8"], [[10133, 10135], "valid", [], "NV8"], [[10136, 10159], "valid", [], "NV8"], [[10160, 10160], "valid", [], "NV8"], [[10161, 10174], "valid", [], "NV8"], [[10175, 10175], "valid", [], "NV8"], [[10176, 10182], "valid", [], "NV8"], [[10183, 10186], "valid", [], "NV8"], [[10187, 10187], "valid", [], "NV8"], [[10188, 10188], "valid", [], "NV8"], [[10189, 10189], "valid", [], "NV8"], [[10190, 10191], "valid", [], "NV8"], [[10192, 10219], "valid", [], "NV8"], [[10220, 10223], "valid", [], "NV8"], [[10224, 10239], "valid", [], "NV8"], [[10240, 10495], "valid", [], "NV8"], [[10496, 10763], "valid", [], "NV8"], [[10764, 10764], "mapped", [8747, 8747, 8747, 8747]], [[10765, 10867], "valid", [], "NV8"], [[10868, 10868], "disallowed_STD3_mapped", [58, 58, 61]], [[10869, 10869], "disallowed_STD3_mapped", [61, 61]], [[10870, 10870], "disallowed_STD3_mapped", [61, 61, 61]], [[10871, 10971], "valid", [], "NV8"], [[10972, 10972], "mapped", [10973, 824]], [[10973, 11007], "valid", [], "NV8"], [[11008, 11021], "valid", [], "NV8"], [[11022, 11027], "valid", [], "NV8"], [[11028, 11034], "valid", [], "NV8"], [[11035, 11039], "valid", [], "NV8"], [[11040, 11043], "valid", [], "NV8"], [[11044, 11084], "valid", [], "NV8"], [[11085, 11087], "valid", [], "NV8"], [[11088, 11092], "valid", [], "NV8"], [[11093, 11097], "valid", [], "NV8"], [[11098, 11123], "valid", [], "NV8"], [[11124, 11125], "disallowed"], [[11126, 11157], "valid", [], "NV8"], [[11158, 11159], "disallowed"], [[11160, 11193], "valid", [], "NV8"], [[11194, 11196], "disallowed"], [[11197, 11208], "valid", [], "NV8"], [[11209, 11209], "disallowed"], [[11210, 11217], "valid", [], "NV8"], [[11218, 11243], "disallowed"], [[11244, 11247], "valid", [], "NV8"], [[11248, 11263], "disallowed"], [[11264, 11264], "mapped", [11312]], [[11265, 11265], "mapped", [11313]], [[11266, 11266], "mapped", [11314]], [[11267, 11267], "mapped", [11315]], [[11268, 11268], "mapped", [11316]], [[11269, 11269], "mapped", [11317]], [[11270, 11270], "mapped", [11318]], [[11271, 11271], "mapped", [11319]], [[11272, 11272], "mapped", [11320]], [[11273, 11273], "mapped", [11321]], [[11274, 11274], "mapped", [11322]], [[11275, 11275], "mapped", [11323]], [[11276, 11276], "mapped", [11324]], [[11277, 11277], "mapped", [11325]], [[11278, 11278], "mapped", [11326]], [[11279, 11279], "mapped", [11327]], [[11280, 11280], "mapped", [11328]], [[11281, 11281], "mapped", [11329]], [[11282, 11282], "mapped", [11330]], [[11283, 11283], "mapped", [11331]], [[11284, 11284], "mapped", [11332]], [[11285, 11285], "mapped", [11333]], [[11286, 11286], "mapped", [11334]], [[11287, 11287], "mapped", [11335]], [[11288, 11288], "mapped", [11336]], [[11289, 11289], "mapped", [11337]], [[11290, 11290], "mapped", [11338]], [[11291, 11291], "mapped", [11339]], [[11292, 11292], "mapped", [11340]], [[11293, 11293], "mapped", [11341]], [[11294, 11294], "mapped", [11342]], [[11295, 11295], "mapped", [11343]], [[11296, 11296], "mapped", [11344]], [[11297, 11297], "mapped", [11345]], [[11298, 11298], "mapped", [11346]], [[11299, 11299], "mapped", [11347]], [[11300, 11300], "mapped", [11348]], [[11301, 11301], "mapped", [11349]], [[11302, 11302], "mapped", [11350]], [[11303, 11303], "mapped", [11351]], [[11304, 11304], "mapped", [11352]], [[11305, 11305], "mapped", [11353]], [[11306, 11306], "mapped", [11354]], [[11307, 11307], "mapped", [11355]], [[11308, 11308], "mapped", [11356]], [[11309, 11309], "mapped", [11357]], [[11310, 11310], "mapped", [11358]], [[11311, 11311], "disallowed"], [[11312, 11358], "valid"], [[11359, 11359], "disallowed"], [[11360, 11360], "mapped", [11361]], [[11361, 11361], "valid"], [[11362, 11362], "mapped", [619]], [[11363, 11363], "mapped", [7549]], [[11364, 11364], "mapped", [637]], [[11365, 11366], "valid"], [[11367, 11367], "mapped", [11368]], [[11368, 11368], "valid"], [[11369, 11369], "mapped", [11370]], [[11370, 11370], "valid"], [[11371, 11371], "mapped", [11372]], [[11372, 11372], "valid"], [[11373, 11373], "mapped", [593]], [[11374, 11374], "mapped", [625]], [[11375, 11375], "mapped", [592]], [[11376, 11376], "mapped", [594]], [[11377, 11377], "valid"], [[11378, 11378], "mapped", [11379]], [[11379, 11379], "valid"], [[11380, 11380], "valid"], [[11381, 11381], "mapped", [11382]], [[11382, 11383], "valid"], [[11384, 11387], "valid"], [[11388, 11388], "mapped", [106]], [[11389, 11389], "mapped", [118]], [[11390, 11390], "mapped", [575]], [[11391, 11391], "mapped", [576]], [[11392, 11392], "mapped", [11393]], [[11393, 11393], "valid"], [[11394, 11394], "mapped", [11395]], [[11395, 11395], "valid"], [[11396, 11396], "mapped", [11397]], [[11397, 11397], "valid"], [[11398, 11398], "mapped", [11399]], [[11399, 11399], "valid"], [[11400, 11400], "mapped", [11401]], [[11401, 11401], "valid"], [[11402, 11402], "mapped", [11403]], [[11403, 11403], "valid"], [[11404, 11404], "mapped", [11405]], [[11405, 11405], "valid"], [[11406, 11406], "mapped", [11407]], [[11407, 11407], "valid"], [[11408, 11408], "mapped", [11409]], [[11409, 11409], "valid"], [[11410, 11410], "mapped", [11411]], [[11411, 11411], "valid"], [[11412, 11412], "mapped", [11413]], [[11413, 11413], "valid"], [[11414, 11414], "mapped", [11415]], [[11415, 11415], "valid"], [[11416, 11416], "mapped", [11417]], [[11417, 11417], "valid"], [[11418, 11418], "mapped", [11419]], [[11419, 11419], "valid"], [[11420, 11420], "mapped", [11421]], [[11421, 11421], "valid"], [[11422, 11422], "mapped", [11423]], [[11423, 11423], "valid"], [[11424, 11424], "mapped", [11425]], [[11425, 11425], "valid"], [[11426, 11426], "mapped", [11427]], [[11427, 11427], "valid"], [[11428, 11428], "mapped", [11429]], [[11429, 11429], "valid"], [[11430, 11430], "mapped", [11431]], [[11431, 11431], "valid"], [[11432, 11432], "mapped", [11433]], [[11433, 11433], "valid"], [[11434, 11434], "mapped", [11435]], [[11435, 11435], "valid"], [[11436, 11436], "mapped", [11437]], [[11437, 11437], "valid"], [[11438, 11438], "mapped", [11439]], [[11439, 11439], "valid"], [[11440, 11440], "mapped", [11441]], [[11441, 11441], "valid"], [[11442, 11442], "mapped", [11443]], [[11443, 11443], "valid"], [[11444, 11444], "mapped", [11445]], [[11445, 11445], "valid"], [[11446, 11446], "mapped", [11447]], [[11447, 11447], "valid"], [[11448, 11448], "mapped", [11449]], [[11449, 11449], "valid"], [[11450, 11450], "mapped", [11451]], [[11451, 11451], "valid"], [[11452, 11452], "mapped", [11453]], [[11453, 11453], "valid"], [[11454, 11454], "mapped", [11455]], [[11455, 11455], "valid"], [[11456, 11456], "mapped", [11457]], [[11457, 11457], "valid"], [[11458, 11458], "mapped", [11459]], [[11459, 11459], "valid"], [[11460, 11460], "mapped", [11461]], [[11461, 11461], "valid"], [[11462, 11462], "mapped", [11463]], [[11463, 11463], "valid"], [[11464, 11464], "mapped", [11465]], [[11465, 11465], "valid"], [[11466, 11466], "mapped", [11467]], [[11467, 11467], "valid"], [[11468, 11468], "mapped", [11469]], [[11469, 11469], "valid"], [[11470, 11470], "mapped", [11471]], [[11471, 11471], "valid"], [[11472, 11472], "mapped", [11473]], [[11473, 11473], "valid"], [[11474, 11474], "mapped", [11475]], [[11475, 11475], "valid"], [[11476, 11476], "mapped", [11477]], [[11477, 11477], "valid"], [[11478, 11478], "mapped", [11479]], [[11479, 11479], "valid"], [[11480, 11480], "mapped", [11481]], [[11481, 11481], "valid"], [[11482, 11482], "mapped", [11483]], [[11483, 11483], "valid"], [[11484, 11484], "mapped", [11485]], [[11485, 11485], "valid"], [[11486, 11486], "mapped", [11487]], [[11487, 11487], "valid"], [[11488, 11488], "mapped", [11489]], [[11489, 11489], "valid"], [[11490, 11490], "mapped", [11491]], [[11491, 11492], "valid"], [[11493, 11498], "valid", [], "NV8"], [[11499, 11499], "mapped", [11500]], [[11500, 11500], "valid"], [[11501, 11501], "mapped", [11502]], [[11502, 11505], "valid"], [[11506, 11506], "mapped", [11507]], [[11507, 11507], "valid"], [[11508, 11512], "disallowed"], [[11513, 11519], "valid", [], "NV8"], [[11520, 11557], "valid"], [[11558, 11558], "disallowed"], [[11559, 11559], "valid"], [[11560, 11564], "disallowed"], [[11565, 11565], "valid"], [[11566, 11567], "disallowed"], [[11568, 11621], "valid"], [[11622, 11623], "valid"], [[11624, 11630], "disallowed"], [[11631, 11631], "mapped", [11617]], [[11632, 11632], "valid", [], "NV8"], [[11633, 11646], "disallowed"], [[11647, 11647], "valid"], [[11648, 11670], "valid"], [[11671, 11679], "disallowed"], [[11680, 11686], "valid"], [[11687, 11687], "disallowed"], [[11688, 11694], "valid"], [[11695, 11695], "disallowed"], [[11696, 11702], "valid"], [[11703, 11703], "disallowed"], [[11704, 11710], "valid"], [[11711, 11711], "disallowed"], [[11712, 11718], "valid"], [[11719, 11719], "disallowed"], [[11720, 11726], "valid"], [[11727, 11727], "disallowed"], [[11728, 11734], "valid"], [[11735, 11735], "disallowed"], [[11736, 11742], "valid"], [[11743, 11743], "disallowed"], [[11744, 11775], "valid"], [[11776, 11799], "valid", [], "NV8"], [[11800, 11803], "valid", [], "NV8"], [[11804, 11805], "valid", [], "NV8"], [[11806, 11822], "valid", [], "NV8"], [[11823, 11823], "valid"], [[11824, 11824], "valid", [], "NV8"], [[11825, 11825], "valid", [], "NV8"], [[11826, 11835], "valid", [], "NV8"], [[11836, 11842], "valid", [], "NV8"], [[11843, 11903], "disallowed"], [[11904, 11929], "valid", [], "NV8"], [[11930, 11930], "disallowed"], [[11931, 11934], "valid", [], "NV8"], [[11935, 11935], "mapped", [27597]], [[11936, 12018], "valid", [], "NV8"], [[12019, 12019], "mapped", [40863]], [[12020, 12031], "disallowed"], [[12032, 12032], "mapped", [19968]], [[12033, 12033], "mapped", [20008]], [[12034, 12034], "mapped", [20022]], [[12035, 12035], "mapped", [20031]], [[12036, 12036], "mapped", [20057]], [[12037, 12037], "mapped", [20101]], [[12038, 12038], "mapped", [20108]], [[12039, 12039], "mapped", [20128]], [[12040, 12040], "mapped", [20154]], [[12041, 12041], "mapped", [20799]], [[12042, 12042], "mapped", [20837]], [[12043, 12043], "mapped", [20843]], [[12044, 12044], "mapped", [20866]], [[12045, 12045], "mapped", [20886]], [[12046, 12046], "mapped", [20907]], [[12047, 12047], "mapped", [20960]], [[12048, 12048], "mapped", [20981]], [[12049, 12049], "mapped", [20992]], [[12050, 12050], "mapped", [21147]], [[12051, 12051], "mapped", [21241]], [[12052, 12052], "mapped", [21269]], [[12053, 12053], "mapped", [21274]], [[12054, 12054], "mapped", [21304]], [[12055, 12055], "mapped", [21313]], [[12056, 12056], "mapped", [21340]], [[12057, 12057], "mapped", [21353]], [[12058, 12058], "mapped", [21378]], [[12059, 12059], "mapped", [21430]], [[12060, 12060], "mapped", [21448]], [[12061, 12061], "mapped", [21475]], [[12062, 12062], "mapped", [22231]], [[12063, 12063], "mapped", [22303]], [[12064, 12064], "mapped", [22763]], [[12065, 12065], "mapped", [22786]], [[12066, 12066], "mapped", [22794]], [[12067, 12067], "mapped", [22805]], [[12068, 12068], "mapped", [22823]], [[12069, 12069], "mapped", [22899]], [[12070, 12070], "mapped", [23376]], [[12071, 12071], "mapped", [23424]], [[12072, 12072], "mapped", [23544]], [[12073, 12073], "mapped", [23567]], [[12074, 12074], "mapped", [23586]], [[12075, 12075], "mapped", [23608]], [[12076, 12076], "mapped", [23662]], [[12077, 12077], "mapped", [23665]], [[12078, 12078], "mapped", [24027]], [[12079, 12079], "mapped", [24037]], [[12080, 12080], "mapped", [24049]], [[12081, 12081], "mapped", [24062]], [[12082, 12082], "mapped", [24178]], [[12083, 12083], "mapped", [24186]], [[12084, 12084], "mapped", [24191]], [[12085, 12085], "mapped", [24308]], [[12086, 12086], "mapped", [24318]], [[12087, 12087], "mapped", [24331]], [[12088, 12088], "mapped", [24339]], [[12089, 12089], "mapped", [24400]], [[12090, 12090], "mapped", [24417]], [[12091, 12091], "mapped", [24435]], [[12092, 12092], "mapped", [24515]], [[12093, 12093], "mapped", [25096]], [[12094, 12094], "mapped", [25142]], [[12095, 12095], "mapped", [25163]], [[12096, 12096], "mapped", [25903]], [[12097, 12097], "mapped", [25908]], [[12098, 12098], "mapped", [25991]], [[12099, 12099], "mapped", [26007]], [[12100, 12100], "mapped", [26020]], [[12101, 12101], "mapped", [26041]], [[12102, 12102], "mapped", [26080]], [[12103, 12103], "mapped", [26085]], [[12104, 12104], "mapped", [26352]], [[12105, 12105], "mapped", [26376]], [[12106, 12106], "mapped", [26408]], [[12107, 12107], "mapped", [27424]], [[12108, 12108], "mapped", [27490]], [[12109, 12109], "mapped", [27513]], [[12110, 12110], "mapped", [27571]], [[12111, 12111], "mapped", [27595]], [[12112, 12112], "mapped", [27604]], [[12113, 12113], "mapped", [27611]], [[12114, 12114], "mapped", [27663]], [[12115, 12115], "mapped", [27668]], [[12116, 12116], "mapped", [27700]], [[12117, 12117], "mapped", [28779]], [[12118, 12118], "mapped", [29226]], [[12119, 12119], "mapped", [29238]], [[12120, 12120], "mapped", [29243]], [[12121, 12121], "mapped", [29247]], [[12122, 12122], "mapped", [29255]], [[12123, 12123], "mapped", [29273]], [[12124, 12124], "mapped", [29275]], [[12125, 12125], "mapped", [29356]], [[12126, 12126], "mapped", [29572]], [[12127, 12127], "mapped", [29577]], [[12128, 12128], "mapped", [29916]], [[12129, 12129], "mapped", [29926]], [[12130, 12130], "mapped", [29976]], [[12131, 12131], "mapped", [29983]], [[12132, 12132], "mapped", [29992]], [[12133, 12133], "mapped", [3e4]], [[12134, 12134], "mapped", [30091]], [[12135, 12135], "mapped", [30098]], [[12136, 12136], "mapped", [30326]], [[12137, 12137], "mapped", [30333]], [[12138, 12138], "mapped", [30382]], [[12139, 12139], "mapped", [30399]], [[12140, 12140], "mapped", [30446]], [[12141, 12141], "mapped", [30683]], [[12142, 12142], "mapped", [30690]], [[12143, 12143], "mapped", [30707]], [[12144, 12144], "mapped", [31034]], [[12145, 12145], "mapped", [31160]], [[12146, 12146], "mapped", [31166]], [[12147, 12147], "mapped", [31348]], [[12148, 12148], "mapped", [31435]], [[12149, 12149], "mapped", [31481]], [[12150, 12150], "mapped", [31859]], [[12151, 12151], "mapped", [31992]], [[12152, 12152], "mapped", [32566]], [[12153, 12153], "mapped", [32593]], [[12154, 12154], "mapped", [32650]], [[12155, 12155], "mapped", [32701]], [[12156, 12156], "mapped", [32769]], [[12157, 12157], "mapped", [32780]], [[12158, 12158], "mapped", [32786]], [[12159, 12159], "mapped", [32819]], [[12160, 12160], "mapped", [32895]], [[12161, 12161], "mapped", [32905]], [[12162, 12162], "mapped", [33251]], [[12163, 12163], "mapped", [33258]], [[12164, 12164], "mapped", [33267]], [[12165, 12165], "mapped", [33276]], [[12166, 12166], "mapped", [33292]], [[12167, 12167], "mapped", [33307]], [[12168, 12168], "mapped", [33311]], [[12169, 12169], "mapped", [33390]], [[12170, 12170], "mapped", [33394]], [[12171, 12171], "mapped", [33400]], [[12172, 12172], "mapped", [34381]], [[12173, 12173], "mapped", [34411]], [[12174, 12174], "mapped", [34880]], [[12175, 12175], "mapped", [34892]], [[12176, 12176], "mapped", [34915]], [[12177, 12177], "mapped", [35198]], [[12178, 12178], "mapped", [35211]], [[12179, 12179], "mapped", [35282]], [[12180, 12180], "mapped", [35328]], [[12181, 12181], "mapped", [35895]], [[12182, 12182], "mapped", [35910]], [[12183, 12183], "mapped", [35925]], [[12184, 12184], "mapped", [35960]], [[12185, 12185], "mapped", [35997]], [[12186, 12186], "mapped", [36196]], [[12187, 12187], "mapped", [36208]], [[12188, 12188], "mapped", [36275]], [[12189, 12189], "mapped", [36523]], [[12190, 12190], "mapped", [36554]], [[12191, 12191], "mapped", [36763]], [[12192, 12192], "mapped", [36784]], [[12193, 12193], "mapped", [36789]], [[12194, 12194], "mapped", [37009]], [[12195, 12195], "mapped", [37193]], [[12196, 12196], "mapped", [37318]], [[12197, 12197], "mapped", [37324]], [[12198, 12198], "mapped", [37329]], [[12199, 12199], "mapped", [38263]], [[12200, 12200], "mapped", [38272]], [[12201, 12201], "mapped", [38428]], [[12202, 12202], "mapped", [38582]], [[12203, 12203], "mapped", [38585]], [[12204, 12204], "mapped", [38632]], [[12205, 12205], "mapped", [38737]], [[12206, 12206], "mapped", [38750]], [[12207, 12207], "mapped", [38754]], [[12208, 12208], "mapped", [38761]], [[12209, 12209], "mapped", [38859]], [[12210, 12210], "mapped", [38893]], [[12211, 12211], "mapped", [38899]], [[12212, 12212], "mapped", [38913]], [[12213, 12213], "mapped", [39080]], [[12214, 12214], "mapped", [39131]], [[12215, 12215], "mapped", [39135]], [[12216, 12216], "mapped", [39318]], [[12217, 12217], "mapped", [39321]], [[12218, 12218], "mapped", [39340]], [[12219, 12219], "mapped", [39592]], [[12220, 12220], "mapped", [39640]], [[12221, 12221], "mapped", [39647]], [[12222, 12222], "mapped", [39717]], [[12223, 12223], "mapped", [39727]], [[12224, 12224], "mapped", [39730]], [[12225, 12225], "mapped", [39740]], [[12226, 12226], "mapped", [39770]], [[12227, 12227], "mapped", [40165]], [[12228, 12228], "mapped", [40565]], [[12229, 12229], "mapped", [40575]], [[12230, 12230], "mapped", [40613]], [[12231, 12231], "mapped", [40635]], [[12232, 12232], "mapped", [40643]], [[12233, 12233], "mapped", [40653]], [[12234, 12234], "mapped", [40657]], [[12235, 12235], "mapped", [40697]], [[12236, 12236], "mapped", [40701]], [[12237, 12237], "mapped", [40718]], [[12238, 12238], "mapped", [40723]], [[12239, 12239], "mapped", [40736]], [[12240, 12240], "mapped", [40763]], [[12241, 12241], "mapped", [40778]], [[12242, 12242], "mapped", [40786]], [[12243, 12243], "mapped", [40845]], [[12244, 12244], "mapped", [40860]], [[12245, 12245], "mapped", [40864]], [[12246, 12271], "disallowed"], [[12272, 12283], "disallowed"], [[12284, 12287], "disallowed"], [[12288, 12288], "disallowed_STD3_mapped", [32]], [[12289, 12289], "valid", [], "NV8"], [[12290, 12290], "mapped", [46]], [[12291, 12292], "valid", [], "NV8"], [[12293, 12295], "valid"], [[12296, 12329], "valid", [], "NV8"], [[12330, 12333], "valid"], [[12334, 12341], "valid", [], "NV8"], [[12342, 12342], "mapped", [12306]], [[12343, 12343], "valid", [], "NV8"], [[12344, 12344], "mapped", [21313]], [[12345, 12345], "mapped", [21316]], [[12346, 12346], "mapped", [21317]], [[12347, 12347], "valid", [], "NV8"], [[12348, 12348], "valid"], [[12349, 12349], "valid", [], "NV8"], [[12350, 12350], "valid", [], "NV8"], [[12351, 12351], "valid", [], "NV8"], [[12352, 12352], "disallowed"], [[12353, 12436], "valid"], [[12437, 12438], "valid"], [[12439, 12440], "disallowed"], [[12441, 12442], "valid"], [[12443, 12443], "disallowed_STD3_mapped", [32, 12441]], [[12444, 12444], "disallowed_STD3_mapped", [32, 12442]], [[12445, 12446], "valid"], [[12447, 12447], "mapped", [12424, 12426]], [[12448, 12448], "valid", [], "NV8"], [[12449, 12542], "valid"], [[12543, 12543], "mapped", [12467, 12488]], [[12544, 12548], "disallowed"], [[12549, 12588], "valid"], [[12589, 12589], "valid"], [[12590, 12592], "disallowed"], [[12593, 12593], "mapped", [4352]], [[12594, 12594], "mapped", [4353]], [[12595, 12595], "mapped", [4522]], [[12596, 12596], "mapped", [4354]], [[12597, 12597], "mapped", [4524]], [[12598, 12598], "mapped", [4525]], [[12599, 12599], "mapped", [4355]], [[12600, 12600], "mapped", [4356]], [[12601, 12601], "mapped", [4357]], [[12602, 12602], "mapped", [4528]], [[12603, 12603], "mapped", [4529]], [[12604, 12604], "mapped", [4530]], [[12605, 12605], "mapped", [4531]], [[12606, 12606], "mapped", [4532]], [[12607, 12607], "mapped", [4533]], [[12608, 12608], "mapped", [4378]], [[12609, 12609], "mapped", [4358]], [[12610, 12610], "mapped", [4359]], [[12611, 12611], "mapped", [4360]], [[12612, 12612], "mapped", [4385]], [[12613, 12613], "mapped", [4361]], [[12614, 12614], "mapped", [4362]], [[12615, 12615], "mapped", [4363]], [[12616, 12616], "mapped", [4364]], [[12617, 12617], "mapped", [4365]], [[12618, 12618], "mapped", [4366]], [[12619, 12619], "mapped", [4367]], [[12620, 12620], "mapped", [4368]], [[12621, 12621], "mapped", [4369]], [[12622, 12622], "mapped", [4370]], [[12623, 12623], "mapped", [4449]], [[12624, 12624], "mapped", [4450]], [[12625, 12625], "mapped", [4451]], [[12626, 12626], "mapped", [4452]], [[12627, 12627], "mapped", [4453]], [[12628, 12628], "mapped", [4454]], [[12629, 12629], "mapped", [4455]], [[12630, 12630], "mapped", [4456]], [[12631, 12631], "mapped", [4457]], [[12632, 12632], "mapped", [4458]], [[12633, 12633], "mapped", [4459]], [[12634, 12634], "mapped", [4460]], [[12635, 12635], "mapped", [4461]], [[12636, 12636], "mapped", [4462]], [[12637, 12637], "mapped", [4463]], [[12638, 12638], "mapped", [4464]], [[12639, 12639], "mapped", [4465]], [[12640, 12640], "mapped", [4466]], [[12641, 12641], "mapped", [4467]], [[12642, 12642], "mapped", [4468]], [[12643, 12643], "mapped", [4469]], [[12644, 12644], "disallowed"], [[12645, 12645], "mapped", [4372]], [[12646, 12646], "mapped", [4373]], [[12647, 12647], "mapped", [4551]], [[12648, 12648], "mapped", [4552]], [[12649, 12649], "mapped", [4556]], [[12650, 12650], "mapped", [4558]], [[12651, 12651], "mapped", [4563]], [[12652, 12652], "mapped", [4567]], [[12653, 12653], "mapped", [4569]], [[12654, 12654], "mapped", [4380]], [[12655, 12655], "mapped", [4573]], [[12656, 12656], "mapped", [4575]], [[12657, 12657], "mapped", [4381]], [[12658, 12658], "mapped", [4382]], [[12659, 12659], "mapped", [4384]], [[12660, 12660], "mapped", [4386]], [[12661, 12661], "mapped", [4387]], [[12662, 12662], "mapped", [4391]], [[12663, 12663], "mapped", [4393]], [[12664, 12664], "mapped", [4395]], [[12665, 12665], "mapped", [4396]], [[12666, 12666], "mapped", [4397]], [[12667, 12667], "mapped", [4398]], [[12668, 12668], "mapped", [4399]], [[12669, 12669], "mapped", [4402]], [[12670, 12670], "mapped", [4406]], [[12671, 12671], "mapped", [4416]], [[12672, 12672], "mapped", [4423]], [[12673, 12673], "mapped", [4428]], [[12674, 12674], "mapped", [4593]], [[12675, 12675], "mapped", [4594]], [[12676, 12676], "mapped", [4439]], [[12677, 12677], "mapped", [4440]], [[12678, 12678], "mapped", [4441]], [[12679, 12679], "mapped", [4484]], [[12680, 12680], "mapped", [4485]], [[12681, 12681], "mapped", [4488]], [[12682, 12682], "mapped", [4497]], [[12683, 12683], "mapped", [4498]], [[12684, 12684], "mapped", [4500]], [[12685, 12685], "mapped", [4510]], [[12686, 12686], "mapped", [4513]], [[12687, 12687], "disallowed"], [[12688, 12689], "valid", [], "NV8"], [[12690, 12690], "mapped", [19968]], [[12691, 12691], "mapped", [20108]], [[12692, 12692], "mapped", [19977]], [[12693, 12693], "mapped", [22235]], [[12694, 12694], "mapped", [19978]], [[12695, 12695], "mapped", [20013]], [[12696, 12696], "mapped", [19979]], [[12697, 12697], "mapped", [30002]], [[12698, 12698], "mapped", [20057]], [[12699, 12699], "mapped", [19993]], [[12700, 12700], "mapped", [19969]], [[12701, 12701], "mapped", [22825]], [[12702, 12702], "mapped", [22320]], [[12703, 12703], "mapped", [20154]], [[12704, 12727], "valid"], [[12728, 12730], "valid"], [[12731, 12735], "disallowed"], [[12736, 12751], "valid", [], "NV8"], [[12752, 12771], "valid", [], "NV8"], [[12772, 12783], "disallowed"], [[12784, 12799], "valid"], [[12800, 12800], "disallowed_STD3_mapped", [40, 4352, 41]], [[12801, 12801], "disallowed_STD3_mapped", [40, 4354, 41]], [[12802, 12802], "disallowed_STD3_mapped", [40, 4355, 41]], [[12803, 12803], "disallowed_STD3_mapped", [40, 4357, 41]], [[12804, 12804], "disallowed_STD3_mapped", [40, 4358, 41]], [[12805, 12805], "disallowed_STD3_mapped", [40, 4359, 41]], [[12806, 12806], "disallowed_STD3_mapped", [40, 4361, 41]], [[12807, 12807], "disallowed_STD3_mapped", [40, 4363, 41]], [[12808, 12808], "disallowed_STD3_mapped", [40, 4364, 41]], [[12809, 12809], "disallowed_STD3_mapped", [40, 4366, 41]], [[12810, 12810], "disallowed_STD3_mapped", [40, 4367, 41]], [[12811, 12811], "disallowed_STD3_mapped", [40, 4368, 41]], [[12812, 12812], "disallowed_STD3_mapped", [40, 4369, 41]], [[12813, 12813], "disallowed_STD3_mapped", [40, 4370, 41]], [[12814, 12814], "disallowed_STD3_mapped", [40, 44032, 41]], [[12815, 12815], "disallowed_STD3_mapped", [40, 45208, 41]], [[12816, 12816], "disallowed_STD3_mapped", [40, 45796, 41]], [[12817, 12817], "disallowed_STD3_mapped", [40, 46972, 41]], [[12818, 12818], "disallowed_STD3_mapped", [40, 47560, 41]], [[12819, 12819], "disallowed_STD3_mapped", [40, 48148, 41]], [[12820, 12820], "disallowed_STD3_mapped", [40, 49324, 41]], [[12821, 12821], "disallowed_STD3_mapped", [40, 50500, 41]], [[12822, 12822], "disallowed_STD3_mapped", [40, 51088, 41]], [[12823, 12823], "disallowed_STD3_mapped", [40, 52264, 41]], [[12824, 12824], "disallowed_STD3_mapped", [40, 52852, 41]], [[12825, 12825], "disallowed_STD3_mapped", [40, 53440, 41]], [[12826, 12826], "disallowed_STD3_mapped", [40, 54028, 41]], [[12827, 12827], "disallowed_STD3_mapped", [40, 54616, 41]], [[12828, 12828], "disallowed_STD3_mapped", [40, 51452, 41]], [[12829, 12829], "disallowed_STD3_mapped", [40, 50724, 51204, 41]], [[12830, 12830], "disallowed_STD3_mapped", [40, 50724, 54980, 41]], [[12831, 12831], "disallowed"], [[12832, 12832], "disallowed_STD3_mapped", [40, 19968, 41]], [[12833, 12833], "disallowed_STD3_mapped", [40, 20108, 41]], [[12834, 12834], "disallowed_STD3_mapped", [40, 19977, 41]], [[12835, 12835], "disallowed_STD3_mapped", [40, 22235, 41]], [[12836, 12836], "disallowed_STD3_mapped", [40, 20116, 41]], [[12837, 12837], "disallowed_STD3_mapped", [40, 20845, 41]], [[12838, 12838], "disallowed_STD3_mapped", [40, 19971, 41]], [[12839, 12839], "disallowed_STD3_mapped", [40, 20843, 41]], [[12840, 12840], "disallowed_STD3_mapped", [40, 20061, 41]], [[12841, 12841], "disallowed_STD3_mapped", [40, 21313, 41]], [[12842, 12842], "disallowed_STD3_mapped", [40, 26376, 41]], [[12843, 12843], "disallowed_STD3_mapped", [40, 28779, 41]], [[12844, 12844], "disallowed_STD3_mapped", [40, 27700, 41]], [[12845, 12845], "disallowed_STD3_mapped", [40, 26408, 41]], [[12846, 12846], "disallowed_STD3_mapped", [40, 37329, 41]], [[12847, 12847], "disallowed_STD3_mapped", [40, 22303, 41]], [[12848, 12848], "disallowed_STD3_mapped", [40, 26085, 41]], [[12849, 12849], "disallowed_STD3_mapped", [40, 26666, 41]], [[12850, 12850], "disallowed_STD3_mapped", [40, 26377, 41]], [[12851, 12851], "disallowed_STD3_mapped", [40, 31038, 41]], [[12852, 12852], "disallowed_STD3_mapped", [40, 21517, 41]], [[12853, 12853], "disallowed_STD3_mapped", [40, 29305, 41]], [[12854, 12854], "disallowed_STD3_mapped", [40, 36001, 41]], [[12855, 12855], "disallowed_STD3_mapped", [40, 31069, 41]], [[12856, 12856], "disallowed_STD3_mapped", [40, 21172, 41]], [[12857, 12857], "disallowed_STD3_mapped", [40, 20195, 41]], [[12858, 12858], "disallowed_STD3_mapped", [40, 21628, 41]], [[12859, 12859], "disallowed_STD3_mapped", [40, 23398, 41]], [[12860, 12860], "disallowed_STD3_mapped", [40, 30435, 41]], [[12861, 12861], "disallowed_STD3_mapped", [40, 20225, 41]], [[12862, 12862], "disallowed_STD3_mapped", [40, 36039, 41]], [[12863, 12863], "disallowed_STD3_mapped", [40, 21332, 41]], [[12864, 12864], "disallowed_STD3_mapped", [40, 31085, 41]], [[12865, 12865], "disallowed_STD3_mapped", [40, 20241, 41]], [[12866, 12866], "disallowed_STD3_mapped", [40, 33258, 41]], [[12867, 12867], "disallowed_STD3_mapped", [40, 33267, 41]], [[12868, 12868], "mapped", [21839]], [[12869, 12869], "mapped", [24188]], [[12870, 12870], "mapped", [25991]], [[12871, 12871], "mapped", [31631]], [[12872, 12879], "valid", [], "NV8"], [[12880, 12880], "mapped", [112, 116, 101]], [[12881, 12881], "mapped", [50, 49]], [[12882, 12882], "mapped", [50, 50]], [[12883, 12883], "mapped", [50, 51]], [[12884, 12884], "mapped", [50, 52]], [[12885, 12885], "mapped", [50, 53]], [[12886, 12886], "mapped", [50, 54]], [[12887, 12887], "mapped", [50, 55]], [[12888, 12888], "mapped", [50, 56]], [[12889, 12889], "mapped", [50, 57]], [[12890, 12890], "mapped", [51, 48]], [[12891, 12891], "mapped", [51, 49]], [[12892, 12892], "mapped", [51, 50]], [[12893, 12893], "mapped", [51, 51]], [[12894, 12894], "mapped", [51, 52]], [[12895, 12895], "mapped", [51, 53]], [[12896, 12896], "mapped", [4352]], [[12897, 12897], "mapped", [4354]], [[12898, 12898], "mapped", [4355]], [[12899, 12899], "mapped", [4357]], [[12900, 12900], "mapped", [4358]], [[12901, 12901], "mapped", [4359]], [[12902, 12902], "mapped", [4361]], [[12903, 12903], "mapped", [4363]], [[12904, 12904], "mapped", [4364]], [[12905, 12905], "mapped", [4366]], [[12906, 12906], "mapped", [4367]], [[12907, 12907], "mapped", [4368]], [[12908, 12908], "mapped", [4369]], [[12909, 12909], "mapped", [4370]], [[12910, 12910], "mapped", [44032]], [[12911, 12911], "mapped", [45208]], [[12912, 12912], "mapped", [45796]], [[12913, 12913], "mapped", [46972]], [[12914, 12914], "mapped", [47560]], [[12915, 12915], "mapped", [48148]], [[12916, 12916], "mapped", [49324]], [[12917, 12917], "mapped", [50500]], [[12918, 12918], "mapped", [51088]], [[12919, 12919], "mapped", [52264]], [[12920, 12920], "mapped", [52852]], [[12921, 12921], "mapped", [53440]], [[12922, 12922], "mapped", [54028]], [[12923, 12923], "mapped", [54616]], [[12924, 12924], "mapped", [52280, 44256]], [[12925, 12925], "mapped", [51452, 51032]], [[12926, 12926], "mapped", [50864]], [[12927, 12927], "valid", [], "NV8"], [[12928, 12928], "mapped", [19968]], [[12929, 12929], "mapped", [20108]], [[12930, 12930], "mapped", [19977]], [[12931, 12931], "mapped", [22235]], [[12932, 12932], "mapped", [20116]], [[12933, 12933], "mapped", [20845]], [[12934, 12934], "mapped", [19971]], [[12935, 12935], "mapped", [20843]], [[12936, 12936], "mapped", [20061]], [[12937, 12937], "mapped", [21313]], [[12938, 12938], "mapped", [26376]], [[12939, 12939], "mapped", [28779]], [[12940, 12940], "mapped", [27700]], [[12941, 12941], "mapped", [26408]], [[12942, 12942], "mapped", [37329]], [[12943, 12943], "mapped", [22303]], [[12944, 12944], "mapped", [26085]], [[12945, 12945], "mapped", [26666]], [[12946, 12946], "mapped", [26377]], [[12947, 12947], "mapped", [31038]], [[12948, 12948], "mapped", [21517]], [[12949, 12949], "mapped", [29305]], [[12950, 12950], "mapped", [36001]], [[12951, 12951], "mapped", [31069]], [[12952, 12952], "mapped", [21172]], [[12953, 12953], "mapped", [31192]], [[12954, 12954], "mapped", [30007]], [[12955, 12955], "mapped", [22899]], [[12956, 12956], "mapped", [36969]], [[12957, 12957], "mapped", [20778]], [[12958, 12958], "mapped", [21360]], [[12959, 12959], "mapped", [27880]], [[12960, 12960], "mapped", [38917]], [[12961, 12961], "mapped", [20241]], [[12962, 12962], "mapped", [20889]], [[12963, 12963], "mapped", [27491]], [[12964, 12964], "mapped", [19978]], [[12965, 12965], "mapped", [20013]], [[12966, 12966], "mapped", [19979]], [[12967, 12967], "mapped", [24038]], [[12968, 12968], "mapped", [21491]], [[12969, 12969], "mapped", [21307]], [[12970, 12970], "mapped", [23447]], [[12971, 12971], "mapped", [23398]], [[12972, 12972], "mapped", [30435]], [[12973, 12973], "mapped", [20225]], [[12974, 12974], "mapped", [36039]], [[12975, 12975], "mapped", [21332]], [[12976, 12976], "mapped", [22812]], [[12977, 12977], "mapped", [51, 54]], [[12978, 12978], "mapped", [51, 55]], [[12979, 12979], "mapped", [51, 56]], [[12980, 12980], "mapped", [51, 57]], [[12981, 12981], "mapped", [52, 48]], [[12982, 12982], "mapped", [52, 49]], [[12983, 12983], "mapped", [52, 50]], [[12984, 12984], "mapped", [52, 51]], [[12985, 12985], "mapped", [52, 52]], [[12986, 12986], "mapped", [52, 53]], [[12987, 12987], "mapped", [52, 54]], [[12988, 12988], "mapped", [52, 55]], [[12989, 12989], "mapped", [52, 56]], [[12990, 12990], "mapped", [52, 57]], [[12991, 12991], "mapped", [53, 48]], [[12992, 12992], "mapped", [49, 26376]], [[12993, 12993], "mapped", [50, 26376]], [[12994, 12994], "mapped", [51, 26376]], [[12995, 12995], "mapped", [52, 26376]], [[12996, 12996], "mapped", [53, 26376]], [[12997, 12997], "mapped", [54, 26376]], [[12998, 12998], "mapped", [55, 26376]], [[12999, 12999], "mapped", [56, 26376]], [[13e3, 13e3], "mapped", [57, 26376]], [[13001, 13001], "mapped", [49, 48, 26376]], [[13002, 13002], "mapped", [49, 49, 26376]], [[13003, 13003], "mapped", [49, 50, 26376]], [[13004, 13004], "mapped", [104, 103]], [[13005, 13005], "mapped", [101, 114, 103]], [[13006, 13006], "mapped", [101, 118]], [[13007, 13007], "mapped", [108, 116, 100]], [[13008, 13008], "mapped", [12450]], [[13009, 13009], "mapped", [12452]], [[13010, 13010], "mapped", [12454]], [[13011, 13011], "mapped", [12456]], [[13012, 13012], "mapped", [12458]], [[13013, 13013], "mapped", [12459]], [[13014, 13014], "mapped", [12461]], [[13015, 13015], "mapped", [12463]], [[13016, 13016], "mapped", [12465]], [[13017, 13017], "mapped", [12467]], [[13018, 13018], "mapped", [12469]], [[13019, 13019], "mapped", [12471]], [[13020, 13020], "mapped", [12473]], [[13021, 13021], "mapped", [12475]], [[13022, 13022], "mapped", [12477]], [[13023, 13023], "mapped", [12479]], [[13024, 13024], "mapped", [12481]], [[13025, 13025], "mapped", [12484]], [[13026, 13026], "mapped", [12486]], [[13027, 13027], "mapped", [12488]], [[13028, 13028], "mapped", [12490]], [[13029, 13029], "mapped", [12491]], [[13030, 13030], "mapped", [12492]], [[13031, 13031], "mapped", [12493]], [[13032, 13032], "mapped", [12494]], [[13033, 13033], "mapped", [12495]], [[13034, 13034], "mapped", [12498]], [[13035, 13035], "mapped", [12501]], [[13036, 13036], "mapped", [12504]], [[13037, 13037], "mapped", [12507]], [[13038, 13038], "mapped", [12510]], [[13039, 13039], "mapped", [12511]], [[13040, 13040], "mapped", [12512]], [[13041, 13041], "mapped", [12513]], [[13042, 13042], "mapped", [12514]], [[13043, 13043], "mapped", [12516]], [[13044, 13044], "mapped", [12518]], [[13045, 13045], "mapped", [12520]], [[13046, 13046], "mapped", [12521]], [[13047, 13047], "mapped", [12522]], [[13048, 13048], "mapped", [12523]], [[13049, 13049], "mapped", [12524]], [[13050, 13050], "mapped", [12525]], [[13051, 13051], "mapped", [12527]], [[13052, 13052], "mapped", [12528]], [[13053, 13053], "mapped", [12529]], [[13054, 13054], "mapped", [12530]], [[13055, 13055], "disallowed"], [[13056, 13056], "mapped", [12450, 12497, 12540, 12488]], [[13057, 13057], "mapped", [12450, 12523, 12501, 12449]], [[13058, 13058], "mapped", [12450, 12531, 12506, 12450]], [[13059, 13059], "mapped", [12450, 12540, 12523]], [[13060, 13060], "mapped", [12452, 12491, 12531, 12464]], [[13061, 13061], "mapped", [12452, 12531, 12481]], [[13062, 13062], "mapped", [12454, 12457, 12531]], [[13063, 13063], "mapped", [12456, 12473, 12463, 12540, 12489]], [[13064, 13064], "mapped", [12456, 12540, 12459, 12540]], [[13065, 13065], "mapped", [12458, 12531, 12473]], [[13066, 13066], "mapped", [12458, 12540, 12512]], [[13067, 13067], "mapped", [12459, 12452, 12522]], [[13068, 13068], "mapped", [12459, 12521, 12483, 12488]], [[13069, 13069], "mapped", [12459, 12525, 12522, 12540]], [[13070, 13070], "mapped", [12460, 12525, 12531]], [[13071, 13071], "mapped", [12460, 12531, 12510]], [[13072, 13072], "mapped", [12462, 12460]], [[13073, 13073], "mapped", [12462, 12491, 12540]], [[13074, 13074], "mapped", [12461, 12517, 12522, 12540]], [[13075, 13075], "mapped", [12462, 12523, 12480, 12540]], [[13076, 13076], "mapped", [12461, 12525]], [[13077, 13077], "mapped", [12461, 12525, 12464, 12521, 12512]], [[13078, 13078], "mapped", [12461, 12525, 12513, 12540, 12488, 12523]], [[13079, 13079], "mapped", [12461, 12525, 12527, 12483, 12488]], [[13080, 13080], "mapped", [12464, 12521, 12512]], [[13081, 13081], "mapped", [12464, 12521, 12512, 12488, 12531]], [[13082, 13082], "mapped", [12463, 12523, 12476, 12452, 12525]], [[13083, 13083], "mapped", [12463, 12525, 12540, 12493]], [[13084, 13084], "mapped", [12465, 12540, 12473]], [[13085, 13085], "mapped", [12467, 12523, 12490]], [[13086, 13086], "mapped", [12467, 12540, 12509]], [[13087, 13087], "mapped", [12469, 12452, 12463, 12523]], [[13088, 13088], "mapped", [12469, 12531, 12481, 12540, 12512]], [[13089, 13089], "mapped", [12471, 12522, 12531, 12464]], [[13090, 13090], "mapped", [12475, 12531, 12481]], [[13091, 13091], "mapped", [12475, 12531, 12488]], [[13092, 13092], "mapped", [12480, 12540, 12473]], [[13093, 13093], "mapped", [12487, 12471]], [[13094, 13094], "mapped", [12489, 12523]], [[13095, 13095], "mapped", [12488, 12531]], [[13096, 13096], "mapped", [12490, 12494]], [[13097, 13097], "mapped", [12494, 12483, 12488]], [[13098, 13098], "mapped", [12495, 12452, 12484]], [[13099, 13099], "mapped", [12497, 12540, 12475, 12531, 12488]], [[13100, 13100], "mapped", [12497, 12540, 12484]], [[13101, 13101], "mapped", [12496, 12540, 12524, 12523]], [[13102, 13102], "mapped", [12500, 12450, 12473, 12488, 12523]], [[13103, 13103], "mapped", [12500, 12463, 12523]], [[13104, 13104], "mapped", [12500, 12467]], [[13105, 13105], "mapped", [12499, 12523]], [[13106, 13106], "mapped", [12501, 12449, 12521, 12483, 12489]], [[13107, 13107], "mapped", [12501, 12451, 12540, 12488]], [[13108, 13108], "mapped", [12502, 12483, 12471, 12455, 12523]], [[13109, 13109], "mapped", [12501, 12521, 12531]], [[13110, 13110], "mapped", [12504, 12463, 12479, 12540, 12523]], [[13111, 13111], "mapped", [12506, 12477]], [[13112, 13112], "mapped", [12506, 12491, 12498]], [[13113, 13113], "mapped", [12504, 12523, 12484]], [[13114, 13114], "mapped", [12506, 12531, 12473]], [[13115, 13115], "mapped", [12506, 12540, 12472]], [[13116, 13116], "mapped", [12505, 12540, 12479]], [[13117, 13117], "mapped", [12509, 12452, 12531, 12488]], [[13118, 13118], "mapped", [12508, 12523, 12488]], [[13119, 13119], "mapped", [12507, 12531]], [[13120, 13120], "mapped", [12509, 12531, 12489]], [[13121, 13121], "mapped", [12507, 12540, 12523]], [[13122, 13122], "mapped", [12507, 12540, 12531]], [[13123, 13123], "mapped", [12510, 12452, 12463, 12525]], [[13124, 13124], "mapped", [12510, 12452, 12523]], [[13125, 13125], "mapped", [12510, 12483, 12495]], [[13126, 13126], "mapped", [12510, 12523, 12463]], [[13127, 13127], "mapped", [12510, 12531, 12471, 12519, 12531]], [[13128, 13128], "mapped", [12511, 12463, 12525, 12531]], [[13129, 13129], "mapped", [12511, 12522]], [[13130, 13130], "mapped", [12511, 12522, 12496, 12540, 12523]], [[13131, 13131], "mapped", [12513, 12460]], [[13132, 13132], "mapped", [12513, 12460, 12488, 12531]], [[13133, 13133], "mapped", [12513, 12540, 12488, 12523]], [[13134, 13134], "mapped", [12516, 12540, 12489]], [[13135, 13135], "mapped", [12516, 12540, 12523]], [[13136, 13136], "mapped", [12518, 12450, 12531]], [[13137, 13137], "mapped", [12522, 12483, 12488, 12523]], [[13138, 13138], "mapped", [12522, 12521]], [[13139, 13139], "mapped", [12523, 12500, 12540]], [[13140, 13140], "mapped", [12523, 12540, 12502, 12523]], [[13141, 13141], "mapped", [12524, 12512]], [[13142, 13142], "mapped", [12524, 12531, 12488, 12466, 12531]], [[13143, 13143], "mapped", [12527, 12483, 12488]], [[13144, 13144], "mapped", [48, 28857]], [[13145, 13145], "mapped", [49, 28857]], [[13146, 13146], "mapped", [50, 28857]], [[13147, 13147], "mapped", [51, 28857]], [[13148, 13148], "mapped", [52, 28857]], [[13149, 13149], "mapped", [53, 28857]], [[13150, 13150], "mapped", [54, 28857]], [[13151, 13151], "mapped", [55, 28857]], [[13152, 13152], "mapped", [56, 28857]], [[13153, 13153], "mapped", [57, 28857]], [[13154, 13154], "mapped", [49, 48, 28857]], [[13155, 13155], "mapped", [49, 49, 28857]], [[13156, 13156], "mapped", [49, 50, 28857]], [[13157, 13157], "mapped", [49, 51, 28857]], [[13158, 13158], "mapped", [49, 52, 28857]], [[13159, 13159], "mapped", [49, 53, 28857]], [[13160, 13160], "mapped", [49, 54, 28857]], [[13161, 13161], "mapped", [49, 55, 28857]], [[13162, 13162], "mapped", [49, 56, 28857]], [[13163, 13163], "mapped", [49, 57, 28857]], [[13164, 13164], "mapped", [50, 48, 28857]], [[13165, 13165], "mapped", [50, 49, 28857]], [[13166, 13166], "mapped", [50, 50, 28857]], [[13167, 13167], "mapped", [50, 51, 28857]], [[13168, 13168], "mapped", [50, 52, 28857]], [[13169, 13169], "mapped", [104, 112, 97]], [[13170, 13170], "mapped", [100, 97]], [[13171, 13171], "mapped", [97, 117]], [[13172, 13172], "mapped", [98, 97, 114]], [[13173, 13173], "mapped", [111, 118]], [[13174, 13174], "mapped", [112, 99]], [[13175, 13175], "mapped", [100, 109]], [[13176, 13176], "mapped", [100, 109, 50]], [[13177, 13177], "mapped", [100, 109, 51]], [[13178, 13178], "mapped", [105, 117]], [[13179, 13179], "mapped", [24179, 25104]], [[13180, 13180], "mapped", [26157, 21644]], [[13181, 13181], "mapped", [22823, 27491]], [[13182, 13182], "mapped", [26126, 27835]], [[13183, 13183], "mapped", [26666, 24335, 20250, 31038]], [[13184, 13184], "mapped", [112, 97]], [[13185, 13185], "mapped", [110, 97]], [[13186, 13186], "mapped", [956, 97]], [[13187, 13187], "mapped", [109, 97]], [[13188, 13188], "mapped", [107, 97]], [[13189, 13189], "mapped", [107, 98]], [[13190, 13190], "mapped", [109, 98]], [[13191, 13191], "mapped", [103, 98]], [[13192, 13192], "mapped", [99, 97, 108]], [[13193, 13193], "mapped", [107, 99, 97, 108]], [[13194, 13194], "mapped", [112, 102]], [[13195, 13195], "mapped", [110, 102]], [[13196, 13196], "mapped", [956, 102]], [[13197, 13197], "mapped", [956, 103]], [[13198, 13198], "mapped", [109, 103]], [[13199, 13199], "mapped", [107, 103]], [[13200, 13200], "mapped", [104, 122]], [[13201, 13201], "mapped", [107, 104, 122]], [[13202, 13202], "mapped", [109, 104, 122]], [[13203, 13203], "mapped", [103, 104, 122]], [[13204, 13204], "mapped", [116, 104, 122]], [[13205, 13205], "mapped", [956, 108]], [[13206, 13206], "mapped", [109, 108]], [[13207, 13207], "mapped", [100, 108]], [[13208, 13208], "mapped", [107, 108]], [[13209, 13209], "mapped", [102, 109]], [[13210, 13210], "mapped", [110, 109]], [[13211, 13211], "mapped", [956, 109]], [[13212, 13212], "mapped", [109, 109]], [[13213, 13213], "mapped", [99, 109]], [[13214, 13214], "mapped", [107, 109]], [[13215, 13215], "mapped", [109, 109, 50]], [[13216, 13216], "mapped", [99, 109, 50]], [[13217, 13217], "mapped", [109, 50]], [[13218, 13218], "mapped", [107, 109, 50]], [[13219, 13219], "mapped", [109, 109, 51]], [[13220, 13220], "mapped", [99, 109, 51]], [[13221, 13221], "mapped", [109, 51]], [[13222, 13222], "mapped", [107, 109, 51]], [[13223, 13223], "mapped", [109, 8725, 115]], [[13224, 13224], "mapped", [109, 8725, 115, 50]], [[13225, 13225], "mapped", [112, 97]], [[13226, 13226], "mapped", [107, 112, 97]], [[13227, 13227], "mapped", [109, 112, 97]], [[13228, 13228], "mapped", [103, 112, 97]], [[13229, 13229], "mapped", [114, 97, 100]], [[13230, 13230], "mapped", [114, 97, 100, 8725, 115]], [[13231, 13231], "mapped", [114, 97, 100, 8725, 115, 50]], [[13232, 13232], "mapped", [112, 115]], [[13233, 13233], "mapped", [110, 115]], [[13234, 13234], "mapped", [956, 115]], [[13235, 13235], "mapped", [109, 115]], [[13236, 13236], "mapped", [112, 118]], [[13237, 13237], "mapped", [110, 118]], [[13238, 13238], "mapped", [956, 118]], [[13239, 13239], "mapped", [109, 118]], [[13240, 13240], "mapped", [107, 118]], [[13241, 13241], "mapped", [109, 118]], [[13242, 13242], "mapped", [112, 119]], [[13243, 13243], "mapped", [110, 119]], [[13244, 13244], "mapped", [956, 119]], [[13245, 13245], "mapped", [109, 119]], [[13246, 13246], "mapped", [107, 119]], [[13247, 13247], "mapped", [109, 119]], [[13248, 13248], "mapped", [107, 969]], [[13249, 13249], "mapped", [109, 969]], [[13250, 13250], "disallowed"], [[13251, 13251], "mapped", [98, 113]], [[13252, 13252], "mapped", [99, 99]], [[13253, 13253], "mapped", [99, 100]], [[13254, 13254], "mapped", [99, 8725, 107, 103]], [[13255, 13255], "disallowed"], [[13256, 13256], "mapped", [100, 98]], [[13257, 13257], "mapped", [103, 121]], [[13258, 13258], "mapped", [104, 97]], [[13259, 13259], "mapped", [104, 112]], [[13260, 13260], "mapped", [105, 110]], [[13261, 13261], "mapped", [107, 107]], [[13262, 13262], "mapped", [107, 109]], [[13263, 13263], "mapped", [107, 116]], [[13264, 13264], "mapped", [108, 109]], [[13265, 13265], "mapped", [108, 110]], [[13266, 13266], "mapped", [108, 111, 103]], [[13267, 13267], "mapped", [108, 120]], [[13268, 13268], "mapped", [109, 98]], [[13269, 13269], "mapped", [109, 105, 108]], [[13270, 13270], "mapped", [109, 111, 108]], [[13271, 13271], "mapped", [112, 104]], [[13272, 13272], "disallowed"], [[13273, 13273], "mapped", [112, 112, 109]], [[13274, 13274], "mapped", [112, 114]], [[13275, 13275], "mapped", [115, 114]], [[13276, 13276], "mapped", [115, 118]], [[13277, 13277], "mapped", [119, 98]], [[13278, 13278], "mapped", [118, 8725, 109]], [[13279, 13279], "mapped", [97, 8725, 109]], [[13280, 13280], "mapped", [49, 26085]], [[13281, 13281], "mapped", [50, 26085]], [[13282, 13282], "mapped", [51, 26085]], [[13283, 13283], "mapped", [52, 26085]], [[13284, 13284], "mapped", [53, 26085]], [[13285, 13285], "mapped", [54, 26085]], [[13286, 13286], "mapped", [55, 26085]], [[13287, 13287], "mapped", [56, 26085]], [[13288, 13288], "mapped", [57, 26085]], [[13289, 13289], "mapped", [49, 48, 26085]], [[13290, 13290], "mapped", [49, 49, 26085]], [[13291, 13291], "mapped", [49, 50, 26085]], [[13292, 13292], "mapped", [49, 51, 26085]], [[13293, 13293], "mapped", [49, 52, 26085]], [[13294, 13294], "mapped", [49, 53, 26085]], [[13295, 13295], "mapped", [49, 54, 26085]], [[13296, 13296], "mapped", [49, 55, 26085]], [[13297, 13297], "mapped", [49, 56, 26085]], [[13298, 13298], "mapped", [49, 57, 26085]], [[13299, 13299], "mapped", [50, 48, 26085]], [[13300, 13300], "mapped", [50, 49, 26085]], [[13301, 13301], "mapped", [50, 50, 26085]], [[13302, 13302], "mapped", [50, 51, 26085]], [[13303, 13303], "mapped", [50, 52, 26085]], [[13304, 13304], "mapped", [50, 53, 26085]], [[13305, 13305], "mapped", [50, 54, 26085]], [[13306, 13306], "mapped", [50, 55, 26085]], [[13307, 13307], "mapped", [50, 56, 26085]], [[13308, 13308], "mapped", [50, 57, 26085]], [[13309, 13309], "mapped", [51, 48, 26085]], [[13310, 13310], "mapped", [51, 49, 26085]], [[13311, 13311], "mapped", [103, 97, 108]], [[13312, 19893], "valid"], [[19894, 19903], "disallowed"], [[19904, 19967], "valid", [], "NV8"], [[19968, 40869], "valid"], [[40870, 40891], "valid"], [[40892, 40899], "valid"], [[40900, 40907], "valid"], [[40908, 40908], "valid"], [[40909, 40917], "valid"], [[40918, 40959], "disallowed"], [[40960, 42124], "valid"], [[42125, 42127], "disallowed"], [[42128, 42145], "valid", [], "NV8"], [[42146, 42147], "valid", [], "NV8"], [[42148, 42163], "valid", [], "NV8"], [[42164, 42164], "valid", [], "NV8"], [[42165, 42176], "valid", [], "NV8"], [[42177, 42177], "valid", [], "NV8"], [[42178, 42180], "valid", [], "NV8"], [[42181, 42181], "valid", [], "NV8"], [[42182, 42182], "valid", [], "NV8"], [[42183, 42191], "disallowed"], [[42192, 42237], "valid"], [[42238, 42239], "valid", [], "NV8"], [[42240, 42508], "valid"], [[42509, 42511], "valid", [], "NV8"], [[42512, 42539], "valid"], [[42540, 42559], "disallowed"], [[42560, 42560], "mapped", [42561]], [[42561, 42561], "valid"], [[42562, 42562], "mapped", [42563]], [[42563, 42563], "valid"], [[42564, 42564], "mapped", [42565]], [[42565, 42565], "valid"], [[42566, 42566], "mapped", [42567]], [[42567, 42567], "valid"], [[42568, 42568], "mapped", [42569]], [[42569, 42569], "valid"], [[42570, 42570], "mapped", [42571]], [[42571, 42571], "valid"], [[42572, 42572], "mapped", [42573]], [[42573, 42573], "valid"], [[42574, 42574], "mapped", [42575]], [[42575, 42575], "valid"], [[42576, 42576], "mapped", [42577]], [[42577, 42577], "valid"], [[42578, 42578], "mapped", [42579]], [[42579, 42579], "valid"], [[42580, 42580], "mapped", [42581]], [[42581, 42581], "valid"], [[42582, 42582], "mapped", [42583]], [[42583, 42583], "valid"], [[42584, 42584], "mapped", [42585]], [[42585, 42585], "valid"], [[42586, 42586], "mapped", [42587]], [[42587, 42587], "valid"], [[42588, 42588], "mapped", [42589]], [[42589, 42589], "valid"], [[42590, 42590], "mapped", [42591]], [[42591, 42591], "valid"], [[42592, 42592], "mapped", [42593]], [[42593, 42593], "valid"], [[42594, 42594], "mapped", [42595]], [[42595, 42595], "valid"], [[42596, 42596], "mapped", [42597]], [[42597, 42597], "valid"], [[42598, 42598], "mapped", [42599]], [[42599, 42599], "valid"], [[42600, 42600], "mapped", [42601]], [[42601, 42601], "valid"], [[42602, 42602], "mapped", [42603]], [[42603, 42603], "valid"], [[42604, 42604], "mapped", [42605]], [[42605, 42607], "valid"], [[42608, 42611], "valid", [], "NV8"], [[42612, 42619], "valid"], [[42620, 42621], "valid"], [[42622, 42622], "valid", [], "NV8"], [[42623, 42623], "valid"], [[42624, 42624], "mapped", [42625]], [[42625, 42625], "valid"], [[42626, 42626], "mapped", [42627]], [[42627, 42627], "valid"], [[42628, 42628], "mapped", [42629]], [[42629, 42629], "valid"], [[42630, 42630], "mapped", [42631]], [[42631, 42631], "valid"], [[42632, 42632], "mapped", [42633]], [[42633, 42633], "valid"], [[42634, 42634], "mapped", [42635]], [[42635, 42635], "valid"], [[42636, 42636], "mapped", [42637]], [[42637, 42637], "valid"], [[42638, 42638], "mapped", [42639]], [[42639, 42639], "valid"], [[42640, 42640], "mapped", [42641]], [[42641, 42641], "valid"], [[42642, 42642], "mapped", [42643]], [[42643, 42643], "valid"], [[42644, 42644], "mapped", [42645]], [[42645, 42645], "valid"], [[42646, 42646], "mapped", [42647]], [[42647, 42647], "valid"], [[42648, 42648], "mapped", [42649]], [[42649, 42649], "valid"], [[42650, 42650], "mapped", [42651]], [[42651, 42651], "valid"], [[42652, 42652], "mapped", [1098]], [[42653, 42653], "mapped", [1100]], [[42654, 42654], "valid"], [[42655, 42655], "valid"], [[42656, 42725], "valid"], [[42726, 42735], "valid", [], "NV8"], [[42736, 42737], "valid"], [[42738, 42743], "valid", [], "NV8"], [[42744, 42751], "disallowed"], [[42752, 42774], "valid", [], "NV8"], [[42775, 42778], "valid"], [[42779, 42783], "valid"], [[42784, 42785], "valid", [], "NV8"], [[42786, 42786], "mapped", [42787]], [[42787, 42787], "valid"], [[42788, 42788], "mapped", [42789]], [[42789, 42789], "valid"], [[42790, 42790], "mapped", [42791]], [[42791, 42791], "valid"], [[42792, 42792], "mapped", [42793]], [[42793, 42793], "valid"], [[42794, 42794], "mapped", [42795]], [[42795, 42795], "valid"], [[42796, 42796], "mapped", [42797]], [[42797, 42797], "valid"], [[42798, 42798], "mapped", [42799]], [[42799, 42801], "valid"], [[42802, 42802], "mapped", [42803]], [[42803, 42803], "valid"], [[42804, 42804], "mapped", [42805]], [[42805, 42805], "valid"], [[42806, 42806], "mapped", [42807]], [[42807, 42807], "valid"], [[42808, 42808], "mapped", [42809]], [[42809, 42809], "valid"], [[42810, 42810], "mapped", [42811]], [[42811, 42811], "valid"], [[42812, 42812], "mapped", [42813]], [[42813, 42813], "valid"], [[42814, 42814], "mapped", [42815]], [[42815, 42815], "valid"], [[42816, 42816], "mapped", [42817]], [[42817, 42817], "valid"], [[42818, 42818], "mapped", [42819]], [[42819, 42819], "valid"], [[42820, 42820], "mapped", [42821]], [[42821, 42821], "valid"], [[42822, 42822], "mapped", [42823]], [[42823, 42823], "valid"], [[42824, 42824], "mapped", [42825]], [[42825, 42825], "valid"], [[42826, 42826], "mapped", [42827]], [[42827, 42827], "valid"], [[42828, 42828], "mapped", [42829]], [[42829, 42829], "valid"], [[42830, 42830], "mapped", [42831]], [[42831, 42831], "valid"], [[42832, 42832], "mapped", [42833]], [[42833, 42833], "valid"], [[42834, 42834], "mapped", [42835]], [[42835, 42835], "valid"], [[42836, 42836], "mapped", [42837]], [[42837, 42837], "valid"], [[42838, 42838], "mapped", [42839]], [[42839, 42839], "valid"], [[42840, 42840], "mapped", [42841]], [[42841, 42841], "valid"], [[42842, 42842], "mapped", [42843]], [[42843, 42843], "valid"], [[42844, 42844], "mapped", [42845]], [[42845, 42845], "valid"], [[42846, 42846], "mapped", [42847]], [[42847, 42847], "valid"], [[42848, 42848], "mapped", [42849]], [[42849, 42849], "valid"], [[42850, 42850], "mapped", [42851]], [[42851, 42851], "valid"], [[42852, 42852], "mapped", [42853]], [[42853, 42853], "valid"], [[42854, 42854], "mapped", [42855]], [[42855, 42855], "valid"], [[42856, 42856], "mapped", [42857]], [[42857, 42857], "valid"], [[42858, 42858], "mapped", [42859]], [[42859, 42859], "valid"], [[42860, 42860], "mapped", [42861]], [[42861, 42861], "valid"], [[42862, 42862], "mapped", [42863]], [[42863, 42863], "valid"], [[42864, 42864], "mapped", [42863]], [[42865, 42872], "valid"], [[42873, 42873], "mapped", [42874]], [[42874, 42874], "valid"], [[42875, 42875], "mapped", [42876]], [[42876, 42876], "valid"], [[42877, 42877], "mapped", [7545]], [[42878, 42878], "mapped", [42879]], [[42879, 42879], "valid"], [[42880, 42880], "mapped", [42881]], [[42881, 42881], "valid"], [[42882, 42882], "mapped", [42883]], [[42883, 42883], "valid"], [[42884, 42884], "mapped", [42885]], [[42885, 42885], "valid"], [[42886, 42886], "mapped", [42887]], [[42887, 42888], "valid"], [[42889, 42890], "valid", [], "NV8"], [[42891, 42891], "mapped", [42892]], [[42892, 42892], "valid"], [[42893, 42893], "mapped", [613]], [[42894, 42894], "valid"], [[42895, 42895], "valid"], [[42896, 42896], "mapped", [42897]], [[42897, 42897], "valid"], [[42898, 42898], "mapped", [42899]], [[42899, 42899], "valid"], [[42900, 42901], "valid"], [[42902, 42902], "mapped", [42903]], [[42903, 42903], "valid"], [[42904, 42904], "mapped", [42905]], [[42905, 42905], "valid"], [[42906, 42906], "mapped", [42907]], [[42907, 42907], "valid"], [[42908, 42908], "mapped", [42909]], [[42909, 42909], "valid"], [[42910, 42910], "mapped", [42911]], [[42911, 42911], "valid"], [[42912, 42912], "mapped", [42913]], [[42913, 42913], "valid"], [[42914, 42914], "mapped", [42915]], [[42915, 42915], "valid"], [[42916, 42916], "mapped", [42917]], [[42917, 42917], "valid"], [[42918, 42918], "mapped", [42919]], [[42919, 42919], "valid"], [[42920, 42920], "mapped", [42921]], [[42921, 42921], "valid"], [[42922, 42922], "mapped", [614]], [[42923, 42923], "mapped", [604]], [[42924, 42924], "mapped", [609]], [[42925, 42925], "mapped", [620]], [[42926, 42927], "disallowed"], [[42928, 42928], "mapped", [670]], [[42929, 42929], "mapped", [647]], [[42930, 42930], "mapped", [669]], [[42931, 42931], "mapped", [43859]], [[42932, 42932], "mapped", [42933]], [[42933, 42933], "valid"], [[42934, 42934], "mapped", [42935]], [[42935, 42935], "valid"], [[42936, 42998], "disallowed"], [[42999, 42999], "valid"], [[43e3, 43e3], "mapped", [295]], [[43001, 43001], "mapped", [339]], [[43002, 43002], "valid"], [[43003, 43007], "valid"], [[43008, 43047], "valid"], [[43048, 43051], "valid", [], "NV8"], [[43052, 43055], "disallowed"], [[43056, 43065], "valid", [], "NV8"], [[43066, 43071], "disallowed"], [[43072, 43123], "valid"], [[43124, 43127], "valid", [], "NV8"], [[43128, 43135], "disallowed"], [[43136, 43204], "valid"], [[43205, 43213], "disallowed"], [[43214, 43215], "valid", [], "NV8"], [[43216, 43225], "valid"], [[43226, 43231], "disallowed"], [[43232, 43255], "valid"], [[43256, 43258], "valid", [], "NV8"], [[43259, 43259], "valid"], [[43260, 43260], "valid", [], "NV8"], [[43261, 43261], "valid"], [[43262, 43263], "disallowed"], [[43264, 43309], "valid"], [[43310, 43311], "valid", [], "NV8"], [[43312, 43347], "valid"], [[43348, 43358], "disallowed"], [[43359, 43359], "valid", [], "NV8"], [[43360, 43388], "valid", [], "NV8"], [[43389, 43391], "disallowed"], [[43392, 43456], "valid"], [[43457, 43469], "valid", [], "NV8"], [[43470, 43470], "disallowed"], [[43471, 43481], "valid"], [[43482, 43485], "disallowed"], [[43486, 43487], "valid", [], "NV8"], [[43488, 43518], "valid"], [[43519, 43519], "disallowed"], [[43520, 43574], "valid"], [[43575, 43583], "disallowed"], [[43584, 43597], "valid"], [[43598, 43599], "disallowed"], [[43600, 43609], "valid"], [[43610, 43611], "disallowed"], [[43612, 43615], "valid", [], "NV8"], [[43616, 43638], "valid"], [[43639, 43641], "valid", [], "NV8"], [[43642, 43643], "valid"], [[43644, 43647], "valid"], [[43648, 43714], "valid"], [[43715, 43738], "disallowed"], [[43739, 43741], "valid"], [[43742, 43743], "valid", [], "NV8"], [[43744, 43759], "valid"], [[43760, 43761], "valid", [], "NV8"], [[43762, 43766], "valid"], [[43767, 43776], "disallowed"], [[43777, 43782], "valid"], [[43783, 43784], "disallowed"], [[43785, 43790], "valid"], [[43791, 43792], "disallowed"], [[43793, 43798], "valid"], [[43799, 43807], "disallowed"], [[43808, 43814], "valid"], [[43815, 43815], "disallowed"], [[43816, 43822], "valid"], [[43823, 43823], "disallowed"], [[43824, 43866], "valid"], [[43867, 43867], "valid", [], "NV8"], [[43868, 43868], "mapped", [42791]], [[43869, 43869], "mapped", [43831]], [[43870, 43870], "mapped", [619]], [[43871, 43871], "mapped", [43858]], [[43872, 43875], "valid"], [[43876, 43877], "valid"], [[43878, 43887], "disallowed"], [[43888, 43888], "mapped", [5024]], [[43889, 43889], "mapped", [5025]], [[43890, 43890], "mapped", [5026]], [[43891, 43891], "mapped", [5027]], [[43892, 43892], "mapped", [5028]], [[43893, 43893], "mapped", [5029]], [[43894, 43894], "mapped", [5030]], [[43895, 43895], "mapped", [5031]], [[43896, 43896], "mapped", [5032]], [[43897, 43897], "mapped", [5033]], [[43898, 43898], "mapped", [5034]], [[43899, 43899], "mapped", [5035]], [[43900, 43900], "mapped", [5036]], [[43901, 43901], "mapped", [5037]], [[43902, 43902], "mapped", [5038]], [[43903, 43903], "mapped", [5039]], [[43904, 43904], "mapped", [5040]], [[43905, 43905], "mapped", [5041]], [[43906, 43906], "mapped", [5042]], [[43907, 43907], "mapped", [5043]], [[43908, 43908], "mapped", [5044]], [[43909, 43909], "mapped", [5045]], [[43910, 43910], "mapped", [5046]], [[43911, 43911], "mapped", [5047]], [[43912, 43912], "mapped", [5048]], [[43913, 43913], "mapped", [5049]], [[43914, 43914], "mapped", [5050]], [[43915, 43915], "mapped", [5051]], [[43916, 43916], "mapped", [5052]], [[43917, 43917], "mapped", [5053]], [[43918, 43918], "mapped", [5054]], [[43919, 43919], "mapped", [5055]], [[43920, 43920], "mapped", [5056]], [[43921, 43921], "mapped", [5057]], [[43922, 43922], "mapped", [5058]], [[43923, 43923], "mapped", [5059]], [[43924, 43924], "mapped", [5060]], [[43925, 43925], "mapped", [5061]], [[43926, 43926], "mapped", [5062]], [[43927, 43927], "mapped", [5063]], [[43928, 43928], "mapped", [5064]], [[43929, 43929], "mapped", [5065]], [[43930, 43930], "mapped", [5066]], [[43931, 43931], "mapped", [5067]], [[43932, 43932], "mapped", [5068]], [[43933, 43933], "mapped", [5069]], [[43934, 43934], "mapped", [5070]], [[43935, 43935], "mapped", [5071]], [[43936, 43936], "mapped", [5072]], [[43937, 43937], "mapped", [5073]], [[43938, 43938], "mapped", [5074]], [[43939, 43939], "mapped", [5075]], [[43940, 43940], "mapped", [5076]], [[43941, 43941], "mapped", [5077]], [[43942, 43942], "mapped", [5078]], [[43943, 43943], "mapped", [5079]], [[43944, 43944], "mapped", [5080]], [[43945, 43945], "mapped", [5081]], [[43946, 43946], "mapped", [5082]], [[43947, 43947], "mapped", [5083]], [[43948, 43948], "mapped", [5084]], [[43949, 43949], "mapped", [5085]], [[43950, 43950], "mapped", [5086]], [[43951, 43951], "mapped", [5087]], [[43952, 43952], "mapped", [5088]], [[43953, 43953], "mapped", [5089]], [[43954, 43954], "mapped", [5090]], [[43955, 43955], "mapped", [5091]], [[43956, 43956], "mapped", [5092]], [[43957, 43957], "mapped", [5093]], [[43958, 43958], "mapped", [5094]], [[43959, 43959], "mapped", [5095]], [[43960, 43960], "mapped", [5096]], [[43961, 43961], "mapped", [5097]], [[43962, 43962], "mapped", [5098]], [[43963, 43963], "mapped", [5099]], [[43964, 43964], "mapped", [5100]], [[43965, 43965], "mapped", [5101]], [[43966, 43966], "mapped", [5102]], [[43967, 43967], "mapped", [5103]], [[43968, 44010], "valid"], [[44011, 44011], "valid", [], "NV8"], [[44012, 44013], "valid"], [[44014, 44015], "disallowed"], [[44016, 44025], "valid"], [[44026, 44031], "disallowed"], [[44032, 55203], "valid"], [[55204, 55215], "disallowed"], [[55216, 55238], "valid", [], "NV8"], [[55239, 55242], "disallowed"], [[55243, 55291], "valid", [], "NV8"], [[55292, 55295], "disallowed"], [[55296, 57343], "disallowed"], [[57344, 63743], "disallowed"], [[63744, 63744], "mapped", [35912]], [[63745, 63745], "mapped", [26356]], [[63746, 63746], "mapped", [36554]], [[63747, 63747], "mapped", [36040]], [[63748, 63748], "mapped", [28369]], [[63749, 63749], "mapped", [20018]], [[63750, 63750], "mapped", [21477]], [[63751, 63752], "mapped", [40860]], [[63753, 63753], "mapped", [22865]], [[63754, 63754], "mapped", [37329]], [[63755, 63755], "mapped", [21895]], [[63756, 63756], "mapped", [22856]], [[63757, 63757], "mapped", [25078]], [[63758, 63758], "mapped", [30313]], [[63759, 63759], "mapped", [32645]], [[63760, 63760], "mapped", [34367]], [[63761, 63761], "mapped", [34746]], [[63762, 63762], "mapped", [35064]], [[63763, 63763], "mapped", [37007]], [[63764, 63764], "mapped", [27138]], [[63765, 63765], "mapped", [27931]], [[63766, 63766], "mapped", [28889]], [[63767, 63767], "mapped", [29662]], [[63768, 63768], "mapped", [33853]], [[63769, 63769], "mapped", [37226]], [[63770, 63770], "mapped", [39409]], [[63771, 63771], "mapped", [20098]], [[63772, 63772], "mapped", [21365]], [[63773, 63773], "mapped", [27396]], [[63774, 63774], "mapped", [29211]], [[63775, 63775], "mapped", [34349]], [[63776, 63776], "mapped", [40478]], [[63777, 63777], "mapped", [23888]], [[63778, 63778], "mapped", [28651]], [[63779, 63779], "mapped", [34253]], [[63780, 63780], "mapped", [35172]], [[63781, 63781], "mapped", [25289]], [[63782, 63782], "mapped", [33240]], [[63783, 63783], "mapped", [34847]], [[63784, 63784], "mapped", [24266]], [[63785, 63785], "mapped", [26391]], [[63786, 63786], "mapped", [28010]], [[63787, 63787], "mapped", [29436]], [[63788, 63788], "mapped", [37070]], [[63789, 63789], "mapped", [20358]], [[63790, 63790], "mapped", [20919]], [[63791, 63791], "mapped", [21214]], [[63792, 63792], "mapped", [25796]], [[63793, 63793], "mapped", [27347]], [[63794, 63794], "mapped", [29200]], [[63795, 63795], "mapped", [30439]], [[63796, 63796], "mapped", [32769]], [[63797, 63797], "mapped", [34310]], [[63798, 63798], "mapped", [34396]], [[63799, 63799], "mapped", [36335]], [[63800, 63800], "mapped", [38706]], [[63801, 63801], "mapped", [39791]], [[63802, 63802], "mapped", [40442]], [[63803, 63803], "mapped", [30860]], [[63804, 63804], "mapped", [31103]], [[63805, 63805], "mapped", [32160]], [[63806, 63806], "mapped", [33737]], [[63807, 63807], "mapped", [37636]], [[63808, 63808], "mapped", [40575]], [[63809, 63809], "mapped", [35542]], [[63810, 63810], "mapped", [22751]], [[63811, 63811], "mapped", [24324]], [[63812, 63812], "mapped", [31840]], [[63813, 63813], "mapped", [32894]], [[63814, 63814], "mapped", [29282]], [[63815, 63815], "mapped", [30922]], [[63816, 63816], "mapped", [36034]], [[63817, 63817], "mapped", [38647]], [[63818, 63818], "mapped", [22744]], [[63819, 63819], "mapped", [23650]], [[63820, 63820], "mapped", [27155]], [[63821, 63821], "mapped", [28122]], [[63822, 63822], "mapped", [28431]], [[63823, 63823], "mapped", [32047]], [[63824, 63824], "mapped", [32311]], [[63825, 63825], "mapped", [38475]], [[63826, 63826], "mapped", [21202]], [[63827, 63827], "mapped", [32907]], [[63828, 63828], "mapped", [20956]], [[63829, 63829], "mapped", [20940]], [[63830, 63830], "mapped", [31260]], [[63831, 63831], "mapped", [32190]], [[63832, 63832], "mapped", [33777]], [[63833, 63833], "mapped", [38517]], [[63834, 63834], "mapped", [35712]], [[63835, 63835], "mapped", [25295]], [[63836, 63836], "mapped", [27138]], [[63837, 63837], "mapped", [35582]], [[63838, 63838], "mapped", [20025]], [[63839, 63839], "mapped", [23527]], [[63840, 63840], "mapped", [24594]], [[63841, 63841], "mapped", [29575]], [[63842, 63842], "mapped", [30064]], [[63843, 63843], "mapped", [21271]], [[63844, 63844], "mapped", [30971]], [[63845, 63845], "mapped", [20415]], [[63846, 63846], "mapped", [24489]], [[63847, 63847], "mapped", [19981]], [[63848, 63848], "mapped", [27852]], [[63849, 63849], "mapped", [25976]], [[63850, 63850], "mapped", [32034]], [[63851, 63851], "mapped", [21443]], [[63852, 63852], "mapped", [22622]], [[63853, 63853], "mapped", [30465]], [[63854, 63854], "mapped", [33865]], [[63855, 63855], "mapped", [35498]], [[63856, 63856], "mapped", [27578]], [[63857, 63857], "mapped", [36784]], [[63858, 63858], "mapped", [27784]], [[63859, 63859], "mapped", [25342]], [[63860, 63860], "mapped", [33509]], [[63861, 63861], "mapped", [25504]], [[63862, 63862], "mapped", [30053]], [[63863, 63863], "mapped", [20142]], [[63864, 63864], "mapped", [20841]], [[63865, 63865], "mapped", [20937]], [[63866, 63866], "mapped", [26753]], [[63867, 63867], "mapped", [31975]], [[63868, 63868], "mapped", [33391]], [[63869, 63869], "mapped", [35538]], [[63870, 63870], "mapped", [37327]], [[63871, 63871], "mapped", [21237]], [[63872, 63872], "mapped", [21570]], [[63873, 63873], "mapped", [22899]], [[63874, 63874], "mapped", [24300]], [[63875, 63875], "mapped", [26053]], [[63876, 63876], "mapped", [28670]], [[63877, 63877], "mapped", [31018]], [[63878, 63878], "mapped", [38317]], [[63879, 63879], "mapped", [39530]], [[63880, 63880], "mapped", [40599]], [[63881, 63881], "mapped", [40654]], [[63882, 63882], "mapped", [21147]], [[63883, 63883], "mapped", [26310]], [[63884, 63884], "mapped", [27511]], [[63885, 63885], "mapped", [36706]], [[63886, 63886], "mapped", [24180]], [[63887, 63887], "mapped", [24976]], [[63888, 63888], "mapped", [25088]], [[63889, 63889], "mapped", [25754]], [[63890, 63890], "mapped", [28451]], [[63891, 63891], "mapped", [29001]], [[63892, 63892], "mapped", [29833]], [[63893, 63893], "mapped", [31178]], [[63894, 63894], "mapped", [32244]], [[63895, 63895], "mapped", [32879]], [[63896, 63896], "mapped", [36646]], [[63897, 63897], "mapped", [34030]], [[63898, 63898], "mapped", [36899]], [[63899, 63899], "mapped", [37706]], [[63900, 63900], "mapped", [21015]], [[63901, 63901], "mapped", [21155]], [[63902, 63902], "mapped", [21693]], [[63903, 63903], "mapped", [28872]], [[63904, 63904], "mapped", [35010]], [[63905, 63905], "mapped", [35498]], [[63906, 63906], "mapped", [24265]], [[63907, 63907], "mapped", [24565]], [[63908, 63908], "mapped", [25467]], [[63909, 63909], "mapped", [27566]], [[63910, 63910], "mapped", [31806]], [[63911, 63911], "mapped", [29557]], [[63912, 63912], "mapped", [20196]], [[63913, 63913], "mapped", [22265]], [[63914, 63914], "mapped", [23527]], [[63915, 63915], "mapped", [23994]], [[63916, 63916], "mapped", [24604]], [[63917, 63917], "mapped", [29618]], [[63918, 63918], "mapped", [29801]], [[63919, 63919], "mapped", [32666]], [[63920, 63920], "mapped", [32838]], [[63921, 63921], "mapped", [37428]], [[63922, 63922], "mapped", [38646]], [[63923, 63923], "mapped", [38728]], [[63924, 63924], "mapped", [38936]], [[63925, 63925], "mapped", [20363]], [[63926, 63926], "mapped", [31150]], [[63927, 63927], "mapped", [37300]], [[63928, 63928], "mapped", [38584]], [[63929, 63929], "mapped", [24801]], [[63930, 63930], "mapped", [20102]], [[63931, 63931], "mapped", [20698]], [[63932, 63932], "mapped", [23534]], [[63933, 63933], "mapped", [23615]], [[63934, 63934], "mapped", [26009]], [[63935, 63935], "mapped", [27138]], [[63936, 63936], "mapped", [29134]], [[63937, 63937], "mapped", [30274]], [[63938, 63938], "mapped", [34044]], [[63939, 63939], "mapped", [36988]], [[63940, 63940], "mapped", [40845]], [[63941, 63941], "mapped", [26248]], [[63942, 63942], "mapped", [38446]], [[63943, 63943], "mapped", [21129]], [[63944, 63944], "mapped", [26491]], [[63945, 63945], "mapped", [26611]], [[63946, 63946], "mapped", [27969]], [[63947, 63947], "mapped", [28316]], [[63948, 63948], "mapped", [29705]], [[63949, 63949], "mapped", [30041]], [[63950, 63950], "mapped", [30827]], [[63951, 63951], "mapped", [32016]], [[63952, 63952], "mapped", [39006]], [[63953, 63953], "mapped", [20845]], [[63954, 63954], "mapped", [25134]], [[63955, 63955], "mapped", [38520]], [[63956, 63956], "mapped", [20523]], [[63957, 63957], "mapped", [23833]], [[63958, 63958], "mapped", [28138]], [[63959, 63959], "mapped", [36650]], [[63960, 63960], "mapped", [24459]], [[63961, 63961], "mapped", [24900]], [[63962, 63962], "mapped", [26647]], [[63963, 63963], "mapped", [29575]], [[63964, 63964], "mapped", [38534]], [[63965, 63965], "mapped", [21033]], [[63966, 63966], "mapped", [21519]], [[63967, 63967], "mapped", [23653]], [[63968, 63968], "mapped", [26131]], [[63969, 63969], "mapped", [26446]], [[63970, 63970], "mapped", [26792]], [[63971, 63971], "mapped", [27877]], [[63972, 63972], "mapped", [29702]], [[63973, 63973], "mapped", [30178]], [[63974, 63974], "mapped", [32633]], [[63975, 63975], "mapped", [35023]], [[63976, 63976], "mapped", [35041]], [[63977, 63977], "mapped", [37324]], [[63978, 63978], "mapped", [38626]], [[63979, 63979], "mapped", [21311]], [[63980, 63980], "mapped", [28346]], [[63981, 63981], "mapped", [21533]], [[63982, 63982], "mapped", [29136]], [[63983, 63983], "mapped", [29848]], [[63984, 63984], "mapped", [34298]], [[63985, 63985], "mapped", [38563]], [[63986, 63986], "mapped", [40023]], [[63987, 63987], "mapped", [40607]], [[63988, 63988], "mapped", [26519]], [[63989, 63989], "mapped", [28107]], [[63990, 63990], "mapped", [33256]], [[63991, 63991], "mapped", [31435]], [[63992, 63992], "mapped", [31520]], [[63993, 63993], "mapped", [31890]], [[63994, 63994], "mapped", [29376]], [[63995, 63995], "mapped", [28825]], [[63996, 63996], "mapped", [35672]], [[63997, 63997], "mapped", [20160]], [[63998, 63998], "mapped", [33590]], [[63999, 63999], "mapped", [21050]], [[64e3, 64e3], "mapped", [20999]], [[64001, 64001], "mapped", [24230]], [[64002, 64002], "mapped", [25299]], [[64003, 64003], "mapped", [31958]], [[64004, 64004], "mapped", [23429]], [[64005, 64005], "mapped", [27934]], [[64006, 64006], "mapped", [26292]], [[64007, 64007], "mapped", [36667]], [[64008, 64008], "mapped", [34892]], [[64009, 64009], "mapped", [38477]], [[64010, 64010], "mapped", [35211]], [[64011, 64011], "mapped", [24275]], [[64012, 64012], "mapped", [20800]], [[64013, 64013], "mapped", [21952]], [[64014, 64015], "valid"], [[64016, 64016], "mapped", [22618]], [[64017, 64017], "valid"], [[64018, 64018], "mapped", [26228]], [[64019, 64020], "valid"], [[64021, 64021], "mapped", [20958]], [[64022, 64022], "mapped", [29482]], [[64023, 64023], "mapped", [30410]], [[64024, 64024], "mapped", [31036]], [[64025, 64025], "mapped", [31070]], [[64026, 64026], "mapped", [31077]], [[64027, 64027], "mapped", [31119]], [[64028, 64028], "mapped", [38742]], [[64029, 64029], "mapped", [31934]], [[64030, 64030], "mapped", [32701]], [[64031, 64031], "valid"], [[64032, 64032], "mapped", [34322]], [[64033, 64033], "valid"], [[64034, 64034], "mapped", [35576]], [[64035, 64036], "valid"], [[64037, 64037], "mapped", [36920]], [[64038, 64038], "mapped", [37117]], [[64039, 64041], "valid"], [[64042, 64042], "mapped", [39151]], [[64043, 64043], "mapped", [39164]], [[64044, 64044], "mapped", [39208]], [[64045, 64045], "mapped", [40372]], [[64046, 64046], "mapped", [37086]], [[64047, 64047], "mapped", [38583]], [[64048, 64048], "mapped", [20398]], [[64049, 64049], "mapped", [20711]], [[64050, 64050], "mapped", [20813]], [[64051, 64051], "mapped", [21193]], [[64052, 64052], "mapped", [21220]], [[64053, 64053], "mapped", [21329]], [[64054, 64054], "mapped", [21917]], [[64055, 64055], "mapped", [22022]], [[64056, 64056], "mapped", [22120]], [[64057, 64057], "mapped", [22592]], [[64058, 64058], "mapped", [22696]], [[64059, 64059], "mapped", [23652]], [[64060, 64060], "mapped", [23662]], [[64061, 64061], "mapped", [24724]], [[64062, 64062], "mapped", [24936]], [[64063, 64063], "mapped", [24974]], [[64064, 64064], "mapped", [25074]], [[64065, 64065], "mapped", [25935]], [[64066, 64066], "mapped", [26082]], [[64067, 64067], "mapped", [26257]], [[64068, 64068], "mapped", [26757]], [[64069, 64069], "mapped", [28023]], [[64070, 64070], "mapped", [28186]], [[64071, 64071], "mapped", [28450]], [[64072, 64072], "mapped", [29038]], [[64073, 64073], "mapped", [29227]], [[64074, 64074], "mapped", [29730]], [[64075, 64075], "mapped", [30865]], [[64076, 64076], "mapped", [31038]], [[64077, 64077], "mapped", [31049]], [[64078, 64078], "mapped", [31048]], [[64079, 64079], "mapped", [31056]], [[64080, 64080], "mapped", [31062]], [[64081, 64081], "mapped", [31069]], [[64082, 64082], "mapped", [31117]], [[64083, 64083], "mapped", [31118]], [[64084, 64084], "mapped", [31296]], [[64085, 64085], "mapped", [31361]], [[64086, 64086], "mapped", [31680]], [[64087, 64087], "mapped", [32244]], [[64088, 64088], "mapped", [32265]], [[64089, 64089], "mapped", [32321]], [[64090, 64090], "mapped", [32626]], [[64091, 64091], "mapped", [32773]], [[64092, 64092], "mapped", [33261]], [[64093, 64094], "mapped", [33401]], [[64095, 64095], "mapped", [33879]], [[64096, 64096], "mapped", [35088]], [[64097, 64097], "mapped", [35222]], [[64098, 64098], "mapped", [35585]], [[64099, 64099], "mapped", [35641]], [[64100, 64100], "mapped", [36051]], [[64101, 64101], "mapped", [36104]], [[64102, 64102], "mapped", [36790]], [[64103, 64103], "mapped", [36920]], [[64104, 64104], "mapped", [38627]], [[64105, 64105], "mapped", [38911]], [[64106, 64106], "mapped", [38971]], [[64107, 64107], "mapped", [24693]], [[64108, 64108], "mapped", [148206]], [[64109, 64109], "mapped", [33304]], [[64110, 64111], "disallowed"], [[64112, 64112], "mapped", [20006]], [[64113, 64113], "mapped", [20917]], [[64114, 64114], "mapped", [20840]], [[64115, 64115], "mapped", [20352]], [[64116, 64116], "mapped", [20805]], [[64117, 64117], "mapped", [20864]], [[64118, 64118], "mapped", [21191]], [[64119, 64119], "mapped", [21242]], [[64120, 64120], "mapped", [21917]], [[64121, 64121], "mapped", [21845]], [[64122, 64122], "mapped", [21913]], [[64123, 64123], "mapped", [21986]], [[64124, 64124], "mapped", [22618]], [[64125, 64125], "mapped", [22707]], [[64126, 64126], "mapped", [22852]], [[64127, 64127], "mapped", [22868]], [[64128, 64128], "mapped", [23138]], [[64129, 64129], "mapped", [23336]], [[64130, 64130], "mapped", [24274]], [[64131, 64131], "mapped", [24281]], [[64132, 64132], "mapped", [24425]], [[64133, 64133], "mapped", [24493]], [[64134, 64134], "mapped", [24792]], [[64135, 64135], "mapped", [24910]], [[64136, 64136], "mapped", [24840]], [[64137, 64137], "mapped", [24974]], [[64138, 64138], "mapped", [24928]], [[64139, 64139], "mapped", [25074]], [[64140, 64140], "mapped", [25140]], [[64141, 64141], "mapped", [25540]], [[64142, 64142], "mapped", [25628]], [[64143, 64143], "mapped", [25682]], [[64144, 64144], "mapped", [25942]], [[64145, 64145], "mapped", [26228]], [[64146, 64146], "mapped", [26391]], [[64147, 64147], "mapped", [26395]], [[64148, 64148], "mapped", [26454]], [[64149, 64149], "mapped", [27513]], [[64150, 64150], "mapped", [27578]], [[64151, 64151], "mapped", [27969]], [[64152, 64152], "mapped", [28379]], [[64153, 64153], "mapped", [28363]], [[64154, 64154], "mapped", [28450]], [[64155, 64155], "mapped", [28702]], [[64156, 64156], "mapped", [29038]], [[64157, 64157], "mapped", [30631]], [[64158, 64158], "mapped", [29237]], [[64159, 64159], "mapped", [29359]], [[64160, 64160], "mapped", [29482]], [[64161, 64161], "mapped", [29809]], [[64162, 64162], "mapped", [29958]], [[64163, 64163], "mapped", [30011]], [[64164, 64164], "mapped", [30237]], [[64165, 64165], "mapped", [30239]], [[64166, 64166], "mapped", [30410]], [[64167, 64167], "mapped", [30427]], [[64168, 64168], "mapped", [30452]], [[64169, 64169], "mapped", [30538]], [[64170, 64170], "mapped", [30528]], [[64171, 64171], "mapped", [30924]], [[64172, 64172], "mapped", [31409]], [[64173, 64173], "mapped", [31680]], [[64174, 64174], "mapped", [31867]], [[64175, 64175], "mapped", [32091]], [[64176, 64176], "mapped", [32244]], [[64177, 64177], "mapped", [32574]], [[64178, 64178], "mapped", [32773]], [[64179, 64179], "mapped", [33618]], [[64180, 64180], "mapped", [33775]], [[64181, 64181], "mapped", [34681]], [[64182, 64182], "mapped", [35137]], [[64183, 64183], "mapped", [35206]], [[64184, 64184], "mapped", [35222]], [[64185, 64185], "mapped", [35519]], [[64186, 64186], "mapped", [35576]], [[64187, 64187], "mapped", [35531]], [[64188, 64188], "mapped", [35585]], [[64189, 64189], "mapped", [35582]], [[64190, 64190], "mapped", [35565]], [[64191, 64191], "mapped", [35641]], [[64192, 64192], "mapped", [35722]], [[64193, 64193], "mapped", [36104]], [[64194, 64194], "mapped", [36664]], [[64195, 64195], "mapped", [36978]], [[64196, 64196], "mapped", [37273]], [[64197, 64197], "mapped", [37494]], [[64198, 64198], "mapped", [38524]], [[64199, 64199], "mapped", [38627]], [[64200, 64200], "mapped", [38742]], [[64201, 64201], "mapped", [38875]], [[64202, 64202], "mapped", [38911]], [[64203, 64203], "mapped", [38923]], [[64204, 64204], "mapped", [38971]], [[64205, 64205], "mapped", [39698]], [[64206, 64206], "mapped", [40860]], [[64207, 64207], "mapped", [141386]], [[64208, 64208], "mapped", [141380]], [[64209, 64209], "mapped", [144341]], [[64210, 64210], "mapped", [15261]], [[64211, 64211], "mapped", [16408]], [[64212, 64212], "mapped", [16441]], [[64213, 64213], "mapped", [152137]], [[64214, 64214], "mapped", [154832]], [[64215, 64215], "mapped", [163539]], [[64216, 64216], "mapped", [40771]], [[64217, 64217], "mapped", [40846]], [[64218, 64255], "disallowed"], [[64256, 64256], "mapped", [102, 102]], [[64257, 64257], "mapped", [102, 105]], [[64258, 64258], "mapped", [102, 108]], [[64259, 64259], "mapped", [102, 102, 105]], [[64260, 64260], "mapped", [102, 102, 108]], [[64261, 64262], "mapped", [115, 116]], [[64263, 64274], "disallowed"], [[64275, 64275], "mapped", [1396, 1398]], [[64276, 64276], "mapped", [1396, 1381]], [[64277, 64277], "mapped", [1396, 1387]], [[64278, 64278], "mapped", [1406, 1398]], [[64279, 64279], "mapped", [1396, 1389]], [[64280, 64284], "disallowed"], [[64285, 64285], "mapped", [1497, 1460]], [[64286, 64286], "valid"], [[64287, 64287], "mapped", [1522, 1463]], [[64288, 64288], "mapped", [1506]], [[64289, 64289], "mapped", [1488]], [[64290, 64290], "mapped", [1491]], [[64291, 64291], "mapped", [1492]], [[64292, 64292], "mapped", [1499]], [[64293, 64293], "mapped", [1500]], [[64294, 64294], "mapped", [1501]], [[64295, 64295], "mapped", [1512]], [[64296, 64296], "mapped", [1514]], [[64297, 64297], "disallowed_STD3_mapped", [43]], [[64298, 64298], "mapped", [1513, 1473]], [[64299, 64299], "mapped", [1513, 1474]], [[64300, 64300], "mapped", [1513, 1468, 1473]], [[64301, 64301], "mapped", [1513, 1468, 1474]], [[64302, 64302], "mapped", [1488, 1463]], [[64303, 64303], "mapped", [1488, 1464]], [[64304, 64304], "mapped", [1488, 1468]], [[64305, 64305], "mapped", [1489, 1468]], [[64306, 64306], "mapped", [1490, 1468]], [[64307, 64307], "mapped", [1491, 1468]], [[64308, 64308], "mapped", [1492, 1468]], [[64309, 64309], "mapped", [1493, 1468]], [[64310, 64310], "mapped", [1494, 1468]], [[64311, 64311], "disallowed"], [[64312, 64312], "mapped", [1496, 1468]], [[64313, 64313], "mapped", [1497, 1468]], [[64314, 64314], "mapped", [1498, 1468]], [[64315, 64315], "mapped", [1499, 1468]], [[64316, 64316], "mapped", [1500, 1468]], [[64317, 64317], "disallowed"], [[64318, 64318], "mapped", [1502, 1468]], [[64319, 64319], "disallowed"], [[64320, 64320], "mapped", [1504, 1468]], [[64321, 64321], "mapped", [1505, 1468]], [[64322, 64322], "disallowed"], [[64323, 64323], "mapped", [1507, 1468]], [[64324, 64324], "mapped", [1508, 1468]], [[64325, 64325], "disallowed"], [[64326, 64326], "mapped", [1510, 1468]], [[64327, 64327], "mapped", [1511, 1468]], [[64328, 64328], "mapped", [1512, 1468]], [[64329, 64329], "mapped", [1513, 1468]], [[64330, 64330], "mapped", [1514, 1468]], [[64331, 64331], "mapped", [1493, 1465]], [[64332, 64332], "mapped", [1489, 1471]], [[64333, 64333], "mapped", [1499, 1471]], [[64334, 64334], "mapped", [1508, 1471]], [[64335, 64335], "mapped", [1488, 1500]], [[64336, 64337], "mapped", [1649]], [[64338, 64341], "mapped", [1659]], [[64342, 64345], "mapped", [1662]], [[64346, 64349], "mapped", [1664]], [[64350, 64353], "mapped", [1658]], [[64354, 64357], "mapped", [1663]], [[64358, 64361], "mapped", [1657]], [[64362, 64365], "mapped", [1700]], [[64366, 64369], "mapped", [1702]], [[64370, 64373], "mapped", [1668]], [[64374, 64377], "mapped", [1667]], [[64378, 64381], "mapped", [1670]], [[64382, 64385], "mapped", [1671]], [[64386, 64387], "mapped", [1677]], [[64388, 64389], "mapped", [1676]], [[64390, 64391], "mapped", [1678]], [[64392, 64393], "mapped", [1672]], [[64394, 64395], "mapped", [1688]], [[64396, 64397], "mapped", [1681]], [[64398, 64401], "mapped", [1705]], [[64402, 64405], "mapped", [1711]], [[64406, 64409], "mapped", [1715]], [[64410, 64413], "mapped", [1713]], [[64414, 64415], "mapped", [1722]], [[64416, 64419], "mapped", [1723]], [[64420, 64421], "mapped", [1728]], [[64422, 64425], "mapped", [1729]], [[64426, 64429], "mapped", [1726]], [[64430, 64431], "mapped", [1746]], [[64432, 64433], "mapped", [1747]], [[64434, 64449], "valid", [], "NV8"], [[64450, 64466], "disallowed"], [[64467, 64470], "mapped", [1709]], [[64471, 64472], "mapped", [1735]], [[64473, 64474], "mapped", [1734]], [[64475, 64476], "mapped", [1736]], [[64477, 64477], "mapped", [1735, 1652]], [[64478, 64479], "mapped", [1739]], [[64480, 64481], "mapped", [1733]], [[64482, 64483], "mapped", [1737]], [[64484, 64487], "mapped", [1744]], [[64488, 64489], "mapped", [1609]], [[64490, 64491], "mapped", [1574, 1575]], [[64492, 64493], "mapped", [1574, 1749]], [[64494, 64495], "mapped", [1574, 1608]], [[64496, 64497], "mapped", [1574, 1735]], [[64498, 64499], "mapped", [1574, 1734]], [[64500, 64501], "mapped", [1574, 1736]], [[64502, 64504], "mapped", [1574, 1744]], [[64505, 64507], "mapped", [1574, 1609]], [[64508, 64511], "mapped", [1740]], [[64512, 64512], "mapped", [1574, 1580]], [[64513, 64513], "mapped", [1574, 1581]], [[64514, 64514], "mapped", [1574, 1605]], [[64515, 64515], "mapped", [1574, 1609]], [[64516, 64516], "mapped", [1574, 1610]], [[64517, 64517], "mapped", [1576, 1580]], [[64518, 64518], "mapped", [1576, 1581]], [[64519, 64519], "mapped", [1576, 1582]], [[64520, 64520], "mapped", [1576, 1605]], [[64521, 64521], "mapped", [1576, 1609]], [[64522, 64522], "mapped", [1576, 1610]], [[64523, 64523], "mapped", [1578, 1580]], [[64524, 64524], "mapped", [1578, 1581]], [[64525, 64525], "mapped", [1578, 1582]], [[64526, 64526], "mapped", [1578, 1605]], [[64527, 64527], "mapped", [1578, 1609]], [[64528, 64528], "mapped", [1578, 1610]], [[64529, 64529], "mapped", [1579, 1580]], [[64530, 64530], "mapped", [1579, 1605]], [[64531, 64531], "mapped", [1579, 1609]], [[64532, 64532], "mapped", [1579, 1610]], [[64533, 64533], "mapped", [1580, 1581]], [[64534, 64534], "mapped", [1580, 1605]], [[64535, 64535], "mapped", [1581, 1580]], [[64536, 64536], "mapped", [1581, 1605]], [[64537, 64537], "mapped", [1582, 1580]], [[64538, 64538], "mapped", [1582, 1581]], [[64539, 64539], "mapped", [1582, 1605]], [[64540, 64540], "mapped", [1587, 1580]], [[64541, 64541], "mapped", [1587, 1581]], [[64542, 64542], "mapped", [1587, 1582]], [[64543, 64543], "mapped", [1587, 1605]], [[64544, 64544], "mapped", [1589, 1581]], [[64545, 64545], "mapped", [1589, 1605]], [[64546, 64546], "mapped", [1590, 1580]], [[64547, 64547], "mapped", [1590, 1581]], [[64548, 64548], "mapped", [1590, 1582]], [[64549, 64549], "mapped", [1590, 1605]], [[64550, 64550], "mapped", [1591, 1581]], [[64551, 64551], "mapped", [1591, 1605]], [[64552, 64552], "mapped", [1592, 1605]], [[64553, 64553], "mapped", [1593, 1580]], [[64554, 64554], "mapped", [1593, 1605]], [[64555, 64555], "mapped", [1594, 1580]], [[64556, 64556], "mapped", [1594, 1605]], [[64557, 64557], "mapped", [1601, 1580]], [[64558, 64558], "mapped", [1601, 1581]], [[64559, 64559], "mapped", [1601, 1582]], [[64560, 64560], "mapped", [1601, 1605]], [[64561, 64561], "mapped", [1601, 1609]], [[64562, 64562], "mapped", [1601, 1610]], [[64563, 64563], "mapped", [1602, 1581]], [[64564, 64564], "mapped", [1602, 1605]], [[64565, 64565], "mapped", [1602, 1609]], [[64566, 64566], "mapped", [1602, 1610]], [[64567, 64567], "mapped", [1603, 1575]], [[64568, 64568], "mapped", [1603, 1580]], [[64569, 64569], "mapped", [1603, 1581]], [[64570, 64570], "mapped", [1603, 1582]], [[64571, 64571], "mapped", [1603, 1604]], [[64572, 64572], "mapped", [1603, 1605]], [[64573, 64573], "mapped", [1603, 1609]], [[64574, 64574], "mapped", [1603, 1610]], [[64575, 64575], "mapped", [1604, 1580]], [[64576, 64576], "mapped", [1604, 1581]], [[64577, 64577], "mapped", [1604, 1582]], [[64578, 64578], "mapped", [1604, 1605]], [[64579, 64579], "mapped", [1604, 1609]], [[64580, 64580], "mapped", [1604, 1610]], [[64581, 64581], "mapped", [1605, 1580]], [[64582, 64582], "mapped", [1605, 1581]], [[64583, 64583], "mapped", [1605, 1582]], [[64584, 64584], "mapped", [1605, 1605]], [[64585, 64585], "mapped", [1605, 1609]], [[64586, 64586], "mapped", [1605, 1610]], [[64587, 64587], "mapped", [1606, 1580]], [[64588, 64588], "mapped", [1606, 1581]], [[64589, 64589], "mapped", [1606, 1582]], [[64590, 64590], "mapped", [1606, 1605]], [[64591, 64591], "mapped", [1606, 1609]], [[64592, 64592], "mapped", [1606, 1610]], [[64593, 64593], "mapped", [1607, 1580]], [[64594, 64594], "mapped", [1607, 1605]], [[64595, 64595], "mapped", [1607, 1609]], [[64596, 64596], "mapped", [1607, 1610]], [[64597, 64597], "mapped", [1610, 1580]], [[64598, 64598], "mapped", [1610, 1581]], [[64599, 64599], "mapped", [1610, 1582]], [[64600, 64600], "mapped", [1610, 1605]], [[64601, 64601], "mapped", [1610, 1609]], [[64602, 64602], "mapped", [1610, 1610]], [[64603, 64603], "mapped", [1584, 1648]], [[64604, 64604], "mapped", [1585, 1648]], [[64605, 64605], "mapped", [1609, 1648]], [[64606, 64606], "disallowed_STD3_mapped", [32, 1612, 1617]], [[64607, 64607], "disallowed_STD3_mapped", [32, 1613, 1617]], [[64608, 64608], "disallowed_STD3_mapped", [32, 1614, 1617]], [[64609, 64609], "disallowed_STD3_mapped", [32, 1615, 1617]], [[64610, 64610], "disallowed_STD3_mapped", [32, 1616, 1617]], [[64611, 64611], "disallowed_STD3_mapped", [32, 1617, 1648]], [[64612, 64612], "mapped", [1574, 1585]], [[64613, 64613], "mapped", [1574, 1586]], [[64614, 64614], "mapped", [1574, 1605]], [[64615, 64615], "mapped", [1574, 1606]], [[64616, 64616], "mapped", [1574, 1609]], [[64617, 64617], "mapped", [1574, 1610]], [[64618, 64618], "mapped", [1576, 1585]], [[64619, 64619], "mapped", [1576, 1586]], [[64620, 64620], "mapped", [1576, 1605]], [[64621, 64621], "mapped", [1576, 1606]], [[64622, 64622], "mapped", [1576, 1609]], [[64623, 64623], "mapped", [1576, 1610]], [[64624, 64624], "mapped", [1578, 1585]], [[64625, 64625], "mapped", [1578, 1586]], [[64626, 64626], "mapped", [1578, 1605]], [[64627, 64627], "mapped", [1578, 1606]], [[64628, 64628], "mapped", [1578, 1609]], [[64629, 64629], "mapped", [1578, 1610]], [[64630, 64630], "mapped", [1579, 1585]], [[64631, 64631], "mapped", [1579, 1586]], [[64632, 64632], "mapped", [1579, 1605]], [[64633, 64633], "mapped", [1579, 1606]], [[64634, 64634], "mapped", [1579, 1609]], [[64635, 64635], "mapped", [1579, 1610]], [[64636, 64636], "mapped", [1601, 1609]], [[64637, 64637], "mapped", [1601, 1610]], [[64638, 64638], "mapped", [1602, 1609]], [[64639, 64639], "mapped", [1602, 1610]], [[64640, 64640], "mapped", [1603, 1575]], [[64641, 64641], "mapped", [1603, 1604]], [[64642, 64642], "mapped", [1603, 1605]], [[64643, 64643], "mapped", [1603, 1609]], [[64644, 64644], "mapped", [1603, 1610]], [[64645, 64645], "mapped", [1604, 1605]], [[64646, 64646], "mapped", [1604, 1609]], [[64647, 64647], "mapped", [1604, 1610]], [[64648, 64648], "mapped", [1605, 1575]], [[64649, 64649], "mapped", [1605, 1605]], [[64650, 64650], "mapped", [1606, 1585]], [[64651, 64651], "mapped", [1606, 1586]], [[64652, 64652], "mapped", [1606, 1605]], [[64653, 64653], "mapped", [1606, 1606]], [[64654, 64654], "mapped", [1606, 1609]], [[64655, 64655], "mapped", [1606, 1610]], [[64656, 64656], "mapped", [1609, 1648]], [[64657, 64657], "mapped", [1610, 1585]], [[64658, 64658], "mapped", [1610, 1586]], [[64659, 64659], "mapped", [1610, 1605]], [[64660, 64660], "mapped", [1610, 1606]], [[64661, 64661], "mapped", [1610, 1609]], [[64662, 64662], "mapped", [1610, 1610]], [[64663, 64663], "mapped", [1574, 1580]], [[64664, 64664], "mapped", [1574, 1581]], [[64665, 64665], "mapped", [1574, 1582]], [[64666, 64666], "mapped", [1574, 1605]], [[64667, 64667], "mapped", [1574, 1607]], [[64668, 64668], "mapped", [1576, 1580]], [[64669, 64669], "mapped", [1576, 1581]], [[64670, 64670], "mapped", [1576, 1582]], [[64671, 64671], "mapped", [1576, 1605]], [[64672, 64672], "mapped", [1576, 1607]], [[64673, 64673], "mapped", [1578, 1580]], [[64674, 64674], "mapped", [1578, 1581]], [[64675, 64675], "mapped", [1578, 1582]], [[64676, 64676], "mapped", [1578, 1605]], [[64677, 64677], "mapped", [1578, 1607]], [[64678, 64678], "mapped", [1579, 1605]], [[64679, 64679], "mapped", [1580, 1581]], [[64680, 64680], "mapped", [1580, 1605]], [[64681, 64681], "mapped", [1581, 1580]], [[64682, 64682], "mapped", [1581, 1605]], [[64683, 64683], "mapped", [1582, 1580]], [[64684, 64684], "mapped", [1582, 1605]], [[64685, 64685], "mapped", [1587, 1580]], [[64686, 64686], "mapped", [1587, 1581]], [[64687, 64687], "mapped", [1587, 1582]], [[64688, 64688], "mapped", [1587, 1605]], [[64689, 64689], "mapped", [1589, 1581]], [[64690, 64690], "mapped", [1589, 1582]], [[64691, 64691], "mapped", [1589, 1605]], [[64692, 64692], "mapped", [1590, 1580]], [[64693, 64693], "mapped", [1590, 1581]], [[64694, 64694], "mapped", [1590, 1582]], [[64695, 64695], "mapped", [1590, 1605]], [[64696, 64696], "mapped", [1591, 1581]], [[64697, 64697], "mapped", [1592, 1605]], [[64698, 64698], "mapped", [1593, 1580]], [[64699, 64699], "mapped", [1593, 1605]], [[64700, 64700], "mapped", [1594, 1580]], [[64701, 64701], "mapped", [1594, 1605]], [[64702, 64702], "mapped", [1601, 1580]], [[64703, 64703], "mapped", [1601, 1581]], [[64704, 64704], "mapped", [1601, 1582]], [[64705, 64705], "mapped", [1601, 1605]], [[64706, 64706], "mapped", [1602, 1581]], [[64707, 64707], "mapped", [1602, 1605]], [[64708, 64708], "mapped", [1603, 1580]], [[64709, 64709], "mapped", [1603, 1581]], [[64710, 64710], "mapped", [1603, 1582]], [[64711, 64711], "mapped", [1603, 1604]], [[64712, 64712], "mapped", [1603, 1605]], [[64713, 64713], "mapped", [1604, 1580]], [[64714, 64714], "mapped", [1604, 1581]], [[64715, 64715], "mapped", [1604, 1582]], [[64716, 64716], "mapped", [1604, 1605]], [[64717, 64717], "mapped", [1604, 1607]], [[64718, 64718], "mapped", [1605, 1580]], [[64719, 64719], "mapped", [1605, 1581]], [[64720, 64720], "mapped", [1605, 1582]], [[64721, 64721], "mapped", [1605, 1605]], [[64722, 64722], "mapped", [1606, 1580]], [[64723, 64723], "mapped", [1606, 1581]], [[64724, 64724], "mapped", [1606, 1582]], [[64725, 64725], "mapped", [1606, 1605]], [[64726, 64726], "mapped", [1606, 1607]], [[64727, 64727], "mapped", [1607, 1580]], [[64728, 64728], "mapped", [1607, 1605]], [[64729, 64729], "mapped", [1607, 1648]], [[64730, 64730], "mapped", [1610, 1580]], [[64731, 64731], "mapped", [1610, 1581]], [[64732, 64732], "mapped", [1610, 1582]], [[64733, 64733], "mapped", [1610, 1605]], [[64734, 64734], "mapped", [1610, 1607]], [[64735, 64735], "mapped", [1574, 1605]], [[64736, 64736], "mapped", [1574, 1607]], [[64737, 64737], "mapped", [1576, 1605]], [[64738, 64738], "mapped", [1576, 1607]], [[64739, 64739], "mapped", [1578, 1605]], [[64740, 64740], "mapped", [1578, 1607]], [[64741, 64741], "mapped", [1579, 1605]], [[64742, 64742], "mapped", [1579, 1607]], [[64743, 64743], "mapped", [1587, 1605]], [[64744, 64744], "mapped", [1587, 1607]], [[64745, 64745], "mapped", [1588, 1605]], [[64746, 64746], "mapped", [1588, 1607]], [[64747, 64747], "mapped", [1603, 1604]], [[64748, 64748], "mapped", [1603, 1605]], [[64749, 64749], "mapped", [1604, 1605]], [[64750, 64750], "mapped", [1606, 1605]], [[64751, 64751], "mapped", [1606, 1607]], [[64752, 64752], "mapped", [1610, 1605]], [[64753, 64753], "mapped", [1610, 1607]], [[64754, 64754], "mapped", [1600, 1614, 1617]], [[64755, 64755], "mapped", [1600, 1615, 1617]], [[64756, 64756], "mapped", [1600, 1616, 1617]], [[64757, 64757], "mapped", [1591, 1609]], [[64758, 64758], "mapped", [1591, 1610]], [[64759, 64759], "mapped", [1593, 1609]], [[64760, 64760], "mapped", [1593, 1610]], [[64761, 64761], "mapped", [1594, 1609]], [[64762, 64762], "mapped", [1594, 1610]], [[64763, 64763], "mapped", [1587, 1609]], [[64764, 64764], "mapped", [1587, 1610]], [[64765, 64765], "mapped", [1588, 1609]], [[64766, 64766], "mapped", [1588, 1610]], [[64767, 64767], "mapped", [1581, 1609]], [[64768, 64768], "mapped", [1581, 1610]], [[64769, 64769], "mapped", [1580, 1609]], [[64770, 64770], "mapped", [1580, 1610]], [[64771, 64771], "mapped", [1582, 1609]], [[64772, 64772], "mapped", [1582, 1610]], [[64773, 64773], "mapped", [1589, 1609]], [[64774, 64774], "mapped", [1589, 1610]], [[64775, 64775], "mapped", [1590, 1609]], [[64776, 64776], "mapped", [1590, 1610]], [[64777, 64777], "mapped", [1588, 1580]], [[64778, 64778], "mapped", [1588, 1581]], [[64779, 64779], "mapped", [1588, 1582]], [[64780, 64780], "mapped", [1588, 1605]], [[64781, 64781], "mapped", [1588, 1585]], [[64782, 64782], "mapped", [1587, 1585]], [[64783, 64783], "mapped", [1589, 1585]], [[64784, 64784], "mapped", [1590, 1585]], [[64785, 64785], "mapped", [1591, 1609]], [[64786, 64786], "mapped", [1591, 1610]], [[64787, 64787], "mapped", [1593, 1609]], [[64788, 64788], "mapped", [1593, 1610]], [[64789, 64789], "mapped", [1594, 1609]], [[64790, 64790], "mapped", [1594, 1610]], [[64791, 64791], "mapped", [1587, 1609]], [[64792, 64792], "mapped", [1587, 1610]], [[64793, 64793], "mapped", [1588, 1609]], [[64794, 64794], "mapped", [1588, 1610]], [[64795, 64795], "mapped", [1581, 1609]], [[64796, 64796], "mapped", [1581, 1610]], [[64797, 64797], "mapped", [1580, 1609]], [[64798, 64798], "mapped", [1580, 1610]], [[64799, 64799], "mapped", [1582, 1609]], [[64800, 64800], "mapped", [1582, 1610]], [[64801, 64801], "mapped", [1589, 1609]], [[64802, 64802], "mapped", [1589, 1610]], [[64803, 64803], "mapped", [1590, 1609]], [[64804, 64804], "mapped", [1590, 1610]], [[64805, 64805], "mapped", [1588, 1580]], [[64806, 64806], "mapped", [1588, 1581]], [[64807, 64807], "mapped", [1588, 1582]], [[64808, 64808], "mapped", [1588, 1605]], [[64809, 64809], "mapped", [1588, 1585]], [[64810, 64810], "mapped", [1587, 1585]], [[64811, 64811], "mapped", [1589, 1585]], [[64812, 64812], "mapped", [1590, 1585]], [[64813, 64813], "mapped", [1588, 1580]], [[64814, 64814], "mapped", [1588, 1581]], [[64815, 64815], "mapped", [1588, 1582]], [[64816, 64816], "mapped", [1588, 1605]], [[64817, 64817], "mapped", [1587, 1607]], [[64818, 64818], "mapped", [1588, 1607]], [[64819, 64819], "mapped", [1591, 1605]], [[64820, 64820], "mapped", [1587, 1580]], [[64821, 64821], "mapped", [1587, 1581]], [[64822, 64822], "mapped", [1587, 1582]], [[64823, 64823], "mapped", [1588, 1580]], [[64824, 64824], "mapped", [1588, 1581]], [[64825, 64825], "mapped", [1588, 1582]], [[64826, 64826], "mapped", [1591, 1605]], [[64827, 64827], "mapped", [1592, 1605]], [[64828, 64829], "mapped", [1575, 1611]], [[64830, 64831], "valid", [], "NV8"], [[64832, 64847], "disallowed"], [[64848, 64848], "mapped", [1578, 1580, 1605]], [[64849, 64850], "mapped", [1578, 1581, 1580]], [[64851, 64851], "mapped", [1578, 1581, 1605]], [[64852, 64852], "mapped", [1578, 1582, 1605]], [[64853, 64853], "mapped", [1578, 1605, 1580]], [[64854, 64854], "mapped", [1578, 1605, 1581]], [[64855, 64855], "mapped", [1578, 1605, 1582]], [[64856, 64857], "mapped", [1580, 1605, 1581]], [[64858, 64858], "mapped", [1581, 1605, 1610]], [[64859, 64859], "mapped", [1581, 1605, 1609]], [[64860, 64860], "mapped", [1587, 1581, 1580]], [[64861, 64861], "mapped", [1587, 1580, 1581]], [[64862, 64862], "mapped", [1587, 1580, 1609]], [[64863, 64864], "mapped", [1587, 1605, 1581]], [[64865, 64865], "mapped", [1587, 1605, 1580]], [[64866, 64867], "mapped", [1587, 1605, 1605]], [[64868, 64869], "mapped", [1589, 1581, 1581]], [[64870, 64870], "mapped", [1589, 1605, 1605]], [[64871, 64872], "mapped", [1588, 1581, 1605]], [[64873, 64873], "mapped", [1588, 1580, 1610]], [[64874, 64875], "mapped", [1588, 1605, 1582]], [[64876, 64877], "mapped", [1588, 1605, 1605]], [[64878, 64878], "mapped", [1590, 1581, 1609]], [[64879, 64880], "mapped", [1590, 1582, 1605]], [[64881, 64882], "mapped", [1591, 1605, 1581]], [[64883, 64883], "mapped", [1591, 1605, 1605]], [[64884, 64884], "mapped", [1591, 1605, 1610]], [[64885, 64885], "mapped", [1593, 1580, 1605]], [[64886, 64887], "mapped", [1593, 1605, 1605]], [[64888, 64888], "mapped", [1593, 1605, 1609]], [[64889, 64889], "mapped", [1594, 1605, 1605]], [[64890, 64890], "mapped", [1594, 1605, 1610]], [[64891, 64891], "mapped", [1594, 1605, 1609]], [[64892, 64893], "mapped", [1601, 1582, 1605]], [[64894, 64894], "mapped", [1602, 1605, 1581]], [[64895, 64895], "mapped", [1602, 1605, 1605]], [[64896, 64896], "mapped", [1604, 1581, 1605]], [[64897, 64897], "mapped", [1604, 1581, 1610]], [[64898, 64898], "mapped", [1604, 1581, 1609]], [[64899, 64900], "mapped", [1604, 1580, 1580]], [[64901, 64902], "mapped", [1604, 1582, 1605]], [[64903, 64904], "mapped", [1604, 1605, 1581]], [[64905, 64905], "mapped", [1605, 1581, 1580]], [[64906, 64906], "mapped", [1605, 1581, 1605]], [[64907, 64907], "mapped", [1605, 1581, 1610]], [[64908, 64908], "mapped", [1605, 1580, 1581]], [[64909, 64909], "mapped", [1605, 1580, 1605]], [[64910, 64910], "mapped", [1605, 1582, 1580]], [[64911, 64911], "mapped", [1605, 1582, 1605]], [[64912, 64913], "disallowed"], [[64914, 64914], "mapped", [1605, 1580, 1582]], [[64915, 64915], "mapped", [1607, 1605, 1580]], [[64916, 64916], "mapped", [1607, 1605, 1605]], [[64917, 64917], "mapped", [1606, 1581, 1605]], [[64918, 64918], "mapped", [1606, 1581, 1609]], [[64919, 64920], "mapped", [1606, 1580, 1605]], [[64921, 64921], "mapped", [1606, 1580, 1609]], [[64922, 64922], "mapped", [1606, 1605, 1610]], [[64923, 64923], "mapped", [1606, 1605, 1609]], [[64924, 64925], "mapped", [1610, 1605, 1605]], [[64926, 64926], "mapped", [1576, 1582, 1610]], [[64927, 64927], "mapped", [1578, 1580, 1610]], [[64928, 64928], "mapped", [1578, 1580, 1609]], [[64929, 64929], "mapped", [1578, 1582, 1610]], [[64930, 64930], "mapped", [1578, 1582, 1609]], [[64931, 64931], "mapped", [1578, 1605, 1610]], [[64932, 64932], "mapped", [1578, 1605, 1609]], [[64933, 64933], "mapped", [1580, 1605, 1610]], [[64934, 64934], "mapped", [1580, 1581, 1609]], [[64935, 64935], "mapped", [1580, 1605, 1609]], [[64936, 64936], "mapped", [1587, 1582, 1609]], [[64937, 64937], "mapped", [1589, 1581, 1610]], [[64938, 64938], "mapped", [1588, 1581, 1610]], [[64939, 64939], "mapped", [1590, 1581, 1610]], [[64940, 64940], "mapped", [1604, 1580, 1610]], [[64941, 64941], "mapped", [1604, 1605, 1610]], [[64942, 64942], "mapped", [1610, 1581, 1610]], [[64943, 64943], "mapped", [1610, 1580, 1610]], [[64944, 64944], "mapped", [1610, 1605, 1610]], [[64945, 64945], "mapped", [1605, 1605, 1610]], [[64946, 64946], "mapped", [1602, 1605, 1610]], [[64947, 64947], "mapped", [1606, 1581, 1610]], [[64948, 64948], "mapped", [1602, 1605, 1581]], [[64949, 64949], "mapped", [1604, 1581, 1605]], [[64950, 64950], "mapped", [1593, 1605, 1610]], [[64951, 64951], "mapped", [1603, 1605, 1610]], [[64952, 64952], "mapped", [1606, 1580, 1581]], [[64953, 64953], "mapped", [1605, 1582, 1610]], [[64954, 64954], "mapped", [1604, 1580, 1605]], [[64955, 64955], "mapped", [1603, 1605, 1605]], [[64956, 64956], "mapped", [1604, 1580, 1605]], [[64957, 64957], "mapped", [1606, 1580, 1581]], [[64958, 64958], "mapped", [1580, 1581, 1610]], [[64959, 64959], "mapped", [1581, 1580, 1610]], [[64960, 64960], "mapped", [1605, 1580, 1610]], [[64961, 64961], "mapped", [1601, 1605, 1610]], [[64962, 64962], "mapped", [1576, 1581, 1610]], [[64963, 64963], "mapped", [1603, 1605, 1605]], [[64964, 64964], "mapped", [1593, 1580, 1605]], [[64965, 64965], "mapped", [1589, 1605, 1605]], [[64966, 64966], "mapped", [1587, 1582, 1610]], [[64967, 64967], "mapped", [1606, 1580, 1610]], [[64968, 64975], "disallowed"], [[64976, 65007], "disallowed"], [[65008, 65008], "mapped", [1589, 1604, 1746]], [[65009, 65009], "mapped", [1602, 1604, 1746]], [[65010, 65010], "mapped", [1575, 1604, 1604, 1607]], [[65011, 65011], "mapped", [1575, 1603, 1576, 1585]], [[65012, 65012], "mapped", [1605, 1581, 1605, 1583]], [[65013, 65013], "mapped", [1589, 1604, 1593, 1605]], [[65014, 65014], "mapped", [1585, 1587, 1608, 1604]], [[65015, 65015], "mapped", [1593, 1604, 1610, 1607]], [[65016, 65016], "mapped", [1608, 1587, 1604, 1605]], [[65017, 65017], "mapped", [1589, 1604, 1609]], [[65018, 65018], "disallowed_STD3_mapped", [1589, 1604, 1609, 32, 1575, 1604, 1604, 1607, 32, 1593, 1604, 1610, 1607, 32, 1608, 1587, 1604, 1605]], [[65019, 65019], "disallowed_STD3_mapped", [1580, 1604, 32, 1580, 1604, 1575, 1604, 1607]], [[65020, 65020], "mapped", [1585, 1740, 1575, 1604]], [[65021, 65021], "valid", [], "NV8"], [[65022, 65023], "disallowed"], [[65024, 65039], "ignored"], [[65040, 65040], "disallowed_STD3_mapped", [44]], [[65041, 65041], "mapped", [12289]], [[65042, 65042], "disallowed"], [[65043, 65043], "disallowed_STD3_mapped", [58]], [[65044, 65044], "disallowed_STD3_mapped", [59]], [[65045, 65045], "disallowed_STD3_mapped", [33]], [[65046, 65046], "disallowed_STD3_mapped", [63]], [[65047, 65047], "mapped", [12310]], [[65048, 65048], "mapped", [12311]], [[65049, 65049], "disallowed"], [[65050, 65055], "disallowed"], [[65056, 65059], "valid"], [[65060, 65062], "valid"], [[65063, 65069], "valid"], [[65070, 65071], "valid"], [[65072, 65072], "disallowed"], [[65073, 65073], "mapped", [8212]], [[65074, 65074], "mapped", [8211]], [[65075, 65076], "disallowed_STD3_mapped", [95]], [[65077, 65077], "disallowed_STD3_mapped", [40]], [[65078, 65078], "disallowed_STD3_mapped", [41]], [[65079, 65079], "disallowed_STD3_mapped", [123]], [[65080, 65080], "disallowed_STD3_mapped", [125]], [[65081, 65081], "mapped", [12308]], [[65082, 65082], "mapped", [12309]], [[65083, 65083], "mapped", [12304]], [[65084, 65084], "mapped", [12305]], [[65085, 65085], "mapped", [12298]], [[65086, 65086], "mapped", [12299]], [[65087, 65087], "mapped", [12296]], [[65088, 65088], "mapped", [12297]], [[65089, 65089], "mapped", [12300]], [[65090, 65090], "mapped", [12301]], [[65091, 65091], "mapped", [12302]], [[65092, 65092], "mapped", [12303]], [[65093, 65094], "valid", [], "NV8"], [[65095, 65095], "disallowed_STD3_mapped", [91]], [[65096, 65096], "disallowed_STD3_mapped", [93]], [[65097, 65100], "disallowed_STD3_mapped", [32, 773]], [[65101, 65103], "disallowed_STD3_mapped", [95]], [[65104, 65104], "disallowed_STD3_mapped", [44]], [[65105, 65105], "mapped", [12289]], [[65106, 65106], "disallowed"], [[65107, 65107], "disallowed"], [[65108, 65108], "disallowed_STD3_mapped", [59]], [[65109, 65109], "disallowed_STD3_mapped", [58]], [[65110, 65110], "disallowed_STD3_mapped", [63]], [[65111, 65111], "disallowed_STD3_mapped", [33]], [[65112, 65112], "mapped", [8212]], [[65113, 65113], "disallowed_STD3_mapped", [40]], [[65114, 65114], "disallowed_STD3_mapped", [41]], [[65115, 65115], "disallowed_STD3_mapped", [123]], [[65116, 65116], "disallowed_STD3_mapped", [125]], [[65117, 65117], "mapped", [12308]], [[65118, 65118], "mapped", [12309]], [[65119, 65119], "disallowed_STD3_mapped", [35]], [[65120, 65120], "disallowed_STD3_mapped", [38]], [[65121, 65121], "disallowed_STD3_mapped", [42]], [[65122, 65122], "disallowed_STD3_mapped", [43]], [[65123, 65123], "mapped", [45]], [[65124, 65124], "disallowed_STD3_mapped", [60]], [[65125, 65125], "disallowed_STD3_mapped", [62]], [[65126, 65126], "disallowed_STD3_mapped", [61]], [[65127, 65127], "disallowed"], [[65128, 65128], "disallowed_STD3_mapped", [92]], [[65129, 65129], "disallowed_STD3_mapped", [36]], [[65130, 65130], "disallowed_STD3_mapped", [37]], [[65131, 65131], "disallowed_STD3_mapped", [64]], [[65132, 65135], "disallowed"], [[65136, 65136], "disallowed_STD3_mapped", [32, 1611]], [[65137, 65137], "mapped", [1600, 1611]], [[65138, 65138], "disallowed_STD3_mapped", [32, 1612]], [[65139, 65139], "valid"], [[65140, 65140], "disallowed_STD3_mapped", [32, 1613]], [[65141, 65141], "disallowed"], [[65142, 65142], "disallowed_STD3_mapped", [32, 1614]], [[65143, 65143], "mapped", [1600, 1614]], [[65144, 65144], "disallowed_STD3_mapped", [32, 1615]], [[65145, 65145], "mapped", [1600, 1615]], [[65146, 65146], "disallowed_STD3_mapped", [32, 1616]], [[65147, 65147], "mapped", [1600, 1616]], [[65148, 65148], "disallowed_STD3_mapped", [32, 1617]], [[65149, 65149], "mapped", [1600, 1617]], [[65150, 65150], "disallowed_STD3_mapped", [32, 1618]], [[65151, 65151], "mapped", [1600, 1618]], [[65152, 65152], "mapped", [1569]], [[65153, 65154], "mapped", [1570]], [[65155, 65156], "mapped", [1571]], [[65157, 65158], "mapped", [1572]], [[65159, 65160], "mapped", [1573]], [[65161, 65164], "mapped", [1574]], [[65165, 65166], "mapped", [1575]], [[65167, 65170], "mapped", [1576]], [[65171, 65172], "mapped", [1577]], [[65173, 65176], "mapped", [1578]], [[65177, 65180], "mapped", [1579]], [[65181, 65184], "mapped", [1580]], [[65185, 65188], "mapped", [1581]], [[65189, 65192], "mapped", [1582]], [[65193, 65194], "mapped", [1583]], [[65195, 65196], "mapped", [1584]], [[65197, 65198], "mapped", [1585]], [[65199, 65200], "mapped", [1586]], [[65201, 65204], "mapped", [1587]], [[65205, 65208], "mapped", [1588]], [[65209, 65212], "mapped", [1589]], [[65213, 65216], "mapped", [1590]], [[65217, 65220], "mapped", [1591]], [[65221, 65224], "mapped", [1592]], [[65225, 65228], "mapped", [1593]], [[65229, 65232], "mapped", [1594]], [[65233, 65236], "mapped", [1601]], [[65237, 65240], "mapped", [1602]], [[65241, 65244], "mapped", [1603]], [[65245, 65248], "mapped", [1604]], [[65249, 65252], "mapped", [1605]], [[65253, 65256], "mapped", [1606]], [[65257, 65260], "mapped", [1607]], [[65261, 65262], "mapped", [1608]], [[65263, 65264], "mapped", [1609]], [[65265, 65268], "mapped", [1610]], [[65269, 65270], "mapped", [1604, 1570]], [[65271, 65272], "mapped", [1604, 1571]], [[65273, 65274], "mapped", [1604, 1573]], [[65275, 65276], "mapped", [1604, 1575]], [[65277, 65278], "disallowed"], [[65279, 65279], "ignored"], [[65280, 65280], "disallowed"], [[65281, 65281], "disallowed_STD3_mapped", [33]], [[65282, 65282], "disallowed_STD3_mapped", [34]], [[65283, 65283], "disallowed_STD3_mapped", [35]], [[65284, 65284], "disallowed_STD3_mapped", [36]], [[65285, 65285], "disallowed_STD3_mapped", [37]], [[65286, 65286], "disallowed_STD3_mapped", [38]], [[65287, 65287], "disallowed_STD3_mapped", [39]], [[65288, 65288], "disallowed_STD3_mapped", [40]], [[65289, 65289], "disallowed_STD3_mapped", [41]], [[65290, 65290], "disallowed_STD3_mapped", [42]], [[65291, 65291], "disallowed_STD3_mapped", [43]], [[65292, 65292], "disallowed_STD3_mapped", [44]], [[65293, 65293], "mapped", [45]], [[65294, 65294], "mapped", [46]], [[65295, 65295], "disallowed_STD3_mapped", [47]], [[65296, 65296], "mapped", [48]], [[65297, 65297], "mapped", [49]], [[65298, 65298], "mapped", [50]], [[65299, 65299], "mapped", [51]], [[65300, 65300], "mapped", [52]], [[65301, 65301], "mapped", [53]], [[65302, 65302], "mapped", [54]], [[65303, 65303], "mapped", [55]], [[65304, 65304], "mapped", [56]], [[65305, 65305], "mapped", [57]], [[65306, 65306], "disallowed_STD3_mapped", [58]], [[65307, 65307], "disallowed_STD3_mapped", [59]], [[65308, 65308], "disallowed_STD3_mapped", [60]], [[65309, 65309], "disallowed_STD3_mapped", [61]], [[65310, 65310], "disallowed_STD3_mapped", [62]], [[65311, 65311], "disallowed_STD3_mapped", [63]], [[65312, 65312], "disallowed_STD3_mapped", [64]], [[65313, 65313], "mapped", [97]], [[65314, 65314], "mapped", [98]], [[65315, 65315], "mapped", [99]], [[65316, 65316], "mapped", [100]], [[65317, 65317], "mapped", [101]], [[65318, 65318], "mapped", [102]], [[65319, 65319], "mapped", [103]], [[65320, 65320], "mapped", [104]], [[65321, 65321], "mapped", [105]], [[65322, 65322], "mapped", [106]], [[65323, 65323], "mapped", [107]], [[65324, 65324], "mapped", [108]], [[65325, 65325], "mapped", [109]], [[65326, 65326], "mapped", [110]], [[65327, 65327], "mapped", [111]], [[65328, 65328], "mapped", [112]], [[65329, 65329], "mapped", [113]], [[65330, 65330], "mapped", [114]], [[65331, 65331], "mapped", [115]], [[65332, 65332], "mapped", [116]], [[65333, 65333], "mapped", [117]], [[65334, 65334], "mapped", [118]], [[65335, 65335], "mapped", [119]], [[65336, 65336], "mapped", [120]], [[65337, 65337], "mapped", [121]], [[65338, 65338], "mapped", [122]], [[65339, 65339], "disallowed_STD3_mapped", [91]], [[65340, 65340], "disallowed_STD3_mapped", [92]], [[65341, 65341], "disallowed_STD3_mapped", [93]], [[65342, 65342], "disallowed_STD3_mapped", [94]], [[65343, 65343], "disallowed_STD3_mapped", [95]], [[65344, 65344], "disallowed_STD3_mapped", [96]], [[65345, 65345], "mapped", [97]], [[65346, 65346], "mapped", [98]], [[65347, 65347], "mapped", [99]], [[65348, 65348], "mapped", [100]], [[65349, 65349], "mapped", [101]], [[65350, 65350], "mapped", [102]], [[65351, 65351], "mapped", [103]], [[65352, 65352], "mapped", [104]], [[65353, 65353], "mapped", [105]], [[65354, 65354], "mapped", [106]], [[65355, 65355], "mapped", [107]], [[65356, 65356], "mapped", [108]], [[65357, 65357], "mapped", [109]], [[65358, 65358], "mapped", [110]], [[65359, 65359], "mapped", [111]], [[65360, 65360], "mapped", [112]], [[65361, 65361], "mapped", [113]], [[65362, 65362], "mapped", [114]], [[65363, 65363], "mapped", [115]], [[65364, 65364], "mapped", [116]], [[65365, 65365], "mapped", [117]], [[65366, 65366], "mapped", [118]], [[65367, 65367], "mapped", [119]], [[65368, 65368], "mapped", [120]], [[65369, 65369], "mapped", [121]], [[65370, 65370], "mapped", [122]], [[65371, 65371], "disallowed_STD3_mapped", [123]], [[65372, 65372], "disallowed_STD3_mapped", [124]], [[65373, 65373], "disallowed_STD3_mapped", [125]], [[65374, 65374], "disallowed_STD3_mapped", [126]], [[65375, 65375], "mapped", [10629]], [[65376, 65376], "mapped", [10630]], [[65377, 65377], "mapped", [46]], [[65378, 65378], "mapped", [12300]], [[65379, 65379], "mapped", [12301]], [[65380, 65380], "mapped", [12289]], [[65381, 65381], "mapped", [12539]], [[65382, 65382], "mapped", [12530]], [[65383, 65383], "mapped", [12449]], [[65384, 65384], "mapped", [12451]], [[65385, 65385], "mapped", [12453]], [[65386, 65386], "mapped", [12455]], [[65387, 65387], "mapped", [12457]], [[65388, 65388], "mapped", [12515]], [[65389, 65389], "mapped", [12517]], [[65390, 65390], "mapped", [12519]], [[65391, 65391], "mapped", [12483]], [[65392, 65392], "mapped", [12540]], [[65393, 65393], "mapped", [12450]], [[65394, 65394], "mapped", [12452]], [[65395, 65395], "mapped", [12454]], [[65396, 65396], "mapped", [12456]], [[65397, 65397], "mapped", [12458]], [[65398, 65398], "mapped", [12459]], [[65399, 65399], "mapped", [12461]], [[65400, 65400], "mapped", [12463]], [[65401, 65401], "mapped", [12465]], [[65402, 65402], "mapped", [12467]], [[65403, 65403], "mapped", [12469]], [[65404, 65404], "mapped", [12471]], [[65405, 65405], "mapped", [12473]], [[65406, 65406], "mapped", [12475]], [[65407, 65407], "mapped", [12477]], [[65408, 65408], "mapped", [12479]], [[65409, 65409], "mapped", [12481]], [[65410, 65410], "mapped", [12484]], [[65411, 65411], "mapped", [12486]], [[65412, 65412], "mapped", [12488]], [[65413, 65413], "mapped", [12490]], [[65414, 65414], "mapped", [12491]], [[65415, 65415], "mapped", [12492]], [[65416, 65416], "mapped", [12493]], [[65417, 65417], "mapped", [12494]], [[65418, 65418], "mapped", [12495]], [[65419, 65419], "mapped", [12498]], [[65420, 65420], "mapped", [12501]], [[65421, 65421], "mapped", [12504]], [[65422, 65422], "mapped", [12507]], [[65423, 65423], "mapped", [12510]], [[65424, 65424], "mapped", [12511]], [[65425, 65425], "mapped", [12512]], [[65426, 65426], "mapped", [12513]], [[65427, 65427], "mapped", [12514]], [[65428, 65428], "mapped", [12516]], [[65429, 65429], "mapped", [12518]], [[65430, 65430], "mapped", [12520]], [[65431, 65431], "mapped", [12521]], [[65432, 65432], "mapped", [12522]], [[65433, 65433], "mapped", [12523]], [[65434, 65434], "mapped", [12524]], [[65435, 65435], "mapped", [12525]], [[65436, 65436], "mapped", [12527]], [[65437, 65437], "mapped", [12531]], [[65438, 65438], "mapped", [12441]], [[65439, 65439], "mapped", [12442]], [[65440, 65440], "disallowed"], [[65441, 65441], "mapped", [4352]], [[65442, 65442], "mapped", [4353]], [[65443, 65443], "mapped", [4522]], [[65444, 65444], "mapped", [4354]], [[65445, 65445], "mapped", [4524]], [[65446, 65446], "mapped", [4525]], [[65447, 65447], "mapped", [4355]], [[65448, 65448], "mapped", [4356]], [[65449, 65449], "mapped", [4357]], [[65450, 65450], "mapped", [4528]], [[65451, 65451], "mapped", [4529]], [[65452, 65452], "mapped", [4530]], [[65453, 65453], "mapped", [4531]], [[65454, 65454], "mapped", [4532]], [[65455, 65455], "mapped", [4533]], [[65456, 65456], "mapped", [4378]], [[65457, 65457], "mapped", [4358]], [[65458, 65458], "mapped", [4359]], [[65459, 65459], "mapped", [4360]], [[65460, 65460], "mapped", [4385]], [[65461, 65461], "mapped", [4361]], [[65462, 65462], "mapped", [4362]], [[65463, 65463], "mapped", [4363]], [[65464, 65464], "mapped", [4364]], [[65465, 65465], "mapped", [4365]], [[65466, 65466], "mapped", [4366]], [[65467, 65467], "mapped", [4367]], [[65468, 65468], "mapped", [4368]], [[65469, 65469], "mapped", [4369]], [[65470, 65470], "mapped", [4370]], [[65471, 65473], "disallowed"], [[65474, 65474], "mapped", [4449]], [[65475, 65475], "mapped", [4450]], [[65476, 65476], "mapped", [4451]], [[65477, 65477], "mapped", [4452]], [[65478, 65478], "mapped", [4453]], [[65479, 65479], "mapped", [4454]], [[65480, 65481], "disallowed"], [[65482, 65482], "mapped", [4455]], [[65483, 65483], "mapped", [4456]], [[65484, 65484], "mapped", [4457]], [[65485, 65485], "mapped", [4458]], [[65486, 65486], "mapped", [4459]], [[65487, 65487], "mapped", [4460]], [[65488, 65489], "disallowed"], [[65490, 65490], "mapped", [4461]], [[65491, 65491], "mapped", [4462]], [[65492, 65492], "mapped", [4463]], [[65493, 65493], "mapped", [4464]], [[65494, 65494], "mapped", [4465]], [[65495, 65495], "mapped", [4466]], [[65496, 65497], "disallowed"], [[65498, 65498], "mapped", [4467]], [[65499, 65499], "mapped", [4468]], [[65500, 65500], "mapped", [4469]], [[65501, 65503], "disallowed"], [[65504, 65504], "mapped", [162]], [[65505, 65505], "mapped", [163]], [[65506, 65506], "mapped", [172]], [[65507, 65507], "disallowed_STD3_mapped", [32, 772]], [[65508, 65508], "mapped", [166]], [[65509, 65509], "mapped", [165]], [[65510, 65510], "mapped", [8361]], [[65511, 65511], "disallowed"], [[65512, 65512], "mapped", [9474]], [[65513, 65513], "mapped", [8592]], [[65514, 65514], "mapped", [8593]], [[65515, 65515], "mapped", [8594]], [[65516, 65516], "mapped", [8595]], [[65517, 65517], "mapped", [9632]], [[65518, 65518], "mapped", [9675]], [[65519, 65528], "disallowed"], [[65529, 65531], "disallowed"], [[65532, 65532], "disallowed"], [[65533, 65533], "disallowed"], [[65534, 65535], "disallowed"], [[65536, 65547], "valid"], [[65548, 65548], "disallowed"], [[65549, 65574], "valid"], [[65575, 65575], "disallowed"], [[65576, 65594], "valid"], [[65595, 65595], "disallowed"], [[65596, 65597], "valid"], [[65598, 65598], "disallowed"], [[65599, 65613], "valid"], [[65614, 65615], "disallowed"], [[65616, 65629], "valid"], [[65630, 65663], "disallowed"], [[65664, 65786], "valid"], [[65787, 65791], "disallowed"], [[65792, 65794], "valid", [], "NV8"], [[65795, 65798], "disallowed"], [[65799, 65843], "valid", [], "NV8"], [[65844, 65846], "disallowed"], [[65847, 65855], "valid", [], "NV8"], [[65856, 65930], "valid", [], "NV8"], [[65931, 65932], "valid", [], "NV8"], [[65933, 65935], "disallowed"], [[65936, 65947], "valid", [], "NV8"], [[65948, 65951], "disallowed"], [[65952, 65952], "valid", [], "NV8"], [[65953, 65999], "disallowed"], [[66e3, 66044], "valid", [], "NV8"], [[66045, 66045], "valid"], [[66046, 66175], "disallowed"], [[66176, 66204], "valid"], [[66205, 66207], "disallowed"], [[66208, 66256], "valid"], [[66257, 66271], "disallowed"], [[66272, 66272], "valid"], [[66273, 66299], "valid", [], "NV8"], [[66300, 66303], "disallowed"], [[66304, 66334], "valid"], [[66335, 66335], "valid"], [[66336, 66339], "valid", [], "NV8"], [[66340, 66351], "disallowed"], [[66352, 66368], "valid"], [[66369, 66369], "valid", [], "NV8"], [[66370, 66377], "valid"], [[66378, 66378], "valid", [], "NV8"], [[66379, 66383], "disallowed"], [[66384, 66426], "valid"], [[66427, 66431], "disallowed"], [[66432, 66461], "valid"], [[66462, 66462], "disallowed"], [[66463, 66463], "valid", [], "NV8"], [[66464, 66499], "valid"], [[66500, 66503], "disallowed"], [[66504, 66511], "valid"], [[66512, 66517], "valid", [], "NV8"], [[66518, 66559], "disallowed"], [[66560, 66560], "mapped", [66600]], [[66561, 66561], "mapped", [66601]], [[66562, 66562], "mapped", [66602]], [[66563, 66563], "mapped", [66603]], [[66564, 66564], "mapped", [66604]], [[66565, 66565], "mapped", [66605]], [[66566, 66566], "mapped", [66606]], [[66567, 66567], "mapped", [66607]], [[66568, 66568], "mapped", [66608]], [[66569, 66569], "mapped", [66609]], [[66570, 66570], "mapped", [66610]], [[66571, 66571], "mapped", [66611]], [[66572, 66572], "mapped", [66612]], [[66573, 66573], "mapped", [66613]], [[66574, 66574], "mapped", [66614]], [[66575, 66575], "mapped", [66615]], [[66576, 66576], "mapped", [66616]], [[66577, 66577], "mapped", [66617]], [[66578, 66578], "mapped", [66618]], [[66579, 66579], "mapped", [66619]], [[66580, 66580], "mapped", [66620]], [[66581, 66581], "mapped", [66621]], [[66582, 66582], "mapped", [66622]], [[66583, 66583], "mapped", [66623]], [[66584, 66584], "mapped", [66624]], [[66585, 66585], "mapped", [66625]], [[66586, 66586], "mapped", [66626]], [[66587, 66587], "mapped", [66627]], [[66588, 66588], "mapped", [66628]], [[66589, 66589], "mapped", [66629]], [[66590, 66590], "mapped", [66630]], [[66591, 66591], "mapped", [66631]], [[66592, 66592], "mapped", [66632]], [[66593, 66593], "mapped", [66633]], [[66594, 66594], "mapped", [66634]], [[66595, 66595], "mapped", [66635]], [[66596, 66596], "mapped", [66636]], [[66597, 66597], "mapped", [66637]], [[66598, 66598], "mapped", [66638]], [[66599, 66599], "mapped", [66639]], [[66600, 66637], "valid"], [[66638, 66717], "valid"], [[66718, 66719], "disallowed"], [[66720, 66729], "valid"], [[66730, 66815], "disallowed"], [[66816, 66855], "valid"], [[66856, 66863], "disallowed"], [[66864, 66915], "valid"], [[66916, 66926], "disallowed"], [[66927, 66927], "valid", [], "NV8"], [[66928, 67071], "disallowed"], [[67072, 67382], "valid"], [[67383, 67391], "disallowed"], [[67392, 67413], "valid"], [[67414, 67423], "disallowed"], [[67424, 67431], "valid"], [[67432, 67583], "disallowed"], [[67584, 67589], "valid"], [[67590, 67591], "disallowed"], [[67592, 67592], "valid"], [[67593, 67593], "disallowed"], [[67594, 67637], "valid"], [[67638, 67638], "disallowed"], [[67639, 67640], "valid"], [[67641, 67643], "disallowed"], [[67644, 67644], "valid"], [[67645, 67646], "disallowed"], [[67647, 67647], "valid"], [[67648, 67669], "valid"], [[67670, 67670], "disallowed"], [[67671, 67679], "valid", [], "NV8"], [[67680, 67702], "valid"], [[67703, 67711], "valid", [], "NV8"], [[67712, 67742], "valid"], [[67743, 67750], "disallowed"], [[67751, 67759], "valid", [], "NV8"], [[67760, 67807], "disallowed"], [[67808, 67826], "valid"], [[67827, 67827], "disallowed"], [[67828, 67829], "valid"], [[67830, 67834], "disallowed"], [[67835, 67839], "valid", [], "NV8"], [[67840, 67861], "valid"], [[67862, 67865], "valid", [], "NV8"], [[67866, 67867], "valid", [], "NV8"], [[67868, 67870], "disallowed"], [[67871, 67871], "valid", [], "NV8"], [[67872, 67897], "valid"], [[67898, 67902], "disallowed"], [[67903, 67903], "valid", [], "NV8"], [[67904, 67967], "disallowed"], [[67968, 68023], "valid"], [[68024, 68027], "disallowed"], [[68028, 68029], "valid", [], "NV8"], [[68030, 68031], "valid"], [[68032, 68047], "valid", [], "NV8"], [[68048, 68049], "disallowed"], [[68050, 68095], "valid", [], "NV8"], [[68096, 68099], "valid"], [[68100, 68100], "disallowed"], [[68101, 68102], "valid"], [[68103, 68107], "disallowed"], [[68108, 68115], "valid"], [[68116, 68116], "disallowed"], [[68117, 68119], "valid"], [[68120, 68120], "disallowed"], [[68121, 68147], "valid"], [[68148, 68151], "disallowed"], [[68152, 68154], "valid"], [[68155, 68158], "disallowed"], [[68159, 68159], "valid"], [[68160, 68167], "valid", [], "NV8"], [[68168, 68175], "disallowed"], [[68176, 68184], "valid", [], "NV8"], [[68185, 68191], "disallowed"], [[68192, 68220], "valid"], [[68221, 68223], "valid", [], "NV8"], [[68224, 68252], "valid"], [[68253, 68255], "valid", [], "NV8"], [[68256, 68287], "disallowed"], [[68288, 68295], "valid"], [[68296, 68296], "valid", [], "NV8"], [[68297, 68326], "valid"], [[68327, 68330], "disallowed"], [[68331, 68342], "valid", [], "NV8"], [[68343, 68351], "disallowed"], [[68352, 68405], "valid"], [[68406, 68408], "disallowed"], [[68409, 68415], "valid", [], "NV8"], [[68416, 68437], "valid"], [[68438, 68439], "disallowed"], [[68440, 68447], "valid", [], "NV8"], [[68448, 68466], "valid"], [[68467, 68471], "disallowed"], [[68472, 68479], "valid", [], "NV8"], [[68480, 68497], "valid"], [[68498, 68504], "disallowed"], [[68505, 68508], "valid", [], "NV8"], [[68509, 68520], "disallowed"], [[68521, 68527], "valid", [], "NV8"], [[68528, 68607], "disallowed"], [[68608, 68680], "valid"], [[68681, 68735], "disallowed"], [[68736, 68736], "mapped", [68800]], [[68737, 68737], "mapped", [68801]], [[68738, 68738], "mapped", [68802]], [[68739, 68739], "mapped", [68803]], [[68740, 68740], "mapped", [68804]], [[68741, 68741], "mapped", [68805]], [[68742, 68742], "mapped", [68806]], [[68743, 68743], "mapped", [68807]], [[68744, 68744], "mapped", [68808]], [[68745, 68745], "mapped", [68809]], [[68746, 68746], "mapped", [68810]], [[68747, 68747], "mapped", [68811]], [[68748, 68748], "mapped", [68812]], [[68749, 68749], "mapped", [68813]], [[68750, 68750], "mapped", [68814]], [[68751, 68751], "mapped", [68815]], [[68752, 68752], "mapped", [68816]], [[68753, 68753], "mapped", [68817]], [[68754, 68754], "mapped", [68818]], [[68755, 68755], "mapped", [68819]], [[68756, 68756], "mapped", [68820]], [[68757, 68757], "mapped", [68821]], [[68758, 68758], "mapped", [68822]], [[68759, 68759], "mapped", [68823]], [[68760, 68760], "mapped", [68824]], [[68761, 68761], "mapped", [68825]], [[68762, 68762], "mapped", [68826]], [[68763, 68763], "mapped", [68827]], [[68764, 68764], "mapped", [68828]], [[68765, 68765], "mapped", [68829]], [[68766, 68766], "mapped", [68830]], [[68767, 68767], "mapped", [68831]], [[68768, 68768], "mapped", [68832]], [[68769, 68769], "mapped", [68833]], [[68770, 68770], "mapped", [68834]], [[68771, 68771], "mapped", [68835]], [[68772, 68772], "mapped", [68836]], [[68773, 68773], "mapped", [68837]], [[68774, 68774], "mapped", [68838]], [[68775, 68775], "mapped", [68839]], [[68776, 68776], "mapped", [68840]], [[68777, 68777], "mapped", [68841]], [[68778, 68778], "mapped", [68842]], [[68779, 68779], "mapped", [68843]], [[68780, 68780], "mapped", [68844]], [[68781, 68781], "mapped", [68845]], [[68782, 68782], "mapped", [68846]], [[68783, 68783], "mapped", [68847]], [[68784, 68784], "mapped", [68848]], [[68785, 68785], "mapped", [68849]], [[68786, 68786], "mapped", [68850]], [[68787, 68799], "disallowed"], [[68800, 68850], "valid"], [[68851, 68857], "disallowed"], [[68858, 68863], "valid", [], "NV8"], [[68864, 69215], "disallowed"], [[69216, 69246], "valid", [], "NV8"], [[69247, 69631], "disallowed"], [[69632, 69702], "valid"], [[69703, 69709], "valid", [], "NV8"], [[69710, 69713], "disallowed"], [[69714, 69733], "valid", [], "NV8"], [[69734, 69743], "valid"], [[69744, 69758], "disallowed"], [[69759, 69759], "valid"], [[69760, 69818], "valid"], [[69819, 69820], "valid", [], "NV8"], [[69821, 69821], "disallowed"], [[69822, 69825], "valid", [], "NV8"], [[69826, 69839], "disallowed"], [[69840, 69864], "valid"], [[69865, 69871], "disallowed"], [[69872, 69881], "valid"], [[69882, 69887], "disallowed"], [[69888, 69940], "valid"], [[69941, 69941], "disallowed"], [[69942, 69951], "valid"], [[69952, 69955], "valid", [], "NV8"], [[69956, 69967], "disallowed"], [[69968, 70003], "valid"], [[70004, 70005], "valid", [], "NV8"], [[70006, 70006], "valid"], [[70007, 70015], "disallowed"], [[70016, 70084], "valid"], [[70085, 70088], "valid", [], "NV8"], [[70089, 70089], "valid", [], "NV8"], [[70090, 70092], "valid"], [[70093, 70093], "valid", [], "NV8"], [[70094, 70095], "disallowed"], [[70096, 70105], "valid"], [[70106, 70106], "valid"], [[70107, 70107], "valid", [], "NV8"], [[70108, 70108], "valid"], [[70109, 70111], "valid", [], "NV8"], [[70112, 70112], "disallowed"], [[70113, 70132], "valid", [], "NV8"], [[70133, 70143], "disallowed"], [[70144, 70161], "valid"], [[70162, 70162], "disallowed"], [[70163, 70199], "valid"], [[70200, 70205], "valid", [], "NV8"], [[70206, 70271], "disallowed"], [[70272, 70278], "valid"], [[70279, 70279], "disallowed"], [[70280, 70280], "valid"], [[70281, 70281], "disallowed"], [[70282, 70285], "valid"], [[70286, 70286], "disallowed"], [[70287, 70301], "valid"], [[70302, 70302], "disallowed"], [[70303, 70312], "valid"], [[70313, 70313], "valid", [], "NV8"], [[70314, 70319], "disallowed"], [[70320, 70378], "valid"], [[70379, 70383], "disallowed"], [[70384, 70393], "valid"], [[70394, 70399], "disallowed"], [[70400, 70400], "valid"], [[70401, 70403], "valid"], [[70404, 70404], "disallowed"], [[70405, 70412], "valid"], [[70413, 70414], "disallowed"], [[70415, 70416], "valid"], [[70417, 70418], "disallowed"], [[70419, 70440], "valid"], [[70441, 70441], "disallowed"], [[70442, 70448], "valid"], [[70449, 70449], "disallowed"], [[70450, 70451], "valid"], [[70452, 70452], "disallowed"], [[70453, 70457], "valid"], [[70458, 70459], "disallowed"], [[70460, 70468], "valid"], [[70469, 70470], "disallowed"], [[70471, 70472], "valid"], [[70473, 70474], "disallowed"], [[70475, 70477], "valid"], [[70478, 70479], "disallowed"], [[70480, 70480], "valid"], [[70481, 70486], "disallowed"], [[70487, 70487], "valid"], [[70488, 70492], "disallowed"], [[70493, 70499], "valid"], [[70500, 70501], "disallowed"], [[70502, 70508], "valid"], [[70509, 70511], "disallowed"], [[70512, 70516], "valid"], [[70517, 70783], "disallowed"], [[70784, 70853], "valid"], [[70854, 70854], "valid", [], "NV8"], [[70855, 70855], "valid"], [[70856, 70863], "disallowed"], [[70864, 70873], "valid"], [[70874, 71039], "disallowed"], [[71040, 71093], "valid"], [[71094, 71095], "disallowed"], [[71096, 71104], "valid"], [[71105, 71113], "valid", [], "NV8"], [[71114, 71127], "valid", [], "NV8"], [[71128, 71133], "valid"], [[71134, 71167], "disallowed"], [[71168, 71232], "valid"], [[71233, 71235], "valid", [], "NV8"], [[71236, 71236], "valid"], [[71237, 71247], "disallowed"], [[71248, 71257], "valid"], [[71258, 71295], "disallowed"], [[71296, 71351], "valid"], [[71352, 71359], "disallowed"], [[71360, 71369], "valid"], [[71370, 71423], "disallowed"], [[71424, 71449], "valid"], [[71450, 71452], "disallowed"], [[71453, 71467], "valid"], [[71468, 71471], "disallowed"], [[71472, 71481], "valid"], [[71482, 71487], "valid", [], "NV8"], [[71488, 71839], "disallowed"], [[71840, 71840], "mapped", [71872]], [[71841, 71841], "mapped", [71873]], [[71842, 71842], "mapped", [71874]], [[71843, 71843], "mapped", [71875]], [[71844, 71844], "mapped", [71876]], [[71845, 71845], "mapped", [71877]], [[71846, 71846], "mapped", [71878]], [[71847, 71847], "mapped", [71879]], [[71848, 71848], "mapped", [71880]], [[71849, 71849], "mapped", [71881]], [[71850, 71850], "mapped", [71882]], [[71851, 71851], "mapped", [71883]], [[71852, 71852], "mapped", [71884]], [[71853, 71853], "mapped", [71885]], [[71854, 71854], "mapped", [71886]], [[71855, 71855], "mapped", [71887]], [[71856, 71856], "mapped", [71888]], [[71857, 71857], "mapped", [71889]], [[71858, 71858], "mapped", [71890]], [[71859, 71859], "mapped", [71891]], [[71860, 71860], "mapped", [71892]], [[71861, 71861], "mapped", [71893]], [[71862, 71862], "mapped", [71894]], [[71863, 71863], "mapped", [71895]], [[71864, 71864], "mapped", [71896]], [[71865, 71865], "mapped", [71897]], [[71866, 71866], "mapped", [71898]], [[71867, 71867], "mapped", [71899]], [[71868, 71868], "mapped", [71900]], [[71869, 71869], "mapped", [71901]], [[71870, 71870], "mapped", [71902]], [[71871, 71871], "mapped", [71903]], [[71872, 71913], "valid"], [[71914, 71922], "valid", [], "NV8"], [[71923, 71934], "disallowed"], [[71935, 71935], "valid"], [[71936, 72383], "disallowed"], [[72384, 72440], "valid"], [[72441, 73727], "disallowed"], [[73728, 74606], "valid"], [[74607, 74648], "valid"], [[74649, 74649], "valid"], [[74650, 74751], "disallowed"], [[74752, 74850], "valid", [], "NV8"], [[74851, 74862], "valid", [], "NV8"], [[74863, 74863], "disallowed"], [[74864, 74867], "valid", [], "NV8"], [[74868, 74868], "valid", [], "NV8"], [[74869, 74879], "disallowed"], [[74880, 75075], "valid"], [[75076, 77823], "disallowed"], [[77824, 78894], "valid"], [[78895, 82943], "disallowed"], [[82944, 83526], "valid"], [[83527, 92159], "disallowed"], [[92160, 92728], "valid"], [[92729, 92735], "disallowed"], [[92736, 92766], "valid"], [[92767, 92767], "disallowed"], [[92768, 92777], "valid"], [[92778, 92781], "disallowed"], [[92782, 92783], "valid", [], "NV8"], [[92784, 92879], "disallowed"], [[92880, 92909], "valid"], [[92910, 92911], "disallowed"], [[92912, 92916], "valid"], [[92917, 92917], "valid", [], "NV8"], [[92918, 92927], "disallowed"], [[92928, 92982], "valid"], [[92983, 92991], "valid", [], "NV8"], [[92992, 92995], "valid"], [[92996, 92997], "valid", [], "NV8"], [[92998, 93007], "disallowed"], [[93008, 93017], "valid"], [[93018, 93018], "disallowed"], [[93019, 93025], "valid", [], "NV8"], [[93026, 93026], "disallowed"], [[93027, 93047], "valid"], [[93048, 93052], "disallowed"], [[93053, 93071], "valid"], [[93072, 93951], "disallowed"], [[93952, 94020], "valid"], [[94021, 94031], "disallowed"], [[94032, 94078], "valid"], [[94079, 94094], "disallowed"], [[94095, 94111], "valid"], [[94112, 110591], "disallowed"], [[110592, 110593], "valid"], [[110594, 113663], "disallowed"], [[113664, 113770], "valid"], [[113771, 113775], "disallowed"], [[113776, 113788], "valid"], [[113789, 113791], "disallowed"], [[113792, 113800], "valid"], [[113801, 113807], "disallowed"], [[113808, 113817], "valid"], [[113818, 113819], "disallowed"], [[113820, 113820], "valid", [], "NV8"], [[113821, 113822], "valid"], [[113823, 113823], "valid", [], "NV8"], [[113824, 113827], "ignored"], [[113828, 118783], "disallowed"], [[118784, 119029], "valid", [], "NV8"], [[119030, 119039], "disallowed"], [[119040, 119078], "valid", [], "NV8"], [[119079, 119080], "disallowed"], [[119081, 119081], "valid", [], "NV8"], [[119082, 119133], "valid", [], "NV8"], [[119134, 119134], "mapped", [119127, 119141]], [[119135, 119135], "mapped", [119128, 119141]], [[119136, 119136], "mapped", [119128, 119141, 119150]], [[119137, 119137], "mapped", [119128, 119141, 119151]], [[119138, 119138], "mapped", [119128, 119141, 119152]], [[119139, 119139], "mapped", [119128, 119141, 119153]], [[119140, 119140], "mapped", [119128, 119141, 119154]], [[119141, 119154], "valid", [], "NV8"], [[119155, 119162], "disallowed"], [[119163, 119226], "valid", [], "NV8"], [[119227, 119227], "mapped", [119225, 119141]], [[119228, 119228], "mapped", [119226, 119141]], [[119229, 119229], "mapped", [119225, 119141, 119150]], [[119230, 119230], "mapped", [119226, 119141, 119150]], [[119231, 119231], "mapped", [119225, 119141, 119151]], [[119232, 119232], "mapped", [119226, 119141, 119151]], [[119233, 119261], "valid", [], "NV8"], [[119262, 119272], "valid", [], "NV8"], [[119273, 119295], "disallowed"], [[119296, 119365], "valid", [], "NV8"], [[119366, 119551], "disallowed"], [[119552, 119638], "valid", [], "NV8"], [[119639, 119647], "disallowed"], [[119648, 119665], "valid", [], "NV8"], [[119666, 119807], "disallowed"], [[119808, 119808], "mapped", [97]], [[119809, 119809], "mapped", [98]], [[119810, 119810], "mapped", [99]], [[119811, 119811], "mapped", [100]], [[119812, 119812], "mapped", [101]], [[119813, 119813], "mapped", [102]], [[119814, 119814], "mapped", [103]], [[119815, 119815], "mapped", [104]], [[119816, 119816], "mapped", [105]], [[119817, 119817], "mapped", [106]], [[119818, 119818], "mapped", [107]], [[119819, 119819], "mapped", [108]], [[119820, 119820], "mapped", [109]], [[119821, 119821], "mapped", [110]], [[119822, 119822], "mapped", [111]], [[119823, 119823], "mapped", [112]], [[119824, 119824], "mapped", [113]], [[119825, 119825], "mapped", [114]], [[119826, 119826], "mapped", [115]], [[119827, 119827], "mapped", [116]], [[119828, 119828], "mapped", [117]], [[119829, 119829], "mapped", [118]], [[119830, 119830], "mapped", [119]], [[119831, 119831], "mapped", [120]], [[119832, 119832], "mapped", [121]], [[119833, 119833], "mapped", [122]], [[119834, 119834], "mapped", [97]], [[119835, 119835], "mapped", [98]], [[119836, 119836], "mapped", [99]], [[119837, 119837], "mapped", [100]], [[119838, 119838], "mapped", [101]], [[119839, 119839], "mapped", [102]], [[119840, 119840], "mapped", [103]], [[119841, 119841], "mapped", [104]], [[119842, 119842], "mapped", [105]], [[119843, 119843], "mapped", [106]], [[119844, 119844], "mapped", [107]], [[119845, 119845], "mapped", [108]], [[119846, 119846], "mapped", [109]], [[119847, 119847], "mapped", [110]], [[119848, 119848], "mapped", [111]], [[119849, 119849], "mapped", [112]], [[119850, 119850], "mapped", [113]], [[119851, 119851], "mapped", [114]], [[119852, 119852], "mapped", [115]], [[119853, 119853], "mapped", [116]], [[119854, 119854], "mapped", [117]], [[119855, 119855], "mapped", [118]], [[119856, 119856], "mapped", [119]], [[119857, 119857], "mapped", [120]], [[119858, 119858], "mapped", [121]], [[119859, 119859], "mapped", [122]], [[119860, 119860], "mapped", [97]], [[119861, 119861], "mapped", [98]], [[119862, 119862], "mapped", [99]], [[119863, 119863], "mapped", [100]], [[119864, 119864], "mapped", [101]], [[119865, 119865], "mapped", [102]], [[119866, 119866], "mapped", [103]], [[119867, 119867], "mapped", [104]], [[119868, 119868], "mapped", [105]], [[119869, 119869], "mapped", [106]], [[119870, 119870], "mapped", [107]], [[119871, 119871], "mapped", [108]], [[119872, 119872], "mapped", [109]], [[119873, 119873], "mapped", [110]], [[119874, 119874], "mapped", [111]], [[119875, 119875], "mapped", [112]], [[119876, 119876], "mapped", [113]], [[119877, 119877], "mapped", [114]], [[119878, 119878], "mapped", [115]], [[119879, 119879], "mapped", [116]], [[119880, 119880], "mapped", [117]], [[119881, 119881], "mapped", [118]], [[119882, 119882], "mapped", [119]], [[119883, 119883], "mapped", [120]], [[119884, 119884], "mapped", [121]], [[119885, 119885], "mapped", [122]], [[119886, 119886], "mapped", [97]], [[119887, 119887], "mapped", [98]], [[119888, 119888], "mapped", [99]], [[119889, 119889], "mapped", [100]], [[119890, 119890], "mapped", [101]], [[119891, 119891], "mapped", [102]], [[119892, 119892], "mapped", [103]], [[119893, 119893], "disallowed"], [[119894, 119894], "mapped", [105]], [[119895, 119895], "mapped", [106]], [[119896, 119896], "mapped", [107]], [[119897, 119897], "mapped", [108]], [[119898, 119898], "mapped", [109]], [[119899, 119899], "mapped", [110]], [[119900, 119900], "mapped", [111]], [[119901, 119901], "mapped", [112]], [[119902, 119902], "mapped", [113]], [[119903, 119903], "mapped", [114]], [[119904, 119904], "mapped", [115]], [[119905, 119905], "mapped", [116]], [[119906, 119906], "mapped", [117]], [[119907, 119907], "mapped", [118]], [[119908, 119908], "mapped", [119]], [[119909, 119909], "mapped", [120]], [[119910, 119910], "mapped", [121]], [[119911, 119911], "mapped", [122]], [[119912, 119912], "mapped", [97]], [[119913, 119913], "mapped", [98]], [[119914, 119914], "mapped", [99]], [[119915, 119915], "mapped", [100]], [[119916, 119916], "mapped", [101]], [[119917, 119917], "mapped", [102]], [[119918, 119918], "mapped", [103]], [[119919, 119919], "mapped", [104]], [[119920, 119920], "mapped", [105]], [[119921, 119921], "mapped", [106]], [[119922, 119922], "mapped", [107]], [[119923, 119923], "mapped", [108]], [[119924, 119924], "mapped", [109]], [[119925, 119925], "mapped", [110]], [[119926, 119926], "mapped", [111]], [[119927, 119927], "mapped", [112]], [[119928, 119928], "mapped", [113]], [[119929, 119929], "mapped", [114]], [[119930, 119930], "mapped", [115]], [[119931, 119931], "mapped", [116]], [[119932, 119932], "mapped", [117]], [[119933, 119933], "mapped", [118]], [[119934, 119934], "mapped", [119]], [[119935, 119935], "mapped", [120]], [[119936, 119936], "mapped", [121]], [[119937, 119937], "mapped", [122]], [[119938, 119938], "mapped", [97]], [[119939, 119939], "mapped", [98]], [[119940, 119940], "mapped", [99]], [[119941, 119941], "mapped", [100]], [[119942, 119942], "mapped", [101]], [[119943, 119943], "mapped", [102]], [[119944, 119944], "mapped", [103]], [[119945, 119945], "mapped", [104]], [[119946, 119946], "mapped", [105]], [[119947, 119947], "mapped", [106]], [[119948, 119948], "mapped", [107]], [[119949, 119949], "mapped", [108]], [[119950, 119950], "mapped", [109]], [[119951, 119951], "mapped", [110]], [[119952, 119952], "mapped", [111]], [[119953, 119953], "mapped", [112]], [[119954, 119954], "mapped", [113]], [[119955, 119955], "mapped", [114]], [[119956, 119956], "mapped", [115]], [[119957, 119957], "mapped", [116]], [[119958, 119958], "mapped", [117]], [[119959, 119959], "mapped", [118]], [[119960, 119960], "mapped", [119]], [[119961, 119961], "mapped", [120]], [[119962, 119962], "mapped", [121]], [[119963, 119963], "mapped", [122]], [[119964, 119964], "mapped", [97]], [[119965, 119965], "disallowed"], [[119966, 119966], "mapped", [99]], [[119967, 119967], "mapped", [100]], [[119968, 119969], "disallowed"], [[119970, 119970], "mapped", [103]], [[119971, 119972], "disallowed"], [[119973, 119973], "mapped", [106]], [[119974, 119974], "mapped", [107]], [[119975, 119976], "disallowed"], [[119977, 119977], "mapped", [110]], [[119978, 119978], "mapped", [111]], [[119979, 119979], "mapped", [112]], [[119980, 119980], "mapped", [113]], [[119981, 119981], "disallowed"], [[119982, 119982], "mapped", [115]], [[119983, 119983], "mapped", [116]], [[119984, 119984], "mapped", [117]], [[119985, 119985], "mapped", [118]], [[119986, 119986], "mapped", [119]], [[119987, 119987], "mapped", [120]], [[119988, 119988], "mapped", [121]], [[119989, 119989], "mapped", [122]], [[119990, 119990], "mapped", [97]], [[119991, 119991], "mapped", [98]], [[119992, 119992], "mapped", [99]], [[119993, 119993], "mapped", [100]], [[119994, 119994], "disallowed"], [[119995, 119995], "mapped", [102]], [[119996, 119996], "disallowed"], [[119997, 119997], "mapped", [104]], [[119998, 119998], "mapped", [105]], [[119999, 119999], "mapped", [106]], [[12e4, 12e4], "mapped", [107]], [[120001, 120001], "mapped", [108]], [[120002, 120002], "mapped", [109]], [[120003, 120003], "mapped", [110]], [[120004, 120004], "disallowed"], [[120005, 120005], "mapped", [112]], [[120006, 120006], "mapped", [113]], [[120007, 120007], "mapped", [114]], [[120008, 120008], "mapped", [115]], [[120009, 120009], "mapped", [116]], [[120010, 120010], "mapped", [117]], [[120011, 120011], "mapped", [118]], [[120012, 120012], "mapped", [119]], [[120013, 120013], "mapped", [120]], [[120014, 120014], "mapped", [121]], [[120015, 120015], "mapped", [122]], [[120016, 120016], "mapped", [97]], [[120017, 120017], "mapped", [98]], [[120018, 120018], "mapped", [99]], [[120019, 120019], "mapped", [100]], [[120020, 120020], "mapped", [101]], [[120021, 120021], "mapped", [102]], [[120022, 120022], "mapped", [103]], [[120023, 120023], "mapped", [104]], [[120024, 120024], "mapped", [105]], [[120025, 120025], "mapped", [106]], [[120026, 120026], "mapped", [107]], [[120027, 120027], "mapped", [108]], [[120028, 120028], "mapped", [109]], [[120029, 120029], "mapped", [110]], [[120030, 120030], "mapped", [111]], [[120031, 120031], "mapped", [112]], [[120032, 120032], "mapped", [113]], [[120033, 120033], "mapped", [114]], [[120034, 120034], "mapped", [115]], [[120035, 120035], "mapped", [116]], [[120036, 120036], "mapped", [117]], [[120037, 120037], "mapped", [118]], [[120038, 120038], "mapped", [119]], [[120039, 120039], "mapped", [120]], [[120040, 120040], "mapped", [121]], [[120041, 120041], "mapped", [122]], [[120042, 120042], "mapped", [97]], [[120043, 120043], "mapped", [98]], [[120044, 120044], "mapped", [99]], [[120045, 120045], "mapped", [100]], [[120046, 120046], "mapped", [101]], [[120047, 120047], "mapped", [102]], [[120048, 120048], "mapped", [103]], [[120049, 120049], "mapped", [104]], [[120050, 120050], "mapped", [105]], [[120051, 120051], "mapped", [106]], [[120052, 120052], "mapped", [107]], [[120053, 120053], "mapped", [108]], [[120054, 120054], "mapped", [109]], [[120055, 120055], "mapped", [110]], [[120056, 120056], "mapped", [111]], [[120057, 120057], "mapped", [112]], [[120058, 120058], "mapped", [113]], [[120059, 120059], "mapped", [114]], [[120060, 120060], "mapped", [115]], [[120061, 120061], "mapped", [116]], [[120062, 120062], "mapped", [117]], [[120063, 120063], "mapped", [118]], [[120064, 120064], "mapped", [119]], [[120065, 120065], "mapped", [120]], [[120066, 120066], "mapped", [121]], [[120067, 120067], "mapped", [122]], [[120068, 120068], "mapped", [97]], [[120069, 120069], "mapped", [98]], [[120070, 120070], "disallowed"], [[120071, 120071], "mapped", [100]], [[120072, 120072], "mapped", [101]], [[120073, 120073], "mapped", [102]], [[120074, 120074], "mapped", [103]], [[120075, 120076], "disallowed"], [[120077, 120077], "mapped", [106]], [[120078, 120078], "mapped", [107]], [[120079, 120079], "mapped", [108]], [[120080, 120080], "mapped", [109]], [[120081, 120081], "mapped", [110]], [[120082, 120082], "mapped", [111]], [[120083, 120083], "mapped", [112]], [[120084, 120084], "mapped", [113]], [[120085, 120085], "disallowed"], [[120086, 120086], "mapped", [115]], [[120087, 120087], "mapped", [116]], [[120088, 120088], "mapped", [117]], [[120089, 120089], "mapped", [118]], [[120090, 120090], "mapped", [119]], [[120091, 120091], "mapped", [120]], [[120092, 120092], "mapped", [121]], [[120093, 120093], "disallowed"], [[120094, 120094], "mapped", [97]], [[120095, 120095], "mapped", [98]], [[120096, 120096], "mapped", [99]], [[120097, 120097], "mapped", [100]], [[120098, 120098], "mapped", [101]], [[120099, 120099], "mapped", [102]], [[120100, 120100], "mapped", [103]], [[120101, 120101], "mapped", [104]], [[120102, 120102], "mapped", [105]], [[120103, 120103], "mapped", [106]], [[120104, 120104], "mapped", [107]], [[120105, 120105], "mapped", [108]], [[120106, 120106], "mapped", [109]], [[120107, 120107], "mapped", [110]], [[120108, 120108], "mapped", [111]], [[120109, 120109], "mapped", [112]], [[120110, 120110], "mapped", [113]], [[120111, 120111], "mapped", [114]], [[120112, 120112], "mapped", [115]], [[120113, 120113], "mapped", [116]], [[120114, 120114], "mapped", [117]], [[120115, 120115], "mapped", [118]], [[120116, 120116], "mapped", [119]], [[120117, 120117], "mapped", [120]], [[120118, 120118], "mapped", [121]], [[120119, 120119], "mapped", [122]], [[120120, 120120], "mapped", [97]], [[120121, 120121], "mapped", [98]], [[120122, 120122], "disallowed"], [[120123, 120123], "mapped", [100]], [[120124, 120124], "mapped", [101]], [[120125, 120125], "mapped", [102]], [[120126, 120126], "mapped", [103]], [[120127, 120127], "disallowed"], [[120128, 120128], "mapped", [105]], [[120129, 120129], "mapped", [106]], [[120130, 120130], "mapped", [107]], [[120131, 120131], "mapped", [108]], [[120132, 120132], "mapped", [109]], [[120133, 120133], "disallowed"], [[120134, 120134], "mapped", [111]], [[120135, 120137], "disallowed"], [[120138, 120138], "mapped", [115]], [[120139, 120139], "mapped", [116]], [[120140, 120140], "mapped", [117]], [[120141, 120141], "mapped", [118]], [[120142, 120142], "mapped", [119]], [[120143, 120143], "mapped", [120]], [[120144, 120144], "mapped", [121]], [[120145, 120145], "disallowed"], [[120146, 120146], "mapped", [97]], [[120147, 120147], "mapped", [98]], [[120148, 120148], "mapped", [99]], [[120149, 120149], "mapped", [100]], [[120150, 120150], "mapped", [101]], [[120151, 120151], "mapped", [102]], [[120152, 120152], "mapped", [103]], [[120153, 120153], "mapped", [104]], [[120154, 120154], "mapped", [105]], [[120155, 120155], "mapped", [106]], [[120156, 120156], "mapped", [107]], [[120157, 120157], "mapped", [108]], [[120158, 120158], "mapped", [109]], [[120159, 120159], "mapped", [110]], [[120160, 120160], "mapped", [111]], [[120161, 120161], "mapped", [112]], [[120162, 120162], "mapped", [113]], [[120163, 120163], "mapped", [114]], [[120164, 120164], "mapped", [115]], [[120165, 120165], "mapped", [116]], [[120166, 120166], "mapped", [117]], [[120167, 120167], "mapped", [118]], [[120168, 120168], "mapped", [119]], [[120169, 120169], "mapped", [120]], [[120170, 120170], "mapped", [121]], [[120171, 120171], "mapped", [122]], [[120172, 120172], "mapped", [97]], [[120173, 120173], "mapped", [98]], [[120174, 120174], "mapped", [99]], [[120175, 120175], "mapped", [100]], [[120176, 120176], "mapped", [101]], [[120177, 120177], "mapped", [102]], [[120178, 120178], "mapped", [103]], [[120179, 120179], "mapped", [104]], [[120180, 120180], "mapped", [105]], [[120181, 120181], "mapped", [106]], [[120182, 120182], "mapped", [107]], [[120183, 120183], "mapped", [108]], [[120184, 120184], "mapped", [109]], [[120185, 120185], "mapped", [110]], [[120186, 120186], "mapped", [111]], [[120187, 120187], "mapped", [112]], [[120188, 120188], "mapped", [113]], [[120189, 120189], "mapped", [114]], [[120190, 120190], "mapped", [115]], [[120191, 120191], "mapped", [116]], [[120192, 120192], "mapped", [117]], [[120193, 120193], "mapped", [118]], [[120194, 120194], "mapped", [119]], [[120195, 120195], "mapped", [120]], [[120196, 120196], "mapped", [121]], [[120197, 120197], "mapped", [122]], [[120198, 120198], "mapped", [97]], [[120199, 120199], "mapped", [98]], [[120200, 120200], "mapped", [99]], [[120201, 120201], "mapped", [100]], [[120202, 120202], "mapped", [101]], [[120203, 120203], "mapped", [102]], [[120204, 120204], "mapped", [103]], [[120205, 120205], "mapped", [104]], [[120206, 120206], "mapped", [105]], [[120207, 120207], "mapped", [106]], [[120208, 120208], "mapped", [107]], [[120209, 120209], "mapped", [108]], [[120210, 120210], "mapped", [109]], [[120211, 120211], "mapped", [110]], [[120212, 120212], "mapped", [111]], [[120213, 120213], "mapped", [112]], [[120214, 120214], "mapped", [113]], [[120215, 120215], "mapped", [114]], [[120216, 120216], "mapped", [115]], [[120217, 120217], "mapped", [116]], [[120218, 120218], "mapped", [117]], [[120219, 120219], "mapped", [118]], [[120220, 120220], "mapped", [119]], [[120221, 120221], "mapped", [120]], [[120222, 120222], "mapped", [121]], [[120223, 120223], "mapped", [122]], [[120224, 120224], "mapped", [97]], [[120225, 120225], "mapped", [98]], [[120226, 120226], "mapped", [99]], [[120227, 120227], "mapped", [100]], [[120228, 120228], "mapped", [101]], [[120229, 120229], "mapped", [102]], [[120230, 120230], "mapped", [103]], [[120231, 120231], "mapped", [104]], [[120232, 120232], "mapped", [105]], [[120233, 120233], "mapped", [106]], [[120234, 120234], "mapped", [107]], [[120235, 120235], "mapped", [108]], [[120236, 120236], "mapped", [109]], [[120237, 120237], "mapped", [110]], [[120238, 120238], "mapped", [111]], [[120239, 120239], "mapped", [112]], [[120240, 120240], "mapped", [113]], [[120241, 120241], "mapped", [114]], [[120242, 120242], "mapped", [115]], [[120243, 120243], "mapped", [116]], [[120244, 120244], "mapped", [117]], [[120245, 120245], "mapped", [118]], [[120246, 120246], "mapped", [119]], [[120247, 120247], "mapped", [120]], [[120248, 120248], "mapped", [121]], [[120249, 120249], "mapped", [122]], [[120250, 120250], "mapped", [97]], [[120251, 120251], "mapped", [98]], [[120252, 120252], "mapped", [99]], [[120253, 120253], "mapped", [100]], [[120254, 120254], "mapped", [101]], [[120255, 120255], "mapped", [102]], [[120256, 120256], "mapped", [103]], [[120257, 120257], "mapped", [104]], [[120258, 120258], "mapped", [105]], [[120259, 120259], "mapped", [106]], [[120260, 120260], "mapped", [107]], [[120261, 120261], "mapped", [108]], [[120262, 120262], "mapped", [109]], [[120263, 120263], "mapped", [110]], [[120264, 120264], "mapped", [111]], [[120265, 120265], "mapped", [112]], [[120266, 120266], "mapped", [113]], [[120267, 120267], "mapped", [114]], [[120268, 120268], "mapped", [115]], [[120269, 120269], "mapped", [116]], [[120270, 120270], "mapped", [117]], [[120271, 120271], "mapped", [118]], [[120272, 120272], "mapped", [119]], [[120273, 120273], "mapped", [120]], [[120274, 120274], "mapped", [121]], [[120275, 120275], "mapped", [122]], [[120276, 120276], "mapped", [97]], [[120277, 120277], "mapped", [98]], [[120278, 120278], "mapped", [99]], [[120279, 120279], "mapped", [100]], [[120280, 120280], "mapped", [101]], [[120281, 120281], "mapped", [102]], [[120282, 120282], "mapped", [103]], [[120283, 120283], "mapped", [104]], [[120284, 120284], "mapped", [105]], [[120285, 120285], "mapped", [106]], [[120286, 120286], "mapped", [107]], [[120287, 120287], "mapped", [108]], [[120288, 120288], "mapped", [109]], [[120289, 120289], "mapped", [110]], [[120290, 120290], "mapped", [111]], [[120291, 120291], "mapped", [112]], [[120292, 120292], "mapped", [113]], [[120293, 120293], "mapped", [114]], [[120294, 120294], "mapped", [115]], [[120295, 120295], "mapped", [116]], [[120296, 120296], "mapped", [117]], [[120297, 120297], "mapped", [118]], [[120298, 120298], "mapped", [119]], [[120299, 120299], "mapped", [120]], [[120300, 120300], "mapped", [121]], [[120301, 120301], "mapped", [122]], [[120302, 120302], "mapped", [97]], [[120303, 120303], "mapped", [98]], [[120304, 120304], "mapped", [99]], [[120305, 120305], "mapped", [100]], [[120306, 120306], "mapped", [101]], [[120307, 120307], "mapped", [102]], [[120308, 120308], "mapped", [103]], [[120309, 120309], "mapped", [104]], [[120310, 120310], "mapped", [105]], [[120311, 120311], "mapped", [106]], [[120312, 120312], "mapped", [107]], [[120313, 120313], "mapped", [108]], [[120314, 120314], "mapped", [109]], [[120315, 120315], "mapped", [110]], [[120316, 120316], "mapped", [111]], [[120317, 120317], "mapped", [112]], [[120318, 120318], "mapped", [113]], [[120319, 120319], "mapped", [114]], [[120320, 120320], "mapped", [115]], [[120321, 120321], "mapped", [116]], [[120322, 120322], "mapped", [117]], [[120323, 120323], "mapped", [118]], [[120324, 120324], "mapped", [119]], [[120325, 120325], "mapped", [120]], [[120326, 120326], "mapped", [121]], [[120327, 120327], "mapped", [122]], [[120328, 120328], "mapped", [97]], [[120329, 120329], "mapped", [98]], [[120330, 120330], "mapped", [99]], [[120331, 120331], "mapped", [100]], [[120332, 120332], "mapped", [101]], [[120333, 120333], "mapped", [102]], [[120334, 120334], "mapped", [103]], [[120335, 120335], "mapped", [104]], [[120336, 120336], "mapped", [105]], [[120337, 120337], "mapped", [106]], [[120338, 120338], "mapped", [107]], [[120339, 120339], "mapped", [108]], [[120340, 120340], "mapped", [109]], [[120341, 120341], "mapped", [110]], [[120342, 120342], "mapped", [111]], [[120343, 120343], "mapped", [112]], [[120344, 120344], "mapped", [113]], [[120345, 120345], "mapped", [114]], [[120346, 120346], "mapped", [115]], [[120347, 120347], "mapped", [116]], [[120348, 120348], "mapped", [117]], [[120349, 120349], "mapped", [118]], [[120350, 120350], "mapped", [119]], [[120351, 120351], "mapped", [120]], [[120352, 120352], "mapped", [121]], [[120353, 120353], "mapped", [122]], [[120354, 120354], "mapped", [97]], [[120355, 120355], "mapped", [98]], [[120356, 120356], "mapped", [99]], [[120357, 120357], "mapped", [100]], [[120358, 120358], "mapped", [101]], [[120359, 120359], "mapped", [102]], [[120360, 120360], "mapped", [103]], [[120361, 120361], "mapped", [104]], [[120362, 120362], "mapped", [105]], [[120363, 120363], "mapped", [106]], [[120364, 120364], "mapped", [107]], [[120365, 120365], "mapped", [108]], [[120366, 120366], "mapped", [109]], [[120367, 120367], "mapped", [110]], [[120368, 120368], "mapped", [111]], [[120369, 120369], "mapped", [112]], [[120370, 120370], "mapped", [113]], [[120371, 120371], "mapped", [114]], [[120372, 120372], "mapped", [115]], [[120373, 120373], "mapped", [116]], [[120374, 120374], "mapped", [117]], [[120375, 120375], "mapped", [118]], [[120376, 120376], "mapped", [119]], [[120377, 120377], "mapped", [120]], [[120378, 120378], "mapped", [121]], [[120379, 120379], "mapped", [122]], [[120380, 120380], "mapped", [97]], [[120381, 120381], "mapped", [98]], [[120382, 120382], "mapped", [99]], [[120383, 120383], "mapped", [100]], [[120384, 120384], "mapped", [101]], [[120385, 120385], "mapped", [102]], [[120386, 120386], "mapped", [103]], [[120387, 120387], "mapped", [104]], [[120388, 120388], "mapped", [105]], [[120389, 120389], "mapped", [106]], [[120390, 120390], "mapped", [107]], [[120391, 120391], "mapped", [108]], [[120392, 120392], "mapped", [109]], [[120393, 120393], "mapped", [110]], [[120394, 120394], "mapped", [111]], [[120395, 120395], "mapped", [112]], [[120396, 120396], "mapped", [113]], [[120397, 120397], "mapped", [114]], [[120398, 120398], "mapped", [115]], [[120399, 120399], "mapped", [116]], [[120400, 120400], "mapped", [117]], [[120401, 120401], "mapped", [118]], [[120402, 120402], "mapped", [119]], [[120403, 120403], "mapped", [120]], [[120404, 120404], "mapped", [121]], [[120405, 120405], "mapped", [122]], [[120406, 120406], "mapped", [97]], [[120407, 120407], "mapped", [98]], [[120408, 120408], "mapped", [99]], [[120409, 120409], "mapped", [100]], [[120410, 120410], "mapped", [101]], [[120411, 120411], "mapped", [102]], [[120412, 120412], "mapped", [103]], [[120413, 120413], "mapped", [104]], [[120414, 120414], "mapped", [105]], [[120415, 120415], "mapped", [106]], [[120416, 120416], "mapped", [107]], [[120417, 120417], "mapped", [108]], [[120418, 120418], "mapped", [109]], [[120419, 120419], "mapped", [110]], [[120420, 120420], "mapped", [111]], [[120421, 120421], "mapped", [112]], [[120422, 120422], "mapped", [113]], [[120423, 120423], "mapped", [114]], [[120424, 120424], "mapped", [115]], [[120425, 120425], "mapped", [116]], [[120426, 120426], "mapped", [117]], [[120427, 120427], "mapped", [118]], [[120428, 120428], "mapped", [119]], [[120429, 120429], "mapped", [120]], [[120430, 120430], "mapped", [121]], [[120431, 120431], "mapped", [122]], [[120432, 120432], "mapped", [97]], [[120433, 120433], "mapped", [98]], [[120434, 120434], "mapped", [99]], [[120435, 120435], "mapped", [100]], [[120436, 120436], "mapped", [101]], [[120437, 120437], "mapped", [102]], [[120438, 120438], "mapped", [103]], [[120439, 120439], "mapped", [104]], [[120440, 120440], "mapped", [105]], [[120441, 120441], "mapped", [106]], [[120442, 120442], "mapped", [107]], [[120443, 120443], "mapped", [108]], [[120444, 120444], "mapped", [109]], [[120445, 120445], "mapped", [110]], [[120446, 120446], "mapped", [111]], [[120447, 120447], "mapped", [112]], [[120448, 120448], "mapped", [113]], [[120449, 120449], "mapped", [114]], [[120450, 120450], "mapped", [115]], [[120451, 120451], "mapped", [116]], [[120452, 120452], "mapped", [117]], [[120453, 120453], "mapped", [118]], [[120454, 120454], "mapped", [119]], [[120455, 120455], "mapped", [120]], [[120456, 120456], "mapped", [121]], [[120457, 120457], "mapped", [122]], [[120458, 120458], "mapped", [97]], [[120459, 120459], "mapped", [98]], [[120460, 120460], "mapped", [99]], [[120461, 120461], "mapped", [100]], [[120462, 120462], "mapped", [101]], [[120463, 120463], "mapped", [102]], [[120464, 120464], "mapped", [103]], [[120465, 120465], "mapped", [104]], [[120466, 120466], "mapped", [105]], [[120467, 120467], "mapped", [106]], [[120468, 120468], "mapped", [107]], [[120469, 120469], "mapped", [108]], [[120470, 120470], "mapped", [109]], [[120471, 120471], "mapped", [110]], [[120472, 120472], "mapped", [111]], [[120473, 120473], "mapped", [112]], [[120474, 120474], "mapped", [113]], [[120475, 120475], "mapped", [114]], [[120476, 120476], "mapped", [115]], [[120477, 120477], "mapped", [116]], [[120478, 120478], "mapped", [117]], [[120479, 120479], "mapped", [118]], [[120480, 120480], "mapped", [119]], [[120481, 120481], "mapped", [120]], [[120482, 120482], "mapped", [121]], [[120483, 120483], "mapped", [122]], [[120484, 120484], "mapped", [305]], [[120485, 120485], "mapped", [567]], [[120486, 120487], "disallowed"], [[120488, 120488], "mapped", [945]], [[120489, 120489], "mapped", [946]], [[120490, 120490], "mapped", [947]], [[120491, 120491], "mapped", [948]], [[120492, 120492], "mapped", [949]], [[120493, 120493], "mapped", [950]], [[120494, 120494], "mapped", [951]], [[120495, 120495], "mapped", [952]], [[120496, 120496], "mapped", [953]], [[120497, 120497], "mapped", [954]], [[120498, 120498], "mapped", [955]], [[120499, 120499], "mapped", [956]], [[120500, 120500], "mapped", [957]], [[120501, 120501], "mapped", [958]], [[120502, 120502], "mapped", [959]], [[120503, 120503], "mapped", [960]], [[120504, 120504], "mapped", [961]], [[120505, 120505], "mapped", [952]], [[120506, 120506], "mapped", [963]], [[120507, 120507], "mapped", [964]], [[120508, 120508], "mapped", [965]], [[120509, 120509], "mapped", [966]], [[120510, 120510], "mapped", [967]], [[120511, 120511], "mapped", [968]], [[120512, 120512], "mapped", [969]], [[120513, 120513], "mapped", [8711]], [[120514, 120514], "mapped", [945]], [[120515, 120515], "mapped", [946]], [[120516, 120516], "mapped", [947]], [[120517, 120517], "mapped", [948]], [[120518, 120518], "mapped", [949]], [[120519, 120519], "mapped", [950]], [[120520, 120520], "mapped", [951]], [[120521, 120521], "mapped", [952]], [[120522, 120522], "mapped", [953]], [[120523, 120523], "mapped", [954]], [[120524, 120524], "mapped", [955]], [[120525, 120525], "mapped", [956]], [[120526, 120526], "mapped", [957]], [[120527, 120527], "mapped", [958]], [[120528, 120528], "mapped", [959]], [[120529, 120529], "mapped", [960]], [[120530, 120530], "mapped", [961]], [[120531, 120532], "mapped", [963]], [[120533, 120533], "mapped", [964]], [[120534, 120534], "mapped", [965]], [[120535, 120535], "mapped", [966]], [[120536, 120536], "mapped", [967]], [[120537, 120537], "mapped", [968]], [[120538, 120538], "mapped", [969]], [[120539, 120539], "mapped", [8706]], [[120540, 120540], "mapped", [949]], [[120541, 120541], "mapped", [952]], [[120542, 120542], "mapped", [954]], [[120543, 120543], "mapped", [966]], [[120544, 120544], "mapped", [961]], [[120545, 120545], "mapped", [960]], [[120546, 120546], "mapped", [945]], [[120547, 120547], "mapped", [946]], [[120548, 120548], "mapped", [947]], [[120549, 120549], "mapped", [948]], [[120550, 120550], "mapped", [949]], [[120551, 120551], "mapped", [950]], [[120552, 120552], "mapped", [951]], [[120553, 120553], "mapped", [952]], [[120554, 120554], "mapped", [953]], [[120555, 120555], "mapped", [954]], [[120556, 120556], "mapped", [955]], [[120557, 120557], "mapped", [956]], [[120558, 120558], "mapped", [957]], [[120559, 120559], "mapped", [958]], [[120560, 120560], "mapped", [959]], [[120561, 120561], "mapped", [960]], [[120562, 120562], "mapped", [961]], [[120563, 120563], "mapped", [952]], [[120564, 120564], "mapped", [963]], [[120565, 120565], "mapped", [964]], [[120566, 120566], "mapped", [965]], [[120567, 120567], "mapped", [966]], [[120568, 120568], "mapped", [967]], [[120569, 120569], "mapped", [968]], [[120570, 120570], "mapped", [969]], [[120571, 120571], "mapped", [8711]], [[120572, 120572], "mapped", [945]], [[120573, 120573], "mapped", [946]], [[120574, 120574], "mapped", [947]], [[120575, 120575], "mapped", [948]], [[120576, 120576], "mapped", [949]], [[120577, 120577], "mapped", [950]], [[120578, 120578], "mapped", [951]], [[120579, 120579], "mapped", [952]], [[120580, 120580], "mapped", [953]], [[120581, 120581], "mapped", [954]], [[120582, 120582], "mapped", [955]], [[120583, 120583], "mapped", [956]], [[120584, 120584], "mapped", [957]], [[120585, 120585], "mapped", [958]], [[120586, 120586], "mapped", [959]], [[120587, 120587], "mapped", [960]], [[120588, 120588], "mapped", [961]], [[120589, 120590], "mapped", [963]], [[120591, 120591], "mapped", [964]], [[120592, 120592], "mapped", [965]], [[120593, 120593], "mapped", [966]], [[120594, 120594], "mapped", [967]], [[120595, 120595], "mapped", [968]], [[120596, 120596], "mapped", [969]], [[120597, 120597], "mapped", [8706]], [[120598, 120598], "mapped", [949]], [[120599, 120599], "mapped", [952]], [[120600, 120600], "mapped", [954]], [[120601, 120601], "mapped", [966]], [[120602, 120602], "mapped", [961]], [[120603, 120603], "mapped", [960]], [[120604, 120604], "mapped", [945]], [[120605, 120605], "mapped", [946]], [[120606, 120606], "mapped", [947]], [[120607, 120607], "mapped", [948]], [[120608, 120608], "mapped", [949]], [[120609, 120609], "mapped", [950]], [[120610, 120610], "mapped", [951]], [[120611, 120611], "mapped", [952]], [[120612, 120612], "mapped", [953]], [[120613, 120613], "mapped", [954]], [[120614, 120614], "mapped", [955]], [[120615, 120615], "mapped", [956]], [[120616, 120616], "mapped", [957]], [[120617, 120617], "mapped", [958]], [[120618, 120618], "mapped", [959]], [[120619, 120619], "mapped", [960]], [[120620, 120620], "mapped", [961]], [[120621, 120621], "mapped", [952]], [[120622, 120622], "mapped", [963]], [[120623, 120623], "mapped", [964]], [[120624, 120624], "mapped", [965]], [[120625, 120625], "mapped", [966]], [[120626, 120626], "mapped", [967]], [[120627, 120627], "mapped", [968]], [[120628, 120628], "mapped", [969]], [[120629, 120629], "mapped", [8711]], [[120630, 120630], "mapped", [945]], [[120631, 120631], "mapped", [946]], [[120632, 120632], "mapped", [947]], [[120633, 120633], "mapped", [948]], [[120634, 120634], "mapped", [949]], [[120635, 120635], "mapped", [950]], [[120636, 120636], "mapped", [951]], [[120637, 120637], "mapped", [952]], [[120638, 120638], "mapped", [953]], [[120639, 120639], "mapped", [954]], [[120640, 120640], "mapped", [955]], [[120641, 120641], "mapped", [956]], [[120642, 120642], "mapped", [957]], [[120643, 120643], "mapped", [958]], [[120644, 120644], "mapped", [959]], [[120645, 120645], "mapped", [960]], [[120646, 120646], "mapped", [961]], [[120647, 120648], "mapped", [963]], [[120649, 120649], "mapped", [964]], [[120650, 120650], "mapped", [965]], [[120651, 120651], "mapped", [966]], [[120652, 120652], "mapped", [967]], [[120653, 120653], "mapped", [968]], [[120654, 120654], "mapped", [969]], [[120655, 120655], "mapped", [8706]], [[120656, 120656], "mapped", [949]], [[120657, 120657], "mapped", [952]], [[120658, 120658], "mapped", [954]], [[120659, 120659], "mapped", [966]], [[120660, 120660], "mapped", [961]], [[120661, 120661], "mapped", [960]], [[120662, 120662], "mapped", [945]], [[120663, 120663], "mapped", [946]], [[120664, 120664], "mapped", [947]], [[120665, 120665], "mapped", [948]], [[120666, 120666], "mapped", [949]], [[120667, 120667], "mapped", [950]], [[120668, 120668], "mapped", [951]], [[120669, 120669], "mapped", [952]], [[120670, 120670], "mapped", [953]], [[120671, 120671], "mapped", [954]], [[120672, 120672], "mapped", [955]], [[120673, 120673], "mapped", [956]], [[120674, 120674], "mapped", [957]], [[120675, 120675], "mapped", [958]], [[120676, 120676], "mapped", [959]], [[120677, 120677], "mapped", [960]], [[120678, 120678], "mapped", [961]], [[120679, 120679], "mapped", [952]], [[120680, 120680], "mapped", [963]], [[120681, 120681], "mapped", [964]], [[120682, 120682], "mapped", [965]], [[120683, 120683], "mapped", [966]], [[120684, 120684], "mapped", [967]], [[120685, 120685], "mapped", [968]], [[120686, 120686], "mapped", [969]], [[120687, 120687], "mapped", [8711]], [[120688, 120688], "mapped", [945]], [[120689, 120689], "mapped", [946]], [[120690, 120690], "mapped", [947]], [[120691, 120691], "mapped", [948]], [[120692, 120692], "mapped", [949]], [[120693, 120693], "mapped", [950]], [[120694, 120694], "mapped", [951]], [[120695, 120695], "mapped", [952]], [[120696, 120696], "mapped", [953]], [[120697, 120697], "mapped", [954]], [[120698, 120698], "mapped", [955]], [[120699, 120699], "mapped", [956]], [[120700, 120700], "mapped", [957]], [[120701, 120701], "mapped", [958]], [[120702, 120702], "mapped", [959]], [[120703, 120703], "mapped", [960]], [[120704, 120704], "mapped", [961]], [[120705, 120706], "mapped", [963]], [[120707, 120707], "mapped", [964]], [[120708, 120708], "mapped", [965]], [[120709, 120709], "mapped", [966]], [[120710, 120710], "mapped", [967]], [[120711, 120711], "mapped", [968]], [[120712, 120712], "mapped", [969]], [[120713, 120713], "mapped", [8706]], [[120714, 120714], "mapped", [949]], [[120715, 120715], "mapped", [952]], [[120716, 120716], "mapped", [954]], [[120717, 120717], "mapped", [966]], [[120718, 120718], "mapped", [961]], [[120719, 120719], "mapped", [960]], [[120720, 120720], "mapped", [945]], [[120721, 120721], "mapped", [946]], [[120722, 120722], "mapped", [947]], [[120723, 120723], "mapped", [948]], [[120724, 120724], "mapped", [949]], [[120725, 120725], "mapped", [950]], [[120726, 120726], "mapped", [951]], [[120727, 120727], "mapped", [952]], [[120728, 120728], "mapped", [953]], [[120729, 120729], "mapped", [954]], [[120730, 120730], "mapped", [955]], [[120731, 120731], "mapped", [956]], [[120732, 120732], "mapped", [957]], [[120733, 120733], "mapped", [958]], [[120734, 120734], "mapped", [959]], [[120735, 120735], "mapped", [960]], [[120736, 120736], "mapped", [961]], [[120737, 120737], "mapped", [952]], [[120738, 120738], "mapped", [963]], [[120739, 120739], "mapped", [964]], [[120740, 120740], "mapped", [965]], [[120741, 120741], "mapped", [966]], [[120742, 120742], "mapped", [967]], [[120743, 120743], "mapped", [968]], [[120744, 120744], "mapped", [969]], [[120745, 120745], "mapped", [8711]], [[120746, 120746], "mapped", [945]], [[120747, 120747], "mapped", [946]], [[120748, 120748], "mapped", [947]], [[120749, 120749], "mapped", [948]], [[120750, 120750], "mapped", [949]], [[120751, 120751], "mapped", [950]], [[120752, 120752], "mapped", [951]], [[120753, 120753], "mapped", [952]], [[120754, 120754], "mapped", [953]], [[120755, 120755], "mapped", [954]], [[120756, 120756], "mapped", [955]], [[120757, 120757], "mapped", [956]], [[120758, 120758], "mapped", [957]], [[120759, 120759], "mapped", [958]], [[120760, 120760], "mapped", [959]], [[120761, 120761], "mapped", [960]], [[120762, 120762], "mapped", [961]], [[120763, 120764], "mapped", [963]], [[120765, 120765], "mapped", [964]], [[120766, 120766], "mapped", [965]], [[120767, 120767], "mapped", [966]], [[120768, 120768], "mapped", [967]], [[120769, 120769], "mapped", [968]], [[120770, 120770], "mapped", [969]], [[120771, 120771], "mapped", [8706]], [[120772, 120772], "mapped", [949]], [[120773, 120773], "mapped", [952]], [[120774, 120774], "mapped", [954]], [[120775, 120775], "mapped", [966]], [[120776, 120776], "mapped", [961]], [[120777, 120777], "mapped", [960]], [[120778, 120779], "mapped", [989]], [[120780, 120781], "disallowed"], [[120782, 120782], "mapped", [48]], [[120783, 120783], "mapped", [49]], [[120784, 120784], "mapped", [50]], [[120785, 120785], "mapped", [51]], [[120786, 120786], "mapped", [52]], [[120787, 120787], "mapped", [53]], [[120788, 120788], "mapped", [54]], [[120789, 120789], "mapped", [55]], [[120790, 120790], "mapped", [56]], [[120791, 120791], "mapped", [57]], [[120792, 120792], "mapped", [48]], [[120793, 120793], "mapped", [49]], [[120794, 120794], "mapped", [50]], [[120795, 120795], "mapped", [51]], [[120796, 120796], "mapped", [52]], [[120797, 120797], "mapped", [53]], [[120798, 120798], "mapped", [54]], [[120799, 120799], "mapped", [55]], [[120800, 120800], "mapped", [56]], [[120801, 120801], "mapped", [57]], [[120802, 120802], "mapped", [48]], [[120803, 120803], "mapped", [49]], [[120804, 120804], "mapped", [50]], [[120805, 120805], "mapped", [51]], [[120806, 120806], "mapped", [52]], [[120807, 120807], "mapped", [53]], [[120808, 120808], "mapped", [54]], [[120809, 120809], "mapped", [55]], [[120810, 120810], "mapped", [56]], [[120811, 120811], "mapped", [57]], [[120812, 120812], "mapped", [48]], [[120813, 120813], "mapped", [49]], [[120814, 120814], "mapped", [50]], [[120815, 120815], "mapped", [51]], [[120816, 120816], "mapped", [52]], [[120817, 120817], "mapped", [53]], [[120818, 120818], "mapped", [54]], [[120819, 120819], "mapped", [55]], [[120820, 120820], "mapped", [56]], [[120821, 120821], "mapped", [57]], [[120822, 120822], "mapped", [48]], [[120823, 120823], "mapped", [49]], [[120824, 120824], "mapped", [50]], [[120825, 120825], "mapped", [51]], [[120826, 120826], "mapped", [52]], [[120827, 120827], "mapped", [53]], [[120828, 120828], "mapped", [54]], [[120829, 120829], "mapped", [55]], [[120830, 120830], "mapped", [56]], [[120831, 120831], "mapped", [57]], [[120832, 121343], "valid", [], "NV8"], [[121344, 121398], "valid"], [[121399, 121402], "valid", [], "NV8"], [[121403, 121452], "valid"], [[121453, 121460], "valid", [], "NV8"], [[121461, 121461], "valid"], [[121462, 121475], "valid", [], "NV8"], [[121476, 121476], "valid"], [[121477, 121483], "valid", [], "NV8"], [[121484, 121498], "disallowed"], [[121499, 121503], "valid"], [[121504, 121504], "disallowed"], [[121505, 121519], "valid"], [[121520, 124927], "disallowed"], [[124928, 125124], "valid"], [[125125, 125126], "disallowed"], [[125127, 125135], "valid", [], "NV8"], [[125136, 125142], "valid"], [[125143, 126463], "disallowed"], [[126464, 126464], "mapped", [1575]], [[126465, 126465], "mapped", [1576]], [[126466, 126466], "mapped", [1580]], [[126467, 126467], "mapped", [1583]], [[126468, 126468], "disallowed"], [[126469, 126469], "mapped", [1608]], [[126470, 126470], "mapped", [1586]], [[126471, 126471], "mapped", [1581]], [[126472, 126472], "mapped", [1591]], [[126473, 126473], "mapped", [1610]], [[126474, 126474], "mapped", [1603]], [[126475, 126475], "mapped", [1604]], [[126476, 126476], "mapped", [1605]], [[126477, 126477], "mapped", [1606]], [[126478, 126478], "mapped", [1587]], [[126479, 126479], "mapped", [1593]], [[126480, 126480], "mapped", [1601]], [[126481, 126481], "mapped", [1589]], [[126482, 126482], "mapped", [1602]], [[126483, 126483], "mapped", [1585]], [[126484, 126484], "mapped", [1588]], [[126485, 126485], "mapped", [1578]], [[126486, 126486], "mapped", [1579]], [[126487, 126487], "mapped", [1582]], [[126488, 126488], "mapped", [1584]], [[126489, 126489], "mapped", [1590]], [[126490, 126490], "mapped", [1592]], [[126491, 126491], "mapped", [1594]], [[126492, 126492], "mapped", [1646]], [[126493, 126493], "mapped", [1722]], [[126494, 126494], "mapped", [1697]], [[126495, 126495], "mapped", [1647]], [[126496, 126496], "disallowed"], [[126497, 126497], "mapped", [1576]], [[126498, 126498], "mapped", [1580]], [[126499, 126499], "disallowed"], [[126500, 126500], "mapped", [1607]], [[126501, 126502], "disallowed"], [[126503, 126503], "mapped", [1581]], [[126504, 126504], "disallowed"], [[126505, 126505], "mapped", [1610]], [[126506, 126506], "mapped", [1603]], [[126507, 126507], "mapped", [1604]], [[126508, 126508], "mapped", [1605]], [[126509, 126509], "mapped", [1606]], [[126510, 126510], "mapped", [1587]], [[126511, 126511], "mapped", [1593]], [[126512, 126512], "mapped", [1601]], [[126513, 126513], "mapped", [1589]], [[126514, 126514], "mapped", [1602]], [[126515, 126515], "disallowed"], [[126516, 126516], "mapped", [1588]], [[126517, 126517], "mapped", [1578]], [[126518, 126518], "mapped", [1579]], [[126519, 126519], "mapped", [1582]], [[126520, 126520], "disallowed"], [[126521, 126521], "mapped", [1590]], [[126522, 126522], "disallowed"], [[126523, 126523], "mapped", [1594]], [[126524, 126529], "disallowed"], [[126530, 126530], "mapped", [1580]], [[126531, 126534], "disallowed"], [[126535, 126535], "mapped", [1581]], [[126536, 126536], "disallowed"], [[126537, 126537], "mapped", [1610]], [[126538, 126538], "disallowed"], [[126539, 126539], "mapped", [1604]], [[126540, 126540], "disallowed"], [[126541, 126541], "mapped", [1606]], [[126542, 126542], "mapped", [1587]], [[126543, 126543], "mapped", [1593]], [[126544, 126544], "disallowed"], [[126545, 126545], "mapped", [1589]], [[126546, 126546], "mapped", [1602]], [[126547, 126547], "disallowed"], [[126548, 126548], "mapped", [1588]], [[126549, 126550], "disallowed"], [[126551, 126551], "mapped", [1582]], [[126552, 126552], "disallowed"], [[126553, 126553], "mapped", [1590]], [[126554, 126554], "disallowed"], [[126555, 126555], "mapped", [1594]], [[126556, 126556], "disallowed"], [[126557, 126557], "mapped", [1722]], [[126558, 126558], "disallowed"], [[126559, 126559], "mapped", [1647]], [[126560, 126560], "disallowed"], [[126561, 126561], "mapped", [1576]], [[126562, 126562], "mapped", [1580]], [[126563, 126563], "disallowed"], [[126564, 126564], "mapped", [1607]], [[126565, 126566], "disallowed"], [[126567, 126567], "mapped", [1581]], [[126568, 126568], "mapped", [1591]], [[126569, 126569], "mapped", [1610]], [[126570, 126570], "mapped", [1603]], [[126571, 126571], "disallowed"], [[126572, 126572], "mapped", [1605]], [[126573, 126573], "mapped", [1606]], [[126574, 126574], "mapped", [1587]], [[126575, 126575], "mapped", [1593]], [[126576, 126576], "mapped", [1601]], [[126577, 126577], "mapped", [1589]], [[126578, 126578], "mapped", [1602]], [[126579, 126579], "disallowed"], [[126580, 126580], "mapped", [1588]], [[126581, 126581], "mapped", [1578]], [[126582, 126582], "mapped", [1579]], [[126583, 126583], "mapped", [1582]], [[126584, 126584], "disallowed"], [[126585, 126585], "mapped", [1590]], [[126586, 126586], "mapped", [1592]], [[126587, 126587], "mapped", [1594]], [[126588, 126588], "mapped", [1646]], [[126589, 126589], "disallowed"], [[126590, 126590], "mapped", [1697]], [[126591, 126591], "disallowed"], [[126592, 126592], "mapped", [1575]], [[126593, 126593], "mapped", [1576]], [[126594, 126594], "mapped", [1580]], [[126595, 126595], "mapped", [1583]], [[126596, 126596], "mapped", [1607]], [[126597, 126597], "mapped", [1608]], [[126598, 126598], "mapped", [1586]], [[126599, 126599], "mapped", [1581]], [[126600, 126600], "mapped", [1591]], [[126601, 126601], "mapped", [1610]], [[126602, 126602], "disallowed"], [[126603, 126603], "mapped", [1604]], [[126604, 126604], "mapped", [1605]], [[126605, 126605], "mapped", [1606]], [[126606, 126606], "mapped", [1587]], [[126607, 126607], "mapped", [1593]], [[126608, 126608], "mapped", [1601]], [[126609, 126609], "mapped", [1589]], [[126610, 126610], "mapped", [1602]], [[126611, 126611], "mapped", [1585]], [[126612, 126612], "mapped", [1588]], [[126613, 126613], "mapped", [1578]], [[126614, 126614], "mapped", [1579]], [[126615, 126615], "mapped", [1582]], [[126616, 126616], "mapped", [1584]], [[126617, 126617], "mapped", [1590]], [[126618, 126618], "mapped", [1592]], [[126619, 126619], "mapped", [1594]], [[126620, 126624], "disallowed"], [[126625, 126625], "mapped", [1576]], [[126626, 126626], "mapped", [1580]], [[126627, 126627], "mapped", [1583]], [[126628, 126628], "disallowed"], [[126629, 126629], "mapped", [1608]], [[126630, 126630], "mapped", [1586]], [[126631, 126631], "mapped", [1581]], [[126632, 126632], "mapped", [1591]], [[126633, 126633], "mapped", [1610]], [[126634, 126634], "disallowed"], [[126635, 126635], "mapped", [1604]], [[126636, 126636], "mapped", [1605]], [[126637, 126637], "mapped", [1606]], [[126638, 126638], "mapped", [1587]], [[126639, 126639], "mapped", [1593]], [[126640, 126640], "mapped", [1601]], [[126641, 126641], "mapped", [1589]], [[126642, 126642], "mapped", [1602]], [[126643, 126643], "mapped", [1585]], [[126644, 126644], "mapped", [1588]], [[126645, 126645], "mapped", [1578]], [[126646, 126646], "mapped", [1579]], [[126647, 126647], "mapped", [1582]], [[126648, 126648], "mapped", [1584]], [[126649, 126649], "mapped", [1590]], [[126650, 126650], "mapped", [1592]], [[126651, 126651], "mapped", [1594]], [[126652, 126703], "disallowed"], [[126704, 126705], "valid", [], "NV8"], [[126706, 126975], "disallowed"], [[126976, 127019], "valid", [], "NV8"], [[127020, 127023], "disallowed"], [[127024, 127123], "valid", [], "NV8"], [[127124, 127135], "disallowed"], [[127136, 127150], "valid", [], "NV8"], [[127151, 127152], "disallowed"], [[127153, 127166], "valid", [], "NV8"], [[127167, 127167], "valid", [], "NV8"], [[127168, 127168], "disallowed"], [[127169, 127183], "valid", [], "NV8"], [[127184, 127184], "disallowed"], [[127185, 127199], "valid", [], "NV8"], [[127200, 127221], "valid", [], "NV8"], [[127222, 127231], "disallowed"], [[127232, 127232], "disallowed"], [[127233, 127233], "disallowed_STD3_mapped", [48, 44]], [[127234, 127234], "disallowed_STD3_mapped", [49, 44]], [[127235, 127235], "disallowed_STD3_mapped", [50, 44]], [[127236, 127236], "disallowed_STD3_mapped", [51, 44]], [[127237, 127237], "disallowed_STD3_mapped", [52, 44]], [[127238, 127238], "disallowed_STD3_mapped", [53, 44]], [[127239, 127239], "disallowed_STD3_mapped", [54, 44]], [[127240, 127240], "disallowed_STD3_mapped", [55, 44]], [[127241, 127241], "disallowed_STD3_mapped", [56, 44]], [[127242, 127242], "disallowed_STD3_mapped", [57, 44]], [[127243, 127244], "valid", [], "NV8"], [[127245, 127247], "disallowed"], [[127248, 127248], "disallowed_STD3_mapped", [40, 97, 41]], [[127249, 127249], "disallowed_STD3_mapped", [40, 98, 41]], [[127250, 127250], "disallowed_STD3_mapped", [40, 99, 41]], [[127251, 127251], "disallowed_STD3_mapped", [40, 100, 41]], [[127252, 127252], "disallowed_STD3_mapped", [40, 101, 41]], [[127253, 127253], "disallowed_STD3_mapped", [40, 102, 41]], [[127254, 127254], "disallowed_STD3_mapped", [40, 103, 41]], [[127255, 127255], "disallowed_STD3_mapped", [40, 104, 41]], [[127256, 127256], "disallowed_STD3_mapped", [40, 105, 41]], [[127257, 127257], "disallowed_STD3_mapped", [40, 106, 41]], [[127258, 127258], "disallowed_STD3_mapped", [40, 107, 41]], [[127259, 127259], "disallowed_STD3_mapped", [40, 108, 41]], [[127260, 127260], "disallowed_STD3_mapped", [40, 109, 41]], [[127261, 127261], "disallowed_STD3_mapped", [40, 110, 41]], [[127262, 127262], "disallowed_STD3_mapped", [40, 111, 41]], [[127263, 127263], "disallowed_STD3_mapped", [40, 112, 41]], [[127264, 127264], "disallowed_STD3_mapped", [40, 113, 41]], [[127265, 127265], "disallowed_STD3_mapped", [40, 114, 41]], [[127266, 127266], "disallowed_STD3_mapped", [40, 115, 41]], [[127267, 127267], "disallowed_STD3_mapped", [40, 116, 41]], [[127268, 127268], "disallowed_STD3_mapped", [40, 117, 41]], [[127269, 127269], "disallowed_STD3_mapped", [40, 118, 41]], [[127270, 127270], "disallowed_STD3_mapped", [40, 119, 41]], [[127271, 127271], "disallowed_STD3_mapped", [40, 120, 41]], [[127272, 127272], "disallowed_STD3_mapped", [40, 121, 41]], [[127273, 127273], "disallowed_STD3_mapped", [40, 122, 41]], [[127274, 127274], "mapped", [12308, 115, 12309]], [[127275, 127275], "mapped", [99]], [[127276, 127276], "mapped", [114]], [[127277, 127277], "mapped", [99, 100]], [[127278, 127278], "mapped", [119, 122]], [[127279, 127279], "disallowed"], [[127280, 127280], "mapped", [97]], [[127281, 127281], "mapped", [98]], [[127282, 127282], "mapped", [99]], [[127283, 127283], "mapped", [100]], [[127284, 127284], "mapped", [101]], [[127285, 127285], "mapped", [102]], [[127286, 127286], "mapped", [103]], [[127287, 127287], "mapped", [104]], [[127288, 127288], "mapped", [105]], [[127289, 127289], "mapped", [106]], [[127290, 127290], "mapped", [107]], [[127291, 127291], "mapped", [108]], [[127292, 127292], "mapped", [109]], [[127293, 127293], "mapped", [110]], [[127294, 127294], "mapped", [111]], [[127295, 127295], "mapped", [112]], [[127296, 127296], "mapped", [113]], [[127297, 127297], "mapped", [114]], [[127298, 127298], "mapped", [115]], [[127299, 127299], "mapped", [116]], [[127300, 127300], "mapped", [117]], [[127301, 127301], "mapped", [118]], [[127302, 127302], "mapped", [119]], [[127303, 127303], "mapped", [120]], [[127304, 127304], "mapped", [121]], [[127305, 127305], "mapped", [122]], [[127306, 127306], "mapped", [104, 118]], [[127307, 127307], "mapped", [109, 118]], [[127308, 127308], "mapped", [115, 100]], [[127309, 127309], "mapped", [115, 115]], [[127310, 127310], "mapped", [112, 112, 118]], [[127311, 127311], "mapped", [119, 99]], [[127312, 127318], "valid", [], "NV8"], [[127319, 127319], "valid", [], "NV8"], [[127320, 127326], "valid", [], "NV8"], [[127327, 127327], "valid", [], "NV8"], [[127328, 127337], "valid", [], "NV8"], [[127338, 127338], "mapped", [109, 99]], [[127339, 127339], "mapped", [109, 100]], [[127340, 127343], "disallowed"], [[127344, 127352], "valid", [], "NV8"], [[127353, 127353], "valid", [], "NV8"], [[127354, 127354], "valid", [], "NV8"], [[127355, 127356], "valid", [], "NV8"], [[127357, 127358], "valid", [], "NV8"], [[127359, 127359], "valid", [], "NV8"], [[127360, 127369], "valid", [], "NV8"], [[127370, 127373], "valid", [], "NV8"], [[127374, 127375], "valid", [], "NV8"], [[127376, 127376], "mapped", [100, 106]], [[127377, 127386], "valid", [], "NV8"], [[127387, 127461], "disallowed"], [[127462, 127487], "valid", [], "NV8"], [[127488, 127488], "mapped", [12411, 12363]], [[127489, 127489], "mapped", [12467, 12467]], [[127490, 127490], "mapped", [12469]], [[127491, 127503], "disallowed"], [[127504, 127504], "mapped", [25163]], [[127505, 127505], "mapped", [23383]], [[127506, 127506], "mapped", [21452]], [[127507, 127507], "mapped", [12487]], [[127508, 127508], "mapped", [20108]], [[127509, 127509], "mapped", [22810]], [[127510, 127510], "mapped", [35299]], [[127511, 127511], "mapped", [22825]], [[127512, 127512], "mapped", [20132]], [[127513, 127513], "mapped", [26144]], [[127514, 127514], "mapped", [28961]], [[127515, 127515], "mapped", [26009]], [[127516, 127516], "mapped", [21069]], [[127517, 127517], "mapped", [24460]], [[127518, 127518], "mapped", [20877]], [[127519, 127519], "mapped", [26032]], [[127520, 127520], "mapped", [21021]], [[127521, 127521], "mapped", [32066]], [[127522, 127522], "mapped", [29983]], [[127523, 127523], "mapped", [36009]], [[127524, 127524], "mapped", [22768]], [[127525, 127525], "mapped", [21561]], [[127526, 127526], "mapped", [28436]], [[127527, 127527], "mapped", [25237]], [[127528, 127528], "mapped", [25429]], [[127529, 127529], "mapped", [19968]], [[127530, 127530], "mapped", [19977]], [[127531, 127531], "mapped", [36938]], [[127532, 127532], "mapped", [24038]], [[127533, 127533], "mapped", [20013]], [[127534, 127534], "mapped", [21491]], [[127535, 127535], "mapped", [25351]], [[127536, 127536], "mapped", [36208]], [[127537, 127537], "mapped", [25171]], [[127538, 127538], "mapped", [31105]], [[127539, 127539], "mapped", [31354]], [[127540, 127540], "mapped", [21512]], [[127541, 127541], "mapped", [28288]], [[127542, 127542], "mapped", [26377]], [[127543, 127543], "mapped", [26376]], [[127544, 127544], "mapped", [30003]], [[127545, 127545], "mapped", [21106]], [[127546, 127546], "mapped", [21942]], [[127547, 127551], "disallowed"], [[127552, 127552], "mapped", [12308, 26412, 12309]], [[127553, 127553], "mapped", [12308, 19977, 12309]], [[127554, 127554], "mapped", [12308, 20108, 12309]], [[127555, 127555], "mapped", [12308, 23433, 12309]], [[127556, 127556], "mapped", [12308, 28857, 12309]], [[127557, 127557], "mapped", [12308, 25171, 12309]], [[127558, 127558], "mapped", [12308, 30423, 12309]], [[127559, 127559], "mapped", [12308, 21213, 12309]], [[127560, 127560], "mapped", [12308, 25943, 12309]], [[127561, 127567], "disallowed"], [[127568, 127568], "mapped", [24471]], [[127569, 127569], "mapped", [21487]], [[127570, 127743], "disallowed"], [[127744, 127776], "valid", [], "NV8"], [[127777, 127788], "valid", [], "NV8"], [[127789, 127791], "valid", [], "NV8"], [[127792, 127797], "valid", [], "NV8"], [[127798, 127798], "valid", [], "NV8"], [[127799, 127868], "valid", [], "NV8"], [[127869, 127869], "valid", [], "NV8"], [[127870, 127871], "valid", [], "NV8"], [[127872, 127891], "valid", [], "NV8"], [[127892, 127903], "valid", [], "NV8"], [[127904, 127940], "valid", [], "NV8"], [[127941, 127941], "valid", [], "NV8"], [[127942, 127946], "valid", [], "NV8"], [[127947, 127950], "valid", [], "NV8"], [[127951, 127955], "valid", [], "NV8"], [[127956, 127967], "valid", [], "NV8"], [[127968, 127984], "valid", [], "NV8"], [[127985, 127991], "valid", [], "NV8"], [[127992, 127999], "valid", [], "NV8"], [[128e3, 128062], "valid", [], "NV8"], [[128063, 128063], "valid", [], "NV8"], [[128064, 128064], "valid", [], "NV8"], [[128065, 128065], "valid", [], "NV8"], [[128066, 128247], "valid", [], "NV8"], [[128248, 128248], "valid", [], "NV8"], [[128249, 128252], "valid", [], "NV8"], [[128253, 128254], "valid", [], "NV8"], [[128255, 128255], "valid", [], "NV8"], [[128256, 128317], "valid", [], "NV8"], [[128318, 128319], "valid", [], "NV8"], [[128320, 128323], "valid", [], "NV8"], [[128324, 128330], "valid", [], "NV8"], [[128331, 128335], "valid", [], "NV8"], [[128336, 128359], "valid", [], "NV8"], [[128360, 128377], "valid", [], "NV8"], [[128378, 128378], "disallowed"], [[128379, 128419], "valid", [], "NV8"], [[128420, 128420], "disallowed"], [[128421, 128506], "valid", [], "NV8"], [[128507, 128511], "valid", [], "NV8"], [[128512, 128512], "valid", [], "NV8"], [[128513, 128528], "valid", [], "NV8"], [[128529, 128529], "valid", [], "NV8"], [[128530, 128532], "valid", [], "NV8"], [[128533, 128533], "valid", [], "NV8"], [[128534, 128534], "valid", [], "NV8"], [[128535, 128535], "valid", [], "NV8"], [[128536, 128536], "valid", [], "NV8"], [[128537, 128537], "valid", [], "NV8"], [[128538, 128538], "valid", [], "NV8"], [[128539, 128539], "valid", [], "NV8"], [[128540, 128542], "valid", [], "NV8"], [[128543, 128543], "valid", [], "NV8"], [[128544, 128549], "valid", [], "NV8"], [[128550, 128551], "valid", [], "NV8"], [[128552, 128555], "valid", [], "NV8"], [[128556, 128556], "valid", [], "NV8"], [[128557, 128557], "valid", [], "NV8"], [[128558, 128559], "valid", [], "NV8"], [[128560, 128563], "valid", [], "NV8"], [[128564, 128564], "valid", [], "NV8"], [[128565, 128576], "valid", [], "NV8"], [[128577, 128578], "valid", [], "NV8"], [[128579, 128580], "valid", [], "NV8"], [[128581, 128591], "valid", [], "NV8"], [[128592, 128639], "valid", [], "NV8"], [[128640, 128709], "valid", [], "NV8"], [[128710, 128719], "valid", [], "NV8"], [[128720, 128720], "valid", [], "NV8"], [[128721, 128735], "disallowed"], [[128736, 128748], "valid", [], "NV8"], [[128749, 128751], "disallowed"], [[128752, 128755], "valid", [], "NV8"], [[128756, 128767], "disallowed"], [[128768, 128883], "valid", [], "NV8"], [[128884, 128895], "disallowed"], [[128896, 128980], "valid", [], "NV8"], [[128981, 129023], "disallowed"], [[129024, 129035], "valid", [], "NV8"], [[129036, 129039], "disallowed"], [[129040, 129095], "valid", [], "NV8"], [[129096, 129103], "disallowed"], [[129104, 129113], "valid", [], "NV8"], [[129114, 129119], "disallowed"], [[129120, 129159], "valid", [], "NV8"], [[129160, 129167], "disallowed"], [[129168, 129197], "valid", [], "NV8"], [[129198, 129295], "disallowed"], [[129296, 129304], "valid", [], "NV8"], [[129305, 129407], "disallowed"], [[129408, 129412], "valid", [], "NV8"], [[129413, 129471], "disallowed"], [[129472, 129472], "valid", [], "NV8"], [[129473, 131069], "disallowed"], [[131070, 131071], "disallowed"], [[131072, 173782], "valid"], [[173783, 173823], "disallowed"], [[173824, 177972], "valid"], [[177973, 177983], "disallowed"], [[177984, 178205], "valid"], [[178206, 178207], "disallowed"], [[178208, 183969], "valid"], [[183970, 194559], "disallowed"], [[194560, 194560], "mapped", [20029]], [[194561, 194561], "mapped", [20024]], [[194562, 194562], "mapped", [20033]], [[194563, 194563], "mapped", [131362]], [[194564, 194564], "mapped", [20320]], [[194565, 194565], "mapped", [20398]], [[194566, 194566], "mapped", [20411]], [[194567, 194567], "mapped", [20482]], [[194568, 194568], "mapped", [20602]], [[194569, 194569], "mapped", [20633]], [[194570, 194570], "mapped", [20711]], [[194571, 194571], "mapped", [20687]], [[194572, 194572], "mapped", [13470]], [[194573, 194573], "mapped", [132666]], [[194574, 194574], "mapped", [20813]], [[194575, 194575], "mapped", [20820]], [[194576, 194576], "mapped", [20836]], [[194577, 194577], "mapped", [20855]], [[194578, 194578], "mapped", [132380]], [[194579, 194579], "mapped", [13497]], [[194580, 194580], "mapped", [20839]], [[194581, 194581], "mapped", [20877]], [[194582, 194582], "mapped", [132427]], [[194583, 194583], "mapped", [20887]], [[194584, 194584], "mapped", [20900]], [[194585, 194585], "mapped", [20172]], [[194586, 194586], "mapped", [20908]], [[194587, 194587], "mapped", [20917]], [[194588, 194588], "mapped", [168415]], [[194589, 194589], "mapped", [20981]], [[194590, 194590], "mapped", [20995]], [[194591, 194591], "mapped", [13535]], [[194592, 194592], "mapped", [21051]], [[194593, 194593], "mapped", [21062]], [[194594, 194594], "mapped", [21106]], [[194595, 194595], "mapped", [21111]], [[194596, 194596], "mapped", [13589]], [[194597, 194597], "mapped", [21191]], [[194598, 194598], "mapped", [21193]], [[194599, 194599], "mapped", [21220]], [[194600, 194600], "mapped", [21242]], [[194601, 194601], "mapped", [21253]], [[194602, 194602], "mapped", [21254]], [[194603, 194603], "mapped", [21271]], [[194604, 194604], "mapped", [21321]], [[194605, 194605], "mapped", [21329]], [[194606, 194606], "mapped", [21338]], [[194607, 194607], "mapped", [21363]], [[194608, 194608], "mapped", [21373]], [[194609, 194611], "mapped", [21375]], [[194612, 194612], "mapped", [133676]], [[194613, 194613], "mapped", [28784]], [[194614, 194614], "mapped", [21450]], [[194615, 194615], "mapped", [21471]], [[194616, 194616], "mapped", [133987]], [[194617, 194617], "mapped", [21483]], [[194618, 194618], "mapped", [21489]], [[194619, 194619], "mapped", [21510]], [[194620, 194620], "mapped", [21662]], [[194621, 194621], "mapped", [21560]], [[194622, 194622], "mapped", [21576]], [[194623, 194623], "mapped", [21608]], [[194624, 194624], "mapped", [21666]], [[194625, 194625], "mapped", [21750]], [[194626, 194626], "mapped", [21776]], [[194627, 194627], "mapped", [21843]], [[194628, 194628], "mapped", [21859]], [[194629, 194630], "mapped", [21892]], [[194631, 194631], "mapped", [21913]], [[194632, 194632], "mapped", [21931]], [[194633, 194633], "mapped", [21939]], [[194634, 194634], "mapped", [21954]], [[194635, 194635], "mapped", [22294]], [[194636, 194636], "mapped", [22022]], [[194637, 194637], "mapped", [22295]], [[194638, 194638], "mapped", [22097]], [[194639, 194639], "mapped", [22132]], [[194640, 194640], "mapped", [20999]], [[194641, 194641], "mapped", [22766]], [[194642, 194642], "mapped", [22478]], [[194643, 194643], "mapped", [22516]], [[194644, 194644], "mapped", [22541]], [[194645, 194645], "mapped", [22411]], [[194646, 194646], "mapped", [22578]], [[194647, 194647], "mapped", [22577]], [[194648, 194648], "mapped", [22700]], [[194649, 194649], "mapped", [136420]], [[194650, 194650], "mapped", [22770]], [[194651, 194651], "mapped", [22775]], [[194652, 194652], "mapped", [22790]], [[194653, 194653], "mapped", [22810]], [[194654, 194654], "mapped", [22818]], [[194655, 194655], "mapped", [22882]], [[194656, 194656], "mapped", [136872]], [[194657, 194657], "mapped", [136938]], [[194658, 194658], "mapped", [23020]], [[194659, 194659], "mapped", [23067]], [[194660, 194660], "mapped", [23079]], [[194661, 194661], "mapped", [23e3]], [[194662, 194662], "mapped", [23142]], [[194663, 194663], "mapped", [14062]], [[194664, 194664], "disallowed"], [[194665, 194665], "mapped", [23304]], [[194666, 194667], "mapped", [23358]], [[194668, 194668], "mapped", [137672]], [[194669, 194669], "mapped", [23491]], [[194670, 194670], "mapped", [23512]], [[194671, 194671], "mapped", [23527]], [[194672, 194672], "mapped", [23539]], [[194673, 194673], "mapped", [138008]], [[194674, 194674], "mapped", [23551]], [[194675, 194675], "mapped", [23558]], [[194676, 194676], "disallowed"], [[194677, 194677], "mapped", [23586]], [[194678, 194678], "mapped", [14209]], [[194679, 194679], "mapped", [23648]], [[194680, 194680], "mapped", [23662]], [[194681, 194681], "mapped", [23744]], [[194682, 194682], "mapped", [23693]], [[194683, 194683], "mapped", [138724]], [[194684, 194684], "mapped", [23875]], [[194685, 194685], "mapped", [138726]], [[194686, 194686], "mapped", [23918]], [[194687, 194687], "mapped", [23915]], [[194688, 194688], "mapped", [23932]], [[194689, 194689], "mapped", [24033]], [[194690, 194690], "mapped", [24034]], [[194691, 194691], "mapped", [14383]], [[194692, 194692], "mapped", [24061]], [[194693, 194693], "mapped", [24104]], [[194694, 194694], "mapped", [24125]], [[194695, 194695], "mapped", [24169]], [[194696, 194696], "mapped", [14434]], [[194697, 194697], "mapped", [139651]], [[194698, 194698], "mapped", [14460]], [[194699, 194699], "mapped", [24240]], [[194700, 194700], "mapped", [24243]], [[194701, 194701], "mapped", [24246]], [[194702, 194702], "mapped", [24266]], [[194703, 194703], "mapped", [172946]], [[194704, 194704], "mapped", [24318]], [[194705, 194706], "mapped", [140081]], [[194707, 194707], "mapped", [33281]], [[194708, 194709], "mapped", [24354]], [[194710, 194710], "mapped", [14535]], [[194711, 194711], "mapped", [144056]], [[194712, 194712], "mapped", [156122]], [[194713, 194713], "mapped", [24418]], [[194714, 194714], "mapped", [24427]], [[194715, 194715], "mapped", [14563]], [[194716, 194716], "mapped", [24474]], [[194717, 194717], "mapped", [24525]], [[194718, 194718], "mapped", [24535]], [[194719, 194719], "mapped", [24569]], [[194720, 194720], "mapped", [24705]], [[194721, 194721], "mapped", [14650]], [[194722, 194722], "mapped", [14620]], [[194723, 194723], "mapped", [24724]], [[194724, 194724], "mapped", [141012]], [[194725, 194725], "mapped", [24775]], [[194726, 194726], "mapped", [24904]], [[194727, 194727], "mapped", [24908]], [[194728, 194728], "mapped", [24910]], [[194729, 194729], "mapped", [24908]], [[194730, 194730], "mapped", [24954]], [[194731, 194731], "mapped", [24974]], [[194732, 194732], "mapped", [25010]], [[194733, 194733], "mapped", [24996]], [[194734, 194734], "mapped", [25007]], [[194735, 194735], "mapped", [25054]], [[194736, 194736], "mapped", [25074]], [[194737, 194737], "mapped", [25078]], [[194738, 194738], "mapped", [25104]], [[194739, 194739], "mapped", [25115]], [[194740, 194740], "mapped", [25181]], [[194741, 194741], "mapped", [25265]], [[194742, 194742], "mapped", [25300]], [[194743, 194743], "mapped", [25424]], [[194744, 194744], "mapped", [142092]], [[194745, 194745], "mapped", [25405]], [[194746, 194746], "mapped", [25340]], [[194747, 194747], "mapped", [25448]], [[194748, 194748], "mapped", [25475]], [[194749, 194749], "mapped", [25572]], [[194750, 194750], "mapped", [142321]], [[194751, 194751], "mapped", [25634]], [[194752, 194752], "mapped", [25541]], [[194753, 194753], "mapped", [25513]], [[194754, 194754], "mapped", [14894]], [[194755, 194755], "mapped", [25705]], [[194756, 194756], "mapped", [25726]], [[194757, 194757], "mapped", [25757]], [[194758, 194758], "mapped", [25719]], [[194759, 194759], "mapped", [14956]], [[194760, 194760], "mapped", [25935]], [[194761, 194761], "mapped", [25964]], [[194762, 194762], "mapped", [143370]], [[194763, 194763], "mapped", [26083]], [[194764, 194764], "mapped", [26360]], [[194765, 194765], "mapped", [26185]], [[194766, 194766], "mapped", [15129]], [[194767, 194767], "mapped", [26257]], [[194768, 194768], "mapped", [15112]], [[194769, 194769], "mapped", [15076]], [[194770, 194770], "mapped", [20882]], [[194771, 194771], "mapped", [20885]], [[194772, 194772], "mapped", [26368]], [[194773, 194773], "mapped", [26268]], [[194774, 194774], "mapped", [32941]], [[194775, 194775], "mapped", [17369]], [[194776, 194776], "mapped", [26391]], [[194777, 194777], "mapped", [26395]], [[194778, 194778], "mapped", [26401]], [[194779, 194779], "mapped", [26462]], [[194780, 194780], "mapped", [26451]], [[194781, 194781], "mapped", [144323]], [[194782, 194782], "mapped", [15177]], [[194783, 194783], "mapped", [26618]], [[194784, 194784], "mapped", [26501]], [[194785, 194785], "mapped", [26706]], [[194786, 194786], "mapped", [26757]], [[194787, 194787], "mapped", [144493]], [[194788, 194788], "mapped", [26766]], [[194789, 194789], "mapped", [26655]], [[194790, 194790], "mapped", [26900]], [[194791, 194791], "mapped", [15261]], [[194792, 194792], "mapped", [26946]], [[194793, 194793], "mapped", [27043]], [[194794, 194794], "mapped", [27114]], [[194795, 194795], "mapped", [27304]], [[194796, 194796], "mapped", [145059]], [[194797, 194797], "mapped", [27355]], [[194798, 194798], "mapped", [15384]], [[194799, 194799], "mapped", [27425]], [[194800, 194800], "mapped", [145575]], [[194801, 194801], "mapped", [27476]], [[194802, 194802], "mapped", [15438]], [[194803, 194803], "mapped", [27506]], [[194804, 194804], "mapped", [27551]], [[194805, 194805], "mapped", [27578]], [[194806, 194806], "mapped", [27579]], [[194807, 194807], "mapped", [146061]], [[194808, 194808], "mapped", [138507]], [[194809, 194809], "mapped", [146170]], [[194810, 194810], "mapped", [27726]], [[194811, 194811], "mapped", [146620]], [[194812, 194812], "mapped", [27839]], [[194813, 194813], "mapped", [27853]], [[194814, 194814], "mapped", [27751]], [[194815, 194815], "mapped", [27926]], [[194816, 194816], "mapped", [27966]], [[194817, 194817], "mapped", [28023]], [[194818, 194818], "mapped", [27969]], [[194819, 194819], "mapped", [28009]], [[194820, 194820], "mapped", [28024]], [[194821, 194821], "mapped", [28037]], [[194822, 194822], "mapped", [146718]], [[194823, 194823], "mapped", [27956]], [[194824, 194824], "mapped", [28207]], [[194825, 194825], "mapped", [28270]], [[194826, 194826], "mapped", [15667]], [[194827, 194827], "mapped", [28363]], [[194828, 194828], "mapped", [28359]], [[194829, 194829], "mapped", [147153]], [[194830, 194830], "mapped", [28153]], [[194831, 194831], "mapped", [28526]], [[194832, 194832], "mapped", [147294]], [[194833, 194833], "mapped", [147342]], [[194834, 194834], "mapped", [28614]], [[194835, 194835], "mapped", [28729]], [[194836, 194836], "mapped", [28702]], [[194837, 194837], "mapped", [28699]], [[194838, 194838], "mapped", [15766]], [[194839, 194839], "mapped", [28746]], [[194840, 194840], "mapped", [28797]], [[194841, 194841], "mapped", [28791]], [[194842, 194842], "mapped", [28845]], [[194843, 194843], "mapped", [132389]], [[194844, 194844], "mapped", [28997]], [[194845, 194845], "mapped", [148067]], [[194846, 194846], "mapped", [29084]], [[194847, 194847], "disallowed"], [[194848, 194848], "mapped", [29224]], [[194849, 194849], "mapped", [29237]], [[194850, 194850], "mapped", [29264]], [[194851, 194851], "mapped", [149e3]], [[194852, 194852], "mapped", [29312]], [[194853, 194853], "mapped", [29333]], [[194854, 194854], "mapped", [149301]], [[194855, 194855], "mapped", [149524]], [[194856, 194856], "mapped", [29562]], [[194857, 194857], "mapped", [29579]], [[194858, 194858], "mapped", [16044]], [[194859, 194859], "mapped", [29605]], [[194860, 194861], "mapped", [16056]], [[194862, 194862], "mapped", [29767]], [[194863, 194863], "mapped", [29788]], [[194864, 194864], "mapped", [29809]], [[194865, 194865], "mapped", [29829]], [[194866, 194866], "mapped", [29898]], [[194867, 194867], "mapped", [16155]], [[194868, 194868], "mapped", [29988]], [[194869, 194869], "mapped", [150582]], [[194870, 194870], "mapped", [30014]], [[194871, 194871], "mapped", [150674]], [[194872, 194872], "mapped", [30064]], [[194873, 194873], "mapped", [139679]], [[194874, 194874], "mapped", [30224]], [[194875, 194875], "mapped", [151457]], [[194876, 194876], "mapped", [151480]], [[194877, 194877], "mapped", [151620]], [[194878, 194878], "mapped", [16380]], [[194879, 194879], "mapped", [16392]], [[194880, 194880], "mapped", [30452]], [[194881, 194881], "mapped", [151795]], [[194882, 194882], "mapped", [151794]], [[194883, 194883], "mapped", [151833]], [[194884, 194884], "mapped", [151859]], [[194885, 194885], "mapped", [30494]], [[194886, 194887], "mapped", [30495]], [[194888, 194888], "mapped", [30538]], [[194889, 194889], "mapped", [16441]], [[194890, 194890], "mapped", [30603]], [[194891, 194891], "mapped", [16454]], [[194892, 194892], "mapped", [16534]], [[194893, 194893], "mapped", [152605]], [[194894, 194894], "mapped", [30798]], [[194895, 194895], "mapped", [30860]], [[194896, 194896], "mapped", [30924]], [[194897, 194897], "mapped", [16611]], [[194898, 194898], "mapped", [153126]], [[194899, 194899], "mapped", [31062]], [[194900, 194900], "mapped", [153242]], [[194901, 194901], "mapped", [153285]], [[194902, 194902], "mapped", [31119]], [[194903, 194903], "mapped", [31211]], [[194904, 194904], "mapped", [16687]], [[194905, 194905], "mapped", [31296]], [[194906, 194906], "mapped", [31306]], [[194907, 194907], "mapped", [31311]], [[194908, 194908], "mapped", [153980]], [[194909, 194910], "mapped", [154279]], [[194911, 194911], "disallowed"], [[194912, 194912], "mapped", [16898]], [[194913, 194913], "mapped", [154539]], [[194914, 194914], "mapped", [31686]], [[194915, 194915], "mapped", [31689]], [[194916, 194916], "mapped", [16935]], [[194917, 194917], "mapped", [154752]], [[194918, 194918], "mapped", [31954]], [[194919, 194919], "mapped", [17056]], [[194920, 194920], "mapped", [31976]], [[194921, 194921], "mapped", [31971]], [[194922, 194922], "mapped", [32e3]], [[194923, 194923], "mapped", [155526]], [[194924, 194924], "mapped", [32099]], [[194925, 194925], "mapped", [17153]], [[194926, 194926], "mapped", [32199]], [[194927, 194927], "mapped", [32258]], [[194928, 194928], "mapped", [32325]], [[194929, 194929], "mapped", [17204]], [[194930, 194930], "mapped", [156200]], [[194931, 194931], "mapped", [156231]], [[194932, 194932], "mapped", [17241]], [[194933, 194933], "mapped", [156377]], [[194934, 194934], "mapped", [32634]], [[194935, 194935], "mapped", [156478]], [[194936, 194936], "mapped", [32661]], [[194937, 194937], "mapped", [32762]], [[194938, 194938], "mapped", [32773]], [[194939, 194939], "mapped", [156890]], [[194940, 194940], "mapped", [156963]], [[194941, 194941], "mapped", [32864]], [[194942, 194942], "mapped", [157096]], [[194943, 194943], "mapped", [32880]], [[194944, 194944], "mapped", [144223]], [[194945, 194945], "mapped", [17365]], [[194946, 194946], "mapped", [32946]], [[194947, 194947], "mapped", [33027]], [[194948, 194948], "mapped", [17419]], [[194949, 194949], "mapped", [33086]], [[194950, 194950], "mapped", [23221]], [[194951, 194951], "mapped", [157607]], [[194952, 194952], "mapped", [157621]], [[194953, 194953], "mapped", [144275]], [[194954, 194954], "mapped", [144284]], [[194955, 194955], "mapped", [33281]], [[194956, 194956], "mapped", [33284]], [[194957, 194957], "mapped", [36766]], [[194958, 194958], "mapped", [17515]], [[194959, 194959], "mapped", [33425]], [[194960, 194960], "mapped", [33419]], [[194961, 194961], "mapped", [33437]], [[194962, 194962], "mapped", [21171]], [[194963, 194963], "mapped", [33457]], [[194964, 194964], "mapped", [33459]], [[194965, 194965], "mapped", [33469]], [[194966, 194966], "mapped", [33510]], [[194967, 194967], "mapped", [158524]], [[194968, 194968], "mapped", [33509]], [[194969, 194969], "mapped", [33565]], [[194970, 194970], "mapped", [33635]], [[194971, 194971], "mapped", [33709]], [[194972, 194972], "mapped", [33571]], [[194973, 194973], "mapped", [33725]], [[194974, 194974], "mapped", [33767]], [[194975, 194975], "mapped", [33879]], [[194976, 194976], "mapped", [33619]], [[194977, 194977], "mapped", [33738]], [[194978, 194978], "mapped", [33740]], [[194979, 194979], "mapped", [33756]], [[194980, 194980], "mapped", [158774]], [[194981, 194981], "mapped", [159083]], [[194982, 194982], "mapped", [158933]], [[194983, 194983], "mapped", [17707]], [[194984, 194984], "mapped", [34033]], [[194985, 194985], "mapped", [34035]], [[194986, 194986], "mapped", [34070]], [[194987, 194987], "mapped", [160714]], [[194988, 194988], "mapped", [34148]], [[194989, 194989], "mapped", [159532]], [[194990, 194990], "mapped", [17757]], [[194991, 194991], "mapped", [17761]], [[194992, 194992], "mapped", [159665]], [[194993, 194993], "mapped", [159954]], [[194994, 194994], "mapped", [17771]], [[194995, 194995], "mapped", [34384]], [[194996, 194996], "mapped", [34396]], [[194997, 194997], "mapped", [34407]], [[194998, 194998], "mapped", [34409]], [[194999, 194999], "mapped", [34473]], [[195e3, 195e3], "mapped", [34440]], [[195001, 195001], "mapped", [34574]], [[195002, 195002], "mapped", [34530]], [[195003, 195003], "mapped", [34681]], [[195004, 195004], "mapped", [34600]], [[195005, 195005], "mapped", [34667]], [[195006, 195006], "mapped", [34694]], [[195007, 195007], "disallowed"], [[195008, 195008], "mapped", [34785]], [[195009, 195009], "mapped", [34817]], [[195010, 195010], "mapped", [17913]], [[195011, 195011], "mapped", [34912]], [[195012, 195012], "mapped", [34915]], [[195013, 195013], "mapped", [161383]], [[195014, 195014], "mapped", [35031]], [[195015, 195015], "mapped", [35038]], [[195016, 195016], "mapped", [17973]], [[195017, 195017], "mapped", [35066]], [[195018, 195018], "mapped", [13499]], [[195019, 195019], "mapped", [161966]], [[195020, 195020], "mapped", [162150]], [[195021, 195021], "mapped", [18110]], [[195022, 195022], "mapped", [18119]], [[195023, 195023], "mapped", [35488]], [[195024, 195024], "mapped", [35565]], [[195025, 195025], "mapped", [35722]], [[195026, 195026], "mapped", [35925]], [[195027, 195027], "mapped", [162984]], [[195028, 195028], "mapped", [36011]], [[195029, 195029], "mapped", [36033]], [[195030, 195030], "mapped", [36123]], [[195031, 195031], "mapped", [36215]], [[195032, 195032], "mapped", [163631]], [[195033, 195033], "mapped", [133124]], [[195034, 195034], "mapped", [36299]], [[195035, 195035], "mapped", [36284]], [[195036, 195036], "mapped", [36336]], [[195037, 195037], "mapped", [133342]], [[195038, 195038], "mapped", [36564]], [[195039, 195039], "mapped", [36664]], [[195040, 195040], "mapped", [165330]], [[195041, 195041], "mapped", [165357]], [[195042, 195042], "mapped", [37012]], [[195043, 195043], "mapped", [37105]], [[195044, 195044], "mapped", [37137]], [[195045, 195045], "mapped", [165678]], [[195046, 195046], "mapped", [37147]], [[195047, 195047], "mapped", [37432]], [[195048, 195048], "mapped", [37591]], [[195049, 195049], "mapped", [37592]], [[195050, 195050], "mapped", [37500]], [[195051, 195051], "mapped", [37881]], [[195052, 195052], "mapped", [37909]], [[195053, 195053], "mapped", [166906]], [[195054, 195054], "mapped", [38283]], [[195055, 195055], "mapped", [18837]], [[195056, 195056], "mapped", [38327]], [[195057, 195057], "mapped", [167287]], [[195058, 195058], "mapped", [18918]], [[195059, 195059], "mapped", [38595]], [[195060, 195060], "mapped", [23986]], [[195061, 195061], "mapped", [38691]], [[195062, 195062], "mapped", [168261]], [[195063, 195063], "mapped", [168474]], [[195064, 195064], "mapped", [19054]], [[195065, 195065], "mapped", [19062]], [[195066, 195066], "mapped", [38880]], [[195067, 195067], "mapped", [168970]], [[195068, 195068], "mapped", [19122]], [[195069, 195069], "mapped", [169110]], [[195070, 195071], "mapped", [38923]], [[195072, 195072], "mapped", [38953]], [[195073, 195073], "mapped", [169398]], [[195074, 195074], "mapped", [39138]], [[195075, 195075], "mapped", [19251]], [[195076, 195076], "mapped", [39209]], [[195077, 195077], "mapped", [39335]], [[195078, 195078], "mapped", [39362]], [[195079, 195079], "mapped", [39422]], [[195080, 195080], "mapped", [19406]], [[195081, 195081], "mapped", [170800]], [[195082, 195082], "mapped", [39698]], [[195083, 195083], "mapped", [4e4]], [[195084, 195084], "mapped", [40189]], [[195085, 195085], "mapped", [19662]], [[195086, 195086], "mapped", [19693]], [[195087, 195087], "mapped", [40295]], [[195088, 195088], "mapped", [172238]], [[195089, 195089], "mapped", [19704]], [[195090, 195090], "mapped", [172293]], [[195091, 195091], "mapped", [172558]], [[195092, 195092], "mapped", [172689]], [[195093, 195093], "mapped", [40635]], [[195094, 195094], "mapped", [19798]], [[195095, 195095], "mapped", [40697]], [[195096, 195096], "mapped", [40702]], [[195097, 195097], "mapped", [40709]], [[195098, 195098], "mapped", [40719]], [[195099, 195099], "mapped", [40726]], [[195100, 195100], "mapped", [40763]], [[195101, 195101], "mapped", [173568]], [[195102, 196605], "disallowed"], [[196606, 196607], "disallowed"], [[196608, 262141], "disallowed"], [[262142, 262143], "disallowed"], [[262144, 327677], "disallowed"], [[327678, 327679], "disallowed"], [[327680, 393213], "disallowed"], [[393214, 393215], "disallowed"], [[393216, 458749], "disallowed"], [[458750, 458751], "disallowed"], [[458752, 524285], "disallowed"], [[524286, 524287], "disallowed"], [[524288, 589821], "disallowed"], [[589822, 589823], "disallowed"], [[589824, 655357], "disallowed"], [[655358, 655359], "disallowed"], [[655360, 720893], "disallowed"], [[720894, 720895], "disallowed"], [[720896, 786429], "disallowed"], [[786430, 786431], "disallowed"], [[786432, 851965], "disallowed"], [[851966, 851967], "disallowed"], [[851968, 917501], "disallowed"], [[917502, 917503], "disallowed"], [[917504, 917504], "disallowed"], [[917505, 917505], "disallowed"], [[917506, 917535], "disallowed"], [[917536, 917631], "disallowed"], [[917632, 917759], "disallowed"], [[917760, 917999], "ignored"], [[918e3, 983037], "disallowed"], [[983038, 983039], "disallowed"], [[983040, 1048573], "disallowed"], [[1048574, 1048575], "disallowed"], [[1048576, 1114109], "disallowed"], [[1114110, 1114111], "disallowed"]];
  }
});

// ../../../node_modules/.pnpm/tr46@0.0.3/node_modules/tr46/index.js
var require_tr46 = __commonJS({
  "../../../node_modules/.pnpm/tr46@0.0.3/node_modules/tr46/index.js"(exports2, module2) {
    "use strict";
    var punycode = require("punycode");
    var mappingTable = require_mappingTable();
    var PROCESSING_OPTIONS = {
      TRANSITIONAL: 0,
      NONTRANSITIONAL: 1
    };
    function normalize2(str2) {
      return str2.split("\0").map(function(s) {
        return s.normalize("NFC");
      }).join("\0");
    }
    function findStatus(val) {
      var start = 0;
      var end = mappingTable.length - 1;
      while (start <= end) {
        var mid = Math.floor((start + end) / 2);
        var target = mappingTable[mid];
        if (target[0][0] <= val && target[0][1] >= val) {
          return target;
        } else if (target[0][0] > val) {
          end = mid - 1;
        } else {
          start = mid + 1;
        }
      }
      return null;
    }
    var regexAstralSymbols = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g;
    function countSymbols(string3) {
      return string3.replace(regexAstralSymbols, "_").length;
    }
    function mapChars(domain_name, useSTD3, processing_option) {
      var hasError = false;
      var processed = "";
      var len = countSymbols(domain_name);
      for (var i = 0; i < len; ++i) {
        var codePoint = domain_name.codePointAt(i);
        var status = findStatus(codePoint);
        switch (status[1]) {
          case "disallowed":
            hasError = true;
            processed += String.fromCodePoint(codePoint);
            break;
          case "ignored":
            break;
          case "mapped":
            processed += String.fromCodePoint.apply(String, status[2]);
            break;
          case "deviation":
            if (processing_option === PROCESSING_OPTIONS.TRANSITIONAL) {
              processed += String.fromCodePoint.apply(String, status[2]);
            } else {
              processed += String.fromCodePoint(codePoint);
            }
            break;
          case "valid":
            processed += String.fromCodePoint(codePoint);
            break;
          case "disallowed_STD3_mapped":
            if (useSTD3) {
              hasError = true;
              processed += String.fromCodePoint(codePoint);
            } else {
              processed += String.fromCodePoint.apply(String, status[2]);
            }
            break;
          case "disallowed_STD3_valid":
            if (useSTD3) {
              hasError = true;
            }
            processed += String.fromCodePoint(codePoint);
            break;
        }
      }
      return {
        string: processed,
        error: hasError
      };
    }
    var combiningMarksRegex = /[\u0300-\u036F\u0483-\u0489\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u065F\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u0711\u0730-\u074A\u07A6-\u07B0\u07EB-\u07F3\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u08E4-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A70\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B62\u0B63\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0C00-\u0C03\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0D01-\u0D03\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D82\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0EB1\u0EB4-\u0EB9\u0EBB\u0EBC\u0EC8-\u0ECD\u0F18\u0F19\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F\u109A-\u109D\u135D-\u135F\u1712-\u1714\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u180B-\u180D\u18A9\u1920-\u192B\u1930-\u193B\u19B0-\u19C0\u19C8\u19C9\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F\u1AB0-\u1ABE\u1B00-\u1B04\u1B34-\u1B44\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BE6-\u1BF3\u1C24-\u1C37\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF2-\u1CF4\u1CF8\u1CF9\u1DC0-\u1DF5\u1DFC-\u1DFF\u20D0-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA66F-\uA672\uA674-\uA67D\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA880\uA881\uA8B4-\uA8C4\uA8E0-\uA8F1\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9E5\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uFB1E\uFE00-\uFE0F\uFE20-\uFE2D]|\uD800[\uDDFD\uDEE0\uDF76-\uDF7A]|\uD802[\uDE01-\uDE03\uDE05\uDE06\uDE0C-\uDE0F\uDE38-\uDE3A\uDE3F\uDEE5\uDEE6]|\uD804[\uDC00-\uDC02\uDC38-\uDC46\uDC7F-\uDC82\uDCB0-\uDCBA\uDD00-\uDD02\uDD27-\uDD34\uDD73\uDD80-\uDD82\uDDB3-\uDDC0\uDE2C-\uDE37\uDEDF-\uDEEA\uDF01-\uDF03\uDF3C\uDF3E-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF57\uDF62\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDCB0-\uDCC3\uDDAF-\uDDB5\uDDB8-\uDDC0\uDE30-\uDE40\uDEAB-\uDEB7]|\uD81A[\uDEF0-\uDEF4\uDF30-\uDF36]|\uD81B[\uDF51-\uDF7E\uDF8F-\uDF92]|\uD82F[\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD83A[\uDCD0-\uDCD6]|\uDB40[\uDD00-\uDDEF]/;
    function validateLabel(label, processing_option) {
      if (label.substr(0, 4) === "xn--") {
        label = punycode.toUnicode(label);
        processing_option = PROCESSING_OPTIONS.NONTRANSITIONAL;
      }
      var error = false;
      if (normalize2(label) !== label || label[3] === "-" && label[4] === "-" || label[0] === "-" || label[label.length - 1] === "-" || label.indexOf(".") !== -1 || label.search(combiningMarksRegex) === 0) {
        error = true;
      }
      var len = countSymbols(label);
      for (var i = 0; i < len; ++i) {
        var status = findStatus(label.codePointAt(i));
        if (processing === PROCESSING_OPTIONS.TRANSITIONAL && status[1] !== "valid" || processing === PROCESSING_OPTIONS.NONTRANSITIONAL && status[1] !== "valid" && status[1] !== "deviation") {
          error = true;
          break;
        }
      }
      return {
        label,
        error
      };
    }
    function processing(domain_name, useSTD3, processing_option) {
      var result = mapChars(domain_name, useSTD3, processing_option);
      result.string = normalize2(result.string);
      var labels = result.string.split(".");
      for (var i = 0; i < labels.length; ++i) {
        try {
          var validation = validateLabel(labels[i]);
          labels[i] = validation.label;
          result.error = result.error || validation.error;
        } catch (e) {
          result.error = true;
        }
      }
      return {
        string: labels.join("."),
        error: result.error
      };
    }
    module2.exports.toASCII = function(domain_name, useSTD3, processing_option, verifyDnsLength) {
      var result = processing(domain_name, useSTD3, processing_option);
      var labels = result.string.split(".");
      labels = labels.map(function(l) {
        try {
          return punycode.toASCII(l);
        } catch (e) {
          result.error = true;
          return l;
        }
      });
      if (verifyDnsLength) {
        var total = labels.slice(0, labels.length - 1).join(".").length;
        if (total.length > 253 || total.length === 0) {
          result.error = true;
        }
        for (var i = 0; i < labels.length; ++i) {
          if (labels.length > 63 || labels.length === 0) {
            result.error = true;
            break;
          }
        }
      }
      if (result.error) return null;
      return labels.join(".");
    };
    module2.exports.toUnicode = function(domain_name, useSTD3) {
      var result = processing(domain_name, useSTD3, PROCESSING_OPTIONS.NONTRANSITIONAL);
      return {
        domain: result.string,
        error: result.error
      };
    };
    module2.exports.PROCESSING_OPTIONS = PROCESSING_OPTIONS;
  }
});

// ../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/url-state-machine.js
var require_url_state_machine = __commonJS({
  "../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/url-state-machine.js"(exports2, module2) {
    "use strict";
    var punycode = require("punycode");
    var tr46 = require_tr46();
    var specialSchemes = {
      ftp: 21,
      file: null,
      gopher: 70,
      http: 80,
      https: 443,
      ws: 80,
      wss: 443
    };
    var failure = Symbol("failure");
    function countSymbols(str2) {
      return punycode.ucs2.decode(str2).length;
    }
    function at(input, idx) {
      const c = input[idx];
      return isNaN(c) ? void 0 : String.fromCodePoint(c);
    }
    function isASCIIDigit(c) {
      return c >= 48 && c <= 57;
    }
    function isASCIIAlpha(c) {
      return c >= 65 && c <= 90 || c >= 97 && c <= 122;
    }
    function isASCIIAlphanumeric(c) {
      return isASCIIAlpha(c) || isASCIIDigit(c);
    }
    function isASCIIHex(c) {
      return isASCIIDigit(c) || c >= 65 && c <= 70 || c >= 97 && c <= 102;
    }
    function isSingleDot(buffer) {
      return buffer === "." || buffer.toLowerCase() === "%2e";
    }
    function isDoubleDot(buffer) {
      buffer = buffer.toLowerCase();
      return buffer === ".." || buffer === "%2e." || buffer === ".%2e" || buffer === "%2e%2e";
    }
    function isWindowsDriveLetterCodePoints(cp1, cp2) {
      return isASCIIAlpha(cp1) && (cp2 === 58 || cp2 === 124);
    }
    function isWindowsDriveLetterString(string3) {
      return string3.length === 2 && isASCIIAlpha(string3.codePointAt(0)) && (string3[1] === ":" || string3[1] === "|");
    }
    function isNormalizedWindowsDriveLetterString(string3) {
      return string3.length === 2 && isASCIIAlpha(string3.codePointAt(0)) && string3[1] === ":";
    }
    function containsForbiddenHostCodePoint(string3) {
      return string3.search(/\u0000|\u0009|\u000A|\u000D|\u0020|#|%|\/|:|\?|@|\[|\\|\]/) !== -1;
    }
    function containsForbiddenHostCodePointExcludingPercent(string3) {
      return string3.search(/\u0000|\u0009|\u000A|\u000D|\u0020|#|\/|:|\?|@|\[|\\|\]/) !== -1;
    }
    function isSpecialScheme(scheme) {
      return specialSchemes[scheme] !== void 0;
    }
    function isSpecial(url) {
      return isSpecialScheme(url.scheme);
    }
    function defaultPort(scheme) {
      return specialSchemes[scheme];
    }
    function percentEncode(c) {
      let hex = c.toString(16).toUpperCase();
      if (hex.length === 1) {
        hex = "0" + hex;
      }
      return "%" + hex;
    }
    function utf8PercentEncode(c) {
      const buf = new Buffer(c);
      let str2 = "";
      for (let i = 0; i < buf.length; ++i) {
        str2 += percentEncode(buf[i]);
      }
      return str2;
    }
    function utf8PercentDecode(str2) {
      const input = new Buffer(str2);
      const output = [];
      for (let i = 0; i < input.length; ++i) {
        if (input[i] !== 37) {
          output.push(input[i]);
        } else if (input[i] === 37 && isASCIIHex(input[i + 1]) && isASCIIHex(input[i + 2])) {
          output.push(parseInt(input.slice(i + 1, i + 3).toString(), 16));
          i += 2;
        } else {
          output.push(input[i]);
        }
      }
      return new Buffer(output).toString();
    }
    function isC0ControlPercentEncode(c) {
      return c <= 31 || c > 126;
    }
    var extraPathPercentEncodeSet = /* @__PURE__ */ new Set([32, 34, 35, 60, 62, 63, 96, 123, 125]);
    function isPathPercentEncode(c) {
      return isC0ControlPercentEncode(c) || extraPathPercentEncodeSet.has(c);
    }
    var extraUserinfoPercentEncodeSet = /* @__PURE__ */ new Set([47, 58, 59, 61, 64, 91, 92, 93, 94, 124]);
    function isUserinfoPercentEncode(c) {
      return isPathPercentEncode(c) || extraUserinfoPercentEncodeSet.has(c);
    }
    function percentEncodeChar(c, encodeSetPredicate) {
      const cStr = String.fromCodePoint(c);
      if (encodeSetPredicate(c)) {
        return utf8PercentEncode(cStr);
      }
      return cStr;
    }
    function parseIPv4Number(input) {
      let R = 10;
      if (input.length >= 2 && input.charAt(0) === "0" && input.charAt(1).toLowerCase() === "x") {
        input = input.substring(2);
        R = 16;
      } else if (input.length >= 2 && input.charAt(0) === "0") {
        input = input.substring(1);
        R = 8;
      }
      if (input === "") {
        return 0;
      }
      const regex = R === 10 ? /[^0-9]/ : R === 16 ? /[^0-9A-Fa-f]/ : /[^0-7]/;
      if (regex.test(input)) {
        return failure;
      }
      return parseInt(input, R);
    }
    function parseIPv4(input) {
      const parts = input.split(".");
      if (parts[parts.length - 1] === "") {
        if (parts.length > 1) {
          parts.pop();
        }
      }
      if (parts.length > 4) {
        return input;
      }
      const numbers = [];
      for (const part of parts) {
        if (part === "") {
          return input;
        }
        const n = parseIPv4Number(part);
        if (n === failure) {
          return input;
        }
        numbers.push(n);
      }
      for (let i = 0; i < numbers.length - 1; ++i) {
        if (numbers[i] > 255) {
          return failure;
        }
      }
      if (numbers[numbers.length - 1] >= Math.pow(256, 5 - numbers.length)) {
        return failure;
      }
      let ipv4 = numbers.pop();
      let counter = 0;
      for (const n of numbers) {
        ipv4 += n * Math.pow(256, 3 - counter);
        ++counter;
      }
      return ipv4;
    }
    function serializeIPv4(address) {
      let output = "";
      let n = address;
      for (let i = 1; i <= 4; ++i) {
        output = String(n % 256) + output;
        if (i !== 4) {
          output = "." + output;
        }
        n = Math.floor(n / 256);
      }
      return output;
    }
    function parseIPv6(input) {
      const address = [0, 0, 0, 0, 0, 0, 0, 0];
      let pieceIndex = 0;
      let compress = null;
      let pointer = 0;
      input = punycode.ucs2.decode(input);
      if (input[pointer] === 58) {
        if (input[pointer + 1] !== 58) {
          return failure;
        }
        pointer += 2;
        ++pieceIndex;
        compress = pieceIndex;
      }
      while (pointer < input.length) {
        if (pieceIndex === 8) {
          return failure;
        }
        if (input[pointer] === 58) {
          if (compress !== null) {
            return failure;
          }
          ++pointer;
          ++pieceIndex;
          compress = pieceIndex;
          continue;
        }
        let value = 0;
        let length = 0;
        while (length < 4 && isASCIIHex(input[pointer])) {
          value = value * 16 + parseInt(at(input, pointer), 16);
          ++pointer;
          ++length;
        }
        if (input[pointer] === 46) {
          if (length === 0) {
            return failure;
          }
          pointer -= length;
          if (pieceIndex > 6) {
            return failure;
          }
          let numbersSeen = 0;
          while (input[pointer] !== void 0) {
            let ipv4Piece = null;
            if (numbersSeen > 0) {
              if (input[pointer] === 46 && numbersSeen < 4) {
                ++pointer;
              } else {
                return failure;
              }
            }
            if (!isASCIIDigit(input[pointer])) {
              return failure;
            }
            while (isASCIIDigit(input[pointer])) {
              const number3 = parseInt(at(input, pointer));
              if (ipv4Piece === null) {
                ipv4Piece = number3;
              } else if (ipv4Piece === 0) {
                return failure;
              } else {
                ipv4Piece = ipv4Piece * 10 + number3;
              }
              if (ipv4Piece > 255) {
                return failure;
              }
              ++pointer;
            }
            address[pieceIndex] = address[pieceIndex] * 256 + ipv4Piece;
            ++numbersSeen;
            if (numbersSeen === 2 || numbersSeen === 4) {
              ++pieceIndex;
            }
          }
          if (numbersSeen !== 4) {
            return failure;
          }
          break;
        } else if (input[pointer] === 58) {
          ++pointer;
          if (input[pointer] === void 0) {
            return failure;
          }
        } else if (input[pointer] !== void 0) {
          return failure;
        }
        address[pieceIndex] = value;
        ++pieceIndex;
      }
      if (compress !== null) {
        let swaps = pieceIndex - compress;
        pieceIndex = 7;
        while (pieceIndex !== 0 && swaps > 0) {
          const temp = address[compress + swaps - 1];
          address[compress + swaps - 1] = address[pieceIndex];
          address[pieceIndex] = temp;
          --pieceIndex;
          --swaps;
        }
      } else if (compress === null && pieceIndex !== 8) {
        return failure;
      }
      return address;
    }
    function serializeIPv6(address) {
      let output = "";
      const seqResult = findLongestZeroSequence(address);
      const compress = seqResult.idx;
      let ignore0 = false;
      for (let pieceIndex = 0; pieceIndex <= 7; ++pieceIndex) {
        if (ignore0 && address[pieceIndex] === 0) {
          continue;
        } else if (ignore0) {
          ignore0 = false;
        }
        if (compress === pieceIndex) {
          const separator = pieceIndex === 0 ? "::" : ":";
          output += separator;
          ignore0 = true;
          continue;
        }
        output += address[pieceIndex].toString(16);
        if (pieceIndex !== 7) {
          output += ":";
        }
      }
      return output;
    }
    function parseHost(input, isSpecialArg) {
      if (input[0] === "[") {
        if (input[input.length - 1] !== "]") {
          return failure;
        }
        return parseIPv6(input.substring(1, input.length - 1));
      }
      if (!isSpecialArg) {
        return parseOpaqueHost(input);
      }
      const domain = utf8PercentDecode(input);
      const asciiDomain = tr46.toASCII(domain, false, tr46.PROCESSING_OPTIONS.NONTRANSITIONAL, false);
      if (asciiDomain === null) {
        return failure;
      }
      if (containsForbiddenHostCodePoint(asciiDomain)) {
        return failure;
      }
      const ipv4Host = parseIPv4(asciiDomain);
      if (typeof ipv4Host === "number" || ipv4Host === failure) {
        return ipv4Host;
      }
      return asciiDomain;
    }
    function parseOpaqueHost(input) {
      if (containsForbiddenHostCodePointExcludingPercent(input)) {
        return failure;
      }
      let output = "";
      const decoded = punycode.ucs2.decode(input);
      for (let i = 0; i < decoded.length; ++i) {
        output += percentEncodeChar(decoded[i], isC0ControlPercentEncode);
      }
      return output;
    }
    function findLongestZeroSequence(arr) {
      let maxIdx = null;
      let maxLen = 1;
      let currStart = null;
      let currLen = 0;
      for (let i = 0; i < arr.length; ++i) {
        if (arr[i] !== 0) {
          if (currLen > maxLen) {
            maxIdx = currStart;
            maxLen = currLen;
          }
          currStart = null;
          currLen = 0;
        } else {
          if (currStart === null) {
            currStart = i;
          }
          ++currLen;
        }
      }
      if (currLen > maxLen) {
        maxIdx = currStart;
        maxLen = currLen;
      }
      return {
        idx: maxIdx,
        len: maxLen
      };
    }
    function serializeHost(host) {
      if (typeof host === "number") {
        return serializeIPv4(host);
      }
      if (host instanceof Array) {
        return "[" + serializeIPv6(host) + "]";
      }
      return host;
    }
    function trimControlChars(url) {
      return url.replace(/^[\u0000-\u001F\u0020]+|[\u0000-\u001F\u0020]+$/g, "");
    }
    function trimTabAndNewline(url) {
      return url.replace(/\u0009|\u000A|\u000D/g, "");
    }
    function shortenPath(url) {
      const path5 = url.path;
      if (path5.length === 0) {
        return;
      }
      if (url.scheme === "file" && path5.length === 1 && isNormalizedWindowsDriveLetter(path5[0])) {
        return;
      }
      path5.pop();
    }
    function includesCredentials(url) {
      return url.username !== "" || url.password !== "";
    }
    function cannotHaveAUsernamePasswordPort(url) {
      return url.host === null || url.host === "" || url.cannotBeABaseURL || url.scheme === "file";
    }
    function isNormalizedWindowsDriveLetter(string3) {
      return /^[A-Za-z]:$/.test(string3);
    }
    function URLStateMachine(input, base, encodingOverride, url, stateOverride) {
      this.pointer = 0;
      this.input = input;
      this.base = base || null;
      this.encodingOverride = encodingOverride || "utf-8";
      this.stateOverride = stateOverride;
      this.url = url;
      this.failure = false;
      this.parseError = false;
      if (!this.url) {
        this.url = {
          scheme: "",
          username: "",
          password: "",
          host: null,
          port: null,
          path: [],
          query: null,
          fragment: null,
          cannotBeABaseURL: false
        };
        const res2 = trimControlChars(this.input);
        if (res2 !== this.input) {
          this.parseError = true;
        }
        this.input = res2;
      }
      const res = trimTabAndNewline(this.input);
      if (res !== this.input) {
        this.parseError = true;
      }
      this.input = res;
      this.state = stateOverride || "scheme start";
      this.buffer = "";
      this.atFlag = false;
      this.arrFlag = false;
      this.passwordTokenSeenFlag = false;
      this.input = punycode.ucs2.decode(this.input);
      for (; this.pointer <= this.input.length; ++this.pointer) {
        const c = this.input[this.pointer];
        const cStr = isNaN(c) ? void 0 : String.fromCodePoint(c);
        const ret = this["parse " + this.state](c, cStr);
        if (!ret) {
          break;
        } else if (ret === failure) {
          this.failure = true;
          break;
        }
      }
    }
    URLStateMachine.prototype["parse scheme start"] = function parseSchemeStart(c, cStr) {
      if (isASCIIAlpha(c)) {
        this.buffer += cStr.toLowerCase();
        this.state = "scheme";
      } else if (!this.stateOverride) {
        this.state = "no scheme";
        --this.pointer;
      } else {
        this.parseError = true;
        return failure;
      }
      return true;
    };
    URLStateMachine.prototype["parse scheme"] = function parseScheme(c, cStr) {
      if (isASCIIAlphanumeric(c) || c === 43 || c === 45 || c === 46) {
        this.buffer += cStr.toLowerCase();
      } else if (c === 58) {
        if (this.stateOverride) {
          if (isSpecial(this.url) && !isSpecialScheme(this.buffer)) {
            return false;
          }
          if (!isSpecial(this.url) && isSpecialScheme(this.buffer)) {
            return false;
          }
          if ((includesCredentials(this.url) || this.url.port !== null) && this.buffer === "file") {
            return false;
          }
          if (this.url.scheme === "file" && (this.url.host === "" || this.url.host === null)) {
            return false;
          }
        }
        this.url.scheme = this.buffer;
        this.buffer = "";
        if (this.stateOverride) {
          return false;
        }
        if (this.url.scheme === "file") {
          if (this.input[this.pointer + 1] !== 47 || this.input[this.pointer + 2] !== 47) {
            this.parseError = true;
          }
          this.state = "file";
        } else if (isSpecial(this.url) && this.base !== null && this.base.scheme === this.url.scheme) {
          this.state = "special relative or authority";
        } else if (isSpecial(this.url)) {
          this.state = "special authority slashes";
        } else if (this.input[this.pointer + 1] === 47) {
          this.state = "path or authority";
          ++this.pointer;
        } else {
          this.url.cannotBeABaseURL = true;
          this.url.path.push("");
          this.state = "cannot-be-a-base-URL path";
        }
      } else if (!this.stateOverride) {
        this.buffer = "";
        this.state = "no scheme";
        this.pointer = -1;
      } else {
        this.parseError = true;
        return failure;
      }
      return true;
    };
    URLStateMachine.prototype["parse no scheme"] = function parseNoScheme(c) {
      if (this.base === null || this.base.cannotBeABaseURL && c !== 35) {
        return failure;
      } else if (this.base.cannotBeABaseURL && c === 35) {
        this.url.scheme = this.base.scheme;
        this.url.path = this.base.path.slice();
        this.url.query = this.base.query;
        this.url.fragment = "";
        this.url.cannotBeABaseURL = true;
        this.state = "fragment";
      } else if (this.base.scheme === "file") {
        this.state = "file";
        --this.pointer;
      } else {
        this.state = "relative";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse special relative or authority"] = function parseSpecialRelativeOrAuthority(c) {
      if (c === 47 && this.input[this.pointer + 1] === 47) {
        this.state = "special authority ignore slashes";
        ++this.pointer;
      } else {
        this.parseError = true;
        this.state = "relative";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse path or authority"] = function parsePathOrAuthority(c) {
      if (c === 47) {
        this.state = "authority";
      } else {
        this.state = "path";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse relative"] = function parseRelative(c) {
      this.url.scheme = this.base.scheme;
      if (isNaN(c)) {
        this.url.username = this.base.username;
        this.url.password = this.base.password;
        this.url.host = this.base.host;
        this.url.port = this.base.port;
        this.url.path = this.base.path.slice();
        this.url.query = this.base.query;
      } else if (c === 47) {
        this.state = "relative slash";
      } else if (c === 63) {
        this.url.username = this.base.username;
        this.url.password = this.base.password;
        this.url.host = this.base.host;
        this.url.port = this.base.port;
        this.url.path = this.base.path.slice();
        this.url.query = "";
        this.state = "query";
      } else if (c === 35) {
        this.url.username = this.base.username;
        this.url.password = this.base.password;
        this.url.host = this.base.host;
        this.url.port = this.base.port;
        this.url.path = this.base.path.slice();
        this.url.query = this.base.query;
        this.url.fragment = "";
        this.state = "fragment";
      } else if (isSpecial(this.url) && c === 92) {
        this.parseError = true;
        this.state = "relative slash";
      } else {
        this.url.username = this.base.username;
        this.url.password = this.base.password;
        this.url.host = this.base.host;
        this.url.port = this.base.port;
        this.url.path = this.base.path.slice(0, this.base.path.length - 1);
        this.state = "path";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse relative slash"] = function parseRelativeSlash(c) {
      if (isSpecial(this.url) && (c === 47 || c === 92)) {
        if (c === 92) {
          this.parseError = true;
        }
        this.state = "special authority ignore slashes";
      } else if (c === 47) {
        this.state = "authority";
      } else {
        this.url.username = this.base.username;
        this.url.password = this.base.password;
        this.url.host = this.base.host;
        this.url.port = this.base.port;
        this.state = "path";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse special authority slashes"] = function parseSpecialAuthoritySlashes(c) {
      if (c === 47 && this.input[this.pointer + 1] === 47) {
        this.state = "special authority ignore slashes";
        ++this.pointer;
      } else {
        this.parseError = true;
        this.state = "special authority ignore slashes";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse special authority ignore slashes"] = function parseSpecialAuthorityIgnoreSlashes(c) {
      if (c !== 47 && c !== 92) {
        this.state = "authority";
        --this.pointer;
      } else {
        this.parseError = true;
      }
      return true;
    };
    URLStateMachine.prototype["parse authority"] = function parseAuthority(c, cStr) {
      if (c === 64) {
        this.parseError = true;
        if (this.atFlag) {
          this.buffer = "%40" + this.buffer;
        }
        this.atFlag = true;
        const len = countSymbols(this.buffer);
        for (let pointer = 0; pointer < len; ++pointer) {
          const codePoint = this.buffer.codePointAt(pointer);
          if (codePoint === 58 && !this.passwordTokenSeenFlag) {
            this.passwordTokenSeenFlag = true;
            continue;
          }
          const encodedCodePoints = percentEncodeChar(codePoint, isUserinfoPercentEncode);
          if (this.passwordTokenSeenFlag) {
            this.url.password += encodedCodePoints;
          } else {
            this.url.username += encodedCodePoints;
          }
        }
        this.buffer = "";
      } else if (isNaN(c) || c === 47 || c === 63 || c === 35 || isSpecial(this.url) && c === 92) {
        if (this.atFlag && this.buffer === "") {
          this.parseError = true;
          return failure;
        }
        this.pointer -= countSymbols(this.buffer) + 1;
        this.buffer = "";
        this.state = "host";
      } else {
        this.buffer += cStr;
      }
      return true;
    };
    URLStateMachine.prototype["parse hostname"] = URLStateMachine.prototype["parse host"] = function parseHostName(c, cStr) {
      if (this.stateOverride && this.url.scheme === "file") {
        --this.pointer;
        this.state = "file host";
      } else if (c === 58 && !this.arrFlag) {
        if (this.buffer === "") {
          this.parseError = true;
          return failure;
        }
        const host = parseHost(this.buffer, isSpecial(this.url));
        if (host === failure) {
          return failure;
        }
        this.url.host = host;
        this.buffer = "";
        this.state = "port";
        if (this.stateOverride === "hostname") {
          return false;
        }
      } else if (isNaN(c) || c === 47 || c === 63 || c === 35 || isSpecial(this.url) && c === 92) {
        --this.pointer;
        if (isSpecial(this.url) && this.buffer === "") {
          this.parseError = true;
          return failure;
        } else if (this.stateOverride && this.buffer === "" && (includesCredentials(this.url) || this.url.port !== null)) {
          this.parseError = true;
          return false;
        }
        const host = parseHost(this.buffer, isSpecial(this.url));
        if (host === failure) {
          return failure;
        }
        this.url.host = host;
        this.buffer = "";
        this.state = "path start";
        if (this.stateOverride) {
          return false;
        }
      } else {
        if (c === 91) {
          this.arrFlag = true;
        } else if (c === 93) {
          this.arrFlag = false;
        }
        this.buffer += cStr;
      }
      return true;
    };
    URLStateMachine.prototype["parse port"] = function parsePort(c, cStr) {
      if (isASCIIDigit(c)) {
        this.buffer += cStr;
      } else if (isNaN(c) || c === 47 || c === 63 || c === 35 || isSpecial(this.url) && c === 92 || this.stateOverride) {
        if (this.buffer !== "") {
          const port = parseInt(this.buffer);
          if (port > Math.pow(2, 16) - 1) {
            this.parseError = true;
            return failure;
          }
          this.url.port = port === defaultPort(this.url.scheme) ? null : port;
          this.buffer = "";
        }
        if (this.stateOverride) {
          return false;
        }
        this.state = "path start";
        --this.pointer;
      } else {
        this.parseError = true;
        return failure;
      }
      return true;
    };
    var fileOtherwiseCodePoints = /* @__PURE__ */ new Set([47, 92, 63, 35]);
    URLStateMachine.prototype["parse file"] = function parseFile(c) {
      this.url.scheme = "file";
      if (c === 47 || c === 92) {
        if (c === 92) {
          this.parseError = true;
        }
        this.state = "file slash";
      } else if (this.base !== null && this.base.scheme === "file") {
        if (isNaN(c)) {
          this.url.host = this.base.host;
          this.url.path = this.base.path.slice();
          this.url.query = this.base.query;
        } else if (c === 63) {
          this.url.host = this.base.host;
          this.url.path = this.base.path.slice();
          this.url.query = "";
          this.state = "query";
        } else if (c === 35) {
          this.url.host = this.base.host;
          this.url.path = this.base.path.slice();
          this.url.query = this.base.query;
          this.url.fragment = "";
          this.state = "fragment";
        } else {
          if (this.input.length - this.pointer - 1 === 0 || // remaining consists of 0 code points
          !isWindowsDriveLetterCodePoints(c, this.input[this.pointer + 1]) || this.input.length - this.pointer - 1 >= 2 && // remaining has at least 2 code points
          !fileOtherwiseCodePoints.has(this.input[this.pointer + 2])) {
            this.url.host = this.base.host;
            this.url.path = this.base.path.slice();
            shortenPath(this.url);
          } else {
            this.parseError = true;
          }
          this.state = "path";
          --this.pointer;
        }
      } else {
        this.state = "path";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse file slash"] = function parseFileSlash(c) {
      if (c === 47 || c === 92) {
        if (c === 92) {
          this.parseError = true;
        }
        this.state = "file host";
      } else {
        if (this.base !== null && this.base.scheme === "file") {
          if (isNormalizedWindowsDriveLetterString(this.base.path[0])) {
            this.url.path.push(this.base.path[0]);
          } else {
            this.url.host = this.base.host;
          }
        }
        this.state = "path";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse file host"] = function parseFileHost(c, cStr) {
      if (isNaN(c) || c === 47 || c === 92 || c === 63 || c === 35) {
        --this.pointer;
        if (!this.stateOverride && isWindowsDriveLetterString(this.buffer)) {
          this.parseError = true;
          this.state = "path";
        } else if (this.buffer === "") {
          this.url.host = "";
          if (this.stateOverride) {
            return false;
          }
          this.state = "path start";
        } else {
          let host = parseHost(this.buffer, isSpecial(this.url));
          if (host === failure) {
            return failure;
          }
          if (host === "localhost") {
            host = "";
          }
          this.url.host = host;
          if (this.stateOverride) {
            return false;
          }
          this.buffer = "";
          this.state = "path start";
        }
      } else {
        this.buffer += cStr;
      }
      return true;
    };
    URLStateMachine.prototype["parse path start"] = function parsePathStart(c) {
      if (isSpecial(this.url)) {
        if (c === 92) {
          this.parseError = true;
        }
        this.state = "path";
        if (c !== 47 && c !== 92) {
          --this.pointer;
        }
      } else if (!this.stateOverride && c === 63) {
        this.url.query = "";
        this.state = "query";
      } else if (!this.stateOverride && c === 35) {
        this.url.fragment = "";
        this.state = "fragment";
      } else if (c !== void 0) {
        this.state = "path";
        if (c !== 47) {
          --this.pointer;
        }
      }
      return true;
    };
    URLStateMachine.prototype["parse path"] = function parsePath(c) {
      if (isNaN(c) || c === 47 || isSpecial(this.url) && c === 92 || !this.stateOverride && (c === 63 || c === 35)) {
        if (isSpecial(this.url) && c === 92) {
          this.parseError = true;
        }
        if (isDoubleDot(this.buffer)) {
          shortenPath(this.url);
          if (c !== 47 && !(isSpecial(this.url) && c === 92)) {
            this.url.path.push("");
          }
        } else if (isSingleDot(this.buffer) && c !== 47 && !(isSpecial(this.url) && c === 92)) {
          this.url.path.push("");
        } else if (!isSingleDot(this.buffer)) {
          if (this.url.scheme === "file" && this.url.path.length === 0 && isWindowsDriveLetterString(this.buffer)) {
            if (this.url.host !== "" && this.url.host !== null) {
              this.parseError = true;
              this.url.host = "";
            }
            this.buffer = this.buffer[0] + ":";
          }
          this.url.path.push(this.buffer);
        }
        this.buffer = "";
        if (this.url.scheme === "file" && (c === void 0 || c === 63 || c === 35)) {
          while (this.url.path.length > 1 && this.url.path[0] === "") {
            this.parseError = true;
            this.url.path.shift();
          }
        }
        if (c === 63) {
          this.url.query = "";
          this.state = "query";
        }
        if (c === 35) {
          this.url.fragment = "";
          this.state = "fragment";
        }
      } else {
        if (c === 37 && (!isASCIIHex(this.input[this.pointer + 1]) || !isASCIIHex(this.input[this.pointer + 2]))) {
          this.parseError = true;
        }
        this.buffer += percentEncodeChar(c, isPathPercentEncode);
      }
      return true;
    };
    URLStateMachine.prototype["parse cannot-be-a-base-URL path"] = function parseCannotBeABaseURLPath(c) {
      if (c === 63) {
        this.url.query = "";
        this.state = "query";
      } else if (c === 35) {
        this.url.fragment = "";
        this.state = "fragment";
      } else {
        if (!isNaN(c) && c !== 37) {
          this.parseError = true;
        }
        if (c === 37 && (!isASCIIHex(this.input[this.pointer + 1]) || !isASCIIHex(this.input[this.pointer + 2]))) {
          this.parseError = true;
        }
        if (!isNaN(c)) {
          this.url.path[0] = this.url.path[0] + percentEncodeChar(c, isC0ControlPercentEncode);
        }
      }
      return true;
    };
    URLStateMachine.prototype["parse query"] = function parseQuery(c, cStr) {
      if (isNaN(c) || !this.stateOverride && c === 35) {
        if (!isSpecial(this.url) || this.url.scheme === "ws" || this.url.scheme === "wss") {
          this.encodingOverride = "utf-8";
        }
        const buffer = new Buffer(this.buffer);
        for (let i = 0; i < buffer.length; ++i) {
          if (buffer[i] < 33 || buffer[i] > 126 || buffer[i] === 34 || buffer[i] === 35 || buffer[i] === 60 || buffer[i] === 62) {
            this.url.query += percentEncode(buffer[i]);
          } else {
            this.url.query += String.fromCodePoint(buffer[i]);
          }
        }
        this.buffer = "";
        if (c === 35) {
          this.url.fragment = "";
          this.state = "fragment";
        }
      } else {
        if (c === 37 && (!isASCIIHex(this.input[this.pointer + 1]) || !isASCIIHex(this.input[this.pointer + 2]))) {
          this.parseError = true;
        }
        this.buffer += cStr;
      }
      return true;
    };
    URLStateMachine.prototype["parse fragment"] = function parseFragment(c) {
      if (isNaN(c)) {
      } else if (c === 0) {
        this.parseError = true;
      } else {
        if (c === 37 && (!isASCIIHex(this.input[this.pointer + 1]) || !isASCIIHex(this.input[this.pointer + 2]))) {
          this.parseError = true;
        }
        this.url.fragment += percentEncodeChar(c, isC0ControlPercentEncode);
      }
      return true;
    };
    function serializeURL(url, excludeFragment) {
      let output = url.scheme + ":";
      if (url.host !== null) {
        output += "//";
        if (url.username !== "" || url.password !== "") {
          output += url.username;
          if (url.password !== "") {
            output += ":" + url.password;
          }
          output += "@";
        }
        output += serializeHost(url.host);
        if (url.port !== null) {
          output += ":" + url.port;
        }
      } else if (url.host === null && url.scheme === "file") {
        output += "//";
      }
      if (url.cannotBeABaseURL) {
        output += url.path[0];
      } else {
        for (const string3 of url.path) {
          output += "/" + string3;
        }
      }
      if (url.query !== null) {
        output += "?" + url.query;
      }
      if (!excludeFragment && url.fragment !== null) {
        output += "#" + url.fragment;
      }
      return output;
    }
    function serializeOrigin(tuple) {
      let result = tuple.scheme + "://";
      result += serializeHost(tuple.host);
      if (tuple.port !== null) {
        result += ":" + tuple.port;
      }
      return result;
    }
    module2.exports.serializeURL = serializeURL;
    module2.exports.serializeURLOrigin = function(url) {
      switch (url.scheme) {
        case "blob":
          try {
            return module2.exports.serializeURLOrigin(module2.exports.parseURL(url.path[0]));
          } catch (e) {
            return "null";
          }
        case "ftp":
        case "gopher":
        case "http":
        case "https":
        case "ws":
        case "wss":
          return serializeOrigin({
            scheme: url.scheme,
            host: url.host,
            port: url.port
          });
        case "file":
          return "file://";
        default:
          return "null";
      }
    };
    module2.exports.basicURLParse = function(input, options) {
      if (options === void 0) {
        options = {};
      }
      const usm = new URLStateMachine(input, options.baseURL, options.encodingOverride, options.url, options.stateOverride);
      if (usm.failure) {
        return "failure";
      }
      return usm.url;
    };
    module2.exports.setTheUsername = function(url, username) {
      url.username = "";
      const decoded = punycode.ucs2.decode(username);
      for (let i = 0; i < decoded.length; ++i) {
        url.username += percentEncodeChar(decoded[i], isUserinfoPercentEncode);
      }
    };
    module2.exports.setThePassword = function(url, password) {
      url.password = "";
      const decoded = punycode.ucs2.decode(password);
      for (let i = 0; i < decoded.length; ++i) {
        url.password += percentEncodeChar(decoded[i], isUserinfoPercentEncode);
      }
    };
    module2.exports.serializeHost = serializeHost;
    module2.exports.cannotHaveAUsernamePasswordPort = cannotHaveAUsernamePasswordPort;
    module2.exports.serializeInteger = function(integer) {
      return String(integer);
    };
    module2.exports.parseURL = function(input, options) {
      if (options === void 0) {
        options = {};
      }
      return module2.exports.basicURLParse(input, { baseURL: options.baseURL, encodingOverride: options.encodingOverride });
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/URL-impl.js
var require_URL_impl = __commonJS({
  "../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/URL-impl.js"(exports2) {
    "use strict";
    var usm = require_url_state_machine();
    exports2.implementation = class URLImpl {
      constructor(constructorArgs) {
        const url = constructorArgs[0];
        const base = constructorArgs[1];
        let parsedBase = null;
        if (base !== void 0) {
          parsedBase = usm.basicURLParse(base);
          if (parsedBase === "failure") {
            throw new TypeError("Invalid base URL");
          }
        }
        const parsedURL = usm.basicURLParse(url, { baseURL: parsedBase });
        if (parsedURL === "failure") {
          throw new TypeError("Invalid URL");
        }
        this._url = parsedURL;
      }
      get href() {
        return usm.serializeURL(this._url);
      }
      set href(v) {
        const parsedURL = usm.basicURLParse(v);
        if (parsedURL === "failure") {
          throw new TypeError("Invalid URL");
        }
        this._url = parsedURL;
      }
      get origin() {
        return usm.serializeURLOrigin(this._url);
      }
      get protocol() {
        return this._url.scheme + ":";
      }
      set protocol(v) {
        usm.basicURLParse(v + ":", { url: this._url, stateOverride: "scheme start" });
      }
      get username() {
        return this._url.username;
      }
      set username(v) {
        if (usm.cannotHaveAUsernamePasswordPort(this._url)) {
          return;
        }
        usm.setTheUsername(this._url, v);
      }
      get password() {
        return this._url.password;
      }
      set password(v) {
        if (usm.cannotHaveAUsernamePasswordPort(this._url)) {
          return;
        }
        usm.setThePassword(this._url, v);
      }
      get host() {
        const url = this._url;
        if (url.host === null) {
          return "";
        }
        if (url.port === null) {
          return usm.serializeHost(url.host);
        }
        return usm.serializeHost(url.host) + ":" + usm.serializeInteger(url.port);
      }
      set host(v) {
        if (this._url.cannotBeABaseURL) {
          return;
        }
        usm.basicURLParse(v, { url: this._url, stateOverride: "host" });
      }
      get hostname() {
        if (this._url.host === null) {
          return "";
        }
        return usm.serializeHost(this._url.host);
      }
      set hostname(v) {
        if (this._url.cannotBeABaseURL) {
          return;
        }
        usm.basicURLParse(v, { url: this._url, stateOverride: "hostname" });
      }
      get port() {
        if (this._url.port === null) {
          return "";
        }
        return usm.serializeInteger(this._url.port);
      }
      set port(v) {
        if (usm.cannotHaveAUsernamePasswordPort(this._url)) {
          return;
        }
        if (v === "") {
          this._url.port = null;
        } else {
          usm.basicURLParse(v, { url: this._url, stateOverride: "port" });
        }
      }
      get pathname() {
        if (this._url.cannotBeABaseURL) {
          return this._url.path[0];
        }
        if (this._url.path.length === 0) {
          return "";
        }
        return "/" + this._url.path.join("/");
      }
      set pathname(v) {
        if (this._url.cannotBeABaseURL) {
          return;
        }
        this._url.path = [];
        usm.basicURLParse(v, { url: this._url, stateOverride: "path start" });
      }
      get search() {
        if (this._url.query === null || this._url.query === "") {
          return "";
        }
        return "?" + this._url.query;
      }
      set search(v) {
        const url = this._url;
        if (v === "") {
          url.query = null;
          return;
        }
        const input = v[0] === "?" ? v.substring(1) : v;
        url.query = "";
        usm.basicURLParse(input, { url, stateOverride: "query" });
      }
      get hash() {
        if (this._url.fragment === null || this._url.fragment === "") {
          return "";
        }
        return "#" + this._url.fragment;
      }
      set hash(v) {
        if (v === "") {
          this._url.fragment = null;
          return;
        }
        const input = v[0] === "#" ? v.substring(1) : v;
        this._url.fragment = "";
        usm.basicURLParse(input, { url: this._url, stateOverride: "fragment" });
      }
      toJSON() {
        return this.href;
      }
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/URL.js
var require_URL = __commonJS({
  "../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/URL.js"(exports2, module2) {
    "use strict";
    var conversions = require_lib2();
    var utils = require_utils3();
    var Impl = require_URL_impl();
    var impl = utils.implSymbol;
    function URL3(url) {
      if (!this || this[impl] || !(this instanceof URL3)) {
        throw new TypeError("Failed to construct 'URL': Please use the 'new' operator, this DOM object constructor cannot be called as a function.");
      }
      if (arguments.length < 1) {
        throw new TypeError("Failed to construct 'URL': 1 argument required, but only " + arguments.length + " present.");
      }
      const args = [];
      for (let i = 0; i < arguments.length && i < 2; ++i) {
        args[i] = arguments[i];
      }
      args[0] = conversions["USVString"](args[0]);
      if (args[1] !== void 0) {
        args[1] = conversions["USVString"](args[1]);
      }
      module2.exports.setup(this, args);
    }
    URL3.prototype.toJSON = function toJSON() {
      if (!this || !module2.exports.is(this)) {
        throw new TypeError("Illegal invocation");
      }
      const args = [];
      for (let i = 0; i < arguments.length && i < 0; ++i) {
        args[i] = arguments[i];
      }
      return this[impl].toJSON.apply(this[impl], args);
    };
    Object.defineProperty(URL3.prototype, "href", {
      get() {
        return this[impl].href;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].href = V;
      },
      enumerable: true,
      configurable: true
    });
    URL3.prototype.toString = function() {
      if (!this || !module2.exports.is(this)) {
        throw new TypeError("Illegal invocation");
      }
      return this.href;
    };
    Object.defineProperty(URL3.prototype, "origin", {
      get() {
        return this[impl].origin;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "protocol", {
      get() {
        return this[impl].protocol;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].protocol = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "username", {
      get() {
        return this[impl].username;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].username = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "password", {
      get() {
        return this[impl].password;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].password = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "host", {
      get() {
        return this[impl].host;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].host = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "hostname", {
      get() {
        return this[impl].hostname;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].hostname = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "port", {
      get() {
        return this[impl].port;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].port = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "pathname", {
      get() {
        return this[impl].pathname;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].pathname = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "search", {
      get() {
        return this[impl].search;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].search = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "hash", {
      get() {
        return this[impl].hash;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].hash = V;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = {
      is(obj) {
        return !!obj && obj[impl] instanceof Impl.implementation;
      },
      create(constructorArgs, privateData) {
        let obj = Object.create(URL3.prototype);
        this.setup(obj, constructorArgs, privateData);
        return obj;
      },
      setup(obj, constructorArgs, privateData) {
        if (!privateData) privateData = {};
        privateData.wrapper = obj;
        obj[impl] = new Impl.implementation(constructorArgs, privateData);
        obj[impl][utils.wrapperSymbol] = obj;
      },
      interface: URL3,
      expose: {
        Window: { URL: URL3 },
        Worker: { URL: URL3 }
      }
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/public-api.js
var require_public_api2 = __commonJS({
  "../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/public-api.js"(exports2) {
    "use strict";
    exports2.URL = require_URL().interface;
    exports2.serializeURL = require_url_state_machine().serializeURL;
    exports2.serializeURLOrigin = require_url_state_machine().serializeURLOrigin;
    exports2.basicURLParse = require_url_state_machine().basicURLParse;
    exports2.setTheUsername = require_url_state_machine().setTheUsername;
    exports2.setThePassword = require_url_state_machine().setThePassword;
    exports2.serializeHost = require_url_state_machine().serializeHost;
    exports2.serializeInteger = require_url_state_machine().serializeInteger;
    exports2.parseURL = require_url_state_machine().parseURL;
  }
});

// ../../../node_modules/.pnpm/node-fetch@2.7.0/node_modules/node-fetch/lib/index.mjs
var lib_exports2 = {};
__export(lib_exports2, {
  AbortError: () => AbortError2,
  FetchError: () => FetchError2,
  Headers: () => Headers2,
  Request: () => Request3,
  Response: () => Response3,
  default: () => lib_default2
});
function FetchError2(message, type2, systemError) {
  Error.call(this, message);
  this.message = message;
  this.type = type2;
  if (systemError) {
    this.code = this.errno = systemError.code;
  }
  Error.captureStackTrace(this, this.constructor);
}
function Body2(body) {
  var _this = this;
  var _ref = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, _ref$size = _ref.size;
  let size2 = _ref$size === void 0 ? 0 : _ref$size;
  var _ref$timeout = _ref.timeout;
  let timeout = _ref$timeout === void 0 ? 0 : _ref$timeout;
  if (body == null) {
    body = null;
  } else if (isURLSearchParams2(body)) {
    body = Buffer.from(body.toString());
  } else if (isBlob(body)) ;
  else if (Buffer.isBuffer(body)) ;
  else if (Object.prototype.toString.call(body) === "[object ArrayBuffer]") {
    body = Buffer.from(body);
  } else if (ArrayBuffer.isView(body)) {
    body = Buffer.from(body.buffer, body.byteOffset, body.byteLength);
  } else if (body instanceof import_stream2.default) ;
  else {
    body = Buffer.from(String(body));
  }
  this[INTERNALS2] = {
    body,
    disturbed: false,
    error: null
  };
  this.size = size2;
  this.timeout = timeout;
  if (body instanceof import_stream2.default) {
    body.on("error", function(err) {
      const error = err.name === "AbortError" ? err : new FetchError2(`Invalid response body while trying to fetch ${_this.url}: ${err.message}`, "system", err);
      _this[INTERNALS2].error = error;
    });
  }
}
function consumeBody2() {
  var _this4 = this;
  if (this[INTERNALS2].disturbed) {
    return Body2.Promise.reject(new TypeError(`body used already for: ${this.url}`));
  }
  this[INTERNALS2].disturbed = true;
  if (this[INTERNALS2].error) {
    return Body2.Promise.reject(this[INTERNALS2].error);
  }
  let body = this.body;
  if (body === null) {
    return Body2.Promise.resolve(Buffer.alloc(0));
  }
  if (isBlob(body)) {
    body = body.stream();
  }
  if (Buffer.isBuffer(body)) {
    return Body2.Promise.resolve(body);
  }
  if (!(body instanceof import_stream2.default)) {
    return Body2.Promise.resolve(Buffer.alloc(0));
  }
  let accum = [];
  let accumBytes = 0;
  let abort = false;
  return new Body2.Promise(function(resolve, reject) {
    let resTimeout;
    if (_this4.timeout) {
      resTimeout = setTimeout(function() {
        abort = true;
        reject(new FetchError2(`Response timeout while trying to fetch ${_this4.url} (over ${_this4.timeout}ms)`, "body-timeout"));
      }, _this4.timeout);
    }
    body.on("error", function(err) {
      if (err.name === "AbortError") {
        abort = true;
        reject(err);
      } else {
        reject(new FetchError2(`Invalid response body while trying to fetch ${_this4.url}: ${err.message}`, "system", err));
      }
    });
    body.on("data", function(chunk) {
      if (abort || chunk === null) {
        return;
      }
      if (_this4.size && accumBytes + chunk.length > _this4.size) {
        abort = true;
        reject(new FetchError2(`content size at ${_this4.url} over limit: ${_this4.size}`, "max-size"));
        return;
      }
      accumBytes += chunk.length;
      accum.push(chunk);
    });
    body.on("end", function() {
      if (abort) {
        return;
      }
      clearTimeout(resTimeout);
      try {
        resolve(Buffer.concat(accum, accumBytes));
      } catch (err) {
        reject(new FetchError2(`Could not create Buffer from response body for ${_this4.url}: ${err.message}`, "system", err));
      }
    });
  });
}
function convertBody2(buffer, headers) {
  if (typeof convert3 !== "function") {
    throw new Error("The package `encoding` must be installed to use the textConverted() function");
  }
  const ct = headers.get("content-type");
  let charset = "utf-8";
  let res, str2;
  if (ct) {
    res = /charset=([^;]*)/i.exec(ct);
  }
  str2 = buffer.slice(0, 1024).toString();
  if (!res && str2) {
    res = /<meta.+?charset=(['"])(.+?)\1/i.exec(str2);
  }
  if (!res && str2) {
    res = /<meta[\s]+?http-equiv=(['"])content-type\1[\s]+?content=(['"])(.+?)\2/i.exec(str2);
    if (!res) {
      res = /<meta[\s]+?content=(['"])(.+?)\1[\s]+?http-equiv=(['"])content-type\3/i.exec(str2);
      if (res) {
        res.pop();
      }
    }
    if (res) {
      res = /charset=(.*)/i.exec(res.pop());
    }
  }
  if (!res && str2) {
    res = /<\?xml.+?encoding=(['"])(.+?)\1/i.exec(str2);
  }
  if (res) {
    charset = res.pop();
    if (charset === "gb2312" || charset === "gbk") {
      charset = "gb18030";
    }
  }
  return convert3(buffer, "UTF-8", charset).toString();
}
function isURLSearchParams2(obj) {
  if (typeof obj !== "object" || typeof obj.append !== "function" || typeof obj.delete !== "function" || typeof obj.get !== "function" || typeof obj.getAll !== "function" || typeof obj.has !== "function" || typeof obj.set !== "function") {
    return false;
  }
  return obj.constructor.name === "URLSearchParams" || Object.prototype.toString.call(obj) === "[object URLSearchParams]" || typeof obj.sort === "function";
}
function isBlob(obj) {
  return typeof obj === "object" && typeof obj.arrayBuffer === "function" && typeof obj.type === "string" && typeof obj.stream === "function" && typeof obj.constructor === "function" && typeof obj.constructor.name === "string" && /^(Blob|File)$/.test(obj.constructor.name) && /^(Blob|File)$/.test(obj[Symbol.toStringTag]);
}
function clone2(instance) {
  let p1, p2;
  let body = instance.body;
  if (instance.bodyUsed) {
    throw new Error("cannot clone body after it is used");
  }
  if (body instanceof import_stream2.default && typeof body.getBoundary !== "function") {
    p1 = new PassThrough2();
    p2 = new PassThrough2();
    body.pipe(p1);
    body.pipe(p2);
    instance[INTERNALS2].body = p1;
    body = p2;
  }
  return body;
}
function extractContentType2(body) {
  if (body === null) {
    return null;
  } else if (typeof body === "string") {
    return "text/plain;charset=UTF-8";
  } else if (isURLSearchParams2(body)) {
    return "application/x-www-form-urlencoded;charset=UTF-8";
  } else if (isBlob(body)) {
    return body.type || null;
  } else if (Buffer.isBuffer(body)) {
    return null;
  } else if (Object.prototype.toString.call(body) === "[object ArrayBuffer]") {
    return null;
  } else if (ArrayBuffer.isView(body)) {
    return null;
  } else if (typeof body.getBoundary === "function") {
    return `multipart/form-data;boundary=${body.getBoundary()}`;
  } else if (body instanceof import_stream2.default) {
    return null;
  } else {
    return "text/plain;charset=UTF-8";
  }
}
function getTotalBytes2(instance) {
  const body = instance.body;
  if (body === null) {
    return 0;
  } else if (isBlob(body)) {
    return body.size;
  } else if (Buffer.isBuffer(body)) {
    return body.length;
  } else if (body && typeof body.getLengthSync === "function") {
    if (body._lengthRetrievers && body._lengthRetrievers.length == 0 || // 1.x
    body.hasKnownLength && body.hasKnownLength()) {
      return body.getLengthSync();
    }
    return null;
  } else {
    return null;
  }
}
function writeToStream2(dest, instance) {
  const body = instance.body;
  if (body === null) {
    dest.end();
  } else if (isBlob(body)) {
    body.stream().pipe(dest);
  } else if (Buffer.isBuffer(body)) {
    dest.write(body);
    dest.end();
  } else {
    body.pipe(dest);
  }
}
function validateName2(name) {
  name = `${name}`;
  if (invalidTokenRegex2.test(name) || name === "") {
    throw new TypeError(`${name} is not a legal HTTP header name`);
  }
}
function validateValue2(value) {
  value = `${value}`;
  if (invalidHeaderCharRegex2.test(value)) {
    throw new TypeError(`${value} is not a legal HTTP header value`);
  }
}
function find2(map2, name) {
  name = name.toLowerCase();
  for (const key in map2) {
    if (key.toLowerCase() === name) {
      return key;
    }
  }
  return void 0;
}
function getHeaders2(headers) {
  let kind = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "key+value";
  const keys5 = Object.keys(headers[MAP2]).sort();
  return keys5.map(kind === "key" ? function(k) {
    return k.toLowerCase();
  } : kind === "value" ? function(k) {
    return headers[MAP2][k].join(", ");
  } : function(k) {
    return [k.toLowerCase(), headers[MAP2][k].join(", ")];
  });
}
function createHeadersIterator2(target, kind) {
  const iterator = Object.create(HeadersIteratorPrototype2);
  iterator[INTERNAL2] = {
    target,
    kind,
    index: 0
  };
  return iterator;
}
function exportNodeCompatibleHeaders2(headers) {
  const obj = Object.assign({ __proto__: null }, headers[MAP2]);
  const hostHeaderKey = find2(headers[MAP2], "Host");
  if (hostHeaderKey !== void 0) {
    obj[hostHeaderKey] = obj[hostHeaderKey][0];
  }
  return obj;
}
function createHeadersLenient2(obj) {
  const headers = new Headers2();
  for (const name of Object.keys(obj)) {
    if (invalidTokenRegex2.test(name)) {
      continue;
    }
    if (Array.isArray(obj[name])) {
      for (const val of obj[name]) {
        if (invalidHeaderCharRegex2.test(val)) {
          continue;
        }
        if (headers[MAP2][name] === void 0) {
          headers[MAP2][name] = [val];
        } else {
          headers[MAP2][name].push(val);
        }
      }
    } else if (!invalidHeaderCharRegex2.test(obj[name])) {
      headers[MAP2][name] = [obj[name]];
    }
  }
  return headers;
}
function parseURL(urlStr) {
  if (/^[a-zA-Z][a-zA-Z\d+\-.]*:/.exec(urlStr)) {
    urlStr = new URL2(urlStr).toString();
  }
  return parse_url2(urlStr);
}
function isRequest2(input) {
  return typeof input === "object" && typeof input[INTERNALS$22] === "object";
}
function isAbortSignal2(signal) {
  const proto = signal && typeof signal === "object" && Object.getPrototypeOf(signal);
  return !!(proto && proto.constructor.name === "AbortSignal");
}
function getNodeRequestOptions2(request) {
  const parsedURL = request[INTERNALS$22].parsedURL;
  const headers = new Headers2(request[INTERNALS$22].headers);
  if (!headers.has("Accept")) {
    headers.set("Accept", "*/*");
  }
  if (!parsedURL.protocol || !parsedURL.hostname) {
    throw new TypeError("Only absolute URLs are supported");
  }
  if (!/^https?:$/.test(parsedURL.protocol)) {
    throw new TypeError("Only HTTP(S) protocols are supported");
  }
  if (request.signal && request.body instanceof import_stream2.default.Readable && !streamDestructionSupported2) {
    throw new Error("Cancellation of streamed requests with AbortSignal is not supported in node < 8");
  }
  let contentLengthValue = null;
  if (request.body == null && /^(POST|PUT)$/i.test(request.method)) {
    contentLengthValue = "0";
  }
  if (request.body != null) {
    const totalBytes = getTotalBytes2(request);
    if (typeof totalBytes === "number") {
      contentLengthValue = String(totalBytes);
    }
  }
  if (contentLengthValue) {
    headers.set("Content-Length", contentLengthValue);
  }
  if (!headers.has("User-Agent")) {
    headers.set("User-Agent", "node-fetch/1.0 (+https://github.com/bitinn/node-fetch)");
  }
  if (request.compress && !headers.has("Accept-Encoding")) {
    headers.set("Accept-Encoding", "gzip,deflate");
  }
  let agent = request.agent;
  if (typeof agent === "function") {
    agent = agent(parsedURL);
  }
  return Object.assign({}, parsedURL, {
    method: request.method,
    headers: exportNodeCompatibleHeaders2(headers),
    agent
  });
}
function AbortError2(message) {
  Error.call(this, message);
  this.type = "aborted";
  this.message = message;
  Error.captureStackTrace(this, this.constructor);
}
function fetch2(url, opts) {
  if (!fetch2.Promise) {
    throw new Error("native promise missing, set fetch.Promise to your favorite alternative");
  }
  Body2.Promise = fetch2.Promise;
  return new fetch2.Promise(function(resolve, reject) {
    const request = new Request3(url, opts);
    const options = getNodeRequestOptions2(request);
    const send = (options.protocol === "https:" ? import_https.default : import_http2.default).request;
    const signal = request.signal;
    let response = null;
    const abort = function abort2() {
      let error = new AbortError2("The user aborted a request.");
      reject(error);
      if (request.body && request.body instanceof import_stream2.default.Readable) {
        destroyStream(request.body, error);
      }
      if (!response || !response.body) return;
      response.body.emit("error", error);
    };
    if (signal && signal.aborted) {
      abort();
      return;
    }
    const abortAndFinalize = function abortAndFinalize2() {
      abort();
      finalize();
    };
    const req = send(options);
    let reqTimeout;
    if (signal) {
      signal.addEventListener("abort", abortAndFinalize);
    }
    function finalize() {
      req.abort();
      if (signal) signal.removeEventListener("abort", abortAndFinalize);
      clearTimeout(reqTimeout);
    }
    if (request.timeout) {
      req.once("socket", function(socket) {
        reqTimeout = setTimeout(function() {
          reject(new FetchError2(`network timeout at: ${request.url}`, "request-timeout"));
          finalize();
        }, request.timeout);
      });
    }
    req.on("error", function(err) {
      reject(new FetchError2(`request to ${request.url} failed, reason: ${err.message}`, "system", err));
      if (response && response.body) {
        destroyStream(response.body, err);
      }
      finalize();
    });
    fixResponseChunkedTransferBadEnding(req, function(err) {
      if (signal && signal.aborted) {
        return;
      }
      if (response && response.body) {
        destroyStream(response.body, err);
      }
    });
    if (parseInt(process.version.substring(1)) < 14) {
      req.on("socket", function(s) {
        s.addListener("close", function(hadError) {
          const hasDataListener = s.listenerCount("data") > 0;
          if (response && hasDataListener && !hadError && !(signal && signal.aborted)) {
            const err = new Error("Premature close");
            err.code = "ERR_STREAM_PREMATURE_CLOSE";
            response.body.emit("error", err);
          }
        });
      });
    }
    req.on("response", function(res) {
      clearTimeout(reqTimeout);
      const headers = createHeadersLenient2(res.headers);
      if (fetch2.isRedirect(res.statusCode)) {
        const location = headers.get("Location");
        let locationURL = null;
        try {
          locationURL = location === null ? null : new URL$1(location, request.url).toString();
        } catch (err) {
          if (request.redirect !== "manual") {
            reject(new FetchError2(`uri requested responds with an invalid redirect URL: ${location}`, "invalid-redirect"));
            finalize();
            return;
          }
        }
        switch (request.redirect) {
          case "error":
            reject(new FetchError2(`uri requested responds with a redirect, redirect mode is set to error: ${request.url}`, "no-redirect"));
            finalize();
            return;
          case "manual":
            if (locationURL !== null) {
              try {
                headers.set("Location", locationURL);
              } catch (err) {
                reject(err);
              }
            }
            break;
          case "follow":
            if (locationURL === null) {
              break;
            }
            if (request.counter >= request.follow) {
              reject(new FetchError2(`maximum redirect reached at: ${request.url}`, "max-redirect"));
              finalize();
              return;
            }
            const requestOpts = {
              headers: new Headers2(request.headers),
              follow: request.follow,
              counter: request.counter + 1,
              agent: request.agent,
              compress: request.compress,
              method: request.method,
              body: request.body,
              signal: request.signal,
              timeout: request.timeout,
              size: request.size
            };
            if (!isDomainOrSubdomain(request.url, locationURL) || !isSameProtocol(request.url, locationURL)) {
              for (const name of ["authorization", "www-authenticate", "cookie", "cookie2"]) {
                requestOpts.headers.delete(name);
              }
            }
            if (res.statusCode !== 303 && request.body && getTotalBytes2(request) === null) {
              reject(new FetchError2("Cannot follow redirect with body being a readable stream", "unsupported-redirect"));
              finalize();
              return;
            }
            if (res.statusCode === 303 || (res.statusCode === 301 || res.statusCode === 302) && request.method === "POST") {
              requestOpts.method = "GET";
              requestOpts.body = void 0;
              requestOpts.headers.delete("content-length");
            }
            resolve(fetch2(new Request3(locationURL, requestOpts)));
            finalize();
            return;
        }
      }
      res.once("end", function() {
        if (signal) signal.removeEventListener("abort", abortAndFinalize);
      });
      let body = res.pipe(new PassThrough$12());
      const response_options = {
        url: request.url,
        status: res.statusCode,
        statusText: res.statusMessage,
        headers,
        size: request.size,
        timeout: request.timeout,
        counter: request.counter
      };
      const codings = headers.get("Content-Encoding");
      if (!request.compress || request.method === "HEAD" || codings === null || res.statusCode === 204 || res.statusCode === 304) {
        response = new Response3(body, response_options);
        resolve(response);
        return;
      }
      const zlibOptions = {
        flush: import_zlib2.default.Z_SYNC_FLUSH,
        finishFlush: import_zlib2.default.Z_SYNC_FLUSH
      };
      if (codings == "gzip" || codings == "x-gzip") {
        body = body.pipe(import_zlib2.default.createGunzip(zlibOptions));
        response = new Response3(body, response_options);
        resolve(response);
        return;
      }
      if (codings == "deflate" || codings == "x-deflate") {
        const raw = res.pipe(new PassThrough$12());
        raw.once("data", function(chunk) {
          if ((chunk[0] & 15) === 8) {
            body = body.pipe(import_zlib2.default.createInflate());
          } else {
            body = body.pipe(import_zlib2.default.createInflateRaw());
          }
          response = new Response3(body, response_options);
          resolve(response);
        });
        raw.on("end", function() {
          if (!response) {
            response = new Response3(body, response_options);
            resolve(response);
          }
        });
        return;
      }
      if (codings == "br" && typeof import_zlib2.default.createBrotliDecompress === "function") {
        body = body.pipe(import_zlib2.default.createBrotliDecompress());
        response = new Response3(body, response_options);
        resolve(response);
        return;
      }
      response = new Response3(body, response_options);
      resolve(response);
    });
    writeToStream2(req, request);
  });
}
function fixResponseChunkedTransferBadEnding(request, errorCallback) {
  let socket;
  request.on("socket", function(s) {
    socket = s;
  });
  request.on("response", function(response) {
    const headers = response.headers;
    if (headers["transfer-encoding"] === "chunked" && !headers["content-length"]) {
      response.once("close", function(hadError) {
        const hasDataListener = socket && socket.listenerCount("data") > 0;
        if (hasDataListener && !hadError) {
          const err = new Error("Premature close");
          err.code = "ERR_STREAM_PREMATURE_CLOSE";
          errorCallback(err);
        }
      });
    }
  });
}
function destroyStream(stream, err) {
  if (stream.destroy) {
    stream.destroy(err);
  } else {
    stream.emit("error", err);
    stream.end();
  }
}
var import_stream2, import_http2, import_url2, import_whatwg_url, import_https, import_zlib2, Readable, BUFFER2, TYPE2, Blob2, convert3, INTERNALS2, PassThrough2, invalidTokenRegex2, invalidHeaderCharRegex2, MAP2, Headers2, INTERNAL2, HeadersIteratorPrototype2, INTERNALS$12, STATUS_CODES2, Response3, INTERNALS$22, URL2, parse_url2, format_url2, streamDestructionSupported2, Request3, URL$1, PassThrough$12, isDomainOrSubdomain, isSameProtocol, lib_default2;
var init_lib2 = __esm({
  "../../../node_modules/.pnpm/node-fetch@2.7.0/node_modules/node-fetch/lib/index.mjs"() {
    "use strict";
    import_stream2 = __toESM(require("stream"), 1);
    import_http2 = __toESM(require("http"), 1);
    import_url2 = __toESM(require("url"), 1);
    import_whatwg_url = __toESM(require_public_api2(), 1);
    import_https = __toESM(require("https"), 1);
    import_zlib2 = __toESM(require("zlib"), 1);
    Readable = import_stream2.default.Readable;
    BUFFER2 = Symbol("buffer");
    TYPE2 = Symbol("type");
    Blob2 = class _Blob {
      constructor() {
        this[TYPE2] = "";
        const blobParts = arguments[0];
        const options = arguments[1];
        const buffers = [];
        let size2 = 0;
        if (blobParts) {
          const a = blobParts;
          const length = Number(a.length);
          for (let i = 0; i < length; i++) {
            const element = a[i];
            let buffer;
            if (element instanceof Buffer) {
              buffer = element;
            } else if (ArrayBuffer.isView(element)) {
              buffer = Buffer.from(element.buffer, element.byteOffset, element.byteLength);
            } else if (element instanceof ArrayBuffer) {
              buffer = Buffer.from(element);
            } else if (element instanceof _Blob) {
              buffer = element[BUFFER2];
            } else {
              buffer = Buffer.from(typeof element === "string" ? element : String(element));
            }
            size2 += buffer.length;
            buffers.push(buffer);
          }
        }
        this[BUFFER2] = Buffer.concat(buffers);
        let type2 = options && options.type !== void 0 && String(options.type).toLowerCase();
        if (type2 && !/[^\u0020-\u007E]/.test(type2)) {
          this[TYPE2] = type2;
        }
      }
      get size() {
        return this[BUFFER2].length;
      }
      get type() {
        return this[TYPE2];
      }
      text() {
        return Promise.resolve(this[BUFFER2].toString());
      }
      arrayBuffer() {
        const buf = this[BUFFER2];
        const ab = buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength);
        return Promise.resolve(ab);
      }
      stream() {
        const readable = new Readable();
        readable._read = function() {
        };
        readable.push(this[BUFFER2]);
        readable.push(null);
        return readable;
      }
      toString() {
        return "[object Blob]";
      }
      slice() {
        const size2 = this.size;
        const start = arguments[0];
        const end = arguments[1];
        let relativeStart, relativeEnd;
        if (start === void 0) {
          relativeStart = 0;
        } else if (start < 0) {
          relativeStart = Math.max(size2 + start, 0);
        } else {
          relativeStart = Math.min(start, size2);
        }
        if (end === void 0) {
          relativeEnd = size2;
        } else if (end < 0) {
          relativeEnd = Math.max(size2 + end, 0);
        } else {
          relativeEnd = Math.min(end, size2);
        }
        const span = Math.max(relativeEnd - relativeStart, 0);
        const buffer = this[BUFFER2];
        const slicedBuffer = buffer.slice(relativeStart, relativeStart + span);
        const blob = new _Blob([], { type: arguments[2] });
        blob[BUFFER2] = slicedBuffer;
        return blob;
      }
    };
    Object.defineProperties(Blob2.prototype, {
      size: { enumerable: true },
      type: { enumerable: true },
      slice: { enumerable: true }
    });
    Object.defineProperty(Blob2.prototype, Symbol.toStringTag, {
      value: "Blob",
      writable: false,
      enumerable: false,
      configurable: true
    });
    FetchError2.prototype = Object.create(Error.prototype);
    FetchError2.prototype.constructor = FetchError2;
    FetchError2.prototype.name = "FetchError";
    try {
      convert3 = require("encoding").convert;
    } catch (e) {
    }
    INTERNALS2 = Symbol("Body internals");
    PassThrough2 = import_stream2.default.PassThrough;
    Body2.prototype = {
      get body() {
        return this[INTERNALS2].body;
      },
      get bodyUsed() {
        return this[INTERNALS2].disturbed;
      },
      /**
       * Decode response as ArrayBuffer
       *
       * @return  Promise
       */
      arrayBuffer() {
        return consumeBody2.call(this).then(function(buf) {
          return buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength);
        });
      },
      /**
       * Return raw response as Blob
       *
       * @return Promise
       */
      blob() {
        let ct = this.headers && this.headers.get("content-type") || "";
        return consumeBody2.call(this).then(function(buf) {
          return Object.assign(
            // Prevent copying
            new Blob2([], {
              type: ct.toLowerCase()
            }),
            {
              [BUFFER2]: buf
            }
          );
        });
      },
      /**
       * Decode response as json
       *
       * @return  Promise
       */
      json() {
        var _this2 = this;
        return consumeBody2.call(this).then(function(buffer) {
          try {
            return JSON.parse(buffer.toString());
          } catch (err) {
            return Body2.Promise.reject(new FetchError2(`invalid json response body at ${_this2.url} reason: ${err.message}`, "invalid-json"));
          }
        });
      },
      /**
       * Decode response as text
       *
       * @return  Promise
       */
      text() {
        return consumeBody2.call(this).then(function(buffer) {
          return buffer.toString();
        });
      },
      /**
       * Decode response as buffer (non-spec api)
       *
       * @return  Promise
       */
      buffer() {
        return consumeBody2.call(this);
      },
      /**
       * Decode response as text, while automatically detecting the encoding and
       * trying to decode to UTF-8 (non-spec api)
       *
       * @return  Promise
       */
      textConverted() {
        var _this3 = this;
        return consumeBody2.call(this).then(function(buffer) {
          return convertBody2(buffer, _this3.headers);
        });
      }
    };
    Object.defineProperties(Body2.prototype, {
      body: { enumerable: true },
      bodyUsed: { enumerable: true },
      arrayBuffer: { enumerable: true },
      blob: { enumerable: true },
      json: { enumerable: true },
      text: { enumerable: true }
    });
    Body2.mixIn = function(proto) {
      for (const name of Object.getOwnPropertyNames(Body2.prototype)) {
        if (!(name in proto)) {
          const desc = Object.getOwnPropertyDescriptor(Body2.prototype, name);
          Object.defineProperty(proto, name, desc);
        }
      }
    };
    Body2.Promise = global.Promise;
    invalidTokenRegex2 = /[^\^_`a-zA-Z\-0-9!#$%&'*+.|~]/;
    invalidHeaderCharRegex2 = /[^\t\x20-\x7e\x80-\xff]/;
    MAP2 = Symbol("map");
    Headers2 = class _Headers {
      /**
       * Headers class
       *
       * @param   Object  headers  Response headers
       * @return  Void
       */
      constructor() {
        let init = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : void 0;
        this[MAP2] = /* @__PURE__ */ Object.create(null);
        if (init instanceof _Headers) {
          const rawHeaders = init.raw();
          const headerNames = Object.keys(rawHeaders);
          for (const headerName of headerNames) {
            for (const value of rawHeaders[headerName]) {
              this.append(headerName, value);
            }
          }
          return;
        }
        if (init == null) ;
        else if (typeof init === "object") {
          const method = init[Symbol.iterator];
          if (method != null) {
            if (typeof method !== "function") {
              throw new TypeError("Header pairs must be iterable");
            }
            const pairs2 = [];
            for (const pair of init) {
              if (typeof pair !== "object" || typeof pair[Symbol.iterator] !== "function") {
                throw new TypeError("Each header pair must be iterable");
              }
              pairs2.push(Array.from(pair));
            }
            for (const pair of pairs2) {
              if (pair.length !== 2) {
                throw new TypeError("Each header pair must be a name/value tuple");
              }
              this.append(pair[0], pair[1]);
            }
          } else {
            for (const key of Object.keys(init)) {
              const value = init[key];
              this.append(key, value);
            }
          }
        } else {
          throw new TypeError("Provided initializer must be an object");
        }
      }
      /**
       * Return combined header value given name
       *
       * @param   String  name  Header name
       * @return  Mixed
       */
      get(name) {
        name = `${name}`;
        validateName2(name);
        const key = find2(this[MAP2], name);
        if (key === void 0) {
          return null;
        }
        return this[MAP2][key].join(", ");
      }
      /**
       * Iterate over all headers
       *
       * @param   Function  callback  Executed for each item with parameters (value, name, thisArg)
       * @param   Boolean   thisArg   `this` context for callback function
       * @return  Void
       */
      forEach(callback) {
        let thisArg = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : void 0;
        let pairs2 = getHeaders2(this);
        let i = 0;
        while (i < pairs2.length) {
          var _pairs$i = pairs2[i];
          const name = _pairs$i[0], value = _pairs$i[1];
          callback.call(thisArg, value, name, this);
          pairs2 = getHeaders2(this);
          i++;
        }
      }
      /**
       * Overwrite header values given name
       *
       * @param   String  name   Header name
       * @param   String  value  Header value
       * @return  Void
       */
      set(name, value) {
        name = `${name}`;
        value = `${value}`;
        validateName2(name);
        validateValue2(value);
        const key = find2(this[MAP2], name);
        this[MAP2][key !== void 0 ? key : name] = [value];
      }
      /**
       * Append a value onto existing header
       *
       * @param   String  name   Header name
       * @param   String  value  Header value
       * @return  Void
       */
      append(name, value) {
        name = `${name}`;
        value = `${value}`;
        validateName2(name);
        validateValue2(value);
        const key = find2(this[MAP2], name);
        if (key !== void 0) {
          this[MAP2][key].push(value);
        } else {
          this[MAP2][name] = [value];
        }
      }
      /**
       * Check for header name existence
       *
       * @param   String   name  Header name
       * @return  Boolean
       */
      has(name) {
        name = `${name}`;
        validateName2(name);
        return find2(this[MAP2], name) !== void 0;
      }
      /**
       * Delete all header values given name
       *
       * @param   String  name  Header name
       * @return  Void
       */
      delete(name) {
        name = `${name}`;
        validateName2(name);
        const key = find2(this[MAP2], name);
        if (key !== void 0) {
          delete this[MAP2][key];
        }
      }
      /**
       * Return raw headers (non-spec api)
       *
       * @return  Object
       */
      raw() {
        return this[MAP2];
      }
      /**
       * Get an iterator on keys.
       *
       * @return  Iterator
       */
      keys() {
        return createHeadersIterator2(this, "key");
      }
      /**
       * Get an iterator on values.
       *
       * @return  Iterator
       */
      values() {
        return createHeadersIterator2(this, "value");
      }
      /**
       * Get an iterator on entries.
       *
       * This is the default iterator of the Headers object.
       *
       * @return  Iterator
       */
      [Symbol.iterator]() {
        return createHeadersIterator2(this, "key+value");
      }
    };
    Headers2.prototype.entries = Headers2.prototype[Symbol.iterator];
    Object.defineProperty(Headers2.prototype, Symbol.toStringTag, {
      value: "Headers",
      writable: false,
      enumerable: false,
      configurable: true
    });
    Object.defineProperties(Headers2.prototype, {
      get: { enumerable: true },
      forEach: { enumerable: true },
      set: { enumerable: true },
      append: { enumerable: true },
      has: { enumerable: true },
      delete: { enumerable: true },
      keys: { enumerable: true },
      values: { enumerable: true },
      entries: { enumerable: true }
    });
    INTERNAL2 = Symbol("internal");
    HeadersIteratorPrototype2 = Object.setPrototypeOf({
      next() {
        if (!this || Object.getPrototypeOf(this) !== HeadersIteratorPrototype2) {
          throw new TypeError("Value of `this` is not a HeadersIterator");
        }
        var _INTERNAL = this[INTERNAL2];
        const target = _INTERNAL.target, kind = _INTERNAL.kind, index = _INTERNAL.index;
        const values = getHeaders2(target, kind);
        const len = values.length;
        if (index >= len) {
          return {
            value: void 0,
            done: true
          };
        }
        this[INTERNAL2].index = index + 1;
        return {
          value: values[index],
          done: false
        };
      }
    }, Object.getPrototypeOf(Object.getPrototypeOf([][Symbol.iterator]())));
    Object.defineProperty(HeadersIteratorPrototype2, Symbol.toStringTag, {
      value: "HeadersIterator",
      writable: false,
      enumerable: false,
      configurable: true
    });
    INTERNALS$12 = Symbol("Response internals");
    STATUS_CODES2 = import_http2.default.STATUS_CODES;
    Response3 = class _Response {
      constructor() {
        let body = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null;
        let opts = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        Body2.call(this, body, opts);
        const status = opts.status || 200;
        const headers = new Headers2(opts.headers);
        if (body != null && !headers.has("Content-Type")) {
          const contentType = extractContentType2(body);
          if (contentType) {
            headers.append("Content-Type", contentType);
          }
        }
        this[INTERNALS$12] = {
          url: opts.url,
          status,
          statusText: opts.statusText || STATUS_CODES2[status],
          headers,
          counter: opts.counter
        };
      }
      get url() {
        return this[INTERNALS$12].url || "";
      }
      get status() {
        return this[INTERNALS$12].status;
      }
      /**
       * Convenience property representing if the request ended normally
       */
      get ok() {
        return this[INTERNALS$12].status >= 200 && this[INTERNALS$12].status < 300;
      }
      get redirected() {
        return this[INTERNALS$12].counter > 0;
      }
      get statusText() {
        return this[INTERNALS$12].statusText;
      }
      get headers() {
        return this[INTERNALS$12].headers;
      }
      /**
       * Clone this response
       *
       * @return  Response
       */
      clone() {
        return new _Response(clone2(this), {
          url: this.url,
          status: this.status,
          statusText: this.statusText,
          headers: this.headers,
          ok: this.ok,
          redirected: this.redirected
        });
      }
    };
    Body2.mixIn(Response3.prototype);
    Object.defineProperties(Response3.prototype, {
      url: { enumerable: true },
      status: { enumerable: true },
      ok: { enumerable: true },
      redirected: { enumerable: true },
      statusText: { enumerable: true },
      headers: { enumerable: true },
      clone: { enumerable: true }
    });
    Object.defineProperty(Response3.prototype, Symbol.toStringTag, {
      value: "Response",
      writable: false,
      enumerable: false,
      configurable: true
    });
    INTERNALS$22 = Symbol("Request internals");
    URL2 = import_url2.default.URL || import_whatwg_url.default.URL;
    parse_url2 = import_url2.default.parse;
    format_url2 = import_url2.default.format;
    streamDestructionSupported2 = "destroy" in import_stream2.default.Readable.prototype;
    Request3 = class _Request {
      constructor(input) {
        let init = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        let parsedURL;
        if (!isRequest2(input)) {
          if (input && input.href) {
            parsedURL = parseURL(input.href);
          } else {
            parsedURL = parseURL(`${input}`);
          }
          input = {};
        } else {
          parsedURL = parseURL(input.url);
        }
        let method = init.method || input.method || "GET";
        method = method.toUpperCase();
        if ((init.body != null || isRequest2(input) && input.body !== null) && (method === "GET" || method === "HEAD")) {
          throw new TypeError("Request with GET/HEAD method cannot have body");
        }
        let inputBody = init.body != null ? init.body : isRequest2(input) && input.body !== null ? clone2(input) : null;
        Body2.call(this, inputBody, {
          timeout: init.timeout || input.timeout || 0,
          size: init.size || input.size || 0
        });
        const headers = new Headers2(init.headers || input.headers || {});
        if (inputBody != null && !headers.has("Content-Type")) {
          const contentType = extractContentType2(inputBody);
          if (contentType) {
            headers.append("Content-Type", contentType);
          }
        }
        let signal = isRequest2(input) ? input.signal : null;
        if ("signal" in init) signal = init.signal;
        if (signal != null && !isAbortSignal2(signal)) {
          throw new TypeError("Expected signal to be an instanceof AbortSignal");
        }
        this[INTERNALS$22] = {
          method,
          redirect: init.redirect || input.redirect || "follow",
          headers,
          parsedURL,
          signal
        };
        this.follow = init.follow !== void 0 ? init.follow : input.follow !== void 0 ? input.follow : 20;
        this.compress = init.compress !== void 0 ? init.compress : input.compress !== void 0 ? input.compress : true;
        this.counter = init.counter || input.counter || 0;
        this.agent = init.agent || input.agent;
      }
      get method() {
        return this[INTERNALS$22].method;
      }
      get url() {
        return format_url2(this[INTERNALS$22].parsedURL);
      }
      get headers() {
        return this[INTERNALS$22].headers;
      }
      get redirect() {
        return this[INTERNALS$22].redirect;
      }
      get signal() {
        return this[INTERNALS$22].signal;
      }
      /**
       * Clone this request
       *
       * @return  Request
       */
      clone() {
        return new _Request(this);
      }
    };
    Body2.mixIn(Request3.prototype);
    Object.defineProperty(Request3.prototype, Symbol.toStringTag, {
      value: "Request",
      writable: false,
      enumerable: false,
      configurable: true
    });
    Object.defineProperties(Request3.prototype, {
      method: { enumerable: true },
      url: { enumerable: true },
      headers: { enumerable: true },
      redirect: { enumerable: true },
      clone: { enumerable: true },
      signal: { enumerable: true }
    });
    AbortError2.prototype = Object.create(Error.prototype);
    AbortError2.prototype.constructor = AbortError2;
    AbortError2.prototype.name = "AbortError";
    URL$1 = import_url2.default.URL || import_whatwg_url.default.URL;
    PassThrough$12 = import_stream2.default.PassThrough;
    isDomainOrSubdomain = function isDomainOrSubdomain2(destination, original) {
      const orig = new URL$1(original).hostname;
      const dest = new URL$1(destination).hostname;
      return orig === dest || orig[orig.length - dest.length - 1] === "." && orig.endsWith(dest);
    };
    isSameProtocol = function isSameProtocol2(destination, original) {
      const orig = new URL$1(original).protocol;
      const dest = new URL$1(destination).protocol;
      return orig === dest;
    };
    fetch2.isRedirect = function(code) {
      return code === 301 || code === 302 || code === 303 || code === 307 || code === 308;
    };
    fetch2.Promise = global.Promise;
    lib_default2 = fetch2;
  }
});

// ../../../node_modules/.pnpm/pluralize@8.0.0/node_modules/pluralize/pluralize.js
var require_pluralize = __commonJS({
  "../../../node_modules/.pnpm/pluralize@8.0.0/node_modules/pluralize/pluralize.js"(exports2, module2) {
    "use strict";
    (function(root2, pluralize) {
      if (typeof require === "function" && typeof exports2 === "object" && typeof module2 === "object") {
        module2.exports = pluralize();
      } else if (typeof define === "function" && define.amd) {
        define(function() {
          return pluralize();
        });
      } else {
        root2.pluralize = pluralize();
      }
    })(exports2, function() {
      var pluralRules = [];
      var singularRules = [];
      var uncountables = {};
      var irregularPlurals = {};
      var irregularSingles = {};
      function sanitizeRule(rule) {
        if (typeof rule === "string") {
          return new RegExp("^" + rule + "$", "i");
        }
        return rule;
      }
      function restoreCase(word, token) {
        if (word === token) return token;
        if (word === word.toLowerCase()) return token.toLowerCase();
        if (word === word.toUpperCase()) return token.toUpperCase();
        if (word[0] === word[0].toUpperCase()) {
          return token.charAt(0).toUpperCase() + token.substr(1).toLowerCase();
        }
        return token.toLowerCase();
      }
      function interpolate(str2, args) {
        return str2.replace(/\$(\d{1,2})/g, function(match, index) {
          return args[index] || "";
        });
      }
      function replace(word, rule) {
        return word.replace(rule[0], function(match, index) {
          var result = interpolate(rule[1], arguments);
          if (match === "") {
            return restoreCase(word[index - 1], result);
          }
          return restoreCase(match, result);
        });
      }
      function sanitizeWord(token, word, rules) {
        if (!token.length || uncountables.hasOwnProperty(token)) {
          return word;
        }
        var len = rules.length;
        while (len--) {
          var rule = rules[len];
          if (rule[0].test(word)) return replace(word, rule);
        }
        return word;
      }
      function replaceWord(replaceMap, keepMap, rules) {
        return function(word) {
          var token = word.toLowerCase();
          if (keepMap.hasOwnProperty(token)) {
            return restoreCase(word, token);
          }
          if (replaceMap.hasOwnProperty(token)) {
            return restoreCase(word, replaceMap[token]);
          }
          return sanitizeWord(token, word, rules);
        };
      }
      function checkWord(replaceMap, keepMap, rules, bool2) {
        return function(word) {
          var token = word.toLowerCase();
          if (keepMap.hasOwnProperty(token)) return true;
          if (replaceMap.hasOwnProperty(token)) return false;
          return sanitizeWord(token, token, rules) === token;
        };
      }
      function pluralize(word, count, inclusive) {
        var pluralized = count === 1 ? pluralize.singular(word) : pluralize.plural(word);
        return (inclusive ? count + " " : "") + pluralized;
      }
      pluralize.plural = replaceWord(
        irregularSingles,
        irregularPlurals,
        pluralRules
      );
      pluralize.isPlural = checkWord(
        irregularSingles,
        irregularPlurals,
        pluralRules
      );
      pluralize.singular = replaceWord(
        irregularPlurals,
        irregularSingles,
        singularRules
      );
      pluralize.isSingular = checkWord(
        irregularPlurals,
        irregularSingles,
        singularRules
      );
      pluralize.addPluralRule = function(rule, replacement) {
        pluralRules.push([sanitizeRule(rule), replacement]);
      };
      pluralize.addSingularRule = function(rule, replacement) {
        singularRules.push([sanitizeRule(rule), replacement]);
      };
      pluralize.addUncountableRule = function(word) {
        if (typeof word === "string") {
          uncountables[word.toLowerCase()] = true;
          return;
        }
        pluralize.addPluralRule(word, "$0");
        pluralize.addSingularRule(word, "$0");
      };
      pluralize.addIrregularRule = function(single, plural) {
        plural = plural.toLowerCase();
        single = single.toLowerCase();
        irregularSingles[single] = plural;
        irregularPlurals[plural] = single;
      };
      [
        // Pronouns.
        ["I", "we"],
        ["me", "us"],
        ["he", "they"],
        ["she", "they"],
        ["them", "them"],
        ["myself", "ourselves"],
        ["yourself", "yourselves"],
        ["itself", "themselves"],
        ["herself", "themselves"],
        ["himself", "themselves"],
        ["themself", "themselves"],
        ["is", "are"],
        ["was", "were"],
        ["has", "have"],
        ["this", "these"],
        ["that", "those"],
        // Words ending in with a consonant and `o`.
        ["echo", "echoes"],
        ["dingo", "dingoes"],
        ["volcano", "volcanoes"],
        ["tornado", "tornadoes"],
        ["torpedo", "torpedoes"],
        // Ends with `us`.
        ["genus", "genera"],
        ["viscus", "viscera"],
        // Ends with `ma`.
        ["stigma", "stigmata"],
        ["stoma", "stomata"],
        ["dogma", "dogmata"],
        ["lemma", "lemmata"],
        ["schema", "schemata"],
        ["anathema", "anathemata"],
        // Other irregular rules.
        ["ox", "oxen"],
        ["axe", "axes"],
        ["die", "dice"],
        ["yes", "yeses"],
        ["foot", "feet"],
        ["eave", "eaves"],
        ["goose", "geese"],
        ["tooth", "teeth"],
        ["quiz", "quizzes"],
        ["human", "humans"],
        ["proof", "proofs"],
        ["carve", "carves"],
        ["valve", "valves"],
        ["looey", "looies"],
        ["thief", "thieves"],
        ["groove", "grooves"],
        ["pickaxe", "pickaxes"],
        ["passerby", "passersby"]
      ].forEach(function(rule) {
        return pluralize.addIrregularRule(rule[0], rule[1]);
      });
      [
        [/s?$/i, "s"],
        [/[^\u0000-\u007F]$/i, "$0"],
        [/([^aeiou]ese)$/i, "$1"],
        [/(ax|test)is$/i, "$1es"],
        [/(alias|[^aou]us|t[lm]as|gas|ris)$/i, "$1es"],
        [/(e[mn]u)s?$/i, "$1s"],
        [/([^l]ias|[aeiou]las|[ejzr]as|[iu]am)$/i, "$1"],
        [/(alumn|syllab|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i, "$1i"],
        [/(alumn|alg|vertebr)(?:a|ae)$/i, "$1ae"],
        [/(seraph|cherub)(?:im)?$/i, "$1im"],
        [/(her|at|gr)o$/i, "$1oes"],
        [/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|automat|quor)(?:a|um)$/i, "$1a"],
        [/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)(?:a|on)$/i, "$1a"],
        [/sis$/i, "ses"],
        [/(?:(kni|wi|li)fe|(ar|l|ea|eo|oa|hoo)f)$/i, "$1$2ves"],
        [/([^aeiouy]|qu)y$/i, "$1ies"],
        [/([^ch][ieo][ln])ey$/i, "$1ies"],
        [/(x|ch|ss|sh|zz)$/i, "$1es"],
        [/(matr|cod|mur|sil|vert|ind|append)(?:ix|ex)$/i, "$1ices"],
        [/\b((?:tit)?m|l)(?:ice|ouse)$/i, "$1ice"],
        [/(pe)(?:rson|ople)$/i, "$1ople"],
        [/(child)(?:ren)?$/i, "$1ren"],
        [/eaux$/i, "$0"],
        [/m[ae]n$/i, "men"],
        ["thou", "you"]
      ].forEach(function(rule) {
        return pluralize.addPluralRule(rule[0], rule[1]);
      });
      [
        [/s$/i, ""],
        [/(ss)$/i, "$1"],
        [/(wi|kni|(?:after|half|high|low|mid|non|night|[^\w]|^)li)ves$/i, "$1fe"],
        [/(ar|(?:wo|[ae])l|[eo][ao])ves$/i, "$1f"],
        [/ies$/i, "y"],
        [/\b([pl]|zomb|(?:neck|cross)?t|coll|faer|food|gen|goon|group|lass|talk|goal|cut)ies$/i, "$1ie"],
        [/\b(mon|smil)ies$/i, "$1ey"],
        [/\b((?:tit)?m|l)ice$/i, "$1ouse"],
        [/(seraph|cherub)im$/i, "$1"],
        [/(x|ch|ss|sh|zz|tto|go|cho|alias|[^aou]us|t[lm]as|gas|(?:her|at|gr)o|[aeiou]ris)(?:es)?$/i, "$1"],
        [/(analy|diagno|parenthe|progno|synop|the|empha|cri|ne)(?:sis|ses)$/i, "$1sis"],
        [/(movie|twelve|abuse|e[mn]u)s$/i, "$1"],
        [/(test)(?:is|es)$/i, "$1is"],
        [/(alumn|syllab|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i, "$1us"],
        [/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|quor)a$/i, "$1um"],
        [/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)a$/i, "$1on"],
        [/(alumn|alg|vertebr)ae$/i, "$1a"],
        [/(cod|mur|sil|vert|ind)ices$/i, "$1ex"],
        [/(matr|append)ices$/i, "$1ix"],
        [/(pe)(rson|ople)$/i, "$1rson"],
        [/(child)ren$/i, "$1"],
        [/(eau)x?$/i, "$1"],
        [/men$/i, "man"]
      ].forEach(function(rule) {
        return pluralize.addSingularRule(rule[0], rule[1]);
      });
      [
        // Singular words with no plurals.
        "adulthood",
        "advice",
        "agenda",
        "aid",
        "aircraft",
        "alcohol",
        "ammo",
        "analytics",
        "anime",
        "athletics",
        "audio",
        "bison",
        "blood",
        "bream",
        "buffalo",
        "butter",
        "carp",
        "cash",
        "chassis",
        "chess",
        "clothing",
        "cod",
        "commerce",
        "cooperation",
        "corps",
        "debris",
        "diabetes",
        "digestion",
        "elk",
        "energy",
        "equipment",
        "excretion",
        "expertise",
        "firmware",
        "flounder",
        "fun",
        "gallows",
        "garbage",
        "graffiti",
        "hardware",
        "headquarters",
        "health",
        "herpes",
        "highjinks",
        "homework",
        "housework",
        "information",
        "jeans",
        "justice",
        "kudos",
        "labour",
        "literature",
        "machinery",
        "mackerel",
        "mail",
        "media",
        "mews",
        "moose",
        "music",
        "mud",
        "manga",
        "news",
        "only",
        "personnel",
        "pike",
        "plankton",
        "pliers",
        "police",
        "pollution",
        "premises",
        "rain",
        "research",
        "rice",
        "salmon",
        "scissors",
        "series",
        "sewage",
        "shambles",
        "shrimp",
        "software",
        "species",
        "staff",
        "swine",
        "tennis",
        "traffic",
        "transportation",
        "trout",
        "tuna",
        "wealth",
        "welfare",
        "whiting",
        "wildebeest",
        "wildlife",
        "you",
        /pok[eé]mon$/i,
        // Regexes.
        /[^aeiou]ese$/i,
        // "chinese", "japanese"
        /deer$/i,
        // "deer", "reindeer"
        /fish$/i,
        // "fish", "blowfish", "angelfish"
        /measles$/i,
        /o[iu]s$/i,
        // "carnivorous"
        /pox$/i,
        // "chickpox", "smallpox"
        /sheep$/i
      ].forEach(pluralize.addUncountableRule);
      return pluralize;
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/common.js
var require_common = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/common.js"(exports2, module2) {
    "use strict";
    function isNothing2(subject) {
      return typeof subject === "undefined" || subject === null;
    }
    function isObject3(subject) {
      return typeof subject === "object" && subject !== null;
    }
    function toArray2(sequence) {
      if (Array.isArray(sequence)) return sequence;
      else if (isNothing2(sequence)) return [];
      return [sequence];
    }
    function extend3(target, source) {
      var index, length, key, sourceKeys;
      if (source) {
        sourceKeys = Object.keys(source);
        for (index = 0, length = sourceKeys.length; index < length; index += 1) {
          key = sourceKeys[index];
          target[key] = source[key];
        }
      }
      return target;
    }
    function repeat2(string3, count) {
      var result = "", cycle;
      for (cycle = 0; cycle < count; cycle += 1) {
        result += string3;
      }
      return result;
    }
    function isNegativeZero2(number3) {
      return number3 === 0 && Number.NEGATIVE_INFINITY === 1 / number3;
    }
    module2.exports.isNothing = isNothing2;
    module2.exports.isObject = isObject3;
    module2.exports.toArray = toArray2;
    module2.exports.repeat = repeat2;
    module2.exports.isNegativeZero = isNegativeZero2;
    module2.exports.extend = extend3;
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/exception.js
var require_exception = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/exception.js"(exports2, module2) {
    "use strict";
    function formatError2(exception2, compact2) {
      var where = "", message = exception2.reason || "(unknown reason)";
      if (!exception2.mark) return message;
      if (exception2.mark.name) {
        where += 'in "' + exception2.mark.name + '" ';
      }
      where += "(" + (exception2.mark.line + 1) + ":" + (exception2.mark.column + 1) + ")";
      if (!compact2 && exception2.mark.snippet) {
        where += "\n\n" + exception2.mark.snippet;
      }
      return message + " " + where;
    }
    function YAMLException2(reason, mark) {
      Error.call(this);
      this.name = "YAMLException";
      this.reason = reason;
      this.mark = mark;
      this.message = formatError2(this, false);
      if (Error.captureStackTrace) {
        Error.captureStackTrace(this, this.constructor);
      } else {
        this.stack = new Error().stack || "";
      }
    }
    YAMLException2.prototype = Object.create(Error.prototype);
    YAMLException2.prototype.constructor = YAMLException2;
    YAMLException2.prototype.toString = function toString4(compact2) {
      return this.name + ": " + formatError2(this, compact2);
    };
    module2.exports = YAMLException2;
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/snippet.js
var require_snippet = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/snippet.js"(exports2, module2) {
    "use strict";
    var common2 = require_common();
    function getLine2(buffer, lineStart, lineEnd, position, maxLineLength) {
      var head = "";
      var tail = "";
      var maxHalfLength = Math.floor(maxLineLength / 2) - 1;
      if (position - lineStart > maxHalfLength) {
        head = " ... ";
        lineStart = position - maxHalfLength + head.length;
      }
      if (lineEnd - position > maxHalfLength) {
        tail = " ...";
        lineEnd = position + maxHalfLength - tail.length;
      }
      return {
        str: head + buffer.slice(lineStart, lineEnd).replace(/\t/g, "\u2192") + tail,
        pos: position - lineStart + head.length
        // relative position
      };
    }
    function padStart2(string3, max) {
      return common2.repeat(" ", max - string3.length) + string3;
    }
    function makeSnippet2(mark, options) {
      options = Object.create(options || null);
      if (!mark.buffer) return null;
      if (!options.maxLength) options.maxLength = 79;
      if (typeof options.indent !== "number") options.indent = 1;
      if (typeof options.linesBefore !== "number") options.linesBefore = 3;
      if (typeof options.linesAfter !== "number") options.linesAfter = 2;
      var re = /\r?\n|\r|\0/g;
      var lineStarts = [0];
      var lineEnds = [];
      var match;
      var foundLineNo = -1;
      while (match = re.exec(mark.buffer)) {
        lineEnds.push(match.index);
        lineStarts.push(match.index + match[0].length);
        if (mark.position <= match.index && foundLineNo < 0) {
          foundLineNo = lineStarts.length - 2;
        }
      }
      if (foundLineNo < 0) foundLineNo = lineStarts.length - 1;
      var result = "", i, line;
      var lineNoLength = Math.min(mark.line + options.linesAfter, lineEnds.length).toString().length;
      var maxLineLength = options.maxLength - (options.indent + lineNoLength + 3);
      for (i = 1; i <= options.linesBefore; i++) {
        if (foundLineNo - i < 0) break;
        line = getLine2(
          mark.buffer,
          lineStarts[foundLineNo - i],
          lineEnds[foundLineNo - i],
          mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo - i]),
          maxLineLength
        );
        result = common2.repeat(" ", options.indent) + padStart2((mark.line - i + 1).toString(), lineNoLength) + " | " + line.str + "\n" + result;
      }
      line = getLine2(mark.buffer, lineStarts[foundLineNo], lineEnds[foundLineNo], mark.position, maxLineLength);
      result += common2.repeat(" ", options.indent) + padStart2((mark.line + 1).toString(), lineNoLength) + " | " + line.str + "\n";
      result += common2.repeat("-", options.indent + lineNoLength + 3 + line.pos) + "^\n";
      for (i = 1; i <= options.linesAfter; i++) {
        if (foundLineNo + i >= lineEnds.length) break;
        line = getLine2(
          mark.buffer,
          lineStarts[foundLineNo + i],
          lineEnds[foundLineNo + i],
          mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo + i]),
          maxLineLength
        );
        result += common2.repeat(" ", options.indent) + padStart2((mark.line + i + 1).toString(), lineNoLength) + " | " + line.str + "\n";
      }
      return result.replace(/\n$/, "");
    }
    module2.exports = makeSnippet2;
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type.js
var require_type = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type.js"(exports2, module2) {
    "use strict";
    var YAMLException2 = require_exception();
    var TYPE_CONSTRUCTOR_OPTIONS2 = [
      "kind",
      "multi",
      "resolve",
      "construct",
      "instanceOf",
      "predicate",
      "represent",
      "representName",
      "defaultStyle",
      "styleAliases"
    ];
    var YAML_NODE_KINDS2 = [
      "scalar",
      "sequence",
      "mapping"
    ];
    function compileStyleAliases2(map2) {
      var result = {};
      if (map2 !== null) {
        Object.keys(map2).forEach(function(style) {
          map2[style].forEach(function(alias) {
            result[String(alias)] = style;
          });
        });
      }
      return result;
    }
    function Type3(tag, options) {
      options = options || {};
      Object.keys(options).forEach(function(name) {
        if (TYPE_CONSTRUCTOR_OPTIONS2.indexOf(name) === -1) {
          throw new YAMLException2('Unknown option "' + name + '" is met in definition of "' + tag + '" YAML type.');
        }
      });
      this.options = options;
      this.tag = tag;
      this.kind = options["kind"] || null;
      this.resolve = options["resolve"] || function() {
        return true;
      };
      this.construct = options["construct"] || function(data) {
        return data;
      };
      this.instanceOf = options["instanceOf"] || null;
      this.predicate = options["predicate"] || null;
      this.represent = options["represent"] || null;
      this.representName = options["representName"] || null;
      this.defaultStyle = options["defaultStyle"] || null;
      this.multi = options["multi"] || false;
      this.styleAliases = compileStyleAliases2(options["styleAliases"] || null);
      if (YAML_NODE_KINDS2.indexOf(this.kind) === -1) {
        throw new YAMLException2('Unknown kind "' + this.kind + '" is specified for "' + tag + '" YAML type.');
      }
    }
    module2.exports = Type3;
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema.js
var require_schema4 = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema.js"(exports2, module2) {
    "use strict";
    var YAMLException2 = require_exception();
    var Type3 = require_type();
    function compileList2(schema2, name) {
      var result = [];
      schema2[name].forEach(function(currentType) {
        var newIndex = result.length;
        result.forEach(function(previousType, previousIndex) {
          if (previousType.tag === currentType.tag && previousType.kind === currentType.kind && previousType.multi === currentType.multi) {
            newIndex = previousIndex;
          }
        });
        result[newIndex] = currentType;
      });
      return result;
    }
    function compileMap2() {
      var result = {
        scalar: {},
        sequence: {},
        mapping: {},
        fallback: {},
        multi: {
          scalar: [],
          sequence: [],
          mapping: [],
          fallback: []
        }
      }, index, length;
      function collectType(type2) {
        if (type2.multi) {
          result.multi[type2.kind].push(type2);
          result.multi["fallback"].push(type2);
        } else {
          result[type2.kind][type2.tag] = result["fallback"][type2.tag] = type2;
        }
      }
      for (index = 0, length = arguments.length; index < length; index += 1) {
        arguments[index].forEach(collectType);
      }
      return result;
    }
    function Schema3(definition) {
      return this.extend(definition);
    }
    Schema3.prototype.extend = function extend3(definition) {
      var implicit = [];
      var explicit = [];
      if (definition instanceof Type3) {
        explicit.push(definition);
      } else if (Array.isArray(definition)) {
        explicit = explicit.concat(definition);
      } else if (definition && (Array.isArray(definition.implicit) || Array.isArray(definition.explicit))) {
        if (definition.implicit) implicit = implicit.concat(definition.implicit);
        if (definition.explicit) explicit = explicit.concat(definition.explicit);
      } else {
        throw new YAMLException2("Schema.extend argument should be a Type, [ Type ], or a schema definition ({ implicit: [...], explicit: [...] })");
      }
      implicit.forEach(function(type2) {
        if (!(type2 instanceof Type3)) {
          throw new YAMLException2("Specified list of YAML types (or a single Type object) contains a non-Type object.");
        }
        if (type2.loadKind && type2.loadKind !== "scalar") {
          throw new YAMLException2("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.");
        }
        if (type2.multi) {
          throw new YAMLException2("There is a multi type in the implicit list of a schema. Multi tags can only be listed as explicit.");
        }
      });
      explicit.forEach(function(type2) {
        if (!(type2 instanceof Type3)) {
          throw new YAMLException2("Specified list of YAML types (or a single Type object) contains a non-Type object.");
        }
      });
      var result = Object.create(Schema3.prototype);
      result.implicit = (this.implicit || []).concat(implicit);
      result.explicit = (this.explicit || []).concat(explicit);
      result.compiledImplicit = compileList2(result, "implicit");
      result.compiledExplicit = compileList2(result, "explicit");
      result.compiledTypeMap = compileMap2(result.compiledImplicit, result.compiledExplicit);
      return result;
    };
    module2.exports = Schema3;
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/str.js
var require_str = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/str.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    module2.exports = new Type3("tag:yaml.org,2002:str", {
      kind: "scalar",
      construct: function(data) {
        return data !== null ? data : "";
      }
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/seq.js
var require_seq2 = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/seq.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    module2.exports = new Type3("tag:yaml.org,2002:seq", {
      kind: "sequence",
      construct: function(data) {
        return data !== null ? data : [];
      }
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/map.js
var require_map2 = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/map.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    module2.exports = new Type3("tag:yaml.org,2002:map", {
      kind: "mapping",
      construct: function(data) {
        return data !== null ? data : {};
      }
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/failsafe.js
var require_failsafe = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/failsafe.js"(exports2, module2) {
    "use strict";
    var Schema3 = require_schema4();
    module2.exports = new Schema3({
      explicit: [
        require_str(),
        require_seq2(),
        require_map2()
      ]
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/null.js
var require_null2 = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/null.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    function resolveYamlNull2(data) {
      if (data === null) return true;
      var max = data.length;
      return max === 1 && data === "~" || max === 4 && (data === "null" || data === "Null" || data === "NULL");
    }
    function constructYamlNull2() {
      return null;
    }
    function isNull3(object3) {
      return object3 === null;
    }
    module2.exports = new Type3("tag:yaml.org,2002:null", {
      kind: "scalar",
      resolve: resolveYamlNull2,
      construct: constructYamlNull2,
      predicate: isNull3,
      represent: {
        canonical: function() {
          return "~";
        },
        lowercase: function() {
          return "null";
        },
        uppercase: function() {
          return "NULL";
        },
        camelcase: function() {
          return "Null";
        },
        empty: function() {
          return "";
        }
      },
      defaultStyle: "lowercase"
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/bool.js
var require_bool3 = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/bool.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    function resolveYamlBoolean2(data) {
      if (data === null) return false;
      var max = data.length;
      return max === 4 && (data === "true" || data === "True" || data === "TRUE") || max === 5 && (data === "false" || data === "False" || data === "FALSE");
    }
    function constructYamlBoolean2(data) {
      return data === "true" || data === "True" || data === "TRUE";
    }
    function isBoolean2(object3) {
      return Object.prototype.toString.call(object3) === "[object Boolean]";
    }
    module2.exports = new Type3("tag:yaml.org,2002:bool", {
      kind: "scalar",
      resolve: resolveYamlBoolean2,
      construct: constructYamlBoolean2,
      predicate: isBoolean2,
      represent: {
        lowercase: function(object3) {
          return object3 ? "true" : "false";
        },
        uppercase: function(object3) {
          return object3 ? "TRUE" : "FALSE";
        },
        camelcase: function(object3) {
          return object3 ? "True" : "False";
        }
      },
      defaultStyle: "lowercase"
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/int.js
var require_int3 = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/int.js"(exports2, module2) {
    "use strict";
    var common2 = require_common();
    var Type3 = require_type();
    function isHexCode2(c) {
      return 48 <= c && c <= 57 || 65 <= c && c <= 70 || 97 <= c && c <= 102;
    }
    function isOctCode2(c) {
      return 48 <= c && c <= 55;
    }
    function isDecCode2(c) {
      return 48 <= c && c <= 57;
    }
    function resolveYamlInteger2(data) {
      if (data === null) return false;
      var max = data.length, index = 0, hasDigits = false, ch;
      if (!max) return false;
      ch = data[index];
      if (ch === "-" || ch === "+") {
        ch = data[++index];
      }
      if (ch === "0") {
        if (index + 1 === max) return true;
        ch = data[++index];
        if (ch === "b") {
          index++;
          for (; index < max; index++) {
            ch = data[index];
            if (ch === "_") continue;
            if (ch !== "0" && ch !== "1") return false;
            hasDigits = true;
          }
          return hasDigits && ch !== "_";
        }
        if (ch === "x") {
          index++;
          for (; index < max; index++) {
            ch = data[index];
            if (ch === "_") continue;
            if (!isHexCode2(data.charCodeAt(index))) return false;
            hasDigits = true;
          }
          return hasDigits && ch !== "_";
        }
        if (ch === "o") {
          index++;
          for (; index < max; index++) {
            ch = data[index];
            if (ch === "_") continue;
            if (!isOctCode2(data.charCodeAt(index))) return false;
            hasDigits = true;
          }
          return hasDigits && ch !== "_";
        }
      }
      if (ch === "_") return false;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_") continue;
        if (!isDecCode2(data.charCodeAt(index))) {
          return false;
        }
        hasDigits = true;
      }
      if (!hasDigits || ch === "_") return false;
      return true;
    }
    function constructYamlInteger2(data) {
      var value = data, sign = 1, ch;
      if (value.indexOf("_") !== -1) {
        value = value.replace(/_/g, "");
      }
      ch = value[0];
      if (ch === "-" || ch === "+") {
        if (ch === "-") sign = -1;
        value = value.slice(1);
        ch = value[0];
      }
      if (value === "0") return 0;
      if (ch === "0") {
        if (value[1] === "b") return sign * parseInt(value.slice(2), 2);
        if (value[1] === "x") return sign * parseInt(value.slice(2), 16);
        if (value[1] === "o") return sign * parseInt(value.slice(2), 8);
      }
      return sign * parseInt(value, 10);
    }
    function isInteger2(object3) {
      return Object.prototype.toString.call(object3) === "[object Number]" && (object3 % 1 === 0 && !common2.isNegativeZero(object3));
    }
    module2.exports = new Type3("tag:yaml.org,2002:int", {
      kind: "scalar",
      resolve: resolveYamlInteger2,
      construct: constructYamlInteger2,
      predicate: isInteger2,
      represent: {
        binary: function(obj) {
          return obj >= 0 ? "0b" + obj.toString(2) : "-0b" + obj.toString(2).slice(1);
        },
        octal: function(obj) {
          return obj >= 0 ? "0o" + obj.toString(8) : "-0o" + obj.toString(8).slice(1);
        },
        decimal: function(obj) {
          return obj.toString(10);
        },
        /* eslint-disable max-len */
        hexadecimal: function(obj) {
          return obj >= 0 ? "0x" + obj.toString(16).toUpperCase() : "-0x" + obj.toString(16).toUpperCase().slice(1);
        }
      },
      defaultStyle: "decimal",
      styleAliases: {
        binary: [2, "bin"],
        octal: [8, "oct"],
        decimal: [10, "dec"],
        hexadecimal: [16, "hex"]
      }
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/float.js
var require_float3 = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/float.js"(exports2, module2) {
    "use strict";
    var common2 = require_common();
    var Type3 = require_type();
    var YAML_FLOAT_PATTERN2 = new RegExp(
      // 2.5e4, 2.5 and integers
      "^(?:[-+]?(?:[0-9][0-9_]*)(?:\\.[0-9_]*)?(?:[eE][-+]?[0-9]+)?|\\.[0-9_]+(?:[eE][-+]?[0-9]+)?|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$"
    );
    function resolveYamlFloat2(data) {
      if (data === null) return false;
      if (!YAML_FLOAT_PATTERN2.test(data) || // Quick hack to not allow integers end with `_`
      // Probably should update regexp & check speed
      data[data.length - 1] === "_") {
        return false;
      }
      return true;
    }
    function constructYamlFloat2(data) {
      var value, sign;
      value = data.replace(/_/g, "").toLowerCase();
      sign = value[0] === "-" ? -1 : 1;
      if ("+-".indexOf(value[0]) >= 0) {
        value = value.slice(1);
      }
      if (value === ".inf") {
        return sign === 1 ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY;
      } else if (value === ".nan") {
        return NaN;
      }
      return sign * parseFloat(value, 10);
    }
    var SCIENTIFIC_WITHOUT_DOT2 = /^[-+]?[0-9]+e/;
    function representYamlFloat2(object3, style) {
      var res;
      if (isNaN(object3)) {
        switch (style) {
          case "lowercase":
            return ".nan";
          case "uppercase":
            return ".NAN";
          case "camelcase":
            return ".NaN";
        }
      } else if (Number.POSITIVE_INFINITY === object3) {
        switch (style) {
          case "lowercase":
            return ".inf";
          case "uppercase":
            return ".INF";
          case "camelcase":
            return ".Inf";
        }
      } else if (Number.NEGATIVE_INFINITY === object3) {
        switch (style) {
          case "lowercase":
            return "-.inf";
          case "uppercase":
            return "-.INF";
          case "camelcase":
            return "-.Inf";
        }
      } else if (common2.isNegativeZero(object3)) {
        return "-0.0";
      }
      res = object3.toString(10);
      return SCIENTIFIC_WITHOUT_DOT2.test(res) ? res.replace("e", ".e") : res;
    }
    function isFloat2(object3) {
      return Object.prototype.toString.call(object3) === "[object Number]" && (object3 % 1 !== 0 || common2.isNegativeZero(object3));
    }
    module2.exports = new Type3("tag:yaml.org,2002:float", {
      kind: "scalar",
      resolve: resolveYamlFloat2,
      construct: constructYamlFloat2,
      predicate: isFloat2,
      represent: representYamlFloat2,
      defaultStyle: "lowercase"
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/json.js
var require_json = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/json.js"(exports2, module2) {
    "use strict";
    module2.exports = require_failsafe().extend({
      implicit: [
        require_null2(),
        require_bool3(),
        require_int3(),
        require_float3()
      ]
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/core.js
var require_core = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/core.js"(exports2, module2) {
    "use strict";
    module2.exports = require_json();
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/timestamp.js
var require_timestamp2 = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/timestamp.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    var YAML_DATE_REGEXP2 = new RegExp(
      "^([0-9][0-9][0-9][0-9])-([0-9][0-9])-([0-9][0-9])$"
    );
    var YAML_TIMESTAMP_REGEXP2 = new RegExp(
      "^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?$"
    );
    function resolveYamlTimestamp2(data) {
      if (data === null) return false;
      if (YAML_DATE_REGEXP2.exec(data) !== null) return true;
      if (YAML_TIMESTAMP_REGEXP2.exec(data) !== null) return true;
      return false;
    }
    function constructYamlTimestamp2(data) {
      var match, year, month, day, hour, minute, second, fraction = 0, delta = null, tz_hour, tz_minute, date3;
      match = YAML_DATE_REGEXP2.exec(data);
      if (match === null) match = YAML_TIMESTAMP_REGEXP2.exec(data);
      if (match === null) throw new Error("Date resolve error");
      year = +match[1];
      month = +match[2] - 1;
      day = +match[3];
      if (!match[4]) {
        return new Date(Date.UTC(year, month, day));
      }
      hour = +match[4];
      minute = +match[5];
      second = +match[6];
      if (match[7]) {
        fraction = match[7].slice(0, 3);
        while (fraction.length < 3) {
          fraction += "0";
        }
        fraction = +fraction;
      }
      if (match[9]) {
        tz_hour = +match[10];
        tz_minute = +(match[11] || 0);
        delta = (tz_hour * 60 + tz_minute) * 6e4;
        if (match[9] === "-") delta = -delta;
      }
      date3 = new Date(Date.UTC(year, month, day, hour, minute, second, fraction));
      if (delta) date3.setTime(date3.getTime() - delta);
      return date3;
    }
    function representYamlTimestamp2(object3) {
      return object3.toISOString();
    }
    module2.exports = new Type3("tag:yaml.org,2002:timestamp", {
      kind: "scalar",
      resolve: resolveYamlTimestamp2,
      construct: constructYamlTimestamp2,
      instanceOf: Date,
      represent: representYamlTimestamp2
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/merge.js
var require_merge = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/merge.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    function resolveYamlMerge2(data) {
      return data === "<<" || data === null;
    }
    module2.exports = new Type3("tag:yaml.org,2002:merge", {
      kind: "scalar",
      resolve: resolveYamlMerge2
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/binary.js
var require_binary2 = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/binary.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    var BASE64_MAP2 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r";
    function resolveYamlBinary2(data) {
      if (data === null) return false;
      var code, idx, bitlen = 0, max = data.length, map2 = BASE64_MAP2;
      for (idx = 0; idx < max; idx++) {
        code = map2.indexOf(data.charAt(idx));
        if (code > 64) continue;
        if (code < 0) return false;
        bitlen += 6;
      }
      return bitlen % 8 === 0;
    }
    function constructYamlBinary2(data) {
      var idx, tailbits, input = data.replace(/[\r\n=]/g, ""), max = input.length, map2 = BASE64_MAP2, bits = 0, result = [];
      for (idx = 0; idx < max; idx++) {
        if (idx % 4 === 0 && idx) {
          result.push(bits >> 16 & 255);
          result.push(bits >> 8 & 255);
          result.push(bits & 255);
        }
        bits = bits << 6 | map2.indexOf(input.charAt(idx));
      }
      tailbits = max % 4 * 6;
      if (tailbits === 0) {
        result.push(bits >> 16 & 255);
        result.push(bits >> 8 & 255);
        result.push(bits & 255);
      } else if (tailbits === 18) {
        result.push(bits >> 10 & 255);
        result.push(bits >> 2 & 255);
      } else if (tailbits === 12) {
        result.push(bits >> 4 & 255);
      }
      return new Uint8Array(result);
    }
    function representYamlBinary2(object3) {
      var result = "", bits = 0, idx, tail, max = object3.length, map2 = BASE64_MAP2;
      for (idx = 0; idx < max; idx++) {
        if (idx % 3 === 0 && idx) {
          result += map2[bits >> 18 & 63];
          result += map2[bits >> 12 & 63];
          result += map2[bits >> 6 & 63];
          result += map2[bits & 63];
        }
        bits = (bits << 8) + object3[idx];
      }
      tail = max % 3;
      if (tail === 0) {
        result += map2[bits >> 18 & 63];
        result += map2[bits >> 12 & 63];
        result += map2[bits >> 6 & 63];
        result += map2[bits & 63];
      } else if (tail === 2) {
        result += map2[bits >> 10 & 63];
        result += map2[bits >> 4 & 63];
        result += map2[bits << 2 & 63];
        result += map2[64];
      } else if (tail === 1) {
        result += map2[bits >> 2 & 63];
        result += map2[bits << 4 & 63];
        result += map2[64];
        result += map2[64];
      }
      return result;
    }
    function isBinary2(obj) {
      return Object.prototype.toString.call(obj) === "[object Uint8Array]";
    }
    module2.exports = new Type3("tag:yaml.org,2002:binary", {
      kind: "scalar",
      resolve: resolveYamlBinary2,
      construct: constructYamlBinary2,
      predicate: isBinary2,
      represent: representYamlBinary2
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/omap.js
var require_omap2 = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/omap.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    var _hasOwnProperty2 = Object.prototype.hasOwnProperty;
    var _toString2 = Object.prototype.toString;
    function resolveYamlOmap2(data) {
      if (data === null) return true;
      var objectKeys = [], index, length, pair, pairKey, pairHasKey, object3 = data;
      for (index = 0, length = object3.length; index < length; index += 1) {
        pair = object3[index];
        pairHasKey = false;
        if (_toString2.call(pair) !== "[object Object]") return false;
        for (pairKey in pair) {
          if (_hasOwnProperty2.call(pair, pairKey)) {
            if (!pairHasKey) pairHasKey = true;
            else return false;
          }
        }
        if (!pairHasKey) return false;
        if (objectKeys.indexOf(pairKey) === -1) objectKeys.push(pairKey);
        else return false;
      }
      return true;
    }
    function constructYamlOmap2(data) {
      return data !== null ? data : [];
    }
    module2.exports = new Type3("tag:yaml.org,2002:omap", {
      kind: "sequence",
      resolve: resolveYamlOmap2,
      construct: constructYamlOmap2
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/pairs.js
var require_pairs2 = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/pairs.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    var _toString2 = Object.prototype.toString;
    function resolveYamlPairs2(data) {
      if (data === null) return true;
      var index, length, pair, keys5, result, object3 = data;
      result = new Array(object3.length);
      for (index = 0, length = object3.length; index < length; index += 1) {
        pair = object3[index];
        if (_toString2.call(pair) !== "[object Object]") return false;
        keys5 = Object.keys(pair);
        if (keys5.length !== 1) return false;
        result[index] = [keys5[0], pair[keys5[0]]];
      }
      return true;
    }
    function constructYamlPairs2(data) {
      if (data === null) return [];
      var index, length, pair, keys5, result, object3 = data;
      result = new Array(object3.length);
      for (index = 0, length = object3.length; index < length; index += 1) {
        pair = object3[index];
        keys5 = Object.keys(pair);
        result[index] = [keys5[0], pair[keys5[0]]];
      }
      return result;
    }
    module2.exports = new Type3("tag:yaml.org,2002:pairs", {
      kind: "sequence",
      resolve: resolveYamlPairs2,
      construct: constructYamlPairs2
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/set.js
var require_set2 = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/set.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    var _hasOwnProperty2 = Object.prototype.hasOwnProperty;
    function resolveYamlSet2(data) {
      if (data === null) return true;
      var key, object3 = data;
      for (key in object3) {
        if (_hasOwnProperty2.call(object3, key)) {
          if (object3[key] !== null) return false;
        }
      }
      return true;
    }
    function constructYamlSet2(data) {
      return data !== null ? data : {};
    }
    module2.exports = new Type3("tag:yaml.org,2002:set", {
      kind: "mapping",
      resolve: resolveYamlSet2,
      construct: constructYamlSet2
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/default.js
var require_default = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/default.js"(exports2, module2) {
    "use strict";
    module2.exports = require_core().extend({
      implicit: [
        require_timestamp2(),
        require_merge()
      ],
      explicit: [
        require_binary2(),
        require_omap2(),
        require_pairs2(),
        require_set2()
      ]
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/loader.js
var require_loader = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/loader.js"(exports2, module2) {
    "use strict";
    var common2 = require_common();
    var YAMLException2 = require_exception();
    var makeSnippet2 = require_snippet();
    var DEFAULT_SCHEMA2 = require_default();
    var _hasOwnProperty2 = Object.prototype.hasOwnProperty;
    var CONTEXT_FLOW_IN2 = 1;
    var CONTEXT_FLOW_OUT2 = 2;
    var CONTEXT_BLOCK_IN2 = 3;
    var CONTEXT_BLOCK_OUT2 = 4;
    var CHOMPING_CLIP2 = 1;
    var CHOMPING_STRIP2 = 2;
    var CHOMPING_KEEP2 = 3;
    var PATTERN_NON_PRINTABLE2 = /[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;
    var PATTERN_NON_ASCII_LINE_BREAKS2 = /[\x85\u2028\u2029]/;
    var PATTERN_FLOW_INDICATORS2 = /[,\[\]\{\}]/;
    var PATTERN_TAG_HANDLE2 = /^(?:!|!!|![a-z\-]+!)$/i;
    var PATTERN_TAG_URI2 = /^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i;
    function _class2(obj) {
      return Object.prototype.toString.call(obj);
    }
    function is_EOL2(c) {
      return c === 10 || c === 13;
    }
    function is_WHITE_SPACE2(c) {
      return c === 9 || c === 32;
    }
    function is_WS_OR_EOL2(c) {
      return c === 9 || c === 32 || c === 10 || c === 13;
    }
    function is_FLOW_INDICATOR2(c) {
      return c === 44 || c === 91 || c === 93 || c === 123 || c === 125;
    }
    function fromHexCode2(c) {
      var lc;
      if (48 <= c && c <= 57) {
        return c - 48;
      }
      lc = c | 32;
      if (97 <= lc && lc <= 102) {
        return lc - 97 + 10;
      }
      return -1;
    }
    function escapedHexLen2(c) {
      if (c === 120) {
        return 2;
      }
      if (c === 117) {
        return 4;
      }
      if (c === 85) {
        return 8;
      }
      return 0;
    }
    function fromDecimalCode2(c) {
      if (48 <= c && c <= 57) {
        return c - 48;
      }
      return -1;
    }
    function simpleEscapeSequence2(c) {
      return c === 48 ? "\0" : c === 97 ? "\x07" : c === 98 ? "\b" : c === 116 ? "	" : c === 9 ? "	" : c === 110 ? "\n" : c === 118 ? "\v" : c === 102 ? "\f" : c === 114 ? "\r" : c === 101 ? "\x1B" : c === 32 ? " " : c === 34 ? '"' : c === 47 ? "/" : c === 92 ? "\\" : c === 78 ? "\x85" : c === 95 ? "\xA0" : c === 76 ? "\u2028" : c === 80 ? "\u2029" : "";
    }
    function charFromCodepoint2(c) {
      if (c <= 65535) {
        return String.fromCharCode(c);
      }
      return String.fromCharCode(
        (c - 65536 >> 10) + 55296,
        (c - 65536 & 1023) + 56320
      );
    }
    var simpleEscapeCheck2 = new Array(256);
    var simpleEscapeMap2 = new Array(256);
    for (i = 0; i < 256; i++) {
      simpleEscapeCheck2[i] = simpleEscapeSequence2(i) ? 1 : 0;
      simpleEscapeMap2[i] = simpleEscapeSequence2(i);
    }
    var i;
    function State3(input, options) {
      this.input = input;
      this.filename = options["filename"] || null;
      this.schema = options["schema"] || DEFAULT_SCHEMA2;
      this.onWarning = options["onWarning"] || null;
      this.legacy = options["legacy"] || false;
      this.json = options["json"] || false;
      this.listener = options["listener"] || null;
      this.implicitTypes = this.schema.compiledImplicit;
      this.typeMap = this.schema.compiledTypeMap;
      this.length = input.length;
      this.position = 0;
      this.line = 0;
      this.lineStart = 0;
      this.lineIndent = 0;
      this.firstTabInLine = -1;
      this.documents = [];
    }
    function generateError2(state, message) {
      var mark = {
        name: state.filename,
        buffer: state.input.slice(0, -1),
        // omit trailing \0
        position: state.position,
        line: state.line,
        column: state.position - state.lineStart
      };
      mark.snippet = makeSnippet2(mark);
      return new YAMLException2(message, mark);
    }
    function throwError2(state, message) {
      throw generateError2(state, message);
    }
    function throwWarning2(state, message) {
      if (state.onWarning) {
        state.onWarning.call(null, generateError2(state, message));
      }
    }
    var directiveHandlers2 = {
      YAML: function handleYamlDirective2(state, name, args) {
        var match, major, minor;
        if (state.version !== null) {
          throwError2(state, "duplication of %YAML directive");
        }
        if (args.length !== 1) {
          throwError2(state, "YAML directive accepts exactly one argument");
        }
        match = /^([0-9]+)\.([0-9]+)$/.exec(args[0]);
        if (match === null) {
          throwError2(state, "ill-formed argument of the YAML directive");
        }
        major = parseInt(match[1], 10);
        minor = parseInt(match[2], 10);
        if (major !== 1) {
          throwError2(state, "unacceptable YAML version of the document");
        }
        state.version = args[0];
        state.checkLineBreaks = minor < 2;
        if (minor !== 1 && minor !== 2) {
          throwWarning2(state, "unsupported YAML version of the document");
        }
      },
      TAG: function handleTagDirective2(state, name, args) {
        var handle, prefix;
        if (args.length !== 2) {
          throwError2(state, "TAG directive accepts exactly two arguments");
        }
        handle = args[0];
        prefix = args[1];
        if (!PATTERN_TAG_HANDLE2.test(handle)) {
          throwError2(state, "ill-formed tag handle (first argument) of the TAG directive");
        }
        if (_hasOwnProperty2.call(state.tagMap, handle)) {
          throwError2(state, 'there is a previously declared suffix for "' + handle + '" tag handle');
        }
        if (!PATTERN_TAG_URI2.test(prefix)) {
          throwError2(state, "ill-formed tag prefix (second argument) of the TAG directive");
        }
        try {
          prefix = decodeURIComponent(prefix);
        } catch (err) {
          throwError2(state, "tag prefix is malformed: " + prefix);
        }
        state.tagMap[handle] = prefix;
      }
    };
    function captureSegment2(state, start, end, checkJson) {
      var _position, _length, _character, _result;
      if (start < end) {
        _result = state.input.slice(start, end);
        if (checkJson) {
          for (_position = 0, _length = _result.length; _position < _length; _position += 1) {
            _character = _result.charCodeAt(_position);
            if (!(_character === 9 || 32 <= _character && _character <= 1114111)) {
              throwError2(state, "expected valid JSON character");
            }
          }
        } else if (PATTERN_NON_PRINTABLE2.test(_result)) {
          throwError2(state, "the stream contains non-printable characters");
        }
        state.result += _result;
      }
    }
    function mergeMappings2(state, destination, source, overridableKeys) {
      var sourceKeys, key, index, quantity;
      if (!common2.isObject(source)) {
        throwError2(state, "cannot merge mappings; the provided source object is unacceptable");
      }
      sourceKeys = Object.keys(source);
      for (index = 0, quantity = sourceKeys.length; index < quantity; index += 1) {
        key = sourceKeys[index];
        if (!_hasOwnProperty2.call(destination, key)) {
          destination[key] = source[key];
          overridableKeys[key] = true;
        }
      }
    }
    function storeMappingPair2(state, _result, overridableKeys, keyTag, keyNode, valueNode, startLine, startLineStart, startPos) {
      var index, quantity;
      if (Array.isArray(keyNode)) {
        keyNode = Array.prototype.slice.call(keyNode);
        for (index = 0, quantity = keyNode.length; index < quantity; index += 1) {
          if (Array.isArray(keyNode[index])) {
            throwError2(state, "nested arrays are not supported inside keys");
          }
          if (typeof keyNode === "object" && _class2(keyNode[index]) === "[object Object]") {
            keyNode[index] = "[object Object]";
          }
        }
      }
      if (typeof keyNode === "object" && _class2(keyNode) === "[object Object]") {
        keyNode = "[object Object]";
      }
      keyNode = String(keyNode);
      if (_result === null) {
        _result = {};
      }
      if (keyTag === "tag:yaml.org,2002:merge") {
        if (Array.isArray(valueNode)) {
          for (index = 0, quantity = valueNode.length; index < quantity; index += 1) {
            mergeMappings2(state, _result, valueNode[index], overridableKeys);
          }
        } else {
          mergeMappings2(state, _result, valueNode, overridableKeys);
        }
      } else {
        if (!state.json && !_hasOwnProperty2.call(overridableKeys, keyNode) && _hasOwnProperty2.call(_result, keyNode)) {
          state.line = startLine || state.line;
          state.lineStart = startLineStart || state.lineStart;
          state.position = startPos || state.position;
          throwError2(state, "duplicated mapping key");
        }
        if (keyNode === "__proto__") {
          Object.defineProperty(_result, keyNode, {
            configurable: true,
            enumerable: true,
            writable: true,
            value: valueNode
          });
        } else {
          _result[keyNode] = valueNode;
        }
        delete overridableKeys[keyNode];
      }
      return _result;
    }
    function readLineBreak2(state) {
      var ch;
      ch = state.input.charCodeAt(state.position);
      if (ch === 10) {
        state.position++;
      } else if (ch === 13) {
        state.position++;
        if (state.input.charCodeAt(state.position) === 10) {
          state.position++;
        }
      } else {
        throwError2(state, "a line break is expected");
      }
      state.line += 1;
      state.lineStart = state.position;
      state.firstTabInLine = -1;
    }
    function skipSeparationSpace2(state, allowComments, checkIndent) {
      var lineBreaks = 0, ch = state.input.charCodeAt(state.position);
      while (ch !== 0) {
        while (is_WHITE_SPACE2(ch)) {
          if (ch === 9 && state.firstTabInLine === -1) {
            state.firstTabInLine = state.position;
          }
          ch = state.input.charCodeAt(++state.position);
        }
        if (allowComments && ch === 35) {
          do {
            ch = state.input.charCodeAt(++state.position);
          } while (ch !== 10 && ch !== 13 && ch !== 0);
        }
        if (is_EOL2(ch)) {
          readLineBreak2(state);
          ch = state.input.charCodeAt(state.position);
          lineBreaks++;
          state.lineIndent = 0;
          while (ch === 32) {
            state.lineIndent++;
            ch = state.input.charCodeAt(++state.position);
          }
        } else {
          break;
        }
      }
      if (checkIndent !== -1 && lineBreaks !== 0 && state.lineIndent < checkIndent) {
        throwWarning2(state, "deficient indentation");
      }
      return lineBreaks;
    }
    function testDocumentSeparator2(state) {
      var _position = state.position, ch;
      ch = state.input.charCodeAt(_position);
      if ((ch === 45 || ch === 46) && ch === state.input.charCodeAt(_position + 1) && ch === state.input.charCodeAt(_position + 2)) {
        _position += 3;
        ch = state.input.charCodeAt(_position);
        if (ch === 0 || is_WS_OR_EOL2(ch)) {
          return true;
        }
      }
      return false;
    }
    function writeFoldedLines2(state, count) {
      if (count === 1) {
        state.result += " ";
      } else if (count > 1) {
        state.result += common2.repeat("\n", count - 1);
      }
    }
    function readPlainScalar2(state, nodeIndent, withinFlowCollection) {
      var preceding, following, captureStart, captureEnd, hasPendingContent, _line, _lineStart, _lineIndent, _kind = state.kind, _result = state.result, ch;
      ch = state.input.charCodeAt(state.position);
      if (is_WS_OR_EOL2(ch) || is_FLOW_INDICATOR2(ch) || ch === 35 || ch === 38 || ch === 42 || ch === 33 || ch === 124 || ch === 62 || ch === 39 || ch === 34 || ch === 37 || ch === 64 || ch === 96) {
        return false;
      }
      if (ch === 63 || ch === 45) {
        following = state.input.charCodeAt(state.position + 1);
        if (is_WS_OR_EOL2(following) || withinFlowCollection && is_FLOW_INDICATOR2(following)) {
          return false;
        }
      }
      state.kind = "scalar";
      state.result = "";
      captureStart = captureEnd = state.position;
      hasPendingContent = false;
      while (ch !== 0) {
        if (ch === 58) {
          following = state.input.charCodeAt(state.position + 1);
          if (is_WS_OR_EOL2(following) || withinFlowCollection && is_FLOW_INDICATOR2(following)) {
            break;
          }
        } else if (ch === 35) {
          preceding = state.input.charCodeAt(state.position - 1);
          if (is_WS_OR_EOL2(preceding)) {
            break;
          }
        } else if (state.position === state.lineStart && testDocumentSeparator2(state) || withinFlowCollection && is_FLOW_INDICATOR2(ch)) {
          break;
        } else if (is_EOL2(ch)) {
          _line = state.line;
          _lineStart = state.lineStart;
          _lineIndent = state.lineIndent;
          skipSeparationSpace2(state, false, -1);
          if (state.lineIndent >= nodeIndent) {
            hasPendingContent = true;
            ch = state.input.charCodeAt(state.position);
            continue;
          } else {
            state.position = captureEnd;
            state.line = _line;
            state.lineStart = _lineStart;
            state.lineIndent = _lineIndent;
            break;
          }
        }
        if (hasPendingContent) {
          captureSegment2(state, captureStart, captureEnd, false);
          writeFoldedLines2(state, state.line - _line);
          captureStart = captureEnd = state.position;
          hasPendingContent = false;
        }
        if (!is_WHITE_SPACE2(ch)) {
          captureEnd = state.position + 1;
        }
        ch = state.input.charCodeAt(++state.position);
      }
      captureSegment2(state, captureStart, captureEnd, false);
      if (state.result) {
        return true;
      }
      state.kind = _kind;
      state.result = _result;
      return false;
    }
    function readSingleQuotedScalar2(state, nodeIndent) {
      var ch, captureStart, captureEnd;
      ch = state.input.charCodeAt(state.position);
      if (ch !== 39) {
        return false;
      }
      state.kind = "scalar";
      state.result = "";
      state.position++;
      captureStart = captureEnd = state.position;
      while ((ch = state.input.charCodeAt(state.position)) !== 0) {
        if (ch === 39) {
          captureSegment2(state, captureStart, state.position, true);
          ch = state.input.charCodeAt(++state.position);
          if (ch === 39) {
            captureStart = state.position;
            state.position++;
            captureEnd = state.position;
          } else {
            return true;
          }
        } else if (is_EOL2(ch)) {
          captureSegment2(state, captureStart, captureEnd, true);
          writeFoldedLines2(state, skipSeparationSpace2(state, false, nodeIndent));
          captureStart = captureEnd = state.position;
        } else if (state.position === state.lineStart && testDocumentSeparator2(state)) {
          throwError2(state, "unexpected end of the document within a single quoted scalar");
        } else {
          state.position++;
          captureEnd = state.position;
        }
      }
      throwError2(state, "unexpected end of the stream within a single quoted scalar");
    }
    function readDoubleQuotedScalar2(state, nodeIndent) {
      var captureStart, captureEnd, hexLength, hexResult, tmp, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch !== 34) {
        return false;
      }
      state.kind = "scalar";
      state.result = "";
      state.position++;
      captureStart = captureEnd = state.position;
      while ((ch = state.input.charCodeAt(state.position)) !== 0) {
        if (ch === 34) {
          captureSegment2(state, captureStart, state.position, true);
          state.position++;
          return true;
        } else if (ch === 92) {
          captureSegment2(state, captureStart, state.position, true);
          ch = state.input.charCodeAt(++state.position);
          if (is_EOL2(ch)) {
            skipSeparationSpace2(state, false, nodeIndent);
          } else if (ch < 256 && simpleEscapeCheck2[ch]) {
            state.result += simpleEscapeMap2[ch];
            state.position++;
          } else if ((tmp = escapedHexLen2(ch)) > 0) {
            hexLength = tmp;
            hexResult = 0;
            for (; hexLength > 0; hexLength--) {
              ch = state.input.charCodeAt(++state.position);
              if ((tmp = fromHexCode2(ch)) >= 0) {
                hexResult = (hexResult << 4) + tmp;
              } else {
                throwError2(state, "expected hexadecimal character");
              }
            }
            state.result += charFromCodepoint2(hexResult);
            state.position++;
          } else {
            throwError2(state, "unknown escape sequence");
          }
          captureStart = captureEnd = state.position;
        } else if (is_EOL2(ch)) {
          captureSegment2(state, captureStart, captureEnd, true);
          writeFoldedLines2(state, skipSeparationSpace2(state, false, nodeIndent));
          captureStart = captureEnd = state.position;
        } else if (state.position === state.lineStart && testDocumentSeparator2(state)) {
          throwError2(state, "unexpected end of the document within a double quoted scalar");
        } else {
          state.position++;
          captureEnd = state.position;
        }
      }
      throwError2(state, "unexpected end of the stream within a double quoted scalar");
    }
    function readFlowCollection2(state, nodeIndent) {
      var readNext = true, _line, _lineStart, _pos, _tag = state.tag, _result, _anchor = state.anchor, following, terminator, isPair, isExplicitPair, isMapping, overridableKeys = /* @__PURE__ */ Object.create(null), keyNode, keyTag, valueNode, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch === 91) {
        terminator = 93;
        isMapping = false;
        _result = [];
      } else if (ch === 123) {
        terminator = 125;
        isMapping = true;
        _result = {};
      } else {
        return false;
      }
      if (state.anchor !== null) {
        state.anchorMap[state.anchor] = _result;
      }
      ch = state.input.charCodeAt(++state.position);
      while (ch !== 0) {
        skipSeparationSpace2(state, true, nodeIndent);
        ch = state.input.charCodeAt(state.position);
        if (ch === terminator) {
          state.position++;
          state.tag = _tag;
          state.anchor = _anchor;
          state.kind = isMapping ? "mapping" : "sequence";
          state.result = _result;
          return true;
        } else if (!readNext) {
          throwError2(state, "missed comma between flow collection entries");
        } else if (ch === 44) {
          throwError2(state, "expected the node content, but found ','");
        }
        keyTag = keyNode = valueNode = null;
        isPair = isExplicitPair = false;
        if (ch === 63) {
          following = state.input.charCodeAt(state.position + 1);
          if (is_WS_OR_EOL2(following)) {
            isPair = isExplicitPair = true;
            state.position++;
            skipSeparationSpace2(state, true, nodeIndent);
          }
        }
        _line = state.line;
        _lineStart = state.lineStart;
        _pos = state.position;
        composeNode2(state, nodeIndent, CONTEXT_FLOW_IN2, false, true);
        keyTag = state.tag;
        keyNode = state.result;
        skipSeparationSpace2(state, true, nodeIndent);
        ch = state.input.charCodeAt(state.position);
        if ((isExplicitPair || state.line === _line) && ch === 58) {
          isPair = true;
          ch = state.input.charCodeAt(++state.position);
          skipSeparationSpace2(state, true, nodeIndent);
          composeNode2(state, nodeIndent, CONTEXT_FLOW_IN2, false, true);
          valueNode = state.result;
        }
        if (isMapping) {
          storeMappingPair2(state, _result, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos);
        } else if (isPair) {
          _result.push(storeMappingPair2(state, null, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos));
        } else {
          _result.push(keyNode);
        }
        skipSeparationSpace2(state, true, nodeIndent);
        ch = state.input.charCodeAt(state.position);
        if (ch === 44) {
          readNext = true;
          ch = state.input.charCodeAt(++state.position);
        } else {
          readNext = false;
        }
      }
      throwError2(state, "unexpected end of the stream within a flow collection");
    }
    function readBlockScalar2(state, nodeIndent) {
      var captureStart, folding, chomping = CHOMPING_CLIP2, didReadContent = false, detectedIndent = false, textIndent = nodeIndent, emptyLines = 0, atMoreIndented = false, tmp, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch === 124) {
        folding = false;
      } else if (ch === 62) {
        folding = true;
      } else {
        return false;
      }
      state.kind = "scalar";
      state.result = "";
      while (ch !== 0) {
        ch = state.input.charCodeAt(++state.position);
        if (ch === 43 || ch === 45) {
          if (CHOMPING_CLIP2 === chomping) {
            chomping = ch === 43 ? CHOMPING_KEEP2 : CHOMPING_STRIP2;
          } else {
            throwError2(state, "repeat of a chomping mode identifier");
          }
        } else if ((tmp = fromDecimalCode2(ch)) >= 0) {
          if (tmp === 0) {
            throwError2(state, "bad explicit indentation width of a block scalar; it cannot be less than one");
          } else if (!detectedIndent) {
            textIndent = nodeIndent + tmp - 1;
            detectedIndent = true;
          } else {
            throwError2(state, "repeat of an indentation width identifier");
          }
        } else {
          break;
        }
      }
      if (is_WHITE_SPACE2(ch)) {
        do {
          ch = state.input.charCodeAt(++state.position);
        } while (is_WHITE_SPACE2(ch));
        if (ch === 35) {
          do {
            ch = state.input.charCodeAt(++state.position);
          } while (!is_EOL2(ch) && ch !== 0);
        }
      }
      while (ch !== 0) {
        readLineBreak2(state);
        state.lineIndent = 0;
        ch = state.input.charCodeAt(state.position);
        while ((!detectedIndent || state.lineIndent < textIndent) && ch === 32) {
          state.lineIndent++;
          ch = state.input.charCodeAt(++state.position);
        }
        if (!detectedIndent && state.lineIndent > textIndent) {
          textIndent = state.lineIndent;
        }
        if (is_EOL2(ch)) {
          emptyLines++;
          continue;
        }
        if (state.lineIndent < textIndent) {
          if (chomping === CHOMPING_KEEP2) {
            state.result += common2.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
          } else if (chomping === CHOMPING_CLIP2) {
            if (didReadContent) {
              state.result += "\n";
            }
          }
          break;
        }
        if (folding) {
          if (is_WHITE_SPACE2(ch)) {
            atMoreIndented = true;
            state.result += common2.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
          } else if (atMoreIndented) {
            atMoreIndented = false;
            state.result += common2.repeat("\n", emptyLines + 1);
          } else if (emptyLines === 0) {
            if (didReadContent) {
              state.result += " ";
            }
          } else {
            state.result += common2.repeat("\n", emptyLines);
          }
        } else {
          state.result += common2.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
        }
        didReadContent = true;
        detectedIndent = true;
        emptyLines = 0;
        captureStart = state.position;
        while (!is_EOL2(ch) && ch !== 0) {
          ch = state.input.charCodeAt(++state.position);
        }
        captureSegment2(state, captureStart, state.position, false);
      }
      return true;
    }
    function readBlockSequence2(state, nodeIndent) {
      var _line, _tag = state.tag, _anchor = state.anchor, _result = [], following, detected = false, ch;
      if (state.firstTabInLine !== -1) return false;
      if (state.anchor !== null) {
        state.anchorMap[state.anchor] = _result;
      }
      ch = state.input.charCodeAt(state.position);
      while (ch !== 0) {
        if (state.firstTabInLine !== -1) {
          state.position = state.firstTabInLine;
          throwError2(state, "tab characters must not be used in indentation");
        }
        if (ch !== 45) {
          break;
        }
        following = state.input.charCodeAt(state.position + 1);
        if (!is_WS_OR_EOL2(following)) {
          break;
        }
        detected = true;
        state.position++;
        if (skipSeparationSpace2(state, true, -1)) {
          if (state.lineIndent <= nodeIndent) {
            _result.push(null);
            ch = state.input.charCodeAt(state.position);
            continue;
          }
        }
        _line = state.line;
        composeNode2(state, nodeIndent, CONTEXT_BLOCK_IN2, false, true);
        _result.push(state.result);
        skipSeparationSpace2(state, true, -1);
        ch = state.input.charCodeAt(state.position);
        if ((state.line === _line || state.lineIndent > nodeIndent) && ch !== 0) {
          throwError2(state, "bad indentation of a sequence entry");
        } else if (state.lineIndent < nodeIndent) {
          break;
        }
      }
      if (detected) {
        state.tag = _tag;
        state.anchor = _anchor;
        state.kind = "sequence";
        state.result = _result;
        return true;
      }
      return false;
    }
    function readBlockMapping2(state, nodeIndent, flowIndent) {
      var following, allowCompact, _line, _keyLine, _keyLineStart, _keyPos, _tag = state.tag, _anchor = state.anchor, _result = {}, overridableKeys = /* @__PURE__ */ Object.create(null), keyTag = null, keyNode = null, valueNode = null, atExplicitKey = false, detected = false, ch;
      if (state.firstTabInLine !== -1) return false;
      if (state.anchor !== null) {
        state.anchorMap[state.anchor] = _result;
      }
      ch = state.input.charCodeAt(state.position);
      while (ch !== 0) {
        if (!atExplicitKey && state.firstTabInLine !== -1) {
          state.position = state.firstTabInLine;
          throwError2(state, "tab characters must not be used in indentation");
        }
        following = state.input.charCodeAt(state.position + 1);
        _line = state.line;
        if ((ch === 63 || ch === 58) && is_WS_OR_EOL2(following)) {
          if (ch === 63) {
            if (atExplicitKey) {
              storeMappingPair2(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
              keyTag = keyNode = valueNode = null;
            }
            detected = true;
            atExplicitKey = true;
            allowCompact = true;
          } else if (atExplicitKey) {
            atExplicitKey = false;
            allowCompact = true;
          } else {
            throwError2(state, "incomplete explicit mapping pair; a key node is missed; or followed by a non-tabulated empty line");
          }
          state.position += 1;
          ch = following;
        } else {
          _keyLine = state.line;
          _keyLineStart = state.lineStart;
          _keyPos = state.position;
          if (!composeNode2(state, flowIndent, CONTEXT_FLOW_OUT2, false, true)) {
            break;
          }
          if (state.line === _line) {
            ch = state.input.charCodeAt(state.position);
            while (is_WHITE_SPACE2(ch)) {
              ch = state.input.charCodeAt(++state.position);
            }
            if (ch === 58) {
              ch = state.input.charCodeAt(++state.position);
              if (!is_WS_OR_EOL2(ch)) {
                throwError2(state, "a whitespace character is expected after the key-value separator within a block mapping");
              }
              if (atExplicitKey) {
                storeMappingPair2(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
                keyTag = keyNode = valueNode = null;
              }
              detected = true;
              atExplicitKey = false;
              allowCompact = false;
              keyTag = state.tag;
              keyNode = state.result;
            } else if (detected) {
              throwError2(state, "can not read an implicit mapping pair; a colon is missed");
            } else {
              state.tag = _tag;
              state.anchor = _anchor;
              return true;
            }
          } else if (detected) {
            throwError2(state, "can not read a block mapping entry; a multiline key may not be an implicit key");
          } else {
            state.tag = _tag;
            state.anchor = _anchor;
            return true;
          }
        }
        if (state.line === _line || state.lineIndent > nodeIndent) {
          if (atExplicitKey) {
            _keyLine = state.line;
            _keyLineStart = state.lineStart;
            _keyPos = state.position;
          }
          if (composeNode2(state, nodeIndent, CONTEXT_BLOCK_OUT2, true, allowCompact)) {
            if (atExplicitKey) {
              keyNode = state.result;
            } else {
              valueNode = state.result;
            }
          }
          if (!atExplicitKey) {
            storeMappingPair2(state, _result, overridableKeys, keyTag, keyNode, valueNode, _keyLine, _keyLineStart, _keyPos);
            keyTag = keyNode = valueNode = null;
          }
          skipSeparationSpace2(state, true, -1);
          ch = state.input.charCodeAt(state.position);
        }
        if ((state.line === _line || state.lineIndent > nodeIndent) && ch !== 0) {
          throwError2(state, "bad indentation of a mapping entry");
        } else if (state.lineIndent < nodeIndent) {
          break;
        }
      }
      if (atExplicitKey) {
        storeMappingPair2(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
      }
      if (detected) {
        state.tag = _tag;
        state.anchor = _anchor;
        state.kind = "mapping";
        state.result = _result;
      }
      return detected;
    }
    function readTagProperty2(state) {
      var _position, isVerbatim = false, isNamed = false, tagHandle, tagName, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch !== 33) return false;
      if (state.tag !== null) {
        throwError2(state, "duplication of a tag property");
      }
      ch = state.input.charCodeAt(++state.position);
      if (ch === 60) {
        isVerbatim = true;
        ch = state.input.charCodeAt(++state.position);
      } else if (ch === 33) {
        isNamed = true;
        tagHandle = "!!";
        ch = state.input.charCodeAt(++state.position);
      } else {
        tagHandle = "!";
      }
      _position = state.position;
      if (isVerbatim) {
        do {
          ch = state.input.charCodeAt(++state.position);
        } while (ch !== 0 && ch !== 62);
        if (state.position < state.length) {
          tagName = state.input.slice(_position, state.position);
          ch = state.input.charCodeAt(++state.position);
        } else {
          throwError2(state, "unexpected end of the stream within a verbatim tag");
        }
      } else {
        while (ch !== 0 && !is_WS_OR_EOL2(ch)) {
          if (ch === 33) {
            if (!isNamed) {
              tagHandle = state.input.slice(_position - 1, state.position + 1);
              if (!PATTERN_TAG_HANDLE2.test(tagHandle)) {
                throwError2(state, "named tag handle cannot contain such characters");
              }
              isNamed = true;
              _position = state.position + 1;
            } else {
              throwError2(state, "tag suffix cannot contain exclamation marks");
            }
          }
          ch = state.input.charCodeAt(++state.position);
        }
        tagName = state.input.slice(_position, state.position);
        if (PATTERN_FLOW_INDICATORS2.test(tagName)) {
          throwError2(state, "tag suffix cannot contain flow indicator characters");
        }
      }
      if (tagName && !PATTERN_TAG_URI2.test(tagName)) {
        throwError2(state, "tag name cannot contain such characters: " + tagName);
      }
      try {
        tagName = decodeURIComponent(tagName);
      } catch (err) {
        throwError2(state, "tag name is malformed: " + tagName);
      }
      if (isVerbatim) {
        state.tag = tagName;
      } else if (_hasOwnProperty2.call(state.tagMap, tagHandle)) {
        state.tag = state.tagMap[tagHandle] + tagName;
      } else if (tagHandle === "!") {
        state.tag = "!" + tagName;
      } else if (tagHandle === "!!") {
        state.tag = "tag:yaml.org,2002:" + tagName;
      } else {
        throwError2(state, 'undeclared tag handle "' + tagHandle + '"');
      }
      return true;
    }
    function readAnchorProperty2(state) {
      var _position, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch !== 38) return false;
      if (state.anchor !== null) {
        throwError2(state, "duplication of an anchor property");
      }
      ch = state.input.charCodeAt(++state.position);
      _position = state.position;
      while (ch !== 0 && !is_WS_OR_EOL2(ch) && !is_FLOW_INDICATOR2(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      if (state.position === _position) {
        throwError2(state, "name of an anchor node must contain at least one character");
      }
      state.anchor = state.input.slice(_position, state.position);
      return true;
    }
    function readAlias2(state) {
      var _position, alias, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch !== 42) return false;
      ch = state.input.charCodeAt(++state.position);
      _position = state.position;
      while (ch !== 0 && !is_WS_OR_EOL2(ch) && !is_FLOW_INDICATOR2(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      if (state.position === _position) {
        throwError2(state, "name of an alias node must contain at least one character");
      }
      alias = state.input.slice(_position, state.position);
      if (!_hasOwnProperty2.call(state.anchorMap, alias)) {
        throwError2(state, 'unidentified alias "' + alias + '"');
      }
      state.result = state.anchorMap[alias];
      skipSeparationSpace2(state, true, -1);
      return true;
    }
    function composeNode2(state, parentIndent, nodeContext, allowToSeek, allowCompact) {
      var allowBlockStyles, allowBlockScalars, allowBlockCollections, indentStatus = 1, atNewLine = false, hasContent = false, typeIndex, typeQuantity, typeList, type2, flowIndent, blockIndent;
      if (state.listener !== null) {
        state.listener("open", state);
      }
      state.tag = null;
      state.anchor = null;
      state.kind = null;
      state.result = null;
      allowBlockStyles = allowBlockScalars = allowBlockCollections = CONTEXT_BLOCK_OUT2 === nodeContext || CONTEXT_BLOCK_IN2 === nodeContext;
      if (allowToSeek) {
        if (skipSeparationSpace2(state, true, -1)) {
          atNewLine = true;
          if (state.lineIndent > parentIndent) {
            indentStatus = 1;
          } else if (state.lineIndent === parentIndent) {
            indentStatus = 0;
          } else if (state.lineIndent < parentIndent) {
            indentStatus = -1;
          }
        }
      }
      if (indentStatus === 1) {
        while (readTagProperty2(state) || readAnchorProperty2(state)) {
          if (skipSeparationSpace2(state, true, -1)) {
            atNewLine = true;
            allowBlockCollections = allowBlockStyles;
            if (state.lineIndent > parentIndent) {
              indentStatus = 1;
            } else if (state.lineIndent === parentIndent) {
              indentStatus = 0;
            } else if (state.lineIndent < parentIndent) {
              indentStatus = -1;
            }
          } else {
            allowBlockCollections = false;
          }
        }
      }
      if (allowBlockCollections) {
        allowBlockCollections = atNewLine || allowCompact;
      }
      if (indentStatus === 1 || CONTEXT_BLOCK_OUT2 === nodeContext) {
        if (CONTEXT_FLOW_IN2 === nodeContext || CONTEXT_FLOW_OUT2 === nodeContext) {
          flowIndent = parentIndent;
        } else {
          flowIndent = parentIndent + 1;
        }
        blockIndent = state.position - state.lineStart;
        if (indentStatus === 1) {
          if (allowBlockCollections && (readBlockSequence2(state, blockIndent) || readBlockMapping2(state, blockIndent, flowIndent)) || readFlowCollection2(state, flowIndent)) {
            hasContent = true;
          } else {
            if (allowBlockScalars && readBlockScalar2(state, flowIndent) || readSingleQuotedScalar2(state, flowIndent) || readDoubleQuotedScalar2(state, flowIndent)) {
              hasContent = true;
            } else if (readAlias2(state)) {
              hasContent = true;
              if (state.tag !== null || state.anchor !== null) {
                throwError2(state, "alias node should not have any properties");
              }
            } else if (readPlainScalar2(state, flowIndent, CONTEXT_FLOW_IN2 === nodeContext)) {
              hasContent = true;
              if (state.tag === null) {
                state.tag = "?";
              }
            }
            if (state.anchor !== null) {
              state.anchorMap[state.anchor] = state.result;
            }
          }
        } else if (indentStatus === 0) {
          hasContent = allowBlockCollections && readBlockSequence2(state, blockIndent);
        }
      }
      if (state.tag === null) {
        if (state.anchor !== null) {
          state.anchorMap[state.anchor] = state.result;
        }
      } else if (state.tag === "?") {
        if (state.result !== null && state.kind !== "scalar") {
          throwError2(state, 'unacceptable node kind for !<?> tag; it should be "scalar", not "' + state.kind + '"');
        }
        for (typeIndex = 0, typeQuantity = state.implicitTypes.length; typeIndex < typeQuantity; typeIndex += 1) {
          type2 = state.implicitTypes[typeIndex];
          if (type2.resolve(state.result)) {
            state.result = type2.construct(state.result);
            state.tag = type2.tag;
            if (state.anchor !== null) {
              state.anchorMap[state.anchor] = state.result;
            }
            break;
          }
        }
      } else if (state.tag !== "!") {
        if (_hasOwnProperty2.call(state.typeMap[state.kind || "fallback"], state.tag)) {
          type2 = state.typeMap[state.kind || "fallback"][state.tag];
        } else {
          type2 = null;
          typeList = state.typeMap.multi[state.kind || "fallback"];
          for (typeIndex = 0, typeQuantity = typeList.length; typeIndex < typeQuantity; typeIndex += 1) {
            if (state.tag.slice(0, typeList[typeIndex].tag.length) === typeList[typeIndex].tag) {
              type2 = typeList[typeIndex];
              break;
            }
          }
        }
        if (!type2) {
          throwError2(state, "unknown tag !<" + state.tag + ">");
        }
        if (state.result !== null && type2.kind !== state.kind) {
          throwError2(state, "unacceptable node kind for !<" + state.tag + '> tag; it should be "' + type2.kind + '", not "' + state.kind + '"');
        }
        if (!type2.resolve(state.result, state.tag)) {
          throwError2(state, "cannot resolve a node with !<" + state.tag + "> explicit tag");
        } else {
          state.result = type2.construct(state.result, state.tag);
          if (state.anchor !== null) {
            state.anchorMap[state.anchor] = state.result;
          }
        }
      }
      if (state.listener !== null) {
        state.listener("close", state);
      }
      return state.tag !== null || state.anchor !== null || hasContent;
    }
    function readDocument2(state) {
      var documentStart = state.position, _position, directiveName, directiveArgs, hasDirectives = false, ch;
      state.version = null;
      state.checkLineBreaks = state.legacy;
      state.tagMap = /* @__PURE__ */ Object.create(null);
      state.anchorMap = /* @__PURE__ */ Object.create(null);
      while ((ch = state.input.charCodeAt(state.position)) !== 0) {
        skipSeparationSpace2(state, true, -1);
        ch = state.input.charCodeAt(state.position);
        if (state.lineIndent > 0 || ch !== 37) {
          break;
        }
        hasDirectives = true;
        ch = state.input.charCodeAt(++state.position);
        _position = state.position;
        while (ch !== 0 && !is_WS_OR_EOL2(ch)) {
          ch = state.input.charCodeAt(++state.position);
        }
        directiveName = state.input.slice(_position, state.position);
        directiveArgs = [];
        if (directiveName.length < 1) {
          throwError2(state, "directive name must not be less than one character in length");
        }
        while (ch !== 0) {
          while (is_WHITE_SPACE2(ch)) {
            ch = state.input.charCodeAt(++state.position);
          }
          if (ch === 35) {
            do {
              ch = state.input.charCodeAt(++state.position);
            } while (ch !== 0 && !is_EOL2(ch));
            break;
          }
          if (is_EOL2(ch)) break;
          _position = state.position;
          while (ch !== 0 && !is_WS_OR_EOL2(ch)) {
            ch = state.input.charCodeAt(++state.position);
          }
          directiveArgs.push(state.input.slice(_position, state.position));
        }
        if (ch !== 0) readLineBreak2(state);
        if (_hasOwnProperty2.call(directiveHandlers2, directiveName)) {
          directiveHandlers2[directiveName](state, directiveName, directiveArgs);
        } else {
          throwWarning2(state, 'unknown document directive "' + directiveName + '"');
        }
      }
      skipSeparationSpace2(state, true, -1);
      if (state.lineIndent === 0 && state.input.charCodeAt(state.position) === 45 && state.input.charCodeAt(state.position + 1) === 45 && state.input.charCodeAt(state.position + 2) === 45) {
        state.position += 3;
        skipSeparationSpace2(state, true, -1);
      } else if (hasDirectives) {
        throwError2(state, "directives end mark is expected");
      }
      composeNode2(state, state.lineIndent - 1, CONTEXT_BLOCK_OUT2, false, true);
      skipSeparationSpace2(state, true, -1);
      if (state.checkLineBreaks && PATTERN_NON_ASCII_LINE_BREAKS2.test(state.input.slice(documentStart, state.position))) {
        throwWarning2(state, "non-ASCII line breaks are interpreted as content");
      }
      state.documents.push(state.result);
      if (state.position === state.lineStart && testDocumentSeparator2(state)) {
        if (state.input.charCodeAt(state.position) === 46) {
          state.position += 3;
          skipSeparationSpace2(state, true, -1);
        }
        return;
      }
      if (state.position < state.length - 1) {
        throwError2(state, "end of the stream or a document separator is expected");
      } else {
        return;
      }
    }
    function loadDocuments2(input, options) {
      input = String(input);
      options = options || {};
      if (input.length !== 0) {
        if (input.charCodeAt(input.length - 1) !== 10 && input.charCodeAt(input.length - 1) !== 13) {
          input += "\n";
        }
        if (input.charCodeAt(0) === 65279) {
          input = input.slice(1);
        }
      }
      var state = new State3(input, options);
      var nullpos = input.indexOf("\0");
      if (nullpos !== -1) {
        state.position = nullpos;
        throwError2(state, "null byte is not allowed in input");
      }
      state.input += "\0";
      while (state.input.charCodeAt(state.position) === 32) {
        state.lineIndent += 1;
        state.position += 1;
      }
      while (state.position < state.length - 1) {
        readDocument2(state);
      }
      return state.documents;
    }
    function loadAll2(input, iterator, options) {
      if (iterator !== null && typeof iterator === "object" && typeof options === "undefined") {
        options = iterator;
        iterator = null;
      }
      var documents = loadDocuments2(input, options);
      if (typeof iterator !== "function") {
        return documents;
      }
      for (var index = 0, length = documents.length; index < length; index += 1) {
        iterator(documents[index]);
      }
    }
    function load2(input, options) {
      var documents = loadDocuments2(input, options);
      if (documents.length === 0) {
        return void 0;
      } else if (documents.length === 1) {
        return documents[0];
      }
      throw new YAMLException2("expected a single document in the stream, but found more");
    }
    module2.exports.loadAll = loadAll2;
    module2.exports.load = load2;
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/dumper.js
var require_dumper = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/dumper.js"(exports2, module2) {
    "use strict";
    var common2 = require_common();
    var YAMLException2 = require_exception();
    var DEFAULT_SCHEMA2 = require_default();
    var _toString2 = Object.prototype.toString;
    var _hasOwnProperty2 = Object.prototype.hasOwnProperty;
    var CHAR_BOM2 = 65279;
    var CHAR_TAB2 = 9;
    var CHAR_LINE_FEED2 = 10;
    var CHAR_CARRIAGE_RETURN2 = 13;
    var CHAR_SPACE2 = 32;
    var CHAR_EXCLAMATION2 = 33;
    var CHAR_DOUBLE_QUOTE2 = 34;
    var CHAR_SHARP2 = 35;
    var CHAR_PERCENT2 = 37;
    var CHAR_AMPERSAND2 = 38;
    var CHAR_SINGLE_QUOTE2 = 39;
    var CHAR_ASTERISK2 = 42;
    var CHAR_COMMA2 = 44;
    var CHAR_MINUS2 = 45;
    var CHAR_COLON2 = 58;
    var CHAR_EQUALS2 = 61;
    var CHAR_GREATER_THAN2 = 62;
    var CHAR_QUESTION2 = 63;
    var CHAR_COMMERCIAL_AT2 = 64;
    var CHAR_LEFT_SQUARE_BRACKET2 = 91;
    var CHAR_RIGHT_SQUARE_BRACKET2 = 93;
    var CHAR_GRAVE_ACCENT2 = 96;
    var CHAR_LEFT_CURLY_BRACKET2 = 123;
    var CHAR_VERTICAL_LINE2 = 124;
    var CHAR_RIGHT_CURLY_BRACKET2 = 125;
    var ESCAPE_SEQUENCES2 = {};
    ESCAPE_SEQUENCES2[0] = "\\0";
    ESCAPE_SEQUENCES2[7] = "\\a";
    ESCAPE_SEQUENCES2[8] = "\\b";
    ESCAPE_SEQUENCES2[9] = "\\t";
    ESCAPE_SEQUENCES2[10] = "\\n";
    ESCAPE_SEQUENCES2[11] = "\\v";
    ESCAPE_SEQUENCES2[12] = "\\f";
    ESCAPE_SEQUENCES2[13] = "\\r";
    ESCAPE_SEQUENCES2[27] = "\\e";
    ESCAPE_SEQUENCES2[34] = '\\"';
    ESCAPE_SEQUENCES2[92] = "\\\\";
    ESCAPE_SEQUENCES2[133] = "\\N";
    ESCAPE_SEQUENCES2[160] = "\\_";
    ESCAPE_SEQUENCES2[8232] = "\\L";
    ESCAPE_SEQUENCES2[8233] = "\\P";
    var DEPRECATED_BOOLEANS_SYNTAX2 = [
      "y",
      "Y",
      "yes",
      "Yes",
      "YES",
      "on",
      "On",
      "ON",
      "n",
      "N",
      "no",
      "No",
      "NO",
      "off",
      "Off",
      "OFF"
    ];
    var DEPRECATED_BASE60_SYNTAX2 = /^[-+]?[0-9_]+(?::[0-9_]+)+(?:\.[0-9_]*)?$/;
    function compileStyleMap2(schema2, map2) {
      var result, keys5, index, length, tag, style, type2;
      if (map2 === null) return {};
      result = {};
      keys5 = Object.keys(map2);
      for (index = 0, length = keys5.length; index < length; index += 1) {
        tag = keys5[index];
        style = String(map2[tag]);
        if (tag.slice(0, 2) === "!!") {
          tag = "tag:yaml.org,2002:" + tag.slice(2);
        }
        type2 = schema2.compiledTypeMap["fallback"][tag];
        if (type2 && _hasOwnProperty2.call(type2.styleAliases, style)) {
          style = type2.styleAliases[style];
        }
        result[tag] = style;
      }
      return result;
    }
    function encodeHex2(character) {
      var string3, handle, length;
      string3 = character.toString(16).toUpperCase();
      if (character <= 255) {
        handle = "x";
        length = 2;
      } else if (character <= 65535) {
        handle = "u";
        length = 4;
      } else if (character <= 4294967295) {
        handle = "U";
        length = 8;
      } else {
        throw new YAMLException2("code point within a string may not be greater than 0xFFFFFFFF");
      }
      return "\\" + handle + common2.repeat("0", length - string3.length) + string3;
    }
    var QUOTING_TYPE_SINGLE2 = 1;
    var QUOTING_TYPE_DOUBLE2 = 2;
    function State3(options) {
      this.schema = options["schema"] || DEFAULT_SCHEMA2;
      this.indent = Math.max(1, options["indent"] || 2);
      this.noArrayIndent = options["noArrayIndent"] || false;
      this.skipInvalid = options["skipInvalid"] || false;
      this.flowLevel = common2.isNothing(options["flowLevel"]) ? -1 : options["flowLevel"];
      this.styleMap = compileStyleMap2(this.schema, options["styles"] || null);
      this.sortKeys = options["sortKeys"] || false;
      this.lineWidth = options["lineWidth"] || 80;
      this.noRefs = options["noRefs"] || false;
      this.noCompatMode = options["noCompatMode"] || false;
      this.condenseFlow = options["condenseFlow"] || false;
      this.quotingType = options["quotingType"] === '"' ? QUOTING_TYPE_DOUBLE2 : QUOTING_TYPE_SINGLE2;
      this.forceQuotes = options["forceQuotes"] || false;
      this.replacer = typeof options["replacer"] === "function" ? options["replacer"] : null;
      this.implicitTypes = this.schema.compiledImplicit;
      this.explicitTypes = this.schema.compiledExplicit;
      this.tag = null;
      this.result = "";
      this.duplicates = [];
      this.usedDuplicates = null;
    }
    function indentString2(string3, spaces) {
      var ind = common2.repeat(" ", spaces), position = 0, next = -1, result = "", line, length = string3.length;
      while (position < length) {
        next = string3.indexOf("\n", position);
        if (next === -1) {
          line = string3.slice(position);
          position = length;
        } else {
          line = string3.slice(position, next + 1);
          position = next + 1;
        }
        if (line.length && line !== "\n") result += ind;
        result += line;
      }
      return result;
    }
    function generateNextLine2(state, level) {
      return "\n" + common2.repeat(" ", state.indent * level);
    }
    function testImplicitResolving2(state, str2) {
      var index, length, type2;
      for (index = 0, length = state.implicitTypes.length; index < length; index += 1) {
        type2 = state.implicitTypes[index];
        if (type2.resolve(str2)) {
          return true;
        }
      }
      return false;
    }
    function isWhitespace2(c) {
      return c === CHAR_SPACE2 || c === CHAR_TAB2;
    }
    function isPrintable2(c) {
      return 32 <= c && c <= 126 || 161 <= c && c <= 55295 && c !== 8232 && c !== 8233 || 57344 <= c && c <= 65533 && c !== CHAR_BOM2 || 65536 <= c && c <= 1114111;
    }
    function isNsCharOrWhitespace2(c) {
      return isPrintable2(c) && c !== CHAR_BOM2 && c !== CHAR_CARRIAGE_RETURN2 && c !== CHAR_LINE_FEED2;
    }
    function isPlainSafe2(c, prev, inblock) {
      var cIsNsCharOrWhitespace = isNsCharOrWhitespace2(c);
      var cIsNsChar = cIsNsCharOrWhitespace && !isWhitespace2(c);
      return (
        // ns-plain-safe
        (inblock ? (
          // c = flow-in
          cIsNsCharOrWhitespace
        ) : cIsNsCharOrWhitespace && c !== CHAR_COMMA2 && c !== CHAR_LEFT_SQUARE_BRACKET2 && c !== CHAR_RIGHT_SQUARE_BRACKET2 && c !== CHAR_LEFT_CURLY_BRACKET2 && c !== CHAR_RIGHT_CURLY_BRACKET2) && c !== CHAR_SHARP2 && !(prev === CHAR_COLON2 && !cIsNsChar) || isNsCharOrWhitespace2(prev) && !isWhitespace2(prev) && c === CHAR_SHARP2 || prev === CHAR_COLON2 && cIsNsChar
      );
    }
    function isPlainSafeFirst2(c) {
      return isPrintable2(c) && c !== CHAR_BOM2 && !isWhitespace2(c) && c !== CHAR_MINUS2 && c !== CHAR_QUESTION2 && c !== CHAR_COLON2 && c !== CHAR_COMMA2 && c !== CHAR_LEFT_SQUARE_BRACKET2 && c !== CHAR_RIGHT_SQUARE_BRACKET2 && c !== CHAR_LEFT_CURLY_BRACKET2 && c !== CHAR_RIGHT_CURLY_BRACKET2 && c !== CHAR_SHARP2 && c !== CHAR_AMPERSAND2 && c !== CHAR_ASTERISK2 && c !== CHAR_EXCLAMATION2 && c !== CHAR_VERTICAL_LINE2 && c !== CHAR_EQUALS2 && c !== CHAR_GREATER_THAN2 && c !== CHAR_SINGLE_QUOTE2 && c !== CHAR_DOUBLE_QUOTE2 && c !== CHAR_PERCENT2 && c !== CHAR_COMMERCIAL_AT2 && c !== CHAR_GRAVE_ACCENT2;
    }
    function isPlainSafeLast2(c) {
      return !isWhitespace2(c) && c !== CHAR_COLON2;
    }
    function codePointAt2(string3, pos) {
      var first = string3.charCodeAt(pos), second;
      if (first >= 55296 && first <= 56319 && pos + 1 < string3.length) {
        second = string3.charCodeAt(pos + 1);
        if (second >= 56320 && second <= 57343) {
          return (first - 55296) * 1024 + second - 56320 + 65536;
        }
      }
      return first;
    }
    function needIndentIndicator2(string3) {
      var leadingSpaceRe = /^\n* /;
      return leadingSpaceRe.test(string3);
    }
    var STYLE_PLAIN2 = 1;
    var STYLE_SINGLE2 = 2;
    var STYLE_LITERAL2 = 3;
    var STYLE_FOLDED2 = 4;
    var STYLE_DOUBLE2 = 5;
    function chooseScalarStyle2(string3, singleLineOnly, indentPerLevel, lineWidth, testAmbiguousType, quotingType, forceQuotes, inblock) {
      var i;
      var char = 0;
      var prevChar = null;
      var hasLineBreak = false;
      var hasFoldableLine = false;
      var shouldTrackWidth = lineWidth !== -1;
      var previousLineBreak = -1;
      var plain = isPlainSafeFirst2(codePointAt2(string3, 0)) && isPlainSafeLast2(codePointAt2(string3, string3.length - 1));
      if (singleLineOnly || forceQuotes) {
        for (i = 0; i < string3.length; char >= 65536 ? i += 2 : i++) {
          char = codePointAt2(string3, i);
          if (!isPrintable2(char)) {
            return STYLE_DOUBLE2;
          }
          plain = plain && isPlainSafe2(char, prevChar, inblock);
          prevChar = char;
        }
      } else {
        for (i = 0; i < string3.length; char >= 65536 ? i += 2 : i++) {
          char = codePointAt2(string3, i);
          if (char === CHAR_LINE_FEED2) {
            hasLineBreak = true;
            if (shouldTrackWidth) {
              hasFoldableLine = hasFoldableLine || // Foldable line = too long, and not more-indented.
              i - previousLineBreak - 1 > lineWidth && string3[previousLineBreak + 1] !== " ";
              previousLineBreak = i;
            }
          } else if (!isPrintable2(char)) {
            return STYLE_DOUBLE2;
          }
          plain = plain && isPlainSafe2(char, prevChar, inblock);
          prevChar = char;
        }
        hasFoldableLine = hasFoldableLine || shouldTrackWidth && (i - previousLineBreak - 1 > lineWidth && string3[previousLineBreak + 1] !== " ");
      }
      if (!hasLineBreak && !hasFoldableLine) {
        if (plain && !forceQuotes && !testAmbiguousType(string3)) {
          return STYLE_PLAIN2;
        }
        return quotingType === QUOTING_TYPE_DOUBLE2 ? STYLE_DOUBLE2 : STYLE_SINGLE2;
      }
      if (indentPerLevel > 9 && needIndentIndicator2(string3)) {
        return STYLE_DOUBLE2;
      }
      if (!forceQuotes) {
        return hasFoldableLine ? STYLE_FOLDED2 : STYLE_LITERAL2;
      }
      return quotingType === QUOTING_TYPE_DOUBLE2 ? STYLE_DOUBLE2 : STYLE_SINGLE2;
    }
    function writeScalar2(state, string3, level, iskey, inblock) {
      state.dump = function() {
        if (string3.length === 0) {
          return state.quotingType === QUOTING_TYPE_DOUBLE2 ? '""' : "''";
        }
        if (!state.noCompatMode) {
          if (DEPRECATED_BOOLEANS_SYNTAX2.indexOf(string3) !== -1 || DEPRECATED_BASE60_SYNTAX2.test(string3)) {
            return state.quotingType === QUOTING_TYPE_DOUBLE2 ? '"' + string3 + '"' : "'" + string3 + "'";
          }
        }
        var indent = state.indent * Math.max(1, level);
        var lineWidth = state.lineWidth === -1 ? -1 : Math.max(Math.min(state.lineWidth, 40), state.lineWidth - indent);
        var singleLineOnly = iskey || state.flowLevel > -1 && level >= state.flowLevel;
        function testAmbiguity(string4) {
          return testImplicitResolving2(state, string4);
        }
        switch (chooseScalarStyle2(
          string3,
          singleLineOnly,
          state.indent,
          lineWidth,
          testAmbiguity,
          state.quotingType,
          state.forceQuotes && !iskey,
          inblock
        )) {
          case STYLE_PLAIN2:
            return string3;
          case STYLE_SINGLE2:
            return "'" + string3.replace(/'/g, "''") + "'";
          case STYLE_LITERAL2:
            return "|" + blockHeader2(string3, state.indent) + dropEndingNewline2(indentString2(string3, indent));
          case STYLE_FOLDED2:
            return ">" + blockHeader2(string3, state.indent) + dropEndingNewline2(indentString2(foldString2(string3, lineWidth), indent));
          case STYLE_DOUBLE2:
            return '"' + escapeString2(string3, lineWidth) + '"';
          default:
            throw new YAMLException2("impossible error: invalid scalar style");
        }
      }();
    }
    function blockHeader2(string3, indentPerLevel) {
      var indentIndicator = needIndentIndicator2(string3) ? String(indentPerLevel) : "";
      var clip = string3[string3.length - 1] === "\n";
      var keep = clip && (string3[string3.length - 2] === "\n" || string3 === "\n");
      var chomp = keep ? "+" : clip ? "" : "-";
      return indentIndicator + chomp + "\n";
    }
    function dropEndingNewline2(string3) {
      return string3[string3.length - 1] === "\n" ? string3.slice(0, -1) : string3;
    }
    function foldString2(string3, width) {
      var lineRe = /(\n+)([^\n]*)/g;
      var result = function() {
        var nextLF = string3.indexOf("\n");
        nextLF = nextLF !== -1 ? nextLF : string3.length;
        lineRe.lastIndex = nextLF;
        return foldLine2(string3.slice(0, nextLF), width);
      }();
      var prevMoreIndented = string3[0] === "\n" || string3[0] === " ";
      var moreIndented;
      var match;
      while (match = lineRe.exec(string3)) {
        var prefix = match[1], line = match[2];
        moreIndented = line[0] === " ";
        result += prefix + (!prevMoreIndented && !moreIndented && line !== "" ? "\n" : "") + foldLine2(line, width);
        prevMoreIndented = moreIndented;
      }
      return result;
    }
    function foldLine2(line, width) {
      if (line === "" || line[0] === " ") return line;
      var breakRe = / [^ ]/g;
      var match;
      var start = 0, end, curr = 0, next = 0;
      var result = "";
      while (match = breakRe.exec(line)) {
        next = match.index;
        if (next - start > width) {
          end = curr > start ? curr : next;
          result += "\n" + line.slice(start, end);
          start = end + 1;
        }
        curr = next;
      }
      result += "\n";
      if (line.length - start > width && curr > start) {
        result += line.slice(start, curr) + "\n" + line.slice(curr + 1);
      } else {
        result += line.slice(start);
      }
      return result.slice(1);
    }
    function escapeString2(string3) {
      var result = "";
      var char = 0;
      var escapeSeq;
      for (var i = 0; i < string3.length; char >= 65536 ? i += 2 : i++) {
        char = codePointAt2(string3, i);
        escapeSeq = ESCAPE_SEQUENCES2[char];
        if (!escapeSeq && isPrintable2(char)) {
          result += string3[i];
          if (char >= 65536) result += string3[i + 1];
        } else {
          result += escapeSeq || encodeHex2(char);
        }
      }
      return result;
    }
    function writeFlowSequence2(state, level, object3) {
      var _result = "", _tag = state.tag, index, length, value;
      for (index = 0, length = object3.length; index < length; index += 1) {
        value = object3[index];
        if (state.replacer) {
          value = state.replacer.call(object3, String(index), value);
        }
        if (writeNode2(state, level, value, false, false) || typeof value === "undefined" && writeNode2(state, level, null, false, false)) {
          if (_result !== "") _result += "," + (!state.condenseFlow ? " " : "");
          _result += state.dump;
        }
      }
      state.tag = _tag;
      state.dump = "[" + _result + "]";
    }
    function writeBlockSequence2(state, level, object3, compact2) {
      var _result = "", _tag = state.tag, index, length, value;
      for (index = 0, length = object3.length; index < length; index += 1) {
        value = object3[index];
        if (state.replacer) {
          value = state.replacer.call(object3, String(index), value);
        }
        if (writeNode2(state, level + 1, value, true, true, false, true) || typeof value === "undefined" && writeNode2(state, level + 1, null, true, true, false, true)) {
          if (!compact2 || _result !== "") {
            _result += generateNextLine2(state, level);
          }
          if (state.dump && CHAR_LINE_FEED2 === state.dump.charCodeAt(0)) {
            _result += "-";
          } else {
            _result += "- ";
          }
          _result += state.dump;
        }
      }
      state.tag = _tag;
      state.dump = _result || "[]";
    }
    function writeFlowMapping2(state, level, object3) {
      var _result = "", _tag = state.tag, objectKeyList = Object.keys(object3), index, length, objectKey, objectValue, pairBuffer;
      for (index = 0, length = objectKeyList.length; index < length; index += 1) {
        pairBuffer = "";
        if (_result !== "") pairBuffer += ", ";
        if (state.condenseFlow) pairBuffer += '"';
        objectKey = objectKeyList[index];
        objectValue = object3[objectKey];
        if (state.replacer) {
          objectValue = state.replacer.call(object3, objectKey, objectValue);
        }
        if (!writeNode2(state, level, objectKey, false, false)) {
          continue;
        }
        if (state.dump.length > 1024) pairBuffer += "? ";
        pairBuffer += state.dump + (state.condenseFlow ? '"' : "") + ":" + (state.condenseFlow ? "" : " ");
        if (!writeNode2(state, level, objectValue, false, false)) {
          continue;
        }
        pairBuffer += state.dump;
        _result += pairBuffer;
      }
      state.tag = _tag;
      state.dump = "{" + _result + "}";
    }
    function writeBlockMapping2(state, level, object3, compact2) {
      var _result = "", _tag = state.tag, objectKeyList = Object.keys(object3), index, length, objectKey, objectValue, explicitPair, pairBuffer;
      if (state.sortKeys === true) {
        objectKeyList.sort();
      } else if (typeof state.sortKeys === "function") {
        objectKeyList.sort(state.sortKeys);
      } else if (state.sortKeys) {
        throw new YAMLException2("sortKeys must be a boolean or a function");
      }
      for (index = 0, length = objectKeyList.length; index < length; index += 1) {
        pairBuffer = "";
        if (!compact2 || _result !== "") {
          pairBuffer += generateNextLine2(state, level);
        }
        objectKey = objectKeyList[index];
        objectValue = object3[objectKey];
        if (state.replacer) {
          objectValue = state.replacer.call(object3, objectKey, objectValue);
        }
        if (!writeNode2(state, level + 1, objectKey, true, true, true)) {
          continue;
        }
        explicitPair = state.tag !== null && state.tag !== "?" || state.dump && state.dump.length > 1024;
        if (explicitPair) {
          if (state.dump && CHAR_LINE_FEED2 === state.dump.charCodeAt(0)) {
            pairBuffer += "?";
          } else {
            pairBuffer += "? ";
          }
        }
        pairBuffer += state.dump;
        if (explicitPair) {
          pairBuffer += generateNextLine2(state, level);
        }
        if (!writeNode2(state, level + 1, objectValue, true, explicitPair)) {
          continue;
        }
        if (state.dump && CHAR_LINE_FEED2 === state.dump.charCodeAt(0)) {
          pairBuffer += ":";
        } else {
          pairBuffer += ": ";
        }
        pairBuffer += state.dump;
        _result += pairBuffer;
      }
      state.tag = _tag;
      state.dump = _result || "{}";
    }
    function detectType2(state, object3, explicit) {
      var _result, typeList, index, length, type2, style;
      typeList = explicit ? state.explicitTypes : state.implicitTypes;
      for (index = 0, length = typeList.length; index < length; index += 1) {
        type2 = typeList[index];
        if ((type2.instanceOf || type2.predicate) && (!type2.instanceOf || typeof object3 === "object" && object3 instanceof type2.instanceOf) && (!type2.predicate || type2.predicate(object3))) {
          if (explicit) {
            if (type2.multi && type2.representName) {
              state.tag = type2.representName(object3);
            } else {
              state.tag = type2.tag;
            }
          } else {
            state.tag = "?";
          }
          if (type2.represent) {
            style = state.styleMap[type2.tag] || type2.defaultStyle;
            if (_toString2.call(type2.represent) === "[object Function]") {
              _result = type2.represent(object3, style);
            } else if (_hasOwnProperty2.call(type2.represent, style)) {
              _result = type2.represent[style](object3, style);
            } else {
              throw new YAMLException2("!<" + type2.tag + '> tag resolver accepts not "' + style + '" style');
            }
            state.dump = _result;
          }
          return true;
        }
      }
      return false;
    }
    function writeNode2(state, level, object3, block, compact2, iskey, isblockseq) {
      state.tag = null;
      state.dump = object3;
      if (!detectType2(state, object3, false)) {
        detectType2(state, object3, true);
      }
      var type2 = _toString2.call(state.dump);
      var inblock = block;
      var tagStr;
      if (block) {
        block = state.flowLevel < 0 || state.flowLevel > level;
      }
      var objectOrArray = type2 === "[object Object]" || type2 === "[object Array]", duplicateIndex, duplicate;
      if (objectOrArray) {
        duplicateIndex = state.duplicates.indexOf(object3);
        duplicate = duplicateIndex !== -1;
      }
      if (state.tag !== null && state.tag !== "?" || duplicate || state.indent !== 2 && level > 0) {
        compact2 = false;
      }
      if (duplicate && state.usedDuplicates[duplicateIndex]) {
        state.dump = "*ref_" + duplicateIndex;
      } else {
        if (objectOrArray && duplicate && !state.usedDuplicates[duplicateIndex]) {
          state.usedDuplicates[duplicateIndex] = true;
        }
        if (type2 === "[object Object]") {
          if (block && Object.keys(state.dump).length !== 0) {
            writeBlockMapping2(state, level, state.dump, compact2);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + state.dump;
            }
          } else {
            writeFlowMapping2(state, level, state.dump);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + " " + state.dump;
            }
          }
        } else if (type2 === "[object Array]") {
          if (block && state.dump.length !== 0) {
            if (state.noArrayIndent && !isblockseq && level > 0) {
              writeBlockSequence2(state, level - 1, state.dump, compact2);
            } else {
              writeBlockSequence2(state, level, state.dump, compact2);
            }
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + state.dump;
            }
          } else {
            writeFlowSequence2(state, level, state.dump);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + " " + state.dump;
            }
          }
        } else if (type2 === "[object String]") {
          if (state.tag !== "?") {
            writeScalar2(state, state.dump, level, iskey, inblock);
          }
        } else if (type2 === "[object Undefined]") {
          return false;
        } else {
          if (state.skipInvalid) return false;
          throw new YAMLException2("unacceptable kind of an object to dump " + type2);
        }
        if (state.tag !== null && state.tag !== "?") {
          tagStr = encodeURI(
            state.tag[0] === "!" ? state.tag.slice(1) : state.tag
          ).replace(/!/g, "%21");
          if (state.tag[0] === "!") {
            tagStr = "!" + tagStr;
          } else if (tagStr.slice(0, 18) === "tag:yaml.org,2002:") {
            tagStr = "!!" + tagStr.slice(18);
          } else {
            tagStr = "!<" + tagStr + ">";
          }
          state.dump = tagStr + " " + state.dump;
        }
      }
      return true;
    }
    function getDuplicateReferences2(object3, state) {
      var objects = [], duplicatesIndexes = [], index, length;
      inspectNode2(object3, objects, duplicatesIndexes);
      for (index = 0, length = duplicatesIndexes.length; index < length; index += 1) {
        state.duplicates.push(objects[duplicatesIndexes[index]]);
      }
      state.usedDuplicates = new Array(length);
    }
    function inspectNode2(object3, objects, duplicatesIndexes) {
      var objectKeyList, index, length;
      if (object3 !== null && typeof object3 === "object") {
        index = objects.indexOf(object3);
        if (index !== -1) {
          if (duplicatesIndexes.indexOf(index) === -1) {
            duplicatesIndexes.push(index);
          }
        } else {
          objects.push(object3);
          if (Array.isArray(object3)) {
            for (index = 0, length = object3.length; index < length; index += 1) {
              inspectNode2(object3[index], objects, duplicatesIndexes);
            }
          } else {
            objectKeyList = Object.keys(object3);
            for (index = 0, length = objectKeyList.length; index < length; index += 1) {
              inspectNode2(object3[objectKeyList[index]], objects, duplicatesIndexes);
            }
          }
        }
      }
    }
    function dump2(input, options) {
      options = options || {};
      var state = new State3(options);
      if (!state.noRefs) getDuplicateReferences2(input, state);
      var value = input;
      if (state.replacer) {
        value = state.replacer.call({ "": value }, "", value);
      }
      if (writeNode2(state, 0, value, true, true)) return state.dump + "\n";
      return "";
    }
    module2.exports.dump = dump2;
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/index.js
var require_js_yaml = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/index.js"(exports2, module2) {
    "use strict";
    var loader2 = require_loader();
    var dumper2 = require_dumper();
    function renamed2(from, to) {
      return function() {
        throw new Error("Function yaml." + from + " is removed in js-yaml 4. Use yaml." + to + " instead, which is now safe by default.");
      };
    }
    module2.exports.Type = require_type();
    module2.exports.Schema = require_schema4();
    module2.exports.FAILSAFE_SCHEMA = require_failsafe();
    module2.exports.JSON_SCHEMA = require_json();
    module2.exports.CORE_SCHEMA = require_core();
    module2.exports.DEFAULT_SCHEMA = require_default();
    module2.exports.load = loader2.load;
    module2.exports.loadAll = loader2.loadAll;
    module2.exports.dump = dumper2.dump;
    module2.exports.YAMLException = require_exception();
    module2.exports.types = {
      binary: require_binary2(),
      float: require_float3(),
      map: require_map2(),
      null: require_null2(),
      pairs: require_pairs2(),
      set: require_set2(),
      timestamp: require_timestamp2(),
      bool: require_bool3(),
      int: require_int3(),
      merge: require_merge(),
      omap: require_omap2(),
      seq: require_seq2(),
      str: require_str()
    };
    module2.exports.safeLoad = renamed2("safeLoad", "load");
    module2.exports.safeLoadAll = renamed2("safeLoadAll", "loadAll");
    module2.exports.safeDump = renamed2("safeDump", "dump");
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/js-yaml/index.js
var require_js_yaml2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/js-yaml/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.stringifyYaml = exports2.parseYaml = void 0;
    var js_yaml_1 = require_js_yaml();
    var DEFAULT_SCHEMA_WITHOUT_TIMESTAMP = js_yaml_1.JSON_SCHEMA.extend({
      implicit: [js_yaml_1.types.merge],
      explicit: [js_yaml_1.types.binary, js_yaml_1.types.omap, js_yaml_1.types.pairs, js_yaml_1.types.set]
    });
    var parseYaml = (str2, opts) => (0, js_yaml_1.load)(str2, Object.assign({ schema: DEFAULT_SCHEMA_WITHOUT_TIMESTAMP }, opts));
    exports2.parseYaml = parseYaml;
    var stringifyYaml = (obj, opts) => (0, js_yaml_1.dump)(obj, opts);
    exports2.stringifyYaml = stringifyYaml;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/env.js
var require_env = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/env.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.env = exports2.isBrowser = void 0;
    exports2.isBrowser = // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-ignore
    typeof window !== "undefined" || typeof process === "undefined";
    exports2.env = exports2.isBrowser ? {} : process.env || {};
  }
});

// ../../../node_modules/.pnpm/colorette@1.4.0/node_modules/colorette/index.cjs
var require_colorette = __commonJS({
  "../../../node_modules/.pnpm/colorette@1.4.0/node_modules/colorette/index.cjs"(exports2) {
    "use strict";
    var tty = require("tty");
    var env = process.env;
    var isDisabled = "NO_COLOR" in env;
    var isForced = "FORCE_COLOR" in env;
    var isWindows = process.platform === "win32";
    var isCompatibleTerminal = tty && tty.isatty(1) && env.TERM && env.TERM !== "dumb";
    var isCI = "CI" in env && ("GITHUB_ACTIONS" in env || "GITLAB_CI" in env || "CIRCLECI" in env);
    var enabled = !isDisabled && (isForced || isWindows || isCompatibleTerminal || isCI);
    var raw = (open, close, searchRegex, replaceValue) => (s) => enabled ? open + (~(s += "").indexOf(close, 4) ? s.replace(searchRegex, replaceValue) : s) + close : s;
    var init = (open, close) => {
      return raw(
        `\x1B[${open}m`,
        `\x1B[${close}m`,
        new RegExp(`\\x1b\\[${close}m`, "g"),
        `\x1B[${open}m`
      );
    };
    exports2.options = Object.defineProperty({}, "enabled", {
      get: () => enabled,
      set: (value) => enabled = value
    });
    exports2.reset = init(0, 0);
    exports2.bold = raw("\x1B[1m", "\x1B[22m", /\x1b\[22m/g, "\x1B[22m\x1B[1m");
    exports2.dim = raw("\x1B[2m", "\x1B[22m", /\x1b\[22m/g, "\x1B[22m\x1B[2m");
    exports2.italic = init(3, 23);
    exports2.underline = init(4, 24);
    exports2.inverse = init(7, 27);
    exports2.hidden = init(8, 28);
    exports2.strikethrough = init(9, 29);
    exports2.black = init(30, 39);
    exports2.red = init(31, 39);
    exports2.green = init(32, 39);
    exports2.yellow = init(33, 39);
    exports2.blue = init(34, 39);
    exports2.magenta = init(35, 39);
    exports2.cyan = init(36, 39);
    exports2.white = init(37, 39);
    exports2.gray = init(90, 39);
    exports2.bgBlack = init(40, 49);
    exports2.bgRed = init(41, 49);
    exports2.bgGreen = init(42, 49);
    exports2.bgYellow = init(43, 49);
    exports2.bgBlue = init(44, 49);
    exports2.bgMagenta = init(45, 49);
    exports2.bgCyan = init(46, 49);
    exports2.bgWhite = init(47, 49);
    exports2.blackBright = init(90, 39);
    exports2.redBright = init(91, 39);
    exports2.greenBright = init(92, 39);
    exports2.yellowBright = init(93, 39);
    exports2.blueBright = init(94, 39);
    exports2.magentaBright = init(95, 39);
    exports2.cyanBright = init(96, 39);
    exports2.whiteBright = init(97, 39);
    exports2.bgBlackBright = init(100, 49);
    exports2.bgRedBright = init(101, 49);
    exports2.bgGreenBright = init(102, 49);
    exports2.bgYellowBright = init(103, 49);
    exports2.bgBlueBright = init(104, 49);
    exports2.bgMagentaBright = init(105, 49);
    exports2.bgCyanBright = init(106, 49);
    exports2.bgWhiteBright = init(107, 49);
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/logger.js
var require_logger = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/logger.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.logger = exports2.colorize = exports2.colorOptions = void 0;
    var colorette = require_colorette();
    var colorette_1 = require_colorette();
    Object.defineProperty(exports2, "colorOptions", { enumerable: true, get: function() {
      return colorette_1.options;
    } });
    var env_1 = require_env();
    var utils_1 = require_utils4();
    exports2.colorize = new Proxy(colorette, {
      get(target, prop) {
        if (env_1.isBrowser) {
          return utils_1.identity;
        }
        return target[prop];
      }
    });
    var Logger = class {
      stderr(str2) {
        return process.stderr.write(str2);
      }
      info(str2) {
        return env_1.isBrowser ? console.log(str2) : this.stderr(str2);
      }
      warn(str2) {
        return env_1.isBrowser ? console.warn(str2) : this.stderr(exports2.colorize.yellow(str2));
      }
      error(str2) {
        return env_1.isBrowser ? console.error(str2) : this.stderr(exports2.colorize.red(str2));
      }
    };
    exports2.logger = new Logger();
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/utils.js
var require_utils4 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/utils.js"(exports2) {
    "use strict";
    var __awaiter = exports2 && exports2.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.nextTick = exports2.pickDefined = exports2.keysOf = exports2.identity = exports2.isTruthy = exports2.showErrorForDeprecatedField = exports2.showWarningForDeprecatedField = exports2.doesYamlFileExist = exports2.isCustomRuleId = exports2.getMatchingStatusCodeRange = exports2.assignExisting = exports2.isNotString = exports2.isString = exports2.isNotEmptyObject = exports2.slash = exports2.isPathParameter = exports2.yamlAndJsonSyncReader = exports2.readFileAsStringSync = exports2.isSingular = exports2.validateMimeTypeOAS3 = exports2.validateMimeType = exports2.splitCamelCaseIntoWords = exports2.omitObjectProps = exports2.pickObjectProps = exports2.readFileFromUrl = exports2.isEmptyArray = exports2.isEmptyObject = exports2.isPlainObject = exports2.isDefined = exports2.loadYaml = exports2.popStack = exports2.pushStack = exports2.stringifyYaml = exports2.parseYaml = void 0;
    var fs = require("fs");
    var path_1 = require("path");
    var minimatch = require_minimatch();
    var node_fetch_1 = (init_lib2(), __toCommonJS(lib_exports2));
    var pluralize = require_pluralize();
    var js_yaml_1 = require_js_yaml2();
    var env_1 = require_env();
    var logger_1 = require_logger();
    var js_yaml_2 = require_js_yaml2();
    Object.defineProperty(exports2, "parseYaml", { enumerable: true, get: function() {
      return js_yaml_2.parseYaml;
    } });
    Object.defineProperty(exports2, "stringifyYaml", { enumerable: true, get: function() {
      return js_yaml_2.stringifyYaml;
    } });
    function pushStack(head, value) {
      return { prev: head, value };
    }
    exports2.pushStack = pushStack;
    function popStack(head) {
      var _a;
      return (_a = head === null || head === void 0 ? void 0 : head.prev) !== null && _a !== void 0 ? _a : null;
    }
    exports2.popStack = popStack;
    function loadYaml(filename) {
      return __awaiter(this, void 0, void 0, function* () {
        const contents = yield fs.promises.readFile(filename, "utf-8");
        return (0, js_yaml_1.parseYaml)(contents);
      });
    }
    exports2.loadYaml = loadYaml;
    function isDefined(x) {
      return x !== void 0;
    }
    exports2.isDefined = isDefined;
    function isPlainObject5(value) {
      return value !== null && typeof value === "object" && !Array.isArray(value);
    }
    exports2.isPlainObject = isPlainObject5;
    function isEmptyObject(value) {
      return isPlainObject5(value) && Object.keys(value).length === 0;
    }
    exports2.isEmptyObject = isEmptyObject;
    function isEmptyArray(value) {
      return Array.isArray(value) && value.length === 0;
    }
    exports2.isEmptyArray = isEmptyArray;
    function readFileFromUrl(url, config) {
      return __awaiter(this, void 0, void 0, function* () {
        const headers = {};
        for (const header of config.headers) {
          if (match(url, header.matches)) {
            headers[header.name] = header.envVariable !== void 0 ? env_1.env[header.envVariable] || "" : header.value;
          }
        }
        const req = yield (config.customFetch || node_fetch_1.default)(url, {
          headers
        });
        if (!req.ok) {
          throw new Error(`Failed to load ${url}: ${req.status} ${req.statusText}`);
        }
        return { body: yield req.text(), mimeType: req.headers.get("content-type") };
      });
    }
    exports2.readFileFromUrl = readFileFromUrl;
    function match(url, pattern) {
      if (!pattern.match(/^https?:\/\//)) {
        url = url.replace(/^https?:\/\//, "");
      }
      return minimatch(url, pattern);
    }
    function pickObjectProps(object3, keys5) {
      return Object.fromEntries(keys5.filter((key) => key in object3).map((key) => [key, object3[key]]));
    }
    exports2.pickObjectProps = pickObjectProps;
    function omitObjectProps(object3, keys5) {
      return Object.fromEntries(Object.entries(object3).filter(([key]) => !keys5.includes(key)));
    }
    exports2.omitObjectProps = omitObjectProps;
    function splitCamelCaseIntoWords(str2) {
      const camel = str2.split(/(?:[-._])|([A-Z][a-z]+)/).filter(isTruthy).map((item) => item.toLocaleLowerCase());
      const caps = str2.split(/([A-Z]{2,})/).filter((e) => e && e === e.toUpperCase()).map((item) => item.toLocaleLowerCase());
      return /* @__PURE__ */ new Set([...camel, ...caps]);
    }
    exports2.splitCamelCaseIntoWords = splitCamelCaseIntoWords;
    function validateMimeType({ type: type2, value }, { report, location }, allowedValues) {
      const ruleType = type2 === "consumes" ? "request" : "response";
      if (!allowedValues)
        throw new Error(`Parameter "allowedValues" is not provided for "${ruleType}-mime-type" rule`);
      if (!value[type2])
        return;
      for (const mime of value[type2]) {
        if (!allowedValues.includes(mime)) {
          report({
            message: `Mime type "${mime}" is not allowed`,
            location: location.child(value[type2].indexOf(mime)).key()
          });
        }
      }
    }
    exports2.validateMimeType = validateMimeType;
    function validateMimeTypeOAS3({ type: type2, value }, { report, location }, allowedValues) {
      const ruleType = type2 === "consumes" ? "request" : "response";
      if (!allowedValues)
        throw new Error(`Parameter "allowedValues" is not provided for "${ruleType}-mime-type" rule`);
      if (!value.content)
        return;
      for (const mime of Object.keys(value.content)) {
        if (!allowedValues.includes(mime)) {
          report({
            message: `Mime type "${mime}" is not allowed`,
            location: location.child("content").child(mime).key()
          });
        }
      }
    }
    exports2.validateMimeTypeOAS3 = validateMimeTypeOAS3;
    function isSingular(path5) {
      return pluralize.isSingular(path5);
    }
    exports2.isSingular = isSingular;
    function readFileAsStringSync(filePath) {
      return fs.readFileSync(filePath, "utf-8");
    }
    exports2.readFileAsStringSync = readFileAsStringSync;
    function yamlAndJsonSyncReader(filePath) {
      const content = fs.readFileSync(filePath, "utf-8");
      return (0, js_yaml_1.parseYaml)(content);
    }
    exports2.yamlAndJsonSyncReader = yamlAndJsonSyncReader;
    function isPathParameter(pathSegment) {
      return pathSegment.startsWith("{") && pathSegment.endsWith("}");
    }
    exports2.isPathParameter = isPathParameter;
    function slash(path5) {
      const isExtendedLengthPath = /^\\\\\?\\/.test(path5);
      if (isExtendedLengthPath) {
        return path5;
      }
      return path5.replace(/\\/g, "/");
    }
    exports2.slash = slash;
    function isNotEmptyObject(obj) {
      return !!obj && Object.keys(obj).length > 0;
    }
    exports2.isNotEmptyObject = isNotEmptyObject;
    function isString2(value) {
      return typeof value === "string";
    }
    exports2.isString = isString2;
    function isNotString(value) {
      return !isString2(value);
    }
    exports2.isNotString = isNotString;
    function assignExisting(target, obj) {
      for (const k of Object.keys(obj)) {
        if (target.hasOwnProperty(k)) {
          target[k] = obj[k];
        }
      }
    }
    exports2.assignExisting = assignExisting;
    function getMatchingStatusCodeRange(code) {
      return `${code}`.replace(/^(\d)\d\d$/, (_, firstDigit) => `${firstDigit}XX`);
    }
    exports2.getMatchingStatusCodeRange = getMatchingStatusCodeRange;
    function isCustomRuleId(id) {
      return id.includes("/");
    }
    exports2.isCustomRuleId = isCustomRuleId;
    function doesYamlFileExist(filePath) {
      return ((0, path_1.extname)(filePath) === ".yaml" || (0, path_1.extname)(filePath) === ".yml") && fs.hasOwnProperty("existsSync") && fs.existsSync(filePath);
    }
    exports2.doesYamlFileExist = doesYamlFileExist;
    function showWarningForDeprecatedField(deprecatedField, updatedField, updatedObject) {
      logger_1.logger.warn(`The '${logger_1.colorize.red(deprecatedField)}' field is deprecated. ${updatedField ? `Use ${logger_1.colorize.green(getUpdatedFieldName(updatedField, updatedObject))} instead. ` : ""}Read more about this change: https://redocly.com/docs/api-registry/guides/migration-guide-config-file/#changed-properties
`);
    }
    exports2.showWarningForDeprecatedField = showWarningForDeprecatedField;
    function showErrorForDeprecatedField(deprecatedField, updatedField, updatedObject) {
      throw new Error(`Do not use '${deprecatedField}' field. ${updatedField ? `Use '${getUpdatedFieldName(updatedField, updatedObject)}' instead. ` : ""}
`);
    }
    exports2.showErrorForDeprecatedField = showErrorForDeprecatedField;
    function isTruthy(value) {
      return !!value;
    }
    exports2.isTruthy = isTruthy;
    function identity2(value) {
      return value;
    }
    exports2.identity = identity2;
    function keysOf(obj) {
      if (!obj)
        return [];
      return Object.keys(obj);
    }
    exports2.keysOf = keysOf;
    function pickDefined(obj) {
      if (!obj)
        return void 0;
      const res = {};
      for (const key in obj) {
        if (obj[key] !== void 0) {
          res[key] = obj[key];
        }
      }
      return res;
    }
    exports2.pickDefined = pickDefined;
    function nextTick() {
      new Promise((resolve) => {
        setTimeout(resolve);
      });
    }
    exports2.nextTick = nextTick;
    function getUpdatedFieldName(updatedField, updatedObject) {
      return `${typeof updatedObject !== "undefined" ? `${updatedObject}.` : ""}${updatedField}`;
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/index.js
var require_types = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isNamedType = exports2.normalizeTypes = exports2.SpecExtension = exports2.mapOf = exports2.listOf = void 0;
    function listOf(typeName) {
      return {
        name: `${typeName}List`,
        properties: {},
        items: typeName
      };
    }
    exports2.listOf = listOf;
    function mapOf(typeName) {
      return {
        name: `${typeName}Map`,
        properties: {},
        additionalProperties: () => typeName
      };
    }
    exports2.mapOf = mapOf;
    exports2.SpecExtension = {
      name: "SpecExtension",
      properties: {},
      // skip validation of additional properties for unknown extensions
      additionalProperties: { resolvable: true }
    };
    function normalizeTypes(types2, options = {}) {
      const normalizedTypes = {};
      for (const typeName of Object.keys(types2)) {
        normalizedTypes[typeName] = Object.assign(Object.assign({}, types2[typeName]), { name: typeName });
      }
      for (const type2 of Object.values(normalizedTypes)) {
        normalizeType(type2);
      }
      normalizedTypes["SpecExtension"] = exports2.SpecExtension;
      return normalizedTypes;
      function normalizeType(type2) {
        if (type2.additionalProperties) {
          type2.additionalProperties = resolveType(type2.additionalProperties);
        }
        if (type2.items) {
          type2.items = resolveType(type2.items);
        }
        if (type2.properties) {
          const mappedProps = {};
          for (const [propName, prop] of Object.entries(type2.properties)) {
            mappedProps[propName] = resolveType(prop);
            if (options.doNotResolveExamples && prop && prop.isExample) {
              mappedProps[propName] = Object.assign(Object.assign({}, prop), { resolvable: false });
            }
          }
          type2.properties = mappedProps;
        }
      }
      function resolveType(type2) {
        if (typeof type2 === "string") {
          if (!normalizedTypes[type2]) {
            throw new Error(`Unknown type name found: ${type2}`);
          }
          return normalizedTypes[type2];
        } else if (typeof type2 === "function") {
          return (value, key) => {
            return resolveType(type2(value, key));
          };
        } else if (type2 && type2.name) {
          type2 = Object.assign({}, type2);
          normalizeType(type2);
          return type2;
        } else if (type2 && type2.directResolveAs) {
          return Object.assign(Object.assign({}, type2), { directResolveAs: resolveType(type2.directResolveAs) });
        } else {
          return type2;
        }
      }
    }
    exports2.normalizeTypes = normalizeTypes;
    function isNamedType(t) {
      return typeof (t === null || t === void 0 ? void 0 : t.name) === "string";
    }
    exports2.isNamedType = isNamedType;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/ref-utils.js
var require_ref_utils = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/ref-utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isAnchor = exports2.isMappingRef = exports2.isAbsoluteUrl = exports2.refBaseName = exports2.pointerBaseName = exports2.parsePointer = exports2.parseRef = exports2.escapePointer = exports2.unescapePointer = exports2.Location = exports2.isRef = exports2.joinPointer = void 0;
    var utils_1 = require_utils4();
    function joinPointer(base, key) {
      if (base === "")
        base = "#/";
      return base[base.length - 1] === "/" ? base + key : base + "/" + key;
    }
    exports2.joinPointer = joinPointer;
    function isRef(node) {
      return node && typeof node.$ref === "string";
    }
    exports2.isRef = isRef;
    var Location = class _Location {
      constructor(source, pointer) {
        this.source = source;
        this.pointer = pointer;
      }
      child(components) {
        return new _Location(this.source, joinPointer(this.pointer, (Array.isArray(components) ? components : [components]).map(escapePointer).join("/")));
      }
      key() {
        return Object.assign(Object.assign({}, this), { reportOnKey: true });
      }
      get absolutePointer() {
        return this.source.absoluteRef + (this.pointer === "#/" ? "" : this.pointer);
      }
    };
    exports2.Location = Location;
    function unescapePointer(fragment) {
      return decodeURIComponent(fragment.replace(/~1/g, "/").replace(/~0/g, "~"));
    }
    exports2.unescapePointer = unescapePointer;
    function escapePointer(fragment) {
      if (typeof fragment === "number")
        return fragment;
      return fragment.replace(/~/g, "~0").replace(/\//g, "~1");
    }
    exports2.escapePointer = escapePointer;
    function parseRef(ref) {
      const [uri, pointer] = ref.split("#/");
      return {
        uri: uri || null,
        pointer: pointer ? pointer.split("/").map(unescapePointer).filter(utils_1.isTruthy) : []
      };
    }
    exports2.parseRef = parseRef;
    function parsePointer(pointer) {
      return pointer.substr(2).split("/").map(unescapePointer);
    }
    exports2.parsePointer = parsePointer;
    function pointerBaseName(pointer) {
      const parts = pointer.split("/");
      return parts[parts.length - 1];
    }
    exports2.pointerBaseName = pointerBaseName;
    function refBaseName(ref) {
      const parts = ref.split(/[\/\\]/);
      return parts[parts.length - 1].replace(/\.[^.]+$/, "");
    }
    exports2.refBaseName = refBaseName;
    function isAbsoluteUrl(ref) {
      return ref.startsWith("http://") || ref.startsWith("https://");
    }
    exports2.isAbsoluteUrl = isAbsoluteUrl;
    function isMappingRef(mapping) {
      return mapping.startsWith("#") || mapping.startsWith("https://") || mapping.startsWith("http://") || mapping.startsWith("./") || mapping.startsWith("../") || mapping.indexOf("/") > -1;
    }
    exports2.isMappingRef = isMappingRef;
    function isAnchor(ref) {
      return /^#[A-Za-z][A-Za-z0-9\-_:.]*$/.test(ref);
    }
    exports2.isAnchor = isAnchor;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/oas3.js
var require_oas3 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/oas3.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Oas3Types = void 0;
    var _1 = require_types();
    var ref_utils_1 = require_ref_utils();
    var responseCodeRegexp = /^[0-9][0-9Xx]{2}$/;
    var Root = {
      properties: {
        openapi: null,
        info: "Info",
        servers: "ServerList",
        security: "SecurityRequirementList",
        tags: "TagList",
        externalDocs: "ExternalDocs",
        paths: "Paths",
        components: "Components",
        "x-webhooks": "WebhooksMap",
        "x-tagGroups": "TagGroups",
        "x-ignoredHeaderParameters": { type: "array", items: { type: "string" } }
      },
      required: ["openapi", "paths", "info"],
      extensionsPrefix: "x-"
    };
    var Tag = {
      properties: {
        name: { type: "string" },
        description: { type: "string" },
        externalDocs: "ExternalDocs",
        "x-traitTag": { type: "boolean" },
        "x-displayName": { type: "string" }
      },
      required: ["name"],
      extensionsPrefix: "x-"
    };
    var TagGroup = {
      properties: {
        name: { type: "string" },
        tags: { type: "array", items: { type: "string" } }
      },
      extensionsPrefix: "x-"
    };
    var ExternalDocs = {
      properties: {
        description: { type: "string" },
        url: { type: "string" }
      },
      required: ["url"],
      extensionsPrefix: "x-"
    };
    var Server = {
      properties: {
        url: { type: "string" },
        description: { type: "string" },
        variables: "ServerVariablesMap"
      },
      required: ["url"],
      extensionsPrefix: "x-"
    };
    var ServerVariable = {
      properties: {
        enum: {
          type: "array",
          items: { type: "string" }
        },
        default: { type: "string" },
        description: { type: "string" }
      },
      required: ["default"],
      extensionsPrefix: "x-"
    };
    var SecurityRequirement = {
      properties: {},
      additionalProperties: { type: "array", items: { type: "string" } }
    };
    var Info = {
      properties: {
        title: { type: "string" },
        version: { type: "string" },
        description: { type: "string" },
        termsOfService: { type: "string" },
        contact: "Contact",
        license: "License",
        "x-logo": "Logo"
      },
      required: ["title", "version"],
      extensionsPrefix: "x-"
    };
    var Logo = {
      properties: {
        url: { type: "string" },
        altText: { type: "string" },
        backgroundColor: { type: "string" },
        href: { type: "string" }
      }
    };
    var Contact = {
      properties: {
        name: { type: "string" },
        url: { type: "string" },
        email: { type: "string" }
      },
      extensionsPrefix: "x-"
    };
    var License = {
      properties: {
        name: { type: "string" },
        url: { type: "string" }
      },
      required: ["name"],
      extensionsPrefix: "x-"
    };
    var Paths = {
      properties: {},
      additionalProperties: (_value, key) => key.startsWith("/") ? "PathItem" : void 0
    };
    var WebhooksMap = {
      properties: {},
      additionalProperties: () => "PathItem"
    };
    var PathItem = {
      properties: {
        $ref: { type: "string" },
        servers: "ServerList",
        parameters: "ParameterList",
        summary: { type: "string" },
        description: { type: "string" },
        get: "Operation",
        put: "Operation",
        post: "Operation",
        delete: "Operation",
        options: "Operation",
        head: "Operation",
        patch: "Operation",
        trace: "Operation"
      },
      extensionsPrefix: "x-"
    };
    var Parameter = {
      properties: {
        name: { type: "string" },
        in: { enum: ["query", "header", "path", "cookie"] },
        description: { type: "string" },
        required: { type: "boolean" },
        deprecated: { type: "boolean" },
        allowEmptyValue: { type: "boolean" },
        style: {
          enum: ["form", "simple", "label", "matrix", "spaceDelimited", "pipeDelimited", "deepObject"]
        },
        explode: { type: "boolean" },
        allowReserved: { type: "boolean" },
        schema: "Schema",
        example: { isExample: true },
        examples: "ExamplesMap",
        content: "MediaTypesMap"
      },
      required: ["name", "in"],
      requiredOneOf: ["schema", "content"],
      extensionsPrefix: "x-"
    };
    var Operation = {
      properties: {
        tags: {
          type: "array",
          items: { type: "string" }
        },
        summary: { type: "string" },
        description: { type: "string" },
        externalDocs: "ExternalDocs",
        operationId: { type: "string" },
        parameters: "ParameterList",
        security: "SecurityRequirementList",
        servers: "ServerList",
        requestBody: "RequestBody",
        responses: "Responses",
        deprecated: { type: "boolean" },
        callbacks: "CallbacksMap",
        "x-codeSamples": "XCodeSampleList",
        "x-code-samples": "XCodeSampleList",
        "x-hideTryItPanel": { type: "boolean" }
      },
      required: ["responses"],
      extensionsPrefix: "x-"
    };
    var XCodeSample = {
      properties: {
        lang: { type: "string" },
        label: { type: "string" },
        source: { type: "string" }
      }
    };
    var RequestBody = {
      properties: {
        description: { type: "string" },
        required: { type: "boolean" },
        content: "MediaTypesMap"
      },
      required: ["content"],
      extensionsPrefix: "x-"
    };
    var MediaTypesMap = {
      properties: {},
      additionalProperties: "MediaType"
    };
    var MediaType2 = {
      properties: {
        schema: "Schema",
        example: { isExample: true },
        examples: "ExamplesMap",
        encoding: "EncodingMap"
      },
      extensionsPrefix: "x-"
    };
    var Example = {
      properties: {
        value: { isExample: true },
        summary: { type: "string" },
        description: { type: "string" },
        externalValue: { type: "string" }
      },
      extensionsPrefix: "x-"
    };
    var Encoding2 = {
      properties: {
        contentType: { type: "string" },
        headers: "HeadersMap",
        style: {
          enum: ["form", "simple", "label", "matrix", "spaceDelimited", "pipeDelimited", "deepObject"]
        },
        explode: { type: "boolean" },
        allowReserved: { type: "boolean" }
      },
      extensionsPrefix: "x-"
    };
    var EnumDescriptions = {
      properties: {},
      additionalProperties: { type: "string" }
    };
    var Header = {
      properties: {
        description: { type: "string" },
        required: { type: "boolean" },
        deprecated: { type: "boolean" },
        allowEmptyValue: { type: "boolean" },
        style: {
          enum: ["form", "simple", "label", "matrix", "spaceDelimited", "pipeDelimited", "deepObject"]
        },
        explode: { type: "boolean" },
        allowReserved: { type: "boolean" },
        schema: "Schema",
        example: { isExample: true },
        examples: "ExamplesMap",
        content: "MediaTypesMap"
      },
      requiredOneOf: ["schema", "content"],
      extensionsPrefix: "x-"
    };
    var Responses = {
      properties: { default: "Response" },
      additionalProperties: (_v, key) => responseCodeRegexp.test(key) ? "Response" : void 0
    };
    var Response4 = {
      properties: {
        description: { type: "string" },
        headers: "HeadersMap",
        content: "MediaTypesMap",
        links: "LinksMap",
        "x-summary": { type: "string" }
      },
      required: ["description"],
      extensionsPrefix: "x-"
    };
    var Link = {
      properties: {
        operationRef: { type: "string" },
        operationId: { type: "string" },
        parameters: null,
        requestBody: null,
        description: { type: "string" },
        server: "Server"
      },
      extensionsPrefix: "x-"
    };
    var Schema3 = {
      properties: {
        externalDocs: "ExternalDocs",
        discriminator: "Discriminator",
        title: { type: "string" },
        multipleOf: { type: "number", minimum: 0 },
        maximum: { type: "number" },
        minimum: { type: "number" },
        exclusiveMaximum: { type: "boolean" },
        exclusiveMinimum: { type: "boolean" },
        maxLength: { type: "integer", minimum: 0 },
        minLength: { type: "integer", minimum: 0 },
        pattern: { type: "string" },
        maxItems: { type: "integer", minimum: 0 },
        minItems: { type: "integer", minimum: 0 },
        uniqueItems: { type: "boolean" },
        maxProperties: { type: "integer", minimum: 0 },
        minProperties: { type: "integer", minimum: 0 },
        required: { type: "array", items: { type: "string" } },
        enum: { type: "array" },
        type: {
          enum: ["object", "array", "string", "number", "integer", "boolean", "null"]
        },
        allOf: (0, _1.listOf)("Schema"),
        anyOf: (0, _1.listOf)("Schema"),
        oneOf: (0, _1.listOf)("Schema"),
        not: "Schema",
        properties: "SchemaProperties",
        items: (value) => {
          if (Array.isArray(value)) {
            return (0, _1.listOf)("Schema");
          } else {
            return "Schema";
          }
        },
        additionalItems: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        additionalProperties: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        description: { type: "string" },
        format: { type: "string" },
        default: null,
        nullable: { type: "boolean" },
        readOnly: { type: "boolean" },
        writeOnly: { type: "boolean" },
        xml: "Xml",
        example: { isExample: true },
        deprecated: { type: "boolean" },
        "x-tags": { type: "array", items: { type: "string" } },
        "x-additionalPropertiesName": { type: "string" },
        "x-explicitMappingOnly": { type: "boolean" }
      },
      extensionsPrefix: "x-"
    };
    var Xml = {
      properties: {
        name: { type: "string" },
        namespace: { type: "string" },
        prefix: { type: "string" },
        attribute: { type: "boolean" },
        wrapped: { type: "boolean" }
      },
      extensionsPrefix: "x-"
    };
    var SchemaProperties = {
      properties: {},
      additionalProperties: "Schema"
    };
    var DiscriminatorMapping = {
      properties: {},
      additionalProperties: (value) => {
        if ((0, ref_utils_1.isMappingRef)(value)) {
          return { type: "string", directResolveAs: "Schema" };
        } else {
          return { type: "string" };
        }
      }
    };
    var Discriminator = {
      properties: {
        propertyName: { type: "string" },
        mapping: "DiscriminatorMapping"
      },
      required: ["propertyName"],
      extensionsPrefix: "x-"
    };
    var Components = {
      properties: {
        parameters: "NamedParameters",
        schemas: "NamedSchemas",
        responses: "NamedResponses",
        examples: "NamedExamples",
        requestBodies: "NamedRequestBodies",
        headers: "NamedHeaders",
        securitySchemes: "NamedSecuritySchemes",
        links: "NamedLinks",
        callbacks: "NamedCallbacks"
      },
      extensionsPrefix: "x-"
    };
    var ImplicitFlow = {
      properties: {
        refreshUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        authorizationUrl: { type: "string" }
      },
      required: ["authorizationUrl", "scopes"],
      extensionsPrefix: "x-"
    };
    var PasswordFlow = {
      properties: {
        refreshUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        tokenUrl: { type: "string" }
      },
      required: ["tokenUrl", "scopes"],
      extensionsPrefix: "x-"
    };
    var ClientCredentials = {
      properties: {
        refreshUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        tokenUrl: { type: "string" }
      },
      required: ["tokenUrl", "scopes"],
      extensionsPrefix: "x-"
    };
    var AuthorizationCode = {
      properties: {
        refreshUrl: { type: "string" },
        authorizationUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        tokenUrl: { type: "string" },
        "x-usePkce": (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "XUsePkce";
          }
        }
      },
      required: ["authorizationUrl", "tokenUrl", "scopes"],
      extensionsPrefix: "x-"
    };
    var OAuth2Flows = {
      properties: {
        implicit: "ImplicitFlow",
        password: "PasswordFlow",
        clientCredentials: "ClientCredentials",
        authorizationCode: "AuthorizationCode"
      },
      extensionsPrefix: "x-"
    };
    var SecurityScheme2 = {
      properties: {
        type: { enum: ["apiKey", "http", "oauth2", "openIdConnect"] },
        description: { type: "string" },
        name: { type: "string" },
        in: { type: "string", enum: ["query", "header", "cookie"] },
        scheme: { type: "string" },
        bearerFormat: { type: "string" },
        flows: "OAuth2Flows",
        openIdConnectUrl: { type: "string" },
        "x-defaultClientId": { type: "string" }
      },
      required(value) {
        switch (value === null || value === void 0 ? void 0 : value.type) {
          case "apiKey":
            return ["type", "name", "in"];
          case "http":
            return ["type", "scheme"];
          case "oauth2":
            return ["type", "flows"];
          case "openIdConnect":
            return ["type", "openIdConnectUrl"];
          default:
            return ["type"];
        }
      },
      allowed(value) {
        switch (value === null || value === void 0 ? void 0 : value.type) {
          case "apiKey":
            return ["type", "name", "in", "description"];
          case "http":
            return ["type", "scheme", "bearerFormat", "description"];
          case "oauth2":
            return ["type", "flows", "description"];
          case "openIdConnect":
            return ["type", "openIdConnectUrl", "description"];
          default:
            return ["type", "description"];
        }
      },
      extensionsPrefix: "x-"
    };
    var XUsePkce = {
      properties: {
        disableManualConfiguration: { type: "boolean" },
        hideClientSecretInput: { type: "boolean" }
      }
    };
    exports2.Oas3Types = {
      Root,
      Tag,
      TagList: (0, _1.listOf)("Tag"),
      TagGroups: (0, _1.listOf)("TagGroup"),
      TagGroup,
      ExternalDocs,
      Server,
      ServerList: (0, _1.listOf)("Server"),
      ServerVariable,
      ServerVariablesMap: (0, _1.mapOf)("ServerVariable"),
      SecurityRequirement,
      SecurityRequirementList: (0, _1.listOf)("SecurityRequirement"),
      Info,
      Contact,
      License,
      Paths,
      PathItem,
      Parameter,
      ParameterList: (0, _1.listOf)("Parameter"),
      Operation,
      Callback: (0, _1.mapOf)("PathItem"),
      CallbacksMap: (0, _1.mapOf)("Callback"),
      RequestBody,
      MediaTypesMap,
      MediaType: MediaType2,
      Example,
      ExamplesMap: (0, _1.mapOf)("Example"),
      Encoding: Encoding2,
      EncodingMap: (0, _1.mapOf)("Encoding"),
      EnumDescriptions,
      Header,
      HeadersMap: (0, _1.mapOf)("Header"),
      Responses,
      Response: Response4,
      Link,
      Logo,
      Schema: Schema3,
      Xml,
      SchemaProperties,
      DiscriminatorMapping,
      Discriminator,
      Components,
      LinksMap: (0, _1.mapOf)("Link"),
      NamedSchemas: (0, _1.mapOf)("Schema"),
      NamedResponses: (0, _1.mapOf)("Response"),
      NamedParameters: (0, _1.mapOf)("Parameter"),
      NamedExamples: (0, _1.mapOf)("Example"),
      NamedRequestBodies: (0, _1.mapOf)("RequestBody"),
      NamedHeaders: (0, _1.mapOf)("Header"),
      NamedSecuritySchemes: (0, _1.mapOf)("SecurityScheme"),
      NamedLinks: (0, _1.mapOf)("Link"),
      NamedCallbacks: (0, _1.mapOf)("Callback"),
      ImplicitFlow,
      PasswordFlow,
      ClientCredentials,
      AuthorizationCode,
      OAuth2Flows,
      SecurityScheme: SecurityScheme2,
      XCodeSample,
      XCodeSampleList: (0, _1.listOf)("XCodeSample"),
      XUsePkce,
      WebhooksMap
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/oas3_1.js
var require_oas3_1 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/oas3_1.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Oas3_1Types = void 0;
    var _1 = require_types();
    var oas3_1 = require_oas3();
    var Root = {
      properties: {
        openapi: null,
        info: "Info",
        servers: "ServerList",
        security: "SecurityRequirementList",
        tags: "TagList",
        externalDocs: "ExternalDocs",
        paths: "Paths",
        webhooks: "WebhooksMap",
        components: "Components",
        jsonSchemaDialect: { type: "string" }
      },
      required: ["openapi", "info"],
      requiredOneOf: ["paths", "components", "webhooks"],
      extensionsPrefix: "x-"
    };
    var License = {
      properties: {
        name: { type: "string" },
        url: { type: "string" },
        identifier: { type: "string" }
      },
      required: ["name"],
      extensionsPrefix: "x-"
    };
    var Info = {
      properties: {
        title: { type: "string" },
        version: { type: "string" },
        description: { type: "string" },
        termsOfService: { type: "string" },
        summary: { type: "string" },
        contact: "Contact",
        license: "License",
        "x-logo": "Logo"
      },
      required: ["title", "version"],
      extensionsPrefix: "x-"
    };
    var Components = {
      properties: {
        parameters: "NamedParameters",
        schemas: "NamedSchemas",
        responses: "NamedResponses",
        examples: "NamedExamples",
        requestBodies: "NamedRequestBodies",
        headers: "NamedHeaders",
        securitySchemes: "NamedSecuritySchemes",
        links: "NamedLinks",
        callbacks: "NamedCallbacks",
        pathItems: "NamedPathItems"
      },
      extensionsPrefix: "x-"
    };
    var Operation = {
      properties: {
        tags: {
          type: "array",
          items: { type: "string" }
        },
        summary: { type: "string" },
        description: { type: "string" },
        externalDocs: "ExternalDocs",
        operationId: { type: "string" },
        parameters: "ParameterList",
        security: "SecurityRequirementList",
        servers: "ServerList",
        requestBody: "RequestBody",
        responses: "Responses",
        deprecated: { type: "boolean" },
        callbacks: "CallbacksMap",
        "x-codeSamples": "XCodeSampleList",
        "x-code-samples": "XCodeSampleList",
        "x-hideTryItPanel": { type: "boolean" }
      },
      extensionsPrefix: "x-"
    };
    var Schema3 = {
      properties: {
        $id: { type: "string" },
        $anchor: { type: "string" },
        id: { type: "string" },
        $schema: { type: "string" },
        definitions: "NamedSchemas",
        $defs: "NamedSchemas",
        $vocabulary: { type: "string" },
        externalDocs: "ExternalDocs",
        discriminator: "Discriminator",
        title: { type: "string" },
        multipleOf: { type: "number", minimum: 0 },
        maximum: { type: "number" },
        minimum: { type: "number" },
        exclusiveMaximum: { type: "number" },
        exclusiveMinimum: { type: "number" },
        maxLength: { type: "integer", minimum: 0 },
        minLength: { type: "integer", minimum: 0 },
        pattern: { type: "string" },
        maxItems: { type: "integer", minimum: 0 },
        minItems: { type: "integer", minimum: 0 },
        uniqueItems: { type: "boolean" },
        maxProperties: { type: "integer", minimum: 0 },
        minProperties: { type: "integer", minimum: 0 },
        required: { type: "array", items: { type: "string" } },
        enum: { type: "array" },
        type: (value) => {
          if (Array.isArray(value)) {
            return {
              type: "array",
              items: { enum: ["object", "array", "string", "number", "integer", "boolean", "null"] }
            };
          } else {
            return {
              enum: ["object", "array", "string", "number", "integer", "boolean", "null"]
            };
          }
        },
        allOf: (0, _1.listOf)("Schema"),
        anyOf: (0, _1.listOf)("Schema"),
        oneOf: (0, _1.listOf)("Schema"),
        not: "Schema",
        if: "Schema",
        then: "Schema",
        else: "Schema",
        dependentSchemas: (0, _1.listOf)("Schema"),
        prefixItems: (0, _1.listOf)("Schema"),
        contains: "Schema",
        minContains: { type: "integer", minimum: 0 },
        maxContains: { type: "integer", minimum: 0 },
        patternProperties: { type: "object" },
        propertyNames: "Schema",
        unevaluatedItems: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        unevaluatedProperties: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        summary: { type: "string" },
        properties: "SchemaProperties",
        items: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        additionalProperties: (value) => {
          return typeof value === "boolean" ? { type: "boolean" } : "Schema";
        },
        description: { type: "string" },
        format: { type: "string" },
        contentEncoding: { type: "string" },
        contentMediaType: { type: "string" },
        default: null,
        readOnly: { type: "boolean" },
        writeOnly: { type: "boolean" },
        xml: "Xml",
        examples: { type: "array" },
        example: { isExample: true },
        deprecated: { type: "boolean" },
        const: null,
        $comment: { type: "string" },
        "x-tags": { type: "array", items: { type: "string" } }
      },
      extensionsPrefix: "x-"
    };
    var SchemaProperties = {
      properties: {},
      additionalProperties: (value) => {
        if (typeof value === "boolean") {
          return { type: "boolean" };
        } else {
          return "Schema";
        }
      }
    };
    var SecurityScheme2 = {
      properties: {
        type: { enum: ["apiKey", "http", "oauth2", "openIdConnect", "mutualTLS"] },
        description: { type: "string" },
        name: { type: "string" },
        in: { type: "string", enum: ["query", "header", "cookie"] },
        scheme: { type: "string" },
        bearerFormat: { type: "string" },
        flows: "OAuth2Flows",
        openIdConnectUrl: { type: "string" }
      },
      required(value) {
        switch (value === null || value === void 0 ? void 0 : value.type) {
          case "apiKey":
            return ["type", "name", "in"];
          case "http":
            return ["type", "scheme"];
          case "oauth2":
            return ["type", "flows"];
          case "openIdConnect":
            return ["type", "openIdConnectUrl"];
          default:
            return ["type"];
        }
      },
      allowed(value) {
        switch (value === null || value === void 0 ? void 0 : value.type) {
          case "apiKey":
            return ["type", "name", "in", "description"];
          case "http":
            return ["type", "scheme", "bearerFormat", "description"];
          case "oauth2":
            switch (value === null || value === void 0 ? void 0 : value.flows) {
              case "implicit":
                return ["type", "flows", "authorizationUrl", "refreshUrl", "description", "scopes"];
              case "password":
              case "clientCredentials":
                return ["type", "flows", "tokenUrl", "refreshUrl", "description", "scopes"];
              case "authorizationCode":
                return [
                  "type",
                  "flows",
                  "authorizationUrl",
                  "refreshUrl",
                  "tokenUrl",
                  "description",
                  "scopes"
                ];
              default:
                return [
                  "type",
                  "flows",
                  "authorizationUrl",
                  "refreshUrl",
                  "tokenUrl",
                  "description",
                  "scopes"
                ];
            }
          case "openIdConnect":
            return ["type", "openIdConnectUrl", "description"];
          case "mutualTLS":
            return ["type", "description"];
          default:
            return ["type", "description"];
        }
      },
      extensionsPrefix: "x-"
    };
    exports2.Oas3_1Types = Object.assign(Object.assign({}, oas3_1.Oas3Types), {
      Info,
      Root,
      Schema: Schema3,
      SchemaProperties,
      License,
      Components,
      NamedPathItems: (0, _1.mapOf)("PathItem"),
      SecurityScheme: SecurityScheme2,
      Operation
    });
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/oas2.js
var require_oas2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/oas2.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Oas2Types = void 0;
    var _1 = require_types();
    var responseCodeRegexp = /^[0-9][0-9Xx]{2}$/;
    var Root = {
      properties: {
        swagger: { type: "string" },
        info: "Info",
        host: { type: "string" },
        basePath: { type: "string" },
        schemes: { type: "array", items: { type: "string" } },
        consumes: { type: "array", items: { type: "string" } },
        produces: { type: "array", items: { type: "string" } },
        paths: "Paths",
        definitions: "NamedSchemas",
        parameters: "NamedParameters",
        responses: "NamedResponses",
        securityDefinitions: "NamedSecuritySchemes",
        security: "SecurityRequirementList",
        tags: "TagList",
        externalDocs: "ExternalDocs",
        "x-servers": "XServerList",
        "x-tagGroups": "TagGroups",
        "x-ignoredHeaderParameters": { type: "array", items: { type: "string" } }
      },
      required: ["swagger", "paths", "info"],
      extensionsPrefix: "x-"
    };
    var Info = {
      properties: {
        title: { type: "string" },
        description: { type: "string" },
        termsOfService: { type: "string" },
        contact: "Contact",
        license: "License",
        version: { type: "string" },
        "x-logo": "Logo"
      },
      required: ["title", "version"],
      extensionsPrefix: "x-"
    };
    var Logo = {
      properties: {
        url: { type: "string" },
        altText: { type: "string" },
        backgroundColor: { type: "string" },
        href: { type: "string" }
      },
      extensionsPrefix: "x-"
    };
    var Contact = {
      properties: {
        name: { type: "string" },
        url: { type: "string" },
        email: { type: "string" }
      },
      extensionsPrefix: "x-"
    };
    var License = {
      properties: {
        name: { type: "string" },
        url: { type: "string" }
      },
      required: ["name"],
      extensionsPrefix: "x-"
    };
    var Paths = {
      properties: {},
      additionalProperties: (_value, key) => key.startsWith("/") ? "PathItem" : void 0
    };
    var PathItem = {
      properties: {
        $ref: { type: "string" },
        parameters: "ParameterList",
        get: "Operation",
        put: "Operation",
        post: "Operation",
        delete: "Operation",
        options: "Operation",
        head: "Operation",
        patch: "Operation"
      },
      extensionsPrefix: "x-"
    };
    var Operation = {
      properties: {
        tags: { type: "array", items: { type: "string" } },
        summary: { type: "string" },
        description: { type: "string" },
        externalDocs: "ExternalDocs",
        operationId: { type: "string" },
        consumes: { type: "array", items: { type: "string" } },
        produces: { type: "array", items: { type: "string" } },
        parameters: "ParameterList",
        responses: "Responses",
        schemes: { type: "array", items: { type: "string" } },
        deprecated: { type: "boolean" },
        security: "SecurityRequirementList",
        "x-codeSamples": "XCodeSampleList",
        "x-code-samples": "XCodeSampleList",
        "x-hideTryItPanel": { type: "boolean" }
      },
      required: ["responses"],
      extensionsPrefix: "x-"
    };
    var XCodeSample = {
      properties: {
        lang: { type: "string" },
        label: { type: "string" },
        source: { type: "string" }
      }
    };
    var XServer = {
      properties: {
        url: { type: "string" },
        description: { type: "string" }
      },
      required: ["url"]
    };
    var ExternalDocs = {
      properties: {
        description: { type: "string" },
        url: { type: "string" }
      },
      required: ["url"],
      extensionsPrefix: "x-"
    };
    var Parameter = {
      properties: {
        name: { type: "string" },
        in: { type: "string", enum: ["query", "header", "path", "formData", "body"] },
        description: { type: "string" },
        required: { type: "boolean" },
        schema: "Schema",
        type: { type: "string", enum: ["string", "number", "integer", "boolean", "array", "file"] },
        format: { type: "string" },
        allowEmptyValue: { type: "boolean" },
        items: "ParameterItems",
        collectionFormat: { type: "string", enum: ["csv", "ssv", "tsv", "pipes", "multi"] },
        default: null,
        maximum: { type: "integer" },
        exclusiveMaximum: { type: "boolean" },
        minimum: { type: "integer" },
        exclusiveMinimum: { type: "boolean" },
        maxLength: { type: "integer" },
        minLength: { type: "integer" },
        pattern: { type: "string" },
        maxItems: { type: "integer" },
        minItems: { type: "integer" },
        uniqueItems: { type: "boolean" },
        enum: { type: "array" },
        multipleOf: { type: "number" },
        "x-example": "Example",
        "x-examples": "ExamplesMap"
      },
      required(value) {
        if (!value || !value.in) {
          return ["name", "in"];
        }
        if (value.in === "body") {
          return ["name", "in", "schema"];
        } else {
          if (value.type === "array") {
            return ["name", "in", "type", "items"];
          } else {
            return ["name", "in", "type"];
          }
        }
      },
      extensionsPrefix: "x-"
    };
    var ParameterItems = {
      properties: {
        type: { type: "string", enum: ["string", "number", "integer", "boolean", "array"] },
        format: { type: "string" },
        items: "ParameterItems",
        collectionFormat: { type: "string", enum: ["csv", "ssv", "tsv", "pipes", "multi"] },
        default: null,
        maximum: { type: "integer" },
        exclusiveMaximum: { type: "boolean" },
        minimum: { type: "integer" },
        exclusiveMinimum: { type: "boolean" },
        maxLength: { type: "integer" },
        minLength: { type: "integer" },
        pattern: { type: "string" },
        maxItems: { type: "integer" },
        minItems: { type: "integer" },
        uniqueItems: { type: "boolean" },
        enum: { type: "array" },
        multipleOf: { type: "number" }
      },
      required(value) {
        if (value && value.type === "array") {
          return ["type", "items"];
        } else {
          return ["type"];
        }
      },
      extensionsPrefix: "x-"
    };
    var Responses = {
      properties: {
        default: "Response"
      },
      additionalProperties: (_v, key) => responseCodeRegexp.test(key) ? "Response" : void 0
    };
    var Response4 = {
      properties: {
        description: { type: "string" },
        schema: "Schema",
        headers: (0, _1.mapOf)("Header"),
        examples: "Examples",
        "x-summary": { type: "string" }
      },
      required: ["description"],
      extensionsPrefix: "x-"
    };
    var Examples = {
      properties: {},
      additionalProperties: { isExample: true }
    };
    var Header = {
      properties: {
        description: { type: "string" },
        type: { type: "string", enum: ["string", "number", "integer", "boolean", "array"] },
        format: { type: "string" },
        items: "ParameterItems",
        collectionFormat: { type: "string", enum: ["csv", "ssv", "tsv", "pipes", "multi"] },
        default: null,
        maximum: { type: "integer" },
        exclusiveMaximum: { type: "boolean" },
        minimum: { type: "integer" },
        exclusiveMinimum: { type: "boolean" },
        maxLength: { type: "integer" },
        minLength: { type: "integer" },
        pattern: { type: "string" },
        maxItems: { type: "integer" },
        minItems: { type: "integer" },
        uniqueItems: { type: "boolean" },
        enum: { type: "array" },
        multipleOf: { type: "number" }
      },
      required(value) {
        if (value && value.type === "array") {
          return ["type", "items"];
        } else {
          return ["type"];
        }
      },
      extensionsPrefix: "x-"
    };
    var Tag = {
      properties: {
        name: { type: "string" },
        description: { type: "string" },
        externalDocs: "ExternalDocs",
        "x-traitTag": { type: "boolean" },
        "x-displayName": { type: "string" }
      },
      required: ["name"],
      extensionsPrefix: "x-"
    };
    var TagGroup = {
      properties: {
        name: { type: "string" },
        tags: { type: "array", items: { type: "string" } }
      }
    };
    var Schema3 = {
      properties: {
        format: { type: "string" },
        title: { type: "string" },
        description: { type: "string" },
        default: null,
        multipleOf: { type: "number" },
        maximum: { type: "number" },
        minimum: { type: "number" },
        exclusiveMaximum: { type: "boolean" },
        exclusiveMinimum: { type: "boolean" },
        maxLength: { type: "number" },
        minLength: { type: "number" },
        pattern: { type: "string" },
        maxItems: { type: "number" },
        minItems: { type: "number" },
        uniqueItems: { type: "boolean" },
        maxProperties: { type: "number" },
        minProperties: { type: "number" },
        required: { type: "array", items: { type: "string" } },
        enum: { type: "array" },
        type: {
          type: "string",
          enum: ["object", "array", "string", "number", "integer", "boolean", "null"]
        },
        items: (value) => {
          if (Array.isArray(value)) {
            return (0, _1.listOf)("Schema");
          } else {
            return "Schema";
          }
        },
        allOf: (0, _1.listOf)("Schema"),
        properties: "SchemaProperties",
        additionalProperties: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        discriminator: { type: "string" },
        readOnly: { type: "boolean" },
        xml: "Xml",
        externalDocs: "ExternalDocs",
        example: { isExample: true },
        "x-tags": { type: "array", items: { type: "string" } },
        "x-nullable": { type: "boolean" },
        "x-extendedDiscriminator": { type: "string" },
        "x-additionalPropertiesName": { type: "string" },
        "x-explicitMappingOnly": { type: "boolean" },
        "x-enumDescriptions": "EnumDescriptions"
      },
      extensionsPrefix: "x-"
    };
    var EnumDescriptions = {
      properties: {},
      additionalProperties: { type: "string" }
    };
    var SchemaProperties = {
      properties: {},
      additionalProperties: "Schema"
    };
    var Xml = {
      properties: {
        name: { type: "string" },
        namespace: { type: "string" },
        prefix: { type: "string" },
        attribute: { type: "boolean" },
        wrapped: { type: "boolean" }
      },
      extensionsPrefix: "x-"
    };
    var SecurityScheme2 = {
      properties: {
        type: { enum: ["basic", "apiKey", "oauth2"] },
        description: { type: "string" },
        name: { type: "string" },
        in: { type: "string", enum: ["query", "header"] },
        flow: { enum: ["implicit", "password", "application", "accessCode"] },
        authorizationUrl: { type: "string" },
        tokenUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        "x-defaultClientId": { type: "string" }
      },
      required(value) {
        switch (value === null || value === void 0 ? void 0 : value.type) {
          case "apiKey":
            return ["type", "name", "in"];
          case "oauth2":
            switch (value === null || value === void 0 ? void 0 : value.flow) {
              case "implicit":
                return ["type", "flow", "authorizationUrl", "scopes"];
              case "accessCode":
                return ["type", "flow", "authorizationUrl", "tokenUrl", "scopes"];
              case "application":
              case "password":
                return ["type", "flow", "tokenUrl", "scopes"];
              default:
                return ["type", "flow", "scopes"];
            }
          default:
            return ["type"];
        }
      },
      allowed(value) {
        switch (value === null || value === void 0 ? void 0 : value.type) {
          case "basic":
            return ["type", "description"];
          case "apiKey":
            return ["type", "name", "in", "description"];
          case "oauth2":
            switch (value === null || value === void 0 ? void 0 : value.flow) {
              case "implicit":
                return ["type", "flow", "authorizationUrl", "description", "scopes"];
              case "accessCode":
                return ["type", "flow", "authorizationUrl", "tokenUrl", "description", "scopes"];
              case "application":
              case "password":
                return ["type", "flow", "tokenUrl", "description", "scopes"];
              default:
                return ["type", "flow", "tokenUrl", "authorizationUrl", "description", "scopes"];
            }
          default:
            return ["type", "description"];
        }
      },
      extensionsPrefix: "x-"
    };
    var SecurityRequirement = {
      properties: {},
      additionalProperties: { type: "array", items: { type: "string" } }
    };
    var Example = {
      properties: {
        value: { isExample: true },
        summary: { type: "string" },
        description: { type: "string" },
        externalValue: { type: "string" }
      },
      extensionsPrefix: "x-"
    };
    exports2.Oas2Types = {
      Root,
      Tag,
      TagList: (0, _1.listOf)("Tag"),
      TagGroups: (0, _1.listOf)("TagGroup"),
      TagGroup,
      ExternalDocs,
      Example,
      ExamplesMap: (0, _1.mapOf)("Example"),
      EnumDescriptions,
      SecurityRequirement,
      SecurityRequirementList: (0, _1.listOf)("SecurityRequirement"),
      Info,
      Contact,
      License,
      Logo,
      Paths,
      PathItem,
      Parameter,
      ParameterItems,
      ParameterList: (0, _1.listOf)("Parameter"),
      Operation,
      Examples,
      Header,
      Responses,
      Response: Response4,
      Schema: Schema3,
      Xml,
      SchemaProperties,
      NamedSchemas: (0, _1.mapOf)("Schema"),
      NamedResponses: (0, _1.mapOf)("Response"),
      NamedParameters: (0, _1.mapOf)("Parameter"),
      NamedSecuritySchemes: (0, _1.mapOf)("SecurityScheme"),
      SecurityScheme: SecurityScheme2,
      XCodeSample,
      XCodeSampleList: (0, _1.listOf)("XCodeSample"),
      XServerList: (0, _1.listOf)("XServer"),
      XServer
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/asyncapi.js
var require_asyncapi = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/asyncapi.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AsyncApi2Types = void 0;
    var _1 = require_types();
    var ref_utils_1 = require_ref_utils();
    var Root = {
      properties: {
        asyncapi: null,
        info: "Info",
        id: { type: "string" },
        servers: "ServerMap",
        channels: "ChannelMap",
        components: "Components",
        tags: "TagList",
        externalDocs: "ExternalDocs",
        defaultContentType: { type: "string" }
      },
      required: ["asyncapi", "channels", "info"]
    };
    var Channel = {
      properties: {
        description: { type: "string" },
        subscribe: "Operation",
        publish: "Operation",
        parameters: "ParametersMap",
        bindings: "ChannelBindings",
        servers: { type: "array", items: { type: "string" } }
      }
    };
    var ChannelMap = {
      properties: {},
      additionalProperties: "Channel"
    };
    var ChannelBindings = {
      properties: {},
      allowed() {
        return [
          "http",
          "ws",
          "kafka",
          "anypointmq",
          "amqp",
          "amqp1",
          "mqtt",
          "mqtt5",
          "nats",
          "jms",
          "sns",
          "solace",
          "sqs",
          "stomp",
          "redis",
          "mercure",
          "ibmmq",
          "googlepubsub",
          "pulsar"
        ];
      },
      additionalProperties: { type: "object" }
    };
    var Tag = {
      properties: {
        name: { type: "string" },
        description: { type: "string" },
        externalDocs: "ExternalDocs"
      },
      required: ["name"]
    };
    var ExternalDocs = {
      properties: {
        description: { type: "string" },
        url: { type: "string" }
      },
      required: ["url"]
    };
    var SecurityRequirement = {
      properties: {},
      additionalProperties: { type: "array", items: { type: "string" } }
    };
    var ServerBindings = {
      properties: {},
      allowed() {
        return [
          "http",
          "ws",
          "kafka",
          "anypointmq",
          "amqp",
          "amqp1",
          "mqtt",
          "mqtt5",
          "nats",
          "jms",
          "sns",
          "solace",
          "sqs",
          "stomp",
          "redis",
          "mercure",
          "ibmmq",
          "googlepubsub",
          "pulsar"
        ];
      },
      additionalProperties: { type: "object" }
    };
    var Server = {
      properties: {
        url: { type: "string" },
        protocol: { type: "string" },
        protocolVersion: { type: "string" },
        description: { type: "string" },
        variables: "ServerVariablesMap",
        security: "SecurityRequirementList",
        bindings: "ServerBindings",
        tags: "TagList"
      },
      required: ["url", "protocol"]
    };
    var ServerMap = {
      properties: {},
      additionalProperties: (_value, key) => key.match(/^[A-Za-z0-9_\-]+$/) ? "Server" : void 0
    };
    var ServerVariable = {
      properties: {
        enum: {
          type: "array",
          items: { type: "string" }
        },
        default: { type: "string" },
        description: { type: "string" },
        examples: {
          type: "array",
          items: { type: "string" }
        }
      },
      required: []
    };
    var Info = {
      properties: {
        title: { type: "string" },
        version: { type: "string" },
        description: { type: "string" },
        termsOfService: { type: "string" },
        contact: "Contact",
        license: "License"
      },
      required: ["title", "version"]
    };
    var Contact = {
      properties: {
        name: { type: "string" },
        url: { type: "string" },
        email: { type: "string" }
      }
    };
    var License = {
      properties: {
        name: { type: "string" },
        url: { type: "string" }
      },
      required: ["name"]
    };
    var Parameter = {
      properties: {
        description: { type: "string" },
        schema: "Schema",
        location: { type: "string" }
      }
    };
    var CorrelationId = {
      properties: {
        description: { type: "string" },
        location: { type: "string" }
      },
      required: ["location"]
    };
    var Message = {
      properties: {
        messageId: { type: "string" },
        headers: "Schema",
        payload: "Schema",
        correlationId: "CorrelationId",
        schemaFormat: { type: "string" },
        contentType: { type: "string" },
        name: { type: "string" },
        title: { type: "string" },
        summary: { type: "string" },
        description: { type: "string" },
        tags: "TagList",
        externalDocs: "ExternalDocs",
        bindings: "MessageBindings",
        // examples: 'MessageExampleList', // TODO: add support for message examples
        traits: "MessageTraitList"
      },
      additionalProperties: {}
    };
    var MessageBindings = {
      properties: {},
      allowed() {
        return [
          "http",
          "ws",
          "kafka",
          "anypointmq",
          "amqp",
          "amqp1",
          "mqtt",
          "mqtt5",
          "nats",
          "jms",
          "sns",
          "solace",
          "sqs",
          "stomp",
          "redis",
          "mercure",
          "ibmmq",
          "googlepubsub",
          "pulsar"
        ];
      },
      additionalProperties: { type: "object" }
    };
    var OperationBindings = {
      properties: {},
      allowed() {
        return [
          "http",
          "ws",
          "kafka",
          "anypointmq",
          "amqp",
          "amqp1",
          "mqtt",
          "mqtt5",
          "nats",
          "jms",
          "sns",
          "solace",
          "sqs",
          "stomp",
          "redis",
          "mercure",
          "ibmmq",
          "googlepubsub",
          "pulsar"
        ];
      },
      additionalProperties: { type: "object" }
    };
    var OperationTrait = {
      properties: {
        tags: {
          type: "array",
          items: { type: "string" }
        },
        summary: { type: "string" },
        description: { type: "string" },
        externalDocs: "ExternalDocs",
        operationId: { type: "string" },
        security: "SecurityRequirementList",
        bindings: "OperationBindings"
      },
      required: []
    };
    var MessageTrait = {
      properties: {
        messageId: { type: "string" },
        headers: "Schema",
        correlationId: "CorrelationId",
        schemaFormat: { type: "string" },
        contentType: { type: "string" },
        name: { type: "string" },
        title: { type: "string" },
        summary: { type: "string" },
        description: { type: "string" },
        tags: "TagList",
        externalDocs: "ExternalDocs",
        bindings: "MessageBindings"
        // examples: 'MessageExampleList', // TODO: support examples for message traits
      },
      additionalProperties: {}
    };
    var Operation = {
      properties: {
        tags: {
          type: "array",
          items: { type: "string" }
        },
        summary: { type: "string" },
        description: { type: "string" },
        externalDocs: "ExternalDocs",
        operationId: { type: "string" },
        security: "SecurityRequirementList",
        bindings: "OperationBindings",
        traits: "OperationTraitList",
        message: "Message"
      },
      required: []
    };
    var MessageExample = {
      properties: {
        payload: { isExample: true },
        summary: { type: "string" },
        name: { type: "string" },
        headers: { type: "object" }
      }
    };
    var Schema3 = {
      properties: {
        $id: { type: "string" },
        id: { type: "string" },
        $schema: { type: "string" },
        definitions: "NamedSchemas",
        $defs: "NamedSchemas",
        $vocabulary: { type: "string" },
        externalDocs: "ExternalDocs",
        discriminator: "Discriminator",
        myArbitraryKeyword: { type: "boolean" },
        title: { type: "string" },
        multipleOf: { type: "number", minimum: 0 },
        maximum: { type: "number" },
        minimum: { type: "number" },
        exclusiveMaximum: { type: "number" },
        exclusiveMinimum: { type: "number" },
        maxLength: { type: "integer", minimum: 0 },
        minLength: { type: "integer", minimum: 0 },
        pattern: { type: "string" },
        maxItems: { type: "integer", minimum: 0 },
        minItems: { type: "integer", minimum: 0 },
        uniqueItems: { type: "boolean" },
        maxProperties: { type: "integer", minimum: 0 },
        minProperties: { type: "integer", minimum: 0 },
        required: { type: "array", items: { type: "string" } },
        enum: { type: "array" },
        type: (value) => {
          if (Array.isArray(value)) {
            return {
              type: "array",
              items: { enum: ["object", "array", "string", "number", "integer", "boolean", "null"] }
            };
          } else {
            return {
              enum: ["object", "array", "string", "number", "integer", "boolean", "null"]
            };
          }
        },
        allOf: (0, _1.listOf)("Schema"),
        anyOf: (0, _1.listOf)("Schema"),
        oneOf: (0, _1.listOf)("Schema"),
        not: "Schema",
        if: "Schema",
        then: "Schema",
        else: "Schema",
        dependentSchemas: (0, _1.listOf)("Schema"),
        prefixItems: (0, _1.listOf)("Schema"),
        contains: "Schema",
        minContains: { type: "integer", minimum: 0 },
        maxContains: { type: "integer", minimum: 0 },
        patternProperties: { type: "object" },
        propertyNames: "Schema",
        unevaluatedItems: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        unevaluatedProperties: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        summary: { type: "string" },
        properties: "SchemaProperties",
        items: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        additionalProperties: (value) => {
          return typeof value === "boolean" ? { type: "boolean" } : "Schema";
        },
        description: { type: "string" },
        format: { type: "string" },
        contentEncoding: { type: "string" },
        contentMediaType: { type: "string" },
        default: null,
        readOnly: { type: "boolean" },
        writeOnly: { type: "boolean" },
        // xml: 'Xml',
        examples: { type: "array" },
        example: { isExample: true },
        deprecated: { type: "boolean" },
        const: null,
        $comment: { type: "string" },
        dependencies: { type: "object" }
        // TODO
      }
    };
    var SchemaProperties = {
      properties: {},
      additionalProperties: (value) => {
        if (typeof value === "boolean") {
          return { type: "boolean" };
        }
        return "Schema";
      }
    };
    var DiscriminatorMapping = {
      properties: {},
      additionalProperties: (value) => {
        if ((0, ref_utils_1.isMappingRef)(value)) {
          return { type: "string", directResolveAs: "Schema" };
        } else {
          return { type: "string" };
        }
      }
    };
    var Discriminator = {
      properties: {
        propertyName: { type: "string" },
        mapping: "DiscriminatorMapping"
      },
      required: ["propertyName"]
    };
    var Components = {
      properties: {
        messages: "NamedMessages",
        parameters: "NamedParameters",
        schemas: "NamedSchemas",
        correlationIds: "NamedCorrelationIds",
        messageTraits: "NamedMessageTraits",
        operationTraits: "NamedOperationTraits",
        streamHeaders: "NamedStreamHeaders",
        securitySchemes: "NamedSecuritySchemes",
        servers: "ServerMap",
        serverVariables: "ServerVariablesMap",
        channels: "ChannelMap",
        serverBindings: "ServerBindings",
        channelBindings: "ChannelBindings",
        operationBindings: "OperationBindings",
        messageBindings: "MessageBindings"
      }
    };
    var ImplicitFlow = {
      properties: {
        refreshUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        authorizationUrl: { type: "string" }
      },
      required: ["authorizationUrl", "scopes"]
    };
    var PasswordFlow = {
      properties: {
        refreshUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        tokenUrl: { type: "string" }
      },
      required: ["tokenUrl", "scopes"]
    };
    var ClientCredentials = {
      properties: {
        refreshUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        tokenUrl: { type: "string" }
      },
      required: ["tokenUrl", "scopes"]
    };
    var AuthorizationCode = {
      properties: {
        refreshUrl: { type: "string" },
        authorizationUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        tokenUrl: { type: "string" }
      },
      required: ["authorizationUrl", "tokenUrl", "scopes"]
    };
    var SecuritySchemeFlows = {
      properties: {
        implicit: "ImplicitFlow",
        password: "PasswordFlow",
        clientCredentials: "ClientCredentials",
        authorizationCode: "AuthorizationCode"
      }
    };
    var SecurityScheme2 = {
      properties: {
        type: {
          enum: [
            "userPassword",
            "apiKey",
            "X509",
            "symmetricEncryption",
            "asymmetricEncryption",
            "httpApiKey",
            "http",
            "oauth2",
            "openIdConnect",
            "plain",
            "scramSha256",
            "scramSha512",
            "gssapi"
          ]
        },
        description: { type: "string" },
        name: { type: "string" },
        in: { type: "string", enum: ["query", "header", "cookie", "user", "password"] },
        scheme: { type: "string" },
        bearerFormat: { type: "string" },
        flows: "SecuritySchemeFlows",
        openIdConnectUrl: { type: "string" }
      },
      required(value) {
        switch (value === null || value === void 0 ? void 0 : value.type) {
          case "apiKey":
            return ["type", "in"];
          case "httpApiKey":
            return ["type", "name", "in"];
          case "http":
            return ["type", "scheme"];
          case "oauth2":
            return ["type", "flows"];
          case "openIdConnect":
            return ["type", "openIdConnectUrl"];
          default:
            return ["type"];
        }
      },
      allowed(value) {
        switch (value === null || value === void 0 ? void 0 : value.type) {
          case "apiKey":
            return ["type", "in", "description"];
          case "httpApiKey":
            return ["type", "name", "in", "description"];
          case "http":
            return ["type", "scheme", "bearerFormat", "description"];
          case "oauth2":
            return ["type", "flows", "description"];
          case "openIdConnect":
            return ["type", "openIdConnectUrl", "description"];
          default:
            return ["type", "description"];
        }
      },
      extensionsPrefix: "x-"
    };
    var HttpChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.http = HttpChannelBinding;
    var HttpServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.http = HttpServerBinding;
    var HttpMessageBinding = {
      properties: {
        headers: "Schema",
        bindingVersion: { type: "string" }
      }
    };
    MessageBindings.properties.http = HttpMessageBinding;
    var HttpOperationBinding = {
      properties: {
        type: { type: "string" },
        method: {
          type: "string",
          enum: ["GET", "POST", "PUT", "PATCH", "DELETE", "HEAD", "OPTIONS", "CONNECT", "TRACE"]
        },
        headers: "Schema",
        bindingVersion: { type: "string" }
      }
    };
    OperationBindings.properties.http = HttpOperationBinding;
    var WsChannelBinding = {
      properties: {
        method: { type: "string" },
        query: "Schema",
        headers: "Schema",
        bindingVersion: { type: "string" }
      }
    };
    ChannelBindings.properties.ws = WsChannelBinding;
    var WsServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.ws = WsServerBinding;
    var WsMessageBinding = {
      properties: {}
      // empty object
    };
    MessageBindings.properties.ws = WsMessageBinding;
    var WsOperationBinding = {
      properties: {}
      // empty object
    };
    OperationBindings.properties.ws = WsOperationBinding;
    var KafkaTopicConfiguration = {
      properties: {
        "cleanup.policy": { type: "array", items: { enum: ["delete", "compact"] } },
        "retention.ms": { type: "integer" },
        "retention.bytes": { type: "integer" },
        "delete.retention.ms": { type: "integer" },
        "max.message.bytes": { type: "integer" }
      }
    };
    var KafkaChannelBinding = {
      properties: {
        topic: { type: "string" },
        partitions: { type: "integer" },
        replicas: { type: "integer" },
        topicConfiguration: "KafkaTopicConfiguration",
        bindingVersion: { type: "string" }
      }
    };
    ChannelBindings.properties.kafka = KafkaChannelBinding;
    var KafkaServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.kafka = KafkaServerBinding;
    var KafkaMessageBinding = {
      properties: {
        key: "Schema",
        schemaIdLocation: { type: "string" },
        schemaIdPayloadEncoding: { type: "string" },
        schemaLookupStrategy: { type: "string" },
        bindingVersion: { type: "string" }
      }
    };
    MessageBindings.properties.kafka = KafkaMessageBinding;
    var KafkaOperationBinding = {
      properties: {
        groupId: "Schema",
        clientId: "Schema",
        bindingVersion: { type: "string" }
      }
    };
    OperationBindings.properties.kafka = KafkaOperationBinding;
    var AnypointmqChannelBinding = {
      properties: {
        destination: { type: "string" },
        destinationType: { type: "string" },
        bindingVersion: { type: "string" }
      }
    };
    ChannelBindings.properties.anypointmq = AnypointmqChannelBinding;
    var AnypointmqServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.anypointmq = AnypointmqServerBinding;
    var AnypointmqMessageBinding = {
      properties: {
        headers: "Schema",
        bindingVersion: { type: "string" }
      }
    };
    MessageBindings.properties.anypointmq = AnypointmqMessageBinding;
    var AnypointmqOperationBinding = {
      properties: {}
      // empty object
    };
    OperationBindings.properties.anypointmq = AnypointmqOperationBinding;
    var AmqpChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.amqp = AmqpChannelBinding;
    var AmqpServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.amqp = AmqpServerBinding;
    var AmqpMessageBinding = {
      properties: {
        contentEncoding: { type: "string" },
        messageType: { type: "string" },
        bindingVersion: { type: "string" }
      }
    };
    MessageBindings.properties.amqp = AmqpMessageBinding;
    var AmqpOperationBinding = {
      // TODO: some fields are subscribe only
      properties: {
        expiration: { type: "integer" },
        userId: { type: "string" },
        cc: { type: "array", items: { type: "string" } },
        priority: { type: "integer" },
        deliveryMode: { type: "integer" },
        mandatory: { type: "boolean" },
        bcc: { type: "array", items: { type: "string" } },
        replyTo: { type: "string" },
        timestamp: { type: "boolean" },
        ack: { type: "boolean" },
        bindingVersion: { type: "string" }
      }
    };
    OperationBindings.properties.amqp = AmqpOperationBinding;
    var Amqp1ChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.amqp1 = Amqp1ChannelBinding;
    var Amqp1ServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.amqp1 = Amqp1ServerBinding;
    var Amqp1MessageBinding = {
      properties: {}
      // empty object
    };
    MessageBindings.properties.amqp1 = Amqp1MessageBinding;
    var Amqp1OperationBinding = {
      properties: {}
      // empty object
    };
    OperationBindings.properties.amqp1 = Amqp1OperationBinding;
    var MqttChannelBinding = {
      properties: {
        qos: { type: "integer" },
        retain: { type: "boolean" },
        bindingVersion: { type: "string" }
      }
    };
    ChannelBindings.properties.mqtt = MqttChannelBinding;
    var MqttServerBindingLastWill = {
      properties: {
        topic: { type: "string" },
        qos: { type: "integer" },
        message: { type: "string" },
        retain: { type: "boolean" }
      }
    };
    var MqttServerBinding = {
      properties: {
        clientId: { type: "string" },
        cleanSession: { type: "boolean" },
        lastWill: "MqttServerBindingLastWill",
        keepAlive: { type: "integer" },
        bindingVersion: { type: "string" }
      }
    };
    ServerBindings.properties.mqtt = MqttServerBinding;
    var MqttMessageBinding = {
      properties: {
        bindingVersion: { type: "string" }
      }
    };
    MessageBindings.properties.mqtt = MqttMessageBinding;
    var MqttOperationBinding = {
      properties: {
        qos: { type: "integer" },
        retain: { type: "boolean" },
        bindingVersion: { type: "string" }
      }
    };
    OperationBindings.properties.mqtt = MqttOperationBinding;
    var Mqtt5ChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.mqtt5 = Mqtt5ChannelBinding;
    var Mqtt5ServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.mqtt5 = Mqtt5ServerBinding;
    var Mqtt5MessageBinding = {
      properties: {}
      // empty object
    };
    MessageBindings.properties.mqtt5 = Mqtt5MessageBinding;
    var Mqtt5OperationBinding = {
      properties: {}
      // empty object
    };
    OperationBindings.properties.mqtt5 = Mqtt5OperationBinding;
    var NatsChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.nats = NatsChannelBinding;
    var NatsServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.nats = NatsServerBinding;
    var NatsMessageBinding = {
      properties: {}
      // empty object
    };
    MessageBindings.properties.nats = NatsMessageBinding;
    var NatsOperationBinding = {
      properties: {
        queue: { type: "string" },
        bindingVersion: { type: "string" }
      }
    };
    OperationBindings.properties.nats = NatsOperationBinding;
    var JmsChannelBinding = {
      properties: {
        destination: { type: "string" },
        destinationType: { type: "string" },
        bindingVersion: { type: "string" }
      }
    };
    ChannelBindings.properties.jms = JmsChannelBinding;
    var JmsServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.jms = JmsServerBinding;
    var JmsMessageBinding = {
      properties: {
        headers: "Schema",
        bindingVersion: { type: "string" }
      }
    };
    MessageBindings.properties.jms = JmsMessageBinding;
    var JmsOperationBinding = {
      properties: {
        headers: "Schema",
        bindingVersion: { type: "string" }
      }
    };
    OperationBindings.properties.jms = JmsOperationBinding;
    var SolaceChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.solace = SolaceChannelBinding;
    var SolaceServerBinding = {
      properties: {
        bindingVersion: { type: "string" },
        msgVpn: { type: "string" }
      }
    };
    ServerBindings.properties.solace = SolaceServerBinding;
    var SolaceMessageBinding = {
      properties: {}
      // empty object
    };
    MessageBindings.properties.solace = SolaceMessageBinding;
    var SolaceDestination = {
      properties: {
        destinationType: { type: "string", enum: ["queue", "topic"] },
        deliveryMode: { type: "string", enum: ["direct", "persistent"] },
        "queue.name": { type: "string" },
        "queue.topicSubscriptions": { type: "array", items: { type: "string" } },
        "queue.accessType": { type: "string", enum: ["exclusive", "nonexclusive"] },
        "queue.maxMsgSpoolSize": { type: "string" },
        "queue.maxTtl": { type: "string" },
        "topic.topicSubscriptions": { type: "array", items: { type: "string" } }
      }
    };
    var SolaceOperationBinding = {
      properties: {
        bindingVersion: { type: "string" },
        destinations: (0, _1.listOf)("SolaceDestination")
      }
    };
    OperationBindings.properties.solace = SolaceOperationBinding;
    var StompChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.stomp = StompChannelBinding;
    var StompServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.stomp = StompServerBinding;
    var StompMessageBinding = {
      properties: {}
      // empty object
    };
    MessageBindings.properties.stomp = StompMessageBinding;
    var StompOperationBinding = {
      properties: {}
      // empty object
    };
    OperationBindings.properties.stomp = StompOperationBinding;
    var RedisChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.redis = RedisChannelBinding;
    var RedisServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.redis = RedisServerBinding;
    var RedisMessageBinding = {
      properties: {}
      // empty object
    };
    MessageBindings.properties.redis = RedisMessageBinding;
    var RedisOperationBinding = {
      properties: {}
      // empty object
    };
    OperationBindings.properties.redis = RedisOperationBinding;
    var MercureChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.mercure = MercureChannelBinding;
    var MercureServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.mercure = MercureServerBinding;
    var MercureMessageBinding = {
      properties: {}
      // empty object
    };
    MessageBindings.properties.mercure = MercureMessageBinding;
    var MercureOperationBinding = {
      properties: {}
      // empty object
    };
    OperationBindings.properties.mercure = MercureOperationBinding;
    exports2.AsyncApi2Types = {
      Root,
      Tag,
      TagList: (0, _1.listOf)("Tag"),
      ServerMap,
      ExternalDocs,
      Server,
      ServerVariable,
      ServerVariablesMap: (0, _1.mapOf)("ServerVariable"),
      SecurityRequirement,
      SecurityRequirementList: (0, _1.listOf)("SecurityRequirement"),
      Info,
      Contact,
      License,
      HttpServerBinding,
      HttpChannelBinding,
      HttpMessageBinding,
      HttpOperationBinding,
      WsServerBinding,
      WsChannelBinding,
      WsMessageBinding,
      WsOperationBinding,
      KafkaServerBinding,
      KafkaTopicConfiguration,
      KafkaChannelBinding,
      KafkaMessageBinding,
      KafkaOperationBinding,
      AnypointmqServerBinding,
      AnypointmqChannelBinding,
      AnypointmqMessageBinding,
      AnypointmqOperationBinding,
      AmqpServerBinding,
      AmqpChannelBinding,
      AmqpMessageBinding,
      AmqpOperationBinding,
      Amqp1ServerBinding,
      Amqp1ChannelBinding,
      Amqp1MessageBinding,
      Amqp1OperationBinding,
      MqttServerBindingLastWill,
      MqttServerBinding,
      MqttChannelBinding,
      MqttMessageBinding,
      MqttOperationBinding,
      Mqtt5ServerBinding,
      Mqtt5ChannelBinding,
      Mqtt5MessageBinding,
      Mqtt5OperationBinding,
      NatsServerBinding,
      NatsChannelBinding,
      NatsMessageBinding,
      NatsOperationBinding,
      JmsServerBinding,
      JmsChannelBinding,
      JmsMessageBinding,
      JmsOperationBinding,
      SolaceServerBinding,
      SolaceChannelBinding,
      SolaceMessageBinding,
      SolaceDestination,
      SolaceOperationBinding,
      StompServerBinding,
      StompChannelBinding,
      StompMessageBinding,
      StompOperationBinding,
      RedisServerBinding,
      RedisChannelBinding,
      RedisMessageBinding,
      RedisOperationBinding,
      MercureServerBinding,
      MercureChannelBinding,
      MercureMessageBinding,
      MercureOperationBinding,
      ServerBindings,
      ChannelBindings,
      ChannelMap,
      Channel,
      Parameter,
      ParametersMap: (0, _1.mapOf)("Parameter"),
      Operation,
      Schema: Schema3,
      MessageExample,
      SchemaProperties,
      DiscriminatorMapping,
      Discriminator,
      Components,
      NamedSchemas: (0, _1.mapOf)("Schema"),
      NamedMessages: (0, _1.mapOf)("Message"),
      NamedMessageTraits: (0, _1.mapOf)("MessageTrait"),
      NamedOperationTraits: (0, _1.mapOf)("OperationTrait"),
      NamedParameters: (0, _1.mapOf)("Parameter"),
      NamedSecuritySchemes: (0, _1.mapOf)("SecurityScheme"),
      NamedCorrelationIds: (0, _1.mapOf)("CorrelationId"),
      NamedStreamHeaders: (0, _1.mapOf)("StreamHeader"),
      ImplicitFlow,
      PasswordFlow,
      ClientCredentials,
      AuthorizationCode,
      SecuritySchemeFlows,
      SecurityScheme: SecurityScheme2,
      Message,
      MessageBindings,
      OperationBindings,
      OperationTrait,
      OperationTraitList: (0, _1.listOf)("OperationTrait"),
      MessageTrait,
      MessageTraitList: (0, _1.listOf)("MessageTrait"),
      CorrelationId
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/oas-types.js
var require_oas_types = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/oas-types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getTypes = exports2.getMajorSpecVersion = exports2.detectSpec = exports2.SpecMajorVersion = exports2.SpecVersion = void 0;
    var oas2_1 = require_oas2();
    var oas3_1 = require_oas3();
    var oas3_1_1 = require_oas3_1();
    var asyncapi_1 = require_asyncapi();
    var SpecVersion;
    (function(SpecVersion2) {
      SpecVersion2["OAS2"] = "oas2";
      SpecVersion2["OAS3_0"] = "oas3_0";
      SpecVersion2["OAS3_1"] = "oas3_1";
      SpecVersion2["Async2"] = "async2";
    })(SpecVersion || (exports2.SpecVersion = SpecVersion = {}));
    var SpecMajorVersion;
    (function(SpecMajorVersion2) {
      SpecMajorVersion2["OAS2"] = "oas2";
      SpecMajorVersion2["OAS3"] = "oas3";
      SpecMajorVersion2["Async2"] = "async2";
    })(SpecMajorVersion || (exports2.SpecMajorVersion = SpecMajorVersion = {}));
    var typesMap = {
      [SpecVersion.OAS2]: oas2_1.Oas2Types,
      [SpecVersion.OAS3_0]: oas3_1.Oas3Types,
      [SpecVersion.OAS3_1]: oas3_1_1.Oas3_1Types,
      [SpecVersion.Async2]: asyncapi_1.AsyncApi2Types
    };
    function detectSpec(root2) {
      if (typeof root2 !== "object") {
        throw new Error(`Document must be JSON object, got ${typeof root2}`);
      }
      if (root2.openapi && typeof root2.openapi !== "string") {
        throw new Error(`Invalid OpenAPI version: should be a string but got "${typeof root2.openapi}"`);
      }
      if (root2.openapi && root2.openapi.startsWith("3.0")) {
        return SpecVersion.OAS3_0;
      }
      if (root2.openapi && root2.openapi.startsWith("3.1")) {
        return SpecVersion.OAS3_1;
      }
      if (root2.swagger && root2.swagger === "2.0") {
        return SpecVersion.OAS2;
      }
      if (root2.openapi || root2.swagger) {
        throw new Error(`Unsupported OpenAPI version: ${root2.openapi || root2.swagger}`);
      }
      if (root2.asyncapi && root2.asyncapi.startsWith("2.")) {
        return SpecVersion.Async2;
      }
      if (root2.asyncapi) {
        throw new Error(`Unsupported AsyncAPI version: ${root2.asyncapi}`);
      }
      throw new Error(`Unsupported specification`);
    }
    exports2.detectSpec = detectSpec;
    function getMajorSpecVersion(version) {
      if (version === SpecVersion.OAS2) {
        return SpecMajorVersion.OAS2;
      } else if (version === SpecVersion.Async2) {
        return SpecMajorVersion.Async2;
      } else {
        return SpecMajorVersion.OAS3;
      }
    }
    exports2.getMajorSpecVersion = getMajorSpecVersion;
    function getTypes(spec) {
      return typesMap[spec];
    }
    exports2.getTypes = getTypes;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/utils.js
var require_utils5 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/utils.js"(exports2) {
    "use strict";
    var __rest = exports2 && exports2.__rest || function(s, e) {
      var t = {};
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
      if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
          if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
            t[p[i]] = s[p[i]];
        }
      return t;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ConfigValidationError = exports2.getUniquePlugins = exports2.getResolveConfig = exports2.transformConfig = exports2.checkForDeprecatedFields = exports2.getMergedConfig = exports2.mergeExtends = exports2.prefixRules = exports2.transformApiDefinitionsToApis = exports2.parsePresetName = void 0;
    var utils_1 = require_utils4();
    var config_1 = require_config();
    var logger_1 = require_logger();
    function parsePresetName(presetName) {
      if (presetName.indexOf("/") > -1) {
        const [pluginId, configName] = presetName.split("/");
        return { pluginId, configName };
      } else {
        return { pluginId: "", configName: presetName };
      }
    }
    exports2.parsePresetName = parsePresetName;
    function transformApiDefinitionsToApis(apiDefinitions) {
      if (!apiDefinitions)
        return void 0;
      const apis = {};
      for (const [apiName, apiPath] of Object.entries(apiDefinitions)) {
        apis[apiName] = { root: apiPath };
      }
      return apis;
    }
    exports2.transformApiDefinitionsToApis = transformApiDefinitionsToApis;
    function extractFlatConfig(_a) {
      var _b;
      var { plugins, extends: _extends, rules, oas2Rules, oas3_0Rules, oas3_1Rules, async2Rules, preprocessors, oas2Preprocessors, oas3_0Preprocessors, oas3_1Preprocessors, async2Preprocessors, decorators, oas2Decorators, oas3_0Decorators, oas3_1Decorators, async2Decorators } = _a, rawConfigRest = __rest(_a, ["plugins", "extends", "rules", "oas2Rules", "oas3_0Rules", "oas3_1Rules", "async2Rules", "preprocessors", "oas2Preprocessors", "oas3_0Preprocessors", "oas3_1Preprocessors", "async2Preprocessors", "decorators", "oas2Decorators", "oas3_0Decorators", "oas3_1Decorators", "async2Decorators"]);
      const styleguideConfig = {
        plugins,
        extends: _extends,
        rules,
        oas2Rules,
        oas3_0Rules,
        oas3_1Rules,
        async2Rules,
        preprocessors,
        oas2Preprocessors,
        oas3_0Preprocessors,
        oas3_1Preprocessors,
        async2Preprocessors,
        decorators,
        oas2Decorators,
        oas3_0Decorators,
        oas3_1Decorators,
        async2Decorators,
        doNotResolveExamples: (_b = rawConfigRest.resolve) === null || _b === void 0 ? void 0 : _b.doNotResolveExamples
      };
      if (rawConfigRest.lint && rawConfigRest.styleguide || Object.values(styleguideConfig).some(utils_1.isDefined) && (rawConfigRest.lint || rawConfigRest.styleguide)) {
        throw new Error(`Do not use 'lint', 'styleguide' and flat syntax together. 
See more about the configuration in the docs: https://redocly.com/docs/cli/configuration/ 
`);
      }
      return {
        styleguideConfig: Object.values(styleguideConfig).some(utils_1.isDefined) ? styleguideConfig : void 0,
        rawConfigRest
      };
    }
    function transformApis(legacyApis) {
      if (!legacyApis)
        return void 0;
      const apis = {};
      for (let _a of Object.entries(legacyApis)) {
        const [apiName, _b] = _a, { lint } = _b, apiContent = __rest(_b, ["lint"]);
        const { styleguideConfig, rawConfigRest } = extractFlatConfig(apiContent);
        apis[apiName] = Object.assign({ styleguide: styleguideConfig || lint }, rawConfigRest);
      }
      return apis;
    }
    function prefixRules(rules, prefix) {
      if (!prefix)
        return rules;
      const res = {};
      for (const name of Object.keys(rules)) {
        res[`${prefix}/${name}`] = rules[name];
      }
      return res;
    }
    exports2.prefixRules = prefixRules;
    function mergeExtends(rulesConfList) {
      const result = {
        rules: {},
        oas2Rules: {},
        oas3_0Rules: {},
        oas3_1Rules: {},
        async2Rules: {},
        preprocessors: {},
        oas2Preprocessors: {},
        oas3_0Preprocessors: {},
        oas3_1Preprocessors: {},
        async2Preprocessors: {},
        decorators: {},
        oas2Decorators: {},
        oas3_0Decorators: {},
        oas3_1Decorators: {},
        async2Decorators: {},
        plugins: [],
        pluginPaths: [],
        extendPaths: []
      };
      for (const rulesConf of rulesConfList) {
        if (rulesConf.extends) {
          throw new Error(`'extends' is not supported in shared configs yet: ${JSON.stringify(rulesConf, null, 2)}.`);
        }
        Object.assign(result.rules, rulesConf.rules);
        Object.assign(result.oas2Rules, rulesConf.oas2Rules);
        (0, utils_1.assignExisting)(result.oas2Rules, rulesConf.rules || {});
        Object.assign(result.oas3_0Rules, rulesConf.oas3_0Rules);
        (0, utils_1.assignExisting)(result.oas3_0Rules, rulesConf.rules || {});
        Object.assign(result.oas3_1Rules, rulesConf.oas3_1Rules);
        (0, utils_1.assignExisting)(result.oas3_1Rules, rulesConf.rules || {});
        Object.assign(result.async2Rules, rulesConf.async2Rules);
        (0, utils_1.assignExisting)(result.async2Rules, rulesConf.rules || {});
        Object.assign(result.preprocessors, rulesConf.preprocessors);
        Object.assign(result.oas2Preprocessors, rulesConf.oas2Preprocessors);
        (0, utils_1.assignExisting)(result.oas2Preprocessors, rulesConf.preprocessors || {});
        Object.assign(result.oas3_0Preprocessors, rulesConf.oas3_0Preprocessors);
        (0, utils_1.assignExisting)(result.oas3_0Preprocessors, rulesConf.preprocessors || {});
        Object.assign(result.oas3_1Preprocessors, rulesConf.oas3_1Preprocessors);
        (0, utils_1.assignExisting)(result.oas3_1Preprocessors, rulesConf.preprocessors || {});
        Object.assign(result.async2Preprocessors, rulesConf.async2Preprocessors);
        (0, utils_1.assignExisting)(result.async2Preprocessors, rulesConf.preprocessors || {});
        Object.assign(result.decorators, rulesConf.decorators);
        Object.assign(result.oas2Decorators, rulesConf.oas2Decorators);
        (0, utils_1.assignExisting)(result.oas2Decorators, rulesConf.decorators || {});
        Object.assign(result.oas3_0Decorators, rulesConf.oas3_0Decorators);
        (0, utils_1.assignExisting)(result.oas3_0Decorators, rulesConf.decorators || {});
        Object.assign(result.oas3_1Decorators, rulesConf.oas3_1Decorators);
        (0, utils_1.assignExisting)(result.oas3_1Decorators, rulesConf.decorators || {});
        Object.assign(result.async2Decorators, rulesConf.async2Decorators);
        (0, utils_1.assignExisting)(result.async2Decorators, rulesConf.decorators || {});
        result.plugins.push(...rulesConf.plugins || []);
        result.pluginPaths.push(...rulesConf.pluginPaths || []);
        result.extendPaths.push(...new Set(rulesConf.extendPaths));
      }
      return result;
    }
    exports2.mergeExtends = mergeExtends;
    function getMergedConfig(config, apiName) {
      var _a, _b, _c, _d, _e, _f, _g, _h;
      const extendPaths = [
        ...Object.values(config.apis).map((api) => {
          var _a2;
          return (_a2 = api === null || api === void 0 ? void 0 : api.styleguide) === null || _a2 === void 0 ? void 0 : _a2.extendPaths;
        }),
        (_b = (_a = config.rawConfig) === null || _a === void 0 ? void 0 : _a.styleguide) === null || _b === void 0 ? void 0 : _b.extendPaths
      ].flat().filter(utils_1.isTruthy);
      const pluginPaths = [
        ...Object.values(config.apis).map((api) => {
          var _a2;
          return (_a2 = api === null || api === void 0 ? void 0 : api.styleguide) === null || _a2 === void 0 ? void 0 : _a2.pluginPaths;
        }),
        (_d = (_c = config.rawConfig) === null || _c === void 0 ? void 0 : _c.styleguide) === null || _d === void 0 ? void 0 : _d.pluginPaths
      ].flat().filter(utils_1.isTruthy);
      return apiName ? new config_1.Config(Object.assign(Object.assign({}, config.rawConfig), { styleguide: Object.assign(Object.assign({}, config.apis[apiName] ? config.apis[apiName].styleguide : config.rawConfig.styleguide), {
        extendPaths,
        pluginPaths
      }), theme: Object.assign(Object.assign({}, config.rawConfig.theme), (_e = config.apis[apiName]) === null || _e === void 0 ? void 0 : _e.theme), files: [...config.files, ...(_h = (_g = (_f = config.apis) === null || _f === void 0 ? void 0 : _f[apiName]) === null || _g === void 0 ? void 0 : _g.files) !== null && _h !== void 0 ? _h : []] }), config.configFile) : config;
    }
    exports2.getMergedConfig = getMergedConfig;
    function checkForDeprecatedFields(deprecatedField, updatedField, rawConfig, updatedObject) {
      const isDeprecatedFieldInApis = rawConfig.apis && Object.values(rawConfig.apis).some((api) => api[deprecatedField]);
      if (rawConfig[deprecatedField] && updatedField === null) {
        (0, utils_1.showWarningForDeprecatedField)(deprecatedField);
      }
      if (rawConfig[deprecatedField] && updatedField && rawConfig[updatedField]) {
        (0, utils_1.showErrorForDeprecatedField)(deprecatedField, updatedField);
      }
      if (rawConfig[deprecatedField] && updatedObject && rawConfig[updatedObject]) {
        (0, utils_1.showErrorForDeprecatedField)(deprecatedField, updatedField, updatedObject);
      }
      if (rawConfig[deprecatedField] || isDeprecatedFieldInApis) {
        (0, utils_1.showWarningForDeprecatedField)(deprecatedField, updatedField, updatedObject);
      }
    }
    exports2.checkForDeprecatedFields = checkForDeprecatedFields;
    function transformConfig(rawConfig) {
      var _a, _b;
      const migratedFields = [
        ["apiDefinitions", "apis", void 0],
        ["referenceDocs", "openapi", "theme"],
        ["lint", void 0, void 0],
        ["styleguide", void 0, void 0],
        ["features.openapi", "openapi", "theme"]
      ];
      for (const [deprecatedField, updatedField, updatedObject] of migratedFields) {
        checkForDeprecatedFields(deprecatedField, updatedField, rawConfig, updatedObject);
      }
      const { apis, apiDefinitions, referenceDocs, lint } = rawConfig, rest = __rest(rawConfig, ["apis", "apiDefinitions", "referenceDocs", "lint"]);
      const { styleguideConfig, rawConfigRest } = extractFlatConfig(rest);
      const transformedConfig = Object.assign({ theme: {
        openapi: Object.assign(Object.assign(Object.assign({}, referenceDocs), rawConfig["features.openapi"]), (_a = rawConfig.theme) === null || _a === void 0 ? void 0 : _a.openapi),
        mockServer: Object.assign(Object.assign({}, rawConfig["features.mockServer"]), (_b = rawConfig.theme) === null || _b === void 0 ? void 0 : _b.mockServer)
      }, apis: transformApis(apis) || transformApiDefinitionsToApis(apiDefinitions), styleguide: styleguideConfig || lint }, rawConfigRest);
      showDeprecationMessages(transformedConfig);
      return transformedConfig;
    }
    exports2.transformConfig = transformConfig;
    function showDeprecationMessages(config) {
      var _a, _b;
      let allRules = Object.assign({}, (_a = config.styleguide) === null || _a === void 0 ? void 0 : _a.rules);
      for (const api of Object.values(config.apis || {})) {
        allRules = Object.assign(Object.assign({}, allRules), (_b = api === null || api === void 0 ? void 0 : api.styleguide) === null || _b === void 0 ? void 0 : _b.rules);
      }
      for (const ruleKey of Object.keys(allRules)) {
        if (ruleKey.startsWith("assert/")) {
          logger_1.logger.warn(`
The 'assert/' syntax in ${ruleKey} is deprecated. Update your configuration to use 'rule/' instead. Examples and more information: https://redocly.com/docs/cli/rules/configurable-rules/
`);
        }
      }
    }
    function getResolveConfig(resolve) {
      var _a, _b;
      return {
        http: {
          headers: (_b = (_a = resolve === null || resolve === void 0 ? void 0 : resolve.http) === null || _a === void 0 ? void 0 : _a.headers) !== null && _b !== void 0 ? _b : [],
          customFetch: void 0
        }
      };
    }
    exports2.getResolveConfig = getResolveConfig;
    function getUniquePlugins(plugins) {
      const seen = /* @__PURE__ */ new Set();
      const results = [];
      for (const p of plugins) {
        if (!seen.has(p.id)) {
          results.push(p);
          seen.add(p.id);
        } else if (p.id) {
          logger_1.logger.warn(`Duplicate plugin id "${logger_1.colorize.red(p.id)}".
`);
        }
      }
      return results;
    }
    exports2.getUniquePlugins = getUniquePlugins;
    var ConfigValidationError = class extends Error {
    };
    exports2.ConfigValidationError = ConfigValidationError;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/config.js
var require_config = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/config.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Config = exports2.StyleguideConfig = exports2.AVAILABLE_REGIONS = exports2.DOMAINS = exports2.DEFAULT_REGION = exports2.IGNORE_FILE = void 0;
    var fs = require("fs");
    var path5 = require("path");
    var js_yaml_1 = require_js_yaml2();
    var utils_1 = require_utils4();
    var oas_types_1 = require_oas_types();
    var env_1 = require_env();
    var utils_2 = require_utils5();
    var ref_utils_1 = require_ref_utils();
    exports2.IGNORE_FILE = ".redocly.lint-ignore.yaml";
    var IGNORE_BANNER = `# This file instructs Redocly's linter to ignore the rules contained for specific parts of your API.
# See https://redoc.ly/docs/cli/ for more information.
`;
    exports2.DEFAULT_REGION = "us";
    function getDomains() {
      const domains = {
        us: "redocly.com",
        eu: "eu.redocly.com"
      };
      const domain = env_1.env.REDOCLY_DOMAIN;
      if (domain === null || domain === void 0 ? void 0 : domain.endsWith(".redocly.host")) {
        domains[domain.split(".")[0]] = domain;
      }
      if (domain === "redoc.online") {
        domains[domain] = domain;
      }
      return domains;
    }
    function getIgnoreFilePath(configFile) {
      if (configFile) {
        return (0, utils_1.doesYamlFileExist)(configFile) ? path5.join(path5.dirname(configFile), exports2.IGNORE_FILE) : path5.join(configFile, exports2.IGNORE_FILE);
      } else {
        return env_1.isBrowser ? void 0 : path5.join(process.cwd(), exports2.IGNORE_FILE);
      }
    }
    exports2.DOMAINS = getDomains();
    exports2.AVAILABLE_REGIONS = Object.keys(exports2.DOMAINS);
    var StyleguideConfig = class {
      constructor(rawConfig, configFile) {
        this.rawConfig = rawConfig;
        this.configFile = configFile;
        this.ignore = {};
        this._usedRules = /* @__PURE__ */ new Set();
        this._usedVersions = /* @__PURE__ */ new Set();
        this.plugins = rawConfig.plugins || [];
        this.doNotResolveExamples = !!rawConfig.doNotResolveExamples;
        this.recommendedFallback = rawConfig.recommendedFallback || false;
        this.rules = {
          [oas_types_1.SpecVersion.OAS2]: Object.assign(Object.assign({}, rawConfig.rules), rawConfig.oas2Rules),
          [oas_types_1.SpecVersion.OAS3_0]: Object.assign(Object.assign({}, rawConfig.rules), rawConfig.oas3_0Rules),
          [oas_types_1.SpecVersion.OAS3_1]: Object.assign(Object.assign({}, rawConfig.rules), rawConfig.oas3_1Rules),
          [oas_types_1.SpecVersion.Async2]: Object.assign(Object.assign({}, rawConfig.rules), rawConfig.async2Rules)
        };
        this.preprocessors = {
          [oas_types_1.SpecVersion.OAS2]: Object.assign(Object.assign({}, rawConfig.preprocessors), rawConfig.oas2Preprocessors),
          [oas_types_1.SpecVersion.OAS3_0]: Object.assign(Object.assign({}, rawConfig.preprocessors), rawConfig.oas3_0Preprocessors),
          [oas_types_1.SpecVersion.OAS3_1]: Object.assign(Object.assign({}, rawConfig.preprocessors), rawConfig.oas3_1Preprocessors),
          [oas_types_1.SpecVersion.Async2]: Object.assign(Object.assign({}, rawConfig.preprocessors), rawConfig.async2Preprocessors)
        };
        this.decorators = {
          [oas_types_1.SpecVersion.OAS2]: Object.assign(Object.assign({}, rawConfig.decorators), rawConfig.oas2Decorators),
          [oas_types_1.SpecVersion.OAS3_0]: Object.assign(Object.assign({}, rawConfig.decorators), rawConfig.oas3_0Decorators),
          [oas_types_1.SpecVersion.OAS3_1]: Object.assign(Object.assign({}, rawConfig.decorators), rawConfig.oas3_1Decorators),
          [oas_types_1.SpecVersion.Async2]: Object.assign(Object.assign({}, rawConfig.decorators), rawConfig.async2Decorators)
        };
        this.extendPaths = rawConfig.extendPaths || [];
        this.pluginPaths = rawConfig.pluginPaths || [];
        this.resolveIgnore(getIgnoreFilePath(configFile));
      }
      resolveIgnore(ignoreFile) {
        if (!ignoreFile || !(0, utils_1.doesYamlFileExist)(ignoreFile))
          return;
        this.ignore = (0, js_yaml_1.parseYaml)(fs.readFileSync(ignoreFile, "utf-8")) || {};
        for (const fileName of Object.keys(this.ignore)) {
          this.ignore[(0, ref_utils_1.isAbsoluteUrl)(fileName) ? fileName : path5.resolve(path5.dirname(ignoreFile), fileName)] = this.ignore[fileName];
          for (const ruleId of Object.keys(this.ignore[fileName])) {
            this.ignore[fileName][ruleId] = new Set(this.ignore[fileName][ruleId]);
          }
          if (!(0, ref_utils_1.isAbsoluteUrl)(fileName)) {
            delete this.ignore[fileName];
          }
        }
      }
      saveIgnore() {
        const dir = this.configFile ? path5.dirname(this.configFile) : process.cwd();
        const ignoreFile = path5.join(dir, exports2.IGNORE_FILE);
        const mapped = {};
        for (const absFileName of Object.keys(this.ignore)) {
          const mappedDefinitionName = (0, ref_utils_1.isAbsoluteUrl)(absFileName) ? absFileName : (0, utils_1.slash)(path5.relative(dir, absFileName));
          const ignoredRules = mapped[mappedDefinitionName] = this.ignore[absFileName];
          for (const ruleId of Object.keys(ignoredRules)) {
            ignoredRules[ruleId] = Array.from(ignoredRules[ruleId]);
          }
        }
        fs.writeFileSync(ignoreFile, IGNORE_BANNER + (0, js_yaml_1.stringifyYaml)(mapped));
      }
      addIgnore(problem) {
        const ignore = this.ignore;
        const loc = problem.location[0];
        if (loc.pointer === void 0)
          return;
        const fileIgnore = ignore[loc.source.absoluteRef] = ignore[loc.source.absoluteRef] || {};
        const ruleIgnore = fileIgnore[problem.ruleId] = fileIgnore[problem.ruleId] || /* @__PURE__ */ new Set();
        ruleIgnore.add(loc.pointer);
      }
      addProblemToIgnore(problem) {
        const loc = problem.location[0];
        if (loc.pointer === void 0)
          return problem;
        const fileIgnore = this.ignore[loc.source.absoluteRef] || {};
        const ruleIgnore = fileIgnore[problem.ruleId];
        const ignored = ruleIgnore && ruleIgnore.has(loc.pointer);
        return ignored ? Object.assign(Object.assign({}, problem), { ignored }) : problem;
      }
      extendTypes(types2, version) {
        let extendedTypes = types2;
        for (const plugin of this.plugins) {
          if (plugin.typeExtension !== void 0) {
            switch (version) {
              case oas_types_1.SpecVersion.OAS3_0:
              case oas_types_1.SpecVersion.OAS3_1:
                if (!plugin.typeExtension.oas3)
                  continue;
                extendedTypes = plugin.typeExtension.oas3(extendedTypes, version);
                break;
              case oas_types_1.SpecVersion.OAS2:
                if (!plugin.typeExtension.oas2)
                  continue;
                extendedTypes = plugin.typeExtension.oas2(extendedTypes, version);
                break;
              case oas_types_1.SpecVersion.Async2:
                if (!plugin.typeExtension.async2)
                  continue;
                extendedTypes = plugin.typeExtension.async2(extendedTypes, version);
                break;
              default:
                throw new Error("Not implemented");
            }
          }
        }
        return extendedTypes;
      }
      getRuleSettings(ruleId, oasVersion) {
        this._usedRules.add(ruleId);
        this._usedVersions.add(oasVersion);
        const settings = this.rules[oasVersion][ruleId] || "off";
        if (typeof settings === "string") {
          return {
            severity: settings
          };
        } else {
          return Object.assign({ severity: "error" }, settings);
        }
      }
      getPreprocessorSettings(ruleId, oasVersion) {
        this._usedRules.add(ruleId);
        this._usedVersions.add(oasVersion);
        const settings = this.preprocessors[oasVersion][ruleId] || "off";
        if (typeof settings === "string") {
          return {
            severity: settings === "on" ? "error" : settings
          };
        } else {
          return Object.assign({ severity: "error" }, settings);
        }
      }
      getDecoratorSettings(ruleId, oasVersion) {
        this._usedRules.add(ruleId);
        this._usedVersions.add(oasVersion);
        const settings = this.decorators[oasVersion][ruleId] || "off";
        if (typeof settings === "string") {
          return {
            severity: settings === "on" ? "error" : settings
          };
        } else {
          return Object.assign({ severity: "error" }, settings);
        }
      }
      getUnusedRules() {
        const rules = [];
        const decorators = [];
        const preprocessors = [];
        for (const usedVersion of Array.from(this._usedVersions)) {
          rules.push(...Object.keys(this.rules[usedVersion]).filter((name) => !this._usedRules.has(name)));
          decorators.push(...Object.keys(this.decorators[usedVersion]).filter((name) => !this._usedRules.has(name)));
          preprocessors.push(...Object.keys(this.preprocessors[usedVersion]).filter((name) => !this._usedRules.has(name)));
        }
        return {
          rules,
          preprocessors,
          decorators
        };
      }
      getRulesForOasVersion(version) {
        switch (version) {
          case oas_types_1.SpecMajorVersion.OAS3:
            const oas3Rules = [];
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.preprocessors) === null || _a === void 0 ? void 0 : _a.oas3) && oas3Rules.push(p.preprocessors.oas3);
            });
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.rules) === null || _a === void 0 ? void 0 : _a.oas3) && oas3Rules.push(p.rules.oas3);
            });
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.decorators) === null || _a === void 0 ? void 0 : _a.oas3) && oas3Rules.push(p.decorators.oas3);
            });
            return oas3Rules;
          case oas_types_1.SpecMajorVersion.OAS2:
            const oas2Rules = [];
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.preprocessors) === null || _a === void 0 ? void 0 : _a.oas2) && oas2Rules.push(p.preprocessors.oas2);
            });
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.rules) === null || _a === void 0 ? void 0 : _a.oas2) && oas2Rules.push(p.rules.oas2);
            });
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.decorators) === null || _a === void 0 ? void 0 : _a.oas2) && oas2Rules.push(p.decorators.oas2);
            });
            return oas2Rules;
          case oas_types_1.SpecMajorVersion.Async2:
            const asyncApiRules = [];
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.preprocessors) === null || _a === void 0 ? void 0 : _a.async2) && asyncApiRules.push(p.preprocessors.async2);
            });
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.rules) === null || _a === void 0 ? void 0 : _a.async2) && asyncApiRules.push(p.rules.async2);
            });
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.decorators) === null || _a === void 0 ? void 0 : _a.async2) && asyncApiRules.push(p.decorators.async2);
            });
            return asyncApiRules;
        }
      }
      skipRules(rules) {
        for (const ruleId of rules || []) {
          for (const version of Object.values(oas_types_1.SpecVersion)) {
            if (this.rules[version][ruleId]) {
              this.rules[version][ruleId] = "off";
            }
          }
        }
      }
      skipPreprocessors(preprocessors) {
        for (const preprocessorId of preprocessors || []) {
          for (const version of Object.values(oas_types_1.SpecVersion)) {
            if (this.preprocessors[version][preprocessorId]) {
              this.preprocessors[version][preprocessorId] = "off";
            }
          }
        }
      }
      skipDecorators(decorators) {
        for (const decoratorId of decorators || []) {
          for (const version of Object.values(oas_types_1.SpecVersion)) {
            if (this.decorators[version][decoratorId]) {
              this.decorators[version][decoratorId] = "off";
            }
          }
        }
      }
    };
    exports2.StyleguideConfig = StyleguideConfig;
    var Config2 = class {
      constructor(rawConfig, configFile) {
        this.rawConfig = rawConfig;
        this.configFile = configFile;
        this.apis = rawConfig.apis || {};
        this.styleguide = new StyleguideConfig(rawConfig.styleguide || {}, configFile);
        this.theme = rawConfig.theme || {};
        this.resolve = (0, utils_2.getResolveConfig)(rawConfig === null || rawConfig === void 0 ? void 0 : rawConfig.resolve);
        this.region = rawConfig.region;
        this.organization = rawConfig.organization;
        this.files = rawConfig.files || [];
        this.telemetry = rawConfig.telemetry;
      }
    };
    exports2.Config = Config2;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/types.js
var require_types2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.DEFAULT_TEAM_CLAIM_NAME = exports2.ApigeeDevOnboardingIntegrationAuthType = exports2.AuthProviderType = void 0;
    var AuthProviderType;
    (function(AuthProviderType2) {
      AuthProviderType2["OIDC"] = "OIDC";
      AuthProviderType2["SAML2"] = "SAML2";
      AuthProviderType2["BASIC"] = "BASIC";
    })(AuthProviderType || (exports2.AuthProviderType = AuthProviderType = {}));
    var ApigeeDevOnboardingIntegrationAuthType;
    (function(ApigeeDevOnboardingIntegrationAuthType2) {
      ApigeeDevOnboardingIntegrationAuthType2["SERVICE_ACCOUNT"] = "SERVICE_ACCOUNT";
      ApigeeDevOnboardingIntegrationAuthType2["OAUTH2"] = "OAUTH2";
    })(ApigeeDevOnboardingIntegrationAuthType || (exports2.ApigeeDevOnboardingIntegrationAuthType = ApigeeDevOnboardingIntegrationAuthType = {}));
    exports2.DEFAULT_TEAM_CLAIM_NAME = "https://redocly.com/sso/teams";
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/rules.js
var require_rules = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/rules.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.initRules = void 0;
    var utils_1 = require_utils4();
    function initRules(rules, config, type2, oasVersion) {
      return rules.flatMap((ruleset) => Object.keys(ruleset).map((ruleId) => {
        const rule = ruleset[ruleId];
        const ruleSettings = type2 === "rules" ? config.getRuleSettings(ruleId, oasVersion) : type2 === "preprocessors" ? config.getPreprocessorSettings(ruleId, oasVersion) : config.getDecoratorSettings(ruleId, oasVersion);
        if (ruleSettings.severity === "off") {
          return void 0;
        }
        const severity = ruleSettings.severity;
        const visitors = rule(ruleSettings);
        if (Array.isArray(visitors)) {
          return visitors.map((visitor) => ({
            severity,
            ruleId,
            visitor
          }));
        }
        return {
          severity,
          ruleId,
          visitor: visitors
          // note: actually it is only one visitor object
        };
      })).flatMap((visitor) => visitor).filter(utils_1.isDefined);
    }
    exports2.initRules = initRules;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/recommended.js
var require_recommended = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/recommended.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var recommended = {
      rules: {
        "info-contact": "off",
        "info-license": "warn",
        "info-license-url": "warn",
        "tag-description": "warn",
        "tags-alphabetical": "off",
        "parameter-description": "off",
        "no-path-trailing-slash": "error",
        "no-identical-paths": "error",
        "no-ambiguous-paths": "warn",
        "path-declaration-must-exist": "error",
        "path-not-include-query": "error",
        "path-parameters-defined": "error",
        "operation-description": "off",
        "operation-2xx-response": "warn",
        "operation-4xx-response": "warn",
        "operation-operationId": "warn",
        "operation-summary": "error",
        "operation-operationId-unique": "error",
        "operation-operationId-url-safe": "error",
        "operation-parameters-unique": "error",
        "operation-tag-defined": "off",
        "security-defined": "error",
        "operation-singular-tag": "off",
        "no-unresolved-refs": "error",
        "no-enum-type-mismatch": "error",
        "paths-kebab-case": "off",
        spec: "error",
        "spec-strict-refs": "off",
        "no-http-verbs-in-paths": "off",
        "no-invalid-parameter-examples": "off",
        "no-invalid-schema-examples": "off",
        "path-excludes-patterns": "off",
        "path-http-verbs-order": "off",
        "path-params-defined": "off",
        "path-segment-plural": "off",
        "required-string-property-missing-min-length": "off",
        "response-contains-header": "off",
        "scalar-property-missing-example": "off"
      },
      oas2Rules: {
        "boolean-parameter-prefixes": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      oas3_0Rules: {
        "no-invalid-media-type-examples": {
          severity: "warn",
          allowAdditionalProperties: false
        },
        "no-server-example.com": "warn",
        "no-server-trailing-slash": "error",
        "no-empty-servers": "error",
        "no-example-value-and-externalValue": "error",
        "no-unused-components": "warn",
        "no-undefined-server-variable": "error",
        "no-server-variables-empty-enum": "error",
        "spec-components-invalid-map-name": "error",
        "boolean-parameter-prefixes": "off",
        "component-name-unique": "off",
        "operation-4xx-problem-details-rfc7807": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      oas3_1Rules: {
        "no-invalid-media-type-examples": "warn",
        "no-server-example.com": "warn",
        "no-server-trailing-slash": "error",
        "no-empty-servers": "error",
        "no-example-value-and-externalValue": "error",
        "no-unused-components": "warn",
        "no-undefined-server-variable": "error",
        "no-server-variables-empty-enum": "error",
        "spec-components-invalid-map-name": "error",
        "boolean-parameter-prefixes": "off",
        "component-name-unique": "off",
        "operation-4xx-problem-details-rfc7807": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      async2Rules: {
        "channels-kebab-case": "off",
        "no-channel-trailing-slash": "off"
      }
    };
    exports2.default = recommended;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/recommended-strict.js
var require_recommended_strict = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/recommended-strict.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var recommendedStrict = {
      rules: {
        "info-contact": "off",
        "info-license": "error",
        "info-license-url": "error",
        "tag-description": "error",
        "tags-alphabetical": "off",
        "parameter-description": "off",
        "no-path-trailing-slash": "error",
        "no-identical-paths": "error",
        "no-ambiguous-paths": "error",
        "path-declaration-must-exist": "error",
        "path-not-include-query": "error",
        "path-parameters-defined": "error",
        "operation-description": "off",
        "operation-2xx-response": "error",
        "operation-4xx-response": "error",
        "operation-operationId": "error",
        "operation-summary": "error",
        "operation-operationId-unique": "error",
        "operation-operationId-url-safe": "error",
        "operation-parameters-unique": "error",
        "operation-tag-defined": "off",
        "security-defined": "error",
        "operation-singular-tag": "off",
        "no-unresolved-refs": "error",
        "no-enum-type-mismatch": "error",
        "paths-kebab-case": "off",
        spec: "error",
        "spec-strict-refs": "off",
        "no-http-verbs-in-paths": "off",
        "no-invalid-parameter-examples": "off",
        "no-invalid-schema-examples": "off",
        "path-excludes-patterns": "off",
        "path-http-verbs-order": "off",
        "path-params-defined": "off",
        "path-segment-plural": "off",
        "required-string-property-missing-min-length": "off",
        "response-contains-header": "off",
        "scalar-property-missing-example": "off"
      },
      oas2Rules: {
        "boolean-parameter-prefixes": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      oas3_0Rules: {
        "no-invalid-media-type-examples": {
          severity: "error",
          allowAdditionalProperties: false
        },
        "no-server-example.com": "error",
        "no-server-trailing-slash": "error",
        "no-empty-servers": "error",
        "no-example-value-and-externalValue": "error",
        "no-unused-components": "error",
        "no-undefined-server-variable": "error",
        "no-server-variables-empty-enum": "error",
        "spec-components-invalid-map-name": "error",
        "boolean-parameter-prefixes": "off",
        "component-name-unique": "off",
        "operation-4xx-problem-details-rfc7807": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      oas3_1Rules: {
        "no-invalid-media-type-examples": "error",
        "no-server-example.com": "error",
        "no-server-trailing-slash": "error",
        "no-empty-servers": "error",
        "no-example-value-and-externalValue": "error",
        "no-unused-components": "error",
        "no-undefined-server-variable": "error",
        "no-server-variables-empty-enum": "error",
        "spec-components-invalid-map-name": "error",
        "boolean-parameter-prefixes": "off",
        "component-name-unique": "off",
        "operation-4xx-problem-details-rfc7807": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      async2Rules: {
        "channels-kebab-case": "off",
        "no-channel-trailing-slash": "off"
      }
    };
    exports2.default = recommendedStrict;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/all.js
var require_all = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/all.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var all = {
      rules: {
        "info-contact": "error",
        "info-license": "error",
        "info-license-url": "error",
        "tag-description": "error",
        "tags-alphabetical": "error",
        "parameter-description": "error",
        "no-identical-paths": "error",
        "no-ambiguous-paths": "error",
        "no-path-trailing-slash": "error",
        "path-segment-plural": "error",
        "path-declaration-must-exist": "error",
        "path-not-include-query": "error",
        "path-parameters-defined": "error",
        "operation-description": "error",
        "operation-2xx-response": "error",
        "operation-4xx-response": "error",
        "operation-operationId": "error",
        "operation-summary": "error",
        "operation-operationId-unique": "error",
        "operation-operationId-url-safe": "error",
        "operation-parameters-unique": "error",
        "operation-tag-defined": "error",
        "security-defined": "error",
        "operation-singular-tag": "error",
        "no-unresolved-refs": "error",
        "no-enum-type-mismatch": "error",
        "paths-kebab-case": "error",
        "no-http-verbs-in-paths": "error",
        "path-excludes-patterns": {
          severity: "error",
          patterns: []
        },
        spec: "error",
        "no-invalid-schema-examples": "error",
        "no-invalid-parameter-examples": "error",
        "scalar-property-missing-example": "error",
        "spec-strict-refs": "error",
        "path-http-verbs-order": "error",
        "path-params-defined": "error",
        "required-string-property-missing-min-length": "error",
        "response-contains-header": "error"
      },
      oas2Rules: {
        "boolean-parameter-prefixes": "error",
        "request-mime-type": {
          severity: "error",
          allowedValues: ["application/json"]
        },
        "response-mime-type": {
          severity: "error",
          allowedValues: ["application/json"]
        },
        "response-contains-property": "error"
      },
      oas3_0Rules: {
        "no-invalid-media-type-examples": "error",
        "no-server-example.com": "error",
        "no-server-trailing-slash": "error",
        "no-empty-servers": "error",
        "no-example-value-and-externalValue": "error",
        "no-unused-components": "error",
        "no-undefined-server-variable": "error",
        "no-server-variables-empty-enum": "error",
        "operation-4xx-problem-details-rfc7807": "error",
        "boolean-parameter-prefixes": "error",
        "request-mime-type": {
          severity: "error",
          allowedValues: ["application/json"]
        },
        "response-mime-type": {
          severity: "error",
          allowedValues: ["application/json"]
        },
        "component-name-unique": "error",
        "response-contains-property": "error",
        "spec-components-invalid-map-name": "error"
      },
      oas3_1Rules: {
        "no-invalid-media-type-examples": "error",
        "no-server-example.com": "error",
        "no-server-trailing-slash": "error",
        "no-empty-servers": "error",
        "no-example-value-and-externalValue": "error",
        "no-unused-components": "error",
        "no-undefined-server-variable": "error",
        "no-server-variables-empty-enum": "error",
        "operation-4xx-problem-details-rfc7807": "error",
        "boolean-parameter-prefixes": "error",
        "request-mime-type": {
          severity: "error",
          allowedValues: ["application/json"]
        },
        "response-mime-type": {
          severity: "error",
          allowedValues: ["application/json"]
        },
        "component-name-unique": "error",
        "response-contains-property": "error",
        "spec-components-invalid-map-name": "error"
      },
      async2Rules: {
        "channels-kebab-case": "error",
        "no-channel-trailing-slash": "error"
      }
    };
    exports2.default = all;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/minimal.js
var require_minimal = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/minimal.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var minimal = {
      rules: {
        "info-contact": "off",
        "info-license": "off",
        "info-license-url": "off",
        "tag-description": "warn",
        "tags-alphabetical": "off",
        "parameter-description": "off",
        "no-path-trailing-slash": "warn",
        "no-identical-paths": "warn",
        "no-ambiguous-paths": "warn",
        "path-declaration-must-exist": "warn",
        "path-not-include-query": "warn",
        "path-parameters-defined": "warn",
        "operation-description": "off",
        "operation-2xx-response": "warn",
        "operation-4xx-response": "off",
        "operation-operationId": "warn",
        "operation-summary": "warn",
        "operation-operationId-unique": "warn",
        "operation-parameters-unique": "warn",
        "operation-tag-defined": "off",
        "security-defined": "warn",
        "operation-operationId-url-safe": "warn",
        "operation-singular-tag": "off",
        "no-unresolved-refs": "error",
        "no-enum-type-mismatch": "warn",
        "paths-kebab-case": "off",
        spec: "error",
        "spec-strict-refs": "off",
        "no-http-verbs-in-paths": "off",
        "no-invalid-parameter-examples": "off",
        "no-invalid-schema-examples": "off",
        "path-excludes-patterns": "off",
        "path-http-verbs-order": "off",
        "path-params-defined": "off",
        "required-string-property-missing-min-length": "off",
        "response-contains-header": "off",
        "path-segment-plural": "off",
        "scalar-property-missing-example": "off"
      },
      oas2Rules: {
        "boolean-parameter-prefixes": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      oas3_0Rules: {
        "no-invalid-media-type-examples": {
          severity: "warn",
          allowAdditionalProperties: false
        },
        "no-server-example.com": "warn",
        "no-server-trailing-slash": "error",
        "no-empty-servers": "warn",
        "no-example-value-and-externalValue": "warn",
        "no-unused-components": "warn",
        "no-undefined-server-variable": "warn",
        "no-server-variables-empty-enum": "error",
        "spec-components-invalid-map-name": "warn",
        "boolean-parameter-prefixes": "off",
        "component-name-unique": "off",
        "operation-4xx-problem-details-rfc7807": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      oas3_1Rules: {
        "no-invalid-media-type-examples": "warn",
        "no-server-example.com": "warn",
        "no-server-trailing-slash": "error",
        "no-empty-servers": "warn",
        "no-example-value-and-externalValue": "warn",
        "no-unused-components": "warn",
        "no-undefined-server-variable": "warn",
        "no-server-variables-empty-enum": "error",
        "spec-components-invalid-map-name": "warn",
        "boolean-parameter-prefixes": "off",
        "component-name-unique": "off",
        "operation-4xx-problem-details-rfc7807": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      async2Rules: {
        "channels-kebab-case": "off",
        "no-channel-trailing-slash": "off"
      }
    };
    exports2.default = minimal;
  }
});

// ../../../node_modules/.pnpm/js-levenshtein@1.1.6/node_modules/js-levenshtein/index.js
var require_js_levenshtein = __commonJS({
  "../../../node_modules/.pnpm/js-levenshtein@1.1.6/node_modules/js-levenshtein/index.js"(exports2, module2) {
    "use strict";
    module2.exports = /* @__PURE__ */ function() {
      function _min(d0, d1, d2, bx, ay) {
        return d0 < d1 || d2 < d1 ? d0 > d2 ? d2 + 1 : d0 + 1 : bx === ay ? d1 : d1 + 1;
      }
      return function(a, b) {
        if (a === b) {
          return 0;
        }
        if (a.length > b.length) {
          var tmp = a;
          a = b;
          b = tmp;
        }
        var la = a.length;
        var lb = b.length;
        while (la > 0 && a.charCodeAt(la - 1) === b.charCodeAt(lb - 1)) {
          la--;
          lb--;
        }
        var offset = 0;
        while (offset < la && a.charCodeAt(offset) === b.charCodeAt(offset)) {
          offset++;
        }
        la -= offset;
        lb -= offset;
        if (la === 0 || lb < 3) {
          return lb;
        }
        var x = 0;
        var y;
        var d0;
        var d1;
        var d2;
        var d3;
        var dd;
        var dy;
        var ay;
        var bx0;
        var bx1;
        var bx2;
        var bx3;
        var vector = [];
        for (y = 0; y < la; y++) {
          vector.push(y + 1);
          vector.push(a.charCodeAt(offset + y));
        }
        var len = vector.length - 1;
        for (; x < lb - 3; ) {
          bx0 = b.charCodeAt(offset + (d0 = x));
          bx1 = b.charCodeAt(offset + (d1 = x + 1));
          bx2 = b.charCodeAt(offset + (d2 = x + 2));
          bx3 = b.charCodeAt(offset + (d3 = x + 3));
          dd = x += 4;
          for (y = 0; y < len; y += 2) {
            dy = vector[y];
            ay = vector[y + 1];
            d0 = _min(dy, d0, d1, bx0, ay);
            d1 = _min(d0, d1, d2, bx1, ay);
            d2 = _min(d1, d2, d3, bx2, ay);
            dd = _min(d2, d3, dd, bx3, ay);
            vector[y] = dd;
            d3 = d2;
            d2 = d1;
            d1 = d0;
            d0 = dy;
          }
        }
        for (; x < lb; ) {
          bx0 = b.charCodeAt(offset + (d0 = x));
          dd = ++x;
          for (y = 0; y < len; y += 2) {
            dy = vector[y];
            vector[y] = dd = _min(dy, d0, dd, bx0, vector[y + 1]);
            d0 = dy;
          }
        }
        return dd;
      };
    }();
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/codegen/code.js
var require_code = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/codegen/code.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.regexpCode = exports2.getEsmExportName = exports2.getProperty = exports2.safeStringify = exports2.stringify = exports2.strConcat = exports2.addCodeArg = exports2.str = exports2._ = exports2.nil = exports2._Code = exports2.Name = exports2.IDENTIFIER = exports2._CodeOrName = void 0;
    var _CodeOrName = class {
    };
    exports2._CodeOrName = _CodeOrName;
    exports2.IDENTIFIER = /^[a-z$_][a-z$_0-9]*$/i;
    var Name = class extends _CodeOrName {
      constructor(s) {
        super();
        if (!exports2.IDENTIFIER.test(s))
          throw new Error("CodeGen: name must be a valid identifier");
        this.str = s;
      }
      toString() {
        return this.str;
      }
      emptyStr() {
        return false;
      }
      get names() {
        return { [this.str]: 1 };
      }
    };
    exports2.Name = Name;
    var _Code = class extends _CodeOrName {
      constructor(code) {
        super();
        this._items = typeof code === "string" ? [code] : code;
      }
      toString() {
        return this.str;
      }
      emptyStr() {
        if (this._items.length > 1)
          return false;
        const item = this._items[0];
        return item === "" || item === '""';
      }
      get str() {
        var _a;
        return (_a = this._str) !== null && _a !== void 0 ? _a : this._str = this._items.reduce((s, c) => `${s}${c}`, "");
      }
      get names() {
        var _a;
        return (_a = this._names) !== null && _a !== void 0 ? _a : this._names = this._items.reduce((names, c) => {
          if (c instanceof Name)
            names[c.str] = (names[c.str] || 0) + 1;
          return names;
        }, {});
      }
    };
    exports2._Code = _Code;
    exports2.nil = new _Code("");
    function _(strs, ...args) {
      const code = [strs[0]];
      let i = 0;
      while (i < args.length) {
        addCodeArg(code, args[i]);
        code.push(strs[++i]);
      }
      return new _Code(code);
    }
    exports2._ = _;
    var plus = new _Code("+");
    function str2(strs, ...args) {
      const expr = [safeStringify(strs[0])];
      let i = 0;
      while (i < args.length) {
        expr.push(plus);
        addCodeArg(expr, args[i]);
        expr.push(plus, safeStringify(strs[++i]));
      }
      optimize(expr);
      return new _Code(expr);
    }
    exports2.str = str2;
    function addCodeArg(code, arg) {
      if (arg instanceof _Code)
        code.push(...arg._items);
      else if (arg instanceof Name)
        code.push(arg);
      else
        code.push(interpolate(arg));
    }
    exports2.addCodeArg = addCodeArg;
    function optimize(expr) {
      let i = 1;
      while (i < expr.length - 1) {
        if (expr[i] === plus) {
          const res = mergeExprItems(expr[i - 1], expr[i + 1]);
          if (res !== void 0) {
            expr.splice(i - 1, 3, res);
            continue;
          }
          expr[i++] = "+";
        }
        i++;
      }
    }
    function mergeExprItems(a, b) {
      if (b === '""')
        return a;
      if (a === '""')
        return b;
      if (typeof a == "string") {
        if (b instanceof Name || a[a.length - 1] !== '"')
          return;
        if (typeof b != "string")
          return `${a.slice(0, -1)}${b}"`;
        if (b[0] === '"')
          return a.slice(0, -1) + b.slice(1);
        return;
      }
      if (typeof b == "string" && b[0] === '"' && !(a instanceof Name))
        return `"${a}${b.slice(1)}`;
      return;
    }
    function strConcat(c1, c2) {
      return c2.emptyStr() ? c1 : c1.emptyStr() ? c2 : str2`${c1}${c2}`;
    }
    exports2.strConcat = strConcat;
    function interpolate(x) {
      return typeof x == "number" || typeof x == "boolean" || x === null ? x : safeStringify(Array.isArray(x) ? x.join(",") : x);
    }
    function stringify(x) {
      return new _Code(safeStringify(x));
    }
    exports2.stringify = stringify;
    function safeStringify(x) {
      return JSON.stringify(x).replace(/\u2028/g, "\\u2028").replace(/\u2029/g, "\\u2029");
    }
    exports2.safeStringify = safeStringify;
    function getProperty2(key) {
      return typeof key == "string" && exports2.IDENTIFIER.test(key) ? new _Code(`.${key}`) : _`[${key}]`;
    }
    exports2.getProperty = getProperty2;
    function getEsmExportName(key) {
      if (typeof key == "string" && exports2.IDENTIFIER.test(key)) {
        return new _Code(`${key}`);
      }
      throw new Error(`CodeGen: invalid export name: ${key}, use explicit $id name mapping`);
    }
    exports2.getEsmExportName = getEsmExportName;
    function regexpCode(rx) {
      return new _Code(rx.toString());
    }
    exports2.regexpCode = regexpCode;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/codegen/scope.js
var require_scope = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/codegen/scope.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ValueScope = exports2.ValueScopeName = exports2.Scope = exports2.varKinds = exports2.UsedValueState = void 0;
    var code_1 = require_code();
    var ValueError = class extends Error {
      constructor(name) {
        super(`CodeGen: "code" for ${name} not defined`);
        this.value = name.value;
      }
    };
    var UsedValueState;
    (function(UsedValueState2) {
      UsedValueState2[UsedValueState2["Started"] = 0] = "Started";
      UsedValueState2[UsedValueState2["Completed"] = 1] = "Completed";
    })(UsedValueState = exports2.UsedValueState || (exports2.UsedValueState = {}));
    exports2.varKinds = {
      const: new code_1.Name("const"),
      let: new code_1.Name("let"),
      var: new code_1.Name("var")
    };
    var Scope = class {
      constructor({ prefixes, parent } = {}) {
        this._names = {};
        this._prefixes = prefixes;
        this._parent = parent;
      }
      toName(nameOrPrefix) {
        return nameOrPrefix instanceof code_1.Name ? nameOrPrefix : this.name(nameOrPrefix);
      }
      name(prefix) {
        return new code_1.Name(this._newName(prefix));
      }
      _newName(prefix) {
        const ng = this._names[prefix] || this._nameGroup(prefix);
        return `${prefix}${ng.index++}`;
      }
      _nameGroup(prefix) {
        var _a, _b;
        if (((_b = (_a = this._parent) === null || _a === void 0 ? void 0 : _a._prefixes) === null || _b === void 0 ? void 0 : _b.has(prefix)) || this._prefixes && !this._prefixes.has(prefix)) {
          throw new Error(`CodeGen: prefix "${prefix}" is not allowed in this scope`);
        }
        return this._names[prefix] = { prefix, index: 0 };
      }
    };
    exports2.Scope = Scope;
    var ValueScopeName = class extends code_1.Name {
      constructor(prefix, nameStr) {
        super(nameStr);
        this.prefix = prefix;
      }
      setValue(value, { property: property4, itemIndex }) {
        this.value = value;
        this.scopePath = (0, code_1._)`.${new code_1.Name(property4)}[${itemIndex}]`;
      }
    };
    exports2.ValueScopeName = ValueScopeName;
    var line = (0, code_1._)`\n`;
    var ValueScope = class extends Scope {
      constructor(opts) {
        super(opts);
        this._values = {};
        this._scope = opts.scope;
        this.opts = { ...opts, _n: opts.lines ? line : code_1.nil };
      }
      get() {
        return this._scope;
      }
      name(prefix) {
        return new ValueScopeName(prefix, this._newName(prefix));
      }
      value(nameOrPrefix, value) {
        var _a;
        if (value.ref === void 0)
          throw new Error("CodeGen: ref must be passed in value");
        const name = this.toName(nameOrPrefix);
        const { prefix } = name;
        const valueKey = (_a = value.key) !== null && _a !== void 0 ? _a : value.ref;
        let vs = this._values[prefix];
        if (vs) {
          const _name = vs.get(valueKey);
          if (_name)
            return _name;
        } else {
          vs = this._values[prefix] = /* @__PURE__ */ new Map();
        }
        vs.set(valueKey, name);
        const s = this._scope[prefix] || (this._scope[prefix] = []);
        const itemIndex = s.length;
        s[itemIndex] = value.ref;
        name.setValue(value, { property: prefix, itemIndex });
        return name;
      }
      getValue(prefix, keyOrRef) {
        const vs = this._values[prefix];
        if (!vs)
          return;
        return vs.get(keyOrRef);
      }
      scopeRefs(scopeName, values = this._values) {
        return this._reduceValues(values, (name) => {
          if (name.scopePath === void 0)
            throw new Error(`CodeGen: name "${name}" has no value`);
          return (0, code_1._)`${scopeName}${name.scopePath}`;
        });
      }
      scopeCode(values = this._values, usedValues, getCode) {
        return this._reduceValues(values, (name) => {
          if (name.value === void 0)
            throw new Error(`CodeGen: name "${name}" has no value`);
          return name.value.code;
        }, usedValues, getCode);
      }
      _reduceValues(values, valueCode, usedValues = {}, getCode) {
        let code = code_1.nil;
        for (const prefix in values) {
          const vs = values[prefix];
          if (!vs)
            continue;
          const nameSet = usedValues[prefix] = usedValues[prefix] || /* @__PURE__ */ new Map();
          vs.forEach((name) => {
            if (nameSet.has(name))
              return;
            nameSet.set(name, UsedValueState.Started);
            let c = valueCode(name);
            if (c) {
              const def = this.opts.es5 ? exports2.varKinds.var : exports2.varKinds.const;
              code = (0, code_1._)`${code}${def} ${name} = ${c};${this.opts._n}`;
            } else if (c = getCode === null || getCode === void 0 ? void 0 : getCode(name)) {
              code = (0, code_1._)`${code}${c}${this.opts._n}`;
            } else {
              throw new ValueError(name);
            }
            nameSet.set(name, UsedValueState.Completed);
          });
        }
        return code;
      }
    };
    exports2.ValueScope = ValueScope;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/codegen/index.js
var require_codegen = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/codegen/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.or = exports2.and = exports2.not = exports2.CodeGen = exports2.operators = exports2.varKinds = exports2.ValueScopeName = exports2.ValueScope = exports2.Scope = exports2.Name = exports2.regexpCode = exports2.stringify = exports2.getProperty = exports2.nil = exports2.strConcat = exports2.str = exports2._ = void 0;
    var code_1 = require_code();
    var scope_1 = require_scope();
    var code_2 = require_code();
    Object.defineProperty(exports2, "_", { enumerable: true, get: function() {
      return code_2._;
    } });
    Object.defineProperty(exports2, "str", { enumerable: true, get: function() {
      return code_2.str;
    } });
    Object.defineProperty(exports2, "strConcat", { enumerable: true, get: function() {
      return code_2.strConcat;
    } });
    Object.defineProperty(exports2, "nil", { enumerable: true, get: function() {
      return code_2.nil;
    } });
    Object.defineProperty(exports2, "getProperty", { enumerable: true, get: function() {
      return code_2.getProperty;
    } });
    Object.defineProperty(exports2, "stringify", { enumerable: true, get: function() {
      return code_2.stringify;
    } });
    Object.defineProperty(exports2, "regexpCode", { enumerable: true, get: function() {
      return code_2.regexpCode;
    } });
    Object.defineProperty(exports2, "Name", { enumerable: true, get: function() {
      return code_2.Name;
    } });
    var scope_2 = require_scope();
    Object.defineProperty(exports2, "Scope", { enumerable: true, get: function() {
      return scope_2.Scope;
    } });
    Object.defineProperty(exports2, "ValueScope", { enumerable: true, get: function() {
      return scope_2.ValueScope;
    } });
    Object.defineProperty(exports2, "ValueScopeName", { enumerable: true, get: function() {
      return scope_2.ValueScopeName;
    } });
    Object.defineProperty(exports2, "varKinds", { enumerable: true, get: function() {
      return scope_2.varKinds;
    } });
    exports2.operators = {
      GT: new code_1._Code(">"),
      GTE: new code_1._Code(">="),
      LT: new code_1._Code("<"),
      LTE: new code_1._Code("<="),
      EQ: new code_1._Code("==="),
      NEQ: new code_1._Code("!=="),
      NOT: new code_1._Code("!"),
      OR: new code_1._Code("||"),
      AND: new code_1._Code("&&"),
      ADD: new code_1._Code("+")
    };
    var Node = class {
      optimizeNodes() {
        return this;
      }
      optimizeNames(_names, _constants) {
        return this;
      }
    };
    var Def = class extends Node {
      constructor(varKind, name, rhs) {
        super();
        this.varKind = varKind;
        this.name = name;
        this.rhs = rhs;
      }
      render({ es5, _n }) {
        const varKind = es5 ? scope_1.varKinds.var : this.varKind;
        const rhs = this.rhs === void 0 ? "" : ` = ${this.rhs}`;
        return `${varKind} ${this.name}${rhs};` + _n;
      }
      optimizeNames(names, constants) {
        if (!names[this.name.str])
          return;
        if (this.rhs)
          this.rhs = optimizeExpr(this.rhs, names, constants);
        return this;
      }
      get names() {
        return this.rhs instanceof code_1._CodeOrName ? this.rhs.names : {};
      }
    };
    var Assign = class extends Node {
      constructor(lhs, rhs, sideEffects) {
        super();
        this.lhs = lhs;
        this.rhs = rhs;
        this.sideEffects = sideEffects;
      }
      render({ _n }) {
        return `${this.lhs} = ${this.rhs};` + _n;
      }
      optimizeNames(names, constants) {
        if (this.lhs instanceof code_1.Name && !names[this.lhs.str] && !this.sideEffects)
          return;
        this.rhs = optimizeExpr(this.rhs, names, constants);
        return this;
      }
      get names() {
        const names = this.lhs instanceof code_1.Name ? {} : { ...this.lhs.names };
        return addExprNames(names, this.rhs);
      }
    };
    var AssignOp = class extends Assign {
      constructor(lhs, op, rhs, sideEffects) {
        super(lhs, rhs, sideEffects);
        this.op = op;
      }
      render({ _n }) {
        return `${this.lhs} ${this.op}= ${this.rhs};` + _n;
      }
    };
    var Label = class extends Node {
      constructor(label) {
        super();
        this.label = label;
        this.names = {};
      }
      render({ _n }) {
        return `${this.label}:` + _n;
      }
    };
    var Break = class extends Node {
      constructor(label) {
        super();
        this.label = label;
        this.names = {};
      }
      render({ _n }) {
        const label = this.label ? ` ${this.label}` : "";
        return `break${label};` + _n;
      }
    };
    var Throw = class extends Node {
      constructor(error) {
        super();
        this.error = error;
      }
      render({ _n }) {
        return `throw ${this.error};` + _n;
      }
      get names() {
        return this.error.names;
      }
    };
    var AnyCode = class extends Node {
      constructor(code) {
        super();
        this.code = code;
      }
      render({ _n }) {
        return `${this.code};` + _n;
      }
      optimizeNodes() {
        return `${this.code}` ? this : void 0;
      }
      optimizeNames(names, constants) {
        this.code = optimizeExpr(this.code, names, constants);
        return this;
      }
      get names() {
        return this.code instanceof code_1._CodeOrName ? this.code.names : {};
      }
    };
    var ParentNode = class extends Node {
      constructor(nodes = []) {
        super();
        this.nodes = nodes;
      }
      render(opts) {
        return this.nodes.reduce((code, n) => code + n.render(opts), "");
      }
      optimizeNodes() {
        const { nodes } = this;
        let i = nodes.length;
        while (i--) {
          const n = nodes[i].optimizeNodes();
          if (Array.isArray(n))
            nodes.splice(i, 1, ...n);
          else if (n)
            nodes[i] = n;
          else
            nodes.splice(i, 1);
        }
        return nodes.length > 0 ? this : void 0;
      }
      optimizeNames(names, constants) {
        const { nodes } = this;
        let i = nodes.length;
        while (i--) {
          const n = nodes[i];
          if (n.optimizeNames(names, constants))
            continue;
          subtractNames(names, n.names);
          nodes.splice(i, 1);
        }
        return nodes.length > 0 ? this : void 0;
      }
      get names() {
        return this.nodes.reduce((names, n) => addNames(names, n.names), {});
      }
    };
    var BlockNode = class extends ParentNode {
      render(opts) {
        return "{" + opts._n + super.render(opts) + "}" + opts._n;
      }
    };
    var Root = class extends ParentNode {
    };
    var Else = class extends BlockNode {
    };
    Else.kind = "else";
    var If = class _If extends BlockNode {
      constructor(condition, nodes) {
        super(nodes);
        this.condition = condition;
      }
      render(opts) {
        let code = `if(${this.condition})` + super.render(opts);
        if (this.else)
          code += "else " + this.else.render(opts);
        return code;
      }
      optimizeNodes() {
        super.optimizeNodes();
        const cond = this.condition;
        if (cond === true)
          return this.nodes;
        let e = this.else;
        if (e) {
          const ns = e.optimizeNodes();
          e = this.else = Array.isArray(ns) ? new Else(ns) : ns;
        }
        if (e) {
          if (cond === false)
            return e instanceof _If ? e : e.nodes;
          if (this.nodes.length)
            return this;
          return new _If(not(cond), e instanceof _If ? [e] : e.nodes);
        }
        if (cond === false || !this.nodes.length)
          return void 0;
        return this;
      }
      optimizeNames(names, constants) {
        var _a;
        this.else = (_a = this.else) === null || _a === void 0 ? void 0 : _a.optimizeNames(names, constants);
        if (!(super.optimizeNames(names, constants) || this.else))
          return;
        this.condition = optimizeExpr(this.condition, names, constants);
        return this;
      }
      get names() {
        const names = super.names;
        addExprNames(names, this.condition);
        if (this.else)
          addNames(names, this.else.names);
        return names;
      }
    };
    If.kind = "if";
    var For = class extends BlockNode {
    };
    For.kind = "for";
    var ForLoop = class extends For {
      constructor(iteration) {
        super();
        this.iteration = iteration;
      }
      render(opts) {
        return `for(${this.iteration})` + super.render(opts);
      }
      optimizeNames(names, constants) {
        if (!super.optimizeNames(names, constants))
          return;
        this.iteration = optimizeExpr(this.iteration, names, constants);
        return this;
      }
      get names() {
        return addNames(super.names, this.iteration.names);
      }
    };
    var ForRange = class extends For {
      constructor(varKind, name, from, to) {
        super();
        this.varKind = varKind;
        this.name = name;
        this.from = from;
        this.to = to;
      }
      render(opts) {
        const varKind = opts.es5 ? scope_1.varKinds.var : this.varKind;
        const { name, from, to } = this;
        return `for(${varKind} ${name}=${from}; ${name}<${to}; ${name}++)` + super.render(opts);
      }
      get names() {
        const names = addExprNames(super.names, this.from);
        return addExprNames(names, this.to);
      }
    };
    var ForIter = class extends For {
      constructor(loop, varKind, name, iterable) {
        super();
        this.loop = loop;
        this.varKind = varKind;
        this.name = name;
        this.iterable = iterable;
      }
      render(opts) {
        return `for(${this.varKind} ${this.name} ${this.loop} ${this.iterable})` + super.render(opts);
      }
      optimizeNames(names, constants) {
        if (!super.optimizeNames(names, constants))
          return;
        this.iterable = optimizeExpr(this.iterable, names, constants);
        return this;
      }
      get names() {
        return addNames(super.names, this.iterable.names);
      }
    };
    var Func = class extends BlockNode {
      constructor(name, args, async) {
        super();
        this.name = name;
        this.args = args;
        this.async = async;
      }
      render(opts) {
        const _async = this.async ? "async " : "";
        return `${_async}function ${this.name}(${this.args})` + super.render(opts);
      }
    };
    Func.kind = "func";
    var Return = class extends ParentNode {
      render(opts) {
        return "return " + super.render(opts);
      }
    };
    Return.kind = "return";
    var Try = class extends BlockNode {
      render(opts) {
        let code = "try" + super.render(opts);
        if (this.catch)
          code += this.catch.render(opts);
        if (this.finally)
          code += this.finally.render(opts);
        return code;
      }
      optimizeNodes() {
        var _a, _b;
        super.optimizeNodes();
        (_a = this.catch) === null || _a === void 0 ? void 0 : _a.optimizeNodes();
        (_b = this.finally) === null || _b === void 0 ? void 0 : _b.optimizeNodes();
        return this;
      }
      optimizeNames(names, constants) {
        var _a, _b;
        super.optimizeNames(names, constants);
        (_a = this.catch) === null || _a === void 0 ? void 0 : _a.optimizeNames(names, constants);
        (_b = this.finally) === null || _b === void 0 ? void 0 : _b.optimizeNames(names, constants);
        return this;
      }
      get names() {
        const names = super.names;
        if (this.catch)
          addNames(names, this.catch.names);
        if (this.finally)
          addNames(names, this.finally.names);
        return names;
      }
    };
    var Catch = class extends BlockNode {
      constructor(error) {
        super();
        this.error = error;
      }
      render(opts) {
        return `catch(${this.error})` + super.render(opts);
      }
    };
    Catch.kind = "catch";
    var Finally = class extends BlockNode {
      render(opts) {
        return "finally" + super.render(opts);
      }
    };
    Finally.kind = "finally";
    var CodeGen = class {
      constructor(extScope, opts = {}) {
        this._values = {};
        this._blockStarts = [];
        this._constants = {};
        this.opts = { ...opts, _n: opts.lines ? "\n" : "" };
        this._extScope = extScope;
        this._scope = new scope_1.Scope({ parent: extScope });
        this._nodes = [new Root()];
      }
      toString() {
        return this._root.render(this.opts);
      }
      // returns unique name in the internal scope
      name(prefix) {
        return this._scope.name(prefix);
      }
      // reserves unique name in the external scope
      scopeName(prefix) {
        return this._extScope.name(prefix);
      }
      // reserves unique name in the external scope and assigns value to it
      scopeValue(prefixOrName, value) {
        const name = this._extScope.value(prefixOrName, value);
        const vs = this._values[name.prefix] || (this._values[name.prefix] = /* @__PURE__ */ new Set());
        vs.add(name);
        return name;
      }
      getScopeValue(prefix, keyOrRef) {
        return this._extScope.getValue(prefix, keyOrRef);
      }
      // return code that assigns values in the external scope to the names that are used internally
      // (same names that were returned by gen.scopeName or gen.scopeValue)
      scopeRefs(scopeName) {
        return this._extScope.scopeRefs(scopeName, this._values);
      }
      scopeCode() {
        return this._extScope.scopeCode(this._values);
      }
      _def(varKind, nameOrPrefix, rhs, constant2) {
        const name = this._scope.toName(nameOrPrefix);
        if (rhs !== void 0 && constant2)
          this._constants[name.str] = rhs;
        this._leafNode(new Def(varKind, name, rhs));
        return name;
      }
      // `const` declaration (`var` in es5 mode)
      const(nameOrPrefix, rhs, _constant) {
        return this._def(scope_1.varKinds.const, nameOrPrefix, rhs, _constant);
      }
      // `let` declaration with optional assignment (`var` in es5 mode)
      let(nameOrPrefix, rhs, _constant) {
        return this._def(scope_1.varKinds.let, nameOrPrefix, rhs, _constant);
      }
      // `var` declaration with optional assignment
      var(nameOrPrefix, rhs, _constant) {
        return this._def(scope_1.varKinds.var, nameOrPrefix, rhs, _constant);
      }
      // assignment code
      assign(lhs, rhs, sideEffects) {
        return this._leafNode(new Assign(lhs, rhs, sideEffects));
      }
      // `+=` code
      add(lhs, rhs) {
        return this._leafNode(new AssignOp(lhs, exports2.operators.ADD, rhs));
      }
      // appends passed SafeExpr to code or executes Block
      code(c) {
        if (typeof c == "function")
          c();
        else if (c !== code_1.nil)
          this._leafNode(new AnyCode(c));
        return this;
      }
      // returns code for object literal for the passed argument list of key-value pairs
      object(...keyValues) {
        const code = ["{"];
        for (const [key, value] of keyValues) {
          if (code.length > 1)
            code.push(",");
          code.push(key);
          if (key !== value || this.opts.es5) {
            code.push(":");
            (0, code_1.addCodeArg)(code, value);
          }
        }
        code.push("}");
        return new code_1._Code(code);
      }
      // `if` clause (or statement if `thenBody` and, optionally, `elseBody` are passed)
      if(condition, thenBody, elseBody) {
        this._blockNode(new If(condition));
        if (thenBody && elseBody) {
          this.code(thenBody).else().code(elseBody).endIf();
        } else if (thenBody) {
          this.code(thenBody).endIf();
        } else if (elseBody) {
          throw new Error('CodeGen: "else" body without "then" body');
        }
        return this;
      }
      // `else if` clause - invalid without `if` or after `else` clauses
      elseIf(condition) {
        return this._elseNode(new If(condition));
      }
      // `else` clause - only valid after `if` or `else if` clauses
      else() {
        return this._elseNode(new Else());
      }
      // end `if` statement (needed if gen.if was used only with condition)
      endIf() {
        return this._endBlockNode(If, Else);
      }
      _for(node, forBody) {
        this._blockNode(node);
        if (forBody)
          this.code(forBody).endFor();
        return this;
      }
      // a generic `for` clause (or statement if `forBody` is passed)
      for(iteration, forBody) {
        return this._for(new ForLoop(iteration), forBody);
      }
      // `for` statement for a range of values
      forRange(nameOrPrefix, from, to, forBody, varKind = this.opts.es5 ? scope_1.varKinds.var : scope_1.varKinds.let) {
        const name = this._scope.toName(nameOrPrefix);
        return this._for(new ForRange(varKind, name, from, to), () => forBody(name));
      }
      // `for-of` statement (in es5 mode replace with a normal for loop)
      forOf(nameOrPrefix, iterable, forBody, varKind = scope_1.varKinds.const) {
        const name = this._scope.toName(nameOrPrefix);
        if (this.opts.es5) {
          const arr = iterable instanceof code_1.Name ? iterable : this.var("_arr", iterable);
          return this.forRange("_i", 0, (0, code_1._)`${arr}.length`, (i) => {
            this.var(name, (0, code_1._)`${arr}[${i}]`);
            forBody(name);
          });
        }
        return this._for(new ForIter("of", varKind, name, iterable), () => forBody(name));
      }
      // `for-in` statement.
      // With option `ownProperties` replaced with a `for-of` loop for object keys
      forIn(nameOrPrefix, obj, forBody, varKind = this.opts.es5 ? scope_1.varKinds.var : scope_1.varKinds.const) {
        if (this.opts.ownProperties) {
          return this.forOf(nameOrPrefix, (0, code_1._)`Object.keys(${obj})`, forBody);
        }
        const name = this._scope.toName(nameOrPrefix);
        return this._for(new ForIter("in", varKind, name, obj), () => forBody(name));
      }
      // end `for` loop
      endFor() {
        return this._endBlockNode(For);
      }
      // `label` statement
      label(label) {
        return this._leafNode(new Label(label));
      }
      // `break` statement
      break(label) {
        return this._leafNode(new Break(label));
      }
      // `return` statement
      return(value) {
        const node = new Return();
        this._blockNode(node);
        this.code(value);
        if (node.nodes.length !== 1)
          throw new Error('CodeGen: "return" should have one node');
        return this._endBlockNode(Return);
      }
      // `try` statement
      try(tryBody, catchCode, finallyCode) {
        if (!catchCode && !finallyCode)
          throw new Error('CodeGen: "try" without "catch" and "finally"');
        const node = new Try();
        this._blockNode(node);
        this.code(tryBody);
        if (catchCode) {
          const error = this.name("e");
          this._currNode = node.catch = new Catch(error);
          catchCode(error);
        }
        if (finallyCode) {
          this._currNode = node.finally = new Finally();
          this.code(finallyCode);
        }
        return this._endBlockNode(Catch, Finally);
      }
      // `throw` statement
      throw(error) {
        return this._leafNode(new Throw(error));
      }
      // start self-balancing block
      block(body, nodeCount) {
        this._blockStarts.push(this._nodes.length);
        if (body)
          this.code(body).endBlock(nodeCount);
        return this;
      }
      // end the current self-balancing block
      endBlock(nodeCount) {
        const len = this._blockStarts.pop();
        if (len === void 0)
          throw new Error("CodeGen: not in self-balancing block");
        const toClose = this._nodes.length - len;
        if (toClose < 0 || nodeCount !== void 0 && toClose !== nodeCount) {
          throw new Error(`CodeGen: wrong number of nodes: ${toClose} vs ${nodeCount} expected`);
        }
        this._nodes.length = len;
        return this;
      }
      // `function` heading (or definition if funcBody is passed)
      func(name, args = code_1.nil, async, funcBody) {
        this._blockNode(new Func(name, args, async));
        if (funcBody)
          this.code(funcBody).endFunc();
        return this;
      }
      // end function definition
      endFunc() {
        return this._endBlockNode(Func);
      }
      optimize(n = 1) {
        while (n-- > 0) {
          this._root.optimizeNodes();
          this._root.optimizeNames(this._root.names, this._constants);
        }
      }
      _leafNode(node) {
        this._currNode.nodes.push(node);
        return this;
      }
      _blockNode(node) {
        this._currNode.nodes.push(node);
        this._nodes.push(node);
      }
      _endBlockNode(N1, N2) {
        const n = this._currNode;
        if (n instanceof N1 || N2 && n instanceof N2) {
          this._nodes.pop();
          return this;
        }
        throw new Error(`CodeGen: not in block "${N2 ? `${N1.kind}/${N2.kind}` : N1.kind}"`);
      }
      _elseNode(node) {
        const n = this._currNode;
        if (!(n instanceof If)) {
          throw new Error('CodeGen: "else" without "if"');
        }
        this._currNode = n.else = node;
        return this;
      }
      get _root() {
        return this._nodes[0];
      }
      get _currNode() {
        const ns = this._nodes;
        return ns[ns.length - 1];
      }
      set _currNode(node) {
        const ns = this._nodes;
        ns[ns.length - 1] = node;
      }
    };
    exports2.CodeGen = CodeGen;
    function addNames(names, from) {
      for (const n in from)
        names[n] = (names[n] || 0) + (from[n] || 0);
      return names;
    }
    function addExprNames(names, from) {
      return from instanceof code_1._CodeOrName ? addNames(names, from.names) : names;
    }
    function optimizeExpr(expr, names, constants) {
      if (expr instanceof code_1.Name)
        return replaceName(expr);
      if (!canOptimize(expr))
        return expr;
      return new code_1._Code(expr._items.reduce((items, c) => {
        if (c instanceof code_1.Name)
          c = replaceName(c);
        if (c instanceof code_1._Code)
          items.push(...c._items);
        else
          items.push(c);
        return items;
      }, []));
      function replaceName(n) {
        const c = constants[n.str];
        if (c === void 0 || names[n.str] !== 1)
          return n;
        delete names[n.str];
        return c;
      }
      function canOptimize(e) {
        return e instanceof code_1._Code && e._items.some((c) => c instanceof code_1.Name && names[c.str] === 1 && constants[c.str] !== void 0);
      }
    }
    function subtractNames(names, from) {
      for (const n in from)
        names[n] = (names[n] || 0) - (from[n] || 0);
    }
    function not(x) {
      return typeof x == "boolean" || typeof x == "number" || x === null ? !x : (0, code_1._)`!${par(x)}`;
    }
    exports2.not = not;
    var andCode = mappend(exports2.operators.AND);
    function and(...args) {
      return args.reduce(andCode);
    }
    exports2.and = and;
    var orCode = mappend(exports2.operators.OR);
    function or(...args) {
      return args.reduce(orCode);
    }
    exports2.or = or;
    function mappend(op) {
      return (x, y) => x === code_1.nil ? y : y === code_1.nil ? x : (0, code_1._)`${par(x)} ${op} ${par(y)}`;
    }
    function par(x) {
      return x instanceof code_1.Name ? x : (0, code_1._)`(${x})`;
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/util.js
var require_util = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.checkStrictMode = exports2.getErrorPath = exports2.Type = exports2.useFunc = exports2.setEvaluated = exports2.evaluatedPropsToName = exports2.mergeEvaluated = exports2.eachItem = exports2.unescapeJsonPointer = exports2.escapeJsonPointer = exports2.escapeFragment = exports2.unescapeFragment = exports2.schemaRefOrVal = exports2.schemaHasRulesButRef = exports2.schemaHasRules = exports2.checkUnknownRules = exports2.alwaysValidSchema = exports2.toHash = void 0;
    var codegen_1 = require_codegen();
    var code_1 = require_code();
    function toHash(arr) {
      const hash2 = {};
      for (const item of arr)
        hash2[item] = true;
      return hash2;
    }
    exports2.toHash = toHash;
    function alwaysValidSchema(it, schema2) {
      if (typeof schema2 == "boolean")
        return schema2;
      if (Object.keys(schema2).length === 0)
        return true;
      checkUnknownRules(it, schema2);
      return !schemaHasRules(schema2, it.self.RULES.all);
    }
    exports2.alwaysValidSchema = alwaysValidSchema;
    function checkUnknownRules(it, schema2 = it.schema) {
      const { opts, self: self2 } = it;
      if (!opts.strictSchema)
        return;
      if (typeof schema2 === "boolean")
        return;
      const rules = self2.RULES.keywords;
      for (const key in schema2) {
        if (!rules[key])
          checkStrictMode(it, `unknown keyword: "${key}"`);
      }
    }
    exports2.checkUnknownRules = checkUnknownRules;
    function schemaHasRules(schema2, rules) {
      if (typeof schema2 == "boolean")
        return !schema2;
      for (const key in schema2)
        if (rules[key])
          return true;
      return false;
    }
    exports2.schemaHasRules = schemaHasRules;
    function schemaHasRulesButRef(schema2, RULES) {
      if (typeof schema2 == "boolean")
        return !schema2;
      for (const key in schema2)
        if (key !== "$ref" && RULES.all[key])
          return true;
      return false;
    }
    exports2.schemaHasRulesButRef = schemaHasRulesButRef;
    function schemaRefOrVal({ topSchemaRef, schemaPath }, schema2, keyword, $data) {
      if (!$data) {
        if (typeof schema2 == "number" || typeof schema2 == "boolean")
          return schema2;
        if (typeof schema2 == "string")
          return (0, codegen_1._)`${schema2}`;
      }
      return (0, codegen_1._)`${topSchemaRef}${schemaPath}${(0, codegen_1.getProperty)(keyword)}`;
    }
    exports2.schemaRefOrVal = schemaRefOrVal;
    function unescapeFragment(str2) {
      return unescapeJsonPointer(decodeURIComponent(str2));
    }
    exports2.unescapeFragment = unescapeFragment;
    function escapeFragment(str2) {
      return encodeURIComponent(escapeJsonPointer(str2));
    }
    exports2.escapeFragment = escapeFragment;
    function escapeJsonPointer(str2) {
      if (typeof str2 == "number")
        return `${str2}`;
      return str2.replace(/~/g, "~0").replace(/\//g, "~1");
    }
    exports2.escapeJsonPointer = escapeJsonPointer;
    function unescapeJsonPointer(str2) {
      return str2.replace(/~1/g, "/").replace(/~0/g, "~");
    }
    exports2.unescapeJsonPointer = unescapeJsonPointer;
    function eachItem(xs, f) {
      if (Array.isArray(xs)) {
        for (const x of xs)
          f(x);
      } else {
        f(xs);
      }
    }
    exports2.eachItem = eachItem;
    function makeMergeEvaluated({ mergeNames, mergeToName, mergeValues: mergeValues2, resultToName }) {
      return (gen, from, to, toName) => {
        const res = to === void 0 ? from : to instanceof codegen_1.Name ? (from instanceof codegen_1.Name ? mergeNames(gen, from, to) : mergeToName(gen, from, to), to) : from instanceof codegen_1.Name ? (mergeToName(gen, to, from), from) : mergeValues2(from, to);
        return toName === codegen_1.Name && !(res instanceof codegen_1.Name) ? resultToName(gen, res) : res;
      };
    }
    exports2.mergeEvaluated = {
      props: makeMergeEvaluated({
        mergeNames: (gen, from, to) => gen.if((0, codegen_1._)`${to} !== true && ${from} !== undefined`, () => {
          gen.if((0, codegen_1._)`${from} === true`, () => gen.assign(to, true), () => gen.assign(to, (0, codegen_1._)`${to} || {}`).code((0, codegen_1._)`Object.assign(${to}, ${from})`));
        }),
        mergeToName: (gen, from, to) => gen.if((0, codegen_1._)`${to} !== true`, () => {
          if (from === true) {
            gen.assign(to, true);
          } else {
            gen.assign(to, (0, codegen_1._)`${to} || {}`);
            setEvaluated(gen, to, from);
          }
        }),
        mergeValues: (from, to) => from === true ? true : { ...from, ...to },
        resultToName: evaluatedPropsToName
      }),
      items: makeMergeEvaluated({
        mergeNames: (gen, from, to) => gen.if((0, codegen_1._)`${to} !== true && ${from} !== undefined`, () => gen.assign(to, (0, codegen_1._)`${from} === true ? true : ${to} > ${from} ? ${to} : ${from}`)),
        mergeToName: (gen, from, to) => gen.if((0, codegen_1._)`${to} !== true`, () => gen.assign(to, from === true ? true : (0, codegen_1._)`${to} > ${from} ? ${to} : ${from}`)),
        mergeValues: (from, to) => from === true ? true : Math.max(from, to),
        resultToName: (gen, items) => gen.var("items", items)
      })
    };
    function evaluatedPropsToName(gen, ps) {
      if (ps === true)
        return gen.var("props", true);
      const props = gen.var("props", (0, codegen_1._)`{}`);
      if (ps !== void 0)
        setEvaluated(gen, props, ps);
      return props;
    }
    exports2.evaluatedPropsToName = evaluatedPropsToName;
    function setEvaluated(gen, props, ps) {
      Object.keys(ps).forEach((p) => gen.assign((0, codegen_1._)`${props}${(0, codegen_1.getProperty)(p)}`, true));
    }
    exports2.setEvaluated = setEvaluated;
    var snippets = {};
    function useFunc(gen, f) {
      return gen.scopeValue("func", {
        ref: f,
        code: snippets[f.code] || (snippets[f.code] = new code_1._Code(f.code))
      });
    }
    exports2.useFunc = useFunc;
    var Type3;
    (function(Type4) {
      Type4[Type4["Num"] = 0] = "Num";
      Type4[Type4["Str"] = 1] = "Str";
    })(Type3 = exports2.Type || (exports2.Type = {}));
    function getErrorPath(dataProp, dataPropType, jsPropertySyntax) {
      if (dataProp instanceof codegen_1.Name) {
        const isNumber = dataPropType === Type3.Num;
        return jsPropertySyntax ? isNumber ? (0, codegen_1._)`"[" + ${dataProp} + "]"` : (0, codegen_1._)`"['" + ${dataProp} + "']"` : isNumber ? (0, codegen_1._)`"/" + ${dataProp}` : (0, codegen_1._)`"/" + ${dataProp}.replace(/~/g, "~0").replace(/\\//g, "~1")`;
      }
      return jsPropertySyntax ? (0, codegen_1.getProperty)(dataProp).toString() : "/" + escapeJsonPointer(dataProp);
    }
    exports2.getErrorPath = getErrorPath;
    function checkStrictMode(it, msg, mode = it.opts.strictSchema) {
      if (!mode)
        return;
      msg = `strict mode: ${msg}`;
      if (mode === true)
        throw new Error(msg);
      it.self.logger.warn(msg);
    }
    exports2.checkStrictMode = checkStrictMode;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/names.js
var require_names = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/names.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var names = {
      // validation function arguments
      data: new codegen_1.Name("data"),
      // args passed from referencing schema
      valCxt: new codegen_1.Name("valCxt"),
      instancePath: new codegen_1.Name("instancePath"),
      parentData: new codegen_1.Name("parentData"),
      parentDataProperty: new codegen_1.Name("parentDataProperty"),
      rootData: new codegen_1.Name("rootData"),
      dynamicAnchors: new codegen_1.Name("dynamicAnchors"),
      isAllOfVariant: new codegen_1.Name("isAllOfVariant"),
      // function scoped variables
      vErrors: new codegen_1.Name("vErrors"),
      errors: new codegen_1.Name("errors"),
      this: new codegen_1.Name("this"),
      // "globals"
      self: new codegen_1.Name("self"),
      scope: new codegen_1.Name("scope"),
      // JTD serialize/parse name for JSON string and position
      json: new codegen_1.Name("json"),
      jsonPos: new codegen_1.Name("jsonPos"),
      jsonLen: new codegen_1.Name("jsonLen"),
      jsonPart: new codegen_1.Name("jsonPart")
    };
    exports2.default = names;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/errors.js
var require_errors2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/errors.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.extendErrors = exports2.resetErrorsCount = exports2.reportExtraError = exports2.reportError = exports2.keyword$DataError = exports2.keywordError = void 0;
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var names_1 = require_names();
    exports2.keywordError = {
      message: ({ keyword }) => (0, codegen_1.str)`must pass "${keyword}" keyword validation`
    };
    exports2.keyword$DataError = {
      message: ({ keyword, schemaType }) => schemaType ? (0, codegen_1.str)`"${keyword}" keyword must be ${schemaType} ($data)` : (0, codegen_1.str)`"${keyword}" keyword is invalid ($data)`
    };
    function reportError(cxt, error = exports2.keywordError, errorPaths, overrideAllErrors) {
      const { it } = cxt;
      const { gen, compositeRule, allErrors } = it;
      const errObj = errorObjectCode(cxt, error, errorPaths);
      if (overrideAllErrors !== null && overrideAllErrors !== void 0 ? overrideAllErrors : compositeRule || allErrors) {
        addError(gen, errObj);
      } else {
        returnErrors(it, (0, codegen_1._)`[${errObj}]`);
      }
    }
    exports2.reportError = reportError;
    function reportExtraError(cxt, error = exports2.keywordError, errorPaths) {
      const { it } = cxt;
      const { gen, compositeRule, allErrors } = it;
      const errObj = errorObjectCode(cxt, error, errorPaths);
      addError(gen, errObj);
      if (!(compositeRule || allErrors)) {
        returnErrors(it, names_1.default.vErrors);
      }
    }
    exports2.reportExtraError = reportExtraError;
    function resetErrorsCount(gen, errsCount) {
      gen.assign(names_1.default.errors, errsCount);
      gen.if((0, codegen_1._)`${names_1.default.vErrors} !== null`, () => gen.if(errsCount, () => gen.assign((0, codegen_1._)`${names_1.default.vErrors}.length`, errsCount), () => gen.assign(names_1.default.vErrors, null)));
    }
    exports2.resetErrorsCount = resetErrorsCount;
    function extendErrors({ gen, keyword, schemaValue, data, errsCount, it }) {
      if (errsCount === void 0)
        throw new Error("ajv implementation error");
      const err = gen.name("err");
      gen.forRange("i", errsCount, names_1.default.errors, (i) => {
        gen.const(err, (0, codegen_1._)`${names_1.default.vErrors}[${i}]`);
        gen.if((0, codegen_1._)`${err}.instancePath === undefined`, () => gen.assign((0, codegen_1._)`${err}.instancePath`, (0, codegen_1.strConcat)(names_1.default.instancePath, it.errorPath)));
        gen.assign((0, codegen_1._)`${err}.schemaPath`, (0, codegen_1.str)`${it.errSchemaPath}/${keyword}`);
        if (it.opts.verbose) {
          gen.assign((0, codegen_1._)`${err}.schema`, schemaValue);
          gen.assign((0, codegen_1._)`${err}.data`, data);
        }
      });
    }
    exports2.extendErrors = extendErrors;
    function addError(gen, errObj) {
      const err = gen.const("err", errObj);
      gen.if((0, codegen_1._)`${names_1.default.vErrors} === null`, () => gen.assign(names_1.default.vErrors, (0, codegen_1._)`[${err}]`), (0, codegen_1._)`${names_1.default.vErrors}.push(${err})`);
      gen.code((0, codegen_1._)`${names_1.default.errors}++`);
    }
    function returnErrors(it, errs) {
      const { gen, validateName: validateName3, schemaEnv } = it;
      if (schemaEnv.$async) {
        gen.throw((0, codegen_1._)`new ${it.ValidationError}(${errs})`);
      } else {
        gen.assign((0, codegen_1._)`${validateName3}.errors`, errs);
        gen.return(false);
      }
    }
    var E = {
      keyword: new codegen_1.Name("keyword"),
      schemaPath: new codegen_1.Name("schemaPath"),
      params: new codegen_1.Name("params"),
      propertyName: new codegen_1.Name("propertyName"),
      message: new codegen_1.Name("message"),
      schema: new codegen_1.Name("schema"),
      parentSchema: new codegen_1.Name("parentSchema")
    };
    function errorObjectCode(cxt, error, errorPaths) {
      const { createErrors } = cxt.it;
      if (createErrors === false)
        return (0, codegen_1._)`{}`;
      return errorObject(cxt, error, errorPaths);
    }
    function errorObject(cxt, error, errorPaths = {}) {
      const { gen, it } = cxt;
      const keyValues = [
        errorInstancePath(it, errorPaths),
        errorSchemaPath(cxt, errorPaths)
      ];
      extraErrorProps(cxt, error, keyValues);
      return gen.object(...keyValues);
    }
    function errorInstancePath({ errorPath }, { instancePath }) {
      const instPath = instancePath ? (0, codegen_1.str)`${errorPath}${(0, util_1.getErrorPath)(instancePath, util_1.Type.Str)}` : errorPath;
      return [names_1.default.instancePath, (0, codegen_1.strConcat)(names_1.default.instancePath, instPath)];
    }
    function errorSchemaPath({ keyword, it: { errSchemaPath } }, { schemaPath, parentSchema }) {
      let schPath = parentSchema ? errSchemaPath : (0, codegen_1.str)`${errSchemaPath}/${keyword}`;
      if (schemaPath) {
        schPath = (0, codegen_1.str)`${schPath}${(0, util_1.getErrorPath)(schemaPath, util_1.Type.Str)}`;
      }
      return [E.schemaPath, schPath];
    }
    function extraErrorProps(cxt, { params, message }, keyValues) {
      const { keyword, data, schemaValue, it } = cxt;
      const { opts, propertyName, topSchemaRef, schemaPath } = it;
      keyValues.push([E.keyword, keyword], [E.params, typeof params == "function" ? params(cxt) : params || (0, codegen_1._)`{}`]);
      if (opts.messages) {
        keyValues.push([E.message, typeof message == "function" ? message(cxt) : message]);
      }
      if (opts.verbose) {
        keyValues.push([E.schema, schemaValue], [E.parentSchema, (0, codegen_1._)`${topSchemaRef}${schemaPath}`], [names_1.default.data, data]);
      }
      if (propertyName)
        keyValues.push([E.propertyName, propertyName]);
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/boolSchema.js
var require_boolSchema = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/boolSchema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.boolOrEmptySchema = exports2.topBoolOrEmptySchema = void 0;
    var errors_1 = require_errors2();
    var codegen_1 = require_codegen();
    var names_1 = require_names();
    var boolError = {
      message: "boolean schema is false"
    };
    function topBoolOrEmptySchema(it) {
      const { gen, schema: schema2, validateName: validateName3 } = it;
      if (schema2 === false) {
        falseSchemaError(it, false);
      } else if (typeof schema2 == "object" && schema2.$async === true) {
        gen.return(names_1.default.data);
      } else {
        gen.assign((0, codegen_1._)`${validateName3}.errors`, null);
        gen.return(true);
      }
    }
    exports2.topBoolOrEmptySchema = topBoolOrEmptySchema;
    function boolOrEmptySchema(it, valid) {
      const { gen, schema: schema2 } = it;
      if (schema2 === false) {
        gen.var(valid, false);
        falseSchemaError(it);
      } else {
        gen.var(valid, true);
      }
    }
    exports2.boolOrEmptySchema = boolOrEmptySchema;
    function falseSchemaError(it, overrideAllErrors) {
      const { gen, data } = it;
      const cxt = {
        gen,
        keyword: "false schema",
        data,
        schema: false,
        schemaCode: false,
        schemaValue: false,
        params: {},
        it
      };
      (0, errors_1.reportError)(cxt, boolError, void 0, overrideAllErrors);
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/rules.js
var require_rules2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/rules.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getRules = exports2.isJSONType = void 0;
    var _jsonTypes = ["string", "number", "integer", "boolean", "null", "object", "array"];
    var jsonTypes = new Set(_jsonTypes);
    function isJSONType(x) {
      return typeof x == "string" && jsonTypes.has(x);
    }
    exports2.isJSONType = isJSONType;
    function getRules() {
      const groups = {
        number: { type: "number", rules: [] },
        string: { type: "string", rules: [] },
        array: { type: "array", rules: [] },
        object: { type: "object", rules: [] }
      };
      return {
        types: { ...groups, integer: true, boolean: true, null: true },
        rules: [{ rules: [] }, groups.number, groups.string, groups.array, groups.object],
        post: { rules: [] },
        all: {},
        keywords: {}
      };
    }
    exports2.getRules = getRules;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/applicability.js
var require_applicability = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/applicability.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.shouldUseRule = exports2.shouldUseGroup = exports2.schemaHasRulesForType = void 0;
    function schemaHasRulesForType({ schema: schema2, self: self2 }, type2) {
      const group = self2.RULES.types[type2];
      return group && group !== true && shouldUseGroup(schema2, group);
    }
    exports2.schemaHasRulesForType = schemaHasRulesForType;
    function shouldUseGroup(schema2, group) {
      return group.rules.some((rule) => shouldUseRule(schema2, rule));
    }
    exports2.shouldUseGroup = shouldUseGroup;
    function shouldUseRule(schema2, rule) {
      var _a;
      return schema2[rule.keyword] !== void 0 || ((_a = rule.definition.implements) === null || _a === void 0 ? void 0 : _a.some((kwd) => schema2[kwd] !== void 0));
    }
    exports2.shouldUseRule = shouldUseRule;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/dataType.js
var require_dataType = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/dataType.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.reportTypeError = exports2.checkDataTypes = exports2.checkDataType = exports2.coerceAndCheckDataType = exports2.getJSONTypes = exports2.getSchemaTypes = exports2.DataType = void 0;
    var rules_1 = require_rules2();
    var applicability_1 = require_applicability();
    var errors_1 = require_errors2();
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var DataType;
    (function(DataType2) {
      DataType2[DataType2["Correct"] = 0] = "Correct";
      DataType2[DataType2["Wrong"] = 1] = "Wrong";
    })(DataType = exports2.DataType || (exports2.DataType = {}));
    function getSchemaTypes(schema2) {
      const types2 = getJSONTypes(schema2.type);
      const hasNull = types2.includes("null");
      if (hasNull) {
        if (schema2.nullable === false)
          throw new Error("type: null contradicts nullable: false");
      } else {
        if (!types2.length && schema2.nullable !== void 0) {
          throw new Error('"nullable" cannot be used without "type"');
        }
        if (schema2.nullable === true)
          types2.push("null");
      }
      return types2;
    }
    exports2.getSchemaTypes = getSchemaTypes;
    function getJSONTypes(ts) {
      const types2 = Array.isArray(ts) ? ts : ts ? [ts] : [];
      if (types2.every(rules_1.isJSONType))
        return types2;
      throw new Error("type must be JSONType or JSONType[]: " + types2.join(","));
    }
    exports2.getJSONTypes = getJSONTypes;
    function coerceAndCheckDataType(it, types2) {
      const { gen, data, opts } = it;
      const coerceTo = coerceToTypes(types2, opts.coerceTypes);
      const checkTypes = types2.length > 0 && !(coerceTo.length === 0 && types2.length === 1 && (0, applicability_1.schemaHasRulesForType)(it, types2[0]));
      if (checkTypes) {
        const wrongType = checkDataTypes(types2, data, opts.strictNumbers, DataType.Wrong);
        gen.if(wrongType, () => {
          if (coerceTo.length)
            coerceData(it, types2, coerceTo);
          else
            reportTypeError(it);
        });
      }
      return checkTypes;
    }
    exports2.coerceAndCheckDataType = coerceAndCheckDataType;
    var COERCIBLE = /* @__PURE__ */ new Set(["string", "number", "integer", "boolean", "null"]);
    function coerceToTypes(types2, coerceTypes) {
      return coerceTypes ? types2.filter((t) => COERCIBLE.has(t) || coerceTypes === "array" && t === "array") : [];
    }
    function coerceData(it, types2, coerceTo) {
      const { gen, data, opts } = it;
      const dataType = gen.let("dataType", (0, codegen_1._)`typeof ${data}`);
      const coerced = gen.let("coerced", (0, codegen_1._)`undefined`);
      if (opts.coerceTypes === "array") {
        gen.if((0, codegen_1._)`${dataType} == 'object' && Array.isArray(${data}) && ${data}.length == 1`, () => gen.assign(data, (0, codegen_1._)`${data}[0]`).assign(dataType, (0, codegen_1._)`typeof ${data}`).if(checkDataTypes(types2, data, opts.strictNumbers), () => gen.assign(coerced, data)));
      }
      gen.if((0, codegen_1._)`${coerced} !== undefined`);
      for (const t of coerceTo) {
        if (COERCIBLE.has(t) || t === "array" && opts.coerceTypes === "array") {
          coerceSpecificType(t);
        }
      }
      gen.else();
      reportTypeError(it);
      gen.endIf();
      gen.if((0, codegen_1._)`${coerced} !== undefined`, () => {
        gen.assign(data, coerced);
        assignParentData(it, coerced);
      });
      function coerceSpecificType(t) {
        switch (t) {
          case "string":
            gen.elseIf((0, codegen_1._)`${dataType} == "number" || ${dataType} == "boolean"`).assign(coerced, (0, codegen_1._)`"" + ${data}`).elseIf((0, codegen_1._)`${data} === null`).assign(coerced, (0, codegen_1._)`""`);
            return;
          case "number":
            gen.elseIf((0, codegen_1._)`${dataType} == "boolean" || ${data} === null
              || (${dataType} == "string" && ${data} && ${data} == +${data})`).assign(coerced, (0, codegen_1._)`+${data}`);
            return;
          case "integer":
            gen.elseIf((0, codegen_1._)`${dataType} === "boolean" || ${data} === null
              || (${dataType} === "string" && ${data} && ${data} == +${data} && !(${data} % 1))`).assign(coerced, (0, codegen_1._)`+${data}`);
            return;
          case "boolean":
            gen.elseIf((0, codegen_1._)`${data} === "false" || ${data} === 0 || ${data} === null`).assign(coerced, false).elseIf((0, codegen_1._)`${data} === "true" || ${data} === 1`).assign(coerced, true);
            return;
          case "null":
            gen.elseIf((0, codegen_1._)`${data} === "" || ${data} === 0 || ${data} === false`);
            gen.assign(coerced, null);
            return;
          case "array":
            gen.elseIf((0, codegen_1._)`${dataType} === "string" || ${dataType} === "number"
              || ${dataType} === "boolean" || ${data} === null`).assign(coerced, (0, codegen_1._)`[${data}]`);
        }
      }
    }
    function assignParentData({ gen, parentData, parentDataProperty }, expr) {
      gen.if((0, codegen_1._)`${parentData} !== undefined`, () => gen.assign((0, codegen_1._)`${parentData}[${parentDataProperty}]`, expr));
    }
    function checkDataType(dataType, data, strictNums, correct = DataType.Correct) {
      const EQ = correct === DataType.Correct ? codegen_1.operators.EQ : codegen_1.operators.NEQ;
      let cond;
      switch (dataType) {
        case "null":
          return (0, codegen_1._)`${data} ${EQ} null`;
        case "array":
          cond = (0, codegen_1._)`Array.isArray(${data})`;
          break;
        case "object":
          cond = (0, codegen_1._)`${data} && typeof ${data} == "object" && !Array.isArray(${data})`;
          break;
        case "integer":
          cond = numCond((0, codegen_1._)`!(${data} % 1) && !isNaN(${data})`);
          break;
        case "number":
          cond = numCond();
          break;
        default:
          return (0, codegen_1._)`typeof ${data} ${EQ} ${dataType}`;
      }
      return correct === DataType.Correct ? cond : (0, codegen_1.not)(cond);
      function numCond(_cond = codegen_1.nil) {
        return (0, codegen_1.and)((0, codegen_1._)`typeof ${data} == "number"`, _cond, strictNums ? (0, codegen_1._)`isFinite(${data})` : codegen_1.nil);
      }
    }
    exports2.checkDataType = checkDataType;
    function checkDataTypes(dataTypes, data, strictNums, correct) {
      if (dataTypes.length === 1) {
        return checkDataType(dataTypes[0], data, strictNums, correct);
      }
      let cond;
      const types2 = (0, util_1.toHash)(dataTypes);
      if (types2.array && types2.object) {
        const notObj = (0, codegen_1._)`typeof ${data} != "object"`;
        cond = types2.null ? notObj : (0, codegen_1._)`!${data} || ${notObj}`;
        delete types2.null;
        delete types2.array;
        delete types2.object;
      } else {
        cond = codegen_1.nil;
      }
      if (types2.number)
        delete types2.integer;
      for (const t in types2)
        cond = (0, codegen_1.and)(cond, checkDataType(t, data, strictNums, correct));
      return cond;
    }
    exports2.checkDataTypes = checkDataTypes;
    var typeError = {
      message: ({ schema: schema2 }) => `must be ${schema2}`,
      params: ({ schema: schema2, schemaValue }) => typeof schema2 == "string" ? (0, codegen_1._)`{type: ${schema2}}` : (0, codegen_1._)`{type: ${schemaValue}}`
    };
    function reportTypeError(it) {
      const cxt = getTypeErrorContext(it);
      (0, errors_1.reportError)(cxt, typeError);
    }
    exports2.reportTypeError = reportTypeError;
    function getTypeErrorContext(it) {
      const { gen, data, schema: schema2 } = it;
      const schemaCode = (0, util_1.schemaRefOrVal)(it, schema2, "type");
      return {
        gen,
        keyword: "type",
        data,
        schema: schema2.type,
        schemaCode,
        schemaValue: schemaCode,
        parentSchema: schema2,
        params: {},
        it
      };
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/defaults.js
var require_defaults = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/defaults.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.assignDefaults = void 0;
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    function assignDefaults(it, ty) {
      const { properties, items } = it.schema;
      if (ty === "object" && properties) {
        for (const key in properties) {
          assignDefault(it, key, properties[key].default);
        }
      } else if (ty === "array" && Array.isArray(items)) {
        items.forEach((sch, i) => assignDefault(it, i, sch.default));
      }
    }
    exports2.assignDefaults = assignDefaults;
    function assignDefault(it, prop, defaultValue) {
      const { gen, compositeRule, data, opts } = it;
      if (defaultValue === void 0)
        return;
      const childData = (0, codegen_1._)`${data}${(0, codegen_1.getProperty)(prop)}`;
      if (compositeRule) {
        (0, util_1.checkStrictMode)(it, `default is ignored for: ${childData}`);
        return;
      }
      let condition = (0, codegen_1._)`${childData} === undefined`;
      if (opts.useDefaults === "empty") {
        condition = (0, codegen_1._)`${condition} || ${childData} === null || ${childData} === ""`;
      }
      gen.if(condition, (0, codegen_1._)`${childData} = ${(0, codegen_1.stringify)(defaultValue)}`);
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/code.js
var require_code2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/code.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateUnion = exports2.validateArray = exports2.usePattern = exports2.callValidateCode = exports2.schemaProperties = exports2.allSchemaProperties = exports2.noPropertyInData = exports2.propertyInData = exports2.isOwnProperty = exports2.hasPropFunc = exports2.reportMissingProp = exports2.checkMissingProp = exports2.checkReportMissingProp = void 0;
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var names_1 = require_names();
    var util_2 = require_util();
    function checkReportMissingProp(cxt, prop) {
      const { gen, data, it } = cxt;
      gen.if(noPropertyInData(gen, data, prop, it.opts.ownProperties), () => {
        cxt.setParams({ missingProperty: (0, codegen_1._)`${prop}` }, true);
        cxt.error();
      });
    }
    exports2.checkReportMissingProp = checkReportMissingProp;
    function checkMissingProp({ gen, data, it: { opts } }, properties, missing) {
      return (0, codegen_1.or)(...properties.map((prop) => (0, codegen_1.and)(noPropertyInData(gen, data, prop, opts.ownProperties), (0, codegen_1._)`${missing} = ${prop}`)));
    }
    exports2.checkMissingProp = checkMissingProp;
    function reportMissingProp(cxt, missing) {
      cxt.setParams({ missingProperty: missing }, true);
      cxt.error();
    }
    exports2.reportMissingProp = reportMissingProp;
    function hasPropFunc(gen) {
      return gen.scopeValue("func", {
        // eslint-disable-next-line @typescript-eslint/unbound-method
        ref: Object.prototype.hasOwnProperty,
        code: (0, codegen_1._)`Object.prototype.hasOwnProperty`
      });
    }
    exports2.hasPropFunc = hasPropFunc;
    function isOwnProperty(gen, data, property4) {
      return (0, codegen_1._)`${hasPropFunc(gen)}.call(${data}, ${property4})`;
    }
    exports2.isOwnProperty = isOwnProperty;
    function propertyInData(gen, data, property4, ownProperties) {
      const cond = (0, codegen_1._)`${data}${(0, codegen_1.getProperty)(property4)} !== undefined`;
      return ownProperties ? (0, codegen_1._)`${cond} && ${isOwnProperty(gen, data, property4)}` : cond;
    }
    exports2.propertyInData = propertyInData;
    function noPropertyInData(gen, data, property4, ownProperties) {
      const cond = (0, codegen_1._)`${data}${(0, codegen_1.getProperty)(property4)} === undefined`;
      return ownProperties ? (0, codegen_1.or)(cond, (0, codegen_1.not)(isOwnProperty(gen, data, property4))) : cond;
    }
    exports2.noPropertyInData = noPropertyInData;
    function allSchemaProperties(schemaMap) {
      return schemaMap ? Object.keys(schemaMap).filter((p) => p !== "__proto__") : [];
    }
    exports2.allSchemaProperties = allSchemaProperties;
    function schemaProperties(it, schemaMap) {
      return allSchemaProperties(schemaMap).filter((p) => !(0, util_1.alwaysValidSchema)(it, schemaMap[p]));
    }
    exports2.schemaProperties = schemaProperties;
    function callValidateCode({ schemaCode, data, it: { gen, topSchemaRef, schemaPath, errorPath }, it }, func, context, passSchema) {
      const dataAndSchema = passSchema ? (0, codegen_1._)`${schemaCode}, ${data}, ${topSchemaRef}${schemaPath}` : data;
      const valCxt = [
        [names_1.default.instancePath, (0, codegen_1.strConcat)(names_1.default.instancePath, errorPath)],
        [names_1.default.parentData, it.parentData],
        [names_1.default.parentDataProperty, it.parentDataProperty],
        [names_1.default.rootData, names_1.default.rootData],
        [names_1.default.isAllOfVariant, it.isAllOfVariant ? 1 : 0]
      ];
      if (it.opts.dynamicRef)
        valCxt.push([names_1.default.dynamicAnchors, names_1.default.dynamicAnchors]);
      const args = (0, codegen_1._)`${dataAndSchema}, ${gen.object(...valCxt)}`;
      return context !== codegen_1.nil ? (0, codegen_1._)`${func}.call(${context}, ${args})` : (0, codegen_1._)`${func}(${args})`;
    }
    exports2.callValidateCode = callValidateCode;
    var newRegExp = (0, codegen_1._)`new RegExp`;
    function usePattern({ gen, it: { opts } }, pattern) {
      const u = opts.unicodeRegExp ? "u" : "";
      const { regExp } = opts.code;
      const rx = regExp(pattern, u);
      return gen.scopeValue("pattern", {
        key: rx.toString(),
        ref: rx,
        code: (0, codegen_1._)`${regExp.code === "new RegExp" ? newRegExp : (0, util_2.useFunc)(gen, regExp)}(${pattern}, ${u})`
      });
    }
    exports2.usePattern = usePattern;
    function validateArray(cxt) {
      const { gen, data, keyword, it } = cxt;
      const valid = gen.name("valid");
      if (it.allErrors) {
        const validArr = gen.let("valid", true);
        validateItems(() => gen.assign(validArr, false));
        return validArr;
      }
      gen.var(valid, true);
      validateItems(() => gen.break());
      return valid;
      function validateItems(notValid) {
        const len = gen.const("len", (0, codegen_1._)`${data}.length`);
        gen.forRange("i", 0, len, (i) => {
          cxt.subschema({
            keyword,
            dataProp: i,
            dataPropType: util_1.Type.Num
          }, valid);
          gen.if((0, codegen_1.not)(valid), notValid);
        });
      }
    }
    exports2.validateArray = validateArray;
    function validateUnion(cxt) {
      const { gen, schema: schema2, keyword, parentSchema, it } = cxt;
      if (!Array.isArray(schema2))
        throw new Error("ajv implementation error");
      if (it.opts.discriminator && parentSchema.discriminator)
        return;
      const alwaysValid = schema2.some((sch) => (0, util_1.alwaysValidSchema)(it, sch));
      if (alwaysValid && !it.opts.unevaluated)
        return;
      const valid = gen.let("valid", false);
      const schValid = gen.name("_valid");
      gen.block(() => schema2.forEach((_sch, i) => {
        const schCxt = cxt.subschema({
          keyword,
          schemaProp: i,
          compositeRule: true
        }, schValid);
        gen.assign(valid, (0, codegen_1._)`${valid} || ${schValid}`);
        const merged = cxt.mergeValidEvaluated(schCxt, schValid);
        if (!merged)
          gen.if((0, codegen_1.not)(valid));
      }));
      cxt.result(valid, () => cxt.reset(), () => cxt.error(true));
    }
    exports2.validateUnion = validateUnion;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/keyword.js
var require_keyword = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/keyword.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateKeywordUsage = exports2.validSchemaType = exports2.funcKeywordCode = exports2.macroKeywordCode = void 0;
    var codegen_1 = require_codegen();
    var names_1 = require_names();
    var code_1 = require_code2();
    var errors_1 = require_errors2();
    function macroKeywordCode(cxt, def) {
      const { gen, keyword, schema: schema2, parentSchema, it } = cxt;
      const macroSchema = def.macro.call(it.self, schema2, parentSchema, it);
      const schemaRef = useKeyword(gen, keyword, macroSchema);
      if (it.opts.validateSchema !== false)
        it.self.validateSchema(macroSchema, true);
      const valid = gen.name("valid");
      cxt.subschema({
        schema: macroSchema,
        schemaPath: codegen_1.nil,
        errSchemaPath: `${it.errSchemaPath}/${keyword}`,
        topSchemaRef: schemaRef,
        compositeRule: true
      }, valid);
      cxt.pass(valid, () => cxt.error(true));
    }
    exports2.macroKeywordCode = macroKeywordCode;
    function funcKeywordCode(cxt, def) {
      var _a;
      const { gen, keyword, schema: schema2, parentSchema, $data, it } = cxt;
      checkAsyncKeyword(it, def);
      const validate = !$data && def.compile ? def.compile.call(it.self, schema2, parentSchema, it) : def.validate;
      const validateRef = useKeyword(gen, keyword, validate);
      const valid = gen.let("valid");
      cxt.block$data(valid, validateKeyword);
      cxt.ok((_a = def.valid) !== null && _a !== void 0 ? _a : valid);
      function validateKeyword() {
        if (def.errors === false) {
          assignValid();
          if (def.modifying)
            modifyData(cxt);
          reportErrs(() => cxt.error());
        } else {
          const ruleErrs = def.async ? validateAsync() : validateSync();
          if (def.modifying)
            modifyData(cxt);
          reportErrs(() => addErrs(cxt, ruleErrs));
        }
      }
      function validateAsync() {
        const ruleErrs = gen.let("ruleErrs", null);
        gen.try(() => assignValid((0, codegen_1._)`await `), (e) => gen.assign(valid, false).if((0, codegen_1._)`${e} instanceof ${it.ValidationError}`, () => gen.assign(ruleErrs, (0, codegen_1._)`${e}.errors`), () => gen.throw(e)));
        return ruleErrs;
      }
      function validateSync() {
        const validateErrs = (0, codegen_1._)`${validateRef}.errors`;
        gen.assign(validateErrs, null);
        assignValid(codegen_1.nil);
        return validateErrs;
      }
      function assignValid(_await = def.async ? (0, codegen_1._)`await ` : codegen_1.nil) {
        const passCxt = it.opts.passContext ? names_1.default.this : names_1.default.self;
        const passSchema = !("compile" in def && !$data || def.schema === false);
        gen.assign(valid, (0, codegen_1._)`${_await}${(0, code_1.callValidateCode)(cxt, validateRef, passCxt, passSchema)}`, def.modifying);
      }
      function reportErrs(errors) {
        var _a2;
        gen.if((0, codegen_1.not)((_a2 = def.valid) !== null && _a2 !== void 0 ? _a2 : valid), errors);
      }
    }
    exports2.funcKeywordCode = funcKeywordCode;
    function modifyData(cxt) {
      const { gen, data, it } = cxt;
      gen.if(it.parentData, () => gen.assign(data, (0, codegen_1._)`${it.parentData}[${it.parentDataProperty}]`));
    }
    function addErrs(cxt, errs) {
      const { gen } = cxt;
      gen.if((0, codegen_1._)`Array.isArray(${errs})`, () => {
        gen.assign(names_1.default.vErrors, (0, codegen_1._)`${names_1.default.vErrors} === null ? ${errs} : ${names_1.default.vErrors}.concat(${errs})`).assign(names_1.default.errors, (0, codegen_1._)`${names_1.default.vErrors}.length`);
        (0, errors_1.extendErrors)(cxt);
      }, () => cxt.error());
    }
    function checkAsyncKeyword({ schemaEnv }, def) {
      if (def.async && !schemaEnv.$async)
        throw new Error("async keyword in sync schema");
    }
    function useKeyword(gen, keyword, result) {
      if (result === void 0)
        throw new Error(`keyword "${keyword}" failed to compile`);
      return gen.scopeValue("keyword", typeof result == "function" ? { ref: result } : { ref: result, code: (0, codegen_1.stringify)(result) });
    }
    function validSchemaType(schema2, schemaType, allowUndefined = false) {
      return !schemaType.length || schemaType.some((st) => st === "array" ? Array.isArray(schema2) : st === "object" ? schema2 && typeof schema2 == "object" && !Array.isArray(schema2) : typeof schema2 == st || allowUndefined && typeof schema2 == "undefined");
    }
    exports2.validSchemaType = validSchemaType;
    function validateKeywordUsage({ schema: schema2, opts, self: self2, errSchemaPath }, def, keyword) {
      if (Array.isArray(def.keyword) ? !def.keyword.includes(keyword) : def.keyword !== keyword) {
        throw new Error("ajv implementation error");
      }
      const deps = def.dependencies;
      if (deps === null || deps === void 0 ? void 0 : deps.some((kwd) => !Object.prototype.hasOwnProperty.call(schema2, kwd))) {
        throw new Error(`parent schema must have dependencies of ${keyword}: ${deps.join(",")}`);
      }
      if (def.validateSchema) {
        const valid = def.validateSchema(schema2[keyword]);
        if (!valid) {
          const msg = `keyword "${keyword}" value is invalid at path "${errSchemaPath}": ` + self2.errorsText(def.validateSchema.errors);
          if (opts.validateSchema === "log")
            self2.logger.error(msg);
          else
            throw new Error(msg);
        }
      }
    }
    exports2.validateKeywordUsage = validateKeywordUsage;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/subschema.js
var require_subschema = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/subschema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.extendSubschemaMode = exports2.extendSubschemaData = exports2.getSubschema = void 0;
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    function getSubschema(it, { keyword, schemaProp, schema: schema2, schemaPath, errSchemaPath, topSchemaRef }) {
      if (keyword !== void 0 && schema2 !== void 0) {
        throw new Error('both "keyword" and "schema" passed, only one allowed');
      }
      if (keyword !== void 0) {
        const sch = it.schema[keyword];
        return schemaProp === void 0 ? {
          schema: sch,
          schemaPath: (0, codegen_1._)`${it.schemaPath}${(0, codegen_1.getProperty)(keyword)}`,
          errSchemaPath: `${it.errSchemaPath}/${keyword}`
        } : {
          schema: sch[schemaProp],
          schemaPath: (0, codegen_1._)`${it.schemaPath}${(0, codegen_1.getProperty)(keyword)}${(0, codegen_1.getProperty)(schemaProp)}`,
          errSchemaPath: `${it.errSchemaPath}/${keyword}/${(0, util_1.escapeFragment)(schemaProp)}`
        };
      }
      if (schema2 !== void 0) {
        if (schemaPath === void 0 || errSchemaPath === void 0 || topSchemaRef === void 0) {
          throw new Error('"schemaPath", "errSchemaPath" and "topSchemaRef" are required with "schema"');
        }
        return {
          schema: schema2,
          schemaPath,
          topSchemaRef,
          errSchemaPath
        };
      }
      throw new Error('either "keyword" or "schema" must be passed');
    }
    exports2.getSubschema = getSubschema;
    function extendSubschemaData(subschema, it, { dataProp, dataPropType: dpType, data, dataTypes, propertyName }) {
      if (data !== void 0 && dataProp !== void 0) {
        throw new Error('both "data" and "dataProp" passed, only one allowed');
      }
      const { gen } = it;
      if (dataProp !== void 0) {
        const { errorPath, dataPathArr, opts } = it;
        const nextData = gen.let("data", (0, codegen_1._)`${it.data}${(0, codegen_1.getProperty)(dataProp)}`, true);
        dataContextProps(nextData);
        subschema.errorPath = (0, codegen_1.str)`${errorPath}${(0, util_1.getErrorPath)(dataProp, dpType, opts.jsPropertySyntax)}`;
        subschema.parentDataProperty = (0, codegen_1._)`${dataProp}`;
        subschema.dataPathArr = [...dataPathArr, subschema.parentDataProperty];
      }
      if (data !== void 0) {
        const nextData = data instanceof codegen_1.Name ? data : gen.let("data", data, true);
        dataContextProps(nextData);
        if (propertyName !== void 0)
          subschema.propertyName = propertyName;
      }
      if (dataTypes)
        subschema.dataTypes = dataTypes;
      function dataContextProps(_nextData) {
        subschema.data = _nextData;
        subschema.dataLevel = it.dataLevel + 1;
        subschema.dataTypes = [];
        it.definedProperties = /* @__PURE__ */ new Set();
        subschema.parentData = it.data;
        subschema.dataNames = [...it.dataNames, _nextData];
      }
    }
    exports2.extendSubschemaData = extendSubschemaData;
    function extendSubschemaMode(subschema, { jtdDiscriminator, jtdMetadata, compositeRule, createErrors, allErrors }) {
      if (compositeRule !== void 0)
        subschema.compositeRule = compositeRule;
      if (createErrors !== void 0)
        subschema.createErrors = createErrors;
      if (allErrors !== void 0)
        subschema.allErrors = allErrors;
      subschema.jtdDiscriminator = jtdDiscriminator;
      subschema.jtdMetadata = jtdMetadata;
    }
    exports2.extendSubschemaMode = extendSubschemaMode;
  }
});

// ../../../node_modules/.pnpm/fast-deep-equal@3.1.3/node_modules/fast-deep-equal/index.js
var require_fast_deep_equal = __commonJS({
  "../../../node_modules/.pnpm/fast-deep-equal@3.1.3/node_modules/fast-deep-equal/index.js"(exports2, module2) {
    "use strict";
    module2.exports = function equal(a, b) {
      if (a === b) return true;
      if (a && b && typeof a == "object" && typeof b == "object") {
        if (a.constructor !== b.constructor) return false;
        var length, i, keys5;
        if (Array.isArray(a)) {
          length = a.length;
          if (length != b.length) return false;
          for (i = length; i-- !== 0; )
            if (!equal(a[i], b[i])) return false;
          return true;
        }
        if (a.constructor === RegExp) return a.source === b.source && a.flags === b.flags;
        if (a.valueOf !== Object.prototype.valueOf) return a.valueOf() === b.valueOf();
        if (a.toString !== Object.prototype.toString) return a.toString() === b.toString();
        keys5 = Object.keys(a);
        length = keys5.length;
        if (length !== Object.keys(b).length) return false;
        for (i = length; i-- !== 0; )
          if (!Object.prototype.hasOwnProperty.call(b, keys5[i])) return false;
        for (i = length; i-- !== 0; ) {
          var key = keys5[i];
          if (!equal(a[key], b[key])) return false;
        }
        return true;
      }
      return a !== a && b !== b;
    };
  }
});

// ../../../node_modules/.pnpm/json-schema-traverse@1.0.0/node_modules/json-schema-traverse/index.js
var require_json_schema_traverse = __commonJS({
  "../../../node_modules/.pnpm/json-schema-traverse@1.0.0/node_modules/json-schema-traverse/index.js"(exports2, module2) {
    "use strict";
    var traverse = module2.exports = function(schema2, opts, cb) {
      if (typeof opts == "function") {
        cb = opts;
        opts = {};
      }
      cb = opts.cb || cb;
      var pre = typeof cb == "function" ? cb : cb.pre || function() {
      };
      var post = cb.post || function() {
      };
      _traverse(opts, pre, post, schema2, "", schema2);
    };
    traverse.keywords = {
      additionalItems: true,
      items: true,
      contains: true,
      additionalProperties: true,
      propertyNames: true,
      not: true,
      if: true,
      then: true,
      else: true
    };
    traverse.arrayKeywords = {
      items: true,
      allOf: true,
      anyOf: true,
      oneOf: true
    };
    traverse.propsKeywords = {
      $defs: true,
      definitions: true,
      properties: true,
      patternProperties: true,
      dependencies: true
    };
    traverse.skipKeywords = {
      default: true,
      enum: true,
      const: true,
      required: true,
      maximum: true,
      minimum: true,
      exclusiveMaximum: true,
      exclusiveMinimum: true,
      multipleOf: true,
      maxLength: true,
      minLength: true,
      pattern: true,
      format: true,
      maxItems: true,
      minItems: true,
      uniqueItems: true,
      maxProperties: true,
      minProperties: true
    };
    function _traverse(opts, pre, post, schema2, jsonPtr, rootSchema, parentJsonPtr, parentKeyword, parentSchema, keyIndex) {
      if (schema2 && typeof schema2 == "object" && !Array.isArray(schema2)) {
        pre(schema2, jsonPtr, rootSchema, parentJsonPtr, parentKeyword, parentSchema, keyIndex);
        for (var key in schema2) {
          var sch = schema2[key];
          if (Array.isArray(sch)) {
            if (key in traverse.arrayKeywords) {
              for (var i = 0; i < sch.length; i++)
                _traverse(opts, pre, post, sch[i], jsonPtr + "/" + key + "/" + i, rootSchema, jsonPtr, key, schema2, i);
            }
          } else if (key in traverse.propsKeywords) {
            if (sch && typeof sch == "object") {
              for (var prop in sch)
                _traverse(opts, pre, post, sch[prop], jsonPtr + "/" + key + "/" + escapeJsonPtr(prop), rootSchema, jsonPtr, key, schema2, prop);
            }
          } else if (key in traverse.keywords || opts.allKeys && !(key in traverse.skipKeywords)) {
            _traverse(opts, pre, post, sch, jsonPtr + "/" + key, rootSchema, jsonPtr, key, schema2);
          }
        }
        post(schema2, jsonPtr, rootSchema, parentJsonPtr, parentKeyword, parentSchema, keyIndex);
      }
    }
    function escapeJsonPtr(str2) {
      return str2.replace(/~/g, "~0").replace(/\//g, "~1");
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/resolve.js
var require_resolve = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/resolve.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getSchemaRefs = exports2.resolveUrl = exports2.normalizeId = exports2._getFullPath = exports2.getFullPath = exports2.inlineRef = void 0;
    var util_1 = require_util();
    var equal = require_fast_deep_equal();
    var traverse = require_json_schema_traverse();
    var SIMPLE_INLINED = /* @__PURE__ */ new Set([
      "type",
      "format",
      "pattern",
      "maxLength",
      "minLength",
      "maxProperties",
      "minProperties",
      "maxItems",
      "minItems",
      "maximum",
      "minimum",
      "uniqueItems",
      "multipleOf",
      "required",
      "enum",
      "const"
    ]);
    function inlineRef(schema2, limit = true) {
      if (typeof schema2 == "boolean")
        return true;
      if (limit === true)
        return !hasRef(schema2);
      if (!limit)
        return false;
      return countKeys(schema2) <= limit;
    }
    exports2.inlineRef = inlineRef;
    var REF_KEYWORDS = /* @__PURE__ */ new Set([
      "$ref",
      "$recursiveRef",
      "$recursiveAnchor",
      "$dynamicRef",
      "$dynamicAnchor"
    ]);
    function hasRef(schema2) {
      for (const key in schema2) {
        if (REF_KEYWORDS.has(key))
          return true;
        const sch = schema2[key];
        if (Array.isArray(sch) && sch.some(hasRef))
          return true;
        if (typeof sch == "object" && hasRef(sch))
          return true;
      }
      return false;
    }
    function countKeys(schema2) {
      let count = 0;
      for (const key in schema2) {
        if (key === "$ref")
          return Infinity;
        count++;
        if (SIMPLE_INLINED.has(key))
          continue;
        if (typeof schema2[key] == "object") {
          (0, util_1.eachItem)(schema2[key], (sch) => count += countKeys(sch));
        }
        if (count === Infinity)
          return Infinity;
      }
      return count;
    }
    function getFullPath(resolver, id = "", normalize2) {
      if (normalize2 !== false)
        id = normalizeId(id);
      const p = resolver.parse(id);
      return _getFullPath(resolver, p);
    }
    exports2.getFullPath = getFullPath;
    function _getFullPath(resolver, p) {
      const serialized = resolver.serialize(p);
      return serialized.split("#")[0] + "#";
    }
    exports2._getFullPath = _getFullPath;
    var TRAILING_SLASH_HASH = /#\/?$/;
    function normalizeId(id) {
      return id ? id.replace(TRAILING_SLASH_HASH, "") : "";
    }
    exports2.normalizeId = normalizeId;
    function resolveUrl(resolver, baseId, id) {
      id = normalizeId(id);
      return resolver.resolve(baseId, id);
    }
    exports2.resolveUrl = resolveUrl;
    var ANCHOR = /^[a-z_][-a-z0-9._]*$/i;
    function getSchemaRefs(schema2, baseId) {
      if (typeof schema2 == "boolean")
        return {};
      const { schemaId, uriResolver } = this.opts;
      const schId = normalizeId(schema2[schemaId] || baseId);
      const baseIds = { "": schId };
      const pathPrefix = getFullPath(uriResolver, schId, false);
      const localRefs = {};
      const schemaRefs = /* @__PURE__ */ new Set();
      traverse(schema2, { allKeys: true }, (sch, jsonPtr, _, parentJsonPtr) => {
        if (parentJsonPtr === void 0)
          return;
        const fullPath = pathPrefix + jsonPtr;
        let baseId2 = baseIds[parentJsonPtr];
        if (typeof sch[schemaId] == "string")
          baseId2 = addRef.call(this, sch[schemaId]);
        addAnchor.call(this, sch.$anchor);
        addAnchor.call(this, sch.$dynamicAnchor);
        baseIds[jsonPtr] = baseId2;
        function addRef(ref) {
          const _resolve = this.opts.uriResolver.resolve;
          ref = normalizeId(baseId2 ? _resolve(baseId2, ref) : ref);
          if (schemaRefs.has(ref))
            throw ambiguos(ref);
          schemaRefs.add(ref);
          let schOrRef = this.refs[ref];
          if (typeof schOrRef == "string")
            schOrRef = this.refs[schOrRef];
          if (typeof schOrRef == "object") {
            checkAmbiguosRef(sch, schOrRef.schema, ref);
          } else if (ref !== normalizeId(fullPath)) {
            if (ref[0] === "#") {
              checkAmbiguosRef(sch, localRefs[ref], ref);
              localRefs[ref] = sch;
            } else {
              this.refs[ref] = fullPath;
            }
          }
          return ref;
        }
        function addAnchor(anchor) {
          if (typeof anchor == "string") {
            if (!ANCHOR.test(anchor))
              throw new Error(`invalid anchor "${anchor}"`);
            addRef.call(this, `#${anchor}`);
          }
        }
      });
      return localRefs;
      function checkAmbiguosRef(sch1, sch2, ref) {
        if (sch2 !== void 0 && !equal(sch1, sch2))
          throw ambiguos(ref);
      }
      function ambiguos(ref) {
        return new Error(`reference "${ref}" resolves to more than one schema`);
      }
    }
    exports2.getSchemaRefs = getSchemaRefs;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/index.js
var require_validate = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getData = exports2.KeywordCxt = exports2.validateFunctionCode = void 0;
    var boolSchema_1 = require_boolSchema();
    var dataType_1 = require_dataType();
    var applicability_1 = require_applicability();
    var dataType_2 = require_dataType();
    var defaults_1 = require_defaults();
    var keyword_1 = require_keyword();
    var subschema_1 = require_subschema();
    var codegen_1 = require_codegen();
    var names_1 = require_names();
    var resolve_1 = require_resolve();
    var util_1 = require_util();
    var errors_1 = require_errors2();
    function validateFunctionCode(it) {
      if (isSchemaObj(it)) {
        checkKeywords(it);
        if (schemaCxtHasRules(it)) {
          topSchemaObjCode(it);
          return;
        }
      }
      validateFunction(it, () => (0, boolSchema_1.topBoolOrEmptySchema)(it));
    }
    exports2.validateFunctionCode = validateFunctionCode;
    function validateFunction({ gen, validateName: validateName3, schema: schema2, schemaEnv, opts }, body) {
      if (opts.code.es5) {
        gen.func(validateName3, (0, codegen_1._)`${names_1.default.data}, ${names_1.default.valCxt}`, schemaEnv.$async, () => {
          gen.code((0, codegen_1._)`"use strict"; ${funcSourceUrl(schema2, opts)}`);
          destructureValCxtES5(gen, opts);
          gen.code(body);
        });
      } else {
        gen.func(validateName3, (0, codegen_1._)`${names_1.default.data}, ${destructureValCxt(opts)}`, schemaEnv.$async, () => gen.code(funcSourceUrl(schema2, opts)).code(body));
      }
    }
    function destructureValCxt(opts) {
      return (0, codegen_1._)`{${names_1.default.instancePath}="", ${names_1.default.parentData}, ${names_1.default.parentDataProperty}, ${names_1.default.rootData}=${names_1.default.data}${opts.dynamicRef ? (0, codegen_1._)`, ${names_1.default.dynamicAnchors}={}` : codegen_1.nil}, ${names_1.default.isAllOfVariant} = 0}={}`;
    }
    function destructureValCxtES5(gen, opts) {
      gen.if(names_1.default.valCxt, () => {
        gen.var(names_1.default.instancePath, (0, codegen_1._)`${names_1.default.valCxt}.${names_1.default.instancePath}`);
        gen.var(names_1.default.parentData, (0, codegen_1._)`${names_1.default.valCxt}.${names_1.default.parentData}`);
        gen.var(names_1.default.parentDataProperty, (0, codegen_1._)`${names_1.default.valCxt}.${names_1.default.parentDataProperty}`);
        gen.var(names_1.default.rootData, (0, codegen_1._)`${names_1.default.valCxt}.${names_1.default.rootData}`);
        gen.var(names_1.default.isAllOfVariant, (0, codegen_1._)`${names_1.default.valCxt}.${names_1.default.isAllOfVariant}`);
        if (opts.dynamicRef)
          gen.var(names_1.default.dynamicAnchors, (0, codegen_1._)`${names_1.default.valCxt}.${names_1.default.dynamicAnchors}`);
      }, () => {
        gen.var(names_1.default.instancePath, (0, codegen_1._)`""`);
        gen.var(names_1.default.parentData, (0, codegen_1._)`undefined`);
        gen.var(names_1.default.parentDataProperty, (0, codegen_1._)`undefined`);
        gen.var(names_1.default.rootData, names_1.default.data);
        gen.var(names_1.default.isAllOfVariant, (0, codegen_1._)`0`);
        if (opts.dynamicRef)
          gen.var(names_1.default.dynamicAnchors, (0, codegen_1._)`{}`);
      });
    }
    function topSchemaObjCode(it) {
      const { schema: schema2, opts, gen } = it;
      validateFunction(it, () => {
        if (opts.$comment && schema2.$comment)
          commentKeyword(it);
        checkNoDefault(it);
        gen.let(names_1.default.vErrors, null);
        gen.let(names_1.default.errors, 0);
        if (opts.unevaluated)
          resetEvaluated(it);
        typeAndKeywords(it);
        returnResults(it);
      });
      return;
    }
    function resetEvaluated(it) {
      const { gen, validateName: validateName3 } = it;
      it.evaluated = gen.const("evaluated", (0, codegen_1._)`${validateName3}.evaluated`);
      gen.if((0, codegen_1._)`${it.evaluated}.dynamicProps`, () => gen.assign((0, codegen_1._)`${it.evaluated}.props`, (0, codegen_1._)`undefined`));
      gen.if((0, codegen_1._)`${it.evaluated}.dynamicItems`, () => gen.assign((0, codegen_1._)`${it.evaluated}.items`, (0, codegen_1._)`undefined`));
    }
    function funcSourceUrl(schema2, opts) {
      const schId = typeof schema2 == "object" && schema2[opts.schemaId];
      return schId && (opts.code.source || opts.code.process) ? (0, codegen_1._)`/*# sourceURL=${schId} */` : codegen_1.nil;
    }
    function subschemaCode(it, valid) {
      if (isSchemaObj(it)) {
        checkKeywords(it);
        if (schemaCxtHasRules(it)) {
          subSchemaObjCode(it, valid);
          return;
        }
      }
      (0, boolSchema_1.boolOrEmptySchema)(it, valid);
    }
    function schemaCxtHasRules({ schema: schema2, self: self2 }) {
      if (typeof schema2 == "boolean")
        return !schema2;
      for (const key in schema2)
        if (self2.RULES.all[key])
          return true;
      return false;
    }
    function isSchemaObj(it) {
      return typeof it.schema != "boolean";
    }
    function subSchemaObjCode(it, valid) {
      const { schema: schema2, gen, opts } = it;
      if (opts.$comment && schema2.$comment)
        commentKeyword(it);
      updateContext(it);
      checkAsyncSchema(it);
      const errsCount = gen.const("_errs", names_1.default.errors);
      typeAndKeywords(it, errsCount);
      gen.var(valid, (0, codegen_1._)`${errsCount} === ${names_1.default.errors}`);
    }
    function checkKeywords(it) {
      (0, util_1.checkUnknownRules)(it);
      checkRefsAndKeywords(it);
    }
    function typeAndKeywords(it, errsCount) {
      if (it.opts.jtd)
        return schemaKeywords(it, [], false, errsCount);
      const types2 = (0, dataType_1.getSchemaTypes)(it.schema);
      const checkedTypes = (0, dataType_1.coerceAndCheckDataType)(it, types2);
      schemaKeywords(it, types2, !checkedTypes, errsCount);
    }
    function checkRefsAndKeywords(it) {
      const { schema: schema2, errSchemaPath, opts, self: self2 } = it;
      if (schema2.$ref && opts.ignoreKeywordsWithRef && (0, util_1.schemaHasRulesButRef)(schema2, self2.RULES)) {
        self2.logger.warn(`$ref: keywords ignored in schema at path "${errSchemaPath}"`);
      }
    }
    function checkNoDefault(it) {
      const { schema: schema2, opts } = it;
      if (schema2.default !== void 0 && opts.useDefaults && opts.strictSchema) {
        (0, util_1.checkStrictMode)(it, "default is ignored in the schema root");
      }
    }
    function updateContext(it) {
      const schId = it.schema[it.opts.schemaId];
      if (schId)
        it.baseId = (0, resolve_1.resolveUrl)(it.opts.uriResolver, it.baseId, schId);
    }
    function checkAsyncSchema(it) {
      if (it.schema.$async && !it.schemaEnv.$async)
        throw new Error("async schema in sync schema");
    }
    function commentKeyword({ gen, schemaEnv, schema: schema2, errSchemaPath, opts }) {
      const msg = schema2.$comment;
      if (opts.$comment === true) {
        gen.code((0, codegen_1._)`${names_1.default.self}.logger.log(${msg})`);
      } else if (typeof opts.$comment == "function") {
        const schemaPath = (0, codegen_1.str)`${errSchemaPath}/$comment`;
        const rootName = gen.scopeValue("root", { ref: schemaEnv.root });
        gen.code((0, codegen_1._)`${names_1.default.self}.opts.$comment(${msg}, ${schemaPath}, ${rootName}.schema)`);
      }
    }
    function returnResults(it) {
      const { gen, schemaEnv, validateName: validateName3, ValidationError, opts } = it;
      if (schemaEnv.$async) {
        gen.if((0, codegen_1._)`${names_1.default.errors} === 0`, () => gen.return(names_1.default.data), () => gen.throw((0, codegen_1._)`new ${ValidationError}(${names_1.default.vErrors})`));
      } else {
        gen.assign((0, codegen_1._)`${validateName3}.errors`, names_1.default.vErrors);
        if (opts.unevaluated)
          assignEvaluated(it);
        gen.return((0, codegen_1._)`${names_1.default.errors} === 0`);
      }
    }
    function assignEvaluated({ gen, evaluated, props, items }) {
      if (props instanceof codegen_1.Name)
        gen.assign((0, codegen_1._)`${evaluated}.props`, props);
      if (items instanceof codegen_1.Name)
        gen.assign((0, codegen_1._)`${evaluated}.items`, items);
    }
    function schemaKeywords(it, types2, typeErrors, errsCount) {
      const { gen, schema: schema2, data, allErrors, opts, self: self2 } = it;
      const { RULES } = self2;
      if (schema2.$ref && (opts.ignoreKeywordsWithRef || !(0, util_1.schemaHasRulesButRef)(schema2, RULES))) {
        gen.block(() => keywordCode(it, "$ref", RULES.all.$ref.definition));
        return;
      }
      if (!opts.jtd)
        checkStrictTypes(it, types2);
      gen.block(() => {
        for (const group of RULES.rules)
          groupKeywords(group);
        groupKeywords(RULES.post);
      });
      function groupKeywords(group) {
        if (!(0, applicability_1.shouldUseGroup)(schema2, group))
          return;
        if (group.type) {
          gen.if((0, dataType_2.checkDataType)(group.type, data, opts.strictNumbers));
          iterateKeywords(it, group);
          if (types2.length === 1 && types2[0] === group.type && typeErrors) {
            gen.else();
            (0, dataType_2.reportTypeError)(it);
          }
          gen.endIf();
        } else {
          iterateKeywords(it, group);
        }
        if (!allErrors)
          gen.if((0, codegen_1._)`${names_1.default.errors} === ${errsCount || 0}`);
      }
    }
    function iterateKeywords(it, group) {
      const { gen, schema: schema2, opts: { useDefaults } } = it;
      if (useDefaults)
        (0, defaults_1.assignDefaults)(it, group.type);
      gen.block(() => {
        for (const rule of group.rules) {
          if ((0, applicability_1.shouldUseRule)(schema2, rule) || shouldForceUnevaluatedProperties(schema2, rule)) {
            keywordCode(it, rule.keyword, rule.definition, group.type);
          }
        }
      });
      function shouldForceUnevaluatedProperties(schema3, rule) {
        return !!(rule.keyword === "unevaluatedProperties" && (schema3.properties || schema3.patternProperties) && !it.isAllOfVariant && it.opts.defaultUnevaluatedProperties === false);
      }
    }
    function checkStrictTypes(it, types2) {
      if (it.schemaEnv.meta || !it.opts.strictTypes)
        return;
      checkContextTypes(it, types2);
      if (!it.opts.allowUnionTypes)
        checkMultipleTypes(it, types2);
      checkKeywordTypes(it, it.dataTypes);
    }
    function checkContextTypes(it, types2) {
      if (!types2.length)
        return;
      if (!it.dataTypes.length) {
        it.dataTypes = types2;
        return;
      }
      types2.forEach((t) => {
        if (!includesType(it.dataTypes, t)) {
          strictTypesError(it, `type "${t}" not allowed by context "${it.dataTypes.join(",")}"`);
        }
      });
      it.dataTypes = it.dataTypes.filter((t) => includesType(types2, t));
    }
    function checkMultipleTypes(it, ts) {
      if (ts.length > 1 && !(ts.length === 2 && ts.includes("null"))) {
        strictTypesError(it, "use allowUnionTypes to allow union type keyword");
      }
    }
    function checkKeywordTypes(it, ts) {
      const rules = it.self.RULES.all;
      for (const keyword in rules) {
        const rule = rules[keyword];
        if (typeof rule == "object" && (0, applicability_1.shouldUseRule)(it.schema, rule)) {
          const { type: type2 } = rule.definition;
          if (type2.length && !type2.some((t) => hasApplicableType(ts, t))) {
            strictTypesError(it, `missing type "${type2.join(",")}" for keyword "${keyword}"`);
          }
        }
      }
    }
    function hasApplicableType(schTs, kwdT) {
      return schTs.includes(kwdT) || kwdT === "number" && schTs.includes("integer");
    }
    function includesType(ts, t) {
      return ts.includes(t) || t === "integer" && ts.includes("number");
    }
    function strictTypesError(it, msg) {
      const schemaPath = it.schemaEnv.baseId + it.errSchemaPath;
      msg += ` at "${schemaPath}" (strictTypes)`;
      (0, util_1.checkStrictMode)(it, msg, it.opts.strictTypes);
    }
    var KeywordCxt = class {
      constructor(it, def, keyword) {
        (0, keyword_1.validateKeywordUsage)(it, def, keyword);
        this.gen = it.gen;
        this.allErrors = it.allErrors;
        this.keyword = keyword;
        this.data = it.data;
        this.schema = it.schema[keyword];
        this.$data = def.$data && it.opts.$data && this.schema && this.schema.$data;
        this.schemaValue = (0, util_1.schemaRefOrVal)(it, this.schema, keyword, this.$data);
        this.schemaType = def.schemaType;
        this.parentSchema = it.schema;
        this.params = {};
        this.it = it;
        this.def = def;
        if (this.$data) {
          this.schemaCode = it.gen.const("vSchema", getData(this.$data, it));
        } else {
          this.schemaCode = this.schemaValue;
          if (!(0, keyword_1.validSchemaType)(this.schema, def.schemaType, def.allowUndefined)) {
            throw new Error(`${keyword} value must be ${JSON.stringify(def.schemaType)}`);
          }
        }
        if ("code" in def ? def.trackErrors : def.errors !== false) {
          this.errsCount = it.gen.const("_errs", names_1.default.errors);
        }
      }
      result(condition, successAction, failAction) {
        this.failResult((0, codegen_1.not)(condition), successAction, failAction);
      }
      failResult(condition, successAction, failAction) {
        this.gen.if(condition);
        if (failAction)
          failAction();
        else
          this.error();
        if (successAction) {
          this.gen.else();
          successAction();
          if (this.allErrors)
            this.gen.endIf();
        } else {
          if (this.allErrors)
            this.gen.endIf();
          else
            this.gen.else();
        }
      }
      pass(condition, failAction) {
        this.failResult((0, codegen_1.not)(condition), void 0, failAction);
      }
      fail(condition) {
        if (condition === void 0) {
          this.error();
          if (!this.allErrors)
            this.gen.if(false);
          return;
        }
        this.gen.if(condition);
        this.error();
        if (this.allErrors)
          this.gen.endIf();
        else
          this.gen.else();
      }
      fail$data(condition) {
        if (!this.$data)
          return this.fail(condition);
        const { schemaCode } = this;
        this.fail((0, codegen_1._)`${schemaCode} !== undefined && (${(0, codegen_1.or)(this.invalid$data(), condition)})`);
      }
      error(append, errorParams, errorPaths) {
        if (errorParams) {
          this.setParams(errorParams);
          this._error(append, errorPaths);
          this.setParams({});
          return;
        }
        this._error(append, errorPaths);
      }
      _error(append, errorPaths) {
        ;
        (append ? errors_1.reportExtraError : errors_1.reportError)(this, this.def.error, errorPaths);
      }
      $dataError() {
        (0, errors_1.reportError)(this, this.def.$dataError || errors_1.keyword$DataError);
      }
      reset() {
        if (this.errsCount === void 0)
          throw new Error('add "trackErrors" to keyword definition');
        (0, errors_1.resetErrorsCount)(this.gen, this.errsCount);
      }
      ok(cond) {
        if (!this.allErrors)
          this.gen.if(cond);
      }
      setParams(obj, assign) {
        if (assign)
          Object.assign(this.params, obj);
        else
          this.params = obj;
      }
      block$data(valid, codeBlock, $dataValid = codegen_1.nil) {
        this.gen.block(() => {
          this.check$data(valid, $dataValid);
          codeBlock();
        });
      }
      check$data(valid = codegen_1.nil, $dataValid = codegen_1.nil) {
        if (!this.$data)
          return;
        const { gen, schemaCode, schemaType, def } = this;
        gen.if((0, codegen_1.or)((0, codegen_1._)`${schemaCode} === undefined`, $dataValid));
        if (valid !== codegen_1.nil)
          gen.assign(valid, true);
        if (schemaType.length || def.validateSchema) {
          gen.elseIf(this.invalid$data());
          this.$dataError();
          if (valid !== codegen_1.nil)
            gen.assign(valid, false);
        }
        gen.else();
      }
      invalid$data() {
        const { gen, schemaCode, schemaType, def, it } = this;
        return (0, codegen_1.or)(wrong$DataType(), invalid$DataSchema());
        function wrong$DataType() {
          if (schemaType.length) {
            if (!(schemaCode instanceof codegen_1.Name))
              throw new Error("ajv implementation error");
            const st = Array.isArray(schemaType) ? schemaType : [schemaType];
            return (0, codegen_1._)`${(0, dataType_2.checkDataTypes)(st, schemaCode, it.opts.strictNumbers, dataType_2.DataType.Wrong)}`;
          }
          return codegen_1.nil;
        }
        function invalid$DataSchema() {
          if (def.validateSchema) {
            const validateSchemaRef = gen.scopeValue("validate$data", { ref: def.validateSchema });
            return (0, codegen_1._)`!${validateSchemaRef}(${schemaCode})`;
          }
          return codegen_1.nil;
        }
      }
      subschema(appl, valid, isAllOfVariant) {
        const subschema = (0, subschema_1.getSubschema)(this.it, appl);
        (0, subschema_1.extendSubschemaData)(subschema, this.it, appl);
        (0, subschema_1.extendSubschemaMode)(subschema, appl);
        const nextContext = {
          ...this.it,
          ...subschema,
          items: void 0,
          props: void 0,
          isAllOfVariant
        };
        subschemaCode(nextContext, valid);
        return nextContext;
      }
      mergeEvaluated(schemaCxt, toName) {
        const { it, gen } = this;
        if (!it.opts.unevaluated)
          return;
        if (it.props !== true && schemaCxt.props !== void 0) {
          it.props = util_1.mergeEvaluated.props(gen, schemaCxt.props, it.props, toName);
        }
        if (it.items !== true && schemaCxt.items !== void 0) {
          it.items = util_1.mergeEvaluated.items(gen, schemaCxt.items, it.items, toName);
        }
      }
      mergeValidEvaluated(schemaCxt, valid) {
        const { it, gen } = this;
        if (it.opts.unevaluated && (it.props !== true || it.items !== true)) {
          gen.if(valid, () => this.mergeEvaluated(schemaCxt, codegen_1.Name));
          return true;
        }
      }
    };
    exports2.KeywordCxt = KeywordCxt;
    function keywordCode(it, keyword, def, ruleType) {
      const cxt = new KeywordCxt(it, def, keyword);
      if ("code" in def) {
        def.code(cxt, ruleType);
      } else if (cxt.$data && def.validate) {
        (0, keyword_1.funcKeywordCode)(cxt, def);
      } else if ("macro" in def) {
        (0, keyword_1.macroKeywordCode)(cxt, def);
      } else if (def.compile || def.validate) {
        (0, keyword_1.funcKeywordCode)(cxt, def);
      }
    }
    var JSON_POINTER = /^\/(?:[^~]|~0|~1)*$/;
    var RELATIVE_JSON_POINTER = /^([0-9]+)(#|\/(?:[^~]|~0|~1)*)?$/;
    function getData($data, { dataLevel, dataNames, dataPathArr }) {
      let jsonPointer;
      let data;
      if ($data === "")
        return names_1.default.rootData;
      if ($data[0] === "/") {
        if (!JSON_POINTER.test($data))
          throw new Error(`Invalid JSON-pointer: ${$data}`);
        jsonPointer = $data;
        data = names_1.default.rootData;
      } else {
        const matches = RELATIVE_JSON_POINTER.exec($data);
        if (!matches)
          throw new Error(`Invalid JSON-pointer: ${$data}`);
        const up = +matches[1];
        jsonPointer = matches[2];
        if (jsonPointer === "#") {
          if (up >= dataLevel)
            throw new Error(errorMsg("property/index", up));
          return dataPathArr[dataLevel - up];
        }
        if (up > dataLevel)
          throw new Error(errorMsg("data", up));
        data = dataNames[dataLevel - up];
        if (!jsonPointer)
          return data;
      }
      let expr = data;
      const segments = jsonPointer.split("/");
      for (const segment of segments) {
        if (segment) {
          data = (0, codegen_1._)`${data}${(0, codegen_1.getProperty)((0, util_1.unescapeJsonPointer)(segment))}`;
          expr = (0, codegen_1._)`${expr} && ${data}`;
        }
      }
      return expr;
      function errorMsg(pointerType, up) {
        return `Cannot access ${pointerType} ${up} levels up, current level is ${dataLevel}`;
      }
    }
    exports2.getData = getData;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/runtime/validation_error.js
var require_validation_error = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/runtime/validation_error.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var ValidationError = class extends Error {
      constructor(errors) {
        super("validation failed");
        this.errors = errors;
        this.ajv = this.validation = true;
      }
    };
    exports2.default = ValidationError;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/ref_error.js
var require_ref_error = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/ref_error.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var resolve_1 = require_resolve();
    var MissingRefError = class extends Error {
      constructor(resolver, baseId, ref, msg) {
        super(msg || `can't resolve reference ${ref} from id ${baseId}`);
        this.missingRef = (0, resolve_1.resolveUrl)(resolver, baseId, ref);
        this.missingSchema = (0, resolve_1.normalizeId)((0, resolve_1.getFullPath)(resolver, this.missingRef));
      }
    };
    exports2.default = MissingRefError;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/index.js
var require_compile = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.resolveSchema = exports2.getCompilingSchema = exports2.resolveRef = exports2.compileSchema = exports2.SchemaEnv = void 0;
    var codegen_1 = require_codegen();
    var validation_error_1 = require_validation_error();
    var names_1 = require_names();
    var resolve_1 = require_resolve();
    var util_1 = require_util();
    var validate_1 = require_validate();
    var SchemaEnv = class {
      constructor(env) {
        var _a;
        this.refs = {};
        this.dynamicAnchors = {};
        let schema2;
        if (typeof env.schema == "object")
          schema2 = env.schema;
        this.schema = env.schema;
        this.schemaId = env.schemaId;
        this.root = env.root || this;
        this.baseId = (_a = env.baseId) !== null && _a !== void 0 ? _a : (0, resolve_1.normalizeId)(schema2 === null || schema2 === void 0 ? void 0 : schema2[env.schemaId || "$id"]);
        this.schemaPath = env.schemaPath;
        this.localRefs = env.localRefs;
        this.meta = env.meta;
        this.$async = schema2 === null || schema2 === void 0 ? void 0 : schema2.$async;
        this.refs = {};
      }
    };
    exports2.SchemaEnv = SchemaEnv;
    function compileSchema(sch) {
      const _sch = getCompilingSchema.call(this, sch);
      if (_sch)
        return _sch;
      const rootId = (0, resolve_1.getFullPath)(this.opts.uriResolver, sch.root.baseId);
      const { es5, lines } = this.opts.code;
      const { ownProperties } = this.opts;
      const gen = new codegen_1.CodeGen(this.scope, { es5, lines, ownProperties });
      let _ValidationError;
      if (sch.$async) {
        _ValidationError = gen.scopeValue("Error", {
          ref: validation_error_1.default,
          code: (0, codegen_1._)`require("ajv/dist/runtime/validation_error").default`
        });
      }
      const validateName3 = gen.scopeName("validate");
      sch.validateName = validateName3;
      const schemaCxt = {
        gen,
        allErrors: this.opts.allErrors,
        data: names_1.default.data,
        parentData: names_1.default.parentData,
        parentDataProperty: names_1.default.parentDataProperty,
        dataNames: [names_1.default.data],
        dataPathArr: [codegen_1.nil],
        dataLevel: 0,
        dataTypes: [],
        definedProperties: /* @__PURE__ */ new Set(),
        topSchemaRef: gen.scopeValue("schema", this.opts.code.source === true ? { ref: sch.schema, code: (0, codegen_1.stringify)(sch.schema) } : { ref: sch.schema }),
        validateName: validateName3,
        ValidationError: _ValidationError,
        schema: sch.schema,
        schemaEnv: sch,
        rootId,
        baseId: sch.baseId || rootId,
        schemaPath: codegen_1.nil,
        errSchemaPath: sch.schemaPath || (this.opts.jtd ? "" : "#"),
        errorPath: (0, codegen_1._)`""`,
        opts: this.opts,
        self: this
      };
      let sourceCode;
      try {
        this._compilations.add(sch);
        (0, validate_1.validateFunctionCode)(schemaCxt);
        gen.optimize(this.opts.code.optimize);
        const validateCode = gen.toString();
        sourceCode = `const visitedNodesForRef = new WeakMap(); ${gen.scopeRefs(names_1.default.scope)}return ${validateCode}`;
        if (this.opts.code.process)
          sourceCode = this.opts.code.process(sourceCode, sch);
        const makeValidate = new Function(`${names_1.default.self}`, `${names_1.default.scope}`, sourceCode);
        const validate = makeValidate(this, this.scope.get());
        this.scope.value(validateName3, { ref: validate });
        validate.errors = null;
        validate.schema = sch.schema;
        validate.schemaEnv = sch;
        if (sch.$async)
          validate.$async = true;
        if (this.opts.code.source === true) {
          validate.source = { validateName: validateName3, validateCode, scopeValues: gen._values };
        }
        if (this.opts.unevaluated) {
          const { props, items } = schemaCxt;
          validate.evaluated = {
            props: props instanceof codegen_1.Name ? void 0 : props,
            items: items instanceof codegen_1.Name ? void 0 : items,
            dynamicProps: props instanceof codegen_1.Name,
            dynamicItems: items instanceof codegen_1.Name
          };
          if (validate.source)
            validate.source.evaluated = (0, codegen_1.stringify)(validate.evaluated);
        }
        sch.validate = validate;
        return sch;
      } catch (e) {
        delete sch.validate;
        delete sch.validateName;
        if (sourceCode)
          this.logger.error("Error compiling schema, function code:", sourceCode);
        throw e;
      } finally {
        this._compilations.delete(sch);
      }
    }
    exports2.compileSchema = compileSchema;
    function resolveRef(root2, baseId, origRef) {
      var _a;
      const ref = (0, resolve_1.resolveUrl)(this.opts.uriResolver, baseId, origRef);
      const schOrFunc = root2.refs[ref];
      if (schOrFunc)
        return schOrFunc;
      let _sch = resolve.call(this, root2, ref);
      if (_sch === void 0) {
        const schema2 = (_a = root2.localRefs) === null || _a === void 0 ? void 0 : _a[ref];
        const { schemaId } = this.opts;
        if (schema2)
          _sch = new SchemaEnv({ schema: schema2, schemaId, root: root2, baseId });
      }
      if (_sch === void 0 && this.opts.loadSchemaSync) {
        const remoteSchema = this.opts.loadSchemaSync(baseId, origRef, ref);
        if (remoteSchema && !(this.refs[ref] || this.schemas[ref])) {
          this.addSchema(remoteSchema, ref, void 0);
          _sch = resolve.call(this, root2, ref);
        }
      }
      if (_sch === void 0)
        return;
      return root2.refs[ref] = inlineOrCompile.call(this, _sch);
    }
    exports2.resolveRef = resolveRef;
    function inlineOrCompile(sch) {
      if ((0, resolve_1.inlineRef)(sch.schema, this.opts.inlineRefs))
        return sch.schema;
      return sch.validate ? sch : compileSchema.call(this, sch);
    }
    function getCompilingSchema(schEnv) {
      for (const sch of this._compilations) {
        if (sameSchemaEnv(sch, schEnv))
          return sch;
      }
    }
    exports2.getCompilingSchema = getCompilingSchema;
    function sameSchemaEnv(s1, s2) {
      return s1.schema === s2.schema && s1.root === s2.root && s1.baseId === s2.baseId;
    }
    function resolve(root2, ref) {
      let sch;
      while (typeof (sch = this.refs[ref]) == "string")
        ref = sch;
      return sch || this.schemas[ref] || resolveSchema2.call(this, root2, ref);
    }
    function resolveSchema2(root2, ref) {
      const p = this.opts.uriResolver.parse(ref);
      const refPath = (0, resolve_1._getFullPath)(this.opts.uriResolver, p);
      let baseId = (0, resolve_1.getFullPath)(this.opts.uriResolver, root2.baseId, void 0);
      if (Object.keys(root2.schema).length > 0 && refPath === baseId) {
        return getJsonPointer.call(this, p, root2);
      }
      const id = (0, resolve_1.normalizeId)(refPath);
      const schOrRef = this.refs[id] || this.schemas[id];
      if (typeof schOrRef == "string") {
        const sch = resolveSchema2.call(this, root2, schOrRef);
        if (typeof (sch === null || sch === void 0 ? void 0 : sch.schema) !== "object")
          return;
        return getJsonPointer.call(this, p, sch);
      }
      if (typeof (schOrRef === null || schOrRef === void 0 ? void 0 : schOrRef.schema) !== "object")
        return;
      if (!schOrRef.validate)
        compileSchema.call(this, schOrRef);
      if (id === (0, resolve_1.normalizeId)(ref)) {
        const { schema: schema2 } = schOrRef;
        const { schemaId } = this.opts;
        const schId = schema2[schemaId];
        if (schId)
          baseId = (0, resolve_1.resolveUrl)(this.opts.uriResolver, baseId, schId);
        return new SchemaEnv({ schema: schema2, schemaId, root: root2, baseId });
      }
      return getJsonPointer.call(this, p, schOrRef);
    }
    exports2.resolveSchema = resolveSchema2;
    var PREVENT_SCOPE_CHANGE = /* @__PURE__ */ new Set([
      "properties",
      "patternProperties",
      "enum",
      "dependencies",
      "definitions"
    ]);
    function getJsonPointer(parsedRef, { baseId, schema: schema2, root: root2 }) {
      var _a;
      if (((_a = parsedRef.fragment) === null || _a === void 0 ? void 0 : _a[0]) !== "/")
        return;
      for (const part of parsedRef.fragment.slice(1).split("/")) {
        if (typeof schema2 === "boolean")
          return;
        const partSchema = schema2[(0, util_1.unescapeFragment)(part)];
        if (partSchema === void 0)
          return;
        schema2 = partSchema;
        const schId = typeof schema2 === "object" && schema2[this.opts.schemaId];
        if (!PREVENT_SCOPE_CHANGE.has(part) && schId) {
          baseId = (0, resolve_1.resolveUrl)(this.opts.uriResolver, baseId, schId);
        }
      }
      let env;
      if (typeof schema2 != "boolean" && schema2.$ref && !(0, util_1.schemaHasRulesButRef)(schema2, this.RULES)) {
        const $ref = (0, resolve_1.resolveUrl)(this.opts.uriResolver, baseId, schema2.$ref);
        env = resolveSchema2.call(this, root2, $ref);
      }
      const { schemaId } = this.opts;
      env = env || new SchemaEnv({ schema: schema2, schemaId, root: root2, baseId });
      if (env.schema !== env.root.schema)
        return env;
      return void 0;
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/data.json
var require_data = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/data.json"(exports2, module2) {
    module2.exports = {
      $id: "https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#",
      description: "Meta-schema for $data reference (JSON AnySchema extension proposal)",
      type: "object",
      required: ["$data"],
      properties: {
        $data: {
          type: "string",
          anyOf: [{ format: "relative-json-pointer" }, { format: "json-pointer" }]
        }
      },
      additionalProperties: false
    };
  }
});

// ../../../node_modules/.pnpm/uri-js@4.4.1/node_modules/uri-js/dist/es5/uri.all.js
var require_uri_all = __commonJS({
  "../../../node_modules/.pnpm/uri-js@4.4.1/node_modules/uri-js/dist/es5/uri.all.js"(exports2, module2) {
    "use strict";
    (function(global2, factory) {
      typeof exports2 === "object" && typeof module2 !== "undefined" ? factory(exports2) : typeof define === "function" && define.amd ? define(["exports"], factory) : factory(global2.URI = global2.URI || {});
    })(exports2, function(exports3) {
      "use strict";
      function merge3() {
        for (var _len = arguments.length, sets = Array(_len), _key = 0; _key < _len; _key++) {
          sets[_key] = arguments[_key];
        }
        if (sets.length > 1) {
          sets[0] = sets[0].slice(0, -1);
          var xl = sets.length - 1;
          for (var x = 1; x < xl; ++x) {
            sets[x] = sets[x].slice(1, -1);
          }
          sets[xl] = sets[xl].slice(1);
          return sets.join("");
        } else {
          return sets[0];
        }
      }
      function subexp(str2) {
        return "(?:" + str2 + ")";
      }
      function typeOf(o) {
        return o === void 0 ? "undefined" : o === null ? "null" : Object.prototype.toString.call(o).split(" ").pop().split("]").shift().toLowerCase();
      }
      function toUpperCase(str2) {
        return str2.toUpperCase();
      }
      function toArray2(obj) {
        return obj !== void 0 && obj !== null ? obj instanceof Array ? obj : typeof obj.length !== "number" || obj.split || obj.setInterval || obj.call ? [obj] : Array.prototype.slice.call(obj) : [];
      }
      function assign(target, source) {
        var obj = target;
        if (source) {
          for (var key in source) {
            obj[key] = source[key];
          }
        }
        return obj;
      }
      function buildExps(isIRI2) {
        var ALPHA$$ = "[A-Za-z]", CR$ = "[\\x0D]", DIGIT$$ = "[0-9]", DQUOTE$$ = "[\\x22]", HEXDIG$$2 = merge3(DIGIT$$, "[A-Fa-f]"), LF$$ = "[\\x0A]", SP$$ = "[\\x20]", PCT_ENCODED$2 = subexp(subexp("%[EFef]" + HEXDIG$$2 + "%" + HEXDIG$$2 + HEXDIG$$2 + "%" + HEXDIG$$2 + HEXDIG$$2) + "|" + subexp("%[89A-Fa-f]" + HEXDIG$$2 + "%" + HEXDIG$$2 + HEXDIG$$2) + "|" + subexp("%" + HEXDIG$$2 + HEXDIG$$2)), GEN_DELIMS$$ = "[\\:\\/\\?\\#\\[\\]\\@]", SUB_DELIMS$$ = "[\\!\\$\\&\\'\\(\\)\\*\\+\\,\\;\\=]", RESERVED$$ = merge3(GEN_DELIMS$$, SUB_DELIMS$$), UCSCHAR$$ = isIRI2 ? "[\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF]" : "[]", IPRIVATE$$ = isIRI2 ? "[\\uE000-\\uF8FF]" : "[]", UNRESERVED$$2 = merge3(ALPHA$$, DIGIT$$, "[\\-\\.\\_\\~]", UCSCHAR$$), SCHEME$ = subexp(ALPHA$$ + merge3(ALPHA$$, DIGIT$$, "[\\+\\-\\.]") + "*"), USERINFO$ = subexp(subexp(PCT_ENCODED$2 + "|" + merge3(UNRESERVED$$2, SUB_DELIMS$$, "[\\:]")) + "*"), DEC_OCTET$ = subexp(subexp("25[0-5]") + "|" + subexp("2[0-4]" + DIGIT$$) + "|" + subexp("1" + DIGIT$$ + DIGIT$$) + "|" + subexp("[1-9]" + DIGIT$$) + "|" + DIGIT$$), DEC_OCTET_RELAXED$ = subexp(subexp("25[0-5]") + "|" + subexp("2[0-4]" + DIGIT$$) + "|" + subexp("1" + DIGIT$$ + DIGIT$$) + "|" + subexp("0?[1-9]" + DIGIT$$) + "|0?0?" + DIGIT$$), IPV4ADDRESS$ = subexp(DEC_OCTET_RELAXED$ + "\\." + DEC_OCTET_RELAXED$ + "\\." + DEC_OCTET_RELAXED$ + "\\." + DEC_OCTET_RELAXED$), H16$ = subexp(HEXDIG$$2 + "{1,4}"), LS32$ = subexp(subexp(H16$ + "\\:" + H16$) + "|" + IPV4ADDRESS$), IPV6ADDRESS1$ = subexp(subexp(H16$ + "\\:") + "{6}" + LS32$), IPV6ADDRESS2$ = subexp("\\:\\:" + subexp(H16$ + "\\:") + "{5}" + LS32$), IPV6ADDRESS3$ = subexp(subexp(H16$) + "?\\:\\:" + subexp(H16$ + "\\:") + "{4}" + LS32$), IPV6ADDRESS4$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,1}" + H16$) + "?\\:\\:" + subexp(H16$ + "\\:") + "{3}" + LS32$), IPV6ADDRESS5$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,2}" + H16$) + "?\\:\\:" + subexp(H16$ + "\\:") + "{2}" + LS32$), IPV6ADDRESS6$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,3}" + H16$) + "?\\:\\:" + H16$ + "\\:" + LS32$), IPV6ADDRESS7$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,4}" + H16$) + "?\\:\\:" + LS32$), IPV6ADDRESS8$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,5}" + H16$) + "?\\:\\:" + H16$), IPV6ADDRESS9$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,6}" + H16$) + "?\\:\\:"), IPV6ADDRESS$ = subexp([IPV6ADDRESS1$, IPV6ADDRESS2$, IPV6ADDRESS3$, IPV6ADDRESS4$, IPV6ADDRESS5$, IPV6ADDRESS6$, IPV6ADDRESS7$, IPV6ADDRESS8$, IPV6ADDRESS9$].join("|")), ZONEID$ = subexp(subexp(UNRESERVED$$2 + "|" + PCT_ENCODED$2) + "+"), IPV6ADDRZ$ = subexp(IPV6ADDRESS$ + "\\%25" + ZONEID$), IPV6ADDRZ_RELAXED$ = subexp(IPV6ADDRESS$ + subexp("\\%25|\\%(?!" + HEXDIG$$2 + "{2})") + ZONEID$), IPVFUTURE$ = subexp("[vV]" + HEXDIG$$2 + "+\\." + merge3(UNRESERVED$$2, SUB_DELIMS$$, "[\\:]") + "+"), IP_LITERAL$ = subexp("\\[" + subexp(IPV6ADDRZ_RELAXED$ + "|" + IPV6ADDRESS$ + "|" + IPVFUTURE$) + "\\]"), REG_NAME$ = subexp(subexp(PCT_ENCODED$2 + "|" + merge3(UNRESERVED$$2, SUB_DELIMS$$)) + "*"), HOST$ = subexp(IP_LITERAL$ + "|" + IPV4ADDRESS$ + "(?!" + REG_NAME$ + ")|" + REG_NAME$), PORT$ = subexp(DIGIT$$ + "*"), AUTHORITY$ = subexp(subexp(USERINFO$ + "@") + "?" + HOST$ + subexp("\\:" + PORT$) + "?"), PCHAR$ = subexp(PCT_ENCODED$2 + "|" + merge3(UNRESERVED$$2, SUB_DELIMS$$, "[\\:\\@]")), SEGMENT$ = subexp(PCHAR$ + "*"), SEGMENT_NZ$ = subexp(PCHAR$ + "+"), SEGMENT_NZ_NC$ = subexp(subexp(PCT_ENCODED$2 + "|" + merge3(UNRESERVED$$2, SUB_DELIMS$$, "[\\@]")) + "+"), PATH_ABEMPTY$ = subexp(subexp("\\/" + SEGMENT$) + "*"), PATH_ABSOLUTE$ = subexp("\\/" + subexp(SEGMENT_NZ$ + PATH_ABEMPTY$) + "?"), PATH_NOSCHEME$ = subexp(SEGMENT_NZ_NC$ + PATH_ABEMPTY$), PATH_ROOTLESS$ = subexp(SEGMENT_NZ$ + PATH_ABEMPTY$), PATH_EMPTY$ = "(?!" + PCHAR$ + ")", PATH$ = subexp(PATH_ABEMPTY$ + "|" + PATH_ABSOLUTE$ + "|" + PATH_NOSCHEME$ + "|" + PATH_ROOTLESS$ + "|" + PATH_EMPTY$), QUERY$ = subexp(subexp(PCHAR$ + "|" + merge3("[\\/\\?]", IPRIVATE$$)) + "*"), FRAGMENT$ = subexp(subexp(PCHAR$ + "|[\\/\\?]") + "*"), HIER_PART$ = subexp(subexp("\\/\\/" + AUTHORITY$ + PATH_ABEMPTY$) + "|" + PATH_ABSOLUTE$ + "|" + PATH_ROOTLESS$ + "|" + PATH_EMPTY$), URI$ = subexp(SCHEME$ + "\\:" + HIER_PART$ + subexp("\\?" + QUERY$) + "?" + subexp("\\#" + FRAGMENT$) + "?"), RELATIVE_PART$ = subexp(subexp("\\/\\/" + AUTHORITY$ + PATH_ABEMPTY$) + "|" + PATH_ABSOLUTE$ + "|" + PATH_NOSCHEME$ + "|" + PATH_EMPTY$), RELATIVE$ = subexp(RELATIVE_PART$ + subexp("\\?" + QUERY$) + "?" + subexp("\\#" + FRAGMENT$) + "?"), URI_REFERENCE$ = subexp(URI$ + "|" + RELATIVE$), ABSOLUTE_URI$ = subexp(SCHEME$ + "\\:" + HIER_PART$ + subexp("\\?" + QUERY$) + "?"), GENERIC_REF$ = "^(" + SCHEME$ + ")\\:" + subexp(subexp("\\/\\/(" + subexp("(" + USERINFO$ + ")@") + "?(" + HOST$ + ")" + subexp("\\:(" + PORT$ + ")") + "?)") + "?(" + PATH_ABEMPTY$ + "|" + PATH_ABSOLUTE$ + "|" + PATH_ROOTLESS$ + "|" + PATH_EMPTY$ + ")") + subexp("\\?(" + QUERY$ + ")") + "?" + subexp("\\#(" + FRAGMENT$ + ")") + "?$", RELATIVE_REF$ = "^(){0}" + subexp(subexp("\\/\\/(" + subexp("(" + USERINFO$ + ")@") + "?(" + HOST$ + ")" + subexp("\\:(" + PORT$ + ")") + "?)") + "?(" + PATH_ABEMPTY$ + "|" + PATH_ABSOLUTE$ + "|" + PATH_NOSCHEME$ + "|" + PATH_EMPTY$ + ")") + subexp("\\?(" + QUERY$ + ")") + "?" + subexp("\\#(" + FRAGMENT$ + ")") + "?$", ABSOLUTE_REF$ = "^(" + SCHEME$ + ")\\:" + subexp(subexp("\\/\\/(" + subexp("(" + USERINFO$ + ")@") + "?(" + HOST$ + ")" + subexp("\\:(" + PORT$ + ")") + "?)") + "?(" + PATH_ABEMPTY$ + "|" + PATH_ABSOLUTE$ + "|" + PATH_ROOTLESS$ + "|" + PATH_EMPTY$ + ")") + subexp("\\?(" + QUERY$ + ")") + "?$", SAMEDOC_REF$ = "^" + subexp("\\#(" + FRAGMENT$ + ")") + "?$", AUTHORITY_REF$ = "^" + subexp("(" + USERINFO$ + ")@") + "?(" + HOST$ + ")" + subexp("\\:(" + PORT$ + ")") + "?$";
        return {
          NOT_SCHEME: new RegExp(merge3("[^]", ALPHA$$, DIGIT$$, "[\\+\\-\\.]"), "g"),
          NOT_USERINFO: new RegExp(merge3("[^\\%\\:]", UNRESERVED$$2, SUB_DELIMS$$), "g"),
          NOT_HOST: new RegExp(merge3("[^\\%\\[\\]\\:]", UNRESERVED$$2, SUB_DELIMS$$), "g"),
          NOT_PATH: new RegExp(merge3("[^\\%\\/\\:\\@]", UNRESERVED$$2, SUB_DELIMS$$), "g"),
          NOT_PATH_NOSCHEME: new RegExp(merge3("[^\\%\\/\\@]", UNRESERVED$$2, SUB_DELIMS$$), "g"),
          NOT_QUERY: new RegExp(merge3("[^\\%]", UNRESERVED$$2, SUB_DELIMS$$, "[\\:\\@\\/\\?]", IPRIVATE$$), "g"),
          NOT_FRAGMENT: new RegExp(merge3("[^\\%]", UNRESERVED$$2, SUB_DELIMS$$, "[\\:\\@\\/\\?]"), "g"),
          ESCAPE: new RegExp(merge3("[^]", UNRESERVED$$2, SUB_DELIMS$$), "g"),
          UNRESERVED: new RegExp(UNRESERVED$$2, "g"),
          OTHER_CHARS: new RegExp(merge3("[^\\%]", UNRESERVED$$2, RESERVED$$), "g"),
          PCT_ENCODED: new RegExp(PCT_ENCODED$2, "g"),
          IPV4ADDRESS: new RegExp("^(" + IPV4ADDRESS$ + ")$"),
          IPV6ADDRESS: new RegExp("^\\[?(" + IPV6ADDRESS$ + ")" + subexp(subexp("\\%25|\\%(?!" + HEXDIG$$2 + "{2})") + "(" + ZONEID$ + ")") + "?\\]?$")
          //RFC 6874, with relaxed parsing rules
        };
      }
      var URI_PROTOCOL = buildExps(false);
      var IRI_PROTOCOL = buildExps(true);
      var slicedToArray = /* @__PURE__ */ function() {
        function sliceIterator(arr, i) {
          var _arr = [];
          var _n = true;
          var _d = false;
          var _e = void 0;
          try {
            for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
              _arr.push(_s.value);
              if (i && _arr.length === i) break;
            }
          } catch (err) {
            _d = true;
            _e = err;
          } finally {
            try {
              if (!_n && _i["return"]) _i["return"]();
            } finally {
              if (_d) throw _e;
            }
          }
          return _arr;
        }
        return function(arr, i) {
          if (Array.isArray(arr)) {
            return arr;
          } else if (Symbol.iterator in Object(arr)) {
            return sliceIterator(arr, i);
          } else {
            throw new TypeError("Invalid attempt to destructure non-iterable instance");
          }
        };
      }();
      var toConsumableArray = function(arr) {
        if (Array.isArray(arr)) {
          for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];
          return arr2;
        } else {
          return Array.from(arr);
        }
      };
      var maxInt = 2147483647;
      var base = 36;
      var tMin = 1;
      var tMax = 26;
      var skew = 38;
      var damp = 700;
      var initialBias = 72;
      var initialN = 128;
      var delimiter = "-";
      var regexPunycode = /^xn--/;
      var regexNonASCII = /[^\0-\x7E]/;
      var regexSeparators = /[\x2E\u3002\uFF0E\uFF61]/g;
      var errors = {
        "overflow": "Overflow: input needs wider integers to process",
        "not-basic": "Illegal input >= 0x80 (not a basic code point)",
        "invalid-input": "Invalid input"
      };
      var baseMinusTMin = base - tMin;
      var floor = Math.floor;
      var stringFromCharCode = String.fromCharCode;
      function error$1(type2) {
        throw new RangeError(errors[type2]);
      }
      function map2(array, fn) {
        var result = [];
        var length = array.length;
        while (length--) {
          result[length] = fn(array[length]);
        }
        return result;
      }
      function mapDomain(string3, fn) {
        var parts = string3.split("@");
        var result = "";
        if (parts.length > 1) {
          result = parts[0] + "@";
          string3 = parts[1];
        }
        string3 = string3.replace(regexSeparators, ".");
        var labels = string3.split(".");
        var encoded = map2(labels, fn).join(".");
        return result + encoded;
      }
      function ucs2decode(string3) {
        var output = [];
        var counter = 0;
        var length = string3.length;
        while (counter < length) {
          var value = string3.charCodeAt(counter++);
          if (value >= 55296 && value <= 56319 && counter < length) {
            var extra = string3.charCodeAt(counter++);
            if ((extra & 64512) == 56320) {
              output.push(((value & 1023) << 10) + (extra & 1023) + 65536);
            } else {
              output.push(value);
              counter--;
            }
          } else {
            output.push(value);
          }
        }
        return output;
      }
      var ucs2encode = function ucs2encode2(array) {
        return String.fromCodePoint.apply(String, toConsumableArray(array));
      };
      var basicToDigit = function basicToDigit2(codePoint) {
        if (codePoint - 48 < 10) {
          return codePoint - 22;
        }
        if (codePoint - 65 < 26) {
          return codePoint - 65;
        }
        if (codePoint - 97 < 26) {
          return codePoint - 97;
        }
        return base;
      };
      var digitToBasic = function digitToBasic2(digit, flag) {
        return digit + 22 + 75 * (digit < 26) - ((flag != 0) << 5);
      };
      var adapt = function adapt2(delta, numPoints, firstTime) {
        var k = 0;
        delta = firstTime ? floor(delta / damp) : delta >> 1;
        delta += floor(delta / numPoints);
        for (
          ;
          /* no initialization */
          delta > baseMinusTMin * tMax >> 1;
          k += base
        ) {
          delta = floor(delta / baseMinusTMin);
        }
        return floor(k + (baseMinusTMin + 1) * delta / (delta + skew));
      };
      var decode = function decode2(input) {
        var output = [];
        var inputLength = input.length;
        var i = 0;
        var n = initialN;
        var bias = initialBias;
        var basic = input.lastIndexOf(delimiter);
        if (basic < 0) {
          basic = 0;
        }
        for (var j = 0; j < basic; ++j) {
          if (input.charCodeAt(j) >= 128) {
            error$1("not-basic");
          }
          output.push(input.charCodeAt(j));
        }
        for (var index = basic > 0 ? basic + 1 : 0; index < inputLength; ) {
          var oldi = i;
          for (
            var w = 1, k = base;
            ;
            /* no condition */
            k += base
          ) {
            if (index >= inputLength) {
              error$1("invalid-input");
            }
            var digit = basicToDigit(input.charCodeAt(index++));
            if (digit >= base || digit > floor((maxInt - i) / w)) {
              error$1("overflow");
            }
            i += digit * w;
            var t = k <= bias ? tMin : k >= bias + tMax ? tMax : k - bias;
            if (digit < t) {
              break;
            }
            var baseMinusT = base - t;
            if (w > floor(maxInt / baseMinusT)) {
              error$1("overflow");
            }
            w *= baseMinusT;
          }
          var out = output.length + 1;
          bias = adapt(i - oldi, out, oldi == 0);
          if (floor(i / out) > maxInt - n) {
            error$1("overflow");
          }
          n += floor(i / out);
          i %= out;
          output.splice(i++, 0, n);
        }
        return String.fromCodePoint.apply(String, output);
      };
      var encode = function encode2(input) {
        var output = [];
        input = ucs2decode(input);
        var inputLength = input.length;
        var n = initialN;
        var delta = 0;
        var bias = initialBias;
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = void 0;
        try {
          for (var _iterator = input[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var _currentValue2 = _step.value;
            if (_currentValue2 < 128) {
              output.push(stringFromCharCode(_currentValue2));
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
        var basicLength = output.length;
        var handledCPCount = basicLength;
        if (basicLength) {
          output.push(delimiter);
        }
        while (handledCPCount < inputLength) {
          var m = maxInt;
          var _iteratorNormalCompletion2 = true;
          var _didIteratorError2 = false;
          var _iteratorError2 = void 0;
          try {
            for (var _iterator2 = input[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
              var currentValue = _step2.value;
              if (currentValue >= n && currentValue < m) {
                m = currentValue;
              }
            }
          } catch (err) {
            _didIteratorError2 = true;
            _iteratorError2 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
              }
            } finally {
              if (_didIteratorError2) {
                throw _iteratorError2;
              }
            }
          }
          var handledCPCountPlusOne = handledCPCount + 1;
          if (m - n > floor((maxInt - delta) / handledCPCountPlusOne)) {
            error$1("overflow");
          }
          delta += (m - n) * handledCPCountPlusOne;
          n = m;
          var _iteratorNormalCompletion3 = true;
          var _didIteratorError3 = false;
          var _iteratorError3 = void 0;
          try {
            for (var _iterator3 = input[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
              var _currentValue = _step3.value;
              if (_currentValue < n && ++delta > maxInt) {
                error$1("overflow");
              }
              if (_currentValue == n) {
                var q = delta;
                for (
                  var k = base;
                  ;
                  /* no condition */
                  k += base
                ) {
                  var t = k <= bias ? tMin : k >= bias + tMax ? tMax : k - bias;
                  if (q < t) {
                    break;
                  }
                  var qMinusT = q - t;
                  var baseMinusT = base - t;
                  output.push(stringFromCharCode(digitToBasic(t + qMinusT % baseMinusT, 0)));
                  q = floor(qMinusT / baseMinusT);
                }
                output.push(stringFromCharCode(digitToBasic(q, 0)));
                bias = adapt(delta, handledCPCountPlusOne, handledCPCount == basicLength);
                delta = 0;
                ++handledCPCount;
              }
            }
          } catch (err) {
            _didIteratorError3 = true;
            _iteratorError3 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion3 && _iterator3.return) {
                _iterator3.return();
              }
            } finally {
              if (_didIteratorError3) {
                throw _iteratorError3;
              }
            }
          }
          ++delta;
          ++n;
        }
        return output.join("");
      };
      var toUnicode = function toUnicode2(input) {
        return mapDomain(input, function(string3) {
          return regexPunycode.test(string3) ? decode(string3.slice(4).toLowerCase()) : string3;
        });
      };
      var toASCII = function toASCII2(input) {
        return mapDomain(input, function(string3) {
          return regexNonASCII.test(string3) ? "xn--" + encode(string3) : string3;
        });
      };
      var punycode = {
        /**
         * A string representing the current Punycode.js version number.
         * @memberOf punycode
         * @type String
         */
        "version": "2.1.0",
        /**
         * An object of methods to convert from JavaScript's internal character
         * representation (UCS-2) to Unicode code points, and back.
         * @see <https://mathiasbynens.be/notes/javascript-encoding>
         * @memberOf punycode
         * @type Object
         */
        "ucs2": {
          "decode": ucs2decode,
          "encode": ucs2encode
        },
        "decode": decode,
        "encode": encode,
        "toASCII": toASCII,
        "toUnicode": toUnicode
      };
      var SCHEMES = {};
      function pctEncChar(chr) {
        var c = chr.charCodeAt(0);
        var e = void 0;
        if (c < 16) e = "%0" + c.toString(16).toUpperCase();
        else if (c < 128) e = "%" + c.toString(16).toUpperCase();
        else if (c < 2048) e = "%" + (c >> 6 | 192).toString(16).toUpperCase() + "%" + (c & 63 | 128).toString(16).toUpperCase();
        else e = "%" + (c >> 12 | 224).toString(16).toUpperCase() + "%" + (c >> 6 & 63 | 128).toString(16).toUpperCase() + "%" + (c & 63 | 128).toString(16).toUpperCase();
        return e;
      }
      function pctDecChars(str2) {
        var newStr = "";
        var i = 0;
        var il = str2.length;
        while (i < il) {
          var c = parseInt(str2.substr(i + 1, 2), 16);
          if (c < 128) {
            newStr += String.fromCharCode(c);
            i += 3;
          } else if (c >= 194 && c < 224) {
            if (il - i >= 6) {
              var c2 = parseInt(str2.substr(i + 4, 2), 16);
              newStr += String.fromCharCode((c & 31) << 6 | c2 & 63);
            } else {
              newStr += str2.substr(i, 6);
            }
            i += 6;
          } else if (c >= 224) {
            if (il - i >= 9) {
              var _c = parseInt(str2.substr(i + 4, 2), 16);
              var c3 = parseInt(str2.substr(i + 7, 2), 16);
              newStr += String.fromCharCode((c & 15) << 12 | (_c & 63) << 6 | c3 & 63);
            } else {
              newStr += str2.substr(i, 9);
            }
            i += 9;
          } else {
            newStr += str2.substr(i, 3);
            i += 3;
          }
        }
        return newStr;
      }
      function _normalizeComponentEncoding(components, protocol) {
        function decodeUnreserved2(str2) {
          var decStr = pctDecChars(str2);
          return !decStr.match(protocol.UNRESERVED) ? str2 : decStr;
        }
        if (components.scheme) components.scheme = String(components.scheme).replace(protocol.PCT_ENCODED, decodeUnreserved2).toLowerCase().replace(protocol.NOT_SCHEME, "");
        if (components.userinfo !== void 0) components.userinfo = String(components.userinfo).replace(protocol.PCT_ENCODED, decodeUnreserved2).replace(protocol.NOT_USERINFO, pctEncChar).replace(protocol.PCT_ENCODED, toUpperCase);
        if (components.host !== void 0) components.host = String(components.host).replace(protocol.PCT_ENCODED, decodeUnreserved2).toLowerCase().replace(protocol.NOT_HOST, pctEncChar).replace(protocol.PCT_ENCODED, toUpperCase);
        if (components.path !== void 0) components.path = String(components.path).replace(protocol.PCT_ENCODED, decodeUnreserved2).replace(components.scheme ? protocol.NOT_PATH : protocol.NOT_PATH_NOSCHEME, pctEncChar).replace(protocol.PCT_ENCODED, toUpperCase);
        if (components.query !== void 0) components.query = String(components.query).replace(protocol.PCT_ENCODED, decodeUnreserved2).replace(protocol.NOT_QUERY, pctEncChar).replace(protocol.PCT_ENCODED, toUpperCase);
        if (components.fragment !== void 0) components.fragment = String(components.fragment).replace(protocol.PCT_ENCODED, decodeUnreserved2).replace(protocol.NOT_FRAGMENT, pctEncChar).replace(protocol.PCT_ENCODED, toUpperCase);
        return components;
      }
      function _stripLeadingZeros(str2) {
        return str2.replace(/^0*(.*)/, "$1") || "0";
      }
      function _normalizeIPv4(host, protocol) {
        var matches = host.match(protocol.IPV4ADDRESS) || [];
        var _matches = slicedToArray(matches, 2), address = _matches[1];
        if (address) {
          return address.split(".").map(_stripLeadingZeros).join(".");
        } else {
          return host;
        }
      }
      function _normalizeIPv6(host, protocol) {
        var matches = host.match(protocol.IPV6ADDRESS) || [];
        var _matches2 = slicedToArray(matches, 3), address = _matches2[1], zone = _matches2[2];
        if (address) {
          var _address$toLowerCase$ = address.toLowerCase().split("::").reverse(), _address$toLowerCase$2 = slicedToArray(_address$toLowerCase$, 2), last = _address$toLowerCase$2[0], first = _address$toLowerCase$2[1];
          var firstFields = first ? first.split(":").map(_stripLeadingZeros) : [];
          var lastFields = last.split(":").map(_stripLeadingZeros);
          var isLastFieldIPv4Address = protocol.IPV4ADDRESS.test(lastFields[lastFields.length - 1]);
          var fieldCount = isLastFieldIPv4Address ? 7 : 8;
          var lastFieldsStart = lastFields.length - fieldCount;
          var fields = Array(fieldCount);
          for (var x = 0; x < fieldCount; ++x) {
            fields[x] = firstFields[x] || lastFields[lastFieldsStart + x] || "";
          }
          if (isLastFieldIPv4Address) {
            fields[fieldCount - 1] = _normalizeIPv4(fields[fieldCount - 1], protocol);
          }
          var allZeroFields = fields.reduce(function(acc, field, index) {
            if (!field || field === "0") {
              var lastLongest = acc[acc.length - 1];
              if (lastLongest && lastLongest.index + lastLongest.length === index) {
                lastLongest.length++;
              } else {
                acc.push({ index, length: 1 });
              }
            }
            return acc;
          }, []);
          var longestZeroFields = allZeroFields.sort(function(a, b) {
            return b.length - a.length;
          })[0];
          var newHost = void 0;
          if (longestZeroFields && longestZeroFields.length > 1) {
            var newFirst = fields.slice(0, longestZeroFields.index);
            var newLast = fields.slice(longestZeroFields.index + longestZeroFields.length);
            newHost = newFirst.join(":") + "::" + newLast.join(":");
          } else {
            newHost = fields.join(":");
          }
          if (zone) {
            newHost += "%" + zone;
          }
          return newHost;
        } else {
          return host;
        }
      }
      var URI_PARSE = /^(?:([^:\/?#]+):)?(?:\/\/((?:([^\/?#@]*)@)?(\[[^\/?#\]]+\]|[^\/?#:]*)(?:\:(\d*))?))?([^?#]*)(?:\?([^#]*))?(?:#((?:.|\n|\r)*))?/i;
      var NO_MATCH_IS_UNDEFINED = "".match(/(){0}/)[1] === void 0;
      function parse2(uriString) {
        var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        var components = {};
        var protocol = options.iri !== false ? IRI_PROTOCOL : URI_PROTOCOL;
        if (options.reference === "suffix") uriString = (options.scheme ? options.scheme + ":" : "") + "//" + uriString;
        var matches = uriString.match(URI_PARSE);
        if (matches) {
          if (NO_MATCH_IS_UNDEFINED) {
            components.scheme = matches[1];
            components.userinfo = matches[3];
            components.host = matches[4];
            components.port = parseInt(matches[5], 10);
            components.path = matches[6] || "";
            components.query = matches[7];
            components.fragment = matches[8];
            if (isNaN(components.port)) {
              components.port = matches[5];
            }
          } else {
            components.scheme = matches[1] || void 0;
            components.userinfo = uriString.indexOf("@") !== -1 ? matches[3] : void 0;
            components.host = uriString.indexOf("//") !== -1 ? matches[4] : void 0;
            components.port = parseInt(matches[5], 10);
            components.path = matches[6] || "";
            components.query = uriString.indexOf("?") !== -1 ? matches[7] : void 0;
            components.fragment = uriString.indexOf("#") !== -1 ? matches[8] : void 0;
            if (isNaN(components.port)) {
              components.port = uriString.match(/\/\/(?:.|\n)*\:(?:\/|\?|\#|$)/) ? matches[4] : void 0;
            }
          }
          if (components.host) {
            components.host = _normalizeIPv6(_normalizeIPv4(components.host, protocol), protocol);
          }
          if (components.scheme === void 0 && components.userinfo === void 0 && components.host === void 0 && components.port === void 0 && !components.path && components.query === void 0) {
            components.reference = "same-document";
          } else if (components.scheme === void 0) {
            components.reference = "relative";
          } else if (components.fragment === void 0) {
            components.reference = "absolute";
          } else {
            components.reference = "uri";
          }
          if (options.reference && options.reference !== "suffix" && options.reference !== components.reference) {
            components.error = components.error || "URI is not a " + options.reference + " reference.";
          }
          var schemeHandler = SCHEMES[(options.scheme || components.scheme || "").toLowerCase()];
          if (!options.unicodeSupport && (!schemeHandler || !schemeHandler.unicodeSupport)) {
            if (components.host && (options.domainHost || schemeHandler && schemeHandler.domainHost)) {
              try {
                components.host = punycode.toASCII(components.host.replace(protocol.PCT_ENCODED, pctDecChars).toLowerCase());
              } catch (e) {
                components.error = components.error || "Host's domain name can not be converted to ASCII via punycode: " + e;
              }
            }
            _normalizeComponentEncoding(components, URI_PROTOCOL);
          } else {
            _normalizeComponentEncoding(components, protocol);
          }
          if (schemeHandler && schemeHandler.parse) {
            schemeHandler.parse(components, options);
          }
        } else {
          components.error = components.error || "URI can not be parsed.";
        }
        return components;
      }
      function _recomposeAuthority(components, options) {
        var protocol = options.iri !== false ? IRI_PROTOCOL : URI_PROTOCOL;
        var uriTokens = [];
        if (components.userinfo !== void 0) {
          uriTokens.push(components.userinfo);
          uriTokens.push("@");
        }
        if (components.host !== void 0) {
          uriTokens.push(_normalizeIPv6(_normalizeIPv4(String(components.host), protocol), protocol).replace(protocol.IPV6ADDRESS, function(_, $1, $2) {
            return "[" + $1 + ($2 ? "%25" + $2 : "") + "]";
          }));
        }
        if (typeof components.port === "number" || typeof components.port === "string") {
          uriTokens.push(":");
          uriTokens.push(String(components.port));
        }
        return uriTokens.length ? uriTokens.join("") : void 0;
      }
      var RDS1 = /^\.\.?\//;
      var RDS2 = /^\/\.(\/|$)/;
      var RDS3 = /^\/\.\.(\/|$)/;
      var RDS5 = /^\/?(?:.|\n)*?(?=\/|$)/;
      function removeDotSegments(input) {
        var output = [];
        while (input.length) {
          if (input.match(RDS1)) {
            input = input.replace(RDS1, "");
          } else if (input.match(RDS2)) {
            input = input.replace(RDS2, "/");
          } else if (input.match(RDS3)) {
            input = input.replace(RDS3, "/");
            output.pop();
          } else if (input === "." || input === "..") {
            input = "";
          } else {
            var im = input.match(RDS5);
            if (im) {
              var s = im[0];
              input = input.slice(s.length);
              output.push(s);
            } else {
              throw new Error("Unexpected dot segment condition");
            }
          }
        }
        return output.join("");
      }
      function serialize(components) {
        var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        var protocol = options.iri ? IRI_PROTOCOL : URI_PROTOCOL;
        var uriTokens = [];
        var schemeHandler = SCHEMES[(options.scheme || components.scheme || "").toLowerCase()];
        if (schemeHandler && schemeHandler.serialize) schemeHandler.serialize(components, options);
        if (components.host) {
          if (protocol.IPV6ADDRESS.test(components.host)) {
          } else if (options.domainHost || schemeHandler && schemeHandler.domainHost) {
            try {
              components.host = !options.iri ? punycode.toASCII(components.host.replace(protocol.PCT_ENCODED, pctDecChars).toLowerCase()) : punycode.toUnicode(components.host);
            } catch (e) {
              components.error = components.error || "Host's domain name can not be converted to " + (!options.iri ? "ASCII" : "Unicode") + " via punycode: " + e;
            }
          }
        }
        _normalizeComponentEncoding(components, protocol);
        if (options.reference !== "suffix" && components.scheme) {
          uriTokens.push(components.scheme);
          uriTokens.push(":");
        }
        var authority = _recomposeAuthority(components, options);
        if (authority !== void 0) {
          if (options.reference !== "suffix") {
            uriTokens.push("//");
          }
          uriTokens.push(authority);
          if (components.path && components.path.charAt(0) !== "/") {
            uriTokens.push("/");
          }
        }
        if (components.path !== void 0) {
          var s = components.path;
          if (!options.absolutePath && (!schemeHandler || !schemeHandler.absolutePath)) {
            s = removeDotSegments(s);
          }
          if (authority === void 0) {
            s = s.replace(/^\/\//, "/%2F");
          }
          uriTokens.push(s);
        }
        if (components.query !== void 0) {
          uriTokens.push("?");
          uriTokens.push(components.query);
        }
        if (components.fragment !== void 0) {
          uriTokens.push("#");
          uriTokens.push(components.fragment);
        }
        return uriTokens.join("");
      }
      function resolveComponents(base2, relative2) {
        var options = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
        var skipNormalization = arguments[3];
        var target = {};
        if (!skipNormalization) {
          base2 = parse2(serialize(base2, options), options);
          relative2 = parse2(serialize(relative2, options), options);
        }
        options = options || {};
        if (!options.tolerant && relative2.scheme) {
          target.scheme = relative2.scheme;
          target.userinfo = relative2.userinfo;
          target.host = relative2.host;
          target.port = relative2.port;
          target.path = removeDotSegments(relative2.path || "");
          target.query = relative2.query;
        } else {
          if (relative2.userinfo !== void 0 || relative2.host !== void 0 || relative2.port !== void 0) {
            target.userinfo = relative2.userinfo;
            target.host = relative2.host;
            target.port = relative2.port;
            target.path = removeDotSegments(relative2.path || "");
            target.query = relative2.query;
          } else {
            if (!relative2.path) {
              target.path = base2.path;
              if (relative2.query !== void 0) {
                target.query = relative2.query;
              } else {
                target.query = base2.query;
              }
            } else {
              if (relative2.path.charAt(0) === "/") {
                target.path = removeDotSegments(relative2.path);
              } else {
                if ((base2.userinfo !== void 0 || base2.host !== void 0 || base2.port !== void 0) && !base2.path) {
                  target.path = "/" + relative2.path;
                } else if (!base2.path) {
                  target.path = relative2.path;
                } else {
                  target.path = base2.path.slice(0, base2.path.lastIndexOf("/") + 1) + relative2.path;
                }
                target.path = removeDotSegments(target.path);
              }
              target.query = relative2.query;
            }
            target.userinfo = base2.userinfo;
            target.host = base2.host;
            target.port = base2.port;
          }
          target.scheme = base2.scheme;
        }
        target.fragment = relative2.fragment;
        return target;
      }
      function resolve(baseURI, relativeURI, options) {
        var schemelessOptions = assign({ scheme: "null" }, options);
        return serialize(resolveComponents(parse2(baseURI, schemelessOptions), parse2(relativeURI, schemelessOptions), schemelessOptions, true), schemelessOptions);
      }
      function normalize2(uri, options) {
        if (typeof uri === "string") {
          uri = serialize(parse2(uri, options), options);
        } else if (typeOf(uri) === "object") {
          uri = parse2(serialize(uri, options), options);
        }
        return uri;
      }
      function equal(uriA, uriB, options) {
        if (typeof uriA === "string") {
          uriA = serialize(parse2(uriA, options), options);
        } else if (typeOf(uriA) === "object") {
          uriA = serialize(uriA, options);
        }
        if (typeof uriB === "string") {
          uriB = serialize(parse2(uriB, options), options);
        } else if (typeOf(uriB) === "object") {
          uriB = serialize(uriB, options);
        }
        return uriA === uriB;
      }
      function escapeComponent(str2, options) {
        return str2 && str2.toString().replace(!options || !options.iri ? URI_PROTOCOL.ESCAPE : IRI_PROTOCOL.ESCAPE, pctEncChar);
      }
      function unescapeComponent(str2, options) {
        return str2 && str2.toString().replace(!options || !options.iri ? URI_PROTOCOL.PCT_ENCODED : IRI_PROTOCOL.PCT_ENCODED, pctDecChars);
      }
      var handler = {
        scheme: "http",
        domainHost: true,
        parse: function parse3(components, options) {
          if (!components.host) {
            components.error = components.error || "HTTP URIs must have a host.";
          }
          return components;
        },
        serialize: function serialize2(components, options) {
          var secure = String(components.scheme).toLowerCase() === "https";
          if (components.port === (secure ? 443 : 80) || components.port === "") {
            components.port = void 0;
          }
          if (!components.path) {
            components.path = "/";
          }
          return components;
        }
      };
      var handler$1 = {
        scheme: "https",
        domainHost: handler.domainHost,
        parse: handler.parse,
        serialize: handler.serialize
      };
      function isSecure(wsComponents) {
        return typeof wsComponents.secure === "boolean" ? wsComponents.secure : String(wsComponents.scheme).toLowerCase() === "wss";
      }
      var handler$2 = {
        scheme: "ws",
        domainHost: true,
        parse: function parse3(components, options) {
          var wsComponents = components;
          wsComponents.secure = isSecure(wsComponents);
          wsComponents.resourceName = (wsComponents.path || "/") + (wsComponents.query ? "?" + wsComponents.query : "");
          wsComponents.path = void 0;
          wsComponents.query = void 0;
          return wsComponents;
        },
        serialize: function serialize2(wsComponents, options) {
          if (wsComponents.port === (isSecure(wsComponents) ? 443 : 80) || wsComponents.port === "") {
            wsComponents.port = void 0;
          }
          if (typeof wsComponents.secure === "boolean") {
            wsComponents.scheme = wsComponents.secure ? "wss" : "ws";
            wsComponents.secure = void 0;
          }
          if (wsComponents.resourceName) {
            var _wsComponents$resourc = wsComponents.resourceName.split("?"), _wsComponents$resourc2 = slicedToArray(_wsComponents$resourc, 2), path5 = _wsComponents$resourc2[0], query = _wsComponents$resourc2[1];
            wsComponents.path = path5 && path5 !== "/" ? path5 : void 0;
            wsComponents.query = query;
            wsComponents.resourceName = void 0;
          }
          wsComponents.fragment = void 0;
          return wsComponents;
        }
      };
      var handler$3 = {
        scheme: "wss",
        domainHost: handler$2.domainHost,
        parse: handler$2.parse,
        serialize: handler$2.serialize
      };
      var O = {};
      var isIRI = true;
      var UNRESERVED$$ = "[A-Za-z0-9\\-\\.\\_\\~" + (isIRI ? "\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF" : "") + "]";
      var HEXDIG$$ = "[0-9A-Fa-f]";
      var PCT_ENCODED$ = subexp(subexp("%[EFef]" + HEXDIG$$ + "%" + HEXDIG$$ + HEXDIG$$ + "%" + HEXDIG$$ + HEXDIG$$) + "|" + subexp("%[89A-Fa-f]" + HEXDIG$$ + "%" + HEXDIG$$ + HEXDIG$$) + "|" + subexp("%" + HEXDIG$$ + HEXDIG$$));
      var ATEXT$$ = "[A-Za-z0-9\\!\\$\\%\\'\\*\\+\\-\\^\\_\\`\\{\\|\\}\\~]";
      var QTEXT$$ = "[\\!\\$\\%\\'\\(\\)\\*\\+\\,\\-\\.0-9\\<\\>A-Z\\x5E-\\x7E]";
      var VCHAR$$ = merge3(QTEXT$$, '[\\"\\\\]');
      var SOME_DELIMS$$ = "[\\!\\$\\'\\(\\)\\*\\+\\,\\;\\:\\@]";
      var UNRESERVED = new RegExp(UNRESERVED$$, "g");
      var PCT_ENCODED = new RegExp(PCT_ENCODED$, "g");
      var NOT_LOCAL_PART = new RegExp(merge3("[^]", ATEXT$$, "[\\.]", '[\\"]', VCHAR$$), "g");
      var NOT_HFNAME = new RegExp(merge3("[^]", UNRESERVED$$, SOME_DELIMS$$), "g");
      var NOT_HFVALUE = NOT_HFNAME;
      function decodeUnreserved(str2) {
        var decStr = pctDecChars(str2);
        return !decStr.match(UNRESERVED) ? str2 : decStr;
      }
      var handler$4 = {
        scheme: "mailto",
        parse: function parse$$1(components, options) {
          var mailtoComponents = components;
          var to = mailtoComponents.to = mailtoComponents.path ? mailtoComponents.path.split(",") : [];
          mailtoComponents.path = void 0;
          if (mailtoComponents.query) {
            var unknownHeaders = false;
            var headers = {};
            var hfields = mailtoComponents.query.split("&");
            for (var x = 0, xl = hfields.length; x < xl; ++x) {
              var hfield = hfields[x].split("=");
              switch (hfield[0]) {
                case "to":
                  var toAddrs = hfield[1].split(",");
                  for (var _x = 0, _xl = toAddrs.length; _x < _xl; ++_x) {
                    to.push(toAddrs[_x]);
                  }
                  break;
                case "subject":
                  mailtoComponents.subject = unescapeComponent(hfield[1], options);
                  break;
                case "body":
                  mailtoComponents.body = unescapeComponent(hfield[1], options);
                  break;
                default:
                  unknownHeaders = true;
                  headers[unescapeComponent(hfield[0], options)] = unescapeComponent(hfield[1], options);
                  break;
              }
            }
            if (unknownHeaders) mailtoComponents.headers = headers;
          }
          mailtoComponents.query = void 0;
          for (var _x2 = 0, _xl2 = to.length; _x2 < _xl2; ++_x2) {
            var addr = to[_x2].split("@");
            addr[0] = unescapeComponent(addr[0]);
            if (!options.unicodeSupport) {
              try {
                addr[1] = punycode.toASCII(unescapeComponent(addr[1], options).toLowerCase());
              } catch (e) {
                mailtoComponents.error = mailtoComponents.error || "Email address's domain name can not be converted to ASCII via punycode: " + e;
              }
            } else {
              addr[1] = unescapeComponent(addr[1], options).toLowerCase();
            }
            to[_x2] = addr.join("@");
          }
          return mailtoComponents;
        },
        serialize: function serialize$$1(mailtoComponents, options) {
          var components = mailtoComponents;
          var to = toArray2(mailtoComponents.to);
          if (to) {
            for (var x = 0, xl = to.length; x < xl; ++x) {
              var toAddr = String(to[x]);
              var atIdx = toAddr.lastIndexOf("@");
              var localPart = toAddr.slice(0, atIdx).replace(PCT_ENCODED, decodeUnreserved).replace(PCT_ENCODED, toUpperCase).replace(NOT_LOCAL_PART, pctEncChar);
              var domain = toAddr.slice(atIdx + 1);
              try {
                domain = !options.iri ? punycode.toASCII(unescapeComponent(domain, options).toLowerCase()) : punycode.toUnicode(domain);
              } catch (e) {
                components.error = components.error || "Email address's domain name can not be converted to " + (!options.iri ? "ASCII" : "Unicode") + " via punycode: " + e;
              }
              to[x] = localPart + "@" + domain;
            }
            components.path = to.join(",");
          }
          var headers = mailtoComponents.headers = mailtoComponents.headers || {};
          if (mailtoComponents.subject) headers["subject"] = mailtoComponents.subject;
          if (mailtoComponents.body) headers["body"] = mailtoComponents.body;
          var fields = [];
          for (var name in headers) {
            if (headers[name] !== O[name]) {
              fields.push(name.replace(PCT_ENCODED, decodeUnreserved).replace(PCT_ENCODED, toUpperCase).replace(NOT_HFNAME, pctEncChar) + "=" + headers[name].replace(PCT_ENCODED, decodeUnreserved).replace(PCT_ENCODED, toUpperCase).replace(NOT_HFVALUE, pctEncChar));
            }
          }
          if (fields.length) {
            components.query = fields.join("&");
          }
          return components;
        }
      };
      var URN_PARSE = /^([^\:]+)\:(.*)/;
      var handler$5 = {
        scheme: "urn",
        parse: function parse$$1(components, options) {
          var matches = components.path && components.path.match(URN_PARSE);
          var urnComponents = components;
          if (matches) {
            var scheme = options.scheme || urnComponents.scheme || "urn";
            var nid = matches[1].toLowerCase();
            var nss = matches[2];
            var urnScheme = scheme + ":" + (options.nid || nid);
            var schemeHandler = SCHEMES[urnScheme];
            urnComponents.nid = nid;
            urnComponents.nss = nss;
            urnComponents.path = void 0;
            if (schemeHandler) {
              urnComponents = schemeHandler.parse(urnComponents, options);
            }
          } else {
            urnComponents.error = urnComponents.error || "URN can not be parsed.";
          }
          return urnComponents;
        },
        serialize: function serialize$$1(urnComponents, options) {
          var scheme = options.scheme || urnComponents.scheme || "urn";
          var nid = urnComponents.nid;
          var urnScheme = scheme + ":" + (options.nid || nid);
          var schemeHandler = SCHEMES[urnScheme];
          if (schemeHandler) {
            urnComponents = schemeHandler.serialize(urnComponents, options);
          }
          var uriComponents = urnComponents;
          var nss = urnComponents.nss;
          uriComponents.path = (nid || options.nid) + ":" + nss;
          return uriComponents;
        }
      };
      var UUID2 = /^[0-9A-Fa-f]{8}(?:\-[0-9A-Fa-f]{4}){3}\-[0-9A-Fa-f]{12}$/;
      var handler$6 = {
        scheme: "urn:uuid",
        parse: function parse3(urnComponents, options) {
          var uuidComponents = urnComponents;
          uuidComponents.uuid = uuidComponents.nss;
          uuidComponents.nss = void 0;
          if (!options.tolerant && (!uuidComponents.uuid || !uuidComponents.uuid.match(UUID2))) {
            uuidComponents.error = uuidComponents.error || "UUID is not valid.";
          }
          return uuidComponents;
        },
        serialize: function serialize2(uuidComponents, options) {
          var urnComponents = uuidComponents;
          urnComponents.nss = (uuidComponents.uuid || "").toLowerCase();
          return urnComponents;
        }
      };
      SCHEMES[handler.scheme] = handler;
      SCHEMES[handler$1.scheme] = handler$1;
      SCHEMES[handler$2.scheme] = handler$2;
      SCHEMES[handler$3.scheme] = handler$3;
      SCHEMES[handler$4.scheme] = handler$4;
      SCHEMES[handler$5.scheme] = handler$5;
      SCHEMES[handler$6.scheme] = handler$6;
      exports3.SCHEMES = SCHEMES;
      exports3.pctEncChar = pctEncChar;
      exports3.pctDecChars = pctDecChars;
      exports3.parse = parse2;
      exports3.removeDotSegments = removeDotSegments;
      exports3.serialize = serialize;
      exports3.resolveComponents = resolveComponents;
      exports3.resolve = resolve;
      exports3.normalize = normalize2;
      exports3.equal = equal;
      exports3.escapeComponent = escapeComponent;
      exports3.unescapeComponent = unescapeComponent;
      Object.defineProperty(exports3, "__esModule", { value: true });
    });
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/runtime/uri.js
var require_uri = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/runtime/uri.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var uri = require_uri_all();
    uri.code = 'require("ajv/dist/runtime/uri").default';
    exports2.default = uri;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/core.js
var require_core2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/core.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CodeGen = exports2.Name = exports2.nil = exports2.stringify = exports2.str = exports2._ = exports2.KeywordCxt = void 0;
    var validate_1 = require_validate();
    Object.defineProperty(exports2, "KeywordCxt", { enumerable: true, get: function() {
      return validate_1.KeywordCxt;
    } });
    var codegen_1 = require_codegen();
    Object.defineProperty(exports2, "_", { enumerable: true, get: function() {
      return codegen_1._;
    } });
    Object.defineProperty(exports2, "str", { enumerable: true, get: function() {
      return codegen_1.str;
    } });
    Object.defineProperty(exports2, "stringify", { enumerable: true, get: function() {
      return codegen_1.stringify;
    } });
    Object.defineProperty(exports2, "nil", { enumerable: true, get: function() {
      return codegen_1.nil;
    } });
    Object.defineProperty(exports2, "Name", { enumerable: true, get: function() {
      return codegen_1.Name;
    } });
    Object.defineProperty(exports2, "CodeGen", { enumerable: true, get: function() {
      return codegen_1.CodeGen;
    } });
    var validation_error_1 = require_validation_error();
    var ref_error_1 = require_ref_error();
    var rules_1 = require_rules2();
    var compile_1 = require_compile();
    var codegen_2 = require_codegen();
    var resolve_1 = require_resolve();
    var dataType_1 = require_dataType();
    var util_1 = require_util();
    var $dataRefSchema = require_data();
    var uri_1 = require_uri();
    var defaultRegExp = (str2, flags) => new RegExp(str2, flags);
    defaultRegExp.code = "new RegExp";
    var META_IGNORE_OPTIONS = [
      "removeAdditional",
      "useDefaults",
      "coerceTypes",
      "defaultUnevaluatedProperties",
      "defaultAdditionalProperties"
    ];
    var EXT_SCOPE_NAMES = /* @__PURE__ */ new Set([
      "validate",
      "serialize",
      "parse",
      "wrapper",
      "root",
      "schema",
      "keyword",
      "pattern",
      "formats",
      "validate$data",
      "func",
      "obj",
      "Error"
    ]);
    var removedOptions = {
      errorDataPath: "",
      format: "`validateFormats: false` can be used instead.",
      nullable: '"nullable" keyword is supported by default.',
      jsonPointers: "Deprecated jsPropertySyntax can be used instead.",
      extendRefs: "Deprecated ignoreKeywordsWithRef can be used instead.",
      missingRefs: "Pass empty schema with $id that should be ignored to ajv.addSchema.",
      processCode: "Use option `code: {process: (code, schemaEnv: object) => string}`",
      sourceCode: "Use option `code: {source: true}`",
      strictDefaults: "It is default now, see option `strict`.",
      strictKeywords: "It is default now, see option `strict`.",
      uniqueItems: '"uniqueItems" keyword is always validated.',
      unknownFormats: "Disable strict mode or pass `true` to `ajv.addFormat` (or `formats` option).",
      cache: "Map is used as cache, schema object as key.",
      serialize: "Map is used as cache, schema object as key.",
      ajvErrors: "It is default now."
    };
    var deprecatedOptions = {
      ignoreKeywordsWithRef: "",
      jsPropertySyntax: "",
      unicode: '"minLength"/"maxLength" account for unicode characters by default.'
    };
    var MAX_EXPRESSION = 200;
    function requiredOptions(o) {
      var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0;
      const s = o.strict;
      const _optz = (_a = o.code) === null || _a === void 0 ? void 0 : _a.optimize;
      const optimize = _optz === true || _optz === void 0 ? 1 : _optz || 0;
      const regExp = (_c = (_b = o.code) === null || _b === void 0 ? void 0 : _b.regExp) !== null && _c !== void 0 ? _c : defaultRegExp;
      const uriResolver = (_d = o.uriResolver) !== null && _d !== void 0 ? _d : uri_1.default;
      return {
        strictSchema: (_f = (_e = o.strictSchema) !== null && _e !== void 0 ? _e : s) !== null && _f !== void 0 ? _f : true,
        strictNumbers: (_h = (_g = o.strictNumbers) !== null && _g !== void 0 ? _g : s) !== null && _h !== void 0 ? _h : true,
        strictTypes: (_k = (_j = o.strictTypes) !== null && _j !== void 0 ? _j : s) !== null && _k !== void 0 ? _k : "log",
        strictTuples: (_m = (_l = o.strictTuples) !== null && _l !== void 0 ? _l : s) !== null && _m !== void 0 ? _m : "log",
        strictRequired: (_p = (_o = o.strictRequired) !== null && _o !== void 0 ? _o : s) !== null && _p !== void 0 ? _p : false,
        code: o.code ? { ...o.code, optimize, regExp } : { optimize, regExp },
        loopRequired: (_q = o.loopRequired) !== null && _q !== void 0 ? _q : MAX_EXPRESSION,
        loopEnum: (_r = o.loopEnum) !== null && _r !== void 0 ? _r : MAX_EXPRESSION,
        meta: (_s = o.meta) !== null && _s !== void 0 ? _s : true,
        messages: (_t = o.messages) !== null && _t !== void 0 ? _t : true,
        inlineRefs: (_u = o.inlineRefs) !== null && _u !== void 0 ? _u : true,
        schemaId: (_v = o.schemaId) !== null && _v !== void 0 ? _v : "$id",
        addUsedSchema: (_w = o.addUsedSchema) !== null && _w !== void 0 ? _w : true,
        validateSchema: (_x = o.validateSchema) !== null && _x !== void 0 ? _x : true,
        validateFormats: (_y = o.validateFormats) !== null && _y !== void 0 ? _y : true,
        unicodeRegExp: (_z = o.unicodeRegExp) !== null && _z !== void 0 ? _z : true,
        int32range: (_0 = o.int32range) !== null && _0 !== void 0 ? _0 : true,
        uriResolver
      };
    }
    var Ajv = class {
      constructor(opts = {}) {
        this.schemas = {};
        this.refs = {};
        this.formats = {};
        this._compilations = /* @__PURE__ */ new Set();
        this._loading = {};
        this._cache = /* @__PURE__ */ new Map();
        opts = this.opts = { ...opts, ...requiredOptions(opts) };
        const { es5, lines } = this.opts.code;
        this.scope = new codegen_2.ValueScope({ scope: {}, prefixes: EXT_SCOPE_NAMES, es5, lines });
        this.logger = getLogger(opts.logger);
        const formatOpt = opts.validateFormats;
        opts.validateFormats = false;
        this.RULES = (0, rules_1.getRules)();
        checkOptions.call(this, removedOptions, opts, "NOT SUPPORTED");
        checkOptions.call(this, deprecatedOptions, opts, "DEPRECATED", "warn");
        this._metaOpts = getMetaSchemaOptions.call(this);
        if (opts.formats)
          addInitialFormats.call(this);
        this._addVocabularies();
        this._addDefaultMetaSchema();
        if (opts.keywords)
          addInitialKeywords.call(this, opts.keywords);
        if (typeof opts.meta == "object")
          this.addMetaSchema(opts.meta);
        addInitialSchemas.call(this);
        opts.validateFormats = formatOpt;
      }
      _addVocabularies() {
        this.addKeyword("$async");
      }
      _addDefaultMetaSchema() {
        const { $data, meta, schemaId } = this.opts;
        let _dataRefSchema = $dataRefSchema;
        if (schemaId === "id") {
          _dataRefSchema = { ...$dataRefSchema };
          _dataRefSchema.id = _dataRefSchema.$id;
          delete _dataRefSchema.$id;
        }
        if (meta && $data)
          this.addMetaSchema(_dataRefSchema, _dataRefSchema[schemaId], false);
      }
      defaultMeta() {
        const { meta, schemaId } = this.opts;
        return this.opts.defaultMeta = typeof meta == "object" ? meta[schemaId] || meta : void 0;
      }
      validate(schemaKeyRef, data) {
        let v;
        if (typeof schemaKeyRef == "string") {
          v = this.getSchema(schemaKeyRef);
          if (!v)
            throw new Error(`no schema with key or ref "${schemaKeyRef}"`);
        } else {
          v = this.compile(schemaKeyRef);
        }
        const valid = v(data);
        if (!("$async" in v))
          this.errors = v.errors;
        return valid;
      }
      compile(schema2, _meta) {
        const sch = this._addSchema(schema2, _meta);
        return sch.validate || this._compileSchemaEnv(sch);
      }
      compileAsync(schema2, meta) {
        if (typeof this.opts.loadSchema != "function") {
          throw new Error("options.loadSchema should be a function");
        }
        const { loadSchema } = this.opts;
        return runCompileAsync.call(this, schema2, meta);
        async function runCompileAsync(_schema, _meta) {
          await loadMetaSchema.call(this, _schema.$schema);
          const sch = this._addSchema(_schema, _meta);
          return sch.validate || _compileAsync.call(this, sch);
        }
        async function loadMetaSchema($ref) {
          if ($ref && !this.getSchema($ref)) {
            await runCompileAsync.call(this, { $ref }, true);
          }
        }
        async function _compileAsync(sch) {
          try {
            return this._compileSchemaEnv(sch);
          } catch (e) {
            if (!(e instanceof ref_error_1.default))
              throw e;
            checkLoaded.call(this, e);
            await loadMissingSchema.call(this, e.missingSchema);
            return _compileAsync.call(this, sch);
          }
        }
        function checkLoaded({ missingSchema: ref, missingRef }) {
          if (this.refs[ref]) {
            throw new Error(`AnySchema ${ref} is loaded but ${missingRef} cannot be resolved`);
          }
        }
        async function loadMissingSchema(ref) {
          const _schema = await _loadSchema.call(this, ref);
          if (!this.refs[ref])
            await loadMetaSchema.call(this, _schema.$schema);
          if (!this.refs[ref])
            this.addSchema(_schema, ref, meta);
        }
        async function _loadSchema(ref) {
          const p = this._loading[ref];
          if (p)
            return p;
          try {
            return await (this._loading[ref] = loadSchema(ref));
          } finally {
            delete this._loading[ref];
          }
        }
      }
      // Adds schema to the instance
      addSchema(schema2, key, _meta, _validateSchema = this.opts.validateSchema) {
        if (Array.isArray(schema2)) {
          for (const sch of schema2)
            this.addSchema(sch, void 0, _meta, _validateSchema);
          return this;
        }
        let id;
        if (typeof schema2 === "object") {
          const { schemaId } = this.opts;
          id = schema2[schemaId];
          if (id !== void 0 && typeof id != "string") {
            throw new Error(`schema ${schemaId} must be string`);
          }
        }
        key = (0, resolve_1.normalizeId)(key || id);
        this._checkUnique(key);
        this.schemas[key] = this._addSchema(schema2, _meta, key, _validateSchema, true);
        return this;
      }
      // Add schema that will be used to validate other schemas
      // options in META_IGNORE_OPTIONS are alway set to false
      addMetaSchema(schema2, key, _validateSchema = this.opts.validateSchema) {
        this.addSchema(schema2, key, true, _validateSchema);
        return this;
      }
      //  Validate schema against its meta-schema
      validateSchema(schema2, throwOrLogError) {
        if (typeof schema2 == "boolean")
          return true;
        let $schema;
        $schema = schema2.$schema;
        if ($schema !== void 0 && typeof $schema != "string") {
          throw new Error("$schema must be a string");
        }
        $schema = $schema || this.opts.defaultMeta || this.defaultMeta();
        if (!$schema) {
          this.logger.warn("meta-schema not available");
          this.errors = null;
          return true;
        }
        const valid = this.validate($schema, schema2);
        if (!valid && throwOrLogError) {
          const message = "schema is invalid: " + this.errorsText();
          if (this.opts.validateSchema === "log")
            this.logger.error(message);
          else
            throw new Error(message);
        }
        return valid;
      }
      // Get compiled schema by `key` or `ref`.
      // (`key` that was passed to `addSchema` or full schema reference - `schema.$id` or resolved id)
      getSchema(keyRef) {
        let sch;
        while (typeof (sch = getSchEnv.call(this, keyRef)) == "string")
          keyRef = sch;
        if (sch === void 0) {
          const { schemaId } = this.opts;
          const root2 = new compile_1.SchemaEnv({ schema: {}, schemaId });
          sch = compile_1.resolveSchema.call(this, root2, keyRef);
          if (!sch)
            return;
          this.refs[keyRef] = sch;
        }
        return sch.validate || this._compileSchemaEnv(sch);
      }
      // Remove cached schema(s).
      // If no parameter is passed all schemas but meta-schemas are removed.
      // If RegExp is passed all schemas with key/id matching pattern but meta-schemas are removed.
      // Even if schema is referenced by other schemas it still can be removed as other schemas have local references.
      removeSchema(schemaKeyRef) {
        if (schemaKeyRef instanceof RegExp) {
          this._removeAllSchemas(this.schemas, schemaKeyRef);
          this._removeAllSchemas(this.refs, schemaKeyRef);
          return this;
        }
        switch (typeof schemaKeyRef) {
          case "undefined":
            this._removeAllSchemas(this.schemas);
            this._removeAllSchemas(this.refs);
            this._cache.clear();
            return this;
          case "string": {
            const sch = getSchEnv.call(this, schemaKeyRef);
            if (typeof sch == "object")
              this._cache.delete(sch.schema);
            delete this.schemas[schemaKeyRef];
            delete this.refs[schemaKeyRef];
            return this;
          }
          case "object": {
            const cacheKey = schemaKeyRef;
            this._cache.delete(cacheKey);
            let id = schemaKeyRef[this.opts.schemaId];
            if (id) {
              id = (0, resolve_1.normalizeId)(id);
              delete this.schemas[id];
              delete this.refs[id];
            }
            return this;
          }
          default:
            throw new Error("ajv.removeSchema: invalid parameter");
        }
      }
      // add "vocabulary" - a collection of keywords
      addVocabulary(definitions) {
        for (const def of definitions)
          this.addKeyword(def);
        return this;
      }
      addKeyword(kwdOrDef, def) {
        let keyword;
        if (typeof kwdOrDef == "string") {
          keyword = kwdOrDef;
          if (typeof def == "object") {
            this.logger.warn("these parameters are deprecated, see docs for addKeyword");
            def.keyword = keyword;
          }
        } else if (typeof kwdOrDef == "object" && def === void 0) {
          def = kwdOrDef;
          keyword = def.keyword;
          if (Array.isArray(keyword) && !keyword.length) {
            throw new Error("addKeywords: keyword must be string or non-empty array");
          }
        } else {
          throw new Error("invalid addKeywords parameters");
        }
        checkKeyword.call(this, keyword, def);
        if (!def) {
          (0, util_1.eachItem)(keyword, (kwd) => addRule.call(this, kwd));
          return this;
        }
        keywordMetaschema.call(this, def);
        const definition = {
          ...def,
          type: (0, dataType_1.getJSONTypes)(def.type),
          schemaType: (0, dataType_1.getJSONTypes)(def.schemaType)
        };
        (0, util_1.eachItem)(keyword, definition.type.length === 0 ? (k) => addRule.call(this, k, definition) : (k) => definition.type.forEach((t) => addRule.call(this, k, definition, t)));
        return this;
      }
      getKeyword(keyword) {
        const rule = this.RULES.all[keyword];
        return typeof rule == "object" ? rule.definition : !!rule;
      }
      // Remove keyword
      removeKeyword(keyword) {
        const { RULES } = this;
        delete RULES.keywords[keyword];
        delete RULES.all[keyword];
        for (const group of RULES.rules) {
          const i = group.rules.findIndex((rule) => rule.keyword === keyword);
          if (i >= 0)
            group.rules.splice(i, 1);
        }
        return this;
      }
      // Add format
      addFormat(name, format) {
        if (typeof format == "string")
          format = new RegExp(format);
        this.formats[name] = format;
        return this;
      }
      errorsText(errors = this.errors, { separator = ", ", dataVar = "data" } = {}) {
        if (!errors || errors.length === 0)
          return "No errors";
        return errors.map((e) => `${dataVar}${e.instancePath} ${e.message}`).reduce((text, msg) => text + separator + msg);
      }
      $dataMetaSchema(metaSchema, keywordsJsonPointers) {
        const rules = this.RULES.all;
        metaSchema = JSON.parse(JSON.stringify(metaSchema));
        for (const jsonPointer of keywordsJsonPointers) {
          const segments = jsonPointer.split("/").slice(1);
          let keywords = metaSchema;
          for (const seg of segments)
            keywords = keywords[seg];
          for (const key in rules) {
            const rule = rules[key];
            if (typeof rule != "object")
              continue;
            const { $data } = rule.definition;
            const schema2 = keywords[key];
            if ($data && schema2)
              keywords[key] = schemaOrData(schema2);
          }
        }
        return metaSchema;
      }
      _removeAllSchemas(schemas, regex) {
        for (const keyRef in schemas) {
          const sch = schemas[keyRef];
          if (!regex || regex.test(keyRef)) {
            if (typeof sch == "string") {
              delete schemas[keyRef];
            } else if (sch && !sch.meta) {
              this._cache.delete(sch.schema);
              delete schemas[keyRef];
            }
          }
        }
      }
      _addSchema(schema2, meta, baseId, validateSchema = this.opts.validateSchema, addSchema = this.opts.addUsedSchema) {
        let id;
        const { schemaId } = this.opts;
        if (typeof schema2 == "object") {
          id = schema2[schemaId];
        } else {
          if (this.opts.jtd)
            throw new Error("schema must be object");
          else if (typeof schema2 != "boolean")
            throw new Error("schema must be object or boolean");
        }
        let sch = this._cache.get(schema2);
        if (sch !== void 0)
          return sch;
        baseId = (0, resolve_1.normalizeId)(id || baseId);
        const localRefs = resolve_1.getSchemaRefs.call(this, schema2, baseId);
        sch = new compile_1.SchemaEnv({ schema: schema2, schemaId, meta, baseId, localRefs });
        this._cache.set(sch.schema, sch);
        if (addSchema && !baseId.startsWith("#")) {
          if (baseId)
            this._checkUnique(baseId);
          this.refs[baseId] = sch;
        }
        if (validateSchema)
          this.validateSchema(schema2, true);
        return sch;
      }
      _checkUnique(id) {
        if (this.schemas[id] || this.refs[id]) {
          throw new Error(`schema with key or id "${id}" already exists`);
        }
      }
      _compileSchemaEnv(sch) {
        if (sch.meta)
          this._compileMetaSchema(sch);
        else
          compile_1.compileSchema.call(this, sch);
        if (!sch.validate)
          throw new Error("ajv implementation error");
        return sch.validate;
      }
      _compileMetaSchema(sch) {
        const currentOpts = this.opts;
        this.opts = this._metaOpts;
        try {
          compile_1.compileSchema.call(this, sch);
        } finally {
          this.opts = currentOpts;
        }
      }
    };
    exports2.default = Ajv;
    Ajv.ValidationError = validation_error_1.default;
    Ajv.MissingRefError = ref_error_1.default;
    function checkOptions(checkOpts, options, msg, log = "error") {
      for (const key in checkOpts) {
        const opt = key;
        if (opt in options)
          this.logger[log](`${msg}: option ${key}. ${checkOpts[opt]}`);
      }
    }
    function getSchEnv(keyRef) {
      keyRef = (0, resolve_1.normalizeId)(keyRef);
      return this.schemas[keyRef] || this.refs[keyRef];
    }
    function addInitialSchemas() {
      const optsSchemas = this.opts.schemas;
      if (!optsSchemas)
        return;
      if (Array.isArray(optsSchemas))
        this.addSchema(optsSchemas);
      else
        for (const key in optsSchemas)
          this.addSchema(optsSchemas[key], key);
    }
    function addInitialFormats() {
      for (const name in this.opts.formats) {
        const format = this.opts.formats[name];
        if (format)
          this.addFormat(name, format);
      }
    }
    function addInitialKeywords(defs) {
      if (Array.isArray(defs)) {
        this.addVocabulary(defs);
        return;
      }
      this.logger.warn("keywords option as map is deprecated, pass array");
      for (const keyword in defs) {
        const def = defs[keyword];
        if (!def.keyword)
          def.keyword = keyword;
        this.addKeyword(def);
      }
    }
    function getMetaSchemaOptions() {
      const metaOpts = { ...this.opts };
      for (const opt of META_IGNORE_OPTIONS)
        delete metaOpts[opt];
      return metaOpts;
    }
    var noLogs = { log() {
    }, warn() {
    }, error() {
    } };
    function getLogger(logger) {
      if (logger === false)
        return noLogs;
      if (logger === void 0)
        return console;
      if (logger.log && logger.warn && logger.error)
        return logger;
      throw new Error("logger must implement log, warn and error methods");
    }
    var KEYWORD_NAME = /^[a-z_$][a-z0-9_$:-]*$/i;
    function checkKeyword(keyword, def) {
      const { RULES } = this;
      (0, util_1.eachItem)(keyword, (kwd) => {
        if (RULES.keywords[kwd])
          throw new Error(`Keyword ${kwd} is already defined`);
        if (!KEYWORD_NAME.test(kwd))
          throw new Error(`Keyword ${kwd} has invalid name`);
      });
      if (!def)
        return;
      if (def.$data && !("code" in def || "validate" in def)) {
        throw new Error('$data keyword must have "code" or "validate" function');
      }
    }
    function addRule(keyword, definition, dataType) {
      var _a;
      const post = definition === null || definition === void 0 ? void 0 : definition.post;
      if (dataType && post)
        throw new Error('keyword with "post" flag cannot have "type"');
      const { RULES } = this;
      let ruleGroup = post ? RULES.post : RULES.rules.find(({ type: t }) => t === dataType);
      if (!ruleGroup) {
        ruleGroup = { type: dataType, rules: [] };
        RULES.rules.push(ruleGroup);
      }
      RULES.keywords[keyword] = true;
      if (!definition)
        return;
      const rule = {
        keyword,
        definition: {
          ...definition,
          type: (0, dataType_1.getJSONTypes)(definition.type),
          schemaType: (0, dataType_1.getJSONTypes)(definition.schemaType)
        }
      };
      if (definition.before)
        addBeforeRule.call(this, ruleGroup, rule, definition.before);
      else
        ruleGroup.rules.push(rule);
      RULES.all[keyword] = rule;
      (_a = definition.implements) === null || _a === void 0 ? void 0 : _a.forEach((kwd) => this.addKeyword(kwd));
    }
    function addBeforeRule(ruleGroup, rule, before) {
      const i = ruleGroup.rules.findIndex((_rule) => _rule.keyword === before);
      if (i >= 0) {
        ruleGroup.rules.splice(i, 0, rule);
      } else {
        ruleGroup.rules.push(rule);
        this.logger.warn(`rule ${before} is not defined`);
      }
    }
    function keywordMetaschema(def) {
      let { metaSchema } = def;
      if (metaSchema === void 0)
        return;
      if (def.$data && this.opts.$data)
        metaSchema = schemaOrData(metaSchema);
      def.validateSchema = this.compile(metaSchema, true);
    }
    var $dataRef = {
      $ref: "https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#"
    };
    function schemaOrData(schema2) {
      return { anyOf: [schema2, $dataRef] };
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/core/id.js
var require_id = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/core/id.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var def = {
      keyword: "id",
      code() {
        throw new Error('NOT SUPPORTED: keyword "id", use "$id" for schema ID');
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/core/ref.js
var require_ref = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/core/ref.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.callRef = exports2.getValidate = void 0;
    var ref_error_1 = require_ref_error();
    var code_1 = require_code2();
    var codegen_1 = require_codegen();
    var names_1 = require_names();
    var compile_1 = require_compile();
    var util_1 = require_util();
    var def = {
      keyword: "$ref",
      schemaType: "string",
      code(cxt) {
        const { gen, schema: $ref, it } = cxt;
        const { baseId, schemaEnv: env, validateName: validateName3, opts, self: self2 } = it;
        const { root: root2 } = env;
        if (($ref === "#" || $ref === "#/") && baseId === root2.baseId)
          return callRootRef();
        const schOrEnv = compile_1.resolveRef.call(self2, root2, baseId, $ref);
        if (schOrEnv === void 0)
          throw new ref_error_1.default(it.opts.uriResolver, baseId, $ref);
        if (schOrEnv instanceof compile_1.SchemaEnv)
          return callValidate(schOrEnv);
        return inlineRefSchema(schOrEnv);
        function callRootRef() {
          if (env === root2)
            return callRef(cxt, validateName3, env, env.$async);
          const rootName = gen.scopeValue("root", { ref: root2 });
          return callRef(cxt, (0, codegen_1._)`${rootName}.validate`, root2, root2.$async);
        }
        function callValidate(sch) {
          const v = getValidate(cxt, sch);
          callRef(cxt, v, sch, sch.$async);
        }
        function inlineRefSchema(sch) {
          const schName = gen.scopeValue("schema", opts.code.source === true ? { ref: sch, code: (0, codegen_1.stringify)(sch) } : { ref: sch });
          const valid = gen.name("valid");
          const schCxt = cxt.subschema(
            {
              schema: sch,
              dataTypes: [],
              schemaPath: codegen_1.nil,
              topSchemaRef: schName,
              errSchemaPath: $ref
            },
            valid,
            it.isAllOfVariant
            // pass isAllOfVariant into inlined $ref
          );
          cxt.mergeEvaluated(schCxt);
          cxt.ok(valid);
        }
      }
    };
    function getValidate(cxt, sch) {
      const { gen } = cxt;
      return sch.validate ? gen.scopeValue("validate", { ref: sch.validate }) : (0, codegen_1._)`${gen.scopeValue("wrapper", { ref: sch })}.validate`;
    }
    exports2.getValidate = getValidate;
    function callRef(cxt, v, sch, $async) {
      const { gen, it } = cxt;
      const { allErrors, schemaEnv: env, opts } = it;
      const passCxt = opts.passContext ? names_1.default.this : codegen_1.nil;
      if ($async)
        callAsyncRef();
      else
        callSyncRef();
      function callAsyncRef() {
        if (!env.$async)
          throw new Error("async schema referenced by sync schema");
        const valid = gen.let("valid");
        gen.try(() => {
          gen.code((0, codegen_1._)`await ${(0, code_1.callValidateCode)(cxt, v, passCxt)}`);
          addEvaluatedFrom(v);
          if (!allErrors)
            gen.assign(valid, true);
        }, (e) => {
          gen.if((0, codegen_1._)`!(${e} instanceof ${it.ValidationError})`, () => gen.throw(e));
          addErrorsFrom(e);
          if (!allErrors)
            gen.assign(valid, false);
        });
        cxt.ok(valid);
      }
      function callSyncRef() {
        const visitedNodes = gen.name("visitedNodes");
        gen.code((0, codegen_1._)`const ${visitedNodes} = (typeof visitedNodesForRef !== 'undefined') && visitedNodesForRef.get(${v}) || new Set()`);
        gen.if((0, codegen_1._)`!${visitedNodes}.has(${cxt.data})`, () => {
          gen.code((0, codegen_1._)`if (typeof visitedNodesForRef !== 'undefined') visitedNodesForRef.set(${v}, ${visitedNodes})`);
          gen.code((0, codegen_1._)`const dataNode = ${cxt.data}`);
          gen.code((0, codegen_1._)`if (typeof dataNode === "object" && dataNode !== null) ${visitedNodes}.add(dataNode)`);
          const res = cxt.result((0, code_1.callValidateCode)(cxt, v, passCxt), () => addEvaluatedFrom(v), () => addErrorsFrom(v));
          gen.code((0, codegen_1._)`${visitedNodes}.delete(dataNode)`);
          return res;
        });
      }
      function addErrorsFrom(source) {
        const errs = (0, codegen_1._)`${source}.errors`;
        gen.assign(names_1.default.vErrors, (0, codegen_1._)`${names_1.default.vErrors} === null ? ${errs} : ${names_1.default.vErrors}.concat(${errs})`);
        gen.assign(names_1.default.errors, (0, codegen_1._)`${names_1.default.vErrors}.length`);
      }
      function addEvaluatedFrom(source) {
        var _a;
        if (!it.opts.unevaluated)
          return;
        const schEvaluated = (_a = sch === null || sch === void 0 ? void 0 : sch.validate) === null || _a === void 0 ? void 0 : _a.evaluated;
        if (it.props !== true) {
          if (schEvaluated && !schEvaluated.dynamicProps) {
            if (schEvaluated.props !== void 0) {
              it.props = util_1.mergeEvaluated.props(gen, schEvaluated.props, it.props);
            }
          } else {
            const props = gen.var("props", (0, codegen_1._)`${source}.evaluated.props`);
            it.props = util_1.mergeEvaluated.props(gen, props, it.props, codegen_1.Name);
          }
        }
        if (it.items !== true) {
          if (schEvaluated && !schEvaluated.dynamicItems) {
            if (schEvaluated.items !== void 0) {
              it.items = util_1.mergeEvaluated.items(gen, schEvaluated.items, it.items);
            }
          } else {
            const items = gen.var("items", (0, codegen_1._)`${source}.evaluated.items`);
            it.items = util_1.mergeEvaluated.items(gen, items, it.items, codegen_1.Name);
          }
        }
      }
    }
    exports2.callRef = callRef;
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/core/index.js
var require_core3 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/core/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var id_1 = require_id();
    var ref_1 = require_ref();
    var core2 = [
      "$schema",
      "$id",
      "$defs",
      "$vocabulary",
      { keyword: "$comment" },
      "definitions",
      id_1.default,
      ref_1.default
    ];
    exports2.default = core2;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitNumber.js
var require_limitNumber = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitNumber.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var ops = codegen_1.operators;
    var KWDs = {
      maximum: { okStr: "<=", ok: ops.LTE, fail: ops.GT },
      minimum: { okStr: ">=", ok: ops.GTE, fail: ops.LT },
      exclusiveMaximum: { okStr: "<", ok: ops.LT, fail: ops.GTE },
      exclusiveMinimum: { okStr: ">", ok: ops.GT, fail: ops.LTE }
    };
    var error = {
      message: ({ keyword, schemaCode }) => (0, codegen_1.str)`must be ${KWDs[keyword].okStr} ${schemaCode}`,
      params: ({ keyword, schemaCode }) => (0, codegen_1._)`{comparison: ${KWDs[keyword].okStr}, limit: ${schemaCode}}`
    };
    var def = {
      keyword: Object.keys(KWDs),
      type: "number",
      schemaType: "number",
      $data: true,
      error,
      code(cxt) {
        const { keyword, data, schemaCode } = cxt;
        cxt.fail$data((0, codegen_1._)`${data} ${KWDs[keyword].fail} ${schemaCode} || isNaN(${data})`);
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/multipleOf.js
var require_multipleOf = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/multipleOf.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var error = {
      message: ({ schemaCode }) => (0, codegen_1.str)`must be multiple of ${schemaCode}`,
      params: ({ schemaCode }) => (0, codegen_1._)`{multipleOf: ${schemaCode}}`
    };
    var def = {
      keyword: "multipleOf",
      type: "number",
      schemaType: "number",
      $data: true,
      error,
      code(cxt) {
        const { gen, data, schemaCode, it } = cxt;
        const prec = it.opts.multipleOfPrecision;
        const res = gen.let("res");
        const invalid = prec ? (0, codegen_1._)`Math.abs(Math.round(${res}) - ${res}) > 1e-${prec}` : (0, codegen_1._)`${res} !== parseInt(${res})`;
        cxt.fail$data((0, codegen_1._)`(${schemaCode} === 0 || (${res} = ${data}/${schemaCode}, ${invalid}))`);
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/runtime/ucs2length.js
var require_ucs2length = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/runtime/ucs2length.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    function ucs2length(str2) {
      const len = str2.length;
      let length = 0;
      let pos = 0;
      let value;
      while (pos < len) {
        length++;
        value = str2.charCodeAt(pos++);
        if (value >= 55296 && value <= 56319 && pos < len) {
          value = str2.charCodeAt(pos);
          if ((value & 64512) === 56320)
            pos++;
        }
      }
      return length;
    }
    exports2.default = ucs2length;
    ucs2length.code = 'require("ajv/dist/runtime/ucs2length").default';
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitLength.js
var require_limitLength = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitLength.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var ucs2length_1 = require_ucs2length();
    var error = {
      message({ keyword, schemaCode }) {
        const comp = keyword === "maxLength" ? "more" : "fewer";
        return (0, codegen_1.str)`must NOT have ${comp} than ${schemaCode} characters`;
      },
      params: ({ schemaCode }) => (0, codegen_1._)`{limit: ${schemaCode}}`
    };
    var def = {
      keyword: ["maxLength", "minLength"],
      type: "string",
      schemaType: "number",
      $data: true,
      error,
      code(cxt) {
        const { keyword, data, schemaCode, it } = cxt;
        const op = keyword === "maxLength" ? codegen_1.operators.GT : codegen_1.operators.LT;
        const len = it.opts.unicode === false ? (0, codegen_1._)`${data}.length` : (0, codegen_1._)`${(0, util_1.useFunc)(cxt.gen, ucs2length_1.default)}(${data})`;
        cxt.fail$data((0, codegen_1._)`${len} ${op} ${schemaCode}`);
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/pattern.js
var require_pattern = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/pattern.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var code_1 = require_code2();
    var codegen_1 = require_codegen();
    var error = {
      message: ({ schemaCode }) => (0, codegen_1.str)`must match pattern "${schemaCode}"`,
      params: ({ schemaCode }) => (0, codegen_1._)`{pattern: ${schemaCode}}`
    };
    var def = {
      keyword: "pattern",
      type: "string",
      schemaType: "string",
      $data: true,
      error,
      code(cxt) {
        const { data, $data, schema: schema2, schemaCode, it } = cxt;
        const u = it.opts.unicodeRegExp ? "u" : "";
        const regExp = $data ? (0, codegen_1._)`(new RegExp(${schemaCode}, ${u}))` : (0, code_1.usePattern)(cxt, schema2);
        cxt.fail$data((0, codegen_1._)`!${regExp}.test(${data})`);
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitProperties.js
var require_limitProperties = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitProperties.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var error = {
      message({ keyword, schemaCode }) {
        const comp = keyword === "maxProperties" ? "more" : "fewer";
        return (0, codegen_1.str)`must NOT have ${comp} than ${schemaCode} properties`;
      },
      params: ({ schemaCode }) => (0, codegen_1._)`{limit: ${schemaCode}}`
    };
    var def = {
      keyword: ["maxProperties", "minProperties"],
      type: "object",
      schemaType: "number",
      $data: true,
      error,
      code(cxt) {
        const { keyword, data, schemaCode } = cxt;
        const op = keyword === "maxProperties" ? codegen_1.operators.GT : codegen_1.operators.LT;
        cxt.fail$data((0, codegen_1._)`Object.keys(${data}).length ${op} ${schemaCode}`);
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/required.js
var require_required = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/required.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var code_1 = require_code2();
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var error = {
      message: ({ params: { missingProperty } }) => (0, codegen_1.str)`must have required property '${missingProperty}'`,
      params: ({ params: { missingProperty } }) => (0, codegen_1._)`{missingProperty: ${missingProperty}}`
    };
    var def = {
      keyword: "required",
      type: "object",
      schemaType: "array",
      $data: true,
      error,
      code(cxt) {
        const { gen, schema: schema2, schemaCode, data, $data, it } = cxt;
        const { opts } = it;
        if (!$data && schema2.length === 0)
          return;
        const useLoop = schema2.length >= opts.loopRequired;
        if (it.allErrors)
          allErrorsMode();
        else
          exitOnErrorMode();
        if (opts.strictRequired) {
          const props = cxt.parentSchema.properties;
          const { definedProperties } = cxt.it;
          for (const requiredKey of schema2) {
            if ((props === null || props === void 0 ? void 0 : props[requiredKey]) === void 0 && !definedProperties.has(requiredKey)) {
              const schemaPath = it.schemaEnv.baseId + it.errSchemaPath;
              const msg = `required property "${requiredKey}" is not defined at "${schemaPath}" (strictRequired)`;
              (0, util_1.checkStrictMode)(it, msg, it.opts.strictRequired);
            }
          }
        }
        function allErrorsMode() {
          if (useLoop || $data) {
            cxt.block$data(codegen_1.nil, loopAllRequired);
          } else {
            for (const prop of schema2) {
              (0, code_1.checkReportMissingProp)(cxt, prop);
            }
          }
        }
        function exitOnErrorMode() {
          const missing = gen.let("missing");
          if (useLoop || $data) {
            const valid = gen.let("valid", true);
            cxt.block$data(valid, () => loopUntilMissing(missing, valid));
            cxt.ok(valid);
          } else {
            gen.if((0, code_1.checkMissingProp)(cxt, schema2, missing));
            (0, code_1.reportMissingProp)(cxt, missing);
            gen.else();
          }
        }
        function loopAllRequired() {
          gen.forOf("prop", schemaCode, (prop) => {
            cxt.setParams({ missingProperty: prop });
            gen.if((0, code_1.noPropertyInData)(gen, data, prop, opts.ownProperties), () => cxt.error());
          });
        }
        function loopUntilMissing(missing, valid) {
          cxt.setParams({ missingProperty: missing });
          gen.forOf(missing, schemaCode, () => {
            gen.assign(valid, (0, code_1.propertyInData)(gen, data, missing, opts.ownProperties));
            gen.if((0, codegen_1.not)(valid), () => {
              cxt.error();
              gen.break();
            });
          }, codegen_1.nil);
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitItems.js
var require_limitItems = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitItems.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var error = {
      message({ keyword, schemaCode }) {
        const comp = keyword === "maxItems" ? "more" : "fewer";
        return (0, codegen_1.str)`must NOT have ${comp} than ${schemaCode} items`;
      },
      params: ({ schemaCode }) => (0, codegen_1._)`{limit: ${schemaCode}}`
    };
    var def = {
      keyword: ["maxItems", "minItems"],
      type: "array",
      schemaType: "number",
      $data: true,
      error,
      code(cxt) {
        const { keyword, data, schemaCode } = cxt;
        const op = keyword === "maxItems" ? codegen_1.operators.GT : codegen_1.operators.LT;
        cxt.fail$data((0, codegen_1._)`${data}.length ${op} ${schemaCode}`);
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/runtime/equal.js
var require_equal = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/runtime/equal.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var equal = require_fast_deep_equal();
    equal.code = 'require("ajv/dist/runtime/equal").default';
    exports2.default = equal;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/uniqueItems.js
var require_uniqueItems = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/uniqueItems.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var dataType_1 = require_dataType();
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var equal_1 = require_equal();
    var error = {
      message: ({ params: { i, j } }) => (0, codegen_1.str)`must NOT have duplicate items (items ## ${j} and ${i} are identical)`,
      params: ({ params: { i, j } }) => (0, codegen_1._)`{i: ${i}, j: ${j}}`
    };
    var def = {
      keyword: "uniqueItems",
      type: "array",
      schemaType: "boolean",
      $data: true,
      error,
      code(cxt) {
        const { gen, data, $data, schema: schema2, parentSchema, schemaCode, it } = cxt;
        if (!$data && !schema2)
          return;
        const valid = gen.let("valid");
        const itemTypes = parentSchema.items ? (0, dataType_1.getSchemaTypes)(parentSchema.items) : [];
        cxt.block$data(valid, validateUniqueItems, (0, codegen_1._)`${schemaCode} === false`);
        cxt.ok(valid);
        function validateUniqueItems() {
          const i = gen.let("i", (0, codegen_1._)`${data}.length`);
          const j = gen.let("j");
          cxt.setParams({ i, j });
          gen.assign(valid, true);
          gen.if((0, codegen_1._)`${i} > 1`, () => (canOptimize() ? loopN : loopN2)(i, j));
        }
        function canOptimize() {
          return itemTypes.length > 0 && !itemTypes.some((t) => t === "object" || t === "array");
        }
        function loopN(i, j) {
          const item = gen.name("item");
          const wrongType = (0, dataType_1.checkDataTypes)(itemTypes, item, it.opts.strictNumbers, dataType_1.DataType.Wrong);
          const indices = gen.const("indices", (0, codegen_1._)`{}`);
          gen.for((0, codegen_1._)`;${i}--;`, () => {
            gen.let(item, (0, codegen_1._)`${data}[${i}]`);
            gen.if(wrongType, (0, codegen_1._)`continue`);
            if (itemTypes.length > 1)
              gen.if((0, codegen_1._)`typeof ${item} == "string"`, (0, codegen_1._)`${item} += "_"`);
            gen.if((0, codegen_1._)`typeof ${indices}[${item}] == "number"`, () => {
              gen.assign(j, (0, codegen_1._)`${indices}[${item}]`);
              cxt.error();
              gen.assign(valid, false).break();
            }).code((0, codegen_1._)`${indices}[${item}] = ${i}`);
          });
        }
        function loopN2(i, j) {
          const eql = (0, util_1.useFunc)(gen, equal_1.default);
          const outer = gen.name("outer");
          gen.label(outer).for((0, codegen_1._)`;${i}--;`, () => gen.for((0, codegen_1._)`${j} = ${i}; ${j}--;`, () => gen.if((0, codegen_1._)`${eql}(${data}[${i}], ${data}[${j}])`, () => {
            cxt.error();
            gen.assign(valid, false).break(outer);
          })));
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/const.js
var require_const = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/const.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var equal_1 = require_equal();
    var error = {
      message: "must be equal to constant",
      params: ({ schemaCode }) => (0, codegen_1._)`{allowedValue: ${schemaCode}}`
    };
    var def = {
      keyword: "const",
      $data: true,
      error,
      code(cxt) {
        const { gen, data, $data, schemaCode, schema: schema2 } = cxt;
        if ($data || schema2 && typeof schema2 == "object") {
          cxt.fail$data((0, codegen_1._)`!${(0, util_1.useFunc)(gen, equal_1.default)}(${data}, ${schemaCode})`);
        } else {
          cxt.fail((0, codegen_1._)`${schema2} !== ${data}`);
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/enum.js
var require_enum = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/enum.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var equal_1 = require_equal();
    var error = {
      message: "must be equal to one of the allowed values",
      params: ({ schemaCode }) => (0, codegen_1._)`{allowedValues: ${schemaCode}}`
    };
    var def = {
      keyword: "enum",
      schemaType: "array",
      $data: true,
      error,
      code(cxt) {
        const { gen, data, $data, schema: schema2, schemaCode, it } = cxt;
        if (!$data && schema2.length === 0)
          throw new Error("enum must have non-empty array");
        const useLoop = schema2.length >= it.opts.loopEnum;
        let eql;
        const getEql = () => eql !== null && eql !== void 0 ? eql : eql = (0, util_1.useFunc)(gen, equal_1.default);
        let valid;
        if (useLoop || $data) {
          valid = gen.let("valid");
          cxt.block$data(valid, loopEnum);
        } else {
          if (!Array.isArray(schema2))
            throw new Error("ajv implementation error");
          const vSchema = gen.const("vSchema", schemaCode);
          valid = (0, codegen_1.or)(...schema2.map((_x, i) => equalCode(vSchema, i)));
        }
        cxt.pass(valid);
        function loopEnum() {
          gen.assign(valid, false);
          gen.forOf("v", schemaCode, (v) => gen.if((0, codegen_1._)`${getEql()}(${data}, ${v})`, () => gen.assign(valid, true).break()));
        }
        function equalCode(vSchema, i) {
          const sch = schema2[i];
          return typeof sch === "object" && sch !== null ? (0, codegen_1._)`${getEql()}(${data}, ${vSchema}[${i}])` : (0, codegen_1._)`${data} === ${sch}`;
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/index.js
var require_validation = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var limitNumber_1 = require_limitNumber();
    var multipleOf_1 = require_multipleOf();
    var limitLength_1 = require_limitLength();
    var pattern_1 = require_pattern();
    var limitProperties_1 = require_limitProperties();
    var required_1 = require_required();
    var limitItems_1 = require_limitItems();
    var uniqueItems_1 = require_uniqueItems();
    var const_1 = require_const();
    var enum_1 = require_enum();
    var validation = [
      // number
      limitNumber_1.default,
      multipleOf_1.default,
      // string
      limitLength_1.default,
      pattern_1.default,
      // object
      limitProperties_1.default,
      required_1.default,
      // array
      limitItems_1.default,
      uniqueItems_1.default,
      // any
      { keyword: "type", schemaType: ["string", "array"] },
      { keyword: "nullable", schemaType: "boolean" },
      const_1.default,
      enum_1.default
    ];
    exports2.default = validation;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/additionalItems.js
var require_additionalItems = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/additionalItems.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateAdditionalItems = void 0;
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var error = {
      message: ({ params: { len } }) => (0, codegen_1.str)`must NOT have more than ${len} items`,
      params: ({ params: { len } }) => (0, codegen_1._)`{limit: ${len}}`
    };
    var def = {
      keyword: "additionalItems",
      type: "array",
      schemaType: ["boolean", "object"],
      before: "uniqueItems",
      error,
      code(cxt) {
        const { parentSchema, it } = cxt;
        const { items } = parentSchema;
        if (!Array.isArray(items)) {
          (0, util_1.checkStrictMode)(it, '"additionalItems" is ignored when "items" is not an array of schemas');
          return;
        }
        validateAdditionalItems(cxt, items);
      }
    };
    function validateAdditionalItems(cxt, items) {
      const { gen, schema: schema2, data, keyword, it } = cxt;
      it.items = true;
      const len = gen.const("len", (0, codegen_1._)`${data}.length`);
      if (schema2 === false) {
        cxt.setParams({ len: items.length });
        cxt.pass((0, codegen_1._)`${len} <= ${items.length}`);
      } else if (typeof schema2 == "object" && !(0, util_1.alwaysValidSchema)(it, schema2)) {
        const valid = gen.var("valid", (0, codegen_1._)`${len} <= ${items.length}`);
        gen.if((0, codegen_1.not)(valid), () => validateItems(valid));
        cxt.ok(valid);
      }
      function validateItems(valid) {
        gen.forRange("i", items.length, len, (i) => {
          cxt.subschema({ keyword, dataProp: i, dataPropType: util_1.Type.Num }, valid);
          if (!it.allErrors)
            gen.if((0, codegen_1.not)(valid), () => gen.break());
        });
      }
    }
    exports2.validateAdditionalItems = validateAdditionalItems;
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/items.js
var require_items = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/items.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateTuple = void 0;
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var code_1 = require_code2();
    var def = {
      keyword: "items",
      type: "array",
      schemaType: ["object", "array", "boolean"],
      before: "uniqueItems",
      code(cxt) {
        const { schema: schema2, it } = cxt;
        if (Array.isArray(schema2))
          return validateTuple(cxt, "additionalItems", schema2);
        it.items = true;
        if ((0, util_1.alwaysValidSchema)(it, schema2))
          return;
        cxt.ok((0, code_1.validateArray)(cxt));
      }
    };
    function validateTuple(cxt, extraItems, schArr = cxt.schema) {
      const { gen, parentSchema, data, keyword, it } = cxt;
      checkStrictTuple(parentSchema);
      if (it.opts.unevaluated && schArr.length && it.items !== true) {
        it.items = util_1.mergeEvaluated.items(gen, schArr.length, it.items);
      }
      const valid = gen.name("valid");
      const len = gen.const("len", (0, codegen_1._)`${data}.length`);
      schArr.forEach((sch, i) => {
        if ((0, util_1.alwaysValidSchema)(it, sch))
          return;
        gen.if((0, codegen_1._)`${len} > ${i}`, () => cxt.subschema({
          keyword,
          schemaProp: i,
          dataProp: i
        }, valid));
        cxt.ok(valid);
      });
      function checkStrictTuple(sch) {
        const { opts, errSchemaPath } = it;
        const l = schArr.length;
        const fullTuple = l === sch.minItems && (l === sch.maxItems || sch[extraItems] === false);
        if (opts.strictTuples && !fullTuple) {
          const msg = `"${keyword}" is ${l}-tuple, but minItems or maxItems/${extraItems} are not specified or different at path "${errSchemaPath}"`;
          (0, util_1.checkStrictMode)(it, msg, opts.strictTuples);
        }
      }
    }
    exports2.validateTuple = validateTuple;
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/prefixItems.js
var require_prefixItems = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/prefixItems.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var items_1 = require_items();
    var def = {
      keyword: "prefixItems",
      type: "array",
      schemaType: ["array"],
      before: "uniqueItems",
      code: (cxt) => (0, items_1.validateTuple)(cxt, "items")
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/items2020.js
var require_items2020 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/items2020.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var code_1 = require_code2();
    var additionalItems_1 = require_additionalItems();
    var error = {
      message: ({ params: { len } }) => (0, codegen_1.str)`must NOT have more than ${len} items`,
      params: ({ params: { len } }) => (0, codegen_1._)`{limit: ${len}}`
    };
    var def = {
      keyword: "items",
      type: "array",
      schemaType: ["object", "boolean"],
      before: "uniqueItems",
      error,
      code(cxt) {
        const { schema: schema2, parentSchema, it } = cxt;
        const { prefixItems } = parentSchema;
        it.items = true;
        if ((0, util_1.alwaysValidSchema)(it, schema2))
          return;
        if (prefixItems)
          (0, additionalItems_1.validateAdditionalItems)(cxt, prefixItems);
        else
          cxt.ok((0, code_1.validateArray)(cxt));
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/contains.js
var require_contains = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/contains.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var error = {
      message: ({ params: { min, max } }) => max === void 0 ? (0, codegen_1.str)`must contain at least ${min} valid item(s)` : (0, codegen_1.str)`must contain at least ${min} and no more than ${max} valid item(s)`,
      params: ({ params: { min, max } }) => max === void 0 ? (0, codegen_1._)`{minContains: ${min}}` : (0, codegen_1._)`{minContains: ${min}, maxContains: ${max}}`
    };
    var def = {
      keyword: "contains",
      type: "array",
      schemaType: ["object", "boolean"],
      before: "uniqueItems",
      trackErrors: true,
      error,
      code(cxt) {
        const { gen, schema: schema2, parentSchema, data, it } = cxt;
        let min;
        let max;
        const { minContains, maxContains } = parentSchema;
        if (it.opts.next) {
          min = minContains === void 0 ? 1 : minContains;
          max = maxContains;
        } else {
          min = 1;
        }
        const len = gen.const("len", (0, codegen_1._)`${data}.length`);
        cxt.setParams({ min, max });
        if (max === void 0 && min === 0) {
          (0, util_1.checkStrictMode)(it, `"minContains" == 0 without "maxContains": "contains" keyword ignored`);
          return;
        }
        if (max !== void 0 && min > max) {
          (0, util_1.checkStrictMode)(it, `"minContains" > "maxContains" is always invalid`);
          cxt.fail();
          return;
        }
        if ((0, util_1.alwaysValidSchema)(it, schema2)) {
          let cond = (0, codegen_1._)`${len} >= ${min}`;
          if (max !== void 0)
            cond = (0, codegen_1._)`${cond} && ${len} <= ${max}`;
          cxt.pass(cond);
          return;
        }
        it.items = true;
        const valid = gen.name("valid");
        if (max === void 0 && min === 1) {
          validateItems(valid, () => gen.if(valid, () => gen.break()));
        } else if (min === 0) {
          gen.let(valid, true);
          if (max !== void 0)
            gen.if((0, codegen_1._)`${data}.length > 0`, validateItemsWithCount);
        } else {
          gen.let(valid, false);
          validateItemsWithCount();
        }
        cxt.result(valid, () => cxt.reset());
        function validateItemsWithCount() {
          const schValid = gen.name("_valid");
          const count = gen.let("count", 0);
          validateItems(schValid, () => gen.if(schValid, () => checkLimits(count)));
        }
        function validateItems(_valid, block) {
          gen.forRange("i", 0, len, (i) => {
            cxt.subschema({
              keyword: "contains",
              dataProp: i,
              dataPropType: util_1.Type.Num,
              compositeRule: true
            }, _valid);
            block();
          });
        }
        function checkLimits(count) {
          gen.code((0, codegen_1._)`${count}++`);
          if (max === void 0) {
            gen.if((0, codegen_1._)`${count} >= ${min}`, () => gen.assign(valid, true).break());
          } else {
            gen.if((0, codegen_1._)`${count} > ${max}`, () => gen.assign(valid, false).break());
            if (min === 1)
              gen.assign(valid, true);
            else
              gen.if((0, codegen_1._)`${count} >= ${min}`, () => gen.assign(valid, true));
          }
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/dependencies.js
var require_dependencies = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/dependencies.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateSchemaDeps = exports2.validatePropertyDeps = exports2.error = void 0;
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var code_1 = require_code2();
    exports2.error = {
      message: ({ params: { property: property4, depsCount, deps } }) => {
        const property_ies = depsCount === 1 ? "property" : "properties";
        return (0, codegen_1.str)`must have ${property_ies} ${deps} when property ${property4} is present`;
      },
      params: ({ params: { property: property4, depsCount, deps, missingProperty } }) => (0, codegen_1._)`{property: ${property4},
    missingProperty: ${missingProperty},
    depsCount: ${depsCount},
    deps: ${deps}}`
      // TODO change to reference
    };
    var def = {
      keyword: "dependencies",
      type: "object",
      schemaType: "object",
      error: exports2.error,
      code(cxt) {
        const [propDeps, schDeps] = splitDependencies(cxt);
        validatePropertyDeps(cxt, propDeps);
        validateSchemaDeps(cxt, schDeps);
      }
    };
    function splitDependencies({ schema: schema2 }) {
      const propertyDeps = {};
      const schemaDeps = {};
      for (const key in schema2) {
        if (key === "__proto__")
          continue;
        const deps = Array.isArray(schema2[key]) ? propertyDeps : schemaDeps;
        deps[key] = schema2[key];
      }
      return [propertyDeps, schemaDeps];
    }
    function validatePropertyDeps(cxt, propertyDeps = cxt.schema) {
      const { gen, data, it } = cxt;
      if (Object.keys(propertyDeps).length === 0)
        return;
      const missing = gen.let("missing");
      for (const prop in propertyDeps) {
        const deps = propertyDeps[prop];
        if (deps.length === 0)
          continue;
        const hasProperty = (0, code_1.propertyInData)(gen, data, prop, it.opts.ownProperties);
        cxt.setParams({
          property: prop,
          depsCount: deps.length,
          deps: deps.join(", ")
        });
        if (it.allErrors) {
          gen.if(hasProperty, () => {
            for (const depProp of deps) {
              (0, code_1.checkReportMissingProp)(cxt, depProp);
            }
          });
        } else {
          gen.if((0, codegen_1._)`${hasProperty} && (${(0, code_1.checkMissingProp)(cxt, deps, missing)})`);
          (0, code_1.reportMissingProp)(cxt, missing);
          gen.else();
        }
      }
    }
    exports2.validatePropertyDeps = validatePropertyDeps;
    function validateSchemaDeps(cxt, schemaDeps = cxt.schema) {
      const { gen, data, keyword, it } = cxt;
      const valid = gen.name("valid");
      for (const prop in schemaDeps) {
        if ((0, util_1.alwaysValidSchema)(it, schemaDeps[prop]))
          continue;
        gen.if(
          (0, code_1.propertyInData)(gen, data, prop, it.opts.ownProperties),
          () => {
            const schCxt = cxt.subschema({ keyword, schemaProp: prop }, valid);
            cxt.mergeValidEvaluated(schCxt, valid);
          },
          () => gen.var(valid, true)
          // TODO var
        );
        cxt.ok(valid);
      }
    }
    exports2.validateSchemaDeps = validateSchemaDeps;
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/propertyNames.js
var require_propertyNames = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/propertyNames.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var error = {
      message: "property name must be valid",
      params: ({ params }) => (0, codegen_1._)`{propertyName: ${params.propertyName}}`
    };
    var def = {
      keyword: "propertyNames",
      type: "object",
      schemaType: ["object", "boolean"],
      error,
      code(cxt) {
        const { gen, schema: schema2, data, it } = cxt;
        if ((0, util_1.alwaysValidSchema)(it, schema2))
          return;
        const valid = gen.name("valid");
        gen.forIn("key", data, (key) => {
          cxt.setParams({ propertyName: key });
          cxt.subschema({
            keyword: "propertyNames",
            data: key,
            dataTypes: ["string"],
            propertyName: key,
            compositeRule: true
          }, valid);
          gen.if((0, codegen_1.not)(valid), () => {
            cxt.error(true);
            if (!it.allErrors)
              gen.break();
          });
        });
        cxt.ok(valid);
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/additionalProperties.js
var require_additionalProperties = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/additionalProperties.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var code_1 = require_code2();
    var codegen_1 = require_codegen();
    var names_1 = require_names();
    var util_1 = require_util();
    var error = {
      message: "must NOT have additional properties",
      params: ({ params }) => (0, codegen_1._)`{additionalProperty: ${params.additionalProperty}}`
    };
    var def = {
      keyword: "additionalProperties",
      type: ["object"],
      schemaType: ["boolean", "object"],
      allowUndefined: true,
      trackErrors: true,
      error,
      code(cxt) {
        const { gen, parentSchema, data, errsCount, it } = cxt;
        const { schema: schema2 = it.opts.defaultAdditionalProperties } = cxt;
        if (!errsCount)
          throw new Error("ajv implementation error");
        const { allErrors, opts } = it;
        it.props = true;
        if (opts.removeAdditional !== "all" && (0, util_1.alwaysValidSchema)(it, schema2))
          return;
        const props = (0, code_1.allSchemaProperties)(parentSchema.properties);
        const patProps = (0, code_1.allSchemaProperties)(parentSchema.patternProperties);
        checkAdditionalProperties();
        cxt.ok((0, codegen_1._)`${errsCount} === ${names_1.default.errors}`);
        function checkAdditionalProperties() {
          gen.forIn("key", data, (key) => {
            if (!props.length && !patProps.length)
              additionalPropertyCode(key);
            else
              gen.if(isAdditional(key), () => additionalPropertyCode(key));
          });
        }
        function isAdditional(key) {
          let definedProp;
          if (props.length > 8) {
            const propsSchema = (0, util_1.schemaRefOrVal)(it, parentSchema.properties, "properties");
            definedProp = (0, code_1.isOwnProperty)(gen, propsSchema, key);
          } else if (props.length) {
            definedProp = (0, codegen_1.or)(...props.map((p) => (0, codegen_1._)`${key} === ${p}`));
          } else {
            definedProp = codegen_1.nil;
          }
          if (patProps.length) {
            definedProp = (0, codegen_1.or)(definedProp, ...patProps.map((p) => (0, codegen_1._)`${(0, code_1.usePattern)(cxt, p)}.test(${key})`));
          }
          return (0, codegen_1.not)(definedProp);
        }
        function deleteAdditional(key) {
          gen.code((0, codegen_1._)`delete ${data}[${key}]`);
        }
        function additionalPropertyCode(key) {
          if (opts.removeAdditional === "all" || opts.removeAdditional && schema2 === false) {
            deleteAdditional(key);
            return;
          }
          if (schema2 === false) {
            cxt.setParams({ additionalProperty: key });
            cxt.error();
            if (!allErrors)
              gen.break();
            return;
          }
          if (typeof schema2 == "object" && !(0, util_1.alwaysValidSchema)(it, schema2)) {
            const valid = gen.name("valid");
            if (opts.removeAdditional === "failing") {
              applyAdditionalSchema(key, valid, false);
              gen.if((0, codegen_1.not)(valid), () => {
                cxt.reset();
                deleteAdditional(key);
              });
            } else {
              applyAdditionalSchema(key, valid);
              if (!allErrors)
                gen.if((0, codegen_1.not)(valid), () => gen.break());
            }
          }
        }
        function applyAdditionalSchema(key, valid, errors) {
          const subschema = {
            keyword: "additionalProperties",
            dataProp: key,
            dataPropType: util_1.Type.Str
          };
          if (errors === false) {
            Object.assign(subschema, {
              compositeRule: true,
              createErrors: false,
              allErrors: false
            });
          }
          cxt.subschema(subschema, valid);
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/properties.js
var require_properties = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/properties.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var validate_1 = require_validate();
    var code_1 = require_code2();
    var util_1 = require_util();
    var additionalProperties_1 = require_additionalProperties();
    var def = {
      keyword: "properties",
      type: "object",
      schemaType: "object",
      code(cxt) {
        const { gen, schema: schema2, parentSchema, data, it } = cxt;
        if (it.opts.removeAdditional === "all" && parentSchema.additionalProperties === void 0 || it.opts.defaultAdditionalProperties === false) {
          additionalProperties_1.default.code(new validate_1.KeywordCxt(it, additionalProperties_1.default, "additionalProperties"));
        }
        const allProps = (0, code_1.allSchemaProperties)(schema2);
        for (const prop of allProps) {
          it.definedProperties.add(prop);
        }
        if (it.opts.unevaluated && allProps.length && it.props !== true) {
          it.props = util_1.mergeEvaluated.props(gen, (0, util_1.toHash)(allProps), it.props);
        }
        const properties = allProps.filter((p) => !(0, util_1.alwaysValidSchema)(it, schema2[p]));
        if (properties.length === 0)
          return;
        const valid = gen.name("valid");
        for (const prop of properties) {
          if (hasDefault(prop)) {
            applyPropertySchema(prop);
          } else {
            gen.if((0, code_1.propertyInData)(gen, data, prop, it.opts.ownProperties));
            applyPropertySchema(prop);
            if (!it.allErrors)
              gen.else().var(valid, true);
            gen.endIf();
          }
          cxt.it.definedProperties.add(prop);
          cxt.ok(valid);
        }
        function hasDefault(prop) {
          return it.opts.useDefaults && !it.compositeRule && schema2[prop].default !== void 0;
        }
        function applyPropertySchema(prop) {
          cxt.subschema({
            keyword: "properties",
            schemaProp: prop,
            dataProp: prop
          }, valid);
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/patternProperties.js
var require_patternProperties = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/patternProperties.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var code_1 = require_code2();
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var util_2 = require_util();
    var def = {
      keyword: "patternProperties",
      type: "object",
      schemaType: "object",
      code(cxt) {
        const { gen, schema: schema2, data, parentSchema, it } = cxt;
        const { opts } = it;
        const patterns = (0, code_1.allSchemaProperties)(schema2);
        const alwaysValidPatterns = patterns.filter((p) => (0, util_1.alwaysValidSchema)(it, schema2[p]));
        if (patterns.length === 0 || alwaysValidPatterns.length === patterns.length && (!it.opts.unevaluated || it.props === true)) {
          return;
        }
        const checkProperties = opts.strictSchema && !opts.allowMatchingProperties && parentSchema.properties;
        const valid = gen.name("valid");
        if (it.props !== true && !(it.props instanceof codegen_1.Name)) {
          it.props = (0, util_2.evaluatedPropsToName)(gen, it.props);
        }
        const { props } = it;
        validatePatternProperties();
        function validatePatternProperties() {
          for (const pat of patterns) {
            if (checkProperties)
              checkMatchingProperties(pat);
            if (it.allErrors) {
              validateProperties(pat);
            } else {
              gen.var(valid, true);
              validateProperties(pat);
              gen.if(valid);
            }
          }
        }
        function checkMatchingProperties(pat) {
          for (const prop in checkProperties) {
            if (new RegExp(pat).test(prop)) {
              (0, util_1.checkStrictMode)(it, `property ${prop} matches pattern ${pat} (use allowMatchingProperties)`);
            }
          }
        }
        function validateProperties(pat) {
          gen.forIn("key", data, (key) => {
            gen.if((0, codegen_1._)`${(0, code_1.usePattern)(cxt, pat)}.test(${key})`, () => {
              const alwaysValid = alwaysValidPatterns.includes(pat);
              if (!alwaysValid) {
                cxt.subschema({
                  keyword: "patternProperties",
                  schemaProp: pat,
                  dataProp: key,
                  dataPropType: util_2.Type.Str
                }, valid);
              }
              if (it.opts.unevaluated && props !== true) {
                gen.assign((0, codegen_1._)`${props}[${key}]`, true);
              } else if (!alwaysValid && !it.allErrors) {
                gen.if((0, codegen_1.not)(valid), () => gen.break());
              }
            });
          });
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/not.js
var require_not = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/not.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var util_1 = require_util();
    var def = {
      keyword: "not",
      schemaType: ["object", "boolean"],
      trackErrors: true,
      code(cxt) {
        const { gen, schema: schema2, it } = cxt;
        if ((0, util_1.alwaysValidSchema)(it, schema2)) {
          cxt.fail();
          return;
        }
        const valid = gen.name("valid");
        cxt.subschema({
          keyword: "not",
          compositeRule: true,
          createErrors: false,
          allErrors: false
        }, valid);
        cxt.failResult(valid, () => cxt.reset(), () => cxt.error());
      },
      error: { message: "must NOT be valid" }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/anyOf.js
var require_anyOf = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/anyOf.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var code_1 = require_code2();
    var def = {
      keyword: "anyOf",
      schemaType: "array",
      trackErrors: true,
      code: code_1.validateUnion,
      error: { message: "must match a schema in anyOf" }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/oneOf.js
var require_oneOf = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/oneOf.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var error = {
      message: "must match exactly one schema in oneOf",
      params: ({ params }) => (0, codegen_1._)`{passingSchemas: ${params.passing}}`
    };
    var def = {
      keyword: "oneOf",
      schemaType: "array",
      trackErrors: true,
      error,
      code(cxt) {
        const { gen, schema: schema2, parentSchema, it } = cxt;
        if (!Array.isArray(schema2))
          throw new Error("ajv implementation error");
        if (it.opts.discriminator && parentSchema.discriminator)
          return;
        const schArr = schema2;
        const valid = gen.let("valid", false);
        const passing = gen.let("passing", null);
        const schValid = gen.name("_valid");
        cxt.setParams({ passing });
        gen.block(validateOneOf);
        cxt.result(valid, () => cxt.reset(), () => cxt.error(true));
        function validateOneOf() {
          schArr.forEach((sch, i) => {
            let schCxt;
            if ((0, util_1.alwaysValidSchema)(it, sch)) {
              gen.var(schValid, true);
            } else {
              schCxt = cxt.subschema({
                keyword: "oneOf",
                schemaProp: i,
                compositeRule: true
              }, schValid);
            }
            if (i > 0) {
              gen.if((0, codegen_1._)`${schValid} && ${valid}`).assign(valid, false).assign(passing, (0, codegen_1._)`[${passing}, ${i}]`).else();
            }
            gen.if(schValid, () => {
              gen.assign(valid, true);
              gen.assign(passing, i);
              if (schCxt)
                cxt.mergeEvaluated(schCxt, codegen_1.Name);
            });
          });
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/allOf.js
var require_allOf = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/allOf.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var util_1 = require_util();
    var def = {
      keyword: "allOf",
      schemaType: "array",
      code(cxt) {
        const { gen, schema: schema2, it } = cxt;
        if (!Array.isArray(schema2))
          throw new Error("ajv implementation error");
        const valid = gen.name("valid");
        schema2.forEach((sch, i) => {
          if ((0, util_1.alwaysValidSchema)(it, sch))
            return;
          const schCxt = cxt.subschema({ keyword: "allOf", schemaProp: i }, valid, true);
          cxt.ok(valid);
          cxt.mergeEvaluated(schCxt);
        });
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/if.js
var require_if = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/if.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var error = {
      message: ({ params }) => (0, codegen_1.str)`must match "${params.ifClause}" schema`,
      params: ({ params }) => (0, codegen_1._)`{failingKeyword: ${params.ifClause}}`
    };
    var def = {
      keyword: "if",
      schemaType: ["object", "boolean"],
      trackErrors: true,
      error,
      code(cxt) {
        const { gen, parentSchema, it } = cxt;
        if (parentSchema.then === void 0 && parentSchema.else === void 0) {
          (0, util_1.checkStrictMode)(it, '"if" without "then" and "else" is ignored');
        }
        const hasThen = hasSchema(it, "then");
        const hasElse = hasSchema(it, "else");
        if (!hasThen && !hasElse)
          return;
        const valid = gen.let("valid", true);
        const schValid = gen.name("_valid");
        validateIf();
        cxt.reset();
        if (hasThen && hasElse) {
          const ifClause = gen.let("ifClause");
          cxt.setParams({ ifClause });
          gen.if(schValid, validateClause("then", ifClause), validateClause("else", ifClause));
        } else if (hasThen) {
          gen.if(schValid, validateClause("then"));
        } else {
          gen.if((0, codegen_1.not)(schValid), validateClause("else"));
        }
        cxt.pass(valid, () => cxt.error(true));
        function validateIf() {
          const schCxt = cxt.subschema({
            keyword: "if",
            compositeRule: true,
            createErrors: false,
            allErrors: false
          }, schValid);
          cxt.mergeEvaluated(schCxt);
        }
        function validateClause(keyword, ifClause) {
          return () => {
            const schCxt = cxt.subschema({ keyword }, schValid);
            gen.assign(valid, schValid);
            cxt.mergeValidEvaluated(schCxt, valid);
            if (ifClause)
              gen.assign(ifClause, (0, codegen_1._)`${keyword}`);
            else
              cxt.setParams({ ifClause: keyword });
          };
        }
      }
    };
    function hasSchema(it, keyword) {
      const schema2 = it.schema[keyword];
      return schema2 !== void 0 && !(0, util_1.alwaysValidSchema)(it, schema2);
    }
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/thenElse.js
var require_thenElse = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/thenElse.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var util_1 = require_util();
    var def = {
      keyword: ["then", "else"],
      schemaType: ["object", "boolean"],
      code({ keyword, parentSchema, it }) {
        if (parentSchema.if === void 0)
          (0, util_1.checkStrictMode)(it, `"${keyword}" without "if" is ignored`);
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/index.js
var require_applicator = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var additionalItems_1 = require_additionalItems();
    var prefixItems_1 = require_prefixItems();
    var items_1 = require_items();
    var items2020_1 = require_items2020();
    var contains_1 = require_contains();
    var dependencies_1 = require_dependencies();
    var propertyNames_1 = require_propertyNames();
    var additionalProperties_1 = require_additionalProperties();
    var properties_1 = require_properties();
    var patternProperties_1 = require_patternProperties();
    var not_1 = require_not();
    var anyOf_1 = require_anyOf();
    var oneOf_1 = require_oneOf();
    var allOf_1 = require_allOf();
    var if_1 = require_if();
    var thenElse_1 = require_thenElse();
    function getApplicator(draft2020 = false) {
      const applicator = [
        // any
        not_1.default,
        anyOf_1.default,
        oneOf_1.default,
        allOf_1.default,
        if_1.default,
        thenElse_1.default,
        // object
        propertyNames_1.default,
        additionalProperties_1.default,
        dependencies_1.default,
        properties_1.default,
        patternProperties_1.default
      ];
      if (draft2020)
        applicator.push(prefixItems_1.default, items2020_1.default);
      else
        applicator.push(additionalItems_1.default, items_1.default);
      applicator.push(contains_1.default);
      return applicator;
    }
    exports2.default = getApplicator;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/dynamicAnchor.js
var require_dynamicAnchor = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/dynamicAnchor.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.dynamicAnchor = void 0;
    var codegen_1 = require_codegen();
    var names_1 = require_names();
    var compile_1 = require_compile();
    var ref_1 = require_ref();
    var def = {
      keyword: "$dynamicAnchor",
      schemaType: "string",
      code: (cxt) => dynamicAnchor(cxt, cxt.schema)
    };
    function dynamicAnchor(cxt, anchor) {
      const { gen, it } = cxt;
      it.schemaEnv.root.dynamicAnchors[anchor] = true;
      const v = (0, codegen_1._)`${names_1.default.dynamicAnchors}${(0, codegen_1.getProperty)(anchor)}`;
      const validate = it.errSchemaPath === "#" ? it.validateName : _getValidate(cxt);
      gen.if((0, codegen_1._)`!${v}`, () => gen.assign(v, validate));
    }
    exports2.dynamicAnchor = dynamicAnchor;
    function _getValidate(cxt) {
      const { schemaEnv, schema: schema2, self: self2 } = cxt.it;
      const { root: root2, baseId, localRefs, meta } = schemaEnv.root;
      const { schemaId } = self2.opts;
      const sch = new compile_1.SchemaEnv({ schema: schema2, schemaId, root: root2, baseId, localRefs, meta });
      compile_1.compileSchema.call(self2, sch);
      return (0, ref_1.getValidate)(cxt, sch);
    }
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/dynamicRef.js
var require_dynamicRef = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/dynamicRef.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.dynamicRef = void 0;
    var codegen_1 = require_codegen();
    var names_1 = require_names();
    var ref_1 = require_ref();
    var def = {
      keyword: "$dynamicRef",
      schemaType: "string",
      code: (cxt) => dynamicRef(cxt, cxt.schema)
    };
    function dynamicRef(cxt, ref) {
      const { gen, keyword, it } = cxt;
      if (ref[0] !== "#")
        throw new Error(`"${keyword}" only supports hash fragment reference`);
      const anchor = ref.slice(1);
      if (it.allErrors) {
        _dynamicRef();
      } else {
        const valid = gen.let("valid", false);
        _dynamicRef(valid);
        cxt.ok(valid);
      }
      function _dynamicRef(valid) {
        if (it.schemaEnv.root.dynamicAnchors[anchor]) {
          const v = gen.let("_v", (0, codegen_1._)`${names_1.default.dynamicAnchors}${(0, codegen_1.getProperty)(anchor)}`);
          gen.if(v, _callRef(v, valid), _callRef(it.validateName, valid));
        } else {
          _callRef(it.validateName, valid)();
        }
      }
      function _callRef(validate, valid) {
        return valid ? () => gen.block(() => {
          (0, ref_1.callRef)(cxt, validate);
          gen.let(valid, true);
        }) : () => (0, ref_1.callRef)(cxt, validate);
      }
    }
    exports2.dynamicRef = dynamicRef;
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/recursiveAnchor.js
var require_recursiveAnchor = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/recursiveAnchor.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var dynamicAnchor_1 = require_dynamicAnchor();
    var util_1 = require_util();
    var def = {
      keyword: "$recursiveAnchor",
      schemaType: "boolean",
      code(cxt) {
        if (cxt.schema)
          (0, dynamicAnchor_1.dynamicAnchor)(cxt, "");
        else
          (0, util_1.checkStrictMode)(cxt.it, "$recursiveAnchor: false is ignored");
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/recursiveRef.js
var require_recursiveRef = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/recursiveRef.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var dynamicRef_1 = require_dynamicRef();
    var def = {
      keyword: "$recursiveRef",
      schemaType: "string",
      code: (cxt) => (0, dynamicRef_1.dynamicRef)(cxt, cxt.schema)
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/index.js
var require_dynamic = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var dynamicAnchor_1 = require_dynamicAnchor();
    var dynamicRef_1 = require_dynamicRef();
    var recursiveAnchor_1 = require_recursiveAnchor();
    var recursiveRef_1 = require_recursiveRef();
    var dynamic = [dynamicAnchor_1.default, dynamicRef_1.default, recursiveAnchor_1.default, recursiveRef_1.default];
    exports2.default = dynamic;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/dependentRequired.js
var require_dependentRequired = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/dependentRequired.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var dependencies_1 = require_dependencies();
    var def = {
      keyword: "dependentRequired",
      type: "object",
      schemaType: "object",
      error: dependencies_1.error,
      code: (cxt) => (0, dependencies_1.validatePropertyDeps)(cxt)
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/dependentSchemas.js
var require_dependentSchemas = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/dependentSchemas.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var dependencies_1 = require_dependencies();
    var def = {
      keyword: "dependentSchemas",
      type: "object",
      schemaType: "object",
      code: (cxt) => (0, dependencies_1.validateSchemaDeps)(cxt)
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitContains.js
var require_limitContains = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitContains.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var util_1 = require_util();
    var def = {
      keyword: ["maxContains", "minContains"],
      type: "array",
      schemaType: "number",
      code({ keyword, parentSchema, it }) {
        if (parentSchema.contains === void 0) {
          (0, util_1.checkStrictMode)(it, `"${keyword}" without "contains" is ignored`);
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/next.js
var require_next2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/next.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var dependentRequired_1 = require_dependentRequired();
    var dependentSchemas_1 = require_dependentSchemas();
    var limitContains_1 = require_limitContains();
    var next = [dependentRequired_1.default, dependentSchemas_1.default, limitContains_1.default];
    exports2.default = next;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/unevaluated/unevaluatedProperties.js
var require_unevaluatedProperties = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/unevaluated/unevaluatedProperties.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var names_1 = require_names();
    var error = {
      message: "must NOT have unevaluated properties",
      params: ({ params }) => (0, codegen_1._)`{unevaluatedProperty: ${params.unevaluatedProperty}}`
    };
    var def = {
      keyword: "unevaluatedProperties",
      type: "object",
      schemaType: ["boolean", "object"],
      allowUndefined: true,
      trackErrors: true,
      error,
      code(cxt) {
        const { gen, schema: schema2 = cxt.it.opts.defaultUnevaluatedProperties, data, errsCount, it } = cxt;
        const isForced = cxt.schema === void 0 && cxt.it.opts.defaultUnevaluatedProperties === false;
        if (!errsCount)
          throw new Error("ajv implementation error");
        const { allErrors, props } = it;
        if (props instanceof codegen_1.Name) {
          gen.if((0, codegen_1._)`${props} !== true`, () => gen.forIn("key", data, (key) => gen.if(unevaluatedDynamic(props, key), () => unevaluatedPropCode(key))));
        } else if (props !== true) {
          const staticCheck = () => gen.forIn("key", data, (key) => props === void 0 ? unevaluatedPropCode(key) : gen.if(unevaluatedStatic(props, key), () => unevaluatedPropCode(key)));
          if (isForced && it.errorPath.emptyStr()) {
            gen.if((0, codegen_1._)`${names_1.default.isAllOfVariant} === 0`, staticCheck);
          } else {
            staticCheck();
          }
        }
        if (!isForced) {
          it.props = true;
        }
        cxt.ok((0, codegen_1._)`${errsCount} === ${names_1.default.errors}`);
        function unevaluatedPropCode(key) {
          if (schema2 === false) {
            cxt.setParams({ unevaluatedProperty: key });
            cxt.error();
            if (!allErrors)
              gen.break();
            return;
          }
          if (!(0, util_1.alwaysValidSchema)(it, schema2)) {
            const valid = gen.name("valid");
            cxt.subschema({
              keyword: "unevaluatedProperties",
              dataProp: key,
              dataPropType: util_1.Type.Str
            }, valid);
            if (!allErrors)
              gen.if((0, codegen_1.not)(valid), () => gen.break());
          }
        }
        function unevaluatedDynamic(evaluatedProps, key) {
          return (0, codegen_1._)`!${evaluatedProps} || !${evaluatedProps}[${key}]`;
        }
        function unevaluatedStatic(evaluatedProps, key) {
          const ps = [];
          for (const p in evaluatedProps) {
            if (evaluatedProps[p] === true)
              ps.push((0, codegen_1._)`${key} !== ${p}`);
          }
          return (0, codegen_1.and)(...ps);
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/unevaluated/unevaluatedItems.js
var require_unevaluatedItems = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/unevaluated/unevaluatedItems.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var error = {
      message: ({ params: { len } }) => (0, codegen_1.str)`must NOT have more than ${len} items`,
      params: ({ params: { len } }) => (0, codegen_1._)`{limit: ${len}}`
    };
    var def = {
      keyword: "unevaluatedItems",
      type: "array",
      schemaType: ["boolean", "object"],
      error,
      code(cxt) {
        const { gen, schema: schema2, data, it } = cxt;
        const items = it.items || 0;
        if (items === true)
          return;
        const len = gen.const("len", (0, codegen_1._)`${data}.length`);
        if (schema2 === false) {
          cxt.setParams({ len: items });
          cxt.fail((0, codegen_1._)`${len} > ${items}`);
        } else if (typeof schema2 == "object" && !(0, util_1.alwaysValidSchema)(it, schema2)) {
          const valid = gen.var("valid", (0, codegen_1._)`${len} <= ${items}`);
          gen.if((0, codegen_1.not)(valid), () => validateItems(valid, items));
          cxt.ok(valid);
        }
        it.items = true;
        function validateItems(valid, from) {
          gen.forRange("i", from, len, (i) => {
            cxt.subschema({ keyword: "unevaluatedItems", dataProp: i, dataPropType: util_1.Type.Num }, valid);
            if (!it.allErrors)
              gen.if((0, codegen_1.not)(valid), () => gen.break());
          });
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/unevaluated/index.js
var require_unevaluated = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/unevaluated/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var unevaluatedProperties_1 = require_unevaluatedProperties();
    var unevaluatedItems_1 = require_unevaluatedItems();
    var unevaluated = [unevaluatedProperties_1.default, unevaluatedItems_1.default];
    exports2.default = unevaluated;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/format/format.js
var require_format = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/format/format.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var error = {
      message: ({ schemaCode }) => (0, codegen_1.str)`must match format "${schemaCode}"`,
      params: ({ schemaCode }) => (0, codegen_1._)`{format: ${schemaCode}}`
    };
    var def = {
      keyword: "format",
      type: ["number", "string"],
      schemaType: "string",
      $data: true,
      error,
      code(cxt, ruleType) {
        const { gen, data, $data, schema: schema2, schemaCode, it } = cxt;
        const { opts, errSchemaPath, schemaEnv, self: self2 } = it;
        if (!opts.validateFormats)
          return;
        if ($data)
          validate$DataFormat();
        else
          validateFormat();
        function validate$DataFormat() {
          const fmts = gen.scopeValue("formats", {
            ref: self2.formats,
            code: opts.code.formats
          });
          const fDef = gen.const("fDef", (0, codegen_1._)`${fmts}[${schemaCode}]`);
          const fType = gen.let("fType");
          const format = gen.let("format");
          gen.if((0, codegen_1._)`typeof ${fDef} == "object" && !(${fDef} instanceof RegExp)`, () => gen.assign(fType, (0, codegen_1._)`${fDef}.type || "string"`).assign(format, (0, codegen_1._)`${fDef}.validate`), () => gen.assign(fType, (0, codegen_1._)`"string"`).assign(format, fDef));
          cxt.fail$data((0, codegen_1.or)(unknownFmt(), invalidFmt()));
          function unknownFmt() {
            if (opts.strictSchema === false)
              return codegen_1.nil;
            return (0, codegen_1._)`${schemaCode} && !${format}`;
          }
          function invalidFmt() {
            const callFormat = schemaEnv.$async ? (0, codegen_1._)`(${fDef}.async ? await ${format}(${data}) : ${format}(${data}))` : (0, codegen_1._)`${format}(${data})`;
            const validData = (0, codegen_1._)`(typeof ${format} == "function" ? ${callFormat} : ${format}.test(${data}))`;
            return (0, codegen_1._)`${format} && ${format} !== true && ${fType} === ${ruleType} && !${validData}`;
          }
        }
        function validateFormat() {
          const formatDef = self2.formats[schema2];
          if (!formatDef) {
            unknownFormat();
            return;
          }
          if (formatDef === true)
            return;
          const [fmtType, format, fmtRef] = getFormat(formatDef);
          if (fmtType === ruleType)
            cxt.pass(validCondition());
          function unknownFormat() {
            if (opts.strictSchema === false) {
              self2.logger.warn(unknownMsg());
              return;
            }
            throw new Error(unknownMsg());
            function unknownMsg() {
              return `unknown format "${schema2}" ignored in schema at path "${errSchemaPath}"`;
            }
          }
          function getFormat(fmtDef) {
            const code = fmtDef instanceof RegExp ? (0, codegen_1.regexpCode)(fmtDef) : opts.code.formats ? (0, codegen_1._)`${opts.code.formats}${(0, codegen_1.getProperty)(schema2)}` : void 0;
            const fmt = gen.scopeValue("formats", { key: schema2, ref: fmtDef, code });
            if (typeof fmtDef == "object" && !(fmtDef instanceof RegExp)) {
              return [fmtDef.type || "string", fmtDef.validate, (0, codegen_1._)`${fmt}.validate`];
            }
            return ["string", fmtDef, fmt];
          }
          function validCondition() {
            if (typeof formatDef == "object" && !(formatDef instanceof RegExp) && formatDef.async) {
              if (!schemaEnv.$async)
                throw new Error("async format in sync schema");
              return (0, codegen_1._)`await ${fmtRef}(${data})`;
            }
            return typeof format == "function" ? (0, codegen_1._)`${fmtRef}(${data})` : (0, codegen_1._)`${fmtRef}.test(${data})`;
          }
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/format/index.js
var require_format2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/format/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var format_1 = require_format();
    var format = [format_1.default];
    exports2.default = format;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/metadata.js
var require_metadata = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/metadata.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.contentVocabulary = exports2.metadataVocabulary = void 0;
    exports2.metadataVocabulary = [
      "title",
      "description",
      "default",
      "deprecated",
      "readOnly",
      "writeOnly",
      "examples"
    ];
    exports2.contentVocabulary = [
      "contentMediaType",
      "contentEncoding",
      "contentSchema"
    ];
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/draft2020.js
var require_draft2020 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/draft2020.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var core_1 = require_core3();
    var validation_1 = require_validation();
    var applicator_1 = require_applicator();
    var dynamic_1 = require_dynamic();
    var next_1 = require_next2();
    var unevaluated_1 = require_unevaluated();
    var format_1 = require_format2();
    var metadata_1 = require_metadata();
    var draft2020Vocabularies = [
      dynamic_1.default,
      core_1.default,
      validation_1.default,
      (0, applicator_1.default)(true),
      format_1.default,
      metadata_1.metadataVocabulary,
      metadata_1.contentVocabulary,
      next_1.default,
      unevaluated_1.default
    ];
    exports2.default = draft2020Vocabularies;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/discriminator/types.js
var require_types3 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/discriminator/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.DiscrError = void 0;
    var DiscrError;
    (function(DiscrError2) {
      DiscrError2["Tag"] = "tag";
      DiscrError2["Mapping"] = "mapping";
    })(DiscrError = exports2.DiscrError || (exports2.DiscrError = {}));
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/discriminator/index.js
var require_discriminator = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/discriminator/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var types_1 = require_types3();
    var compile_1 = require_compile();
    var util_1 = require_util();
    var error = {
      message: ({ params: { discrError, tagName } }) => discrError === types_1.DiscrError.Tag ? `tag "${tagName}" must be string` : `value of tag "${tagName}" must be in oneOf or anyOf`,
      params: ({ params: { discrError, tag, tagName } }) => (0, codegen_1._)`{error: ${discrError}, tag: ${tagName}, tagValue: ${tag}}`
    };
    var def = {
      keyword: "discriminator",
      type: "object",
      schemaType: "object",
      error,
      code(cxt) {
        const { gen, data, schema: schema2, parentSchema, it } = cxt;
        const keyword = parentSchema.oneOf ? "oneOf" : parentSchema.anyOf ? "anyOf" : void 0;
        if (!it.opts.discriminator) {
          throw new Error("discriminator: requires discriminator option");
        }
        const tagName = schema2.propertyName;
        if (typeof tagName != "string")
          throw new Error("discriminator: requires propertyName");
        if (!keyword)
          throw new Error("discriminator: requires oneOf or anyOf composite keyword");
        const parentSchemaVariants = parentSchema[keyword];
        const valid = gen.let("valid", false);
        const tag = gen.const("tag", (0, codegen_1._)`${data}${(0, codegen_1.getProperty)(tagName)}`);
        gen.if((0, codegen_1._)`typeof ${tag} == "string"`, () => validateMapping(), () => cxt.error(false, { discrError: types_1.DiscrError.Tag, tag, tagName }));
        cxt.ok(valid);
        function validateMapping() {
          const mapping = getMapping();
          gen.if(false);
          for (const tagValue in mapping) {
            gen.elseIf((0, codegen_1._)`${tag} === ${tagValue}`);
            gen.assign(valid, applyTagSchema(mapping[tagValue]));
          }
          gen.else();
          cxt.error(false, { discrError: types_1.DiscrError.Mapping, tag, tagName });
          gen.endIf();
        }
        function applyTagSchema(schemaProp) {
          const _valid = gen.name("valid");
          const schCxt = cxt.subschema({ keyword, schemaProp }, _valid);
          cxt.mergeEvaluated(schCxt, codegen_1.Name);
          return _valid;
        }
        function getMapping() {
          var _a;
          const discriminatorMapping = {};
          const topRequired = hasRequired(parentSchema);
          let tagRequired = true;
          for (let i = 0; i < parentSchemaVariants.length; i++) {
            let sch = parentSchemaVariants[i];
            const schRef = sch === null || sch === void 0 ? void 0 : sch.$ref;
            if (schRef && schema2.mapping) {
              const { mapping } = schema2;
              const matchedKeys = Object.keys(mapping).filter((key) => mapping[key] === sch.$ref);
              if (matchedKeys.length) {
                for (const key of matchedKeys) {
                  addMapping(key, i);
                }
                continue;
              }
            }
            if (schRef && !(0, util_1.schemaHasRulesButRef)(sch, it.self.RULES)) {
              sch = compile_1.resolveRef.call(it.self, it.schemaEnv.root, it.baseId, schRef);
              if (sch instanceof compile_1.SchemaEnv)
                sch = sch.schema;
            }
            const propSch = (_a = sch === null || sch === void 0 ? void 0 : sch.properties) === null || _a === void 0 ? void 0 : _a[tagName];
            if (typeof propSch != "object") {
              throw new Error(`discriminator: ${keyword} subschemas (or referenced schemas) must have "properties/${tagName}" or match mapping`);
            }
            tagRequired = tagRequired && (topRequired || hasRequired(sch));
            addMappings(propSch, i);
          }
          if (!tagRequired)
            throw new Error(`discriminator: "${tagName}" must be required`);
          return discriminatorMapping;
          function hasRequired({ required }) {
            return Array.isArray(required) && required.includes(tagName);
          }
          function addMappings(sch, i) {
            if (sch.const) {
              addMapping(sch.const, i);
            } else if (sch.enum) {
              for (const tagValue of sch.enum) {
                addMapping(tagValue, i);
              }
            } else {
              throw new Error(`discriminator: "properties/${tagName}" must have "const" or "enum"`);
            }
          }
          function addMapping(tagValue, i) {
            if (typeof tagValue != "string" || tagValue in discriminatorMapping) {
              throw new Error(`discriminator: "${tagName}" values must be unique strings`);
            }
            discriminatorMapping[tagValue] = i;
          }
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/schema.json
var require_schema5 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/schema.json"(exports2, module2) {
    module2.exports = {
      $schema: "https://json-schema.org/draft/2020-12/schema",
      $id: "https://json-schema.org/draft/2020-12/schema",
      $vocabulary: {
        "https://json-schema.org/draft/2020-12/vocab/core": true,
        "https://json-schema.org/draft/2020-12/vocab/applicator": true,
        "https://json-schema.org/draft/2020-12/vocab/unevaluated": true,
        "https://json-schema.org/draft/2020-12/vocab/validation": true,
        "https://json-schema.org/draft/2020-12/vocab/meta-data": true,
        "https://json-schema.org/draft/2020-12/vocab/format-annotation": true,
        "https://json-schema.org/draft/2020-12/vocab/content": true
      },
      $dynamicAnchor: "meta",
      title: "Core and Validation specifications meta-schema",
      allOf: [
        { $ref: "meta/core" },
        { $ref: "meta/applicator" },
        { $ref: "meta/unevaluated" },
        { $ref: "meta/validation" },
        { $ref: "meta/meta-data" },
        { $ref: "meta/format-annotation" },
        { $ref: "meta/content" }
      ],
      type: ["object", "boolean"],
      $comment: "This meta-schema also defines keywords that have appeared in previous drafts in order to prevent incompatible extensions as they remain in common use.",
      properties: {
        definitions: {
          $comment: '"definitions" has been replaced by "$defs".',
          type: "object",
          additionalProperties: { $dynamicRef: "#meta" },
          deprecated: true,
          default: {}
        },
        dependencies: {
          $comment: '"dependencies" has been split and replaced by "dependentSchemas" and "dependentRequired" in order to serve their differing semantics.',
          type: "object",
          additionalProperties: {
            anyOf: [{ $dynamicRef: "#meta" }, { $ref: "meta/validation#/$defs/stringArray" }]
          },
          deprecated: true,
          default: {}
        },
        $recursiveAnchor: {
          $comment: '"$recursiveAnchor" has been replaced by "$dynamicAnchor".',
          $ref: "meta/core#/$defs/anchorString",
          deprecated: true
        },
        $recursiveRef: {
          $comment: '"$recursiveRef" has been replaced by "$dynamicRef".',
          $ref: "meta/core#/$defs/uriReferenceString",
          deprecated: true
        }
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/applicator.json
var require_applicator2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/applicator.json"(exports2, module2) {
    module2.exports = {
      $schema: "https://json-schema.org/draft/2020-12/schema",
      $id: "https://json-schema.org/draft/2020-12/meta/applicator",
      $vocabulary: {
        "https://json-schema.org/draft/2020-12/vocab/applicator": true
      },
      $dynamicAnchor: "meta",
      title: "Applicator vocabulary meta-schema",
      type: ["object", "boolean"],
      properties: {
        prefixItems: { $ref: "#/$defs/schemaArray" },
        items: { $dynamicRef: "#meta" },
        contains: { $dynamicRef: "#meta" },
        additionalProperties: { $dynamicRef: "#meta" },
        properties: {
          type: "object",
          additionalProperties: { $dynamicRef: "#meta" },
          default: {}
        },
        patternProperties: {
          type: "object",
          additionalProperties: { $dynamicRef: "#meta" },
          propertyNames: { format: "regex" },
          default: {}
        },
        dependentSchemas: {
          type: "object",
          additionalProperties: { $dynamicRef: "#meta" },
          default: {}
        },
        propertyNames: { $dynamicRef: "#meta" },
        if: { $dynamicRef: "#meta" },
        then: { $dynamicRef: "#meta" },
        else: { $dynamicRef: "#meta" },
        allOf: { $ref: "#/$defs/schemaArray" },
        anyOf: { $ref: "#/$defs/schemaArray" },
        oneOf: { $ref: "#/$defs/schemaArray" },
        not: { $dynamicRef: "#meta" }
      },
      $defs: {
        schemaArray: {
          type: "array",
          minItems: 1,
          items: { $dynamicRef: "#meta" }
        }
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/unevaluated.json
var require_unevaluated2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/unevaluated.json"(exports2, module2) {
    module2.exports = {
      $schema: "https://json-schema.org/draft/2020-12/schema",
      $id: "https://json-schema.org/draft/2020-12/meta/unevaluated",
      $vocabulary: {
        "https://json-schema.org/draft/2020-12/vocab/unevaluated": true
      },
      $dynamicAnchor: "meta",
      title: "Unevaluated applicator vocabulary meta-schema",
      type: ["object", "boolean"],
      properties: {
        unevaluatedItems: { $dynamicRef: "#meta" },
        unevaluatedProperties: { $dynamicRef: "#meta" }
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/content.json
var require_content = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/content.json"(exports2, module2) {
    module2.exports = {
      $schema: "https://json-schema.org/draft/2020-12/schema",
      $id: "https://json-schema.org/draft/2020-12/meta/content",
      $vocabulary: {
        "https://json-schema.org/draft/2020-12/vocab/content": true
      },
      $dynamicAnchor: "meta",
      title: "Content vocabulary meta-schema",
      type: ["object", "boolean"],
      properties: {
        contentEncoding: { type: "string" },
        contentMediaType: { type: "string" },
        contentSchema: { $dynamicRef: "#meta" }
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/core.json
var require_core4 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/core.json"(exports2, module2) {
    module2.exports = {
      $schema: "https://json-schema.org/draft/2020-12/schema",
      $id: "https://json-schema.org/draft/2020-12/meta/core",
      $vocabulary: {
        "https://json-schema.org/draft/2020-12/vocab/core": true
      },
      $dynamicAnchor: "meta",
      title: "Core vocabulary meta-schema",
      type: ["object", "boolean"],
      properties: {
        $id: {
          $ref: "#/$defs/uriReferenceString",
          $comment: "Non-empty fragments not allowed.",
          pattern: "^[^#]*#?$"
        },
        $schema: { $ref: "#/$defs/uriString" },
        $ref: { $ref: "#/$defs/uriReferenceString" },
        $anchor: { $ref: "#/$defs/anchorString" },
        $dynamicRef: { $ref: "#/$defs/uriReferenceString" },
        $dynamicAnchor: { $ref: "#/$defs/anchorString" },
        $vocabulary: {
          type: "object",
          propertyNames: { $ref: "#/$defs/uriString" },
          additionalProperties: {
            type: "boolean"
          }
        },
        $comment: {
          type: "string"
        },
        $defs: {
          type: "object",
          additionalProperties: { $dynamicRef: "#meta" }
        }
      },
      $defs: {
        anchorString: {
          type: "string",
          pattern: "^[A-Za-z_][-A-Za-z0-9._]*$"
        },
        uriString: {
          type: "string",
          format: "uri"
        },
        uriReferenceString: {
          type: "string",
          format: "uri-reference"
        }
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/format-annotation.json
var require_format_annotation = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/format-annotation.json"(exports2, module2) {
    module2.exports = {
      $schema: "https://json-schema.org/draft/2020-12/schema",
      $id: "https://json-schema.org/draft/2020-12/meta/format-annotation",
      $vocabulary: {
        "https://json-schema.org/draft/2020-12/vocab/format-annotation": true
      },
      $dynamicAnchor: "meta",
      title: "Format vocabulary meta-schema for annotation results",
      type: ["object", "boolean"],
      properties: {
        format: { type: "string" }
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/meta-data.json
var require_meta_data = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/meta-data.json"(exports2, module2) {
    module2.exports = {
      $schema: "https://json-schema.org/draft/2020-12/schema",
      $id: "https://json-schema.org/draft/2020-12/meta/meta-data",
      $vocabulary: {
        "https://json-schema.org/draft/2020-12/vocab/meta-data": true
      },
      $dynamicAnchor: "meta",
      title: "Meta-data vocabulary meta-schema",
      type: ["object", "boolean"],
      properties: {
        title: {
          type: "string"
        },
        description: {
          type: "string"
        },
        default: true,
        deprecated: {
          type: "boolean",
          default: false
        },
        readOnly: {
          type: "boolean",
          default: false
        },
        writeOnly: {
          type: "boolean",
          default: false
        },
        examples: {
          type: "array",
          items: true
        }
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/validation.json
var require_validation2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/validation.json"(exports2, module2) {
    module2.exports = {
      $schema: "https://json-schema.org/draft/2020-12/schema",
      $id: "https://json-schema.org/draft/2020-12/meta/validation",
      $vocabulary: {
        "https://json-schema.org/draft/2020-12/vocab/validation": true
      },
      $dynamicAnchor: "meta",
      title: "Validation vocabulary meta-schema",
      type: ["object", "boolean"],
      properties: {
        type: {
          anyOf: [
            { $ref: "#/$defs/simpleTypes" },
            {
              type: "array",
              items: { $ref: "#/$defs/simpleTypes" },
              minItems: 1,
              uniqueItems: true
            }
          ]
        },
        const: true,
        enum: {
          type: "array",
          items: true
        },
        multipleOf: {
          type: "number",
          exclusiveMinimum: 0
        },
        maximum: {
          type: "number"
        },
        exclusiveMaximum: {
          type: "number"
        },
        minimum: {
          type: "number"
        },
        exclusiveMinimum: {
          type: "number"
        },
        maxLength: { $ref: "#/$defs/nonNegativeInteger" },
        minLength: { $ref: "#/$defs/nonNegativeIntegerDefault0" },
        pattern: {
          type: "string",
          format: "regex"
        },
        maxItems: { $ref: "#/$defs/nonNegativeInteger" },
        minItems: { $ref: "#/$defs/nonNegativeIntegerDefault0" },
        uniqueItems: {
          type: "boolean",
          default: false
        },
        maxContains: { $ref: "#/$defs/nonNegativeInteger" },
        minContains: {
          $ref: "#/$defs/nonNegativeInteger",
          default: 1
        },
        maxProperties: { $ref: "#/$defs/nonNegativeInteger" },
        minProperties: { $ref: "#/$defs/nonNegativeIntegerDefault0" },
        required: { $ref: "#/$defs/stringArray" },
        dependentRequired: {
          type: "object",
          additionalProperties: {
            $ref: "#/$defs/stringArray"
          }
        }
      },
      $defs: {
        nonNegativeInteger: {
          type: "integer",
          minimum: 0
        },
        nonNegativeIntegerDefault0: {
          $ref: "#/$defs/nonNegativeInteger",
          default: 0
        },
        simpleTypes: {
          enum: ["array", "boolean", "integer", "null", "number", "object", "string"]
        },
        stringArray: {
          type: "array",
          items: { type: "string" },
          uniqueItems: true,
          default: []
        }
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/index.js
var require_json_schema_2020_12 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var metaSchema = require_schema5();
    var applicator = require_applicator2();
    var unevaluated = require_unevaluated2();
    var content = require_content();
    var core2 = require_core4();
    var format = require_format_annotation();
    var metadata = require_meta_data();
    var validation = require_validation2();
    var META_SUPPORT_DATA = ["/properties"];
    function addMetaSchema2020($data) {
      ;
      [
        metaSchema,
        applicator,
        unevaluated,
        content,
        core2,
        with$data(this, format),
        metadata,
        with$data(this, validation)
      ].forEach((sch) => this.addMetaSchema(sch, void 0, false));
      return this;
      function with$data(ajv, sch) {
        return $data ? ajv.$dataMetaSchema(sch, META_SUPPORT_DATA) : sch;
      }
    }
    exports2.default = addMetaSchema2020;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/2020.js
var require__ = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/2020.js"(exports2, module2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CodeGen = exports2.Name = exports2.nil = exports2.stringify = exports2.str = exports2._ = exports2.KeywordCxt = void 0;
    var core_1 = require_core2();
    var draft2020_1 = require_draft2020();
    var discriminator_1 = require_discriminator();
    var json_schema_2020_12_1 = require_json_schema_2020_12();
    var META_SCHEMA_ID = "https://json-schema.org/draft/2020-12/schema";
    var Ajv2020 = class extends core_1.default {
      constructor(opts = {}) {
        super({
          ...opts,
          dynamicRef: true,
          next: true,
          unevaluated: true
        });
      }
      _addVocabularies() {
        super._addVocabularies();
        draft2020_1.default.forEach((v) => this.addVocabulary(v));
        if (this.opts.discriminator)
          this.addKeyword(discriminator_1.default);
      }
      _addDefaultMetaSchema() {
        super._addDefaultMetaSchema();
        const { $data, meta } = this.opts;
        if (!meta)
          return;
        json_schema_2020_12_1.default.call(this, $data);
        this.refs["http://json-schema.org/schema"] = META_SCHEMA_ID;
      }
      defaultMeta() {
        return this.opts.defaultMeta = super.defaultMeta() || (this.getSchema(META_SCHEMA_ID) ? META_SCHEMA_ID : void 0);
      }
    };
    module2.exports = exports2 = Ajv2020;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.default = Ajv2020;
    var validate_1 = require_validate();
    Object.defineProperty(exports2, "KeywordCxt", { enumerable: true, get: function() {
      return validate_1.KeywordCxt;
    } });
    var codegen_1 = require_codegen();
    Object.defineProperty(exports2, "_", { enumerable: true, get: function() {
      return codegen_1._;
    } });
    Object.defineProperty(exports2, "str", { enumerable: true, get: function() {
      return codegen_1.str;
    } });
    Object.defineProperty(exports2, "stringify", { enumerable: true, get: function() {
      return codegen_1.stringify;
    } });
    Object.defineProperty(exports2, "nil", { enumerable: true, get: function() {
      return codegen_1.nil;
    } });
    Object.defineProperty(exports2, "Name", { enumerable: true, get: function() {
      return codegen_1.Name;
    } });
    Object.defineProperty(exports2, "CodeGen", { enumerable: true, get: function() {
      return codegen_1.CodeGen;
    } });
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/ajv.js
var require_ajv = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/ajv.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateJsonSchema = exports2.releaseAjvInstance = void 0;
    var _2020_1 = require__();
    var ref_utils_1 = require_ref_utils();
    var ajvInstance = null;
    function releaseAjvInstance() {
      ajvInstance = null;
    }
    exports2.releaseAjvInstance = releaseAjvInstance;
    function getAjv(resolve, allowAdditionalProperties) {
      if (!ajvInstance) {
        ajvInstance = new _2020_1.default({
          schemaId: "$id",
          meta: true,
          allErrors: true,
          strictSchema: false,
          inlineRefs: false,
          validateSchema: false,
          discriminator: true,
          allowUnionTypes: true,
          validateFormats: false,
          defaultUnevaluatedProperties: allowAdditionalProperties,
          loadSchemaSync(base, $ref) {
            const resolvedRef = resolve({ $ref }, base.split("#")[0]);
            if (!resolvedRef || !resolvedRef.location)
              return false;
            return Object.assign({ $id: resolvedRef.location.absolutePointer }, resolvedRef.node);
          },
          logger: false
        });
      }
      return ajvInstance;
    }
    function getAjvValidator(schema2, loc, resolve, allowAdditionalProperties) {
      const ajv = getAjv(resolve, allowAdditionalProperties);
      if (!ajv.getSchema(loc.absolutePointer)) {
        ajv.addSchema(Object.assign({ $id: loc.absolutePointer }, schema2), loc.absolutePointer);
      }
      return ajv.getSchema(loc.absolutePointer);
    }
    function validateJsonSchema(data, schema2, schemaLoc, instancePath, resolve, allowAdditionalProperties) {
      const validate = getAjvValidator(schema2, schemaLoc, resolve, allowAdditionalProperties);
      if (!validate)
        return { valid: true, errors: [] };
      const valid = validate(data, {
        instancePath,
        parentData: { fake: {} },
        parentDataProperty: "fake",
        rootData: {},
        dynamicAnchors: {}
      });
      return {
        valid: !!valid,
        errors: (validate.errors || []).map(beatifyErrorMessage)
      };
      function beatifyErrorMessage(error) {
        let message = error.message;
        const suggest = error.keyword === "enum" ? error.params.allowedValues : void 0;
        if (suggest) {
          message += ` ${suggest.map((e) => `"${e}"`).join(", ")}`;
        }
        if (error.keyword === "type") {
          message = `type ${message}`;
        }
        const relativePath = error.instancePath.substring(instancePath.length + 1);
        const propName = relativePath.substring(relativePath.lastIndexOf("/") + 1);
        if (propName) {
          message = `\`${propName}\` property ${message}`;
        }
        if (error.keyword === "additionalProperties" || error.keyword === "unevaluatedProperties") {
          const property4 = error.params.additionalProperty || error.params.unevaluatedProperty;
          message = `${message} \`${property4}\``;
          error.instancePath += "/" + (0, ref_utils_1.escapePointer)(property4);
        }
        return Object.assign(Object.assign({}, error), {
          message,
          suggest
        });
      }
    }
    exports2.validateJsonSchema = validateJsonSchema;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/utils.js
var require_utils6 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateResponseCodes = exports2.validateSchemaEnumType = exports2.getAdditionalPropertiesOption = exports2.validateExample = exports2.getSuggest = exports2.validateDefinedAndNonEmpty = exports2.fieldNonEmpty = exports2.missingRequiredField = exports2.matchesJsonSchemaType = exports2.oasTypeOf = void 0;
    var levenshtein = require_js_levenshtein();
    var ref_utils_1 = require_ref_utils();
    var ajv_1 = require_ajv();
    var utils_1 = require_utils4();
    function oasTypeOf(value) {
      if (Array.isArray(value)) {
        return "array";
      } else if (value === null) {
        return "null";
      } else if (Number.isInteger(value)) {
        return "integer";
      } else {
        return typeof value;
      }
    }
    exports2.oasTypeOf = oasTypeOf;
    function matchesJsonSchemaType(value, type2, nullable) {
      if (nullable && value === null) {
        return true;
      }
      switch (type2) {
        case "array":
          return Array.isArray(value);
        case "object":
          return typeof value === "object" && value !== null && !Array.isArray(value);
        case "null":
          return value === null;
        case "integer":
          return Number.isInteger(value);
        default:
          return typeof value === type2;
      }
    }
    exports2.matchesJsonSchemaType = matchesJsonSchemaType;
    function missingRequiredField(type2, field) {
      return `${type2} object should contain \`${field}\` field.`;
    }
    exports2.missingRequiredField = missingRequiredField;
    function fieldNonEmpty(type2, field) {
      return `${type2} object \`${field}\` must be non-empty string.`;
    }
    exports2.fieldNonEmpty = fieldNonEmpty;
    function validateDefinedAndNonEmpty(fieldName, value, ctx) {
      if (typeof value !== "object") {
        return;
      }
      if (value[fieldName] === void 0) {
        ctx.report({
          message: missingRequiredField(ctx.type.name, fieldName),
          location: ctx.location.child([fieldName]).key()
        });
      } else if (!value[fieldName]) {
        ctx.report({
          message: fieldNonEmpty(ctx.type.name, fieldName),
          location: ctx.location.child([fieldName]).key()
        });
      }
    }
    exports2.validateDefinedAndNonEmpty = validateDefinedAndNonEmpty;
    function getSuggest(given, variants) {
      if (given === null)
        return variants;
      if (typeof given !== "string" || !variants.length)
        return [];
      const distances = [];
      for (let i = 0; i < variants.length; i++) {
        const distance = levenshtein(given, variants[i]);
        if (distance < 4) {
          distances.push({ distance, variant: variants[i] });
        }
      }
      distances.sort((a, b) => a.distance - b.distance);
      return distances.map((d) => d.variant);
    }
    exports2.getSuggest = getSuggest;
    function validateExample(example, schema2, dataLoc, { resolve, location, report }, allowAdditionalProperties) {
      try {
        const { valid, errors } = (0, ajv_1.validateJsonSchema)(example, schema2, location.child("schema"), dataLoc.pointer, resolve, allowAdditionalProperties);
        if (!valid) {
          for (const error of errors) {
            report({
              message: `Example value must conform to the schema: ${error.message}.`,
              location: Object.assign(Object.assign({}, new ref_utils_1.Location(dataLoc.source, error.instancePath)), { reportOnKey: error.keyword === "unevaluatedProperties" || error.keyword === "additionalProperties" }),
              from: location,
              suggest: error.suggest
            });
          }
        }
      } catch (e) {
        if (e.message === "discriminator: requires oneOf or anyOf composite keyword") {
          return;
        }
        report({
          message: `Example validation errored: ${e.message}.`,
          location: location.child("schema"),
          from: location
        });
      }
    }
    exports2.validateExample = validateExample;
    function getAdditionalPropertiesOption(opts) {
      if (opts.disallowAdditionalProperties === void 0) {
        return opts.allowAdditionalProperties;
      }
      if (opts.allowAdditionalProperties !== void 0) {
        (0, utils_1.showErrorForDeprecatedField)("disallowAdditionalProperties", "allowAdditionalProperties", void 0);
      }
      (0, utils_1.showWarningForDeprecatedField)("disallowAdditionalProperties", "allowAdditionalProperties");
      return !opts.disallowAdditionalProperties;
    }
    exports2.getAdditionalPropertiesOption = getAdditionalPropertiesOption;
    function validateSchemaEnumType(schemaEnum, propertyValue, propName, refLocation, { report, location }) {
      if (!schemaEnum) {
        return;
      }
      if (!schemaEnum.includes(propertyValue)) {
        report({
          location,
          message: `\`${propName}\` can be one of the following only: ${schemaEnum.map((type2) => `"${type2}"`).join(", ")}.`,
          from: refLocation,
          suggest: getSuggest(propertyValue, schemaEnum)
        });
      }
    }
    exports2.validateSchemaEnumType = validateSchemaEnumType;
    function validateResponseCodes(responseCodes, codeRange, { report }) {
      const responseCodeRegexp = new RegExp(`^${codeRange[0]}[0-9Xx]{2}$`);
      const containsNeededCode = responseCodes.some((code) => codeRange === "2XX" && code === "default" || // It's OK to replace 2xx codes with the default
      responseCodeRegexp.test(code));
      if (!containsNeededCode) {
        report({
          message: `Operation must have at least one \`${codeRange}\` response.`,
          location: { reportOnKey: true }
        });
      }
    }
    exports2.validateResponseCodes = validateResponseCodes;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/spec.js
var require_spec = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/spec.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Spec = void 0;
    var types_1 = require_types();
    var utils_1 = require_utils6();
    var ref_utils_1 = require_ref_utils();
    var utils_2 = require_utils4();
    var Spec = () => {
      return {
        any(node, { report, type: type2, location, rawLocation, key, resolve, ignoreNextVisitorsOnNode }) {
          var _a, _b, _c, _d, _e, _f;
          const nodeType = (0, utils_1.oasTypeOf)(node);
          const refLocation = rawLocation !== location ? rawLocation : void 0;
          if (type2.items) {
            if (nodeType !== "array") {
              report({
                message: `Expected type \`${type2.name}\` (array) but got \`${nodeType}\``,
                from: refLocation
              });
              ignoreNextVisitorsOnNode();
            }
            return;
          } else if (nodeType !== "object") {
            if (type2 !== types_1.SpecExtension) {
              report({
                message: `Expected type \`${type2.name}\` (object) but got \`${nodeType}\``,
                from: refLocation
              });
            }
            ignoreNextVisitorsOnNode();
            return;
          }
          const required = typeof type2.required === "function" ? type2.required(node, key) : type2.required;
          for (const propName of required || []) {
            if (!node.hasOwnProperty(propName)) {
              report({
                message: `The field \`${propName}\` must be present on this level.`,
                from: refLocation,
                location: [{ reportOnKey: true }]
              });
            }
          }
          const allowed = (_a = type2.allowed) === null || _a === void 0 ? void 0 : _a.call(type2, node);
          if (allowed && (0, utils_2.isPlainObject)(node)) {
            for (const propName in node) {
              if (allowed.includes(propName) || type2.extensionsPrefix && propName.startsWith(type2.extensionsPrefix) || !Object.keys(type2.properties).includes(propName)) {
                continue;
              }
              report({
                message: `The field \`${propName}\` is not allowed here.`,
                from: refLocation,
                location: location.child([propName]).key()
              });
            }
          }
          const requiredOneOf = type2.requiredOneOf || null;
          if (requiredOneOf) {
            let hasProperty = false;
            for (const propName of requiredOneOf || []) {
              if (node.hasOwnProperty(propName)) {
                hasProperty = true;
              }
            }
            if (!hasProperty)
              report({
                message: `Must contain at least one of the following fields: ${(_b = type2.requiredOneOf) === null || _b === void 0 ? void 0 : _b.join(", ")}.`,
                from: refLocation,
                location: [{ reportOnKey: true }]
              });
          }
          for (const propName of Object.keys(node)) {
            const propLocation = location.child([propName]);
            let propValue = node[propName];
            let propType = type2.properties[propName];
            if (propType === void 0)
              propType = type2.additionalProperties;
            if (typeof propType === "function")
              propType = propType(propValue, propName);
            if ((0, types_1.isNamedType)(propType)) {
              continue;
            }
            const propSchema = propType;
            const propValueType = (0, utils_1.oasTypeOf)(propValue);
            if (propSchema === void 0) {
              if (propName.startsWith("x-"))
                continue;
              report({
                message: `Property \`${propName}\` is not expected here.`,
                suggest: (0, utils_1.getSuggest)(propName, Object.keys(type2.properties)),
                from: refLocation,
                location: propLocation.key()
              });
              continue;
            }
            if (propSchema === null) {
              continue;
            }
            if (propSchema.resolvable !== false && (0, ref_utils_1.isRef)(propValue)) {
              propValue = resolve(propValue).node;
            }
            if (propSchema.items && ((_c = propSchema.items) === null || _c === void 0 ? void 0 : _c.enum) && Array.isArray(propValue)) {
              for (let i = 0; i < propValue.length; i++) {
                (0, utils_1.validateSchemaEnumType)((_d = propSchema.items) === null || _d === void 0 ? void 0 : _d.enum, propValue[i], propName, refLocation, {
                  report,
                  location: location.child([propName, i])
                });
              }
            }
            if (propSchema.enum) {
              (0, utils_1.validateSchemaEnumType)(propSchema.enum, propValue, propName, refLocation, {
                report,
                location: location.child([propName])
              });
            } else if (propSchema.type && !(0, utils_1.matchesJsonSchemaType)(propValue, propSchema.type, false)) {
              report({
                message: `Expected type \`${propSchema.type}\` but got \`${propValueType}\`.`,
                from: refLocation,
                location: propLocation
              });
              ignoreNextVisitorsOnNode();
            } else if (propValueType === "array" && ((_e = propSchema.items) === null || _e === void 0 ? void 0 : _e.type)) {
              const itemsType = (_f = propSchema.items) === null || _f === void 0 ? void 0 : _f.type;
              for (let i = 0; i < propValue.length; i++) {
                const item = propValue[i];
                if (!(0, utils_1.matchesJsonSchemaType)(item, itemsType, false)) {
                  report({
                    message: `Expected type \`${itemsType}\` but got \`${(0, utils_1.oasTypeOf)(item)}\`.`,
                    from: refLocation,
                    location: propLocation.child([i])
                  });
                }
              }
            }
            if (typeof propSchema.minimum === "number") {
              if (propSchema.minimum > node[propName]) {
                report({
                  message: `The value of the ${propName} field must be greater than or equal to ${propSchema.minimum}`,
                  from: refLocation,
                  location: location.child([propName])
                });
              }
            }
            if (propName === "nullable" && !node.type) {
              report({
                message: "The `type` field must be defined when the `nullable` field is used.",
                location: location.child([propName])
              });
            }
          }
        }
      };
    };
    exports2.Spec = Spec;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-2xx-response.js
var require_operation_2xx_response = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-2xx-response.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Operation2xxResponse = void 0;
    var utils_1 = require_utils6();
    var Operation2xxResponse = ({ validateWebhooks }) => {
      return {
        Paths: {
          Responses(responses, { report }) {
            const codes = Object.keys(responses || {});
            (0, utils_1.validateResponseCodes)(codes, "2XX", { report });
          }
        },
        WebhooksMap: {
          Responses(responses, { report }) {
            if (!validateWebhooks)
              return;
            const codes = Object.keys(responses || {});
            (0, utils_1.validateResponseCodes)(codes, "2XX", { report });
          }
        }
      };
    };
    exports2.Operation2xxResponse = Operation2xxResponse;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-4xx-response.js
var require_operation_4xx_response = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-4xx-response.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Operation4xxResponse = void 0;
    var utils_1 = require_utils6();
    var Operation4xxResponse = ({ validateWebhooks }) => {
      return {
        Paths: {
          Responses(responses, { report }) {
            const codes = Object.keys(responses || {});
            (0, utils_1.validateResponseCodes)(codes, "4XX", { report });
          }
        },
        WebhooksMap: {
          Responses(responses, { report }) {
            if (!validateWebhooks)
              return;
            const codes = Object.keys(responses || {});
            (0, utils_1.validateResponseCodes)(codes, "4XX", { report });
          }
        }
      };
    };
    exports2.Operation4xxResponse = Operation4xxResponse;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/assertions/asserts.js
var require_asserts = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/assertions/asserts.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.buildAssertCustomFunction = exports2.asserts = exports2.runOnValuesSet = exports2.runOnKeysSet = void 0;
    var utils_1 = require_utils4();
    var utils_2 = require_utils7();
    exports2.runOnKeysSet = /* @__PURE__ */ new Set([
      "mutuallyExclusive",
      "mutuallyRequired",
      "enum",
      "pattern",
      "notPattern",
      "minLength",
      "maxLength",
      "casing",
      "sortOrder",
      "disallowed",
      "required",
      "requireAny",
      "ref",
      "const",
      "defined"
      // In case if `property` for assertions is not added
    ]);
    exports2.runOnValuesSet = /* @__PURE__ */ new Set([
      "pattern",
      "notPattern",
      "enum",
      "defined",
      "undefined",
      "nonEmpty",
      "minLength",
      "maxLength",
      "casing",
      "sortOrder",
      "ref",
      "const"
    ]);
    exports2.asserts = {
      pattern: (value, condition, { baseLocation, rawValue }) => {
        if (typeof value === "undefined" || (0, utils_1.isPlainObject)(value))
          return [];
        const values = Array.isArray(value) ? value : [value];
        const regex = (0, utils_2.regexFromString)(condition);
        return values.map((_val) => !(regex === null || regex === void 0 ? void 0 : regex.test(_val)) && {
          message: `"${_val}" should match a regex ${condition}`,
          location: (0, utils_1.isString)(value) ? baseLocation : (0, utils_1.isPlainObject)(rawValue) ? baseLocation.child(_val).key() : baseLocation.key()
        }).filter(utils_1.isTruthy);
      },
      notPattern: (value, condition, { baseLocation, rawValue }) => {
        if (typeof value === "undefined" || (0, utils_1.isPlainObject)(value))
          return [];
        const values = Array.isArray(value) ? value : [value];
        const regex = (0, utils_2.regexFromString)(condition);
        return values.map((_val) => (regex === null || regex === void 0 ? void 0 : regex.test(_val)) && {
          message: `"${_val}" should not match a regex ${condition}`,
          location: (0, utils_1.isString)(value) ? baseLocation : (0, utils_1.isPlainObject)(rawValue) ? baseLocation.child(_val).key() : baseLocation.key()
        }).filter(utils_1.isTruthy);
      },
      enum: (value, condition, { baseLocation }) => {
        if (typeof value === "undefined" || (0, utils_1.isPlainObject)(value))
          return [];
        const values = Array.isArray(value) ? value : [value];
        return values.map((_val) => !condition.includes(_val) && {
          message: `"${_val}" should be one of the predefined values`,
          location: (0, utils_1.isString)(value) ? baseLocation : baseLocation.child(_val).key()
        }).filter(utils_1.isTruthy);
      },
      defined: (value, condition = true, { baseLocation }) => {
        const isDefined = typeof value !== "undefined";
        const isValid2 = condition ? isDefined : !isDefined;
        return isValid2 ? [] : [
          {
            message: condition ? `Should be defined` : "Should be not defined",
            location: baseLocation
          }
        ];
      },
      required: (value, keys5, { baseLocation }) => {
        return keys5.map((requiredKey) => !value.includes(requiredKey) && {
          message: `${requiredKey} is required`,
          location: baseLocation.key()
        }).filter(utils_1.isTruthy);
      },
      disallowed: (value, condition, { baseLocation }) => {
        if (typeof value === "undefined" || (0, utils_1.isPlainObject)(value))
          return [];
        const values = Array.isArray(value) ? value : [value];
        return values.map((_val) => condition.includes(_val) && {
          message: `"${_val}" is disallowed`,
          location: (0, utils_1.isString)(value) ? baseLocation : baseLocation.child(_val).key()
        }).filter(utils_1.isTruthy);
      },
      const: (value, condition, { baseLocation }) => {
        if (typeof value === "undefined")
          return [];
        if (Array.isArray(value)) {
          return value.map((_val) => condition !== _val && {
            message: `"${_val}" should be equal ${condition} `,
            location: (0, utils_1.isString)(value) ? baseLocation : baseLocation.child(_val).key()
          }).filter(utils_1.isTruthy);
        } else {
          return value !== condition ? [
            {
              message: `${value} should be equal ${condition}`,
              location: baseLocation
            }
          ] : [];
        }
      },
      undefined: (value, condition = true, { baseLocation }) => {
        const isUndefined = typeof value === "undefined";
        const isValid2 = condition ? isUndefined : !isUndefined;
        return isValid2 ? [] : [
          {
            message: condition ? `Should not be defined` : "Should be defined",
            location: baseLocation
          }
        ];
      },
      nonEmpty: (value, condition = true, { baseLocation }) => {
        const isEmpty = typeof value === "undefined" || value === null || value === "";
        const isValid2 = condition ? !isEmpty : isEmpty;
        return isValid2 ? [] : [
          {
            message: condition ? `Should not be empty` : "Should be empty",
            location: baseLocation
          }
        ];
      },
      minLength: (value, condition, { baseLocation }) => {
        if (typeof value === "undefined" || value.length >= condition)
          return [];
        return [
          {
            message: `Should have at least ${condition} characters`,
            location: baseLocation
          }
        ];
      },
      maxLength: (value, condition, { baseLocation }) => {
        if (typeof value === "undefined" || value.length <= condition)
          return [];
        return [
          {
            message: `Should have at most ${condition} characters`,
            location: baseLocation
          }
        ];
      },
      casing: (value, condition, { baseLocation }) => {
        if (typeof value === "undefined" || (0, utils_1.isPlainObject)(value))
          return [];
        const values = Array.isArray(value) ? value : [value];
        const casingRegexes = {
          camelCase: /^[a-z][a-zA-Z0-9]+$/g,
          "kebab-case": /^([a-z][a-z0-9]*)(-[a-z0-9]+)*$/g,
          snake_case: /^([a-z][a-z0-9]*)(_[a-z0-9]+)*$/g,
          PascalCase: /^[A-Z][a-zA-Z0-9]+$/g,
          MACRO_CASE: /^([A-Z][A-Z0-9]*)(_[A-Z0-9]+)*$/g,
          "COBOL-CASE": /^([A-Z][A-Z0-9]*)(-[A-Z0-9]+)*$/g,
          flatcase: /^[a-z][a-z0-9]+$/g
        };
        return values.map((_val) => !_val.match(casingRegexes[condition]) && {
          message: `"${_val}" should use ${condition}`,
          location: (0, utils_1.isString)(value) ? baseLocation : baseLocation.child(_val).key()
        }).filter(utils_1.isTruthy);
      },
      sortOrder: (value, condition, { baseLocation }) => {
        const direction = condition.direction || condition;
        const property4 = condition.property;
        if (Array.isArray(value) && value.length > 0 && typeof value[0] === "object" && !property4) {
          return [
            {
              message: `Please define a property to sort objects by`,
              location: baseLocation
            }
          ];
        }
        if (typeof value === "undefined" || (0, utils_2.isOrdered)(value, condition))
          return [];
        return [
          {
            message: `Should be sorted in ${direction === "asc" ? "an ascending" : "a descending"} order${property4 ? ` by property ${property4}` : ""}`,
            location: baseLocation
          }
        ];
      },
      mutuallyExclusive: (value, condition, { baseLocation }) => {
        if ((0, utils_2.getIntersectionLength)(value, condition) < 2)
          return [];
        return [
          {
            message: `${condition.join(", ")} keys should be mutually exclusive`,
            location: baseLocation.key()
          }
        ];
      },
      mutuallyRequired: (value, condition, { baseLocation }) => {
        const isValid2 = (0, utils_2.getIntersectionLength)(value, condition) > 0 ? (0, utils_2.getIntersectionLength)(value, condition) === condition.length : true;
        return isValid2 ? [] : [
          {
            message: `Properties ${condition.join(", ")} are mutually required`,
            location: baseLocation.key()
          }
        ];
      },
      requireAny: (value, condition, { baseLocation }) => {
        return (0, utils_2.getIntersectionLength)(value, condition) >= 1 ? [] : [
          {
            message: `Should have any of ${condition.join(", ")}`,
            location: baseLocation.key()
          }
        ];
      },
      ref: (_value, condition, { baseLocation, rawValue }) => {
        if (typeof rawValue === "undefined")
          return [];
        const hasRef = rawValue.hasOwnProperty("$ref");
        if (typeof condition === "boolean") {
          const isValid3 = condition ? hasRef : !hasRef;
          return isValid3 ? [] : [
            {
              message: condition ? `should use $ref` : "should not use $ref",
              location: hasRef ? baseLocation : baseLocation.key()
            }
          ];
        }
        const regex = (0, utils_2.regexFromString)(condition);
        const isValid2 = hasRef && (regex === null || regex === void 0 ? void 0 : regex.test(rawValue["$ref"]));
        return isValid2 ? [] : [
          {
            message: `$ref value should match ${condition}`,
            location: hasRef ? baseLocation : baseLocation.key()
          }
        ];
      }
    };
    function buildAssertCustomFunction(fn) {
      return (value, options, ctx) => fn.call(null, value, options, ctx);
    }
    exports2.buildAssertCustomFunction = buildAssertCustomFunction;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/assertions/utils.js
var require_utils7 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/assertions/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.regexFromString = exports2.runAssertion = exports2.isOrdered = exports2.getIntersectionLength = exports2.buildSubjectVisitor = exports2.buildVisitorObject = exports2.getAssertsToApply = void 0;
    var asserts_1 = require_asserts();
    var logger_1 = require_logger();
    var ref_utils_1 = require_ref_utils();
    var utils_1 = require_utils4();
    var assertionMessageTemplates = {
      problems: "{{problems}}"
    };
    function getPredicatesFromLocators(locators) {
      const { filterInParentKeys, filterOutParentKeys, matchParentKeys } = locators;
      const keyMatcher = matchParentKeys && regexFromString(matchParentKeys);
      const matchKeysPredicate = keyMatcher && ((key) => keyMatcher.test(key.toString()));
      const filterInPredicate = Array.isArray(filterInParentKeys) && ((key) => filterInParentKeys.includes(key.toString()));
      const filterOutPredicate = Array.isArray(filterOutParentKeys) && ((key) => !filterOutParentKeys.includes(key.toString()));
      return [matchKeysPredicate, filterInPredicate, filterOutPredicate].filter(utils_1.isTruthy);
    }
    function getAssertsToApply(assertion) {
      const assertsToApply = (0, utils_1.keysOf)(asserts_1.asserts).filter((assertName) => assertion.assertions[assertName] !== void 0).map((assertName) => {
        return {
          name: assertName,
          conditions: assertion.assertions[assertName],
          runsOnKeys: asserts_1.runOnKeysSet.has(assertName),
          runsOnValues: asserts_1.runOnValuesSet.has(assertName)
        };
      });
      const shouldRunOnKeys = assertsToApply.find((assert) => assert.runsOnKeys && !assert.runsOnValues);
      const shouldRunOnValues = assertsToApply.find((assert) => assert.runsOnValues && !assert.runsOnKeys);
      if (shouldRunOnValues && !assertion.subject.property) {
        throw new Error(`${shouldRunOnValues.name} can't be used on all keys. Please provide a single property`);
      }
      if (shouldRunOnKeys && assertion.subject.property) {
        throw new Error(`${shouldRunOnKeys.name} can't be used on a single property. Please use 'property'.`);
      }
      return assertsToApply;
    }
    exports2.getAssertsToApply = getAssertsToApply;
    function getAssertionProperties({ subject }) {
      return (Array.isArray(subject.property) ? subject.property : [subject === null || subject === void 0 ? void 0 : subject.property]).filter(Boolean);
    }
    function applyAssertions(assertionDefinition, asserts, ctx) {
      const properties = getAssertionProperties(assertionDefinition);
      const assertResults = [];
      for (const assert of asserts) {
        if (properties.length) {
          for (const property4 of properties) {
            assertResults.push(runAssertion({
              assert,
              ctx,
              assertionProperty: property4
            }));
          }
        } else {
          assertResults.push(runAssertion({
            assert,
            ctx
          }));
        }
      }
      return assertResults.flat();
    }
    function buildVisitorObject(assertion, subjectVisitor) {
      var _a, _b;
      const targetVisitorLocatorPredicates = getPredicatesFromLocators(assertion.subject);
      const targetVisitorSkipFunction = targetVisitorLocatorPredicates.length ? (_, key) => !targetVisitorLocatorPredicates.every((predicate) => predicate(key)) : void 0;
      const targetVisitor = {
        [assertion.subject.type]: Object.assign({ enter: subjectVisitor }, targetVisitorSkipFunction && { skip: targetVisitorSkipFunction })
      };
      if (!Array.isArray(assertion.where)) {
        return targetVisitor;
      }
      let currentVisitorLevel = {};
      const visitor = currentVisitorLevel;
      const context = assertion.where;
      for (let index = 0; index < context.length; index++) {
        const assertionDefinitionNode = context[index];
        if (!(0, utils_1.isString)((_a = assertionDefinitionNode.subject) === null || _a === void 0 ? void 0 : _a.type)) {
          throw new Error(`${assertion.assertionId} -> where -> [${index}]: 'type' (String) is required`);
        }
        const locatorPredicates = getPredicatesFromLocators(assertionDefinitionNode.subject);
        const assertsToApply = getAssertsToApply(assertionDefinitionNode);
        const skipFunction = (node, key, ctx) => !locatorPredicates.every((predicate) => predicate(key)) || !!applyAssertions(assertionDefinitionNode, assertsToApply, Object.assign(Object.assign({}, ctx), { node })).length;
        const nodeVisitor = Object.assign({}, (locatorPredicates.length || assertsToApply.length) && { skip: skipFunction });
        if (assertionDefinitionNode.subject.type === assertion.subject.type && index === context.length - 1) {
          targetVisitor[assertion.subject.type] = Object.assign({ enter: subjectVisitor }, nodeVisitor.skip && { skip: nodeVisitor.skip } || targetVisitorSkipFunction && {
            skip: (node, key, ctx) => {
              var _a2;
              return !!(((_a2 = nodeVisitor.skip) === null || _a2 === void 0 ? void 0 : _a2.call(nodeVisitor, node, key, ctx)) || (targetVisitorSkipFunction === null || targetVisitorSkipFunction === void 0 ? void 0 : targetVisitorSkipFunction(node, key)));
            }
          });
        } else {
          currentVisitorLevel = currentVisitorLevel[(_b = assertionDefinitionNode.subject) === null || _b === void 0 ? void 0 : _b.type] = nodeVisitor;
        }
      }
      currentVisitorLevel[assertion.subject.type] = targetVisitor[assertion.subject.type];
      return visitor;
    }
    exports2.buildVisitorObject = buildVisitorObject;
    function buildSubjectVisitor(assertId, assertion) {
      return (node, ctx) => {
        const properties = getAssertionProperties(assertion);
        const defaultMessage = `${logger_1.colorize.blue(assertId)} failed because the ${logger_1.colorize.blue(assertion.subject.type)} ${logger_1.colorize.blue(properties.join(", "))} didn't meet the assertions: ${assertionMessageTemplates.problems}`.replace(/ +/g, " ");
        const problems = applyAssertions(assertion, getAssertsToApply(assertion), Object.assign(Object.assign({}, ctx), { node }));
        if (problems.length) {
          for (const problemGroup of groupProblemsByPointer(problems)) {
            const message = assertion.message || defaultMessage;
            const problemMessage = getProblemsMessage(problemGroup);
            ctx.report({
              message: message.replace(assertionMessageTemplates.problems, problemMessage),
              location: getProblemsLocation(problemGroup) || ctx.location,
              forceSeverity: assertion.severity || "error",
              suggest: assertion.suggest || [],
              ruleId: assertId
            });
          }
        }
      };
    }
    exports2.buildSubjectVisitor = buildSubjectVisitor;
    function groupProblemsByPointer(problems) {
      const groups = {};
      for (const problem of problems) {
        if (!problem.location)
          continue;
        const pointer = problem.location.pointer;
        groups[pointer] = groups[pointer] || [];
        groups[pointer].push(problem);
      }
      return Object.values(groups);
    }
    function getProblemsLocation(problems) {
      return problems.length ? problems[0].location : void 0;
    }
    function getProblemsMessage(problems) {
      var _a;
      return problems.length === 1 ? (_a = problems[0].message) !== null && _a !== void 0 ? _a : "" : problems.map((problem) => {
        var _a2;
        return `
- ${(_a2 = problem.message) !== null && _a2 !== void 0 ? _a2 : ""}`;
      }).join("");
    }
    function getIntersectionLength(keys5, properties) {
      const props = new Set(properties);
      let count = 0;
      for (const key of keys5) {
        if (props.has(key)) {
          count++;
        }
      }
      return count;
    }
    exports2.getIntersectionLength = getIntersectionLength;
    function isOrdered(value, options) {
      const direction = options.direction || options;
      const property4 = options.property;
      for (let i = 1; i < value.length; i++) {
        let currValue = value[i];
        let prevVal = value[i - 1];
        if (property4) {
          const currPropValue = value[i][property4];
          const prevPropValue = value[i - 1][property4];
          if (!currPropValue || !prevPropValue) {
            return false;
          }
          currValue = currPropValue;
          prevVal = prevPropValue;
        }
        if (typeof currValue === "string" && typeof prevVal === "string") {
          currValue = currValue.toLowerCase();
          prevVal = prevVal.toLowerCase();
        }
        const result = direction === "asc" ? currValue >= prevVal : currValue <= prevVal;
        if (!result) {
          return false;
        }
      }
      return true;
    }
    exports2.isOrdered = isOrdered;
    function runAssertion({ assert, ctx, assertionProperty }) {
      var _a;
      const currentLocation = assert.name === "ref" ? ctx.rawLocation : ctx.location;
      if (assertionProperty) {
        const values = (0, ref_utils_1.isRef)(ctx.node[assertionProperty]) ? (_a = ctx.resolve(ctx.node[assertionProperty])) === null || _a === void 0 ? void 0 : _a.node : ctx.node[assertionProperty];
        const rawValues = ctx.rawNode[assertionProperty];
        const location = currentLocation.child(assertionProperty);
        return asserts_1.asserts[assert.name](values, assert.conditions, Object.assign(Object.assign({}, ctx), { baseLocation: location, rawValue: rawValues }));
      } else {
        const value = Array.isArray(ctx.node) ? ctx.node : Object.keys(ctx.node);
        return asserts_1.asserts[assert.name](value, assert.conditions, Object.assign(Object.assign({}, ctx), { rawValue: ctx.rawNode, baseLocation: currentLocation }));
      }
    }
    exports2.runAssertion = runAssertion;
    function regexFromString(input) {
      const matches = input.match(/^\/(.*)\/(.*)|(.*)/);
      return matches && new RegExp(matches[1] || matches[3], matches[2]);
    }
    exports2.regexFromString = regexFromString;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/assertions/index.js
var require_assertions = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/assertions/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Assertions = void 0;
    var utils_1 = require_utils7();
    var utils_2 = require_utils4();
    var Assertions = (opts) => {
      const visitors = [];
      const assertions = Object.values(opts).filter((opt) => typeof opt === "object" && opt !== null);
      for (const [_, assertion] of assertions.entries()) {
        if (!(0, utils_2.isString)(assertion.subject.type)) {
          throw new Error(`${assertion.assertionId}: 'type' (String) is required`);
        }
        const subjectVisitor = (0, utils_1.buildSubjectVisitor)(assertion.assertionId, assertion);
        const visitorObject = (0, utils_1.buildVisitorObject)(assertion, subjectVisitor);
        visitors.push(visitorObject);
      }
      return visitors;
    };
    exports2.Assertions = Assertions;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-operationId-unique.js
var require_operation_operationId_unique = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-operationId-unique.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationIdUnique = void 0;
    var OperationIdUnique = () => {
      const seenOperations = /* @__PURE__ */ new Set();
      return {
        Operation(operation, { report, location }) {
          if (!operation.operationId)
            return;
          if (seenOperations.has(operation.operationId)) {
            report({
              message: "Every operation must have a unique `operationId`.",
              location: location.child([operation.operationId])
            });
          }
          seenOperations.add(operation.operationId);
        }
      };
    };
    exports2.OperationIdUnique = OperationIdUnique;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-parameters-unique.js
var require_operation_parameters_unique = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-parameters-unique.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationParametersUnique = void 0;
    var OperationParametersUnique = () => {
      let seenPathParams;
      let seenOperationParams;
      return {
        PathItem: {
          enter() {
            seenPathParams = /* @__PURE__ */ new Set();
          },
          Parameter(parameter, { report, key, parentLocations }) {
            const paramId = `${parameter.in}___${parameter.name}`;
            if (seenPathParams.has(paramId)) {
              report({
                message: `Paths must have unique \`name\` + \`in\` parameters.
Repeats of \`in:${parameter.in}\` + \`name:${parameter.name}\`.`,
                location: parentLocations.PathItem.child(["parameters", key])
              });
            }
            seenPathParams.add(`${parameter.in}___${parameter.name}`);
          },
          Operation: {
            enter() {
              seenOperationParams = /* @__PURE__ */ new Set();
            },
            Parameter(parameter, { report, key, parentLocations }) {
              const paramId = `${parameter.in}___${parameter.name}`;
              if (seenOperationParams.has(paramId)) {
                report({
                  message: `Operations must have unique \`name\` + \`in\` parameters. Repeats of \`in:${parameter.in}\` + \`name:${parameter.name}\`.`,
                  location: parentLocations.Operation.child(["parameters", key])
                });
              }
              seenOperationParams.add(paramId);
            }
          }
        }
      };
    };
    exports2.OperationParametersUnique = OperationParametersUnique;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-params-defined.js
var require_path_params_defined = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-params-defined.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PathParamsDefined = void 0;
    var pathRegex = /\{([a-zA-Z0-9_.-]+)\}+/g;
    var PathParamsDefined = () => {
      let pathTemplateParams;
      let definedPathParams;
      let currentPath;
      let definedOperationParams;
      return {
        PathItem: {
          enter(_, { key }) {
            definedPathParams = /* @__PURE__ */ new Set();
            currentPath = key;
            pathTemplateParams = new Set(Array.from(key.toString().matchAll(pathRegex)).map((m) => m[1]));
          },
          Parameter(parameter, { report, location }) {
            if (parameter.in === "path" && parameter.name) {
              definedPathParams.add(parameter.name);
              if (!pathTemplateParams.has(parameter.name)) {
                report({
                  message: `Path parameter \`${parameter.name}\` is not used in the path \`${currentPath}\`.`,
                  location: location.child(["name"])
                });
              }
            }
          },
          Operation: {
            enter() {
              definedOperationParams = /* @__PURE__ */ new Set();
            },
            leave(_op, { report, location }) {
              for (const templateParam of Array.from(pathTemplateParams.keys())) {
                if (!definedOperationParams.has(templateParam) && !definedPathParams.has(templateParam)) {
                  report({
                    message: `The operation does not define the path parameter \`{${templateParam}}\` expected by path \`${currentPath}\`.`,
                    location: location.child(["parameters"]).key()
                    // report on operation
                  });
                }
              }
            },
            Parameter(parameter, { report, location }) {
              if (parameter.in === "path" && parameter.name) {
                definedOperationParams.add(parameter.name);
                if (!pathTemplateParams.has(parameter.name)) {
                  report({
                    message: `Path parameter \`${parameter.name}\` is not used in the path \`${currentPath}\`.`,
                    location: location.child(["name"])
                  });
                }
              }
            }
          }
        }
      };
    };
    exports2.PathParamsDefined = PathParamsDefined;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-tag-defined.js
var require_operation_tag_defined = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-tag-defined.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationTagDefined = void 0;
    var OperationTagDefined = () => {
      let definedTags;
      return {
        Root(root2) {
          var _a;
          definedTags = new Set(((_a = root2.tags) !== null && _a !== void 0 ? _a : []).map((t) => t.name));
        },
        Operation(operation, { report, location }) {
          if (operation.tags) {
            for (let i = 0; i < operation.tags.length; i++) {
              if (!definedTags.has(operation.tags[i])) {
                report({
                  message: `Operation tags should be defined in global tags.`,
                  location: location.child(["tags", i])
                });
              }
            }
          }
        }
      };
    };
    exports2.OperationTagDefined = OperationTagDefined;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-example-value-and-externalValue.js
var require_no_example_value_and_externalValue = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-example-value-and-externalValue.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoExampleValueAndExternalValue = void 0;
    var NoExampleValueAndExternalValue = () => {
      return {
        Example(example, { report, location }) {
          if (example.value && example.externalValue) {
            report({
              message: "Example object can have either `value` or `externalValue` fields.",
              location: location.child(["value"]).key()
            });
          }
        }
      };
    };
    exports2.NoExampleValueAndExternalValue = NoExampleValueAndExternalValue;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-enum-type-mismatch.js
var require_no_enum_type_mismatch = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-enum-type-mismatch.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoEnumTypeMismatch = void 0;
    var utils_1 = require_utils6();
    var NoEnumTypeMismatch = () => {
      return {
        Schema(schema2, { report, location }) {
          if (schema2.enum && !Array.isArray(schema2.enum))
            return;
          if (schema2.enum && schema2.type && !Array.isArray(schema2.type)) {
            const typeMismatchedValues = schema2.enum.filter((item) => !(0, utils_1.matchesJsonSchemaType)(item, schema2.type, schema2.nullable));
            for (const mismatchedValue of typeMismatchedValues) {
              report({
                message: `All values of \`enum\` field must be of the same type as the \`type\` field: expected "${schema2.type}" but received "${(0, utils_1.oasTypeOf)(mismatchedValue)}".`,
                location: location.child(["enum", schema2.enum.indexOf(mismatchedValue)])
              });
            }
          }
          if (schema2.enum && schema2.type && Array.isArray(schema2.type)) {
            const mismatchedResults = {};
            for (const enumValue of schema2.enum) {
              mismatchedResults[enumValue] = [];
              for (const type2 of schema2.type) {
                const valid = (0, utils_1.matchesJsonSchemaType)(enumValue, type2, schema2.nullable);
                if (!valid)
                  mismatchedResults[enumValue].push(type2);
              }
              if (mismatchedResults[enumValue].length !== schema2.type.length)
                delete mismatchedResults[enumValue];
            }
            for (const mismatchedKey of Object.keys(mismatchedResults)) {
              report({
                message: `Enum value \`${mismatchedKey}\` must be of allowed types: \`${schema2.type}\`.`,
                location: location.child(["enum", schema2.enum.indexOf(mismatchedKey)])
              });
            }
          }
        }
      };
    };
    exports2.NoEnumTypeMismatch = NoEnumTypeMismatch;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-path-trailing-slash.js
var require_no_path_trailing_slash = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-path-trailing-slash.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoPathTrailingSlash = void 0;
    var NoPathTrailingSlash = () => {
      return {
        PathItem(_path, { report, key, rawLocation }) {
          if (key.endsWith("/") && key !== "/") {
            report({
              message: `\`${key}\` should not have a trailing slash.`,
              location: rawLocation.key()
            });
          }
        }
      };
    };
    exports2.NoPathTrailingSlash = NoPathTrailingSlash;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-declaration-must-exist.js
var require_path_declaration_must_exist = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-declaration-must-exist.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PathDeclarationMustExist = void 0;
    var PathDeclarationMustExist = () => {
      return {
        PathItem(_path, { report, key }) {
          if (key.indexOf("{}") !== -1) {
            report({
              message: "Path parameter declarations must be non-empty. `{}` is invalid.",
              location: { reportOnKey: true }
            });
          }
        }
      };
    };
    exports2.PathDeclarationMustExist = PathDeclarationMustExist;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-operationId-url-safe.js
var require_operation_operationId_url_safe = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-operationId-url-safe.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationIdUrlSafe = void 0;
    var validUrlSymbols = /^[A-Za-z0-9-._~:/?#\[\]@!\$&'()*+,;=]*$/;
    var OperationIdUrlSafe = () => {
      return {
        Operation(operation, { report, location }) {
          if (operation.operationId && !validUrlSymbols.test(operation.operationId)) {
            report({
              message: "Operation `operationId` should not have URL invalid characters.",
              location: location.child(["operationId"])
            });
          }
        }
      };
    };
    exports2.OperationIdUrlSafe = OperationIdUrlSafe;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/tags-alphabetical.js
var require_tags_alphabetical = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/tags-alphabetical.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.TagsAlphabetical = void 0;
    var TagsAlphabetical = ({ ignoreCase = false }) => {
      return {
        Root(root2, { report, location }) {
          if (!root2.tags)
            return;
          for (let i = 0; i < root2.tags.length - 1; i++) {
            if (getTagName(root2.tags[i], ignoreCase) > getTagName(root2.tags[i + 1], ignoreCase)) {
              report({
                message: "The `tags` array should be in alphabetical order.",
                location: location.child(["tags", i])
              });
            }
          }
        }
      };
    };
    exports2.TagsAlphabetical = TagsAlphabetical;
    function getTagName(tag, ignoreCase) {
      return ignoreCase ? tag.name.toLowerCase() : tag.name;
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-server-example.com.js
var require_no_server_example_com = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-server-example.com.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoServerExample = void 0;
    var NoServerExample = () => {
      return {
        Server(server, { report, location }) {
          const pattern = /^(.*[\/.])?(example\.com|localhost)([\/:?].*|$)/;
          if (server.url && pattern.test(server.url)) {
            report({
              message: "Server `url` should not point to example.com or localhost.",
              location: location.child(["url"])
            });
          }
        }
      };
    };
    exports2.NoServerExample = NoServerExample;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-server-trailing-slash.js
var require_no_server_trailing_slash = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-server-trailing-slash.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoServerTrailingSlash = void 0;
    var NoServerTrailingSlash = () => {
      return {
        Server(server, { report, location }) {
          if (!server.url)
            return;
          if (server.url.endsWith("/") && server.url !== "/") {
            report({
              message: "Server `url` should not have a trailing slash.",
              location: location.child(["url"])
            });
          }
        }
      };
    };
    exports2.NoServerTrailingSlash = NoServerTrailingSlash;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/tag-description.js
var require_tag_description = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/tag-description.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.TagDescription = void 0;
    var utils_1 = require_utils6();
    var TagDescription = () => {
      return {
        Tag(tag, ctx) {
          (0, utils_1.validateDefinedAndNonEmpty)("description", tag, ctx);
        }
      };
    };
    exports2.TagDescription = TagDescription;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/info-contact.js
var require_info_contact = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/info-contact.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.InfoContact = void 0;
    var utils_1 = require_utils6();
    var InfoContact = () => {
      return {
        Info(info, { report, location }) {
          if (!info.contact) {
            report({
              message: (0, utils_1.missingRequiredField)("Info", "contact"),
              location: location.child("contact").key()
            });
          }
        }
      };
    };
    exports2.InfoContact = InfoContact;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/info-license.js
var require_info_license = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/info-license.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.InfoLicense = void 0;
    var utils_1 = require_utils6();
    var InfoLicense = () => {
      return {
        Info(info, { report }) {
          if (!info.license) {
            report({
              message: (0, utils_1.missingRequiredField)("Info", "license"),
              location: { reportOnKey: true }
            });
          }
        }
      };
    };
    exports2.InfoLicense = InfoLicense;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/info-license-url.js
var require_info_license_url = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/info-license-url.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.InfoLicenseUrl = void 0;
    var utils_1 = require_utils6();
    var InfoLicenseUrl = () => {
      return {
        License(license, ctx) {
          (0, utils_1.validateDefinedAndNonEmpty)("url", license, ctx);
        }
      };
    };
    exports2.InfoLicenseUrl = InfoLicenseUrl;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-description.js
var require_operation_description = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-description.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationDescription = void 0;
    var utils_1 = require_utils6();
    var OperationDescription = () => {
      return {
        Operation(operation, ctx) {
          (0, utils_1.validateDefinedAndNonEmpty)("description", operation, ctx);
        }
      };
    };
    exports2.OperationDescription = OperationDescription;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-unused-components.js
var require_no_unused_components = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-unused-components.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoUnusedComponents = void 0;
    var NoUnusedComponents = () => {
      const components = /* @__PURE__ */ new Map();
      function registerComponent(location, name) {
        var _a;
        components.set(location.absolutePointer, {
          used: ((_a = components.get(location.absolutePointer)) === null || _a === void 0 ? void 0 : _a.used) || false,
          location,
          name
        });
      }
      return {
        ref(ref, { type: type2, resolve, key, location }) {
          if (["Schema", "Header", "Parameter", "Response", "Example", "RequestBody"].includes(type2.name)) {
            const resolvedRef = resolve(ref);
            if (!resolvedRef.location)
              return;
            components.set(resolvedRef.location.absolutePointer, {
              used: true,
              name: key.toString(),
              location
            });
          }
        },
        Root: {
          leave(_, { report }) {
            components.forEach((usageInfo) => {
              if (!usageInfo.used) {
                report({
                  message: `Component: "${usageInfo.name}" is never used.`,
                  location: usageInfo.location.key()
                });
              }
            });
          }
        },
        NamedSchemas: {
          Schema(schema2, { location, key }) {
            if (!schema2.allOf) {
              registerComponent(location, key.toString());
            }
          }
        },
        NamedParameters: {
          Parameter(_parameter, { location, key }) {
            registerComponent(location, key.toString());
          }
        },
        NamedResponses: {
          Response(_response, { location, key }) {
            registerComponent(location, key.toString());
          }
        },
        NamedExamples: {
          Example(_example, { location, key }) {
            registerComponent(location, key.toString());
          }
        },
        NamedRequestBodies: {
          RequestBody(_requestBody, { location, key }) {
            registerComponent(location, key.toString());
          }
        },
        NamedHeaders: {
          Header(_header, { location, key }) {
            registerComponent(location, key.toString());
          }
        }
      };
    };
    exports2.NoUnusedComponents = NoUnusedComponents;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-not-include-query.js
var require_path_not_include_query = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-not-include-query.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PathNotIncludeQuery = void 0;
    var PathNotIncludeQuery = () => {
      return {
        Paths: {
          PathItem(_operation, { report, key }) {
            if (key.toString().includes("?")) {
              report({
                message: `Don't put query string items in the path, they belong in parameters with \`in: query\`.`,
                location: { reportOnKey: true }
              });
            }
          }
        }
      };
    };
    exports2.PathNotIncludeQuery = PathNotIncludeQuery;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/parameter-description.js
var require_parameter_description = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/parameter-description.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ParameterDescription = void 0;
    var ParameterDescription = () => {
      return {
        Parameter(parameter, { report, location }) {
          if (parameter.description === void 0) {
            report({
              message: "Parameter object description must be present.",
              location: { reportOnKey: true }
            });
          } else if (!parameter.description) {
            report({
              message: "Parameter object description must be non-empty string.",
              location: location.child(["description"])
            });
          }
        }
      };
    };
    exports2.ParameterDescription = ParameterDescription;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-singular-tag.js
var require_operation_singular_tag = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-singular-tag.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationSingularTag = void 0;
    var OperationSingularTag = () => {
      return {
        Operation(operation, { report, location }) {
          if (operation.tags && operation.tags.length > 1) {
            report({
              message: "Operation `tags` object should have only one tag.",
              location: location.child(["tags"]).key()
            });
          }
        }
      };
    };
    exports2.OperationSingularTag = OperationSingularTag;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/security-defined.js
var require_security_defined = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/security-defined.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SecurityDefined = void 0;
    var SecurityDefined = () => {
      const referencedSchemes = /* @__PURE__ */ new Map();
      const operationsWithoutSecurity = [];
      let eachOperationHasSecurity = true;
      return {
        Root: {
          leave(root2, { report }) {
            for (const [name, scheme] of referencedSchemes.entries()) {
              if (scheme.defined)
                continue;
              for (const reportedFromLocation of scheme.from) {
                report({
                  message: `There is no \`${name}\` security scheme defined.`,
                  location: reportedFromLocation.key()
                });
              }
            }
            if (root2.security || eachOperationHasSecurity) {
              return;
            } else {
              for (const operationLocation of operationsWithoutSecurity) {
                report({
                  message: `Every operation should have security defined on it or on the root level.`,
                  location: operationLocation.key()
                });
              }
            }
          }
        },
        SecurityScheme(_securityScheme, { key }) {
          referencedSchemes.set(key.toString(), { defined: true, from: [] });
        },
        SecurityRequirement(requirements, { location }) {
          for (const requirement of Object.keys(requirements)) {
            const authScheme = referencedSchemes.get(requirement);
            const requirementLocation = location.child([requirement]);
            if (!authScheme) {
              referencedSchemes.set(requirement, { from: [requirementLocation] });
            } else {
              authScheme.from.push(requirementLocation);
            }
          }
        },
        Operation(operation, { location }) {
          if (!(operation === null || operation === void 0 ? void 0 : operation.security)) {
            eachOperationHasSecurity = false;
            operationsWithoutSecurity.push(location);
          }
        }
      };
    };
    exports2.SecurityDefined = SecurityDefined;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/resolve.js
var require_resolve2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/resolve.js"(exports2) {
    "use strict";
    var __awaiter = exports2 && exports2.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.resolveDocument = exports2.BaseResolver = exports2.makeDocumentFromString = exports2.makeRefId = exports2.YamlParseError = exports2.ResolveError = exports2.Source = void 0;
    var fs = require("fs");
    var path5 = require("path");
    var ref_utils_1 = require_ref_utils();
    var types_1 = require_types();
    var utils_1 = require_utils4();
    var Source4 = class {
      constructor(absoluteRef, body, mimeType) {
        this.absoluteRef = absoluteRef;
        this.body = body;
        this.mimeType = mimeType;
      }
      // pass safeLoad as argument to separate it from browser bundle
      getAst(safeLoad2) {
        var _a;
        if (this._ast === void 0) {
          this._ast = (_a = safeLoad2(this.body, { filename: this.absoluteRef })) !== null && _a !== void 0 ? _a : void 0;
          if (this._ast && this._ast.kind === 0 && // KIND.scalar = 0
          this._ast.value === "" && this._ast.startPosition !== 1) {
            this._ast.startPosition = 1;
            this._ast.endPosition = 1;
          }
        }
        return this._ast;
      }
      getLines() {
        if (this._lines === void 0) {
          this._lines = this.body.split(/\r\n|[\n\r]/g);
        }
        return this._lines;
      }
    };
    exports2.Source = Source4;
    var ResolveError = class _ResolveError extends Error {
      constructor(originalError) {
        super(originalError.message);
        this.originalError = originalError;
        Object.setPrototypeOf(this, _ResolveError.prototype);
      }
    };
    exports2.ResolveError = ResolveError;
    var jsYamlErrorLineColRegexp = /\((\d+):(\d+)\)$/;
    var YamlParseError = class _YamlParseError extends Error {
      constructor(originalError, source) {
        super(originalError.message.split("\n")[0]);
        this.originalError = originalError;
        this.source = source;
        Object.setPrototypeOf(this, _YamlParseError.prototype);
        const [, line, col] = this.message.match(jsYamlErrorLineColRegexp) || [];
        this.line = parseInt(line, 10);
        this.col = parseInt(col, 10);
      }
    };
    exports2.YamlParseError = YamlParseError;
    function makeRefId(absoluteRef, pointer) {
      return absoluteRef + "::" + pointer;
    }
    exports2.makeRefId = makeRefId;
    function makeDocumentFromString(sourceString, absoluteRef) {
      const source = new Source4(absoluteRef, sourceString);
      try {
        return {
          source,
          parsed: (0, utils_1.parseYaml)(sourceString, { filename: absoluteRef })
        };
      } catch (e) {
        throw new YamlParseError(e, source);
      }
    }
    exports2.makeDocumentFromString = makeDocumentFromString;
    var BaseResolver = class {
      constructor(config = { http: { headers: [] } }) {
        this.config = config;
        this.cache = /* @__PURE__ */ new Map();
      }
      getFiles() {
        return new Set(Array.from(this.cache.keys()));
      }
      resolveExternalRef(base, ref) {
        if ((0, ref_utils_1.isAbsoluteUrl)(ref)) {
          return ref;
        }
        if (base && (0, ref_utils_1.isAbsoluteUrl)(base)) {
          return new URL(ref, base).href;
        }
        return path5.resolve(base ? path5.dirname(base) : process.cwd(), ref);
      }
      loadExternalRef(absoluteRef) {
        return __awaiter(this, void 0, void 0, function* () {
          try {
            if ((0, ref_utils_1.isAbsoluteUrl)(absoluteRef)) {
              const { body, mimeType } = yield (0, utils_1.readFileFromUrl)(absoluteRef, this.config.http);
              return new Source4(absoluteRef, body, mimeType);
            } else {
              if (fs.lstatSync(absoluteRef).isDirectory()) {
                throw new Error(`Expected a file but received a folder at ${absoluteRef}`);
              }
              const content = yield fs.promises.readFile(absoluteRef, "utf-8");
              return new Source4(absoluteRef, content.replace(/\r\n/g, "\n"));
            }
          } catch (error) {
            error.message = error.message.replace(", lstat", "");
            throw new ResolveError(error);
          }
        });
      }
      parseDocument(source, isRoot = false) {
        var _a;
        const ext = source.absoluteRef.substr(source.absoluteRef.lastIndexOf("."));
        if (![".json", ".json", ".yml", ".yaml"].includes(ext) && !((_a = source.mimeType) === null || _a === void 0 ? void 0 : _a.match(/(json|yaml|openapi)/)) && !isRoot) {
          return { source, parsed: source.body };
        }
        try {
          return {
            source,
            parsed: (0, utils_1.parseYaml)(source.body, { filename: source.absoluteRef })
          };
        } catch (e) {
          throw new YamlParseError(e, source);
        }
      }
      resolveDocument(base, ref, isRoot = false) {
        return __awaiter(this, void 0, void 0, function* () {
          const absoluteRef = this.resolveExternalRef(base, ref);
          const cachedDocument = this.cache.get(absoluteRef);
          if (cachedDocument) {
            return cachedDocument;
          }
          const doc = this.loadExternalRef(absoluteRef).then((source) => {
            return this.parseDocument(source, isRoot);
          });
          this.cache.set(absoluteRef, doc);
          return doc;
        });
      }
    };
    exports2.BaseResolver = BaseResolver;
    function pushRef(head, node) {
      return {
        prev: head,
        node
      };
    }
    function hasRef(head, node) {
      while (head) {
        if (head.node === node) {
          return true;
        }
        head = head.prev;
      }
      return false;
    }
    var unknownType2 = { name: "unknown", properties: {} };
    var resolvableScalarType = { name: "scalar", properties: {} };
    function resolveDocument(opts) {
      return __awaiter(this, void 0, void 0, function* () {
        const { rootDocument, externalRefResolver, rootType } = opts;
        const resolvedRefMap = /* @__PURE__ */ new Map();
        const seedNodes = /* @__PURE__ */ new Set();
        const resolvePromises = [];
        resolveRefsInParallel(rootDocument.parsed, rootDocument, "#/", rootType);
        let resolved;
        do {
          resolved = yield Promise.all(resolvePromises);
        } while (resolvePromises.length !== resolved.length);
        return resolvedRefMap;
        function resolveRefsInParallel(rootNode, rootNodeDocument, rootNodePointer, type2) {
          const rootNodeDocAbsoluteRef = rootNodeDocument.source.absoluteRef;
          const anchorRefsMap = /* @__PURE__ */ new Map();
          walk(rootNode, type2, rootNodeDocAbsoluteRef + rootNodePointer);
          function walk(node, type3, nodeAbsoluteRef) {
            if (typeof node !== "object" || node === null) {
              return;
            }
            const nodeId = `${type3.name}::${nodeAbsoluteRef}`;
            if (seedNodes.has(nodeId)) {
              return;
            }
            seedNodes.add(nodeId);
            const [_, anchor] = Object.entries(node).find(([key]) => key === "$anchor") || [];
            if (anchor) {
              anchorRefsMap.set(`#${anchor}`, node);
            }
            if (Array.isArray(node)) {
              const itemsType = type3.items;
              if (itemsType === void 0 && type3 !== unknownType2 && type3 !== types_1.SpecExtension) {
                return;
              }
              for (let i = 0; i < node.length; i++) {
                walk(node[i], itemsType || unknownType2, (0, ref_utils_1.joinPointer)(nodeAbsoluteRef, i));
              }
              return;
            }
            for (const propName of Object.keys(node)) {
              let propValue = node[propName];
              let propType = type3.properties[propName];
              if (propType === void 0)
                propType = type3.additionalProperties;
              if (typeof propType === "function")
                propType = propType(propValue, propName);
              if (propType === void 0)
                propType = unknownType2;
              if (type3.extensionsPrefix && propName.startsWith(type3.extensionsPrefix) && propType === unknownType2) {
                propType = types_1.SpecExtension;
              }
              if (!(0, types_1.isNamedType)(propType) && (propType === null || propType === void 0 ? void 0 : propType.directResolveAs)) {
                propType = propType.directResolveAs;
                propValue = { $ref: propValue };
              }
              if (propType && propType.name === void 0 && propType.resolvable !== false) {
                propType = resolvableScalarType;
              }
              if (!(0, types_1.isNamedType)(propType) || typeof propValue !== "object") {
                continue;
              }
              walk(propValue, propType, (0, ref_utils_1.joinPointer)(nodeAbsoluteRef, (0, ref_utils_1.escapePointer)(propName)));
            }
            if ((0, ref_utils_1.isRef)(node)) {
              const promise = followRef(rootNodeDocument, node, {
                prev: null,
                node
              }).then((resolvedRef) => {
                if (resolvedRef.resolved) {
                  resolveRefsInParallel(resolvedRef.node, resolvedRef.document, resolvedRef.nodePointer, type3);
                }
              });
              resolvePromises.push(promise);
            }
          }
          function followRef(document2, ref, refStack) {
            return __awaiter(this, void 0, void 0, function* () {
              if (hasRef(refStack.prev, ref)) {
                throw new Error("Self-referencing circular pointer");
              }
              if ((0, ref_utils_1.isAnchor)(ref.$ref)) {
                yield (0, utils_1.nextTick)();
                const resolvedRef2 = {
                  resolved: true,
                  isRemote: false,
                  node: anchorRefsMap.get(ref.$ref),
                  document: document2,
                  nodePointer: ref.$ref
                };
                const refId2 = makeRefId(document2.source.absoluteRef, ref.$ref);
                resolvedRefMap.set(refId2, resolvedRef2);
                return resolvedRef2;
              }
              const { uri, pointer } = (0, ref_utils_1.parseRef)(ref.$ref);
              const isRemote = uri !== null;
              let targetDoc;
              try {
                targetDoc = isRemote ? yield externalRefResolver.resolveDocument(document2.source.absoluteRef, uri) : document2;
              } catch (error) {
                const resolvedRef2 = {
                  resolved: false,
                  isRemote,
                  document: void 0,
                  error
                };
                const refId2 = makeRefId(document2.source.absoluteRef, ref.$ref);
                resolvedRefMap.set(refId2, resolvedRef2);
                return resolvedRef2;
              }
              let resolvedRef = {
                resolved: true,
                document: targetDoc,
                isRemote,
                node: document2.parsed,
                nodePointer: "#/"
              };
              let target = targetDoc.parsed;
              const segments = pointer;
              for (const segment of segments) {
                if (typeof target !== "object") {
                  target = void 0;
                  break;
                } else if (target[segment] !== void 0) {
                  target = target[segment];
                  resolvedRef.nodePointer = (0, ref_utils_1.joinPointer)(resolvedRef.nodePointer, (0, ref_utils_1.escapePointer)(segment));
                } else if ((0, ref_utils_1.isRef)(target)) {
                  resolvedRef = yield followRef(targetDoc, target, pushRef(refStack, target));
                  targetDoc = resolvedRef.document || targetDoc;
                  if (typeof resolvedRef.node !== "object") {
                    target = void 0;
                    break;
                  }
                  target = resolvedRef.node[segment];
                  resolvedRef.nodePointer = (0, ref_utils_1.joinPointer)(resolvedRef.nodePointer, (0, ref_utils_1.escapePointer)(segment));
                } else {
                  target = void 0;
                  break;
                }
              }
              resolvedRef.node = target;
              resolvedRef.document = targetDoc;
              const refId = makeRefId(document2.source.absoluteRef, ref.$ref);
              if (resolvedRef.document && (0, ref_utils_1.isRef)(target)) {
                resolvedRef = yield followRef(resolvedRef.document, target, pushRef(refStack, target));
              }
              resolvedRefMap.set(refId, resolvedRef);
              return Object.assign({}, resolvedRef);
            });
          }
        }
      });
    }
    exports2.resolveDocument = resolveDocument;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/no-unresolved-refs.js
var require_no_unresolved_refs = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/no-unresolved-refs.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.reportUnresolvedRef = exports2.NoUnresolvedRefs = void 0;
    var resolve_1 = require_resolve2();
    var NoUnresolvedRefs = () => {
      return {
        ref: {
          leave(_, { report, location }, resolved) {
            if (resolved.node !== void 0)
              return;
            reportUnresolvedRef(resolved, report, location);
          }
        },
        DiscriminatorMapping(mapping, { report, resolve, location }) {
          for (const mappingName of Object.keys(mapping)) {
            const resolved = resolve({ $ref: mapping[mappingName] });
            if (resolved.node !== void 0)
              return;
            reportUnresolvedRef(resolved, report, location.child(mappingName));
          }
        }
      };
    };
    exports2.NoUnresolvedRefs = NoUnresolvedRefs;
    function reportUnresolvedRef(resolved, report, location) {
      var _a;
      const error = resolved.error;
      if (error instanceof resolve_1.YamlParseError) {
        report({
          message: "Failed to parse: " + error.message,
          location: {
            source: error.source,
            pointer: void 0,
            start: {
              col: error.col,
              line: error.line
            }
          }
        });
      }
      const message = (_a = resolved.error) === null || _a === void 0 ? void 0 : _a.message;
      report({
        location,
        message: `Can't resolve $ref${message ? ": " + message : ""}`
      });
    }
    exports2.reportUnresolvedRef = reportUnresolvedRef;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/boolean-parameter-prefixes.js
var require_boolean_parameter_prefixes = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/boolean-parameter-prefixes.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.BooleanParameterPrefixes = void 0;
    var BooleanParameterPrefixes = (options) => {
      const prefixes = options.prefixes || ["is", "has"];
      const regexp = new RegExp(`^(${prefixes.join("|")})[A-Z-_]`);
      const wrappedPrefixes = prefixes.map((p) => `\`${p}\``);
      const prefixesString = wrappedPrefixes.length === 1 ? wrappedPrefixes[0] : wrappedPrefixes.slice(0, -1).join(", ") + " or " + wrappedPrefixes[prefixes.length - 1];
      return {
        Parameter: {
          Schema(schema2, { report, parentLocations }, parents) {
            if (schema2.type === "boolean" && !regexp.test(parents.Parameter.name)) {
              report({
                message: `Boolean parameter \`${parents.Parameter.name}\` should have ${prefixesString} prefix.`,
                location: parentLocations.Parameter.child(["name"])
              });
            }
          }
        }
      };
    };
    exports2.BooleanParameterPrefixes = BooleanParameterPrefixes;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/paths-kebab-case.js
var require_paths_kebab_case = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/paths-kebab-case.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PathsKebabCase = void 0;
    var PathsKebabCase = () => {
      return {
        PathItem(_path, { report, key }) {
          const segments = key.substr(1).split("/").filter((s) => s !== "");
          if (!segments.every((segment) => /^{.+}$/.test(segment) || /^[a-z0-9-.]+$/.test(segment))) {
            report({
              message: `\`${key}\` does not use kebab-case.`,
              location: { reportOnKey: true }
            });
          }
        }
      };
    };
    exports2.PathsKebabCase = PathsKebabCase;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-http-verbs-order.js
var require_path_http_verbs_order = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-http-verbs-order.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PathHttpVerbsOrder = void 0;
    var defaultOrder = ["get", "head", "post", "put", "patch", "delete", "options", "trace"];
    var PathHttpVerbsOrder = (opts) => {
      const order = opts && opts.order || defaultOrder;
      if (!Array.isArray(order)) {
        throw new Error("path-http-verbs-order `order` option must be an array");
      }
      return {
        PathItem(path5, { report, location }) {
          const httpVerbs = Object.keys(path5).filter((k) => order.includes(k));
          for (let i = 0; i < httpVerbs.length - 1; i++) {
            const aIdx = order.indexOf(httpVerbs[i]);
            const bIdx = order.indexOf(httpVerbs[i + 1]);
            if (bIdx < aIdx) {
              report({
                message: "Operation http verbs must be ordered.",
                location: Object.assign({ reportOnKey: true }, location.child(httpVerbs[i + 1]))
              });
            }
          }
        }
      };
    };
    exports2.PathHttpVerbsOrder = PathHttpVerbsOrder;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-empty-servers.js
var require_no_empty_servers = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-empty-servers.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoEmptyServers = void 0;
    var NoEmptyServers = () => {
      return {
        Root(root2, { report, location }) {
          if (!root2.hasOwnProperty("servers")) {
            report({
              message: "Servers must be present.",
              location: location.child(["openapi"]).key()
            });
            return;
          }
          if (!Array.isArray(root2.servers) || root2.servers.length === 0) {
            report({
              message: "Servers must be a non-empty array.",
              location: location.child(["servers"]).key()
            });
          }
        }
      };
    };
    exports2.NoEmptyServers = NoEmptyServers;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-invalid-media-type-examples.js
var require_no_invalid_media_type_examples = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-invalid-media-type-examples.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ValidContentExamples = void 0;
    var ref_utils_1 = require_ref_utils();
    var utils_1 = require_utils6();
    var ValidContentExamples = (opts) => {
      var _a;
      const allowAdditionalProperties = (_a = (0, utils_1.getAdditionalPropertiesOption)(opts)) !== null && _a !== void 0 ? _a : false;
      return {
        MediaType: {
          leave(mediaType, ctx) {
            const { location, resolve } = ctx;
            if (!mediaType.schema)
              return;
            if (mediaType.example) {
              resolveAndValidateExample(mediaType.example, location.child("example"));
            } else if (mediaType.examples) {
              for (const exampleName of Object.keys(mediaType.examples)) {
                resolveAndValidateExample(mediaType.examples[exampleName], location.child(["examples", exampleName, "value"]), true);
              }
            }
            function resolveAndValidateExample(example, location2, isMultiple) {
              if ((0, ref_utils_1.isRef)(example)) {
                const resolved = resolve(example);
                if (!resolved.location)
                  return;
                location2 = isMultiple ? resolved.location.child("value") : resolved.location;
                example = resolved.node;
              }
              (0, utils_1.validateExample)(isMultiple ? example.value : example, mediaType.schema, location2, ctx, allowAdditionalProperties);
            }
          }
        }
      };
    };
    exports2.ValidContentExamples = ValidContentExamples;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-identical-paths.js
var require_no_identical_paths = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-identical-paths.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoIdenticalPaths = void 0;
    var NoIdenticalPaths = () => {
      return {
        Paths(pathMap, { report, location }) {
          const Paths = /* @__PURE__ */ new Map();
          for (const pathName of Object.keys(pathMap)) {
            const id = pathName.replace(/{.+?}/g, "{VARIABLE}");
            const existingSamePath = Paths.get(id);
            if (existingSamePath) {
              report({
                message: `The path already exists which differs only by path parameter name(s): \`${existingSamePath}\` and \`${pathName}\`.`,
                location: location.child([pathName]).key()
              });
            } else {
              Paths.set(id, pathName);
            }
          }
        }
      };
    };
    exports2.NoIdenticalPaths = NoIdenticalPaths;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-undefined-server-variable.js
var require_no_undefined_server_variable = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-undefined-server-variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoUndefinedServerVariable = void 0;
    var NoUndefinedServerVariable = () => {
      return {
        Server(server, { report, location }) {
          var _a;
          if (!server.url)
            return;
          const urlVariables = ((_a = server.url.match(/{[^}]+}/g)) === null || _a === void 0 ? void 0 : _a.map((e) => e.slice(1, e.length - 1))) || [];
          const definedVariables = (server === null || server === void 0 ? void 0 : server.variables) && Object.keys(server.variables) || [];
          for (const serverVar of urlVariables) {
            if (!definedVariables.includes(serverVar)) {
              report({
                message: `The \`${serverVar}\` variable is not defined in the \`variables\` objects.`,
                location: location.child(["url"])
              });
            }
          }
          for (const definedServerVar of definedVariables) {
            if (!urlVariables.includes(definedServerVar)) {
              report({
                message: `The \`${definedServerVar}\` variable is not used in the server's \`url\` field.`,
                location: location.child(["variables", definedServerVar]).key(),
                from: location.child("url")
              });
            }
          }
        }
      };
    };
    exports2.NoUndefinedServerVariable = NoUndefinedServerVariable;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-operationId.js
var require_operation_operationId = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-operationId.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationOperationId = void 0;
    var utils_1 = require_utils6();
    var OperationOperationId = () => {
      return {
        Root: {
          PathItem: {
            Operation(operation, ctx) {
              (0, utils_1.validateDefinedAndNonEmpty)("operationId", operation, ctx);
            }
          }
        }
      };
    };
    exports2.OperationOperationId = OperationOperationId;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-summary.js
var require_operation_summary = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-summary.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationSummary = void 0;
    var utils_1 = require_utils6();
    var OperationSummary = () => {
      return {
        Operation(operation, ctx) {
          (0, utils_1.validateDefinedAndNonEmpty)("summary", operation, ctx);
        }
      };
    };
    exports2.OperationSummary = OperationSummary;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-ambiguous-paths.js
var require_no_ambiguous_paths = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-ambiguous-paths.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoAmbiguousPaths = void 0;
    var NoAmbiguousPaths = () => {
      return {
        Paths(pathMap, { report, location }) {
          const seenPaths = [];
          for (const currentPath of Object.keys(pathMap)) {
            const ambiguousPath = seenPaths.find((seenPath) => arePathsAmbiguous(seenPath, currentPath));
            if (ambiguousPath) {
              report({
                message: `Paths should resolve unambiguously. Found two ambiguous paths: \`${ambiguousPath}\` and \`${currentPath}\`.`,
                location: location.child([currentPath]).key()
              });
            }
            seenPaths.push(currentPath);
          }
        }
      };
    };
    exports2.NoAmbiguousPaths = NoAmbiguousPaths;
    function arePathsAmbiguous(a, b) {
      const partsA = a.split("/");
      const partsB = b.split("/");
      if (partsA.length !== partsB.length)
        return false;
      let aVars = 0;
      let bVars = 0;
      let ambiguous = true;
      for (let i = 0; i < partsA.length; i++) {
        const aIsVar = partsA[i].match(/^{.+?}$/);
        const bIsVar = partsB[i].match(/^{.+?}$/);
        if (aIsVar || bIsVar) {
          if (aIsVar)
            aVars++;
          if (bIsVar)
            bVars++;
          continue;
        } else if (partsA[i] !== partsB[i]) {
          ambiguous = false;
        }
      }
      return ambiguous && aVars === bVars;
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-server-variables-empty-enum.js
var require_no_server_variables_empty_enum = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-server-variables-empty-enum.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoServerVariablesEmptyEnum = void 0;
    var enumError;
    (function(enumError2) {
      enumError2["empty"] = "empty";
      enumError2["invalidDefaultValue"] = "invalidDefaultValue";
    })(enumError || (enumError = {}));
    var NoServerVariablesEmptyEnum = () => {
      return {
        Root(root2, { report, location }) {
          if (!root2.servers || root2.servers.length === 0)
            return;
          const invalidVariables = [];
          if (Array.isArray(root2.servers)) {
            for (const server of root2.servers) {
              const enumErrors = checkEnumVariables(server);
              if (!enumErrors)
                continue;
              invalidVariables.push(...enumErrors);
            }
          } else {
            const enumErrors = checkEnumVariables(root2.servers);
            if (!enumErrors)
              return;
            invalidVariables.push(...enumErrors);
          }
          for (const invalidVariable of invalidVariables) {
            if (invalidVariable === enumError.empty) {
              report({
                message: "Server variable with `enum` must be a non-empty array.",
                location: location.child(["servers"]).key()
              });
            }
            if (invalidVariable === enumError.invalidDefaultValue) {
              report({
                message: "Server variable define `enum` and `default`. `enum` must include default value",
                location: location.child(["servers"]).key()
              });
            }
          }
        }
      };
    };
    exports2.NoServerVariablesEmptyEnum = NoServerVariablesEmptyEnum;
    function checkEnumVariables(server) {
      var _a;
      if (server.variables && Object.keys(server.variables).length === 0)
        return;
      const errors = [];
      for (const variable in server.variables) {
        const serverVariable = server.variables[variable];
        if (!serverVariable.enum)
          continue;
        if (Array.isArray(serverVariable.enum) && ((_a = serverVariable.enum) === null || _a === void 0 ? void 0 : _a.length) === 0)
          errors.push(enumError.empty);
        if (!serverVariable.default)
          continue;
        const defaultValue = server.variables[variable].default;
        if (serverVariable.enum && !serverVariable.enum.includes(defaultValue))
          errors.push(enumError.invalidDefaultValue);
      }
      if (errors.length)
        return errors;
      return;
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-http-verbs-in-paths.js
var require_no_http_verbs_in_paths = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-http-verbs-in-paths.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoHttpVerbsInPaths = void 0;
    var utils_1 = require_utils4();
    var httpMethods = ["get", "head", "post", "put", "patch", "delete", "options", "trace"];
    var NoHttpVerbsInPaths = ({ splitIntoWords }) => {
      return {
        PathItem(_path, { key, report, location }) {
          const pathKey = key.toString();
          if (!pathKey.startsWith("/"))
            return;
          const pathSegments = pathKey.split("/");
          for (const pathSegment of pathSegments) {
            if (!pathSegment || (0, utils_1.isPathParameter)(pathSegment))
              continue;
            const isHttpMethodIncluded = (method) => {
              return splitIntoWords ? (0, utils_1.splitCamelCaseIntoWords)(pathSegment).has(method) : pathSegment.toLocaleLowerCase().includes(method);
            };
            for (const method of httpMethods) {
              if (isHttpMethodIncluded(method)) {
                report({
                  message: `path \`${pathKey}\` should not contain http verb ${method}`,
                  location: location.key()
                });
              }
            }
          }
        }
      };
    };
    exports2.NoHttpVerbsInPaths = NoHttpVerbsInPaths;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/request-mime-type.js
var require_request_mime_type = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/request-mime-type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RequestMimeType = void 0;
    var utils_1 = require_utils4();
    var RequestMimeType = ({ allowedValues }) => {
      return {
        Paths: {
          RequestBody: {
            leave(requestBody, ctx) {
              (0, utils_1.validateMimeTypeOAS3)({ type: "consumes", value: requestBody }, ctx, allowedValues);
            }
          },
          Callback: {
            RequestBody() {
            },
            Response: {
              leave(response, ctx) {
                (0, utils_1.validateMimeTypeOAS3)({ type: "consumes", value: response }, ctx, allowedValues);
              }
            }
          }
        },
        WebhooksMap: {
          Response: {
            leave(response, ctx) {
              (0, utils_1.validateMimeTypeOAS3)({ type: "consumes", value: response }, ctx, allowedValues);
            }
          }
        }
      };
    };
    exports2.RequestMimeType = RequestMimeType;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/response-mime-type.js
var require_response_mime_type = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/response-mime-type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ResponseMimeType = void 0;
    var utils_1 = require_utils4();
    var ResponseMimeType = ({ allowedValues }) => {
      return {
        Paths: {
          Response: {
            leave(response, ctx) {
              (0, utils_1.validateMimeTypeOAS3)({ type: "produces", value: response }, ctx, allowedValues);
            }
          },
          Callback: {
            Response() {
            },
            RequestBody: {
              leave(requestBody, ctx) {
                (0, utils_1.validateMimeTypeOAS3)({ type: "produces", value: requestBody }, ctx, allowedValues);
              }
            }
          }
        },
        WebhooksMap: {
          RequestBody: {
            leave(requestBody, ctx) {
              (0, utils_1.validateMimeTypeOAS3)({ type: "produces", value: requestBody }, ctx, allowedValues);
            }
          }
        }
      };
    };
    exports2.ResponseMimeType = ResponseMimeType;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-segment-plural.js
var require_path_segment_plural = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-segment-plural.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PathSegmentPlural = void 0;
    var utils_1 = require_utils4();
    var PathSegmentPlural = (opts) => {
      const { ignoreLastPathSegment, exceptions } = opts;
      return {
        PathItem: {
          leave(_path, { report, key, location }) {
            const pathKey = key.toString();
            if (pathKey.startsWith("/")) {
              const pathSegments = pathKey.split("/");
              pathSegments.shift();
              if (ignoreLastPathSegment && pathSegments.length > 1) {
                pathSegments.pop();
              }
              for (const pathSegment of pathSegments) {
                if (exceptions && exceptions.includes(pathSegment))
                  continue;
                if (!(0, utils_1.isPathParameter)(pathSegment) && (0, utils_1.isSingular)(pathSegment)) {
                  report({
                    message: `path segment \`${pathSegment}\` should be plural.`,
                    location: location.key()
                  });
                }
              }
            }
          }
        }
      };
    };
    exports2.PathSegmentPlural = PathSegmentPlural;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-excludes-patterns.js
var require_path_excludes_patterns = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-excludes-patterns.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PathExcludesPatterns = void 0;
    var PathExcludesPatterns = ({ patterns }) => {
      return {
        PathItem(_path, { report, key, location }) {
          if (!patterns)
            throw new Error(`Parameter "patterns" is not provided for "path-excludes-patterns" rule`);
          const pathKey = key.toString();
          if (pathKey.startsWith("/")) {
            const matches = patterns.filter((pattern) => pathKey.match(pattern));
            for (const match of matches) {
              report({
                message: `path \`${pathKey}\` should not match regex pattern: \`${match}\``,
                location: location.key()
              });
            }
          }
        }
      };
    };
    exports2.PathExcludesPatterns = PathExcludesPatterns;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-invalid-schema-examples.js
var require_no_invalid_schema_examples = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-invalid-schema-examples.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoInvalidSchemaExamples = void 0;
    var utils_1 = require_utils6();
    var NoInvalidSchemaExamples = (opts) => {
      var _a;
      const allowAdditionalProperties = (_a = (0, utils_1.getAdditionalPropertiesOption)(opts)) !== null && _a !== void 0 ? _a : false;
      return {
        Schema: {
          leave(schema2, ctx) {
            if (schema2.examples) {
              for (const example of schema2.examples) {
                (0, utils_1.validateExample)(example, schema2, ctx.location.child(["examples", schema2.examples.indexOf(example)]), ctx, allowAdditionalProperties);
              }
            }
            if (schema2.example) {
              (0, utils_1.validateExample)(schema2.example, schema2, ctx.location.child("example"), ctx, true);
            }
          }
        }
      };
    };
    exports2.NoInvalidSchemaExamples = NoInvalidSchemaExamples;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-invalid-parameter-examples.js
var require_no_invalid_parameter_examples = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-invalid-parameter-examples.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoInvalidParameterExamples = void 0;
    var utils_1 = require_utils6();
    var NoInvalidParameterExamples = (opts) => {
      var _a;
      const allowAdditionalProperties = (_a = (0, utils_1.getAdditionalPropertiesOption)(opts)) !== null && _a !== void 0 ? _a : false;
      return {
        Parameter: {
          leave(parameter, ctx) {
            if (parameter.example) {
              (0, utils_1.validateExample)(parameter.example, parameter.schema, ctx.location.child("example"), ctx, allowAdditionalProperties);
            }
            if (parameter.examples) {
              for (const [key, example] of Object.entries(parameter.examples)) {
                if ("value" in example) {
                  (0, utils_1.validateExample)(example.value, parameter.schema, ctx.location.child(["examples", key]), ctx, true);
                }
              }
            }
          }
        }
      };
    };
    exports2.NoInvalidParameterExamples = NoInvalidParameterExamples;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/response-contains-header.js
var require_response_contains_header = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/response-contains-header.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ResponseContainsHeader = void 0;
    var utils_1 = require_utils4();
    var ResponseContainsHeader = (options) => {
      const names = options.names || {};
      return {
        Operation: {
          Response: {
            enter: (response, { report, location, key }) => {
              const expectedHeaders = names[key] || names[(0, utils_1.getMatchingStatusCodeRange)(key)] || names[(0, utils_1.getMatchingStatusCodeRange)(key).toLowerCase()] || [];
              for (const expectedHeader of expectedHeaders) {
                if (!(response === null || response === void 0 ? void 0 : response.headers) || !Object.keys(response === null || response === void 0 ? void 0 : response.headers).some((header) => header.toLowerCase() === expectedHeader.toLowerCase())) {
                  report({
                    message: `Response object must contain a "${expectedHeader}" header.`,
                    location: location.child("headers").key()
                  });
                }
              }
            }
          }
        }
      };
    };
    exports2.ResponseContainsHeader = ResponseContainsHeader;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/response-contains-property.js
var require_response_contains_property = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/response-contains-property.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ResponseContainsProperty = void 0;
    var utils_1 = require_utils4();
    var ResponseContainsProperty = (options) => {
      const names = options.names || {};
      let key;
      return {
        Operation: {
          Response: {
            skip: (_response, key2) => {
              return `${key2}` === "204";
            },
            enter: (_response, ctx) => {
              key = ctx.key;
            },
            MediaType: {
              Schema(schema2, { report, location }) {
                var _a;
                if (schema2.type !== "object")
                  return;
                const expectedProperties = names[key] || names[(0, utils_1.getMatchingStatusCodeRange)(key)] || names[(0, utils_1.getMatchingStatusCodeRange)(key).toLowerCase()] || [];
                for (const expectedProperty of expectedProperties) {
                  if (!((_a = schema2.properties) === null || _a === void 0 ? void 0 : _a[expectedProperty])) {
                    report({
                      message: `Response object must contain a top-level "${expectedProperty}" property.`,
                      location: location.child("properties").key()
                    });
                  }
                }
              }
            }
          }
        }
      };
    };
    exports2.ResponseContainsProperty = ResponseContainsProperty;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/scalar-property-missing-example.js
var require_scalar_property_missing_example = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/scalar-property-missing-example.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ScalarPropertyMissingExample = void 0;
    var oas_types_1 = require_oas_types();
    var SCALAR_TYPES = ["string", "integer", "number", "boolean", "null"];
    var ScalarPropertyMissingExample = () => {
      return {
        SchemaProperties(properties, { report, location, oasVersion, resolve }) {
          for (const propName of Object.keys(properties)) {
            const propSchema = resolve(properties[propName]).node;
            if (!propSchema || !isScalarSchema(propSchema)) {
              continue;
            }
            if (propSchema.example === void 0 && propSchema.examples === void 0) {
              report({
                message: `Scalar property should have "example"${oasVersion === oas_types_1.SpecVersion.OAS3_1 ? ' or "examples"' : ""} defined.`,
                location: location.child(propName).key()
              });
            }
          }
        }
      };
    };
    exports2.ScalarPropertyMissingExample = ScalarPropertyMissingExample;
    function isScalarSchema(schema2) {
      if (!schema2.type) {
        return false;
      }
      if (schema2.allOf || schema2.anyOf || schema2.oneOf) {
        return false;
      }
      if (schema2.format === "binary") {
        return false;
      }
      if (Array.isArray(schema2.type)) {
        return schema2.type.every((t) => SCALAR_TYPES.includes(t));
      }
      return SCALAR_TYPES.includes(schema2.type);
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/spec-components-invalid-map-name.js
var require_spec_components_invalid_map_name = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/spec-components-invalid-map-name.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SpecComponentsInvalidMapName = void 0;
    var SpecComponentsInvalidMapName = () => {
      const KEYS_REGEX = "^[a-zA-Z0-9\\.\\-_]+$";
      function validateKey(key, report, location, component) {
        if (!new RegExp(KEYS_REGEX).test(key)) {
          report({
            message: `The map key in ${component} "${key}" does not match the regular expression "${KEYS_REGEX}"`,
            location: location.key()
          });
        }
      }
      return {
        NamedSchemas: {
          Schema(_node, { key, report, location }) {
            validateKey(key, report, location, "schemas");
          }
        },
        NamedParameters: {
          Parameter(_node, { key, report, location }) {
            validateKey(key, report, location, "parameters");
          }
        },
        NamedResponses: {
          Response(_node, { key, report, location }) {
            validateKey(key, report, location, "responses");
          }
        },
        NamedExamples: {
          Example(_node, { key, report, location }) {
            validateKey(key, report, location, "examples");
          }
        },
        NamedRequestBodies: {
          RequestBody(_node, { key, report, location }) {
            validateKey(key, report, location, "requestBodies");
          }
        },
        NamedHeaders: {
          Header(_node, { key, report, location }) {
            validateKey(key, report, location, "headers");
          }
        },
        NamedSecuritySchemes: {
          SecurityScheme(_node, { key, report, location }) {
            validateKey(key, report, location, "securitySchemes");
          }
        },
        NamedLinks: {
          Link(_node, { key, report, location }) {
            validateKey(key, report, location, "links");
          }
        },
        NamedCallbacks: {
          Callback(_node, { key, report, location }) {
            validateKey(key, report, location, "callbacks");
          }
        }
      };
    };
    exports2.SpecComponentsInvalidMapName = SpecComponentsInvalidMapName;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/operation-4xx-problem-details-rfc7807.js
var require_operation_4xx_problem_details_rfc7807 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/operation-4xx-problem-details-rfc7807.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Operation4xxProblemDetailsRfc7807 = void 0;
    var utils_1 = require_utils6();
    var Operation4xxProblemDetailsRfc7807 = () => {
      return {
        Response: {
          skip(_, key) {
            return !/4[Xx0-9]{2}/.test(`${key}`);
          },
          enter(response, { report, location }) {
            if (!response.content || !response.content["application/problem+json"])
              report({
                message: "Response `4xx` must have content-type `application/problem+json`.",
                location: location.key()
              });
          },
          MediaType: {
            skip(_, key) {
              return key !== "application/problem+json";
            },
            enter(media, ctx) {
              (0, utils_1.validateDefinedAndNonEmpty)("schema", media, ctx);
            },
            SchemaProperties(schema2, ctx) {
              (0, utils_1.validateDefinedAndNonEmpty)("type", schema2, ctx);
              (0, utils_1.validateDefinedAndNonEmpty)("title", schema2, ctx);
            }
          }
        }
      };
    };
    exports2.Operation4xxProblemDetailsRfc7807 = Operation4xxProblemDetailsRfc7807;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/required-string-property-missing-min-length.js
var require_required_string_property_missing_min_length = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/required-string-property-missing-min-length.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RequiredStringPropertyMissingMinLength = void 0;
    var RequiredStringPropertyMissingMinLength = () => {
      let skipSchemaProperties;
      let requiredPropertiesSet;
      return {
        Schema: {
          enter(schema2) {
            if (!(schema2 === null || schema2 === void 0 ? void 0 : schema2.required)) {
              skipSchemaProperties = true;
              return;
            }
            requiredPropertiesSet = new Set(schema2.required);
            skipSchemaProperties = false;
          },
          SchemaProperties: {
            skip() {
              return skipSchemaProperties;
            },
            Schema: {
              enter(schema2, { key, location, report }) {
                if (requiredPropertiesSet.has(key) && schema2.type === "string") {
                  if (!(schema2 === null || schema2 === void 0 ? void 0 : schema2.minLength)) {
                    report({
                      message: "Property minLength is required.",
                      location: location.key()
                    });
                  }
                }
              }
            }
          }
        }
      };
    };
    exports2.RequiredStringPropertyMissingMinLength = RequiredStringPropertyMissingMinLength;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/spec-strict-refs.js
var require_spec_strict_refs = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/spec-strict-refs.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SpecStrictRefs = void 0;
    var ref_utils_1 = require_ref_utils();
    var SpecStrictRefs = () => {
      const nodesToSkip = [
        "Schema",
        "Response",
        "Parameter",
        "RequestBody",
        "Example",
        "Header",
        "SecurityScheme",
        "Link",
        "Callback",
        "PathItem"
      ];
      return {
        any(_node, { report, rawNode, rawLocation, type: type2 }) {
          const shouldCheck = !nodesToSkip.includes(type2.name);
          if (shouldCheck && (0, ref_utils_1.isRef)(rawNode)) {
            report({
              message: "Field $ref is not expected here.",
              location: rawLocation.child("$ref").key()
            });
          }
        }
      };
    };
    exports2.SpecStrictRefs = SpecStrictRefs;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/component-name-unique.js
var require_component_name_unique = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/component-name-unique.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ComponentNameUnique = void 0;
    var TYPE_NAME_SCHEMA = "Schema";
    var TYPE_NAME_PARAMETER = "Parameter";
    var TYPE_NAME_RESPONSE = "Response";
    var TYPE_NAME_REQUEST_BODY = "RequestBody";
    var TYPE_NAME_TO_OPTION_COMPONENT_NAME = {
      [TYPE_NAME_SCHEMA]: "schemas",
      [TYPE_NAME_PARAMETER]: "parameters",
      [TYPE_NAME_RESPONSE]: "responses",
      [TYPE_NAME_REQUEST_BODY]: "requestBodies"
    };
    var ComponentNameUnique = (options) => {
      const components = /* @__PURE__ */ new Map();
      const typeNames = [];
      if (options.schemas !== "off") {
        typeNames.push(TYPE_NAME_SCHEMA);
      }
      if (options.parameters !== "off") {
        typeNames.push(TYPE_NAME_PARAMETER);
      }
      if (options.responses !== "off") {
        typeNames.push(TYPE_NAME_RESPONSE);
      }
      if (options.requestBodies !== "off") {
        typeNames.push(TYPE_NAME_REQUEST_BODY);
      }
      const rule = {
        ref: {
          leave(ref, { type: type2, resolve }) {
            const typeName = type2.name;
            if (typeNames.includes(typeName)) {
              const resolvedRef = resolve(ref);
              if (!resolvedRef.location)
                return;
              addComponentFromAbsoluteLocation(typeName, resolvedRef.location.absolutePointer.toString());
            }
          }
        },
        Root: {
          leave(root2, ctx) {
            components.forEach((value, key, _) => {
              if (value.size > 1) {
                const component = getComponentFromKey(key);
                const optionComponentName = getOptionComponentNameForTypeName(component.typeName);
                const definitions = Array.from(value).map((v) => `- ${v}`).join("\n");
                const problem = {
                  message: `Component '${optionComponentName}/${component.componentName}' is not unique. It is defined at:
${definitions}`
                };
                const componentSeverity = optionComponentName ? options[optionComponentName] : null;
                if (componentSeverity) {
                  problem.forceSeverity = componentSeverity;
                }
                ctx.report(problem);
              }
            });
          }
        }
      };
      if (options.schemas != "off") {
        rule.NamedSchemas = {
          Schema(_, { location }) {
            addComponentFromAbsoluteLocation(TYPE_NAME_SCHEMA, location.absolutePointer.toString());
          }
        };
      }
      if (options.responses != "off") {
        rule.NamedResponses = {
          Response(_, { location }) {
            addComponentFromAbsoluteLocation(TYPE_NAME_RESPONSE, location.absolutePointer.toString());
          }
        };
      }
      if (options.parameters != "off") {
        rule.NamedParameters = {
          Parameter(_, { location }) {
            addComponentFromAbsoluteLocation(TYPE_NAME_PARAMETER, location.absolutePointer.toString());
          }
        };
      }
      if (options.requestBodies != "off") {
        rule.NamedRequestBodies = {
          RequestBody(_, { location }) {
            addComponentFromAbsoluteLocation(TYPE_NAME_REQUEST_BODY, location.absolutePointer.toString());
          }
        };
      }
      return rule;
      function getComponentNameFromAbsoluteLocation(absoluteLocation) {
        const componentName = absoluteLocation.split("/").slice(-1)[0];
        if (componentName.endsWith(".yml") || componentName.endsWith(".yaml") || componentName.endsWith(".json")) {
          return componentName.slice(0, componentName.lastIndexOf("."));
        }
        return componentName;
      }
      function addFoundComponent(typeName, componentName, absoluteLocation) {
        var _a;
        const key = getKeyForComponent(typeName, componentName);
        const locations = (_a = components.get(key)) !== null && _a !== void 0 ? _a : /* @__PURE__ */ new Set();
        locations.add(absoluteLocation);
        components.set(key, locations);
      }
      function addComponentFromAbsoluteLocation(typeName, absoluteLocation) {
        const componentName = getComponentNameFromAbsoluteLocation(absoluteLocation);
        addFoundComponent(typeName, componentName, absoluteLocation);
      }
    };
    exports2.ComponentNameUnique = ComponentNameUnique;
    function getOptionComponentNameForTypeName(typeName) {
      var _a;
      return (_a = TYPE_NAME_TO_OPTION_COMPONENT_NAME[typeName]) !== null && _a !== void 0 ? _a : null;
    }
    function getKeyForComponent(typeName, componentName) {
      return `${typeName}/${componentName}`;
    }
    function getComponentFromKey(key) {
      const [typeName, componentName] = key.split("/");
      return { typeName, componentName };
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/index.js
var require_oas32 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.preprocessors = exports2.rules = void 0;
    var spec_1 = require_spec();
    var operation_2xx_response_1 = require_operation_2xx_response();
    var operation_4xx_response_1 = require_operation_4xx_response();
    var assertions_1 = require_assertions();
    var operation_operationId_unique_1 = require_operation_operationId_unique();
    var operation_parameters_unique_1 = require_operation_parameters_unique();
    var path_params_defined_1 = require_path_params_defined();
    var operation_tag_defined_1 = require_operation_tag_defined();
    var no_example_value_and_externalValue_1 = require_no_example_value_and_externalValue();
    var no_enum_type_mismatch_1 = require_no_enum_type_mismatch();
    var no_path_trailing_slash_1 = require_no_path_trailing_slash();
    var path_declaration_must_exist_1 = require_path_declaration_must_exist();
    var operation_operationId_url_safe_1 = require_operation_operationId_url_safe();
    var tags_alphabetical_1 = require_tags_alphabetical();
    var no_server_example_com_1 = require_no_server_example_com();
    var no_server_trailing_slash_1 = require_no_server_trailing_slash();
    var tag_description_1 = require_tag_description();
    var info_contact_1 = require_info_contact();
    var info_license_1 = require_info_license();
    var info_license_url_1 = require_info_license_url();
    var operation_description_1 = require_operation_description();
    var no_unused_components_1 = require_no_unused_components();
    var path_not_include_query_1 = require_path_not_include_query();
    var parameter_description_1 = require_parameter_description();
    var operation_singular_tag_1 = require_operation_singular_tag();
    var security_defined_1 = require_security_defined();
    var no_unresolved_refs_1 = require_no_unresolved_refs();
    var boolean_parameter_prefixes_1 = require_boolean_parameter_prefixes();
    var paths_kebab_case_1 = require_paths_kebab_case();
    var path_http_verbs_order_1 = require_path_http_verbs_order();
    var no_empty_servers_1 = require_no_empty_servers();
    var no_invalid_media_type_examples_1 = require_no_invalid_media_type_examples();
    var no_identical_paths_1 = require_no_identical_paths();
    var no_undefined_server_variable_1 = require_no_undefined_server_variable();
    var operation_operationId_1 = require_operation_operationId();
    var operation_summary_1 = require_operation_summary();
    var no_ambiguous_paths_1 = require_no_ambiguous_paths();
    var no_server_variables_empty_enum_1 = require_no_server_variables_empty_enum();
    var no_http_verbs_in_paths_1 = require_no_http_verbs_in_paths();
    var request_mime_type_1 = require_request_mime_type();
    var response_mime_type_1 = require_response_mime_type();
    var path_segment_plural_1 = require_path_segment_plural();
    var path_excludes_patterns_1 = require_path_excludes_patterns();
    var no_invalid_schema_examples_1 = require_no_invalid_schema_examples();
    var no_invalid_parameter_examples_1 = require_no_invalid_parameter_examples();
    var response_contains_header_1 = require_response_contains_header();
    var response_contains_property_1 = require_response_contains_property();
    var scalar_property_missing_example_1 = require_scalar_property_missing_example();
    var spec_components_invalid_map_name_1 = require_spec_components_invalid_map_name();
    var operation_4xx_problem_details_rfc7807_1 = require_operation_4xx_problem_details_rfc7807();
    var required_string_property_missing_min_length_1 = require_required_string_property_missing_min_length();
    var spec_strict_refs_1 = require_spec_strict_refs();
    var component_name_unique_1 = require_component_name_unique();
    exports2.rules = {
      spec: spec_1.Spec,
      "info-contact": info_contact_1.InfoContact,
      "info-license": info_license_1.InfoLicense,
      "info-license-url": info_license_url_1.InfoLicenseUrl,
      "operation-2xx-response": operation_2xx_response_1.Operation2xxResponse,
      "operation-4xx-response": operation_4xx_response_1.Operation4xxResponse,
      "operation-4xx-problem-details-rfc7807": operation_4xx_problem_details_rfc7807_1.Operation4xxProblemDetailsRfc7807,
      assertions: assertions_1.Assertions,
      "operation-operationId-unique": operation_operationId_unique_1.OperationIdUnique,
      "operation-parameters-unique": operation_parameters_unique_1.OperationParametersUnique,
      "operation-tag-defined": operation_tag_defined_1.OperationTagDefined,
      "no-example-value-and-externalValue": no_example_value_and_externalValue_1.NoExampleValueAndExternalValue,
      "no-enum-type-mismatch": no_enum_type_mismatch_1.NoEnumTypeMismatch,
      "no-path-trailing-slash": no_path_trailing_slash_1.NoPathTrailingSlash,
      "no-empty-servers": no_empty_servers_1.NoEmptyServers,
      "path-declaration-must-exist": path_declaration_must_exist_1.PathDeclarationMustExist,
      "operation-operationId-url-safe": operation_operationId_url_safe_1.OperationIdUrlSafe,
      "operation-operationId": operation_operationId_1.OperationOperationId,
      "operation-summary": operation_summary_1.OperationSummary,
      "tags-alphabetical": tags_alphabetical_1.TagsAlphabetical,
      "no-server-example.com": no_server_example_com_1.NoServerExample,
      "no-server-trailing-slash": no_server_trailing_slash_1.NoServerTrailingSlash,
      "tag-description": tag_description_1.TagDescription,
      "operation-description": operation_description_1.OperationDescription,
      "no-unused-components": no_unused_components_1.NoUnusedComponents,
      "path-not-include-query": path_not_include_query_1.PathNotIncludeQuery,
      "path-parameters-defined": path_params_defined_1.PathParamsDefined,
      "path-params-defined": path_params_defined_1.PathParamsDefined,
      "parameter-description": parameter_description_1.ParameterDescription,
      "operation-singular-tag": operation_singular_tag_1.OperationSingularTag,
      "security-defined": security_defined_1.SecurityDefined,
      "no-unresolved-refs": no_unresolved_refs_1.NoUnresolvedRefs,
      "paths-kebab-case": paths_kebab_case_1.PathsKebabCase,
      "boolean-parameter-prefixes": boolean_parameter_prefixes_1.BooleanParameterPrefixes,
      "path-http-verbs-order": path_http_verbs_order_1.PathHttpVerbsOrder,
      "no-invalid-media-type-examples": no_invalid_media_type_examples_1.ValidContentExamples,
      "no-identical-paths": no_identical_paths_1.NoIdenticalPaths,
      "no-ambiguous-paths": no_ambiguous_paths_1.NoAmbiguousPaths,
      "no-undefined-server-variable": no_undefined_server_variable_1.NoUndefinedServerVariable,
      "no-server-variables-empty-enum": no_server_variables_empty_enum_1.NoServerVariablesEmptyEnum,
      "no-http-verbs-in-paths": no_http_verbs_in_paths_1.NoHttpVerbsInPaths,
      "path-excludes-patterns": path_excludes_patterns_1.PathExcludesPatterns,
      "request-mime-type": request_mime_type_1.RequestMimeType,
      "response-mime-type": response_mime_type_1.ResponseMimeType,
      "path-segment-plural": path_segment_plural_1.PathSegmentPlural,
      "no-invalid-schema-examples": no_invalid_schema_examples_1.NoInvalidSchemaExamples,
      "no-invalid-parameter-examples": no_invalid_parameter_examples_1.NoInvalidParameterExamples,
      "response-contains-header": response_contains_header_1.ResponseContainsHeader,
      "response-contains-property": response_contains_property_1.ResponseContainsProperty,
      "scalar-property-missing-example": scalar_property_missing_example_1.ScalarPropertyMissingExample,
      "spec-components-invalid-map-name": spec_components_invalid_map_name_1.SpecComponentsInvalidMapName,
      "required-string-property-missing-min-length": required_string_property_missing_min_length_1.RequiredStringPropertyMissingMinLength,
      "spec-strict-refs": spec_strict_refs_1.SpecStrictRefs,
      "component-name-unique": component_name_unique_1.ComponentNameUnique
    };
    exports2.preprocessors = {};
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/boolean-parameter-prefixes.js
var require_boolean_parameter_prefixes2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/boolean-parameter-prefixes.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.BooleanParameterPrefixes = void 0;
    var BooleanParameterPrefixes = (options) => {
      const prefixes = options.prefixes || ["is", "has"];
      const regexp = new RegExp(`^(${prefixes.join("|")})[A-Z-_]`);
      const wrappedPrefixes = prefixes.map((p) => `\`${p}\``);
      const prefixesString = wrappedPrefixes.length === 1 ? wrappedPrefixes[0] : wrappedPrefixes.slice(0, -1).join(", ") + " or " + wrappedPrefixes[prefixes.length - 1];
      return {
        Parameter(param, { report, location }) {
          if (param.type === "boolean" && !regexp.test(param.name)) {
            report({
              message: `Boolean parameter \`${param.name}\` should have ${prefixesString} prefix.`,
              location: location.child("name")
            });
          }
        }
      };
    };
    exports2.BooleanParameterPrefixes = BooleanParameterPrefixes;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/request-mime-type.js
var require_request_mime_type2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/request-mime-type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RequestMimeType = void 0;
    var utils_1 = require_utils4();
    var RequestMimeType = ({ allowedValues }) => {
      return {
        Root(root2, ctx) {
          (0, utils_1.validateMimeType)({ type: "consumes", value: root2 }, ctx, allowedValues);
        },
        Operation: {
          leave(operation, ctx) {
            (0, utils_1.validateMimeType)({ type: "consumes", value: operation }, ctx, allowedValues);
          }
        }
      };
    };
    exports2.RequestMimeType = RequestMimeType;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/response-mime-type.js
var require_response_mime_type2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/response-mime-type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ResponseMimeType = void 0;
    var utils_1 = require_utils4();
    var ResponseMimeType = ({ allowedValues }) => {
      return {
        Root(root2, ctx) {
          (0, utils_1.validateMimeType)({ type: "produces", value: root2 }, ctx, allowedValues);
        },
        Operation: {
          leave(operation, ctx) {
            (0, utils_1.validateMimeType)({ type: "produces", value: operation }, ctx, allowedValues);
          }
        }
      };
    };
    exports2.ResponseMimeType = ResponseMimeType;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/response-contains-property.js
var require_response_contains_property2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/response-contains-property.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ResponseContainsProperty = void 0;
    var utils_1 = require_utils4();
    var ResponseContainsProperty = (options) => {
      const names = options.names || {};
      let key;
      return {
        Operation: {
          Response: {
            skip: (_response, key2) => {
              return `${key2}` === "204";
            },
            enter: (_response, ctx) => {
              key = ctx.key;
            },
            Schema(schema2, { report, location }) {
              var _a;
              if (schema2.type !== "object")
                return;
              const expectedProperties = names[key] || names[(0, utils_1.getMatchingStatusCodeRange)(key)] || names[(0, utils_1.getMatchingStatusCodeRange)(key).toLowerCase()] || [];
              for (const expectedProperty of expectedProperties) {
                if (!((_a = schema2.properties) === null || _a === void 0 ? void 0 : _a[expectedProperty])) {
                  report({
                    message: `Response object must contain a top-level "${expectedProperty}" property.`,
                    location: location.child("properties").key()
                  });
                }
              }
            }
          }
        }
      };
    };
    exports2.ResponseContainsProperty = ResponseContainsProperty;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/index.js
var require_oas22 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.preprocessors = exports2.rules = void 0;
    var spec_1 = require_spec();
    var no_invalid_schema_examples_1 = require_no_invalid_schema_examples();
    var no_invalid_parameter_examples_1 = require_no_invalid_parameter_examples();
    var info_contact_1 = require_info_contact();
    var info_license_1 = require_info_license();
    var info_license_url_1 = require_info_license_url();
    var boolean_parameter_prefixes_1 = require_boolean_parameter_prefixes2();
    var tag_description_1 = require_tag_description();
    var tags_alphabetical_1 = require_tags_alphabetical();
    var paths_kebab_case_1 = require_paths_kebab_case();
    var no_enum_type_mismatch_1 = require_no_enum_type_mismatch();
    var no_path_trailing_slash_1 = require_no_path_trailing_slash();
    var operation_2xx_response_1 = require_operation_2xx_response();
    var operation_4xx_response_1 = require_operation_4xx_response();
    var assertions_1 = require_assertions();
    var operation_operationId_unique_1 = require_operation_operationId_unique();
    var operation_parameters_unique_1 = require_operation_parameters_unique();
    var path_params_defined_1 = require_path_params_defined();
    var operation_tag_defined_1 = require_operation_tag_defined();
    var path_declaration_must_exist_1 = require_path_declaration_must_exist();
    var operation_operationId_url_safe_1 = require_operation_operationId_url_safe();
    var operation_description_1 = require_operation_description();
    var path_not_include_query_1 = require_path_not_include_query();
    var parameter_description_1 = require_parameter_description();
    var operation_singular_tag_1 = require_operation_singular_tag();
    var security_defined_1 = require_security_defined();
    var no_unresolved_refs_1 = require_no_unresolved_refs();
    var path_http_verbs_order_1 = require_path_http_verbs_order();
    var no_identical_paths_1 = require_no_identical_paths();
    var operation_operationId_1 = require_operation_operationId();
    var operation_summary_1 = require_operation_summary();
    var no_ambiguous_paths_1 = require_no_ambiguous_paths();
    var no_http_verbs_in_paths_1 = require_no_http_verbs_in_paths();
    var path_excludes_patterns_1 = require_path_excludes_patterns();
    var request_mime_type_1 = require_request_mime_type2();
    var response_mime_type_1 = require_response_mime_type2();
    var path_segment_plural_1 = require_path_segment_plural();
    var response_contains_header_1 = require_response_contains_header();
    var response_contains_property_1 = require_response_contains_property2();
    var scalar_property_missing_example_1 = require_scalar_property_missing_example();
    var required_string_property_missing_min_length_1 = require_required_string_property_missing_min_length();
    var spec_strict_refs_1 = require_spec_strict_refs();
    exports2.rules = {
      spec: spec_1.Spec,
      "no-invalid-schema-examples": no_invalid_schema_examples_1.NoInvalidSchemaExamples,
      "no-invalid-parameter-examples": no_invalid_parameter_examples_1.NoInvalidParameterExamples,
      "info-contact": info_contact_1.InfoContact,
      "info-license": info_license_1.InfoLicense,
      "info-license-url": info_license_url_1.InfoLicenseUrl,
      "tag-description": tag_description_1.TagDescription,
      "tags-alphabetical": tags_alphabetical_1.TagsAlphabetical,
      "paths-kebab-case": paths_kebab_case_1.PathsKebabCase,
      "no-enum-type-mismatch": no_enum_type_mismatch_1.NoEnumTypeMismatch,
      "boolean-parameter-prefixes": boolean_parameter_prefixes_1.BooleanParameterPrefixes,
      "no-path-trailing-slash": no_path_trailing_slash_1.NoPathTrailingSlash,
      "operation-2xx-response": operation_2xx_response_1.Operation2xxResponse,
      "operation-4xx-response": operation_4xx_response_1.Operation4xxResponse,
      assertions: assertions_1.Assertions,
      "operation-operationId-unique": operation_operationId_unique_1.OperationIdUnique,
      "operation-parameters-unique": operation_parameters_unique_1.OperationParametersUnique,
      "path-parameters-defined": path_params_defined_1.PathParamsDefined,
      "operation-tag-defined": operation_tag_defined_1.OperationTagDefined,
      "path-declaration-must-exist": path_declaration_must_exist_1.PathDeclarationMustExist,
      "operation-operationId-url-safe": operation_operationId_url_safe_1.OperationIdUrlSafe,
      "operation-operationId": operation_operationId_1.OperationOperationId,
      "operation-summary": operation_summary_1.OperationSummary,
      "operation-description": operation_description_1.OperationDescription,
      "path-not-include-query": path_not_include_query_1.PathNotIncludeQuery,
      "path-params-defined": path_params_defined_1.PathParamsDefined,
      "parameter-description": parameter_description_1.ParameterDescription,
      "operation-singular-tag": operation_singular_tag_1.OperationSingularTag,
      "security-defined": security_defined_1.SecurityDefined,
      "no-unresolved-refs": no_unresolved_refs_1.NoUnresolvedRefs,
      "no-identical-paths": no_identical_paths_1.NoIdenticalPaths,
      "no-ambiguous-paths": no_ambiguous_paths_1.NoAmbiguousPaths,
      "path-http-verbs-order": path_http_verbs_order_1.PathHttpVerbsOrder,
      "no-http-verbs-in-paths": no_http_verbs_in_paths_1.NoHttpVerbsInPaths,
      "path-excludes-patterns": path_excludes_patterns_1.PathExcludesPatterns,
      "request-mime-type": request_mime_type_1.RequestMimeType,
      "response-mime-type": response_mime_type_1.ResponseMimeType,
      "path-segment-plural": path_segment_plural_1.PathSegmentPlural,
      "response-contains-header": response_contains_header_1.ResponseContainsHeader,
      "response-contains-property": response_contains_property_1.ResponseContainsProperty,
      "scalar-property-missing-example": scalar_property_missing_example_1.ScalarPropertyMissingExample,
      "required-string-property-missing-min-length": required_string_property_missing_min_length_1.RequiredStringPropertyMissingMinLength,
      "spec-strict-refs": spec_strict_refs_1.SpecStrictRefs
    };
    exports2.preprocessors = {};
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/async2/channels-kebab-case.js
var require_channels_kebab_case = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/async2/channels-kebab-case.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ChannelsKebabCase = void 0;
    var ChannelsKebabCase = () => {
      return {
        Channel(_channel, { report, key }) {
          const segments = key.split(/[/.:]/).filter((s) => s !== "");
          if (!segments.every((segment) => /^{.+}$/.test(segment) || /^[a-z0-9-.]+$/.test(segment))) {
            report({
              message: `\`${key}\` does not use kebab-case.`,
              location: { reportOnKey: true }
            });
          }
        }
      };
    };
    exports2.ChannelsKebabCase = ChannelsKebabCase;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/async2/no-channel-trailing-slash.js
var require_no_channel_trailing_slash = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/async2/no-channel-trailing-slash.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoChannelTrailingSlash = void 0;
    var NoChannelTrailingSlash = () => {
      return {
        Channel(_channel, { report, key, location }) {
          if (key.endsWith("/") && key !== "/") {
            report({
              message: `\`${key}\` should not have a trailing slash.`,
              location: location.key()
            });
          }
        }
      };
    };
    exports2.NoChannelTrailingSlash = NoChannelTrailingSlash;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/async2/index.js
var require_async2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/async2/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.preprocessors = exports2.rules = void 0;
    var assertions_1 = require_assertions();
    var spec_1 = require_spec();
    var info_contact_1 = require_info_contact();
    var operation_operationId_1 = require_operation_operationId();
    var tag_description_1 = require_tag_description();
    var tags_alphabetical_1 = require_tags_alphabetical();
    var channels_kebab_case_1 = require_channels_kebab_case();
    var no_channel_trailing_slash_1 = require_no_channel_trailing_slash();
    exports2.rules = {
      spec: spec_1.Spec,
      assertions: assertions_1.Assertions,
      "info-contact": info_contact_1.InfoContact,
      "operation-operationId": operation_operationId_1.OperationOperationId,
      "channels-kebab-case": channels_kebab_case_1.ChannelsKebabCase,
      "no-channel-trailing-slash": no_channel_trailing_slash_1.NoChannelTrailingSlash,
      "tag-description": tag_description_1.TagDescription,
      "tags-alphabetical": tags_alphabetical_1.TagsAlphabetical
    };
    exports2.preprocessors = {};
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/package.json
var require_package3 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/package.json"(exports2, module2) {
    module2.exports = {
      name: "@redocly/openapi-core",
      version: "1.4.1",
      description: "",
      main: "lib/index.js",
      engines: {
        node: ">=14.19.0",
        npm: ">=7.0.0"
      },
      engineStrict: true,
      license: "MIT",
      repository: {
        type: "git",
        url: "https://github.com/Redocly/redocly-cli.git"
      },
      browser: {
        fs: false,
        path: "path-browserify",
        os: false,
        "node-fetch": false,
        colorette: false
      },
      homepage: "https://github.com/Redocly/redocly-cli",
      keywords: [
        "linter",
        "OpenAPI",
        "Swagger",
        "OpenAPI linter",
        "Swagger linter",
        "AsyncAPI linter",
        "oas"
      ],
      contributors: [
        "Roman Hotsiy <roman@redoc.ly> (https://redoc.ly/)"
      ],
      dependencies: {
        "@redocly/ajv": "^8.11.0",
        "@types/node": "^14.11.8",
        colorette: "^1.2.0",
        "js-levenshtein": "^1.1.6",
        "js-yaml": "^4.1.0",
        "lodash.isequal": "^4.5.0",
        minimatch: "^5.0.1",
        "node-fetch": "^2.6.1",
        pluralize: "^8.0.0",
        "yaml-ast-parser": "0.0.43"
      },
      devDependencies: {
        "@types/js-levenshtein": "^1.1.0",
        "@types/js-yaml": "^4.0.3",
        "@types/lodash.isequal": "^4.5.5",
        "@types/minimatch": "^3.0.5",
        "@types/node-fetch": "^2.5.7",
        "@types/pluralize": "^0.0.29",
        typescript: "^5.2.2"
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/redocly/registry-api.js
var require_registry_api = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/redocly/registry-api.js"(exports2) {
    "use strict";
    var __awaiter = exports2 && exports2.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RegistryApi = void 0;
    var node_fetch_1 = (init_lib2(), __toCommonJS(lib_exports2));
    var config_1 = require_config();
    var utils_1 = require_utils4();
    var version = require_package3().version;
    var RegistryApi = class {
      constructor(accessTokens, region) {
        this.accessTokens = accessTokens;
        this.region = region;
      }
      get accessToken() {
        return (0, utils_1.isNotEmptyObject)(this.accessTokens) && this.accessTokens[this.region];
      }
      getBaseUrl(region = config_1.DEFAULT_REGION) {
        return `https://api.${config_1.DOMAINS[region]}/registry`;
      }
      setAccessTokens(accessTokens) {
        this.accessTokens = accessTokens;
        return this;
      }
      request(path5 = "", options = {}, region) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
          const currentCommand = typeof process !== "undefined" ? ((_a = process.env) === null || _a === void 0 ? void 0 : _a.REDOCLY_CLI_COMMAND) || "" : "";
          const redoclyEnv = typeof process !== "undefined" ? ((_b = process.env) === null || _b === void 0 ? void 0 : _b.REDOCLY_ENVIRONMENT) || "" : "";
          const headers = Object.assign({}, options.headers || {}, {
            "x-redocly-cli-version": version,
            "user-agent": `redocly-cli / ${version} ${currentCommand} ${redoclyEnv}`
          });
          if (!headers.hasOwnProperty("authorization")) {
            throw new Error("Unauthorized");
          }
          const response = yield (0, node_fetch_1.default)(`${this.getBaseUrl(region)}${path5}`, Object.assign({}, options, { headers }));
          if (response.status === 401) {
            throw new Error("Unauthorized");
          }
          if (response.status === 404) {
            const body = yield response.json();
            throw new Error(body.code);
          }
          return response;
        });
      }
      authStatus(accessToken, region, verbose = false) {
        return __awaiter(this, void 0, void 0, function* () {
          try {
            const response = yield this.request("", { headers: { authorization: accessToken } }, region);
            return yield response.json();
          } catch (error) {
            if (verbose) {
              console.log(error);
            }
            throw error;
          }
        });
      }
      prepareFileUpload({ organizationId, name, version: version2, filesHash, filename, isUpsert }) {
        return __awaiter(this, void 0, void 0, function* () {
          const response = yield this.request(`/${organizationId}/${name}/${version2}/prepare-file-upload`, {
            method: "POST",
            headers: {
              "content-type": "application/json",
              authorization: this.accessToken
            },
            body: JSON.stringify({
              filesHash,
              filename,
              isUpsert
            })
          }, this.region);
          if (response.ok) {
            return response.json();
          }
          throw new Error("Could not prepare file upload");
        });
      }
      pushApi({ organizationId, name, version: version2, rootFilePath, filePaths, branch, isUpsert, isPublic, batchId, batchSize }) {
        return __awaiter(this, void 0, void 0, function* () {
          const response = yield this.request(`/${organizationId}/${name}/${version2}`, {
            method: "PUT",
            headers: {
              "content-type": "application/json",
              authorization: this.accessToken
            },
            body: JSON.stringify({
              rootFilePath,
              filePaths,
              branch,
              isUpsert,
              isPublic,
              batchId,
              batchSize
            })
          }, this.region);
          if (response.ok) {
            return;
          }
          throw new Error("Could not push api");
        });
      }
    };
    exports2.RegistryApi = RegistryApi;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/redocly/index.js
var require_redocly = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/redocly/index.js"(exports2) {
    "use strict";
    var __awaiter = exports2 && exports2.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isRedoclyRegistryURL = exports2.RedoclyClient = void 0;
    var fs_1 = require("fs");
    var path_1 = require("path");
    var os_1 = require("os");
    var registry_api_1 = require_registry_api();
    var config_1 = require_config();
    var env_1 = require_env();
    var utils_1 = require_utils4();
    var logger_1 = require_logger();
    var TOKEN_FILENAME = ".redocly-config.json";
    var RedoclyClient = class {
      constructor(region) {
        this.accessTokens = {};
        this.region = this.loadRegion(region);
        this.loadTokens();
        this.domain = region ? config_1.DOMAINS[region] : env_1.env.REDOCLY_DOMAIN || config_1.DOMAINS[config_1.DEFAULT_REGION];
        env_1.env.REDOCLY_DOMAIN = this.domain;
        this.registryApi = new registry_api_1.RegistryApi(this.accessTokens, this.region);
      }
      loadRegion(region) {
        if (region && !config_1.DOMAINS[region]) {
          throw new Error(`Invalid argument: region in config file.
Given: ${logger_1.colorize.green(region)}, choices: "us", "eu".`);
        }
        if (env_1.env.REDOCLY_DOMAIN) {
          return config_1.AVAILABLE_REGIONS.find((region2) => config_1.DOMAINS[region2] === env_1.env.REDOCLY_DOMAIN) || config_1.DEFAULT_REGION;
        }
        return region || config_1.DEFAULT_REGION;
      }
      getRegion() {
        return this.region;
      }
      hasTokens() {
        return (0, utils_1.isNotEmptyObject)(this.accessTokens);
      }
      // <backward compatibility: old versions of portal>
      hasToken() {
        return !!this.accessTokens[this.region];
      }
      getAuthorizationHeader() {
        return __awaiter(this, void 0, void 0, function* () {
          return this.accessTokens[this.region];
        });
      }
      // </backward compatibility: portal>
      setAccessTokens(accessTokens) {
        this.accessTokens = accessTokens;
      }
      loadTokens() {
        const credentialsPath = (0, path_1.resolve)((0, os_1.homedir)(), TOKEN_FILENAME);
        const credentials = this.readCredentialsFile(credentialsPath);
        if ((0, utils_1.isNotEmptyObject)(credentials)) {
          this.setAccessTokens(Object.assign(Object.assign({}, credentials), credentials.token && !credentials[this.region] && {
            [this.region]: credentials.token
          }));
        }
        if (env_1.env.REDOCLY_AUTHORIZATION) {
          this.setAccessTokens(Object.assign(Object.assign({}, this.accessTokens), { [this.region]: env_1.env.REDOCLY_AUTHORIZATION }));
        }
      }
      getAllTokens() {
        return Object.entries(this.accessTokens).filter(([region]) => config_1.AVAILABLE_REGIONS.includes(region)).map(([region, token]) => ({ region, token }));
      }
      getValidTokens() {
        return __awaiter(this, void 0, void 0, function* () {
          const allTokens = this.getAllTokens();
          const verifiedTokens = yield Promise.allSettled(allTokens.map(({ token, region }) => this.verifyToken(token, region)));
          return allTokens.filter((_, index) => verifiedTokens[index].status === "fulfilled").map(({ token, region }) => ({ token, region, valid: true }));
        });
      }
      getTokens() {
        return __awaiter(this, void 0, void 0, function* () {
          return this.hasTokens() ? yield this.getValidTokens() : [];
        });
      }
      isAuthorizedWithRedoclyByRegion() {
        return __awaiter(this, void 0, void 0, function* () {
          if (!this.hasTokens()) {
            return false;
          }
          const accessToken = this.accessTokens[this.region];
          if (!accessToken) {
            return false;
          }
          try {
            yield this.verifyToken(accessToken, this.region);
            return true;
          } catch (err) {
            return false;
          }
        });
      }
      isAuthorizedWithRedocly() {
        return __awaiter(this, void 0, void 0, function* () {
          return this.hasTokens() && (0, utils_1.isNotEmptyObject)(yield this.getValidTokens());
        });
      }
      readCredentialsFile(credentialsPath) {
        return (0, fs_1.existsSync)(credentialsPath) ? JSON.parse((0, fs_1.readFileSync)(credentialsPath, "utf-8")) : {};
      }
      verifyToken(accessToken, region, verbose = false) {
        return __awaiter(this, void 0, void 0, function* () {
          return this.registryApi.authStatus(accessToken, region, verbose);
        });
      }
      login(accessToken, verbose = false) {
        return __awaiter(this, void 0, void 0, function* () {
          const credentialsPath = (0, path_1.resolve)((0, os_1.homedir)(), TOKEN_FILENAME);
          try {
            yield this.verifyToken(accessToken, this.region, verbose);
          } catch (err) {
            throw new Error("Authorization failed. Please check if you entered a valid API key.");
          }
          const credentials = Object.assign(Object.assign({}, this.readCredentialsFile(credentialsPath)), { [this.region]: accessToken, token: accessToken });
          this.accessTokens = credentials;
          this.registryApi.setAccessTokens(credentials);
          (0, fs_1.writeFileSync)(credentialsPath, JSON.stringify(credentials, null, 2));
        });
      }
      logout() {
        const credentialsPath = (0, path_1.resolve)((0, os_1.homedir)(), TOKEN_FILENAME);
        if ((0, fs_1.existsSync)(credentialsPath)) {
          (0, fs_1.unlinkSync)(credentialsPath);
        }
      }
    };
    exports2.RedoclyClient = RedoclyClient;
    function isRedoclyRegistryURL(link) {
      const domain = env_1.env.REDOCLY_DOMAIN || config_1.DOMAINS[config_1.DEFAULT_REGION];
      const legacyDomain = domain === "redocly.com" ? "redoc.ly" : domain;
      if (!link.startsWith(`https://api.${domain}/registry/`) && !link.startsWith(`https://api.${legacyDomain}/registry/`)) {
        return false;
      }
      return true;
    }
    exports2.isRedoclyRegistryURL = isRedoclyRegistryURL;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/registry-dependencies.js
var require_registry_dependencies = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/registry-dependencies.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RegistryDependencies = void 0;
    var redocly_1 = require_redocly();
    var RegistryDependencies = () => {
      const registryDependencies = /* @__PURE__ */ new Set();
      return {
        Root: {
          leave(_, ctx) {
            const data = ctx.getVisitorData();
            data.links = Array.from(registryDependencies);
          }
        },
        ref(node) {
          if (node.$ref) {
            const link = node.$ref.split("#/")[0];
            if ((0, redocly_1.isRedoclyRegistryURL)(link)) {
              registryDependencies.add(link);
            }
          }
        }
      };
    };
    exports2.RegistryDependencies = RegistryDependencies;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/operation-description-override.js
var require_operation_description_override = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/operation-description-override.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationDescriptionOverride = void 0;
    var utils_1 = require_utils4();
    var OperationDescriptionOverride = ({ operationIds }) => {
      return {
        Operation: {
          leave(operation, { report, location }) {
            if (!operation.operationId)
              return;
            if (!operationIds)
              throw new Error(`Parameter "operationIds" is not provided for "operation-description-override" rule`);
            const operationId = operation.operationId;
            if (operationIds[operationId]) {
              try {
                operation.description = (0, utils_1.readFileAsStringSync)(operationIds[operationId]);
              } catch (e) {
                report({
                  message: `Failed to read markdown override file for operation "${operationId}".
${e.message}`,
                  location: location.child("operationId").key()
                });
              }
            }
          }
        }
      };
    };
    exports2.OperationDescriptionOverride = OperationDescriptionOverride;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/tag-description-override.js
var require_tag_description_override = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/tag-description-override.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.TagDescriptionOverride = void 0;
    var utils_1 = require_utils4();
    var TagDescriptionOverride = ({ tagNames }) => {
      return {
        Tag: {
          leave(tag, { report }) {
            if (!tagNames)
              throw new Error(`Parameter "tagNames" is not provided for "tag-description-override" rule`);
            if (tagNames[tag.name]) {
              try {
                tag.description = (0, utils_1.readFileAsStringSync)(tagNames[tag.name]);
              } catch (e) {
                report({
                  message: `Failed to read markdown override file for tag "${tag.name}".
${e.message}`
                });
              }
            }
          }
        }
      };
    };
    exports2.TagDescriptionOverride = TagDescriptionOverride;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/info-description-override.js
var require_info_description_override = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/info-description-override.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.InfoDescriptionOverride = void 0;
    var utils_1 = require_utils4();
    var InfoDescriptionOverride = ({ filePath }) => {
      return {
        Info: {
          leave(info, { report, location }) {
            if (!filePath)
              throw new Error(`Parameter "filePath" is not provided for "info-description-override" rule`);
            try {
              info.description = (0, utils_1.readFileAsStringSync)(filePath);
            } catch (e) {
              report({
                message: `Failed to read markdown override file for "info.description".
${e.message}`,
                location: location.child("description")
              });
            }
          }
        }
      };
    };
    exports2.InfoDescriptionOverride = InfoDescriptionOverride;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/info-override.js
var require_info_override = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/info-override.js"(exports2) {
    "use strict";
    var __rest = exports2 && exports2.__rest || function(s, e) {
      var t = {};
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
      if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
          if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
            t[p[i]] = s[p[i]];
        }
      return t;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.InfoOverride = void 0;
    var InfoOverride = (newInfo) => {
      return {
        Info: {
          leave(info) {
            if (typeof newInfo !== "object" || Array.isArray(newInfo) || newInfo === null) {
              throw new Error(`"info-override" decorator should be called with an object`);
            }
            const { severity: _ } = newInfo, rest = __rest(newInfo, ["severity"]);
            Object.assign(info, rest);
          }
        }
      };
    };
    exports2.InfoOverride = InfoOverride;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/remove-x-internal.js
var require_remove_x_internal = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/remove-x-internal.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RemoveXInternal = void 0;
    var utils_1 = require_utils4();
    var ref_utils_1 = require_ref_utils();
    var DEFAULT_INTERNAL_PROPERTY_NAME = "x-internal";
    var RemoveXInternal = ({ internalFlagProperty }) => {
      const hiddenTag = internalFlagProperty || DEFAULT_INTERNAL_PROPERTY_NAME;
      function removeInternal(node, ctx) {
        var _a, _b, _c, _d;
        const { parent, key } = ctx;
        let didDelete = false;
        if (Array.isArray(node)) {
          for (let i = 0; i < node.length; i++) {
            if ((0, ref_utils_1.isRef)(node[i])) {
              const resolved = ctx.resolve(node[i]);
              if ((_a = resolved.node) === null || _a === void 0 ? void 0 : _a[hiddenTag]) {
                node.splice(i, 1);
                didDelete = true;
                i--;
              }
            }
            if ((_b = node[i]) === null || _b === void 0 ? void 0 : _b[hiddenTag]) {
              node.splice(i, 1);
              didDelete = true;
              i--;
            }
          }
        } else if ((0, utils_1.isPlainObject)(node)) {
          for (const key2 of Object.keys(node)) {
            node = node;
            if ((0, ref_utils_1.isRef)(node[key2])) {
              const resolved = ctx.resolve(node[key2]);
              if ((_c = resolved.node) === null || _c === void 0 ? void 0 : _c[hiddenTag]) {
                delete node[key2];
                didDelete = true;
              }
            }
            if ((_d = node[key2]) === null || _d === void 0 ? void 0 : _d[hiddenTag]) {
              delete node[key2];
              didDelete = true;
            }
          }
        }
        if (didDelete && ((0, utils_1.isEmptyObject)(node) || (0, utils_1.isEmptyArray)(node))) {
          delete parent[key];
        }
      }
      return {
        any: {
          enter: (node, ctx) => {
            removeInternal(node, ctx);
          }
        }
      };
    };
    exports2.RemoveXInternal = RemoveXInternal;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/filters/filter-helper.js
var require_filter_helper = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/filters/filter-helper.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.checkIfMatchByStrategy = exports2.filter = void 0;
    var ref_utils_1 = require_ref_utils();
    var utils_1 = require_utils4();
    function filter(node, ctx, criteria) {
      const { parent, key } = ctx;
      let didDelete = false;
      if (Array.isArray(node)) {
        for (let i = 0; i < node.length; i++) {
          if ((0, ref_utils_1.isRef)(node[i])) {
            const resolved = ctx.resolve(node[i]);
            if (criteria(resolved.node)) {
              node.splice(i, 1);
              didDelete = true;
              i--;
            }
          }
          if (criteria(node[i])) {
            node.splice(i, 1);
            didDelete = true;
            i--;
          }
        }
      } else if ((0, utils_1.isPlainObject)(node)) {
        for (const key2 of Object.keys(node)) {
          node = node;
          if ((0, ref_utils_1.isRef)(node[key2])) {
            const resolved = ctx.resolve(node[key2]);
            if (criteria(resolved.node)) {
              delete node[key2];
              didDelete = true;
            }
          }
          if (criteria(node[key2])) {
            delete node[key2];
            didDelete = true;
          }
        }
      }
      if (didDelete && ((0, utils_1.isEmptyObject)(node) || (0, utils_1.isEmptyArray)(node))) {
        delete parent[key];
      }
    }
    exports2.filter = filter;
    function checkIfMatchByStrategy(nodeValue, decoratorValue, strategy) {
      if (nodeValue === void 0 || decoratorValue === void 0) {
        return false;
      }
      if (!Array.isArray(decoratorValue) && !Array.isArray(nodeValue)) {
        return nodeValue === decoratorValue;
      }
      decoratorValue = toArrayIfNeeded(decoratorValue);
      nodeValue = toArrayIfNeeded(nodeValue);
      if (strategy === "any") {
        return decoratorValue.some((item) => nodeValue.includes(item));
      }
      if (strategy === "all") {
        return decoratorValue.every((item) => nodeValue.includes(item));
      }
      return false;
    }
    exports2.checkIfMatchByStrategy = checkIfMatchByStrategy;
    function toArrayIfNeeded(value) {
      return Array.isArray(value) ? value : [value];
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/filters/filter-in.js
var require_filter_in = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/filters/filter-in.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.FilterIn = void 0;
    var filter_helper_1 = require_filter_helper();
    var DEFAULT_STRATEGY = "any";
    var FilterIn = ({ property: property4, value, matchStrategy }) => {
      const strategy = matchStrategy || DEFAULT_STRATEGY;
      const filterInCriteria = (item) => (item === null || item === void 0 ? void 0 : item[property4]) && !(0, filter_helper_1.checkIfMatchByStrategy)(item === null || item === void 0 ? void 0 : item[property4], value, strategy);
      return {
        any: {
          enter: (node, ctx) => {
            (0, filter_helper_1.filter)(node, ctx, filterInCriteria);
          }
        }
      };
    };
    exports2.FilterIn = FilterIn;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/filters/filter-out.js
var require_filter_out = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/filters/filter-out.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.FilterOut = void 0;
    var filter_helper_1 = require_filter_helper();
    var DEFAULT_STRATEGY = "any";
    var FilterOut = ({ property: property4, value, matchStrategy }) => {
      const strategy = matchStrategy || DEFAULT_STRATEGY;
      const filterOutCriteria = (item) => (0, filter_helper_1.checkIfMatchByStrategy)(item === null || item === void 0 ? void 0 : item[property4], value, strategy);
      return {
        any: {
          enter: (node, ctx) => {
            (0, filter_helper_1.filter)(node, ctx, filterOutCriteria);
          }
        }
      };
    };
    exports2.FilterOut = FilterOut;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/media-type-examples-override.js
var require_media_type_examples_override = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/media-type-examples-override.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.MediaTypeExamplesOverride = void 0;
    var utils_1 = require_utils4();
    var ref_utils_1 = require_ref_utils();
    var MediaTypeExamplesOverride = ({ operationIds }) => {
      return {
        Operation: {
          enter(operation, ctx) {
            const operationId = operation.operationId;
            if (!operationId) {
              return;
            }
            const properties = operationIds[operationId];
            if (!properties) {
              return;
            }
            if (properties.responses && operation.responses) {
              for (const responseCode of Object.keys(properties.responses)) {
                const resolvedResponse = checkAndResolveRef(operation.responses[responseCode], ctx.resolve);
                if (!resolvedResponse) {
                  continue;
                }
                resolvedResponse.content = resolvedResponse.content ? resolvedResponse.content : {};
                Object.keys(properties.responses[responseCode]).forEach((mimeType) => {
                  resolvedResponse.content[mimeType] = Object.assign(Object.assign({}, resolvedResponse.content[mimeType]), { examples: (0, utils_1.yamlAndJsonSyncReader)(properties.responses[responseCode][mimeType]) });
                });
                operation.responses[responseCode] = resolvedResponse;
              }
            }
            if (properties.request && operation.requestBody) {
              const resolvedRequest = checkAndResolveRef(operation.requestBody, ctx.resolve);
              if (!resolvedRequest) {
                return;
              }
              resolvedRequest.content = resolvedRequest.content ? resolvedRequest.content : {};
              Object.keys(properties.request).forEach((mimeType) => {
                resolvedRequest.content[mimeType] = Object.assign(Object.assign({}, resolvedRequest.content[mimeType]), { examples: (0, utils_1.yamlAndJsonSyncReader)(properties.request[mimeType]) });
              });
              operation.requestBody = resolvedRequest;
            }
          }
        }
      };
    };
    exports2.MediaTypeExamplesOverride = MediaTypeExamplesOverride;
    function checkAndResolveRef(node, resolver) {
      if (!(0, ref_utils_1.isRef)(node)) {
        return node;
      }
      const resolved = resolver(node);
      return resolved.error ? void 0 : JSON.parse(JSON.stringify(resolved.node));
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/oas3/index.js
var require_oas33 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/oas3/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decorators = void 0;
    var registry_dependencies_1 = require_registry_dependencies();
    var operation_description_override_1 = require_operation_description_override();
    var tag_description_override_1 = require_tag_description_override();
    var info_description_override_1 = require_info_description_override();
    var info_override_1 = require_info_override();
    var remove_x_internal_1 = require_remove_x_internal();
    var filter_in_1 = require_filter_in();
    var filter_out_1 = require_filter_out();
    var media_type_examples_override_1 = require_media_type_examples_override();
    exports2.decorators = {
      "registry-dependencies": registry_dependencies_1.RegistryDependencies,
      "operation-description-override": operation_description_override_1.OperationDescriptionOverride,
      "tag-description-override": tag_description_override_1.TagDescriptionOverride,
      "info-description-override": info_description_override_1.InfoDescriptionOverride,
      "info-override": info_override_1.InfoOverride,
      "remove-x-internal": remove_x_internal_1.RemoveXInternal,
      "filter-in": filter_in_1.FilterIn,
      "filter-out": filter_out_1.FilterOut,
      "media-type-examples-override": media_type_examples_override_1.MediaTypeExamplesOverride
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/oas2/index.js
var require_oas23 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/oas2/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decorators = void 0;
    var registry_dependencies_1 = require_registry_dependencies();
    var operation_description_override_1 = require_operation_description_override();
    var tag_description_override_1 = require_tag_description_override();
    var info_description_override_1 = require_info_description_override();
    var info_override_1 = require_info_override();
    var remove_x_internal_1 = require_remove_x_internal();
    var filter_in_1 = require_filter_in();
    var filter_out_1 = require_filter_out();
    exports2.decorators = {
      "registry-dependencies": registry_dependencies_1.RegistryDependencies,
      "operation-description-override": operation_description_override_1.OperationDescriptionOverride,
      "tag-description-override": tag_description_override_1.TagDescriptionOverride,
      "info-description-override": info_description_override_1.InfoDescriptionOverride,
      "info-override": info_override_1.InfoOverride,
      "remove-x-internal": remove_x_internal_1.RemoveXInternal,
      "filter-in": filter_in_1.FilterIn,
      "filter-out": filter_out_1.FilterOut
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/builtIn.js
var require_builtIn = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/builtIn.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.defaultPlugin = exports2.builtInConfigs = void 0;
    var recommended_1 = require_recommended();
    var recommended_strict_1 = require_recommended_strict();
    var all_1 = require_all();
    var minimal_1 = require_minimal();
    var oas3_1 = require_oas32();
    var oas2_1 = require_oas22();
    var async2_1 = require_async2();
    var oas3_2 = require_oas32();
    var oas2_2 = require_oas22();
    var oas3_3 = require_oas33();
    var oas2_3 = require_oas23();
    exports2.builtInConfigs = {
      recommended: recommended_1.default,
      "recommended-strict": recommended_strict_1.default,
      minimal: minimal_1.default,
      all: all_1.default,
      "redocly-registry": {
        decorators: { "registry-dependencies": "on" }
      }
    };
    exports2.defaultPlugin = {
      id: "",
      rules: {
        oas3: oas3_1.rules,
        oas2: oas2_1.rules,
        async2: async2_1.rules
      },
      preprocessors: {
        oas3: oas3_2.preprocessors,
        oas2: oas2_2.preprocessors,
        async2: {}
      },
      decorators: {
        oas3: oas3_3.decorators,
        oas2: oas2_3.decorators,
        async2: {}
      },
      configs: exports2.builtInConfigs
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/config-resolvers.js
var require_config_resolvers = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/config-resolvers.js"(exports2) {
    "use strict";
    var __awaiter = exports2 && exports2.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    var __rest = exports2 && exports2.__rest || function(s, e) {
      var t = {};
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
      if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
          if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
            t[p[i]] = s[p[i]];
        }
      return t;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.resolvePreset = exports2.resolveStyleguideConfig = exports2.resolveApis = exports2.resolvePlugins = exports2.resolveConfig = void 0;
    var path5 = require("path");
    var ref_utils_1 = require_ref_utils();
    var utils_1 = require_utils4();
    var resolve_1 = require_resolve2();
    var builtIn_1 = require_builtIn();
    var utils_2 = require_utils5();
    var env_1 = require_env();
    var utils_3 = require_utils4();
    var config_1 = require_config();
    var logger_1 = require_logger();
    var asserts_1 = require_asserts();
    function resolveConfig(rawConfig, configPath) {
      var _a, _b;
      return __awaiter(this, void 0, void 0, function* () {
        if ((_b = (_a = rawConfig.styleguide) === null || _a === void 0 ? void 0 : _a.extends) === null || _b === void 0 ? void 0 : _b.some(utils_3.isNotString)) {
          throw new Error(`Error configuration format not detected in extends value must contain strings`);
        }
        const resolver = new resolve_1.BaseResolver((0, utils_2.getResolveConfig)(rawConfig.resolve));
        const apis = yield resolveApis({
          rawConfig,
          configPath,
          resolver
        });
        const styleguide = yield resolveStyleguideConfig({
          styleguideConfig: rawConfig.styleguide,
          configPath,
          resolver
        });
        return new config_1.Config(Object.assign(Object.assign({}, rawConfig), {
          apis,
          styleguide
        }), configPath);
      });
    }
    exports2.resolveConfig = resolveConfig;
    function resolvePlugins(plugins, configPath = "") {
      if (!plugins)
        return [];
      const requireFunc = (plugin) => {
        if (env_1.isBrowser && (0, utils_3.isString)(plugin)) {
          logger_1.logger.error(`Cannot load ${plugin}. Plugins aren't supported in browser yet.`);
          return void 0;
        }
        if ((0, utils_3.isString)(plugin)) {
          try {
            const absoltePluginPath = path5.resolve(path5.dirname(configPath), plugin);
            return typeof __webpack_require__ === "function" ? (
              // eslint-disable-next-line @typescript-eslint/ban-ts-comment
              // @ts-ignore
              __non_webpack_require__(absoltePluginPath)
            ) : require(absoltePluginPath);
          } catch (e) {
            if (e instanceof SyntaxError) {
              throw e;
            }
            throw new Error(`Failed to load plugin "${plugin}". Please provide a valid path`);
          }
        }
        return plugin;
      };
      const seenPluginIds = /* @__PURE__ */ new Map();
      return plugins.map((p) => {
        if ((0, utils_3.isString)(p) && (0, ref_utils_1.isAbsoluteUrl)(p)) {
          throw new Error(logger_1.colorize.red(`We don't support remote plugins yet.`));
        }
        const pluginModule = requireFunc(p);
        if (!pluginModule) {
          return;
        }
        const id = pluginModule.id;
        if (typeof id !== "string") {
          throw new Error(logger_1.colorize.red(`Plugin must define \`id\` property in ${logger_1.colorize.blue(p.toString())}.`));
        }
        if (seenPluginIds.has(id)) {
          const pluginPath = seenPluginIds.get(id);
          throw new Error(logger_1.colorize.red(`Plugin "id" must be unique. Plugin ${logger_1.colorize.blue(p.toString())} uses id "${logger_1.colorize.blue(id)}" already seen in ${logger_1.colorize.blue(pluginPath)}`));
        }
        seenPluginIds.set(id, p.toString());
        const plugin = Object.assign(Object.assign({ id }, pluginModule.configs ? { configs: pluginModule.configs } : {}), pluginModule.typeExtension ? { typeExtension: pluginModule.typeExtension } : {});
        if (pluginModule.rules) {
          if (!pluginModule.rules.oas3 && !pluginModule.rules.oas2 && !pluginModule.rules.async2) {
            throw new Error(`Plugin rules must have \`oas3\`, \`oas2\` or \`async2\` rules "${p}.`);
          }
          plugin.rules = {};
          if (pluginModule.rules.oas3) {
            plugin.rules.oas3 = (0, utils_2.prefixRules)(pluginModule.rules.oas3, id);
          }
          if (pluginModule.rules.oas2) {
            plugin.rules.oas2 = (0, utils_2.prefixRules)(pluginModule.rules.oas2, id);
          }
          if (pluginModule.rules.async2) {
            plugin.rules.async2 = (0, utils_2.prefixRules)(pluginModule.rules.async2, id);
          }
        }
        if (pluginModule.preprocessors) {
          if (!pluginModule.preprocessors.oas3 && !pluginModule.preprocessors.oas2 && !pluginModule.preprocessors.async2) {
            throw new Error(`Plugin \`preprocessors\` must have \`oas3\`, \`oas2\` or \`async2\` preprocessors "${p}.`);
          }
          plugin.preprocessors = {};
          if (pluginModule.preprocessors.oas3) {
            plugin.preprocessors.oas3 = (0, utils_2.prefixRules)(pluginModule.preprocessors.oas3, id);
          }
          if (pluginModule.preprocessors.oas2) {
            plugin.preprocessors.oas2 = (0, utils_2.prefixRules)(pluginModule.preprocessors.oas2, id);
          }
          if (pluginModule.preprocessors.async2) {
            plugin.preprocessors.async2 = (0, utils_2.prefixRules)(pluginModule.preprocessors.async2, id);
          }
        }
        if (pluginModule.decorators) {
          if (!pluginModule.decorators.oas3 && !pluginModule.decorators.oas2 && !pluginModule.decorators.async2) {
            throw new Error(`Plugin \`decorators\` must have \`oas3\`, \`oas2\` or \`async2\` decorators "${p}.`);
          }
          plugin.decorators = {};
          if (pluginModule.decorators.oas3) {
            plugin.decorators.oas3 = (0, utils_2.prefixRules)(pluginModule.decorators.oas3, id);
          }
          if (pluginModule.decorators.oas2) {
            plugin.decorators.oas2 = (0, utils_2.prefixRules)(pluginModule.decorators.oas2, id);
          }
          if (pluginModule.decorators.async2) {
            plugin.decorators.async2 = (0, utils_2.prefixRules)(pluginModule.decorators.async2, id);
          }
        }
        if (pluginModule.assertions) {
          plugin.assertions = pluginModule.assertions;
        }
        return plugin;
      }).filter(utils_3.isDefined);
    }
    exports2.resolvePlugins = resolvePlugins;
    function resolveApis({ rawConfig, configPath = "", resolver }) {
      var _a, _b;
      return __awaiter(this, void 0, void 0, function* () {
        const { apis = {}, styleguide: styleguideConfig = {} } = rawConfig;
        const resolvedApis = {};
        for (const [apiName, apiContent] of Object.entries(apis || {})) {
          if ((_b = (_a = apiContent.styleguide) === null || _a === void 0 ? void 0 : _a.extends) === null || _b === void 0 ? void 0 : _b.some(utils_3.isNotString)) {
            throw new Error(`Error configuration format not detected in extends value must contain strings`);
          }
          const rawStyleguideConfig = getMergedRawStyleguideConfig(styleguideConfig, apiContent.styleguide);
          const resolvedApiConfig = yield resolveStyleguideConfig({
            styleguideConfig: rawStyleguideConfig,
            configPath,
            resolver
          });
          resolvedApis[apiName] = Object.assign(Object.assign({}, apiContent), { styleguide: resolvedApiConfig });
        }
        return resolvedApis;
      });
    }
    exports2.resolveApis = resolveApis;
    function resolveAndMergeNestedStyleguideConfig({ styleguideConfig, configPath = "", resolver = new resolve_1.BaseResolver() }, parentConfigPaths = [], extendPaths = []) {
      var _a, _b, _c;
      return __awaiter(this, void 0, void 0, function* () {
        if (parentConfigPaths.includes(configPath)) {
          throw new Error(`Circular dependency in config file: "${configPath}"`);
        }
        const plugins = (0, utils_2.getUniquePlugins)(resolvePlugins([...(styleguideConfig === null || styleguideConfig === void 0 ? void 0 : styleguideConfig.plugins) || [], builtIn_1.defaultPlugin], configPath));
        const pluginPaths = (_a = styleguideConfig === null || styleguideConfig === void 0 ? void 0 : styleguideConfig.plugins) === null || _a === void 0 ? void 0 : _a.filter(utils_3.isString).map((p) => path5.resolve(path5.dirname(configPath), p));
        const resolvedConfigPath = (0, ref_utils_1.isAbsoluteUrl)(configPath) ? configPath : configPath && path5.resolve(configPath);
        const extendConfigs = yield Promise.all(((_b = styleguideConfig === null || styleguideConfig === void 0 ? void 0 : styleguideConfig.extends) === null || _b === void 0 ? void 0 : _b.map((presetItem) => __awaiter(this, void 0, void 0, function* () {
          if (!(0, ref_utils_1.isAbsoluteUrl)(presetItem) && !path5.extname(presetItem)) {
            return resolvePreset(presetItem, plugins);
          }
          const pathItem = (0, ref_utils_1.isAbsoluteUrl)(presetItem) ? presetItem : (0, ref_utils_1.isAbsoluteUrl)(configPath) ? new URL(presetItem, configPath).href : path5.resolve(path5.dirname(configPath), presetItem);
          const extendedStyleguideConfig = yield loadExtendStyleguideConfig(pathItem, resolver);
          return yield resolveAndMergeNestedStyleguideConfig({
            styleguideConfig: extendedStyleguideConfig,
            configPath: pathItem,
            resolver
          }, [...parentConfigPaths, resolvedConfigPath], extendPaths);
        }))) || []);
        const _d = (0, utils_2.mergeExtends)([
          ...extendConfigs,
          Object.assign(Object.assign({}, styleguideConfig), { plugins, extends: void 0, extendPaths: [...parentConfigPaths, resolvedConfigPath], pluginPaths })
        ]), { plugins: mergedPlugins = [] } = _d, styleguide = __rest(_d, ["plugins"]);
        return Object.assign(Object.assign({}, styleguide), { extendPaths: (_c = styleguide.extendPaths) === null || _c === void 0 ? void 0 : _c.filter((path6) => path6 && !(0, ref_utils_1.isAbsoluteUrl)(path6)), plugins: (0, utils_2.getUniquePlugins)(mergedPlugins), recommendedFallback: styleguideConfig === null || styleguideConfig === void 0 ? void 0 : styleguideConfig.recommendedFallback, doNotResolveExamples: styleguideConfig === null || styleguideConfig === void 0 ? void 0 : styleguideConfig.doNotResolveExamples });
      });
    }
    function resolveStyleguideConfig(opts, parentConfigPaths = [], extendPaths = []) {
      return __awaiter(this, void 0, void 0, function* () {
        const resolvedStyleguideConfig = yield resolveAndMergeNestedStyleguideConfig(opts, parentConfigPaths, extendPaths);
        return Object.assign(Object.assign({}, resolvedStyleguideConfig), { rules: resolvedStyleguideConfig.rules && groupStyleguideAssertionRules(resolvedStyleguideConfig) });
      });
    }
    exports2.resolveStyleguideConfig = resolveStyleguideConfig;
    function resolvePreset(presetName, plugins) {
      var _a;
      const { pluginId, configName } = (0, utils_2.parsePresetName)(presetName);
      const plugin = plugins.find((p) => p.id === pluginId);
      if (!plugin) {
        throw new Error(`Invalid config ${logger_1.colorize.red(presetName)}: plugin ${pluginId} is not included.`);
      }
      const preset = (_a = plugin.configs) === null || _a === void 0 ? void 0 : _a[configName];
      if (!preset) {
        throw new Error(pluginId ? `Invalid config ${logger_1.colorize.red(presetName)}: plugin ${pluginId} doesn't export config with name ${configName}.` : `Invalid config ${logger_1.colorize.red(presetName)}: there is no such built-in config.`);
      }
      return preset;
    }
    exports2.resolvePreset = resolvePreset;
    function loadExtendStyleguideConfig(filePath, resolver) {
      return __awaiter(this, void 0, void 0, function* () {
        try {
          const fileSource = yield resolver.loadExternalRef(filePath);
          const rawConfig = (0, utils_2.transformConfig)((0, utils_3.parseYaml)(fileSource.body));
          if (!rawConfig.styleguide) {
            throw new Error(`Styleguide configuration format not detected: "${filePath}"`);
          }
          return rawConfig.styleguide;
        } catch (error) {
          throw new Error(`Failed to load "${filePath}": ${error.message}`);
        }
      });
    }
    function getMergedRawStyleguideConfig(rootStyleguideConfig, apiStyleguideConfig) {
      const resultLint = Object.assign(Object.assign(Object.assign({}, rootStyleguideConfig), (0, utils_1.pickDefined)(apiStyleguideConfig)), { rules: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.rules), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.rules), oas2Rules: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas2Rules), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas2Rules), oas3_0Rules: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas3_0Rules), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas3_0Rules), oas3_1Rules: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas3_1Rules), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas3_1Rules), preprocessors: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.preprocessors), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.preprocessors), oas2Preprocessors: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas2Preprocessors), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas2Preprocessors), oas3_0Preprocessors: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas3_0Preprocessors), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas3_0Preprocessors), oas3_1Preprocessors: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas3_1Preprocessors), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas3_1Preprocessors), decorators: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.decorators), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.decorators), oas2Decorators: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas2Decorators), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas2Decorators), oas3_0Decorators: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas3_0Decorators), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas3_0Decorators), oas3_1Decorators: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas3_1Decorators), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas3_1Decorators), recommendedFallback: (apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.extends) ? false : rootStyleguideConfig.recommendedFallback });
      return resultLint;
    }
    function groupStyleguideAssertionRules({ rules, plugins }) {
      if (!rules) {
        return rules;
      }
      const transformedRules = {};
      const assertions = [];
      for (const [ruleKey, rule] of Object.entries(rules)) {
        if ((ruleKey.startsWith("rule/") || ruleKey.startsWith("assert/")) && typeof rule === "object" && rule !== null) {
          const assertion = rule;
          if (plugins) {
            registerCustomAssertions(plugins, assertion);
            for (const context of assertion.where || []) {
              registerCustomAssertions(plugins, context);
            }
          }
          assertions.push(Object.assign(Object.assign({}, assertion), { assertionId: ruleKey }));
        } else {
          transformedRules[ruleKey] = rule;
        }
      }
      if (assertions.length > 0) {
        transformedRules.assertions = assertions;
      }
      return transformedRules;
    }
    function registerCustomAssertions(plugins, assertion) {
      for (const field of (0, utils_3.keysOf)(assertion.assertions)) {
        const [pluginId, fn] = field.split("/");
        if (!pluginId || !fn)
          continue;
        const plugin = plugins.find((plugin2) => plugin2.id === pluginId);
        if (!plugin) {
          throw Error(logger_1.colorize.red(`Plugin ${logger_1.colorize.blue(pluginId)} isn't found.`));
        }
        if (!plugin.assertions || !plugin.assertions[fn]) {
          throw Error(`Plugin ${logger_1.colorize.red(pluginId)} doesn't export assertions function with name ${logger_1.colorize.red(fn)}.`);
        }
        asserts_1.asserts[field] = (0, asserts_1.buildAssertCustomFunction)(plugin.assertions[fn]);
      }
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/load.js
var require_load = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/load.js"(exports2) {
    "use strict";
    var __awaiter = exports2 && exports2.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.createConfig = exports2.getConfig = exports2.findConfig = exports2.CONFIG_FILE_NAMES = exports2.loadConfig = void 0;
    var fs = require("fs");
    var path5 = require("path");
    var redocly_1 = require_redocly();
    var utils_1 = require_utils4();
    var js_yaml_1 = require_js_yaml2();
    var config_1 = require_config();
    var utils_2 = require_utils5();
    var config_resolvers_1 = require_config_resolvers();
    function addConfigMetadata({ rawConfig, customExtends, configPath, tokens, files, region }) {
      var _a;
      return __awaiter(this, void 0, void 0, function* () {
        if (customExtends !== void 0) {
          rawConfig.styleguide = rawConfig.styleguide || {};
          rawConfig.styleguide.extends = customExtends;
        } else if ((0, utils_1.isEmptyObject)(rawConfig)) {
          rawConfig.styleguide = { extends: ["recommended"], recommendedFallback: true };
        }
        if (tokens === null || tokens === void 0 ? void 0 : tokens.length) {
          if (!rawConfig.resolve)
            rawConfig.resolve = {};
          if (!rawConfig.resolve.http)
            rawConfig.resolve.http = {};
          rawConfig.resolve.http.headers = [...(_a = rawConfig.resolve.http.headers) !== null && _a !== void 0 ? _a : []];
          for (const item of tokens) {
            const domain = config_1.DOMAINS[item.region];
            rawConfig.resolve.http.headers.push(
              {
                matches: `https://api.${domain}/registry/**`,
                name: "Authorization",
                envVariable: void 0,
                value: item.token
              },
              ...item.region === "us" ? [
                {
                  matches: `https://api.redoc.ly/registry/**`,
                  name: "Authorization",
                  envVariable: void 0,
                  value: item.token
                }
              ] : []
            );
          }
        }
        return (0, config_resolvers_1.resolveConfig)(Object.assign(Object.assign({}, rawConfig), { files: files !== null && files !== void 0 ? files : rawConfig.files, region: region !== null && region !== void 0 ? region : rawConfig.region }), configPath);
      });
    }
    function loadConfig(options = {}) {
      return __awaiter(this, void 0, void 0, function* () {
        const { configPath = findConfig(), customExtends, processRawConfig, files, region } = options;
        const rawConfig = yield getConfig(configPath, processRawConfig);
        const redoclyClient = new redocly_1.RedoclyClient();
        const tokens = yield redoclyClient.getTokens();
        return addConfigMetadata({
          rawConfig,
          customExtends,
          configPath,
          tokens,
          files,
          region
        });
      });
    }
    exports2.loadConfig = loadConfig;
    exports2.CONFIG_FILE_NAMES = ["redocly.yaml", "redocly.yml", ".redocly.yaml", ".redocly.yml"];
    function findConfig(dir) {
      if (!fs.hasOwnProperty("existsSync"))
        return;
      const existingConfigFiles = exports2.CONFIG_FILE_NAMES.map((name) => dir ? path5.resolve(dir, name) : name).filter(fs.existsSync);
      if (existingConfigFiles.length > 1) {
        throw new Error(`
      Multiple configuration files are not allowed.
      Found the following files: ${existingConfigFiles.join(", ")}.
      Please use 'redocly.yaml' instead.
    `);
      }
      return existingConfigFiles[0];
    }
    exports2.findConfig = findConfig;
    function getConfig(configPath = findConfig(), processRawConfig) {
      return __awaiter(this, void 0, void 0, function* () {
        if (!configPath || !(0, utils_1.doesYamlFileExist)(configPath))
          return {};
        try {
          const rawConfig = (yield (0, utils_1.loadYaml)(configPath)) || {};
          if (typeof processRawConfig === "function") {
            yield processRawConfig(rawConfig);
          }
          return (0, utils_2.transformConfig)(rawConfig);
        } catch (e) {
          if (e instanceof utils_2.ConfigValidationError) {
            throw e;
          }
          throw new Error(`Error parsing config file at '${configPath}': ${e.message}`);
        }
      });
    }
    exports2.getConfig = getConfig;
    function createConfig(config, options) {
      return __awaiter(this, void 0, void 0, function* () {
        return addConfigMetadata(Object.assign({ rawConfig: (0, utils_2.transformConfig)(typeof config === "string" ? (0, js_yaml_1.parseYaml)(config) : config) }, options));
      });
    }
    exports2.createConfig = createConfig;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/index.js
var require_config2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0) k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m, k);
      if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m[k];
        } };
      }
      Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      if (k2 === void 0) k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports3) {
      for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p)) __createBinding(exports3, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar(require_config(), exports2);
    __exportStar(require_types2(), exports2);
    __exportStar(require_rules(), exports2);
    __exportStar(require_builtIn(), exports2);
    __exportStar(require_load(), exports2);
    __exportStar(require_utils5(), exports2);
    __exportStar(require_config_resolvers(), exports2);
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/portal-config-schema.js
var require_portal_config_schema = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/portal-config-schema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.rootRedoclyConfigSchema = exports2.environmentSchema = exports2.redoclyConfigSchema = exports2.apiConfigSchema = exports2.ssoConfigSchema = void 0;
    var config_1 = require_config2();
    var oidcIssuerMetadataSchema = {
      type: "object",
      properties: {
        end_session_endpoint: { type: "string" },
        token_endpoint: { type: "string" },
        authorization_endpoint: { type: "string" },
        jwks_uri: { type: "string" }
      },
      required: ["token_endpoint", "authorization_endpoint"],
      additionalProperties: true
    };
    var oidcProviderConfigSchema = {
      type: "object",
      properties: {
        type: { type: "string", const: config_1.AuthProviderType.OIDC },
        title: { type: "string" },
        configurationUrl: { type: "string", minLength: 1 },
        configuration: oidcIssuerMetadataSchema,
        clientId: { type: "string", minLength: 1 },
        clientSecret: { type: "string", minLength: 1 },
        teamsClaimName: { type: "string" },
        teamsClaimMap: { type: "object", additionalProperties: { type: "string" } },
        defaultTeams: { type: "array", items: { type: "string" } },
        scopes: { type: "array", items: { type: "string" } },
        tokenExpirationTime: { type: "number" },
        authorizationRequestCustomParams: { type: "object", additionalProperties: { type: "string" } },
        tokenRequestCustomParams: { type: "object", additionalProperties: { type: "string" } },
        audience: { type: "array", items: { type: "string" } }
      },
      required: ["type", "clientId", "clientSecret"],
      oneOf: [{ required: ["configurationUrl"] }, { required: ["configuration"] }],
      additionalProperties: false
    };
    var saml2ProviderConfigSchema = {
      type: "object",
      properties: {
        type: { type: "string", const: config_1.AuthProviderType.SAML2 },
        title: { type: "string" },
        issuerId: { type: "string" },
        entityId: { type: "string" },
        ssoUrl: { type: "string" },
        x509PublicCert: { type: "string" },
        teamsAttributeName: { type: "string", default: config_1.DEFAULT_TEAM_CLAIM_NAME },
        teamsAttributeMap: { type: "object", additionalProperties: { type: "string" } },
        defaultTeams: { type: "array", items: { type: "string" } }
      },
      additionalProperties: false,
      required: ["type", "issuerId", "ssoUrl", "x509PublicCert"]
    };
    var basicAuthProviderConfigSchema = {
      type: "object",
      properties: {
        type: { type: "string", const: config_1.AuthProviderType.BASIC },
        title: { type: "string" },
        credentials: {
          type: "array",
          items: {
            type: "object",
            properties: {
              username: { type: "string" },
              password: { type: "string" },
              passwordHash: { type: "string" },
              teams: { type: "array", items: { type: "string" } }
            },
            required: ["username"],
            additionalProperties: false
          }
        }
      },
      required: ["type", "credentials"],
      additionalProperties: false
    };
    var authProviderConfigSchema = {
      oneOf: [oidcProviderConfigSchema, saml2ProviderConfigSchema, basicAuthProviderConfigSchema],
      discriminator: { propertyName: "type" }
    };
    exports2.ssoConfigSchema = {
      type: "object",
      additionalProperties: authProviderConfigSchema
    };
    var redirectConfigSchema = {
      type: "object",
      properties: {
        to: { type: "string" },
        type: { type: "number", default: 301 }
      },
      required: ["to"],
      additionalProperties: false
    };
    exports2.apiConfigSchema = {
      type: "object",
      properties: {
        root: { type: "string" },
        rbac: { type: "object", additionalProperties: true },
        theme: {
          type: "object",
          properties: {
            openapi: { type: "object", additionalProperties: true }
          },
          additionalProperties: false
        },
        title: { type: "string" },
        metadata: { type: "object", additionalProperties: true }
      },
      additionalProperties: true,
      required: ["root"]
    };
    var metadataConfigSchema = {
      type: "object",
      additionalProperties: true
    };
    var seoConfigSchema = {
      type: "object",
      properties: {
        title: { type: "string" },
        description: { type: "string" },
        siteUrl: { type: "string" },
        image: { type: "string" },
        keywords: { type: "array", items: { type: "string" } },
        lang: { type: "string" },
        jsonLd: { type: "object" },
        meta: {
          type: "array",
          items: {
            type: "object",
            properties: {
              name: { type: "string" },
              content: { type: "string" }
            },
            required: ["name", "content"],
            additionalProperties: false
          }
        }
      },
      additionalProperties: false
    };
    var rbacScopeItemsSchema = { type: "object", additionalProperties: { type: "string" } };
    var rbacConfigSchema = {
      type: "object",
      properties: {
        defaults: rbacScopeItemsSchema
      },
      additionalProperties: rbacScopeItemsSchema
    };
    var graviteeAdapterConfigSchema = {
      type: "object",
      properties: {
        type: { type: "string", const: "GRAVITEE" },
        apiBaseUrl: { type: "string" },
        env: { type: "string" },
        allowApiProductsOutsideCatalog: { type: "boolean", default: false },
        stage: { type: "string", default: "non-production" },
        auth: { type: "object", properties: { static: { type: "string" } } }
      },
      additionalProperties: false,
      required: ["type", "apiBaseUrl"]
    };
    var apigeeAdapterAuthOauth2Schema = {
      type: "object",
      properties: {
        type: { type: "string", const: config_1.ApigeeDevOnboardingIntegrationAuthType.OAUTH2 },
        tokenEndpoint: { type: "string" },
        clientId: { type: "string" },
        clientSecret: { type: "string" }
      },
      additionalProperties: false,
      required: ["type", "tokenEndpoint", "clientId", "clientSecret"]
    };
    var apigeeAdapterAuthServiceAccountSchema = {
      type: "object",
      properties: {
        type: { type: "string", const: config_1.ApigeeDevOnboardingIntegrationAuthType.SERVICE_ACCOUNT },
        serviceAccountEmail: { type: "string" },
        serviceAccountPrivateKey: { type: "string" }
      },
      additionalProperties: false,
      required: ["type", "serviceAccountEmail", "serviceAccountPrivateKey"]
    };
    var apigeeXAdapterConfigSchema = {
      type: "object",
      properties: {
        type: { type: "string", const: "APIGEE_X" },
        apiUrl: { type: "string" },
        stage: { type: "string", default: "non-production" },
        organizationName: { type: "string" },
        ignoreApiProducts: { type: "array", items: { type: "string" } },
        allowApiProductsOutsideCatalog: { type: "boolean", default: false },
        auth: {
          type: "object",
          oneOf: [apigeeAdapterAuthOauth2Schema, apigeeAdapterAuthServiceAccountSchema],
          discriminator: { propertyName: "type" }
        }
      },
      additionalProperties: false,
      required: ["type", "organizationName", "auth"]
    };
    var apigeeEdgeAdapterConfigSchema = Object.assign(Object.assign({}, apigeeXAdapterConfigSchema), { properties: Object.assign(Object.assign({}, apigeeXAdapterConfigSchema.properties), { type: { type: "string", const: "APIGEE_EDGE" } }) });
    var devOnboardingAdapterConfigSchema = {
      type: "object",
      oneOf: [apigeeXAdapterConfigSchema, apigeeEdgeAdapterConfigSchema, graviteeAdapterConfigSchema],
      discriminator: { propertyName: "type" }
    };
    var devOnboardingConfigSchema = {
      type: "object",
      required: ["adapters"],
      additionalProperties: false,
      properties: {
        adapters: {
          type: "array",
          items: devOnboardingAdapterConfigSchema
        }
      }
    };
    var responseHeaderSchema = {
      type: "object",
      properties: {
        name: { type: "string" },
        value: { type: "string" }
      },
      additionalProperties: false,
      required: ["name", "value"]
    };
    exports2.redoclyConfigSchema = {
      type: "object",
      properties: {
        licenseKey: { type: "string" },
        theme: { type: "object", default: {} },
        redirects: { type: "object", additionalProperties: redirectConfigSchema, default: {} },
        seo: seoConfigSchema,
        rbac: rbacConfigSchema,
        responseHeaders: {
          type: "object",
          additionalProperties: {
            type: "array",
            items: responseHeaderSchema
          }
        },
        mockServer: {
          type: "object",
          properties: {
            off: { type: "boolean", default: false },
            position: { type: "string", enum: ["first", "last", "replace", "off"], default: "first" },
            strictExamples: { type: "boolean", default: false },
            errorIfForcedExampleNotFound: { type: "boolean", default: false },
            description: { type: "string" }
          }
        },
        apis: {
          type: "object",
          additionalProperties: exports2.apiConfigSchema
        },
        sso: exports2.ssoConfigSchema,
        developerOnboarding: devOnboardingConfigSchema,
        i18n: {
          type: "object",
          properties: {
            defaultLocale: {
              type: "string"
            },
            locales: {
              type: "array",
              items: {
                type: "object",
                properties: {
                  code: {
                    type: "string"
                  },
                  name: {
                    type: "string"
                  }
                },
                required: ["code"]
              }
            }
          },
          additionalProperties: false,
          required: ["defaultLocale", "locales"]
        },
        metadata: metadataConfigSchema
      },
      default: {},
      additionalProperties: true
    };
    exports2.environmentSchema = {
      oneOf: [
        Object.assign(Object.assign({}, exports2.redoclyConfigSchema), { additionalProperties: false }),
        {
          type: "object",
          properties: {
            $ref: { type: "string" }
          },
          required: ["$ref"],
          additionalProperties: false
        }
      ]
    };
    exports2.rootRedoclyConfigSchema = Object.assign(Object.assign({}, exports2.redoclyConfigSchema), { properties: Object.assign(Object.assign({}, exports2.redoclyConfigSchema.properties), { env: {
      type: "object",
      additionalProperties: exports2.environmentSchema
    } }), default: {}, required: ["redirects"] });
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/theme-config.js
var require_theme_config = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/theme-config.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ScorecardStatus = exports2.productThemeOverrideSchema = exports2.themeConfigSchema = void 0;
    var logoConfigSchema = {
      type: "object",
      properties: {
        image: { type: "string" },
        srcSet: { type: "string" },
        altText: { type: "string" },
        link: { type: "string" },
        favicon: { type: "string" }
      },
      additionalProperties: false
    };
    var hideConfigSchema = {
      type: "object",
      properties: {
        hide: { type: "boolean" }
      },
      additionalProperties: false
    };
    var scriptConfigSchema = {
      type: "object",
      properties: {
        src: { type: "string" },
        async: { type: "boolean" },
        crossorigin: { type: "string" },
        defer: { type: "boolean" },
        fetchpriority: { type: "string" },
        integrity: { type: "string" },
        module: { type: "boolean" },
        nomodule: { type: "boolean" },
        nonce: { type: "string" },
        referrerpolicy: { type: "string" },
        type: { type: "string" }
      },
      required: ["src"],
      additionalProperties: true
    };
    var linksConfigSchema = {
      type: "object",
      properties: {
        href: { type: "string" },
        as: { type: "string" },
        crossorigin: { type: "string" },
        fetchpriority: { type: "string" },
        hreflang: { type: "string" },
        imagesizes: { type: "string" },
        imagesrcset: { type: "string" },
        integrity: { type: "string" },
        media: { type: "string" },
        prefetch: { type: "string" },
        referrerpolicy: { type: "string" },
        rel: { type: "string" },
        sizes: { type: "string" },
        title: { type: "string" },
        type: { type: "string" }
      },
      required: ["href"],
      additionalProperties: true
    };
    var markdownConfigSchema = {
      type: "object",
      properties: {
        frontMatterKeysToResolve: {
          type: "array",
          items: { type: "string" },
          default: ["image", "links"]
        },
        lastUpdatedBlock: {
          type: "object",
          properties: Object.assign({ format: {
            type: "string",
            enum: ["timeago", "iso", "long", "short"],
            default: "timeago"
          }, locale: { type: "string", default: "en-US" } }, hideConfigSchema.properties),
          additionalProperties: false,
          default: {}
        },
        toc: {
          type: "object",
          properties: Object.assign({ header: { type: "string", default: "On this page" }, depth: { type: "integer", default: 3, minimum: 1 } }, hideConfigSchema.properties),
          additionalProperties: false,
          default: {}
        },
        editPage: {
          type: "object",
          properties: Object.assign({ baseUrl: { type: "string" } }, hideConfigSchema.properties),
          additionalProperties: false,
          default: {}
        }
      },
      additionalProperties: false,
      default: {}
    };
    var amplitudeAnalyticsConfigSchema = {
      type: "object",
      properties: {
        includeInDevelopment: { type: "boolean" },
        apiKey: { type: "string" },
        head: { type: "boolean" },
        respectDNT: { type: "boolean" },
        exclude: { type: "array", items: { type: "string" } },
        outboundClickEventName: { type: "string" },
        pageViewEventName: { type: "string" },
        amplitudeConfig: { type: "object", additionalProperties: true }
      },
      additionalProperties: false,
      required: ["apiKey"]
    };
    var fullstoryAnalyticsConfigSchema = {
      type: "object",
      properties: {
        includeInDevelopment: { type: "boolean" },
        orgId: { type: "string" }
      },
      additionalProperties: false,
      required: ["orgId"]
    };
    var heapAnalyticsConfigSchema = {
      type: "object",
      properties: {
        includeInDevelopment: { type: "boolean" },
        appId: { type: "string" }
      },
      additionalProperties: false,
      required: ["appId"]
    };
    var rudderstackAnalyticsConfigSchema = {
      type: "object",
      properties: {
        includeInDevelopment: { type: "boolean" },
        writeKey: { type: "string", minLength: 10 },
        trackPage: { type: "boolean" },
        dataPlaneUrl: { type: "string" },
        controlPlaneUrl: { type: "string" },
        sdkUrl: { type: "string" },
        loadOptions: { type: "object", additionalProperties: true }
      },
      additionalProperties: false,
      required: ["writeKey"]
    };
    var segmentAnalyticsConfigSchema = {
      type: "object",
      properties: {
        includeInDevelopment: { type: "boolean" },
        writeKey: { type: "string", minLength: 10 },
        trackPage: { type: "boolean" },
        includeTitleInPageCall: { type: "boolean" },
        host: { type: "string" }
      },
      additionalProperties: false,
      required: ["writeKey"]
    };
    var gtmAnalyticsConfigSchema = {
      type: "object",
      properties: {
        includeInDevelopment: { type: "boolean" },
        trackingId: { type: "string" },
        gtmAuth: { type: "string" },
        gtmPreview: { type: "string" },
        defaultDataLayer: {},
        dataLayerName: { type: "string" },
        enableWebVitalsTracking: { type: "boolean" },
        selfHostedOrigin: { type: "string" },
        pageViewEventName: { type: "string" }
      },
      additionalProperties: false,
      required: ["trackingId"]
    };
    var googleAnalyticsConfigSchema = {
      type: "object",
      properties: {
        includeInDevelopment: { type: "boolean" },
        trackingId: { type: "string" },
        conversionId: { type: "string" },
        floodlightId: { type: "string" },
        head: { type: "boolean" },
        respectDNT: { type: "boolean" },
        exclude: { type: "array", items: { type: "string" } },
        optimizeId: { type: "string" },
        anonymizeIp: { type: "boolean" },
        cookieExpires: { type: "number" }
      },
      additionalProperties: false,
      required: ["trackingId"]
    };
    var adobeAnalyticsConfigSchema = {
      type: "object",
      properties: {
        includeInDevelopment: { type: "boolean" },
        scriptUrl: { type: "string" },
        pageViewEventName: { type: "string" }
      },
      additionalProperties: false,
      required: ["scriptUrl"]
    };
    var navItemSchema = {
      type: "object",
      properties: {
        page: { type: "string" },
        directory: { type: "string" },
        group: { type: "string" },
        label: { type: "string" },
        separator: { type: "string" },
        separatorLine: { type: "boolean" },
        linePosition: {
          type: "string",
          enum: ["top", "bottom"],
          default: "top"
        },
        version: { type: "string" },
        menuStyle: { type: "string", enum: ["drilldown"] },
        expanded: { type: "string", const: "always" },
        selectFirstItemOnExpand: { type: "boolean" },
        flatten: { type: "boolean" },
        linkedSidebars: {
          type: "array",
          items: { type: "string" }
        }
      }
    };
    var navItemsSchema = {
      type: "array",
      items: Object.assign(Object.assign({}, navItemSchema), { properties: Object.assign(Object.assign({}, navItemSchema.properties), { items: { type: "array", items: navItemSchema } }) })
    };
    var productConfigSchema = {
      type: "object",
      properties: {
        name: { type: "string" },
        icon: { type: "string" },
        folder: { type: "string" }
      },
      additionalProperties: false,
      required: ["name", "icon", "folder"]
    };
    var suggestedPageSchema = {
      type: "object",
      properties: {
        page: { type: "string" },
        label: { type: "string" },
        labelTranslationKey: { type: "string" }
      },
      required: ["page"]
    };
    var catalogFilterSchema = {
      type: "object",
      additionalProperties: false,
      required: ["title", "property"],
      properties: {
        type: { type: "string", enum: ["select", "checkboxes", "date-range"] },
        title: { type: "string" },
        titleTranslationKey: { type: "string" },
        property: { type: "string" },
        parentFilter: { type: "string" },
        missingCategoryName: { type: "string" },
        missingCategoryNameTranslationKey: { type: "string" },
        options: { type: "array", items: { type: "string" } }
      }
    };
    var scorecardConfigSchema = {
      type: "object",
      additionalProperties: true,
      required: ["levels"],
      properties: {
        failBuildIfBelowMinimum: { type: "boolean", default: false },
        teamMetadataProperty: {
          type: "object",
          properties: {
            property: { type: "string" },
            label: { type: "string" },
            default: { type: "string" }
          }
        },
        levels: {
          type: "array",
          items: {
            type: "object",
            required: ["name"],
            properties: {
              name: { type: "string" },
              extends: { type: "array", items: { type: "string" } },
              rules: {
                type: "object",
                additionalProperties: {
                  type: ["object", "string"]
                }
              }
            },
            additionalProperties: false
          }
        },
        targets: {
          type: "array",
          items: {
            type: "object",
            required: ["where"],
            properties: {
              minimumLevel: { type: "string" },
              where: {
                type: "object",
                required: ["metadata"],
                properties: {
                  metadata: { type: "object", additionalProperties: { type: "string" } }
                },
                additionalProperties: false
              }
            },
            additionalProperties: false
          }
        }
      }
    };
    var catalogSchema = {
      type: "object",
      additionalProperties: true,
      required: ["slug", "items"],
      properties: {
        slug: { type: "string" },
        filters: { type: "array", items: catalogFilterSchema },
        groupByFirstFilter: { type: "boolean" },
        filterValuesCasing: {
          type: "string",
          enum: ["sentence", "original", "lowercase", "uppercase"]
        },
        items: navItemsSchema,
        requiredPermission: { type: "string" },
        separateVersions: { type: "boolean" },
        title: { type: "string" },
        titleTranslationKey: { type: "string" },
        description: { type: "string" },
        descriptionTranslationKey: { type: "string" }
      }
    };
    var catalogsConfigSchema = {
      type: "object",
      patternProperties: {
        ".*": catalogSchema
      }
    };
    exports2.themeConfigSchema = {
      type: "object",
      properties: {
        imports: {
          type: "array",
          items: { type: "string" },
          default: []
        },
        logo: logoConfigSchema,
        navbar: {
          type: "object",
          properties: Object.assign({ items: navItemsSchema }, hideConfigSchema.properties),
          additionalProperties: false
        },
        products: {
          type: "object",
          additionalProperties: productConfigSchema
        },
        footer: {
          type: "object",
          properties: Object.assign({ items: navItemsSchema, copyrightText: { type: "string" }, logo: hideConfigSchema }, hideConfigSchema.properties),
          additionalProperties: false
        },
        sidebar: {
          type: "object",
          properties: Object.assign({ separatorLine: { type: "boolean" }, linePosition: {
            type: "string",
            enum: ["top", "bottom"],
            default: "bottom"
          } }, hideConfigSchema.properties),
          additionalProperties: false
        },
        seo: {
          type: "object",
          properties: {
            title: { type: "string" }
          }
        },
        scripts: {
          type: "object",
          properties: {
            head: { type: "array", items: scriptConfigSchema },
            body: { type: "array", items: scriptConfigSchema }
          },
          additionalProperties: false
        },
        links: { type: "array", items: linksConfigSchema },
        feedback: {
          type: "object",
          properties: {
            hide: {
              type: "boolean",
              default: false
            },
            type: {
              type: "string",
              enum: ["rating", "sentiment", "comment", "reasons"],
              default: "sentiment"
            },
            settings: Object.assign({ type: "object", properties: {
              label: { type: "string" },
              submitText: { type: "string" },
              max: { type: "number" },
              buttonText: { type: "string" },
              multi: { type: "boolean" },
              items: { type: "array", items: { type: "string" }, minItems: 1 },
              reasons: {
                type: "object",
                properties: {
                  enable: { type: "boolean", default: true },
                  multi: { type: "boolean" },
                  label: { type: "string" },
                  items: { type: "array", items: { type: "string" } }
                },
                additionalProperties: false
              },
              comment: {
                type: "object",
                properties: {
                  enable: { type: "boolean", default: true },
                  label: { type: "string" },
                  likeLabel: { type: "string" },
                  dislikeLabel: { type: "string" }
                },
                additionalProperties: false
              }
            }, additionalProperties: false }, hideConfigSchema.properties)
          },
          additionalProperties: false,
          default: {}
        },
        search: {
          type: "object",
          properties: Object.assign({ placement: {
            type: "string",
            default: "navbar"
          }, shortcuts: {
            type: "array",
            items: { type: "string" },
            default: ["/"]
          }, suggestedPages: {
            type: "array",
            items: suggestedPageSchema
          } }, hideConfigSchema.properties),
          additionalProperties: false,
          default: {}
        },
        colorMode: {
          type: "object",
          properties: Object.assign({ ignoreDetection: { type: "boolean" }, modes: {
            type: "array",
            items: { type: "string" },
            default: ["light", "dark"]
          } }, hideConfigSchema.properties),
          additionalProperties: false,
          default: {}
        },
        navigation: {
          type: "object",
          properties: {
            nextButton: {
              type: "object",
              properties: Object.assign({ text: { type: "string", default: "Next to {label}" } }, hideConfigSchema.properties),
              additionalProperties: false,
              default: {}
            },
            previousButton: {
              type: "object",
              properties: Object.assign({ text: { type: "string", default: "Back to {label}" } }, hideConfigSchema.properties),
              additionalProperties: false,
              default: {}
            }
          },
          additionalProperties: false,
          default: {}
        },
        codeSnippet: {
          type: "object",
          properties: {
            controlsStyle: { type: "string", default: "icon" },
            copy: {
              type: "object",
              properties: Object.assign({}, hideConfigSchema.properties),
              additionalProperties: false,
              default: { hide: false }
            },
            report: {
              type: "object",
              properties: Object.assign({}, hideConfigSchema.properties),
              additionalProperties: false,
              default: { hide: true }
            },
            expand: {
              type: "object",
              properties: Object.assign({}, hideConfigSchema.properties),
              additionalProperties: false,
              default: { hide: false }
            },
            collapse: {
              type: "object",
              properties: Object.assign({}, hideConfigSchema.properties),
              additionalProperties: false,
              default: { hide: false }
            }
          },
          additionalProperties: false,
          default: {}
        },
        markdown: markdownConfigSchema,
        openapi: { type: "object", additionalProperties: true },
        graphql: { type: "object", additionalProperties: true },
        analytics: {
          type: "object",
          properties: {
            adobe: adobeAnalyticsConfigSchema,
            amplitude: amplitudeAnalyticsConfigSchema,
            fullstory: fullstoryAnalyticsConfigSchema,
            heap: heapAnalyticsConfigSchema,
            rudderstack: rudderstackAnalyticsConfigSchema,
            segment: segmentAnalyticsConfigSchema,
            gtm: gtmAnalyticsConfigSchema,
            ga: googleAnalyticsConfigSchema
          }
        },
        userProfile: {
          type: "object",
          properties: Object.assign({ loginLabel: { type: "string", default: "Login" }, logoutLabel: { type: "string", default: "Logout" }, menu: {
            type: "array",
            items: {
              type: "object",
              properties: {
                label: { type: "string" },
                external: { type: "boolean" },
                link: { type: "string" },
                separatorLine: { type: "boolean" }
              },
              additionalProperties: true
            },
            default: []
          } }, hideConfigSchema.properties),
          additionalProperties: false,
          default: {}
        },
        versionPicker: {
          type: "object",
          properties: {
            hide: { type: "boolean" },
            showForUnversioned: {
              type: "boolean"
            }
          }
        },
        breadcrumbs: {
          type: "object",
          properties: {
            hide: { type: "boolean" },
            prefixItems: {
              type: "array",
              items: {
                type: "object",
                properties: {
                  label: { type: "string" },
                  labelTranslationKey: { type: "string" },
                  page: { type: "string" }
                },
                additionalProperties: false,
                default: {}
              }
            }
          },
          additionalProperties: false,
          default: {}
        },
        catalog: catalogsConfigSchema,
        scorecard: scorecardConfigSchema
      },
      additionalProperties: true,
      default: {}
    };
    exports2.productThemeOverrideSchema = {
      type: "object",
      properties: {
        logo: exports2.themeConfigSchema.properties.logo,
        navbar: exports2.themeConfigSchema.properties.navbar,
        footer: exports2.themeConfigSchema.properties.footer,
        sidebar: exports2.themeConfigSchema.properties.sidebar,
        search: exports2.themeConfigSchema.properties.search,
        codeSnippet: exports2.themeConfigSchema.properties.codeSnippet,
        breadcrumbs: exports2.themeConfigSchema.properties.breadcrumbs
      },
      additionalProperties: true,
      default: {}
    };
    var ScorecardStatus;
    (function(ScorecardStatus2) {
      ScorecardStatus2["BelowMinimum"] = "Below minimum";
      ScorecardStatus2["Highest"] = "Highest";
      ScorecardStatus2["Minimum"] = "Minimum";
    })(ScorecardStatus || (exports2.ScorecardStatus = ScorecardStatus = {}));
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/redocly-yaml.js
var require_redocly_yaml = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/redocly-yaml.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ConfigTypes = void 0;
    var portal_config_schema_1 = require_portal_config_schema();
    var theme_config_1 = require_theme_config();
    var _1 = require_types();
    var oas3_1_1 = require_oas3_1();
    var utils_1 = require_utils4();
    var builtInCommonRules = [
      "spec",
      "info-contact",
      "operation-operationId",
      "tag-description",
      "tags-alphabetical"
    ];
    var builtInCommonOASRules = [
      "info-license-url",
      "info-license",
      "no-ambiguous-paths",
      "no-enum-type-mismatch",
      "no-http-verbs-in-paths",
      "no-identical-paths",
      "no-invalid-parameter-examples",
      "no-invalid-schema-examples",
      "no-path-trailing-slash",
      "operation-2xx-response",
      "operation-4xx-response",
      "operation-description",
      "operation-operationId-unique",
      "operation-operationId-url-safe",
      "operation-parameters-unique",
      "operation-singular-tag",
      "operation-summary",
      "operation-tag-defined",
      "parameter-description",
      "path-declaration-must-exist",
      "path-excludes-patterns",
      "path-http-verbs-order",
      "path-not-include-query",
      "path-params-defined",
      "path-parameters-defined",
      "path-segment-plural",
      "paths-kebab-case",
      "required-string-property-missing-min-length",
      "response-contains-header",
      "scalar-property-missing-example",
      "security-defined",
      "spec-strict-refs",
      "no-unresolved-refs"
    ];
    var builtInOAS2Rules = [
      "boolean-parameter-prefixes",
      "request-mime-type",
      "response-contains-property",
      "response-mime-type"
    ];
    var builtInOAS3Rules = [
      "boolean-parameter-prefixes",
      "component-name-unique",
      "no-empty-servers",
      "no-example-value-and-externalValue",
      "no-invalid-media-type-examples",
      "no-server-example.com",
      "no-server-trailing-slash",
      "no-server-variables-empty-enum",
      "no-undefined-server-variable",
      "no-unused-components",
      "operation-4xx-problem-details-rfc7807",
      "request-mime-type",
      "response-contains-property",
      "response-mime-type",
      "spec-components-invalid-map-name"
    ];
    var builtInAsync2Rules = ["channels-kebab-case", "no-channel-trailing-slash"];
    var builtInRules = [
      ...builtInCommonRules,
      ...builtInCommonOASRules,
      ...builtInOAS2Rules,
      ...builtInOAS3Rules,
      ...builtInAsync2Rules
    ];
    var nodeTypesList = [
      "any",
      "Root",
      "Tag",
      "TagList",
      "ExternalDocs",
      "Server",
      "ServerList",
      "ServerVariable",
      "ServerVariablesMap",
      "SecurityRequirement",
      "SecurityRequirementList",
      "Info",
      "Contact",
      "License",
      "Paths",
      "PathItem",
      "Parameter",
      "ParameterList",
      "Operation",
      "Callback",
      "CallbacksMap",
      "RequestBody",
      "MediaTypesMap",
      "MediaType",
      "Example",
      "ExamplesMap",
      "Encoding",
      "EncodingMap",
      "Header",
      "HeadersMap",
      "Responses",
      "Response",
      "Link",
      "LinksMap",
      "Schema",
      "Xml",
      "SchemaProperties",
      "DiscriminatorMapping",
      "Discriminator",
      "Components",
      "NamedSchemas",
      "NamedResponses",
      "NamedParameters",
      "NamedExamples",
      "NamedRequestBodies",
      "NamedHeaders",
      "NamedSecuritySchemes",
      "NamedLinks",
      "NamedCallbacks",
      "ImplicitFlow",
      "PasswordFlow",
      "ClientCredentials",
      "AuthorizationCode",
      "OAuth2Flows",
      "SecurityScheme",
      "XCodeSample",
      "XCodeSampleList",
      "WebhooksMap",
      "SpecExtension",
      "Message"
    ];
    var ConfigStyleguide = {
      properties: {
        extends: {
          type: "array",
          items: {
            type: "string"
          }
        },
        rules: "Rules",
        oas2Rules: "Rules",
        oas3_0Rules: "Rules",
        oas3_1Rules: "Rules",
        async2Rules: "Rules",
        preprocessors: { type: "object" },
        oas2Preprocessors: { type: "object" },
        oas3_0Preprocessors: { type: "object" },
        oas3_1Preprocessors: { type: "object" },
        async2Preprocessors: { type: "object" },
        decorators: { type: "object" },
        oas2Decorators: { type: "object" },
        oas3_0Decorators: { type: "object" },
        oas3_1Decorators: { type: "object" },
        async2Decorators: { type: "object" }
      }
    };
    var RootConfigStyleguide = {
      properties: Object.assign({ plugins: {
        type: "array",
        items: { type: "string" }
      } }, ConfigStyleguide.properties)
    };
    var ConfigRoot = {
      properties: Object.assign(Object.assign(Object.assign({}, portal_config_schema_1.rootRedoclyConfigSchema.properties), RootConfigStyleguide.properties), { apis: "ConfigApis", theme: "ConfigRootTheme", "features.openapi": "ConfigReferenceDocs", "features.mockServer": "ConfigMockServer", organization: { type: "string" }, region: { enum: ["us", "eu"] }, telemetry: { enum: ["on", "off"] }, resolve: {
        properties: {
          http: "ConfigHTTP",
          doNotResolveExamples: { type: "boolean" }
        }
      }, files: {
        type: "array",
        items: {
          type: "string"
        }
      } })
    };
    var ConfigApis = {
      properties: {},
      additionalProperties: "ConfigApisProperties"
    };
    var ConfigApisProperties = {
      properties: Object.assign(Object.assign(Object.assign(Object.assign({}, portal_config_schema_1.apiConfigSchema.properties), { root: { type: "string" }, labels: {
        type: "array",
        items: {
          type: "string"
        }
      }, lint: "ConfigStyleguide", styleguide: "ConfigStyleguide" }), ConfigStyleguide.properties), { "features.openapi": "ConfigReferenceDocs", "features.mockServer": "ConfigMockServer", theme: "ConfigRootTheme", files: {
        type: "array",
        items: {
          type: "string"
        }
      } }),
      required: ["root"]
    };
    var ConfigHTTP = {
      properties: {
        headers: {
          type: "array",
          items: {
            type: "string"
          }
        }
      }
    };
    var ConfigRootTheme = {
      properties: Object.assign(Object.assign({}, theme_config_1.themeConfigSchema.properties), { openapi: "ConfigReferenceDocs", mockServer: "ConfigMockServer" })
    };
    var Rules = {
      properties: {},
      additionalProperties: (value, key) => {
        if (key.startsWith("rule/")) {
          return "Assert";
        } else if (key.startsWith("assert/")) {
          return "Assert";
        } else if (builtInRules.includes(key) || (0, utils_1.isCustomRuleId)(key)) {
          if (typeof value === "string") {
            return { enum: ["error", "warn", "off"] };
          } else {
            return "ObjectRule";
          }
        } else if (key === "metadata-schema" || key === "custom-fields-schema") {
          return "Schema";
        }
        return;
      }
    };
    var ObjectRule = {
      properties: {
        severity: { enum: ["error", "warn", "off"] }
      },
      additionalProperties: {},
      required: ["severity"]
    };
    var AssertionDefinitionSubject = {
      properties: {
        type: { enum: nodeTypesList },
        property: (value) => {
          if (Array.isArray(value)) {
            return { type: "array", items: { type: "string" } };
          } else if (value === null) {
            return null;
          } else {
            return { type: "string" };
          }
        },
        filterInParentKeys: { type: "array", items: { type: "string" } },
        filterOutParentKeys: { type: "array", items: { type: "string" } },
        matchParentKeys: { type: "string" }
      },
      required: ["type"]
    };
    var AssertionDefinitionAssertions = {
      properties: {
        enum: { type: "array", items: { type: "string" } },
        pattern: { type: "string" },
        notPattern: { type: "string" },
        casing: {
          enum: [
            "camelCase",
            "kebab-case",
            "snake_case",
            "PascalCase",
            "MACRO_CASE",
            "COBOL-CASE",
            "flatcase"
          ]
        },
        mutuallyExclusive: { type: "array", items: { type: "string" } },
        mutuallyRequired: { type: "array", items: { type: "string" } },
        required: { type: "array", items: { type: "string" } },
        requireAny: { type: "array", items: { type: "string" } },
        disallowed: { type: "array", items: { type: "string" } },
        defined: { type: "boolean" },
        // undefined: { type: 'boolean' }, // TODO: Remove `undefined` assertion from codebase overall
        nonEmpty: { type: "boolean" },
        minLength: { type: "integer" },
        maxLength: { type: "integer" },
        ref: (value) => typeof value === "string" ? { type: "string" } : { type: "boolean" },
        const: (value) => {
          if (typeof value === "string") {
            return { type: "string" };
          }
          if (typeof value === "number") {
            return { type: "number" };
          }
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return;
          }
        }
      },
      additionalProperties: (_value, key) => {
        if (/^\w+\/\w+$/.test(key))
          return { type: "object" };
        return;
      }
    };
    var AssertDefinition = {
      properties: {
        subject: "AssertionDefinitionSubject",
        assertions: "AssertionDefinitionAssertions"
      },
      required: ["subject", "assertions"]
    };
    var Assert = {
      properties: {
        subject: "AssertionDefinitionSubject",
        assertions: "AssertionDefinitionAssertions",
        where: (0, _1.listOf)("AssertDefinition"),
        message: { type: "string" },
        suggest: { type: "array", items: { type: "string" } },
        severity: { enum: ["error", "warn", "off"] }
      },
      required: ["subject", "assertions"]
    };
    var ConfigLanguage = {
      properties: {
        label: { type: "string" },
        lang: {
          enum: [
            "curl",
            "C#",
            "Go",
            "Java",
            "Java8+Apache",
            "JavaScript",
            "Node.js",
            "PHP",
            "Python",
            "R",
            "Ruby"
          ]
        }
      },
      required: ["lang"]
    };
    var ConfigLabels = {
      properties: {
        enum: { type: "string" },
        enumSingleValue: { type: "string" },
        enumArray: { type: "string" },
        default: { type: "string" },
        deprecated: { type: "string" },
        example: { type: "string" },
        examples: { type: "string" },
        nullable: { type: "string" },
        recursive: { type: "string" },
        arrayOf: { type: "string" },
        webhook: { type: "string" },
        authorizations: { type: "string" },
        tryItAuthBasicUsername: { type: "string" },
        tryItAuthBasicPassword: { type: "string" }
      }
    };
    var ConfigSidebarLinks = {
      properties: {
        beforeInfo: (0, _1.listOf)("CommonConfigSidebarLinks"),
        end: (0, _1.listOf)("CommonConfigSidebarLinks")
      }
    };
    var CommonConfigSidebarLinks = {
      properties: {
        label: { type: "string" },
        link: { type: "string" },
        target: { type: "string" }
      },
      required: ["label", "link"]
    };
    var CommonThemeColors = {
      properties: {
        main: { type: "string" },
        light: { type: "string" },
        dark: { type: "string" },
        contrastText: { type: "string" }
      }
    };
    var CommonColorProps = {
      properties: {
        backgroundColor: { type: "string" },
        borderColor: { type: "string" },
        color: { type: "string" },
        tabTextColor: { type: "string" }
      }
    };
    var BorderThemeColors = {
      properties: (0, utils_1.pickObjectProps)(CommonThemeColors.properties, ["light", "dark"])
    };
    var HttpColors = {
      properties: {
        basic: { type: "string" },
        delete: { type: "string" },
        get: { type: "string" },
        head: { type: "string" },
        link: { type: "string" },
        options: { type: "string" },
        patch: { type: "string" },
        post: { type: "string" },
        put: { type: "string" }
      }
    };
    var ResponseColors = {
      properties: {
        error: "CommonColorProps",
        info: "CommonColorProps",
        redirect: "CommonColorProps",
        success: "CommonColorProps"
      }
    };
    var SecondaryColors = {
      properties: (0, utils_1.omitObjectProps)(CommonThemeColors.properties, ["dark"])
    };
    var TextThemeColors = {
      properties: {
        primary: { type: "string" },
        secondary: { type: "string" },
        light: { type: "string" }
      }
    };
    var ThemeColors = {
      properties: {
        accent: "CommonThemeColors",
        border: "BorderThemeColors",
        error: "CommonThemeColors",
        http: "HttpColors",
        primary: "CommonThemeColors",
        responses: "ResponseColors",
        secondary: "SecondaryColors",
        success: "CommonThemeColors",
        text: "TextThemeColors",
        tonalOffset: { type: "number" },
        warning: "CommonThemeColors"
      }
    };
    var SizeProps = {
      properties: {
        fontSize: { type: "string" },
        padding: { type: "string" },
        minWidth: { type: "string" }
      }
    };
    var Sizes = {
      properties: {
        small: "SizeProps",
        medium: "SizeProps",
        large: "SizeProps",
        xlarge: "SizeProps"
      }
    };
    var FontConfig = {
      properties: {
        fontFamily: { type: "string" },
        fontSize: { type: "string" },
        fontWeight: { type: "string" },
        lineHeight: { type: "string" }
      }
    };
    var ButtonsConfig = {
      properties: Object.assign(Object.assign({}, (0, utils_1.omitObjectProps)(FontConfig.properties, ["fontSize", "lineHeight"])), { borderRadius: { type: "string" }, hoverStyle: { type: "string" }, boxShadow: { type: "string" }, hoverBoxShadow: { type: "string" }, sizes: "Sizes" })
    };
    var BadgeFontConfig = {
      properties: (0, utils_1.pickObjectProps)(FontConfig.properties, ["fontSize", "lineHeight"])
    };
    var BadgeSizes = {
      properties: {
        medium: "BadgeFontConfig",
        small: "BadgeFontConfig"
      }
    };
    var HttpBadgesConfig = {
      properties: Object.assign(Object.assign({}, (0, utils_1.omitObjectProps)(FontConfig.properties, ["fontSize", "lineHeight"])), { borderRadius: { type: "string" }, color: { type: "string" }, sizes: "BadgeSizes" })
    };
    var LabelControls = {
      properties: {
        top: { type: "string" },
        width: { type: "string" },
        height: { type: "string" }
      }
    };
    var Panels = {
      properties: {
        borderRadius: { type: "string" },
        backgroundColor: { type: "string" }
      }
    };
    var TryItButton = {
      properties: {
        fullWidth: { type: "boolean" }
      }
    };
    var ConfigThemeComponents = {
      properties: {
        buttons: "ButtonsConfig",
        httpBadges: "HttpBadgesConfig",
        layoutControls: "LabelControls",
        panels: "Panels",
        tryItButton: "TryItButton",
        tryItSendButton: "TryItButton"
      }
    };
    var Breakpoints = {
      properties: {
        small: { type: "string" },
        medium: { type: "string" },
        large: { type: "string" }
      }
    };
    var StackedConfig = {
      properties: {
        maxWidth: "Breakpoints"
      }
    };
    var ThreePanelConfig = {
      properties: {
        maxWidth: "Breakpoints",
        middlePanelMaxWidth: "Breakpoints"
      }
    };
    var Layout = {
      properties: {
        showDarkRightPanel: { type: "boolean" },
        stacked: "StackedConfig",
        "three-panel": "ThreePanelConfig"
      }
    };
    var SchemaColorsConfig = {
      properties: {
        backgroundColor: { type: "string" },
        border: { type: "string" }
      }
    };
    var ConfigThemeSchema = {
      properties: {
        breakFieldNames: { type: "boolean" },
        caretColor: { type: "string" },
        caretSize: { type: "string" },
        constraints: "SchemaColorsConfig",
        defaultDetailsWidth: { type: "string" },
        examples: "SchemaColorsConfig",
        labelsTextSize: { type: "string" },
        linesColor: { type: "string" },
        nestedBackground: { type: "string" },
        nestingSpacing: { type: "string" },
        requireLabelColor: { type: "string" },
        typeNameColor: { type: "string" },
        typeTitleColor: { type: "string" }
      }
    };
    var GroupItemsConfig = {
      properties: {
        subItemsColor: { type: "string" },
        textTransform: { type: "string" },
        fontWeight: { type: "string" }
      }
    };
    var Level1Items = {
      properties: (0, utils_1.pickObjectProps)(GroupItemsConfig.properties, ["textTransform"])
    };
    var SpacingConfig = {
      properties: {
        unit: { type: "number" },
        paddingHorizontal: { type: "string" },
        paddingVertical: { type: "string" },
        offsetTop: { type: "string" },
        offsetLeft: { type: "string" },
        offsetNesting: { type: "string" }
      }
    };
    var Sidebar = {
      properties: Object.assign(Object.assign({}, (0, utils_1.omitObjectProps)(FontConfig.properties, ["fontWeight", "lineHeight"])), { activeBgColor: { type: "string" }, activeTextColor: { type: "string" }, backgroundColor: { type: "string" }, borderRadius: { type: "string" }, breakPath: { type: "boolean" }, caretColor: { type: "string" }, caretSize: { type: "string" }, groupItems: "GroupItemsConfig", level1items: "Level1Items", rightLineColor: { type: "string" }, separatorLabelColor: { type: "string" }, showAtBreakpoint: { type: "string" }, spacing: "SpacingConfig", textColor: { type: "string" }, width: { type: "string" } })
    };
    var Heading = {
      properties: Object.assign(Object.assign({}, FontConfig.properties), { color: { type: "string" }, transform: { type: "string" } })
    };
    var CodeConfig = {
      properties: Object.assign(Object.assign({}, FontConfig.properties), { backgroundColor: { type: "string" }, color: { type: "string" }, wordBreak: {
        enum: [
          "break-all",
          "break-word",
          "keep-all",
          "normal",
          "revert",
          "unset",
          "inherit",
          "initial"
        ]
      }, wrap: { type: "boolean" } })
    };
    var HeadingsConfig = {
      properties: (0, utils_1.omitObjectProps)(FontConfig.properties, ["fontSize"])
    };
    var LinksConfig = {
      properties: {
        color: { type: "string" },
        hover: { type: "string" },
        textDecoration: { type: "string" },
        hoverTextDecoration: { type: "string" },
        visited: { type: "string" }
      }
    };
    var Typography = {
      properties: Object.assign(Object.assign({ code: "CodeConfig", fieldName: "FontConfig" }, (0, utils_1.pickObjectProps)(FontConfig.properties, ["fontSize", "fontFamily"])), { fontWeightBold: { type: "string" }, fontWeightLight: { type: "string" }, fontWeightRegular: { type: "string" }, heading1: "Heading", heading2: "Heading", heading3: "Heading", headings: "HeadingsConfig", lineHeight: { type: "string" }, links: "LinksConfig", optimizeSpeed: { type: "boolean" }, rightPanelHeading: "Heading", smoothing: { enum: ["auto", "none", "antialiased", "subpixel-antialiased", "grayscale"] } })
    };
    var TokenProps = {
      properties: Object.assign({ color: { type: "string" } }, (0, utils_1.omitObjectProps)(FontConfig.properties, ["fontWeight"]))
    };
    var CodeBlock = {
      properties: {
        backgroundColor: { type: "string" },
        borderRadius: { type: "string" },
        tokens: "TokenProps"
      }
    };
    var ConfigThemeLogo = {
      properties: {
        gutter: { type: "string" },
        maxHeight: { type: "string" },
        maxWidth: { type: "string" }
      }
    };
    var Fab = {
      properties: {
        backgroundColor: { type: "string" },
        color: { type: "string" }
      }
    };
    var ButtonOverrides = {
      properties: {
        custom: { type: "string" }
      }
    };
    var Overrides = {
      properties: {
        DownloadButton: "ButtonOverrides",
        NextSectionButton: "ButtonOverrides"
      }
    };
    var RightPanel = {
      properties: {
        backgroundColor: { type: "string" },
        panelBackgroundColor: { type: "string" },
        panelControlsBackgroundColor: { type: "string" },
        showAtBreakpoint: { type: "string" },
        textColor: { type: "string" },
        width: { type: "string" }
      }
    };
    var Shape = {
      properties: { borderRadius: { type: "string" } }
    };
    var ThemeSpacing = {
      properties: {
        sectionHorizontal: { type: "number" },
        sectionVertical: { type: "number" },
        unit: { type: "number" }
      }
    };
    var ConfigTheme = {
      properties: {
        breakpoints: "Breakpoints",
        codeBlock: "CodeBlock",
        colors: "ThemeColors",
        components: "ConfigThemeComponents",
        layout: "Layout",
        logo: "ConfigThemeLogo",
        fab: "Fab",
        overrides: "Overrides",
        rightPanel: "RightPanel",
        schema: "ConfigThemeSchema",
        shape: "Shape",
        sidebar: "Sidebar",
        spacing: "ThemeSpacing",
        typography: "Typography",
        links: { properties: { color: { type: "string" } } },
        codeSample: { properties: { backgroundColor: { type: "string" } } }
        // deprecated
      }
    };
    var GenerateCodeSamples = {
      properties: {
        skipOptionalParameters: { type: "boolean" },
        languages: (0, _1.listOf)("ConfigLanguage")
      },
      required: ["languages"]
    };
    var ConfigReferenceDocs = {
      properties: {
        theme: "ConfigTheme",
        corsProxyUrl: { type: "string" },
        ctrlFHijack: { type: "boolean" },
        defaultSampleLanguage: { type: "string" },
        disableDeepLinks: { type: "boolean" },
        disableSearch: { type: "boolean" },
        disableSidebar: { type: "boolean" },
        downloadDefinitionUrl: { type: "string" },
        expandDefaultServerVariables: { type: "boolean" },
        enumSkipQuotes: { type: "boolean" },
        expandDefaultRequest: { type: "boolean" },
        expandDefaultResponse: { type: "boolean" },
        expandResponses: { type: "string" },
        expandSingleSchemaField: { type: "boolean" },
        generateCodeSamples: "GenerateCodeSamples",
        generatedPayloadSamplesMaxDepth: { type: "number" },
        hideDownloadButton: { type: "boolean" },
        hideHostname: { type: "boolean" },
        hideInfoSection: { type: "boolean" },
        hideLoading: { type: "boolean" },
        hideLogo: { type: "boolean" },
        hideRequestPayloadSample: { type: "boolean" },
        hideRightPanel: { type: "boolean" },
        hideSchemaPattern: { type: "boolean" },
        hideSchemaTitles: { type: "boolean" },
        hideSingleRequestSampleTab: { type: "boolean" },
        hideSecuritySection: { type: "boolean" },
        hideTryItPanel: { type: "boolean" },
        hideFab: { type: "boolean" },
        hideOneOfDescription: { type: "boolean" },
        htmlTemplate: { type: "string" },
        jsonSampleExpandLevel: (value) => {
          if (typeof value === "number") {
            return { type: "number", minimum: 1 };
          } else {
            return { type: "string" };
          }
        },
        labels: "ConfigLabels",
        layout: { enum: ["stacked", "three-panel"] },
        maxDisplayedEnumValues: { type: "number" },
        menuToggle: { type: "boolean" },
        nativeScrollbars: { type: "boolean" },
        noAutoAuth: { type: "boolean" },
        oAuth2RedirectURI: { type: "string" },
        onDeepLinkClick: { type: "object" },
        onlyRequiredInSamples: { type: "boolean" },
        pagination: { enum: ["none", "section", "item"] },
        pathInMiddlePanel: { type: "boolean" },
        payloadSampleIdx: { type: "number", minimum: 0 },
        requestInterceptor: { type: "object" },
        requiredPropsFirst: { type: "boolean" },
        routingBasePath: { type: "string" },
        routingStrategy: { type: "string" },
        samplesTabsMaxCount: { type: "number" },
        schemaExpansionLevel: (value) => {
          if (typeof value === "number") {
            return { type: "number", minimum: 0 };
          } else {
            return { type: "string" };
          }
        },
        schemaDefinitionsTagName: { type: "string" },
        minCharacterLengthToInitSearch: { type: "number", minimum: 1 },
        maxResponseHeadersToShowInTryIt: { type: "number", minimum: 0 },
        scrollYOffset: (value) => {
          if (typeof value === "number") {
            return { type: "number" };
          } else {
            return { type: "string" };
          }
        },
        searchAutoExpand: { type: "boolean" },
        searchFieldLevelBoost: { type: "number", minimum: 0 },
        searchMaxDepth: { type: "number", minimum: 1 },
        searchMode: { enum: ["default", "path-only"] },
        searchOperationTitleBoost: { type: "number" },
        searchTagTitleBoost: { type: "number" },
        sendXUserAgentInTryIt: { type: "boolean" },
        showChangeLayoutButton: { type: "boolean" },
        showConsole: { type: "boolean" },
        showExtensions: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return {
              type: "array",
              items: {
                type: "string"
              }
            };
          }
        },
        showNextButton: { type: "boolean" },
        showRightPanelToggle: { type: "boolean" },
        showSecuritySchemeType: { type: "boolean" },
        showWebhookVerb: { type: "boolean" },
        showObjectSchemaExamples: { type: "boolean" },
        disableTryItRequestUrlEncoding: { type: "boolean" },
        sidebarLinks: "ConfigSidebarLinks",
        sideNavStyle: { enum: ["summary-only", "path-first", "id-only"] },
        simpleOneOfTypeLabel: { type: "boolean" },
        sortEnumValuesAlphabetically: { type: "boolean" },
        sortOperationsAlphabetically: { type: "boolean" },
        sortPropsAlphabetically: { type: "boolean" },
        sortTagsAlphabetically: { type: "boolean" },
        suppressWarnings: { type: "boolean" },
        unstable_externalDescription: { type: "boolean" },
        unstable_ignoreMimeParameters: { type: "boolean" },
        untrustedDefinition: { type: "boolean" },
        mockServer: {
          properties: {
            url: { type: "string" },
            position: { enum: ["first", "last", "replace", "off"] },
            description: { type: "string" }
          }
        },
        showAccessMode: { type: "boolean" },
        preserveOriginalExtensionsName: { type: "boolean" },
        markdownHeadingsAnchorLevel: { type: "number" }
      },
      additionalProperties: { type: "string" }
    };
    var ConfigMockServer = {
      properties: {
        strictExamples: { type: "boolean" },
        errorIfForcedExampleNotFound: { type: "boolean" }
      }
    };
    exports2.ConfigTypes = Object.assign(Object.assign({}, oas3_1_1.Oas3_1Types), {
      Assert,
      ConfigRoot,
      ConfigApis,
      ConfigApisProperties,
      RootConfigStyleguide,
      ConfigStyleguide,
      ConfigReferenceDocs,
      ConfigMockServer,
      ConfigHTTP,
      ConfigLanguage,
      ConfigLabels,
      ConfigSidebarLinks,
      CommonConfigSidebarLinks,
      ConfigTheme,
      ConfigRootTheme,
      AssertDefinition,
      ThemeColors,
      CommonThemeColors,
      BorderThemeColors,
      HttpColors,
      ResponseColors,
      SecondaryColors,
      TextThemeColors,
      Sizes,
      ButtonsConfig,
      CommonColorProps,
      BadgeFontConfig,
      BadgeSizes,
      HttpBadgesConfig,
      LabelControls,
      Panels,
      TryItButton,
      Breakpoints,
      StackedConfig,
      ThreePanelConfig,
      SchemaColorsConfig,
      SizeProps,
      Level1Items,
      SpacingConfig,
      FontConfig,
      CodeConfig,
      HeadingsConfig,
      LinksConfig,
      TokenProps,
      CodeBlock,
      ConfigThemeLogo,
      Fab,
      ButtonOverrides,
      Overrides,
      ObjectRule,
      RightPanel,
      Rules,
      Shape,
      ThemeSpacing,
      GenerateCodeSamples,
      GroupItemsConfig,
      ConfigThemeComponents,
      Layout,
      ConfigThemeSchema,
      Sidebar,
      Heading,
      Typography,
      AssertionDefinitionAssertions,
      AssertionDefinitionSubject
    });
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/other/stats.js
var require_stats = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/other/stats.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Stats = void 0;
    var Stats = (statsAccumulator) => {
      return {
        ExternalDocs: {
          leave() {
            statsAccumulator.externalDocs.total++;
          }
        },
        ref: {
          enter(ref) {
            statsAccumulator.refs.items.add(ref["$ref"]);
          }
        },
        Tag: {
          leave(tag) {
            statsAccumulator.tags.items.add(tag.name);
          }
        },
        Link: {
          leave(link) {
            statsAccumulator.links.items.add(link.operationId);
          }
        },
        Root: {
          leave() {
            statsAccumulator.parameters.total = statsAccumulator.parameters.items.size;
            statsAccumulator.refs.total = statsAccumulator.refs.items.size;
            statsAccumulator.links.total = statsAccumulator.links.items.size;
            statsAccumulator.tags.total = statsAccumulator.tags.items.size;
          }
        },
        WebhooksMap: {
          Operation: {
            leave(operation) {
              operation.tags.forEach((tag) => {
                statsAccumulator.tags.items.add(tag);
              });
            }
          }
        },
        Paths: {
          PathItem: {
            leave() {
              statsAccumulator.pathItems.total++;
            },
            Operation: {
              leave(operation) {
                statsAccumulator.operations.total++;
                operation.tags && operation.tags.forEach((tag) => {
                  statsAccumulator.tags.items.add(tag);
                });
              }
            },
            Parameter: {
              leave(parameter) {
                statsAccumulator.parameters.items.add(parameter.name);
              }
            }
          }
        },
        NamedSchemas: {
          Schema: {
            leave() {
              statsAccumulator.schemas.total++;
            }
          }
        }
      };
    };
    exports2.Stats = Stats;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/visitors.js
var require_visitors = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/visitors.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.normalizeVisitors = void 0;
    var types_1 = require_types();
    var legacyTypesMap = {
      Root: "DefinitionRoot",
      ServerVariablesMap: "ServerVariableMap",
      Paths: ["PathMap", "PathsMap"],
      CallbacksMap: "CallbackMap",
      MediaTypesMap: "MediaTypeMap",
      ExamplesMap: "ExampleMap",
      EncodingMap: "EncodingsMap",
      HeadersMap: "HeaderMap",
      LinksMap: "LinkMap",
      OAuth2Flows: "SecuritySchemeFlows",
      Responses: "ResponsesMap"
    };
    function normalizeVisitors(visitorsConfig, types2) {
      const normalizedVisitors = {};
      normalizedVisitors.any = {
        enter: [],
        leave: []
      };
      for (const typeName of Object.keys(types2)) {
        normalizedVisitors[typeName] = {
          enter: [],
          leave: []
        };
      }
      normalizedVisitors.ref = {
        enter: [],
        leave: []
      };
      for (const { ruleId, severity, visitor } of visitorsConfig) {
        normalizeVisitorLevel({ ruleId, severity }, visitor, null);
      }
      for (const v of Object.keys(normalizedVisitors)) {
        normalizedVisitors[v].enter.sort((a, b) => b.depth - a.depth);
        normalizedVisitors[v].leave.sort((a, b) => a.depth - b.depth);
      }
      return normalizedVisitors;
      function addWeakNodes(ruleConf, from, to, parentContext, stack = []) {
        if (stack.includes(from))
          return;
        stack = [...stack, from];
        const possibleChildren = /* @__PURE__ */ new Set();
        for (const type2 of Object.values(from.properties)) {
          if (type2 === to) {
            addWeakFromStack(ruleConf, stack);
            continue;
          }
          if (typeof type2 === "object" && type2 !== null && type2.name) {
            possibleChildren.add(type2);
          }
        }
        if (from.additionalProperties && typeof from.additionalProperties !== "function") {
          if (from.additionalProperties === to) {
            addWeakFromStack(ruleConf, stack);
          } else if (from.additionalProperties.name !== void 0) {
            possibleChildren.add(from.additionalProperties);
          }
        }
        if (from.items) {
          if (from.items === to) {
            addWeakFromStack(ruleConf, stack);
          } else if (from.items.name !== void 0) {
            possibleChildren.add(from.items);
          }
        }
        if (from.extensionsPrefix) {
          possibleChildren.add(types_1.SpecExtension);
        }
        for (const fromType of Array.from(possibleChildren.values())) {
          addWeakNodes(ruleConf, fromType, to, parentContext, stack);
        }
        function addWeakFromStack(ruleConf2, stack2) {
          for (const interType of stack2.slice(1)) {
            normalizedVisitors[interType.name] = normalizedVisitors[interType.name] || {
              enter: [],
              leave: []
            };
            normalizedVisitors[interType.name].enter.push(Object.assign(Object.assign({}, ruleConf2), { visit: () => void 0, depth: 0, context: {
              isSkippedLevel: true,
              seen: /* @__PURE__ */ new Set(),
              parent: parentContext
            } }));
          }
        }
      }
      function findLegacyVisitorNode(visitor, typeName) {
        if (Array.isArray(typeName)) {
          const name = typeName.find((name2) => visitor[name2]) || void 0;
          return name && visitor[name];
        }
        return visitor[typeName];
      }
      function normalizeVisitorLevel(ruleConf, visitor, parentContext, depth = 0) {
        const visitorKeys = Object.keys(types2);
        if (depth === 0) {
          visitorKeys.push("any");
          visitorKeys.push("ref");
        } else {
          if (visitor.any) {
            throw new Error("any() is allowed only on top level");
          }
          if (visitor.ref) {
            throw new Error("ref() is allowed only on top level");
          }
        }
        for (const typeName of visitorKeys) {
          const typeVisitor = visitor[typeName] || findLegacyVisitorNode(visitor, legacyTypesMap[typeName]);
          const normalizedTypeVisitor = normalizedVisitors[typeName];
          if (!typeVisitor)
            continue;
          let visitorEnter;
          let visitorLeave;
          let visitorSkip;
          const isObjectVisitor = typeof typeVisitor === "object";
          if (typeName === "ref" && isObjectVisitor && typeVisitor.skip) {
            throw new Error("ref() visitor does not support skip");
          }
          if (typeof typeVisitor === "function") {
            visitorEnter = typeVisitor;
          } else if (isObjectVisitor) {
            visitorEnter = typeVisitor.enter;
            visitorLeave = typeVisitor.leave;
            visitorSkip = typeVisitor.skip;
          }
          const context = {
            activatedOn: null,
            type: types2[typeName],
            parent: parentContext,
            isSkippedLevel: false
          };
          if (typeof typeVisitor === "object") {
            normalizeVisitorLevel(ruleConf, typeVisitor, context, depth + 1);
          }
          if (parentContext) {
            addWeakNodes(ruleConf, parentContext.type, types2[typeName], parentContext);
          }
          if (visitorEnter || isObjectVisitor) {
            if (visitorEnter && typeof visitorEnter !== "function") {
              throw new Error("DEV: should be function");
            }
            normalizedTypeVisitor.enter.push(Object.assign(Object.assign({}, ruleConf), {
              visit: visitorEnter || (() => void 0),
              skip: visitorSkip,
              depth,
              context
            }));
          }
          if (visitorLeave) {
            if (typeof visitorLeave !== "function") {
              throw new Error("DEV: should be function");
            }
            normalizedTypeVisitor.leave.push(Object.assign(Object.assign({}, ruleConf), {
              visit: visitorLeave,
              depth,
              context
            }));
          }
        }
      }
    }
    exports2.normalizeVisitors = normalizeVisitors;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/walk.js
var require_walk = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/walk.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.walkDocument = void 0;
    var ref_utils_1 = require_ref_utils();
    var utils_1 = require_utils4();
    var resolve_1 = require_resolve2();
    var types_1 = require_types();
    function collectParents(ctx) {
      var _a;
      const parents = {};
      while (ctx.parent) {
        parents[ctx.parent.type.name] = (_a = ctx.parent.activatedOn) === null || _a === void 0 ? void 0 : _a.value.node;
        ctx = ctx.parent;
      }
      return parents;
    }
    function collectParentsLocations(ctx) {
      var _a, _b;
      const locations = {};
      while (ctx.parent) {
        if ((_a = ctx.parent.activatedOn) === null || _a === void 0 ? void 0 : _a.value.location) {
          locations[ctx.parent.type.name] = (_b = ctx.parent.activatedOn) === null || _b === void 0 ? void 0 : _b.value.location;
        }
        ctx = ctx.parent;
      }
      return locations;
    }
    function walkDocument(opts) {
      const { document: document2, rootType, normalizedVisitors, resolvedRefMap, ctx } = opts;
      const seenNodesPerType = {};
      const ignoredNodes = /* @__PURE__ */ new Set();
      walkNode(document2.parsed, rootType, new ref_utils_1.Location(document2.source, "#/"), void 0, "");
      function walkNode(node, type2, location, parent, key) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
        const resolve = (ref, from = currentLocation.source.absoluteRef) => {
          if (!(0, ref_utils_1.isRef)(ref))
            return { location, node: ref };
          const refId = (0, resolve_1.makeRefId)(from, ref.$ref);
          const resolvedRef = resolvedRefMap.get(refId);
          if (!resolvedRef) {
            return {
              location: void 0,
              node: void 0
            };
          }
          const { resolved, node: node2, document: document3, nodePointer, error: error2 } = resolvedRef;
          const newLocation = resolved ? new ref_utils_1.Location(document3.source, nodePointer) : error2 instanceof resolve_1.YamlParseError ? new ref_utils_1.Location(error2.source, "") : void 0;
          return { location: newLocation, node: node2, error: error2 };
        };
        const rawLocation = location;
        let currentLocation = location;
        const { node: resolvedNode, location: resolvedLocation, error } = resolve(node);
        const enteredContexts = /* @__PURE__ */ new Set();
        if ((0, ref_utils_1.isRef)(node)) {
          const refEnterVisitors = normalizedVisitors.ref.enter;
          for (const { visit: visitor, ruleId, severity, context } of refEnterVisitors) {
            enteredContexts.add(context);
            const report = reportFn.bind(void 0, ruleId, severity);
            visitor(node, {
              report,
              resolve,
              rawNode: node,
              rawLocation,
              location,
              type: type2,
              parent,
              key,
              parentLocations: {},
              oasVersion: ctx.oasVersion,
              getVisitorData: getVisitorDataFn.bind(void 0, ruleId)
            }, { node: resolvedNode, location: resolvedLocation, error });
            if ((resolvedLocation === null || resolvedLocation === void 0 ? void 0 : resolvedLocation.source.absoluteRef) && ctx.refTypes) {
              ctx.refTypes.set(resolvedLocation === null || resolvedLocation === void 0 ? void 0 : resolvedLocation.source.absoluteRef, type2);
            }
          }
        }
        if (resolvedNode !== void 0 && resolvedLocation && type2.name !== "scalar") {
          currentLocation = resolvedLocation;
          const isNodeSeen = (_b = (_a = seenNodesPerType[type2.name]) === null || _a === void 0 ? void 0 : _a.has) === null || _b === void 0 ? void 0 : _b.call(_a, resolvedNode);
          let visitedBySome = false;
          const anyEnterVisitors = normalizedVisitors.any.enter;
          const currentEnterVisitors = anyEnterVisitors.concat(((_c = normalizedVisitors[type2.name]) === null || _c === void 0 ? void 0 : _c.enter) || []);
          const activatedContexts = [];
          for (const { context, visit, skip, ruleId, severity } of currentEnterVisitors) {
            if (ignoredNodes.has(currentLocation.pointer))
              break;
            if (context.isSkippedLevel) {
              if (context.parent.activatedOn && !context.parent.activatedOn.value.nextLevelTypeActivated && !context.seen.has(node)) {
                context.seen.add(node);
                visitedBySome = true;
                activatedContexts.push(context);
              }
            } else {
              if (context.parent && // if nested
              context.parent.activatedOn && ((_d = context.activatedOn) === null || _d === void 0 ? void 0 : _d.value.withParentNode) !== context.parent.activatedOn.value.node && // do not enter if visited by parent children (it works thanks because deeper visitors are sorted before)
              ((_e = context.parent.activatedOn.value.nextLevelTypeActivated) === null || _e === void 0 ? void 0 : _e.value) !== type2 || !context.parent && !isNodeSeen) {
                activatedContexts.push(context);
                const activatedOn = {
                  node: resolvedNode,
                  location: resolvedLocation,
                  nextLevelTypeActivated: null,
                  withParentNode: (_g = (_f = context.parent) === null || _f === void 0 ? void 0 : _f.activatedOn) === null || _g === void 0 ? void 0 : _g.value.node,
                  skipped: (_k = ((_j = (_h = context.parent) === null || _h === void 0 ? void 0 : _h.activatedOn) === null || _j === void 0 ? void 0 : _j.value.skipped) || (skip === null || skip === void 0 ? void 0 : skip(resolvedNode, key, {
                    location,
                    rawLocation,
                    resolve,
                    rawNode: node
                  }))) !== null && _k !== void 0 ? _k : false
                };
                context.activatedOn = (0, utils_1.pushStack)(context.activatedOn, activatedOn);
                let ctx2 = context.parent;
                while (ctx2) {
                  ctx2.activatedOn.value.nextLevelTypeActivated = (0, utils_1.pushStack)(ctx2.activatedOn.value.nextLevelTypeActivated, type2);
                  ctx2 = ctx2.parent;
                }
                if (!activatedOn.skipped) {
                  visitedBySome = true;
                  enteredContexts.add(context);
                  visitWithContext(visit, resolvedNode, node, context, ruleId, severity);
                }
              }
            }
          }
          if (visitedBySome || !isNodeSeen) {
            seenNodesPerType[type2.name] = seenNodesPerType[type2.name] || /* @__PURE__ */ new Set();
            seenNodesPerType[type2.name].add(resolvedNode);
            if (Array.isArray(resolvedNode)) {
              const itemsType = type2.items;
              if (itemsType !== void 0) {
                for (let i = 0; i < resolvedNode.length; i++) {
                  walkNode(resolvedNode[i], itemsType, resolvedLocation.child([i]), resolvedNode, i);
                }
              }
            } else if (typeof resolvedNode === "object" && resolvedNode !== null) {
              const props = Object.keys(type2.properties);
              if (type2.additionalProperties) {
                props.push(...Object.keys(resolvedNode).filter((k) => !props.includes(k)));
              } else if (type2.extensionsPrefix) {
                props.push(...Object.keys(resolvedNode).filter((k) => k.startsWith(type2.extensionsPrefix)));
              }
              if ((0, ref_utils_1.isRef)(node)) {
                props.push(...Object.keys(node).filter((k) => k !== "$ref" && !props.includes(k)));
              }
              for (const propName of props) {
                let value = resolvedNode[propName];
                let loc = resolvedLocation;
                if (value === void 0) {
                  value = node[propName];
                  loc = location;
                }
                let propType = type2.properties[propName];
                if (propType === void 0)
                  propType = type2.additionalProperties;
                if (typeof propType === "function")
                  propType = propType(value, propName);
                if (propType === void 0 && type2.extensionsPrefix && propName.startsWith(type2.extensionsPrefix)) {
                  propType = types_1.SpecExtension;
                }
                if (!(0, types_1.isNamedType)(propType) && (propType === null || propType === void 0 ? void 0 : propType.directResolveAs)) {
                  propType = propType.directResolveAs;
                  value = { $ref: value };
                }
                if (propType && propType.name === void 0 && propType.resolvable !== false) {
                  propType = { name: "scalar", properties: {} };
                }
                if (!(0, types_1.isNamedType)(propType) || propType.name === "scalar" && !(0, ref_utils_1.isRef)(value)) {
                  continue;
                }
                walkNode(value, propType, loc.child([propName]), resolvedNode, propName);
              }
            }
          }
          const anyLeaveVisitors = normalizedVisitors.any.leave;
          const currentLeaveVisitors = (((_l = normalizedVisitors[type2.name]) === null || _l === void 0 ? void 0 : _l.leave) || []).concat(anyLeaveVisitors);
          for (const context of activatedContexts.reverse()) {
            if (context.isSkippedLevel) {
              context.seen.delete(resolvedNode);
            } else {
              context.activatedOn = (0, utils_1.popStack)(context.activatedOn);
              if (context.parent) {
                let ctx2 = context.parent;
                while (ctx2) {
                  ctx2.activatedOn.value.nextLevelTypeActivated = (0, utils_1.popStack)(ctx2.activatedOn.value.nextLevelTypeActivated);
                  ctx2 = ctx2.parent;
                }
              }
            }
          }
          for (const { context, visit, ruleId, severity } of currentLeaveVisitors) {
            if (!context.isSkippedLevel && enteredContexts.has(context)) {
              visitWithContext(visit, resolvedNode, node, context, ruleId, severity);
            }
          }
        }
        currentLocation = location;
        if ((0, ref_utils_1.isRef)(node)) {
          const refLeaveVisitors = normalizedVisitors.ref.leave;
          for (const { visit: visitor, ruleId, severity, context } of refLeaveVisitors) {
            if (enteredContexts.has(context)) {
              const report = reportFn.bind(void 0, ruleId, severity);
              visitor(node, {
                report,
                resolve,
                rawNode: node,
                rawLocation,
                location,
                type: type2,
                parent,
                key,
                parentLocations: {},
                oasVersion: ctx.oasVersion,
                getVisitorData: getVisitorDataFn.bind(void 0, ruleId)
              }, { node: resolvedNode, location: resolvedLocation, error });
            }
          }
        }
        function visitWithContext(visit, resolvedNode2, node2, context, ruleId, severity) {
          const report = reportFn.bind(void 0, ruleId, severity);
          visit(resolvedNode2, {
            report,
            resolve,
            rawNode: node2,
            location: currentLocation,
            rawLocation,
            type: type2,
            parent,
            key,
            parentLocations: collectParentsLocations(context),
            oasVersion: ctx.oasVersion,
            ignoreNextVisitorsOnNode: () => {
              ignoredNodes.add(currentLocation.pointer);
            },
            getVisitorData: getVisitorDataFn.bind(void 0, ruleId)
          }, collectParents(context), context);
        }
        function reportFn(ruleId, severity, opts2) {
          const normalizedLocation = opts2.location ? Array.isArray(opts2.location) ? opts2.location : [opts2.location] : [Object.assign(Object.assign({}, currentLocation), { reportOnKey: false })];
          const location2 = normalizedLocation.map((l) => Object.assign(Object.assign(Object.assign({}, currentLocation), { reportOnKey: false }), l));
          const ruleSeverity = opts2.forceSeverity || severity;
          if (ruleSeverity !== "off") {
            ctx.problems.push(Object.assign(Object.assign({ ruleId: opts2.ruleId || ruleId, severity: ruleSeverity }, opts2), { suggest: opts2.suggest || [], location: location2 }));
          }
        }
        function getVisitorDataFn(ruleId) {
          ctx.visitorsData[ruleId] = ctx.visitorsData[ruleId] || {};
          return ctx.visitorsData[ruleId];
        }
      }
    }
    exports2.walkDocument = walkDocument;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/yamlAST.js
var require_yamlAST = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/yamlAST.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var Kind;
    (function(Kind2) {
      Kind2[Kind2["SCALAR"] = 0] = "SCALAR";
      Kind2[Kind2["MAPPING"] = 1] = "MAPPING";
      Kind2[Kind2["MAP"] = 2] = "MAP";
      Kind2[Kind2["SEQ"] = 3] = "SEQ";
      Kind2[Kind2["ANCHOR_REF"] = 4] = "ANCHOR_REF";
      Kind2[Kind2["INCLUDE_REF"] = 5] = "INCLUDE_REF";
    })(Kind = exports2.Kind || (exports2.Kind = {}));
    function newMapping(key, value) {
      var end = value ? value.endPosition : key.endPosition + 1;
      var node = {
        key,
        value,
        startPosition: key.startPosition,
        endPosition: end,
        kind: Kind.MAPPING,
        parent: null,
        errors: []
      };
      return node;
    }
    exports2.newMapping = newMapping;
    function newAnchorRef(key, start, end, value) {
      return {
        errors: [],
        referencesAnchor: key,
        value,
        startPosition: start,
        endPosition: end,
        kind: Kind.ANCHOR_REF,
        parent: null
      };
    }
    exports2.newAnchorRef = newAnchorRef;
    function newScalar(v) {
      if (v === void 0) {
        v = "";
      }
      var result = {
        errors: [],
        startPosition: -1,
        endPosition: -1,
        value: "" + v,
        kind: Kind.SCALAR,
        parent: null,
        doubleQuoted: false,
        rawValue: "" + v
      };
      if (typeof v !== "string") {
        result.valueObject = v;
      }
      return result;
    }
    exports2.newScalar = newScalar;
    function newItems() {
      return {
        errors: [],
        startPosition: -1,
        endPosition: -1,
        items: [],
        kind: Kind.SEQ,
        parent: null
      };
    }
    exports2.newItems = newItems;
    function newSeq() {
      return newItems();
    }
    exports2.newSeq = newSeq;
    function newMap(mappings) {
      return {
        errors: [],
        startPosition: -1,
        endPosition: -1,
        mappings: mappings ? mappings : [],
        kind: Kind.MAP,
        parent: null
      };
    }
    exports2.newMap = newMap;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/common.js
var require_common2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/common.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    function isNothing2(subject) {
      return typeof subject === "undefined" || null === subject;
    }
    exports2.isNothing = isNothing2;
    function isObject3(subject) {
      return typeof subject === "object" && null !== subject;
    }
    exports2.isObject = isObject3;
    function toArray2(sequence) {
      if (Array.isArray(sequence)) {
        return sequence;
      } else if (isNothing2(sequence)) {
        return [];
      }
      return [sequence];
    }
    exports2.toArray = toArray2;
    function extend3(target, source) {
      var index, length, key, sourceKeys;
      if (source) {
        sourceKeys = Object.keys(source);
        for (index = 0, length = sourceKeys.length; index < length; index += 1) {
          key = sourceKeys[index];
          target[key] = source[key];
        }
      }
      return target;
    }
    exports2.extend = extend3;
    function repeat2(string3, count) {
      var result = "", cycle;
      for (cycle = 0; cycle < count; cycle += 1) {
        result += string3;
      }
      return result;
    }
    exports2.repeat = repeat2;
    function isNegativeZero2(number3) {
      return 0 === number3 && Number.NEGATIVE_INFINITY === 1 / number3;
    }
    exports2.isNegativeZero = isNegativeZero2;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/exception.js
var require_exception2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/exception.js"(exports2, module2) {
    "use strict";
    var YAMLException2 = function() {
      function YAMLException3(reason, mark, isWarning) {
        if (mark === void 0) {
          mark = null;
        }
        if (isWarning === void 0) {
          isWarning = false;
        }
        this.name = "YAMLException";
        this.reason = reason;
        this.mark = mark;
        this.message = this.toString(false);
        this.isWarning = isWarning;
      }
      YAMLException3.isInstance = function(instance) {
        if (instance != null && instance.getClassIdentifier && typeof instance.getClassIdentifier == "function") {
          for (var _i = 0, _a = instance.getClassIdentifier(); _i < _a.length; _i++) {
            var currentIdentifier = _a[_i];
            if (currentIdentifier == YAMLException3.CLASS_IDENTIFIER)
              return true;
          }
        }
        return false;
      };
      YAMLException3.prototype.getClassIdentifier = function() {
        var superIdentifiers = [];
        return superIdentifiers.concat(YAMLException3.CLASS_IDENTIFIER);
      };
      YAMLException3.prototype.toString = function(compact2) {
        if (compact2 === void 0) {
          compact2 = false;
        }
        var result;
        result = "JS-YAML: " + (this.reason || "(unknown reason)");
        if (!compact2 && this.mark) {
          result += " " + this.mark.toString();
        }
        return result;
      };
      YAMLException3.CLASS_IDENTIFIER = "yaml-ast-parser.YAMLException";
      return YAMLException3;
    }();
    module2.exports = YAMLException2;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/mark.js
var require_mark = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/mark.js"(exports2, module2) {
    "use strict";
    var common2 = require_common2();
    var Mark = function() {
      function Mark2(name, buffer, position, line, column) {
        this.name = name;
        this.buffer = buffer;
        this.position = position;
        this.line = line;
        this.column = column;
      }
      Mark2.prototype.getSnippet = function(indent, maxLength) {
        if (indent === void 0) {
          indent = 0;
        }
        if (maxLength === void 0) {
          maxLength = 75;
        }
        var head, start, tail, end, snippet2;
        if (!this.buffer) {
          return null;
        }
        indent = indent || 4;
        maxLength = maxLength || 75;
        head = "";
        start = this.position;
        while (start > 0 && -1 === "\0\r\n\x85\u2028\u2029".indexOf(this.buffer.charAt(start - 1))) {
          start -= 1;
          if (this.position - start > maxLength / 2 - 1) {
            head = " ... ";
            start += 5;
            break;
          }
        }
        tail = "";
        end = this.position;
        while (end < this.buffer.length && -1 === "\0\r\n\x85\u2028\u2029".indexOf(this.buffer.charAt(end))) {
          end += 1;
          if (end - this.position > maxLength / 2 - 1) {
            tail = " ... ";
            end -= 5;
            break;
          }
        }
        snippet2 = this.buffer.slice(start, end);
        return common2.repeat(" ", indent) + head + snippet2 + tail + "\n" + common2.repeat(" ", indent + this.position - start + head.length) + "^";
      };
      Mark2.prototype.toString = function(compact2) {
        if (compact2 === void 0) {
          compact2 = true;
        }
        var snippet2, where = "";
        if (this.name) {
          where += 'in "' + this.name + '" ';
        }
        where += "at line " + (this.line + 1) + ", column " + (this.column + 1);
        if (!compact2) {
          snippet2 = this.getSnippet();
          if (snippet2) {
            where += ":\n" + snippet2;
          }
        }
        return where;
      };
      return Mark2;
    }();
    module2.exports = Mark;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type.js
var require_type2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var YAMLException2 = require_exception2();
    var TYPE_CONSTRUCTOR_OPTIONS2 = [
      "kind",
      "resolve",
      "construct",
      "instanceOf",
      "predicate",
      "represent",
      "defaultStyle",
      "styleAliases"
    ];
    var YAML_NODE_KINDS2 = [
      "scalar",
      "sequence",
      "mapping"
    ];
    function compileStyleAliases2(map2) {
      var result = {};
      if (null !== map2) {
        Object.keys(map2).forEach(function(style) {
          map2[style].forEach(function(alias) {
            result[String(alias)] = style;
          });
        });
      }
      return result;
    }
    var Type3 = /* @__PURE__ */ function() {
      function Type4(tag, options) {
        options = options || {};
        Object.keys(options).forEach(function(name) {
          if (-1 === TYPE_CONSTRUCTOR_OPTIONS2.indexOf(name)) {
            throw new YAMLException2('Unknown option "' + name + '" is met in definition of "' + tag + '" YAML type.');
          }
        });
        this.tag = tag;
        this.kind = options["kind"] || null;
        this.resolve = options["resolve"] || function() {
          return true;
        };
        this.construct = options["construct"] || function(data) {
          return data;
        };
        this.instanceOf = options["instanceOf"] || null;
        this.predicate = options["predicate"] || null;
        this.represent = options["represent"] || null;
        this.defaultStyle = options["defaultStyle"] || null;
        this.styleAliases = compileStyleAliases2(options["styleAliases"] || null);
        if (-1 === YAML_NODE_KINDS2.indexOf(this.kind)) {
          throw new YAMLException2('Unknown kind "' + this.kind + '" is specified for "' + tag + '" YAML type.');
        }
      }
      return Type4;
    }();
    exports2.Type = Type3;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema.js
var require_schema6 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var common2 = require_common2();
    var YAMLException2 = require_exception2();
    var type_1 = require_type2();
    function compileList2(schema2, name, result) {
      var exclude = [];
      schema2.include.forEach(function(includedSchema) {
        result = compileList2(includedSchema, name, result);
      });
      schema2[name].forEach(function(currentType) {
        result.forEach(function(previousType, previousIndex) {
          if (previousType.tag === currentType.tag) {
            exclude.push(previousIndex);
          }
        });
        result.push(currentType);
      });
      return result.filter(function(type2, index) {
        return -1 === exclude.indexOf(index);
      });
    }
    function compileMap2() {
      var result = {}, index, length;
      function collectType(type2) {
        result[type2.tag] = type2;
      }
      for (index = 0, length = arguments.length; index < length; index += 1) {
        arguments[index].forEach(collectType);
      }
      return result;
    }
    var Schema3 = function() {
      function Schema4(definition) {
        this.include = definition.include || [];
        this.implicit = definition.implicit || [];
        this.explicit = definition.explicit || [];
        this.implicit.forEach(function(type2) {
          if (type2.loadKind && "scalar" !== type2.loadKind) {
            throw new YAMLException2("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.");
          }
        });
        this.compiledImplicit = compileList2(this, "implicit", []);
        this.compiledExplicit = compileList2(this, "explicit", []);
        this.compiledTypeMap = compileMap2(this.compiledImplicit, this.compiledExplicit);
      }
      Schema4.DEFAULT = null;
      Schema4.create = function createSchema() {
        var schemas, types2;
        switch (arguments.length) {
          case 1:
            schemas = Schema4.DEFAULT;
            types2 = arguments[0];
            break;
          case 2:
            schemas = arguments[0];
            types2 = arguments[1];
            break;
          default:
            throw new YAMLException2("Wrong number of arguments for Schema.create function");
        }
        schemas = common2.toArray(schemas);
        types2 = common2.toArray(types2);
        if (!schemas.every(function(schema2) {
          return schema2 instanceof Schema4;
        })) {
          throw new YAMLException2("Specified list of super schemas (or a single Schema object) contains a non-Schema object.");
        }
        if (!types2.every(function(type2) {
          return type2 instanceof type_1.Type;
        })) {
          throw new YAMLException2("Specified list of YAML types (or a single Type object) contains a non-Type object.");
        }
        return new Schema4({
          include: schemas,
          explicit: types2
        });
      };
      return Schema4;
    }();
    exports2.Schema = Schema3;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/str.js
var require_str2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/str.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    module2.exports = new type_1.Type("tag:yaml.org,2002:str", {
      kind: "scalar",
      construct: function(data) {
        return null !== data ? data : "";
      }
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/seq.js
var require_seq3 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/seq.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    module2.exports = new type_1.Type("tag:yaml.org,2002:seq", {
      kind: "sequence",
      construct: function(data) {
        return null !== data ? data : [];
      }
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/map.js
var require_map3 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/map.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    module2.exports = new type_1.Type("tag:yaml.org,2002:map", {
      kind: "mapping",
      construct: function(data) {
        return null !== data ? data : {};
      }
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/failsafe.js
var require_failsafe2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/failsafe.js"(exports2, module2) {
    "use strict";
    var schema_1 = require_schema6();
    module2.exports = new schema_1.Schema({
      explicit: [
        require_str2(),
        require_seq3(),
        require_map3()
      ]
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/null.js
var require_null3 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/null.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    function resolveYamlNull2(data) {
      if (null === data) {
        return true;
      }
      var max = data.length;
      return max === 1 && data === "~" || max === 4 && (data === "null" || data === "Null" || data === "NULL");
    }
    function constructYamlNull2() {
      return null;
    }
    function isNull3(object3) {
      return null === object3;
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:null", {
      kind: "scalar",
      resolve: resolveYamlNull2,
      construct: constructYamlNull2,
      predicate: isNull3,
      represent: {
        canonical: function() {
          return "~";
        },
        lowercase: function() {
          return "null";
        },
        uppercase: function() {
          return "NULL";
        },
        camelcase: function() {
          return "Null";
        }
      },
      defaultStyle: "lowercase"
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/bool.js
var require_bool4 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/bool.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    function resolveYamlBoolean2(data) {
      if (null === data) {
        return false;
      }
      var max = data.length;
      return max === 4 && (data === "true" || data === "True" || data === "TRUE") || max === 5 && (data === "false" || data === "False" || data === "FALSE");
    }
    function constructYamlBoolean2(data) {
      return data === "true" || data === "True" || data === "TRUE";
    }
    function isBoolean2(object3) {
      return "[object Boolean]" === Object.prototype.toString.call(object3);
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:bool", {
      kind: "scalar",
      resolve: resolveYamlBoolean2,
      construct: constructYamlBoolean2,
      predicate: isBoolean2,
      represent: {
        lowercase: function(object3) {
          return object3 ? "true" : "false";
        },
        uppercase: function(object3) {
          return object3 ? "TRUE" : "FALSE";
        },
        camelcase: function(object3) {
          return object3 ? "True" : "False";
        }
      },
      defaultStyle: "lowercase"
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/int.js
var require_int4 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/int.js"(exports2, module2) {
    "use strict";
    var common2 = require_common2();
    var type_1 = require_type2();
    function isHexCode2(c) {
      return 48 <= c && c <= 57 || 65 <= c && c <= 70 || 97 <= c && c <= 102;
    }
    function isOctCode2(c) {
      return 48 <= c && c <= 55;
    }
    function isDecCode2(c) {
      return 48 <= c && c <= 57;
    }
    function resolveYamlInteger2(data) {
      if (null === data) {
        return false;
      }
      var max = data.length, index = 0, hasDigits = false, ch;
      if (!max) {
        return false;
      }
      ch = data[index];
      if (ch === "-" || ch === "+") {
        ch = data[++index];
      }
      if (ch === "0") {
        if (index + 1 === max) {
          return true;
        }
        ch = data[++index];
        if (ch === "b") {
          index++;
          for (; index < max; index++) {
            ch = data[index];
            if (ch === "_") {
              continue;
            }
            if (ch !== "0" && ch !== "1") {
              return false;
            }
            hasDigits = true;
          }
          return hasDigits;
        }
        if (ch === "x") {
          index++;
          for (; index < max; index++) {
            ch = data[index];
            if (ch === "_") {
              continue;
            }
            if (!isHexCode2(data.charCodeAt(index))) {
              return false;
            }
            hasDigits = true;
          }
          return hasDigits;
        }
        for (; index < max; index++) {
          ch = data[index];
          if (ch === "_") {
            continue;
          }
          if (!isOctCode2(data.charCodeAt(index))) {
            return false;
          }
          hasDigits = true;
        }
        return hasDigits;
      }
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_") {
          continue;
        }
        if (ch === ":") {
          break;
        }
        if (!isDecCode2(data.charCodeAt(index))) {
          return false;
        }
        hasDigits = true;
      }
      if (!hasDigits) {
        return false;
      }
      if (ch !== ":") {
        return true;
      }
      return /^(:[0-5]?[0-9])+$/.test(data.slice(index));
    }
    function constructYamlInteger2(data) {
      var value = data, sign = 1, ch, base, digits = [];
      if (value.indexOf("_") !== -1) {
        value = value.replace(/_/g, "");
      }
      ch = value[0];
      if (ch === "-" || ch === "+") {
        if (ch === "-") {
          sign = -1;
        }
        value = value.slice(1);
        ch = value[0];
      }
      if ("0" === value) {
        return 0;
      }
      if (ch === "0") {
        if (value[1] === "b") {
          return sign * parseInt(value.slice(2), 2);
        }
        if (value[1] === "x") {
          return sign * parseInt(value, 16);
        }
        return sign * parseInt(value, 8);
      }
      if (value.indexOf(":") !== -1) {
        value.split(":").forEach(function(v) {
          digits.unshift(parseInt(v, 10));
        });
        value = 0;
        base = 1;
        digits.forEach(function(d) {
          value += d * base;
          base *= 60;
        });
        return sign * value;
      }
      return sign * parseInt(value, 10);
    }
    function isInteger2(object3) {
      return "[object Number]" === Object.prototype.toString.call(object3) && (0 === object3 % 1 && !common2.isNegativeZero(object3));
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:int", {
      kind: "scalar",
      resolve: resolveYamlInteger2,
      construct: constructYamlInteger2,
      predicate: isInteger2,
      represent: {
        binary: function(object3) {
          return "0b" + object3.toString(2);
        },
        octal: function(object3) {
          return "0" + object3.toString(8);
        },
        decimal: function(object3) {
          return object3.toString(10);
        },
        hexadecimal: function(object3) {
          return "0x" + object3.toString(16).toUpperCase();
        }
      },
      defaultStyle: "decimal",
      styleAliases: {
        binary: [2, "bin"],
        octal: [8, "oct"],
        decimal: [10, "dec"],
        hexadecimal: [16, "hex"]
      }
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/float.js
var require_float4 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/float.js"(exports2, module2) {
    "use strict";
    var common2 = require_common2();
    var type_1 = require_type2();
    var YAML_FLOAT_PATTERN2 = new RegExp("^(?:[-+]?(?:[0-9][0-9_]*)\\.[0-9_]*(?:[eE][-+][0-9]+)?|\\.[0-9_]+(?:[eE][-+][0-9]+)?|[-+]?[0-9][0-9_]*(?::[0-5]?[0-9])+\\.[0-9_]*|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$");
    function resolveYamlFloat2(data) {
      if (null === data) {
        return false;
      }
      var value, sign, base, digits;
      if (!YAML_FLOAT_PATTERN2.test(data)) {
        return false;
      }
      return true;
    }
    function constructYamlFloat2(data) {
      var value, sign, base, digits;
      value = data.replace(/_/g, "").toLowerCase();
      sign = "-" === value[0] ? -1 : 1;
      digits = [];
      if (0 <= "+-".indexOf(value[0])) {
        value = value.slice(1);
      }
      if (".inf" === value) {
        return 1 === sign ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY;
      } else if (".nan" === value) {
        return NaN;
      } else if (0 <= value.indexOf(":")) {
        value.split(":").forEach(function(v) {
          digits.unshift(parseFloat(v, 10));
        });
        value = 0;
        base = 1;
        digits.forEach(function(d) {
          value += d * base;
          base *= 60;
        });
        return sign * value;
      }
      return sign * parseFloat(value, 10);
    }
    function representYamlFloat2(object3, style) {
      if (isNaN(object3)) {
        switch (style) {
          case "lowercase":
            return ".nan";
          case "uppercase":
            return ".NAN";
          case "camelcase":
            return ".NaN";
        }
      } else if (Number.POSITIVE_INFINITY === object3) {
        switch (style) {
          case "lowercase":
            return ".inf";
          case "uppercase":
            return ".INF";
          case "camelcase":
            return ".Inf";
        }
      } else if (Number.NEGATIVE_INFINITY === object3) {
        switch (style) {
          case "lowercase":
            return "-.inf";
          case "uppercase":
            return "-.INF";
          case "camelcase":
            return "-.Inf";
        }
      } else if (common2.isNegativeZero(object3)) {
        return "-0.0";
      }
      return object3.toString(10);
    }
    function isFloat2(object3) {
      return "[object Number]" === Object.prototype.toString.call(object3) && (0 !== object3 % 1 || common2.isNegativeZero(object3));
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:float", {
      kind: "scalar",
      resolve: resolveYamlFloat2,
      construct: constructYamlFloat2,
      predicate: isFloat2,
      represent: representYamlFloat2,
      defaultStyle: "lowercase"
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/json.js
var require_json2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/json.js"(exports2, module2) {
    "use strict";
    var schema_1 = require_schema6();
    module2.exports = new schema_1.Schema({
      include: [
        require_failsafe2()
      ],
      implicit: [
        require_null3(),
        require_bool4(),
        require_int4(),
        require_float4()
      ]
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/core.js
var require_core5 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/core.js"(exports2, module2) {
    "use strict";
    var schema_1 = require_schema6();
    module2.exports = new schema_1.Schema({
      include: [
        require_json2()
      ]
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/timestamp.js
var require_timestamp3 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/timestamp.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    var YAML_TIMESTAMP_REGEXP2 = new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?)?$");
    function resolveYamlTimestamp2(data) {
      if (null === data) {
        return false;
      }
      var match, year, month, day, hour, minute, second, fraction = 0, delta = null, tz_hour, tz_minute, date3;
      match = YAML_TIMESTAMP_REGEXP2.exec(data);
      if (null === match) {
        return false;
      }
      return true;
    }
    function constructYamlTimestamp2(data) {
      var match, year, month, day, hour, minute, second, fraction = 0, delta = null, tz_hour, tz_minute, date3;
      match = YAML_TIMESTAMP_REGEXP2.exec(data);
      if (null === match) {
        throw new Error("Date resolve error");
      }
      year = +match[1];
      month = +match[2] - 1;
      day = +match[3];
      if (!match[4]) {
        return new Date(Date.UTC(year, month, day));
      }
      hour = +match[4];
      minute = +match[5];
      second = +match[6];
      if (match[7]) {
        fraction = match[7].slice(0, 3);
        while (fraction.length < 3) {
          fraction = fraction + "0";
        }
        fraction = +fraction;
      }
      if (match[9]) {
        tz_hour = +match[10];
        tz_minute = +(match[11] || 0);
        delta = (tz_hour * 60 + tz_minute) * 6e4;
        if ("-" === match[9]) {
          delta = -delta;
        }
      }
      date3 = new Date(Date.UTC(year, month, day, hour, minute, second, fraction));
      if (delta) {
        date3.setTime(date3.getTime() - delta);
      }
      return date3;
    }
    function representYamlTimestamp2(object3) {
      return object3.toISOString();
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:timestamp", {
      kind: "scalar",
      resolve: resolveYamlTimestamp2,
      construct: constructYamlTimestamp2,
      instanceOf: Date,
      represent: representYamlTimestamp2
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/merge.js
var require_merge2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/merge.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    function resolveYamlMerge2(data) {
      return "<<" === data || null === data;
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:merge", {
      kind: "scalar",
      resolve: resolveYamlMerge2
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/binary.js
var require_binary3 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/binary.js"(exports2, module2) {
    "use strict";
    var NodeBuffer = require("buffer").Buffer;
    var type_1 = require_type2();
    var BASE64_MAP2 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r";
    function resolveYamlBinary2(data) {
      if (null === data) {
        return false;
      }
      var code, idx, bitlen = 0, len = 0, max = data.length, map2 = BASE64_MAP2;
      for (idx = 0; idx < max; idx++) {
        code = map2.indexOf(data.charAt(idx));
        if (code > 64) {
          continue;
        }
        if (code < 0) {
          return false;
        }
        bitlen += 6;
      }
      return bitlen % 8 === 0;
    }
    function constructYamlBinary2(data) {
      var code, idx, tailbits, input = data.replace(/[\r\n=]/g, ""), max = input.length, map2 = BASE64_MAP2, bits = 0, result = [];
      for (idx = 0; idx < max; idx++) {
        if (idx % 4 === 0 && idx) {
          result.push(bits >> 16 & 255);
          result.push(bits >> 8 & 255);
          result.push(bits & 255);
        }
        bits = bits << 6 | map2.indexOf(input.charAt(idx));
      }
      tailbits = max % 4 * 6;
      if (tailbits === 0) {
        result.push(bits >> 16 & 255);
        result.push(bits >> 8 & 255);
        result.push(bits & 255);
      } else if (tailbits === 18) {
        result.push(bits >> 10 & 255);
        result.push(bits >> 2 & 255);
      } else if (tailbits === 12) {
        result.push(bits >> 4 & 255);
      }
      if (NodeBuffer) {
        return new NodeBuffer(result);
      }
      return result;
    }
    function representYamlBinary2(object3) {
      var result = "", bits = 0, idx, tail, max = object3.length, map2 = BASE64_MAP2;
      for (idx = 0; idx < max; idx++) {
        if (idx % 3 === 0 && idx) {
          result += map2[bits >> 18 & 63];
          result += map2[bits >> 12 & 63];
          result += map2[bits >> 6 & 63];
          result += map2[bits & 63];
        }
        bits = (bits << 8) + object3[idx];
      }
      tail = max % 3;
      if (tail === 0) {
        result += map2[bits >> 18 & 63];
        result += map2[bits >> 12 & 63];
        result += map2[bits >> 6 & 63];
        result += map2[bits & 63];
      } else if (tail === 2) {
        result += map2[bits >> 10 & 63];
        result += map2[bits >> 4 & 63];
        result += map2[bits << 2 & 63];
        result += map2[64];
      } else if (tail === 1) {
        result += map2[bits >> 2 & 63];
        result += map2[bits << 4 & 63];
        result += map2[64];
        result += map2[64];
      }
      return result;
    }
    function isBinary2(object3) {
      return NodeBuffer && NodeBuffer.isBuffer(object3);
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:binary", {
      kind: "scalar",
      resolve: resolveYamlBinary2,
      construct: constructYamlBinary2,
      predicate: isBinary2,
      represent: representYamlBinary2
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/omap.js
var require_omap3 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/omap.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    var _hasOwnProperty2 = Object.prototype.hasOwnProperty;
    var _toString2 = Object.prototype.toString;
    function resolveYamlOmap2(data) {
      if (null === data) {
        return true;
      }
      var objectKeys = [], index, length, pair, pairKey, pairHasKey, object3 = data;
      for (index = 0, length = object3.length; index < length; index += 1) {
        pair = object3[index];
        pairHasKey = false;
        if ("[object Object]" !== _toString2.call(pair)) {
          return false;
        }
        for (pairKey in pair) {
          if (_hasOwnProperty2.call(pair, pairKey)) {
            if (!pairHasKey) {
              pairHasKey = true;
            } else {
              return false;
            }
          }
        }
        if (!pairHasKey) {
          return false;
        }
        if (-1 === objectKeys.indexOf(pairKey)) {
          objectKeys.push(pairKey);
        } else {
          return false;
        }
      }
      return true;
    }
    function constructYamlOmap2(data) {
      return null !== data ? data : [];
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:omap", {
      kind: "sequence",
      resolve: resolveYamlOmap2,
      construct: constructYamlOmap2
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/pairs.js
var require_pairs3 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/pairs.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    var ast = require_yamlAST();
    var _toString2 = Object.prototype.toString;
    function resolveYamlPairs2(data) {
      if (null === data) {
        return true;
      }
      if (data.kind != ast.Kind.SEQ) {
        return false;
      }
      var index, length, pair, keys5, result, object3 = data.items;
      for (index = 0, length = object3.length; index < length; index += 1) {
        pair = object3[index];
        if ("[object Object]" !== _toString2.call(pair)) {
          return false;
        }
        if (!Array.isArray(pair.mappings)) {
          return false;
        }
        if (1 !== pair.mappings.length) {
          return false;
        }
      }
      return true;
    }
    function constructYamlPairs2(data) {
      if (null === data || !Array.isArray(data.items)) {
        return [];
      }
      var index, length, keys5, result, object3 = data.items;
      result = ast.newItems();
      result.parent = data.parent;
      result.startPosition = data.startPosition;
      result.endPosition = data.endPosition;
      for (index = 0, length = object3.length; index < length; index += 1) {
        var pair = object3[index];
        var mapping = pair.mappings[0];
        var pairSeq = ast.newItems();
        pairSeq.parent = result;
        pairSeq.startPosition = mapping.key.startPosition;
        pairSeq.endPosition = mapping.value.startPosition;
        mapping.key.parent = pairSeq;
        mapping.value.parent = pairSeq;
        pairSeq.items = [mapping.key, mapping.value];
        result.items.push(pairSeq);
      }
      return result;
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:pairs", {
      kind: "sequence",
      resolve: resolveYamlPairs2,
      construct: constructYamlPairs2
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/set.js
var require_set3 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/set.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    var ast = require_yamlAST();
    function resolveYamlSet2(data) {
      if (null === data) {
        return true;
      }
      if (data.kind != ast.Kind.MAP) {
        return false;
      }
      return true;
    }
    function constructYamlSet2(data) {
      return null !== data ? data : {};
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:set", {
      kind: "mapping",
      resolve: resolveYamlSet2,
      construct: constructYamlSet2
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/default_safe.js
var require_default_safe = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/default_safe.js"(exports2, module2) {
    "use strict";
    var schema_1 = require_schema6();
    var schema2 = new schema_1.Schema({
      include: [
        require_core5()
      ],
      implicit: [
        require_timestamp3(),
        require_merge2()
      ],
      explicit: [
        require_binary3(),
        require_omap3(),
        require_pairs3(),
        require_set3()
      ]
    });
    module2.exports = schema2;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/js/undefined.js
var require_undefined = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/js/undefined.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    function resolveJavascriptUndefined() {
      return true;
    }
    function constructJavascriptUndefined() {
      return void 0;
    }
    function representJavascriptUndefined() {
      return "";
    }
    function isUndefined(object3) {
      return "undefined" === typeof object3;
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:js/undefined", {
      kind: "scalar",
      resolve: resolveJavascriptUndefined,
      construct: constructJavascriptUndefined,
      predicate: isUndefined,
      represent: representJavascriptUndefined
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/js/regexp.js
var require_regexp = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/js/regexp.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    function resolveJavascriptRegExp(data) {
      if (null === data) {
        return false;
      }
      if (0 === data.length) {
        return false;
      }
      var regexp = data, tail = /\/([gim]*)$/.exec(data), modifiers = "";
      if ("/" === regexp[0]) {
        if (tail) {
          modifiers = tail[1];
        }
        if (modifiers.length > 3) {
          return false;
        }
        if (regexp[regexp.length - modifiers.length - 1] !== "/") {
          return false;
        }
        regexp = regexp.slice(1, regexp.length - modifiers.length - 1);
      }
      try {
        var dummy = new RegExp(regexp, modifiers);
        return true;
      } catch (error) {
        return false;
      }
    }
    function constructJavascriptRegExp(data) {
      var regexp = data, tail = /\/([gim]*)$/.exec(data), modifiers = "";
      if ("/" === regexp[0]) {
        if (tail) {
          modifiers = tail[1];
        }
        regexp = regexp.slice(1, regexp.length - modifiers.length - 1);
      }
      return new RegExp(regexp, modifiers);
    }
    function representJavascriptRegExp(object3) {
      var result = "/" + object3.source + "/";
      if (object3.global) {
        result += "g";
      }
      if (object3.multiline) {
        result += "m";
      }
      if (object3.ignoreCase) {
        result += "i";
      }
      return result;
    }
    function isRegExp(object3) {
      return "[object RegExp]" === Object.prototype.toString.call(object3);
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:js/regexp", {
      kind: "scalar",
      resolve: resolveJavascriptRegExp,
      construct: constructJavascriptRegExp,
      predicate: isRegExp,
      represent: representJavascriptRegExp
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/default_full.js
var require_default_full = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/default_full.js"(exports2, module2) {
    "use strict";
    var schema_1 = require_schema6();
    var schema2 = new schema_1.Schema({
      include: [
        require_default_safe()
      ],
      explicit: [
        require_undefined(),
        require_regexp()
      ]
    });
    schema_1.Schema.DEFAULT = schema2;
    module2.exports = schema2;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/loader.js
var require_loader2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/loader.js"(exports2, module2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var ast = require_yamlAST();
    var common2 = require_common2();
    var YAMLException2 = require_exception2();
    var Mark = require_mark();
    var DEFAULT_SAFE_SCHEMA = require_default_safe();
    var DEFAULT_FULL_SCHEMA = require_default_full();
    var _hasOwnProperty2 = Object.prototype.hasOwnProperty;
    var CONTEXT_FLOW_IN2 = 1;
    var CONTEXT_FLOW_OUT2 = 2;
    var CONTEXT_BLOCK_IN2 = 3;
    var CONTEXT_BLOCK_OUT2 = 4;
    var CHOMPING_CLIP2 = 1;
    var CHOMPING_STRIP2 = 2;
    var CHOMPING_KEEP2 = 3;
    var PATTERN_NON_PRINTABLE2 = /[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;
    var PATTERN_NON_ASCII_LINE_BREAKS2 = /[\x85\u2028\u2029]/;
    var PATTERN_FLOW_INDICATORS2 = /[,\[\]\{\}]/;
    var PATTERN_TAG_HANDLE2 = /^(?:!|!!|![a-z\-]+!)$/i;
    var PATTERN_TAG_URI2 = /^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i;
    function is_EOL2(c) {
      return c === 10 || c === 13;
    }
    function is_WHITE_SPACE2(c) {
      return c === 9 || c === 32;
    }
    function is_WS_OR_EOL2(c) {
      return c === 9 || c === 32 || c === 10 || c === 13;
    }
    function is_FLOW_INDICATOR2(c) {
      return 44 === c || 91 === c || 93 === c || 123 === c || 125 === c;
    }
    function fromHexCode2(c) {
      var lc;
      if (48 <= c && c <= 57) {
        return c - 48;
      }
      lc = c | 32;
      if (97 <= lc && lc <= 102) {
        return lc - 97 + 10;
      }
      return -1;
    }
    function escapedHexLen2(c) {
      if (c === 120) {
        return 2;
      }
      if (c === 117) {
        return 4;
      }
      if (c === 85) {
        return 8;
      }
      return 0;
    }
    function fromDecimalCode2(c) {
      if (48 <= c && c <= 57) {
        return c - 48;
      }
      return -1;
    }
    function simpleEscapeSequence2(c) {
      return c === 48 ? "\0" : c === 97 ? "\x07" : c === 98 ? "\b" : c === 116 ? "	" : c === 9 ? "	" : c === 110 ? "\n" : c === 118 ? "\v" : c === 102 ? "\f" : c === 114 ? "\r" : c === 101 ? "\x1B" : c === 32 ? " " : c === 34 ? '"' : c === 47 ? "/" : c === 92 ? "\\" : c === 78 ? "\x85" : c === 95 ? "\xA0" : c === 76 ? "\u2028" : c === 80 ? "\u2029" : "";
    }
    function charFromCodepoint2(c) {
      if (c <= 65535) {
        return String.fromCharCode(c);
      }
      return String.fromCharCode((c - 65536 >> 10) + 55296, (c - 65536 & 1023) + 56320);
    }
    var simpleEscapeCheck2 = new Array(256);
    var simpleEscapeMap2 = new Array(256);
    var customEscapeCheck = new Array(256);
    var customEscapeMap = new Array(256);
    for (i = 0; i < 256; i++) {
      customEscapeMap[i] = simpleEscapeMap2[i] = simpleEscapeSequence2(i);
      simpleEscapeCheck2[i] = simpleEscapeMap2[i] ? 1 : 0;
      customEscapeCheck[i] = 1;
      if (!simpleEscapeCheck2[i]) {
        customEscapeMap[i] = "\\" + String.fromCharCode(i);
      }
    }
    var i;
    var State3 = /* @__PURE__ */ function() {
      function State4(input, options) {
        this.errorMap = {};
        this.errors = [];
        this.lines = [];
        this.input = input;
        this.filename = options["filename"] || null;
        this.schema = options["schema"] || DEFAULT_FULL_SCHEMA;
        this.onWarning = options["onWarning"] || null;
        this.legacy = options["legacy"] || false;
        this.allowAnyEscape = options["allowAnyEscape"] || false;
        this.ignoreDuplicateKeys = options["ignoreDuplicateKeys"] || false;
        this.implicitTypes = this.schema.compiledImplicit;
        this.typeMap = this.schema.compiledTypeMap;
        this.length = input.length;
        this.position = 0;
        this.line = 0;
        this.lineStart = 0;
        this.lineIndent = 0;
        this.documents = [];
      }
      return State4;
    }();
    function generateError2(state, message, isWarning) {
      if (isWarning === void 0) {
        isWarning = false;
      }
      return new YAMLException2(message, new Mark(state.filename, state.input, state.position, state.line, state.position - state.lineStart), isWarning);
    }
    function throwErrorFromPosition(state, position, message, isWarning, toLineEnd) {
      if (isWarning === void 0) {
        isWarning = false;
      }
      if (toLineEnd === void 0) {
        toLineEnd = false;
      }
      var line = positionToLine(state, position);
      if (!line) {
        return;
      }
      var hash2 = message + position;
      if (state.errorMap[hash2]) {
        return;
      }
      var mark = new Mark(state.filename, state.input, position, line.line, position - line.start);
      if (toLineEnd) {
        mark.toLineEnd = true;
      }
      var error = new YAMLException2(message, mark, isWarning);
      state.errors.push(error);
    }
    function throwError2(state, message) {
      var error = generateError2(state, message);
      var hash2 = error.message + error.mark.position;
      if (state.errorMap[hash2]) {
        return;
      }
      state.errors.push(error);
      state.errorMap[hash2] = 1;
      var or = state.position;
      while (true) {
        if (state.position >= state.input.length - 1) {
          return;
        }
        var c = state.input.charAt(state.position);
        if (c == "\n") {
          state.position--;
          if (state.position == or) {
            state.position += 1;
          }
          return;
        }
        if (c == "\r") {
          state.position--;
          if (state.position == or) {
            state.position += 1;
          }
          return;
        }
        state.position++;
      }
    }
    function throwWarning2(state, message) {
      var error = generateError2(state, message);
      if (state.onWarning) {
        state.onWarning.call(null, error);
      } else {
      }
    }
    var directiveHandlers2 = {
      YAML: function handleYamlDirective2(state, name, args) {
        var match, major, minor;
        if (null !== state.version) {
          throwError2(state, "duplication of %YAML directive");
        }
        if (1 !== args.length) {
          throwError2(state, "YAML directive accepts exactly one argument");
        }
        match = /^([0-9]+)\.([0-9]+)$/.exec(args[0]);
        if (null === match) {
          throwError2(state, "ill-formed argument of the YAML directive");
        }
        major = parseInt(match[1], 10);
        minor = parseInt(match[2], 10);
        if (1 !== major) {
          throwError2(state, "found incompatible YAML document (version 1.2 is required)");
        }
        state.version = args[0];
        state.checkLineBreaks = minor < 2;
        if (2 !== minor) {
          throwError2(state, "found incompatible YAML document (version 1.2 is required)");
        }
      },
      TAG: function handleTagDirective2(state, name, args) {
        var handle, prefix;
        if (2 !== args.length) {
          throwError2(state, "TAG directive accepts exactly two arguments");
        }
        handle = args[0];
        prefix = args[1];
        if (!PATTERN_TAG_HANDLE2.test(handle)) {
          throwError2(state, "ill-formed tag handle (first argument) of the TAG directive");
        }
        if (_hasOwnProperty2.call(state.tagMap, handle)) {
          throwError2(state, 'there is a previously declared suffix for "' + handle + '" tag handle');
        }
        if (!PATTERN_TAG_URI2.test(prefix)) {
          throwError2(state, "ill-formed tag prefix (second argument) of the TAG directive");
        }
        state.tagMap[handle] = prefix;
      }
    };
    function captureSegment2(state, start, end, checkJson) {
      var _position, _length, _character, _result;
      var scalar = state.result;
      if (scalar.startPosition == -1) {
        scalar.startPosition = start;
      }
      if (start <= end) {
        _result = state.input.slice(start, end);
        if (checkJson) {
          for (_position = 0, _length = _result.length; _position < _length; _position += 1) {
            _character = _result.charCodeAt(_position);
            if (!(9 === _character || 32 <= _character && _character <= 1114111)) {
              throwError2(state, "expected valid JSON character");
            }
          }
        } else if (PATTERN_NON_PRINTABLE2.test(_result)) {
          throwError2(state, "the stream contains non-printable characters");
        }
        scalar.value += _result;
        scalar.endPosition = end;
      }
    }
    function storeMappingPair2(state, _result, keyTag, keyNode, valueNode) {
      var index, quantity;
      if (keyNode == null) {
        return;
      }
      if (null === _result) {
        _result = {
          startPosition: keyNode.startPosition,
          endPosition: valueNode.endPosition,
          parent: null,
          errors: [],
          mappings: [],
          kind: ast.Kind.MAP
        };
      }
      var mapping = ast.newMapping(keyNode, valueNode);
      mapping.parent = _result;
      keyNode.parent = mapping;
      if (valueNode != null) {
        valueNode.parent = mapping;
      }
      !state.ignoreDuplicateKeys && _result.mappings.forEach(function(sibling) {
        if (sibling.key && sibling.key.value === (mapping.key && mapping.key.value)) {
          throwErrorFromPosition(state, mapping.key.startPosition, "duplicate key");
          throwErrorFromPosition(state, sibling.key.startPosition, "duplicate key");
        }
      });
      _result.mappings.push(mapping);
      _result.endPosition = valueNode ? valueNode.endPosition : keyNode.endPosition + 1;
      return _result;
    }
    function readLineBreak2(state) {
      var ch;
      ch = state.input.charCodeAt(state.position);
      if (10 === ch) {
        state.position++;
      } else if (13 === ch) {
        state.position++;
        if (10 === state.input.charCodeAt(state.position)) {
          state.position++;
        }
      } else {
        throwError2(state, "a line break is expected");
      }
      state.line += 1;
      state.lineStart = state.position;
      state.lines.push({
        start: state.lineStart,
        line: state.line
      });
    }
    function positionToLine(state, position) {
      var line;
      for (var i2 = 0; i2 < state.lines.length; i2++) {
        if (state.lines[i2].start > position) {
          break;
        }
        line = state.lines[i2];
      }
      if (!line) {
        return {
          start: 0,
          line: 0
        };
      }
      return line;
    }
    function skipSeparationSpace2(state, allowComments, checkIndent) {
      var lineBreaks = 0, ch = state.input.charCodeAt(state.position);
      while (0 !== ch) {
        while (is_WHITE_SPACE2(ch)) {
          if (ch === 9) {
            state.errors.push(generateError2(state, "Using tabs can lead to unpredictable results", true));
          }
          ch = state.input.charCodeAt(++state.position);
        }
        if (allowComments && 35 === ch) {
          do {
            ch = state.input.charCodeAt(++state.position);
          } while (ch !== 10 && ch !== 13 && 0 !== ch);
        }
        if (is_EOL2(ch)) {
          readLineBreak2(state);
          ch = state.input.charCodeAt(state.position);
          lineBreaks++;
          state.lineIndent = 0;
          while (32 === ch) {
            state.lineIndent++;
            ch = state.input.charCodeAt(++state.position);
          }
        } else {
          break;
        }
      }
      if (-1 !== checkIndent && 0 !== lineBreaks && state.lineIndent < checkIndent) {
        throwWarning2(state, "deficient indentation");
      }
      return lineBreaks;
    }
    function testDocumentSeparator2(state) {
      var _position = state.position, ch;
      ch = state.input.charCodeAt(_position);
      if ((45 === ch || 46 === ch) && state.input.charCodeAt(_position + 1) === ch && state.input.charCodeAt(_position + 2) === ch) {
        _position += 3;
        ch = state.input.charCodeAt(_position);
        if (ch === 0 || is_WS_OR_EOL2(ch)) {
          return true;
        }
      }
      return false;
    }
    function writeFoldedLines2(state, scalar, count) {
      if (1 === count) {
        scalar.value += " ";
      } else if (count > 1) {
        scalar.value += common2.repeat("\n", count - 1);
      }
    }
    function readPlainScalar2(state, nodeIndent, withinFlowCollection) {
      var preceding, following, captureStart, captureEnd, hasPendingContent, _line, _lineStart, _lineIndent, _kind = state.kind, _result = state.result, ch;
      var state_result = ast.newScalar();
      state_result.plainScalar = true;
      state.result = state_result;
      ch = state.input.charCodeAt(state.position);
      if (is_WS_OR_EOL2(ch) || is_FLOW_INDICATOR2(ch) || 35 === ch || 38 === ch || 42 === ch || 33 === ch || 124 === ch || 62 === ch || 39 === ch || 34 === ch || 37 === ch || 64 === ch || 96 === ch) {
        return false;
      }
      if (63 === ch || 45 === ch) {
        following = state.input.charCodeAt(state.position + 1);
        if (is_WS_OR_EOL2(following) || withinFlowCollection && is_FLOW_INDICATOR2(following)) {
          return false;
        }
      }
      state.kind = "scalar";
      captureStart = captureEnd = state.position;
      hasPendingContent = false;
      while (0 !== ch) {
        if (58 === ch) {
          following = state.input.charCodeAt(state.position + 1);
          if (is_WS_OR_EOL2(following) || withinFlowCollection && is_FLOW_INDICATOR2(following)) {
            break;
          }
        } else if (35 === ch) {
          preceding = state.input.charCodeAt(state.position - 1);
          if (is_WS_OR_EOL2(preceding)) {
            break;
          }
        } else if (state.position === state.lineStart && testDocumentSeparator2(state) || withinFlowCollection && is_FLOW_INDICATOR2(ch)) {
          break;
        } else if (is_EOL2(ch)) {
          _line = state.line;
          _lineStart = state.lineStart;
          _lineIndent = state.lineIndent;
          skipSeparationSpace2(state, false, -1);
          if (state.lineIndent >= nodeIndent) {
            hasPendingContent = true;
            ch = state.input.charCodeAt(state.position);
            continue;
          } else {
            state.position = captureEnd;
            state.line = _line;
            state.lineStart = _lineStart;
            state.lineIndent = _lineIndent;
            break;
          }
        }
        if (hasPendingContent) {
          captureSegment2(state, captureStart, captureEnd, false);
          writeFoldedLines2(state, state_result, state.line - _line);
          captureStart = captureEnd = state.position;
          hasPendingContent = false;
        }
        if (!is_WHITE_SPACE2(ch)) {
          captureEnd = state.position + 1;
        }
        ch = state.input.charCodeAt(++state.position);
        if (state.position >= state.input.length) {
          return false;
        }
      }
      captureSegment2(state, captureStart, captureEnd, false);
      if (state.result.startPosition != -1) {
        state_result.rawValue = state.input.substring(state_result.startPosition, state_result.endPosition);
        return true;
      }
      state.kind = _kind;
      state.result = _result;
      return false;
    }
    function readSingleQuotedScalar2(state, nodeIndent) {
      var ch, captureStart, captureEnd;
      ch = state.input.charCodeAt(state.position);
      if (39 !== ch) {
        return false;
      }
      var scalar = ast.newScalar();
      scalar.singleQuoted = true;
      state.kind = "scalar";
      state.result = scalar;
      scalar.startPosition = state.position;
      state.position++;
      captureStart = captureEnd = state.position;
      while (0 !== (ch = state.input.charCodeAt(state.position))) {
        if (39 === ch) {
          captureSegment2(state, captureStart, state.position, true);
          ch = state.input.charCodeAt(++state.position);
          scalar.endPosition = state.position;
          if (39 === ch) {
            captureStart = captureEnd = state.position;
            state.position++;
          } else {
            return true;
          }
        } else if (is_EOL2(ch)) {
          captureSegment2(state, captureStart, captureEnd, true);
          writeFoldedLines2(state, scalar, skipSeparationSpace2(state, false, nodeIndent));
          captureStart = captureEnd = state.position;
        } else if (state.position === state.lineStart && testDocumentSeparator2(state)) {
          throwError2(state, "unexpected end of the document within a single quoted scalar");
        } else {
          state.position++;
          captureEnd = state.position;
          scalar.endPosition = state.position;
        }
      }
      throwError2(state, "unexpected end of the stream within a single quoted scalar");
    }
    function readDoubleQuotedScalar2(state, nodeIndent) {
      var captureStart, captureEnd, hexLength, hexResult, tmp, tmpEsc, ch;
      ch = state.input.charCodeAt(state.position);
      if (34 !== ch) {
        return false;
      }
      state.kind = "scalar";
      var scalar = ast.newScalar();
      scalar.doubleQuoted = true;
      state.result = scalar;
      scalar.startPosition = state.position;
      state.position++;
      captureStart = captureEnd = state.position;
      while (0 !== (ch = state.input.charCodeAt(state.position))) {
        if (34 === ch) {
          captureSegment2(state, captureStart, state.position, true);
          state.position++;
          scalar.endPosition = state.position;
          scalar.rawValue = state.input.substring(scalar.startPosition, scalar.endPosition);
          return true;
        } else if (92 === ch) {
          captureSegment2(state, captureStart, state.position, true);
          ch = state.input.charCodeAt(++state.position);
          if (is_EOL2(ch)) {
            skipSeparationSpace2(state, false, nodeIndent);
          } else if (ch < 256 && (state.allowAnyEscape ? customEscapeCheck[ch] : simpleEscapeCheck2[ch])) {
            scalar.value += state.allowAnyEscape ? customEscapeMap[ch] : simpleEscapeMap2[ch];
            state.position++;
          } else if ((tmp = escapedHexLen2(ch)) > 0) {
            hexLength = tmp;
            hexResult = 0;
            for (; hexLength > 0; hexLength--) {
              ch = state.input.charCodeAt(++state.position);
              if ((tmp = fromHexCode2(ch)) >= 0) {
                hexResult = (hexResult << 4) + tmp;
              } else {
                throwError2(state, "expected hexadecimal character");
              }
            }
            scalar.value += charFromCodepoint2(hexResult);
            state.position++;
          } else {
            throwError2(state, "unknown escape sequence");
          }
          captureStart = captureEnd = state.position;
        } else if (is_EOL2(ch)) {
          captureSegment2(state, captureStart, captureEnd, true);
          writeFoldedLines2(state, scalar, skipSeparationSpace2(state, false, nodeIndent));
          captureStart = captureEnd = state.position;
        } else if (state.position === state.lineStart && testDocumentSeparator2(state)) {
          throwError2(state, "unexpected end of the document within a double quoted scalar");
        } else {
          state.position++;
          captureEnd = state.position;
        }
      }
      throwError2(state, "unexpected end of the stream within a double quoted scalar");
    }
    function readFlowCollection2(state, nodeIndent) {
      var readNext = true, _line, _tag = state.tag, _result, _anchor = state.anchor, following, terminator, isPair, isExplicitPair, isMapping, keyNode, keyTag, valueNode, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch === 91) {
        terminator = 93;
        isMapping = false;
        _result = ast.newItems();
        _result.startPosition = state.position;
      } else if (ch === 123) {
        terminator = 125;
        isMapping = true;
        _result = ast.newMap();
        _result.startPosition = state.position;
      } else {
        return false;
      }
      if (null !== state.anchor) {
        _result.anchorId = state.anchor;
        state.anchorMap[state.anchor] = _result;
      }
      ch = state.input.charCodeAt(++state.position);
      while (0 !== ch) {
        skipSeparationSpace2(state, true, nodeIndent);
        ch = state.input.charCodeAt(state.position);
        if (ch === terminator) {
          state.position++;
          state.tag = _tag;
          state.anchor = _anchor;
          state.kind = isMapping ? "mapping" : "sequence";
          state.result = _result;
          _result.endPosition = state.position;
          return true;
        } else if (!readNext) {
          var p = state.position;
          throwError2(state, "missed comma between flow collection entries");
          state.position = p + 1;
        }
        keyTag = keyNode = valueNode = null;
        isPair = isExplicitPair = false;
        if (63 === ch) {
          following = state.input.charCodeAt(state.position + 1);
          if (is_WS_OR_EOL2(following)) {
            isPair = isExplicitPair = true;
            state.position++;
            skipSeparationSpace2(state, true, nodeIndent);
          }
        }
        _line = state.line;
        composeNode2(state, nodeIndent, CONTEXT_FLOW_IN2, false, true);
        keyTag = state.tag;
        keyNode = state.result;
        skipSeparationSpace2(state, true, nodeIndent);
        ch = state.input.charCodeAt(state.position);
        if ((isExplicitPair || state.line === _line) && 58 === ch) {
          isPair = true;
          ch = state.input.charCodeAt(++state.position);
          skipSeparationSpace2(state, true, nodeIndent);
          composeNode2(state, nodeIndent, CONTEXT_FLOW_IN2, false, true);
          valueNode = state.result;
        }
        if (isMapping) {
          storeMappingPair2(state, _result, keyTag, keyNode, valueNode);
        } else if (isPair) {
          var mp = storeMappingPair2(state, null, keyTag, keyNode, valueNode);
          mp.parent = _result;
          _result.items.push(mp);
        } else {
          if (keyNode) {
            keyNode.parent = _result;
          }
          _result.items.push(keyNode);
        }
        _result.endPosition = state.position + 1;
        skipSeparationSpace2(state, true, nodeIndent);
        ch = state.input.charCodeAt(state.position);
        if (44 === ch) {
          readNext = true;
          ch = state.input.charCodeAt(++state.position);
        } else {
          readNext = false;
        }
      }
      throwError2(state, "unexpected end of the stream within a flow collection");
    }
    function readBlockScalar2(state, nodeIndent) {
      var captureStart, folding, chomping = CHOMPING_CLIP2, detectedIndent = false, textIndent = nodeIndent, emptyLines = 0, atMoreIndented = false, tmp, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch === 124) {
        folding = false;
      } else if (ch === 62) {
        folding = true;
      } else {
        return false;
      }
      var sc = ast.newScalar();
      state.kind = "scalar";
      state.result = sc;
      sc.startPosition = state.position;
      while (0 !== ch) {
        ch = state.input.charCodeAt(++state.position);
        if (43 === ch || 45 === ch) {
          if (CHOMPING_CLIP2 === chomping) {
            chomping = 43 === ch ? CHOMPING_KEEP2 : CHOMPING_STRIP2;
          } else {
            throwError2(state, "repeat of a chomping mode identifier");
          }
        } else if ((tmp = fromDecimalCode2(ch)) >= 0) {
          if (tmp === 0) {
            throwError2(state, "bad explicit indentation width of a block scalar; it cannot be less than one");
          } else if (!detectedIndent) {
            textIndent = nodeIndent + tmp - 1;
            detectedIndent = true;
          } else {
            throwError2(state, "repeat of an indentation width identifier");
          }
        } else {
          break;
        }
      }
      if (is_WHITE_SPACE2(ch)) {
        do {
          ch = state.input.charCodeAt(++state.position);
        } while (is_WHITE_SPACE2(ch));
        if (35 === ch) {
          do {
            ch = state.input.charCodeAt(++state.position);
          } while (!is_EOL2(ch) && 0 !== ch);
        }
      }
      while (0 !== ch) {
        readLineBreak2(state);
        state.lineIndent = 0;
        ch = state.input.charCodeAt(state.position);
        while ((!detectedIndent || state.lineIndent < textIndent) && 32 === ch) {
          state.lineIndent++;
          ch = state.input.charCodeAt(++state.position);
        }
        if (!detectedIndent && state.lineIndent > textIndent) {
          textIndent = state.lineIndent;
        }
        if (is_EOL2(ch)) {
          emptyLines++;
          continue;
        }
        if (state.lineIndent < textIndent) {
          if (chomping === CHOMPING_KEEP2) {
            sc.value += common2.repeat("\n", emptyLines);
          } else if (chomping === CHOMPING_CLIP2) {
            if (detectedIndent) {
              sc.value += "\n";
            }
          }
          break;
        }
        if (folding) {
          if (is_WHITE_SPACE2(ch)) {
            atMoreIndented = true;
            sc.value += common2.repeat("\n", emptyLines + 1);
          } else if (atMoreIndented) {
            atMoreIndented = false;
            sc.value += common2.repeat("\n", emptyLines + 1);
          } else if (0 === emptyLines) {
            if (detectedIndent) {
              sc.value += " ";
            }
          } else {
            sc.value += common2.repeat("\n", emptyLines);
          }
        } else if (detectedIndent) {
          sc.value += common2.repeat("\n", emptyLines + 1);
        } else {
        }
        detectedIndent = true;
        emptyLines = 0;
        captureStart = state.position;
        while (!is_EOL2(ch) && 0 !== ch) {
          ch = state.input.charCodeAt(++state.position);
        }
        captureSegment2(state, captureStart, state.position, false);
      }
      sc.endPosition = state.position;
      var i2 = state.position - 1;
      var needMinus = false;
      while (true) {
        var c = state.input[i2];
        if (c == "\r" || c == "\n") {
          if (needMinus) {
            i2--;
          }
          break;
        }
        if (c != " " && c != "	") {
          break;
        }
        i2--;
      }
      sc.endPosition = i2;
      sc.rawValue = state.input.substring(sc.startPosition, sc.endPosition);
      return true;
    }
    function readBlockSequence2(state, nodeIndent) {
      var _line, _tag = state.tag, _anchor = state.anchor, _result = ast.newItems(), following, detected = false, ch;
      if (null !== state.anchor) {
        _result.anchorId = state.anchor;
        state.anchorMap[state.anchor] = _result;
      }
      _result.startPosition = state.position;
      ch = state.input.charCodeAt(state.position);
      while (0 !== ch) {
        if (45 !== ch) {
          break;
        }
        following = state.input.charCodeAt(state.position + 1);
        if (!is_WS_OR_EOL2(following)) {
          break;
        }
        detected = true;
        state.position++;
        if (skipSeparationSpace2(state, true, -1)) {
          if (state.lineIndent <= nodeIndent) {
            _result.items.push(null);
            ch = state.input.charCodeAt(state.position);
            continue;
          }
        }
        _line = state.line;
        composeNode2(state, nodeIndent, CONTEXT_BLOCK_IN2, false, true);
        if (state.result) {
          state.result.parent = _result;
          _result.items.push(state.result);
        }
        skipSeparationSpace2(state, true, -1);
        ch = state.input.charCodeAt(state.position);
        if ((state.line === _line || state.lineIndent > nodeIndent) && 0 !== ch) {
          throwError2(state, "bad indentation of a sequence entry");
        } else if (state.lineIndent < nodeIndent) {
          break;
        }
      }
      _result.endPosition = state.position;
      if (detected) {
        state.tag = _tag;
        state.anchor = _anchor;
        state.kind = "sequence";
        state.result = _result;
        _result.endPosition = state.position;
        return true;
      }
      return false;
    }
    function readBlockMapping2(state, nodeIndent, flowIndent) {
      var following, allowCompact, _line, _tag = state.tag, _anchor = state.anchor, _result = ast.newMap(), keyTag = null, keyNode = null, valueNode = null, atExplicitKey = false, detected = false, ch;
      _result.startPosition = state.position;
      if (null !== state.anchor) {
        _result.anchorId = state.anchor;
        state.anchorMap[state.anchor] = _result;
      }
      ch = state.input.charCodeAt(state.position);
      while (0 !== ch) {
        following = state.input.charCodeAt(state.position + 1);
        _line = state.line;
        if ((63 === ch || 58 === ch) && is_WS_OR_EOL2(following)) {
          if (63 === ch) {
            if (atExplicitKey) {
              storeMappingPair2(state, _result, keyTag, keyNode, null);
              keyTag = keyNode = valueNode = null;
            }
            detected = true;
            atExplicitKey = true;
            allowCompact = true;
          } else if (atExplicitKey) {
            atExplicitKey = false;
            allowCompact = true;
          } else {
            throwError2(state, "incomplete explicit mapping pair; a key node is missed");
          }
          state.position += 1;
          ch = following;
        } else if (composeNode2(state, flowIndent, CONTEXT_FLOW_OUT2, false, true)) {
          if (state.line === _line) {
            ch = state.input.charCodeAt(state.position);
            while (is_WHITE_SPACE2(ch)) {
              ch = state.input.charCodeAt(++state.position);
            }
            if (58 === ch) {
              ch = state.input.charCodeAt(++state.position);
              if (!is_WS_OR_EOL2(ch)) {
                throwError2(state, "a whitespace character is expected after the key-value separator within a block mapping");
              }
              if (atExplicitKey) {
                storeMappingPair2(state, _result, keyTag, keyNode, null);
                keyTag = keyNode = valueNode = null;
              }
              detected = true;
              atExplicitKey = false;
              allowCompact = false;
              keyTag = state.tag;
              keyNode = state.result;
            } else if (state.position == state.lineStart && testDocumentSeparator2(state)) {
              break;
            } else if (detected) {
              throwError2(state, "can not read an implicit mapping pair; a colon is missed");
            } else {
              state.tag = _tag;
              state.anchor = _anchor;
              return true;
            }
          } else if (detected) {
            throwError2(state, "can not read a block mapping entry; a multiline key may not be an implicit key");
            while (state.position > 0) {
              ch = state.input.charCodeAt(--state.position);
              if (is_EOL2(ch)) {
                state.position++;
                break;
              }
            }
          } else {
            state.tag = _tag;
            state.anchor = _anchor;
            return true;
          }
        } else {
          break;
        }
        if (state.line === _line || state.lineIndent > nodeIndent) {
          if (composeNode2(state, nodeIndent, CONTEXT_BLOCK_OUT2, true, allowCompact)) {
            if (atExplicitKey) {
              keyNode = state.result;
            } else {
              valueNode = state.result;
            }
          }
          if (!atExplicitKey) {
            storeMappingPair2(state, _result, keyTag, keyNode, valueNode);
            keyTag = keyNode = valueNode = null;
          }
          skipSeparationSpace2(state, true, -1);
          ch = state.input.charCodeAt(state.position);
        }
        if (state.lineIndent > nodeIndent && 0 !== ch) {
          throwError2(state, "bad indentation of a mapping entry");
        } else if (state.lineIndent < nodeIndent) {
          break;
        }
      }
      if (atExplicitKey) {
        storeMappingPair2(state, _result, keyTag, keyNode, null);
      }
      if (detected) {
        state.tag = _tag;
        state.anchor = _anchor;
        state.kind = "mapping";
        state.result = _result;
      }
      return detected;
    }
    function readTagProperty2(state) {
      var _position, isVerbatim = false, isNamed = false, tagHandle, tagName, ch;
      ch = state.input.charCodeAt(state.position);
      if (33 !== ch) {
        return false;
      }
      if (null !== state.tag) {
        throwError2(state, "duplication of a tag property");
      }
      ch = state.input.charCodeAt(++state.position);
      if (60 === ch) {
        isVerbatim = true;
        ch = state.input.charCodeAt(++state.position);
      } else if (33 === ch) {
        isNamed = true;
        tagHandle = "!!";
        ch = state.input.charCodeAt(++state.position);
      } else {
        tagHandle = "!";
      }
      _position = state.position;
      if (isVerbatim) {
        do {
          ch = state.input.charCodeAt(++state.position);
        } while (0 !== ch && 62 !== ch);
        if (state.position < state.length) {
          tagName = state.input.slice(_position, state.position);
          ch = state.input.charCodeAt(++state.position);
        } else {
          throwError2(state, "unexpected end of the stream within a verbatim tag");
        }
      } else {
        while (0 !== ch && !is_WS_OR_EOL2(ch)) {
          if (33 === ch) {
            if (!isNamed) {
              tagHandle = state.input.slice(_position - 1, state.position + 1);
              if (!PATTERN_TAG_HANDLE2.test(tagHandle)) {
                throwError2(state, "named tag handle cannot contain such characters");
              }
              isNamed = true;
              _position = state.position + 1;
            } else {
              throwError2(state, "tag suffix cannot contain exclamation marks");
            }
          }
          ch = state.input.charCodeAt(++state.position);
        }
        tagName = state.input.slice(_position, state.position);
        if (PATTERN_FLOW_INDICATORS2.test(tagName)) {
          throwError2(state, "tag suffix cannot contain flow indicator characters");
        }
      }
      if (tagName && !PATTERN_TAG_URI2.test(tagName)) {
        throwError2(state, "tag name cannot contain such characters: " + tagName);
      }
      if (isVerbatim) {
        state.tag = tagName;
      } else if (_hasOwnProperty2.call(state.tagMap, tagHandle)) {
        state.tag = state.tagMap[tagHandle] + tagName;
      } else if ("!" === tagHandle) {
        state.tag = "!" + tagName;
      } else if ("!!" === tagHandle) {
        state.tag = "tag:yaml.org,2002:" + tagName;
      } else {
        throwError2(state, 'undeclared tag handle "' + tagHandle + '"');
      }
      return true;
    }
    function readAnchorProperty2(state) {
      var _position, ch;
      ch = state.input.charCodeAt(state.position);
      if (38 !== ch) {
        return false;
      }
      if (null !== state.anchor) {
        throwError2(state, "duplication of an anchor property");
      }
      ch = state.input.charCodeAt(++state.position);
      _position = state.position;
      while (0 !== ch && !is_WS_OR_EOL2(ch) && !is_FLOW_INDICATOR2(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      if (state.position === _position) {
        throwError2(state, "name of an anchor node must contain at least one character");
      }
      state.anchor = state.input.slice(_position, state.position);
      return true;
    }
    function readAlias2(state) {
      var _position, alias, len = state.length, input = state.input, ch;
      ch = state.input.charCodeAt(state.position);
      if (42 !== ch) {
        return false;
      }
      ch = state.input.charCodeAt(++state.position);
      _position = state.position;
      while (0 !== ch && !is_WS_OR_EOL2(ch) && !is_FLOW_INDICATOR2(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      if (state.position <= _position) {
        throwError2(state, "name of an alias node must contain at least one character");
        state.position = _position + 1;
      }
      alias = state.input.slice(_position, state.position);
      if (!state.anchorMap.hasOwnProperty(alias)) {
        throwError2(state, 'unidentified alias "' + alias + '"');
        if (state.position <= _position) {
          state.position = _position + 1;
        }
      }
      state.result = ast.newAnchorRef(alias, _position, state.position, state.anchorMap[alias]);
      skipSeparationSpace2(state, true, -1);
      return true;
    }
    function composeNode2(state, parentIndent, nodeContext, allowToSeek, allowCompact) {
      var allowBlockStyles, allowBlockScalars, allowBlockCollections, indentStatus = 1, atNewLine = false, hasContent = false, typeIndex, typeQuantity, type2, flowIndent, blockIndent, _result;
      state.tag = null;
      state.anchor = null;
      state.kind = null;
      state.result = null;
      allowBlockStyles = allowBlockScalars = allowBlockCollections = CONTEXT_BLOCK_OUT2 === nodeContext || CONTEXT_BLOCK_IN2 === nodeContext;
      if (allowToSeek) {
        if (skipSeparationSpace2(state, true, -1)) {
          atNewLine = true;
          if (state.lineIndent > parentIndent) {
            indentStatus = 1;
          } else if (state.lineIndent === parentIndent) {
            indentStatus = 0;
          } else if (state.lineIndent < parentIndent) {
            indentStatus = -1;
          }
        }
      }
      var tagStart = state.position;
      var tagColumn = state.position - state.lineStart;
      if (1 === indentStatus) {
        while (readTagProperty2(state) || readAnchorProperty2(state)) {
          if (skipSeparationSpace2(state, true, -1)) {
            atNewLine = true;
            allowBlockCollections = allowBlockStyles;
            if (state.lineIndent > parentIndent) {
              indentStatus = 1;
            } else if (state.lineIndent === parentIndent) {
              indentStatus = 0;
            } else if (state.lineIndent < parentIndent) {
              indentStatus = -1;
            }
          } else {
            allowBlockCollections = false;
          }
        }
      }
      if (allowBlockCollections) {
        allowBlockCollections = atNewLine || allowCompact;
      }
      if (1 === indentStatus || CONTEXT_BLOCK_OUT2 === nodeContext) {
        if (CONTEXT_FLOW_IN2 === nodeContext || CONTEXT_FLOW_OUT2 === nodeContext) {
          flowIndent = parentIndent;
        } else {
          flowIndent = parentIndent + 1;
        }
        blockIndent = state.position - state.lineStart;
        if (1 === indentStatus) {
          if (allowBlockCollections && (readBlockSequence2(state, blockIndent) || readBlockMapping2(state, blockIndent, flowIndent)) || readFlowCollection2(state, flowIndent)) {
            hasContent = true;
          } else {
            if (allowBlockScalars && readBlockScalar2(state, flowIndent) || readSingleQuotedScalar2(state, flowIndent) || readDoubleQuotedScalar2(state, flowIndent)) {
              hasContent = true;
            } else if (readAlias2(state)) {
              hasContent = true;
              if (null !== state.tag || null !== state.anchor) {
                throwError2(state, "alias node should not have any properties");
              }
            } else if (readPlainScalar2(state, flowIndent, CONTEXT_FLOW_IN2 === nodeContext)) {
              hasContent = true;
              if (null === state.tag) {
                state.tag = "?";
              }
            }
            if (null !== state.anchor) {
              state.anchorMap[state.anchor] = state.result;
              state.result.anchorId = state.anchor;
            }
          }
        } else if (0 === indentStatus) {
          hasContent = allowBlockCollections && readBlockSequence2(state, blockIndent);
        }
      }
      if (null !== state.tag && "!" !== state.tag) {
        if (state.tag == "!include") {
          if (!state.result) {
            state.result = ast.newScalar();
            state.result.startPosition = state.position;
            state.result.endPosition = state.position;
            throwError2(state, "!include without value");
          }
          state.result.kind = ast.Kind.INCLUDE_REF;
        } else if ("?" === state.tag) {
          for (typeIndex = 0, typeQuantity = state.implicitTypes.length; typeIndex < typeQuantity; typeIndex += 1) {
            type2 = state.implicitTypes[typeIndex];
            var vl = state.result["value"];
            if (type2.resolve(vl)) {
              state.result.valueObject = type2.construct(state.result["value"]);
              state.tag = type2.tag;
              if (null !== state.anchor) {
                state.result.anchorId = state.anchor;
                state.anchorMap[state.anchor] = state.result;
              }
              break;
            }
          }
        } else if (_hasOwnProperty2.call(state.typeMap, state.tag)) {
          type2 = state.typeMap[state.tag];
          if (null !== state.result && type2.kind !== state.kind) {
            throwError2(state, "unacceptable node kind for !<" + state.tag + '> tag; it should be "' + type2.kind + '", not "' + state.kind + '"');
          }
          if (!type2.resolve(state.result)) {
            throwError2(state, "cannot resolve a node with !<" + state.tag + "> explicit tag");
          } else {
            state.result = type2.construct(state.result);
            if (null !== state.anchor) {
              state.result.anchorId = state.anchor;
              state.anchorMap[state.anchor] = state.result;
            }
          }
        } else {
          throwErrorFromPosition(state, tagStart, "unknown tag <" + state.tag + ">", false, true);
        }
      }
      return null !== state.tag || null !== state.anchor || hasContent;
    }
    function readDocument2(state) {
      var documentStart = state.position, _position, directiveName, directiveArgs, hasDirectives = false, ch;
      state.version = null;
      state.checkLineBreaks = state.legacy;
      state.tagMap = {};
      state.anchorMap = {};
      while (0 !== (ch = state.input.charCodeAt(state.position))) {
        skipSeparationSpace2(state, true, -1);
        ch = state.input.charCodeAt(state.position);
        if (state.lineIndent > 0 || 37 !== ch) {
          break;
        }
        hasDirectives = true;
        ch = state.input.charCodeAt(++state.position);
        _position = state.position;
        while (0 !== ch && !is_WS_OR_EOL2(ch)) {
          ch = state.input.charCodeAt(++state.position);
        }
        directiveName = state.input.slice(_position, state.position);
        directiveArgs = [];
        if (directiveName.length < 1) {
          throwError2(state, "directive name must not be less than one character in length");
        }
        while (0 !== ch) {
          while (is_WHITE_SPACE2(ch)) {
            ch = state.input.charCodeAt(++state.position);
          }
          if (35 === ch) {
            do {
              ch = state.input.charCodeAt(++state.position);
            } while (0 !== ch && !is_EOL2(ch));
            break;
          }
          if (is_EOL2(ch)) {
            break;
          }
          _position = state.position;
          while (0 !== ch && !is_WS_OR_EOL2(ch)) {
            ch = state.input.charCodeAt(++state.position);
          }
          directiveArgs.push(state.input.slice(_position, state.position));
        }
        if (0 !== ch) {
          readLineBreak2(state);
        }
        if (_hasOwnProperty2.call(directiveHandlers2, directiveName)) {
          directiveHandlers2[directiveName](state, directiveName, directiveArgs);
        } else {
          throwWarning2(state, 'unknown document directive "' + directiveName + '"');
          state.position++;
        }
      }
      skipSeparationSpace2(state, true, -1);
      if (0 === state.lineIndent && 45 === state.input.charCodeAt(state.position) && 45 === state.input.charCodeAt(state.position + 1) && 45 === state.input.charCodeAt(state.position + 2)) {
        state.position += 3;
        skipSeparationSpace2(state, true, -1);
      } else if (hasDirectives) {
        throwError2(state, "directives end mark is expected");
      }
      composeNode2(state, state.lineIndent - 1, CONTEXT_BLOCK_OUT2, false, true);
      skipSeparationSpace2(state, true, -1);
      if (state.checkLineBreaks && PATTERN_NON_ASCII_LINE_BREAKS2.test(state.input.slice(documentStart, state.position))) {
        throwWarning2(state, "non-ASCII line breaks are interpreted as content");
      }
      state.documents.push(state.result);
      if (state.position === state.lineStart && testDocumentSeparator2(state)) {
        if (46 === state.input.charCodeAt(state.position)) {
          state.position += 3;
          skipSeparationSpace2(state, true, -1);
        }
        return;
      }
      if (state.position < state.length - 1) {
        throwError2(state, "end of the stream or a document separator is expected");
      } else {
        return;
      }
    }
    function loadDocuments2(input, options) {
      input = String(input);
      options = options || {};
      var inputLength = input.length;
      if (inputLength !== 0) {
        if (10 !== input.charCodeAt(inputLength - 1) && 13 !== input.charCodeAt(inputLength - 1)) {
          input += "\n";
        }
        if (input.charCodeAt(0) === 65279) {
          input = input.slice(1);
        }
      }
      var state = new State3(input, options);
      state.input += "\0";
      while (32 === state.input.charCodeAt(state.position)) {
        state.lineIndent += 1;
        state.position += 1;
      }
      while (state.position < state.length - 1) {
        var q = state.position;
        readDocument2(state);
        if (state.position <= q) {
          for (; state.position < state.length - 1; state.position++) {
            var c = state.input.charAt(state.position);
            if (c == "\n") {
              break;
            }
          }
        }
      }
      var documents = state.documents;
      var docsCount = documents.length;
      if (docsCount > 0) {
        documents[docsCount - 1].endPosition = inputLength;
      }
      for (var _i = 0, documents_1 = documents; _i < documents_1.length; _i++) {
        var x = documents_1[_i];
        x.errors = state.errors;
        if (x.startPosition > x.endPosition) {
          x.startPosition = x.endPosition;
        }
      }
      return documents;
    }
    function loadAll2(input, iterator, options) {
      if (options === void 0) {
        options = {};
      }
      var documents = loadDocuments2(input, options), index, length;
      for (index = 0, length = documents.length; index < length; index += 1) {
        iterator(documents[index]);
      }
    }
    exports2.loadAll = loadAll2;
    function load2(input, options) {
      if (options === void 0) {
        options = {};
      }
      var documents = loadDocuments2(input, options), index, length;
      if (0 === documents.length) {
        return void 0;
      } else if (1 === documents.length) {
        return documents[0];
      }
      var e = new YAMLException2("expected a single document in the stream, but found more");
      e.mark = new Mark("", "", 0, 0, 0);
      e.mark.position = documents[0].endPosition;
      documents[0].errors.push(e);
      return documents[0];
    }
    exports2.load = load2;
    function safeLoadAll2(input, output, options) {
      if (options === void 0) {
        options = {};
      }
      loadAll2(input, output, common2.extend({ schema: DEFAULT_SAFE_SCHEMA }, options));
    }
    exports2.safeLoadAll = safeLoadAll2;
    function safeLoad2(input, options) {
      if (options === void 0) {
        options = {};
      }
      return load2(input, common2.extend({ schema: DEFAULT_SAFE_SCHEMA }, options));
    }
    exports2.safeLoad = safeLoad2;
    module2.exports.loadAll = loadAll2;
    module2.exports.load = load2;
    module2.exports.safeLoadAll = safeLoadAll2;
    module2.exports.safeLoad = safeLoad2;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/dumper.js
var require_dumper2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/dumper.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var common2 = require_common2();
    var YAMLException2 = require_exception2();
    var DEFAULT_FULL_SCHEMA = require_default_full();
    var DEFAULT_SAFE_SCHEMA = require_default_safe();
    var _toString2 = Object.prototype.toString;
    var _hasOwnProperty2 = Object.prototype.hasOwnProperty;
    var CHAR_TAB2 = 9;
    var CHAR_LINE_FEED2 = 10;
    var CHAR_CARRIAGE_RETURN2 = 13;
    var CHAR_SPACE2 = 32;
    var CHAR_EXCLAMATION2 = 33;
    var CHAR_DOUBLE_QUOTE2 = 34;
    var CHAR_SHARP2 = 35;
    var CHAR_PERCENT2 = 37;
    var CHAR_AMPERSAND2 = 38;
    var CHAR_SINGLE_QUOTE2 = 39;
    var CHAR_ASTERISK2 = 42;
    var CHAR_COMMA2 = 44;
    var CHAR_MINUS2 = 45;
    var CHAR_COLON2 = 58;
    var CHAR_GREATER_THAN2 = 62;
    var CHAR_QUESTION2 = 63;
    var CHAR_COMMERCIAL_AT2 = 64;
    var CHAR_LEFT_SQUARE_BRACKET2 = 91;
    var CHAR_RIGHT_SQUARE_BRACKET2 = 93;
    var CHAR_GRAVE_ACCENT2 = 96;
    var CHAR_LEFT_CURLY_BRACKET2 = 123;
    var CHAR_VERTICAL_LINE2 = 124;
    var CHAR_RIGHT_CURLY_BRACKET2 = 125;
    var ESCAPE_SEQUENCES2 = {};
    ESCAPE_SEQUENCES2[0] = "\\0";
    ESCAPE_SEQUENCES2[7] = "\\a";
    ESCAPE_SEQUENCES2[8] = "\\b";
    ESCAPE_SEQUENCES2[9] = "\\t";
    ESCAPE_SEQUENCES2[10] = "\\n";
    ESCAPE_SEQUENCES2[11] = "\\v";
    ESCAPE_SEQUENCES2[12] = "\\f";
    ESCAPE_SEQUENCES2[13] = "\\r";
    ESCAPE_SEQUENCES2[27] = "\\e";
    ESCAPE_SEQUENCES2[34] = '\\"';
    ESCAPE_SEQUENCES2[92] = "\\\\";
    ESCAPE_SEQUENCES2[133] = "\\N";
    ESCAPE_SEQUENCES2[160] = "\\_";
    ESCAPE_SEQUENCES2[8232] = "\\L";
    ESCAPE_SEQUENCES2[8233] = "\\P";
    var DEPRECATED_BOOLEANS_SYNTAX2 = [
      "y",
      "Y",
      "yes",
      "Yes",
      "YES",
      "on",
      "On",
      "ON",
      "n",
      "N",
      "no",
      "No",
      "NO",
      "off",
      "Off",
      "OFF"
    ];
    function compileStyleMap2(schema2, map2) {
      var result, keys5, index, length, tag, style, type2;
      if (null === map2) {
        return {};
      }
      result = {};
      keys5 = Object.keys(map2);
      for (index = 0, length = keys5.length; index < length; index += 1) {
        tag = keys5[index];
        style = String(map2[tag]);
        if ("!!" === tag.slice(0, 2)) {
          tag = "tag:yaml.org,2002:" + tag.slice(2);
        }
        type2 = schema2.compiledTypeMap[tag];
        if (type2 && _hasOwnProperty2.call(type2.styleAliases, style)) {
          style = type2.styleAliases[style];
        }
        result[tag] = style;
      }
      return result;
    }
    function encodeHex2(character) {
      var string3, handle, length;
      string3 = character.toString(16).toUpperCase();
      if (character <= 255) {
        handle = "x";
        length = 2;
      } else if (character <= 65535) {
        handle = "u";
        length = 4;
      } else if (character <= 4294967295) {
        handle = "U";
        length = 8;
      } else {
        throw new YAMLException2("code point within a string may not be greater than 0xFFFFFFFF");
      }
      return "\\" + handle + common2.repeat("0", length - string3.length) + string3;
    }
    function State3(options) {
      this.schema = options["schema"] || DEFAULT_FULL_SCHEMA;
      this.indent = Math.max(1, options["indent"] || 2);
      this.skipInvalid = options["skipInvalid"] || false;
      this.flowLevel = common2.isNothing(options["flowLevel"]) ? -1 : options["flowLevel"];
      this.styleMap = compileStyleMap2(this.schema, options["styles"] || null);
      this.implicitTypes = this.schema.compiledImplicit;
      this.explicitTypes = this.schema.compiledExplicit;
      this.tag = null;
      this.result = "";
      this.duplicates = [];
      this.usedDuplicates = null;
    }
    function indentString2(string3, spaces) {
      var ind = common2.repeat(" ", spaces), position = 0, next = -1, result = "", line, length = string3.length;
      while (position < length) {
        next = string3.indexOf("\n", position);
        if (next === -1) {
          line = string3.slice(position);
          position = length;
        } else {
          line = string3.slice(position, next + 1);
          position = next + 1;
        }
        if (line.length && line !== "\n") {
          result += ind;
        }
        result += line;
      }
      return result;
    }
    function generateNextLine2(state, level) {
      return "\n" + common2.repeat(" ", state.indent * level);
    }
    function testImplicitResolving2(state, str2) {
      var index, length, type2;
      for (index = 0, length = state.implicitTypes.length; index < length; index += 1) {
        type2 = state.implicitTypes[index];
        if (type2.resolve(str2)) {
          return true;
        }
      }
      return false;
    }
    function StringBuilder(source) {
      this.source = source;
      this.result = "";
      this.checkpoint = 0;
    }
    StringBuilder.prototype.takeUpTo = function(position) {
      var er;
      if (position < this.checkpoint) {
        er = new Error("position should be > checkpoint");
        er.position = position;
        er.checkpoint = this.checkpoint;
        throw er;
      }
      this.result += this.source.slice(this.checkpoint, position);
      this.checkpoint = position;
      return this;
    };
    StringBuilder.prototype.escapeChar = function() {
      var character, esc;
      character = this.source.charCodeAt(this.checkpoint);
      esc = ESCAPE_SEQUENCES2[character] || encodeHex2(character);
      this.result += esc;
      this.checkpoint += 1;
      return this;
    };
    StringBuilder.prototype.finish = function() {
      if (this.source.length > this.checkpoint) {
        this.takeUpTo(this.source.length);
      }
    };
    function writeScalar2(state, object3, level) {
      var simple, first, spaceWrap, folded, literal, single, double, sawLineFeed, linePosition, longestLine, indent, max, character, position, escapeSeq, hexEsc, previous, lineLength, modifier, trailingLineBreaks, result;
      if (0 === object3.length) {
        state.dump = "''";
        return;
      }
      if (object3.indexOf("!include") == 0) {
        state.dump = "" + object3;
        return;
      }
      if (object3.indexOf("!$$$novalue") == 0) {
        state.dump = "";
        return;
      }
      if (-1 !== DEPRECATED_BOOLEANS_SYNTAX2.indexOf(object3)) {
        state.dump = "'" + object3 + "'";
        return;
      }
      simple = true;
      first = object3.length ? object3.charCodeAt(0) : 0;
      spaceWrap = CHAR_SPACE2 === first || CHAR_SPACE2 === object3.charCodeAt(object3.length - 1);
      if (CHAR_MINUS2 === first || CHAR_QUESTION2 === first || CHAR_COMMERCIAL_AT2 === first || CHAR_GRAVE_ACCENT2 === first) {
        simple = false;
      }
      if (spaceWrap) {
        simple = false;
        folded = false;
        literal = false;
      } else {
        folded = true;
        literal = true;
      }
      single = true;
      double = new StringBuilder(object3);
      sawLineFeed = false;
      linePosition = 0;
      longestLine = 0;
      indent = state.indent * level;
      max = 80;
      if (indent < 40) {
        max -= indent;
      } else {
        max = 40;
      }
      for (position = 0; position < object3.length; position++) {
        character = object3.charCodeAt(position);
        if (simple) {
          if (!simpleChar(character)) {
            simple = false;
          } else {
            continue;
          }
        }
        if (single && character === CHAR_SINGLE_QUOTE2) {
          single = false;
        }
        escapeSeq = ESCAPE_SEQUENCES2[character];
        hexEsc = needsHexEscape(character);
        if (!escapeSeq && !hexEsc) {
          continue;
        }
        if (character !== CHAR_LINE_FEED2 && character !== CHAR_DOUBLE_QUOTE2 && character !== CHAR_SINGLE_QUOTE2) {
          folded = false;
          literal = false;
        } else if (character === CHAR_LINE_FEED2) {
          sawLineFeed = true;
          single = false;
          if (position > 0) {
            previous = object3.charCodeAt(position - 1);
            if (previous === CHAR_SPACE2) {
              literal = false;
              folded = false;
            }
          }
          if (folded) {
            lineLength = position - linePosition;
            linePosition = position;
            if (lineLength > longestLine) {
              longestLine = lineLength;
            }
          }
        }
        if (character !== CHAR_DOUBLE_QUOTE2) {
          single = false;
        }
        double.takeUpTo(position);
        double.escapeChar();
      }
      if (simple && testImplicitResolving2(state, object3)) {
        simple = false;
      }
      modifier = "";
      if (folded || literal) {
        trailingLineBreaks = 0;
        if (object3.charCodeAt(object3.length - 1) === CHAR_LINE_FEED2) {
          trailingLineBreaks += 1;
          if (object3.charCodeAt(object3.length - 2) === CHAR_LINE_FEED2) {
            trailingLineBreaks += 1;
          }
        }
        if (trailingLineBreaks === 0) {
          modifier = "-";
        } else if (trailingLineBreaks === 2) {
          modifier = "+";
        }
      }
      if (literal && longestLine < max) {
        folded = false;
      }
      if (!sawLineFeed) {
        literal = false;
      }
      if (simple) {
        state.dump = object3;
      } else if (single) {
        state.dump = "'" + object3 + "'";
      } else if (folded) {
        result = fold(object3, max);
        state.dump = ">" + modifier + "\n" + indentString2(result, indent);
      } else if (literal) {
        if (!modifier) {
          object3 = object3.replace(/\n$/, "");
        }
        state.dump = "|" + modifier + "\n" + indentString2(object3, indent);
      } else if (double) {
        double.finish();
        state.dump = '"' + double.result + '"';
      } else {
        throw new Error("Failed to dump scalar value");
      }
      return;
    }
    function fold(object3, max) {
      var result = "", position = 0, length = object3.length, trailing = /\n+$/.exec(object3), newLine;
      if (trailing) {
        length = trailing.index + 1;
      }
      while (position < length) {
        newLine = object3.indexOf("\n", position);
        if (newLine > length || newLine === -1) {
          if (result) {
            result += "\n\n";
          }
          result += foldLine2(object3.slice(position, length), max);
          position = length;
        } else {
          if (result) {
            result += "\n\n";
          }
          result += foldLine2(object3.slice(position, newLine), max);
          position = newLine + 1;
        }
      }
      if (trailing && trailing[0] !== "\n") {
        result += trailing[0];
      }
      return result;
    }
    function foldLine2(line, max) {
      if (line === "") {
        return line;
      }
      var foldRe = /[^\s] [^\s]/g, result = "", prevMatch = 0, foldStart = 0, match = foldRe.exec(line), index, foldEnd, folded;
      while (match) {
        index = match.index;
        if (index - foldStart > max) {
          if (prevMatch !== foldStart) {
            foldEnd = prevMatch;
          } else {
            foldEnd = index;
          }
          if (result) {
            result += "\n";
          }
          folded = line.slice(foldStart, foldEnd);
          result += folded;
          foldStart = foldEnd + 1;
        }
        prevMatch = index + 1;
        match = foldRe.exec(line);
      }
      if (result) {
        result += "\n";
      }
      if (foldStart !== prevMatch && line.length - foldStart > max) {
        result += line.slice(foldStart, prevMatch) + "\n" + line.slice(prevMatch + 1);
      } else {
        result += line.slice(foldStart);
      }
      return result;
    }
    function simpleChar(character) {
      return CHAR_TAB2 !== character && CHAR_LINE_FEED2 !== character && CHAR_CARRIAGE_RETURN2 !== character && CHAR_COMMA2 !== character && CHAR_LEFT_SQUARE_BRACKET2 !== character && CHAR_RIGHT_SQUARE_BRACKET2 !== character && CHAR_LEFT_CURLY_BRACKET2 !== character && CHAR_RIGHT_CURLY_BRACKET2 !== character && CHAR_SHARP2 !== character && CHAR_AMPERSAND2 !== character && CHAR_ASTERISK2 !== character && CHAR_EXCLAMATION2 !== character && CHAR_VERTICAL_LINE2 !== character && CHAR_GREATER_THAN2 !== character && CHAR_SINGLE_QUOTE2 !== character && CHAR_DOUBLE_QUOTE2 !== character && CHAR_PERCENT2 !== character && CHAR_COLON2 !== character && !ESCAPE_SEQUENCES2[character] && !needsHexEscape(character);
    }
    function needsHexEscape(character) {
      return !(32 <= character && character <= 126 || 133 === character || 160 <= character && character <= 55295 || 57344 <= character && character <= 65533 || 65536 <= character && character <= 1114111);
    }
    function writeFlowSequence2(state, level, object3) {
      var _result = "", _tag = state.tag, index, length;
      for (index = 0, length = object3.length; index < length; index += 1) {
        if (writeNode2(state, level, object3[index], false, false)) {
          if (0 !== index) {
            _result += ", ";
          }
          _result += state.dump;
        }
      }
      state.tag = _tag;
      state.dump = "[" + _result + "]";
    }
    function writeBlockSequence2(state, level, object3, compact2) {
      var _result = "", _tag = state.tag, index, length;
      for (index = 0, length = object3.length; index < length; index += 1) {
        if (writeNode2(state, level + 1, object3[index], true, true)) {
          if (!compact2 || 0 !== index) {
            _result += generateNextLine2(state, level);
          }
          _result += "- " + state.dump;
        }
      }
      state.tag = _tag;
      state.dump = _result || "[]";
    }
    function writeFlowMapping2(state, level, object3) {
      var _result = "", _tag = state.tag, objectKeyList = Object.keys(object3), index, length, objectKey, objectValue, pairBuffer;
      for (index = 0, length = objectKeyList.length; index < length; index += 1) {
        pairBuffer = "";
        if (0 !== index) {
          pairBuffer += ", ";
        }
        objectKey = objectKeyList[index];
        objectValue = object3[objectKey];
        if (!writeNode2(state, level, objectKey, false, false)) {
          continue;
        }
        if (state.dump.length > 1024) {
          pairBuffer += "? ";
        }
        pairBuffer += state.dump + ": ";
        if (!writeNode2(state, level, objectValue, false, false)) {
          continue;
        }
        pairBuffer += state.dump;
        _result += pairBuffer;
      }
      state.tag = _tag;
      state.dump = "{" + _result + "}";
    }
    function writeBlockMapping2(state, level, object3, compact2) {
      var _result = "", _tag = state.tag, objectKeyList = Object.keys(object3), index, length, objectKey, objectValue, explicitPair, pairBuffer;
      for (index = 0, length = objectKeyList.length; index < length; index += 1) {
        pairBuffer = "";
        if (!compact2 || 0 !== index) {
          pairBuffer += generateNextLine2(state, level);
        }
        objectKey = objectKeyList[index];
        objectValue = object3[objectKey];
        if (!writeNode2(state, level + 1, objectKey, true, true)) {
          continue;
        }
        explicitPair = null !== state.tag && "?" !== state.tag || state.dump && state.dump.length > 1024;
        if (explicitPair) {
          if (state.dump && CHAR_LINE_FEED2 === state.dump.charCodeAt(0)) {
            pairBuffer += "?";
          } else {
            pairBuffer += "? ";
          }
        }
        pairBuffer += state.dump;
        if (explicitPair) {
          pairBuffer += generateNextLine2(state, level);
        }
        if (!writeNode2(state, level + 1, objectValue, true, explicitPair)) {
          continue;
        }
        if (state.dump && CHAR_LINE_FEED2 === state.dump.charCodeAt(0)) {
          pairBuffer += ":";
        } else {
          pairBuffer += ": ";
        }
        pairBuffer += state.dump;
        _result += pairBuffer;
      }
      state.tag = _tag;
      state.dump = _result || "{}";
    }
    function detectType2(state, object3, explicit) {
      var _result, typeList, index, length, type2, style;
      typeList = explicit ? state.explicitTypes : state.implicitTypes;
      for (index = 0, length = typeList.length; index < length; index += 1) {
        type2 = typeList[index];
        if ((type2.instanceOf || type2.predicate) && (!type2.instanceOf || "object" === typeof object3 && object3 instanceof type2.instanceOf) && (!type2.predicate || type2.predicate(object3))) {
          state.tag = explicit ? type2.tag : "?";
          if (type2.represent) {
            style = state.styleMap[type2.tag] || type2.defaultStyle;
            if ("[object Function]" === _toString2.call(type2.represent)) {
              _result = type2.represent(object3, style);
            } else if (_hasOwnProperty2.call(type2.represent, style)) {
              _result = type2.represent[style](object3, style);
            } else {
              throw new YAMLException2("!<" + type2.tag + '> tag resolver accepts not "' + style + '" style');
            }
            state.dump = _result;
          }
          return true;
        }
      }
      return false;
    }
    function writeNode2(state, level, object3, block, compact2) {
      state.tag = null;
      state.dump = object3;
      if (!detectType2(state, object3, false)) {
        detectType2(state, object3, true);
      }
      var type2 = _toString2.call(state.dump);
      if (block) {
        block = 0 > state.flowLevel || state.flowLevel > level;
      }
      if (null !== state.tag && "?" !== state.tag || 2 !== state.indent && level > 0) {
        compact2 = false;
      }
      var objectOrArray = "[object Object]" === type2 || "[object Array]" === type2, duplicateIndex, duplicate;
      if (objectOrArray) {
        duplicateIndex = state.duplicates.indexOf(object3);
        duplicate = duplicateIndex !== -1;
      }
      if (duplicate && state.usedDuplicates[duplicateIndex]) {
        state.dump = "*ref_" + duplicateIndex;
      } else {
        if (objectOrArray && duplicate && !state.usedDuplicates[duplicateIndex]) {
          state.usedDuplicates[duplicateIndex] = true;
        }
        if ("[object Object]" === type2) {
          if (block && 0 !== Object.keys(state.dump).length) {
            writeBlockMapping2(state, level, state.dump, compact2);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + (0 === level ? "\n" : "") + state.dump;
            }
          } else {
            writeFlowMapping2(state, level, state.dump);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + " " + state.dump;
            }
          }
        } else if ("[object Array]" === type2) {
          if (block && 0 !== state.dump.length) {
            writeBlockSequence2(state, level, state.dump, compact2);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + (0 === level ? "\n" : "") + state.dump;
            }
          } else {
            writeFlowSequence2(state, level, state.dump);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + " " + state.dump;
            }
          }
        } else if ("[object String]" === type2) {
          if ("?" !== state.tag) {
            writeScalar2(state, state.dump, level);
          }
        } else {
          if (state.skipInvalid) {
            return false;
          }
          throw new YAMLException2("unacceptable kind of an object to dump " + type2);
        }
        if (null !== state.tag && "?" !== state.tag) {
          state.dump = "!<" + state.tag + "> " + state.dump;
        }
      }
      return true;
    }
    function getDuplicateReferences2(object3, state) {
      var objects = [], duplicatesIndexes = [], index, length;
      inspectNode2(object3, objects, duplicatesIndexes);
      for (index = 0, length = duplicatesIndexes.length; index < length; index += 1) {
        state.duplicates.push(objects[duplicatesIndexes[index]]);
      }
      state.usedDuplicates = new Array(length);
    }
    function inspectNode2(object3, objects, duplicatesIndexes) {
      var type2 = _toString2.call(object3), objectKeyList, index, length;
      if (null !== object3 && "object" === typeof object3) {
        index = objects.indexOf(object3);
        if (-1 !== index) {
          if (-1 === duplicatesIndexes.indexOf(index)) {
            duplicatesIndexes.push(index);
          }
        } else {
          objects.push(object3);
          if (Array.isArray(object3)) {
            for (index = 0, length = object3.length; index < length; index += 1) {
              inspectNode2(object3[index], objects, duplicatesIndexes);
            }
          } else {
            objectKeyList = Object.keys(object3);
            for (index = 0, length = objectKeyList.length; index < length; index += 1) {
              inspectNode2(object3[objectKeyList[index]], objects, duplicatesIndexes);
            }
          }
        }
      }
    }
    function dump2(input, options) {
      options = options || {};
      var state = new State3(options);
      getDuplicateReferences2(input, state);
      if (writeNode2(state, 0, input, true, true)) {
        return state.dump + "\n";
      }
      return "";
    }
    exports2.dump = dump2;
    function safeDump2(input, options) {
      return dump2(input, common2.extend({ schema: DEFAULT_SAFE_SCHEMA }, options));
    }
    exports2.safeDump = safeDump2;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/scalarInference.js
var require_scalarInference = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/scalarInference.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    function parseYamlBoolean(input) {
      if (["true", "True", "TRUE"].lastIndexOf(input) >= 0) {
        return true;
      } else if (["false", "False", "FALSE"].lastIndexOf(input) >= 0) {
        return false;
      }
      throw 'Invalid boolean "' + input + '"';
    }
    exports2.parseYamlBoolean = parseYamlBoolean;
    function safeParseYamlInteger(input) {
      if (input.lastIndexOf("0o", 0) === 0) {
        return parseInt(input.substring(2), 8);
      }
      return parseInt(input);
    }
    function parseYamlInteger(input) {
      var result = safeParseYamlInteger(input);
      if (isNaN(result)) {
        throw 'Invalid integer "' + input + '"';
      }
      return result;
    }
    exports2.parseYamlInteger = parseYamlInteger;
    function parseYamlFloat(input) {
      if ([".nan", ".NaN", ".NAN"].lastIndexOf(input) >= 0) {
        return NaN;
      }
      var infinity = /^([-+])?(?:\.inf|\.Inf|\.INF)$/;
      var match = infinity.exec(input);
      if (match) {
        return match[1] === "-" ? -Infinity : Infinity;
      }
      var result = parseFloat(input);
      if (!isNaN(result)) {
        return result;
      }
      throw 'Invalid float "' + input + '"';
    }
    exports2.parseYamlFloat = parseYamlFloat;
    var ScalarType;
    (function(ScalarType2) {
      ScalarType2[ScalarType2["null"] = 0] = "null";
      ScalarType2[ScalarType2["bool"] = 1] = "bool";
      ScalarType2[ScalarType2["int"] = 2] = "int";
      ScalarType2[ScalarType2["float"] = 3] = "float";
      ScalarType2[ScalarType2["string"] = 4] = "string";
    })(ScalarType = exports2.ScalarType || (exports2.ScalarType = {}));
    function determineScalarType(node) {
      if (node === void 0) {
        return ScalarType.null;
      }
      if (node.doubleQuoted || !node.plainScalar || node["singleQuoted"]) {
        return ScalarType.string;
      }
      var value = node.value;
      if (["null", "Null", "NULL", "~", ""].indexOf(value) >= 0) {
        return ScalarType.null;
      }
      if (value === null || value === void 0) {
        return ScalarType.null;
      }
      if (["true", "True", "TRUE", "false", "False", "FALSE"].indexOf(value) >= 0) {
        return ScalarType.bool;
      }
      var base10 = /^[-+]?[0-9]+$/;
      var base8 = /^0o[0-7]+$/;
      var base16 = /^0x[0-9a-fA-F]+$/;
      if (base10.test(value) || base8.test(value) || base16.test(value)) {
        return ScalarType.int;
      }
      var float2 = /^[-+]?(\.[0-9]+|[0-9]+(\.[0-9]*)?)([eE][-+]?[0-9]+)?$/;
      var infinity = /^[-+]?(\.inf|\.Inf|\.INF)$/;
      if (float2.test(value) || infinity.test(value) || [".nan", ".NaN", ".NAN"].indexOf(value) >= 0) {
        return ScalarType.float;
      }
      return ScalarType.string;
    }
    exports2.determineScalarType = determineScalarType;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/index.js
var require_src = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/index.js"(exports2) {
    "use strict";
    function __export2(m) {
      for (var p in m) if (!exports2.hasOwnProperty(p)) exports2[p] = m[p];
    }
    Object.defineProperty(exports2, "__esModule", { value: true });
    var loader_1 = require_loader2();
    exports2.load = loader_1.load;
    exports2.loadAll = loader_1.loadAll;
    exports2.safeLoad = loader_1.safeLoad;
    exports2.safeLoadAll = loader_1.safeLoadAll;
    var dumper_1 = require_dumper2();
    exports2.dump = dumper_1.dump;
    exports2.safeDump = dumper_1.safeDump;
    exports2.YAMLException = require_exception2();
    __export2(require_yamlAST());
    __export2(require_scalarInference());
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/format/codeframes.js
var require_codeframes = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/format/codeframes.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getAstNodeByPointer = exports2.getLineColLocation = exports2.getCodeframe = void 0;
    var yamlAst = require_src();
    var ref_utils_1 = require_ref_utils();
    var logger_1 = require_logger();
    var MAX_LINE_LENGTH = 150;
    var MAX_CODEFRAME_LINES = 3;
    function parsePointer(pointer) {
      return pointer.substr(2).split("/").map(ref_utils_1.unescapePointer);
    }
    function getCodeframe(location, color) {
      logger_1.colorOptions.enabled = color;
      const { start, end = { line: start.line, col: start.col + 1 }, source } = location;
      const lines = source.getLines();
      const startLineNum = start.line;
      const endLineNum = Math.max(Math.min(end.line, lines.length), start.line);
      let skipLines = Math.max(endLineNum - startLineNum - MAX_CODEFRAME_LINES + 1, 0);
      if (skipLines < 2)
        skipLines = 0;
      const prefixedLines = [];
      let currentPad = 0;
      for (let i = startLineNum; i <= endLineNum; i++) {
        if (skipLines > 0 && i >= endLineNum - skipLines)
          break;
        const line = lines[i - 1] || "";
        if (line !== "")
          currentPad = padSize(line);
        const startIdx = i === startLineNum ? start.col - 1 : currentPad;
        const endIdx = i === endLineNum ? end.col - 1 : line.length;
        prefixedLines.push([`${i}`, markLine(line, startIdx, endIdx, logger_1.colorize.red)]);
        if (!color)
          prefixedLines.push(["", underlineLine(line, startIdx, endIdx)]);
      }
      if (skipLines > 0) {
        prefixedLines.push([
          `\u2026`,
          `${whitespace(currentPad)}${logger_1.colorize.gray(`< ${skipLines} more lines >`)}`
        ]);
        prefixedLines.push([
          `${endLineNum}`,
          markLine(lines[endLineNum - 1], -1, end.col - 1, logger_1.colorize.red)
        ]);
        if (!color)
          prefixedLines.push(["", underlineLine(lines[endLineNum - 1], -1, end.col - 1)]);
      }
      return printPrefixedLines([
        [`${startLineNum - 2}`, markLine(lines[startLineNum - 1 - 2])],
        [`${startLineNum - 1}`, markLine(lines[startLineNum - 1 - 1])],
        ...prefixedLines,
        [`${endLineNum + 1}`, markLine(lines[endLineNum - 1 + 1])],
        [`${endLineNum + 2}`, markLine(lines[endLineNum - 1 + 2])]
      ]);
      function markLine(line, startIdx = -1, endIdx = Infinity, variant = logger_1.colorize.gray) {
        if (!color)
          return line;
        if (!line)
          return line;
        if (startIdx === -1) {
          startIdx = padSize(line);
        }
        endIdx = Math.min(endIdx, line.length);
        return line.substr(0, startIdx) + variant(line.substring(startIdx, endIdx)) + line.substr(endIdx);
      }
    }
    exports2.getCodeframe = getCodeframe;
    function printPrefixedLines(lines) {
      const existingLines = lines.filter(([_, line]) => line !== void 0);
      const padLen = Math.max(...existingLines.map(([prefix]) => prefix.length));
      const dedentLen = Math.min(...existingLines.map(([_, line]) => line === "" ? Infinity : padSize(line)));
      return existingLines.map(([prefix, line]) => logger_1.colorize.gray(leftPad(padLen, prefix) + " |") + (line ? " " + limitLineLength(line.substring(dedentLen)) : "")).join("\n");
    }
    function limitLineLength(line, maxLen = MAX_LINE_LENGTH) {
      const overflowLen = line.length - maxLen;
      if (overflowLen > 0) {
        const charsMoreText = logger_1.colorize.gray(`...<${overflowLen} chars>`);
        return line.substring(0, maxLen - charsMoreText.length) + charsMoreText;
      } else {
        return line;
      }
    }
    function underlineLine(line, startIdx = -1, endIdx = Infinity) {
      if (startIdx === -1) {
        startIdx = padSize(line);
      }
      endIdx = Math.min(endIdx, line.length);
      return whitespace(startIdx) + "^".repeat(Math.max(endIdx - startIdx, 1));
    }
    function whitespace(len) {
      return " ".repeat(len);
    }
    function leftPad(len, str2) {
      return whitespace(len - str2.length) + str2;
    }
    function padSize(line) {
      for (let i = 0; i < line.length; i++) {
        if (line[i] !== " ")
          return i;
      }
      return line.length;
    }
    function getLineColLocation(location) {
      var _a, _b;
      if (location.pointer === void 0)
        return location;
      const { source, pointer, reportOnKey } = location;
      const ast = source.getAst(yamlAst.safeLoad);
      const astNode = getAstNodeByPointer(ast, pointer, !!reportOnKey);
      return Object.assign(Object.assign(Object.assign({}, location), { pointer: void 0 }), positionsToLoc(source.body, (_a = astNode === null || astNode === void 0 ? void 0 : astNode.startPosition) !== null && _a !== void 0 ? _a : 1, (_b = astNode === null || astNode === void 0 ? void 0 : astNode.endPosition) !== null && _b !== void 0 ? _b : 1));
    }
    exports2.getLineColLocation = getLineColLocation;
    function positionsToLoc(source, startPos, endPos) {
      let currentLine = 1;
      let currentCol = 1;
      let start = { line: 1, col: 1 };
      for (let i = 0; i < endPos - 1; i++) {
        if (i === startPos - 1) {
          start = { line: currentLine, col: currentCol + 1 };
        }
        if (source[i] === "\n") {
          currentLine++;
          currentCol = 1;
          if (i === startPos - 1) {
            start = { line: currentLine, col: currentCol };
          }
          if (source[i + 1] === "\r")
            i++;
          continue;
        }
        currentCol++;
      }
      const end = startPos === endPos ? Object.assign({}, start) : { line: currentLine, col: currentCol + 1 };
      return { start, end };
    }
    function getAstNodeByPointer(root2, pointer, reportOnKey) {
      const pointerSegments = parsePointer(pointer);
      if (root2 === void 0) {
        return void 0;
      }
      let currentNode = root2;
      for (const key of pointerSegments) {
        if (currentNode.kind === yamlAst.Kind.MAP) {
          const mapping = currentNode.mappings.find((m) => m.key.value === key);
          if (!mapping)
            break;
          currentNode = mapping;
          if (!(mapping === null || mapping === void 0 ? void 0 : mapping.value))
            break;
          currentNode = mapping.value;
        } else if (currentNode.kind === yamlAst.Kind.SEQ) {
          const elem = currentNode.items[parseInt(key, 10)];
          if (!elem)
            break;
          currentNode = elem;
        }
      }
      if (!reportOnKey) {
        return currentNode;
      } else {
        const parent = currentNode.parent;
        if (!parent)
          return currentNode;
        if (parent.kind === yamlAst.Kind.SEQ) {
          return currentNode;
        } else if (parent.kind === yamlAst.Kind.MAPPING) {
          return parent.key;
        } else {
          return currentNode;
        }
      }
    }
    exports2.getAstNodeByPointer = getAstNodeByPointer;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/output.js
var require_output = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/output.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.output = void 0;
    var env_1 = require_env();
    exports2.output = {
      write(str2) {
        return env_1.isBrowser ? void 0 : process.stdout.write(str2);
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/format/format.js
var require_format3 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/format/format.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.formatProblems = exports2.getTotals = void 0;
    var path5 = require("path");
    var logger_1 = require_logger();
    var output_1 = require_output();
    var coreVersion = require_package3().version;
    var codeframes_1 = require_codeframes();
    var env_1 = require_env();
    var ref_utils_1 = require_ref_utils();
    var ERROR_MESSAGE = {
      INVALID_SEVERITY_LEVEL: "Invalid severity level; accepted values: error or warn"
    };
    var BG_COLORS = {
      warn: (str2) => logger_1.colorize.bgYellow(logger_1.colorize.black(str2)),
      error: logger_1.colorize.bgRed
    };
    var COLORS = {
      warn: logger_1.colorize.yellow,
      error: logger_1.colorize.red
    };
    var SEVERITY_NAMES = {
      warn: "Warning",
      error: "Error"
    };
    var CODECLIMATE_SEVERITY_MAPPING = {
      error: "critical",
      warn: "minor"
    };
    var MAX_SUGGEST = 5;
    function severityToNumber(severity) {
      return severity === "error" ? 1 : 2;
    }
    function getTotals(problems) {
      let errors = 0;
      let warnings = 0;
      let ignored = 0;
      for (const m of problems) {
        if (m.ignored) {
          ignored++;
          continue;
        }
        if (m.severity === "error")
          errors++;
        if (m.severity === "warn")
          warnings++;
      }
      return {
        errors,
        warnings,
        ignored
      };
    }
    exports2.getTotals = getTotals;
    function formatProblems(problems, opts) {
      const { maxProblems = 100, cwd = process.cwd(), format = "codeframe", color = logger_1.colorOptions.enabled, totals = getTotals(problems), version = coreVersion } = opts;
      logger_1.colorOptions.enabled = color;
      const totalProblems = problems.length;
      problems = problems.filter((m) => !m.ignored);
      const ignoredProblems = totalProblems - problems.length;
      problems = problems.sort((a, b) => severityToNumber(a.severity) - severityToNumber(b.severity)).slice(0, maxProblems);
      if (!totalProblems && format !== "json")
        return;
      switch (format) {
        case "json":
          outputJSON();
          break;
        case "codeframe":
          for (let i = 0; i < problems.length; i++) {
            const problem = problems[i];
            logger_1.logger.info(`${formatCodeframe(problem, i)}
`);
          }
          break;
        case "stylish": {
          const groupedByFile = groupByFiles(problems);
          for (const [file, { ruleIdPad, locationPad: positionPad, fileProblems }] of Object.entries(groupedByFile)) {
            logger_1.logger.info(`${logger_1.colorize.blue((0, ref_utils_1.isAbsoluteUrl)(file) ? file : path5.relative(cwd, file))}:
`);
            for (let i = 0; i < fileProblems.length; i++) {
              const problem = fileProblems[i];
              logger_1.logger.info(`${formatStylish(problem, positionPad, ruleIdPad)}
`);
            }
            logger_1.logger.info("\n");
          }
          break;
        }
        case "checkstyle": {
          const groupedByFile = groupByFiles(problems);
          output_1.output.write('<?xml version="1.0" encoding="UTF-8"?>\n');
          output_1.output.write('<checkstyle version="4.3">\n');
          for (const [file, { fileProblems }] of Object.entries(groupedByFile)) {
            output_1.output.write(`<file name="${xmlEscape((0, ref_utils_1.isAbsoluteUrl)(file) ? file : path5.relative(cwd, file))}">
`);
            fileProblems.forEach(formatCheckstyle);
            output_1.output.write(`</file>
`);
          }
          output_1.output.write(`</checkstyle>
`);
          break;
        }
        case "codeclimate":
          outputForCodeClimate();
          break;
        case "summary":
          formatSummary(problems);
          break;
      }
      if (totalProblems - ignoredProblems > maxProblems) {
        logger_1.logger.info(`< ... ${totalProblems - maxProblems} more problems hidden > ${logger_1.colorize.gray("increase with `--max-problems N`")}
`);
      }
      function outputForCodeClimate() {
        const issues = problems.map((p) => {
          const location = p.location[0];
          const lineCol = (0, codeframes_1.getLineColLocation)(location);
          return {
            description: p.message,
            location: {
              path: (0, ref_utils_1.isAbsoluteUrl)(location.source.absoluteRef) ? location.source.absoluteRef : path5.relative(cwd, location.source.absoluteRef),
              lines: {
                begin: lineCol.start.line
              }
            },
            severity: CODECLIMATE_SEVERITY_MAPPING[p.severity],
            fingerprint: `${p.ruleId}${p.location.length > 0 ? "-" + p.location[0].pointer : ""}`
          };
        });
        output_1.output.write(JSON.stringify(issues, null, 2));
      }
      function outputJSON() {
        const resultObject = {
          totals,
          version,
          problems: problems.map((p) => {
            var _a, _b, _c;
            const problem = Object.assign(Object.assign({}, p), { location: p.location.map((location) => Object.assign(Object.assign({}, location), { source: {
              ref: (0, ref_utils_1.isAbsoluteUrl)(location.source.absoluteRef) ? location.source.absoluteRef : path5.relative(cwd, location.source.absoluteRef)
            } })), from: p.from ? Object.assign(Object.assign({}, p.from), { source: {
              ref: (0, ref_utils_1.isAbsoluteUrl)((_a = p.from) === null || _a === void 0 ? void 0 : _a.source.absoluteRef) ? (_b = p.from) === null || _b === void 0 ? void 0 : _b.source.absoluteRef : path5.relative(cwd, ((_c = p.from) === null || _c === void 0 ? void 0 : _c.source.absoluteRef) || cwd)
            } }) : void 0 });
            if (env_1.env.FORMAT_JSON_WITH_CODEFRAMES) {
              const location = p.location[0];
              const loc = (0, codeframes_1.getLineColLocation)(location);
              problem.codeframe = (0, codeframes_1.getCodeframe)(loc, color);
            }
            return problem;
          })
        };
        output_1.output.write(JSON.stringify(resultObject, null, 2));
      }
      function getBgColor(problem) {
        const { severity } = problem;
        if (!BG_COLORS[severity]) {
          throw new Error(ERROR_MESSAGE.INVALID_SEVERITY_LEVEL);
        }
        return BG_COLORS[severity];
      }
      function formatCodeframe(problem, idx) {
        const bgColor = getBgColor(problem);
        const location = problem.location[0];
        const relativePath = (0, ref_utils_1.isAbsoluteUrl)(location.source.absoluteRef) ? location.source.absoluteRef : path5.relative(cwd, location.source.absoluteRef);
        const loc = (0, codeframes_1.getLineColLocation)(location);
        const atPointer = location.pointer ? logger_1.colorize.gray(`at ${location.pointer}`) : "";
        const fileWithLoc = `${relativePath}:${loc.start.line}:${loc.start.col}`;
        return `[${idx + 1}] ${bgColor(fileWithLoc)} ${atPointer}

${problem.message}

` + formatDidYouMean(problem) + (0, codeframes_1.getCodeframe)(loc, color) + "\n\n" + formatFrom(cwd, problem.from) + `${SEVERITY_NAMES[problem.severity]} was generated by the ${logger_1.colorize.blue(problem.ruleId)} rule.

`;
      }
      function formatStylish(problem, locationPad, ruleIdPad) {
        const color2 = COLORS[problem.severity];
        if (!SEVERITY_NAMES[problem.severity]) {
          return "Error not found severity. Please check your config file. Allowed values: `warn,error,off`";
        }
        const severityName = color2(SEVERITY_NAMES[problem.severity].toLowerCase().padEnd(7));
        const { start } = problem.location[0];
        return `  ${`${start.line}:${start.col}`.padEnd(locationPad)}  ${severityName}  ${problem.ruleId.padEnd(ruleIdPad)}  ${problem.message}`;
      }
      function formatCheckstyle(problem) {
        const { line, col } = problem.location[0].start;
        const severity = problem.severity == "warn" ? "warning" : "error";
        const message = xmlEscape(problem.message);
        const source = xmlEscape(problem.ruleId);
        output_1.output.write(`<error line="${line}" column="${col}" severity="${severity}" message="${message}" source="${source}" />
`);
      }
    }
    exports2.formatProblems = formatProblems;
    function formatSummary(problems) {
      const counts = {};
      for (const problem of problems) {
        counts[problem.ruleId] = counts[problem.ruleId] || { count: 0, severity: problem.severity };
        counts[problem.ruleId].count++;
      }
      const sorted = Object.entries(counts).sort(([, a], [, b]) => {
        const severityDiff = severityToNumber(a.severity) - severityToNumber(b.severity);
        return severityDiff || b.count - a.count;
      });
      for (const [ruleId, info] of sorted) {
        const color = COLORS[info.severity];
        const severityName = color(SEVERITY_NAMES[info.severity].toLowerCase().padEnd(7));
        logger_1.logger.info(`${severityName} ${ruleId}: ${info.count}
`);
      }
      logger_1.logger.info("\n");
    }
    function formatFrom(cwd, location) {
      if (!location)
        return "";
      const relativePath = path5.relative(cwd, location.source.absoluteRef);
      const loc = (0, codeframes_1.getLineColLocation)(location);
      const fileWithLoc = `${relativePath}:${loc.start.line}:${loc.start.col}`;
      const atPointer = location.pointer ? logger_1.colorize.gray(`at ${location.pointer}`) : "";
      return `referenced from ${logger_1.colorize.blue(fileWithLoc)} ${atPointer} 

`;
    }
    function formatDidYouMean(problem) {
      if (problem.suggest.length === 0)
        return "";
      if (problem.suggest.length === 1) {
        return `Did you mean: ${problem.suggest[0]} ?

`;
      } else {
        return `Did you mean:
  - ${problem.suggest.slice(0, MAX_SUGGEST).join("\n  - ")}

`;
      }
    }
    var groupByFiles = (problems) => {
      const fileGroups = {};
      for (const problem of problems) {
        const absoluteRef = problem.location[0].source.absoluteRef;
        fileGroups[absoluteRef] = fileGroups[absoluteRef] || {
          fileProblems: [],
          ruleIdPad: 0,
          locationPad: 0
        };
        const mappedProblem = Object.assign(Object.assign({}, problem), { location: problem.location.map(codeframes_1.getLineColLocation) });
        fileGroups[absoluteRef].fileProblems.push(mappedProblem);
        fileGroups[absoluteRef].ruleIdPad = Math.max(problem.ruleId.length, fileGroups[absoluteRef].ruleIdPad);
        fileGroups[absoluteRef].locationPad = Math.max(Math.max(...mappedProblem.location.map((loc) => `${loc.start.line}:${loc.start.col}`.length)), fileGroups[absoluteRef].locationPad);
      }
      return fileGroups;
    };
    function xmlEscape(s) {
      return s.replace(/[<>&"'\x00-\x1F\x7F\u0080-\uFFFF]/gu, (char) => {
        switch (char) {
          case "<":
            return "&lt;";
          case ">":
            return "&gt;";
          case "&":
            return "&amp;";
          case '"':
            return "&quot;";
          case "'":
            return "&apos;";
          default:
            return `&#${char.charCodeAt(0)};`;
        }
      });
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/lint.js
var require_lint = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/lint.js"(exports2) {
    "use strict";
    var __awaiter = exports2 && exports2.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.lintConfig = exports2.lintDocument = exports2.lintFromString = exports2.lint = void 0;
    var resolve_1 = require_resolve2();
    var visitors_1 = require_visitors();
    var walk_1 = require_walk();
    var config_1 = require_config2();
    var types_1 = require_types();
    var ajv_1 = require_ajv();
    var oas_types_1 = require_oas_types();
    var redocly_yaml_1 = require_redocly_yaml();
    var spec_1 = require_spec();
    function lint(opts) {
      return __awaiter(this, void 0, void 0, function* () {
        const { ref, externalRefResolver = new resolve_1.BaseResolver(opts.config.resolve) } = opts;
        const document2 = yield externalRefResolver.resolveDocument(null, ref, true);
        return lintDocument(Object.assign(Object.assign({ document: document2 }, opts), { externalRefResolver, config: opts.config.styleguide }));
      });
    }
    exports2.lint = lint;
    function lintFromString(opts) {
      return __awaiter(this, void 0, void 0, function* () {
        const { source, absoluteRef, externalRefResolver = new resolve_1.BaseResolver(opts.config.resolve) } = opts;
        const document2 = (0, resolve_1.makeDocumentFromString)(source, absoluteRef || "/");
        return lintDocument(Object.assign(Object.assign({ document: document2 }, opts), { externalRefResolver, config: opts.config.styleguide }));
      });
    }
    exports2.lintFromString = lintFromString;
    function lintDocument(opts) {
      return __awaiter(this, void 0, void 0, function* () {
        (0, ajv_1.releaseAjvInstance)();
        const { document: document2, customTypes, externalRefResolver, config } = opts;
        const specVersion = (0, oas_types_1.detectSpec)(document2.parsed);
        const specMajorVersion = (0, oas_types_1.getMajorSpecVersion)(specVersion);
        const rules = config.getRulesForOasVersion(specMajorVersion);
        const types2 = (0, types_1.normalizeTypes)(config.extendTypes(customTypes !== null && customTypes !== void 0 ? customTypes : (0, oas_types_1.getTypes)(specVersion), specVersion), config);
        const ctx = {
          problems: [],
          oasVersion: specVersion,
          visitorsData: {}
        };
        const preprocessors = (0, config_1.initRules)(rules, config, "preprocessors", specVersion);
        const regularRules = (0, config_1.initRules)(rules, config, "rules", specVersion);
        let resolvedRefMap = yield (0, resolve_1.resolveDocument)({
          rootDocument: document2,
          rootType: types2.Root,
          externalRefResolver
        });
        if (preprocessors.length > 0) {
          (0, walk_1.walkDocument)({
            document: document2,
            rootType: types2.Root,
            normalizedVisitors: (0, visitors_1.normalizeVisitors)(preprocessors, types2),
            resolvedRefMap,
            ctx
          });
          resolvedRefMap = yield (0, resolve_1.resolveDocument)({
            rootDocument: document2,
            rootType: types2.Root,
            externalRefResolver
          });
        }
        const normalizedVisitors = (0, visitors_1.normalizeVisitors)(regularRules, types2);
        (0, walk_1.walkDocument)({
          document: document2,
          rootType: types2.Root,
          normalizedVisitors,
          resolvedRefMap,
          ctx
        });
        return ctx.problems.map((problem) => config.addProblemToIgnore(problem));
      });
    }
    exports2.lintDocument = lintDocument;
    function lintConfig(opts) {
      return __awaiter(this, void 0, void 0, function* () {
        const { document: document2, severity } = opts;
        const ctx = {
          problems: [],
          oasVersion: oas_types_1.SpecVersion.OAS3_0,
          visitorsData: {}
        };
        const plugins = (0, config_1.resolvePlugins)([config_1.defaultPlugin]);
        const config = new config_1.StyleguideConfig({
          plugins,
          rules: { spec: "error" }
        });
        const types2 = (0, types_1.normalizeTypes)(redocly_yaml_1.ConfigTypes, config);
        const rules = [
          {
            severity: severity || "error",
            ruleId: "configuration spec",
            visitor: (0, spec_1.Spec)({ severity: "error" })
          }
        ];
        const normalizedVisitors = (0, visitors_1.normalizeVisitors)(rules, types2);
        (0, walk_1.walkDocument)({
          document: document2,
          rootType: types2.ConfigRoot,
          normalizedVisitors,
          resolvedRefMap: /* @__PURE__ */ new Map(),
          ctx
        });
        return ctx.problems;
      });
    }
    exports2.lintConfig = lintConfig;
  }
});

// ../../../node_modules/.pnpm/lodash.isequal@4.5.0/node_modules/lodash.isequal/index.js
var require_lodash = __commonJS({
  "../../../node_modules/.pnpm/lodash.isequal@4.5.0/node_modules/lodash.isequal/index.js"(exports2, module2) {
    "use strict";
    var LARGE_ARRAY_SIZE3 = 200;
    var HASH_UNDEFINED4 = "__lodash_hash_undefined__";
    var COMPARE_PARTIAL_FLAG7 = 1;
    var COMPARE_UNORDERED_FLAG5 = 2;
    var MAX_SAFE_INTEGER3 = 9007199254740991;
    var argsTag4 = "[object Arguments]";
    var arrayTag3 = "[object Array]";
    var asyncTag2 = "[object AsyncFunction]";
    var boolTag3 = "[object Boolean]";
    var dateTag3 = "[object Date]";
    var errorTag3 = "[object Error]";
    var funcTag3 = "[object Function]";
    var genTag2 = "[object GeneratorFunction]";
    var mapTag5 = "[object Map]";
    var numberTag3 = "[object Number]";
    var nullTag2 = "[object Null]";
    var objectTag5 = "[object Object]";
    var promiseTag2 = "[object Promise]";
    var proxyTag2 = "[object Proxy]";
    var regexpTag3 = "[object RegExp]";
    var setTag5 = "[object Set]";
    var stringTag4 = "[object String]";
    var symbolTag3 = "[object Symbol]";
    var undefinedTag2 = "[object Undefined]";
    var weakMapTag3 = "[object WeakMap]";
    var arrayBufferTag3 = "[object ArrayBuffer]";
    var dataViewTag4 = "[object DataView]";
    var float32Tag2 = "[object Float32Array]";
    var float64Tag2 = "[object Float64Array]";
    var int8Tag2 = "[object Int8Array]";
    var int16Tag2 = "[object Int16Array]";
    var int32Tag2 = "[object Int32Array]";
    var uint8Tag2 = "[object Uint8Array]";
    var uint8ClampedTag2 = "[object Uint8ClampedArray]";
    var uint16Tag2 = "[object Uint16Array]";
    var uint32Tag2 = "[object Uint32Array]";
    var reRegExpChar2 = /[\\^$.*+?()[\]{}|]/g;
    var reIsHostCtor2 = /^\[object .+?Constructor\]$/;
    var reIsUint2 = /^(?:0|[1-9]\d*)$/;
    var typedArrayTags2 = {};
    typedArrayTags2[float32Tag2] = typedArrayTags2[float64Tag2] = typedArrayTags2[int8Tag2] = typedArrayTags2[int16Tag2] = typedArrayTags2[int32Tag2] = typedArrayTags2[uint8Tag2] = typedArrayTags2[uint8ClampedTag2] = typedArrayTags2[uint16Tag2] = typedArrayTags2[uint32Tag2] = true;
    typedArrayTags2[argsTag4] = typedArrayTags2[arrayTag3] = typedArrayTags2[arrayBufferTag3] = typedArrayTags2[boolTag3] = typedArrayTags2[dataViewTag4] = typedArrayTags2[dateTag3] = typedArrayTags2[errorTag3] = typedArrayTags2[funcTag3] = typedArrayTags2[mapTag5] = typedArrayTags2[numberTag3] = typedArrayTags2[objectTag5] = typedArrayTags2[regexpTag3] = typedArrayTags2[setTag5] = typedArrayTags2[stringTag4] = typedArrayTags2[weakMapTag3] = false;
    var freeGlobal2 = typeof global == "object" && global && global.Object === Object && global;
    var freeSelf2 = typeof self == "object" && self && self.Object === Object && self;
    var root2 = freeGlobal2 || freeSelf2 || Function("return this")();
    var freeExports4 = typeof exports2 == "object" && exports2 && !exports2.nodeType && exports2;
    var freeModule4 = freeExports4 && typeof module2 == "object" && module2 && !module2.nodeType && module2;
    var moduleExports4 = freeModule4 && freeModule4.exports === freeExports4;
    var freeProcess2 = moduleExports4 && freeGlobal2.process;
    var nodeUtil2 = function() {
      try {
        return freeProcess2 && freeProcess2.binding && freeProcess2.binding("util");
      } catch (e) {
      }
    }();
    var nodeIsTypedArray2 = nodeUtil2 && nodeUtil2.isTypedArray;
    function arrayFilter2(array, predicate) {
      var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result = [];
      while (++index < length) {
        var value = array[index];
        if (predicate(value, index, array)) {
          result[resIndex++] = value;
        }
      }
      return result;
    }
    function arrayPush2(array, values) {
      var index = -1, length = values.length, offset = array.length;
      while (++index < length) {
        array[offset + index] = values[index];
      }
      return array;
    }
    function arraySome2(array, predicate) {
      var index = -1, length = array == null ? 0 : array.length;
      while (++index < length) {
        if (predicate(array[index], index, array)) {
          return true;
        }
      }
      return false;
    }
    function baseTimes2(n, iteratee) {
      var index = -1, result = Array(n);
      while (++index < n) {
        result[index] = iteratee(index);
      }
      return result;
    }
    function baseUnary2(func) {
      return function(value) {
        return func(value);
      };
    }
    function cacheHas2(cache, key) {
      return cache.has(key);
    }
    function getValue2(object3, key) {
      return object3 == null ? void 0 : object3[key];
    }
    function mapToArray2(map2) {
      var index = -1, result = Array(map2.size);
      map2.forEach(function(value, key) {
        result[++index] = [key, value];
      });
      return result;
    }
    function overArg2(func, transform3) {
      return function(arg) {
        return func(transform3(arg));
      };
    }
    function setToArray2(set4) {
      var index = -1, result = Array(set4.size);
      set4.forEach(function(value) {
        result[++index] = value;
      });
      return result;
    }
    var arrayProto2 = Array.prototype;
    var funcProto4 = Function.prototype;
    var objectProto16 = Object.prototype;
    var coreJsData2 = root2["__core-js_shared__"];
    var funcToString4 = funcProto4.toString;
    var hasOwnProperty13 = objectProto16.hasOwnProperty;
    var maskSrcKey2 = function() {
      var uid = /[^.]+$/.exec(coreJsData2 && coreJsData2.keys && coreJsData2.keys.IE_PROTO || "");
      return uid ? "Symbol(src)_1." + uid : "";
    }();
    var nativeObjectToString3 = objectProto16.toString;
    var reIsNative2 = RegExp(
      "^" + funcToString4.call(hasOwnProperty13).replace(reRegExpChar2, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
    );
    var Buffer4 = moduleExports4 ? root2.Buffer : void 0;
    var Symbol3 = root2.Symbol;
    var Uint8Array3 = root2.Uint8Array;
    var propertyIsEnumerable3 = objectProto16.propertyIsEnumerable;
    var splice2 = arrayProto2.splice;
    var symToStringTag3 = Symbol3 ? Symbol3.toStringTag : void 0;
    var nativeGetSymbols3 = Object.getOwnPropertySymbols;
    var nativeIsBuffer2 = Buffer4 ? Buffer4.isBuffer : void 0;
    var nativeKeys2 = overArg2(Object.keys, Object);
    var DataView2 = getNative2(root2, "DataView");
    var Map3 = getNative2(root2, "Map");
    var Promise3 = getNative2(root2, "Promise");
    var Set3 = getNative2(root2, "Set");
    var WeakMap3 = getNative2(root2, "WeakMap");
    var nativeCreate2 = getNative2(Object, "create");
    var dataViewCtorString2 = toSource2(DataView2);
    var mapCtorString2 = toSource2(Map3);
    var promiseCtorString2 = toSource2(Promise3);
    var setCtorString2 = toSource2(Set3);
    var weakMapCtorString2 = toSource2(WeakMap3);
    var symbolProto3 = Symbol3 ? Symbol3.prototype : void 0;
    var symbolValueOf2 = symbolProto3 ? symbolProto3.valueOf : void 0;
    function Hash2(entries4) {
      var index = -1, length = entries4 == null ? 0 : entries4.length;
      this.clear();
      while (++index < length) {
        var entry = entries4[index];
        this.set(entry[0], entry[1]);
      }
    }
    function hashClear2() {
      this.__data__ = nativeCreate2 ? nativeCreate2(null) : {};
      this.size = 0;
    }
    function hashDelete2(key) {
      var result = this.has(key) && delete this.__data__[key];
      this.size -= result ? 1 : 0;
      return result;
    }
    function hashGet2(key) {
      var data = this.__data__;
      if (nativeCreate2) {
        var result = data[key];
        return result === HASH_UNDEFINED4 ? void 0 : result;
      }
      return hasOwnProperty13.call(data, key) ? data[key] : void 0;
    }
    function hashHas2(key) {
      var data = this.__data__;
      return nativeCreate2 ? data[key] !== void 0 : hasOwnProperty13.call(data, key);
    }
    function hashSet2(key, value) {
      var data = this.__data__;
      this.size += this.has(key) ? 0 : 1;
      data[key] = nativeCreate2 && value === void 0 ? HASH_UNDEFINED4 : value;
      return this;
    }
    Hash2.prototype.clear = hashClear2;
    Hash2.prototype["delete"] = hashDelete2;
    Hash2.prototype.get = hashGet2;
    Hash2.prototype.has = hashHas2;
    Hash2.prototype.set = hashSet2;
    function ListCache2(entries4) {
      var index = -1, length = entries4 == null ? 0 : entries4.length;
      this.clear();
      while (++index < length) {
        var entry = entries4[index];
        this.set(entry[0], entry[1]);
      }
    }
    function listCacheClear2() {
      this.__data__ = [];
      this.size = 0;
    }
    function listCacheDelete2(key) {
      var data = this.__data__, index = assocIndexOf2(data, key);
      if (index < 0) {
        return false;
      }
      var lastIndex = data.length - 1;
      if (index == lastIndex) {
        data.pop();
      } else {
        splice2.call(data, index, 1);
      }
      --this.size;
      return true;
    }
    function listCacheGet2(key) {
      var data = this.__data__, index = assocIndexOf2(data, key);
      return index < 0 ? void 0 : data[index][1];
    }
    function listCacheHas2(key) {
      return assocIndexOf2(this.__data__, key) > -1;
    }
    function listCacheSet2(key, value) {
      var data = this.__data__, index = assocIndexOf2(data, key);
      if (index < 0) {
        ++this.size;
        data.push([key, value]);
      } else {
        data[index][1] = value;
      }
      return this;
    }
    ListCache2.prototype.clear = listCacheClear2;
    ListCache2.prototype["delete"] = listCacheDelete2;
    ListCache2.prototype.get = listCacheGet2;
    ListCache2.prototype.has = listCacheHas2;
    ListCache2.prototype.set = listCacheSet2;
    function MapCache2(entries4) {
      var index = -1, length = entries4 == null ? 0 : entries4.length;
      this.clear();
      while (++index < length) {
        var entry = entries4[index];
        this.set(entry[0], entry[1]);
      }
    }
    function mapCacheClear2() {
      this.size = 0;
      this.__data__ = {
        "hash": new Hash2(),
        "map": new (Map3 || ListCache2)(),
        "string": new Hash2()
      };
    }
    function mapCacheDelete2(key) {
      var result = getMapData2(this, key)["delete"](key);
      this.size -= result ? 1 : 0;
      return result;
    }
    function mapCacheGet2(key) {
      return getMapData2(this, key).get(key);
    }
    function mapCacheHas2(key) {
      return getMapData2(this, key).has(key);
    }
    function mapCacheSet2(key, value) {
      var data = getMapData2(this, key), size2 = data.size;
      data.set(key, value);
      this.size += data.size == size2 ? 0 : 1;
      return this;
    }
    MapCache2.prototype.clear = mapCacheClear2;
    MapCache2.prototype["delete"] = mapCacheDelete2;
    MapCache2.prototype.get = mapCacheGet2;
    MapCache2.prototype.has = mapCacheHas2;
    MapCache2.prototype.set = mapCacheSet2;
    function SetCache2(values) {
      var index = -1, length = values == null ? 0 : values.length;
      this.__data__ = new MapCache2();
      while (++index < length) {
        this.add(values[index]);
      }
    }
    function setCacheAdd2(value) {
      this.__data__.set(value, HASH_UNDEFINED4);
      return this;
    }
    function setCacheHas2(value) {
      return this.__data__.has(value);
    }
    SetCache2.prototype.add = SetCache2.prototype.push = setCacheAdd2;
    SetCache2.prototype.has = setCacheHas2;
    function Stack2(entries4) {
      var data = this.__data__ = new ListCache2(entries4);
      this.size = data.size;
    }
    function stackClear2() {
      this.__data__ = new ListCache2();
      this.size = 0;
    }
    function stackDelete2(key) {
      var data = this.__data__, result = data["delete"](key);
      this.size = data.size;
      return result;
    }
    function stackGet2(key) {
      return this.__data__.get(key);
    }
    function stackHas2(key) {
      return this.__data__.has(key);
    }
    function stackSet2(key, value) {
      var data = this.__data__;
      if (data instanceof ListCache2) {
        var pairs2 = data.__data__;
        if (!Map3 || pairs2.length < LARGE_ARRAY_SIZE3 - 1) {
          pairs2.push([key, value]);
          this.size = ++data.size;
          return this;
        }
        data = this.__data__ = new MapCache2(pairs2);
      }
      data.set(key, value);
      this.size = data.size;
      return this;
    }
    Stack2.prototype.clear = stackClear2;
    Stack2.prototype["delete"] = stackDelete2;
    Stack2.prototype.get = stackGet2;
    Stack2.prototype.has = stackHas2;
    Stack2.prototype.set = stackSet2;
    function arrayLikeKeys2(value, inherited) {
      var isArr = isArray2(value), isArg = !isArr && isArguments2(value), isBuff = !isArr && !isArg && isBuffer2(value), isType = !isArr && !isArg && !isBuff && isTypedArray2(value), skipIndexes = isArr || isArg || isBuff || isType, result = skipIndexes ? baseTimes2(value.length, String) : [], length = result.length;
      for (var key in value) {
        if ((inherited || hasOwnProperty13.call(value, key)) && !(skipIndexes && // Safari 9 has enumerable `arguments.length` in strict mode.
        (key == "length" || // Node.js 0.10 has enumerable non-index properties on buffers.
        isBuff && (key == "offset" || key == "parent") || // PhantomJS 2 has enumerable non-index properties on typed arrays.
        isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || // Skip index properties.
        isIndex2(key, length)))) {
          result.push(key);
        }
      }
      return result;
    }
    function assocIndexOf2(array, key) {
      var length = array.length;
      while (length--) {
        if (eq2(array[length][0], key)) {
          return length;
        }
      }
      return -1;
    }
    function baseGetAllKeys2(object3, keysFunc, symbolsFunc) {
      var result = keysFunc(object3);
      return isArray2(object3) ? result : arrayPush2(result, symbolsFunc(object3));
    }
    function baseGetTag2(value) {
      if (value == null) {
        return value === void 0 ? undefinedTag2 : nullTag2;
      }
      return symToStringTag3 && symToStringTag3 in Object(value) ? getRawTag2(value) : objectToString2(value);
    }
    function baseIsArguments2(value) {
      return isObjectLike3(value) && baseGetTag2(value) == argsTag4;
    }
    function baseIsEqual2(value, other, bitmask, customizer, stack) {
      if (value === other) {
        return true;
      }
      if (value == null || other == null || !isObjectLike3(value) && !isObjectLike3(other)) {
        return value !== value && other !== other;
      }
      return baseIsEqualDeep2(value, other, bitmask, customizer, baseIsEqual2, stack);
    }
    function baseIsEqualDeep2(object3, other, bitmask, customizer, equalFunc, stack) {
      var objIsArr = isArray2(object3), othIsArr = isArray2(other), objTag = objIsArr ? arrayTag3 : getTag2(object3), othTag = othIsArr ? arrayTag3 : getTag2(other);
      objTag = objTag == argsTag4 ? objectTag5 : objTag;
      othTag = othTag == argsTag4 ? objectTag5 : othTag;
      var objIsObj = objTag == objectTag5, othIsObj = othTag == objectTag5, isSameTag = objTag == othTag;
      if (isSameTag && isBuffer2(object3)) {
        if (!isBuffer2(other)) {
          return false;
        }
        objIsArr = true;
        objIsObj = false;
      }
      if (isSameTag && !objIsObj) {
        stack || (stack = new Stack2());
        return objIsArr || isTypedArray2(object3) ? equalArrays2(object3, other, bitmask, customizer, equalFunc, stack) : equalByTag2(object3, other, objTag, bitmask, customizer, equalFunc, stack);
      }
      if (!(bitmask & COMPARE_PARTIAL_FLAG7)) {
        var objIsWrapped = objIsObj && hasOwnProperty13.call(object3, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty13.call(other, "__wrapped__");
        if (objIsWrapped || othIsWrapped) {
          var objUnwrapped = objIsWrapped ? object3.value() : object3, othUnwrapped = othIsWrapped ? other.value() : other;
          stack || (stack = new Stack2());
          return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
        }
      }
      if (!isSameTag) {
        return false;
      }
      stack || (stack = new Stack2());
      return equalObjects2(object3, other, bitmask, customizer, equalFunc, stack);
    }
    function baseIsNative2(value) {
      if (!isObject3(value) || isMasked2(value)) {
        return false;
      }
      var pattern = isFunction2(value) ? reIsNative2 : reIsHostCtor2;
      return pattern.test(toSource2(value));
    }
    function baseIsTypedArray2(value) {
      return isObjectLike3(value) && isLength2(value.length) && !!typedArrayTags2[baseGetTag2(value)];
    }
    function baseKeys2(object3) {
      if (!isPrototype2(object3)) {
        return nativeKeys2(object3);
      }
      var result = [];
      for (var key in Object(object3)) {
        if (hasOwnProperty13.call(object3, key) && key != "constructor") {
          result.push(key);
        }
      }
      return result;
    }
    function equalArrays2(array, other, bitmask, customizer, equalFunc, stack) {
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG7, arrLength = array.length, othLength = other.length;
      if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
        return false;
      }
      var stacked = stack.get(array);
      if (stacked && stack.get(other)) {
        return stacked == other;
      }
      var index = -1, result = true, seen = bitmask & COMPARE_UNORDERED_FLAG5 ? new SetCache2() : void 0;
      stack.set(array, other);
      stack.set(other, array);
      while (++index < arrLength) {
        var arrValue = array[index], othValue = other[index];
        if (customizer) {
          var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
        }
        if (compared !== void 0) {
          if (compared) {
            continue;
          }
          result = false;
          break;
        }
        if (seen) {
          if (!arraySome2(other, function(othValue2, othIndex) {
            if (!cacheHas2(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
              return seen.push(othIndex);
            }
          })) {
            result = false;
            break;
          }
        } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
          result = false;
          break;
        }
      }
      stack["delete"](array);
      stack["delete"](other);
      return result;
    }
    function equalByTag2(object3, other, tag, bitmask, customizer, equalFunc, stack) {
      switch (tag) {
        case dataViewTag4:
          if (object3.byteLength != other.byteLength || object3.byteOffset != other.byteOffset) {
            return false;
          }
          object3 = object3.buffer;
          other = other.buffer;
        case arrayBufferTag3:
          if (object3.byteLength != other.byteLength || !equalFunc(new Uint8Array3(object3), new Uint8Array3(other))) {
            return false;
          }
          return true;
        case boolTag3:
        case dateTag3:
        case numberTag3:
          return eq2(+object3, +other);
        case errorTag3:
          return object3.name == other.name && object3.message == other.message;
        case regexpTag3:
        case stringTag4:
          return object3 == other + "";
        case mapTag5:
          var convert4 = mapToArray2;
        case setTag5:
          var isPartial = bitmask & COMPARE_PARTIAL_FLAG7;
          convert4 || (convert4 = setToArray2);
          if (object3.size != other.size && !isPartial) {
            return false;
          }
          var stacked = stack.get(object3);
          if (stacked) {
            return stacked == other;
          }
          bitmask |= COMPARE_UNORDERED_FLAG5;
          stack.set(object3, other);
          var result = equalArrays2(convert4(object3), convert4(other), bitmask, customizer, equalFunc, stack);
          stack["delete"](object3);
          return result;
        case symbolTag3:
          if (symbolValueOf2) {
            return symbolValueOf2.call(object3) == symbolValueOf2.call(other);
          }
      }
      return false;
    }
    function equalObjects2(object3, other, bitmask, customizer, equalFunc, stack) {
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG7, objProps = getAllKeys2(object3), objLength = objProps.length, othProps = getAllKeys2(other), othLength = othProps.length;
      if (objLength != othLength && !isPartial) {
        return false;
      }
      var index = objLength;
      while (index--) {
        var key = objProps[index];
        if (!(isPartial ? key in other : hasOwnProperty13.call(other, key))) {
          return false;
        }
      }
      var stacked = stack.get(object3);
      if (stacked && stack.get(other)) {
        return stacked == other;
      }
      var result = true;
      stack.set(object3, other);
      stack.set(other, object3);
      var skipCtor = isPartial;
      while (++index < objLength) {
        key = objProps[index];
        var objValue = object3[key], othValue = other[key];
        if (customizer) {
          var compared = isPartial ? customizer(othValue, objValue, key, other, object3, stack) : customizer(objValue, othValue, key, object3, other, stack);
        }
        if (!(compared === void 0 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
          result = false;
          break;
        }
        skipCtor || (skipCtor = key == "constructor");
      }
      if (result && !skipCtor) {
        var objCtor = object3.constructor, othCtor = other.constructor;
        if (objCtor != othCtor && ("constructor" in object3 && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
          result = false;
        }
      }
      stack["delete"](object3);
      stack["delete"](other);
      return result;
    }
    function getAllKeys2(object3) {
      return baseGetAllKeys2(object3, keys5, getSymbols2);
    }
    function getMapData2(map2, key) {
      var data = map2.__data__;
      return isKeyable2(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
    }
    function getNative2(object3, key) {
      var value = getValue2(object3, key);
      return baseIsNative2(value) ? value : void 0;
    }
    function getRawTag2(value) {
      var isOwn = hasOwnProperty13.call(value, symToStringTag3), tag = value[symToStringTag3];
      try {
        value[symToStringTag3] = void 0;
        var unmasked = true;
      } catch (e) {
      }
      var result = nativeObjectToString3.call(value);
      if (unmasked) {
        if (isOwn) {
          value[symToStringTag3] = tag;
        } else {
          delete value[symToStringTag3];
        }
      }
      return result;
    }
    var getSymbols2 = !nativeGetSymbols3 ? stubArray2 : function(object3) {
      if (object3 == null) {
        return [];
      }
      object3 = Object(object3);
      return arrayFilter2(nativeGetSymbols3(object3), function(symbol) {
        return propertyIsEnumerable3.call(object3, symbol);
      });
    };
    var getTag2 = baseGetTag2;
    if (DataView2 && getTag2(new DataView2(new ArrayBuffer(1))) != dataViewTag4 || Map3 && getTag2(new Map3()) != mapTag5 || Promise3 && getTag2(Promise3.resolve()) != promiseTag2 || Set3 && getTag2(new Set3()) != setTag5 || WeakMap3 && getTag2(new WeakMap3()) != weakMapTag3) {
      getTag2 = function(value) {
        var result = baseGetTag2(value), Ctor = result == objectTag5 ? value.constructor : void 0, ctorString = Ctor ? toSource2(Ctor) : "";
        if (ctorString) {
          switch (ctorString) {
            case dataViewCtorString2:
              return dataViewTag4;
            case mapCtorString2:
              return mapTag5;
            case promiseCtorString2:
              return promiseTag2;
            case setCtorString2:
              return setTag5;
            case weakMapCtorString2:
              return weakMapTag3;
          }
        }
        return result;
      };
    }
    function isIndex2(value, length) {
      length = length == null ? MAX_SAFE_INTEGER3 : length;
      return !!length && (typeof value == "number" || reIsUint2.test(value)) && (value > -1 && value % 1 == 0 && value < length);
    }
    function isKeyable2(value) {
      var type2 = typeof value;
      return type2 == "string" || type2 == "number" || type2 == "symbol" || type2 == "boolean" ? value !== "__proto__" : value === null;
    }
    function isMasked2(func) {
      return !!maskSrcKey2 && maskSrcKey2 in func;
    }
    function isPrototype2(value) {
      var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto16;
      return value === proto;
    }
    function objectToString2(value) {
      return nativeObjectToString3.call(value);
    }
    function toSource2(func) {
      if (func != null) {
        try {
          return funcToString4.call(func);
        } catch (e) {
        }
        try {
          return func + "";
        } catch (e) {
        }
      }
      return "";
    }
    function eq2(value, other) {
      return value === other || value !== value && other !== other;
    }
    var isArguments2 = baseIsArguments2(/* @__PURE__ */ function() {
      return arguments;
    }()) ? baseIsArguments2 : function(value) {
      return isObjectLike3(value) && hasOwnProperty13.call(value, "callee") && !propertyIsEnumerable3.call(value, "callee");
    };
    var isArray2 = Array.isArray;
    function isArrayLike2(value) {
      return value != null && isLength2(value.length) && !isFunction2(value);
    }
    var isBuffer2 = nativeIsBuffer2 || stubFalse2;
    function isEqual2(value, other) {
      return baseIsEqual2(value, other);
    }
    function isFunction2(value) {
      if (!isObject3(value)) {
        return false;
      }
      var tag = baseGetTag2(value);
      return tag == funcTag3 || tag == genTag2 || tag == asyncTag2 || tag == proxyTag2;
    }
    function isLength2(value) {
      return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER3;
    }
    function isObject3(value) {
      var type2 = typeof value;
      return value != null && (type2 == "object" || type2 == "function");
    }
    function isObjectLike3(value) {
      return value != null && typeof value == "object";
    }
    var isTypedArray2 = nodeIsTypedArray2 ? baseUnary2(nodeIsTypedArray2) : baseIsTypedArray2;
    function keys5(object3) {
      return isArrayLike2(object3) ? arrayLikeKeys2(object3) : baseKeys2(object3);
    }
    function stubArray2() {
      return [];
    }
    function stubFalse2() {
      return false;
    }
    module2.exports = isEqual2;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/oas2/remove-unused-components.js
var require_remove_unused_components = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/oas2/remove-unused-components.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RemoveUnusedComponents = void 0;
    var utils_1 = require_utils4();
    var RemoveUnusedComponents = () => {
      const components = /* @__PURE__ */ new Map();
      function registerComponent(location, componentType, name) {
        var _a;
        components.set(location.absolutePointer, {
          used: ((_a = components.get(location.absolutePointer)) === null || _a === void 0 ? void 0 : _a.used) || false,
          componentType,
          name
        });
      }
      return {
        ref: {
          leave(ref, { type: type2, resolve, key }) {
            if (["Schema", "Parameter", "Response", "SecurityScheme"].includes(type2.name)) {
              const resolvedRef = resolve(ref);
              if (!resolvedRef.location)
                return;
              const [fileLocation, localPointer] = resolvedRef.location.absolutePointer.split("#", 2);
              const componentLevelLocalPointer = localPointer.split("/").slice(0, 3).join("/");
              const pointer = `${fileLocation}#${componentLevelLocalPointer}`;
              components.set(pointer, {
                used: true,
                name: key.toString()
              });
            }
          }
        },
        Root: {
          leave(root2, ctx) {
            const data = ctx.getVisitorData();
            data.removedCount = 0;
            const rootComponents = /* @__PURE__ */ new Set();
            components.forEach((usageInfo) => {
              const { used, name, componentType } = usageInfo;
              if (!used && componentType) {
                rootComponents.add(componentType);
                delete root2[componentType][name];
                data.removedCount++;
              }
            });
            for (const component of rootComponents) {
              if ((0, utils_1.isEmptyObject)(root2[component])) {
                delete root2[component];
              }
            }
          }
        },
        NamedSchemas: {
          Schema(schema2, { location, key }) {
            if (!schema2.allOf) {
              registerComponent(location, "definitions", key.toString());
            }
          }
        },
        NamedParameters: {
          Parameter(_parameter, { location, key }) {
            registerComponent(location, "parameters", key.toString());
          }
        },
        NamedResponses: {
          Response(_response, { location, key }) {
            registerComponent(location, "responses", key.toString());
          }
        },
        NamedSecuritySchemes: {
          SecurityScheme(_securityScheme, { location, key }) {
            registerComponent(location, "securityDefinitions", key.toString());
          }
        }
      };
    };
    exports2.RemoveUnusedComponents = RemoveUnusedComponents;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/oas3/remove-unused-components.js
var require_remove_unused_components2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/oas3/remove-unused-components.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RemoveUnusedComponents = void 0;
    var utils_1 = require_utils4();
    var RemoveUnusedComponents = () => {
      const components = /* @__PURE__ */ new Map();
      function registerComponent(location, componentType, name) {
        var _a;
        components.set(location.absolutePointer, {
          used: ((_a = components.get(location.absolutePointer)) === null || _a === void 0 ? void 0 : _a.used) || false,
          componentType,
          name
        });
      }
      return {
        ref: {
          leave(ref, { type: type2, resolve, key }) {
            if (["Schema", "Header", "Parameter", "Response", "Example", "RequestBody"].includes(type2.name)) {
              const resolvedRef = resolve(ref);
              if (!resolvedRef.location)
                return;
              const [fileLocation, localPointer] = resolvedRef.location.absolutePointer.split("#", 2);
              const componentLevelLocalPointer = localPointer.split("/").slice(0, 4).join("/");
              const pointer = `${fileLocation}#${componentLevelLocalPointer}`;
              components.set(pointer, {
                used: true,
                name: key.toString()
              });
            }
          }
        },
        Root: {
          leave(root2, ctx) {
            const data = ctx.getVisitorData();
            data.removedCount = 0;
            components.forEach((usageInfo) => {
              const { used, componentType, name } = usageInfo;
              if (!used && componentType && root2.components) {
                const componentChild = root2.components[componentType];
                delete componentChild[name];
                data.removedCount++;
                if ((0, utils_1.isEmptyObject)(componentChild)) {
                  delete root2.components[componentType];
                }
              }
            });
            if ((0, utils_1.isEmptyObject)(root2.components)) {
              delete root2.components;
            }
          }
        },
        NamedSchemas: {
          Schema(schema2, { location, key }) {
            if (!schema2.allOf) {
              registerComponent(location, "schemas", key.toString());
            }
          }
        },
        NamedParameters: {
          Parameter(_parameter, { location, key }) {
            registerComponent(location, "parameters", key.toString());
          }
        },
        NamedResponses: {
          Response(_response, { location, key }) {
            registerComponent(location, "responses", key.toString());
          }
        },
        NamedExamples: {
          Example(_example, { location, key }) {
            registerComponent(location, "examples", key.toString());
          }
        },
        NamedRequestBodies: {
          RequestBody(_requestBody, { location, key }) {
            registerComponent(location, "requestBodies", key.toString());
          }
        },
        NamedHeaders: {
          Header(_header, { location, key }) {
            registerComponent(location, "headers", key.toString());
          }
        }
      };
    };
    exports2.RemoveUnusedComponents = RemoveUnusedComponents;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/bundle.js
var require_bundle = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/bundle.js"(exports2) {
    "use strict";
    var __awaiter = exports2 && exports2.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.mapTypeToComponent = exports2.bundleDocument = exports2.bundleFromString = exports2.bundle = exports2.OasVersion = void 0;
    var isEqual2 = require_lodash();
    var resolve_1 = require_resolve2();
    var visitors_1 = require_visitors();
    var types_1 = require_types();
    var walk_1 = require_walk();
    var oas_types_1 = require_oas_types();
    var ref_utils_1 = require_ref_utils();
    var rules_1 = require_rules();
    var no_unresolved_refs_1 = require_no_unresolved_refs();
    var utils_1 = require_utils4();
    var redocly_1 = require_redocly();
    var remove_unused_components_1 = require_remove_unused_components();
    var remove_unused_components_2 = require_remove_unused_components2();
    var OasVersion;
    (function(OasVersion2) {
      OasVersion2["Version2"] = "oas2";
      OasVersion2["Version3_0"] = "oas3_0";
      OasVersion2["Version3_1"] = "oas3_1";
    })(OasVersion || (exports2.OasVersion = OasVersion = {}));
    function bundle2(opts) {
      return __awaiter(this, void 0, void 0, function* () {
        const { ref, doc, externalRefResolver = new resolve_1.BaseResolver(opts.config.resolve), base = null } = opts;
        if (!(ref || doc)) {
          throw new Error("Document or reference is required.\n");
        }
        const document2 = doc === void 0 ? yield externalRefResolver.resolveDocument(base, ref, true) : doc;
        if (document2 instanceof Error) {
          throw document2;
        }
        return bundleDocument(Object.assign(Object.assign({ document: document2 }, opts), { config: opts.config.styleguide, externalRefResolver }));
      });
    }
    exports2.bundle = bundle2;
    function bundleFromString(opts) {
      return __awaiter(this, void 0, void 0, function* () {
        const { source, absoluteRef, externalRefResolver = new resolve_1.BaseResolver(opts.config.resolve) } = opts;
        const document2 = (0, resolve_1.makeDocumentFromString)(source, absoluteRef || "/");
        return bundleDocument(Object.assign(Object.assign({ document: document2 }, opts), { externalRefResolver, config: opts.config.styleguide }));
      });
    }
    exports2.bundleFromString = bundleFromString;
    function bundleDocument(opts) {
      return __awaiter(this, void 0, void 0, function* () {
        const { document: document2, config, customTypes, externalRefResolver, dereference = false, skipRedoclyRegistryRefs = false, removeUnusedComponents = false, keepUrlRefs = false } = opts;
        const specVersion = (0, oas_types_1.detectSpec)(document2.parsed);
        const specMajorVersion = (0, oas_types_1.getMajorSpecVersion)(specVersion);
        const rules = config.getRulesForOasVersion(specMajorVersion);
        const types2 = (0, types_1.normalizeTypes)(config.extendTypes(customTypes !== null && customTypes !== void 0 ? customTypes : (0, oas_types_1.getTypes)(specVersion), specVersion), config);
        const preprocessors = (0, rules_1.initRules)(rules, config, "preprocessors", specVersion);
        const decorators = (0, rules_1.initRules)(rules, config, "decorators", specVersion);
        const ctx = {
          problems: [],
          oasVersion: specVersion,
          refTypes: /* @__PURE__ */ new Map(),
          visitorsData: {}
        };
        if (removeUnusedComponents) {
          decorators.push({
            severity: "error",
            ruleId: "remove-unused-components",
            visitor: specMajorVersion === oas_types_1.SpecMajorVersion.OAS2 ? (0, remove_unused_components_1.RemoveUnusedComponents)({}) : (0, remove_unused_components_2.RemoveUnusedComponents)({})
          });
        }
        let resolvedRefMap = yield (0, resolve_1.resolveDocument)({
          rootDocument: document2,
          rootType: types2.Root,
          externalRefResolver
        });
        if (preprocessors.length > 0) {
          (0, walk_1.walkDocument)({
            document: document2,
            rootType: types2.Root,
            normalizedVisitors: (0, visitors_1.normalizeVisitors)(preprocessors, types2),
            resolvedRefMap,
            ctx
          });
          resolvedRefMap = yield (0, resolve_1.resolveDocument)({
            rootDocument: document2,
            rootType: types2.Root,
            externalRefResolver
          });
        }
        const bundleVisitor = (0, visitors_1.normalizeVisitors)([
          {
            severity: "error",
            ruleId: "bundler",
            visitor: makeBundleVisitor(specMajorVersion, dereference, skipRedoclyRegistryRefs, document2, resolvedRefMap, keepUrlRefs)
          },
          ...decorators
        ], types2);
        (0, walk_1.walkDocument)({
          document: document2,
          rootType: types2.Root,
          normalizedVisitors: bundleVisitor,
          resolvedRefMap,
          ctx
        });
        return {
          bundle: document2,
          problems: ctx.problems.map((problem) => config.addProblemToIgnore(problem)),
          fileDependencies: externalRefResolver.getFiles(),
          rootType: types2.Root,
          refTypes: ctx.refTypes,
          visitorsData: ctx.visitorsData
        };
      });
    }
    exports2.bundleDocument = bundleDocument;
    function mapTypeToComponent(typeName, version) {
      switch (version) {
        case oas_types_1.SpecMajorVersion.OAS3:
          switch (typeName) {
            case "Schema":
              return "schemas";
            case "Parameter":
              return "parameters";
            case "Response":
              return "responses";
            case "Example":
              return "examples";
            case "RequestBody":
              return "requestBodies";
            case "Header":
              return "headers";
            case "SecuritySchema":
              return "securitySchemes";
            case "Link":
              return "links";
            case "Callback":
              return "callbacks";
            default:
              return null;
          }
        case oas_types_1.SpecMajorVersion.OAS2:
          switch (typeName) {
            case "Schema":
              return "definitions";
            case "Parameter":
              return "parameters";
            case "Response":
              return "responses";
            default:
              return null;
          }
        case oas_types_1.SpecMajorVersion.Async2:
          switch (typeName) {
            case "Schema":
              return "schemas";
            case "Parameter":
              return "parameters";
            default:
              return null;
          }
      }
    }
    exports2.mapTypeToComponent = mapTypeToComponent;
    function makeBundleVisitor(version, dereference, skipRedoclyRegistryRefs, rootDocument, resolvedRefMap, keepUrlRefs) {
      let components;
      let rootLocation;
      const visitor = {
        ref: {
          leave(node, ctx, resolved) {
            if (!resolved.location || resolved.node === void 0) {
              (0, no_unresolved_refs_1.reportUnresolvedRef)(resolved, ctx.report, ctx.location);
              return;
            }
            if (resolved.location.source === rootDocument.source && resolved.location.source === ctx.location.source && ctx.type.name !== "scalar" && !dereference) {
              return;
            }
            if (skipRedoclyRegistryRefs && (0, redocly_1.isRedoclyRegistryURL)(node.$ref)) {
              return;
            }
            if (keepUrlRefs && (0, ref_utils_1.isAbsoluteUrl)(node.$ref)) {
              return;
            }
            const componentType = mapTypeToComponent(ctx.type.name, version);
            if (!componentType) {
              replaceRef(node, resolved, ctx);
            } else {
              if (dereference) {
                saveComponent(componentType, resolved, ctx);
                replaceRef(node, resolved, ctx);
              } else {
                node.$ref = saveComponent(componentType, resolved, ctx);
                resolveBundledComponent(node, resolved, ctx);
              }
            }
          }
        },
        Root: {
          enter(root2, ctx) {
            rootLocation = ctx.location;
            if (version === oas_types_1.SpecMajorVersion.OAS3) {
              components = root2.components = root2.components || {};
            } else if (version === oas_types_1.SpecMajorVersion.OAS2) {
              components = root2;
            }
          }
        }
      };
      if (version === oas_types_1.SpecMajorVersion.OAS3) {
        visitor.DiscriminatorMapping = {
          leave(mapping, ctx) {
            for (const name of Object.keys(mapping)) {
              const $ref = mapping[name];
              const resolved = ctx.resolve({ $ref });
              if (!resolved.location || resolved.node === void 0) {
                (0, no_unresolved_refs_1.reportUnresolvedRef)(resolved, ctx.report, ctx.location.child(name));
                return;
              }
              const componentType = mapTypeToComponent("Schema", version);
              if (dereference) {
                saveComponent(componentType, resolved, ctx);
              } else {
                mapping[name] = saveComponent(componentType, resolved, ctx);
              }
            }
          }
        };
      }
      function resolveBundledComponent(node, resolved, ctx) {
        const newRefId = (0, resolve_1.makeRefId)(ctx.location.source.absoluteRef, node.$ref);
        resolvedRefMap.set(newRefId, {
          document: rootDocument,
          isRemote: false,
          node: resolved.node,
          nodePointer: node.$ref,
          resolved: true
        });
      }
      function replaceRef(ref, resolved, ctx) {
        if (!(0, utils_1.isPlainObject)(resolved.node)) {
          ctx.parent[ctx.key] = resolved.node;
        } else {
          delete ref.$ref;
          const obj = Object.assign({}, resolved.node, ref);
          Object.assign(ref, obj);
        }
      }
      function saveComponent(componentType, target, ctx) {
        components[componentType] = components[componentType] || {};
        const name = getComponentName(target, componentType, ctx);
        components[componentType][name] = target.node;
        if (version === oas_types_1.SpecMajorVersion.OAS3) {
          return `#/components/${componentType}/${name}`;
        } else {
          return `#/${componentType}/${name}`;
        }
      }
      function isEqualOrEqualRef(node, target, ctx) {
        var _a;
        if ((0, ref_utils_1.isRef)(node) && ((_a = ctx.resolve(node, rootLocation.absolutePointer).location) === null || _a === void 0 ? void 0 : _a.absolutePointer) === target.location.absolutePointer) {
          return true;
        }
        return isEqual2(node, target.node);
      }
      function getComponentName(target, componentType, ctx) {
        const [fileRef, pointer] = [target.location.source.absoluteRef, target.location.pointer];
        const componentsGroup = components[componentType];
        let name = "";
        const refParts = pointer.slice(2).split("/").filter(utils_1.isTruthy);
        while (refParts.length > 0) {
          name = refParts.pop() + (name ? `-${name}` : "");
          if (!componentsGroup || !componentsGroup[name] || isEqualOrEqualRef(componentsGroup[name], target, ctx)) {
            return name;
          }
        }
        name = (0, ref_utils_1.refBaseName)(fileRef) + (name ? `_${name}` : "");
        if (!componentsGroup[name] || isEqualOrEqualRef(componentsGroup[name], target, ctx)) {
          return name;
        }
        const prevName = name;
        let serialId = 2;
        while (componentsGroup[name] && !isEqualOrEqualRef(componentsGroup[name], target, ctx)) {
          name = `${prevName}-${serialId}`;
          serialId++;
        }
        if (!componentsGroup[name]) {
          ctx.report({
            message: `Two schemas are referenced with the same name but different content. Renamed ${prevName} to ${name}.`,
            location: ctx.location,
            forceSeverity: "warn"
          });
        }
        return name;
      }
      return visitor;
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/index.js
var require_lib3 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.lintConfig = exports2.lintFromString = exports2.lintDocument = exports2.validate = exports2.lint = exports2.getTotals = exports2.formatProblems = exports2.getLineColLocation = exports2.getAstNodeByPointer = exports2.walkDocument = exports2.normalizeVisitors = exports2.getTypes = exports2.detectSpec = exports2.SpecVersion = exports2.getMajorSpecVersion = exports2.SpecMajorVersion = exports2.isAbsoluteUrl = exports2.isRef = exports2.unescapePointer = exports2.stringifyYaml = exports2.parseYaml = exports2.makeDocumentFromString = exports2.YamlParseError = exports2.ResolveError = exports2.resolveDocument = exports2.BaseResolver = exports2.Source = exports2.isRedoclyRegistryURL = exports2.RedoclyClient = exports2.createConfig = exports2.CONFIG_FILE_NAMES = exports2.findConfig = exports2.getConfig = exports2.loadConfig = exports2.transformConfig = exports2.getMergedConfig = exports2.IGNORE_FILE = exports2.StyleguideConfig = exports2.Config = exports2.Stats = exports2.normalizeTypes = exports2.ConfigTypes = exports2.AsyncApi2Types = exports2.Oas2Types = exports2.Oas3Types = exports2.Oas3_1Types = exports2.isTruthy = exports2.doesYamlFileExist = exports2.slash = exports2.readFileFromUrl = void 0;
    exports2.bundleFromString = exports2.mapTypeToComponent = exports2.bundleDocument = exports2.bundle = void 0;
    var utils_1 = require_utils4();
    Object.defineProperty(exports2, "readFileFromUrl", { enumerable: true, get: function() {
      return utils_1.readFileFromUrl;
    } });
    Object.defineProperty(exports2, "slash", { enumerable: true, get: function() {
      return utils_1.slash;
    } });
    Object.defineProperty(exports2, "doesYamlFileExist", { enumerable: true, get: function() {
      return utils_1.doesYamlFileExist;
    } });
    Object.defineProperty(exports2, "isTruthy", { enumerable: true, get: function() {
      return utils_1.isTruthy;
    } });
    var oas3_1_1 = require_oas3_1();
    Object.defineProperty(exports2, "Oas3_1Types", { enumerable: true, get: function() {
      return oas3_1_1.Oas3_1Types;
    } });
    var oas3_1 = require_oas3();
    Object.defineProperty(exports2, "Oas3Types", { enumerable: true, get: function() {
      return oas3_1.Oas3Types;
    } });
    var oas2_1 = require_oas2();
    Object.defineProperty(exports2, "Oas2Types", { enumerable: true, get: function() {
      return oas2_1.Oas2Types;
    } });
    var asyncapi_1 = require_asyncapi();
    Object.defineProperty(exports2, "AsyncApi2Types", { enumerable: true, get: function() {
      return asyncapi_1.AsyncApi2Types;
    } });
    var redocly_yaml_1 = require_redocly_yaml();
    Object.defineProperty(exports2, "ConfigTypes", { enumerable: true, get: function() {
      return redocly_yaml_1.ConfigTypes;
    } });
    var types_1 = require_types();
    Object.defineProperty(exports2, "normalizeTypes", { enumerable: true, get: function() {
      return types_1.normalizeTypes;
    } });
    var stats_1 = require_stats();
    Object.defineProperty(exports2, "Stats", { enumerable: true, get: function() {
      return stats_1.Stats;
    } });
    var config_1 = require_config2();
    Object.defineProperty(exports2, "Config", { enumerable: true, get: function() {
      return config_1.Config;
    } });
    Object.defineProperty(exports2, "StyleguideConfig", { enumerable: true, get: function() {
      return config_1.StyleguideConfig;
    } });
    Object.defineProperty(exports2, "IGNORE_FILE", { enumerable: true, get: function() {
      return config_1.IGNORE_FILE;
    } });
    Object.defineProperty(exports2, "getMergedConfig", { enumerable: true, get: function() {
      return config_1.getMergedConfig;
    } });
    Object.defineProperty(exports2, "transformConfig", { enumerable: true, get: function() {
      return config_1.transformConfig;
    } });
    Object.defineProperty(exports2, "loadConfig", { enumerable: true, get: function() {
      return config_1.loadConfig;
    } });
    Object.defineProperty(exports2, "getConfig", { enumerable: true, get: function() {
      return config_1.getConfig;
    } });
    Object.defineProperty(exports2, "findConfig", { enumerable: true, get: function() {
      return config_1.findConfig;
    } });
    Object.defineProperty(exports2, "CONFIG_FILE_NAMES", { enumerable: true, get: function() {
      return config_1.CONFIG_FILE_NAMES;
    } });
    Object.defineProperty(exports2, "createConfig", { enumerable: true, get: function() {
      return config_1.createConfig;
    } });
    var redocly_1 = require_redocly();
    Object.defineProperty(exports2, "RedoclyClient", { enumerable: true, get: function() {
      return redocly_1.RedoclyClient;
    } });
    Object.defineProperty(exports2, "isRedoclyRegistryURL", { enumerable: true, get: function() {
      return redocly_1.isRedoclyRegistryURL;
    } });
    var resolve_1 = require_resolve2();
    Object.defineProperty(exports2, "Source", { enumerable: true, get: function() {
      return resolve_1.Source;
    } });
    Object.defineProperty(exports2, "BaseResolver", { enumerable: true, get: function() {
      return resolve_1.BaseResolver;
    } });
    Object.defineProperty(exports2, "resolveDocument", { enumerable: true, get: function() {
      return resolve_1.resolveDocument;
    } });
    Object.defineProperty(exports2, "ResolveError", { enumerable: true, get: function() {
      return resolve_1.ResolveError;
    } });
    Object.defineProperty(exports2, "YamlParseError", { enumerable: true, get: function() {
      return resolve_1.YamlParseError;
    } });
    Object.defineProperty(exports2, "makeDocumentFromString", { enumerable: true, get: function() {
      return resolve_1.makeDocumentFromString;
    } });
    var js_yaml_1 = require_js_yaml2();
    Object.defineProperty(exports2, "parseYaml", { enumerable: true, get: function() {
      return js_yaml_1.parseYaml;
    } });
    Object.defineProperty(exports2, "stringifyYaml", { enumerable: true, get: function() {
      return js_yaml_1.stringifyYaml;
    } });
    var ref_utils_1 = require_ref_utils();
    Object.defineProperty(exports2, "unescapePointer", { enumerable: true, get: function() {
      return ref_utils_1.unescapePointer;
    } });
    Object.defineProperty(exports2, "isRef", { enumerable: true, get: function() {
      return ref_utils_1.isRef;
    } });
    Object.defineProperty(exports2, "isAbsoluteUrl", { enumerable: true, get: function() {
      return ref_utils_1.isAbsoluteUrl;
    } });
    var oas_types_1 = require_oas_types();
    Object.defineProperty(exports2, "SpecMajorVersion", { enumerable: true, get: function() {
      return oas_types_1.SpecMajorVersion;
    } });
    Object.defineProperty(exports2, "getMajorSpecVersion", { enumerable: true, get: function() {
      return oas_types_1.getMajorSpecVersion;
    } });
    Object.defineProperty(exports2, "SpecVersion", { enumerable: true, get: function() {
      return oas_types_1.SpecVersion;
    } });
    Object.defineProperty(exports2, "detectSpec", { enumerable: true, get: function() {
      return oas_types_1.detectSpec;
    } });
    Object.defineProperty(exports2, "getTypes", { enumerable: true, get: function() {
      return oas_types_1.getTypes;
    } });
    var visitors_1 = require_visitors();
    Object.defineProperty(exports2, "normalizeVisitors", { enumerable: true, get: function() {
      return visitors_1.normalizeVisitors;
    } });
    var walk_1 = require_walk();
    Object.defineProperty(exports2, "walkDocument", { enumerable: true, get: function() {
      return walk_1.walkDocument;
    } });
    var codeframes_1 = require_codeframes();
    Object.defineProperty(exports2, "getAstNodeByPointer", { enumerable: true, get: function() {
      return codeframes_1.getAstNodeByPointer;
    } });
    Object.defineProperty(exports2, "getLineColLocation", { enumerable: true, get: function() {
      return codeframes_1.getLineColLocation;
    } });
    var format_1 = require_format3();
    Object.defineProperty(exports2, "formatProblems", { enumerable: true, get: function() {
      return format_1.formatProblems;
    } });
    Object.defineProperty(exports2, "getTotals", { enumerable: true, get: function() {
      return format_1.getTotals;
    } });
    var lint_1 = require_lint();
    Object.defineProperty(exports2, "lint", { enumerable: true, get: function() {
      return lint_1.lint;
    } });
    Object.defineProperty(exports2, "validate", { enumerable: true, get: function() {
      return lint_1.lint;
    } });
    Object.defineProperty(exports2, "lintDocument", { enumerable: true, get: function() {
      return lint_1.lintDocument;
    } });
    Object.defineProperty(exports2, "lintFromString", { enumerable: true, get: function() {
      return lint_1.lintFromString;
    } });
    Object.defineProperty(exports2, "lintConfig", { enumerable: true, get: function() {
      return lint_1.lintConfig;
    } });
    var bundle_1 = require_bundle();
    Object.defineProperty(exports2, "bundle", { enumerable: true, get: function() {
      return bundle_1.bundle;
    } });
    Object.defineProperty(exports2, "bundleDocument", { enumerable: true, get: function() {
      return bundle_1.bundleDocument;
    } });
    Object.defineProperty(exports2, "mapTypeToComponent", { enumerable: true, get: function() {
      return bundle_1.mapTypeToComponent;
    } });
    Object.defineProperty(exports2, "bundleFromString", { enumerable: true, get: function() {
      return bundle_1.bundleFromString;
    } });
  }
});

// ../../../node_modules/.pnpm/object-hash@3.0.0/node_modules/object-hash/index.js
var require_object_hash = __commonJS({
  "../../../node_modules/.pnpm/object-hash@3.0.0/node_modules/object-hash/index.js"(exports2, module2) {
    "use strict";
    var crypto2 = require("crypto");
    exports2 = module2.exports = objectHash;
    function objectHash(object3, options) {
      options = applyDefaults(object3, options);
      return hash2(object3, options);
    }
    exports2.sha1 = function(object3) {
      return objectHash(object3);
    };
    exports2.keys = function(object3) {
      return objectHash(object3, { excludeValues: true, algorithm: "sha1", encoding: "hex" });
    };
    exports2.MD5 = function(object3) {
      return objectHash(object3, { algorithm: "md5", encoding: "hex" });
    };
    exports2.keysMD5 = function(object3) {
      return objectHash(object3, { algorithm: "md5", encoding: "hex", excludeValues: true });
    };
    var hashes = crypto2.getHashes ? crypto2.getHashes().slice() : ["sha1", "md5"];
    hashes.push("passthrough");
    var encodings = ["buffer", "hex", "binary", "base64"];
    function applyDefaults(object3, sourceOptions) {
      sourceOptions = sourceOptions || {};
      var options = {};
      options.algorithm = sourceOptions.algorithm || "sha1";
      options.encoding = sourceOptions.encoding || "hex";
      options.excludeValues = sourceOptions.excludeValues ? true : false;
      options.algorithm = options.algorithm.toLowerCase();
      options.encoding = options.encoding.toLowerCase();
      options.ignoreUnknown = sourceOptions.ignoreUnknown !== true ? false : true;
      options.respectType = sourceOptions.respectType === false ? false : true;
      options.respectFunctionNames = sourceOptions.respectFunctionNames === false ? false : true;
      options.respectFunctionProperties = sourceOptions.respectFunctionProperties === false ? false : true;
      options.unorderedArrays = sourceOptions.unorderedArrays !== true ? false : true;
      options.unorderedSets = sourceOptions.unorderedSets === false ? false : true;
      options.unorderedObjects = sourceOptions.unorderedObjects === false ? false : true;
      options.replacer = sourceOptions.replacer || void 0;
      options.excludeKeys = sourceOptions.excludeKeys || void 0;
      if (typeof object3 === "undefined") {
        throw new Error("Object argument required.");
      }
      for (var i = 0; i < hashes.length; ++i) {
        if (hashes[i].toLowerCase() === options.algorithm.toLowerCase()) {
          options.algorithm = hashes[i];
        }
      }
      if (hashes.indexOf(options.algorithm) === -1) {
        throw new Error('Algorithm "' + options.algorithm + '"  not supported. supported values: ' + hashes.join(", "));
      }
      if (encodings.indexOf(options.encoding) === -1 && options.algorithm !== "passthrough") {
        throw new Error('Encoding "' + options.encoding + '"  not supported. supported values: ' + encodings.join(", "));
      }
      return options;
    }
    function isNativeFunction(f) {
      if (typeof f !== "function") {
        return false;
      }
      var exp = /^function\s+\w*\s*\(\s*\)\s*{\s+\[native code\]\s+}$/i;
      return exp.exec(Function.prototype.toString.call(f)) != null;
    }
    function hash2(object3, options) {
      var hashingStream;
      if (options.algorithm !== "passthrough") {
        hashingStream = crypto2.createHash(options.algorithm);
      } else {
        hashingStream = new PassThrough3();
      }
      if (typeof hashingStream.write === "undefined") {
        hashingStream.write = hashingStream.update;
        hashingStream.end = hashingStream.update;
      }
      var hasher = typeHasher(options, hashingStream);
      hasher.dispatch(object3);
      if (!hashingStream.update) {
        hashingStream.end("");
      }
      if (hashingStream.digest) {
        return hashingStream.digest(options.encoding === "buffer" ? void 0 : options.encoding);
      }
      var buf = hashingStream.read();
      if (options.encoding === "buffer") {
        return buf;
      }
      return buf.toString(options.encoding);
    }
    exports2.writeToStream = function(object3, options, stream) {
      if (typeof stream === "undefined") {
        stream = options;
        options = {};
      }
      options = applyDefaults(object3, options);
      return typeHasher(options, stream).dispatch(object3);
    };
    function typeHasher(options, writeTo, context) {
      context = context || [];
      var write = function(str2) {
        if (writeTo.update) {
          return writeTo.update(str2, "utf8");
        } else {
          return writeTo.write(str2, "utf8");
        }
      };
      return {
        dispatch: function(value) {
          if (options.replacer) {
            value = options.replacer(value);
          }
          var type2 = typeof value;
          if (value === null) {
            type2 = "null";
          }
          return this["_" + type2](value);
        },
        _object: function(object3) {
          var pattern = /\[object (.*)\]/i;
          var objString = Object.prototype.toString.call(object3);
          var objType = pattern.exec(objString);
          if (!objType) {
            objType = "unknown:[" + objString + "]";
          } else {
            objType = objType[1];
          }
          objType = objType.toLowerCase();
          var objectNumber = null;
          if ((objectNumber = context.indexOf(object3)) >= 0) {
            return this.dispatch("[CIRCULAR:" + objectNumber + "]");
          } else {
            context.push(object3);
          }
          if (typeof Buffer !== "undefined" && Buffer.isBuffer && Buffer.isBuffer(object3)) {
            write("buffer:");
            return write(object3);
          }
          if (objType !== "object" && objType !== "function" && objType !== "asyncfunction") {
            if (this["_" + objType]) {
              this["_" + objType](object3);
            } else if (options.ignoreUnknown) {
              return write("[" + objType + "]");
            } else {
              throw new Error('Unknown object type "' + objType + '"');
            }
          } else {
            var keys5 = Object.keys(object3);
            if (options.unorderedObjects) {
              keys5 = keys5.sort();
            }
            if (options.respectType !== false && !isNativeFunction(object3)) {
              keys5.splice(0, 0, "prototype", "__proto__", "constructor");
            }
            if (options.excludeKeys) {
              keys5 = keys5.filter(function(key) {
                return !options.excludeKeys(key);
              });
            }
            write("object:" + keys5.length + ":");
            var self2 = this;
            return keys5.forEach(function(key) {
              self2.dispatch(key);
              write(":");
              if (!options.excludeValues) {
                self2.dispatch(object3[key]);
              }
              write(",");
            });
          }
        },
        _array: function(arr, unordered) {
          unordered = typeof unordered !== "undefined" ? unordered : options.unorderedArrays !== false;
          var self2 = this;
          write("array:" + arr.length + ":");
          if (!unordered || arr.length <= 1) {
            return arr.forEach(function(entry) {
              return self2.dispatch(entry);
            });
          }
          var contextAdditions = [];
          var entries4 = arr.map(function(entry) {
            var strm = new PassThrough3();
            var localContext = context.slice();
            var hasher = typeHasher(options, strm, localContext);
            hasher.dispatch(entry);
            contextAdditions = contextAdditions.concat(localContext.slice(context.length));
            return strm.read().toString();
          });
          context = context.concat(contextAdditions);
          entries4.sort();
          return this._array(entries4, false);
        },
        _date: function(date3) {
          return write("date:" + date3.toJSON());
        },
        _symbol: function(sym) {
          return write("symbol:" + sym.toString());
        },
        _error: function(err) {
          return write("error:" + err.toString());
        },
        _boolean: function(bool2) {
          return write("bool:" + bool2.toString());
        },
        _string: function(string3) {
          write("string:" + string3.length + ":");
          write(string3.toString());
        },
        _function: function(fn) {
          write("fn:");
          if (isNativeFunction(fn)) {
            this.dispatch("[native]");
          } else {
            this.dispatch(fn.toString());
          }
          if (options.respectFunctionNames !== false) {
            this.dispatch("function-name:" + String(fn.name));
          }
          if (options.respectFunctionProperties) {
            this._object(fn);
          }
        },
        _number: function(number3) {
          return write("number:" + number3.toString());
        },
        _xml: function(xml) {
          return write("xml:" + xml.toString());
        },
        _null: function() {
          return write("Null");
        },
        _undefined: function() {
          return write("Undefined");
        },
        _regexp: function(regex) {
          return write("regex:" + regex.toString());
        },
        _uint8array: function(arr) {
          write("uint8array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _uint8clampedarray: function(arr) {
          write("uint8clampedarray:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _int8array: function(arr) {
          write("int8array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _uint16array: function(arr) {
          write("uint16array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _int16array: function(arr) {
          write("int16array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _uint32array: function(arr) {
          write("uint32array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _int32array: function(arr) {
          write("int32array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _float32array: function(arr) {
          write("float32array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _float64array: function(arr) {
          write("float64array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _arraybuffer: function(arr) {
          write("arraybuffer:");
          return this.dispatch(new Uint8Array(arr));
        },
        _url: function(url) {
          return write("url:" + url.toString(), "utf8");
        },
        _map: function(map2) {
          write("map:");
          var arr = Array.from(map2);
          return this._array(arr, options.unorderedSets !== false);
        },
        _set: function(set4) {
          write("set:");
          var arr = Array.from(set4);
          return this._array(arr, options.unorderedSets !== false);
        },
        _file: function(file) {
          write("file:");
          return this.dispatch([file.name, file.size, file.type, file.lastModfied]);
        },
        _blob: function() {
          if (options.ignoreUnknown) {
            return write("[blob]");
          }
          throw Error('Hashing Blob objects is currently not supported\n(see https://github.com/puleos/object-hash/issues/26)\nUse "options.replacer" or "options.ignoreUnknown"\n');
        },
        _domwindow: function() {
          return write("domwindow");
        },
        _bigint: function(number3) {
          return write("bigint:" + number3.toString());
        },
        /* Node.js standard native objects */
        _process: function() {
          return write("process");
        },
        _timer: function() {
          return write("timer");
        },
        _pipe: function() {
          return write("pipe");
        },
        _tcp: function() {
          return write("tcp");
        },
        _udp: function() {
          return write("udp");
        },
        _tty: function() {
          return write("tty");
        },
        _statwatcher: function() {
          return write("statwatcher");
        },
        _securecontext: function() {
          return write("securecontext");
        },
        _connection: function() {
          return write("connection");
        },
        _zlib: function() {
          return write("zlib");
        },
        _context: function() {
          return write("context");
        },
        _nodescript: function() {
          return write("nodescript");
        },
        _httpparser: function() {
          return write("httpparser");
        },
        _dataview: function() {
          return write("dataview");
        },
        _signal: function() {
          return write("signal");
        },
        _fsevent: function() {
          return write("fsevent");
        },
        _tlswrap: function() {
          return write("tlswrap");
        }
      };
    }
    function PassThrough3() {
      return {
        buf: "",
        write: function(b) {
          this.buf += b;
        },
        end: function(b) {
          this.buf += b;
        },
        read: function() {
          return this.buf;
        }
      };
    }
  }
});

// src/index.ts
var src_exports = {};
__export(src_exports, {
  generateDynamicIR: () => generateDynamicIR
});
module.exports = __toCommonJS(src_exports);

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_freeGlobal.js
var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
var freeGlobal_default = freeGlobal;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_root.js
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root = freeGlobal_default || freeSelf || Function("return this")();
var root_default = root;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Symbol.js
var Symbol2 = root_default.Symbol;
var Symbol_default = Symbol2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getRawTag.js
var objectProto = Object.prototype;
var hasOwnProperty = objectProto.hasOwnProperty;
var nativeObjectToString = objectProto.toString;
var symToStringTag = Symbol_default ? Symbol_default.toStringTag : void 0;
function getRawTag(value) {
  var isOwn = hasOwnProperty.call(value, symToStringTag), tag = value[symToStringTag];
  try {
    value[symToStringTag] = void 0;
    var unmasked = true;
  } catch (e) {
  }
  var result = nativeObjectToString.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag] = tag;
    } else {
      delete value[symToStringTag];
    }
  }
  return result;
}
var getRawTag_default = getRawTag;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_objectToString.js
var objectProto2 = Object.prototype;
var nativeObjectToString2 = objectProto2.toString;
function objectToString(value) {
  return nativeObjectToString2.call(value);
}
var objectToString_default = objectToString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGetTag.js
var nullTag = "[object Null]";
var undefinedTag = "[object Undefined]";
var symToStringTag2 = Symbol_default ? Symbol_default.toStringTag : void 0;
function baseGetTag(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag2 && symToStringTag2 in Object(value) ? getRawTag_default(value) : objectToString_default(value);
}
var baseGetTag_default = baseGetTag;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObjectLike.js
function isObjectLike(value) {
  return value != null && typeof value == "object";
}
var isObjectLike_default = isObjectLike;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isSymbol.js
var symbolTag = "[object Symbol]";
function isSymbol(value) {
  return typeof value == "symbol" || isObjectLike_default(value) && baseGetTag_default(value) == symbolTag;
}
var isSymbol_default = isSymbol;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayMap.js
function arrayMap(array, iteratee) {
  var index = -1, length = array == null ? 0 : array.length, result = Array(length);
  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}
var arrayMap_default = arrayMap;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArray.js
var isArray = Array.isArray;
var isArray_default = isArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseToString.js
var INFINITY = 1 / 0;
var symbolProto = Symbol_default ? Symbol_default.prototype : void 0;
var symbolToString = symbolProto ? symbolProto.toString : void 0;
function baseToString(value) {
  if (typeof value == "string") {
    return value;
  }
  if (isArray_default(value)) {
    return arrayMap_default(value, baseToString) + "";
  }
  if (isSymbol_default(value)) {
    return symbolToString ? symbolToString.call(value) : "";
  }
  var result = value + "";
  return result == "0" && 1 / value == -INFINITY ? "-0" : result;
}
var baseToString_default = baseToString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObject.js
function isObject(value) {
  var type2 = typeof value;
  return value != null && (type2 == "object" || type2 == "function");
}
var isObject_default = isObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/identity.js
function identity(value) {
  return value;
}
var identity_default = identity;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isFunction.js
var asyncTag = "[object AsyncFunction]";
var funcTag = "[object Function]";
var genTag = "[object GeneratorFunction]";
var proxyTag = "[object Proxy]";
function isFunction(value) {
  if (!isObject_default(value)) {
    return false;
  }
  var tag = baseGetTag_default(value);
  return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
}
var isFunction_default = isFunction;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_coreJsData.js
var coreJsData = root_default["__core-js_shared__"];
var coreJsData_default = coreJsData;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isMasked.js
var maskSrcKey = function() {
  var uid = /[^.]+$/.exec(coreJsData_default && coreJsData_default.keys && coreJsData_default.keys.IE_PROTO || "");
  return uid ? "Symbol(src)_1." + uid : "";
}();
function isMasked(func) {
  return !!maskSrcKey && maskSrcKey in func;
}
var isMasked_default = isMasked;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_toSource.js
var funcProto = Function.prototype;
var funcToString = funcProto.toString;
function toSource(func) {
  if (func != null) {
    try {
      return funcToString.call(func);
    } catch (e) {
    }
    try {
      return func + "";
    } catch (e) {
    }
  }
  return "";
}
var toSource_default = toSource;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsNative.js
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
var reIsHostCtor = /^\[object .+?Constructor\]$/;
var funcProto2 = Function.prototype;
var objectProto3 = Object.prototype;
var funcToString2 = funcProto2.toString;
var hasOwnProperty2 = objectProto3.hasOwnProperty;
var reIsNative = RegExp(
  "^" + funcToString2.call(hasOwnProperty2).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
);
function baseIsNative(value) {
  if (!isObject_default(value) || isMasked_default(value)) {
    return false;
  }
  var pattern = isFunction_default(value) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource_default(value));
}
var baseIsNative_default = baseIsNative;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getValue.js
function getValue(object3, key) {
  return object3 == null ? void 0 : object3[key];
}
var getValue_default = getValue;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getNative.js
function getNative(object3, key) {
  var value = getValue_default(object3, key);
  return baseIsNative_default(value) ? value : void 0;
}
var getNative_default = getNative;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_WeakMap.js
var WeakMap2 = getNative_default(root_default, "WeakMap");
var WeakMap_default = WeakMap2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseCreate.js
var objectCreate = Object.create;
var baseCreate = /* @__PURE__ */ function() {
  function object3() {
  }
  return function(proto) {
    if (!isObject_default(proto)) {
      return {};
    }
    if (objectCreate) {
      return objectCreate(proto);
    }
    object3.prototype = proto;
    var result = new object3();
    object3.prototype = void 0;
    return result;
  };
}();
var baseCreate_default = baseCreate;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_apply.js
function apply(func, thisArg, args) {
  switch (args.length) {
    case 0:
      return func.call(thisArg);
    case 1:
      return func.call(thisArg, args[0]);
    case 2:
      return func.call(thisArg, args[0], args[1]);
    case 3:
      return func.call(thisArg, args[0], args[1], args[2]);
  }
  return func.apply(thisArg, args);
}
var apply_default = apply;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_copyArray.js
function copyArray(source, array) {
  var index = -1, length = source.length;
  array || (array = Array(length));
  while (++index < length) {
    array[index] = source[index];
  }
  return array;
}
var copyArray_default = copyArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_shortOut.js
var HOT_COUNT = 800;
var HOT_SPAN = 16;
var nativeNow = Date.now;
function shortOut(func) {
  var count = 0, lastCalled = 0;
  return function() {
    var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
    lastCalled = stamp;
    if (remaining > 0) {
      if (++count >= HOT_COUNT) {
        return arguments[0];
      }
    } else {
      count = 0;
    }
    return func.apply(void 0, arguments);
  };
}
var shortOut_default = shortOut;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/constant.js
function constant(value) {
  return function() {
    return value;
  };
}
var constant_default = constant;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_defineProperty.js
var defineProperty = function() {
  try {
    var func = getNative_default(Object, "defineProperty");
    func({}, "", {});
    return func;
  } catch (e) {
  }
}();
var defineProperty_default = defineProperty;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseSetToString.js
var baseSetToString = !defineProperty_default ? identity_default : function(func, string3) {
  return defineProperty_default(func, "toString", {
    "configurable": true,
    "enumerable": false,
    "value": constant_default(string3),
    "writable": true
  });
};
var baseSetToString_default = baseSetToString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_setToString.js
var setToString = shortOut_default(baseSetToString_default);
var setToString_default = setToString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseFindIndex.js
function baseFindIndex(array, predicate, fromIndex, fromRight) {
  var length = array.length, index = fromIndex + (fromRight ? 1 : -1);
  while (fromRight ? index-- : ++index < length) {
    if (predicate(array[index], index, array)) {
      return index;
    }
  }
  return -1;
}
var baseFindIndex_default = baseFindIndex;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsNaN.js
function baseIsNaN(value) {
  return value !== value;
}
var baseIsNaN_default = baseIsNaN;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_strictIndexOf.js
function strictIndexOf(array, value, fromIndex) {
  var index = fromIndex - 1, length = array.length;
  while (++index < length) {
    if (array[index] === value) {
      return index;
    }
  }
  return -1;
}
var strictIndexOf_default = strictIndexOf;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIndexOf.js
function baseIndexOf(array, value, fromIndex) {
  return value === value ? strictIndexOf_default(array, value, fromIndex) : baseFindIndex_default(array, baseIsNaN_default, fromIndex);
}
var baseIndexOf_default = baseIndexOf;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayIncludes.js
function arrayIncludes(array, value) {
  var length = array == null ? 0 : array.length;
  return !!length && baseIndexOf_default(array, value, 0) > -1;
}
var arrayIncludes_default = arrayIncludes;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isIndex.js
var MAX_SAFE_INTEGER = 9007199254740991;
var reIsUint = /^(?:0|[1-9]\d*)$/;
function isIndex(value, length) {
  var type2 = typeof value;
  length = length == null ? MAX_SAFE_INTEGER : length;
  return !!length && (type2 == "number" || type2 != "symbol" && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
}
var isIndex_default = isIndex;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseAssignValue.js
function baseAssignValue(object3, key, value) {
  if (key == "__proto__" && defineProperty_default) {
    defineProperty_default(object3, key, {
      "configurable": true,
      "enumerable": true,
      "value": value,
      "writable": true
    });
  } else {
    object3[key] = value;
  }
}
var baseAssignValue_default = baseAssignValue;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/eq.js
function eq(value, other) {
  return value === other || value !== value && other !== other;
}
var eq_default = eq;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_assignValue.js
var objectProto4 = Object.prototype;
var hasOwnProperty3 = objectProto4.hasOwnProperty;
function assignValue(object3, key, value) {
  var objValue = object3[key];
  if (!(hasOwnProperty3.call(object3, key) && eq_default(objValue, value)) || value === void 0 && !(key in object3)) {
    baseAssignValue_default(object3, key, value);
  }
}
var assignValue_default = assignValue;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_copyObject.js
function copyObject(source, props, object3, customizer) {
  var isNew = !object3;
  object3 || (object3 = {});
  var index = -1, length = props.length;
  while (++index < length) {
    var key = props[index];
    var newValue = customizer ? customizer(object3[key], source[key], key, object3, source) : void 0;
    if (newValue === void 0) {
      newValue = source[key];
    }
    if (isNew) {
      baseAssignValue_default(object3, key, newValue);
    } else {
      assignValue_default(object3, key, newValue);
    }
  }
  return object3;
}
var copyObject_default = copyObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_overRest.js
var nativeMax = Math.max;
function overRest(func, start, transform3) {
  start = nativeMax(start === void 0 ? func.length - 1 : start, 0);
  return function() {
    var args = arguments, index = -1, length = nativeMax(args.length - start, 0), array = Array(length);
    while (++index < length) {
      array[index] = args[start + index];
    }
    index = -1;
    var otherArgs = Array(start + 1);
    while (++index < start) {
      otherArgs[index] = args[index];
    }
    otherArgs[start] = transform3(array);
    return apply_default(func, this, otherArgs);
  };
}
var overRest_default = overRest;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseRest.js
function baseRest(func, start) {
  return setToString_default(overRest_default(func, start, identity_default), func + "");
}
var baseRest_default = baseRest;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isLength.js
var MAX_SAFE_INTEGER2 = 9007199254740991;
function isLength(value) {
  return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER2;
}
var isLength_default = isLength;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArrayLike.js
function isArrayLike(value) {
  return value != null && isLength_default(value.length) && !isFunction_default(value);
}
var isArrayLike_default = isArrayLike;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isIterateeCall.js
function isIterateeCall(value, index, object3) {
  if (!isObject_default(object3)) {
    return false;
  }
  var type2 = typeof index;
  if (type2 == "number" ? isArrayLike_default(object3) && isIndex_default(index, object3.length) : type2 == "string" && index in object3) {
    return eq_default(object3[index], value);
  }
  return false;
}
var isIterateeCall_default = isIterateeCall;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createAssigner.js
function createAssigner(assigner) {
  return baseRest_default(function(object3, sources) {
    var index = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : void 0, guard = length > 2 ? sources[2] : void 0;
    customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : void 0;
    if (guard && isIterateeCall_default(sources[0], sources[1], guard)) {
      customizer = length < 3 ? void 0 : customizer;
      length = 1;
    }
    object3 = Object(object3);
    while (++index < length) {
      var source = sources[index];
      if (source) {
        assigner(object3, source, index, customizer);
      }
    }
    return object3;
  });
}
var createAssigner_default = createAssigner;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isPrototype.js
var objectProto5 = Object.prototype;
function isPrototype(value) {
  var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto5;
  return value === proto;
}
var isPrototype_default = isPrototype;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseTimes.js
function baseTimes(n, iteratee) {
  var index = -1, result = Array(n);
  while (++index < n) {
    result[index] = iteratee(index);
  }
  return result;
}
var baseTimes_default = baseTimes;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsArguments.js
var argsTag = "[object Arguments]";
function baseIsArguments(value) {
  return isObjectLike_default(value) && baseGetTag_default(value) == argsTag;
}
var baseIsArguments_default = baseIsArguments;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArguments.js
var objectProto6 = Object.prototype;
var hasOwnProperty4 = objectProto6.hasOwnProperty;
var propertyIsEnumerable = objectProto6.propertyIsEnumerable;
var isArguments = baseIsArguments_default(/* @__PURE__ */ function() {
  return arguments;
}()) ? baseIsArguments_default : function(value) {
  return isObjectLike_default(value) && hasOwnProperty4.call(value, "callee") && !propertyIsEnumerable.call(value, "callee");
};
var isArguments_default = isArguments;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/stubFalse.js
function stubFalse() {
  return false;
}
var stubFalse_default = stubFalse;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isBuffer.js
var freeExports = typeof exports == "object" && exports && !exports.nodeType && exports;
var freeModule = freeExports && typeof module == "object" && module && !module.nodeType && module;
var moduleExports = freeModule && freeModule.exports === freeExports;
var Buffer2 = moduleExports ? root_default.Buffer : void 0;
var nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : void 0;
var isBuffer = nativeIsBuffer || stubFalse_default;
var isBuffer_default = isBuffer;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsTypedArray.js
var argsTag2 = "[object Arguments]";
var arrayTag = "[object Array]";
var boolTag = "[object Boolean]";
var dateTag = "[object Date]";
var errorTag = "[object Error]";
var funcTag2 = "[object Function]";
var mapTag = "[object Map]";
var numberTag = "[object Number]";
var objectTag = "[object Object]";
var regexpTag = "[object RegExp]";
var setTag = "[object Set]";
var stringTag = "[object String]";
var weakMapTag = "[object WeakMap]";
var arrayBufferTag = "[object ArrayBuffer]";
var dataViewTag = "[object DataView]";
var float32Tag = "[object Float32Array]";
var float64Tag = "[object Float64Array]";
var int8Tag = "[object Int8Array]";
var int16Tag = "[object Int16Array]";
var int32Tag = "[object Int32Array]";
var uint8Tag = "[object Uint8Array]";
var uint8ClampedTag = "[object Uint8ClampedArray]";
var uint16Tag = "[object Uint16Array]";
var uint32Tag = "[object Uint32Array]";
var typedArrayTags = {};
typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
typedArrayTags[argsTag2] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag2] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;
function baseIsTypedArray(value) {
  return isObjectLike_default(value) && isLength_default(value.length) && !!typedArrayTags[baseGetTag_default(value)];
}
var baseIsTypedArray_default = baseIsTypedArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseUnary.js
function baseUnary(func) {
  return function(value) {
    return func(value);
  };
}
var baseUnary_default = baseUnary;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_nodeUtil.js
var freeExports2 = typeof exports == "object" && exports && !exports.nodeType && exports;
var freeModule2 = freeExports2 && typeof module == "object" && module && !module.nodeType && module;
var moduleExports2 = freeModule2 && freeModule2.exports === freeExports2;
var freeProcess = moduleExports2 && freeGlobal_default.process;
var nodeUtil = function() {
  try {
    var types2 = freeModule2 && freeModule2.require && freeModule2.require("util").types;
    if (types2) {
      return types2;
    }
    return freeProcess && freeProcess.binding && freeProcess.binding("util");
  } catch (e) {
  }
}();
var nodeUtil_default = nodeUtil;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isTypedArray.js
var nodeIsTypedArray = nodeUtil_default && nodeUtil_default.isTypedArray;
var isTypedArray = nodeIsTypedArray ? baseUnary_default(nodeIsTypedArray) : baseIsTypedArray_default;
var isTypedArray_default = isTypedArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayLikeKeys.js
var objectProto7 = Object.prototype;
var hasOwnProperty5 = objectProto7.hasOwnProperty;
function arrayLikeKeys(value, inherited) {
  var isArr = isArray_default(value), isArg = !isArr && isArguments_default(value), isBuff = !isArr && !isArg && isBuffer_default(value), isType = !isArr && !isArg && !isBuff && isTypedArray_default(value), skipIndexes = isArr || isArg || isBuff || isType, result = skipIndexes ? baseTimes_default(value.length, String) : [], length = result.length;
  for (var key in value) {
    if ((inherited || hasOwnProperty5.call(value, key)) && !(skipIndexes && // Safari 9 has enumerable `arguments.length` in strict mode.
    (key == "length" || // Node.js 0.10 has enumerable non-index properties on buffers.
    isBuff && (key == "offset" || key == "parent") || // PhantomJS 2 has enumerable non-index properties on typed arrays.
    isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || // Skip index properties.
    isIndex_default(key, length)))) {
      result.push(key);
    }
  }
  return result;
}
var arrayLikeKeys_default = arrayLikeKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_overArg.js
function overArg(func, transform3) {
  return function(arg) {
    return func(transform3(arg));
  };
}
var overArg_default = overArg;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_nativeKeys.js
var nativeKeys = overArg_default(Object.keys, Object);
var nativeKeys_default = nativeKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseKeys.js
var objectProto8 = Object.prototype;
var hasOwnProperty6 = objectProto8.hasOwnProperty;
function baseKeys(object3) {
  if (!isPrototype_default(object3)) {
    return nativeKeys_default(object3);
  }
  var result = [];
  for (var key in Object(object3)) {
    if (hasOwnProperty6.call(object3, key) && key != "constructor") {
      result.push(key);
    }
  }
  return result;
}
var baseKeys_default = baseKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/keys.js
function keys(object3) {
  return isArrayLike_default(object3) ? arrayLikeKeys_default(object3) : baseKeys_default(object3);
}
var keys_default = keys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_nativeKeysIn.js
function nativeKeysIn(object3) {
  var result = [];
  if (object3 != null) {
    for (var key in Object(object3)) {
      result.push(key);
    }
  }
  return result;
}
var nativeKeysIn_default = nativeKeysIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseKeysIn.js
var objectProto9 = Object.prototype;
var hasOwnProperty7 = objectProto9.hasOwnProperty;
function baseKeysIn(object3) {
  if (!isObject_default(object3)) {
    return nativeKeysIn_default(object3);
  }
  var isProto = isPrototype_default(object3), result = [];
  for (var key in object3) {
    if (!(key == "constructor" && (isProto || !hasOwnProperty7.call(object3, key)))) {
      result.push(key);
    }
  }
  return result;
}
var baseKeysIn_default = baseKeysIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/keysIn.js
function keysIn(object3) {
  return isArrayLike_default(object3) ? arrayLikeKeys_default(object3, true) : baseKeysIn_default(object3);
}
var keysIn_default = keysIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isKey.js
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/;
var reIsPlainProp = /^\w*$/;
function isKey(value, object3) {
  if (isArray_default(value)) {
    return false;
  }
  var type2 = typeof value;
  if (type2 == "number" || type2 == "symbol" || type2 == "boolean" || value == null || isSymbol_default(value)) {
    return true;
  }
  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object3 != null && value in Object(object3);
}
var isKey_default = isKey;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_nativeCreate.js
var nativeCreate = getNative_default(Object, "create");
var nativeCreate_default = nativeCreate;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hashClear.js
function hashClear() {
  this.__data__ = nativeCreate_default ? nativeCreate_default(null) : {};
  this.size = 0;
}
var hashClear_default = hashClear;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hashDelete.js
function hashDelete(key) {
  var result = this.has(key) && delete this.__data__[key];
  this.size -= result ? 1 : 0;
  return result;
}
var hashDelete_default = hashDelete;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hashGet.js
var HASH_UNDEFINED = "__lodash_hash_undefined__";
var objectProto10 = Object.prototype;
var hasOwnProperty8 = objectProto10.hasOwnProperty;
function hashGet(key) {
  var data = this.__data__;
  if (nativeCreate_default) {
    var result = data[key];
    return result === HASH_UNDEFINED ? void 0 : result;
  }
  return hasOwnProperty8.call(data, key) ? data[key] : void 0;
}
var hashGet_default = hashGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hashHas.js
var objectProto11 = Object.prototype;
var hasOwnProperty9 = objectProto11.hasOwnProperty;
function hashHas(key) {
  var data = this.__data__;
  return nativeCreate_default ? data[key] !== void 0 : hasOwnProperty9.call(data, key);
}
var hashHas_default = hashHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hashSet.js
var HASH_UNDEFINED2 = "__lodash_hash_undefined__";
function hashSet(key, value) {
  var data = this.__data__;
  this.size += this.has(key) ? 0 : 1;
  data[key] = nativeCreate_default && value === void 0 ? HASH_UNDEFINED2 : value;
  return this;
}
var hashSet_default = hashSet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Hash.js
function Hash(entries4) {
  var index = -1, length = entries4 == null ? 0 : entries4.length;
  this.clear();
  while (++index < length) {
    var entry = entries4[index];
    this.set(entry[0], entry[1]);
  }
}
Hash.prototype.clear = hashClear_default;
Hash.prototype["delete"] = hashDelete_default;
Hash.prototype.get = hashGet_default;
Hash.prototype.has = hashHas_default;
Hash.prototype.set = hashSet_default;
var Hash_default = Hash;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_listCacheClear.js
function listCacheClear() {
  this.__data__ = [];
  this.size = 0;
}
var listCacheClear_default = listCacheClear;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_assocIndexOf.js
function assocIndexOf(array, key) {
  var length = array.length;
  while (length--) {
    if (eq_default(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}
var assocIndexOf_default = assocIndexOf;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_listCacheDelete.js
var arrayProto = Array.prototype;
var splice = arrayProto.splice;
function listCacheDelete(key) {
  var data = this.__data__, index = assocIndexOf_default(data, key);
  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }
  --this.size;
  return true;
}
var listCacheDelete_default = listCacheDelete;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_listCacheGet.js
function listCacheGet(key) {
  var data = this.__data__, index = assocIndexOf_default(data, key);
  return index < 0 ? void 0 : data[index][1];
}
var listCacheGet_default = listCacheGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_listCacheHas.js
function listCacheHas(key) {
  return assocIndexOf_default(this.__data__, key) > -1;
}
var listCacheHas_default = listCacheHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_listCacheSet.js
function listCacheSet(key, value) {
  var data = this.__data__, index = assocIndexOf_default(data, key);
  if (index < 0) {
    ++this.size;
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}
var listCacheSet_default = listCacheSet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_ListCache.js
function ListCache(entries4) {
  var index = -1, length = entries4 == null ? 0 : entries4.length;
  this.clear();
  while (++index < length) {
    var entry = entries4[index];
    this.set(entry[0], entry[1]);
  }
}
ListCache.prototype.clear = listCacheClear_default;
ListCache.prototype["delete"] = listCacheDelete_default;
ListCache.prototype.get = listCacheGet_default;
ListCache.prototype.has = listCacheHas_default;
ListCache.prototype.set = listCacheSet_default;
var ListCache_default = ListCache;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Map.js
var Map2 = getNative_default(root_default, "Map");
var Map_default = Map2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapCacheClear.js
function mapCacheClear() {
  this.size = 0;
  this.__data__ = {
    "hash": new Hash_default(),
    "map": new (Map_default || ListCache_default)(),
    "string": new Hash_default()
  };
}
var mapCacheClear_default = mapCacheClear;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isKeyable.js
function isKeyable(value) {
  var type2 = typeof value;
  return type2 == "string" || type2 == "number" || type2 == "symbol" || type2 == "boolean" ? value !== "__proto__" : value === null;
}
var isKeyable_default = isKeyable;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getMapData.js
function getMapData(map2, key) {
  var data = map2.__data__;
  return isKeyable_default(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
}
var getMapData_default = getMapData;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapCacheDelete.js
function mapCacheDelete(key) {
  var result = getMapData_default(this, key)["delete"](key);
  this.size -= result ? 1 : 0;
  return result;
}
var mapCacheDelete_default = mapCacheDelete;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapCacheGet.js
function mapCacheGet(key) {
  return getMapData_default(this, key).get(key);
}
var mapCacheGet_default = mapCacheGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapCacheHas.js
function mapCacheHas(key) {
  return getMapData_default(this, key).has(key);
}
var mapCacheHas_default = mapCacheHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapCacheSet.js
function mapCacheSet(key, value) {
  var data = getMapData_default(this, key), size2 = data.size;
  data.set(key, value);
  this.size += data.size == size2 ? 0 : 1;
  return this;
}
var mapCacheSet_default = mapCacheSet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_MapCache.js
function MapCache(entries4) {
  var index = -1, length = entries4 == null ? 0 : entries4.length;
  this.clear();
  while (++index < length) {
    var entry = entries4[index];
    this.set(entry[0], entry[1]);
  }
}
MapCache.prototype.clear = mapCacheClear_default;
MapCache.prototype["delete"] = mapCacheDelete_default;
MapCache.prototype.get = mapCacheGet_default;
MapCache.prototype.has = mapCacheHas_default;
MapCache.prototype.set = mapCacheSet_default;
var MapCache_default = MapCache;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/memoize.js
var FUNC_ERROR_TEXT = "Expected a function";
function memoize(func, resolver) {
  if (typeof func != "function" || resolver != null && typeof resolver != "function") {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  var memoized = function() {
    var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
    if (cache.has(key)) {
      return cache.get(key);
    }
    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result) || cache;
    return result;
  };
  memoized.cache = new (memoize.Cache || MapCache_default)();
  return memoized;
}
memoize.Cache = MapCache_default;
var memoize_default = memoize;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_memoizeCapped.js
var MAX_MEMOIZE_SIZE = 500;
function memoizeCapped(func) {
  var result = memoize_default(func, function(key) {
    if (cache.size === MAX_MEMOIZE_SIZE) {
      cache.clear();
    }
    return key;
  });
  var cache = result.cache;
  return result;
}
var memoizeCapped_default = memoizeCapped;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stringToPath.js
var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
var reEscapeChar = /\\(\\)?/g;
var stringToPath = memoizeCapped_default(function(string3) {
  var result = [];
  if (string3.charCodeAt(0) === 46) {
    result.push("");
  }
  string3.replace(rePropName, function(match, number3, quote, subString) {
    result.push(quote ? subString.replace(reEscapeChar, "$1") : number3 || match);
  });
  return result;
});
var stringToPath_default = stringToPath;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/toString.js
function toString2(value) {
  return value == null ? "" : baseToString_default(value);
}
var toString_default = toString2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_castPath.js
function castPath(value, object3) {
  if (isArray_default(value)) {
    return value;
  }
  return isKey_default(value, object3) ? [value] : stringToPath_default(toString_default(value));
}
var castPath_default = castPath;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_toKey.js
var INFINITY2 = 1 / 0;
function toKey(value) {
  if (typeof value == "string" || isSymbol_default(value)) {
    return value;
  }
  var result = value + "";
  return result == "0" && 1 / value == -INFINITY2 ? "-0" : result;
}
var toKey_default = toKey;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGet.js
function baseGet(object3, path5) {
  path5 = castPath_default(path5, object3);
  var index = 0, length = path5.length;
  while (object3 != null && index < length) {
    object3 = object3[toKey_default(path5[index++])];
  }
  return index && index == length ? object3 : void 0;
}
var baseGet_default = baseGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/get.js
function get(object3, path5, defaultValue) {
  var result = object3 == null ? void 0 : baseGet_default(object3, path5);
  return result === void 0 ? defaultValue : result;
}
var get_default = get;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayPush.js
function arrayPush(array, values) {
  var index = -1, length = values.length, offset = array.length;
  while (++index < length) {
    array[offset + index] = values[index];
  }
  return array;
}
var arrayPush_default = arrayPush;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isFlattenable.js
var spreadableSymbol = Symbol_default ? Symbol_default.isConcatSpreadable : void 0;
function isFlattenable(value) {
  return isArray_default(value) || isArguments_default(value) || !!(spreadableSymbol && value && value[spreadableSymbol]);
}
var isFlattenable_default = isFlattenable;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseFlatten.js
function baseFlatten(array, depth, predicate, isStrict, result) {
  var index = -1, length = array.length;
  predicate || (predicate = isFlattenable_default);
  result || (result = []);
  while (++index < length) {
    var value = array[index];
    if (depth > 0 && predicate(value)) {
      if (depth > 1) {
        baseFlatten(value, depth - 1, predicate, isStrict, result);
      } else {
        arrayPush_default(result, value);
      }
    } else if (!isStrict) {
      result[result.length] = value;
    }
  }
  return result;
}
var baseFlatten_default = baseFlatten;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getPrototype.js
var getPrototype = overArg_default(Object.getPrototypeOf, Object);
var getPrototype_default = getPrototype;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isPlainObject.js
var objectTag2 = "[object Object]";
var funcProto3 = Function.prototype;
var objectProto12 = Object.prototype;
var funcToString3 = funcProto3.toString;
var hasOwnProperty10 = objectProto12.hasOwnProperty;
var objectCtorString = funcToString3.call(Object);
function isPlainObject(value) {
  if (!isObjectLike_default(value) || baseGetTag_default(value) != objectTag2) {
    return false;
  }
  var proto = getPrototype_default(value);
  if (proto === null) {
    return true;
  }
  var Ctor = hasOwnProperty10.call(proto, "constructor") && proto.constructor;
  return typeof Ctor == "function" && Ctor instanceof Ctor && funcToString3.call(Ctor) == objectCtorString;
}
var isPlainObject_default = isPlainObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseSlice.js
function baseSlice(array, start, end) {
  var index = -1, length = array.length;
  if (start < 0) {
    start = -start > length ? 0 : length + start;
  }
  end = end > length ? length : end;
  if (end < 0) {
    end += length;
  }
  length = start > end ? 0 : end - start >>> 0;
  start >>>= 0;
  var result = Array(length);
  while (++index < length) {
    result[index] = array[index + start];
  }
  return result;
}
var baseSlice_default = baseSlice;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_castSlice.js
function castSlice(array, start, end) {
  var length = array.length;
  end = end === void 0 ? length : end;
  return !start && end >= length ? array : baseSlice_default(array, start, end);
}
var castSlice_default = castSlice;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hasUnicode.js
var rsAstralRange = "\\ud800-\\udfff";
var rsComboMarksRange = "\\u0300-\\u036f";
var reComboHalfMarksRange = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange = "\\u20d0-\\u20ff";
var rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange;
var rsVarRange = "\\ufe0e\\ufe0f";
var rsZWJ = "\\u200d";
var reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + "]");
function hasUnicode(string3) {
  return reHasUnicode.test(string3);
}
var hasUnicode_default = hasUnicode;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_asciiToArray.js
function asciiToArray(string3) {
  return string3.split("");
}
var asciiToArray_default = asciiToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_unicodeToArray.js
var rsAstralRange2 = "\\ud800-\\udfff";
var rsComboMarksRange2 = "\\u0300-\\u036f";
var reComboHalfMarksRange2 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange2 = "\\u20d0-\\u20ff";
var rsComboRange2 = rsComboMarksRange2 + reComboHalfMarksRange2 + rsComboSymbolsRange2;
var rsVarRange2 = "\\ufe0e\\ufe0f";
var rsAstral = "[" + rsAstralRange2 + "]";
var rsCombo = "[" + rsComboRange2 + "]";
var rsFitz = "\\ud83c[\\udffb-\\udfff]";
var rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")";
var rsNonAstral = "[^" + rsAstralRange2 + "]";
var rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}";
var rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]";
var rsZWJ2 = "\\u200d";
var reOptMod = rsModifier + "?";
var rsOptVar = "[" + rsVarRange2 + "]?";
var rsOptJoin = "(?:" + rsZWJ2 + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*";
var rsSeq = rsOptVar + reOptMod + rsOptJoin;
var rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")";
var reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
function unicodeToArray(string3) {
  return string3.match(reUnicode) || [];
}
var unicodeToArray_default = unicodeToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stringToArray.js
function stringToArray(string3) {
  return hasUnicode_default(string3) ? unicodeToArray_default(string3) : asciiToArray_default(string3);
}
var stringToArray_default = stringToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createCaseFirst.js
function createCaseFirst(methodName) {
  return function(string3) {
    string3 = toString_default(string3);
    var strSymbols = hasUnicode_default(string3) ? stringToArray_default(string3) : void 0;
    var chr = strSymbols ? strSymbols[0] : string3.charAt(0);
    var trailing = strSymbols ? castSlice_default(strSymbols, 1).join("") : string3.slice(1);
    return chr[methodName]() + trailing;
  };
}
var createCaseFirst_default = createCaseFirst;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/upperFirst.js
var upperFirst = createCaseFirst_default("toUpperCase");
var upperFirst_default = upperFirst;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/capitalize.js
function capitalize(string3) {
  return upperFirst_default(toString_default(string3).toLowerCase());
}
var capitalize_default = capitalize;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayReduce.js
function arrayReduce(array, iteratee, accumulator, initAccum) {
  var index = -1, length = array == null ? 0 : array.length;
  if (initAccum && length) {
    accumulator = array[++index];
  }
  while (++index < length) {
    accumulator = iteratee(accumulator, array[index], index, array);
  }
  return accumulator;
}
var arrayReduce_default = arrayReduce;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_basePropertyOf.js
function basePropertyOf(object3) {
  return function(key) {
    return object3 == null ? void 0 : object3[key];
  };
}
var basePropertyOf_default = basePropertyOf;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_deburrLetter.js
var deburredLetters = {
  // Latin-1 Supplement block.
  "\xC0": "A",
  "\xC1": "A",
  "\xC2": "A",
  "\xC3": "A",
  "\xC4": "A",
  "\xC5": "A",
  "\xE0": "a",
  "\xE1": "a",
  "\xE2": "a",
  "\xE3": "a",
  "\xE4": "a",
  "\xE5": "a",
  "\xC7": "C",
  "\xE7": "c",
  "\xD0": "D",
  "\xF0": "d",
  "\xC8": "E",
  "\xC9": "E",
  "\xCA": "E",
  "\xCB": "E",
  "\xE8": "e",
  "\xE9": "e",
  "\xEA": "e",
  "\xEB": "e",
  "\xCC": "I",
  "\xCD": "I",
  "\xCE": "I",
  "\xCF": "I",
  "\xEC": "i",
  "\xED": "i",
  "\xEE": "i",
  "\xEF": "i",
  "\xD1": "N",
  "\xF1": "n",
  "\xD2": "O",
  "\xD3": "O",
  "\xD4": "O",
  "\xD5": "O",
  "\xD6": "O",
  "\xD8": "O",
  "\xF2": "o",
  "\xF3": "o",
  "\xF4": "o",
  "\xF5": "o",
  "\xF6": "o",
  "\xF8": "o",
  "\xD9": "U",
  "\xDA": "U",
  "\xDB": "U",
  "\xDC": "U",
  "\xF9": "u",
  "\xFA": "u",
  "\xFB": "u",
  "\xFC": "u",
  "\xDD": "Y",
  "\xFD": "y",
  "\xFF": "y",
  "\xC6": "Ae",
  "\xE6": "ae",
  "\xDE": "Th",
  "\xFE": "th",
  "\xDF": "ss",
  // Latin Extended-A block.
  "\u0100": "A",
  "\u0102": "A",
  "\u0104": "A",
  "\u0101": "a",
  "\u0103": "a",
  "\u0105": "a",
  "\u0106": "C",
  "\u0108": "C",
  "\u010A": "C",
  "\u010C": "C",
  "\u0107": "c",
  "\u0109": "c",
  "\u010B": "c",
  "\u010D": "c",
  "\u010E": "D",
  "\u0110": "D",
  "\u010F": "d",
  "\u0111": "d",
  "\u0112": "E",
  "\u0114": "E",
  "\u0116": "E",
  "\u0118": "E",
  "\u011A": "E",
  "\u0113": "e",
  "\u0115": "e",
  "\u0117": "e",
  "\u0119": "e",
  "\u011B": "e",
  "\u011C": "G",
  "\u011E": "G",
  "\u0120": "G",
  "\u0122": "G",
  "\u011D": "g",
  "\u011F": "g",
  "\u0121": "g",
  "\u0123": "g",
  "\u0124": "H",
  "\u0126": "H",
  "\u0125": "h",
  "\u0127": "h",
  "\u0128": "I",
  "\u012A": "I",
  "\u012C": "I",
  "\u012E": "I",
  "\u0130": "I",
  "\u0129": "i",
  "\u012B": "i",
  "\u012D": "i",
  "\u012F": "i",
  "\u0131": "i",
  "\u0134": "J",
  "\u0135": "j",
  "\u0136": "K",
  "\u0137": "k",
  "\u0138": "k",
  "\u0139": "L",
  "\u013B": "L",
  "\u013D": "L",
  "\u013F": "L",
  "\u0141": "L",
  "\u013A": "l",
  "\u013C": "l",
  "\u013E": "l",
  "\u0140": "l",
  "\u0142": "l",
  "\u0143": "N",
  "\u0145": "N",
  "\u0147": "N",
  "\u014A": "N",
  "\u0144": "n",
  "\u0146": "n",
  "\u0148": "n",
  "\u014B": "n",
  "\u014C": "O",
  "\u014E": "O",
  "\u0150": "O",
  "\u014D": "o",
  "\u014F": "o",
  "\u0151": "o",
  "\u0154": "R",
  "\u0156": "R",
  "\u0158": "R",
  "\u0155": "r",
  "\u0157": "r",
  "\u0159": "r",
  "\u015A": "S",
  "\u015C": "S",
  "\u015E": "S",
  "\u0160": "S",
  "\u015B": "s",
  "\u015D": "s",
  "\u015F": "s",
  "\u0161": "s",
  "\u0162": "T",
  "\u0164": "T",
  "\u0166": "T",
  "\u0163": "t",
  "\u0165": "t",
  "\u0167": "t",
  "\u0168": "U",
  "\u016A": "U",
  "\u016C": "U",
  "\u016E": "U",
  "\u0170": "U",
  "\u0172": "U",
  "\u0169": "u",
  "\u016B": "u",
  "\u016D": "u",
  "\u016F": "u",
  "\u0171": "u",
  "\u0173": "u",
  "\u0174": "W",
  "\u0175": "w",
  "\u0176": "Y",
  "\u0177": "y",
  "\u0178": "Y",
  "\u0179": "Z",
  "\u017B": "Z",
  "\u017D": "Z",
  "\u017A": "z",
  "\u017C": "z",
  "\u017E": "z",
  "\u0132": "IJ",
  "\u0133": "ij",
  "\u0152": "Oe",
  "\u0153": "oe",
  "\u0149": "'n",
  "\u017F": "s"
};
var deburrLetter = basePropertyOf_default(deburredLetters);
var deburrLetter_default = deburrLetter;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/deburr.js
var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;
var rsComboMarksRange3 = "\\u0300-\\u036f";
var reComboHalfMarksRange3 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange3 = "\\u20d0-\\u20ff";
var rsComboRange3 = rsComboMarksRange3 + reComboHalfMarksRange3 + rsComboSymbolsRange3;
var rsCombo2 = "[" + rsComboRange3 + "]";
var reComboMark = RegExp(rsCombo2, "g");
function deburr(string3) {
  string3 = toString_default(string3);
  return string3 && string3.replace(reLatin, deburrLetter_default).replace(reComboMark, "");
}
var deburr_default = deburr;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_asciiWords.js
var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
function asciiWords(string3) {
  return string3.match(reAsciiWord) || [];
}
var asciiWords_default = asciiWords;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hasUnicodeWord.js
var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
function hasUnicodeWord(string3) {
  return reHasUnicodeWord.test(string3);
}
var hasUnicodeWord_default = hasUnicodeWord;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_unicodeWords.js
var rsAstralRange3 = "\\ud800-\\udfff";
var rsComboMarksRange4 = "\\u0300-\\u036f";
var reComboHalfMarksRange4 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange4 = "\\u20d0-\\u20ff";
var rsComboRange4 = rsComboMarksRange4 + reComboHalfMarksRange4 + rsComboSymbolsRange4;
var rsDingbatRange = "\\u2700-\\u27bf";
var rsLowerRange = "a-z\\xdf-\\xf6\\xf8-\\xff";
var rsMathOpRange = "\\xac\\xb1\\xd7\\xf7";
var rsNonCharRange = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf";
var rsPunctuationRange = "\\u2000-\\u206f";
var rsSpaceRange = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000";
var rsUpperRange = "A-Z\\xc0-\\xd6\\xd8-\\xde";
var rsVarRange3 = "\\ufe0e\\ufe0f";
var rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;
var rsApos = "['\u2019]";
var rsBreak = "[" + rsBreakRange + "]";
var rsCombo3 = "[" + rsComboRange4 + "]";
var rsDigits = "\\d+";
var rsDingbat = "[" + rsDingbatRange + "]";
var rsLower = "[" + rsLowerRange + "]";
var rsMisc = "[^" + rsAstralRange3 + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + "]";
var rsFitz2 = "\\ud83c[\\udffb-\\udfff]";
var rsModifier2 = "(?:" + rsCombo3 + "|" + rsFitz2 + ")";
var rsNonAstral2 = "[^" + rsAstralRange3 + "]";
var rsRegional2 = "(?:\\ud83c[\\udde6-\\uddff]){2}";
var rsSurrPair2 = "[\\ud800-\\udbff][\\udc00-\\udfff]";
var rsUpper = "[" + rsUpperRange + "]";
var rsZWJ3 = "\\u200d";
var rsMiscLower = "(?:" + rsLower + "|" + rsMisc + ")";
var rsMiscUpper = "(?:" + rsUpper + "|" + rsMisc + ")";
var rsOptContrLower = "(?:" + rsApos + "(?:d|ll|m|re|s|t|ve))?";
var rsOptContrUpper = "(?:" + rsApos + "(?:D|LL|M|RE|S|T|VE))?";
var reOptMod2 = rsModifier2 + "?";
var rsOptVar2 = "[" + rsVarRange3 + "]?";
var rsOptJoin2 = "(?:" + rsZWJ3 + "(?:" + [rsNonAstral2, rsRegional2, rsSurrPair2].join("|") + ")" + rsOptVar2 + reOptMod2 + ")*";
var rsOrdLower = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])";
var rsOrdUpper = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])";
var rsSeq2 = rsOptVar2 + reOptMod2 + rsOptJoin2;
var rsEmoji = "(?:" + [rsDingbat, rsRegional2, rsSurrPair2].join("|") + ")" + rsSeq2;
var reUnicodeWord = RegExp([
  rsUpper + "?" + rsLower + "+" + rsOptContrLower + "(?=" + [rsBreak, rsUpper, "$"].join("|") + ")",
  rsMiscUpper + "+" + rsOptContrUpper + "(?=" + [rsBreak, rsUpper + rsMiscLower, "$"].join("|") + ")",
  rsUpper + "?" + rsMiscLower + "+" + rsOptContrLower,
  rsUpper + "+" + rsOptContrUpper,
  rsOrdUpper,
  rsOrdLower,
  rsDigits,
  rsEmoji
].join("|"), "g");
function unicodeWords(string3) {
  return string3.match(reUnicodeWord) || [];
}
var unicodeWords_default = unicodeWords;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/words.js
function words(string3, pattern, guard) {
  string3 = toString_default(string3);
  pattern = guard ? void 0 : pattern;
  if (pattern === void 0) {
    return hasUnicodeWord_default(string3) ? unicodeWords_default(string3) : asciiWords_default(string3);
  }
  return string3.match(pattern) || [];
}
var words_default = words;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createCompounder.js
var rsApos2 = "['\u2019]";
var reApos = RegExp(rsApos2, "g");
function createCompounder(callback) {
  return function(string3) {
    return arrayReduce_default(words_default(deburr_default(string3).replace(reApos, "")), callback, "");
  };
}
var createCompounder_default = createCompounder;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/camelCase.js
var camelCase = createCompounder_default(function(result, word, index) {
  word = word.toLowerCase();
  return result + (index ? capitalize_default(word) : word);
});
var camelCase_default = camelCase;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stackClear.js
function stackClear() {
  this.__data__ = new ListCache_default();
  this.size = 0;
}
var stackClear_default = stackClear;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stackDelete.js
function stackDelete(key) {
  var data = this.__data__, result = data["delete"](key);
  this.size = data.size;
  return result;
}
var stackDelete_default = stackDelete;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stackGet.js
function stackGet(key) {
  return this.__data__.get(key);
}
var stackGet_default = stackGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stackHas.js
function stackHas(key) {
  return this.__data__.has(key);
}
var stackHas_default = stackHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stackSet.js
var LARGE_ARRAY_SIZE = 200;
function stackSet(key, value) {
  var data = this.__data__;
  if (data instanceof ListCache_default) {
    var pairs2 = data.__data__;
    if (!Map_default || pairs2.length < LARGE_ARRAY_SIZE - 1) {
      pairs2.push([key, value]);
      this.size = ++data.size;
      return this;
    }
    data = this.__data__ = new MapCache_default(pairs2);
  }
  data.set(key, value);
  this.size = data.size;
  return this;
}
var stackSet_default = stackSet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Stack.js
function Stack(entries4) {
  var data = this.__data__ = new ListCache_default(entries4);
  this.size = data.size;
}
Stack.prototype.clear = stackClear_default;
Stack.prototype["delete"] = stackDelete_default;
Stack.prototype.get = stackGet_default;
Stack.prototype.has = stackHas_default;
Stack.prototype.set = stackSet_default;
var Stack_default = Stack;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cloneBuffer.js
var freeExports3 = typeof exports == "object" && exports && !exports.nodeType && exports;
var freeModule3 = freeExports3 && typeof module == "object" && module && !module.nodeType && module;
var moduleExports3 = freeModule3 && freeModule3.exports === freeExports3;
var Buffer3 = moduleExports3 ? root_default.Buffer : void 0;
var allocUnsafe = Buffer3 ? Buffer3.allocUnsafe : void 0;
function cloneBuffer(buffer, isDeep) {
  if (isDeep) {
    return buffer.slice();
  }
  var length = buffer.length, result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);
  buffer.copy(result);
  return result;
}
var cloneBuffer_default = cloneBuffer;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayFilter.js
function arrayFilter(array, predicate) {
  var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result = [];
  while (++index < length) {
    var value = array[index];
    if (predicate(value, index, array)) {
      result[resIndex++] = value;
    }
  }
  return result;
}
var arrayFilter_default = arrayFilter;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/stubArray.js
function stubArray() {
  return [];
}
var stubArray_default = stubArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getSymbols.js
var objectProto13 = Object.prototype;
var propertyIsEnumerable2 = objectProto13.propertyIsEnumerable;
var nativeGetSymbols = Object.getOwnPropertySymbols;
var getSymbols = !nativeGetSymbols ? stubArray_default : function(object3) {
  if (object3 == null) {
    return [];
  }
  object3 = Object(object3);
  return arrayFilter_default(nativeGetSymbols(object3), function(symbol) {
    return propertyIsEnumerable2.call(object3, symbol);
  });
};
var getSymbols_default = getSymbols;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getSymbolsIn.js
var nativeGetSymbols2 = Object.getOwnPropertySymbols;
var getSymbolsIn = !nativeGetSymbols2 ? stubArray_default : function(object3) {
  var result = [];
  while (object3) {
    arrayPush_default(result, getSymbols_default(object3));
    object3 = getPrototype_default(object3);
  }
  return result;
};
var getSymbolsIn_default = getSymbolsIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGetAllKeys.js
function baseGetAllKeys(object3, keysFunc, symbolsFunc) {
  var result = keysFunc(object3);
  return isArray_default(object3) ? result : arrayPush_default(result, symbolsFunc(object3));
}
var baseGetAllKeys_default = baseGetAllKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getAllKeys.js
function getAllKeys(object3) {
  return baseGetAllKeys_default(object3, keys_default, getSymbols_default);
}
var getAllKeys_default = getAllKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getAllKeysIn.js
function getAllKeysIn(object3) {
  return baseGetAllKeys_default(object3, keysIn_default, getSymbolsIn_default);
}
var getAllKeysIn_default = getAllKeysIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_DataView.js
var DataView = getNative_default(root_default, "DataView");
var DataView_default = DataView;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Promise.js
var Promise2 = getNative_default(root_default, "Promise");
var Promise_default = Promise2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Set.js
var Set2 = getNative_default(root_default, "Set");
var Set_default = Set2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getTag.js
var mapTag2 = "[object Map]";
var objectTag3 = "[object Object]";
var promiseTag = "[object Promise]";
var setTag2 = "[object Set]";
var weakMapTag2 = "[object WeakMap]";
var dataViewTag2 = "[object DataView]";
var dataViewCtorString = toSource_default(DataView_default);
var mapCtorString = toSource_default(Map_default);
var promiseCtorString = toSource_default(Promise_default);
var setCtorString = toSource_default(Set_default);
var weakMapCtorString = toSource_default(WeakMap_default);
var getTag = baseGetTag_default;
if (DataView_default && getTag(new DataView_default(new ArrayBuffer(1))) != dataViewTag2 || Map_default && getTag(new Map_default()) != mapTag2 || Promise_default && getTag(Promise_default.resolve()) != promiseTag || Set_default && getTag(new Set_default()) != setTag2 || WeakMap_default && getTag(new WeakMap_default()) != weakMapTag2) {
  getTag = function(value) {
    var result = baseGetTag_default(value), Ctor = result == objectTag3 ? value.constructor : void 0, ctorString = Ctor ? toSource_default(Ctor) : "";
    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString:
          return dataViewTag2;
        case mapCtorString:
          return mapTag2;
        case promiseCtorString:
          return promiseTag;
        case setCtorString:
          return setTag2;
        case weakMapCtorString:
          return weakMapTag2;
      }
    }
    return result;
  };
}
var getTag_default = getTag;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Uint8Array.js
var Uint8Array2 = root_default.Uint8Array;
var Uint8Array_default = Uint8Array2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cloneArrayBuffer.js
function cloneArrayBuffer(arrayBuffer) {
  var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
  new Uint8Array_default(result).set(new Uint8Array_default(arrayBuffer));
  return result;
}
var cloneArrayBuffer_default = cloneArrayBuffer;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cloneTypedArray.js
function cloneTypedArray(typedArray, isDeep) {
  var buffer = isDeep ? cloneArrayBuffer_default(typedArray.buffer) : typedArray.buffer;
  return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
}
var cloneTypedArray_default = cloneTypedArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_initCloneObject.js
function initCloneObject(object3) {
  return typeof object3.constructor == "function" && !isPrototype_default(object3) ? baseCreate_default(getPrototype_default(object3)) : {};
}
var initCloneObject_default = initCloneObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/compact.js
function compact(array) {
  var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result = [];
  while (++index < length) {
    var value = array[index];
    if (value) {
      result[resIndex++] = value;
    }
  }
  return result;
}
var compact_default = compact;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_setCacheAdd.js
var HASH_UNDEFINED3 = "__lodash_hash_undefined__";
function setCacheAdd(value) {
  this.__data__.set(value, HASH_UNDEFINED3);
  return this;
}
var setCacheAdd_default = setCacheAdd;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_setCacheHas.js
function setCacheHas(value) {
  return this.__data__.has(value);
}
var setCacheHas_default = setCacheHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_SetCache.js
function SetCache(values) {
  var index = -1, length = values == null ? 0 : values.length;
  this.__data__ = new MapCache_default();
  while (++index < length) {
    this.add(values[index]);
  }
}
SetCache.prototype.add = SetCache.prototype.push = setCacheAdd_default;
SetCache.prototype.has = setCacheHas_default;
var SetCache_default = SetCache;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arraySome.js
function arraySome(array, predicate) {
  var index = -1, length = array == null ? 0 : array.length;
  while (++index < length) {
    if (predicate(array[index], index, array)) {
      return true;
    }
  }
  return false;
}
var arraySome_default = arraySome;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cacheHas.js
function cacheHas(cache, key) {
  return cache.has(key);
}
var cacheHas_default = cacheHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_equalArrays.js
var COMPARE_PARTIAL_FLAG = 1;
var COMPARE_UNORDERED_FLAG = 2;
function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG, arrLength = array.length, othLength = other.length;
  if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
    return false;
  }
  var arrStacked = stack.get(array);
  var othStacked = stack.get(other);
  if (arrStacked && othStacked) {
    return arrStacked == other && othStacked == array;
  }
  var index = -1, result = true, seen = bitmask & COMPARE_UNORDERED_FLAG ? new SetCache_default() : void 0;
  stack.set(array, other);
  stack.set(other, array);
  while (++index < arrLength) {
    var arrValue = array[index], othValue = other[index];
    if (customizer) {
      var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
    }
    if (compared !== void 0) {
      if (compared) {
        continue;
      }
      result = false;
      break;
    }
    if (seen) {
      if (!arraySome_default(other, function(othValue2, othIndex) {
        if (!cacheHas_default(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
          return seen.push(othIndex);
        }
      })) {
        result = false;
        break;
      }
    } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
      result = false;
      break;
    }
  }
  stack["delete"](array);
  stack["delete"](other);
  return result;
}
var equalArrays_default = equalArrays;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapToArray.js
function mapToArray(map2) {
  var index = -1, result = Array(map2.size);
  map2.forEach(function(value, key) {
    result[++index] = [key, value];
  });
  return result;
}
var mapToArray_default = mapToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_setToArray.js
function setToArray(set4) {
  var index = -1, result = Array(set4.size);
  set4.forEach(function(value) {
    result[++index] = value;
  });
  return result;
}
var setToArray_default = setToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_equalByTag.js
var COMPARE_PARTIAL_FLAG2 = 1;
var COMPARE_UNORDERED_FLAG2 = 2;
var boolTag2 = "[object Boolean]";
var dateTag2 = "[object Date]";
var errorTag2 = "[object Error]";
var mapTag3 = "[object Map]";
var numberTag2 = "[object Number]";
var regexpTag2 = "[object RegExp]";
var setTag3 = "[object Set]";
var stringTag2 = "[object String]";
var symbolTag2 = "[object Symbol]";
var arrayBufferTag2 = "[object ArrayBuffer]";
var dataViewTag3 = "[object DataView]";
var symbolProto2 = Symbol_default ? Symbol_default.prototype : void 0;
var symbolValueOf = symbolProto2 ? symbolProto2.valueOf : void 0;
function equalByTag(object3, other, tag, bitmask, customizer, equalFunc, stack) {
  switch (tag) {
    case dataViewTag3:
      if (object3.byteLength != other.byteLength || object3.byteOffset != other.byteOffset) {
        return false;
      }
      object3 = object3.buffer;
      other = other.buffer;
    case arrayBufferTag2:
      if (object3.byteLength != other.byteLength || !equalFunc(new Uint8Array_default(object3), new Uint8Array_default(other))) {
        return false;
      }
      return true;
    case boolTag2:
    case dateTag2:
    case numberTag2:
      return eq_default(+object3, +other);
    case errorTag2:
      return object3.name == other.name && object3.message == other.message;
    case regexpTag2:
    case stringTag2:
      return object3 == other + "";
    case mapTag3:
      var convert4 = mapToArray_default;
    case setTag3:
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG2;
      convert4 || (convert4 = setToArray_default);
      if (object3.size != other.size && !isPartial) {
        return false;
      }
      var stacked = stack.get(object3);
      if (stacked) {
        return stacked == other;
      }
      bitmask |= COMPARE_UNORDERED_FLAG2;
      stack.set(object3, other);
      var result = equalArrays_default(convert4(object3), convert4(other), bitmask, customizer, equalFunc, stack);
      stack["delete"](object3);
      return result;
    case symbolTag2:
      if (symbolValueOf) {
        return symbolValueOf.call(object3) == symbolValueOf.call(other);
      }
  }
  return false;
}
var equalByTag_default = equalByTag;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_equalObjects.js
var COMPARE_PARTIAL_FLAG3 = 1;
var objectProto14 = Object.prototype;
var hasOwnProperty11 = objectProto14.hasOwnProperty;
function equalObjects(object3, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG3, objProps = getAllKeys_default(object3), objLength = objProps.length, othProps = getAllKeys_default(other), othLength = othProps.length;
  if (objLength != othLength && !isPartial) {
    return false;
  }
  var index = objLength;
  while (index--) {
    var key = objProps[index];
    if (!(isPartial ? key in other : hasOwnProperty11.call(other, key))) {
      return false;
    }
  }
  var objStacked = stack.get(object3);
  var othStacked = stack.get(other);
  if (objStacked && othStacked) {
    return objStacked == other && othStacked == object3;
  }
  var result = true;
  stack.set(object3, other);
  stack.set(other, object3);
  var skipCtor = isPartial;
  while (++index < objLength) {
    key = objProps[index];
    var objValue = object3[key], othValue = other[key];
    if (customizer) {
      var compared = isPartial ? customizer(othValue, objValue, key, other, object3, stack) : customizer(objValue, othValue, key, object3, other, stack);
    }
    if (!(compared === void 0 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
      result = false;
      break;
    }
    skipCtor || (skipCtor = key == "constructor");
  }
  if (result && !skipCtor) {
    var objCtor = object3.constructor, othCtor = other.constructor;
    if (objCtor != othCtor && ("constructor" in object3 && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
      result = false;
    }
  }
  stack["delete"](object3);
  stack["delete"](other);
  return result;
}
var equalObjects_default = equalObjects;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsEqualDeep.js
var COMPARE_PARTIAL_FLAG4 = 1;
var argsTag3 = "[object Arguments]";
var arrayTag2 = "[object Array]";
var objectTag4 = "[object Object]";
var objectProto15 = Object.prototype;
var hasOwnProperty12 = objectProto15.hasOwnProperty;
function baseIsEqualDeep(object3, other, bitmask, customizer, equalFunc, stack) {
  var objIsArr = isArray_default(object3), othIsArr = isArray_default(other), objTag = objIsArr ? arrayTag2 : getTag_default(object3), othTag = othIsArr ? arrayTag2 : getTag_default(other);
  objTag = objTag == argsTag3 ? objectTag4 : objTag;
  othTag = othTag == argsTag3 ? objectTag4 : othTag;
  var objIsObj = objTag == objectTag4, othIsObj = othTag == objectTag4, isSameTag = objTag == othTag;
  if (isSameTag && isBuffer_default(object3)) {
    if (!isBuffer_default(other)) {
      return false;
    }
    objIsArr = true;
    objIsObj = false;
  }
  if (isSameTag && !objIsObj) {
    stack || (stack = new Stack_default());
    return objIsArr || isTypedArray_default(object3) ? equalArrays_default(object3, other, bitmask, customizer, equalFunc, stack) : equalByTag_default(object3, other, objTag, bitmask, customizer, equalFunc, stack);
  }
  if (!(bitmask & COMPARE_PARTIAL_FLAG4)) {
    var objIsWrapped = objIsObj && hasOwnProperty12.call(object3, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty12.call(other, "__wrapped__");
    if (objIsWrapped || othIsWrapped) {
      var objUnwrapped = objIsWrapped ? object3.value() : object3, othUnwrapped = othIsWrapped ? other.value() : other;
      stack || (stack = new Stack_default());
      return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
    }
  }
  if (!isSameTag) {
    return false;
  }
  stack || (stack = new Stack_default());
  return equalObjects_default(object3, other, bitmask, customizer, equalFunc, stack);
}
var baseIsEqualDeep_default = baseIsEqualDeep;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsEqual.js
function baseIsEqual(value, other, bitmask, customizer, stack) {
  if (value === other) {
    return true;
  }
  if (value == null || other == null || !isObjectLike_default(value) && !isObjectLike_default(other)) {
    return value !== value && other !== other;
  }
  return baseIsEqualDeep_default(value, other, bitmask, customizer, baseIsEqual, stack);
}
var baseIsEqual_default = baseIsEqual;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsMatch.js
var COMPARE_PARTIAL_FLAG5 = 1;
var COMPARE_UNORDERED_FLAG3 = 2;
function baseIsMatch(object3, source, matchData, customizer) {
  var index = matchData.length, length = index, noCustomizer = !customizer;
  if (object3 == null) {
    return !length;
  }
  object3 = Object(object3);
  while (index--) {
    var data = matchData[index];
    if (noCustomizer && data[2] ? data[1] !== object3[data[0]] : !(data[0] in object3)) {
      return false;
    }
  }
  while (++index < length) {
    data = matchData[index];
    var key = data[0], objValue = object3[key], srcValue = data[1];
    if (noCustomizer && data[2]) {
      if (objValue === void 0 && !(key in object3)) {
        return false;
      }
    } else {
      var stack = new Stack_default();
      if (customizer) {
        var result = customizer(objValue, srcValue, key, object3, source, stack);
      }
      if (!(result === void 0 ? baseIsEqual_default(srcValue, objValue, COMPARE_PARTIAL_FLAG5 | COMPARE_UNORDERED_FLAG3, customizer, stack) : result)) {
        return false;
      }
    }
  }
  return true;
}
var baseIsMatch_default = baseIsMatch;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isStrictComparable.js
function isStrictComparable(value) {
  return value === value && !isObject_default(value);
}
var isStrictComparable_default = isStrictComparable;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getMatchData.js
function getMatchData(object3) {
  var result = keys_default(object3), length = result.length;
  while (length--) {
    var key = result[length], value = object3[key];
    result[length] = [key, value, isStrictComparable_default(value)];
  }
  return result;
}
var getMatchData_default = getMatchData;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_matchesStrictComparable.js
function matchesStrictComparable(key, srcValue) {
  return function(object3) {
    if (object3 == null) {
      return false;
    }
    return object3[key] === srcValue && (srcValue !== void 0 || key in Object(object3));
  };
}
var matchesStrictComparable_default = matchesStrictComparable;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseMatches.js
function baseMatches(source) {
  var matchData = getMatchData_default(source);
  if (matchData.length == 1 && matchData[0][2]) {
    return matchesStrictComparable_default(matchData[0][0], matchData[0][1]);
  }
  return function(object3) {
    return object3 === source || baseIsMatch_default(object3, source, matchData);
  };
}
var baseMatches_default = baseMatches;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseHasIn.js
function baseHasIn(object3, key) {
  return object3 != null && key in Object(object3);
}
var baseHasIn_default = baseHasIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hasPath.js
function hasPath(object3, path5, hasFunc) {
  path5 = castPath_default(path5, object3);
  var index = -1, length = path5.length, result = false;
  while (++index < length) {
    var key = toKey_default(path5[index]);
    if (!(result = object3 != null && hasFunc(object3, key))) {
      break;
    }
    object3 = object3[key];
  }
  if (result || ++index != length) {
    return result;
  }
  length = object3 == null ? 0 : object3.length;
  return !!length && isLength_default(length) && isIndex_default(key, length) && (isArray_default(object3) || isArguments_default(object3));
}
var hasPath_default = hasPath;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/hasIn.js
function hasIn(object3, path5) {
  return object3 != null && hasPath_default(object3, path5, baseHasIn_default);
}
var hasIn_default = hasIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseMatchesProperty.js
var COMPARE_PARTIAL_FLAG6 = 1;
var COMPARE_UNORDERED_FLAG4 = 2;
function baseMatchesProperty(path5, srcValue) {
  if (isKey_default(path5) && isStrictComparable_default(srcValue)) {
    return matchesStrictComparable_default(toKey_default(path5), srcValue);
  }
  return function(object3) {
    var objValue = get_default(object3, path5);
    return objValue === void 0 && objValue === srcValue ? hasIn_default(object3, path5) : baseIsEqual_default(srcValue, objValue, COMPARE_PARTIAL_FLAG6 | COMPARE_UNORDERED_FLAG4);
  };
}
var baseMatchesProperty_default = baseMatchesProperty;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseProperty.js
function baseProperty(key) {
  return function(object3) {
    return object3 == null ? void 0 : object3[key];
  };
}
var baseProperty_default = baseProperty;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_basePropertyDeep.js
function basePropertyDeep(path5) {
  return function(object3) {
    return baseGet_default(object3, path5);
  };
}
var basePropertyDeep_default = basePropertyDeep;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/property.js
function property(path5) {
  return isKey_default(path5) ? baseProperty_default(toKey_default(path5)) : basePropertyDeep_default(path5);
}
var property_default = property;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIteratee.js
function baseIteratee(value) {
  if (typeof value == "function") {
    return value;
  }
  if (value == null) {
    return identity_default;
  }
  if (typeof value == "object") {
    return isArray_default(value) ? baseMatchesProperty_default(value[0], value[1]) : baseMatches_default(value);
  }
  return property_default(value);
}
var baseIteratee_default = baseIteratee;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayAggregator.js
function arrayAggregator(array, setter, iteratee, accumulator) {
  var index = -1, length = array == null ? 0 : array.length;
  while (++index < length) {
    var value = array[index];
    setter(accumulator, value, iteratee(value), array);
  }
  return accumulator;
}
var arrayAggregator_default = arrayAggregator;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createBaseFor.js
function createBaseFor(fromRight) {
  return function(object3, iteratee, keysFunc) {
    var index = -1, iterable = Object(object3), props = keysFunc(object3), length = props.length;
    while (length--) {
      var key = props[fromRight ? length : ++index];
      if (iteratee(iterable[key], key, iterable) === false) {
        break;
      }
    }
    return object3;
  };
}
var createBaseFor_default = createBaseFor;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseFor.js
var baseFor = createBaseFor_default();
var baseFor_default = baseFor;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseForOwn.js
function baseForOwn(object3, iteratee) {
  return object3 && baseFor_default(object3, iteratee, keys_default);
}
var baseForOwn_default = baseForOwn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createBaseEach.js
function createBaseEach(eachFunc, fromRight) {
  return function(collection, iteratee) {
    if (collection == null) {
      return collection;
    }
    if (!isArrayLike_default(collection)) {
      return eachFunc(collection, iteratee);
    }
    var length = collection.length, index = fromRight ? length : -1, iterable = Object(collection);
    while (fromRight ? index-- : ++index < length) {
      if (iteratee(iterable[index], index, iterable) === false) {
        break;
      }
    }
    return collection;
  };
}
var createBaseEach_default = createBaseEach;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseEach.js
var baseEach = createBaseEach_default(baseForOwn_default);
var baseEach_default = baseEach;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseAggregator.js
function baseAggregator(collection, setter, iteratee, accumulator) {
  baseEach_default(collection, function(value, key, collection2) {
    setter(accumulator, value, iteratee(value), collection2);
  });
  return accumulator;
}
var baseAggregator_default = baseAggregator;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createAggregator.js
function createAggregator(setter, initializer) {
  return function(collection, iteratee) {
    var func = isArray_default(collection) ? arrayAggregator_default : baseAggregator_default, accumulator = initializer ? initializer() : {};
    return func(collection, setter, baseIteratee_default(iteratee, 2), accumulator);
  };
}
var createAggregator_default = createAggregator;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_assignMergeValue.js
function assignMergeValue(object3, key, value) {
  if (value !== void 0 && !eq_default(object3[key], value) || value === void 0 && !(key in object3)) {
    baseAssignValue_default(object3, key, value);
  }
}
var assignMergeValue_default = assignMergeValue;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArrayLikeObject.js
function isArrayLikeObject(value) {
  return isObjectLike_default(value) && isArrayLike_default(value);
}
var isArrayLikeObject_default = isArrayLikeObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_safeGet.js
function safeGet(object3, key) {
  if (key === "constructor" && typeof object3[key] === "function") {
    return;
  }
  if (key == "__proto__") {
    return;
  }
  return object3[key];
}
var safeGet_default = safeGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/toPlainObject.js
function toPlainObject(value) {
  return copyObject_default(value, keysIn_default(value));
}
var toPlainObject_default = toPlainObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseMergeDeep.js
function baseMergeDeep(object3, source, key, srcIndex, mergeFunc, customizer, stack) {
  var objValue = safeGet_default(object3, key), srcValue = safeGet_default(source, key), stacked = stack.get(srcValue);
  if (stacked) {
    assignMergeValue_default(object3, key, stacked);
    return;
  }
  var newValue = customizer ? customizer(objValue, srcValue, key + "", object3, source, stack) : void 0;
  var isCommon = newValue === void 0;
  if (isCommon) {
    var isArr = isArray_default(srcValue), isBuff = !isArr && isBuffer_default(srcValue), isTyped = !isArr && !isBuff && isTypedArray_default(srcValue);
    newValue = srcValue;
    if (isArr || isBuff || isTyped) {
      if (isArray_default(objValue)) {
        newValue = objValue;
      } else if (isArrayLikeObject_default(objValue)) {
        newValue = copyArray_default(objValue);
      } else if (isBuff) {
        isCommon = false;
        newValue = cloneBuffer_default(srcValue, true);
      } else if (isTyped) {
        isCommon = false;
        newValue = cloneTypedArray_default(srcValue, true);
      } else {
        newValue = [];
      }
    } else if (isPlainObject_default(srcValue) || isArguments_default(srcValue)) {
      newValue = objValue;
      if (isArguments_default(objValue)) {
        newValue = toPlainObject_default(objValue);
      } else if (!isObject_default(objValue) || isFunction_default(objValue)) {
        newValue = initCloneObject_default(srcValue);
      }
    } else {
      isCommon = false;
    }
  }
  if (isCommon) {
    stack.set(srcValue, newValue);
    mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
    stack["delete"](srcValue);
  }
  assignMergeValue_default(object3, key, newValue);
}
var baseMergeDeep_default = baseMergeDeep;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseMerge.js
function baseMerge(object3, source, srcIndex, customizer, stack) {
  if (object3 === source) {
    return;
  }
  baseFor_default(source, function(srcValue, key) {
    stack || (stack = new Stack_default());
    if (isObject_default(srcValue)) {
      baseMergeDeep_default(object3, source, key, srcIndex, baseMerge, customizer, stack);
    } else {
      var newValue = customizer ? customizer(safeGet_default(object3, key), srcValue, key + "", object3, source, stack) : void 0;
      if (newValue === void 0) {
        newValue = srcValue;
      }
      assignMergeValue_default(object3, key, newValue);
    }
  }, keysIn_default);
}
var baseMerge_default = baseMerge;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/mergeWith.js
var mergeWith = createAssigner_default(function(object3, source, srcIndex, customizer) {
  baseMerge_default(object3, source, srcIndex, customizer);
});
var mergeWith_default = mergeWith;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayIncludesWith.js
function arrayIncludesWith(array, value, comparator) {
  var index = -1, length = array == null ? 0 : array.length;
  while (++index < length) {
    if (comparator(value, array[index])) {
      return true;
    }
  }
  return false;
}
var arrayIncludesWith_default = arrayIncludesWith;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseDifference.js
var LARGE_ARRAY_SIZE2 = 200;
function baseDifference(array, values, iteratee, comparator) {
  var index = -1, includes = arrayIncludes_default, isCommon = true, length = array.length, result = [], valuesLength = values.length;
  if (!length) {
    return result;
  }
  if (iteratee) {
    values = arrayMap_default(values, baseUnary_default(iteratee));
  }
  if (comparator) {
    includes = arrayIncludesWith_default;
    isCommon = false;
  } else if (values.length >= LARGE_ARRAY_SIZE2) {
    includes = cacheHas_default;
    isCommon = false;
    values = new SetCache_default(values);
  }
  outer:
    while (++index < length) {
      var value = array[index], computed = iteratee == null ? value : iteratee(value);
      value = comparator || value !== 0 ? value : 0;
      if (isCommon && computed === computed) {
        var valuesIndex = valuesLength;
        while (valuesIndex--) {
          if (values[valuesIndex] === computed) {
            continue outer;
          }
        }
        result.push(value);
      } else if (!includes(values, computed, comparator)) {
        result.push(value);
      }
    }
  return result;
}
var baseDifference_default = baseDifference;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/difference.js
var difference = baseRest_default(function(array, values) {
  return isArrayLikeObject_default(array) ? baseDifference_default(array, baseFlatten_default(values, 1, isArrayLikeObject_default, true)) : [];
});
var difference_default = difference;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isString.js
var stringTag3 = "[object String]";
function isString(value) {
  return typeof value == "string" || !isArray_default(value) && isObjectLike_default(value) && baseGetTag_default(value) == stringTag3;
}
var isString_default = isString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isEqual.js
function isEqual(value, other) {
  return baseIsEqual_default(value, other);
}
var isEqual_default = isEqual;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isNull.js
function isNull(value) {
  return value === null;
}
var isNull_default = isNull;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/keyBy.js
var keyBy = createAggregator_default(function(result, value, key) {
  baseAssignValue_default(result, key, value);
});
var keyBy_default = keyBy;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/mapKeys.js
function mapKeys(object3, iteratee) {
  var result = {};
  iteratee = baseIteratee_default(iteratee, 3);
  baseForOwn_default(object3, function(value, key, object4) {
    baseAssignValue_default(result, iteratee(value, key, object4), value);
  });
  return result;
}
var mapKeys_default = mapKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/mapValues.js
function mapValues(object3, iteratee) {
  var result = {};
  iteratee = baseIteratee_default(iteratee, 3);
  baseForOwn_default(object3, function(value, key, object4) {
    baseAssignValue_default(result, key, iteratee(value, key, object4));
  });
  return result;
}
var mapValues_default = mapValues;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/negate.js
var FUNC_ERROR_TEXT2 = "Expected a function";
function negate(predicate) {
  if (typeof predicate != "function") {
    throw new TypeError(FUNC_ERROR_TEXT2);
  }
  return function() {
    var args = arguments;
    switch (args.length) {
      case 0:
        return !predicate.call(this);
      case 1:
        return !predicate.call(this, args[0]);
      case 2:
        return !predicate.call(this, args[0], args[1]);
      case 3:
        return !predicate.call(this, args[0], args[1], args[2]);
    }
    return !predicate.apply(this, args);
  };
}
var negate_default = negate;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseSet.js
function baseSet(object3, path5, value, customizer) {
  if (!isObject_default(object3)) {
    return object3;
  }
  path5 = castPath_default(path5, object3);
  var index = -1, length = path5.length, lastIndex = length - 1, nested = object3;
  while (nested != null && ++index < length) {
    var key = toKey_default(path5[index]), newValue = value;
    if (key === "__proto__" || key === "constructor" || key === "prototype") {
      return object3;
    }
    if (index != lastIndex) {
      var objValue = nested[key];
      newValue = customizer ? customizer(objValue, key, nested) : void 0;
      if (newValue === void 0) {
        newValue = isObject_default(objValue) ? objValue : isIndex_default(path5[index + 1]) ? [] : {};
      }
    }
    assignValue_default(nested, key, newValue);
    nested = nested[key];
  }
  return object3;
}
var baseSet_default = baseSet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_basePickBy.js
function basePickBy(object3, paths, predicate) {
  var index = -1, length = paths.length, result = {};
  while (++index < length) {
    var path5 = paths[index], value = baseGet_default(object3, path5);
    if (predicate(value, path5)) {
      baseSet_default(result, castPath_default(path5, object3), value);
    }
  }
  return result;
}
var basePickBy_default = basePickBy;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/pickBy.js
function pickBy(object3, predicate) {
  if (object3 == null) {
    return {};
  }
  var props = arrayMap_default(getAllKeysIn_default(object3), function(prop) {
    return [prop];
  });
  predicate = baseIteratee_default(predicate);
  return basePickBy_default(object3, props, function(value, path5) {
    return predicate(value, path5[0]);
  });
}
var pickBy_default = pickBy;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/omitBy.js
function omitBy(object3, predicate) {
  return pickBy_default(object3, negate_default(baseIteratee_default(predicate)));
}
var omitBy_default = omitBy;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_asciiSize.js
var asciiSize = baseProperty_default("length");
var asciiSize_default = asciiSize;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_unicodeSize.js
var rsAstralRange4 = "\\ud800-\\udfff";
var rsComboMarksRange5 = "\\u0300-\\u036f";
var reComboHalfMarksRange5 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange5 = "\\u20d0-\\u20ff";
var rsComboRange5 = rsComboMarksRange5 + reComboHalfMarksRange5 + rsComboSymbolsRange5;
var rsVarRange4 = "\\ufe0e\\ufe0f";
var rsAstral2 = "[" + rsAstralRange4 + "]";
var rsCombo4 = "[" + rsComboRange5 + "]";
var rsFitz3 = "\\ud83c[\\udffb-\\udfff]";
var rsModifier3 = "(?:" + rsCombo4 + "|" + rsFitz3 + ")";
var rsNonAstral3 = "[^" + rsAstralRange4 + "]";
var rsRegional3 = "(?:\\ud83c[\\udde6-\\uddff]){2}";
var rsSurrPair3 = "[\\ud800-\\udbff][\\udc00-\\udfff]";
var rsZWJ4 = "\\u200d";
var reOptMod3 = rsModifier3 + "?";
var rsOptVar3 = "[" + rsVarRange4 + "]?";
var rsOptJoin3 = "(?:" + rsZWJ4 + "(?:" + [rsNonAstral3, rsRegional3, rsSurrPair3].join("|") + ")" + rsOptVar3 + reOptMod3 + ")*";
var rsSeq3 = rsOptVar3 + reOptMod3 + rsOptJoin3;
var rsSymbol2 = "(?:" + [rsNonAstral3 + rsCombo4 + "?", rsCombo4, rsRegional3, rsSurrPair3, rsAstral2].join("|") + ")";
var reUnicode2 = RegExp(rsFitz3 + "(?=" + rsFitz3 + ")|" + rsSymbol2 + rsSeq3, "g");
function unicodeSize(string3) {
  var result = reUnicode2.lastIndex = 0;
  while (reUnicode2.test(string3)) {
    ++result;
  }
  return result;
}
var unicodeSize_default = unicodeSize;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stringSize.js
function stringSize(string3) {
  return hasUnicode_default(string3) ? unicodeSize_default(string3) : asciiSize_default(string3);
}
var stringSize_default = stringSize;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/size.js
var mapTag4 = "[object Map]";
var setTag4 = "[object Set]";
function size(collection) {
  if (collection == null) {
    return 0;
  }
  if (isArrayLike_default(collection)) {
    return isString_default(collection) ? stringSize_default(collection) : collection.length;
  }
  var tag = getTag_default(collection);
  if (tag == mapTag4 || tag == setTag4) {
    return collection.size;
  }
  return baseKeys_default(collection).length;
}
var size_default = size;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/snakeCase.js
var snakeCase = createCompounder_default(function(result, word, index) {
  return result + (index ? "_" : "") + word.toLowerCase();
});
var snakeCase_default = snakeCase;

// ../../commons/core-utils/lib/assertNever.js
function assertNever(x) {
  throw new Error("Unexpected value: " + JSON.stringify(x));
}

// ../../commons/core-utils/lib/examples.js
var examples_exports = {};
__export(examples_exports, {
  BASE64: () => BASE64,
  BIG_INTEGER: () => BIG_INTEGER,
  BOOLEAN: () => BOOLEAN,
  DATE: () => DATE,
  DATE_TIME: () => DATE_TIME,
  DOUBLE: () => DOUBLE,
  FLOAT: () => FLOAT,
  INT: () => INT,
  INT64: () => INT64,
  SAMPLE_STRINGS: () => SAMPLE_STRINGS,
  STRING: () => STRING,
  UINT: () => UINT,
  UINT64: () => UINT64,
  UUID: () => UUID
});
var STRING = "string";
var BASE64 = "SGVsbG8gd29ybGQh";
var BOOLEAN = true;
var DATE = "2023-01-15";
var DATE_TIME = "2024-01-15T09:30:00Z";
var DOUBLE = 1.1;
var FLOAT = 1.1;
var INT = 1;
var INT64 = 1e6;
var UINT = 1;
var UINT64 = 1e6;
var UUID = "d5e9c84f-c2b2-4bf4-b4b0-7ffd7a9ffc32";
var BIG_INTEGER = "123456789123456789";
var SAMPLE_STRINGS = [
  "x",
  "xy",
  "foo",
  "buzz",
  "alpha",
  "banana",
  "apricot",
  "mandarin",
  "nectarine",
  "strawberry",
  "pomegranate",
  "blackcurrant"
];

// ../../commons/core-utils/lib/getDuplicates.js
function getDuplicates(items) {
  const seen = /* @__PURE__ */ new Set();
  const duplicatesSet = /* @__PURE__ */ new Set();
  const duplicates = [];
  for (const item of items) {
    if (seen.has(item) && !duplicatesSet.has(item)) {
      duplicatesSet.add(item);
      duplicates.push(item);
    }
    seen.add(item);
  }
  return duplicates;
}

// ../../commons/core-utils/lib/isNonNullish.js
function isNonNullish(x) {
  return x != null;
}

// ../../commons/core-utils/lib/mediaType.js
var import_whatwg_mimetype = __toESM(require_mime_type(), 1);
var MediaType = class _MediaType {
  type;
  subtype;
  essence;
  parameters;
  mimeType;
  input;
  constructor(type2, subtype, essence, parameters, mimeType, input) {
    this.type = type2;
    this.subtype = subtype;
    this.essence = essence;
    this.parameters = parameters;
    this.mimeType = mimeType;
    this.input = input;
  }
  static APPLICATION_JSON = "application/json";
  static APPLICATION_OCTET_STREAM = "application/octet-stream";
  static MULTIPART_FORM_DATA = "multipart/form-data";
  static parse(input) {
    if (input == null) {
      return null;
    }
    const parsed = import_whatwg_mimetype.default.parse(input);
    if (parsed == null) {
      return null;
    }
    return new _MediaType(parsed.type, parsed.subtype, parsed.essence, parsed.parameters, parsed, input);
  }
  toString() {
    return this.input;
  }
  /** Types */
  isText() {
    return this.type === "text";
  }
  isImage() {
    return this.type === "image";
  }
  isAudio() {
    return this.type === "audio";
  }
  isVideo() {
    return this.type === "video";
  }
  isFont() {
    return this.type === "font";
  }
  isMultipart() {
    return this.type === "multipart";
  }
  isApplication() {
    return this.type === "application";
  }
  isMessage() {
    return this.type === "message";
  }
  isModel() {
    return this.type === "model";
  }
  /** Text */
  isCSS() {
    return this.isText() && this.subtype === "css";
  }
  isCSV() {
    return this.isText() && this.subtype === "csv";
  }
  isMarkdown() {
    return this.isText() && this.subtype === "markdown";
  }
  isPlainText() {
    return this.isText() && this.subtype === "plain";
  }
  /** Multipart */
  isMultiPartFormData() {
    return this.isMultipart() && this.subtype === "form-data";
  }
  /** Application */
  isJSON() {
    return this.isApplication() && this.subtype === "json";
  }
  isURLEncoded() {
    return this.isApplication() && this.subtype === "x-www-form-urlencoded";
  }
  isOctetStream() {
    return this.isApplication() && this.subtype === "octet-stream";
  }
  isPDF() {
    return this.isApplication() && this.subtype === "pdf";
  }
  isZip() {
    return this.isApplication() && this.subtype === "zip";
  }
  isGzip() {
    return this.isApplication() && this.subtype === "gzip";
  }
  isTar() {
    return this.isApplication() && this.subtype === "tar";
  }
  isBrotli() {
    return this.isApplication() && this.subtype === "br";
  }
  isDeflate() {
    return this.isApplication() && this.subtype === "deflate";
  }
  isProtobuf() {
    return this.isApplication() && this.subtype === "protobuf";
  }
  /** Images */
  isAvif() {
    return this.isImage() && this.subtype === "avif";
  }
  isWebP() {
    return this.isImage() && this.subtype === "webp";
  }
  isSVG() {
    return this.isImage() && this.subtype === "svg+xml";
  }
  isPNG() {
    return this.isImage() && this.subtype === "png";
  }
  isJPEG() {
    return this.isImage() && this.subtype === "jpeg";
  }
  isGIF() {
    return this.isImage() && this.subtype === "gif";
  }
  /** Audio */
  isMPEG() {
    return this.isAudio() && this.subtype === "mpeg";
  }
  isWAV() {
    return this.isAudio() && this.subtype === "wav";
  }
  /** Mixed */
  isHTML() {
    return this.mimeType.isHTML();
  }
  isXML() {
    return this.mimeType.isXML();
  }
  isJavaScript() {
    return this.mimeType.isJavaScript();
  }
};

// ../../commons/core-utils/lib/noop.js
function noop() {
}

// ../../commons/core-utils/lib/objects/keys.js
function keys2(object3) {
  return Object.keys(object3);
}

// ../../commons/core-utils/lib/ObjectPropertiesVisitor.js
async function visitObject(object3, visitor) {
  for (const key of keys2(visitor)) {
    await visitor[key](object3[key]);
  }
}

// ../../commons/core-utils/lib/objects/entries.js
function entries(object3) {
  return Object.entries(object3);
}

// ../../commons/core-utils/lib/objects/isPlainObject.js
function isPlainObject2(value) {
  if (!isObjectLike2(value) || toString.call(value) !== "[object Object]") {
    return false;
  }
  if (Object.getPrototypeOf(value) == null) {
    return true;
  }
  let proto = value;
  while (Object.getPrototypeOf(proto) != null) {
    proto = Object.getPrototypeOf(proto);
  }
  return Object.getPrototypeOf(value) === proto;
}
function isObjectLike2(value) {
  return typeof value === "object" && value != null;
}

// ../../commons/core-utils/lib/mergeWithOverrides.js
async function mergeWithOverrides({ data, overrides }) {
  const merged = mergeWith_default(data, mergeWith_default, overrides, (obj, src) => Array.isArray(obj) && Array.isArray(src) ? src.every((element) => typeof element === "object") && obj.every((element) => typeof element === "object") ? (
    // nested arrays of objects are merged
    void 0
  ) : (
    // nested arrays of primitives are replaced
    [...src]
  ) : void 0);
  const filtered = omitDeepBy(merged, isNull_default);
  return filtered;
}
var omitDeepBy = (object3, cb) => {
  function omitByDeepByOnOwnProps(object4) {
    if (Array.isArray(object4)) {
      return object4.map((element) => omitDeepBy(element, cb));
    }
    if (isPlainObject_default(object4)) {
      const temp = {};
      for (const [key, value] of Object.entries(object4)) {
        temp[key] = omitDeepBy(value, cb);
      }
      return omitBy_default(temp, cb);
    }
    return object4;
  }
  return omitByDeepByOnOwnProps(object3);
};

// ../../cli/configuration/lib/constants.js
var ROOT_API_FILENAME = "api.yml";
var FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION = "__package__";
var FERN_PACKAGE_MARKER_FILENAME = `${FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION}.yml`;
var DEFAULT_GROUP_NAME = "local";

// ../../cli/configuration/lib/generators-yml/index.js
var generators_yml_exports = {};
__export(generators_yml_exports, {
  API_ORIGIN_LOCATION_KEY: () => API_ORIGIN_LOCATION_KEY,
  API_SETTINGS_KEY: () => API_SETTINGS_KEY,
  ASYNC_API_LOCATION_KEY: () => ASYNC_API_LOCATION_KEY,
  DEFAULT_GROUP_GENERATORS_CONFIG_KEY: () => DEFAULT_GROUP_GENERATORS_CONFIG_KEY,
  DEFAULT_GROUP_NAME: () => DEFAULT_GROUP_NAME,
  GenerationLanguage: () => GenerationLanguage,
  GithubCommitAndReleaseMode: () => GithubCommitAndReleaseMode,
  GithubLicenseType: () => GithubLicenseType,
  MessageNamingSettingsSchema: () => MessageNamingSettingsSchema,
  OPENAPI_LOCATION_KEY: () => OPENAPI_LOCATION_KEY,
  OPENAPI_OVERRIDES_LOCATION_KEY: () => OPENAPI_OVERRIDES_LOCATION_KEY,
  UnionSettingsSchema: () => UnionSettingsSchema,
  fernDefinition: () => fernDefinition_exports,
  generators: () => generators_exports,
  getPackageName: () => getPackageName,
  group: () => group_exports,
  isApiConfigurationV2Schema: () => isApiConfigurationV2Schema,
  isAsyncAPISchema: () => isAsyncAPISchema,
  isConjureSchema: () => isConjureSchema,
  isNamespacedApiConfiguration: () => isNamespacedApiConfiguration,
  isOpenAPISchema: () => isOpenAPISchema,
  isRawProtobufAPIDefinitionSchema: () => isRawProtobufAPIDefinitionSchema,
  license: () => license_exports,
  reviewers: () => reviewers_exports,
  serialization: () => serialization_exports
});

// ../../cli/configuration/lib/generators-yml/utils/isApiConfigurationV2Schema.js
function isApiConfigurationV2Schema(api) {
  return api?.specs != null;
}

// ../../cli/configuration/lib/generators-yml/utils/isAsyncAPISpecSchema.js
function isAsyncAPISchema(spec) {
  return spec?.asyncapi != null;
}

// ../../cli/configuration/lib/generators-yml/utils/isOpenAPISpecSchema.js
function isOpenAPISchema(spec) {
  return spec?.openapi != null;
}

// ../../cli/configuration/lib/generators-yml/utils/isConjureSchema.js
function isConjureSchema(specs) {
  return specs?.conjure != null;
}

// ../../cli/configuration/lib/generators-yml/utils/isNamespacedApiConfiguration.js
function isNamespacedApiConfiguration(api) {
  return api?.namespaces != null;
}

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/generators/index.js
var generators_exports = {};
__export(generators_exports, {
  MessageNamingSettingsSchema: () => MessageNamingSettingsSchema,
  UnionSettingsSchema: () => UnionSettingsSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/generators/types/UnionSettingsSchema.js
var UnionSettingsSchema = {
  V1: "v1"
};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/generators/types/MessageNamingSettingsSchema.js
var MessageNamingSettingsSchema = {
  V1: "v1",
  V2: "v2"
};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/group/index.js
var group_exports = {};
__export(group_exports, {
  GithubCommitAndReleaseMode: () => GithubCommitAndReleaseMode
});

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/group/types/GithubCommitAndReleaseMode.js
var GithubCommitAndReleaseMode = {
  Commit: "commit",
  Release: "release"
};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/license/index.js
var license_exports = {};
__export(license_exports, {
  GithubLicenseType: () => GithubLicenseType
});

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/license/types/GithubLicenseType.js
var GithubLicenseType = {
  Mit: "MIT",
  Apache: "Apache-2.0"
};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/reviewers/index.js
var reviewers_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/index.js
var fernDefinition_exports = {};
__export(fernDefinition_exports, {
  AvailabilityStatusSchema: () => AvailabilityStatusSchema,
  auth: () => auth_exports,
  availability: () => availability_exports,
  commons: () => commons_exports,
  encoding: () => encoding_exports,
  environments: () => environments_exports,
  file: () => file_exports,
  service: () => service_exports,
  types: () => types_exports,
  validation: () => validation_exports
});

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/auth/index.js
var auth_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/availability/index.js
var availability_exports = {};
__export(availability_exports, {
  AvailabilityStatusSchema: () => AvailabilityStatusSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/availability/types/AvailabilityStatusSchema.js
var AvailabilityStatusSchema = {
  InDevelopment: "in-development",
  PreRelease: "pre-release",
  Deprecated: "deprecated",
  GenerallyAvailable: "generally-available"
};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/commons/index.js
var commons_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/encoding/index.js
var encoding_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/environments/index.js
var environments_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/file/index.js
var file_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/service/index.js
var service_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/types/index.js
var types_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/validation/index.js
var validation_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/serialization/index.js
var serialization_exports = {};
__export(serialization_exports, {
  ApiConfigurationSchema: () => ApiConfigurationSchema,
  ApiConfigurationSchemaInternal: () => ApiConfigurationSchemaInternal,
  ApiConfigurationV2Schema: () => ApiConfigurationV2Schema,
  ApiConfigurationV2SpecsSchema: () => ApiConfigurationV2SpecsSchema,
  ApiDefinitionList: () => ApiDefinitionList,
  ApiDefinitionPathSchema: () => ApiDefinitionPathSchema,
  ApiDefinitionSchema: () => ApiDefinitionSchema,
  ApiDefinitionSettingsSchema: () => ApiDefinitionSettingsSchema,
  ApiDefinitionWithOverridesSchema: () => ApiDefinitionWithOverridesSchema,
  AsyncApiOrOpenApiSpecSchema: () => AsyncApiOrOpenApiSpecSchema,
  AsyncApiSchema: () => AsyncApiSchema,
  AsyncApiSettingsSchema: () => AsyncApiSettingsSchema,
  ConjureSchema: () => ConjureSchema,
  GeneratorApiSettingsSchema: () => GeneratorApiSettingsSchema,
  GeneratorGroupSchema: () => GeneratorGroupSchema,
  GeneratorInvocationSchema: () => GeneratorInvocationSchema,
  GeneratorOutputSchema: () => GeneratorOutputSchema,
  GeneratorPublishMetadataSchema: () => GeneratorPublishMetadataSchema,
  GeneratorSnippetsSchema: () => GeneratorSnippetsSchema,
  GeneratorsConfigurationSchema: () => GeneratorsConfigurationSchema,
  GeneratorsOpenApiObjectSchema: () => GeneratorsOpenApiObjectSchema,
  GeneratorsOpenApiSchema: () => GeneratorsOpenApiSchema,
  GithubCommitAndReleaseMode: () => GithubCommitAndReleaseMode2,
  GithubCommitAndReleaseSchema: () => GithubCommitAndReleaseSchema,
  GithubConfigurationSchema: () => GithubConfigurationSchema,
  GithubLicenseCustomSchema: () => GithubLicenseCustomSchema,
  GithubLicenseSchema: () => GithubLicenseSchema,
  GithubLicenseType: () => GithubLicenseType2,
  GithubPullRequestSchema: () => GithubPullRequestSchema,
  GithubPushSchema: () => GithubPushSchema,
  LocalFileSystemOutputLocationSchema: () => LocalFileSystemOutputLocationSchema,
  MavenOutputLocationSchema: () => MavenOutputLocationSchema,
  MavenOutputSignatureSchema: () => MavenOutputSignatureSchema,
  MessageNamingSettingsSchema: () => MessageNamingSettingsSchema2,
  NamespacedApiConfigurationSchema: () => NamespacedApiConfigurationSchema,
  NpmOutputLocationSchema: () => NpmOutputLocationSchema,
  NugetOutputLocationSchema: () => NugetOutputLocationSchema,
  OpenApiSettingsSchema: () => OpenApiSettingsSchema,
  OpenApiSpecSchema: () => OpenApiSpecSchema,
  OutputMetadataAuthor: () => OutputMetadataAuthor,
  OutputMetadataSchema: () => OutputMetadataSchema,
  PostmanOutputLocationSchema: () => PostmanOutputLocationSchema,
  ProtobufApiDefinitionSchema: () => ProtobufApiDefinitionSchema,
  ProtobufDefinitionSchema: () => ProtobufDefinitionSchema,
  PypiOutputLocationSchema: () => PypiOutputLocationSchema,
  PypiOutputMetadataSchema: () => PypiOutputMetadataSchema,
  ReadmeEndpointObjectSchema: () => ReadmeEndpointObjectSchema,
  ReadmeEndpointSchema: () => ReadmeEndpointSchema,
  ReadmeSchema: () => ReadmeSchema,
  ReviewerSchema: () => ReviewerSchema,
  ReviewersSchema: () => ReviewersSchema,
  RubyGemsOutputLocationSchema: () => RubyGemsOutputLocationSchema,
  UnionSettingsSchema: () => UnionSettingsSchema2,
  WhitelabelConfigurationSchema: () => WhitelabelConfigurationSchema,
  WhitelabelGithubConfigurationSchema: () => WhitelabelGithubConfigurationSchema,
  fernDefinition: () => fernDefinition_exports2,
  generators: () => generators_exports2,
  group: () => group_exports2,
  license: () => license_exports2,
  reviewers: () => reviewers_exports2
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/index.js
var generators_exports2 = {};
__export(generators_exports2, {
  ApiConfigurationSchema: () => ApiConfigurationSchema,
  ApiConfigurationSchemaInternal: () => ApiConfigurationSchemaInternal,
  ApiConfigurationV2Schema: () => ApiConfigurationV2Schema,
  ApiConfigurationV2SpecsSchema: () => ApiConfigurationV2SpecsSchema,
  ApiDefinitionList: () => ApiDefinitionList,
  ApiDefinitionPathSchema: () => ApiDefinitionPathSchema,
  ApiDefinitionSchema: () => ApiDefinitionSchema,
  ApiDefinitionSettingsSchema: () => ApiDefinitionSettingsSchema,
  ApiDefinitionWithOverridesSchema: () => ApiDefinitionWithOverridesSchema,
  AsyncApiOrOpenApiSpecSchema: () => AsyncApiOrOpenApiSpecSchema,
  AsyncApiSchema: () => AsyncApiSchema,
  AsyncApiSettingsSchema: () => AsyncApiSettingsSchema,
  ConjureSchema: () => ConjureSchema,
  GeneratorsConfigurationSchema: () => GeneratorsConfigurationSchema,
  GeneratorsOpenApiObjectSchema: () => GeneratorsOpenApiObjectSchema,
  GeneratorsOpenApiSchema: () => GeneratorsOpenApiSchema,
  MessageNamingSettingsSchema: () => MessageNamingSettingsSchema2,
  NamespacedApiConfigurationSchema: () => NamespacedApiConfigurationSchema,
  OpenApiSettingsSchema: () => OpenApiSettingsSchema,
  OpenApiSpecSchema: () => OpenApiSpecSchema,
  OutputMetadataAuthor: () => OutputMetadataAuthor,
  OutputMetadataSchema: () => OutputMetadataSchema,
  ProtobufApiDefinitionSchema: () => ProtobufApiDefinitionSchema,
  ProtobufDefinitionSchema: () => ProtobufDefinitionSchema,
  ReadmeEndpointObjectSchema: () => ReadmeEndpointObjectSchema,
  ReadmeEndpointSchema: () => ReadmeEndpointSchema,
  ReadmeSchema: () => ReadmeSchema,
  UnionSettingsSchema: () => UnionSettingsSchema2,
  WhitelabelConfigurationSchema: () => WhitelabelConfigurationSchema,
  WhitelabelGithubConfigurationSchema: () => WhitelabelGithubConfigurationSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/index.js
var schemas_exports = {};
__export(schemas_exports, {
  JsonError: () => JsonError,
  ParseError: () => ParseError,
  any: () => any,
  boolean: () => boolean,
  booleanLiteral: () => booleanLiteral,
  date: () => date,
  discriminant: () => discriminant,
  enum_: () => enum_,
  getObjectLikeUtils: () => getObjectLikeUtils,
  getObjectUtils: () => getObjectUtils,
  getSchemaUtils: () => getSchemaUtils,
  isProperty: () => isProperty,
  lazy: () => lazy,
  lazyObject: () => lazyObject,
  list: () => list,
  number: () => number,
  object: () => object,
  objectWithoutOptionalProperties: () => objectWithoutOptionalProperties,
  optional: () => optional,
  property: () => property2,
  record: () => record,
  set: () => set,
  string: () => string,
  stringLiteral: () => stringLiteral,
  transform: () => transform,
  undiscriminatedUnion: () => undiscriminatedUnion,
  union: () => union,
  unknown: () => unknown,
  withParsedProperties: () => withParsedProperties
});

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/Schema.js
var SchemaType = {
  DATE: "date",
  ENUM: "enum",
  LIST: "list",
  STRING_LITERAL: "stringLiteral",
  BOOLEAN_LITERAL: "booleanLiteral",
  OBJECT: "object",
  ANY: "any",
  BOOLEAN: "boolean",
  NUMBER: "number",
  STRING: "string",
  UNKNOWN: "unknown",
  RECORD: "record",
  SET: "set",
  UNION: "union",
  UNDISCRIMINATED_UNION: "undiscriminatedUnion",
  OPTIONAL: "optional"
};

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/getErrorMessageForIncorrectType.js
function getErrorMessageForIncorrectType(value, expectedType) {
  return `Expected ${expectedType}. Received ${getTypeAsString(value)}.`;
}
function getTypeAsString(value) {
  if (Array.isArray(value)) {
    return "list";
  }
  if (value === null) {
    return "null";
  }
  switch (typeof value) {
    case "string":
      return `"${value}"`;
    case "number":
    case "boolean":
    case "undefined":
      return `${value}`;
  }
  return typeof value;
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/maybeSkipValidation.js
function maybeSkipValidation(schema2) {
  return {
    ...schema2,
    json: transformAndMaybeSkipValidation(schema2.json),
    parse: transformAndMaybeSkipValidation(schema2.parse)
  };
}
function transformAndMaybeSkipValidation(transform3) {
  return (value, opts) => {
    const transformed = transform3(value, opts);
    const { skipValidation = false } = opts ?? {};
    if (!transformed.ok && skipValidation) {
      console.warn([
        "Failed to validate.",
        ...transformed.errors.map((error) => "  - " + (error.path.length > 0 ? `${error.path.join(".")}: ${error.message}` : error.message))
      ].join("\n"));
      return {
        ok: true,
        value
      };
    } else {
      return transformed;
    }
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/schema-utils/stringifyValidationErrors.js
function stringifyValidationError(error) {
  if (error.path.length === 0) {
    return error.message;
  }
  return `${error.path.join(" -> ")}: ${error.message}`;
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/schema-utils/JsonError.js
var JsonError = class _JsonError extends Error {
  errors;
  constructor(errors) {
    super(errors.map(stringifyValidationError).join("; "));
    this.errors = errors;
    Object.setPrototypeOf(this, _JsonError.prototype);
  }
};

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/schema-utils/ParseError.js
var ParseError = class _ParseError extends Error {
  errors;
  constructor(errors) {
    super(errors.map(stringifyValidationError).join("; "));
    this.errors = errors;
    Object.setPrototypeOf(this, _ParseError.prototype);
  }
};

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/schema-utils/getSchemaUtils.js
function getSchemaUtils(schema2) {
  return {
    optional: () => optional(schema2),
    transform: (transformer) => transform(schema2, transformer),
    parseOrThrow: (raw, opts) => {
      const parsed = schema2.parse(raw, opts);
      if (parsed.ok) {
        return parsed.value;
      }
      throw new ParseError(parsed.errors);
    },
    jsonOrThrow: (parsed, opts) => {
      const raw = schema2.json(parsed, opts);
      if (raw.ok) {
        return raw.value;
      }
      throw new JsonError(raw.errors);
    }
  };
}
function optional(schema2) {
  const baseSchema = {
    parse: (raw, opts) => {
      if (raw == null) {
        return {
          ok: true,
          value: void 0
        };
      }
      return schema2.parse(raw, opts);
    },
    json: (parsed, opts) => {
      if (opts?.omitUndefined && parsed === void 0) {
        return {
          ok: true,
          value: void 0
        };
      }
      if (parsed == null) {
        return {
          ok: true,
          value: null
        };
      }
      return schema2.json(parsed, opts);
    },
    getType: () => SchemaType.OPTIONAL
  };
  return {
    ...baseSchema,
    ...getSchemaUtils(baseSchema)
  };
}
function transform(schema2, transformer) {
  const baseSchema = {
    parse: (raw, opts) => {
      const parsed = schema2.parse(raw, opts);
      if (!parsed.ok) {
        return parsed;
      }
      return {
        ok: true,
        value: transformer.transform(parsed.value)
      };
    },
    json: (transformed, opts) => {
      const parsed = transformer.untransform(transformed);
      return schema2.json(parsed, opts);
    },
    getType: () => schema2.getType()
  };
  return {
    ...baseSchema,
    ...getSchemaUtils(baseSchema)
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/date/date.js
var ISO_8601_REGEX = /^([+-]?\d{4}(?!\d{2}\b))((-?)((0[1-9]|1[0-2])(\3([12]\d|0[1-9]|3[01]))?|W([0-4]\d|5[0-2])(-?[1-7])?|(00[1-9]|0[1-9]\d|[12]\d{2}|3([0-5]\d|6[1-6])))([T\s]((([01]\d|2[0-3])((:?)[0-5]\d)?|24:?00)([.,]\d+(?!:))?)?(\17[0-5]\d([.,]\d+)?)?([zZ]|([+-])([01]\d|2[0-3]):?([0-5]\d)?)?)?)?$/;
function date() {
  const baseSchema = {
    parse: (raw, { breadcrumbsPrefix = [] } = {}) => {
      if (typeof raw !== "string") {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType(raw, "string")
            }
          ]
        };
      }
      if (!ISO_8601_REGEX.test(raw)) {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType(raw, "ISO 8601 date string")
            }
          ]
        };
      }
      return {
        ok: true,
        value: new Date(raw)
      };
    },
    json: (date3, { breadcrumbsPrefix = [] } = {}) => {
      if (date3 instanceof Date) {
        return {
          ok: true,
          value: date3.toISOString()
        };
      } else {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType(date3, "Date object")
            }
          ]
        };
      }
    },
    getType: () => SchemaType.DATE
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema)
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/createIdentitySchemaCreator.js
function createIdentitySchemaCreator(schemaType, validate) {
  return () => {
    const baseSchema = {
      parse: validate,
      json: validate,
      getType: () => schemaType
    };
    return {
      ...maybeSkipValidation(baseSchema),
      ...getSchemaUtils(baseSchema)
    };
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/enum/enum.js
function enum_(values) {
  const validValues = new Set(values);
  const schemaCreator = createIdentitySchemaCreator(SchemaType.ENUM, (value, { allowUnrecognizedEnumValues, breadcrumbsPrefix = [] } = {}) => {
    if (typeof value !== "string") {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType(value, "string")
          }
        ]
      };
    }
    if (!validValues.has(value) && !allowUnrecognizedEnumValues) {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType(value, "enum")
          }
        ]
      };
    }
    return {
      ok: true,
      value
    };
  });
  return schemaCreator();
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/lazy/lazy.js
function lazy(getter) {
  const baseSchema = constructLazyBaseSchema(getter);
  return {
    ...baseSchema,
    ...getSchemaUtils(baseSchema)
  };
}
function constructLazyBaseSchema(getter) {
  return {
    parse: (raw, opts) => getMemoizedSchema(getter).parse(raw, opts),
    json: (parsed, opts) => getMemoizedSchema(getter).json(parsed, opts),
    getType: () => getMemoizedSchema(getter).getType()
  };
}
function getMemoizedSchema(getter) {
  const castedGetter = getter;
  if (castedGetter.__zurg_memoized == null) {
    castedGetter.__zurg_memoized = getter();
  }
  return castedGetter.__zurg_memoized;
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/entries.js
function entries2(object3) {
  return Object.entries(object3);
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/filterObject.js
function filterObject(obj, keysToInclude) {
  const keysToIncludeSet = new Set(keysToInclude);
  return Object.entries(obj).reduce((acc, [key, value]) => {
    if (keysToIncludeSet.has(key)) {
      acc[key] = value;
    }
    return acc;
  }, {});
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/isPlainObject.js
function isPlainObject3(value) {
  if (typeof value !== "object" || value === null) {
    return false;
  }
  if (Object.getPrototypeOf(value) === null) {
    return true;
  }
  let proto = value;
  while (Object.getPrototypeOf(proto) !== null) {
    proto = Object.getPrototypeOf(proto);
  }
  return Object.getPrototypeOf(value) === proto;
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/keys.js
function keys3(object3) {
  return Object.keys(object3);
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/partition.js
function partition(items, predicate) {
  const trueItems = [], falseItems = [];
  for (const item of items) {
    if (predicate(item)) {
      trueItems.push(item);
    } else {
      falseItems.push(item);
    }
  }
  return [trueItems, falseItems];
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/object-like/getObjectLikeUtils.js
function getObjectLikeUtils(schema2) {
  return {
    withParsedProperties: (properties) => withParsedProperties(schema2, properties)
  };
}
function withParsedProperties(objectLike, properties) {
  const objectSchema = {
    parse: (raw, opts) => {
      const parsedObject = objectLike.parse(raw, opts);
      if (!parsedObject.ok) {
        return parsedObject;
      }
      const additionalProperties = Object.entries(properties).reduce((processed, [key, value]) => {
        return {
          ...processed,
          [key]: typeof value === "function" ? value(parsedObject.value) : value
        };
      }, {});
      return {
        ok: true,
        value: {
          ...parsedObject.value,
          ...additionalProperties
        }
      };
    },
    json: (parsed, opts) => {
      if (!isPlainObject3(parsed)) {
        return {
          ok: false,
          errors: [
            {
              path: opts?.breadcrumbsPrefix ?? [],
              message: getErrorMessageForIncorrectType(parsed, "object")
            }
          ]
        };
      }
      const addedPropertyKeys = new Set(Object.keys(properties));
      const parsedWithoutAddedProperties = filterObject(parsed, Object.keys(parsed).filter((key) => !addedPropertyKeys.has(key)));
      return objectLike.json(parsedWithoutAddedProperties, opts);
    },
    getType: () => objectLike.getType()
  };
  return {
    ...objectSchema,
    ...getSchemaUtils(objectSchema),
    ...getObjectLikeUtils(objectSchema)
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/object/property.js
function property2(rawKey, valueSchema) {
  return {
    rawKey,
    valueSchema,
    isProperty: true
  };
}
function isProperty(maybeProperty) {
  return maybeProperty.isProperty;
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/object/object.js
function object(schemas) {
  const baseSchema = {
    _getRawProperties: () => Object.entries(schemas).map(([parsedKey, propertySchema]) => isProperty(propertySchema) ? propertySchema.rawKey : parsedKey),
    _getParsedProperties: () => keys3(schemas),
    parse: (raw, opts) => {
      const rawKeyToProperty = {};
      const requiredKeys = [];
      for (const [parsedKey, schemaOrObjectProperty] of entries2(schemas)) {
        const rawKey = isProperty(schemaOrObjectProperty) ? schemaOrObjectProperty.rawKey : parsedKey;
        const valueSchema = isProperty(schemaOrObjectProperty) ? schemaOrObjectProperty.valueSchema : schemaOrObjectProperty;
        const property4 = {
          rawKey,
          parsedKey,
          valueSchema
        };
        rawKeyToProperty[rawKey] = property4;
        if (isSchemaRequired(valueSchema)) {
          requiredKeys.push(rawKey);
        }
      }
      return validateAndTransformObject({
        value: raw,
        requiredKeys,
        getProperty: (rawKey) => {
          const property4 = rawKeyToProperty[rawKey];
          if (property4 == null) {
            return void 0;
          }
          return {
            transformedKey: property4.parsedKey,
            transform: (propertyValue) => property4.valueSchema.parse(propertyValue, {
              ...opts,
              breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], rawKey]
            })
          };
        },
        unrecognizedObjectKeys: opts?.unrecognizedObjectKeys,
        skipValidation: opts?.skipValidation,
        breadcrumbsPrefix: opts?.breadcrumbsPrefix,
        omitUndefined: opts?.omitUndefined
      });
    },
    json: (parsed, opts) => {
      const requiredKeys = [];
      for (const [parsedKey, schemaOrObjectProperty] of entries2(schemas)) {
        const valueSchema = isProperty(schemaOrObjectProperty) ? schemaOrObjectProperty.valueSchema : schemaOrObjectProperty;
        if (isSchemaRequired(valueSchema)) {
          requiredKeys.push(parsedKey);
        }
      }
      return validateAndTransformObject({
        value: parsed,
        requiredKeys,
        getProperty: (parsedKey) => {
          const property4 = schemas[parsedKey];
          if (property4 == null) {
            return void 0;
          }
          if (isProperty(property4)) {
            return {
              transformedKey: property4.rawKey,
              transform: (propertyValue) => property4.valueSchema.json(propertyValue, {
                ...opts,
                breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedKey]
              })
            };
          } else {
            return {
              transformedKey: parsedKey,
              transform: (propertyValue) => property4.json(propertyValue, {
                ...opts,
                breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedKey]
              })
            };
          }
        },
        unrecognizedObjectKeys: opts?.unrecognizedObjectKeys,
        skipValidation: opts?.skipValidation,
        breadcrumbsPrefix: opts?.breadcrumbsPrefix,
        omitUndefined: opts?.omitUndefined
      });
    },
    getType: () => SchemaType.OBJECT
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema),
    ...getObjectLikeUtils(baseSchema),
    ...getObjectUtils(baseSchema)
  };
}
function validateAndTransformObject({ value, requiredKeys, getProperty: getProperty2, unrecognizedObjectKeys = "fail", skipValidation = false, breadcrumbsPrefix = [] }) {
  if (!isPlainObject3(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "object")
        }
      ]
    };
  }
  const missingRequiredKeys = new Set(requiredKeys);
  const errors = [];
  const transformed = {};
  for (const [preTransformedKey, preTransformedItemValue] of Object.entries(value)) {
    const property4 = getProperty2(preTransformedKey);
    if (property4 != null) {
      missingRequiredKeys.delete(preTransformedKey);
      const value2 = property4.transform(preTransformedItemValue);
      if (value2.ok) {
        transformed[property4.transformedKey] = value2.value;
      } else {
        transformed[preTransformedKey] = preTransformedItemValue;
        errors.push(...value2.errors);
      }
    } else {
      switch (unrecognizedObjectKeys) {
        case "fail":
          errors.push({
            path: [...breadcrumbsPrefix, preTransformedKey],
            message: `Unexpected key "${preTransformedKey}"`
          });
          break;
        case "strip":
          break;
        case "passthrough":
          transformed[preTransformedKey] = preTransformedItemValue;
          break;
      }
    }
  }
  errors.push(...requiredKeys.filter((key) => missingRequiredKeys.has(key)).map((key) => ({
    path: breadcrumbsPrefix,
    message: `Missing required key "${key}"`
  })));
  if (errors.length === 0 || skipValidation) {
    return {
      ok: true,
      value: transformed
    };
  } else {
    return {
      ok: false,
      errors
    };
  }
}
function getObjectUtils(schema2) {
  return {
    extend: (extension) => {
      const baseSchema = {
        _getParsedProperties: () => [...schema2._getParsedProperties(), ...extension._getParsedProperties()],
        _getRawProperties: () => [...schema2._getRawProperties(), ...extension._getRawProperties()],
        parse: (raw, opts) => {
          return validateAndTransformExtendedObject({
            extensionKeys: extension._getRawProperties(),
            value: raw,
            transformBase: (rawBase) => schema2.parse(rawBase, opts),
            transformExtension: (rawExtension) => extension.parse(rawExtension, opts)
          });
        },
        json: (parsed, opts) => {
          return validateAndTransformExtendedObject({
            extensionKeys: extension._getParsedProperties(),
            value: parsed,
            transformBase: (parsedBase) => schema2.json(parsedBase, opts),
            transformExtension: (parsedExtension) => extension.json(parsedExtension, opts)
          });
        },
        getType: () => SchemaType.OBJECT
      };
      return {
        ...baseSchema,
        ...getSchemaUtils(baseSchema),
        ...getObjectLikeUtils(baseSchema),
        ...getObjectUtils(baseSchema)
      };
    }
  };
}
function validateAndTransformExtendedObject({ extensionKeys, value, transformBase, transformExtension }) {
  const extensionPropertiesSet = new Set(extensionKeys);
  const [extensionProperties, baseProperties] = partition(keys3(value), (key) => extensionPropertiesSet.has(key));
  const transformedBase = transformBase(filterObject(value, baseProperties));
  const transformedExtension = transformExtension(filterObject(value, extensionProperties));
  if (transformedBase.ok && transformedExtension.ok) {
    return {
      ok: true,
      value: {
        ...transformedBase.value,
        ...transformedExtension.value
      }
    };
  } else {
    return {
      ok: false,
      errors: [
        ...transformedBase.ok ? [] : transformedBase.errors,
        ...transformedExtension.ok ? [] : transformedExtension.errors
      ]
    };
  }
}
function isSchemaRequired(schema2) {
  return !isSchemaOptional(schema2);
}
function isSchemaOptional(schema2) {
  switch (schema2.getType()) {
    case SchemaType.ANY:
    case SchemaType.UNKNOWN:
    case SchemaType.OPTIONAL:
      return true;
    default:
      return false;
  }
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/object/objectWithoutOptionalProperties.js
function objectWithoutOptionalProperties(schemas) {
  return object(schemas);
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/lazy/lazyObject.js
function lazyObject(getter) {
  const baseSchema = {
    ...constructLazyBaseSchema(getter),
    _getRawProperties: () => getMemoizedSchema(getter)._getRawProperties(),
    _getParsedProperties: () => getMemoizedSchema(getter)._getParsedProperties()
  };
  return {
    ...baseSchema,
    ...getSchemaUtils(baseSchema),
    ...getObjectLikeUtils(baseSchema),
    ...getObjectUtils(baseSchema)
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/list/list.js
function list(schema2) {
  const baseSchema = {
    parse: (raw, opts) => validateAndTransformArray(raw, (item, index) => schema2.parse(item, {
      ...opts,
      breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `[${index}]`]
    })),
    json: (parsed, opts) => validateAndTransformArray(parsed, (item, index) => schema2.json(item, {
      ...opts,
      breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `[${index}]`]
    })),
    getType: () => SchemaType.LIST
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema)
  };
}
function validateAndTransformArray(value, transformItem) {
  if (!Array.isArray(value)) {
    return {
      ok: false,
      errors: [
        {
          message: getErrorMessageForIncorrectType(value, "list"),
          path: []
        }
      ]
    };
  }
  const maybeValidItems = value.map((item, index) => transformItem(item, index));
  return maybeValidItems.reduce((acc, item) => {
    if (acc.ok && item.ok) {
      return {
        ok: true,
        value: [...acc.value, item.value]
      };
    }
    const errors = [];
    if (!acc.ok) {
      errors.push(...acc.errors);
    }
    if (!item.ok) {
      errors.push(...item.errors);
    }
    return {
      ok: false,
      errors
    };
  }, { ok: true, value: [] });
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/literals/stringLiteral.js
function stringLiteral(literal) {
  const schemaCreator = createIdentitySchemaCreator(SchemaType.STRING_LITERAL, (value, { breadcrumbsPrefix = [] } = {}) => {
    if (value === literal) {
      return {
        ok: true,
        value: literal
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType(value, `"${literal}"`)
          }
        ]
      };
    }
  });
  return schemaCreator();
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/literals/booleanLiteral.js
function booleanLiteral(literal) {
  const schemaCreator = createIdentitySchemaCreator(SchemaType.BOOLEAN_LITERAL, (value, { breadcrumbsPrefix = [] } = {}) => {
    if (value === literal) {
      return {
        ok: true,
        value: literal
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType(value, `${literal.toString()}`)
          }
        ]
      };
    }
  });
  return schemaCreator();
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/primitives/any.js
var any = createIdentitySchemaCreator(SchemaType.ANY, (value) => ({ ok: true, value }));

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/primitives/boolean.js
var boolean = createIdentitySchemaCreator(SchemaType.BOOLEAN, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "boolean") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "boolean")
        }
      ]
    };
  }
});

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/primitives/number.js
var number = createIdentitySchemaCreator(SchemaType.NUMBER, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "number") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "number")
        }
      ]
    };
  }
});

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/primitives/string.js
var string = createIdentitySchemaCreator(SchemaType.STRING, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "string") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "string")
        }
      ]
    };
  }
});

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/primitives/unknown.js
var unknown = createIdentitySchemaCreator(SchemaType.UNKNOWN, (value) => ({ ok: true, value }));

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/record/record.js
function record(keySchema, valueSchema) {
  const baseSchema = {
    parse: (raw, opts) => {
      return validateAndTransformRecord({
        value: raw,
        isKeyNumeric: keySchema.getType() === SchemaType.NUMBER,
        transformKey: (key) => keySchema.parse(key, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key} (key)`]
        }),
        transformValue: (value, key) => valueSchema.parse(value, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key}`]
        }),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    json: (parsed, opts) => {
      return validateAndTransformRecord({
        value: parsed,
        isKeyNumeric: keySchema.getType() === SchemaType.NUMBER,
        transformKey: (key) => keySchema.json(key, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key} (key)`]
        }),
        transformValue: (value, key) => valueSchema.json(value, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key}`]
        }),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    getType: () => SchemaType.RECORD
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema)
  };
}
function validateAndTransformRecord({ value, isKeyNumeric, transformKey, transformValue, breadcrumbsPrefix = [] }) {
  if (!isPlainObject3(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "object")
        }
      ]
    };
  }
  return entries2(value).reduce((accPromise, [stringKey, value2]) => {
    if (value2 == null) {
      return accPromise;
    }
    const acc = accPromise;
    let key = stringKey;
    if (isKeyNumeric) {
      const numberKey = stringKey.length > 0 ? Number(stringKey) : NaN;
      if (!isNaN(numberKey)) {
        key = numberKey;
      }
    }
    const transformedKey = transformKey(key);
    const transformedValue = transformValue(value2, key);
    if (acc.ok && transformedKey.ok && transformedValue.ok) {
      return {
        ok: true,
        value: {
          ...acc.value,
          [transformedKey.value]: transformedValue.value
        }
      };
    }
    const errors = [];
    if (!acc.ok) {
      errors.push(...acc.errors);
    }
    if (!transformedKey.ok) {
      errors.push(...transformedKey.errors);
    }
    if (!transformedValue.ok) {
      errors.push(...transformedValue.errors);
    }
    return {
      ok: false,
      errors
    };
  }, { ok: true, value: {} });
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/set/set.js
function set(schema2) {
  const listSchema = list(schema2);
  const baseSchema = {
    parse: (raw, opts) => {
      const parsedList = listSchema.parse(raw, opts);
      if (parsedList.ok) {
        return {
          ok: true,
          value: new Set(parsedList.value)
        };
      } else {
        return parsedList;
      }
    },
    json: (parsed, opts) => {
      if (!(parsed instanceof Set)) {
        return {
          ok: false,
          errors: [
            {
              path: opts?.breadcrumbsPrefix ?? [],
              message: getErrorMessageForIncorrectType(parsed, "Set")
            }
          ]
        };
      }
      const jsonList = listSchema.json([...parsed], opts);
      return jsonList;
    },
    getType: () => SchemaType.SET
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema)
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/undiscriminated-union/undiscriminatedUnion.js
function undiscriminatedUnion(schemas) {
  const baseSchema = {
    parse: (raw, opts) => {
      return validateAndTransformUndiscriminatedUnion((schema2, opts2) => schema2.parse(raw, opts2), schemas, opts);
    },
    json: (parsed, opts) => {
      return validateAndTransformUndiscriminatedUnion((schema2, opts2) => schema2.json(parsed, opts2), schemas, opts);
    },
    getType: () => SchemaType.UNDISCRIMINATED_UNION
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema)
  };
}
function validateAndTransformUndiscriminatedUnion(transform3, schemas, opts) {
  const errors = [];
  for (const [index, schema2] of schemas.entries()) {
    const transformed = transform3(schema2, { ...opts, skipValidation: false });
    if (transformed.ok) {
      return transformed;
    } else {
      for (const error of transformed.errors) {
        errors.push({
          path: error.path,
          message: `[Variant ${index}] ${error.message}`
        });
      }
    }
  }
  return {
    ok: false,
    errors
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/union/discriminant.js
function discriminant(parsedDiscriminant, rawDiscriminant) {
  return {
    parsedDiscriminant,
    rawDiscriminant
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/union/union.js
function union(discriminant3, union3) {
  const rawDiscriminant = typeof discriminant3 === "string" ? discriminant3 : discriminant3.rawDiscriminant;
  const parsedDiscriminant = typeof discriminant3 === "string" ? discriminant3 : discriminant3.parsedDiscriminant;
  const discriminantValueSchema = enum_(keys3(union3));
  const baseSchema = {
    parse: (raw, opts) => {
      return transformAndValidateUnion({
        value: raw,
        discriminant: rawDiscriminant,
        transformedDiscriminant: parsedDiscriminant,
        transformDiscriminantValue: (discriminantValue) => discriminantValueSchema.parse(discriminantValue, {
          allowUnrecognizedEnumValues: opts?.allowUnrecognizedUnionMembers,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], rawDiscriminant]
        }),
        getAdditionalPropertiesSchema: (discriminantValue) => union3[discriminantValue],
        allowUnrecognizedUnionMembers: opts?.allowUnrecognizedUnionMembers,
        transformAdditionalProperties: (additionalProperties, additionalPropertiesSchema) => additionalPropertiesSchema.parse(additionalProperties, opts),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    json: (parsed, opts) => {
      return transformAndValidateUnion({
        value: parsed,
        discriminant: parsedDiscriminant,
        transformedDiscriminant: rawDiscriminant,
        transformDiscriminantValue: (discriminantValue) => discriminantValueSchema.json(discriminantValue, {
          allowUnrecognizedEnumValues: opts?.allowUnrecognizedUnionMembers,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedDiscriminant]
        }),
        getAdditionalPropertiesSchema: (discriminantValue) => union3[discriminantValue],
        allowUnrecognizedUnionMembers: opts?.allowUnrecognizedUnionMembers,
        transformAdditionalProperties: (additionalProperties, additionalPropertiesSchema) => additionalPropertiesSchema.json(additionalProperties, opts),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    getType: () => SchemaType.UNION
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema),
    ...getObjectLikeUtils(baseSchema)
  };
}
function transformAndValidateUnion({ value, discriminant: discriminant3, transformedDiscriminant, transformDiscriminantValue, getAdditionalPropertiesSchema, allowUnrecognizedUnionMembers = false, transformAdditionalProperties, breadcrumbsPrefix = [] }) {
  if (!isPlainObject3(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "object")
        }
      ]
    };
  }
  const { [discriminant3]: discriminantValue, ...additionalProperties } = value;
  if (discriminantValue == null) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: `Missing discriminant ("${discriminant3}")`
        }
      ]
    };
  }
  const transformedDiscriminantValue = transformDiscriminantValue(discriminantValue);
  if (!transformedDiscriminantValue.ok) {
    return {
      ok: false,
      errors: transformedDiscriminantValue.errors
    };
  }
  const additionalPropertiesSchema = getAdditionalPropertiesSchema(transformedDiscriminantValue.value);
  if (additionalPropertiesSchema == null) {
    if (allowUnrecognizedUnionMembers) {
      return {
        ok: true,
        value: {
          [transformedDiscriminant]: transformedDiscriminantValue.value,
          ...additionalProperties
        }
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: [...breadcrumbsPrefix, discriminant3],
            message: "Unexpected discriminant value"
          }
        ]
      };
    }
  }
  const transformedAdditionalProperties = transformAdditionalProperties(additionalProperties, additionalPropertiesSchema);
  if (!transformedAdditionalProperties.ok) {
    return transformedAdditionalProperties;
  }
  return {
    ok: true,
    value: {
      [transformedDiscriminant]: discriminantValue,
      ...transformedAdditionalProperties.value
    }
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthAccessTokenRequestPropertiesSchema.js
var OAuthAccessTokenRequestPropertiesSchema = schemas_exports.object({
  "client-id": schemas_exports.string().optional(),
  "client-secret": schemas_exports.string().optional(),
  scopes: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthAccessTokenResponsePropertiesSchema.js
var OAuthAccessTokenResponsePropertiesSchema = schemas_exports.object({
  "access-token": schemas_exports.string().optional(),
  "expires-in": schemas_exports.string().optional(),
  "refresh-token": schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthGetTokenEndpointSchema.js
var OAuthGetTokenEndpointSchema = schemas_exports.object({
  endpoint: schemas_exports.string(),
  "request-properties": OAuthAccessTokenRequestPropertiesSchema.optional(),
  "response-properties": OAuthAccessTokenResponsePropertiesSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthRefreshTokenRequestPropertiesSchema.js
var OAuthRefreshTokenRequestPropertiesSchema = schemas_exports.object({
  "refresh-token": schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthRefreshTokenResponsePropertiesSchema.js
var OAuthRefreshTokenResponsePropertiesSchema = schemas_exports.object({
  "access-token": schemas_exports.string().optional(),
  "expires-in": schemas_exports.string().optional(),
  "refresh-token": schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthRefreshTokenEndpointSchema.js
var OAuthRefreshTokenEndpointSchema = schemas_exports.object({
  endpoint: schemas_exports.string(),
  "request-properties": OAuthRefreshTokenRequestPropertiesSchema.optional(),
  "response-properties": OAuthRefreshTokenResponsePropertiesSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/commons/types/WithDocsSchema.js
var WithDocsSchema = schemas_exports.object({
  docs: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthSchemeSchema.js
var OAuthSchemeSchema = schemas_exports.object({
  scheme: schemas_exports.stringLiteral("oauth"),
  type: schemas_exports.stringLiteral("client-credentials"),
  scopes: schemas_exports.list(schemas_exports.string()).optional(),
  "client-id-env": schemas_exports.string().optional(),
  "client-secret-env": schemas_exports.string().optional(),
  "token-prefix": schemas_exports.string().optional(),
  "token-header": schemas_exports.string().optional(),
  "get-token": OAuthGetTokenEndpointSchema,
  "refresh-token": OAuthRefreshTokenEndpointSchema.optional()
}).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/WithEnvironmentVariable.js
var WithEnvironmentVariable = schemas_exports.object({
  env: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/commons/types/WithName.js
var WithName = schemas_exports.object({
  name: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/HeaderAuthSchemeSchema.js
var HeaderAuthSchemeSchema = schemas_exports.object({
  header: schemas_exports.string(),
  type: schemas_exports.string().optional(),
  prefix: schemas_exports.string().optional()
}).extend(WithEnvironmentVariable).extend(WithName).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/AuthVariable.js
var AuthVariable = schemas_exports.object({}).extend(WithEnvironmentVariable).extend(WithName);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/BasicAuthSchemeSchema.js
var BasicAuthSchemeSchema = schemas_exports.object({
  scheme: schemas_exports.stringLiteral("basic"),
  username: AuthVariable.optional(),
  password: AuthVariable.optional()
}).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/BearerAuthSchemeSchema.js
var BearerAuthSchemeSchema = schemas_exports.object({
  scheme: schemas_exports.stringLiteral("bearer"),
  token: AuthVariable.optional()
}).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/AuthSchemeDeclarationSchema.js
var AuthSchemeDeclarationSchema = schemas_exports.undiscriminatedUnion([
  OAuthSchemeSchema,
  HeaderAuthSchemeSchema,
  BasicAuthSchemeSchema,
  BearerAuthSchemeSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiDefinitionPathSchema.js
var ApiDefinitionPathSchema = schemas_exports.string();

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/UnionSettingsSchema.js
var UnionSettingsSchema2 = schemas_exports.enum_(["v1"]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/MessageNamingSettingsSchema.js
var MessageNamingSettingsSchema2 = schemas_exports.enum_(["v1", "v2"]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiDefinitionSettingsSchema.js
var ApiDefinitionSettingsSchema = schemas_exports.object({
  "use-title": schemas_exports.boolean().optional(),
  unions: UnionSettingsSchema2.optional(),
  "message-naming": MessageNamingSettingsSchema2.optional(),
  "only-include-referenced-schemas": schemas_exports.boolean().optional(),
  "inline-path-parameters": schemas_exports.boolean().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiDefinitionWithOverridesSchema.js
var ApiDefinitionWithOverridesSchema = schemas_exports.object({
  path: ApiDefinitionPathSchema,
  origin: schemas_exports.string().optional(),
  overrides: schemas_exports.string().optional(),
  audiences: schemas_exports.list(schemas_exports.string()).optional(),
  settings: ApiDefinitionSettingsSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ProtobufDefinitionSchema.js
var ProtobufDefinitionSchema = schemas_exports.object({
  root: schemas_exports.string(),
  target: schemas_exports.string(),
  overrides: schemas_exports.string().optional(),
  "local-generation": schemas_exports.boolean().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ProtobufApiDefinitionSchema.js
var ProtobufApiDefinitionSchema = schemas_exports.object({
  proto: ProtobufDefinitionSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiDefinitionSchema.js
var ApiDefinitionSchema = schemas_exports.undiscriminatedUnion([
  ApiDefinitionPathSchema,
  ApiDefinitionWithOverridesSchema,
  ProtobufApiDefinitionSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiDefinitionList.js
var ApiDefinitionList = schemas_exports.list(ApiDefinitionSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiConfigurationSchemaInternal.js
var ApiConfigurationSchemaInternal = schemas_exports.undiscriminatedUnion([
  ApiDefinitionPathSchema,
  ApiDefinitionWithOverridesSchema,
  ApiDefinitionList,
  ProtobufApiDefinitionSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/NamespacedApiConfigurationSchema.js
var NamespacedApiConfigurationSchema = schemas_exports.object({
  namespaces: schemas_exports.record(schemas_exports.string(), ApiConfigurationSchemaInternal)
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/AuthSchemeReferenceSchema.js
var AuthSchemeReferenceSchema = schemas_exports.object({
  scheme: schemas_exports.string()
}).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/AnyAuthItem.js
var AnyAuthItem = schemas_exports.undiscriminatedUnion([schemas_exports.string(), AuthSchemeReferenceSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/AnyAuthSchemesSchema.js
var AnyAuthSchemesSchema = schemas_exports.object({
  any: schemas_exports.list(AnyAuthItem)
}).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/ApiAuthSchema.js
var ApiAuthSchema = schemas_exports.undiscriminatedUnion([
  schemas_exports.string(),
  AuthSchemeReferenceSchema,
  AnyAuthSchemesSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/OpenApiSettingsSchema.js
var OpenApiSettingsSchema = schemas_exports.object({
  "title-as-schema-name": schemas_exports.boolean().optional(),
  "optional-additional-properties": schemas_exports.boolean().optional(),
  "coerce-enums-to-literals": schemas_exports.boolean().optional(),
  "object-query-parameters": schemas_exports.boolean().optional(),
  "respect-readonly-schemas": schemas_exports.boolean().optional(),
  "only-include-referenced-schemas": schemas_exports.boolean().optional(),
  "inline-path-parameters": schemas_exports.boolean().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/OpenApiSpecSchema.js
var OpenApiSpecSchema = schemas_exports.object({
  openapi: schemas_exports.string(),
  origin: schemas_exports.string().optional(),
  overrides: schemas_exports.string().optional(),
  namespace: schemas_exports.string().optional(),
  settings: OpenApiSettingsSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/AsyncApiSettingsSchema.js
var AsyncApiSettingsSchema = schemas_exports.object({
  "title-as-schema-name": schemas_exports.boolean().optional(),
  "optional-additional-properties": schemas_exports.boolean().optional(),
  "coerce-enums-to-literals": schemas_exports.boolean().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/AsyncApiSchema.js
var AsyncApiSchema = schemas_exports.object({
  asyncapi: schemas_exports.string(),
  origin: schemas_exports.string().optional(),
  overrides: schemas_exports.string().optional(),
  namespace: schemas_exports.string().optional(),
  settings: AsyncApiSettingsSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/AsyncApiOrOpenApiSpecSchema.js
var AsyncApiOrOpenApiSpecSchema = schemas_exports.undiscriminatedUnion([OpenApiSpecSchema, AsyncApiSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ConjureSchema.js
var ConjureSchema = schemas_exports.object({
  conjure: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiConfigurationV2SpecsSchema.js
var ApiConfigurationV2SpecsSchema = schemas_exports.undiscriminatedUnion([schemas_exports.list(AsyncApiOrOpenApiSpecSchema), ConjureSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/encoding/types/ProtobufTypeSchema.js
var ProtobufTypeSchema = schemas_exports.object({
  type: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/encoding/types/EncodingSchema.js
var EncodingSchema = schemas_exports.object({
  proto: ProtobufTypeSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/validation/types/StringValidationSchema.js
var StringValidationSchema = schemas_exports.object({
  minLength: schemas_exports.number().optional(),
  maxLength: schemas_exports.number().optional(),
  pattern: schemas_exports.string().optional(),
  format: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/validation/types/NumberValidationSchema.js
var NumberValidationSchema = schemas_exports.object({
  min: schemas_exports.number().optional(),
  max: schemas_exports.number().optional(),
  exclusiveMin: schemas_exports.boolean().optional(),
  exclusiveMax: schemas_exports.boolean().optional(),
  multipleOf: schemas_exports.number().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/validation/types/ValidationSchema.js
var ValidationSchema = schemas_exports.undiscriminatedUnion([StringValidationSchema, NumberValidationSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/availability/types/AvailabilityStatusSchema.js
var AvailabilityStatusSchema2 = schemas_exports.enum_(["in-development", "pre-release", "deprecated", "generally-available"]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/availability/types/AvailabilitySchema.js
var AvailabilitySchema = schemas_exports.object({
  status: AvailabilityStatusSchema2,
  message: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/availability/types/AvailabilityUnionSchema.js
var AvailabilityUnionSchema = schemas_exports.undiscriminatedUnion([AvailabilityStatusSchema2, AvailabilitySchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/commons/types/WithAvailability.js
var WithAvailability = schemas_exports.object({
  availability: AvailabilityUnionSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/types/types/BaseTypeReferenceSchema.js
var BaseTypeReferenceSchema = schemas_exports.object({
  default: schemas_exports.unknown().optional(),
  encoding: EncodingSchema.optional(),
  validation: ValidationSchema.optional()
}).extend(WithDocsSchema).extend(WithAvailability);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/commons/types/WithAudiences.js
var WithAudiences = schemas_exports.object({
  audiences: schemas_exports.list(schemas_exports.string()).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/types/types/TypeReferenceDeclarationWithName.js
var TypeReferenceDeclarationWithName = schemas_exports.object({
  type: schemas_exports.string()
}).extend(BaseTypeReferenceSchema).extend(WithName).extend(WithAudiences);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/service/types/TypeReferenceDeclarationWithEnvOverrideSchema.js
var TypeReferenceDeclarationWithEnvOverrideSchema = schemas_exports.object({
  env: schemas_exports.string().optional()
}).extend(TypeReferenceDeclarationWithName);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/service/types/TypeReferenceDeclarationWithEnvOverride.js
var TypeReferenceDeclarationWithEnvOverride = schemas_exports.undiscriminatedUnion([
  schemas_exports.string(),
  TypeReferenceDeclarationWithEnvOverrideSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/service/types/HttpHeaderSchema.js
var HttpHeaderSchema = TypeReferenceDeclarationWithEnvOverride;

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/file/types/WithHeadersSchema.js
var WithHeadersSchema = schemas_exports.object({
  headers: schemas_exports.record(schemas_exports.string(), HttpHeaderSchema).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/environments/types/SingleBaseUrlEnvironmentSchema.js
var SingleBaseUrlEnvironmentSchema = schemas_exports.object({
  url: schemas_exports.string()
}).extend(WithAudiences).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/environments/types/MultipleBaseUrlsEnvironmentSchema.js
var MultipleBaseUrlsEnvironmentSchema = schemas_exports.object({
  urls: schemas_exports.record(schemas_exports.string(), schemas_exports.string())
}).extend(WithAudiences).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/environments/types/EnvironmentSchema.js
var EnvironmentSchema = schemas_exports.undiscriminatedUnion([
  schemas_exports.string(),
  SingleBaseUrlEnvironmentSchema,
  MultipleBaseUrlsEnvironmentSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/environments/types/WithEnvironmentsSchema.js
var WithEnvironmentsSchema = schemas_exports.object({
  "default-url": schemas_exports.string().optional(),
  "default-environment": schemas_exports.string().optional(),
  environments: schemas_exports.record(schemas_exports.string(), EnvironmentSchema).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiConfigurationV2Schema.js
var ApiConfigurationV2Schema = schemas_exports.object({
  auth: ApiAuthSchema.optional(),
  specs: ApiConfigurationV2SpecsSchema
}).extend(WithHeadersSchema).extend(WithEnvironmentsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiConfigurationSchema.js
var ApiConfigurationSchema = schemas_exports.undiscriminatedUnion([
  ApiConfigurationSchemaInternal,
  NamespacedApiConfigurationSchema,
  ApiConfigurationV2Schema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/WhitelabelGithubConfigurationSchema.js
var WhitelabelGithubConfigurationSchema = schemas_exports.object({
  username: schemas_exports.string(),
  email: schemas_exports.string(),
  token: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/WhitelabelConfigurationSchema.js
var WhitelabelConfigurationSchema = schemas_exports.object({
  github: WhitelabelGithubConfigurationSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/OutputMetadataAuthor.js
var OutputMetadataAuthor = schemas_exports.object({
  name: schemas_exports.string(),
  email: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/OutputMetadataSchema.js
var OutputMetadataSchema = schemas_exports.object({
  description: schemas_exports.string().optional(),
  authors: schemas_exports.list(OutputMetadataAuthor).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ReadmeEndpointObjectSchema.js
var ReadmeEndpointObjectSchema = schemas_exports.object({
  method: schemas_exports.string(),
  path: schemas_exports.string(),
  stream: schemas_exports.boolean().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ReadmeEndpointSchema.js
var ReadmeEndpointSchema = schemas_exports.undiscriminatedUnion([schemas_exports.string(), ReadmeEndpointObjectSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ReadmeSchema.js
var ReadmeSchema = schemas_exports.object({
  bannerLink: schemas_exports.string().optional(),
  introduction: schemas_exports.string().optional(),
  apiReferenceLink: schemas_exports.string().optional(),
  defaultEndpoint: ReadmeEndpointSchema.optional(),
  features: schemas_exports.record(schemas_exports.string(), schemas_exports.list(ReadmeEndpointSchema)).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/NpmOutputLocationSchema.js
var NpmOutputLocationSchema = schemas_exports.object({
  url: schemas_exports.string().optional(),
  "package-name": schemas_exports.string(),
  token: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/MavenOutputSignatureSchema.js
var MavenOutputSignatureSchema = schemas_exports.object({
  keyId: schemas_exports.string(),
  password: schemas_exports.string(),
  secretKey: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/MavenOutputLocationSchema.js
var MavenOutputLocationSchema = schemas_exports.object({
  url: schemas_exports.string().optional(),
  coordinate: schemas_exports.string(),
  username: schemas_exports.string().optional(),
  password: schemas_exports.string().optional(),
  signature: MavenOutputSignatureSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/PypiOutputMetadataSchema.js
var PypiOutputMetadataSchema = schemas_exports.object({
  keywords: schemas_exports.list(schemas_exports.string()).optional(),
  "documentation-link": schemas_exports.string().optional(),
  "homepage-link": schemas_exports.string().optional()
}).extend(OutputMetadataSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/PypiOutputLocationSchema.js
var PypiOutputLocationSchema = schemas_exports.object({
  url: schemas_exports.string().optional(),
  "package-name": schemas_exports.string(),
  token: schemas_exports.string().optional(),
  username: schemas_exports.string().optional(),
  password: schemas_exports.string().optional(),
  metadata: PypiOutputMetadataSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/PostmanOutputLocationSchema.js
var PostmanOutputLocationSchema = schemas_exports.object({
  "api-key": schemas_exports.string(),
  "workspace-id": schemas_exports.string(),
  "collection-id": schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/LocalFileSystemOutputLocationSchema.js
var LocalFileSystemOutputLocationSchema = schemas_exports.object({
  path: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/NugetOutputLocationSchema.js
var NugetOutputLocationSchema = schemas_exports.object({
  url: schemas_exports.string().optional(),
  "package-name": schemas_exports.string(),
  "api-key": schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/RubyGemsOutputLocationSchema.js
var RubyGemsOutputLocationSchema = schemas_exports.object({
  url: schemas_exports.string().optional(),
  "package-name": schemas_exports.string(),
  "api-key": schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorOutputSchema.js
var GeneratorOutputSchema = schemas_exports.union("location", {
  npm: NpmOutputLocationSchema,
  maven: MavenOutputLocationSchema,
  pypi: PypiOutputLocationSchema,
  postman: PostmanOutputLocationSchema,
  "local-file-system": LocalFileSystemOutputLocationSchema,
  nuget: NugetOutputLocationSchema,
  rubygems: RubyGemsOutputLocationSchema
}).transform({
  transform: (value) => value,
  untransform: (value) => value
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/license/types/GithubLicenseType.js
var GithubLicenseType2 = schemas_exports.enum_(["MIT", "Apache-2.0"]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/license/types/GithubLicenseCustomSchema.js
var GithubLicenseCustomSchema = schemas_exports.object({
  custom: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/license/types/GithubLicenseSchema.js
var GithubLicenseSchema = schemas_exports.undiscriminatedUnion([GithubLicenseType2, GithubLicenseCustomSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GithubCommitAndReleaseMode.js
var GithubCommitAndReleaseMode2 = schemas_exports.enum_(["commit", "release"]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GithubCommitAndReleaseSchema.js
var GithubCommitAndReleaseSchema = schemas_exports.object({
  repository: schemas_exports.string(),
  license: GithubLicenseSchema.optional(),
  mode: GithubCommitAndReleaseMode2.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/reviewers/types/ReviewerSchema.js
var ReviewerSchema = schemas_exports.object({
  name: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/reviewers/types/ReviewersSchema.js
var ReviewersSchema = schemas_exports.object({
  teams: schemas_exports.list(ReviewerSchema).optional(),
  users: schemas_exports.list(ReviewerSchema).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GithubPullRequestSchema.js
var GithubPullRequestSchema = schemas_exports.object({
  repository: schemas_exports.string(),
  branch: schemas_exports.string().optional(),
  license: GithubLicenseSchema.optional(),
  mode: schemas_exports.stringLiteral("pull-request"),
  reviewers: ReviewersSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GithubPushSchema.js
var GithubPushSchema = schemas_exports.object({
  repository: schemas_exports.string(),
  license: GithubLicenseSchema.optional(),
  mode: schemas_exports.stringLiteral("push"),
  branch: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GithubConfigurationSchema.js
var GithubConfigurationSchema = schemas_exports.undiscriminatedUnion([GithubCommitAndReleaseSchema, GithubPullRequestSchema, GithubPushSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorPublishMetadataSchema.js
var GeneratorPublishMetadataSchema = schemas_exports.object({
  "package-description": schemas_exports.string().optional(),
  email: schemas_exports.string().optional(),
  "reference-url": schemas_exports.string().optional(),
  author: schemas_exports.string().optional(),
  license: GithubLicenseSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorSnippetsSchema.js
var GeneratorSnippetsSchema = schemas_exports.object({
  path: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorApiSettingsSchema.js
var GeneratorApiSettingsSchema = schemas_exports.object({
  settings: ApiDefinitionSettingsSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorInvocationSchema.js
var GeneratorInvocationSchema = schemas_exports.object({
  name: schemas_exports.string(),
  version: schemas_exports.string(),
  output: GeneratorOutputSchema.optional(),
  github: GithubConfigurationSchema.optional(),
  config: schemas_exports.unknown(),
  metadata: GeneratorPublishMetadataSchema.optional(),
  keywords: schemas_exports.list(schemas_exports.string()).optional(),
  snippets: GeneratorSnippetsSchema.optional(),
  "ir-version": schemas_exports.string().optional(),
  "smart-casing": schemas_exports.boolean().optional(),
  api: GeneratorApiSettingsSchema.optional(),
  "disable-examples": schemas_exports.boolean().optional(),
  "publish-metadata": GeneratorPublishMetadataSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorGroupSchema.js
var GeneratorGroupSchema = schemas_exports.object({
  audiences: schemas_exports.list(schemas_exports.string()).optional(),
  generators: schemas_exports.list(GeneratorInvocationSchema),
  metadata: OutputMetadataSchema.optional(),
  reviewers: ReviewersSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/GeneratorsOpenApiObjectSchema.js
var GeneratorsOpenApiObjectSchema = schemas_exports.object({
  path: schemas_exports.string(),
  origin: schemas_exports.string().optional(),
  overrides: schemas_exports.string().optional(),
  "disable-examples": schemas_exports.boolean().optional(),
  settings: ApiDefinitionSettingsSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/GeneratorsOpenApiSchema.js
var GeneratorsOpenApiSchema = schemas_exports.undiscriminatedUnion([GeneratorsOpenApiObjectSchema, schemas_exports.string()]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/GeneratorsConfigurationSchema.js
var GeneratorsConfigurationSchema = schemas_exports.object({
  "auth-schemes": schemas_exports.record(schemas_exports.string(), AuthSchemeDeclarationSchema).optional(),
  api: ApiConfigurationSchema.optional(),
  whitelabel: WhitelabelConfigurationSchema.optional(),
  metadata: OutputMetadataSchema.optional(),
  readme: ReadmeSchema.optional(),
  "default-group": schemas_exports.string().optional(),
  groups: schemas_exports.record(schemas_exports.string(), GeneratorGroupSchema).optional(),
  reviewers: ReviewersSchema.optional(),
  openapi: GeneratorsOpenApiSchema.optional(),
  "openapi-overrides": schemas_exports.string().optional(),
  "spec-origin": schemas_exports.string().optional(),
  "async-api": schemas_exports.string().optional(),
  "api-settings": ApiDefinitionSettingsSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/index.js
var group_exports2 = {};
__export(group_exports2, {
  GeneratorApiSettingsSchema: () => GeneratorApiSettingsSchema,
  GeneratorGroupSchema: () => GeneratorGroupSchema,
  GeneratorInvocationSchema: () => GeneratorInvocationSchema,
  GeneratorOutputSchema: () => GeneratorOutputSchema,
  GeneratorPublishMetadataSchema: () => GeneratorPublishMetadataSchema,
  GeneratorSnippetsSchema: () => GeneratorSnippetsSchema,
  GithubCommitAndReleaseMode: () => GithubCommitAndReleaseMode2,
  GithubCommitAndReleaseSchema: () => GithubCommitAndReleaseSchema,
  GithubConfigurationSchema: () => GithubConfigurationSchema,
  GithubPullRequestSchema: () => GithubPullRequestSchema,
  GithubPushSchema: () => GithubPushSchema,
  LocalFileSystemOutputLocationSchema: () => LocalFileSystemOutputLocationSchema,
  MavenOutputLocationSchema: () => MavenOutputLocationSchema,
  MavenOutputSignatureSchema: () => MavenOutputSignatureSchema,
  NpmOutputLocationSchema: () => NpmOutputLocationSchema,
  NugetOutputLocationSchema: () => NugetOutputLocationSchema,
  PostmanOutputLocationSchema: () => PostmanOutputLocationSchema,
  PypiOutputLocationSchema: () => PypiOutputLocationSchema,
  PypiOutputMetadataSchema: () => PypiOutputMetadataSchema,
  RubyGemsOutputLocationSchema: () => RubyGemsOutputLocationSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/license/index.js
var license_exports2 = {};
__export(license_exports2, {
  GithubLicenseCustomSchema: () => GithubLicenseCustomSchema,
  GithubLicenseSchema: () => GithubLicenseSchema,
  GithubLicenseType: () => GithubLicenseType2
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/reviewers/index.js
var reviewers_exports2 = {};
__export(reviewers_exports2, {
  ReviewerSchema: () => ReviewerSchema,
  ReviewersSchema: () => ReviewersSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/index.js
var fernDefinition_exports2 = {};
__export(fernDefinition_exports2, {
  AnyAuthItem: () => AnyAuthItem,
  AnyAuthSchemesSchema: () => AnyAuthSchemesSchema,
  ApiAuthSchema: () => ApiAuthSchema,
  AuthSchemeDeclarationSchema: () => AuthSchemeDeclarationSchema,
  AuthSchemeReferenceSchema: () => AuthSchemeReferenceSchema,
  AuthVariable: () => AuthVariable,
  AvailabilitySchema: () => AvailabilitySchema,
  AvailabilityStatusSchema: () => AvailabilityStatusSchema2,
  AvailabilityUnionSchema: () => AvailabilityUnionSchema,
  BaseTypeReferenceSchema: () => BaseTypeReferenceSchema,
  BasicAuthSchemeSchema: () => BasicAuthSchemeSchema,
  BearerAuthSchemeSchema: () => BearerAuthSchemeSchema,
  EncodingSchema: () => EncodingSchema,
  EnvironmentSchema: () => EnvironmentSchema,
  HeaderAuthSchemeSchema: () => HeaderAuthSchemeSchema,
  HttpHeaderSchema: () => HttpHeaderSchema,
  MultipleBaseUrlsEnvironmentSchema: () => MultipleBaseUrlsEnvironmentSchema,
  NumberValidationSchema: () => NumberValidationSchema,
  OAuthAccessTokenRequestPropertiesSchema: () => OAuthAccessTokenRequestPropertiesSchema,
  OAuthAccessTokenResponsePropertiesSchema: () => OAuthAccessTokenResponsePropertiesSchema,
  OAuthGetTokenEndpointSchema: () => OAuthGetTokenEndpointSchema,
  OAuthRefreshTokenEndpointSchema: () => OAuthRefreshTokenEndpointSchema,
  OAuthRefreshTokenRequestPropertiesSchema: () => OAuthRefreshTokenRequestPropertiesSchema,
  OAuthRefreshTokenResponsePropertiesSchema: () => OAuthRefreshTokenResponsePropertiesSchema,
  OAuthSchemeSchema: () => OAuthSchemeSchema,
  ProtobufTypeSchema: () => ProtobufTypeSchema,
  SingleBaseUrlEnvironmentSchema: () => SingleBaseUrlEnvironmentSchema,
  StringValidationSchema: () => StringValidationSchema,
  TypeReferenceDeclarationWithEnvOverride: () => TypeReferenceDeclarationWithEnvOverride,
  TypeReferenceDeclarationWithEnvOverrideSchema: () => TypeReferenceDeclarationWithEnvOverrideSchema,
  TypeReferenceDeclarationWithName: () => TypeReferenceDeclarationWithName,
  ValidationSchema: () => ValidationSchema,
  WithAudiences: () => WithAudiences,
  WithAvailability: () => WithAvailability,
  WithDocsSchema: () => WithDocsSchema,
  WithEnvironmentVariable: () => WithEnvironmentVariable,
  WithEnvironmentsSchema: () => WithEnvironmentsSchema,
  WithHeadersSchema: () => WithHeadersSchema,
  WithName: () => WithName,
  auth: () => auth_exports2,
  availability: () => availability_exports2,
  commons: () => commons_exports2,
  encoding: () => encoding_exports2,
  environments: () => environments_exports2,
  file: () => file_exports2,
  service: () => service_exports2,
  types: () => types_exports2,
  validation: () => validation_exports2
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/index.js
var auth_exports2 = {};
__export(auth_exports2, {
  AnyAuthItem: () => AnyAuthItem,
  AnyAuthSchemesSchema: () => AnyAuthSchemesSchema,
  ApiAuthSchema: () => ApiAuthSchema,
  AuthSchemeDeclarationSchema: () => AuthSchemeDeclarationSchema,
  AuthSchemeReferenceSchema: () => AuthSchemeReferenceSchema,
  AuthVariable: () => AuthVariable,
  BasicAuthSchemeSchema: () => BasicAuthSchemeSchema,
  BearerAuthSchemeSchema: () => BearerAuthSchemeSchema,
  HeaderAuthSchemeSchema: () => HeaderAuthSchemeSchema,
  OAuthAccessTokenRequestPropertiesSchema: () => OAuthAccessTokenRequestPropertiesSchema,
  OAuthAccessTokenResponsePropertiesSchema: () => OAuthAccessTokenResponsePropertiesSchema,
  OAuthGetTokenEndpointSchema: () => OAuthGetTokenEndpointSchema,
  OAuthRefreshTokenEndpointSchema: () => OAuthRefreshTokenEndpointSchema,
  OAuthRefreshTokenRequestPropertiesSchema: () => OAuthRefreshTokenRequestPropertiesSchema,
  OAuthRefreshTokenResponsePropertiesSchema: () => OAuthRefreshTokenResponsePropertiesSchema,
  OAuthSchemeSchema: () => OAuthSchemeSchema,
  WithEnvironmentVariable: () => WithEnvironmentVariable
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/availability/index.js
var availability_exports2 = {};
__export(availability_exports2, {
  AvailabilitySchema: () => AvailabilitySchema,
  AvailabilityStatusSchema: () => AvailabilityStatusSchema2,
  AvailabilityUnionSchema: () => AvailabilityUnionSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/commons/index.js
var commons_exports2 = {};
__export(commons_exports2, {
  WithAudiences: () => WithAudiences,
  WithAvailability: () => WithAvailability,
  WithDocsSchema: () => WithDocsSchema,
  WithName: () => WithName
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/encoding/index.js
var encoding_exports2 = {};
__export(encoding_exports2, {
  EncodingSchema: () => EncodingSchema,
  ProtobufTypeSchema: () => ProtobufTypeSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/environments/index.js
var environments_exports2 = {};
__export(environments_exports2, {
  EnvironmentSchema: () => EnvironmentSchema,
  MultipleBaseUrlsEnvironmentSchema: () => MultipleBaseUrlsEnvironmentSchema,
  SingleBaseUrlEnvironmentSchema: () => SingleBaseUrlEnvironmentSchema,
  WithEnvironmentsSchema: () => WithEnvironmentsSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/file/index.js
var file_exports2 = {};
__export(file_exports2, {
  WithHeadersSchema: () => WithHeadersSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/service/index.js
var service_exports2 = {};
__export(service_exports2, {
  HttpHeaderSchema: () => HttpHeaderSchema,
  TypeReferenceDeclarationWithEnvOverride: () => TypeReferenceDeclarationWithEnvOverride,
  TypeReferenceDeclarationWithEnvOverrideSchema: () => TypeReferenceDeclarationWithEnvOverrideSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/types/index.js
var types_exports2 = {};
__export(types_exports2, {
  BaseTypeReferenceSchema: () => BaseTypeReferenceSchema,
  TypeReferenceDeclarationWithName: () => TypeReferenceDeclarationWithName
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/validation/index.js
var validation_exports2 = {};
__export(validation_exports2, {
  NumberValidationSchema: () => NumberValidationSchema,
  StringValidationSchema: () => StringValidationSchema,
  ValidationSchema: () => ValidationSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/index.js
var API_ORIGIN_LOCATION_KEY = "spec-origin";
var ASYNC_API_LOCATION_KEY = "async-api";
var DEFAULT_GROUP_GENERATORS_CONFIG_KEY = "default-group";
var OPENAPI_LOCATION_KEY = "openapi";
var OPENAPI_OVERRIDES_LOCATION_KEY = "openapi-overrides";
var API_SETTINGS_KEY = "api-settings";

// ../../cli/configuration/lib/generators-yml/GeneratorsConfiguration.js
var GenerationLanguage = {
  TYPESCRIPT: "typescript",
  JAVA: "java",
  PYTHON: "python",
  GO: "go",
  RUBY: "ruby",
  CSHARP: "csharp",
  SWIFT: "swift",
  PHP: "php"
};
function getPackageName({ generatorInvocation }) {
  return generatorInvocation.outputMode._visit({
    downloadFiles: () => void 0,
    github: (val) => val.publishInfo?._visit({
      maven: (val2) => val2.coordinate,
      npm: (val2) => val2.packageName,
      pypi: (val2) => val2.packageName,
      postman: () => void 0,
      rubygems: (val2) => val2.packageName,
      nuget: (val2) => val2.packageName,
      _other: () => void 0
    }),
    githubV2: (val) => val.publishInfo?._visit({
      maven: (val2) => val2.coordinate,
      npm: (val2) => val2.packageName,
      pypi: (val2) => val2.packageName,
      postman: () => void 0,
      rubygems: (val2) => val2.packageName,
      nuget: (val2) => val2.packageName,
      _other: () => void 0
    }),
    publish: () => void 0,
    publishV2: () => void 0,
    _other: () => void 0
  });
}

// ../../cli/configuration/lib/generators-yml/isRawProtobufAPIDefinitionSchema.js
function isRawProtobufAPIDefinitionSchema(rawApiConfiguration) {
  return typeof rawApiConfiguration !== "string" && "proto" in rawApiConfiguration;
}

// ../../cli/generation/ir-generator/lib/casings/reserved.js
var RESERVED_KEYWORDS = {
  [generators_yml_exports.GenerationLanguage.PHP]: new Set([
    "abstract",
    "and",
    "as",
    "break",
    "callable",
    "case",
    "catch",
    "class",
    "clone",
    "const",
    "continue",
    "declare",
    "default",
    "do",
    "echo",
    "else",
    "elseif",
    "enddeclare",
    "endfor",
    "endforeach",
    "endif",
    "endswitch",
    "endwhile",
    "extends",
    "final",
    "finally",
    "fn",
    "for",
    "foreach",
    "function",
    "global",
    "goto",
    "list",
    "if",
    "implements",
    "include",
    "include_once",
    "instanceof",
    "insteadof",
    "interface",
    "match",
    "namespace",
    "new",
    "or",
    "parent",
    "Parent",
    "print",
    "private",
    "protected",
    "public",
    "readonly",
    "require",
    "require_once",
    "return",
    "static",
    "switch",
    "throw",
    "trait",
    "try",
    "use",
    "var",
    "while",
    "xor",
    "yield"
  ].flatMap((str2) => [str2, upperFirst_default(str2)])),
  [generators_yml_exports.GenerationLanguage.TYPESCRIPT]: /* @__PURE__ */ new Set([
    "any",
    "as",
    "boolean",
    "break",
    "case",
    "catch",
    "class",
    "const",
    "constructor",
    "continue",
    "debugger",
    "declare",
    "default",
    "delete",
    "do",
    "else",
    "enum",
    "export",
    "extends",
    "false",
    "finally",
    "for",
    "from",
    "function",
    "get",
    "if",
    "implements",
    "import",
    "in",
    "instanceof",
    "interface",
    "let",
    "module",
    "new",
    "null",
    "number",
    "of",
    "package",
    "private",
    "protected",
    "public",
    "require",
    "return",
    "set",
    "static",
    "string",
    "super",
    "switch",
    "symbol",
    "this",
    "throw",
    "true",
    "try",
    "type",
    "typeof",
    "var",
    "void",
    "while",
    "with",
    "yield",
    "Date",
    "Error",
    "File",
    "Object",
    "Record"
  ]),
  [generators_yml_exports.GenerationLanguage.JAVA]: /* @__PURE__ */ new Set([
    "abstract",
    "assert",
    "boolean",
    "break",
    "byte",
    "case",
    "catch",
    "char",
    "class",
    "const",
    "continue",
    "default",
    "do",
    "double",
    "else",
    "enum",
    "extends",
    "final",
    "finally",
    "float",
    "for",
    "goto",
    "if",
    "implements",
    "import",
    "instanceof",
    "int",
    "interface",
    "long",
    "native",
    "new",
    "null",
    "package",
    "private",
    "protected",
    "public",
    "return",
    "short",
    "static",
    "strictfp",
    "super",
    "switch",
    "synchronized",
    "this",
    "throw",
    "throws",
    "transient",
    "try",
    "void",
    "volatile",
    "while"
  ]),
  [generators_yml_exports.GenerationLanguage.PYTHON]: /* @__PURE__ */ new Set([
    "False",
    "None",
    "True",
    "and",
    "as",
    "assert",
    "async",
    "await",
    "break",
    "class",
    "continue",
    "def",
    "del",
    "elif",
    "else",
    "except",
    "finally",
    "for",
    "from",
    "global",
    "if",
    "import",
    "in",
    "is",
    "lambda",
    "nonlocal",
    "not",
    "or",
    "pass",
    "raise",
    "return",
    "try",
    "while",
    "with",
    "yield",
    "float",
    "int",
    "complex",
    "bool",
    "uuid",
    "list",
    "set",
    "map",
    "long",
    // the following aren't actually reserved, but we treat them as unavailable
    "self",
    "all"
  ]),
  [generators_yml_exports.GenerationLanguage.GO]: /* @__PURE__ */ new Set([
    // Keywords - these are not allowed. https://go.dev/ref/spec#Keywords
    "break",
    "case",
    "chan",
    "const",
    "continue",
    "default",
    "defer",
    "else",
    "fallthrough",
    "for",
    "func",
    "go",
    "goto",
    "if",
    "import",
    "interface",
    "map",
    "package",
    "range",
    "return",
    "select",
    "struct",
    "switch",
    "type",
    "var",
    // Technically allowed as identifiers, but should be avoided.
    "any",
    "bool",
    "byte",
    "complex64",
    "complex128",
    "error",
    "float32",
    "float64",
    "int",
    "int8",
    "int16",
    "int32",
    "int64",
    "make",
    "new",
    "rune",
    "string",
    "uint",
    "uint8",
    "uint16",
    "uint32",
    "uint64",
    "uintptr"
  ]),
  [generators_yml_exports.GenerationLanguage.RUBY]: /* @__PURE__ */ new Set([
    // https://docs.ruby-lang.org/en/2.2.0/keywords_rdoc.html
    "__ENCODING__",
    "__LINE__",
    "__FILE__",
    "alias",
    "and",
    "begin",
    "break",
    "case",
    "class",
    "def",
    "defined",
    "do",
    "else",
    "elsif",
    "end",
    "ensure",
    "false",
    "for",
    "if",
    "in",
    "module",
    "next",
    "nil",
    "not",
    "or",
    "redo",
    "rescue",
    "retry",
    "return",
    "self",
    "super",
    "then",
    "true",
    "undef",
    "unless",
    "until",
    "when",
    "while",
    "yield",
    "Object",
    "JSON",
    "Date",
    "DateTime"
  ]),
  [generators_yml_exports.GenerationLanguage.CSHARP]: /* @__PURE__ */ new Set([
    "abstract",
    "as",
    "base",
    "bool",
    "break",
    "byte",
    "case",
    "catch",
    "char",
    "checked",
    "class",
    "const",
    "continue",
    "decimal",
    "default",
    "delegate",
    "do",
    "double",
    "else",
    "enum",
    "event",
    "explicit",
    "extern",
    "false",
    "finally",
    "fixed",
    "float",
    "for",
    "foreach",
    "goto",
    "if",
    "implicit",
    "in",
    "int",
    "interface",
    "internal",
    "is",
    "lock",
    "long",
    "namespace",
    "new",
    "null",
    "object",
    "operator",
    "out",
    "override",
    "params",
    "private",
    "protected",
    "public",
    "readonly",
    "ref",
    "return",
    "sbyte",
    "sealed",
    "short",
    "sizeof",
    "stackalloc",
    "static",
    "string",
    "struct",
    "switch",
    "this",
    "throw",
    "true",
    "try",
    "typeof",
    "uint",
    "ulong",
    "unchecked",
    "unsafe",
    "ushort",
    "using",
    "virtual",
    "void",
    "volatile",
    "while",
    "add",
    "and",
    "alias",
    "ascending",
    "args",
    "async",
    "await",
    "by",
    "descending",
    "dynamic",
    "equals",
    "file",
    "from",
    "get",
    "global",
    "group",
    "init",
    "into",
    "join",
    "let",
    "managed",
    "nameof",
    "nint",
    "not",
    "notnull",
    "nuint",
    "on",
    "or",
    "orderby",
    "partial",
    "record",
    "remove",
    "required",
    "scoped",
    "select",
    "set",
    "unmanaged",
    "value",
    "var",
    "when",
    "where",
    "with",
    "yield"
  ]),
  // TODO(mikemilla): add reserved keywords for Swift
  [generators_yml_exports.GenerationLanguage.SWIFT]: /* @__PURE__ */ new Set([])
};

// ../../cli/generation/ir-generator/lib/casings/CasingsGenerator.js
var CAPITALIZE_INITIALISM = ["go", "ruby"];
function constructCasingsGenerator({ generationLanguage, keywords, smartCasing }) {
  const casingsGenerator = {
    generateName: (name, opts) => {
      const generateSafeAndUnsafeString = (unsafeString) => ({
        unsafeName: unsafeString,
        safeName: sanitizeName({
          name: unsafeString,
          keywords: getKeywords({ generationLanguage, keywords })
        })
      });
      let camelCaseName = camelCase_default(name);
      let pascalCaseName = upperFirst_default(camelCaseName);
      let snakeCaseName = snakeCase_default(name);
      const camelCaseWords = words_default(camelCaseName);
      if (smartCasing) {
        if (!hasAdjacentCommonInitialisms(camelCaseWords) && (generationLanguage == null || CAPITALIZE_INITIALISM.includes(generationLanguage))) {
          camelCaseName = camelCaseWords.map((word, index) => {
            if (index > 0) {
              const pluralInitialism = maybeGetPluralInitialism(word);
              if (pluralInitialism != null) {
                return pluralInitialism;
              }
              if (isCommonInitialism(word)) {
                return word.toUpperCase();
              }
            }
            return word;
          }).join("");
          pascalCaseName = camelCaseWords.map((word, index) => {
            const pluralInitialism = maybeGetPluralInitialism(word);
            if (pluralInitialism != null) {
              return pluralInitialism;
            }
            if (isCommonInitialism(word)) {
              return word.toUpperCase();
            }
            if (index === 0) {
              return upperFirst_default(word);
            }
            return word;
          }).join("");
        }
        snakeCaseName = name.split(" ").map((part) => part.split(/(\d+)/).map(snakeCase_default).join("")).join("_");
      }
      return {
        originalName: name,
        camelCase: generateSafeAndUnsafeString(opts?.casingOverrides?.camel ?? camelCaseName),
        snakeCase: generateSafeAndUnsafeString(opts?.casingOverrides?.snake ?? snakeCaseName),
        screamingSnakeCase: generateSafeAndUnsafeString(opts?.casingOverrides?.["screaming-snake"] ?? snakeCaseName.toUpperCase()),
        pascalCase: generateSafeAndUnsafeString(opts?.casingOverrides?.pascal ?? pascalCaseName)
      };
    },
    generateNameAndWireValue: ({ name, wireValue, opts }) => ({
      name: casingsGenerator.generateName(name, opts),
      wireValue
    })
  };
  return casingsGenerator;
}
function sanitizeName({ name, keywords }) {
  if (keywords == null) {
    return name;
  }
  if (keywords.has(name)) {
    return name + "_";
  } else if (startsWithNumber(name)) {
    return "_" + name;
  } else {
    return name;
  }
}
function getKeywords({ generationLanguage, keywords }) {
  if (keywords != null) {
    return new Set(keywords);
  }
  if (generationLanguage != null) {
    return RESERVED_KEYWORDS[generationLanguage];
  }
  return void 0;
}
var STARTS_WITH_NUMBER = /^[0-9]/;
function startsWithNumber(str2) {
  return STARTS_WITH_NUMBER.test(str2);
}
function hasAdjacentCommonInitialisms(wordList) {
  return wordList.some((word, index) => {
    if (index === 0) {
      return false;
    }
    const previousWord = wordList[index - 1];
    if (previousWord == null) {
      return false;
    }
    const previousWordIsInitialism = maybeGetPluralInitialism(previousWord) != null || isCommonInitialism(previousWord);
    const currentWordIsInitialism = maybeGetPluralInitialism(word) != null || isCommonInitialism(word);
    return previousWordIsInitialism && currentWordIsInitialism;
  });
}
function maybeGetPluralInitialism(name) {
  return PLURAL_COMMON_ITIALISMS.get(name.toUpperCase());
}
function isCommonInitialism(name) {
  return COMMON_ITIALISMS.has(name.toUpperCase());
}
var COMMON_ITIALISMS = /* @__PURE__ */ new Set([
  "ACL",
  "API",
  "ASCII",
  "CPU",
  "CSS",
  "DNS",
  "EOF",
  "GUID",
  "HTML",
  "HTTP",
  "HTTPS",
  "ID",
  "IP",
  "JSON",
  "LHS",
  "QPS",
  "RAM",
  "RHS",
  "RPC",
  "SAML",
  "SCIM",
  "SLA",
  "SMTP",
  "SQL",
  "SSH",
  "SSO",
  "TCP",
  "TLS",
  "TTL",
  "UDP",
  "UI",
  "UID",
  "UUID",
  "URI",
  "URL",
  "UTF8",
  "VM",
  "XML",
  "XMPP",
  "XSRF",
  "XSS"
]);
var PLURAL_COMMON_ITIALISMS = /* @__PURE__ */ new Map([
  ["ACLS", "ACLs"],
  ["APIS", "APIs"],
  ["CPUS", "CPUs"],
  ["GUIDS", "GUIDs"],
  ["IDS", "IDs"],
  ["UIDS", "UIDs"],
  ["UUIDS", "UUIDs"],
  ["URIS", "URIs"],
  ["URLS", "URLs"]
]);

// ../../cli/generation/ir-generator/lib/converters/services/constructHttpPath.js
function constructHttpPath(rawPath) {
  const rawPathGenerator = createStringGenerator(rawPath);
  const { value: head, done } = readUntil(rawPathGenerator, "{");
  if (done) {
    return { head, parts: [] };
  } else {
    return {
      head,
      parts: [...getAllParts(rawPathGenerator)]
    };
  }
}
function* getAllParts(rawPathGenerator) {
  let done;
  do {
    const { value: pathParameter } = readUntil(rawPathGenerator, "}");
    const untilNextOpeningBrace = readUntil(rawPathGenerator, "{");
    done = untilNextOpeningBrace.done;
    yield {
      pathParameter,
      tail: untilNextOpeningBrace.value
    };
  } while (!done);
}
function* createStringGenerator(str2) {
  for (const char of str2) {
    yield char;
  }
}
function readUntil(generator, delimiter) {
  let value = "";
  let nextResult = generator.next();
  while (nextResult.done !== true && nextResult.value !== delimiter) {
    value += nextResult.value;
    nextResult = generator.next();
  }
  return {
    value,
    done: nextResult.done ?? false
  };
}

// ../../cli/generation/ir-generator/lib/IdGenerator.js
var IdGenerator = {
  generateTypeId: (typeName) => {
    const joinedFernFilePath = stringifyFernFilepath(typeName.fernFilepath);
    return `type_${joinedFernFilePath}:${typeName.name.originalName}`;
  },
  generateErrorId: (errorName) => {
    const joinedFernFilePath = stringifyFernFilepath(errorName.fernFilepath);
    return `error_${joinedFernFilePath}:${errorName.name.originalName}`;
  },
  generateServiceId: (serviceName) => {
    const joinedFernFilePath = stringifyFernFilepath(serviceName.fernFilepath);
    return `service_${joinedFernFilePath}`;
  },
  generateServiceIdFromFernFilepath: (fernFilepath) => {
    const joinedFernFilePath = stringifyFernFilepath(fernFilepath);
    return `service_${joinedFernFilePath}`;
  },
  generateSubpackageId: (fernFilepath) => {
    const joinedFernFilePath = stringifyFernFilepath(fernFilepath);
    return `subpackage_${joinedFernFilePath}`;
  },
  generateEndpointId: (declaredServiceName, httpEndpoint) => {
    const joinedFernFilePath = stringifyFernFilepath(declaredServiceName.fernFilepath);
    const endpointId = httpEndpoint.name.originalName;
    return `endpoint_${joinedFernFilePath}.${endpointId}`;
  },
  generateEndpointIdFromResolvedEndpoint: (resolvedEndpoint) => {
    const joinedFernFilePath = stringifyFernFilepath(resolvedEndpoint.file.fernFilepath);
    const endpointId = resolvedEndpoint.endpointId;
    return `endpoint_${joinedFernFilePath}.${endpointId}`;
  },
  generateWebhookGroupId: (fernFilepath) => {
    const joinedFernFilePath = stringifyFernFilepath(fernFilepath);
    return `webhooks_${joinedFernFilePath}`;
  },
  generateWebhookId: (fernFilepath, webhookId) => {
    const joinedFernFilePath = stringifyFernFilepath(fernFilepath);
    return `webhooks_${joinedFernFilePath}.${webhookId}`;
  },
  generateWebSocketChannelId: (fernFilepath) => {
    const joinedFernFilePath = stringifyFernFilepath(fernFilepath);
    return `channel_${joinedFernFilePath}`;
  }
};
function stringifyFernFilepath(fernFilepath) {
  return fernFilepath.allParts.map((part) => part.originalName).join("/");
}

// ../../commons/path-utils/lib/isBrowser.js
function isBrowser() {
  return typeof window !== "undefined";
}

// ../../commons/path-utils/lib/getPathModule.js
function getPathModule() {
  if (isBrowser()) {
    return {
      isAbsolute: (value) => {
        return value.startsWith("/");
      }
    };
  } else {
    return require("path");
  }
}

// ../../commons/path-utils/lib/convertToOsPath.js
function convertToOsPath(path5) {
  if (isBrowser()) {
    return path5.replace(/\\/g, "/");
  }
  if (process.platform === "win32") {
    return path5.replace(/\//g, "\\");
  } else {
    return path5.replace(/\\/g, "/");
  }
}

// ../../commons/path-utils/lib/AbsoluteFilePath.js
var path = getPathModule();
var AbsoluteFilePath = {
  of: (value) => {
    if (!path.isAbsolute(value)) {
      throw new Error("Filepath is not absolute: " + value);
    }
    return convertToOsPath(value);
  }
};

// ../../commons/path-utils/lib/RelativeFilePath.js
var path2 = getPathModule();
var RelativeFilePath = {
  of: (value) => {
    if (path2.isAbsolute(value)) {
      throw new Error("Filepath is not relative: " + value);
    }
    return convertToOsPath(value);
  }
};

// ../../commons/path-utils/lib/basename.js
function basename(path5, options) {
  const basename3 = path5.split("/").pop() ?? path5;
  if (options?.stripExtension) {
    return basename3.split(".")[0] ?? basename3;
  }
  return basename3;
}

// ../../commons/path-utils/lib/dirname.js
function dirname(filepath) {
  const trimmed = filepath.replace(/\/+$/, "");
  const lastSlashIndex = trimmed.lastIndexOf("/");
  if (lastSlashIndex === -1) {
    return ".";
  }
  if (lastSlashIndex === 0) {
    return "/";
  }
  return filepath.slice(0, lastSlashIndex);
}

// ../../commons/path-utils/lib/join.js
function join(...parts) {
  const stack = [];
  for (const part of parts.flatMap((segment) => segment.split("/")).filter(Boolean)) {
    if (part === "." || part === "") {
      continue;
    }
    if (part === "..") {
      if (stack.length > 0 && stack[stack.length - 1] !== "..") {
        stack.pop();
      } else {
        stack.push(part);
      }
    } else {
      stack.push(part);
    }
  }
  return (parts[0]?.startsWith("/") ? "/" : "") + stack.join("/");
}

// ../../commons/path-utils/lib/sep.js
var sep = "/";

// ../../commons/path-utils/lib/relative.js
function relative(from, to) {
  const fromParts = from.split(sep).filter(Boolean);
  const toParts = to.split(sep).filter(Boolean);
  let i = 0;
  while (i < fromParts.length && i < toParts.length && fromParts[i] === toParts[i]) {
    i++;
  }
  const upLevels = fromParts.length - i;
  const result = [
    ...Array(upLevels).fill(".."),
    ...toParts.slice(i)
    // Add the remaining path parts from `to`
  ];
  return result.join(sep) || ".";
}

// ../../cli/generation/ir-generator/lib/utils/convertToFernFilepath.js
function convertToFernFilepath({ relativeFilepath, casingsGenerator }) {
  const pathToPackage = dirname(relativeFilepath);
  const filename = basename(relativeFilepath, { stripExtension: true });
  const packagePath = pathToPackage === "." ? [] : pathToPackage.split(sep).map((part) => casingsGenerator.generateName(part));
  const file = filename !== FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION ? casingsGenerator.generateName(filename) : void 0;
  const allParts = [];
  allParts.push(...packagePath);
  if (file != null) {
    allParts.push(file);
  }
  return {
    allParts,
    packagePath,
    file
  };
}

// ../../cli/generation/ir-generator/lib/utils/getResolvedPathOfImportedFile.js
function getResolvedPathOfImportedFile({ referencedIn, importPath }) {
  return join(dirname(referencedIn), importPath);
}

// ../../cli/generation/ir-generator/lib/utils/parseReferenceToTypeName.js
function parseReferenceToTypeName({ reference, referencedIn, imports }) {
  const [firstPart, secondPart, ...rest] = reference.split(".");
  if (firstPart == null || rest.length > 0) {
    return void 0;
  }
  if (secondPart == null) {
    return {
      typeName: firstPart,
      relativeFilepath: referencedIn
    };
  }
  const importAlias = firstPart;
  const importPath = imports[importAlias];
  if (importPath == null) {
    return void 0;
  }
  return {
    relativeFilepath: getResolvedPathOfImportedFile({ referencedIn, importPath }),
    typeName: secondPart
  };
}

// ../../cli/generation/ir-generator/lib/utils/parseErrorName.js
function parseErrorName({ errorName, file }) {
  const reference = parseReferenceToTypeName({
    reference: errorName,
    referencedIn: file.relativeFilepath,
    imports: file.imports
  });
  if (reference == null) {
    throw new Error("Failed to locate error " + errorName);
  }
  const nameWithoutId = {
    name: file.casingsGenerator.generateName(reference.typeName),
    fernFilepath: convertToFernFilepath({
      relativeFilepath: reference.relativeFilepath,
      casingsGenerator: file.casingsGenerator
    })
  };
  return {
    ...nameWithoutId,
    errorId: IdGenerator.generateErrorId(nameWithoutId)
  };
}

// ../../cli/generation/ir-generator/lib/converters/services/convertResponseErrors.js
function convertResponseErrors({ errors, file }) {
  return errors == null ? [] : Object.values(errors).map((errorReference) => {
    const referenceToError = typeof errorReference === "string" ? errorReference : errorReference.error;
    const errorName = parseErrorName({
      errorName: referenceToError,
      file
    });
    return {
      docs: typeof errorReference !== "string" ? errorReference.docs : void 0,
      error: errorName
    };
  });
}

// ../../ir-sdk/lib/sdk/api/resources/auth/types/AuthSchemesRequirement.js
var AuthSchemesRequirement = {
  All: "ALL",
  Any: "ANY",
  _visit: (value, visitor) => {
    switch (value) {
      case AuthSchemesRequirement.All:
        return visitor.all();
      case AuthSchemesRequirement.Any:
        return visitor.any();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/auth/types/AuthScheme.js
var AuthScheme = {
  bearer: (value) => {
    return {
      ...value,
      type: "bearer",
      _visit: function(visitor) {
        return AuthScheme._visit(this, visitor);
      }
    };
  },
  basic: (value) => {
    return {
      ...value,
      type: "basic",
      _visit: function(visitor) {
        return AuthScheme._visit(this, visitor);
      }
    };
  },
  header: (value) => {
    return {
      ...value,
      type: "header",
      _visit: function(visitor) {
        return AuthScheme._visit(this, visitor);
      }
    };
  },
  oauth: (value) => {
    return {
      ...value,
      type: "oauth",
      _visit: function(visitor) {
        return AuthScheme._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "bearer":
        return visitor.bearer(value);
      case "basic":
        return visitor.basic(value);
      case "header":
        return visitor.header(value);
      case "oauth":
        return visitor.oauth(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/auth/types/OAuthConfiguration.js
var OAuthConfiguration = {
  clientCredentials: (value) => {
    return {
      ...value,
      type: "clientCredentials",
      _visit: function(visitor) {
        return OAuthConfiguration._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "clientCredentials":
        return visitor.clientCredentials(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/commons/types/AvailabilityStatus.js
var AvailabilityStatus = {
  InDevelopment: "IN_DEVELOPMENT",
  PreRelease: "PRE_RELEASE",
  GeneralAvailability: "GENERAL_AVAILABILITY",
  Deprecated: "DEPRECATED",
  _visit: (value, visitor) => {
    switch (value) {
      case AvailabilityStatus.InDevelopment:
        return visitor.inDevelopment();
      case AvailabilityStatus.PreRelease:
        return visitor.preRelease();
      case AvailabilityStatus.GeneralAvailability:
        return visitor.generalAvailability();
      case AvailabilityStatus.Deprecated:
        return visitor.deprecated();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/index.js
var dynamic_exports = {};
__export(dynamic_exports, {
  Auth: () => Auth,
  AuthValues: () => AuthValues,
  ErrorSeverity: () => ErrorSeverity,
  FileUploadRequestBodyProperty: () => FileUploadRequestBodyProperty,
  InlinedRequestBody: () => InlinedRequestBody,
  LiteralType: () => LiteralType,
  NamedType: () => NamedType,
  ReferencedRequestBodyType: () => ReferencedRequestBodyType,
  Request: () => Request,
  Response: () => Response,
  SingleDiscriminatedUnionType: () => SingleDiscriminatedUnionType,
  TypeReference: () => TypeReference,
  auth: () => auth_exports3,
  declaration: () => declaration_exports,
  endpoints: () => endpoints_exports,
  ir: () => ir_exports,
  snippets: () => snippets_exports,
  types: () => types_exports3
});

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/auth/index.js
var auth_exports3 = {};
__export(auth_exports3, {
  Auth: () => Auth,
  AuthValues: () => AuthValues
});

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/auth/types/Auth.js
var Auth = {
  basic: (value) => {
    return {
      ...value,
      type: "basic",
      _visit: function(visitor) {
        return dynamic_exports.Auth._visit(this, visitor);
      }
    };
  },
  bearer: (value) => {
    return {
      ...value,
      type: "bearer",
      _visit: function(visitor) {
        return dynamic_exports.Auth._visit(this, visitor);
      }
    };
  },
  header: (value) => {
    return {
      ...value,
      type: "header",
      _visit: function(visitor) {
        return dynamic_exports.Auth._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "basic":
        return visitor.basic(value);
      case "bearer":
        return visitor.bearer(value);
      case "header":
        return visitor.header(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/auth/types/AuthValues.js
var AuthValues = {
  basic: (value) => {
    return {
      ...value,
      type: "basic",
      _visit: function(visitor) {
        return dynamic_exports.AuthValues._visit(this, visitor);
      }
    };
  },
  bearer: (value) => {
    return {
      ...value,
      type: "bearer",
      _visit: function(visitor) {
        return dynamic_exports.AuthValues._visit(this, visitor);
      }
    };
  },
  header: (value) => {
    return {
      ...value,
      type: "header",
      _visit: function(visitor) {
        return dynamic_exports.AuthValues._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "basic":
        return visitor.basic(value);
      case "bearer":
        return visitor.bearer(value);
      case "header":
        return visitor.header(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/declaration/index.js
var declaration_exports = {};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/index.js
var endpoints_exports = {};
__export(endpoints_exports, {
  FileUploadRequestBodyProperty: () => FileUploadRequestBodyProperty,
  InlinedRequestBody: () => InlinedRequestBody,
  ReferencedRequestBodyType: () => ReferencedRequestBodyType,
  Request: () => Request,
  Response: () => Response
});

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/types/Request.js
var Request = {
  body: (value) => {
    return {
      ...value,
      type: "body",
      _visit: function(visitor) {
        return dynamic_exports.Request._visit(this, visitor);
      }
    };
  },
  inlined: (value) => {
    return {
      ...value,
      type: "inlined",
      _visit: function(visitor) {
        return dynamic_exports.Request._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "body":
        return visitor.body(value);
      case "inlined":
        return visitor.inlined(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/types/Response.js
var Response = {
  json: () => {
    return {
      type: "json",
      _visit: function(visitor) {
        return dynamic_exports.Response._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "json":
        return visitor.json();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/types/InlinedRequestBody.js
var InlinedRequestBody = {
  properties: (value) => {
    return {
      value,
      type: "properties",
      _visit: function(visitor) {
        return dynamic_exports.InlinedRequestBody._visit(this, visitor);
      }
    };
  },
  referenced: (value) => {
    return {
      ...value,
      type: "referenced",
      _visit: function(visitor) {
        return dynamic_exports.InlinedRequestBody._visit(this, visitor);
      }
    };
  },
  fileUpload: (value) => {
    return {
      ...value,
      type: "fileUpload",
      _visit: function(visitor) {
        return dynamic_exports.InlinedRequestBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "properties":
        return visitor.properties(value.value);
      case "referenced":
        return visitor.referenced(value);
      case "fileUpload":
        return visitor.fileUpload(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/types/ReferencedRequestBodyType.js
var ReferencedRequestBodyType = {
  bytes: () => {
    return {
      type: "bytes",
      _visit: function(visitor) {
        return dynamic_exports.ReferencedRequestBodyType._visit(this, visitor);
      }
    };
  },
  typeReference: (value) => {
    return {
      value,
      type: "typeReference",
      _visit: function(visitor) {
        return dynamic_exports.ReferencedRequestBodyType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "bytes":
        return visitor.bytes();
      case "typeReference":
        return visitor.typeReference(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/types/FileUploadRequestBodyProperty.js
var FileUploadRequestBodyProperty = {
  file: (value) => {
    return {
      ...value,
      type: "file",
      _visit: function(visitor) {
        return dynamic_exports.FileUploadRequestBodyProperty._visit(this, visitor);
      }
    };
  },
  fileArray: (value) => {
    return {
      ...value,
      type: "fileArray",
      _visit: function(visitor) {
        return dynamic_exports.FileUploadRequestBodyProperty._visit(this, visitor);
      }
    };
  },
  bodyProperty: (value) => {
    return {
      ...value,
      type: "bodyProperty",
      _visit: function(visitor) {
        return dynamic_exports.FileUploadRequestBodyProperty._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "file":
        return visitor.file(value);
      case "fileArray":
        return visitor.fileArray(value);
      case "bodyProperty":
        return visitor.bodyProperty(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/ir/index.js
var ir_exports = {};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/snippets/index.js
var snippets_exports = {};
__export(snippets_exports, {
  ErrorSeverity: () => ErrorSeverity
});

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/snippets/types/ErrorSeverity.js
var ErrorSeverity = {
  Critical: "CRITICAL",
  Warning: "WARNING",
  _visit: (value, visitor) => {
    switch (value) {
      case ErrorSeverity.Critical:
        return visitor.critical();
      case ErrorSeverity.Warning:
        return visitor.warning();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/types/index.js
var types_exports3 = {};
__export(types_exports3, {
  LiteralType: () => LiteralType,
  NamedType: () => NamedType,
  SingleDiscriminatedUnionType: () => SingleDiscriminatedUnionType,
  TypeReference: () => TypeReference
});

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/types/types/NamedType.js
var NamedType = {
  alias: (value) => {
    return {
      ...value,
      type: "alias",
      _visit: function(visitor) {
        return dynamic_exports.NamedType._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      ...value,
      type: "enum",
      _visit: function(visitor) {
        return dynamic_exports.NamedType._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function(visitor) {
        return dynamic_exports.NamedType._visit(this, visitor);
      }
    };
  },
  discriminatedUnion: (value) => {
    return {
      ...value,
      type: "discriminatedUnion",
      _visit: function(visitor) {
        return dynamic_exports.NamedType._visit(this, visitor);
      }
    };
  },
  undiscriminatedUnion: (value) => {
    return {
      ...value,
      type: "undiscriminatedUnion",
      _visit: function(visitor) {
        return dynamic_exports.NamedType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "alias":
        return visitor.alias(value);
      case "enum":
        return visitor.enum(value);
      case "object":
        return visitor.object(value);
      case "discriminatedUnion":
        return visitor.discriminatedUnion(value);
      case "undiscriminatedUnion":
        return visitor.undiscriminatedUnion(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/types/types/TypeReference.js
var TypeReference = {
  list: (value) => {
    return {
      value,
      type: "list",
      _visit: function(visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      value,
      type: "literal",
      _visit: function(visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      ...value,
      type: "map",
      _visit: function(visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  named: (value) => {
    return {
      value,
      type: "named",
      _visit: function(visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  optional: (value) => {
    return {
      value,
      type: "optional",
      _visit: function(visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  primitive: (value) => {
    return {
      value,
      type: "primitive",
      _visit: function(visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  set: (value) => {
    return {
      value,
      type: "set",
      _visit: function(visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  unknown: () => {
    return {
      type: "unknown",
      _visit: function(visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "list":
        return visitor.list(value.value);
      case "literal":
        return visitor.literal(value.value);
      case "map":
        return visitor.map(value);
      case "named":
        return visitor.named(value.value);
      case "optional":
        return visitor.optional(value.value);
      case "primitive":
        return visitor.primitive(value.value);
      case "set":
        return visitor.set(value.value);
      case "unknown":
        return visitor.unknown();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/types/types/SingleDiscriminatedUnionType.js
var SingleDiscriminatedUnionType = {
  samePropertiesAsObject: (value) => {
    return {
      ...value,
      type: "samePropertiesAsObject",
      _visit: function(visitor) {
        return dynamic_exports.SingleDiscriminatedUnionType._visit(this, visitor);
      }
    };
  },
  singleProperty: (value) => {
    return {
      ...value,
      type: "singleProperty",
      _visit: function(visitor) {
        return dynamic_exports.SingleDiscriminatedUnionType._visit(this, visitor);
      }
    };
  },
  noProperties: (value) => {
    return {
      ...value,
      type: "noProperties",
      _visit: function(visitor) {
        return dynamic_exports.SingleDiscriminatedUnionType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "samePropertiesAsObject":
        return visitor.samePropertiesAsObject(value);
      case "singleProperty":
        return visitor.singleProperty(value);
      case "noProperties":
        return visitor.noProperties(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/types/types/LiteralType.js
var LiteralType = {
  boolean: (value) => {
    return {
      value,
      type: "boolean",
      _visit: function(visitor) {
        return dynamic_exports.LiteralType._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      value,
      type: "string",
      _visit: function(visitor) {
        return dynamic_exports.LiteralType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "boolean":
        return visitor.boolean(value.value);
      case "string":
        return visitor.string(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/environment/types/Environments.js
var Environments = {
  singleBaseUrl: (value) => {
    return {
      ...value,
      type: "singleBaseUrl",
      _visit: function(visitor) {
        return Environments._visit(this, visitor);
      }
    };
  },
  multipleBaseUrls: (value) => {
    return {
      ...value,
      type: "multipleBaseUrls",
      _visit: function(visitor) {
        return Environments._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "singleBaseUrl":
        return visitor.singleBaseUrl(value);
      case "multipleBaseUrls":
        return visitor.multipleBaseUrls(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/Transport.js
var Transport = {
  http: () => {
    return {
      type: "http",
      _visit: function(visitor) {
        return Transport._visit(this, visitor);
      }
    };
  },
  grpc: (value) => {
    return {
      ...value,
      type: "grpc",
      _visit: function(visitor) {
        return Transport._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "http":
        return visitor.http();
      case "grpc":
        return visitor.grpc(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/HttpMethod.js
var HttpMethod = {
  Get: "GET",
  Post: "POST",
  Put: "PUT",
  Patch: "PATCH",
  Delete: "DELETE",
  _visit: (value, visitor) => {
    switch (value) {
      case HttpMethod.Get:
        return visitor.get();
      case HttpMethod.Post:
        return visitor.post();
      case HttpMethod.Put:
        return visitor.put();
      case HttpMethod.Patch:
        return visitor.patch();
      case HttpMethod.Delete:
        return visitor.delete();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/PathParameterLocation.js
var PathParameterLocation = {
  Root: "ROOT",
  Service: "SERVICE",
  Endpoint: "ENDPOINT",
  _visit: (value, visitor) => {
    switch (value) {
      case PathParameterLocation.Root:
        return visitor.root();
      case PathParameterLocation.Service:
        return visitor.service();
      case PathParameterLocation.Endpoint:
        return visitor.endpoint();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/HttpRequestBody.js
var HttpRequestBody = {
  inlinedRequestBody: (value) => {
    return {
      ...value,
      type: "inlinedRequestBody",
      _visit: function(visitor) {
        return HttpRequestBody._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function(visitor) {
        return HttpRequestBody._visit(this, visitor);
      }
    };
  },
  fileUpload: (value) => {
    return {
      ...value,
      type: "fileUpload",
      _visit: function(visitor) {
        return HttpRequestBody._visit(this, visitor);
      }
    };
  },
  bytes: (value) => {
    return {
      ...value,
      type: "bytes",
      _visit: function(visitor) {
        return HttpRequestBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "inlinedRequestBody":
        return visitor.inlinedRequestBody(value);
      case "reference":
        return visitor.reference(value);
      case "fileUpload":
        return visitor.fileUpload(value);
      case "bytes":
        return visitor.bytes(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/FileUploadRequestProperty.js
var FileUploadRequestProperty = {
  file: (value) => {
    return {
      value,
      type: "file",
      _visit: function(visitor) {
        return FileUploadRequestProperty._visit(this, visitor);
      }
    };
  },
  bodyProperty: (value) => {
    return {
      ...value,
      type: "bodyProperty",
      _visit: function(visitor) {
        return FileUploadRequestProperty._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "file":
        return visitor.file(value.value);
      case "bodyProperty":
        return visitor.bodyProperty(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/FileProperty.js
var FileProperty = {
  file: (value) => {
    return {
      ...value,
      type: "file",
      _visit: function(visitor) {
        return FileProperty._visit(this, visitor);
      }
    };
  },
  fileArray: (value) => {
    return {
      ...value,
      type: "fileArray",
      _visit: function(visitor) {
        return FileProperty._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "file":
        return visitor.file(value);
      case "fileArray":
        return visitor.fileArray(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/SdkRequestBodyType.js
var SdkRequestBodyType = {
  typeReference: (value) => {
    return {
      ...value,
      type: "typeReference",
      _visit: function(visitor) {
        return SdkRequestBodyType._visit(this, visitor);
      }
    };
  },
  bytes: (value) => {
    return {
      ...value,
      type: "bytes",
      _visit: function(visitor) {
        return SdkRequestBodyType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "typeReference":
        return visitor.typeReference(value);
      case "bytes":
        return visitor.bytes(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/SdkRequestShape.js
var SdkRequestShape = {
  justRequestBody: (value) => {
    return {
      value,
      type: "justRequestBody",
      _visit: function(visitor) {
        return SdkRequestShape._visit(this, visitor);
      }
    };
  },
  wrapper: (value) => {
    return {
      ...value,
      type: "wrapper",
      _visit: function(visitor) {
        return SdkRequestShape._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "justRequestBody":
        return visitor.justRequestBody(value.value);
      case "wrapper":
        return visitor.wrapper(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/NonStreamHttpResponseBody.js
var NonStreamHttpResponseBody = {
  json: (value) => {
    return {
      value,
      type: "json",
      _visit: function(visitor) {
        return NonStreamHttpResponseBody._visit(this, visitor);
      }
    };
  },
  fileDownload: (value) => {
    return {
      ...value,
      type: "fileDownload",
      _visit: function(visitor) {
        return NonStreamHttpResponseBody._visit(this, visitor);
      }
    };
  },
  text: (value) => {
    return {
      ...value,
      type: "text",
      _visit: function(visitor) {
        return NonStreamHttpResponseBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "json":
        return visitor.json(value.value);
      case "fileDownload":
        return visitor.fileDownload(value);
      case "text":
        return visitor.text(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/HttpResponseBody.js
var HttpResponseBody = {
  json: (value) => {
    return {
      value,
      type: "json",
      _visit: function(visitor) {
        return HttpResponseBody._visit(this, visitor);
      }
    };
  },
  fileDownload: (value) => {
    return {
      ...value,
      type: "fileDownload",
      _visit: function(visitor) {
        return HttpResponseBody._visit(this, visitor);
      }
    };
  },
  text: (value) => {
    return {
      ...value,
      type: "text",
      _visit: function(visitor) {
        return HttpResponseBody._visit(this, visitor);
      }
    };
  },
  streaming: (value) => {
    return {
      value,
      type: "streaming",
      _visit: function(visitor) {
        return HttpResponseBody._visit(this, visitor);
      }
    };
  },
  streamParameter: (value) => {
    return {
      ...value,
      type: "streamParameter",
      _visit: function(visitor) {
        return HttpResponseBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "json":
        return visitor.json(value.value);
      case "fileDownload":
        return visitor.fileDownload(value);
      case "text":
        return visitor.text(value);
      case "streaming":
        return visitor.streaming(value.value);
      case "streamParameter":
        return visitor.streamParameter(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/JsonResponse.js
var JsonResponse = {
  response: (value) => {
    return {
      ...value,
      type: "response",
      _visit: function(visitor) {
        return JsonResponse._visit(this, visitor);
      }
    };
  },
  nestedPropertyAsResponse: (value) => {
    return {
      ...value,
      type: "nestedPropertyAsResponse",
      _visit: function(visitor) {
        return JsonResponse._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "response":
        return visitor.response(value);
      case "nestedPropertyAsResponse":
        return visitor.nestedPropertyAsResponse(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/StreamingResponse.js
var StreamingResponse = {
  json: (value) => {
    return {
      ...value,
      type: "json",
      _visit: function(visitor) {
        return StreamingResponse._visit(this, visitor);
      }
    };
  },
  text: (value) => {
    return {
      ...value,
      type: "text",
      _visit: function(visitor) {
        return StreamingResponse._visit(this, visitor);
      }
    };
  },
  sse: (value) => {
    return {
      ...value,
      type: "sse",
      _visit: function(visitor) {
        return StreamingResponse._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "json":
        return visitor.json(value);
      case "text":
        return visitor.text(value);
      case "sse":
        return visitor.sse(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/Pagination.js
var Pagination = {
  cursor: (value) => {
    return {
      ...value,
      type: "cursor",
      _visit: function(visitor) {
        return Pagination._visit(this, visitor);
      }
    };
  },
  offset: (value) => {
    return {
      ...value,
      type: "offset",
      _visit: function(visitor) {
        return Pagination._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "cursor":
        return visitor.cursor(value);
      case "offset":
        return visitor.offset(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/RequestPropertyValue.js
var RequestPropertyValue = {
  query: (value) => {
    return {
      ...value,
      type: "query",
      _visit: function(visitor) {
        return RequestPropertyValue._visit(this, visitor);
      }
    };
  },
  body: (value) => {
    return {
      ...value,
      type: "body",
      _visit: function(visitor) {
        return RequestPropertyValue._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "query":
        return visitor.query(value);
      case "body":
        return visitor.body(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/ExampleCodeSample.js
var ExampleCodeSample = {
  language: (value) => {
    return {
      ...value,
      type: "language",
      _visit: function(visitor) {
        return ExampleCodeSample._visit(this, visitor);
      }
    };
  },
  sdk: (value) => {
    return {
      ...value,
      type: "sdk",
      _visit: function(visitor) {
        return ExampleCodeSample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "language":
        return visitor.language(value);
      case "sdk":
        return visitor.sdk(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/ExampleQueryParameterShape.js
var ExampleQueryParameterShape = {
  single: () => {
    return {
      type: "single",
      _visit: function(visitor) {
        return ExampleQueryParameterShape._visit(this, visitor);
      }
    };
  },
  exploded: () => {
    return {
      type: "exploded",
      _visit: function(visitor) {
        return ExampleQueryParameterShape._visit(this, visitor);
      }
    };
  },
  commaSeparated: () => {
    return {
      type: "commaSeparated",
      _visit: function(visitor) {
        return ExampleQueryParameterShape._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "single":
        return visitor.single();
      case "exploded":
        return visitor.exploded();
      case "commaSeparated":
        return visitor.commaSeparated();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/ExampleRequestBody.js
var ExampleRequestBody = {
  inlinedRequestBody: (value) => {
    return {
      ...value,
      type: "inlinedRequestBody",
      _visit: function(visitor) {
        return ExampleRequestBody._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function(visitor) {
        return ExampleRequestBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "inlinedRequestBody":
        return visitor.inlinedRequestBody(value);
      case "reference":
        return visitor.reference(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/ExampleResponse.js
var ExampleResponse = {
  ok: (value) => {
    return {
      value,
      type: "ok",
      _visit: function(visitor) {
        return ExampleResponse._visit(this, visitor);
      }
    };
  },
  error: (value) => {
    return {
      ...value,
      type: "error",
      _visit: function(visitor) {
        return ExampleResponse._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "ok":
        return visitor.ok(value.value);
      case "error":
        return visitor.error(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/ExampleEndpointSuccessResponse.js
var ExampleEndpointSuccessResponse = {
  body: (value) => {
    return {
      value,
      type: "body",
      _visit: function(visitor) {
        return ExampleEndpointSuccessResponse._visit(this, visitor);
      }
    };
  },
  stream: (value) => {
    return {
      value,
      type: "stream",
      _visit: function(visitor) {
        return ExampleEndpointSuccessResponse._visit(this, visitor);
      }
    };
  },
  sse: (value) => {
    return {
      value,
      type: "sse",
      _visit: function(visitor) {
        return ExampleEndpointSuccessResponse._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "body":
        return visitor.body(value.value);
      case "stream":
        return visitor.stream(value.value);
      case "sse":
        return visitor.sse(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/ir/types/ApiVersionScheme.js
var ApiVersionScheme = {
  header: (value) => {
    return {
      ...value,
      type: "header",
      _visit: function(visitor) {
        return ApiVersionScheme._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "header":
        return visitor.header(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/ir/types/ErrorDiscriminationStrategy.js
var ErrorDiscriminationStrategy = {
  statusCode: () => {
    return {
      type: "statusCode",
      _visit: function(visitor) {
        return ErrorDiscriminationStrategy._visit(this, visitor);
      }
    };
  },
  property: (value) => {
    return {
      ...value,
      type: "property",
      _visit: function(visitor) {
        return ErrorDiscriminationStrategy._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "statusCode":
        return visitor.statusCode();
      case "property":
        return visitor.property(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/proto/types/ProtobufType.js
var ProtobufType = {
  wellKnown: (value) => {
    return {
      value,
      type: "wellKnown",
      _visit: function(visitor) {
        return ProtobufType._visit(this, visitor);
      }
    };
  },
  userDefined: (value) => {
    return {
      ...value,
      type: "userDefined",
      _visit: function(visitor) {
        return ProtobufType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "wellKnown":
        return visitor.wellKnown(value.value);
      case "userDefined":
        return visitor.userDefined(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/proto/types/WellKnownProtobufType.js
var WellKnownProtobufType = {
  any: () => {
    return {
      type: "any",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  api: () => {
    return {
      type: "api",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  boolValue: () => {
    return {
      type: "boolValue",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  bytesValue: () => {
    return {
      type: "bytesValue",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  doubleValue: () => {
    return {
      type: "doubleValue",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  duration: () => {
    return {
      type: "duration",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  empty: () => {
    return {
      type: "empty",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  enum: () => {
    return {
      type: "enum",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  enumValue: () => {
    return {
      type: "enumValue",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  field: () => {
    return {
      type: "field",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  fieldCardinality: () => {
    return {
      type: "fieldCardinality",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  fieldKind: () => {
    return {
      type: "fieldKind",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  fieldMask: () => {
    return {
      type: "fieldMask",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  floatValue: () => {
    return {
      type: "floatValue",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  int32Value: () => {
    return {
      type: "int32Value",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  int64Value: () => {
    return {
      type: "int64Value",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  listValue: () => {
    return {
      type: "listValue",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  method: () => {
    return {
      type: "method",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  mixin: () => {
    return {
      type: "mixin",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  nullValue: () => {
    return {
      type: "nullValue",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  option: () => {
    return {
      type: "option",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  sourceContext: () => {
    return {
      type: "sourceContext",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  stringValue: () => {
    return {
      type: "stringValue",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  struct: () => {
    return {
      type: "struct",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  syntax: () => {
    return {
      type: "syntax",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  timestamp: () => {
    return {
      type: "timestamp",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  type: () => {
    return {
      type: "type",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  uint32Value: () => {
    return {
      type: "uint32Value",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  uint64Value: () => {
    return {
      type: "uint64Value",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  value: () => {
    return {
      type: "value",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "any":
        return visitor.any();
      case "api":
        return visitor.api();
      case "boolValue":
        return visitor.boolValue();
      case "bytesValue":
        return visitor.bytesValue();
      case "doubleValue":
        return visitor.doubleValue();
      case "duration":
        return visitor.duration();
      case "empty":
        return visitor.empty();
      case "enum":
        return visitor.enum();
      case "enumValue":
        return visitor.enumValue();
      case "field":
        return visitor.field();
      case "fieldCardinality":
        return visitor.fieldCardinality();
      case "fieldKind":
        return visitor.fieldKind();
      case "fieldMask":
        return visitor.fieldMask();
      case "floatValue":
        return visitor.floatValue();
      case "int32Value":
        return visitor.int32Value();
      case "int64Value":
        return visitor.int64Value();
      case "listValue":
        return visitor.listValue();
      case "method":
        return visitor.method();
      case "mixin":
        return visitor.mixin();
      case "nullValue":
        return visitor.nullValue();
      case "option":
        return visitor.option();
      case "sourceContext":
        return visitor.sourceContext();
      case "stringValue":
        return visitor.stringValue();
      case "struct":
        return visitor.struct();
      case "syntax":
        return visitor.syntax();
      case "timestamp":
        return visitor.timestamp();
      case "type":
        return visitor.type();
      case "uint32Value":
        return visitor.uint32Value();
      case "uint64Value":
        return visitor.uint64Value();
      case "value":
        return visitor.value();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/Source.js
var Source = {
  proto: (value) => {
    return {
      value,
      type: "proto",
      _visit: function(visitor) {
        return Source._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "proto":
        return visitor.proto(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/Type.js
var Type = {
  alias: (value) => {
    return {
      ...value,
      type: "alias",
      _visit: function(visitor) {
        return Type._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      ...value,
      type: "enum",
      _visit: function(visitor) {
        return Type._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function(visitor) {
        return Type._visit(this, visitor);
      }
    };
  },
  union: (value) => {
    return {
      ...value,
      type: "union",
      _visit: function(visitor) {
        return Type._visit(this, visitor);
      }
    };
  },
  undiscriminatedUnion: (value) => {
    return {
      ...value,
      type: "undiscriminatedUnion",
      _visit: function(visitor) {
        return Type._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "alias":
        return visitor.alias(value);
      case "enum":
        return visitor.enum(value);
      case "object":
        return visitor.object(value);
      case "union":
        return visitor.union(value);
      case "undiscriminatedUnion":
        return visitor.undiscriminatedUnion(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ResolvedTypeReference.js
var ResolvedTypeReference = {
  container: (value) => {
    return {
      container: value,
      type: "container",
      _visit: function(visitor) {
        return ResolvedTypeReference._visit(this, visitor);
      }
    };
  },
  named: (value) => {
    return {
      ...value,
      type: "named",
      _visit: function(visitor) {
        return ResolvedTypeReference._visit(this, visitor);
      }
    };
  },
  primitive: (value) => {
    return {
      primitive: value,
      type: "primitive",
      _visit: function(visitor) {
        return ResolvedTypeReference._visit(this, visitor);
      }
    };
  },
  unknown: () => {
    return {
      type: "unknown",
      _visit: function(visitor) {
        return ResolvedTypeReference._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "container":
        return visitor.container(value.container);
      case "named":
        return visitor.named(value);
      case "primitive":
        return visitor.primitive(value.primitive);
      case "unknown":
        return visitor.unknown();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ShapeType.js
var ShapeType = {
  Enum: "ENUM",
  Object: "OBJECT",
  Union: "UNION",
  UndiscriminatedUnion: "UNDISCRIMINATED_UNION",
  _visit: (value, visitor) => {
    switch (value) {
      case ShapeType.Enum:
        return visitor.enum();
      case ShapeType.Object:
        return visitor.object();
      case ShapeType.Union:
        return visitor.union();
      case ShapeType.UndiscriminatedUnion:
        return visitor.undiscriminatedUnion();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/SingleUnionTypeProperties.js
var SingleUnionTypeProperties = {
  samePropertiesAsObject: (value) => {
    return {
      ...value,
      propertiesType: "samePropertiesAsObject",
      _visit: function(visitor) {
        return SingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  singleProperty: (value) => {
    return {
      ...value,
      propertiesType: "singleProperty",
      _visit: function(visitor) {
        return SingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  noProperties: () => {
    return {
      propertiesType: "noProperties",
      _visit: function(visitor) {
        return SingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.propertiesType) {
      case "samePropertiesAsObject":
        return visitor.samePropertiesAsObject(value);
      case "singleProperty":
        return visitor.singleProperty(value);
      case "noProperties":
        return visitor.noProperties();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/TypeReference.js
var TypeReference2 = {
  container: (value) => {
    return {
      container: value,
      type: "container",
      _visit: function(visitor) {
        return TypeReference2._visit(this, visitor);
      }
    };
  },
  named: (value) => {
    return {
      ...value,
      type: "named",
      _visit: function(visitor) {
        return TypeReference2._visit(this, visitor);
      }
    };
  },
  primitive: (value) => {
    return {
      primitive: value,
      type: "primitive",
      _visit: function(visitor) {
        return TypeReference2._visit(this, visitor);
      }
    };
  },
  unknown: () => {
    return {
      type: "unknown",
      _visit: function(visitor) {
        return TypeReference2._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "container":
        return visitor.container(value.container);
      case "named":
        return visitor.named(value);
      case "primitive":
        return visitor.primitive(value.primitive);
      case "unknown":
        return visitor.unknown();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ContainerType.js
var ContainerType = {
  list: (value) => {
    return {
      list: value,
      type: "list",
      _visit: function(visitor) {
        return ContainerType._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      ...value,
      type: "map",
      _visit: function(visitor) {
        return ContainerType._visit(this, visitor);
      }
    };
  },
  optional: (value) => {
    return {
      optional: value,
      type: "optional",
      _visit: function(visitor) {
        return ContainerType._visit(this, visitor);
      }
    };
  },
  set: (value) => {
    return {
      set: value,
      type: "set",
      _visit: function(visitor) {
        return ContainerType._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      literal: value,
      type: "literal",
      _visit: function(visitor) {
        return ContainerType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "list":
        return visitor.list(value.list);
      case "map":
        return visitor.map(value);
      case "optional":
        return visitor.optional(value.optional);
      case "set":
        return visitor.set(value.set);
      case "literal":
        return visitor.literal(value.literal);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/PrimitiveTypeV1.js
var PrimitiveTypeV1 = {
  Integer: "INTEGER",
  Long: "LONG",
  Uint: "UINT",
  Uint64: "UINT_64",
  Float: "FLOAT",
  Double: "DOUBLE",
  Boolean: "BOOLEAN",
  String: "STRING",
  Date: "DATE",
  DateTime: "DATE_TIME",
  Uuid: "UUID",
  Base64: "BASE_64",
  BigInteger: "BIG_INTEGER",
  _visit: (value, visitor) => {
    switch (value) {
      case PrimitiveTypeV1.Integer:
        return visitor.integer();
      case PrimitiveTypeV1.Long:
        return visitor.long();
      case PrimitiveTypeV1.Uint:
        return visitor.uint();
      case PrimitiveTypeV1.Uint64:
        return visitor.uint64();
      case PrimitiveTypeV1.Float:
        return visitor.float();
      case PrimitiveTypeV1.Double:
        return visitor.double();
      case PrimitiveTypeV1.Boolean:
        return visitor.boolean();
      case PrimitiveTypeV1.String:
        return visitor.string();
      case PrimitiveTypeV1.Date:
        return visitor.date();
      case PrimitiveTypeV1.DateTime:
        return visitor.dateTime();
      case PrimitiveTypeV1.Uuid:
        return visitor.uuid();
      case PrimitiveTypeV1.Base64:
        return visitor.base64();
      case PrimitiveTypeV1.BigInteger:
        return visitor.bigInteger();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/PrimitiveTypeV2.js
var PrimitiveTypeV2 = {
  integer: (value) => {
    return {
      ...value,
      type: "integer",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  long: (value) => {
    return {
      ...value,
      type: "long",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  uint: (value) => {
    return {
      ...value,
      type: "uint",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  uint64: (value) => {
    return {
      ...value,
      type: "uint64",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  float: (value) => {
    return {
      ...value,
      type: "float",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  double: (value) => {
    return {
      ...value,
      type: "double",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      ...value,
      type: "boolean",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      ...value,
      type: "string",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  date: (value) => {
    return {
      ...value,
      type: "date",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  dateTime: (value) => {
    return {
      ...value,
      type: "dateTime",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  uuid: (value) => {
    return {
      ...value,
      type: "uuid",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  base64: (value) => {
    return {
      ...value,
      type: "base64",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  bigInteger: (value) => {
    return {
      ...value,
      type: "bigInteger",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "integer":
        return visitor.integer(value);
      case "long":
        return visitor.long(value);
      case "uint":
        return visitor.uint(value);
      case "uint64":
        return visitor.uint64(value);
      case "float":
        return visitor.float(value);
      case "double":
        return visitor.double(value);
      case "boolean":
        return visitor.boolean(value);
      case "string":
        return visitor.string(value);
      case "date":
        return visitor.date(value);
      case "dateTime":
        return visitor.dateTime(value);
      case "uuid":
        return visitor.uuid(value);
      case "base64":
        return visitor.base64(value);
      case "bigInteger":
        return visitor.bigInteger(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/Literal.js
var Literal = {
  string: (value) => {
    return {
      string: value,
      type: "string",
      _visit: function(visitor) {
        return Literal._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      boolean: value,
      type: "boolean",
      _visit: function(visitor) {
        return Literal._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "string":
        return visitor.string(value.string);
      case "boolean":
        return visitor.boolean(value.boolean);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ExampleTypeShape.js
var ExampleTypeShape = {
  alias: (value) => {
    return {
      ...value,
      type: "alias",
      _visit: function(visitor) {
        return ExampleTypeShape._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      ...value,
      type: "enum",
      _visit: function(visitor) {
        return ExampleTypeShape._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function(visitor) {
        return ExampleTypeShape._visit(this, visitor);
      }
    };
  },
  union: (value) => {
    return {
      ...value,
      type: "union",
      _visit: function(visitor) {
        return ExampleTypeShape._visit(this, visitor);
      }
    };
  },
  undiscriminatedUnion: (value) => {
    return {
      ...value,
      type: "undiscriminatedUnion",
      _visit: function(visitor) {
        return ExampleTypeShape._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "alias":
        return visitor.alias(value);
      case "enum":
        return visitor.enum(value);
      case "object":
        return visitor.object(value);
      case "union":
        return visitor.union(value);
      case "undiscriminatedUnion":
        return visitor.undiscriminatedUnion(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ExampleSingleUnionTypeProperties.js
var ExampleSingleUnionTypeProperties = {
  samePropertiesAsObject: (value) => {
    return {
      ...value,
      type: "samePropertiesAsObject",
      _visit: function(visitor) {
        return ExampleSingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  singleProperty: (value) => {
    return {
      ...value,
      type: "singleProperty",
      _visit: function(visitor) {
        return ExampleSingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  noProperties: () => {
    return {
      type: "noProperties",
      _visit: function(visitor) {
        return ExampleSingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "samePropertiesAsObject":
        return visitor.samePropertiesAsObject(value);
      case "singleProperty":
        return visitor.singleProperty(value);
      case "noProperties":
        return visitor.noProperties();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ExampleTypeReferenceShape.js
var ExampleTypeReferenceShape = {
  primitive: (value) => {
    return {
      primitive: value,
      type: "primitive",
      _visit: function(visitor) {
        return ExampleTypeReferenceShape._visit(this, visitor);
      }
    };
  },
  container: (value) => {
    return {
      container: value,
      type: "container",
      _visit: function(visitor) {
        return ExampleTypeReferenceShape._visit(this, visitor);
      }
    };
  },
  unknown: (value) => {
    return {
      unknown: value,
      type: "unknown",
      _visit: function(visitor) {
        return ExampleTypeReferenceShape._visit(this, visitor);
      }
    };
  },
  named: (value) => {
    return {
      ...value,
      type: "named",
      _visit: function(visitor) {
        return ExampleTypeReferenceShape._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "primitive":
        return visitor.primitive(value.primitive);
      case "container":
        return visitor.container(value.container);
      case "unknown":
        return visitor.unknown(value.unknown);
      case "named":
        return visitor.named(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ExampleContainer.js
var ExampleContainer = {
  list: (value) => {
    return {
      ...value,
      type: "list",
      _visit: function(visitor) {
        return ExampleContainer._visit(this, visitor);
      }
    };
  },
  set: (value) => {
    return {
      ...value,
      type: "set",
      _visit: function(visitor) {
        return ExampleContainer._visit(this, visitor);
      }
    };
  },
  optional: (value) => {
    return {
      ...value,
      type: "optional",
      _visit: function(visitor) {
        return ExampleContainer._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      ...value,
      type: "map",
      _visit: function(visitor) {
        return ExampleContainer._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      ...value,
      type: "literal",
      _visit: function(visitor) {
        return ExampleContainer._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "list":
        return visitor.list(value);
      case "set":
        return visitor.set(value);
      case "optional":
        return visitor.optional(value);
      case "map":
        return visitor.map(value);
      case "literal":
        return visitor.literal(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ExamplePrimitive.js
var ExamplePrimitive = {
  integer: (value) => {
    return {
      integer: value,
      type: "integer",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  long: (value) => {
    return {
      long: value,
      type: "long",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  uint: (value) => {
    return {
      uint: value,
      type: "uint",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  uint64: (value) => {
    return {
      uint64: value,
      type: "uint64",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  float: (value) => {
    return {
      float: value,
      type: "float",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  double: (value) => {
    return {
      double: value,
      type: "double",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      boolean: value,
      type: "boolean",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      string: value,
      type: "string",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  date: (value) => {
    return {
      date: value,
      type: "date",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  datetime: (value) => {
    return {
      ...value,
      type: "datetime",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  uuid: (value) => {
    return {
      uuid: value,
      type: "uuid",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  base64: (value) => {
    return {
      base64: value,
      type: "base64",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  bigInteger: (value) => {
    return {
      bigInteger: value,
      type: "bigInteger",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "integer":
        return visitor.integer(value.integer);
      case "long":
        return visitor.long(value.long);
      case "uint":
        return visitor.uint(value.uint);
      case "uint64":
        return visitor.uint64(value.uint64);
      case "float":
        return visitor.float(value.float);
      case "double":
        return visitor.double(value.double);
      case "boolean":
        return visitor.boolean(value.boolean);
      case "string":
        return visitor.string(value.string);
      case "date":
        return visitor.date(value.date);
      case "datetime":
        return visitor.datetime(value);
      case "uuid":
        return visitor.uuid(value.uuid);
      case "base64":
        return visitor.base64(value.base64);
      case "bigInteger":
        return visitor.bigInteger(value.bigInteger);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/webhooks/types/WebhookPayload.js
var WebhookPayload = {
  inlinedPayload: (value) => {
    return {
      ...value,
      type: "inlinedPayload",
      _visit: function(visitor) {
        return WebhookPayload._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function(visitor) {
        return WebhookPayload._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "inlinedPayload":
        return visitor.inlinedPayload(value);
      case "reference":
        return visitor.reference(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/websocket/types/WebSocketMessageBody.js
var WebSocketMessageBody = {
  inlinedBody: (value) => {
    return {
      ...value,
      type: "inlinedBody",
      _visit: function(visitor) {
        return WebSocketMessageBody._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function(visitor) {
        return WebSocketMessageBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "inlinedBody":
        return visitor.inlinedBody(value);
      case "reference":
        return visitor.reference(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/websocket/types/ExampleWebSocketMessageBody.js
var ExampleWebSocketMessageBody = {
  inlinedBody: (value) => {
    return {
      ...value,
      type: "inlinedBody",
      _visit: function(visitor) {
        return ExampleWebSocketMessageBody._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function(visitor) {
        return ExampleWebSocketMessageBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "inlinedBody":
        return visitor.inlinedBody(value);
      case "reference":
        return visitor.reference(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/fern-definition/schema/lib/constants.js
var EXAMPLE_REFERENCE_PREFIX = "$";

// ../../cli/fern-definition/schema/lib/schemas/index.js
var schemas_exports3 = {};
__export(schemas_exports3, {
  AvailabilityStatusSchema: () => AvailabilityStatusSchema3,
  FernDefinitionError: () => FernDefinitionError,
  FernDefinitionTimeoutError: () => FernDefinitionTimeoutError,
  HttpMethodSchema: () => HttpMethodSchema,
  StreamFormat: () => StreamFormat,
  SupportedSdkLanguageSchema: () => SupportedSdkLanguageSchema,
  WebSocketOrigin: () => WebSocketOrigin,
  WebhookMethodSchema: () => WebhookMethodSchema,
  auth: () => auth_exports5,
  availability: () => availability_exports3,
  commons: () => commons_exports4,
  encoding: () => encoding_exports3,
  environments: () => environments_exports3,
  errors: () => errors_exports2,
  examples: () => examples_exports2,
  file: () => file_exports3,
  pagination: () => pagination_exports,
  serialization: () => serialization_exports2,
  service: () => service_exports3,
  source: () => source_exports,
  types: () => types_exports5,
  validation: () => validation_exports3,
  variables: () => variables_exports2,
  versioning: () => versioning_exports,
  webhooks: () => webhooks_exports2,
  websocket: () => websocket_exports2
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/auth/index.js
var auth_exports5 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/availability/index.js
var availability_exports3 = {};
__export(availability_exports3, {
  AvailabilityStatusSchema: () => AvailabilityStatusSchema3
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/availability/types/AvailabilityStatusSchema.js
var AvailabilityStatusSchema3 = {
  InDevelopment: "in-development",
  PreRelease: "pre-release",
  Deprecated: "deprecated",
  GenerallyAvailable: "generally-available"
};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/commons/index.js
var commons_exports4 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/encoding/index.js
var encoding_exports3 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/environments/index.js
var environments_exports3 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/errors/index.js
var errors_exports2 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/examples/index.js
var examples_exports2 = {};
__export(examples_exports2, {
  SupportedSdkLanguageSchema: () => SupportedSdkLanguageSchema
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/examples/types/SupportedSdkLanguageSchema.js
var SupportedSdkLanguageSchema = {
  Curl: "curl",
  Python: "python",
  Javascript: "javascript",
  Typescript: "typescript",
  Go: "go",
  Ruby: "ruby",
  Csharp: "csharp",
  Java: "java",
  Js: "js",
  Node: "node",
  Ts: "ts",
  Nodets: "nodets",
  Golang: "golang",
  Dotnet: "dotnet",
  Jvm: "jvm",
  Csharp2: "c#"
};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/file/index.js
var file_exports3 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/pagination/index.js
var pagination_exports = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/service/index.js
var service_exports3 = {};
__export(service_exports3, {
  HttpMethodSchema: () => HttpMethodSchema,
  StreamFormat: () => StreamFormat
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/service/types/HttpMethodSchema.js
var HttpMethodSchema = {
  Get: "GET",
  Post: "POST",
  Put: "PUT",
  Patch: "PATCH",
  Delete: "DELETE"
};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/service/types/StreamFormat.js
var StreamFormat = {
  Sse: "sse",
  Json: "json"
};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/source/index.js
var source_exports = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/types/index.js
var types_exports5 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/validation/index.js
var validation_exports3 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/variables/index.js
var variables_exports2 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/versioning/index.js
var versioning_exports = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/webhooks/index.js
var webhooks_exports2 = {};
__export(webhooks_exports2, {
  WebhookMethodSchema: () => WebhookMethodSchema
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/webhooks/types/WebhookMethodSchema.js
var WebhookMethodSchema = {
  Post: "POST",
  Get: "GET"
};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/websocket/index.js
var websocket_exports2 = {};
__export(websocket_exports2, {
  WebSocketOrigin: () => WebSocketOrigin
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/websocket/types/WebSocketOrigin.js
var WebSocketOrigin = {
  Client: "client",
  Server: "server"
};

// ../../cli/fern-definition/schema/lib/schemas/serialization/index.js
var serialization_exports2 = {};
__export(serialization_exports2, {
  AliasSchema: () => AliasSchema,
  AnyAuthItem: () => AnyAuthItem2,
  AnyAuthSchemesSchema: () => AnyAuthSchemesSchema2,
  ApiAuthSchema: () => ApiAuthSchema2,
  AuthSchemeDeclarationSchema: () => AuthSchemeDeclarationSchema2,
  AuthSchemeReferenceSchema: () => AuthSchemeReferenceSchema2,
  AuthVariable: () => AuthVariable2,
  AvailabilitySchema: () => AvailabilitySchema2,
  AvailabilityStatusSchema: () => AvailabilityStatusSchema4,
  AvailabilityUnionSchema: () => AvailabilityUnionSchema2,
  BaseTypeDeclarationSchema: () => BaseTypeDeclarationSchema,
  BaseTypeReferenceSchema: () => BaseTypeReferenceSchema2,
  BasicAuthSchemeSchema: () => BasicAuthSchemeSchema2,
  BearerAuthSchemeSchema: () => BearerAuthSchemeSchema2,
  CasingOverridesSchema: () => CasingOverridesSchema,
  CursorPaginationSchema: () => CursorPaginationSchema,
  DeclarationSchema: () => DeclarationSchema,
  DeclarationWithNameSchema: () => DeclarationWithNameSchema,
  DeclarationWithoutDocsSchema: () => DeclarationWithoutDocsSchema,
  DefinitionFileSchema: () => DefinitionFileSchema,
  DiscriminatedUnionSchema: () => DiscriminatedUnionSchema,
  EncodingSchema: () => EncodingSchema2,
  EnumSchema: () => EnumSchema,
  EnumValue: () => EnumValue,
  EnumValueSchema: () => EnumValueSchema,
  EnvironmentSchema: () => EnvironmentSchema2,
  ErrorDeclarationSchema: () => ErrorDeclarationSchema,
  ErrorDiscriminationSchema: () => ErrorDiscriminationSchema,
  ExampleBodyResponseSchema: () => ExampleBodyResponseSchema,
  ExampleCodeSampleSchema: () => ExampleCodeSampleSchema,
  ExampleCodeSampleSchemaLanguage: () => ExampleCodeSampleSchemaLanguage,
  ExampleCodeSampleSchemaSdk: () => ExampleCodeSampleSchemaSdk,
  ExampleEndpointCallArraySchema: () => ExampleEndpointCallArraySchema,
  ExampleEndpointCallSchema: () => ExampleEndpointCallSchema,
  ExampleResponseSchema: () => ExampleResponseSchema,
  ExampleSseEventSchema: () => ExampleSseEventSchema,
  ExampleSseResponseSchema: () => ExampleSseResponseSchema,
  ExampleStreamResponseSchema: () => ExampleStreamResponseSchema,
  ExampleTypeReferenceSchema: () => ExampleTypeReferenceSchema,
  ExampleTypeSchema: () => ExampleTypeSchema,
  ExampleTypeValueSchema: () => ExampleTypeValueSchema,
  ExampleWebSocketMessage: () => ExampleWebSocketMessage,
  ExampleWebSocketSession: () => ExampleWebSocketSession,
  ExampleWebhookCallSchema: () => ExampleWebhookCallSchema,
  Export: () => Export,
  ExportDetailed: () => ExportDetailed,
  GrpcTransport: () => GrpcTransport,
  HeaderAuthSchemeSchema: () => HeaderAuthSchemeSchema2,
  HttpEndpointSchema: () => HttpEndpointSchema,
  HttpHeaderSchema: () => HttpHeaderSchema2,
  HttpInlineRequestBodyPropertySchema: () => HttpInlineRequestBodyPropertySchema,
  HttpInlineRequestBodySchema: () => HttpInlineRequestBodySchema,
  HttpMethodSchema: () => HttpMethodSchema2,
  HttpPathParameterSchema: () => HttpPathParameterSchema,
  HttpQueryParameterSchema: () => HttpQueryParameterSchema,
  HttpReferencedRequestBodySchema: () => HttpReferencedRequestBodySchema,
  HttpRequest: () => HttpRequest,
  HttpRequestBodySchema: () => HttpRequestBodySchema,
  HttpRequestSchema: () => HttpRequestSchema,
  HttpResponseSchema: () => HttpResponseSchema,
  HttpResponseSchemaDetailed: () => HttpResponseSchemaDetailed,
  HttpResponseStreamSchema: () => HttpResponseStreamSchema,
  HttpResponseStreamSchemaDetailed: () => HttpResponseStreamSchemaDetailed,
  HttpServiceSchema: () => HttpServiceSchema,
  MultipleBaseUrlsEnvironmentSchema: () => MultipleBaseUrlsEnvironmentSchema2,
  Navigation: () => Navigation,
  NumberValidationSchema: () => NumberValidationSchema2,
  OAuthAccessTokenRequestPropertiesSchema: () => OAuthAccessTokenRequestPropertiesSchema2,
  OAuthAccessTokenResponsePropertiesSchema: () => OAuthAccessTokenResponsePropertiesSchema2,
  OAuthGetTokenEndpointSchema: () => OAuthGetTokenEndpointSchema2,
  OAuthRefreshTokenEndpointSchema: () => OAuthRefreshTokenEndpointSchema2,
  OAuthRefreshTokenRequestPropertiesSchema: () => OAuthRefreshTokenRequestPropertiesSchema2,
  OAuthRefreshTokenResponsePropertiesSchema: () => OAuthRefreshTokenResponsePropertiesSchema2,
  OAuthSchemeSchema: () => OAuthSchemeSchema2,
  ObjectExtendsSchema: () => ObjectExtendsSchema,
  ObjectPropertySchema: () => ObjectPropertySchema,
  ObjectSchema: () => ObjectSchema,
  OffsetPaginationSchema: () => OffsetPaginationSchema,
  OpenApiSourceSchema: () => OpenApiSourceSchema,
  PackageMarkerFileSchema: () => PackageMarkerFileSchema,
  Pagination: () => Pagination2,
  PaginationSchema: () => PaginationSchema,
  PropertyBasedErrorDiscrimination: () => PropertyBasedErrorDiscrimination,
  ProtobufSourceSchema: () => ProtobufSourceSchema,
  ProtobufTypeSchema: () => ProtobufTypeSchema2,
  QueryParameterTypeReferenceDetailed: () => QueryParameterTypeReferenceDetailed,
  ResponseError: () => ResponseError,
  ResponseErrorWithDocsSchema: () => ResponseErrorWithDocsSchema,
  ResponseErrorsSchema: () => ResponseErrorsSchema,
  RootApiFileSchema: () => RootApiFileSchema,
  ServiceTransport: () => ServiceTransport,
  SingleBaseUrlEnvironmentSchema: () => SingleBaseUrlEnvironmentSchema2,
  SingleUndiscriminatedUnionTypeDetailedSchema: () => SingleUndiscriminatedUnionTypeDetailedSchema,
  SingleUndiscriminatedUnionTypeSchema: () => SingleUndiscriminatedUnionTypeSchema,
  SingleUnionTypeDetailedSchema: () => SingleUnionTypeDetailedSchema,
  SingleUnionTypeKey: () => SingleUnionTypeKey,
  SingleUnionTypeKeySchema: () => SingleUnionTypeKeySchema,
  SingleUnionTypeSchema: () => SingleUnionTypeSchema,
  SourceSchema: () => SourceSchema,
  StatusCodeBasedErrorDiscrimination: () => StatusCodeBasedErrorDiscrimination,
  StreamFormat: () => StreamFormat2,
  StringValidationSchema: () => StringValidationSchema2,
  SupportedSdkLanguageSchema: () => SupportedSdkLanguageSchema2,
  TypeDeclarationSchema: () => TypeDeclarationSchema,
  TypeReferenceDeclarationWithContentTypeSchema: () => TypeReferenceDeclarationWithContentTypeSchema,
  TypeReferenceDeclarationWithEnvOverride: () => TypeReferenceDeclarationWithEnvOverride2,
  TypeReferenceDeclarationWithEnvOverrideSchema: () => TypeReferenceDeclarationWithEnvOverrideSchema2,
  TypeReferenceDeclarationWithName: () => TypeReferenceDeclarationWithName2,
  TypeReferenceDeclarationWithNameSchema: () => TypeReferenceDeclarationWithNameSchema,
  TypeReferenceDetailedSchema: () => TypeReferenceDetailedSchema,
  TypeReferenceSchema: () => TypeReferenceSchema,
  UndiscriminatedUnionSchema: () => UndiscriminatedUnionSchema,
  UnionDiscriminant: () => UnionDiscriminant,
  UnionDiscriminantSchema: () => UnionDiscriminantSchema,
  ValidationSchema: () => ValidationSchema2,
  VariableDeclarationDetailed: () => VariableDeclarationDetailed,
  VariableDeclarationSchema: () => VariableDeclarationSchema,
  VariableReferenceSchema: () => VariableReferenceSchema,
  VersionDeclarationHeaderObjectSchema: () => VersionDeclarationHeaderObjectSchema,
  VersionDeclarationHeaderSchema: () => VersionDeclarationHeaderSchema,
  VersionDeclarationSchema: () => VersionDeclarationSchema,
  VersionValue: () => VersionValue,
  VersionValueDetailed: () => VersionValueDetailed,
  WebSocketChannelInlinedMessageSchema: () => WebSocketChannelInlinedMessageSchema,
  WebSocketChannelMessageBodySchema: () => WebSocketChannelMessageBodySchema,
  WebSocketChannelMessageSchema: () => WebSocketChannelMessageSchema,
  WebSocketChannelReferencedMessageSchema: () => WebSocketChannelReferencedMessageSchema,
  WebSocketChannelSchema: () => WebSocketChannelSchema,
  WebSocketOrigin: () => WebSocketOrigin2,
  WebhookInlinedPayloadSchema: () => WebhookInlinedPayloadSchema,
  WebhookMethodSchema: () => WebhookMethodSchema2,
  WebhookPayloadSchema: () => WebhookPayloadSchema,
  WebhookReferencedPayloadSchema: () => WebhookReferencedPayloadSchema,
  WebhookSchema: () => WebhookSchema,
  WithAudiences: () => WithAudiences2,
  WithAuthSchema: () => WithAuthSchema,
  WithAvailability: () => WithAvailability2,
  WithDisplayName: () => WithDisplayName,
  WithDocsSchema: () => WithDocsSchema2,
  WithEnvironmentVariable: () => WithEnvironmentVariable2,
  WithEnvironmentsSchema: () => WithEnvironmentsSchema2,
  WithHeadersSchema: () => WithHeadersSchema2,
  WithName: () => WithName2,
  auth: () => auth_exports6,
  availability: () => availability_exports4,
  commons: () => commons_exports5,
  encoding: () => encoding_exports4,
  environments: () => environments_exports4,
  errors: () => errors_exports3,
  examples: () => examples_exports3,
  file: () => file_exports4,
  pagination: () => pagination_exports2,
  service: () => service_exports4,
  source: () => source_exports2,
  types: () => types_exports6,
  validation: () => validation_exports4,
  variables: () => variables_exports3,
  versioning: () => versioning_exports2,
  webhooks: () => webhooks_exports3,
  websocket: () => websocket_exports3
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/index.js
var auth_exports6 = {};
__export(auth_exports6, {
  AnyAuthItem: () => AnyAuthItem2,
  AnyAuthSchemesSchema: () => AnyAuthSchemesSchema2,
  ApiAuthSchema: () => ApiAuthSchema2,
  AuthSchemeDeclarationSchema: () => AuthSchemeDeclarationSchema2,
  AuthSchemeReferenceSchema: () => AuthSchemeReferenceSchema2,
  AuthVariable: () => AuthVariable2,
  BasicAuthSchemeSchema: () => BasicAuthSchemeSchema2,
  BearerAuthSchemeSchema: () => BearerAuthSchemeSchema2,
  HeaderAuthSchemeSchema: () => HeaderAuthSchemeSchema2,
  OAuthAccessTokenRequestPropertiesSchema: () => OAuthAccessTokenRequestPropertiesSchema2,
  OAuthAccessTokenResponsePropertiesSchema: () => OAuthAccessTokenResponsePropertiesSchema2,
  OAuthGetTokenEndpointSchema: () => OAuthGetTokenEndpointSchema2,
  OAuthRefreshTokenEndpointSchema: () => OAuthRefreshTokenEndpointSchema2,
  OAuthRefreshTokenRequestPropertiesSchema: () => OAuthRefreshTokenRequestPropertiesSchema2,
  OAuthRefreshTokenResponsePropertiesSchema: () => OAuthRefreshTokenResponsePropertiesSchema2,
  OAuthSchemeSchema: () => OAuthSchemeSchema2,
  WithAuthSchema: () => WithAuthSchema,
  WithEnvironmentVariable: () => WithEnvironmentVariable2
});

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/index.js
var schemas_exports2 = {};
__export(schemas_exports2, {
  JsonError: () => JsonError2,
  ParseError: () => ParseError2,
  any: () => any2,
  boolean: () => boolean2,
  booleanLiteral: () => booleanLiteral2,
  date: () => date2,
  discriminant: () => discriminant2,
  enum_: () => enum_2,
  getObjectLikeUtils: () => getObjectLikeUtils2,
  getObjectUtils: () => getObjectUtils2,
  getSchemaUtils: () => getSchemaUtils2,
  isProperty: () => isProperty2,
  lazy: () => lazy2,
  lazyObject: () => lazyObject2,
  list: () => list2,
  number: () => number2,
  object: () => object2,
  objectWithoutOptionalProperties: () => objectWithoutOptionalProperties2,
  optional: () => optional2,
  property: () => property3,
  record: () => record2,
  set: () => set2,
  string: () => string2,
  stringLiteral: () => stringLiteral2,
  transform: () => transform2,
  undiscriminatedUnion: () => undiscriminatedUnion2,
  union: () => union2,
  unknown: () => unknown2,
  withParsedProperties: () => withParsedProperties2
});

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/Schema.js
var SchemaType2 = {
  DATE: "date",
  ENUM: "enum",
  LIST: "list",
  STRING_LITERAL: "stringLiteral",
  BOOLEAN_LITERAL: "booleanLiteral",
  OBJECT: "object",
  ANY: "any",
  BOOLEAN: "boolean",
  NUMBER: "number",
  STRING: "string",
  UNKNOWN: "unknown",
  RECORD: "record",
  SET: "set",
  UNION: "union",
  UNDISCRIMINATED_UNION: "undiscriminatedUnion",
  OPTIONAL: "optional"
};

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/getErrorMessageForIncorrectType.js
function getErrorMessageForIncorrectType2(value, expectedType) {
  return `Expected ${expectedType}. Received ${getTypeAsString2(value)}.`;
}
function getTypeAsString2(value) {
  if (Array.isArray(value)) {
    return "list";
  }
  if (value === null) {
    return "null";
  }
  switch (typeof value) {
    case "string":
      return `"${value}"`;
    case "number":
    case "boolean":
    case "undefined":
      return `${value}`;
  }
  return typeof value;
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/maybeSkipValidation.js
function maybeSkipValidation2(schema2) {
  return {
    ...schema2,
    json: transformAndMaybeSkipValidation2(schema2.json),
    parse: transformAndMaybeSkipValidation2(schema2.parse)
  };
}
function transformAndMaybeSkipValidation2(transform3) {
  return (value, opts) => {
    const transformed = transform3(value, opts);
    const { skipValidation = false } = opts ?? {};
    if (!transformed.ok && skipValidation) {
      console.warn([
        "Failed to validate.",
        ...transformed.errors.map((error) => "  - " + (error.path.length > 0 ? `${error.path.join(".")}: ${error.message}` : error.message))
      ].join("\n"));
      return {
        ok: true,
        value
      };
    } else {
      return transformed;
    }
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/schema-utils/stringifyValidationErrors.js
function stringifyValidationError2(error) {
  if (error.path.length === 0) {
    return error.message;
  }
  return `${error.path.join(" -> ")}: ${error.message}`;
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/schema-utils/JsonError.js
var JsonError2 = class _JsonError extends Error {
  errors;
  constructor(errors) {
    super(errors.map(stringifyValidationError2).join("; "));
    this.errors = errors;
    Object.setPrototypeOf(this, _JsonError.prototype);
  }
};

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/schema-utils/ParseError.js
var ParseError2 = class _ParseError extends Error {
  errors;
  constructor(errors) {
    super(errors.map(stringifyValidationError2).join("; "));
    this.errors = errors;
    Object.setPrototypeOf(this, _ParseError.prototype);
  }
};

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/schema-utils/getSchemaUtils.js
function getSchemaUtils2(schema2) {
  return {
    optional: () => optional2(schema2),
    transform: (transformer) => transform2(schema2, transformer),
    parseOrThrow: (raw, opts) => {
      const parsed = schema2.parse(raw, opts);
      if (parsed.ok) {
        return parsed.value;
      }
      throw new ParseError2(parsed.errors);
    },
    jsonOrThrow: (parsed, opts) => {
      const raw = schema2.json(parsed, opts);
      if (raw.ok) {
        return raw.value;
      }
      throw new JsonError2(raw.errors);
    }
  };
}
function optional2(schema2) {
  const baseSchema = {
    parse: (raw, opts) => {
      if (raw == null) {
        return {
          ok: true,
          value: void 0
        };
      }
      return schema2.parse(raw, opts);
    },
    json: (parsed, opts) => {
      if (opts?.omitUndefined && parsed === void 0) {
        return {
          ok: true,
          value: void 0
        };
      }
      if (parsed == null) {
        return {
          ok: true,
          value: null
        };
      }
      return schema2.json(parsed, opts);
    },
    getType: () => SchemaType2.OPTIONAL
  };
  return {
    ...baseSchema,
    ...getSchemaUtils2(baseSchema)
  };
}
function transform2(schema2, transformer) {
  const baseSchema = {
    parse: (raw, opts) => {
      const parsed = schema2.parse(raw, opts);
      if (!parsed.ok) {
        return parsed;
      }
      return {
        ok: true,
        value: transformer.transform(parsed.value)
      };
    },
    json: (transformed, opts) => {
      const parsed = transformer.untransform(transformed);
      return schema2.json(parsed, opts);
    },
    getType: () => schema2.getType()
  };
  return {
    ...baseSchema,
    ...getSchemaUtils2(baseSchema)
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/date/date.js
var ISO_8601_REGEX2 = /^([+-]?\d{4}(?!\d{2}\b))((-?)((0[1-9]|1[0-2])(\3([12]\d|0[1-9]|3[01]))?|W([0-4]\d|5[0-2])(-?[1-7])?|(00[1-9]|0[1-9]\d|[12]\d{2}|3([0-5]\d|6[1-6])))([T\s]((([01]\d|2[0-3])((:?)[0-5]\d)?|24:?00)([.,]\d+(?!:))?)?(\17[0-5]\d([.,]\d+)?)?([zZ]|([+-])([01]\d|2[0-3]):?([0-5]\d)?)?)?)?$/;
function date2() {
  const baseSchema = {
    parse: (raw, { breadcrumbsPrefix = [] } = {}) => {
      if (typeof raw !== "string") {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType2(raw, "string")
            }
          ]
        };
      }
      if (!ISO_8601_REGEX2.test(raw)) {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType2(raw, "ISO 8601 date string")
            }
          ]
        };
      }
      return {
        ok: true,
        value: new Date(raw)
      };
    },
    json: (date3, { breadcrumbsPrefix = [] } = {}) => {
      if (date3 instanceof Date) {
        return {
          ok: true,
          value: date3.toISOString()
        };
      } else {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType2(date3, "Date object")
            }
          ]
        };
      }
    },
    getType: () => SchemaType2.DATE
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema)
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/createIdentitySchemaCreator.js
function createIdentitySchemaCreator2(schemaType, validate) {
  return () => {
    const baseSchema = {
      parse: validate,
      json: validate,
      getType: () => schemaType
    };
    return {
      ...maybeSkipValidation2(baseSchema),
      ...getSchemaUtils2(baseSchema)
    };
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/enum/enum.js
function enum_2(values) {
  const validValues = new Set(values);
  const schemaCreator = createIdentitySchemaCreator2(SchemaType2.ENUM, (value, { allowUnrecognizedEnumValues, breadcrumbsPrefix = [] } = {}) => {
    if (typeof value !== "string") {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType2(value, "string")
          }
        ]
      };
    }
    if (!validValues.has(value) && !allowUnrecognizedEnumValues) {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType2(value, "enum")
          }
        ]
      };
    }
    return {
      ok: true,
      value
    };
  });
  return schemaCreator();
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/lazy/lazy.js
function lazy2(getter) {
  const baseSchema = constructLazyBaseSchema2(getter);
  return {
    ...baseSchema,
    ...getSchemaUtils2(baseSchema)
  };
}
function constructLazyBaseSchema2(getter) {
  return {
    parse: (raw, opts) => getMemoizedSchema2(getter).parse(raw, opts),
    json: (parsed, opts) => getMemoizedSchema2(getter).json(parsed, opts),
    getType: () => getMemoizedSchema2(getter).getType()
  };
}
function getMemoizedSchema2(getter) {
  const castedGetter = getter;
  if (castedGetter.__zurg_memoized == null) {
    castedGetter.__zurg_memoized = getter();
  }
  return castedGetter.__zurg_memoized;
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/entries.js
function entries3(object3) {
  return Object.entries(object3);
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/filterObject.js
function filterObject2(obj, keysToInclude) {
  const keysToIncludeSet = new Set(keysToInclude);
  return Object.entries(obj).reduce((acc, [key, value]) => {
    if (keysToIncludeSet.has(key)) {
      acc[key] = value;
    }
    return acc;
  }, {});
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/isPlainObject.js
function isPlainObject4(value) {
  if (typeof value !== "object" || value === null) {
    return false;
  }
  if (Object.getPrototypeOf(value) === null) {
    return true;
  }
  let proto = value;
  while (Object.getPrototypeOf(proto) !== null) {
    proto = Object.getPrototypeOf(proto);
  }
  return Object.getPrototypeOf(value) === proto;
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/keys.js
function keys4(object3) {
  return Object.keys(object3);
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/partition.js
function partition2(items, predicate) {
  const trueItems = [], falseItems = [];
  for (const item of items) {
    if (predicate(item)) {
      trueItems.push(item);
    } else {
      falseItems.push(item);
    }
  }
  return [trueItems, falseItems];
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/object-like/getObjectLikeUtils.js
function getObjectLikeUtils2(schema2) {
  return {
    withParsedProperties: (properties) => withParsedProperties2(schema2, properties)
  };
}
function withParsedProperties2(objectLike, properties) {
  const objectSchema = {
    parse: (raw, opts) => {
      const parsedObject = objectLike.parse(raw, opts);
      if (!parsedObject.ok) {
        return parsedObject;
      }
      const additionalProperties = Object.entries(properties).reduce((processed, [key, value]) => {
        return {
          ...processed,
          [key]: typeof value === "function" ? value(parsedObject.value) : value
        };
      }, {});
      return {
        ok: true,
        value: {
          ...parsedObject.value,
          ...additionalProperties
        }
      };
    },
    json: (parsed, opts) => {
      if (!isPlainObject4(parsed)) {
        return {
          ok: false,
          errors: [
            {
              path: opts?.breadcrumbsPrefix ?? [],
              message: getErrorMessageForIncorrectType2(parsed, "object")
            }
          ]
        };
      }
      const addedPropertyKeys = new Set(Object.keys(properties));
      const parsedWithoutAddedProperties = filterObject2(parsed, Object.keys(parsed).filter((key) => !addedPropertyKeys.has(key)));
      return objectLike.json(parsedWithoutAddedProperties, opts);
    },
    getType: () => objectLike.getType()
  };
  return {
    ...objectSchema,
    ...getSchemaUtils2(objectSchema),
    ...getObjectLikeUtils2(objectSchema)
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/object/property.js
function property3(rawKey, valueSchema) {
  return {
    rawKey,
    valueSchema,
    isProperty: true
  };
}
function isProperty2(maybeProperty) {
  return maybeProperty.isProperty;
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/object/object.js
function object2(schemas) {
  const baseSchema = {
    _getRawProperties: () => Object.entries(schemas).map(([parsedKey, propertySchema]) => isProperty2(propertySchema) ? propertySchema.rawKey : parsedKey),
    _getParsedProperties: () => keys4(schemas),
    parse: (raw, opts) => {
      const rawKeyToProperty = {};
      const requiredKeys = [];
      for (const [parsedKey, schemaOrObjectProperty] of entries3(schemas)) {
        const rawKey = isProperty2(schemaOrObjectProperty) ? schemaOrObjectProperty.rawKey : parsedKey;
        const valueSchema = isProperty2(schemaOrObjectProperty) ? schemaOrObjectProperty.valueSchema : schemaOrObjectProperty;
        const property4 = {
          rawKey,
          parsedKey,
          valueSchema
        };
        rawKeyToProperty[rawKey] = property4;
        if (isSchemaRequired2(valueSchema)) {
          requiredKeys.push(rawKey);
        }
      }
      return validateAndTransformObject2({
        value: raw,
        requiredKeys,
        getProperty: (rawKey) => {
          const property4 = rawKeyToProperty[rawKey];
          if (property4 == null) {
            return void 0;
          }
          return {
            transformedKey: property4.parsedKey,
            transform: (propertyValue) => property4.valueSchema.parse(propertyValue, {
              ...opts,
              breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], rawKey]
            })
          };
        },
        unrecognizedObjectKeys: opts?.unrecognizedObjectKeys,
        skipValidation: opts?.skipValidation,
        breadcrumbsPrefix: opts?.breadcrumbsPrefix,
        omitUndefined: opts?.omitUndefined
      });
    },
    json: (parsed, opts) => {
      const requiredKeys = [];
      for (const [parsedKey, schemaOrObjectProperty] of entries3(schemas)) {
        const valueSchema = isProperty2(schemaOrObjectProperty) ? schemaOrObjectProperty.valueSchema : schemaOrObjectProperty;
        if (isSchemaRequired2(valueSchema)) {
          requiredKeys.push(parsedKey);
        }
      }
      return validateAndTransformObject2({
        value: parsed,
        requiredKeys,
        getProperty: (parsedKey) => {
          const property4 = schemas[parsedKey];
          if (property4 == null) {
            return void 0;
          }
          if (isProperty2(property4)) {
            return {
              transformedKey: property4.rawKey,
              transform: (propertyValue) => property4.valueSchema.json(propertyValue, {
                ...opts,
                breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedKey]
              })
            };
          } else {
            return {
              transformedKey: parsedKey,
              transform: (propertyValue) => property4.json(propertyValue, {
                ...opts,
                breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedKey]
              })
            };
          }
        },
        unrecognizedObjectKeys: opts?.unrecognizedObjectKeys,
        skipValidation: opts?.skipValidation,
        breadcrumbsPrefix: opts?.breadcrumbsPrefix,
        omitUndefined: opts?.omitUndefined
      });
    },
    getType: () => SchemaType2.OBJECT
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema),
    ...getObjectLikeUtils2(baseSchema),
    ...getObjectUtils2(baseSchema)
  };
}
function validateAndTransformObject2({ value, requiredKeys, getProperty: getProperty2, unrecognizedObjectKeys = "fail", skipValidation = false, breadcrumbsPrefix = [] }) {
  if (!isPlainObject4(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "object")
        }
      ]
    };
  }
  const missingRequiredKeys = new Set(requiredKeys);
  const errors = [];
  const transformed = {};
  for (const [preTransformedKey, preTransformedItemValue] of Object.entries(value)) {
    const property4 = getProperty2(preTransformedKey);
    if (property4 != null) {
      missingRequiredKeys.delete(preTransformedKey);
      const value2 = property4.transform(preTransformedItemValue);
      if (value2.ok) {
        transformed[property4.transformedKey] = value2.value;
      } else {
        transformed[preTransformedKey] = preTransformedItemValue;
        errors.push(...value2.errors);
      }
    } else {
      switch (unrecognizedObjectKeys) {
        case "fail":
          errors.push({
            path: [...breadcrumbsPrefix, preTransformedKey],
            message: `Unexpected key "${preTransformedKey}"`
          });
          break;
        case "strip":
          break;
        case "passthrough":
          transformed[preTransformedKey] = preTransformedItemValue;
          break;
      }
    }
  }
  errors.push(...requiredKeys.filter((key) => missingRequiredKeys.has(key)).map((key) => ({
    path: breadcrumbsPrefix,
    message: `Missing required key "${key}"`
  })));
  if (errors.length === 0 || skipValidation) {
    return {
      ok: true,
      value: transformed
    };
  } else {
    return {
      ok: false,
      errors
    };
  }
}
function getObjectUtils2(schema2) {
  return {
    extend: (extension) => {
      const baseSchema = {
        _getParsedProperties: () => [...schema2._getParsedProperties(), ...extension._getParsedProperties()],
        _getRawProperties: () => [...schema2._getRawProperties(), ...extension._getRawProperties()],
        parse: (raw, opts) => {
          return validateAndTransformExtendedObject2({
            extensionKeys: extension._getRawProperties(),
            value: raw,
            transformBase: (rawBase) => schema2.parse(rawBase, opts),
            transformExtension: (rawExtension) => extension.parse(rawExtension, opts)
          });
        },
        json: (parsed, opts) => {
          return validateAndTransformExtendedObject2({
            extensionKeys: extension._getParsedProperties(),
            value: parsed,
            transformBase: (parsedBase) => schema2.json(parsedBase, opts),
            transformExtension: (parsedExtension) => extension.json(parsedExtension, opts)
          });
        },
        getType: () => SchemaType2.OBJECT
      };
      return {
        ...baseSchema,
        ...getSchemaUtils2(baseSchema),
        ...getObjectLikeUtils2(baseSchema),
        ...getObjectUtils2(baseSchema)
      };
    }
  };
}
function validateAndTransformExtendedObject2({ extensionKeys, value, transformBase, transformExtension }) {
  const extensionPropertiesSet = new Set(extensionKeys);
  const [extensionProperties, baseProperties] = partition2(keys4(value), (key) => extensionPropertiesSet.has(key));
  const transformedBase = transformBase(filterObject2(value, baseProperties));
  const transformedExtension = transformExtension(filterObject2(value, extensionProperties));
  if (transformedBase.ok && transformedExtension.ok) {
    return {
      ok: true,
      value: {
        ...transformedBase.value,
        ...transformedExtension.value
      }
    };
  } else {
    return {
      ok: false,
      errors: [
        ...transformedBase.ok ? [] : transformedBase.errors,
        ...transformedExtension.ok ? [] : transformedExtension.errors
      ]
    };
  }
}
function isSchemaRequired2(schema2) {
  return !isSchemaOptional2(schema2);
}
function isSchemaOptional2(schema2) {
  switch (schema2.getType()) {
    case SchemaType2.ANY:
    case SchemaType2.UNKNOWN:
    case SchemaType2.OPTIONAL:
      return true;
    default:
      return false;
  }
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/object/objectWithoutOptionalProperties.js
function objectWithoutOptionalProperties2(schemas) {
  return object2(schemas);
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/lazy/lazyObject.js
function lazyObject2(getter) {
  const baseSchema = {
    ...constructLazyBaseSchema2(getter),
    _getRawProperties: () => getMemoizedSchema2(getter)._getRawProperties(),
    _getParsedProperties: () => getMemoizedSchema2(getter)._getParsedProperties()
  };
  return {
    ...baseSchema,
    ...getSchemaUtils2(baseSchema),
    ...getObjectLikeUtils2(baseSchema),
    ...getObjectUtils2(baseSchema)
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/list/list.js
function list2(schema2) {
  const baseSchema = {
    parse: (raw, opts) => validateAndTransformArray2(raw, (item, index) => schema2.parse(item, {
      ...opts,
      breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `[${index}]`]
    })),
    json: (parsed, opts) => validateAndTransformArray2(parsed, (item, index) => schema2.json(item, {
      ...opts,
      breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `[${index}]`]
    })),
    getType: () => SchemaType2.LIST
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema)
  };
}
function validateAndTransformArray2(value, transformItem) {
  if (!Array.isArray(value)) {
    return {
      ok: false,
      errors: [
        {
          message: getErrorMessageForIncorrectType2(value, "list"),
          path: []
        }
      ]
    };
  }
  const maybeValidItems = value.map((item, index) => transformItem(item, index));
  return maybeValidItems.reduce((acc, item) => {
    if (acc.ok && item.ok) {
      return {
        ok: true,
        value: [...acc.value, item.value]
      };
    }
    const errors = [];
    if (!acc.ok) {
      errors.push(...acc.errors);
    }
    if (!item.ok) {
      errors.push(...item.errors);
    }
    return {
      ok: false,
      errors
    };
  }, { ok: true, value: [] });
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/literals/stringLiteral.js
function stringLiteral2(literal) {
  const schemaCreator = createIdentitySchemaCreator2(SchemaType2.STRING_LITERAL, (value, { breadcrumbsPrefix = [] } = {}) => {
    if (value === literal) {
      return {
        ok: true,
        value: literal
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType2(value, `"${literal}"`)
          }
        ]
      };
    }
  });
  return schemaCreator();
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/literals/booleanLiteral.js
function booleanLiteral2(literal) {
  const schemaCreator = createIdentitySchemaCreator2(SchemaType2.BOOLEAN_LITERAL, (value, { breadcrumbsPrefix = [] } = {}) => {
    if (value === literal) {
      return {
        ok: true,
        value: literal
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType2(value, `${literal.toString()}`)
          }
        ]
      };
    }
  });
  return schemaCreator();
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/primitives/any.js
var any2 = createIdentitySchemaCreator2(SchemaType2.ANY, (value) => ({ ok: true, value }));

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/primitives/boolean.js
var boolean2 = createIdentitySchemaCreator2(SchemaType2.BOOLEAN, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "boolean") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "boolean")
        }
      ]
    };
  }
});

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/primitives/number.js
var number2 = createIdentitySchemaCreator2(SchemaType2.NUMBER, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "number") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "number")
        }
      ]
    };
  }
});

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/primitives/string.js
var string2 = createIdentitySchemaCreator2(SchemaType2.STRING, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "string") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "string")
        }
      ]
    };
  }
});

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/primitives/unknown.js
var unknown2 = createIdentitySchemaCreator2(SchemaType2.UNKNOWN, (value) => ({ ok: true, value }));

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/record/record.js
function record2(keySchema, valueSchema) {
  const baseSchema = {
    parse: (raw, opts) => {
      return validateAndTransformRecord2({
        value: raw,
        isKeyNumeric: keySchema.getType() === SchemaType2.NUMBER,
        transformKey: (key) => keySchema.parse(key, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key} (key)`]
        }),
        transformValue: (value, key) => valueSchema.parse(value, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key}`]
        }),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    json: (parsed, opts) => {
      return validateAndTransformRecord2({
        value: parsed,
        isKeyNumeric: keySchema.getType() === SchemaType2.NUMBER,
        transformKey: (key) => keySchema.json(key, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key} (key)`]
        }),
        transformValue: (value, key) => valueSchema.json(value, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key}`]
        }),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    getType: () => SchemaType2.RECORD
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema)
  };
}
function validateAndTransformRecord2({ value, isKeyNumeric, transformKey, transformValue, breadcrumbsPrefix = [] }) {
  if (!isPlainObject4(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "object")
        }
      ]
    };
  }
  return entries3(value).reduce((accPromise, [stringKey, value2]) => {
    if (value2 == null) {
      return accPromise;
    }
    const acc = accPromise;
    let key = stringKey;
    if (isKeyNumeric) {
      const numberKey = stringKey.length > 0 ? Number(stringKey) : NaN;
      if (!isNaN(numberKey)) {
        key = numberKey;
      }
    }
    const transformedKey = transformKey(key);
    const transformedValue = transformValue(value2, key);
    if (acc.ok && transformedKey.ok && transformedValue.ok) {
      return {
        ok: true,
        value: {
          ...acc.value,
          [transformedKey.value]: transformedValue.value
        }
      };
    }
    const errors = [];
    if (!acc.ok) {
      errors.push(...acc.errors);
    }
    if (!transformedKey.ok) {
      errors.push(...transformedKey.errors);
    }
    if (!transformedValue.ok) {
      errors.push(...transformedValue.errors);
    }
    return {
      ok: false,
      errors
    };
  }, { ok: true, value: {} });
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/set/set.js
function set2(schema2) {
  const listSchema = list2(schema2);
  const baseSchema = {
    parse: (raw, opts) => {
      const parsedList = listSchema.parse(raw, opts);
      if (parsedList.ok) {
        return {
          ok: true,
          value: new Set(parsedList.value)
        };
      } else {
        return parsedList;
      }
    },
    json: (parsed, opts) => {
      if (!(parsed instanceof Set)) {
        return {
          ok: false,
          errors: [
            {
              path: opts?.breadcrumbsPrefix ?? [],
              message: getErrorMessageForIncorrectType2(parsed, "Set")
            }
          ]
        };
      }
      const jsonList = listSchema.json([...parsed], opts);
      return jsonList;
    },
    getType: () => SchemaType2.SET
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema)
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/undiscriminated-union/undiscriminatedUnion.js
function undiscriminatedUnion2(schemas) {
  const baseSchema = {
    parse: (raw, opts) => {
      return validateAndTransformUndiscriminatedUnion2((schema2, opts2) => schema2.parse(raw, opts2), schemas, opts);
    },
    json: (parsed, opts) => {
      return validateAndTransformUndiscriminatedUnion2((schema2, opts2) => schema2.json(parsed, opts2), schemas, opts);
    },
    getType: () => SchemaType2.UNDISCRIMINATED_UNION
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema)
  };
}
function validateAndTransformUndiscriminatedUnion2(transform3, schemas, opts) {
  const errors = [];
  for (const [index, schema2] of schemas.entries()) {
    const transformed = transform3(schema2, { ...opts, skipValidation: false });
    if (transformed.ok) {
      return transformed;
    } else {
      for (const error of transformed.errors) {
        errors.push({
          path: error.path,
          message: `[Variant ${index}] ${error.message}`
        });
      }
    }
  }
  return {
    ok: false,
    errors
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/union/discriminant.js
function discriminant2(parsedDiscriminant, rawDiscriminant) {
  return {
    parsedDiscriminant,
    rawDiscriminant
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/union/union.js
function union2(discriminant3, union3) {
  const rawDiscriminant = typeof discriminant3 === "string" ? discriminant3 : discriminant3.rawDiscriminant;
  const parsedDiscriminant = typeof discriminant3 === "string" ? discriminant3 : discriminant3.parsedDiscriminant;
  const discriminantValueSchema = enum_2(keys4(union3));
  const baseSchema = {
    parse: (raw, opts) => {
      return transformAndValidateUnion2({
        value: raw,
        discriminant: rawDiscriminant,
        transformedDiscriminant: parsedDiscriminant,
        transformDiscriminantValue: (discriminantValue) => discriminantValueSchema.parse(discriminantValue, {
          allowUnrecognizedEnumValues: opts?.allowUnrecognizedUnionMembers,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], rawDiscriminant]
        }),
        getAdditionalPropertiesSchema: (discriminantValue) => union3[discriminantValue],
        allowUnrecognizedUnionMembers: opts?.allowUnrecognizedUnionMembers,
        transformAdditionalProperties: (additionalProperties, additionalPropertiesSchema) => additionalPropertiesSchema.parse(additionalProperties, opts),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    json: (parsed, opts) => {
      return transformAndValidateUnion2({
        value: parsed,
        discriminant: parsedDiscriminant,
        transformedDiscriminant: rawDiscriminant,
        transformDiscriminantValue: (discriminantValue) => discriminantValueSchema.json(discriminantValue, {
          allowUnrecognizedEnumValues: opts?.allowUnrecognizedUnionMembers,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedDiscriminant]
        }),
        getAdditionalPropertiesSchema: (discriminantValue) => union3[discriminantValue],
        allowUnrecognizedUnionMembers: opts?.allowUnrecognizedUnionMembers,
        transformAdditionalProperties: (additionalProperties, additionalPropertiesSchema) => additionalPropertiesSchema.json(additionalProperties, opts),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    getType: () => SchemaType2.UNION
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema),
    ...getObjectLikeUtils2(baseSchema)
  };
}
function transformAndValidateUnion2({ value, discriminant: discriminant3, transformedDiscriminant, transformDiscriminantValue, getAdditionalPropertiesSchema, allowUnrecognizedUnionMembers = false, transformAdditionalProperties, breadcrumbsPrefix = [] }) {
  if (!isPlainObject4(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "object")
        }
      ]
    };
  }
  const { [discriminant3]: discriminantValue, ...additionalProperties } = value;
  if (discriminantValue == null) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: `Missing discriminant ("${discriminant3}")`
        }
      ]
    };
  }
  const transformedDiscriminantValue = transformDiscriminantValue(discriminantValue);
  if (!transformedDiscriminantValue.ok) {
    return {
      ok: false,
      errors: transformedDiscriminantValue.errors
    };
  }
  const additionalPropertiesSchema = getAdditionalPropertiesSchema(transformedDiscriminantValue.value);
  if (additionalPropertiesSchema == null) {
    if (allowUnrecognizedUnionMembers) {
      return {
        ok: true,
        value: {
          [transformedDiscriminant]: transformedDiscriminantValue.value,
          ...additionalProperties
        }
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: [...breadcrumbsPrefix, discriminant3],
            message: "Unexpected discriminant value"
          }
        ]
      };
    }
  }
  const transformedAdditionalProperties = transformAdditionalProperties(additionalProperties, additionalPropertiesSchema);
  if (!transformedAdditionalProperties.ok) {
    return transformedAdditionalProperties;
  }
  return {
    ok: true,
    value: {
      [transformedDiscriminant]: discriminantValue,
      ...transformedAdditionalProperties.value
    }
  };
}

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/WithDocsSchema.js
var WithDocsSchema2 = schemas_exports2.object({
  docs: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/AuthSchemeReferenceSchema.js
var AuthSchemeReferenceSchema2 = schemas_exports2.object({
  scheme: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/AnyAuthItem.js
var AnyAuthItem2 = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), AuthSchemeReferenceSchema2]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/AnyAuthSchemesSchema.js
var AnyAuthSchemesSchema2 = schemas_exports2.object({
  any: schemas_exports2.list(AnyAuthItem2)
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/ApiAuthSchema.js
var ApiAuthSchema2 = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  AuthSchemeReferenceSchema2,
  AnyAuthSchemesSchema2
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthAccessTokenRequestPropertiesSchema.js
var OAuthAccessTokenRequestPropertiesSchema2 = schemas_exports2.object({
  "client-id": schemas_exports2.string().optional(),
  "client-secret": schemas_exports2.string().optional(),
  scopes: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthAccessTokenResponsePropertiesSchema.js
var OAuthAccessTokenResponsePropertiesSchema2 = schemas_exports2.object({
  "access-token": schemas_exports2.string().optional(),
  "expires-in": schemas_exports2.string().optional(),
  "refresh-token": schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthGetTokenEndpointSchema.js
var OAuthGetTokenEndpointSchema2 = schemas_exports2.object({
  endpoint: schemas_exports2.string(),
  "request-properties": OAuthAccessTokenRequestPropertiesSchema2.optional(),
  "response-properties": OAuthAccessTokenResponsePropertiesSchema2.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthRefreshTokenRequestPropertiesSchema.js
var OAuthRefreshTokenRequestPropertiesSchema2 = schemas_exports2.object({
  "refresh-token": schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthRefreshTokenResponsePropertiesSchema.js
var OAuthRefreshTokenResponsePropertiesSchema2 = schemas_exports2.object({
  "access-token": schemas_exports2.string().optional(),
  "expires-in": schemas_exports2.string().optional(),
  "refresh-token": schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthRefreshTokenEndpointSchema.js
var OAuthRefreshTokenEndpointSchema2 = schemas_exports2.object({
  endpoint: schemas_exports2.string(),
  "request-properties": OAuthRefreshTokenRequestPropertiesSchema2.optional(),
  "response-properties": OAuthRefreshTokenResponsePropertiesSchema2.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthSchemeSchema.js
var OAuthSchemeSchema2 = schemas_exports2.object({
  scheme: schemas_exports2.stringLiteral("oauth"),
  type: schemas_exports2.stringLiteral("client-credentials"),
  scopes: schemas_exports2.list(schemas_exports2.string()).optional(),
  "client-id-env": schemas_exports2.string().optional(),
  "client-secret-env": schemas_exports2.string().optional(),
  "token-prefix": schemas_exports2.string().optional(),
  "token-header": schemas_exports2.string().optional(),
  "get-token": OAuthGetTokenEndpointSchema2,
  "refresh-token": OAuthRefreshTokenEndpointSchema2.optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/WithEnvironmentVariable.js
var WithEnvironmentVariable2 = schemas_exports2.object({
  env: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/WithName.js
var WithName2 = schemas_exports2.object({
  name: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/HeaderAuthSchemeSchema.js
var HeaderAuthSchemeSchema2 = schemas_exports2.object({
  header: schemas_exports2.string(),
  type: schemas_exports2.string().optional(),
  prefix: schemas_exports2.string().optional()
}).extend(WithEnvironmentVariable2).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/AuthVariable.js
var AuthVariable2 = schemas_exports2.object({}).extend(WithEnvironmentVariable2).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/BasicAuthSchemeSchema.js
var BasicAuthSchemeSchema2 = schemas_exports2.object({
  scheme: schemas_exports2.stringLiteral("basic"),
  username: AuthVariable2.optional(),
  password: AuthVariable2.optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/BearerAuthSchemeSchema.js
var BearerAuthSchemeSchema2 = schemas_exports2.object({
  scheme: schemas_exports2.stringLiteral("bearer"),
  token: AuthVariable2.optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/AuthSchemeDeclarationSchema.js
var AuthSchemeDeclarationSchema2 = schemas_exports2.undiscriminatedUnion([
  OAuthSchemeSchema2,
  HeaderAuthSchemeSchema2,
  BasicAuthSchemeSchema2,
  BearerAuthSchemeSchema2
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/WithAuthSchema.js
var WithAuthSchema = schemas_exports2.object({
  auth: ApiAuthSchema2.optional(),
  "auth-schemes": schemas_exports2.record(schemas_exports2.string(), AuthSchemeDeclarationSchema2).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/availability/index.js
var availability_exports4 = {};
__export(availability_exports4, {
  AvailabilitySchema: () => AvailabilitySchema2,
  AvailabilityStatusSchema: () => AvailabilityStatusSchema4,
  AvailabilityUnionSchema: () => AvailabilityUnionSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/availability/types/AvailabilityStatusSchema.js
var AvailabilityStatusSchema4 = schemas_exports2.enum_(["in-development", "pre-release", "deprecated", "generally-available"]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/availability/types/AvailabilitySchema.js
var AvailabilitySchema2 = schemas_exports2.object({
  status: AvailabilityStatusSchema4,
  message: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/availability/types/AvailabilityUnionSchema.js
var AvailabilityUnionSchema2 = schemas_exports2.undiscriminatedUnion([AvailabilityStatusSchema4, AvailabilitySchema2]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/index.js
var commons_exports5 = {};
__export(commons_exports5, {
  DeclarationSchema: () => DeclarationSchema,
  DeclarationWithNameSchema: () => DeclarationWithNameSchema,
  DeclarationWithoutDocsSchema: () => DeclarationWithoutDocsSchema,
  WithAudiences: () => WithAudiences2,
  WithAvailability: () => WithAvailability2,
  WithDisplayName: () => WithDisplayName,
  WithDocsSchema: () => WithDocsSchema2,
  WithName: () => WithName2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/WithAvailability.js
var WithAvailability2 = schemas_exports2.object({
  availability: AvailabilityUnionSchema2.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/WithDisplayName.js
var WithDisplayName = schemas_exports2.object({
  "display-name": schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/WithAudiences.js
var WithAudiences2 = schemas_exports2.object({
  audiences: schemas_exports2.list(schemas_exports2.string()).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/DeclarationSchema.js
var DeclarationSchema = schemas_exports2.object({}).extend(WithDocsSchema2).extend(WithAvailability2).extend(WithAudiences2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/DeclarationWithoutDocsSchema.js
var DeclarationWithoutDocsSchema = schemas_exports2.object({}).extend(WithAvailability2).extend(WithAudiences2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/DeclarationWithNameSchema.js
var DeclarationWithNameSchema = schemas_exports2.object({}).extend(DeclarationSchema).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/encoding/index.js
var encoding_exports4 = {};
__export(encoding_exports4, {
  EncodingSchema: () => EncodingSchema2,
  ProtobufTypeSchema: () => ProtobufTypeSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/encoding/types/ProtobufTypeSchema.js
var ProtobufTypeSchema2 = schemas_exports2.object({
  type: schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/encoding/types/EncodingSchema.js
var EncodingSchema2 = schemas_exports2.object({
  proto: ProtobufTypeSchema2.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/environments/index.js
var environments_exports4 = {};
__export(environments_exports4, {
  EnvironmentSchema: () => EnvironmentSchema2,
  MultipleBaseUrlsEnvironmentSchema: () => MultipleBaseUrlsEnvironmentSchema2,
  SingleBaseUrlEnvironmentSchema: () => SingleBaseUrlEnvironmentSchema2,
  WithEnvironmentsSchema: () => WithEnvironmentsSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/environments/types/SingleBaseUrlEnvironmentSchema.js
var SingleBaseUrlEnvironmentSchema2 = schemas_exports2.object({
  url: schemas_exports2.string()
}).extend(WithAudiences2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/environments/types/MultipleBaseUrlsEnvironmentSchema.js
var MultipleBaseUrlsEnvironmentSchema2 = schemas_exports2.object({
  urls: schemas_exports2.record(schemas_exports2.string(), schemas_exports2.string())
}).extend(WithAudiences2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/environments/types/EnvironmentSchema.js
var EnvironmentSchema2 = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  SingleBaseUrlEnvironmentSchema2,
  MultipleBaseUrlsEnvironmentSchema2
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/environments/types/WithEnvironmentsSchema.js
var WithEnvironmentsSchema2 = schemas_exports2.object({
  "default-url": schemas_exports2.string().optional(),
  "default-environment": schemas_exports2.string().optional(),
  environments: schemas_exports2.record(schemas_exports2.string(), EnvironmentSchema2).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/errors/index.js
var errors_exports3 = {};
__export(errors_exports3, {
  ErrorDeclarationSchema: () => ErrorDeclarationSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleTypeValueSchema.js
var ExampleTypeValueSchema = schemas_exports2.unknown();

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleTypeSchema.js
var ExampleTypeSchema = schemas_exports2.object({
  value: ExampleTypeValueSchema
}).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/errors/types/ErrorDeclarationSchema.js
var ErrorDeclarationSchema = schemas_exports2.object({
  "status-code": schemas_exports2.number(),
  type: schemas_exports2.string().optional(),
  examples: schemas_exports2.list(ExampleTypeSchema).optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/index.js
var examples_exports3 = {};
__export(examples_exports3, {
  ExampleBodyResponseSchema: () => ExampleBodyResponseSchema,
  ExampleCodeSampleSchema: () => ExampleCodeSampleSchema,
  ExampleCodeSampleSchemaLanguage: () => ExampleCodeSampleSchemaLanguage,
  ExampleCodeSampleSchemaSdk: () => ExampleCodeSampleSchemaSdk,
  ExampleEndpointCallArraySchema: () => ExampleEndpointCallArraySchema,
  ExampleEndpointCallSchema: () => ExampleEndpointCallSchema,
  ExampleResponseSchema: () => ExampleResponseSchema,
  ExampleSseEventSchema: () => ExampleSseEventSchema,
  ExampleSseResponseSchema: () => ExampleSseResponseSchema,
  ExampleStreamResponseSchema: () => ExampleStreamResponseSchema,
  ExampleTypeReferenceSchema: () => ExampleTypeReferenceSchema,
  ExampleTypeSchema: () => ExampleTypeSchema,
  ExampleTypeValueSchema: () => ExampleTypeValueSchema,
  ExampleWebSocketMessage: () => ExampleWebSocketMessage,
  ExampleWebSocketSession: () => ExampleWebSocketSession,
  ExampleWebhookCallSchema: () => ExampleWebhookCallSchema,
  SupportedSdkLanguageSchema: () => SupportedSdkLanguageSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleTypeReferenceSchema.js
var ExampleTypeReferenceSchema = schemas_exports2.unknown();

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleWebSocketMessage.js
var ExampleWebSocketMessage = schemas_exports2.object({
  type: schemas_exports2.string(),
  body: schemas_exports2.unknown()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleWebSocketSession.js
var ExampleWebSocketSession = schemas_exports2.object({
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  "query-parameters": schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  headers: schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  messages: schemas_exports2.list(ExampleWebSocketMessage)
}).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleBodyResponseSchema.js
var ExampleBodyResponseSchema = schemas_exports2.object({
  error: schemas_exports2.string().optional(),
  body: ExampleTypeReferenceSchema.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleStreamResponseSchema.js
var ExampleStreamResponseSchema = schemas_exports2.object({
  stream: schemas_exports2.list(ExampleTypeReferenceSchema)
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleSseEventSchema.js
var ExampleSseEventSchema = schemas_exports2.object({
  event: schemas_exports2.string(),
  data: ExampleTypeReferenceSchema.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleSseResponseSchema.js
var ExampleSseResponseSchema = schemas_exports2.object({
  stream: schemas_exports2.list(ExampleSseEventSchema)
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleResponseSchema.js
var ExampleResponseSchema = schemas_exports2.undiscriminatedUnion([
  ExampleBodyResponseSchema,
  ExampleStreamResponseSchema,
  ExampleSseResponseSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/SupportedSdkLanguageSchema.js
var SupportedSdkLanguageSchema2 = schemas_exports2.enum_([
  "curl",
  "python",
  "javascript",
  "typescript",
  "go",
  "ruby",
  "csharp",
  "java",
  "js",
  "node",
  "ts",
  "nodets",
  "golang",
  "dotnet",
  "jvm",
  "c#"
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleCodeSampleSchemaSdk.js
var ExampleCodeSampleSchemaSdk = schemas_exports2.object({
  sdk: SupportedSdkLanguageSchema2,
  code: schemas_exports2.string()
}).extend(WithDocsSchema2).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleCodeSampleSchemaLanguage.js
var ExampleCodeSampleSchemaLanguage = schemas_exports2.object({
  language: schemas_exports2.string(),
  code: schemas_exports2.string(),
  install: schemas_exports2.string().optional()
}).extend(WithDocsSchema2).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleCodeSampleSchema.js
var ExampleCodeSampleSchema = schemas_exports2.undiscriminatedUnion([ExampleCodeSampleSchemaSdk, ExampleCodeSampleSchemaLanguage]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleEndpointCallSchema.js
var ExampleEndpointCallSchema = schemas_exports2.object({
  id: schemas_exports2.string().optional(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  "query-parameters": schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  headers: schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  request: ExampleTypeReferenceSchema.optional(),
  response: ExampleResponseSchema.optional(),
  "code-samples": schemas_exports2.list(ExampleCodeSampleSchema).optional()
}).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleEndpointCallArraySchema.js
var ExampleEndpointCallArraySchema = schemas_exports2.list(ExampleEndpointCallSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleWebhookCallSchema.js
var ExampleWebhookCallSchema = schemas_exports2.object({
  id: schemas_exports2.string().optional(),
  payload: ExampleTypeReferenceSchema
}).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/index.js
var file_exports4 = {};
__export(file_exports4, {
  DefinitionFileSchema: () => DefinitionFileSchema,
  ErrorDiscriminationSchema: () => ErrorDiscriminationSchema,
  Export: () => Export,
  ExportDetailed: () => ExportDetailed,
  Navigation: () => Navigation,
  PackageMarkerFileSchema: () => PackageMarkerFileSchema,
  PropertyBasedErrorDiscrimination: () => PropertyBasedErrorDiscrimination,
  RootApiFileSchema: () => RootApiFileSchema,
  StatusCodeBasedErrorDiscrimination: () => StatusCodeBasedErrorDiscrimination,
  WithHeadersSchema: () => WithHeadersSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/ObjectExtendsSchema.js
var ObjectExtendsSchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  schemas_exports2.list(schemas_exports2.string())
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/validation/types/StringValidationSchema.js
var StringValidationSchema2 = schemas_exports2.object({
  minLength: schemas_exports2.number().optional(),
  maxLength: schemas_exports2.number().optional(),
  pattern: schemas_exports2.string().optional(),
  format: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/validation/types/NumberValidationSchema.js
var NumberValidationSchema2 = schemas_exports2.object({
  min: schemas_exports2.number().optional(),
  max: schemas_exports2.number().optional(),
  exclusiveMin: schemas_exports2.boolean().optional(),
  exclusiveMax: schemas_exports2.boolean().optional(),
  multipleOf: schemas_exports2.number().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/validation/types/ValidationSchema.js
var ValidationSchema2 = schemas_exports2.undiscriminatedUnion([StringValidationSchema2, NumberValidationSchema2]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/BaseTypeReferenceSchema.js
var BaseTypeReferenceSchema2 = schemas_exports2.object({
  default: schemas_exports2.unknown().optional(),
  encoding: EncodingSchema2.optional(),
  validation: ValidationSchema2.optional()
}).extend(WithDocsSchema2).extend(WithAvailability2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/TypeReferenceDeclarationWithName.js
var TypeReferenceDeclarationWithName2 = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(BaseTypeReferenceSchema2).extend(WithName2).extend(WithAudiences2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/TypeReferenceDeclarationWithNameSchema.js
var TypeReferenceDeclarationWithNameSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), TypeReferenceDeclarationWithName2]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/ObjectPropertySchema.js
var ObjectPropertySchema = TypeReferenceDeclarationWithNameSchema;

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/source/types/OpenApiSourceSchema.js
var OpenApiSourceSchema = schemas_exports2.object({
  openapi: schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/source/types/ProtobufSourceSchema.js
var ProtobufSourceSchema = schemas_exports2.object({
  proto: schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/source/types/SourceSchema.js
var SourceSchema = schemas_exports2.undiscriminatedUnion([OpenApiSourceSchema, ProtobufSourceSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/BaseTypeDeclarationSchema.js
var BaseTypeDeclarationSchema = schemas_exports2.object({
  examples: schemas_exports2.list(ExampleTypeSchema).optional(),
  encoding: EncodingSchema2.optional(),
  source: SourceSchema.optional(),
  inline: schemas_exports2.boolean().optional()
}).extend(WithDocsSchema2).extend(WithAvailability2).extend(WithAudiences2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/ObjectSchema.js
var ObjectSchema = schemas_exports2.object({
  extends: ObjectExtendsSchema.optional(),
  properties: schemas_exports2.record(schemas_exports2.string(), ObjectPropertySchema).optional(),
  "extra-properties": schemas_exports2.boolean().optional()
}).extend(BaseTypeDeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/CasingOverridesSchema.js
var CasingOverridesSchema = schemas_exports2.object({
  camel: schemas_exports2.string().optional(),
  snake: schemas_exports2.string().optional(),
  pascal: schemas_exports2.string().optional(),
  "screaming-snake": schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/EnumValueSchema.js
var EnumValueSchema = schemas_exports2.object({
  value: schemas_exports2.string(),
  casing: CasingOverridesSchema.optional()
}).extend(WithDocsSchema2).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/EnumValue.js
var EnumValue = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), EnumValueSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/EnumSchema.js
var EnumSchema = schemas_exports2.object({
  default: schemas_exports2.string().optional(),
  enum: schemas_exports2.list(EnumValue)
}).extend(BaseTypeDeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/UnionDiscriminantSchema.js
var UnionDiscriminantSchema = schemas_exports2.object({
  value: schemas_exports2.string()
}).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/UnionDiscriminant.js
var UnionDiscriminant = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), UnionDiscriminantSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/TypeReferenceDetailedSchema.js
var TypeReferenceDetailedSchema = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(BaseTypeReferenceSchema2).extend(WithName2).extend(WithAudiences2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/TypeReferenceSchema.js
var TypeReferenceSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), TypeReferenceDetailedSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUnionTypeKeySchema.js
var SingleUnionTypeKeySchema = schemas_exports2.object({
  value: schemas_exports2.string()
}).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUnionTypeKey.js
var SingleUnionTypeKey = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), SingleUnionTypeKeySchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUnionTypeDetailedSchema.js
var SingleUnionTypeDetailedSchema = schemas_exports2.object({
  type: schemas_exports2.string().optional(),
  key: SingleUnionTypeKey.optional()
}).extend(WithDocsSchema2).extend(WithName2).extend(WithAvailability2).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUnionTypeSchema.js
var SingleUnionTypeSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), SingleUnionTypeDetailedSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/DiscriminatedUnionSchema.js
var DiscriminatedUnionSchema = schemas_exports2.object({
  discriminant: UnionDiscriminant.optional(),
  extends: ObjectExtendsSchema.optional(),
  "base-properties": schemas_exports2.record(schemas_exports2.string(), TypeReferenceSchema).optional(),
  union: schemas_exports2.record(schemas_exports2.string(), SingleUnionTypeSchema)
}).extend(BaseTypeDeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUndiscriminatedUnionTypeDetailedSchema.js
var SingleUndiscriminatedUnionTypeDetailedSchema = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(WithDocsSchema2).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUndiscriminatedUnionTypeSchema.js
var SingleUndiscriminatedUnionTypeSchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  SingleUndiscriminatedUnionTypeDetailedSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/UndiscriminatedUnionSchema.js
var UndiscriminatedUnionSchema = schemas_exports2.object({
  discriminated: schemas_exports2.booleanLiteral(false),
  union: schemas_exports2.list(SingleUndiscriminatedUnionTypeSchema)
}).extend(BaseTypeDeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/AliasSchema.js
var AliasSchema = schemas_exports2.object({
  type: schemas_exports2.string(),
  validation: ValidationSchema2.optional()
}).extend(BaseTypeDeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/TypeDeclarationSchema.js
var TypeDeclarationSchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  ObjectSchema,
  EnumSchema,
  DiscriminatedUnionSchema,
  UndiscriminatedUnionSchema,
  AliasSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/GrpcTransport.js
var GrpcTransport = schemas_exports2.object({
  "service-name": schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/ServiceTransport.js
var ServiceTransport = schemas_exports2.object({
  grpc: GrpcTransport.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpMethodSchema.js
var HttpMethodSchema2 = schemas_exports2.enum_(["GET", "POST", "PUT", "PATCH", "DELETE"]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/variables/types/VariableReferenceSchema.js
var VariableReferenceSchema = schemas_exports2.object({
  variable: schemas_exports2.string()
}).extend(WithAvailability2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpPathParameterSchema.js
var HttpPathParameterSchema = schemas_exports2.undiscriminatedUnion([TypeReferenceSchema, VariableReferenceSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/QueryParameterTypeReferenceDetailed.js
var QueryParameterTypeReferenceDetailed = schemas_exports2.object({
  "allow-multiple": schemas_exports2.boolean().optional()
}).extend(TypeReferenceDeclarationWithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpQueryParameterSchema.js
var HttpQueryParameterSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), QueryParameterTypeReferenceDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/TypeReferenceDeclarationWithEnvOverrideSchema.js
var TypeReferenceDeclarationWithEnvOverrideSchema2 = schemas_exports2.object({
  env: schemas_exports2.string().optional()
}).extend(TypeReferenceDeclarationWithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/TypeReferenceDeclarationWithEnvOverride.js
var TypeReferenceDeclarationWithEnvOverride2 = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  TypeReferenceDeclarationWithEnvOverrideSchema2
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpHeaderSchema.js
var HttpHeaderSchema2 = TypeReferenceDeclarationWithEnvOverride2;

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpReferencedRequestBodySchema.js
var HttpReferencedRequestBodySchema = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/TypeReferenceDeclarationWithContentTypeSchema.js
var TypeReferenceDeclarationWithContentTypeSchema = schemas_exports2.object({
  "content-type": schemas_exports2.string().optional()
}).extend(TypeReferenceDeclarationWithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpInlineRequestBodyPropertySchema.js
var HttpInlineRequestBodyPropertySchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  TypeReferenceDeclarationWithContentTypeSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpInlineRequestBodySchema.js
var HttpInlineRequestBodySchema = schemas_exports2.object({
  extends: ObjectExtendsSchema.optional(),
  "extra-properties": schemas_exports2.boolean().optional(),
  properties: schemas_exports2.record(schemas_exports2.string(), HttpInlineRequestBodyPropertySchema).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpRequestBodySchema.js
var HttpRequestBodySchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  HttpReferencedRequestBodySchema,
  HttpInlineRequestBodySchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpRequestSchema.js
var HttpRequestSchema = schemas_exports2.object({
  "content-type": schemas_exports2.string().optional(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), HttpPathParameterSchema).optional(),
  "query-parameters": schemas_exports2.record(schemas_exports2.string(), HttpQueryParameterSchema).optional(),
  headers: schemas_exports2.record(schemas_exports2.string(), HttpHeaderSchema2).optional(),
  body: HttpRequestBodySchema.optional()
}).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpRequest.js
var HttpRequest = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), HttpRequestSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpResponseSchemaDetailed.js
var HttpResponseSchemaDetailed = schemas_exports2.object({
  type: schemas_exports2.string(),
  property: schemas_exports2.string().optional(),
  "status-code": schemas_exports2.number().optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpResponseSchema.js
var HttpResponseSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), HttpResponseSchemaDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/StreamFormat.js
var StreamFormat2 = schemas_exports2.enum_(["sse", "json"]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpResponseStreamSchemaDetailed.js
var HttpResponseStreamSchemaDetailed = schemas_exports2.object({
  type: schemas_exports2.string(),
  format: StreamFormat2.optional(),
  terminator: schemas_exports2.string().optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpResponseStreamSchema.js
var HttpResponseStreamSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), HttpResponseStreamSchemaDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/ResponseErrorWithDocsSchema.js
var ResponseErrorWithDocsSchema = schemas_exports2.object({
  error: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/ResponseError.js
var ResponseError = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), ResponseErrorWithDocsSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/ResponseErrorsSchema.js
var ResponseErrorsSchema = schemas_exports2.list(ResponseError);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/pagination/types/CursorPaginationSchema.js
var CursorPaginationSchema = schemas_exports2.object({
  cursor: schemas_exports2.string(),
  next_cursor: schemas_exports2.string(),
  results: schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/pagination/types/OffsetPaginationSchema.js
var OffsetPaginationSchema = schemas_exports2.object({
  offset: schemas_exports2.string(),
  results: schemas_exports2.string(),
  step: schemas_exports2.string().optional(),
  "has-next-page": schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/pagination/types/PaginationSchema.js
var PaginationSchema = schemas_exports2.undiscriminatedUnion([CursorPaginationSchema, OffsetPaginationSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/Pagination.js
var Pagination2 = schemas_exports2.undiscriminatedUnion([PaginationSchema, schemas_exports2.boolean()]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpEndpointSchema.js
var HttpEndpointSchema = schemas_exports2.object({
  method: HttpMethodSchema2.optional(),
  "base-path": schemas_exports2.string().optional(),
  path: schemas_exports2.string(),
  url: schemas_exports2.string().optional(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), HttpPathParameterSchema).optional(),
  auth: schemas_exports2.boolean().optional(),
  idempotent: schemas_exports2.boolean().optional(),
  "stream-condition": schemas_exports2.string().optional(),
  request: HttpRequest.optional(),
  response: HttpResponseSchema.optional(),
  "response-stream": HttpResponseStreamSchema.optional(),
  errors: ResponseErrorsSchema.optional(),
  examples: schemas_exports2.list(ExampleEndpointCallSchema).optional(),
  pagination: Pagination2.optional(),
  transport: ServiceTransport.optional(),
  source: SourceSchema.optional()
}).extend(WithDisplayName).extend(DeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpServiceSchema.js
var HttpServiceSchema = schemas_exports2.object({
  auth: schemas_exports2.boolean(),
  url: schemas_exports2.string().optional(),
  "base-path": schemas_exports2.string(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), schemas_exports2.string()).optional(),
  idempotent: schemas_exports2.boolean().optional(),
  headers: schemas_exports2.record(schemas_exports2.string(), TypeReferenceSchema).optional(),
  transport: ServiceTransport.optional(),
  source: SourceSchema.optional(),
  endpoints: schemas_exports2.record(schemas_exports2.string(), HttpEndpointSchema)
}).extend(DeclarationWithoutDocsSchema).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/types/WebhookMethodSchema.js
var WebhookMethodSchema2 = schemas_exports2.enum_(["POST", "GET"]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/types/WebhookReferencedPayloadSchema.js
var WebhookReferencedPayloadSchema = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/types/WebhookInlinedPayloadSchema.js
var WebhookInlinedPayloadSchema = schemas_exports2.object({
  name: schemas_exports2.string(),
  extends: ObjectExtendsSchema.optional(),
  properties: schemas_exports2.record(schemas_exports2.string(), ObjectPropertySchema).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/types/WebhookPayloadSchema.js
var WebhookPayloadSchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  WebhookReferencedPayloadSchema,
  WebhookInlinedPayloadSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/types/WebhookSchema.js
var WebhookSchema = schemas_exports2.object({
  method: WebhookMethodSchema2,
  headers: schemas_exports2.record(schemas_exports2.string(), HttpHeaderSchema2).optional(),
  payload: WebhookPayloadSchema,
  examples: schemas_exports2.list(ExampleWebhookCallSchema).optional()
}).extend(WithAvailability2).extend(WithAudiences2).extend(WithDocsSchema2).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketOrigin.js
var WebSocketOrigin2 = schemas_exports2.enum_(["client", "server"]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketChannelReferencedMessageSchema.js
var WebSocketChannelReferencedMessageSchema = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketChannelInlinedMessageSchema.js
var WebSocketChannelInlinedMessageSchema = schemas_exports2.object({
  name: schemas_exports2.string(),
  extends: ObjectExtendsSchema.optional(),
  properties: schemas_exports2.record(schemas_exports2.string(), ObjectPropertySchema).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketChannelMessageBodySchema.js
var WebSocketChannelMessageBodySchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  WebSocketChannelReferencedMessageSchema,
  WebSocketChannelInlinedMessageSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketChannelMessageSchema.js
var WebSocketChannelMessageSchema = schemas_exports2.object({
  origin: WebSocketOrigin2,
  body: WebSocketChannelMessageBodySchema
}).extend(DeclarationSchema).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketChannelSchema.js
var WebSocketChannelSchema = schemas_exports2.object({
  auth: schemas_exports2.boolean(),
  path: schemas_exports2.string(),
  headers: schemas_exports2.record(schemas_exports2.string(), HttpHeaderSchema2).optional(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), HttpPathParameterSchema).optional(),
  "query-parameters": schemas_exports2.record(schemas_exports2.string(), HttpQueryParameterSchema).optional(),
  messages: schemas_exports2.record(schemas_exports2.string(), WebSocketChannelMessageSchema).optional(),
  examples: schemas_exports2.list(ExampleWebSocketSession).optional()
}).extend(DeclarationSchema).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/DefinitionFileSchema.js
var DefinitionFileSchema = schemas_exports2.object({
  imports: schemas_exports2.record(schemas_exports2.string(), schemas_exports2.string()).optional(),
  types: schemas_exports2.record(schemas_exports2.string(), TypeDeclarationSchema).optional(),
  service: HttpServiceSchema.optional(),
  errors: schemas_exports2.record(schemas_exports2.string(), ErrorDeclarationSchema).optional(),
  webhooks: schemas_exports2.record(schemas_exports2.string(), WebhookSchema).optional(),
  channel: WebSocketChannelSchema.optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/Navigation.js
var Navigation = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  schemas_exports2.list(schemas_exports2.string())
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/ExportDetailed.js
var ExportDetailed = schemas_exports2.object({
  dependency: schemas_exports2.string(),
  url: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/Export.js
var Export = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), ExportDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/PackageMarkerFileSchema.js
var PackageMarkerFileSchema = schemas_exports2.object({
  navigation: Navigation.optional(),
  export: Export.optional()
}).extend(DefinitionFileSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/WithHeadersSchema.js
var WithHeadersSchema2 = schemas_exports2.object({
  headers: schemas_exports2.record(schemas_exports2.string(), HttpHeaderSchema2).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/PropertyBasedErrorDiscrimination.js
var PropertyBasedErrorDiscrimination = schemas_exports2.object({
  strategy: schemas_exports2.stringLiteral("property"),
  "property-name": schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/StatusCodeBasedErrorDiscrimination.js
var StatusCodeBasedErrorDiscrimination = schemas_exports2.object({
  strategy: schemas_exports2.stringLiteral("status-code")
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/ErrorDiscriminationSchema.js
var ErrorDiscriminationSchema = schemas_exports2.undiscriminatedUnion([PropertyBasedErrorDiscrimination, StatusCodeBasedErrorDiscrimination]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/variables/types/VariableDeclarationDetailed.js
var VariableDeclarationDetailed = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/variables/types/VariableDeclarationSchema.js
var VariableDeclarationSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), VariableDeclarationDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/types/VersionValueDetailed.js
var VersionValueDetailed = schemas_exports2.object({
  value: schemas_exports2.string()
}).extend(WithDocsSchema2).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/types/VersionValue.js
var VersionValue = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), VersionValueDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/types/VersionDeclarationHeaderObjectSchema.js
var VersionDeclarationHeaderObjectSchema = schemas_exports2.object({
  name: schemas_exports2.string().optional(),
  env: schemas_exports2.string().optional(),
  value: schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/types/VersionDeclarationHeaderSchema.js
var VersionDeclarationHeaderSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), VersionDeclarationHeaderObjectSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/types/VersionDeclarationSchema.js
var VersionDeclarationSchema = schemas_exports2.object({
  default: schemas_exports2.string().optional(),
  values: schemas_exports2.list(VersionValue),
  header: VersionDeclarationHeaderSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/RootApiFileSchema.js
var RootApiFileSchema = schemas_exports2.object({
  name: schemas_exports2.string(),
  imports: schemas_exports2.record(schemas_exports2.string(), schemas_exports2.string()).optional(),
  "error-discrimination": ErrorDiscriminationSchema.optional(),
  audiences: schemas_exports2.list(schemas_exports2.string()).optional(),
  errors: schemas_exports2.list(schemas_exports2.string()).optional(),
  "base-path": schemas_exports2.string().optional(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), HttpPathParameterSchema).optional(),
  "idempotency-headers": schemas_exports2.record(schemas_exports2.string(), HttpHeaderSchema2).optional(),
  variables: schemas_exports2.record(schemas_exports2.string(), VariableDeclarationSchema).optional(),
  pagination: PaginationSchema.optional(),
  version: VersionDeclarationSchema.optional()
}).extend(WithDocsSchema2).extend(WithDisplayName).extend(WithEnvironmentsSchema2).extend(WithAuthSchema).extend(WithHeadersSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/pagination/index.js
var pagination_exports2 = {};
__export(pagination_exports2, {
  CursorPaginationSchema: () => CursorPaginationSchema,
  OffsetPaginationSchema: () => OffsetPaginationSchema,
  PaginationSchema: () => PaginationSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/index.js
var service_exports4 = {};
__export(service_exports4, {
  GrpcTransport: () => GrpcTransport,
  HttpEndpointSchema: () => HttpEndpointSchema,
  HttpHeaderSchema: () => HttpHeaderSchema2,
  HttpInlineRequestBodyPropertySchema: () => HttpInlineRequestBodyPropertySchema,
  HttpInlineRequestBodySchema: () => HttpInlineRequestBodySchema,
  HttpMethodSchema: () => HttpMethodSchema2,
  HttpPathParameterSchema: () => HttpPathParameterSchema,
  HttpQueryParameterSchema: () => HttpQueryParameterSchema,
  HttpReferencedRequestBodySchema: () => HttpReferencedRequestBodySchema,
  HttpRequest: () => HttpRequest,
  HttpRequestBodySchema: () => HttpRequestBodySchema,
  HttpRequestSchema: () => HttpRequestSchema,
  HttpResponseSchema: () => HttpResponseSchema,
  HttpResponseSchemaDetailed: () => HttpResponseSchemaDetailed,
  HttpResponseStreamSchema: () => HttpResponseStreamSchema,
  HttpResponseStreamSchemaDetailed: () => HttpResponseStreamSchemaDetailed,
  HttpServiceSchema: () => HttpServiceSchema,
  Pagination: () => Pagination2,
  QueryParameterTypeReferenceDetailed: () => QueryParameterTypeReferenceDetailed,
  ResponseError: () => ResponseError,
  ResponseErrorWithDocsSchema: () => ResponseErrorWithDocsSchema,
  ResponseErrorsSchema: () => ResponseErrorsSchema,
  ServiceTransport: () => ServiceTransport,
  StreamFormat: () => StreamFormat2,
  TypeReferenceDeclarationWithContentTypeSchema: () => TypeReferenceDeclarationWithContentTypeSchema,
  TypeReferenceDeclarationWithEnvOverride: () => TypeReferenceDeclarationWithEnvOverride2,
  TypeReferenceDeclarationWithEnvOverrideSchema: () => TypeReferenceDeclarationWithEnvOverrideSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/source/index.js
var source_exports2 = {};
__export(source_exports2, {
  OpenApiSourceSchema: () => OpenApiSourceSchema,
  ProtobufSourceSchema: () => ProtobufSourceSchema,
  SourceSchema: () => SourceSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/index.js
var types_exports6 = {};
__export(types_exports6, {
  AliasSchema: () => AliasSchema,
  BaseTypeDeclarationSchema: () => BaseTypeDeclarationSchema,
  BaseTypeReferenceSchema: () => BaseTypeReferenceSchema2,
  CasingOverridesSchema: () => CasingOverridesSchema,
  DiscriminatedUnionSchema: () => DiscriminatedUnionSchema,
  EnumSchema: () => EnumSchema,
  EnumValue: () => EnumValue,
  EnumValueSchema: () => EnumValueSchema,
  ObjectExtendsSchema: () => ObjectExtendsSchema,
  ObjectPropertySchema: () => ObjectPropertySchema,
  ObjectSchema: () => ObjectSchema,
  SingleUndiscriminatedUnionTypeDetailedSchema: () => SingleUndiscriminatedUnionTypeDetailedSchema,
  SingleUndiscriminatedUnionTypeSchema: () => SingleUndiscriminatedUnionTypeSchema,
  SingleUnionTypeDetailedSchema: () => SingleUnionTypeDetailedSchema,
  SingleUnionTypeKey: () => SingleUnionTypeKey,
  SingleUnionTypeKeySchema: () => SingleUnionTypeKeySchema,
  SingleUnionTypeSchema: () => SingleUnionTypeSchema,
  TypeDeclarationSchema: () => TypeDeclarationSchema,
  TypeReferenceDeclarationWithName: () => TypeReferenceDeclarationWithName2,
  TypeReferenceDeclarationWithNameSchema: () => TypeReferenceDeclarationWithNameSchema,
  TypeReferenceDetailedSchema: () => TypeReferenceDetailedSchema,
  TypeReferenceSchema: () => TypeReferenceSchema,
  UndiscriminatedUnionSchema: () => UndiscriminatedUnionSchema,
  UnionDiscriminant: () => UnionDiscriminant,
  UnionDiscriminantSchema: () => UnionDiscriminantSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/validation/index.js
var validation_exports4 = {};
__export(validation_exports4, {
  NumberValidationSchema: () => NumberValidationSchema2,
  StringValidationSchema: () => StringValidationSchema2,
  ValidationSchema: () => ValidationSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/variables/index.js
var variables_exports3 = {};
__export(variables_exports3, {
  VariableDeclarationDetailed: () => VariableDeclarationDetailed,
  VariableDeclarationSchema: () => VariableDeclarationSchema,
  VariableReferenceSchema: () => VariableReferenceSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/index.js
var versioning_exports2 = {};
__export(versioning_exports2, {
  VersionDeclarationHeaderObjectSchema: () => VersionDeclarationHeaderObjectSchema,
  VersionDeclarationHeaderSchema: () => VersionDeclarationHeaderSchema,
  VersionDeclarationSchema: () => VersionDeclarationSchema,
  VersionValue: () => VersionValue,
  VersionValueDetailed: () => VersionValueDetailed
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/index.js
var webhooks_exports3 = {};
__export(webhooks_exports3, {
  WebhookInlinedPayloadSchema: () => WebhookInlinedPayloadSchema,
  WebhookMethodSchema: () => WebhookMethodSchema2,
  WebhookPayloadSchema: () => WebhookPayloadSchema,
  WebhookReferencedPayloadSchema: () => WebhookReferencedPayloadSchema,
  WebhookSchema: () => WebhookSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/index.js
var websocket_exports3 = {};
__export(websocket_exports3, {
  WebSocketChannelInlinedMessageSchema: () => WebSocketChannelInlinedMessageSchema,
  WebSocketChannelMessageBodySchema: () => WebSocketChannelMessageBodySchema,
  WebSocketChannelMessageSchema: () => WebSocketChannelMessageSchema,
  WebSocketChannelReferencedMessageSchema: () => WebSocketChannelReferencedMessageSchema,
  WebSocketChannelSchema: () => WebSocketChannelSchema,
  WebSocketOrigin: () => WebSocketOrigin2
});

// ../../cli/fern-definition/schema/lib/schemas/errors/FernDefinitionError.js
var FernDefinitionError = class _FernDefinitionError extends Error {
  statusCode;
  body;
  constructor({ message, statusCode, body }) {
    super(buildMessage({ message, statusCode, body }));
    Object.setPrototypeOf(this, _FernDefinitionError.prototype);
    if (statusCode != null) {
      this.statusCode = statusCode;
    }
    if (body !== void 0) {
      this.body = body;
    }
  }
};
function buildMessage({ message, statusCode, body }) {
  let lines = [];
  if (message != null) {
    lines.push(message);
  }
  if (statusCode != null) {
    lines.push(`Status code: ${statusCode.toString()}`);
  }
  if (body != null) {
    lines.push(`Body: ${JSON.stringify(body, void 0, 2)}`);
  }
  return lines.join("\n");
}

// ../../cli/fern-definition/schema/lib/schemas/errors/FernDefinitionTimeoutError.js
var FernDefinitionTimeoutError = class _FernDefinitionTimeoutError extends Error {
  constructor() {
    super("Timeout");
    Object.setPrototypeOf(this, _FernDefinitionTimeoutError.prototype);
  }
};

// ../../cli/fern-definition/schema/lib/utils/RawContainerType.js
var RawContainerType = {
  optional: "optional",
  set: "set",
  list: "list",
  map: "map",
  literal: "literal"
};
var RawContainerTypes = new Set(Object.values(RawContainerType));

// ../../cli/fern-definition/schema/lib/utils/generics/parseGeneric.js
function parseGeneric(name) {
  const genericMatch = name.match(/([\w.]+)<([\w,\s]+)>/);
  if (genericMatch?.[0] != null && genericMatch[1] != null && genericMatch[2] != null && !RawContainerTypes.has(genericMatch[1].trim())) {
    return {
      name: genericMatch[1].trim(),
      arguments: genericMatch[2].split(",").map((arg) => arg.trim())
    };
  }
  return void 0;
}

// ../../cli/fern-definition/schema/lib/utils/generics/isGeneric.js
function isGeneric(name) {
  return parseGeneric(name) != null;
}

// ../../cli/fern-definition/schema/lib/utils/isInlineRequestBody.js
function isInlineRequestBody(requestBody) {
  if (typeof requestBody === "string") {
    return false;
  }
  return (
    // eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
    requestBody?.extends != null || // eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
    requestBody?.properties != null
  );
}

// ../../cli/fern-definition/schema/lib/utils/isRawProtobufSourceSchema.js
function isRawProtobufSourceSchema(rawSourceSchema) {
  if (!rawSourceSchema) {
    return false;
  }
  return rawSourceSchema.proto != null;
}

// ../../cli/fern-definition/schema/lib/utils/isRawTextType.js
var TEXT_TYPE = "text";
function isRawTextType(typeReference) {
  return typeReference === TEXT_TYPE;
}

// ../../cli/fern-definition/schema/lib/utils/RawPrimitiveType.js
var RawPrimitiveType = {
  integer: "integer",
  long: "long",
  uint: "uint",
  uint64: "uint64",
  float: "float",
  double: "double",
  boolean: "boolean",
  string: "string",
  datetime: "datetime",
  base64: "base64",
  uuid: "uuid",
  date: "date",
  bigint: "bigint",
  unknown: "unknown"
};

// ../../cli/fern-definition/schema/lib/utils/visitRawTypeReference.js
var FernContainerRegex = {
  MAP: /^map<\s*([^,]*)\s*,\s*(.*)\s*>$/,
  LIST: /^list<\s*(.*)\s*>$/,
  SET: /^set<\s*(.*)\s*>$/,
  OPTIONAL: /^optional<\s*(.*)\s*>$/,
  LITERAL: /^literal<\s*(?:"(.*)"|(true|false))\s*>$/
};
function visitRawTypeReference({ type: type2, _default: _default2, validation, visitor }) {
  switch (type2) {
    case RawPrimitiveType.integer: {
      const maybeNumberValidation2 = validation != null ? validation : void 0;
      return visitor.primitive({
        v1: PrimitiveTypeV1.Integer,
        v2: PrimitiveTypeV2.integer({
          default: _default2 != null ? _default2 : void 0,
          validation: maybeNumberValidation2 != null ? {
            min: maybeNumberValidation2.min,
            max: maybeNumberValidation2.max,
            exclusiveMin: maybeNumberValidation2.exclusiveMin,
            exclusiveMax: maybeNumberValidation2.exclusiveMax,
            multipleOf: maybeNumberValidation2.multipleOf
          } : void 0
        })
      });
    }
    case RawPrimitiveType.double: {
      const maybeNumberValidation2 = validation != null ? validation : void 0;
      return visitor.primitive({
        v1: PrimitiveTypeV1.Double,
        v2: PrimitiveTypeV2.double({
          default: _default2 != null ? _default2 : void 0,
          validation: maybeNumberValidation2 != null ? {
            min: maybeNumberValidation2.min,
            max: maybeNumberValidation2.max,
            exclusiveMin: maybeNumberValidation2.exclusiveMin,
            exclusiveMax: maybeNumberValidation2.exclusiveMax,
            multipleOf: maybeNumberValidation2.multipleOf
          } : void 0
        })
      });
    }
    case RawPrimitiveType.string: {
      const maybeStringValidation3 = validation != null ? validation : void 0;
      return visitor.primitive({
        v1: PrimitiveTypeV1.String,
        v2: PrimitiveTypeV2.string({
          default: _default2 != null ? _default2 : void 0,
          validation: maybeStringValidation3 != null ? {
            format: maybeStringValidation3.format,
            pattern: maybeStringValidation3.pattern,
            minLength: maybeStringValidation3.minLength,
            maxLength: maybeStringValidation3.maxLength
          } : void 0
        })
      });
    }
    case RawPrimitiveType.float:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Float,
        v2: void 0
      });
    case RawPrimitiveType.long:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Long,
        v2: void 0
      });
    case RawPrimitiveType.boolean:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Boolean,
        v2: void 0
      });
    case RawPrimitiveType.datetime:
      return visitor.primitive({
        v1: PrimitiveTypeV1.DateTime,
        v2: void 0
      });
    case RawPrimitiveType.date:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Date,
        v2: void 0
      });
    case RawPrimitiveType.uuid:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Uuid,
        v2: void 0
      });
    case RawPrimitiveType.base64:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Base64,
        v2: void 0
      });
    case RawPrimitiveType.bigint:
      return visitor.primitive({
        v1: PrimitiveTypeV1.BigInteger,
        v2: void 0
      });
    case RawPrimitiveType.uint:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Uint,
        v2: void 0
      });
    case RawPrimitiveType.uint64:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Uint64,
        v2: void 0
      });
    case RawPrimitiveType.unknown:
      return visitor.unknown();
  }
  const mapMatch = type2.match(FernContainerRegex.MAP);
  if (mapMatch?.[1] != null && mapMatch[2] != null) {
    return visitor.map({
      keyType: mapMatch[1],
      valueType: mapMatch[2]
    });
  }
  const listMatch = type2.match(FernContainerRegex.LIST);
  if (listMatch?.[1] != null) {
    return visitor.list(listMatch[1]);
  }
  const setMatch = type2.match(FernContainerRegex.SET);
  if (setMatch?.[1] != null) {
    return visitor.set(setMatch[1]);
  }
  const optionalMatch = type2.match(FernContainerRegex.OPTIONAL);
  if (optionalMatch?.[1] != null) {
    return visitor.optional(optionalMatch[1]);
  }
  const literalMatch = type2.match(FernContainerRegex.LITERAL);
  if (literalMatch?.[1] != null) {
    return visitor.literal(Literal.string(literalMatch[1]));
  }
  if (literalMatch?.[2] != null) {
    const group = literalMatch[2];
    switch (group) {
      case "false":
        return visitor.literal(Literal.boolean(false));
      case "true":
        return visitor.literal(Literal.boolean(true));
      default:
        throw new Error(`Unsupported literal value: ${group}`);
    }
  }
  return visitor.named(type2);
}

// ../../cli/fern-definition/schema/lib/utils/parseRawBytesType.js
var BYTES_TYPE = "bytes";
function parseRawBytesType(typeReference) {
  if (typeReference === BYTES_TYPE) {
    return { isOptional: false };
  }
  const optionalMatch = typeReference.match(FernContainerRegex.OPTIONAL);
  if (optionalMatch?.[1] === BYTES_TYPE) {
    return { isOptional: true };
  }
  return void 0;
}

// ../../cli/fern-definition/schema/lib/utils/parseBytesRequest.js
function parseBytesRequest(request) {
  const reference = typeof request === "string" ? request : typeof request.body === "string" ? request.body : void 0;
  if (reference == null) {
    return void 0;
  }
  return parseRawBytesType(reference);
}

// ../../cli/fern-definition/schema/lib/utils/parseRawFileType.js
var FILE_TYPE = "file";
function isFileArray(typeReference) {
  const listMatch = typeReference.match(FernContainerRegex.LIST);
  if (listMatch?.[1] === FILE_TYPE) {
    return true;
  }
  return false;
}
function parseRawFileType(typeReference) {
  if (typeReference === FILE_TYPE) {
    return { isOptional: false, isArray: false };
  }
  const optionalMatch = typeReference.match(FernContainerRegex.OPTIONAL);
  if (optionalMatch?.[1] !== void 0) {
    if (optionalMatch[1] === FILE_TYPE) {
      return { isOptional: true, isArray: false };
    } else if (isFileArray(optionalMatch[1])) {
      return { isOptional: true, isArray: true };
    }
  }
  if (isFileArray(typeReference)) {
    return { isOptional: false, isArray: true };
  }
  return void 0;
}

// ../../cli/fern-definition/schema/lib/utils/parseFileUploadRequest.js
function isFileUploadRequest(request) {
  if (typeof request === "string") {
    return false;
  }
  if (MediaType.parse(request["content-type"])?.isMultiPartFormData() ?? false) {
    return true;
  }
  if (request.body != null && isInlineRequestBody(request.body)) {
    if (Object.values(request.body.properties ?? []).some((property4) => {
      const propertyType = typeof property4 === "string" ? property4 : property4.type;
      return propertyType === "file";
    })) {
      return true;
    }
  }
  return false;
}
function parseFileUploadRequest(request) {
  if (!isFileUploadRequest(request) || request.body == null) {
    return void 0;
  }
  if (request.name == null) {
    return void 0;
  }
  if (request.body != null && isInlineRequestBody(request.body)) {
    return createRawFileUploadRequest(request.name, request.body);
  }
  return void 0;
}
function createRawFileUploadRequest(requestName, requestBody) {
  const properties = Object.entries(requestBody.properties ?? []).reduce((acc, [key, propertyType]) => {
    const docs = typeof propertyType !== "string" ? propertyType.docs : void 0;
    const contentType = typeof propertyType !== "string" ? propertyType["content-type"] : void 0;
    const maybeParsedFileType = parseRawFileType(typeof propertyType === "string" ? propertyType : propertyType.type);
    if (maybeParsedFileType != null) {
      acc.push({
        isFile: true,
        key,
        docs,
        isOptional: maybeParsedFileType.isOptional,
        isArray: maybeParsedFileType.isArray,
        contentType
      });
    } else {
      acc.push({ isFile: false, key, propertyType, docs, contentType });
    }
    return acc;
  }, []);
  if (requestBody["extra-properties"]) {
  }
  return {
    name: requestName,
    // TODO: handle requestBody.extends
    extends: requestBody.extends,
    properties
  };
}

// ../../cli/fern-definition/schema/lib/utils/parseRawTextType.js
var TEXT_TYPE2 = "text";
function parseRawTextType(typeReference) {
  if (typeReference === TEXT_TYPE2) {
    return { isOptional: false };
  }
  const optionalMatch = typeReference.match(FernContainerRegex.OPTIONAL);
  if (optionalMatch?.[1] === TEXT_TYPE2) {
    return { isOptional: true };
  }
  return void 0;
}

// ../../cli/fern-definition/schema/lib/utils/recursivelyVisitRawTypeReference.js
function recursivelyVisitRawTypeReference({ type: type2, _default: _default2, validation, visitor }) {
  return visitRawTypeReference({
    type: type2,
    _default: _default2,
    validation,
    visitor: {
      primitive: visitor.primitive,
      map: ({ keyType, valueType }) => visitor.map({
        keyType: recursivelyVisitRawTypeReference({
          type: keyType,
          _default: void 0,
          validation: void 0,
          visitor
        }),
        valueType: recursivelyVisitRawTypeReference({
          type: valueType,
          _default: void 0,
          validation: void 0,
          visitor
        })
      }),
      list: (valueType) => visitor.list(recursivelyVisitRawTypeReference({
        type: valueType,
        _default: void 0,
        validation: void 0,
        visitor
      })),
      set: (valueType) => visitor.set(recursivelyVisitRawTypeReference({
        type: valueType,
        _default: void 0,
        validation: void 0,
        visitor
      })),
      optional: (valueType) => visitor.optional(recursivelyVisitRawTypeReference({ type: valueType, _default: _default2, validation, visitor })),
      literal: visitor.literal,
      named: visitor.named,
      unknown: visitor.unknown
    }
  });
}

// ../../cli/fern-definition/schema/lib/utils/visitExampleCodeSampleSchema.js
function visitExampleCodeSampleSchema(codeSample, visitor) {
  if (isExampleCodeSampleSchemaSdk(codeSample)) {
    return visitor.sdk(codeSample);
  }
  if (isExampleCodeSampleSchemaLanguage(codeSample)) {
    return visitor.language(codeSample);
  }
  assertNever(codeSample);
}
function isExampleCodeSampleSchemaSdk(codeSample) {
  return codeSample.sdk != null;
}
function isExampleCodeSampleSchemaLanguage(codeSample) {
  return codeSample.language != null;
}

// ../../cli/fern-definition/schema/lib/utils/isSimpleStreamResponseSchema.js
function isSimpleStreamResponseSchema(endpoint) {
  return endpoint["response-stream"] != null && (typeof endpoint["response-stream"] === "string" || endpoint["response-stream"].format == null || endpoint["response-stream"].format === "json");
}

// ../../cli/fern-definition/schema/lib/utils/isSseStreamResponseSchema.js
function isSseStsreamResponseSchema(endpoint) {
  return endpoint["response-stream"] != null && typeof endpoint["response-stream"] !== "string" && endpoint["response-stream"].format === "sse";
}

// ../../cli/fern-definition/schema/lib/utils/visitExampleResponseSchema.js
function visitExampleResponseSchema(endpoint, example, visitor) {
  if (isExampleStreamResponseSchema(endpoint, example)) {
    return visitor.stream(example);
  } else if (isExampleSseResponseSchema(endpoint, example)) {
    return visitor.events(example);
  } else {
    return visitor.body(example);
  }
}
function isExampleStreamResponseSchema(endpoint, example) {
  return example.stream !== void 0 && isSimpleStreamResponseSchema(endpoint);
}
function isExampleSseResponseSchema(endpoint, example) {
  return example.stream !== void 0 && isSseStsreamResponseSchema(endpoint);
}

// ../../cli/fern-definition/schema/lib/utils/visitRawApiAuth.js
function visitRawApiAuth(apiAuth, visitor) {
  if (isSingleAuthScheme(apiAuth)) {
    return visitor.single(apiAuth);
  }
  if (isAnyAuthSchemes(apiAuth)) {
    return visitor.any(apiAuth);
  }
  assertNever(apiAuth);
}
function isSingleAuthScheme(apiAuth) {
  return typeof apiAuth === "string" || apiAuth.scheme != null;
}
function isAnyAuthSchemes(apiAuth) {
  const [firstKey, ...rest] = Object.keys(apiAuth);
  return firstKey === "any" && rest.length === 0;
}

// ../../cli/fern-definition/schema/lib/utils/visitRawAuthSchemeDeclaration.js
function visitRawAuthSchemeDeclaration(authScheme, visitor) {
  if (isHeaderAuthScheme(authScheme)) {
    return visitor.header(authScheme);
  }
  switch (authScheme.scheme) {
    case "basic":
      return visitor.basic(authScheme);
    case "bearer":
      return visitor.bearer(authScheme);
    case "oauth":
      return visitor.oauth(authScheme);
    default:
      assertNever(authScheme);
  }
}
function isHeaderAuthScheme(authScheme) {
  return authScheme.header != null;
}

// ../../cli/fern-definition/schema/lib/utils/visitRawEnvironmentDeclaration.js
function visitRawEnvironmentDeclaration(environment, visitor) {
  if (isRawSingleBaseUrlEnvironment(environment)) {
    return visitor.singleBaseUrl(environment);
  }
  if (isRawMultipleBaseUrlsEnvironment(environment)) {
    return visitor.multipleBaseUrls(environment);
  }
  assertNever(environment);
}
function isRawSingleBaseUrlEnvironment(environment) {
  return typeof environment === "string" || "url" in environment;
}
function isRawMultipleBaseUrlsEnvironment(environment) {
  return typeof environment !== "string" && "urls" in environment;
}

// ../../cli/fern-definition/schema/lib/utils/visitRawPathParameter.js
function isVariablePathParameter(rawPathParameter) {
  if (typeof rawPathParameter === "string") {
    return rawPathParameter.startsWith("$");
  }
  return "variable" in rawPathParameter;
}

// ../../cli/fern-definition/schema/lib/utils/visitRawTypeDeclaration.js
function visitRawTypeDeclaration(declaration, visitor) {
  if (isRawAliasDefinition(declaration)) {
    return visitor.alias(declaration);
  }
  if (isRawDiscriminatedUnionDefinition(declaration)) {
    return visitor.discriminatedUnion(declaration);
  }
  if (isRawObjectDefinition(declaration)) {
    return visitor.object(declaration);
  }
  if (isRawUndiscriminatedUnionDefinition(declaration)) {
    return visitor.undiscriminatedUnion(declaration);
  }
  if (isRawEnumDefinition(declaration)) {
    return visitor.enum(declaration);
  }
  assertNever(declaration);
}
function isRawAliasDefinition(rawTypeDeclaration) {
  return typeof rawTypeDeclaration === "string" || rawTypeDeclaration.type != null;
}
function isRawObjectDefinition(rawTypeDeclaration) {
  return rawTypeDeclaration.extends != null || rawTypeDeclaration.properties != null;
}
function isRawDiscriminatedUnionDefinition(rawTypeDeclaration) {
  return (
    // eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
    rawTypeDeclaration.union != null && // eslint-disable-next-line @typescript-eslint/no-explicit-any
    rawTypeDeclaration.discriminated == null
  );
}
function isRawUndiscriminatedUnionDefinition(rawTypeDeclaration) {
  const undiscriminatedUnionSchema = rawTypeDeclaration;
  return undiscriminatedUnionSchema.union != null && undiscriminatedUnionSchema.discriminated != null;
}
function isRawEnumDefinition(rawTypeDeclaration) {
  return rawTypeDeclaration.enum != null;
}

// ../../cli/fern-definition/schema/lib/utils/HttpEndpointReferenceParser.js
var HttpEndpointReferenceParser = class {
  //eslint-disable-next-line
  REFERENCE_REGEX = /^(GET|POST|PUT|DELETE|PATCH)\s(\/[a-zA-Z0-9\/]*)$/;
  validate(reference) {
    const validFormat = this.REFERENCE_REGEX.test(reference);
    if (!validFormat) {
      return { type: "invalid" };
    }
    return { type: "valid" };
  }
  tryParse(reference) {
    const validationResponse = this.validate(reference);
    if (validationResponse.type === "invalid") {
      return void 0;
    }
    const match = reference.match(this.REFERENCE_REGEX);
    if (match == null || match[1] == null || match[2] == null) {
      return void 0;
    }
    return {
      method: match[1],
      path: match[2]
    };
  }
};

// ../../cli/generation/ir-generator/lib/utils/parseTypeName.js
function parseTypeName({ typeName, file }) {
  const reference = parseReferenceToTypeName({
    reference: typeName,
    referencedIn: file.relativeFilepath,
    imports: file.imports
  });
  if (reference == null) {
    throw new Error("Failed to locate type: " + typeName);
  }
  const nameWithoutId = {
    name: file.casingsGenerator.generateName(reference.typeName),
    fernFilepath: convertToFernFilepath({
      relativeFilepath: reference.relativeFilepath,
      casingsGenerator: file.casingsGenerator
    })
  };
  return {
    ...nameWithoutId,
    typeId: IdGenerator.generateTypeId(nameWithoutId)
  };
}

// ../../cli/generation/ir-generator/lib/formatDocs.js
var isBrowser2 = typeof window !== "undefined" && typeof window.document !== "undefined";
async function formatDocs(docs) {
  if (docs == null || isBrowser2) {
    return void 0;
  }
  const prettier = await Promise.resolve().then(() => __toESM(require_prettier(), 1));
  const formattedDocs = prettier.format(docs, {
    parser: "markdown"
  });
  if (formattedDocs.endsWith("\n") || formattedDocs.endsWith("\r")) {
    return formattedDocs.substring(0, formattedDocs.length - 1);
  }
  return formattedDocs;
}

// ../../cli/generation/ir-generator/lib/converters/convertDeclaration.js
var DEFAULT_DECLARATION = {
  docs: void 0,
  availability: void 0
};
async function convertDeclaration(declaration) {
  if (typeof declaration === "string") {
    return DEFAULT_DECLARATION;
  }
  return {
    docs: await formatDocs(declaration.docs),
    availability: convertAvailability(declaration.availability)
  };
}
function convertAvailability(availability) {
  if (availability == null) {
    return void 0;
  }
  return {
    status: convertAvailabilityStatus(typeof availability === "string" ? availability : availability.status),
    message: typeof availability !== "string" ? availability.message : void 0
  };
}
function getAudiences(schema2) {
  if (typeof schema2 === "string") {
    return [];
  }
  return schema2.audiences ?? [];
}
function convertAvailabilityStatus(status) {
  switch (status) {
    case "in-development":
      return AvailabilityStatus.InDevelopment;
    case "pre-release":
      return AvailabilityStatus.PreRelease;
    case "deprecated":
      return AvailabilityStatus.Deprecated;
    case "generally-available":
      return AvailabilityStatus.GeneralAvailability;
    default:
      assertNever(status);
  }
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertObjectTypeDeclaration.js
async function convertObjectTypeDeclaration({ object: object3, file }) {
  return Type.object({
    extends: getExtensionsAsList(object3.extends).map((extended) => parseTypeName({ typeName: extended, file })),
    properties: await getObjectPropertiesFromRawObjectSchema(object3, file),
    extraProperties: object3["extra-properties"] ?? false,
    extendedProperties: void 0
  });
}
async function getObjectPropertiesFromRawObjectSchema(object3, file) {
  if (object3.properties == null) {
    return [];
  }
  return await Promise.all(Object.entries(object3.properties).map(async ([propertyKey, propertyDefinition]) => ({
    ...await convertDeclaration(propertyDefinition),
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: propertyKey,
      name: getPropertyName({ propertyKey, property: propertyDefinition }).name
    }),
    valueType: file.parseTypeReference(propertyDefinition)
  })));
}
function getExtensionsAsList(extensions) {
  if (extensions == null) {
    return [];
  }
  if (typeof extensions === "string") {
    return [extensions];
  }
  return extensions;
}
function getPropertyName({ propertyKey, property: property4 }) {
  if (typeof property4 !== "string" && property4.name != null) {
    return {
      name: property4.name,
      wasExplicitlySet: true
    };
  }
  return {
    name: propertyKey,
    wasExplicitlySet: false
  };
}

// ../../cli/generation/ir-generator/lib/converters/services/convertHttpRequestBody.js
function convertHttpRequestBody({ request, file }) {
  const bytesRequest = request != null ? parseBytesRequest(request) : void 0;
  if (bytesRequest != null) {
    return HttpRequestBody.bytes({
      isOptional: bytesRequest.isOptional,
      contentType: typeof request === "string" ? void 0 : request?.["content-type"],
      docs: typeof request === "string" ? void 0 : request?.docs
    });
  }
  if (typeof request === "string") {
    return HttpRequestBody.reference(convertReferenceHttpRequestBody({
      requestBody: request,
      file
    }));
  }
  if (request?.body == null) {
    return void 0;
  }
  const fileUploadRequest = parseFileUploadRequest(request);
  if (fileUploadRequest != null) {
    return HttpRequestBody.fileUpload({
      name: file.casingsGenerator.generateName(fileUploadRequest.name),
      properties: fileUploadRequest.properties.map((property4) => {
        if (property4.isFile) {
          if (property4.isArray) {
            return FileUploadRequestProperty.file(FileProperty.fileArray({
              key: file.casingsGenerator.generateNameAndWireValue({
                wireValue: property4.key,
                name: property4.key
              }),
              isOptional: property4.isOptional,
              contentType: property4.contentType
            }));
          } else {
            return FileUploadRequestProperty.file(FileProperty.file({
              key: file.casingsGenerator.generateNameAndWireValue({
                wireValue: property4.key,
                name: property4.key
              }),
              isOptional: property4.isOptional,
              contentType: property4.contentType
            }));
          }
        } else {
          return FileUploadRequestProperty.bodyProperty({
            ...convertInlinedRequestProperty({
              propertyKey: property4.key,
              propertyDefinition: property4.propertyType,
              docs: property4.docs,
              availability: convertAvailability(property4.availability),
              file
            }),
            contentType: property4.contentType
          });
        }
      }),
      docs: request.docs
    });
  }
  if (isInlineRequestBody(request.body)) {
    if (request.name == null) {
      throw new Error("Name is missing for inlined request");
    }
    return HttpRequestBody.inlinedRequestBody({
      name: file.casingsGenerator.generateName(request.name),
      extends: getExtensionsAsList(request.body.extends).map((extended) => parseTypeName({ typeName: extended, file })),
      contentType: request["content-type"],
      docs: request.docs,
      properties: request.body.properties != null ? Object.entries(request.body.properties).map(([propertyKey, propertyDefinition]) => convertInlinedRequestProperty({
        propertyKey,
        propertyDefinition,
        docs: typeof propertyDefinition !== "string" ? propertyDefinition.docs : void 0,
        availability: typeof propertyDefinition !== "string" ? convertAvailability(propertyDefinition.availability) : void 0,
        file
      })) : [],
      extraProperties: request.body["extra-properties"] ?? false,
      extendedProperties: void 0
    });
  }
  return HttpRequestBody.reference(convertReferenceHttpRequestBody({
    requestBody: request.body,
    file,
    contentType: request["content-type"]
  }));
}
function convertReferenceHttpRequestBody({ requestBody, file, contentType }) {
  return {
    docs: typeof requestBody !== "string" ? requestBody.docs : void 0,
    requestBodyType: file.parseTypeReference(requestBody),
    contentType
  };
}
function convertInlinedRequestProperty({ propertyKey, propertyDefinition, docs, availability, file }) {
  return {
    docs,
    availability,
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: propertyKey,
      name: getPropertyName({ propertyKey, property: propertyDefinition }).name
    }),
    valueType: file.parseTypeReference(propertyDefinition)
  };
}

// ../../cli/generation/ir-generator/lib/converters/services/getObjectPropertyFromResolvedType.js
async function getObjectPropertyFromResolvedType({ typeResolver, file, resolvedType, property: property4 }) {
  switch (resolvedType._type) {
    case "container":
      if (resolvedType.container._type === "optional") {
        return await getObjectPropertyFromResolvedType({
          typeResolver,
          file,
          resolvedType: resolvedType.container.itemType,
          property: property4
        });
      }
      break;
    case "named":
      if (isRawObjectDefinition(resolvedType.declaration)) {
        return await getObjectPropertyFromObjectSchema({
          typeResolver,
          file: resolvedType.file,
          objectSchema: resolvedType.declaration,
          property: property4
        });
      }
      break;
    case "primitive":
    case "unknown":
      break;
    default:
      assertNever(resolvedType);
  }
  throw new Error("Internal error; response must be an object in order to return a property as a response");
}
async function getObjectPropertyFromObjectSchema({ typeResolver, file, objectSchema, property: property4 }) {
  const properties = await getAllPropertiesForRawObjectSchema(objectSchema, file, typeResolver);
  const objectProperty = properties[property4];
  if (objectProperty == null) {
    throw new Error(`Object does not have a property named ${property4}.`);
  }
  return objectProperty;
}
async function getAllPropertiesForRawObjectSchema(objectSchema, file, typeResolver) {
  let extendedTypes = [];
  if (typeof objectSchema.extends === "string") {
    extendedTypes = [objectSchema.extends];
  } else if (Array.isArray(objectSchema.extends)) {
    extendedTypes = objectSchema.extends;
  }
  const properties = {};
  for (const extendedType of extendedTypes) {
    const extendedProperties = await getAllPropertiesForExtendedType(extendedType, file, typeResolver);
    Object.entries(extendedProperties).map(([propertyKey, objectProperty]) => {
      properties[propertyKey] = objectProperty;
    });
  }
  const objectProperties = await getObjectPropertiesFromRawObjectSchema(objectSchema, file);
  objectProperties.forEach((objectProperty) => {
    properties[objectProperty.name.name.originalName] = objectProperty;
  });
  return properties;
}
async function getAllPropertiesForExtendedType(extendedType, file, typeResolver) {
  const resolvedType = typeResolver.resolveNamedTypeOrThrow({
    referenceToNamedType: extendedType,
    file
  });
  if (resolvedType._type === "named" && isRawObjectDefinition(resolvedType.declaration)) {
    return await getAllPropertiesForRawObjectSchema(resolvedType.declaration, file, typeResolver);
  }
  throw new Error(`Extended type ${extendedType} must be another named type`);
}

// ../../cli/generation/ir-generator/lib/converters/services/convertProperty.js
async function getNestedObjectPropertyFromResolvedType({ typeResolver, file, resolvedType, propertyComponents }) {
  if (propertyComponents.length === 0) {
    return void 0;
  }
  if (propertyComponents.length === 1) {
    return await getObjectPropertyFromResolvedType({
      typeResolver,
      file,
      resolvedType,
      property: propertyComponents[0] ?? ""
    });
  }
  const objectSchema = maybeObjectSchema(resolvedType);
  if (objectSchema == null) {
    return void 0;
  }
  return getNestedObjectPropertyFromObjectSchema({
    typeResolver,
    file,
    objectSchema,
    propertyComponents
  });
}
async function getNestedObjectPropertyFromObjectSchema({ typeResolver, file, objectSchema, propertyComponents }) {
  if (propertyComponents.length === 0) {
    return void 0;
  }
  if (propertyComponents.length === 1) {
    return await getObjectPropertyFromObjectSchema({
      typeResolver,
      file,
      objectSchema,
      property: propertyComponents[0] ?? ""
    });
  }
  const propertyType = await getPropertyTypeFromObjectSchema({
    typeResolver,
    file,
    objectSchema,
    property: propertyComponents[0] ?? ""
  });
  const resolvedTypeProperty = typeResolver.resolveTypeOrThrow({
    type: propertyType,
    file
  });
  return getNestedObjectPropertyFromResolvedType({
    typeResolver,
    file: maybeFileFromResolvedType(resolvedTypeProperty) ?? file,
    resolvedType: resolvedTypeProperty,
    propertyComponents: propertyComponents.slice(1)
  });
}
async function getPropertyTypeFromObjectSchema({ typeResolver, file, objectSchema, property: property4 }) {
  const properties = await getAllPropertiesForRawObjectSchema2({
    typeResolver,
    file,
    objectSchema
  });
  const propertyType = properties[property4];
  if (propertyType == null) {
    throw new Error(`Response does not have a property named ${property4}.`);
  }
  return propertyType;
}
async function getAllPropertiesForRawObjectSchema2({ typeResolver, file, objectSchema }) {
  let extendedTypes = [];
  if (typeof objectSchema.extends === "string") {
    extendedTypes = [objectSchema.extends];
  } else if (Array.isArray(objectSchema.extends)) {
    extendedTypes = objectSchema.extends;
  }
  const properties = {};
  for (const extendedType of extendedTypes) {
    const extendedProperties = await getAllPropertiesForExtendedType2({
      typeResolver,
      file,
      extendedType
    });
    Object.entries(extendedProperties).map(([propertyKey, propertyType]) => {
      properties[propertyKey] = propertyType;
    });
  }
  if (objectSchema.properties != null) {
    Object.entries(objectSchema.properties).map(([propertyKey, propertyType]) => {
      properties[propertyKey] = typeof propertyType === "string" ? propertyType : propertyType.type;
    });
  }
  return properties;
}
async function getAllPropertiesForExtendedType2({ typeResolver, file, extendedType }) {
  const resolvedType = typeResolver.resolveNamedTypeOrThrow({
    referenceToNamedType: extendedType,
    file
  });
  if (resolvedType._type === "named" && isRawObjectDefinition(resolvedType.declaration)) {
    return await getAllPropertiesForRawObjectSchema2({
      typeResolver,
      file: maybeFileFromResolvedType(resolvedType) ?? file,
      objectSchema: resolvedType.declaration
    });
  }
  throw new Error(`Extended type ${extendedType} must be another named type.`);
}
function maybeFileFromResolvedType(resolvedType) {
  if (resolvedType == null) {
    return void 0;
  }
  if (resolvedType._type === "named") {
    return resolvedType.file;
  }
  if (resolvedType._type === "container" && resolvedType.container._type === "optional") {
    return maybeFileFromResolvedType(resolvedType.container.itemType);
  }
  return void 0;
}
function maybeObjectSchema(resolvedType) {
  if (resolvedType == null) {
    return void 0;
  }
  if (resolvedType._type === "named" && isRawObjectDefinition(resolvedType.declaration)) {
    return resolvedType.declaration;
  }
  if (resolvedType._type === "container" && resolvedType.container._type === "optional") {
    return maybeObjectSchema(resolvedType.container.itemType);
  }
  return void 0;
}
function getRequestPropertyComponents(value) {
  const trimmed = value.substring("$request.".length);
  return trimmed?.split(".") ?? [];
}
function getResponsePropertyComponents(value) {
  const trimmed = value.substring("$response.".length);
  return trimmed?.split(".") ?? [];
}

// ../../cli/generation/ir-generator/lib/converters/services/convertHttpSdkRequest.js
var DEFAULT_REQUEST_PARAMETER_NAME = "request";
var DEFAULT_BODY_PROPERTY_KEY_IN_WRAPPER = "body";
async function convertHttpSdkRequest({ request, endpointKey, endpoint, service, file, typeResolver, propertyResolver }) {
  const shape = convertHttpSdkRequestShape({ request, service, file, typeResolver });
  if (shape == null) {
    return void 0;
  }
  return {
    shape,
    requestParameterName: file.casingsGenerator.generateName(DEFAULT_REQUEST_PARAMETER_NAME),
    streamParameter: endpoint["stream-condition"] != null ? await propertyResolver.resolveRequestPropertyOrThrow({
      file,
      endpoint: endpointKey,
      propertyComponents: getRequestPropertyComponents(endpoint["stream-condition"])
    }) : void 0
  };
}
function convertHttpSdkRequestShape({ service, request, file, typeResolver }) {
  const constructWrapper = () => {
    if (typeof request === "string" || request?.name == null) {
      throw new Error("Name is missing for request wrapper");
    }
    return SdkRequestShape.wrapper({
      wrapperName: file.casingsGenerator.generateName(request.name),
      bodyKey: file.casingsGenerator.generateName(DEFAULT_BODY_PROPERTY_KEY_IN_WRAPPER),
      includePathParameters: shouldIncludePathParametersInWrapper(request),
      onlyPathParameters: doesRequestHaveOnlyPathParameters({ request, file, typeResolver })
    });
  };
  if (!areAllHeadersLiteral({ headers: service.headers ?? {}, file, typeResolver })) {
    return constructWrapper();
  }
  if (request == null) {
    return void 0;
  }
  if (typeof request === "string") {
    return SdkRequestShape.justRequestBody(getSdkJustRequestBodyType({ requestBody: request, file }));
  }
  const { body } = request;
  if (doesRequestHaveNonBodyProperties({ request, file, typeResolver }) || body != null && isInlineRequestBody(body)) {
    return constructWrapper();
  }
  if (body == null) {
    return void 0;
  }
  return SdkRequestShape.justRequestBody(getSdkJustRequestBodyType({ requestBody: body, file }));
}
function getSdkJustRequestBodyType({ requestBody, file, contentType }) {
  const rawBytes = typeof requestBody === "string" ? parseRawBytesType(requestBody) : parseRawBytesType(requestBody.type);
  if (rawBytes != null) {
    return SdkRequestBodyType.bytes({
      isOptional: rawBytes.isOptional,
      contentType,
      docs: void 0
    });
  }
  return SdkRequestBodyType.typeReference(convertReferenceHttpRequestBody({
    requestBody,
    file,
    contentType
  }));
}
function doesRequestHaveNonBodyProperties({ request, file, typeResolver }) {
  const { headers = {}, "path-parameters": pathParameters = {}, "query-parameters": queryParameters = {} } = request;
  return !areAllHeadersLiteral({ headers, file, typeResolver }) || size_default(pathParameters) > 0 || size_default(queryParameters) > 0;
}
function doesRequestHaveOnlyPathParameters({ request, file, typeResolver }) {
  const { headers = {}, "path-parameters": pathParameters = {}, "query-parameters": queryParameters = {} } = request;
  return size_default(pathParameters) > 0 && areAllHeadersLiteral({ headers, file, typeResolver }) && size_default(queryParameters) === 0 && request.body == null;
}
function shouldIncludePathParametersInWrapper(request) {
  return typeof request !== "string" && request?.["path-parameters"] != null;
}
function areAllHeadersLiteral({ headers, file, typeResolver }) {
  return Object.values(headers).filter((header) => {
    const headerType = typeof header === "string" ? header : header.type;
    const resolvedType = typeResolver.resolveTypeOrThrow({
      type: headerType,
      file
    });
    const isLiteral = resolvedType._type === "container" && resolvedType.container._type === "literal";
    return !isLiteral;
  }).length === 0;
}

// ../../../node_modules/.pnpm/url-join@5.0.0/node_modules/url-join/lib/url-join.js
function normalize(strArray) {
  var resultArray = [];
  if (strArray.length === 0) {
    return "";
  }
  if (typeof strArray[0] !== "string") {
    throw new TypeError("Url must be a string. Received " + strArray[0]);
  }
  if (strArray[0].match(/^[^/:]+:\/*$/) && strArray.length > 1) {
    var first = strArray.shift();
    strArray[0] = first + strArray[0];
  }
  if (strArray[0].match(/^file:\/\/\//)) {
    strArray[0] = strArray[0].replace(/^([^/:]+):\/*/, "$1:///");
  } else {
    strArray[0] = strArray[0].replace(/^([^/:]+):\/*/, "$1://");
  }
  for (var i = 0; i < strArray.length; i++) {
    var component = strArray[i];
    if (typeof component !== "string") {
      throw new TypeError("Url must be a string. Received " + component);
    }
    if (component === "") {
      continue;
    }
    if (i > 0) {
      component = component.replace(/^[\/]+/, "");
    }
    if (i < strArray.length - 1) {
      component = component.replace(/[\/]+$/, "");
    } else {
      component = component.replace(/[\/]+$/, "/");
    }
    resultArray.push(component);
  }
  var str2 = resultArray.join("/");
  str2 = str2.replace(/\/(\?|&|#[^!])/g, "$1");
  var parts = str2.split("?");
  str2 = parts.shift() + (parts.length > 0 ? "?" : "") + parts.join("&");
  return str2;
}
function urlJoin() {
  var input;
  if (typeof arguments[0] === "object") {
    input = arguments[0];
  } else {
    input = [].slice.call(arguments);
  }
  return normalize(input);
}

// ../../cli/generation/ir-generator/lib/converters/services/convertCodeSamples.js
function convertCodeSample({ codeSample, file }) {
  return visitExampleCodeSampleSchema(codeSample, {
    language: (languageScheme) => ExampleCodeSample.language({
      name: languageScheme.name != null ? file.casingsGenerator.generateName(languageScheme.name) : void 0,
      docs: languageScheme.docs,
      language: languageScheme.language,
      code: languageScheme.code,
      install: languageScheme.install
    }),
    sdk: (sdkScheme) => ExampleCodeSample.sdk({
      name: sdkScheme.name != null ? file.casingsGenerator.generateName(sdkScheme.name) : void 0,
      docs: sdkScheme.docs,
      sdk: removeSdkAlias(sdkScheme.sdk),
      code: sdkScheme.code
    })
  });
}
function removeSdkAlias(sdk) {
  switch (sdk) {
    case "js":
      return "javascript";
    case "node":
      return "javascript";
    case "ts":
      return "typescript";
    case "nodets":
      return "typescript";
    case "golang":
      return "go";
    case "dotnet":
      return "csharp";
    case "c#":
      return "csharp";
    case "jvm":
      return "java";
    default:
      return sdk;
  }
}

// ../../cli/generation/ir-generator/lib/converters/services/convertExampleEndpointCall.js
var import_crypto = __toESM(require("crypto"), 1);

// ../../cli/generation/ir-generator/lib/examples/getViolationsForMisshapenExample.js
function getViolationsForMisshapenExample(example, expectedTypeIncludingArticle) {
  return [
    {
      message: `Expected example to be ${expectedTypeIncludingArticle}. Example is: ${JSON.stringify(example)}`
    }
  ];
}

// ../../cli/generation/ir-generator/lib/examples/validateAliasExample.js
function validateAliasExample({ rawAlias, example, file, typeResolver, exampleResolver, workspace, breadcrumbs, depth }) {
  return validateTypeReferenceExample({
    rawTypeReference: typeof rawAlias === "string" ? rawAlias : rawAlias.type,
    example,
    file,
    typeResolver,
    exampleResolver,
    workspace,
    breadcrumbs,
    depth: depth + 1
  });
}

// ../../cli/generation/ir-generator/lib/examples/validateEnumExample.js
function validateEnumExample({ rawEnum, example, breadcrumbs }) {
  const wireValues = rawEnum.enum.map((enumValue) => typeof enumValue === "string" ? enumValue : enumValue.value);
  const validEnumValuesLines = wireValues.map((wireValue) => `  - ${wireValue}`).join("\n");
  if (typeof example !== "string") {
    return getViolationsForMisshapenExample(example, "a string");
  }
  if (wireValues.includes(example)) {
    return [];
  }
  return [
    {
      message: `"${example}" is not a valid example for this enum. Enum values are:
` + validEnumValuesLines
    }
  ];
}

// ../../cli/workspace/commons/lib/AbstractAPIWorkspace.js
var AbstractAPIWorkspace = class {
  generatorsConfiguration;
  workspaceName;
  cliVersion;
  absoluteFilePath;
  changelog;
  type = "api";
  constructor({ generatorsConfiguration, workspaceName, cliVersion, absoluteFilePath, changelog }) {
    this.generatorsConfiguration = generatorsConfiguration;
    this.workspaceName = workspaceName;
    this.cliVersion = cliVersion;
    this.absoluteFilePath = absoluteFilePath;
    this.changelog = changelog;
  }
};

// ../../cli/workspace/commons/lib/FernWorkspace.js
var FernWorkspace = class extends AbstractAPIWorkspace {
  definition;
  sources;
  constructor({ definition, sources, ...superArgs }) {
    super(superArgs);
    this.definition = definition;
    this.sources = sources ?? [];
  }
  async getDefinition() {
    return this.definition;
  }
  async toFernWorkspace() {
    return this;
  }
  getSources() {
    return this.sources;
  }
  getAbsoluteFilePaths() {
    return [this.absoluteFilePath];
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/commons/types/Source.js
var Source2 = {
  openapi: (value) => {
    return {
      ...value,
      type: "openapi",
      _visit: function(visitor) {
        return Source2._visit(this, visitor);
      }
    };
  },
  protobuf: (value) => {
    return {
      ...value,
      type: "protobuf",
      _visit: function(visitor) {
        return Source2._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "openapi":
        return visitor.openapi(value);
      case "protobuf":
        return visitor.protobuf(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/commons/types/Encoding.js
var Encoding = {
  protobuf: (value) => {
    return {
      ...value,
      type: "protobuf",
      _visit: function(visitor) {
        return Encoding._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "protobuf":
        return visitor.protobuf(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/commons/types/SecurityScheme.js
var SecurityScheme = {
  basic: (value) => {
    return {
      ...value,
      type: "basic",
      _visit: function(visitor) {
        return SecurityScheme._visit(this, visitor);
      }
    };
  },
  bearer: (value) => {
    return {
      ...value,
      type: "bearer",
      _visit: function(visitor) {
        return SecurityScheme._visit(this, visitor);
      }
    };
  },
  header: (value) => {
    return {
      ...value,
      type: "header",
      _visit: function(visitor) {
        return SecurityScheme._visit(this, visitor);
      }
    };
  },
  query: (value) => {
    return {
      ...value,
      type: "query",
      _visit: function(visitor) {
        return SecurityScheme._visit(this, visitor);
      }
    };
  },
  oauth: (value) => {
    return {
      ...value,
      type: "oauth",
      _visit: function(visitor) {
        return SecurityScheme._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "basic":
        return visitor.basic(value);
      case "bearer":
        return visitor.bearer(value);
      case "header":
        return visitor.header(value);
      case "query":
        return visitor.query(value);
      case "oauth":
        return visitor.oauth(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/example/types/FullExample.js
var FullExample = {
  primitive: (value) => {
    return {
      value,
      type: "primitive",
      _visit: function(visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function(visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  array: (value) => {
    return {
      value,
      type: "array",
      _visit: function(visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      value,
      type: "map",
      _visit: function(visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      value,
      type: "enum",
      _visit: function(visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      value,
      type: "literal",
      _visit: function(visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  oneOf: (value) => {
    return {
      value,
      type: "oneOf",
      _visit: function(visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  unknown: (value) => {
    return {
      value,
      type: "unknown",
      _visit: function(visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "primitive":
        return visitor.primitive(value.value);
      case "object":
        return visitor.object(value);
      case "array":
        return visitor.array(value.value);
      case "map":
        return visitor.map(value.value);
      case "enum":
        return visitor.enum(value.value);
      case "literal":
        return visitor.literal(value.value);
      case "oneOf":
        return visitor.oneOf(value.value);
      case "unknown":
        return visitor.unknown(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/example/types/PrimitiveExample.js
var PrimitiveExample = {
  int: (value) => {
    return {
      value,
      type: "int",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  int64: (value) => {
    return {
      value,
      type: "int64",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  uint: (value) => {
    return {
      value,
      type: "uint",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  uint64: (value) => {
    return {
      value,
      type: "uint64",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  float: (value) => {
    return {
      value,
      type: "float",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  double: (value) => {
    return {
      value,
      type: "double",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      value,
      type: "string",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  datetime: (value) => {
    return {
      value,
      type: "datetime",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  date: (value) => {
    return {
      value,
      type: "date",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  base64: (value) => {
    return {
      value,
      type: "base64",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      value,
      type: "boolean",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "int":
        return visitor.int(value.value);
      case "int64":
        return visitor.int64(value.value);
      case "uint":
        return visitor.uint(value.value);
      case "uint64":
        return visitor.uint64(value.value);
      case "float":
        return visitor.float(value.value);
      case "double":
        return visitor.double(value.value);
      case "string":
        return visitor.string(value.value);
      case "datetime":
        return visitor.datetime(value.value);
      case "date":
        return visitor.date(value.value);
      case "base64":
        return visitor.base64(value.value);
      case "boolean":
        return visitor.boolean(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/example/types/FullOneOfExample.js
var FullOneOfExample = {
  discriminated: (value) => {
    return {
      value,
      type: "discriminated",
      _visit: function(visitor) {
        return FullOneOfExample._visit(this, visitor);
      }
    };
  },
  undisciminated: (value) => {
    return {
      value,
      type: "undisciminated",
      _visit: function(visitor) {
        return FullOneOfExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "discriminated":
        return visitor.discriminated(value.value);
      case "undisciminated":
        return visitor.undisciminated(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/Availability.js
var Availability = {
  GenerallyAvailable: "GenerallyAvailable",
  Beta: "Beta",
  Deprecated: "Deprecated",
  _visit: (value, visitor) => {
    switch (value) {
      case Availability.GenerallyAvailable:
        return visitor.generallyAvailable();
      case Availability.Beta:
        return visitor.beta();
      case Availability.Deprecated:
        return visitor.deprecated();
      default:
        return visitor._other();
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/Pagination.js
var Pagination3 = {
  cursor: (value) => {
    return {
      ...value,
      type: "cursor",
      _visit: function(visitor) {
        return Pagination3._visit(this, visitor);
      }
    };
  },
  offset: (value) => {
    return {
      ...value,
      type: "offset",
      _visit: function(visitor) {
        return Pagination3._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "cursor":
        return visitor.cursor(value);
      case "offset":
        return visitor.offset(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/CustomCodeSample.js
var CustomCodeSample = {
  language: (value) => {
    return {
      ...value,
      type: "language",
      _visit: function(visitor) {
        return CustomCodeSample._visit(this, visitor);
      }
    };
  },
  sdk: (value) => {
    return {
      ...value,
      type: "sdk",
      _visit: function(visitor) {
        return CustomCodeSample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "language":
        return visitor.language(value);
      case "sdk":
        return visitor.sdk(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/SupportedSdkLanguage.js
var SupportedSdkLanguage = {
  Curl: "curl",
  Python: "python",
  Javascript: "javascript",
  Typescript: "typescript",
  Go: "go",
  Ruby: "ruby",
  Csharp: "csharp",
  Java: "java",
  Js: "js",
  Node: "node",
  Ts: "ts",
  Nodets: "nodets",
  Golang: "golang",
  Dotnet: "dotnet",
  Jvm: "jvm",
  _visit: (value, visitor) => {
    switch (value) {
      case SupportedSdkLanguage.Curl:
        return visitor.curl();
      case SupportedSdkLanguage.Python:
        return visitor.python();
      case SupportedSdkLanguage.Javascript:
        return visitor.javascript();
      case SupportedSdkLanguage.Typescript:
        return visitor.typescript();
      case SupportedSdkLanguage.Go:
        return visitor.go();
      case SupportedSdkLanguage.Ruby:
        return visitor.ruby();
      case SupportedSdkLanguage.Csharp:
        return visitor.csharp();
      case SupportedSdkLanguage.Java:
        return visitor.java();
      case SupportedSdkLanguage.Js:
        return visitor.js();
      case SupportedSdkLanguage.Node:
        return visitor.node();
      case SupportedSdkLanguage.Ts:
        return visitor.ts();
      case SupportedSdkLanguage.Nodets:
        return visitor.nodets();
      case SupportedSdkLanguage.Golang:
        return visitor.golang();
      case SupportedSdkLanguage.Dotnet:
        return visitor.dotnet();
      case SupportedSdkLanguage.Jvm:
        return visitor.jvm();
      default:
        return visitor._other();
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/EndpointExample.js
var EndpointExample = {
  unknown: (value) => {
    return {
      value,
      type: "unknown",
      _visit: function(visitor) {
        return EndpointExample._visit(this, visitor);
      }
    };
  },
  full: (value) => {
    return {
      ...value,
      type: "full",
      _visit: function(visitor) {
        return EndpointExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "unknown":
        return visitor.unknown(value.value);
      case "full":
        return visitor.full(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/EndpointResponseExample.js
var EndpointResponseExample = {
  withStreaming: (value) => {
    return {
      value,
      type: "withStreaming",
      _visit: function(visitor) {
        return EndpointResponseExample._visit(this, visitor);
      }
    };
  },
  withoutStreaming: (value) => {
    return {
      value,
      type: "withoutStreaming",
      _visit: function(visitor) {
        return EndpointResponseExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "withStreaming":
        return visitor.withStreaming(value.value);
      case "withoutStreaming":
        return visitor.withoutStreaming(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/HttpMethod.js
var HttpMethod2 = {
  Get: "GET",
  Post: "POST",
  Put: "PUT",
  Patch: "PATCH",
  Delete: "DELETE",
  Head: "HEAD",
  Options: "OPTIONS",
  Trace: "TRACE",
  _visit: (value, visitor) => {
    switch (value) {
      case HttpMethod2.Get:
        return visitor.get();
      case HttpMethod2.Post:
        return visitor.post();
      case HttpMethod2.Put:
        return visitor.put();
      case HttpMethod2.Patch:
        return visitor.patch();
      case HttpMethod2.Delete:
        return visitor.delete();
      case HttpMethod2.Head:
        return visitor.head();
      case HttpMethod2.Options:
        return visitor.options();
      case HttpMethod2.Trace:
        return visitor.trace();
      default:
        return visitor._other();
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/MultipartSchema.js
var MultipartSchema = {
  file: (value) => {
    return {
      ...value,
      type: "file",
      _visit: function(visitor) {
        return MultipartSchema._visit(this, visitor);
      }
    };
  },
  json: (value) => {
    return {
      value,
      type: "json",
      _visit: function(visitor) {
        return MultipartSchema._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "file":
        return visitor.file(value);
      case "json":
        return visitor.json(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/Schema.js
var Schema = {
  primitive: (value) => {
    return {
      ...value,
      type: "primitive",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  array: (value) => {
    return {
      ...value,
      type: "array",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      ...value,
      type: "map",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  optional: (value) => {
    return {
      ...value,
      type: "optional",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      ...value,
      type: "enum",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      ...value,
      type: "literal",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  oneOf: (value) => {
    return {
      value,
      type: "oneOf",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  nullable: (value) => {
    return {
      ...value,
      type: "nullable",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  unknown: (value) => {
    return {
      ...value,
      type: "unknown",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "primitive":
        return visitor.primitive(value);
      case "object":
        return visitor.object(value);
      case "array":
        return visitor.array(value);
      case "map":
        return visitor.map(value);
      case "optional":
        return visitor.optional(value);
      case "enum":
        return visitor.enum(value);
      case "reference":
        return visitor.reference(value);
      case "literal":
        return visitor.literal(value);
      case "oneOf":
        return visitor.oneOf(value.value);
      case "nullable":
        return visitor.nullable(value);
      case "unknown":
        return visitor.unknown(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/PrimitiveSchemaValue.js
var PrimitiveSchemaValue = {
  int: (value) => {
    return {
      ...value,
      type: "int",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  int64: (value) => {
    return {
      ...value,
      type: "int64",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  uint: () => {
    return {
      type: "uint",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  uint64: () => {
    return {
      type: "uint64",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  float: () => {
    return {
      type: "float",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  double: (value) => {
    return {
      ...value,
      type: "double",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      ...value,
      type: "string",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  datetime: () => {
    return {
      type: "datetime",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  date: () => {
    return {
      type: "date",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  base64: () => {
    return {
      type: "base64",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      ...value,
      type: "boolean",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "int":
        return visitor.int(value);
      case "int64":
        return visitor.int64(value);
      case "uint":
        return visitor.uint();
      case "uint64":
        return visitor.uint64();
      case "float":
        return visitor.float();
      case "double":
        return visitor.double(value);
      case "string":
        return visitor.string(value);
      case "datetime":
        return visitor.datetime();
      case "date":
        return visitor.date();
      case "base64":
        return visitor.base64();
      case "boolean":
        return visitor.boolean(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/LiteralSchemaValue.js
var LiteralSchemaValue = {
  boolean: (value) => {
    return {
      value,
      type: "boolean",
      _visit: function(visitor) {
        return LiteralSchemaValue._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      value,
      type: "string",
      _visit: function(visitor) {
        return LiteralSchemaValue._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "boolean":
        return visitor.boolean(value.value);
      case "string":
        return visitor.string(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/OneOfSchema.js
var OneOfSchema = {
  discriminated: (value) => {
    return {
      ...value,
      type: "discriminated",
      _visit: function(visitor) {
        return OneOfSchema._visit(this, visitor);
      }
    };
  },
  undisciminated: (value) => {
    return {
      ...value,
      type: "undisciminated",
      _visit: function(visitor) {
        return OneOfSchema._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "discriminated":
        return visitor.discriminated(value);
      case "undisciminated":
        return visitor.undisciminated(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/parseIr/types/RequestWithExample.js
var RequestWithExample = {
  octetStream: (value) => {
    return {
      ...value,
      type: "octetStream",
      _visit: function(visitor) {
        return RequestWithExample._visit(this, visitor);
      }
    };
  },
  multipart: (value) => {
    return {
      ...value,
      type: "multipart",
      _visit: function(visitor) {
        return RequestWithExample._visit(this, visitor);
      }
    };
  },
  json: (value) => {
    return {
      ...value,
      type: "json",
      _visit: function(visitor) {
        return RequestWithExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "octetStream":
        return visitor.octetStream(value);
      case "multipart":
        return visitor.multipart(value);
      case "json":
        return visitor.json(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/parseIr/types/ResponseWithExample.js
var ResponseWithExample = {
  file: (value) => {
    return {
      ...value,
      type: "file",
      _visit: function(visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  json: (value) => {
    return {
      ...value,
      type: "json",
      _visit: function(visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  text: (value) => {
    return {
      ...value,
      type: "text",
      _visit: function(visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  streamingSse: (value) => {
    return {
      ...value,
      type: "streamingSse",
      _visit: function(visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  streamingText: (value) => {
    return {
      ...value,
      type: "streamingText",
      _visit: function(visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  streamingJson: (value) => {
    return {
      ...value,
      type: "streamingJson",
      _visit: function(visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "file":
        return visitor.file(value);
      case "json":
        return visitor.json(value);
      case "text":
        return visitor.text(value);
      case "streamingSse":
        return visitor.streamingSse(value);
      case "streamingText":
        return visitor.streamingText(value);
      case "streamingJson":
        return visitor.streamingJson(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/parseIr/types/SchemaWithExample.js
var SchemaWithExample = {
  primitive: (value) => {
    return {
      ...value,
      type: "primitive",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  array: (value) => {
    return {
      ...value,
      type: "array",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      ...value,
      type: "map",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  optional: (value) => {
    return {
      ...value,
      type: "optional",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      ...value,
      type: "enum",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      ...value,
      type: "literal",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  oneOf: (value) => {
    return {
      value,
      type: "oneOf",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  nullable: (value) => {
    return {
      ...value,
      type: "nullable",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  unknown: (value) => {
    return {
      ...value,
      type: "unknown",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "primitive":
        return visitor.primitive(value);
      case "object":
        return visitor.object(value);
      case "array":
        return visitor.array(value);
      case "map":
        return visitor.map(value);
      case "optional":
        return visitor.optional(value);
      case "enum":
        return visitor.enum(value);
      case "reference":
        return visitor.reference(value);
      case "literal":
        return visitor.literal(value);
      case "oneOf":
        return visitor.oneOf(value.value);
      case "nullable":
        return visitor.nullable(value);
      case "unknown":
        return visitor.unknown(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/parseIr/types/OneOfSchemaWithExample.js
var OneOfSchemaWithExample = {
  discriminated: (value) => {
    return {
      ...value,
      type: "discriminated",
      _visit: function(visitor) {
        return OneOfSchemaWithExample._visit(this, visitor);
      }
    };
  },
  undisciminated: (value) => {
    return {
      ...value,
      type: "undisciminated",
      _visit: function(visitor) {
        return OneOfSchemaWithExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "discriminated":
        return visitor.discriminated(value);
      case "undisciminated":
        return visitor.undisciminated(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/parseIr/types/PrimitiveSchemaValueWithExample.js
var PrimitiveSchemaValueWithExample = {
  int: (value) => {
    return {
      ...value,
      type: "int",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  int64: (value) => {
    return {
      ...value,
      type: "int64",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  uint: (value) => {
    return {
      ...value,
      type: "uint",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  uint64: (value) => {
    return {
      ...value,
      type: "uint64",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  float: (value) => {
    return {
      ...value,
      type: "float",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  double: (value) => {
    return {
      ...value,
      type: "double",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      ...value,
      type: "string",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  datetime: (value) => {
    return {
      ...value,
      type: "datetime",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  date: (value) => {
    return {
      ...value,
      type: "date",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  base64: (value) => {
    return {
      ...value,
      type: "base64",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      ...value,
      type: "boolean",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "int":
        return visitor.int(value);
      case "int64":
        return visitor.int64(value);
      case "uint":
        return visitor.uint(value);
      case "uint64":
        return visitor.uint64(value);
      case "float":
        return visitor.float(value);
      case "double":
        return visitor.double(value);
      case "string":
        return visitor.string(value);
      case "datetime":
        return visitor.datetime(value);
      case "date":
        return visitor.date(value);
      case "base64":
        return visitor.base64(value);
      case "boolean":
        return visitor.boolean(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/utils/constants.js
var NUMERIC_REGEX = /^(\d+)/;
var VALID_ENUM_NAME_REGEX = /^[a-zA-Z][a-zA-Z0-9_]*$/;
var HARDCODED_ENUM_NAMES = {
  "<": "LESS_THAN",
  ">": "GREATER_THAN",
  ">=": "GREATER_THAN_OR_EQUAL_TO",
  "<=": "LESS_THAN_OR_EQUAL_TO",
  "!=": "NOT_EQUALS",
  "=": "EQUAL_TO",
  "==": "EQUAL_TO",
  "*": "ALL",
  "": "EMPTY",
  '""': "EMPTY_STRING",
  "-": "HYPHEN",
  "|": "PIPE",
  ".": "DOT",
  "/": "SLASH"
};

// ../../cli/api-importers/openapi/openapi-ir/lib/utils/convertNumberToSnakeCase.js
function convertNumberToSnakeCase(number3) {
  const singleDigits = ["zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine"];
  const teenNumbers = [
    "ten",
    "eleven",
    "twelve",
    "thirteen",
    "fourteen",
    "fifteen",
    "sixteen",
    "seventeen",
    "eighteen",
    "nineteen"
  ];
  const tensNumbers = ["", "", "twenty", "thirty", "forty", "fifty", "sixty", "seventy", "eighty", "ninety"];
  if (number3 < 0 || number3 > 9999) {
    return void 0;
  }
  if (number3 < 10) {
    return singleDigits[number3];
  }
  if (number3 < 20) {
    return teenNumbers[number3 - 10];
  }
  if (number3 < 100) {
    const tens = Math.floor(number3 / 10);
    const remainder2 = number3 % 10;
    if (remainder2 === 0) {
      return tensNumbers[tens];
    } else {
      return `${tensNumbers[tens]}_${singleDigits[remainder2]}`;
    }
  }
  if (number3 < 1e3) {
    const hundreds = Math.floor(number3 / 100);
    const remainder2 = number3 % 100;
    if (remainder2 === 0) {
      return `${singleDigits[hundreds]}_hundred`;
    } else {
      return `${singleDigits[hundreds]}_hundred_${convertNumberToSnakeCase(remainder2)}`;
    }
  }
  const thousands = Math.floor(number3 / 1e3);
  const remainder = number3 % 1e3;
  if (remainder === 0) {
    return `${singleDigits[thousands]}_thousand`;
  } else {
    return `${singleDigits[thousands]}_thousand_${convertNumberToSnakeCase(remainder)}`;
  }
}

// ../../cli/api-importers/openapi/openapi-ir/lib/utils/replaceStartingNumber.js
function replaceStartingNumber(input) {
  const matches = input.match(NUMERIC_REGEX);
  if (matches && matches[0] != null) {
    const numericPart = matches[0];
    const nonNumericPart = input.substring(numericPart.length);
    const parsedNumber = parseFloat(numericPart);
    if (!isNaN(parsedNumber) && isFinite(parsedNumber)) {
      const snakeCasedNumber = convertNumberToSnakeCase(parsedNumber);
      return nonNumericPart.length > 0 ? `${snakeCasedNumber}_${nonNumericPart}` : snakeCasedNumber;
    }
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir/lib/utils/generateEnumNameFromValue.js
function generateEnumNameFromValue(value) {
  const maybeParsedNumber = replaceStartingNumber(value);
  const maybeHardcodedEnumName = HARDCODED_ENUM_NAMES[value];
  if (maybeParsedNumber != null) {
    return upperFirst_default(camelCase_default(maybeParsedNumber));
  } else if (maybeHardcodedEnumName != null) {
    return maybeHardcodedEnumName;
  } else {
    if (value.toLowerCase() === "n/a") {
      return "NOT_APPLICABLE";
    }
    return upperFirst_default(camelCase_default(value));
  }
}

// ../../cli/api-importers/openapi/openapi-ir/lib/utils/isSchemaEqual.js
function isSchemaEqual(a, b) {
  if (a.type === "primitive" && b.type === "primitive") {
    return isPrimitiveSchemaValueEqual(a.schema, b.schema);
  } else if (a.type === "enum" && b.type === "enum") {
    return areEnumValuesEqual(a.values, b.values);
  } else if (a.type === "array" && b.type === "array") {
    return isSchemaEqual(a.value, b.value);
  } else if (a.type === "unknown" && b.type === "unknown") {
    return true;
  } else if (a.type === "reference" && b.type === "reference") {
    return a.schema === b.schema;
  } else if (a.type === "optional" && b.type === "optional") {
    return isSchemaEqual(a.value, b.value);
  } else if (a.type === "oneOf" && b.type === "oneOf") {
    return isOneOfEqual(a.value, b.value);
  } else if (a.type === "object" && b.type === "object") {
    return isObjectEqual(a, b);
  } else if (a.type === "map" && b.type === "map") {
    return isPrimitiveSchemaValueEqual(a.key.schema, b.key.schema) && isSchemaEqual(a.value, b.value);
  } else if (a.type === "literal" && b.type === "literal") {
    return a.value === b.value;
  }
  return false;
}
function isPrimitiveSchemaValueEqual(a, b) {
  return a.type === b.type;
}
function areEnumValuesEqual(a, b) {
  const aSet = new Set(...a.map((enumValue) => enumValue.value));
  const bSet = new Set(...b.map((enumValue) => enumValue.value));
  return isEqual_default(aSet, bSet);
}
function isOneOfEqual(a, b) {
  if (a.type === "discriminated" && b.type === "discriminated") {
    return a.discriminantProperty === b.discriminantProperty && Object.keys(a.schemas).length === Object.keys(b.schemas).length && Object.entries(a.schemas).every(([discrminant, aSchema]) => {
      const bSchema = b.schemas[discrminant];
      if (bSchema == null) {
        return false;
      }
      return isSchemaEqual(aSchema, bSchema);
    });
  }
  if (a.type === "undisciminated" && b.type === "undisciminated") {
    return a.schemas.length === b.schemas.length && a.schemas.every((aSchema, index) => {
      const bSchema = b.schemas[index];
      if (bSchema == null) {
        return false;
      }
      return isSchemaEqual(aSchema, bSchema);
    });
  }
  return false;
}
function isObjectEqual(a, b) {
  if (Object.keys(a.properties).length !== Object.keys(b.properties).length) {
    return false;
  }
  const aPropertyMap = Object.fromEntries(a.properties.map((property4) => {
    return [property4.key, property4.schema];
  }));
  return Object.entries(b.properties).every(([bPropertyName, bPropertySchema]) => {
    const aProperty = aPropertyMap[bPropertyName];
    if (aProperty == null) {
      return false;
    }
    return isSchemaEqual(aProperty, bPropertySchema.schema);
  });
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertToEncodingSchema.js
function convertToEncodingSchema(encoding) {
  switch (encoding.type) {
    case "protobuf":
      return {
        proto: {
          type: encoding.typeName
        }
      };
    default:
      assertNever(encoding.type);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getGroupNameForSchema.js
function getGroupNameForSchema(schema2) {
  switch (schema2.type) {
    case "object":
    case "enum":
    case "array":
    case "map":
    case "reference":
    case "literal":
    case "optional":
    case "nullable":
    case "primitive":
      return schema2.groupName ?? void 0;
    case "oneOf":
      return schema2.value.groupName ?? void 0;
    case "unknown":
      return void 0;
    default:
      assertNever(schema2);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getTypeFromTypeReference.js
function getTypeFromTypeReference(typeReference) {
  if (typeof typeReference === "string") {
    return typeReference;
  }
  return typeReference.type;
}
function getDocsFromTypeReference(typeReference) {
  if (typeof typeReference === "string") {
    return void 0;
  }
  return typeReference.docs;
}
function getDefaultFromTypeReference(typeReference) {
  if (typeof typeReference === "string") {
    return void 0;
  }
  return typeReference.default;
}
function getValidationFromTypeReference(typeReference) {
  if (typeof typeReference === "string") {
    return void 0;
  }
  return typeReference.validation;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertSdkGroupName.js
function cleanSdkGroupName(groupName) {
  const maybeNamespace = groupName.find((group) => typeof group === "object" && group.type === "namespace");
  const noNamespace = groupName.filter((group) => typeof group === "string" || group.type !== "namespace");
  return maybeNamespace ? [maybeNamespace, ...noNamespace] : noNamespace;
}
function convertSdkGroupNameToFileWithoutExtension(groupName) {
  const cleanedGroupName = groupName ? cleanSdkGroupName(groupName) : void 0;
  if (cleanedGroupName == null || cleanedGroupName.length === 0) {
    return FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION;
  }
  const fileNames = [];
  for (const [index, group] of cleanedGroupName.entries()) {
    if (typeof group === "string") {
      fileNames.push(camelCase_default(group));
    } else if (typeof group === "object") {
      switch (group.type) {
        case "namespace": {
          if (index < cleanedGroupName.length - 1) {
            fileNames.push(camelCase_default(group.name));
          } else {
            fileNames.push(...[group.name, FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION]);
          }
          break;
        }
        default:
          assertNever(group.type);
      }
    } else {
      assertNever(group);
    }
  }
  return fileNames.join("/");
}
function convertSdkGroupNameToFile(groupName) {
  return RelativeFilePath.of(`${convertSdkGroupNameToFileWithoutExtension(groupName)}.yml`);
}
function convertEndpointSdkNameToFileWithoutExtension({ sdkName, namespaceOverride }) {
  let groupName;
  if (sdkName == null || sdkName.groupName.length === 0 && namespaceOverride == null) {
    return FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION;
  } else if (namespaceOverride != null) {
    groupName = [
      { type: "namespace", name: namespaceOverride },
      ...sdkName.groupName.filter((group) => typeof group === "string" || group.type !== "namespace")
    ];
  } else {
    groupName = sdkName.groupName;
  }
  return convertSdkGroupNameToFileWithoutExtension(groupName);
}
function convertEndpointSdkNameToFile({ sdkName, namespaceOverride }) {
  return RelativeFilePath.of(`${convertEndpointSdkNameToFileWithoutExtension({ sdkName, namespaceOverride })}.yml`);
}
function resolveLocationWithNamespace({ location, namespaceOverride }) {
  if (namespaceOverride != null) {
    return join(RelativeFilePath.of(namespaceOverride), location);
  }
  return location;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertAvailability.js
function convertAvailability2(availability) {
  switch (availability) {
    case Availability.Deprecated:
      return "deprecated";
    case Availability.Beta:
      return "pre-release";
    case Availability.GenerallyAvailable:
      return "generally-available";
    default:
      return void 0;
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildTypeReference.js
var MIN_INT_32 = -2147483648;
var MAX_INT_32 = 2147483647;
var MIN_DOUBLE_64 = -17976931348623157e292;
var MAX_DOUBLE_64 = 17976931348623157e292;
function buildTypeReference({
  schema: schema2,
  /* The file the type reference will be written to */
  fileContainingReference,
  /* The file any type declarations will be written to. Defaults to fileContainingReference if not present */
  declarationFile = fileContainingReference,
  context,
  namespace,
  declarationDepth
}) {
  if (context.shouldMarkSchemaAsReferenced()) {
    context.markSchemaAsReferenced(schema2, namespace);
  }
  switch (schema2.type) {
    case "primitive": {
      return buildPrimitiveTypeReference(schema2);
    }
    case "array":
      return buildArrayTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    case "map":
      return buildMapTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    case "reference":
      return buildReferenceTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        namespace
      });
    case "unknown":
      return buildUnknownTypeReference();
    case "optional":
    case "nullable":
      return buildOptionalTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    case "enum":
      return buildEnumTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        declarationFile,
        declarationDepth
      });
    case "literal":
      schema2.value;
      return buildLiteralTypeReference(schema2);
    case "object":
      return buildObjectTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    case "oneOf":
      return buildOneOfTypeReference({
        schema: schema2.value,
        fileContainingReference,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    default:
      assertNever(schema2);
  }
}
function buildPrimitiveTypeReference(primitiveSchema) {
  switch (primitiveSchema.schema.type) {
    case "string":
      return buildStringTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
    case "int":
      return buildIntegerTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
    case "float":
      return buildFloatTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
    case "double":
      return buildDoubleTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
    case "boolean":
      return buildBooleanTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
    case "int64":
      return buildLongTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
  }
  const typeReference = primitiveSchema.schema._visit({
    int: () => "integer",
    int64: () => "long",
    uint: () => "uint",
    uint64: () => "uint64",
    float: () => "double",
    double: () => "double",
    string: () => "string",
    datetime: () => "datetime",
    date: () => "date",
    base64: () => "base64",
    boolean: () => "boolean",
    _other: () => "unknown"
  });
  if (primitiveSchema.description == null && primitiveSchema.title == null) {
    return typeReference;
  }
  return {
    type: typeReference,
    ...primitiveSchema.description != null ? { docs: primitiveSchema.description } : {},
    ...primitiveSchema.availability != null ? { availability: convertAvailability2(primitiveSchema.availability) } : {}
  };
}
function buildBooleanTypeReference({ description, schema: schema2 }) {
  const type2 = "boolean";
  if (description == null && schema2.default == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  if (schema2.default != null) {
    result.default = schema2.default;
  }
  return result;
}
function buildLongTypeReference({ description, schema: schema2 }) {
  const type2 = "long";
  if (description == null && schema2.default == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  if (schema2.default != null) {
    result.default = schema2.default;
  }
  return result;
}
function buildStringTypeReference({ description, schema: schema2 }) {
  const type2 = "string";
  const validation = maybeStringValidation(schema2);
  if (description == null && schema2.default == null && validation == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  if (schema2.default != null) {
    result.default = schema2.default;
  }
  if (validation != null) {
    result.validation = validation;
  }
  return result;
}
function buildIntegerTypeReference({ description, schema: schema2 }) {
  const type2 = "integer";
  const validation = maybeNumberValidation(schema2, type2);
  if (description == null && schema2.default == null && validation == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  if (schema2.default != null) {
    result.default = schema2.default;
  }
  if (validation != null) {
    result.validation = validation;
  }
  return result;
}
function buildFloatTypeReference({ description, schema: schema2 }) {
  const type2 = "float";
  if (description == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  return result;
}
function buildDoubleTypeReference({ description, schema: schema2 }) {
  const type2 = "double";
  const validation = maybeNumberValidation(schema2, type2);
  if (description == null && schema2.default == null && validation == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  if (schema2.default != null) {
    result.default = schema2.default;
  }
  if (validation != null) {
    result.validation = validation;
  }
  return result;
}
function maybeStringValidation(schema2) {
  if (schema2 == null) {
    return void 0;
  }
  const { format, pattern, minLength, maxLength } = schema2;
  const validFormat = maybeValidFormat(format);
  if (validFormat == null && pattern == null && minLength == null && maxLength == null) {
    return void 0;
  }
  return {
    format: validFormat,
    pattern,
    minLength,
    maxLength
  };
}
function maybeValidFormat(format) {
  switch (format) {
    case "date":
    case "date-time":
    case "password":
    case "byte":
    case "bytes":
    case "binary":
    case "email":
    case "uuid":
    case "uri":
    case "hostname":
    case "ipv4":
    case "ipv6":
      return format;
    default:
      return void 0;
  }
}
function maybeNumberValidation(schema2, type2) {
  if (schema2 == null) {
    return void 0;
  }
  let { minimum, maximum, multipleOf } = schema2;
  const { exclusiveMinimum, exclusiveMaximum } = schema2;
  minimum = makeUndefinedIfOutsideRange(minimum, type2);
  maximum = makeUndefinedIfOutsideRange(maximum, type2);
  multipleOf = makeUndefinedIfOutsideRange(multipleOf, type2);
  if (minimum == null && maximum == null && exclusiveMinimum == null && exclusiveMaximum == null && multipleOf == null) {
    return void 0;
  }
  return {
    min: minimum,
    max: maximum,
    exclusiveMin: exclusiveMinimum,
    exclusiveMax: exclusiveMaximum,
    multipleOf
  };
}
function makeUndefinedIfOutsideRange(num, type2) {
  if (num === void 0) {
    return void 0;
  }
  const [min, max] = type2 === "integer" ? [MIN_INT_32, MAX_INT_32] : [MIN_DOUBLE_64, MAX_DOUBLE_64];
  return num < min || num > max ? void 0 : num;
}
function buildReferenceTypeReference({ schema: schema2, fileContainingReference, context, namespace }) {
  const resolvedSchema = context.getSchema(schema2.schema, namespace);
  if (resolvedSchema == null) {
    return "unknown";
  }
  const schemaName = getSchemaName(resolvedSchema) ?? schema2.schema;
  const groupName = getGroupNameForSchema(resolvedSchema);
  const displayName = getDisplayName(resolvedSchema);
  const typeWithPrefix = getPrefixedType({
    context,
    fileContainingReference,
    declarationFile: convertSdkGroupNameToFile(groupName),
    type: schemaName
  });
  const type2 = resolvedSchema.type === "nullable" ? `optional<${typeWithPrefix}>` : typeWithPrefix;
  if (schema2.description == null && displayName == null) {
    return type2;
  }
  return {
    type: resolvedSchema.type === "nullable" ? `optional<${typeWithPrefix}>` : typeWithPrefix,
    ...schema2.description != null ? { docs: schema2.description } : {},
    ...schema2.availability != null ? { availability: convertAvailability2(schema2.availability) } : {}
  };
}
function buildArrayTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, namespace, declarationDepth }) {
  const item = buildTypeReference({
    schema: schema2.value,
    fileContainingReference,
    declarationFile,
    context,
    namespace,
    declarationDepth
  });
  const type2 = `list<${getTypeFromTypeReference(item)}>`;
  if (schema2.description == null && schema2.title == null) {
    return type2;
  }
  return {
    ...schema2.description != null ? { docs: schema2.description } : {},
    ...schema2.availability != null ? { availability: convertAvailability2(schema2.availability) } : {},
    type: type2
  };
}
function buildMapTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, namespace, declarationDepth }) {
  const keyTypeReference = buildPrimitiveTypeReference(schema2.key);
  const valueTypeReference = buildTypeReference({
    schema: schema2.value,
    fileContainingReference,
    declarationFile,
    context,
    namespace,
    declarationDepth
  });
  const encoding = schema2.encoding != null ? convertToEncodingSchema(schema2.encoding) : void 0;
  const type2 = `map<${getTypeFromTypeReference(keyTypeReference)}, ${getTypeFromTypeReference(valueTypeReference)}>`;
  if (schema2.description == null && encoding == null && schema2.title == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (schema2.description != null) {
    result.docs = schema2.description;
  }
  if (schema2.encoding != null) {
    result.encoding = encoding;
  }
  if (schema2.availability != null) {
    result.availability = convertAvailability2(schema2.availability);
  }
  return result;
}
function buildOptionalTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, namespace, declarationDepth }) {
  const itemTypeReference = buildTypeReference({
    schema: schema2.value,
    fileContainingReference,
    declarationFile,
    context,
    namespace,
    declarationDepth
  });
  const itemType = getTypeFromTypeReference(itemTypeReference);
  const itemDocs = getDocsFromTypeReference(itemTypeReference);
  const itemDefault = getDefaultFromTypeReference(itemTypeReference);
  const itemValidation = getValidationFromTypeReference(itemTypeReference);
  const type2 = itemType.startsWith("optional<") ? itemType : `optional<${itemType}>`;
  if (schema2.availability == null && schema2.description == null && itemDocs == null && itemDefault == null && itemValidation == null && schema2.title == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (schema2.description != null || itemDocs != null) {
    result.docs = schema2.description ?? itemDocs;
  }
  if (itemDefault != null) {
    result.default = itemDefault;
  }
  if (itemValidation != null) {
    result.validation = itemValidation;
  }
  if (schema2.availability != null) {
    result.availability = convertAvailability2(schema2.availability);
  }
  return result;
}
function buildUnknownTypeReference() {
  return "unknown";
}
function buildLiteralTypeReference(schema2) {
  let value;
  switch (schema2.value.type) {
    case "boolean": {
      value = `literal<${schema2.value.value}>`;
      break;
    }
    case "string": {
      value = `literal<"${schema2.value.value}">`;
      break;
    }
    default:
      assertNever(schema2.value);
  }
  if (schema2.description == null && schema2.title == null) {
    return value;
  }
  return {
    type: value,
    ...schema2.description != null ? { docs: schema2.description } : {},
    ...schema2.availability != null ? { availability: convertAvailability2(schema2.availability) } : {}
  };
}
function buildEnumTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, declarationDepth }) {
  const enumTypeDeclaration = buildEnumTypeDeclaration(schema2, declarationDepth);
  const name = schema2.nameOverride ?? schema2.generatedName;
  context.builder.addType(declarationFile, {
    name,
    schema: enumTypeDeclaration.schema
  });
  const prefixedType = getPrefixedType({ type: name, fileContainingReference, declarationFile, context });
  if (schema2.description == null && schema2.default == null && schema2.title == null) {
    return prefixedType;
  }
  const result = {
    type: prefixedType
  };
  if (schema2.description != null) {
    result.docs = schema2.description;
  }
  if (schema2.default != null) {
    result.default = schema2.default.value;
  }
  if (schema2.availability != null) {
    result.availability = convertAvailability2(schema2.availability);
  }
  return result;
}
function buildObjectTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, namespace, declarationDepth }) {
  const objectTypeDeclaration = buildObjectTypeDeclaration({
    schema: schema2,
    declarationFile,
    context,
    namespace,
    declarationDepth
  });
  const name = schema2.nameOverride ?? schema2.generatedName;
  context.builder.addType(declarationFile, {
    name,
    schema: objectTypeDeclaration.schema
  });
  const prefixedType = getPrefixedType({ type: name, fileContainingReference, declarationFile, context });
  if (schema2.description == null && schema2.title == null) {
    return prefixedType;
  }
  return {
    type: prefixedType,
    ...schema2.description != null ? { docs: schema2.description } : {},
    ...schema2.availability != null ? { availability: convertAvailability2(schema2.availability) } : {}
  };
}
function buildOneOfTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, namespace, declarationDepth }) {
  const unionTypeDeclaration = buildOneOfTypeDeclaration({
    schema: schema2,
    declarationFile,
    context,
    namespace,
    declarationDepth
  });
  const name = schema2.nameOverride ?? schema2.generatedName;
  context.builder.addType(declarationFile, {
    name,
    schema: unionTypeDeclaration.schema
  });
  const prefixedType = getPrefixedType({ type: name, fileContainingReference, declarationFile, context });
  if (schema2.description == null && schema2.title == null) {
    return prefixedType;
  }
  return {
    ...schema2.title != null ? { "display-name": schema2.title } : {},
    type: prefixedType,
    ...schema2.description != null ? { docs: schema2.description } : {},
    ...schema2.availability != null ? { availability: convertAvailability2(schema2.availability) } : {}
  };
}
function getPrefixedType({ type: type2, fileContainingReference, declarationFile, context }) {
  if (declarationFile === fileContainingReference) {
    return type2;
  }
  const prefix = context.builder.addImport({
    file: fileContainingReference,
    fileToImport: declarationFile
  });
  return prefix != null ? `${prefix}.${type2}` : type2;
}
function getSchemaName(schema2) {
  return Schema._visit(schema2, {
    primitive: (s) => s.nameOverride ?? s.generatedName,
    object: (s) => s.nameOverride ?? s.generatedName,
    array: (s) => s.nameOverride ?? s.generatedName,
    map: (s) => s.nameOverride ?? s.generatedName,
    enum: (s) => s.nameOverride ?? s.generatedName,
    reference: (s) => s.nameOverride ?? s.generatedName,
    literal: (s) => s.nameOverride ?? s.generatedName,
    oneOf: (s) => s.nameOverride ?? s.generatedName,
    optional: (s) => s.nameOverride ?? s.generatedName,
    nullable: (s) => s.nameOverride ?? s.generatedName,
    unknown: (s) => s.nameOverride ?? s.generatedName,
    _other: () => void 0
  });
}
function getDisplayName(schema2) {
  return Schema._visit(schema2, {
    primitive: (s) => s.title,
    object: (s) => s.title,
    array: (s) => s.title,
    map: (s) => s.title,
    enum: (s) => s.title,
    reference: (s) => s.title,
    literal: (s) => s.title,
    oneOf: (s) => s.title,
    optional: (s) => s.title,
    nullable: (s) => s.title,
    unknown: (s) => void 0,
    _other: () => void 0
  });
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertToSourceSchema.js
function convertToSourceSchema(source) {
  switch (source.type) {
    case "openapi":
      return {
        openapi: source.file
      };
    case "protobuf":
      return {
        proto: source.file
      };
    default:
      assertNever(source);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/State.js
var State;
(function(State3) {
  State3[State3["Channel"] = 0] = "Channel";
  State3[State3["Endpoint"] = 1] = "Endpoint";
  State3[State3["Request"] = 2] = "Request";
  State3[State3["Webhook"] = 3] = "Webhook";
})(State || (State = {}));

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildTypeDeclaration.js
function buildTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  switch (schema2.type) {
    case "primitive":
      return buildPrimitiveTypeDeclaration(schema2);
    case "array":
      return buildArrayTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth });
    case "map":
      return buildMapTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth });
    case "reference":
      return buildReferenceTypeDeclaration({ schema: schema2, context, declarationFile, namespace });
    case "unknown":
      return buildUnknownTypeDeclaration(schema2.nameOverride, schema2.generatedName);
    case "optional":
    case "nullable":
      return buildOptionalTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth });
    case "enum":
      return buildEnumTypeDeclaration(schema2, declarationDepth);
    case "literal":
      return buildLiteralTypeDeclaration(schema2, schema2.nameOverride, schema2.generatedName);
    case "object":
      return buildObjectTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth });
    case "oneOf":
      return buildOneOfTypeDeclaration({
        schema: schema2.value,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    default:
      assertNever(schema2);
  }
}
function buildObjectTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  const shouldSkipReadonly = context.isInState(State.Request) && context.respectReadonlySchemas && (context.getEndpointMethod() === "POST" || context.getEndpointMethod() === "PUT" || context.getEndpointMethod() === "PATCH");
  let readOnlyPropertyPresent = false;
  const properties = {};
  const schemasToInline = /* @__PURE__ */ new Set();
  for (const property4 of schema2.properties) {
    if (property4.readonly) {
      readOnlyPropertyPresent = true;
    }
    if (shouldSkipReadonly && property4.readonly) {
      continue;
    }
    if (Object.keys(property4.conflict).length > 0) {
      const parentHasIdentiticalProperty = Object.entries(property4.conflict).every(([_, conflict]) => {
        return !conflict.differentSchema;
      });
      if (parentHasIdentiticalProperty) {
        continue;
      } else {
        Object.entries(property4.conflict).forEach(([schemaId]) => {
          const parentSchemasToInine = getAllParentSchemasToInline({
            property: property4.key,
            schemaId,
            context,
            namespace
          });
          parentSchemasToInine.forEach((schemaToInline) => {
            schemasToInline.add(schemaToInline);
          });
        });
      }
    }
    const typeReference = buildTypeReference({
      schema: property4.schema,
      context,
      fileContainingReference: declarationFile,
      namespace,
      declarationDepth: declarationDepth + 1
    });
    const audiences = property4.audiences;
    const name2 = property4.nameOverride;
    const availability = convertAvailability2(property4.availability);
    properties[property4.key] = convertPropertyTypeReferenceToTypeDefinition({
      typeReference,
      audiences,
      name: name2,
      availability
    });
  }
  const propertiesToSetToUnknown = /* @__PURE__ */ new Set();
  for (const allOfPropertyConflict of schema2.allOfPropertyConflicts) {
    allOfPropertyConflict.allOfSchemaIds.forEach((schemaId) => schemasToInline.add(schemaId));
    if (allOfPropertyConflict.conflictingTypeSignatures) {
      propertiesToSetToUnknown.add(allOfPropertyConflict.propertyKey);
    }
  }
  const extendedSchemas = [];
  for (const allOf of schema2.allOf) {
    const resolvedSchemaId = getSchemaIdOfResolvedType({ schema: allOf.schema, context, namespace });
    if (resolvedSchemaId == null) {
      continue;
    }
    if (schemasToInline.has(allOf.schema) || schemasToInline.has(resolvedSchemaId)) {
      continue;
    }
    const allOfTypeReference = buildTypeReference({
      schema: Schema.reference(allOf),
      context,
      fileContainingReference: declarationFile,
      namespace,
      declarationDepth: declarationDepth + 1
    });
    extendedSchemas.push(getTypeFromTypeReference(allOfTypeReference));
  }
  for (const inlineSchemaId of schemasToInline) {
    const inlinedSchemaPropertyInfo = getProperties(context, inlineSchemaId, namespace);
    for (const propertyToInline of inlinedSchemaPropertyInfo.properties) {
      if (properties[propertyToInline.key] == null) {
        if (propertiesToSetToUnknown.has(propertyToInline.key)) {
          properties[propertyToInline.key] = "unknown";
        }
        properties[propertyToInline.key] = buildTypeReference({
          schema: propertyToInline.schema,
          context,
          fileContainingReference: declarationFile,
          namespace,
          declarationDepth: declarationDepth + 1
        });
      }
    }
    for (const extendedSchema of inlinedSchemaPropertyInfo.allOf) {
      if (schemasToInline.has(extendedSchema.schema)) {
        continue;
      }
      const extendedSchemaTypeReference = buildTypeReference({
        schema: Schema.reference(extendedSchema),
        context,
        fileContainingReference: declarationFile,
        namespace,
        declarationDepth: declarationDepth + 1
      });
      extendedSchemas.push(getTypeFromTypeReference(extendedSchemaTypeReference));
    }
  }
  const objectTypeDeclaration = {
    docs: schema2.description ?? void 0,
    properties: Object.fromEntries(Object.entries(properties).map(([propertyKey, propertyDefinition]) => {
      if (startsWithNumber2(propertyKey)) {
        return [
          propertyKey,
          typeof propertyDefinition === "string" ? {
            type: propertyDefinition,
            name: `_${propertyKey}`
          } : {
            ...propertyDefinition,
            name: `_${propertyKey}`
          }
        ];
      }
      return [propertyKey, propertyDefinition];
    }))
  };
  if (extendedSchemas.length > 0) {
    objectTypeDeclaration.extends = extendedSchemas;
  }
  if (schema2.additionalProperties) {
    objectTypeDeclaration["extra-properties"] = true;
  }
  if (schema2.availability != null) {
    objectTypeDeclaration.availability = convertAvailability2(schema2.availability);
  }
  if (schema2.source != null) {
    objectTypeDeclaration.source = convertToSourceSchema(schema2.source);
  }
  objectTypeDeclaration.inline = getInline(declarationDepth);
  const name = schema2.nameOverride ?? schema2.generatedName;
  return {
    name: readOnlyPropertyPresent && context.respectReadonlySchemas && !shouldSkipReadonly ? `${name}Read` : name,
    schema: objectTypeDeclaration
  };
}
function getAllParentSchemasToInline({ property: property4, schemaId, context, namespace }) {
  const schema2 = context.getSchema(schemaId, namespace);
  if (schema2 == null) {
    return [];
  }
  if (schema2.type === "reference") {
    return getAllParentSchemasToInline({ property: property4, schemaId: schema2.schema, context, namespace });
  }
  if (schema2.type === "object") {
    const { properties, allOf } = getProperties(context, schemaId, namespace);
    const hasProperty = properties.some((p) => {
      return p.key === property4;
    });
    const parentSchemasToInline = [
      ...allOf.flatMap((parent) => {
        return getAllParentSchemasToInline({ property: property4, context, schemaId: parent.schema, namespace });
      })
    ];
    if (hasProperty || parentSchemasToInline.length > 0) {
      return [schemaId, ...parentSchemasToInline];
    }
  }
  return [];
}
function getProperties(context, schemaId, namespace) {
  const schema2 = context.getSchema(schemaId, namespace);
  if (schema2 == null) {
    return { properties: [], allOf: [] };
  }
  if (schema2.type === "object") {
    return { properties: schema2.properties, allOf: schema2.allOf };
  } else if (schema2.type === "reference") {
    return getProperties(context, schema2.schema, namespace);
  }
  throw new Error(`Cannot getAllProperties for a non-object schema. schemaId=${schemaId}, type=${schema2.type}`);
}
function buildArrayTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: buildArrayTypeReference({
      schema: schema2,
      fileContainingReference: declarationFile,
      declarationFile,
      context,
      namespace,
      declarationDepth
    })
  };
}
function buildMapTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: buildMapTypeReference({
      schema: schema2,
      fileContainingReference: declarationFile,
      declarationFile,
      context,
      namespace,
      declarationDepth
    })
  };
}
function buildPrimitiveTypeDeclaration(schema2) {
  const typeReference = buildPrimitiveTypeReference(schema2);
  if (typeof typeReference === "string") {
    return {
      name: schema2.nameOverride ?? schema2.generatedName,
      schema: typeReference
    };
  }
  const { default: _, ...rest } = typeReference;
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: {
      ...rest
    }
  };
}
function isCasingEmpty(casing) {
  return casing.camel == null && casing.pascal == null && casing.screamingSnake == null && casing.snake == null;
}
function buildEnumTypeDeclaration(schema2, declarationDepth) {
  const enumSchema = {
    enum: schema2.values.map((enumValue) => {
      const name = enumValue.nameOverride ?? enumValue.generatedName;
      const value = enumValue.value;
      if (name === value && enumValue.description == null && (enumValue.casing == null || isCasingEmpty(enumValue.casing))) {
        return name;
      }
      const enumValueDeclaration = {
        value: enumValue.value
      };
      if (name !== value) {
        enumValueDeclaration.name = name;
      }
      if (enumValue.description != null) {
        enumValueDeclaration.docs = enumValue.description;
      }
      if (enumValue.casing != null && !isCasingEmpty(enumValue.casing)) {
        const casing = {};
        let setCasing = false;
        if (enumValue.casing.camel != null) {
          casing.camel = enumValue.casing.camel;
          setCasing = true;
        }
        if (enumValue.casing.screamingSnake != null) {
          casing["screaming-snake"] = enumValue.casing.screamingSnake;
          setCasing = true;
        }
        if (enumValue.casing.snake != null) {
          casing.snake = enumValue.casing.snake;
          setCasing = true;
        }
        if (enumValue.casing.pascal != null) {
          casing.pascal = enumValue.casing.pascal;
          setCasing = true;
        }
        if (setCasing) {
          enumValueDeclaration.casing = casing;
        }
      }
      return enumValueDeclaration;
    })
  };
  if (schema2.description != null) {
    enumSchema.docs = schema2.description;
  }
  if (schema2.default != null) {
    enumSchema.default = schema2.default.value;
  }
  const uniqueEnumName = /* @__PURE__ */ new Set();
  const uniqueEnumSchema = {
    ...enumSchema,
    enum: [],
    source: schema2.source != null ? convertToSourceSchema(schema2.source) : void 0
  };
  for (const enumValue of enumSchema.enum) {
    const name = typeof enumValue === "string" ? enumValue : enumValue.name ?? enumValue.value;
    if (!uniqueEnumName.has(name.toLowerCase())) {
      uniqueEnumSchema.enum.push(enumValue);
      uniqueEnumName.add(name.toLowerCase());
    }
  }
  enumSchema.inline = getInline(declarationDepth);
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: uniqueEnumSchema
  };
}
function buildReferenceTypeDeclaration({ schema: schema2, context, declarationFile, namespace }) {
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: buildReferenceTypeReference({
      schema: schema2,
      context,
      fileContainingReference: declarationFile,
      namespace
    })
  };
}
function buildOptionalTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: buildOptionalTypeReference({
      schema: schema2,
      context,
      fileContainingReference: declarationFile,
      declarationFile,
      namespace,
      declarationDepth
    })
  };
}
function buildUnknownTypeDeclaration(nameOverride, generatedName) {
  return {
    name: nameOverride ?? generatedName,
    schema: buildUnknownTypeReference()
  };
}
function buildLiteralTypeDeclaration(schema2, nameOverride, generatedName) {
  return {
    name: nameOverride ?? generatedName,
    schema: buildLiteralTypeReference(schema2)
  };
}
function buildOneOfTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  const encoding = schema2.encoding != null ? convertToEncodingSchema(schema2.encoding) : void 0;
  if (schema2.type === "discriminated") {
    const baseProperties = {};
    for (const property4 of schema2.commonProperties) {
      baseProperties[property4.key] = buildTypeReference({
        schema: property4.schema,
        fileContainingReference: declarationFile,
        context,
        namespace,
        declarationDepth: declarationDepth + 1
      });
    }
    const union4 = {};
    for (const [discriminantValue, subSchema] of Object.entries(schema2.schemas)) {
      union4[discriminantValue] = buildTypeReference({
        schema: subSchema,
        context,
        fileContainingReference: declarationFile,
        namespace,
        declarationDepth: declarationDepth + 1
      });
    }
    return {
      name: schema2.nameOverride ?? schema2.generatedName,
      schema: {
        discriminant: schema2.discriminantProperty,
        "base-properties": baseProperties,
        docs: schema2.description ?? void 0,
        availability: schema2.availability != null ? convertAvailability2(schema2.availability) : void 0,
        union: union4,
        encoding,
        source: schema2.source != null ? convertToSourceSchema(schema2.source) : void 0
      }
    };
  }
  const union3 = [];
  for (const subSchema of schema2.schemas) {
    union3.push(buildTypeReference({
      schema: subSchema,
      fileContainingReference: declarationFile,
      context,
      namespace,
      declarationDepth: declarationDepth + 1
    }));
  }
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: {
      discriminated: false,
      docs: schema2.description ?? void 0,
      union: union3,
      encoding,
      source: schema2.source != null ? convertToSourceSchema(schema2.source) : void 0,
      inline: getInline(declarationDepth)
    }
  };
}
var STARTS_WITH_NUMBER2 = /^[0-9]/;
function startsWithNumber2(str2) {
  return STARTS_WITH_NUMBER2.test(str2);
}
function getSchemaIdOfResolvedType({ schema: schema2, context, namespace }) {
  const resolvedSchema = context.getSchema(schema2, namespace);
  if (resolvedSchema == null) {
    return void 0;
  }
  if (resolvedSchema.type === "reference") {
    return getSchemaIdOfResolvedType({ context, schema: resolvedSchema.schema, namespace });
  }
  return schema2;
}
function convertPropertyTypeReferenceToTypeDefinition({ typeReference, audiences, name, availability }) {
  if (audiences.length === 0 && name == null && availability == null) {
    return typeReference;
  } else {
    return {
      ...typeof typeReference === "string" ? { type: typeReference } : { ...typeReference },
      ...audiences.length > 0 ? { audiences } : {},
      ...name != null ? { name } : {},
      ...availability != null ? { availability } : {}
    };
  }
}
function getInline(declarationDepth) {
  return declarationDepth > 0 ? true : void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getHeaderName.js
function getHeaderName(headerWireKey) {
  const headerWithoutXPrefix = headerWireKey.replace(/^x-|^X-/, "");
  return camelCase_default(headerWithoutXPrefix);
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildAuthSchemes.js
var BASIC_AUTH_SCHEME = "BasicAuthScheme";
var BEARER_AUTH_SCHEME = "BearerAuthScheme";
function buildAuthSchemes(context) {
  if (context.authOverrides != null) {
    for (const [name, declaration] of Object.entries(context.authOverrides["auth-schemes"] ?? {})) {
      context.builder.addAuthScheme({
        name,
        schema: declaration
      });
    }
    if (context.authOverrides.auth != null) {
      context.builder.setAuth(context.authOverrides.auth);
    }
    return;
  }
  let setAuth = false;
  for (const [id, securityScheme] of Object.entries(context.ir.securitySchemes)) {
    if (securityScheme.type === "basic") {
      const basicAuthScheme = {
        scheme: "basic"
      };
      if (securityScheme.usernameVariableName != null) {
        if (basicAuthScheme.username === void 0) {
          basicAuthScheme.username = {
            name: securityScheme.usernameVariableName
          };
        } else {
          basicAuthScheme.username.name = securityScheme.usernameVariableName;
        }
      }
      if (securityScheme.usernameEnvVar != null) {
        if (basicAuthScheme.username === void 0) {
          basicAuthScheme.username = {
            env: securityScheme.usernameEnvVar
          };
        } else {
          basicAuthScheme.username.env = securityScheme.usernameEnvVar;
        }
      }
      if (securityScheme.passwordVariableName != null) {
        if (basicAuthScheme.password === void 0) {
          basicAuthScheme.password = {
            name: securityScheme.passwordVariableName
          };
        } else {
          basicAuthScheme.password.name = securityScheme.passwordVariableName;
        }
      }
      if (securityScheme.passwordEnvVar != null) {
        if (basicAuthScheme.password === void 0) {
          basicAuthScheme.password = {
            env: securityScheme.passwordEnvVar
          };
        } else {
          basicAuthScheme.password.env = securityScheme.passwordEnvVar;
        }
      }
      context.builder.addAuthScheme({
        name: BASIC_AUTH_SCHEME,
        schema: basicAuthScheme
      });
      if (!setAuth) {
        context.builder.setAuth(BASIC_AUTH_SCHEME);
        setAuth = true;
      }
    } else if (securityScheme.type === "bearer") {
      const bearerAuthScheme = {
        scheme: "bearer"
      };
      if (securityScheme.tokenVariableName != null) {
        if (bearerAuthScheme.token === void 0) {
          bearerAuthScheme.token = {
            name: securityScheme.tokenVariableName
          };
        } else {
          bearerAuthScheme.token.name = securityScheme.tokenVariableName;
        }
      }
      if (securityScheme.tokenEnvVar != null) {
        if (bearerAuthScheme.token === void 0) {
          bearerAuthScheme.token = {
            env: securityScheme.tokenEnvVar
          };
        } else {
          bearerAuthScheme.token.env = securityScheme.tokenEnvVar;
        }
      }
      context.builder.addAuthScheme({
        name: BEARER_AUTH_SCHEME,
        schema: bearerAuthScheme
      });
      if (!setAuth) {
        context.builder.setAuth(BEARER_AUTH_SCHEME);
        setAuth = true;
      }
    } else if (securityScheme.type === "header") {
      if (!setAuth) {
        const schema2 = {
          header: securityScheme.headerName,
          name: securityScheme.headerVariableName ?? "apiKey",
          type: "string"
        };
        if (securityScheme.headerEnvVar != null) {
          schema2.env = securityScheme.headerEnvVar;
        }
        if (securityScheme.prefix != null) {
          schema2.prefix = securityScheme.prefix;
        }
        context.builder.addAuthScheme({
          name: id,
          schema: schema2
        });
        context.builder.setAuth(id);
        setAuth = true;
      } else {
        context.builder.addGlobalHeader({
          name: securityScheme.headerName,
          schema: {
            type: "string",
            name: securityScheme.headerVariableName ?? getHeaderName(securityScheme.headerName),
            env: securityScheme.headerEnvVar
          }
        });
      }
    } else if (securityScheme.type === "oauth") {
      const bearerAuthScheme = {
        scheme: "bearer"
      };
      context.builder.addAuthScheme({
        name: BEARER_AUTH_SCHEME,
        schema: bearerAuthScheme
      });
      if (!setAuth) {
        context.builder.setAuth(BEARER_AUTH_SCHEME);
        setAuth = true;
      }
      if (securityScheme.scopesEnum != null && securityScheme.scopesEnum.values.length > 0) {
        context.builder.addType(RelativeFilePath.of("__package__.yml"), {
          name: "OauthScope",
          schema: buildEnumTypeDeclaration(securityScheme.scopesEnum, 0).schema
        });
      }
    }
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildHeader.js
function buildHeader({ header, context, fileContainingReference, namespace }) {
  const typeReference = buildTypeReference({
    schema: header.schema,
    context,
    fileContainingReference,
    namespace,
    declarationDepth: 0
  });
  const headerType = getTypeFromTypeReference(typeReference);
  const headerWithoutXPrefix = header.name.replace(/^x-|^X-/, "");
  const headerVariableName = header.parameterNameOverride != null ? header.parameterNameOverride : camelCase_default(headerWithoutXPrefix);
  if (header.description == null && header.name === headerVariableName && header.env == null && header.availability == null) {
    return headerType;
  }
  const headerSchema = {
    type: headerType
  };
  if (headerVariableName !== header.name) {
    headerSchema.name = headerVariableName;
  }
  if (header.description != null) {
    headerSchema.docs = header.description;
  }
  if (header.env != null) {
    headerSchema.env = header.env;
  }
  if (header.availability != null) {
    headerSchema.availability = convertAvailability2(header.availability);
  }
  return headerSchema;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildPathParameter.js
function buildPathParameter({ pathParameter, context, fileContainingReference, namespace }) {
  const typeReference = buildTypeReference({
    schema: pathParameter.schema,
    context,
    fileContainingReference,
    namespace,
    declarationDepth: 0
  });
  if (pathParameter.variableReference == null && pathParameter.description == null && pathParameter.availability == null) {
    return getTypeFromTypeReference(typeReference);
  }
  const pathParameterSchema = pathParameter.variableReference != null ? {
    variable: `$${pathParameter.variableReference}`
  } : {
    type: getTypeFromTypeReference(typeReference)
  };
  if (pathParameter.description != null) {
    pathParameterSchema.docs = pathParameter.description;
  }
  if (pathParameter.availability != null) {
    pathParameterSchema.availability = convertAvailability2(pathParameter.availability);
  }
  return pathParameterSchema;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildQueryParameter.js
function buildQueryParameter({ queryParameter, context, fileContainingReference, namespace }) {
  const typeReference = getQueryParameterTypeReference({
    schema: queryParameter.schema,
    context,
    fileContainingReference,
    namespace
  });
  if (typeReference == null) {
    return void 0;
  }
  let queryParameterType = getTypeFromTypeReference(typeReference.value);
  if (queryParameterType === "unknown") {
    queryParameterType = "string";
  } else if (queryParameterType === "optional<unknown>") {
    queryParameterType = "optional<string>";
  }
  if (queryParameter.description == null && !typeReference.allowMultiple && queryParameter.parameterNameOverride == null && queryParameter.availability == null) {
    return queryParameterType;
  }
  const queryParameterSchema = {
    type: queryParameterType
  };
  if (typeReference.allowMultiple) {
    queryParameterSchema["allow-multiple"] = true;
  }
  if (queryParameter.description != null) {
    queryParameterSchema.docs = queryParameter.description;
  }
  if (queryParameter.parameterNameOverride != null) {
    queryParameterSchema.name = queryParameter.parameterNameOverride;
  }
  if (queryParameter.availability != null) {
    queryParameterSchema.availability = convertAvailability2(queryParameter.availability);
  }
  if (isRawTypeReferenceDetailedSchema(typeReference.value)) {
    if (typeReference.value.validation !== void 0) {
      queryParameterSchema.validation = typeReference.value.validation;
    }
  }
  return queryParameterSchema;
}
function getQueryParameterTypeReference({ schema: schema2, context, fileContainingReference, namespace }) {
  if (schema2.type === "reference") {
    const resolvedSchema = context.getSchema(schema2.schema, namespace);
    if (resolvedSchema == null) {
      return void 0;
    } else if (resolvedSchema.type === "array") {
      return {
        value: buildTypeReference({
          schema: Schema.optional({
            nameOverride: schema2.nameOverride,
            generatedName: schema2.generatedName,
            title: schema2.title,
            value: resolvedSchema.value,
            description: schema2.description ?? resolvedSchema.description,
            availability: schema2.availability,
            groupName: void 0
          }),
          context,
          declarationFile: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
          fileContainingReference,
          namespace,
          declarationDepth: 0
        }),
        allowMultiple: true
      };
    } else if (resolvedSchema.type === "oneOf" && resolvedSchema.value.type === "undisciminated") {
      const potentialEnumValues = [];
      for (const [_, schema3] of Object.entries(resolvedSchema.value.schemas)) {
        if (schema3.type === "literal" && schema3.value.type === "string") {
          if (VALID_ENUM_NAME_REGEX.test(schema3.value.value)) {
            potentialEnumValues.push(schema3.value.value);
          } else {
            potentialEnumValues.push({
              value: schema3.value.value,
              name: generateEnumNameFromValue(schema3.value.value)
            });
          }
        }
      }
      if (potentialEnumValues.length > 0) {
        context.builder.addType(fileContainingReference, {
          name: schema2.generatedName,
          schema: { enum: potentialEnumValues }
        });
        return {
          value: schema2.generatedName,
          allowMultiple: false
        };
      }
      if (resolvedSchema.value.schemas.length === 2) {
        const [firstSchema, secondSchema] = resolvedSchema.value.schemas;
        if (firstSchema != null && secondSchema != null && hasSamePrimitiveValueType({ array: firstSchema, primitive: secondSchema })) {
          return {
            value: buildTypeReference({
              schema: Schema.optional({
                nameOverride: schema2.nameOverride,
                generatedName: schema2.generatedName,
                title: schema2.title,
                value: secondSchema,
                description: schema2.description,
                availability: schema2.availability,
                groupName: void 0
              }),
              context,
              fileContainingReference,
              namespace,
              declarationDepth: 0
            }),
            allowMultiple: true
          };
        }
        if (firstSchema != null && secondSchema != null && hasSamePrimitiveValueType({ array: firstSchema, primitive: secondSchema })) {
          return {
            value: buildTypeReference({
              schema: Schema.optional({
                nameOverride: schema2.nameOverride,
                generatedName: schema2.generatedName,
                title: schema2.title,
                value: firstSchema,
                description: schema2.description,
                availability: schema2.availability,
                groupName: void 0
              }),
              context,
              fileContainingReference,
              namespace,
              declarationDepth: 0
            }),
            allowMultiple: true
          };
        }
      }
      for (const [_, schema3] of Object.entries(resolvedSchema.value.schemas)) {
        return getQueryParameterTypeReference({
          schema: schema3,
          context,
          fileContainingReference,
          namespace
        });
      }
    } else if (context.objectQueryParameters) {
      return {
        value: buildTypeReference({
          schema: schema2,
          context,
          fileContainingReference,
          declarationFile: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
          namespace,
          declarationDepth: 0
        }),
        allowMultiple: false
      };
    }
  }
  if (schema2.type === "optional" || schema2.type === "nullable") {
    if (schema2.value.type === "reference") {
      const resolvedSchema = context.getSchema(schema2.value.schema, namespace);
      if (resolvedSchema == null) {
        return void 0;
      } else if (resolvedSchema.type === "array") {
        return {
          value: buildTypeReference({
            schema: Schema.optional({
              nameOverride: schema2.nameOverride,
              generatedName: schema2.generatedName,
              title: schema2.title,
              value: resolvedSchema.value,
              description: schema2.description ?? resolvedSchema.description,
              availability: schema2.availability,
              groupName: void 0
            }),
            context,
            fileContainingReference,
            declarationFile: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
            namespace,
            declarationDepth: 0
          }),
          allowMultiple: true
        };
      } else if (context.objectQueryParameters) {
        return {
          value: buildTypeReference({
            schema: schema2,
            context,
            fileContainingReference,
            declarationFile: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
            namespace,
            declarationDepth: 0
          }),
          allowMultiple: false
        };
      }
    }
    if (schema2.value.type === "array") {
      return {
        value: buildTypeReference({
          schema: Schema.optional({
            nameOverride: schema2.nameOverride,
            generatedName: schema2.generatedName,
            title: schema2.title,
            value: schema2.value.value,
            description: schema2.description,
            availability: schema2.availability,
            groupName: void 0
          }),
          context,
          fileContainingReference,
          namespace,
          declarationDepth: 0
        }),
        allowMultiple: true
      };
    } else if (schema2.value.type === "oneOf" && schema2.value.value.type === "undisciminated") {
      const potentialEnumValues = [];
      for (const [_, oneOfSchema] of Object.entries(schema2.value.value.schemas)) {
        if (oneOfSchema.type === "literal" && oneOfSchema.value.type === "string") {
          if (VALID_ENUM_NAME_REGEX.test(oneOfSchema.value.value)) {
            potentialEnumValues.push(oneOfSchema.value.value);
          } else {
            potentialEnumValues.push({
              value: oneOfSchema.value.value,
              name: generateEnumNameFromValue(oneOfSchema.value.value)
            });
          }
        }
      }
      if (potentialEnumValues.length > 0) {
        context.builder.addType(fileContainingReference, {
          name: schema2.generatedName,
          schema: { enum: potentialEnumValues }
        });
        return {
          value: `optional<${schema2.value.value.generatedName}>`,
          allowMultiple: false
        };
      }
      if (schema2.value.value.schemas.length === 2) {
        const [firstSchema, secondSchema] = schema2.value.value.schemas;
        if (firstSchema != null && secondSchema != null && hasSamePrimitiveValueType({ array: firstSchema, primitive: secondSchema })) {
          return {
            value: buildTypeReference({
              schema: Schema.optional({
                nameOverride: schema2.nameOverride,
                generatedName: schema2.generatedName,
                title: schema2.title,
                value: secondSchema,
                description: schema2.description,
                availability: schema2.availability,
                groupName: void 0
              }),
              context,
              fileContainingReference,
              namespace,
              declarationDepth: 0
            }),
            allowMultiple: true
          };
        }
        if (firstSchema != null && secondSchema != null && hasSamePrimitiveValueType({ array: secondSchema, primitive: firstSchema })) {
          return {
            value: buildTypeReference({
              schema: Schema.optional({
                nameOverride: schema2.nameOverride,
                generatedName: schema2.generatedName,
                title: schema2.title,
                value: firstSchema,
                description: schema2.description,
                availability: schema2.availability,
                groupName: void 0
              }),
              context,
              fileContainingReference,
              namespace,
              declarationDepth: 0
            }),
            allowMultiple: true
          };
        }
      }
      for (const [_, oneOfSchema] of Object.entries(schema2.value.value.schemas)) {
        return getQueryParameterTypeReference({
          schema: Schema.optional({
            nameOverride: schema2.nameOverride,
            generatedName: schema2.generatedName,
            title: schema2.title,
            value: oneOfSchema,
            description: void 0,
            availability: schema2.availability,
            groupName: void 0
          }),
          context,
          fileContainingReference,
          namespace
        });
      }
    } else if (schema2.value.type === "object") {
      if (context.objectQueryParameters) {
        return {
          value: buildTypeReference({
            schema: schema2,
            context,
            fileContainingReference,
            declarationFile: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
            namespace,
            declarationDepth: 0
          }),
          allowMultiple: false
        };
      }
      return void 0;
    }
    return {
      value: buildTypeReference({
        schema: schema2,
        context,
        fileContainingReference,
        namespace,
        declarationDepth: 0
      }),
      allowMultiple: false
    };
  }
  if (schema2.type === "array") {
    return {
      value: buildTypeReference({
        schema: Schema.optional({
          nameOverride: schema2.nameOverride,
          generatedName: schema2.generatedName,
          title: schema2.title,
          value: schema2.value,
          description: schema2.description,
          availability: schema2.availability,
          groupName: void 0
        }),
        context,
        fileContainingReference,
        namespace,
        declarationDepth: 0
      }),
      allowMultiple: true
    };
  } else {
    return {
      value: buildTypeReference({
        schema: schema2,
        context,
        fileContainingReference,
        namespace,
        declarationDepth: 0
      }),
      allowMultiple: false
    };
  }
}
function hasSamePrimitiveValueType({ array, primitive }) {
  return array?.type === "array" && array.value.type === "primitive" && primitive?.type === "primitive" && array.value.schema.type === primitive.schema.type;
}
function isRawTypeReferenceDetailedSchema(rawTypeReference) {
  return rawTypeReference.type != null;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildWebsocketSessionExample.js
function buildWebsocketSessionExample({ websocketExample, context }) {
  const example = {
    messages: []
  };
  if (websocketExample.name != null) {
    example.name = websocketExample.name;
  }
  if (websocketExample.description != null) {
    example.docs = websocketExample.description;
  }
  if (websocketExample.queryParameters != null && websocketExample.queryParameters.length > 0) {
    example["query-parameters"] = convertQueryParameterExample(websocketExample.queryParameters);
  }
  if (websocketExample.headers != null && websocketExample.headers.length > 0) {
    example.headers = convertHeaderExamples({ context, namedFullExamples: websocketExample.headers });
  }
  for (const message of websocketExample.messages) {
    const convertedMessage = convertFullExample(message.payload);
    if (convertedMessage != null) {
      example.messages.push({
        type: message.messageType,
        body: convertedMessage
      });
    }
  }
  return example;
}
function convertQueryParameterExample(namedFullExamples) {
  const result = {};
  namedFullExamples.forEach((namedFullExample) => {
    const convertedExample = convertFullExample(namedFullExample.value);
    if (Array.isArray(convertedExample)) {
      result[namedFullExample.name] = convertedExample[0];
    } else if (convertedExample != null) {
      result[namedFullExample.name] = convertedExample;
    }
  });
  return result;
}
function convertHeaderExamples({ context, namedFullExamples }) {
  const globalHeaderNames = context.builder.getGlobalHeaderNames();
  const result = {};
  namedFullExamples.forEach((namedFullExample) => {
    const convertedExample = convertFullExample(namedFullExample.value);
    if (globalHeaderNames.has(namedFullExample.name)) {
      return;
    } else if (convertedExample != null) {
      result[namedFullExample.name] = convertedExample;
    }
  });
  return result;
}
function convertFullExample(fullExample) {
  switch (fullExample.type) {
    case "primitive":
      return convertPrimitive(fullExample.value);
    case "object":
      return convertObject(fullExample.properties);
    case "array":
      return convertArrayExample(fullExample.value);
    case "map":
      return convertMapExample(fullExample.value);
    case "oneOf":
      return convertOneOfExample(fullExample.value);
    case "enum":
      return fullExample.value;
    case "literal":
      return convertLiteralExample(fullExample.value);
    case "unknown":
      return convertFullExample(fullExample.value);
    default:
      assertNever(fullExample);
  }
}
function convertPrimitive(primitiveExample) {
  switch (primitiveExample.type) {
    case "int":
      return primitiveExample.value;
    case "int64":
      return primitiveExample.value;
    case "uint":
      return primitiveExample.value;
    case "uint64":
      return primitiveExample.value;
    case "float":
      return primitiveExample.value;
    case "double":
      return primitiveExample.value;
    case "string": {
      if (primitiveExample.value.startsWith("$")) {
        return `${primitiveExample.value.slice(1)}`;
      }
      return primitiveExample.value;
    }
    case "datetime":
      try {
        return new Date(primitiveExample.value).toISOString().replace(/\.\d{3}Z$/, "Z");
      } catch (e) {
        return "2024-01-15T09:30:00Z";
      }
    case "date":
      return primitiveExample.value;
    case "base64":
    case "boolean":
      return primitiveExample.value;
    default:
      assertNever(primitiveExample);
  }
}
function convertObject(object3) {
  return Object.fromEntries(Object.entries(object3).map(([propertyKey, fullExample]) => {
    return [propertyKey, convertFullExample(fullExample)];
  }));
}
function convertArrayExample(fullExamples) {
  return fullExamples.map((fullExample) => {
    return convertFullExample(fullExample);
  });
}
function convertMapExample(pairs2) {
  return Object.fromEntries(pairs2.map((pair) => {
    return [convertPrimitive(pair.key), convertFullExample(pair.value)];
  }));
}
function convertOneOfExample(oneOf) {
  if (oneOf.type === "discriminated") {
    return convertObject(oneOf.value);
  }
  return convertFullExample(oneOf.value);
}
function convertLiteralExample(literal) {
  switch (literal.type) {
    case "string":
      return literal.value;
    case "boolean":
      return literal.value;
    default:
      assertNever(literal);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getNamespaceFromGroup.js
function getNamespaceFromGroup(groupName) {
  return groupName.find((group) => typeof group !== "string" && group.type === "namespace")?.name;
}
function getEndpointNamespace(sdkName, namespaceOverride) {
  return namespaceOverride != null ? namespaceOverride : sdkName?.groupName != null ? getNamespaceFromGroup(sdkName.groupName) : void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildChannel.js
function buildChannel({ channel, context, declarationFile }) {
  const convertedChannel = {
    path: channel.path,
    auth: false
  };
  if (channel.summary != null) {
    convertedChannel["display-name"] = channel.summary;
  }
  const maybeChannelNamespace = getNamespaceFromGroup(channel.groupName);
  const pathParameters = {};
  if (channel.handshake.pathParameters.length > 0) {
    for (const pathParameter of channel.handshake.pathParameters) {
      pathParameters[pathParameter.name] = buildPathParameter({
        pathParameter,
        context,
        fileContainingReference: declarationFile,
        namespace: maybeChannelNamespace
      });
    }
  }
  if (Object.keys(pathParameters).length > 0) {
    convertedChannel["path-parameters"] = pathParameters;
  }
  const queryParameters = {};
  if (channel.handshake.queryParameters.length > 0) {
    for (const queryParameter of channel.handshake.queryParameters) {
      const convertedQueryParameter = buildQueryParameter({
        queryParameter,
        context,
        fileContainingReference: declarationFile,
        namespace: maybeChannelNamespace
      });
      if (convertedQueryParameter == null) {
        continue;
      }
      queryParameters[queryParameter.name] = convertedQueryParameter;
    }
  }
  if (Object.keys(queryParameters).length > 0) {
    convertedChannel["query-parameters"] = queryParameters;
  }
  const headers = {};
  if (channel.handshake.headers.length > 0) {
    for (const header of channel.handshake.headers) {
      const headerSchema = buildHeader({
        header,
        context,
        fileContainingReference: declarationFile,
        namespace: maybeChannelNamespace
      });
      headers[header.name] = headerSchema;
    }
  }
  if (Object.keys(headers).length > 0) {
    convertedChannel.headers = headers;
  }
  context.builder.addChannel(declarationFile, {
    channel: convertedChannel
  });
  if (channel.subscribe != null) {
    context.builder.addChannelMessage(declarationFile, {
      messageId: "subscribe",
      message: {
        origin: "server",
        body: buildTypeReference({
          schema: channel.subscribe,
          context,
          fileContainingReference: declarationFile,
          namespace: maybeChannelNamespace,
          declarationDepth: 0
        })
      }
    });
  }
  if (channel.publish != null) {
    context.builder.addChannelMessage(declarationFile, {
      messageId: "publish",
      message: {
        origin: "client",
        body: buildTypeReference({
          schema: channel.publish,
          context,
          fileContainingReference: declarationFile,
          namespace: maybeChannelNamespace,
          declarationDepth: 0
        })
      }
    });
  }
  for (const example of channel.examples) {
    const websocketExample = buildWebsocketSessionExample({ context, websocketExample: example });
    context.builder.addChannelExample(declarationFile, {
      example: websocketExample
    });
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildEnvironments.js
var PRODUCTION_ENVNIRONMENT_NAME = "Production";
var DEFAULT_ENVIRONMENT_NAME = "Default";
function extractUrlsFromEnvironmentSchema(record3) {
  return Object.entries(record3).reduce((acc, [name, schemaOrUrl]) => {
    if (isRawMultipleBaseUrlsEnvironment(schemaOrUrl)) {
      Object.entries(schemaOrUrl.urls).forEach(([urlsName, urlsValue]) => {
        acc[urlsName] = urlsValue;
      });
    } else {
      acc[name] = typeof schemaOrUrl === "string" ? schemaOrUrl : schemaOrUrl.url;
    }
    return acc;
  }, {});
}
function buildEnvironments(context) {
  if (context.environmentOverrides != null) {
    for (const [environment, environmentDeclaration] of Object.entries(context.environmentOverrides.environments ?? {})) {
      context.builder.addEnvironment({
        name: environment,
        schema: environmentDeclaration
      });
    }
    if (context.environmentOverrides["default-environment"] != null) {
      context.builder.setDefaultEnvironment(context.environmentOverrides["default-environment"]);
    }
    if (context.environmentOverrides["default-url"] != null) {
      context.builder.setDefaultUrl(context.environmentOverrides["default-url"]);
    }
    return;
  }
  const topLevelServersWithName = {};
  const topLevelSkippedServers = [];
  for (const server of context.ir.servers) {
    const environmentSchema = server.audiences ? {
      url: server.url,
      audiences: server.audiences
    } : server.url;
    if (server.name == null) {
      topLevelSkippedServers.push(environmentSchema);
      continue;
    }
    topLevelServersWithName[server.name] = environmentSchema;
  }
  const endpointLevelServersWithName = {};
  const endpointLevelSkippedServers = [];
  for (const endpoint of context.ir.endpoints) {
    for (const server of endpoint.server) {
      if (server.url == null) {
        continue;
      }
      const environmentSchema = server.audiences ? {
        url: server.url,
        audiences: server.audiences
      } : server.url;
      if (server.name == null) {
        endpointLevelSkippedServers.push(environmentSchema);
        continue;
      }
      endpointLevelServersWithName[server.name] = environmentSchema;
    }
  }
  const numTopLevelServers = Object.keys(topLevelServersWithName).length;
  const numEndpointLevelServers = Object.keys(endpointLevelServersWithName).length;
  if (numTopLevelServers === 0 && numEndpointLevelServers === 0) {
    const singleURL = context.ir.servers[0]?.url;
    const singleURLAudiences = context.ir.servers[0]?.audiences;
    if (singleURL != null) {
      context.builder.addEnvironment({
        name: DEFAULT_ENVIRONMENT_NAME,
        schema: singleURLAudiences ? {
          url: singleURL,
          audiences: singleURLAudiences
        } : singleURL
      });
      context.builder.setDefaultEnvironment(DEFAULT_ENVIRONMENT_NAME);
    }
  } else if (numTopLevelServers > 0 && numEndpointLevelServers === 0) {
    let count = 0;
    if (topLevelSkippedServers.length > 0) {
      context.logger.error(`Skipping servers ${topLevelSkippedServers.map((server) => typeof server === "string" ? server : server.url).join(", ")} because x-fern-server-name was not provided.`);
    }
    for (const [name, schema2] of Object.entries(topLevelServersWithName)) {
      if (count === 0) {
        context.builder.setDefaultEnvironment(name);
      }
      context.builder.addEnvironment({
        name,
        schema: schema2
      });
      count += 1;
    }
  } else if (numEndpointLevelServers > 0) {
    if (topLevelSkippedServers.length > 0 || endpointLevelSkippedServers.length > 0) {
      context.logger.error(`Skipping servers ${[...topLevelSkippedServers, ...endpointLevelSkippedServers].map((server) => typeof server === "string" ? server : server.url).join(", ")} because x-fern-server-name was not provided.`);
    }
    const toplevelServerEntries = Object.entries(topLevelServersWithName)[0];
    if (toplevelServerEntries != null) {
      const [name, _] = toplevelServerEntries;
      context.setDefaultServerName(name);
    }
    context.builder.addEnvironment({
      name: PRODUCTION_ENVNIRONMENT_NAME,
      schema: {
        urls: {
          ...extractUrlsFromEnvironmentSchema(topLevelServersWithName),
          ...extractUrlsFromEnvironmentSchema(endpointLevelServersWithName)
        }
      }
    });
    context.builder.setDefaultEnvironment(PRODUCTION_ENVNIRONMENT_NAME);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/wrapTypeReferenceAsOptional.js
function wrapTypeReferenceAsOptional(typeReference) {
  const type2 = getTypeFromTypeReference(typeReference);
  if (type2.startsWith("optional")) {
    return typeReference;
  } else if (typeof typeReference === "string") {
    return `optional<${typeReference}>`;
  } else {
    return { ...typeReference, type: `optional<${typeReference.type}>` };
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildGlobalHeaders.js
var HeaderWithCount = class {
  schema;
  count = 0;
  constructor(schema2) {
    this.schema = schema2;
  }
  increment() {
    this.count += 1;
  }
};
var GLOBAL_HEADER_PERCENTAGE_THRESHOLD = 0.75;
var HEADERS_TO_IGNORE = new Set(...["authorization"]);
function buildGlobalHeaders(context) {
  if (context.globalHeaderOverrides != null) {
    for (const [name, declaration] of Object.entries(context.globalHeaderOverrides.headers ?? {})) {
      context.builder.addGlobalHeader({
        name,
        schema: declaration
      });
    }
    return;
  }
  const predefinedGlobalHeaders = Object.fromEntries((context.ir.globalHeaders ?? []).map((header) => [header.header, header]));
  for (const [headerName, header] of Object.entries(predefinedGlobalHeaders)) {
    let schema2 = "optional<string>";
    if (header.name == null && header.env == null && typeof header.schema === "string") {
      schema2 = header.schema;
    } else if (header != null) {
      const groupName = header.schema ? getGroupNameForSchema(header.schema) : void 0;
      const namespace = groupName != null ? getNamespaceFromGroup(groupName) : void 0;
      const defaultFile = RelativeFilePath.of("api.yml");
      schema2 = {
        name: header.name,
        env: header.env,
        type: header.schema != null ? getTypeFromTypeReference(buildTypeReference({
          schema: header.schema,
          context,
          fileContainingReference: namespace ? join(RelativeFilePath.of(camelCase_default(namespace)), defaultFile) : defaultFile,
          namespace,
          declarationDepth: 0
        })) ?? "optional<string>" : "optional<string>"
      };
    }
    context.builder.addGlobalHeader({
      name: headerName,
      schema: schema2
    });
  }
  if (context.detectGlobalHeaders) {
    const globalHeaders = {};
    for (const endpoint of context.ir.endpoints) {
      for (const header of endpoint.headers) {
        if (HEADERS_TO_IGNORE.has(header.name.toLowerCase())) {
          continue;
        }
        let headerWithCount = globalHeaders[header.name];
        if (headerWithCount == null) {
          const predefinedHeader = predefinedGlobalHeaders[header.name];
          const convertedHeader = buildHeader({
            header: {
              ...header,
              schema: predefinedHeader?.schema ?? header.schema,
              name: predefinedHeader?.name ?? header.name
            },
            fileContainingReference: RelativeFilePath.of(ROOT_API_FILENAME),
            context,
            // TODO: how are we namespacing global headers
            namespace: void 0
          });
          headerWithCount = new HeaderWithCount(convertedHeader);
          globalHeaders[header.name] = headerWithCount;
        }
        headerWithCount.increment();
      }
    }
    const globalHeaderThreshold = context.ir.endpoints.length * GLOBAL_HEADER_PERCENTAGE_THRESHOLD;
    for (const [headerName, header] of Object.entries(globalHeaders)) {
      const predefinedHeader = predefinedGlobalHeaders[headerName];
      const isRequired = header.count === context.ir.endpoints.length;
      const isOptional2 = header.count >= globalHeaderThreshold;
      if (predefinedHeader != null) {
        continue;
      } else if (isRequired) {
        context.builder.addGlobalHeader({
          name: headerName,
          schema: header.schema
        });
      } else if (isOptional2) {
        context.builder.addGlobalHeader({
          name: headerName,
          schema: wrapTypeReferenceAsOptional(header.schema)
        });
      }
    }
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildIdempotencyHeaders.js
function buildIdempotencyHeaders(context) {
  for (const header of context.ir.idempotencyHeaders ?? []) {
    const groupName = header.schema ? getGroupNameForSchema(header.schema) : void 0;
    const namespace = groupName != null ? getNamespaceFromGroup(groupName) : void 0;
    const convertedHeader = buildHeader({
      header: {
        ...header,
        schema: header.schema ?? Schema.primitive({
          description: void 0,
          availability: void 0,
          generatedName: "",
          title: void 0,
          groupName: void 0,
          nameOverride: void 0,
          schema: PrimitiveSchemaValue.string({
            default: void 0,
            pattern: void 0,
            format: void 0,
            minLength: void 0,
            maxLength: void 0
          })
        }),
        name: header.name ?? header.header,
        parameterNameOverride: void 0,
        description: void 0,
        availability: void 0,
        source: void 0
      },
      fileContainingReference: RelativeFilePath.of(ROOT_API_FILENAME),
      context,
      namespace
    });
    context.builder.addIdempotencyHeader({
      name: header.header,
      schema: wrapTypeReferenceAsOptional(convertedHeader)
    });
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertFullExample.js
function convertFullExample2(fullExample) {
  switch (fullExample.type) {
    case "primitive":
      return convertPrimitive2(fullExample.value);
    case "object":
      return convertObject2(fullExample.properties);
    case "array":
      return convertArrayExample2(fullExample.value);
    case "map":
      return convertMapExample2(fullExample.value);
    case "oneOf":
      return convertOneOfExample2(fullExample.value);
    case "enum":
      return fullExample.value;
    case "literal":
      return convertLiteralExample2(fullExample.value);
    case "unknown":
      return convertFullExample2(fullExample.value);
    default:
      assertNever(fullExample);
  }
}
function convertEndpointResponseExample(endpointResponseExample) {
  switch (endpointResponseExample.type) {
    case "withStreaming":
      return {
        stream: convertArrayExample2(endpointResponseExample.value)
      };
    case "withoutStreaming":
      return {
        body: convertFullExample2(endpointResponseExample.value)
      };
    default:
      assertNever(endpointResponseExample);
  }
}
function convertPrimitive2(primitiveExample) {
  switch (primitiveExample.type) {
    case "int":
      return primitiveExample.value;
    case "int64":
      return primitiveExample.value;
    case "uint":
      return primitiveExample.value;
    case "uint64":
      return primitiveExample.value;
    case "float":
      return primitiveExample.value;
    case "double":
      return primitiveExample.value;
    case "string": {
      if (primitiveExample.value.startsWith("$")) {
        return `${primitiveExample.value.slice(1)}`;
      }
      return primitiveExample.value;
    }
    case "datetime":
      try {
        if (!primitiveExample.value.endsWith("Z") && !primitiveExample.value.includes("+")) {
          primitiveExample.value += "Z";
        }
        return new Date(primitiveExample.value).toISOString().replace(/\.\d{3}Z$/, "Z");
      } catch (e) {
        return "2024-01-15T09:30:00Z";
      }
    case "date":
      return primitiveExample.value;
    case "base64":
    case "boolean":
      return primitiveExample.value;
    default:
      assertNever(primitiveExample);
  }
}
function convertObject2(object3) {
  return Object.fromEntries(Object.entries(object3).map(([propertyKey, fullExample]) => {
    return [propertyKey, convertFullExample2(fullExample)];
  }));
}
function convertArrayExample2(fullExamples) {
  return fullExamples.map((fullExample) => {
    return convertFullExample2(fullExample);
  });
}
function convertMapExample2(pairs2) {
  return Object.fromEntries(pairs2.map((pair) => {
    return [convertPrimitive2(pair.key), convertFullExample2(pair.value)];
  }));
}
function convertOneOfExample2(oneOf) {
  if (oneOf.type === "discriminated") {
    return convertObject2(oneOf.value);
  }
  return convertFullExample2(oneOf.value);
}
function convertLiteralExample2(literal) {
  switch (literal.type) {
    case "string":
      return literal.value;
    case "boolean":
      return literal.value;
    default:
      assertNever(literal);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildEndpointExample.js
function buildEndpointExample({ endpointExample, context }) {
  const example = {};
  if (endpointExample.type !== "full") {
    return endpointExample.value;
  }
  if (endpointExample.name != null) {
    example.name = endpointExample.name;
  }
  if (endpointExample.description != null) {
    example.docs = endpointExample.description;
  }
  if (endpointExample.pathParameters != null && endpointExample.pathParameters.length > 0) {
    example["path-parameters"] = convertPathParameterExample(endpointExample.pathParameters);
  }
  if (endpointExample.queryParameters != null && endpointExample.queryParameters.length > 0) {
    example["query-parameters"] = convertQueryParameterExample2(endpointExample.queryParameters);
  }
  if (endpointExample.headers != null && endpointExample.headers.length > 0) {
    example.headers = convertHeaderExamples2({ context, namedFullExamples: endpointExample.headers });
  }
  if (endpointExample.request != null) {
    example.request = convertFullExample2(endpointExample.request);
  }
  if (endpointExample.response != null) {
    example.response = convertEndpointResponseExample(endpointExample.response);
  }
  if (endpointExample.codeSamples != null && endpointExample.codeSamples.length > 0) {
    example["code-samples"] = endpointExample.codeSamples.map((codeSample) => {
      if (codeSample.type === "language") {
        return {
          name: codeSample.name ?? void 0,
          docs: codeSample.description ?? void 0,
          language: codeSample.language,
          code: codeSample.code,
          install: codeSample.install ?? void 0
        };
      } else {
        return {
          name: codeSample.name ?? void 0,
          docs: codeSample.description ?? void 0,
          sdk: codeSample.sdk,
          code: codeSample.code
        };
      }
    }).filter(isNonNullish);
  }
  return example;
}
function convertPathParameterExample(pathParameterExamples) {
  const result = {};
  pathParameterExamples.forEach((pathParameterExample) => {
    const convertedExample = convertFullExample2(pathParameterExample.value);
    if (convertedExample != null) {
      result[pathParameterExample.parameterNameOverride ?? pathParameterExample.name] = convertedExample;
    }
  });
  return result;
}
function convertQueryParameterExample2(namedFullExamples) {
  const result = {};
  namedFullExamples.forEach((namedFullExample) => {
    const convertedExample = convertFullExample2(namedFullExample.value);
    if (Array.isArray(convertedExample)) {
      result[namedFullExample.name] = convertedExample[0];
    } else if (convertedExample != null) {
      result[namedFullExample.name] = convertedExample;
    }
  });
  return result;
}
function convertHeaderExamples2({ context, namedFullExamples }) {
  const globalHeaderNames = context.builder.getGlobalHeaderNames();
  const result = {};
  namedFullExamples.forEach((namedFullExample) => {
    const convertedExample = convertFullExample2(namedFullExample.value);
    if (globalHeaderNames.has(namedFullExample.name)) {
      return;
    } else if (convertedExample != null) {
      result[namedFullExample.name] = convertedExample;
    }
  });
  return result;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertToHttpMethod.js
function convertToHttpMethod(httpMethod) {
  return HttpMethod2._visit(httpMethod, {
    get: () => schemas_exports3.HttpMethodSchema.Get,
    post: () => schemas_exports3.HttpMethodSchema.Post,
    put: () => schemas_exports3.HttpMethodSchema.Put,
    patch: () => schemas_exports3.HttpMethodSchema.Patch,
    delete: () => schemas_exports3.HttpMethodSchema.Delete,
    head: () => {
      throw new Error("HEAD is unsupported");
    },
    options: () => {
      throw new Error("HEAD is unsupported");
    },
    trace: () => {
      throw new Error("HEAD is unsupported");
    },
    _other: () => {
      throw new Error("Unkown http method is unsupported");
    }
  });
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildEndpoint.js
function buildEndpoint({ endpoint, declarationFile, context }) {
  const { nonRequestReferencedSchemas } = context.ir;
  let schemaIdsToExclude = [];
  const names = /* @__PURE__ */ new Set();
  let path5 = endpoint.path;
  const maybeEndpointNamespace = getEndpointNamespace(endpoint.sdkName, endpoint.namespace);
  const pathParameters = {};
  for (const pathParameter of endpoint.pathParameters) {
    if (pathParameter.parameterNameOverride) {
      path5 = path5.replace(pathParameter.name, pathParameter.parameterNameOverride);
    }
    pathParameters[pathParameter.parameterNameOverride ?? pathParameter.name] = buildPathParameter({
      pathParameter,
      context,
      fileContainingReference: declarationFile,
      namespace: maybeEndpointNamespace
    });
    names.add(pathParameter.name);
  }
  const queryParameters = {};
  for (const queryParameter of endpoint.queryParameters) {
    const convertedQueryParameter = buildQueryParameter({
      queryParameter,
      context,
      fileContainingReference: declarationFile,
      namespace: maybeEndpointNamespace
    });
    if (convertedQueryParameter == null) {
      continue;
    }
    queryParameters[queryParameter.name] = convertedQueryParameter;
    names.add(queryParameter.name);
  }
  let pagination = void 0;
  if (endpoint.pagination != null) {
    if (endpoint.pagination.type === "cursor") {
      pagination = {
        cursor: endpoint.pagination.cursor,
        next_cursor: endpoint.pagination.nextCursor,
        results: endpoint.pagination.results
      };
    } else {
      pagination = {
        offset: endpoint.pagination.offset,
        step: endpoint.pagination.step,
        results: endpoint.pagination.results,
        "has-next-page": endpoint.pagination.hasNextPage
      };
    }
  }
  const convertedEndpoint = {
    path: path5,
    method: convertToHttpMethod(endpoint.method),
    auth: endpoint.authed,
    docs: endpoint.description ?? void 0,
    pagination,
    source: endpoint.source != null ? convertToSourceSchema(endpoint.source) : void 0
  };
  if (!endpointRequestSupportsInlinedPathParameters({ context, request: endpoint.request }) && Object.keys(pathParameters).length > 0) {
    convertedEndpoint["path-parameters"] = pathParameters;
  }
  if (endpoint.summary != null) {
    convertedEndpoint["display-name"] = endpoint.summary;
  }
  const headers = {};
  const globalHeaderNames = context.builder.getGlobalHeaderNames();
  const endpointSpecificHeaders = endpoint.headers.filter((header) => {
    return !globalHeaderNames.has(header.name);
  });
  for (const header of endpointSpecificHeaders) {
    const headerSchema = buildHeader({
      header,
      context,
      fileContainingReference: declarationFile,
      namespace: maybeEndpointNamespace
    });
    headers[header.name] = headerSchema;
    names.add(typeof headerSchema === "string" ? header.name : headerSchema.name ?? header.name);
  }
  if (endpoint.request != null) {
    context.setInState(State.Request);
    const convertedRequest = getRequest({
      endpoint,
      context,
      declarationFile,
      request: endpoint.request,
      generatedRequestName: endpoint.generatedRequestName,
      requestNameOverride: endpoint.requestNameOverride ?? void 0,
      pathParameters: context.inlinePathParameters && Object.keys(pathParameters).length > 0 ? pathParameters : void 0,
      queryParameters: Object.keys(queryParameters).length > 0 ? queryParameters : void 0,
      nonRequestReferencedSchemas: Array.from(nonRequestReferencedSchemas),
      headers: Object.keys(headers).length > 0 ? headers : void 0,
      usedNames: names,
      namespace: maybeEndpointNamespace
    });
    convertedEndpoint.request = convertedRequest.value;
    schemaIdsToExclude = [...schemaIdsToExclude, ...convertedRequest.schemaIdsToExclude ?? []];
    context.unsetInState(State.Request);
  } else {
    const hasPathParams = context.inlinePathParameters && Object.keys(pathParameters).length > 0;
    const hasQueryParams = Object.keys(queryParameters).length > 0;
    const hasHeaders = Object.keys(headers).length > 0;
    const convertedRequest = {};
    if (hasPathParams || hasQueryParams || hasHeaders) {
      convertedRequest.name = endpoint.requestNameOverride ?? endpoint.generatedRequestName;
    }
    if (hasPathParams) {
      convertedRequest["path-parameters"] = pathParameters;
    }
    if (hasQueryParams) {
      convertedRequest["query-parameters"] = queryParameters;
    }
    if (hasHeaders) {
      convertedRequest.headers = headers;
    }
    if (Object.keys(convertedRequest).length > 0) {
      convertedEndpoint.request = convertedRequest;
    }
  }
  if (endpoint.response != null) {
    endpoint.response._visit({
      json: (jsonResponse) => {
        const responseTypeReference = buildTypeReference({
          schema: jsonResponse.schema,
          context,
          fileContainingReference: declarationFile,
          namespace: maybeEndpointNamespace,
          declarationDepth: 0
        });
        convertedEndpoint.response = {
          docs: jsonResponse.description ?? void 0,
          type: getTypeFromTypeReference(responseTypeReference)
        };
        if (jsonResponse.responseProperty != null) {
          convertedEndpoint.response.property = jsonResponse.responseProperty;
        }
      },
      streamingJson: (jsonResponse) => {
        const responseTypeReference = buildTypeReference({
          schema: jsonResponse.schema,
          context,
          fileContainingReference: declarationFile,
          namespace: maybeEndpointNamespace,
          declarationDepth: 0
        });
        convertedEndpoint["response-stream"] = {
          docs: jsonResponse.description ?? void 0,
          type: getTypeFromTypeReference(responseTypeReference),
          format: "json"
        };
      },
      streamingSse: (jsonResponse) => {
        const responseTypeReference = buildTypeReference({
          schema: jsonResponse.schema,
          context,
          fileContainingReference: declarationFile,
          namespace: maybeEndpointNamespace,
          declarationDepth: 0
        });
        convertedEndpoint["response-stream"] = {
          docs: jsonResponse.description ?? void 0,
          type: getTypeFromTypeReference(responseTypeReference),
          format: "sse"
        };
      },
      file: (fileResponse) => {
        convertedEndpoint.response = {
          docs: fileResponse.description ?? void 0,
          type: "file"
        };
      },
      streamingText: (textResponse) => {
        convertedEndpoint["response-stream"] = {
          docs: textResponse.description ?? void 0,
          type: "text"
        };
      },
      text: (textResponse) => {
        convertedEndpoint.response = {
          docs: textResponse.description ?? void 0,
          type: "text"
        };
      },
      _other: () => {
        throw new Error("Unrecognized Response type: " + endpoint.response?.type);
      }
    });
  }
  if (context.builder.getEnvironmentType() === "multi") {
    const defaultServer = context.getDefaultServerName();
    const serverOverride = endpoint.server[0];
    if (serverOverride == null) {
      if (defaultServer != null) {
        convertedEndpoint.url = defaultServer;
      }
    } else {
      convertedEndpoint.url = serverOverride.name ?? void 0;
    }
  }
  if (endpoint.idempotent) {
    convertedEndpoint.idempotent = true;
  }
  if (endpoint.availability != null) {
    convertedEndpoint.availability = convertAvailability2(endpoint.availability);
  }
  Object.entries(endpoint.errors).forEach(([statusCode, httpError]) => {
    let errorName = httpError.generatedName;
    const fileContainingReference = RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME);
    if (context.builder.enableUniqueErrorsPerEndpoint) {
      errorName = `${endpoint.generatedRequestName}${httpError.generatedName}`;
      if (httpError.schema != null) {
        if (httpError.schema.type !== "reference" && httpError.schema.type !== "oneOf") {
          httpError.schema.generatedName = `${endpoint.generatedRequestName}${httpError.schema.generatedName}`;
        } else if (httpError.schema.type === "oneOf") {
          httpError.schema.value.generatedName = `${endpoint.generatedRequestName}${httpError.schema.value.generatedName}`;
        }
      }
    }
    const errorDeclaration = {
      "status-code": parseInt(statusCode)
    };
    const errorDeclarationFile = resolveLocationWithNamespace({
      location: ERROR_DECLARATIONS_FILENAME,
      namespaceOverride: maybeEndpointNamespace
    });
    if (httpError.schema != null) {
      const typeReference = buildTypeReference({
        schema: httpError.schema,
        context,
        fileContainingReference: errorDeclarationFile,
        declarationFile: errorDeclarationFile,
        namespace: maybeEndpointNamespace,
        declarationDepth: 0
      });
      errorDeclaration.type = getTypeFromTypeReference(typeReference);
      errorDeclaration.docs = httpError.description;
    }
    context.builder.addError(errorDeclarationFile, {
      name: errorName,
      schema: context.isErrorUnknownSchema(parseInt(statusCode)) ? { ...errorDeclaration, type: "unknown" } : errorDeclaration
    });
    if (convertedEndpoint.errors == null) {
      convertedEndpoint.errors = [];
    }
    const prefix = context.builder.addImport({
      file: declarationFile,
      fileToImport: errorDeclarationFile
    });
    convertedEndpoint.errors.push(prefix != null ? `${prefix}.${errorName}` : errorName);
    const errorTypeReference = errorDeclaration.type;
    if (errorTypeReference != null) {
      httpError.examples?.forEach((example) => {
        const convertedExample = {
          value: convertFullExample2(example.example),
          name: example.name,
          docs: example.description
        };
        context.builder.addErrorExample(errorDeclarationFile, {
          name: errorName,
          example: convertedExample
        });
      });
    }
  });
  if (endpoint.examples.length > 0) {
    convertedEndpoint.examples = convertEndpointExamples({
      endpointExamples: endpoint.examples,
      context
    });
  }
  if (context.ir.hasEndpointsMarkedInternal && (endpoint.internal == null || !endpoint.internal)) {
    convertedEndpoint.audiences = [EXTERNAL_AUDIENCE, ...endpoint.audiences];
  } else if (endpoint.audiences.length > 0) {
    convertedEndpoint.audiences = endpoint.audiences;
  }
  return {
    value: convertedEndpoint,
    schemaIdsToExclude
  };
}
function convertEndpointExamples({ endpointExamples, context }) {
  return endpointExamples.map((endpointExample) => {
    try {
      return buildEndpointExample({ endpointExample, context });
    } catch (e) {
      console.error(`Error building endpoint example: ${e}`);
      throw e;
    }
  });
}
function getRequest({ endpoint, declarationFile, context, request, requestNameOverride, generatedRequestName, pathParameters, queryParameters, nonRequestReferencedSchemas, headers, usedNames, namespace }) {
  if (request.type === "json") {
    const maybeSchemaId = request.schema.type === "reference" ? request.schema.schema : void 0;
    const resolvedSchema = request.schema.type === "reference" ? context.getSchema(request.schema.schema, namespace) : request.schema;
    if (resolvedSchema?.type !== "object" || maybeSchemaId != null && nonRequestReferencedSchemas.includes(maybeSchemaId)) {
      const requestTypeReference = buildTypeReference({
        schema: request.schema,
        fileContainingReference: declarationFile,
        context,
        namespace,
        declarationDepth: 0
      });
      const convertedRequest = {
        schemaIdsToExclude: [],
        value: {
          body: requestTypeReference
        }
      };
      const hasPathParams = Object.keys(pathParameters ?? {}).length > 0;
      const hasQueryParams = Object.keys(queryParameters ?? {}).length > 0;
      const hasHeaders = Object.keys(headers ?? {}).length > 0;
      if (hasPathParams) {
        convertedRequest.value["path-parameters"] = pathParameters;
      }
      if (hasQueryParams) {
        convertedRequest.value["query-parameters"] = queryParameters;
      }
      if (hasHeaders) {
        convertedRequest.value.headers = headers;
      }
      if (hasPathParams || hasQueryParams || hasHeaders) {
        convertedRequest.value.name = requestNameOverride ?? generatedRequestName;
      }
      if (request.contentType != null) {
        convertedRequest.value["content-type"] = request.contentType;
      }
      if (request.description != null) {
        convertedRequest.value.docs = request.description;
      }
      return convertedRequest;
    }
    const properties = Object.fromEntries(resolvedSchema.properties.filter((property4) => {
      if (property4.readonly == null) {
        return true;
      }
      const writeEndpoint = endpoint.method === "POST" || endpoint.method === "PUT";
      if (writeEndpoint && property4.readonly) {
        return false;
      }
      return true;
    }).map((property4) => {
      const propertyTypeReference = buildTypeReference({
        schema: property4.schema,
        fileContainingReference: declarationFile,
        context,
        namespace,
        declarationDepth: 1
        // 1 level deep for request body properties
      });
      const name = property4.nameOverride ?? property4.key;
      const availability = convertAvailability2(property4.availability);
      if (!usedNames.has(name) && property4.audiences.length <= 0) {
        usedNames.add(name);
        if (property4.nameOverride != null) {
          return [
            property4.key,
            {
              type: getTypeFromTypeReference(propertyTypeReference),
              docs: getDocsFromTypeReference(propertyTypeReference),
              name: property4.nameOverride,
              availability
            }
          ];
        }
        return [
          property4.key,
          availability ? {
            ...typeof propertyTypeReference === "string" ? { type: propertyTypeReference } : propertyTypeReference,
            availability
          } : propertyTypeReference
        ];
      }
      const typeReference = {
        type: getTypeFromTypeReference(propertyTypeReference),
        docs: getDocsFromTypeReference(propertyTypeReference)
      };
      if (usedNames.has(name)) {
        typeReference.name = property4.generatedName;
      }
      if (property4.audiences.length > 0) {
        typeReference.audiences = property4.audiences;
      }
      if (availability != null) {
        typeReference.availability = availability;
      }
      usedNames.add(name);
      return [property4.key, typeReference];
    }));
    const extendedSchemas = resolvedSchema.allOf.map((referencedSchema) => {
      const allOfTypeReference = buildTypeReference({
        schema: Schema.reference(referencedSchema),
        fileContainingReference: declarationFile,
        context,
        namespace,
        declarationDepth: 0
      });
      return getTypeFromTypeReference(allOfTypeReference);
    });
    const requestBodySchema = {
      properties
    };
    if (extendedSchemas.length > 0) {
      requestBodySchema.extends = extendedSchemas;
    }
    if (request.additionalProperties) {
      requestBodySchema["extra-properties"] = true;
    }
    const convertedRequestValue = {
      name: requestNameOverride ?? resolvedSchema.nameOverride ?? resolvedSchema.generatedName,
      "path-parameters": pathParameters,
      "query-parameters": queryParameters,
      headers,
      body: requestBodySchema
    };
    if (request.contentType != null) {
      convertedRequestValue["content-type"] = request.contentType;
    }
    if (request.description != null) {
      convertedRequestValue.docs = request.description;
    }
    return {
      schemaIdsToExclude: maybeSchemaId != null ? [maybeSchemaId] : [],
      value: convertedRequestValue
    };
  } else if (request.type === "octetStream") {
    return {
      schemaIdsToExclude: [],
      value: {
        body: "bytes",
        "content-type": MediaType.APPLICATION_OCTET_STREAM,
        ...request.description ? { docs: request.description } : {}
      }
    };
  } else if (request.type === "multipart") {
    const properties = Object.fromEntries(request.properties.map((property4) => {
      if (property4.schema.type === "file") {
        let fileType = property4.schema.isArray ? "list<file>" : "file";
        fileType = property4.schema.isOptional ? `optional<${fileType}>` : fileType;
        if (property4.description != null || property4.contentType != null) {
          const propertyTypeReference = {
            type: fileType
          };
          if (property4.description != null) {
            propertyTypeReference.docs = property4.description;
          }
          if (property4.contentType != null) {
            const contentType = property4.contentType.split(",")[0];
            propertyTypeReference["content-type"] = contentType;
          }
          return [property4.key, propertyTypeReference];
        }
        return [property4.key, fileType];
      } else {
        let propertyTypeReference = buildTypeReference({
          schema: property4.schema.value,
          fileContainingReference: declarationFile,
          context,
          namespace,
          declarationDepth: 1
          // 1 level deep for request body properties
        });
        if (property4.contentType != null) {
          if (typeof propertyTypeReference === "string") {
            propertyTypeReference = {
              type: propertyTypeReference,
              "content-type": property4.contentType
            };
          } else {
            propertyTypeReference["content-type"] = property4.contentType;
          }
        }
        return [property4.key, propertyTypeReference];
      }
    }));
    return {
      schemaIdsToExclude: request.name == null ? [] : [request.name],
      value: {
        name: requestNameOverride ?? request.name ?? generatedRequestName,
        "path-parameters": pathParameters,
        "query-parameters": queryParameters,
        headers,
        body: {
          properties
        },
        "content-type": MediaType.MULTIPART_FORM_DATA,
        ...request.description ? { docs: request.description } : {}
      }
    };
  } else {
    assertNever(request);
  }
}
function endpointRequestSupportsInlinedPathParameters({ context, request }) {
  if (!context.inlinePathParameters) {
    return false;
  }
  if (request == null) {
    return true;
  }
  switch (request.type) {
    case "octetStream":
      return false;
    case "multipart":
      return true;
    case "json":
      return true;
    default:
      assertNever(request);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getEndpointLocation.js
function resolveEndpointLocationWithNamespaceOverride({ location, namespaceOverride }) {
  if (namespaceOverride != null) {
    return {
      ...location,
      file: join(RelativeFilePath.of(namespaceOverride), location.file)
    };
  }
  return location;
}
function getUnresolvedEndpointLocation(endpoint) {
  const namespace = endpoint.namespace;
  const tag = endpoint.tags.filter((tag2) => tag2 !== namespace)[0];
  const operationId = endpoint.operationId;
  if (operationId == null) {
    if (tag != null) {
      return {
        file: RelativeFilePath.of(`${camelCase_default(tag)}.yml`),
        endpointId: endpoint.summary != null ? camelCase_default(endpoint.summary) : camelCase_default(`${endpoint.method}_${endpoint.path.split("/").join("_")}`)
      };
    }
    if (endpoint.summary != null) {
      return {
        file: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
        endpointId: camelCase_default(endpoint.summary)
      };
    }
    return {
      file: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
      endpointId: camelCase_default(`${endpoint.method}_${endpoint.path.split("/").join("_")}`)
    };
  }
  if (tag == null) {
    return {
      file: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
      endpointId: operationId
    };
  }
  const tagTokens = tokenizeString(tag);
  const operationIdTokens = tokenizeString(operationId);
  if (isEqual_default(tagTokens, operationIdTokens)) {
    return {
      file: RelativeFilePath.of("__package__.yml"),
      endpointId: tag
    };
  }
  const fastapiEndpointLocation = maybeGetFastApiEndpointLocation({
    operationId,
    tag,
    path: endpoint.path,
    method: endpoint.method
  });
  if (fastapiEndpointLocation != null) {
    return fastapiEndpointLocation;
  }
  const fileParts = [];
  for (let i = 0; i < tagTokens.length; ++i) {
    const tagElement = tagTokens[i];
    if (tagElement != null && tagElement === operationIdTokens[i]) {
      fileParts.push(tagElement);
    } else {
      const camelCasedTag = camelCase_default(tag);
      return {
        file: RelativeFilePath.of(`${camelCasedTag}.yml`),
        endpointId: operationId,
        tag
      };
    }
  }
  if (fileParts.length >= operationIdTokens.length) {
    throw new Error(`Cannot get file for endpoint ${JSON.stringify(endpoint)}`);
  }
  return {
    file: RelativeFilePath.of(camelCase_default(fileParts.join("_")) + ".yml"),
    endpointId: camelCase_default(operationIdTokens.slice(fileParts.length).join("_")),
    tag
  };
}
function getEndpointLocation(endpoint) {
  const tag = endpoint.tags[0];
  if (endpoint.sdkName != null) {
    const filenameWithoutExtension = convertEndpointSdkNameToFileWithoutExtension({
      sdkName: endpoint.sdkName,
      namespaceOverride: endpoint.namespace
    });
    const filename = `${filenameWithoutExtension}.yml`;
    const isTagApplicable = filenameWithoutExtension.toLowerCase() === tag?.toLowerCase().replaceAll(" ", "");
    return {
      file: RelativeFilePath.of(filename),
      endpointId: endpoint.sdkName.methodName,
      // only if the tag lines up with `x-fern-sdk-group-name` do we use it
      tag: isTagApplicable ? tag : void 0
    };
  }
  return resolveEndpointLocationWithNamespaceOverride({
    namespaceOverride: endpoint.namespace,
    location: getUnresolvedEndpointLocation(endpoint)
  });
}
function tokenizeString(input) {
  let tokens;
  if (/^[a-z]+(?:[A-Z][a-z]+)*$/.test(input)) {
    tokens = input.split(/(?=[A-Z])/);
  } else {
    tokens = input.split(/[^a-zA-Z0-9]+/);
  }
  tokens = tokens.map((token) => token.toLowerCase());
  tokens = compact_default(tokens);
  return tokens;
}
var NON_ALPHANUMERIC_EXCEPT_BRACES_REGEX = new RegExp("[^a-zA-Z0-9{}]+");
var BRACE_REGEX = new RegExp("[{}]", "g");
function maybeGetFastApiEndpointLocation({ operationId, tag, path: path5, method }) {
  const pathSegment = path5.split(NON_ALPHANUMERIC_EXCEPT_BRACES_REGEX).join("_").replaceAll(BRACE_REGEX, "_");
  const operationIdSuffix = `${pathSegment}_${method.toLowerCase()}`;
  if (operationId.endsWith(operationIdSuffix)) {
    return {
      file: RelativeFilePath.of(camelCase_default(tag) + ".yml"),
      endpointId: camelCase_default(operationId.slice(0, -1 * operationIdSuffix.length)),
      tag
    };
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildServices.js
function buildServices(context) {
  const sdkGroups = /* @__PURE__ */ new Set();
  const { endpoints, tags } = context.ir;
  let schemaIdsToExclude = [];
  for (const endpoint of endpoints) {
    const { endpointId, file, tag } = getEndpointLocation(endpoint);
    const sdkGroup = file.split(".")[0];
    if (sdkGroup != null) {
      sdkGroups.add(sdkGroup);
    }
    let group = void 0;
    if (endpoint.sdkName != null) {
      const groupInfo = context.ir.groups;
      for (const groupName of endpoint.sdkName.groupName) {
        const trueGroupName = typeof groupName === "string" ? groupName : groupName.name;
        const value = groupInfo[trueGroupName];
        if (value == null) {
          break;
        } else if (value.summary != null || value.description != null) {
          group = groupInfo[trueGroupName];
          break;
        }
      }
    }
    const irTag = tag == null ? void 0 : tags.tagsById[tag];
    context.setInState(State.Endpoint);
    context.setEndpointMethod(endpoint.method);
    const convertedEndpoint = buildEndpoint({
      context,
      endpoint,
      declarationFile: file
    });
    context.unsetEndpointMethod();
    context.unsetInState(State.Endpoint);
    schemaIdsToExclude = [...schemaIdsToExclude, ...convertedEndpoint.schemaIdsToExclude];
    context.builder.addEndpoint(file, {
      name: endpointId,
      schema: convertedEndpoint.value,
      source: endpoint.source != null ? convertToSourceSchema(endpoint.source) : void 0
    });
    if (irTag?.id != null || irTag?.description != null) {
      context.builder.setServiceInfo(file, {
        "display-name": group?.summary ?? irTag?.id,
        docs: group?.description ?? irTag?.description ?? void 0
      });
    }
  }
  return { schemaIdsToExclude, sdkGroups };
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildVariables.js
function buildVariables(context) {
  for (const [variable, variableSchema] of Object.entries(context.ir.variables)) {
    const namespace = variableSchema.groupName != null ? getNamespaceFromGroup(variableSchema.groupName) : void 0;
    const typeReference = buildTypeReference({
      schema: Schema.primitive(variableSchema),
      context,
      fileContainingReference: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
      namespace,
      declarationDepth: 0
    });
    context.builder.addVariable({
      name: variable,
      schema: {
        type: getTypeFromTypeReference(typeReference),
        docs: variableSchema.description ?? void 0
      }
    });
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildWebhooks.js
function buildWebhooks(context) {
  for (const webhook of context.ir.webhooks) {
    const webhookLocation = getWebhookLocation({ webhook, context });
    if (webhookLocation == null) {
      continue;
    }
    const maybeWebhookNamespace = getEndpointNamespace(webhook.sdkName, webhook.namespace);
    const headers = {};
    for (const header of webhook.headers) {
      headers[header.name] = buildHeader({
        header,
        context,
        fileContainingReference: webhookLocation.file,
        namespace: maybeWebhookNamespace
      });
    }
    const webhookDefinition = {
      method: webhook.method,
      "display-name": webhook.summary ?? void 0,
      headers,
      payload: buildTypeReference({
        schema: webhook.payload,
        context,
        fileContainingReference: webhookLocation.file,
        namespace: maybeWebhookNamespace,
        declarationDepth: 0
      }),
      examples: webhook.examples != null ? webhook.examples.map((exampleWebhookCall) => {
        return {
          docs: exampleWebhookCall.description,
          name: exampleWebhookCall.name,
          payload: convertFullExample2(exampleWebhookCall.payload)
        };
      }) : void 0
    };
    context.builder.addWebhook(webhookLocation.file, {
      name: webhookLocation.endpointId,
      schema: webhookDefinition
    });
    if (webhook.description != null) {
      webhookDefinition.docs = webhook.description;
    }
  }
}
function resolveWebhookLocationWithNamespaceOverride({ location, namespaceOverride }) {
  if (location == null) {
    return void 0;
  }
  if (namespaceOverride != null) {
    return {
      ...location,
      file: join(RelativeFilePath.of(namespaceOverride), location.file)
    };
  }
  return location;
}
function getUnresolvedWebhookLocation({ webhook, context }) {
  const tag = webhook.tags[0];
  const operationId = webhook.operationId;
  if (tag == null) {
    return {
      file: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
      endpointId: operationId
    };
  }
  const tagTokens = tokenizeString(tag);
  const operationIdTokens = tokenizeString(operationId);
  if (isEqual_default(tagTokens, operationIdTokens)) {
    return {
      file: RelativeFilePath.of("__package__.yml"),
      endpointId: tag
    };
  }
  const fileParts = [];
  for (let i = 0; i < tagTokens.length; ++i) {
    const tagElement = tagTokens[i];
    if (tagElement != null && tagElement === operationIdTokens[i]) {
      fileParts.push(tagElement);
    } else {
      const camelCasedTag = camelCase_default(tag);
      return {
        file: RelativeFilePath.of(`${camelCasedTag}.yml`),
        endpointId: operationId,
        tag
      };
    }
  }
  if (fileParts.length >= operationIdTokens.length) {
    context.logger.warn(`Skipping webhook ${webhook.operationId} because couldn't compute file location`);
    return void 0;
  }
  return {
    file: RelativeFilePath.of(camelCase_default(fileParts.join("_")) + ".yml"),
    endpointId: camelCase_default(operationIdTokens.slice(fileParts.length).join("_")),
    tag
  };
}
function getWebhookLocation({ webhook, context }) {
  if (webhook.sdkName != null) {
    return {
      file: convertEndpointSdkNameToFile({ sdkName: webhook.sdkName, namespaceOverride: webhook.namespace }),
      endpointId: webhook.sdkName.methodName
    };
  }
  return resolveWebhookLocationWithNamespaceOverride({
    namespaceOverride: webhook.namespace,
    location: getUnresolvedWebhookLocation({ webhook, context })
  });
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getDeclarationFileForSchema.js
var PACKAGE_MARKER_RELATIVE_FILEPATH = RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME);
function getDeclarationFileForSchema(schema2) {
  switch (schema2.type) {
    case "object":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "enum":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "oneOf":
      return getDeclarationFileFromGroupName(schema2.value.groupName);
    case "array":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "map":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "reference":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "literal":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "optional":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "nullable":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "primitive":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "unknown":
      return PACKAGE_MARKER_RELATIVE_FILEPATH;
    default:
      assertNever(schema2);
  }
}
function getDeclarationFileFromGroupName(groupName) {
  return convertSdkGroupNameToFile(groupName);
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildFernDefinition.js
var EXTERNAL_AUDIENCE = "external";
var ERROR_DECLARATIONS_FILENAME = RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME);
function addSchemas({ schemas, schemaIdsToExclude, namespace, context }) {
  for (const [id, schema2] of Object.entries(schemas)) {
    if (schemaIdsToExclude.includes(id)) {
      continue;
    }
    const declarationFile = getDeclarationFileForSchema(schema2);
    const typeDeclaration = buildTypeDeclaration({
      schema: schema2,
      context,
      declarationFile,
      namespace,
      declarationDepth: 0
    });
    if (isRawAliasDefinition(typeDeclaration.schema)) {
      const aliasType = getTypeFromTypeReference(typeDeclaration.schema);
      if (aliasType === (typeDeclaration.name ?? id) || aliasType === `optional<${typeDeclaration.name ?? id}>`) {
        continue;
      }
    }
    context.builder.addType(declarationFile, {
      name: typeDeclaration.name ?? id,
      schema: typeDeclaration.schema
    });
  }
}
function buildFernDefinition(context) {
  if (context.ir.apiVersion != null) {
    context.builder.setApiVersion(context.ir.apiVersion);
  }
  buildEnvironments(context);
  buildGlobalHeaders(context);
  buildIdempotencyHeaders(context);
  buildAuthSchemes(context);
  buildVariables(context);
  if (context.ir.basePath != null) {
    context.builder.setBasePath(context.ir.basePath);
  }
  if (context.ir.hasEndpointsMarkedInternal) {
    context.builder.addAudience(EXTERNAL_AUDIENCE);
  }
  const convertedServices = buildServices(context);
  const sdkGroups = convertedServices.sdkGroups;
  context.setInState(State.Webhook);
  buildWebhooks(context);
  context.unsetInState(State.Webhook);
  context.setInState(State.Channel);
  for (const channel of context.ir.channel) {
    const declarationFile = convertSdkGroupNameToFile(channel.groupName);
    buildChannel({ channel, context, declarationFile });
  }
  context.unsetInState(State.Channel);
  const schemaIdsToExclude = getSchemaIdsToExclude({
    context,
    schemaIdsToExcludeFromServices: convertedServices.schemaIdsToExclude
  });
  addSchemas({ schemas: context.ir.groupedSchemas.rootSchemas, schemaIdsToExclude, namespace: void 0, context });
  for (const [namespace, schemas] of Object.entries(context.ir.groupedSchemas.namespacedSchemas)) {
    addSchemas({ schemas, schemaIdsToExclude, namespace, context });
  }
  if (context.ir.tags.orderedTagIds != null && context.ir.tags.orderedTagIds.length > 0) {
    const containsValidTagIds = context.ir.tags.orderedTagIds.every((tagId) => {
      return sdkGroups.has(tagId);
    });
    if (containsValidTagIds) {
      context.builder.addNavigation({
        navigation: context.ir.tags.orderedTagIds
      });
    }
  }
  return context.builder.build();
}
function getSchemaIdsToExclude({ context, schemaIdsToExcludeFromServices }) {
  const referencedSchemaIds = context.getReferencedSchemaIds();
  if (referencedSchemaIds == null) {
    return schemaIdsToExcludeFromServices;
  }
  const allSchemaIds = /* @__PURE__ */ new Set([
    ...Object.keys(context.ir.groupedSchemas.rootSchemas),
    ...Object.values(context.ir.groupedSchemas.namespacedSchemas).flatMap((schemas) => Object.keys(schemas))
  ]);
  const schemaIdsToExcludeSet = new Set(schemaIdsToExcludeFromServices);
  for (const schemaId of allSchemaIds) {
    if (!referencedSchemaIds.includes(schemaId)) {
      schemaIdsToExcludeSet.add(schemaId);
    }
  }
  return Array.from(schemaIdsToExcludeSet);
}

// ../../cli/api-importers/commons/lib/FernDefinitionBuilder.js
var import_path = __toESM(require("path"), 1);

// ../../cli/api-importers/commons/lib/utils/FernDefinitionDirectory.js
var FernDefinitionDirectory = class _FernDefinitionDirectory {
  files = {};
  directories = {};
  getAllFiles() {
    const files = {};
    const walk = (root2, currentPath) => {
      for (const [relativeFilePath, definition] of Object.entries(root2.files)) {
        const fullRelativeFilePath = currentPath != null ? RelativeFilePath.of(`${currentPath}${sep}${relativeFilePath}`) : RelativeFilePath.of(relativeFilePath);
        files[fullRelativeFilePath] = definition;
      }
      const sortedDirectories = Object.keys(root2.directories).sort();
      for (const directory of sortedDirectories) {
        const nextPath = currentPath != null ? `${currentPath}${sep}${directory}` : directory;
        const nextDirectory = root2.directories[directory];
        walk(nextDirectory, nextPath);
      }
    };
    walk(this);
    return files;
  }
  getOrCreateFile(relativeFilePath) {
    return this.getOrCreateFileRecursive(relativeFilePath.split(sep));
  }
  getOrCreateFileRecursive(pathParts) {
    if (pathParts.length === 1) {
      return this.files[RelativeFilePath.of(pathParts[0])] ??= {};
    }
    const [directory, ...remainingPath] = pathParts;
    if (directory == null) {
      throw new Error(`Internal error; cannot add file with path: ${pathParts}`);
    }
    if (!this.directories[directory]) {
      this.directories[directory] = new _FernDefinitionDirectory();
    }
    return this.directories[directory].getOrCreateFileRecursive(remainingPath);
  }
};

// ../../cli/api-importers/commons/lib/FernDefinitionBuilder.js
var FernDefinitionBuilderImpl = class {
  enableUniqueErrorsPerEndpoint;
  root;
  rootApiFile;
  packageMarkerFile = {};
  basePath = void 0;
  constructor(enableUniqueErrorsPerEndpoint) {
    this.enableUniqueErrorsPerEndpoint = enableUniqueErrorsPerEndpoint;
    this.root = new FernDefinitionDirectory();
    this.rootApiFile = {
      name: "api",
      "error-discrimination": {
        strategy: "status-code"
      }
    };
  }
  setDisplayName({ displayName }) {
    this.rootApiFile["display-name"] = displayName;
  }
  addNavigation({ navigation }) {
    this.packageMarkerFile.navigation = navigation;
  }
  setServiceInfo(file, { auth, "base-path": basePath, "display-name": displayName, docs }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.service == null) {
      fernFile.service = {
        auth: false,
        "base-path": "",
        endpoints: {}
      };
    }
    if (auth != null) {
      fernFile.service.auth = auth;
    }
    if (basePath != null) {
      fernFile.service["base-path"] = basePath;
    }
    if (displayName != null) {
      fernFile.service["display-name"] = displayName;
    }
    if (docs != null) {
      fernFile.docs = docs;
    }
  }
  addAudience(name) {
    if (this.rootApiFile.audiences == null) {
      this.rootApiFile.audiences = [];
    }
    this.rootApiFile.audiences.push(name);
  }
  setAuth(auth) {
    this.rootApiFile.auth = auth;
  }
  addAuthScheme({ name, schema: schema2 }) {
    if (this.rootApiFile["auth-schemes"] == null) {
      this.rootApiFile["auth-schemes"] = {};
    }
    if (this.rootApiFile["auth-schemes"][name] == null) {
      this.rootApiFile["auth-schemes"][name] = schema2;
    }
  }
  setDefaultEnvironment(name) {
    this.rootApiFile["default-environment"] = name;
  }
  setDefaultUrl(name) {
    this.rootApiFile["default-url"] = name;
  }
  setBasePath(basePath) {
    this.basePath = basePath;
  }
  setApiVersion(apiVersionScheme) {
    this.rootApiFile.version = apiVersionScheme;
  }
  getEnvironmentType() {
    const environmentEntry = Object.entries(this.rootApiFile.environments ?? {})[0];
    if (environmentEntry == null) {
      return void 0;
    }
    return visitRawEnvironmentDeclaration(environmentEntry[1], {
      singleBaseUrl: () => "single",
      multipleBaseUrls: () => "multi"
    });
  }
  addEnvironment({ name, schema: schema2 }) {
    if (this.rootApiFile.environments == null) {
      this.rootApiFile.environments = {};
    }
    this.rootApiFile.environments[name] = schema2;
  }
  getGlobalHeaderNames() {
    const headerNames = Object.keys(this.rootApiFile.headers ?? {});
    const maybeVersionHeader = this.getVersionHeader();
    if (maybeVersionHeader != null) {
      headerNames.push(maybeVersionHeader);
    }
    return new Set(headerNames);
  }
  addGlobalHeader({ name, schema: schema2 }) {
    const maybeVersionHeader = this.getVersionHeader();
    if (maybeVersionHeader != null && maybeVersionHeader === name) {
      return;
    }
    if (this.rootApiFile.headers == null) {
      this.rootApiFile.headers = {};
    }
    this.rootApiFile.headers[name] = schema2;
  }
  addIdempotencyHeader({ name, schema: schema2 }) {
    if (this.rootApiFile["idempotency-headers"] == null) {
      this.rootApiFile["idempotency-headers"] = {};
    }
    this.rootApiFile["idempotency-headers"][name] = schema2;
  }
  addVariable({ name, schema: schema2 }) {
    if (this.rootApiFile.variables == null) {
      this.rootApiFile.variables = {};
    }
    this.rootApiFile.variables[name] = schema2;
  }
  addImport({ file, fileToImport, alias }) {
    if (file === fileToImport) {
      return void 0;
    }
    const importPrefix = alias ?? camelCase_default((dirname(fileToImport) + "/" + (0, import_path.basename)(fileToImport, (0, import_path.extname)(fileToImport))).replaceAll("__package__", "root"));
    if (file === RelativeFilePath.of(ROOT_API_FILENAME)) {
      if (this.rootApiFile.imports == null) {
        this.rootApiFile.imports = {};
      }
      this.rootApiFile.imports[importPrefix] = relative(dirname(AbsoluteFilePath.of(`/${file}`)), AbsoluteFilePath.of(`/${fileToImport}`));
      return importPrefix;
    }
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.imports == null) {
      fernFile.imports = {};
    }
    fernFile.imports[importPrefix] = relative(dirname(AbsoluteFilePath.of(`/${file}`)), AbsoluteFilePath.of(`/${fileToImport}`));
    return importPrefix;
  }
  addType(file, { name, schema: schema2 }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.types == null) {
      fernFile.types = {};
    }
    fernFile.types[name] = schema2;
  }
  addTypeExample(file, name, convertedExample) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.types == null) {
      fernFile.types = {};
    }
    const type2 = fernFile.types[name];
    if (type2 != null) {
      if (typeof type2 === "string") {
        fernFile.types[name] = {
          type: type2,
          examples: [convertedExample]
        };
      } else {
        if (type2.examples == null) {
          type2.examples = [];
        }
        type2.examples.push(convertedExample);
      }
    }
  }
  addError(file, { name, schema: schema2 }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.errors == null) {
      fernFile.errors = {};
    }
    if (fernFile.errors[name] == null) {
      fernFile.errors[name] = schema2;
    } else if (fernFile.errors[name]?.type !== schema2.type) {
      fernFile.errors[name] = {
        "status-code": schema2["status-code"],
        type: "unknown"
      };
    }
  }
  addErrorExample(file, { name, example }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.errors == null) {
      return;
    }
    const errorDeclaration = fernFile.errors[name];
    if (errorDeclaration == null) {
      return;
    }
    if (errorDeclaration.examples == null) {
      errorDeclaration.examples = [];
    }
    const alreadyAdded = errorDeclaration.examples.some((existingExample) => {
      return isEqual_default(existingExample, example);
    }) ?? false;
    if (!alreadyAdded) {
      errorDeclaration.examples?.push(example);
    }
  }
  addEndpoint(file, { name, schema: schema2, source }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.service == null) {
      fernFile.service = {
        auth: false,
        "base-path": "",
        endpoints: {}
      };
    }
    if (source != null) {
      fernFile.service.source = source;
    }
    fernFile.service.endpoints[name] = schema2;
  }
  addWebhook(file, { name, schema: schema2 }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.webhooks == null) {
      fernFile.webhooks = {};
    }
    fernFile.webhooks[name] = schema2;
  }
  addChannel(file, { channel }) {
    const fernFile = this.getOrCreateFile(file);
    fernFile.channel = channel;
    const basePath = this.basePath;
    if (basePath != null) {
      fernFile.channel.path = import_path.default.join(basePath, channel.path);
    }
  }
  addChannelExample(file, { example }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.channel == null) {
      fernFile.channel = {
        path: "",
        auth: false
      };
    }
    if (fernFile.channel.messages == null) {
      fernFile.channel.messages = {};
    }
    if (fernFile.channel.examples == null) {
      fernFile.channel.examples = [];
    }
    fernFile.channel.examples.push(example);
  }
  addChannelMessage(file, { messageId, message }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.channel == null) {
      fernFile.channel = {
        path: "",
        auth: false
      };
    }
    if (fernFile.channel.messages == null) {
      fernFile.channel.messages = {};
    }
    fernFile.channel.messages[messageId] = message;
  }
  build() {
    const definitionFiles = this.root.getAllFiles();
    const basePath = this.basePath;
    if (basePath != null) {
      if (this.packageMarkerFile.service != null) {
        this.packageMarkerFile.service = {
          ...this.packageMarkerFile.service,
          endpoints: Object.fromEntries(Object.entries(this.packageMarkerFile.service.endpoints).map(([id, endpoint]) => {
            return [
              id,
              {
                ...endpoint,
                path: import_path.default.join(basePath, endpoint.path)
              }
            ];
          }))
        };
      }
      for (const file of Object.values(definitionFiles)) {
        if (file.service != null) {
          file.service = {
            ...file.service,
            endpoints: Object.fromEntries(Object.entries(file.service.endpoints).map(([id, endpoint]) => {
              return [
                id,
                {
                  ...endpoint,
                  path: import_path.default.join(basePath, endpoint.path)
                }
              ];
            }))
          };
        }
      }
    }
    const definition = {
      rootApiFile: this.rootApiFile,
      packageMarkerFile: this.packageMarkerFile,
      definitionFiles
    };
    return definition;
  }
  getOrCreateFile(file) {
    if (file === FERN_PACKAGE_MARKER_FILENAME) {
      return this.packageMarkerFile;
    } else {
      return this.root.getOrCreateFile(file);
    }
  }
  getVersionHeader() {
    if (this.rootApiFile.version == null) {
      return void 0;
    }
    return typeof this.rootApiFile.version.header === "string" ? this.rootApiFile.version.header : this.rootApiFile.version.header.value;
  }
};

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/OpenApiIrConverterContext.js
var OpenApiIrConverterContext = class {
  logger;
  taskContext;
  ir;
  builder;
  environmentOverrides;
  authOverrides;
  globalHeaderOverrides;
  detectGlobalHeaders;
  objectQueryParameters;
  respectReadonlySchemas;
  onlyIncludeReferencedSchemas;
  inlinePathParameters;
  enableUniqueErrorsPerEndpoint;
  defaultServerName = void 0;
  unknownSchema = /* @__PURE__ */ new Set();
  /**
   * The set of referenced schema ids to include in the generated definition.
   * If this value is undefined, _all_ schemaIds should be treated as referenced,
   * and therefore included in the generated definition.
   */
  referencedSchemaIds;
  /**
   * The current endpoint method being processed. This is used to determine
   * whether certain properties should be included in the generated definition
   * (e.g. readonly properties are excluded for POST/PUT endpoints).
   */
  endpointMethod;
  /**
   * Tracks the state in which a schema is being processed (e.g. endpoint, channel, webhook,
   * request). It's possible that a schema is being processed in multiple states (e.g. an
   * endpoint and a request).
   */
  state = /* @__PURE__ */ new Set();
  constructor({ taskContext, ir, enableUniqueErrorsPerEndpoint, detectGlobalHeaders, environmentOverrides, globalHeaderOverrides, authOverrides, objectQueryParameters, respectReadonlySchemas, onlyIncludeReferencedSchemas, inlinePathParameters }) {
    this.logger = taskContext.logger;
    this.taskContext = taskContext;
    this.ir = ir;
    this.enableUniqueErrorsPerEndpoint = enableUniqueErrorsPerEndpoint;
    this.builder = new FernDefinitionBuilderImpl(enableUniqueErrorsPerEndpoint);
    if (ir.title != null) {
      this.builder.setDisplayName({ displayName: ir.title });
    }
    this.detectGlobalHeaders = detectGlobalHeaders;
    this.environmentOverrides = environmentOverrides;
    this.authOverrides = authOverrides;
    this.globalHeaderOverrides = globalHeaderOverrides;
    this.objectQueryParameters = objectQueryParameters;
    this.respectReadonlySchemas = respectReadonlySchemas;
    this.onlyIncludeReferencedSchemas = onlyIncludeReferencedSchemas;
    this.inlinePathParameters = inlinePathParameters;
    this.referencedSchemaIds = onlyIncludeReferencedSchemas ? /* @__PURE__ */ new Set() : void 0;
    const schemaByStatusCode = {};
    if (!this.enableUniqueErrorsPerEndpoint) {
      for (const endpoint of ir.endpoints) {
        for (const [statusCodeString, error] of Object.entries(endpoint.errors)) {
          const statusCode = parseInt(statusCodeString);
          const existingSchema = schemaByStatusCode[statusCode];
          if (existingSchema == null && error.schema != null) {
            schemaByStatusCode[statusCode] = error.schema;
          } else if (existingSchema != null && error.schema != null && isSchemaEqual(existingSchema, error.schema)) {
          } else {
            this.unknownSchema.add(statusCode);
          }
        }
      }
    }
  }
  getReferencedSchemaIds() {
    if (this.referencedSchemaIds == null) {
      return void 0;
    }
    return Array.from(this.referencedSchemaIds);
  }
  getSchema(id, namespace) {
    if (namespace == null) {
      return this.ir.groupedSchemas.rootSchemas[id];
    }
    return this.ir.groupedSchemas.namespacedSchemas[namespace]?.[id];
  }
  /**
   * Returns the default server URL. This URL should only be set for multi-url cases.
   */
  getDefaultServerName() {
    return this.defaultServerName;
  }
  /**
   * Sets the default server URL. This URL should only be set for multi-url cases.
   */
  setDefaultServerName(name) {
    this.defaultServerName = name;
  }
  /**
   * Is error an unknown schema
   */
  isErrorUnknownSchema(statusCode) {
    return this.unknownSchema.has(statusCode);
  }
  /**
   * Returns the current endpoint method being processed
   */
  getEndpointMethod() {
    return this.endpointMethod;
  }
  /**
   * Sets the current endpoint method being processed
   */
  setEndpointMethod(method) {
    this.endpointMethod = method;
  }
  /**
   * Unsets the current endpoint method being processed
   */
  unsetEndpointMethod() {
    this.endpointMethod = void 0;
  }
  /**
   * Returns whether we're currently processing the given state.
   */
  isInState(state) {
    return this.state.has(state);
  }
  /**
   * Sets that we're currently processing the given state.
   */
  setInState(state) {
    this.state.add(state);
  }
  /**
   * Unsets that we're currently processing the given state.
   */
  unsetInState(state) {
    this.state.delete(state);
  }
  shouldMarkSchemaAsReferenced() {
    return this.onlyIncludeReferencedSchemas && this.isInAnyState(State.Channel, State.Endpoint, State.Webhook);
  }
  /**
   * Marks a schema as referenced.
   */
  markSchemaAsReferenced(schema2, namespace) {
    switch (schema2.type) {
      case "primitive":
        return;
      case "object":
        this.markObjectSchemaAsReferenced(schema2, namespace);
        return;
      case "array":
        this.markSchemaAsReferenced(schema2.value, namespace);
        return;
      case "map":
        this.markSchemaAsReferenced(schema2.value, namespace);
        return;
      case "optional":
        this.markSchemaAsReferenced(schema2.value, namespace);
        return;
      case "reference":
        this.markSchemaIdAsReferenced(schema2.schema, namespace);
        return;
      case "oneOf":
        this.markOneofSchemaAsReferenced(schema2.value, namespace);
        return;
      case "nullable":
        this.markSchemaAsReferenced(schema2.value, namespace);
        return;
      case "enum":
        return;
      case "literal":
        return;
      case "unknown":
        return;
      default:
        assertNever(schema2);
    }
  }
  markObjectSchemaAsReferenced(schema2, namespace) {
    for (const allOf of schema2.allOf) {
      this.markSchemaIdAsReferenced(allOf.schema, namespace);
    }
    for (const property4 of schema2.properties) {
      this.markSchemaAsReferenced(property4.schema, namespace);
    }
  }
  markOneofSchemaAsReferenced(schema2, namespace) {
    switch (schema2.type) {
      case "discriminated":
        for (const oneOf of Object.values(schema2.schemas)) {
          this.markSchemaAsReferenced(oneOf, namespace);
        }
        return;
      case "undisciminated":
        for (const oneOf of schema2.schemas) {
          this.markSchemaAsReferenced(oneOf, namespace);
        }
        return;
      default:
        assertNever(schema2);
    }
  }
  markSchemaIdAsReferenced(id, namespace) {
    if (this.referencedSchemaIds != null && !this.referencedSchemaIds.has(id)) {
      this.referencedSchemaIds.add(id);
      const schema2 = this.getSchema(id, namespace);
      if (schema2 != null) {
        this.markSchemaAsReferenced(schema2, namespace);
      }
    }
  }
  isInAnyState(...states) {
    return states.some((state) => this.isInState(state));
  }
};

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/convert.js
function convert(opts) {
  const context = new OpenApiIrConverterContext(opts);
  return buildFernDefinition(context);
}

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/dist/js-yaml.mjs
function isNothing(subject) {
  return typeof subject === "undefined" || subject === null;
}
function isObject2(subject) {
  return typeof subject === "object" && subject !== null;
}
function toArray(sequence) {
  if (Array.isArray(sequence)) return sequence;
  else if (isNothing(sequence)) return [];
  return [sequence];
}
function extend(target, source) {
  var index, length, key, sourceKeys;
  if (source) {
    sourceKeys = Object.keys(source);
    for (index = 0, length = sourceKeys.length; index < length; index += 1) {
      key = sourceKeys[index];
      target[key] = source[key];
    }
  }
  return target;
}
function repeat(string3, count) {
  var result = "", cycle;
  for (cycle = 0; cycle < count; cycle += 1) {
    result += string3;
  }
  return result;
}
function isNegativeZero(number3) {
  return number3 === 0 && Number.NEGATIVE_INFINITY === 1 / number3;
}
var isNothing_1 = isNothing;
var isObject_1 = isObject2;
var toArray_1 = toArray;
var repeat_1 = repeat;
var isNegativeZero_1 = isNegativeZero;
var extend_1 = extend;
var common = {
  isNothing: isNothing_1,
  isObject: isObject_1,
  toArray: toArray_1,
  repeat: repeat_1,
  isNegativeZero: isNegativeZero_1,
  extend: extend_1
};
function formatError(exception2, compact2) {
  var where = "", message = exception2.reason || "(unknown reason)";
  if (!exception2.mark) return message;
  if (exception2.mark.name) {
    where += 'in "' + exception2.mark.name + '" ';
  }
  where += "(" + (exception2.mark.line + 1) + ":" + (exception2.mark.column + 1) + ")";
  if (!compact2 && exception2.mark.snippet) {
    where += "\n\n" + exception2.mark.snippet;
  }
  return message + " " + where;
}
function YAMLException$1(reason, mark) {
  Error.call(this);
  this.name = "YAMLException";
  this.reason = reason;
  this.mark = mark;
  this.message = formatError(this, false);
  if (Error.captureStackTrace) {
    Error.captureStackTrace(this, this.constructor);
  } else {
    this.stack = new Error().stack || "";
  }
}
YAMLException$1.prototype = Object.create(Error.prototype);
YAMLException$1.prototype.constructor = YAMLException$1;
YAMLException$1.prototype.toString = function toString3(compact2) {
  return this.name + ": " + formatError(this, compact2);
};
var exception = YAMLException$1;
function getLine(buffer, lineStart, lineEnd, position, maxLineLength) {
  var head = "";
  var tail = "";
  var maxHalfLength = Math.floor(maxLineLength / 2) - 1;
  if (position - lineStart > maxHalfLength) {
    head = " ... ";
    lineStart = position - maxHalfLength + head.length;
  }
  if (lineEnd - position > maxHalfLength) {
    tail = " ...";
    lineEnd = position + maxHalfLength - tail.length;
  }
  return {
    str: head + buffer.slice(lineStart, lineEnd).replace(/\t/g, "\u2192") + tail,
    pos: position - lineStart + head.length
    // relative position
  };
}
function padStart(string3, max) {
  return common.repeat(" ", max - string3.length) + string3;
}
function makeSnippet(mark, options) {
  options = Object.create(options || null);
  if (!mark.buffer) return null;
  if (!options.maxLength) options.maxLength = 79;
  if (typeof options.indent !== "number") options.indent = 1;
  if (typeof options.linesBefore !== "number") options.linesBefore = 3;
  if (typeof options.linesAfter !== "number") options.linesAfter = 2;
  var re = /\r?\n|\r|\0/g;
  var lineStarts = [0];
  var lineEnds = [];
  var match;
  var foundLineNo = -1;
  while (match = re.exec(mark.buffer)) {
    lineEnds.push(match.index);
    lineStarts.push(match.index + match[0].length);
    if (mark.position <= match.index && foundLineNo < 0) {
      foundLineNo = lineStarts.length - 2;
    }
  }
  if (foundLineNo < 0) foundLineNo = lineStarts.length - 1;
  var result = "", i, line;
  var lineNoLength = Math.min(mark.line + options.linesAfter, lineEnds.length).toString().length;
  var maxLineLength = options.maxLength - (options.indent + lineNoLength + 3);
  for (i = 1; i <= options.linesBefore; i++) {
    if (foundLineNo - i < 0) break;
    line = getLine(
      mark.buffer,
      lineStarts[foundLineNo - i],
      lineEnds[foundLineNo - i],
      mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo - i]),
      maxLineLength
    );
    result = common.repeat(" ", options.indent) + padStart((mark.line - i + 1).toString(), lineNoLength) + " | " + line.str + "\n" + result;
  }
  line = getLine(mark.buffer, lineStarts[foundLineNo], lineEnds[foundLineNo], mark.position, maxLineLength);
  result += common.repeat(" ", options.indent) + padStart((mark.line + 1).toString(), lineNoLength) + " | " + line.str + "\n";
  result += common.repeat("-", options.indent + lineNoLength + 3 + line.pos) + "^\n";
  for (i = 1; i <= options.linesAfter; i++) {
    if (foundLineNo + i >= lineEnds.length) break;
    line = getLine(
      mark.buffer,
      lineStarts[foundLineNo + i],
      lineEnds[foundLineNo + i],
      mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo + i]),
      maxLineLength
    );
    result += common.repeat(" ", options.indent) + padStart((mark.line + i + 1).toString(), lineNoLength) + " | " + line.str + "\n";
  }
  return result.replace(/\n$/, "");
}
var snippet = makeSnippet;
var TYPE_CONSTRUCTOR_OPTIONS = [
  "kind",
  "multi",
  "resolve",
  "construct",
  "instanceOf",
  "predicate",
  "represent",
  "representName",
  "defaultStyle",
  "styleAliases"
];
var YAML_NODE_KINDS = [
  "scalar",
  "sequence",
  "mapping"
];
function compileStyleAliases(map2) {
  var result = {};
  if (map2 !== null) {
    Object.keys(map2).forEach(function(style) {
      map2[style].forEach(function(alias) {
        result[String(alias)] = style;
      });
    });
  }
  return result;
}
function Type$1(tag, options) {
  options = options || {};
  Object.keys(options).forEach(function(name) {
    if (TYPE_CONSTRUCTOR_OPTIONS.indexOf(name) === -1) {
      throw new exception('Unknown option "' + name + '" is met in definition of "' + tag + '" YAML type.');
    }
  });
  this.options = options;
  this.tag = tag;
  this.kind = options["kind"] || null;
  this.resolve = options["resolve"] || function() {
    return true;
  };
  this.construct = options["construct"] || function(data) {
    return data;
  };
  this.instanceOf = options["instanceOf"] || null;
  this.predicate = options["predicate"] || null;
  this.represent = options["represent"] || null;
  this.representName = options["representName"] || null;
  this.defaultStyle = options["defaultStyle"] || null;
  this.multi = options["multi"] || false;
  this.styleAliases = compileStyleAliases(options["styleAliases"] || null);
  if (YAML_NODE_KINDS.indexOf(this.kind) === -1) {
    throw new exception('Unknown kind "' + this.kind + '" is specified for "' + tag + '" YAML type.');
  }
}
var type = Type$1;
function compileList(schema2, name) {
  var result = [];
  schema2[name].forEach(function(currentType) {
    var newIndex = result.length;
    result.forEach(function(previousType, previousIndex) {
      if (previousType.tag === currentType.tag && previousType.kind === currentType.kind && previousType.multi === currentType.multi) {
        newIndex = previousIndex;
      }
    });
    result[newIndex] = currentType;
  });
  return result;
}
function compileMap() {
  var result = {
    scalar: {},
    sequence: {},
    mapping: {},
    fallback: {},
    multi: {
      scalar: [],
      sequence: [],
      mapping: [],
      fallback: []
    }
  }, index, length;
  function collectType(type2) {
    if (type2.multi) {
      result.multi[type2.kind].push(type2);
      result.multi["fallback"].push(type2);
    } else {
      result[type2.kind][type2.tag] = result["fallback"][type2.tag] = type2;
    }
  }
  for (index = 0, length = arguments.length; index < length; index += 1) {
    arguments[index].forEach(collectType);
  }
  return result;
}
function Schema$1(definition) {
  return this.extend(definition);
}
Schema$1.prototype.extend = function extend2(definition) {
  var implicit = [];
  var explicit = [];
  if (definition instanceof type) {
    explicit.push(definition);
  } else if (Array.isArray(definition)) {
    explicit = explicit.concat(definition);
  } else if (definition && (Array.isArray(definition.implicit) || Array.isArray(definition.explicit))) {
    if (definition.implicit) implicit = implicit.concat(definition.implicit);
    if (definition.explicit) explicit = explicit.concat(definition.explicit);
  } else {
    throw new exception("Schema.extend argument should be a Type, [ Type ], or a schema definition ({ implicit: [...], explicit: [...] })");
  }
  implicit.forEach(function(type$1) {
    if (!(type$1 instanceof type)) {
      throw new exception("Specified list of YAML types (or a single Type object) contains a non-Type object.");
    }
    if (type$1.loadKind && type$1.loadKind !== "scalar") {
      throw new exception("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.");
    }
    if (type$1.multi) {
      throw new exception("There is a multi type in the implicit list of a schema. Multi tags can only be listed as explicit.");
    }
  });
  explicit.forEach(function(type$1) {
    if (!(type$1 instanceof type)) {
      throw new exception("Specified list of YAML types (or a single Type object) contains a non-Type object.");
    }
  });
  var result = Object.create(Schema$1.prototype);
  result.implicit = (this.implicit || []).concat(implicit);
  result.explicit = (this.explicit || []).concat(explicit);
  result.compiledImplicit = compileList(result, "implicit");
  result.compiledExplicit = compileList(result, "explicit");
  result.compiledTypeMap = compileMap(result.compiledImplicit, result.compiledExplicit);
  return result;
};
var schema = Schema$1;
var str = new type("tag:yaml.org,2002:str", {
  kind: "scalar",
  construct: function(data) {
    return data !== null ? data : "";
  }
});
var seq = new type("tag:yaml.org,2002:seq", {
  kind: "sequence",
  construct: function(data) {
    return data !== null ? data : [];
  }
});
var map = new type("tag:yaml.org,2002:map", {
  kind: "mapping",
  construct: function(data) {
    return data !== null ? data : {};
  }
});
var failsafe = new schema({
  explicit: [
    str,
    seq,
    map
  ]
});
function resolveYamlNull(data) {
  if (data === null) return true;
  var max = data.length;
  return max === 1 && data === "~" || max === 4 && (data === "null" || data === "Null" || data === "NULL");
}
function constructYamlNull() {
  return null;
}
function isNull2(object3) {
  return object3 === null;
}
var _null = new type("tag:yaml.org,2002:null", {
  kind: "scalar",
  resolve: resolveYamlNull,
  construct: constructYamlNull,
  predicate: isNull2,
  represent: {
    canonical: function() {
      return "~";
    },
    lowercase: function() {
      return "null";
    },
    uppercase: function() {
      return "NULL";
    },
    camelcase: function() {
      return "Null";
    },
    empty: function() {
      return "";
    }
  },
  defaultStyle: "lowercase"
});
function resolveYamlBoolean(data) {
  if (data === null) return false;
  var max = data.length;
  return max === 4 && (data === "true" || data === "True" || data === "TRUE") || max === 5 && (data === "false" || data === "False" || data === "FALSE");
}
function constructYamlBoolean(data) {
  return data === "true" || data === "True" || data === "TRUE";
}
function isBoolean(object3) {
  return Object.prototype.toString.call(object3) === "[object Boolean]";
}
var bool = new type("tag:yaml.org,2002:bool", {
  kind: "scalar",
  resolve: resolveYamlBoolean,
  construct: constructYamlBoolean,
  predicate: isBoolean,
  represent: {
    lowercase: function(object3) {
      return object3 ? "true" : "false";
    },
    uppercase: function(object3) {
      return object3 ? "TRUE" : "FALSE";
    },
    camelcase: function(object3) {
      return object3 ? "True" : "False";
    }
  },
  defaultStyle: "lowercase"
});
function isHexCode(c) {
  return 48 <= c && c <= 57 || 65 <= c && c <= 70 || 97 <= c && c <= 102;
}
function isOctCode(c) {
  return 48 <= c && c <= 55;
}
function isDecCode(c) {
  return 48 <= c && c <= 57;
}
function resolveYamlInteger(data) {
  if (data === null) return false;
  var max = data.length, index = 0, hasDigits = false, ch;
  if (!max) return false;
  ch = data[index];
  if (ch === "-" || ch === "+") {
    ch = data[++index];
  }
  if (ch === "0") {
    if (index + 1 === max) return true;
    ch = data[++index];
    if (ch === "b") {
      index++;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_") continue;
        if (ch !== "0" && ch !== "1") return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
    if (ch === "x") {
      index++;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_") continue;
        if (!isHexCode(data.charCodeAt(index))) return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
    if (ch === "o") {
      index++;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_") continue;
        if (!isOctCode(data.charCodeAt(index))) return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
  }
  if (ch === "_") return false;
  for (; index < max; index++) {
    ch = data[index];
    if (ch === "_") continue;
    if (!isDecCode(data.charCodeAt(index))) {
      return false;
    }
    hasDigits = true;
  }
  if (!hasDigits || ch === "_") return false;
  return true;
}
function constructYamlInteger(data) {
  var value = data, sign = 1, ch;
  if (value.indexOf("_") !== -1) {
    value = value.replace(/_/g, "");
  }
  ch = value[0];
  if (ch === "-" || ch === "+") {
    if (ch === "-") sign = -1;
    value = value.slice(1);
    ch = value[0];
  }
  if (value === "0") return 0;
  if (ch === "0") {
    if (value[1] === "b") return sign * parseInt(value.slice(2), 2);
    if (value[1] === "x") return sign * parseInt(value.slice(2), 16);
    if (value[1] === "o") return sign * parseInt(value.slice(2), 8);
  }
  return sign * parseInt(value, 10);
}
function isInteger(object3) {
  return Object.prototype.toString.call(object3) === "[object Number]" && (object3 % 1 === 0 && !common.isNegativeZero(object3));
}
var int = new type("tag:yaml.org,2002:int", {
  kind: "scalar",
  resolve: resolveYamlInteger,
  construct: constructYamlInteger,
  predicate: isInteger,
  represent: {
    binary: function(obj) {
      return obj >= 0 ? "0b" + obj.toString(2) : "-0b" + obj.toString(2).slice(1);
    },
    octal: function(obj) {
      return obj >= 0 ? "0o" + obj.toString(8) : "-0o" + obj.toString(8).slice(1);
    },
    decimal: function(obj) {
      return obj.toString(10);
    },
    /* eslint-disable max-len */
    hexadecimal: function(obj) {
      return obj >= 0 ? "0x" + obj.toString(16).toUpperCase() : "-0x" + obj.toString(16).toUpperCase().slice(1);
    }
  },
  defaultStyle: "decimal",
  styleAliases: {
    binary: [2, "bin"],
    octal: [8, "oct"],
    decimal: [10, "dec"],
    hexadecimal: [16, "hex"]
  }
});
var YAML_FLOAT_PATTERN = new RegExp(
  // 2.5e4, 2.5 and integers
  "^(?:[-+]?(?:[0-9][0-9_]*)(?:\\.[0-9_]*)?(?:[eE][-+]?[0-9]+)?|\\.[0-9_]+(?:[eE][-+]?[0-9]+)?|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$"
);
function resolveYamlFloat(data) {
  if (data === null) return false;
  if (!YAML_FLOAT_PATTERN.test(data) || // Quick hack to not allow integers end with `_`
  // Probably should update regexp & check speed
  data[data.length - 1] === "_") {
    return false;
  }
  return true;
}
function constructYamlFloat(data) {
  var value, sign;
  value = data.replace(/_/g, "").toLowerCase();
  sign = value[0] === "-" ? -1 : 1;
  if ("+-".indexOf(value[0]) >= 0) {
    value = value.slice(1);
  }
  if (value === ".inf") {
    return sign === 1 ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY;
  } else if (value === ".nan") {
    return NaN;
  }
  return sign * parseFloat(value, 10);
}
var SCIENTIFIC_WITHOUT_DOT = /^[-+]?[0-9]+e/;
function representYamlFloat(object3, style) {
  var res;
  if (isNaN(object3)) {
    switch (style) {
      case "lowercase":
        return ".nan";
      case "uppercase":
        return ".NAN";
      case "camelcase":
        return ".NaN";
    }
  } else if (Number.POSITIVE_INFINITY === object3) {
    switch (style) {
      case "lowercase":
        return ".inf";
      case "uppercase":
        return ".INF";
      case "camelcase":
        return ".Inf";
    }
  } else if (Number.NEGATIVE_INFINITY === object3) {
    switch (style) {
      case "lowercase":
        return "-.inf";
      case "uppercase":
        return "-.INF";
      case "camelcase":
        return "-.Inf";
    }
  } else if (common.isNegativeZero(object3)) {
    return "-0.0";
  }
  res = object3.toString(10);
  return SCIENTIFIC_WITHOUT_DOT.test(res) ? res.replace("e", ".e") : res;
}
function isFloat(object3) {
  return Object.prototype.toString.call(object3) === "[object Number]" && (object3 % 1 !== 0 || common.isNegativeZero(object3));
}
var float = new type("tag:yaml.org,2002:float", {
  kind: "scalar",
  resolve: resolveYamlFloat,
  construct: constructYamlFloat,
  predicate: isFloat,
  represent: representYamlFloat,
  defaultStyle: "lowercase"
});
var json = failsafe.extend({
  implicit: [
    _null,
    bool,
    int,
    float
  ]
});
var core = json;
var YAML_DATE_REGEXP = new RegExp(
  "^([0-9][0-9][0-9][0-9])-([0-9][0-9])-([0-9][0-9])$"
);
var YAML_TIMESTAMP_REGEXP = new RegExp(
  "^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?$"
);
function resolveYamlTimestamp(data) {
  if (data === null) return false;
  if (YAML_DATE_REGEXP.exec(data) !== null) return true;
  if (YAML_TIMESTAMP_REGEXP.exec(data) !== null) return true;
  return false;
}
function constructYamlTimestamp(data) {
  var match, year, month, day, hour, minute, second, fraction = 0, delta = null, tz_hour, tz_minute, date3;
  match = YAML_DATE_REGEXP.exec(data);
  if (match === null) match = YAML_TIMESTAMP_REGEXP.exec(data);
  if (match === null) throw new Error("Date resolve error");
  year = +match[1];
  month = +match[2] - 1;
  day = +match[3];
  if (!match[4]) {
    return new Date(Date.UTC(year, month, day));
  }
  hour = +match[4];
  minute = +match[5];
  second = +match[6];
  if (match[7]) {
    fraction = match[7].slice(0, 3);
    while (fraction.length < 3) {
      fraction += "0";
    }
    fraction = +fraction;
  }
  if (match[9]) {
    tz_hour = +match[10];
    tz_minute = +(match[11] || 0);
    delta = (tz_hour * 60 + tz_minute) * 6e4;
    if (match[9] === "-") delta = -delta;
  }
  date3 = new Date(Date.UTC(year, month, day, hour, minute, second, fraction));
  if (delta) date3.setTime(date3.getTime() - delta);
  return date3;
}
function representYamlTimestamp(object3) {
  return object3.toISOString();
}
var timestamp = new type("tag:yaml.org,2002:timestamp", {
  kind: "scalar",
  resolve: resolveYamlTimestamp,
  construct: constructYamlTimestamp,
  instanceOf: Date,
  represent: representYamlTimestamp
});
function resolveYamlMerge(data) {
  return data === "<<" || data === null;
}
var merge = new type("tag:yaml.org,2002:merge", {
  kind: "scalar",
  resolve: resolveYamlMerge
});
var BASE64_MAP = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r";
function resolveYamlBinary(data) {
  if (data === null) return false;
  var code, idx, bitlen = 0, max = data.length, map2 = BASE64_MAP;
  for (idx = 0; idx < max; idx++) {
    code = map2.indexOf(data.charAt(idx));
    if (code > 64) continue;
    if (code < 0) return false;
    bitlen += 6;
  }
  return bitlen % 8 === 0;
}
function constructYamlBinary(data) {
  var idx, tailbits, input = data.replace(/[\r\n=]/g, ""), max = input.length, map2 = BASE64_MAP, bits = 0, result = [];
  for (idx = 0; idx < max; idx++) {
    if (idx % 4 === 0 && idx) {
      result.push(bits >> 16 & 255);
      result.push(bits >> 8 & 255);
      result.push(bits & 255);
    }
    bits = bits << 6 | map2.indexOf(input.charAt(idx));
  }
  tailbits = max % 4 * 6;
  if (tailbits === 0) {
    result.push(bits >> 16 & 255);
    result.push(bits >> 8 & 255);
    result.push(bits & 255);
  } else if (tailbits === 18) {
    result.push(bits >> 10 & 255);
    result.push(bits >> 2 & 255);
  } else if (tailbits === 12) {
    result.push(bits >> 4 & 255);
  }
  return new Uint8Array(result);
}
function representYamlBinary(object3) {
  var result = "", bits = 0, idx, tail, max = object3.length, map2 = BASE64_MAP;
  for (idx = 0; idx < max; idx++) {
    if (idx % 3 === 0 && idx) {
      result += map2[bits >> 18 & 63];
      result += map2[bits >> 12 & 63];
      result += map2[bits >> 6 & 63];
      result += map2[bits & 63];
    }
    bits = (bits << 8) + object3[idx];
  }
  tail = max % 3;
  if (tail === 0) {
    result += map2[bits >> 18 & 63];
    result += map2[bits >> 12 & 63];
    result += map2[bits >> 6 & 63];
    result += map2[bits & 63];
  } else if (tail === 2) {
    result += map2[bits >> 10 & 63];
    result += map2[bits >> 4 & 63];
    result += map2[bits << 2 & 63];
    result += map2[64];
  } else if (tail === 1) {
    result += map2[bits >> 2 & 63];
    result += map2[bits << 4 & 63];
    result += map2[64];
    result += map2[64];
  }
  return result;
}
function isBinary(obj) {
  return Object.prototype.toString.call(obj) === "[object Uint8Array]";
}
var binary = new type("tag:yaml.org,2002:binary", {
  kind: "scalar",
  resolve: resolveYamlBinary,
  construct: constructYamlBinary,
  predicate: isBinary,
  represent: representYamlBinary
});
var _hasOwnProperty$3 = Object.prototype.hasOwnProperty;
var _toString$2 = Object.prototype.toString;
function resolveYamlOmap(data) {
  if (data === null) return true;
  var objectKeys = [], index, length, pair, pairKey, pairHasKey, object3 = data;
  for (index = 0, length = object3.length; index < length; index += 1) {
    pair = object3[index];
    pairHasKey = false;
    if (_toString$2.call(pair) !== "[object Object]") return false;
    for (pairKey in pair) {
      if (_hasOwnProperty$3.call(pair, pairKey)) {
        if (!pairHasKey) pairHasKey = true;
        else return false;
      }
    }
    if (!pairHasKey) return false;
    if (objectKeys.indexOf(pairKey) === -1) objectKeys.push(pairKey);
    else return false;
  }
  return true;
}
function constructYamlOmap(data) {
  return data !== null ? data : [];
}
var omap = new type("tag:yaml.org,2002:omap", {
  kind: "sequence",
  resolve: resolveYamlOmap,
  construct: constructYamlOmap
});
var _toString$1 = Object.prototype.toString;
function resolveYamlPairs(data) {
  if (data === null) return true;
  var index, length, pair, keys5, result, object3 = data;
  result = new Array(object3.length);
  for (index = 0, length = object3.length; index < length; index += 1) {
    pair = object3[index];
    if (_toString$1.call(pair) !== "[object Object]") return false;
    keys5 = Object.keys(pair);
    if (keys5.length !== 1) return false;
    result[index] = [keys5[0], pair[keys5[0]]];
  }
  return true;
}
function constructYamlPairs(data) {
  if (data === null) return [];
  var index, length, pair, keys5, result, object3 = data;
  result = new Array(object3.length);
  for (index = 0, length = object3.length; index < length; index += 1) {
    pair = object3[index];
    keys5 = Object.keys(pair);
    result[index] = [keys5[0], pair[keys5[0]]];
  }
  return result;
}
var pairs = new type("tag:yaml.org,2002:pairs", {
  kind: "sequence",
  resolve: resolveYamlPairs,
  construct: constructYamlPairs
});
var _hasOwnProperty$2 = Object.prototype.hasOwnProperty;
function resolveYamlSet(data) {
  if (data === null) return true;
  var key, object3 = data;
  for (key in object3) {
    if (_hasOwnProperty$2.call(object3, key)) {
      if (object3[key] !== null) return false;
    }
  }
  return true;
}
function constructYamlSet(data) {
  return data !== null ? data : {};
}
var set3 = new type("tag:yaml.org,2002:set", {
  kind: "mapping",
  resolve: resolveYamlSet,
  construct: constructYamlSet
});
var _default = core.extend({
  implicit: [
    timestamp,
    merge
  ],
  explicit: [
    binary,
    omap,
    pairs,
    set3
  ]
});
var _hasOwnProperty$1 = Object.prototype.hasOwnProperty;
var CONTEXT_FLOW_IN = 1;
var CONTEXT_FLOW_OUT = 2;
var CONTEXT_BLOCK_IN = 3;
var CONTEXT_BLOCK_OUT = 4;
var CHOMPING_CLIP = 1;
var CHOMPING_STRIP = 2;
var CHOMPING_KEEP = 3;
var PATTERN_NON_PRINTABLE = /[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;
var PATTERN_NON_ASCII_LINE_BREAKS = /[\x85\u2028\u2029]/;
var PATTERN_FLOW_INDICATORS = /[,\[\]\{\}]/;
var PATTERN_TAG_HANDLE = /^(?:!|!!|![a-z\-]+!)$/i;
var PATTERN_TAG_URI = /^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i;
function _class(obj) {
  return Object.prototype.toString.call(obj);
}
function is_EOL(c) {
  return c === 10 || c === 13;
}
function is_WHITE_SPACE(c) {
  return c === 9 || c === 32;
}
function is_WS_OR_EOL(c) {
  return c === 9 || c === 32 || c === 10 || c === 13;
}
function is_FLOW_INDICATOR(c) {
  return c === 44 || c === 91 || c === 93 || c === 123 || c === 125;
}
function fromHexCode(c) {
  var lc;
  if (48 <= c && c <= 57) {
    return c - 48;
  }
  lc = c | 32;
  if (97 <= lc && lc <= 102) {
    return lc - 97 + 10;
  }
  return -1;
}
function escapedHexLen(c) {
  if (c === 120) {
    return 2;
  }
  if (c === 117) {
    return 4;
  }
  if (c === 85) {
    return 8;
  }
  return 0;
}
function fromDecimalCode(c) {
  if (48 <= c && c <= 57) {
    return c - 48;
  }
  return -1;
}
function simpleEscapeSequence(c) {
  return c === 48 ? "\0" : c === 97 ? "\x07" : c === 98 ? "\b" : c === 116 ? "	" : c === 9 ? "	" : c === 110 ? "\n" : c === 118 ? "\v" : c === 102 ? "\f" : c === 114 ? "\r" : c === 101 ? "\x1B" : c === 32 ? " " : c === 34 ? '"' : c === 47 ? "/" : c === 92 ? "\\" : c === 78 ? "\x85" : c === 95 ? "\xA0" : c === 76 ? "\u2028" : c === 80 ? "\u2029" : "";
}
function charFromCodepoint(c) {
  if (c <= 65535) {
    return String.fromCharCode(c);
  }
  return String.fromCharCode(
    (c - 65536 >> 10) + 55296,
    (c - 65536 & 1023) + 56320
  );
}
var simpleEscapeCheck = new Array(256);
var simpleEscapeMap = new Array(256);
for (i = 0; i < 256; i++) {
  simpleEscapeCheck[i] = simpleEscapeSequence(i) ? 1 : 0;
  simpleEscapeMap[i] = simpleEscapeSequence(i);
}
var i;
function State$1(input, options) {
  this.input = input;
  this.filename = options["filename"] || null;
  this.schema = options["schema"] || _default;
  this.onWarning = options["onWarning"] || null;
  this.legacy = options["legacy"] || false;
  this.json = options["json"] || false;
  this.listener = options["listener"] || null;
  this.implicitTypes = this.schema.compiledImplicit;
  this.typeMap = this.schema.compiledTypeMap;
  this.length = input.length;
  this.position = 0;
  this.line = 0;
  this.lineStart = 0;
  this.lineIndent = 0;
  this.firstTabInLine = -1;
  this.documents = [];
}
function generateError(state, message) {
  var mark = {
    name: state.filename,
    buffer: state.input.slice(0, -1),
    // omit trailing \0
    position: state.position,
    line: state.line,
    column: state.position - state.lineStart
  };
  mark.snippet = snippet(mark);
  return new exception(message, mark);
}
function throwError(state, message) {
  throw generateError(state, message);
}
function throwWarning(state, message) {
  if (state.onWarning) {
    state.onWarning.call(null, generateError(state, message));
  }
}
var directiveHandlers = {
  YAML: function handleYamlDirective(state, name, args) {
    var match, major, minor;
    if (state.version !== null) {
      throwError(state, "duplication of %YAML directive");
    }
    if (args.length !== 1) {
      throwError(state, "YAML directive accepts exactly one argument");
    }
    match = /^([0-9]+)\.([0-9]+)$/.exec(args[0]);
    if (match === null) {
      throwError(state, "ill-formed argument of the YAML directive");
    }
    major = parseInt(match[1], 10);
    minor = parseInt(match[2], 10);
    if (major !== 1) {
      throwError(state, "unacceptable YAML version of the document");
    }
    state.version = args[0];
    state.checkLineBreaks = minor < 2;
    if (minor !== 1 && minor !== 2) {
      throwWarning(state, "unsupported YAML version of the document");
    }
  },
  TAG: function handleTagDirective(state, name, args) {
    var handle, prefix;
    if (args.length !== 2) {
      throwError(state, "TAG directive accepts exactly two arguments");
    }
    handle = args[0];
    prefix = args[1];
    if (!PATTERN_TAG_HANDLE.test(handle)) {
      throwError(state, "ill-formed tag handle (first argument) of the TAG directive");
    }
    if (_hasOwnProperty$1.call(state.tagMap, handle)) {
      throwError(state, 'there is a previously declared suffix for "' + handle + '" tag handle');
    }
    if (!PATTERN_TAG_URI.test(prefix)) {
      throwError(state, "ill-formed tag prefix (second argument) of the TAG directive");
    }
    try {
      prefix = decodeURIComponent(prefix);
    } catch (err) {
      throwError(state, "tag prefix is malformed: " + prefix);
    }
    state.tagMap[handle] = prefix;
  }
};
function captureSegment(state, start, end, checkJson) {
  var _position, _length, _character, _result;
  if (start < end) {
    _result = state.input.slice(start, end);
    if (checkJson) {
      for (_position = 0, _length = _result.length; _position < _length; _position += 1) {
        _character = _result.charCodeAt(_position);
        if (!(_character === 9 || 32 <= _character && _character <= 1114111)) {
          throwError(state, "expected valid JSON character");
        }
      }
    } else if (PATTERN_NON_PRINTABLE.test(_result)) {
      throwError(state, "the stream contains non-printable characters");
    }
    state.result += _result;
  }
}
function mergeMappings(state, destination, source, overridableKeys) {
  var sourceKeys, key, index, quantity;
  if (!common.isObject(source)) {
    throwError(state, "cannot merge mappings; the provided source object is unacceptable");
  }
  sourceKeys = Object.keys(source);
  for (index = 0, quantity = sourceKeys.length; index < quantity; index += 1) {
    key = sourceKeys[index];
    if (!_hasOwnProperty$1.call(destination, key)) {
      destination[key] = source[key];
      overridableKeys[key] = true;
    }
  }
}
function storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, startLine, startLineStart, startPos) {
  var index, quantity;
  if (Array.isArray(keyNode)) {
    keyNode = Array.prototype.slice.call(keyNode);
    for (index = 0, quantity = keyNode.length; index < quantity; index += 1) {
      if (Array.isArray(keyNode[index])) {
        throwError(state, "nested arrays are not supported inside keys");
      }
      if (typeof keyNode === "object" && _class(keyNode[index]) === "[object Object]") {
        keyNode[index] = "[object Object]";
      }
    }
  }
  if (typeof keyNode === "object" && _class(keyNode) === "[object Object]") {
    keyNode = "[object Object]";
  }
  keyNode = String(keyNode);
  if (_result === null) {
    _result = {};
  }
  if (keyTag === "tag:yaml.org,2002:merge") {
    if (Array.isArray(valueNode)) {
      for (index = 0, quantity = valueNode.length; index < quantity; index += 1) {
        mergeMappings(state, _result, valueNode[index], overridableKeys);
      }
    } else {
      mergeMappings(state, _result, valueNode, overridableKeys);
    }
  } else {
    if (!state.json && !_hasOwnProperty$1.call(overridableKeys, keyNode) && _hasOwnProperty$1.call(_result, keyNode)) {
      state.line = startLine || state.line;
      state.lineStart = startLineStart || state.lineStart;
      state.position = startPos || state.position;
      throwError(state, "duplicated mapping key");
    }
    if (keyNode === "__proto__") {
      Object.defineProperty(_result, keyNode, {
        configurable: true,
        enumerable: true,
        writable: true,
        value: valueNode
      });
    } else {
      _result[keyNode] = valueNode;
    }
    delete overridableKeys[keyNode];
  }
  return _result;
}
function readLineBreak(state) {
  var ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 10) {
    state.position++;
  } else if (ch === 13) {
    state.position++;
    if (state.input.charCodeAt(state.position) === 10) {
      state.position++;
    }
  } else {
    throwError(state, "a line break is expected");
  }
  state.line += 1;
  state.lineStart = state.position;
  state.firstTabInLine = -1;
}
function skipSeparationSpace(state, allowComments, checkIndent) {
  var lineBreaks = 0, ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    while (is_WHITE_SPACE(ch)) {
      if (ch === 9 && state.firstTabInLine === -1) {
        state.firstTabInLine = state.position;
      }
      ch = state.input.charCodeAt(++state.position);
    }
    if (allowComments && ch === 35) {
      do {
        ch = state.input.charCodeAt(++state.position);
      } while (ch !== 10 && ch !== 13 && ch !== 0);
    }
    if (is_EOL(ch)) {
      readLineBreak(state);
      ch = state.input.charCodeAt(state.position);
      lineBreaks++;
      state.lineIndent = 0;
      while (ch === 32) {
        state.lineIndent++;
        ch = state.input.charCodeAt(++state.position);
      }
    } else {
      break;
    }
  }
  if (checkIndent !== -1 && lineBreaks !== 0 && state.lineIndent < checkIndent) {
    throwWarning(state, "deficient indentation");
  }
  return lineBreaks;
}
function testDocumentSeparator(state) {
  var _position = state.position, ch;
  ch = state.input.charCodeAt(_position);
  if ((ch === 45 || ch === 46) && ch === state.input.charCodeAt(_position + 1) && ch === state.input.charCodeAt(_position + 2)) {
    _position += 3;
    ch = state.input.charCodeAt(_position);
    if (ch === 0 || is_WS_OR_EOL(ch)) {
      return true;
    }
  }
  return false;
}
function writeFoldedLines(state, count) {
  if (count === 1) {
    state.result += " ";
  } else if (count > 1) {
    state.result += common.repeat("\n", count - 1);
  }
}
function readPlainScalar(state, nodeIndent, withinFlowCollection) {
  var preceding, following, captureStart, captureEnd, hasPendingContent, _line, _lineStart, _lineIndent, _kind = state.kind, _result = state.result, ch;
  ch = state.input.charCodeAt(state.position);
  if (is_WS_OR_EOL(ch) || is_FLOW_INDICATOR(ch) || ch === 35 || ch === 38 || ch === 42 || ch === 33 || ch === 124 || ch === 62 || ch === 39 || ch === 34 || ch === 37 || ch === 64 || ch === 96) {
    return false;
  }
  if (ch === 63 || ch === 45) {
    following = state.input.charCodeAt(state.position + 1);
    if (is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following)) {
      return false;
    }
  }
  state.kind = "scalar";
  state.result = "";
  captureStart = captureEnd = state.position;
  hasPendingContent = false;
  while (ch !== 0) {
    if (ch === 58) {
      following = state.input.charCodeAt(state.position + 1);
      if (is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following)) {
        break;
      }
    } else if (ch === 35) {
      preceding = state.input.charCodeAt(state.position - 1);
      if (is_WS_OR_EOL(preceding)) {
        break;
      }
    } else if (state.position === state.lineStart && testDocumentSeparator(state) || withinFlowCollection && is_FLOW_INDICATOR(ch)) {
      break;
    } else if (is_EOL(ch)) {
      _line = state.line;
      _lineStart = state.lineStart;
      _lineIndent = state.lineIndent;
      skipSeparationSpace(state, false, -1);
      if (state.lineIndent >= nodeIndent) {
        hasPendingContent = true;
        ch = state.input.charCodeAt(state.position);
        continue;
      } else {
        state.position = captureEnd;
        state.line = _line;
        state.lineStart = _lineStart;
        state.lineIndent = _lineIndent;
        break;
      }
    }
    if (hasPendingContent) {
      captureSegment(state, captureStart, captureEnd, false);
      writeFoldedLines(state, state.line - _line);
      captureStart = captureEnd = state.position;
      hasPendingContent = false;
    }
    if (!is_WHITE_SPACE(ch)) {
      captureEnd = state.position + 1;
    }
    ch = state.input.charCodeAt(++state.position);
  }
  captureSegment(state, captureStart, captureEnd, false);
  if (state.result) {
    return true;
  }
  state.kind = _kind;
  state.result = _result;
  return false;
}
function readSingleQuotedScalar(state, nodeIndent) {
  var ch, captureStart, captureEnd;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 39) {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  state.position++;
  captureStart = captureEnd = state.position;
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    if (ch === 39) {
      captureSegment(state, captureStart, state.position, true);
      ch = state.input.charCodeAt(++state.position);
      if (ch === 39) {
        captureStart = state.position;
        state.position++;
        captureEnd = state.position;
      } else {
        return true;
      }
    } else if (is_EOL(ch)) {
      captureSegment(state, captureStart, captureEnd, true);
      writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
      captureStart = captureEnd = state.position;
    } else if (state.position === state.lineStart && testDocumentSeparator(state)) {
      throwError(state, "unexpected end of the document within a single quoted scalar");
    } else {
      state.position++;
      captureEnd = state.position;
    }
  }
  throwError(state, "unexpected end of the stream within a single quoted scalar");
}
function readDoubleQuotedScalar(state, nodeIndent) {
  var captureStart, captureEnd, hexLength, hexResult, tmp, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 34) {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  state.position++;
  captureStart = captureEnd = state.position;
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    if (ch === 34) {
      captureSegment(state, captureStart, state.position, true);
      state.position++;
      return true;
    } else if (ch === 92) {
      captureSegment(state, captureStart, state.position, true);
      ch = state.input.charCodeAt(++state.position);
      if (is_EOL(ch)) {
        skipSeparationSpace(state, false, nodeIndent);
      } else if (ch < 256 && simpleEscapeCheck[ch]) {
        state.result += simpleEscapeMap[ch];
        state.position++;
      } else if ((tmp = escapedHexLen(ch)) > 0) {
        hexLength = tmp;
        hexResult = 0;
        for (; hexLength > 0; hexLength--) {
          ch = state.input.charCodeAt(++state.position);
          if ((tmp = fromHexCode(ch)) >= 0) {
            hexResult = (hexResult << 4) + tmp;
          } else {
            throwError(state, "expected hexadecimal character");
          }
        }
        state.result += charFromCodepoint(hexResult);
        state.position++;
      } else {
        throwError(state, "unknown escape sequence");
      }
      captureStart = captureEnd = state.position;
    } else if (is_EOL(ch)) {
      captureSegment(state, captureStart, captureEnd, true);
      writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
      captureStart = captureEnd = state.position;
    } else if (state.position === state.lineStart && testDocumentSeparator(state)) {
      throwError(state, "unexpected end of the document within a double quoted scalar");
    } else {
      state.position++;
      captureEnd = state.position;
    }
  }
  throwError(state, "unexpected end of the stream within a double quoted scalar");
}
function readFlowCollection(state, nodeIndent) {
  var readNext = true, _line, _lineStart, _pos, _tag = state.tag, _result, _anchor = state.anchor, following, terminator, isPair, isExplicitPair, isMapping, overridableKeys = /* @__PURE__ */ Object.create(null), keyNode, keyTag, valueNode, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 91) {
    terminator = 93;
    isMapping = false;
    _result = [];
  } else if (ch === 123) {
    terminator = 125;
    isMapping = true;
    _result = {};
  } else {
    return false;
  }
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(++state.position);
  while (ch !== 0) {
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if (ch === terminator) {
      state.position++;
      state.tag = _tag;
      state.anchor = _anchor;
      state.kind = isMapping ? "mapping" : "sequence";
      state.result = _result;
      return true;
    } else if (!readNext) {
      throwError(state, "missed comma between flow collection entries");
    } else if (ch === 44) {
      throwError(state, "expected the node content, but found ','");
    }
    keyTag = keyNode = valueNode = null;
    isPair = isExplicitPair = false;
    if (ch === 63) {
      following = state.input.charCodeAt(state.position + 1);
      if (is_WS_OR_EOL(following)) {
        isPair = isExplicitPair = true;
        state.position++;
        skipSeparationSpace(state, true, nodeIndent);
      }
    }
    _line = state.line;
    _lineStart = state.lineStart;
    _pos = state.position;
    composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
    keyTag = state.tag;
    keyNode = state.result;
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if ((isExplicitPair || state.line === _line) && ch === 58) {
      isPair = true;
      ch = state.input.charCodeAt(++state.position);
      skipSeparationSpace(state, true, nodeIndent);
      composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
      valueNode = state.result;
    }
    if (isMapping) {
      storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos);
    } else if (isPair) {
      _result.push(storeMappingPair(state, null, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos));
    } else {
      _result.push(keyNode);
    }
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if (ch === 44) {
      readNext = true;
      ch = state.input.charCodeAt(++state.position);
    } else {
      readNext = false;
    }
  }
  throwError(state, "unexpected end of the stream within a flow collection");
}
function readBlockScalar(state, nodeIndent) {
  var captureStart, folding, chomping = CHOMPING_CLIP, didReadContent = false, detectedIndent = false, textIndent = nodeIndent, emptyLines = 0, atMoreIndented = false, tmp, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 124) {
    folding = false;
  } else if (ch === 62) {
    folding = true;
  } else {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  while (ch !== 0) {
    ch = state.input.charCodeAt(++state.position);
    if (ch === 43 || ch === 45) {
      if (CHOMPING_CLIP === chomping) {
        chomping = ch === 43 ? CHOMPING_KEEP : CHOMPING_STRIP;
      } else {
        throwError(state, "repeat of a chomping mode identifier");
      }
    } else if ((tmp = fromDecimalCode(ch)) >= 0) {
      if (tmp === 0) {
        throwError(state, "bad explicit indentation width of a block scalar; it cannot be less than one");
      } else if (!detectedIndent) {
        textIndent = nodeIndent + tmp - 1;
        detectedIndent = true;
      } else {
        throwError(state, "repeat of an indentation width identifier");
      }
    } else {
      break;
    }
  }
  if (is_WHITE_SPACE(ch)) {
    do {
      ch = state.input.charCodeAt(++state.position);
    } while (is_WHITE_SPACE(ch));
    if (ch === 35) {
      do {
        ch = state.input.charCodeAt(++state.position);
      } while (!is_EOL(ch) && ch !== 0);
    }
  }
  while (ch !== 0) {
    readLineBreak(state);
    state.lineIndent = 0;
    ch = state.input.charCodeAt(state.position);
    while ((!detectedIndent || state.lineIndent < textIndent) && ch === 32) {
      state.lineIndent++;
      ch = state.input.charCodeAt(++state.position);
    }
    if (!detectedIndent && state.lineIndent > textIndent) {
      textIndent = state.lineIndent;
    }
    if (is_EOL(ch)) {
      emptyLines++;
      continue;
    }
    if (state.lineIndent < textIndent) {
      if (chomping === CHOMPING_KEEP) {
        state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
      } else if (chomping === CHOMPING_CLIP) {
        if (didReadContent) {
          state.result += "\n";
        }
      }
      break;
    }
    if (folding) {
      if (is_WHITE_SPACE(ch)) {
        atMoreIndented = true;
        state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
      } else if (atMoreIndented) {
        atMoreIndented = false;
        state.result += common.repeat("\n", emptyLines + 1);
      } else if (emptyLines === 0) {
        if (didReadContent) {
          state.result += " ";
        }
      } else {
        state.result += common.repeat("\n", emptyLines);
      }
    } else {
      state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
    }
    didReadContent = true;
    detectedIndent = true;
    emptyLines = 0;
    captureStart = state.position;
    while (!is_EOL(ch) && ch !== 0) {
      ch = state.input.charCodeAt(++state.position);
    }
    captureSegment(state, captureStart, state.position, false);
  }
  return true;
}
function readBlockSequence(state, nodeIndent) {
  var _line, _tag = state.tag, _anchor = state.anchor, _result = [], following, detected = false, ch;
  if (state.firstTabInLine !== -1) return false;
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    if (state.firstTabInLine !== -1) {
      state.position = state.firstTabInLine;
      throwError(state, "tab characters must not be used in indentation");
    }
    if (ch !== 45) {
      break;
    }
    following = state.input.charCodeAt(state.position + 1);
    if (!is_WS_OR_EOL(following)) {
      break;
    }
    detected = true;
    state.position++;
    if (skipSeparationSpace(state, true, -1)) {
      if (state.lineIndent <= nodeIndent) {
        _result.push(null);
        ch = state.input.charCodeAt(state.position);
        continue;
      }
    }
    _line = state.line;
    composeNode(state, nodeIndent, CONTEXT_BLOCK_IN, false, true);
    _result.push(state.result);
    skipSeparationSpace(state, true, -1);
    ch = state.input.charCodeAt(state.position);
    if ((state.line === _line || state.lineIndent > nodeIndent) && ch !== 0) {
      throwError(state, "bad indentation of a sequence entry");
    } else if (state.lineIndent < nodeIndent) {
      break;
    }
  }
  if (detected) {
    state.tag = _tag;
    state.anchor = _anchor;
    state.kind = "sequence";
    state.result = _result;
    return true;
  }
  return false;
}
function readBlockMapping(state, nodeIndent, flowIndent) {
  var following, allowCompact, _line, _keyLine, _keyLineStart, _keyPos, _tag = state.tag, _anchor = state.anchor, _result = {}, overridableKeys = /* @__PURE__ */ Object.create(null), keyTag = null, keyNode = null, valueNode = null, atExplicitKey = false, detected = false, ch;
  if (state.firstTabInLine !== -1) return false;
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    if (!atExplicitKey && state.firstTabInLine !== -1) {
      state.position = state.firstTabInLine;
      throwError(state, "tab characters must not be used in indentation");
    }
    following = state.input.charCodeAt(state.position + 1);
    _line = state.line;
    if ((ch === 63 || ch === 58) && is_WS_OR_EOL(following)) {
      if (ch === 63) {
        if (atExplicitKey) {
          storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
          keyTag = keyNode = valueNode = null;
        }
        detected = true;
        atExplicitKey = true;
        allowCompact = true;
      } else if (atExplicitKey) {
        atExplicitKey = false;
        allowCompact = true;
      } else {
        throwError(state, "incomplete explicit mapping pair; a key node is missed; or followed by a non-tabulated empty line");
      }
      state.position += 1;
      ch = following;
    } else {
      _keyLine = state.line;
      _keyLineStart = state.lineStart;
      _keyPos = state.position;
      if (!composeNode(state, flowIndent, CONTEXT_FLOW_OUT, false, true)) {
        break;
      }
      if (state.line === _line) {
        ch = state.input.charCodeAt(state.position);
        while (is_WHITE_SPACE(ch)) {
          ch = state.input.charCodeAt(++state.position);
        }
        if (ch === 58) {
          ch = state.input.charCodeAt(++state.position);
          if (!is_WS_OR_EOL(ch)) {
            throwError(state, "a whitespace character is expected after the key-value separator within a block mapping");
          }
          if (atExplicitKey) {
            storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
            keyTag = keyNode = valueNode = null;
          }
          detected = true;
          atExplicitKey = false;
          allowCompact = false;
          keyTag = state.tag;
          keyNode = state.result;
        } else if (detected) {
          throwError(state, "can not read an implicit mapping pair; a colon is missed");
        } else {
          state.tag = _tag;
          state.anchor = _anchor;
          return true;
        }
      } else if (detected) {
        throwError(state, "can not read a block mapping entry; a multiline key may not be an implicit key");
      } else {
        state.tag = _tag;
        state.anchor = _anchor;
        return true;
      }
    }
    if (state.line === _line || state.lineIndent > nodeIndent) {
      if (atExplicitKey) {
        _keyLine = state.line;
        _keyLineStart = state.lineStart;
        _keyPos = state.position;
      }
      if (composeNode(state, nodeIndent, CONTEXT_BLOCK_OUT, true, allowCompact)) {
        if (atExplicitKey) {
          keyNode = state.result;
        } else {
          valueNode = state.result;
        }
      }
      if (!atExplicitKey) {
        storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _keyLine, _keyLineStart, _keyPos);
        keyTag = keyNode = valueNode = null;
      }
      skipSeparationSpace(state, true, -1);
      ch = state.input.charCodeAt(state.position);
    }
    if ((state.line === _line || state.lineIndent > nodeIndent) && ch !== 0) {
      throwError(state, "bad indentation of a mapping entry");
    } else if (state.lineIndent < nodeIndent) {
      break;
    }
  }
  if (atExplicitKey) {
    storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
  }
  if (detected) {
    state.tag = _tag;
    state.anchor = _anchor;
    state.kind = "mapping";
    state.result = _result;
  }
  return detected;
}
function readTagProperty(state) {
  var _position, isVerbatim = false, isNamed = false, tagHandle, tagName, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 33) return false;
  if (state.tag !== null) {
    throwError(state, "duplication of a tag property");
  }
  ch = state.input.charCodeAt(++state.position);
  if (ch === 60) {
    isVerbatim = true;
    ch = state.input.charCodeAt(++state.position);
  } else if (ch === 33) {
    isNamed = true;
    tagHandle = "!!";
    ch = state.input.charCodeAt(++state.position);
  } else {
    tagHandle = "!";
  }
  _position = state.position;
  if (isVerbatim) {
    do {
      ch = state.input.charCodeAt(++state.position);
    } while (ch !== 0 && ch !== 62);
    if (state.position < state.length) {
      tagName = state.input.slice(_position, state.position);
      ch = state.input.charCodeAt(++state.position);
    } else {
      throwError(state, "unexpected end of the stream within a verbatim tag");
    }
  } else {
    while (ch !== 0 && !is_WS_OR_EOL(ch)) {
      if (ch === 33) {
        if (!isNamed) {
          tagHandle = state.input.slice(_position - 1, state.position + 1);
          if (!PATTERN_TAG_HANDLE.test(tagHandle)) {
            throwError(state, "named tag handle cannot contain such characters");
          }
          isNamed = true;
          _position = state.position + 1;
        } else {
          throwError(state, "tag suffix cannot contain exclamation marks");
        }
      }
      ch = state.input.charCodeAt(++state.position);
    }
    tagName = state.input.slice(_position, state.position);
    if (PATTERN_FLOW_INDICATORS.test(tagName)) {
      throwError(state, "tag suffix cannot contain flow indicator characters");
    }
  }
  if (tagName && !PATTERN_TAG_URI.test(tagName)) {
    throwError(state, "tag name cannot contain such characters: " + tagName);
  }
  try {
    tagName = decodeURIComponent(tagName);
  } catch (err) {
    throwError(state, "tag name is malformed: " + tagName);
  }
  if (isVerbatim) {
    state.tag = tagName;
  } else if (_hasOwnProperty$1.call(state.tagMap, tagHandle)) {
    state.tag = state.tagMap[tagHandle] + tagName;
  } else if (tagHandle === "!") {
    state.tag = "!" + tagName;
  } else if (tagHandle === "!!") {
    state.tag = "tag:yaml.org,2002:" + tagName;
  } else {
    throwError(state, 'undeclared tag handle "' + tagHandle + '"');
  }
  return true;
}
function readAnchorProperty(state) {
  var _position, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 38) return false;
  if (state.anchor !== null) {
    throwError(state, "duplication of an anchor property");
  }
  ch = state.input.charCodeAt(++state.position);
  _position = state.position;
  while (ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch)) {
    ch = state.input.charCodeAt(++state.position);
  }
  if (state.position === _position) {
    throwError(state, "name of an anchor node must contain at least one character");
  }
  state.anchor = state.input.slice(_position, state.position);
  return true;
}
function readAlias(state) {
  var _position, alias, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 42) return false;
  ch = state.input.charCodeAt(++state.position);
  _position = state.position;
  while (ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch)) {
    ch = state.input.charCodeAt(++state.position);
  }
  if (state.position === _position) {
    throwError(state, "name of an alias node must contain at least one character");
  }
  alias = state.input.slice(_position, state.position);
  if (!_hasOwnProperty$1.call(state.anchorMap, alias)) {
    throwError(state, 'unidentified alias "' + alias + '"');
  }
  state.result = state.anchorMap[alias];
  skipSeparationSpace(state, true, -1);
  return true;
}
function composeNode(state, parentIndent, nodeContext, allowToSeek, allowCompact) {
  var allowBlockStyles, allowBlockScalars, allowBlockCollections, indentStatus = 1, atNewLine = false, hasContent = false, typeIndex, typeQuantity, typeList, type2, flowIndent, blockIndent;
  if (state.listener !== null) {
    state.listener("open", state);
  }
  state.tag = null;
  state.anchor = null;
  state.kind = null;
  state.result = null;
  allowBlockStyles = allowBlockScalars = allowBlockCollections = CONTEXT_BLOCK_OUT === nodeContext || CONTEXT_BLOCK_IN === nodeContext;
  if (allowToSeek) {
    if (skipSeparationSpace(state, true, -1)) {
      atNewLine = true;
      if (state.lineIndent > parentIndent) {
        indentStatus = 1;
      } else if (state.lineIndent === parentIndent) {
        indentStatus = 0;
      } else if (state.lineIndent < parentIndent) {
        indentStatus = -1;
      }
    }
  }
  if (indentStatus === 1) {
    while (readTagProperty(state) || readAnchorProperty(state)) {
      if (skipSeparationSpace(state, true, -1)) {
        atNewLine = true;
        allowBlockCollections = allowBlockStyles;
        if (state.lineIndent > parentIndent) {
          indentStatus = 1;
        } else if (state.lineIndent === parentIndent) {
          indentStatus = 0;
        } else if (state.lineIndent < parentIndent) {
          indentStatus = -1;
        }
      } else {
        allowBlockCollections = false;
      }
    }
  }
  if (allowBlockCollections) {
    allowBlockCollections = atNewLine || allowCompact;
  }
  if (indentStatus === 1 || CONTEXT_BLOCK_OUT === nodeContext) {
    if (CONTEXT_FLOW_IN === nodeContext || CONTEXT_FLOW_OUT === nodeContext) {
      flowIndent = parentIndent;
    } else {
      flowIndent = parentIndent + 1;
    }
    blockIndent = state.position - state.lineStart;
    if (indentStatus === 1) {
      if (allowBlockCollections && (readBlockSequence(state, blockIndent) || readBlockMapping(state, blockIndent, flowIndent)) || readFlowCollection(state, flowIndent)) {
        hasContent = true;
      } else {
        if (allowBlockScalars && readBlockScalar(state, flowIndent) || readSingleQuotedScalar(state, flowIndent) || readDoubleQuotedScalar(state, flowIndent)) {
          hasContent = true;
        } else if (readAlias(state)) {
          hasContent = true;
          if (state.tag !== null || state.anchor !== null) {
            throwError(state, "alias node should not have any properties");
          }
        } else if (readPlainScalar(state, flowIndent, CONTEXT_FLOW_IN === nodeContext)) {
          hasContent = true;
          if (state.tag === null) {
            state.tag = "?";
          }
        }
        if (state.anchor !== null) {
          state.anchorMap[state.anchor] = state.result;
        }
      }
    } else if (indentStatus === 0) {
      hasContent = allowBlockCollections && readBlockSequence(state, blockIndent);
    }
  }
  if (state.tag === null) {
    if (state.anchor !== null) {
      state.anchorMap[state.anchor] = state.result;
    }
  } else if (state.tag === "?") {
    if (state.result !== null && state.kind !== "scalar") {
      throwError(state, 'unacceptable node kind for !<?> tag; it should be "scalar", not "' + state.kind + '"');
    }
    for (typeIndex = 0, typeQuantity = state.implicitTypes.length; typeIndex < typeQuantity; typeIndex += 1) {
      type2 = state.implicitTypes[typeIndex];
      if (type2.resolve(state.result)) {
        state.result = type2.construct(state.result);
        state.tag = type2.tag;
        if (state.anchor !== null) {
          state.anchorMap[state.anchor] = state.result;
        }
        break;
      }
    }
  } else if (state.tag !== "!") {
    if (_hasOwnProperty$1.call(state.typeMap[state.kind || "fallback"], state.tag)) {
      type2 = state.typeMap[state.kind || "fallback"][state.tag];
    } else {
      type2 = null;
      typeList = state.typeMap.multi[state.kind || "fallback"];
      for (typeIndex = 0, typeQuantity = typeList.length; typeIndex < typeQuantity; typeIndex += 1) {
        if (state.tag.slice(0, typeList[typeIndex].tag.length) === typeList[typeIndex].tag) {
          type2 = typeList[typeIndex];
          break;
        }
      }
    }
    if (!type2) {
      throwError(state, "unknown tag !<" + state.tag + ">");
    }
    if (state.result !== null && type2.kind !== state.kind) {
      throwError(state, "unacceptable node kind for !<" + state.tag + '> tag; it should be "' + type2.kind + '", not "' + state.kind + '"');
    }
    if (!type2.resolve(state.result, state.tag)) {
      throwError(state, "cannot resolve a node with !<" + state.tag + "> explicit tag");
    } else {
      state.result = type2.construct(state.result, state.tag);
      if (state.anchor !== null) {
        state.anchorMap[state.anchor] = state.result;
      }
    }
  }
  if (state.listener !== null) {
    state.listener("close", state);
  }
  return state.tag !== null || state.anchor !== null || hasContent;
}
function readDocument(state) {
  var documentStart = state.position, _position, directiveName, directiveArgs, hasDirectives = false, ch;
  state.version = null;
  state.checkLineBreaks = state.legacy;
  state.tagMap = /* @__PURE__ */ Object.create(null);
  state.anchorMap = /* @__PURE__ */ Object.create(null);
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    skipSeparationSpace(state, true, -1);
    ch = state.input.charCodeAt(state.position);
    if (state.lineIndent > 0 || ch !== 37) {
      break;
    }
    hasDirectives = true;
    ch = state.input.charCodeAt(++state.position);
    _position = state.position;
    while (ch !== 0 && !is_WS_OR_EOL(ch)) {
      ch = state.input.charCodeAt(++state.position);
    }
    directiveName = state.input.slice(_position, state.position);
    directiveArgs = [];
    if (directiveName.length < 1) {
      throwError(state, "directive name must not be less than one character in length");
    }
    while (ch !== 0) {
      while (is_WHITE_SPACE(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      if (ch === 35) {
        do {
          ch = state.input.charCodeAt(++state.position);
        } while (ch !== 0 && !is_EOL(ch));
        break;
      }
      if (is_EOL(ch)) break;
      _position = state.position;
      while (ch !== 0 && !is_WS_OR_EOL(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      directiveArgs.push(state.input.slice(_position, state.position));
    }
    if (ch !== 0) readLineBreak(state);
    if (_hasOwnProperty$1.call(directiveHandlers, directiveName)) {
      directiveHandlers[directiveName](state, directiveName, directiveArgs);
    } else {
      throwWarning(state, 'unknown document directive "' + directiveName + '"');
    }
  }
  skipSeparationSpace(state, true, -1);
  if (state.lineIndent === 0 && state.input.charCodeAt(state.position) === 45 && state.input.charCodeAt(state.position + 1) === 45 && state.input.charCodeAt(state.position + 2) === 45) {
    state.position += 3;
    skipSeparationSpace(state, true, -1);
  } else if (hasDirectives) {
    throwError(state, "directives end mark is expected");
  }
  composeNode(state, state.lineIndent - 1, CONTEXT_BLOCK_OUT, false, true);
  skipSeparationSpace(state, true, -1);
  if (state.checkLineBreaks && PATTERN_NON_ASCII_LINE_BREAKS.test(state.input.slice(documentStart, state.position))) {
    throwWarning(state, "non-ASCII line breaks are interpreted as content");
  }
  state.documents.push(state.result);
  if (state.position === state.lineStart && testDocumentSeparator(state)) {
    if (state.input.charCodeAt(state.position) === 46) {
      state.position += 3;
      skipSeparationSpace(state, true, -1);
    }
    return;
  }
  if (state.position < state.length - 1) {
    throwError(state, "end of the stream or a document separator is expected");
  } else {
    return;
  }
}
function loadDocuments(input, options) {
  input = String(input);
  options = options || {};
  if (input.length !== 0) {
    if (input.charCodeAt(input.length - 1) !== 10 && input.charCodeAt(input.length - 1) !== 13) {
      input += "\n";
    }
    if (input.charCodeAt(0) === 65279) {
      input = input.slice(1);
    }
  }
  var state = new State$1(input, options);
  var nullpos = input.indexOf("\0");
  if (nullpos !== -1) {
    state.position = nullpos;
    throwError(state, "null byte is not allowed in input");
  }
  state.input += "\0";
  while (state.input.charCodeAt(state.position) === 32) {
    state.lineIndent += 1;
    state.position += 1;
  }
  while (state.position < state.length - 1) {
    readDocument(state);
  }
  return state.documents;
}
function loadAll$1(input, iterator, options) {
  if (iterator !== null && typeof iterator === "object" && typeof options === "undefined") {
    options = iterator;
    iterator = null;
  }
  var documents = loadDocuments(input, options);
  if (typeof iterator !== "function") {
    return documents;
  }
  for (var index = 0, length = documents.length; index < length; index += 1) {
    iterator(documents[index]);
  }
}
function load$1(input, options) {
  var documents = loadDocuments(input, options);
  if (documents.length === 0) {
    return void 0;
  } else if (documents.length === 1) {
    return documents[0];
  }
  throw new exception("expected a single document in the stream, but found more");
}
var loadAll_1 = loadAll$1;
var load_1 = load$1;
var loader = {
  loadAll: loadAll_1,
  load: load_1
};
var _toString = Object.prototype.toString;
var _hasOwnProperty = Object.prototype.hasOwnProperty;
var CHAR_BOM = 65279;
var CHAR_TAB = 9;
var CHAR_LINE_FEED = 10;
var CHAR_CARRIAGE_RETURN = 13;
var CHAR_SPACE = 32;
var CHAR_EXCLAMATION = 33;
var CHAR_DOUBLE_QUOTE = 34;
var CHAR_SHARP = 35;
var CHAR_PERCENT = 37;
var CHAR_AMPERSAND = 38;
var CHAR_SINGLE_QUOTE = 39;
var CHAR_ASTERISK = 42;
var CHAR_COMMA = 44;
var CHAR_MINUS = 45;
var CHAR_COLON = 58;
var CHAR_EQUALS = 61;
var CHAR_GREATER_THAN = 62;
var CHAR_QUESTION = 63;
var CHAR_COMMERCIAL_AT = 64;
var CHAR_LEFT_SQUARE_BRACKET = 91;
var CHAR_RIGHT_SQUARE_BRACKET = 93;
var CHAR_GRAVE_ACCENT = 96;
var CHAR_LEFT_CURLY_BRACKET = 123;
var CHAR_VERTICAL_LINE = 124;
var CHAR_RIGHT_CURLY_BRACKET = 125;
var ESCAPE_SEQUENCES = {};
ESCAPE_SEQUENCES[0] = "\\0";
ESCAPE_SEQUENCES[7] = "\\a";
ESCAPE_SEQUENCES[8] = "\\b";
ESCAPE_SEQUENCES[9] = "\\t";
ESCAPE_SEQUENCES[10] = "\\n";
ESCAPE_SEQUENCES[11] = "\\v";
ESCAPE_SEQUENCES[12] = "\\f";
ESCAPE_SEQUENCES[13] = "\\r";
ESCAPE_SEQUENCES[27] = "\\e";
ESCAPE_SEQUENCES[34] = '\\"';
ESCAPE_SEQUENCES[92] = "\\\\";
ESCAPE_SEQUENCES[133] = "\\N";
ESCAPE_SEQUENCES[160] = "\\_";
ESCAPE_SEQUENCES[8232] = "\\L";
ESCAPE_SEQUENCES[8233] = "\\P";
var DEPRECATED_BOOLEANS_SYNTAX = [
  "y",
  "Y",
  "yes",
  "Yes",
  "YES",
  "on",
  "On",
  "ON",
  "n",
  "N",
  "no",
  "No",
  "NO",
  "off",
  "Off",
  "OFF"
];
var DEPRECATED_BASE60_SYNTAX = /^[-+]?[0-9_]+(?::[0-9_]+)+(?:\.[0-9_]*)?$/;
function compileStyleMap(schema2, map2) {
  var result, keys5, index, length, tag, style, type2;
  if (map2 === null) return {};
  result = {};
  keys5 = Object.keys(map2);
  for (index = 0, length = keys5.length; index < length; index += 1) {
    tag = keys5[index];
    style = String(map2[tag]);
    if (tag.slice(0, 2) === "!!") {
      tag = "tag:yaml.org,2002:" + tag.slice(2);
    }
    type2 = schema2.compiledTypeMap["fallback"][tag];
    if (type2 && _hasOwnProperty.call(type2.styleAliases, style)) {
      style = type2.styleAliases[style];
    }
    result[tag] = style;
  }
  return result;
}
function encodeHex(character) {
  var string3, handle, length;
  string3 = character.toString(16).toUpperCase();
  if (character <= 255) {
    handle = "x";
    length = 2;
  } else if (character <= 65535) {
    handle = "u";
    length = 4;
  } else if (character <= 4294967295) {
    handle = "U";
    length = 8;
  } else {
    throw new exception("code point within a string may not be greater than 0xFFFFFFFF");
  }
  return "\\" + handle + common.repeat("0", length - string3.length) + string3;
}
var QUOTING_TYPE_SINGLE = 1;
var QUOTING_TYPE_DOUBLE = 2;
function State2(options) {
  this.schema = options["schema"] || _default;
  this.indent = Math.max(1, options["indent"] || 2);
  this.noArrayIndent = options["noArrayIndent"] || false;
  this.skipInvalid = options["skipInvalid"] || false;
  this.flowLevel = common.isNothing(options["flowLevel"]) ? -1 : options["flowLevel"];
  this.styleMap = compileStyleMap(this.schema, options["styles"] || null);
  this.sortKeys = options["sortKeys"] || false;
  this.lineWidth = options["lineWidth"] || 80;
  this.noRefs = options["noRefs"] || false;
  this.noCompatMode = options["noCompatMode"] || false;
  this.condenseFlow = options["condenseFlow"] || false;
  this.quotingType = options["quotingType"] === '"' ? QUOTING_TYPE_DOUBLE : QUOTING_TYPE_SINGLE;
  this.forceQuotes = options["forceQuotes"] || false;
  this.replacer = typeof options["replacer"] === "function" ? options["replacer"] : null;
  this.implicitTypes = this.schema.compiledImplicit;
  this.explicitTypes = this.schema.compiledExplicit;
  this.tag = null;
  this.result = "";
  this.duplicates = [];
  this.usedDuplicates = null;
}
function indentString(string3, spaces) {
  var ind = common.repeat(" ", spaces), position = 0, next = -1, result = "", line, length = string3.length;
  while (position < length) {
    next = string3.indexOf("\n", position);
    if (next === -1) {
      line = string3.slice(position);
      position = length;
    } else {
      line = string3.slice(position, next + 1);
      position = next + 1;
    }
    if (line.length && line !== "\n") result += ind;
    result += line;
  }
  return result;
}
function generateNextLine(state, level) {
  return "\n" + common.repeat(" ", state.indent * level);
}
function testImplicitResolving(state, str2) {
  var index, length, type2;
  for (index = 0, length = state.implicitTypes.length; index < length; index += 1) {
    type2 = state.implicitTypes[index];
    if (type2.resolve(str2)) {
      return true;
    }
  }
  return false;
}
function isWhitespace(c) {
  return c === CHAR_SPACE || c === CHAR_TAB;
}
function isPrintable(c) {
  return 32 <= c && c <= 126 || 161 <= c && c <= 55295 && c !== 8232 && c !== 8233 || 57344 <= c && c <= 65533 && c !== CHAR_BOM || 65536 <= c && c <= 1114111;
}
function isNsCharOrWhitespace(c) {
  return isPrintable(c) && c !== CHAR_BOM && c !== CHAR_CARRIAGE_RETURN && c !== CHAR_LINE_FEED;
}
function isPlainSafe(c, prev, inblock) {
  var cIsNsCharOrWhitespace = isNsCharOrWhitespace(c);
  var cIsNsChar = cIsNsCharOrWhitespace && !isWhitespace(c);
  return (
    // ns-plain-safe
    (inblock ? (
      // c = flow-in
      cIsNsCharOrWhitespace
    ) : cIsNsCharOrWhitespace && c !== CHAR_COMMA && c !== CHAR_LEFT_SQUARE_BRACKET && c !== CHAR_RIGHT_SQUARE_BRACKET && c !== CHAR_LEFT_CURLY_BRACKET && c !== CHAR_RIGHT_CURLY_BRACKET) && c !== CHAR_SHARP && !(prev === CHAR_COLON && !cIsNsChar) || isNsCharOrWhitespace(prev) && !isWhitespace(prev) && c === CHAR_SHARP || prev === CHAR_COLON && cIsNsChar
  );
}
function isPlainSafeFirst(c) {
  return isPrintable(c) && c !== CHAR_BOM && !isWhitespace(c) && c !== CHAR_MINUS && c !== CHAR_QUESTION && c !== CHAR_COLON && c !== CHAR_COMMA && c !== CHAR_LEFT_SQUARE_BRACKET && c !== CHAR_RIGHT_SQUARE_BRACKET && c !== CHAR_LEFT_CURLY_BRACKET && c !== CHAR_RIGHT_CURLY_BRACKET && c !== CHAR_SHARP && c !== CHAR_AMPERSAND && c !== CHAR_ASTERISK && c !== CHAR_EXCLAMATION && c !== CHAR_VERTICAL_LINE && c !== CHAR_EQUALS && c !== CHAR_GREATER_THAN && c !== CHAR_SINGLE_QUOTE && c !== CHAR_DOUBLE_QUOTE && c !== CHAR_PERCENT && c !== CHAR_COMMERCIAL_AT && c !== CHAR_GRAVE_ACCENT;
}
function isPlainSafeLast(c) {
  return !isWhitespace(c) && c !== CHAR_COLON;
}
function codePointAt(string3, pos) {
  var first = string3.charCodeAt(pos), second;
  if (first >= 55296 && first <= 56319 && pos + 1 < string3.length) {
    second = string3.charCodeAt(pos + 1);
    if (second >= 56320 && second <= 57343) {
      return (first - 55296) * 1024 + second - 56320 + 65536;
    }
  }
  return first;
}
function needIndentIndicator(string3) {
  var leadingSpaceRe = /^\n* /;
  return leadingSpaceRe.test(string3);
}
var STYLE_PLAIN = 1;
var STYLE_SINGLE = 2;
var STYLE_LITERAL = 3;
var STYLE_FOLDED = 4;
var STYLE_DOUBLE = 5;
function chooseScalarStyle(string3, singleLineOnly, indentPerLevel, lineWidth, testAmbiguousType, quotingType, forceQuotes, inblock) {
  var i;
  var char = 0;
  var prevChar = null;
  var hasLineBreak = false;
  var hasFoldableLine = false;
  var shouldTrackWidth = lineWidth !== -1;
  var previousLineBreak = -1;
  var plain = isPlainSafeFirst(codePointAt(string3, 0)) && isPlainSafeLast(codePointAt(string3, string3.length - 1));
  if (singleLineOnly || forceQuotes) {
    for (i = 0; i < string3.length; char >= 65536 ? i += 2 : i++) {
      char = codePointAt(string3, i);
      if (!isPrintable(char)) {
        return STYLE_DOUBLE;
      }
      plain = plain && isPlainSafe(char, prevChar, inblock);
      prevChar = char;
    }
  } else {
    for (i = 0; i < string3.length; char >= 65536 ? i += 2 : i++) {
      char = codePointAt(string3, i);
      if (char === CHAR_LINE_FEED) {
        hasLineBreak = true;
        if (shouldTrackWidth) {
          hasFoldableLine = hasFoldableLine || // Foldable line = too long, and not more-indented.
          i - previousLineBreak - 1 > lineWidth && string3[previousLineBreak + 1] !== " ";
          previousLineBreak = i;
        }
      } else if (!isPrintable(char)) {
        return STYLE_DOUBLE;
      }
      plain = plain && isPlainSafe(char, prevChar, inblock);
      prevChar = char;
    }
    hasFoldableLine = hasFoldableLine || shouldTrackWidth && (i - previousLineBreak - 1 > lineWidth && string3[previousLineBreak + 1] !== " ");
  }
  if (!hasLineBreak && !hasFoldableLine) {
    if (plain && !forceQuotes && !testAmbiguousType(string3)) {
      return STYLE_PLAIN;
    }
    return quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE;
  }
  if (indentPerLevel > 9 && needIndentIndicator(string3)) {
    return STYLE_DOUBLE;
  }
  if (!forceQuotes) {
    return hasFoldableLine ? STYLE_FOLDED : STYLE_LITERAL;
  }
  return quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE;
}
function writeScalar(state, string3, level, iskey, inblock) {
  state.dump = function() {
    if (string3.length === 0) {
      return state.quotingType === QUOTING_TYPE_DOUBLE ? '""' : "''";
    }
    if (!state.noCompatMode) {
      if (DEPRECATED_BOOLEANS_SYNTAX.indexOf(string3) !== -1 || DEPRECATED_BASE60_SYNTAX.test(string3)) {
        return state.quotingType === QUOTING_TYPE_DOUBLE ? '"' + string3 + '"' : "'" + string3 + "'";
      }
    }
    var indent = state.indent * Math.max(1, level);
    var lineWidth = state.lineWidth === -1 ? -1 : Math.max(Math.min(state.lineWidth, 40), state.lineWidth - indent);
    var singleLineOnly = iskey || state.flowLevel > -1 && level >= state.flowLevel;
    function testAmbiguity(string4) {
      return testImplicitResolving(state, string4);
    }
    switch (chooseScalarStyle(
      string3,
      singleLineOnly,
      state.indent,
      lineWidth,
      testAmbiguity,
      state.quotingType,
      state.forceQuotes && !iskey,
      inblock
    )) {
      case STYLE_PLAIN:
        return string3;
      case STYLE_SINGLE:
        return "'" + string3.replace(/'/g, "''") + "'";
      case STYLE_LITERAL:
        return "|" + blockHeader(string3, state.indent) + dropEndingNewline(indentString(string3, indent));
      case STYLE_FOLDED:
        return ">" + blockHeader(string3, state.indent) + dropEndingNewline(indentString(foldString(string3, lineWidth), indent));
      case STYLE_DOUBLE:
        return '"' + escapeString(string3) + '"';
      default:
        throw new exception("impossible error: invalid scalar style");
    }
  }();
}
function blockHeader(string3, indentPerLevel) {
  var indentIndicator = needIndentIndicator(string3) ? String(indentPerLevel) : "";
  var clip = string3[string3.length - 1] === "\n";
  var keep = clip && (string3[string3.length - 2] === "\n" || string3 === "\n");
  var chomp = keep ? "+" : clip ? "" : "-";
  return indentIndicator + chomp + "\n";
}
function dropEndingNewline(string3) {
  return string3[string3.length - 1] === "\n" ? string3.slice(0, -1) : string3;
}
function foldString(string3, width) {
  var lineRe = /(\n+)([^\n]*)/g;
  var result = function() {
    var nextLF = string3.indexOf("\n");
    nextLF = nextLF !== -1 ? nextLF : string3.length;
    lineRe.lastIndex = nextLF;
    return foldLine(string3.slice(0, nextLF), width);
  }();
  var prevMoreIndented = string3[0] === "\n" || string3[0] === " ";
  var moreIndented;
  var match;
  while (match = lineRe.exec(string3)) {
    var prefix = match[1], line = match[2];
    moreIndented = line[0] === " ";
    result += prefix + (!prevMoreIndented && !moreIndented && line !== "" ? "\n" : "") + foldLine(line, width);
    prevMoreIndented = moreIndented;
  }
  return result;
}
function foldLine(line, width) {
  if (line === "" || line[0] === " ") return line;
  var breakRe = / [^ ]/g;
  var match;
  var start = 0, end, curr = 0, next = 0;
  var result = "";
  while (match = breakRe.exec(line)) {
    next = match.index;
    if (next - start > width) {
      end = curr > start ? curr : next;
      result += "\n" + line.slice(start, end);
      start = end + 1;
    }
    curr = next;
  }
  result += "\n";
  if (line.length - start > width && curr > start) {
    result += line.slice(start, curr) + "\n" + line.slice(curr + 1);
  } else {
    result += line.slice(start);
  }
  return result.slice(1);
}
function escapeString(string3) {
  var result = "";
  var char = 0;
  var escapeSeq;
  for (var i = 0; i < string3.length; char >= 65536 ? i += 2 : i++) {
    char = codePointAt(string3, i);
    escapeSeq = ESCAPE_SEQUENCES[char];
    if (!escapeSeq && isPrintable(char)) {
      result += string3[i];
      if (char >= 65536) result += string3[i + 1];
    } else {
      result += escapeSeq || encodeHex(char);
    }
  }
  return result;
}
function writeFlowSequence(state, level, object3) {
  var _result = "", _tag = state.tag, index, length, value;
  for (index = 0, length = object3.length; index < length; index += 1) {
    value = object3[index];
    if (state.replacer) {
      value = state.replacer.call(object3, String(index), value);
    }
    if (writeNode(state, level, value, false, false) || typeof value === "undefined" && writeNode(state, level, null, false, false)) {
      if (_result !== "") _result += "," + (!state.condenseFlow ? " " : "");
      _result += state.dump;
    }
  }
  state.tag = _tag;
  state.dump = "[" + _result + "]";
}
function writeBlockSequence(state, level, object3, compact2) {
  var _result = "", _tag = state.tag, index, length, value;
  for (index = 0, length = object3.length; index < length; index += 1) {
    value = object3[index];
    if (state.replacer) {
      value = state.replacer.call(object3, String(index), value);
    }
    if (writeNode(state, level + 1, value, true, true, false, true) || typeof value === "undefined" && writeNode(state, level + 1, null, true, true, false, true)) {
      if (!compact2 || _result !== "") {
        _result += generateNextLine(state, level);
      }
      if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
        _result += "-";
      } else {
        _result += "- ";
      }
      _result += state.dump;
    }
  }
  state.tag = _tag;
  state.dump = _result || "[]";
}
function writeFlowMapping(state, level, object3) {
  var _result = "", _tag = state.tag, objectKeyList = Object.keys(object3), index, length, objectKey, objectValue, pairBuffer;
  for (index = 0, length = objectKeyList.length; index < length; index += 1) {
    pairBuffer = "";
    if (_result !== "") pairBuffer += ", ";
    if (state.condenseFlow) pairBuffer += '"';
    objectKey = objectKeyList[index];
    objectValue = object3[objectKey];
    if (state.replacer) {
      objectValue = state.replacer.call(object3, objectKey, objectValue);
    }
    if (!writeNode(state, level, objectKey, false, false)) {
      continue;
    }
    if (state.dump.length > 1024) pairBuffer += "? ";
    pairBuffer += state.dump + (state.condenseFlow ? '"' : "") + ":" + (state.condenseFlow ? "" : " ");
    if (!writeNode(state, level, objectValue, false, false)) {
      continue;
    }
    pairBuffer += state.dump;
    _result += pairBuffer;
  }
  state.tag = _tag;
  state.dump = "{" + _result + "}";
}
function writeBlockMapping(state, level, object3, compact2) {
  var _result = "", _tag = state.tag, objectKeyList = Object.keys(object3), index, length, objectKey, objectValue, explicitPair, pairBuffer;
  if (state.sortKeys === true) {
    objectKeyList.sort();
  } else if (typeof state.sortKeys === "function") {
    objectKeyList.sort(state.sortKeys);
  } else if (state.sortKeys) {
    throw new exception("sortKeys must be a boolean or a function");
  }
  for (index = 0, length = objectKeyList.length; index < length; index += 1) {
    pairBuffer = "";
    if (!compact2 || _result !== "") {
      pairBuffer += generateNextLine(state, level);
    }
    objectKey = objectKeyList[index];
    objectValue = object3[objectKey];
    if (state.replacer) {
      objectValue = state.replacer.call(object3, objectKey, objectValue);
    }
    if (!writeNode(state, level + 1, objectKey, true, true, true)) {
      continue;
    }
    explicitPair = state.tag !== null && state.tag !== "?" || state.dump && state.dump.length > 1024;
    if (explicitPair) {
      if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
        pairBuffer += "?";
      } else {
        pairBuffer += "? ";
      }
    }
    pairBuffer += state.dump;
    if (explicitPair) {
      pairBuffer += generateNextLine(state, level);
    }
    if (!writeNode(state, level + 1, objectValue, true, explicitPair)) {
      continue;
    }
    if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
      pairBuffer += ":";
    } else {
      pairBuffer += ": ";
    }
    pairBuffer += state.dump;
    _result += pairBuffer;
  }
  state.tag = _tag;
  state.dump = _result || "{}";
}
function detectType(state, object3, explicit) {
  var _result, typeList, index, length, type2, style;
  typeList = explicit ? state.explicitTypes : state.implicitTypes;
  for (index = 0, length = typeList.length; index < length; index += 1) {
    type2 = typeList[index];
    if ((type2.instanceOf || type2.predicate) && (!type2.instanceOf || typeof object3 === "object" && object3 instanceof type2.instanceOf) && (!type2.predicate || type2.predicate(object3))) {
      if (explicit) {
        if (type2.multi && type2.representName) {
          state.tag = type2.representName(object3);
        } else {
          state.tag = type2.tag;
        }
      } else {
        state.tag = "?";
      }
      if (type2.represent) {
        style = state.styleMap[type2.tag] || type2.defaultStyle;
        if (_toString.call(type2.represent) === "[object Function]") {
          _result = type2.represent(object3, style);
        } else if (_hasOwnProperty.call(type2.represent, style)) {
          _result = type2.represent[style](object3, style);
        } else {
          throw new exception("!<" + type2.tag + '> tag resolver accepts not "' + style + '" style');
        }
        state.dump = _result;
      }
      return true;
    }
  }
  return false;
}
function writeNode(state, level, object3, block, compact2, iskey, isblockseq) {
  state.tag = null;
  state.dump = object3;
  if (!detectType(state, object3, false)) {
    detectType(state, object3, true);
  }
  var type2 = _toString.call(state.dump);
  var inblock = block;
  var tagStr;
  if (block) {
    block = state.flowLevel < 0 || state.flowLevel > level;
  }
  var objectOrArray = type2 === "[object Object]" || type2 === "[object Array]", duplicateIndex, duplicate;
  if (objectOrArray) {
    duplicateIndex = state.duplicates.indexOf(object3);
    duplicate = duplicateIndex !== -1;
  }
  if (state.tag !== null && state.tag !== "?" || duplicate || state.indent !== 2 && level > 0) {
    compact2 = false;
  }
  if (duplicate && state.usedDuplicates[duplicateIndex]) {
    state.dump = "*ref_" + duplicateIndex;
  } else {
    if (objectOrArray && duplicate && !state.usedDuplicates[duplicateIndex]) {
      state.usedDuplicates[duplicateIndex] = true;
    }
    if (type2 === "[object Object]") {
      if (block && Object.keys(state.dump).length !== 0) {
        writeBlockMapping(state, level, state.dump, compact2);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + state.dump;
        }
      } else {
        writeFlowMapping(state, level, state.dump);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + " " + state.dump;
        }
      }
    } else if (type2 === "[object Array]") {
      if (block && state.dump.length !== 0) {
        if (state.noArrayIndent && !isblockseq && level > 0) {
          writeBlockSequence(state, level - 1, state.dump, compact2);
        } else {
          writeBlockSequence(state, level, state.dump, compact2);
        }
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + state.dump;
        }
      } else {
        writeFlowSequence(state, level, state.dump);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + " " + state.dump;
        }
      }
    } else if (type2 === "[object String]") {
      if (state.tag !== "?") {
        writeScalar(state, state.dump, level, iskey, inblock);
      }
    } else if (type2 === "[object Undefined]") {
      return false;
    } else {
      if (state.skipInvalid) return false;
      throw new exception("unacceptable kind of an object to dump " + type2);
    }
    if (state.tag !== null && state.tag !== "?") {
      tagStr = encodeURI(
        state.tag[0] === "!" ? state.tag.slice(1) : state.tag
      ).replace(/!/g, "%21");
      if (state.tag[0] === "!") {
        tagStr = "!" + tagStr;
      } else if (tagStr.slice(0, 18) === "tag:yaml.org,2002:") {
        tagStr = "!!" + tagStr.slice(18);
      } else {
        tagStr = "!<" + tagStr + ">";
      }
      state.dump = tagStr + " " + state.dump;
    }
  }
  return true;
}
function getDuplicateReferences(object3, state) {
  var objects = [], duplicatesIndexes = [], index, length;
  inspectNode(object3, objects, duplicatesIndexes);
  for (index = 0, length = duplicatesIndexes.length; index < length; index += 1) {
    state.duplicates.push(objects[duplicatesIndexes[index]]);
  }
  state.usedDuplicates = new Array(length);
}
function inspectNode(object3, objects, duplicatesIndexes) {
  var objectKeyList, index, length;
  if (object3 !== null && typeof object3 === "object") {
    index = objects.indexOf(object3);
    if (index !== -1) {
      if (duplicatesIndexes.indexOf(index) === -1) {
        duplicatesIndexes.push(index);
      }
    } else {
      objects.push(object3);
      if (Array.isArray(object3)) {
        for (index = 0, length = object3.length; index < length; index += 1) {
          inspectNode(object3[index], objects, duplicatesIndexes);
        }
      } else {
        objectKeyList = Object.keys(object3);
        for (index = 0, length = objectKeyList.length; index < length; index += 1) {
          inspectNode(object3[objectKeyList[index]], objects, duplicatesIndexes);
        }
      }
    }
  }
}
function dump$1(input, options) {
  options = options || {};
  var state = new State2(options);
  if (!state.noRefs) getDuplicateReferences(input, state);
  var value = input;
  if (state.replacer) {
    value = state.replacer.call({ "": value }, "", value);
  }
  if (writeNode(state, 0, value, true, true)) return state.dump + "\n";
  return "";
}
var dump_1 = dump$1;
var dumper = {
  dump: dump_1
};
function renamed(from, to) {
  return function() {
    throw new Error("Function yaml." + from + " is removed in js-yaml 4. Use yaml." + to + " instead, which is now safe by default.");
  };
}
var Type2 = type;
var Schema2 = schema;
var FAILSAFE_SCHEMA = failsafe;
var JSON_SCHEMA = json;
var CORE_SCHEMA = core;
var DEFAULT_SCHEMA = _default;
var load = loader.load;
var loadAll = loader.loadAll;
var dump = dumper.dump;
var YAMLException = exception;
var types = {
  binary,
  float,
  map,
  null: _null,
  pairs,
  set: set3,
  timestamp,
  bool,
  int,
  merge,
  omap,
  seq,
  str
};
var safeLoad = renamed("safeLoad", "load");
var safeLoadAll = renamed("safeLoadAll", "loadAll");
var safeDump = renamed("safeDump", "dump");
var jsYaml = {
  Type: Type2,
  Schema: Schema2,
  FAILSAFE_SCHEMA,
  JSON_SCHEMA,
  CORE_SCHEMA,
  DEFAULT_SCHEMA,
  load,
  loadAll,
  dump,
  YAMLException,
  types,
  safeLoad,
  safeLoadAll,
  safeDump
};
var js_yaml_default = jsYaml;

// ../../cli/workspace/commons/lib/openapi/BaseOpenAPIWorkspace.js
var BaseOpenAPIWorkspace = class extends AbstractAPIWorkspace {
  inlinePathParameters;
  objectQueryParameters;
  onlyIncludeReferencedSchemas;
  respectReadonlySchemas;
  constructor(args) {
    super(args);
    this.inlinePathParameters = args.inlinePathParameters;
    this.objectQueryParameters = args.objectQueryParameters;
    this.onlyIncludeReferencedSchemas = args.onlyIncludeReferencedSchemas;
    this.respectReadonlySchemas = args.respectReadonlySchemas;
  }
  async getDefinition({ context, absoluteFilePath, relativePathToDependency }, settings) {
    const openApiIr = await this.getOpenAPIIr({ context, relativePathToDependency }, settings);
    const definition = convert({
      authOverrides: this.generatorsConfiguration?.api?.auth != null ? { ...this.generatorsConfiguration?.api } : void 0,
      environmentOverrides: this.generatorsConfiguration?.api?.environments != null ? { ...this.generatorsConfiguration?.api } : void 0,
      globalHeaderOverrides: this.generatorsConfiguration?.api?.headers != null ? { ...this.generatorsConfiguration?.api } : void 0,
      taskContext: context,
      ir: openApiIr,
      enableUniqueErrorsPerEndpoint: settings?.enableUniqueErrorsPerEndpoint ?? false,
      detectGlobalHeaders: settings?.detectGlobalHeaders ?? true,
      objectQueryParameters: this.objectQueryParameters,
      respectReadonlySchemas: this.respectReadonlySchemas,
      onlyIncludeReferencedSchemas: this.onlyIncludeReferencedSchemas,
      inlinePathParameters: this.inlinePathParameters
    });
    return {
      absoluteFilePath: absoluteFilePath ?? this.absoluteFilePath,
      rootApiFile: {
        defaultUrl: definition.rootApiFile["default-url"],
        contents: definition.rootApiFile,
        rawContents: js_yaml_default.dump(definition.rootApiFile)
      },
      namedDefinitionFiles: {
        ...mapValues_default(definition.definitionFiles, (definitionFile) => ({
          absoluteFilepath: absoluteFilePath ?? this.absoluteFilePath,
          rawContents: js_yaml_default.dump(definitionFile),
          contents: definitionFile
        })),
        [RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME)]: {
          absoluteFilepath: absoluteFilePath ?? this.absoluteFilePath,
          rawContents: js_yaml_default.dump(definition.packageMarkerFile),
          contents: definition.packageMarkerFile
        }
      },
      packageMarkers: {},
      importedDefinitions: {}
    };
  }
  async toFernWorkspace({ context }, settings) {
    const definition = await this.getDefinition({ context }, settings);
    return new FernWorkspace({
      absoluteFilePath: this.absoluteFilePath,
      workspaceName: this.workspaceName,
      generatorsConfiguration: this.generatorsConfiguration,
      dependenciesConfiguration: {
        dependencies: {}
      },
      definition,
      cliVersion: this.cliVersion
    });
  }
};

// ../../cli/workspace/commons/lib/openapi/getOptionsOverridesFromSettings.js
function getOptionsOverridesFromSettings(settings) {
  if (settings == null) {
    return void 0;
  }
  const result = {};
  if (settings.enableDiscriminatedUnionV2) {
    result.discriminatedUnionV2 = true;
  }
  if (settings.optionalAdditionalProperties) {
    result.optionalAdditionalProperties = true;
  }
  if (settings.cooerceEnumsToLiterals) {
    result.cooerceEnumsToLiterals = true;
  }
  if (settings.preserveSchemaIds) {
    result.preserveSchemaIds = true;
  }
  return result;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/options.js
var DEFAULT_PARSE_ASYNCAPI_SETTINGS = {
  naming: "v1"
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/getExtension.js
function getExtension(object3, extension) {
  const extensions = Array.isArray(extension) ? extension : [extension];
  for (const extension2 of extensions) {
    const extensionValue = object3[extension2];
    if (extensionValue != null) {
      return extensionValue;
    }
  }
  return void 0;
}
function getExtensionAndValidate(object3, extension, schema2, logger, breadcrumbs = []) {
  try {
    const extensionValue = getExtension(object3, extension);
    if (extensionValue != null) {
      return schema2.parse(extensionValue);
    }
  } catch (e) {
    const breadcrumb = compact_default(breadcrumbs).join(" -> ");
    logger.error(`${breadcrumb.length > 0 ? `${breadcrumb}: ` : ""}Failed to parse ${extension}`);
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/id.js
var TypedExtensionId = {
  of(key) {
    return key;
  }
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/fernExtensions.js
var XFernStreaming = {
  properties: {
    "stream-condition": { type: "string" },
    response: "Schema",
    "response-stream": "Schema"
  },
  required: ["stream-condition", "response", "response-stream"],
  extensionsPrefix: "x-"
};
var FERN_TYPE_EXTENSIONS = {
  id: "",
  typeExtension: {
    oas3: (types2) => {
      return {
        ...types2,
        XFernStreaming,
        Operation: {
          ...types2.Operation,
          properties: {
            ...types2.Operation?.properties,
            "x-fern-streaming": "XFernStreaming"
          }
        }
      };
    }
  }
};
var FernOpenAPIExtension = {
  SDK_METHOD_NAME: TypedExtensionId.of("x-fern-sdk-method-name"),
  SDK_GROUP_NAME: TypedExtensionId.of("x-fern-sdk-group-name"),
  REQUEST_NAME_V1: "x-request-name",
  REQUEST_NAME_V2: "x-fern-request-name",
  TYPE_NAME: "x-fern-type-name",
  BOOLEAN_LITERAL: "x-fern-boolean-literal",
  SERVER_NAME_V1: "x-name",
  SERVER_NAME_V2: "x-fern-server-name",
  /**
   * Prepends the configured base path to all of the endpoint paths.
   *
   * x-fern-base-path: /v1
   * servers:
   *   - url: https://api.example.com
   * paths:
   *   /path/to/my/endpoint:
   */
  BASE_PATH: "x-fern-base-path",
  /**
   * Should align with the OpenAPI spec's `x-fern-sdk-group-name` extension.
   * This is a place where you can specify any display names related to the
   * configured SDK group names. These display names and descriptions will
   * come through in the docs.
   *
   * x-fern-groups:
   *  group1:
   *    display-name: Group 1
   *    description: This is group 1
   *    groups:
   *      group2 # add child groups
   */
  GROUPS: TypedExtensionId.of("x-fern-groups"),
  /**
   * Filepath that contains any OpenAPI overrides
   * that you wan't Fern to add on top of your existing spec.
   *
   * x-fern-overrides-filepath: relative/path/to/file
   */
  OPENAPI_OVERIDES_FILEPATH: "x-fern-overrides-filepath",
  /**
   * Used to override the type with fern's type syntax
   * Bar:
   *  properties:
   *    createdDate:
   *      type: string
   *      x-fern-type: datetime
   *      x-fern-type:
   *        properties:
   *         a: string
   *         b: integer
   *      x-fern-type: optional<map<string, integer>>
   */
  TYPE_DEFINITION: "x-fern-type",
  /**
   * Used to specify if an endpoint should be generated
   * as a streaming endpoint.
   *
   * Example usage:
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-streaming: true
   *
   * Used to specify if an endpoint should be generated
   * as a streaming endpoint with sever-sent0events.
   *
   * Example usage:
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-streaming:
   *          format: sse
   *
   * Alternatively, you can annotate the endpoint so that
   * it generates both a traditional unary endpoint,
   * as well as its streaming equivalent. The stream
   * condition property is included to specify a boolean
   * propetry that tells the server whether or not the
   * response should be streamed or not.
   *
   * Example usage:
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-streaming:
   *         format: sse # or json
   *         stream-condition: $request.stream
   *         stream-description: A description
   *         response:
   *           $ref: ./path/to/response/type.yaml
   *         response-stream:
   *           $ref: ./path/to/response-stream/type.yaml
   */
  STREAMING: "x-fern-streaming",
  /**
   * Used to specify if an endpoint should be generated
   * as a paginated endpoint. Both cursor and offset pagination
   * examples are shown below.
   *
   * Example usage:
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-pagination:
   *         cursor: $request.cursor
   *         next_cursor: $response.next
   *         results: $response.results
   *
   * Alternatively, if the configuration shown above is
   * specified at the document-level, paths can inherit the
   * configuration by setting the extension to true.
   *
   * Example usage:
   *   x-fern-pagination:
   *     offset: $request.page_number
   *     results: $response.results
   *
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-pagination: true
   */
  PAGINATION: "x-fern-pagination",
  /**
   * Used to specify if an endpoint is actually
   * representing a webhook
   * Example usage:
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-webhook: true
   */
  WEBHOOK: "x-fern-webhook",
  /**
   * Used to detect if an endpoint has an async version of it
   * Example usage:
   *   paths:
   *    /path/to/my/endpoint:
   *      x-fern-async-config:
   *        discriminant:
   *          type: header
   *          name: X-Header-Name
   *          value: async
   *        response-status-code: 202
   **/
  ASYNC_CONFIG: "x-fern-async-config",
  /**
   * Used to create veriables in the fern definition
   * Example usage:
   * x-fern-sdk-variables:
   *   appName:
   *     type: string
   * paths:
   *   /path/to/my/endpoint/{id}:
   *     parameters:
   *       - name: id
   *         in: path
   *         type: string
   *         x-fern-sdk-variable: appName
   */
  SDK_VARIABLES: "x-fern-sdk-variables",
  SDK_VARIABLE: "x-fern-sdk-variable",
  /**
   * Used to customize the name of the parameter used for a header.
   * Example usage:
   * paths:
   *   /path/to/my/endpoint/{id}:
   *     parameters:
   *       - in: header
   *         name: X-Fern-Version
   *         type: string
   *         x-fern-parameter-name: version
   */
  PARAMETER_NAME: "x-fern-parameter-name",
  /**
   * securitySchemes:
   *   Basic:
   *     scheme: http
   *     type: basic
   *     x-fern-username-variable-name: clientId
   *     x-fern-password-variable-name: clientSecret
   */
  BASIC_AUTH_USERNAME_VARIABLE_NAME: "x-fern-username-variable-name",
  BASIC_AUTH_PASSWORD_VARIABLE_NAME: "x-fern-password-variable-name",
  /**
   * securitySchemes:
   *   Bearer:
   *     scheme: http
   *     type: bearer
   *     x-fern-token-variable-name: apiKey
   */
  BEARER_TOKEN_VARIABLE_NAME: "x-fern-token-variable-name",
  /**
   * securitySchemes:
   *   Bearer:
   *     type: apiKey
   *     in: header
   *     name: X-API-KEY-ID
   *     x-fern-header-variable-name: apiKeyId
   */
  HEADER_VARIABLE_NAME: "x-fern-header-variable-name",
  /**
   * The x-fern-enum allows you to specify docs for the enum value.
   * If your enum is not codegen friendly (not alphanumeric), then you can specify a codegen name as well.
   *
   * MyEnum:
   *   enum:
   *     - VARIANT_ONE
   *     - VARIANT_TWO
   *   x-fern-enum:
   *     VARIANT_ONE:
   *       description: These are docs about the enum
   *       name: ONE
   */
  FERN_ENUM: "x-fern-enum",
  /**
   * Used to mark operations with audiences
   *
   * paths:
   *   /path/to/my/endpoint/{id}:
   *     x-fern-audiences:
   *       - external
   */
  AUDIENCES: "x-fern-audiences",
  /**
   * Used to tell fern to ignore endpoints.
   *
   * paths:
   *   /path/to/my/endpoint/{id}:
   *     get:
   *       x-fern-ignore: true
   */
  IGNORE: "x-fern-ignore",
  /**
   * paths:
   *  /path/to/my:
   *    get:
   *      x-fern-availability: ga # or beta, generally-available, deprecated,
   */
  AVAILABILITY: "x-fern-availability",
  /**
   * Used to signal that the SDK should return a specific property on the response.
   *
   * paths:
   *  /path/to/my:
   *    get:
   *      x-fern-sdk-return-value: data
   */
  RESPONSE_PROPERTY: "x-fern-sdk-return-value",
  /**
   * Used to resolve multiple schemas into a single schema. All the references
   * are replaced with a single schema.
   *
   * x-fern-resolutions:
   *  - name: User
   *    resolutions:
   *      - `#/components/schemas/Group/properties/user`
   *      - `#/components/schemas/User`
   */
  RESOLUTIONS: "x-fern-resolutions",
  /**
   * paths:
   *  /path/to/my:
   *    get:
   *     x-fern-examples:
   *      - name: Example 1
   *        docs: This is an example
   *        request: {}
   *        response:
   *          body: {}
   *        code-samples:
   *          - language: typescript
   *            install: npm install my-client
   *            code: |
   *              import { MyClient } from "my-client";
   *              const client = new MyClient();
   *              const response = await client.myEndpoint();
   *              console.log(response);
   *            name: Console Log My Endpoint
   *            description: This is a code sample that logs the response
   */
  EXAMPLES: "x-fern-examples",
  /**
   * securitySchemes:
   *   Bearer:
   *     scheme: http
   *     type: bearer
   *     x-fern-bearer:
   *       name: apiKey
   *       env: MY_AUTH_TOKEN
   */
  FERN_BEARER_TOKEN: "x-fern-bearer",
  /**
   * securitySchemes:
   *   Bearer:
   *     type: apiKey
   *     in: header
   *     name: X-API-KEY-ID
   *     x-fern-header:
   *       name: header
   *       env: MY_AUTH_TOKEN
   */
  FERN_HEADER_AUTH: "x-fern-header",
  /**
   * securitySchemes:
   *   Basic:
   *     scheme: http
   *     type: basic
   *     x-fern-basic:
   *       username:
   *          name: username
   *          env: MY_USERNAME
   *       password:
   *          name: password
   *          env: MY_PASSWORD
   */
  FERN_BASIC_AUTH: "x-fern-basic",
  /**
   * Allows users to specify which headers are global, and an optional alias for them
   * `header` is the name of the header used throughout your spec, while `name` is the
   * alias you'd like it to appear as within your generated SDK to the consumer.
   *
   * x-fern-global-headers:
   *  - header: our_api_key
   *    name: api_key
   *    optional: true
   *  - header: telemetry_id
   *    env: MY_ENVVAR
   *  - header: X-API-Version
   *    name: version
   *    type: literal<"2.10"> # The type of the header to use
   */
  FERN_GLOBAL_HEADERS: "x-fern-global-headers",
  /**
   * Allows users to specify which headers are idempotent.
   *
   * x-fern-idempotency-headers:
   *  - header: our_api_key
   *    name: api_key
   *    optional: true
   *  - header: telemetry_id
   *    env: MY_ENVVAR
   *  - header: X-API-Version
   *    name: version
   *    type: literal<"2.10"> # The type of the header to use
   */
  FERN_IDEMPOTENCY_HEADERS: "x-fern-idempotency-headers",
  /**
   * Mark a particular endpoint as idempotent.
   *
   * paths:
   *  send:
   *    post:
   *      x-fern-idempotent: true
   */
  IDEMPOTENT: "x-fern-idempotent",
  /**
   * Allows a user to configure the property name for the schema.
   */
  FERN_PROPERTY_NAME: "x-fern-property-name",
  /**
   * Allows a user to configure that a union wiht a discriminant should
   * be undiscriminated.
   *
   * Shape:
   *   x-fern-undiscriminated: true
   *   oneOf:
   *    - $ref: components/schemas/Triangle
   *    - $ref: components/schemas/Square
   */
  IS_UNDISCRIMINATED: "x-fern-undiscriminated",
  /**
   * Allows users to specify the version scheme supported by the API.
   *
   * x-fern-version:
   *   header: X-API-Version
   *   default: "2.0"
   *   values:
   *     - "1.0"
   *     - "2.0"
   *     - "Latest"
   */
  FERN_VERSION: "x-fern-version",
  /**
   * Allows users to specify the encoding of the type. For example, suppose you need to configure
   * Protobuf-encoding details like the following:
   *
   * User:
   *  properties:
   *    username:
   *      type: string
   *  x-fern-encoding:
   *    proto:
   *      type: user.v1.User
   */
  ENCODING: "x-fern-encoding",
  /**
   * Allows users to configure gRPC services. This must be specified on individual service
   * declarations.
   *
   * x-fern-transport:
   *   grpc:
   *     service-name: UserService
   */
  TRANSPORT: "x-fern-transport"
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/isReferenceObject.js
function isReferenceObject(parameter) {
  return parameter.$ref != null;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertAvailability.js
function convertAvailability3(propertySchema) {
  switch (getExtension(propertySchema, FernOpenAPIExtension.AVAILABILITY)) {
    case "deprecated":
      return Availability.Deprecated;
    case "beta":
      return Availability.Beta;
    case "generally-available":
      return Availability.GenerallyAvailable;
    default:
      break;
  }
  if (!isReferenceObject(propertySchema) && propertySchema.deprecated) {
    return Availability.Deprecated;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/extensions.js
var OpenAPIExtension = {
  BEARER_FORMAT: "x-bearer-format",
  /* This is an extension that several OpenAPI generators use that we support */
  ENUM_VAR_NAMES: "x-enum-varnames",
  /* This extension is a boolean that several generators use */
  INTERNAL: "x-internal",
  /* This extension is used for specifying examples */
  EXAMPLES: "x-examples",
  /* This extension is used for specifying tags on schemas*/
  TAGS: "x-tags",
  /* https://redocly.com/docs/api-reference-docs/specification-extensions/x-code-samples/ */
  REDOCLY_CODE_SAMPLES_KEBAB: "x-code-samples",
  REDOCLY_CODE_SAMPLES_CAMEL: "x-codeSamples"
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getExamples.js
function getExamples(schema2) {
  const examples = getExtension(schema2, "examples");
  if (examples != null && Array.isArray(examples)) {
    return examples;
  }
  return [];
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernEncoding.js
function getFernEncoding({ schema: schema2, logger }) {
  return getExtension(schema2, FernOpenAPIExtension.ENCODING) ?? void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernEnum.js
function getFernEnum(schema2) {
  return getExtension(schema2, FernOpenAPIExtension.FERN_ENUM);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernTypeExtension.js
function getFernTypeExtension({ nameOverride, generatedName, title, schema: schema2, description, availability }) {
  const groupName = getExtension(schema2, FernOpenAPIExtension.SDK_GROUP_NAME);
  const fernType = getExtension(schema2, FernOpenAPIExtension.TYPE_DEFINITION);
  if (fernType == null) {
    return;
  }
  return getSchemaFromFernType({
    fernType,
    nameOverride,
    generatedName,
    title,
    description,
    availability,
    groupName: typeof groupName === "string" ? [groupName] : groupName
  });
}
function getSchemaFromFernType({ fernType, nameOverride, generatedName, title, description, availability, groupName }) {
  return recursivelyVisitRawTypeReference({
    type: fernType,
    _default: void 0,
    validation: void 0,
    visitor: {
      primitive: (primitive) => {
        switch (primitive.v1) {
          case "BASE_64":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.base64({
                example: void 0
              })
            });
          case "BOOLEAN":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.boolean({
                default: void 0,
                example: void 0
              })
            });
          case "DATE":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.date({
                example: void 0
              })
            });
          case "DATE_TIME":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.datetime({
                example: void 0
              })
            });
          case "FLOAT":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.float({
                example: void 0
              })
            });
          case "DOUBLE":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.double({
                default: void 0,
                minimum: void 0,
                maximum: void 0,
                exclusiveMinimum: void 0,
                exclusiveMaximum: void 0,
                multipleOf: void 0,
                example: void 0
              })
            });
          case "UINT":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.uint({
                default: void 0,
                example: void 0
              })
            });
          case "INTEGER":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.int({
                default: void 0,
                minimum: void 0,
                maximum: void 0,
                exclusiveMinimum: void 0,
                exclusiveMaximum: void 0,
                multipleOf: void 0,
                example: void 0
              })
            });
          case "UINT_64":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.uint64({
                default: void 0,
                example: void 0
              })
            });
          case "LONG":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.int64({
                default: void 0,
                example: void 0
              })
            });
          case "STRING":
          case "UUID":
          case "BIG_INTEGER":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.string({
                default: void 0,
                pattern: void 0,
                maxLength: void 0,
                minLength: void 0,
                example: void 0,
                format: void 0
              })
            });
          default:
            assertNever(primitive.v1);
        }
      },
      unknown: () => {
        return SchemaWithExample.unknown({
          nameOverride,
          generatedName,
          title,
          example: void 0,
          description,
          availability,
          groupName
        });
      },
      map: ({ keyType, valueType }) => keyType?.type === "primitive" && valueType != null ? SchemaWithExample.map({
        nameOverride,
        generatedName,
        title,
        key: keyType,
        value: valueType,
        description,
        availability,
        groupName,
        encoding: void 0,
        example: void 0
      }) : void 0,
      list: (itemType) => itemType != null ? SchemaWithExample.array({
        nameOverride,
        generatedName,
        title,
        value: itemType,
        description,
        availability,
        groupName,
        example: void 0
      }) : void 0,
      optional: (itemType) => itemType != null ? SchemaWithExample.optional({
        nameOverride,
        generatedName,
        title,
        value: itemType,
        description,
        availability,
        groupName
      }) : void 0,
      set: (itemType) => itemType != null ? SchemaWithExample.array({
        nameOverride,
        generatedName,
        title,
        value: itemType,
        description,
        availability,
        groupName,
        example: void 0
      }) : void 0,
      literal: (literal) => SchemaWithExample.literal({
        nameOverride,
        generatedName,
        title,
        value: literal._visit({
          string: (value) => LiteralSchemaValue.string(value),
          boolean: (value) => LiteralSchemaValue.boolean(value),
          _other: () => {
            throw new Error("Unexpected literal type");
          }
        }),
        description,
        availability,
        groupName
      }),
      named: () => {
        return void 0;
      }
    }
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/utils/getValue.js
function getValueIfBoolean(value) {
  if (value != null && typeof value === "boolean") {
    return value;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertAdditionalProperties.js
function convertAdditionalProperties({ nameOverride, generatedName, title, breadcrumbs, additionalProperties, description, availability, wrapAsNullable, context, groupName, example, encoding, source, namespace }) {
  if (typeof additionalProperties === "boolean" || isAdditionalPropertiesAny(additionalProperties)) {
    return wrapMap({
      nameOverride,
      generatedName,
      title,
      wrapAsNullable,
      description,
      availability,
      keySchema: {
        nameOverride: void 0,
        generatedName: `${generatedName}Key`,
        title: void 0,
        description: void 0,
        availability: void 0,
        schema: PrimitiveSchemaValueWithExample.string({
          default: void 0,
          pattern: void 0,
          format: void 0,
          minLength: void 0,
          maxLength: void 0,
          example: void 0
        }),
        groupName: void 0
      },
      valueSchema: SchemaWithExample.unknown({
        nameOverride: void 0,
        generatedName: `${generatedName}Value`,
        title: void 0,
        description: void 0,
        availability: void 0,
        example: void 0,
        groupName: void 0
      }),
      groupName,
      example,
      encoding
    });
  }
  return wrapMap({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    description,
    availability,
    keySchema: {
      nameOverride: void 0,
      generatedName: `${generatedName}Key`,
      title: void 0,
      description: void 0,
      availability: void 0,
      schema: PrimitiveSchemaValueWithExample.string({
        default: void 0,
        pattern: void 0,
        format: void 0,
        minLength: void 0,
        maxLength: void 0,
        example: void 0
      }),
      groupName: void 0
    },
    valueSchema: convertSchema(additionalProperties, context.options.optionalAdditionalProperties ? wrapAsNullable : false, context, [...breadcrumbs, "Value"], source, namespace),
    groupName,
    example,
    encoding
  });
}
function wrapMap({ nameOverride, generatedName, title, keySchema, valueSchema, wrapAsNullable, description, availability, groupName, example, encoding }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.map({
        nameOverride,
        generatedName,
        title,
        description,
        availability: keySchema.availability,
        key: keySchema,
        value: valueSchema,
        groupName,
        encoding,
        example
      }),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.map({
    nameOverride,
    generatedName,
    title,
    description,
    availability,
    key: keySchema,
    value: valueSchema,
    groupName,
    encoding,
    example
  });
}
function isAdditionalPropertiesAny(additionalProperties) {
  if (additionalProperties == null) {
    return false;
  }
  if (typeof additionalProperties === "boolean") {
    return additionalProperties;
  }
  return !isReferenceObject(additionalProperties) && Object.keys(additionalProperties).length === 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertArray.js
function convertArray({ nameOverride, generatedName, title, breadcrumbs, item, description, availability, wrapAsNullable, context, groupName, example, source, namespace }) {
  const itemSchema = item == null ? SchemaWithExample.unknown({
    nameOverride,
    generatedName,
    title,
    description: void 0,
    availability: void 0,
    example: void 0,
    groupName
  }) : convertSchema(item, false, context, [...breadcrumbs, "Item"], source, namespace);
  return wrapArray({
    nameOverride,
    generatedName,
    title,
    groupName,
    itemSchema,
    wrapAsNullable,
    description,
    availability,
    example
  });
}
function wrapArray({ nameOverride, generatedName, title, itemSchema, wrapAsNullable, description, availability, groupName, example }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.array({
        nameOverride,
        generatedName,
        title,
        value: itemSchema,
        description,
        availability,
        groupName,
        example
      }),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.array({
    nameOverride,
    generatedName,
    title,
    value: itemSchema,
    description,
    availability,
    groupName,
    example
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertDiscriminatedOneOf.js
function convertDiscriminatedOneOf({ nameOverride, generatedName, title, breadcrumbs, properties, description, availability, required, wrapAsNullable, discriminator, context, groupName, encoding, source, namespace }) {
  const discriminant3 = discriminator.propertyName;
  const unionSubTypes = Object.fromEntries(Object.entries(discriminator.mapping ?? {}).map(([discriminantValue, schema2]) => {
    const subtypeReference = convertReferenceObject({
      $ref: schema2
    }, false, context, [schema2], encoding, source, namespace);
    context.markReferencedByDiscriminatedUnion({
      $ref: schema2
    }, discriminant3, 1);
    return [discriminantValue, subtypeReference];
  }));
  const convertedProperties = Object.entries(properties).filter(([propertyName]) => {
    return propertyName !== discriminant3;
  }).map(([propertyName, propertySchema]) => {
    const isRequired = required != null && required.includes(propertyName);
    const schema2 = convertSchema(propertySchema, !isRequired, context, [...breadcrumbs, propertyName], source, namespace);
    return {
      key: propertyName,
      schema: schema2
    };
  });
  return wrapDiscriminantedOneOf({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    properties: convertedProperties,
    description,
    availability,
    discriminant: discriminant3,
    subtypes: unionSubTypes,
    groupName,
    source
  });
}
function convertDiscriminatedOneOfWithVariants({ nameOverride, generatedName, title, breadcrumbs, properties, description, availability, required, wrapAsNullable, discriminant: discriminant3, variants, context, groupName, encoding, source, namespace }) {
  const unionSubTypes = Object.fromEntries(Object.entries(variants).map(([discriminantValue, schema2]) => {
    if (isReferenceObject(schema2)) {
      const subtypeReference = convertReferenceObject(schema2, false, context, [schema2.$ref], encoding, source, namespace);
      context.markReferencedByDiscriminatedUnion(schema2, discriminant3, 1);
      return [discriminantValue, subtypeReference];
    } else {
      const variantSchema = convertSchemaObject(schema2, false, context, [...breadcrumbs, discriminantValue], encoding, source, namespace, /* @__PURE__ */ new Set([discriminant3]));
      return [discriminantValue, variantSchema];
    }
  }));
  const convertedProperties = Object.entries(properties).filter(([propertyName]) => {
    return propertyName !== discriminant3;
  }).map(([propertyName, propertySchema]) => {
    const isRequired = required != null && required.includes(propertyName);
    const schema2 = convertSchema(propertySchema, !isRequired, context, [...breadcrumbs, propertyName], source, namespace);
    return {
      key: propertyName,
      schema: schema2
    };
  });
  return wrapDiscriminantedOneOf({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    properties: convertedProperties,
    description,
    availability,
    discriminant: discriminant3,
    subtypes: unionSubTypes,
    groupName,
    source
  });
}
function wrapDiscriminantedOneOf({ nameOverride, generatedName, title, wrapAsNullable, properties, description, availability, discriminant: discriminant3, subtypes, groupName, source }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.oneOf(OneOfSchemaWithExample.discriminated({
        description,
        availability,
        discriminantProperty: discriminant3,
        nameOverride,
        generatedName,
        title,
        schemas: subtypes,
        commonProperties: properties,
        groupName,
        encoding: void 0,
        source
      })),
      groupName,
      description,
      availability
    });
  }
  return SchemaWithExample.oneOf(OneOfSchemaWithExample.discriminated({
    description,
    availability,
    discriminantProperty: discriminant3,
    nameOverride,
    generatedName,
    title,
    schemas: subtypes,
    commonProperties: properties,
    groupName,
    encoding: void 0,
    source
  }));
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertEncoding.js
function convertEncoding(encodingSchema) {
  if (encodingSchema.proto != null) {
    return Encoding.protobuf({
      typeName: encodingSchema.proto.type
    });
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertEnum.js
function convertEnum({ nameOverride, generatedName, title, fernEnum, enumVarNames, enumValues, _default: _default2, description, availability, wrapAsNullable, groupName, context, source }) {
  const strippedEnumVarNames = stripCommonPrefix(enumVarNames ?? []);
  const uniqueValues = new Set(enumValues);
  const values = Array.from(uniqueValues).map((value, index) => {
    const fernEnumValue = fernEnum?.[value];
    const enumVarName = strippedEnumVarNames[index];
    const valueIsValidName = VALID_ENUM_NAME_REGEX.test(value);
    let nameOverride2 = fernEnumValue?.name ?? enumVarName;
    const generatedName2 = valueIsValidName ? value : generateEnumNameFromValue(value);
    if (nameOverride2 != null && !VALID_ENUM_NAME_REGEX.test(nameOverride2)) {
      context?.logger.warn(`Enum name override ${nameOverride2} is not a valid name. Falling back on ${generatedName2}.`);
      nameOverride2 = void 0;
    }
    return {
      nameOverride: nameOverride2,
      generatedName: generatedName2,
      value,
      description: fernEnumValue?.description,
      availability,
      casing: {
        snake: fernEnumValue?.casing?.snake ?? void 0,
        pascal: fernEnumValue?.casing?.pascal ?? void 0,
        screamingSnake: fernEnumValue?.casing?.screamingSnake ?? void 0,
        camel: fernEnumValue?.casing?.camel ?? void 0
      }
    };
  });
  const _defaultEnumValue = _default2 != null ? values.find((value) => value.value === _default2) : void 0;
  return wrapEnum({
    wrapAsNullable,
    nameOverride,
    generatedName,
    title,
    values,
    _default: _defaultEnumValue,
    description,
    availability,
    groupName,
    source
  });
}
function wrapEnum({ wrapAsNullable, nameOverride, generatedName, title, values, _default: _default2, description, availability, groupName, source }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.enum({
        nameOverride,
        generatedName,
        title,
        values,
        description,
        default: _default2,
        availability,
        example: void 0,
        groupName,
        source
      }),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.enum({
    nameOverride,
    generatedName,
    title,
    values,
    description,
    availability,
    default: _default2,
    example: void 0,
    groupName,
    source
  });
}
function stripCommonPrefix(names) {
  if (names.length <= 1 || names[0] == null) {
    return names;
  }
  const nameZero = names[0];
  let i = 0;
  while (nameZero[i] != null && names.every((name) => name[i] === nameZero[i])) {
    i++;
  }
  return names.map((name) => name.substring(i));
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertInteger.js
function convertInteger({ nameOverride, generatedName, title, format, _default: _default2, minimum, maximum, exclusiveMinimum, exclusiveMaximum, multipleOf, description, availability, wrapAsNullable, example, groupName }) {
  if (format === "int64") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.int64({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "uint32") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.uint({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "uint64") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.uint64({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  }
  return wrapPrimitive({
    nameOverride,
    generatedName,
    title,
    primitive: PrimitiveSchemaValueWithExample.int({
      default: _default2,
      minimum,
      maximum,
      exclusiveMinimum,
      exclusiveMaximum,
      multipleOf,
      example
    }),
    wrapAsNullable,
    description,
    availability,
    groupName
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertLiteral.js
function createLiteralSchemaValue(value) {
  if (typeof value === "string") {
    return LiteralSchemaValue.string(value);
  } else if (typeof value === "boolean") {
    return LiteralSchemaValue.boolean(value);
  } else {
    return LiteralSchemaValue.string(`${value}`);
  }
}
function convertLiteral({ nameOverride, generatedName, title, wrapAsNullable, value, description, availability, groupName }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.literal({
        nameOverride,
        generatedName,
        title,
        value: createLiteralSchemaValue(value),
        description,
        availability,
        groupName
      }),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.literal({
    nameOverride,
    generatedName,
    title,
    value: createLiteralSchemaValue(value),
    description,
    availability,
    groupName
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertNumber.js
function convertNumber({ nameOverride, generatedName, title, format, _default: _default2, minimum, maximum, exclusiveMinimum, exclusiveMaximum, multipleOf, description, availability, wrapAsNullable, example, groupName }) {
  if (format == null || format === "double") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.double({
        default: _default2,
        minimum,
        maximum,
        exclusiveMinimum,
        exclusiveMaximum,
        multipleOf,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "float") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.float({
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "int32") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.int({
        default: _default2,
        minimum,
        maximum,
        exclusiveMinimum,
        exclusiveMaximum,
        multipleOf,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "int64") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.int64({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "uint32") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.uint({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "uint64") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.uint64({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "time-delta") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.float({
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  }
  return wrapPrimitive({
    nameOverride,
    generatedName,
    title,
    primitive: PrimitiveSchemaValueWithExample.float({
      example
    }),
    wrapAsNullable,
    description,
    availability,
    groupName
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/getBreadcrumbsFromReference.js
var STARTS_WITH_COMPONENTS_SCHEMAS = {
  // if the first three breadcrumbs are "#", "components", "schemas"
  // then the fourth breadcrumb will be a user-defined value that we want to extract
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "#" && refUnderProcessing[1] === "components" && refUnderProcessing[2] === "schemas",
  applyStrategy: (refUnderProcessing) => {
    const newBreadcrumbs = [refUnderProcessing[3] ?? ""];
    return {
      refUnderProcessing: refUnderProcessing.slice(4),
      newBreadcrumbs
    };
  }
};
var STARTS_WITH_COMPONENTS_RESPONSES = {
  // if the first three breadcrumbs are "#", "components", "responses"
  // then the fourth breadcrumb will be a user-defined value that we want to extract
  isApplicable: (breadcrumbs) => breadcrumbs[0] === "#" && breadcrumbs[1] === "components" && breadcrumbs[2] === "responses",
  applyStrategy: (refUnderProcessing) => {
    const newBreadcrumbs = [refUnderProcessing[3] ?? ""];
    refUnderProcessing = refUnderProcessing.slice(4);
    return {
      refUnderProcessing: refUnderProcessing.slice(4),
      newBreadcrumbs
    };
  }
};
var STARTS_WITH_COMPONENTS_PARAMETERS = {
  // if the first three breadcrumbs are "#", "components", "parameters"
  // then the fourth breadcrumb will be a user-defined value that we want to extract
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "#" && refUnderProcessing[1] === "components" && refUnderProcessing[2] === "parameters",
  applyStrategy: (refUnderProcessing) => {
    const newBreadcrumbs = [refUnderProcessing[3] ?? ""];
    refUnderProcessing = refUnderProcessing.slice(4);
    if (refUnderProcessing[0] === "schema") {
      refUnderProcessing = refUnderProcessing.slice(1);
    }
    return {
      refUnderProcessing,
      newBreadcrumbs
    };
  }
};
var EXTRACT_PROPERTY = {
  // if the first breadcrumb is "properties"
  // then the second breadcrumb will be a user-defined value that we want to extract
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "properties",
  applyStrategy: (refUnderProcessing) => {
    const newBreadcrumbs = [refUnderProcessing[1] ?? ""];
    return {
      refUnderProcessing: refUnderProcessing.slice(2),
      newBreadcrumbs
    };
  }
};
var REMOVE_ITEMS_KEYWORD = {
  // if the first breadcrumb is "items"
  // then we want to remove it from the breadcrumbs array
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "items",
  applyStrategy: (refUnderProcessing) => {
    return {
      refUnderProcessing: refUnderProcessing.slice(1),
      newBreadcrumbs: []
    };
  }
};
var REMOVE_ALL_OF_KEYWORD = {
  // if the first breadcrumb is "allOf"
  // then we want to remove it from the breadcrumbs array
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "allOf",
  applyStrategy: (refUnderProcessing) => {
    return {
      refUnderProcessing: refUnderProcessing.slice(1),
      newBreadcrumbs: []
    };
  }
};
var REMOVE_ANY_OF_KEYWORD = {
  // if the first breadcrumb is "anyOf"
  // then we want to remove it from the breadcrumbs array
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "anyOf",
  applyStrategy: (refUnderProcessing) => {
    return {
      refUnderProcessing: refUnderProcessing.slice(1),
      newBreadcrumbs: []
    };
  }
};
var REMOVE_ONE_OF_KEYWORD = {
  // if the first breadcrumb is "oneOf"
  // then we want to remove it from the breadcrumbs array
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "oneOf",
  applyStrategy: (refUnderProcessing) => {
    return {
      refUnderProcessing: refUnderProcessing.slice(1),
      newBreadcrumbs: []
    };
  }
};
function getBreadcrumbsFromReference(reference) {
  let refUnderProcessing = reference.split("/").map((breadcrumb) => breadcrumb.replace(/~1/g, "/"));
  let breadcrumbs = [];
  const strategies = [
    // prefix strategies
    STARTS_WITH_COMPONENTS_SCHEMAS,
    STARTS_WITH_COMPONENTS_RESPONSES,
    STARTS_WITH_COMPONENTS_PARAMETERS,
    // index-aware strategies that must happen after prefix strategies
    EXTRACT_PROPERTY,
    REMOVE_ITEMS_KEYWORD,
    REMOVE_ALL_OF_KEYWORD,
    REMOVE_ANY_OF_KEYWORD,
    REMOVE_ONE_OF_KEYWORD
  ];
  let previousRefUnderProcessing;
  do {
    previousRefUnderProcessing = refUnderProcessing;
    for (const strategy of strategies) {
      if (strategy.isApplicable(refUnderProcessing)) {
        const { refUnderProcessing: newRefUnderProcessing, newBreadcrumbs } = strategy.applyStrategy(refUnderProcessing);
        refUnderProcessing = newRefUnderProcessing;
        breadcrumbs = [...breadcrumbs, ...newBreadcrumbs];
      }
    }
  } while (refUnderProcessing.join("") !== previousRefUnderProcessing.join(""));
  return breadcrumbs;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/getSchemaName.js
function getGeneratedTypeName(breadcrumbs, useOriginalSchemaIds) {
  const processedTokens = breadcrumbs.map((token) => {
    if (/^[^a-zA-Z0-9]+$/.test(token)) {
      return token;
    } else {
      return upperFirst_default(camelCase_default(token));
    }
  });
  const name = processedTokens.join("");
  if (/^\d/.test(name)) {
    return replaceStartingNumber(name) ?? name;
  }
  return name;
}
function getGeneratedPropertyName(breadcrumbs) {
  const underscoreDelimited = breadcrumbs.join("_");
  return camelCase_default(underscoreDelimited);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/convertSchemaWithExampleToSchema.js
function convertSchemaWithExampleToSchema(schema2) {
  switch (schema2.type) {
    case "object":
      return Schema.object({
        allOf: schema2.allOf,
        properties: schema2.properties.map((objectProperty) => convertToObjectProperty(objectProperty)),
        allOfPropertyConflicts: schema2.allOfPropertyConflicts,
        description: schema2.description,
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName,
        additionalProperties: schema2.additionalProperties,
        availability: schema2.availability,
        source: schema2.source
      });
    case "array":
      return Schema.array({
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaWithExampleToSchema(schema2.value),
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName
      });
    case "enum":
      return Schema.enum({
        description: schema2.description,
        availability: schema2.availability,
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        values: schema2.values,
        default: schema2.default,
        groupName: schema2.groupName,
        source: schema2.source
      });
    case "literal":
      return Schema.literal({
        description: schema2.description,
        availability: schema2.availability,
        value: schema2.value,
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName
      });
    case "nullable":
      return Schema.nullable({
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaWithExampleToSchema(schema2.value),
        groupName: schema2.groupName
      });
    case "optional":
      return Schema.optional({
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaWithExampleToSchema(schema2.value),
        groupName: schema2.groupName
      });
    case "primitive":
      return Schema.primitive({
        description: schema2.description,
        availability: schema2.availability,
        schema: convertToPrimitiveSchemaValue(schema2.schema),
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName
      });
    case "map":
      return Schema.map({
        description: schema2.description,
        availability: schema2.availability,
        key: Schema.primitive({
          description: schema2.key.description,
          availability: schema2.key.availability,
          schema: convertToPrimitiveSchemaValue(schema2.key.schema),
          generatedName: schema2.key.generatedName,
          title: schema2.key.title,
          nameOverride: schema2.key.nameOverride,
          groupName: schema2.groupName
        }),
        value: convertSchemaWithExampleToSchema(schema2.value),
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        groupName: schema2.groupName,
        encoding: schema2.encoding
      });
    case "reference":
      return Schema.reference({
        description: schema2.description,
        availability: schema2.availability,
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        schema: schema2.schema,
        groupName: schema2.groupName,
        source: schema2.source
      });
    case "oneOf":
      return Schema.oneOf(convertToOneOf(schema2.value));
    case "unknown":
      return Schema.unknown({ nameOverride: schema2.nameOverride, generatedName: schema2.generatedName });
    default:
      assertNever(schema2);
  }
}
function convertToOneOf(oneOfSchema) {
  switch (oneOfSchema.type) {
    case "discriminated":
      return OneOfSchema.discriminated({
        commonProperties: oneOfSchema.commonProperties.map((commonProperty) => {
          return {
            key: commonProperty.key,
            schema: convertSchemaWithExampleToSchema(commonProperty.schema)
          };
        }),
        description: oneOfSchema.description,
        availability: oneOfSchema.availability,
        discriminantProperty: oneOfSchema.discriminantProperty,
        generatedName: oneOfSchema.generatedName,
        title: oneOfSchema.title,
        nameOverride: oneOfSchema.nameOverride,
        schemas: Object.fromEntries(Object.entries(oneOfSchema.schemas).map(([discriminantValue, schemaWithExample]) => {
          return [discriminantValue, convertSchemaWithExampleToSchema(schemaWithExample)];
        })),
        groupName: oneOfSchema.groupName,
        encoding: oneOfSchema.encoding,
        source: oneOfSchema.source
      });
    case "undisciminated":
      return OneOfSchema.undisciminated({
        description: oneOfSchema.description,
        availability: oneOfSchema.availability,
        generatedName: oneOfSchema.generatedName,
        title: oneOfSchema.title,
        nameOverride: oneOfSchema.nameOverride,
        schemas: oneOfSchema.schemas.map((oneOfSchema2) => convertSchemaWithExampleToSchema(oneOfSchema2)),
        groupName: oneOfSchema.groupName,
        encoding: oneOfSchema.encoding,
        source: oneOfSchema.source
      });
    default:
      assertNever(oneOfSchema);
  }
}
function convertToPrimitiveSchemaValue(primitiveSchema) {
  switch (primitiveSchema.type) {
    case "string":
      return PrimitiveSchemaValue.string(primitiveSchema);
    case "base64":
      return PrimitiveSchemaValue.base64();
    case "boolean":
      return PrimitiveSchemaValue.boolean(primitiveSchema);
    case "date":
      return PrimitiveSchemaValue.date();
    case "datetime":
      return PrimitiveSchemaValue.datetime();
    case "double":
      return PrimitiveSchemaValue.double(primitiveSchema);
    case "float":
      return PrimitiveSchemaValue.float();
    case "int":
      return PrimitiveSchemaValue.int(primitiveSchema);
    case "int64":
      return PrimitiveSchemaValue.int64(primitiveSchema);
    case "uint":
      return PrimitiveSchemaValue.uint();
    case "uint64":
      return PrimitiveSchemaValue.uint64();
    default:
      assertNever(primitiveSchema);
  }
}
function convertToObjectProperty(objectProperty) {
  return {
    conflict: objectProperty.conflict,
    generatedName: objectProperty.generatedName,
    key: objectProperty.key,
    schema: convertSchemaWithExampleToSchema(objectProperty.schema),
    audiences: objectProperty.audiences,
    nameOverride: objectProperty.nameOverride,
    availability: objectProperty.availability,
    readonly: objectProperty.readonly
  };
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/isSchemaWithExampleEqual.js
function isSchemaWithExampleEqual(a, b) {
  return isSchemaEqual(convertSchemaWithExampleToSchema(a), convertSchemaWithExampleToSchema(b));
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertObject.js
function convertObject3({ nameOverride, generatedName, title, breadcrumbs, properties, description, required, wrapAsNullable, allOf, context, propertiesToExclude, groupName, fullExamples, additionalProperties, availability, encoding, source, namespace }) {
  const allRequired = [...required ?? []];
  const propertiesToConvert = { ...properties };
  const inlinedParentProperties = [];
  const parents = [];
  for (const allOfElement of allOf) {
    if (isReferenceObject(allOfElement)) {
      const resolvedReference = context.resolveSchemaReference(allOfElement);
      if (resolvedReference.discriminator != null && resolvedReference.discriminator.mapping != null) {
        continue;
      }
      if (resolvedReference.oneOf != null) {
        for (const oneOfSchema of resolvedReference.oneOf) {
          const resolvedOneOfSchema = isReferenceObject(oneOfSchema) ? context.resolveSchemaReference(oneOfSchema) : oneOfSchema;
          const convertedOneOfSchema = convertSchema(resolvedOneOfSchema, false, context.DUMMY, breadcrumbs, source, namespace);
          if (convertedOneOfSchema.type === "object") {
            inlinedParentProperties.push(...convertedOneOfSchema.properties.map((property4) => {
              if (property4.schema.type !== "optional" && property4.schema.type !== "nullable") {
                return {
                  ...property4,
                  schema: SchemaWithExample.optional({
                    nameOverride: void 0,
                    generatedName: "",
                    title: void 0,
                    value: property4.schema,
                    description: void 0,
                    availability: property4.availability,
                    groupName: void 0
                  })
                };
              }
              return property4;
            }));
          }
        }
        continue;
      }
      const schemaId = getSchemaIdFromReference(allOfElement);
      if (schemaId == null) {
        continue;
      }
      parents.push({
        schemaId,
        convertedSchema: convertToReferencedSchema(allOfElement, [schemaId], source, context.options.preserveSchemaIds),
        properties: getAllProperties({ schema: allOfElement, context, breadcrumbs, source, namespace })
      });
      context.markSchemaAsReferencedByNonRequest(schemaId);
    } else {
      const allOfSchema = convertSchema(allOfElement, false, context, breadcrumbs, source, namespace);
      if (allOfSchema.type === "object") {
        inlinedParentProperties.push(...allOfSchema.properties);
      }
    }
  }
  const allPropertiesMap = {};
  for (const parent of parents) {
    for (const [propertyKey, propertySchema] of Object.entries(parent.properties)) {
      const propertyInfo = allPropertiesMap[propertyKey];
      if (propertyInfo != null) {
        propertyInfo.schemaIds.push(parent.schemaId);
        const schemaExists = propertyInfo.schemas.some((schema2) => {
          return isSchemaWithExampleEqual(schema2, propertySchema);
        });
        if (!schemaExists) {
          propertyInfo.schemas.push(propertySchema);
        }
      } else {
        allPropertiesMap[propertyKey] = { schemaIds: [parent.schemaId], schemas: [propertySchema] };
      }
    }
  }
  const allOfPropertyConflicts = [];
  for (const [allOfPropertyKey, allOfPropertyInfo] of Object.entries(allPropertiesMap)) {
    if (allOfPropertyInfo.schemaIds.length > 1) {
      allOfPropertyConflicts.push({
        propertyKey: allOfPropertyKey,
        allOfSchemaIds: allOfPropertyInfo.schemaIds,
        conflictingTypeSignatures: allOfPropertyInfo.schemas.length > 1
      });
    }
  }
  const convertedProperties = Object.entries(propertiesToConvert).map(([propertyName, propertySchema]) => {
    const isRequired = allRequired.includes(propertyName);
    const audiences = getExtension(propertySchema, FernOpenAPIExtension.AUDIENCES) ?? [];
    const availability2 = convertAvailability3(propertySchema);
    const readonly = isReferenceObject(propertySchema) ? false : propertySchema.readOnly;
    const propertyNameOverride = getExtension(propertySchema, FernOpenAPIExtension.FERN_PROPERTY_NAME);
    const propertyBreadcrumbs = [...breadcrumbs, propertyName];
    const generatedName2 = getGeneratedPropertyName(propertyBreadcrumbs);
    const schema2 = isRequired ? convertSchema(propertySchema, false, context, propertyBreadcrumbs, source, namespace) : SchemaWithExample.optional({
      nameOverride,
      generatedName: generatedName2,
      title,
      description: void 0,
      availability: availability2,
      value: convertSchema(propertySchema, false, context, propertyBreadcrumbs, source, namespace),
      groupName
    });
    const conflicts = {};
    for (const parent of parents) {
      const parentPropertySchema = parent.properties[propertyName];
      if (parentPropertySchema != null && !isSchemaWithExampleEqual(schema2, parentPropertySchema)) {
        conflicts[parent.schemaId] = { differentSchema: true };
      } else if (parentPropertySchema != null) {
        conflicts[parent.schemaId] = { differentSchema: false };
      }
    }
    return {
      key: propertyName,
      schema: schema2,
      nameOverride: propertyNameOverride,
      audiences,
      conflict: conflicts,
      generatedName: getGeneratedPropertyName([...breadcrumbs, propertyName]),
      availability: availability2,
      readonly
    };
  });
  convertedProperties.push(...inlinedParentProperties.map((property4) => {
    const conflicts = property4.conflict;
    for (const parent of parents) {
      const parentPropertySchema = parent.properties[property4.key];
      if (parentPropertySchema != null && !isSchemaWithExampleEqual(property4.schema, parentPropertySchema)) {
        conflicts[parent.schemaId] = { differentSchema: true };
      } else if (parentPropertySchema != null) {
        conflicts[parent.schemaId] = { differentSchema: false };
      }
    }
    return {
      ...property4,
      conflict: conflicts
    };
  }));
  return wrapObject({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    properties: convertedProperties.filter((objectProperty) => {
      return !propertiesToExclude.has(objectProperty.key);
    }),
    description,
    allOf: parents.map((parent) => parent.convertedSchema),
    allOfPropertyConflicts,
    groupName,
    fullExamples,
    additionalProperties,
    availability,
    source
  });
}
function wrapObject({ nameOverride, generatedName, title, wrapAsNullable, properties, description, allOf, allOfPropertyConflicts, groupName, fullExamples, additionalProperties, availability, source }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.object({
        description,
        properties,
        nameOverride,
        generatedName,
        title,
        allOf,
        allOfPropertyConflicts,
        groupName,
        fullExamples,
        additionalProperties: isAdditionalPropertiesAny(additionalProperties),
        availability: void 0,
        source
      }),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.object({
    description,
    properties,
    nameOverride,
    generatedName,
    title,
    allOf,
    allOfPropertyConflicts,
    groupName,
    fullExamples,
    additionalProperties: isAdditionalPropertiesAny(additionalProperties),
    availability,
    source
  });
}
function getAllProperties({ schema: schema2, context, breadcrumbs, source, namespace }) {
  let properties = {};
  const [resolvedSchema, resolvedBreadCrumbs] = isReferenceObject(schema2) ? [context.resolveSchemaReference(schema2), getBreadcrumbsFromReference(schema2.$ref)] : [schema2, breadcrumbs];
  for (const allOfElement of resolvedSchema.allOf ?? []) {
    properties = {
      ...properties,
      ...getAllProperties({ schema: allOfElement, context, breadcrumbs: resolvedBreadCrumbs, source, namespace })
    };
  }
  for (const [propertyName, propertySchema] of Object.entries(resolvedSchema.properties ?? {})) {
    const convertedPropertySchema = convertSchema(propertySchema, false, context, [...resolvedBreadCrumbs, propertyName], source, namespace);
    properties[propertyName] = convertedPropertySchema;
  }
  return properties;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertUndiscriminatedOneOf.js
function convertUndiscriminatedOneOf({ nameOverride, generatedName, title, breadcrumbs, description, availability, wrapAsNullable, context, subtypes, groupName, encoding, source, subtypePrefixOverrides, namespace }) {
  const derivedSubtypePrefixes = getUniqueSubTypeNames({ schemas: subtypes });
  const convertedSubtypes = subtypes.flatMap((schema2, index) => {
    if (!isReferenceObject(schema2) && schema2.enum != null && context.options.cooerceEnumsToLiterals) {
      return schema2.enum.map((enumValue) => {
        return SchemaWithExample.literal({
          nameOverride: void 0,
          generatedName: getGeneratedTypeName([generatedName, enumValue], context.options.preserveSchemaIds),
          title: void 0,
          value: LiteralSchemaValue.string(enumValue),
          groupName: void 0,
          description: void 0,
          availability: enumValue.availability
        });
      });
    }
    let subtypePrefix = derivedSubtypePrefixes[index];
    if (subtypePrefixOverrides != null) {
      const override = subtypePrefixOverrides[index];
      if (override != null && "name" in override) {
        subtypePrefix = override.name;
      }
    }
    return [
      convertSchema(schema2, false, context, [...breadcrumbs, subtypePrefix ?? `${index}`], source, namespace)
    ];
  });
  const uniqueSubtypes = [];
  for (let i = 0; i < convertedSubtypes.length; ++i) {
    const a = convertedSubtypes[i];
    let isDuplicate = false;
    for (let j = i + 1; j < convertedSubtypes.length; ++j) {
      const b = convertedSubtypes[j];
      if (a != null && b != null && isSchemaEqual(a, b)) {
        isDuplicate = true;
        break;
      }
    }
    if (a != null && !isDuplicate) {
      uniqueSubtypes.push(a);
    }
  }
  const everySubTypeIsLiteral = Object.entries(uniqueSubtypes).every(([_, schema2]) => {
    return schema2.type === "literal";
  });
  if (everySubTypeIsLiteral) {
    const enumDescriptions = {};
    const enumValues = [];
    Object.entries(uniqueSubtypes).forEach(([_, schema2]) => {
      if (schema2.type === "literal" && schema2.value.type === "string") {
        enumValues.push(schema2.value.value);
        if (schema2.description != null) {
          enumDescriptions[schema2.value.value] = {
            description: schema2.description
          };
        }
      }
    });
    return convertEnum({
      nameOverride,
      generatedName,
      title,
      wrapAsNullable,
      description,
      availability,
      fernEnum: enumDescriptions,
      enumVarNames: void 0,
      enumValues,
      _default: void 0,
      groupName,
      context,
      source
    });
  }
  if (uniqueSubtypes.length === 1 && uniqueSubtypes[0] != null) {
    return uniqueSubtypes[0];
  }
  return wrapUndiscriminantedOneOf({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    description,
    availability,
    subtypes: uniqueSubtypes,
    groupName,
    encoding,
    source
  });
}
function convertUndiscriminatedOneOfWithDiscriminant({ nameOverride, generatedName, title, description, availability, wrapAsNullable, context, groupName, discriminator, encoding, source, namespace }) {
  const convertedSubtypes = Object.entries(discriminator.mapping ?? {}).map(([discriminantValue, schema2], index) => {
    const subtypeReferenceSchema = {
      $ref: schema2
    };
    const subtypeReference = convertReferenceObject(subtypeReferenceSchema, false, context, [schema2], encoding, source, namespace);
    context.markSchemaWithDiscriminantValue(subtypeReferenceSchema, discriminator.propertyName, discriminantValue);
    if (subtypeReference.type === "object") {
      subtypeReference.properties = {
        [discriminator.propertyName]: SchemaWithExample.literal({
          nameOverride: void 0,
          generatedName: getGeneratedTypeName([generatedName, discriminantValue], context.options.preserveSchemaIds),
          title: void 0,
          value: LiteralSchemaValue.string(discriminantValue),
          groupName: void 0,
          description: void 0,
          availability: void 0
        }),
        ...subtypeReference.properties.filter((objectProperty) => {
          return objectProperty.key !== discriminator.propertyName;
        })
      };
    }
    return subtypeReference;
  });
  const uniqueSubtypes = [];
  for (let i = 0; i < convertedSubtypes.length; ++i) {
    const a = convertedSubtypes[i];
    let isDuplicate = false;
    for (let j = i + 1; j < convertedSubtypes.length; ++j) {
      const b = convertedSubtypes[j];
      if (a != null && b != null && isSchemaEqual(a, b)) {
        isDuplicate = true;
        break;
      }
    }
    if (a != null && !isDuplicate) {
      uniqueSubtypes.push(a);
    }
  }
  const everySubTypeIsLiteral = Object.entries(uniqueSubtypes).every(([_, schema2]) => {
    return schema2.type === "literal";
  });
  if (everySubTypeIsLiteral) {
    const enumDescriptions = {};
    const enumValues = [];
    Object.entries(uniqueSubtypes).forEach(([_, schema2]) => {
      if (schema2.type === "literal" && schema2.value.type === "string") {
        enumValues.push(schema2.value.value);
        if (schema2.description != null) {
          enumDescriptions[schema2.value.value] = {
            description: schema2.description
          };
        }
      }
    });
    return convertEnum({
      nameOverride,
      generatedName,
      title,
      wrapAsNullable,
      description,
      availability,
      fernEnum: enumDescriptions,
      enumVarNames: void 0,
      enumValues,
      _default: void 0,
      groupName,
      context,
      source
    });
  }
  if (uniqueSubtypes.length === 1 && uniqueSubtypes[0] != null) {
    return uniqueSubtypes[0];
  }
  return wrapUndiscriminantedOneOf({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    description,
    availability,
    subtypes: uniqueSubtypes,
    groupName,
    encoding,
    source
  });
}
function getUniqueSubTypeNames({ schemas }) {
  let uniquePropertySets = {};
  let index = 0;
  for (const schema2 of schemas) {
    if (isReferenceObject(schema2)) {
    } else if (schema2.properties != null && Object.entries(schema2.properties).length > 0) {
      const schemaProperties = Object.keys(schema2.properties);
      const updatedPropertySets = {};
      let uniqueSchemaProperties = schemaProperties;
      for (const [key, uniquePropertySet] of Object.entries(uniquePropertySets)) {
        const updatedSet = difference_default(uniquePropertySet, schemaProperties);
        uniqueSchemaProperties = difference_default(uniqueSchemaProperties, uniquePropertySet);
        updatedPropertySets[key] = updatedSet;
      }
      updatedPropertySets[index] = uniqueSchemaProperties;
      uniquePropertySets = updatedPropertySets;
    }
    index++;
  }
  const prefixes = [];
  let i = 0;
  for (const schema2 of schemas) {
    const propertySet = uniquePropertySets[i];
    if (propertySet != null && propertySet.length > 0) {
      const sortedProperties = propertySet.sort();
      if (sortedProperties[0] != null) {
        prefixes.push(sortedProperties[0]);
        ++i;
        continue;
      }
    }
    if (isReferenceObject(schema2)) {
      prefixes.push(convertNumberToSnakeCase(i) ?? `${i}`);
    } else if (schema2.type === "array" || schema2.type === "boolean" || schema2.type === "integer" || schema2.type === "number" || schema2.type === "string") {
      prefixes.push("");
    } else {
      prefixes.push(convertNumberToSnakeCase(i) ?? `${i}`);
    }
    ++i;
  }
  return prefixes;
}
function wrapUndiscriminantedOneOf({ nameOverride, generatedName, title, wrapAsNullable, description, availability, subtypes, groupName, encoding, source }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.oneOf(OneOfSchemaWithExample.undisciminated({
        description,
        availability,
        nameOverride,
        generatedName,
        title,
        schemas: subtypes,
        groupName,
        encoding,
        source
      })),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.oneOf(OneOfSchemaWithExample.undisciminated({
    description,
    availability,
    nameOverride,
    generatedName,
    title,
    schemas: subtypes,
    groupName,
    encoding,
    source
  }));
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/defaults/getDefault.js
function getDefaultAsString(schema2) {
  if (schema2.default != null && typeof schema2.default === "string") {
    return schema2.default;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/examples/getExample.js
function getExampleAsNumber({ schema: schema2, logger, fallback }) {
  if (schema2.example != null && typeof schema2.example === "number") {
    return schema2.example;
  }
  const examples = getExamples(schema2);
  for (const example of examples ?? []) {
    if (typeof example === "number") {
      return example;
    }
  }
  if (fallback && typeof fallback === "number") {
    return fallback;
  }
  return void 0;
}
function getExampleAsBoolean({ schema: schema2, logger, fallback }) {
  if (schema2.example != null && typeof schema2.example === "boolean") {
    return schema2.example;
  }
  const examples = getExamples(schema2);
  for (const example of examples ?? []) {
    if (typeof example === "boolean") {
      return example;
    }
  }
  if (fallback && typeof fallback === "boolean") {
    return fallback;
  }
  return void 0;
}
function getExamplesString({ schema: schema2, logger, fallback }) {
  if (schema2.example != null && typeof schema2.example === "string") {
    return schema2.example;
  }
  const examples = getExamples(schema2);
  for (const example of examples ?? []) {
    if (typeof example === "string") {
      return example;
    }
  }
  if (fallback && typeof fallback === "string") {
    return fallback;
  }
  return void 0;
}
function getExampleAsArray({ schema: schema2, logger, fallback }) {
  if (schema2.example != null && Array.isArray(schema2.example)) {
    return schema2.example;
  }
  const examples = getExamples(schema2);
  for (const example of examples ?? []) {
    if (Array.isArray(example)) {
      return example;
    }
  }
  if (fallback && Array.isArray(fallback)) {
    return fallback;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertSchemas.js
var SCHEMA_REFERENCE_PREFIX = "#/components/schemas/";
function convertSchema(schema2, wrapAsNullable, context, breadcrumbs, source, namespace, referencedAsRequest = false, propertiesToExclude = /* @__PURE__ */ new Set(), fallback) {
  const encoding = getEncoding({ schema: schema2, logger: context.logger });
  if (isReferenceObject(schema2)) {
    const schemaId = getSchemaIdFromReference(schema2);
    if (schemaId != null) {
      if (!referencedAsRequest) {
        context.markSchemaAsReferencedByNonRequest(schemaId);
      } else {
        context.markSchemaAsReferencedByRequest(schemaId);
      }
      return convertReferenceObject(schema2, wrapAsNullable, context, breadcrumbs, encoding, source, namespace);
    }
    return convertSchemaObject(context.resolveSchemaReference(schema2), wrapAsNullable, context, getBreadcrumbsFromReference(schema2.$ref), encoding, source, namespace, propertiesToExclude, referencedAsRequest, fallback);
  }
  return convertSchemaObject(schema2, wrapAsNullable, context, breadcrumbs, encoding, source, namespace, propertiesToExclude, referencedAsRequest, fallback);
}
function convertReferenceObject(schema2, wrapAsNullable, context, breadcrumbs, encoding, source, namespace) {
  const referenceSchema = schema2.$ref.includes("properties") ? convertSchemaObject(context.resolveSchemaReference(schema2), wrapAsNullable, context, breadcrumbs, encoding, source, namespace, /* @__PURE__ */ new Set()) : SchemaWithExample.reference(convertToReferencedSchema(schema2, breadcrumbs, source, context.options.preserveSchemaIds));
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      title: void 0,
      nameOverride: void 0,
      generatedName: getGeneratedTypeName(breadcrumbs, context.options.preserveSchemaIds),
      value: referenceSchema,
      description: void 0,
      availability: void 0,
      groupName: void 0
    });
  } else {
    return referenceSchema;
  }
}
function getTitleAsName(title) {
  if (title == null) {
    return void 0;
  }
  if (title.includes(" ")) {
    return void 0;
  }
  if (!/^[a-zA-Z]+$/.test(title)) {
    return void 0;
  }
  return title;
}
function convertSchemaObject(schema2, wrapAsNullable, context, breadcrumbs, encoding, source, namespace, propertiesToExclude = /* @__PURE__ */ new Set(), referencedAsRequest = false, fallback) {
  const nameOverride = getExtension(schema2, FernOpenAPIExtension.TYPE_NAME) ?? (context.options.useTitlesAsName ? getTitleAsName(schema2.title) : void 0);
  const mixedGroupName = getExtension(schema2, FernOpenAPIExtension.SDK_GROUP_NAME) ?? getExtension(schema2, OpenAPIExtension.TAGS)?.[0];
  let groupName = (typeof mixedGroupName === "string" ? [mixedGroupName] : mixedGroupName) ?? [];
  groupName = context.resolveGroupName(groupName);
  const generatedName = getGeneratedTypeName(breadcrumbs, context.options.preserveSchemaIds);
  const title = schema2.title;
  const description = schema2.description;
  const availability = convertAvailability3(schema2);
  const fullExamples = [];
  if (schema2.example != null) {
    fullExamples.push({ name: void 0, value: schema2.example, description: void 0 });
  }
  const xExamples = getExtension(schema2, OpenAPIExtension.EXAMPLES);
  if (xExamples != null && Object.keys(xExamples).length > 0) {
    fullExamples.push(...Object.entries(xExamples).map(([name, value]) => {
      return { name: value?.summary ?? name, value: value.value, description: value.description };
    }));
  }
  const examples = getExamples(schema2);
  if (examples != null && Object.keys(examples).length > 0) {
    fullExamples.push(...examples.map((value) => {
      return { name: void 0, value, description: void 0 };
    }));
  }
  const fernSchema = getFernTypeExtension({ schema: schema2, description, title, nameOverride, generatedName, availability });
  if (fernSchema != null) {
    return fernSchema;
  }
  if (!wrapAsNullable && schema2.nullable === true) {
    return convertSchemaObject(schema2, true, context, breadcrumbs, encoding, source, namespace, propertiesToExclude, referencedAsRequest, fallback);
  }
  if (schema2.enum != null && (schema2.type === "string" || schema2.type == null)) {
    if (!isListOfStrings(schema2.enum)) {
      return wrapPrimitive({
        nameOverride,
        generatedName,
        title,
        primitive: PrimitiveSchemaValueWithExample.string({
          default: getDefaultAsString(schema2),
          minLength: schema2.minLength,
          maxLength: schema2.maxLength,
          pattern: schema2.pattern,
          format: schema2.format,
          example: getExamplesString({ schema: schema2, logger: context.logger, fallback })
        }),
        groupName,
        wrapAsNullable,
        description,
        availability
      });
    }
    const fernEnum = getFernEnum(schema2);
    if (schema2.enum.length === 1 && schema2.enum[0] != null && fernEnum == null) {
      return convertLiteral({
        nameOverride,
        generatedName,
        title,
        wrapAsNullable,
        value: schema2.enum[0],
        description,
        availability,
        groupName
      });
    }
    return convertEnum({
      nameOverride,
      generatedName,
      title,
      fernEnum,
      enumVarNames: getExtension(schema2, [OpenAPIExtension.ENUM_VAR_NAMES]),
      enumValues: schema2.enum,
      _default: schema2.default,
      description,
      availability,
      wrapAsNullable,
      groupName,
      context,
      source
    });
  }
  if (isListOfStrings(schema2.type) && schema2.type[1] != null && schema2.type[0] != null) {
    const firstElement = schema2.type[0];
    const secondElement = schema2.type[1];
    if (firstElement === "null") {
      return SchemaWithExample.nullable({
        nameOverride,
        generatedName,
        title,
        value: convertSchemaObject({
          ...schema2,
          type: secondElement
        }, wrapAsNullable, context, breadcrumbs, encoding, source, namespace, propertiesToExclude, referencedAsRequest, fallback),
        groupName,
        description: schema2.description,
        availability
      });
    } else if (secondElement === "null") {
      return SchemaWithExample.nullable({
        nameOverride,
        generatedName,
        title,
        value: convertSchemaObject({
          ...schema2,
          type: firstElement
        }, wrapAsNullable, context, breadcrumbs, encoding, source, namespace, propertiesToExclude, referencedAsRequest, fallback),
        groupName,
        description: schema2.description,
        availability
      });
    }
  }
  if (isListOfStrings(schema2.type) && schema2.type.length > 1) {
    const wrapVariantAsNullable = schema2.type.includes("null");
    const subtypes = schema2.type.filter((val) => val !== "null").map((type2) => {
      return {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        type: type2,
        nullable: wrapVariantAsNullable
      };
    });
    return convertUndiscriminatedOneOf({
      nameOverride,
      generatedName,
      title,
      breadcrumbs,
      description,
      availability,
      wrapAsNullable,
      context,
      subtypes,
      groupName,
      encoding,
      source,
      namespace
    });
  }
  if (schema2 === "boolean" || schema2.type === "boolean") {
    const literalValue = getExtension(schema2, FernOpenAPIExtension.BOOLEAN_LITERAL);
    if (literalValue != null) {
      return wrapLiteral({
        nameOverride,
        generatedName,
        title,
        literal: LiteralSchemaValue.boolean(literalValue),
        wrapAsNullable,
        description,
        availability,
        groupName
      });
    }
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.boolean({
        default: schema2.default,
        example: getExampleAsBoolean({ schema: schema2, logger: context.logger, fallback })
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  }
  if (schema2 === "number" || schema2.type === "number") {
    return convertNumber({
      nameOverride,
      generatedName,
      title,
      format: schema2.format,
      _default: schema2.default,
      minimum: schema2.minimum,
      maximum: schema2.maximum,
      exclusiveMinimum: getValueIfBoolean(schema2.exclusiveMinimum),
      exclusiveMaximum: getValueIfBoolean(schema2.exclusiveMaximum),
      multipleOf: schema2.multipleOf,
      description,
      availability,
      wrapAsNullable,
      example: getExampleAsNumber({ schema: schema2, logger: context.logger, fallback }),
      groupName
    });
  }
  if (schema2 === "integer" || schema2.type === "integer") {
    return convertInteger({
      nameOverride,
      generatedName,
      title,
      format: schema2.format,
      _default: schema2.default,
      minimum: schema2.minimum,
      maximum: schema2.maximum,
      exclusiveMinimum: getValueIfBoolean(schema2.exclusiveMinimum),
      exclusiveMaximum: getValueIfBoolean(schema2.exclusiveMaximum),
      multipleOf: schema2.multipleOf,
      description,
      availability,
      wrapAsNullable,
      example: getExampleAsNumber({ schema: schema2, logger: context.logger, fallback }),
      groupName
    });
  }
  if (schema2 === "float") {
    return convertNumber({
      nameOverride,
      generatedName,
      title,
      format: "float",
      _default: schema2.default,
      minimum: schema2.minimum,
      maximum: schema2.maximum,
      exclusiveMinimum: getValueIfBoolean(schema2.exclusiveMinimum),
      exclusiveMaximum: getValueIfBoolean(schema2.exclusiveMaximum),
      multipleOf: schema2.multipleOf,
      description,
      availability,
      wrapAsNullable,
      example: getExampleAsNumber({ schema: schema2, logger: context.logger, fallback }),
      groupName
    });
  }
  if (schema2 === "string" || schema2.type === "string") {
    if (schema2.format === "date-time") {
      return wrapPrimitive({
        nameOverride,
        generatedName,
        title,
        primitive: PrimitiveSchemaValueWithExample.datetime({
          example: getExamplesString({ schema: schema2, logger: context.logger, fallback })
        }),
        wrapAsNullable,
        description,
        availability,
        groupName
      });
    } else if (schema2.format === "json-string") {
      return SchemaWithExample.unknown({
        nameOverride,
        generatedName,
        title,
        description,
        availability,
        groupName,
        example: void 0
      });
    }
    const maybeConstValue = getProperty(schema2, "const");
    if (maybeConstValue != null) {
      return wrapLiteral({
        nameOverride,
        generatedName,
        title,
        literal: LiteralSchemaValue.string(maybeConstValue),
        wrapAsNullable,
        description,
        availability,
        groupName
      });
    }
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.string({
        default: getDefaultAsString(schema2),
        pattern: schema2.pattern,
        format: schema2.format,
        minLength: schema2.minLength,
        maxLength: schema2.maxLength,
        example: getExamplesString({ schema: schema2, logger: context.logger, fallback })
      }),
      groupName,
      wrapAsNullable,
      description,
      availability
    });
  }
  if (schema2.type === "array") {
    return convertArray({
      nameOverride,
      generatedName,
      title,
      breadcrumbs,
      item: schema2.items,
      description,
      availability,
      wrapAsNullable,
      context,
      groupName,
      example: getExampleAsArray({ schema: schema2, logger: context.logger, fallback }),
      source,
      namespace
    });
  }
  if (schema2.additionalProperties != null && schema2.additionalProperties !== false && hasNoProperties(schema2)) {
    return convertAdditionalProperties({
      nameOverride,
      generatedName,
      title,
      breadcrumbs,
      additionalProperties: schema2.additionalProperties,
      description,
      availability,
      wrapAsNullable,
      context,
      groupName,
      encoding,
      example: schema2.example,
      source,
      namespace
    });
  }
  if (schema2.type === "object" && schema2.discriminator != null && schema2.discriminator.mapping != null) {
    if (!context.options.discriminatedUnionV2) {
      return convertDiscriminatedOneOf({
        nameOverride,
        generatedName,
        title,
        breadcrumbs,
        description,
        availability,
        discriminator: schema2.discriminator,
        properties: schema2.properties ?? {},
        required: schema2.required,
        wrapAsNullable,
        context,
        groupName,
        encoding,
        source,
        namespace
      });
    } else {
      return convertUndiscriminatedOneOfWithDiscriminant({
        nameOverride,
        generatedName,
        title,
        description,
        availability,
        wrapAsNullable,
        context,
        groupName,
        discriminator: schema2.discriminator,
        encoding,
        source,
        namespace
      });
    }
  }
  if (Array.isArray(schema2.type)) {
    if (schema2.oneOf == null) {
      schema2.oneOf = schema2.type;
    } else {
      schema2.oneOf.push(...schema2.type);
    }
  }
  if (schema2.oneOf != null && schema2.oneOf.length > 0) {
    const isUndiscriminated = getExtension(schema2, FernOpenAPIExtension.IS_UNDISCRIMINATED);
    if (schema2.discriminator != null && schema2.discriminator.mapping != null && Object.keys(schema2.discriminator.mapping).length > 0) {
      if (context.options.discriminatedUnionV2 || isUndiscriminated) {
        return convertUndiscriminatedOneOfWithDiscriminant({
          nameOverride,
          generatedName,
          title,
          description,
          availability,
          wrapAsNullable,
          context,
          groupName,
          discriminator: schema2.discriminator,
          encoding,
          source,
          namespace
        });
      } else {
        return convertDiscriminatedOneOf({
          nameOverride,
          generatedName,
          title,
          breadcrumbs,
          description,
          availability,
          discriminator: schema2.discriminator,
          properties: schema2.properties ?? {},
          required: schema2.required,
          wrapAsNullable,
          context,
          groupName,
          encoding,
          source,
          namespace
        });
      }
    } else if (schema2.oneOf.length === 1 && schema2.oneOf[0] != null) {
      const convertedSchema = convertSchema(schema2.oneOf[0], wrapAsNullable, context, breadcrumbs, source, namespace, referencedAsRequest);
      return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
    } else if (schema2.oneOf.length > 1) {
      if (schema2.oneOf.length === 2 && schema2.oneOf[0] != null && schema2.oneOf[1] != null) {
        const firstSchema = schema2.oneOf[0];
        const secondSchema = schema2.oneOf[1];
        if (!isReferenceObject(firstSchema) && firstSchema.type === "null") {
          return convertSchema(secondSchema, true, context, breadcrumbs, source, namespace);
        } else if (!isReferenceObject(secondSchema) && secondSchema.type === "null") {
          return convertSchema(firstSchema, true, context, breadcrumbs, source, namespace);
        }
      }
      const maybeAllEnumValues = getMaybeAllEnumValues({ schemas: schema2.oneOf });
      if (maybeAllEnumValues != null) {
        return convertEnum({
          nameOverride,
          generatedName,
          title,
          fernEnum: void 0,
          enumVarNames: void 0,
          enumValues: maybeAllEnumValues,
          _default: schema2.default,
          description,
          availability,
          wrapAsNullable,
          groupName,
          context,
          source
        });
      }
      const maybeDiscriminant = getDiscriminant({ schemas: schema2.oneOf, context });
      if (maybeDiscriminant != null && !context.options.discriminatedUnionV2 && !isUndiscriminated) {
        return convertDiscriminatedOneOfWithVariants({
          nameOverride,
          generatedName,
          title,
          breadcrumbs,
          properties: schema2.properties ?? {},
          required: schema2.required,
          description,
          availability,
          wrapAsNullable,
          discriminant: maybeDiscriminant.discriminant,
          variants: maybeDiscriminant.schemas,
          context,
          groupName,
          encoding,
          source,
          namespace
        });
      }
      const hasNullValue = schema2.oneOf.filter((schema3) => {
        return !isReferenceObject(schema3) && schema3.type === "null";
      }).length > 0;
      return convertUndiscriminatedOneOf({
        nameOverride,
        generatedName,
        title,
        breadcrumbs,
        description,
        availability,
        wrapAsNullable: wrapAsNullable || hasNullValue,
        context,
        subtypes: schema2.oneOf.filter((schema3) => {
          return isReferenceObject(schema3) || schema3.type !== "null";
        }),
        encoding,
        groupName,
        source,
        namespace
      });
    }
  }
  if (schema2.anyOf != null && schema2.anyOf.length > 0) {
    if (schema2.anyOf.length === 1 && schema2.anyOf[0] != null) {
      const convertedSchema = convertSchema(schema2.anyOf[0], wrapAsNullable, context, breadcrumbs, source, namespace, referencedAsRequest);
      return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
    }
    if (schema2.anyOf.length === 2) {
      const [firstSchema, secondSchema] = schema2.anyOf;
      if (firstSchema != null && secondSchema != null) {
        if (!isReferenceObject(firstSchema) && firstSchema.type === "null") {
          const convertedSchema = convertSchema(secondSchema, true, context, breadcrumbs, source, namespace);
          return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
        } else if (!isReferenceObject(secondSchema) && secondSchema.type === "null") {
          const convertedSchema = convertSchema(firstSchema, true, context, breadcrumbs, source, namespace);
          return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
        }
      }
    }
    const maybeDiscriminant = getDiscriminant({
      schemas: schema2.anyOf,
      context
    });
    if (maybeDiscriminant != null && !context.options.discriminatedUnionV2) {
      return convertDiscriminatedOneOfWithVariants({
        nameOverride,
        generatedName,
        title,
        breadcrumbs,
        properties: schema2.properties ?? {},
        required: schema2.required,
        description,
        availability,
        wrapAsNullable,
        discriminant: maybeDiscriminant.discriminant,
        variants: maybeDiscriminant.schemas,
        context,
        groupName,
        encoding,
        source,
        namespace
      });
    }
    const hasNullValue = schema2.anyOf.filter((schema3) => {
      return !isReferenceObject(schema3) && schema3.type === "null";
    }).length > 0;
    return convertUndiscriminatedOneOf({
      nameOverride,
      generatedName,
      title,
      breadcrumbs,
      description,
      availability,
      wrapAsNullable: wrapAsNullable || hasNullValue,
      context,
      subtypes: schema2.anyOf.filter((schema3) => {
        return isReferenceObject(schema3) || schema3.type !== "null";
      }),
      encoding,
      groupName,
      source,
      namespace
    });
  }
  if (schema2.allOf != null || schema2.properties != null) {
    const filteredAllOfs = [];
    for (const allOf of schema2.allOf ?? []) {
      if (isReferenceObject(allOf) || Object.keys(allOf).length > 0) {
        filteredAllOfs.push(allOf);
      }
    }
    if ((schema2.properties == null || schema2.properties.length === 0) && filteredAllOfs.length === 1 && filteredAllOfs[0] != null) {
      const convertedSchema = convertSchema(filteredAllOfs[0], wrapAsNullable, context, breadcrumbs, source, namespace, referencedAsRequest);
      return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
    }
    const filteredAllOfObjects = filteredAllOfs.filter((allOf) => {
      const valid = isValidAllOfObject(allOf);
      if (!valid) {
        context.logger.warn(`Skipping non-object allOf element: ${JSON.stringify(allOf)}`);
      }
      return valid;
    });
    if ((schema2.properties == null || schema2.properties.length === 0) && filteredAllOfObjects.length === 1 && filteredAllOfObjects[0] != null) {
      const convertedSchema = convertSchema(filteredAllOfObjects[0], wrapAsNullable, context, breadcrumbs, source, namespace, referencedAsRequest);
      return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
    }
    return convertObject3({
      nameOverride,
      generatedName,
      title,
      breadcrumbs,
      properties: schema2.properties ?? {},
      description,
      required: schema2.required,
      wrapAsNullable,
      allOf: filteredAllOfObjects,
      context,
      propertiesToExclude,
      groupName,
      fullExamples,
      additionalProperties: schema2.additionalProperties,
      availability,
      encoding,
      source,
      namespace
    });
  }
  if (schema2.type === "object" && hasNoOneOf(schema2) && hasNoAllOf(schema2) && hasNoProperties(schema2)) {
    return wrapMap({
      nameOverride,
      generatedName,
      title,
      description,
      availability,
      wrapAsNullable,
      keySchema: {
        nameOverride: void 0,
        generatedName: `${generatedName}Key`,
        title: void 0,
        description: void 0,
        availability: void 0,
        schema: PrimitiveSchemaValueWithExample.string({
          default: getDefaultAsString(schema2),
          pattern: schema2.pattern,
          format: schema2.format,
          minLength: schema2.minLength,
          maxLength: schema2.maxLength,
          example: getExamplesString({ schema: schema2, logger: context.logger, fallback })
        }),
        groupName
      },
      valueSchema: SchemaWithExample.unknown({
        nameOverride: void 0,
        generatedName: `${generatedName}Value`,
        title: void 0,
        description: void 0,
        availability: void 0,
        example: void 0,
        groupName
      }),
      groupName,
      encoding,
      example: schema2.example
    });
  }
  if (schema2.type == null) {
    const inferredValue = schema2.example ?? schema2.default;
    return SchemaWithExample.unknown({
      nameOverride,
      generatedName,
      title,
      description,
      availability,
      groupName,
      example: inferredValue
    });
  }
  throw new Error(`Failed to convert schema breadcrumbs=${JSON.stringify(breadcrumbs)} value=${JSON.stringify(schema2)}`);
}
function getSchemaIdFromReference(ref) {
  if (!ref.$ref.startsWith(SCHEMA_REFERENCE_PREFIX)) {
    return void 0;
  }
  return ref.$ref.replace(SCHEMA_REFERENCE_PREFIX, "");
}
function convertToReferencedSchema(schema2, breadcrumbs, source, preserveSchemaIds) {
  const nameOverride = getExtension(schema2, FernOpenAPIExtension.TYPE_NAME);
  const generatedName = getGeneratedTypeName(breadcrumbs, preserveSchemaIds);
  const description = schema2.description;
  const availability = convertAvailability3(schema2);
  const schemaId = getSchemaIdFromReference(schema2);
  if (schemaId == null) {
    throw new Error(`Invalid schema reference ${JSON.stringify(schema2)}`);
  }
  return Schema.reference({
    // TODO(dsinghvi): references may contain files
    generatedName,
    nameOverride,
    title: void 0,
    schema: schemaId,
    description: description ?? void 0,
    availability,
    groupName: void 0,
    source
  });
}
function hasNoOneOf(schema2) {
  return schema2.oneOf == null || schema2.oneOf.length === 0;
}
function hasNoAllOf(schema2) {
  return schema2.allOf == null || schema2.allOf.length === 0;
}
function hasNoProperties(schema2) {
  return schema2.properties == null || Object.keys(schema2.properties).length === 0;
}
function isListOfStrings(x) {
  return Array.isArray(x) && x.every((item) => typeof item === "string");
}
function maybeInjectDescriptionOrGroupName(schema2, description, groupName) {
  if (schema2.type === "reference") {
    return SchemaWithExample.reference({
      ...schema2,
      description,
      availability: schema2.availability,
      groupName
    });
  } else if (schema2.type === "optional") {
    return SchemaWithExample.optional({
      nameOverride: schema2.nameOverride,
      generatedName: schema2.generatedName,
      title: schema2.title,
      value: schema2.value,
      description,
      availability: schema2.availability,
      groupName
    });
  } else if (schema2.type === "nullable") {
    return SchemaWithExample.nullable({
      nameOverride: schema2.nameOverride,
      generatedName: schema2.generatedName,
      title: schema2.title,
      value: schema2.value,
      description,
      availability: schema2.availability,
      groupName
    });
  }
  return schema2;
}
function isValidAllOfObject(allOf) {
  if (isReferenceObject(allOf) || allOf.type === "object" || allOf.properties != null) {
    return true;
  }
  if (allOf.allOf != null) {
    return allOf.allOf.every((elem) => isValidAllOfObject(elem));
  }
  if (allOf.oneOf != null) {
    return allOf.oneOf.every((elem) => isValidAllOfObject(elem));
  }
  if (allOf.anyOf != null) {
    return allOf.anyOf.every((elem) => isValidAllOfObject(elem));
  }
  return false;
}
function wrapLiteral({ literal, wrapAsNullable, groupName, description, availability, nameOverride, generatedName, title }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.literal({
        nameOverride,
        generatedName,
        title,
        value: literal,
        description,
        availability,
        groupName
      }),
      groupName,
      description,
      availability
    });
  }
  return SchemaWithExample.literal({
    nameOverride,
    generatedName,
    title,
    value: literal,
    groupName,
    description,
    availability
  });
}
function wrapPrimitive({ primitive, wrapAsNullable, groupName, description, availability, generatedName, nameOverride, title }) {
  groupName = typeof groupName === "string" ? [groupName] : groupName;
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.primitive({
        nameOverride,
        generatedName,
        title,
        schema: primitive,
        description,
        availability,
        groupName
      }),
      groupName,
      description,
      availability
    });
  }
  return SchemaWithExample.primitive({
    nameOverride,
    generatedName,
    title,
    schema: primitive,
    description,
    availability,
    groupName
  });
}
function getMaybeAllEnumValues({ schemas }) {
  const enumValues = /* @__PURE__ */ new Set();
  for (const schema2 of schemas) {
    if (isReferenceObject(schema2)) {
      return void 0;
    }
    if (schema2.enum != null && isListOfStrings(schema2.enum)) {
      schema2.enum.forEach((val) => enumValues.add(val));
    } else {
      return void 0;
    }
  }
  return Array.from(enumValues);
}
function getDiscriminant({ schemas, context }) {
  const discriminantToVariants = {};
  for (const schema2 of schemas) {
    const possibleDiscriminants = getPossibleDiscriminants({ schema: schema2, context });
    for (const [property4, value] of Object.entries(possibleDiscriminants)) {
      const variants = discriminantToVariants[property4];
      if (variants != null) {
        variants[value] = schema2;
      } else {
        discriminantToVariants[property4] = {
          [value]: schema2
        };
      }
    }
  }
  for (const [discriminant3, variants] of Object.entries(discriminantToVariants)) {
    if (Object.keys(variants).length === schemas.length) {
      return {
        discriminant: discriminant3,
        schemas: variants
      };
    }
  }
  return void 0;
}
function getPossibleDiscriminants({ schema: schema2, context }) {
  const resolvedSchema = isReferenceObject(schema2) ? context.resolveSchemaReference(schema2) : schema2;
  return getPossibleDiscriminantsForSchemaObject({ schema: resolvedSchema, context });
}
function getPossibleDiscriminantsForSchemaObject({ schema: schema2, context }) {
  const possibleDiscrimimants = {};
  if (schema2.anyOf != null) {
    for (const elem of schema2.anyOf) {
      const possibleDiscriminantsForVariant = getPossibleDiscriminants({
        schema: elem,
        context
      });
      for (const [key, value] of Object.entries(possibleDiscriminantsForVariant ?? {})) {
        possibleDiscrimimants[key] = value;
      }
    }
    return possibleDiscrimimants;
  }
  for (const [propertyName, propertySchema] of Object.entries(schema2.properties ?? {})) {
    const resolvedPropertySchema = isReferenceObject(propertySchema) ? context.resolveSchemaReference(propertySchema) : propertySchema;
    if (resolvedPropertySchema.type === "string" && resolvedPropertySchema.enum != null && isListOfStrings(resolvedPropertySchema.enum) && getEnumSet(resolvedPropertySchema.enum).length === 1 && resolvedPropertySchema.enum[0] != null) {
      possibleDiscrimimants[propertyName] = resolvedPropertySchema.enum[0];
    }
    const maybeConstValue = getProperty(resolvedPropertySchema, "const");
    if (resolvedPropertySchema.type === "string" && maybeConstValue != null) {
      possibleDiscrimimants[propertyName] = maybeConstValue;
    }
    if (propertyName === "type" && resolvedPropertySchema.example != null) {
      possibleDiscrimimants[propertyName] = resolvedPropertySchema.example;
    }
  }
  return possibleDiscrimimants;
}
function getEnumSet(enums) {
  if (!enums) {
    return [];
  }
  const set4 = /* @__PURE__ */ new Set();
  enums.forEach((item) => {
    if (typeof item === "string") {
      set4.add(item.toLowerCase());
    } else {
      set4.add(item);
    }
  });
  return Array.from(set4);
}
function getProperty(object3, property4) {
  const extensionValue = object3[property4];
  if (extensionValue != null) {
    return extensionValue;
  }
  return void 0;
}
function getEncoding({ schema: schema2, logger }) {
  const encoding = getFernEncoding({ schema: schema2, logger });
  if (encoding == null) {
    return void 0;
  }
  return convertEncoding(encoding);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/utils/getSchemas.js
function getSchemas(namespace, schemas) {
  let rootSchemas = {};
  let namespacedSchemas = {};
  if (namespace == null) {
    rootSchemas = schemas;
  } else {
    namespacedSchemas = {
      [namespace]: schemas
    };
  }
  return {
    rootSchemas,
    namespacedSchemas
  };
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/AsyncAPIParserContext.js
var MESSAGE_REFERENCE_PREFIX = "#/components/messages/";
var AbstractAsyncAPIV2ParserContext = class {
  logger;
  document;
  taskContext;
  DUMMY;
  options;
  namespace;
  constructor({ document: document2, taskContext, options, namespace }) {
    this.document = document2;
    this.taskContext = taskContext;
    this.logger = taskContext.logger;
    this.DUMMY = this;
    this.options = options;
    this.namespace = namespace;
  }
  resolveGroupName(groupName) {
    if (this.namespace != null) {
      return [{ type: "namespace", name: this.namespace }, ...groupName];
    }
    return groupName;
  }
  resolveTags(operationTags, fallback) {
    if (this.namespace == null && operationTags == null && fallback != null) {
      return [fallback];
    }
    const tags = [];
    if (this.namespace != null) {
      const namespaceSegment = {
        type: "namespace",
        name: this.namespace
      };
      tags.push(namespaceSegment);
    }
    return tags.concat(operationTags ?? []);
  }
  resolveSchemaReference(schema2) {
    if (this.document.components == null || this.document.components.schemas == null || !schema2.$ref.startsWith(SCHEMA_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${schema2.$ref}`);
    }
    const schemaKey = schema2.$ref.substring(SCHEMA_REFERENCE_PREFIX.length);
    const splitSchemaKey = schemaKey.split("/");
    if (splitSchemaKey[0] == null) {
      throw new Error(`${schema2.$ref} is undefined`);
    }
    let resolvedSchema = this.document.components.schemas[splitSchemaKey[0]];
    if (resolvedSchema == null) {
      throw new Error(`${splitSchemaKey[0]} is undefined`);
    }
    if (isReferenceObject(resolvedSchema)) {
      resolvedSchema = this.resolveSchemaReference(resolvedSchema);
    }
    if (splitSchemaKey[1] === "properties" && splitSchemaKey[2] != null) {
      const resolvedProperty = resolvedSchema.properties?.[splitSchemaKey[2]];
      if (resolvedProperty == null) {
        throw new Error(`${schema2.$ref} is undefiened. Property does not exist on object.`);
      } else if (isReferenceObject(resolvedProperty)) {
        resolvedSchema = this.resolveSchemaReference(resolvedProperty);
      } else {
        resolvedSchema = resolvedProperty;
      }
    }
    return resolvedSchema;
  }
  resolveMessageReference(message) {
    if (this.document.components == null || this.document.components.messages == null || !message.$ref.startsWith(MESSAGE_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${message.$ref}`);
    }
    const messageKey = message.$ref.substring(MESSAGE_REFERENCE_PREFIX.length);
    const resolvedMessage = this.document.components.messages[messageKey];
    if (resolvedMessage == null) {
      throw new Error(`${message.$ref}  is undefined`);
    }
    return resolvedMessage;
  }
  referenceExists(ref) {
    const keys5 = ref.substring(2).split("/").map((key) => key.replace(/~1/g, "/"));
    let resolvedSchema = this.document;
    for (const key of keys5) {
      if (typeof resolvedSchema !== "object" || resolvedSchema == null) {
        return false;
      }
      resolvedSchema = resolvedSchema[key];
    }
    return true;
  }
};
var AsyncAPIV2ParserContext = class extends AbstractAsyncAPIV2ParserContext {
  constructor({ document: document2, taskContext, options, namespace }) {
    super({
      document: document2,
      taskContext,
      options,
      namespace
    });
  }
  markSchemaAsReferencedByNonRequest(schemaId) {
    return;
  }
  markSchemaAsReferencedByRequest(schemaId) {
    return;
  }
  markReferencedByDiscriminatedUnion(schema2, discrminant, times) {
    return;
  }
  markSchemaWithDiscriminantValue(schema2, discrminant, discriminantValue) {
    return;
  }
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/examples/convertToFullExample.js
function convertToFullExample(value) {
  if (typeof value === "string") {
    return FullExample.primitive(PrimitiveExample.string(value));
  } else if (typeof value === "number") {
    if (Number.isInteger(value)) {
      return FullExample.primitive(PrimitiveExample.int(value));
    }
    return FullExample.primitive(PrimitiveExample.double(value));
  } else if (typeof value === "boolean") {
    return FullExample.primitive(PrimitiveExample.boolean(value));
  } else if (Array.isArray(value)) {
    const examples = value.map((example) => convertToFullExample(example));
    if (examples.length === 0) {
      return void 0;
    }
    return FullExample.array(examples.filter((example) => example != null));
  } else if (value != null && typeof value === "object" && Object.keys(value).every((key) => typeof key === "string")) {
    const kvs = [];
    for (const [property4, propertyValue] of Object.entries(value)) {
      const propertyExample = convertToFullExample(propertyValue);
      if (propertyExample != null) {
        kvs.push({
          key: PrimitiveExample.string(property4),
          value: propertyExample
        });
      }
    }
    return FullExample.map(kvs);
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/examples/getFullExample.js
function getFullExampleAsObject(value) {
  if (value != null && typeof value === "object" && Object.keys(value).every((key) => typeof key === "string")) {
    return value;
  }
  return void 0;
}
function getFullExampleAsArray(value) {
  if (value != null && Array.isArray(value)) {
    return value;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/examples/ExampleTypeFactory.js
var ExampleTypeFactory = class {
  schemas;
  nonRequestReferencedSchemas;
  context;
  constructor(schemas, nonRequestReferencedSchemas, context) {
    this.schemas = schemas;
    this.nonRequestReferencedSchemas = nonRequestReferencedSchemas;
    this.context = context;
  }
  buildExample({ schema: schema2, exampleId, example, options, skipReadonly }) {
    return this.buildExampleHelper({
      schema: schema2,
      visitedSchemaIds: /* @__PURE__ */ new Set(),
      exampleId,
      example,
      // Default maxCheckerDepth to 5
      options: { ...options, maxCheckerDepth: options.maxCheckerDepth ?? 5 },
      depth: 0,
      skipReadonly: skipReadonly ?? false
    });
  }
  buildExampleHelper({ exampleId, example, schema: schema2, depth, visitedSchemaIds, options, skipReadonly }) {
    switch (schema2.type) {
      case "enum":
        if (typeof example === "string" && enumContainsValue({ schema: schema2, value: example })) {
          return FullExample.enum(example);
        }
        return schema2.values[0] != null ? FullExample.enum(schema2.values[0]?.value) : void 0;
      case "literal":
        return FullExample.literal(schema2.value);
      case "nullable": {
        if (example == null && !this.hasExample(schema2.value, 0, visitedSchemaIds, options) && (options.ignoreOptionals || this.exceedsMaxDepth(depth, options))) {
          return void 0;
        }
        const result = this.buildExampleHelper({
          schema: schema2.value,
          visitedSchemaIds,
          exampleId,
          example,
          depth,
          options,
          skipReadonly
        });
        if (result != null && result.type === "array" && result.value.length === 0) {
          return void 0;
        }
        if (result != null && result.type === "map" && result.value.length === 0) {
          return void 0;
        }
        if (result != null && result.type === "object" && Object.keys(result.properties).length === 0) {
          return void 0;
        }
        return result;
      }
      case "optional": {
        if (example == null && !this.hasExample(schema2.value, 0, visitedSchemaIds, options) && (options.ignoreOptionals || this.exceedsMaxDepth(depth, options))) {
          return void 0;
        }
        if (Object.is(example, null)) {
          return void 0;
        }
        const result = this.buildExampleHelper({
          schema: schema2.value,
          visitedSchemaIds,
          exampleId,
          example,
          depth,
          options,
          skipReadonly
        });
        if (result != null && result.type === "array" && result.value.length === 0) {
          return void 0;
        }
        if (result != null && result.type === "map" && result.value.length === 0) {
          return void 0;
        }
        if (result != null && result.type === "object" && Object.keys(result.properties).length === 0) {
          return void 0;
        }
        return result;
      }
      case "primitive": {
        const primitiveExample = this.buildExampleFromPrimitive({ schema: schema2.schema, example, options });
        return FullExample.primitive(primitiveExample);
      }
      case "reference": {
        const referencedSchemaWithExample = this.schemas[schema2.schema];
        if (referencedSchemaWithExample != null && !visitedSchemaIds.has(schema2.schema)) {
          visitedSchemaIds.add(schema2.schema);
          const isInlinedRequest = referencedSchemaWithExample?.type === "object" && !this.nonRequestReferencedSchemas.has(schema2.schema);
          const referencedExample = this.buildExampleHelper({
            example,
            schema: referencedSchemaWithExample,
            exampleId,
            visitedSchemaIds,
            depth,
            options,
            // by default we respect readonly on inlined requests
            skipReadonly: isInlinedRequest || this.context.options.respectReadonlySchemas ? skipReadonly : false
          });
          visitedSchemaIds.delete(schema2.schema);
          return referencedExample;
        }
        return void 0;
      }
      case "oneOf":
        switch (schema2.value.type) {
          case "discriminated": {
            const result = {};
            let allProperties = {};
            let requiredProperties = {};
            const fullExample = getFullExampleAsObject(example);
            const exampleDiscriminant = fullExample?.[schema2.value.discriminantProperty];
            const exampleUnionVariantSchema = schema2.value.schemas[exampleDiscriminant];
            const unionVariants = [];
            const schemaFromExample = this.getDiscriminatedUnionVariantSchema(schema2.value, fullExample);
            if (schemaFromExample != null) {
              unionVariants.push(schemaFromExample);
            }
            unionVariants.push(...Object.entries(schema2.value.schemas));
            for (const unionVariant of unionVariants) {
              if (exampleDiscriminant != null && exampleUnionVariantSchema != null && exampleUnionVariantSchema.type === "object") {
                allProperties = this.getAllProperties(exampleUnionVariantSchema);
                requiredProperties = this.getAllRequiredProperties(exampleUnionVariantSchema);
                result[schema2.value.discriminantProperty] = FullExample.primitive(PrimitiveExample.string(exampleDiscriminant));
                break;
              } else {
                const objectSchema = this.getObjectSchema(unionVariant[1]);
                if (objectSchema == null) {
                  continue;
                }
                allProperties = this.getAllProperties(objectSchema);
                requiredProperties = this.getAllRequiredProperties(objectSchema);
                result[schema2.value.discriminantProperty] = FullExample.primitive(PrimitiveExample.string(unionVariant[0]));
              }
            }
            for (const commonProperty of schema2.value.commonProperties) {
              allProperties[commonProperty.key] = { schema: commonProperty.schema, readonly: false };
              const resolvedSchema = this.getResolvedSchema(commonProperty.schema);
              if (resolvedSchema.type !== "optional" && resolvedSchema.type !== "nullable") {
                requiredProperties[commonProperty.key] = commonProperty.schema;
              }
            }
            for (const [property4, schema3] of Object.entries(allProperties)) {
              const required = property4 in requiredProperties;
              if (required && fullExample?.[property4] != null) {
                const propertyExample = this.buildExampleHelper({
                  schema: schema3.schema,
                  exampleId,
                  example: fullExample[property4],
                  visitedSchemaIds,
                  depth: depth + 1,
                  options,
                  skipReadonly
                });
                if (propertyExample != null) {
                  result[property4] = propertyExample;
                } else {
                  return void 0;
                }
              } else {
                const propertyExample = this.buildExampleHelper({
                  exampleId,
                  schema: schema3.schema,
                  example: fullExample?.[property4],
                  visitedSchemaIds,
                  depth: depth + 1,
                  options,
                  skipReadonly
                });
                if (propertyExample != null) {
                  result[property4] = propertyExample;
                } else if (required) {
                  return void 0;
                }
              }
            }
            return FullExample.oneOf(FullOneOfExample.discriminated(result));
          }
          case "undisciminated": {
            const unionVariantSchema = this.getUnDiscriminatedUnionVariantSchema(schema2.value, example);
            if (unionVariantSchema != null) {
              return this.buildExampleHelper({
                exampleId,
                example,
                schema: unionVariantSchema,
                visitedSchemaIds,
                depth,
                options,
                skipReadonly
              });
            }
            break;
          }
        }
        return void 0;
      case "unknown":
        if (example != null) {
          const fullExample = convertToFullExample(example);
          if (fullExample != null) {
            return FullExample.unknown(fullExample);
          }
        }
        if (options.ignoreOptionals || this.exceedsMaxDepth(depth, options)) {
          return void 0;
        }
        if (options.isParameter) {
          return FullExample.primitive(PrimitiveExample.string(options.name ?? "string"));
        }
        return FullExample.map([
          {
            key: PrimitiveExample.string("key"),
            value: FullExample.primitive(PrimitiveExample.string("value"))
          }
        ]);
      case "array": {
        const fullExample = getFullExampleAsArray(example);
        const itemExamples = [];
        if (fullExample != null && fullExample.length > 0) {
          for (const item of fullExample) {
            const itemExample = this.buildExampleHelper({
              exampleId,
              example: item,
              schema: schema2.value,
              depth: depth + 1,
              visitedSchemaIds,
              options,
              skipReadonly
            });
            if (itemExample != null) {
              itemExamples.push(itemExample);
            }
          }
        } else if (schema2.example != null && schema2.example.length > 0) {
          for (const item of schema2.example) {
            const itemExample = this.buildExampleHelper({
              exampleId,
              example: item,
              schema: schema2.value,
              depth: depth + 1,
              visitedSchemaIds,
              options,
              skipReadonly
            });
            if (itemExample != null) {
              itemExamples.push(itemExample);
            }
          }
        } else {
          const itemExample = this.buildExampleHelper({
            exampleId,
            example: void 0,
            schema: schema2.value,
            depth: depth + 1,
            visitedSchemaIds,
            options,
            skipReadonly
          });
          if (itemExample != null) {
            itemExamples.push(itemExample);
          }
        }
        return FullExample.array(itemExamples);
      }
      case "map": {
        const objectExample = getFullExampleAsObject(example ?? schema2.example);
        if (objectExample != null && Object.entries(objectExample).length > 0) {
          const kvs = [];
          for (const [key, value] of Object.entries(objectExample)) {
            const keyExample2 = this.buildExampleFromPrimitive({
              schema: schema2.key.schema,
              example: key,
              options
            });
            const valueExample2 = this.buildExampleHelper({
              exampleId,
              example: value,
              schema: schema2.value,
              visitedSchemaIds,
              depth: depth + 1,
              options,
              skipReadonly
            });
            if (valueExample2 != null) {
              kvs.push({
                key: keyExample2,
                value: valueExample2
              });
            }
          }
          return FullExample.map(kvs);
        }
        if (schema2.key.schema.type === "string" && schema2.value.type === "unknown") {
          return FullExample.map([
            {
              key: PrimitiveExample.string("key"),
              value: FullExample.unknown(FullExample.primitive(PrimitiveExample.string("value")))
            }
          ]);
        }
        const keyExample = this.buildExampleFromPrimitive({
          schema: schema2.key.schema,
          example: void 0,
          options: {
            ...options,
            // override the name to be "key" for map keys otherwise you can start to get key name
            // nesting since primitive examples use their name e.g. "metadata": {"metadata": {...}}
            name: "key"
          }
        });
        const valueExample = this.buildExampleHelper({
          exampleId,
          example: void 0,
          schema: schema2.value,
          visitedSchemaIds,
          depth: depth + 1,
          options: {
            ...options,
            // override the name to be "value" for map value otherwise you can start to get key name
            // nesting since primitive examples use their name e.g. "metadata": {"metadata": "metadata"}
            name: "value"
          },
          skipReadonly
        });
        if (valueExample != null) {
          return FullExample.map([
            {
              key: keyExample,
              value: valueExample
            }
          ]);
        }
        return FullExample.map([]);
      }
      case "object": {
        const result = {};
        const foundObjectExample = schema2.fullExamples?.find((example2) => example2.name === exampleId) ?? schema2.fullExamples?.find((example2) => example2.name == null) ?? schema2.fullExamples?.[0];
        const fullExample = getFullExampleAsObject(example) ?? (foundObjectExample != null ? getFullExampleAsObject(foundObjectExample.value) : {}) ?? {};
        const allProperties = this.getAllProperties(schema2);
        const requiredProperties = this.getAllRequiredProperties(schema2);
        for (const [property4, schema3] of Object.entries(allProperties)) {
          if (skipReadonly && schema3.readonly) {
            continue;
          }
          const required = property4 in requiredProperties;
          const inExample = Object.keys(fullExample).includes(property4);
          const propertyExample = this.buildExampleHelper({
            schema: schema3.schema,
            exampleId,
            example: fullExample[property4],
            visitedSchemaIds,
            depth: depth + 1,
            options: {
              ...options,
              name: property4
            },
            skipReadonly
          });
          if (required && propertyExample != null) {
            result[property4] = propertyExample;
          } else if (required) {
            return void 0;
          } else if (inExample && propertyExample != null) {
            result[property4] = propertyExample;
          } else if (!options.ignoreOptionals && propertyExample != null) {
            result[property4] = propertyExample;
          }
        }
        return FullExample.object({
          properties: result
        });
      }
      default:
        assertNever(schema2);
    }
  }
  getObjectSchema(schema2) {
    if (schema2.type === "object") {
      return schema2;
    }
    if (schema2.type === "reference") {
      const referenceDeclaration = this.schemas[schema2.schema];
      if (referenceDeclaration != null) {
        return this.getObjectSchema(referenceDeclaration);
      }
    }
    return void 0;
  }
  getDiscriminatedUnionVariantSchema(schema2, fullExample) {
    const discriminantValue = fullExample?.[schema2.discriminantProperty];
    if (discriminantValue == null || typeof discriminantValue !== "string") {
      return Object.entries(schema2.schemas)[0];
    }
    const unionVariantSchema = schema2.schemas[discriminantValue];
    if (unionVariantSchema == null) {
      return Object.entries(schema2.schemas)[0];
    }
    return [discriminantValue, unionVariantSchema];
  }
  getUnDiscriminatedUnionVariantSchema(schema2, fullExample) {
    if (fullExample == null) {
      return schema2.schemas[0];
    }
    const matches = schema2.schemas.map((schema3) => ({
      schema: schema3,
      heuristic: this.calcExampleHeuristic(schema3, fullExample)
    }));
    const sortedMatches = matches.sort((a, b) => b.heuristic - a.heuristic);
    return sortedMatches[0]?.schema;
  }
  // this is not a perfect heuristic, but it's a start. algorithm is as follows:
  // * tally up all properties that are both in the schema and example when traversing recursively
  // * subtract 1 for every property that is in the example but not in the schema.
  // this doesn't account for objects that can have arbitrary properties, and overvalues schemas with more properties.
  calcExampleHeuristic(schema2, fullExample) {
    switch (schema2.type) {
      case "literal": {
        return schema2.value.value === fullExample ? 5 : 0;
      }
      case "enum": {
        return enumContainsValue({ schema: schema2, value: fullExample }) ? 5 : 0;
      }
      case "object": {
        if (!isPlainObject2(fullExample)) {
          return 0;
        }
        const allProperties = this.getAllProperties(schema2);
        let heuristic = 0;
        for (const [property4, schema3] of Object.entries(allProperties)) {
          if (fullExample[property4] != null) {
            heuristic++;
            heuristic += this.calcExampleHeuristic(schema3.schema, fullExample[property4]);
          } else {
            heuristic--;
          }
        }
        return heuristic;
      }
      case "array": {
        if (!Array.isArray(fullExample)) {
          return 0;
        }
        let heuristic = 0;
        for (const item of fullExample) {
          heuristic += this.calcExampleHeuristic(schema2.value, item);
        }
        return heuristic;
      }
      case "map": {
        if (!isPlainObject2(fullExample)) {
          return 0;
        }
        let heuristic = 0;
        for (const [, value] of Object.entries(fullExample)) {
          heuristic += this.calcExampleHeuristic(schema2.value, value);
        }
        return heuristic;
      }
      case "nullable":
      case "optional": {
        return this.calcExampleHeuristic(schema2.value, fullExample);
      }
      case "reference": {
        const resolvedSchema = this.getResolvedSchema(schema2);
        if (resolvedSchema == null) {
          return 0;
        }
        return this.calcExampleHeuristic(resolvedSchema, fullExample);
      }
      case "oneOf": {
        const matches = Object.values(schema2.value.schemas).map((schema3) => this.calcExampleHeuristic(schema3, fullExample));
        return matches.sort((a, b) => b - a)[0] ?? 0;
      }
      case "primitive": {
        if (fullExample == null) {
          return 0;
        }
        const matches = schema2.schema._visit({
          int: () => typeof fullExample === "number",
          int64: () => typeof fullExample === "number",
          uint: () => typeof fullExample === "number",
          uint64: () => typeof fullExample === "number",
          float: () => typeof fullExample === "number",
          double: () => typeof fullExample === "number",
          string: () => typeof fullExample === "string",
          datetime: () => typeof fullExample === "string",
          date: () => typeof fullExample === "string",
          base64: () => typeof fullExample === "string",
          boolean: () => typeof fullExample === "boolean",
          _other: () => true
        });
        return matches ? 1 : -1;
      }
      default:
        return 0;
    }
  }
  hasExample(schema2, depth, visitedSchemaIds = /* @__PURE__ */ new Set(), options) {
    if (this.exceedsMaxCheckerDepth(depth, options)) {
      return false;
    }
    switch (schema2.type) {
      case "array":
        return this.hasExample(schema2.value, depth + 1, visitedSchemaIds, options);
      case "enum":
        return schema2.example != null;
      case "literal":
        return false;
      case "map":
        return schema2.example != null || schema2.key.schema.example != null && this.hasExample(schema2.value, depth + 1, visitedSchemaIds, options);
      case "object": {
        const objectExample = schema2.fullExamples != null && schema2.fullExamples.length > 0;
        if (objectExample) {
          return true;
        }
        for (const property4 of schema2.properties) {
          if (this.hasExample(property4.schema, depth + 1, visitedSchemaIds, options)) {
            return true;
          }
        }
        return false;
      }
      case "primitive":
        return schema2.schema.example != null;
      case "reference": {
        const resolvedSchema = this.schemas[schema2.schema];
        if (resolvedSchema != null && !visitedSchemaIds.has(schema2.schema)) {
          visitedSchemaIds.add(schema2.schema);
          const hasExample = this.hasExample(resolvedSchema, depth, visitedSchemaIds, options);
          visitedSchemaIds.delete(schema2.schema);
          return hasExample;
        }
        return false;
      }
      case "unknown":
        return schema2.example != null;
      case "oneOf":
        return Object.values(schema2.value.schemas).some((schema3) => this.hasExample(schema3, depth, visitedSchemaIds, options));
      default:
        return false;
    }
  }
  exceedsMaxCheckerDepth(depth, options) {
    return depth > (options.maxCheckerDepth ?? 0);
  }
  exceedsMaxDepth(depth, options) {
    return depth > (options.maxDepth ?? 0);
  }
  getAllProperties(object3) {
    let properties = {};
    for (const property4 of object3.properties) {
      properties[property4.key] = { schema: property4.schema, readonly: property4.readonly ?? false };
    }
    for (const allOf of object3.allOf) {
      const allOfSchema = this.schemas[allOf.schema];
      if (allOfSchema == null) {
        continue;
      }
      const resolvedAllOfSchema = this.getResolvedSchema(allOfSchema);
      if (resolvedAllOfSchema.type !== "object") {
        continue;
      }
      properties = {
        ...this.getAllProperties(resolvedAllOfSchema),
        ...properties
      };
    }
    return properties;
  }
  getAllRequiredProperties(object3) {
    let requiredProperties = {};
    for (const property4 of object3.properties) {
      const resolvedSchema = this.getResolvedSchema(property4.schema);
      if (resolvedSchema.type !== "optional" && resolvedSchema.type !== "nullable") {
        requiredProperties[property4.key] = property4.schema;
      }
    }
    for (const allOf of object3.allOf) {
      const allOfSchema = this.schemas[allOf.schema];
      if (allOfSchema == null) {
        continue;
      }
      const resolvedAllOfSchema = this.getResolvedSchema(allOfSchema);
      if (resolvedAllOfSchema.type !== "object") {
        continue;
      }
      requiredProperties = {
        ...this.getAllRequiredProperties(resolvedAllOfSchema),
        ...requiredProperties
      };
    }
    return requiredProperties;
  }
  getResolvedSchema(schema2) {
    while (schema2.type === "reference") {
      const resolvedSchema = this.schemas[schema2.schema];
      if (resolvedSchema == null) {
        throw new Error(`Unexpected error: Failed to resolve schema reference: ${schema2.schema}`);
      }
      schema2 = resolvedSchema;
    }
    return schema2;
  }
  buildExampleFromPrimitive({ example, schema: schema2, options }) {
    switch (schema2.type) {
      case "string":
        if (example != null && typeof example === "string") {
          return PrimitiveExample.string(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.string(schema2.example);
        } else {
          return PrimitiveExample.string(options.name ?? examples_exports.STRING);
        }
      case "base64":
        if (example != null && typeof example === "string") {
          return PrimitiveExample.base64(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.base64(schema2.example);
        } else {
          return PrimitiveExample.base64(examples_exports.BASE64);
        }
      case "boolean":
        if (example != null && typeof example === "boolean") {
          return PrimitiveExample.boolean(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.boolean(schema2.example);
        } else {
          return PrimitiveExample.boolean(examples_exports.BOOLEAN);
        }
      case "date":
        if (example != null && typeof example === "string") {
          return PrimitiveExample.date(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.date(schema2.example);
        } else {
          return PrimitiveExample.date(examples_exports.DATE);
        }
      case "datetime":
        if (example != null && typeof example === "string") {
          return PrimitiveExample.datetime(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.datetime(schema2.example);
        } else {
          return PrimitiveExample.datetime(examples_exports.DATE_TIME);
        }
      case "double":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.double(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.double(schema2.example);
        } else {
          return PrimitiveExample.double(examples_exports.DOUBLE);
        }
      case "float":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.float(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.float(schema2.example);
        } else {
          return PrimitiveExample.float(examples_exports.FLOAT);
        }
      case "int":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.int(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.int(schema2.example);
        } else {
          return PrimitiveExample.int(examples_exports.INT);
        }
      case "int64":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.int64(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.int64(schema2.example);
        } else {
          return PrimitiveExample.int64(examples_exports.INT64);
        }
      case "uint":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.uint(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.uint(schema2.example);
        } else {
          return PrimitiveExample.uint(examples_exports.UINT);
        }
      case "uint64":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.uint64(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.uint64(schema2.example);
        } else {
          return PrimitiveExample.uint64(examples_exports.UINT64);
        }
      default:
        assertNever(schema2);
    }
  }
};
function enumContainsValue({ schema: schema2, value }) {
  return schema2.values.map((enumValue) => {
    return enumValue.value;
  }).includes(value);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/convertSchemaToSchemaWithExample.js
function convertSchemaToSchemaWithExample(schema2) {
  switch (schema2.type) {
    case "object":
      return SchemaWithExample.object({
        allOf: schema2.allOf,
        properties: schema2.properties.map((objectProperty) => convertToObjectProperty2(objectProperty)),
        allOfPropertyConflicts: schema2.allOfPropertyConflicts,
        description: schema2.description,
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        groupName: schema2.groupName,
        fullExamples: void 0,
        additionalProperties: schema2.additionalProperties,
        availability: schema2.availability,
        source: schema2.source
      });
    case "array":
      return SchemaWithExample.array({
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaToSchemaWithExample(schema2.value),
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        groupName: schema2.groupName,
        example: void 0
      });
    case "enum":
      return SchemaWithExample.enum({
        description: schema2.description,
        availability: schema2.availability,
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        values: schema2.values,
        default: schema2.default,
        groupName: schema2.groupName,
        example: void 0,
        source: schema2.source
      });
    case "literal":
      return SchemaWithExample.literal({
        description: schema2.description,
        availability: schema2.availability,
        value: schema2.value,
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        groupName: schema2.groupName
      });
    case "nullable":
      return SchemaWithExample.nullable({
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaToSchemaWithExample(schema2.value),
        groupName: schema2.groupName
      });
    case "optional":
      return SchemaWithExample.optional({
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaToSchemaWithExample(schema2.value),
        groupName: schema2.groupName
      });
    case "primitive":
      return SchemaWithExample.primitive({
        description: schema2.description,
        availability: schema2.availability,
        schema: convertToPrimitiveSchemaValue2(schema2.schema),
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName
      });
    case "map":
      return SchemaWithExample.map({
        description: schema2.description,
        availability: schema2.availability,
        key: SchemaWithExample.primitive({
          description: schema2.key.description,
          availability: schema2.key.availability,
          schema: convertToPrimitiveSchemaValue2(schema2.key.schema),
          generatedName: schema2.key.generatedName,
          nameOverride: schema2.key.nameOverride,
          title: schema2.key.title,
          groupName: schema2.groupName
        }),
        value: convertSchemaToSchemaWithExample(schema2.value),
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName,
        encoding: schema2.encoding,
        example: void 0
      });
    case "reference":
      return SchemaWithExample.reference({
        description: schema2.description,
        availability: schema2.availability,
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        schema: schema2.schema,
        groupName: schema2.groupName,
        source: schema2.source
      });
    case "oneOf":
      return SchemaWithExample.oneOf(convertToOneOf2(schema2.value));
    case "unknown":
      return SchemaWithExample.unknown({
        nameOverride: schema2.nameOverride,
        generatedName: schema2.generatedName,
        title: void 0,
        example: void 0,
        groupName: void 0,
        description: void 0,
        availability: void 0
      });
    default:
      assertNever(schema2);
  }
}
function convertToOneOf2(oneOfSchema) {
  switch (oneOfSchema.type) {
    case "discriminated":
      return OneOfSchemaWithExample.discriminated({
        commonProperties: oneOfSchema.commonProperties.map((commonProperty) => {
          return {
            key: commonProperty.key,
            schema: convertSchemaToSchemaWithExample(commonProperty.schema)
          };
        }),
        description: oneOfSchema.description,
        availability: oneOfSchema.availability,
        discriminantProperty: oneOfSchema.discriminantProperty,
        generatedName: oneOfSchema.generatedName,
        nameOverride: oneOfSchema.nameOverride,
        title: oneOfSchema.title,
        schemas: Object.fromEntries(Object.entries(oneOfSchema.schemas).map(([discriminantValue, schemaWithExample]) => {
          return [discriminantValue, convertSchemaToSchemaWithExample(schemaWithExample)];
        })),
        groupName: oneOfSchema.groupName,
        encoding: oneOfSchema.encoding,
        source: oneOfSchema.source
      });
    case "undisciminated":
      return OneOfSchemaWithExample.undisciminated({
        description: oneOfSchema.description,
        availability: oneOfSchema.availability,
        generatedName: oneOfSchema.generatedName,
        nameOverride: oneOfSchema.nameOverride,
        title: oneOfSchema.title,
        schemas: oneOfSchema.schemas.map((oneOfSchema2) => convertSchemaToSchemaWithExample(oneOfSchema2)),
        groupName: oneOfSchema.groupName,
        encoding: oneOfSchema.encoding,
        source: oneOfSchema.source
      });
    default:
      assertNever(oneOfSchema);
  }
}
function convertToPrimitiveSchemaValue2(primitiveSchema) {
  switch (primitiveSchema.type) {
    case "string":
      return PrimitiveSchemaValueWithExample.string({
        default: primitiveSchema.default,
        pattern: primitiveSchema.pattern,
        format: primitiveSchema.format,
        minLength: primitiveSchema.minLength,
        maxLength: primitiveSchema.maxLength,
        example: void 0
      });
    case "base64":
      return PrimitiveSchemaValueWithExample.base64({
        example: void 0
      });
    case "boolean":
      return PrimitiveSchemaValueWithExample.boolean({
        default: primitiveSchema.default,
        example: void 0
      });
    case "date":
      return PrimitiveSchemaValueWithExample.date({
        example: void 0
      });
    case "datetime":
      return PrimitiveSchemaValueWithExample.datetime({
        example: void 0
      });
    case "double":
      return PrimitiveSchemaValueWithExample.double({
        default: primitiveSchema.default,
        minimum: primitiveSchema.minimum,
        maximum: primitiveSchema.maximum,
        exclusiveMinimum: primitiveSchema.exclusiveMinimum,
        exclusiveMaximum: primitiveSchema.exclusiveMaximum,
        multipleOf: primitiveSchema.multipleOf,
        example: void 0
      });
    case "float":
      return PrimitiveSchemaValueWithExample.float({
        example: void 0
      });
    case "int":
      return PrimitiveSchemaValueWithExample.int({
        default: primitiveSchema.default,
        minimum: primitiveSchema.minimum,
        maximum: primitiveSchema.maximum,
        exclusiveMinimum: primitiveSchema.exclusiveMinimum,
        exclusiveMaximum: primitiveSchema.exclusiveMaximum,
        multipleOf: primitiveSchema.multipleOf,
        example: void 0
      });
    case "int64":
      return PrimitiveSchemaValueWithExample.int64({
        default: primitiveSchema.default,
        example: void 0
      });
    case "uint":
      return PrimitiveSchemaValueWithExample.uint({
        default: void 0,
        example: void 0
      });
    case "uint64":
      return PrimitiveSchemaValueWithExample.uint64({
        default: void 0,
        example: void 0
      });
    default:
      assertNever(primitiveSchema);
  }
}
function convertToObjectProperty2(objectProperty) {
  return {
    conflict: objectProperty.conflict,
    generatedName: objectProperty.generatedName,
    key: objectProperty.key,
    schema: convertSchemaToSchemaWithExample(objectProperty.schema),
    audiences: objectProperty.audiences,
    nameOverride: objectProperty.nameOverride,
    availability: objectProperty.availability,
    readonly: objectProperty.readonly
  };
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/isSchemaRequired.js
function isSchemaRequired3(schema2) {
  return schema2.type !== "optional" && schema2.type !== "nullable";
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/hasIncompleteExample.js
function hasIncompleteExample(example) {
  if (example.type === "full") {
    return example.request == null && example.response == null && example.queryParameters == null && example.pathParameters == null && example.headers == null;
  } else {
    const castExample = example.value;
    return castExample.request == null && castExample.response == null && castExample["query-parameters"] == null && castExample["path-parameters"] == null && castExample.headers == null;
  }
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/ExampleEndpointFactory.js
var ExampleEndpointFactory = class {
  exampleTypeFactory;
  logger;
  schemas;
  constructor(schemas, context) {
    this.schemas = schemas;
    this.exampleTypeFactory = new ExampleTypeFactory(schemas, context.nonRequestReferencedSchemas, context);
    this.logger = context.logger;
  }
  buildEndpointExample(endpoint) {
    this.logger.debug(`Building endpoint example for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
    const requestSchemaIdResponse = getRequestSchema(endpoint.request);
    const responseSchemaIdResponse = getResponseSchema(endpoint.response);
    if (requestSchemaIdResponse?.type === "unsupported" || responseSchemaIdResponse?.type === "unsupported") {
      return [];
    }
    const requestExamples = [];
    if (requestSchemaIdResponse != null && requestSchemaIdResponse.type === "present") {
      const required = this.isSchemaRequired(requestSchemaIdResponse.schema);
      if (requestSchemaIdResponse.examples.length === 0) {
        const example = this.exampleTypeFactory.buildExample({
          skipReadonly: endpoint.method === "POST" || endpoint.method === "PUT",
          schema: requestSchemaIdResponse.schema,
          exampleId: void 0,
          example: void 0,
          options: {
            isParameter: false,
            ignoreOptionals: true
          }
        });
        if (example != null) {
          requestExamples.push([void 0, example]);
        }
      } else {
        for (const { name: exampleId, value: rawExample } of requestSchemaIdResponse.examples) {
          const example = this.exampleTypeFactory.buildExample({
            skipReadonly: endpoint.method === "POST" || endpoint.method === "PUT",
            schema: requestSchemaIdResponse.schema,
            exampleId,
            example: rawExample,
            options: {
              isParameter: false,
              ignoreOptionals: true
            }
          });
          if (example != null) {
            requestExamples.push([exampleId, example]);
          }
        }
      }
      if (required && requestExamples.length === 0) {
        this.logger.warn(`Failed to generate required request example for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
        return [];
      }
    }
    const responseExamples = [];
    if (responseSchemaIdResponse != null && responseSchemaIdResponse.type === "present") {
      const required = this.isSchemaRequired(responseSchemaIdResponse.schema);
      if (responseSchemaIdResponse.examples.length === 0) {
        const example = this.exampleTypeFactory.buildExample({
          skipReadonly: false,
          schema: responseSchemaIdResponse.schema,
          exampleId: void 0,
          example: void 0,
          options: {
            maxDepth: 3,
            isParameter: false,
            ignoreOptionals: false
          }
        });
        if (example != null) {
          if (endpoint.response?.type === "json") {
            responseExamples.push([void 0, EndpointResponseExample.withoutStreaming(example)]);
          } else if (endpoint.response?.type === "streamingJson") {
            responseExamples.push([void 0, EndpointResponseExample.withStreaming([example])]);
          }
        }
      } else {
        for (const { name: exampleId, value: rawExample } of responseSchemaIdResponse.examples) {
          const example = this.exampleTypeFactory.buildExample({
            skipReadonly: false,
            schema: responseSchemaIdResponse.schema,
            exampleId,
            example: rawExample,
            options: {
              maxDepth: 3,
              isParameter: false,
              ignoreOptionals: false
            }
          });
          if (example != null) {
            if (endpoint.response?.type === "json") {
              responseExamples.push([exampleId, EndpointResponseExample.withoutStreaming(example)]);
            } else if (endpoint.response?.type === "streamingJson") {
              responseExamples.push([exampleId, EndpointResponseExample.withStreaming([example])]);
            }
          }
        }
      }
      if (required && responseExamples.length === 0) {
        this.logger.warn(`Failed to generate required response example for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
        return [];
      }
    }
    const pathParameters = [];
    for (const pathParameter of endpoint.pathParameters) {
      const required = this.isSchemaRequired(pathParameter.schema);
      let example = this.exampleTypeFactory.buildExample({
        schema: pathParameter.schema,
        exampleId: void 0,
        example: void 0,
        options: {
          name: pathParameter.name,
          isParameter: true,
          ignoreOptionals: true
        }
      });
      if (example != null && !isExamplePrimitive(example)) {
        this.logger.warn(`Expected a primitive example but got ${example.type} for path parameter ${pathParameter.name} for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
        example = void 0;
      }
      if (required && example == null) {
        return [];
      } else if (example != null) {
        pathParameters.push({
          name: pathParameter.name,
          parameterNameOverride: pathParameter.parameterNameOverride,
          value: example
        });
      }
    }
    const queryParameters = [];
    for (const queryParameter of endpoint.queryParameters) {
      const required = this.isSchemaRequired(queryParameter.schema);
      let example = this.exampleTypeFactory.buildExample({
        schema: queryParameter.schema,
        exampleId: void 0,
        example: void 0,
        options: {
          name: queryParameter.name,
          isParameter: true,
          ignoreOptionals: true
        }
      });
      if (example != null && !isExamplePrimitive(example)) {
        this.logger.warn(`Expected a primitive example but got ${example.type} for query parameter ${queryParameter.name} for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
        example = void 0;
      }
      if (required && example == null) {
        return [];
      } else if (example != null) {
        queryParameters.push({
          name: queryParameter.name,
          value: example
        });
      }
    }
    const headers = [];
    for (const header of endpoint.headers) {
      const required = this.isSchemaRequired(header.schema);
      let example = this.exampleTypeFactory.buildExample({
        schema: header.schema,
        exampleId: void 0,
        example: void 0,
        options: {
          name: header.name,
          isParameter: true,
          ignoreOptionals: true
        }
      });
      if (example != null && !isExamplePrimitive(example)) {
        this.logger.warn(`Expected a primitive example but got ${example.type} for header ${header.name} for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
        example = void 0;
      }
      if (required && example == null) {
        return [];
      } else if (example != null) {
        headers.push({
          name: header.name,
          value: example
        });
      }
    }
    let requestResponsePairs = [];
    if (endpoint.request != null && endpoint.response != null) {
      requestResponsePairs = consolidateRequestResponseExamples(requestExamples, responseExamples);
    } else if (endpoint.request != null) {
      requestResponsePairs = requestExamples.map(([id, example]) => {
        return { id, request: example, response: void 0 };
      });
    } else if (endpoint.response != null) {
      requestResponsePairs = responseExamples.map(([id, example]) => {
        return { id, request: void 0, response: example };
      });
    }
    const codeSamples = endpoint.examples.filter((ex) => hasIncompleteExample(ex)).flatMap((ex) => {
      if (ex.type === "unknown") {
        if (ex.value != null) {
          const samples = ex.value["code-samples"];
          if (samples != null) {
            return this.convertCodeSamples(samples);
          }
        }
        return void 0;
      } else {
        return ex.codeSamples;
      }
    }).filter((ex) => isNonNullish(ex));
    if (requestResponsePairs.length === 0) {
      return [
        EndpointExample.full({
          name: void 0,
          description: void 0,
          pathParameters,
          queryParameters,
          headers,
          request: void 0,
          response: void 0,
          codeSamples
        })
      ];
    }
    return requestResponsePairs.map(({ id: exampleName, request: requestExample, response: responseExample }) => {
      return EndpointExample.full({
        name: exampleName,
        description: void 0,
        pathParameters,
        queryParameters,
        headers,
        request: requestExample,
        response: responseExample,
        codeSamples
      });
    });
  }
  convertCodeSamples(codeSamples) {
    return codeSamples.map((codeSample) => {
      if ("language" in codeSample) {
        return CustomCodeSample.language({
          name: codeSample.name ?? void 0,
          description: codeSample.docs ?? void 0,
          language: codeSample.language,
          code: codeSample.code,
          install: codeSample.install ?? void 0
        });
      } else {
        return CustomCodeSample.sdk({
          name: codeSample.name ?? void 0,
          description: codeSample.docs ?? void 0,
          sdk: codeSample.sdk === "c#" ? SupportedSdkLanguage.Csharp : codeSample.sdk,
          code: codeSample.code
        });
      }
    }).filter(isNonNullish);
  }
  isSchemaRequired(schema2) {
    return isSchemaRequired3(this.getResolvedSchema(schema2));
  }
  getResolvedSchema(schema2) {
    return schema2;
  }
};
function consolidateRequestResponseExamples(requestExamples, responseExamples) {
  const pairs2 = [];
  if (requestExamples.length <= 1) {
    const [requestId, requestExample] = requestExamples[0] ?? [];
    if (responseExamples.length === 0) {
      pairs2.push({
        id: requestId,
        request: requestExample,
        response: void 0
      });
      return pairs2;
    } else {
      for (const [responseId, responseExample] of responseExamples) {
        pairs2.push({
          id: responseId ?? requestId,
          request: requestExample,
          response: responseExample
        });
      }
    }
    return pairs2;
  }
  if (responseExamples.length <= 1) {
    const [responseId, responseExample] = responseExamples[0] ?? [];
    if (responseExamples.length === 0) {
      pairs2.push({
        id: responseId,
        request: void 0,
        response: responseExample
      });
      return pairs2;
    } else {
      for (const [requestId, requestExample] of requestExamples) {
        pairs2.push({
          id: requestId ?? responseId,
          request: requestExample,
          response: responseExample
        });
      }
    }
    return pairs2;
  }
  const visitedResponseIdx = /* @__PURE__ */ new Set();
  for (const [requestId, requestExample] of requestExamples) {
    const fallbackResponseExample = responseExamples.find(([responseId]) => responseId == null)?.[1] ?? responseExamples[0]?.[1];
    if (requestId == null) {
      if (fallbackResponseExample == null) {
        continue;
      }
      pairs2.push({
        id: void 0,
        request: requestExample,
        response: fallbackResponseExample
      });
      continue;
    }
    let paired = false;
    for (let idx = 0; idx < responseExamples.length; idx++) {
      const [responseId, responseExample] = responseExamples[idx];
      if (responseId == null || visitedResponseIdx.has(idx)) {
        continue;
      }
      if (requestId === responseId) {
        pairs2.push({
          id: requestId,
          request: requestExample,
          response: responseExample
        });
        if (responseId != null) {
          visitedResponseIdx.add(idx);
        }
        paired = true;
      }
    }
    if (!paired && fallbackResponseExample != null) {
      pairs2.push({
        id: requestId,
        request: requestExample,
        response: fallbackResponseExample
      });
    }
  }
  for (let idx = 0; idx < responseExamples.length; idx++) {
    if (visitedResponseIdx.has(idx)) {
      continue;
    }
    const [responseId, responseExample] = responseExamples[idx];
    const requestExample = requestExamples.find(([requestId]) => requestId == null)?.[1] ?? requestExamples[0]?.[1];
    if (requestExample != null) {
      pairs2.push({
        id: responseId,
        request: requestExample,
        response: responseExample
      });
    }
  }
  return pairs2;
}
function getRequestSchema(request) {
  if (request == null) {
    return void 0;
  }
  if (request.type === "multipart") {
    return {
      type: "present",
      schema: convertMultipartRequestToSchema(request),
      examples: []
    };
  }
  if (request.type === "json") {
    return { type: "present", schema: request.schema, examples: request.fullExamples ?? [] };
  }
  return { type: "unsupported" };
}
function getResponseSchema(response) {
  if (response == null) {
    return void 0;
  }
  if (response.type !== "json" && response.type !== "streamingJson") {
    return { type: "unsupported" };
  }
  return { type: "present", schema: response.schema, examples: response.fullExamples ?? [] };
}
function isExamplePrimitive(example) {
  switch (example.type) {
    case "primitive":
    case "enum":
    case "literal":
      return true;
    case "unknown":
      return isExamplePrimitive(example);
    case "array":
    case "object":
    case "map":
      return false;
    case "oneOf":
      switch (example.value.type) {
        case "discriminated":
          return false;
        case "undisciminated":
          return isExamplePrimitive(example.value.value);
        default:
          return false;
      }
    default:
      assertNever(example);
  }
}
function convertMultipartRequestToSchema(request) {
  return SchemaWithExample.object({
    properties: request.properties.map((property4) => {
      if (property4.schema.type === "file") {
        return null;
      }
      return {
        key: property4.key,
        // Convert the schema to a schema with example to ensure that the example is generated
        // This is a workaround for the fact that the example is not getting parsed upstream
        // TODO: Fix the example parsing upstream
        schema: convertSchemaToSchemaWithExample(property4.schema.value),
        audiences: [],
        conflict: {},
        generatedName: property4.key,
        nameOverride: void 0,
        availability: void 0,
        readonly: void 0,
        inline: void 0
      };
    }).filter(isNonNullish),
    allOf: [],
    allOfPropertyConflicts: [],
    fullExamples: void 0,
    description: request.description,
    nameOverride: void 0,
    generatedName: "",
    title: void 0,
    groupName: void 0,
    additionalProperties: false,
    availability: void 0,
    source: request.source
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/ExampleWebsocketSessionFactory.js
var ExampleWebsocketSessionFactory = class {
  exampleTypeFactory;
  schemas;
  constructor(schemas, context) {
    this.exampleTypeFactory = new ExampleTypeFactory(schemas, /* @__PURE__ */ new Set(), context);
    this.schemas = schemas;
  }
  buildWebsocketSessionExamplesForExtension({ context, extensionExamples, publish, subscribe, handshake, source, namespace }) {
    const result = [];
    for (const extensionExample of extensionExamples) {
      const queryParameters = [];
      for (const queryParameter of handshake.queryParameters) {
        const required = this.isSchemaRequired(queryParameter.schema);
        let example = this.exampleTypeFactory.buildExample({
          schema: queryParameter.schema,
          exampleId: void 0,
          example: extensionExample.queryParameters?.[queryParameter.name],
          options: {
            name: queryParameter.name,
            isParameter: true,
            ignoreOptionals: true
          }
        });
        if (example != null && !isExamplePrimitive(example)) {
          example = void 0;
        }
        if (required && example == null) {
          continue;
        } else if (example != null) {
          queryParameters.push({
            name: queryParameter.name,
            value: example
          });
        }
      }
      const headers = [];
      for (const header of handshake.headers) {
        const required = this.isSchemaRequired(header.schema);
        let example = this.exampleTypeFactory.buildExample({
          schema: header.schema,
          exampleId: void 0,
          example: extensionExample.headers?.[header.name],
          options: {
            name: header.name,
            isParameter: true,
            ignoreOptionals: true
          }
        });
        if (example != null && !isExamplePrimitive(example)) {
          example = void 0;
        }
        if (required && example == null) {
          continue;
        } else if (example != null) {
          headers.push({
            name: header.name,
            value: example
          });
        }
      }
      const messages = [];
      for (const messageExample of extensionExample.messages) {
        const messageSchema = context.resolveMessageReference({
          $ref: `#/components/messages/${messageExample.messageId}`
        });
        const resolvedSchema = isReferenceObject(messageSchema.payload) ? context.resolveSchemaReference(messageSchema.payload) : messageSchema.payload;
        const example = this.exampleTypeFactory.buildExample({
          schema: convertSchema(resolvedSchema, false, context, [messageExample.messageId], source, namespace),
          exampleId: void 0,
          example: messageExample.value,
          options: {
            isParameter: false,
            ignoreOptionals: true
          }
        });
        if (example != null) {
          messages.push({
            messageType: messageExample.type,
            payload: example,
            description: void 0
          });
        }
      }
      result.push({
        name: extensionExample.summary,
        queryParameters,
        headers,
        description: extensionExample.description,
        messages
      });
    }
    return result;
  }
  buildWebsocketSessionExample({ publish, subscribe, handshake }) {
    const example = {
      name: void 0,
      queryParameters: [],
      headers: [],
      description: void 0,
      messages: []
    };
    const queryParameters = [];
    for (const queryParameter of handshake.queryParameters) {
      const required = this.isSchemaRequired(queryParameter.schema);
      let example2 = this.exampleTypeFactory.buildExample({
        schema: queryParameter.schema,
        exampleId: void 0,
        example: void 0,
        options: {
          name: queryParameter.name,
          isParameter: true,
          ignoreOptionals: true
        }
      });
      if (example2 != null && !isExamplePrimitive(example2)) {
        example2 = void 0;
      }
      if (required && example2 == null) {
        return void 0;
      } else if (example2 != null) {
        queryParameters.push({
          name: queryParameter.name,
          value: example2
        });
      }
    }
    const headers = [];
    for (const header of handshake.headers) {
      const required = this.isSchemaRequired(header.schema);
      let example2 = this.exampleTypeFactory.buildExample({
        schema: header.schema,
        exampleId: void 0,
        example: void 0,
        options: {
          name: header.name,
          isParameter: true,
          ignoreOptionals: true
        }
      });
      if (example2 != null && !isExamplePrimitive(example2)) {
        example2 = void 0;
      }
      if (required && example2 == null) {
        return void 0;
      } else if (example2 != null) {
        headers.push({
          name: header.name,
          value: example2
        });
      }
    }
    if (publish != null) {
      const publishMessageExample = this.exampleTypeFactory.buildExample({
        schema: publish,
        exampleId: void 0,
        example: void 0,
        options: {
          isParameter: false,
          ignoreOptionals: true
        }
      });
      if (publishMessageExample != null) {
        example.messages.push({
          messageType: "publish",
          payload: publishMessageExample,
          description: void 0
        });
      }
    }
    if (subscribe != null) {
      const publishMessageExample = this.exampleTypeFactory.buildExample({
        schema: subscribe,
        exampleId: void 0,
        example: void 0,
        options: {
          isParameter: false,
          ignoreOptionals: true
        }
      });
      if (publishMessageExample != null) {
        example.messages.push({
          messageType: "subscribe",
          payload: publishMessageExample,
          description: void 0
        });
      }
    }
    return example;
  }
  isSchemaRequired(schema2) {
    return isSchemaRequired3(this.getResolvedSchema(schema2));
  }
  getResolvedSchema(schema2) {
    while (schema2.type === "reference") {
      const resolvedSchema = this.schemas[schema2.schema];
      if (resolvedSchema == null) {
        throw new Error(`Unexpected error: Failed to resolve schema reference: ${schema2.schema}`);
      }
      schema2 = resolvedSchema;
    }
    return schema2;
  }
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/fernExtensions.js
var FernAsyncAPIExtension = {
  /**
   * The x-fern-summary allows you to specify a display name for the websocket channel.
   */
  FERN_DISPLAY_NAME: "x-fern-display-name",
  /**
   * The x-fern-examples allows you to specify examples for the websocket session.
   *
   * channels:
   *   /my-channel:
   *      subscribe:
   *        ...
   *
   *      x-fern-examples:
   *       - name: example-1
   *         summary: This is an example of a websocket session
   *         description: This is a description of the example
   *         messages:
   *           - type: publish
   *             messageId: SendMessage
   *             value:
   *               data: "1223233"
   *           - type: subscribe
   *             messageId: ReceiveMessage
   *             value:
   *              data: "12340213"
   */
  FERN_EXAMPLES: "x-fern-examples",
  /**
   * Prepends the configured base path to all of the endpoint paths.
   *
   * x-fern-base-path: /v1
   * servers:
   *   - url: https://api.example.com
   * paths:
   *   /path/to/my/endpoint:
   */
  BASE_PATH: "x-fern-base-path"
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/getFernExamples.js
function getFernExamples(channel) {
  return getExtension(channel, FernAsyncAPIExtension.FERN_EXAMPLES) ?? [];
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/parse.js
function parseAsyncAPI({ document: document2, taskContext, options, source, asyncApiOptions, namespace }) {
  const breadcrumbs = [];
  if (namespace != null) {
    breadcrumbs.push(namespace);
  }
  if (document2.tags?.[0] != null) {
    breadcrumbs.push(document2.tags[0].name);
  } else if (asyncApiOptions.naming !== "v2") {
    breadcrumbs.push("websocket");
  }
  const context = new AsyncAPIV2ParserContext({
    document: document2,
    taskContext,
    options,
    namespace
  });
  const schemas = {};
  let parsedChannel = void 0;
  for (const [schemaId, schema2] of Object.entries(document2.components?.schemas ?? {})) {
    const convertedSchema = convertSchema(schema2, false, context, [schemaId], source, namespace);
    schemas[schemaId] = convertedSchema;
  }
  const exampleFactory = new ExampleWebsocketSessionFactory(schemas, context);
  for (const [channelPath, channel] of Object.entries(document2.channels ?? {})) {
    if (channel.bindings?.ws == null) {
      context.logger.error(`Channel ${channelPath} does not have websocket bindings. Skipping.`);
      continue;
    }
    const pathParameters = [];
    if (channel.parameters != null) {
      for (const [name, parameter] of Object.entries(channel.parameters ?? {})) {
        pathParameters.push({
          name,
          description: parameter.description,
          parameterNameOverride: void 0,
          schema: parameter.schema != null ? convertSchema(parameter.schema, false, context, breadcrumbs, source, namespace) : SchemaWithExample.primitive({
            schema: PrimitiveSchemaValueWithExample.string({
              default: void 0,
              pattern: void 0,
              format: void 0,
              maxLength: void 0,
              minLength: void 0,
              example: void 0
            }),
            description: void 0,
            availability: void 0,
            generatedName: "",
            title: void 0,
            groupName: void 0,
            nameOverride: void 0
          }),
          variableReference: void 0,
          availability: convertAvailability3(parameter),
          source
        });
      }
    }
    const headers = [];
    if (channel.bindings.ws.headers != null) {
      const required = channel.bindings.ws.headers.required ?? [];
      for (const [name, schema2] of Object.entries(channel.bindings.ws.headers.properties ?? {})) {
        const resolvedHeader = isReferenceObject(schema2) ? context.resolveSchemaReference(schema2) : schema2;
        headers.push({
          name,
          schema: convertSchema(resolvedHeader, !required.includes(name), context, breadcrumbs, source, namespace),
          description: resolvedHeader.description,
          parameterNameOverride: void 0,
          env: void 0,
          availability: convertAvailability3(resolvedHeader),
          source
        });
      }
    }
    const queryParameters = [];
    if (channel.bindings.ws.query != null) {
      const required = channel.bindings.ws.query.required ?? [];
      for (const [name, schema2] of Object.entries(channel.bindings.ws.query.properties ?? {})) {
        const resolvedQueryParameter = isReferenceObject(schema2) ? context.resolveSchemaReference(schema2) : schema2;
        queryParameters.push({
          name,
          schema: convertSchema(resolvedQueryParameter, !required.includes(name), context, breadcrumbs, source, namespace),
          description: resolvedQueryParameter.description,
          parameterNameOverride: void 0,
          availability: convertAvailability3(resolvedQueryParameter),
          source
        });
      }
    }
    let publishSchema = void 0;
    if (channel.publish != null) {
      publishSchema = convertMessageToSchema({
        generatedName: channel.publish.operationId ?? "PublishEvent",
        event: channel.publish,
        breadcrumbs,
        context,
        source,
        options,
        asyncApiOptions
      });
    }
    let subscribeSchema = void 0;
    if (channel.subscribe != null) {
      subscribeSchema = convertMessageToSchema({
        generatedName: channel.subscribe.operationId ?? "SubscribeEvent",
        event: channel.subscribe,
        breadcrumbs,
        context,
        source,
        options,
        asyncApiOptions
      });
    }
    if (headers.length > 0 || queryParameters.length > 0 || publishSchema != null || subscribeSchema != null) {
      const fernExamples = getFernExamples(channel);
      let examples = [];
      if (fernExamples.length > 0) {
        examples = exampleFactory.buildWebsocketSessionExamplesForExtension({
          context,
          extensionExamples: fernExamples,
          handshake: {
            headers,
            queryParameters
          },
          publish: publishSchema,
          subscribe: subscribeSchema,
          source,
          namespace
        });
      } else {
        const autogenExample = exampleFactory.buildWebsocketSessionExample({
          handshake: {
            headers,
            queryParameters
          },
          publish: publishSchema,
          subscribe: subscribeSchema
        });
        if (autogenExample != null) {
          examples.push(autogenExample);
        }
      }
      const tags = document2.tags?.[0]?.name != null ? [document2.tags?.[0].name] : void 0;
      parsedChannel = {
        handshake: {
          headers: headers.map((header) => {
            return {
              ...header,
              schema: convertSchemaWithExampleToSchema(header.schema),
              env: header.env
            };
          }),
          queryParameters: queryParameters.map((param) => {
            return {
              ...param,
              schema: convertSchemaWithExampleToSchema(param.schema)
            };
          }),
          pathParameters: pathParameters.map((param) => {
            return {
              ...param,
              parameterNameOverride: void 0,
              schema: convertSchemaWithExampleToSchema(param.schema)
            };
          })
        },
        groupName: context.resolveTags(tags, "Websocket"),
        publish: publishSchema != null ? convertSchemaWithExampleToSchema(publishSchema) : publishSchema,
        subscribe: subscribeSchema != null ? convertSchemaWithExampleToSchema(subscribeSchema) : subscribeSchema,
        summary: getExtension(channel, FernAsyncAPIExtension.FERN_DISPLAY_NAME),
        path: channelPath,
        description: void 0,
        examples,
        source
      };
      break;
    }
  }
  return {
    groupedSchemas: getSchemas(namespace, schemas),
    channel: parsedChannel,
    basePath: getExtension(document2, FernAsyncAPIExtension.BASE_PATH)
  };
}
function convertMessageToSchema({ generatedName, event, context, breadcrumbs, source, options, asyncApiOptions }) {
  if (event.message.oneOf != null) {
    const subtypes = [];
    const prefixes = [];
    for (const schema2 of event.message.oneOf) {
      let resolvedSchema;
      let namePrefix = { type: "notFound" };
      if (isReferenceObject(schema2)) {
        const resolvedMessage = context.resolveMessageReference(schema2);
        if (!isReferenceObject(resolvedMessage.payload) && asyncApiOptions.naming === "v2") {
          namePrefix = resolvedMessage.name ? { type: "name", name: resolvedMessage.name } : namePrefix;
          resolvedSchema = {
            ...resolvedMessage.payload,
            title: resolvedMessage.name ?? resolvedMessage.payload.title,
            description: resolvedMessage.name ?? resolvedMessage.payload.description
          };
        } else {
          resolvedSchema = resolvedMessage.payload;
        }
      } else {
        resolvedSchema = schema2;
      }
      prefixes.push(namePrefix);
      subtypes.push(resolvedSchema);
    }
    return convertUndiscriminatedOneOf({
      description: event.description ?? event.message.description,
      availability: convertAvailability3(event.message),
      subtypes,
      nameOverride: event.operationId,
      generatedName,
      title: event.message.title,
      groupName: void 0,
      wrapAsNullable: false,
      breadcrumbs,
      context,
      encoding: void 0,
      source,
      namespace: context.namespace,
      subtypePrefixOverrides: asyncApiOptions.naming === "v2" ? prefixes : []
    });
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernAsyncExtension.js
function getFernAsyncExtension(operation) {
  return getExtension(operation, FernOpenAPIExtension.ASYNC_CONFIG);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernStreamingExtension.js
var REQUEST_PREFIX = "$request.";
function getFernStreamingExtension(operation) {
  const streaming = getExtension(operation, FernOpenAPIExtension.STREAMING);
  if (streaming == null) {
    return void 0;
  }
  if (typeof streaming === "boolean") {
    return streaming ? {
      type: "stream",
      format: "json"
    } : void 0;
  }
  if (streaming["stream-condition"] == null && streaming.format != null) {
    return {
      type: "stream",
      format: streaming.format
    };
  }
  return {
    type: "streamCondition",
    format: streaming.format ?? "json",
    streamDescription: streaming["stream-description"],
    streamConditionProperty: maybeTrimRequestPrefix(streaming["stream-condition"]),
    responseStream: streaming["response-stream"],
    response: streaming.response
  };
}
function maybeTrimRequestPrefix(streamCondition) {
  if (streamCondition.startsWith(REQUEST_PREFIX)) {
    return streamCondition.slice(REQUEST_PREFIX.length);
  }
  return streamCondition;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getPaginationExtension.js
function convertPaginationExtension(pagination) {
  const maybeCursorPagination = pagination;
  if (maybeCursorPagination.cursor != null) {
    return Pagination3.cursor({
      cursor: maybeCursorPagination.cursor,
      nextCursor: maybeCursorPagination.next_cursor,
      results: maybeCursorPagination.results
    });
  }
  const maybeOffsetPagination = pagination;
  return Pagination3.offset({
    offset: maybeOffsetPagination.offset,
    results: maybeOffsetPagination.results,
    step: maybeOffsetPagination.step,
    hasNextPage: maybeOffsetPagination["has-next-page"]
  });
}
function getFernPaginationExtension(document2, operation) {
  const pagination = getExtension(operation, FernOpenAPIExtension.PAGINATION);
  if (pagination == null) {
    return void 0;
  }
  if (typeof pagination === "boolean") {
    const topLevelPagination = getExtension(document2, FernOpenAPIExtension.PAGINATION);
    if (typeof topLevelPagination === "boolean") {
      throw new Error("Global pagination extension is a boolean, expected an object. Only endpoints may declare a boolean for x-fern-pagination.");
    }
    return topLevelPagination == null ? void 0 : convertPaginationExtension(topLevelPagination);
  }
  return convertPaginationExtension(pagination);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/getReferenceOccurrences.js
function getReferenceOccurrences(document2) {
  const contentConflictsRemovedDocument = removeApplicationJsonAndMultipartConflictsFromDocument(document2);
  const occurrences = {};
  getReferenceOccurrencesHelper({ obj: contentConflictsRemovedDocument, occurrences, breadcrumbs: [] });
  return occurrences;
}
function getReferenceOccurrencesHelper({ obj, occurrences, breadcrumbs }) {
  if (obj == null) {
    return;
  }
  if (Array.isArray(obj)) {
    for (const element of obj) {
      getReferenceOccurrencesHelper({
        obj: element,
        occurrences,
        breadcrumbs
      });
    }
    return;
  }
  if (typeof obj !== "object") {
    return;
  }
  if (obj.$ref != null && typeof obj.$ref === "string") {
    const refProperty = obj.$ref;
    if (occurrences[refProperty] == null) {
      occurrences[refProperty] = 1;
    } else {
      occurrences[refProperty] += 1;
    }
    return;
  }
  for (const key in obj) {
    getReferenceOccurrencesHelper({
      obj: obj[key],
      occurrences,
      breadcrumbs: [...breadcrumbs, key]
    });
  }
}
function removeApplicationJsonAndMultipartConflictsFromDocument(document2) {
  return {
    ...document2,
    paths: Object.fromEntries(Object.entries(document2.paths ?? {}).map(([path5, pathItem]) => {
      return [
        path5,
        {
          ...pathItem,
          get: pathItem?.get != null ? removeApplicationJsonAndMultipartConflictsFromOperationObject(pathItem.get) : void 0,
          put: pathItem?.put != null ? removeApplicationJsonAndMultipartConflictsFromOperationObject(pathItem.put) : void 0,
          post: pathItem?.post != null ? removeApplicationJsonAndMultipartConflictsFromOperationObject(pathItem.post) : void 0,
          patch: pathItem?.patch != null ? removeApplicationJsonAndMultipartConflictsFromOperationObject(pathItem.patch) : void 0,
          delete: pathItem?.delete != null ? removeApplicationJsonAndMultipartConflictsFromOperationObject(pathItem.delete) : void 0
        }
      ];
    }))
  };
}
function removeApplicationJsonAndMultipartConflictsFromOperationObject(operationObject) {
  return {
    ...operationObject,
    requestBody: operationObject.requestBody != null ? isReferenceObject(operationObject.requestBody) ? operationObject.requestBody : removeApplicationJsonAndMultipartConflictsFromRequestBody(operationObject.requestBody) : void 0
  };
}
function removeApplicationJsonAndMultipartConflictsFromRequestBody(requestBody) {
  let jsonContent;
  let multipartContent;
  for (const mediatype in requestBody.content) {
    const mimetype = MediaType.parse(mediatype);
    if (mimetype == null) {
      continue;
    }
    if (mimetype.isJSON()) {
      jsonContent = requestBody.content[mediatype];
    } else if (mimetype.isMultipart()) {
      multipartContent = requestBody.content[mediatype];
    }
  }
  if (multipartContent != null && jsonContent != null) {
    return {
      ...requestBody,
      content: {
        [MediaType.MULTIPART_FORM_DATA]: multipartContent
      }
    };
  }
  return requestBody;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/AbstractOpenAPIV3ParserContext.js
var PARAMETER_REFERENCE_PREFIX = "#/components/parameters/";
var RESPONSE_REFERENCE_PREFIX = "#/components/responses/";
var EXAMPLES_REFERENCE_PREFIX = "#/components/examples/";
var REQUEST_BODY_REFERENCE_PREFIX = "#/components/requestBodies/";
var AbstractOpenAPIV3ParserContext = class {
  logger;
  document;
  taskContext;
  authHeaders;
  refOccurrences;
  DUMMY;
  options;
  source;
  namespace;
  constructor({ document: document2, taskContext, authHeaders, options, source, namespace }) {
    this.document = document2;
    this.logger = taskContext.logger;
    this.taskContext = taskContext;
    this.authHeaders = authHeaders;
    this.refOccurrences = getReferenceOccurrences(document2);
    this.options = options;
    this.source = source;
    this.DUMMY = this.getDummy();
    this.namespace = namespace;
  }
  getNumberOfOccurrencesForRef(schema2) {
    return this.refOccurrences[schema2.$ref] ?? 0;
  }
  resolveTagsToTagIds(operationTags) {
    const tags = [];
    if (this.namespace != null) {
      tags.push(this.namespace);
    }
    return tags.concat(operationTags ?? []);
  }
  resolveTags(operationTags) {
    const tags = [];
    if (this.namespace != null) {
      const namespaceSegment = {
        type: "namespace",
        name: this.namespace
      };
      tags.push(namespaceSegment);
    }
    return tags.concat(operationTags ?? []);
  }
  resolveGroupName(groupName) {
    if (this.namespace != null) {
      return [{ type: "namespace", name: this.namespace }, ...groupName];
    }
    return groupName;
  }
  resolveSchemaReference(schema2) {
    const keys5 = schema2.$ref.substring(2).split("/").map((key) => key.replace(/~1/g, "/"));
    let resolvedSchema = this.document;
    for (const key of keys5) {
      if (typeof resolvedSchema !== "object" || resolvedSchema == null) {
        return {
          "x-fern-type": "unknown",
          additionalProperties: true
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
        };
      }
      resolvedSchema = resolvedSchema[key];
    }
    if (resolvedSchema == null) {
      return {
        "x-fern-type": "unknown",
        additionalProperties: true
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
      };
    }
    if (isReferenceObject(resolvedSchema)) {
      resolvedSchema = this.resolveSchemaReference(resolvedSchema);
    }
    return resolvedSchema;
  }
  resolveParameterReference(parameter) {
    if (this.document.components == null || this.document.components.parameters == null || !parameter.$ref.startsWith(PARAMETER_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${parameter.$ref}`);
    }
    const parameterKey = parameter.$ref.substring(PARAMETER_REFERENCE_PREFIX.length);
    const resolvedParameter = this.document.components.parameters[parameterKey];
    if (resolvedParameter == null) {
      throw new Error(`${parameter.$ref} is undefined`);
    }
    if (isReferenceObject(resolvedParameter)) {
      return this.resolveParameterReference(resolvedParameter);
    }
    return resolvedParameter;
  }
  resolveRequestBodyReference(requestBody) {
    if (this.document.components == null || this.document.components.requestBodies == null || !requestBody.$ref.startsWith(REQUEST_BODY_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${requestBody.$ref}`);
    }
    const requestBodyKey = requestBody.$ref.substring(REQUEST_BODY_REFERENCE_PREFIX.length);
    const resolvedRequestBody = this.document.components.requestBodies[requestBodyKey];
    if (resolvedRequestBody == null) {
      throw new Error(`${requestBody.$ref} is undefined`);
    }
    if (isReferenceObject(resolvedRequestBody)) {
      return this.resolveRequestBodyReference(resolvedRequestBody);
    }
    return resolvedRequestBody;
  }
  resolveResponseReference(response) {
    if (this.document.components == null || this.document.components.responses == null || !response.$ref.startsWith(RESPONSE_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${response.$ref}`);
    }
    const parameterKey = response.$ref.substring(RESPONSE_REFERENCE_PREFIX.length);
    const resolvedResponse = this.document.components.responses[parameterKey];
    if (resolvedResponse == null) {
      throw new Error(`${response.$ref} is undefined`);
    }
    if (isReferenceObject(resolvedResponse)) {
      return this.resolveResponseReference(resolvedResponse);
    }
    return resolvedResponse;
  }
  resolveExampleReference(example) {
    if (this.document.components == null || this.document.components.examples == null || !example.$ref.startsWith(EXAMPLES_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${example.$ref}`);
    }
    const parameterKey = example.$ref.substring(EXAMPLES_REFERENCE_PREFIX.length);
    const resolvedExample = this.document.components.examples[parameterKey];
    if (resolvedExample == null) {
      throw new Error(`${example.$ref} is undefined`);
    }
    if (isReferenceObject(resolvedExample)) {
      return this.resolveExampleReference(resolvedExample);
    }
    return resolvedExample;
  }
  referenceExists(ref) {
    const keys5 = ref.substring(2).split("/").map((key) => key.replace(/~1/g, "/"));
    let resolvedSchema = this.document;
    for (const key of keys5) {
      if (typeof resolvedSchema !== "object" || resolvedSchema == null) {
        return false;
      }
      resolvedSchema = resolvedSchema[key];
    }
    return true;
  }
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/DummyOpenAPIV3ParserContext.js
var DummyOpenAPIV3ParserContext = class extends AbstractOpenAPIV3ParserContext {
  constructor({ document: document2, taskContext, options, source, namespace }) {
    super({
      document: document2,
      taskContext,
      authHeaders: /* @__PURE__ */ new Set(),
      options,
      source,
      namespace
    });
  }
  getDummy() {
    return this;
  }
  markSchemaAsReferencedByNonRequest(_schemaId) {
    return;
  }
  markSchemaAsReferencedByRequest(_schemaId) {
    return;
  }
  getReferencedSchemas() {
    return /* @__PURE__ */ new Set();
  }
  markReferencedByDiscriminatedUnion(_schema, _discrminant, _times) {
    return;
  }
  getReferencesFromDiscriminatedUnion(_schema) {
    return void 0;
  }
  excludeSchema(_schemaId) {
  }
  isSchemaExcluded(_schemaId) {
    return false;
  }
  markSchemaWithDiscriminantValue(_schema, _discrminant, _discriminantValue) {
    return;
  }
  getDiscriminatedUnionMetadata(_schema) {
    return;
  }
};

// ../../../node_modules/.pnpm/zod@3.23.8/node_modules/zod/lib/index.mjs
var util;
(function(util2) {
  util2.assertEqual = (val) => val;
  function assertIs(_arg) {
  }
  util2.assertIs = assertIs;
  function assertNever2(_x) {
    throw new Error();
  }
  util2.assertNever = assertNever2;
  util2.arrayToEnum = (items) => {
    const obj = {};
    for (const item of items) {
      obj[item] = item;
    }
    return obj;
  };
  util2.getValidEnumValues = (obj) => {
    const validKeys = util2.objectKeys(obj).filter((k) => typeof obj[obj[k]] !== "number");
    const filtered = {};
    for (const k of validKeys) {
      filtered[k] = obj[k];
    }
    return util2.objectValues(filtered);
  };
  util2.objectValues = (obj) => {
    return util2.objectKeys(obj).map(function(e) {
      return obj[e];
    });
  };
  util2.objectKeys = typeof Object.keys === "function" ? (obj) => Object.keys(obj) : (object3) => {
    const keys5 = [];
    for (const key in object3) {
      if (Object.prototype.hasOwnProperty.call(object3, key)) {
        keys5.push(key);
      }
    }
    return keys5;
  };
  util2.find = (arr, checker) => {
    for (const item of arr) {
      if (checker(item))
        return item;
    }
    return void 0;
  };
  util2.isInteger = typeof Number.isInteger === "function" ? (val) => Number.isInteger(val) : (val) => typeof val === "number" && isFinite(val) && Math.floor(val) === val;
  function joinValues(array, separator = " | ") {
    return array.map((val) => typeof val === "string" ? `'${val}'` : val).join(separator);
  }
  util2.joinValues = joinValues;
  util2.jsonStringifyReplacer = (_, value) => {
    if (typeof value === "bigint") {
      return value.toString();
    }
    return value;
  };
})(util || (util = {}));
var objectUtil;
(function(objectUtil2) {
  objectUtil2.mergeShapes = (first, second) => {
    return {
      ...first,
      ...second
      // second overwrites first
    };
  };
})(objectUtil || (objectUtil = {}));
var ZodParsedType = util.arrayToEnum([
  "string",
  "nan",
  "number",
  "integer",
  "float",
  "boolean",
  "date",
  "bigint",
  "symbol",
  "function",
  "undefined",
  "null",
  "array",
  "object",
  "unknown",
  "promise",
  "void",
  "never",
  "map",
  "set"
]);
var getParsedType = (data) => {
  const t = typeof data;
  switch (t) {
    case "undefined":
      return ZodParsedType.undefined;
    case "string":
      return ZodParsedType.string;
    case "number":
      return isNaN(data) ? ZodParsedType.nan : ZodParsedType.number;
    case "boolean":
      return ZodParsedType.boolean;
    case "function":
      return ZodParsedType.function;
    case "bigint":
      return ZodParsedType.bigint;
    case "symbol":
      return ZodParsedType.symbol;
    case "object":
      if (Array.isArray(data)) {
        return ZodParsedType.array;
      }
      if (data === null) {
        return ZodParsedType.null;
      }
      if (data.then && typeof data.then === "function" && data.catch && typeof data.catch === "function") {
        return ZodParsedType.promise;
      }
      if (typeof Map !== "undefined" && data instanceof Map) {
        return ZodParsedType.map;
      }
      if (typeof Set !== "undefined" && data instanceof Set) {
        return ZodParsedType.set;
      }
      if (typeof Date !== "undefined" && data instanceof Date) {
        return ZodParsedType.date;
      }
      return ZodParsedType.object;
    default:
      return ZodParsedType.unknown;
  }
};
var ZodIssueCode = util.arrayToEnum([
  "invalid_type",
  "invalid_literal",
  "custom",
  "invalid_union",
  "invalid_union_discriminator",
  "invalid_enum_value",
  "unrecognized_keys",
  "invalid_arguments",
  "invalid_return_type",
  "invalid_date",
  "invalid_string",
  "too_small",
  "too_big",
  "invalid_intersection_types",
  "not_multiple_of",
  "not_finite"
]);
var quotelessJson = (obj) => {
  const json2 = JSON.stringify(obj, null, 2);
  return json2.replace(/"([^"]+)":/g, "$1:");
};
var ZodError = class _ZodError extends Error {
  constructor(issues) {
    super();
    this.issues = [];
    this.addIssue = (sub) => {
      this.issues = [...this.issues, sub];
    };
    this.addIssues = (subs = []) => {
      this.issues = [...this.issues, ...subs];
    };
    const actualProto = new.target.prototype;
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(this, actualProto);
    } else {
      this.__proto__ = actualProto;
    }
    this.name = "ZodError";
    this.issues = issues;
  }
  get errors() {
    return this.issues;
  }
  format(_mapper) {
    const mapper = _mapper || function(issue) {
      return issue.message;
    };
    const fieldErrors = { _errors: [] };
    const processError = (error) => {
      for (const issue of error.issues) {
        if (issue.code === "invalid_union") {
          issue.unionErrors.map(processError);
        } else if (issue.code === "invalid_return_type") {
          processError(issue.returnTypeError);
        } else if (issue.code === "invalid_arguments") {
          processError(issue.argumentsError);
        } else if (issue.path.length === 0) {
          fieldErrors._errors.push(mapper(issue));
        } else {
          let curr = fieldErrors;
          let i = 0;
          while (i < issue.path.length) {
            const el = issue.path[i];
            const terminal = i === issue.path.length - 1;
            if (!terminal) {
              curr[el] = curr[el] || { _errors: [] };
            } else {
              curr[el] = curr[el] || { _errors: [] };
              curr[el]._errors.push(mapper(issue));
            }
            curr = curr[el];
            i++;
          }
        }
      }
    };
    processError(this);
    return fieldErrors;
  }
  static assert(value) {
    if (!(value instanceof _ZodError)) {
      throw new Error(`Not a ZodError: ${value}`);
    }
  }
  toString() {
    return this.message;
  }
  get message() {
    return JSON.stringify(this.issues, util.jsonStringifyReplacer, 2);
  }
  get isEmpty() {
    return this.issues.length === 0;
  }
  flatten(mapper = (issue) => issue.message) {
    const fieldErrors = {};
    const formErrors = [];
    for (const sub of this.issues) {
      if (sub.path.length > 0) {
        fieldErrors[sub.path[0]] = fieldErrors[sub.path[0]] || [];
        fieldErrors[sub.path[0]].push(mapper(sub));
      } else {
        formErrors.push(mapper(sub));
      }
    }
    return { formErrors, fieldErrors };
  }
  get formErrors() {
    return this.flatten();
  }
};
ZodError.create = (issues) => {
  const error = new ZodError(issues);
  return error;
};
var errorMap = (issue, _ctx) => {
  let message;
  switch (issue.code) {
    case ZodIssueCode.invalid_type:
      if (issue.received === ZodParsedType.undefined) {
        message = "Required";
      } else {
        message = `Expected ${issue.expected}, received ${issue.received}`;
      }
      break;
    case ZodIssueCode.invalid_literal:
      message = `Invalid literal value, expected ${JSON.stringify(issue.expected, util.jsonStringifyReplacer)}`;
      break;
    case ZodIssueCode.unrecognized_keys:
      message = `Unrecognized key(s) in object: ${util.joinValues(issue.keys, ", ")}`;
      break;
    case ZodIssueCode.invalid_union:
      message = `Invalid input`;
      break;
    case ZodIssueCode.invalid_union_discriminator:
      message = `Invalid discriminator value. Expected ${util.joinValues(issue.options)}`;
      break;
    case ZodIssueCode.invalid_enum_value:
      message = `Invalid enum value. Expected ${util.joinValues(issue.options)}, received '${issue.received}'`;
      break;
    case ZodIssueCode.invalid_arguments:
      message = `Invalid function arguments`;
      break;
    case ZodIssueCode.invalid_return_type:
      message = `Invalid function return type`;
      break;
    case ZodIssueCode.invalid_date:
      message = `Invalid date`;
      break;
    case ZodIssueCode.invalid_string:
      if (typeof issue.validation === "object") {
        if ("includes" in issue.validation) {
          message = `Invalid input: must include "${issue.validation.includes}"`;
          if (typeof issue.validation.position === "number") {
            message = `${message} at one or more positions greater than or equal to ${issue.validation.position}`;
          }
        } else if ("startsWith" in issue.validation) {
          message = `Invalid input: must start with "${issue.validation.startsWith}"`;
        } else if ("endsWith" in issue.validation) {
          message = `Invalid input: must end with "${issue.validation.endsWith}"`;
        } else {
          util.assertNever(issue.validation);
        }
      } else if (issue.validation !== "regex") {
        message = `Invalid ${issue.validation}`;
      } else {
        message = "Invalid";
      }
      break;
    case ZodIssueCode.too_small:
      if (issue.type === "array")
        message = `Array must contain ${issue.exact ? "exactly" : issue.inclusive ? `at least` : `more than`} ${issue.minimum} element(s)`;
      else if (issue.type === "string")
        message = `String must contain ${issue.exact ? "exactly" : issue.inclusive ? `at least` : `over`} ${issue.minimum} character(s)`;
      else if (issue.type === "number")
        message = `Number must be ${issue.exact ? `exactly equal to ` : issue.inclusive ? `greater than or equal to ` : `greater than `}${issue.minimum}`;
      else if (issue.type === "date")
        message = `Date must be ${issue.exact ? `exactly equal to ` : issue.inclusive ? `greater than or equal to ` : `greater than `}${new Date(Number(issue.minimum))}`;
      else
        message = "Invalid input";
      break;
    case ZodIssueCode.too_big:
      if (issue.type === "array")
        message = `Array must contain ${issue.exact ? `exactly` : issue.inclusive ? `at most` : `less than`} ${issue.maximum} element(s)`;
      else if (issue.type === "string")
        message = `String must contain ${issue.exact ? `exactly` : issue.inclusive ? `at most` : `under`} ${issue.maximum} character(s)`;
      else if (issue.type === "number")
        message = `Number must be ${issue.exact ? `exactly` : issue.inclusive ? `less than or equal to` : `less than`} ${issue.maximum}`;
      else if (issue.type === "bigint")
        message = `BigInt must be ${issue.exact ? `exactly` : issue.inclusive ? `less than or equal to` : `less than`} ${issue.maximum}`;
      else if (issue.type === "date")
        message = `Date must be ${issue.exact ? `exactly` : issue.inclusive ? `smaller than or equal to` : `smaller than`} ${new Date(Number(issue.maximum))}`;
      else
        message = "Invalid input";
      break;
    case ZodIssueCode.custom:
      message = `Invalid input`;
      break;
    case ZodIssueCode.invalid_intersection_types:
      message = `Intersection results could not be merged`;
      break;
    case ZodIssueCode.not_multiple_of:
      message = `Number must be a multiple of ${issue.multipleOf}`;
      break;
    case ZodIssueCode.not_finite:
      message = "Number must be finite";
      break;
    default:
      message = _ctx.defaultError;
      util.assertNever(issue);
  }
  return { message };
};
var overrideErrorMap = errorMap;
function setErrorMap(map2) {
  overrideErrorMap = map2;
}
function getErrorMap() {
  return overrideErrorMap;
}
var makeIssue = (params) => {
  const { data, path: path5, errorMaps, issueData } = params;
  const fullPath = [...path5, ...issueData.path || []];
  const fullIssue = {
    ...issueData,
    path: fullPath
  };
  if (issueData.message !== void 0) {
    return {
      ...issueData,
      path: fullPath,
      message: issueData.message
    };
  }
  let errorMessage = "";
  const maps = errorMaps.filter((m) => !!m).slice().reverse();
  for (const map2 of maps) {
    errorMessage = map2(fullIssue, { data, defaultError: errorMessage }).message;
  }
  return {
    ...issueData,
    path: fullPath,
    message: errorMessage
  };
};
var EMPTY_PATH = [];
function addIssueToContext(ctx, issueData) {
  const overrideMap = getErrorMap();
  const issue = makeIssue({
    issueData,
    data: ctx.data,
    path: ctx.path,
    errorMaps: [
      ctx.common.contextualErrorMap,
      ctx.schemaErrorMap,
      overrideMap,
      overrideMap === errorMap ? void 0 : errorMap
      // then global default map
    ].filter((x) => !!x)
  });
  ctx.common.issues.push(issue);
}
var ParseStatus = class _ParseStatus {
  constructor() {
    this.value = "valid";
  }
  dirty() {
    if (this.value === "valid")
      this.value = "dirty";
  }
  abort() {
    if (this.value !== "aborted")
      this.value = "aborted";
  }
  static mergeArray(status, results) {
    const arrayValue = [];
    for (const s of results) {
      if (s.status === "aborted")
        return INVALID;
      if (s.status === "dirty")
        status.dirty();
      arrayValue.push(s.value);
    }
    return { status: status.value, value: arrayValue };
  }
  static async mergeObjectAsync(status, pairs2) {
    const syncPairs = [];
    for (const pair of pairs2) {
      const key = await pair.key;
      const value = await pair.value;
      syncPairs.push({
        key,
        value
      });
    }
    return _ParseStatus.mergeObjectSync(status, syncPairs);
  }
  static mergeObjectSync(status, pairs2) {
    const finalObject = {};
    for (const pair of pairs2) {
      const { key, value } = pair;
      if (key.status === "aborted")
        return INVALID;
      if (value.status === "aborted")
        return INVALID;
      if (key.status === "dirty")
        status.dirty();
      if (value.status === "dirty")
        status.dirty();
      if (key.value !== "__proto__" && (typeof value.value !== "undefined" || pair.alwaysSet)) {
        finalObject[key.value] = value.value;
      }
    }
    return { status: status.value, value: finalObject };
  }
};
var INVALID = Object.freeze({
  status: "aborted"
});
var DIRTY = (value) => ({ status: "dirty", value });
var OK = (value) => ({ status: "valid", value });
var isAborted = (x) => x.status === "aborted";
var isDirty = (x) => x.status === "dirty";
var isValid = (x) => x.status === "valid";
var isAsync = (x) => typeof Promise !== "undefined" && x instanceof Promise;
function __classPrivateFieldGet(receiver, state, kind, f) {
  if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
  if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
  return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
}
function __classPrivateFieldSet(receiver, state, value, kind, f) {
  if (kind === "m") throw new TypeError("Private method is not writable");
  if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
  if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
  return kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value), value;
}
var errorUtil;
(function(errorUtil2) {
  errorUtil2.errToObj = (message) => typeof message === "string" ? { message } : message || {};
  errorUtil2.toString = (message) => typeof message === "string" ? message : message === null || message === void 0 ? void 0 : message.message;
})(errorUtil || (errorUtil = {}));
var _ZodEnum_cache;
var _ZodNativeEnum_cache;
var ParseInputLazyPath = class {
  constructor(parent, value, path5, key) {
    this._cachedPath = [];
    this.parent = parent;
    this.data = value;
    this._path = path5;
    this._key = key;
  }
  get path() {
    if (!this._cachedPath.length) {
      if (this._key instanceof Array) {
        this._cachedPath.push(...this._path, ...this._key);
      } else {
        this._cachedPath.push(...this._path, this._key);
      }
    }
    return this._cachedPath;
  }
};
var handleResult = (ctx, result) => {
  if (isValid(result)) {
    return { success: true, data: result.value };
  } else {
    if (!ctx.common.issues.length) {
      throw new Error("Validation failed but no issues detected.");
    }
    return {
      success: false,
      get error() {
        if (this._error)
          return this._error;
        const error = new ZodError(ctx.common.issues);
        this._error = error;
        return this._error;
      }
    };
  }
};
function processCreateParams(params) {
  if (!params)
    return {};
  const { errorMap: errorMap2, invalid_type_error, required_error, description } = params;
  if (errorMap2 && (invalid_type_error || required_error)) {
    throw new Error(`Can't use "invalid_type_error" or "required_error" in conjunction with custom error map.`);
  }
  if (errorMap2)
    return { errorMap: errorMap2, description };
  const customMap = (iss, ctx) => {
    var _a, _b;
    const { message } = params;
    if (iss.code === "invalid_enum_value") {
      return { message: message !== null && message !== void 0 ? message : ctx.defaultError };
    }
    if (typeof ctx.data === "undefined") {
      return { message: (_a = message !== null && message !== void 0 ? message : required_error) !== null && _a !== void 0 ? _a : ctx.defaultError };
    }
    if (iss.code !== "invalid_type")
      return { message: ctx.defaultError };
    return { message: (_b = message !== null && message !== void 0 ? message : invalid_type_error) !== null && _b !== void 0 ? _b : ctx.defaultError };
  };
  return { errorMap: customMap, description };
}
var ZodType = class {
  constructor(def) {
    this.spa = this.safeParseAsync;
    this._def = def;
    this.parse = this.parse.bind(this);
    this.safeParse = this.safeParse.bind(this);
    this.parseAsync = this.parseAsync.bind(this);
    this.safeParseAsync = this.safeParseAsync.bind(this);
    this.spa = this.spa.bind(this);
    this.refine = this.refine.bind(this);
    this.refinement = this.refinement.bind(this);
    this.superRefine = this.superRefine.bind(this);
    this.optional = this.optional.bind(this);
    this.nullable = this.nullable.bind(this);
    this.nullish = this.nullish.bind(this);
    this.array = this.array.bind(this);
    this.promise = this.promise.bind(this);
    this.or = this.or.bind(this);
    this.and = this.and.bind(this);
    this.transform = this.transform.bind(this);
    this.brand = this.brand.bind(this);
    this.default = this.default.bind(this);
    this.catch = this.catch.bind(this);
    this.describe = this.describe.bind(this);
    this.pipe = this.pipe.bind(this);
    this.readonly = this.readonly.bind(this);
    this.isNullable = this.isNullable.bind(this);
    this.isOptional = this.isOptional.bind(this);
  }
  get description() {
    return this._def.description;
  }
  _getType(input) {
    return getParsedType(input.data);
  }
  _getOrReturnCtx(input, ctx) {
    return ctx || {
      common: input.parent.common,
      data: input.data,
      parsedType: getParsedType(input.data),
      schemaErrorMap: this._def.errorMap,
      path: input.path,
      parent: input.parent
    };
  }
  _processInputParams(input) {
    return {
      status: new ParseStatus(),
      ctx: {
        common: input.parent.common,
        data: input.data,
        parsedType: getParsedType(input.data),
        schemaErrorMap: this._def.errorMap,
        path: input.path,
        parent: input.parent
      }
    };
  }
  _parseSync(input) {
    const result = this._parse(input);
    if (isAsync(result)) {
      throw new Error("Synchronous parse encountered promise.");
    }
    return result;
  }
  _parseAsync(input) {
    const result = this._parse(input);
    return Promise.resolve(result);
  }
  parse(data, params) {
    const result = this.safeParse(data, params);
    if (result.success)
      return result.data;
    throw result.error;
  }
  safeParse(data, params) {
    var _a;
    const ctx = {
      common: {
        issues: [],
        async: (_a = params === null || params === void 0 ? void 0 : params.async) !== null && _a !== void 0 ? _a : false,
        contextualErrorMap: params === null || params === void 0 ? void 0 : params.errorMap
      },
      path: (params === null || params === void 0 ? void 0 : params.path) || [],
      schemaErrorMap: this._def.errorMap,
      parent: null,
      data,
      parsedType: getParsedType(data)
    };
    const result = this._parseSync({ data, path: ctx.path, parent: ctx });
    return handleResult(ctx, result);
  }
  async parseAsync(data, params) {
    const result = await this.safeParseAsync(data, params);
    if (result.success)
      return result.data;
    throw result.error;
  }
  async safeParseAsync(data, params) {
    const ctx = {
      common: {
        issues: [],
        contextualErrorMap: params === null || params === void 0 ? void 0 : params.errorMap,
        async: true
      },
      path: (params === null || params === void 0 ? void 0 : params.path) || [],
      schemaErrorMap: this._def.errorMap,
      parent: null,
      data,
      parsedType: getParsedType(data)
    };
    const maybeAsyncResult = this._parse({ data, path: ctx.path, parent: ctx });
    const result = await (isAsync(maybeAsyncResult) ? maybeAsyncResult : Promise.resolve(maybeAsyncResult));
    return handleResult(ctx, result);
  }
  refine(check, message) {
    const getIssueProperties = (val) => {
      if (typeof message === "string" || typeof message === "undefined") {
        return { message };
      } else if (typeof message === "function") {
        return message(val);
      } else {
        return message;
      }
    };
    return this._refinement((val, ctx) => {
      const result = check(val);
      const setError = () => ctx.addIssue({
        code: ZodIssueCode.custom,
        ...getIssueProperties(val)
      });
      if (typeof Promise !== "undefined" && result instanceof Promise) {
        return result.then((data) => {
          if (!data) {
            setError();
            return false;
          } else {
            return true;
          }
        });
      }
      if (!result) {
        setError();
        return false;
      } else {
        return true;
      }
    });
  }
  refinement(check, refinementData) {
    return this._refinement((val, ctx) => {
      if (!check(val)) {
        ctx.addIssue(typeof refinementData === "function" ? refinementData(val, ctx) : refinementData);
        return false;
      } else {
        return true;
      }
    });
  }
  _refinement(refinement) {
    return new ZodEffects({
      schema: this,
      typeName: ZodFirstPartyTypeKind.ZodEffects,
      effect: { type: "refinement", refinement }
    });
  }
  superRefine(refinement) {
    return this._refinement(refinement);
  }
  optional() {
    return ZodOptional.create(this, this._def);
  }
  nullable() {
    return ZodNullable.create(this, this._def);
  }
  nullish() {
    return this.nullable().optional();
  }
  array() {
    return ZodArray.create(this, this._def);
  }
  promise() {
    return ZodPromise.create(this, this._def);
  }
  or(option) {
    return ZodUnion.create([this, option], this._def);
  }
  and(incoming) {
    return ZodIntersection.create(this, incoming, this._def);
  }
  transform(transform3) {
    return new ZodEffects({
      ...processCreateParams(this._def),
      schema: this,
      typeName: ZodFirstPartyTypeKind.ZodEffects,
      effect: { type: "transform", transform: transform3 }
    });
  }
  default(def) {
    const defaultValueFunc = typeof def === "function" ? def : () => def;
    return new ZodDefault({
      ...processCreateParams(this._def),
      innerType: this,
      defaultValue: defaultValueFunc,
      typeName: ZodFirstPartyTypeKind.ZodDefault
    });
  }
  brand() {
    return new ZodBranded({
      typeName: ZodFirstPartyTypeKind.ZodBranded,
      type: this,
      ...processCreateParams(this._def)
    });
  }
  catch(def) {
    const catchValueFunc = typeof def === "function" ? def : () => def;
    return new ZodCatch({
      ...processCreateParams(this._def),
      innerType: this,
      catchValue: catchValueFunc,
      typeName: ZodFirstPartyTypeKind.ZodCatch
    });
  }
  describe(description) {
    const This = this.constructor;
    return new This({
      ...this._def,
      description
    });
  }
  pipe(target) {
    return ZodPipeline.create(this, target);
  }
  readonly() {
    return ZodReadonly.create(this);
  }
  isOptional() {
    return this.safeParse(void 0).success;
  }
  isNullable() {
    return this.safeParse(null).success;
  }
};
var cuidRegex = /^c[^\s-]{8,}$/i;
var cuid2Regex = /^[0-9a-z]+$/;
var ulidRegex = /^[0-9A-HJKMNP-TV-Z]{26}$/;
var uuidRegex = /^[0-9a-fA-F]{8}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{12}$/i;
var nanoidRegex = /^[a-z0-9_-]{21}$/i;
var durationRegex = /^[-+]?P(?!$)(?:(?:[-+]?\d+Y)|(?:[-+]?\d+[.,]\d+Y$))?(?:(?:[-+]?\d+M)|(?:[-+]?\d+[.,]\d+M$))?(?:(?:[-+]?\d+W)|(?:[-+]?\d+[.,]\d+W$))?(?:(?:[-+]?\d+D)|(?:[-+]?\d+[.,]\d+D$))?(?:T(?=[\d+-])(?:(?:[-+]?\d+H)|(?:[-+]?\d+[.,]\d+H$))?(?:(?:[-+]?\d+M)|(?:[-+]?\d+[.,]\d+M$))?(?:[-+]?\d+(?:[.,]\d+)?S)?)??$/;
var emailRegex = /^(?!\.)(?!.*\.\.)([A-Z0-9_'+\-\.]*)[A-Z0-9_+-]@([A-Z0-9][A-Z0-9\-]*\.)+[A-Z]{2,}$/i;
var _emojiRegex = `^(\\p{Extended_Pictographic}|\\p{Emoji_Component})+$`;
var emojiRegex;
var ipv4Regex = /^(?:(?:25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])\.){3}(?:25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])$/;
var ipv6Regex = /^(([a-f0-9]{1,4}:){7}|::([a-f0-9]{1,4}:){0,6}|([a-f0-9]{1,4}:){1}:([a-f0-9]{1,4}:){0,5}|([a-f0-9]{1,4}:){2}:([a-f0-9]{1,4}:){0,4}|([a-f0-9]{1,4}:){3}:([a-f0-9]{1,4}:){0,3}|([a-f0-9]{1,4}:){4}:([a-f0-9]{1,4}:){0,2}|([a-f0-9]{1,4}:){5}:([a-f0-9]{1,4}:){0,1})([a-f0-9]{1,4}|(((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))\.){3}((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2})))$/;
var base64Regex = /^([0-9a-zA-Z+/]{4})*(([0-9a-zA-Z+/]{2}==)|([0-9a-zA-Z+/]{3}=))?$/;
var dateRegexSource = `((\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-((0[13578]|1[02])-(0[1-9]|[12]\\d|3[01])|(0[469]|11)-(0[1-9]|[12]\\d|30)|(02)-(0[1-9]|1\\d|2[0-8])))`;
var dateRegex = new RegExp(`^${dateRegexSource}$`);
function timeRegexSource(args) {
  let regex = `([01]\\d|2[0-3]):[0-5]\\d:[0-5]\\d`;
  if (args.precision) {
    regex = `${regex}\\.\\d{${args.precision}}`;
  } else if (args.precision == null) {
    regex = `${regex}(\\.\\d+)?`;
  }
  return regex;
}
function timeRegex(args) {
  return new RegExp(`^${timeRegexSource(args)}$`);
}
function datetimeRegex(args) {
  let regex = `${dateRegexSource}T${timeRegexSource(args)}`;
  const opts = [];
  opts.push(args.local ? `Z?` : `Z`);
  if (args.offset)
    opts.push(`([+-]\\d{2}:?\\d{2})`);
  regex = `${regex}(${opts.join("|")})`;
  return new RegExp(`^${regex}$`);
}
function isValidIP(ip, version) {
  if ((version === "v4" || !version) && ipv4Regex.test(ip)) {
    return true;
  }
  if ((version === "v6" || !version) && ipv6Regex.test(ip)) {
    return true;
  }
  return false;
}
var ZodString = class _ZodString extends ZodType {
  _parse(input) {
    if (this._def.coerce) {
      input.data = String(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.string) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.string,
        received: ctx2.parsedType
      });
      return INVALID;
    }
    const status = new ParseStatus();
    let ctx = void 0;
    for (const check of this._def.checks) {
      if (check.kind === "min") {
        if (input.data.length < check.value) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_small,
            minimum: check.value,
            type: "string",
            inclusive: true,
            exact: false,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "max") {
        if (input.data.length > check.value) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_big,
            maximum: check.value,
            type: "string",
            inclusive: true,
            exact: false,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "length") {
        const tooBig = input.data.length > check.value;
        const tooSmall = input.data.length < check.value;
        if (tooBig || tooSmall) {
          ctx = this._getOrReturnCtx(input, ctx);
          if (tooBig) {
            addIssueToContext(ctx, {
              code: ZodIssueCode.too_big,
              maximum: check.value,
              type: "string",
              inclusive: true,
              exact: true,
              message: check.message
            });
          } else if (tooSmall) {
            addIssueToContext(ctx, {
              code: ZodIssueCode.too_small,
              minimum: check.value,
              type: "string",
              inclusive: true,
              exact: true,
              message: check.message
            });
          }
          status.dirty();
        }
      } else if (check.kind === "email") {
        if (!emailRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "email",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "emoji") {
        if (!emojiRegex) {
          emojiRegex = new RegExp(_emojiRegex, "u");
        }
        if (!emojiRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "emoji",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "uuid") {
        if (!uuidRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "uuid",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "nanoid") {
        if (!nanoidRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "nanoid",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "cuid") {
        if (!cuidRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "cuid",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "cuid2") {
        if (!cuid2Regex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "cuid2",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "ulid") {
        if (!ulidRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "ulid",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "url") {
        try {
          new URL(input.data);
        } catch (_a) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "url",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "regex") {
        check.regex.lastIndex = 0;
        const testResult = check.regex.test(input.data);
        if (!testResult) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "regex",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "trim") {
        input.data = input.data.trim();
      } else if (check.kind === "includes") {
        if (!input.data.includes(check.value, check.position)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: { includes: check.value, position: check.position },
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "toLowerCase") {
        input.data = input.data.toLowerCase();
      } else if (check.kind === "toUpperCase") {
        input.data = input.data.toUpperCase();
      } else if (check.kind === "startsWith") {
        if (!input.data.startsWith(check.value)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: { startsWith: check.value },
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "endsWith") {
        if (!input.data.endsWith(check.value)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: { endsWith: check.value },
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "datetime") {
        const regex = datetimeRegex(check);
        if (!regex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: "datetime",
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "date") {
        const regex = dateRegex;
        if (!regex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: "date",
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "time") {
        const regex = timeRegex(check);
        if (!regex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: "time",
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "duration") {
        if (!durationRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "duration",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "ip") {
        if (!isValidIP(input.data, check.version)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "ip",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "base64") {
        if (!base64Regex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "base64",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else {
        util.assertNever(check);
      }
    }
    return { status: status.value, value: input.data };
  }
  _regex(regex, validation, message) {
    return this.refinement((data) => regex.test(data), {
      validation,
      code: ZodIssueCode.invalid_string,
      ...errorUtil.errToObj(message)
    });
  }
  _addCheck(check) {
    return new _ZodString({
      ...this._def,
      checks: [...this._def.checks, check]
    });
  }
  email(message) {
    return this._addCheck({ kind: "email", ...errorUtil.errToObj(message) });
  }
  url(message) {
    return this._addCheck({ kind: "url", ...errorUtil.errToObj(message) });
  }
  emoji(message) {
    return this._addCheck({ kind: "emoji", ...errorUtil.errToObj(message) });
  }
  uuid(message) {
    return this._addCheck({ kind: "uuid", ...errorUtil.errToObj(message) });
  }
  nanoid(message) {
    return this._addCheck({ kind: "nanoid", ...errorUtil.errToObj(message) });
  }
  cuid(message) {
    return this._addCheck({ kind: "cuid", ...errorUtil.errToObj(message) });
  }
  cuid2(message) {
    return this._addCheck({ kind: "cuid2", ...errorUtil.errToObj(message) });
  }
  ulid(message) {
    return this._addCheck({ kind: "ulid", ...errorUtil.errToObj(message) });
  }
  base64(message) {
    return this._addCheck({ kind: "base64", ...errorUtil.errToObj(message) });
  }
  ip(options) {
    return this._addCheck({ kind: "ip", ...errorUtil.errToObj(options) });
  }
  datetime(options) {
    var _a, _b;
    if (typeof options === "string") {
      return this._addCheck({
        kind: "datetime",
        precision: null,
        offset: false,
        local: false,
        message: options
      });
    }
    return this._addCheck({
      kind: "datetime",
      precision: typeof (options === null || options === void 0 ? void 0 : options.precision) === "undefined" ? null : options === null || options === void 0 ? void 0 : options.precision,
      offset: (_a = options === null || options === void 0 ? void 0 : options.offset) !== null && _a !== void 0 ? _a : false,
      local: (_b = options === null || options === void 0 ? void 0 : options.local) !== null && _b !== void 0 ? _b : false,
      ...errorUtil.errToObj(options === null || options === void 0 ? void 0 : options.message)
    });
  }
  date(message) {
    return this._addCheck({ kind: "date", message });
  }
  time(options) {
    if (typeof options === "string") {
      return this._addCheck({
        kind: "time",
        precision: null,
        message: options
      });
    }
    return this._addCheck({
      kind: "time",
      precision: typeof (options === null || options === void 0 ? void 0 : options.precision) === "undefined" ? null : options === null || options === void 0 ? void 0 : options.precision,
      ...errorUtil.errToObj(options === null || options === void 0 ? void 0 : options.message)
    });
  }
  duration(message) {
    return this._addCheck({ kind: "duration", ...errorUtil.errToObj(message) });
  }
  regex(regex, message) {
    return this._addCheck({
      kind: "regex",
      regex,
      ...errorUtil.errToObj(message)
    });
  }
  includes(value, options) {
    return this._addCheck({
      kind: "includes",
      value,
      position: options === null || options === void 0 ? void 0 : options.position,
      ...errorUtil.errToObj(options === null || options === void 0 ? void 0 : options.message)
    });
  }
  startsWith(value, message) {
    return this._addCheck({
      kind: "startsWith",
      value,
      ...errorUtil.errToObj(message)
    });
  }
  endsWith(value, message) {
    return this._addCheck({
      kind: "endsWith",
      value,
      ...errorUtil.errToObj(message)
    });
  }
  min(minLength, message) {
    return this._addCheck({
      kind: "min",
      value: minLength,
      ...errorUtil.errToObj(message)
    });
  }
  max(maxLength, message) {
    return this._addCheck({
      kind: "max",
      value: maxLength,
      ...errorUtil.errToObj(message)
    });
  }
  length(len, message) {
    return this._addCheck({
      kind: "length",
      value: len,
      ...errorUtil.errToObj(message)
    });
  }
  /**
   * @deprecated Use z.string().min(1) instead.
   * @see {@link ZodString.min}
   */
  nonempty(message) {
    return this.min(1, errorUtil.errToObj(message));
  }
  trim() {
    return new _ZodString({
      ...this._def,
      checks: [...this._def.checks, { kind: "trim" }]
    });
  }
  toLowerCase() {
    return new _ZodString({
      ...this._def,
      checks: [...this._def.checks, { kind: "toLowerCase" }]
    });
  }
  toUpperCase() {
    return new _ZodString({
      ...this._def,
      checks: [...this._def.checks, { kind: "toUpperCase" }]
    });
  }
  get isDatetime() {
    return !!this._def.checks.find((ch) => ch.kind === "datetime");
  }
  get isDate() {
    return !!this._def.checks.find((ch) => ch.kind === "date");
  }
  get isTime() {
    return !!this._def.checks.find((ch) => ch.kind === "time");
  }
  get isDuration() {
    return !!this._def.checks.find((ch) => ch.kind === "duration");
  }
  get isEmail() {
    return !!this._def.checks.find((ch) => ch.kind === "email");
  }
  get isURL() {
    return !!this._def.checks.find((ch) => ch.kind === "url");
  }
  get isEmoji() {
    return !!this._def.checks.find((ch) => ch.kind === "emoji");
  }
  get isUUID() {
    return !!this._def.checks.find((ch) => ch.kind === "uuid");
  }
  get isNANOID() {
    return !!this._def.checks.find((ch) => ch.kind === "nanoid");
  }
  get isCUID() {
    return !!this._def.checks.find((ch) => ch.kind === "cuid");
  }
  get isCUID2() {
    return !!this._def.checks.find((ch) => ch.kind === "cuid2");
  }
  get isULID() {
    return !!this._def.checks.find((ch) => ch.kind === "ulid");
  }
  get isIP() {
    return !!this._def.checks.find((ch) => ch.kind === "ip");
  }
  get isBase64() {
    return !!this._def.checks.find((ch) => ch.kind === "base64");
  }
  get minLength() {
    let min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "min") {
        if (min === null || ch.value > min)
          min = ch.value;
      }
    }
    return min;
  }
  get maxLength() {
    let max = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "max") {
        if (max === null || ch.value < max)
          max = ch.value;
      }
    }
    return max;
  }
};
ZodString.create = (params) => {
  var _a;
  return new ZodString({
    checks: [],
    typeName: ZodFirstPartyTypeKind.ZodString,
    coerce: (_a = params === null || params === void 0 ? void 0 : params.coerce) !== null && _a !== void 0 ? _a : false,
    ...processCreateParams(params)
  });
};
function floatSafeRemainder(val, step) {
  const valDecCount = (val.toString().split(".")[1] || "").length;
  const stepDecCount = (step.toString().split(".")[1] || "").length;
  const decCount = valDecCount > stepDecCount ? valDecCount : stepDecCount;
  const valInt = parseInt(val.toFixed(decCount).replace(".", ""));
  const stepInt = parseInt(step.toFixed(decCount).replace(".", ""));
  return valInt % stepInt / Math.pow(10, decCount);
}
var ZodNumber = class _ZodNumber extends ZodType {
  constructor() {
    super(...arguments);
    this.min = this.gte;
    this.max = this.lte;
    this.step = this.multipleOf;
  }
  _parse(input) {
    if (this._def.coerce) {
      input.data = Number(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.number) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.number,
        received: ctx2.parsedType
      });
      return INVALID;
    }
    let ctx = void 0;
    const status = new ParseStatus();
    for (const check of this._def.checks) {
      if (check.kind === "int") {
        if (!util.isInteger(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_type,
            expected: "integer",
            received: "float",
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "min") {
        const tooSmall = check.inclusive ? input.data < check.value : input.data <= check.value;
        if (tooSmall) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_small,
            minimum: check.value,
            type: "number",
            inclusive: check.inclusive,
            exact: false,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "max") {
        const tooBig = check.inclusive ? input.data > check.value : input.data >= check.value;
        if (tooBig) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_big,
            maximum: check.value,
            type: "number",
            inclusive: check.inclusive,
            exact: false,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "multipleOf") {
        if (floatSafeRemainder(input.data, check.value) !== 0) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.not_multiple_of,
            multipleOf: check.value,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "finite") {
        if (!Number.isFinite(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.not_finite,
            message: check.message
          });
          status.dirty();
        }
      } else {
        util.assertNever(check);
      }
    }
    return { status: status.value, value: input.data };
  }
  gte(value, message) {
    return this.setLimit("min", value, true, errorUtil.toString(message));
  }
  gt(value, message) {
    return this.setLimit("min", value, false, errorUtil.toString(message));
  }
  lte(value, message) {
    return this.setLimit("max", value, true, errorUtil.toString(message));
  }
  lt(value, message) {
    return this.setLimit("max", value, false, errorUtil.toString(message));
  }
  setLimit(kind, value, inclusive, message) {
    return new _ZodNumber({
      ...this._def,
      checks: [
        ...this._def.checks,
        {
          kind,
          value,
          inclusive,
          message: errorUtil.toString(message)
        }
      ]
    });
  }
  _addCheck(check) {
    return new _ZodNumber({
      ...this._def,
      checks: [...this._def.checks, check]
    });
  }
  int(message) {
    return this._addCheck({
      kind: "int",
      message: errorUtil.toString(message)
    });
  }
  positive(message) {
    return this._addCheck({
      kind: "min",
      value: 0,
      inclusive: false,
      message: errorUtil.toString(message)
    });
  }
  negative(message) {
    return this._addCheck({
      kind: "max",
      value: 0,
      inclusive: false,
      message: errorUtil.toString(message)
    });
  }
  nonpositive(message) {
    return this._addCheck({
      kind: "max",
      value: 0,
      inclusive: true,
      message: errorUtil.toString(message)
    });
  }
  nonnegative(message) {
    return this._addCheck({
      kind: "min",
      value: 0,
      inclusive: true,
      message: errorUtil.toString(message)
    });
  }
  multipleOf(value, message) {
    return this._addCheck({
      kind: "multipleOf",
      value,
      message: errorUtil.toString(message)
    });
  }
  finite(message) {
    return this._addCheck({
      kind: "finite",
      message: errorUtil.toString(message)
    });
  }
  safe(message) {
    return this._addCheck({
      kind: "min",
      inclusive: true,
      value: Number.MIN_SAFE_INTEGER,
      message: errorUtil.toString(message)
    })._addCheck({
      kind: "max",
      inclusive: true,
      value: Number.MAX_SAFE_INTEGER,
      message: errorUtil.toString(message)
    });
  }
  get minValue() {
    let min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "min") {
        if (min === null || ch.value > min)
          min = ch.value;
      }
    }
    return min;
  }
  get maxValue() {
    let max = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "max") {
        if (max === null || ch.value < max)
          max = ch.value;
      }
    }
    return max;
  }
  get isInt() {
    return !!this._def.checks.find((ch) => ch.kind === "int" || ch.kind === "multipleOf" && util.isInteger(ch.value));
  }
  get isFinite() {
    let max = null, min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "finite" || ch.kind === "int" || ch.kind === "multipleOf") {
        return true;
      } else if (ch.kind === "min") {
        if (min === null || ch.value > min)
          min = ch.value;
      } else if (ch.kind === "max") {
        if (max === null || ch.value < max)
          max = ch.value;
      }
    }
    return Number.isFinite(min) && Number.isFinite(max);
  }
};
ZodNumber.create = (params) => {
  return new ZodNumber({
    checks: [],
    typeName: ZodFirstPartyTypeKind.ZodNumber,
    coerce: (params === null || params === void 0 ? void 0 : params.coerce) || false,
    ...processCreateParams(params)
  });
};
var ZodBigInt = class _ZodBigInt extends ZodType {
  constructor() {
    super(...arguments);
    this.min = this.gte;
    this.max = this.lte;
  }
  _parse(input) {
    if (this._def.coerce) {
      input.data = BigInt(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.bigint) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.bigint,
        received: ctx2.parsedType
      });
      return INVALID;
    }
    let ctx = void 0;
    const status = new ParseStatus();
    for (const check of this._def.checks) {
      if (check.kind === "min") {
        const tooSmall = check.inclusive ? input.data < check.value : input.data <= check.value;
        if (tooSmall) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_small,
            type: "bigint",
            minimum: check.value,
            inclusive: check.inclusive,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "max") {
        const tooBig = check.inclusive ? input.data > check.value : input.data >= check.value;
        if (tooBig) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_big,
            type: "bigint",
            maximum: check.value,
            inclusive: check.inclusive,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "multipleOf") {
        if (input.data % check.value !== BigInt(0)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.not_multiple_of,
            multipleOf: check.value,
            message: check.message
          });
          status.dirty();
        }
      } else {
        util.assertNever(check);
      }
    }
    return { status: status.value, value: input.data };
  }
  gte(value, message) {
    return this.setLimit("min", value, true, errorUtil.toString(message));
  }
  gt(value, message) {
    return this.setLimit("min", value, false, errorUtil.toString(message));
  }
  lte(value, message) {
    return this.setLimit("max", value, true, errorUtil.toString(message));
  }
  lt(value, message) {
    return this.setLimit("max", value, false, errorUtil.toString(message));
  }
  setLimit(kind, value, inclusive, message) {
    return new _ZodBigInt({
      ...this._def,
      checks: [
        ...this._def.checks,
        {
          kind,
          value,
          inclusive,
          message: errorUtil.toString(message)
        }
      ]
    });
  }
  _addCheck(check) {
    return new _ZodBigInt({
      ...this._def,
      checks: [...this._def.checks, check]
    });
  }
  positive(message) {
    return this._addCheck({
      kind: "min",
      value: BigInt(0),
      inclusive: false,
      message: errorUtil.toString(message)
    });
  }
  negative(message) {
    return this._addCheck({
      kind: "max",
      value: BigInt(0),
      inclusive: false,
      message: errorUtil.toString(message)
    });
  }
  nonpositive(message) {
    return this._addCheck({
      kind: "max",
      value: BigInt(0),
      inclusive: true,
      message: errorUtil.toString(message)
    });
  }
  nonnegative(message) {
    return this._addCheck({
      kind: "min",
      value: BigInt(0),
      inclusive: true,
      message: errorUtil.toString(message)
    });
  }
  multipleOf(value, message) {
    return this._addCheck({
      kind: "multipleOf",
      value,
      message: errorUtil.toString(message)
    });
  }
  get minValue() {
    let min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "min") {
        if (min === null || ch.value > min)
          min = ch.value;
      }
    }
    return min;
  }
  get maxValue() {
    let max = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "max") {
        if (max === null || ch.value < max)
          max = ch.value;
      }
    }
    return max;
  }
};
ZodBigInt.create = (params) => {
  var _a;
  return new ZodBigInt({
    checks: [],
    typeName: ZodFirstPartyTypeKind.ZodBigInt,
    coerce: (_a = params === null || params === void 0 ? void 0 : params.coerce) !== null && _a !== void 0 ? _a : false,
    ...processCreateParams(params)
  });
};
var ZodBoolean = class extends ZodType {
  _parse(input) {
    if (this._def.coerce) {
      input.data = Boolean(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.boolean) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.boolean,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return OK(input.data);
  }
};
ZodBoolean.create = (params) => {
  return new ZodBoolean({
    typeName: ZodFirstPartyTypeKind.ZodBoolean,
    coerce: (params === null || params === void 0 ? void 0 : params.coerce) || false,
    ...processCreateParams(params)
  });
};
var ZodDate = class _ZodDate extends ZodType {
  _parse(input) {
    if (this._def.coerce) {
      input.data = new Date(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.date) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.date,
        received: ctx2.parsedType
      });
      return INVALID;
    }
    if (isNaN(input.data.getTime())) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_date
      });
      return INVALID;
    }
    const status = new ParseStatus();
    let ctx = void 0;
    for (const check of this._def.checks) {
      if (check.kind === "min") {
        if (input.data.getTime() < check.value) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_small,
            message: check.message,
            inclusive: true,
            exact: false,
            minimum: check.value,
            type: "date"
          });
          status.dirty();
        }
      } else if (check.kind === "max") {
        if (input.data.getTime() > check.value) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_big,
            message: check.message,
            inclusive: true,
            exact: false,
            maximum: check.value,
            type: "date"
          });
          status.dirty();
        }
      } else {
        util.assertNever(check);
      }
    }
    return {
      status: status.value,
      value: new Date(input.data.getTime())
    };
  }
  _addCheck(check) {
    return new _ZodDate({
      ...this._def,
      checks: [...this._def.checks, check]
    });
  }
  min(minDate, message) {
    return this._addCheck({
      kind: "min",
      value: minDate.getTime(),
      message: errorUtil.toString(message)
    });
  }
  max(maxDate, message) {
    return this._addCheck({
      kind: "max",
      value: maxDate.getTime(),
      message: errorUtil.toString(message)
    });
  }
  get minDate() {
    let min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "min") {
        if (min === null || ch.value > min)
          min = ch.value;
      }
    }
    return min != null ? new Date(min) : null;
  }
  get maxDate() {
    let max = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "max") {
        if (max === null || ch.value < max)
          max = ch.value;
      }
    }
    return max != null ? new Date(max) : null;
  }
};
ZodDate.create = (params) => {
  return new ZodDate({
    checks: [],
    coerce: (params === null || params === void 0 ? void 0 : params.coerce) || false,
    typeName: ZodFirstPartyTypeKind.ZodDate,
    ...processCreateParams(params)
  });
};
var ZodSymbol = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.symbol) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.symbol,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return OK(input.data);
  }
};
ZodSymbol.create = (params) => {
  return new ZodSymbol({
    typeName: ZodFirstPartyTypeKind.ZodSymbol,
    ...processCreateParams(params)
  });
};
var ZodUndefined = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.undefined) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.undefined,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return OK(input.data);
  }
};
ZodUndefined.create = (params) => {
  return new ZodUndefined({
    typeName: ZodFirstPartyTypeKind.ZodUndefined,
    ...processCreateParams(params)
  });
};
var ZodNull = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.null) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.null,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return OK(input.data);
  }
};
ZodNull.create = (params) => {
  return new ZodNull({
    typeName: ZodFirstPartyTypeKind.ZodNull,
    ...processCreateParams(params)
  });
};
var ZodAny = class extends ZodType {
  constructor() {
    super(...arguments);
    this._any = true;
  }
  _parse(input) {
    return OK(input.data);
  }
};
ZodAny.create = (params) => {
  return new ZodAny({
    typeName: ZodFirstPartyTypeKind.ZodAny,
    ...processCreateParams(params)
  });
};
var ZodUnknown = class extends ZodType {
  constructor() {
    super(...arguments);
    this._unknown = true;
  }
  _parse(input) {
    return OK(input.data);
  }
};
ZodUnknown.create = (params) => {
  return new ZodUnknown({
    typeName: ZodFirstPartyTypeKind.ZodUnknown,
    ...processCreateParams(params)
  });
};
var ZodNever = class extends ZodType {
  _parse(input) {
    const ctx = this._getOrReturnCtx(input);
    addIssueToContext(ctx, {
      code: ZodIssueCode.invalid_type,
      expected: ZodParsedType.never,
      received: ctx.parsedType
    });
    return INVALID;
  }
};
ZodNever.create = (params) => {
  return new ZodNever({
    typeName: ZodFirstPartyTypeKind.ZodNever,
    ...processCreateParams(params)
  });
};
var ZodVoid = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.undefined) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.void,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return OK(input.data);
  }
};
ZodVoid.create = (params) => {
  return new ZodVoid({
    typeName: ZodFirstPartyTypeKind.ZodVoid,
    ...processCreateParams(params)
  });
};
var ZodArray = class _ZodArray extends ZodType {
  _parse(input) {
    const { ctx, status } = this._processInputParams(input);
    const def = this._def;
    if (ctx.parsedType !== ZodParsedType.array) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.array,
        received: ctx.parsedType
      });
      return INVALID;
    }
    if (def.exactLength !== null) {
      const tooBig = ctx.data.length > def.exactLength.value;
      const tooSmall = ctx.data.length < def.exactLength.value;
      if (tooBig || tooSmall) {
        addIssueToContext(ctx, {
          code: tooBig ? ZodIssueCode.too_big : ZodIssueCode.too_small,
          minimum: tooSmall ? def.exactLength.value : void 0,
          maximum: tooBig ? def.exactLength.value : void 0,
          type: "array",
          inclusive: true,
          exact: true,
          message: def.exactLength.message
        });
        status.dirty();
      }
    }
    if (def.minLength !== null) {
      if (ctx.data.length < def.minLength.value) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.too_small,
          minimum: def.minLength.value,
          type: "array",
          inclusive: true,
          exact: false,
          message: def.minLength.message
        });
        status.dirty();
      }
    }
    if (def.maxLength !== null) {
      if (ctx.data.length > def.maxLength.value) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.too_big,
          maximum: def.maxLength.value,
          type: "array",
          inclusive: true,
          exact: false,
          message: def.maxLength.message
        });
        status.dirty();
      }
    }
    if (ctx.common.async) {
      return Promise.all([...ctx.data].map((item, i) => {
        return def.type._parseAsync(new ParseInputLazyPath(ctx, item, ctx.path, i));
      })).then((result2) => {
        return ParseStatus.mergeArray(status, result2);
      });
    }
    const result = [...ctx.data].map((item, i) => {
      return def.type._parseSync(new ParseInputLazyPath(ctx, item, ctx.path, i));
    });
    return ParseStatus.mergeArray(status, result);
  }
  get element() {
    return this._def.type;
  }
  min(minLength, message) {
    return new _ZodArray({
      ...this._def,
      minLength: { value: minLength, message: errorUtil.toString(message) }
    });
  }
  max(maxLength, message) {
    return new _ZodArray({
      ...this._def,
      maxLength: { value: maxLength, message: errorUtil.toString(message) }
    });
  }
  length(len, message) {
    return new _ZodArray({
      ...this._def,
      exactLength: { value: len, message: errorUtil.toString(message) }
    });
  }
  nonempty(message) {
    return this.min(1, message);
  }
};
ZodArray.create = (schema2, params) => {
  return new ZodArray({
    type: schema2,
    minLength: null,
    maxLength: null,
    exactLength: null,
    typeName: ZodFirstPartyTypeKind.ZodArray,
    ...processCreateParams(params)
  });
};
function deepPartialify(schema2) {
  if (schema2 instanceof ZodObject) {
    const newShape = {};
    for (const key in schema2.shape) {
      const fieldSchema = schema2.shape[key];
      newShape[key] = ZodOptional.create(deepPartialify(fieldSchema));
    }
    return new ZodObject({
      ...schema2._def,
      shape: () => newShape
    });
  } else if (schema2 instanceof ZodArray) {
    return new ZodArray({
      ...schema2._def,
      type: deepPartialify(schema2.element)
    });
  } else if (schema2 instanceof ZodOptional) {
    return ZodOptional.create(deepPartialify(schema2.unwrap()));
  } else if (schema2 instanceof ZodNullable) {
    return ZodNullable.create(deepPartialify(schema2.unwrap()));
  } else if (schema2 instanceof ZodTuple) {
    return ZodTuple.create(schema2.items.map((item) => deepPartialify(item)));
  } else {
    return schema2;
  }
}
var ZodObject = class _ZodObject extends ZodType {
  constructor() {
    super(...arguments);
    this._cached = null;
    this.nonstrict = this.passthrough;
    this.augment = this.extend;
  }
  _getCached() {
    if (this._cached !== null)
      return this._cached;
    const shape = this._def.shape();
    const keys5 = util.objectKeys(shape);
    return this._cached = { shape, keys: keys5 };
  }
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.object) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.object,
        received: ctx2.parsedType
      });
      return INVALID;
    }
    const { status, ctx } = this._processInputParams(input);
    const { shape, keys: shapeKeys } = this._getCached();
    const extraKeys = [];
    if (!(this._def.catchall instanceof ZodNever && this._def.unknownKeys === "strip")) {
      for (const key in ctx.data) {
        if (!shapeKeys.includes(key)) {
          extraKeys.push(key);
        }
      }
    }
    const pairs2 = [];
    for (const key of shapeKeys) {
      const keyValidator = shape[key];
      const value = ctx.data[key];
      pairs2.push({
        key: { status: "valid", value: key },
        value: keyValidator._parse(new ParseInputLazyPath(ctx, value, ctx.path, key)),
        alwaysSet: key in ctx.data
      });
    }
    if (this._def.catchall instanceof ZodNever) {
      const unknownKeys = this._def.unknownKeys;
      if (unknownKeys === "passthrough") {
        for (const key of extraKeys) {
          pairs2.push({
            key: { status: "valid", value: key },
            value: { status: "valid", value: ctx.data[key] }
          });
        }
      } else if (unknownKeys === "strict") {
        if (extraKeys.length > 0) {
          addIssueToContext(ctx, {
            code: ZodIssueCode.unrecognized_keys,
            keys: extraKeys
          });
          status.dirty();
        }
      } else if (unknownKeys === "strip") ;
      else {
        throw new Error(`Internal ZodObject error: invalid unknownKeys value.`);
      }
    } else {
      const catchall = this._def.catchall;
      for (const key of extraKeys) {
        const value = ctx.data[key];
        pairs2.push({
          key: { status: "valid", value: key },
          value: catchall._parse(
            new ParseInputLazyPath(ctx, value, ctx.path, key)
            //, ctx.child(key), value, getParsedType(value)
          ),
          alwaysSet: key in ctx.data
        });
      }
    }
    if (ctx.common.async) {
      return Promise.resolve().then(async () => {
        const syncPairs = [];
        for (const pair of pairs2) {
          const key = await pair.key;
          const value = await pair.value;
          syncPairs.push({
            key,
            value,
            alwaysSet: pair.alwaysSet
          });
        }
        return syncPairs;
      }).then((syncPairs) => {
        return ParseStatus.mergeObjectSync(status, syncPairs);
      });
    } else {
      return ParseStatus.mergeObjectSync(status, pairs2);
    }
  }
  get shape() {
    return this._def.shape();
  }
  strict(message) {
    errorUtil.errToObj;
    return new _ZodObject({
      ...this._def,
      unknownKeys: "strict",
      ...message !== void 0 ? {
        errorMap: (issue, ctx) => {
          var _a, _b, _c, _d;
          const defaultError = (_c = (_b = (_a = this._def).errorMap) === null || _b === void 0 ? void 0 : _b.call(_a, issue, ctx).message) !== null && _c !== void 0 ? _c : ctx.defaultError;
          if (issue.code === "unrecognized_keys")
            return {
              message: (_d = errorUtil.errToObj(message).message) !== null && _d !== void 0 ? _d : defaultError
            };
          return {
            message: defaultError
          };
        }
      } : {}
    });
  }
  strip() {
    return new _ZodObject({
      ...this._def,
      unknownKeys: "strip"
    });
  }
  passthrough() {
    return new _ZodObject({
      ...this._def,
      unknownKeys: "passthrough"
    });
  }
  // const AugmentFactory =
  //   <Def extends ZodObjectDef>(def: Def) =>
  //   <Augmentation extends ZodRawShape>(
  //     augmentation: Augmentation
  //   ): ZodObject<
  //     extendShape<ReturnType<Def["shape"]>, Augmentation>,
  //     Def["unknownKeys"],
  //     Def["catchall"]
  //   > => {
  //     return new ZodObject({
  //       ...def,
  //       shape: () => ({
  //         ...def.shape(),
  //         ...augmentation,
  //       }),
  //     }) as any;
  //   };
  extend(augmentation) {
    return new _ZodObject({
      ...this._def,
      shape: () => ({
        ...this._def.shape(),
        ...augmentation
      })
    });
  }
  /**
   * Prior to zod@1.0.12 there was a bug in the
   * inferred type of merged objects. Please
   * upgrade if you are experiencing issues.
   */
  merge(merging) {
    const merged = new _ZodObject({
      unknownKeys: merging._def.unknownKeys,
      catchall: merging._def.catchall,
      shape: () => ({
        ...this._def.shape(),
        ...merging._def.shape()
      }),
      typeName: ZodFirstPartyTypeKind.ZodObject
    });
    return merged;
  }
  // merge<
  //   Incoming extends AnyZodObject,
  //   Augmentation extends Incoming["shape"],
  //   NewOutput extends {
  //     [k in keyof Augmentation | keyof Output]: k extends keyof Augmentation
  //       ? Augmentation[k]["_output"]
  //       : k extends keyof Output
  //       ? Output[k]
  //       : never;
  //   },
  //   NewInput extends {
  //     [k in keyof Augmentation | keyof Input]: k extends keyof Augmentation
  //       ? Augmentation[k]["_input"]
  //       : k extends keyof Input
  //       ? Input[k]
  //       : never;
  //   }
  // >(
  //   merging: Incoming
  // ): ZodObject<
  //   extendShape<T, ReturnType<Incoming["_def"]["shape"]>>,
  //   Incoming["_def"]["unknownKeys"],
  //   Incoming["_def"]["catchall"],
  //   NewOutput,
  //   NewInput
  // > {
  //   const merged: any = new ZodObject({
  //     unknownKeys: merging._def.unknownKeys,
  //     catchall: merging._def.catchall,
  //     shape: () =>
  //       objectUtil.mergeShapes(this._def.shape(), merging._def.shape()),
  //     typeName: ZodFirstPartyTypeKind.ZodObject,
  //   }) as any;
  //   return merged;
  // }
  setKey(key, schema2) {
    return this.augment({ [key]: schema2 });
  }
  // merge<Incoming extends AnyZodObject>(
  //   merging: Incoming
  // ): //ZodObject<T & Incoming["_shape"], UnknownKeys, Catchall> = (merging) => {
  // ZodObject<
  //   extendShape<T, ReturnType<Incoming["_def"]["shape"]>>,
  //   Incoming["_def"]["unknownKeys"],
  //   Incoming["_def"]["catchall"]
  // > {
  //   // const mergedShape = objectUtil.mergeShapes(
  //   //   this._def.shape(),
  //   //   merging._def.shape()
  //   // );
  //   const merged: any = new ZodObject({
  //     unknownKeys: merging._def.unknownKeys,
  //     catchall: merging._def.catchall,
  //     shape: () =>
  //       objectUtil.mergeShapes(this._def.shape(), merging._def.shape()),
  //     typeName: ZodFirstPartyTypeKind.ZodObject,
  //   }) as any;
  //   return merged;
  // }
  catchall(index) {
    return new _ZodObject({
      ...this._def,
      catchall: index
    });
  }
  pick(mask) {
    const shape = {};
    util.objectKeys(mask).forEach((key) => {
      if (mask[key] && this.shape[key]) {
        shape[key] = this.shape[key];
      }
    });
    return new _ZodObject({
      ...this._def,
      shape: () => shape
    });
  }
  omit(mask) {
    const shape = {};
    util.objectKeys(this.shape).forEach((key) => {
      if (!mask[key]) {
        shape[key] = this.shape[key];
      }
    });
    return new _ZodObject({
      ...this._def,
      shape: () => shape
    });
  }
  /**
   * @deprecated
   */
  deepPartial() {
    return deepPartialify(this);
  }
  partial(mask) {
    const newShape = {};
    util.objectKeys(this.shape).forEach((key) => {
      const fieldSchema = this.shape[key];
      if (mask && !mask[key]) {
        newShape[key] = fieldSchema;
      } else {
        newShape[key] = fieldSchema.optional();
      }
    });
    return new _ZodObject({
      ...this._def,
      shape: () => newShape
    });
  }
  required(mask) {
    const newShape = {};
    util.objectKeys(this.shape).forEach((key) => {
      if (mask && !mask[key]) {
        newShape[key] = this.shape[key];
      } else {
        const fieldSchema = this.shape[key];
        let newField = fieldSchema;
        while (newField instanceof ZodOptional) {
          newField = newField._def.innerType;
        }
        newShape[key] = newField;
      }
    });
    return new _ZodObject({
      ...this._def,
      shape: () => newShape
    });
  }
  keyof() {
    return createZodEnum(util.objectKeys(this.shape));
  }
};
ZodObject.create = (shape, params) => {
  return new ZodObject({
    shape: () => shape,
    unknownKeys: "strip",
    catchall: ZodNever.create(),
    typeName: ZodFirstPartyTypeKind.ZodObject,
    ...processCreateParams(params)
  });
};
ZodObject.strictCreate = (shape, params) => {
  return new ZodObject({
    shape: () => shape,
    unknownKeys: "strict",
    catchall: ZodNever.create(),
    typeName: ZodFirstPartyTypeKind.ZodObject,
    ...processCreateParams(params)
  });
};
ZodObject.lazycreate = (shape, params) => {
  return new ZodObject({
    shape,
    unknownKeys: "strip",
    catchall: ZodNever.create(),
    typeName: ZodFirstPartyTypeKind.ZodObject,
    ...processCreateParams(params)
  });
};
var ZodUnion = class extends ZodType {
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    const options = this._def.options;
    function handleResults(results) {
      for (const result of results) {
        if (result.result.status === "valid") {
          return result.result;
        }
      }
      for (const result of results) {
        if (result.result.status === "dirty") {
          ctx.common.issues.push(...result.ctx.common.issues);
          return result.result;
        }
      }
      const unionErrors = results.map((result) => new ZodError(result.ctx.common.issues));
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_union,
        unionErrors
      });
      return INVALID;
    }
    if (ctx.common.async) {
      return Promise.all(options.map(async (option) => {
        const childCtx = {
          ...ctx,
          common: {
            ...ctx.common,
            issues: []
          },
          parent: null
        };
        return {
          result: await option._parseAsync({
            data: ctx.data,
            path: ctx.path,
            parent: childCtx
          }),
          ctx: childCtx
        };
      })).then(handleResults);
    } else {
      let dirty = void 0;
      const issues = [];
      for (const option of options) {
        const childCtx = {
          ...ctx,
          common: {
            ...ctx.common,
            issues: []
          },
          parent: null
        };
        const result = option._parseSync({
          data: ctx.data,
          path: ctx.path,
          parent: childCtx
        });
        if (result.status === "valid") {
          return result;
        } else if (result.status === "dirty" && !dirty) {
          dirty = { result, ctx: childCtx };
        }
        if (childCtx.common.issues.length) {
          issues.push(childCtx.common.issues);
        }
      }
      if (dirty) {
        ctx.common.issues.push(...dirty.ctx.common.issues);
        return dirty.result;
      }
      const unionErrors = issues.map((issues2) => new ZodError(issues2));
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_union,
        unionErrors
      });
      return INVALID;
    }
  }
  get options() {
    return this._def.options;
  }
};
ZodUnion.create = (types2, params) => {
  return new ZodUnion({
    options: types2,
    typeName: ZodFirstPartyTypeKind.ZodUnion,
    ...processCreateParams(params)
  });
};
var getDiscriminator = (type2) => {
  if (type2 instanceof ZodLazy) {
    return getDiscriminator(type2.schema);
  } else if (type2 instanceof ZodEffects) {
    return getDiscriminator(type2.innerType());
  } else if (type2 instanceof ZodLiteral) {
    return [type2.value];
  } else if (type2 instanceof ZodEnum) {
    return type2.options;
  } else if (type2 instanceof ZodNativeEnum) {
    return util.objectValues(type2.enum);
  } else if (type2 instanceof ZodDefault) {
    return getDiscriminator(type2._def.innerType);
  } else if (type2 instanceof ZodUndefined) {
    return [void 0];
  } else if (type2 instanceof ZodNull) {
    return [null];
  } else if (type2 instanceof ZodOptional) {
    return [void 0, ...getDiscriminator(type2.unwrap())];
  } else if (type2 instanceof ZodNullable) {
    return [null, ...getDiscriminator(type2.unwrap())];
  } else if (type2 instanceof ZodBranded) {
    return getDiscriminator(type2.unwrap());
  } else if (type2 instanceof ZodReadonly) {
    return getDiscriminator(type2.unwrap());
  } else if (type2 instanceof ZodCatch) {
    return getDiscriminator(type2._def.innerType);
  } else {
    return [];
  }
};
var ZodDiscriminatedUnion = class _ZodDiscriminatedUnion extends ZodType {
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.object) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.object,
        received: ctx.parsedType
      });
      return INVALID;
    }
    const discriminator = this.discriminator;
    const discriminatorValue = ctx.data[discriminator];
    const option = this.optionsMap.get(discriminatorValue);
    if (!option) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_union_discriminator,
        options: Array.from(this.optionsMap.keys()),
        path: [discriminator]
      });
      return INVALID;
    }
    if (ctx.common.async) {
      return option._parseAsync({
        data: ctx.data,
        path: ctx.path,
        parent: ctx
      });
    } else {
      return option._parseSync({
        data: ctx.data,
        path: ctx.path,
        parent: ctx
      });
    }
  }
  get discriminator() {
    return this._def.discriminator;
  }
  get options() {
    return this._def.options;
  }
  get optionsMap() {
    return this._def.optionsMap;
  }
  /**
   * The constructor of the discriminated union schema. Its behaviour is very similar to that of the normal z.union() constructor.
   * However, it only allows a union of objects, all of which need to share a discriminator property. This property must
   * have a different value for each object in the union.
   * @param discriminator the name of the discriminator property
   * @param types an array of object schemas
   * @param params
   */
  static create(discriminator, options, params) {
    const optionsMap = /* @__PURE__ */ new Map();
    for (const type2 of options) {
      const discriminatorValues = getDiscriminator(type2.shape[discriminator]);
      if (!discriminatorValues.length) {
        throw new Error(`A discriminator value for key \`${discriminator}\` could not be extracted from all schema options`);
      }
      for (const value of discriminatorValues) {
        if (optionsMap.has(value)) {
          throw new Error(`Discriminator property ${String(discriminator)} has duplicate value ${String(value)}`);
        }
        optionsMap.set(value, type2);
      }
    }
    return new _ZodDiscriminatedUnion({
      typeName: ZodFirstPartyTypeKind.ZodDiscriminatedUnion,
      discriminator,
      options,
      optionsMap,
      ...processCreateParams(params)
    });
  }
};
function mergeValues(a, b) {
  const aType = getParsedType(a);
  const bType = getParsedType(b);
  if (a === b) {
    return { valid: true, data: a };
  } else if (aType === ZodParsedType.object && bType === ZodParsedType.object) {
    const bKeys = util.objectKeys(b);
    const sharedKeys = util.objectKeys(a).filter((key) => bKeys.indexOf(key) !== -1);
    const newObj = { ...a, ...b };
    for (const key of sharedKeys) {
      const sharedValue = mergeValues(a[key], b[key]);
      if (!sharedValue.valid) {
        return { valid: false };
      }
      newObj[key] = sharedValue.data;
    }
    return { valid: true, data: newObj };
  } else if (aType === ZodParsedType.array && bType === ZodParsedType.array) {
    if (a.length !== b.length) {
      return { valid: false };
    }
    const newArray = [];
    for (let index = 0; index < a.length; index++) {
      const itemA = a[index];
      const itemB = b[index];
      const sharedValue = mergeValues(itemA, itemB);
      if (!sharedValue.valid) {
        return { valid: false };
      }
      newArray.push(sharedValue.data);
    }
    return { valid: true, data: newArray };
  } else if (aType === ZodParsedType.date && bType === ZodParsedType.date && +a === +b) {
    return { valid: true, data: a };
  } else {
    return { valid: false };
  }
}
var ZodIntersection = class extends ZodType {
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    const handleParsed = (parsedLeft, parsedRight) => {
      if (isAborted(parsedLeft) || isAborted(parsedRight)) {
        return INVALID;
      }
      const merged = mergeValues(parsedLeft.value, parsedRight.value);
      if (!merged.valid) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.invalid_intersection_types
        });
        return INVALID;
      }
      if (isDirty(parsedLeft) || isDirty(parsedRight)) {
        status.dirty();
      }
      return { status: status.value, value: merged.data };
    };
    if (ctx.common.async) {
      return Promise.all([
        this._def.left._parseAsync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx
        }),
        this._def.right._parseAsync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx
        })
      ]).then(([left, right]) => handleParsed(left, right));
    } else {
      return handleParsed(this._def.left._parseSync({
        data: ctx.data,
        path: ctx.path,
        parent: ctx
      }), this._def.right._parseSync({
        data: ctx.data,
        path: ctx.path,
        parent: ctx
      }));
    }
  }
};
ZodIntersection.create = (left, right, params) => {
  return new ZodIntersection({
    left,
    right,
    typeName: ZodFirstPartyTypeKind.ZodIntersection,
    ...processCreateParams(params)
  });
};
var ZodTuple = class _ZodTuple extends ZodType {
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.array) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.array,
        received: ctx.parsedType
      });
      return INVALID;
    }
    if (ctx.data.length < this._def.items.length) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.too_small,
        minimum: this._def.items.length,
        inclusive: true,
        exact: false,
        type: "array"
      });
      return INVALID;
    }
    const rest = this._def.rest;
    if (!rest && ctx.data.length > this._def.items.length) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.too_big,
        maximum: this._def.items.length,
        inclusive: true,
        exact: false,
        type: "array"
      });
      status.dirty();
    }
    const items = [...ctx.data].map((item, itemIndex) => {
      const schema2 = this._def.items[itemIndex] || this._def.rest;
      if (!schema2)
        return null;
      return schema2._parse(new ParseInputLazyPath(ctx, item, ctx.path, itemIndex));
    }).filter((x) => !!x);
    if (ctx.common.async) {
      return Promise.all(items).then((results) => {
        return ParseStatus.mergeArray(status, results);
      });
    } else {
      return ParseStatus.mergeArray(status, items);
    }
  }
  get items() {
    return this._def.items;
  }
  rest(rest) {
    return new _ZodTuple({
      ...this._def,
      rest
    });
  }
};
ZodTuple.create = (schemas, params) => {
  if (!Array.isArray(schemas)) {
    throw new Error("You must pass an array of schemas to z.tuple([ ... ])");
  }
  return new ZodTuple({
    items: schemas,
    typeName: ZodFirstPartyTypeKind.ZodTuple,
    rest: null,
    ...processCreateParams(params)
  });
};
var ZodRecord = class _ZodRecord extends ZodType {
  get keySchema() {
    return this._def.keyType;
  }
  get valueSchema() {
    return this._def.valueType;
  }
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.object) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.object,
        received: ctx.parsedType
      });
      return INVALID;
    }
    const pairs2 = [];
    const keyType = this._def.keyType;
    const valueType = this._def.valueType;
    for (const key in ctx.data) {
      pairs2.push({
        key: keyType._parse(new ParseInputLazyPath(ctx, key, ctx.path, key)),
        value: valueType._parse(new ParseInputLazyPath(ctx, ctx.data[key], ctx.path, key)),
        alwaysSet: key in ctx.data
      });
    }
    if (ctx.common.async) {
      return ParseStatus.mergeObjectAsync(status, pairs2);
    } else {
      return ParseStatus.mergeObjectSync(status, pairs2);
    }
  }
  get element() {
    return this._def.valueType;
  }
  static create(first, second, third) {
    if (second instanceof ZodType) {
      return new _ZodRecord({
        keyType: first,
        valueType: second,
        typeName: ZodFirstPartyTypeKind.ZodRecord,
        ...processCreateParams(third)
      });
    }
    return new _ZodRecord({
      keyType: ZodString.create(),
      valueType: first,
      typeName: ZodFirstPartyTypeKind.ZodRecord,
      ...processCreateParams(second)
    });
  }
};
var ZodMap = class extends ZodType {
  get keySchema() {
    return this._def.keyType;
  }
  get valueSchema() {
    return this._def.valueType;
  }
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.map) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.map,
        received: ctx.parsedType
      });
      return INVALID;
    }
    const keyType = this._def.keyType;
    const valueType = this._def.valueType;
    const pairs2 = [...ctx.data.entries()].map(([key, value], index) => {
      return {
        key: keyType._parse(new ParseInputLazyPath(ctx, key, ctx.path, [index, "key"])),
        value: valueType._parse(new ParseInputLazyPath(ctx, value, ctx.path, [index, "value"]))
      };
    });
    if (ctx.common.async) {
      const finalMap = /* @__PURE__ */ new Map();
      return Promise.resolve().then(async () => {
        for (const pair of pairs2) {
          const key = await pair.key;
          const value = await pair.value;
          if (key.status === "aborted" || value.status === "aborted") {
            return INVALID;
          }
          if (key.status === "dirty" || value.status === "dirty") {
            status.dirty();
          }
          finalMap.set(key.value, value.value);
        }
        return { status: status.value, value: finalMap };
      });
    } else {
      const finalMap = /* @__PURE__ */ new Map();
      for (const pair of pairs2) {
        const key = pair.key;
        const value = pair.value;
        if (key.status === "aborted" || value.status === "aborted") {
          return INVALID;
        }
        if (key.status === "dirty" || value.status === "dirty") {
          status.dirty();
        }
        finalMap.set(key.value, value.value);
      }
      return { status: status.value, value: finalMap };
    }
  }
};
ZodMap.create = (keyType, valueType, params) => {
  return new ZodMap({
    valueType,
    keyType,
    typeName: ZodFirstPartyTypeKind.ZodMap,
    ...processCreateParams(params)
  });
};
var ZodSet = class _ZodSet extends ZodType {
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.set) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.set,
        received: ctx.parsedType
      });
      return INVALID;
    }
    const def = this._def;
    if (def.minSize !== null) {
      if (ctx.data.size < def.minSize.value) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.too_small,
          minimum: def.minSize.value,
          type: "set",
          inclusive: true,
          exact: false,
          message: def.minSize.message
        });
        status.dirty();
      }
    }
    if (def.maxSize !== null) {
      if (ctx.data.size > def.maxSize.value) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.too_big,
          maximum: def.maxSize.value,
          type: "set",
          inclusive: true,
          exact: false,
          message: def.maxSize.message
        });
        status.dirty();
      }
    }
    const valueType = this._def.valueType;
    function finalizeSet(elements2) {
      const parsedSet = /* @__PURE__ */ new Set();
      for (const element of elements2) {
        if (element.status === "aborted")
          return INVALID;
        if (element.status === "dirty")
          status.dirty();
        parsedSet.add(element.value);
      }
      return { status: status.value, value: parsedSet };
    }
    const elements = [...ctx.data.values()].map((item, i) => valueType._parse(new ParseInputLazyPath(ctx, item, ctx.path, i)));
    if (ctx.common.async) {
      return Promise.all(elements).then((elements2) => finalizeSet(elements2));
    } else {
      return finalizeSet(elements);
    }
  }
  min(minSize, message) {
    return new _ZodSet({
      ...this._def,
      minSize: { value: minSize, message: errorUtil.toString(message) }
    });
  }
  max(maxSize, message) {
    return new _ZodSet({
      ...this._def,
      maxSize: { value: maxSize, message: errorUtil.toString(message) }
    });
  }
  size(size2, message) {
    return this.min(size2, message).max(size2, message);
  }
  nonempty(message) {
    return this.min(1, message);
  }
};
ZodSet.create = (valueType, params) => {
  return new ZodSet({
    valueType,
    minSize: null,
    maxSize: null,
    typeName: ZodFirstPartyTypeKind.ZodSet,
    ...processCreateParams(params)
  });
};
var ZodFunction = class _ZodFunction extends ZodType {
  constructor() {
    super(...arguments);
    this.validate = this.implement;
  }
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.function) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.function,
        received: ctx.parsedType
      });
      return INVALID;
    }
    function makeArgsIssue(args, error) {
      return makeIssue({
        data: args,
        path: ctx.path,
        errorMaps: [
          ctx.common.contextualErrorMap,
          ctx.schemaErrorMap,
          getErrorMap(),
          errorMap
        ].filter((x) => !!x),
        issueData: {
          code: ZodIssueCode.invalid_arguments,
          argumentsError: error
        }
      });
    }
    function makeReturnsIssue(returns, error) {
      return makeIssue({
        data: returns,
        path: ctx.path,
        errorMaps: [
          ctx.common.contextualErrorMap,
          ctx.schemaErrorMap,
          getErrorMap(),
          errorMap
        ].filter((x) => !!x),
        issueData: {
          code: ZodIssueCode.invalid_return_type,
          returnTypeError: error
        }
      });
    }
    const params = { errorMap: ctx.common.contextualErrorMap };
    const fn = ctx.data;
    if (this._def.returns instanceof ZodPromise) {
      const me = this;
      return OK(async function(...args) {
        const error = new ZodError([]);
        const parsedArgs = await me._def.args.parseAsync(args, params).catch((e) => {
          error.addIssue(makeArgsIssue(args, e));
          throw error;
        });
        const result = await Reflect.apply(fn, this, parsedArgs);
        const parsedReturns = await me._def.returns._def.type.parseAsync(result, params).catch((e) => {
          error.addIssue(makeReturnsIssue(result, e));
          throw error;
        });
        return parsedReturns;
      });
    } else {
      const me = this;
      return OK(function(...args) {
        const parsedArgs = me._def.args.safeParse(args, params);
        if (!parsedArgs.success) {
          throw new ZodError([makeArgsIssue(args, parsedArgs.error)]);
        }
        const result = Reflect.apply(fn, this, parsedArgs.data);
        const parsedReturns = me._def.returns.safeParse(result, params);
        if (!parsedReturns.success) {
          throw new ZodError([makeReturnsIssue(result, parsedReturns.error)]);
        }
        return parsedReturns.data;
      });
    }
  }
  parameters() {
    return this._def.args;
  }
  returnType() {
    return this._def.returns;
  }
  args(...items) {
    return new _ZodFunction({
      ...this._def,
      args: ZodTuple.create(items).rest(ZodUnknown.create())
    });
  }
  returns(returnType) {
    return new _ZodFunction({
      ...this._def,
      returns: returnType
    });
  }
  implement(func) {
    const validatedFunc = this.parse(func);
    return validatedFunc;
  }
  strictImplement(func) {
    const validatedFunc = this.parse(func);
    return validatedFunc;
  }
  static create(args, returns, params) {
    return new _ZodFunction({
      args: args ? args : ZodTuple.create([]).rest(ZodUnknown.create()),
      returns: returns || ZodUnknown.create(),
      typeName: ZodFirstPartyTypeKind.ZodFunction,
      ...processCreateParams(params)
    });
  }
};
var ZodLazy = class extends ZodType {
  get schema() {
    return this._def.getter();
  }
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    const lazySchema = this._def.getter();
    return lazySchema._parse({ data: ctx.data, path: ctx.path, parent: ctx });
  }
};
ZodLazy.create = (getter, params) => {
  return new ZodLazy({
    getter,
    typeName: ZodFirstPartyTypeKind.ZodLazy,
    ...processCreateParams(params)
  });
};
var ZodLiteral = class extends ZodType {
  _parse(input) {
    if (input.data !== this._def.value) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        received: ctx.data,
        code: ZodIssueCode.invalid_literal,
        expected: this._def.value
      });
      return INVALID;
    }
    return { status: "valid", value: input.data };
  }
  get value() {
    return this._def.value;
  }
};
ZodLiteral.create = (value, params) => {
  return new ZodLiteral({
    value,
    typeName: ZodFirstPartyTypeKind.ZodLiteral,
    ...processCreateParams(params)
  });
};
function createZodEnum(values, params) {
  return new ZodEnum({
    values,
    typeName: ZodFirstPartyTypeKind.ZodEnum,
    ...processCreateParams(params)
  });
}
var ZodEnum = class _ZodEnum extends ZodType {
  constructor() {
    super(...arguments);
    _ZodEnum_cache.set(this, void 0);
  }
  _parse(input) {
    if (typeof input.data !== "string") {
      const ctx = this._getOrReturnCtx(input);
      const expectedValues = this._def.values;
      addIssueToContext(ctx, {
        expected: util.joinValues(expectedValues),
        received: ctx.parsedType,
        code: ZodIssueCode.invalid_type
      });
      return INVALID;
    }
    if (!__classPrivateFieldGet(this, _ZodEnum_cache, "f")) {
      __classPrivateFieldSet(this, _ZodEnum_cache, new Set(this._def.values), "f");
    }
    if (!__classPrivateFieldGet(this, _ZodEnum_cache, "f").has(input.data)) {
      const ctx = this._getOrReturnCtx(input);
      const expectedValues = this._def.values;
      addIssueToContext(ctx, {
        received: ctx.data,
        code: ZodIssueCode.invalid_enum_value,
        options: expectedValues
      });
      return INVALID;
    }
    return OK(input.data);
  }
  get options() {
    return this._def.values;
  }
  get enum() {
    const enumValues = {};
    for (const val of this._def.values) {
      enumValues[val] = val;
    }
    return enumValues;
  }
  get Values() {
    const enumValues = {};
    for (const val of this._def.values) {
      enumValues[val] = val;
    }
    return enumValues;
  }
  get Enum() {
    const enumValues = {};
    for (const val of this._def.values) {
      enumValues[val] = val;
    }
    return enumValues;
  }
  extract(values, newDef = this._def) {
    return _ZodEnum.create(values, {
      ...this._def,
      ...newDef
    });
  }
  exclude(values, newDef = this._def) {
    return _ZodEnum.create(this.options.filter((opt) => !values.includes(opt)), {
      ...this._def,
      ...newDef
    });
  }
};
_ZodEnum_cache = /* @__PURE__ */ new WeakMap();
ZodEnum.create = createZodEnum;
var ZodNativeEnum = class extends ZodType {
  constructor() {
    super(...arguments);
    _ZodNativeEnum_cache.set(this, void 0);
  }
  _parse(input) {
    const nativeEnumValues = util.getValidEnumValues(this._def.values);
    const ctx = this._getOrReturnCtx(input);
    if (ctx.parsedType !== ZodParsedType.string && ctx.parsedType !== ZodParsedType.number) {
      const expectedValues = util.objectValues(nativeEnumValues);
      addIssueToContext(ctx, {
        expected: util.joinValues(expectedValues),
        received: ctx.parsedType,
        code: ZodIssueCode.invalid_type
      });
      return INVALID;
    }
    if (!__classPrivateFieldGet(this, _ZodNativeEnum_cache, "f")) {
      __classPrivateFieldSet(this, _ZodNativeEnum_cache, new Set(util.getValidEnumValues(this._def.values)), "f");
    }
    if (!__classPrivateFieldGet(this, _ZodNativeEnum_cache, "f").has(input.data)) {
      const expectedValues = util.objectValues(nativeEnumValues);
      addIssueToContext(ctx, {
        received: ctx.data,
        code: ZodIssueCode.invalid_enum_value,
        options: expectedValues
      });
      return INVALID;
    }
    return OK(input.data);
  }
  get enum() {
    return this._def.values;
  }
};
_ZodNativeEnum_cache = /* @__PURE__ */ new WeakMap();
ZodNativeEnum.create = (values, params) => {
  return new ZodNativeEnum({
    values,
    typeName: ZodFirstPartyTypeKind.ZodNativeEnum,
    ...processCreateParams(params)
  });
};
var ZodPromise = class extends ZodType {
  unwrap() {
    return this._def.type;
  }
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.promise && ctx.common.async === false) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.promise,
        received: ctx.parsedType
      });
      return INVALID;
    }
    const promisified = ctx.parsedType === ZodParsedType.promise ? ctx.data : Promise.resolve(ctx.data);
    return OK(promisified.then((data) => {
      return this._def.type.parseAsync(data, {
        path: ctx.path,
        errorMap: ctx.common.contextualErrorMap
      });
    }));
  }
};
ZodPromise.create = (schema2, params) => {
  return new ZodPromise({
    type: schema2,
    typeName: ZodFirstPartyTypeKind.ZodPromise,
    ...processCreateParams(params)
  });
};
var ZodEffects = class extends ZodType {
  innerType() {
    return this._def.schema;
  }
  sourceType() {
    return this._def.schema._def.typeName === ZodFirstPartyTypeKind.ZodEffects ? this._def.schema.sourceType() : this._def.schema;
  }
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    const effect = this._def.effect || null;
    const checkCtx = {
      addIssue: (arg) => {
        addIssueToContext(ctx, arg);
        if (arg.fatal) {
          status.abort();
        } else {
          status.dirty();
        }
      },
      get path() {
        return ctx.path;
      }
    };
    checkCtx.addIssue = checkCtx.addIssue.bind(checkCtx);
    if (effect.type === "preprocess") {
      const processed = effect.transform(ctx.data, checkCtx);
      if (ctx.common.async) {
        return Promise.resolve(processed).then(async (processed2) => {
          if (status.value === "aborted")
            return INVALID;
          const result = await this._def.schema._parseAsync({
            data: processed2,
            path: ctx.path,
            parent: ctx
          });
          if (result.status === "aborted")
            return INVALID;
          if (result.status === "dirty")
            return DIRTY(result.value);
          if (status.value === "dirty")
            return DIRTY(result.value);
          return result;
        });
      } else {
        if (status.value === "aborted")
          return INVALID;
        const result = this._def.schema._parseSync({
          data: processed,
          path: ctx.path,
          parent: ctx
        });
        if (result.status === "aborted")
          return INVALID;
        if (result.status === "dirty")
          return DIRTY(result.value);
        if (status.value === "dirty")
          return DIRTY(result.value);
        return result;
      }
    }
    if (effect.type === "refinement") {
      const executeRefinement = (acc) => {
        const result = effect.refinement(acc, checkCtx);
        if (ctx.common.async) {
          return Promise.resolve(result);
        }
        if (result instanceof Promise) {
          throw new Error("Async refinement encountered during synchronous parse operation. Use .parseAsync instead.");
        }
        return acc;
      };
      if (ctx.common.async === false) {
        const inner = this._def.schema._parseSync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx
        });
        if (inner.status === "aborted")
          return INVALID;
        if (inner.status === "dirty")
          status.dirty();
        executeRefinement(inner.value);
        return { status: status.value, value: inner.value };
      } else {
        return this._def.schema._parseAsync({ data: ctx.data, path: ctx.path, parent: ctx }).then((inner) => {
          if (inner.status === "aborted")
            return INVALID;
          if (inner.status === "dirty")
            status.dirty();
          return executeRefinement(inner.value).then(() => {
            return { status: status.value, value: inner.value };
          });
        });
      }
    }
    if (effect.type === "transform") {
      if (ctx.common.async === false) {
        const base = this._def.schema._parseSync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx
        });
        if (!isValid(base))
          return base;
        const result = effect.transform(base.value, checkCtx);
        if (result instanceof Promise) {
          throw new Error(`Asynchronous transform encountered during synchronous parse operation. Use .parseAsync instead.`);
        }
        return { status: status.value, value: result };
      } else {
        return this._def.schema._parseAsync({ data: ctx.data, path: ctx.path, parent: ctx }).then((base) => {
          if (!isValid(base))
            return base;
          return Promise.resolve(effect.transform(base.value, checkCtx)).then((result) => ({ status: status.value, value: result }));
        });
      }
    }
    util.assertNever(effect);
  }
};
ZodEffects.create = (schema2, effect, params) => {
  return new ZodEffects({
    schema: schema2,
    typeName: ZodFirstPartyTypeKind.ZodEffects,
    effect,
    ...processCreateParams(params)
  });
};
ZodEffects.createWithPreprocess = (preprocess, schema2, params) => {
  return new ZodEffects({
    schema: schema2,
    effect: { type: "preprocess", transform: preprocess },
    typeName: ZodFirstPartyTypeKind.ZodEffects,
    ...processCreateParams(params)
  });
};
var ZodOptional = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType === ZodParsedType.undefined) {
      return OK(void 0);
    }
    return this._def.innerType._parse(input);
  }
  unwrap() {
    return this._def.innerType;
  }
};
ZodOptional.create = (type2, params) => {
  return new ZodOptional({
    innerType: type2,
    typeName: ZodFirstPartyTypeKind.ZodOptional,
    ...processCreateParams(params)
  });
};
var ZodNullable = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType === ZodParsedType.null) {
      return OK(null);
    }
    return this._def.innerType._parse(input);
  }
  unwrap() {
    return this._def.innerType;
  }
};
ZodNullable.create = (type2, params) => {
  return new ZodNullable({
    innerType: type2,
    typeName: ZodFirstPartyTypeKind.ZodNullable,
    ...processCreateParams(params)
  });
};
var ZodDefault = class extends ZodType {
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    let data = ctx.data;
    if (ctx.parsedType === ZodParsedType.undefined) {
      data = this._def.defaultValue();
    }
    return this._def.innerType._parse({
      data,
      path: ctx.path,
      parent: ctx
    });
  }
  removeDefault() {
    return this._def.innerType;
  }
};
ZodDefault.create = (type2, params) => {
  return new ZodDefault({
    innerType: type2,
    typeName: ZodFirstPartyTypeKind.ZodDefault,
    defaultValue: typeof params.default === "function" ? params.default : () => params.default,
    ...processCreateParams(params)
  });
};
var ZodCatch = class extends ZodType {
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    const newCtx = {
      ...ctx,
      common: {
        ...ctx.common,
        issues: []
      }
    };
    const result = this._def.innerType._parse({
      data: newCtx.data,
      path: newCtx.path,
      parent: {
        ...newCtx
      }
    });
    if (isAsync(result)) {
      return result.then((result2) => {
        return {
          status: "valid",
          value: result2.status === "valid" ? result2.value : this._def.catchValue({
            get error() {
              return new ZodError(newCtx.common.issues);
            },
            input: newCtx.data
          })
        };
      });
    } else {
      return {
        status: "valid",
        value: result.status === "valid" ? result.value : this._def.catchValue({
          get error() {
            return new ZodError(newCtx.common.issues);
          },
          input: newCtx.data
        })
      };
    }
  }
  removeCatch() {
    return this._def.innerType;
  }
};
ZodCatch.create = (type2, params) => {
  return new ZodCatch({
    innerType: type2,
    typeName: ZodFirstPartyTypeKind.ZodCatch,
    catchValue: typeof params.catch === "function" ? params.catch : () => params.catch,
    ...processCreateParams(params)
  });
};
var ZodNaN = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.nan) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.nan,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return { status: "valid", value: input.data };
  }
};
ZodNaN.create = (params) => {
  return new ZodNaN({
    typeName: ZodFirstPartyTypeKind.ZodNaN,
    ...processCreateParams(params)
  });
};
var BRAND = Symbol("zod_brand");
var ZodBranded = class extends ZodType {
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    const data = ctx.data;
    return this._def.type._parse({
      data,
      path: ctx.path,
      parent: ctx
    });
  }
  unwrap() {
    return this._def.type;
  }
};
var ZodPipeline = class _ZodPipeline extends ZodType {
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    if (ctx.common.async) {
      const handleAsync = async () => {
        const inResult = await this._def.in._parseAsync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx
        });
        if (inResult.status === "aborted")
          return INVALID;
        if (inResult.status === "dirty") {
          status.dirty();
          return DIRTY(inResult.value);
        } else {
          return this._def.out._parseAsync({
            data: inResult.value,
            path: ctx.path,
            parent: ctx
          });
        }
      };
      return handleAsync();
    } else {
      const inResult = this._def.in._parseSync({
        data: ctx.data,
        path: ctx.path,
        parent: ctx
      });
      if (inResult.status === "aborted")
        return INVALID;
      if (inResult.status === "dirty") {
        status.dirty();
        return {
          status: "dirty",
          value: inResult.value
        };
      } else {
        return this._def.out._parseSync({
          data: inResult.value,
          path: ctx.path,
          parent: ctx
        });
      }
    }
  }
  static create(a, b) {
    return new _ZodPipeline({
      in: a,
      out: b,
      typeName: ZodFirstPartyTypeKind.ZodPipeline
    });
  }
};
var ZodReadonly = class extends ZodType {
  _parse(input) {
    const result = this._def.innerType._parse(input);
    const freeze = (data) => {
      if (isValid(data)) {
        data.value = Object.freeze(data.value);
      }
      return data;
    };
    return isAsync(result) ? result.then((data) => freeze(data)) : freeze(result);
  }
  unwrap() {
    return this._def.innerType;
  }
};
ZodReadonly.create = (type2, params) => {
  return new ZodReadonly({
    innerType: type2,
    typeName: ZodFirstPartyTypeKind.ZodReadonly,
    ...processCreateParams(params)
  });
};
function custom(check, params = {}, fatal) {
  if (check)
    return ZodAny.create().superRefine((data, ctx) => {
      var _a, _b;
      if (!check(data)) {
        const p = typeof params === "function" ? params(data) : typeof params === "string" ? { message: params } : params;
        const _fatal = (_b = (_a = p.fatal) !== null && _a !== void 0 ? _a : fatal) !== null && _b !== void 0 ? _b : true;
        const p2 = typeof p === "string" ? { message: p } : p;
        ctx.addIssue({ code: "custom", ...p2, fatal: _fatal });
      }
    });
  return ZodAny.create();
}
var late = {
  object: ZodObject.lazycreate
};
var ZodFirstPartyTypeKind;
(function(ZodFirstPartyTypeKind2) {
  ZodFirstPartyTypeKind2["ZodString"] = "ZodString";
  ZodFirstPartyTypeKind2["ZodNumber"] = "ZodNumber";
  ZodFirstPartyTypeKind2["ZodNaN"] = "ZodNaN";
  ZodFirstPartyTypeKind2["ZodBigInt"] = "ZodBigInt";
  ZodFirstPartyTypeKind2["ZodBoolean"] = "ZodBoolean";
  ZodFirstPartyTypeKind2["ZodDate"] = "ZodDate";
  ZodFirstPartyTypeKind2["ZodSymbol"] = "ZodSymbol";
  ZodFirstPartyTypeKind2["ZodUndefined"] = "ZodUndefined";
  ZodFirstPartyTypeKind2["ZodNull"] = "ZodNull";
  ZodFirstPartyTypeKind2["ZodAny"] = "ZodAny";
  ZodFirstPartyTypeKind2["ZodUnknown"] = "ZodUnknown";
  ZodFirstPartyTypeKind2["ZodNever"] = "ZodNever";
  ZodFirstPartyTypeKind2["ZodVoid"] = "ZodVoid";
  ZodFirstPartyTypeKind2["ZodArray"] = "ZodArray";
  ZodFirstPartyTypeKind2["ZodObject"] = "ZodObject";
  ZodFirstPartyTypeKind2["ZodUnion"] = "ZodUnion";
  ZodFirstPartyTypeKind2["ZodDiscriminatedUnion"] = "ZodDiscriminatedUnion";
  ZodFirstPartyTypeKind2["ZodIntersection"] = "ZodIntersection";
  ZodFirstPartyTypeKind2["ZodTuple"] = "ZodTuple";
  ZodFirstPartyTypeKind2["ZodRecord"] = "ZodRecord";
  ZodFirstPartyTypeKind2["ZodMap"] = "ZodMap";
  ZodFirstPartyTypeKind2["ZodSet"] = "ZodSet";
  ZodFirstPartyTypeKind2["ZodFunction"] = "ZodFunction";
  ZodFirstPartyTypeKind2["ZodLazy"] = "ZodLazy";
  ZodFirstPartyTypeKind2["ZodLiteral"] = "ZodLiteral";
  ZodFirstPartyTypeKind2["ZodEnum"] = "ZodEnum";
  ZodFirstPartyTypeKind2["ZodEffects"] = "ZodEffects";
  ZodFirstPartyTypeKind2["ZodNativeEnum"] = "ZodNativeEnum";
  ZodFirstPartyTypeKind2["ZodOptional"] = "ZodOptional";
  ZodFirstPartyTypeKind2["ZodNullable"] = "ZodNullable";
  ZodFirstPartyTypeKind2["ZodDefault"] = "ZodDefault";
  ZodFirstPartyTypeKind2["ZodCatch"] = "ZodCatch";
  ZodFirstPartyTypeKind2["ZodPromise"] = "ZodPromise";
  ZodFirstPartyTypeKind2["ZodBranded"] = "ZodBranded";
  ZodFirstPartyTypeKind2["ZodPipeline"] = "ZodPipeline";
  ZodFirstPartyTypeKind2["ZodReadonly"] = "ZodReadonly";
})(ZodFirstPartyTypeKind || (ZodFirstPartyTypeKind = {}));
var instanceOfType = (cls, params = {
  message: `Input not instance of ${cls.name}`
}) => custom((data) => data instanceof cls, params);
var stringType = ZodString.create;
var numberType = ZodNumber.create;
var nanType = ZodNaN.create;
var bigIntType = ZodBigInt.create;
var booleanType = ZodBoolean.create;
var dateType = ZodDate.create;
var symbolType = ZodSymbol.create;
var undefinedType = ZodUndefined.create;
var nullType = ZodNull.create;
var anyType = ZodAny.create;
var unknownType = ZodUnknown.create;
var neverType = ZodNever.create;
var voidType = ZodVoid.create;
var arrayType = ZodArray.create;
var objectType = ZodObject.create;
var strictObjectType = ZodObject.strictCreate;
var unionType = ZodUnion.create;
var discriminatedUnionType = ZodDiscriminatedUnion.create;
var intersectionType = ZodIntersection.create;
var tupleType = ZodTuple.create;
var recordType = ZodRecord.create;
var mapType = ZodMap.create;
var setType = ZodSet.create;
var functionType = ZodFunction.create;
var lazyType = ZodLazy.create;
var literalType = ZodLiteral.create;
var enumType = ZodEnum.create;
var nativeEnumType = ZodNativeEnum.create;
var promiseType = ZodPromise.create;
var effectsType = ZodEffects.create;
var optionalType = ZodOptional.create;
var nullableType = ZodNullable.create;
var preprocessType = ZodEffects.createWithPreprocess;
var pipelineType = ZodPipeline.create;
var ostring = () => stringType().optional();
var onumber = () => numberType().optional();
var oboolean = () => booleanType().optional();
var coerce = {
  string: (arg) => ZodString.create({ ...arg, coerce: true }),
  number: (arg) => ZodNumber.create({ ...arg, coerce: true }),
  boolean: (arg) => ZodBoolean.create({
    ...arg,
    coerce: true
  }),
  bigint: (arg) => ZodBigInt.create({ ...arg, coerce: true }),
  date: (arg) => ZodDate.create({ ...arg, coerce: true })
};
var NEVER = INVALID;
var z = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  defaultErrorMap: errorMap,
  setErrorMap,
  getErrorMap,
  makeIssue,
  EMPTY_PATH,
  addIssueToContext,
  ParseStatus,
  INVALID,
  DIRTY,
  OK,
  isAborted,
  isDirty,
  isValid,
  isAsync,
  get util() {
    return util;
  },
  get objectUtil() {
    return objectUtil;
  },
  ZodParsedType,
  getParsedType,
  ZodType,
  datetimeRegex,
  ZodString,
  ZodNumber,
  ZodBigInt,
  ZodBoolean,
  ZodDate,
  ZodSymbol,
  ZodUndefined,
  ZodNull,
  ZodAny,
  ZodUnknown,
  ZodNever,
  ZodVoid,
  ZodArray,
  ZodObject,
  ZodUnion,
  ZodDiscriminatedUnion,
  ZodIntersection,
  ZodTuple,
  ZodRecord,
  ZodMap,
  ZodSet,
  ZodFunction,
  ZodLazy,
  ZodLiteral,
  ZodEnum,
  ZodNativeEnum,
  ZodPromise,
  ZodEffects,
  ZodTransformer: ZodEffects,
  ZodOptional,
  ZodNullable,
  ZodDefault,
  ZodCatch,
  ZodNaN,
  BRAND,
  ZodBranded,
  ZodPipeline,
  ZodReadonly,
  custom,
  Schema: ZodType,
  ZodSchema: ZodType,
  late,
  get ZodFirstPartyTypeKind() {
    return ZodFirstPartyTypeKind;
  },
  coerce,
  any: anyType,
  array: arrayType,
  bigint: bigIntType,
  boolean: booleanType,
  date: dateType,
  discriminatedUnion: discriminatedUnionType,
  effect: effectsType,
  "enum": enumType,
  "function": functionType,
  "instanceof": instanceOfType,
  intersection: intersectionType,
  lazy: lazyType,
  literal: literalType,
  map: mapType,
  nan: nanType,
  nativeEnum: nativeEnumType,
  never: neverType,
  "null": nullType,
  nullable: nullableType,
  number: numberType,
  object: objectType,
  oboolean,
  onumber,
  optional: optionalType,
  ostring,
  pipeline: pipelineType,
  preprocess: preprocessType,
  promise: promiseType,
  record: recordType,
  set: setType,
  strictObject: strictObjectType,
  string: stringType,
  symbol: symbolType,
  transformer: effectsType,
  tuple: tupleType,
  "undefined": undefinedType,
  union: unionType,
  unknown: unknownType,
  "void": voidType,
  NEVER,
  ZodIssueCode,
  quotelessJson,
  ZodError
});

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/schemas/RedoclyCodeSampleSchema.js
var RedoclyCodeSampleSchema = z.object({
  lang: z.string(),
  label: z.optional(z.string()),
  source: z.string()
});
var RedoclyCodeSampleArraySchema = z.array(RedoclyCodeSampleSchema);

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/readmeExtensions.js
var ReadmeOpenAPIExtension = {
  /**
   * Migrate from readme extensions to fern IR.
   *
   * https://docs.readme.com/main/docs/openapi-extensions
   */
  README_EXT: "x-readme"
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getReadmeCodeSamples.js
function isReadMeCodeSamples(maybeCodeSamples) {
  if (!Array.isArray(maybeCodeSamples)) {
    return false;
  }
  for (const maybeCodeSample of maybeCodeSamples) {
    if (!isPlainObject2(maybeCodeSample)) {
      return false;
    }
    if (typeof maybeCodeSample.language !== "string" || typeof maybeCodeSample.code !== "string") {
      return false;
    }
  }
  return true;
}
function getRawReadmeCodeSamples(operationObject) {
  const readme = getExtension(operationObject, ReadmeOpenAPIExtension.README_EXT);
  if (!isPlainObject2(readme)) {
    return [];
  }
  const readmeCodeSamples = readme["code-samples"];
  if (!isReadMeCodeSamples(readmeCodeSamples)) {
    return [];
  }
  const customCodeSamples = [];
  for (const codeSample of readmeCodeSamples) {
    customCodeSamples.push({
      name: codeSample.name,
      language: codeSample.language,
      code: codeSample.code,
      install: codeSample.install,
      docs: void 0
    });
  }
  return customCodeSamples;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getExamplesFromExtension.js
function getExamplesFromExtension(operationContext, operationObject, context) {
  const exampleEndpointCalls = getExtension(
    operationObject,
    FernOpenAPIExtension.EXAMPLES
    // RawSchemas.ExampleEndpointCallArraySchema,
    // context.logger,
    // [...operationContext.baseBreadcrumbs, `${operationContext.method} ${operationContext.path}`]
  ) ?? [];
  const validatedExampleEndpointCalls = exampleEndpointCalls.filter((example) => {
    const maybeFernExample = schemas_exports3.serialization.ExampleEndpointCallSchema.parse(example);
    if (!maybeFernExample.ok) {
      context.logger.error(`Failed to parse x-fern-example in ${operationContext.path}/${operationContext.method}`);
    }
    return maybeFernExample.ok;
  });
  const redoclyCodeSamplesKebabCase = getExtensionAndValidate(operationObject, OpenAPIExtension.REDOCLY_CODE_SAMPLES_KEBAB, RedoclyCodeSampleArraySchema, context.logger, [...operationContext.baseBreadcrumbs, `${operationContext.method} ${operationContext.path}`]) ?? [];
  const redoclyCodeSamplesCamelCase = getExtensionAndValidate(operationObject, OpenAPIExtension.REDOCLY_CODE_SAMPLES_CAMEL, RedoclyCodeSampleArraySchema, context.logger, [...operationContext.baseBreadcrumbs, `${operationContext.method} ${operationContext.path}`]) ?? [];
  const redoclyCodeSamples = [
    ...redoclyCodeSamplesCamelCase,
    ...redoclyCodeSamplesKebabCase
  ];
  if (redoclyCodeSamples.length > 0) {
    validatedExampleEndpointCalls.push({
      "code-samples": redoclyCodeSamples.map((value) => ({
        name: value.label ?? value.lang,
        language: value.lang,
        code: value.source,
        install: void 0,
        docs: void 0
      }))
    });
  }
  const readmeCodeSamples = getRawReadmeCodeSamples(operationObject);
  if (readmeCodeSamples.length > 0) {
    validatedExampleEndpointCalls.push({
      "code-samples": readmeCodeSamples
    });
  }
  return validatedExampleEndpointCalls.map(EndpointExample.unknown);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernAvailability.js
function getFernAvailability(operationObject) {
  const availability = getExtension(operationObject, FernOpenAPIExtension.AVAILABILITY);
  if (availability === "ga" || availability === "generally-available") {
    return Availability.GenerallyAvailable;
  } else if (availability === "beta" || availability === "pre-release") {
    return Availability.Beta;
  } else if (availability === "deprecated") {
    return Availability.Deprecated;
  }
  if (operationObject.deprecated) {
    return Availability.Deprecated;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/convertServer.js
function convertServer(server) {
  return {
    url: getServerUrl({ url: server.url, variables: server.variables ?? {} }),
    description: server.description,
    name: getServerName(server),
    audiences: getExtension(server, FernOpenAPIExtension.AUDIENCES)
  };
}
function getServerUrl({ url, variables }) {
  const valuesToSubstitute = Object.fromEntries(Object.entries(variables).map(([name, declaration]) => {
    return [name, declaration.default];
  }));
  for (const [variable, value] of Object.entries(valuesToSubstitute)) {
    url = url.replace(`{${variable}}`, value);
  }
  return url;
}
function getServerName(server) {
  const name = getExtension(server, [
    FernOpenAPIExtension.SERVER_NAME_V1,
    FernOpenAPIExtension.SERVER_NAME_V2
  ]);
  if (name != null) {
    return name;
  }
  if (server.description?.toLowerCase() === "production") {
    return "Production";
  }
  if (server.description?.toLowerCase() === "sandbox") {
    return "Sandbox";
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getParameterName.js
function getParameterName(parameter) {
  return getExtension(parameter, FernOpenAPIExtension.PARAMETER_NAME);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getVariableReference.js
function getVariableReference(parameter) {
  return getExtension(parameter, FernOpenAPIExtension.SDK_VARIABLE);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/endpoint/convertParameters.js
function convertParameters({ path: path5, httpMethod, parameters, context, requestBreadcrumbs, source }) {
  const convertedParameters = {
    pathParameters: [],
    queryParameters: [],
    headers: []
  };
  for (const parameter of parameters) {
    const shouldIgnore = getExtension(parameter, FernOpenAPIExtension.IGNORE);
    if (shouldIgnore != null && shouldIgnore) {
      context.logger.debug(`${httpMethod.toUpperCase()} ${path5} has a parameter marked with x-fern-ignore. Skipping.`);
      continue;
    }
    const resolvedParameter = isReferenceObject(parameter) ? context.resolveParameterReference(parameter) : parameter;
    const isRequired = resolvedParameter.required ?? false;
    const availability = convertAvailability3(resolvedParameter);
    const parameterBreadcrumbs = [...requestBreadcrumbs, resolvedParameter.name];
    const generatedName = getGeneratedTypeName(parameterBreadcrumbs, context.options.preserveSchemaIds);
    let schema2 = resolvedParameter.schema != null ? convertSchema(resolvedParameter.schema, !isRequired, context, parameterBreadcrumbs, source, context.namespace, false, /* @__PURE__ */ new Set(), getExamplesString({
      schema: resolvedParameter,
      logger: context.logger
    })) : isRequired ? SchemaWithExample.primitive({
      nameOverride: void 0,
      generatedName,
      title: void 0,
      schema: PrimitiveSchemaValueWithExample.string({
        default: void 0,
        pattern: void 0,
        format: void 0,
        minLength: void 0,
        maxLength: void 0,
        example: getExamplesString({
          schema: resolvedParameter,
          logger: context.logger
        })
      }),
      description: void 0,
      availability,
      groupName: void 0
    }) : SchemaWithExample.optional({
      nameOverride: void 0,
      generatedName,
      title: void 0,
      value: SchemaWithExample.primitive({
        nameOverride: void 0,
        generatedName,
        title: void 0,
        schema: PrimitiveSchemaValueWithExample.string({
          default: void 0,
          pattern: void 0,
          format: void 0,
          minLength: void 0,
          maxLength: void 0,
          example: getExamplesString({
            schema: resolvedParameter,
            logger: context.logger
          })
        }),
        description: void 0,
        availability: void 0,
        groupName: void 0
      }),
      description: void 0,
      availability,
      groupName: void 0
    });
    if (resolvedParameter.in === "header" && resolvedParameter.schema != null && !isReferenceObject(resolvedParameter.schema) && // eslint-disable-next-line @typescript-eslint/no-explicit-any
    resolvedParameter.schema.default != null) {
      const defaultValue = resolvedParameter.schema.default;
      if (typeof defaultValue === "string" && defaultValue.length > 0) {
        schema2 = SchemaWithExample.literal({
          nameOverride: void 0,
          generatedName,
          title: void 0,
          value: LiteralSchemaValue.string(defaultValue),
          description: void 0,
          availability,
          groupName: void 0
        });
      }
    }
    const convertedParameter = {
      name: resolvedParameter.name,
      schema: schema2,
      description: resolvedParameter.description,
      parameterNameOverride: getParameterName(resolvedParameter),
      availability,
      source
    };
    if (resolvedParameter.in === "query") {
      convertedParameters.queryParameters.push(convertedParameter);
    } else if (resolvedParameter.in === "path") {
      convertedParameters.pathParameters.push({
        ...convertedParameter,
        variableReference: getVariableReference(resolvedParameter)
      });
    } else if (resolvedParameter.in === "header") {
      if (!HEADERS_TO_SKIP.has(resolvedParameter.name.toLowerCase()) && !context.authHeaders.has(resolvedParameter.name)) {
        convertedParameters.headers.push({ ...convertedParameter, env: void 0 });
      } else {
        context.logger.debug(`Ignoring ${resolvedParameter.name} header, in ${httpMethod.toUpperCase()} ${path5}`);
      }
    } else {
      context.logger.warn(`Skipping ${resolvedParameter.in} parameter, ${resolvedParameter.name}, in ${httpMethod.toUpperCase()} ${path5}`);
    }
  }
  return convertedParameters;
}
var HEADERS_TO_SKIP = /* @__PURE__ */ new Set([
  "user-agent",
  "content-length",
  "content-type",
  "x-forwarded-for",
  "cookie",
  "origin",
  "content-disposition",
  "x-ping-custom-domain"
]);

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/endpoint/getApplicationJsonSchema.js
function getTextEventStreamObject(media, context) {
  for (const contentType of Object.keys(media)) {
    if (contentType.includes("text/event-stream")) {
      const mediaObject = media[contentType];
      if (mediaObject == null) {
        continue;
      }
      const schema2 = mediaObject.schema;
      return {
        contentType,
        schema: schema2 ?? {},
        examples: getExamples2(mediaObject, context)
      };
    }
  }
  return void 0;
}
function getApplicationJsonSchemaMediaObject(media, context) {
  for (const contentType of Object.keys(media)) {
    if (contentType.includes("json") || contentType === "*/*") {
      const mediaObject = media[contentType];
      if (mediaObject == null) {
        continue;
      }
      const schema2 = mediaObject.schema;
      return {
        contentType: !contentType.includes("*") ? contentType : void 0,
        schema: schema2 ?? {},
        examples: getExamples2(mediaObject, context)
      };
    }
  }
  return void 0;
}
function getSchemaMediaObject(media, context) {
  for (const contentType of Object.keys(media)) {
    const mediaObject = media[contentType];
    if (mediaObject == null) {
      continue;
    }
    const schema2 = mediaObject.schema;
    return {
      schema: schema2 ?? {},
      examples: getExamples2(mediaObject, context)
    };
  }
  return void 0;
}
function getExamples2(mediaObject, context) {
  const fullExamples = [];
  if (mediaObject.example != null) {
    fullExamples.push({ name: void 0, value: mediaObject.example, description: void 0 });
  }
  const examples = getExtension(mediaObject, OpenAPIExtension.EXAMPLES);
  if (examples != null && Object.keys(examples).length > 0) {
    fullExamples.push(...Object.entries(examples).map(([name, value]) => {
      return { name: value.summary ?? name, value: value.value, description: value.description };
    }));
  }
  if (mediaObject.examples != null && Object.keys(mediaObject.examples).length > 0) {
    fullExamples.push(...Object.entries(mediaObject.examples).map(([name, example]) => {
      const resolvedExample = isReferenceObject(example) ? context.resolveExampleReference(example) : example;
      return {
        name: resolvedExample.summary ?? name,
        value: resolvedExample.value,
        description: resolvedExample.description
      };
    }));
  }
  return fullExamples;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/endpoint/convertRequest.js
function getApplicationUrlFormEncodedRequest(requestBody, context) {
  for (const [mediaType, mediaTypeObject] of Object.entries(requestBody.content)) {
    if (MediaType.parse(mediaType)?.isURLEncoded()) {
      return {
        schema: mediaTypeObject.schema,
        contentType: mediaType,
        examples: getExamples2(mediaTypeObject, context)
      };
    }
  }
  return void 0;
}
function getMultipartFormDataRequest(requestBody) {
  for (const [mediaType, mediaTypeObject] of Object.entries(requestBody.content)) {
    if (MediaType.parse(mediaType)?.isMultipart()) {
      return { schema: mediaTypeObject.schema, encoding: mediaTypeObject.encoding };
    }
  }
  return void 0;
}
function isOctetStreamRequest(requestBody) {
  for (const mediaType in requestBody.content) {
    if (MediaType.parse(mediaType)?.isOctetStream()) {
      return true;
    }
  }
  return false;
}
function multipartRequestHasFile(multipartSchema, document2) {
  const resolvedMultipartSchema = isReferenceObject(multipartSchema) ? resolveSchema(multipartSchema, document2) : {
    id: void 0,
    schema: multipartSchema
  };
  return Object.entries(resolvedMultipartSchema.schema.properties ?? {}).find(([_, definition]) => {
    return !isReferenceObject(definition) && definition.type === "string" && definition.format === "binary";
  }) != null;
}
function convertRequest({ requestBody, document: document2, context, requestBreadcrumbs, source, namespace }) {
  const resolvedRequestBody = isReferenceObject(requestBody) ? context.resolveRequestBodyReference(requestBody) : requestBody;
  const multipartFormData = getMultipartFormDataRequest(resolvedRequestBody);
  const multipartSchema = multipartFormData?.schema;
  const multipartEncoding = multipartFormData?.encoding;
  const urlEncodedRequest = getApplicationUrlFormEncodedRequest(resolvedRequestBody, context);
  const jsonMediaObject = getApplicationJsonSchemaMediaObject(resolvedRequestBody.content, context);
  if (urlEncodedRequest != null && urlEncodedRequest.schema != null) {
    const convertedUrlEncodedSchema = convertSchema(urlEncodedRequest.schema, false, context, requestBreadcrumbs, source, namespace);
    return RequestWithExample.json({
      schema: convertedUrlEncodedSchema,
      description: resolvedRequestBody.description,
      contentType: urlEncodedRequest.contentType,
      source,
      fullExamples: urlEncodedRequest.examples,
      additionalProperties: false
    });
  }
  if (isOctetStreamRequest(resolvedRequestBody)) {
    return RequestWithExample.octetStream({
      description: resolvedRequestBody.description,
      source
    });
  }
  if (multipartSchema != null && jsonMediaObject == null || multipartSchema != null && multipartRequestHasFile(multipartSchema, document2)) {
    const resolvedMultipartSchema = isReferenceObject(multipartSchema) ? resolveSchema(multipartSchema, document2) : {
      id: void 0,
      schema: multipartSchema
    };
    const convertedMultipartSchema = convertSchema(resolvedMultipartSchema.schema, false, context, requestBreadcrumbs, source, namespace);
    const properties = [];
    if (convertedMultipartSchema.type === "object") {
      for (const property4 of convertedMultipartSchema.properties) {
        if (property4.schema.type === "primitive" && property4.schema.schema.type === "string" && property4.schema.schema.format === "binary") {
          properties.push({
            key: property4.key,
            schema: MultipartSchema.file({ isOptional: false, isArray: false }),
            description: property4.schema.description,
            contentType: multipartEncoding != null ? multipartEncoding[property4.key]?.contentType : void 0
          });
          continue;
        }
        if (property4.schema.type === "optional" && property4.schema.value.type === "primitive" && property4.schema.value.schema.type === "string" && property4.schema.value.schema.format === "binary") {
          properties.push({
            key: property4.key,
            schema: MultipartSchema.file({ isOptional: true, isArray: false }),
            description: property4.schema.description,
            contentType: multipartEncoding != null ? multipartEncoding[property4.key]?.contentType : void 0
          });
          continue;
        }
        if (property4.schema.type === "array" && property4.schema.value.type === "primitive" && property4.schema.value.schema.type === "string" && property4.schema.value.schema.format === "binary") {
          properties.push({
            key: property4.key,
            schema: MultipartSchema.file({ isOptional: false, isArray: true }),
            description: property4.schema.description,
            contentType: multipartEncoding != null ? multipartEncoding[property4.key]?.contentType : void 0
          });
          continue;
        }
        if (property4.schema.type === "optional" && property4.schema.value.type === "array" && property4.schema.value.value.type === "primitive" && property4.schema.value.value.schema.type === "string" && property4.schema.value.value.schema.format === "binary") {
          properties.push({
            key: property4.key,
            schema: MultipartSchema.file({ isOptional: true, isArray: true }),
            description: property4.schema.description,
            contentType: multipartEncoding != null ? multipartEncoding[property4.key]?.contentType : void 0
          });
          continue;
        }
        properties.push({
          key: property4.key,
          schema: MultipartSchema.json(property4.schema),
          description: void 0,
          contentType: multipartEncoding != null ? multipartEncoding[property4.key]?.contentType : void 0
        });
      }
    }
    return RequestWithExample.multipart({
      name: isReferenceObject(multipartSchema) && context.getNumberOfOccurrencesForRef(multipartSchema) === 1 ? resolvedMultipartSchema.id : void 0,
      description: resolvedMultipartSchema.schema.description,
      properties,
      source
    });
  }
  if (jsonMediaObject == null) {
    return void 0;
  }
  const requestSchema = convertSchema(jsonMediaObject.schema, false, context, requestBreadcrumbs, source, namespace, true);
  return RequestWithExample.json({
    description: void 0,
    schema: requestSchema,
    contentType: jsonMediaObject.contentType,
    fullExamples: jsonMediaObject.examples,
    additionalProperties: !isReferenceObject(jsonMediaObject.schema) && isAdditionalPropertiesAny(jsonMediaObject.schema.additionalProperties),
    source
  });
}
function resolveSchema(schema2, document2) {
  if (!schema2.$ref.startsWith(SCHEMA_REFERENCE_PREFIX)) {
    throw new Error(`Failed to resolve schema reference because of unsupported prefix: ${schema2.$ref}`);
  }
  const schemaId = getSchemaIdFromReference(schema2);
  if (schemaId == null) {
    throw new Error(`Failed to resolve schema reference because missing schema id: ${schema2.$ref}`);
  }
  const resolvedSchema = document2.components?.schemas?.[schemaId];
  if (resolvedSchema == null) {
    throw new Error(`Failed to resolve schema reference because missing: ${schema2.$ref}`);
  }
  if (isReferenceObject(resolvedSchema)) {
    return resolveSchema(resolvedSchema, document2);
  }
  return {
    id: schemaId,
    schema: resolvedSchema
  };
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/convertToHttpError.js
var ERROR_NAMES_BY_STATUS_CODE = {
  400: "BadRequestError",
  401: "UnauthorizedError",
  402: "PaymentRequiredError",
  403: "ForbiddenError",
  404: "NotFoundError",
  405: "MethodNotAllowedError",
  406: "NotAcceptableError",
  407: "ProxyAuthenticationRequiredError",
  408: "RequestTimeoutError",
  409: "ConflictError",
  410: "GoneError",
  411: "LengthRequiredError",
  412: "PreconditionFailedError",
  413: "ContentTooLargeError",
  414: "URITooLongError",
  415: "UnsupportedMediaTypeError",
  416: "RangeNotSatisfiableError",
  417: "ExpectationFailedError",
  418: "ImATeapotError",
  419: "AuthenticationTimeoutError",
  420: "MethodFailureError",
  421: "MisdirectedRequestError",
  422: "UnprocessableEntityError",
  423: "LockedError",
  424: "FailedDependencyError",
  425: "TooEarlyError",
  426: "UpgradeRequiredError",
  // TODO: 428 should be PreconditionRequiredError
  428: "PreconditionError",
  429: "TooManyRequestsError",
  430: "RequestHeaderFieldsTooLargeError",
  431: "RequestHeaderFieldsTooLargeError",
  444: "NoResponseError",
  449: "RetryWithError",
  450: "BlockedByWindowsParentalControlsError",
  451: "UnavailableForLegalReasonsError",
  498: "InvalidTokenError",
  499: "ClientClosedRequestError",
  500: "InternalServerError",
  501: "NotImplementedError",
  502: "BadGatewayError",
  503: "ServiceUnavailableError",
  504: "GatewayTimeoutError",
  505: "HTTPVersionNotSupportedError",
  506: "VariantAlsoNegotiatesError",
  507: "InsufficientStorageError",
  508: "LoopDetectedError",
  509: "BandwidthLimitExceededError",
  510: "NotExtendedError",
  511: "NetworkAuthenticationRequiredError"
};
var ERROR_NAMES = new Set(Object.values(ERROR_NAMES_BY_STATUS_CODE));

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/endpoint/convertResponse.js
var SUCCESSFUL_STATUS_CODES = ["200", "201", "202", "204"];
function convertResponse({ operationContext, responses, context, responseBreadcrumbs, responseStatusCode, streamFormat, source }) {
  if (responses == null) {
    return { value: void 0, errors: {} };
  }
  const errors = markErrorSchemas({ responses, context, source, namespace: context.namespace });
  let successStatusCodePresent = false;
  let convertedResponse = void 0;
  for (const statusCode of responseStatusCode != null ? [responseStatusCode] : SUCCESSFUL_STATUS_CODES) {
    const response = responses[statusCode];
    if (response == null) {
      continue;
    }
    successStatusCodePresent = true;
    if (convertedResponse == null) {
      convertedResponse = convertResolvedResponse({
        operationContext,
        response,
        context,
        responseBreadcrumbs,
        streamFormat,
        source,
        namespace: context.namespace
      });
    }
  }
  if (convertedResponse == null && !successStatusCodePresent && responses.default != null) {
    convertedResponse = convertResolvedResponse({
      operationContext,
      response: responses.default,
      context,
      responseBreadcrumbs,
      streamFormat,
      source,
      namespace: context.namespace
    });
  }
  if (convertedResponse != null) {
    switch (convertedResponse.type) {
      case "json":
        return {
          value: convertedResponse,
          errors
        };
      case "streamingJson":
      case "streamingSse":
        return {
          value: convertedResponse,
          errors
        };
      case "file":
      case "text":
      case "streamingText":
        return {
          value: convertedResponse,
          errors
        };
      default:
        assertNever(convertedResponse);
    }
  }
  return {
    value: void 0,
    errors
  };
}
function convertResolvedResponse({ operationContext, streamFormat, response, context, responseBreadcrumbs, source, namespace }) {
  const resolvedResponse = isReferenceObject(response) ? context.resolveResponseReference(response) : response;
  if (resolvedResponse.content != null) {
    const isdownloadFile = Object.entries(resolvedResponse.content).find(([_, mediaObject]) => {
      if (mediaObject.schema == null) {
        return false;
      }
      const resolvedSchema = isReferenceObject(mediaObject.schema) ? context.resolveSchemaReference(mediaObject.schema) : mediaObject.schema;
      return resolvedSchema.type === "string" && resolvedSchema.format === "binary";
    });
    if (isdownloadFile) {
      return ResponseWithExample.file({ description: resolvedResponse.description, source });
    }
  }
  const textEventStreamObject = getTextEventStreamObject(resolvedResponse.content ?? {}, context);
  if (textEventStreamObject != null && streamFormat != null) {
    switch (streamFormat) {
      case "json":
        return ResponseWithExample.streamingJson({
          description: resolvedResponse.description,
          responseProperty: getExtension(operationContext.operation, FernOpenAPIExtension.RESPONSE_PROPERTY),
          fullExamples: textEventStreamObject.examples,
          schema: convertSchema(textEventStreamObject.schema, false, context, responseBreadcrumbs, source, namespace),
          source
        });
      case "sse":
        return ResponseWithExample.streamingSse({
          description: resolvedResponse.description,
          responseProperty: void 0,
          schema: convertSchemaWithExampleToSchema(convertSchema(textEventStreamObject.schema, false, context, responseBreadcrumbs, source, namespace)),
          source
        });
    }
  }
  const jsonMediaObject = getApplicationJsonSchemaMediaObject(resolvedResponse.content ?? {}, context);
  if (jsonMediaObject != null) {
    if (streamFormat != null) {
      switch (streamFormat) {
        case "json":
          return ResponseWithExample.streamingJson({
            description: resolvedResponse.description,
            responseProperty: void 0,
            fullExamples: jsonMediaObject.examples,
            schema: convertSchema(jsonMediaObject.schema, false, context, responseBreadcrumbs, source, namespace),
            source
          });
        case "sse":
          return ResponseWithExample.streamingSse({
            description: resolvedResponse.description,
            responseProperty: void 0,
            schema: convertSchemaWithExampleToSchema(convertSchema(jsonMediaObject.schema, false, context, responseBreadcrumbs, source, namespace)),
            source
          });
      }
    }
    return ResponseWithExample.json({
      description: resolvedResponse.description,
      schema: convertSchema(jsonMediaObject.schema, false, context, responseBreadcrumbs, source, namespace),
      responseProperty: getExtension(operationContext.operation, FernOpenAPIExtension.RESPONSE_PROPERTY),
      fullExamples: jsonMediaObject.examples,
      source
    });
  }
  for (const [mediaType, mediaObject] of Object.entries(resolvedResponse.content ?? {})) {
    const mimeType = MediaType.parse(mediaType);
    if (mimeType == null) {
      continue;
    }
    if (mimeType.isOctetStream() || mimeType.isPDF() || mimeType.isAudio() || mimeType.isImage() || mimeType.isVideo()) {
      return ResponseWithExample.file({ description: resolvedResponse.description, source });
    }
    if (mimeType.isPlainText()) {
      const textPlainSchema = mediaObject.schema;
      if (textPlainSchema == null) {
        return ResponseWithExample.text({ description: resolvedResponse.description, source });
      }
      const resolvedTextPlainSchema = isReferenceObject(textPlainSchema) ? context.resolveSchemaReference(textPlainSchema) : textPlainSchema;
      if (resolvedTextPlainSchema.type === "string" && resolvedTextPlainSchema.format === "byte") {
        return ResponseWithExample.file({ description: resolvedResponse.description, source });
      }
      return ResponseWithExample.text({ description: resolvedResponse.description, source });
    }
  }
  return void 0;
}
function markErrorSchemas({ responses, context, source, namespace }) {
  const errors = {};
  for (const [statusCode, response] of Object.entries(responses)) {
    if (statusCode === "default") {
      continue;
    }
    const parsedStatusCode = parseInt(statusCode);
    if (parsedStatusCode < 400 || parsedStatusCode > 600) {
      continue;
    }
    const resolvedResponse = isReferenceObject(response) ? context.resolveResponseReference(response) : response;
    const mediaObject = getSchemaMediaObject(resolvedResponse.content ?? {}, context);
    const errorName = ERROR_NAMES_BY_STATUS_CODE[parsedStatusCode];
    if (errorName == null) {
      context.logger.warn(`No error name found for status code ${statusCode}`);
      continue;
    }
    errors[parsedStatusCode] = {
      statusCode: parsedStatusCode,
      nameOverride: void 0,
      generatedName: errorName,
      description: resolvedResponse.description,
      schema: convertSchema(mediaObject?.schema ?? {}, false, context, [errorName, "Body"], source, namespace),
      fullExamples: mediaObject?.examples,
      source
    };
  }
  return errors;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/operation/convertHttpOperation.js
function convertHttpOperation({ operationContext, context, responseStatusCode, suffix, streamFormat, source }) {
  const { document: document2, operation, path: path5, method, baseBreadcrumbs, sdkMethodName } = operationContext;
  const idempotent = getExtension(operation, FernOpenAPIExtension.IDEMPOTENT);
  const requestNameOverride = getExtension(operation, [
    FernOpenAPIExtension.REQUEST_NAME_V1,
    FernOpenAPIExtension.REQUEST_NAME_V2
  ]);
  const requestBreadcrumbs = [...baseBreadcrumbs, "Request"];
  const convertedParameters = convertParameters({
    parameters: [...operationContext.pathItemParameters, ...operationContext.operationParameters],
    context,
    requestBreadcrumbs,
    path: path5,
    httpMethod: method,
    source
  });
  let convertedRequest = operation.requestBody != null ? convertRequest({
    requestBody: operation.requestBody,
    document: document2,
    context: new DummyOpenAPIV3ParserContext({
      document: context.document,
      taskContext: context.taskContext,
      options: context.options,
      source: context.source,
      namespace: context.namespace
    }),
    requestBreadcrumbs,
    source,
    namespace: context.namespace
  }) : void 0;
  if (endpointHasNonRequestBodyParameters({ context, convertedParameters }) && convertedRequest != null && convertedRequest.type === "json" && convertedRequest.schema.type !== "object" && operation.requestBody != null) {
    convertedRequest = convertRequest({
      requestBody: operation.requestBody,
      document: document2,
      context,
      requestBreadcrumbs: [...requestBreadcrumbs, "Body"],
      source,
      namespace: context.namespace
    });
  } else if (operation.requestBody != null) {
    convertedRequest = convertRequest({
      requestBody: operation.requestBody,
      document: document2,
      context,
      requestBreadcrumbs: [...requestBreadcrumbs],
      source,
      namespace: context.namespace
    });
  }
  const responseBreadcrumbs = [...baseBreadcrumbs, "Response"];
  const convertedResponse = convertResponse({
    operationContext,
    streamFormat,
    responses: operation.responses,
    context,
    responseBreadcrumbs,
    responseStatusCode,
    source
  });
  const availability = getFernAvailability(operation);
  const examples = getExamplesFromExtension(operationContext, operation, context);
  const serverName = getExtension(operation, FernOpenAPIExtension.SERVER_NAME_V2);
  return {
    summary: operation.summary,
    internal: getExtension(operation, OpenAPIExtension.INTERNAL),
    idempotent,
    audiences: getExtension(operation, FernOpenAPIExtension.AUDIENCES) ?? [],
    operationId: operation.operationId != null && suffix != null ? operation.operationId + "_" + suffix : operation.operationId,
    tags: context.resolveTagsToTagIds(operation.tags),
    namespace: context.namespace,
    sdkName: sdkMethodName,
    pathParameters: convertedParameters.pathParameters,
    queryParameters: convertedParameters.queryParameters,
    headers: convertedParameters.headers,
    requestNameOverride: requestNameOverride ?? void 0,
    generatedRequestName: getGeneratedTypeName(requestBreadcrumbs, context.options.preserveSchemaIds),
    request: convertedRequest,
    response: convertedResponse.value,
    errors: convertedResponse.errors,
    server: serverName != null ? [{ name: serverName, url: void 0, audiences: void 0 }] : (operation.servers ?? []).map((server) => convertServer(server)),
    description: operation.description,
    authed: isEndpointAuthed(operation, document2),
    availability,
    method,
    path: path5,
    examples,
    pagination: operationContext.pagination,
    source
  };
}
function isEndpointAuthed(operation, document2) {
  if (operation.security != null) {
    return Object.keys(operation.security).length > 0;
  }
  if (document2.security != null) {
    return Object.keys(document2.security).length > 0;
  }
  return false;
}
function endpointHasNonRequestBodyParameters({ context, convertedParameters }) {
  return context.options.inlinePathParameters && convertedParameters.pathParameters.length > 0 || convertedParameters.queryParameters.length > 0 || convertedParameters.headers.length > 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/operation/convertAsyncSyncOperation.js
function convertAsyncSyncOperation({ operationContext, context, asyncExtension, source }) {
  const { operation, pathItemParameters, operationParameters } = operationContext;
  const headerToIgnore = asyncExtension.discriminant.name;
  const headerValue = asyncExtension.discriminant.value;
  const asyncResponseStatusCode = asyncExtension["response-status-code"];
  const filteredPathItemParams = filterParameters({ context, headerToIgnore, parameters: pathItemParameters });
  const filteredOperationParams = filterParameters({ context, headerToIgnore, parameters: operationParameters });
  const syncOperation = convertHttpOperation({
    operationContext: {
      ...operationContext,
      pathItemParameters: filteredPathItemParams,
      operationParameters: filteredOperationParams,
      operation: {
        ...operation,
        responses: Object.fromEntries(Object.entries(operation.responses).filter(([statusCode]) => {
          return parseInt(statusCode) !== asyncResponseStatusCode;
        }))
      }
    },
    context,
    streamFormat: void 0,
    source
  });
  const asyncOperation = convertHttpOperation({
    operationContext: {
      ...operationContext,
      pathItemParameters: filteredPathItemParams,
      operationParameters: filteredOperationParams,
      baseBreadcrumbs: [...operationContext.baseBreadcrumbs, "async"]
    },
    context,
    suffix: "async",
    responseStatusCode: asyncResponseStatusCode,
    streamFormat: void 0,
    source
  });
  asyncOperation.headers.push({
    name: headerToIgnore,
    schema: SchemaWithExample.literal({
      nameOverride: void 0,
      generatedName: getGeneratedTypeName([headerToIgnore], context.options.preserveSchemaIds),
      title: void 0,
      description: void 0,
      availability: void 0,
      value: LiteralSchemaValue.string(headerValue),
      groupName: void 0
    }),
    description: void 0,
    parameterNameOverride: void 0,
    env: void 0,
    availability: void 0,
    source
  });
  return {
    sync: syncOperation,
    async: asyncOperation
  };
}
function filterParameters({ context, headerToIgnore, parameters }) {
  return parameters.filter((parameter) => {
    const resolvedParameter = isReferenceObject(parameter) ? context.resolveParameterReference(parameter) : parameter;
    if (resolvedParameter.in === "header" && resolvedParameter.name === headerToIgnore) {
      return false;
    }
    return true;
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/operation/convertStreamingOperation.js
var STREAM_SUFFIX = "stream";
function convertStreamingOperation({ operationContext, context, streamingExtension }) {
  switch (streamingExtension.type) {
    case "stream": {
      const streamingOperation = convertHttpOperation({
        operationContext,
        context,
        streamFormat: streamingExtension.format,
        source: context.source
      });
      return {
        streaming: streamingOperation,
        nonStreaming: void 0
      };
    }
    case "streamCondition": {
      const streamingRequestBody = getRequestBody({
        context,
        operation: operationContext.operation,
        streamingExtension,
        isStreaming: true
      });
      if (streamingRequestBody?.schemaReference != null) {
        const schemaId = getSchemaIdFromReference(streamingRequestBody.schemaReference);
        if (schemaId != null) {
          context.excludeSchema(schemaId);
        }
      }
      const streamingResponses = getResponses({
        operation: operationContext.operation,
        response: streamingExtension.responseStream
      });
      const streamingOperation = convertHttpOperation({
        operationContext: {
          ...operationContext,
          sdkMethodName: operationContext.sdkMethodName != null ? {
            groupName: operationContext.sdkMethodName.groupName,
            methodName: operationContext.sdkMethodName.methodName + "_" + STREAM_SUFFIX
          } : void 0,
          operation: {
            ...operationContext.operation,
            description: streamingExtension.streamDescription ?? operationContext.operation.description,
            requestBody: streamingRequestBody?.requestBody,
            responses: streamingResponses
          },
          baseBreadcrumbs: [...operationContext.baseBreadcrumbs, STREAM_SUFFIX]
        },
        context,
        streamFormat: streamingExtension.format,
        suffix: STREAM_SUFFIX,
        source: context.source
      });
      streamingOperation.examples = streamingOperation.examples.filter((example) => isStreamingExample(example, context) !== false);
      const nonStreamingRequestBody = getRequestBody({
        context,
        operation: operationContext.operation,
        streamingExtension,
        isStreaming: false
      });
      const nonStreamingResponses = getResponses({
        operation: operationContext.operation,
        response: streamingExtension.response
      });
      const nonStreamingOperation = convertHttpOperation({
        streamFormat: void 0,
        operationContext: {
          ...operationContext,
          operation: {
            ...operationContext.operation,
            requestBody: nonStreamingRequestBody?.requestBody,
            responses: nonStreamingResponses
          }
        },
        context,
        source: context.source
      });
      nonStreamingOperation.examples = nonStreamingOperation.examples.filter((example) => isStreamingExample(example, context) !== true);
      return {
        streaming: streamingOperation,
        nonStreaming: nonStreamingOperation
      };
    }
    default:
      assertNever(streamingExtension);
  }
}
function getRequestBody({ context, operation, streamingExtension, isStreaming }) {
  if (operation.requestBody == null) {
    return void 0;
  }
  const resolvedRequestBody = isReferenceObject(operation.requestBody) ? context.resolveRequestBodyReference(operation.requestBody) : operation.requestBody;
  const jsonMediaObject = getApplicationJsonSchemaMediaObject(resolvedRequestBody.content, context);
  if (jsonMediaObject == null) {
    return void 0;
  }
  const resolvedRequstBodySchema = isReferenceObject(jsonMediaObject.schema) ? context.resolveSchemaReference(jsonMediaObject.schema) : jsonMediaObject.schema;
  if (resolvedRequstBodySchema.allOf == null && resolvedRequstBodySchema.properties == null) {
    return void 0;
  }
  let streamingProperty = resolvedRequstBodySchema.properties?.[streamingExtension.streamConditionProperty];
  if (streamingProperty != null && isReferenceObject(streamingProperty)) {
    streamingProperty = void 0;
  }
  const requestBodySchemaWithLiteralProperty = {
    ...resolvedRequstBodySchema,
    properties: {
      ...resolvedRequstBodySchema.properties,
      [streamingExtension.streamConditionProperty]: {
        type: "boolean",
        "x-fern-boolean-literal": isStreaming,
        ...streamingProperty ?? {}
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
      }
    },
    // Set to undefined because we inline both the streaming and non-streaming request schemas
    // and title would cause conflicting names
    title: void 0,
    required: [...resolvedRequstBodySchema.required ?? [], streamingExtension.streamConditionProperty]
  };
  return {
    requestBody: {
      content: {
        [MediaType.APPLICATION_JSON]: {
          schema: requestBodySchemaWithLiteralProperty
        }
      }
    },
    schemaReference: isReferenceObject(jsonMediaObject.schema) ? jsonMediaObject.schema : void 0
  };
}
function getResponses({ operation, response }) {
  return {
    ...operation.responses,
    "200": {
      description: "",
      content: {
        [MediaType.APPLICATION_JSON]: {
          schema: response
        }
      }
    }
  };
}
function isStreamingExample(example, context) {
  return example._visit({
    unknown: (unknownExample) => {
      const maybeFernExample = schemas_exports3.serialization.ExampleEndpointCallSchema.parse(unknownExample);
      if (!maybeFernExample.ok) {
        return void 0;
      }
      if (maybeFernExample.value.response == null) {
        return void 0;
      }
      return maybeFernExample.value.response.stream != null;
    },
    full: () => void 0,
    _other: () => void 0
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/operation/convertWebhookOperation.js
function convertWebhookOperation({ context, operationContext, source }) {
  const { document: document2, operation, path: path5, method, baseBreadcrumbs, sdkMethodName } = operationContext;
  const payloadBreadcrumbs = [...baseBreadcrumbs, "Payload"];
  const convertedParameters = convertParameters({
    parameters: [...operationContext.pathItemParameters, ...operationContext.operationParameters],
    context,
    requestBreadcrumbs: payloadBreadcrumbs,
    path: path5,
    httpMethod: method,
    source
  });
  if (operation.requestBody == null) {
    context.logger.error(`Skipping webhook ${method.toUpperCase()} ${path5}: Missing a request body`);
    return void 0;
  }
  if (method !== "POST" && method !== "GET") {
    context.logger.error(`Skipping webhook ${method.toUpperCase()} ${path5}: Not POST or GET`);
    return void 0;
  }
  const convertedPayload = convertRequest({
    requestBody: operation.requestBody,
    document: document2,
    context,
    requestBreadcrumbs: [...baseBreadcrumbs, "Payload"],
    source,
    namespace: context.namespace
  });
  if (convertedPayload == null || convertedPayload.type !== "json") {
    context.logger.error(`Skipping webhook ${path5} because non-json request body`);
    return void 0;
  }
  if (operation.operationId == null) {
    context.logger.error(`Skipping webhook ${path5} because no operation id present`);
    return void 0;
  }
  return {
    summary: operation.summary,
    sdkName: sdkMethodName,
    namespace: context.namespace,
    method,
    operationId: operation.operationId,
    tags: context.resolveTagsToTagIds(operation.tags),
    headers: convertedParameters.headers,
    generatedPayloadName: getGeneratedTypeName(payloadBreadcrumbs, context.options.preserveSchemaIds),
    payload: convertedPayload.schema,
    description: operation.description,
    examples: convertWebhookExamples(convertedPayload.fullExamples),
    source
  };
}
function convertWebhookExamples(payloadExamples) {
  if (payloadExamples == null) {
    return [];
  }
  const webhookExampleCalls = [];
  for (const payloadExample of payloadExamples) {
    const fullExample = convertToFullExample(payloadExample.value);
    if (fullExample == null) {
      continue;
    }
    webhookExampleCalls.push({
      description: payloadExample.description,
      name: payloadExample.name,
      payload: fullExample
    });
  }
  return webhookExampleCalls;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/operation/convertOperation.js
function convertOperation({ context, pathItemContext, operation, convertToWebhook }) {
  const shouldIgnore = getExtension(operation, FernOpenAPIExtension.IGNORE);
  if (shouldIgnore != null && shouldIgnore) {
    context.logger.info(`${pathItemContext.method.toUpperCase()} ${pathItemContext.path} is marked with x-fern-ignore. Skipping.`);
    return void 0;
  }
  const sdkMethodName = getSdkGroupAndMethod(operation, context);
  const pagination = getFernPaginationExtension(context.document, operation);
  const operationContext = {
    ...pathItemContext,
    sdkMethodName,
    baseBreadcrumbs: getBaseBreadcrumbs({
      operation,
      sdkMethodName,
      httpMethod: pathItemContext.method,
      path: pathItemContext.path
    }),
    operation,
    operationParameters: operation.parameters ?? [],
    pagination
  };
  if (convertToWebhook) {
    const webhook = convertWebhookOperation({
      context,
      operationContext,
      source: context.source
    });
    return webhook != null ? { type: "webhook", value: webhook } : void 0;
  }
  const streamingExtension = getFernStreamingExtension(operation);
  if (streamingExtension != null) {
    const streamingOperation = convertStreamingOperation({
      context,
      operationContext,
      streamingExtension
    });
    return streamingOperation != null ? {
      type: "streaming",
      streaming: streamingOperation.streaming,
      nonStreaming: streamingOperation.nonStreaming
    } : void 0;
  }
  const asyncExtension = getFernAsyncExtension(operation);
  if (asyncExtension != null) {
    const asyncAndSync = convertAsyncSyncOperation({
      context,
      operationContext,
      asyncExtension,
      source: context.source
    });
    return {
      type: "async",
      async: asyncAndSync.async,
      sync: asyncAndSync.sync
    };
  }
  const convertedHttpOperation = convertHttpOperation({
    context,
    operationContext,
    streamFormat: void 0,
    source: context.source
  });
  return { type: "http", value: convertedHttpOperation };
}
function getSdkGroupAndMethod(operation, context) {
  const sdkMethodName = getExtension(operation, FernOpenAPIExtension.SDK_METHOD_NAME);
  const sdkGroupName = getExtension(operation, FernOpenAPIExtension.SDK_GROUP_NAME) ?? [];
  if (sdkMethodName != null) {
    let groupName = typeof sdkGroupName === "string" ? [sdkGroupName] : sdkGroupName;
    groupName = context.resolveGroupName(groupName);
    return {
      groupName,
      methodName: sdkMethodName
    };
  }
  return void 0;
}
function getBaseBreadcrumbs({ sdkMethodName, operation, httpMethod, path: path5 }) {
  const baseBreadcrumbs = [];
  if (sdkMethodName != null) {
    if (sdkMethodName.groupName.length > 0) {
      const lastGroupName = sdkMethodName.groupName[sdkMethodName.groupName.length - 1];
      if (lastGroupName != null) {
        baseBreadcrumbs.push(typeof lastGroupName === "string" ? lastGroupName : lastGroupName.name);
      }
    }
    baseBreadcrumbs.push(sdkMethodName.methodName);
  } else if (operation.operationId != null) {
    baseBreadcrumbs.push(operation.operationId);
  } else {
    baseBreadcrumbs.push(camelCase_default(`${httpMethod}_${path5.split("/").join("_")}`));
  }
  return baseBreadcrumbs;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/convertPathItem.js
function convertPathItem(path5, pathItemObject, document2, context) {
  const result = [];
  const operations = getOperationObjectsFromPathItem(pathItemObject);
  const basePathItemContext = {
    document: document2,
    pathItem: pathItemObject,
    path: path5,
    pathItemParameters: pathItemObject.parameters ?? []
  };
  for (const operation of operations) {
    const convertToWebhook = isWebhook({ operation: operation.operation });
    const convertedOperation = convertOperation({
      context,
      pathItemContext: {
        ...basePathItemContext,
        method: operation.method
      },
      operation: operation.operation,
      convertToWebhook
    });
    if (convertedOperation != null) {
      result.push(convertedOperation);
    }
  }
  return result;
}
function convertPathItemToWebhooks(path5, pathItemObject, document2, context) {
  const result = [];
  const operations = getOperationObjectsFromPathItem(pathItemObject);
  const basePathItemContext = {
    document: document2,
    pathItem: pathItemObject,
    path: path5,
    pathItemParameters: pathItemObject.parameters ?? []
  };
  for (const operation of operations) {
    const convertedOperation = convertOperation({
      context,
      pathItemContext: {
        ...basePathItemContext,
        method: operation.method
      },
      operation: operation.operation,
      convertToWebhook: true
    });
    if (convertedOperation != null) {
      result.push(convertedOperation);
    }
  }
  return result;
}
function getOperationObjectsFromPathItem(pathItemObject) {
  const operations = [];
  if (pathItemObject.get != null) {
    operations.push({
      method: HttpMethod2.Get,
      operation: pathItemObject.get
    });
  }
  if (pathItemObject.post != null) {
    operations.push({
      method: HttpMethod2.Post,
      operation: pathItemObject.post
    });
  }
  if (pathItemObject.put != null) {
    operations.push({
      method: HttpMethod2.Put,
      operation: pathItemObject.put
    });
  }
  if (pathItemObject.delete != null) {
    operations.push({
      method: HttpMethod2.Delete,
      operation: pathItemObject.delete
    });
  }
  if (pathItemObject.patch != null) {
    operations.push({
      method: HttpMethod2.Patch,
      operation: pathItemObject.patch
    });
  }
  return operations;
}
function isWebhook({ operation }) {
  return getExtension(operation, [FernOpenAPIExtension.WEBHOOK]) ?? false;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getBasicSecuritySchemeNames.js
function getBasicSecuritySchemeNames(securityScheme) {
  const usernameVariable = getExtension(securityScheme, FernOpenAPIExtension.BASIC_AUTH_USERNAME_VARIABLE_NAME);
  const passwordVariable = getExtension(securityScheme, FernOpenAPIExtension.BASIC_AUTH_PASSWORD_VARIABLE_NAME);
  return {
    usernameVariable,
    passwordVariable
  };
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getSecuritySchemeNameAndEnvvars.js
function getBasicSecuritySchemeNameAndEnvvar(securityScheme) {
  return getExtension(securityScheme, FernOpenAPIExtension.FERN_BASIC_AUTH);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/convertSecurityScheme.js
function convertSecurityScheme(securityScheme, source) {
  if (isReferenceObject(securityScheme)) {
    throw new Error(`Converting referenced security schemes is unsupported: ${JSON.stringify(securityScheme)}`);
  }
  return convertSecuritySchemeHelper(securityScheme, source);
}
function convertSecuritySchemeHelper(securityScheme, source) {
  if (securityScheme.type === "apiKey" && securityScheme.in === "header") {
    const bearerFormat = getExtension(securityScheme, OpenAPIExtension.BEARER_FORMAT);
    const headerNames = getExtension(securityScheme, FernOpenAPIExtension.FERN_HEADER_AUTH);
    return SecurityScheme.header({
      headerName: securityScheme.name,
      prefix: bearerFormat != null ? "Bearer" : headerNames?.prefix,
      headerVariableName: headerNames?.name ?? getExtension(securityScheme, FernOpenAPIExtension.HEADER_VARIABLE_NAME),
      headerEnvVar: headerNames?.env
    });
  } else if (securityScheme.type === "http" && securityScheme.scheme === "bearer") {
    const bearerNames = getExtension(securityScheme, FernOpenAPIExtension.FERN_BEARER_TOKEN);
    return SecurityScheme.bearer({
      tokenVariableName: bearerNames?.name ?? getExtension(securityScheme, FernOpenAPIExtension.BEARER_TOKEN_VARIABLE_NAME),
      tokenEnvVar: bearerNames?.env
    });
  } else if (securityScheme.type === "http" && securityScheme.scheme === "basic") {
    const basicSecuritySchemeNamingAndEnvvar = getBasicSecuritySchemeNameAndEnvvar(securityScheme);
    const basicSecuritySchemeNaming = getBasicSecuritySchemeNames(securityScheme);
    return SecurityScheme.basic({
      usernameVariableName: basicSecuritySchemeNamingAndEnvvar?.username?.name ?? basicSecuritySchemeNaming.usernameVariable,
      usernameEnvVar: basicSecuritySchemeNamingAndEnvvar?.username?.env,
      passwordVariableName: basicSecuritySchemeNamingAndEnvvar?.password?.name ?? basicSecuritySchemeNaming.passwordVariable,
      passwordEnvVar: basicSecuritySchemeNamingAndEnvvar?.password?.env
    });
  } else if (securityScheme.type === "openIdConnect") {
    return SecurityScheme.bearer({
      tokenVariableName: void 0,
      tokenEnvVar: void 0
    });
  } else if (securityScheme.type === "oauth2") {
    return SecurityScheme.oauth({
      scopesEnum: getScopes(securityScheme, source)
    });
  }
  throw new Error(`Failed to convert security scheme ${JSON.stringify(securityScheme)}`);
}
function getScopes(oauthSecurityScheme, source) {
  const scopes = oauthSecurityScheme.flows.authorizationCode?.scopes ?? oauthSecurityScheme.flows.clientCredentials?.scopes ?? oauthSecurityScheme.flows.implicit?.scopes ?? oauthSecurityScheme.flows.password?.scopes;
  if (scopes != null) {
    const schemaWithExample = convertEnum({
      nameOverride: void 0,
      generatedName: "OauthScope",
      title: void 0,
      enumValues: Object.keys(scopes),
      fernEnum: Object.fromEntries(Object.entries(scopes).map(([scope, description]) => {
        return [
          scope,
          {
            description
          }
        ];
      })),
      _default: void 0,
      description: void 0,
      availability: void 0,
      enumVarNames: void 0,
      wrapAsNullable: false,
      groupName: void 0,
      context: void 0,
      source
    });
    const schema2 = convertSchemaWithExampleToSchema(schemaWithExample);
    if (schema2.type === "enum") {
      return schema2;
    }
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernBasePath.js
function getFernBasePath(parameter) {
  return getExtension(parameter, FernOpenAPIExtension.BASE_PATH);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernGroups.js
var XFernGroupsSchema = z.record(z.string(), z.object({
  summary: z.string().optional(),
  description: z.string().optional()
}));
function getFernGroups({ document: document2, context }) {
  return getExtensionAndValidate(document2, FernOpenAPIExtension.GROUPS, XFernGroupsSchema, context.logger);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernVersion.js
function getFernVersion({ context, document: document2 }) {
  return getExtension(document2, FernOpenAPIExtension.FERN_VERSION) ?? void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getGlobalHeaders.js
function getGlobalHeaders(document2) {
  const globalHeaders = getExtension(document2, FernOpenAPIExtension.FERN_GLOBAL_HEADERS);
  const result = [];
  for (const header of globalHeaders ?? []) {
    result.push({
      ...header,
      schema: header.type != null ? getSchemaFromFernType({
        fernType: header.type,
        description: void 0,
        availability: void 0,
        generatedName: header.name ?? header.header,
        title: void 0,
        groupName: void 0,
        nameOverride: void 0
      }) : void 0
    });
  }
  return result;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getIdempotencyHeaders.js
function getIdempotencyHeaders(document2) {
  const idempotencyHeaders = getExtension(document2, FernOpenAPIExtension.FERN_IDEMPOTENCY_HEADERS);
  const result = [];
  for (const header of idempotencyHeaders ?? []) {
    result.push({
      ...header,
      schema: header.type != null ? getSchemaFromFernType({
        fernType: header.type,
        description: void 0,
        availability: void 0,
        generatedName: header.name ?? header.header,
        title: void 0,
        groupName: void 0,
        nameOverride: void 0
      }) : void 0
    });
  }
  return result;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getVariableDefinitions.js
function getVariableDefinitions(document2, preserveSchemaIds) {
  const variables = getExtension(document2, FernOpenAPIExtension.SDK_VARIABLES);
  if (variables == null) {
    return {};
  }
  return Object.fromEntries(Object.entries(variables).map(([variableName, schema2]) => {
    if (schema2.type === "string") {
      return [
        variableName,
        {
          nameOverride: void 0,
          generatedName: getGeneratedTypeName([variableName], preserveSchemaIds),
          title: schema2.title,
          schema: PrimitiveSchemaValue.string({
            default: getDefaultAsString(schema2),
            pattern: schema2.pattern,
            format: schema2.format,
            minLength: schema2.minLength,
            maxLength: schema2.maxLength
          }),
          description: schema2.description,
          availability: void 0,
          groupName: void 0
        }
      ];
    } else {
      throw new Error(`Variable ${variableName} has unsupported schema ${JSON.stringify(schema2)}`);
    }
  }));
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/getWebhookPathsObject.js
var WEBHOOKS = "webhooks";
function getWebhooksPathsObject(document2) {
  return getExtension(document2, WEBHOOKS) ?? {};
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/OpenAPIV3ParserContext.js
var OpenAPIV3ParserContext = class extends AbstractOpenAPIV3ParserContext {
  nonRequestReferencedSchemas = /* @__PURE__ */ new Set();
  twoOrMoreRequestsReferencedSchemas = /* @__PURE__ */ new Set();
  singleRequestReferencedSchemas = /* @__PURE__ */ new Set();
  discrminatedUnionReferences = {};
  discrminatedUnionMetadata = {};
  schemasToExclude = /* @__PURE__ */ new Set();
  constructor({ document: document2, taskContext, authHeaders, options, source, namespace }) {
    super({
      document: document2,
      taskContext,
      authHeaders,
      options,
      source,
      namespace
    });
  }
  getDummy() {
    return new DummyOpenAPIV3ParserContext({
      document: this.document,
      taskContext: this.taskContext,
      options: this.options,
      source: this.source,
      namespace: this.namespace
    });
  }
  markSchemaAsReferencedByNonRequest(schemaId) {
    this.nonRequestReferencedSchemas.add(schemaId);
  }
  markSchemaAsReferencedByRequest(schemaId) {
    if (this.singleRequestReferencedSchemas.has(schemaId)) {
      this.twoOrMoreRequestsReferencedSchemas.add(schemaId);
    } else {
      this.singleRequestReferencedSchemas.add(schemaId);
    }
  }
  getReferencedSchemas() {
    return /* @__PURE__ */ new Set([...this.nonRequestReferencedSchemas, ...this.twoOrMoreRequestsReferencedSchemas]);
  }
  markReferencedByDiscriminatedUnion(schema2, discrminant, times) {
    const existingReference = this.discrminatedUnionReferences[schema2.$ref];
    if (existingReference != null) {
      existingReference.discriminants.add(discrminant);
      existingReference.numReferences += times;
    } else {
      this.discrminatedUnionReferences[schema2.$ref] = {
        discriminants: /* @__PURE__ */ new Set([discrminant]),
        numReferences: times
      };
    }
  }
  getReferencesFromDiscriminatedUnion(schema2) {
    return this.discrminatedUnionReferences[schema2.$ref];
  }
  markSchemaWithDiscriminantValue(schema2, discrminant, discriminantValue) {
    const existingMetadata = this.discrminatedUnionMetadata[schema2.$ref];
    if (existingMetadata != null) {
      existingMetadata.discriminants.set(discrminant, discriminantValue);
    } else {
      this.discrminatedUnionMetadata[schema2.$ref] = {
        discriminants: /* @__PURE__ */ new Map([[discrminant, discriminantValue]])
      };
    }
  }
  getDiscriminatedUnionMetadata(schema2) {
    return this.discrminatedUnionMetadata[schema2.$ref];
  }
  excludeSchema(schemaId) {
    this.schemasToExclude.add(schemaId);
  }
  isSchemaExcluded(schemaId) {
    return this.schemasToExclude.has(schemaId);
  }
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernResolutions.js
function getFernResolutions(openapi) {
  return getExtension(openapi, FernOpenAPIExtension.RESOLUTIONS);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/runResolutions.js
function runResolutions({ openapi }) {
  const resolutions = getFernResolutions(openapi);
  if (resolutions == null) {
    return openapi;
  }
  let replacedReferences = {};
  for (const resolution of resolutions) {
    const schemaReference = `#/components/schemas/${resolution.name}`;
    for (const resolutionPath of resolution.resolutions) {
      openapi = addComponentSchema({ openapi, schemaReference: resolutionPath, schemaName: resolution.name });
      openapi = replaceWithSchemaReference({
        openapi,
        replaceReference: resolutionPath,
        schemaReference,
        replacedReferences
      });
      replacedReferences = {
        ...replacedReferences,
        ...Object.fromEntries(resolution.resolutions.map((resolution2) => [schemaReference, resolution2]))
      };
    }
  }
  return openapi;
}
function addComponentSchema({ openapi, schemaReference, schemaName }) {
  const keys5 = schemaReference.replace("#/", "").split("/").map((key) => key.replace("~1", "/"));
  let value = openapi;
  for (const key of keys5) {
    const nextValue = value[key];
    if (nextValue == null) {
      return openapi;
    }
    value = nextValue;
  }
  if (openapi.components == null) {
    openapi.components = {};
  }
  if (openapi.components.schemas == null) {
    openapi.components.schemas = {};
  }
  openapi.components.schemas[schemaName] = value;
  return openapi;
}
function replaceWithSchemaReference({ openapi, replaceReference, schemaReference, replacedReferences }) {
  const overlappingReference = Object.keys(replacedReferences).filter((replacedReference) => replaceReference.startsWith(replacedReference)).sort((a, b) => b.length - a.length)[0];
  if (overlappingReference != null) {
    const resolvedOverlappingReference = replacedReferences[overlappingReference];
    if (resolvedOverlappingReference != null) {
      const newSchemaReference = schemaReference.replace(overlappingReference, resolvedOverlappingReference);
      return replaceWithSchemaReference({
        openapi,
        replaceReference,
        schemaReference: newSchemaReference,
        replacedReferences: {}
      });
    }
  }
  const keys5 = replaceReference.replace("#/", "").split("/").map((key) => key.replace("~1", "/"));
  let value = openapi;
  for (const key of keys5.slice(0, -1)) {
    const nextValue = value[key];
    if (nextValue == null) {
      return openapi;
    }
    value = nextValue;
  }
  const finalKey = keys5[keys5.length - 1];
  if (finalKey == null) {
    return openapi;
  }
  value[finalKey] = {
    $ref: schemaReference
  };
  return openapi;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/generateIr.js
function generateIr({ openApi, taskContext, options, source, namespace }) {
  openApi = runResolutions({ openapi: openApi });
  const securitySchemes = Object.fromEntries(Object.entries(openApi.components?.securitySchemes ?? {}).map(([key, securityScheme]) => {
    const convertedSecurityScheme = convertSecurityScheme(securityScheme, source);
    if (convertedSecurityScheme == null) {
      return [];
    }
    return [key, convertSecurityScheme(securityScheme, source)];
  }));
  const authHeaders = new Set(...Object.entries(securitySchemes).map(([_, securityScheme]) => {
    if (securityScheme.type === "basic" || securityScheme.type === "bearer") {
      return "Authorization";
    } else if (securityScheme.type === "header") {
      return securityScheme.headerName;
    }
    return null;
  }));
  const context = new OpenAPIV3ParserContext({
    document: openApi,
    taskContext,
    authHeaders,
    options,
    source,
    namespace
  });
  const variables = getVariableDefinitions(openApi, options.preserveSchemaIds);
  const globalHeaders = getGlobalHeaders(openApi);
  const idempotencyHeaders = getIdempotencyHeaders(openApi);
  const audiences = options.audiences ?? [];
  const endpointsWithExample = [];
  const webhooksWithExample = [];
  Object.entries(openApi.paths ?? {}).forEach(([path5, pathItem]) => {
    if (pathItem == null) {
      return;
    }
    taskContext.logger.debug(`Converting path ${path5}`);
    const convertedOperations = convertPathItem(path5, pathItem, openApi, context);
    for (const operation of convertedOperations) {
      const operationAudiences = getAudiences2({ operation });
      if (audiences.length > 0 && !audiences.some((audience) => operationAudiences.includes(audience))) {
        continue;
      }
      switch (operation.type) {
        case "async":
          endpointsWithExample.push(operation.sync);
          endpointsWithExample.push(operation.async);
          break;
        case "http":
          endpointsWithExample.push(operation.value);
          break;
        case "streaming":
          endpointsWithExample.push(operation.streaming);
          if (operation.nonStreaming) {
            endpointsWithExample.push(operation.nonStreaming);
          }
          break;
        case "webhook":
          webhooksWithExample.push(operation.value);
          break;
        default:
          assertNever(operation);
      }
    }
  });
  Object.entries(getWebhooksPathsObject(openApi)).forEach(([path5, pathItem]) => {
    if (pathItem == null) {
      return;
    }
    taskContext.logger.debug(`Converting path ${path5}`);
    const convertedWebhooks = convertPathItemToWebhooks(path5, pathItem, openApi, context);
    for (const webhook of convertedWebhooks) {
      const webhookAudiences = getAudiences2({ operation: webhook });
      if (audiences.length > 0 && !audiences.some((audience) => webhookAudiences.includes(audience))) {
        continue;
      }
      webhooksWithExample.push(webhook.value);
    }
  });
  const schemasWithExample = Object.fromEntries(Object.entries(openApi.components?.schemas ?? {}).map(([key, schema2]) => {
    if (!isReferenceObject(schema2)) {
      const ignoreSchema = getExtension(schema2, FernOpenAPIExtension.IGNORE);
      if (ignoreSchema != null && ignoreSchema) {
        return [];
      }
      if (ERROR_NAMES.has(key)) {
        return [
          key,
          convertSchema(
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            { ...schema2, "x-fern-type-name": `${key}Body` },
            false,
            context,
            [key],
            source,
            namespace
          )
        ];
      }
    }
    return [key, convertSchema(schema2, false, context, [key], source, namespace)];
  }).filter((entry) => entry.length > 0));
  const schemasWithoutDiscriminants = maybeRemoveDiscriminantsFromSchemas(schemasWithExample, context, source);
  const schemasWithDiscriminants = maybeAddBackDiscriminantsFromSchemas(schemasWithoutDiscriminants, context);
  const schemas = {};
  for (const [key, schemaWithExample] of Object.entries(schemasWithDiscriminants)) {
    const schema2 = convertSchemaWithExampleToSchema(schemaWithExample);
    if (context.isSchemaExcluded(key)) {
      continue;
    }
    schemas[key] = schema2;
    taskContext.logger.debug(`Converted schema ${key}`);
  }
  const exampleTypeFactory = new ExampleTypeFactory(schemasWithDiscriminants, context.nonRequestReferencedSchemas, context);
  const webhooks = webhooksWithExample.map((webhookWithExample) => {
    const extensionExamples = webhookWithExample.examples;
    let examples = extensionExamples;
    if (!options.disableExamples && examples.length === 0) {
      const webhookExample = exampleTypeFactory.buildExample({
        schema: webhookWithExample.payload,
        exampleId: void 0,
        example: void 0,
        skipReadonly: false,
        options: {
          ignoreOptionals: false,
          isParameter: false
        }
      });
      if (webhookExample != null) {
        examples = [
          {
            name: void 0,
            description: void 0,
            payload: webhookExample
          }
        ];
      }
    }
    return {
      ...webhookWithExample,
      payload: convertSchemaWithExampleToSchema(webhookWithExample.payload),
      examples
    };
  });
  const exampleEndpointFactory = new ExampleEndpointFactory(schemasWithDiscriminants, context);
  const endpoints = endpointsWithExample.map((endpointWithExample) => {
    const extensionExamples = endpointWithExample.examples;
    let examples = extensionExamples;
    if (!options.disableExamples && (extensionExamples.length === 0 || extensionExamples.every(hasIncompleteExample))) {
      const endpointExample = exampleEndpointFactory.buildEndpointExample(endpointWithExample);
      if (endpointExample.length > 0) {
        examples = [
          ...endpointExample,
          // Remove incomplete examples (codesamples are included in generated examples)
          ...extensionExamples.filter((example) => !hasIncompleteExample(example))
        ];
      }
    }
    const request = endpointWithExample.request;
    const response = endpointWithExample.response;
    return {
      ...endpointWithExample,
      request: request?.type === "json" ? {
        ...request,
        schema: convertSchemaWithExampleToSchema(request.schema)
      } : request,
      response: response?.type === "json" ? {
        ...response,
        schema: convertSchemaWithExampleToSchema(response.schema)
      } : response,
      queryParameters: endpointWithExample.queryParameters.map((queryParameter) => {
        return {
          description: queryParameter.description,
          name: queryParameter.name,
          schema: convertSchemaWithExampleToSchema(queryParameter.schema),
          parameterNameOverride: queryParameter.parameterNameOverride,
          availability: queryParameter.availability,
          source: queryParameter.source
        };
      }),
      pathParameters: endpointWithExample.pathParameters.map((pathParameter) => {
        return {
          description: pathParameter.description,
          name: pathParameter.name,
          schema: convertSchemaWithExampleToSchema(pathParameter.schema),
          parameterNameOverride: pathParameter.parameterNameOverride,
          variableReference: pathParameter.variableReference,
          availability: pathParameter.availability,
          source: pathParameter.source
        };
      }),
      headers: endpointWithExample.headers.map((header) => {
        return {
          description: header.description,
          name: header.name,
          schema: convertSchemaWithExampleToSchema(header.schema),
          parameterNameOverride: header.parameterNameOverride,
          env: header.env,
          availability: header.availability,
          source: header.source
        };
      }),
      examples,
      errors: mapValues_default(endpointWithExample.errors, (error) => {
        const examples2 = error.fullExamples?.map((example) => {
          const fullExample = convertToFullExample(example.value);
          if (fullExample == null) {
            return void 0;
          }
          return {
            name: example.name,
            description: example.description,
            example: fullExample
          };
        }).filter(isNonNullish);
        if (examples2?.length === 0) {
          const generatedExample = exampleTypeFactory.buildExample({
            schema: error.schema,
            example: void 0,
            exampleId: void 0,
            skipReadonly: false,
            options: {
              ignoreOptionals: false,
              isParameter: false
            }
          });
          if (generatedExample != null) {
            examples2.push({
              name: void 0,
              description: void 0,
              example: generatedExample
            });
          }
        }
        return {
          generatedName: error.generatedName,
          nameOverride: error.nameOverride,
          schema: convertSchemaWithExampleToSchema(error.schema),
          description: error.description,
          source: error.source,
          examples: examples2
        };
      })
    };
  });
  const groupInfo = getFernGroups({ document: openApi, context });
  const ir = {
    apiVersion: getFernVersion({
      context,
      document: openApi
    }),
    basePath: getFernBasePath(openApi),
    title: openApi.info.title,
    description: openApi.info.description,
    groups: Object.fromEntries(Object.entries(groupInfo ?? {}).map(([key, value]) => {
      return [key, { summary: value.summary ?? void 0, description: value.description ?? void 0 }];
    })),
    servers: (openApi.servers ?? []).map((server) => convertServer(server)),
    tags: {
      tagsById: Object.fromEntries((openApi.tags ?? []).map((tag) => {
        return [tag.name, { id: tag.name, description: tag.description }];
      })),
      orderedTagIds: openApi.tags?.map((tag) => tag.name)
    },
    endpoints,
    webhooks,
    channel: [],
    groupedSchemas: getSchemas(namespace, schemas),
    securitySchemes,
    hasEndpointsMarkedInternal: endpoints.some((endpoint) => endpoint.internal),
    nonRequestReferencedSchemas: context.getReferencedSchemas(),
    variables,
    globalHeaders,
    idempotencyHeaders
  };
  return ir;
}
function maybeRemoveDiscriminantsFromSchemas(schemas, context, source) {
  const result = {};
  for (const [schemaId, schema2] of Object.entries(schemas)) {
    if (schema2.type !== "object") {
      result[schemaId] = schema2;
      continue;
    }
    const referenceToSchema = {
      $ref: `#/components/schemas/${schemaId}`
    };
    const discriminatedUnionReference = context.getReferencesFromDiscriminatedUnion(referenceToSchema);
    if (discriminatedUnionReference == null) {
      result[schemaId] = schema2;
      continue;
    }
    const schemaWithoutDiscriminants = {
      ...schema2,
      type: "object",
      properties: schema2.properties.filter((objectProperty) => {
        return !discriminatedUnionReference.discriminants.has(objectProperty.key);
      }),
      allOfPropertyConflicts: schema2.allOfPropertyConflicts.filter((allOfPropertyConflict) => {
        return !discriminatedUnionReference.discriminants.has(allOfPropertyConflict.propertyKey);
      }),
      source
    };
    result[schemaId] = schemaWithoutDiscriminants;
    const parentSchemaIds = getAllParentSchemaIds({ schema: schema2, schemas });
    for (const parentSchemaId of [...new Set(parentSchemaIds)]) {
      const parentSchema = result[parentSchemaId] ?? schemas[parentSchemaId];
      if (parentSchema == null || parentSchema.type !== "object") {
        continue;
      }
      result[parentSchemaId] = {
        ...parentSchema,
        type: "object",
        properties: parentSchema.properties.filter((objectProperty) => {
          return !discriminatedUnionReference.discriminants.has(objectProperty.key);
        }),
        allOfPropertyConflicts: parentSchema.allOfPropertyConflicts.filter((allOfPropertyConflict) => {
          return !discriminatedUnionReference.discriminants.has(allOfPropertyConflict.propertyKey);
        })
      };
    }
  }
  return result;
}
function maybeAddBackDiscriminantsFromSchemas(schemas, context) {
  const result = {};
  for (const [schemaId, schema2] of Object.entries(schemas)) {
    if (schema2.type !== "object") {
      result[schemaId] = schema2;
      continue;
    }
    const referenceToSchema = {
      $ref: `#/components/schemas/${schemaId}`
    };
    const metadata = context.getDiscriminatedUnionMetadata(referenceToSchema);
    if (metadata == null) {
      result[schemaId] = schema2;
      continue;
    }
    const propertiesWithDiscriminants = [];
    for (const property4 of schema2.properties) {
      if (metadata.discriminants.has(property4.key)) {
        const discriminantValue = metadata.discriminants.get(property4.key);
        if (discriminantValue != null) {
          propertiesWithDiscriminants.push({
            ...property4,
            schema: SchemaWithExample.literal({
              nameOverride: void 0,
              generatedName: getGeneratedTypeName([schema2.generatedName, discriminantValue], context.options.preserveSchemaIds),
              title: void 0,
              value: LiteralSchemaValue.string(discriminantValue),
              groupName: void 0,
              description: void 0,
              availability: schema2.availability
            })
          });
        }
      } else {
        propertiesWithDiscriminants.push(property4);
      }
    }
    const schemaWithoutDiscriminants = {
      ...schema2,
      type: "object",
      properties: propertiesWithDiscriminants
    };
    result[schemaId] = schemaWithoutDiscriminants;
  }
  return result;
}
function getAllParentSchemaIds({ schema: schema2, schemas }) {
  const result = [];
  for (const allOfSchema of schema2.allOf) {
    result.push(allOfSchema.schema);
    const allOfSchemaDefinition = schemas[allOfSchema.schema];
    if (allOfSchemaDefinition != null && allOfSchemaDefinition.type === "object") {
      result.push(...getAllParentSchemaIds({ schema: allOfSchemaDefinition, schemas }));
    }
  }
  return result;
}
function getAudiences2({ operation }) {
  let endpointAudiences = [];
  switch (operation.type) {
    case "async":
      endpointAudiences = operation.async.audiences;
      break;
    case "http":
      endpointAudiences = operation.value.audiences;
      break;
    case "streaming":
      endpointAudiences = operation.streaming.audiences;
      break;
    case "webhook":
      break;
    default:
      assertNever(operation);
  }
  return endpointAudiences;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v2/generateIr.js
var isBrowser3 = typeof window !== "undefined" && typeof window.document !== "undefined";
async function generateIr2({ openApi, taskContext, options, source, namespace }) {
  if (isBrowser3) {
    throw new Error("Swagger 2.0 is not supported in the browser");
  }
  const swagger2openapi = await Promise.resolve().then(() => __toESM(require_swagger2openapi(), 1));
  const conversionResult = await swagger2openapi.convertObj(openApi, {});
  return generateIr({
    openApi: conversionResult.openapi,
    taskContext,
    options,
    source,
    namespace
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/options.js
var DEFAULT_PARSE_OPENAPI_SETTINGS = {
  disableExamples: false,
  discriminatedUnionV2: false,
  useTitlesAsName: true,
  audiences: void 0,
  optionalAdditionalProperties: true,
  cooerceEnumsToLiterals: true,
  respectReadonlySchemas: false,
  onlyIncludeReferencedSchemas: false,
  inlinePathParameters: false,
  preserveSchemaIds: false
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/parse.js
async function parse({ context, documents, options }) {
  let ir = {
    apiVersion: void 0,
    title: void 0,
    description: void 0,
    basePath: void 0,
    servers: [],
    tags: {
      tagsById: {},
      orderedTagIds: void 0
    },
    hasEndpointsMarkedInternal: false,
    endpoints: [],
    webhooks: [],
    channel: [],
    groupedSchemas: {
      rootSchemas: {},
      namespacedSchemas: {}
    },
    variables: {},
    nonRequestReferencedSchemas: /* @__PURE__ */ new Set(),
    securitySchemes: {},
    globalHeaders: [],
    idempotencyHeaders: [],
    groups: {}
  };
  for (const document2 of documents) {
    const source = document2.source != null ? document2.source : Source2.openapi({ file: "<memory>" });
    switch (document2.type) {
      case "openapi": {
        if (isOpenApiV3(document2.value)) {
          const openapiIr = generateIr({
            taskContext: context,
            openApi: document2.value,
            options: getParseOptions({ specSettings: document2.settings, overrides: options }),
            source,
            namespace: document2.namespace
          });
          ir = merge2(ir, openapiIr);
        } else if (isOpenApiV2(document2.value)) {
          const openapiIr = await generateIr2({
            taskContext: context,
            openApi: document2.value,
            options: getParseOptions({ specSettings: document2.settings }),
            source,
            namespace: document2.namespace
          });
          ir = merge2(ir, openapiIr);
        }
        break;
      }
      case "asyncapi": {
        const parsedAsyncAPI = parseAsyncAPI({
          document: document2.value,
          taskContext: context,
          options: getParseOptions({ specSettings: document2.settings }),
          source,
          asyncApiOptions: getParseAsyncOptions({ specSettings: document2.settings }),
          namespace: document2.namespace
        });
        if (parsedAsyncAPI.channel != null) {
          ir.channel.push(parsedAsyncAPI.channel);
        }
        if (parsedAsyncAPI.groupedSchemas != null) {
          ir.groupedSchemas = mergeSchemaMaps(ir.groupedSchemas, parsedAsyncAPI.groupedSchemas);
        }
        if (parsedAsyncAPI.basePath != null) {
          ir.basePath = parsedAsyncAPI.basePath;
        }
        break;
      }
      default:
        assertNever(document2);
    }
  }
  return ir;
}
function getParseOptions({ specSettings, overrides }) {
  return {
    disableExamples: overrides?.disableExamples ?? DEFAULT_PARSE_OPENAPI_SETTINGS.disableExamples,
    discriminatedUnionV2: overrides?.discriminatedUnionV2 ?? specSettings?.shouldUseUndiscriminatedUnionsWithLiterals ?? DEFAULT_PARSE_OPENAPI_SETTINGS.discriminatedUnionV2,
    useTitlesAsName: overrides?.useTitlesAsName ?? specSettings?.shouldUseTitleAsName ?? DEFAULT_PARSE_OPENAPI_SETTINGS.useTitlesAsName,
    audiences: overrides?.audiences ?? specSettings?.audiences ?? DEFAULT_PARSE_OPENAPI_SETTINGS.audiences,
    optionalAdditionalProperties: overrides?.optionalAdditionalProperties ?? specSettings?.optionalAdditionalProperties ?? DEFAULT_PARSE_OPENAPI_SETTINGS.optionalAdditionalProperties,
    cooerceEnumsToLiterals: overrides?.cooerceEnumsToLiterals ?? specSettings?.cooerceEnumsToLiterals ?? DEFAULT_PARSE_OPENAPI_SETTINGS.cooerceEnumsToLiterals,
    respectReadonlySchemas: overrides?.respectReadonlySchemas ?? specSettings?.respectReadonlySchemas ?? DEFAULT_PARSE_OPENAPI_SETTINGS.respectReadonlySchemas,
    onlyIncludeReferencedSchemas: overrides?.onlyIncludeReferencedSchemas ?? specSettings?.onlyIncludeReferencedSchemas ?? DEFAULT_PARSE_OPENAPI_SETTINGS.onlyIncludeReferencedSchemas,
    inlinePathParameters: overrides?.inlinePathParameters ?? specSettings?.inlinePathParameters ?? DEFAULT_PARSE_OPENAPI_SETTINGS.inlinePathParameters,
    preserveSchemaIds: overrides?.preserveSchemaIds ?? DEFAULT_PARSE_OPENAPI_SETTINGS.preserveSchemaIds
  };
}
function getParseAsyncOptions({ specSettings, overrides }) {
  return {
    naming: overrides?.naming ?? specSettings?.asyncApiNaming ?? DEFAULT_PARSE_ASYNCAPI_SETTINGS.naming
  };
}
function merge2(ir1, ir2) {
  return {
    apiVersion: ir1.apiVersion ?? ir2.apiVersion,
    title: ir1.title ?? ir2.title,
    description: ir1.description ?? ir2.description,
    basePath: ir1.basePath ?? ir2.basePath,
    servers: [...ir1.servers, ...ir2.servers],
    tags: {
      tagsById: {
        ...ir1.tags.tagsById,
        ...ir2.tags.tagsById
      },
      orderedTagIds: ir1.tags.orderedTagIds == null && ir2.tags.orderedTagIds == null ? void 0 : [...ir1.tags.orderedTagIds ?? [], ...ir2.tags.orderedTagIds ?? []]
    },
    hasEndpointsMarkedInternal: ir1.hasEndpointsMarkedInternal || ir2.hasEndpointsMarkedInternal,
    endpoints: [...ir1.endpoints, ...ir2.endpoints],
    webhooks: [...ir1.webhooks, ...ir2.webhooks],
    channel: [...ir1.channel, ...ir2.channel],
    groupedSchemas: mergeSchemaMaps(ir1.groupedSchemas, ir2.groupedSchemas),
    variables: {
      ...ir1.variables,
      ...ir2.variables
    },
    nonRequestReferencedSchemas: /* @__PURE__ */ new Set([...ir1.nonRequestReferencedSchemas, ...ir2.nonRequestReferencedSchemas]),
    securitySchemes: {
      ...ir1.securitySchemes,
      ...ir2.securitySchemes
    },
    globalHeaders: ir1.globalHeaders != null ? [...ir1.globalHeaders, ...ir2.globalHeaders ?? []] : void 0,
    idempotencyHeaders: ir1.idempotencyHeaders != null ? [...ir1.idempotencyHeaders, ...ir2.idempotencyHeaders ?? []] : void 0,
    groups: {
      ...ir1.groups,
      ...ir2.groups
    }
  };
}
function mergeSchemaMaps(schemas1, schemas2) {
  schemas1.rootSchemas = { ...schemas1.rootSchemas, ...schemas2.rootSchemas };
  for (const [namespace, namespaceSchemas] of Object.entries(schemas2.namespacedSchemas)) {
    if (schemas1.namespacedSchemas[namespace] != null) {
      schemas1.namespacedSchemas[namespace] = { ...schemas1.namespacedSchemas[namespace], ...namespaceSchemas };
    } else {
      schemas1.namespacedSchemas[namespace] = namespaceSchemas;
    }
  }
  return schemas1;
}
function isOpenApiV3(openApi) {
  return openApi.openapi != null;
}
function isOpenApiV2(openApi) {
  return openApi.swagger != null;
}

// ../../cli/workspace/commons/lib/openapi/constants.js
var import_openapi_core = __toESM(require_lib3(), 1);
var DEFAULT_OPENAPI_BUNDLE_OPTIONS = {
  config: new import_openapi_core.Config({
    apis: {},
    styleguide: {
      plugins: [FERN_TYPE_EXTENSIONS],
      rules: {
        spec: "warn"
      }
    }
  }, void 0),
  dereference: false,
  removeUnusedComponents: false,
  keepUrlRefs: true
};

// ../../cli/workspace/commons/lib/utils/getAllNamedDefinitionFiles.js
function getAllNamedDefinitionFiles(definition, opts = {}) {
  return {
    ...Object.fromEntries(entries(definition.namedDefinitionFiles).map(([path5, file]) => {
      return [path5, { ...file, defaultUrl: opts.defaultURL }];
    })),
    ...entries(definition.importedDefinitions).reduce((acc, [pathToImportedDefinition, definition2]) => {
      return {
        ...acc,
        ...mapKeys_default(getAllNamedDefinitionFiles(definition2.definition, { defaultURL: definition2.url }), (_file, path5) => join(pathToImportedDefinition, RelativeFilePath.of(path5)))
      };
    }, {})
  };
}

// ../../cli/workspace/commons/lib/utils/getAllPackageMarkers.js
function getAllPackageMarkers(definition, opts = {}) {
  return {
    ...Object.fromEntries(entries(definition.packageMarkers).map(([path5, file]) => {
      return [path5, { ...file, defaultUrl: opts.defaultURL }];
    })),
    ...entries(definition.importedDefinitions).reduce((acc, [pathToImportedDefinition, definition2]) => {
      return {
        ...acc,
        ...mapKeys_default(getAllPackageMarkers(definition2.definition, { defaultURL: definition2.url }), (_file, path5) => join(pathToImportedDefinition, RelativeFilePath.of(path5)))
      };
    }, {})
  };
}

// ../../cli/workspace/commons/lib/utils/getAllDefinitionFiles.js
function getAllDefinitionFiles(definition) {
  return {
    ...getAllPackageMarkers(definition),
    ...getAllNamedDefinitionFiles(definition)
  };
}

// ../../cli/workspace/commons/lib/utils/getDefinitionFile.js
function getDefinitionFile(workspace, relativeFilepath) {
  return getAllDefinitionFiles(workspace.definition)[relativeFilepath]?.contents;
}

// ../../cli/workspace/commons/lib/utils/visitAllDefinitionFiles.js
var import_path2 = __toESM(require("path"), 1);
async function visitAllDefinitionFiles(workspace, visitor) {
  for (const [relativeFilepath, file] of entries(getAllDefinitionFiles(workspace.definition))) {
    await visitor(relativeFilepath, file.contents, {
      isPackageMarker: import_path2.default.basename(relativeFilepath) === FERN_PACKAGE_MARKER_FILENAME,
      defaultUrl: file.defaultUrl
    });
  }
}

// ../../cli/workspace/commons/lib/utils/visitAllPackageMarkers.js
async function visitAllPackageMarkers(workspace, visitor) {
  for (const [relativeFilepath, file] of entries(getAllPackageMarkers(workspace.definition))) {
    await visitor(relativeFilepath, file.contents);
  }
}

// ../../cli/generation/ir-generator/lib/utils/parseInlineType.js
function parseInlineType({ type: type2, file, _default: _default2, validation }) {
  return recursivelyVisitRawTypeReference({
    type: type2,
    _default: _default2,
    validation,
    visitor: {
      primitive: TypeReference2.primitive,
      unknown: TypeReference2.unknown,
      map: ({ keyType, valueType }) => TypeReference2.container(ContainerType.map({ keyType, valueType })),
      list: (valueType) => TypeReference2.container(ContainerType.list(valueType)),
      set: (valueType) => TypeReference2.container(ContainerType.set(valueType)),
      optional: (valueType) => TypeReference2.container(ContainerType.optional(valueType)),
      literal: (literal) => TypeReference2.container(ContainerType.literal(literal)),
      named: (namedType) => TypeReference2.named({
        ...parseTypeName({
          typeName: namedType,
          file
        }),
        default: void 0,
        inline: void 0
      })
    }
  });
}

// ../../cli/generation/ir-generator/lib/FernFileContext.js
function constructRootApiFileContext({ casingsGenerator, rootApiFile }) {
  return constructFernFileContext({
    relativeFilepath: RelativeFilePath.of("."),
    definitionFile: {
      imports: rootApiFile.imports
    },
    casingsGenerator,
    rootApiFile
  });
}
function constructFernFileContext({ defaultUrl, relativeFilepath, definitionFile, casingsGenerator, rootApiFile }) {
  const file = {
    defaultUrl,
    relativeFilepath,
    fernFilepath: convertToFernFilepath({ relativeFilepath, casingsGenerator }),
    imports: mapValues_default(definitionFile.imports ?? {}, RelativeFilePath.of),
    definitionFile,
    parseTypeReference: (type2) => {
      if (typeof type2 === "string") {
        return parseInlineType({ type: type2, _default: void 0, validation: void 0, file });
      }
      return parseInlineType({
        type: type2.type,
        _default: type2.default,
        validation: type2.validation,
        file
      });
    },
    casingsGenerator,
    rootApiFile
  };
  return file;
}

// ../../cli/generation/ir-generator/lib/utils/getAllPropertiesForObject.js
var CASINGS_GENERATOR = constructCasingsGenerator({
  generationLanguage: void 0,
  keywords: void 0,
  smartCasing: false
});
function getAllPropertiesForObject({
  typeName,
  objectDeclaration,
  filepathOfDeclaration,
  definitionFile,
  workspace,
  typeResolver,
  smartCasing,
  // used only for recursive calls
  path: path5 = [],
  seen = {}
}) {
  const properties = [];
  if (typeName != null) {
    const seenAtFilepath = seen[filepathOfDeclaration] ??= /* @__PURE__ */ new Set();
    if (seenAtFilepath.has(typeName)) {
      return properties;
    }
    seenAtFilepath.add(typeName);
  }
  let casingsGenerator = CASINGS_GENERATOR;
  if (smartCasing) {
    casingsGenerator = constructCasingsGenerator({
      generationLanguage: void 0,
      keywords: void 0,
      smartCasing
    });
  }
  const file = constructFernFileContext({
    relativeFilepath: filepathOfDeclaration,
    definitionFile,
    casingsGenerator,
    rootApiFile: workspace.definition.rootApiFile.contents
  });
  if (objectDeclaration.properties != null) {
    for (const [propertyKey, propertyDeclaration] of Object.entries(objectDeclaration.properties)) {
      const propertyType = typeof propertyDeclaration === "string" ? propertyDeclaration : propertyDeclaration.type;
      const resolvedPropertyType = typeResolver.resolveType({ type: propertyType, file });
      if (resolvedPropertyType != null) {
        properties.push({
          wireKey: propertyKey,
          name: getPropertyName({ propertyKey, property: propertyDeclaration }).name,
          filepathOfDeclaration,
          path: path5,
          propertyType,
          resolvedPropertyType,
          isOptional: resolvedPropertyType._type === "container" && resolvedPropertyType.container._type === "optional"
        });
      }
    }
  }
  if (objectDeclaration.extends != null) {
    const extensions = typeof objectDeclaration.extends === "string" ? [objectDeclaration.extends] : objectDeclaration.extends;
    for (const extension of extensions) {
      const resolvedTypeOfExtension = typeResolver.resolveNamedType({
        referenceToNamedType: extension,
        file
      });
      if (resolvedTypeOfExtension?._type === "named" && isRawObjectDefinition(resolvedTypeOfExtension.declaration)) {
        const definitionFile2 = getDefinitionFile(workspace, resolvedTypeOfExtension.filepath);
        if (definitionFile2 != null) {
          properties.push(...getAllPropertiesForObject({
            typeName: resolvedTypeOfExtension.rawName,
            objectDeclaration: resolvedTypeOfExtension.declaration,
            filepathOfDeclaration: resolvedTypeOfExtension.filepath,
            definitionFile: definitionFile2,
            workspace,
            typeResolver,
            smartCasing,
            path: [
              ...path5,
              {
                reference: extension,
                followedVia: "extension"
              },
              ...resolvedTypeOfExtension.objectPath.map((pathItem) => ({
                reference: pathItem.reference,
                followedVia: "alias"
              }))
            ],
            seen
          }));
        }
      }
    }
  }
  return properties;
}

// ../../cli/generation/ir-generator/lib/examples/validateObjectExample.js
function validateObjectExample({ typeName, typeNameForBreadcrumb, rawObject, file, typeResolver, exampleResolver, workspace, example, breadcrumbs, depth }) {
  if (!isPlainObject2(example)) {
    return getViolationsForMisshapenExample(example, "an object");
  }
  const violations = [];
  const allPropertiesForObject = getAllPropertiesForObject({
    typeName,
    objectDeclaration: rawObject,
    typeResolver,
    definitionFile: file.definitionFile,
    workspace,
    filepathOfDeclaration: file.relativeFilepath,
    smartCasing: false
  });
  const allPropertiesByWireKey = keyBy_default(allPropertiesForObject, (property4) => property4.wireKey);
  const requiredProperties = allPropertiesForObject.filter((property4) => !property4.isOptional && property4.resolvedPropertyType._type !== "unknown");
  for (const requiredProperty of requiredProperties) {
    if (requiredProperty.resolvedPropertyType._type === "container" && requiredProperty.resolvedPropertyType.container._type === "literal") {
      continue;
    }
    if (example[requiredProperty.wireKey] == null) {
      const propertyReference = breadcrumbs.length > 0 ? `${breadcrumbs.join(".")}.${requiredProperty.wireKey}` : requiredProperty.wireKey;
      const message = `Example is missing required property "${propertyReference}"`;
      violations.push({
        message
      });
    }
  }
  for (const [exampleKey, exampleValue] of Object.entries(example)) {
    const propertyWithPath = allPropertiesByWireKey[exampleKey];
    if (propertyWithPath == null) {
      violations.push({
        message: `Unexpected property "${exampleKey}"`
      });
    } else {
      const definitionFile = getDefinitionFile(workspace, propertyWithPath.filepathOfDeclaration);
      if (definitionFile == null) {
        throw new Error("Service file does not exist for property: " + propertyWithPath.wireKey);
      }
      violations.push(...validateTypeReferenceExample({
        rawTypeReference: propertyWithPath.propertyType,
        example: exampleValue,
        file: constructFernFileContext({
          relativeFilepath: propertyWithPath.filepathOfDeclaration,
          definitionFile,
          casingsGenerator: file.casingsGenerator,
          rootApiFile: workspace.definition.rootApiFile.contents
        }),
        workspace,
        typeResolver,
        exampleResolver,
        breadcrumbs: [...breadcrumbs, `${exampleKey}`],
        depth: depth + 1
      }));
    }
  }
  return violations;
}

// ../../cli/generation/ir-generator/lib/examples/validateUndiscriminatedUnionExample.js
function validateUndiscriminatedUnionExample({ rawUnion, example, typeResolver, exampleResolver, file, workspace, breadcrumbs, depth }) {
  const violations = [];
  for (const member of rawUnion.union) {
    const violationsForMember = validateTypeReferenceExample({
      rawTypeReference: typeof member === "string" ? member : member.type,
      example,
      typeResolver,
      exampleResolver,
      file,
      workspace,
      breadcrumbs,
      depth: depth + 1
    });
    if (violationsForMember.length === 0) {
      return [];
    } else if (violations.length === 0) {
      violations.push(...violationsForMember);
    }
  }
  return violations;
}

// ../../cli/generation/ir-generator/lib/utils/getAvailability.js
function getAvailability(field) {
  if (typeof field === "string" || field.availability == null) {
    return void 0;
  }
  const rawAvailability = typeof field.availability === "string" ? { status: field.availability } : field.availability;
  return convertAvailability(field.availability);
}

// ../../cli/generation/ir-generator/lib/utils/getDocs.js
function getDocs(field) {
  if (typeof field === "string") {
    return void 0;
  }
  return field.docs;
}

// ../../cli/generation/ir-generator/lib/utils/getDisplayName.js
function getDisplayName2(field) {
  if (typeof field === "string") {
    return void 0;
  }
  return field["display-name"];
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertDiscriminatedUnionTypeDeclaration.js
var DEFAULT_UNION_VALUE_PROPERTY_VALUE = "value";
async function convertDiscriminatedUnionTypeDeclaration({ union: union3, file, typeResolver }) {
  const discriminant3 = getUnionDiscriminant(union3);
  return Type.union({
    discriminant: file.casingsGenerator.generateNameAndWireValue({
      wireValue: discriminant3,
      name: getUnionDiscriminantName(union3).name
    }),
    extends: getExtensionsAsList(union3.extends).map((extended) => parseTypeName({ typeName: extended, file })),
    baseProperties: union3["base-properties"] != null ? await Promise.all(Object.entries(union3["base-properties"]).map(async ([propertyKey, propertyDefinition]) => ({
      ...await convertDeclaration(propertyDefinition),
      name: file.casingsGenerator.generateNameAndWireValue({
        wireValue: propertyKey,
        name: getPropertyName({ propertyKey, property: propertyDefinition }).name
      }),
      valueType: file.parseTypeReference(propertyDefinition)
    }))) : [],
    types: Object.entries(union3.union).map(([unionKey, rawSingleUnionType]) => {
      const rawType = typeof rawSingleUnionType === "string" ? rawSingleUnionType : typeof rawSingleUnionType.type === "string" ? rawSingleUnionType.type : void 0;
      const discriminantValue = file.casingsGenerator.generateNameAndWireValue({
        wireValue: unionKey,
        name: getSingleUnionTypeName({ unionKey, rawSingleUnionType }).name
      });
      const docs = getDocs(rawSingleUnionType);
      if (rawType == null) {
        return {
          discriminantValue,
          docs,
          shape: SingleUnionTypeProperties.noProperties(),
          displayName: void 0,
          availability: void 0
        };
      }
      const parsedValueType = file.parseTypeReference(rawType);
      return {
        discriminantValue,
        shape: getSingleUnionTypeProperties({
          rawSingleUnionType,
          rawValueType: rawType,
          parsedValueType,
          file,
          typeResolver
        }),
        docs: getDocs(rawSingleUnionType),
        displayName: getDisplayName2(rawSingleUnionType),
        availability: getAvailability(rawSingleUnionType)
      };
    })
  });
}
function getUnionDiscriminant(union3) {
  if (union3.discriminant == null) {
    return "type";
  }
  if (typeof union3.discriminant === "string") {
    return union3.discriminant;
  }
  return union3.discriminant.value;
}
function getUnionDiscriminantName(union3) {
  if (union3.discriminant != null && typeof union3.discriminant !== "string" && union3.discriminant.name != null) {
    return {
      name: union3.discriminant.name,
      wasExplicitlySet: true
    };
  }
  return {
    name: getUnionDiscriminant(union3),
    wasExplicitlySet: false
  };
}
function getSingleUnionTypeName({ unionKey, rawSingleUnionType }) {
  if (typeof rawSingleUnionType !== "string" && rawSingleUnionType.name != null) {
    return {
      name: rawSingleUnionType.name,
      wasExplicitlySet: true
    };
  }
  return {
    name: unionKey,
    wasExplicitlySet: false
  };
}
function getSingleUnionTypeProperties({ rawSingleUnionType, rawValueType, parsedValueType, file, typeResolver }) {
  const singlePropertyKey = typeof rawSingleUnionType !== "string" ? rawSingleUnionType.key : void 0;
  const resolvedType = typeResolver.resolveTypeOrThrow({ type: rawValueType, file });
  if (resolvedType._type === "named" && isRawObjectDefinition(resolvedType.declaration) && singlePropertyKey == null) {
    return SingleUnionTypeProperties.samePropertiesAsObject(resolvedType.name);
  }
  return SingleUnionTypeProperties.singleProperty({
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: getSinglePropertyKeyValue(singlePropertyKey),
      name: getSinglePropertyKeyName(singlePropertyKey)
    }),
    type: parsedValueType
  });
}
function getSinglePropertyKeyName(rawSingleUnionType) {
  if (rawSingleUnionType != null) {
    if (typeof rawSingleUnionType === "string") {
      return rawSingleUnionType;
    }
    return rawSingleUnionType.name ?? rawSingleUnionType.value;
  }
  return DEFAULT_UNION_VALUE_PROPERTY_VALUE;
}
function getSinglePropertyKeyValue(rawSingleUnionType) {
  if (rawSingleUnionType != null) {
    if (typeof rawSingleUnionType === "string") {
      return rawSingleUnionType;
    }
    return rawSingleUnionType.value;
  }
  return DEFAULT_UNION_VALUE_PROPERTY_VALUE;
}

// ../../cli/generation/ir-generator/lib/examples/validateUnionExample.js
function validateUnionExample({ typeName, rawUnion, example, typeResolver, exampleResolver, file, workspace, breadcrumbs, depth }) {
  if (!isPlainObject2(example)) {
    return getViolationsForMisshapenExample(example, "an object");
  }
  const discriminant3 = getUnionDiscriminant(rawUnion);
  const { [discriminant3]: discriminantValue, ...nonDiscriminantPropertyExamples } = example;
  if (discriminantValue == null) {
    return [
      {
        message: `Missing discriminant property ("${discriminant3}")`
      }
    ];
  }
  if (typeof discriminantValue !== "string") {
    return getViolationsForMisshapenExample(discriminantValue, "a string");
  }
  const singleUnionTypeDefinition = rawUnion.union[discriminantValue];
  if (singleUnionTypeDefinition == null) {
    return [
      {
        message: `Invalid discriminant property: "${discriminantValue}". Allowed discriminant values:
` + Object.keys(rawUnion.union).map((otherDiscriminantValue) => `  - ${otherDiscriminantValue}`).join("\n")
      }
    ];
  }
  if (rawUnion["base-properties"] != null) {
    const example2 = Object.fromEntries(Object.entries(nonDiscriminantPropertyExamples).filter(([key]) => rawUnion["base-properties"]?.[key] != null));
    const basePropertyViolations = validateObjectExample({
      typeName,
      typeNameForBreadcrumb: typeName,
      rawObject: {
        properties: rawUnion["base-properties"]
      },
      file,
      example: example2,
      typeResolver,
      exampleResolver,
      workspace,
      breadcrumbs,
      depth: depth + 1
    });
    if (basePropertyViolations.length > 0) {
      return basePropertyViolations;
    }
  }
  const type2 = typeof singleUnionTypeDefinition === "string" ? singleUnionTypeDefinition : singleUnionTypeDefinition.type;
  if (typeof type2 !== "string") {
    return getRuleViolationForExtraProperties(nonDiscriminantPropertyExamples);
  }
  const resolvedType = typeResolver.resolveType({
    type: type2,
    file
  });
  if (resolvedType == null) {
    return [];
  }
  if (resolvedType._type === "named" && isRawObjectDefinition(resolvedType.declaration)) {
    const example2 = Object.fromEntries(Object.entries(nonDiscriminantPropertyExamples).filter(([key]) => rawUnion["base-properties"]?.[key] == null));
    return validateObjectExample({
      typeName,
      typeNameForBreadcrumb: typeName,
      rawObject: resolvedType.declaration,
      file: resolvedType.file,
      example: example2,
      typeResolver,
      exampleResolver,
      workspace,
      breadcrumbs,
      depth: depth + 1
    });
  }
  const singlePropertyKey = typeof singleUnionTypeDefinition !== "string" && typeof singleUnionTypeDefinition.key === "string" ? singleUnionTypeDefinition.key : void 0;
  if (singlePropertyKey == null) {
    return [];
  }
  const { [singlePropertyKey]: singlePropertyExample, ...extraProperties } = nonDiscriminantPropertyExamples;
  const violations = [];
  if (singlePropertyExample == null) {
    violations.push({
      message: `Missing property "${singlePropertyKey}"`
    });
  } else {
    violations.push(...validateTypeReferenceExample({
      rawTypeReference: type2,
      example: singlePropertyExample,
      typeResolver,
      exampleResolver,
      file,
      workspace,
      breadcrumbs,
      depth: depth + 1
    }));
  }
  violations.push(...getRuleViolationForExtraProperties(extraProperties));
  return violations;
}
function getRuleViolationForExtraProperties(extraProperties) {
  return Object.keys(extraProperties).map((key) => ({
    severity: "error",
    message: `Unexpected property "${key}"`
  }));
}

// ../../cli/generation/ir-generator/lib/examples/validateTypeExample.js
function validateTypeExample({ typeName, typeDeclaration, file, typeResolver, exampleResolver, example, workspace, breadcrumbs, depth }) {
  return visitRawTypeDeclaration(typeDeclaration, {
    alias: (rawAlias) => {
      return validateAliasExample({
        rawAlias,
        file,
        typeResolver,
        exampleResolver,
        example,
        workspace,
        breadcrumbs,
        depth
      });
    },
    enum: (rawEnum) => {
      return validateEnumExample({
        rawEnum,
        example,
        breadcrumbs
      });
    },
    object: (rawObject) => {
      return validateObjectExample({
        typeName,
        typeNameForBreadcrumb: typeName,
        rawObject,
        example,
        file,
        typeResolver,
        exampleResolver,
        workspace,
        breadcrumbs,
        depth
      });
    },
    discriminatedUnion: (rawUnion) => {
      return validateUnionExample({
        typeName,
        rawUnion,
        example,
        file,
        typeResolver,
        exampleResolver,
        workspace,
        breadcrumbs,
        depth
      });
    },
    undiscriminatedUnion: (rawUnion) => {
      return validateUndiscriminatedUnionExample({
        rawUnion,
        example,
        file,
        typeResolver,
        exampleResolver,
        workspace,
        breadcrumbs,
        depth
      });
    }
  });
}

// ../../cli/generation/ir-generator/lib/examples/validateTypeReferenceExample.js
var ISO_8601_REGEX3 = /^([+-]?\d{4}(?!\d{2}\b))((-?)((0[1-9]|1[0-2])(\3([12]\d|0[1-9]|3[01]))?|W([0-4]\d|5[0-2])(-?[1-7])?|(00[1-9]|0[1-9]\d|[12]\d{2}|3([0-5]\d|6[1-6])))([T\s]((([01]\d|2[0-3])((:?)[0-5]\d)?|24:?00)([.,]\d+(?!:))?)?(\17[0-5]\d([.,]\d+)?)?([zZ]|([+-])([01]\d|2[0-3]):?([0-5]\d)?)?)?)?$/;
var UUID_REGEX = /^[0-9a-fA-F]{8}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{12}$/;
var RFC_3339_DATE_REGEX = /^\d{4}-\d{2}-\d{2}$/;
var MAX_RECURSION_DEPTH = 128;
function validateTypeReferenceExample({ rawTypeReference, example, typeResolver, exampleResolver, file, workspace, breadcrumbs, depth }) {
  if (depth > MAX_RECURSION_DEPTH) {
    return [
      {
        message: "Example is too deeply nested. This may indicate a circular reference."
      }
    ];
  }
  if (typeof example === "string" && example.startsWith(EXAMPLE_REFERENCE_PREFIX)) {
    const resolvedExpectedType = typeResolver.resolveType({
      type: rawTypeReference,
      file
    });
    if (resolvedExpectedType == null) {
      return [];
    }
    const parsedExampleReference = exampleResolver.parseExampleReference(example);
    if (parsedExampleReference == null) {
      return [];
    }
    const resolvedActualType = typeResolver.resolveNamedType({
      referenceToNamedType: parsedExampleReference.rawTypeReference,
      file
    });
    if (resolvedActualType == null) {
      return [];
    }
    if (areResolvedTypesEquivalent({ expected: resolvedExpectedType, actual: resolvedActualType })) {
      return [];
    } else {
      return [
        {
          message: `Expected example to be: ${rawTypeReference}. Example is ${example}.`
        }
      ];
    }
  }
  return visitRawTypeReference({
    type: rawTypeReference,
    _default: void 0,
    validation: void 0,
    visitor: {
      primitive: (primitiveType) => validatePrimitiveExample({ primitiveType, example }),
      named: (referenceToNamedType) => {
        const declaration = typeResolver.getDeclarationOfNamedType({
          referenceToNamedType,
          file
        });
        if (declaration == null) {
          return [];
        }
        return validateTypeExample({
          typeName: declaration.typeName,
          typeDeclaration: declaration.declaration,
          file: declaration.file,
          example,
          typeResolver,
          exampleResolver,
          workspace,
          breadcrumbs,
          depth: depth + 1
        });
      },
      map: ({ keyType, valueType }) => {
        if (!isPlainObject2(example)) {
          return getViolationsForMisshapenExample(example, "a map");
        }
        return Object.entries(example).flatMap(([exampleKey, exampleValue]) => [
          ...validateTypeReferenceExample({
            rawTypeReference: keyType,
            example: exampleKey,
            typeResolver,
            exampleResolver,
            file,
            workspace,
            breadcrumbs: [...breadcrumbs, exampleKey],
            depth: depth + 1
          }),
          ...validateTypeReferenceExample({
            rawTypeReference: valueType,
            example: exampleValue,
            typeResolver,
            exampleResolver,
            file,
            workspace,
            breadcrumbs: [...breadcrumbs, exampleKey],
            depth: depth + 1
          })
        ]);
      },
      list: (itemType) => {
        if (!Array.isArray(example)) {
          return getViolationsForMisshapenExample(example, "a list");
        }
        return example.flatMap((exampleItem, idx) => validateTypeReferenceExample({
          rawTypeReference: itemType,
          example: exampleItem,
          typeResolver,
          exampleResolver,
          file,
          workspace,
          breadcrumbs: [...breadcrumbs, `${idx}`],
          depth: depth + 1
        }));
      },
      set: (itemType) => {
        if (!Array.isArray(example)) {
          return getViolationsForMisshapenExample(example, "a list");
        }
        const duplicates = getDuplicates(example);
        if (duplicates.length > 0) {
          return [
            {
              severity: "error",
              message: "Set has duplicate elements:\n" + duplicates.map((item) => `  - ${JSON.stringify(item)}`).join("\n")
            }
          ];
        }
        return example.flatMap((exampleItem, idx) => validateTypeReferenceExample({
          rawTypeReference: itemType,
          example: exampleItem,
          typeResolver,
          exampleResolver,
          file,
          workspace,
          breadcrumbs: [...breadcrumbs, `${idx}`],
          depth: depth + 1
        }));
      },
      optional: (itemType) => {
        if (example == null) {
          return [];
        }
        return validateTypeReferenceExample({
          rawTypeReference: itemType,
          example,
          typeResolver,
          exampleResolver,
          file,
          workspace,
          breadcrumbs,
          depth: depth + 1
        });
      },
      unknown: () => {
        return [];
      },
      literal: (expectedLiteral) => {
        switch (expectedLiteral.type) {
          case "boolean":
            return createValidator((e) => e === expectedLiteral.boolean, expectedLiteral.boolean.toString())(example);
          case "string":
            return createValidator((e) => e === expectedLiteral.string, `"${expectedLiteral.string}"`)(example);
          default:
            assertNever(expectedLiteral);
        }
      }
    }
  });
}
function validatePrimitiveExample({ primitiveType, example }) {
  if (primitiveType.v2 != null) {
    return PrimitiveTypeV2._visit(primitiveType.v2, {
      integer: (v2) => validateIntegerWithRules({
        example,
        rules: v2.validation
      }),
      long: () => validateLong(example),
      uint: () => validateUint(example),
      uint64: () => validateUint64(example),
      double: (v2) => validateDoubleWithRules({
        example,
        rules: v2.validation
      }),
      float: () => validateFloat(example),
      boolean: () => validateBoolean(example),
      string: (v2) => validateStringWithRules({
        example,
        rules: v2.validation
      }),
      uuid: () => validateUuid(example),
      date: () => validateDate(example),
      dateTime: () => validateDateTime(example),
      base64: () => validateString(example),
      bigInteger: () => validateString(example),
      _other: () => {
        throw new Error("Unknown primitive type v2: " + primitiveType.v2);
      }
    });
  }
  return PrimitiveTypeV1._visit(primitiveType.v1, {
    integer: () => validateInteger(example),
    long: () => validateLong(example),
    uint: () => validateUint(example),
    uint64: () => validateUint64(example),
    double: () => validateDouble(example),
    float: () => validateFloat(example),
    boolean: () => validateBoolean(example),
    string: () => validateString(example),
    uuid: () => validateUuid(example),
    dateTime: () => validateDateTime(example),
    date: () => validateDate(example),
    base64: () => validateString(example),
    bigInteger: () => validateString(example),
    _other: () => {
      throw new Error("Unknown primitive type: " + primitiveType.v1);
    }
  });
}
function validateIntegerWithRules({ example, rules }) {
  const violations = validateInteger(example);
  if (violations.length > 0 || rules == null) {
    return violations;
  }
  const integer = example;
  if (rules.min != null) {
    if (rules.exclusiveMin && integer <= rules.min || !rules.exclusiveMin && integer < rules.min) {
      return [
        {
          message: `Expected integer to be greater than or equal to ${rules.min}. Example is ${example}.`
        }
      ];
    }
  }
  if (rules.max != null) {
    if (rules.exclusiveMax && integer >= rules.max || !rules.exclusiveMax && integer > rules.max) {
      return [
        {
          message: `Expected integer to be less than or equal to ${rules.max}. Example is ${example}.`
        }
      ];
    }
  }
  if (rules.multipleOf != null) {
    if (integer % rules.multipleOf !== 0) {
      return [
        {
          message: `Expected integer to be a multiple of ${rules.multipleOf}. Example is ${example}.`
        }
      ];
    }
  }
  return [];
}
function validateDoubleWithRules({ example, rules }) {
  const violations = validateDouble(example);
  if (violations.length > 0 || rules == null) {
    return violations;
  }
  const double = example;
  if (rules.min != null) {
    if (rules.exclusiveMin && double <= rules.min || !rules.exclusiveMin && double < rules.min) {
      return [
        {
          message: `Expected double to be greater than or equal to ${rules.min}. Example is ${example}.`
        }
      ];
    }
  }
  if (rules.max != null) {
    if (rules.exclusiveMax && double >= rules.max || !rules.exclusiveMax && double > rules.max) {
      return [
        {
          message: `Expected double to be less than or equal to ${rules.max}. Example is ${example}.`
        }
      ];
    }
  }
  if (rules.multipleOf != null) {
    if (double % rules.multipleOf !== 0) {
      return [
        {
          message: `Expected double to be a multiple of ${rules.multipleOf}. Example is ${example}.`
        }
      ];
    }
  }
  return [];
}
function validateStringWithRules({ example, rules }) {
  const violations = validateString(example);
  if (violations.length > 0 || rules == null) {
    return violations;
  }
  const str2 = example;
  if (rules.minLength != null) {
    if (str2.length < rules.minLength) {
      return [
        {
          message: `Expected string length to be greater than or equal to ${rules.minLength}. Example is ${example}, which is of length ${str2.length}.`
        }
      ];
    }
  }
  if (rules.maxLength != null) {
    if (str2.length > rules.maxLength) {
      return [
        {
          message: `Expected string length to be less than or equal to ${rules.maxLength}. Example is ${example}, which is of length ${str2.length}.`
        }
      ];
    }
  }
  if (rules.pattern != null) {
    const regex = new RegExp(rules.pattern);
    if (!regex.test(str2)) {
      return [
        {
          message: `Expected string to match pattern ${rules.pattern}. Example is ${example}.`
        }
      ];
    }
  }
  return [];
}
var validateString = createValidator((example) => typeof example === "string", "a string");
var validateInteger = createValidator((example) => Number.isInteger(example), "an integer");
var validateUint = createValidator((example) => Number.isInteger(example) && typeof example === "number" && example >= 0, "a uint");
var validateUint64 = createValidator((example) => Number.isInteger(example) && typeof example === "number" && example >= 0, "a uint64");
var validateFloat = createValidator((example) => typeof example === "number", "a float");
var validateDouble = createValidator((example) => typeof example === "number", "a double");
var validateLong = createValidator((example) => Number.isInteger(example), "an integer");
var validateBoolean = createValidator((example) => typeof example === "boolean", "a boolean");
var validateUuid = createValidator((example) => typeof example === "string" && UUID_REGEX.test(example), "a UUID");
var validateDateTime = createValidator((example) => typeof example === "string" && ISO_8601_REGEX3.test(example), "an ISO 8601 timestamp");
var validateDate = createValidator((example) => typeof example === "string" && RFC_3339_DATE_REGEX.test(example) && ISO_8601_REGEX3.test(example), "a date");
function createValidator(validate, expectedTypeIncludingArticle) {
  return (example) => {
    if (validate(example)) {
      return [];
    }
    return getViolationsForMisshapenExample(example, expectedTypeIncludingArticle);
  };
}
function areResolvedTypesEquivalent({ expected, actual }) {
  if (expected._type === "unknown") {
    return true;
  }
  if (expected._type === "primitive") {
    return actual._type === "primitive" && expected.primitive.v1 === actual.primitive.v1;
  }
  if (expected._type === "container") {
    switch (expected.container._type) {
      case "list":
      case "set":
        return actual._type === "container" && actual.container._type === expected.container._type && areResolvedTypesEquivalent({
          expected: expected.container.itemType,
          actual: actual.container.itemType
        });
      case "optional":
        return areResolvedTypesEquivalent({
          expected: expected.container.itemType,
          actual: actual._type === "container" && actual.container._type === "optional" ? actual.container.itemType : actual
        });
      case "map":
        return actual._type === "container" && actual.container._type === expected.container._type && areResolvedTypesEquivalent({
          expected: expected.container.keyType,
          actual: actual.container.keyType
        }) && areResolvedTypesEquivalent({
          expected: expected.container.valueType,
          actual: actual.container.valueType
        });
      case "literal":
        if (actual._type !== "container" || actual.container._type !== expected.container._type) {
          return false;
        }
        return areLiteralTypesEquivalent({
          expected: expected.container.literal,
          actual: actual.container.literal
        });
      default:
        assertNever(expected.container);
    }
  }
  if (expected._type === "named") {
    return actual._type === "named" && actual.filepath === expected.filepath && actual.rawName === expected.rawName;
  }
  assertNever(expected);
}
function areLiteralTypesEquivalent({ expected, actual }) {
  switch (expected.type) {
    case "boolean":
      return actual.type === "boolean" ? expected.boolean === actual.boolean : false;
    case "string":
      return actual.type === "string" ? expected.string === actual.string : false;
    default:
      assertNever(expected);
  }
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertEnumTypeDeclaration.js
async function convertEnumTypeDeclaration({ _enum, file }) {
  const values = await Promise.all(_enum.enum.map(async (value) => {
    return {
      ...await convertDeclaration(value),
      name: file.casingsGenerator.generateNameAndWireValue({
        wireValue: typeof value === "string" ? value : value.value,
        name: getEnumName(value).name,
        opts: {
          casingOverrides: typeof value !== "string" ? value.casing : void 0
        }
      })
    };
  }));
  let defaultValue;
  if (_enum.default != null) {
    defaultValue = values.find((enumValue) => enumValue.name.wireValue === _enum.default);
    if (defaultValue == null) {
      throw new Error(`Default value ${_enum.default} not found in enum values`);
    }
  }
  return {
    default: defaultValue,
    values
  };
}
function getEnumNameFromEnumValue(enumValue, _enum) {
  const maybeEnumDefintion = _enum.enum.find((value) => typeof value === "string" ? false : value.value === enumValue);
  return {
    name: typeof maybeEnumDefintion === "string" ? enumValue : maybeEnumDefintion?.name ?? enumValue,
    wasExplicitlySet: false
  };
}
function getEnumName(enumValue) {
  if (typeof enumValue === "string") {
    return {
      name: enumValue,
      wasExplicitlySet: false
    };
  }
  if (enumValue.name == null) {
    return {
      name: enumValue.value,
      wasExplicitlySet: false
    };
  }
  return {
    name: enumValue.name,
    wasExplicitlySet: true
  };
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertExampleType.js
function convertTypeExample({ typeName, typeDeclaration, example, typeResolver, exampleResolver, fileContainingType, fileContainingExample, workspace }) {
  return visitRawTypeDeclaration(typeDeclaration, {
    alias: (rawAlias) => {
      return ExampleTypeShape.alias({
        value: convertTypeReferenceExample({
          example,
          rawTypeBeingExemplified: typeof rawAlias === "string" ? rawAlias : rawAlias.type,
          fileContainingRawTypeReference: fileContainingType,
          fileContainingExample,
          typeResolver,
          exampleResolver,
          workspace
        })
      });
    },
    object: (rawObject) => {
      return convertObject4({
        typeName,
        rawObject,
        example,
        fileContainingType,
        fileContainingExample,
        typeResolver,
        exampleResolver,
        workspace
      });
    },
    discriminatedUnion: (rawUnion) => {
      const discriminant3 = getUnionDiscriminant(rawUnion);
      if (!isPlainObject2(example)) {
        throw new Error("Example is not an object");
      }
      const discriminantValueForExample = example[discriminant3];
      if (discriminantValueForExample == null) {
        throw new Error("Example is missing discriminant: " + discriminant3);
      }
      if (typeof discriminantValueForExample !== "string") {
        throw new Error("Discriminant value is not a string");
      }
      const rawSingleUnionType = rawUnion.union[discriminantValueForExample];
      if (rawSingleUnionType == null) {
        throw new Error(`${discriminantValueForExample} is not one of the specified discriminant values.`);
      }
      const rawValueType = typeof rawSingleUnionType === "string" ? rawSingleUnionType : typeof rawSingleUnionType.type === "string" ? rawSingleUnionType.type : void 0;
      return ExampleTypeShape.union({
        discriminant: fileContainingExample.casingsGenerator.generateNameAndWireValue({
          name: getUnionDiscriminantName(rawUnion).name,
          wireValue: discriminant3
        }),
        singleUnionType: convertSingleUnionType({
          rawValueType,
          rawSingleUnionType,
          fileContainingType,
          fileContainingExample,
          typeResolver,
          exampleResolver,
          example,
          discriminant: discriminant3,
          discriminantValueForExample,
          workspace
        })
      });
    },
    enum: (rawEnum) => {
      if (typeof example !== "string") {
        throw new Error("Enum example is not a string");
      }
      return ExampleTypeShape.enum({
        value: fileContainingExample.casingsGenerator.generateNameAndWireValue({
          name: getEnumNameFromEnumValue(example, rawEnum).name,
          wireValue: example
        })
      });
    },
    undiscriminatedUnion: (undiscriminatedUnion3) => {
      for (const [index, variant] of undiscriminatedUnion3.union.entries()) {
        const violationsForMember = validateTypeReferenceExample({
          rawTypeReference: typeof variant === "string" ? variant : variant.type,
          example,
          typeResolver,
          exampleResolver,
          file: fileContainingType,
          workspace,
          breadcrumbs: [],
          depth: 0
        });
        if (violationsForMember.length === 0) {
          return ExampleTypeShape.undiscriminatedUnion({
            index,
            singleUnionType: convertTypeReferenceExample({
              example,
              rawTypeBeingExemplified: typeof variant === "string" ? variant : variant.type,
              fileContainingRawTypeReference: fileContainingType,
              fileContainingExample,
              typeResolver,
              exampleResolver,
              workspace
            })
          });
        }
      }
      throw new Error("Example doesn't match any of the undiscriminated unions");
    }
  });
}
function convertTypeReferenceExample({ example, fileContainingExample, rawTypeBeingExemplified, fileContainingRawTypeReference, typeResolver, exampleResolver, workspace }) {
  const { resolvedExample, file: fileContainingResolvedExample } = exampleResolver.resolveExampleOrThrow({
    example,
    file: fileContainingExample
  });
  const jsonExample = exampleResolver.resolveAllReferencesInExampleOrThrow({
    example,
    file: fileContainingExample
  }).resolvedExample;
  const shape = visitRawTypeReference({
    type: rawTypeBeingExemplified,
    _default: void 0,
    validation: void 0,
    visitor: {
      primitive: (primitive) => {
        return convertPrimitiveExample({
          example: resolvedExample,
          typeBeingExemplified: primitive.v1
        });
      },
      map: ({ keyType, valueType }) => {
        if (!isPlainObject2(resolvedExample)) {
          throw new Error("Example is not an object");
        }
        return ExampleTypeReferenceShape.container(ExampleContainer.map({
          map: Object.entries(resolvedExample).map(([key, value]) => ({
            key: convertTypeReferenceExample({
              example: key,
              fileContainingExample: fileContainingResolvedExample,
              rawTypeBeingExemplified: keyType,
              fileContainingRawTypeReference,
              typeResolver,
              exampleResolver,
              workspace
            }),
            value: convertTypeReferenceExample({
              example: value,
              fileContainingExample: fileContainingResolvedExample,
              rawTypeBeingExemplified: valueType,
              fileContainingRawTypeReference,
              typeResolver,
              exampleResolver,
              workspace
            })
          })),
          keyType: fileContainingRawTypeReference.parseTypeReference(keyType),
          valueType: fileContainingRawTypeReference.parseTypeReference(valueType)
        }));
      },
      list: (itemType) => {
        if (!Array.isArray(resolvedExample)) {
          throw new Error("Example is not a list");
        }
        return ExampleTypeReferenceShape.container(ExampleContainer.list({
          list: resolvedExample.map((exampleItem) => convertTypeReferenceExample({
            example: exampleItem,
            fileContainingExample: fileContainingResolvedExample,
            rawTypeBeingExemplified: itemType,
            fileContainingRawTypeReference,
            typeResolver,
            exampleResolver,
            workspace
          })),
          itemType: fileContainingRawTypeReference.parseTypeReference(itemType)
        }));
      },
      set: (itemType) => {
        if (!Array.isArray(resolvedExample)) {
          throw new Error("Example is not a list");
        }
        return ExampleTypeReferenceShape.container(ExampleContainer.set({
          set: resolvedExample.map((exampleItem) => convertTypeReferenceExample({
            example: exampleItem,
            fileContainingExample: fileContainingResolvedExample,
            rawTypeBeingExemplified: itemType,
            fileContainingRawTypeReference,
            typeResolver,
            exampleResolver,
            workspace
          })),
          itemType: fileContainingRawTypeReference.parseTypeReference(itemType)
        }));
      },
      optional: (itemType) => {
        return ExampleTypeReferenceShape.container(ExampleContainer.optional({
          optional: resolvedExample != null ? convertTypeReferenceExample({
            example: resolvedExample,
            fileContainingExample: fileContainingResolvedExample,
            rawTypeBeingExemplified: itemType,
            fileContainingRawTypeReference,
            typeResolver,
            exampleResolver,
            workspace
          }) : void 0,
          valueType: fileContainingRawTypeReference.parseTypeReference(itemType)
        }));
      },
      literal: (literal) => {
        switch (literal.type) {
          case "boolean":
            return ExampleTypeReferenceShape.container(ExampleContainer.literal({ literal: ExamplePrimitive.boolean(literal.boolean) }));
          case "string":
            return ExampleTypeReferenceShape.container(ExampleContainer.literal({
              literal: ExamplePrimitive.string({
                original: literal.string
              })
            }));
          default:
            assertNever(literal);
        }
      },
      named: (named) => {
        const typeDeclaration = typeResolver.getDeclarationOfNamedTypeOrThrow({
          referenceToNamedType: rawTypeBeingExemplified,
          file: fileContainingRawTypeReference
        });
        const parsedReferenceToNamedType = fileContainingRawTypeReference.parseTypeReference(named);
        if (parsedReferenceToNamedType.type !== "named") {
          throw new Error("Type reference is not to a named type.");
        }
        const typeName = {
          typeId: parsedReferenceToNamedType.typeId,
          fernFilepath: parsedReferenceToNamedType.fernFilepath,
          name: parsedReferenceToNamedType.name
        };
        return ExampleTypeReferenceShape.named({
          typeName,
          shape: convertTypeExample({
            typeName,
            typeDeclaration: typeDeclaration.declaration,
            fileContainingType: typeDeclaration.file,
            fileContainingExample: fileContainingResolvedExample,
            example: resolvedExample,
            typeResolver,
            exampleResolver,
            workspace
          })
        });
      },
      unknown: () => {
        return ExampleTypeReferenceShape.unknown(jsonExample);
      }
    }
  });
  return {
    shape,
    jsonExample
  };
}
function convertPrimitiveExample({ example, typeBeingExemplified }) {
  return PrimitiveTypeV1._visit(typeBeingExemplified, {
    string: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.string({
        original: example
      }));
    },
    dateTime: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.datetime({
        datetime: new Date(example),
        raw: example
      }));
    },
    date: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.date(example));
    },
    base64: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.string({
        original: example
      }));
    },
    uint: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.uint(example));
    },
    uint64: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.uint64(example));
    },
    integer: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.integer(example));
    },
    float: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.float(example));
    },
    double: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.double(example));
    },
    long: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.long(example));
    },
    boolean: () => {
      if (typeof example !== "boolean") {
        throw new Error("Example is not a boolean");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.boolean(example));
    },
    uuid: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.uuid(example));
    },
    bigInteger: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.string({
        original: example
      }));
    },
    _other: () => {
      throw new Error("Unknown primitive type: " + typeBeingExemplified);
    }
  });
}
function convertObject4({ typeName, rawObject, example, fileContainingType, fileContainingExample, typeResolver, exampleResolver, workspace }) {
  if (!isPlainObject2(example)) {
    throw new Error(`Example is not an object. Got: ${JSON.stringify(example)}`);
  }
  return ExampleTypeShape.object({
    properties: rawObject.properties != null || rawObject.extends != null ? Object.entries(example).reduce((exampleProperties, [wireKey, propertyExample]) => {
      const originalTypeDeclaration = getOriginalTypeDeclarationForProperty({
        typeName,
        wirePropertyKey: wireKey,
        rawObject,
        typeResolver,
        file: fileContainingType
      });
      if (originalTypeDeclaration == null) {
        return exampleProperties;
      }
      const valueExample = convertTypeReferenceExample({
        example: propertyExample,
        fileContainingExample,
        rawTypeBeingExemplified: typeof originalTypeDeclaration.rawPropertyType === "string" ? originalTypeDeclaration.rawPropertyType : originalTypeDeclaration.rawPropertyType.type,
        fileContainingRawTypeReference: originalTypeDeclaration.file,
        typeResolver,
        exampleResolver,
        workspace
      });
      exampleProperties.push({
        name: fileContainingExample.casingsGenerator.generateNameAndWireValue({
          name: getPropertyName({
            propertyKey: wireKey,
            property: originalTypeDeclaration.rawPropertyType
          }).name,
          wireValue: wireKey
        }),
        value: valueExample,
        originalTypeDeclaration: originalTypeDeclaration.typeName
      });
      return exampleProperties;
    }, []) : []
  });
}
function getOriginalTypeDeclarationForProperty({ typeName, wirePropertyKey, rawObject, typeResolver, file }) {
  const rawPropertyType = rawObject.properties?.[wirePropertyKey];
  if (rawPropertyType != null) {
    return { typeName, rawPropertyType, file };
  } else {
    return getOriginalTypeDeclarationForPropertyFromExtensions({
      wirePropertyKey,
      extends_: rawObject.extends,
      typeResolver,
      file
    });
  }
}
function getOriginalTypeDeclarationForPropertyFromExtensions({ wirePropertyKey, extends_, typeResolver, file }) {
  if (extends_ != null) {
    const extendsList = typeof extends_ === "string" ? [extends_] : extends_;
    for (const typeName of extendsList) {
      const resolvedType = typeResolver.resolveNamedTypeOrThrow({
        referenceToNamedType: typeName,
        file
      });
      if (resolvedType._type !== "named" || !isRawObjectDefinition(resolvedType.declaration)) {
        throw new Error("Extension is not of a named object");
      }
      const originalTypeDeclaration = getOriginalTypeDeclarationForProperty({
        wirePropertyKey,
        rawObject: resolvedType.declaration,
        typeResolver,
        typeName: resolvedType.name,
        file: resolvedType.file
      });
      if (originalTypeDeclaration != null) {
        return originalTypeDeclaration;
      }
    }
  }
  return void 0;
}
function convertSingleUnionType({ rawValueType, rawSingleUnionType, fileContainingType, fileContainingExample, typeResolver, exampleResolver, example, discriminant: discriminant3, discriminantValueForExample, workspace }) {
  const wireDiscriminantValue = fileContainingExample.casingsGenerator.generateNameAndWireValue({
    name: getSingleUnionTypeName({ unionKey: discriminantValueForExample, rawSingleUnionType }).name,
    wireValue: discriminantValueForExample
  });
  if (rawValueType == null) {
    return {
      wireDiscriminantValue,
      shape: ExampleSingleUnionTypeProperties.noProperties()
    };
  }
  const parsedSingleUnionTypeProperties = getSingleUnionTypeProperties({
    rawSingleUnionType,
    rawValueType,
    parsedValueType: fileContainingType.parseTypeReference(rawValueType),
    file: fileContainingType,
    typeResolver
  });
  switch (parsedSingleUnionTypeProperties.propertiesType) {
    case "singleProperty": {
      if (!isPlainObject2(example)) {
        throw new Error("Example is not an object");
      }
      return {
        wireDiscriminantValue,
        shape: ExampleSingleUnionTypeProperties.singleProperty(convertTypeReferenceExample({
          example: example[parsedSingleUnionTypeProperties.name.wireValue],
          rawTypeBeingExemplified: rawValueType,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: fileContainingType,
          fileContainingExample,
          workspace
        }))
      };
    }
    case "samePropertiesAsObject": {
      if (!isPlainObject2(example)) {
        throw new Error("Example is not an object");
      }
      const { [discriminant3]: _discriminantValue, ...nonDiscriminantPropertiesFromExample } = example;
      let rawDeclaration = typeResolver.getDeclarationOfNamedTypeOrThrow({
        referenceToNamedType: rawValueType,
        file: fileContainingType
      });
      while (isRawAliasDefinition(rawDeclaration.declaration)) {
        rawDeclaration = typeResolver.getDeclarationOfNamedTypeOrThrow({
          referenceToNamedType: typeof rawDeclaration.declaration === "string" ? rawDeclaration.declaration : rawDeclaration.declaration.type,
          file: fileContainingType
        });
      }
      if (!isRawObjectDefinition(rawDeclaration.declaration)) {
        throw new Error(`${rawValueType} is not an object`);
      }
      const typeName = {
        typeId: parsedSingleUnionTypeProperties.typeId,
        fernFilepath: parsedSingleUnionTypeProperties.fernFilepath,
        name: parsedSingleUnionTypeProperties.name
      };
      return {
        wireDiscriminantValue,
        shape: ExampleSingleUnionTypeProperties.samePropertiesAsObject({
          typeId: IdGenerator.generateTypeId(typeName),
          object: convertObject4({
            rawObject: rawDeclaration.declaration,
            example: nonDiscriminantPropertiesFromExample,
            fileContainingType: rawDeclaration.file,
            fileContainingExample,
            typeResolver,
            exampleResolver,
            typeName,
            workspace
          })
        })
      };
    }
    default:
      assertNever(parsedSingleUnionTypeProperties);
  }
}

// ../../cli/generation/ir-generator/lib/converters/services/convertQueryParameter.js
async function convertQueryParameter({ file, queryParameterKey, queryParameter }) {
  const { name } = getQueryParameterName({ queryParameterKey, queryParameter });
  const valueType = file.parseTypeReference(queryParameter);
  return {
    ...await convertDeclaration(queryParameter),
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: queryParameterKey,
      name
    }),
    valueType,
    allowMultiple: typeof queryParameter !== "string" && queryParameter["allow-multiple"] != null ? queryParameter["allow-multiple"] : false
  };
}
function getQueryParameterName({ queryParameterKey, queryParameter }) {
  if (typeof queryParameter !== "string") {
    if (queryParameter.name != null) {
      return { name: queryParameter.name, wasExplicitlySet: true };
    }
  }
  return { name: queryParameterKey, wasExplicitlySet: false };
}

// ../../cli/generation/ir-generator/lib/utils/getEndpointPathParameters.js
function getEndpointPathParameters(endpoint) {
  return typeof endpoint.request !== "string" && endpoint.request?.["path-parameters"] ? endpoint.request?.["path-parameters"] : endpoint["path-parameters"] != null ? endpoint["path-parameters"] : {};
}

// ../../cli/generation/ir-generator/lib/converters/services/convertExampleEndpointCall.js
function hashJSON(obj) {
  const jsonString = JSON.stringify(obj);
  return import_crypto.default.createHash("sha256").update(jsonString).digest("hex");
}
function convertExampleEndpointCall({ service, endpoint, example, typeResolver, errorResolver, exampleResolver, variableResolver, file, workspace }) {
  const convertedPathParameters = convertPathParameters({
    service,
    endpoint,
    example,
    typeResolver,
    exampleResolver,
    variableResolver,
    file,
    workspace
  });
  return {
    id: example.name ?? hashJSON(example),
    name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
    docs: example.docs,
    url: buildUrl({ file, service, endpoint, example, pathParams: convertedPathParameters }),
    ...convertedPathParameters,
    ...convertHeaders({ service, endpoint, example, typeResolver, exampleResolver, file, workspace }),
    queryParameters: example["query-parameters"] != null ? Object.entries(example["query-parameters"]).map(([wireKey, value]) => {
      const queryParameterDeclaration = typeof endpoint.request !== "string" ? endpoint.request?.["query-parameters"]?.[wireKey] : void 0;
      if (queryParameterDeclaration == null) {
        throw new Error(`Query parameter ${wireKey} does not exist`);
      }
      return {
        name: file.casingsGenerator.generateNameAndWireValue({
          name: getQueryParameterName({
            queryParameterKey: wireKey,
            queryParameter: queryParameterDeclaration
          }).name,
          wireValue: wireKey
        }),
        value: convertTypeReferenceExample({
          example: value,
          rawTypeBeingExemplified: typeof queryParameterDeclaration === "string" ? queryParameterDeclaration : queryParameterDeclaration.type,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          workspace
        }),
        shape: getQueryParamaterDeclationShape({ queryParameter: queryParameterDeclaration })
      };
    }) : [],
    request: convertExampleRequestBody({ endpoint, example, typeResolver, exampleResolver, file, workspace }),
    response: convertExampleResponse({
      endpoint,
      example,
      typeResolver,
      errorResolver,
      exampleResolver,
      file,
      workspace
    })
  };
}
function getQueryParamaterDeclationShape({ queryParameter }) {
  const isAllowMultiple = typeof queryParameter !== "string" && queryParameter["allow-multiple"] != null ? queryParameter["allow-multiple"] : false;
  return isAllowMultiple ? ExampleQueryParameterShape.exploded() : ExampleQueryParameterShape.single();
}
function convertPathParameters({ service, endpoint, example, typeResolver, exampleResolver, variableResolver, file, workspace }) {
  const rootPathParameters = [];
  const servicePathParameters = [];
  const endpointPathParameters = [];
  const buildExamplePathParameter = ({ name, pathParameterDeclaration, examplePathParameter }) => {
    const resolvedPathParameter = resolvePathParameterOrThrow({
      parameter: pathParameterDeclaration,
      variableResolver,
      file
    });
    return {
      name,
      value: convertTypeReferenceExample({
        example: examplePathParameter,
        rawTypeBeingExemplified: resolvedPathParameter.rawType,
        typeResolver,
        exampleResolver,
        fileContainingRawTypeReference: resolvedPathParameter.file,
        fileContainingExample: file,
        workspace
      })
    };
  };
  if (example["path-parameters"] != null) {
    const rawEndpointPathParameters = getEndpointPathParameters(endpoint);
    for (const [key, examplePathParameter] of Object.entries(example["path-parameters"])) {
      const rootPathParameterDeclaration = file.rootApiFile["path-parameters"]?.[key];
      const servicePathParameterDeclaration = service["path-parameters"]?.[key];
      const endpointPathParameterDeclaration = rawEndpointPathParameters[key];
      if (rootPathParameterDeclaration != null) {
        rootPathParameters.push(buildExamplePathParameter({
          name: file.casingsGenerator.generateName(key),
          pathParameterDeclaration: rootPathParameterDeclaration,
          examplePathParameter
        }));
      } else if (endpointPathParameterDeclaration != null) {
        endpointPathParameters.push(buildExamplePathParameter({
          name: file.casingsGenerator.generateName(key),
          pathParameterDeclaration: endpointPathParameterDeclaration,
          examplePathParameter
        }));
      } else if (servicePathParameterDeclaration != null) {
        servicePathParameters.push(buildExamplePathParameter({
          name: file.casingsGenerator.generateName(key),
          pathParameterDeclaration: servicePathParameterDeclaration,
          examplePathParameter
        }));
      } else {
        throw new Error(`Path parameter ${key} does not exist`);
      }
    }
  }
  return {
    rootPathParameters,
    endpointPathParameters,
    servicePathParameters
  };
}
function convertHeaders({ service, endpoint, example, typeResolver, exampleResolver, file, workspace }) {
  const serviceHeaders = [];
  const endpointHeaders = [];
  if (example.headers != null) {
    for (const [wireKey, exampleHeader] of Object.entries(example.headers)) {
      const endpointHeaderDeclaration = typeof endpoint.request !== "string" ? endpoint.request?.headers?.[wireKey] : void 0;
      const serviceHeaderDeclaration = service.headers?.[wireKey];
      if (endpointHeaderDeclaration != null) {
        endpointHeaders.push({
          name: file.casingsGenerator.generateNameAndWireValue({
            name: getHeaderName2({ headerKey: wireKey, header: endpointHeaderDeclaration }).name,
            wireValue: wireKey
          }),
          value: convertTypeReferenceExample({
            example: exampleHeader,
            rawTypeBeingExemplified: typeof endpointHeaderDeclaration === "string" ? endpointHeaderDeclaration : endpointHeaderDeclaration.type,
            typeResolver,
            exampleResolver,
            fileContainingRawTypeReference: file,
            fileContainingExample: file,
            workspace
          })
        });
      } else if (serviceHeaderDeclaration != null) {
        serviceHeaders.push({
          name: file.casingsGenerator.generateNameAndWireValue({
            name: getHeaderName2({ headerKey: wireKey, header: serviceHeaderDeclaration }).name,
            wireValue: wireKey
          }),
          value: convertTypeReferenceExample({
            example: exampleHeader,
            rawTypeBeingExemplified: typeof serviceHeaderDeclaration === "string" ? serviceHeaderDeclaration : serviceHeaderDeclaration.type,
            typeResolver,
            exampleResolver,
            fileContainingRawTypeReference: file,
            fileContainingExample: file,
            workspace
          })
        });
      } else {
        throw new Error(`Header ${wireKey} does not exist`);
      }
    }
  }
  return {
    endpointHeaders,
    serviceHeaders
  };
}
function convertExampleRequestBody({ endpoint, example, typeResolver, exampleResolver, file, workspace }) {
  const requestType = typeof endpoint.request !== "string" ? endpoint.request?.body : endpoint.request;
  if (requestType == null) {
    return void 0;
  }
  if (typeof requestType === "string" && parseBytesRequest(requestType) != null) {
    return void 0;
  }
  if (!isInlineRequestBody(requestType)) {
    return ExampleRequestBody.reference(convertTypeReferenceExample({
      example: example.request,
      rawTypeBeingExemplified: typeof requestType !== "string" ? requestType.type : requestType,
      typeResolver,
      exampleResolver,
      fileContainingRawTypeReference: file,
      fileContainingExample: file,
      workspace
    }));
  }
  if (!example.request) {
    return void 0;
  }
  if (!isPlainObject2(example.request)) {
    throw new Error(`Example is not an object. Got: ${JSON.stringify(example.request)}`);
  }
  const exampleProperties = [];
  for (const [wireKey, propertyExample] of Object.entries(example.request)) {
    const inlinedRequestPropertyDeclaration = requestType.properties?.[wireKey];
    const inilnedRequestPropertyType = typeof inlinedRequestPropertyDeclaration === "string" ? inlinedRequestPropertyDeclaration : inlinedRequestPropertyDeclaration?.type;
    if (inilnedRequestPropertyType != null && parseRawFileType(inilnedRequestPropertyType) != null) {
      continue;
    }
    if (inlinedRequestPropertyDeclaration != null) {
      exampleProperties.push({
        name: file.casingsGenerator.generateNameAndWireValue({
          name: getPropertyName({ propertyKey: wireKey, property: inlinedRequestPropertyDeclaration }).name,
          wireValue: wireKey
        }),
        value: convertTypeReferenceExample({
          example: propertyExample,
          rawTypeBeingExemplified: typeof inlinedRequestPropertyDeclaration !== "string" ? inlinedRequestPropertyDeclaration.type : inlinedRequestPropertyDeclaration,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          workspace
        }),
        originalTypeDeclaration: void 0
      });
    } else {
      const originalTypeDeclaration = getOriginalTypeDeclarationForPropertyFromExtensions({
        extends_: requestType.extends,
        wirePropertyKey: wireKey,
        typeResolver,
        file
      });
      if (originalTypeDeclaration == null) {
        throw new Error("Could not find original type declaration for property: " + wireKey);
      }
      exampleProperties.push({
        name: file.casingsGenerator.generateNameAndWireValue({
          name: getPropertyName({ propertyKey: wireKey, property: originalTypeDeclaration.rawPropertyType }).name,
          wireValue: wireKey
        }),
        value: convertTypeReferenceExample({
          example: propertyExample,
          rawTypeBeingExemplified: typeof originalTypeDeclaration.rawPropertyType === "string" ? originalTypeDeclaration.rawPropertyType : originalTypeDeclaration.rawPropertyType.type,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: originalTypeDeclaration.file,
          fileContainingExample: file,
          workspace
        }),
        originalTypeDeclaration: originalTypeDeclaration.typeName
      });
    }
  }
  return ExampleRequestBody.inlinedRequestBody({
    jsonExample: exampleResolver.resolveAllReferencesInExampleOrThrow({ example: example.request, file }).resolvedExample,
    properties: exampleProperties
  });
}
function convertExampleResponse({ endpoint, example, typeResolver, errorResolver, exampleResolver, file, workspace }) {
  if (example.response == null) {
    return ExampleResponse.ok(ExampleEndpointSuccessResponse.body(void 0));
  }
  return visitExampleResponseSchema(endpoint, example.response, {
    body: (example2) => {
      if (example2.error != null) {
        const errorDeclaration = errorResolver.getDeclarationOrThrow(example2.error, file);
        return ExampleResponse.error({
          error: parseErrorName({
            errorName: example2.error,
            file
          }),
          body: errorDeclaration.declaration.type != null ? convertTypeReferenceExample({
            example: example2.body,
            rawTypeBeingExemplified: errorDeclaration.declaration.type,
            typeResolver,
            exampleResolver,
            fileContainingRawTypeReference: errorDeclaration.file,
            fileContainingExample: file,
            workspace
          }) : void 0
        });
      }
      return ExampleResponse.ok(ExampleEndpointSuccessResponse.body(convertExampleResponseBody({ endpoint, example: example2, typeResolver, exampleResolver, file, workspace })));
    },
    stream: (example2) => {
      const rawTypeBeingExemplified = typeof endpoint["response-stream"] === "string" ? endpoint["response-stream"] : endpoint["response-stream"]?.type;
      return ExampleResponse.ok(ExampleEndpointSuccessResponse.stream(example2.stream.map((data) => {
        if (rawTypeBeingExemplified == null) {
          return void 0;
        }
        return convertTypeReferenceExample({
          example: data,
          rawTypeBeingExemplified,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          workspace
        });
      }).filter(isNonNullish)));
    },
    events: (example2) => {
      const rawTypeBeingExemplified = typeof endpoint["response-stream"] === "string" ? endpoint["response-stream"] : endpoint["response-stream"]?.type;
      return ExampleResponse.ok(ExampleEndpointSuccessResponse.sse(example2.stream.map(({ event, data }) => {
        if (rawTypeBeingExemplified == null) {
          return void 0;
        }
        const convertedExample = convertTypeReferenceExample({
          example: data,
          rawTypeBeingExemplified,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          workspace
        });
        return { event, data: convertedExample };
      }).filter(isNonNullish)));
    }
  });
}
function convertExampleResponseBody({ endpoint, example, typeResolver, exampleResolver, file, workspace }) {
  const responseBodyType = typeof endpoint.response !== "string" ? endpoint.response?.type : endpoint.response;
  if (responseBodyType == null) {
    return void 0;
  }
  if (example.body == null) {
    return void 0;
  }
  return convertTypeReferenceExample({
    example: example.body,
    rawTypeBeingExemplified: responseBodyType,
    typeResolver,
    exampleResolver,
    fileContainingRawTypeReference: file,
    fileContainingExample: file,
    workspace
  });
}
function buildUrl({ file, service, endpoint, example, pathParams }) {
  let url = urlJoin(file.rootApiFile["base-path"] ?? "", service["base-path"], endpoint.path);
  if (example["path-parameters"] != null) {
    for (const parameter of [
      ...pathParams.endpointPathParameters,
      ...pathParams.servicePathParameters,
      ...pathParams.rootPathParameters
    ]) {
      url = url.replaceAll(`{${parameter.name.originalName}}`, `${parameter.value.jsonExample}`);
    }
  }
  url = url.replaceAll("//", "/");
  if (!url.startsWith("/")) {
    url = `/${url}`;
  }
  return url;
}

// ../../cli/generation/ir-generator/lib/converters/services/convertHttpResponse.js
async function convertHttpResponse({ endpoint, file, typeResolver }) {
  const responseBody = await convertHttpResponseBody({
    endpoint,
    file,
    typeResolver
  });
  return {
    body: responseBody,
    statusCode: typeof endpoint.response !== "string" ? endpoint.response?.["status-code"] : void 0
  };
}
async function convertHttpResponseBody({ endpoint, file, typeResolver }) {
  const response = await convertNonStreamHttpResponseBody({
    endpoint,
    file,
    typeResolver
  });
  const streamResponse = await convertStreamHttpResponseBody({
    endpoint,
    file,
    typeResolver
  });
  if (response != null && streamResponse != null) {
    let nonStreamResponse;
    switch (response.type) {
      case "fileDownload": {
        nonStreamResponse = NonStreamHttpResponseBody.fileDownload({ ...response });
        break;
      }
      case "json": {
        nonStreamResponse = NonStreamHttpResponseBody.json({
          ...response.value
        });
        break;
      }
      case "text": {
        nonStreamResponse = NonStreamHttpResponseBody.text({ ...response });
        break;
      }
      default:
        assertNever(response);
    }
    return HttpResponseBody.streamParameter({
      nonStreamResponse,
      streamResponse
    });
  } else if (response != null) {
    return response;
  } else if (streamResponse != null) {
    return HttpResponseBody.streaming(streamResponse);
  }
  return void 0;
}
async function convertNonStreamHttpResponseBody({ endpoint, file, typeResolver }) {
  const { response } = endpoint;
  if (response != null) {
    const docs = typeof response !== "string" ? response.docs : void 0;
    const responseType = typeof response === "string" ? response : response.type;
    if (parseRawFileType(responseType) != null) {
      return HttpResponseBody.fileDownload({
        docs
      });
    } else if (parseRawTextType(responseType) != null) {
      return HttpResponseBody.text({
        docs
      });
    } else {
      return await convertJsonResponse(response, docs, file, typeResolver);
    }
  }
  return void 0;
}
async function convertStreamHttpResponseBody({ endpoint, file, typeResolver }) {
  const { ["response-stream"]: responseStream } = endpoint;
  if (responseStream != null) {
    const docs = typeof responseStream !== "string" ? responseStream.docs : void 0;
    const typeReference = typeof responseStream === "string" ? responseStream : responseStream.type;
    const streamFormat = typeof responseStream === "string" ? "json" : responseStream.format ?? "json";
    if (isRawTextType(typeReference)) {
      return StreamingResponse.text({
        docs
      });
    } else if (typeof responseStream !== "string" && streamFormat === "sse") {
      return StreamingResponse.sse({
        docs,
        payload: file.parseTypeReference(typeReference),
        terminator: typeof responseStream !== "string" ? responseStream.terminator : void 0
      });
    } else {
      return StreamingResponse.json({
        docs,
        payload: file.parseTypeReference(typeReference),
        terminator: typeof responseStream !== "string" ? responseStream.terminator : void 0
      });
    }
  }
  return void 0;
}
async function convertJsonResponse(response, docs, file, typeResolver) {
  const responseBodyType = file.parseTypeReference(response);
  const resolvedType = typeResolver.resolveTypeOrThrow({
    type: typeof response !== "string" ? response.type : response,
    file
  });
  const responseProperty = typeof response !== "string" ? response.property : void 0;
  if (responseProperty != null) {
    return HttpResponseBody.json(JsonResponse.nestedPropertyAsResponse({
      docs,
      responseBodyType,
      responseProperty: await getObjectPropertyFromResolvedType({
        typeResolver,
        file,
        resolvedType,
        property: responseProperty
      })
    }));
  }
  return HttpResponseBody.json(JsonResponse.response({
    docs,
    responseBodyType
  }));
}

// ../../cli/generation/ir-generator/lib/converters/services/convertCursorPagination.js
async function convertCursorPagination({ propertyResolver, file, endpointName, endpointSchema, paginationPropertyComponents }) {
  return Pagination.cursor({
    page: await propertyResolver.resolveRequestPropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.cursor
    }),
    next: await propertyResolver.resolveResponsePropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.next_cursor
    }),
    results: await propertyResolver.resolveResponsePropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.results
    })
  });
}

// ../../cli/generation/ir-generator/lib/converters/services/convertOffsetPagination.js
async function convertOffsetPagination({ propertyResolver, file, endpointName, endpointSchema, paginationPropertyComponents }) {
  return Pagination.offset({
    page: await propertyResolver.resolveRequestPropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.offset
    }),
    results: await propertyResolver.resolveResponsePropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.results
    }),
    step: paginationPropertyComponents.step != null ? await propertyResolver.resolveRequestPropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.step
    }) : void 0,
    hasNextPage: paginationPropertyComponents.hasNextPage != null ? await propertyResolver.resolveResponsePropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.hasNextPage
    }) : void 0
  });
}

// ../../cli/generation/ir-generator/lib/converters/services/convertPaginationUtils.js
function getPaginationPropertyComponents(endpointPagination) {
  if (isRawOffsetPaginationSchema(endpointPagination)) {
    return {
      type: "offset",
      offset: getRequestPropertyComponents(endpointPagination.offset),
      results: getResponsePropertyComponents(endpointPagination.results),
      step: endpointPagination.step != null ? getRequestPropertyComponents(endpointPagination.step) : void 0,
      hasNextPage: endpointPagination["has-next-page"] != null ? getResponsePropertyComponents(endpointPagination["has-next-page"]) : void 0
    };
  }
  return {
    type: "cursor",
    cursor: getRequestPropertyComponents(endpointPagination.cursor),
    next_cursor: getResponsePropertyComponents(endpointPagination.next_cursor),
    results: getResponsePropertyComponents(endpointPagination.results)
  };
}
function isRawOffsetPaginationSchema(rawPaginationSchema) {
  return rawPaginationSchema.offset != null && rawPaginationSchema.results != null;
}

// ../../cli/generation/ir-generator/lib/converters/services/convertPagination.js
async function convertPagination({ propertyResolver, file, endpointName, endpointSchema }) {
  const endpointPagination = typeof endpointSchema.pagination === "boolean" ? file.rootApiFile.pagination : endpointSchema.pagination;
  if (!endpointPagination) {
    return void 0;
  }
  const paginationPropertyComponents = getPaginationPropertyComponents(endpointPagination);
  switch (paginationPropertyComponents.type) {
    case "cursor":
      return await convertCursorPagination({
        propertyResolver,
        file,
        endpointName,
        endpointSchema,
        paginationPropertyComponents
      });
    case "offset":
      return convertOffsetPagination({
        propertyResolver,
        file,
        endpointName,
        endpointSchema,
        paginationPropertyComponents
      });
    default:
      assertNever(paginationPropertyComponents);
  }
}

// ../../cli/generation/ir-generator/lib/converters/convertProtobufFile.js
function convertProtobufFile({ source }) {
  return {
    filepath: source.relativeFilePath,
    packageName: source.packageName,
    options: source.csharpNamespace != null ? {
      csharp: {
        namespace: source.csharpNamespace
      }
    } : void 0
  };
}

// ../../cli/generation/ir-generator/lib/converters/services/convertProtobufService.js
function convertProtobufService({ source, serviceNameOverride }) {
  const serviceName = serviceNameOverride ?? source.serviceName;
  if (serviceName == null) {
    return void 0;
  }
  return {
    file: convertProtobufFile({ source }),
    // Use the global casings generator so that the name is not
    // affected by the user's casing settings (e.g. smart-casing).
    name: CASINGS_GENERATOR.generateName(serviceName)
  };
}

// ../../cli/generation/ir-generator/lib/converters/services/convertTransport.js
async function getTransportForService({ file, serviceDeclaration, sourceResolver }) {
  if (!isRawProtobufSourceSchema(serviceDeclaration.source)) {
    return Transport.http();
  }
  return await createProtobufService(file, serviceDeclaration.source, sourceResolver, serviceDeclaration.transport?.grpc?.["service-name"]);
}
async function getTransportForEndpoint({ file, serviceTransport, endpointDeclaration, sourceResolver }) {
  const isGrpcService = serviceTransport.type === "grpc";
  const isHttpService = serviceTransport.type === "http";
  const isGrpcEndpoint = isRawProtobufSourceSchema(endpointDeclaration.source);
  const isHttpEndpoint = !isGrpcEndpoint;
  if (!isGrpcService) {
    return void 0;
  }
  if (isHttpService && isGrpcEndpoint) {
    throw new Error("Cannot have a grpc endpoint on an http service");
  }
  if (isGrpcService && isHttpEndpoint) {
    return Transport.http();
  }
  if (isGrpcService && isGrpcEndpoint) {
    const protoSource = endpointDeclaration.source;
    const serviceNameOverride = endpointDeclaration.transport?.grpc?.["service-name"];
    if (!serviceNameOverride) {
      return void 0;
    } else {
      return await createProtobufService(file, protoSource, sourceResolver, serviceNameOverride);
    }
  }
  throw new Error(`Internal error; failed to determine endpoint transport for
  ${JSON.stringify(endpointDeclaration)}"`);
}
async function createProtobufService(file, source, sourceResolver, serviceNameOverride) {
  const resolvedSource = await sourceResolver.resolveSourceOrThrow({
    source,
    relativeFilepath: file.relativeFilepath
  });
  if (resolvedSource == null || resolvedSource.type !== "protobuf") {
    throw new Error(`Expected a protobuf source for ${source.proto}.`);
  }
  const protobufService = convertProtobufService({
    source: resolvedSource,
    serviceNameOverride
  });
  if (protobufService == null) {
    throw new Error(`Failed to resolve service name from ${resolvedSource.relativeFilePath}.`);
  }
  return Transport.grpc({
    service: protobufService
  });
}

// ../../cli/generation/ir-generator/lib/converters/services/convertHttpService.js
async function convertHttpService({ rootDefaultUrl, rootPathParameters, serviceDefinition, file, errorResolver, typeResolver, propertyResolver, exampleResolver, variableResolver, sourceResolver, globalErrors, workspace }) {
  const servicePathParameters = await convertPathParameters2({
    pathParameters: serviceDefinition["path-parameters"],
    location: PathParameterLocation.Service,
    file,
    variableResolver
  });
  const transport = await getTransportForService({
    file,
    serviceDeclaration: serviceDefinition,
    sourceResolver
  });
  const serviceName = { fernFilepath: file.fernFilepath };
  const service = {
    availability: convertAvailability(serviceDefinition.availability),
    name: serviceName,
    displayName: serviceDefinition["display-name"] ?? void 0,
    basePath: constructHttpPath(serviceDefinition["base-path"]),
    headers: serviceDefinition.headers != null ? await Promise.all(Object.entries(serviceDefinition.headers).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file }))) : [],
    pathParameters: servicePathParameters,
    encoding: convertTransportToEncoding(transport, serviceDefinition),
    transport,
    endpoints: await Promise.all(Object.entries(serviceDefinition.endpoints).map(async ([endpointKey, endpoint]) => {
      const endpointPathParameters = await convertPathParameters2({
        pathParameters: getEndpointPathParameters(endpoint),
        location: PathParameterLocation.Endpoint,
        file,
        variableResolver
      });
      const httpEndpoint = {
        ...await convertDeclaration(endpoint),
        id: "",
        name: file.casingsGenerator.generateName(endpointKey),
        displayName: endpoint["display-name"],
        auth: endpoint.auth ?? serviceDefinition.auth,
        idempotent: endpoint.idempotent ?? serviceDefinition.idempotent ?? false,
        baseUrl: endpoint.url ?? serviceDefinition.url ?? rootDefaultUrl,
        method: endpoint.method != null ? convertHttpMethod(endpoint.method) : HttpMethod.Post,
        basePath: endpoint["base-path"] != null ? constructHttpPath(endpoint["base-path"]) : void 0,
        path: constructHttpPath(endpoint.path),
        fullPath: constructHttpPath(endpoint["base-path"] != null ? urlJoin(endpoint["base-path"], endpoint.path) : file.rootApiFile["base-path"] != null ? urlJoin(file.rootApiFile["base-path"], serviceDefinition["base-path"], endpoint.path) : urlJoin(serviceDefinition["base-path"], endpoint.path)),
        pathParameters: endpointPathParameters,
        allPathParameters: endpoint["base-path"] != null ? endpointPathParameters : [...rootPathParameters, ...servicePathParameters, ...endpointPathParameters],
        queryParameters: typeof endpoint.request !== "string" && endpoint.request?.["query-parameters"] != null ? await Promise.all(Object.entries(endpoint.request["query-parameters"]).map(async ([queryParameterKey, queryParameter]) => {
          return await convertQueryParameter({
            file,
            queryParameterKey,
            queryParameter
          });
        })) : [],
        headers: typeof endpoint.request !== "string" && endpoint.request?.headers != null ? await Promise.all(Object.entries(endpoint.request.headers).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file }))) : [],
        requestBody: convertHttpRequestBody({ request: endpoint.request, file }),
        sdkRequest: await convertHttpSdkRequest({
          service: serviceDefinition,
          request: endpoint.request,
          endpoint,
          endpointKey,
          file,
          typeResolver,
          propertyResolver
        }),
        response: await convertHttpResponse({ endpoint, file, typeResolver }),
        errors: [...convertResponseErrors({ errors: endpoint.errors, file }), ...globalErrors],
        userSpecifiedExamples: endpoint.examples != null ? endpoint.examples.map((example) => {
          return {
            example: convertExampleEndpointCall({
              service: serviceDefinition,
              endpoint,
              example,
              typeResolver,
              errorResolver,
              exampleResolver,
              variableResolver,
              file,
              workspace
            }),
            codeSamples: example["code-samples"]?.map((codeSample) => convertCodeSample({ codeSample, file }))
          };
        }) : [],
        autogeneratedExamples: [],
        pagination: await convertPagination({
          propertyResolver,
          file,
          endpointName: endpointKey,
          endpointSchema: endpoint
        }),
        transport: await getTransportForEndpoint({
          file,
          serviceTransport: transport,
          endpointDeclaration: endpoint,
          sourceResolver
        })
      };
      httpEndpoint.id = IdGenerator.generateEndpointId(serviceName, httpEndpoint);
      return httpEndpoint;
    }))
  };
  return service;
}
async function convertPathParameters2({ pathParameters, location, file, variableResolver }) {
  if (pathParameters == null) {
    return [];
  }
  return await Promise.all(Object.entries(pathParameters).map(([parameterName, parameter]) => convertPathParameter({
    parameterName,
    parameter,
    location,
    file,
    variableResolver
  })));
}
async function convertPathParameter({ parameterName, parameter, location, file, variableResolver }) {
  return {
    ...await convertDeclaration(parameter),
    name: file.casingsGenerator.generateName(parameterName),
    valueType: getPathParameterType({ parameter, variableResolver, file }),
    location,
    variable: isVariablePathParameter(parameter) ? variableResolver.getVariableIdOrThrow(typeof parameter === "string" ? parameter : parameter.variable) : void 0
  };
}
function getPathParameterType({ parameter, variableResolver, file }) {
  const parsed = resolvePathParameterOrThrow({
    parameter,
    variableResolver,
    file
  });
  return parsed.file.parseTypeReference(parsed.rawType);
}
function resolvePathParameterOrThrow({ parameter, variableResolver, file }) {
  const resolved = resolvePathParameter({
    parameter,
    variableResolver,
    file
  });
  if (resolved == null) {
    throw new Error("Cannot resolve path parameter");
  }
  return resolved;
}
function resolvePathParameter({ parameter, variableResolver, file }) {
  if (isVariablePathParameter(parameter)) {
    const variable = typeof parameter === "string" ? parameter : parameter.variable;
    const resolvedVariable = variableResolver.getDeclaration(variable, file);
    if (resolvedVariable == null) {
      return void 0;
    }
    const rawType = typeof resolvedVariable.declaration === "string" ? resolvedVariable.declaration : resolvedVariable.declaration.type;
    return {
      rawType,
      file: resolvedVariable.file
    };
  } else {
    return {
      file,
      rawType: typeof parameter === "string" ? parameter : parameter.type
    };
  }
}
function convertHttpMethod(method) {
  switch (method) {
    case "GET":
      return HttpMethod.Get;
    case "POST":
      return HttpMethod.Post;
    case "PUT":
      return HttpMethod.Put;
    case "PATCH":
      return HttpMethod.Patch;
    case "DELETE":
      return HttpMethod.Delete;
    default:
      assertNever(method);
  }
}
async function convertHttpHeader({ headerKey, header, file }) {
  const { name } = getHeaderName2({ headerKey, header });
  return {
    ...await convertDeclaration(header),
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: headerKey,
      name
    }),
    valueType: file.parseTypeReference(header),
    env: typeof header === "string" ? void 0 : header.env
  };
}
function getHeaderName2({ headerKey, header }) {
  if (typeof header !== "string") {
    if (header.name != null) {
      return {
        name: header.name,
        wasExplicitlySet: true
      };
    }
  }
  return {
    name: headerKey,
    wasExplicitlySet: false
  };
}
function convertTransportToEncoding(transport, service) {
  switch (transport.type) {
    case "http":
      return {
        json: {},
        proto: void 0
      };
    case "grpc":
      return {
        json: void 0,
        proto: {}
      };
    default:
      assertNever(transport);
  }
}

// ../../cli/generation/ir-generator/lib/converters/constants.js
function generateFernConstants(casingsGenerator) {
  return {
    errorInstanceIdKey: casingsGenerator.generateNameAndWireValue({
      wireValue: "errorInstanceId",
      name: "errorInstanceId"
    })
  };
}

// ../../cli/generation/ir-generator/lib/utils/isRootFernFilepath.js
function isRootFernFilepath({ fernFilePath }) {
  return fernFilePath.packagePath.length === 0 && fernFilePath.file == null;
}

// ../../cli/generation/ir-generator/lib/converters/convertOAuthRefreshEndpoint.js
async function convertOAuthRefreshEndpoint({ endpointResolver, propertyResolver, file, refreshTokenEndpoint }) {
  const resolvedEndpoint = await endpointResolver.resolveEndpointOrThrow({
    endpoint: refreshTokenEndpoint.endpoint,
    file
  });
  return {
    endpointReference: {
      endpointId: IdGenerator.generateEndpointIdFromResolvedEndpoint(resolvedEndpoint),
      serviceId: IdGenerator.generateServiceIdFromFernFilepath(resolvedEndpoint.file.fernFilepath),
      subpackageId: !isRootFernFilepath({ fernFilePath: resolvedEndpoint.file.fernFilepath }) ? IdGenerator.generateSubpackageId(resolvedEndpoint.file.fernFilepath) : void 0
    },
    requestProperties: {
      refreshToken: await propertyResolver.resolveRequestPropertyOrThrow({
        file,
        endpoint: refreshTokenEndpoint.endpoint,
        propertyComponents: refreshTokenEndpoint.requestProperties.refresh_token
      })
    },
    responseProperties: {
      accessToken: await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: refreshTokenEndpoint.endpoint,
        propertyComponents: refreshTokenEndpoint.responseProperties.access_token
      }),
      expiresIn: refreshTokenEndpoint.responseProperties.expires_in != null ? await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: refreshTokenEndpoint.endpoint,
        propertyComponents: refreshTokenEndpoint.responseProperties.expires_in
      }) : void 0,
      refreshToken: refreshTokenEndpoint.responseProperties.refresh_token != null ? await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: refreshTokenEndpoint.endpoint,
        propertyComponents: refreshTokenEndpoint.responseProperties.refresh_token
      }) : void 0
    }
  };
}

// ../../cli/generation/ir-generator/lib/converters/convertOAuthTokenEndpoint.js
async function convertOAuthTokenEndpoint({ endpointResolver, propertyResolver, file, tokenEndpoint }) {
  const resolvedEndpoint = await endpointResolver.resolveEndpointOrThrow({
    endpoint: tokenEndpoint.endpoint,
    file
  });
  return {
    endpointReference: {
      endpointId: IdGenerator.generateEndpointIdFromResolvedEndpoint(resolvedEndpoint),
      serviceId: IdGenerator.generateServiceIdFromFernFilepath(resolvedEndpoint.file.fernFilepath),
      subpackageId: !isRootFernFilepath({ fernFilePath: resolvedEndpoint.file.fernFilepath }) ? IdGenerator.generateSubpackageId(resolvedEndpoint.file.fernFilepath) : void 0
    },
    requestProperties: {
      clientId: await propertyResolver.resolveRequestPropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.requestProperties.client_id
      }),
      clientSecret: await propertyResolver.resolveRequestPropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.requestProperties.client_secret
      }),
      scopes: tokenEndpoint.requestProperties.scopes != null ? await propertyResolver.resolveRequestPropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.requestProperties.scopes
      }) : void 0
    },
    responseProperties: {
      accessToken: await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.responseProperties.access_token
      }),
      expiresIn: tokenEndpoint.responseProperties.expires_in != null ? await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.responseProperties.expires_in
      }) : void 0,
      refreshToken: tokenEndpoint.responseProperties.refresh_token != null ? await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.responseProperties.refresh_token
      }) : void 0
    }
  };
}

// ../../cli/generation/ir-generator/lib/converters/convertOAuthClientCredentials.js
async function convertOAuthClientCredentials({ propertyResolver, endpointResolver, file, oauthScheme, tokenEndpoint, refreshTokenEndpoint }) {
  const oauthTokenEndpoint = await convertOAuthTokenEndpoint({
    propertyResolver,
    endpointResolver,
    file,
    tokenEndpoint
  });
  if (oauthTokenEndpoint == null) {
    throw new Error("Failed to convert OAuth token endpoint.");
  }
  const refreshEndpoint = refreshTokenEndpoint != null ? await convertOAuthRefreshEndpoint({
    propertyResolver,
    endpointResolver,
    file,
    refreshTokenEndpoint
  }) : void 0;
  return {
    clientIdEnvVar: oauthScheme["client-id-env"],
    clientSecretEnvVar: oauthScheme["client-secret-env"],
    tokenPrefix: oauthScheme["token-prefix"],
    tokenHeader: oauthScheme["token-header"],
    scopes: oauthScheme.scopes,
    tokenEndpoint: oauthTokenEndpoint,
    refreshEndpoint
  };
}

// ../../cli/generation/ir-generator/lib/converters/convertOAuthUtils.js
var DEFAULT_TOKEN_ENDPOINT = {
  requestProperties: {
    type: "access_token",
    client_id: ["client_id"],
    client_secret: ["client_secret"],
    scopes: void 0
  },
  responseProperties: {
    type: "access_token",
    access_token: ["access_token"],
    expires_in: void 0,
    refresh_token: void 0
  }
};
var DEFAULT_REFRESH_TOKEN_ENDPOINT = {
  requestProperties: {
    type: "refresh_token",
    refresh_token: ["refresh_token"]
  },
  responseProperties: {
    type: "access_token",
    access_token: ["access_token"],
    refresh_token: void 0,
    expires_in: void 0
  }
};
function getTokenEndpoint(oauthSchema) {
  return {
    endpoint: oauthSchema["get-token"].endpoint,
    requestProperties: getTokenEndpointRequestProperties({
      requestProperties: oauthSchema["get-token"]?.["request-properties"]
    }),
    responseProperties: getTokenEndpointResponseProperties({
      responseProperties: oauthSchema["get-token"]?.["response-properties"]
    })
  };
}
function getRefreshTokenEndpoint(oauthSchema) {
  if (oauthSchema["refresh-token"] == null) {
    return void 0;
  }
  return {
    endpoint: oauthSchema["refresh-token"].endpoint,
    requestProperties: getRefreshTokenEndpointRequestProperties({
      requestProperties: oauthSchema["refresh-token"]?.["request-properties"]
    }),
    responseProperties: getRefreshTokenEndpointResponseProperties({
      responseProperties: oauthSchema["refresh-token"]?.["response-properties"]
    })
  };
}
function getTokenEndpointRequestProperties({ requestProperties }) {
  if (requestProperties == null) {
    return DEFAULT_TOKEN_ENDPOINT.requestProperties;
  }
  const maybeClientId = requestProperties["client-id"];
  const maybeClientSecret = requestProperties["client-secret"];
  const maybeScopes = requestProperties.scopes;
  return {
    type: "access_token",
    client_id: maybeClientId != null ? getRequestPropertyComponents(maybeClientId) : DEFAULT_TOKEN_ENDPOINT.requestProperties.client_id,
    client_secret: maybeClientSecret != null ? getRequestPropertyComponents(maybeClientSecret) : DEFAULT_TOKEN_ENDPOINT.requestProperties.client_secret,
    scopes: maybeScopes != null ? getRequestPropertyComponents(maybeScopes) : DEFAULT_TOKEN_ENDPOINT.requestProperties.scopes
  };
}
function getTokenEndpointResponseProperties({ responseProperties }) {
  return getTokenEndpointResponsePropertiesWithDefault({
    responseProperties,
    defaultValue: DEFAULT_TOKEN_ENDPOINT.responseProperties
  });
}
function getRefreshTokenEndpointRequestProperties({ requestProperties }) {
  if (requestProperties == null) {
    return DEFAULT_REFRESH_TOKEN_ENDPOINT.requestProperties;
  }
  const maybeRefreshToken = requestProperties["refresh-token"];
  return {
    type: "refresh_token",
    refresh_token: maybeRefreshToken != null ? getRequestPropertyComponents(maybeRefreshToken) : DEFAULT_REFRESH_TOKEN_ENDPOINT.requestProperties.refresh_token
  };
}
function getRefreshTokenEndpointResponseProperties({ responseProperties }) {
  return getTokenEndpointResponsePropertiesWithDefault({
    responseProperties,
    defaultValue: DEFAULT_REFRESH_TOKEN_ENDPOINT.responseProperties
  });
}
function getTokenEndpointResponsePropertiesWithDefault({ responseProperties, defaultValue }) {
  if (responseProperties == null) {
    return defaultValue;
  }
  const maybeAccessToken = responseProperties["access-token"];
  const maybeExpiresIn = responseProperties["expires-in"];
  const maybeRefreshToken = responseProperties["refresh-token"];
  return {
    type: "access_token",
    access_token: maybeAccessToken != null ? getResponsePropertyComponents(maybeAccessToken) : defaultValue.access_token,
    expires_in: maybeExpiresIn != null ? getResponsePropertyComponents(maybeExpiresIn) : defaultValue.expires_in,
    refresh_token: maybeRefreshToken != null ? getResponsePropertyComponents(maybeRefreshToken) : defaultValue.refresh_token
  };
}

// ../../cli/generation/ir-generator/lib/converters/convertApiAuth.js
async function convertApiAuth({ rawApiFileSchema, file, propertyResolver, endpointResolver }) {
  if (rawApiFileSchema.auth == null) {
    return {
      docs: void 0,
      requirement: AuthSchemesRequirement.All,
      schemes: []
    };
  }
  const docs = typeof rawApiFileSchema.auth !== "string" ? rawApiFileSchema.auth.docs : void 0;
  return visitRawApiAuth(rawApiFileSchema.auth, {
    single: async (authScheme) => {
      const schemaReference = await convertSchemeReference({
        reference: authScheme,
        authSchemeDeclarations: rawApiFileSchema["auth-schemes"],
        file,
        propertyResolver,
        endpointResolver
      });
      return {
        docs,
        requirement: AuthSchemesRequirement.All,
        schemes: [schemaReference]
      };
    },
    any: async ({ any: any3 }) => ({
      docs,
      requirement: AuthSchemesRequirement.Any,
      schemes: await Promise.all(any3.map(async (schemeReference) => await convertSchemeReference({
        reference: schemeReference,
        authSchemeDeclarations: rawApiFileSchema["auth-schemes"],
        file,
        propertyResolver,
        endpointResolver
      })))
    })
  });
}
async function convertSchemeReference({ reference, authSchemeDeclarations, file, propertyResolver, endpointResolver }) {
  const convertNamedAuthSchemeReference = (reference2, docs) => {
    const declaration = authSchemeDeclarations?.[reference2];
    if (declaration == null) {
      throw new Error("Unknown auth scheme: " + reference2);
    }
    return visitRawAuthSchemeDeclaration(declaration, {
      header: async (rawHeader) => AuthScheme.header({
        docs,
        name: file.casingsGenerator.generateNameAndWireValue({
          name: rawHeader.name ?? reference2,
          wireValue: rawHeader.header
        }),
        valueType: file.parseTypeReference(rawHeader.type ?? "string"),
        prefix: rawHeader.prefix,
        headerEnvVar: rawHeader.env
      }),
      basic: async (rawScheme) => generateBasicAuth({
        file,
        docs,
        rawScheme
      }),
      bearer: async (rawScheme) => generateBearerAuth({
        file,
        docs,
        rawScheme
      }),
      oauth: async (rawScheme) => await generateOAuth({
        file,
        docs,
        rawScheme,
        propertyResolver,
        endpointResolver
      })
    });
  };
  const scheme = typeof reference === "string" ? reference : reference.scheme;
  switch (scheme) {
    case "bearer":
      return generateBearerAuth({
        file,
        docs: void 0,
        rawScheme: void 0
      });
    case "basic":
      return generateBasicAuth({
        file,
        docs: void 0,
        rawScheme: void 0
      });
    case "oauth":
      return await generateOAuth({
        file,
        docs: void 0,
        rawScheme: void 0,
        propertyResolver,
        endpointResolver
      });
    default:
      return convertNamedAuthSchemeReference(scheme, typeof reference !== "string" ? reference.docs : void 0);
  }
}
function generateBearerAuth({ file, docs, rawScheme }) {
  return AuthScheme.bearer({
    docs,
    token: file.casingsGenerator.generateName(rawScheme?.token?.name ?? "token"),
    tokenEnvVar: rawScheme?.token?.env
  });
}
function generateBasicAuth({ file, docs, rawScheme }) {
  return AuthScheme.basic({
    docs,
    username: file.casingsGenerator.generateName(rawScheme?.username?.name ?? "username"),
    usernameEnvVar: rawScheme?.username?.env,
    password: file.casingsGenerator.generateName(rawScheme?.password?.name ?? "password"),
    passwordEnvVar: rawScheme?.password?.env
  });
}
async function generateOAuth({ file, docs, rawScheme, propertyResolver, endpointResolver }) {
  switch (rawScheme?.type) {
    case "client-credentials":
      return AuthScheme.oauth({
        docs,
        configuration: OAuthConfiguration.clientCredentials(await convertOAuthClientCredentials({
          propertyResolver,
          endpointResolver,
          file,
          oauthScheme: rawScheme,
          tokenEndpoint: getTokenEndpoint(rawScheme),
          refreshTokenEndpoint: getRefreshTokenEndpoint(rawScheme)
        }))
      });
    default:
      throw new Error(`Unknown OAuth type: '${rawScheme?.type}'`);
  }
}

// ../../cli/generation/ir-generator/lib/converters/convertApiVersionScheme.js
async function convertApiVersionScheme({ file, rawApiFileSchema }) {
  if (rawApiFileSchema.version == null) {
    return void 0;
  }
  return ApiVersionScheme.header({
    header: await convertHeader({
      file,
      header: rawApiFileSchema.version.header
    }),
    value: await convertEnum2({
      file,
      versionDeclaration: rawApiFileSchema.version
    })
  });
}
async function convertHeader({ file, header }) {
  if (typeof header === "string") {
    return await convertHttpHeader({
      file,
      headerKey: header,
      header: {
        type: "string"
      }
    });
  }
  return await convertHttpHeader({
    file,
    headerKey: header.value,
    header: {
      type: "string",
      name: header.name,
      env: header.env
    }
  });
}
async function convertEnum2({ file, versionDeclaration }) {
  return await convertEnumTypeDeclaration({
    _enum: {
      default: versionDeclaration.default,
      enum: versionDeclaration.values
    },
    file
  });
}

// ../../cli/generation/ir-generator/lib/converters/convertChannel.js
async function convertChannel({ channel, typeResolver, exampleResolver, variableResolver, file, workspace }) {
  const messages = [];
  for (const [messageId, message] of Object.entries(channel.messages ?? {})) {
    messages.push({
      type: messageId,
      availability: convertAvailability(message.availability),
      docs: message.docs,
      origin: message.origin,
      body: convertMessageSchema({ body: message.body, file }),
      displayName: message["display-name"]
    });
  }
  return {
    availability: convertAvailability(channel.availability),
    path: constructHttpPath(channel.path),
    auth: channel.auth,
    // since there's only 1 channel per file, we can use the file name as the channel's name
    name: file.fernFilepath.file ?? file.casingsGenerator.generateName(channel["display-name"] ?? channel.path),
    displayName: channel["display-name"],
    headers: channel.headers != null ? await Promise.all(Object.entries(channel.headers).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file }))) : [],
    docs: channel.docs,
    pathParameters: channel["path-parameters"] != null ? await convertPathParameters2({
      pathParameters: channel["path-parameters"],
      location: PathParameterLocation.Endpoint,
      file,
      variableResolver
    }) : [],
    queryParameters: channel["query-parameters"] != null ? await Promise.all(Object.entries(channel["query-parameters"]).map(async ([queryParameterKey, queryParameter]) => {
      const { name } = getQueryParameterName({ queryParameterKey, queryParameter });
      const valueType = file.parseTypeReference(queryParameter);
      return {
        ...await convertDeclaration(queryParameter),
        name: file.casingsGenerator.generateNameAndWireValue({
          wireValue: queryParameterKey,
          name
        }),
        valueType,
        allowMultiple: typeof queryParameter !== "string" && queryParameter["allow-multiple"] != null ? queryParameter["allow-multiple"] : false
      };
    })) : [],
    messages: Object.values(messages),
    examples: (channel.examples ?? []).map((example) => {
      const convertedPathParameters = convertChannelPathParameters({
        channel,
        example,
        typeResolver,
        exampleResolver,
        variableResolver,
        file,
        workspace
      });
      return {
        name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
        docs: example.docs,
        url: buildUrl2({ channel, example, pathParams: convertedPathParameters }),
        ...convertedPathParameters,
        ...convertHeaders2({ channel, example, typeResolver, exampleResolver, file, workspace }),
        queryParameters: example["query-parameters"] != null ? Object.entries(example["query-parameters"]).map(([wireKey, value]) => {
          const queryParameterDeclaration = channel["query-parameters"]?.[wireKey];
          if (queryParameterDeclaration == null) {
            throw new Error(`Query parameter ${wireKey} does not exist`);
          }
          return {
            name: file.casingsGenerator.generateNameAndWireValue({
              name: getQueryParameterName({
                queryParameterKey: wireKey,
                queryParameter: queryParameterDeclaration
              }).name,
              wireValue: wireKey
            }),
            value: convertTypeReferenceExample({
              example: value,
              rawTypeBeingExemplified: typeof queryParameterDeclaration === "string" ? queryParameterDeclaration : queryParameterDeclaration.type,
              typeResolver,
              exampleResolver,
              fileContainingRawTypeReference: file,
              fileContainingExample: file,
              workspace
            }),
            shape: getQueryParamaterDeclationShape2({ queryParameter: queryParameterDeclaration })
          };
        }) : [],
        messages: example.messages.map((messageExample) => {
          const message = channel.messages?.[messageExample.type];
          if (message == null) {
            throw new Error(`Message ${messageExample.type} does not exist`);
          }
          return {
            type: messageExample.type,
            body: convertExampleWebSocketMessageBody({
              message,
              example: messageExample.body,
              typeResolver,
              exampleResolver,
              file,
              workspace
            })
          };
        })
      };
    })
  };
}
function getQueryParamaterDeclationShape2({ queryParameter }) {
  const isAllowMultiple = typeof queryParameter !== "string" && queryParameter["allow-multiple"] != null ? queryParameter["allow-multiple"] : false;
  return isAllowMultiple ? ExampleQueryParameterShape.exploded() : ExampleQueryParameterShape.single();
}
function convertExampleWebSocketMessageBody({ message, example, typeResolver, exampleResolver, file, workspace }) {
  if (!isInlineMessageBody(message.body)) {
    return ExampleWebSocketMessageBody.reference(convertTypeReferenceExample({
      example,
      rawTypeBeingExemplified: typeof message.body !== "string" ? message.body.type : message.body,
      typeResolver,
      exampleResolver,
      fileContainingRawTypeReference: file,
      fileContainingExample: file,
      workspace
    }));
  }
  if (!isPlainObject2(example)) {
    throw new Error("Example must be an object");
  }
  const exampleProperties = [];
  for (const [wireKey, propertyExample] of Object.entries(example)) {
    const inlinedRequestPropertyDeclaration = message.body.properties?.[wireKey];
    if (inlinedRequestPropertyDeclaration != null) {
      exampleProperties.push({
        name: file.casingsGenerator.generateNameAndWireValue({
          name: getPropertyName({ propertyKey: wireKey, property: inlinedRequestPropertyDeclaration }).name,
          wireValue: wireKey
        }),
        value: convertTypeReferenceExample({
          example: propertyExample,
          rawTypeBeingExemplified: typeof inlinedRequestPropertyDeclaration !== "string" ? inlinedRequestPropertyDeclaration.type : inlinedRequestPropertyDeclaration,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          workspace
        }),
        originalTypeDeclaration: void 0
      });
    } else {
      const originalTypeDeclaration = getOriginalTypeDeclarationForPropertyFromExtensions({
        extends_: message.body.extends,
        wirePropertyKey: wireKey,
        typeResolver,
        file
      });
      if (originalTypeDeclaration == null) {
        throw new Error("Could not find original type declaration for property: " + wireKey);
      }
      exampleProperties.push({
        name: file.casingsGenerator.generateNameAndWireValue({
          name: getPropertyName({ propertyKey: wireKey, property: originalTypeDeclaration.rawPropertyType }).name,
          wireValue: wireKey
        }),
        value: convertTypeReferenceExample({
          example: propertyExample,
          rawTypeBeingExemplified: typeof originalTypeDeclaration.rawPropertyType === "string" ? originalTypeDeclaration.rawPropertyType : originalTypeDeclaration.rawPropertyType.type,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: originalTypeDeclaration.file,
          fileContainingExample: file,
          workspace
        }),
        originalTypeDeclaration: originalTypeDeclaration.typeName
      });
    }
  }
  return ExampleWebSocketMessageBody.inlinedBody({
    jsonExample: exampleResolver.resolveAllReferencesInExampleOrThrow({ example, file }).resolvedExample,
    properties: exampleProperties
  });
}
function convertMessageSchema({ body, file }) {
  if (typeof body === "string") {
    return WebSocketMessageBody.reference({
      docs: void 0,
      bodyType: file.parseTypeReference(body)
    });
  } else if (isReferencedWebhookPayloadSchema(body)) {
    return WebSocketMessageBody.reference({
      docs: void 0,
      bodyType: file.parseTypeReference(body.type)
    });
  } else {
    return WebSocketMessageBody.inlinedBody({
      name: file.casingsGenerator.generateName(body.name),
      extends: getExtensionsAsList(body.extends ?? []).map((extended) => parseTypeName({ typeName: extended, file })),
      properties: []
    });
  }
}
function isReferencedWebhookPayloadSchema(payload) {
  return payload.type != null;
}
function convertChannelPathParameters({ channel, example, typeResolver, exampleResolver, variableResolver, file, workspace }) {
  const pathParameters = [];
  const buildExamplePathParameter = ({ name, pathParameterDeclaration, examplePathParameter }) => {
    const resolvedPathParameter = resolvePathParameterOrThrow({
      parameter: pathParameterDeclaration,
      variableResolver,
      file
    });
    return {
      name,
      value: convertTypeReferenceExample({
        example: examplePathParameter,
        rawTypeBeingExemplified: resolvedPathParameter.rawType,
        typeResolver,
        exampleResolver,
        fileContainingRawTypeReference: resolvedPathParameter.file,
        fileContainingExample: file,
        workspace
      })
    };
  };
  if (example["path-parameters"] != null) {
    const rawEndpointPathParameters = getEndpointPathParameters(channel);
    for (const [key, examplePathParameter] of Object.entries(example["path-parameters"])) {
      const pathParameterDeclaration = rawEndpointPathParameters[key];
      if (pathParameterDeclaration != null) {
        pathParameters.push(buildExamplePathParameter({
          name: file.casingsGenerator.generateName(key),
          pathParameterDeclaration,
          examplePathParameter
        }));
      } else {
        throw new Error(`Path parameter ${key} does not exist`);
      }
    }
  }
  return { pathParameters };
}
function convertHeaders2({ channel, example, typeResolver, exampleResolver, file, workspace }) {
  const headers = [];
  if (example.headers != null) {
    for (const [wireKey, exampleHeader] of Object.entries(example.headers)) {
      const headerDeclaration = channel.headers?.[wireKey];
      if (headerDeclaration != null) {
        headers.push({
          name: file.casingsGenerator.generateNameAndWireValue({
            name: getHeaderName2({ headerKey: wireKey, header: headerDeclaration }).name,
            wireValue: wireKey
          }),
          value: convertTypeReferenceExample({
            example: exampleHeader,
            rawTypeBeingExemplified: typeof headerDeclaration === "string" ? headerDeclaration : headerDeclaration.type,
            typeResolver,
            exampleResolver,
            fileContainingRawTypeReference: file,
            fileContainingExample: file,
            workspace
          })
        });
      } else {
        throw new Error(`Heder ${wireKey} does not exist`);
      }
    }
  }
  return { headers };
}
function buildUrl2({ channel, example, pathParams }) {
  let url = channel.path;
  if (example["path-parameters"] != null) {
    for (const parameter of [...pathParams.pathParameters]) {
      url = url.replaceAll(`{${parameter.name.originalName}}`, `${parameter.value.jsonExample}`);
    }
  }
  return url;
}
function isInlineMessageBody(messageBody) {
  if (typeof messageBody === "string") {
    return false;
  }
  return messageBody.extends != null || messageBody.properties != null;
}

// ../../cli/generation/ir-generator/lib/converters/convertEnvironments.js
function convertEnvironments({ rawApiFileSchema: { "default-environment": defaultEnvironment, environments }, casingsGenerator }) {
  if (environments == null) {
    return void 0;
  }
  const firstEnvironment = Object.values(environments)[0];
  if (firstEnvironment == null) {
    return void 0;
  }
  return {
    defaultEnvironment: defaultEnvironment ?? void 0,
    environments: visitRawEnvironmentDeclaration(firstEnvironment, {
      singleBaseUrl: () => Environments.singleBaseUrl(convertSingleBaseUrlEnvironments({ environments, casingsGenerator })),
      multipleBaseUrls: (firstMultipleBaseUrlsEnvironment) => Environments.multipleBaseUrls(convertMultipleBaseUrlEnvironments({
        baseUrls: Object.keys(firstMultipleBaseUrlsEnvironment.urls),
        environments,
        casingsGenerator
      }))
    })
  };
}
function convertSingleBaseUrlEnvironments({ environments, casingsGenerator }) {
  return {
    environments: Object.entries(environments).map(([environmentName, rawEnvironment]) => visitRawEnvironmentDeclaration(rawEnvironment, {
      singleBaseUrl: (singleBaseUrlEnvironment) => ({
        docs: typeof singleBaseUrlEnvironment === "string" ? void 0 : singleBaseUrlEnvironment.docs,
        id: environmentName,
        name: casingsGenerator.generateName(environmentName),
        url: removeTrailingSlash(typeof singleBaseUrlEnvironment === "string" ? singleBaseUrlEnvironment : singleBaseUrlEnvironment.url)
      }),
      multipleBaseUrls: () => {
        throw new Error(`Environment ${environmentName} has multiple base URLs`);
      }
    }))
  };
}
function convertMultipleBaseUrlEnvironments({ baseUrls, environments, casingsGenerator }) {
  return {
    baseUrls: baseUrls.map((baseUrl) => ({
      id: baseUrl,
      name: casingsGenerator.generateName(baseUrl)
    })),
    environments: Object.entries(environments).map(([environmentName, rawEnvironment]) => visitRawEnvironmentDeclaration(rawEnvironment, {
      multipleBaseUrls: (multipleBaseUrlsEnvironment) => ({
        docs: multipleBaseUrlsEnvironment.docs,
        id: environmentName,
        name: casingsGenerator.generateName(environmentName),
        urls: mapValues_default(multipleBaseUrlsEnvironment.urls, (url) => removeTrailingSlash(url))
      }),
      singleBaseUrl: () => {
        throw new Error(`Environment ${environmentName} does not have multiple base URLs`);
      }
    }))
  };
}
function removeTrailingSlash(url) {
  return url.endsWith("/") ? url.slice(0, -1) : url;
}

// ../../cli/generation/ir-generator/lib/converters/convertErrorDeclaration.js
function convertErrorDeclaration({ errorName, errorDeclaration, file, typeResolver, exampleResolver, workspace }) {
  const examples = [];
  if (errorDeclaration.type != null && errorDeclaration.examples != null) {
    for (const example of errorDeclaration.examples) {
      examples.push({
        name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
        docs: example.docs,
        jsonExample: exampleResolver.resolveAllReferencesInExampleOrThrow({
          example: example.value,
          file
        }).resolvedExample,
        shape: convertTypeReferenceExample({
          example: example.value,
          rawTypeBeingExemplified: errorDeclaration.type,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          typeResolver,
          exampleResolver,
          workspace
        })
      });
    }
  }
  return {
    name: parseErrorName({
      errorName,
      file
    }),
    discriminantValue: file.casingsGenerator.generateNameAndWireValue({
      wireValue: errorName,
      name: errorName
    }),
    docs: typeof errorDeclaration !== "string" ? errorDeclaration.docs : void 0,
    statusCode: errorDeclaration["status-code"],
    type: errorDeclaration.type != null ? file.parseTypeReference(errorDeclaration.type) : void 0,
    examples
  };
}

// ../../cli/generation/ir-generator/lib/converters/convertErrorDiscriminationStrategy.js
var ERROR_CONTENT_PROPERTY_NAME = "content";
function convertErrorDiscriminationStrategy(rawStrategy, file) {
  if (rawStrategy == null || rawStrategy.strategy === "status-code") {
    return ErrorDiscriminationStrategy.statusCode();
  }
  switch (rawStrategy.strategy) {
    case "property":
      return ErrorDiscriminationStrategy.property({
        discriminant: file.casingsGenerator.generateNameAndWireValue({
          name: rawStrategy["property-name"],
          wireValue: rawStrategy["property-name"]
        }),
        contentProperty: file.casingsGenerator.generateNameAndWireValue({
          name: ERROR_CONTENT_PROPERTY_NAME,
          wireValue: ERROR_CONTENT_PROPERTY_NAME
        })
      });
    default:
      assertNever(rawStrategy);
  }
}

// ../../cli/generation/ir-generator/lib/converters/convertReadmeConfig.js
function convertReadmeConfig({ readme, services }) {
  const readmeEndpointCache = new ReadmeEndpointCache(services);
  return {
    apiReferenceLink: readme.apiReferenceLink,
    bannerLink: readme.bannerLink,
    introduction: readme.introduction,
    defaultEndpoint: readme.defaultEndpoint != null ? readmeEndpointCache.getEndpointForReadmeOrThrow(readme.defaultEndpoint).id : void 0,
    features: readme.features != null ? Object.fromEntries(Object.entries(readme.features).map(([featureId, endpoints]) => {
      return [
        featureId,
        endpoints.map((endpoint) => readmeEndpointCache.getEndpointForReadmeOrThrow(endpoint).id)
      ];
    })) : void 0
  };
}
var ReadmeEndpointCache = class {
  endpoints = {};
  constructor(services) {
    this.endpoints = this.buildEndpoints(services);
  }
  getEndpointForReadme(readmeEndpoint) {
    const readmeEndpointObject = getReadmeEndpointObject({ endpoint: readmeEndpoint });
    const endpointKey = this.getEndpointKeyForReadmeEndpoint(readmeEndpointObject);
    return this.endpoints[endpointKey];
  }
  getEndpointForReadmeOrThrow(readmeEndpoint) {
    const endpoint = this.getEndpointForReadme(readmeEndpoint);
    if (endpoint == null) {
      throw new Error(`Endpoint not found for ${JSON.stringify(readmeEndpoint)}`);
    }
    return endpoint;
  }
  buildEndpoints(services) {
    const endpoints = {};
    for (const service of Object.values(services)) {
      for (const endpoint of service.endpoints) {
        endpoints[this.getEndpointKeyForHttpEndpoint(endpoint)] = endpoint;
      }
    }
    return endpoints;
  }
  getEndpointKeyForReadmeEndpoint(endpoint) {
    return this.getEndpointKey({
      method: endpoint.method,
      path: endpoint.path,
      stream: endpoint.stream ?? false
    });
  }
  getEndpointKeyForHttpEndpoint(endpoint) {
    return this.getEndpointKey({
      method: endpoint.method,
      path: getFullPathForEndpoint(endpoint),
      stream: endpoint.response?.body?.type === "streaming"
    });
  }
  getEndpointKey({ method, path: path5, stream }) {
    return `${method}|${path5}|${stream}`;
  }
};
function getFullPathForEndpoint(endpoint) {
  let url = "";
  if (endpoint.fullPath.head.length > 0) {
    url = urlJoin(url, endpoint.fullPath.head);
  }
  for (const part of endpoint.fullPath.parts) {
    url = urlJoin(url, "{" + part.pathParameter + "}");
    if (part.tail.length > 0) {
      url = urlJoin(url, part.tail);
    }
  }
  return url.startsWith("/") ? url : `/${url}`;
}
function getReadmeEndpointObject({ endpoint }) {
  if (typeof endpoint === "string") {
    const split = endpoint.split(" ");
    if (split.length !== 2 || split[0] == null || split[1] == null) {
      throw new Error(`invalid endpoint string: ${endpoint}`);
    }
    return {
      method: split[0],
      path: split[1]
    };
  }
  return endpoint;
}

// ../../cli/generation/ir-generator/lib/converters/convertWebhookGroup.js
async function convertWebhookGroup({ webhooks, file, typeResolver, exampleResolver, workspace }) {
  const webhookGroup = [];
  for (const [webhookId, webhook] of Object.entries(webhooks)) {
    webhookGroup.push({
      id: IdGenerator.generateWebhookId(file.fernFilepath, webhookId),
      availability: convertAvailability(webhook.availability),
      displayName: webhook["display-name"],
      docs: webhook.docs,
      method: webhook.method,
      name: file.casingsGenerator.generateName(webhookId),
      headers: webhook.headers != null ? await Promise.all(Object.entries(webhook.headers).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file }))) : [],
      payload: convertWebhookPayloadSchema({ payload: webhook.payload, file }),
      examples: webhook.examples != null ? convertWebhookExamples2({
        webhook,
        examples: webhook.examples,
        file,
        typeResolver,
        exampleResolver,
        workspace
      }) : void 0
    });
  }
  return webhookGroup;
}
function convertWebhookPayloadSchema({ payload, file }) {
  if (typeof payload === "string") {
    return WebhookPayload.reference({
      docs: void 0,
      payloadType: file.parseTypeReference(payload)
    });
  } else if (isReferencedWebhookPayloadSchema2(payload)) {
    return WebhookPayload.reference({
      docs: void 0,
      payloadType: file.parseTypeReference(payload.type)
    });
  } else {
    return WebhookPayload.inlinedPayload({
      name: file.casingsGenerator.generateName(payload.name),
      extends: getExtensionsAsList(payload.extends).map((extended) => parseTypeName({ typeName: extended, file })),
      properties: payload.properties != null ? Object.entries(payload.properties).map(([propertyKey, propertyDefinition]) => convertInlinedRequestProperty2({
        propertyKey,
        propertyDefinition,
        docs: typeof propertyDefinition !== "string" ? propertyDefinition.docs : void 0,
        availability: typeof propertyDefinition !== "string" ? convertAvailability(propertyDefinition.availability) : void 0,
        file
      })) : []
    });
  }
}
function convertInlinedRequestProperty2({ propertyKey, propertyDefinition, docs, availability, file }) {
  return {
    docs,
    availability,
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: propertyKey,
      name: getPropertyName({ propertyKey, property: propertyDefinition }).name
    }),
    valueType: file.parseTypeReference(propertyDefinition)
  };
}
function convertWebhookExamples2({ webhook, examples, file, typeResolver, exampleResolver, workspace }) {
  const typeName = typeof webhook.payload === "string" ? webhook.payload : isReferencedWebhookPayloadSchema2(webhook.payload) ? webhook.payload.type : void 0;
  if (typeName != null) {
    return examples.map((example) => ({
      docs: webhook.docs,
      name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
      payload: convertTypeReferenceExample({
        example: example.payload,
        rawTypeBeingExemplified: typeName,
        fileContainingRawTypeReference: file,
        fileContainingExample: file,
        typeResolver,
        exampleResolver,
        workspace
      })
    }));
  }
  if (!isPlainObject2(webhook.payload)) {
    throw new Error(`Example webhook payload is not an object. Got: ${JSON.stringify(webhook.payload)}`);
  }
  return examples.map((example) => ({
    docs: webhook.docs,
    name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
    payload: convertTypeReferenceExample({
      example: example.payload,
      rawTypeBeingExemplified: "map<string, unknown>",
      fileContainingRawTypeReference: file,
      fileContainingExample: file,
      typeResolver,
      exampleResolver,
      workspace
    })
  }));
}
function isReferencedWebhookPayloadSchema2(payload) {
  return payload.type != null;
}

// ../../cli/generation/ir-generator/lib/utils/getPropertiesByAudience.js
function getPropertiesByAudience(properties) {
  const propertiesByAudience = {};
  for (const [property4, propertyDeclaration] of Object.entries(properties)) {
    if (typeof propertyDeclaration === "string") {
      continue;
    }
    for (const audience of propertyDeclaration.audiences ?? []) {
      if (propertiesByAudience[audience] == null) {
        propertiesByAudience[audience] = /* @__PURE__ */ new Set();
      }
      propertiesByAudience[audience]?.add(property4);
    }
  }
  return propertiesByAudience;
}

// ../../cli/generation/ir-generator/lib/converters/convertProtobufType.js
function convertSourceToProtobufType({ name, source }) {
  return ProtobufType.userDefined({
    file: convertProtobufFile({ source }),
    // Use the global casings generator so that the name is not
    // affected by the user's casing settings (e.g. smart-casing).
    name: CASINGS_GENERATOR.generateName(name)
  });
}
function maybeConvertEncodingToProtobufType({ encoding }) {
  if (encoding.proto != null && encoding.proto.type != null) {
    const wellKnownType = maybeConvertWellKnownProtobufType({ type: encoding.proto.type });
    if (wellKnownType != null) {
      return wellKnownType;
    }
  }
  return void 0;
}
function maybeConvertWellKnownProtobufType({ type: type2 }) {
  switch (type2) {
    case "google.protobuf.Any":
      return ProtobufType.wellKnown(WellKnownProtobufType.any());
    case "google.protobuf.Api":
      return ProtobufType.wellKnown(WellKnownProtobufType.api());
    case "google.protobuf.BoolValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.boolValue());
    case "google.protobuf.BytesValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.bytesValue());
    case "google.protobuf.DoubleValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.doubleValue());
    case "google.protobuf.Duration":
      return ProtobufType.wellKnown(WellKnownProtobufType.duration());
    case "google.protobuf.Empty":
      return ProtobufType.wellKnown(WellKnownProtobufType.empty());
    case "google.protobuf.Enum":
      return ProtobufType.wellKnown(WellKnownProtobufType.enum());
    case "google.protobuf.EnumValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.enumValue());
    case "google.protobuf.Field":
      return ProtobufType.wellKnown(WellKnownProtobufType.field());
    case "google.protobuf.FieldCardinality":
      return ProtobufType.wellKnown(WellKnownProtobufType.fieldCardinality());
    case "google.protobuf.FieldKind":
      return ProtobufType.wellKnown(WellKnownProtobufType.fieldKind());
    case "google.protobuf.FieldMask":
      return ProtobufType.wellKnown(WellKnownProtobufType.fieldMask());
    case "google.protobuf.FloatVlaue":
      return ProtobufType.wellKnown(WellKnownProtobufType.floatValue());
    case "google.protobuf.Int32Value":
      return ProtobufType.wellKnown(WellKnownProtobufType.int32Value());
    case "google.protobuf.Int64Value":
      return ProtobufType.wellKnown(WellKnownProtobufType.int64Value());
    case "google.protobuf.ListValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.listValue());
    case "google.protobuf.Method":
      return ProtobufType.wellKnown(WellKnownProtobufType.method());
    case "google.protobuf.Mixin":
      return ProtobufType.wellKnown(WellKnownProtobufType.mixin());
    case "google.protobuf.NullValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.nullValue());
    case "google.protobuf.Option":
      return ProtobufType.wellKnown(WellKnownProtobufType.option());
    case "google.protobuf.SourceContext":
      return ProtobufType.wellKnown(WellKnownProtobufType.sourceContext());
    case "google.protobuf.StringValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.stringValue());
    case "google.protobuf.Struct":
      return ProtobufType.wellKnown(WellKnownProtobufType.struct());
    case "google.protobuf.Syntax":
      return ProtobufType.wellKnown(WellKnownProtobufType.syntax());
    case "google.protobuf.Timestamp":
      return ProtobufType.wellKnown(WellKnownProtobufType.timestamp());
    case "google.protobuf.Type":
      return ProtobufType.wellKnown(WellKnownProtobufType.type());
    case "google.protobuf.Uint32Value":
      return ProtobufType.wellKnown(WellKnownProtobufType.uint32Value());
    case "google.protobuf.Uint64Value":
      return ProtobufType.wellKnown(WellKnownProtobufType.uint64Value());
    case "google.protobuf.Value":
      return ProtobufType.wellKnown(WellKnownProtobufType.value());
  }
  return void 0;
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertGenericTypeDeclaration.js
async function convertGenericTypeDeclaration({ generic, file, typeResolver }) {
  const genericInstantiation = typeof generic === "string" ? generic : generic.type;
  const maybeGeneric = parseGeneric(genericInstantiation);
  if (maybeGeneric == null) {
    throw new Error(`Invalid generic type definition: ${genericInstantiation}`);
  }
  const resolvedBaseGeneric = typeResolver.getDeclarationOfNamedTypeOrThrow({
    referenceToNamedType: genericInstantiation,
    file
  });
  if (maybeGeneric.arguments && isRawObjectDefinition(resolvedBaseGeneric.declaration)) {
    const genericArgumentDefinitions = parseGeneric(resolvedBaseGeneric.typeName)?.arguments ?? [];
    const newProperties = Object.entries(resolvedBaseGeneric.declaration.properties ?? {}).map(([key, value]) => {
      let maybeReplacedValue = value;
      if (typeof value === "string" && genericArgumentDefinitions?.includes(value)) {
        maybeReplacedValue = maybeGeneric.arguments?.[genericArgumentDefinitions.indexOf(value)] ?? value;
      }
      return [key, maybeReplacedValue];
    });
    return Type.object({
      extends: getExtensionsAsList(resolvedBaseGeneric.declaration.extends).map((extended) => parseTypeName({ typeName: extended, file })),
      properties: await getObjectPropertiesFromRawObjectSchema({ properties: Object.fromEntries(newProperties) }, file),
      extraProperties: resolvedBaseGeneric.declaration["extra-properties"] ?? false,
      extendedProperties: void 0
    });
  }
  throw new Error(`Generic type definition not supported: ${genericInstantiation}`);
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertAliasTypeDeclaration.js
async function convertAliasTypeDeclaration({ alias, file, typeResolver }) {
  const aliasOfStr = typeof alias === "string" ? alias : alias.type;
  if (isGeneric(aliasOfStr)) {
    return await convertGenericTypeDeclaration({ generic: aliasOfStr, file, typeResolver });
  }
  return Type.alias({
    aliasOf: file.parseTypeReference(alias),
    resolvedType: constructResolvedTypeReference({ aliasOf: aliasOfStr, file, typeResolver })
  });
}
function constructResolvedTypeReference({ aliasOf, file, typeResolver }) {
  const resolvedType = typeResolver.resolveTypeOrThrow({ type: aliasOf, file });
  switch (resolvedType._type) {
    case "primitive":
      return ResolvedTypeReference.primitive(resolvedType.originalTypeReference.primitive);
    case "container":
      return ResolvedTypeReference.container(resolvedType.originalTypeReference.container);
    case "unknown":
      return ResolvedTypeReference.unknown();
    case "named": {
      const shapeType = isRawObjectDefinition(resolvedType.declaration) ? ShapeType.Object : isRawDiscriminatedUnionDefinition(resolvedType.declaration) ? ShapeType.Union : isRawEnumDefinition(resolvedType.declaration) ? ShapeType.Enum : isRawUndiscriminatedUnionDefinition(resolvedType.declaration) ? ShapeType.UndiscriminatedUnion : assertNever(resolvedType.declaration);
      return ResolvedTypeReference.named({
        name: resolvedType.name,
        shape: shapeType
      });
    }
  }
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertUndiscriminatedUnionTypeDeclaration.js
function convertUndiscriminatedUnionTypeDeclaration({ union: union3, file }) {
  return Type.undiscriminatedUnion({
    members: union3.union.map((unionMember) => {
      if (typeof unionMember === "string") {
        return {
          docs: void 0,
          type: file.parseTypeReference(unionMember)
        };
      }
      return {
        type: file.parseTypeReference(unionMember),
        docs: unionMember.docs
      };
    })
  });
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/getReferencedTypesFromRawDeclaration.js
function getObjectRawTypeReferences(objectDeclaration) {
  const types2 = [];
  if (objectDeclaration.extends != null) {
    const extendsArr = typeof objectDeclaration.extends === "string" ? [objectDeclaration.extends] : objectDeclaration.extends;
    types2.push(...extendsArr);
  }
  if (objectDeclaration.properties != null) {
    types2.push(...Object.values(objectDeclaration.properties).map((property4) => typeof property4 === "string" ? property4 : property4.type));
  }
  return types2;
}
function getReferencedTypesFromRawDeclaration({ typeDeclaration, file, typeResolver, seenTypeNames = new SeenTypeNamesImpl() }) {
  const rawTypeReferences = visitRawTypeDeclaration(typeDeclaration, {
    alias: (aliasDeclaration) => {
      const aliasTypeReference = typeof aliasDeclaration === "string" ? aliasDeclaration : aliasDeclaration.type;
      const parsedGeneric = parseGeneric(aliasTypeReference);
      if (parsedGeneric != null) {
        const rawTypeReferences2 = new Set(parsedGeneric.arguments ?? []);
        const resolvedBaseGeneric = typeResolver.getDeclarationOfNamedTypeOrThrow({
          referenceToNamedType: aliasTypeReference,
          file
        });
        const resolvedBaseGenericArguments = parseGeneric(resolvedBaseGeneric.typeName)?.arguments;
        if (isRawObjectDefinition(resolvedBaseGeneric.declaration)) {
          const underlyingObjectRawTypeReferences = getObjectRawTypeReferences(resolvedBaseGeneric.declaration);
          if (resolvedBaseGenericArguments) {
            underlyingObjectRawTypeReferences.filter((typeReference) => !resolvedBaseGenericArguments.includes(typeReference)).forEach((type2) => rawTypeReferences2.add(type2));
          }
        }
        return Array.from(rawTypeReferences2);
      }
      return [aliasTypeReference];
    },
    object: (objectDeclaration) => getObjectRawTypeReferences(objectDeclaration),
    discriminatedUnion: (unionDeclaration) => {
      const types2 = [];
      if (unionDeclaration["base-properties"] != null) {
        types2.push(...Object.values(unionDeclaration["base-properties"]).map((property4) => typeof property4 === "string" ? property4 : property4.type));
      }
      types2.push(...Object.values(unionDeclaration.union).reduce((types3, singleUnionType) => {
        const rawType = typeof singleUnionType === "string" ? singleUnionType : singleUnionType.type;
        if (typeof rawType === "string") {
          types3.push(rawType);
        }
        return types3;
      }, []));
      return types2;
    },
    undiscriminatedUnion: (unionDeclaration) => {
      return Object.values(unionDeclaration.union).reduce((types2, unionMember) => {
        const rawType = typeof unionMember === "string" ? unionMember : unionMember.type;
        if (typeof rawType === "string") {
          types2.push(rawType);
        }
        return types2;
      }, []);
    },
    enum: () => []
  });
  const referencedTypes = [];
  for (const rawTypeReference of rawTypeReferences) {
    const rawNames = recursivelyVisitRawTypeReference({
      type: rawTypeReference,
      _default: void 0,
      validation: void 0,
      visitor: {
        primitive: () => [],
        map: ({ keyType, valueType }) => [...keyType, ...valueType],
        list: (valueType) => valueType,
        optional: (valueType) => valueType,
        set: (valueType) => valueType,
        named: (name) => [name],
        literal: () => [],
        unknown: () => []
      }
    });
    for (const rawName of rawNames) {
      const parsedTypeName = parseTypeName({ typeName: rawName, file });
      if (!seenTypeNames.hasTypeNameBeenSeen(parsedTypeName)) {
        seenTypeNames.addTypeName(parsedTypeName);
        referencedTypes.push(parsedTypeName);
        const maybeDeclaration = typeResolver.getDeclarationOfNamedTypeOrThrow({
          referenceToNamedType: rawName,
          file
        });
        if (isGeneric(maybeDeclaration.typeName)) {
          continue;
        }
        referencedTypes.push(...getReferencedTypesFromRawDeclaration({
          typeDeclaration: maybeDeclaration.declaration,
          file: maybeDeclaration.file,
          typeResolver,
          seenTypeNames
        }));
      }
    }
  }
  return referencedTypes;
}
var SeenTypeNamesImpl = class {
  cache = /* @__PURE__ */ new Set();
  addTypeName(typeName) {
    this.cache.add(this.computeCacheKey(typeName));
  }
  hasTypeNameBeenSeen(typeName) {
    return this.cache.has(this.computeCacheKey(typeName));
  }
  computeCacheKey(typeName) {
    return typeName.fernFilepath.allParts.map((part) => part.originalName).join("/") + ":" + typeName.name.originalName;
  }
};

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertTypeDeclaration.js
async function convertTypeDeclaration({ typeName, typeDeclaration, file, typeResolver, exampleResolver, sourceResolver, workspace }) {
  const declaration = await convertDeclaration(typeDeclaration);
  const declaredTypeName = parseTypeName({
    typeName,
    file
  });
  const referencedTypes = getReferencedTypesFromRawDeclaration({ typeDeclaration, file, typeResolver });
  let propertiesByAudience = {};
  if (isRawObjectDefinition(typeDeclaration)) {
    propertiesByAudience = getPropertiesByAudience(typeDeclaration.properties ?? {});
  }
  const source = await convertTypeDeclarationSource({
    file,
    typeDeclaration,
    typeName,
    sourceResolver
  });
  return {
    propertiesByAudience,
    typeDeclaration: {
      ...declaration,
      inline: getInline2(typeDeclaration),
      name: declaredTypeName,
      shape: await convertType({ typeDeclaration, file, typeResolver }),
      referencedTypes: new Set(referencedTypes.map((referencedType) => referencedType.typeId)),
      encoding: convertTypeDeclarationEncoding({ typeDeclaration, source }),
      source,
      userProvidedExamples: typeof typeDeclaration !== "string" && typeDeclaration.examples != null ? typeDeclaration.examples.map((example) => ({
        name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
        docs: example.docs,
        jsonExample: exampleResolver.resolveAllReferencesInExampleOrThrow({
          example: example.value,
          file
        }).resolvedExample,
        shape: convertTypeExample({
          typeName: declaredTypeName,
          example: example.value,
          typeResolver,
          exampleResolver,
          typeDeclaration,
          fileContainingType: file,
          fileContainingExample: file,
          workspace
        })
      })) : [],
      autogeneratedExamples: []
    },
    descendantFilepaths: new Set(referencedTypes.map((referencedType) => referencedType.fernFilepath))
  };
}
async function convertType({ typeDeclaration, file, typeResolver }) {
  return await visitRawTypeDeclaration(typeDeclaration, {
    alias: (alias) => convertAliasTypeDeclaration({ alias, file, typeResolver }),
    object: (object3) => convertObjectTypeDeclaration({ object: object3, file }),
    discriminatedUnion: (union3) => convertDiscriminatedUnionTypeDeclaration({ union: union3, file, typeResolver }),
    undiscriminatedUnion: (union3) => convertUndiscriminatedUnionTypeDeclaration({ union: union3, file }),
    enum: async (enum_3) => Type.enum(await convertEnumTypeDeclaration({ _enum: enum_3, file }))
  });
}
async function convertTypeDeclarationSource({ file, typeDeclaration, typeName, sourceResolver }) {
  if (typeof typeDeclaration === "string" || typeDeclaration.source == null && typeDeclaration.encoding == null) {
    return void 0;
  }
  if (typeDeclaration.encoding != null) {
    const maybeProtobufType = maybeConvertEncodingToProtobufType({
      encoding: typeDeclaration.encoding
    });
    if (maybeProtobufType != null) {
      return Source.proto(maybeProtobufType);
    }
  }
  if (typeDeclaration.source == null) {
    return void 0;
  }
  const resolvedSource = await sourceResolver.resolveSourceOrThrow({
    source: typeDeclaration.source,
    relativeFilepath: file.relativeFilepath
  });
  if (resolvedSource == null || resolvedSource.type !== "protobuf") {
    return void 0;
  }
  return Source.proto(convertSourceToProtobufType({
    source: resolvedSource,
    name: typeName
  }));
}
function convertTypeDeclarationEncoding({ typeDeclaration, source }) {
  if (typeof typeDeclaration !== "string" && typeDeclaration.encoding != null) {
    return convertEncoding2(typeDeclaration.encoding);
  }
  return convertSourceToEncoding(source);
}
function convertEncoding2(encodingSchema) {
  return encodingSchema.proto != null ? {
    json: void 0,
    proto: {}
  } : {
    json: {},
    proto: void 0
  };
}
function convertSourceToEncoding(source) {
  return source != null && source.type === "proto" ? {
    json: void 0,
    proto: {}
  } : {
    json: {},
    proto: void 0
  };
}
function getInline2(typeDeclaration) {
  if (typeof typeDeclaration === "string") {
    return void 0;
  }
  if ("inline" in typeDeclaration) {
    return typeDeclaration.inline;
  }
  return void 0;
}

// ../../cli/task-context/lib/LoggableFernCliError.js
var LoggableFernCliError = class _LoggableFernCliError extends Error {
  log;
  constructor(log) {
    super();
    this.log = log;
    Object.setPrototypeOf(this, _LoggableFernCliError.prototype);
  }
};

// ../../cli/generation/ir-generator/lib/utils/getTypeDeclaration.js
function getTypeDeclaration(typeId, types2) {
  const maybeTypeDeclaration = types2[typeId];
  if (maybeTypeDeclaration == null) {
    throw new LoggableFernCliError(`Illegal Error: Failed to load type declaration for type ${typeId}`);
  }
  return maybeTypeDeclaration;
}

// ../../cli/generation/ir-generator/lib/extended-properties/addExtendedPropertiesToIr.js
function addExtendedPropertiesToIr(ir) {
  return {
    types: Object.fromEntries(Object.entries(ir.types).map(([typeId, typeDeclaration]) => {
      return [typeId, addExtendedPropertiesToType({ typeDeclaration, ir })];
    })),
    services: Object.fromEntries(Object.entries(ir.services).map(([serviceId, serviceDeclration]) => {
      return [
        serviceId,
        {
          ...serviceDeclration,
          endpoints: serviceDeclration.endpoints.map((endpoint) => {
            return addExtendedPropertiesToEndpoint({ endpoint, ir });
          })
        }
      ];
    }))
  };
}
function addExtendedPropertiesToEndpoint({ endpoint, ir }) {
  if (endpoint.requestBody?.type !== "inlinedRequestBody") {
    return endpoint;
  }
  return {
    ...endpoint,
    requestBody: {
      ...endpoint.requestBody,
      extendedProperties: endpoint.requestBody.extends.flatMap((extended) => getExtendedPropertiesForDeclaredTypeName(extended, ir))
    }
  };
}
function addExtendedPropertiesToType({ typeDeclaration, ir }) {
  switch (typeDeclaration.shape.type) {
    case "object":
      return {
        ...typeDeclaration,
        shape: {
          ...typeDeclaration.shape,
          extendedProperties: typeDeclaration.shape.extends.flatMap((extended) => getExtendedPropertiesForDeclaredTypeName(extended, ir))
        }
      };
  }
  return typeDeclaration;
}
function getExtendedPropertiesForDeclaredTypeName(declaredTypeName, ir) {
  const objectTypeDeclaration = getObjectTypeDeclarationFromTypeId(declaredTypeName.typeId, ir);
  return getAllPropertiesForObject2({ objectTypeDeclaration, ir });
}
function getObjectTypeDeclarationFromTypeId(typeId, ir) {
  const typeDeclaration = getTypeDeclaration(typeId, ir.types);
  switch (typeDeclaration.shape.type) {
    case "object":
      return typeDeclaration.shape;
    case "alias": {
      if (typeDeclaration.shape.resolvedType.type === "named") {
        return getObjectTypeDeclarationFromTypeId(typeDeclaration.shape.resolvedType.name.typeId, ir);
      }
    }
  }
  throw new LoggableFernCliError(`Unexpected error: ${typeId} is extended but has shape ${typeDeclaration.shape.type}`);
}
function getAllPropertiesForObject2({ objectTypeDeclaration, ir }) {
  const extendedProperties = objectTypeDeclaration.extends.flatMap((extended) => {
    const extendedObjectDeclaration = getObjectTypeDeclarationFromTypeId(extended.typeId, ir);
    return getAllPropertiesForObject2({ objectTypeDeclaration: extendedObjectDeclaration, ir });
  });
  return [...objectTypeDeclaration.properties, ...extendedProperties];
}

// ../../cli/generation/ir-generator/lib/filtered-ir/FilteredIr.js
var FilteredIrImpl = class {
  environments = /* @__PURE__ */ new Set();
  types = /* @__PURE__ */ new Set();
  properties;
  errors = /* @__PURE__ */ new Set();
  services = /* @__PURE__ */ new Set();
  endpoints = /* @__PURE__ */ new Set();
  requestProperties;
  queryParameters;
  webhooks = /* @__PURE__ */ new Set();
  webhookPayloadProperties;
  subpackages = /* @__PURE__ */ new Set();
  constructor({ types: types2, properties, errors, environments, services, endpoints, webhooks, subpackages, queryParameters, requestProperties, webhookPayloadProperties }) {
    this.environments = environments;
    this.types = types2;
    this.properties = properties;
    this.errors = errors;
    this.services = services;
    this.endpoints = endpoints;
    this.webhooks = webhooks;
    this.webhookPayloadProperties = webhookPayloadProperties;
    this.subpackages = subpackages;
    this.requestProperties = requestProperties;
    this.queryParameters = queryParameters;
  }
  hasTypeId(typeId) {
    return this.types.has(typeId);
  }
  hasErrorId(errorId) {
    return this.errors.has(errorId);
  }
  hasServiceId(serviceId) {
    return this.services.has(serviceId);
  }
  hasSubpackageId(subpackageId) {
    return this.subpackages.has(subpackageId);
  }
  hasType(type2) {
    const typeId = IdGenerator.generateTypeId(type2.name);
    return this.types.has(typeId);
  }
  hasProperty(typeId, property4) {
    const properties = this.properties[typeId];
    if (properties == null) {
      return true;
    }
    return properties.has(property4);
  }
  hasError(error) {
    const errorId = IdGenerator.generateErrorId(error.name);
    return this.errors.has(errorId);
  }
  hasService(service) {
    const serviceId = IdGenerator.generateServiceId(service.name);
    return this.services.has(serviceId);
  }
  hasEnvironmentId(environmentId) {
    return this.environments.has(environmentId);
  }
  hasEndpoint(endpoint) {
    return this.endpoints.has(endpoint.id);
  }
  hasRequestProperty(endpoint, property4) {
    const properties = this.requestProperties[endpoint];
    if (properties == null) {
      return true;
    }
    return properties.has(property4);
  }
  hasQueryParameter(endpoint, parameter) {
    const parameters = this.queryParameters[endpoint];
    if (parameters == null) {
      return true;
    }
    return parameters.has(parameter);
  }
  hasSubpackage(subpackageId) {
    return this.subpackages.has(subpackageId);
  }
  hasWebhook(webhook) {
    if (webhook.id) {
      return this.webhooks.has(webhook.id);
    }
    return true;
  }
  hasWebhookPayloadProperty(webhookId, property4) {
    const properties = this.webhookPayloadProperties[webhookId];
    if (properties == null) {
      return true;
    }
    return properties.has(property4);
  }
};

// ../../cli/generation/ir-generator/lib/filtered-ir/IrGraph.js
var IrGraph = class {
  types = {};
  properties = {};
  queryParameters = {};
  requestProperties = {};
  webhookProperties = {};
  errors = {};
  endpoints = {};
  webhooks = {};
  audiences;
  typesReferencedByService = {};
  environmentsNeededForAudience = /* @__PURE__ */ new Set();
  typesNeededForAudience = /* @__PURE__ */ new Set();
  servicesNeededForAudience = /* @__PURE__ */ new Set();
  endpointsNeededForAudience = /* @__PURE__ */ new Set();
  webhooksNeededForAudience = /* @__PURE__ */ new Set();
  subpackagesNeededForAudience = /* @__PURE__ */ new Set();
  constructor(audiences) {
    this.audiences = audiencesFromConfig(audiences);
  }
  addType({ declaredTypeName, descendantTypeIds, descendantFilepaths, descendantTypeIdsByAudience, propertiesByAudience }) {
    const typeId = IdGenerator.generateTypeId(declaredTypeName);
    const typeNode = {
      typeId,
      allDescendants: descendantTypeIds,
      descendantsByAudience: descendantTypeIdsByAudience,
      referencedSubpackages: descendantFilepaths
    };
    this.types[typeId] = typeNode;
    if (this.typesReferencedByService[typeId] == null) {
      this.typesReferencedByService[typeId] = /* @__PURE__ */ new Set();
    }
    this.properties[typeId] = {
      typeId,
      propertiesByAudience
    };
  }
  markTypeForAudiences(declaredTypeName, audiences) {
    const typeId = IdGenerator.generateTypeId(declaredTypeName);
    if (this.hasAudience(audiences)) {
      this.typesNeededForAudience.add(typeId);
      this.addSubpackages(declaredTypeName.fernFilepath);
      this.types[typeId]?.referencedSubpackages.forEach((fernFilePath) => {
        this.addSubpackages(fernFilePath);
      });
    }
  }
  markEnvironmentForAudiences(environment, audiences, ignoreAudiences) {
    if (environment) {
      if (this.hasAudience(audiences) || ignoreAudiences) {
        this.environmentsNeededForAudience.add(environment.id);
      }
    }
  }
  getTypesReferencedByService() {
    for (const endpoint of Object.values(this.endpoints)) {
      for (const typeId of endpoint.referencedTypes) {
        this.markTypeForService(typeId, endpoint.serviceId);
      }
    }
    return this.typesReferencedByService;
  }
  addError(errorDeclaration) {
    const errorId = IdGenerator.generateErrorId(errorDeclaration.name);
    const referencedTypes = /* @__PURE__ */ new Set();
    const referencedSubpackages = /* @__PURE__ */ new Set();
    if (errorDeclaration.type != null) {
      populateReferencesFromTypeReference(errorDeclaration.type, referencedTypes, referencedSubpackages);
    }
    const errorNode = {
      errorId,
      referencedTypes,
      referencedSubpackages
    };
    this.errors[errorId] = errorNode;
  }
  addEndpoint(service, httpEndpoint, rawEndpoint) {
    const serviceId = IdGenerator.generateServiceId(service.name);
    const endpointId = httpEndpoint.id;
    const referencedTypes = /* @__PURE__ */ new Set();
    const referencedErrors = /* @__PURE__ */ new Set();
    const referencedSubpackages = /* @__PURE__ */ new Set();
    for (const header of [...service.headers, ...httpEndpoint.headers]) {
      populateReferencesFromTypeReference(header.valueType, referencedTypes, referencedSubpackages);
    }
    for (const pathParameter of [...service.pathParameters, ...httpEndpoint.pathParameters]) {
      populateReferencesFromTypeReference(pathParameter.valueType, referencedTypes, referencedSubpackages);
    }
    for (const queryParameter of httpEndpoint.queryParameters) {
      populateReferencesFromTypeReference(queryParameter.valueType, referencedTypes, referencedSubpackages);
    }
    if (rawEndpoint != null && rawEndpoint.request != null && typeof rawEndpoint.request !== "string") {
      const parametersByAudience = getPropertiesByAudience(rawEndpoint.request["query-parameters"] ?? {});
      this.queryParameters[endpointId] = {
        endpointId,
        parametersByAudience
      };
    }
    if (httpEndpoint.requestBody != null) {
      HttpRequestBody._visit(httpEndpoint.requestBody, {
        inlinedRequestBody: (inlinedRequestBody) => {
          for (const extension of inlinedRequestBody.extends) {
            populateReferencesFromTypeName(extension, referencedTypes, referencedSubpackages);
          }
          for (const property4 of inlinedRequestBody.properties) {
            populateReferencesFromTypeReference(property4.valueType, referencedTypes, referencedSubpackages);
          }
          if (rawEndpoint != null && typeof rawEndpoint.request === "object" && typeof rawEndpoint.request.body === "object" && isInlineRequestBody(rawEndpoint.request.body)) {
            const propertiesByAudience = getPropertiesByAudience(rawEndpoint.request.body.properties ?? {});
            this.requestProperties[endpointId] = {
              endpointId,
              propertiesByAudience
            };
          }
        },
        reference: ({ requestBodyType }) => {
          populateReferencesFromTypeReference(requestBodyType, referencedTypes, referencedSubpackages);
        },
        fileUpload: ({ properties }) => {
          for (const property4 of properties) {
            FileUploadRequestProperty._visit(property4, {
              file: noop,
              bodyProperty: ({ valueType }) => {
                populateReferencesFromTypeReference(valueType, referencedTypes, referencedSubpackages);
              },
              _other: () => {
                throw new Error("Unknown FileUploadRequestProperty: " + property4.type);
              }
            });
          }
        },
        bytes: () => {
          return;
        },
        _other: () => {
          throw new Error("Unknown HttpRequestBody: " + httpEndpoint.requestBody?.type);
        }
      });
    }
    if (httpEndpoint.response?.body != null) {
      HttpResponseBody._visit(httpEndpoint.response.body, {
        fileDownload: noop,
        json: (jsonResponse) => {
          populateReferencesFromTypeReference(jsonResponse.responseBodyType, referencedTypes, referencedSubpackages);
        },
        streaming: (streamingResponse) => {
          streamingResponse._visit({
            sse: (sse) => populateReferencesFromTypeReference(sse.payload, referencedTypes, referencedSubpackages),
            json: (json2) => populateReferencesFromTypeReference(json2.payload, referencedTypes, referencedSubpackages),
            text: noop,
            _other: () => {
              throw new Error("Unknown streamingResponse type: " + streamingResponse.type);
            }
          });
        },
        streamParameter: (response) => {
          response.streamResponse._visit({
            sse: (sse) => populateReferencesFromTypeReference(sse.payload, referencedTypes, referencedSubpackages),
            json: (json2) => populateReferencesFromTypeReference(json2.payload, referencedTypes, referencedSubpackages),
            text: noop,
            _other: () => {
              throw new Error("Unknown streamingResponse type: " + response.streamResponse.type);
            }
          });
          if (response.nonStreamResponse.type === "json") {
            populateReferencesFromTypeReference(response.nonStreamResponse.value.responseBodyType, referencedTypes, referencedSubpackages);
          }
        },
        text: noop,
        _other: () => {
          throw new Error("Unknown HttpResponse: " + httpEndpoint.response?.body?.type);
        }
      });
    }
    httpEndpoint.errors.forEach((responseError) => {
      referencedErrors.add(IdGenerator.generateErrorId(responseError.error));
      referencedSubpackages.add(responseError.error.fernFilepath);
    });
    this.endpoints[endpointId] = {
      endpointId,
      serviceId,
      referencedTypes,
      referencedErrors,
      referencedSubpackages
    };
  }
  markEndpointForAudience(declaredServiceName, httpEndpoints, audiences) {
    if (this.hasAudience(audiences)) {
      const serviceId = IdGenerator.generateServiceId(declaredServiceName);
      this.servicesNeededForAudience.add(serviceId);
      httpEndpoints.forEach((httpEndpoint) => {
        const endpointId = httpEndpoint.id;
        this.endpointsNeededForAudience.add(endpointId);
        this.endpoints[endpointId]?.referencedSubpackages.forEach((fernFilePath) => {
          this.addSubpackages(fernFilePath);
        });
      });
      this.servicesNeededForAudience.add(serviceId);
      this.addSubpackages(declaredServiceName.fernFilepath);
    }
  }
  addWebhook(file, webhook, rawWebhook) {
    const webhookId = webhook.id;
    if (webhookId == null) {
      return;
    }
    const referencedTypes = /* @__PURE__ */ new Set();
    const referencedSubpackages = /* @__PURE__ */ new Set();
    if (webhook.payload != null) {
      WebhookPayload._visit(webhook.payload, {
        inlinedPayload: (inlinedPayload) => {
          for (const extension of inlinedPayload.extends) {
            populateReferencesFromTypeName(extension, referencedTypes, referencedSubpackages);
          }
          for (const property4 of inlinedPayload.properties) {
            populateReferencesFromTypeReference(property4.valueType, referencedTypes, referencedSubpackages);
          }
          if (rawWebhook?.payload != null && typeof rawWebhook.payload === "object" && !isReferencedWebhookPayloadSchema2(rawWebhook.payload)) {
            const propertiesByAudience = getPropertiesByAudience(rawWebhook.payload.properties ?? {});
            this.webhookProperties[webhookId] = {
              webhookId,
              propertiesByAudience
            };
          }
        },
        reference: ({ payloadType }) => {
          populateReferencesFromTypeReference(payloadType, referencedTypes, referencedSubpackages);
        },
        _other: () => {
          throw new Error("Unknown WebhookPayload: " + webhook.payload?.type);
        }
      });
    }
    referencedSubpackages.add(file.fernFilepath);
    this.webhooks[webhookId] = {
      webhookId,
      referencedTypes,
      referencedSubpackages
    };
  }
  markWebhookForAudiences(file, webhook, audiences) {
    const webhookId = webhook.id;
    if (webhookId == null) {
      return;
    }
    if (this.hasAudience(audiences)) {
      this.webhooksNeededForAudience.add(webhookId);
      this.addSubpackages(file.fernFilepath);
    }
  }
  build() {
    const typeIds = /* @__PURE__ */ new Set();
    const errorIds = /* @__PURE__ */ new Set();
    for (const endpointId of this.endpointsNeededForAudience.keys()) {
      const endpointNode = this.getEndpointNode(endpointId);
      for (const errorId of endpointNode.referencedErrors) {
        if (errorIds.has(errorId)) {
          continue;
        }
        errorIds.add(errorId);
        const errorNode = this.getErrorNode(errorId);
        this.addReferencedTypes(typeIds, errorNode.referencedTypes);
      }
      this.addReferencedTypes(typeIds, endpointNode.referencedTypes);
    }
    this.addReferencedTypes(typeIds, this.typesNeededForAudience);
    for (const webhookId of this.webhooksNeededForAudience.keys()) {
      const webhookNode = this.getWebhookNode(webhookId);
      this.addReferencedTypes(typeIds, webhookNode.referencedTypes);
    }
    const properties = {};
    const requestProperties = {};
    const queryParameters = {};
    const webhookPayloadProperties = {};
    if (this.audiences.type === "filtered") {
      for (const [typeId, typePropertiesNode] of Object.entries(this.properties)) {
        if (!typeIds.has(typeId)) {
          continue;
        }
        const propertiesForTypeId = /* @__PURE__ */ new Set();
        for (const audience of this.audiences.audiences) {
          const propertiesForAudience = typePropertiesNode.propertiesByAudience[audience];
          if (propertiesForAudience != null) {
            propertiesForAudience.forEach((property4) => {
              propertiesForTypeId.add(property4);
            });
          }
        }
        if (propertiesForTypeId.size > 0) {
          properties[typeId] = propertiesForTypeId;
        }
        properties[typeId] = propertiesForTypeId.size > 0 ? propertiesForTypeId : void 0;
      }
      for (const [endpointId, requestPropertiesNode] of Object.entries(this.requestProperties)) {
        if (!this.endpointsNeededForAudience.has(endpointId)) {
          continue;
        }
        const propertiesForEndpoint = /* @__PURE__ */ new Set();
        for (const audience of this.audiences.audiences) {
          const propertiesForAudience = requestPropertiesNode.propertiesByAudience[audience];
          if (propertiesForAudience != null) {
            propertiesForAudience.forEach((property4) => {
              propertiesForEndpoint.add(property4);
            });
          }
        }
        requestProperties[endpointId] = propertiesForEndpoint.size > 0 ? propertiesForEndpoint : void 0;
      }
      for (const [endpointId, queryParametersNode] of Object.entries(this.queryParameters)) {
        if (!this.endpointsNeededForAudience.has(endpointId)) {
          continue;
        }
        const parametersForEndpoint = /* @__PURE__ */ new Set();
        for (const audience of this.audiences.audiences) {
          const parametersByAudience = queryParametersNode.parametersByAudience[audience];
          if (parametersByAudience != null) {
            parametersByAudience.forEach((parameter) => {
              parametersForEndpoint.add(parameter);
            });
          }
        }
        queryParameters[endpointId] = parametersForEndpoint.size > 0 ? parametersForEndpoint : void 0;
      }
      for (const [webhookId, webhookPaylodPropertiesNode] of Object.entries(this.webhookProperties)) {
        if (!this.webhooksNeededForAudience.has(webhookId)) {
          continue;
        }
        const propertiesForWebhook = /* @__PURE__ */ new Set();
        for (const audience of this.audiences.audiences) {
          const propertiesForAudience = webhookPaylodPropertiesNode.propertiesByAudience[audience];
          if (propertiesForAudience != null) {
            propertiesForAudience.forEach((property4) => {
              propertiesForWebhook.add(property4);
            });
          }
        }
        webhookPayloadProperties[webhookId] = propertiesForWebhook.size > 0 ? propertiesForWebhook : void 0;
      }
    }
    return new FilteredIrImpl({
      types: typeIds,
      properties,
      errors: errorIds,
      requestProperties,
      queryParameters,
      environments: this.environmentsNeededForAudience,
      services: this.servicesNeededForAudience,
      endpoints: this.endpointsNeededForAudience,
      webhooks: this.webhooksNeededForAudience,
      webhookPayloadProperties,
      subpackages: this.subpackagesNeededForAudience
    });
  }
  markTypeForService(typeId, serviceId) {
    const types2 = this.typesReferencedByService[typeId] ??= /* @__PURE__ */ new Set();
    if (types2.has(serviceId)) {
      return;
    }
    types2.add(serviceId);
    const typeNode = this.getTypeNode(typeId);
    for (const descendantTypeId of typeNode.allDescendants) {
      this.markTypeForService(descendantTypeId, serviceId);
    }
  }
  addReferencedTypes(types2, typesToAdd) {
    for (const typeId of typesToAdd) {
      if (types2.has(typeId)) {
        continue;
      }
      types2.add(typeId);
      const typeNode = this.getTypeNode(typeId);
      if (this.audiences.type === "filtered") {
        for (const audienceId of this.audiences.audiences) {
          const descendantsForAudience = typeNode.descendantsByAudience[audienceId];
          if (descendantsForAudience != null) {
            descendantsForAudience.forEach((descendantTypeId) => {
              types2.add(descendantTypeId);
            });
          } else {
            typeNode.allDescendants.forEach((descendantTypeId) => {
              types2.add(descendantTypeId);
            });
            break;
          }
        }
      } else {
        typeNode.allDescendants.forEach((descendantTypeId) => {
          types2.add(descendantTypeId);
        });
      }
    }
  }
  getTypeNode(typeId) {
    const typeNode = this.types[typeId];
    if (typeNode == null) {
      throw new Error(`Failed to find type node with id ${typeId}`);
    }
    return typeNode;
  }
  getErrorNode(errorId) {
    const errorNode = this.errors[errorId];
    if (errorNode == null) {
      throw new Error(`Failed to find error node with id ${errorId}`);
    }
    return errorNode;
  }
  getEndpointNode(endpointId) {
    const endpointNode = this.endpoints[endpointId];
    if (endpointNode == null) {
      throw new Error(`Failed to find endpoint node with id ${endpointId}`);
    }
    return endpointNode;
  }
  getWebhookNode(webhookId) {
    const webhookNode = this.webhooks[webhookId];
    if (webhookNode == null) {
      throw new Error(`Failed to find webhook node with id ${webhookId}`);
    }
    return webhookNode;
  }
  hasNoAudiences() {
    return this.audiences.type === "none";
  }
  hasAudience(audiences) {
    const configuredAudiences = this.audiences;
    switch (configuredAudiences.type) {
      case "none":
        return true;
      case "filtered":
        return audiences.some((audienceId) => configuredAudiences.audiences.has(audienceId));
      default:
        assertNever(configuredAudiences);
    }
  }
  addSubpackages(fernFilePath) {
    for (let i = 1; i <= fernFilePath.allParts.length; ++i) {
      const packageFilePath = {
        ...fernFilePath,
        allParts: fernFilePath.allParts.slice(0, i)
      };
      this.subpackagesNeededForAudience.add(IdGenerator.generateSubpackageId(packageFilePath));
    }
  }
};
function audiencesFromConfig(configAudiences) {
  switch (configAudiences.type) {
    case "all":
      return { type: "none" };
    case "select":
      return { type: "filtered", audiences: new Set(configAudiences.audiences) };
    default:
      assertNever(configAudiences);
  }
}
function populateReferencesFromTypeReference(typeReference, referencedTypes, referencedSubpackages) {
  TypeReference2._visit(typeReference, {
    container: (containerType) => {
      populateReferencesFromContainer(containerType, referencedTypes, referencedSubpackages);
    },
    named: (declaredTypeName) => {
      populateReferencesFromTypeName(declaredTypeName, referencedTypes, referencedSubpackages);
    },
    primitive: noop,
    unknown: noop,
    _other: noop
  });
}
function populateReferencesFromTypeName(typeName, referencedTypes, referencedSubpackages) {
  referencedTypes.add(IdGenerator.generateTypeId(typeName));
  referencedSubpackages.add(typeName.fernFilepath);
}
function populateReferencesFromContainer(containerType, referencedTypes, referencedSubpackages) {
  ContainerType._visit(containerType, {
    list: (listType) => {
      populateReferencesFromTypeReference(listType, referencedTypes, referencedSubpackages);
    },
    map: (mapType2) => {
      populateReferencesFromTypeReference(mapType2.keyType, referencedTypes, referencedSubpackages);
      populateReferencesFromTypeReference(mapType2.valueType, referencedTypes, referencedSubpackages);
    },
    optional: (optionalType2) => {
      populateReferencesFromTypeReference(optionalType2, referencedTypes, referencedSubpackages);
    },
    set: (setType2) => {
      populateReferencesFromTypeReference(setType2, referencedTypes, referencedSubpackages);
    },
    literal: noop,
    _other: noop
  });
}

// ../../cli/generation/ir-generator/lib/filterExamples.js
function filterExampleSingleUnionTypeProperties({ filteredIr, singleUnionTypeProperties }) {
  return singleUnionTypeProperties._visit({
    samePropertiesAsObject: (s) => {
      const filteredObject = filteredIr.hasTypeId(s.typeId) ? {
        ...s,
        object: {
          properties: s.object.properties.filter((p) => filteredIr.hasProperty(p.originalTypeDeclaration.typeId, p.name.wireValue)).map((p) => ({
            ...p,
            value: filterExampleTypeReference({ filteredIr, exampleTypeReference: p.value })
          })).filter((p) => p.value !== void 0)
        }
      } : void 0;
      return filteredObject !== void 0 ? ExampleSingleUnionTypeProperties.samePropertiesAsObject(filteredObject) : void 0;
    },
    singleProperty: (s) => {
      const filteredProperty = filterExampleTypeReference({ filteredIr, exampleTypeReference: s });
      return filteredProperty !== void 0 ? ExampleSingleUnionTypeProperties.singleProperty(filteredProperty) : void 0;
    },
    noProperties: () => singleUnionTypeProperties,
    _other: () => {
      throw new Error("Received unknown type for example.");
    }
  });
}
function filterExampleTypeReference({ filteredIr, exampleTypeReference }) {
  return exampleTypeReference.shape._visit({
    primitive: () => exampleTypeReference,
    container: (c) => c._visit({
      list: (l) => ({
        ...exampleTypeReference,
        shape: ExampleTypeReferenceShape.container(ExampleContainer.list({
          ...l,
          list: l.list.map((t) => filterExampleTypeReference({ filteredIr, exampleTypeReference: t })).filter((t) => t !== void 0)
        }))
      }),
      set: (s) => ({
        ...exampleTypeReference,
        shape: ExampleTypeReferenceShape.container(ExampleContainer.set({
          ...s,
          set: s.set.map((t) => filterExampleTypeReference({ filteredIr, exampleTypeReference: t })).filter((t) => t !== void 0)
        }))
      }),
      optional: (o) => {
        const filteredOptionalTypReference = o.optional != null ? filterExampleTypeReference({ filteredIr, exampleTypeReference: o.optional }) : void 0;
        return filteredOptionalTypReference != null ? {
          ...exampleTypeReference,
          shape: ExampleTypeReferenceShape.container(ExampleContainer.optional({
            optional: filteredOptionalTypReference,
            valueType: o.valueType
          }))
        } : void 0;
      },
      map: (m) => ({
        ...exampleTypeReference,
        shape: ExampleTypeReferenceShape.container(ExampleContainer.map({
          ...m,
          map: m.map.map((v) => {
            const filteredKey = filterExampleTypeReference({
              filteredIr,
              exampleTypeReference: v.key
            });
            const filteredValue = filterExampleTypeReference({
              filteredIr,
              exampleTypeReference: v.value
            });
            return filteredKey !== void 0 && filteredValue !== void 0 ? { key: filteredKey, value: filteredValue } : void 0;
          }).filter((t) => t !== void 0)
        }))
      }),
      // This is just a primitive, don't do anything
      literal: () => exampleTypeReference,
      _other: () => {
        throw new Error("Received unknown type for example.");
      }
    }),
    // If the type is allowed filter it's properties and return
    // Otherwise just return null
    named: (n) => filteredIr.hasTypeId(n.typeName.typeId) ? n.shape._visit({
      alias: (a) => {
        const filteredAlias = filterExampleTypeReference({
          filteredIr,
          exampleTypeReference: a.value
        });
        return filteredAlias !== void 0 ? {
          ...exampleTypeReference,
          shape: ExampleTypeReferenceShape.named({
            ...n,
            shape: ExampleTypeShape.alias({ ...a, value: filteredAlias })
          })
        } : void 0;
      },
      enum: (e) => ({
        ...exampleTypeReference,
        shape: ExampleTypeReferenceShape.named({ ...n, shape: ExampleTypeShape.enum(e) })
      }),
      object: (o) => ({
        ...exampleTypeReference,
        shape: ExampleTypeReferenceShape.named({
          ...n,
          shape: ExampleTypeShape.object({
            ...o,
            properties: o.properties.filter((p) => filteredIr.hasProperty(p.originalTypeDeclaration.typeId, p.name.wireValue)).map((p) => ({
              ...p,
              value: filterExampleTypeReference({
                filteredIr,
                exampleTypeReference: p.value
              })
            })).filter((p) => p.value !== void 0)
          })
        })
      }),
      union: (u) => {
        const filteredUnion = filterExampleSingleUnionTypeProperties({
          filteredIr,
          singleUnionTypeProperties: u.singleUnionType.shape
        });
        return filteredUnion !== void 0 ? {
          ...exampleTypeReference,
          shape: ExampleTypeReferenceShape.named({
            ...n,
            shape: ExampleTypeShape.union({
              ...u,
              singleUnionType: { ...u.singleUnionType, shape: filteredUnion }
            })
          })
        } : void 0;
      },
      undiscriminatedUnion: (u) => {
        const filteredUnion = filterExampleTypeReference({
          filteredIr,
          exampleTypeReference: u.singleUnionType
        });
        return filteredUnion !== void 0 ? {
          ...exampleTypeReference,
          shape: ExampleTypeReferenceShape.named({
            ...n,
            shape: ExampleTypeShape.undiscriminatedUnion({
              ...u,
              singleUnionType: filteredUnion
            })
          })
        } : void 0;
      },
      _other: () => {
        throw new Error("Received unknown type for example.");
      }
    }) : void 0,
    unknown: () => exampleTypeReference,
    _other: () => exampleTypeReference
  });
}
function filterExamplePathParameters({ filteredIr, pathParameters }) {
  return pathParameters.map((param) => {
    const filteredParam = filterExampleTypeReference({ filteredIr, exampleTypeReference: param.value });
    return filteredParam !== void 0 ? {
      ...param,
      value: filteredParam
    } : void 0;
  }).filter((param) => param !== void 0);
}
function filterExampleQueryParameters({ filteredIr, queryParameters }) {
  return queryParameters.map((queryParameter) => {
    const filteredQueryParameter = filterExampleTypeReference({
      filteredIr,
      exampleTypeReference: queryParameter.value
    });
    return filteredQueryParameter !== void 0 ? {
      ...queryParameter,
      value: filteredQueryParameter
    } : void 0;
  }).filter((queryParameter) => queryParameter !== void 0);
}
function filterExampleHeader({ filteredIr, headers }) {
  return headers.map((header) => {
    const filteredHeader = filterExampleTypeReference({ filteredIr, exampleTypeReference: header.value });
    return filteredHeader !== void 0 ? {
      ...header,
      value: filteredHeader
    } : void 0;
  }).filter((header) => header !== void 0);
}
function filterExampleRequestBody({ filteredIr, requestBody }) {
  return requestBody._visit({
    inlinedRequestBody: (inlined) => {
      return {
        ...requestBody,
        properties: inlined.properties.filter((p) => p.originalTypeDeclaration ? filteredIr.hasProperty(p.originalTypeDeclaration.typeId, p.name.wireValue) : true).map((property4) => {
          const filteredProperty = filterExampleTypeReference({
            filteredIr,
            exampleTypeReference: property4.value
          });
          return filteredProperty !== void 0 ? {
            ...property4,
            value: filteredProperty
          } : void 0;
        }).filter((property4) => property4 !== void 0)
      };
    },
    reference: (reference) => {
      const filteredReference = filterExampleTypeReference({ filteredIr, exampleTypeReference: reference });
      return filteredReference !== void 0 ? ExampleRequestBody.reference(filteredReference) : void 0;
    },
    _other: () => {
      throw new Error("Received unknown type for example.");
    }
  });
}
function filterExampleResponse({ filteredIr, response }) {
  return response._visit({
    ok: (ok) => ok._visit({
      body: (exampleTypeReference) => ExampleResponse.ok(ExampleEndpointSuccessResponse.body(exampleTypeReference != null ? filterExampleTypeReference({ filteredIr, exampleTypeReference }) : void 0)),
      stream: (stream) => ExampleResponse.ok(ExampleEndpointSuccessResponse.stream(stream.map((exampleTypeReference) => filterExampleTypeReference({ filteredIr, exampleTypeReference })).filter(isNonNullish))),
      sse: (events) => ExampleResponse.ok(ExampleEndpointSuccessResponse.sse(events.map(({ event, data }) => {
        const filteredData = filterExampleTypeReference({
          filteredIr,
          exampleTypeReference: data
        });
        return filteredData !== void 0 ? { event, data: filteredData } : void 0;
      }).filter(isNonNullish))),
      _other: ({ type: type2 }) => {
        throw new Error(`Received unknown type for OK example: ${type2}`);
      }
    }),
    error: ({ error, body }) => ExampleResponse.error({
      error,
      body: body != null ? filterExampleTypeReference({ filteredIr, exampleTypeReference: body }) : void 0
    }),
    _other: ({ type: type2 }) => {
      throw new Error(`Received unknown type for example: ${type2}`);
    }
  });
}
function filterEndpointExample({ filteredIr, example }) {
  return {
    ...example,
    rootPathParameters: filterExamplePathParameters({ filteredIr, pathParameters: example.rootPathParameters }),
    servicePathParameters: filterExamplePathParameters({
      filteredIr,
      pathParameters: example.servicePathParameters
    }),
    endpointPathParameters: filterExamplePathParameters({
      filteredIr,
      pathParameters: example.endpointPathParameters
    }),
    serviceHeaders: filterExampleHeader({ filteredIr, headers: example.serviceHeaders }),
    endpointHeaders: filterExampleHeader({ filteredIr, headers: example.endpointHeaders }),
    queryParameters: filterExampleQueryParameters({ filteredIr, queryParameters: example.queryParameters }),
    request: example.request !== void 0 ? filterExampleRequestBody({ filteredIr, requestBody: example.request }) : void 0,
    response: filterExampleResponse({ filteredIr, response: example.response })
  };
}
function filterExampleType({ filteredIr, exampleType }) {
  return exampleType.shape._visit({
    alias: (a) => {
      const filteredAlias = filterExampleTypeReference({ filteredIr, exampleTypeReference: a.value });
      return filteredAlias !== void 0 ? { ...exampleType, shape: ExampleTypeShape.alias({ ...a, value: filteredAlias }) } : void 0;
    },
    enum: () => exampleType,
    object: (o) => ({
      ...exampleType,
      shape: ExampleTypeShape.object({
        ...o,
        properties: o.properties.filter((p) => filteredIr.hasProperty(p.originalTypeDeclaration.typeId, p.name.wireValue)).map((p) => ({
          ...p,
          value: filterExampleTypeReference({ filteredIr, exampleTypeReference: p.value })
        })).filter((p) => p.value !== void 0)
      })
    }),
    union: (u) => {
      const filteredUnion = filterExampleSingleUnionTypeProperties({
        filteredIr,
        singleUnionTypeProperties: u.singleUnionType.shape
      });
      return filteredUnion !== void 0 ? {
        ...exampleType,
        shape: ExampleTypeShape.union({
          ...u,
          singleUnionType: { ...u.singleUnionType, shape: filteredUnion }
        })
      } : void 0;
    },
    undiscriminatedUnion: (u) => {
      const filteredUnion = filterExampleTypeReference({ filteredIr, exampleTypeReference: u.singleUnionType });
      return filteredUnion !== void 0 ? {
        ...exampleType,
        shape: ExampleTypeShape.undiscriminatedUnion({
          ...u,
          singleUnionType: filteredUnion
        })
      } : void 0;
    },
    _other: () => {
      throw new Error("Received unknown type for example.");
    }
  });
}

// ../../cli/generation/ir-generator/lib/PackageTreeGenerator.js
var PackageTreeGenerator = class {
  subpackages = {};
  rootPackage = {
    docs: void 0,
    fernFilepath: {
      allParts: [],
      packagePath: [],
      file: void 0
    },
    websocket: void 0,
    service: void 0,
    types: [],
    errors: [],
    subpackages: [],
    webhooks: void 0,
    navigationConfig: void 0
  };
  addPackageRedirection({ from, to }) {
    const package_ = this.getPackageForFernFilepath(from);
    if (package_.navigationConfig != null) {
      throw new Error("Found duplicate navigationConfig for package");
    }
    package_.navigationConfig = {
      pointsTo: IdGenerator.generateSubpackageId(to)
    };
  }
  addDocs(fernFilepath, docs) {
    const package_ = this.getPackageForFernFilepath(fernFilepath);
    if (package_.docs != null) {
      throw new Error("Found duplicate docs for package");
    }
    package_.docs = docs;
  }
  addSubpackage(fernFilepath) {
    this.getPackageForFernFilepath(fernFilepath);
  }
  addType(typeId, type2) {
    this.getPackageForFernFilepath(type2.name.fernFilepath).types.push(typeId);
  }
  addError(errorId, error) {
    this.getPackageForFernFilepath(error.name.fernFilepath).errors.push(errorId);
  }
  addService(serviceId, service) {
    const package_ = this.getPackageForFernFilepath(service.name.fernFilepath);
    if (package_.service != null) {
      throw new Error("Found duplicate service for " + serviceId);
    }
    package_.service = serviceId;
  }
  addWebhookGroup(webhookGroupId, fernFilepath) {
    const package_ = this.getPackageForFernFilepath(fernFilepath);
    if (package_.webhooks != null) {
      throw new Error("Found duplicate webhook group for " + webhookGroupId);
    }
    package_.webhooks = webhookGroupId;
  }
  addWebSocketChannel(websocketChannelId, fernFilepath) {
    const package_ = this.getPackageForFernFilepath(fernFilepath);
    if (package_.webhooks != null) {
      throw new Error("Found duplicate webhook group for " + websocketChannelId);
    }
    package_.websocket = websocketChannelId;
  }
  build(filteredIr) {
    if (filteredIr != null) {
      Object.entries(this.subpackages).forEach(([subpackageId, subpackage]) => {
        if (!filteredIr.hasSubpackageId(subpackageId)) {
          delete this.subpackages[subpackageId];
        } else {
          this.subpackages[subpackageId] = {
            ...subpackage,
            types: subpackage.types.filter((typeId) => filteredIr.hasTypeId(typeId)),
            errors: subpackage.errors.filter((errorId) => filteredIr.hasErrorId(errorId)),
            service: subpackage.service != null ? filteredIr.hasServiceId(subpackage.service) ? subpackage.service : void 0 : void 0,
            subpackages: subpackage.subpackages.filter((subpackageId2) => filteredIr.hasSubpackageId(subpackageId2))
          };
        }
      });
      this.rootPackage = {
        ...this.rootPackage,
        types: this.rootPackage.types.filter((typeId) => filteredIr.hasTypeId(typeId)),
        errors: this.rootPackage.errors.filter((errorId) => filteredIr.hasErrorId(errorId)),
        service: this.rootPackage.service != null ? filteredIr.hasServiceId(this.rootPackage.service) ? this.rootPackage.service : void 0 : void 0,
        subpackages: this.rootPackage.subpackages.filter((subpackageId) => filteredIr.hasSubpackageId(subpackageId)),
        webhooks: this.rootPackage.webhooks != null ? this.rootPackage.webhooks : void 0
      };
    }
    const allSubpackagesWithEndpoints = new Set(this.getAllChildrenWithEndpoints(this.rootPackage));
    return {
      subpackages: mapValues_default(this.subpackages, (subpackage, subpackageId) => ({
        ...subpackage,
        hasEndpointsInTree: allSubpackagesWithEndpoints.has(subpackageId)
      })),
      rootPackage: {
        ...this.rootPackage,
        hasEndpointsInTree: allSubpackagesWithEndpoints.size > 0 || this.rootPackage.service != null
      }
    };
  }
  sortRootPackage(subpackagesInOrder) {
    if (!isEqualIgnoreOrder(this.rootPackage.subpackages, subpackagesInOrder)) {
      throw new Error("Sorted subpackages differ from unsorted packages in root");
    }
    this.rootPackage.subpackages = subpackagesInOrder;
  }
  sortSubpackage(subpackageId, subpackagesInOrder) {
    const subpackage = this.subpackages[subpackageId];
    if (subpackage == null) {
      throw new Error("Subpackage does not exist: " + subpackageId);
    }
    if (!isEqualIgnoreOrder(subpackage.subpackages, subpackagesInOrder)) {
      throw new Error("Sorted subpackages differ from unsorted packages");
    }
    subpackage.subpackages = subpackagesInOrder;
  }
  getAllSubpackagesWithEndpoints(root2) {
    const subpackage = this.subpackages[root2];
    if (subpackage == null) {
      throw new Error("Subpackage does not exist: " + root2);
    }
    const subpackagesWithEndpoints = this.getAllChildrenWithEndpoints(subpackage);
    if (subpackagesWithEndpoints.length > 0 || subpackage.service != null) {
      subpackagesWithEndpoints.push(root2);
    }
    return subpackagesWithEndpoints;
  }
  getAllChildrenWithEndpoints(package_) {
    return package_.subpackages.flatMap((child) => {
      return [...this.getAllSubpackagesWithEndpoints(child)];
    });
  }
  getPackageForFernFilepath(fernFilepath, index = 0, parent = this.rootPackage) {
    const nextPart = fernFilepath.allParts[index];
    if (nextPart == null) {
      return parent;
    }
    const subpackagesInParent = parent.subpackages.map((subpackageId) => {
      const subpackage = this.subpackages[subpackageId];
      if (subpackage == null) {
        throw new Error("Subpackage ID is invalid: " + subpackageId);
      }
      return subpackage;
    });
    const nextIndex = index + 1;
    const fernFilepathForNextParent = {
      allParts: fernFilepath.allParts.slice(0, nextIndex),
      packagePath: fernFilepath.packagePath.slice(0, nextIndex),
      file: nextIndex === fernFilepath.allParts.length ? fernFilepath.file : void 0
    };
    let nextParent = subpackagesInParent.find((subpackage) => subpackage.name.originalName === nextPart.originalName);
    if (nextParent == null) {
      const newParentId = IdGenerator.generateSubpackageId(fernFilepathForNextParent);
      const newParent = {
        docs: void 0,
        fernFilepath: fernFilepathForNextParent,
        name: nextPart,
        service: void 0,
        types: [],
        errors: [],
        subpackages: [],
        navigationConfig: void 0,
        webhooks: void 0,
        websocket: void 0
      };
      this.subpackages[newParentId] = newParent;
      parent.subpackages.push(newParentId);
      nextParent = newParent;
    }
    return this.getPackageForFernFilepath(fernFilepath, nextIndex, nextParent);
  }
};
function isEqualIgnoreOrder(a, b) {
  if (a.length !== b.length) {
    return false;
  }
  const aSet = new Set(a);
  for (const bElement of b) {
    if (!aSet.has(bElement)) {
      return false;
    }
  }
  return true;
}

// ../../cli/generation/ir-generator/lib/utils/parseReferenceToEndpointName.js
function parseReferenceToEndpointName({ reference, referencedIn, imports }) {
  const [firstPart, secondPart, ...rest] = reference.split(".");
  if (firstPart == null || rest.length > 0) {
    return void 0;
  }
  if (secondPart == null) {
    return {
      endpointName: firstPart,
      relativeFilepath: referencedIn
    };
  }
  const importAlias = firstPart;
  const importPath = imports[importAlias];
  if (importPath == null) {
    return void 0;
  }
  return {
    endpointName: secondPart,
    relativeFilepath: getResolvedPathOfImportedFile({ referencedIn, importPath })
  };
}

// ../../cli/generation/ir-generator/lib/resolvers/EndpointResolver.js
var EndpointResolverImpl = class {
  workspace;
  constructor(workspace) {
    this.workspace = workspace;
  }
  async resolveEndpointOrThrow({ endpoint, file }) {
    const resolvedEndpoint = await this.resolveEndpoint({ endpoint, file });
    if (resolvedEndpoint == null) {
      throw new Error("Cannot resolve endpoint: " + endpoint + " in file " + file.relativeFilepath);
    }
    return resolvedEndpoint;
  }
  async resolveEndpointByMethodAndPath({ method, path: path5 }) {
    let result = void 0;
    await visitAllDefinitionFiles(this.workspace, async (relativeFilepath, file, metadata) => {
      const context = constructFernFileContext({
        relativeFilepath,
        definitionFile: file,
        casingsGenerator: CASINGS_GENERATOR,
        rootApiFile: this.workspace.definition.rootApiFile.contents,
        defaultUrl: metadata.defaultUrl
      });
      for (const [endpointId, endpointDeclaration] of Object.entries(file.service?.endpoints ?? {})) {
        if (endpointDeclaration.method === method && endpointDeclaration.path === path5) {
          result = {
            endpointId,
            endpoint: endpointDeclaration,
            file: context
          };
        }
      }
    });
    await visitAllPackageMarkers(this.workspace, async (relativeFilepath, packageMarker) => {
      const context = constructFernFileContext({
        relativeFilepath,
        definitionFile: packageMarker,
        casingsGenerator: CASINGS_GENERATOR,
        rootApiFile: this.workspace.definition.rootApiFile.contents
      });
      for (const [endpointId, endpointDeclaration] of Object.entries(packageMarker.service?.endpoints ?? {})) {
        if (endpointDeclaration.method === method && endpointDeclaration.path === path5) {
          result = {
            endpointId,
            endpoint: endpointDeclaration,
            file: context
          };
        }
      }
    });
    return result;
  }
  async resolveEndpoint({ endpoint, file }) {
    const referenceParser = new HttpEndpointReferenceParser();
    const parsedEndpointReference = referenceParser.tryParse(endpoint);
    if (parsedEndpointReference != null) {
      return await this.resolveEndpointByMethodAndPath(parsedEndpointReference);
    }
    const maybeDeclaration = this.getDeclarationOfEndpoint({
      referenceToEndpoint: endpoint,
      file
    });
    if (maybeDeclaration == null) {
      return void 0;
    }
    const maybeEndpoint = maybeDeclaration.file.definitionFile.service?.endpoints?.[maybeDeclaration.endpointName];
    if (maybeEndpoint == null) {
      return void 0;
    }
    return {
      endpointId: maybeDeclaration.endpointName,
      endpoint: maybeEndpoint,
      file: maybeDeclaration.file
    };
  }
  getDeclarationOfEndpoint({ referenceToEndpoint, file }) {
    const parsedReference = parseReferenceToEndpointName({
      reference: referenceToEndpoint,
      referencedIn: file.relativeFilepath,
      imports: file.imports
    });
    if (parsedReference == null) {
      return void 0;
    }
    const definitionFile = getDefinitionFile(this.workspace, parsedReference.relativeFilepath);
    if (definitionFile == null) {
      return void 0;
    }
    const declaration = definitionFile.service?.endpoints?.[parsedReference.endpointName];
    if (declaration == null) {
      return void 0;
    }
    return {
      endpointName: parsedReference.endpointName,
      file: constructFernFileContext({
        relativeFilepath: parsedReference.relativeFilepath,
        definitionFile,
        casingsGenerator: file.casingsGenerator,
        rootApiFile: this.workspace.definition.rootApiFile.contents
      })
    };
  }
};

// ../../cli/generation/ir-generator/lib/resolvers/ErrorResolver.js
var ErrorResolverImpl = class {
  workspace;
  constructor(workspace) {
    this.workspace = workspace;
  }
  getDeclarationOrThrow(referenceToError, file) {
    const declaration = this.getDeclaration(referenceToError, file);
    if (declaration == null) {
      throw new Error("Error does not exist: " + referenceToError);
    }
    return declaration;
  }
  getDeclaration(referenceToError, file) {
    const parsedReference = parseReferenceToTypeName({
      reference: referenceToError,
      referencedIn: file.relativeFilepath,
      imports: file.imports
    });
    if (parsedReference == null) {
      return void 0;
    }
    const definitionFile = getDefinitionFile(this.workspace, parsedReference.relativeFilepath);
    if (definitionFile == null) {
      return void 0;
    }
    const declaration = definitionFile.errors?.[parsedReference.typeName];
    if (declaration == null) {
      return void 0;
    }
    return {
      declaration,
      file: constructFernFileContext({
        definitionFile,
        relativeFilepath: parsedReference.relativeFilepath,
        casingsGenerator: file.casingsGenerator,
        rootApiFile: this.workspace.definition.rootApiFile.contents
      })
    };
  }
};

// ../../cli/generation/ir-generator/lib/resolvers/ExampleResolver.js
var ExampleResolverImpl = class {
  typeResolver;
  constructor(typeResolver) {
    this.typeResolver = typeResolver;
  }
  resolveAllReferencesInExample({ example, file }) {
    if (typeof example === "string") {
      const resolvedExample = this.resolveExample({
        example,
        file
      });
      if (resolvedExample == null || typeof resolvedExample.resolvedExample === "string") {
        return resolvedExample;
      }
      return this.resolveAllReferencesInExample({
        example: resolvedExample.resolvedExample,
        file: resolvedExample.file
      });
    } else if (isPlainObject2(example)) {
      const newExample = {};
      for (const [exampleKey, exampleValue] of Object.entries(example)) {
        const resolvedExampleValue = this.resolveAllReferencesInExample({ example: exampleValue, file });
        if (resolvedExampleValue == null) {
          return void 0;
        }
        newExample[exampleKey] = resolvedExampleValue.resolvedExample;
      }
      return { resolvedExample: newExample };
    } else if (Array.isArray(example)) {
      const newExample = [];
      for (const exampleItem of example) {
        const resolvedExampleItem = this.resolveAllReferencesInExample({ example: exampleItem, file });
        if (resolvedExampleItem == null) {
          return void 0;
        }
        newExample.push(resolvedExampleItem.resolvedExample);
      }
      return { resolvedExample: newExample };
    }
    return { resolvedExample: example };
  }
  resolveAllReferencesInExampleOrThrow({ example, file }) {
    const resolvedExample = this.resolveAllReferencesInExample({ example, file });
    if (resolvedExample == null) {
      throw new Error("Failed to resolve examples");
    }
    return resolvedExample;
  }
  resolveExample({ example, file }) {
    if (typeof example !== "string") {
      return {
        resolvedExample: example,
        file
      };
    }
    if (example.startsWith(`\\${EXAMPLE_REFERENCE_PREFIX}`)) {
      return {
        // remove backslash
        resolvedExample: example.slice(1),
        file
      };
    }
    if (!example.startsWith(EXAMPLE_REFERENCE_PREFIX)) {
      return {
        resolvedExample: example,
        file
      };
    }
    const parsedExampleReference = this.parseExampleReference(example);
    if (parsedExampleReference == null) {
      return void 0;
    }
    const typeDeclaration = this.typeResolver.getDeclarationOfNamedType({
      referenceToNamedType: parsedExampleReference.rawTypeReference,
      file
    });
    if (typeDeclaration == null || typeof typeDeclaration.declaration === "string" || typeDeclaration.declaration.examples == null) {
      return void 0;
    }
    const resolvedExample = typeDeclaration.declaration.examples.find((otherExample) => otherExample.name === parsedExampleReference.exampleName);
    if (resolvedExample == null) {
      return void 0;
    }
    return this.resolveExample({ example: resolvedExample.value, file: typeDeclaration.file });
  }
  resolveExampleOrThrow({ example, file }) {
    const resolvedExample = this.resolveExample({ example, file });
    if (resolvedExample == null) {
      throw new Error("Cannot resolve example: " + example);
    }
    return resolvedExample;
  }
  parseExampleReference(exampleReference) {
    const [first, second, third, ...rest] = exampleReference.split(".");
    if (first == null || second == null || rest.length > 0) {
      return void 0;
    }
    if (third == null) {
      return {
        rawTypeReference: first.slice(EXAMPLE_REFERENCE_PREFIX.length),
        exampleName: second
      };
    }
    return {
      rawTypeReference: `${first}.${second}`.slice(EXAMPLE_REFERENCE_PREFIX.length),
      exampleName: third
    };
  }
};

// ../../cli/generation/ir-generator/lib/resolvers/PropertyResolver.js
var PropertyResolverImpl = class {
  typeResolver;
  endpointResolver;
  constructor(typeResolver, endpointResolver) {
    this.typeResolver = typeResolver;
    this.endpointResolver = endpointResolver;
    this.typeResolver = typeResolver;
    this.endpointResolver = endpointResolver;
  }
  async resolveRequestPropertyOrThrow({ file, endpoint, propertyComponents }) {
    const resolvedRequestProperty = await this.resolveRequestProperty({ file, endpoint, propertyComponents });
    if (resolvedRequestProperty == null) {
      throw new Error("Cannot resolve request property from endpoint: " + endpoint + " in file " + file.relativeFilepath);
    }
    return resolvedRequestProperty;
  }
  async resolveRequestProperty({ file, endpoint, propertyComponents }) {
    const resolvedEndpoint = await this.endpointResolver.resolveEndpointOrThrow({
      endpoint,
      file
    });
    if (resolvedEndpoint.endpoint.request == null) {
      return void 0;
    }
    if (typeof resolvedEndpoint.endpoint.request !== "string") {
      return this.resolveRequestPropertyFromInlinedRequest({
        typeResolver: this.typeResolver,
        file: resolvedEndpoint.file,
        requestType: resolvedEndpoint.endpoint.request,
        propertyComponents
      });
    }
    const objectProperty = await this.resolveObjectProperty({
      file: resolvedEndpoint.file,
      typeName: resolvedEndpoint.endpoint.request,
      propertyComponents
    });
    if (objectProperty == null) {
      return void 0;
    }
    return {
      propertyPath: await this.propertyPathFromPropertyComponents({
        propertyComponents,
        file
      }),
      property: RequestPropertyValue.body(objectProperty)
    };
  }
  async resolveResponsePropertyOrThrow({ file, endpoint, propertyComponents }) {
    const resolvedResponseProperty = await this.resolveResponseProperty({ file, endpoint, propertyComponents });
    if (resolvedResponseProperty == null) {
      throw new Error("Cannot resolve response property from endpoint: " + endpoint + " in file " + file.relativeFilepath);
    }
    return resolvedResponseProperty;
  }
  async resolveResponseProperty({ file, endpoint, propertyComponents }) {
    const resolvedEndpoint = await this.endpointResolver.resolveEndpointOrThrow({
      endpoint,
      file
    });
    const objectProperty = await this.resolveObjectProperty({
      file: resolvedEndpoint.file,
      typeName: (typeof resolvedEndpoint.endpoint.response !== "string" ? resolvedEndpoint.endpoint.response?.type : resolvedEndpoint.endpoint.response) ?? "",
      propertyComponents
    });
    if (objectProperty == null) {
      return void 0;
    }
    return {
      propertyPath: await this.propertyPathFromPropertyComponents({
        propertyComponents,
        file
      }),
      property: objectProperty
    };
  }
  async resolveRequestPropertyFromInlinedRequest({ typeResolver, file, requestType, propertyComponents }) {
    if (propertyComponents.length === 1) {
      const queryParameterKey = propertyComponents[0] ?? "";
      const queryParameter = typeof requestType["query-parameters"] != null ? requestType["query-parameters"]?.[queryParameterKey] : void 0;
      if (queryParameter != null) {
        return {
          property: RequestPropertyValue.query(await convertQueryParameter({
            file,
            queryParameterKey,
            queryParameter
          })),
          propertyPath: void 0
        };
      }
    }
    return this.resolveRequestPropertyFromInlinedRequestBody({
      typeResolver,
      file,
      requestType,
      propertyComponents
    });
  }
  async resolveRequestPropertyFromInlinedRequestBody({ typeResolver, file, requestType, propertyComponents }) {
    if (requestType.body == null) {
      return void 0;
    }
    if (typeof requestType.body === "string") {
      const objectProperty2 = await this.resolveObjectProperty({
        file,
        typeName: requestType.body,
        propertyComponents
      });
      if (objectProperty2 == null) {
        return void 0;
      }
      return {
        propertyPath: await this.propertyPathFromPropertyComponents({
          propertyComponents,
          file
        }),
        property: RequestPropertyValue.body(objectProperty2)
      };
    }
    if (isInlineRequestBody(requestType.body)) {
      const objectProperty2 = await getNestedObjectPropertyFromObjectSchema({
        typeResolver,
        file,
        objectSchema: requestType.body,
        propertyComponents
      });
      if (objectProperty2 == null) {
        return void 0;
      }
      return {
        propertyPath: await this.propertyPathFromPropertyComponents({
          propertyComponents,
          file
        }),
        property: RequestPropertyValue.body(objectProperty2)
      };
    }
    const objectProperty = await this.resolveObjectProperty({
      file,
      typeName: requestType.body.type,
      propertyComponents
    });
    if (objectProperty == null) {
      return void 0;
    }
    return {
      propertyPath: await this.propertyPathFromPropertyComponents({
        propertyComponents,
        file
      }),
      property: RequestPropertyValue.body(objectProperty)
    };
  }
  async resolveObjectProperty({ file, typeName, propertyComponents }) {
    const resolvedType = this.typeResolver.resolveTypeOrThrow({
      type: typeName,
      file
    });
    return await getNestedObjectPropertyFromResolvedType({
      typeResolver: this.typeResolver,
      file: maybeFileFromResolvedType(resolvedType) ?? file,
      resolvedType,
      propertyComponents
    });
  }
  async propertyPathFromPropertyComponents({ propertyComponents, file }) {
    if (propertyComponents.length <= 1) {
      return [];
    }
    return propertyComponents.slice(0, -1).map((property4) => file.casingsGenerator.generateName(property4));
  }
};

// ../../cli/generation/ir-generator/lib/resolvers/TypeResolver.js
var TypeResolverImpl = class {
  workspace;
  constructor(workspace) {
    this.workspace = workspace;
  }
  resolveTypeOrThrow({ type: type2, file }) {
    const resolvedType = this.resolveType({ type: type2, file });
    if (resolvedType == null) {
      throw new Error("Cannot resolve type: " + type2 + " in file " + file.relativeFilepath);
    }
    return resolvedType;
  }
  getDeclarationOfNamedTypeOrThrow({ referenceToNamedType, file }) {
    const declaration = this.getDeclarationOfNamedType({ referenceToNamedType, file });
    if (declaration == null) {
      throw new Error("Cannot find declaration of type: " + referenceToNamedType + " in file " + file.relativeFilepath);
    }
    return declaration;
  }
  getDeclarationOfNamedType({ referenceToNamedType, file }) {
    const parsedReference = parseReferenceToTypeName({
      reference: referenceToNamedType,
      referencedIn: file.relativeFilepath,
      imports: file.imports
    });
    if (parsedReference == null) {
      return void 0;
    }
    const definitionFile = getDefinitionFile(this.workspace, parsedReference.relativeFilepath);
    if (definitionFile == null) {
      return void 0;
    }
    const declaration = definitionFile.types?.[parsedReference.typeName];
    if (declaration == null) {
      const parsedGeneric = parseGeneric(parsedReference.typeName);
      if (parsedGeneric != null) {
        for (const type2 of Object.keys(definitionFile.types ?? {}) ?? []) {
          if (parsedGeneric.name && type2.startsWith(parsedGeneric.name) && type2.endsWith(">")) {
            const genericDeclaration = definitionFile.types?.[type2];
            return genericDeclaration != null ? {
              typeName: type2,
              declaration: genericDeclaration,
              file: constructFernFileContext({
                relativeFilepath: parsedReference.relativeFilepath,
                definitionFile,
                casingsGenerator: file.casingsGenerator,
                rootApiFile: this.workspace.definition.rootApiFile.contents
              })
            } : void 0;
          }
        }
      }
      return void 0;
    }
    return {
      typeName: parsedReference.typeName,
      declaration,
      file: constructFernFileContext({
        relativeFilepath: parsedReference.relativeFilepath,
        definitionFile,
        casingsGenerator: file.casingsGenerator,
        rootApiFile: this.workspace.definition.rootApiFile.contents
      })
    };
  }
  resolveType({ type: type2, file, objectPath = [] }) {
    return recursivelyVisitRawTypeReference({
      type: type2,
      _default: void 0,
      validation: void 0,
      visitor: {
        primitive: (primitive) => ({
          _type: "primitive",
          primitive,
          originalTypeReference: TypeReference2.primitive(primitive)
        }),
        unknown: () => ({ _type: "unknown", originalTypeReference: TypeReference2.unknown() }),
        map: ({ keyType, valueType }) => keyType != null && valueType != null ? {
          _type: "container",
          container: {
            _type: "map",
            keyType,
            valueType
          },
          originalTypeReference: TypeReference2.container(ContainerType.map({
            keyType: keyType.originalTypeReference,
            valueType: valueType.originalTypeReference
          }))
        } : void 0,
        list: (itemType) => itemType != null ? {
          _type: "container",
          container: {
            _type: "list",
            itemType
          },
          originalTypeReference: TypeReference2.container(ContainerType.list(itemType.originalTypeReference))
        } : void 0,
        optional: (itemType) => itemType != null ? {
          _type: "container",
          container: {
            _type: "optional",
            itemType
          },
          originalTypeReference: TypeReference2.container(ContainerType.optional(itemType.originalTypeReference))
        } : void 0,
        set: (itemType) => itemType != null ? {
          _type: "container",
          container: {
            _type: "set",
            itemType
          },
          originalTypeReference: TypeReference2.container(ContainerType.set(itemType.originalTypeReference))
        } : void 0,
        literal: (literal) => ({
          _type: "container",
          container: {
            _type: "literal",
            literal
          },
          originalTypeReference: TypeReference2.container(ContainerType.literal(literal))
        }),
        named: (referenceToNamedType) => {
          const maybeDeclaration = this.getDeclarationOfNamedType({
            referenceToNamedType,
            file
          });
          if (maybeDeclaration == null) {
            return void 0;
          }
          const newObjectPathItem = {
            typeName: maybeDeclaration.typeName,
            file: maybeDeclaration.file.relativeFilepath,
            reference: referenceToNamedType
          };
          if (objectPath.some((pathItem) => pathItem.file === newObjectPathItem.file && pathItem.typeName === newObjectPathItem.typeName)) {
            return void 0;
          }
          return this.resolveNamedTypeFromDeclaration({
            referenceToNamedType,
            referencedIn: file,
            rawDeclaration: maybeDeclaration,
            objectPath: [...objectPath, newObjectPathItem]
          });
        }
      }
    });
  }
  resolveNamedTypeOrThrow({ referenceToNamedType, file }) {
    const resolvedType = this.resolveNamedType({ referenceToNamedType, file });
    if (resolvedType == null) {
      throw new Error("Cannot resolve type: " + referenceToNamedType);
    }
    return resolvedType;
  }
  resolveNamedType({ referenceToNamedType, file }) {
    const maybeDeclaration = this.getDeclarationOfNamedType({
      referenceToNamedType,
      file
    });
    if (maybeDeclaration == null) {
      return void 0;
    }
    return this.resolveNamedTypeFromDeclaration({
      referenceToNamedType,
      referencedIn: file,
      rawDeclaration: maybeDeclaration
    });
  }
  resolveNamedTypeFromDeclaration({ referenceToNamedType, referencedIn, rawDeclaration, objectPath = [] }) {
    const { declaration, file: fileOfResolvedDeclaration } = rawDeclaration;
    if (isRawAliasDefinition(declaration)) {
      return this.resolveType({
        type: typeof declaration === "string" ? declaration : declaration.type,
        file: fileOfResolvedDeclaration,
        objectPath
      });
    }
    const parsedTypeReference = parseInlineType({
      type: referenceToNamedType,
      _default: void 0,
      validation: void 0,
      file: referencedIn
    });
    if (parsedTypeReference.type !== "named") {
      return void 0;
    }
    const definitionFile = getDefinitionFile(this.workspace, fileOfResolvedDeclaration.relativeFilepath);
    if (definitionFile == null) {
      return void 0;
    }
    return {
      _type: "named",
      rawName: rawDeclaration.typeName,
      name: parsedTypeReference,
      declaration,
      filepath: fileOfResolvedDeclaration.relativeFilepath,
      objectPath,
      originalTypeReference: parsedTypeReference,
      file: fileOfResolvedDeclaration
    };
  }
};

// ../../cli/generation/ir-generator/lib/resolvers/VariableResolver.js
var VariableResolverImpl = class _VariableResolverImpl {
  static VARIABLE_PREFIX = "$";
  getDeclarationOrThrow(referenceToVariable, file) {
    const declaration = this.getDeclaration(referenceToVariable, file);
    if (declaration == null) {
      throw new Error("Variable does not exist: " + referenceToVariable);
    }
    return declaration;
  }
  getDeclaration(referenceToVariable, file) {
    if (!referenceToVariable.startsWith(_VariableResolverImpl.VARIABLE_PREFIX)) {
      return void 0;
    }
    const declaration = file.rootApiFile.variables?.[referenceToVariable.substring(1)];
    if (declaration == null) {
      return void 0;
    }
    return {
      declaration,
      file: constructRootApiFileContext({
        casingsGenerator: file.casingsGenerator,
        rootApiFile: file.rootApiFile
      })
    };
  }
  getVariableIdOrThrow(referenceToVariable) {
    const variableId = this.getVariableId(referenceToVariable);
    if (variableId == null) {
      throw new Error("Variable reference does not start with " + _VariableResolverImpl.VARIABLE_PREFIX);
    }
    return variableId;
  }
  getVariableId(referenceToVariable) {
    if (!referenceToVariable.startsWith(_VariableResolverImpl.VARIABLE_PREFIX)) {
      return void 0;
    }
    return referenceToVariable.substring(_VariableResolverImpl.VARIABLE_PREFIX.length);
  }
};

// ../../cli/generation/ir-generator/lib/utils/getEnvironmentsByAudience.js
function getAudienceForEnvironment(environmentId, rawEnvironments) {
  if (rawEnvironments) {
    for (const [envId, environment] of Object.entries(rawEnvironments)) {
      if (typeof environment !== "string" && envId === environmentId) {
        return environment.audiences;
      }
    }
  }
  return void 0;
}

// ../../cli/generation/ir-generator/lib/examples/generator/generatePrimitiveExample.js
function generatePrimitiveExample({ fieldName, primitiveType }) {
  switch (primitiveType.v1) {
    case "STRING": {
      return generatePrimitiveStringExample({
        fieldName,
        validation: maybeStringValidation2(primitiveType.v2)
      });
    }
    case "BASE_64": {
      return { type: "success", example: ExamplePrimitive.base64(examples_exports.BASE64), jsonExample: examples_exports.BASE64 };
    }
    case "BOOLEAN": {
      return {
        type: "success",
        example: ExamplePrimitive.boolean(examples_exports.BOOLEAN),
        jsonExample: examples_exports.BOOLEAN
      };
    }
    case "DATE": {
      return { type: "success", example: ExamplePrimitive.date(examples_exports.DATE), jsonExample: examples_exports.DATE };
    }
    case "DATE_TIME": {
      return {
        type: "success",
        example: ExamplePrimitive.datetime({
          datetime: new Date(examples_exports.DATE_TIME),
          raw: examples_exports.DATE_TIME
        }),
        jsonExample: examples_exports.DATE_TIME
      };
    }
    case "DOUBLE": {
      return generatePrimitiveDoubleExample({
        fieldName,
        validation: maybeDoubleValidation(primitiveType.v2)
      });
    }
    case "FLOAT": {
      return { type: "success", example: ExamplePrimitive.float(examples_exports.FLOAT), jsonExample: examples_exports.FLOAT };
    }
    case "INTEGER": {
      return generatePrimitiveIntegerExample({
        fieldName,
        validation: maybeIntegerValidation(primitiveType.v2)
      });
    }
    case "UINT_64": {
      return { type: "success", example: ExamplePrimitive.uint64(examples_exports.INT64), jsonExample: examples_exports.INT64 };
    }
    case "UINT": {
      return { type: "success", example: ExamplePrimitive.uint(examples_exports.UINT), jsonExample: examples_exports.UINT };
    }
    case "BIG_INTEGER": {
      return {
        type: "success",
        example: ExamplePrimitive.bigInteger(examples_exports.INT64.toString()),
        jsonExample: `${examples_exports.INT64}`
      };
    }
    case "LONG": {
      return { type: "success", example: ExamplePrimitive.long(examples_exports.INT64), jsonExample: examples_exports.INT64 };
    }
    case "UUID": {
      return { type: "success", example: ExamplePrimitive.uuid(examples_exports.UUID), jsonExample: examples_exports.UUID };
    }
    default:
      assertNever(primitiveType.v1);
  }
}
function maybeStringValidation2(v2) {
  if (v2?.type === "string") {
    const stringType2 = v2;
    return stringType2.validation;
  }
  return void 0;
}
function maybeDoubleValidation(v2) {
  if (v2?.type === "double") {
    const doubleType = v2;
    return doubleType.validation;
  }
  return void 0;
}
function maybeIntegerValidation(v2) {
  if (v2?.type === "integer") {
    const integerType = v2;
    return integerType.validation;
  }
  return void 0;
}
function getStringExampleOfLength(length) {
  if (length <= examples_exports.SAMPLE_STRINGS.length) {
    const sampleString = examples_exports.SAMPLE_STRINGS[length - 1];
    if (sampleString) {
      return sampleString;
    } else {
      throw new Error(`Unexpected undefined value in SAMPLE_STRINGS at index ${length - 1}`);
    }
  }
  return examples_exports.SAMPLE_STRINGS[examples_exports.SAMPLE_STRINGS.length - 1] + ".".repeat(length - examples_exports.SAMPLE_STRINGS.length);
}
function generatePrimitiveStringExample({ fieldName, validation }) {
  if (validation) {
    const minLength = validation.minLength;
    const maxLength = validation.maxLength;
    if (minLength) {
      const minLengthExample = getStringExampleOfLength(minLength);
      return {
        type: "success",
        example: ExamplePrimitive.string({ original: minLengthExample }),
        jsonExample: minLengthExample
      };
    } else if (maxLength) {
      const maxLengthExample = getStringExampleOfLength(maxLength);
      return {
        type: "success",
        example: ExamplePrimitive.string({ original: maxLengthExample }),
        jsonExample: maxLengthExample
      };
    }
  }
  const jsonExample = fieldName ?? examples_exports.STRING;
  return { type: "success", example: ExamplePrimitive.string({ original: jsonExample }), jsonExample };
}
function generatePrimitiveDoubleExample({ fieldName, validation }) {
  if (validation) {
    const maximum = validation.max;
    const minimum = validation.min;
    if (maximum) {
      return { type: "success", example: ExamplePrimitive.double(maximum), jsonExample: maximum };
    } else if (minimum) {
      return { type: "success", example: ExamplePrimitive.double(minimum), jsonExample: minimum };
    }
  }
  return { type: "success", example: ExamplePrimitive.double(examples_exports.DOUBLE), jsonExample: examples_exports.DOUBLE };
}
function generatePrimitiveIntegerExample({ fieldName, validation }) {
  if (validation) {
    const maximum = validation.max;
    const minimum = validation.min;
    if (maximum) {
      return { type: "success", example: ExamplePrimitive.integer(maximum), jsonExample: maximum };
    } else if (minimum) {
      return { type: "success", example: ExamplePrimitive.integer(minimum), jsonExample: minimum };
    }
  }
  return { type: "success", example: ExamplePrimitive.integer(examples_exports.INT), jsonExample: examples_exports.INT };
}

// ../../cli/generation/ir-generator/lib/examples/generator/generateContainerExample.js
function generateContainerExample({ fieldName, containerType, maxDepth, currentDepth, typeDeclarations, skipOptionalProperties }) {
  if (currentDepth >= maxDepth) {
    return generateEmptyContainerExample({ containerType });
  }
  switch (containerType.type) {
    case "list": {
      const example = generateTypeReferenceExample({
        fieldName,
        typeReference: containerType.list,
        maxDepth,
        currentDepth: currentDepth + 1,
        typeDeclarations,
        skipOptionalProperties
      });
      if (example.type === "failure") {
        return generateEmptyContainerExample({ containerType });
      }
      return {
        type: "success",
        example: ExampleContainer.list({
          list: [example.example, example.example],
          itemType: containerType.list
        }),
        jsonExample: [example.jsonExample, example.jsonExample]
      };
    }
    case "literal": {
      return {
        type: "success",
        example: ExampleContainer.literal({
          literal: containerType.literal._visit({
            boolean: (value) => ExamplePrimitive.boolean(value),
            string: (value) => ExamplePrimitive.string({ original: value }),
            _other: () => {
              throw new Error("Encountered unknown literal type");
            }
          })
        }),
        jsonExample: containerType.literal._visit({
          boolean: (value) => value,
          string: (value) => value,
          _other: () => {
            throw new Error("Encountered unknown literal type");
          }
        })
      };
    }
    case "optional": {
      if (skipOptionalProperties) {
        return generateEmptyContainerExample({ containerType });
      }
      const example = generateTypeReferenceExample({
        fieldName,
        typeReference: containerType.optional,
        maxDepth,
        currentDepth: currentDepth + 1,
        typeDeclarations,
        skipOptionalProperties
      });
      if (example.type === "failure") {
        return generateEmptyContainerExample({ containerType });
      }
      return {
        type: "success",
        example: ExampleContainer.optional({
          optional: example.example,
          valueType: containerType.optional
        }),
        jsonExample: example.jsonExample
      };
    }
    case "set": {
      const example = generateTypeReferenceExample({
        fieldName,
        typeReference: containerType.set,
        maxDepth,
        currentDepth: currentDepth + 1,
        typeDeclarations,
        skipOptionalProperties
      });
      if (example.type === "failure") {
        return generateEmptyContainerExample({ containerType });
      }
      return {
        type: "success",
        example: ExampleContainer.set({
          set: [example.example],
          itemType: containerType.set
        }),
        jsonExample: [example.jsonExample]
      };
    }
    case "map": {
      const keyExample = generateTypeReferenceExample({
        fieldName,
        typeReference: containerType.keyType,
        maxDepth,
        currentDepth: currentDepth + 1,
        typeDeclarations,
        skipOptionalProperties
      });
      const valueExample = generateTypeReferenceExample({
        fieldName,
        typeReference: containerType.valueType,
        maxDepth,
        currentDepth: currentDepth + 1,
        typeDeclarations,
        skipOptionalProperties
      });
      if (keyExample.type === "failure" || valueExample.type === "failure") {
        return generateEmptyContainerExample({ containerType });
      }
      return {
        type: "success",
        example: ExampleContainer.map({
          map: [
            {
              key: keyExample.example,
              value: valueExample.example
            }
          ],
          keyType: containerType.keyType,
          valueType: containerType.valueType
        }),
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        jsonExample: { [keyExample.jsonExample]: valueExample.jsonExample }
      };
    }
    default:
      assertNever(containerType);
  }
}
function generateEmptyContainerExample({ containerType }) {
  switch (containerType.type) {
    case "list": {
      return {
        type: "success",
        example: ExampleContainer.list({
          list: [],
          itemType: containerType.list
        }),
        jsonExample: []
      };
    }
    case "literal": {
      return {
        type: "success",
        example: ExampleContainer.literal({
          literal: containerType.literal._visit({
            boolean: (value) => ExamplePrimitive.boolean(value),
            string: (value) => ExamplePrimitive.string({ original: value }),
            _other: () => {
              throw new Error("Encountered unknown literal type");
            }
          })
        }),
        jsonExample: containerType.literal._visit({
          boolean: (value) => value,
          string: (value) => value,
          _other: () => {
            throw new Error("Encountered unknown literal type");
          }
        })
      };
    }
    case "optional": {
      return {
        type: "success",
        example: ExampleContainer.optional({
          optional: void 0,
          valueType: containerType.optional
        }),
        jsonExample: void 0
      };
    }
    case "set": {
      return {
        type: "success",
        example: ExampleContainer.set({
          set: [],
          itemType: containerType.set
        }),
        jsonExample: []
      };
    }
    case "map": {
      return {
        type: "success",
        example: ExampleContainer.map({
          map: [],
          keyType: containerType.keyType,
          valueType: containerType.valueType
        }),
        jsonExample: {}
      };
    }
    default:
      assertNever(containerType);
  }
}

// ../../cli/generation/ir-generator/lib/examples/generator/isTypeReferenceOptional.js
function isOptional({ typeReference, typeDeclarations }) {
  if (typeReference.type === "container" && typeReference.container.type === "optional") {
    return true;
  }
  if (typeReference.type === "named") {
    const typeDeclaration = typeDeclarations[typeReference.typeId];
    if (typeDeclaration?.shape.type === "alias" && typeDeclaration?.shape.resolvedType.type === "container" && typeDeclaration?.shape.resolvedType.container.type === "optional") {
      return true;
    }
  }
  return false;
}

// ../../cli/generation/ir-generator/lib/examples/generator/generateTypeDeclarationExample.js
function generateTypeDeclarationExample({ fieldName, typeDeclarations, typeDeclaration, maxDepth, currentDepth, skipOptionalProperties }) {
  switch (typeDeclaration.shape.type) {
    case "alias": {
      const generatedExample = generateTypeReferenceExample({
        fieldName,
        typeDeclarations,
        typeReference: typeDeclaration.shape.aliasOf,
        maxDepth,
        currentDepth,
        skipOptionalProperties
      });
      if (generatedExample.type === "failure") {
        return generatedExample;
      }
      const { example, jsonExample } = generatedExample;
      return {
        type: "success",
        example: ExampleTypeShape.alias({
          value: example
        }),
        jsonExample
      };
    }
    case "enum": {
      const enumValue = typeDeclaration.shape.values[0];
      if (enumValue == null) {
        return { type: "failure", message: "No enum values present" };
      }
      return {
        type: "success",
        example: ExampleTypeShape.enum({
          value: enumValue.name
        }),
        jsonExample: enumValue.name.wireValue
      };
    }
    case "object": {
      const objectExample = generateObjectDeclarationExample({
        fieldName,
        typeDeclaration,
        objectTypeDeclaration: typeDeclaration.shape,
        typeDeclarations,
        currentDepth,
        maxDepth,
        skipOptionalProperties
      });
      if (objectExample.type === "failure") {
        return objectExample;
      }
      const { example, jsonExample } = objectExample;
      return {
        type: "success",
        example: ExampleTypeShape.object(example),
        jsonExample
      };
    }
    case "undiscriminatedUnion": {
      let i = 0;
      for (const variant of typeDeclaration.shape.members) {
        const variantExample = generateTypeReferenceExample({
          fieldName,
          typeReference: variant.type,
          typeDeclarations,
          currentDepth: currentDepth + 1,
          maxDepth,
          skipOptionalProperties
        });
        if (variantExample.type === "failure") {
          ++i;
          continue;
        }
        const { example, jsonExample } = variantExample;
        return {
          type: "success",
          example: ExampleTypeShape.undiscriminatedUnion({
            index: i,
            singleUnionType: example
          }),
          jsonExample
        };
      }
      break;
    }
    case "union": {
      const discriminant3 = typeDeclaration.shape.discriminant;
      for (const variant of typeDeclaration.shape.types) {
        const variantExample = variant.shape._visit({
          noProperties: () => {
            return {
              type: "success",
              example: ExampleTypeShape.union({
                discriminant: discriminant3,
                singleUnionType: {
                  wireDiscriminantValue: variant.discriminantValue,
                  shape: ExampleSingleUnionTypeProperties.noProperties()
                }
              }),
              jsonExample: {
                [discriminant3.wireValue]: variant.discriminantValue.wireValue
              }
            };
          },
          samePropertiesAsObject: (samePropertiesAsObject) => {
            const typeDeclaration2 = typeDeclarations[samePropertiesAsObject.typeId];
            if (typeDeclaration2 == null) {
              throw new Error(`Failed to find type declaration with id ${samePropertiesAsObject.typeId}`);
            }
            if (typeDeclaration2.shape.type !== "object") {
              throw new Error(`Same properties as object union is not an object ${typeDeclaration2.shape.type}`);
            }
            const objectExample = generateObjectDeclarationExample({
              currentDepth,
              maxDepth,
              fieldName,
              objectTypeDeclaration: typeDeclaration2.shape,
              typeDeclaration: typeDeclaration2,
              typeDeclarations,
              skipOptionalProperties
            });
            if (objectExample.type === "failure") {
              return objectExample;
            }
            const { example, jsonExample } = objectExample;
            return {
              type: "success",
              example: ExampleTypeShape.union({
                discriminant: discriminant3,
                singleUnionType: {
                  wireDiscriminantValue: variant.discriminantValue,
                  shape: ExampleSingleUnionTypeProperties.samePropertiesAsObject({
                    typeId: typeDeclaration2.name.typeId,
                    object: example
                  })
                }
              }),
              jsonExample: {
                [discriminant3.wireValue]: variant.discriminantValue.wireValue,
                ...typeof jsonExample === "object" ? jsonExample : {}
              }
            };
          },
          singleProperty: (value) => {
            const singlePropertyExample = generateTypeReferenceExample({
              currentDepth: currentDepth + 1,
              maxDepth,
              fieldName,
              typeReference: value.type,
              typeDeclarations,
              skipOptionalProperties
            });
            if (singlePropertyExample.type === "failure") {
              return singlePropertyExample;
            }
            const { example, jsonExample } = singlePropertyExample;
            return {
              type: "success",
              example: ExampleTypeShape.union({
                discriminant: discriminant3,
                singleUnionType: {
                  wireDiscriminantValue: variant.discriminantValue,
                  shape: ExampleSingleUnionTypeProperties.singleProperty(example)
                }
              }),
              jsonExample: {
                [discriminant3.wireValue]: variant.discriminantValue.wireValue,
                [value.name.wireValue]: jsonExample
              }
            };
          },
          _other: () => {
            throw new Error("Encountered unknown union type");
          }
        });
        if (variantExample.type === "failure") {
          continue;
        }
        return variantExample;
      }
    }
  }
  return { type: "failure", message: "Failed to generate example for type reference" };
}
function generateObjectDeclarationExample({ fieldName, typeDeclaration, objectTypeDeclaration, typeDeclarations, maxDepth, currentDepth, skipOptionalProperties }) {
  const jsonExample = {};
  const properties = [];
  for (const property4 of [
    ...objectTypeDeclaration.properties ?? [],
    ...objectTypeDeclaration.extendedProperties ?? []
  ]) {
    const propertyExample = generateTypeReferenceExample({
      fieldName: property4.name.wireValue,
      typeReference: property4.valueType,
      typeDeclarations,
      currentDepth: currentDepth + 1,
      maxDepth,
      skipOptionalProperties
    });
    if (propertyExample.type === "failure" && !isOptional({ typeDeclarations, typeReference: property4.valueType })) {
      return {
        type: "failure",
        message: `Failed to generate required property ${property4.name.wireValue} b/c ${propertyExample.message}`
      };
    } else if (propertyExample.type === "failure") {
      continue;
    }
    const { example, jsonExample: propertyJsonExample } = propertyExample;
    properties.push({
      name: property4.name,
      originalTypeDeclaration: typeDeclaration.name,
      value: example
    });
    jsonExample[property4.name.wireValue] = propertyJsonExample;
  }
  return {
    type: "success",
    example: ExampleTypeShape.object({
      properties
    }),
    jsonExample
  };
}

// ../../cli/generation/ir-generator/lib/examples/generator/generateTypeReferenceExample.js
function generateTypeReferenceExample({ fieldName, typeReference, typeDeclarations, maxDepth, currentDepth, skipOptionalProperties }) {
  if (currentDepth > maxDepth) {
    return { type: "failure", message: "Exceeded max depth" };
  }
  switch (typeReference.type) {
    case "named": {
      const typeDeclaration = typeDeclarations[typeReference.typeId];
      if (typeDeclaration == null) {
        throw new Error(`Failed to find type declaration with id ${typeReference.typeId}`);
      }
      const generatedExample = generateTypeDeclarationExample({
        fieldName,
        typeDeclaration,
        typeDeclarations,
        maxDepth,
        currentDepth,
        skipOptionalProperties
      });
      if (generatedExample.type === "failure") {
        return generatedExample;
      }
      const { example, jsonExample } = generatedExample;
      return {
        type: "success",
        example: {
          jsonExample,
          shape: ExampleTypeReferenceShape.named({
            shape: example,
            typeName: typeDeclaration.name
          })
        },
        jsonExample
      };
    }
    case "container": {
      const generatedExample = generateContainerExample({
        fieldName,
        containerType: typeReference.container,
        typeDeclarations,
        maxDepth,
        currentDepth,
        skipOptionalProperties
      });
      if (generatedExample.type === "failure") {
        const { example: example2, jsonExample: jsonExample2 } = generateEmptyContainerExample({
          containerType: typeReference.container
        });
        return {
          type: "success",
          example: {
            jsonExample: jsonExample2,
            shape: ExampleTypeReferenceShape.container(example2)
          },
          jsonExample: jsonExample2
        };
      }
      const { example, jsonExample } = generatedExample;
      return {
        type: "success",
        example: {
          jsonExample,
          shape: ExampleTypeReferenceShape.container(example)
        },
        jsonExample
      };
    }
    case "primitive": {
      const { jsonExample, example } = generatePrimitiveExample({
        fieldName,
        primitiveType: typeReference.primitive
      });
      return {
        type: "success",
        example: {
          jsonExample,
          shape: ExampleTypeReferenceShape.primitive(example)
        },
        jsonExample
      };
    }
    case "unknown": {
      const jsonExample = { key: "value" };
      return {
        type: "success",
        example: {
          jsonExample,
          shape: ExampleTypeReferenceShape.unknown(jsonExample)
        },
        jsonExample
      };
    }
  }
}

// ../../cli/generation/ir-generator/lib/examples/generator/generateSuccessEndpointExample.js
var import_object_hash = __toESM(require_object_hash(), 1);
function generateEndpointExample({ ir, endpoint, service, typeDeclarations, skipOptionalRequestProperties, generationResponse }) {
  const result = {
    name: void 0,
    endpointHeaders: [],
    endpointPathParameters: [],
    queryParameters: [],
    servicePathParameters: [],
    serviceHeaders: [],
    rootPathParameters: [],
    request: void 0,
    response: ExampleResponse.ok(ExampleEndpointSuccessResponse.body(void 0)),
    docs: void 0
  };
  const pathParameterGroups = [
    {
      params: endpoint.pathParameters,
      add: (example) => result.endpointPathParameters.push(example)
    },
    {
      params: service.pathParameters,
      add: (example) => result.servicePathParameters.push(example)
    },
    {
      params: ir.pathParameters,
      add: (example) => result.rootPathParameters.push(example)
    }
  ];
  for (const group of pathParameterGroups) {
    for (const pathParameter of group.params) {
      const generatedExample = generateTypeReferenceExample({
        fieldName: pathParameter.name.originalName,
        currentDepth: 0,
        maxDepth: 1,
        typeDeclarations,
        typeReference: pathParameter.valueType,
        skipOptionalProperties: skipOptionalRequestProperties
      });
      if (generatedExample.type === "failure") {
        return generatedExample;
      }
      const { example } = generatedExample;
      group.add({
        name: pathParameter.name,
        value: example
      });
    }
  }
  for (const queryParameter of endpoint.queryParameters) {
    if (skipOptionalRequestProperties && isOptional({ typeDeclarations, typeReference: queryParameter.valueType })) {
      continue;
    }
    const generatedExample = generateTypeReferenceExample({
      fieldName: queryParameter.name.name.originalName,
      currentDepth: 0,
      maxDepth: 1,
      typeDeclarations,
      typeReference: queryParameter.valueType,
      skipOptionalProperties: skipOptionalRequestProperties
    });
    if (generatedExample.type === "failure") {
      return generatedExample;
    }
    const { example } = generatedExample;
    result.queryParameters.push({
      name: queryParameter.name,
      shape: queryParameter.allowMultiple ? ExampleQueryParameterShape.exploded() : ExampleQueryParameterShape.single(),
      value: example
    });
  }
  const headerGroup = [
    {
      params: endpoint.headers,
      add: (example) => result.endpointHeaders.push(example)
    },
    {
      params: service.headers,
      add: (example) => result.serviceHeaders.push(example)
    }
  ];
  for (const group of headerGroup) {
    for (const header of group.params) {
      if (skipOptionalRequestProperties && isOptional({ typeDeclarations, typeReference: header.valueType })) {
        continue;
      }
      const generatedExample = generateTypeReferenceExample({
        fieldName: header.name.name.originalName,
        currentDepth: 0,
        maxDepth: 1,
        typeDeclarations,
        typeReference: header.valueType,
        skipOptionalProperties: skipOptionalRequestProperties
      });
      if (generatedExample.type === "failure") {
        return generatedExample;
      }
      const { example } = generatedExample;
      group.add({
        name: header.name,
        value: example
      });
    }
  }
  if (endpoint.requestBody != null) {
    switch (endpoint.requestBody.type) {
      case "bytes":
        return { type: "failure", message: "Bytes request unsupported" };
      case "fileUpload":
        return { type: "failure", message: "File upload unsupported" };
      case "inlinedRequestBody": {
        const jsonExample = {};
        const properties = [];
        for (const property4 of [
          ...endpoint.requestBody.properties ?? [],
          ...endpoint.requestBody.extendedProperties ?? []
        ]) {
          const propertyExample = generateTypeReferenceExample({
            fieldName: property4.name.wireValue,
            typeReference: property4.valueType,
            typeDeclarations,
            currentDepth: 1,
            maxDepth: 10,
            skipOptionalProperties: skipOptionalRequestProperties
          });
          if (propertyExample.type === "failure" && !isOptional({ typeDeclarations, typeReference: property4.valueType })) {
            return {
              type: "failure",
              message: `Failed to generate required property ${property4.name.wireValue} b/c ${propertyExample.message}`
            };
          } else if (propertyExample.type === "failure") {
            continue;
          }
          const { example, jsonExample: propertyJsonExample } = propertyExample;
          properties.push({
            name: property4.name,
            originalTypeDeclaration: void 0,
            value: example
          });
          jsonExample[property4.name.wireValue] = propertyJsonExample;
        }
        result.request = ExampleRequestBody.inlinedRequestBody({
          jsonExample,
          properties
        });
        break;
      }
      case "reference": {
        const generatedExample = generateTypeReferenceExample({
          currentDepth: 0,
          maxDepth: 10,
          typeDeclarations,
          typeReference: endpoint.requestBody.requestBodyType,
          skipOptionalProperties: skipOptionalRequestProperties
        });
        if (generatedExample.type === "failure") {
          return generatedExample;
        }
        const { example } = generatedExample;
        result.request = ExampleRequestBody.reference(example);
        break;
      }
      default:
        assertNever(endpoint.requestBody);
    }
  }
  if (generationResponse.type === "success" && endpoint.response?.body != null) {
    switch (endpoint.response.body.type) {
      case "fileDownload":
        return { type: "failure", message: "File download unsupported" };
      case "json": {
        const generatedExample = generateTypeReferenceExample({
          currentDepth: 0,
          maxDepth: 10,
          typeDeclarations,
          typeReference: endpoint.response.body.value.responseBodyType,
          skipOptionalProperties: false
        });
        if (generatedExample.type === "failure") {
          return generatedExample;
        }
        const { example, jsonExample } = generatedExample;
        result.response = ExampleResponse.ok(ExampleEndpointSuccessResponse.body({ ...example, jsonExample }));
        break;
      }
      case "streamParameter":
        return { type: "failure", message: "Stream parameter unsupported" };
      case "streaming":
        return { type: "failure", message: "Streaming unsupported" };
      case "text":
        return { type: "failure", message: "Text unsupported" };
      default:
        assertNever(endpoint.response.body);
    }
  } else if (generationResponse.type === "error") {
    if (generationResponse.declaration.type == null) {
      result.response = ExampleResponse.error({
        body: void 0,
        error: generationResponse.declaration.name
      });
    } else {
      const generatedExample = generateTypeReferenceExample({
        currentDepth: 0,
        maxDepth: 10,
        typeDeclarations,
        typeReference: generationResponse.declaration.type,
        skipOptionalProperties: skipOptionalRequestProperties
      });
      if (generatedExample.type === "failure") {
        return generatedExample;
      }
      const { example } = generatedExample;
      result.response = ExampleResponse.error({
        body: example,
        error: generationResponse.declaration.name
      });
    }
  }
  return {
    type: "success",
    example: {
      id: (0, import_object_hash.default)(result),
      url: getUrlForExample(endpoint, result),
      ...result
    },
    jsonExample: void 0
    // dummmy
  };
}
function getUrlForExample(endpoint, example) {
  const pathParameters = {};
  [...example.rootPathParameters, ...example.servicePathParameters, ...example.endpointPathParameters].forEach((examplePathParameter) => {
    const value = examplePathParameter.value.jsonExample;
    const stringValue = typeof value === "string" ? value : JSON.stringify(value);
    pathParameters[examplePathParameter.name.originalName] = stringValue;
  });
  const url = endpoint.fullPath.head + endpoint.fullPath.parts.map((pathPart) => pathParameters[pathPart.pathParameter] + pathPart.tail).join("");
  return url.startsWith("/") || url === "" ? url : `/${url}`;
}

// ../../cli/generation/ir-generator/lib/dynamic-snippets/version.js
var Version = "1.0.0";

// ../../cli/generation/ir-generator/lib/dynamic-snippets/DynamicSnippetsConverter.js
var DynamicSnippetsConverter = class {
  ir;
  auth;
  constructor(ir) {
    this.ir = ir;
    this.auth = this.convertAuth(ir.auth);
  }
  convert() {
    return {
      version: Version,
      types: this.convertNamedTypes(),
      headers: this.convertHeaders(),
      endpoints: this.convertEndpoints()
    };
  }
  convertNamedTypes() {
    return Object.fromEntries(Object.entries(this.ir.types).map(([typeId, typeDeclaration]) => [
      typeId,
      this.convertTypeDeclaration(typeDeclaration)
    ]));
  }
  convertHeaders() {
    return this.convertWireValueParameters({ wireValueParameters: this.ir.headers });
  }
  convertEndpoints() {
    const endpoints = this.getAllHttpEndpoints();
    return Object.fromEntries(endpoints.map((endpoint) => [endpoint.id, this.convertEndpoint(endpoint)]));
  }
  convertEndpoint(endpoint) {
    return {
      auth: this.auth,
      declaration: this.convertDeclaration({ name: endpoint.name, fernFilepath: endpoint.fernFilepath }),
      location: this.convertEndpointLocation({ endpoint }),
      request: this.convertRequest({ endpoint }),
      response: dynamic_exports.Response.json()
    };
  }
  convertRequest({ endpoint }) {
    const pathParameters = this.convertPathParameters({ pathParameters: endpoint.allPathParameters });
    if (endpoint.sdkRequest == null && endpoint.requestBody == null) {
      return dynamic_exports.Request.body({ pathParameters, body: void 0 });
    }
    if (endpoint.sdkRequest == null) {
      throw new Error(`Internal error; endpoint "${endpoint.id}" has a request body but no SDK request`);
    }
    switch (endpoint.sdkRequest.shape.type) {
      case "justRequestBody":
        return dynamic_exports.Request.body({
          pathParameters,
          body: this.convertReferencedRequestBodyType({ body: endpoint.sdkRequest.shape.value })
        });
      case "wrapper":
        return this.convertInlinedRequest({
          fernFilepath: endpoint.fernFilepath,
          wrapper: endpoint.sdkRequest.shape,
          pathParameters,
          queryParameters: this.convertQueryParameters({ queryParameters: endpoint.queryParameters }),
          headers: this.convertWireValueParameters({
            wireValueParameters: [...endpoint.serviceHeaders, ...endpoint.headers]
          }),
          body: endpoint.requestBody
        });
      default:
        assertNever(endpoint.sdkRequest.shape);
    }
  }
  convertReferencedRequestBodyType({ body }) {
    switch (body.type) {
      case "bytes":
        return dynamic_exports.ReferencedRequestBodyType.bytes();
      case "typeReference":
        return dynamic_exports.ReferencedRequestBodyType.typeReference(this.convertTypeReference(body.requestBodyType));
      default:
        assertNever(body);
    }
  }
  convertInlinedRequest({ fernFilepath, wrapper, pathParameters, queryParameters, headers, body }) {
    return dynamic_exports.Request.inlined({
      declaration: this.convertDeclaration({ name: wrapper.wrapperName, fernFilepath }),
      pathParameters,
      queryParameters,
      headers,
      body: body != null ? this.convertInlinedRequestBody({ wrapper, body }) : void 0,
      metadata: this.convertInlinedRequestMetadata({ wrapper })
    });
  }
  convertInlinedRequestMetadata({ wrapper }) {
    return {
      includePathParameters: wrapper.includePathParameters ?? false,
      onlyPathParameters: wrapper.onlyPathParameters ?? false
    };
  }
  convertInlinedRequestBody({ wrapper, body }) {
    switch (body.type) {
      case "inlinedRequestBody": {
        const properties = [...body.extendedProperties ?? [], ...body.properties];
        return dynamic_exports.InlinedRequestBody.properties(this.convertWireValueParameters({ wireValueParameters: properties }));
      }
      case "reference":
        return dynamic_exports.InlinedRequestBody.referenced({
          bodyKey: wrapper.bodyKey,
          bodyType: dynamic_exports.ReferencedRequestBodyType.typeReference(this.convertTypeReference(body.requestBodyType))
        });
      case "bytes":
        return dynamic_exports.InlinedRequestBody.referenced({
          bodyKey: wrapper.bodyKey,
          bodyType: dynamic_exports.ReferencedRequestBodyType.bytes()
        });
      case "fileUpload":
        return this.convertFileUploadRequestBody({ properties: body.properties });
      default:
        assertNever(body);
    }
  }
  convertFileUploadRequestBody({ properties }) {
    return dynamic_exports.InlinedRequestBody.fileUpload({
      properties: this.convertFileUploadRequestBodyProperties({ properties })
    });
  }
  convertFileUploadRequestBodyProperties({ properties }) {
    return properties.map((property4) => {
      switch (property4.type) {
        case "file":
          return this.convertFileUploadRequestBodyFileProperty({ fileProperty: property4.value });
        case "bodyProperty":
          return dynamic_exports.FileUploadRequestBodyProperty.bodyProperty({
            name: property4.name,
            typeReference: this.convertTypeReference(property4.valueType)
          });
        default:
          assertNever(property4);
      }
    });
  }
  convertFileUploadRequestBodyFileProperty({ fileProperty }) {
    switch (fileProperty.type) {
      case "file":
        return dynamic_exports.FileUploadRequestBodyProperty.file(fileProperty.key);
      case "fileArray":
        return dynamic_exports.FileUploadRequestBodyProperty.fileArray(fileProperty.key);
      default:
        assertNever(fileProperty);
    }
  }
  convertPathParameters({ pathParameters }) {
    return pathParameters.map((pathParameter) => ({
      name: {
        name: pathParameter.name,
        wireValue: pathParameter.name.originalName
      },
      typeReference: this.convertTypeReference(pathParameter.valueType)
    }));
  }
  convertWireValueParameters({ wireValueParameters }) {
    return wireValueParameters.map((parameter) => ({
      name: {
        name: parameter.name.name,
        wireValue: parameter.name.wireValue
      },
      typeReference: this.convertTypeReference(parameter.valueType)
    }));
  }
  convertQueryParameters({ queryParameters }) {
    const parameters = [];
    for (const queryParameter of queryParameters) {
      let typeReference = this.convertTypeReference(queryParameter.valueType);
      if (queryParameter.allowMultiple) {
        typeReference = dynamic_exports.TypeReference.list(typeReference);
      }
      parameters.push({
        name: {
          name: queryParameter.name.name,
          wireValue: queryParameter.name.wireValue
        },
        typeReference
      });
    }
    return parameters;
  }
  convertTypeReference(typeReference) {
    switch (typeReference.type) {
      case "container":
        return this.convertContainerType(typeReference.container);
      case "named":
        return this.convertNamedType(typeReference);
      case "primitive":
        return this.convertPrimitiveType(typeReference.primitive);
      case "unknown":
        return this.convertUnknownType();
      default:
        assertNever(typeReference);
    }
  }
  convertContainerType(container) {
    switch (container.type) {
      case "list":
        return dynamic_exports.TypeReference.list(this.convertTypeReference(container.list));
      case "map":
        return dynamic_exports.TypeReference.map({
          key: this.convertTypeReference(container.keyType),
          value: this.convertTypeReference(container.valueType)
        });
      case "optional":
        return dynamic_exports.TypeReference.optional(this.convertTypeReference(container.optional));
      case "set":
        return dynamic_exports.TypeReference.set(this.convertTypeReference(container.set));
      case "literal":
        return dynamic_exports.TypeReference.literal(this.convertLiteral(container.literal));
      default:
        assertNever(container);
    }
  }
  convertNamedType(named) {
    return dynamic_exports.TypeReference.named(named.typeId);
  }
  convertTypeDeclaration(typeDeclaration) {
    const declaration = this.convertDeclaration(typeDeclaration.name);
    switch (typeDeclaration.shape.type) {
      case "alias":
        return this.convertAlias({ declaration, alias: typeDeclaration.shape });
      case "enum":
        return this.convertEnum({ declaration, enum_: typeDeclaration.shape });
      case "object":
        return this.convertObject({ declaration, object: typeDeclaration.shape });
      case "union":
        return this.convertDiscriminatedUnion({ declaration, union: typeDeclaration.shape });
      case "undiscriminatedUnion":
        return this.convertUndiscriminatedUnion({ declaration, union: typeDeclaration.shape });
      default:
        assertNever(typeDeclaration.shape);
    }
  }
  convertAlias({ declaration, alias }) {
    return dynamic_exports.NamedType.alias({
      declaration,
      typeReference: this.convertTypeReference(alias.aliasOf)
    });
  }
  convertEnum({ declaration, enum_: enum_3 }) {
    return dynamic_exports.NamedType.enum({
      declaration,
      values: enum_3.values.map((value) => value.name)
    });
  }
  convertObject({ declaration, object: object3 }) {
    const properties = [...object3.extendedProperties ?? [], ...object3.properties];
    return this.convertObjectProperties({
      declaration,
      properties
    });
  }
  convertObjectProperties({ declaration, properties }) {
    return dynamic_exports.NamedType.object({
      declaration,
      properties: this.convertWireValueParameters({ wireValueParameters: properties })
    });
  }
  convertDiscriminatedUnion({ declaration, union: union3 }) {
    const inheritedProperties = [...this.resolveProperties(union3.extends), ...union3.baseProperties];
    return dynamic_exports.NamedType.discriminatedUnion({
      declaration,
      discriminant: union3.discriminant,
      types: Object.fromEntries(union3.types.map((unionType2) => [
        unionType2.discriminantValue.wireValue,
        this.convertDiscriminatedUnionType({
          inheritedProperties,
          discriminantValue: unionType2.discriminantValue,
          singleUnionTypeProperties: unionType2.shape
        })
      ]))
    });
  }
  convertDiscriminatedUnionType({ inheritedProperties, discriminantValue, singleUnionTypeProperties }) {
    switch (singleUnionTypeProperties.propertiesType) {
      case "samePropertiesAsObject":
        return this.convertDiscriminatedUnionTypeObject({
          inheritedProperties,
          discriminantValue,
          declaredTypeName: singleUnionTypeProperties
        });
      case "singleProperty":
        return this.convertDiscriminatedUnionTypeSingleProperty({
          inheritedProperties,
          discriminantValue,
          singleUnionTypeProperty: singleUnionTypeProperties
        });
      case "noProperties":
        return this.convertDiscriminatedUnionTypeNoProperties({
          inheritedProperties,
          discriminantValue
        });
      default:
        assertNever(singleUnionTypeProperties);
    }
  }
  convertDiscriminatedUnionTypeObject({ inheritedProperties, discriminantValue, declaredTypeName }) {
    return dynamic_exports.SingleDiscriminatedUnionType.samePropertiesAsObject({
      typeId: declaredTypeName.typeId,
      discriminantValue,
      properties: this.convertWireValueParameters({ wireValueParameters: inheritedProperties })
    });
  }
  convertDiscriminatedUnionTypeSingleProperty({ inheritedProperties, discriminantValue, singleUnionTypeProperty }) {
    return dynamic_exports.SingleDiscriminatedUnionType.singleProperty({
      typeReference: this.convertTypeReference(singleUnionTypeProperty.type),
      discriminantValue,
      properties: inheritedProperties.length > 0 ? this.convertWireValueParameters({ wireValueParameters: inheritedProperties }) : void 0
    });
  }
  convertDiscriminatedUnionTypeNoProperties({ inheritedProperties, discriminantValue }) {
    return dynamic_exports.SingleDiscriminatedUnionType.noProperties({
      discriminantValue,
      properties: inheritedProperties.length > 0 ? this.convertWireValueParameters({ wireValueParameters: inheritedProperties }) : void 0
    });
  }
  convertUndiscriminatedUnion({ declaration, union: union3 }) {
    return dynamic_exports.NamedType.undiscriminatedUnion({
      declaration,
      types: union3.members.map((member) => this.convertTypeReference(member.type))
    });
  }
  convertLiteral(literal) {
    switch (literal.type) {
      case "boolean":
        return dynamic_exports.LiteralType.boolean(literal.boolean);
      case "string":
        return dynamic_exports.LiteralType.string(literal.string);
      default:
        assertNever(literal);
    }
  }
  convertPrimitiveType(primitive) {
    return dynamic_exports.TypeReference.primitive(primitive.v1);
  }
  convertUnknownType() {
    return dynamic_exports.TypeReference.unknown();
  }
  convertAuth(auth) {
    if (auth.schemes[0] == null) {
      return void 0;
    }
    const scheme = auth.schemes[0];
    switch (scheme.type) {
      case "basic":
        return dynamic_exports.Auth.basic(scheme);
      case "bearer":
        return dynamic_exports.Auth.bearer(scheme);
      case "header":
        return dynamic_exports.Auth.header({
          header: {
            name: scheme.name,
            typeReference: this.convertTypeReference(scheme.valueType)
          }
        });
      case "oauth":
        return void 0;
      default:
        assertNever(scheme);
    }
  }
  convertDeclaration({ name, fernFilepath }) {
    return {
      name,
      fernFilepath
    };
  }
  convertEndpointLocation({ endpoint }) {
    return {
      method: endpoint.method,
      path: this.getFullPathForEndpoint(endpoint)
    };
  }
  getAllHttpEndpoints() {
    return Object.values(this.ir.services).flatMap((service) => service.endpoints.map((endpoint) => ({
      ...endpoint,
      serviceHeaders: service.headers,
      fernFilepath: service.name.fernFilepath
    })));
  }
  resolveProperties(declaredTypeNames) {
    const properties = [];
    for (const declaredTypeName of declaredTypeNames) {
      const typeDeclaration = this.resolveObjectTypeOrThrow(declaredTypeName.typeId);
      properties.push(...this.resolveProperties(typeDeclaration.extends));
      properties.push(...typeDeclaration.properties);
    }
    return Object.values(properties);
  }
  resolveObjectTypeOrThrow(typeId) {
    const typeDeclaration = this.ir.types[typeId];
    if (typeDeclaration == null) {
      throw new Error(`Internal error; type "${typeId}" not found`);
    }
    if (typeDeclaration.shape.type !== "object") {
      throw new Error(`Internal error; type "${typeId}" is not an object`);
    }
    return typeDeclaration.shape;
  }
  getFullPathForEndpoint(endpoint) {
    let url = "";
    if (endpoint.fullPath.head.length > 0) {
      url = urlJoin(url, endpoint.fullPath.head);
    }
    for (const part of endpoint.fullPath.parts) {
      url = urlJoin(url, "{" + part.pathParameter + "}");
      if (part.tail.length > 0) {
        url = urlJoin(url, part.tail);
      }
    }
    return url.startsWith("/") ? url : `/${url}`;
  }
};

// ../../cli/generation/ir-generator/lib/dynamic-snippets/convertIrToDynamicSnippetsIr.js
async function convertIrToDynamicSnippetsIr(ir) {
  const converter = new DynamicSnippetsConverter(ir);
  return converter.convert();
}

// ../../cli/generation/ir-generator/lib/generateIntermediateRepresentation.js
async function generateIntermediateRepresentation({ workspace, generationLanguage, keywords, smartCasing, disableExamples, audiences, readme, packageName, version, context, fdrApiDefinitionId, includeOptionalRequestPropertyExamples, sourceResolver }) {
  const casingsGenerator = constructCasingsGenerator({ generationLanguage, keywords, smartCasing });
  const irGraph = new IrGraph(audiences);
  const rootApiFileContext = constructRootApiFileContext({
    casingsGenerator,
    rootApiFile: workspace.definition.rootApiFile.contents
  });
  const globalErrors = (workspace.definition.rootApiFile.contents.errors ?? []).map((referenceToError) => {
    const errorName = parseErrorName({
      errorName: referenceToError,
      file: rootApiFileContext
    });
    return { error: errorName, docs: void 0 };
  });
  const typeResolver = new TypeResolverImpl(workspace);
  const endpointResolver = new EndpointResolverImpl(workspace);
  const propertyResolver = new PropertyResolverImpl(typeResolver, endpointResolver);
  const errorResolver = new ErrorResolverImpl(workspace);
  const exampleResolver = new ExampleResolverImpl(typeResolver);
  const variableResolver = new VariableResolverImpl();
  const intermediateRepresentation = {
    fdrApiDefinitionId,
    apiVersion: await convertApiVersionScheme({
      file: rootApiFileContext,
      rawApiFileSchema: workspace.definition.rootApiFile.contents
    }),
    apiName: casingsGenerator.generateName(workspace.definition.rootApiFile.contents.name),
    apiDisplayName: workspace.definition.rootApiFile.contents["display-name"],
    apiDocs: await formatDocs(workspace.definition.rootApiFile.contents.docs),
    auth: await convertApiAuth({
      rawApiFileSchema: workspace.definition.rootApiFile.contents,
      file: rootApiFileContext,
      propertyResolver,
      endpointResolver
    }),
    headers: workspace.definition.rootApiFile.contents.headers != null ? await Promise.all(Object.entries(workspace.definition.rootApiFile.contents.headers).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file: rootApiFileContext }))) : [],
    idempotencyHeaders: workspace.definition.rootApiFile.contents["idempotency-headers"] != null ? await Promise.all(Object.entries(workspace.definition.rootApiFile.contents["idempotency-headers"]).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file: rootApiFileContext }))) : [],
    types: {},
    errors: {},
    services: {},
    constants: generateFernConstants(casingsGenerator),
    environments: convertEnvironments({
      casingsGenerator,
      rawApiFileSchema: workspace.definition.rootApiFile.contents
    }),
    errorDiscriminationStrategy: convertErrorDiscriminationStrategy(workspace.definition.rootApiFile.contents["error-discrimination"], rootApiFileContext),
    basePath: workspace.definition.rootApiFile.contents["base-path"] != null ? constructHttpPath(workspace.definition.rootApiFile.contents["base-path"]) : void 0,
    pathParameters: await convertPathParameters2({
      pathParameters: workspace.definition.rootApiFile.contents["path-parameters"],
      file: rootApiFileContext,
      location: PathParameterLocation.Root,
      variableResolver
    }),
    variables: workspace.definition.rootApiFile.contents.variables != null ? Object.entries(workspace.definition.rootApiFile.contents.variables).map(([key, variable]) => ({
      docs: typeof variable !== "string" ? variable.docs : void 0,
      id: key,
      name: rootApiFileContext.casingsGenerator.generateName(key),
      type: rootApiFileContext.parseTypeReference(variable)
    })) : [],
    serviceTypeReferenceInfo: {
      typesReferencedOnlyByService: {},
      sharedTypes: []
    },
    webhookGroups: {},
    websocketChannels: {},
    readmeConfig: void 0,
    sourceConfig: void 0,
    publishConfig: void 0,
    dynamic: void 0
  };
  const packageTreeGenerator = new PackageTreeGenerator();
  const visitDefinitionFile = async (file) => {
    packageTreeGenerator.addSubpackage(file.fernFilepath);
    await visitObject(file.definitionFile, {
      imports: noop,
      docs: (docs) => {
        if (docs != null) {
          packageTreeGenerator.addDocs(file.fernFilepath, docs);
        }
      },
      types: async (types3) => {
        if (types3 == null) {
          return;
        }
        for (const [typeName, typeDeclaration] of Object.entries(types3)) {
          if (isGeneric(typeName)) {
            continue;
          }
          const convertedTypeDeclarationWithFilepaths = await convertTypeDeclaration({
            typeName,
            typeDeclaration,
            file,
            typeResolver,
            exampleResolver,
            sourceResolver,
            workspace
          });
          const convertedTypeDeclaration = convertedTypeDeclarationWithFilepaths.typeDeclaration;
          if (disableExamples) {
            convertedTypeDeclaration.userProvidedExamples = [];
            convertedTypeDeclaration.autogeneratedExamples = [];
          }
          const subpackageFilepaths = convertedTypeDeclarationWithFilepaths.descendantFilepaths;
          const typeId = IdGenerator.generateTypeId(convertedTypeDeclaration.name);
          intermediateRepresentation.types[typeId] = convertedTypeDeclaration;
          packageTreeGenerator.addType(typeId, convertedTypeDeclaration);
          irGraph.addType({
            declaredTypeName: convertedTypeDeclaration.name,
            descendantTypeIds: convertedTypeDeclaration.referencedTypes,
            descendantTypeIdsByAudience: {},
            propertiesByAudience: convertedTypeDeclarationWithFilepaths.propertiesByAudience,
            descendantFilepaths: subpackageFilepaths
          });
          irGraph.markTypeForAudiences(convertedTypeDeclaration.name, getAudiences(typeDeclaration));
        }
      },
      errors: (errors) => {
        if (errors == null) {
          return;
        }
        const errorDiscriminationSchema = workspace.definition.rootApiFile.contents["error-discrimination"];
        if (errorDiscriminationSchema == null) {
          throw new Error("error-discrimination is missing in api.yml but there are declared errors.");
        }
        for (const [errorName, errorDeclaration] of Object.entries(errors)) {
          const convertedErrorDeclaration = convertErrorDeclaration({
            errorName,
            errorDeclaration,
            file,
            typeResolver,
            exampleResolver,
            workspace
          });
          const errorId = IdGenerator.generateErrorId(convertedErrorDeclaration.name);
          intermediateRepresentation.errors[errorId] = convertedErrorDeclaration;
          packageTreeGenerator.addError(errorId, convertedErrorDeclaration);
          irGraph.addError(convertedErrorDeclaration);
        }
      },
      service: async (service) => {
        if (service == null) {
          return;
        }
        const convertedHttpService = await convertHttpService({
          rootDefaultUrl: file.defaultUrl ?? workspace.definition.rootApiFile.contents["default-url"],
          rootPathParameters: intermediateRepresentation.pathParameters,
          serviceDefinition: service,
          file,
          errorResolver,
          typeResolver,
          propertyResolver,
          exampleResolver,
          sourceResolver,
          globalErrors,
          variableResolver,
          workspace
        });
        const serviceId = IdGenerator.generateServiceId(convertedHttpService.name);
        intermediateRepresentation.services[serviceId] = convertedHttpService;
        packageTreeGenerator.addService(serviceId, convertedHttpService);
        const convertedEndpoints = {};
        convertedHttpService.endpoints.forEach((httpEndpoint) => {
          if (disableExamples) {
            httpEndpoint.autogeneratedExamples = [];
            httpEndpoint.userSpecifiedExamples = [];
          }
          const rawEndpointSchema = service.endpoints[httpEndpoint.name.originalName];
          irGraph.addEndpoint(convertedHttpService, httpEndpoint, rawEndpointSchema);
          convertedEndpoints[httpEndpoint.name.originalName] = httpEndpoint;
        });
        if (service.audiences != null) {
          irGraph.markEndpointForAudience(convertedHttpService.name, convertedHttpService.endpoints, service.audiences);
        }
        Object.entries(service.endpoints).map(([endpointId, endpoint]) => {
          const convertedEndpoint = convertedEndpoints[endpointId];
          if (convertedEndpoint != null && endpoint.audiences != null) {
            irGraph.markEndpointForAudience(convertedHttpService.name, [convertedEndpoint], endpoint.audiences);
          }
        });
      },
      webhooks: async (webhooks) => {
        if (webhooks == null) {
          return;
        }
        const webhookGroupId = IdGenerator.generateWebhookGroupId(file.fernFilepath);
        const convertedWebhookGroup = await convertWebhookGroup({
          webhooks,
          file,
          typeResolver,
          exampleResolver,
          workspace
        });
        const webhooksByOriginalName = {};
        for (const convertedWebhook of convertedWebhookGroup) {
          webhooksByOriginalName[convertedWebhook.name.originalName] = convertedWebhook;
        }
        Object.entries(webhooks).forEach(([key, webhook]) => {
          const irWebhook = webhooksByOriginalName[key];
          if (irWebhook != null) {
            irGraph.addWebhook(file, irWebhook, webhook);
            if (webhook.audiences != null) {
              irGraph.markWebhookForAudiences(file, irWebhook, webhook.audiences);
            }
          }
        });
        intermediateRepresentation.webhookGroups[webhookGroupId] = convertedWebhookGroup;
        packageTreeGenerator.addWebhookGroup(webhookGroupId, file.fernFilepath);
      },
      channel: async (channel) => {
        if (channel == null) {
          return;
        }
        const websocketChannelId = IdGenerator.generateWebSocketChannelId(file.fernFilepath);
        const websocketChannel = await convertChannel({
          channel,
          file,
          variableResolver,
          typeResolver,
          exampleResolver,
          workspace
        });
        if (intermediateRepresentation.websocketChannels != null) {
          intermediateRepresentation.websocketChannels[websocketChannelId] = websocketChannel;
          packageTreeGenerator.addWebSocketChannel(websocketChannelId, file.fernFilepath);
        }
      }
    });
  };
  await visitAllDefinitionFiles(workspace, async (relativeFilepath, file, metadata) => {
    await visitDefinitionFile(constructFernFileContext({
      relativeFilepath,
      definitionFile: file,
      casingsGenerator,
      rootApiFile: workspace.definition.rootApiFile.contents,
      defaultUrl: metadata.defaultUrl
    }));
  });
  await visitAllPackageMarkers(workspace, async (relativeFilepath, packageMarker) => {
    if (packageMarker.navigation == null) {
      return;
    }
    if (typeof packageMarker.navigation === "string") {
      packageTreeGenerator.addPackageRedirection({
        from: convertToFernFilepath({ relativeFilepath, casingsGenerator }),
        to: convertToFernFilepath({
          relativeFilepath: join(dirname(relativeFilepath), RelativeFilePath.of(packageMarker.navigation)),
          casingsGenerator
        })
      });
    } else {
      const childrenInOrder = packageMarker.navigation.map((childFilepath) => {
        return IdGenerator.generateSubpackageId(convertToFernFilepath({
          relativeFilepath: join(dirname(relativeFilepath), RelativeFilePath.of(childFilepath)),
          casingsGenerator
        }));
      });
      if (relativeFilepath === FERN_PACKAGE_MARKER_FILENAME) {
        packageTreeGenerator.sortRootPackage(childrenInOrder);
      } else {
        packageTreeGenerator.sortSubpackage(IdGenerator.generateSubpackageId(convertToFernFilepath({
          relativeFilepath,
          casingsGenerator
        })), childrenInOrder);
      }
    }
  });
  intermediateRepresentation.serviceTypeReferenceInfo = computeServiceTypeReferenceInfo(irGraph);
  const intermediateRepresentationWithGeneratedExamples = disableExamples ? intermediateRepresentation : injectAutogeneratedExamples(intermediateRepresentation, context, !includeOptionalRequestPropertyExamples);
  const workspaceDefinitionRootApiFileContents = workspace.definition.rootApiFile.contents;
  const environments = convertEnvironments({
    casingsGenerator,
    rawApiFileSchema: workspaceDefinitionRootApiFileContents
  });
  const ignoreAudiences = environments?.environments._visit({
    singleBaseUrl: (value) => {
      return value.environments.filter((environment) => {
        return getAudienceForEnvironment(environment.id, workspaceDefinitionRootApiFileContents.environments) != null;
      }).length === 0;
    },
    multipleBaseUrls: (value) => {
      return value.environments.filter((environment) => {
        return getAudienceForEnvironment(environment.id, workspaceDefinitionRootApiFileContents.environments) != null;
      }).length === 0;
    },
    _other: () => false
  });
  environments?.environments.environments.forEach((environment) => {
    irGraph.markEnvironmentForAudiences(environment, getAudienceForEnvironment(environment.id, workspaceDefinitionRootApiFileContents.environments) ?? [], ignoreAudiences);
  });
  const filteredIr = !irGraph.hasNoAudiences() ? irGraph.build() : void 0;
  const intermediateRepresentationForAudiences = filterIntermediateRepresentationForAudiences(intermediateRepresentationWithGeneratedExamples, filteredIr);
  const isAuthMandatory = workspace.definition.rootApiFile.contents.auth != null && Object.values(intermediateRepresentationForAudiences.services).every((service) => {
    return service.endpoints.every((endpoint) => endpoint.auth);
  });
  const hasStreamingEndpoints = Object.values(intermediateRepresentationForAudiences.services).some((service) => {
    return service.endpoints.some((endpoint) => endpoint.response?.body?.type === "streaming");
  });
  const hasPaginatedEndpoints = Object.values(intermediateRepresentationForAudiences.services).some((service) => {
    return service.endpoints.some((endpoint) => endpoint.pagination != null);
  });
  const hasFileDownloadEndpoints = Object.values(intermediateRepresentationForAudiences.services).some((service) => {
    return service.endpoints.some((endpoint) => endpoint.response?.body?.type === "fileDownload");
  });
  const sdkConfig = {
    isAuthMandatory,
    hasStreamingEndpoints,
    hasPaginatedEndpoints,
    hasFileDownloadEndpoints,
    platformHeaders: {
      language: "X-Fern-Language",
      sdkName: "X-Fern-SDK-Name",
      sdkVersion: "X-Fern-SDK-Version",
      userAgent: version != null && packageName != null ? {
        header: "User-Agent",
        value: `${packageName}/${version}`
      } : void 0
    }
  };
  const readmeConfig = readme != null ? convertReadmeConfig({ readme, services: intermediateRepresentation.services }) : void 0;
  const { types: types2, services } = addExtendedPropertiesToIr(intermediateRepresentationForAudiences);
  const finalIR = {
    ...intermediateRepresentationForAudiences,
    ...packageTreeGenerator.build(filteredIr),
    types: types2,
    services,
    sdkConfig,
    readmeConfig
  };
  return {
    ...finalIR,
    dynamic: await convertIrToDynamicSnippetsIr(finalIR)
  };
}
function injectAutogeneratedExamples(ir, context, skipOptionalRequestProperties) {
  for (const [_, service] of Object.entries(ir.services)) {
    for (const endpoint of service.endpoints) {
      context.logger.debug(`Generating example for ${endpoint.id}`);
      const generatedExample = generateEndpointExample({
        ir,
        service,
        endpoint,
        typeDeclarations: ir.types,
        skipOptionalRequestProperties: skipOptionalRequestProperties ?? true,
        generationResponse: { type: "success" }
      });
      if (generatedExample.type === "failure") {
        context.logger.debug(`Failed to generate example for ${endpoint.id}. ${generatedExample.message}`);
        continue;
      }
      const { example } = generatedExample;
      endpoint.autogeneratedExamples = [{ example }];
    }
  }
  return ir;
}
function computeServiceTypeReferenceInfo(irGraph) {
  const typesReferencedOnlyByService = {};
  const sharedTypes = [];
  const typesReferencedByService = irGraph.getTypesReferencedByService();
  for (const [typeId, serviceIds] of Object.entries(typesReferencedByService)) {
    if (serviceIds.size === 1) {
      const serviceId = serviceIds.values().next().value;
      if (typesReferencedOnlyByService[serviceId] === void 0) {
        typesReferencedOnlyByService[serviceId] = [];
      }
      typesReferencedOnlyByService[serviceId]?.push(typeId);
      continue;
    }
    sharedTypes.push(typeId);
  }
  return {
    typesReferencedOnlyByService,
    sharedTypes
  };
}
function filterIntermediateRepresentationForAudiences(intermediateRepresentation, filteredIr) {
  if (filteredIr == null) {
    return intermediateRepresentation;
  }
  const filteredTypes = pickBy_default(intermediateRepresentation.types, (type2) => filteredIr.hasType(type2));
  const filteredTypesAndProperties = Object.fromEntries(Object.entries(filteredTypes).map(([typeId, typeDeclaration]) => {
    const filteredProperties = [];
    typeDeclaration.userProvidedExamples = typeDeclaration.userProvidedExamples.map((example) => filterExampleType({ filteredIr, exampleType: example })).filter((ex) => ex !== void 0);
    if (typeDeclaration.shape.type === "object") {
      for (const property4 of typeDeclaration.shape.properties) {
        const hasProperty = filteredIr.hasProperty(typeId, property4.name.wireValue);
        if (hasProperty) {
          filteredProperties.push(property4);
        }
      }
      return [
        typeId,
        {
          ...typeDeclaration,
          shape: Type.object({
            ...typeDeclaration.shape,
            properties: filteredProperties
          })
        }
      ];
    }
    return [typeId, typeDeclaration];
  }));
  const filteredWebhookGroups = Object.fromEntries(Object.entries(intermediateRepresentation.webhookGroups).map(([webhookGroupId, webhookGroup]) => {
    const filteredWebhooks = webhookGroup.filter((webhook) => filteredIr.hasWebhook(webhook)).map((webhook) => {
      const webhookId = webhook.id;
      if (webhook.payload.type === "inlinedPayload" && webhookId != null) {
        webhook.payload = {
          ...webhook.payload,
          properties: webhook.payload.properties.filter((property4) => {
            return filteredIr.hasWebhookPayloadProperty(webhookId, property4.name.wireValue);
          })
        };
      }
      return webhook;
    });
    return [webhookGroupId, filteredWebhooks];
  }));
  const filteredEnvironmentsConfig = intermediateRepresentation.environments;
  if (filteredEnvironmentsConfig) {
    switch (filteredEnvironmentsConfig.environments.type) {
      case "singleBaseUrl": {
        filteredEnvironmentsConfig.environments.environments = filteredEnvironmentsConfig.environments.environments.filter((environment) => filteredIr.hasEnvironmentId(environment.id));
        break;
      }
      case "multipleBaseUrls": {
        filteredEnvironmentsConfig.environments.environments = filteredEnvironmentsConfig.environments.environments.filter((environment) => filteredIr.hasEnvironmentId(environment.id));
        break;
      }
    }
    if (filteredEnvironmentsConfig.defaultEnvironment) {
      if (!filteredIr.hasEnvironmentId(filteredEnvironmentsConfig.defaultEnvironment)) {
        filteredEnvironmentsConfig.defaultEnvironment = void 0;
      }
    }
  }
  return {
    ...intermediateRepresentation,
    environments: filteredEnvironmentsConfig,
    types: filteredTypesAndProperties,
    errors: pickBy_default(intermediateRepresentation.errors, (error) => filteredIr.hasError(error)),
    services: mapValues_default(pickBy_default(intermediateRepresentation.services, (httpService) => filteredIr.hasService(httpService)), (httpService) => ({
      ...httpService,
      endpoints: httpService.endpoints.filter((httpEndpoint) => filteredIr.hasEndpoint(httpEndpoint)).map((httpEndpoint) => {
        httpEndpoint.autogeneratedExamples = httpEndpoint.autogeneratedExamples.map((autogenerated) => {
          return {
            ...autogenerated,
            example: filterEndpointExample({ filteredIr, example: autogenerated.example })
          };
        });
        httpEndpoint.userSpecifiedExamples = httpEndpoint.userSpecifiedExamples.map((userSpecified) => {
          return {
            ...userSpecified,
            example: userSpecified.example != null ? filterEndpointExample({ filteredIr, example: userSpecified.example }) : void 0
          };
        });
        if (httpEndpoint.queryParameters.length > 0) {
          httpEndpoint.queryParameters = httpEndpoint.queryParameters.filter((queryParameter) => {
            return filteredIr.hasQueryParameter(httpEndpoint.id, queryParameter.name.wireValue);
          });
        }
        if (httpEndpoint.requestBody?.type === "inlinedRequestBody") {
          return {
            ...httpEndpoint,
            requestBody: {
              ...httpEndpoint.requestBody,
              properties: httpEndpoint.requestBody.properties.filter((property4) => {
                return filteredIr.hasRequestProperty(httpEndpoint.id, property4.name.wireValue);
              })
            }
          };
        }
        return httpEndpoint;
      })
    })),
    webhookGroups: filteredWebhookGroups,
    serviceTypeReferenceInfo: filterServiceTypeReferenceInfoForAudiences(intermediateRepresentation.serviceTypeReferenceInfo, filteredIr)
  };
}
function filterServiceTypeReferenceInfoForAudiences(serviceTypeReferenceInfo, filteredIr) {
  if (filteredIr == null) {
    return serviceTypeReferenceInfo;
  }
  const filteredTypesReferencedOnlyByService = {};
  Object.entries(serviceTypeReferenceInfo.typesReferencedOnlyByService).forEach(([key, values]) => {
    if (filteredIr.hasServiceId(key)) {
      filteredTypesReferencedOnlyByService[key] = values.filter((value) => filteredIr.hasTypeId(value));
    }
  });
  return {
    sharedTypes: serviceTypeReferenceInfo.sharedTypes.filter((typeId) => filteredIr.hasTypeId(typeId)),
    typesReferencedOnlyByService: filteredTypesReferencedOnlyByService
  };
}

// ../../cli/generation/source-resolver/lib/NopSourceResolver.js
var NopSourceResolver = class {
  async resolveSource({ source }) {
    return void 0;
  }
  async resolveSourceOrThrow({ source }) {
    return void 0;
  }
};

// src/utils/NopLogger.ts
var NopLogger = class {
  disable() {
  }
  enable() {
  }
  debug(...args) {
  }
  info(...args) {
  }
  warn(...args) {
  }
  error(...args) {
  }
  log(level, ...args) {
  }
};

// src/utils/createTaskContext.ts
function createTaskContext() {
  const context = {
    logger: new NopLogger(),
    takeOverTerminal: async (run) => {
    },
    failAndThrow: (_message, _error) => {
      throw new Error("unimplemented");
    },
    failWithoutThrowing: (_message, _error) => {
    },
    getResult: () => 0 /* Success */,
    addInteractiveTask: () => {
      throw new Error("unimplemented");
    },
    runInteractiveTask: async (_params, _run) => {
      return false;
    },
    instrumentPostHogEvent: async (_event) => {
    }
  };
  return context;
}

// ../../cli/workspace/browser-compatible-fern-workspace/lib/InMemoryOpenAPILoader.js
var import_openapi_core2 = __toESM(require_lib3(), 1);
var InMemoryOpenAPILoader = class {
  async loadDocument(spec) {
    return {
      type: "openapi",
      value: await this.loadParsedOpenAPI({
        openapi: spec.parsed,
        overrides: spec.overrides
      }),
      settings: spec.settings
    };
  }
  async loadParsedOpenAPI({ openapi, overrides }) {
    const parsed = await this.parseOpenAPI({
      parsed: openapi
    });
    if (overrides != null) {
      const merged = await mergeWithOverrides({ data: parsed, overrides });
      return await this.parseOpenAPI({
        parsed: merged
      });
    }
    return parsed;
  }
  async parseOpenAPI({ parsed }) {
    const result = await (0, import_openapi_core2.bundle)({
      ...DEFAULT_OPENAPI_BUNDLE_OPTIONS,
      doc: {
        source: new import_openapi_core2.Source("<memory>", "<openapi>"),
        parsed
      }
    });
    return result.bundle.parsed;
  }
};

// ../../cli/workspace/browser-compatible-fern-workspace/lib/OpenAPIWorkspace.js
var IN_MEMORY_ABSOLUTE_FILEPATH = AbsoluteFilePath.of("/<memory>");
var DEFAULT_WORKSPACE_ARGS = {
  absoluteFilePath: IN_MEMORY_ABSOLUTE_FILEPATH,
  cliVersion: "<unknown>",
  workspaceName: "anonymous"
};
var OpenAPIWorkspace = class extends BaseOpenAPIWorkspace {
  spec;
  loader;
  constructor({ spec, generatorsConfiguration }) {
    super({
      ...DEFAULT_WORKSPACE_ARGS,
      generatorsConfiguration,
      respectReadonlySchemas: spec.settings?.respectReadonlySchemas ?? false,
      onlyIncludeReferencedSchemas: spec.settings?.onlyIncludeReferencedSchemas ?? false,
      inlinePathParameters: spec.settings?.inlinePathParameters ?? false,
      objectQueryParameters: spec.settings?.objectQueryParameters ?? false
    });
    this.spec = spec;
    this.loader = new InMemoryOpenAPILoader();
  }
  async getOpenAPIIr({ context }, settings) {
    const optionOverrides = getOptionsOverridesFromSettings(settings);
    const document2 = await this.loader.loadDocument(this.spec);
    return await parse({
      context,
      documents: [document2],
      options: {
        ...optionOverrides,
        respectReadonlySchemas: this.respectReadonlySchemas,
        onlyIncludeReferencedSchemas: this.onlyIncludeReferencedSchemas
      }
    });
  }
  getAbsoluteFilePaths() {
    return [];
  }
};

// src/utils/convertAPIToWorkspace.ts
async function convertAPIToWorkspace({
  context,
  api,
  generatorsConfiguration,
  settings
}) {
  switch (api.type) {
    case "openapi": {
      const openapi = new OpenAPIWorkspace({
        spec: {
          parsed: api.openapi,
          overrides: api.overrides
        },
        generatorsConfiguration
      });
      return await openapi.toFernWorkspace({ context }, settings);
    }
  }
}

// src/generateDynamicIR.ts
async function generateDynamicIR({
  api,
  language,
  generatorsConfiguration,
  settings,
  audiences,
  keywords,
  smartCasing
}) {
  const context = createTaskContext();
  const workspace = await convertAPIToWorkspace({ context, api, generatorsConfiguration, settings });
  const ir = await generateIntermediateRepresentation({
    context,
    workspace,
    generationLanguage: language,
    audiences: audiences ?? { type: "all" },
    keywords,
    sourceResolver: new NopSourceResolver(),
    smartCasing: smartCasing ?? false,
    disableExamples: true,
    version: void 0,
    packageName: void 0,
    readme: void 0
  });
  if (ir.dynamic == null) {
    throw new Error("Internal error; failed to generate dynamic intermediate representation");
  }
  return ir.dynamic;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  generateDynamicIR
});
/*! Bundled license information:

uri-js/dist/es5/uri.all.js:
  (** @license URI.js v4.4.1 (c) 2011 Gary Court. License: http://github.com/garycourt/uri-js *)

lodash-es/lodash.js:
  (**
   * @license
   * Lodash (Custom Build) <https://lodash.com/>
   * Build: `lodash modularize exports="es" -o ./`
   * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
   * Released under MIT license <https://lodash.com/license>
   * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
   * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
   *)

js-yaml/dist/js-yaml.mjs:
  (*! js-yaml 4.1.0 https://github.com/nodeca/js-yaml @license MIT *)
*/
